/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the RISCV target                           *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 94;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(RISCVInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(RISCVInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static RISCVInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static RISCVInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(4),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_p0s32,
  GILLT_p0s64,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_nxv1s1,
  GILLT_nxv1s8,
  GILLT_nxv1s16,
  GILLT_nxv1s32,
  GILLT_nxv1s64,
  GILLT_nxv2s1,
  GILLT_nxv2s8,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s8,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv4s64,
  GILLT_nxv8s1,
  GILLT_nxv8s8,
  GILLT_nxv8s16,
  GILLT_nxv8s32,
  GILLT_nxv8s64,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
  GILLT_nxv16s16,
  GILLT_nxv16s32,
  GILLT_nxv32s1,
  GILLT_nxv32s8,
  GILLT_nxv32s16,
  GILLT_nxv64s1,
  GILLT_nxv64s8,
};
const static size_t NumTypeObjects = 34;
const static LLT TypeObjects[] = {
  LLT::pointer(0, 32),
  LLT::pointer(0, 64),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(1), 8),
  LLT::vector(ElementCount::getScalable(1), 16),
  LLT::vector(ElementCount::getScalable(1), 32),
  LLT::vector(ElementCount::getScalable(1), 64),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 8),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 8),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(4), 64),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 8),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(8), 32),
  LLT::vector(ElementCount::getScalable(8), 64),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
  LLT::vector(ElementCount::getScalable(16), 16),
  LLT::vector(ElementCount::getScalable(16), 32),
  LLT::vector(ElementCount::getScalable(32), 1),
  LLT::vector(ElementCount::getScalable(32), 8),
  LLT::vector(ElementCount::getScalable(32), 16),
  LLT::vector(ElementCount::getScalable(64), 1),
  LLT::vector(ElementCount::getScalable(64), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasStdExtZicbopBit = 64,
  Feature_HasStdExtZicondBit = 65,
  Feature_HasStdExtZimopBit = 63,
  Feature_HasStdExtZicfilpBit = 2,
  Feature_NoStdExtZicfilpBit = 1,
  Feature_HasStdExtZmmulBit = 22,
  Feature_HasStdExtMBit = 23,
  Feature_HasStdExtABit = 25,
  Feature_HasStdExtZtsoBit = 27,
  Feature_NotHasStdExtZtsoBit = 26,
  Feature_HasStdExtZabhaBit = 30,
  Feature_HasStdExtZacasBit = 29,
  Feature_NoStdExtZacasBit = 28,
  Feature_HasStdExtZalasrBit = 31,
  Feature_HasStdExtFBit = 5,
  Feature_HasStdExtDBit = 7,
  Feature_HasStdExtZfhminBit = 12,
  Feature_HasStdExtZfhBit = 10,
  Feature_HasStdExtZfaBit = 32,
  Feature_NoStdExtZfaBit = 8,
  Feature_HasStdExtZfinxBit = 6,
  Feature_HasStdExtZdinxBit = 9,
  Feature_HasStdExtZhinxminBit = 13,
  Feature_HasStdExtZhinxBit = 11,
  Feature_HasStdExtCBit = 18,
  Feature_HasStdExtCOrZcaBit = 20,
  Feature_HasStdExtZbaBit = 38,
  Feature_NotHasStdExtZbaBit = 21,
  Feature_HasStdExtZbbBit = 35,
  Feature_NoStdExtZbbBit = 37,
  Feature_HasStdExtZbcBit = 40,
  Feature_HasStdExtZbsBit = 34,
  Feature_HasStdExtZbkbBit = 36,
  Feature_NoStdExtZbkbBit = 91,
  Feature_HasStdExtZbkxBit = 41,
  Feature_HasStdExtZbbOrZbkbBit = 33,
  Feature_HasStdExtZbcOrZbkcBit = 39,
  Feature_HasStdExtZkndBit = 42,
  Feature_HasStdExtZkneBit = 44,
  Feature_HasStdExtZkndOrZkneBit = 43,
  Feature_HasStdExtZknhBit = 45,
  Feature_HasStdExtZksedBit = 46,
  Feature_HasStdExtZkshBit = 47,
  Feature_HasStdExtZvkbBit = 55,
  Feature_HasStdExtZvbbBit = 54,
  Feature_HasStdExtZvbcBit = 59,
  Feature_HasStdExtZvkgBit = 56,
  Feature_HasStdExtZvknedBit = 57,
  Feature_HasStdExtZvknhaBit = 60,
  Feature_HasStdExtZvknhbBit = 61,
  Feature_HasStdExtZvksedBit = 62,
  Feature_HasStdExtZvkshBit = 58,
  Feature_HasVInstructionsBit = 14,
  Feature_HasVInstructionsI64Bit = 50,
  Feature_HasVInstructionsAnyFBit = 49,
  Feature_HasVInstructionsF16MinimalBit = 52,
  Feature_HasVInstructionsF16Bit = 48,
  Feature_HasVInstructionsF64Bit = 53,
  Feature_HasVInstructionsFullMultiplyBit = 51,
  Feature_HasVendorXVentanaCondOpsBit = 66,
  Feature_HasVendorXTHeadBaBit = 67,
  Feature_HasVendorXTHeadBbBit = 68,
  Feature_HasVendorXTHeadBsBit = 69,
  Feature_HasVendorXTHeadCondMovBit = 70,
  Feature_HasVendorXTHeadFMemIdxBit = 75,
  Feature_HasVendorXTHeadMacBit = 71,
  Feature_HasVendorXTHeadMemIdxBit = 74,
  Feature_HasVendorXTHeadMemPairBit = 73,
  Feature_HasVendorXTHeadVdotBit = 72,
  Feature_HasVendorXSfvcpBit = 76,
  Feature_HasVendorXSfvqmaccdodBit = 77,
  Feature_HasVendorXSfvqmaccqoqBit = 78,
  Feature_HasVendorXSfvfnrclipxfqfBit = 79,
  Feature_HasVendorXCVbitmanipBit = 81,
  Feature_HasVendorXCVmacBit = 84,
  Feature_HasVendorXCVmemBit = 80,
  Feature_HasVendorXCValuBit = 82,
  Feature_HasVendorXCVbiBit = 83,
  Feature_UseCCMovInsnBit = 90,
  Feature_HasVendorXqcislsBit = 87,
  Feature_HasVendorXqciaBit = 88,
  Feature_HasVendorXqciintBit = 89,
  Feature_HasVendorXqciliaBit = 85,
  Feature_HasVendorXqciloBit = 86,
  Feature_IsRV64Bit = 4,
  Feature_IsRV32Bit = 3,
  Feature_HasShortForwardBranchOptBit = 15,
  Feature_NoShortForwardBranchOptBit = 17,
  Feature_HasConditionalMoveFusionBit = 16,
  Feature_NoConditionalMoveFusionBit = 0,
  Feature_HasAtomicLdStBit = 24,
  Feature_OptForMinSizeBit = 19,
  Feature_HwMode1Bit = 93,
  Feature_HwMode0Bit = 92,
};

PredicateBitset RISCVInstructionSelector::
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasStdExtZicbop())
    Features.set(Feature_HasStdExtZicbopBit);
  if (Subtarget->hasStdExtZicond())
    Features.set(Feature_HasStdExtZicondBit);
  if (Subtarget->hasStdExtZimop())
    Features.set(Feature_HasStdExtZimopBit);
  if (Subtarget->hasStdExtZicfilp())
    Features.set(Feature_HasStdExtZicfilpBit);
  if (!Subtarget->hasStdExtZicfilp())
    Features.set(Feature_NoStdExtZicfilpBit);
  if (Subtarget->hasStdExtZmmul())
    Features.set(Feature_HasStdExtZmmulBit);
  if (Subtarget->hasStdExtM())
    Features.set(Feature_HasStdExtMBit);
  if (Subtarget->hasStdExtA())
    Features.set(Feature_HasStdExtABit);
  if (Subtarget->hasStdExtZtso())
    Features.set(Feature_HasStdExtZtsoBit);
  if (!Subtarget->hasStdExtZtso())
    Features.set(Feature_NotHasStdExtZtsoBit);
  if (Subtarget->hasStdExtZabha())
    Features.set(Feature_HasStdExtZabhaBit);
  if (Subtarget->hasStdExtZacas())
    Features.set(Feature_HasStdExtZacasBit);
  if (!Subtarget->hasStdExtZacas())
    Features.set(Feature_NoStdExtZacasBit);
  if (Subtarget->hasStdExtZalasr())
    Features.set(Feature_HasStdExtZalasrBit);
  if (Subtarget->hasStdExtF())
    Features.set(Feature_HasStdExtFBit);
  if (Subtarget->hasStdExtD())
    Features.set(Feature_HasStdExtDBit);
  if (Subtarget->hasStdExtZfhmin())
    Features.set(Feature_HasStdExtZfhminBit);
  if (Subtarget->hasStdExtZfh())
    Features.set(Feature_HasStdExtZfhBit);
  if (Subtarget->hasStdExtZfa())
    Features.set(Feature_HasStdExtZfaBit);
  if (!Subtarget->hasStdExtZfa())
    Features.set(Feature_NoStdExtZfaBit);
  if (Subtarget->hasStdExtZfinx())
    Features.set(Feature_HasStdExtZfinxBit);
  if (Subtarget->hasStdExtZdinx())
    Features.set(Feature_HasStdExtZdinxBit);
  if (Subtarget->hasStdExtZhinxmin())
    Features.set(Feature_HasStdExtZhinxminBit);
  if (Subtarget->hasStdExtZhinx())
    Features.set(Feature_HasStdExtZhinxBit);
  if (Subtarget->hasStdExtC())
    Features.set(Feature_HasStdExtCBit);
  if (Subtarget->hasStdExtCOrZca())
    Features.set(Feature_HasStdExtCOrZcaBit);
  if (Subtarget->hasStdExtZba())
    Features.set(Feature_HasStdExtZbaBit);
  if (!Subtarget->hasStdExtZba())
    Features.set(Feature_NotHasStdExtZbaBit);
  if (Subtarget->hasStdExtZbb())
    Features.set(Feature_HasStdExtZbbBit);
  if (!Subtarget->hasStdExtZbb())
    Features.set(Feature_NoStdExtZbbBit);
  if (Subtarget->hasStdExtZbc())
    Features.set(Feature_HasStdExtZbcBit);
  if (Subtarget->hasStdExtZbs())
    Features.set(Feature_HasStdExtZbsBit);
  if (Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbkbBit);
  if (!Subtarget->hasStdExtZbkb())
    Features.set(Feature_NoStdExtZbkbBit);
  if (Subtarget->hasStdExtZbkx())
    Features.set(Feature_HasStdExtZbkxBit);
  if (Subtarget->hasStdExtZbb() || Subtarget->hasStdExtZbkb())
    Features.set(Feature_HasStdExtZbbOrZbkbBit);
  if (Subtarget->hasStdExtZbc() || Subtarget->hasStdExtZbkc())
    Features.set(Feature_HasStdExtZbcOrZbkcBit);
  if (Subtarget->hasStdExtZknd())
    Features.set(Feature_HasStdExtZkndBit);
  if (Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkneBit);
  if (Subtarget->hasStdExtZknd() || Subtarget->hasStdExtZkne())
    Features.set(Feature_HasStdExtZkndOrZkneBit);
  if (Subtarget->hasStdExtZknh())
    Features.set(Feature_HasStdExtZknhBit);
  if (Subtarget->hasStdExtZksed())
    Features.set(Feature_HasStdExtZksedBit);
  if (Subtarget->hasStdExtZksh())
    Features.set(Feature_HasStdExtZkshBit);
  if (Subtarget->hasStdExtZvkb())
    Features.set(Feature_HasStdExtZvkbBit);
  if (Subtarget->hasStdExtZvbb())
    Features.set(Feature_HasStdExtZvbbBit);
  if (Subtarget->hasStdExtZvbc())
    Features.set(Feature_HasStdExtZvbcBit);
  if (Subtarget->hasStdExtZvkg())
    Features.set(Feature_HasStdExtZvkgBit);
  if (Subtarget->hasStdExtZvkned())
    Features.set(Feature_HasStdExtZvknedBit);
  if (Subtarget->hasStdExtZvknha())
    Features.set(Feature_HasStdExtZvknhaBit);
  if (Subtarget->hasStdExtZvknhb())
    Features.set(Feature_HasStdExtZvknhbBit);
  if (Subtarget->hasStdExtZvksed())
    Features.set(Feature_HasStdExtZvksedBit);
  if (Subtarget->hasStdExtZvksh())
    Features.set(Feature_HasStdExtZvkshBit);
  if (Subtarget->hasVInstructions())
    Features.set(Feature_HasVInstructionsBit);
  if (Subtarget->hasVInstructionsI64())
    Features.set(Feature_HasVInstructionsI64Bit);
  if (Subtarget->hasVInstructionsAnyF())
    Features.set(Feature_HasVInstructionsAnyFBit);
  if (Subtarget->hasVInstructionsF16Minimal())
    Features.set(Feature_HasVInstructionsF16MinimalBit);
  if (Subtarget->hasVInstructionsF16())
    Features.set(Feature_HasVInstructionsF16Bit);
  if (Subtarget->hasVInstructionsF64())
    Features.set(Feature_HasVInstructionsF64Bit);
  if (Subtarget->hasVInstructionsFullMultiply())
    Features.set(Feature_HasVInstructionsFullMultiplyBit);
  if (Subtarget->hasVendorXVentanaCondOps())
    Features.set(Feature_HasVendorXVentanaCondOpsBit);
  if (Subtarget->hasVendorXTHeadBa())
    Features.set(Feature_HasVendorXTHeadBaBit);
  if (Subtarget->hasVendorXTHeadBb())
    Features.set(Feature_HasVendorXTHeadBbBit);
  if (Subtarget->hasVendorXTHeadBs())
    Features.set(Feature_HasVendorXTHeadBsBit);
  if (Subtarget->hasVendorXTHeadCondMov())
    Features.set(Feature_HasVendorXTHeadCondMovBit);
  if (Subtarget->hasVendorXTHeadFMemIdx())
    Features.set(Feature_HasVendorXTHeadFMemIdxBit);
  if (Subtarget->hasVendorXTHeadMac())
    Features.set(Feature_HasVendorXTHeadMacBit);
  if (Subtarget->hasVendorXTHeadMemIdx())
    Features.set(Feature_HasVendorXTHeadMemIdxBit);
  if (Subtarget->hasVendorXTHeadMemPair())
    Features.set(Feature_HasVendorXTHeadMemPairBit);
  if (Subtarget->hasVendorXTHeadVdot())
    Features.set(Feature_HasVendorXTHeadVdotBit);
  if (Subtarget->hasVendorXSfvcp())
    Features.set(Feature_HasVendorXSfvcpBit);
  if (Subtarget->hasVendorXSfvqmaccdod())
    Features.set(Feature_HasVendorXSfvqmaccdodBit);
  if (Subtarget->hasVendorXSfvqmaccqoq())
    Features.set(Feature_HasVendorXSfvqmaccqoqBit);
  if (Subtarget->hasVendorXSfvfnrclipxfqf())
    Features.set(Feature_HasVendorXSfvfnrclipxfqfBit);
  if (Subtarget->hasVendorXCVbitmanip())
    Features.set(Feature_HasVendorXCVbitmanipBit);
  if (Subtarget->hasVendorXCVmac())
    Features.set(Feature_HasVendorXCVmacBit);
  if (Subtarget->hasVendorXCVmem())
    Features.set(Feature_HasVendorXCVmemBit);
  if (Subtarget->hasVendorXCValu())
    Features.set(Feature_HasVendorXCValuBit);
  if (Subtarget->hasVendorXCVbi())
    Features.set(Feature_HasVendorXCVbiBit);
  if (Subtarget->useCCMovInsn())
    Features.set(Feature_UseCCMovInsnBit);
  if (Subtarget->hasVendorXqcisls())
    Features.set(Feature_HasVendorXqcislsBit);
  if (Subtarget->hasVendorXqcia())
    Features.set(Feature_HasVendorXqciaBit);
  if (Subtarget->hasVendorXqciint())
    Features.set(Feature_HasVendorXqciintBit);
  if (Subtarget->hasVendorXqcilia())
    Features.set(Feature_HasVendorXqciliaBit);
  if (Subtarget->hasVendorXqcilo())
    Features.set(Feature_HasVendorXqciloBit);
  if (Subtarget->is64Bit())
    Features.set(Feature_IsRV64Bit);
  if (!Subtarget->is64Bit())
    Features.set(Feature_IsRV32Bit);
  if (Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_HasShortForwardBranchOptBit);
  if (!Subtarget->hasShortForwardBranchOpt())
    Features.set(Feature_NoShortForwardBranchOptBit);
  if (Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_HasConditionalMoveFusionBit);
  if (!Subtarget->hasConditionalMoveFusion())
    Features.set(Feature_NoConditionalMoveFusionBit);
  if (Subtarget->hasStdExtA() || Subtarget->hasForcedAtomics())
    Features.set(Feature_HasAtomicLdStBit);
  if (MF ? MF->getFunction().hasMinSize() : false)
    Features.set(Feature_OptForMinSizeBit);
  if (!((Subtarget->is64Bit())))
    Features.set(Feature_HwMode1Bit);
  if ((Subtarget->is64Bit()))
    Features.set(Feature_HwMode0Bit);
  return Features;
}

void RISCVInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const RISCVSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset RISCVInstructionSelector::
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HwMode0,
  GIFBS_HwMode1,
  GIFBS_HasAtomicLdSt_HwMode0,
  GIFBS_HasAtomicLdSt_HwMode1,
  GIFBS_HasShortForwardBranchOpt_HwMode0,
  GIFBS_HasShortForwardBranchOpt_HwMode1,
  GIFBS_HasStdExtA_HwMode0,
  GIFBS_HasStdExtA_HwMode1,
  GIFBS_HasStdExtD,
  GIFBS_HasStdExtD_HwMode0,
  GIFBS_HasStdExtD_HwMode1,
  GIFBS_HasStdExtF,
  GIFBS_HasStdExtF_HwMode0,
  GIFBS_HasStdExtF_HwMode1,
  GIFBS_HasStdExtM_HwMode0,
  GIFBS_HasStdExtM_HwMode1,
  GIFBS_HasStdExtZalasr_HwMode0,
  GIFBS_HasStdExtZalasr_HwMode1,
  GIFBS_HasStdExtZba_HwMode0,
  GIFBS_HasStdExtZba_HwMode1,
  GIFBS_HasStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_HwMode1,
  GIFBS_HasStdExtZbkb_HwMode0,
  GIFBS_HasStdExtZbkb_HwMode1,
  GIFBS_HasStdExtZbkx_HwMode0,
  GIFBS_HasStdExtZbkx_HwMode1,
  GIFBS_HasStdExtZbs_HwMode0,
  GIFBS_HasStdExtZbs_HwMode1,
  GIFBS_HasStdExtZfa,
  GIFBS_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtZfh,
  GIFBS_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtZfinx,
  GIFBS_HasStdExtZfinx_HwMode0,
  GIFBS_HasStdExtZfinx_HwMode1,
  GIFBS_HasStdExtZhinx,
  GIFBS_HasStdExtZhinx_HwMode0,
  GIFBS_HasStdExtZhinx_HwMode1,
  GIFBS_HasStdExtZhinxmin_HwMode0,
  GIFBS_HasStdExtZhinxmin_HwMode1,
  GIFBS_HasStdExtZmmul_HwMode0,
  GIFBS_HasStdExtZmmul_HwMode1,
  GIFBS_HasStdExtZvbb_HwMode0,
  GIFBS_HasStdExtZvbb_HwMode1,
  GIFBS_HasStdExtZvbc_HwMode0,
  GIFBS_HasStdExtZvbc_HwMode1,
  GIFBS_HasStdExtZvkb_HwMode0,
  GIFBS_HasStdExtZvkb_HwMode1,
  GIFBS_HasStdExtZvkg_HwMode0,
  GIFBS_HasStdExtZvkg_HwMode1,
  GIFBS_HasStdExtZvkned_HwMode0,
  GIFBS_HasStdExtZvkned_HwMode1,
  GIFBS_HasStdExtZvknha_HwMode0,
  GIFBS_HasStdExtZvknha_HwMode1,
  GIFBS_HasStdExtZvknhb_HwMode0,
  GIFBS_HasStdExtZvknhb_HwMode1,
  GIFBS_HasStdExtZvksed_HwMode0,
  GIFBS_HasStdExtZvksed_HwMode1,
  GIFBS_HasStdExtZvksh_HwMode0,
  GIFBS_HasStdExtZvksh_HwMode1,
  GIFBS_HasVInstructions_HwMode0,
  GIFBS_HasVInstructions_HwMode1,
  GIFBS_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsF16Minimal_HwMode0,
  GIFBS_HasVInstructionsF16Minimal_HwMode1,
  GIFBS_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsFullMultiply_HwMode0,
  GIFBS_HasVInstructionsFullMultiply_HwMode1,
  GIFBS_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCVmac_HwMode0,
  GIFBS_HasVendorXCVmac_HwMode1,
  GIFBS_HasVendorXSfvcp_HwMode0,
  GIFBS_HasVendorXSfvcp_HwMode1,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0,
  GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1,
  GIFBS_HasVendorXSfvqmaccdod_HwMode0,
  GIFBS_HasVendorXSfvqmaccdod_HwMode1,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode0,
  GIFBS_HasVendorXSfvqmaccqoq_HwMode1,
  GIFBS_HasVendorXTHeadBa_HwMode0,
  GIFBS_HasVendorXTHeadBa_HwMode1,
  GIFBS_HasVendorXTHeadBb_HwMode0,
  GIFBS_HasVendorXTHeadBb_HwMode1,
  GIFBS_HasVendorXTHeadBs_HwMode0,
  GIFBS_HasVendorXTHeadBs_HwMode1,
  GIFBS_HasVendorXTHeadCondMov_HwMode0,
  GIFBS_HasVendorXTHeadCondMov_HwMode1,
  GIFBS_HasVendorXTHeadMac_HwMode0,
  GIFBS_HasVendorXTHeadMac_HwMode1,
  GIFBS_HasVendorXTHeadVdot_HwMode0,
  GIFBS_HasVendorXTHeadVdot_HwMode1,
  GIFBS_IsRV32_HwMode0,
  GIFBS_IsRV32_HwMode1,
  GIFBS_IsRV64_HwMode0,
  GIFBS_IsRV64_HwMode1,
  GIFBS_UseCCMovInsn_HwMode0,
  GIFBS_UseCCMovInsn_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV32_HwMode1,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode0,
  GIFBS_HasAtomicLdSt_IsRV64_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_IsRV64_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_NoStdExtZacas_HwMode1,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfa,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_HwMode1,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1,
  GIFBS_HasStdExtD_IsRV32_HwMode0,
  GIFBS_HasStdExtD_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV64_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode0,
  GIFBS_HasStdExtF_IsRV32_HwMode1,
  GIFBS_HasStdExtF_IsRV64_HwMode0,
  GIFBS_HasStdExtM_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV32_HwMode1,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode0,
  GIFBS_HasStdExtZalasr_IsRV64_HwMode1,
  GIFBS_HasStdExtZba_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbb_IsRV64_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0,
  GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1,
  GIFBS_HasStdExtZfh_IsRV32_HwMode0,
  GIFBS_HasStdExtZfh_IsRV32_HwMode1,
  GIFBS_HasStdExtZfh_IsRV64_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZfinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZfinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode0,
  GIFBS_HasStdExtZhinx_IsRV32_HwMode1,
  GIFBS_HasStdExtZhinx_IsRV64_HwMode0,
  GIFBS_HasStdExtZknd_IsRV32_HwMode1,
  GIFBS_HasStdExtZknd_IsRV64_HwMode0,
  GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZkne_IsRV32_HwMode1,
  GIFBS_HasStdExtZkne_IsRV64_HwMode0,
  GIFBS_HasStdExtZknh_IsRV32_HwMode1,
  GIFBS_HasStdExtZknh_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0,
  GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1,
  GIFBS_HasVendorXCValu_IsRV32_HwMode0,
  GIFBS_HasVendorXCValu_IsRV32_HwMode1,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0,
  GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1,
  GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0,
  GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode0,
  GIFBS_HasVendorXqcia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcilia_IsRV32_HwMode1,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode0,
  GIFBS_HasVendorXqcisls_IsRV32_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0,
  GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0,
  GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0,
  GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1,
  GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0,
  GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0,
  GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1,
  GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0,
  GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0,
  GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0,
  GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HwMode0Bit, },
  {Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_HwMode1Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode0Bit, },
  {Feature_HasShortForwardBranchOptBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, },
  {Feature_HasStdExtDBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, },
  {Feature_HasStdExtFBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbcBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkgBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvknhbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvksedBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkshBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF16MinimalBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsFullMultiplyBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVmacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvcpBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvfnrclipxfqfBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccdodBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXSfvqmaccqoqBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBaBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadBsBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadCondMovBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadVdotBit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode0Bit, },
  {Feature_UseCCMovInsnBit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasAtomicLdStBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NoStdExtZacasBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfhminBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtFBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtMBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZalasrBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbaBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbBit, Feature_IsRV64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbbOrZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfaBit, Feature_HasStdExtZfhBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZfinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZhinxBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkndBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkndOrZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZkneBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZknhBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvkbBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsAnyFBit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF16Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsF64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsAnyFBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasVInstructionsF64Bit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCValuBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXCVbitmanipBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXTHeadBbBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXTHeadMacBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqciaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqciliaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasVendorXqcislsBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZabhaBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtABit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NoStdExtZacasBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtABit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_HasStdExtZfaBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtDBit, Feature_IsRV32Bit, Feature_NoStdExtZfaBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZabhaBit, Feature_HasStdExtZacasBit, Feature_NotHasStdExtZtsoBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZacasBit, Feature_HasStdExtZtsoBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZacasBit, Feature_IsRV64Bit, Feature_NotHasStdExtZtsoBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZbkbBit, Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV32Bit, Feature_HwMode1Bit, },
  {Feature_HasStdExtZdinxBit, Feature_HasStdExtZhinxminBit, Feature_IsRV64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZmmulBit, Feature_IsRV64Bit, Feature_NotHasStdExtZbaBit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode0Bit, },
  {Feature_HasStdExtZvbbBit, Feature_HasVInstructionsBit, Feature_HasVInstructionsI64Bit, Feature_HwMode1Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV32Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode0Bit, },
  {Feature_IsRV64Bit, Feature_NoStdExtZbbBit, Feature_NoStdExtZbkbBit, Feature_HwMode1Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_GIAddrRegImm,
  GICP_GIShiftMask32,
  GICP_GIShiftMaskXLen,
  GICP_GIVLOp,
  GICP_gi_sexti32,
  GICP_gi_sh1add_op,
  GICP_gi_sh1add_uw_op,
  GICP_gi_sh2add_op,
  GICP_gi_sh2add_uw_op,
  GICP_gi_sh3add_op,
  GICP_gi_sh3add_uw_op,
  GICP_gi_zexti16,
  GICP_gi_zexti32,
  GICP_gi_zexti8,
};
// See constructor for table contents

RISCVInstructionSelector::ComplexMatcherMemFn
RISCVInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &RISCVInstructionSelector::selectAddrRegImm, // GIAddrRegImm
  &RISCVInstructionSelector::selectShiftMask32, // GIShiftMask32
  &RISCVInstructionSelector::selectShiftMaskXLen, // GIShiftMaskXLen
  &RISCVInstructionSelector::renderVLOp, // GIVLOp
  &RISCVInstructionSelector::selectSExtBits<32>, // gi_sexti32
  &RISCVInstructionSelector::selectSHXADDOp<1>, // gi_sh1add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<1>, // gi_sh1add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<2>, // gi_sh2add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<2>, // gi_sh2add_uw_op
  &RISCVInstructionSelector::selectSHXADDOp<3>, // gi_sh3add_op
  &RISCVInstructionSelector::selectSHXADD_UWOp<3>, // gi_sh3add_uw_op
  &RISCVInstructionSelector::selectZExtBits<16>, // gi_zexti16
  &RISCVInstructionSelector::selectZExtBits<32>, // gi_zexti32
  &RISCVInstructionSelector::selectZExtBits<8>, // gi_zexti8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_like_non_imm12 = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_add_non_imm12,
  GICXXPred_MI_Predicate_anonymous_9934,
  GICXXPred_MI_Predicate_anonymous_9936,
  GICXXPred_MI_Predicate_anonymous_10024,
  GICXXPred_MI_Predicate_anonymous_10038,
  GICXXPred_MI_Predicate_anonymous_10042,
  GICXXPred_MI_Predicate_anonymous_10044,
  GICXXPred_MI_Predicate_anonymous_10046,
  GICXXPred_MI_Predicate_anonymous_10048,
  GICXXPred_MI_Predicate_anonymous_10051,
  GICXXPred_MI_Predicate_anonymous_10053,
  GICXXPred_MI_Predicate_anonymous_10066,
  GICXXPred_MI_Predicate_anonymous_10078,
  GICXXPred_MI_Predicate_anonymous_11211,
};
bool RISCVInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_like_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_like_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_add_non_imm12: {
    
        const MachineOperand &ImmOp = *Operands[1];
    
        if (ImmOp.isReg() && ImmOp.getReg())
          if (auto Val = getIConstantVRegValWithLookThrough(ImmOp.getReg(), MRI)) {
            // We do NOT want immediates that fit in 12 bits.
            return !isInt<12>(Val->Value.getSExtValue());
          }
    
        return true;
      
    llvm_unreachable("add_non_imm12 should have returned");
  }
  case GICXXPred_MI_Predicate_anonymous_9934: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_9936: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10024: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10038: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10042: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10044: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10046: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10048: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10051: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10053: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_10066: {
    
        return MRI.hasOneNonDBGUse(MI.getOperand(0).getReg());
      
  }
  case GICXXPred_MI_Predicate_anonymous_10078: {
     return hasAllWUsers(MI); 
  }
  case GICXXPred_MI_Predicate_anonymous_11211: {
     return hasAllHUsers(MI); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_AddiPair = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_BCLRMask,
  GICXXPred_I64_Predicate_LeadingOnesMask,
  GICXXPred_I64_Predicate_LeadingOnesWMask,
  GICXXPred_I64_Predicate_SingleBitSetMask,
  GICXXPred_I64_Predicate_allonessew8,
  GICXXPred_I64_Predicate_allonessew16,
  GICXXPred_I64_Predicate_allonessew32,
  GICXXPred_I64_Predicate_allonessew64,
  GICXXPred_I64_Predicate_bare_simm9_lsb0,
  GICXXPred_I64_Predicate_bare_simm12_lsb0,
  GICXXPred_I64_Predicate_byteselect,
  GICXXPred_I64_Predicate_c_lui_imm,
  GICXXPred_I64_Predicate_csr_sysreg,
  GICXXPred_I64_Predicate_cv_tuimm2,
  GICXXPred_I64_Predicate_cv_tuimm5,
  GICXXPred_I64_Predicate_cv_uimm10,
  GICXXPred_I64_Predicate_immzero,
  GICXXPred_I64_Predicate_payload1,
  GICXXPred_I64_Predicate_payload2,
  GICXXPred_I64_Predicate_payload5,
  GICXXPred_I64_Predicate_powerOf2Minus1,
  GICXXPred_I64_Predicate_rnum,
  GICXXPred_I64_Predicate_simm5,
  GICXXPred_I64_Predicate_simm5_plus1,
  GICXXPred_I64_Predicate_simm5_plus1_nonzero,
  GICXXPred_I64_Predicate_simm5nonzero,
  GICXXPred_I64_Predicate_simm6,
  GICXXPred_I64_Predicate_simm6nonzero,
  GICXXPred_I64_Predicate_simm10_lsb0000nonzero,
  GICXXPred_I64_Predicate_simm11,
  GICXXPred_I64_Predicate_simm12,
  GICXXPred_I64_Predicate_simm12Minus1Nonzero,
  GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1,
  GICXXPred_I64_Predicate_simm12Plus1,
  GICXXPred_I64_Predicate_simm12Plus1i32,
  GICXXPred_I64_Predicate_simm12_lsb00000,
  GICXXPred_I64_Predicate_simm12_no6,
  GICXXPred_I64_Predicate_simm12_plus1,
  GICXXPred_I64_Predicate_simm16nonzero,
  GICXXPred_I64_Predicate_simm26,
  GICXXPred_I64_Predicate_simm26_nosimm12,
  GICXXPred_I64_Predicate_simm32_nosimm26,
  GICXXPred_I64_Predicate_tsimm5,
  GICXXPred_I64_Predicate_tuimm5,
  GICXXPred_I64_Predicate_u32simm12,
  GICXXPred_I64_Predicate_uimm1,
  GICXXPred_I64_Predicate_uimm2,
  GICXXPred_I64_Predicate_uimm2_3,
  GICXXPred_I64_Predicate_uimm2_4,
  GICXXPred_I64_Predicate_uimm2_lsb0,
  GICXXPred_I64_Predicate_uimm3,
  GICXXPred_I64_Predicate_uimm4,
  GICXXPred_I64_Predicate_uimm5,
  GICXXPred_I64_Predicate_uimm5_lsb0,
  GICXXPred_I64_Predicate_uimm5_plus1,
  GICXXPred_I64_Predicate_uimm5ge6_plus1,
  GICXXPred_I64_Predicate_uimm5gt3,
  GICXXPred_I64_Predicate_uimm5i32,
  GICXXPred_I64_Predicate_uimm5nonzero,
  GICXXPred_I64_Predicate_uimm5slist,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_lsb0,
  GICXXPred_I64_Predicate_uimm6gt32,
  GICXXPred_I64_Predicate_uimm7_lsb00,
  GICXXPred_I64_Predicate_uimm7_lsb000,
  GICXXPred_I64_Predicate_uimm8_lsb00,
  GICXXPred_I64_Predicate_uimm8_lsb000,
  GICXXPred_I64_Predicate_uimm9_lsb000,
  GICXXPred_I64_Predicate_uimm10,
  GICXXPred_I64_Predicate_uimm10_lsb00nonzero,
  GICXXPred_I64_Predicate_uimm11,
  GICXXPred_I64_Predicate_uimm14lsb00,
  GICXXPred_I64_Predicate_uimm16nonzero,
  GICXXPred_I64_Predicate_uimmlog2xlen,
  GICXXPred_I64_Predicate_uimmlog2xlennonzero,
};
bool RISCVInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_AddiPair: {
    
      // The immediate operand must be in range [-4096,-2049] or [2048,4094].
      return (-4096 <= Imm && Imm <= -2049) || (2048 <= Imm && Imm <= 4094);
    
    llvm_unreachable("AddiPair should have returned");
  }
  case GICXXPred_I64_Predicate_BCLRMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(~Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(~Imm);
    
    llvm_unreachable("BCLRMask should have returned");
  }
  case GICXXPred_I64_Predicate_LeadingOnesMask: {
    
      return !isInt<32>(Imm) && isMask_64(~Imm);
    
  }
  case GICXXPred_I64_Predicate_LeadingOnesWMask: {
    
      // If the value is a uint32 but not an int32, it must have bit 31 set and
      // bits 63:32 cleared. After that we're looking for a shifted mask but not
      // an all ones mask.
      return !isInt<32>(Imm) && isUInt<32>(Imm) && isShiftedMask_64(Imm) &&
             Imm != UINT64_C(0xffffffff);
    
    llvm_unreachable("LeadingOnesWMask should have returned");
  }
  case GICXXPred_I64_Predicate_SingleBitSetMask: {
    
      if (Subtarget->is64Bit())
        return !isInt<12>(Imm) && isPowerOf2_64(Imm);
      return !isInt<12>(Imm) && isPowerOf2_32(Imm);
    
    llvm_unreachable("SingleBitSetMask should have returned");
  }
  case GICXXPred_I64_Predicate_allonessew8: {
    return SignExtend64<8>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew16: {
    return SignExtend64<16>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew32: {
    return SignExtend64<32>(Imm) == -1LL;
  }
  case GICXXPred_I64_Predicate_allonessew64: {
    return Imm == -1LL;
  }
  case GICXXPred_I64_Predicate_bare_simm9_lsb0: {
    return isShiftedInt<8, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_bare_simm12_lsb0: {
    return isShiftedInt<11, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_byteselect: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_c_lui_imm: {
    return (Imm != 0) &&
                                     (isUInt<5>(Imm) ||
                                      (Imm >= 0xfffe0 && Imm <= 0xfffff));
  }
  case GICXXPred_I64_Predicate_csr_sysreg: {
    return isUInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_cv_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_immzero: {
    return (Imm == 0);
  }
  case GICXXPred_I64_Predicate_payload1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_payload2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_payload5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_powerOf2Minus1: {
     return isPowerOf2_32(Imm+1); 
  }
  case GICXXPred_I64_Predicate_rnum: {
    return (Imm >= 0 && Imm <= 10);
  }
  case GICXXPred_I64_Predicate_simm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm5_plus1: {
    return (isInt<5>(Imm) && Imm != -16) || Imm == 16;
  }
  case GICXXPred_I64_Predicate_simm5_plus1_nonzero: {
    return Imm != 0 && ((isInt<5>(Imm) && Imm != -16) || Imm == 16);
  }
  case GICXXPred_I64_Predicate_simm5nonzero: {
    return (Imm != 0) && isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6: {
    return isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm6nonzero: {
    return (Imm != 0) && isInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_simm10_lsb0000nonzero: {
    return (Imm != 0) && isShiftedInt<6, 4>(Imm);
  }
  case GICXXPred_I64_Predicate_simm11: {
    return isInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12: {
    return isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12Minus1Nonzero: {
    
      return (Imm >= -2049 && Imm < 0) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1: {
    
      return (Imm >= -2049 && Imm < -1) || (Imm > 0 && Imm <= 2046);
  }
  case GICXXPred_I64_Predicate_simm12Plus1: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12Plus1i32: {
    
        return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm12_lsb00000: {
    return isShiftedInt<7, 5>(Imm);
  }
  case GICXXPred_I64_Predicate_simm12_no6: {
    
      return isInt<12>(Imm) && !isInt<6>(Imm) && isInt<12>(-Imm);
  }
  case GICXXPred_I64_Predicate_simm12_plus1: {
    return (isInt<12>(Imm) && Imm != -2048) || Imm == 2048;
  }
  case GICXXPred_I64_Predicate_simm16nonzero: {
    return (Imm != 0) && isInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26: {
    return isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_simm26_nosimm12: {
    
      return isInt<26>(Imm) && !isInt<12>(Imm);
  }
  case GICXXPred_I64_Predicate_simm32_nosimm26: {
    
      return isInt<32>(Imm) && !isInt<26>(Imm);
  }
  case GICXXPred_I64_Predicate_tsimm5: {
    return isInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_tuimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_u32simm12: {
    
      return isUInt<32>(Imm) && isInt<12>(SignExtend64<32>(Imm));
    
  }
  case GICXXPred_I64_Predicate_uimm1: {
    return isUInt<1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2: {
    return isUInt<2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm2_3: {
    
      return isShiftedUInt<2, 3>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_4: {
    
      return isShiftedUInt<2, 4>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm2_lsb0: {
    return isShiftedUInt<1, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm3: {
    return isUInt<3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm4: {
    return isUInt<4>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_lsb0: {
    return isShiftedUInt<4, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5_plus1: {
    return (isUInt<5>(Imm) && (Imm != 0)) || (Imm == 32);
  }
  case GICXXPred_I64_Predicate_uimm5ge6_plus1: {
    return (Imm >= 6) && (isUInt<5>(Imm) || (Imm == 32));
  }
  case GICXXPred_I64_Predicate_uimm5gt3: {
    return (Imm > 3) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5i32: {
    return isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5nonzero: {
    return (Imm != 0) && isUInt<5>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm5slist: {
    return ((Imm == 0)  ||
                (Imm == 1)  ||
                (Imm == 2)  ||
                (Imm == 4)  ||
                (Imm == 8)  ||
                (Imm == 16) ||
                (Imm == 15) ||
                (Imm == 31));
  }
  case GICXXPred_I64_Predicate_uimm6: {
    return isUInt<6>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6_lsb0: {
    return isShiftedUInt<5, 1>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm6gt32: {
    
      return isUInt<6>(Imm) && Imm > 32;
    
  }
  case GICXXPred_I64_Predicate_uimm7_lsb00: {
    return isShiftedUInt<5, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm7_lsb000: {
    return isShiftedUInt<4, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb00: {
    return isShiftedUInt<6, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm8_lsb000: {
    return isShiftedUInt<5, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm9_lsb000: {
    return isShiftedUInt<6, 3>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10: {
    return isUInt<10>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm10_lsb00nonzero: {
    return isShiftedUInt<8, 2>(Imm) && (Imm != 0);
  }
  case GICXXPred_I64_Predicate_uimm11: {
    return isUInt<11>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm14lsb00: {
    return isShiftedUInt<12, 2>(Imm);
  }
  case GICXXPred_I64_Predicate_uimm16nonzero: {
    return (Imm != 0) && isUInt<16>(Imm);
  }
  case GICXXPred_I64_Predicate_uimmlog2xlen: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm);
      return isUInt<5>(Imm);
    
    llvm_unreachable("uimmlog2xlen should have returned");
  }
  case GICXXPred_I64_Predicate_uimmlog2xlennonzero: {
    
      if (Subtarget->is64Bit())
        return isUInt<6>(Imm) && (Imm != 0);
      return isUInt<5>(Imm) && (Imm != 0);
    
    llvm_unreachable("uimmlog2xlennonzero should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool RISCVInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_Shifted32OnesMask = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_TrailingOnesMask,
};
bool RISCVInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_Shifted32OnesMask: {
    
      if (!Imm.isShiftedMask())
        return false;
    
      unsigned TrailingZeros = Imm.countr_zero();
      return TrailingZeros > 0 && TrailingZeros < 32 &&
             Imm == UINT64_C(0xFFFFFFFF) << TrailingZeros;
    
    llvm_unreachable("Shifted32OnesMask should have returned");
  }
  case GICXXPred_APInt_Predicate_TrailingOnesMask: {
    
      return !isInt<12>(Imm.getSExtValue()) && isMask_64(Imm.getZExtValue());
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool RISCVInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("RISCVInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderAddiPairImmLarge,
  GICR_renderAddiPairImmSmall,
  GICR_renderFrameIndex,
  GICR_renderImmPlus1,
  GICR_renderImmSubFrom32,
  GICR_renderImmSubFromXLen,
  GICR_renderNegImm,
  GICR_renderTrailingZeros,
  GICR_renderXLenSubTrailingOnes,
};
RISCVInstructionSelector::CustomRendererFn
RISCVInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &RISCVInstructionSelector::renderAddiPairImmLarge,
  &RISCVInstructionSelector::renderAddiPairImmSmall,
  &RISCVInstructionSelector::renderFrameIndex,
  &RISCVInstructionSelector::renderImmPlus1,
  &RISCVInstructionSelector::renderImmSubFrom32,
  &RISCVInstructionSelector::renderImmSubFromXLen,
  &RISCVInstructionSelector::renderNegImm,
  &RISCVInstructionSelector::renderTrailingZeros,
  &RISCVInstructionSelector::renderXLenSubTrailingOnes,
};

bool RISCVInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool RISCVInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("RISCVInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *RISCVInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*       0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(333), /*)*//*default:*//*Label 125*/ GIMT_Encode4(2435439),
     /*      10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1130),
     /*      14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(56961),
     /*      18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(76194),
     /*      22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(103248),
     /*      26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(105982),
     /*      30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(108716),
     /*      34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(111495), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(114229),
     /*      50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(123673),
     /*      54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(136294), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      74 */ /*TargetOpcode::G_FRAME_INDEX*//*Label 10*/ GIMT_Encode4(151201), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*      94 */ /*TargetOpcode::G_UNMERGE_VALUES*//*Label 11*/ GIMT_Encode4(151262), GIMT_Encode4(0),
     /*     102 */ /*TargetOpcode::G_MERGE_VALUES*//*Label 12*/ GIMT_Encode4(151323), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     126 */ /*TargetOpcode::G_BITCAST*//*Label 13*/ GIMT_Encode4(151414), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 14*/ GIMT_Encode4(151781),
     /*     146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 15*/ GIMT_Encode4(151979),
     /*     150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 16*/ GIMT_Encode4(152177),
     /*     154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 17*/ GIMT_Encode4(152757),
     /*     158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 18*/ GIMT_Encode4(152967),
     /*     162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 19*/ GIMT_Encode4(153165),
     /*     166 */ /*TargetOpcode::G_READSTEADYCOUNTER*//*Label 20*/ GIMT_Encode4(153204),
     /*     170 */ /*TargetOpcode::G_LOAD*//*Label 21*/ GIMT_Encode4(153243),
     /*     174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 22*/ GIMT_Encode4(163423),
     /*     178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 23*/ GIMT_Encode4(165393), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     194 */ /*TargetOpcode::G_STORE*//*Label 24*/ GIMT_Encode4(166883), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 25*/ GIMT_Encode4(174985),
     /*     210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 26*/ GIMT_Encode4(179871),
     /*     214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 27*/ GIMT_Encode4(182781), GIMT_Encode4(0),
     /*     222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 28*/ GIMT_Encode4(185691),
     /*     226 */ /*TargetOpcode::G_ATOMICRMW_NAND*//*Label 29*/ GIMT_Encode4(188601),
     /*     230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 30*/ GIMT_Encode4(189513),
     /*     234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 31*/ GIMT_Encode4(192423),
     /*     238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 32*/ GIMT_Encode4(195333),
     /*     242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 33*/ GIMT_Encode4(198243),
     /*     246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 34*/ GIMT_Encode4(201153),
     /*     250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 35*/ GIMT_Encode4(204063), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(206973), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(207191),
     /*     318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(2192578), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(2194094), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     354 */ /*TargetOpcode::G_SEXT*//*Label 40*/ GIMT_Encode4(2197215),
     /*     358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 41*/ GIMT_Encode4(2200690),
     /*     362 */ /*TargetOpcode::G_ZEXT*//*Label 42*/ GIMT_Encode4(2201239),
     /*     366 */ /*TargetOpcode::G_SHL*//*Label 43*/ GIMT_Encode4(2204926),
     /*     370 */ /*TargetOpcode::G_LSHR*//*Label 44*/ GIMT_Encode4(2213522),
     /*     374 */ /*TargetOpcode::G_ASHR*//*Label 45*/ GIMT_Encode4(2216553), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     386 */ /*TargetOpcode::G_ROTR*//*Label 46*/ GIMT_Encode4(2219492),
     /*     390 */ /*TargetOpcode::G_ROTL*//*Label 47*/ GIMT_Encode4(2222432),
     /*     394 */ /*TargetOpcode::G_ICMP*//*Label 48*/ GIMT_Encode4(2225342),
     /*     398 */ /*TargetOpcode::G_FCMP*//*Label 49*/ GIMT_Encode4(2252005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     410 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(2259467), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     454 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(2263859),
     /*     458 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(2266593),
     /*     462 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(2269327),
     /*     466 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(2272180),
     /*     470 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(2275033),
     /*     474 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(2277886),
     /*     478 */ /*TargetOpcode::G_USHLSAT*//*Label 57*/ GIMT_Encode4(2280739),
     /*     482 */ /*TargetOpcode::G_SSHLSAT*//*Label 58*/ GIMT_Encode4(2280797), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(2280855),
     /*     522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(2283283),
     /*     526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(2285711),
     /*     530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(2288139), GIMT_Encode4(0),
     /*     538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(2304784), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(2307212),
     /*     590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(2309183),
     /*     594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(2309636),
     /*     598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(2311172),
     /*     602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(2316058),
     /*     606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(2320944),
     /*     610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(2326230), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     622 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(2331516),
     /*     626 */ /*TargetOpcode::G_FCOPYSIGN*//*Label 72*/ GIMT_Encode4(2333487), GIMT_Encode4(0),
     /*     634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 73*/ GIMT_Encode4(2339549),
     /*     638 */ /*TargetOpcode::G_FMINNUM*//*Label 74*/ GIMT_Encode4(2339739),
     /*     642 */ /*TargetOpcode::G_FMAXNUM*//*Label 75*/ GIMT_Encode4(2341824), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     654 */ /*TargetOpcode::G_FMINIMUM*//*Label 76*/ GIMT_Encode4(2343909),
     /*     658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 77*/ GIMT_Encode4(2344035),
     /*     662 */ /*TargetOpcode::G_FMINIMUMNUM*//*Label 78*/ GIMT_Encode4(2344161),
     /*     666 */ /*TargetOpcode::G_FMAXIMUMNUM*//*Label 79*/ GIMT_Encode4(2346246), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     702 */ /*TargetOpcode::G_SMIN*//*Label 80*/ GIMT_Encode4(2348331),
     /*     706 */ /*TargetOpcode::G_SMAX*//*Label 81*/ GIMT_Encode4(2351107),
     /*     710 */ /*TargetOpcode::G_UMIN*//*Label 82*/ GIMT_Encode4(2353883),
     /*     714 */ /*TargetOpcode::G_UMAX*//*Label 83*/ GIMT_Encode4(2356659),
     /*     718 */ /*TargetOpcode::G_ABS*//*Label 84*/ GIMT_Encode4(2359435),
     /*     722 */ /*TargetOpcode::G_LROUND*//*Label 85*/ GIMT_Encode4(2359593),
     /*     726 */ /*TargetOpcode::G_LLROUND*//*Label 86*/ GIMT_Encode4(2360173),
     /*     730 */ /*TargetOpcode::G_BR*//*Label 87*/ GIMT_Encode4(2360383), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     774 */ /*TargetOpcode::G_CTTZ*//*Label 88*/ GIMT_Encode4(2360399), GIMT_Encode4(0),
     /*     782 */ /*TargetOpcode::G_CTLZ*//*Label 89*/ GIMT_Encode4(2362919), GIMT_Encode4(0),
     /*     790 */ /*TargetOpcode::G_CTPOP*//*Label 90*/ GIMT_Encode4(2365577),
     /*     794 */ /*TargetOpcode::G_BSWAP*//*Label 91*/ GIMT_Encode4(2368128),
     /*     798 */ /*TargetOpcode::G_BITREVERSE*//*Label 92*/ GIMT_Encode4(2370663),
     /*     802 */ /*TargetOpcode::G_FCEIL*//*Label 93*/ GIMT_Encode4(2373157), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     850 */ /*TargetOpcode::G_FSQRT*//*Label 94*/ GIMT_Encode4(2373355),
     /*     854 */ /*TargetOpcode::G_FFLOOR*//*Label 95*/ GIMT_Encode4(2375531),
     /*     858 */ /*TargetOpcode::G_FRINT*//*Label 96*/ GIMT_Encode4(2375729),
     /*     862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 97*/ GIMT_Encode4(2375927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 98*/ GIMT_Encode4(2376125),
     /*     894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 99*/ GIMT_Encode4(2378553),
     /*     898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 100*/ GIMT_Encode4(2380981),
     /*     902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 101*/ GIMT_Encode4(2383409), GIMT_Encode4(0),
     /*     910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 102*/ GIMT_Encode4(2385837),
     /*     914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 103*/ GIMT_Encode4(2402482), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     950 */ /*TargetOpcode::G_TRAP*//*Label 104*/ GIMT_Encode4(2404658),
     /*     954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 105*/ GIMT_Encode4(2404671), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    1050 */ /*RISCV::G_CLZW*//*Label 106*/ GIMT_Encode4(2404684),
     /*    1054 */ /*RISCV::G_CTZW*//*Label 107*/ GIMT_Encode4(2404779),
     /*    1058 */ /*RISCV::G_DIVUW*//*Label 108*/ GIMT_Encode4(2404809),
     /*    1062 */ /*RISCV::G_DIVW*//*Label 109*/ GIMT_Encode4(2404846),
     /*    1066 */ /*RISCV::G_FCLASS*//*Label 110*/ GIMT_Encode4(2404883),
     /*    1070 */ /*RISCV::G_FCVT_WU_RV64*//*Label 111*/ GIMT_Encode4(2405243),
     /*    1074 */ /*RISCV::G_FCVT_W_RV64*//*Label 112*/ GIMT_Encode4(2405441),
     /*    1078 */ /*RISCV::G_READ_VLENB*//*Label 113*/ GIMT_Encode4(2405639),
     /*    1082 */ /*RISCV::G_REMUW*//*Label 114*/ GIMT_Encode4(2405699),
     /*    1086 */ /*RISCV::G_ROLW*//*Label 115*/ GIMT_Encode4(2405736),
     /*    1090 */ /*RISCV::G_RORW*//*Label 116*/ GIMT_Encode4(2405861),
     /*    1094 */ /*RISCV::G_SLLW*//*Label 117*/ GIMT_Encode4(2405982), GIMT_Encode4(0),
     /*    1102 */ /*RISCV::G_SRAW*//*Label 118*/ GIMT_Encode4(2406029),
     /*    1106 */ /*RISCV::G_SRLW*//*Label 119*/ GIMT_Encode4(2406076),
     /*    1110 */ /*RISCV::G_VMCLR_VL*//*Label 120*/ GIMT_Encode4(2406123),
     /*    1114 */ /*RISCV::G_VMSET_VL*//*Label 121*/ GIMT_Encode4(2406772),
     /*    1118 */ /*RISCV::G_VMV_V_V_VL*//*Label 122*/ GIMT_Encode4(2407421),
     /*    1122 */ /*RISCV::G_VSLIDEDOWN_VL*//*Label 123*/ GIMT_Encode4(2411679),
     /*    1126 */ /*RISCV::G_VSLIDEUP_VL*//*Label 124*/ GIMT_Encode4(2423559),
     /*    1130 */ // Label 0: @1130
     /*    1130 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 150*/ GIMT_Encode4(56960),
     /*    1141 */ /*GILLT_s32*//*Label 126*/ GIMT_Encode4(1265),
     /*    1145 */ /*GILLT_s64*//*Label 127*/ GIMT_Encode4(2834), GIMT_Encode4(0),
     /*    1153 */ /*GILLT_nxv1s8*//*Label 128*/ GIMT_Encode4(7320),
     /*    1157 */ /*GILLT_nxv1s16*//*Label 129*/ GIMT_Encode4(7715),
     /*    1161 */ /*GILLT_nxv1s32*//*Label 130*/ GIMT_Encode4(10840),
     /*    1165 */ /*GILLT_nxv1s64*//*Label 131*/ GIMT_Encode4(13965), GIMT_Encode4(0),
     /*    1173 */ /*GILLT_nxv2s8*//*Label 132*/ GIMT_Encode4(17090),
     /*    1177 */ /*GILLT_nxv2s16*//*Label 133*/ GIMT_Encode4(17485),
     /*    1181 */ /*GILLT_nxv2s32*//*Label 134*/ GIMT_Encode4(20610),
     /*    1185 */ /*GILLT_nxv2s64*//*Label 135*/ GIMT_Encode4(23735), GIMT_Encode4(0),
     /*    1193 */ /*GILLT_nxv4s8*//*Label 136*/ GIMT_Encode4(26860),
     /*    1197 */ /*GILLT_nxv4s16*//*Label 137*/ GIMT_Encode4(27255),
     /*    1201 */ /*GILLT_nxv4s32*//*Label 138*/ GIMT_Encode4(30380),
     /*    1205 */ /*GILLT_nxv4s64*//*Label 139*/ GIMT_Encode4(33505), GIMT_Encode4(0),
     /*    1213 */ /*GILLT_nxv8s8*//*Label 140*/ GIMT_Encode4(36630),
     /*    1217 */ /*GILLT_nxv8s16*//*Label 141*/ GIMT_Encode4(37025),
     /*    1221 */ /*GILLT_nxv8s32*//*Label 142*/ GIMT_Encode4(40150),
     /*    1225 */ /*GILLT_nxv8s64*//*Label 143*/ GIMT_Encode4(43275), GIMT_Encode4(0),
     /*    1233 */ /*GILLT_nxv16s8*//*Label 144*/ GIMT_Encode4(46400),
     /*    1237 */ /*GILLT_nxv16s16*//*Label 145*/ GIMT_Encode4(46795),
     /*    1241 */ /*GILLT_nxv16s32*//*Label 146*/ GIMT_Encode4(49920), GIMT_Encode4(0),
     /*    1249 */ /*GILLT_nxv32s8*//*Label 147*/ GIMT_Encode4(53045),
     /*    1253 */ /*GILLT_nxv32s16*//*Label 148*/ GIMT_Encode4(53440), GIMT_Encode4(0),
     /*    1261 */ /*GILLT_nxv64s8*//*Label 149*/ GIMT_Encode4(56565),
     /*    1265 */ // Label 126: @1265
     /*    1265 */ GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(2833),
     /*    1270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*    1273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*    1276 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(1324), // Rule ID 2460 //
     /*    1281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1288 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    1292 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    1296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1300 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1311 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1:$pred:2:x, GPR:{ *:[i32] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1316 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1322 */     GIR_RootConstrainSelectedInstOperands,
     /*    1323 */     // GIR_Coverage, 2460,
     /*    1323 */     GIR_EraseRootFromParent_Done,
     /*    1324 */   // Label 152: @1324
     /*    1324 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(1372), // Rule ID 2470 //
     /*    1329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1336 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    1340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    1344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1359 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1:$pred:4:x, GPR:{ *:[i32] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1364 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1370 */     GIR_RootConstrainSelectedInstOperands,
     /*    1371 */     // GIR_Coverage, 2470,
     /*    1371 */     GIR_EraseRootFromParent_Done,
     /*    1372 */   // Label 153: @1372
     /*    1372 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(1420), // Rule ID 2480 //
     /*    1377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1384 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    1388 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    1392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1407 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1:$pred:6:x, GPR:{ *:[i32] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1412 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1418 */     GIR_RootConstrainSelectedInstOperands,
     /*    1419 */     // GIR_Coverage, 2480,
     /*    1419 */     GIR_EraseRootFromParent_Done,
     /*    1420 */   // Label 154: @1420
     /*    1420 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(1471), // Rule ID 62506 //
     /*    1425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1432 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    1436 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    1440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1444 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1455 */     // (add:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs2:$pred:24:x, GPR:{ *:[i32] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1462 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1469 */     GIR_RootConstrainSelectedInstOperands,
     /*    1470 */     // GIR_Coverage, 62506,
     /*    1470 */     GIR_EraseRootFromParent_Done,
     /*    1471 */   // Label 155: @1471
     /*    1471 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(1522), // Rule ID 62510 //
     /*    1476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1483 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    1487 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    1491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1495 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1506 */     // (add:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs2:$pred:25:x, GPR:{ *:[i32] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1513 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1520 */     GIR_RootConstrainSelectedInstOperands,
     /*    1521 */     // GIR_Coverage, 62510,
     /*    1521 */     GIR_EraseRootFromParent_Done,
     /*    1522 */   // Label 156: @1522
     /*    1522 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(1573), // Rule ID 62514 //
     /*    1527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    1538 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    1542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1557 */     // (add:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs2:$pred:26:x, GPR:{ *:[i32] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    1564 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1571 */     GIR_RootConstrainSelectedInstOperands,
     /*    1572 */     // GIR_Coverage, 62514,
     /*    1572 */     GIR_EraseRootFromParent_Done,
     /*    1573 */   // Label 157: @1573
     /*    1573 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(1621), // Rule ID 65174 //
     /*    1578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1585 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    1589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1593 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    1597 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1608 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:2:y, sh1add_op:{ *:[i32] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } sh1add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1613 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1619 */     GIR_RootConstrainSelectedInstOperands,
     /*    1620 */     // GIR_Coverage, 65174,
     /*    1620 */     GIR_EraseRootFromParent_Done,
     /*    1621 */   // Label 158: @1621
     /*    1621 */   GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(1669), // Rule ID 65182 //
     /*    1626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1633 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    1637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1641 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    1645 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1656 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:4:y, sh2add_op:{ *:[i32] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } sh2add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1661 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1667 */     GIR_RootConstrainSelectedInstOperands,
     /*    1668 */     // GIR_Coverage, 65182,
     /*    1668 */     GIR_EraseRootFromParent_Done,
     /*    1669 */   // Label 159: @1669
     /*    1669 */   GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(1717), // Rule ID 65190 //
     /*    1674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1681 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    1685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1689 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    1693 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1704 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:6:y, sh3add_op:{ *:[i32] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } sh3add_op:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    1707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1709 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    1713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    1715 */     GIR_RootConstrainSelectedInstOperands,
     /*    1716 */     // GIR_Coverage, 65190,
     /*    1716 */     GIR_EraseRootFromParent_Done,
     /*    1717 */   // Label 160: @1717
     /*    1717 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(1768), // Rule ID 73998 //
     /*    1722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1729 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    1733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1737 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    1741 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    1752 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:24:y, sh1add_op:{ *:[i32] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh1add_op:{ *:[i32] }:$rs2, 1:{ *:[i32] })
     /*    1752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1759 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    1766 */     GIR_RootConstrainSelectedInstOperands,
     /*    1767 */     // GIR_Coverage, 73998,
     /*    1767 */     GIR_EraseRootFromParent_Done,
     /*    1768 */   // Label 161: @1768
     /*    1768 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(1819), // Rule ID 74002 //
     /*    1773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1780 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    1784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1788 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    1792 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    1803 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:25:y, sh2add_op:{ *:[i32] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh2add_op:{ *:[i32] }:$rs2, 2:{ *:[i32] })
     /*    1803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1810 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    1817 */     GIR_RootConstrainSelectedInstOperands,
     /*    1818 */     // GIR_Coverage, 74002,
     /*    1818 */     GIR_EraseRootFromParent_Done,
     /*    1819 */   // Label 162: @1819
     /*    1819 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(1870), // Rule ID 74006 //
     /*    1824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    1827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1831 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    1835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1839 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    1843 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    1854 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:26:y, sh3add_op:{ *:[i32] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, sh3add_op:{ *:[i32] }:$rs2, 3:{ *:[i32] })
     /*    1854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    1857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    1861 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    1865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    1868 */     GIR_RootConstrainSelectedInstOperands,
     /*    1869 */     // GIR_Coverage, 74006,
     /*    1869 */     GIR_EraseRootFromParent_Done,
     /*    1870 */   // Label 163: @1870
     /*    1870 */   GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(1938), // Rule ID 2454 //
     /*    1875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1882 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    1886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    1890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    1894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    1898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    1902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1907 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    1911 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    1915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1919 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    1925 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x, GPR:{ *:[i32] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    1928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    1934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    1936 */     GIR_RootConstrainSelectedInstOperands,
     /*    1937 */     // GIR_Coverage, 2454,
     /*    1937 */     GIR_EraseRootFromParent_Done,
     /*    1938 */   // Label 164: @1938
     /*    1938 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(2006), // Rule ID 2464 //
     /*    1943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    1946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1950 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    1954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    1958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    1962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    1966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    1970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1975 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    1979 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    1983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    1987 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    1991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    1993 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x, GPR:{ *:[i32] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    1993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    1996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    1998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2004 */     GIR_RootConstrainSelectedInstOperands,
     /*    2005 */     // GIR_Coverage, 2464,
     /*    2005 */     GIR_EraseRootFromParent_Done,
     /*    2006 */   // Label 165: @2006
     /*    2006 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(2074), // Rule ID 2474 //
     /*    2011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2018 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    2022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2043 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    2051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2055 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2061 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x, GPR:{ *:[i32] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2072 */     GIR_RootConstrainSelectedInstOperands,
     /*    2073 */     // GIR_Coverage, 2474,
     /*    2073 */     GIR_EraseRootFromParent_Done,
     /*    2074 */   // Label 166: @2074
     /*    2074 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(2142), // Rule ID 65170 //
     /*    2079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2086 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    2090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2094 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    2098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    2123 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2129 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:1:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    2132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2140 */     GIR_RootConstrainSelectedInstOperands,
     /*    2141 */     // GIR_Coverage, 65170,
     /*    2141 */     GIR_EraseRootFromParent_Done,
     /*    2142 */   // Label 167: @2142
     /*    2142 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(2210), // Rule ID 65178 //
     /*    2147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2154 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    2158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2162 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    2166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2187 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    2191 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2197 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:3:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 2:{ *:[i32] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    2200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2208 */     GIR_RootConstrainSelectedInstOperands,
     /*    2209 */     // GIR_Coverage, 65178,
     /*    2209 */     GIR_EraseRootFromParent_Done,
     /*    2210 */   // Label 168: @2210
     /*    2210 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(2278), // Rule ID 65186 //
     /*    2215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode1),
     /*    2218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2222 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    2226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2230 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    2234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2255 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    2259 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2265 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs2:$pred:5:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 3:{ *:[i32] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    2268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    2276 */     GIR_RootConstrainSelectedInstOperands,
     /*    2277 */     // GIR_Coverage, 65186,
     /*    2277 */     GIR_EraseRootFromParent_Done,
     /*    2278 */   // Label 169: @2278
     /*    2278 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(2357), // Rule ID 62500 //
     /*    2283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2290 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    2294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    2319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    2327 */     // MIs[2] Operand 1
     /*    2327 */     // No operand predicates
     /*    2327 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    2331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2335 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2341 */     // (add:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i32] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    2341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    2348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    2352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    2355 */     GIR_RootConstrainSelectedInstOperands,
     /*    2356 */     // GIR_Coverage, 62500,
     /*    2356 */     GIR_EraseRootFromParent_Done,
     /*    2357 */   // Label 170: @2357
     /*    2357 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(2436), // Rule ID 73994 //
     /*    2362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode1),
     /*    2365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2369 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    2373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2377 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    2381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    2406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2410 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    2414 */     // MIs[2] Operand 1
     /*    2414 */     // No operand predicates
     /*    2414 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2420 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1:$pred:23:y, (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm2>>:$uimm2)
     /*    2420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    2423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    2431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    2434 */     GIR_RootConstrainSelectedInstOperands,
     /*    2435 */     // GIR_Coverage, 73994,
     /*    2435 */     GIR_EraseRootFromParent_Done,
     /*    2436 */   // Label 171: @2436
     /*    2436 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(2485), // Rule ID 115 //
     /*    2441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    2456 */     // MIs[1] Operand 1
     /*    2456 */     // No operand predicates
     /*    2456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    2460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    2468 */     // MIs[2] Operand 1
     /*    2468 */     // No operand predicates
     /*    2468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2470 */     // (add:{ *:[i32] } (frameindex:{ *:[i32] }):$fi, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i32] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i32] }:$fi), (imm:{ *:[i32] })<<P:Predicate_simm12>>:$offset)
     /*    2470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2475 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    2480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    2483 */     GIR_RootConstrainSelectedInstOperands,
     /*    2484 */     // GIR_Coverage, 115,
     /*    2484 */     GIR_EraseRootFromParent_Done,
     /*    2485 */   // Label 172: @2485
     /*    2485 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(2527), // Rule ID 75 //
     /*    2490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    2513 */     // MIs[1] Operand 1
     /*    2513 */     // No operand predicates
     /*    2513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2515 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*    2515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    2525 */     GIR_RootConstrainSelectedInstOperands,
     /*    2526 */     // GIR_Coverage, 75,
     /*    2526 */     GIR_EraseRootFromParent_Done,
     /*    2527 */   // Label 173: @2527
     /*    2527 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(2599), // Rule ID 286 //
     /*    2532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    2555 */     // MIs[1] Operand 1
     /*    2555 */     // No operand predicates
     /*    2555 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10066),
     /*    2559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2561 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10066>>:$rs2)  =>  (ADDI:{ *:[i32] } (ADDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (AddiPairImmLarge:{ *:[i32] } (imm:{ *:[i32] }):$rs2)), (AddiPairImmSmall:{ *:[i32] } (imm:{ *:[i32] }):$rs2))
     /*    2561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*    2564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    2573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    2577 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    2582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    2584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    2587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    2592 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    2597 */     GIR_RootConstrainSelectedInstOperands,
     /*    2598 */     // GIR_Coverage, 286,
     /*    2598 */     GIR_EraseRootFromParent_Done,
     /*    2599 */   // Label 174: @2599
     /*    2599 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(2641), // Rule ID 64499 //
     /*    2604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    2607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    2611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    2615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*    2627 */     // MIs[1] Operand 1
     /*    2627 */     // No operand predicates
     /*    2627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2629 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ADDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*    2629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDAI),
     /*    2632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    2634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    2639 */     GIR_RootConstrainSelectedInstOperands,
     /*    2640 */     // GIR_Coverage, 64499,
     /*    2640 */     GIR_EraseRootFromParent_Done,
     /*    2641 */   // Label 175: @2641
     /*    2641 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(2683), // Rule ID 64503 //
     /*    2646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*    2649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    2653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*    2657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    2665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*    2669 */     // MIs[1] Operand 1
     /*    2669 */     // No operand predicates
     /*    2669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2671 */     // (add:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ADDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*    2671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ADDI),
     /*    2674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    2678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    2681 */     GIR_RootConstrainSelectedInstOperands,
     /*    2682 */     // GIR_Coverage, 64503,
     /*    2682 */     GIR_EraseRootFromParent_Done,
     /*    2683 */   // Label 176: @2683
     /*    2683 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(2744), // Rule ID 74008 //
     /*    2688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    2691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    2703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2727 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rd)  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    2730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    2732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    2734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    2742 */     GIR_RootConstrainSelectedInstOperands,
     /*    2743 */     // GIR_Coverage, 74008,
     /*    2743 */     GIR_EraseRootFromParent_Done,
     /*    2744 */   // Label 177: @2744
     /*    2744 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(2805), // Rule ID 62568 //
     /*    2749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*    2752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    2764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    2768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*    2772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*    2776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    2788 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULA:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    2791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    2793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    2795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    2799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    2803 */     GIR_RootConstrainSelectedInstOperands,
     /*    2804 */     // GIR_Coverage, 62568,
     /*    2804 */     GIR_EraseRootFromParent_Done,
     /*    2805 */   // Label 178: @2805
     /*    2805 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(2832), // Rule ID 73 //
     /*    2810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*    2813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2825 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (ADD:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*    2825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    2830 */     GIR_RootConstrainSelectedInstOperands,
     /*    2831 */     // GIR_Coverage, 73,
     /*    2831 */     GIR_Done,
     /*    2832 */   // Label 179: @2832
     /*    2832 */   GIM_Reject,
     /*    2833 */ // Label 151: @2833
     /*    2833 */ GIM_Reject,
     /*    2834 */ // Label 127: @2834
     /*    2834 */ GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(7319),
     /*    2839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*    2842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*    2845 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(2940), // Rule ID 2504 //
     /*    2850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    2853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2857 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:11:x
     /*    2861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    2869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    2873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    2877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    2881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    2889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    2893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2898 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    2902 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    2913 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:11:y
     /*    2917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    2925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    2927 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x, GPR:{ *:[i64] }:$rs2:$pred:11:y)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    2927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    2930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    2932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    2936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    2938 */     GIR_RootConstrainSelectedInstOperands,
     /*    2939 */     // GIR_Coverage, 2504,
     /*    2939 */     GIR_EraseRootFromParent_Done,
     /*    2940 */   // Label 181: @2940
     /*    2940 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(3035), // Rule ID 2506 //
     /*    2945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    2948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2952 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:12:x
     /*    2956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    2960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    2964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    2968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    2972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    2976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    2980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    2984 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    2988 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    2993 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    2997 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3008 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:12:y
     /*    3012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3016 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3022 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x, GPR:{ *:[i64] }:$rs2:$pred:12:y)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3033 */     GIR_RootConstrainSelectedInstOperands,
     /*    3034 */     // GIR_Coverage, 2506,
     /*    3034 */     GIR_EraseRootFromParent_Done,
     /*    3035 */   // Label 182: @3035
     /*    3035 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(3130), // Rule ID 2508 //
     /*    3040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3047 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:13:x
     /*    3051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3079 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3083 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3088 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
     /*    3092 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
     /*    3103 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:13:y
     /*    3107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3111 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3117 */     // (add:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x, GPR:{ *:[i64] }:$rs2:$pred:13:y)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3128 */     GIR_RootConstrainSelectedInstOperands,
     /*    3129 */     // GIR_Coverage, 2508,
     /*    3129 */     GIR_EraseRootFromParent_Done,
     /*    3130 */   // Label 183: @3130
     /*    3130 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(3225), // Rule ID 2495 //
     /*    3135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3142 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:8:x
     /*    3146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3183 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3194 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3198 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:8:y
     /*    3202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3206 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3212 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x, GPR:{ *:[i64] }:$rs2:$pred:8:y)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3223 */     GIR_RootConstrainSelectedInstOperands,
     /*    3224 */     // GIR_Coverage, 2495,
     /*    3224 */     GIR_EraseRootFromParent_Done,
     /*    3225 */   // Label 184: @3225
     /*    3225 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(3320), // Rule ID 2498 //
     /*    3230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3237 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:9:x
     /*    3241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3269 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3278 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3289 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    3293 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:9:y
     /*    3297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3301 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3307 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x, GPR:{ *:[i64] }:$rs2:$pred:9:y)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3318 */     GIR_RootConstrainSelectedInstOperands,
     /*    3319 */     // GIR_Coverage, 2498,
     /*    3319 */     GIR_EraseRootFromParent_Done,
     /*    3320 */   // Label 185: @3320
     /*    3320 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(3415), // Rule ID 2501 //
     /*    3325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3332 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:10:x
     /*    3336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    3340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3364 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3373 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    3388 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:10:y
     /*    3392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3396 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3402 */     // (add:{ *:[i64] } (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x, GPR:{ *:[i64] }:$rs2:$pred:10:y)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    3413 */     GIR_RootConstrainSelectedInstOperands,
     /*    3414 */     // GIR_Coverage, 2501,
     /*    3414 */     GIR_EraseRootFromParent_Done,
     /*    3415 */   // Label 186: @3415
     /*    3415 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(3510), // Rule ID 65200 //
     /*    3420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3427 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:11:y
     /*    3431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3435 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:11:x
     /*    3439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3476 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*    3480 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934591),
     /*    3491 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3497 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:11:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), 8589934591:{ *:[i64] }):$pred:11:x)<<P:11:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3508 */     GIR_RootConstrainSelectedInstOperands,
     /*    3509 */     // GIR_Coverage, 65200,
     /*    3509 */     GIR_EraseRootFromParent_Done,
     /*    3510 */   // Label 187: @3510
     /*    3510 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(3605), // Rule ID 65202 //
     /*    3515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3522 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:12:y
     /*    3526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3530 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:12:x
     /*    3534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3571 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 2,
     /*    3575 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869183),
     /*    3586 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3592 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:12:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), 17179869183:{ *:[i64] }):$pred:12:x)<<P:12:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3603 */     GIR_RootConstrainSelectedInstOperands,
     /*    3604 */     // GIR_Coverage, 65202,
     /*    3604 */     GIR_EraseRootFromParent_Done,
     /*    3605 */   // Label 188: @3605
     /*    3605 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(3700), // Rule ID 65204 //
     /*    3610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3617 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:13:y
     /*    3621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3625 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:13:x
     /*    3629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3666 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 3,
     /*    3670 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738367),
     /*    3681 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3687 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:13:y, (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), 34359738367:{ *:[i64] }):$pred:13:x)<<P:13:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3698 */     GIR_RootConstrainSelectedInstOperands,
     /*    3699 */     // GIR_Coverage, 65204,
     /*    3699 */     GIR_EraseRootFromParent_Done,
     /*    3700 */   // Label 189: @3700
     /*    3700 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(3795), // Rule ID 65194 //
     /*    3705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3712 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:8:y
     /*    3716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3720 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:8:x
     /*    3724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3752 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3761 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3772 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    3776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3780 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3782 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:8:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 1:{ *:[i64] }):$pred:8:x)<<P:8:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    3785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3793 */     GIR_RootConstrainSelectedInstOperands,
     /*    3794 */     // GIR_Coverage, 65194,
     /*    3794 */     GIR_EraseRootFromParent_Done,
     /*    3795 */   // Label 190: @3795
     /*    3795 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(3890), // Rule ID 65196 //
     /*    3800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3807 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:9:y
     /*    3811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3815 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:9:x
     /*    3819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3843 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3847 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3851 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3856 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3867 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    3871 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3875 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3877 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:9:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 2:{ *:[i64] }):$pred:9:x)<<P:9:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    3880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3888 */     GIR_RootConstrainSelectedInstOperands,
     /*    3889 */     // GIR_Coverage, 65196,
     /*    3889 */     GIR_EraseRootFromParent_Done,
     /*    3890 */   // Label 191: @3890
     /*    3890 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(3985), // Rule ID 65198 //
     /*    3895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    3898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3902 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:10:y
     /*    3906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3910 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:10:x
     /*    3914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    3918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    3922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    3926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    3930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    3934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*    3938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*    3942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*    3946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3951 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*    3962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    3966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    3970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    3972 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:10:y, (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), 3:{ *:[i64] }):$pred:10:x)<<P:10:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    3972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    3975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    3977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    3981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    3983 */     GIR_RootConstrainSelectedInstOperands,
     /*    3984 */     // GIR_Coverage, 65198,
     /*    3984 */     GIR_EraseRootFromParent_Done,
     /*    3985 */   // Label 192: @3985
     /*    3985 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(4033), // Rule ID 2459 //
     /*    3990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    3993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    3997 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:2:x
     /*    4001 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:2:y
     /*    4005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4009 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4020 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1:$pred:2:x, GPR:{ *:[i64] }:$rs2:$pred:2:y)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    4023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4025 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4031 */     GIR_RootConstrainSelectedInstOperands,
     /*    4032 */     // GIR_Coverage, 2459,
     /*    4032 */     GIR_EraseRootFromParent_Done,
     /*    4033 */   // Label 193: @4033
     /*    4033 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(4081), // Rule ID 2469 //
     /*    4038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4045 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:4:x
     /*    4049 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:4:y
     /*    4053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4057 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4068 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1:$pred:4:x, GPR:{ *:[i64] }:$rs2:$pred:4:y)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    4071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4079 */     GIR_RootConstrainSelectedInstOperands,
     /*    4080 */     // GIR_Coverage, 2469,
     /*    4080 */     GIR_EraseRootFromParent_Done,
     /*    4081 */   // Label 194: @4081
     /*    4081 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(4129), // Rule ID 2479 //
     /*    4086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4093 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:6:x
     /*    4097 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:6:y
     /*    4101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4105 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4116 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1:$pred:6:x, GPR:{ *:[i64] }:$rs2:$pred:6:y)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    4119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4127 */     GIR_RootConstrainSelectedInstOperands,
     /*    4128 */     // GIR_Coverage, 2479,
     /*    4128 */     GIR_EraseRootFromParent_Done,
     /*    4129 */   // Label 195: @4129
     /*    4129 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(4177), // Rule ID 2510 //
     /*    4134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4141 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:14:x
     /*    4145 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:14:y
     /*    4149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4153 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    4164 */     // (add:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x, GPR:{ *:[i64] }:$rs2:$pred:14:y)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4169 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4175 */     GIR_RootConstrainSelectedInstOperands,
     /*    4176 */     // GIR_Coverage, 2510,
     /*    4176 */     GIR_EraseRootFromParent_Done,
     /*    4177 */   // Label 196: @4177
     /*    4177 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(4225), // Rule ID 2512 //
     /*    4182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4189 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:15:x
     /*    4193 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:15:y
     /*    4197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4201 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    4212 */     // (add:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x, GPR:{ *:[i64] }:$rs2:$pred:15:y)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4217 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4223 */     GIR_RootConstrainSelectedInstOperands,
     /*    4224 */     // GIR_Coverage, 2512,
     /*    4224 */     GIR_EraseRootFromParent_Done,
     /*    4225 */   // Label 197: @4225
     /*    4225 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(4273), // Rule ID 2514 //
     /*    4230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4237 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:16:x
     /*    4241 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:16:y
     /*    4245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4249 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    4260 */     // (add:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x, GPR:{ *:[i64] }:$rs2:$pred:16:y)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4265 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4271 */     GIR_RootConstrainSelectedInstOperands,
     /*    4272 */     // GIR_Coverage, 2514,
     /*    4272 */     GIR_EraseRootFromParent_Done,
     /*    4273 */   // Label 198: @4273
     /*    4273 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(4324), // Rule ID 62505 //
     /*    4278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4285 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:24:x
     /*    4289 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:24:y
     /*    4293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4297 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4308 */     // (add:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs2:$pred:24:x, GPR:{ *:[i64] }:$rs1:$pred:24:y)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    4308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4315 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    4322 */     GIR_RootConstrainSelectedInstOperands,
     /*    4323 */     // GIR_Coverage, 62505,
     /*    4323 */     GIR_EraseRootFromParent_Done,
     /*    4324 */   // Label 199: @4324
     /*    4324 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(4375), // Rule ID 62509 //
     /*    4329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4336 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:25:x
     /*    4340 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:25:y
     /*    4344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4348 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4359 */     // (add:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs2:$pred:25:x, GPR:{ *:[i64] }:$rs1:$pred:25:y)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    4359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4366 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    4373 */     GIR_RootConstrainSelectedInstOperands,
     /*    4374 */     // GIR_Coverage, 62509,
     /*    4374 */     GIR_EraseRootFromParent_Done,
     /*    4375 */   // Label 200: @4375
     /*    4375 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(4426), // Rule ID 62513 //
     /*    4380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4387 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:26:x
     /*    4391 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:26:y
     /*    4395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4399 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4410 */     // (add:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs2:$pred:26:x, GPR:{ *:[i64] }:$rs1:$pred:26:y)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    4410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    4417 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    4424 */     GIR_RootConstrainSelectedInstOperands,
     /*    4425 */     // GIR_Coverage, 62513,
     /*    4425 */     GIR_EraseRootFromParent_Done,
     /*    4426 */   // Label 201: @4426
     /*    4426 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(4474), // Rule ID 65173 //
     /*    4431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4438 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:2:y
     /*    4442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4446 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:2:x
     /*    4450 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4461 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:2:y, sh1add_op:{ *:[i64] }:$rs1:$pred:2:x)<<P:2:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } sh1add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    4464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4466 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4472 */     GIR_RootConstrainSelectedInstOperands,
     /*    4473 */     // GIR_Coverage, 65173,
     /*    4473 */     GIR_EraseRootFromParent_Done,
     /*    4474 */   // Label 202: @4474
     /*    4474 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(4522), // Rule ID 65181 //
     /*    4479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4486 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:4:y
     /*    4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4494 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:4:x
     /*    4498 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4509 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:4:y, sh2add_op:{ *:[i64] }:$rs1:$pred:4:x)<<P:4:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } sh2add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    4512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4514 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4520 */     GIR_RootConstrainSelectedInstOperands,
     /*    4521 */     // GIR_Coverage, 65181,
     /*    4521 */     GIR_EraseRootFromParent_Done,
     /*    4522 */   // Label 203: @4522
     /*    4522 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(4570), // Rule ID 65189 //
     /*    4527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    4530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4534 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:6:y
     /*    4538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4542 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:6:x
     /*    4546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4557 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:6:y, sh3add_op:{ *:[i64] }:$rs1:$pred:6:x)<<P:6:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } sh3add_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    4560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4562 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4568 */     GIR_RootConstrainSelectedInstOperands,
     /*    4569 */     // GIR_Coverage, 65189,
     /*    4569 */     GIR_EraseRootFromParent_Done,
     /*    4570 */   // Label 204: @4570
     /*    4570 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(4618), // Rule ID 65206 //
     /*    4575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4582 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:14:y
     /*    4586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4590 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:14:x
     /*    4594 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_uw_op),
     /*    4605 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:14:y, sh1add_uw_op:{ *:[i64] }:$rs1:$pred:14:x)<<P:14:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } sh1add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    4608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4616 */     GIR_RootConstrainSelectedInstOperands,
     /*    4617 */     // GIR_Coverage, 65206,
     /*    4617 */     GIR_EraseRootFromParent_Done,
     /*    4618 */   // Label 205: @4618
     /*    4618 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(4666), // Rule ID 65208 //
     /*    4623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4630 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:15:y
     /*    4634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4638 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:15:x
     /*    4642 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_uw_op),
     /*    4653 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:15:y, sh2add_uw_op:{ *:[i64] }:$rs1:$pred:15:x)<<P:15:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } sh2add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    4656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4658 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4664 */     GIR_RootConstrainSelectedInstOperands,
     /*    4665 */     // GIR_Coverage, 65208,
     /*    4665 */     GIR_EraseRootFromParent_Done,
     /*    4666 */   // Label 206: @4666
     /*    4666 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(4714), // Rule ID 65210 //
     /*    4671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4678 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:16:y
     /*    4682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4686 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:16:x
     /*    4690 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_uw_op),
     /*    4701 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:16:y, sh3add_uw_op:{ *:[i64] }:$rs1:$pred:16:x)<<P:16:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } sh3add_uw_op:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    4704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4706 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs1
     /*    4710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    4712 */     GIR_RootConstrainSelectedInstOperands,
     /*    4713 */     // GIR_Coverage, 65210,
     /*    4713 */     GIR_EraseRootFromParent_Done,
     /*    4714 */   // Label 207: @4714
     /*    4714 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(4765), // Rule ID 73997 //
     /*    4719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4726 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:24:y
     /*    4730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4734 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:24:x
     /*    4738 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh1add_op),
     /*    4749 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:24:y, sh1add_op:{ *:[i64] }:$rs2:$pred:24:x)<<P:24:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh1add_op:{ *:[i64] }:$rs2, 1:{ *:[i64] })
     /*    4749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4756 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    4763 */     GIR_RootConstrainSelectedInstOperands,
     /*    4764 */     // GIR_Coverage, 73997,
     /*    4764 */     GIR_EraseRootFromParent_Done,
     /*    4765 */   // Label 208: @4765
     /*    4765 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(4816), // Rule ID 74001 //
     /*    4770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4777 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:25:y
     /*    4781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4785 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:25:x
     /*    4789 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh2add_op),
     /*    4800 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:25:y, sh2add_op:{ *:[i64] }:$rs2:$pred:25:x)<<P:25:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh2add_op:{ *:[i64] }:$rs2, 2:{ *:[i64] })
     /*    4800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4807 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*    4814 */     GIR_RootConstrainSelectedInstOperands,
     /*    4815 */     // GIR_Coverage, 74001,
     /*    4815 */     GIR_EraseRootFromParent_Done,
     /*    4816 */   // Label 209: @4816
     /*    4816 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(4867), // Rule ID 74005 //
     /*    4821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    4824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4828 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:26:y
     /*    4832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4836 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:26:x
     /*    4840 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sh3add_op),
     /*    4851 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:26:y, sh3add_op:{ *:[i64] }:$rs2:$pred:26:x)<<P:26:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, sh3add_op:{ *:[i64] }:$rs2, 3:{ *:[i64] })
     /*    4851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    4854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    4858 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // rs2
     /*    4862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    4865 */     GIR_RootConstrainSelectedInstOperands,
     /*    4866 */     // GIR_Coverage, 74005,
     /*    4866 */     GIR_EraseRootFromParent_Done,
     /*    4867 */   // Label 210: @4867
     /*    4867 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(4942), // Rule ID 2492 //
     /*    4872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4879 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:7:x
     /*    4883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4904 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    4915 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:7:y
     /*    4919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4923 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    4927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    4929 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x, GPR:{ *:[i64] }:$rs2:$pred:7:y)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    4929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    4932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    4934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    4938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    4940 */     GIR_RootConstrainSelectedInstOperands,
     /*    4941 */     // GIR_Coverage, 2492,
     /*    4941 */     GIR_EraseRootFromParent_Done,
     /*    4942 */   // Label 211: @4942
     /*    4942 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(5037), // Rule ID 2516 //
     /*    4947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    4950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4954 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:17:x
     /*    4958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    4962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    4966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    4970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    4974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4979 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    4990 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:17:y
     /*    4994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    4998 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5004 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x, GPR:{ *:[i64] }:$rs2:$pred:17:y)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5016 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5020 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    5023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5035 */     GIR_RootConstrainSelectedInstOperands,
     /*    5036 */     // GIR_Coverage, 2516,
     /*    5036 */     GIR_EraseRootFromParent_Done,
     /*    5037 */   // Label 212: @5037
     /*    5037 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(5132), // Rule ID 2518 //
     /*    5042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5049 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:18:x
     /*    5053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5074 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    5085 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:18:y
     /*    5089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5093 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5099 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x, GPR:{ *:[i64] }:$rs2:$pred:18:y)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5130 */     GIR_RootConstrainSelectedInstOperands,
     /*    5131 */     // GIR_Coverage, 2518,
     /*    5131 */     GIR_EraseRootFromParent_Done,
     /*    5132 */   // Label 213: @5132
     /*    5132 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(5227), // Rule ID 2520 //
     /*    5137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5144 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:19:x
     /*    5148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5169 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    5180 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:19:y
     /*    5184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5188 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5194 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x, GPR:{ *:[i64] }:$rs2:$pred:19:y)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5210 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    5213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5225 */     GIR_RootConstrainSelectedInstOperands,
     /*    5226 */     // GIR_Coverage, 2520,
     /*    5226 */     GIR_EraseRootFromParent_Done,
     /*    5227 */   // Label 214: @5227
     /*    5227 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(5322), // Rule ID 2522 //
     /*    5232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5239 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:20:x
     /*    5243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5264 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    5275 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:20:y
     /*    5279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5283 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5289 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x, GPR:{ *:[i64] }:$rs2:$pred:20:y)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5305 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    5308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    5313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5320 */     GIR_RootConstrainSelectedInstOperands,
     /*    5321 */     // GIR_Coverage, 2522,
     /*    5321 */     GIR_EraseRootFromParent_Done,
     /*    5322 */   // Label 215: @5322
     /*    5322 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(5417), // Rule ID 2524 //
     /*    5327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5334 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:21:x
     /*    5338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5359 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    5370 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:21:y
     /*    5374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5378 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5384 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x, GPR:{ *:[i64] }:$rs2:$pred:21:y)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5400 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    5408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5415 */     GIR_RootConstrainSelectedInstOperands,
     /*    5416 */     // GIR_Coverage, 2524,
     /*    5416 */     GIR_EraseRootFromParent_Done,
     /*    5417 */   // Label 216: @5417
     /*    5417 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(5512), // Rule ID 2526 //
     /*    5422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5429 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:22:x
     /*    5433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5445 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5454 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    5465 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:22:y
     /*    5469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5473 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5479 */     // (add:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x, GPR:{ *:[i64] }:$rs2:$pred:22:y)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    5486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5491 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5495 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    5498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    5503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5510 */     GIR_RootConstrainSelectedInstOperands,
     /*    5511 */     // GIR_Coverage, 2526,
     /*    5511 */     GIR_EraseRootFromParent_Done,
     /*    5512 */   // Label 217: @5512
     /*    5512 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(5580), // Rule ID 2453 //
     /*    5517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5524 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:1:x
     /*    5528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5549 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    5553 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:1:y
     /*    5557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5567 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x, GPR:{ *:[i64] }:$rs2:$pred:1:y)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5578 */     GIR_RootConstrainSelectedInstOperands,
     /*    5579 */     // GIR_Coverage, 2453,
     /*    5579 */     GIR_EraseRootFromParent_Done,
     /*    5580 */   // Label 218: @5580
     /*    5580 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(5648), // Rule ID 2463 //
     /*    5585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5592 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:3:x
     /*    5596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5617 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    5621 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:3:y
     /*    5625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5629 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5635 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x, GPR:{ *:[i64] }:$rs2:$pred:3:y)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5646 */     GIR_RootConstrainSelectedInstOperands,
     /*    5647 */     // GIR_Coverage, 2463,
     /*    5647 */     GIR_EraseRootFromParent_Done,
     /*    5648 */   // Label 219: @5648
     /*    5648 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(5716), // Rule ID 2473 //
     /*    5653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    5656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5660 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:5:x
     /*    5664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    5668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    5672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    5689 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:5:y
     /*    5693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5697 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5703 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x, GPR:{ *:[i64] }:$rs2:$pred:5:y)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    5706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    5714 */     GIR_RootConstrainSelectedInstOperands,
     /*    5715 */     // GIR_Coverage, 2473,
     /*    5715 */     GIR_EraseRootFromParent_Done,
     /*    5716 */   // Label 220: @5716
     /*    5716 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(5791), // Rule ID 65192 //
     /*    5721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5728 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:7:y
     /*    5732 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5736 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:7:x
     /*    5740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5761 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*    5772 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5778 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:7:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }):$pred:7:x)<<P:7:Predicate_add_like_non_imm12>>  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    5778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*    5781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5789 */     GIR_RootConstrainSelectedInstOperands,
     /*    5790 */     // GIR_Coverage, 65192,
     /*    5790 */     GIR_EraseRootFromParent_Done,
     /*    5791 */   // Label 221: @5791
     /*    5791 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(5886), // Rule ID 65212 //
     /*    5796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5803 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:17:y
     /*    5807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5811 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:17:x
     /*    5815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5836 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967294),
     /*    5847 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5853 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:17:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967294:{ *:[i64] }):$pred:17:x)<<P:17:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5865 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5869 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    5872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    5877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5884 */     GIR_RootConstrainSelectedInstOperands,
     /*    5885 */     // GIR_Coverage, 65212,
     /*    5885 */     GIR_EraseRootFromParent_Done,
     /*    5886 */   // Label 222: @5886
     /*    5886 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(5981), // Rule ID 65214 //
     /*    5891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5898 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:18:y
     /*    5902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5906 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:18:x
     /*    5910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    5914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    5918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    5922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    5926 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5931 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967292),
     /*    5942 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    5946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    5948 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:18:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967292:{ *:[i64] }):$pred:18:x)<<P:18:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    5948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    5951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    5955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    5960 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    5964 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    5967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    5969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    5972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    5974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    5977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    5979 */     GIR_RootConstrainSelectedInstOperands,
     /*    5980 */     // GIR_Coverage, 65214,
     /*    5980 */     GIR_EraseRootFromParent_Done,
     /*    5981 */   // Label 223: @5981
     /*    5981 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(6076), // Rule ID 65216 //
     /*    5986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    5989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    5993 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:19:y
     /*    5997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6001 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:19:x
     /*    6005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6026 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967288),
     /*    6037 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6043 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:19:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967288:{ *:[i64] }):$pred:19:x)<<P:19:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*    6050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6055 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    6062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6074 */     GIR_RootConstrainSelectedInstOperands,
     /*    6075 */     // GIR_Coverage, 65216,
     /*    6075 */     GIR_EraseRootFromParent_Done,
     /*    6076 */   // Label 224: @6076
     /*    6076 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(6171), // Rule ID 65218 //
     /*    6081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6088 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:20:y
     /*    6092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6096 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:20:x
     /*    6100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6121 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8589934590),
     /*    6132 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6138 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:20:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 8589934590:{ *:[i64] }):$pred:20:x)<<P:20:Predicate_add_like_non_imm12>>  =>  (SH1ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*    6157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD_UW),
     /*    6162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6169 */     GIR_RootConstrainSelectedInstOperands,
     /*    6170 */     // GIR_Coverage, 65218,
     /*    6170 */     GIR_EraseRootFromParent_Done,
     /*    6171 */   // Label 225: @6171
     /*    6171 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(6266), // Rule ID 65220 //
     /*    6176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6183 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:21:y
     /*    6187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6191 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:21:x
     /*    6195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6216 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(17179869180),
     /*    6227 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6233 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:21:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 17179869180:{ *:[i64] }):$pred:21:x)<<P:21:Predicate_add_like_non_imm12>>  =>  (SH2ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/2,
     /*    6252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD_UW),
     /*    6257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6264 */     GIR_RootConstrainSelectedInstOperands,
     /*    6265 */     // GIR_Coverage, 65220,
     /*    6265 */     GIR_EraseRootFromParent_Done,
     /*    6266 */   // Label 226: @6266
     /*    6266 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(6361), // Rule ID 65222 //
     /*    6271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*    6274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6278 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:22:y
     /*    6282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6286 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:22:x
     /*    6290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*    6298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6311 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(34359738360),
     /*    6322 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6328 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:22:y, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 34359738360:{ *:[i64] }):$pred:22:x)<<P:22:Predicate_add_like_non_imm12>>  =>  (SH3ADD_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)
     /*    6328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*    6335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6344 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*    6347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD_UW),
     /*    6352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6359 */     GIR_RootConstrainSelectedInstOperands,
     /*    6360 */     // GIR_Coverage, 65222,
     /*    6360 */     GIR_EraseRootFromParent_Done,
     /*    6361 */   // Label 227: @6361
     /*    6361 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(6429), // Rule ID 65169 //
     /*    6366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6373 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:1:y
     /*    6377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6381 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:1:x
     /*    6385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*    6410 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6416 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:1:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] }):$pred:1:x)<<P:1:Predicate_add_like_non_imm12>>  =>  (SH1ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH1ADD),
     /*    6419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6427 */     GIR_RootConstrainSelectedInstOperands,
     /*    6428 */     // GIR_Coverage, 65169,
     /*    6428 */     GIR_EraseRootFromParent_Done,
     /*    6429 */   // Label 228: @6429
     /*    6429 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(6497), // Rule ID 65177 //
     /*    6434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6441 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:3:y
     /*    6445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6449 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:3:x
     /*    6453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6474 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 2,
     /*    6478 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6484 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:3:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 2:{ *:[i64] }):$pred:3:x)<<P:3:Predicate_add_like_non_imm12>>  =>  (SH2ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH2ADD),
     /*    6487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6489 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6495 */     GIR_RootConstrainSelectedInstOperands,
     /*    6496 */     // GIR_Coverage, 65177,
     /*    6496 */     GIR_EraseRootFromParent_Done,
     /*    6497 */   // Label 229: @6497
     /*    6497 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(6565), // Rule ID 65185 //
     /*    6502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_HwMode0),
     /*    6505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6509 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:5:y
     /*    6513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6517 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:5:x
     /*    6521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6542 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 3,
     /*    6546 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6552 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs2:$pred:5:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 3:{ *:[i64] }):$pred:5:x)<<P:5:Predicate_add_like_non_imm12>>  =>  (SH3ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH3ADD),
     /*    6555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    6563 */     GIR_RootConstrainSelectedInstOperands,
     /*    6564 */     // GIR_Coverage, 65185,
     /*    6564 */     GIR_EraseRootFromParent_Done,
     /*    6565 */   // Label 230: @6565
     /*    6565 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(6644), // Rule ID 62499 //
     /*    6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6577 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/0, // Name : pred:23:x
     /*    6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    6606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6610 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    6614 */     // MIs[2] Operand 1
     /*    6614 */     // No operand predicates
     /*    6614 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/1, // Name : pred:23:y
     /*    6618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6622 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6628 */     // (add:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x, GPR:{ *:[i64] }:$rs1:$pred:23:y)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*    6628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*    6635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    6639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    6642 */     GIR_RootConstrainSelectedInstOperands,
     /*    6643 */     // GIR_Coverage, 62499,
     /*    6643 */     GIR_EraseRootFromParent_Done,
     /*    6644 */   // Label 231: @6644
     /*    6644 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(6723), // Rule ID 73993 //
     /*    6649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBa_HwMode0),
     /*    6652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6656 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/1, /*StoreIdx*/1, // Name : pred:23:y
     /*    6660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6664 */     GIM_RecordNamedOperand, /*MI*/0, /*Op*/2, /*StoreIdx*/0, // Name : pred:23:x
     /*    6668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*    6676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*    6693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm2),
     /*    6701 */     // MIs[2] Operand 1
     /*    6701 */     // No operand predicates
     /*    6701 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_like_non_imm12),
     /*    6705 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6707 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1:$pred:23:y, (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2):$pred:23:x)<<P:23:Predicate_add_like_non_imm12>>  =>  (TH_ADDSL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm2>>:$uimm2)
     /*    6707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_ADDSL),
     /*    6710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    6718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // uimm2
     /*    6721 */     GIR_RootConstrainSelectedInstOperands,
     /*    6722 */     // GIR_Coverage, 73993,
     /*    6722 */     GIR_EraseRootFromParent_Done,
     /*    6723 */   // Label 232: @6723
     /*    6723 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(6772), // Rule ID 114 //
     /*    6728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    6731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FRAME_INDEX),
     /*    6743 */     // MIs[1] Operand 1
     /*    6743 */     // No operand predicates
     /*    6743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    6747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6751 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    6755 */     // MIs[2] Operand 1
     /*    6755 */     // No operand predicates
     /*    6755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    6757 */     // (add:{ *:[i64] } (frameindex:{ *:[i64] }):$fi, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)  =>  (ADDI:{ *:[i64] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[i64] }:$fi), (imm:{ *:[i64] })<<P:Predicate_simm12>>:$offset)
     /*    6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6762 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*    6767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // offset
     /*    6770 */     GIR_RootConstrainSelectedInstOperands,
     /*    6771 */     // GIR_Coverage, 114,
     /*    6771 */     GIR_EraseRootFromParent_Done,
     /*    6772 */   // Label 233: @6772
     /*    6772 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(6818), // Rule ID 265 //
     /*    6777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    6780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    6800 */     // MIs[1] Operand 1
     /*    6800 */     // No operand predicates
     /*    6800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*    6804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6806 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)<<P:Predicate_anonymous_10038>>  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*    6806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    6813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    6816 */     GIR_RootConstrainSelectedInstOperands,
     /*    6817 */     // GIR_Coverage, 265,
     /*    6817 */     GIR_EraseRootFromParent_Done,
     /*    6818 */   // Label 234: @6818
     /*    6818 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(6894), // Rule ID 287 //
     /*    6823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    6826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    6842 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    6846 */     // MIs[1] Operand 1
     /*    6846 */     // No operand predicates
     /*    6846 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10066),
     /*    6850 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*    6854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6856 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10066>>:$rs2)<<P:Predicate_anonymous_10038>>  =>  (ADDIW:{ *:[i64] } (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*    6856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    6859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    6868 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    6872 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    6877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    6879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /*    6882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    6884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    6887 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    6892 */     GIR_RootConstrainSelectedInstOperands,
     /*    6893 */     // GIR_Coverage, 287,
     /*    6893 */     GIR_EraseRootFromParent_Done,
     /*    6894 */   // Label 235: @6894
     /*    6894 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(6959), // Rule ID 74009 //
     /*    6899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*    6902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    6910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    6914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6936 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*    6940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    6942 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)<<P:Predicate_anonymous_10038>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    6942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*    6945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    6947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    6949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    6953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    6957 */     GIR_RootConstrainSelectedInstOperands,
     /*    6958 */     // GIR_Coverage, 74009,
     /*    6958 */     GIR_EraseRootFromParent_Done,
     /*    6959 */   // Label 236: @6959
     /*    6959 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(7024), // Rule ID 62571 //
     /*    6964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*    6967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    6979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    6983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    6987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    6991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    6996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7001 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*    7005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7007 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10038>>  =>  (TH_MULAW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULAW),
     /*    7010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    7012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    7014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    7022 */     GIR_RootConstrainSelectedInstOperands,
     /*    7023 */     // GIR_Coverage, 62571,
     /*    7023 */     GIR_EraseRootFromParent_Done,
     /*    7024 */   // Label 237: @7024
     /*    7024 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(7066), // Rule ID 74 //
     /*    7029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    7032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    7048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*    7052 */     // MIs[1] Operand 1
     /*    7052 */     // No operand predicates
     /*    7052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7054 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*    7054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    7057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*    7064 */     GIR_RootConstrainSelectedInstOperands,
     /*    7065 */     // GIR_Coverage, 74,
     /*    7065 */     GIR_EraseRootFromParent_Done,
     /*    7066 */   // Label 238: @7066
     /*    7066 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(7138), // Rule ID 285 //
     /*    7071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    7074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*    7090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_AddiPair),
     /*    7094 */     // MIs[1] Operand 1
     /*    7094 */     // No operand predicates
     /*    7094 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10066),
     /*    7098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7100 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_AddiPair>><<P:Predicate_anonymous_10066>>:$rs2)  =>  (ADDI:{ *:[i64] } (ADDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (AddiPairImmLarge:{ *:[i64] } (imm:{ *:[i64] }):$rs2)), (AddiPairImmSmall:{ *:[i64] } (imm:{ *:[i64] }):$rs2))
     /*    7100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*    7103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    7107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7112 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*    7116 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmLarge), // rs2
     /*    7121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*    7126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7131 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderAddiPairImmSmall), // rs2
     /*    7136 */     GIR_RootConstrainSelectedInstOperands,
     /*    7137 */     // GIR_Coverage, 285,
     /*    7137 */     GIR_EraseRootFromParent_Done,
     /*    7138 */   // Label 239: @7138
     /*    7138 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(7199), // Rule ID 74007 //
     /*    7143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*    7146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7182 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rd)  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    7185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    7187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    7189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    7197 */     GIR_RootConstrainSelectedInstOperands,
     /*    7198 */     // GIR_Coverage, 74007,
     /*    7198 */     GIR_EraseRootFromParent_Done,
     /*    7199 */   // Label 240: @7199
     /*    7199 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(7260), // Rule ID 62567 //
     /*    7204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*    7207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*    7227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*    7231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7243 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULA:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULA),
     /*    7246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*    7248 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    7250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*    7258 */     GIR_RootConstrainSelectedInstOperands,
     /*    7259 */     // GIR_Coverage, 62567,
     /*    7259 */     GIR_EraseRootFromParent_Done,
     /*    7260 */   // Label 241: @7260
     /*    7260 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(7291), // Rule ID 264 //
     /*    7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*    7268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7280 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10038),
     /*    7284 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10038>>  =>  (ADDW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADDW),
     /*    7289 */     GIR_RootConstrainSelectedInstOperands,
     /*    7290 */     // GIR_Coverage, 264,
     /*    7290 */     GIR_Done,
     /*    7291 */   // Label 242: @7291
     /*    7291 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(7318), // Rule ID 72 //
     /*    7296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*    7299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*    7311 */     // (add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (ADD:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*    7311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ADD),
     /*    7316 */     GIR_RootConstrainSelectedInstOperands,
     /*    7317 */     // GIR_Coverage, 72,
     /*    7317 */     GIR_Done,
     /*    7318 */   // Label 243: @7318
     /*    7318 */   GIM_Reject,
     /*    7319 */ // Label 180: @7319
     /*    7319 */ GIM_Reject,
     /*    7320 */ // Label 128: @7320
     /*    7320 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(7714),
     /*    7325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7335 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(7403), // Rule ID 68961 //
     /*    7340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7377 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    7377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*    7380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    7386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7401 */     GIR_RootConstrainSelectedInstOperands,
     /*    7402 */     // GIR_Coverage, 68961,
     /*    7402 */     GIR_EraseRootFromParent_Done,
     /*    7403 */   // Label 245: @7403
     /*    7403 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(7471), // Rule ID 68962 //
     /*    7408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7427 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7445 */     // (add:{ *:[nxv1i8] } (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    7445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*    7448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    7454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7469 */     GIR_RootConstrainSelectedInstOperands,
     /*    7470 */     // GIR_Coverage, 68962,
     /*    7470 */     GIR_EraseRootFromParent_Done,
     /*    7471 */   // Label 246: @7471
     /*    7471 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(7539), // Rule ID 45796 //
     /*    7476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7499 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7513 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    7513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*    7516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    7522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7537 */     GIR_RootConstrainSelectedInstOperands,
     /*    7538 */     // GIR_Coverage, 45796,
     /*    7538 */     GIR_EraseRootFromParent_Done,
     /*    7539 */   // Label 247: @7539
     /*    7539 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(7607), // Rule ID 45797 //
     /*    7544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    7555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*    7567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    7581 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    7581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*    7584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    7590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    7594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*    7596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7605 */     GIR_RootConstrainSelectedInstOperands,
     /*    7606 */     // GIR_Coverage, 45797,
     /*    7606 */     GIR_EraseRootFromParent_Done,
     /*    7607 */   // Label 248: @7607
     /*    7607 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(7660), // Rule ID 45624 //
     /*    7612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7623 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    7623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*    7626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*    7640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7658 */     GIR_RootConstrainSelectedInstOperands,
     /*    7659 */     // GIR_Coverage, 45624,
     /*    7659 */     GIR_EraseRootFromParent_Done,
     /*    7660 */   // Label 249: @7660
     /*    7660 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(7713), // Rule ID 45625 //
     /*    7665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7676 */     // (add:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    7676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*    7679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    7683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    7688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    7690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*    7693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    7698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*    7700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    7702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7711 */     GIR_RootConstrainSelectedInstOperands,
     /*    7712 */     // GIR_Coverage, 45625,
     /*    7712 */     GIR_EraseRootFromParent_Done,
     /*    7713 */   // Label 250: @7713
     /*    7713 */   GIM_Reject,
     /*    7714 */ // Label 244: @7714
     /*    7714 */ GIM_Reject,
     /*    7715 */ // Label 129: @7715
     /*    7715 */ GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10839),
     /*    7720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    7723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    7726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7730 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(7826), // Rule ID 68875 //
     /*    7735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    7750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    7754 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    7760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    7764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    7770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    7779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    7783 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7787 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    7789 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    7800 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    7800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*    7803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    7807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    7811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    7815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7824 */     GIR_RootConstrainSelectedInstOperands,
     /*    7825 */     // GIR_Coverage, 68875,
     /*    7825 */     GIR_EraseRootFromParent_Done,
     /*    7826 */   // Label 252: @7826
     /*    7826 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(7922), // Rule ID 68876 //
     /*    7831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    7834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    7846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    7850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7864 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    7866 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    7875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    7879 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7883 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    7885 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7894 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    7896 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    7896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*    7899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    7903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    7907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    7911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    7914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    7917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    7920 */     GIR_RootConstrainSelectedInstOperands,
     /*    7921 */     // GIR_Coverage, 68876,
     /*    7921 */     GIR_EraseRootFromParent_Done,
     /*    7922 */   // Label 253: @7922
     /*    7922 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(8018), // Rule ID 70697 //
     /*    7927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    7930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    7934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    7938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    7942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    7946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    7948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    7952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    7956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    7962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    7971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    7975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    7979 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    7981 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    7990 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    7992 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    7992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    7995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    7997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    7999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8016 */     GIR_RootConstrainSelectedInstOperands,
     /*    8017 */     // GIR_Coverage, 70697,
     /*    8017 */     GIR_EraseRootFromParent_Done,
     /*    8018 */   // Label 254: @8018
     /*    8018 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(8114), // Rule ID 70698 //
     /*    8023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8042 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8075 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8077 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8088 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    8088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    8095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8112 */     GIR_RootConstrainSelectedInstOperands,
     /*    8113 */     // GIR_Coverage, 70698,
     /*    8113 */     GIR_EraseRootFromParent_Done,
     /*    8114 */   // Label 255: @8114
     /*    8114 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(8210), // Rule ID 70699 //
     /*    8119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8138 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8167 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8171 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8173 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8184 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    8184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    8191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*    8195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*    8199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8208 */     GIR_RootConstrainSelectedInstOperands,
     /*    8209 */     // GIR_Coverage, 70699,
     /*    8209 */     GIR_EraseRootFromParent_Done,
     /*    8210 */   // Label 256: @8210
     /*    8210 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(8306), // Rule ID 70700 //
     /*    8215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8234 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8248 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8255 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8259 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8263 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8267 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8269 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8280 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    8287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*    8291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*    8295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8304 */     GIR_RootConstrainSelectedInstOperands,
     /*    8305 */     // GIR_Coverage, 70700,
     /*    8305 */     GIR_EraseRootFromParent_Done,
     /*    8306 */   // Label 257: @8306
     /*    8306 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(8402), // Rule ID 70575 //
     /*    8311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8330 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8359 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8363 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8365 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8374 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8376 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    8376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*    8379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    8383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8400 */     GIR_RootConstrainSelectedInstOperands,
     /*    8401 */     // GIR_Coverage, 70575,
     /*    8401 */     GIR_EraseRootFromParent_Done,
     /*    8402 */   // Label 258: @8402
     /*    8402 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(8498), // Rule ID 70576 //
     /*    8407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    8414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8459 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8461 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8472 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    8472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*    8475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*    8479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8496 */     GIR_RootConstrainSelectedInstOperands,
     /*    8497 */     // GIR_Coverage, 70576,
     /*    8497 */     GIR_EraseRootFromParent_Done,
     /*    8498 */   // Label 259: @8498
     /*    8498 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(8594), // Rule ID 45708 //
     /*    8503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8526 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8555 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8559 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8566 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8568 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    8568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*    8571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    8575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8592 */     GIR_RootConstrainSelectedInstOperands,
     /*    8593 */     // GIR_Coverage, 45708,
     /*    8593 */     GIR_EraseRootFromParent_Done,
     /*    8594 */   // Label 260: @8594
     /*    8594 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(8690), // Rule ID 45709 //
     /*    8599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8636 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8655 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8662 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8664 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    8664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /*    8667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    8671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8688 */     GIR_RootConstrainSelectedInstOperands,
     /*    8689 */     // GIR_Coverage, 45709,
     /*    8689 */     GIR_EraseRootFromParent_Done,
     /*    8690 */   // Label 261: @8690
     /*    8690 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(8786), // Rule ID 52024 //
     /*    8695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8718 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8732 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8747 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8751 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8753 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8760 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    8760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    8767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8784 */     GIR_RootConstrainSelectedInstOperands,
     /*    8785 */     // GIR_Coverage, 52024,
     /*    8785 */     GIR_EraseRootFromParent_Done,
     /*    8786 */   // Label 262: @8786
     /*    8786 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(8882), // Rule ID 52025 //
     /*    8791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8810 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8814 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8828 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8843 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8847 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8849 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8856 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    8856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    8863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    8867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    8871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8880 */     GIR_RootConstrainSelectedInstOperands,
     /*    8881 */     // GIR_Coverage, 52025,
     /*    8881 */     GIR_EraseRootFromParent_Done,
     /*    8882 */   // Label 263: @8882
     /*    8882 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(8978), // Rule ID 70695 //
     /*    8887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    8890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    8906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    8910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    8912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    8916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    8920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8924 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    8926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    8935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    8939 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    8943 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    8945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8950 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    8952 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    8952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    8955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    8957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    8959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*    8963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*    8967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    8970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    8973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    8976 */     GIR_RootConstrainSelectedInstOperands,
     /*    8977 */     // GIR_Coverage, 70695,
     /*    8977 */     GIR_EraseRootFromParent_Done,
     /*    8978 */   // Label 264: @8978
     /*    8978 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(9074), // Rule ID 70696 //
     /*    8983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    8986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    8990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    8994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    8998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    9002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    9006 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    9012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9020 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9027 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    9031 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    9035 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9039 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    9041 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9046 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    9048 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    9048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /*    9051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    9055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*    9059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*    9063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9072 */     GIR_RootConstrainSelectedInstOperands,
     /*    9073 */     // GIR_Coverage, 70696,
     /*    9073 */     GIR_EraseRootFromParent_Done,
     /*    9074 */   // Label 265: @9074
     /*    9074 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(9170), // Rule ID 51964 //
     /*    9079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    9094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    9098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    9102 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    9108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9116 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9118 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    9127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9135 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    9137 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9142 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    9144 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    9144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*    9147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    9151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    9159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9168 */     GIR_RootConstrainSelectedInstOperands,
     /*    9169 */     // GIR_Coverage, 51964,
     /*    9169 */     GIR_EraseRootFromParent_Done,
     /*    9170 */   // Label 266: @9170
     /*    9170 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(9266), // Rule ID 51965 //
     /*    9175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*    9186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    9190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    9194 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    9198 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*    9204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9212 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9219 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*    9223 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9227 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9231 */     GIM_CheckHasOneUse, /*MI*/3,
     /*    9233 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9238 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*    9240 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*    9240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /*    9243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*    9247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*    9255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9264 */     GIR_RootConstrainSelectedInstOperands,
     /*    9265 */     // GIR_Coverage, 51965,
     /*    9265 */     GIR_EraseRootFromParent_Done,
     /*    9266 */   // Label 267: @9266
     /*    9266 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(9355), // Rule ID 46550 //
     /*    9271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*    9282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9286 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*    9301 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9305 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9314 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*    9331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9353 */     GIR_RootConstrainSelectedInstOperands,
     /*    9354 */     // GIR_Coverage, 46550,
     /*    9354 */     GIR_EraseRootFromParent_Done,
     /*    9355 */   // Label 268: @9355
     /*    9355 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(9444), // Rule ID 46551 //
     /*    9360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*    9371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9375 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*    9390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9394 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9396 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9403 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*    9420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9442 */     GIR_RootConstrainSelectedInstOperands,
     /*    9443 */     // GIR_Coverage, 46551,
     /*    9443 */     GIR_EraseRootFromParent_Done,
     /*    9444 */   // Label 269: @9444
     /*    9444 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(9533), // Rule ID 45700 //
     /*    9449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    9460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    9479 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9483 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9492 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*    9509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9531 */     GIR_RootConstrainSelectedInstOperands,
     /*    9532 */     // GIR_Coverage, 45700,
     /*    9532 */     GIR_EraseRootFromParent_Done,
     /*    9533 */   // Label 270: @9533
     /*    9533 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(9622), // Rule ID 45701 //
     /*    9538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    9549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9553 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*    9568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9572 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9581 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*    9598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9620 */     GIR_RootConstrainSelectedInstOperands,
     /*    9621 */     // GIR_Coverage, 45701,
     /*    9621 */     GIR_EraseRootFromParent_Done,
     /*    9622 */   // Label 271: @9622
     /*    9622 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(9711), // Rule ID 46430 //
     /*    9627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9661 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9663 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9670 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*    9670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*    9687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9709 */     GIR_RootConstrainSelectedInstOperands,
     /*    9710 */     // GIR_Coverage, 46430,
     /*    9710 */     GIR_EraseRootFromParent_Done,
     /*    9711 */   // Label 272: @9711
     /*    9711 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(9800), // Rule ID 46431 //
     /*    9716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*    9742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*    9746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*    9752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*    9759 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*    9759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*    9762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*    9766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*    9771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*    9773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*    9776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*    9781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*    9785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*    9789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9798 */     GIR_RootConstrainSelectedInstOperands,
     /*    9799 */     // GIR_Coverage, 46431,
     /*    9799 */     GIR_EraseRootFromParent_Done,
     /*    9800 */   // Label 273: @9800
     /*    9800 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(9868), // Rule ID 70267 //
     /*    9805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    9816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    9820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    9824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9842 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*    9842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*    9845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    9851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9866 */     GIR_RootConstrainSelectedInstOperands,
     /*    9867 */     // GIR_Coverage, 70267,
     /*    9867 */     GIR_EraseRootFromParent_Done,
     /*    9868 */   // Label 274: @9868
     /*    9868 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(9936), // Rule ID 70268 //
     /*    9873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*    9884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*    9888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*    9892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9910 */     // (add:{ *:[nxv1i16] } (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*    9910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*    9913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*    9919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*    9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9934 */     GIR_RootConstrainSelectedInstOperands,
     /*    9935 */     // GIR_Coverage, 70268,
     /*    9935 */     GIR_EraseRootFromParent_Done,
     /*    9936 */   // Label 275: @9936
     /*    9936 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(9991), // Rule ID 69259 //
     /*    9941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*    9944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*    9948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*    9952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*    9956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*    9958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*    9967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*    9969 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*    9969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*    9972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*    9974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*    9976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*    9980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*    9983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*    9986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*    9989 */     GIR_RootConstrainSelectedInstOperands,
     /*    9990 */     // GIR_Coverage, 69259,
     /*    9990 */     GIR_EraseRootFromParent_Done,
     /*    9991 */   // Label 276: @9991
     /*    9991 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(10046), // Rule ID 69260 //
     /*    9996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*    9999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   10007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10024 */     // (add:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10044 */     GIR_RootConstrainSelectedInstOperands,
     /*   10045 */     // GIR_Coverage, 69260,
     /*   10045 */     GIR_EraseRootFromParent_Done,
     /*   10046 */   // Label 277: @10046
     /*   10046 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(10101), // Rule ID 68871 //
     /*   10051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10079 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   10079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   10082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10099 */     GIR_RootConstrainSelectedInstOperands,
     /*   10100 */     // GIR_Coverage, 68871,
     /*   10100 */     GIR_EraseRootFromParent_Done,
     /*   10101 */   // Label 278: @10101
     /*   10101 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(10156), // Rule ID 68872 //
     /*   10106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10134 */     // (add:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   10137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10154 */     GIR_RootConstrainSelectedInstOperands,
     /*   10155 */     // GIR_Coverage, 68872,
     /*   10155 */     GIR_EraseRootFromParent_Done,
     /*   10156 */   // Label 279: @10156
     /*   10156 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(10211), // Rule ID 69169 //
     /*   10161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   10172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10176 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10189 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   10189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10209 */     GIR_RootConstrainSelectedInstOperands,
     /*   10210 */     // GIR_Coverage, 69169,
     /*   10210 */     GIR_EraseRootFromParent_Done,
     /*   10211 */   // Label 280: @10211
     /*   10211 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(10266), // Rule ID 69170 //
     /*   10216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   10227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10231 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10244 */     // (add:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10264 */     GIR_RootConstrainSelectedInstOperands,
     /*   10265 */     // GIR_Coverage, 69170,
     /*   10265 */     GIR_EraseRootFromParent_Done,
     /*   10266 */   // Label 281: @10266
     /*   10266 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(10334), // Rule ID 51744 //
     /*   10271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   10294 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10308 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   10308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   10311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   10317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10332 */     GIR_RootConstrainSelectedInstOperands,
     /*   10333 */     // GIR_Coverage, 51744,
     /*   10333 */     GIR_EraseRootFromParent_Done,
     /*   10334 */   // Label 282: @10334
     /*   10334 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(10402), // Rule ID 51745 //
     /*   10339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   10362 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10376 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   10376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   10379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   10385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10400 */     GIR_RootConstrainSelectedInstOperands,
     /*   10401 */     // GIR_Coverage, 51745,
     /*   10401 */     GIR_EraseRootFromParent_Done,
     /*   10402 */   // Label 283: @10402
     /*   10402 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(10457), // Rule ID 46610 //
     /*   10407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   10422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10435 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   10435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10455 */     GIR_RootConstrainSelectedInstOperands,
     /*   10456 */     // GIR_Coverage, 46610,
     /*   10456 */     GIR_EraseRootFromParent_Done,
     /*   10457 */   // Label 284: @10457
     /*   10457 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(10512), // Rule ID 46611 //
     /*   10462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   10477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10490 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10510 */     GIR_RootConstrainSelectedInstOperands,
     /*   10511 */     // GIR_Coverage, 46611,
     /*   10511 */     GIR_EraseRootFromParent_Done,
     /*   10512 */   // Label 285: @10512
     /*   10512 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(10567), // Rule ID 45704 //
     /*   10517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10545 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   10545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   10548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10565 */     GIR_RootConstrainSelectedInstOperands,
     /*   10566 */     // GIR_Coverage, 45704,
     /*   10566 */     GIR_EraseRootFromParent_Done,
     /*   10567 */   // Label 286: @10567
     /*   10567 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(10622), // Rule ID 45705 //
     /*   10572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10600 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*   10603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10620 */     GIR_RootConstrainSelectedInstOperands,
     /*   10621 */     // GIR_Coverage, 45705,
     /*   10621 */     GIR_EraseRootFromParent_Done,
     /*   10622 */   // Label 287: @10622
     /*   10622 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(10677), // Rule ID 46490 //
     /*   10627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   10642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10655 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   10655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10675 */     GIR_RootConstrainSelectedInstOperands,
     /*   10676 */     // GIR_Coverage, 46490,
     /*   10676 */     GIR_EraseRootFromParent_Done,
     /*   10677 */   // Label 288: @10677
     /*   10677 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(10732), // Rule ID 46491 //
     /*   10682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   10693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   10697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   10701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   10710 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   10710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*   10713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   10717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   10721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10730 */     GIR_RootConstrainSelectedInstOperands,
     /*   10731 */     // GIR_Coverage, 46491,
     /*   10731 */     GIR_EraseRootFromParent_Done,
     /*   10732 */   // Label 289: @10732
     /*   10732 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(10785), // Rule ID 45980 //
     /*   10737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10748 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   10748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   10751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   10765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10783 */     GIR_RootConstrainSelectedInstOperands,
     /*   10784 */     // GIR_Coverage, 45980,
     /*   10784 */     GIR_EraseRootFromParent_Done,
     /*   10785 */   // Label 290: @10785
     /*   10785 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(10838), // Rule ID 45981 //
     /*   10790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10801 */     // (add:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   10801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   10804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   10808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   10813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   10815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   10818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   10823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   10825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   10827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   10836 */     GIR_RootConstrainSelectedInstOperands,
     /*   10837 */     // GIR_Coverage, 45981,
     /*   10837 */     GIR_EraseRootFromParent_Done,
     /*   10838 */   // Label 291: @10838
     /*   10838 */   GIM_Reject,
     /*   10839 */ // Label 251: @10839
     /*   10839 */ GIM_Reject,
     /*   10840 */ // Label 130: @10840
     /*   10840 */ GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(13964),
     /*   10845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   10848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   10851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10855 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(10951), // Rule ID 70473 //
     /*   10860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   10863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   10875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   10879 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   10885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10893 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   10895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   10904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10908 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10912 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   10914 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   10925 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   10925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   10928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   10930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   10932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   10936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   10940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   10943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   10946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   10949 */     GIR_RootConstrainSelectedInstOperands,
     /*   10950 */     // GIR_Coverage, 70473,
     /*   10950 */     GIR_EraseRootFromParent_Done,
     /*   10951 */   // Label 293: @10951
     /*   10951 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(11047), // Rule ID 70474 //
     /*   10956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   10959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   10963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   10967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   10971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   10975 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   10977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   10981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   10985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   10989 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   10991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   10996 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11000 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11004 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11008 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11010 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11019 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11021 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   11024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11045 */     GIR_RootConstrainSelectedInstOperands,
     /*   11046 */     // GIR_Coverage, 70474,
     /*   11046 */     GIR_EraseRootFromParent_Done,
     /*   11047 */   // Label 294: @11047
     /*   11047 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(11143), // Rule ID 70733 //
     /*   11052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11085 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11104 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11115 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11117 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   11117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11141 */     GIR_RootConstrainSelectedInstOperands,
     /*   11142 */     // GIR_Coverage, 70733,
     /*   11142 */     GIR_EraseRootFromParent_Done,
     /*   11143 */   // Label 295: @11143
     /*   11143 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(11239), // Rule ID 70734 //
     /*   11148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11196 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11200 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11202 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11213 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11237 */     GIR_RootConstrainSelectedInstOperands,
     /*   11238 */     // GIR_Coverage, 70734,
     /*   11238 */     GIR_EraseRootFromParent_Done,
     /*   11239 */   // Label 296: @11239
     /*   11239 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(11335), // Rule ID 70735 //
     /*   11244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11263 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11284 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11288 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11292 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11296 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11309 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   11309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   11320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   11324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11333 */     GIR_RootConstrainSelectedInstOperands,
     /*   11334 */     // GIR_Coverage, 70735,
     /*   11334 */     GIR_EraseRootFromParent_Done,
     /*   11335 */   // Label 297: @11335
     /*   11335 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(11431), // Rule ID 70736 //
     /*   11340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11373 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11388 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11392 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11405 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   11416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   11420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11429 */     GIR_RootConstrainSelectedInstOperands,
     /*   11430 */     // GIR_Coverage, 70736,
     /*   11430 */     GIR_EraseRootFromParent_Done,
     /*   11431 */   // Label 298: @11431
     /*   11431 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(11527), // Rule ID 70587 //
     /*   11436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11469 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11476 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11480 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11484 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11488 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11490 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11499 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11501 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   11501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   11504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11525 */     GIR_RootConstrainSelectedInstOperands,
     /*   11526 */     // GIR_Coverage, 70587,
     /*   11526 */     GIR_EraseRootFromParent_Done,
     /*   11527 */   // Label 299: @11527
     /*   11527 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(11623), // Rule ID 70588 //
     /*   11532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   11539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11584 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11586 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11595 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11597 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   11600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   11604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11621 */     GIR_RootConstrainSelectedInstOperands,
     /*   11622 */     // GIR_Coverage, 70588,
     /*   11622 */     GIR_EraseRootFromParent_Done,
     /*   11623 */   // Label 300: @11623
     /*   11623 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(11719), // Rule ID 51918 //
     /*   11628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11651 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11665 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11684 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11686 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11693 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   11693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   11696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11717 */     GIR_RootConstrainSelectedInstOperands,
     /*   11718 */     // GIR_Coverage, 51918,
     /*   11718 */     GIR_EraseRootFromParent_Done,
     /*   11719 */   // Label 301: @11719
     /*   11719 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(11815), // Rule ID 51919 //
     /*   11724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11768 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11772 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11776 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11780 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11782 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11789 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   11792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11813 */     GIR_RootConstrainSelectedInstOperands,
     /*   11814 */     // GIR_Coverage, 51919,
     /*   11814 */     GIR_EraseRootFromParent_Done,
     /*   11815 */   // Label 302: @11815
     /*   11815 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(11911), // Rule ID 52036 //
     /*   11820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   11823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11839 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11843 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11857 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11876 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11878 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11883 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11885 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   11885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   11906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   11909 */     GIR_RootConstrainSelectedInstOperands,
     /*   11910 */     // GIR_Coverage, 52036,
     /*   11910 */     GIR_EraseRootFromParent_Done,
     /*   11911 */   // Label 303: @11911
     /*   11911 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(12007), // Rule ID 52037 //
     /*   11916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   11919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   11927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   11931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   11935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   11939 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   11941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   11945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   11949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11953 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   11955 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   11964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   11968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   11972 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   11974 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   11979 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   11981 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   11981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   11984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   11986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   11988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   11992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   11996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   11999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12005 */     GIR_RootConstrainSelectedInstOperands,
     /*   12006 */     // GIR_Coverage, 52037,
     /*   12006 */     GIR_EraseRootFromParent_Done,
     /*   12007 */   // Label 304: @12007
     /*   12007 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(12103), // Rule ID 70731 //
     /*   12012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   12031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   12035 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12064 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12068 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12075 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12077 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   12077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   12080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12101 */     GIR_RootConstrainSelectedInstOperands,
     /*   12102 */     // GIR_Coverage, 70731,
     /*   12102 */     GIR_EraseRootFromParent_Done,
     /*   12103 */   // Label 305: @12103
     /*   12103 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(12199), // Rule ID 70732 //
     /*   12108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   12127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   12131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12160 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12164 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12166 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12173 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   12173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   12176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   12184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   12188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12197 */     GIR_RootConstrainSelectedInstOperands,
     /*   12198 */     // GIR_Coverage, 70732,
     /*   12198 */     GIR_EraseRootFromParent_Done,
     /*   12199 */   // Label 306: @12199
     /*   12199 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(12295), // Rule ID 51976 //
     /*   12204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   12223 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   12227 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12248 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12252 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12256 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12260 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12262 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12269 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   12269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   12272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12293 */     GIR_RootConstrainSelectedInstOperands,
     /*   12294 */     // GIR_Coverage, 51976,
     /*   12294 */     GIR_EraseRootFromParent_Done,
     /*   12295 */   // Label 307: @12295
     /*   12295 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(12391), // Rule ID 51977 //
     /*   12300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   12311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   12319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   12323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   12329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12337 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12344 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   12348 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12352 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12356 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   12358 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12363 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   12365 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   12365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   12368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   12372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   12380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12389 */     GIR_RootConstrainSelectedInstOperands,
     /*   12390 */     // GIR_Coverage, 51977,
     /*   12390 */     GIR_EraseRootFromParent_Done,
     /*   12391 */   // Label 308: @12391
     /*   12391 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(12480), // Rule ID 46574 //
     /*   12396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   12407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   12426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12439 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   12439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   12456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12478 */     GIR_RootConstrainSelectedInstOperands,
     /*   12479 */     // GIR_Coverage, 46574,
     /*   12479 */     GIR_EraseRootFromParent_Done,
     /*   12480 */   // Label 309: @12480
     /*   12480 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(12569), // Rule ID 46575 //
     /*   12485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   12496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   12515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12528 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   12528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   12545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12567 */     GIR_RootConstrainSelectedInstOperands,
     /*   12568 */     // GIR_Coverage, 46575,
     /*   12568 */     GIR_EraseRootFromParent_Done,
     /*   12569 */   // Label 310: @12569
     /*   12569 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(12658), // Rule ID 46338 //
     /*   12574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12617 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   12617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   12634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12656 */     GIR_RootConstrainSelectedInstOperands,
     /*   12657 */     // GIR_Coverage, 46338,
     /*   12657 */     GIR_EraseRootFromParent_Done,
     /*   12658 */   // Label 311: @12658
     /*   12658 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(12747), // Rule ID 46339 //
     /*   12663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   12693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12706 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   12706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   12723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12745 */     GIR_RootConstrainSelectedInstOperands,
     /*   12746 */     // GIR_Coverage, 46339,
     /*   12746 */     GIR_EraseRootFromParent_Done,
     /*   12747 */   // Label 312: @12747
     /*   12747 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(12836), // Rule ID 46454 //
     /*   12752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12795 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   12795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   12812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12834 */     GIR_RootConstrainSelectedInstOperands,
     /*   12835 */     // GIR_Coverage, 46454,
     /*   12835 */     GIR_EraseRootFromParent_Done,
     /*   12836 */   // Label 313: @12836
     /*   12836 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(12925), // Rule ID 46455 //
     /*   12841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   12844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   12867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   12871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   12875 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   12877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   12884 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   12884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   12887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   12891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   12896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   12898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   12901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   12906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   12910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   12914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   12920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   12923 */     GIR_RootConstrainSelectedInstOperands,
     /*   12924 */     // GIR_Coverage, 46455,
     /*   12924 */     GIR_EraseRootFromParent_Done,
     /*   12925 */   // Label 314: @12925
     /*   12925 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(12993), // Rule ID 70283 //
     /*   12930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   12933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   12937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   12941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   12945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   12949 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   12951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12956 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   12965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   12967 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   12967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   12970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   12972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   12976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   12980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   12982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   12985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   12988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   12991 */     GIR_RootConstrainSelectedInstOperands,
     /*   12992 */     // GIR_Coverage, 70283,
     /*   12992 */     GIR_EraseRootFromParent_Done,
     /*   12993 */   // Label 315: @12993
     /*   12993 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(13061), // Rule ID 70284 //
     /*   12998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   13013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   13017 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13035 */     // (add:{ *:[nxv1i32] } (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   13035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   13038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13059 */     GIR_RootConstrainSelectedInstOperands,
     /*   13060 */     // GIR_Coverage, 70284,
     /*   13060 */     GIR_EraseRootFromParent_Done,
     /*   13061 */   // Label 316: @13061
     /*   13061 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(13116), // Rule ID 69283 //
     /*   13066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13094 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13114 */     GIR_RootConstrainSelectedInstOperands,
     /*   13115 */     // GIR_Coverage, 69283,
     /*   13115 */     GIR_EraseRootFromParent_Done,
     /*   13116 */   // Label 317: @13116
     /*   13116 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(13171), // Rule ID 69284 //
     /*   13121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13149 */     // (add:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13169 */     GIR_RootConstrainSelectedInstOperands,
     /*   13170 */     // GIR_Coverage, 69284,
     /*   13170 */     GIR_EraseRootFromParent_Done,
     /*   13171 */   // Label 318: @13171
     /*   13171 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(13226), // Rule ID 69103 //
     /*   13176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13204 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   13207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13224 */     GIR_RootConstrainSelectedInstOperands,
     /*   13225 */     // GIR_Coverage, 69103,
     /*   13225 */     GIR_EraseRootFromParent_Done,
     /*   13226 */   // Label 319: @13226
     /*   13226 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(13281), // Rule ID 69104 //
     /*   13231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13259 */     // (add:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   13262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13279 */     GIR_RootConstrainSelectedInstOperands,
     /*   13280 */     // GIR_Coverage, 69104,
     /*   13280 */     GIR_EraseRootFromParent_Done,
     /*   13281 */   // Label 320: @13281
     /*   13281 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(13336), // Rule ID 69193 //
     /*   13286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13314 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13334 */     GIR_RootConstrainSelectedInstOperands,
     /*   13335 */     // GIR_Coverage, 69193,
     /*   13335 */     GIR_EraseRootFromParent_Done,
     /*   13336 */   // Label 321: @13336
     /*   13336 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(13391), // Rule ID 69194 //
     /*   13341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13369 */     // (add:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13389 */     GIR_RootConstrainSelectedInstOperands,
     /*   13390 */     // GIR_Coverage, 69194,
     /*   13390 */     GIR_EraseRootFromParent_Done,
     /*   13391 */   // Label 322: @13391
     /*   13391 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(13459), // Rule ID 51752 //
     /*   13396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   13415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   13419 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13433 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   13433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   13436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13457 */     GIR_RootConstrainSelectedInstOperands,
     /*   13458 */     // GIR_Coverage, 51752,
     /*   13458 */     GIR_EraseRootFromParent_Done,
     /*   13459 */   // Label 323: @13459
     /*   13459 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(13527), // Rule ID 51753 //
     /*   13464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   13483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   13487 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13501 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   13501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   13504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   13510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13525 */     GIR_RootConstrainSelectedInstOperands,
     /*   13526 */     // GIR_Coverage, 51753,
     /*   13526 */     GIR_EraseRootFromParent_Done,
     /*   13527 */   // Label 324: @13527
     /*   13527 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(13582), // Rule ID 46634 //
     /*   13532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13560 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13580 */     GIR_RootConstrainSelectedInstOperands,
     /*   13581 */     // GIR_Coverage, 46634,
     /*   13581 */     GIR_EraseRootFromParent_Done,
     /*   13582 */   // Label 325: @13582
     /*   13582 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(13637), // Rule ID 46635 //
     /*   13587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   13602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13615 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13635 */     GIR_RootConstrainSelectedInstOperands,
     /*   13636 */     // GIR_Coverage, 46635,
     /*   13636 */     GIR_EraseRootFromParent_Done,
     /*   13637 */   // Label 326: @13637
     /*   13637 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(13692), // Rule ID 46394 //
     /*   13642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13670 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   13673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13690 */     GIR_RootConstrainSelectedInstOperands,
     /*   13691 */     // GIR_Coverage, 46394,
     /*   13691 */     GIR_EraseRootFromParent_Done,
     /*   13692 */   // Label 327: @13692
     /*   13692 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(13747), // Rule ID 46395 //
     /*   13697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   13712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13725 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   13728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13745 */     GIR_RootConstrainSelectedInstOperands,
     /*   13746 */     // GIR_Coverage, 46395,
     /*   13746 */     GIR_EraseRootFromParent_Done,
     /*   13747 */   // Label 328: @13747
     /*   13747 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(13802), // Rule ID 46514 //
     /*   13752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13780 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   13780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13800 */     GIR_RootConstrainSelectedInstOperands,
     /*   13801 */     // GIR_Coverage, 46514,
     /*   13801 */     GIR_EraseRootFromParent_Done,
     /*   13802 */   // Label 329: @13802
     /*   13802 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(13857), // Rule ID 46515 //
     /*   13807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   13818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   13822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   13826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   13828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   13835 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   13842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   13846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   13852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   13855 */     GIR_RootConstrainSelectedInstOperands,
     /*   13856 */     // GIR_Coverage, 46515,
     /*   13856 */     GIR_EraseRootFromParent_Done,
     /*   13857 */   // Label 330: @13857
     /*   13857 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(13910), // Rule ID 45988 //
     /*   13862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   13865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13873 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   13873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   13876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   13890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13908 */     GIR_RootConstrainSelectedInstOperands,
     /*   13909 */     // GIR_Coverage, 45988,
     /*   13909 */     GIR_EraseRootFromParent_Done,
     /*   13910 */   // Label 331: @13910
     /*   13910 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(13963), // Rule ID 45989 //
     /*   13915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   13918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13926 */     // (add:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   13926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   13929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   13933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   13938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   13940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   13943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   13945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   13948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   13950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   13952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   13955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   13958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   13961 */     GIR_RootConstrainSelectedInstOperands,
     /*   13962 */     // GIR_Coverage, 45989,
     /*   13962 */     GIR_EraseRootFromParent_Done,
     /*   13963 */   // Label 332: @13963
     /*   13963 */   GIM_Reject,
     /*   13964 */ // Label 292: @13964
     /*   13964 */ GIM_Reject,
     /*   13965 */ // Label 131: @13965
     /*   13965 */ GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(17089),
     /*   13970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   13973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   13976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   13980 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(14076), // Rule ID 70483 //
     /*   13985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   13988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   13992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   13996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14037 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14050 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   14050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   14053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14074 */     GIR_RootConstrainSelectedInstOperands,
     /*   14075 */     // GIR_Coverage, 70483,
     /*   14075 */     GIR_EraseRootFromParent_Done,
     /*   14076 */   // Label 334: @14076
     /*   14076 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(14172), // Rule ID 70484 //
     /*   14081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   14084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14146 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   14146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   14149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14170 */     GIR_RootConstrainSelectedInstOperands,
     /*   14171 */     // GIR_Coverage, 70484,
     /*   14171 */     GIR_EraseRootFromParent_Done,
     /*   14172 */   // Label 335: @14172
     /*   14172 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(14268), // Rule ID 70763 //
     /*   14177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   14180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14242 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   14242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   14245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14266 */     GIR_RootConstrainSelectedInstOperands,
     /*   14267 */     // GIR_Coverage, 70763,
     /*   14267 */     GIR_EraseRootFromParent_Done,
     /*   14268 */   // Label 336: @14268
     /*   14268 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(14364), // Rule ID 70764 //
     /*   14273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   14276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14306 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14308 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14321 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14325 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14327 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14338 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   14338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   14341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14362 */     GIR_RootConstrainSelectedInstOperands,
     /*   14363 */     // GIR_Coverage, 70764,
     /*   14363 */     GIR_EraseRootFromParent_Done,
     /*   14364 */   // Label 337: @14364
     /*   14364 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(14460), // Rule ID 70765 //
     /*   14369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   14372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14402 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14421 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14423 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14434 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   14434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   14437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   14445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   14449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14458 */     GIR_RootConstrainSelectedInstOperands,
     /*   14459 */     // GIR_Coverage, 70765,
     /*   14459 */     GIR_EraseRootFromParent_Done,
     /*   14460 */   // Label 338: @14460
     /*   14460 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(14556), // Rule ID 70766 //
     /*   14465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   14468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14498 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14513 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14517 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14519 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14530 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   14530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   14533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   14541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   14545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14554 */     GIR_RootConstrainSelectedInstOperands,
     /*   14555 */     // GIR_Coverage, 70766,
     /*   14555 */     GIR_EraseRootFromParent_Done,
     /*   14556 */   // Label 339: @14556
     /*   14556 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(14652), // Rule ID 70597 //
     /*   14561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   14564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14594 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14609 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14613 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14626 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   14626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   14629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14650 */     GIR_RootConstrainSelectedInstOperands,
     /*   14651 */     // GIR_Coverage, 70597,
     /*   14651 */     GIR_EraseRootFromParent_Done,
     /*   14652 */   // Label 340: @14652
     /*   14652 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(14748), // Rule ID 70598 //
     /*   14657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   14660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   14664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14690 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14697 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14701 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14705 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14709 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14711 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14722 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   14722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   14725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   14729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14746 */     GIR_RootConstrainSelectedInstOperands,
     /*   14747 */     // GIR_Coverage, 70598,
     /*   14747 */     GIR_EraseRootFromParent_Done,
     /*   14748 */   // Label 341: @14748
     /*   14748 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(14844), // Rule ID 51928 //
     /*   14753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   14756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14809 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14811 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14818 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   14818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   14821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   14825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14842 */     GIR_RootConstrainSelectedInstOperands,
     /*   14843 */     // GIR_Coverage, 51928,
     /*   14843 */     GIR_EraseRootFromParent_Done,
     /*   14844 */   // Label 342: @14844
     /*   14844 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(14940), // Rule ID 51929 //
     /*   14849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   14852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14872 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14905 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   14907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   14914 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   14914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   14917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   14919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   14921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   14925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   14929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   14932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   14935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   14938 */     GIR_RootConstrainSelectedInstOperands,
     /*   14939 */     // GIR_Coverage, 51929,
     /*   14939 */     GIR_EraseRootFromParent_Done,
     /*   14940 */   // Label 343: @14940
     /*   14940 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(15036), // Rule ID 52046 //
     /*   14945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   14948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   14956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   14960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   14964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   14968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   14970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   14974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   14978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   14982 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   14984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   14989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   14993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   14997 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15001 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15010 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   15010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   15013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15034 */     GIR_RootConstrainSelectedInstOperands,
     /*   15035 */     // GIR_Coverage, 52046,
     /*   15035 */     GIR_EraseRootFromParent_Done,
     /*   15036 */   // Label 344: @15036
     /*   15036 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(15132), // Rule ID 52047 //
     /*   15041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   15060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   15064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15078 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15093 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15097 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15099 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15106 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   15106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   15109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15130 */     GIR_RootConstrainSelectedInstOperands,
     /*   15131 */     // GIR_Coverage, 52047,
     /*   15131 */     GIR_EraseRootFromParent_Done,
     /*   15132 */   // Label 345: @15132
     /*   15132 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(15228), // Rule ID 70761 //
     /*   15137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   15140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   15156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   15160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15174 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15193 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15200 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15202 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   15202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   15205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15226 */     GIR_RootConstrainSelectedInstOperands,
     /*   15227 */     // GIR_Coverage, 70761,
     /*   15227 */     GIR_EraseRootFromParent_Done,
     /*   15228 */   // Label 346: @15228
     /*   15228 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(15324), // Rule ID 70762 //
     /*   15233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   15252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   15256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15289 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15298 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   15298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   15301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   15309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   15313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15322 */     GIR_RootConstrainSelectedInstOperands,
     /*   15323 */     // GIR_Coverage, 70762,
     /*   15323 */     GIR_EraseRootFromParent_Done,
     /*   15324 */   // Label 347: @15324
     /*   15324 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15420), // Rule ID 51986 //
     /*   15329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   15332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   15348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   15352 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15385 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15392 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15394 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   15394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   15397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15418 */     GIR_RootConstrainSelectedInstOperands,
     /*   15419 */     // GIR_Coverage, 51986,
     /*   15419 */     GIR_EraseRootFromParent_Done,
     /*   15420 */   // Label 348: @15420
     /*   15420 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15516), // Rule ID 51987 //
     /*   15425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   15436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   15440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   15444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   15448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   15454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   15473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15481 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   15483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15488 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   15490 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   15490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   15493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   15497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   15505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   15514 */     GIR_RootConstrainSelectedInstOperands,
     /*   15515 */     // GIR_Coverage, 51987,
     /*   15515 */     GIR_EraseRootFromParent_Done,
     /*   15516 */   // Label 349: @15516
     /*   15516 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15605), // Rule ID 46594 //
     /*   15521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   15524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15536 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15555 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   15564 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   15564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   15567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   15581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   15590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15603 */     GIR_RootConstrainSelectedInstOperands,
     /*   15604 */     // GIR_Coverage, 46594,
     /*   15604 */     GIR_EraseRootFromParent_Done,
     /*   15605 */   // Label 350: @15605
     /*   15605 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15694), // Rule ID 46595 //
     /*   15610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15625 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   15640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15644 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   15653 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   15653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   15656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   15670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   15679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15692 */     GIR_RootConstrainSelectedInstOperands,
     /*   15693 */     // GIR_Coverage, 46595,
     /*   15693 */     GIR_EraseRootFromParent_Done,
     /*   15694 */   // Label 351: @15694
     /*   15694 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15783), // Rule ID 46358 //
     /*   15699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   15702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15714 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15733 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   15742 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   15742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   15745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   15759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   15768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15781 */     GIR_RootConstrainSelectedInstOperands,
     /*   15782 */     // GIR_Coverage, 46358,
     /*   15782 */     GIR_EraseRootFromParent_Done,
     /*   15783 */   // Label 352: @15783
     /*   15783 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15872), // Rule ID 46359 //
     /*   15788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15803 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   15818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15822 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   15831 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   15831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   15834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   15848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   15857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15870 */     GIR_RootConstrainSelectedInstOperands,
     /*   15871 */     // GIR_Coverage, 46359,
     /*   15871 */     GIR_EraseRootFromParent_Done,
     /*   15872 */   // Label 353: @15872
     /*   15872 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15961), // Rule ID 46474 //
     /*   15877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   15880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15911 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   15913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   15920 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   15920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   15923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   15927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   15932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   15934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   15937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   15939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   15942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   15946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   15950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   15953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   15956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   15959 */     GIR_RootConstrainSelectedInstOperands,
     /*   15960 */     // GIR_Coverage, 46474,
     /*   15960 */     GIR_EraseRootFromParent_Done,
     /*   15961 */   // Label 354: @15961
     /*   15961 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(16050), // Rule ID 46475 //
     /*   15966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   15969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   15973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   15981 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   15983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   15988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   15992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   15996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16000 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   16002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   16009 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   16009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   16012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   16016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   16021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   16023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   16026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   16031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   16035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   16039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   16048 */     GIR_RootConstrainSelectedInstOperands,
     /*   16049 */     // GIR_Coverage, 46475,
     /*   16049 */     GIR_EraseRootFromParent_Done,
     /*   16050 */   // Label 355: @16050
     /*   16050 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16118), // Rule ID 70315 //
     /*   16055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   16058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   16070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   16074 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16092 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   16092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   16095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   16101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16116 */     GIR_RootConstrainSelectedInstOperands,
     /*   16117 */     // GIR_Coverage, 70315,
     /*   16117 */     GIR_EraseRootFromParent_Done,
     /*   16118 */   // Label 356: @16118
     /*   16118 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16186), // Rule ID 70316 //
     /*   16123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   16126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   16138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   16142 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16160 */     // (add:{ *:[nxv1i64] } (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   16160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   16163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   16169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16184 */     GIR_RootConstrainSelectedInstOperands,
     /*   16185 */     // GIR_Coverage, 70316,
     /*   16185 */     GIR_EraseRootFromParent_Done,
     /*   16186 */   // Label 357: @16186
     /*   16186 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16241), // Rule ID 69303 //
     /*   16191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16219 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16239 */     GIR_RootConstrainSelectedInstOperands,
     /*   16240 */     // GIR_Coverage, 69303,
     /*   16240 */     GIR_EraseRootFromParent_Done,
     /*   16241 */   // Label 358: @16241
     /*   16241 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16296), // Rule ID 69304 //
     /*   16246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16274 */     // (add:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16294 */     GIR_RootConstrainSelectedInstOperands,
     /*   16295 */     // GIR_Coverage, 69304,
     /*   16295 */     GIR_EraseRootFromParent_Done,
     /*   16296 */   // Label 359: @16296
     /*   16296 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16351), // Rule ID 69123 //
     /*   16301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16329 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   16332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16349 */     GIR_RootConstrainSelectedInstOperands,
     /*   16350 */     // GIR_Coverage, 69123,
     /*   16350 */     GIR_EraseRootFromParent_Done,
     /*   16351 */   // Label 360: @16351
     /*   16351 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16406), // Rule ID 69124 //
     /*   16356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16384 */     // (add:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   16387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16404 */     GIR_RootConstrainSelectedInstOperands,
     /*   16405 */     // GIR_Coverage, 69124,
     /*   16405 */     GIR_EraseRootFromParent_Done,
     /*   16406 */   // Label 361: @16406
     /*   16406 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16461), // Rule ID 69213 //
     /*   16411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16439 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16459 */     GIR_RootConstrainSelectedInstOperands,
     /*   16460 */     // GIR_Coverage, 69213,
     /*   16460 */     GIR_EraseRootFromParent_Done,
     /*   16461 */   // Label 362: @16461
     /*   16461 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16516), // Rule ID 69214 //
     /*   16466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   16473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16481 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16494 */     // (add:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   16501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16514 */     GIR_RootConstrainSelectedInstOperands,
     /*   16515 */     // GIR_Coverage, 69214,
     /*   16515 */     GIR_EraseRootFromParent_Done,
     /*   16516 */   // Label 363: @16516
     /*   16516 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16584), // Rule ID 51768 //
     /*   16521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   16524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   16540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   16544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16558 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   16558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   16561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   16567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16582 */     GIR_RootConstrainSelectedInstOperands,
     /*   16583 */     // GIR_Coverage, 51768,
     /*   16583 */     GIR_EraseRootFromParent_Done,
     /*   16584 */   // Label 364: @16584
     /*   16584 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16652), // Rule ID 51769 //
     /*   16589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   16592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   16604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   16608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   16612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16626 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   16626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   16629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   16635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   16647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16650 */     GIR_RootConstrainSelectedInstOperands,
     /*   16651 */     // GIR_Coverage, 51769,
     /*   16651 */     GIR_EraseRootFromParent_Done,
     /*   16652 */   // Label 365: @16652
     /*   16652 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16707), // Rule ID 46654 //
     /*   16657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16685 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16705 */     GIR_RootConstrainSelectedInstOperands,
     /*   16706 */     // GIR_Coverage, 46654,
     /*   16706 */     GIR_EraseRootFromParent_Done,
     /*   16707 */   // Label 366: @16707
     /*   16707 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16762), // Rule ID 46655 //
     /*   16712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   16727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16740 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16760 */     GIR_RootConstrainSelectedInstOperands,
     /*   16761 */     // GIR_Coverage, 46655,
     /*   16761 */     GIR_EraseRootFromParent_Done,
     /*   16762 */   // Label 367: @16762
     /*   16762 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16817), // Rule ID 46414 //
     /*   16767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16795 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   16798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16815 */     GIR_RootConstrainSelectedInstOperands,
     /*   16816 */     // GIR_Coverage, 46414,
     /*   16816 */     GIR_EraseRootFromParent_Done,
     /*   16817 */   // Label 368: @16817
     /*   16817 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(16872), // Rule ID 46415 //
     /*   16822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   16837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16850 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   16853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16870 */     GIR_RootConstrainSelectedInstOperands,
     /*   16871 */     // GIR_Coverage, 46415,
     /*   16871 */     GIR_EraseRootFromParent_Done,
     /*   16872 */   // Label 369: @16872
     /*   16872 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(16927), // Rule ID 46534 //
     /*   16877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   16880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16905 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   16905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16925 */     GIR_RootConstrainSelectedInstOperands,
     /*   16926 */     // GIR_Coverage, 46534,
     /*   16926 */     GIR_EraseRootFromParent_Done,
     /*   16927 */   // Label 370: @16927
     /*   16927 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(16982), // Rule ID 46535 //
     /*   16932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   16935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   16943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   16947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   16951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   16953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   16960 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   16960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   16963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   16965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   16967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   16971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   16974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   16977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   16980 */     GIR_RootConstrainSelectedInstOperands,
     /*   16981 */     // GIR_Coverage, 46535,
     /*   16981 */     GIR_EraseRootFromParent_Done,
     /*   16982 */   // Label 371: @16982
     /*   16982 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17035), // Rule ID 46004 //
     /*   16987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   16990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   16998 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   16998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   17001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   17015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17033 */     GIR_RootConstrainSelectedInstOperands,
     /*   17034 */     // GIR_Coverage, 46004,
     /*   17034 */     GIR_EraseRootFromParent_Done,
     /*   17035 */   // Label 372: @17035
     /*   17035 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17088), // Rule ID 46005 //
     /*   17040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   17043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17051 */     // (add:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   17051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   17054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   17068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   17083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17086 */     GIR_RootConstrainSelectedInstOperands,
     /*   17087 */     // GIR_Coverage, 46005,
     /*   17087 */     GIR_EraseRootFromParent_Done,
     /*   17088 */   // Label 373: @17088
     /*   17088 */   GIM_Reject,
     /*   17089 */ // Label 333: @17089
     /*   17089 */ GIM_Reject,
     /*   17090 */ // Label 132: @17090
     /*   17090 */ GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17484),
     /*   17095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   17101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17105 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17173), // Rule ID 70251 //
     /*   17110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   17129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17147 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   17147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   17150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17171 */     GIR_RootConstrainSelectedInstOperands,
     /*   17172 */     // GIR_Coverage, 70251,
     /*   17172 */     GIR_EraseRootFromParent_Done,
     /*   17173 */   // Label 375: @17173
     /*   17173 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17241), // Rule ID 70252 //
     /*   17178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17193 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   17197 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17215 */     // (add:{ *:[nxv2i8] } (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   17215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   17218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17239 */     GIR_RootConstrainSelectedInstOperands,
     /*   17240 */     // GIR_Coverage, 70252,
     /*   17240 */     GIR_EraseRootFromParent_Done,
     /*   17241 */   // Label 376: @17241
     /*   17241 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17309), // Rule ID 51736 //
     /*   17246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   17269 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17283 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   17283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   17286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17307 */     GIR_RootConstrainSelectedInstOperands,
     /*   17308 */     // GIR_Coverage, 51736,
     /*   17308 */     GIR_EraseRootFromParent_Done,
     /*   17309 */   // Label 377: @17309
     /*   17309 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17377), // Rule ID 51737 //
     /*   17314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   17325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   17337 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   17351 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   17351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /*   17354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   17360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   17364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   17366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17375 */     GIR_RootConstrainSelectedInstOperands,
     /*   17376 */     // GIR_Coverage, 51737,
     /*   17376 */     GIR_EraseRootFromParent_Done,
     /*   17377 */   // Label 378: @17377
     /*   17377 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17430), // Rule ID 45972 //
     /*   17382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17393 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   17393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   17396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   17410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17428 */     GIR_RootConstrainSelectedInstOperands,
     /*   17429 */     // GIR_Coverage, 45972,
     /*   17429 */     GIR_EraseRootFromParent_Done,
     /*   17430 */   // Label 379: @17430
     /*   17430 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17483), // Rule ID 45973 //
     /*   17435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17446 */     // (add:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   17446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   17449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   17453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   17458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   17460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*   17463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   17468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   17470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   17472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17481 */     GIR_RootConstrainSelectedInstOperands,
     /*   17482 */     // GIR_Coverage, 45973,
     /*   17482 */     GIR_EraseRootFromParent_Done,
     /*   17483 */   // Label 380: @17483
     /*   17483 */   GIM_Reject,
     /*   17484 */ // Label 374: @17484
     /*   17484 */ GIM_Reject,
     /*   17485 */ // Label 133: @17485
     /*   17485 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(20609),
     /*   17490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17500 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17596), // Rule ID 70463 //
     /*   17505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17524 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   17530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17538 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   17549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17557 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   17559 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   17570 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   17570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   17573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   17577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   17585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17594 */     GIR_RootConstrainSelectedInstOperands,
     /*   17595 */     // GIR_Coverage, 70463,
     /*   17595 */     GIR_EraseRootFromParent_Done,
     /*   17596 */   // Label 382: @17596
     /*   17596 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17692), // Rule ID 70464 //
     /*   17601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17616 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   17626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17634 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   17645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17653 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   17655 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17664 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   17666 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   17666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   17669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   17673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   17681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17690 */     GIR_RootConstrainSelectedInstOperands,
     /*   17691 */     // GIR_Coverage, 70464,
     /*   17691 */     GIR_EraseRootFromParent_Done,
     /*   17692 */   // Label 383: @17692
     /*   17692 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17788), // Rule ID 70703 //
     /*   17697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   17722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   17741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17745 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17749 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   17751 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   17762 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   17762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   17765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   17769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   17777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17786 */     GIR_RootConstrainSelectedInstOperands,
     /*   17787 */     // GIR_Coverage, 70703,
     /*   17787 */     GIR_EraseRootFromParent_Done,
     /*   17788 */   // Label 384: @17788
     /*   17788 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17884), // Rule ID 70704 //
     /*   17793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   17818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17822 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17826 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17828 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   17837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17841 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17845 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   17847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   17858 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   17858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   17861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   17865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   17869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   17873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17882 */     GIR_RootConstrainSelectedInstOperands,
     /*   17883 */     // GIR_Coverage, 70704,
     /*   17883 */     GIR_EraseRootFromParent_Done,
     /*   17884 */   // Label 385: @17884
     /*   17884 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(17980), // Rule ID 70705 //
     /*   17889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   17892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   17904 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   17908 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   17910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   17914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   17918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17922 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   17924 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   17933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   17937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   17941 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   17943 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   17952 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   17954 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   17954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   17957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   17959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   17961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   17965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   17969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   17972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   17975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   17978 */     GIR_RootConstrainSelectedInstOperands,
     /*   17979 */     // GIR_Coverage, 70705,
     /*   17979 */     GIR_EraseRootFromParent_Done,
     /*   17980 */   // Label 386: @17980
     /*   17980 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18076), // Rule ID 70706 //
     /*   17985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   17988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   17992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   17996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18033 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18037 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18039 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18048 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18050 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   18050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   18053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18074 */     GIR_RootConstrainSelectedInstOperands,
     /*   18075 */     // GIR_Coverage, 70706,
     /*   18075 */     GIR_EraseRootFromParent_Done,
     /*   18076 */   // Label 387: @18076
     /*   18076 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18172), // Rule ID 70577 //
     /*   18081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18114 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18129 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18133 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18135 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18144 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18146 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   18146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   18149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18170 */     GIR_RootConstrainSelectedInstOperands,
     /*   18171 */     // GIR_Coverage, 70577,
     /*   18171 */     GIR_EraseRootFromParent_Done,
     /*   18172 */   // Label 388: @18172
     /*   18172 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18268), // Rule ID 70578 //
     /*   18177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   18184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18210 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18217 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18221 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18225 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18229 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18231 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18242 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   18242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   18245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   18249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18266 */     GIR_RootConstrainSelectedInstOperands,
     /*   18267 */     // GIR_Coverage, 70578,
     /*   18267 */     GIR_EraseRootFromParent_Done,
     /*   18268 */   // Label 389: @18268
     /*   18268 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18364), // Rule ID 51908 //
     /*   18273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18296 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18329 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18331 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18336 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18338 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   18338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   18341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18362 */     GIR_RootConstrainSelectedInstOperands,
     /*   18363 */     // GIR_Coverage, 51908,
     /*   18363 */     GIR_EraseRootFromParent_Done,
     /*   18364 */   // Label 390: @18364
     /*   18364 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18460), // Rule ID 51909 //
     /*   18369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18392 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18406 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18408 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18421 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18425 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18427 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18432 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18434 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   18434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /*   18437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18458 */     GIR_RootConstrainSelectedInstOperands,
     /*   18459 */     // GIR_Coverage, 51909,
     /*   18459 */     GIR_EraseRootFromParent_Done,
     /*   18460 */   // Label 391: @18460
     /*   18460 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18556), // Rule ID 52026 //
     /*   18465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18502 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18517 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18521 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18523 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18530 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   18530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   18533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18554 */     GIR_RootConstrainSelectedInstOperands,
     /*   18555 */     // GIR_Coverage, 52026,
     /*   18555 */     GIR_EraseRootFromParent_Done,
     /*   18556 */   // Label 392: @18556
     /*   18556 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18652), // Rule ID 52027 //
     /*   18561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18584 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18617 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18619 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18624 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18626 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   18626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   18629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18650 */     GIR_RootConstrainSelectedInstOperands,
     /*   18651 */     // GIR_Coverage, 52027,
     /*   18651 */     GIR_EraseRootFromParent_Done,
     /*   18652 */   // Label 393: @18652
     /*   18652 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18748), // Rule ID 70701 //
     /*   18657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18694 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18709 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18713 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18722 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   18722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   18725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18746 */     GIR_RootConstrainSelectedInstOperands,
     /*   18747 */     // GIR_Coverage, 70701,
     /*   18747 */     GIR_EraseRootFromParent_Done,
     /*   18748 */   // Label 394: @18748
     /*   18748 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18844), // Rule ID 70702 //
     /*   18753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18776 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18797 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18801 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   18805 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18809 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18811 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18818 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   18818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /*   18821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   18829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   18833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18842 */     GIR_RootConstrainSelectedInstOperands,
     /*   18843 */     // GIR_Coverage, 70702,
     /*   18843 */     GIR_EraseRootFromParent_Done,
     /*   18844 */   // Label 395: @18844
     /*   18844 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18940), // Rule ID 51966 //
     /*   18849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   18852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18872 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18886 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18893 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18897 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18901 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18905 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   18907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   18914 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   18914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   18917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   18919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   18921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   18925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   18929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   18932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   18935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   18938 */     GIR_RootConstrainSelectedInstOperands,
     /*   18939 */     // GIR_Coverage, 51966,
     /*   18939 */     GIR_EraseRootFromParent_Done,
     /*   18940 */   // Label 396: @18940
     /*   18940 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(19036), // Rule ID 51967 //
     /*   18945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   18948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   18956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   18960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   18964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   18968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   18970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   18974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   18982 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   18984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   18989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   18993 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   18997 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19001 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   19003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19008 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   19010 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   19010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /*   19013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   19017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   19025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19034 */     GIR_RootConstrainSelectedInstOperands,
     /*   19035 */     // GIR_Coverage, 51967,
     /*   19035 */     GIR_EraseRootFromParent_Done,
     /*   19036 */   // Label 397: @19036
     /*   19036 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(19125), // Rule ID 46554 //
     /*   19041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19052 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19056 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19075 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19084 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   19101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19123 */     GIR_RootConstrainSelectedInstOperands,
     /*   19124 */     // GIR_Coverage, 46554,
     /*   19124 */     GIR_EraseRootFromParent_Done,
     /*   19125 */   // Label 398: @19125
     /*   19125 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(19214), // Rule ID 46555 //
     /*   19130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19145 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19164 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19173 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   19173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   19190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19212 */     GIR_RootConstrainSelectedInstOperands,
     /*   19213 */     // GIR_Coverage, 46555,
     /*   19213 */     GIR_EraseRootFromParent_Done,
     /*   19214 */   // Label 399: @19214
     /*   19214 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(19303), // Rule ID 46318 //
     /*   19219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19234 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19253 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19255 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19262 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   19279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19301 */     GIR_RootConstrainSelectedInstOperands,
     /*   19302 */     // GIR_Coverage, 46318,
     /*   19302 */     GIR_EraseRootFromParent_Done,
     /*   19303 */   // Label 400: @19303
     /*   19303 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(19392), // Rule ID 46319 //
     /*   19308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19323 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19342 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19344 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19349 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19351 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   19351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*   19368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19390 */     GIR_RootConstrainSelectedInstOperands,
     /*   19391 */     // GIR_Coverage, 46319,
     /*   19391 */     GIR_EraseRootFromParent_Done,
     /*   19392 */   // Label 401: @19392
     /*   19392 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(19481), // Rule ID 46434 //
     /*   19397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19431 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19440 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   19440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   19457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19479 */     GIR_RootConstrainSelectedInstOperands,
     /*   19480 */     // GIR_Coverage, 46434,
     /*   19480 */     GIR_EraseRootFromParent_Done,
     /*   19481 */   // Label 402: @19481
     /*   19481 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(19570), // Rule ID 46435 //
     /*   19486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   19512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   19522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   19529 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   19529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   19532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   19536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   19541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   19543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*   19546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   19551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   19555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   19559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19568 */     GIR_RootConstrainSelectedInstOperands,
     /*   19569 */     // GIR_Coverage, 46435,
     /*   19569 */     GIR_EraseRootFromParent_Done,
     /*   19570 */   // Label 403: @19570
     /*   19570 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(19638), // Rule ID 70275 //
     /*   19575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   19590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   19594 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19612 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   19612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   19615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   19621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19636 */     GIR_RootConstrainSelectedInstOperands,
     /*   19637 */     // GIR_Coverage, 70275,
     /*   19637 */     GIR_EraseRootFromParent_Done,
     /*   19638 */   // Label 404: @19638
     /*   19638 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(19706), // Rule ID 70276 //
     /*   19643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   19654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   19658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   19662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19680 */     // (add:{ *:[nxv2i16] } (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   19680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   19683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   19689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   19701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19704 */     GIR_RootConstrainSelectedInstOperands,
     /*   19705 */     // GIR_Coverage, 70276,
     /*   19705 */     GIR_EraseRootFromParent_Done,
     /*   19706 */   // Label 405: @19706
     /*   19706 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(19761), // Rule ID 69263 //
     /*   19711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19739 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   19739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   19742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19759 */     GIR_RootConstrainSelectedInstOperands,
     /*   19760 */     // GIR_Coverage, 69263,
     /*   19760 */     GIR_EraseRootFromParent_Done,
     /*   19761 */   // Label 406: @19761
     /*   19761 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(19816), // Rule ID 69264 //
     /*   19766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   19777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19794 */     // (add:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   19794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   19797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19814 */     GIR_RootConstrainSelectedInstOperands,
     /*   19815 */     // GIR_Coverage, 69264,
     /*   19815 */     GIR_EraseRootFromParent_Done,
     /*   19816 */   // Label 407: @19816
     /*   19816 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(19871), // Rule ID 69083 //
     /*   19821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19849 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   19849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   19852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19869 */     GIR_RootConstrainSelectedInstOperands,
     /*   19870 */     // GIR_Coverage, 69083,
     /*   19870 */     GIR_EraseRootFromParent_Done,
     /*   19871 */   // Label 408: @19871
     /*   19871 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(19926), // Rule ID 69084 //
     /*   19876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   19887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19891 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19904 */     // (add:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   19904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   19907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19924 */     GIR_RootConstrainSelectedInstOperands,
     /*   19925 */     // GIR_Coverage, 69084,
     /*   19925 */     GIR_EraseRootFromParent_Done,
     /*   19926 */   // Label 409: @19926
     /*   19926 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(19981), // Rule ID 69173 //
     /*   19931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   19934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   19946 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   19948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   19957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   19959 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   19959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   19962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   19964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   19966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   19970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   19973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   19976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   19979 */     GIR_RootConstrainSelectedInstOperands,
     /*   19980 */     // GIR_Coverage, 69173,
     /*   19980 */     GIR_EraseRootFromParent_Done,
     /*   19981 */   // Label 410: @19981
     /*   19981 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(20036), // Rule ID 69174 //
     /*   19986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   19989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   19993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   19997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20014 */     // (add:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   20014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   20017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20034 */     GIR_RootConstrainSelectedInstOperands,
     /*   20035 */     // GIR_Coverage, 69174,
     /*   20035 */     GIR_EraseRootFromParent_Done,
     /*   20036 */   // Label 411: @20036
     /*   20036 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(20104), // Rule ID 51748 //
     /*   20041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   20064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20078 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   20078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   20081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20102 */     GIR_RootConstrainSelectedInstOperands,
     /*   20103 */     // GIR_Coverage, 51748,
     /*   20103 */     GIR_EraseRootFromParent_Done,
     /*   20104 */   // Label 412: @20104
     /*   20104 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(20172), // Rule ID 51749 //
     /*   20109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   20132 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20146 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   20146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   20149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   20155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20170 */     GIR_RootConstrainSelectedInstOperands,
     /*   20171 */     // GIR_Coverage, 51749,
     /*   20171 */     GIR_EraseRootFromParent_Done,
     /*   20172 */   // Label 413: @20172
     /*   20172 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(20227), // Rule ID 46614 //
     /*   20177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20205 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   20205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   20208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20225 */     GIR_RootConstrainSelectedInstOperands,
     /*   20226 */     // GIR_Coverage, 46614,
     /*   20226 */     GIR_EraseRootFromParent_Done,
     /*   20227 */   // Label 414: @20227
     /*   20227 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(20282), // Rule ID 46615 //
     /*   20232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   20247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20260 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   20260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   20263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20280 */     GIR_RootConstrainSelectedInstOperands,
     /*   20281 */     // GIR_Coverage, 46615,
     /*   20281 */     GIR_EraseRootFromParent_Done,
     /*   20282 */   // Label 415: @20282
     /*   20282 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(20337), // Rule ID 46374 //
     /*   20287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20315 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   20315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   20318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20335 */     GIR_RootConstrainSelectedInstOperands,
     /*   20336 */     // GIR_Coverage, 46374,
     /*   20336 */     GIR_EraseRootFromParent_Done,
     /*   20337 */   // Label 416: @20337
     /*   20337 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(20392), // Rule ID 46375 //
     /*   20342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20361 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20370 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   20370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*   20373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20390 */     GIR_RootConstrainSelectedInstOperands,
     /*   20391 */     // GIR_Coverage, 46375,
     /*   20391 */     GIR_EraseRootFromParent_Done,
     /*   20392 */   // Label 417: @20392
     /*   20392 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(20447), // Rule ID 46494 //
     /*   20397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20416 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20425 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   20425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   20428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20445 */     GIR_RootConstrainSelectedInstOperands,
     /*   20446 */     // GIR_Coverage, 46494,
     /*   20446 */     GIR_EraseRootFromParent_Done,
     /*   20447 */   // Label 418: @20447
     /*   20447 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(20502), // Rule ID 46495 //
     /*   20452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20455 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   20463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   20471 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   20480 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   20480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*   20483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   20487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   20491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20500 */     GIR_RootConstrainSelectedInstOperands,
     /*   20501 */     // GIR_Coverage, 46495,
     /*   20501 */     GIR_EraseRootFromParent_Done,
     /*   20502 */   // Label 419: @20502
     /*   20502 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(20555), // Rule ID 45984 //
     /*   20507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20518 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   20518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   20521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   20535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20553 */     GIR_RootConstrainSelectedInstOperands,
     /*   20554 */     // GIR_Coverage, 45984,
     /*   20554 */     GIR_EraseRootFromParent_Done,
     /*   20555 */   // Label 420: @20555
     /*   20555 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(20608), // Rule ID 45985 //
     /*   20560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20571 */     // (add:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   20571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   20574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   20578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   20583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   20585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   20588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   20593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   20595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   20597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   20606 */     GIR_RootConstrainSelectedInstOperands,
     /*   20607 */     // GIR_Coverage, 45985,
     /*   20607 */     GIR_EraseRootFromParent_Done,
     /*   20608 */   // Label 421: @20608
     /*   20608 */   GIM_Reject,
     /*   20609 */ // Label 381: @20609
     /*   20609 */ GIM_Reject,
     /*   20610 */ // Label 134: @20610
     /*   20610 */ GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(23734),
     /*   20615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   20618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   20621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20625 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(20721), // Rule ID 70475 //
     /*   20630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   20645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   20649 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20663 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20682 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20684 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20695 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   20695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   20698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   20702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20719 */     GIR_RootConstrainSelectedInstOperands,
     /*   20720 */     // GIR_Coverage, 70475,
     /*   20720 */     GIR_EraseRootFromParent_Done,
     /*   20721 */   // Label 423: @20721
     /*   20721 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20817), // Rule ID 70476 //
     /*   20726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   20741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   20745 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20766 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20770 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20774 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20778 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20780 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20789 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20791 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   20791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   20794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   20798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20815 */     GIR_RootConstrainSelectedInstOperands,
     /*   20816 */     // GIR_Coverage, 70476,
     /*   20816 */     GIR_EraseRootFromParent_Done,
     /*   20817 */   // Label 424: @20817
     /*   20817 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20913), // Rule ID 70739 //
     /*   20822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   20825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   20837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   20841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20862 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20866 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20870 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20874 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20876 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20885 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20887 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   20887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   20890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   20894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   20905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   20908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   20911 */     GIR_RootConstrainSelectedInstOperands,
     /*   20912 */     // GIR_Coverage, 70739,
     /*   20912 */     GIR_EraseRootFromParent_Done,
     /*   20913 */   // Label 425: @20913
     /*   20913 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(21009), // Rule ID 70740 //
     /*   20918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   20921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   20925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   20929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   20933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   20937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   20939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   20943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   20947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20951 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   20953 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20958 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   20962 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   20966 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   20970 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   20972 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   20981 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   20983 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   20983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   20986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   20988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   20990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   20994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   20998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21007 */     GIR_RootConstrainSelectedInstOperands,
     /*   21008 */     // GIR_Coverage, 70740,
     /*   21008 */     GIR_EraseRootFromParent_Done,
     /*   21009 */   // Label 426: @21009
     /*   21009 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(21105), // Rule ID 70741 //
     /*   21014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21033 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21047 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21066 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21068 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21077 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21079 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   21079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   21090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   21094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21103 */     GIR_RootConstrainSelectedInstOperands,
     /*   21104 */     // GIR_Coverage, 70741,
     /*   21104 */     GIR_EraseRootFromParent_Done,
     /*   21105 */   // Label 427: @21105
     /*   21105 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(21201), // Rule ID 70742 //
     /*   21110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21131 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21135 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21139 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21143 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21158 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21162 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21164 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21173 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21175 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   21175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   21186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   21190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21199 */     GIR_RootConstrainSelectedInstOperands,
     /*   21200 */     // GIR_Coverage, 70742,
     /*   21200 */     GIR_EraseRootFromParent_Done,
     /*   21201 */   // Label 428: @21201
     /*   21201 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(21297), // Rule ID 70589 //
     /*   21206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21239 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21246 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21250 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21254 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21258 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21260 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21271 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   21271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   21274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21295 */     GIR_RootConstrainSelectedInstOperands,
     /*   21296 */     // GIR_Coverage, 70589,
     /*   21296 */     GIR_EraseRootFromParent_Done,
     /*   21297 */   // Label 429: @21297
     /*   21297 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(21393), // Rule ID 70590 //
     /*   21302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   21309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21335 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21354 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21356 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21365 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21367 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   21367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   21370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   21374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21391 */     GIR_RootConstrainSelectedInstOperands,
     /*   21392 */     // GIR_Coverage, 70590,
     /*   21392 */     GIR_EraseRootFromParent_Done,
     /*   21393 */   // Label 430: @21393
     /*   21393 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(21489), // Rule ID 51920 //
     /*   21398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21423 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21427 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21431 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21435 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21442 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21446 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21450 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21454 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21456 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21461 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21463 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   21463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   21466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21487 */     GIR_RootConstrainSelectedInstOperands,
     /*   21488 */     // GIR_Coverage, 51920,
     /*   21488 */     GIR_EraseRootFromParent_Done,
     /*   21489 */   // Label 431: @21489
     /*   21489 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21585), // Rule ID 51921 //
     /*   21494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21517 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21531 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21546 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21550 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21552 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21557 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21559 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   21559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   21562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21583 */     GIR_RootConstrainSelectedInstOperands,
     /*   21584 */     // GIR_Coverage, 51921,
     /*   21584 */     GIR_EraseRootFromParent_Done,
     /*   21585 */   // Label 432: @21585
     /*   21585 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21681), // Rule ID 52038 //
     /*   21590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21613 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21627 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21642 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21646 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21648 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21653 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21655 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   21655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21679 */     GIR_RootConstrainSelectedInstOperands,
     /*   21680 */     // GIR_Coverage, 52038,
     /*   21680 */     GIR_EraseRootFromParent_Done,
     /*   21681 */   // Label 433: @21681
     /*   21681 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21777), // Rule ID 52039 //
     /*   21686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21723 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21730 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21734 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21738 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21742 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21744 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21751 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   21751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   21762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   21766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21775 */     GIR_RootConstrainSelectedInstOperands,
     /*   21776 */     // GIR_Coverage, 52039,
     /*   21776 */     GIR_EraseRootFromParent_Done,
     /*   21777 */   // Label 434: @21777
     /*   21777 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21873), // Rule ID 70737 //
     /*   21782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21805 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21819 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21834 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21838 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21840 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21847 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   21847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   21858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   21862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21871 */     GIR_RootConstrainSelectedInstOperands,
     /*   21872 */     // GIR_Coverage, 70737,
     /*   21872 */     GIR_EraseRootFromParent_Done,
     /*   21873 */   // Label 435: @21873
     /*   21873 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21969), // Rule ID 70738 //
     /*   21878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   21881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21903 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   21907 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   21911 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21915 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   21917 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   21926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   21930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   21934 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   21936 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   21943 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   21943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   21946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   21948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   21950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   21954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   21958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   21961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   21964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   21967 */     GIR_RootConstrainSelectedInstOperands,
     /*   21968 */     // GIR_Coverage, 70738,
     /*   21968 */     GIR_EraseRootFromParent_Done,
     /*   21969 */   // Label 436: @21969
     /*   21969 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(22065), // Rule ID 51978 //
     /*   21974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   21977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   21981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   21985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   21989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   21993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   21997 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   21999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22011 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22026 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22030 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22032 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22039 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   22039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   22042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22063 */     GIR_RootConstrainSelectedInstOperands,
     /*   22064 */     // GIR_Coverage, 51978,
     /*   22064 */     GIR_EraseRootFromParent_Done,
     /*   22065 */   // Label 437: @22065
     /*   22065 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(22161), // Rule ID 51979 //
     /*   22070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   22081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   22089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   22093 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   22099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   22118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22122 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22126 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   22128 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22133 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   22135 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   22135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   22138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   22142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   22150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22159 */     GIR_RootConstrainSelectedInstOperands,
     /*   22160 */     // GIR_Coverage, 51979,
     /*   22160 */     GIR_EraseRootFromParent_Done,
     /*   22161 */   // Label 438: @22161
     /*   22161 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(22250), // Rule ID 46578 //
     /*   22166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22181 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22200 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22209 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   22209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   22226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22248 */     GIR_RootConstrainSelectedInstOperands,
     /*   22249 */     // GIR_Coverage, 46578,
     /*   22249 */     GIR_EraseRootFromParent_Done,
     /*   22250 */   // Label 439: @22250
     /*   22250 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(22339), // Rule ID 46579 //
     /*   22255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22270 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22289 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22298 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   22298 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22301 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22305 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   22315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22337 */     GIR_RootConstrainSelectedInstOperands,
     /*   22338 */     // GIR_Coverage, 46579,
     /*   22338 */     GIR_EraseRootFromParent_Done,
     /*   22339 */   // Label 440: @22339
     /*   22339 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22428), // Rule ID 46342 //
     /*   22344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22378 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22387 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   22387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   22404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22426 */     GIR_RootConstrainSelectedInstOperands,
     /*   22427 */     // GIR_Coverage, 46342,
     /*   22427 */     GIR_EraseRootFromParent_Done,
     /*   22428 */   // Label 441: @22428
     /*   22428 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22517), // Rule ID 46343 //
     /*   22433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22467 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22476 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   22476 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22479 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22483 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22488 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   22493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22515 */     GIR_RootConstrainSelectedInstOperands,
     /*   22516 */     // GIR_Coverage, 46343,
     /*   22516 */     GIR_EraseRootFromParent_Done,
     /*   22517 */   // Label 442: @22517
     /*   22517 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22606), // Rule ID 46458 //
     /*   22522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22556 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22565 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   22565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   22582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22604 */     GIR_RootConstrainSelectedInstOperands,
     /*   22605 */     // GIR_Coverage, 46458,
     /*   22605 */     GIR_EraseRootFromParent_Done,
     /*   22606 */   // Label 443: @22606
     /*   22606 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22695), // Rule ID 46459 //
     /*   22611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   22637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   22641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22645 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   22647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   22654 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   22654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   22657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   22661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   22666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   22668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   22671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   22676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   22680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   22684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   22693 */     GIR_RootConstrainSelectedInstOperands,
     /*   22694 */     // GIR_Coverage, 46459,
     /*   22694 */     GIR_EraseRootFromParent_Done,
     /*   22695 */   // Label 444: @22695
     /*   22695 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22763), // Rule ID 70307 //
     /*   22700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   22715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   22719 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   22737 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   22737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   22740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   22746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   22750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22761 */     GIR_RootConstrainSelectedInstOperands,
     /*   22762 */     // GIR_Coverage, 70307,
     /*   22762 */     GIR_EraseRootFromParent_Done,
     /*   22763 */   // Label 445: @22763
     /*   22763 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22831), // Rule ID 70308 //
     /*   22768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   22779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   22783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   22787 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   22805 */     // (add:{ *:[nxv2i32] } (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   22805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   22808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   22814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   22818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   22826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22829 */     GIR_RootConstrainSelectedInstOperands,
     /*   22830 */     // GIR_Coverage, 70308,
     /*   22830 */     GIR_EraseRootFromParent_Done,
     /*   22831 */   // Label 446: @22831
     /*   22831 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22886), // Rule ID 69287 //
     /*   22836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   22864 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   22864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   22867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   22875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22884 */     GIR_RootConstrainSelectedInstOperands,
     /*   22885 */     // GIR_Coverage, 69287,
     /*   22885 */     GIR_EraseRootFromParent_Done,
     /*   22886 */   // Label 447: @22886
     /*   22886 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22941), // Rule ID 69288 //
     /*   22891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   22894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   22902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   22919 */     // (add:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   22919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   22922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   22930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22939 */     GIR_RootConstrainSelectedInstOperands,
     /*   22940 */     // GIR_Coverage, 69288,
     /*   22940 */     GIR_EraseRootFromParent_Done,
     /*   22941 */   // Label 448: @22941
     /*   22941 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22996), // Rule ID 69107 //
     /*   22946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   22949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   22953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   22957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   22961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   22963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   22972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   22974 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   22974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   22977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   22979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   22981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   22985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   22991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   22994 */     GIR_RootConstrainSelectedInstOperands,
     /*   22995 */     // GIR_Coverage, 69107,
     /*   22995 */     GIR_EraseRootFromParent_Done,
     /*   22996 */   // Label 449: @22996
     /*   22996 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(23051), // Rule ID 69108 //
     /*   23001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23029 */     // (add:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   23032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23049 */     GIR_RootConstrainSelectedInstOperands,
     /*   23050 */     // GIR_Coverage, 69108,
     /*   23050 */     GIR_EraseRootFromParent_Done,
     /*   23051 */   // Label 450: @23051
     /*   23051 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(23106), // Rule ID 69197 //
     /*   23056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23071 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23084 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23104 */     GIR_RootConstrainSelectedInstOperands,
     /*   23105 */     // GIR_Coverage, 69197,
     /*   23105 */     GIR_EraseRootFromParent_Done,
     /*   23106 */   // Label 451: @23106
     /*   23106 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23161), // Rule ID 69198 //
     /*   23111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23139 */     // (add:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23159 */     GIR_RootConstrainSelectedInstOperands,
     /*   23160 */     // GIR_Coverage, 69198,
     /*   23160 */     GIR_EraseRootFromParent_Done,
     /*   23161 */   // Label 452: @23161
     /*   23161 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23229), // Rule ID 51764 //
     /*   23166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   23189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23203 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   23203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   23206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23227 */     GIR_RootConstrainSelectedInstOperands,
     /*   23228 */     // GIR_Coverage, 51764,
     /*   23228 */     GIR_EraseRootFromParent_Done,
     /*   23229 */   // Label 453: @23229
     /*   23229 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23297), // Rule ID 51765 //
     /*   23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   23257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23271 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   23271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   23274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   23280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23295 */     GIR_RootConstrainSelectedInstOperands,
     /*   23296 */     // GIR_Coverage, 51765,
     /*   23296 */     GIR_EraseRootFromParent_Done,
     /*   23297 */   // Label 454: @23297
     /*   23297 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23352), // Rule ID 46638 //
     /*   23302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23330 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23350 */     GIR_RootConstrainSelectedInstOperands,
     /*   23351 */     // GIR_Coverage, 46638,
     /*   23351 */     GIR_EraseRootFromParent_Done,
     /*   23352 */   // Label 455: @23352
     /*   23352 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23407), // Rule ID 46639 //
     /*   23357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   23372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23385 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23405 */     GIR_RootConstrainSelectedInstOperands,
     /*   23406 */     // GIR_Coverage, 46639,
     /*   23406 */     GIR_EraseRootFromParent_Done,
     /*   23407 */   // Label 456: @23407
     /*   23407 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23462), // Rule ID 46398 //
     /*   23412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23440 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   23443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23460 */     GIR_RootConstrainSelectedInstOperands,
     /*   23461 */     // GIR_Coverage, 46398,
     /*   23461 */     GIR_EraseRootFromParent_Done,
     /*   23462 */   // Label 457: @23462
     /*   23462 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23517), // Rule ID 46399 //
     /*   23467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23495 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   23498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23515 */     GIR_RootConstrainSelectedInstOperands,
     /*   23516 */     // GIR_Coverage, 46399,
     /*   23516 */     GIR_EraseRootFromParent_Done,
     /*   23517 */   // Label 458: @23517
     /*   23517 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23572), // Rule ID 46518 //
     /*   23522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23550 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   23550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23570 */     GIR_RootConstrainSelectedInstOperands,
     /*   23571 */     // GIR_Coverage, 46518,
     /*   23571 */     GIR_EraseRootFromParent_Done,
     /*   23572 */   // Label 459: @23572
     /*   23572 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23627), // Rule ID 46519 //
     /*   23577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   23588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   23596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   23605 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   23605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   23608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   23612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   23616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   23622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23625 */     GIR_RootConstrainSelectedInstOperands,
     /*   23626 */     // GIR_Coverage, 46519,
     /*   23626 */     GIR_EraseRootFromParent_Done,
     /*   23627 */   // Label 460: @23627
     /*   23627 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23680), // Rule ID 46000 //
     /*   23632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   23635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23643 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   23643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   23646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   23660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23678 */     GIR_RootConstrainSelectedInstOperands,
     /*   23679 */     // GIR_Coverage, 46000,
     /*   23679 */     GIR_EraseRootFromParent_Done,
     /*   23680 */   // Label 461: @23680
     /*   23680 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23733), // Rule ID 46001 //
     /*   23685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   23688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23696 */     // (add:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   23696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   23699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   23703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   23708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   23710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   23713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   23718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   23720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   23722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   23731 */     GIR_RootConstrainSelectedInstOperands,
     /*   23732 */     // GIR_Coverage, 46001,
     /*   23732 */     GIR_EraseRootFromParent_Done,
     /*   23733 */   // Label 462: @23733
     /*   23733 */   GIM_Reject,
     /*   23734 */ // Label 422: @23734
     /*   23734 */ GIM_Reject,
     /*   23735 */ // Label 135: @23735
     /*   23735 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(26859),
     /*   23740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   23743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   23746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23750 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23846), // Rule ID 70485 //
     /*   23755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   23758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   23770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   23774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23788 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23807 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23820 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   23820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   23823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   23827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23844 */     GIR_RootConstrainSelectedInstOperands,
     /*   23845 */     // GIR_Coverage, 70485,
     /*   23845 */     GIR_EraseRootFromParent_Done,
     /*   23846 */   // Label 464: @23846
     /*   23846 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23942), // Rule ID 70486 //
     /*   23851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   23854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   23866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   23870 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23903 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   23905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   23914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   23916 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   23916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   23919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   23921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   23923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   23927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   23931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   23934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   23937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   23940 */     GIR_RootConstrainSelectedInstOperands,
     /*   23941 */     // GIR_Coverage, 70486,
     /*   23941 */     GIR_EraseRootFromParent_Done,
     /*   23942 */   // Label 465: @23942
     /*   23942 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(24038), // Rule ID 70769 //
     /*   23947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   23950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   23954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   23958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   23962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   23966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   23968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   23972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   23976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23980 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   23982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   23987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   23991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   23995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   23999 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24001 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24012 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24036 */     GIR_RootConstrainSelectedInstOperands,
     /*   24037 */     // GIR_Coverage, 70769,
     /*   24037 */     GIR_EraseRootFromParent_Done,
     /*   24038 */   // Label 466: @24038
     /*   24038 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(24134), // Rule ID 70770 //
     /*   24043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   24046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24062 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24083 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24087 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24091 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24095 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24097 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24108 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   24108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24132 */     GIR_RootConstrainSelectedInstOperands,
     /*   24133 */     // GIR_Coverage, 70770,
     /*   24133 */     GIR_EraseRootFromParent_Done,
     /*   24134 */   // Label 467: @24134
     /*   24134 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(24230), // Rule ID 70771 //
     /*   24139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   24142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24154 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24158 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24172 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24191 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24204 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   24215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   24219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24228 */     GIR_RootConstrainSelectedInstOperands,
     /*   24229 */     // GIR_Coverage, 70771,
     /*   24229 */     GIR_EraseRootFromParent_Done,
     /*   24230 */   // Label 468: @24230
     /*   24230 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(24326), // Rule ID 70772 //
     /*   24235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   24238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24268 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24283 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24287 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24289 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24300 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   24300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   24311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   24315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24324 */     GIR_RootConstrainSelectedInstOperands,
     /*   24325 */     // GIR_Coverage, 70772,
     /*   24325 */     GIR_EraseRootFromParent_Done,
     /*   24326 */   // Label 469: @24326
     /*   24326 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(24422), // Rule ID 70599 //
     /*   24331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   24334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24350 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24379 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24383 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24385 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24396 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   24399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24420 */     GIR_RootConstrainSelectedInstOperands,
     /*   24421 */     // GIR_Coverage, 70599,
     /*   24421 */     GIR_EraseRootFromParent_Done,
     /*   24422 */   // Label 470: @24422
     /*   24422 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24518), // Rule ID 70600 //
     /*   24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   24430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   24434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24460 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24475 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24479 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24481 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24492 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   24492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   24495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   24499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24516 */     GIR_RootConstrainSelectedInstOperands,
     /*   24517 */     // GIR_Coverage, 70600,
     /*   24517 */     GIR_EraseRootFromParent_Done,
     /*   24518 */   // Label 471: @24518
     /*   24518 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24614), // Rule ID 51930 //
     /*   24523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   24526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24579 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24581 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24588 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   24591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   24595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24612 */     GIR_RootConstrainSelectedInstOperands,
     /*   24613 */     // GIR_Coverage, 51930,
     /*   24613 */     GIR_EraseRootFromParent_Done,
     /*   24614 */   // Label 472: @24614
     /*   24614 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24710), // Rule ID 51931 //
     /*   24619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   24622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24656 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24675 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24677 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24684 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   24684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   24687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   24691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24708 */     GIR_RootConstrainSelectedInstOperands,
     /*   24709 */     // GIR_Coverage, 51931,
     /*   24709 */     GIR_EraseRootFromParent_Done,
     /*   24710 */   // Label 473: @24710
     /*   24710 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24806), // Rule ID 52048 //
     /*   24715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   24718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24752 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24767 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24771 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24773 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24780 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   24787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24804 */     GIR_RootConstrainSelectedInstOperands,
     /*   24805 */     // GIR_Coverage, 52048,
     /*   24805 */     GIR_EraseRootFromParent_Done,
     /*   24806 */   // Label 474: @24806
     /*   24806 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24902), // Rule ID 52049 //
     /*   24811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   24814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24867 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24876 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   24876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   24883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   24887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   24891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24900 */     GIR_RootConstrainSelectedInstOperands,
     /*   24901 */     // GIR_Coverage, 52049,
     /*   24901 */     GIR_EraseRootFromParent_Done,
     /*   24902 */   // Label 475: @24902
     /*   24902 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24998), // Rule ID 70767 //
     /*   24907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   24910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   24914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   24918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   24922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   24926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   24930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   24932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   24936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   24940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   24946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   24955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   24959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   24963 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   24965 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   24970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   24972 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   24972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   24975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   24977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   24979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   24983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   24987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   24990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   24993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   24996 */     GIR_RootConstrainSelectedInstOperands,
     /*   24997 */     // GIR_Coverage, 70767,
     /*   24997 */     GIR_EraseRootFromParent_Done,
     /*   24998 */   // Label 476: @24998
     /*   24998 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(25094), // Rule ID 70768 //
     /*   25003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   25006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   25022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   25026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25040 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25055 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25059 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25061 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25068 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   25068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   25071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   25079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   25083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25092 */     GIR_RootConstrainSelectedInstOperands,
     /*   25093 */     // GIR_Coverage, 70768,
     /*   25093 */     GIR_EraseRootFromParent_Done,
     /*   25094 */   // Label 477: @25094
     /*   25094 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(25190), // Rule ID 51988 //
     /*   25099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   25102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   25118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   25122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25155 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25162 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25164 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   25164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   25167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25188 */     GIR_RootConstrainSelectedInstOperands,
     /*   25189 */     // GIR_Coverage, 51988,
     /*   25189 */     GIR_EraseRootFromParent_Done,
     /*   25190 */   // Label 478: @25190
     /*   25190 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(25286), // Rule ID 51989 //
     /*   25195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   25198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   25206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   25214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   25218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   25224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   25243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25251 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   25253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25258 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   25260 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   25260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   25263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   25267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   25275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25284 */     GIR_RootConstrainSelectedInstOperands,
     /*   25285 */     // GIR_Coverage, 51989,
     /*   25285 */     GIR_EraseRootFromParent_Done,
     /*   25286 */   // Label 479: @25286
     /*   25286 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(25375), // Rule ID 46598 //
     /*   25291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   25294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   25302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25306 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   25321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25325 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25327 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25334 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   25334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   25351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25373 */     GIR_RootConstrainSelectedInstOperands,
     /*   25374 */     // GIR_Coverage, 46598,
     /*   25374 */     GIR_EraseRootFromParent_Done,
     /*   25375 */   // Label 480: @25375
     /*   25375 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(25464), // Rule ID 46599 //
     /*   25380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   25383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   25391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25395 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   25410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25414 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25423 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   25423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   25440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25462 */     GIR_RootConstrainSelectedInstOperands,
     /*   25463 */     // GIR_Coverage, 46599,
     /*   25463 */     GIR_EraseRootFromParent_Done,
     /*   25464 */   // Label 481: @25464
     /*   25464 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(25553), // Rule ID 46362 //
     /*   25469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   25472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25484 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25499 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25503 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25512 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   25512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   25529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25551 */     GIR_RootConstrainSelectedInstOperands,
     /*   25552 */     // GIR_Coverage, 46362,
     /*   25552 */     GIR_EraseRootFromParent_Done,
     /*   25553 */   // Label 482: @25553
     /*   25553 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(25642), // Rule ID 46363 //
     /*   25558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   25561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25573 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   25588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25592 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25594 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25601 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   25601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   25618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25640 */     GIR_RootConstrainSelectedInstOperands,
     /*   25641 */     // GIR_Coverage, 46363,
     /*   25641 */     GIR_EraseRootFromParent_Done,
     /*   25642 */   // Label 483: @25642
     /*   25642 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(25731), // Rule ID 46478 //
     /*   25647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   25650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25681 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25683 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25690 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   25690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   25707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25729 */     GIR_RootConstrainSelectedInstOperands,
     /*   25730 */     // GIR_Coverage, 46478,
     /*   25730 */     GIR_EraseRootFromParent_Done,
     /*   25731 */   // Label 484: @25731
     /*   25731 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(25820), // Rule ID 46479 //
     /*   25736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   25739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25751 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   25762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   25766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25770 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   25772 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25777 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   25779 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   25779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   25782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   25786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   25791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   25793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   25796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   25801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   25805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   25809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   25815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   25818 */     GIR_RootConstrainSelectedInstOperands,
     /*   25819 */     // GIR_Coverage, 46479,
     /*   25819 */     GIR_EraseRootFromParent_Done,
     /*   25820 */   // Label 485: @25820
     /*   25820 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(25888), // Rule ID 70395 //
     /*   25825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   25828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   25840 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   25844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25862 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   25862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   25865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   25871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25886 */     GIR_RootConstrainSelectedInstOperands,
     /*   25887 */     // GIR_Coverage, 70395,
     /*   25887 */     GIR_EraseRootFromParent_Done,
     /*   25888 */   // Label 486: @25888
     /*   25888 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(25956), // Rule ID 70396 //
     /*   25893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   25896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   25904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   25908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   25912 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25930 */     // (add:{ *:[nxv2i64] } (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   25930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   25933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   25939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   25943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   25948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   25951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   25954 */     GIR_RootConstrainSelectedInstOperands,
     /*   25955 */     // GIR_Coverage, 70396,
     /*   25955 */     GIR_EraseRootFromParent_Done,
     /*   25956 */   // Label 487: @25956
     /*   25956 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(26011), // Rule ID 69307 //
     /*   25961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   25964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   25968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   25972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   25976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   25978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   25983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   25987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   25989 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   25989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   25992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   25994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   25996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26009 */     GIR_RootConstrainSelectedInstOperands,
     /*   26010 */     // GIR_Coverage, 69307,
     /*   26010 */     GIR_EraseRootFromParent_Done,
     /*   26011 */   // Label 488: @26011
     /*   26011 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(26066), // Rule ID 69308 //
     /*   26016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26031 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26044 */     // (add:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26064 */     GIR_RootConstrainSelectedInstOperands,
     /*   26065 */     // GIR_Coverage, 69308,
     /*   26065 */     GIR_EraseRootFromParent_Done,
     /*   26066 */   // Label 489: @26066
     /*   26066 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(26121), // Rule ID 69127 //
     /*   26071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   26074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26099 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   26102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26119 */     GIR_RootConstrainSelectedInstOperands,
     /*   26120 */     // GIR_Coverage, 69127,
     /*   26120 */     GIR_EraseRootFromParent_Done,
     /*   26121 */   // Label 490: @26121
     /*   26121 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(26176), // Rule ID 69128 //
     /*   26126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26154 */     // (add:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   26157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26174 */     GIR_RootConstrainSelectedInstOperands,
     /*   26175 */     // GIR_Coverage, 69128,
     /*   26175 */     GIR_EraseRootFromParent_Done,
     /*   26176 */   // Label 491: @26176
     /*   26176 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(26231), // Rule ID 69217 //
     /*   26181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   26184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26196 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26209 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26229 */     GIR_RootConstrainSelectedInstOperands,
     /*   26230 */     // GIR_Coverage, 69217,
     /*   26230 */     GIR_EraseRootFromParent_Done,
     /*   26231 */   // Label 492: @26231
     /*   26231 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(26286), // Rule ID 69218 //
     /*   26236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26264 */     // (add:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26284 */     GIR_RootConstrainSelectedInstOperands,
     /*   26285 */     // GIR_Coverage, 69218,
     /*   26285 */     GIR_EraseRootFromParent_Done,
     /*   26286 */   // Label 493: @26286
     /*   26286 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(26354), // Rule ID 51808 //
     /*   26291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   26294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   26310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   26314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26328 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   26328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   26331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   26349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26352 */     GIR_RootConstrainSelectedInstOperands,
     /*   26353 */     // GIR_Coverage, 51808,
     /*   26353 */     GIR_EraseRootFromParent_Done,
     /*   26354 */   // Label 494: @26354
     /*   26354 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(26422), // Rule ID 51809 //
     /*   26359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   26362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   26378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   26382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26396 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   26396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   26399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   26417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26420 */     GIR_RootConstrainSelectedInstOperands,
     /*   26421 */     // GIR_Coverage, 51809,
     /*   26421 */     GIR_EraseRootFromParent_Done,
     /*   26422 */   // Label 495: @26422
     /*   26422 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(26477), // Rule ID 46658 //
     /*   26427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   26430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26455 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26475 */     GIR_RootConstrainSelectedInstOperands,
     /*   26476 */     // GIR_Coverage, 46658,
     /*   26476 */     GIR_EraseRootFromParent_Done,
     /*   26477 */   // Label 496: @26477
     /*   26477 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(26532), // Rule ID 46659 //
     /*   26482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   26497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26510 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26530 */     GIR_RootConstrainSelectedInstOperands,
     /*   26531 */     // GIR_Coverage, 46659,
     /*   26531 */     GIR_EraseRootFromParent_Done,
     /*   26532 */   // Label 497: @26532
     /*   26532 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(26587), // Rule ID 46418 //
     /*   26537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   26540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26565 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   26568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26585 */     GIR_RootConstrainSelectedInstOperands,
     /*   26586 */     // GIR_Coverage, 46418,
     /*   26586 */     GIR_EraseRootFromParent_Done,
     /*   26587 */   // Label 498: @26587
     /*   26587 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(26642), // Rule ID 46419 //
     /*   26592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   26607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26620 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   26623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26640 */     GIR_RootConstrainSelectedInstOperands,
     /*   26641 */     // GIR_Coverage, 46419,
     /*   26641 */     GIR_EraseRootFromParent_Done,
     /*   26642 */   // Label 499: @26642
     /*   26642 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(26697), // Rule ID 46538 //
     /*   26647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   26650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26675 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   26675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26695 */     GIR_RootConstrainSelectedInstOperands,
     /*   26696 */     // GIR_Coverage, 46538,
     /*   26696 */     GIR_EraseRootFromParent_Done,
     /*   26697 */   // Label 500: @26697
     /*   26697 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(26752), // Rule ID 46539 //
     /*   26702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   26705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   26713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   26717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   26721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26730 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   26730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   26733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   26737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   26747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26750 */     GIR_RootConstrainSelectedInstOperands,
     /*   26751 */     // GIR_Coverage, 46539,
     /*   26751 */     GIR_EraseRootFromParent_Done,
     /*   26752 */   // Label 501: @26752
     /*   26752 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(26805), // Rule ID 46044 //
     /*   26757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   26760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26768 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   26768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   26771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   26785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   26800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26803 */     GIR_RootConstrainSelectedInstOperands,
     /*   26804 */     // GIR_Coverage, 46044,
     /*   26804 */     GIR_EraseRootFromParent_Done,
     /*   26805 */   // Label 502: @26805
     /*   26805 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(26858), // Rule ID 46045 //
     /*   26810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   26813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   26821 */     // (add:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   26821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   26824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   26828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   26833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   26835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   26838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   26843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   26845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   26853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26856 */     GIR_RootConstrainSelectedInstOperands,
     /*   26857 */     // GIR_Coverage, 46045,
     /*   26857 */     GIR_EraseRootFromParent_Done,
     /*   26858 */   // Label 503: @26858
     /*   26858 */   GIM_Reject,
     /*   26859 */ // Label 463: @26859
     /*   26859 */ GIM_Reject,
     /*   26860 */ // Label 136: @26860
     /*   26860 */ GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(27254),
     /*   26865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   26868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   26871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26875 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(26943), // Rule ID 70259 //
     /*   26880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   26883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   26895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   26899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26917 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   26917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   26920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   26932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   26935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   26938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   26941 */     GIR_RootConstrainSelectedInstOperands,
     /*   26942 */     // GIR_Coverage, 70259,
     /*   26942 */     GIR_EraseRootFromParent_Done,
     /*   26943 */   // Label 505: @26943
     /*   26943 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(27011), // Rule ID 70260 //
     /*   26948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   26951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   26955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   26959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   26963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   26967 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   26969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   26983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   26985 */     // (add:{ *:[nxv4i8] } (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   26985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   26988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   26990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   26994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   26998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27009 */     GIR_RootConstrainSelectedInstOperands,
     /*   27010 */     // GIR_Coverage, 70260,
     /*   27010 */     GIR_EraseRootFromParent_Done,
     /*   27011 */   // Label 506: @27011
     /*   27011 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(27079), // Rule ID 51740 //
     /*   27016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   27039 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27053 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   27053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   27056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27077 */     GIR_RootConstrainSelectedInstOperands,
     /*   27078 */     // GIR_Coverage, 51740,
     /*   27078 */     GIR_EraseRootFromParent_Done,
     /*   27079 */   // Label 507: @27079
     /*   27079 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(27147), // Rule ID 51741 //
     /*   27084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   27095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   27107 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   27121 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   27121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /*   27124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   27130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   27134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   27136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27145 */     GIR_RootConstrainSelectedInstOperands,
     /*   27146 */     // GIR_Coverage, 51741,
     /*   27146 */     GIR_EraseRootFromParent_Done,
     /*   27147 */   // Label 508: @27147
     /*   27147 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(27200), // Rule ID 45976 //
     /*   27152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27163 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   27163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   27166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   27180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27198 */     GIR_RootConstrainSelectedInstOperands,
     /*   27199 */     // GIR_Coverage, 45976,
     /*   27199 */     GIR_EraseRootFromParent_Done,
     /*   27200 */   // Label 509: @27200
     /*   27200 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(27253), // Rule ID 45977 //
     /*   27205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27216 */     // (add:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   27216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   27219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   27223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   27228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   27230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*   27233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   27238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   27240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   27242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27251 */     GIR_RootConstrainSelectedInstOperands,
     /*   27252 */     // GIR_Coverage, 45977,
     /*   27252 */     GIR_EraseRootFromParent_Done,
     /*   27253 */   // Label 510: @27253
     /*   27253 */   GIM_Reject,
     /*   27254 */ // Label 504: @27254
     /*   27254 */ GIM_Reject,
     /*   27255 */ // Label 137: @27255
     /*   27255 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(30379),
     /*   27260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27270 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(27366), // Rule ID 70465 //
     /*   27275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27294 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27319 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27323 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27327 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27329 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27340 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   27340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   27343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27364 */     GIR_RootConstrainSelectedInstOperands,
     /*   27365 */     // GIR_Coverage, 70465,
     /*   27365 */     GIR_EraseRootFromParent_Done,
     /*   27366 */   // Label 512: @27366
     /*   27366 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(27462), // Rule ID 70466 //
     /*   27371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27390 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27404 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27419 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27423 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27436 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   27436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   27439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27460 */     GIR_RootConstrainSelectedInstOperands,
     /*   27461 */     // GIR_Coverage, 70466,
     /*   27461 */     GIR_EraseRootFromParent_Done,
     /*   27462 */   // Label 513: @27462
     /*   27462 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(27558), // Rule ID 70709 //
     /*   27467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27500 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27502 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27507 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27511 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27515 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27519 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27521 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27532 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   27532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   27535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27556 */     GIR_RootConstrainSelectedInstOperands,
     /*   27557 */     // GIR_Coverage, 70709,
     /*   27557 */     GIR_EraseRootFromParent_Done,
     /*   27558 */   // Label 514: @27558
     /*   27558 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(27654), // Rule ID 70710 //
     /*   27563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27582 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27603 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27607 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27611 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27615 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27617 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27626 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27628 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   27628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   27631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27652 */     GIR_RootConstrainSelectedInstOperands,
     /*   27653 */     // GIR_Coverage, 70710,
     /*   27653 */     GIR_EraseRootFromParent_Done,
     /*   27654 */   // Label 515: @27654
     /*   27654 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(27750), // Rule ID 70711 //
     /*   27659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27692 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27711 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27713 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27722 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27724 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   27724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   27727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   27735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   27739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27748 */     GIR_RootConstrainSelectedInstOperands,
     /*   27749 */     // GIR_Coverage, 70711,
     /*   27749 */     GIR_EraseRootFromParent_Done,
     /*   27750 */   // Label 516: @27750
     /*   27750 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(27846), // Rule ID 70712 //
     /*   27755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27788 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   27803 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27807 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27809 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27820 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   27820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   27823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   27831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   27835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27844 */     GIR_RootConstrainSelectedInstOperands,
     /*   27845 */     // GIR_Coverage, 70712,
     /*   27845 */     GIR_EraseRootFromParent_Done,
     /*   27846 */   // Label 517: @27846
     /*   27846 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(27942), // Rule ID 70579 //
     /*   27851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   27854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27870 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27884 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27899 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27903 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   27905 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   27916 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   27916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   27919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   27921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   27923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   27927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   27931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   27934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   27937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   27940 */     GIR_RootConstrainSelectedInstOperands,
     /*   27941 */     // GIR_Coverage, 70579,
     /*   27941 */     GIR_EraseRootFromParent_Done,
     /*   27942 */   // Label 518: @27942
     /*   27942 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(28038), // Rule ID 70580 //
     /*   27947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   27950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   27954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   27958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   27962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   27966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   27968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   27972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27980 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   27982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   27987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   27991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   27995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   27999 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28001 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28012 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rd)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   28012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   28015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   28019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28036 */     GIR_RootConstrainSelectedInstOperands,
     /*   28037 */     // GIR_Coverage, 70580,
     /*   28037 */     GIR_EraseRootFromParent_Done,
     /*   28038 */   // Label 519: @28038
     /*   28038 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(28134), // Rule ID 51910 //
     /*   28043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28046 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28066 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28076 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28080 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28082 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28095 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28099 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28101 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28108 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   28108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   28111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28132 */     GIR_RootConstrainSelectedInstOperands,
     /*   28133 */     // GIR_Coverage, 51910,
     /*   28133 */     GIR_EraseRootFromParent_Done,
     /*   28134 */   // Label 520: @28134
     /*   28134 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(28230), // Rule ID 51911 //
     /*   28139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28176 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28178 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28183 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28187 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28191 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28195 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28197 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28202 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28204 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   28204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /*   28207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28228 */     GIR_RootConstrainSelectedInstOperands,
     /*   28229 */     // GIR_Coverage, 51911,
     /*   28229 */     GIR_EraseRootFromParent_Done,
     /*   28230 */   // Label 521: @28230
     /*   28230 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(28326), // Rule ID 52028 //
     /*   28235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28272 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28283 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28287 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28291 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28300 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   28300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   28303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28324 */     GIR_RootConstrainSelectedInstOperands,
     /*   28325 */     // GIR_Coverage, 52028,
     /*   28325 */     GIR_EraseRootFromParent_Done,
     /*   28326 */   // Label 522: @28326
     /*   28326 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(28422), // Rule ID 52029 //
     /*   28331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28354 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28368 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28387 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28389 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28394 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28396 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   28396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   28399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28420 */     GIR_RootConstrainSelectedInstOperands,
     /*   28421 */     // GIR_Coverage, 52029,
     /*   28421 */     GIR_EraseRootFromParent_Done,
     /*   28422 */   // Label 523: @28422
     /*   28422 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(28518), // Rule ID 70707 //
     /*   28427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28446 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28450 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28464 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28479 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28483 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28485 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28492 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   28492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   28495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28516 */     GIR_RootConstrainSelectedInstOperands,
     /*   28517 */     // GIR_Coverage, 70707,
     /*   28517 */     GIR_EraseRootFromParent_Done,
     /*   28518 */   // Label 524: @28518
     /*   28518 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(28614), // Rule ID 70708 //
     /*   28523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28567 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28571 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   28575 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28579 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28581 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28588 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   28588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /*   28591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   28599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   28603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28612 */     GIR_RootConstrainSelectedInstOperands,
     /*   28613 */     // GIR_Coverage, 70708,
     /*   28613 */     GIR_EraseRootFromParent_Done,
     /*   28614 */   // Label 525: @28614
     /*   28614 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(28710), // Rule ID 51968 //
     /*   28619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28656 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28675 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28677 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28684 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   28684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   28687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28708 */     GIR_RootConstrainSelectedInstOperands,
     /*   28709 */     // GIR_Coverage, 51968,
     /*   28709 */     GIR_EraseRootFromParent_Done,
     /*   28710 */   // Label 526: @28710
     /*   28710 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(28806), // Rule ID 51969 //
     /*   28715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   28726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   28730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   28734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   28738 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   28744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28752 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28754 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28759 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   28763 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   28767 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28771 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   28773 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28778 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   28780 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   28780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /*   28783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   28787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   28795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   28804 */     GIR_RootConstrainSelectedInstOperands,
     /*   28805 */     // GIR_Coverage, 51969,
     /*   28805 */     GIR_EraseRootFromParent_Done,
     /*   28806 */   // Label 527: @28806
     /*   28806 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(28895), // Rule ID 46558 //
     /*   28811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   28822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28826 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   28837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   28841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28854 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   28854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   28857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   28871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   28880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28893 */     GIR_RootConstrainSelectedInstOperands,
     /*   28894 */     // GIR_Coverage, 46558,
     /*   28894 */     GIR_EraseRootFromParent_Done,
     /*   28895 */   // Label 528: @28895
     /*   28895 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(28984), // Rule ID 46559 //
     /*   28900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   28903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   28911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28915 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   28917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   28926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   28930 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   28934 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   28936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   28941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   28943 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   28943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   28946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   28950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   28955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   28957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   28960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   28962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   28965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   28969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   28973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   28976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   28982 */     GIR_RootConstrainSelectedInstOperands,
     /*   28983 */     // GIR_Coverage, 46559,
     /*   28983 */     GIR_EraseRootFromParent_Done,
     /*   28984 */   // Label 529: @28984
     /*   28984 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(29073), // Rule ID 46322 //
     /*   28989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   28992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   28996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29004 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29023 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29025 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29030 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29032 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   29032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   29035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   29049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29071 */     GIR_RootConstrainSelectedInstOperands,
     /*   29072 */     // GIR_Coverage, 46322,
     /*   29072 */     GIR_EraseRootFromParent_Done,
     /*   29073 */   // Label 530: @29073
     /*   29073 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(29162), // Rule ID 46323 //
     /*   29078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29093 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29112 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29121 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   29121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   29124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*   29138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29160 */     GIR_RootConstrainSelectedInstOperands,
     /*   29161 */     // GIR_Coverage, 46323,
     /*   29161 */     GIR_EraseRootFromParent_Done,
     /*   29162 */   // Label 531: @29162
     /*   29162 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(29251), // Rule ID 46438 //
     /*   29167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29201 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29210 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   29210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   29213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   29227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29249 */     GIR_RootConstrainSelectedInstOperands,
     /*   29250 */     // GIR_Coverage, 46438,
     /*   29250 */     GIR_EraseRootFromParent_Done,
     /*   29251 */   // Label 532: @29251
     /*   29251 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(29340), // Rule ID 46439 //
     /*   29256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29278 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   29282 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29286 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29290 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   29292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   29299 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   29299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   29302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   29306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   29311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   29313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*   29316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   29321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   29325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   29329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29338 */     GIR_RootConstrainSelectedInstOperands,
     /*   29339 */     // GIR_Coverage, 46439,
     /*   29339 */     GIR_EraseRootFromParent_Done,
     /*   29340 */   // Label 533: @29340
     /*   29340 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(29408), // Rule ID 70299 //
     /*   29345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   29360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   29364 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29382 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   29382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   29385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29406 */     GIR_RootConstrainSelectedInstOperands,
     /*   29407 */     // GIR_Coverage, 70299,
     /*   29407 */     GIR_EraseRootFromParent_Done,
     /*   29408 */   // Label 534: @29408
     /*   29408 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(29476), // Rule ID 70300 //
     /*   29413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   29428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   29432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29450 */     // (add:{ *:[nxv4i16] } (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   29450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   29453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29474 */     GIR_RootConstrainSelectedInstOperands,
     /*   29475 */     // GIR_Coverage, 70300,
     /*   29475 */     GIR_EraseRootFromParent_Done,
     /*   29476 */   // Label 535: @29476
     /*   29476 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(29531), // Rule ID 69267 //
     /*   29481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29496 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29509 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   29509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   29512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29529 */     GIR_RootConstrainSelectedInstOperands,
     /*   29530 */     // GIR_Coverage, 69267,
     /*   29530 */     GIR_EraseRootFromParent_Done,
     /*   29531 */   // Label 536: @29531
     /*   29531 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(29586), // Rule ID 69268 //
     /*   29536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29551 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29564 */     // (add:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   29564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   29567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29584 */     GIR_RootConstrainSelectedInstOperands,
     /*   29585 */     // GIR_Coverage, 69268,
     /*   29585 */     GIR_EraseRootFromParent_Done,
     /*   29586 */   // Label 537: @29586
     /*   29586 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(29641), // Rule ID 69087 //
     /*   29591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29619 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   29619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   29622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29639 */     GIR_RootConstrainSelectedInstOperands,
     /*   29640 */     // GIR_Coverage, 69087,
     /*   29640 */     GIR_EraseRootFromParent_Done,
     /*   29641 */   // Label 538: @29641
     /*   29641 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(29696), // Rule ID 69088 //
     /*   29646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   29657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29661 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29674 */     // (add:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   29674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   29677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29694 */     GIR_RootConstrainSelectedInstOperands,
     /*   29695 */     // GIR_Coverage, 69088,
     /*   29695 */     GIR_EraseRootFromParent_Done,
     /*   29696 */   // Label 539: @29696
     /*   29696 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(29751), // Rule ID 69177 //
     /*   29701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29716 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29729 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   29729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   29732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29749 */     GIR_RootConstrainSelectedInstOperands,
     /*   29750 */     // GIR_Coverage, 69177,
     /*   29750 */     GIR_EraseRootFromParent_Done,
     /*   29751 */   // Label 540: @29751
     /*   29751 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(29806), // Rule ID 69178 //
     /*   29756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   29763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   29767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29771 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29784 */     // (add:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   29784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   29787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   29791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29804 */     GIR_RootConstrainSelectedInstOperands,
     /*   29805 */     // GIR_Coverage, 69178,
     /*   29805 */     GIR_EraseRootFromParent_Done,
     /*   29806 */   // Label 541: @29806
     /*   29806 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(29874), // Rule ID 51760 //
     /*   29811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   29830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   29834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29848 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   29848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   29851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   29863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29872 */     GIR_RootConstrainSelectedInstOperands,
     /*   29873 */     // GIR_Coverage, 51760,
     /*   29873 */     GIR_EraseRootFromParent_Done,
     /*   29874 */   // Label 542: @29874
     /*   29874 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(29942), // Rule ID 51761 //
     /*   29879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   29882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   29894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   29898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   29902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29916 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   29916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   29919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   29925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   29931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   29937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29940 */     GIR_RootConstrainSelectedInstOperands,
     /*   29941 */     // GIR_Coverage, 51761,
     /*   29941 */     GIR_EraseRootFromParent_Done,
     /*   29942 */   // Label 543: @29942
     /*   29942 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(29997), // Rule ID 46618 //
     /*   29947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   29950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   29958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   29962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   29966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   29968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   29973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   29975 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   29975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   29978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   29980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   29982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   29986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   29989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   29992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   29995 */     GIR_RootConstrainSelectedInstOperands,
     /*   29996 */     // GIR_Coverage, 46618,
     /*   29996 */     GIR_EraseRootFromParent_Done,
     /*   29997 */   // Label 544: @29997
     /*   29997 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(30052), // Rule ID 46619 //
     /*   30002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   30017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30030 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   30030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   30033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30050 */     GIR_RootConstrainSelectedInstOperands,
     /*   30051 */     // GIR_Coverage, 46619,
     /*   30051 */     GIR_EraseRootFromParent_Done,
     /*   30052 */   // Label 545: @30052
     /*   30052 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(30107), // Rule ID 46378 //
     /*   30057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30085 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   30085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   30088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30105 */     GIR_RootConstrainSelectedInstOperands,
     /*   30106 */     // GIR_Coverage, 46378,
     /*   30106 */     GIR_EraseRootFromParent_Done,
     /*   30107 */   // Label 546: @30107
     /*   30107 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(30162), // Rule ID 46379 //
     /*   30112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30131 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30140 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   30140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*   30143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30160 */     GIR_RootConstrainSelectedInstOperands,
     /*   30161 */     // GIR_Coverage, 46379,
     /*   30161 */     GIR_EraseRootFromParent_Done,
     /*   30162 */   // Label 547: @30162
     /*   30162 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(30217), // Rule ID 46498 //
     /*   30167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30186 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30195 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   30195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   30198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30215 */     GIR_RootConstrainSelectedInstOperands,
     /*   30216 */     // GIR_Coverage, 46498,
     /*   30216 */     GIR_EraseRootFromParent_Done,
     /*   30217 */   // Label 548: @30217
     /*   30217 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(30272), // Rule ID 46499 //
     /*   30222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   30233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   30241 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   30250 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   30250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*   30253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   30257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   30261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30270 */     GIR_RootConstrainSelectedInstOperands,
     /*   30271 */     // GIR_Coverage, 46499,
     /*   30271 */     GIR_EraseRootFromParent_Done,
     /*   30272 */   // Label 549: @30272
     /*   30272 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(30325), // Rule ID 45996 //
     /*   30277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30288 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   30288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   30291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   30305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30323 */     GIR_RootConstrainSelectedInstOperands,
     /*   30324 */     // GIR_Coverage, 45996,
     /*   30324 */     GIR_EraseRootFromParent_Done,
     /*   30325 */   // Label 550: @30325
     /*   30325 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(30378), // Rule ID 45997 //
     /*   30330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30341 */     // (add:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   30341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   30344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   30348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   30353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   30355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   30358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   30363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   30365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   30367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   30376 */     GIR_RootConstrainSelectedInstOperands,
     /*   30377 */     // GIR_Coverage, 45997,
     /*   30377 */     GIR_EraseRootFromParent_Done,
     /*   30378 */   // Label 551: @30378
     /*   30378 */   GIM_Reject,
     /*   30379 */ // Label 511: @30379
     /*   30379 */ GIM_Reject,
     /*   30380 */ // Label 138: @30380
     /*   30380 */ GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(33504),
     /*   30385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30395 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(30491), // Rule ID 70477 //
     /*   30400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30415 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30419 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30440 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30444 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30448 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30452 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30454 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30465 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   30465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   30468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   30480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30489 */     GIR_RootConstrainSelectedInstOperands,
     /*   30490 */     // GIR_Coverage, 70477,
     /*   30490 */     GIR_EraseRootFromParent_Done,
     /*   30491 */   // Label 553: @30491
     /*   30491 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(30587), // Rule ID 70478 //
     /*   30496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30515 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30548 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30550 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30559 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30561 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   30561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   30564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   30576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30585 */     GIR_RootConstrainSelectedInstOperands,
     /*   30586 */     // GIR_Coverage, 70478,
     /*   30586 */     GIR_EraseRootFromParent_Done,
     /*   30587 */   // Label 554: @30587
     /*   30587 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(30683), // Rule ID 70745 //
     /*   30592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30632 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30636 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30640 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30644 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30646 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30657 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   30657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   30660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   30672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30681 */     GIR_RootConstrainSelectedInstOperands,
     /*   30682 */     // GIR_Coverage, 70745,
     /*   30682 */     GIR_EraseRootFromParent_Done,
     /*   30683 */   // Label 555: @30683
     /*   30683 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(30779), // Rule ID 70746 //
     /*   30688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30707 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30721 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30740 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30742 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30751 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30753 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   30753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   30756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   30764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   30768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30777 */     GIR_RootConstrainSelectedInstOperands,
     /*   30778 */     // GIR_Coverage, 70746,
     /*   30778 */     GIR_EraseRootFromParent_Done,
     /*   30779 */   // Label 556: @30779
     /*   30779 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(30875), // Rule ID 70747 //
     /*   30784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30803 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30836 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30838 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30849 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   30849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   30852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   30860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   30864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30873 */     GIR_RootConstrainSelectedInstOperands,
     /*   30874 */     // GIR_Coverage, 70747,
     /*   30874 */     GIR_EraseRootFromParent_Done,
     /*   30875 */   // Label 557: @30875
     /*   30875 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(30971), // Rule ID 70748 //
     /*   30880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   30883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   30905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   30909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30913 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   30915 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30920 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   30924 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   30928 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   30932 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   30934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   30939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   30943 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   30945 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   30945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   30948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   30950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   30952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   30956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   30960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   30963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   30966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   30969 */     GIR_RootConstrainSelectedInstOperands,
     /*   30970 */     // GIR_Coverage, 70748,
     /*   30970 */     GIR_EraseRootFromParent_Done,
     /*   30971 */   // Label 558: @30971
     /*   30971 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(31067), // Rule ID 70591 //
     /*   30976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   30979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   30983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   30987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   30991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   30995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   30997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31009 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31028 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31030 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31039 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31041 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   31041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   31044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31065 */     GIR_RootConstrainSelectedInstOperands,
     /*   31066 */     // GIR_Coverage, 70591,
     /*   31066 */     GIR_EraseRootFromParent_Done,
     /*   31067 */   // Label 559: @31067
     /*   31067 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(31163), // Rule ID 70592 //
     /*   31072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31105 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31120 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31124 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31126 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31135 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31137 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   31137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   31140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   31144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31161 */     GIR_RootConstrainSelectedInstOperands,
     /*   31162 */     // GIR_Coverage, 70592,
     /*   31162 */     GIR_EraseRootFromParent_Done,
     /*   31163 */   // Label 560: @31163
     /*   31163 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(31259), // Rule ID 51922 //
     /*   31168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31205 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31212 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31216 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31220 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31224 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31226 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31231 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31233 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   31233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   31236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31257 */     GIR_RootConstrainSelectedInstOperands,
     /*   31258 */     // GIR_Coverage, 51922,
     /*   31258 */     GIR_EraseRootFromParent_Done,
     /*   31259 */   // Label 561: @31259
     /*   31259 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(31355), // Rule ID 51923 //
     /*   31264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31283 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31287 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31301 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31320 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31322 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31327 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31329 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   31329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   31332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31353 */     GIR_RootConstrainSelectedInstOperands,
     /*   31354 */     // GIR_Coverage, 51923,
     /*   31354 */     GIR_EraseRootFromParent_Done,
     /*   31355 */   // Label 562: @31355
     /*   31355 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(31451), // Rule ID 52040 //
     /*   31360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31379 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31383 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31412 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31416 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31423 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31425 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   31425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   31428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31449 */     GIR_RootConstrainSelectedInstOperands,
     /*   31450 */     // GIR_Coverage, 52040,
     /*   31450 */     GIR_EraseRootFromParent_Done,
     /*   31451 */   // Label 563: @31451
     /*   31451 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(31547), // Rule ID 52041 //
     /*   31456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31493 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31512 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31514 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31519 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31521 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   31521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   31524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31545 */     GIR_RootConstrainSelectedInstOperands,
     /*   31546 */     // GIR_Coverage, 52041,
     /*   31546 */     GIR_EraseRootFromParent_Done,
     /*   31547 */   // Label 564: @31547
     /*   31547 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(31643), // Rule ID 70743 //
     /*   31552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31575 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31589 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31608 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31615 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31617 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   31617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   31620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31641 */     GIR_RootConstrainSelectedInstOperands,
     /*   31642 */     // GIR_Coverage, 70743,
     /*   31642 */     GIR_EraseRootFromParent_Done,
     /*   31643 */   // Label 565: @31643
     /*   31643 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(31739), // Rule ID 70744 //
     /*   31648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   31700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31704 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31706 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31711 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31713 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   31713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   31716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   31724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   31728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31737 */     GIR_RootConstrainSelectedInstOperands,
     /*   31738 */     // GIR_Coverage, 70744,
     /*   31738 */     GIR_EraseRootFromParent_Done,
     /*   31739 */   // Label 566: @31739
     /*   31739 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(31835), // Rule ID 51980 //
     /*   31744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31781 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31800 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31809 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   31809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   31812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31833 */     GIR_RootConstrainSelectedInstOperands,
     /*   31834 */     // GIR_Coverage, 51980,
     /*   31834 */     GIR_EraseRootFromParent_Done,
     /*   31835 */   // Label 567: @31835
     /*   31835 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(31931), // Rule ID 51981 //
     /*   31840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   31843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   31847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   31851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   31855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   31859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   31863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   31869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   31888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   31892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31896 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   31898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31903 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   31905 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   31905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   31908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   31912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   31916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   31920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   31923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   31926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   31929 */     GIR_RootConstrainSelectedInstOperands,
     /*   31930 */     // GIR_Coverage, 51981,
     /*   31930 */     GIR_EraseRootFromParent_Done,
     /*   31931 */   // Label 568: @31931
     /*   31931 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(32020), // Rule ID 46582 //
     /*   31936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   31939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   31943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31951 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   31953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   31962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   31966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   31970 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   31972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   31977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   31979 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   31979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   31982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   31986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   31991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   31993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   31996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   31998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32018 */     GIR_RootConstrainSelectedInstOperands,
     /*   32019 */     // GIR_Coverage, 46582,
     /*   32019 */     GIR_EraseRootFromParent_Done,
     /*   32020 */   // Label 569: @32020
     /*   32020 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(32109), // Rule ID 46583 //
     /*   32025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32047 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32051 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32055 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32059 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32061 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32068 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   32068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   32085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32107 */     GIR_RootConstrainSelectedInstOperands,
     /*   32108 */     // GIR_Coverage, 46583,
     /*   32108 */     GIR_EraseRootFromParent_Done,
     /*   32109 */   // Label 570: @32109
     /*   32109 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(32198), // Rule ID 46346 //
     /*   32114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32129 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32144 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32148 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32157 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   32157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   32174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32196 */     GIR_RootConstrainSelectedInstOperands,
     /*   32197 */     // GIR_Coverage, 46346,
     /*   32197 */     GIR_EraseRootFromParent_Done,
     /*   32198 */   // Label 571: @32198
     /*   32198 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(32287), // Rule ID 46347 //
     /*   32203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32237 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32246 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   32246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   32263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32285 */     GIR_RootConstrainSelectedInstOperands,
     /*   32286 */     // GIR_Coverage, 46347,
     /*   32286 */     GIR_EraseRootFromParent_Done,
     /*   32287 */   // Label 572: @32287
     /*   32287 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(32376), // Rule ID 46462 //
     /*   32292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32326 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32335 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   32335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   32352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32374 */     GIR_RootConstrainSelectedInstOperands,
     /*   32375 */     // GIR_Coverage, 46462,
     /*   32375 */     GIR_EraseRootFromParent_Done,
     /*   32376 */   // Label 573: @32376
     /*   32376 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(32465), // Rule ID 46463 //
     /*   32381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32396 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   32407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32415 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   32417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   32424 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   32424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   32427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   32431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   32436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   32438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   32441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   32446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   32450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   32454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   32463 */     GIR_RootConstrainSelectedInstOperands,
     /*   32464 */     // GIR_Coverage, 46463,
     /*   32464 */     GIR_EraseRootFromParent_Done,
     /*   32465 */   // Label 574: @32465
     /*   32465 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(32533), // Rule ID 70371 //
     /*   32470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   32485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   32489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32507 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   32507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   32510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   32516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   32528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32531 */     GIR_RootConstrainSelectedInstOperands,
     /*   32532 */     // GIR_Coverage, 70371,
     /*   32532 */     GIR_EraseRootFromParent_Done,
     /*   32533 */   // Label 575: @32533
     /*   32533 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(32601), // Rule ID 70372 //
     /*   32538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   32553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   32557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32575 */     // (add:{ *:[nxv4i32] } (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   32575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   32578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   32584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   32596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32599 */     GIR_RootConstrainSelectedInstOperands,
     /*   32600 */     // GIR_Coverage, 70372,
     /*   32600 */     GIR_EraseRootFromParent_Done,
     /*   32601 */   // Label 576: @32601
     /*   32601 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(32656), // Rule ID 69291 //
     /*   32606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32621 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32634 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   32634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   32637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32654 */     GIR_RootConstrainSelectedInstOperands,
     /*   32655 */     // GIR_Coverage, 69291,
     /*   32655 */     GIR_EraseRootFromParent_Done,
     /*   32656 */   // Label 577: @32656
     /*   32656 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(32711), // Rule ID 69292 //
     /*   32661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   32672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32689 */     // (add:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   32689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   32692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32709 */     GIR_RootConstrainSelectedInstOperands,
     /*   32710 */     // GIR_Coverage, 69292,
     /*   32710 */     GIR_EraseRootFromParent_Done,
     /*   32711 */   // Label 578: @32711
     /*   32711 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(32766), // Rule ID 69111 //
     /*   32716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32744 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   32744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   32747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32764 */     GIR_RootConstrainSelectedInstOperands,
     /*   32765 */     // GIR_Coverage, 69111,
     /*   32765 */     GIR_EraseRootFromParent_Done,
     /*   32766 */   // Label 579: @32766
     /*   32766 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(32821), // Rule ID 69112 //
     /*   32771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   32782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32786 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32799 */     // (add:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   32799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   32802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32819 */     GIR_RootConstrainSelectedInstOperands,
     /*   32820 */     // GIR_Coverage, 69112,
     /*   32820 */     GIR_EraseRootFromParent_Done,
     /*   32821 */   // Label 580: @32821
     /*   32821 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(32876), // Rule ID 69201 //
     /*   32826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32841 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32854 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   32854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   32857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32874 */     GIR_RootConstrainSelectedInstOperands,
     /*   32875 */     // GIR_Coverage, 69201,
     /*   32875 */     GIR_EraseRootFromParent_Done,
     /*   32876 */   // Label 581: @32876
     /*   32876 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(32931), // Rule ID 69202 //
     /*   32881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   32884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   32888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   32892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   32896 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   32903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32909 */     // (add:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   32909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   32912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   32916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   32926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32929 */     GIR_RootConstrainSelectedInstOperands,
     /*   32930 */     // GIR_Coverage, 69202,
     /*   32930 */     GIR_EraseRootFromParent_Done,
     /*   32931 */   // Label 582: @32931
     /*   32931 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(32999), // Rule ID 51796 //
     /*   32936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   32939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   32947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   32951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   32955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   32959 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   32961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   32971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   32973 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   32973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   32976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   32978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   32982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   32986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   32988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   32991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   32994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   32997 */     GIR_RootConstrainSelectedInstOperands,
     /*   32998 */     // GIR_Coverage, 51796,
     /*   32998 */     GIR_EraseRootFromParent_Done,
     /*   32999 */   // Label 583: @32999
     /*   32999 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(33067), // Rule ID 51797 //
     /*   33004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33007 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   33027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33041 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   33041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   33044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   33050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33065 */     GIR_RootConstrainSelectedInstOperands,
     /*   33066 */     // GIR_Coverage, 51797,
     /*   33066 */     GIR_EraseRootFromParent_Done,
     /*   33067 */   // Label 584: @33067
     /*   33067 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(33122), // Rule ID 46642 //
     /*   33072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33100 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   33103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33120 */     GIR_RootConstrainSelectedInstOperands,
     /*   33121 */     // GIR_Coverage, 46642,
     /*   33121 */     GIR_EraseRootFromParent_Done,
     /*   33122 */   // Label 585: @33122
     /*   33122 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(33177), // Rule ID 46643 //
     /*   33127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   33142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33155 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   33158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33175 */     GIR_RootConstrainSelectedInstOperands,
     /*   33176 */     // GIR_Coverage, 46643,
     /*   33176 */     GIR_EraseRootFromParent_Done,
     /*   33177 */   // Label 586: @33177
     /*   33177 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(33232), // Rule ID 46402 //
     /*   33182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33210 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   33213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33230 */     GIR_RootConstrainSelectedInstOperands,
     /*   33231 */     // GIR_Coverage, 46402,
     /*   33231 */     GIR_EraseRootFromParent_Done,
     /*   33232 */   // Label 587: @33232
     /*   33232 */   GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(33287), // Rule ID 46403 //
     /*   33237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33265 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   33268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33285 */     GIR_RootConstrainSelectedInstOperands,
     /*   33286 */     // GIR_Coverage, 46403,
     /*   33286 */     GIR_EraseRootFromParent_Done,
     /*   33287 */   // Label 588: @33287
     /*   33287 */   GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(33342), // Rule ID 46522 //
     /*   33292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33320 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   33320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   33323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33340 */     GIR_RootConstrainSelectedInstOperands,
     /*   33341 */     // GIR_Coverage, 46522,
     /*   33341 */     GIR_EraseRootFromParent_Done,
     /*   33342 */   // Label 589: @33342
     /*   33342 */   GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(33397), // Rule ID 46523 //
     /*   33347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   33358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   33366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   33373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   33375 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   33375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   33378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   33382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   33386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   33392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33395 */     GIR_RootConstrainSelectedInstOperands,
     /*   33396 */     // GIR_Coverage, 46523,
     /*   33396 */     GIR_EraseRootFromParent_Done,
     /*   33397 */   // Label 590: @33397
     /*   33397 */   GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(33450), // Rule ID 46032 //
     /*   33402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   33405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33413 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   33413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   33416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   33430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33448 */     GIR_RootConstrainSelectedInstOperands,
     /*   33449 */     // GIR_Coverage, 46032,
     /*   33449 */     GIR_EraseRootFromParent_Done,
     /*   33450 */   // Label 591: @33450
     /*   33450 */   GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(33503), // Rule ID 46033 //
     /*   33455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   33458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33466 */     // (add:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   33466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   33469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   33473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   33478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   33480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   33483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   33488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   33490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   33492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   33501 */     GIR_RootConstrainSelectedInstOperands,
     /*   33502 */     // GIR_Coverage, 46033,
     /*   33502 */     GIR_EraseRootFromParent_Done,
     /*   33503 */   // Label 592: @33503
     /*   33503 */   GIM_Reject,
     /*   33504 */ // Label 552: @33504
     /*   33504 */ GIM_Reject,
     /*   33505 */ // Label 139: @33505
     /*   33505 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(36629),
     /*   33510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33520 */   GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(33616), // Rule ID 70487 //
     /*   33525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   33528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33577 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33590 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   33590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   33593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   33597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33614 */     GIR_RootConstrainSelectedInstOperands,
     /*   33615 */     // GIR_Coverage, 70487,
     /*   33615 */     GIR_EraseRootFromParent_Done,
     /*   33616 */   // Label 594: @33616
     /*   33616 */   GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(33712), // Rule ID 70488 //
     /*   33621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   33624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33673 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33686 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   33686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   33689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   33693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33710 */     GIR_RootConstrainSelectedInstOperands,
     /*   33711 */     // GIR_Coverage, 70488,
     /*   33711 */     GIR_EraseRootFromParent_Done,
     /*   33712 */   // Label 595: @33712
     /*   33712 */   GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(33808), // Rule ID 70775 //
     /*   33717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   33720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33769 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33782 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   33782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   33785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   33789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33806 */     GIR_RootConstrainSelectedInstOperands,
     /*   33807 */     // GIR_Coverage, 70775,
     /*   33807 */     GIR_EraseRootFromParent_Done,
     /*   33808 */   // Label 596: @33808
     /*   33808 */   GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(33904), // Rule ID 70776 //
     /*   33813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   33816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33832 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33853 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33857 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33861 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33865 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33878 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   33878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   33881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   33885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   33889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   33893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33902 */     GIR_RootConstrainSelectedInstOperands,
     /*   33903 */     // GIR_Coverage, 70776,
     /*   33903 */     GIR_EraseRootFromParent_Done,
     /*   33904 */   // Label 597: @33904
     /*   33904 */   GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(34000), // Rule ID 70777 //
     /*   33909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   33912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   33916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   33920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   33924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   33928 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   33930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   33934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   33938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33942 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   33944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33949 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   33953 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   33957 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   33961 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   33963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   33968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   33972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   33974 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   33974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   33977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   33979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   33981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   33985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   33989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   33992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   33995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   33998 */     GIR_RootConstrainSelectedInstOperands,
     /*   33999 */     // GIR_Coverage, 70777,
     /*   33999 */     GIR_EraseRootFromParent_Done,
     /*   34000 */   // Label 598: @34000
     /*   34000 */   GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(34096), // Rule ID 70778 //
     /*   34005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34038 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34053 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34057 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34059 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34070 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   34070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   34073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34094 */     GIR_RootConstrainSelectedInstOperands,
     /*   34095 */     // GIR_Coverage, 70778,
     /*   34095 */     GIR_EraseRootFromParent_Done,
     /*   34096 */   // Label 599: @34096
     /*   34096 */   GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(34192), // Rule ID 70601 //
     /*   34101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   34104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34120 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34153 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34166 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   34166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   34169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34190 */     GIR_RootConstrainSelectedInstOperands,
     /*   34191 */     // GIR_Coverage, 70601,
     /*   34191 */     GIR_EraseRootFromParent_Done,
     /*   34192 */   // Label 600: @34192
     /*   34192 */   GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(34288), // Rule ID 70602 //
     /*   34197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   34204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34230 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34232 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34249 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34251 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34262 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   34262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   34265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   34269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34286 */     GIR_RootConstrainSelectedInstOperands,
     /*   34287 */     // GIR_Coverage, 70602,
     /*   34287 */     GIR_EraseRootFromParent_Done,
     /*   34288 */   // Label 601: @34288
     /*   34288 */   GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(34384), // Rule ID 51932 //
     /*   34293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   34296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34330 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34349 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34351 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34358 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   34358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   34361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34382 */     GIR_RootConstrainSelectedInstOperands,
     /*   34383 */     // GIR_Coverage, 51932,
     /*   34383 */     GIR_EraseRootFromParent_Done,
     /*   34384 */   // Label 602: @34384
     /*   34384 */   GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(34480), // Rule ID 51933 //
     /*   34389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34441 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34445 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34447 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34454 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   34454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   34457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34478 */     GIR_RootConstrainSelectedInstOperands,
     /*   34479 */     // GIR_Coverage, 51933,
     /*   34479 */     GIR_EraseRootFromParent_Done,
     /*   34480 */   // Label 603: @34480
     /*   34480 */   GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(34576), // Rule ID 52050 //
     /*   34485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   34488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34508 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34541 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34543 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34550 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   34550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   34553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34574 */     GIR_RootConstrainSelectedInstOperands,
     /*   34575 */     // GIR_Coverage, 52050,
     /*   34575 */     GIR_EraseRootFromParent_Done,
     /*   34576 */   // Label 604: @34576
     /*   34576 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(34672), // Rule ID 52051 //
     /*   34581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34625 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34629 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34633 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34637 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34639 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34646 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   34646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   34649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34670 */     GIR_RootConstrainSelectedInstOperands,
     /*   34671 */     // GIR_Coverage, 52051,
     /*   34671 */     GIR_EraseRootFromParent_Done,
     /*   34672 */   // Label 605: @34672
     /*   34672 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(34768), // Rule ID 70773 //
     /*   34677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   34680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34700 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34721 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34725 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34729 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34733 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34735 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34740 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34742 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   34742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   34745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34766 */     GIR_RootConstrainSelectedInstOperands,
     /*   34767 */     // GIR_Coverage, 70773,
     /*   34767 */     GIR_EraseRootFromParent_Done,
     /*   34768 */   // Label 606: @34768
     /*   34768 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(34864), // Rule ID 70774 //
     /*   34773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34810 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   34825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34829 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34836 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34838 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   34838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   34841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   34849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   34853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34862 */     GIR_RootConstrainSelectedInstOperands,
     /*   34863 */     // GIR_Coverage, 70774,
     /*   34863 */     GIR_EraseRootFromParent_Done,
     /*   34864 */   // Label 607: @34864
     /*   34864 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(34960), // Rule ID 51990 //
     /*   34869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   34872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34892 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   34908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   34917 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34921 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   34925 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   34927 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   34932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   34934 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   34934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   34937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   34939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   34941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   34945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   34949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   34952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   34955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   34958 */     GIR_RootConstrainSelectedInstOperands,
     /*   34959 */     // GIR_Coverage, 51990,
     /*   34959 */     GIR_EraseRootFromParent_Done,
     /*   34960 */   // Label 608: @34960
     /*   34960 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(35056), // Rule ID 51991 //
     /*   34965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   34968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   34972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   34976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   34980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   34984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   34988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   34990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   34994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   34998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   35013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35021 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   35023 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   35030 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   35030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   35033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   35037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   35045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35054 */     GIR_RootConstrainSelectedInstOperands,
     /*   35055 */     // GIR_Coverage, 51991,
     /*   35055 */     GIR_EraseRootFromParent_Done,
     /*   35056 */   // Label 609: @35056
     /*   35056 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(35145), // Rule ID 46602 //
     /*   35061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35076 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35095 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35104 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   35104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   35121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35123 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35143 */     GIR_RootConstrainSelectedInstOperands,
     /*   35144 */     // GIR_Coverage, 46602,
     /*   35144 */     GIR_EraseRootFromParent_Done,
     /*   35145 */   // Label 610: @35145
     /*   35145 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(35234), // Rule ID 46603 //
     /*   35150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   35153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35165 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35184 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35193 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   35193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   35210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35232 */     GIR_RootConstrainSelectedInstOperands,
     /*   35233 */     // GIR_Coverage, 46603,
     /*   35233 */     GIR_EraseRootFromParent_Done,
     /*   35234 */   // Label 611: @35234
     /*   35234 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(35323), // Rule ID 46366 //
     /*   35239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35254 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35273 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35282 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   35282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   35299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35321 */     GIR_RootConstrainSelectedInstOperands,
     /*   35322 */     // GIR_Coverage, 46366,
     /*   35322 */     GIR_EraseRootFromParent_Done,
     /*   35323 */   // Label 612: @35323
     /*   35323 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(35412), // Rule ID 46367 //
     /*   35328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   35331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35362 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35371 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   35371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   35388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35410 */     GIR_RootConstrainSelectedInstOperands,
     /*   35411 */     // GIR_Coverage, 46367,
     /*   35411 */     GIR_EraseRootFromParent_Done,
     /*   35412 */   // Label 613: @35412
     /*   35412 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(35501), // Rule ID 46482 //
     /*   35417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35432 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35451 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35453 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35460 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   35460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   35477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35499 */     GIR_RootConstrainSelectedInstOperands,
     /*   35500 */     // GIR_Coverage, 46482,
     /*   35500 */     GIR_EraseRootFromParent_Done,
     /*   35501 */   // Label 614: @35501
     /*   35501 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(35590), // Rule ID 46483 //
     /*   35506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   35509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35521 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   35532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35540 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   35542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   35549 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   35549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   35552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   35556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   35561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   35563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   35566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   35571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   35575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   35579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   35588 */     GIR_RootConstrainSelectedInstOperands,
     /*   35589 */     // GIR_Coverage, 46483,
     /*   35589 */     GIR_EraseRootFromParent_Done,
     /*   35590 */   // Label 615: @35590
     /*   35590 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(35658), // Rule ID 70403 //
     /*   35595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   35598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   35610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   35614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35632 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   35632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   35635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   35641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   35653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35656 */     GIR_RootConstrainSelectedInstOperands,
     /*   35657 */     // GIR_Coverage, 70403,
     /*   35657 */     GIR_EraseRootFromParent_Done,
     /*   35658 */   // Label 616: @35658
     /*   35658 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(35726), // Rule ID 70404 //
     /*   35663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   35666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   35674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   35678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   35682 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35700 */     // (add:{ *:[nxv4i64] } (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   35700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   35703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   35709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   35721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35724 */     GIR_RootConstrainSelectedInstOperands,
     /*   35725 */     // GIR_Coverage, 70404,
     /*   35725 */     GIR_EraseRootFromParent_Done,
     /*   35726 */   // Label 617: @35726
     /*   35726 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(35781), // Rule ID 69311 //
     /*   35731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35746 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35759 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   35759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   35762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35779 */     GIR_RootConstrainSelectedInstOperands,
     /*   35780 */     // GIR_Coverage, 69311,
     /*   35780 */     GIR_EraseRootFromParent_Done,
     /*   35781 */   // Label 618: @35781
     /*   35781 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(35836), // Rule ID 69312 //
     /*   35786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   35789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   35797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35801 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35814 */     // (add:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   35814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   35817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35834 */     GIR_RootConstrainSelectedInstOperands,
     /*   35835 */     // GIR_Coverage, 69312,
     /*   35835 */     GIR_EraseRootFromParent_Done,
     /*   35836 */   // Label 619: @35836
     /*   35836 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(35891), // Rule ID 69131 //
     /*   35841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35869 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   35869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   35872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35889 */     GIR_RootConstrainSelectedInstOperands,
     /*   35890 */     // GIR_Coverage, 69131,
     /*   35890 */     GIR_EraseRootFromParent_Done,
     /*   35891 */   // Label 620: @35891
     /*   35891 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(35946), // Rule ID 69132 //
     /*   35896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   35899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   35907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35911 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35924 */     // (add:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   35924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   35927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35944 */     GIR_RootConstrainSelectedInstOperands,
     /*   35945 */     // GIR_Coverage, 69132,
     /*   35945 */     GIR_EraseRootFromParent_Done,
     /*   35946 */   // Label 621: @35946
     /*   35946 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(36001), // Rule ID 69221 //
     /*   35951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   35954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   35958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   35962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   35966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   35968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   35973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   35977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   35979 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   35979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   35982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   35984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   35986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   35990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   35993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   35996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   35999 */     GIR_RootConstrainSelectedInstOperands,
     /*   36000 */     // GIR_Coverage, 69221,
     /*   36000 */     GIR_EraseRootFromParent_Done,
     /*   36001 */   // Label 622: @36001
     /*   36001 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(36056), // Rule ID 69222 //
     /*   36006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   36009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36021 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36034 */     // (add:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   36037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36054 */     GIR_RootConstrainSelectedInstOperands,
     /*   36055 */     // GIR_Coverage, 69222,
     /*   36055 */     GIR_EraseRootFromParent_Done,
     /*   36056 */   // Label 623: @36056
     /*   36056 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(36124), // Rule ID 51812 //
     /*   36061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   36064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   36080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   36084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36098 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   36098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   36101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   36119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36122 */     GIR_RootConstrainSelectedInstOperands,
     /*   36123 */     // GIR_Coverage, 51812,
     /*   36123 */     GIR_EraseRootFromParent_Done,
     /*   36124 */   // Label 624: @36124
     /*   36124 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(36192), // Rule ID 51813 //
     /*   36129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   36132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   36148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   36152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36166 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   36166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   36169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   36187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36190 */     GIR_RootConstrainSelectedInstOperands,
     /*   36191 */     // GIR_Coverage, 51813,
     /*   36191 */     GIR_EraseRootFromParent_Done,
     /*   36192 */   // Label 625: @36192
     /*   36192 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(36247), // Rule ID 46662 //
     /*   36197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   36200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36225 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   36228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36245 */     GIR_RootConstrainSelectedInstOperands,
     /*   36246 */     // GIR_Coverage, 46662,
     /*   36246 */     GIR_EraseRootFromParent_Done,
     /*   36247 */   // Label 626: @36247
     /*   36247 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(36302), // Rule ID 46663 //
     /*   36252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   36255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   36267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36280 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   36283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36300 */     GIR_RootConstrainSelectedInstOperands,
     /*   36301 */     // GIR_Coverage, 46663,
     /*   36301 */     GIR_EraseRootFromParent_Done,
     /*   36302 */   // Label 627: @36302
     /*   36302 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(36357), // Rule ID 46422 //
     /*   36307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   36310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36335 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   36338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36355 */     GIR_RootConstrainSelectedInstOperands,
     /*   36356 */     // GIR_Coverage, 46422,
     /*   36356 */     GIR_EraseRootFromParent_Done,
     /*   36357 */   // Label 628: @36357
     /*   36357 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(36412), // Rule ID 46423 //
     /*   36362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   36365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   36377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36390 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   36393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36410 */     GIR_RootConstrainSelectedInstOperands,
     /*   36411 */     // GIR_Coverage, 46423,
     /*   36411 */     GIR_EraseRootFromParent_Done,
     /*   36412 */   // Label 629: @36412
     /*   36412 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(36467), // Rule ID 46542 //
     /*   36417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   36420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36445 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   36445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   36448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36465 */     GIR_RootConstrainSelectedInstOperands,
     /*   36466 */     // GIR_Coverage, 46542,
     /*   36466 */     GIR_EraseRootFromParent_Done,
     /*   36467 */   // Label 630: @36467
     /*   36467 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(36522), // Rule ID 46543 //
     /*   36472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   36475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   36487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   36491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   36498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36500 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   36500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   36503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   36517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36520 */     GIR_RootConstrainSelectedInstOperands,
     /*   36521 */     // GIR_Coverage, 46543,
     /*   36521 */     GIR_EraseRootFromParent_Done,
     /*   36522 */   // Label 631: @36522
     /*   36522 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(36575), // Rule ID 46048 //
     /*   36527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   36530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36538 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   36538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   36541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   36555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   36562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   36570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36573 */     GIR_RootConstrainSelectedInstOperands,
     /*   36574 */     // GIR_Coverage, 46048,
     /*   36574 */     GIR_EraseRootFromParent_Done,
     /*   36575 */   // Label 632: @36575
     /*   36575 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(36628), // Rule ID 46049 //
     /*   36580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   36583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   36591 */     // (add:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   36591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   36594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   36608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   36615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   36623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36626 */     GIR_RootConstrainSelectedInstOperands,
     /*   36627 */     // GIR_Coverage, 46049,
     /*   36627 */     GIR_EraseRootFromParent_Done,
     /*   36628 */   // Label 633: @36628
     /*   36628 */   GIM_Reject,
     /*   36629 */ // Label 593: @36629
     /*   36629 */ GIM_Reject,
     /*   36630 */ // Label 140: @36630
     /*   36630 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(37024),
     /*   36635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   36638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   36641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36645 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(36713), // Rule ID 70291 //
     /*   36650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   36665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   36669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36687 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   36687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   36690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36711 */     GIR_RootConstrainSelectedInstOperands,
     /*   36712 */     // GIR_Coverage, 70291,
     /*   36712 */     GIR_EraseRootFromParent_Done,
     /*   36713 */   // Label 635: @36713
     /*   36713 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(36781), // Rule ID 70292 //
     /*   36718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   36725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   36733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   36737 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36755 */     // (add:{ *:[nxv8i8] } (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   36755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   36758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36779 */     GIR_RootConstrainSelectedInstOperands,
     /*   36780 */     // GIR_Coverage, 70292,
     /*   36780 */     GIR_EraseRootFromParent_Done,
     /*   36781 */   // Label 636: @36781
     /*   36781 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(36849), // Rule ID 51756 //
     /*   36786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   36805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   36809 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36823 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   36823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   36826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36847 */     GIR_RootConstrainSelectedInstOperands,
     /*   36848 */     // GIR_Coverage, 51756,
     /*   36848 */     GIR_EraseRootFromParent_Done,
     /*   36849 */   // Label 637: @36849
     /*   36849 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(36917), // Rule ID 51757 //
     /*   36854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   36865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   36869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   36873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   36877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   36879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   36891 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   36891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /*   36894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   36900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   36904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   36906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   36915 */     GIR_RootConstrainSelectedInstOperands,
     /*   36916 */     // GIR_Coverage, 51757,
     /*   36916 */     GIR_EraseRootFromParent_Done,
     /*   36917 */   // Label 638: @36917
     /*   36917 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(36970), // Rule ID 45992 //
     /*   36922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   36925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36933 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   36933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   36936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   36947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   36950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   36952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   36955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   36957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   36959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   36962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   36968 */     GIR_RootConstrainSelectedInstOperands,
     /*   36969 */     // GIR_Coverage, 45992,
     /*   36969 */     GIR_EraseRootFromParent_Done,
     /*   36970 */   // Label 639: @36970
     /*   36970 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(37023), // Rule ID 45993 //
     /*   36975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   36978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   36986 */     // (add:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   36986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   36989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   36993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   36998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   37000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*   37003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   37008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   37010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   37012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37021 */     GIR_RootConstrainSelectedInstOperands,
     /*   37022 */     // GIR_Coverage, 45993,
     /*   37022 */     GIR_EraseRootFromParent_Done,
     /*   37023 */   // Label 640: @37023
     /*   37023 */   GIM_Reject,
     /*   37024 */ // Label 634: @37024
     /*   37024 */ GIM_Reject,
     /*   37025 */ // Label 141: @37025
     /*   37025 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40149),
     /*   37030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37040 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(37136), // Rule ID 70467 //
     /*   37045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37064 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37078 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37080 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37085 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37089 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37093 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37097 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37099 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37108 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37110 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   37110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   37113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37134 */     GIR_RootConstrainSelectedInstOperands,
     /*   37135 */     // GIR_Coverage, 70467,
     /*   37135 */     GIR_EraseRootFromParent_Done,
     /*   37136 */   // Label 642: @37136
     /*   37136 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(37232), // Rule ID 70468 //
     /*   37141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37160 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37174 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37181 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37185 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37189 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37193 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37204 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37206 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   37206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   37209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37230 */     GIR_RootConstrainSelectedInstOperands,
     /*   37231 */     // GIR_Coverage, 70468,
     /*   37231 */     GIR_EraseRootFromParent_Done,
     /*   37232 */   // Label 643: @37232
     /*   37232 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(37328), // Rule ID 70715 //
     /*   37237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37289 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37291 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37302 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   37302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   37305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37326 */     GIR_RootConstrainSelectedInstOperands,
     /*   37327 */     // GIR_Coverage, 70715,
     /*   37327 */     GIR_EraseRootFromParent_Done,
     /*   37328 */   // Label 644: @37328
     /*   37328 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(37424), // Rule ID 70716 //
     /*   37333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37348 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37352 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37373 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37377 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37381 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37385 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37387 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37398 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   37398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   37401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37422 */     GIR_RootConstrainSelectedInstOperands,
     /*   37423 */     // GIR_Coverage, 70716,
     /*   37423 */     GIR_EraseRootFromParent_Done,
     /*   37424 */   // Label 645: @37424
     /*   37424 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(37520), // Rule ID 70717 //
     /*   37429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37448 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37462 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37469 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37473 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37477 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37481 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37483 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37494 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   37494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   37497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   37505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   37509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37518 */     GIR_RootConstrainSelectedInstOperands,
     /*   37519 */     // GIR_Coverage, 70717,
     /*   37519 */     GIR_EraseRootFromParent_Done,
     /*   37520 */   // Label 646: @37520
     /*   37520 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(37616), // Rule ID 70718 //
     /*   37525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37554 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37558 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37577 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37579 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37588 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37590 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   37590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   37593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   37601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   37605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37614 */     GIR_RootConstrainSelectedInstOperands,
     /*   37615 */     // GIR_Coverage, 70718,
     /*   37615 */     GIR_EraseRootFromParent_Done,
     /*   37616 */   // Label 647: @37616
     /*   37616 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(37712), // Rule ID 70581 //
     /*   37621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37661 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37665 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37669 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37673 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37675 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37686 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   37686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   37689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37710 */     GIR_RootConstrainSelectedInstOperands,
     /*   37711 */     // GIR_Coverage, 70581,
     /*   37711 */     GIR_EraseRootFromParent_Done,
     /*   37712 */   // Label 648: @37712
     /*   37712 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(37808), // Rule ID 70582 //
     /*   37717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   37724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37750 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37757 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37761 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   37765 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37769 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37782 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rd)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   37782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   37785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   37789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37806 */     GIR_RootConstrainSelectedInstOperands,
     /*   37807 */     // GIR_Coverage, 70582,
     /*   37807 */     GIR_EraseRootFromParent_Done,
     /*   37808 */   // Label 649: @37808
     /*   37808 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(37904), // Rule ID 51912 //
     /*   37813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   37816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37865 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37869 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37871 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37876 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37878 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   37878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   37881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   37885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37902 */     GIR_RootConstrainSelectedInstOperands,
     /*   37903 */     // GIR_Coverage, 51912,
     /*   37903 */     GIR_EraseRootFromParent_Done,
     /*   37904 */   // Label 650: @37904
     /*   37904 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(38000), // Rule ID 51913 //
     /*   37909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   37912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   37916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   37920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   37924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   37928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   37932 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   37934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   37938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   37948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   37957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   37961 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   37965 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   37967 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   37972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   37974 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   37974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /*   37977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   37979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   37981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   37985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   37989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   37992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   37995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   37998 */     GIR_RootConstrainSelectedInstOperands,
     /*   37999 */     // GIR_Coverage, 51913,
     /*   37999 */     GIR_EraseRootFromParent_Done,
     /*   38000 */   // Label 651: @38000
     /*   38000 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(38096), // Rule ID 52030 //
     /*   38005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38028 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38042 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38057 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38061 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38063 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38068 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38070 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   38070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   38073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38094 */     GIR_RootConstrainSelectedInstOperands,
     /*   38095 */     // GIR_Coverage, 52030,
     /*   38095 */     GIR_EraseRootFromParent_Done,
     /*   38096 */   // Label 652: @38096
     /*   38096 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(38192), // Rule ID 52031 //
     /*   38101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38104 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38124 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38157 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38159 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38164 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38166 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   38166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   38169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38190 */     GIR_RootConstrainSelectedInstOperands,
     /*   38191 */     // GIR_Coverage, 52031,
     /*   38191 */     GIR_EraseRootFromParent_Done,
     /*   38192 */   // Label 653: @38192
     /*   38192 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(38288), // Rule ID 70713 //
     /*   38197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38220 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38253 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38255 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38260 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38262 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   38262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   38265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38286 */     GIR_RootConstrainSelectedInstOperands,
     /*   38287 */     // GIR_Coverage, 70713,
     /*   38287 */     GIR_EraseRootFromParent_Done,
     /*   38288 */   // Label 654: @38288
     /*   38288 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(38384), // Rule ID 70714 //
     /*   38293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38330 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38345 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38349 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38351 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38358 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   38358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /*   38361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   38369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   38373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38382 */     GIR_RootConstrainSelectedInstOperands,
     /*   38383 */     // GIR_Coverage, 70714,
     /*   38383 */     GIR_EraseRootFromParent_Done,
     /*   38384 */   // Label 655: @38384
     /*   38384 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(38480), // Rule ID 51970 //
     /*   38389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38412 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38426 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38437 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38441 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38445 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38447 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38452 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38454 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   38454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   38457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38478 */     GIR_RootConstrainSelectedInstOperands,
     /*   38479 */     // GIR_Coverage, 51970,
     /*   38479 */     GIR_EraseRootFromParent_Done,
     /*   38480 */   // Label 656: @38480
     /*   38480 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(38576), // Rule ID 51971 //
     /*   38485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   38492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   38496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   38500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   38504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   38508 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   38514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   38533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38541 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   38543 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   38550 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /*   38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   38557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   38565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   38574 */     GIR_RootConstrainSelectedInstOperands,
     /*   38575 */     // GIR_Coverage, 51971,
     /*   38575 */     GIR_EraseRootFromParent_Done,
     /*   38576 */   // Label 657: @38576
     /*   38576 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(38665), // Rule ID 46562 //
     /*   38581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   38592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38596 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   38607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   38611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38615 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   38624 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   38624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   38627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   38641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38663 */     GIR_RootConstrainSelectedInstOperands,
     /*   38664 */     // GIR_Coverage, 46562,
     /*   38664 */     GIR_EraseRootFromParent_Done,
     /*   38665 */   // Label 658: @38665
     /*   38665 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(38754), // Rule ID 46563 //
     /*   38670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   38681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   38696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   38700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38704 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   38713 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   38713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   38716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   38730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38752 */     GIR_RootConstrainSelectedInstOperands,
     /*   38753 */     // GIR_Coverage, 46563,
     /*   38753 */     GIR_EraseRootFromParent_Done,
     /*   38754 */   // Label 659: @38754
     /*   38754 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(38843), // Rule ID 46326 //
     /*   38759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38774 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   38785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38793 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38795 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   38802 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   38802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   38805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   38819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38841 */     GIR_RootConstrainSelectedInstOperands,
     /*   38842 */     // GIR_Coverage, 46326,
     /*   38842 */     GIR_EraseRootFromParent_Done,
     /*   38843 */   // Label 660: @38843
     /*   38843 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(38932), // Rule ID 46327 //
     /*   38848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   38851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   38874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   38878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38882 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   38891 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   38891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   38894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*   38908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38910 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   38913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   38917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   38921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   38924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   38930 */     GIR_RootConstrainSelectedInstOperands,
     /*   38931 */     // GIR_Coverage, 46327,
     /*   38931 */     GIR_EraseRootFromParent_Done,
     /*   38932 */   // Label 661: @38932
     /*   38932 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(39021), // Rule ID 46442 //
     /*   38937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   38940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   38944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38952 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   38954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   38963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   38967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   38971 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   38973 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   38978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   38980 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   38980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   38983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   38987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   38994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   38997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   38999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39019 */     GIR_RootConstrainSelectedInstOperands,
     /*   39020 */     // GIR_Coverage, 46442,
     /*   39020 */     GIR_EraseRootFromParent_Done,
     /*   39021 */   // Label 662: @39021
     /*   39021 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(39110), // Rule ID 46443 //
     /*   39026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   39052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39060 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   39062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   39069 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   39069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   39072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   39076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   39081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   39083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*   39086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   39091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   39095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   39099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39108 */     GIR_RootConstrainSelectedInstOperands,
     /*   39109 */     // GIR_Coverage, 46443,
     /*   39109 */     GIR_EraseRootFromParent_Done,
     /*   39110 */   // Label 663: @39110
     /*   39110 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(39178), // Rule ID 70347 //
     /*   39115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   39130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   39134 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39152 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   39152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   39155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   39173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39176 */     GIR_RootConstrainSelectedInstOperands,
     /*   39177 */     // GIR_Coverage, 70347,
     /*   39177 */     GIR_EraseRootFromParent_Done,
     /*   39178 */   // Label 664: @39178
     /*   39178 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(39246), // Rule ID 70348 //
     /*   39183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   39198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   39202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39220 */     // (add:{ *:[nxv8i16] } (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   39220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   39223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   39241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39244 */     GIR_RootConstrainSelectedInstOperands,
     /*   39245 */     // GIR_Coverage, 70348,
     /*   39245 */     GIR_EraseRootFromParent_Done,
     /*   39246 */   // Label 665: @39246
     /*   39246 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(39301), // Rule ID 69271 //
     /*   39251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39279 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39299 */     GIR_RootConstrainSelectedInstOperands,
     /*   39300 */     // GIR_Coverage, 69271,
     /*   39300 */     GIR_EraseRootFromParent_Done,
     /*   39301 */   // Label 666: @39301
     /*   39301 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(39356), // Rule ID 69272 //
     /*   39306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39321 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39334 */     // (add:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   39334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39354 */     GIR_RootConstrainSelectedInstOperands,
     /*   39355 */     // GIR_Coverage, 69272,
     /*   39355 */     GIR_EraseRootFromParent_Done,
     /*   39356 */   // Label 667: @39356
     /*   39356 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(39411), // Rule ID 69091 //
     /*   39361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39376 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39389 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   39392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39409 */     GIR_RootConstrainSelectedInstOperands,
     /*   39410 */     // GIR_Coverage, 69091,
     /*   39410 */     GIR_EraseRootFromParent_Done,
     /*   39411 */   // Label 668: @39411
     /*   39411 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(39466), // Rule ID 69092 //
     /*   39416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39444 */     // (add:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   39444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   39447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39464 */     GIR_RootConstrainSelectedInstOperands,
     /*   39465 */     // GIR_Coverage, 69092,
     /*   39465 */     GIR_EraseRootFromParent_Done,
     /*   39466 */   // Label 669: @39466
     /*   39466 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(39521), // Rule ID 69181 //
     /*   39471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39486 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39499 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39519 */     GIR_RootConstrainSelectedInstOperands,
     /*   39520 */     // GIR_Coverage, 69181,
     /*   39520 */     GIR_EraseRootFromParent_Done,
     /*   39521 */   // Label 670: @39521
     /*   39521 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(39576), // Rule ID 69182 //
     /*   39526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   39533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39554 */     // (add:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   39554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   39561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39574 */     GIR_RootConstrainSelectedInstOperands,
     /*   39575 */     // GIR_Coverage, 69182,
     /*   39575 */     GIR_EraseRootFromParent_Done,
     /*   39576 */   // Label 671: @39576
     /*   39576 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(39644), // Rule ID 51784 //
     /*   39581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   39600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   39604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39618 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   39618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   39621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   39639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39642 */     GIR_RootConstrainSelectedInstOperands,
     /*   39643 */     // GIR_Coverage, 51784,
     /*   39643 */     GIR_EraseRootFromParent_Done,
     /*   39644 */   // Label 672: @39644
     /*   39644 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(39712), // Rule ID 51785 //
     /*   39649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   39664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   39668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   39672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39686 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   39686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   39689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   39695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   39707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39710 */     GIR_RootConstrainSelectedInstOperands,
     /*   39711 */     // GIR_Coverage, 51785,
     /*   39711 */     GIR_EraseRootFromParent_Done,
     /*   39712 */   // Label 673: @39712
     /*   39712 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(39767), // Rule ID 46622 //
     /*   39717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39745 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39765 */     GIR_RootConstrainSelectedInstOperands,
     /*   39766 */     // GIR_Coverage, 46622,
     /*   39766 */     GIR_EraseRootFromParent_Done,
     /*   39767 */   // Label 674: @39767
     /*   39767 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(39822), // Rule ID 46623 //
     /*   39772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   39787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39800 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   39800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39820 */     GIR_RootConstrainSelectedInstOperands,
     /*   39821 */     // GIR_Coverage, 46623,
     /*   39821 */     GIR_EraseRootFromParent_Done,
     /*   39822 */   // Label 675: @39822
     /*   39822 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(39877), // Rule ID 46382 //
     /*   39827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39855 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   39858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39875 */     GIR_RootConstrainSelectedInstOperands,
     /*   39876 */     // GIR_Coverage, 46382,
     /*   39876 */     GIR_EraseRootFromParent_Done,
     /*   39877 */   // Label 676: @39877
     /*   39877 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(39932), // Rule ID 46383 //
     /*   39882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   39897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39910 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   39910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*   39913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39930 */     GIR_RootConstrainSelectedInstOperands,
     /*   39931 */     // GIR_Coverage, 46383,
     /*   39931 */     GIR_EraseRootFromParent_Done,
     /*   39932 */   // Label 677: @39932
     /*   39932 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(39987), // Rule ID 46502 //
     /*   39937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   39940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   39948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   39952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   39956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   39958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   39963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   39965 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   39965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   39968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   39970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   39972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   39976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   39979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   39982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   39985 */     GIR_RootConstrainSelectedInstOperands,
     /*   39986 */     // GIR_Coverage, 46502,
     /*   39986 */     GIR_EraseRootFromParent_Done,
     /*   39987 */   // Label 678: @39987
     /*   39987 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(40042), // Rule ID 46503 //
     /*   39992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   39995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   39999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   40011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   40018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   40020 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   40020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*   40023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   40027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   40031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40040 */     GIR_RootConstrainSelectedInstOperands,
     /*   40041 */     // GIR_Coverage, 46503,
     /*   40041 */     GIR_EraseRootFromParent_Done,
     /*   40042 */   // Label 679: @40042
     /*   40042 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(40095), // Rule ID 46020 //
     /*   40047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40058 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   40058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   40061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   40075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40093 */     GIR_RootConstrainSelectedInstOperands,
     /*   40094 */     // GIR_Coverage, 46020,
     /*   40094 */     GIR_EraseRootFromParent_Done,
     /*   40095 */   // Label 680: @40095
     /*   40095 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(40148), // Rule ID 46021 //
     /*   40100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40111 */     // (add:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   40111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   40114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   40118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   40123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   40125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   40128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   40133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   40135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   40137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   40146 */     GIR_RootConstrainSelectedInstOperands,
     /*   40147 */     // GIR_Coverage, 46021,
     /*   40147 */     GIR_EraseRootFromParent_Done,
     /*   40148 */   // Label 681: @40148
     /*   40148 */   GIM_Reject,
     /*   40149 */ // Label 641: @40149
     /*   40149 */ GIM_Reject,
     /*   40150 */ // Label 142: @40150
     /*   40150 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43274),
     /*   40155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40165 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(40261), // Rule ID 70479 //
     /*   40170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40203 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40205 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40210 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40214 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40218 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40222 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40224 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40233 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40235 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   40235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   40238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40259 */     GIR_RootConstrainSelectedInstOperands,
     /*   40260 */     // GIR_Coverage, 70479,
     /*   40260 */     GIR_EraseRootFromParent_Done,
     /*   40261 */   // Label 683: @40261
     /*   40261 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(40357), // Rule ID 70480 //
     /*   40266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40285 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40299 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40306 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40310 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40314 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40318 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40320 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40331 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   40331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   40334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40355 */     GIR_RootConstrainSelectedInstOperands,
     /*   40356 */     // GIR_Coverage, 70480,
     /*   40356 */     GIR_EraseRootFromParent_Done,
     /*   40357 */   // Label 684: @40357
     /*   40357 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(40453), // Rule ID 70751 //
     /*   40362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40395 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40397 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40414 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40416 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40425 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40427 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   40427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   40430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40451 */     GIR_RootConstrainSelectedInstOperands,
     /*   40452 */     // GIR_Coverage, 70751,
     /*   40452 */     GIR_EraseRootFromParent_Done,
     /*   40453 */   // Label 685: @40453
     /*   40453 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(40549), // Rule ID 70752 //
     /*   40458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40491 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40506 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40510 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40512 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40523 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   40523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   40526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40547 */     GIR_RootConstrainSelectedInstOperands,
     /*   40548 */     // GIR_Coverage, 70752,
     /*   40548 */     GIR_EraseRootFromParent_Done,
     /*   40549 */   // Label 686: @40549
     /*   40549 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(40645), // Rule ID 70753 //
     /*   40554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40573 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40587 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40589 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40602 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40606 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40608 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40617 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40619 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   40619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   40622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   40630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40643 */     GIR_RootConstrainSelectedInstOperands,
     /*   40644 */     // GIR_Coverage, 70753,
     /*   40644 */     GIR_EraseRootFromParent_Done,
     /*   40645 */   // Label 687: @40645
     /*   40645 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(40741), // Rule ID 70754 //
     /*   40650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40683 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40698 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40702 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40704 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40715 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   40715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   40718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   40726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   40730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40739 */     GIR_RootConstrainSelectedInstOperands,
     /*   40740 */     // GIR_Coverage, 70754,
     /*   40740 */     GIR_EraseRootFromParent_Done,
     /*   40741 */   // Label 688: @40741
     /*   40741 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(40837), // Rule ID 70593 //
     /*   40746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40779 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40781 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40786 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40790 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40794 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40798 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40800 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40809 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40811 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   40811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   40814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40835 */     GIR_RootConstrainSelectedInstOperands,
     /*   40836 */     // GIR_Coverage, 70593,
     /*   40836 */     GIR_EraseRootFromParent_Done,
     /*   40837 */   // Label 689: @40837
     /*   40837 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(40933), // Rule ID 70594 //
     /*   40842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   40845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   40849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40875 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   40890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40894 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40905 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   40907 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   40907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   40910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   40912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   40914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   40918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   40922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   40925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   40928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   40931 */     GIR_RootConstrainSelectedInstOperands,
     /*   40932 */     // GIR_Coverage, 70594,
     /*   40932 */     GIR_EraseRootFromParent_Done,
     /*   40933 */   // Label 690: @40933
     /*   40933 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(41029), // Rule ID 51924 //
     /*   40938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   40941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   40945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   40949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   40953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   40957 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   40961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   40963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   40967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40971 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40975 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   40977 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   40982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   40986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   40990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   40994 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   40996 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41003 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   41003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   41006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41027 */     GIR_RootConstrainSelectedInstOperands,
     /*   41028 */     // GIR_Coverage, 51924,
     /*   41028 */     GIR_EraseRootFromParent_Done,
     /*   41029 */   // Label 691: @41029
     /*   41029 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(41125), // Rule ID 51925 //
     /*   41034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41071 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41078 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41082 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41086 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41090 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41092 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41097 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41099 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   41099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   41102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41123 */     GIR_RootConstrainSelectedInstOperands,
     /*   41124 */     // GIR_Coverage, 51925,
     /*   41124 */     GIR_EraseRootFromParent_Done,
     /*   41125 */   // Label 692: @41125
     /*   41125 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(41221), // Rule ID 52042 //
     /*   41130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41149 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41153 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41167 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41169 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41174 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41178 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41182 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41186 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41188 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41193 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41195 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   41195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   41198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41219 */     GIR_RootConstrainSelectedInstOperands,
     /*   41220 */     // GIR_Coverage, 52042,
     /*   41220 */     GIR_EraseRootFromParent_Done,
     /*   41221 */   // Label 693: @41221
     /*   41221 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(41317), // Rule ID 52043 //
     /*   41226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41249 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41263 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41282 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41284 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41291 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   41291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   41294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41315 */     GIR_RootConstrainSelectedInstOperands,
     /*   41316 */     // GIR_Coverage, 52043,
     /*   41316 */     GIR_EraseRootFromParent_Done,
     /*   41317 */   // Label 694: @41317
     /*   41317 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(41413), // Rule ID 70749 //
     /*   41322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41378 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41380 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41387 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   41387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   41390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41411 */     GIR_RootConstrainSelectedInstOperands,
     /*   41412 */     // GIR_Coverage, 70749,
     /*   41412 */     GIR_EraseRootFromParent_Done,
     /*   41413 */   // Label 695: @41413
     /*   41413 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(41509), // Rule ID 70750 //
     /*   41418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41441 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41470 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41474 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41476 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41481 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41483 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   41483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   41486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   41494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   41498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41507 */     GIR_RootConstrainSelectedInstOperands,
     /*   41508 */     // GIR_Coverage, 70750,
     /*   41508 */     GIR_EraseRootFromParent_Done,
     /*   41509 */   // Label 696: @41509
     /*   41509 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(41605), // Rule ID 51982 //
     /*   41514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41551 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41566 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41570 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41572 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41579 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   41579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   41582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41603 */     GIR_RootConstrainSelectedInstOperands,
     /*   41604 */     // GIR_Coverage, 51982,
     /*   41604 */     GIR_EraseRootFromParent_Done,
     /*   41605 */   // Label 697: @41605
     /*   41605 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(41701), // Rule ID 51983 //
     /*   41610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   41617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   41621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   41625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   41629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   41633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   41639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41647 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41654 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   41658 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   41662 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41666 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   41668 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   41675 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   41675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   41678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   41682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   41690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   41699 */     GIR_RootConstrainSelectedInstOperands,
     /*   41700 */     // GIR_Coverage, 51983,
     /*   41700 */     GIR_EraseRootFromParent_Done,
     /*   41701 */   // Label 698: @41701
     /*   41701 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(41790), // Rule ID 46586 //
     /*   41706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   41717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   41732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   41736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41749 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   41749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   41752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   41766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41788 */     GIR_RootConstrainSelectedInstOperands,
     /*   41789 */     // GIR_Coverage, 46586,
     /*   41789 */     GIR_EraseRootFromParent_Done,
     /*   41790 */   // Label 699: @41790
     /*   41790 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(41879), // Rule ID 46587 //
     /*   41795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   41806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   41821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   41825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41838 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   41838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   41841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   41855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41877 */     GIR_RootConstrainSelectedInstOperands,
     /*   41878 */     // GIR_Coverage, 46587,
     /*   41878 */     GIR_EraseRootFromParent_Done,
     /*   41879 */   // Label 700: @41879
     /*   41879 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(41968), // Rule ID 46350 //
     /*   41884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   41887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41899 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   41910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41918 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   41920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   41927 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   41927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   41930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   41934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   41939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   41941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   41944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   41946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   41949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   41953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   41957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   41960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   41963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   41966 */     GIR_RootConstrainSelectedInstOperands,
     /*   41967 */     // GIR_Coverage, 46350,
     /*   41967 */     GIR_EraseRootFromParent_Done,
     /*   41968 */   // Label 701: @41968
     /*   41968 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(42057), // Rule ID 46351 //
     /*   41973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   41976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   41980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   41984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   41988 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   41990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   41995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   41999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42007 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42016 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   42016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   42019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   42033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42055 */     GIR_RootConstrainSelectedInstOperands,
     /*   42056 */     // GIR_Coverage, 46351,
     /*   42056 */     GIR_EraseRootFromParent_Done,
     /*   42057 */   // Label 702: @42057
     /*   42057 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(42146), // Rule ID 46466 //
     /*   42062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42077 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42096 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42098 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42105 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   42105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   42108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   42122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42144 */     GIR_RootConstrainSelectedInstOperands,
     /*   42145 */     // GIR_Coverage, 46466,
     /*   42145 */     GIR_EraseRootFromParent_Done,
     /*   42146 */   // Label 703: @42146
     /*   42146 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(42235), // Rule ID 46467 //
     /*   42151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42166 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   42177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42185 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   42187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   42194 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   42194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   42197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   42201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   42206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   42208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   42211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   42216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   42220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   42224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   42233 */     GIR_RootConstrainSelectedInstOperands,
     /*   42234 */     // GIR_Coverage, 46467,
     /*   42234 */     GIR_EraseRootFromParent_Done,
     /*   42235 */   // Label 704: @42235
     /*   42235 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(42303), // Rule ID 70379 //
     /*   42240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   42255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   42259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42277 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   42277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   42280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   42286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42301 */     GIR_RootConstrainSelectedInstOperands,
     /*   42302 */     // GIR_Coverage, 70379,
     /*   42302 */     GIR_EraseRootFromParent_Done,
     /*   42303 */   // Label 705: @42303
     /*   42303 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(42371), // Rule ID 70380 //
     /*   42308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   42323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   42327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42345 */     // (add:{ *:[nxv8i32] } (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   42345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   42348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   42354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42369 */     GIR_RootConstrainSelectedInstOperands,
     /*   42370 */     // GIR_Coverage, 70380,
     /*   42370 */     GIR_EraseRootFromParent_Done,
     /*   42371 */   // Label 706: @42371
     /*   42371 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(42426), // Rule ID 69295 //
     /*   42376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42391 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42404 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   42404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42424 */     GIR_RootConstrainSelectedInstOperands,
     /*   42425 */     // GIR_Coverage, 69295,
     /*   42425 */     GIR_EraseRootFromParent_Done,
     /*   42426 */   // Label 707: @42426
     /*   42426 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(42481), // Rule ID 69296 //
     /*   42431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42459 */     // (add:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   42459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42479 */     GIR_RootConstrainSelectedInstOperands,
     /*   42480 */     // GIR_Coverage, 69296,
     /*   42480 */     GIR_EraseRootFromParent_Done,
     /*   42481 */   // Label 708: @42481
     /*   42481 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(42536), // Rule ID 69115 //
     /*   42486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42501 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42514 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   42514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   42517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42534 */     GIR_RootConstrainSelectedInstOperands,
     /*   42535 */     // GIR_Coverage, 69115,
     /*   42535 */     GIR_EraseRootFromParent_Done,
     /*   42536 */   // Label 709: @42536
     /*   42536 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(42591), // Rule ID 69116 //
     /*   42541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42569 */     // (add:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   42569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   42572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42589 */     GIR_RootConstrainSelectedInstOperands,
     /*   42590 */     // GIR_Coverage, 69116,
     /*   42590 */     GIR_EraseRootFromParent_Done,
     /*   42591 */   // Label 710: @42591
     /*   42591 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(42646), // Rule ID 69205 //
     /*   42596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42611 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42624 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   42624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42644 */     GIR_RootConstrainSelectedInstOperands,
     /*   42645 */     // GIR_Coverage, 69205,
     /*   42645 */     GIR_EraseRootFromParent_Done,
     /*   42646 */   // Label 711: @42646
     /*   42646 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(42701), // Rule ID 69206 //
     /*   42651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   42658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   42662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42679 */     // (add:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   42679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   42686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42699 */     GIR_RootConstrainSelectedInstOperands,
     /*   42700 */     // GIR_Coverage, 69206,
     /*   42700 */     GIR_EraseRootFromParent_Done,
     /*   42701 */   // Label 712: @42701
     /*   42701 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(42769), // Rule ID 51800 //
     /*   42706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   42725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   42729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42743 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   42743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   42746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42748 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   42752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   42758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42767 */     GIR_RootConstrainSelectedInstOperands,
     /*   42768 */     // GIR_Coverage, 51800,
     /*   42768 */     GIR_EraseRootFromParent_Done,
     /*   42769 */   // Label 713: @42769
     /*   42769 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(42837), // Rule ID 51801 //
     /*   42774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   42789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   42793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   42797 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42811 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   42811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   42814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   42820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   42826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   42832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42835 */     GIR_RootConstrainSelectedInstOperands,
     /*   42836 */     // GIR_Coverage, 51801,
     /*   42836 */     GIR_EraseRootFromParent_Done,
     /*   42837 */   // Label 714: @42837
     /*   42837 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(42892), // Rule ID 46646 //
     /*   42842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42861 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42870 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   42870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   42877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42890 */     GIR_RootConstrainSelectedInstOperands,
     /*   42891 */     // GIR_Coverage, 46646,
     /*   42891 */     GIR_EraseRootFromParent_Done,
     /*   42892 */   // Label 715: @42892
     /*   42892 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(42947), // Rule ID 46647 //
     /*   42897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   42900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   42912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42916 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42925 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   42925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   42928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   42932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   42945 */     GIR_RootConstrainSelectedInstOperands,
     /*   42946 */     // GIR_Coverage, 46647,
     /*   42946 */     GIR_EraseRootFromParent_Done,
     /*   42947 */   // Label 716: @42947
     /*   42947 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(43002), // Rule ID 46406 //
     /*   42952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   42955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   42959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   42963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   42967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   42971 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   42973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   42978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   42980 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   42980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   42983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   42985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   42987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   42991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   42994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   42997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43000 */     GIR_RootConstrainSelectedInstOperands,
     /*   43001 */     // GIR_Coverage, 46406,
     /*   43001 */     GIR_EraseRootFromParent_Done,
     /*   43002 */   // Label 717: @43002
     /*   43002 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(43057), // Rule ID 46407 //
     /*   43007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43035 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   43038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43055 */     GIR_RootConstrainSelectedInstOperands,
     /*   43056 */     // GIR_Coverage, 46407,
     /*   43056 */     GIR_EraseRootFromParent_Done,
     /*   43057 */   // Label 718: @43057
     /*   43057 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(43112), // Rule ID 46526 //
     /*   43062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43081 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43090 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   43090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   43093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43110 */     GIR_RootConstrainSelectedInstOperands,
     /*   43111 */     // GIR_Coverage, 46526,
     /*   43111 */     GIR_EraseRootFromParent_Done,
     /*   43112 */   // Label 719: @43112
     /*   43112 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(43167), // Rule ID 46527 //
     /*   43117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   43128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   43136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   43143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   43145 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   43145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   43148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   43152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   43156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   43162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43165 */     GIR_RootConstrainSelectedInstOperands,
     /*   43166 */     // GIR_Coverage, 46527,
     /*   43166 */     GIR_EraseRootFromParent_Done,
     /*   43167 */   // Label 720: @43167
     /*   43167 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(43220), // Rule ID 46036 //
     /*   43172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   43175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43183 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   43183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   43186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   43200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43218 */     GIR_RootConstrainSelectedInstOperands,
     /*   43219 */     // GIR_Coverage, 46036,
     /*   43219 */     GIR_EraseRootFromParent_Done,
     /*   43220 */   // Label 721: @43220
     /*   43220 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(43273), // Rule ID 46037 //
     /*   43225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   43228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43236 */     // (add:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   43236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   43239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   43243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   43248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   43250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   43253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   43258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   43260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   43262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   43271 */     GIR_RootConstrainSelectedInstOperands,
     /*   43272 */     // GIR_Coverage, 46037,
     /*   43272 */     GIR_EraseRootFromParent_Done,
     /*   43273 */   // Label 722: @43273
     /*   43273 */   GIM_Reject,
     /*   43274 */ // Label 682: @43274
     /*   43274 */ GIM_Reject,
     /*   43275 */ // Label 143: @43275
     /*   43275 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(46399),
     /*   43280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43283 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43290 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(43386), // Rule ID 70489 //
     /*   43295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   43298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43328 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43347 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43349 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43360 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   43360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   43363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43384 */     GIR_RootConstrainSelectedInstOperands,
     /*   43385 */     // GIR_Coverage, 70489,
     /*   43385 */     GIR_EraseRootFromParent_Done,
     /*   43386 */   // Label 724: @43386
     /*   43386 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(43482), // Rule ID 70490 //
     /*   43391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   43394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43443 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43456 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   43456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   43459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43480 */     GIR_RootConstrainSelectedInstOperands,
     /*   43481 */     // GIR_Coverage, 70490,
     /*   43481 */     GIR_EraseRootFromParent_Done,
     /*   43482 */   // Label 725: @43482
     /*   43482 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(43578), // Rule ID 70781 //
     /*   43487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   43490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43539 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43541 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43552 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   43552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   43555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43576 */     GIR_RootConstrainSelectedInstOperands,
     /*   43577 */     // GIR_Coverage, 70781,
     /*   43577 */     GIR_EraseRootFromParent_Done,
     /*   43578 */   // Label 726: @43578
     /*   43578 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(43674), // Rule ID 70782 //
     /*   43583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   43586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43598 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43604 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43608 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43612 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43616 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43635 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43637 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43648 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   43648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   43651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43672 */     GIR_RootConstrainSelectedInstOperands,
     /*   43673 */     // GIR_Coverage, 70782,
     /*   43673 */     GIR_EraseRootFromParent_Done,
     /*   43674 */   // Label 727: @43674
     /*   43674 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(43770), // Rule ID 70783 //
     /*   43679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   43682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43708 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43712 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43714 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43719 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43723 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43727 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43731 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43744 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   43744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   43747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   43755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   43759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43768 */     GIR_RootConstrainSelectedInstOperands,
     /*   43769 */     // GIR_Coverage, 70783,
     /*   43769 */     GIR_EraseRootFromParent_Done,
     /*   43770 */   // Label 728: @43770
     /*   43770 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(43866), // Rule ID 70784 //
     /*   43775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   43778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43794 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43808 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   43823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43827 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43840 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   43840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   43843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   43851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   43855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43864 */     GIR_RootConstrainSelectedInstOperands,
     /*   43865 */     // GIR_Coverage, 70784,
     /*   43865 */     GIR_EraseRootFromParent_Done,
     /*   43866 */   // Label 729: @43866
     /*   43866 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(43962), // Rule ID 70603 //
     /*   43871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   43874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43890 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43904 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   43906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   43915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   43923 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   43925 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   43930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   43934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   43936 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   43936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   43939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   43941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   43943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   43947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   43951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   43954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   43957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   43960 */     GIR_RootConstrainSelectedInstOperands,
     /*   43961 */     // GIR_Coverage, 70603,
     /*   43961 */     GIR_EraseRootFromParent_Done,
     /*   43962 */   // Label 730: @43962
     /*   43962 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(44058), // Rule ID 70604 //
     /*   43967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   43970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   43974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   43978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   43982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   43986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   43988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   43992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   43996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44000 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44015 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44019 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44032 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   44032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   44035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   44039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44056 */     GIR_RootConstrainSelectedInstOperands,
     /*   44057 */     // GIR_Coverage, 70604,
     /*   44057 */     GIR_EraseRootFromParent_Done,
     /*   44058 */   // Label 731: @44058
     /*   44058 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(44154), // Rule ID 51934 //
     /*   44063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   44066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44100 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44119 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44128 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   44128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   44131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44152 */     GIR_RootConstrainSelectedInstOperands,
     /*   44153 */     // GIR_Coverage, 51934,
     /*   44153 */     GIR_EraseRootFromParent_Done,
     /*   44154 */   // Label 732: @44154
     /*   44154 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(44250), // Rule ID 51935 //
     /*   44159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   44162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44211 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44215 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44217 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44224 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   44224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   44227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44248 */     GIR_RootConstrainSelectedInstOperands,
     /*   44249 */     // GIR_Coverage, 51935,
     /*   44249 */     GIR_EraseRootFromParent_Done,
     /*   44250 */   // Label 733: @44250
     /*   44250 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(44346), // Rule ID 52052 //
     /*   44255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   44258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44292 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44311 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44320 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   44320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   44323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44344 */     GIR_RootConstrainSelectedInstOperands,
     /*   44345 */     // GIR_Coverage, 52052,
     /*   44345 */     GIR_EraseRootFromParent_Done,
     /*   44346 */   // Label 734: @44346
     /*   44346 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(44442), // Rule ID 52053 //
     /*   44351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   44354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44388 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44403 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44407 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44409 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44416 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   44416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   44419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44440 */     GIR_RootConstrainSelectedInstOperands,
     /*   44441 */     // GIR_Coverage, 52053,
     /*   44441 */     GIR_EraseRootFromParent_Done,
     /*   44442 */   // Label 735: @44442
     /*   44442 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(44538), // Rule ID 70779 //
     /*   44447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   44450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44470 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44484 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44499 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44503 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44505 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44510 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44512 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   44512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   44515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44536 */     GIR_RootConstrainSelectedInstOperands,
     /*   44537 */     // GIR_Coverage, 70779,
     /*   44537 */     GIR_EraseRootFromParent_Done,
     /*   44538 */   // Label 736: @44538
     /*   44538 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(44634), // Rule ID 70780 //
     /*   44543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   44546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44576 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44580 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44582 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   44595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44599 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44601 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44608 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   44608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   44611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   44619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   44623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44632 */     GIR_RootConstrainSelectedInstOperands,
     /*   44633 */     // GIR_Coverage, 70780,
     /*   44633 */     GIR_EraseRootFromParent_Done,
     /*   44634 */   // Label 737: @44634
     /*   44634 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(44730), // Rule ID 51992 //
     /*   44639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   44642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44676 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44695 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44697 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44704 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   44704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   44707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44728 */     GIR_RootConstrainSelectedInstOperands,
     /*   44729 */     // GIR_Coverage, 51992,
     /*   44729 */     GIR_EraseRootFromParent_Done,
     /*   44730 */   // Label 738: @44730
     /*   44730 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(44826), // Rule ID 51993 //
     /*   44735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   44738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   44742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   44746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   44750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   44754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   44758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   44764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44772 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   44783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   44787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44791 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   44793 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44798 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   44800 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   44800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   44803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   44807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   44815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   44824 */     GIR_RootConstrainSelectedInstOperands,
     /*   44825 */     // GIR_Coverage, 51993,
     /*   44825 */     GIR_EraseRootFromParent_Done,
     /*   44826 */   // Label 739: @44826
     /*   44826 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(44915), // Rule ID 46606 //
     /*   44831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   44834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   44857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44874 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   44874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   44877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   44891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   44900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   44913 */     GIR_RootConstrainSelectedInstOperands,
     /*   44914 */     // GIR_Coverage, 46606,
     /*   44914 */     GIR_EraseRootFromParent_Done,
     /*   44915 */   // Label 740: @44915
     /*   44915 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(45004), // Rule ID 46607 //
     /*   44920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   44923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   44927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   44937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   44946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   44950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   44954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   44956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   44961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   44963 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   44963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   44966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   44970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   44975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   44977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   44980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   44982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   44985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   44989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   44993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   44996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   44999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45002 */     GIR_RootConstrainSelectedInstOperands,
     /*   45003 */     // GIR_Coverage, 46607,
     /*   45003 */     GIR_EraseRootFromParent_Done,
     /*   45004 */   // Label 741: @45004
     /*   45004 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(45093), // Rule ID 46370 //
     /*   45009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45052 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   45052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   45069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45091 */     GIR_RootConstrainSelectedInstOperands,
     /*   45092 */     // GIR_Coverage, 46370,
     /*   45092 */     GIR_EraseRootFromParent_Done,
     /*   45093 */   // Label 742: @45093
     /*   45093 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(45182), // Rule ID 46371 //
     /*   45098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   45101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45141 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   45141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   45158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45180 */     GIR_RootConstrainSelectedInstOperands,
     /*   45181 */     // GIR_Coverage, 46371,
     /*   45181 */     GIR_EraseRootFromParent_Done,
     /*   45182 */   // Label 743: @45182
     /*   45182 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(45271), // Rule ID 46486 //
     /*   45187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45230 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   45230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   45247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45269 */     GIR_RootConstrainSelectedInstOperands,
     /*   45270 */     // GIR_Coverage, 46486,
     /*   45270 */     GIR_EraseRootFromParent_Done,
     /*   45271 */   // Label 744: @45271
     /*   45271 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(45360), // Rule ID 46487 //
     /*   45276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   45279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   45302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   45312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   45319 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   45319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   45322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   45326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   45331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   45333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   45336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   45341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   45345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   45349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   45358 */     GIR_RootConstrainSelectedInstOperands,
     /*   45359 */     // GIR_Coverage, 46487,
     /*   45359 */     GIR_EraseRootFromParent_Done,
     /*   45360 */   // Label 745: @45360
     /*   45360 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(45428), // Rule ID 70411 //
     /*   45365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   45368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   45380 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   45384 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45402 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   45402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   45405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   45411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45426 */     GIR_RootConstrainSelectedInstOperands,
     /*   45427 */     // GIR_Coverage, 70411,
     /*   45427 */     GIR_EraseRootFromParent_Done,
     /*   45428 */   // Label 746: @45428
     /*   45428 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(45496), // Rule ID 70412 //
     /*   45433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   45436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   45448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   45452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45470 */     // (add:{ *:[nxv8i64] } (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   45470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   45473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   45479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45494 */     GIR_RootConstrainSelectedInstOperands,
     /*   45495 */     // GIR_Coverage, 70412,
     /*   45495 */     GIR_EraseRootFromParent_Done,
     /*   45496 */   // Label 747: @45496
     /*   45496 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(45551), // Rule ID 69315 //
     /*   45501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45516 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45529 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   45529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   45532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45549 */     GIR_RootConstrainSelectedInstOperands,
     /*   45550 */     // GIR_Coverage, 69315,
     /*   45550 */     GIR_EraseRootFromParent_Done,
     /*   45551 */   // Label 748: @45551
     /*   45551 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(45606), // Rule ID 69316 //
     /*   45556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   45559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45584 */     // (add:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   45584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   45587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45604 */     GIR_RootConstrainSelectedInstOperands,
     /*   45605 */     // GIR_Coverage, 69316,
     /*   45605 */     GIR_EraseRootFromParent_Done,
     /*   45606 */   // Label 749: @45606
     /*   45606 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(45661), // Rule ID 69135 //
     /*   45611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45626 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45639 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   45639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   45642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45659 */     GIR_RootConstrainSelectedInstOperands,
     /*   45660 */     // GIR_Coverage, 69135,
     /*   45660 */     GIR_EraseRootFromParent_Done,
     /*   45661 */   // Label 750: @45661
     /*   45661 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(45716), // Rule ID 69136 //
     /*   45666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   45669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   45677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45694 */     // (add:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   45694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   45697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45714 */     GIR_RootConstrainSelectedInstOperands,
     /*   45715 */     // GIR_Coverage, 69136,
     /*   45715 */     GIR_EraseRootFromParent_Done,
     /*   45716 */   // Label 751: @45716
     /*   45716 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(45771), // Rule ID 69225 //
     /*   45721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45749 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   45749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   45752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45769 */     GIR_RootConstrainSelectedInstOperands,
     /*   45770 */     // GIR_Coverage, 69225,
     /*   45770 */     GIR_EraseRootFromParent_Done,
     /*   45771 */   // Label 752: @45771
     /*   45771 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(45826), // Rule ID 69226 //
     /*   45776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   45779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   45783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   45787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45804 */     // (add:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   45804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   45807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   45811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   45821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45824 */     GIR_RootConstrainSelectedInstOperands,
     /*   45825 */     // GIR_Coverage, 69226,
     /*   45825 */     GIR_EraseRootFromParent_Done,
     /*   45826 */   // Label 753: @45826
     /*   45826 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(45894), // Rule ID 51816 //
     /*   45831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   45834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   45850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   45854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45868 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   45868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   45871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   45877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   45883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45892 */     GIR_RootConstrainSelectedInstOperands,
     /*   45893 */     // GIR_Coverage, 51816,
     /*   45893 */     GIR_EraseRootFromParent_Done,
     /*   45894 */   // Label 754: @45894
     /*   45894 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(45962), // Rule ID 51817 //
     /*   45899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   45902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   45914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   45918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   45922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45936 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   45936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   45939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   45941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   45945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   45949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   45951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   45954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   45957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   45960 */     GIR_RootConstrainSelectedInstOperands,
     /*   45961 */     // GIR_Coverage, 51817,
     /*   45961 */     GIR_EraseRootFromParent_Done,
     /*   45962 */   // Label 755: @45962
     /*   45962 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(46017), // Rule ID 46666 //
     /*   45967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   45970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   45974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   45978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   45982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   45986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   45988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   45993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   45995 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   45995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   45998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46015 */     GIR_RootConstrainSelectedInstOperands,
     /*   46016 */     // GIR_Coverage, 46666,
     /*   46016 */     GIR_EraseRootFromParent_Done,
     /*   46017 */   // Label 756: @46017
     /*   46017 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(46072), // Rule ID 46667 //
     /*   46022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   46025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   46037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46050 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   46053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46070 */     GIR_RootConstrainSelectedInstOperands,
     /*   46071 */     // GIR_Coverage, 46667,
     /*   46071 */     GIR_EraseRootFromParent_Done,
     /*   46072 */   // Label 757: @46072
     /*   46072 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(46127), // Rule ID 46426 //
     /*   46077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   46080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46105 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   46108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46125 */     GIR_RootConstrainSelectedInstOperands,
     /*   46126 */     // GIR_Coverage, 46426,
     /*   46126 */     GIR_EraseRootFromParent_Done,
     /*   46127 */   // Label 758: @46127
     /*   46127 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(46182), // Rule ID 46427 //
     /*   46132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   46135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46160 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   46163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46180 */     GIR_RootConstrainSelectedInstOperands,
     /*   46181 */     // GIR_Coverage, 46427,
     /*   46181 */     GIR_EraseRootFromParent_Done,
     /*   46182 */   // Label 759: @46182
     /*   46182 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(46237), // Rule ID 46546 //
     /*   46187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   46190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46215 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   46215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   46218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46235 */     GIR_RootConstrainSelectedInstOperands,
     /*   46236 */     // GIR_Coverage, 46546,
     /*   46236 */     GIR_EraseRootFromParent_Done,
     /*   46237 */   // Label 760: @46237
     /*   46237 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(46292), // Rule ID 46547 //
     /*   46242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   46245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   46257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   46261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46270 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   46270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   46273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   46287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46290 */     GIR_RootConstrainSelectedInstOperands,
     /*   46291 */     // GIR_Coverage, 46547,
     /*   46291 */     GIR_EraseRootFromParent_Done,
     /*   46292 */   // Label 761: @46292
     /*   46292 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(46345), // Rule ID 46052 //
     /*   46297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   46300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46308 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   46308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   46311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   46325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   46340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46343 */     GIR_RootConstrainSelectedInstOperands,
     /*   46344 */     // GIR_Coverage, 46052,
     /*   46344 */     GIR_EraseRootFromParent_Done,
     /*   46345 */   // Label 762: @46345
     /*   46345 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(46398), // Rule ID 46053 //
     /*   46350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   46353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   46361 */     // (add:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   46361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   46364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   46378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   46393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46396 */     GIR_RootConstrainSelectedInstOperands,
     /*   46397 */     // GIR_Coverage, 46053,
     /*   46397 */     GIR_EraseRootFromParent_Done,
     /*   46398 */   // Label 763: @46398
     /*   46398 */   GIM_Reject,
     /*   46399 */ // Label 723: @46399
     /*   46399 */ GIM_Reject,
     /*   46400 */ // Label 144: @46400
     /*   46400 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(46794),
     /*   46405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46415 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(46483), // Rule ID 70323 //
     /*   46420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46457 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   46457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   46460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46481 */     GIR_RootConstrainSelectedInstOperands,
     /*   46482 */     // GIR_Coverage, 70323,
     /*   46482 */     GIR_EraseRootFromParent_Done,
     /*   46483 */   // Label 765: @46483
     /*   46483 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(46551), // Rule ID 70324 //
     /*   46488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46525 */     // (add:{ *:[nxv16i8] } (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   46525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   46528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46549 */     GIR_RootConstrainSelectedInstOperands,
     /*   46550 */     // GIR_Coverage, 70324,
     /*   46550 */     GIR_EraseRootFromParent_Done,
     /*   46551 */   // Label 766: @46551
     /*   46551 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(46619), // Rule ID 51772 //
     /*   46556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46593 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   46593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   46596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46617 */     GIR_RootConstrainSelectedInstOperands,
     /*   46618 */     // GIR_Coverage, 51772,
     /*   46618 */     GIR_EraseRootFromParent_Done,
     /*   46619 */   // Label 767: @46619
     /*   46619 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(46687), // Rule ID 51773 //
     /*   46624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   46635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46643 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   46647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   46661 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   46661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /*   46664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   46670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   46674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   46676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46685 */     GIR_RootConstrainSelectedInstOperands,
     /*   46686 */     // GIR_Coverage, 51773,
     /*   46686 */     GIR_EraseRootFromParent_Done,
     /*   46687 */   // Label 768: @46687
     /*   46687 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(46740), // Rule ID 46008 //
     /*   46692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46703 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   46703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   46706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   46720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46738 */     GIR_RootConstrainSelectedInstOperands,
     /*   46739 */     // GIR_Coverage, 46008,
     /*   46739 */     GIR_EraseRootFromParent_Done,
     /*   46740 */   // Label 769: @46740
     /*   46740 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(46793), // Rule ID 46009 //
     /*   46745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46756 */     // (add:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   46756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   46759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   46763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   46768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   46770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*   46773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   46778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   46780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   46782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46791 */     GIR_RootConstrainSelectedInstOperands,
     /*   46792 */     // GIR_Coverage, 46009,
     /*   46792 */     GIR_EraseRootFromParent_Done,
     /*   46793 */   // Label 770: @46793
     /*   46793 */   GIM_Reject,
     /*   46794 */ // Label 764: @46794
     /*   46794 */ GIM_Reject,
     /*   46795 */ // Label 145: @46795
     /*   46795 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(49919),
     /*   46800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   46803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   46806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46810 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(46906), // Rule ID 70469 //
     /*   46815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   46818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   46830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   46834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46848 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46867 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46869 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46878 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46880 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   46880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   46883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   46887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   46904 */     GIR_RootConstrainSelectedInstOperands,
     /*   46905 */     // GIR_Coverage, 70469,
     /*   46905 */     GIR_EraseRootFromParent_Done,
     /*   46906 */   // Label 772: @46906
     /*   46906 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(47002), // Rule ID 70470 //
     /*   46911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   46914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   46918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   46922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   46926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   46930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   46932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   46936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   46946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   46955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   46959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   46963 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   46965 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   46970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   46974 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   46976 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   46976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   46979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   46981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   46983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   46987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   46991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   46994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   46997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47000 */     GIR_RootConstrainSelectedInstOperands,
     /*   47001 */     // GIR_Coverage, 70470,
     /*   47001 */     GIR_EraseRootFromParent_Done,
     /*   47002 */   // Label 773: @47002
     /*   47002 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(47098), // Rule ID 70721 //
     /*   47007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47040 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47055 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47059 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47061 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47072 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   47072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47096 */     GIR_RootConstrainSelectedInstOperands,
     /*   47097 */     // GIR_Coverage, 70721,
     /*   47097 */     GIR_EraseRootFromParent_Done,
     /*   47098 */   // Label 774: @47098
     /*   47098 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(47194), // Rule ID 70722 //
     /*   47103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47122 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47136 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47138 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47143 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47147 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47151 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47155 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47157 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47166 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47168 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   47168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47192 */     GIR_RootConstrainSelectedInstOperands,
     /*   47193 */     // GIR_Coverage, 70722,
     /*   47193 */     GIR_EraseRootFromParent_Done,
     /*   47194 */   // Label 775: @47194
     /*   47194 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(47290), // Rule ID 70723 //
     /*   47199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47232 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47247 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47251 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47264 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   47264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47288 */     GIR_RootConstrainSelectedInstOperands,
     /*   47289 */     // GIR_Coverage, 70723,
     /*   47289 */     GIR_EraseRootFromParent_Done,
     /*   47290 */   // Label 776: @47290
     /*   47290 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(47386), // Rule ID 70724 //
     /*   47295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47328 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47343 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47347 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47349 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47360 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   47360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   47371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   47375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47384 */     GIR_RootConstrainSelectedInstOperands,
     /*   47385 */     // GIR_Coverage, 70724,
     /*   47385 */     GIR_EraseRootFromParent_Done,
     /*   47386 */   // Label 777: @47386
     /*   47386 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(47482), // Rule ID 70583 //
     /*   47391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47410 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47424 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47435 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47439 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47443 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47445 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47456 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   47456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   47459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47480 */     GIR_RootConstrainSelectedInstOperands,
     /*   47481 */     // GIR_Coverage, 70583,
     /*   47481 */     GIR_EraseRootFromParent_Done,
     /*   47482 */   // Label 778: @47482
     /*   47482 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(47578), // Rule ID 70584 //
     /*   47487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   47494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47520 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47535 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47539 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47541 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47550 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47552 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rd)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   47552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   47555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   47559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47576 */     GIR_RootConstrainSelectedInstOperands,
     /*   47577 */     // GIR_Coverage, 70584,
     /*   47577 */     GIR_EraseRootFromParent_Done,
     /*   47578 */   // Label 779: @47578
     /*   47578 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(47674), // Rule ID 51914 //
     /*   47583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47620 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47635 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47639 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47641 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47648 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   47648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   47651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   47655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47672 */     GIR_RootConstrainSelectedInstOperands,
     /*   47673 */     // GIR_Coverage, 51914,
     /*   47673 */     GIR_EraseRootFromParent_Done,
     /*   47674 */   // Label 780: @47674
     /*   47674 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(47770), // Rule ID 51915 //
     /*   47679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47702 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47716 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47718 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47735 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47737 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47744 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   47744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /*   47747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   47751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47768 */     GIR_RootConstrainSelectedInstOperands,
     /*   47769 */     // GIR_Coverage, 51915,
     /*   47769 */     GIR_EraseRootFromParent_Done,
     /*   47770 */   // Label 781: @47770
     /*   47770 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(47866), // Rule ID 52032 //
     /*   47775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47812 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47819 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47823 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47827 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47831 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47833 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47840 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   47840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   47847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47864 */     GIR_RootConstrainSelectedInstOperands,
     /*   47865 */     // GIR_Coverage, 52032,
     /*   47865 */     GIR_EraseRootFromParent_Done,
     /*   47866 */   // Label 782: @47866
     /*   47866 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(47962), // Rule ID 52033 //
     /*   47871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   47874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47894 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   47904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47908 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   47910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   47919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   47923 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   47927 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   47929 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   47934 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   47936 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   47936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   47939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   47941 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   47943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   47947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   47951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   47954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   47957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   47960 */     GIR_RootConstrainSelectedInstOperands,
     /*   47961 */     // GIR_Coverage, 52033,
     /*   47961 */     GIR_EraseRootFromParent_Done,
     /*   47962 */   // Label 783: @47962
     /*   47962 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(48058), // Rule ID 70719 //
     /*   47967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   47970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   47974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   47978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   47982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   47986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   47990 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   47992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   47996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48004 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48006 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48023 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48025 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48032 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   48032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   48035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48056 */     GIR_RootConstrainSelectedInstOperands,
     /*   48057 */     // GIR_Coverage, 70719,
     /*   48057 */     GIR_EraseRootFromParent_Done,
     /*   48058 */   // Label 784: @48058
     /*   48058 */   GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(48154), // Rule ID 70720 //
     /*   48063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   48082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   48086 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48100 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48107 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48111 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48115 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48119 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48121 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48128 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   48128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /*   48131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   48139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   48143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48152 */     GIR_RootConstrainSelectedInstOperands,
     /*   48153 */     // GIR_Coverage, 70720,
     /*   48153 */     GIR_EraseRootFromParent_Done,
     /*   48154 */   // Label 785: @48154
     /*   48154 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(48250), // Rule ID 51972 //
     /*   48159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   48178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   48182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48211 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48215 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48217 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48222 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48224 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   48224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   48227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48248 */     GIR_RootConstrainSelectedInstOperands,
     /*   48249 */     // GIR_Coverage, 51972,
     /*   48249 */     GIR_EraseRootFromParent_Done,
     /*   48250 */   // Label 786: @48250
     /*   48250 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(48346), // Rule ID 51973 //
     /*   48255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   48266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   48274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   48278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   48284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48292 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48294 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   48303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48311 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   48313 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48318 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   48320 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   48320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /*   48323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   48327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   48335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48344 */     GIR_RootConstrainSelectedInstOperands,
     /*   48345 */     // GIR_Coverage, 51973,
     /*   48345 */     GIR_EraseRootFromParent_Done,
     /*   48346 */   // Label 787: @48346
     /*   48346 */   GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(48435), // Rule ID 46566 //
     /*   48351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48366 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48385 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48394 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   48394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   48411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48433 */     GIR_RootConstrainSelectedInstOperands,
     /*   48434 */     // GIR_Coverage, 46566,
     /*   48434 */     GIR_EraseRootFromParent_Done,
     /*   48435 */   // Label 788: @48435
     /*   48435 */   GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(48524), // Rule ID 46567 //
     /*   48440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48455 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   48470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48474 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48483 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   48483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   48500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48522 */     GIR_RootConstrainSelectedInstOperands,
     /*   48523 */     // GIR_Coverage, 46567,
     /*   48523 */     GIR_EraseRootFromParent_Done,
     /*   48524 */   // Label 789: @48524
     /*   48524 */   GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(48613), // Rule ID 46330 //
     /*   48529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48544 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48563 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48572 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   48572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   48589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48611 */     GIR_RootConstrainSelectedInstOperands,
     /*   48612 */     // GIR_Coverage, 46330,
     /*   48612 */     GIR_EraseRootFromParent_Done,
     /*   48613 */   // Label 790: @48613
     /*   48613 */   GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(48702), // Rule ID 46331 //
     /*   48618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48633 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   48648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48652 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48661 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   48661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48673 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*   48678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48700 */     GIR_RootConstrainSelectedInstOperands,
     /*   48701 */     // GIR_Coverage, 46331,
     /*   48701 */     GIR_EraseRootFromParent_Done,
     /*   48702 */   // Label 791: @48702
     /*   48702 */   GIM_Try, /*On fail goto*//*Label 792*/ GIMT_Encode4(48791), // Rule ID 46446 //
     /*   48707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48722 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48741 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48750 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   48750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   48767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48789 */     GIR_RootConstrainSelectedInstOperands,
     /*   48790 */     // GIR_Coverage, 46446,
     /*   48790 */     GIR_EraseRootFromParent_Done,
     /*   48791 */   // Label 792: @48791
     /*   48791 */   GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(48880), // Rule ID 46447 //
     /*   48796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48811 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   48822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   48826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   48830 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   48832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   48837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   48839 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   48839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   48842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   48846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   48851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   48853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*   48856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   48861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   48865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   48869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   48878 */     GIR_RootConstrainSelectedInstOperands,
     /*   48879 */     // GIR_Coverage, 46447,
     /*   48879 */     GIR_EraseRootFromParent_Done,
     /*   48880 */   // Label 793: @48880
     /*   48880 */   GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(48948), // Rule ID 70355 //
     /*   48885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   48888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   48900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   48904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48922 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   48922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   48925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   48931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   48935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   48937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   48940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   48943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   48946 */     GIR_RootConstrainSelectedInstOperands,
     /*   48947 */     // GIR_Coverage, 70355,
     /*   48947 */     GIR_EraseRootFromParent_Done,
     /*   48948 */   // Label 794: @48948
     /*   48948 */   GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(49016), // Rule ID 70356 //
     /*   48953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   48956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   48960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   48964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   48968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   48972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   48974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   48988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   48990 */     // (add:{ *:[nxv16i16] } (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   48990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   48993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   48995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   48999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   49011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49014 */     GIR_RootConstrainSelectedInstOperands,
     /*   49015 */     // GIR_Coverage, 70356,
     /*   49015 */     GIR_EraseRootFromParent_Done,
     /*   49016 */   // Label 795: @49016
     /*   49016 */   GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(49071), // Rule ID 69275 //
     /*   49021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49036 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49049 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49069 */     GIR_RootConstrainSelectedInstOperands,
     /*   49070 */     // GIR_Coverage, 69275,
     /*   49070 */     GIR_EraseRootFromParent_Done,
     /*   49071 */   // Label 796: @49071
     /*   49071 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(49126), // Rule ID 69276 //
     /*   49076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49091 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49104 */     // (add:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49124 */     GIR_RootConstrainSelectedInstOperands,
     /*   49125 */     // GIR_Coverage, 69276,
     /*   49125 */     GIR_EraseRootFromParent_Done,
     /*   49126 */   // Label 797: @49126
     /*   49126 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(49181), // Rule ID 69095 //
     /*   49131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49159 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   49162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49179 */     GIR_RootConstrainSelectedInstOperands,
     /*   49180 */     // GIR_Coverage, 69095,
     /*   49180 */     GIR_EraseRootFromParent_Done,
     /*   49181 */   // Label 798: @49181
     /*   49181 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(49236), // Rule ID 69096 //
     /*   49186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49201 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49214 */     // (add:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   49217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49234 */     GIR_RootConstrainSelectedInstOperands,
     /*   49235 */     // GIR_Coverage, 69096,
     /*   49235 */     GIR_EraseRootFromParent_Done,
     /*   49236 */   // Label 799: @49236
     /*   49236 */   GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(49291), // Rule ID 69185 //
     /*   49241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49269 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49289 */     GIR_RootConstrainSelectedInstOperands,
     /*   49290 */     // GIR_Coverage, 69185,
     /*   49290 */     GIR_EraseRootFromParent_Done,
     /*   49291 */   // Label 800: @49291
     /*   49291 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(49346), // Rule ID 69186 //
     /*   49296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49324 */     // (add:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49344 */     GIR_RootConstrainSelectedInstOperands,
     /*   49345 */     // GIR_Coverage, 69186,
     /*   49345 */     GIR_EraseRootFromParent_Done,
     /*   49346 */   // Label 801: @49346
     /*   49346 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(49414), // Rule ID 51788 //
     /*   49351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   49370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   49374 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49388 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   49388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   49391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   49409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49412 */     GIR_RootConstrainSelectedInstOperands,
     /*   49413 */     // GIR_Coverage, 51788,
     /*   49413 */     GIR_EraseRootFromParent_Done,
     /*   49414 */   // Label 802: @49414
     /*   49414 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(49482), // Rule ID 51789 //
     /*   49419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   49438 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   49442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49456 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   49456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   49459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   49465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   49477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49480 */     GIR_RootConstrainSelectedInstOperands,
     /*   49481 */     // GIR_Coverage, 51789,
     /*   49481 */     GIR_EraseRootFromParent_Done,
     /*   49482 */   // Label 803: @49482
     /*   49482 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(49537), // Rule ID 46626 //
     /*   49487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49506 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49515 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49535 */     GIR_RootConstrainSelectedInstOperands,
     /*   49536 */     // GIR_Coverage, 46626,
     /*   49536 */     GIR_EraseRootFromParent_Done,
     /*   49537 */   // Label 804: @49537
     /*   49537 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(49592), // Rule ID 46627 //
     /*   49542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   49557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49561 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49570 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49590 */     GIR_RootConstrainSelectedInstOperands,
     /*   49591 */     // GIR_Coverage, 46627,
     /*   49591 */     GIR_EraseRootFromParent_Done,
     /*   49592 */   // Label 805: @49592
     /*   49592 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(49647), // Rule ID 46386 //
     /*   49597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49616 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49625 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   49628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49645 */     GIR_RootConstrainSelectedInstOperands,
     /*   49646 */     // GIR_Coverage, 46386,
     /*   49646 */     GIR_EraseRootFromParent_Done,
     /*   49647 */   // Label 806: @49647
     /*   49647 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(49702), // Rule ID 46387 //
     /*   49652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49680 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*   49683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49700 */     GIR_RootConstrainSelectedInstOperands,
     /*   49701 */     // GIR_Coverage, 46387,
     /*   49701 */     GIR_EraseRootFromParent_Done,
     /*   49702 */   // Label 807: @49702
     /*   49702 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(49757), // Rule ID 46506 //
     /*   49707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49735 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   49735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49755 */     GIR_RootConstrainSelectedInstOperands,
     /*   49756 */     // GIR_Coverage, 46506,
     /*   49756 */     GIR_EraseRootFromParent_Done,
     /*   49757 */   // Label 808: @49757
     /*   49757 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(49812), // Rule ID 46507 //
     /*   49762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   49773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   49777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   49781 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   49788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   49790 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   49790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*   49793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   49797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   49801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   49810 */     GIR_RootConstrainSelectedInstOperands,
     /*   49811 */     // GIR_Coverage, 46507,
     /*   49811 */     GIR_EraseRootFromParent_Done,
     /*   49812 */   // Label 809: @49812
     /*   49812 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(49865), // Rule ID 46024 //
     /*   49817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49828 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   49828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   49831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   49845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   49852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   49860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49863 */     GIR_RootConstrainSelectedInstOperands,
     /*   49864 */     // GIR_Coverage, 46024,
     /*   49864 */     GIR_EraseRootFromParent_Done,
     /*   49865 */   // Label 810: @49865
     /*   49865 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(49918), // Rule ID 46025 //
     /*   49870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   49873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49881 */     // (add:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   49881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   49884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   49888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   49893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   49895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   49898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   49900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   49903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   49905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   49907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   49910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   49913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   49916 */     GIR_RootConstrainSelectedInstOperands,
     /*   49917 */     // GIR_Coverage, 46025,
     /*   49917 */     GIR_EraseRootFromParent_Done,
     /*   49918 */   // Label 811: @49918
     /*   49918 */   GIM_Reject,
     /*   49919 */ // Label 771: @49919
     /*   49919 */ GIM_Reject,
     /*   49920 */ // Label 146: @49920
     /*   49920 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(53044),
     /*   49925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   49928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   49931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   49935 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(50031), // Rule ID 70481 //
     /*   49940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   49943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   49947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   49951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   49955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   49959 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   49961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   49965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   49973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   49975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   49984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   49988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   49992 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   49994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   49999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50005 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   50008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50029 */     GIR_RootConstrainSelectedInstOperands,
     /*   50030 */     // GIR_Coverage, 70481,
     /*   50030 */     GIR_EraseRootFromParent_Done,
     /*   50031 */   // Label 813: @50031
     /*   50031 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(50127), // Rule ID 70482 //
     /*   50036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50069 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50088 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50101 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   50101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   50104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50125 */     GIR_RootConstrainSelectedInstOperands,
     /*   50126 */     // GIR_Coverage, 70482,
     /*   50126 */     GIR_EraseRootFromParent_Done,
     /*   50127 */   // Label 814: @50127
     /*   50127 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(50223), // Rule ID 70757 //
     /*   50132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50184 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50197 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   50200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50221 */     GIR_RootConstrainSelectedInstOperands,
     /*   50222 */     // GIR_Coverage, 70757,
     /*   50222 */     GIR_EraseRootFromParent_Done,
     /*   50223 */   // Label 815: @50223
     /*   50223 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(50319), // Rule ID 70758 //
     /*   50228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50247 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50276 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50280 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50293 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   50293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   50296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50317 */     GIR_RootConstrainSelectedInstOperands,
     /*   50318 */     // GIR_Coverage, 70758,
     /*   50318 */     GIR_EraseRootFromParent_Done,
     /*   50319 */   // Label 816: @50319
     /*   50319 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(50415), // Rule ID 70759 //
     /*   50324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50357 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50376 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50378 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50389 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   50392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   50400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   50404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50413 */     GIR_RootConstrainSelectedInstOperands,
     /*   50414 */     // GIR_Coverage, 70759,
     /*   50414 */     GIR_EraseRootFromParent_Done,
     /*   50415 */   // Label 817: @50415
     /*   50415 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(50511), // Rule ID 70760 //
     /*   50420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50439 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50468 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50472 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50474 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50485 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   50485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   50488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   50496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   50500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50509 */     GIR_RootConstrainSelectedInstOperands,
     /*   50510 */     // GIR_Coverage, 70760,
     /*   50510 */     GIR_EraseRootFromParent_Done,
     /*   50511 */   // Label 818: @50511
     /*   50511 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(50607), // Rule ID 70595 //
     /*   50516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50549 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50551 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50560 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50564 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50568 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50570 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50581 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   50584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50605 */     GIR_RootConstrainSelectedInstOperands,
     /*   50606 */     // GIR_Coverage, 70595,
     /*   50606 */     GIR_EraseRootFromParent_Done,
     /*   50607 */   // Label 819: @50607
     /*   50607 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(50703), // Rule ID 70596 //
     /*   50612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   50619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50645 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50656 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50660 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50664 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50666 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50677 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   50677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   50680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   50684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50701 */     GIR_RootConstrainSelectedInstOperands,
     /*   50702 */     // GIR_Coverage, 70596,
     /*   50702 */     GIR_EraseRootFromParent_Done,
     /*   50703 */   // Label 820: @50703
     /*   50703 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(50799), // Rule ID 51926 //
     /*   50708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50745 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50764 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50766 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50773 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   50776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   50780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50797 */     GIR_RootConstrainSelectedInstOperands,
     /*   50798 */     // GIR_Coverage, 51926,
     /*   50798 */     GIR_EraseRootFromParent_Done,
     /*   50799 */   // Label 821: @50799
     /*   50799 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(50895), // Rule ID 51927 //
     /*   50804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50841 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50860 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50862 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50869 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   50869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   50872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   50876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50893 */     GIR_RootConstrainSelectedInstOperands,
     /*   50894 */     // GIR_Coverage, 51927,
     /*   50894 */     GIR_EraseRootFromParent_Done,
     /*   50895 */   // Label 822: @50895
     /*   50895 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(50991), // Rule ID 52044 //
     /*   50900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   50903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   50907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   50911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   50915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   50919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   50923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   50925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   50929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   50933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   50939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   50948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   50952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   50956 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   50958 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   50963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   50965 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   50965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   50968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   50970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   50972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   50976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   50980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   50983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   50986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   50989 */     GIR_RootConstrainSelectedInstOperands,
     /*   50990 */     // GIR_Coverage, 52044,
     /*   50990 */     GIR_EraseRootFromParent_Done,
     /*   50991 */   // Label 823: @50991
     /*   50991 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(51087), // Rule ID 52045 //
     /*   50996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   50999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   51003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   51015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   51019 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51040 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51044 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51048 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51052 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51061 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   51061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   51064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51085 */     GIR_RootConstrainSelectedInstOperands,
     /*   51086 */     // GIR_Coverage, 52045,
     /*   51086 */     GIR_EraseRootFromParent_Done,
     /*   51087 */   // Label 824: @51087
     /*   51087 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(51183), // Rule ID 70755 //
     /*   51092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   51099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   51111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   51115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51129 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51136 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51140 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51144 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51148 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51150 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51155 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51157 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   51157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   51160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51181 */     GIR_RootConstrainSelectedInstOperands,
     /*   51182 */     // GIR_Coverage, 70755,
     /*   51182 */     GIR_EraseRootFromParent_Done,
     /*   51183 */   // Label 825: @51183
     /*   51183 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(51279), // Rule ID 70756 //
     /*   51188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   51195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   51207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   51211 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51225 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51227 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51244 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51246 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51251 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51253 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   51253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   51256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   51264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   51268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51277 */     GIR_RootConstrainSelectedInstOperands,
     /*   51278 */     // GIR_Coverage, 70756,
     /*   51278 */     GIR_EraseRootFromParent_Done,
     /*   51279 */   // Label 826: @51279
     /*   51279 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(51375), // Rule ID 51984 //
     /*   51284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   51291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   51303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   51307 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51321 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51323 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51328 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51332 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51336 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51340 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51342 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51349 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   51349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   51352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51373 */     GIR_RootConstrainSelectedInstOperands,
     /*   51374 */     // GIR_Coverage, 51984,
     /*   51374 */     GIR_EraseRootFromParent_Done,
     /*   51375 */   // Label 827: @51375
     /*   51375 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(51471), // Rule ID 51985 //
     /*   51380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   51387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   51391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   51395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   51399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   51403 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   51409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51417 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51424 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   51428 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51432 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51436 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   51438 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   51445 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   51445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   51448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   51452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   51460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   51469 */     GIR_RootConstrainSelectedInstOperands,
     /*   51470 */     // GIR_Coverage, 51985,
     /*   51470 */     GIR_EraseRootFromParent_Done,
     /*   51471 */   // Label 828: @51471
     /*   51471 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(51560), // Rule ID 46590 //
     /*   51476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   51487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51491 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51493 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   51506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51510 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51519 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   51519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   51536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51558 */     GIR_RootConstrainSelectedInstOperands,
     /*   51559 */     // GIR_Coverage, 46590,
     /*   51559 */     GIR_EraseRootFromParent_Done,
     /*   51560 */   // Label 829: @51560
     /*   51560 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(51649), // Rule ID 46591 //
     /*   51565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   51576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51580 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   51595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51599 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51606 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51608 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   51608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   51625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51647 */     GIR_RootConstrainSelectedInstOperands,
     /*   51648 */     // GIR_Coverage, 46591,
     /*   51648 */     GIR_EraseRootFromParent_Done,
     /*   51649 */   // Label 830: @51649
     /*   51649 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(51738), // Rule ID 46354 //
     /*   51654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51684 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51688 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51697 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   51697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   51714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51736 */     GIR_RootConstrainSelectedInstOperands,
     /*   51737 */     // GIR_Coverage, 46354,
     /*   51737 */     GIR_EraseRootFromParent_Done,
     /*   51738 */   // Label 831: @51738
     /*   51738 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(51827), // Rule ID 46355 //
     /*   51743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51758 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   51773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51777 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51786 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   51786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   51803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51825 */     GIR_RootConstrainSelectedInstOperands,
     /*   51826 */     // GIR_Coverage, 46355,
     /*   51826 */     GIR_EraseRootFromParent_Done,
     /*   51827 */   // Label 832: @51827
     /*   51827 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(51916), // Rule ID 46470 //
     /*   51832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   51835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51847 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51866 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51875 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   51875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   51892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   51911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   51914 */     GIR_RootConstrainSelectedInstOperands,
     /*   51915 */     // GIR_Coverage, 46470,
     /*   51915 */     GIR_EraseRootFromParent_Done,
     /*   51916 */   // Label 833: @51916
     /*   51916 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(52005), // Rule ID 46471 //
     /*   51921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   51924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   51928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51936 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   51938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   51947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   51951 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   51955 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   51957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   51962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   51964 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   51964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   51967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   51971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   51976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   51978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   51981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   51983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   51986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   51990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   51994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   51997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52003 */     GIR_RootConstrainSelectedInstOperands,
     /*   52004 */     // GIR_Coverage, 46471,
     /*   52004 */     GIR_EraseRootFromParent_Done,
     /*   52005 */   // Label 834: @52005
     /*   52005 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(52073), // Rule ID 70387 //
     /*   52010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   52025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   52029 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52047 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   52047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   52050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   52056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   52068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52071 */     GIR_RootConstrainSelectedInstOperands,
     /*   52072 */     // GIR_Coverage, 70387,
     /*   52072 */     GIR_EraseRootFromParent_Done,
     /*   52073 */   // Label 835: @52073
     /*   52073 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(52141), // Rule ID 70388 //
     /*   52078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   52093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   52097 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52115 */     // (add:{ *:[nxv16i32] } (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   52115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   52118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   52124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   52136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52139 */     GIR_RootConstrainSelectedInstOperands,
     /*   52140 */     // GIR_Coverage, 70388,
     /*   52140 */     GIR_EraseRootFromParent_Done,
     /*   52141 */   // Label 836: @52141
     /*   52141 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(52196), // Rule ID 69299 //
     /*   52146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52161 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52174 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52194 */     GIR_RootConstrainSelectedInstOperands,
     /*   52195 */     // GIR_Coverage, 69299,
     /*   52195 */     GIR_EraseRootFromParent_Done,
     /*   52196 */   // Label 837: @52196
     /*   52196 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(52251), // Rule ID 69300 //
     /*   52201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52216 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52229 */     // (add:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52249 */     GIR_RootConstrainSelectedInstOperands,
     /*   52250 */     // GIR_Coverage, 69300,
     /*   52250 */     GIR_EraseRootFromParent_Done,
     /*   52251 */   // Label 838: @52251
     /*   52251 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52306), // Rule ID 69119 //
     /*   52256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52271 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52284 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   52287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52304 */     GIR_RootConstrainSelectedInstOperands,
     /*   52305 */     // GIR_Coverage, 69119,
     /*   52305 */     GIR_EraseRootFromParent_Done,
     /*   52306 */   // Label 839: @52306
     /*   52306 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52361), // Rule ID 69120 //
     /*   52311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52326 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52339 */     // (add:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   52342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52359 */     GIR_RootConstrainSelectedInstOperands,
     /*   52360 */     // GIR_Coverage, 69120,
     /*   52360 */     GIR_EraseRootFromParent_Done,
     /*   52361 */   // Label 840: @52361
     /*   52361 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(52416), // Rule ID 69209 //
     /*   52366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52394 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52414 */     GIR_RootConstrainSelectedInstOperands,
     /*   52415 */     // GIR_Coverage, 69209,
     /*   52415 */     GIR_EraseRootFromParent_Done,
     /*   52416 */   // Label 841: @52416
     /*   52416 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(52471), // Rule ID 69210 //
     /*   52421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   52428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52449 */     // (add:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52469 */     GIR_RootConstrainSelectedInstOperands,
     /*   52470 */     // GIR_Coverage, 69210,
     /*   52470 */     GIR_EraseRootFromParent_Done,
     /*   52471 */   // Label 842: @52471
     /*   52471 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(52539), // Rule ID 51804 //
     /*   52476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   52495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   52499 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52513 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   52513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   52516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   52522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   52534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52537 */     GIR_RootConstrainSelectedInstOperands,
     /*   52538 */     // GIR_Coverage, 51804,
     /*   52538 */     GIR_EraseRootFromParent_Done,
     /*   52539 */   // Label 843: @52539
     /*   52539 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(52607), // Rule ID 51805 //
     /*   52544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   52559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   52563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   52567 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52581 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   52581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   52584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   52590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   52602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52605 */     GIR_RootConstrainSelectedInstOperands,
     /*   52606 */     // GIR_Coverage, 51805,
     /*   52606 */     GIR_EraseRootFromParent_Done,
     /*   52607 */   // Label 844: @52607
     /*   52607 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(52662), // Rule ID 46650 //
     /*   52612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52631 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52640 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52660 */     GIR_RootConstrainSelectedInstOperands,
     /*   52661 */     // GIR_Coverage, 46650,
     /*   52661 */     GIR_EraseRootFromParent_Done,
     /*   52662 */   // Label 845: @52662
     /*   52662 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(52717), // Rule ID 46651 //
     /*   52667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   52682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52686 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52695 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52715 */     GIR_RootConstrainSelectedInstOperands,
     /*   52716 */     // GIR_Coverage, 46651,
     /*   52716 */     GIR_EraseRootFromParent_Done,
     /*   52717 */   // Label 846: @52717
     /*   52717 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(52772), // Rule ID 46410 //
     /*   52722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52741 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52750 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   52753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52770 */     GIR_RootConstrainSelectedInstOperands,
     /*   52771 */     // GIR_Coverage, 46410,
     /*   52771 */     GIR_EraseRootFromParent_Done,
     /*   52772 */   // Label 847: @52772
     /*   52772 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(52827), // Rule ID 46411 //
     /*   52777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   52792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52805 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   52808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52825 */     GIR_RootConstrainSelectedInstOperands,
     /*   52826 */     // GIR_Coverage, 46411,
     /*   52826 */     GIR_EraseRootFromParent_Done,
     /*   52827 */   // Label 848: @52827
     /*   52827 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(52882), // Rule ID 46530 //
     /*   52832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52851 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52860 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   52860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52880 */     GIR_RootConstrainSelectedInstOperands,
     /*   52881 */     // GIR_Coverage, 46530,
     /*   52881 */     GIR_EraseRootFromParent_Done,
     /*   52882 */   // Label 849: @52882
     /*   52882 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(52937), // Rule ID 46531 //
     /*   52887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   52898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   52902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   52906 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   52908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   52913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   52915 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   52915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   52918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   52922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   52926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   52932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   52935 */     GIR_RootConstrainSelectedInstOperands,
     /*   52936 */     // GIR_Coverage, 46531,
     /*   52936 */     GIR_EraseRootFromParent_Done,
     /*   52937 */   // Label 850: @52937
     /*   52937 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(52990), // Rule ID 46040 //
     /*   52942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   52945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   52953 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   52953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   52956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   52960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   52965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   52967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   52970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   52972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   52975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   52977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   52979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   52982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   52985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   52988 */     GIR_RootConstrainSelectedInstOperands,
     /*   52989 */     // GIR_Coverage, 46040,
     /*   52989 */     GIR_EraseRootFromParent_Done,
     /*   52990 */   // Label 851: @52990
     /*   52990 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(53043), // Rule ID 46041 //
     /*   52995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   52998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53006 */     // (add:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   53006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   53009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   53023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   53038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53041 */     GIR_RootConstrainSelectedInstOperands,
     /*   53042 */     // GIR_Coverage, 46041,
     /*   53042 */     GIR_EraseRootFromParent_Done,
     /*   53043 */   // Label 852: @53043
     /*   53043 */   GIM_Reject,
     /*   53044 */ // Label 812: @53044
     /*   53044 */ GIM_Reject,
     /*   53045 */ // Label 147: @53045
     /*   53045 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(53439),
     /*   53050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   53056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53060 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(53128), // Rule ID 70331 //
     /*   53065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   53084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53102 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53126 */     GIR_RootConstrainSelectedInstOperands,
     /*   53127 */     // GIR_Coverage, 70331,
     /*   53127 */     GIR_EraseRootFromParent_Done,
     /*   53128 */   // Label 854: @53128
     /*   53128 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(53196), // Rule ID 70332 //
     /*   53133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   53152 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53170 */     // (add:{ *:[nxv32i8] } (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53194 */     GIR_RootConstrainSelectedInstOperands,
     /*   53195 */     // GIR_Coverage, 70332,
     /*   53195 */     GIR_EraseRootFromParent_Done,
     /*   53196 */   // Label 855: @53196
     /*   53196 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(53264), // Rule ID 51776 //
     /*   53201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53208 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53212 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53216 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53220 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   53224 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53238 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53262 */     GIR_RootConstrainSelectedInstOperands,
     /*   53263 */     // GIR_Coverage, 51776,
     /*   53263 */     GIR_EraseRootFromParent_Done,
     /*   53264 */   // Label 856: @53264
     /*   53264 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(53332), // Rule ID 51777 //
     /*   53269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   53280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53284 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53288 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   53292 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   53306 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /*   53309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   53315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   53319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   53321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53330 */     GIR_RootConstrainSelectedInstOperands,
     /*   53331 */     // GIR_Coverage, 51777,
     /*   53331 */     GIR_EraseRootFromParent_Done,
     /*   53332 */   // Label 857: @53332
     /*   53332 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(53385), // Rule ID 46012 //
     /*   53337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53348 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   53348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   53351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53383 */     GIR_RootConstrainSelectedInstOperands,
     /*   53384 */     // GIR_Coverage, 46012,
     /*   53384 */     GIR_EraseRootFromParent_Done,
     /*   53385 */   // Label 858: @53385
     /*   53385 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(53438), // Rule ID 46013 //
     /*   53390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53401 */     // (add:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   53401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   53404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   53408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   53413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   53415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*   53418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   53423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   53425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   53427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53436 */     GIR_RootConstrainSelectedInstOperands,
     /*   53437 */     // GIR_Coverage, 46013,
     /*   53437 */     GIR_EraseRootFromParent_Done,
     /*   53438 */   // Label 859: @53438
     /*   53438 */   GIM_Reject,
     /*   53439 */ // Label 853: @53439
     /*   53439 */ GIM_Reject,
     /*   53440 */ // Label 148: @53440
     /*   53440 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(56564),
     /*   53445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53455 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53551), // Rule ID 70471 //
     /*   53460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53493 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53500 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53504 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53508 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53512 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53514 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53523 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   53525 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   53528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   53532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   53540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53549 */     GIR_RootConstrainSelectedInstOperands,
     /*   53550 */     // GIR_Coverage, 70471,
     /*   53550 */     GIR_EraseRootFromParent_Done,
     /*   53551 */   // Label 861: @53551
     /*   53551 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53647), // Rule ID 70472 //
     /*   53556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53575 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53589 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53608 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53610 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53619 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   53621 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   53624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   53628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   53636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53645 */     GIR_RootConstrainSelectedInstOperands,
     /*   53646 */     // GIR_Coverage, 70472,
     /*   53646 */     GIR_EraseRootFromParent_Done,
     /*   53647 */   // Label 862: @53647
     /*   53647 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53743), // Rule ID 70727 //
     /*   53652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53671 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53704 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53706 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53715 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   53717 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   53720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   53724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   53732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53741 */     GIR_RootConstrainSelectedInstOperands,
     /*   53742 */     // GIR_Coverage, 70727,
     /*   53742 */     GIR_EraseRootFromParent_Done,
     /*   53743 */   // Label 863: @53743
     /*   53743 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53839), // Rule ID 70728 //
     /*   53748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53781 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53796 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53800 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53802 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53811 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   53813 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   53813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   53816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   53820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   53824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   53828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53837 */     GIR_RootConstrainSelectedInstOperands,
     /*   53838 */     // GIR_Coverage, 70728,
     /*   53838 */     GIR_EraseRootFromParent_Done,
     /*   53839 */   // Label 864: @53839
     /*   53839 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53935), // Rule ID 70729 //
     /*   53844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   53847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53859 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53884 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53888 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53892 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53896 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53898 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   53907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   53909 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   53909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   53912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   53914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   53916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   53920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   53924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   53927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   53930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   53933 */     GIR_RootConstrainSelectedInstOperands,
     /*   53934 */     // GIR_Coverage, 70729,
     /*   53934 */     GIR_EraseRootFromParent_Done,
     /*   53935 */   // Label 865: @53935
     /*   53935 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(54031), // Rule ID 70730 //
     /*   53940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   53943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   53947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   53951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   53955 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   53959 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   53961 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   53965 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   53969 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53973 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   53975 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   53984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   53988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   53992 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   53994 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   53999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54005 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54029 */     GIR_RootConstrainSelectedInstOperands,
     /*   54030 */     // GIR_Coverage, 70730,
     /*   54030 */     GIR_EraseRootFromParent_Done,
     /*   54031 */   // Label 866: @54031
     /*   54031 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(54127), // Rule ID 70585 //
     /*   54036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54069 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54084 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54088 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54101 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54125 */     GIR_RootConstrainSelectedInstOperands,
     /*   54126 */     // GIR_Coverage, 70585,
     /*   54126 */     GIR_EraseRootFromParent_Done,
     /*   54127 */   // Label 867: @54127
     /*   54127 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(54223), // Rule ID 70586 //
     /*   54132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   54139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54180 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54184 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54186 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54195 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54197 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rd)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*   54204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54221 */     GIR_RootConstrainSelectedInstOperands,
     /*   54222 */     // GIR_Coverage, 70586,
     /*   54222 */     GIR_EraseRootFromParent_Done,
     /*   54223 */   // Label 868: @54223
     /*   54223 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(54319), // Rule ID 51916 //
     /*   54228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54265 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54280 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54284 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54286 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54291 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54293 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54317 */     GIR_RootConstrainSelectedInstOperands,
     /*   54318 */     // GIR_Coverage, 51916,
     /*   54318 */     GIR_EraseRootFromParent_Done,
     /*   54319 */   // Label 869: @54319
     /*   54319 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(54415), // Rule ID 51917 //
     /*   54324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54361 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54380 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54382 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54389 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /*   54392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54413 */     GIR_RootConstrainSelectedInstOperands,
     /*   54414 */     // GIR_Coverage, 51917,
     /*   54414 */     GIR_EraseRootFromParent_Done,
     /*   54415 */   // Label 870: @54415
     /*   54415 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54511), // Rule ID 52034 //
     /*   54420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54457 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54464 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54468 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54472 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54476 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54478 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54483 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54485 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54509 */     GIR_RootConstrainSelectedInstOperands,
     /*   54510 */     // GIR_Coverage, 52034,
     /*   54510 */     GIR_EraseRootFromParent_Done,
     /*   54511 */   // Label 871: @54511
     /*   54511 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(54607), // Rule ID 52035 //
     /*   54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54539 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54553 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54572 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54574 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54581 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54605 */     GIR_RootConstrainSelectedInstOperands,
     /*   54606 */     // GIR_Coverage, 52035,
     /*   54606 */     GIR_EraseRootFromParent_Done,
     /*   54607 */   // Label 872: @54607
     /*   54607 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(54703), // Rule ID 70725 //
     /*   54612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54649 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54656 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54660 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54664 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54668 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54670 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54675 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54677 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54701 */     GIR_RootConstrainSelectedInstOperands,
     /*   54702 */     // GIR_Coverage, 70725,
     /*   54702 */     GIR_EraseRootFromParent_Done,
     /*   54703 */   // Label 873: @54703
     /*   54703 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(54799), // Rule ID 70726 //
     /*   54708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54731 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54745 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   54760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54764 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54766 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54773 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /*   54776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs1
     /*   54784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   54788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54797 */     GIR_RootConstrainSelectedInstOperands,
     /*   54798 */     // GIR_Coverage, 70726,
     /*   54798 */     GIR_EraseRootFromParent_Done,
     /*   54799 */   // Label 874: @54799
     /*   54799 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54895), // Rule ID 51974 //
     /*   54804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54827 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54841 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54856 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54860 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54862 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54869 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   54869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54893 */     GIR_RootConstrainSelectedInstOperands,
     /*   54894 */     // GIR_Coverage, 51974,
     /*   54894 */     GIR_EraseRootFromParent_Done,
     /*   54895 */   // Label 875: @54895
     /*   54895 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(54991), // Rule ID 51975 //
     /*   54900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   54903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   54907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   54911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   54915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   54919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   54923 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   54925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   54929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54937 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   54939 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   54948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   54952 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   54956 */     GIM_CheckHasOneUse, /*MI*/3,
     /*   54958 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   54963 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   54965 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   54965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /*   54968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   54970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   54972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   54976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // rs2
     /*   54980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   54983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   54986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   54989 */     GIR_RootConstrainSelectedInstOperands,
     /*   54990 */     // GIR_Coverage, 51975,
     /*   54990 */     GIR_EraseRootFromParent_Done,
     /*   54991 */   // Label 876: @54991
     /*   54991 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(55080), // Rule ID 46570 //
     /*   54996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   54999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55039 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   55039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55078 */     GIR_RootConstrainSelectedInstOperands,
     /*   55079 */     // GIR_Coverage, 46570,
     /*   55079 */     GIR_EraseRootFromParent_Done,
     /*   55080 */   // Label 877: @55080
     /*   55080 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55169), // Rule ID 46571 //
     /*   55085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55128 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   55128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55167 */     GIR_RootConstrainSelectedInstOperands,
     /*   55168 */     // GIR_Coverage, 46571,
     /*   55168 */     GIR_EraseRootFromParent_Done,
     /*   55169 */   // Label 878: @55169
     /*   55169 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55258), // Rule ID 46334 //
     /*   55174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55189 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55204 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55208 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55217 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   55217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55256 */     GIR_RootConstrainSelectedInstOperands,
     /*   55257 */     // GIR_Coverage, 46334,
     /*   55257 */     GIR_EraseRootFromParent_Done,
     /*   55258 */   // Label 879: @55258
     /*   55258 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55347), // Rule ID 46335 //
     /*   55263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55297 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55299 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55306 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   55306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*   55323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55345 */     GIR_RootConstrainSelectedInstOperands,
     /*   55346 */     // GIR_Coverage, 46335,
     /*   55346 */     GIR_EraseRootFromParent_Done,
     /*   55347 */   // Label 880: @55347
     /*   55347 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55436), // Rule ID 46450 //
     /*   55352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55367 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55386 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55388 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55393 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55395 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   55395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55434 */     GIR_RootConstrainSelectedInstOperands,
     /*   55435 */     // GIR_Coverage, 46450,
     /*   55435 */     GIR_EraseRootFromParent_Done,
     /*   55436 */   // Label 881: @55436
     /*   55436 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55525), // Rule ID 46451 //
     /*   55441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55456 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   55467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55475 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   55477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   55484 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   55484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   55487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   55491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   55496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   55498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*   55501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   55506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   55510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   55514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55523 */     GIR_RootConstrainSelectedInstOperands,
     /*   55524 */     // GIR_Coverage, 46451,
     /*   55524 */     GIR_EraseRootFromParent_Done,
     /*   55525 */   // Label 882: @55525
     /*   55525 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55593), // Rule ID 70363 //
     /*   55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   55549 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55567 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   55567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   55570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   55576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55591 */     GIR_RootConstrainSelectedInstOperands,
     /*   55592 */     // GIR_Coverage, 70363,
     /*   55592 */     GIR_EraseRootFromParent_Done,
     /*   55593 */   // Label 883: @55593
     /*   55593 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55661), // Rule ID 70364 //
     /*   55598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   55609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   55613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   55617 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55635 */     // (add:{ *:[nxv32i16] } (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   55635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   55638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   55644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   55656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55659 */     GIR_RootConstrainSelectedInstOperands,
     /*   55660 */     // GIR_Coverage, 70364,
     /*   55660 */     GIR_EraseRootFromParent_Done,
     /*   55661 */   // Label 884: @55661
     /*   55661 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(55716), // Rule ID 69279 //
     /*   55666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55681 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55694 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   55694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   55697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55714 */     GIR_RootConstrainSelectedInstOperands,
     /*   55715 */     // GIR_Coverage, 69279,
     /*   55715 */     GIR_EraseRootFromParent_Done,
     /*   55716 */   // Label 885: @55716
     /*   55716 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55771), // Rule ID 69280 //
     /*   55721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   55732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55749 */     // (add:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   55749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   55752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55769 */     GIR_RootConstrainSelectedInstOperands,
     /*   55770 */     // GIR_Coverage, 69280,
     /*   55770 */     GIR_EraseRootFromParent_Done,
     /*   55771 */   // Label 886: @55771
     /*   55771 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55826), // Rule ID 69099 //
     /*   55776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55791 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55804 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   55804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   55807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55824 */     GIR_RootConstrainSelectedInstOperands,
     /*   55825 */     // GIR_Coverage, 69099,
     /*   55825 */     GIR_EraseRootFromParent_Done,
     /*   55826 */   // Label 887: @55826
     /*   55826 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55881), // Rule ID 69100 //
     /*   55831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   55842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55859 */     // (add:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   55859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   55862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55879 */     GIR_RootConstrainSelectedInstOperands,
     /*   55880 */     // GIR_Coverage, 69100,
     /*   55880 */     GIR_EraseRootFromParent_Done,
     /*   55881 */   // Label 888: @55881
     /*   55881 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55936), // Rule ID 69189 //
     /*   55886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55914 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   55914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   55917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55934 */     GIR_RootConstrainSelectedInstOperands,
     /*   55935 */     // GIR_Coverage, 69189,
     /*   55935 */     GIR_EraseRootFromParent_Done,
     /*   55936 */   // Label 889: @55936
     /*   55936 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55991), // Rule ID 69190 //
     /*   55941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   55944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   55948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   55952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   55956 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   55958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   55963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   55967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   55969 */     // (add:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   55969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   55972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   55974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   55976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   55980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   55983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   55986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   55989 */     GIR_RootConstrainSelectedInstOperands,
     /*   55990 */     // GIR_Coverage, 69190,
     /*   55990 */     GIR_EraseRootFromParent_Done,
     /*   55991 */   // Label 890: @55991
     /*   55991 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(56059), // Rule ID 51792 //
     /*   55996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   55999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   56015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   56019 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56021 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56033 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   56033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56057 */     GIR_RootConstrainSelectedInstOperands,
     /*   56058 */     // GIR_Coverage, 51792,
     /*   56058 */     GIR_EraseRootFromParent_Done,
     /*   56059 */   // Label 891: @56059
     /*   56059 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56127), // Rule ID 51793 //
     /*   56064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   56083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   56087 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56101 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   56101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56125 */     GIR_RootConstrainSelectedInstOperands,
     /*   56126 */     // GIR_Coverage, 51793,
     /*   56126 */     GIR_EraseRootFromParent_Done,
     /*   56127 */   // Label 892: @56127
     /*   56127 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56182), // Rule ID 46630 //
     /*   56132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56151 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56160 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   56160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56180 */     GIR_RootConstrainSelectedInstOperands,
     /*   56181 */     // GIR_Coverage, 46630,
     /*   56181 */     GIR_EraseRootFromParent_Done,
     /*   56182 */   // Label 893: @56182
     /*   56182 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56237), // Rule ID 46631 //
     /*   56187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   56202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56206 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56215 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   56215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56220 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56235 */     GIR_RootConstrainSelectedInstOperands,
     /*   56236 */     // GIR_Coverage, 46631,
     /*   56236 */     GIR_EraseRootFromParent_Done,
     /*   56237 */   // Label 894: @56237
     /*   56237 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56292), // Rule ID 46390 //
     /*   56242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56261 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56270 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   56270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56290 */     GIR_RootConstrainSelectedInstOperands,
     /*   56291 */     // GIR_Coverage, 46390,
     /*   56291 */     GIR_EraseRootFromParent_Done,
     /*   56292 */   // Label 895: @56292
     /*   56292 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56347), // Rule ID 46391 //
     /*   56297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   56312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56316 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56325 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   56325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*   56328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56345 */     GIR_RootConstrainSelectedInstOperands,
     /*   56346 */     // GIR_Coverage, 46391,
     /*   56346 */     GIR_EraseRootFromParent_Done,
     /*   56347 */   // Label 896: @56347
     /*   56347 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56402), // Rule ID 46510 //
     /*   56352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56371 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56380 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   56380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56400 */     GIR_RootConstrainSelectedInstOperands,
     /*   56401 */     // GIR_Coverage, 46510,
     /*   56401 */     GIR_EraseRootFromParent_Done,
     /*   56402 */   // Label 897: @56402
     /*   56402 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56457), // Rule ID 46511 //
     /*   56407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   56422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   56426 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   56433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56435 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   56435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*   56438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56455 */     GIR_RootConstrainSelectedInstOperands,
     /*   56456 */     // GIR_Coverage, 46511,
     /*   56456 */     GIR_EraseRootFromParent_Done,
     /*   56457 */   // Label 898: @56457
     /*   56457 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56510), // Rule ID 46028 //
     /*   56462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56473 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   56473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   56476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   56490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   56497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56508 */     GIR_RootConstrainSelectedInstOperands,
     /*   56509 */     // GIR_Coverage, 46028,
     /*   56509 */     GIR_EraseRootFromParent_Done,
     /*   56510 */   // Label 899: @56510
     /*   56510 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56563), // Rule ID 46029 //
     /*   56515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56526 */     // (add:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   56526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   56529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   56543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   56550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   56558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56561 */     GIR_RootConstrainSelectedInstOperands,
     /*   56562 */     // GIR_Coverage, 46029,
     /*   56562 */     GIR_EraseRootFromParent_Done,
     /*   56563 */   // Label 900: @56563
     /*   56563 */   GIM_Reject,
     /*   56564 */ // Label 860: @56564
     /*   56564 */ GIM_Reject,
     /*   56565 */ // Label 149: @56565
     /*   56565 */ GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56959),
     /*   56570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   56573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   56576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56580 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56648), // Rule ID 70339 //
     /*   56585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   56600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   56604 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56622 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   56622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56646 */     GIR_RootConstrainSelectedInstOperands,
     /*   56647 */     // GIR_Coverage, 70339,
     /*   56647 */     GIR_EraseRootFromParent_Done,
     /*   56648 */   // Label 902: @56648
     /*   56648 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56716), // Rule ID 70340 //
     /*   56653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   56660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   56668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   56672 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56690 */     // (add:{ *:[nxv64i8] } (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   56690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56714 */     GIR_RootConstrainSelectedInstOperands,
     /*   56715 */     // GIR_Coverage, 70340,
     /*   56715 */     GIR_EraseRootFromParent_Done,
     /*   56716 */   // Label 903: @56716
     /*   56716 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56784), // Rule ID 51780 //
     /*   56721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   56740 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   56744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56758 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   56758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56782 */     GIR_RootConstrainSelectedInstOperands,
     /*   56783 */     // GIR_Coverage, 51780,
     /*   56783 */     GIR_EraseRootFromParent_Done,
     /*   56784 */   // Label 904: @56784
     /*   56784 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56852), // Rule ID 51781 //
     /*   56789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   56800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   56804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   56808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   56812 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   56814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   56826 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   56826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /*   56829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   56835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   56839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   56841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   56850 */     GIR_RootConstrainSelectedInstOperands,
     /*   56851 */     // GIR_Coverage, 51781,
     /*   56851 */     GIR_EraseRootFromParent_Done,
     /*   56852 */   // Label 905: @56852
     /*   56852 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56905), // Rule ID 46016 //
     /*   56857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   56860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56868 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   56868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   56871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   56885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   56892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56903 */     GIR_RootConstrainSelectedInstOperands,
     /*   56904 */     // GIR_Coverage, 46016,
     /*   56904 */     GIR_EraseRootFromParent_Done,
     /*   56905 */   // Label 906: @56905
     /*   56905 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56958), // Rule ID 46017 //
     /*   56910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   56913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   56921 */     // (add:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   56921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   56924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   56928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   56933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   56935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*   56938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   56940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   56943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   56945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   56947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   56950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   56956 */     GIR_RootConstrainSelectedInstOperands,
     /*   56957 */     // GIR_Coverage, 46017,
     /*   56957 */     GIR_EraseRootFromParent_Done,
     /*   56958 */   // Label 907: @56958
     /*   56958 */   GIM_Reject,
     /*   56959 */ // Label 901: @56959
     /*   56959 */ GIM_Reject,
     /*   56960 */ // Label 150: @56960
     /*   56960 */ GIM_Reject,
     /*   56961 */ // Label 1: @56961
     /*   56961 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 932*/ GIMT_Encode4(76193),
     /*   56972 */ /*GILLT_s32*//*Label 908*/ GIMT_Encode4(57096),
     /*   56976 */ /*GILLT_s64*//*Label 909*/ GIMT_Encode4(57343), GIMT_Encode4(0),
     /*   56984 */ /*GILLT_nxv1s8*//*Label 910*/ GIMT_Encode4(57619),
     /*   56988 */ /*GILLT_nxv1s16*//*Label 911*/ GIMT_Encode4(57866),
     /*   56992 */ /*GILLT_nxv1s32*//*Label 912*/ GIMT_Encode4(58989),
     /*   56996 */ /*GILLT_nxv1s64*//*Label 913*/ GIMT_Encode4(60112), GIMT_Encode4(0),
     /*   57004 */ /*GILLT_nxv2s8*//*Label 914*/ GIMT_Encode4(61235),
     /*   57008 */ /*GILLT_nxv2s16*//*Label 915*/ GIMT_Encode4(61482),
     /*   57012 */ /*GILLT_nxv2s32*//*Label 916*/ GIMT_Encode4(62605),
     /*   57016 */ /*GILLT_nxv2s64*//*Label 917*/ GIMT_Encode4(63728), GIMT_Encode4(0),
     /*   57024 */ /*GILLT_nxv4s8*//*Label 918*/ GIMT_Encode4(64851),
     /*   57028 */ /*GILLT_nxv4s16*//*Label 919*/ GIMT_Encode4(65098),
     /*   57032 */ /*GILLT_nxv4s32*//*Label 920*/ GIMT_Encode4(66221),
     /*   57036 */ /*GILLT_nxv4s64*//*Label 921*/ GIMT_Encode4(67344), GIMT_Encode4(0),
     /*   57044 */ /*GILLT_nxv8s8*//*Label 922*/ GIMT_Encode4(68467),
     /*   57048 */ /*GILLT_nxv8s16*//*Label 923*/ GIMT_Encode4(68714),
     /*   57052 */ /*GILLT_nxv8s32*//*Label 924*/ GIMT_Encode4(69837),
     /*   57056 */ /*GILLT_nxv8s64*//*Label 925*/ GIMT_Encode4(70960), GIMT_Encode4(0),
     /*   57064 */ /*GILLT_nxv16s8*//*Label 926*/ GIMT_Encode4(72083),
     /*   57068 */ /*GILLT_nxv16s16*//*Label 927*/ GIMT_Encode4(72330),
     /*   57072 */ /*GILLT_nxv16s32*//*Label 928*/ GIMT_Encode4(73453), GIMT_Encode4(0),
     /*   57080 */ /*GILLT_nxv32s8*//*Label 929*/ GIMT_Encode4(74576),
     /*   57084 */ /*GILLT_nxv32s16*//*Label 930*/ GIMT_Encode4(74823), GIMT_Encode4(0),
     /*   57092 */ /*GILLT_nxv64s8*//*Label 931*/ GIMT_Encode4(75946),
     /*   57096 */ // Label 908: @57096
     /*   57096 */ GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57342),
     /*   57101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   57104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   57107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57111 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(57186), // Rule ID 98 //
     /*   57116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*   57119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   57123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   57131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   57135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   57139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57146 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   57150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57152 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i64] }), 31:{ *:[i64] })
     /*   57152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   57155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   57159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57164 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   57168 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   57171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   57176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   57184 */     GIR_RootConstrainSelectedInstOperands,
     /*   57185 */     // GIR_Coverage, 98,
     /*   57185 */     GIR_EraseRootFromParent_Done,
     /*   57186 */   // Label 934: @57186
     /*   57186 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(57261), // Rule ID 99 //
     /*   57191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*   57194 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   57198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   57206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   57210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   57214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57221 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   57225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57227 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 1:{ *:[i32] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, 31:{ *:[i32] }), 31:{ *:[i32] })
     /*   57227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   57230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   57234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   57243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*   57246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   57251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /*   57259 */     GIR_RootConstrainSelectedInstOperands,
     /*   57260 */     // GIR_Coverage, 99,
     /*   57260 */     GIR_EraseRootFromParent_Done,
     /*   57261 */   // Label 935: @57261
     /*   57261 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(57318), // Rule ID 62570 //
     /*   57266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode1),
     /*   57269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   57285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   57289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57301 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rd, (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))  =>  (TH_MULS:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   57301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   57304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   57306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   57308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57316 */     GIR_RootConstrainSelectedInstOperands,
     /*   57317 */     // GIR_Coverage, 62570,
     /*   57317 */     GIR_EraseRootFromParent_Done,
     /*   57318 */   // Label 936: @57318
     /*   57318 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(57341), // Rule ID 77 //
     /*   57323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*   57326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57334 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   57334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   57339 */     GIR_RootConstrainSelectedInstOperands,
     /*   57340 */     // GIR_Coverage, 77,
     /*   57340 */     GIR_Done,
     /*   57341 */   // Label 937: @57341
     /*   57341 */   GIM_Reject,
     /*   57342 */ // Label 933: @57342
     /*   57342 */ GIM_Reject,
     /*   57343 */ // Label 909: @57343
     /*   57343 */ GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(57618),
     /*   57348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   57351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   57354 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57433), // Rule ID 100 //
     /*   57359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   57362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57366 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*   57370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   57378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   57382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   57386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57393 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   57397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57399 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 1:{ *:[i64] })<<P:Predicate_and_oneuse>>)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, 63:{ *:[i64] }), 63:{ *:[i64] })
     /*   57399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   57402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   57406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57411 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs
     /*   57415 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/63,
     /*   57418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /*   57423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /*   57431 */     GIR_RootConstrainSelectedInstOperands,
     /*   57432 */     // GIR_Coverage, 100,
     /*   57432 */     GIR_EraseRootFromParent_Done,
     /*   57433 */   // Label 939: @57433
     /*   57433 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57498), // Rule ID 62572 //
     /*   57438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_IsRV64_HwMode0),
     /*   57441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   57461 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   57465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57475 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10042),
     /*   57479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57481 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))<<P:Predicate_anonymous_10042>>  =>  (TH_MULSW:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   57481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULSW),
     /*   57484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   57486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   57488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57496 */     GIR_RootConstrainSelectedInstOperands,
     /*   57497 */     // GIR_Coverage, 62572,
     /*   57497 */     GIR_EraseRootFromParent_Done,
     /*   57498 */   // Label 940: @57498
     /*   57498 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57559), // Rule ID 62569 //
     /*   57503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadMac_HwMode0),
     /*   57506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   57526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   57530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57542 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rd, (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))  =>  (TH_MULS:{ *:[i64] } GPR:{ *:[i64] }:$rd, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   57542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MULS),
     /*   57545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*   57547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /*   57549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*   57557 */     GIR_RootConstrainSelectedInstOperands,
     /*   57558 */     // GIR_Coverage, 62569,
     /*   57558 */     GIR_EraseRootFromParent_Done,
     /*   57559 */   // Label 941: @57559
     /*   57559 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57590), // Rule ID 267 //
     /*   57564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*   57567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10042),
     /*   57583 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10042>>  =>  (SUBW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   57583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUBW),
     /*   57588 */     GIR_RootConstrainSelectedInstOperands,
     /*   57589 */     // GIR_Coverage, 267,
     /*   57589 */     GIR_Done,
     /*   57590 */   // Label 942: @57590
     /*   57590 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57617), // Rule ID 76 //
     /*   57595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*   57598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   57610 */     // (sub:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (SUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   57610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SUB),
     /*   57615 */     GIR_RootConstrainSelectedInstOperands,
     /*   57616 */     // GIR_Coverage, 76,
     /*   57616 */     GIR_Done,
     /*   57617 */   // Label 943: @57617
     /*   57617 */   GIM_Reject,
     /*   57618 */ // Label 938: @57618
     /*   57618 */ GIM_Reject,
     /*   57619 */ // Label 910: @57619
     /*   57619 */ GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57865),
     /*   57624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   57630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57638 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57702), // Rule ID 51820 //
     /*   57643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   57662 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57676 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   57676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   57679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57700 */     GIR_RootConstrainSelectedInstOperands,
     /*   57701 */     // GIR_Coverage, 51820,
     /*   57701 */     GIR_EraseRootFromParent_Done,
     /*   57702 */   // Label 945: @57702
     /*   57702 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57766), // Rule ID 51821 //
     /*   57707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   57714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   57718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   57726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   57740 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs2, (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   57740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /*   57743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   57749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   57753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   57755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   57764 */     GIR_RootConstrainSelectedInstOperands,
     /*   57765 */     // GIR_Coverage, 51821,
     /*   57765 */     GIR_EraseRootFromParent_Done,
     /*   57766 */   // Label 946: @57766
     /*   57766 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57815), // Rule ID 46098 //
     /*   57771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57778 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   57781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   57795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57813 */     GIR_RootConstrainSelectedInstOperands,
     /*   57814 */     // GIR_Coverage, 46098,
     /*   57814 */     GIR_EraseRootFromParent_Done,
     /*   57815 */   // Label 947: @57815
     /*   57815 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57864), // Rule ID 46099 //
     /*   57820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57827 */     // (sub:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   57827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   57830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*   57844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   57851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   57853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57862 */     GIR_RootConstrainSelectedInstOperands,
     /*   57863 */     // GIR_Coverage, 46099,
     /*   57863 */     GIR_EraseRootFromParent_Done,
     /*   57864 */   // Label 948: @57864
     /*   57864 */   GIM_Reject,
     /*   57865 */ // Label 944: @57865
     /*   57865 */ GIM_Reject,
     /*   57866 */ // Label 911: @57866
     /*   57866 */ GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58988),
     /*   57871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   57874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   57877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57881 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57970), // Rule ID 47090 //
     /*   57886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   57889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57901 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   57912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57920 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   57922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   57929 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   57929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   57932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   57936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   57941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   57948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   57951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   57955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   57959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   57962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   57968 */     GIR_RootConstrainSelectedInstOperands,
     /*   57969 */     // GIR_Coverage, 47090,
     /*   57969 */     GIR_EraseRootFromParent_Done,
     /*   57970 */   // Label 950: @57970
     /*   57970 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58059), // Rule ID 47091 //
     /*   57975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   57978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   57982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   57986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   57990 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   57992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   57997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   58005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58009 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58018 */     // (sub:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   58018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   58035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   58044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58057 */     GIR_RootConstrainSelectedInstOperands,
     /*   58058 */     // GIR_Coverage, 47091,
     /*   58058 */     GIR_EraseRootFromParent_Done,
     /*   58059 */   // Label 951: @58059
     /*   58059 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58148), // Rule ID 46850 //
     /*   58064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58079 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58098 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58107 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   58107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   58133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58146 */     GIR_RootConstrainSelectedInstOperands,
     /*   58147 */     // GIR_Coverage, 46850,
     /*   58147 */     GIR_EraseRootFromParent_Done,
     /*   58148 */   // Label 952: @58148
     /*   58148 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58237), // Rule ID 46851 //
     /*   58153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58168 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58187 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58196 */     // (sub:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   58196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*   58213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   58222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58235 */     GIR_RootConstrainSelectedInstOperands,
     /*   58236 */     // GIR_Coverage, 46851,
     /*   58236 */     GIR_EraseRootFromParent_Done,
     /*   58237 */   // Label 953: @58237
     /*   58237 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(58326), // Rule ID 46970 //
     /*   58242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58257 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58276 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58285 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   58285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   58302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   58311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58324 */     GIR_RootConstrainSelectedInstOperands,
     /*   58325 */     // GIR_Coverage, 46970,
     /*   58325 */     GIR_EraseRootFromParent_Done,
     /*   58326 */   // Label 954: @58326
     /*   58326 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(58415), // Rule ID 46971 //
     /*   58331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   58338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58346 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   58357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58365 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   58367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   58374 */     // (sub:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   58374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*   58391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   58400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   58404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58413 */     GIR_RootConstrainSelectedInstOperands,
     /*   58414 */     // GIR_Coverage, 46971,
     /*   58414 */     GIR_EraseRootFromParent_Done,
     /*   58415 */   // Label 955: @58415
     /*   58415 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(58483), // Rule ID 51832 //
     /*   58420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   58439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   58443 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58450 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58457 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   58457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   58460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   58466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   58478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58481 */     GIR_RootConstrainSelectedInstOperands,
     /*   58482 */     // GIR_Coverage, 51832,
     /*   58482 */     GIR_EraseRootFromParent_Done,
     /*   58483 */   // Label 956: @58483
     /*   58483 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(58551), // Rule ID 51833 //
     /*   58488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   58503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   58507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   58511 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58525 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   58525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   58528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   58534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   58546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58549 */     GIR_RootConstrainSelectedInstOperands,
     /*   58550 */     // GIR_Coverage, 51833,
     /*   58550 */     GIR_EraseRootFromParent_Done,
     /*   58551 */   // Label 957: @58551
     /*   58551 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(58606), // Rule ID 47150 //
     /*   58556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   58571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58575 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58584 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   58587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58604 */     GIR_RootConstrainSelectedInstOperands,
     /*   58605 */     // GIR_Coverage, 47150,
     /*   58605 */     GIR_EraseRootFromParent_Done,
     /*   58606 */   // Label 958: @58606
     /*   58606 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(58661), // Rule ID 47151 //
     /*   58611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   58626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58639 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   58642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58659 */     GIR_RootConstrainSelectedInstOperands,
     /*   58660 */     // GIR_Coverage, 47151,
     /*   58660 */     GIR_EraseRootFromParent_Done,
     /*   58661 */   // Label 959: @58661
     /*   58661 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58716), // Rule ID 46910 //
     /*   58666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58685 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58694 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   58697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58714 */     GIR_RootConstrainSelectedInstOperands,
     /*   58715 */     // GIR_Coverage, 46910,
     /*   58715 */     GIR_EraseRootFromParent_Done,
     /*   58716 */   // Label 960: @58716
     /*   58716 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58771), // Rule ID 46911 //
     /*   58721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   58736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58740 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58749 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*   58752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58769 */     GIR_RootConstrainSelectedInstOperands,
     /*   58770 */     // GIR_Coverage, 46911,
     /*   58770 */     GIR_EraseRootFromParent_Done,
     /*   58771 */   // Label 961: @58771
     /*   58771 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58826), // Rule ID 47030 //
     /*   58776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58795 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58804 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   58804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   58807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58809 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58824 */     GIR_RootConstrainSelectedInstOperands,
     /*   58825 */     // GIR_Coverage, 47030,
     /*   58825 */     GIR_EraseRootFromParent_Done,
     /*   58826 */   // Label 962: @58826
     /*   58826 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58881), // Rule ID 47031 //
     /*   58831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   58842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   58846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   58850 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   58852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   58859 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   58859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*   58862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   58866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   58870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   58879 */     GIR_RootConstrainSelectedInstOperands,
     /*   58880 */     // GIR_Coverage, 47031,
     /*   58880 */     GIR_EraseRootFromParent_Done,
     /*   58881 */   // Label 963: @58881
     /*   58881 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58934), // Rule ID 46110 //
     /*   58886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   58889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58897 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   58897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   58914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   58921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   58929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58932 */     GIR_RootConstrainSelectedInstOperands,
     /*   58933 */     // GIR_Coverage, 46110,
     /*   58933 */     GIR_EraseRootFromParent_Done,
     /*   58934 */   // Label 964: @58934
     /*   58934 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58987), // Rule ID 46111 //
     /*   58939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   58942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   58950 */     // (sub:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   58950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   58953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   58957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   58962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   58964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   58967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   58969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   58972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   58974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   58976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   58979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   58982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   58985 */     GIR_RootConstrainSelectedInstOperands,
     /*   58986 */     // GIR_Coverage, 46111,
     /*   58986 */     GIR_EraseRootFromParent_Done,
     /*   58987 */   // Label 965: @58987
     /*   58987 */   GIM_Reject,
     /*   58988 */ // Label 949: @58988
     /*   58988 */ GIM_Reject,
     /*   58989 */ // Label 912: @58989
     /*   58989 */ GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(60111),
     /*   58994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   58997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   59000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59004 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(59093), // Rule ID 47114 //
     /*   59009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59052 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   59052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   59069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59091 */     GIR_RootConstrainSelectedInstOperands,
     /*   59092 */     // GIR_Coverage, 47114,
     /*   59092 */     GIR_EraseRootFromParent_Done,
     /*   59093 */   // Label 967: @59093
     /*   59093 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59182), // Rule ID 47115 //
     /*   59098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59141 */     // (sub:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   59141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   59158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59180 */     GIR_RootConstrainSelectedInstOperands,
     /*   59181 */     // GIR_Coverage, 47115,
     /*   59181 */     GIR_EraseRootFromParent_Done,
     /*   59182 */   // Label 968: @59182
     /*   59182 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59271), // Rule ID 46874 //
     /*   59187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59230 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   59230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   59247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59269 */     GIR_RootConstrainSelectedInstOperands,
     /*   59270 */     // GIR_Coverage, 46874,
     /*   59270 */     GIR_EraseRootFromParent_Done,
     /*   59271 */   // Label 969: @59271
     /*   59271 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59360), // Rule ID 46875 //
     /*   59276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59319 */     // (sub:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   59319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   59336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59358 */     GIR_RootConstrainSelectedInstOperands,
     /*   59359 */     // GIR_Coverage, 46875,
     /*   59359 */     GIR_EraseRootFromParent_Done,
     /*   59360 */   // Label 970: @59360
     /*   59360 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59449), // Rule ID 46994 //
     /*   59365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59408 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   59408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   59425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59447 */     GIR_RootConstrainSelectedInstOperands,
     /*   59448 */     // GIR_Coverage, 46994,
     /*   59448 */     GIR_EraseRootFromParent_Done,
     /*   59449 */   // Label 971: @59449
     /*   59449 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59538), // Rule ID 46995 //
     /*   59454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   59461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   59480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   59490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   59497 */     // (sub:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   59497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   59500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   59504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   59509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   59511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   59514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   59519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   59523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   59527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   59536 */     GIR_RootConstrainSelectedInstOperands,
     /*   59537 */     // GIR_Coverage, 46995,
     /*   59537 */     GIR_EraseRootFromParent_Done,
     /*   59538 */   // Label 972: @59538
     /*   59538 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59606), // Rule ID 51840 //
     /*   59543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   59562 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   59566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59580 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   59580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   59583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   59601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59604 */     GIR_RootConstrainSelectedInstOperands,
     /*   59605 */     // GIR_Coverage, 51840,
     /*   59605 */     GIR_EraseRootFromParent_Done,
     /*   59606 */   // Label 973: @59606
     /*   59606 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59674), // Rule ID 51841 //
     /*   59611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   59626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   59630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   59634 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59648 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   59648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   59651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   59657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   59669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59672 */     GIR_RootConstrainSelectedInstOperands,
     /*   59673 */     // GIR_Coverage, 51841,
     /*   59673 */     GIR_EraseRootFromParent_Done,
     /*   59674 */   // Label 974: @59674
     /*   59674 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(59729), // Rule ID 47174 //
     /*   59679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59707 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   59710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59727 */     GIR_RootConstrainSelectedInstOperands,
     /*   59728 */     // GIR_Coverage, 47174,
     /*   59728 */     GIR_EraseRootFromParent_Done,
     /*   59729 */   // Label 975: @59729
     /*   59729 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(59784), // Rule ID 47175 //
     /*   59734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   59749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59753 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59762 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   59765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59782 */     GIR_RootConstrainSelectedInstOperands,
     /*   59783 */     // GIR_Coverage, 47175,
     /*   59783 */     GIR_EraseRootFromParent_Done,
     /*   59784 */   // Label 976: @59784
     /*   59784 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(59839), // Rule ID 46934 //
     /*   59789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59817 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   59820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59837 */     GIR_RootConstrainSelectedInstOperands,
     /*   59838 */     // GIR_Coverage, 46934,
     /*   59838 */     GIR_EraseRootFromParent_Done,
     /*   59839 */   // Label 977: @59839
     /*   59839 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(59894), // Rule ID 46935 //
     /*   59844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   59859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59863 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59872 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   59875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59892 */     GIR_RootConstrainSelectedInstOperands,
     /*   59893 */     // GIR_Coverage, 46935,
     /*   59893 */     GIR_EraseRootFromParent_Done,
     /*   59894 */   // Label 978: @59894
     /*   59894 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(59949), // Rule ID 47054 //
     /*   59899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   59902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59918 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59927 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   59927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   59930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   59947 */     GIR_RootConstrainSelectedInstOperands,
     /*   59948 */     // GIR_Coverage, 47054,
     /*   59948 */     GIR_EraseRootFromParent_Done,
     /*   59949 */   // Label 979: @59949
     /*   59949 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(60004), // Rule ID 47055 //
     /*   59954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   59957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   59965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   59969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   59973 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   59975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   59980 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   59982 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   59982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   59985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   59987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   59989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   59993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   59996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   59999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60002 */     GIR_RootConstrainSelectedInstOperands,
     /*   60003 */     // GIR_Coverage, 47055,
     /*   60003 */     GIR_EraseRootFromParent_Done,
     /*   60004 */   // Label 980: @60004
     /*   60004 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60057), // Rule ID 46118 //
     /*   60009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   60012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60020 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   60020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   60023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   60037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60055 */     GIR_RootConstrainSelectedInstOperands,
     /*   60056 */     // GIR_Coverage, 46118,
     /*   60056 */     GIR_EraseRootFromParent_Done,
     /*   60057 */   // Label 981: @60057
     /*   60057 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(60110), // Rule ID 46119 //
     /*   60062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   60065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60073 */     // (sub:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   60073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   60076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   60090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   60097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   60099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60108 */     GIR_RootConstrainSelectedInstOperands,
     /*   60109 */     // GIR_Coverage, 46119,
     /*   60109 */     GIR_EraseRootFromParent_Done,
     /*   60110 */   // Label 982: @60110
     /*   60110 */   GIM_Reject,
     /*   60111 */ // Label 966: @60111
     /*   60111 */ GIM_Reject,
     /*   60112 */ // Label 913: @60112
     /*   60112 */ GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(61234),
     /*   60117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   60120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   60123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60127 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(60216), // Rule ID 47134 //
     /*   60132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   60135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60147 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60166 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60168 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60175 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   60175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   60192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60214 */     GIR_RootConstrainSelectedInstOperands,
     /*   60215 */     // GIR_Coverage, 47134,
     /*   60215 */     GIR_EraseRootFromParent_Done,
     /*   60216 */   // Label 984: @60216
     /*   60216 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(60305), // Rule ID 47135 //
     /*   60221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   60224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60236 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60255 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60262 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60264 */     // (sub:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   60264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60303 */     GIR_RootConstrainSelectedInstOperands,
     /*   60304 */     // GIR_Coverage, 47135,
     /*   60304 */     GIR_EraseRootFromParent_Done,
     /*   60305 */   // Label 985: @60305
     /*   60305 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(60394), // Rule ID 46894 //
     /*   60310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   60313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60325 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60344 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60353 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   60353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   60370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60392 */     GIR_RootConstrainSelectedInstOperands,
     /*   60393 */     // GIR_Coverage, 46894,
     /*   60393 */     GIR_EraseRootFromParent_Done,
     /*   60394 */   // Label 986: @60394
     /*   60394 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(60483), // Rule ID 46895 //
     /*   60399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   60402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60433 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60442 */     // (sub:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   60442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   60459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60481 */     GIR_RootConstrainSelectedInstOperands,
     /*   60482 */     // GIR_Coverage, 46895,
     /*   60482 */     GIR_EraseRootFromParent_Done,
     /*   60483 */   // Label 987: @60483
     /*   60483 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(60572), // Rule ID 47014 //
     /*   60488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   60491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60503 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60522 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60531 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   60531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   60548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60570 */     GIR_RootConstrainSelectedInstOperands,
     /*   60571 */     // GIR_Coverage, 47014,
     /*   60571 */     GIR_EraseRootFromParent_Done,
     /*   60572 */   // Label 988: @60572
     /*   60572 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60661), // Rule ID 47015 //
     /*   60577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   60580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   60584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60592 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   60603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   60607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60611 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   60613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   60620 */     // (sub:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   60620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   60623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   60627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   60632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   60634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   60637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   60642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   60646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   60650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   60659 */     GIR_RootConstrainSelectedInstOperands,
     /*   60660 */     // GIR_Coverage, 47015,
     /*   60660 */     GIR_EraseRootFromParent_Done,
     /*   60661 */   // Label 989: @60661
     /*   60661 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60729), // Rule ID 51856 //
     /*   60666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   60669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   60685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   60689 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60703 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   60703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   60706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   60724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60727 */     GIR_RootConstrainSelectedInstOperands,
     /*   60728 */     // GIR_Coverage, 51856,
     /*   60728 */     GIR_EraseRootFromParent_Done,
     /*   60729 */   // Label 990: @60729
     /*   60729 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60797), // Rule ID 51857 //
     /*   60734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   60737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   60749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   60753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   60757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60771 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   60771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   60774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   60780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   60792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60795 */     GIR_RootConstrainSelectedInstOperands,
     /*   60796 */     // GIR_Coverage, 51857,
     /*   60796 */     GIR_EraseRootFromParent_Done,
     /*   60797 */   // Label 991: @60797
     /*   60797 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60852), // Rule ID 47194 //
     /*   60802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   60805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60830 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   60830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   60833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60850 */     GIR_RootConstrainSelectedInstOperands,
     /*   60851 */     // GIR_Coverage, 47194,
     /*   60851 */     GIR_EraseRootFromParent_Done,
     /*   60852 */   // Label 992: @60852
     /*   60852 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60907), // Rule ID 47195 //
     /*   60857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   60860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   60872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60876 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60885 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   60885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   60888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60905 */     GIR_RootConstrainSelectedInstOperands,
     /*   60906 */     // GIR_Coverage, 47195,
     /*   60906 */     GIR_EraseRootFromParent_Done,
     /*   60907 */   // Label 993: @60907
     /*   60907 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60962), // Rule ID 46954 //
     /*   60912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   60915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60931 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60940 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   60940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   60943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   60945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   60947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   60951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   60954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   60957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   60960 */     GIR_RootConstrainSelectedInstOperands,
     /*   60961 */     // GIR_Coverage, 46954,
     /*   60961 */     GIR_EraseRootFromParent_Done,
     /*   60962 */   // Label 994: @60962
     /*   60962 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(61017), // Rule ID 46955 //
     /*   60967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   60970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   60978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   60982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   60986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   60988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   60993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   60995 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   60995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   60998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   61012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61015 */     GIR_RootConstrainSelectedInstOperands,
     /*   61016 */     // GIR_Coverage, 46955,
     /*   61016 */     GIR_EraseRootFromParent_Done,
     /*   61017 */   // Label 995: @61017
     /*   61017 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61072), // Rule ID 47074 //
     /*   61022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   61025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   61041 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61050 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   61050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   61053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   61067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61070 */     GIR_RootConstrainSelectedInstOperands,
     /*   61071 */     // GIR_Coverage, 47074,
     /*   61071 */     GIR_EraseRootFromParent_Done,
     /*   61072 */   // Label 996: @61072
     /*   61072 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61127), // Rule ID 47075 //
     /*   61077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   61080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   61096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61105 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   61105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   61108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   61122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61125 */     GIR_RootConstrainSelectedInstOperands,
     /*   61126 */     // GIR_Coverage, 47075,
     /*   61126 */     GIR_EraseRootFromParent_Done,
     /*   61127 */   // Label 997: @61127
     /*   61127 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61180), // Rule ID 46134 //
     /*   61132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   61135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61143 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   61143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   61146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   61160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   61175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61178 */     GIR_RootConstrainSelectedInstOperands,
     /*   61179 */     // GIR_Coverage, 46134,
     /*   61179 */     GIR_EraseRootFromParent_Done,
     /*   61180 */   // Label 998: @61180
     /*   61180 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61233), // Rule ID 46135 //
     /*   61185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   61188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61196 */     // (sub:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   61196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   61199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   61213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   61228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61231 */     GIR_RootConstrainSelectedInstOperands,
     /*   61232 */     // GIR_Coverage, 46135,
     /*   61232 */     GIR_EraseRootFromParent_Done,
     /*   61233 */   // Label 999: @61233
     /*   61233 */   GIM_Reject,
     /*   61234 */ // Label 983: @61234
     /*   61234 */ GIM_Reject,
     /*   61235 */ // Label 914: @61235
     /*   61235 */ GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61481),
     /*   61240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   61246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61254 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61318), // Rule ID 51824 //
     /*   61259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   61278 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61292 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   61292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   61295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61316 */     GIR_RootConstrainSelectedInstOperands,
     /*   61317 */     // GIR_Coverage, 51824,
     /*   61317 */     GIR_EraseRootFromParent_Done,
     /*   61318 */   // Label 1001: @61318
     /*   61318 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61382), // Rule ID 51825 //
     /*   61323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   61330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   61334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   61342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   61356 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs2, (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   61356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /*   61359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   61365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   61369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   61371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   61380 */     GIR_RootConstrainSelectedInstOperands,
     /*   61381 */     // GIR_Coverage, 51825,
     /*   61381 */     GIR_EraseRootFromParent_Done,
     /*   61382 */   // Label 1002: @61382
     /*   61382 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61431), // Rule ID 46102 //
     /*   61387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61394 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   61397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   61411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61429 */     GIR_RootConstrainSelectedInstOperands,
     /*   61430 */     // GIR_Coverage, 46102,
     /*   61430 */     GIR_EraseRootFromParent_Done,
     /*   61431 */   // Label 1003: @61431
     /*   61431 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61480), // Rule ID 46103 //
     /*   61436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61443 */     // (sub:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   61446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*   61460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   61467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   61469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61478 */     GIR_RootConstrainSelectedInstOperands,
     /*   61479 */     // GIR_Coverage, 46103,
     /*   61479 */     GIR_EraseRootFromParent_Done,
     /*   61480 */   // Label 1004: @61480
     /*   61480 */   GIM_Reject,
     /*   61481 */ // Label 1000: @61481
     /*   61481 */ GIM_Reject,
     /*   61482 */ // Label 915: @61482
     /*   61482 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(62604),
     /*   61487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   61490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   61493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61497 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(61586), // Rule ID 47094 //
     /*   61502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   61513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61517 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   61532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61536 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61543 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61545 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   61562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   61571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   61575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61584 */     GIR_RootConstrainSelectedInstOperands,
     /*   61585 */     // GIR_Coverage, 47094,
     /*   61585 */     GIR_EraseRootFromParent_Done,
     /*   61586 */   // Label 1006: @61586
     /*   61586 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(61675), // Rule ID 47095 //
     /*   61591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   61602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61606 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   61621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61625 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61634 */     // (sub:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   61651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   61660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   61664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61673 */     GIR_RootConstrainSelectedInstOperands,
     /*   61674 */     // GIR_Coverage, 47095,
     /*   61674 */     GIR_EraseRootFromParent_Done,
     /*   61675 */   // Label 1007: @61675
     /*   61675 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(61764), // Rule ID 46854 //
     /*   61680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   61691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61695 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61706 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   61710 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61714 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61716 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61723 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   61740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   61749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   61753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61762 */     GIR_RootConstrainSelectedInstOperands,
     /*   61763 */     // GIR_Coverage, 46854,
     /*   61763 */     GIR_EraseRootFromParent_Done,
     /*   61764 */   // Label 1008: @61764
     /*   61764 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(61853), // Rule ID 46855 //
     /*   61769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   61780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61784 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   61799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61803 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61812 */     // (sub:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*   61829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   61838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   61842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61851 */     GIR_RootConstrainSelectedInstOperands,
     /*   61852 */     // GIR_Coverage, 46855,
     /*   61852 */     GIR_EraseRootFromParent_Done,
     /*   61853 */   // Label 1009: @61853
     /*   61853 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61942), // Rule ID 46974 //
     /*   61858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   61861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61873 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61892 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61901 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   61901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   61913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   61915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   61918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   61920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   61923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   61927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   61931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   61934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   61940 */     GIR_RootConstrainSelectedInstOperands,
     /*   61941 */     // GIR_Coverage, 46974,
     /*   61941 */     GIR_EraseRootFromParent_Done,
     /*   61942 */   // Label 1010: @61942
     /*   61942 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(62031), // Rule ID 46975 //
     /*   61947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   61950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   61954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61962 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   61964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   61973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   61977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   61981 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   61983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   61988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   61990 */     // (sub:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   61990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   61993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   61997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*   62007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62029 */     GIR_RootConstrainSelectedInstOperands,
     /*   62030 */     // GIR_Coverage, 46975,
     /*   62030 */     GIR_EraseRootFromParent_Done,
     /*   62031 */   // Label 1011: @62031
     /*   62031 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(62099), // Rule ID 51836 //
     /*   62036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   62059 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62073 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   62073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   62076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62097 */     GIR_RootConstrainSelectedInstOperands,
     /*   62098 */     // GIR_Coverage, 51836,
     /*   62098 */     GIR_EraseRootFromParent_Done,
     /*   62099 */   // Label 1012: @62099
     /*   62099 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(62167), // Rule ID 51837 //
     /*   62104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   62119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   62127 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62141 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   62141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   62144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   62150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62165 */     GIR_RootConstrainSelectedInstOperands,
     /*   62166 */     // GIR_Coverage, 51837,
     /*   62166 */     GIR_EraseRootFromParent_Done,
     /*   62167 */   // Label 1013: @62167
     /*   62167 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(62222), // Rule ID 47154 //
     /*   62172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62191 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62200 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   62203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62220 */     GIR_RootConstrainSelectedInstOperands,
     /*   62221 */     // GIR_Coverage, 47154,
     /*   62221 */     GIR_EraseRootFromParent_Done,
     /*   62222 */   // Label 1014: @62222
     /*   62222 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(62277), // Rule ID 47155 //
     /*   62227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62246 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62255 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   62258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62275 */     GIR_RootConstrainSelectedInstOperands,
     /*   62276 */     // GIR_Coverage, 47155,
     /*   62276 */     GIR_EraseRootFromParent_Done,
     /*   62277 */   // Label 1015: @62277
     /*   62277 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62332), // Rule ID 46914 //
     /*   62282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62310 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   62313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62330 */     GIR_RootConstrainSelectedInstOperands,
     /*   62331 */     // GIR_Coverage, 46914,
     /*   62331 */     GIR_EraseRootFromParent_Done,
     /*   62332 */   // Label 1016: @62332
     /*   62332 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62387), // Rule ID 46915 //
     /*   62337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62356 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62365 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*   62368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62385 */     GIR_RootConstrainSelectedInstOperands,
     /*   62386 */     // GIR_Coverage, 46915,
     /*   62386 */     GIR_EraseRootFromParent_Done,
     /*   62387 */   // Label 1017: @62387
     /*   62387 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62442), // Rule ID 47034 //
     /*   62392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62420 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   62420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   62423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62440 */     GIR_RootConstrainSelectedInstOperands,
     /*   62441 */     // GIR_Coverage, 47034,
     /*   62441 */     GIR_EraseRootFromParent_Done,
     /*   62442 */   // Label 1018: @62442
     /*   62442 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62497), // Rule ID 47035 //
     /*   62447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   62458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   62466 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   62475 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   62475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*   62478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   62482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   62486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   62495 */     GIR_RootConstrainSelectedInstOperands,
     /*   62496 */     // GIR_Coverage, 47035,
     /*   62496 */     GIR_EraseRootFromParent_Done,
     /*   62497 */   // Label 1019: @62497
     /*   62497 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(62550), // Rule ID 46114 //
     /*   62502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62513 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   62513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   62516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   62530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62548 */     GIR_RootConstrainSelectedInstOperands,
     /*   62549 */     // GIR_Coverage, 46114,
     /*   62549 */     GIR_EraseRootFromParent_Done,
     /*   62550 */   // Label 1020: @62550
     /*   62550 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(62603), // Rule ID 46115 //
     /*   62555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62566 */     // (sub:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   62566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   62569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   62583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62588 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   62590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   62592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62601 */     GIR_RootConstrainSelectedInstOperands,
     /*   62602 */     // GIR_Coverage, 46115,
     /*   62602 */     GIR_EraseRootFromParent_Done,
     /*   62603 */   // Label 1021: @62603
     /*   62603 */   GIM_Reject,
     /*   62604 */ // Label 1005: @62604
     /*   62604 */ GIM_Reject,
     /*   62605 */ // Label 916: @62605
     /*   62605 */ GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(63727),
     /*   62610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   62613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   62616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62620 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(62709), // Rule ID 47118 //
     /*   62625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62640 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62659 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62668 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   62668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   62671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   62685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62707 */     GIR_RootConstrainSelectedInstOperands,
     /*   62708 */     // GIR_Coverage, 47118,
     /*   62708 */     GIR_EraseRootFromParent_Done,
     /*   62709 */   // Label 1023: @62709
     /*   62709 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(62798), // Rule ID 47119 //
     /*   62714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62729 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   62744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62748 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62757 */     // (sub:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   62757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   62760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   62774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62796 */     GIR_RootConstrainSelectedInstOperands,
     /*   62797 */     // GIR_Coverage, 47119,
     /*   62797 */     GIR_EraseRootFromParent_Done,
     /*   62798 */   // Label 1024: @62798
     /*   62798 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(62887), // Rule ID 46878 //
     /*   62803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62818 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62837 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62846 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   62846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   62849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   62863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62885 */     GIR_RootConstrainSelectedInstOperands,
     /*   62886 */     // GIR_Coverage, 46878,
     /*   62886 */     GIR_EraseRootFromParent_Done,
     /*   62887 */   // Label 1025: @62887
     /*   62887 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(62976), // Rule ID 46879 //
     /*   62892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   62895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   62918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   62922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62926 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   62928 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   62933 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   62935 */     // (sub:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   62935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   62938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   62942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   62947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   62949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   62952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   62954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   62957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   62961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   62965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   62968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   62971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   62974 */     GIR_RootConstrainSelectedInstOperands,
     /*   62975 */     // GIR_Coverage, 46879,
     /*   62975 */     GIR_EraseRootFromParent_Done,
     /*   62976 */   // Label 1026: @62976
     /*   62976 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(63065), // Rule ID 46998 //
     /*   62981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   62984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   62988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   62992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   62996 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   62998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63015 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63017 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63022 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63024 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   63024 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   63027 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63031 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   63041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63043 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63063 */     GIR_RootConstrainSelectedInstOperands,
     /*   63064 */     // GIR_Coverage, 46998,
     /*   63064 */     GIR_EraseRootFromParent_Done,
     /*   63065 */   // Label 1027: @63065
     /*   63065 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(63154), // Rule ID 46999 //
     /*   63070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63085 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63113 */     // (sub:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   63113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   63116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   63130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63152 */     GIR_RootConstrainSelectedInstOperands,
     /*   63153 */     // GIR_Coverage, 46999,
     /*   63153 */     GIR_EraseRootFromParent_Done,
     /*   63154 */   // Label 1028: @63154
     /*   63154 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(63222), // Rule ID 51852 //
     /*   63159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63178 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   63182 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63196 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   63196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   63199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63220 */     GIR_RootConstrainSelectedInstOperands,
     /*   63221 */     // GIR_Coverage, 51852,
     /*   63221 */     GIR_EraseRootFromParent_Done,
     /*   63222 */   // Label 1029: @63222
     /*   63222 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(63290), // Rule ID 51853 //
     /*   63227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   63242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   63250 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63257 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63264 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   63264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   63267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   63273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63288 */     GIR_RootConstrainSelectedInstOperands,
     /*   63289 */     // GIR_Coverage, 51853,
     /*   63289 */     GIR_EraseRootFromParent_Done,
     /*   63290 */   // Label 1030: @63290
     /*   63290 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(63345), // Rule ID 47178 //
     /*   63295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63323 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   63326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63343 */     GIR_RootConstrainSelectedInstOperands,
     /*   63344 */     // GIR_Coverage, 47178,
     /*   63344 */     GIR_EraseRootFromParent_Done,
     /*   63345 */   // Label 1031: @63345
     /*   63345 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(63400), // Rule ID 47179 //
     /*   63350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63369 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63378 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   63381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63398 */     GIR_RootConstrainSelectedInstOperands,
     /*   63399 */     // GIR_Coverage, 47179,
     /*   63399 */     GIR_EraseRootFromParent_Done,
     /*   63400 */   // Label 1032: @63400
     /*   63400 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(63455), // Rule ID 46938 //
     /*   63405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63424 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63433 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   63436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63453 */     GIR_RootConstrainSelectedInstOperands,
     /*   63454 */     // GIR_Coverage, 46938,
     /*   63454 */     GIR_EraseRootFromParent_Done,
     /*   63455 */   // Label 1033: @63455
     /*   63455 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(63510), // Rule ID 46939 //
     /*   63460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63479 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63488 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   63491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63508 */     GIR_RootConstrainSelectedInstOperands,
     /*   63509 */     // GIR_Coverage, 46939,
     /*   63509 */     GIR_EraseRootFromParent_Done,
     /*   63510 */   // Label 1034: @63510
     /*   63510 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(63565), // Rule ID 47058 //
     /*   63515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63534 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63543 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   63543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   63546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63563 */     GIR_RootConstrainSelectedInstOperands,
     /*   63564 */     // GIR_Coverage, 47058,
     /*   63564 */     GIR_EraseRootFromParent_Done,
     /*   63565 */   // Label 1035: @63565
     /*   63565 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(63620), // Rule ID 47059 //
     /*   63570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   63581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   63585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   63589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   63598 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   63598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   63601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   63605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   63609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   63615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   63618 */     GIR_RootConstrainSelectedInstOperands,
     /*   63619 */     // GIR_Coverage, 47059,
     /*   63619 */     GIR_EraseRootFromParent_Done,
     /*   63620 */   // Label 1036: @63620
     /*   63620 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(63673), // Rule ID 46130 //
     /*   63625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   63628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63636 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   63636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   63639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   63653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63671 */     GIR_RootConstrainSelectedInstOperands,
     /*   63672 */     // GIR_Coverage, 46130,
     /*   63672 */     GIR_EraseRootFromParent_Done,
     /*   63673 */   // Label 1037: @63673
     /*   63673 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(63726), // Rule ID 46131 //
     /*   63678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   63681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63689 */     // (sub:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   63689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   63692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   63706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   63713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   63715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63724 */     GIR_RootConstrainSelectedInstOperands,
     /*   63725 */     // GIR_Coverage, 46131,
     /*   63725 */     GIR_EraseRootFromParent_Done,
     /*   63726 */   // Label 1038: @63726
     /*   63726 */   GIM_Reject,
     /*   63727 */ // Label 1022: @63727
     /*   63727 */ GIM_Reject,
     /*   63728 */ // Label 917: @63728
     /*   63728 */ GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(64850),
     /*   63733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   63736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   63739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   63743 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(63832), // Rule ID 47138 //
     /*   63748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   63751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63763 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63782 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63791 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   63791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   63794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   63808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63830 */     GIR_RootConstrainSelectedInstOperands,
     /*   63831 */     // GIR_Coverage, 47138,
     /*   63831 */     GIR_EraseRootFromParent_Done,
     /*   63832 */   // Label 1040: @63832
     /*   63832 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(63921), // Rule ID 47139 //
     /*   63837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   63840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63852 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   63867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63871 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63880 */     // (sub:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   63880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   63883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   63897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   63913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   63916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   63919 */     GIR_RootConstrainSelectedInstOperands,
     /*   63920 */     // GIR_Coverage, 47139,
     /*   63920 */     GIR_EraseRootFromParent_Done,
     /*   63921 */   // Label 1041: @63921
     /*   63921 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(64010), // Rule ID 46898 //
     /*   63926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   63929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   63933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63941 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   63943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   63952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   63956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   63960 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   63962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   63967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   63969 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   63969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   63972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   63976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   63981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   63983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   63986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   63988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   63991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   63995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   63999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64008 */     GIR_RootConstrainSelectedInstOperands,
     /*   64009 */     // GIR_Coverage, 46898,
     /*   64009 */     GIR_EraseRootFromParent_Done,
     /*   64010 */   // Label 1042: @64010
     /*   64010 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(64099), // Rule ID 46899 //
     /*   64015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64049 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64058 */     // (sub:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   64061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   64075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64097 */     GIR_RootConstrainSelectedInstOperands,
     /*   64098 */     // GIR_Coverage, 46899,
     /*   64098 */     GIR_EraseRootFromParent_Done,
     /*   64099 */   // Label 1043: @64099
     /*   64099 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(64188), // Rule ID 47018 //
     /*   64104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64119 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64138 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64147 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   64147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   64150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   64164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64186 */     GIR_RootConstrainSelectedInstOperands,
     /*   64187 */     // GIR_Coverage, 47018,
     /*   64187 */     GIR_EraseRootFromParent_Done,
     /*   64188 */   // Label 1044: @64188
     /*   64188 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(64277), // Rule ID 47019 //
     /*   64193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   64200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64208 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   64219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64227 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   64229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   64236 */     // (sub:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   64236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   64239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   64253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64255 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   64262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   64266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64275 */     GIR_RootConstrainSelectedInstOperands,
     /*   64276 */     // GIR_Coverage, 47019,
     /*   64276 */     GIR_EraseRootFromParent_Done,
     /*   64277 */   // Label 1045: @64277
     /*   64277 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(64345), // Rule ID 51896 //
     /*   64282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   64301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   64305 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64319 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   64319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   64322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64343 */     GIR_RootConstrainSelectedInstOperands,
     /*   64344 */     // GIR_Coverage, 51896,
     /*   64344 */     GIR_EraseRootFromParent_Done,
     /*   64345 */   // Label 1046: @64345
     /*   64345 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(64413), // Rule ID 51897 //
     /*   64350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   64369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   64373 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64387 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   64387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   64390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64411 */     GIR_RootConstrainSelectedInstOperands,
     /*   64412 */     // GIR_Coverage, 51897,
     /*   64412 */     GIR_EraseRootFromParent_Done,
     /*   64413 */   // Label 1047: @64413
     /*   64413 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(64468), // Rule ID 47198 //
     /*   64418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64446 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   64449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64466 */     GIR_RootConstrainSelectedInstOperands,
     /*   64467 */     // GIR_Coverage, 47198,
     /*   64467 */     GIR_EraseRootFromParent_Done,
     /*   64468 */   // Label 1048: @64468
     /*   64468 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(64523), // Rule ID 47199 //
     /*   64473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   64488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64501 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   64504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64521 */     GIR_RootConstrainSelectedInstOperands,
     /*   64522 */     // GIR_Coverage, 47199,
     /*   64522 */     GIR_EraseRootFromParent_Done,
     /*   64523 */   // Label 1049: @64523
     /*   64523 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(64578), // Rule ID 46958 //
     /*   64528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64547 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64556 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   64559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64576 */     GIR_RootConstrainSelectedInstOperands,
     /*   64577 */     // GIR_Coverage, 46958,
     /*   64577 */     GIR_EraseRootFromParent_Done,
     /*   64578 */   // Label 1050: @64578
     /*   64578 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(64633), // Rule ID 46959 //
     /*   64583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   64598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64611 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   64614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64631 */     GIR_RootConstrainSelectedInstOperands,
     /*   64632 */     // GIR_Coverage, 46959,
     /*   64632 */     GIR_EraseRootFromParent_Done,
     /*   64633 */   // Label 1051: @64633
     /*   64633 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(64688), // Rule ID 47078 //
     /*   64638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   64641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64657 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64666 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   64666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   64669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64686 */     GIR_RootConstrainSelectedInstOperands,
     /*   64687 */     // GIR_Coverage, 47078,
     /*   64687 */     GIR_EraseRootFromParent_Done,
     /*   64688 */   // Label 1052: @64688
     /*   64688 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(64743), // Rule ID 47079 //
     /*   64693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   64696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   64708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   64712 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64721 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   64721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   64724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   64738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64741 */     GIR_RootConstrainSelectedInstOperands,
     /*   64742 */     // GIR_Coverage, 47079,
     /*   64742 */     GIR_EraseRootFromParent_Done,
     /*   64743 */   // Label 1053: @64743
     /*   64743 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(64796), // Rule ID 46174 //
     /*   64748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   64751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64759 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   64759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   64762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   64776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64794 */     GIR_RootConstrainSelectedInstOperands,
     /*   64795 */     // GIR_Coverage, 46174,
     /*   64795 */     GIR_EraseRootFromParent_Done,
     /*   64796 */   // Label 1054: @64796
     /*   64796 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(64849), // Rule ID 46175 //
     /*   64801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   64804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   64812 */     // (sub:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   64812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   64815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   64819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   64824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   64826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   64829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   64834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   64836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   64838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   64844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64847 */     GIR_RootConstrainSelectedInstOperands,
     /*   64848 */     // GIR_Coverage, 46175,
     /*   64848 */     GIR_EraseRootFromParent_Done,
     /*   64849 */   // Label 1055: @64849
     /*   64849 */   GIM_Reject,
     /*   64850 */ // Label 1039: @64850
     /*   64850 */ GIM_Reject,
     /*   64851 */ // Label 918: @64851
     /*   64851 */ GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(65097),
     /*   64856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   64859 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   64862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64870 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(64934), // Rule ID 51828 //
     /*   64875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   64878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   64890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   64894 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64908 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   64908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64932 */     GIR_RootConstrainSelectedInstOperands,
     /*   64933 */     // GIR_Coverage, 51828,
     /*   64933 */     GIR_EraseRootFromParent_Done,
     /*   64934 */   // Label 1057: @64934
     /*   64934 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(64998), // Rule ID 51829 //
     /*   64939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   64942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   64946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   64950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   64954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   64958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   64960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   64970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   64972 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs2, (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   64972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /*   64975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   64977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   64981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   64985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   64987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   64990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   64993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   64996 */     GIR_RootConstrainSelectedInstOperands,
     /*   64997 */     // GIR_Coverage, 51829,
     /*   64997 */     GIR_EraseRootFromParent_Done,
     /*   64998 */   // Label 1058: @64998
     /*   64998 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(65047), // Rule ID 46106 //
     /*   65003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65010 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   65013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   65027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65045 */     GIR_RootConstrainSelectedInstOperands,
     /*   65046 */     // GIR_Coverage, 46106,
     /*   65046 */     GIR_EraseRootFromParent_Done,
     /*   65047 */   // Label 1059: @65047
     /*   65047 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(65096), // Rule ID 46107 //
     /*   65052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65059 */     // (sub:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   65062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65071 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*   65076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65081 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   65083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   65085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65094 */     GIR_RootConstrainSelectedInstOperands,
     /*   65095 */     // GIR_Coverage, 46107,
     /*   65095 */     GIR_EraseRootFromParent_Done,
     /*   65096 */   // Label 1060: @65096
     /*   65096 */   GIM_Reject,
     /*   65097 */ // Label 1056: @65097
     /*   65097 */ GIM_Reject,
     /*   65098 */ // Label 919: @65098
     /*   65098 */ GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(66220),
     /*   65103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   65106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   65109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65113 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(65202), // Rule ID 47098 //
     /*   65118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65133 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65152 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65161 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65200 */     GIR_RootConstrainSelectedInstOperands,
     /*   65201 */     // GIR_Coverage, 47098,
     /*   65201 */     GIR_EraseRootFromParent_Done,
     /*   65202 */   // Label 1062: @65202
     /*   65202 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(65291), // Rule ID 47099 //
     /*   65207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65222 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65241 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65250 */     // (sub:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65289 */     GIR_RootConstrainSelectedInstOperands,
     /*   65290 */     // GIR_Coverage, 47099,
     /*   65290 */     GIR_EraseRootFromParent_Done,
     /*   65291 */   // Label 1063: @65291
     /*   65291 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(65380), // Rule ID 46858 //
     /*   65296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65311 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65330 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65339 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   65356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65378 */     GIR_RootConstrainSelectedInstOperands,
     /*   65379 */     // GIR_Coverage, 46858,
     /*   65379 */     GIR_EraseRootFromParent_Done,
     /*   65380 */   // Label 1064: @65380
     /*   65380 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(65469), // Rule ID 46859 //
     /*   65385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65419 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65421 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65428 */     // (sub:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*   65445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65467 */     GIR_RootConstrainSelectedInstOperands,
     /*   65468 */     // GIR_Coverage, 46859,
     /*   65468 */     GIR_EraseRootFromParent_Done,
     /*   65469 */   // Label 1065: @65469
     /*   65469 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(65558), // Rule ID 46978 //
     /*   65474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65489 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65508 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65517 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   65517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65556 */     GIR_RootConstrainSelectedInstOperands,
     /*   65557 */     // GIR_Coverage, 46978,
     /*   65557 */     GIR_EraseRootFromParent_Done,
     /*   65558 */   // Label 1066: @65558
     /*   65558 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(65647), // Rule ID 46979 //
     /*   65563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   65570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65578 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   65589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   65593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65597 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   65599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   65606 */     // (sub:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   65606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   65609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   65613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   65618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   65620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*   65623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   65628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   65632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   65636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65645 */     GIR_RootConstrainSelectedInstOperands,
     /*   65646 */     // GIR_Coverage, 46979,
     /*   65646 */     GIR_EraseRootFromParent_Done,
     /*   65647 */   // Label 1067: @65647
     /*   65647 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(65715), // Rule ID 51848 //
     /*   65652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   65671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   65675 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65689 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   65689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   65710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65713 */     GIR_RootConstrainSelectedInstOperands,
     /*   65714 */     // GIR_Coverage, 51848,
     /*   65714 */     GIR_EraseRootFromParent_Done,
     /*   65715 */   // Label 1068: @65715
     /*   65715 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(65783), // Rule ID 51849 //
     /*   65720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   65735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   65739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   65743 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65757 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   65757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   65760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   65766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   65778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65781 */     GIR_RootConstrainSelectedInstOperands,
     /*   65782 */     // GIR_Coverage, 51849,
     /*   65782 */     GIR_EraseRootFromParent_Done,
     /*   65783 */   // Label 1069: @65783
     /*   65783 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(65838), // Rule ID 47158 //
     /*   65788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65816 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65836 */     GIR_RootConstrainSelectedInstOperands,
     /*   65837 */     // GIR_Coverage, 47158,
     /*   65837 */     GIR_EraseRootFromParent_Done,
     /*   65838 */   // Label 1070: @65838
     /*   65838 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(65893), // Rule ID 47159 //
     /*   65843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   65858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65862 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65871 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   65874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65891 */     GIR_RootConstrainSelectedInstOperands,
     /*   65892 */     // GIR_Coverage, 47159,
     /*   65892 */     GIR_EraseRootFromParent_Done,
     /*   65893 */   // Label 1071: @65893
     /*   65893 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(65948), // Rule ID 46918 //
     /*   65898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   65901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65917 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65926 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   65926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   65946 */     GIR_RootConstrainSelectedInstOperands,
     /*   65947 */     // GIR_Coverage, 46918,
     /*   65947 */     GIR_EraseRootFromParent_Done,
     /*   65948 */   // Label 1072: @65948
     /*   65948 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(66003), // Rule ID 46919 //
     /*   65953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   65956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   65964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   65968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   65972 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   65974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   65979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   65981 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   65981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*   65984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   65986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   65988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   65992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   65995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   65998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66001 */     GIR_RootConstrainSelectedInstOperands,
     /*   66002 */     // GIR_Coverage, 46919,
     /*   66002 */     GIR_EraseRootFromParent_Done,
     /*   66003 */   // Label 1073: @66003
     /*   66003 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(66058), // Rule ID 47038 //
     /*   66008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   66027 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66036 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   66036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   66039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66056 */     GIR_RootConstrainSelectedInstOperands,
     /*   66057 */     // GIR_Coverage, 47038,
     /*   66057 */     GIR_EraseRootFromParent_Done,
     /*   66058 */   // Label 1074: @66058
     /*   66058 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(66113), // Rule ID 47039 //
     /*   66063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   66082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66091 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   66091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*   66094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66111 */     GIR_RootConstrainSelectedInstOperands,
     /*   66112 */     // GIR_Coverage, 47039,
     /*   66112 */     GIR_EraseRootFromParent_Done,
     /*   66113 */   // Label 1075: @66113
     /*   66113 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(66166), // Rule ID 46126 //
     /*   66118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66129 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   66132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   66146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66164 */     GIR_RootConstrainSelectedInstOperands,
     /*   66165 */     // GIR_Coverage, 46126,
     /*   66165 */     GIR_EraseRootFromParent_Done,
     /*   66166 */   // Label 1076: @66166
     /*   66166 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(66219), // Rule ID 46127 //
     /*   66171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66182 */     // (sub:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   66185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   66199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   66206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   66208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66217 */     GIR_RootConstrainSelectedInstOperands,
     /*   66218 */     // GIR_Coverage, 46127,
     /*   66218 */     GIR_EraseRootFromParent_Done,
     /*   66219 */   // Label 1077: @66219
     /*   66219 */   GIM_Reject,
     /*   66220 */ // Label 1061: @66220
     /*   66220 */ GIM_Reject,
     /*   66221 */ // Label 920: @66221
     /*   66221 */ GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(67343),
     /*   66226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   66229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   66232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66236 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(66325), // Rule ID 47122 //
     /*   66241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66284 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   66301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66323 */     GIR_RootConstrainSelectedInstOperands,
     /*   66324 */     // GIR_Coverage, 47122,
     /*   66324 */     GIR_EraseRootFromParent_Done,
     /*   66325 */   // Label 1079: @66325
     /*   66325 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(66414), // Rule ID 47123 //
     /*   66330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66373 */     // (sub:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   66390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66412 */     GIR_RootConstrainSelectedInstOperands,
     /*   66413 */     // GIR_Coverage, 47123,
     /*   66413 */     GIR_EraseRootFromParent_Done,
     /*   66414 */   // Label 1080: @66414
     /*   66414 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(66503), // Rule ID 46882 //
     /*   66419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66462 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   66479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66501 */     GIR_RootConstrainSelectedInstOperands,
     /*   66502 */     // GIR_Coverage, 46882,
     /*   66502 */     GIR_EraseRootFromParent_Done,
     /*   66503 */   // Label 1081: @66503
     /*   66503 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(66592), // Rule ID 46883 //
     /*   66508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   66538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66551 */     // (sub:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   66568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66590 */     GIR_RootConstrainSelectedInstOperands,
     /*   66591 */     // GIR_Coverage, 46883,
     /*   66591 */     GIR_EraseRootFromParent_Done,
     /*   66592 */   // Label 1082: @66592
     /*   66592 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(66681), // Rule ID 47002 //
     /*   66597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66640 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   66640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   66657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66679 */     GIR_RootConstrainSelectedInstOperands,
     /*   66680 */     // GIR_Coverage, 47002,
     /*   66680 */     GIR_EraseRootFromParent_Done,
     /*   66681 */   // Label 1083: @66681
     /*   66681 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(66770), // Rule ID 47003 //
     /*   66686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   66693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   66712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   66716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   66722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   66729 */     // (sub:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   66729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   66732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   66736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   66741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   66743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   66746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   66751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   66755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   66759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   66768 */     GIR_RootConstrainSelectedInstOperands,
     /*   66769 */     // GIR_Coverage, 47003,
     /*   66769 */     GIR_EraseRootFromParent_Done,
     /*   66770 */   // Label 1084: @66770
     /*   66770 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(66838), // Rule ID 51884 //
     /*   66775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   66794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   66798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66812 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   66812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   66815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   66833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66836 */     GIR_RootConstrainSelectedInstOperands,
     /*   66837 */     // GIR_Coverage, 51884,
     /*   66837 */     GIR_EraseRootFromParent_Done,
     /*   66838 */   // Label 1085: @66838
     /*   66838 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(66906), // Rule ID 51885 //
     /*   66843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   66858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   66862 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   66866 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66880 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   66880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   66883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   66889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   66901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66904 */     GIR_RootConstrainSelectedInstOperands,
     /*   66905 */     // GIR_Coverage, 51885,
     /*   66905 */     GIR_EraseRootFromParent_Done,
     /*   66906 */   // Label 1086: @66906
     /*   66906 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(66961), // Rule ID 47182 //
     /*   66911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   66914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66930 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66939 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   66939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   66942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   66946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   66950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   66953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   66956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   66959 */     GIR_RootConstrainSelectedInstOperands,
     /*   66960 */     // GIR_Coverage, 47182,
     /*   66960 */     GIR_EraseRootFromParent_Done,
     /*   66961 */   // Label 1087: @66961
     /*   66961 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(67016), // Rule ID 47183 //
     /*   66966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   66969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   66973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   66977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   66981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   66985 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   66987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   66992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   66994 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   66994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   66997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   66999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67014 */     GIR_RootConstrainSelectedInstOperands,
     /*   67015 */     // GIR_Coverage, 47183,
     /*   67015 */     GIR_EraseRootFromParent_Done,
     /*   67016 */   // Label 1088: @67016
     /*   67016 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(67071), // Rule ID 46942 //
     /*   67021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   67040 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67042 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67049 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   67052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67069 */     GIR_RootConstrainSelectedInstOperands,
     /*   67070 */     // GIR_Coverage, 46942,
     /*   67070 */     GIR_EraseRootFromParent_Done,
     /*   67071 */   // Label 1089: @67071
     /*   67071 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(67126), // Rule ID 46943 //
     /*   67076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   67095 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67104 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   67107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67124 */     GIR_RootConstrainSelectedInstOperands,
     /*   67125 */     // GIR_Coverage, 46943,
     /*   67125 */     GIR_EraseRootFromParent_Done,
     /*   67126 */   // Label 1090: @67126
     /*   67126 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(67181), // Rule ID 47062 //
     /*   67131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   67150 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67159 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   67159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   67162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67179 */     GIR_RootConstrainSelectedInstOperands,
     /*   67180 */     // GIR_Coverage, 47062,
     /*   67180 */     GIR_EraseRootFromParent_Done,
     /*   67181 */   // Label 1091: @67181
     /*   67181 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(67236), // Rule ID 47063 //
     /*   67186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   67205 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   67212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67214 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   67214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   67217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   67231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67234 */     GIR_RootConstrainSelectedInstOperands,
     /*   67235 */     // GIR_Coverage, 47063,
     /*   67235 */     GIR_EraseRootFromParent_Done,
     /*   67236 */   // Label 1092: @67236
     /*   67236 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(67289), // Rule ID 46162 //
     /*   67241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   67244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67252 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   67255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   67269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67287 */     GIR_RootConstrainSelectedInstOperands,
     /*   67288 */     // GIR_Coverage, 46162,
     /*   67288 */     GIR_EraseRootFromParent_Done,
     /*   67289 */   // Label 1093: @67289
     /*   67289 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(67342), // Rule ID 46163 //
     /*   67294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   67297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67305 */     // (sub:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   67308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   67322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   67329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   67331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67340 */     GIR_RootConstrainSelectedInstOperands,
     /*   67341 */     // GIR_Coverage, 46163,
     /*   67341 */     GIR_EraseRootFromParent_Done,
     /*   67342 */   // Label 1094: @67342
     /*   67342 */   GIM_Reject,
     /*   67343 */ // Label 1078: @67343
     /*   67343 */ GIM_Reject,
     /*   67344 */ // Label 921: @67344
     /*   67344 */ GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(68466),
     /*   67349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   67352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   67355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67359 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(67448), // Rule ID 47142 //
     /*   67364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67379 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67398 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67405 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67407 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   67424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67446 */     GIR_RootConstrainSelectedInstOperands,
     /*   67447 */     // GIR_Coverage, 47142,
     /*   67447 */     GIR_EraseRootFromParent_Done,
     /*   67448 */   // Label 1096: @67448
     /*   67448 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(67537), // Rule ID 47143 //
     /*   67453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   67483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67487 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67496 */     // (sub:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   67513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67535 */     GIR_RootConstrainSelectedInstOperands,
     /*   67536 */     // GIR_Coverage, 47143,
     /*   67536 */     GIR_EraseRootFromParent_Done,
     /*   67537 */   // Label 1097: @67537
     /*   67537 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(67626), // Rule ID 46902 //
     /*   67542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67557 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67576 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67585 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   67602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67624 */     GIR_RootConstrainSelectedInstOperands,
     /*   67625 */     // GIR_Coverage, 46902,
     /*   67625 */     GIR_EraseRootFromParent_Done,
     /*   67626 */   // Label 1098: @67626
     /*   67626 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(67715), // Rule ID 46903 //
     /*   67631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67646 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   67661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67665 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67674 */     // (sub:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   67691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67713 */     GIR_RootConstrainSelectedInstOperands,
     /*   67714 */     // GIR_Coverage, 46903,
     /*   67714 */     GIR_EraseRootFromParent_Done,
     /*   67715 */   // Label 1099: @67715
     /*   67715 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(67804), // Rule ID 47022 //
     /*   67720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   67723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67735 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67742 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67746 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67750 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67754 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67763 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   67763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   67780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67802 */     GIR_RootConstrainSelectedInstOperands,
     /*   67803 */     // GIR_Coverage, 47022,
     /*   67803 */     GIR_EraseRootFromParent_Done,
     /*   67804 */   // Label 1100: @67804
     /*   67804 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(67893), // Rule ID 47023 //
     /*   67809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   67812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   67816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67824 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   67835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   67839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   67843 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   67845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   67850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   67852 */     // (sub:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   67852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   67855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   67859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   67864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   67866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   67869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   67874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   67878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   67882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   67888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   67891 */     GIR_RootConstrainSelectedInstOperands,
     /*   67892 */     // GIR_Coverage, 47023,
     /*   67892 */     GIR_EraseRootFromParent_Done,
     /*   67893 */   // Label 1101: @67893
     /*   67893 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(67961), // Rule ID 51900 //
     /*   67898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   67901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   67917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   67921 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   67935 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   67935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   67938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   67940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   67944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   67948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   67950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   67953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   67956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   67959 */     GIR_RootConstrainSelectedInstOperands,
     /*   67960 */     // GIR_Coverage, 51900,
     /*   67960 */     GIR_EraseRootFromParent_Done,
     /*   67961 */   // Label 1102: @67961
     /*   67961 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(68029), // Rule ID 51901 //
     /*   67966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   67969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   67977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   67981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   67985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   67989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   67991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   67996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68003 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   68003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   68006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68027 */     GIR_RootConstrainSelectedInstOperands,
     /*   68028 */     // GIR_Coverage, 51901,
     /*   68028 */     GIR_EraseRootFromParent_Done,
     /*   68029 */   // Label 1103: @68029
     /*   68029 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(68084), // Rule ID 47202 //
     /*   68034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68062 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   68065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68082 */     GIR_RootConstrainSelectedInstOperands,
     /*   68083 */     // GIR_Coverage, 47202,
     /*   68083 */     GIR_EraseRootFromParent_Done,
     /*   68084 */   // Label 1104: @68084
     /*   68084 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(68139), // Rule ID 47203 //
     /*   68089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68108 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68117 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   68120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68137 */     GIR_RootConstrainSelectedInstOperands,
     /*   68138 */     // GIR_Coverage, 47203,
     /*   68138 */     GIR_EraseRootFromParent_Done,
     /*   68139 */   // Label 1105: @68139
     /*   68139 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(68194), // Rule ID 46962 //
     /*   68144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68163 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68172 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   68175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68192 */     GIR_RootConstrainSelectedInstOperands,
     /*   68193 */     // GIR_Coverage, 46962,
     /*   68193 */     GIR_EraseRootFromParent_Done,
     /*   68194 */   // Label 1106: @68194
     /*   68194 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(68249), // Rule ID 46963 //
     /*   68199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68218 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68227 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   68230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68247 */     GIR_RootConstrainSelectedInstOperands,
     /*   68248 */     // GIR_Coverage, 46963,
     /*   68248 */     GIR_EraseRootFromParent_Done,
     /*   68249 */   // Label 1107: @68249
     /*   68249 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(68304), // Rule ID 47082 //
     /*   68254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   68257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68273 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68282 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   68282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   68285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68302 */     GIR_RootConstrainSelectedInstOperands,
     /*   68303 */     // GIR_Coverage, 47082,
     /*   68303 */     GIR_EraseRootFromParent_Done,
     /*   68304 */   // Label 1108: @68304
     /*   68304 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(68359), // Rule ID 47083 //
     /*   68309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   68312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   68324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   68328 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68337 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   68337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   68340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   68354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68357 */     GIR_RootConstrainSelectedInstOperands,
     /*   68358 */     // GIR_Coverage, 47083,
     /*   68358 */     GIR_EraseRootFromParent_Done,
     /*   68359 */   // Label 1109: @68359
     /*   68359 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(68412), // Rule ID 46178 //
     /*   68364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   68367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68375 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   68375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   68378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   68392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68410 */     GIR_RootConstrainSelectedInstOperands,
     /*   68411 */     // GIR_Coverage, 46178,
     /*   68411 */     GIR_EraseRootFromParent_Done,
     /*   68412 */   // Label 1110: @68412
     /*   68412 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(68465), // Rule ID 46179 //
     /*   68417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   68420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   68428 */     // (sub:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   68428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   68431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   68445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   68460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68463 */     GIR_RootConstrainSelectedInstOperands,
     /*   68464 */     // GIR_Coverage, 46179,
     /*   68464 */     GIR_EraseRootFromParent_Done,
     /*   68465 */   // Label 1111: @68465
     /*   68465 */   GIM_Reject,
     /*   68466 */ // Label 1095: @68466
     /*   68466 */ GIM_Reject,
     /*   68467 */ // Label 922: @68467
     /*   68467 */ GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(68713),
     /*   68472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   68478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68486 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(68550), // Rule ID 51844 //
     /*   68491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68506 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   68510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68524 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   68524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   68527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68548 */     GIR_RootConstrainSelectedInstOperands,
     /*   68549 */     // GIR_Coverage, 51844,
     /*   68549 */     GIR_EraseRootFromParent_Done,
     /*   68550 */   // Label 1113: @68550
     /*   68550 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(68614), // Rule ID 51845 //
     /*   68555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   68562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   68566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   68574 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   68588 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs2, (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   68588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /*   68591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   68597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   68601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   68603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   68612 */     GIR_RootConstrainSelectedInstOperands,
     /*   68613 */     // GIR_Coverage, 51845,
     /*   68613 */     GIR_EraseRootFromParent_Done,
     /*   68614 */   // Label 1114: @68614
     /*   68614 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(68663), // Rule ID 46122 //
     /*   68619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68626 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   68626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   68629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68661 */     GIR_RootConstrainSelectedInstOperands,
     /*   68662 */     // GIR_Coverage, 46122,
     /*   68662 */     GIR_EraseRootFromParent_Done,
     /*   68663 */   // Label 1115: @68663
     /*   68663 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(68712), // Rule ID 46123 //
     /*   68668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68675 */     // (sub:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   68675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   68678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*   68692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   68699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   68701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68710 */     GIR_RootConstrainSelectedInstOperands,
     /*   68711 */     // GIR_Coverage, 46123,
     /*   68711 */     GIR_EraseRootFromParent_Done,
     /*   68712 */   // Label 1116: @68712
     /*   68712 */   GIM_Reject,
     /*   68713 */ // Label 1112: @68713
     /*   68713 */ GIM_Reject,
     /*   68714 */ // Label 923: @68714
     /*   68714 */ GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(69836),
     /*   68719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   68722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   68725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   68729 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(68818), // Rule ID 47102 //
     /*   68734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68749 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68777 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   68777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   68780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68816 */     GIR_RootConstrainSelectedInstOperands,
     /*   68817 */     // GIR_Coverage, 47102,
     /*   68817 */     GIR_EraseRootFromParent_Done,
     /*   68818 */   // Label 1118: @68818
     /*   68818 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(68907), // Rule ID 47103 //
     /*   68823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   68826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   68853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68857 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68866 */     // (sub:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   68866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   68869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   68883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68905 */     GIR_RootConstrainSelectedInstOperands,
     /*   68906 */     // GIR_Coverage, 47103,
     /*   68906 */     GIR_EraseRootFromParent_Done,
     /*   68907 */   // Label 1119: @68907
     /*   68907 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(68996), // Rule ID 46862 //
     /*   68912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   68915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   68919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   68929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   68938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   68942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   68946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   68948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   68953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   68955 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   68955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   68958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   68962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   68967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   68969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   68972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   68974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   68977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   68981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   68985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   68988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   68994 */     GIR_RootConstrainSelectedInstOperands,
     /*   68995 */     // GIR_Coverage, 46862,
     /*   68995 */     GIR_EraseRootFromParent_Done,
     /*   68996 */   // Label 1120: @68996
     /*   68996 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(69085), // Rule ID 46863 //
     /*   69001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69035 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69044 */     // (sub:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   69047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*   69061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69083 */     GIR_RootConstrainSelectedInstOperands,
     /*   69084 */     // GIR_Coverage, 46863,
     /*   69084 */     GIR_EraseRootFromParent_Done,
     /*   69085 */   // Label 1121: @69085
     /*   69085 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(69174), // Rule ID 46982 //
     /*   69090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69133 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   69133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   69136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   69150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69172 */     GIR_RootConstrainSelectedInstOperands,
     /*   69173 */     // GIR_Coverage, 46982,
     /*   69173 */     GIR_EraseRootFromParent_Done,
     /*   69174 */   // Label 1122: @69174
     /*   69174 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(69263), // Rule ID 46983 //
     /*   69179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69213 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69222 */     // (sub:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   69222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   69225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*   69239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69261 */     GIR_RootConstrainSelectedInstOperands,
     /*   69262 */     // GIR_Coverage, 46983,
     /*   69262 */     GIR_EraseRootFromParent_Done,
     /*   69263 */   // Label 1123: @69263
     /*   69263 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(69331), // Rule ID 51872 //
     /*   69268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   69291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69305 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   69305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   69308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69329 */     GIR_RootConstrainSelectedInstOperands,
     /*   69330 */     // GIR_Coverage, 51872,
     /*   69330 */     GIR_EraseRootFromParent_Done,
     /*   69331 */   // Label 1124: @69331
     /*   69331 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(69399), // Rule ID 51873 //
     /*   69336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   69351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   69359 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69373 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   69373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   69376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   69382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69397 */     GIR_RootConstrainSelectedInstOperands,
     /*   69398 */     // GIR_Coverage, 51873,
     /*   69398 */     GIR_EraseRootFromParent_Done,
     /*   69399 */   // Label 1125: @69399
     /*   69399 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(69454), // Rule ID 47162 //
     /*   69404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69423 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69432 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69452 */     GIR_RootConstrainSelectedInstOperands,
     /*   69453 */     // GIR_Coverage, 47162,
     /*   69453 */     GIR_EraseRootFromParent_Done,
     /*   69454 */   // Label 1126: @69454
     /*   69454 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(69509), // Rule ID 47163 //
     /*   69459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69478 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69487 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69507 */     GIR_RootConstrainSelectedInstOperands,
     /*   69508 */     // GIR_Coverage, 47163,
     /*   69508 */     GIR_EraseRootFromParent_Done,
     /*   69509 */   // Label 1127: @69509
     /*   69509 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(69564), // Rule ID 46922 //
     /*   69514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69542 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69562 */     GIR_RootConstrainSelectedInstOperands,
     /*   69563 */     // GIR_Coverage, 46922,
     /*   69563 */     GIR_EraseRootFromParent_Done,
     /*   69564 */   // Label 1128: @69564
     /*   69564 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(69619), // Rule ID 46923 //
     /*   69569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   69584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69588 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69597 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*   69600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69602 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69617 */     GIR_RootConstrainSelectedInstOperands,
     /*   69618 */     // GIR_Coverage, 46923,
     /*   69618 */     GIR_EraseRootFromParent_Done,
     /*   69619 */   // Label 1129: @69619
     /*   69619 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(69674), // Rule ID 47042 //
     /*   69624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69639 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69643 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69652 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   69652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69672 */     GIR_RootConstrainSelectedInstOperands,
     /*   69673 */     // GIR_Coverage, 47042,
     /*   69673 */     GIR_EraseRootFromParent_Done,
     /*   69674 */   // Label 1130: @69674
     /*   69674 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(69729), // Rule ID 47043 //
     /*   69679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   69690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   69694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   69698 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   69705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   69707 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   69707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*   69710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69712 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   69714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   69718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   69727 */     GIR_RootConstrainSelectedInstOperands,
     /*   69728 */     // GIR_Coverage, 47043,
     /*   69728 */     GIR_EraseRootFromParent_Done,
     /*   69729 */   // Label 1131: @69729
     /*   69729 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(69782), // Rule ID 46150 //
     /*   69734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69745 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   69745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   69748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69780 */     GIR_RootConstrainSelectedInstOperands,
     /*   69781 */     // GIR_Coverage, 46150,
     /*   69781 */     GIR_EraseRootFromParent_Done,
     /*   69782 */   // Label 1132: @69782
     /*   69782 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(69835), // Rule ID 46151 //
     /*   69787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69798 */     // (sub:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   69798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   69801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   69815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   69822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   69824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69833 */     GIR_RootConstrainSelectedInstOperands,
     /*   69834 */     // GIR_Coverage, 46151,
     /*   69834 */     GIR_EraseRootFromParent_Done,
     /*   69835 */   // Label 1133: @69835
     /*   69835 */   GIM_Reject,
     /*   69836 */ // Label 1117: @69836
     /*   69836 */ GIM_Reject,
     /*   69837 */ // Label 924: @69837
     /*   69837 */ GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(70959),
     /*   69842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   69845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   69848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   69852 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69941), // Rule ID 47126 //
     /*   69857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   69860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69872 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69891 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69900 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   69900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   69903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   69912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   69914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   69917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   69919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   69922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   69926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   69930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   69933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   69936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   69939 */     GIR_RootConstrainSelectedInstOperands,
     /*   69940 */     // GIR_Coverage, 47126,
     /*   69940 */     GIR_EraseRootFromParent_Done,
     /*   69941 */   // Label 1135: @69941
     /*   69941 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(70030), // Rule ID 47127 //
     /*   69946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   69949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   69953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69961 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   69963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   69972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   69976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   69980 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   69982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   69987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   69989 */     // (sub:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   69989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   69992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   69996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   70006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70028 */     GIR_RootConstrainSelectedInstOperands,
     /*   70029 */     // GIR_Coverage, 47127,
     /*   70029 */     GIR_EraseRootFromParent_Done,
     /*   70030 */   // Label 1136: @70030
     /*   70030 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(70119), // Rule ID 46886 //
     /*   70035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70050 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70069 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70078 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   70095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70100 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70117 */     GIR_RootConstrainSelectedInstOperands,
     /*   70118 */     // GIR_Coverage, 46886,
     /*   70118 */     GIR_EraseRootFromParent_Done,
     /*   70119 */   // Label 1137: @70119
     /*   70119 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(70208), // Rule ID 46887 //
     /*   70124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70139 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70154 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70158 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70167 */     // (sub:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   70184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70206 */     GIR_RootConstrainSelectedInstOperands,
     /*   70207 */     // GIR_Coverage, 46887,
     /*   70207 */     GIR_EraseRootFromParent_Done,
     /*   70208 */   // Label 1138: @70208
     /*   70208 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(70297), // Rule ID 47006 //
     /*   70213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70228 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70247 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70256 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   70256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   70273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70295 */     GIR_RootConstrainSelectedInstOperands,
     /*   70296 */     // GIR_Coverage, 47006,
     /*   70296 */     GIR_EraseRootFromParent_Done,
     /*   70297 */   // Label 1139: @70297
     /*   70297 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(70386), // Rule ID 47007 //
     /*   70302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70317 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   70328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70332 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70336 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   70338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   70345 */     // (sub:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   70345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   70362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   70371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   70375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70384 */     GIR_RootConstrainSelectedInstOperands,
     /*   70385 */     // GIR_Coverage, 47007,
     /*   70385 */     GIR_EraseRootFromParent_Done,
     /*   70386 */   // Label 1140: @70386
     /*   70386 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(70454), // Rule ID 51888 //
     /*   70391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   70410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   70414 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70428 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   70428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   70431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70452 */     GIR_RootConstrainSelectedInstOperands,
     /*   70453 */     // GIR_Coverage, 51888,
     /*   70453 */     GIR_EraseRootFromParent_Done,
     /*   70454 */   // Label 1141: @70454
     /*   70454 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(70522), // Rule ID 51889 //
     /*   70459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   70474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   70478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   70482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70496 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   70496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   70499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   70505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70520 */     GIR_RootConstrainSelectedInstOperands,
     /*   70521 */     // GIR_Coverage, 51889,
     /*   70521 */     GIR_EraseRootFromParent_Done,
     /*   70522 */   // Label 1142: @70522
     /*   70522 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(70577), // Rule ID 47186 //
     /*   70527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70555 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   70555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   70558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70575 */     GIR_RootConstrainSelectedInstOperands,
     /*   70576 */     // GIR_Coverage, 47186,
     /*   70576 */     GIR_EraseRootFromParent_Done,
     /*   70577 */   // Label 1143: @70577
     /*   70577 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(70632), // Rule ID 47187 //
     /*   70582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70601 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70610 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   70610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   70613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70630 */     GIR_RootConstrainSelectedInstOperands,
     /*   70631 */     // GIR_Coverage, 47187,
     /*   70631 */     GIR_EraseRootFromParent_Done,
     /*   70632 */   // Label 1144: @70632
     /*   70632 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70687), // Rule ID 46946 //
     /*   70637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70656 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70665 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   70665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   70668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70685 */     GIR_RootConstrainSelectedInstOperands,
     /*   70686 */     // GIR_Coverage, 46946,
     /*   70686 */     GIR_EraseRootFromParent_Done,
     /*   70687 */   // Label 1145: @70687
     /*   70687 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(70742), // Rule ID 46947 //
     /*   70692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   70707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70720 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   70720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   70723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70740 */     GIR_RootConstrainSelectedInstOperands,
     /*   70741 */     // GIR_Coverage, 46947,
     /*   70741 */     GIR_EraseRootFromParent_Done,
     /*   70742 */   // Label 1146: @70742
     /*   70742 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(70797), // Rule ID 47066 //
     /*   70747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70766 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70775 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   70775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   70778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70795 */     GIR_RootConstrainSelectedInstOperands,
     /*   70796 */     // GIR_Coverage, 47066,
     /*   70796 */     GIR_EraseRootFromParent_Done,
     /*   70797 */   // Label 1147: @70797
     /*   70797 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(70852), // Rule ID 47067 //
     /*   70802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   70813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   70817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   70821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   70828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   70830 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   70830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   70833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   70837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   70841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   70847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   70850 */     GIR_RootConstrainSelectedInstOperands,
     /*   70851 */     // GIR_Coverage, 47067,
     /*   70851 */     GIR_EraseRootFromParent_Done,
     /*   70852 */   // Label 1148: @70852
     /*   70852 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70905), // Rule ID 46166 //
     /*   70857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   70860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70868 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   70868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   70885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70903 */     GIR_RootConstrainSelectedInstOperands,
     /*   70904 */     // GIR_Coverage, 46166,
     /*   70904 */     GIR_EraseRootFromParent_Done,
     /*   70905 */   // Label 1149: @70905
     /*   70905 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70958), // Rule ID 46167 //
     /*   70910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   70913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   70921 */     // (sub:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   70921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   70924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   70928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   70933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   70935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   70938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   70940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   70943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   70945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   70947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   70950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   70953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   70956 */     GIR_RootConstrainSelectedInstOperands,
     /*   70957 */     // GIR_Coverage, 46167,
     /*   70957 */     GIR_EraseRootFromParent_Done,
     /*   70958 */   // Label 1150: @70958
     /*   70958 */   GIM_Reject,
     /*   70959 */ // Label 1134: @70959
     /*   70959 */ GIM_Reject,
     /*   70960 */ // Label 925: @70960
     /*   70960 */ GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(72082),
     /*   70965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   70968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   70971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   70975 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(71064), // Rule ID 47146 //
     /*   70980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   70983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   70987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   70991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   70995 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   70997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71014 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71021 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71023 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   71040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71062 */     GIR_RootConstrainSelectedInstOperands,
     /*   71063 */     // GIR_Coverage, 47146,
     /*   71063 */     GIR_EraseRootFromParent_Done,
     /*   71064 */   // Label 1152: @71064
     /*   71064 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71153), // Rule ID 47147 //
     /*   71069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71084 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71103 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71112 */     // (sub:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   71129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71151 */     GIR_RootConstrainSelectedInstOperands,
     /*   71152 */     // GIR_Coverage, 47147,
     /*   71152 */     GIR_EraseRootFromParent_Done,
     /*   71153 */   // Label 1153: @71153
     /*   71153 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(71242), // Rule ID 46906 //
     /*   71158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71173 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71192 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71201 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   71218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71240 */     GIR_RootConstrainSelectedInstOperands,
     /*   71241 */     // GIR_Coverage, 46906,
     /*   71241 */     GIR_EraseRootFromParent_Done,
     /*   71242 */   // Label 1154: @71242
     /*   71242 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71331), // Rule ID 46907 //
     /*   71247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71262 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71277 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71281 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71290 */     // (sub:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   71307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71329 */     GIR_RootConstrainSelectedInstOperands,
     /*   71330 */     // GIR_Coverage, 46907,
     /*   71330 */     GIR_EraseRootFromParent_Done,
     /*   71331 */   // Label 1155: @71331
     /*   71331 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71420), // Rule ID 47026 //
     /*   71336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71351 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71370 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71379 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   71379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   71396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71418 */     GIR_RootConstrainSelectedInstOperands,
     /*   71419 */     // GIR_Coverage, 47026,
     /*   71419 */     GIR_EraseRootFromParent_Done,
     /*   71420 */   // Label 1156: @71420
     /*   71420 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71509), // Rule ID 47027 //
     /*   71425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   71432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71440 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   71451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71459 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   71461 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   71468 */     // (sub:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   71468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   71480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   71482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   71485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   71490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   71494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   71498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   71507 */     GIR_RootConstrainSelectedInstOperands,
     /*   71508 */     // GIR_Coverage, 47027,
     /*   71508 */     GIR_EraseRootFromParent_Done,
     /*   71509 */   // Label 1157: @71509
     /*   71509 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71577), // Rule ID 51904 //
     /*   71514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   71517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   71533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   71537 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71551 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*   71551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   71554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71575 */     GIR_RootConstrainSelectedInstOperands,
     /*   71576 */     // GIR_Coverage, 51904,
     /*   71576 */     GIR_EraseRootFromParent_Done,
     /*   71577 */   // Label 1158: @71577
     /*   71577 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71645), // Rule ID 51905 //
     /*   71582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   71585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   71597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   71601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   71605 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71619 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*   71619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   71622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   71628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   71640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71643 */     GIR_RootConstrainSelectedInstOperands,
     /*   71644 */     // GIR_Coverage, 51905,
     /*   71644 */     GIR_EraseRootFromParent_Done,
     /*   71645 */   // Label 1159: @71645
     /*   71645 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71700), // Rule ID 47206 //
     /*   71650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71669 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71678 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   71678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   71681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71683 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71698 */     GIR_RootConstrainSelectedInstOperands,
     /*   71699 */     // GIR_Coverage, 47206,
     /*   71699 */     GIR_EraseRootFromParent_Done,
     /*   71700 */   // Label 1160: @71700
     /*   71700 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71755), // Rule ID 47207 //
     /*   71705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   71720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71733 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   71736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71753 */     GIR_RootConstrainSelectedInstOperands,
     /*   71754 */     // GIR_Coverage, 47207,
     /*   71754 */     GIR_EraseRootFromParent_Done,
     /*   71755 */   // Label 1161: @71755
     /*   71755 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71810), // Rule ID 46966 //
     /*   71760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71779 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71788 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   71788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   71791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71808 */     GIR_RootConstrainSelectedInstOperands,
     /*   71809 */     // GIR_Coverage, 46966,
     /*   71809 */     GIR_EraseRootFromParent_Done,
     /*   71810 */   // Label 1162: @71810
     /*   71810 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(71865), // Rule ID 46967 //
     /*   71815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   71830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71834 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71843 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   71846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71863 */     GIR_RootConstrainSelectedInstOperands,
     /*   71864 */     // GIR_Coverage, 46967,
     /*   71864 */     GIR_EraseRootFromParent_Done,
     /*   71865 */   // Label 1163: @71865
     /*   71865 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(71920), // Rule ID 47086 //
     /*   71870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   71873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71898 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   71898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   71901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71918 */     GIR_RootConstrainSelectedInstOperands,
     /*   71919 */     // GIR_Coverage, 47086,
     /*   71919 */     GIR_EraseRootFromParent_Done,
     /*   71920 */   // Label 1164: @71920
     /*   71920 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71975), // Rule ID 47087 //
     /*   71925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   71928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   71936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   71940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   71944 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   71946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   71951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   71953 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   71953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   71956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   71958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   71960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   71964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   71967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   71970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   71973 */     GIR_RootConstrainSelectedInstOperands,
     /*   71974 */     // GIR_Coverage, 47087,
     /*   71974 */     GIR_EraseRootFromParent_Done,
     /*   71975 */   // Label 1165: @71975
     /*   71975 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(72028), // Rule ID 46182 //
     /*   71980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   71983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   71991 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   71991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   71994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   71998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   72008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72026 */     GIR_RootConstrainSelectedInstOperands,
     /*   72027 */     // GIR_Coverage, 46182,
     /*   72027 */     GIR_EraseRootFromParent_Done,
     /*   72028 */   // Label 1166: @72028
     /*   72028 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(72081), // Rule ID 46183 //
     /*   72033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   72036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   72040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   72044 */     // (sub:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   72044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   72047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   72061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   72076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72079 */     GIR_RootConstrainSelectedInstOperands,
     /*   72080 */     // GIR_Coverage, 46183,
     /*   72080 */     GIR_EraseRootFromParent_Done,
     /*   72081 */   // Label 1167: @72081
     /*   72081 */   GIM_Reject,
     /*   72082 */ // Label 1151: @72082
     /*   72082 */ GIM_Reject,
     /*   72083 */ // Label 926: @72083
     /*   72083 */ GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(72329),
     /*   72088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   72094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72102 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72166), // Rule ID 51860 //
     /*   72107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   72126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72140 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   72140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   72143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72164 */     GIR_RootConstrainSelectedInstOperands,
     /*   72165 */     // GIR_Coverage, 51860,
     /*   72165 */     GIR_EraseRootFromParent_Done,
     /*   72166 */   // Label 1169: @72166
     /*   72166 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72230), // Rule ID 51861 //
     /*   72171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   72190 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72204 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs2, (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   72204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /*   72207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72228 */     GIR_RootConstrainSelectedInstOperands,
     /*   72229 */     // GIR_Coverage, 51861,
     /*   72229 */     GIR_EraseRootFromParent_Done,
     /*   72230 */   // Label 1170: @72230
     /*   72230 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72279), // Rule ID 46138 //
     /*   72235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72242 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   72245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   72259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72277 */     GIR_RootConstrainSelectedInstOperands,
     /*   72278 */     // GIR_Coverage, 46138,
     /*   72278 */     GIR_EraseRootFromParent_Done,
     /*   72279 */   // Label 1171: @72279
     /*   72279 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72328), // Rule ID 46139 //
     /*   72284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72291 */     // (sub:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   72294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*   72308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   72315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   72317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72326 */     GIR_RootConstrainSelectedInstOperands,
     /*   72327 */     // GIR_Coverage, 46139,
     /*   72327 */     GIR_EraseRootFromParent_Done,
     /*   72328 */   // Label 1172: @72328
     /*   72328 */   GIM_Reject,
     /*   72329 */ // Label 1168: @72329
     /*   72329 */ GIM_Reject,
     /*   72330 */ // Label 927: @72330
     /*   72330 */ GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(73452),
     /*   72335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   72338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   72341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72345 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72434), // Rule ID 47106 //
     /*   72350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72384 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72393 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72432 */     GIR_RootConstrainSelectedInstOperands,
     /*   72433 */     // GIR_Coverage, 47106,
     /*   72433 */     GIR_EraseRootFromParent_Done,
     /*   72434 */   // Label 1174: @72434
     /*   72434 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72523), // Rule ID 47107 //
     /*   72439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   72469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72473 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72482 */     // (sub:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72521 */     GIR_RootConstrainSelectedInstOperands,
     /*   72522 */     // GIR_Coverage, 47107,
     /*   72522 */     GIR_EraseRootFromParent_Done,
     /*   72523 */   // Label 1175: @72523
     /*   72523 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72612), // Rule ID 46866 //
     /*   72528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72562 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72571 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72610 */     GIR_RootConstrainSelectedInstOperands,
     /*   72611 */     // GIR_Coverage, 46866,
     /*   72611 */     GIR_EraseRootFromParent_Done,
     /*   72612 */   // Label 1176: @72612
     /*   72612 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72701), // Rule ID 46867 //
     /*   72617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   72647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72660 */     // (sub:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*   72677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72699 */     GIR_RootConstrainSelectedInstOperands,
     /*   72700 */     // GIR_Coverage, 46867,
     /*   72700 */     GIR_EraseRootFromParent_Done,
     /*   72701 */   // Label 1177: @72701
     /*   72701 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72790), // Rule ID 46986 //
     /*   72706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72749 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   72749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72788 */     GIR_RootConstrainSelectedInstOperands,
     /*   72789 */     // GIR_Coverage, 46986,
     /*   72789 */     GIR_EraseRootFromParent_Done,
     /*   72790 */   // Label 1178: @72790
     /*   72790 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72879), // Rule ID 46987 //
     /*   72795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   72802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   72821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   72825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   72829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   72831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   72836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   72838 */     // (sub:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   72838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   72841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   72845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   72850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   72852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*   72855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   72860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   72864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   72868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   72877 */     GIR_RootConstrainSelectedInstOperands,
     /*   72878 */     // GIR_Coverage, 46987,
     /*   72878 */     GIR_EraseRootFromParent_Done,
     /*   72879 */   // Label 1179: @72879
     /*   72879 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72947), // Rule ID 51876 //
     /*   72884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   72887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   72903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   72907 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72921 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   72921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   72934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   72936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   72939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   72942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   72945 */     GIR_RootConstrainSelectedInstOperands,
     /*   72946 */     // GIR_Coverage, 51876,
     /*   72946 */     GIR_EraseRootFromParent_Done,
     /*   72947 */   // Label 1180: @72947
     /*   72947 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(73015), // Rule ID 51877 //
     /*   72952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   72955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   72963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   72967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   72971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   72975 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   72977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   72987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   72989 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   72989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   72992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   72994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   72998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73013 */     GIR_RootConstrainSelectedInstOperands,
     /*   73014 */     // GIR_Coverage, 51877,
     /*   73014 */     GIR_EraseRootFromParent_Done,
     /*   73015 */   // Label 1181: @73015
     /*   73015 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73070), // Rule ID 47166 //
     /*   73020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73039 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73048 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   73051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73068 */     GIR_RootConstrainSelectedInstOperands,
     /*   73069 */     // GIR_Coverage, 47166,
     /*   73069 */     GIR_EraseRootFromParent_Done,
     /*   73070 */   // Label 1182: @73070
     /*   73070 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73125), // Rule ID 47167 //
     /*   73075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73094 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73103 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   73106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73123 */     GIR_RootConstrainSelectedInstOperands,
     /*   73124 */     // GIR_Coverage, 47167,
     /*   73124 */     GIR_EraseRootFromParent_Done,
     /*   73125 */   // Label 1183: @73125
     /*   73125 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73180), // Rule ID 46926 //
     /*   73130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73149 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73158 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   73161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73178 */     GIR_RootConstrainSelectedInstOperands,
     /*   73179 */     // GIR_Coverage, 46926,
     /*   73179 */     GIR_EraseRootFromParent_Done,
     /*   73180 */   // Label 1184: @73180
     /*   73180 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73235), // Rule ID 46927 //
     /*   73185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73204 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73213 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*   73216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73233 */     GIR_RootConstrainSelectedInstOperands,
     /*   73234 */     // GIR_Coverage, 46927,
     /*   73234 */     GIR_EraseRootFromParent_Done,
     /*   73235 */   // Label 1185: @73235
     /*   73235 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73290), // Rule ID 47046 //
     /*   73240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73259 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73268 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   73268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   73271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73288 */     GIR_RootConstrainSelectedInstOperands,
     /*   73289 */     // GIR_Coverage, 47046,
     /*   73289 */     GIR_EraseRootFromParent_Done,
     /*   73290 */   // Label 1186: @73290
     /*   73290 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73345), // Rule ID 47047 //
     /*   73295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   73306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   73314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   73321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   73323 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   73323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*   73326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   73330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   73334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   73343 */     GIR_RootConstrainSelectedInstOperands,
     /*   73344 */     // GIR_Coverage, 47047,
     /*   73344 */     GIR_EraseRootFromParent_Done,
     /*   73345 */   // Label 1187: @73345
     /*   73345 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73398), // Rule ID 46154 //
     /*   73350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73361 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   73364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   73378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73396 */     GIR_RootConstrainSelectedInstOperands,
     /*   73397 */     // GIR_Coverage, 46154,
     /*   73397 */     GIR_EraseRootFromParent_Done,
     /*   73398 */   // Label 1188: @73398
     /*   73398 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73451), // Rule ID 46155 //
     /*   73403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73414 */     // (sub:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   73417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   73431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   73438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   73440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73449 */     GIR_RootConstrainSelectedInstOperands,
     /*   73450 */     // GIR_Coverage, 46155,
     /*   73450 */     GIR_EraseRootFromParent_Done,
     /*   73451 */   // Label 1189: @73451
     /*   73451 */   GIM_Reject,
     /*   73452 */ // Label 1173: @73452
     /*   73452 */ GIM_Reject,
     /*   73453 */ // Label 928: @73453
     /*   73453 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(74575),
     /*   73458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   73461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   73464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   73468 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73557), // Rule ID 47130 //
     /*   73473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73488 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73507 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73516 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   73533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73555 */     GIR_RootConstrainSelectedInstOperands,
     /*   73556 */     // GIR_Coverage, 47130,
     /*   73556 */     GIR_EraseRootFromParent_Done,
     /*   73557 */   // Label 1191: @73557
     /*   73557 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73646), // Rule ID 47131 //
     /*   73562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73577 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   73592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73596 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73605 */     // (sub:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   73622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73644 */     GIR_RootConstrainSelectedInstOperands,
     /*   73645 */     // GIR_Coverage, 47131,
     /*   73645 */     GIR_EraseRootFromParent_Done,
     /*   73646 */   // Label 1192: @73646
     /*   73646 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(73735), // Rule ID 46890 //
     /*   73651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73666 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73685 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73694 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   73711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73733 */     GIR_RootConstrainSelectedInstOperands,
     /*   73734 */     // GIR_Coverage, 46890,
     /*   73734 */     GIR_EraseRootFromParent_Done,
     /*   73735 */   // Label 1193: @73735
     /*   73735 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(73824), // Rule ID 46891 //
     /*   73740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73755 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   73770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73774 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73781 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73783 */     // (sub:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   73800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73822 */     GIR_RootConstrainSelectedInstOperands,
     /*   73823 */     // GIR_Coverage, 46891,
     /*   73823 */     GIR_EraseRootFromParent_Done,
     /*   73824 */   // Label 1194: @73824
     /*   73824 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(73913), // Rule ID 47010 //
     /*   73829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   73832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73844 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73863 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73865 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73872 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   73872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   73889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   73911 */     GIR_RootConstrainSelectedInstOperands,
     /*   73912 */     // GIR_Coverage, 47010,
     /*   73912 */     GIR_EraseRootFromParent_Done,
     /*   73913 */   // Label 1195: @73913
     /*   73913 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74002), // Rule ID 47011 //
     /*   73918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   73921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   73925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73933 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   73935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   73944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   73948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   73952 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   73954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   73959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   73961 */     // (sub:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   73961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   73964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   73968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   73973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   73975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   73978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   73980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   73983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   73987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   73991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   73994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   73997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74000 */     GIR_RootConstrainSelectedInstOperands,
     /*   74001 */     // GIR_Coverage, 47011,
     /*   74001 */     GIR_EraseRootFromParent_Done,
     /*   74002 */   // Label 1196: @74002
     /*   74002 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(74070), // Rule ID 51892 //
     /*   74007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   74026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   74030 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74044 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*   74044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   74047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74068 */     GIR_RootConstrainSelectedInstOperands,
     /*   74069 */     // GIR_Coverage, 51892,
     /*   74069 */     GIR_EraseRootFromParent_Done,
     /*   74070 */   // Label 1197: @74070
     /*   74070 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74138), // Rule ID 51893 //
     /*   74075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   74094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   74098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74112 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*   74112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   74115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74136 */     GIR_RootConstrainSelectedInstOperands,
     /*   74137 */     // GIR_Coverage, 51893,
     /*   74137 */     GIR_EraseRootFromParent_Done,
     /*   74138 */   // Label 1198: @74138
     /*   74138 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74193), // Rule ID 47190 //
     /*   74143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74171 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   74174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74191 */     GIR_RootConstrainSelectedInstOperands,
     /*   74192 */     // GIR_Coverage, 47190,
     /*   74192 */     GIR_EraseRootFromParent_Done,
     /*   74193 */   // Label 1199: @74193
     /*   74193 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74248), // Rule ID 47191 //
     /*   74198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74226 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   74229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74246 */     GIR_RootConstrainSelectedInstOperands,
     /*   74247 */     // GIR_Coverage, 47191,
     /*   74247 */     GIR_EraseRootFromParent_Done,
     /*   74248 */   // Label 1200: @74248
     /*   74248 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74303), // Rule ID 46950 //
     /*   74253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74272 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74281 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   74284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74301 */     GIR_RootConstrainSelectedInstOperands,
     /*   74302 */     // GIR_Coverage, 46950,
     /*   74302 */     GIR_EraseRootFromParent_Done,
     /*   74303 */   // Label 1201: @74303
     /*   74303 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74358), // Rule ID 46951 //
     /*   74308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   74323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74327 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74336 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   74339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74356 */     GIR_RootConstrainSelectedInstOperands,
     /*   74357 */     // GIR_Coverage, 46951,
     /*   74357 */     GIR_EraseRootFromParent_Done,
     /*   74358 */   // Label 1202: @74358
     /*   74358 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74413), // Rule ID 47070 //
     /*   74363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74382 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74391 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   74391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   74394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74411 */     GIR_RootConstrainSelectedInstOperands,
     /*   74412 */     // GIR_Coverage, 47070,
     /*   74412 */     GIR_EraseRootFromParent_Done,
     /*   74413 */   // Label 1203: @74413
     /*   74413 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74468), // Rule ID 47071 //
     /*   74418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   74433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   74437 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74446 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   74446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   74449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   74463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74466 */     GIR_RootConstrainSelectedInstOperands,
     /*   74467 */     // GIR_Coverage, 47071,
     /*   74467 */     GIR_EraseRootFromParent_Done,
     /*   74468 */   // Label 1204: @74468
     /*   74468 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(74521), // Rule ID 46170 //
     /*   74473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74484 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   74484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   74487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   74501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74519 */     GIR_RootConstrainSelectedInstOperands,
     /*   74520 */     // GIR_Coverage, 46170,
     /*   74520 */     GIR_EraseRootFromParent_Done,
     /*   74521 */   // Label 1205: @74521
     /*   74521 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(74574), // Rule ID 46171 //
     /*   74526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74537 */     // (sub:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   74537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   74540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   74554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   74569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74572 */     GIR_RootConstrainSelectedInstOperands,
     /*   74573 */     // GIR_Coverage, 46171,
     /*   74573 */     GIR_EraseRootFromParent_Done,
     /*   74574 */   // Label 1206: @74574
     /*   74574 */   GIM_Reject,
     /*   74575 */ // Label 1190: @74575
     /*   74575 */ GIM_Reject,
     /*   74576 */ // Label 929: @74576
     /*   74576 */ GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(74822),
     /*   74581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   74587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74595 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(74659), // Rule ID 51864 //
     /*   74600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   74619 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74633 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   74633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74657 */     GIR_RootConstrainSelectedInstOperands,
     /*   74658 */     // GIR_Coverage, 51864,
     /*   74658 */     GIR_EraseRootFromParent_Done,
     /*   74659 */   // Label 1208: @74659
     /*   74659 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(74723), // Rule ID 51865 //
     /*   74664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   74671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   74675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*   74683 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   74697 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs2, (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   74697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /*   74700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   74706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   74710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   74712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   74721 */     GIR_RootConstrainSelectedInstOperands,
     /*   74722 */     // GIR_Coverage, 51865,
     /*   74722 */     GIR_EraseRootFromParent_Done,
     /*   74723 */   // Label 1209: @74723
     /*   74723 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(74772), // Rule ID 46142 //
     /*   74728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74735 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   74735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   74738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   74752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74770 */     GIR_RootConstrainSelectedInstOperands,
     /*   74771 */     // GIR_Coverage, 46142,
     /*   74771 */     GIR_EraseRootFromParent_Done,
     /*   74772 */   // Label 1210: @74772
     /*   74772 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(74821), // Rule ID 46143 //
     /*   74777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74784 */     // (sub:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   74784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*   74787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*   74801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   74808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   74810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74819 */     GIR_RootConstrainSelectedInstOperands,
     /*   74820 */     // GIR_Coverage, 46143,
     /*   74820 */     GIR_EraseRootFromParent_Done,
     /*   74821 */   // Label 1211: @74821
     /*   74821 */   GIM_Reject,
     /*   74822 */ // Label 1207: @74822
     /*   74822 */ GIM_Reject,
     /*   74823 */ // Label 930: @74823
     /*   74823 */ GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75945),
     /*   74828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   74831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   74834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   74838 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(74927), // Rule ID 47110 //
     /*   74843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   74846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74858 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74877 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74879 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74886 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   74886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   74889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   74903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   74912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   74916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   74919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   74925 */     GIR_RootConstrainSelectedInstOperands,
     /*   74926 */     // GIR_Coverage, 47110,
     /*   74926 */     GIR_EraseRootFromParent_Done,
     /*   74927 */   // Label 1213: @74927
     /*   74927 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(75016), // Rule ID 47111 //
     /*   74932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   74935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   74939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74947 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   74949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   74958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   74962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   74966 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   74968 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   74973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   74975 */     // (sub:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   74975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   74978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   74982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   74987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   74989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   74992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   74994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   74997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75014 */     GIR_RootConstrainSelectedInstOperands,
     /*   75015 */     // GIR_Coverage, 47111,
     /*   75015 */     GIR_EraseRootFromParent_Done,
     /*   75016 */   // Label 1214: @75016
     /*   75016 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(75105), // Rule ID 46870 //
     /*   75021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75036 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75051 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75055 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75064 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   75064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75103 */     GIR_RootConstrainSelectedInstOperands,
     /*   75104 */     // GIR_Coverage, 46870,
     /*   75104 */     GIR_EraseRootFromParent_Done,
     /*   75105 */   // Label 1215: @75105
     /*   75105 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(75194), // Rule ID 46871 //
     /*   75110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75125 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75144 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75153 */     // (sub:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   75153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*   75170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75192 */     GIR_RootConstrainSelectedInstOperands,
     /*   75193 */     // GIR_Coverage, 46871,
     /*   75193 */     GIR_EraseRootFromParent_Done,
     /*   75194 */   // Label 1216: @75194
     /*   75194 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(75283), // Rule ID 46990 //
     /*   75199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75214 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75233 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75242 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   75242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75281 */     GIR_RootConstrainSelectedInstOperands,
     /*   75282 */     // GIR_Coverage, 46990,
     /*   75282 */     GIR_EraseRootFromParent_Done,
     /*   75283 */   // Label 1217: @75283
     /*   75283 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(75372), // Rule ID 46991 //
     /*   75288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   75295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75303 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   75314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75322 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   75324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   75331 */     // (sub:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   75331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*   75348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   75357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   75361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75370 */     GIR_RootConstrainSelectedInstOperands,
     /*   75371 */     // GIR_Coverage, 46991,
     /*   75371 */     GIR_EraseRootFromParent_Done,
     /*   75372 */   // Label 1218: @75372
     /*   75372 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(75440), // Rule ID 51880 //
     /*   75377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   75396 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   75400 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75414 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*   75414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75438 */     GIR_RootConstrainSelectedInstOperands,
     /*   75439 */     // GIR_Coverage, 51880,
     /*   75439 */     GIR_EraseRootFromParent_Done,
     /*   75440 */   // Label 1219: @75440
     /*   75440 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(75508), // Rule ID 51881 //
     /*   75445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*   75464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*   75468 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75482 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*   75482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   75485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   75491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75506 */     GIR_RootConstrainSelectedInstOperands,
     /*   75507 */     // GIR_Coverage, 51881,
     /*   75507 */     GIR_EraseRootFromParent_Done,
     /*   75508 */   // Label 1220: @75508
     /*   75508 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(75563), // Rule ID 47170 //
     /*   75513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75532 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75541 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   75541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75561 */     GIR_RootConstrainSelectedInstOperands,
     /*   75562 */     // GIR_Coverage, 47170,
     /*   75562 */     GIR_EraseRootFromParent_Done,
     /*   75563 */   // Label 1221: @75563
     /*   75563 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(75618), // Rule ID 47171 //
     /*   75568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   75583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75596 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   75596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75616 */     GIR_RootConstrainSelectedInstOperands,
     /*   75617 */     // GIR_Coverage, 47171,
     /*   75617 */     GIR_EraseRootFromParent_Done,
     /*   75618 */   // Label 1222: @75618
     /*   75618 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(75673), // Rule ID 46930 //
     /*   75623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75642 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75651 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   75651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75671 */     GIR_RootConstrainSelectedInstOperands,
     /*   75672 */     // GIR_Coverage, 46930,
     /*   75672 */     GIR_EraseRootFromParent_Done,
     /*   75673 */   // Label 1223: @75673
     /*   75673 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(75728), // Rule ID 46931 //
     /*   75678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   75693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75697 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75706 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   75706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*   75709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75726 */     GIR_RootConstrainSelectedInstOperands,
     /*   75727 */     // GIR_Coverage, 46931,
     /*   75727 */     GIR_EraseRootFromParent_Done,
     /*   75728 */   // Label 1224: @75728
     /*   75728 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(75783), // Rule ID 47050 //
     /*   75733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75752 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75761 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   75761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75781 */     GIR_RootConstrainSelectedInstOperands,
     /*   75782 */     // GIR_Coverage, 47050,
     /*   75782 */     GIR_EraseRootFromParent_Done,
     /*   75783 */   // Label 1225: @75783
     /*   75783 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(75838), // Rule ID 47051 //
     /*   75788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   75803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*   75807 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   75814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   75816 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   75816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*   75819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   75823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   75827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   75836 */     GIR_RootConstrainSelectedInstOperands,
     /*   75837 */     // GIR_Coverage, 47051,
     /*   75837 */     GIR_EraseRootFromParent_Done,
     /*   75838 */   // Label 1226: @75838
     /*   75838 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(75891), // Rule ID 46158 //
     /*   75843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75854 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   75854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   75871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75889 */     GIR_RootConstrainSelectedInstOperands,
     /*   75890 */     // GIR_Coverage, 46158,
     /*   75890 */     GIR_EraseRootFromParent_Done,
     /*   75891 */   // Label 1227: @75891
     /*   75891 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(75944), // Rule ID 46159 //
     /*   75896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   75899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75907 */     // (sub:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   75907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*   75910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   75914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   75919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   75921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   75924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   75926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   75929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   75931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   75933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   75936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   75939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   75942 */     GIR_RootConstrainSelectedInstOperands,
     /*   75943 */     // GIR_Coverage, 46159,
     /*   75943 */     GIR_EraseRootFromParent_Done,
     /*   75944 */   // Label 1228: @75944
     /*   75944 */   GIM_Reject,
     /*   75945 */ // Label 1212: @75945
     /*   75945 */ GIM_Reject,
     /*   75946 */ // Label 931: @75946
     /*   75946 */ GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(76192),
     /*   75951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   75954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   75957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75965 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(76029), // Rule ID 51868 //
     /*   75970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   75973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   75977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   75981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   75985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   75989 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   75991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   75996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76003 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*   76003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76027 */     GIR_RootConstrainSelectedInstOperands,
     /*   76028 */     // GIR_Coverage, 51868,
     /*   76028 */     GIR_EraseRootFromParent_Done,
     /*   76029 */   // Label 1230: @76029
     /*   76029 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(76093), // Rule ID 51869 //
     /*   76034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   76041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   76045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*   76049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*   76053 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   76067 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs2, (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rd)<<P:Predicate_mul_oneuse>>)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*   76067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /*   76070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rd
     /*   76076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*   76082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   76091 */     GIR_RootConstrainSelectedInstOperands,
     /*   76092 */     // GIR_Coverage, 51869,
     /*   76092 */     GIR_EraseRootFromParent_Done,
     /*   76093 */   // Label 1231: @76093
     /*   76093 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(76142), // Rule ID 46146 //
     /*   76098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76105 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   76108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76140 */     GIR_RootConstrainSelectedInstOperands,
     /*   76141 */     // GIR_Coverage, 46146,
     /*   76141 */     GIR_EraseRootFromParent_Done,
     /*   76142 */   // Label 1232: @76142
     /*   76142 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(76191), // Rule ID 46147 //
     /*   76147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   76154 */     // (sub:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*   76157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*   76171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76189 */     GIR_RootConstrainSelectedInstOperands,
     /*   76190 */     // GIR_Coverage, 46147,
     /*   76190 */     GIR_EraseRootFromParent_Done,
     /*   76191 */   // Label 1233: @76191
     /*   76191 */   GIM_Reject,
     /*   76192 */ // Label 1229: @76192
     /*   76192 */ GIM_Reject,
     /*   76193 */ // Label 932: @76193
     /*   76193 */ GIM_Reject,
     /*   76194 */ // Label 2: @76194
     /*   76194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1258*/ GIMT_Encode4(103247),
     /*   76205 */ /*GILLT_s32*//*Label 1234*/ GIMT_Encode4(76329),
     /*   76209 */ /*GILLT_s64*//*Label 1235*/ GIMT_Encode4(76363), GIMT_Encode4(0),
     /*   76217 */ /*GILLT_nxv1s8*//*Label 1236*/ GIMT_Encode4(76567),
     /*   76221 */ /*GILLT_nxv1s16*//*Label 1237*/ GIMT_Encode4(76682),
     /*   76225 */ /*GILLT_nxv1s32*//*Label 1238*/ GIMT_Encode4(78407),
     /*   76229 */ /*GILLT_nxv1s64*//*Label 1239*/ GIMT_Encode4(80132), GIMT_Encode4(0),
     /*   76237 */ /*GILLT_nxv2s8*//*Label 1240*/ GIMT_Encode4(81857),
     /*   76241 */ /*GILLT_nxv2s16*//*Label 1241*/ GIMT_Encode4(81972),
     /*   76245 */ /*GILLT_nxv2s32*//*Label 1242*/ GIMT_Encode4(83697),
     /*   76249 */ /*GILLT_nxv2s64*//*Label 1243*/ GIMT_Encode4(85422), GIMT_Encode4(0),
     /*   76257 */ /*GILLT_nxv4s8*//*Label 1244*/ GIMT_Encode4(87147),
     /*   76261 */ /*GILLT_nxv4s16*//*Label 1245*/ GIMT_Encode4(87262),
     /*   76265 */ /*GILLT_nxv4s32*//*Label 1246*/ GIMT_Encode4(88987),
     /*   76269 */ /*GILLT_nxv4s64*//*Label 1247*/ GIMT_Encode4(90712), GIMT_Encode4(0),
     /*   76277 */ /*GILLT_nxv8s8*//*Label 1248*/ GIMT_Encode4(92437),
     /*   76281 */ /*GILLT_nxv8s16*//*Label 1249*/ GIMT_Encode4(92552),
     /*   76285 */ /*GILLT_nxv8s32*//*Label 1250*/ GIMT_Encode4(94277),
     /*   76289 */ /*GILLT_nxv8s64*//*Label 1251*/ GIMT_Encode4(96002), GIMT_Encode4(0),
     /*   76297 */ /*GILLT_nxv16s8*//*Label 1252*/ GIMT_Encode4(97727),
     /*   76301 */ /*GILLT_nxv16s16*//*Label 1253*/ GIMT_Encode4(97842),
     /*   76305 */ /*GILLT_nxv16s32*//*Label 1254*/ GIMT_Encode4(99567), GIMT_Encode4(0),
     /*   76313 */ /*GILLT_nxv32s8*//*Label 1255*/ GIMT_Encode4(101292),
     /*   76317 */ /*GILLT_nxv32s16*//*Label 1256*/ GIMT_Encode4(101407), GIMT_Encode4(0),
     /*   76325 */ /*GILLT_nxv64s8*//*Label 1257*/ GIMT_Encode4(103132),
     /*   76329 */ // Label 1234: @76329
     /*   76329 */ GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(76362), // Rule ID 290 //
     /*   76334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /*   76337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   76340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   76343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76355 */   // (mul:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MUL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*   76355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   76360 */   GIR_RootConstrainSelectedInstOperands,
     /*   76361 */   // GIR_Coverage, 290,
     /*   76361 */   GIR_Done,
     /*   76362 */ // Label 1259: @76362
     /*   76362 */ GIM_Reject,
     /*   76363 */ // Label 1235: @76363
     /*   76363 */ GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(76566),
     /*   76368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   76371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   76374 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(76507), // Rule ID 312 //
     /*   76379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_NotHasStdExtZba_HwMode0),
     /*   76382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   76394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   76398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   76402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76407 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*   76418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*   76426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   76430 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   76434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76439 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*   76450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76452 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 4294967295:{ *:[i64] }))  =>  (MULHU:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))
     /*   76452 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   76455 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   76459 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76464 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   76468 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/32,
     /*   76471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   76473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   76476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*   76480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*   76492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /*   76497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   76505 */     GIR_RootConstrainSelectedInstOperands,
     /*   76506 */     // GIR_Coverage, 312,
     /*   76506 */     GIR_EraseRootFromParent_Done,
     /*   76507 */   // Label 1261: @76507
     /*   76507 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(76538), // Rule ID 305 //
     /*   76512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_IsRV64_HwMode0),
     /*   76515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10078),
     /*   76531 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_anonymous_10078>>  =>  (MULW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   76531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULW),
     /*   76536 */     GIR_RootConstrainSelectedInstOperands,
     /*   76537 */     // GIR_Coverage, 305,
     /*   76537 */     GIR_Done,
     /*   76538 */   // Label 1262: @76538
     /*   76538 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(76565), // Rule ID 289 //
     /*   76543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /*   76546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*   76558 */     // (mul:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MUL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*   76558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MUL),
     /*   76563 */     GIR_RootConstrainSelectedInstOperands,
     /*   76564 */     // GIR_Coverage, 289,
     /*   76564 */     GIR_Done,
     /*   76565 */   // Label 1263: @76565
     /*   76565 */   GIM_Reject,
     /*   76566 */ // Label 1260: @76566
     /*   76566 */ GIM_Reject,
     /*   76567 */ // Label 1236: @76567
     /*   76567 */ GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(76681),
     /*   76572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*   76578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76586 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76590 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(76635), // Rule ID 50730 //
     /*   76595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76598 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   76601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   76615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76633 */     GIR_RootConstrainSelectedInstOperands,
     /*   76634 */     // GIR_Coverage, 50730,
     /*   76634 */     GIR_EraseRootFromParent_Done,
     /*   76635 */   // Label 1265: @76635
     /*   76635 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(76680), // Rule ID 50731 //
     /*   76640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76643 */     // (mul:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*   76646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*   76660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   76667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   76669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76678 */     GIR_RootConstrainSelectedInstOperands,
     /*   76679 */     // GIR_Coverage, 50731,
     /*   76679 */     GIR_EraseRootFromParent_Done,
     /*   76680 */   // Label 1266: @76680
     /*   76680 */   GIM_Reject,
     /*   76681 */ // Label 1264: @76681
     /*   76681 */ GIM_Reject,
     /*   76682 */ // Label 1237: @76682
     /*   76682 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(78406),
     /*   76687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   76690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*   76693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76697 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(76786), // Rule ID 51496 //
     /*   76702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76717 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76745 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   76748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   76762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76784 */     GIR_RootConstrainSelectedInstOperands,
     /*   76785 */     // GIR_Coverage, 51496,
     /*   76785 */     GIR_EraseRootFromParent_Done,
     /*   76786 */   // Label 1268: @76786
     /*   76786 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(76875), // Rule ID 51497 //
     /*   76791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76806 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76825 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76834 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   76834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   76837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   76851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   76860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   76864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76873 */     GIR_RootConstrainSelectedInstOperands,
     /*   76874 */     // GIR_Coverage, 51497,
     /*   76874 */     GIR_EraseRootFromParent_Done,
     /*   76875 */   // Label 1269: @76875
     /*   76875 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(76964), // Rule ID 70191 //
     /*   76880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   76883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76895 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76914 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   76916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76921 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   76923 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   76923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   76926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   76930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   76935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   76937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   76940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   76942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   76945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   76949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   76953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   76956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   76962 */     GIR_RootConstrainSelectedInstOperands,
     /*   76963 */     // GIR_Coverage, 70191,
     /*   76963 */     GIR_EraseRootFromParent_Done,
     /*   76964 */   // Label 1270: @76964
     /*   76964 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(77053), // Rule ID 70192 //
     /*   76969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   76972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   76976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   76980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   76984 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   76986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   76991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   76995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   76999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77012 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   77029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   77038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77051 */     GIR_RootConstrainSelectedInstOperands,
     /*   77052 */     // GIR_Coverage, 70192,
     /*   77052 */     GIR_EraseRootFromParent_Done,
     /*   77053 */   // Label 1271: @77053
     /*   77053 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(77142), // Rule ID 70071 //
     /*   77058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77073 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77088 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77092 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77094 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77099 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77101 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   77118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   77127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77140 */     GIR_RootConstrainSelectedInstOperands,
     /*   77141 */     // GIR_Coverage, 70071,
     /*   77141 */     GIR_EraseRootFromParent_Done,
     /*   77142 */   // Label 1272: @77142
     /*   77142 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(77231), // Rule ID 70072 //
     /*   77147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77162 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77181 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77190 */     // (mul:{ *:[nxv1i16] } (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   77207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   77216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   77220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77229 */     GIR_RootConstrainSelectedInstOperands,
     /*   77230 */     // GIR_Coverage, 70072,
     /*   77230 */     GIR_EraseRootFromParent_Done,
     /*   77231 */   // Label 1273: @77231
     /*   77231 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(77320), // Rule ID 51676 //
     /*   77236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77251 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77270 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77279 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   77296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77318 */     GIR_RootConstrainSelectedInstOperands,
     /*   77319 */     // GIR_Coverage, 51676,
     /*   77319 */     GIR_EraseRootFromParent_Done,
     /*   77320 */   // Label 1274: @77320
     /*   77320 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(77409), // Rule ID 51677 //
     /*   77325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77340 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77359 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77368 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   77385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77407 */     GIR_RootConstrainSelectedInstOperands,
     /*   77408 */     // GIR_Coverage, 51677,
     /*   77408 */     GIR_EraseRootFromParent_Done,
     /*   77409 */   // Label 1275: @77409
     /*   77409 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(77498), // Rule ID 51376 //
     /*   77414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77429 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77448 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77457 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   77474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77496 */     GIR_RootConstrainSelectedInstOperands,
     /*   77497 */     // GIR_Coverage, 51376,
     /*   77497 */     GIR_EraseRootFromParent_Done,
     /*   77498 */   // Label 1276: @77498
     /*   77498 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(77587), // Rule ID 51377 //
     /*   77503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77518 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77537 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77546 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*   77563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77585 */     GIR_RootConstrainSelectedInstOperands,
     /*   77586 */     // GIR_Coverage, 51377,
     /*   77586 */     GIR_EraseRootFromParent_Done,
     /*   77587 */   // Label 1277: @77587
     /*   77587 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(77676), // Rule ID 51616 //
     /*   77592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77607 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77626 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77635 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   77652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77674 */     GIR_RootConstrainSelectedInstOperands,
     /*   77675 */     // GIR_Coverage, 51616,
     /*   77675 */     GIR_EraseRootFromParent_Done,
     /*   77676 */   // Label 1278: @77676
     /*   77676 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(77765), // Rule ID 51617 //
     /*   77681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77696 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77715 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77724 */     // (mul:{ *:[nxv1i16] } (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   77741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77763 */     GIR_RootConstrainSelectedInstOperands,
     /*   77764 */     // GIR_Coverage, 51617,
     /*   77764 */     GIR_EraseRootFromParent_Done,
     /*   77765 */   // Label 1279: @77765
     /*   77765 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(77854), // Rule ID 51556 //
     /*   77770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77785 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77804 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77813 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   77830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77852 */     GIR_RootConstrainSelectedInstOperands,
     /*   77853 */     // GIR_Coverage, 51556,
     /*   77853 */     GIR_EraseRootFromParent_Done,
     /*   77854 */   // Label 1280: @77854
     /*   77854 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(77943), // Rule ID 51557 //
     /*   77859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   77862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77874 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   77889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77893 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77902 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   77902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   77914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   77916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   77919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   77921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   77924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   77928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   77932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   77935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   77941 */     GIR_RootConstrainSelectedInstOperands,
     /*   77942 */     // GIR_Coverage, 51557,
     /*   77942 */     GIR_EraseRootFromParent_Done,
     /*   77943 */   // Label 1281: @77943
     /*   77943 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(78032), // Rule ID 70131 //
     /*   77948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   77951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   77955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   77959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77963 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   77965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   77974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   77978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   77982 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   77984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   77989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   77991 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   77991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   77994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   77998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   78008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78030 */     GIR_RootConstrainSelectedInstOperands,
     /*   78031 */     // GIR_Coverage, 70131,
     /*   78031 */     GIR_EraseRootFromParent_Done,
     /*   78032 */   // Label 1282: @78032
     /*   78032 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(78121), // Rule ID 70132 //
     /*   78037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78052 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78071 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78080 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   78083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*   78097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78119 */     GIR_RootConstrainSelectedInstOperands,
     /*   78120 */     // GIR_Coverage, 70132,
     /*   78120 */     GIR_EraseRootFromParent_Done,
     /*   78121 */   // Label 1283: @78121
     /*   78121 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(78210), // Rule ID 51436 //
     /*   78126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78141 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78169 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   78169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   78172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   78186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78208 */     GIR_RootConstrainSelectedInstOperands,
     /*   78209 */     // GIR_Coverage, 51436,
     /*   78209 */     GIR_EraseRootFromParent_Done,
     /*   78210 */   // Label 1284: @78210
     /*   78210 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(78299), // Rule ID 51437 //
     /*   78215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78230 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*   78249 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78251 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78256 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78258 */     // (mul:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   78258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   78261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*   78275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78297 */     GIR_RootConstrainSelectedInstOperands,
     /*   78298 */     // GIR_Coverage, 51437,
     /*   78298 */     GIR_EraseRootFromParent_Done,
     /*   78299 */   // Label 1285: @78299
     /*   78299 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(78352), // Rule ID 50742 //
     /*   78304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78315 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   78318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   78332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78350 */     GIR_RootConstrainSelectedInstOperands,
     /*   78351 */     // GIR_Coverage, 50742,
     /*   78351 */     GIR_EraseRootFromParent_Done,
     /*   78352 */   // Label 1286: @78352
     /*   78352 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(78405), // Rule ID 50743 //
     /*   78357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78368 */     // (mul:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*   78371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   78385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   78392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   78394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78403 */     GIR_RootConstrainSelectedInstOperands,
     /*   78404 */     // GIR_Coverage, 50743,
     /*   78404 */     GIR_EraseRootFromParent_Done,
     /*   78405 */   // Label 1287: @78405
     /*   78405 */   GIM_Reject,
     /*   78406 */ // Label 1267: @78406
     /*   78406 */ GIM_Reject,
     /*   78407 */ // Label 1238: @78407
     /*   78407 */ GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(80131),
     /*   78412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   78415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*   78418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78422 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(78511), // Rule ID 51520 //
     /*   78427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78470 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   78487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78509 */     GIR_RootConstrainSelectedInstOperands,
     /*   78510 */     // GIR_Coverage, 51520,
     /*   78510 */     GIR_EraseRootFromParent_Done,
     /*   78511 */   // Label 1289: @78511
     /*   78511 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(78600), // Rule ID 51521 //
     /*   78516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78559 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   78576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   78585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   78589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78598 */     GIR_RootConstrainSelectedInstOperands,
     /*   78599 */     // GIR_Coverage, 51521,
     /*   78599 */     GIR_EraseRootFromParent_Done,
     /*   78600 */   // Label 1290: @78600
     /*   78600 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(78689), // Rule ID 70215 //
     /*   78605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78648 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   78665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78687 */     GIR_RootConstrainSelectedInstOperands,
     /*   78688 */     // GIR_Coverage, 70215,
     /*   78688 */     GIR_EraseRootFromParent_Done,
     /*   78689 */   // Label 1291: @78689
     /*   78689 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(78778), // Rule ID 70216 //
     /*   78694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78737 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   78754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78776 */     GIR_RootConstrainSelectedInstOperands,
     /*   78777 */     // GIR_Coverage, 70216,
     /*   78777 */     GIR_EraseRootFromParent_Done,
     /*   78778 */   // Label 1292: @78778
     /*   78778 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(78867), // Rule ID 70095 //
     /*   78783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78826 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   78826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   78843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78865 */     GIR_RootConstrainSelectedInstOperands,
     /*   78866 */     // GIR_Coverage, 70095,
     /*   78866 */     GIR_EraseRootFromParent_Done,
     /*   78867 */   // Label 1293: @78867
     /*   78867 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(78956), // Rule ID 70096 //
     /*   78872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   78875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   78902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   78915 */     // (mul:{ *:[nxv1i32] } (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   78915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   78918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   78922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   78927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   78929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   78932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   78934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   78937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   78941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   78945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   78948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   78951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   78954 */     GIR_RootConstrainSelectedInstOperands,
     /*   78955 */     // GIR_Coverage, 70096,
     /*   78955 */     GIR_EraseRootFromParent_Done,
     /*   78956 */   // Label 1294: @78956
     /*   78956 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(79045), // Rule ID 51700 //
     /*   78961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   78964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   78968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   78972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   78978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   78983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   78987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   78991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   78995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   78997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79004 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79043 */     GIR_RootConstrainSelectedInstOperands,
     /*   79044 */     // GIR_Coverage, 51700,
     /*   79044 */     GIR_EraseRootFromParent_Done,
     /*   79045 */   // Label 1295: @79045
     /*   79045 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(79134), // Rule ID 51701 //
     /*   79050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79093 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79132 */     GIR_RootConstrainSelectedInstOperands,
     /*   79133 */     // GIR_Coverage, 51701,
     /*   79133 */     GIR_EraseRootFromParent_Done,
     /*   79134 */   // Label 1296: @79134
     /*   79134 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(79223), // Rule ID 51400 //
     /*   79139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79182 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   79199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79221 */     GIR_RootConstrainSelectedInstOperands,
     /*   79222 */     // GIR_Coverage, 51400,
     /*   79222 */     GIR_EraseRootFromParent_Done,
     /*   79223 */   // Label 1297: @79223
     /*   79223 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(79312), // Rule ID 51401 //
     /*   79228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79271 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   79288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79310 */     GIR_RootConstrainSelectedInstOperands,
     /*   79311 */     // GIR_Coverage, 51401,
     /*   79311 */     GIR_EraseRootFromParent_Done,
     /*   79312 */   // Label 1298: @79312
     /*   79312 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(79401), // Rule ID 51640 //
     /*   79317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79360 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79399 */     GIR_RootConstrainSelectedInstOperands,
     /*   79400 */     // GIR_Coverage, 51640,
     /*   79400 */     GIR_EraseRootFromParent_Done,
     /*   79401 */   // Label 1299: @79401
     /*   79401 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(79490), // Rule ID 51641 //
     /*   79406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79449 */     // (mul:{ *:[nxv1i32] } (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79488 */     GIR_RootConstrainSelectedInstOperands,
     /*   79489 */     // GIR_Coverage, 51641,
     /*   79489 */     GIR_EraseRootFromParent_Done,
     /*   79490 */   // Label 1300: @79490
     /*   79490 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(79579), // Rule ID 51580 //
     /*   79495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79538 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   79555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79577 */     GIR_RootConstrainSelectedInstOperands,
     /*   79578 */     // GIR_Coverage, 51580,
     /*   79578 */     GIR_EraseRootFromParent_Done,
     /*   79579 */   // Label 1301: @79579
     /*   79579 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(79668), // Rule ID 51581 //
     /*   79584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   79614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79627 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   79644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79666 */     GIR_RootConstrainSelectedInstOperands,
     /*   79667 */     // GIR_Coverage, 51581,
     /*   79667 */     GIR_EraseRootFromParent_Done,
     /*   79668 */   // Label 1302: @79668
     /*   79668 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(79757), // Rule ID 70155 //
     /*   79673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79716 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   79742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79755 */     GIR_RootConstrainSelectedInstOperands,
     /*   79756 */     // GIR_Coverage, 70155,
     /*   79756 */     GIR_EraseRootFromParent_Done,
     /*   79757 */   // Label 1303: @79757
     /*   79757 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(79846), // Rule ID 70156 //
     /*   79762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79777 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   79792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79796 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79805 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   79822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   79831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   79835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79844 */     GIR_RootConstrainSelectedInstOperands,
     /*   79845 */     // GIR_Coverage, 70156,
     /*   79845 */     GIR_EraseRootFromParent_Done,
     /*   79846 */   // Label 1304: @79846
     /*   79846 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(79935), // Rule ID 51460 //
     /*   79851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   79854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79866 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79885 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79894 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   79894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   79911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   79913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   79916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   79920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   79924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   79927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   79930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   79933 */     GIR_RootConstrainSelectedInstOperands,
     /*   79934 */     // GIR_Coverage, 51460,
     /*   79934 */     GIR_EraseRootFromParent_Done,
     /*   79935 */   // Label 1305: @79935
     /*   79935 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(80024), // Rule ID 51461 //
     /*   79940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   79943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   79947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   79957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   79966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   79970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*   79974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   79976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   79981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   79983 */     // (mul:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   79983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   79986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   79990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   79995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   79997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   80000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   80019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80022 */     GIR_RootConstrainSelectedInstOperands,
     /*   80023 */     // GIR_Coverage, 51461,
     /*   80023 */     GIR_EraseRootFromParent_Done,
     /*   80024 */   // Label 1306: @80024
     /*   80024 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(80077), // Rule ID 50750 //
     /*   80029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   80032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80040 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   80043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   80057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80075 */     GIR_RootConstrainSelectedInstOperands,
     /*   80076 */     // GIR_Coverage, 50750,
     /*   80076 */     GIR_EraseRootFromParent_Done,
     /*   80077 */   // Label 1307: @80077
     /*   80077 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(80130), // Rule ID 50751 //
     /*   80082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   80085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80093 */     // (mul:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*   80096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   80110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   80117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   80119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80128 */     GIR_RootConstrainSelectedInstOperands,
     /*   80129 */     // GIR_Coverage, 50751,
     /*   80129 */     GIR_EraseRootFromParent_Done,
     /*   80130 */   // Label 1308: @80130
     /*   80130 */   GIM_Reject,
     /*   80131 */ // Label 1288: @80131
     /*   80131 */ GIM_Reject,
     /*   80132 */ // Label 1239: @80132
     /*   80132 */ GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(81856),
     /*   80137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*   80140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*   80143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80147 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(80236), // Rule ID 51540 //
     /*   80152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   80155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80167 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80186 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80195 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   80212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80234 */     GIR_RootConstrainSelectedInstOperands,
     /*   80235 */     // GIR_Coverage, 51540,
     /*   80235 */     GIR_EraseRootFromParent_Done,
     /*   80236 */   // Label 1310: @80236
     /*   80236 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(80325), // Rule ID 51541 //
     /*   80241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   80244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80275 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80284 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   80301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80323 */     GIR_RootConstrainSelectedInstOperands,
     /*   80324 */     // GIR_Coverage, 51541,
     /*   80324 */     GIR_EraseRootFromParent_Done,
     /*   80325 */   // Label 1311: @80325
     /*   80325 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(80414), // Rule ID 70235 //
     /*   80330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   80333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80345 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80360 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80364 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80373 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   80390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80412 */     GIR_RootConstrainSelectedInstOperands,
     /*   80413 */     // GIR_Coverage, 70235,
     /*   80413 */     GIR_EraseRootFromParent_Done,
     /*   80414 */   // Label 1312: @80414
     /*   80414 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(80503), // Rule ID 70236 //
     /*   80419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   80422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80434 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80453 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80462 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   80479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80501 */     GIR_RootConstrainSelectedInstOperands,
     /*   80502 */     // GIR_Coverage, 70236,
     /*   80502 */     GIR_EraseRootFromParent_Done,
     /*   80503 */   // Label 1313: @80503
     /*   80503 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(80592), // Rule ID 70115 //
     /*   80508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   80511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80523 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80542 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80551 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   80568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80590 */     GIR_RootConstrainSelectedInstOperands,
     /*   80591 */     // GIR_Coverage, 70115,
     /*   80591 */     GIR_EraseRootFromParent_Done,
     /*   80592 */   // Label 1314: @80592
     /*   80592 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(80681), // Rule ID 70116 //
     /*   80597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   80600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80612 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   80627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80631 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80640 */     // (mul:{ *:[nxv1i64] } (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   80657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   80666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   80670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80679 */     GIR_RootConstrainSelectedInstOperands,
     /*   80680 */     // GIR_Coverage, 70116,
     /*   80680 */     GIR_EraseRootFromParent_Done,
     /*   80681 */   // Label 1315: @80681
     /*   80681 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(80770), // Rule ID 51720 //
     /*   80686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   80689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80701 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80720 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80729 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   80746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80768 */     GIR_RootConstrainSelectedInstOperands,
     /*   80769 */     // GIR_Coverage, 51720,
     /*   80769 */     GIR_EraseRootFromParent_Done,
     /*   80770 */   // Label 1316: @80770
     /*   80770 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(80859), // Rule ID 51721 //
     /*   80775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   80778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80790 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   80805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80809 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80811 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80818 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   80835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80857 */     GIR_RootConstrainSelectedInstOperands,
     /*   80858 */     // GIR_Coverage, 51721,
     /*   80858 */     GIR_EraseRootFromParent_Done,
     /*   80859 */   // Label 1317: @80859
     /*   80859 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(80948), // Rule ID 51420 //
     /*   80864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   80867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80879 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80898 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80907 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   80907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   80914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   80919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   80921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   80924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   80926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   80929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   80933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   80937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   80940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   80943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   80946 */     GIR_RootConstrainSelectedInstOperands,
     /*   80947 */     // GIR_Coverage, 51420,
     /*   80947 */     GIR_EraseRootFromParent_Done,
     /*   80948 */   // Label 1318: @80948
     /*   80948 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(81037), // Rule ID 51421 //
     /*   80953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   80956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   80960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80968 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   80970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   80979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   80983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   80987 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   80989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   80994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   80996 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   80996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   80999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   81013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81035 */     GIR_RootConstrainSelectedInstOperands,
     /*   81036 */     // GIR_Coverage, 51421,
     /*   81036 */     GIR_EraseRootFromParent_Done,
     /*   81037 */   // Label 1319: @81037
     /*   81037 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(81126), // Rule ID 51660 //
     /*   81042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   81045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81057 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81076 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81085 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   81085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   81102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81124 */     GIR_RootConstrainSelectedInstOperands,
     /*   81125 */     // GIR_Coverage, 51660,
     /*   81125 */     GIR_EraseRootFromParent_Done,
     /*   81126 */   // Label 1320: @81126
     /*   81126 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(81215), // Rule ID 51661 //
     /*   81131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   81134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81146 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81161 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81165 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81174 */     // (mul:{ *:[nxv1i64] } (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   81174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   81191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81213 */     GIR_RootConstrainSelectedInstOperands,
     /*   81214 */     // GIR_Coverage, 51661,
     /*   81214 */     GIR_EraseRootFromParent_Done,
     /*   81215 */   // Label 1321: @81215
     /*   81215 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(81304), // Rule ID 51600 //
     /*   81220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   81223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81235 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81254 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81263 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   81263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   81280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81302 */     GIR_RootConstrainSelectedInstOperands,
     /*   81303 */     // GIR_Coverage, 51600,
     /*   81303 */     GIR_EraseRootFromParent_Done,
     /*   81304 */   // Label 1322: @81304
     /*   81304 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(81393), // Rule ID 51601 //
     /*   81309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   81312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81324 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   81339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81343 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81352 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   81352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   81369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81374 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81391 */     GIR_RootConstrainSelectedInstOperands,
     /*   81392 */     // GIR_Coverage, 51601,
     /*   81392 */     GIR_EraseRootFromParent_Done,
     /*   81393 */   // Label 1323: @81393
     /*   81393 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(81482), // Rule ID 70175 //
     /*   81398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   81401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81413 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81432 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81441 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   81441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   81458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81480 */     GIR_RootConstrainSelectedInstOperands,
     /*   81481 */     // GIR_Coverage, 70175,
     /*   81481 */     GIR_EraseRootFromParent_Done,
     /*   81482 */   // Label 1324: @81482
     /*   81482 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(81571), // Rule ID 70176 //
     /*   81487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   81490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81502 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81504 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   81517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81521 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81530 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   81530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   81547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   81556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   81560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81569 */     GIR_RootConstrainSelectedInstOperands,
     /*   81570 */     // GIR_Coverage, 70176,
     /*   81570 */     GIR_EraseRootFromParent_Done,
     /*   81571 */   // Label 1325: @81571
     /*   81571 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(81660), // Rule ID 51480 //
     /*   81576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   81579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81591 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81606 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81610 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81619 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   81619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   81636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81658 */     GIR_RootConstrainSelectedInstOperands,
     /*   81659 */     // GIR_Coverage, 51480,
     /*   81659 */     GIR_EraseRootFromParent_Done,
     /*   81660 */   // Label 1326: @81660
     /*   81660 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(81749), // Rule ID 51481 //
     /*   81665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   81668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81680 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   81682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   81691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   81695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*   81699 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   81701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   81708 */     // (mul:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   81708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   81725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   81734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   81738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   81744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81747 */     GIR_RootConstrainSelectedInstOperands,
     /*   81748 */     // GIR_Coverage, 51481,
     /*   81748 */     GIR_EraseRootFromParent_Done,
     /*   81749 */   // Label 1327: @81749
     /*   81749 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(81802), // Rule ID 50766 //
     /*   81754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   81757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81765 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   81765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   81782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   81797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81800 */     GIR_RootConstrainSelectedInstOperands,
     /*   81801 */     // GIR_Coverage, 50766,
     /*   81801 */     GIR_EraseRootFromParent_Done,
     /*   81802 */   // Label 1328: @81802
     /*   81802 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(81855), // Rule ID 50767 //
     /*   81807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   81810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81818 */     // (mul:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   81818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*   81821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   81835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   81850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81853 */     GIR_RootConstrainSelectedInstOperands,
     /*   81854 */     // GIR_Coverage, 50767,
     /*   81854 */     GIR_EraseRootFromParent_Done,
     /*   81855 */   // Label 1329: @81855
     /*   81855 */   GIM_Reject,
     /*   81856 */ // Label 1309: @81856
     /*   81856 */ GIM_Reject,
     /*   81857 */ // Label 1240: @81857
     /*   81857 */ GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(81971),
     /*   81862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   81865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*   81868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81880 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(81925), // Rule ID 50734 //
     /*   81885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81888 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   81888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   81891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   81905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81923 */     GIR_RootConstrainSelectedInstOperands,
     /*   81924 */     // GIR_Coverage, 50734,
     /*   81924 */     GIR_EraseRootFromParent_Done,
     /*   81925 */   // Label 1331: @81925
     /*   81925 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(81970), // Rule ID 50735 //
     /*   81930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   81933 */     // (mul:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   81933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*   81936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   81940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   81945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   81947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*   81950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   81952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   81955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   81957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   81959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   81962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   81968 */     GIR_RootConstrainSelectedInstOperands,
     /*   81969 */     // GIR_Coverage, 50735,
     /*   81969 */     GIR_EraseRootFromParent_Done,
     /*   81970 */   // Label 1332: @81970
     /*   81970 */   GIM_Reject,
     /*   81971 */ // Label 1330: @81971
     /*   81971 */ GIM_Reject,
     /*   81972 */ // Label 1241: @81972
     /*   81972 */ GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(83696),
     /*   81977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   81980 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*   81983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   81987 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(82076), // Rule ID 51500 //
     /*   81992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   81995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   81999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82007 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82026 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82035 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82074 */     GIR_RootConstrainSelectedInstOperands,
     /*   82075 */     // GIR_Coverage, 51500,
     /*   82075 */     GIR_EraseRootFromParent_Done,
     /*   82076 */   // Label 1334: @82076
     /*   82076 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(82165), // Rule ID 51501 //
     /*   82081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82096 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82115 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82124 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82163 */     GIR_RootConstrainSelectedInstOperands,
     /*   82164 */     // GIR_Coverage, 51501,
     /*   82164 */     GIR_EraseRootFromParent_Done,
     /*   82165 */   // Label 1335: @82165
     /*   82165 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(82254), // Rule ID 70195 //
     /*   82170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82185 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82204 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82213 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82252 */     GIR_RootConstrainSelectedInstOperands,
     /*   82253 */     // GIR_Coverage, 70195,
     /*   82253 */     GIR_EraseRootFromParent_Done,
     /*   82254 */   // Label 1336: @82254
     /*   82254 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(82343), // Rule ID 70196 //
     /*   82259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82274 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82293 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82295 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82300 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82302 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82341 */     GIR_RootConstrainSelectedInstOperands,
     /*   82342 */     // GIR_Coverage, 70196,
     /*   82342 */     GIR_EraseRootFromParent_Done,
     /*   82343 */   // Label 1337: @82343
     /*   82343 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(82432), // Rule ID 70075 //
     /*   82348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82363 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82382 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82391 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82430 */     GIR_RootConstrainSelectedInstOperands,
     /*   82431 */     // GIR_Coverage, 70075,
     /*   82431 */     GIR_EraseRootFromParent_Done,
     /*   82432 */   // Label 1338: @82432
     /*   82432 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(82521), // Rule ID 70076 //
     /*   82437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82452 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82471 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82480 */     // (mul:{ *:[nxv2i16] } (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   82497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   82506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   82510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82519 */     GIR_RootConstrainSelectedInstOperands,
     /*   82520 */     // GIR_Coverage, 70076,
     /*   82520 */     GIR_EraseRootFromParent_Done,
     /*   82521 */   // Label 1339: @82521
     /*   82521 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(82610), // Rule ID 51680 //
     /*   82526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82541 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82560 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82562 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82569 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82608 */     GIR_RootConstrainSelectedInstOperands,
     /*   82609 */     // GIR_Coverage, 51680,
     /*   82609 */     GIR_EraseRootFromParent_Done,
     /*   82610 */   // Label 1340: @82610
     /*   82610 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(82699), // Rule ID 51681 //
     /*   82615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82630 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   82645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82649 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82651 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82658 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82697 */     GIR_RootConstrainSelectedInstOperands,
     /*   82698 */     // GIR_Coverage, 51681,
     /*   82698 */     GIR_EraseRootFromParent_Done,
     /*   82699 */   // Label 1341: @82699
     /*   82699 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(82788), // Rule ID 51380 //
     /*   82704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82719 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82738 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82747 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   82764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82786 */     GIR_RootConstrainSelectedInstOperands,
     /*   82787 */     // GIR_Coverage, 51380,
     /*   82787 */     GIR_EraseRootFromParent_Done,
     /*   82788 */   // Label 1342: @82788
     /*   82788 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(82877), // Rule ID 51381 //
     /*   82793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82808 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82827 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82836 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   82836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*   82853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82875 */     GIR_RootConstrainSelectedInstOperands,
     /*   82876 */     // GIR_Coverage, 51381,
     /*   82876 */     GIR_EraseRootFromParent_Done,
     /*   82877 */   // Label 1343: @82877
     /*   82877 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(82966), // Rule ID 51620 //
     /*   82882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   82885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82897 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   82912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82916 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   82918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   82925 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   82925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   82928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   82932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   82937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   82939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   82942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   82944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   82947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   82951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   82955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   82958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   82964 */     GIR_RootConstrainSelectedInstOperands,
     /*   82965 */     // GIR_Coverage, 51620,
     /*   82965 */     GIR_EraseRootFromParent_Done,
     /*   82966 */   // Label 1344: @82966
     /*   82966 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(83055), // Rule ID 51621 //
     /*   82971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   82974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   82978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   82982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   82986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   82988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   82993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   82997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83005 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83012 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83014 */     // (mul:{ *:[nxv2i16] } (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   83014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83053 */     GIR_RootConstrainSelectedInstOperands,
     /*   83054 */     // GIR_Coverage, 51621,
     /*   83054 */     GIR_EraseRootFromParent_Done,
     /*   83055 */   // Label 1345: @83055
     /*   83055 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(83144), // Rule ID 51560 //
     /*   83060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83075 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83090 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83094 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83103 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   83103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83142 */     GIR_RootConstrainSelectedInstOperands,
     /*   83143 */     // GIR_Coverage, 51560,
     /*   83143 */     GIR_EraseRootFromParent_Done,
     /*   83144 */   // Label 1346: @83144
     /*   83144 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(83233), // Rule ID 51561 //
     /*   83149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83164 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83183 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83192 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   83192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83231 */     GIR_RootConstrainSelectedInstOperands,
     /*   83232 */     // GIR_Coverage, 51561,
     /*   83232 */     GIR_EraseRootFromParent_Done,
     /*   83233 */   // Label 1347: @83233
     /*   83233 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(83322), // Rule ID 70135 //
     /*   83238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83253 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83272 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83281 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   83281 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83284 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83288 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83300 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83320 */     GIR_RootConstrainSelectedInstOperands,
     /*   83321 */     // GIR_Coverage, 70135,
     /*   83321 */     GIR_EraseRootFromParent_Done,
     /*   83322 */   // Label 1348: @83322
     /*   83322 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(83411), // Rule ID 70136 //
     /*   83327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83342 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83361 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83370 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   83370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*   83387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83409 */     GIR_RootConstrainSelectedInstOperands,
     /*   83410 */     // GIR_Coverage, 70136,
     /*   83410 */     GIR_EraseRootFromParent_Done,
     /*   83411 */   // Label 1349: @83411
     /*   83411 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(83500), // Rule ID 51440 //
     /*   83416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83431 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83450 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83459 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   83459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83498 */     GIR_RootConstrainSelectedInstOperands,
     /*   83499 */     // GIR_Coverage, 51440,
     /*   83499 */     GIR_EraseRootFromParent_Done,
     /*   83500 */   // Label 1350: @83500
     /*   83500 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(83589), // Rule ID 51441 //
     /*   83505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83520 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   83535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*   83539 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83548 */     // (mul:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   83548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*   83565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83587 */     GIR_RootConstrainSelectedInstOperands,
     /*   83588 */     // GIR_Coverage, 51441,
     /*   83588 */     GIR_EraseRootFromParent_Done,
     /*   83589 */   // Label 1351: @83589
     /*   83589 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(83642), // Rule ID 50746 //
     /*   83594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83605 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   83622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   83629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   83631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83640 */     GIR_RootConstrainSelectedInstOperands,
     /*   83641 */     // GIR_Coverage, 50746,
     /*   83641 */     GIR_EraseRootFromParent_Done,
     /*   83642 */   // Label 1352: @83642
     /*   83642 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(83695), // Rule ID 50747 //
     /*   83647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83658 */     // (mul:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*   83661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   83675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   83682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   83684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83693 */     GIR_RootConstrainSelectedInstOperands,
     /*   83694 */     // GIR_Coverage, 50747,
     /*   83694 */     GIR_EraseRootFromParent_Done,
     /*   83695 */   // Label 1353: @83695
     /*   83695 */   GIM_Reject,
     /*   83696 */ // Label 1333: @83696
     /*   83696 */ GIM_Reject,
     /*   83697 */ // Label 1242: @83697
     /*   83697 */ GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(85421),
     /*   83702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   83705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*   83708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83712 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(83801), // Rule ID 51524 //
     /*   83717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83732 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83751 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83760 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   83763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   83777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83799 */     GIR_RootConstrainSelectedInstOperands,
     /*   83800 */     // GIR_Coverage, 51524,
     /*   83800 */     GIR_EraseRootFromParent_Done,
     /*   83801 */   // Label 1355: @83801
     /*   83801 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(83890), // Rule ID 51525 //
     /*   83806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83821 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83840 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83849 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   83849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   83852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   83866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   83875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   83879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83888 */     GIR_RootConstrainSelectedInstOperands,
     /*   83889 */     // GIR_Coverage, 51525,
     /*   83889 */     GIR_EraseRootFromParent_Done,
     /*   83890 */   // Label 1356: @83890
     /*   83890 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(83979), // Rule ID 70219 //
     /*   83895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   83898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83910 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   83912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   83921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   83925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83929 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   83931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   83936 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   83938 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   83938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   83941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   83945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   83950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   83952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   83955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   83957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   83960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   83964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   83968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   83971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   83974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   83977 */     GIR_RootConstrainSelectedInstOperands,
     /*   83978 */     // GIR_Coverage, 70219,
     /*   83978 */     GIR_EraseRootFromParent_Done,
     /*   83979 */   // Label 1357: @83979
     /*   83979 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(84068), // Rule ID 70220 //
     /*   83984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   83987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   83991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   83995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   83999 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84018 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84020 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84027 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84066 */     GIR_RootConstrainSelectedInstOperands,
     /*   84067 */     // GIR_Coverage, 70220,
     /*   84067 */     GIR_EraseRootFromParent_Done,
     /*   84068 */   // Label 1358: @84068
     /*   84068 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(84157), // Rule ID 70099 //
     /*   84073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84088 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84095 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84099 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84103 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84107 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84114 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84116 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84155 */     GIR_RootConstrainSelectedInstOperands,
     /*   84156 */     // GIR_Coverage, 70099,
     /*   84156 */     GIR_EraseRootFromParent_Done,
     /*   84157 */   // Label 1359: @84157
     /*   84157 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(84246), // Rule ID 70100 //
     /*   84162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84177 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84192 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84196 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84205 */     // (mul:{ *:[nxv2i32] } (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   84231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   84235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84244 */     GIR_RootConstrainSelectedInstOperands,
     /*   84245 */     // GIR_Coverage, 70100,
     /*   84245 */     GIR_EraseRootFromParent_Done,
     /*   84246 */   // Label 1360: @84246
     /*   84246 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(84335), // Rule ID 51704 //
     /*   84251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84266 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84285 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84294 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84333 */     GIR_RootConstrainSelectedInstOperands,
     /*   84334 */     // GIR_Coverage, 51704,
     /*   84334 */     GIR_EraseRootFromParent_Done,
     /*   84335 */   // Label 1361: @84335
     /*   84335 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(84424), // Rule ID 51705 //
     /*   84340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84355 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84374 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84376 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84383 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84422 */     GIR_RootConstrainSelectedInstOperands,
     /*   84423 */     // GIR_Coverage, 51705,
     /*   84423 */     GIR_EraseRootFromParent_Done,
     /*   84424 */   // Label 1362: @84424
     /*   84424 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(84513), // Rule ID 51404 //
     /*   84429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84444 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84463 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84472 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   84489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84511 */     GIR_RootConstrainSelectedInstOperands,
     /*   84512 */     // GIR_Coverage, 51404,
     /*   84512 */     GIR_EraseRootFromParent_Done,
     /*   84513 */   // Label 1363: @84513
     /*   84513 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(84602), // Rule ID 51405 //
     /*   84518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84533 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84552 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84561 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   84578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84600 */     GIR_RootConstrainSelectedInstOperands,
     /*   84601 */     // GIR_Coverage, 51405,
     /*   84601 */     GIR_EraseRootFromParent_Done,
     /*   84602 */   // Label 1364: @84602
     /*   84602 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(84691), // Rule ID 51644 //
     /*   84607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84622 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84624 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84641 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84650 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84689 */     GIR_RootConstrainSelectedInstOperands,
     /*   84690 */     // GIR_Coverage, 51644,
     /*   84690 */     GIR_EraseRootFromParent_Done,
     /*   84691 */   // Label 1365: @84691
     /*   84691 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(84780), // Rule ID 51645 //
     /*   84696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84711 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84730 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84739 */     // (mul:{ *:[nxv2i32] } (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   84756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84778 */     GIR_RootConstrainSelectedInstOperands,
     /*   84779 */     // GIR_Coverage, 51645,
     /*   84779 */     GIR_EraseRootFromParent_Done,
     /*   84780 */   // Label 1366: @84780
     /*   84780 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(84869), // Rule ID 51584 //
     /*   84785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84800 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84819 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84828 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   84828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84867 */     GIR_RootConstrainSelectedInstOperands,
     /*   84868 */     // GIR_Coverage, 51584,
     /*   84868 */     GIR_EraseRootFromParent_Done,
     /*   84869 */   // Label 1367: @84869
     /*   84869 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(84958), // Rule ID 51585 //
     /*   84874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   84877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84889 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   84904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84908 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   84917 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   84917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   84920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   84924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   84929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   84931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   84934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   84936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   84939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   84943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   84947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   84950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   84953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   84956 */     GIR_RootConstrainSelectedInstOperands,
     /*   84957 */     // GIR_Coverage, 51585,
     /*   84957 */     GIR_EraseRootFromParent_Done,
     /*   84958 */   // Label 1368: @84958
     /*   84958 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(85047), // Rule ID 70159 //
     /*   84963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   84966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   84970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   84974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84978 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   84980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   84985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   84989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   84993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   84997 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   84999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85006 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   85006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   85042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85045 */     GIR_RootConstrainSelectedInstOperands,
     /*   85046 */     // GIR_Coverage, 70159,
     /*   85046 */     GIR_EraseRootFromParent_Done,
     /*   85047 */   // Label 1369: @85047
     /*   85047 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(85136), // Rule ID 70160 //
     /*   85052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   85055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85067 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85086 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85095 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   85095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   85112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   85131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85134 */     GIR_RootConstrainSelectedInstOperands,
     /*   85135 */     // GIR_Coverage, 70160,
     /*   85135 */     GIR_EraseRootFromParent_Done,
     /*   85136 */   // Label 1370: @85136
     /*   85136 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(85225), // Rule ID 51464 //
     /*   85141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   85144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85156 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85175 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85184 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   85184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   85220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85223 */     GIR_RootConstrainSelectedInstOperands,
     /*   85224 */     // GIR_Coverage, 51464,
     /*   85224 */     GIR_EraseRootFromParent_Done,
     /*   85225 */   // Label 1371: @85225
     /*   85225 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(85314), // Rule ID 51465 //
     /*   85230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   85233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85245 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*   85264 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85266 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85271 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85273 */     // (mul:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   85273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   85290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   85309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85312 */     GIR_RootConstrainSelectedInstOperands,
     /*   85313 */     // GIR_Coverage, 51465,
     /*   85313 */     GIR_EraseRootFromParent_Done,
     /*   85314 */   // Label 1372: @85314
     /*   85314 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(85367), // Rule ID 50762 //
     /*   85319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   85322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85330 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85365 */     GIR_RootConstrainSelectedInstOperands,
     /*   85366 */     // GIR_Coverage, 50762,
     /*   85366 */     GIR_EraseRootFromParent_Done,
     /*   85367 */   // Label 1373: @85367
     /*   85367 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(85420), // Rule ID 50763 //
     /*   85372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   85375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85383 */     // (mul:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*   85386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   85400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   85407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   85409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85418 */     GIR_RootConstrainSelectedInstOperands,
     /*   85419 */     // GIR_Coverage, 50763,
     /*   85419 */     GIR_EraseRootFromParent_Done,
     /*   85420 */   // Label 1374: @85420
     /*   85420 */   GIM_Reject,
     /*   85421 */ // Label 1354: @85421
     /*   85421 */ GIM_Reject,
     /*   85422 */ // Label 1243: @85422
     /*   85422 */ GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(87146),
     /*   85427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*   85430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*   85433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   85437 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(85526), // Rule ID 51544 //
     /*   85442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85457 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85476 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85485 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   85502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85524 */     GIR_RootConstrainSelectedInstOperands,
     /*   85525 */     // GIR_Coverage, 51544,
     /*   85525 */     GIR_EraseRootFromParent_Done,
     /*   85526 */   // Label 1376: @85526
     /*   85526 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(85615), // Rule ID 51545 //
     /*   85531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85546 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85565 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85574 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   85591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   85600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   85604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85613 */     GIR_RootConstrainSelectedInstOperands,
     /*   85614 */     // GIR_Coverage, 51545,
     /*   85614 */     GIR_EraseRootFromParent_Done,
     /*   85615 */   // Label 1377: @85615
     /*   85615 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(85704), // Rule ID 70239 //
     /*   85620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85635 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85654 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85663 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   85680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85702 */     GIR_RootConstrainSelectedInstOperands,
     /*   85703 */     // GIR_Coverage, 70239,
     /*   85703 */     GIR_EraseRootFromParent_Done,
     /*   85704 */   // Label 1378: @85704
     /*   85704 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(85793), // Rule ID 70240 //
     /*   85709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85724 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85743 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85745 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85752 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   85769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85791 */     GIR_RootConstrainSelectedInstOperands,
     /*   85792 */     // GIR_Coverage, 70240,
     /*   85792 */     GIR_EraseRootFromParent_Done,
     /*   85793 */   // Label 1379: @85793
     /*   85793 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(85882), // Rule ID 70119 //
     /*   85798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85813 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85832 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85839 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85841 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   85841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   85858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85880 */     GIR_RootConstrainSelectedInstOperands,
     /*   85881 */     // GIR_Coverage, 70119,
     /*   85881 */     GIR_EraseRootFromParent_Done,
     /*   85882 */   // Label 1380: @85882
     /*   85882 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(85971), // Rule ID 70120 //
     /*   85887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   85890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   85898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85902 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   85913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   85917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85921 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   85923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   85930 */     // (mul:{ *:[nxv2i64] } (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   85930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   85933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   85937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   85942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   85944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   85947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   85949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   85952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   85956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   85960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   85963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   85966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   85969 */     GIR_RootConstrainSelectedInstOperands,
     /*   85970 */     // GIR_Coverage, 70120,
     /*   85970 */     GIR_EraseRootFromParent_Done,
     /*   85971 */   // Label 1381: @85971
     /*   85971 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(86060), // Rule ID 51724 //
     /*   85976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   85979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   85983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   85987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   85991 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   85993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   85998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86010 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86019 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86058 */     GIR_RootConstrainSelectedInstOperands,
     /*   86059 */     // GIR_Coverage, 51724,
     /*   86059 */     GIR_EraseRootFromParent_Done,
     /*   86060 */   // Label 1382: @86060
     /*   86060 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(86149), // Rule ID 51725 //
     /*   86065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86080 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86099 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86108 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86147 */     GIR_RootConstrainSelectedInstOperands,
     /*   86148 */     // GIR_Coverage, 51725,
     /*   86148 */     GIR_EraseRootFromParent_Done,
     /*   86149 */   // Label 1383: @86149
     /*   86149 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(86238), // Rule ID 51424 //
     /*   86154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86169 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86188 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86197 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   86214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86236 */     GIR_RootConstrainSelectedInstOperands,
     /*   86237 */     // GIR_Coverage, 51424,
     /*   86237 */     GIR_EraseRootFromParent_Done,
     /*   86238 */   // Label 1384: @86238
     /*   86238 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(86327), // Rule ID 51425 //
     /*   86243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86258 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86277 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86286 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   86303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86325 */     GIR_RootConstrainSelectedInstOperands,
     /*   86326 */     // GIR_Coverage, 51425,
     /*   86326 */     GIR_EraseRootFromParent_Done,
     /*   86327 */   // Label 1385: @86327
     /*   86327 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(86416), // Rule ID 51664 //
     /*   86332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86347 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86366 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86368 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86375 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86414 */     GIR_RootConstrainSelectedInstOperands,
     /*   86415 */     // GIR_Coverage, 51664,
     /*   86415 */     GIR_EraseRootFromParent_Done,
     /*   86416 */   // Label 1386: @86416
     /*   86416 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(86505), // Rule ID 51665 //
     /*   86421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86436 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86455 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86464 */     // (mul:{ *:[nxv2i64] } (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86503 */     GIR_RootConstrainSelectedInstOperands,
     /*   86504 */     // GIR_Coverage, 51665,
     /*   86504 */     GIR_EraseRootFromParent_Done,
     /*   86505 */   // Label 1387: @86505
     /*   86505 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(86594), // Rule ID 51604 //
     /*   86510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86525 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86544 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86546 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86553 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   86570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86592 */     GIR_RootConstrainSelectedInstOperands,
     /*   86593 */     // GIR_Coverage, 51604,
     /*   86593 */     GIR_EraseRootFromParent_Done,
     /*   86594 */   // Label 1388: @86594
     /*   86594 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(86683), // Rule ID 51605 //
     /*   86599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86614 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   86629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86633 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86642 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   86659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86681 */     GIR_RootConstrainSelectedInstOperands,
     /*   86682 */     // GIR_Coverage, 51605,
     /*   86682 */     GIR_EraseRootFromParent_Done,
     /*   86683 */   // Label 1389: @86683
     /*   86683 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(86772), // Rule ID 70179 //
     /*   86688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86703 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86722 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86731 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86770 */     GIR_RootConstrainSelectedInstOperands,
     /*   86771 */     // GIR_Coverage, 70179,
     /*   86771 */     GIR_EraseRootFromParent_Done,
     /*   86772 */   // Label 1390: @86772
     /*   86772 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(86861), // Rule ID 70180 //
     /*   86777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86792 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   86807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86811 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86813 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86820 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   86837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   86846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   86850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86859 */     GIR_RootConstrainSelectedInstOperands,
     /*   86860 */     // GIR_Coverage, 70180,
     /*   86860 */     GIR_EraseRootFromParent_Done,
     /*   86861 */   // Label 1391: @86861
     /*   86861 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(86950), // Rule ID 51484 //
     /*   86866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   86869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86881 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86900 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86909 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   86909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   86912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   86916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   86921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   86923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   86926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   86928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   86931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   86935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   86939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   86942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   86945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   86948 */     GIR_RootConstrainSelectedInstOperands,
     /*   86949 */     // GIR_Coverage, 51484,
     /*   86949 */     GIR_EraseRootFromParent_Done,
     /*   86950 */   // Label 1392: @86950
     /*   86950 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(87039), // Rule ID 51485 //
     /*   86955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   86958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   86962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86970 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   86972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   86981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   86985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*   86989 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   86991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   86996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   86998 */     // (mul:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   86998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   87001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   87015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   87034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87037 */     GIR_RootConstrainSelectedInstOperands,
     /*   87038 */     // GIR_Coverage, 51485,
     /*   87038 */     GIR_EraseRootFromParent_Done,
     /*   87039 */   // Label 1393: @87039
     /*   87039 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(87092), // Rule ID 50806 //
     /*   87044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   87047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   87051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   87055 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   87055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   87058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   87072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   87087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87090 */     GIR_RootConstrainSelectedInstOperands,
     /*   87091 */     // GIR_Coverage, 50806,
     /*   87091 */     GIR_EraseRootFromParent_Done,
     /*   87092 */   // Label 1394: @87092
     /*   87092 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(87145), // Rule ID 50807 //
     /*   87097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   87100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   87104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   87108 */     // (mul:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   87108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*   87111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   87125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   87140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87143 */     GIR_RootConstrainSelectedInstOperands,
     /*   87144 */     // GIR_Coverage, 50807,
     /*   87144 */     GIR_EraseRootFromParent_Done,
     /*   87145 */   // Label 1395: @87145
     /*   87145 */   GIM_Reject,
     /*   87146 */ // Label 1375: @87146
     /*   87146 */ GIM_Reject,
     /*   87147 */ // Label 1244: @87147
     /*   87147 */ GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(87261),
     /*   87152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*   87158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87170 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(87215), // Rule ID 50738 //
     /*   87175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87178 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   87181 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87185 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87200 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87213 */     GIR_RootConstrainSelectedInstOperands,
     /*   87214 */     // GIR_Coverage, 50738,
     /*   87214 */     GIR_EraseRootFromParent_Done,
     /*   87215 */   // Label 1397: @87215
     /*   87215 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(87260), // Rule ID 50739 //
     /*   87220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87223 */     // (mul:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*   87226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*   87240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   87247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   87249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87258 */     GIR_RootConstrainSelectedInstOperands,
     /*   87259 */     // GIR_Coverage, 50739,
     /*   87259 */     GIR_EraseRootFromParent_Done,
     /*   87260 */   // Label 1398: @87260
     /*   87260 */   GIM_Reject,
     /*   87261 */ // Label 1396: @87261
     /*   87261 */ GIM_Reject,
     /*   87262 */ // Label 1245: @87262
     /*   87262 */ GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(88986),
     /*   87267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   87270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*   87273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87277 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(87366), // Rule ID 51504 //
     /*   87282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87297 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87325 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87364 */     GIR_RootConstrainSelectedInstOperands,
     /*   87365 */     // GIR_Coverage, 51504,
     /*   87365 */     GIR_EraseRootFromParent_Done,
     /*   87366 */   // Label 1400: @87366
     /*   87366 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(87455), // Rule ID 51505 //
     /*   87371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87386 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87405 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87414 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87433 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87453 */     GIR_RootConstrainSelectedInstOperands,
     /*   87454 */     // GIR_Coverage, 51505,
     /*   87454 */     GIR_EraseRootFromParent_Done,
     /*   87455 */   // Label 1401: @87455
     /*   87455 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(87544), // Rule ID 70199 //
     /*   87460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87475 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87494 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87496 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87503 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   87520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87542 */     GIR_RootConstrainSelectedInstOperands,
     /*   87543 */     // GIR_Coverage, 70199,
     /*   87543 */     GIR_EraseRootFromParent_Done,
     /*   87544 */   // Label 1402: @87544
     /*   87544 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(87633), // Rule ID 70200 //
     /*   87549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87564 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87583 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87592 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   87609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87631 */     GIR_RootConstrainSelectedInstOperands,
     /*   87632 */     // GIR_Coverage, 70200,
     /*   87632 */     GIR_EraseRootFromParent_Done,
     /*   87633 */   // Label 1403: @87633
     /*   87633 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(87722), // Rule ID 70079 //
     /*   87638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87653 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87672 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87681 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87720 */     GIR_RootConstrainSelectedInstOperands,
     /*   87721 */     // GIR_Coverage, 70079,
     /*   87721 */     GIR_EraseRootFromParent_Done,
     /*   87722 */   // Label 1404: @87722
     /*   87722 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(87811), // Rule ID 70080 //
     /*   87727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87742 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   87757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87761 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87770 */     // (mul:{ *:[nxv4i16] } (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   87787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   87796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   87800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87809 */     GIR_RootConstrainSelectedInstOperands,
     /*   87810 */     // GIR_Coverage, 70080,
     /*   87810 */     GIR_EraseRootFromParent_Done,
     /*   87811 */   // Label 1405: @87811
     /*   87811 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(87900), // Rule ID 51684 //
     /*   87816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87831 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87850 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87859 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   87859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   87876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87898 */     GIR_RootConstrainSelectedInstOperands,
     /*   87899 */     // GIR_Coverage, 51684,
     /*   87899 */     GIR_EraseRootFromParent_Done,
     /*   87900 */   // Label 1406: @87900
     /*   87900 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(87989), // Rule ID 51685 //
     /*   87905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   87908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   87912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   87916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87920 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   87922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   87931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   87935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   87939 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   87941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   87946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   87948 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   87948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   87951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   87955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   87960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   87962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   87965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   87967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   87970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   87974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   87978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   87981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   87987 */     GIR_RootConstrainSelectedInstOperands,
     /*   87988 */     // GIR_Coverage, 51685,
     /*   87988 */     GIR_EraseRootFromParent_Done,
     /*   87989 */   // Label 1407: @87989
     /*   87989 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(88078), // Rule ID 51384 //
     /*   87994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   87997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88009 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88024 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88028 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88030 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88037 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88076 */     GIR_RootConstrainSelectedInstOperands,
     /*   88077 */     // GIR_Coverage, 51384,
     /*   88077 */     GIR_EraseRootFromParent_Done,
     /*   88078 */   // Label 1408: @88078
     /*   88078 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(88167), // Rule ID 51385 //
     /*   88083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88098 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88117 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88126 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*   88143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88165 */     GIR_RootConstrainSelectedInstOperands,
     /*   88166 */     // GIR_Coverage, 51385,
     /*   88166 */     GIR_EraseRootFromParent_Done,
     /*   88167 */   // Label 1409: @88167
     /*   88167 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(88256), // Rule ID 51624 //
     /*   88172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88187 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88206 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88215 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88254 */     GIR_RootConstrainSelectedInstOperands,
     /*   88255 */     // GIR_Coverage, 51624,
     /*   88255 */     GIR_EraseRootFromParent_Done,
     /*   88256 */   // Label 1410: @88256
     /*   88256 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(88345), // Rule ID 51625 //
     /*   88261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88276 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88295 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88304 */     // (mul:{ *:[nxv4i16] } (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88343 */     GIR_RootConstrainSelectedInstOperands,
     /*   88344 */     // GIR_Coverage, 51625,
     /*   88344 */     GIR_EraseRootFromParent_Done,
     /*   88345 */   // Label 1411: @88345
     /*   88345 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(88434), // Rule ID 51564 //
     /*   88350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88365 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88384 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88393 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88432 */     GIR_RootConstrainSelectedInstOperands,
     /*   88433 */     // GIR_Coverage, 51564,
     /*   88433 */     GIR_EraseRootFromParent_Done,
     /*   88434 */   // Label 1412: @88434
     /*   88434 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(88523), // Rule ID 51565 //
     /*   88439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88454 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   88469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88473 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88482 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88521 */     GIR_RootConstrainSelectedInstOperands,
     /*   88522 */     // GIR_Coverage, 51565,
     /*   88522 */     GIR_EraseRootFromParent_Done,
     /*   88523 */   // Label 1413: @88523
     /*   88523 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(88612), // Rule ID 70139 //
     /*   88528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88543 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88562 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88571 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88610 */     GIR_RootConstrainSelectedInstOperands,
     /*   88611 */     // GIR_Coverage, 70139,
     /*   88611 */     GIR_EraseRootFromParent_Done,
     /*   88612 */   // Label 1414: @88612
     /*   88612 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(88701), // Rule ID 70140 //
     /*   88617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88632 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   88647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88651 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88653 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88660 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*   88677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   88686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   88690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88699 */     GIR_RootConstrainSelectedInstOperands,
     /*   88700 */     // GIR_Coverage, 70140,
     /*   88700 */     GIR_EraseRootFromParent_Done,
     /*   88701 */   // Label 1415: @88701
     /*   88701 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(88790), // Rule ID 51444 //
     /*   88706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88721 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88740 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88742 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88749 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   88749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88788 */     GIR_RootConstrainSelectedInstOperands,
     /*   88789 */     // GIR_Coverage, 51444,
     /*   88789 */     GIR_EraseRootFromParent_Done,
     /*   88790 */   // Label 1416: @88790
     /*   88790 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(88879), // Rule ID 51445 //
     /*   88795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   88802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88810 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   88812 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   88821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   88825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*   88829 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   88831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   88838 */     // (mul:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   88838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*   88855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   88864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   88868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88877 */     GIR_RootConstrainSelectedInstOperands,
     /*   88878 */     // GIR_Coverage, 51445,
     /*   88878 */     GIR_EraseRootFromParent_Done,
     /*   88879 */   // Label 1417: @88879
     /*   88879 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(88932), // Rule ID 50758 //
     /*   88884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   88887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88895 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   88895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   88912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88930 */     GIR_RootConstrainSelectedInstOperands,
     /*   88931 */     // GIR_Coverage, 50758,
     /*   88931 */     GIR_EraseRootFromParent_Done,
     /*   88932 */   // Label 1418: @88932
     /*   88932 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(88985), // Rule ID 50759 //
     /*   88937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   88940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   88948 */     // (mul:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   88948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*   88951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   88955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   88960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   88962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   88965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   88967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   88970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   88972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   88974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   88977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   88980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   88983 */     GIR_RootConstrainSelectedInstOperands,
     /*   88984 */     // GIR_Coverage, 50759,
     /*   88984 */     GIR_EraseRootFromParent_Done,
     /*   88985 */   // Label 1419: @88985
     /*   88985 */   GIM_Reject,
     /*   88986 */ // Label 1399: @88986
     /*   88986 */ GIM_Reject,
     /*   88987 */ // Label 1246: @88987
     /*   88987 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(90711),
     /*   88992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   88995 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*   88998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   89002 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(89091), // Rule ID 51528 //
     /*   89007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89022 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89041 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89050 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89089 */     GIR_RootConstrainSelectedInstOperands,
     /*   89090 */     // GIR_Coverage, 51528,
     /*   89090 */     GIR_EraseRootFromParent_Done,
     /*   89091 */   // Label 1421: @89091
     /*   89091 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(89180), // Rule ID 51529 //
     /*   89096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89111 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89126 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89130 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89139 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89178 */     GIR_RootConstrainSelectedInstOperands,
     /*   89179 */     // GIR_Coverage, 51529,
     /*   89179 */     GIR_EraseRootFromParent_Done,
     /*   89180 */   // Label 1422: @89180
     /*   89180 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(89269), // Rule ID 70223 //
     /*   89185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89200 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89219 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89228 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89267 */     GIR_RootConstrainSelectedInstOperands,
     /*   89268 */     // GIR_Coverage, 70223,
     /*   89268 */     GIR_EraseRootFromParent_Done,
     /*   89269 */   // Label 1423: @89269
     /*   89269 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(89358), // Rule ID 70224 //
     /*   89274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89289 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89304 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89308 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89310 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89317 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89356 */     GIR_RootConstrainSelectedInstOperands,
     /*   89357 */     // GIR_Coverage, 70224,
     /*   89357 */     GIR_EraseRootFromParent_Done,
     /*   89358 */   // Label 1424: @89358
     /*   89358 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(89447), // Rule ID 70103 //
     /*   89363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89378 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89397 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89406 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89445 */     GIR_RootConstrainSelectedInstOperands,
     /*   89446 */     // GIR_Coverage, 70103,
     /*   89446 */     GIR_EraseRootFromParent_Done,
     /*   89447 */   // Label 1425: @89447
     /*   89447 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(89536), // Rule ID 70104 //
     /*   89452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89467 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89486 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89495 */     // (mul:{ *:[nxv4i32] } (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   89512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   89521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   89525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89534 */     GIR_RootConstrainSelectedInstOperands,
     /*   89535 */     // GIR_Coverage, 70104,
     /*   89535 */     GIR_EraseRootFromParent_Done,
     /*   89536 */   // Label 1426: @89536
     /*   89536 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(89625), // Rule ID 51708 //
     /*   89541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89556 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89563 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89567 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89571 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89575 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89584 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89623 */     GIR_RootConstrainSelectedInstOperands,
     /*   89624 */     // GIR_Coverage, 51708,
     /*   89624 */     GIR_EraseRootFromParent_Done,
     /*   89625 */   // Label 1427: @89625
     /*   89625 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(89714), // Rule ID 51709 //
     /*   89630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89645 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   89660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89664 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89673 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89712 */     GIR_RootConstrainSelectedInstOperands,
     /*   89713 */     // GIR_Coverage, 51709,
     /*   89713 */     GIR_EraseRootFromParent_Done,
     /*   89714 */   // Label 1428: @89714
     /*   89714 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(89803), // Rule ID 51408 //
     /*   89719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89734 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89753 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89755 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89762 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   89779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89801 */     GIR_RootConstrainSelectedInstOperands,
     /*   89802 */     // GIR_Coverage, 51408,
     /*   89802 */     GIR_EraseRootFromParent_Done,
     /*   89803 */   // Label 1429: @89803
     /*   89803 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(89892), // Rule ID 51409 //
     /*   89808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89823 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89842 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89851 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   89851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   89868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89890 */     GIR_RootConstrainSelectedInstOperands,
     /*   89891 */     // GIR_Coverage, 51409,
     /*   89891 */     GIR_EraseRootFromParent_Done,
     /*   89892 */   // Label 1430: @89892
     /*   89892 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(89981), // Rule ID 51648 //
     /*   89897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   89900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89912 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   89914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   89923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   89927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   89931 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   89933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   89938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   89940 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   89940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   89943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   89947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   89952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   89954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   89957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   89959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   89962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   89966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   89970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   89973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   89976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   89979 */     GIR_RootConstrainSelectedInstOperands,
     /*   89980 */     // GIR_Coverage, 51648,
     /*   89980 */     GIR_EraseRootFromParent_Done,
     /*   89981 */   // Label 1431: @89981
     /*   89981 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(90070), // Rule ID 51649 //
     /*   89986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   89989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   89993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   89997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90001 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90020 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90022 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90029 */     // (mul:{ *:[nxv4i32] } (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   90029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90068 */     GIR_RootConstrainSelectedInstOperands,
     /*   90069 */     // GIR_Coverage, 51649,
     /*   90069 */     GIR_EraseRootFromParent_Done,
     /*   90070 */   // Label 1432: @90070
     /*   90070 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(90159), // Rule ID 51588 //
     /*   90075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   90078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90090 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90109 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90118 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   90118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90157 */     GIR_RootConstrainSelectedInstOperands,
     /*   90158 */     // GIR_Coverage, 51588,
     /*   90158 */     GIR_EraseRootFromParent_Done,
     /*   90159 */   // Label 1433: @90159
     /*   90159 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(90248), // Rule ID 51589 //
     /*   90164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   90167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90179 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90198 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90200 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90207 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   90207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90246 */     GIR_RootConstrainSelectedInstOperands,
     /*   90247 */     // GIR_Coverage, 51589,
     /*   90247 */     GIR_EraseRootFromParent_Done,
     /*   90248 */   // Label 1434: @90248
     /*   90248 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(90337), // Rule ID 70163 //
     /*   90253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   90256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90268 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90270 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90287 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90294 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90296 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   90296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90335 */     GIR_RootConstrainSelectedInstOperands,
     /*   90336 */     // GIR_Coverage, 70163,
     /*   90336 */     GIR_EraseRootFromParent_Done,
     /*   90337 */   // Label 1435: @90337
     /*   90337 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(90426), // Rule ID 70164 //
     /*   90342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   90345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90357 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90376 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90385 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   90385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   90402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90424 */     GIR_RootConstrainSelectedInstOperands,
     /*   90425 */     // GIR_Coverage, 70164,
     /*   90425 */     GIR_EraseRootFromParent_Done,
     /*   90426 */   // Label 1436: @90426
     /*   90426 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(90515), // Rule ID 51468 //
     /*   90431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   90434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90446 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90465 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90474 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   90474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90513 */     GIR_RootConstrainSelectedInstOperands,
     /*   90514 */     // GIR_Coverage, 51468,
     /*   90514 */     GIR_EraseRootFromParent_Done,
     /*   90515 */   // Label 1437: @90515
     /*   90515 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(90604), // Rule ID 51469 //
     /*   90520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   90523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90535 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   90550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*   90554 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   90561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90563 */     // (mul:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   90563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   90580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   90599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90602 */     GIR_RootConstrainSelectedInstOperands,
     /*   90603 */     // GIR_Coverage, 51469,
     /*   90603 */     GIR_EraseRootFromParent_Done,
     /*   90604 */   // Label 1438: @90604
     /*   90604 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(90657), // Rule ID 50794 //
     /*   90609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   90612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90620 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   90637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   90644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   90646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90655 */     GIR_RootConstrainSelectedInstOperands,
     /*   90656 */     // GIR_Coverage, 50794,
     /*   90656 */     GIR_EraseRootFromParent_Done,
     /*   90657 */   // Label 1439: @90657
     /*   90657 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(90710), // Rule ID 50795 //
     /*   90662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   90665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90673 */     // (mul:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*   90676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   90690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   90697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   90699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90708 */     GIR_RootConstrainSelectedInstOperands,
     /*   90709 */     // GIR_Coverage, 50795,
     /*   90709 */     GIR_EraseRootFromParent_Done,
     /*   90710 */   // Label 1440: @90710
     /*   90710 */   GIM_Reject,
     /*   90711 */ // Label 1420: @90711
     /*   90711 */ GIM_Reject,
     /*   90712 */ // Label 1247: @90712
     /*   90712 */ GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92436),
     /*   90717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*   90720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*   90723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   90727 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(90816), // Rule ID 51548 //
     /*   90732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90747 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90766 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90775 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   90778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   90792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90814 */     GIR_RootConstrainSelectedInstOperands,
     /*   90815 */     // GIR_Coverage, 51548,
     /*   90815 */     GIR_EraseRootFromParent_Done,
     /*   90816 */   // Label 1442: @90816
     /*   90816 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(90905), // Rule ID 51549 //
     /*   90821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   90824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90836 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90851 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90855 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90857 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90864 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   90864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   90867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   90881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   90890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   90894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90903 */     GIR_RootConstrainSelectedInstOperands,
     /*   90904 */     // GIR_Coverage, 51549,
     /*   90904 */     GIR_EraseRootFromParent_Done,
     /*   90905 */   // Label 1443: @90905
     /*   90905 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(90994), // Rule ID 70243 //
     /*   90910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   90913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   90917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   90921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90925 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   90927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   90936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   90940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   90944 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   90946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   90951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   90953 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   90953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   90956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   90960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   90965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   90967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   90970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   90972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   90975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   90979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   90983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   90986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   90989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   90992 */     GIR_RootConstrainSelectedInstOperands,
     /*   90993 */     // GIR_Coverage, 70243,
     /*   90993 */     GIR_EraseRootFromParent_Done,
     /*   90994 */   // Label 1444: @90994
     /*   90994 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(91083), // Rule ID 70244 //
     /*   90999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91014 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91033 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91042 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   91059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91081 */     GIR_RootConstrainSelectedInstOperands,
     /*   91082 */     // GIR_Coverage, 70244,
     /*   91082 */     GIR_EraseRootFromParent_Done,
     /*   91083 */   // Label 1445: @91083
     /*   91083 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(91172), // Rule ID 70123 //
     /*   91088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91103 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91122 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91131 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   91148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91170 */     GIR_RootConstrainSelectedInstOperands,
     /*   91171 */     // GIR_Coverage, 70123,
     /*   91171 */     GIR_EraseRootFromParent_Done,
     /*   91172 */   // Label 1446: @91172
     /*   91172 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(91261), // Rule ID 70124 //
     /*   91177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91192 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91211 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91218 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91220 */     // (mul:{ *:[nxv4i64] } (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   91237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   91246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   91250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91259 */     GIR_RootConstrainSelectedInstOperands,
     /*   91260 */     // GIR_Coverage, 70124,
     /*   91260 */     GIR_EraseRootFromParent_Done,
     /*   91261 */   // Label 1447: @91261
     /*   91261 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(91350), // Rule ID 51728 //
     /*   91266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91281 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91300 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91309 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   91326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91348 */     GIR_RootConstrainSelectedInstOperands,
     /*   91349 */     // GIR_Coverage, 51728,
     /*   91349 */     GIR_EraseRootFromParent_Done,
     /*   91350 */   // Label 1448: @91350
     /*   91350 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(91439), // Rule ID 51729 //
     /*   91355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91370 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91389 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91398 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   91415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91437 */     GIR_RootConstrainSelectedInstOperands,
     /*   91438 */     // GIR_Coverage, 51729,
     /*   91438 */     GIR_EraseRootFromParent_Done,
     /*   91439 */   // Label 1449: @91439
     /*   91439 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(91528), // Rule ID 51428 //
     /*   91444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91459 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91487 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   91504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91526 */     GIR_RootConstrainSelectedInstOperands,
     /*   91527 */     // GIR_Coverage, 51428,
     /*   91527 */     GIR_EraseRootFromParent_Done,
     /*   91528 */   // Label 1450: @91528
     /*   91528 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(91617), // Rule ID 51429 //
     /*   91533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91548 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91567 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91576 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   91593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91615 */     GIR_RootConstrainSelectedInstOperands,
     /*   91616 */     // GIR_Coverage, 51429,
     /*   91616 */     GIR_EraseRootFromParent_Done,
     /*   91617 */   // Label 1451: @91617
     /*   91617 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(91706), // Rule ID 51668 //
     /*   91622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91637 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91656 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91665 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   91682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91704 */     GIR_RootConstrainSelectedInstOperands,
     /*   91705 */     // GIR_Coverage, 51668,
     /*   91705 */     GIR_EraseRootFromParent_Done,
     /*   91706 */   // Label 1452: @91706
     /*   91706 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(91795), // Rule ID 51669 //
     /*   91711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   91722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91726 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91745 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91754 */     // (mul:{ *:[nxv4i64] } (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   91771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91793 */     GIR_RootConstrainSelectedInstOperands,
     /*   91794 */     // GIR_Coverage, 51669,
     /*   91794 */     GIR_EraseRootFromParent_Done,
     /*   91795 */   // Label 1453: @91795
     /*   91795 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(91884), // Rule ID 51608 //
     /*   91800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91815 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91834 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91843 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   91843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   91860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91882 */     GIR_RootConstrainSelectedInstOperands,
     /*   91883 */     // GIR_Coverage, 51608,
     /*   91883 */     GIR_EraseRootFromParent_Done,
     /*   91884 */   // Label 1454: @91884
     /*   91884 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(91973), // Rule ID 51609 //
     /*   91889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   91892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91904 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   91915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   91919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91923 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   91925 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   91930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   91932 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   91932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   91935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   91939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   91944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   91946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   91949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   91951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   91954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   91958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   91962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   91965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   91968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   91971 */     GIR_RootConstrainSelectedInstOperands,
     /*   91972 */     // GIR_Coverage, 51609,
     /*   91972 */     GIR_EraseRootFromParent_Done,
     /*   91973 */   // Label 1455: @91973
     /*   91973 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(92062), // Rule ID 70183 //
     /*   91978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   91981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   91985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   91989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   91993 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   91995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92012 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92021 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   92021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   92038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   92057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92060 */     GIR_RootConstrainSelectedInstOperands,
     /*   92061 */     // GIR_Coverage, 70183,
     /*   92061 */     GIR_EraseRootFromParent_Done,
     /*   92062 */   // Label 1456: @92062
     /*   92062 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(92151), // Rule ID 70184 //
     /*   92067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   92070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92082 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92101 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92110 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   92110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   92127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   92146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92149 */     GIR_RootConstrainSelectedInstOperands,
     /*   92150 */     // GIR_Coverage, 70184,
     /*   92150 */     GIR_EraseRootFromParent_Done,
     /*   92151 */   // Label 1457: @92151
     /*   92151 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(92240), // Rule ID 51488 //
     /*   92156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   92159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92167 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92171 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92190 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92199 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   92199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   92216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   92235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92238 */     GIR_RootConstrainSelectedInstOperands,
     /*   92239 */     // GIR_Coverage, 51488,
     /*   92239 */     GIR_EraseRootFromParent_Done,
     /*   92240 */   // Label 1458: @92240
     /*   92240 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(92329), // Rule ID 51489 //
     /*   92245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   92248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92260 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*   92279 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92288 */     // (mul:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   92288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   92305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   92324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92327 */     GIR_RootConstrainSelectedInstOperands,
     /*   92328 */     // GIR_Coverage, 51489,
     /*   92328 */     GIR_EraseRootFromParent_Done,
     /*   92329 */   // Label 1459: @92329
     /*   92329 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(92382), // Rule ID 50810 //
     /*   92334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   92337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   92341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   92345 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   92345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   92362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   92369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   92371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   92377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92380 */     GIR_RootConstrainSelectedInstOperands,
     /*   92381 */     // GIR_Coverage, 50810,
     /*   92381 */     GIR_EraseRootFromParent_Done,
     /*   92382 */   // Label 1460: @92382
     /*   92382 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(92435), // Rule ID 50811 //
     /*   92387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   92390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   92394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   92398 */     // (mul:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   92398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*   92401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   92415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   92422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   92424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   92430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92433 */     GIR_RootConstrainSelectedInstOperands,
     /*   92434 */     // GIR_Coverage, 50811,
     /*   92434 */     GIR_EraseRootFromParent_Done,
     /*   92435 */   // Label 1461: @92435
     /*   92435 */   GIM_Reject,
     /*   92436 */ // Label 1441: @92436
     /*   92436 */ GIM_Reject,
     /*   92437 */ // Label 1248: @92437
     /*   92437 */ GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(92551),
     /*   92442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*   92448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92460 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(92505), // Rule ID 50754 //
     /*   92465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92468 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   92471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   92485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   92492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   92494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92503 */     GIR_RootConstrainSelectedInstOperands,
     /*   92504 */     // GIR_Coverage, 50754,
     /*   92504 */     GIR_EraseRootFromParent_Done,
     /*   92505 */   // Label 1463: @92505
     /*   92505 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(92550), // Rule ID 50755 //
     /*   92510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92513 */     // (mul:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*   92516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*   92530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   92537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   92539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92548 */     GIR_RootConstrainSelectedInstOperands,
     /*   92549 */     // GIR_Coverage, 50755,
     /*   92549 */     GIR_EraseRootFromParent_Done,
     /*   92550 */   // Label 1464: @92550
     /*   92550 */   GIM_Reject,
     /*   92551 */ // Label 1462: @92551
     /*   92551 */ GIM_Reject,
     /*   92552 */ // Label 1249: @92552
     /*   92552 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94276),
     /*   92557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   92560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*   92563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   92567 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(92656), // Rule ID 51508 //
     /*   92572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92587 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92589 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92606 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92615 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   92618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   92632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92654 */     GIR_RootConstrainSelectedInstOperands,
     /*   92655 */     // GIR_Coverage, 51508,
     /*   92655 */     GIR_EraseRootFromParent_Done,
     /*   92656 */   // Label 1466: @92656
     /*   92656 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(92745), // Rule ID 51509 //
     /*   92661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92676 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92695 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92704 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   92707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   92721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   92730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   92734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92743 */     GIR_RootConstrainSelectedInstOperands,
     /*   92744 */     // GIR_Coverage, 51509,
     /*   92744 */     GIR_EraseRootFromParent_Done,
     /*   92745 */   // Label 1467: @92745
     /*   92745 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(92834), // Rule ID 70203 //
     /*   92750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92765 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92784 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92791 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92793 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   92796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   92810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92832 */     GIR_RootConstrainSelectedInstOperands,
     /*   92833 */     // GIR_Coverage, 70203,
     /*   92833 */     GIR_EraseRootFromParent_Done,
     /*   92834 */   // Label 1468: @92834
     /*   92834 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(92923), // Rule ID 70204 //
     /*   92839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   92842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92854 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92861 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92865 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   92869 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92873 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92882 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   92882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   92885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   92899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   92912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   92915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   92921 */     GIR_RootConstrainSelectedInstOperands,
     /*   92922 */     // GIR_Coverage, 70204,
     /*   92922 */     GIR_EraseRootFromParent_Done,
     /*   92923 */   // Label 1469: @92923
     /*   92923 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(93012), // Rule ID 70083 //
     /*   92928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   92931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   92935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   92939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92943 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   92945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   92954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   92958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   92962 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   92964 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   92969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   92971 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   92971 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   92974 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   92978 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   92983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   92985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   92988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   92990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   92993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   92997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93010 */     GIR_RootConstrainSelectedInstOperands,
     /*   93011 */     // GIR_Coverage, 70083,
     /*   93011 */     GIR_EraseRootFromParent_Done,
     /*   93012 */   // Label 1470: @93012
     /*   93012 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(93101), // Rule ID 70084 //
     /*   93017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93032 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93051 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93060 */     // (mul:{ *:[nxv8i16] } (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93099 */     GIR_RootConstrainSelectedInstOperands,
     /*   93100 */     // GIR_Coverage, 70084,
     /*   93100 */     GIR_EraseRootFromParent_Done,
     /*   93101 */   // Label 1471: @93101
     /*   93101 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(93190), // Rule ID 51688 //
     /*   93106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93121 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93140 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93147 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93149 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93188 */     GIR_RootConstrainSelectedInstOperands,
     /*   93189 */     // GIR_Coverage, 51688,
     /*   93189 */     GIR_EraseRootFromParent_Done,
     /*   93190 */   // Label 1472: @93190
     /*   93190 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(93279), // Rule ID 51689 //
     /*   93195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93210 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93229 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93231 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93238 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93277 */     GIR_RootConstrainSelectedInstOperands,
     /*   93278 */     // GIR_Coverage, 51689,
     /*   93278 */     GIR_EraseRootFromParent_Done,
     /*   93279 */   // Label 1473: @93279
     /*   93279 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(93368), // Rule ID 51388 //
     /*   93284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93299 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93318 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93327 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93346 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93366 */     GIR_RootConstrainSelectedInstOperands,
     /*   93367 */     // GIR_Coverage, 51388,
     /*   93367 */     GIR_EraseRootFromParent_Done,
     /*   93368 */   // Label 1474: @93368
     /*   93368 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(93457), // Rule ID 51389 //
     /*   93373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93388 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93407 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93416 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*   93433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93455 */     GIR_RootConstrainSelectedInstOperands,
     /*   93456 */     // GIR_Coverage, 51389,
     /*   93456 */     GIR_EraseRootFromParent_Done,
     /*   93457 */   // Label 1475: @93457
     /*   93457 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(93546), // Rule ID 51628 //
     /*   93462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93477 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93496 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93505 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93544 */     GIR_RootConstrainSelectedInstOperands,
     /*   93545 */     // GIR_Coverage, 51628,
     /*   93545 */     GIR_EraseRootFromParent_Done,
     /*   93546 */   // Label 1476: @93546
     /*   93546 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(93635), // Rule ID 51629 //
     /*   93551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93566 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93585 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93594 */     // (mul:{ *:[nxv8i16] } (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93633 */     GIR_RootConstrainSelectedInstOperands,
     /*   93634 */     // GIR_Coverage, 51629,
     /*   93634 */     GIR_EraseRootFromParent_Done,
     /*   93635 */   // Label 1477: @93635
     /*   93635 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(93724), // Rule ID 51568 //
     /*   93640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93655 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93674 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93683 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93722 */     GIR_RootConstrainSelectedInstOperands,
     /*   93723 */     // GIR_Coverage, 51568,
     /*   93723 */     GIR_EraseRootFromParent_Done,
     /*   93724 */   // Label 1478: @93724
     /*   93724 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(93813), // Rule ID 51569 //
     /*   93729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93744 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   93759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93763 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93772 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   93789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   93798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   93802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93811 */     GIR_RootConstrainSelectedInstOperands,
     /*   93812 */     // GIR_Coverage, 51569,
     /*   93812 */     GIR_EraseRootFromParent_Done,
     /*   93813 */   // Label 1479: @93813
     /*   93813 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(93902), // Rule ID 70143 //
     /*   93818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93833 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93852 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93854 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93861 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   93861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93900 */     GIR_RootConstrainSelectedInstOperands,
     /*   93901 */     // GIR_Coverage, 70143,
     /*   93901 */     GIR_EraseRootFromParent_Done,
     /*   93902 */   // Label 1480: @93902
     /*   93902 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(93991), // Rule ID 70144 //
     /*   93907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   93910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   93914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   93918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93922 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   93924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   93933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   93937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   93941 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   93943 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   93948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   93950 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   93950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   93953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   93957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   93962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   93964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*   93967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   93969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   93972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   93976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   93980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   93983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   93989 */     GIR_RootConstrainSelectedInstOperands,
     /*   93990 */     // GIR_Coverage, 70144,
     /*   93990 */     GIR_EraseRootFromParent_Done,
     /*   93991 */   // Label 1481: @93991
     /*   93991 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(94080), // Rule ID 51448 //
     /*   93996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   93999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   94011 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   94030 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94039 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   94039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   94042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94078 */     GIR_RootConstrainSelectedInstOperands,
     /*   94079 */     // GIR_Coverage, 51448,
     /*   94079 */     GIR_EraseRootFromParent_Done,
     /*   94080 */   // Label 1482: @94080
     /*   94080 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(94169), // Rule ID 51449 //
     /*   94085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   94100 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*   94119 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*   94126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94128 */     // (mul:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   94128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   94131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*   94145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94167 */     GIR_RootConstrainSelectedInstOperands,
     /*   94168 */     // GIR_Coverage, 51449,
     /*   94168 */     GIR_EraseRootFromParent_Done,
     /*   94169 */   // Label 1483: @94169
     /*   94169 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(94222), // Rule ID 50782 //
     /*   94174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94185 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   94188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94207 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94220 */     GIR_RootConstrainSelectedInstOperands,
     /*   94221 */     // GIR_Coverage, 50782,
     /*   94221 */     GIR_EraseRootFromParent_Done,
     /*   94222 */   // Label 1484: @94222
     /*   94222 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(94275), // Rule ID 50783 //
     /*   94227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94238 */     // (mul:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*   94241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   94255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   94262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   94264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94273 */     GIR_RootConstrainSelectedInstOperands,
     /*   94274 */     // GIR_Coverage, 50783,
     /*   94274 */     GIR_EraseRootFromParent_Done,
     /*   94275 */   // Label 1485: @94275
     /*   94275 */   GIM_Reject,
     /*   94276 */ // Label 1465: @94276
     /*   94276 */ GIM_Reject,
     /*   94277 */ // Label 1250: @94277
     /*   94277 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(96001),
     /*   94282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   94285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*   94288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   94292 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(94381), // Rule ID 51532 //
     /*   94297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94312 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94331 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94340 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94379 */     GIR_RootConstrainSelectedInstOperands,
     /*   94380 */     // GIR_Coverage, 51532,
     /*   94380 */     GIR_EraseRootFromParent_Done,
     /*   94381 */   // Label 1487: @94381
     /*   94381 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(94470), // Rule ID 51533 //
     /*   94386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94420 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94422 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94429 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94468 */     GIR_RootConstrainSelectedInstOperands,
     /*   94469 */     // GIR_Coverage, 51533,
     /*   94469 */     GIR_EraseRootFromParent_Done,
     /*   94470 */   // Label 1488: @94470
     /*   94470 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(94559), // Rule ID 70227 //
     /*   94475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94490 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94509 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94518 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   94535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94557 */     GIR_RootConstrainSelectedInstOperands,
     /*   94558 */     // GIR_Coverage, 70227,
     /*   94558 */     GIR_EraseRootFromParent_Done,
     /*   94559 */   // Label 1489: @94559
     /*   94559 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(94648), // Rule ID 70228 //
     /*   94564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94579 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94598 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94607 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   94624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94646 */     GIR_RootConstrainSelectedInstOperands,
     /*   94647 */     // GIR_Coverage, 70228,
     /*   94647 */     GIR_EraseRootFromParent_Done,
     /*   94648 */   // Label 1490: @94648
     /*   94648 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(94737), // Rule ID 70107 //
     /*   94653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94668 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94687 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94696 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94735 */     GIR_RootConstrainSelectedInstOperands,
     /*   94736 */     // GIR_Coverage, 70107,
     /*   94736 */     GIR_EraseRootFromParent_Done,
     /*   94737 */   // Label 1491: @94737
     /*   94737 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(94826), // Rule ID 70108 //
     /*   94742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94757 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   94772 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94776 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94785 */     // (mul:{ *:[nxv8i32] } (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   94802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   94811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   94815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94824 */     GIR_RootConstrainSelectedInstOperands,
     /*   94825 */     // GIR_Coverage, 70108,
     /*   94825 */     GIR_EraseRootFromParent_Done,
     /*   94826 */   // Label 1492: @94826
     /*   94826 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(94915), // Rule ID 51712 //
     /*   94831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   94834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94846 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94865 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94874 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   94874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94877 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94881 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   94891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   94913 */     GIR_RootConstrainSelectedInstOperands,
     /*   94914 */     // GIR_Coverage, 51712,
     /*   94914 */     GIR_EraseRootFromParent_Done,
     /*   94915 */   // Label 1493: @94915
     /*   94915 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(95004), // Rule ID 51713 //
     /*   94920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   94923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   94927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   94931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94935 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   94937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   94946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   94950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   94954 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   94956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   94961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   94963 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   94963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   94966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   94970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   94975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   94977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   94980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   94982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   94985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   94989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   94993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   94996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   94999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95002 */     GIR_RootConstrainSelectedInstOperands,
     /*   95003 */     // GIR_Coverage, 51713,
     /*   95003 */     GIR_EraseRootFromParent_Done,
     /*   95004 */   // Label 1494: @95004
     /*   95004 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(95093), // Rule ID 51412 //
     /*   95009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95024 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95043 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95045 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95052 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95091 */     GIR_RootConstrainSelectedInstOperands,
     /*   95092 */     // GIR_Coverage, 51412,
     /*   95092 */     GIR_EraseRootFromParent_Done,
     /*   95093 */   // Label 1495: @95093
     /*   95093 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(95182), // Rule ID 51413 //
     /*   95098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95113 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95128 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95132 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95141 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   95158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95180 */     GIR_RootConstrainSelectedInstOperands,
     /*   95181 */     // GIR_Coverage, 51413,
     /*   95181 */     GIR_EraseRootFromParent_Done,
     /*   95182 */   // Label 1496: @95182
     /*   95182 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(95271), // Rule ID 51652 //
     /*   95187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95202 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95221 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95230 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95269 */     GIR_RootConstrainSelectedInstOperands,
     /*   95270 */     // GIR_Coverage, 51652,
     /*   95270 */     GIR_EraseRootFromParent_Done,
     /*   95271 */   // Label 1497: @95271
     /*   95271 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(95360), // Rule ID 51653 //
     /*   95276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95291 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95310 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95319 */     // (mul:{ *:[nxv8i32] } (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95358 */     GIR_RootConstrainSelectedInstOperands,
     /*   95359 */     // GIR_Coverage, 51653,
     /*   95359 */     GIR_EraseRootFromParent_Done,
     /*   95360 */   // Label 1498: @95360
     /*   95360 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(95449), // Rule ID 51592 //
     /*   95365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95380 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95399 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95408 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95447 */     GIR_RootConstrainSelectedInstOperands,
     /*   95448 */     // GIR_Coverage, 51592,
     /*   95448 */     GIR_EraseRootFromParent_Done,
     /*   95449 */   // Label 1499: @95449
     /*   95449 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(95538), // Rule ID 51593 //
     /*   95454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95469 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   95484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95488 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95497 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95536 */     GIR_RootConstrainSelectedInstOperands,
     /*   95537 */     // GIR_Coverage, 51593,
     /*   95537 */     GIR_EraseRootFromParent_Done,
     /*   95538 */   // Label 1500: @95538
     /*   95538 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(95627), // Rule ID 70167 //
     /*   95543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95554 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95558 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95577 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95579 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95586 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95625 */     GIR_RootConstrainSelectedInstOperands,
     /*   95626 */     // GIR_Coverage, 70167,
     /*   95626 */     GIR_EraseRootFromParent_Done,
     /*   95627 */   // Label 1501: @95627
     /*   95627 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(95716), // Rule ID 70168 //
     /*   95632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95647 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   95662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95666 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95668 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95675 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   95692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   95701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   95705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95714 */     GIR_RootConstrainSelectedInstOperands,
     /*   95715 */     // GIR_Coverage, 70168,
     /*   95715 */     GIR_EraseRootFromParent_Done,
     /*   95716 */   // Label 1502: @95716
     /*   95716 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(95805), // Rule ID 51472 //
     /*   95721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95736 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95755 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95757 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95764 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   95764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95803 */     GIR_RootConstrainSelectedInstOperands,
     /*   95804 */     // GIR_Coverage, 51472,
     /*   95804 */     GIR_EraseRootFromParent_Done,
     /*   95805 */   // Label 1503: @95805
     /*   95805 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(95894), // Rule ID 51473 //
     /*   95810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   95817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95825 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   95827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   95836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   95840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*   95844 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   95846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   95851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   95853 */     // (mul:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   95853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   95870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   95879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   95883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   95889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95892 */     GIR_RootConstrainSelectedInstOperands,
     /*   95893 */     // GIR_Coverage, 51473,
     /*   95893 */     GIR_EraseRootFromParent_Done,
     /*   95894 */   // Label 1504: @95894
     /*   95894 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(95947), // Rule ID 50798 //
     /*   95899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   95902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95910 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   95910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   95927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95945 */     GIR_RootConstrainSelectedInstOperands,
     /*   95946 */     // GIR_Coverage, 50798,
     /*   95946 */     GIR_EraseRootFromParent_Done,
     /*   95947 */   // Label 1505: @95947
     /*   95947 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(96000), // Rule ID 50799 //
     /*   95952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   95955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   95963 */     // (mul:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   95963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*   95966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   95970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   95975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   95977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   95980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   95982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   95985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   95987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   95989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   95992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   95995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   95998 */     GIR_RootConstrainSelectedInstOperands,
     /*   95999 */     // GIR_Coverage, 50799,
     /*   95999 */     GIR_EraseRootFromParent_Done,
     /*   96000 */   // Label 1506: @96000
     /*   96000 */   GIM_Reject,
     /*   96001 */ // Label 1486: @96001
     /*   96001 */ GIM_Reject,
     /*   96002 */ // Label 1251: @96002
     /*   96002 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(97726),
     /*   96007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*   96010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*   96013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   96017 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(96106), // Rule ID 51552 //
     /*   96022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96037 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96056 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96065 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   96082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96104 */     GIR_RootConstrainSelectedInstOperands,
     /*   96105 */     // GIR_Coverage, 51552,
     /*   96105 */     GIR_EraseRootFromParent_Done,
     /*   96106 */   // Label 1508: @96106
     /*   96106 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(96195), // Rule ID 51553 //
     /*   96111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96126 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96145 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96154 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   96171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96193 */     GIR_RootConstrainSelectedInstOperands,
     /*   96194 */     // GIR_Coverage, 51553,
     /*   96194 */     GIR_EraseRootFromParent_Done,
     /*   96195 */   // Label 1509: @96195
     /*   96195 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(96284), // Rule ID 70247 //
     /*   96200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96215 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96234 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96236 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96241 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96243 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   96260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96282 */     GIR_RootConstrainSelectedInstOperands,
     /*   96283 */     // GIR_Coverage, 70247,
     /*   96283 */     GIR_EraseRootFromParent_Done,
     /*   96284 */   // Label 1510: @96284
     /*   96284 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(96373), // Rule ID 70248 //
     /*   96289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96304 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96323 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96332 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   96349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96371 */     GIR_RootConstrainSelectedInstOperands,
     /*   96372 */     // GIR_Coverage, 70248,
     /*   96372 */     GIR_EraseRootFromParent_Done,
     /*   96373 */   // Label 1511: @96373
     /*   96373 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(96462), // Rule ID 70127 //
     /*   96378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96393 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96412 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96421 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   96438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96460 */     GIR_RootConstrainSelectedInstOperands,
     /*   96461 */     // GIR_Coverage, 70127,
     /*   96461 */     GIR_EraseRootFromParent_Done,
     /*   96462 */   // Label 1512: @96462
     /*   96462 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(96551), // Rule ID 70128 //
     /*   96467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96482 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96501 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96510 */     // (mul:{ *:[nxv8i64] } (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   96527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   96536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   96540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96549 */     GIR_RootConstrainSelectedInstOperands,
     /*   96550 */     // GIR_Coverage, 70128,
     /*   96550 */     GIR_EraseRootFromParent_Done,
     /*   96551 */   // Label 1513: @96551
     /*   96551 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(96640), // Rule ID 51732 //
     /*   96556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96571 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96590 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96592 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96599 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   96616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96638 */     GIR_RootConstrainSelectedInstOperands,
     /*   96639 */     // GIR_Coverage, 51732,
     /*   96639 */     GIR_EraseRootFromParent_Done,
     /*   96640 */   // Label 1514: @96640
     /*   96640 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(96729), // Rule ID 51733 //
     /*   96645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96660 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   96675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96679 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96688 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   96705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96727 */     GIR_RootConstrainSelectedInstOperands,
     /*   96728 */     // GIR_Coverage, 51733,
     /*   96728 */     GIR_EraseRootFromParent_Done,
     /*   96729 */   // Label 1515: @96729
     /*   96729 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(96818), // Rule ID 51432 //
     /*   96734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96749 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96756 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96760 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96764 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96768 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96775 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96777 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*   96794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96816 */     GIR_RootConstrainSelectedInstOperands,
     /*   96817 */     // GIR_Coverage, 51432,
     /*   96817 */     GIR_EraseRootFromParent_Done,
     /*   96818 */   // Label 1516: @96818
     /*   96818 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(96907), // Rule ID 51433 //
     /*   96823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   96826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96838 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96857 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96866 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   96866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*   96883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96905 */     GIR_RootConstrainSelectedInstOperands,
     /*   96906 */     // GIR_Coverage, 51433,
     /*   96906 */     GIR_EraseRootFromParent_Done,
     /*   96907 */   // Label 1517: @96907
     /*   96907 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(96996), // Rule ID 51672 //
     /*   96912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   96915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   96919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   96923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96927 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   96929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   96938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   96942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   96946 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   96948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   96953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   96955 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   96955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   96958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   96962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   96967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   96969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   96972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   96974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   96977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   96981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   96985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   96988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   96991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   96994 */     GIR_RootConstrainSelectedInstOperands,
     /*   96995 */     // GIR_Coverage, 51672,
     /*   96995 */     GIR_EraseRootFromParent_Done,
     /*   96996 */   // Label 1518: @96996
     /*   96996 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(97085), // Rule ID 51673 //
     /*   97001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   97004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97016 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97035 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97044 */     // (mul:{ *:[nxv8i64] } (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   97044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   97061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97083 */     GIR_RootConstrainSelectedInstOperands,
     /*   97084 */     // GIR_Coverage, 51673,
     /*   97084 */     GIR_EraseRootFromParent_Done,
     /*   97085 */   // Label 1519: @97085
     /*   97085 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(97174), // Rule ID 51612 //
     /*   97090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   97093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97105 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97124 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97126 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97133 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   97133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   97150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97172 */     GIR_RootConstrainSelectedInstOperands,
     /*   97173 */     // GIR_Coverage, 51612,
     /*   97173 */     GIR_EraseRootFromParent_Done,
     /*   97174 */   // Label 1520: @97174
     /*   97174 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(97263), // Rule ID 51613 //
     /*   97179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   97182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97194 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97213 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97222 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   97222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   97239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97261 */     GIR_RootConstrainSelectedInstOperands,
     /*   97262 */     // GIR_Coverage, 51613,
     /*   97262 */     GIR_EraseRootFromParent_Done,
     /*   97263 */   // Label 1521: @97263
     /*   97263 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(97352), // Rule ID 70187 //
     /*   97268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   97271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97283 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97302 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97311 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   97311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   97328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97350 */     GIR_RootConstrainSelectedInstOperands,
     /*   97351 */     // GIR_Coverage, 70187,
     /*   97351 */     GIR_EraseRootFromParent_Done,
     /*   97352 */   // Label 1522: @97352
     /*   97352 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(97441), // Rule ID 70188 //
     /*   97357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   97360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97372 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   97387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97391 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97393 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97400 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   97400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   97417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   97426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   97430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97439 */     GIR_RootConstrainSelectedInstOperands,
     /*   97440 */     // GIR_Coverage, 70188,
     /*   97440 */     GIR_EraseRootFromParent_Done,
     /*   97441 */   // Label 1523: @97441
     /*   97441 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(97530), // Rule ID 51492 //
     /*   97446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*   97449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97461 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97480 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97489 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*   97489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   97506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97528 */     GIR_RootConstrainSelectedInstOperands,
     /*   97529 */     // GIR_Coverage, 51492,
     /*   97529 */     GIR_EraseRootFromParent_Done,
     /*   97530 */   // Label 1524: @97530
     /*   97530 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(97619), // Rule ID 51493 //
     /*   97535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*   97538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97550 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   97565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*   97569 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97578 */     // (mul:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*   97578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   97595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*   97614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97617 */     GIR_RootConstrainSelectedInstOperands,
     /*   97618 */     // GIR_Coverage, 51493,
     /*   97618 */     GIR_EraseRootFromParent_Done,
     /*   97619 */   // Label 1525: @97619
     /*   97619 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(97672), // Rule ID 50814 //
     /*   97624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*   97627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   97631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   97635 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*   97635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   97652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   97667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97670 */     GIR_RootConstrainSelectedInstOperands,
     /*   97671 */     // GIR_Coverage, 50814,
     /*   97671 */     GIR_EraseRootFromParent_Done,
     /*   97672 */   // Label 1526: @97672
     /*   97672 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(97725), // Rule ID 50815 //
     /*   97677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*   97680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   97684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   97688 */     // (mul:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*   97688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*   97691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*   97705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97710 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*   97720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97723 */     GIR_RootConstrainSelectedInstOperands,
     /*   97724 */     // GIR_Coverage, 50815,
     /*   97724 */     GIR_EraseRootFromParent_Done,
     /*   97725 */   // Label 1527: @97725
     /*   97725 */   GIM_Reject,
     /*   97726 */ // Label 1507: @97726
     /*   97726 */ GIM_Reject,
     /*   97727 */ // Label 1252: @97727
     /*   97727 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(97841),
     /*   97732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   97735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*   97738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97750 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(97795), // Rule ID 50770 //
     /*   97755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97758 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   97761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   97775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97793 */     GIR_RootConstrainSelectedInstOperands,
     /*   97794 */     // GIR_Coverage, 50770,
     /*   97794 */     GIR_EraseRootFromParent_Done,
     /*   97795 */   // Label 1529: @97795
     /*   97795 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(97840), // Rule ID 50771 //
     /*   97800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97803 */     // (mul:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*   97806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97815 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*   97820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   97827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   97829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97838 */     GIR_RootConstrainSelectedInstOperands,
     /*   97839 */     // GIR_Coverage, 50771,
     /*   97839 */     GIR_EraseRootFromParent_Done,
     /*   97840 */   // Label 1530: @97840
     /*   97840 */   GIM_Reject,
     /*   97841 */ // Label 1528: @97841
     /*   97841 */ GIM_Reject,
     /*   97842 */ // Label 1253: @97842
     /*   97842 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(99566),
     /*   97847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   97850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*   97853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   97857 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(97946), // Rule ID 51512 //
     /*   97862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   97865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   97877 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   97896 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97905 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   97905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   97908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   97912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   97917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   97919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   97922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   97924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   97927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   97931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   97935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   97938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   97944 */     GIR_RootConstrainSelectedInstOperands,
     /*   97945 */     // GIR_Coverage, 51512,
     /*   97945 */     GIR_EraseRootFromParent_Done,
     /*   97946 */   // Label 1532: @97946
     /*   97946 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(98035), // Rule ID 51513 //
     /*   97951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   97954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   97958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   97966 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   97968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   97977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   97981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   97985 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   97987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   97992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   97994 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   97994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   97997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98033 */     GIR_RootConstrainSelectedInstOperands,
     /*   98034 */     // GIR_Coverage, 51513,
     /*   98034 */     GIR_EraseRootFromParent_Done,
     /*   98035 */   // Label 1533: @98035
     /*   98035 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98124), // Rule ID 70207 //
     /*   98040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98055 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98074 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98081 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98083 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98122 */     GIR_RootConstrainSelectedInstOperands,
     /*   98123 */     // GIR_Coverage, 70207,
     /*   98123 */     GIR_EraseRootFromParent_Done,
     /*   98124 */   // Label 1534: @98124
     /*   98124 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98213), // Rule ID 70208 //
     /*   98129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98144 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98163 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98165 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98172 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98211 */     GIR_RootConstrainSelectedInstOperands,
     /*   98212 */     // GIR_Coverage, 70208,
     /*   98212 */     GIR_EraseRootFromParent_Done,
     /*   98213 */   // Label 1535: @98213
     /*   98213 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98302), // Rule ID 70087 //
     /*   98218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98233 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98252 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98261 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98300 */     GIR_RootConstrainSelectedInstOperands,
     /*   98301 */     // GIR_Coverage, 70087,
     /*   98301 */     GIR_EraseRootFromParent_Done,
     /*   98302 */   // Label 1536: @98302
     /*   98302 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98391), // Rule ID 70088 //
     /*   98307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98322 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98341 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98350 */     // (mul:{ *:[nxv16i16] } (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   98376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   98380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98389 */     GIR_RootConstrainSelectedInstOperands,
     /*   98390 */     // GIR_Coverage, 70088,
     /*   98390 */     GIR_EraseRootFromParent_Done,
     /*   98391 */   // Label 1537: @98391
     /*   98391 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(98480), // Rule ID 51692 //
     /*   98396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98411 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98430 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98439 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98478 */     GIR_RootConstrainSelectedInstOperands,
     /*   98479 */     // GIR_Coverage, 51692,
     /*   98479 */     GIR_EraseRootFromParent_Done,
     /*   98480 */   // Label 1538: @98480
     /*   98480 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(98569), // Rule ID 51693 //
     /*   98485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98500 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98519 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98528 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98567 */     GIR_RootConstrainSelectedInstOperands,
     /*   98568 */     // GIR_Coverage, 51693,
     /*   98568 */     GIR_EraseRootFromParent_Done,
     /*   98569 */   // Label 1539: @98569
     /*   98569 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(98658), // Rule ID 51392 //
     /*   98574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98589 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98591 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98608 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98617 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   98634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98656 */     GIR_RootConstrainSelectedInstOperands,
     /*   98657 */     // GIR_Coverage, 51392,
     /*   98657 */     GIR_EraseRootFromParent_Done,
     /*   98658 */   // Label 1540: @98658
     /*   98658 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(98747), // Rule ID 51393 //
     /*   98663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98678 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98685 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98689 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98693 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98697 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98706 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*   98723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98745 */     GIR_RootConstrainSelectedInstOperands,
     /*   98746 */     // GIR_Coverage, 51393,
     /*   98746 */     GIR_EraseRootFromParent_Done,
     /*   98747 */   // Label 1541: @98747
     /*   98747 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(98836), // Rule ID 51632 //
     /*   98752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98767 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98786 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98795 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98834 */     GIR_RootConstrainSelectedInstOperands,
     /*   98835 */     // GIR_Coverage, 51632,
     /*   98835 */     GIR_EraseRootFromParent_Done,
     /*   98836 */   // Label 1542: @98836
     /*   98836 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(98925), // Rule ID 51633 //
     /*   98841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   98844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   98852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98856 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98863 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98867 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98871 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98875 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98884 */     // (mul:{ *:[nxv16i16] } (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   98884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   98901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   98914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   98917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   98923 */     GIR_RootConstrainSelectedInstOperands,
     /*   98924 */     // GIR_Coverage, 51633,
     /*   98924 */     GIR_EraseRootFromParent_Done,
     /*   98925 */   // Label 1543: @98925
     /*   98925 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99014), // Rule ID 51572 //
     /*   98930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   98933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   98937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   98941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98945 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   98947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   98956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   98960 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   98964 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   98966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   98971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   98973 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   98973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   98976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   98980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   98985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   98987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   98990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   98992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   98995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   98999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99012 */     GIR_RootConstrainSelectedInstOperands,
     /*   99013 */     // GIR_Coverage, 51572,
     /*   99013 */     GIR_EraseRootFromParent_Done,
     /*   99014 */   // Label 1544: @99014
     /*   99014 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99103), // Rule ID 51573 //
     /*   99019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99034 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99053 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99062 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   99062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99101 */     GIR_RootConstrainSelectedInstOperands,
     /*   99102 */     // GIR_Coverage, 51573,
     /*   99102 */     GIR_EraseRootFromParent_Done,
     /*   99103 */   // Label 1545: @99103
     /*   99103 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99192), // Rule ID 70147 //
     /*   99108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99123 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99142 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99151 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   99151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99190 */     GIR_RootConstrainSelectedInstOperands,
     /*   99191 */     // GIR_Coverage, 70147,
     /*   99191 */     GIR_EraseRootFromParent_Done,
     /*   99192 */   // Label 1546: @99192
     /*   99192 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99281), // Rule ID 70148 //
     /*   99197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99212 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99231 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99233 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99240 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   99240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*   99257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99279 */     GIR_RootConstrainSelectedInstOperands,
     /*   99280 */     // GIR_Coverage, 70148,
     /*   99280 */     GIR_EraseRootFromParent_Done,
     /*   99281 */   // Label 1547: @99281
     /*   99281 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(99370), // Rule ID 51452 //
     /*   99286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99301 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99320 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99322 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99329 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*   99329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99368 */     GIR_RootConstrainSelectedInstOperands,
     /*   99369 */     // GIR_Coverage, 51452,
     /*   99369 */     GIR_EraseRootFromParent_Done,
     /*   99370 */   // Label 1548: @99370
     /*   99370 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(99459), // Rule ID 51453 //
     /*   99375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99390 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*   99409 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*   99416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99418 */     // (mul:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*   99418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*   99435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99457 */     GIR_RootConstrainSelectedInstOperands,
     /*   99458 */     // GIR_Coverage, 51453,
     /*   99458 */     GIR_EraseRootFromParent_Done,
     /*   99459 */   // Label 1549: @99459
     /*   99459 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(99512), // Rule ID 50786 //
     /*   99464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99475 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   99492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   99499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   99501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99510 */     GIR_RootConstrainSelectedInstOperands,
     /*   99511 */     // GIR_Coverage, 50786,
     /*   99511 */     GIR_EraseRootFromParent_Done,
     /*   99512 */   // Label 1550: @99512
     /*   99512 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(99565), // Rule ID 50787 //
     /*   99517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99528 */     // (mul:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*   99531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*   99545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*   99552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*   99554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99563 */     GIR_RootConstrainSelectedInstOperands,
     /*   99564 */     // GIR_Coverage, 50787,
     /*   99564 */     GIR_EraseRootFromParent_Done,
     /*   99565 */   // Label 1551: @99565
     /*   99565 */   GIM_Reject,
     /*   99566 */ // Label 1531: @99566
     /*   99566 */ GIM_Reject,
     /*   99567 */ // Label 1254: @99567
     /*   99567 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(101291),
     /*   99572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*   99575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*   99578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*   99582 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(99671), // Rule ID 51536 //
     /*   99587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99602 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99621 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99630 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   99633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   99647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99669 */     GIR_RootConstrainSelectedInstOperands,
     /*   99670 */     // GIR_Coverage, 51536,
     /*   99670 */     GIR_EraseRootFromParent_Done,
     /*   99671 */   // Label 1553: @99671
     /*   99671 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(99760), // Rule ID 51537 //
     /*   99676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99691 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99710 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99719 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   99722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*   99736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*   99745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*   99749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99758 */     GIR_RootConstrainSelectedInstOperands,
     /*   99759 */     // GIR_Coverage, 51537,
     /*   99759 */     GIR_EraseRootFromParent_Done,
     /*   99760 */   // Label 1554: @99760
     /*   99760 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(99849), // Rule ID 70231 //
     /*   99765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99780 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99799 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99808 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   99811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   99825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99847 */     GIR_RootConstrainSelectedInstOperands,
     /*   99848 */     // GIR_Coverage, 70231,
     /*   99848 */     GIR_EraseRootFromParent_Done,
     /*   99849 */   // Label 1555: @99849
     /*   99849 */   GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(99938), // Rule ID 70232 //
     /*   99854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*   99857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99869 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   99884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99888 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99897 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*   99897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   99900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   99911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*   99914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*   99916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   99919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*   99923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*   99927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*   99930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*   99933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   99936 */     GIR_RootConstrainSelectedInstOperands,
     /*   99937 */     // GIR_Coverage, 70232,
     /*   99937 */     GIR_EraseRootFromParent_Done,
     /*   99938 */   // Label 1556: @99938
     /*   99938 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100027), // Rule ID 70111 //
     /*   99943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*   99946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   99950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   99954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99958 */     GIM_CheckHasOneUse, /*MI*/1,
     /*   99960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   99969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   99973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*   99977 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   99979 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*   99984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   99986 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*   99986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*   99989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   99993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   99998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100025 */     GIR_RootConstrainSelectedInstOperands,
     /*  100026 */     // GIR_Coverage, 70111,
     /*  100026 */     GIR_EraseRootFromParent_Done,
     /*  100027 */   // Label 1557: @100027
     /*  100027 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(100116), // Rule ID 70112 //
     /*  100032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100047 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100062 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100066 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100075 */     // (mul:{ *:[nxv16i32] } (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100114 */     GIR_RootConstrainSelectedInstOperands,
     /*  100115 */     // GIR_Coverage, 70112,
     /*  100115 */     GIR_EraseRootFromParent_Done,
     /*  100116 */   // Label 1558: @100116
     /*  100116 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(100205), // Rule ID 51716 //
     /*  100121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100136 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100155 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100164 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100203 */     GIR_RootConstrainSelectedInstOperands,
     /*  100204 */     // GIR_Coverage, 51716,
     /*  100204 */     GIR_EraseRootFromParent_Done,
     /*  100205 */   // Label 1559: @100205
     /*  100205 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(100294), // Rule ID 51717 //
     /*  100210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100225 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100240 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100244 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100251 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100253 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100292 */     GIR_RootConstrainSelectedInstOperands,
     /*  100293 */     // GIR_Coverage, 51717,
     /*  100293 */     GIR_EraseRootFromParent_Done,
     /*  100294 */   // Label 1560: @100294
     /*  100294 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(100383), // Rule ID 51416 //
     /*  100299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100314 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100333 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100342 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100381 */     GIR_RootConstrainSelectedInstOperands,
     /*  100382 */     // GIR_Coverage, 51416,
     /*  100382 */     GIR_EraseRootFromParent_Done,
     /*  100383 */   // Label 1561: @100383
     /*  100383 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(100472), // Rule ID 51417 //
     /*  100388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100403 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100410 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100414 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100418 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100431 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  100448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100470 */     GIR_RootConstrainSelectedInstOperands,
     /*  100471 */     // GIR_Coverage, 51417,
     /*  100471 */     GIR_EraseRootFromParent_Done,
     /*  100472 */   // Label 1562: @100472
     /*  100472 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(100561), // Rule ID 51656 //
     /*  100477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100492 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100511 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100520 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100559 */     GIR_RootConstrainSelectedInstOperands,
     /*  100560 */     // GIR_Coverage, 51656,
     /*  100560 */     GIR_EraseRootFromParent_Done,
     /*  100561 */   // Label 1563: @100561
     /*  100561 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(100650), // Rule ID 51657 //
     /*  100566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100581 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100600 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100609 */     // (mul:{ *:[nxv16i32] } (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100648 */     GIR_RootConstrainSelectedInstOperands,
     /*  100649 */     // GIR_Coverage, 51657,
     /*  100649 */     GIR_EraseRootFromParent_Done,
     /*  100650 */   // Label 1564: @100650
     /*  100650 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(100739), // Rule ID 51596 //
     /*  100655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100689 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100698 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100720 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100737 */     GIR_RootConstrainSelectedInstOperands,
     /*  100738 */     // GIR_Coverage, 51596,
     /*  100738 */     GIR_EraseRootFromParent_Done,
     /*  100739 */   // Label 1565: @100739
     /*  100739 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(100828), // Rule ID 51597 //
     /*  100744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100759 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  100774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100778 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100780 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100787 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100787 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100790 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100794 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  100804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  100813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  100817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100826 */     GIR_RootConstrainSelectedInstOperands,
     /*  100827 */     // GIR_Coverage, 51597,
     /*  100827 */     GIR_EraseRootFromParent_Done,
     /*  100828 */   // Label 1566: @100828
     /*  100828 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(100917), // Rule ID 70171 //
     /*  100833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  100836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100848 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100867 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100876 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  100876 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100879 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100883 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  100912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  100915 */     GIR_RootConstrainSelectedInstOperands,
     /*  100916 */     // GIR_Coverage, 70171,
     /*  100916 */     GIR_EraseRootFromParent_Done,
     /*  100917 */   // Label 1567: @100917
     /*  100917 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(101006), // Rule ID 70172 //
     /*  100922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  100925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  100929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  100933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100937 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  100939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  100948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  100952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  100956 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  100958 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  100963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  100965 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  100965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  100968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  100972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  100977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  100979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  100982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  100984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  100987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  100991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  100995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  100998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  101001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101004 */     GIR_RootConstrainSelectedInstOperands,
     /*  101005 */     // GIR_Coverage, 70172,
     /*  101005 */     GIR_EraseRootFromParent_Done,
     /*  101006 */   // Label 1568: @101006
     /*  101006 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(101095), // Rule ID 51476 //
     /*  101011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101026 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101045 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101047 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101054 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  101054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  101057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  101090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101093 */     GIR_RootConstrainSelectedInstOperands,
     /*  101094 */     // GIR_Coverage, 51476,
     /*  101094 */     GIR_EraseRootFromParent_Done,
     /*  101095 */   // Label 1569: @101095
     /*  101095 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(101184), // Rule ID 51477 //
     /*  101100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101115 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  101134 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101143 */     // (mul:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  101143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  101146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  101179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101182 */     GIR_RootConstrainSelectedInstOperands,
     /*  101183 */     // GIR_Coverage, 51477,
     /*  101183 */     GIR_EraseRootFromParent_Done,
     /*  101184 */   // Label 1570: @101184
     /*  101184 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(101237), // Rule ID 50802 //
     /*  101189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101200 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  101200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  101203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101235 */     GIR_RootConstrainSelectedInstOperands,
     /*  101236 */     // GIR_Coverage, 50802,
     /*  101236 */     GIR_EraseRootFromParent_Done,
     /*  101237 */   // Label 1571: @101237
     /*  101237 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(101290), // Rule ID 50803 //
     /*  101242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101253 */     // (mul:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  101253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  101256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  101270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  101285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101288 */     GIR_RootConstrainSelectedInstOperands,
     /*  101289 */     // GIR_Coverage, 50803,
     /*  101289 */     GIR_EraseRootFromParent_Done,
     /*  101290 */   // Label 1572: @101290
     /*  101290 */   GIM_Reject,
     /*  101291 */ // Label 1552: @101291
     /*  101291 */ GIM_Reject,
     /*  101292 */ // Label 1255: @101292
     /*  101292 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(101406),
     /*  101297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  101303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101315 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(101360), // Rule ID 50774 //
     /*  101320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101323 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  101326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  101340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101358 */     GIR_RootConstrainSelectedInstOperands,
     /*  101359 */     // GIR_Coverage, 50774,
     /*  101359 */     GIR_EraseRootFromParent_Done,
     /*  101360 */   // Label 1574: @101360
     /*  101360 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(101405), // Rule ID 50775 //
     /*  101365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101368 */     // (mul:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  101371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  101385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  101392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  101394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101403 */     GIR_RootConstrainSelectedInstOperands,
     /*  101404 */     // GIR_Coverage, 50775,
     /*  101404 */     GIR_EraseRootFromParent_Done,
     /*  101405 */   // Label 1575: @101405
     /*  101405 */   GIM_Reject,
     /*  101406 */ // Label 1573: @101406
     /*  101406 */ GIM_Reject,
     /*  101407 */ // Label 1256: @101407
     /*  101407 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(103131),
     /*  101412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  101415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  101418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  101422 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(101511), // Rule ID 51516 //
     /*  101427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101442 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101461 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101470 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101509 */     GIR_RootConstrainSelectedInstOperands,
     /*  101510 */     // GIR_Coverage, 51516,
     /*  101510 */     GIR_EraseRootFromParent_Done,
     /*  101511 */   // Label 1577: @101511
     /*  101511 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(101600), // Rule ID 51517 //
     /*  101516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101531 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101550 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101559 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_anyext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  101585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  101589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101598 */     GIR_RootConstrainSelectedInstOperands,
     /*  101599 */     // GIR_Coverage, 51517,
     /*  101599 */     GIR_EraseRootFromParent_Done,
     /*  101600 */   // Label 1578: @101600
     /*  101600 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(101689), // Rule ID 70211 //
     /*  101605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101620 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101639 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101641 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101648 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101687 */     GIR_RootConstrainSelectedInstOperands,
     /*  101688 */     // GIR_Coverage, 70211,
     /*  101688 */     GIR_EraseRootFromParent_Done,
     /*  101689 */   // Label 1579: @101689
     /*  101689 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(101778), // Rule ID 70212 //
     /*  101694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101709 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101728 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101735 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101737 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  101754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101776 */     GIR_RootConstrainSelectedInstOperands,
     /*  101777 */     // GIR_Coverage, 70212,
     /*  101777 */     GIR_EraseRootFromParent_Done,
     /*  101778 */   // Label 1580: @101778
     /*  101778 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(101867), // Rule ID 70091 //
     /*  101783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101798 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101817 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101826 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  101826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101865 */     GIR_RootConstrainSelectedInstOperands,
     /*  101866 */     // GIR_Coverage, 70091,
     /*  101866 */     GIR_EraseRootFromParent_Done,
     /*  101867 */   // Label 1581: @101867
     /*  101867 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(101956), // Rule ID 70092 //
     /*  101872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  101875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101887 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  101902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101906 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101913 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  101915 */     // (mul:{ *:[nxv32i16] } (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  101915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  101918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  101922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  101927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  101929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  101932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  101934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  101937 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  101941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  101945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  101948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  101954 */     GIR_RootConstrainSelectedInstOperands,
     /*  101955 */     // GIR_Coverage, 70092,
     /*  101955 */     GIR_EraseRootFromParent_Done,
     /*  101956 */   // Label 1582: @101956
     /*  101956 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(102045), // Rule ID 51696 //
     /*  101961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  101964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  101968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  101972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101976 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  101978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  101983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  101987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  101991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  101995 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  101997 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102002 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102004 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102043 */     GIR_RootConstrainSelectedInstOperands,
     /*  102044 */     // GIR_Coverage, 51696,
     /*  102044 */     GIR_EraseRootFromParent_Done,
     /*  102045 */   // Label 1583: @102045
     /*  102045 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(102134), // Rule ID 51697 //
     /*  102050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102065 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102084 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102091 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102093 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102132 */     GIR_RootConstrainSelectedInstOperands,
     /*  102133 */     // GIR_Coverage, 51697,
     /*  102133 */     GIR_EraseRootFromParent_Done,
     /*  102134 */   // Label 1584: @102134
     /*  102134 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(102223), // Rule ID 51396 //
     /*  102139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102150 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102173 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102175 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102182 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  102199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102221 */     GIR_RootConstrainSelectedInstOperands,
     /*  102222 */     // GIR_Coverage, 51396,
     /*  102222 */     GIR_EraseRootFromParent_Done,
     /*  102223 */   // Label 1585: @102223
     /*  102223 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(102312), // Rule ID 51397 //
     /*  102228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102243 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102262 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102271 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  102288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102310 */     GIR_RootConstrainSelectedInstOperands,
     /*  102311 */     // GIR_Coverage, 51397,
     /*  102311 */     GIR_EraseRootFromParent_Done,
     /*  102312 */   // Label 1586: @102312
     /*  102312 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(102401), // Rule ID 51636 //
     /*  102317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102332 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102351 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102353 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102360 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102399 */     GIR_RootConstrainSelectedInstOperands,
     /*  102400 */     // GIR_Coverage, 51636,
     /*  102400 */     GIR_EraseRootFromParent_Done,
     /*  102401 */   // Label 1587: @102401
     /*  102401 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(102490), // Rule ID 51637 //
     /*  102406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102421 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102423 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102440 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102442 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102449 */     // (mul:{ *:[nxv32i16] } (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102488 */     GIR_RootConstrainSelectedInstOperands,
     /*  102489 */     // GIR_Coverage, 51637,
     /*  102489 */     GIR_EraseRootFromParent_Done,
     /*  102490 */   // Label 1588: @102490
     /*  102490 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(102579), // Rule ID 51576 //
     /*  102495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102510 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102529 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102538 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102577 */     GIR_RootConstrainSelectedInstOperands,
     /*  102578 */     // GIR_Coverage, 51576,
     /*  102578 */     GIR_EraseRootFromParent_Done,
     /*  102579 */   // Label 1589: @102579
     /*  102579 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(102668), // Rule ID 51577 //
     /*  102584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102599 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  102614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102618 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102620 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102627 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_anyext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102666 */     GIR_RootConstrainSelectedInstOperands,
     /*  102667 */     // GIR_Coverage, 51577,
     /*  102667 */     GIR_EraseRootFromParent_Done,
     /*  102668 */   // Label 1590: @102668
     /*  102668 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(102757), // Rule ID 70151 //
     /*  102673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102688 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102707 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102709 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102716 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102755 */     GIR_RootConstrainSelectedInstOperands,
     /*  102756 */     // GIR_Coverage, 70151,
     /*  102756 */     GIR_EraseRootFromParent_Done,
     /*  102757 */   // Label 1591: @102757
     /*  102757 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(102846), // Rule ID 70152 //
     /*  102762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102777 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  102792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102796 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102805 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_sext_oneuse>>)  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  102822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  102831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  102835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102844 */     GIR_RootConstrainSelectedInstOperands,
     /*  102845 */     // GIR_Coverage, 70152,
     /*  102845 */     GIR_EraseRootFromParent_Done,
     /*  102846 */   // Label 1592: @102846
     /*  102846 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(102935), // Rule ID 51456 //
     /*  102851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  102854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102866 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102885 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102894 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  102894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  102911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  102913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  102916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  102920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  102924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  102927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  102933 */     GIR_RootConstrainSelectedInstOperands,
     /*  102934 */     // GIR_Coverage, 51456,
     /*  102934 */     GIR_EraseRootFromParent_Done,
     /*  102935 */   // Label 1593: @102935
     /*  102935 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(103024), // Rule ID 51457 //
     /*  102940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  102943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  102947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102955 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  102957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  102966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  102970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  102974 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  102976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  102981 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  102983 */     // (mul:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_zext_oneuse>>)  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  102983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  102986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  102990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  102995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  102997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  103000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  103009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  103013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103022 */     GIR_RootConstrainSelectedInstOperands,
     /*  103023 */     // GIR_Coverage, 51457,
     /*  103023 */     GIR_EraseRootFromParent_Done,
     /*  103024 */   // Label 1594: @103024
     /*  103024 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(103077), // Rule ID 50790 //
     /*  103029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103040 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  103043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  103057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103075 */     GIR_RootConstrainSelectedInstOperands,
     /*  103076 */     // GIR_Coverage, 50790,
     /*  103076 */     GIR_EraseRootFromParent_Done,
     /*  103077 */   // Label 1595: @103077
     /*  103077 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(103130), // Rule ID 50791 //
     /*  103082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103093 */     // (mul:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  103096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  103110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103128 */     GIR_RootConstrainSelectedInstOperands,
     /*  103129 */     // GIR_Coverage, 50791,
     /*  103129 */     GIR_EraseRootFromParent_Done,
     /*  103130 */   // Label 1596: @103130
     /*  103130 */   GIM_Reject,
     /*  103131 */ // Label 1576: @103131
     /*  103131 */ GIM_Reject,
     /*  103132 */ // Label 1257: @103132
     /*  103132 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(103246),
     /*  103137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  103140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  103143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  103155 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(103200), // Rule ID 50778 //
     /*  103160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103163 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  103166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  103180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103198 */     GIR_RootConstrainSelectedInstOperands,
     /*  103199 */     // GIR_Coverage, 50778,
     /*  103199 */     GIR_EraseRootFromParent_Done,
     /*  103200 */   // Label 1598: @103200
     /*  103200 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(103245), // Rule ID 50779 //
     /*  103205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103208 */     // (mul:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  103211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  103225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103243 */     GIR_RootConstrainSelectedInstOperands,
     /*  103244 */     // GIR_Coverage, 50779,
     /*  103244 */     GIR_EraseRootFromParent_Done,
     /*  103245 */   // Label 1599: @103245
     /*  103245 */   GIM_Reject,
     /*  103246 */ // Label 1597: @103246
     /*  103246 */ GIM_Reject,
     /*  103247 */ // Label 1258: @103247
     /*  103247 */ GIM_Reject,
     /*  103248 */ // Label 3: @103248
     /*  103248 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1624*/ GIMT_Encode4(105981),
     /*  103259 */ /*GILLT_s32*//*Label 1600*/ GIMT_Encode4(103383),
     /*  103263 */ /*GILLT_s64*//*Label 1601*/ GIMT_Encode4(103417), GIMT_Encode4(0),
     /*  103271 */ /*GILLT_nxv1s8*//*Label 1602*/ GIMT_Encode4(103451),
     /*  103275 */ /*GILLT_nxv1s16*//*Label 1603*/ GIMT_Encode4(103566),
     /*  103279 */ /*GILLT_nxv1s32*//*Label 1604*/ GIMT_Encode4(103681),
     /*  103283 */ /*GILLT_nxv1s64*//*Label 1605*/ GIMT_Encode4(103796), GIMT_Encode4(0),
     /*  103291 */ /*GILLT_nxv2s8*//*Label 1606*/ GIMT_Encode4(103911),
     /*  103295 */ /*GILLT_nxv2s16*//*Label 1607*/ GIMT_Encode4(104026),
     /*  103299 */ /*GILLT_nxv2s32*//*Label 1608*/ GIMT_Encode4(104141),
     /*  103303 */ /*GILLT_nxv2s64*//*Label 1609*/ GIMT_Encode4(104256), GIMT_Encode4(0),
     /*  103311 */ /*GILLT_nxv4s8*//*Label 1610*/ GIMT_Encode4(104371),
     /*  103315 */ /*GILLT_nxv4s16*//*Label 1611*/ GIMT_Encode4(104486),
     /*  103319 */ /*GILLT_nxv4s32*//*Label 1612*/ GIMT_Encode4(104601),
     /*  103323 */ /*GILLT_nxv4s64*//*Label 1613*/ GIMT_Encode4(104716), GIMT_Encode4(0),
     /*  103331 */ /*GILLT_nxv8s8*//*Label 1614*/ GIMT_Encode4(104831),
     /*  103335 */ /*GILLT_nxv8s16*//*Label 1615*/ GIMT_Encode4(104946),
     /*  103339 */ /*GILLT_nxv8s32*//*Label 1616*/ GIMT_Encode4(105061),
     /*  103343 */ /*GILLT_nxv8s64*//*Label 1617*/ GIMT_Encode4(105176), GIMT_Encode4(0),
     /*  103351 */ /*GILLT_nxv16s8*//*Label 1618*/ GIMT_Encode4(105291),
     /*  103355 */ /*GILLT_nxv16s16*//*Label 1619*/ GIMT_Encode4(105406),
     /*  103359 */ /*GILLT_nxv16s32*//*Label 1620*/ GIMT_Encode4(105521), GIMT_Encode4(0),
     /*  103367 */ /*GILLT_nxv32s8*//*Label 1621*/ GIMT_Encode4(105636),
     /*  103371 */ /*GILLT_nxv32s16*//*Label 1622*/ GIMT_Encode4(105751), GIMT_Encode4(0),
     /*  103379 */ /*GILLT_nxv64s8*//*Label 1623*/ GIMT_Encode4(105866),
     /*  103383 */ // Label 1600: @103383
     /*  103383 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(103416), // Rule ID 298 //
     /*  103388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  103391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  103394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  103397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103409 */   // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  103409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  103414 */   GIR_RootConstrainSelectedInstOperands,
     /*  103415 */   // GIR_Coverage, 298,
     /*  103415 */   GIR_Done,
     /*  103416 */ // Label 1625: @103416
     /*  103416 */ GIM_Reject,
     /*  103417 */ // Label 1601: @103417
     /*  103417 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(103450), // Rule ID 297 //
     /*  103422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  103425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  103428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  103431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  103443 */   // (sdiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  103443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIV),
     /*  103448 */   GIR_RootConstrainSelectedInstOperands,
     /*  103449 */   // GIR_Coverage, 297,
     /*  103449 */   GIR_Done,
     /*  103450 */ // Label 1626: @103450
     /*  103450 */ GIM_Reject,
     /*  103451 */ // Label 1602: @103451
     /*  103451 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(103565),
     /*  103456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  103459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  103462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103470 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103474 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(103519), // Rule ID 51082 //
     /*  103479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103482 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  103485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  103499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103517 */     GIR_RootConstrainSelectedInstOperands,
     /*  103518 */     // GIR_Coverage, 51082,
     /*  103518 */     GIR_EraseRootFromParent_Done,
     /*  103519 */   // Label 1628: @103519
     /*  103519 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(103564), // Rule ID 51083 //
     /*  103524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103527 */     // (sdiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  103530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  103544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103562 */     GIR_RootConstrainSelectedInstOperands,
     /*  103563 */     // GIR_Coverage, 51083,
     /*  103563 */     GIR_EraseRootFromParent_Done,
     /*  103564 */   // Label 1629: @103564
     /*  103564 */   GIM_Reject,
     /*  103565 */ // Label 1627: @103565
     /*  103565 */ GIM_Reject,
     /*  103566 */ // Label 1603: @103566
     /*  103566 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(103680),
     /*  103571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  103574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  103577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103585 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103589 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(103634), // Rule ID 51094 //
     /*  103594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103597 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  103597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  103600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  103614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103632 */     GIR_RootConstrainSelectedInstOperands,
     /*  103633 */     // GIR_Coverage, 51094,
     /*  103633 */     GIR_EraseRootFromParent_Done,
     /*  103634 */   // Label 1631: @103634
     /*  103634 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(103679), // Rule ID 51095 //
     /*  103639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103642 */     // (sdiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  103642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  103645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  103659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  103674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103677 */     GIR_RootConstrainSelectedInstOperands,
     /*  103678 */     // GIR_Coverage, 51095,
     /*  103678 */     GIR_EraseRootFromParent_Done,
     /*  103679 */   // Label 1632: @103679
     /*  103679 */   GIM_Reject,
     /*  103680 */ // Label 1630: @103680
     /*  103680 */ GIM_Reject,
     /*  103681 */ // Label 1604: @103681
     /*  103681 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(103795),
     /*  103686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  103689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  103692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103704 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(103749), // Rule ID 51102 //
     /*  103709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103712 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  103712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  103715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  103729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  103744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103747 */     GIR_RootConstrainSelectedInstOperands,
     /*  103748 */     // GIR_Coverage, 51102,
     /*  103748 */     GIR_EraseRootFromParent_Done,
     /*  103749 */   // Label 1634: @103749
     /*  103749 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(103794), // Rule ID 51103 //
     /*  103754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103757 */     // (sdiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  103757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  103760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  103774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  103789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103792 */     GIR_RootConstrainSelectedInstOperands,
     /*  103793 */     // GIR_Coverage, 51103,
     /*  103793 */     GIR_EraseRootFromParent_Done,
     /*  103794 */   // Label 1635: @103794
     /*  103794 */   GIM_Reject,
     /*  103795 */ // Label 1633: @103795
     /*  103795 */ GIM_Reject,
     /*  103796 */ // Label 1605: @103796
     /*  103796 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(103910),
     /*  103801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  103804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  103807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103819 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(103864), // Rule ID 51118 //
     /*  103824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  103827 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  103827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  103830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  103844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  103859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103862 */     GIR_RootConstrainSelectedInstOperands,
     /*  103863 */     // GIR_Coverage, 51118,
     /*  103863 */     GIR_EraseRootFromParent_Done,
     /*  103864 */   // Label 1637: @103864
     /*  103864 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(103909), // Rule ID 51119 //
     /*  103869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  103872 */     // (sdiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  103872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  103875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  103889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  103904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103907 */     GIR_RootConstrainSelectedInstOperands,
     /*  103908 */     // GIR_Coverage, 51119,
     /*  103908 */     GIR_EraseRootFromParent_Done,
     /*  103909 */   // Label 1638: @103909
     /*  103909 */   GIM_Reject,
     /*  103910 */ // Label 1636: @103910
     /*  103910 */ GIM_Reject,
     /*  103911 */ // Label 1606: @103911
     /*  103911 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(104025),
     /*  103916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  103919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  103922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  103934 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(103979), // Rule ID 51086 //
     /*  103939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  103942 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  103942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  103945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  103956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  103959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  103961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  103964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  103966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  103968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  103971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  103977 */     GIR_RootConstrainSelectedInstOperands,
     /*  103978 */     // GIR_Coverage, 51086,
     /*  103978 */     GIR_EraseRootFromParent_Done,
     /*  103979 */   // Label 1640: @103979
     /*  103979 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(104024), // Rule ID 51087 //
     /*  103984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  103987 */     // (sdiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  103987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  103990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  103994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  103999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  104004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104022 */     GIR_RootConstrainSelectedInstOperands,
     /*  104023 */     // GIR_Coverage, 51087,
     /*  104023 */     GIR_EraseRootFromParent_Done,
     /*  104024 */   // Label 1641: @104024
     /*  104024 */   GIM_Reject,
     /*  104025 */ // Label 1639: @104025
     /*  104025 */ GIM_Reject,
     /*  104026 */ // Label 1607: @104026
     /*  104026 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(104140),
     /*  104031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  104034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  104037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104049 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(104094), // Rule ID 51098 //
     /*  104054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104057 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  104060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  104074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104092 */     GIR_RootConstrainSelectedInstOperands,
     /*  104093 */     // GIR_Coverage, 51098,
     /*  104093 */     GIR_EraseRootFromParent_Done,
     /*  104094 */   // Label 1643: @104094
     /*  104094 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(104139), // Rule ID 51099 //
     /*  104099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104102 */     // (sdiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  104105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  104119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104137 */     GIR_RootConstrainSelectedInstOperands,
     /*  104138 */     // GIR_Coverage, 51099,
     /*  104138 */     GIR_EraseRootFromParent_Done,
     /*  104139 */   // Label 1644: @104139
     /*  104139 */   GIM_Reject,
     /*  104140 */ // Label 1642: @104140
     /*  104140 */ GIM_Reject,
     /*  104141 */ // Label 1608: @104141
     /*  104141 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(104255),
     /*  104146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  104149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  104152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104164 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(104209), // Rule ID 51114 //
     /*  104169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104172 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  104172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  104175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  104189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  104204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104207 */     GIR_RootConstrainSelectedInstOperands,
     /*  104208 */     // GIR_Coverage, 51114,
     /*  104208 */     GIR_EraseRootFromParent_Done,
     /*  104209 */   // Label 1646: @104209
     /*  104209 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(104254), // Rule ID 51115 //
     /*  104214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104217 */     // (sdiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  104217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  104220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  104234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  104249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104252 */     GIR_RootConstrainSelectedInstOperands,
     /*  104253 */     // GIR_Coverage, 51115,
     /*  104253 */     GIR_EraseRootFromParent_Done,
     /*  104254 */   // Label 1647: @104254
     /*  104254 */   GIM_Reject,
     /*  104255 */ // Label 1645: @104255
     /*  104255 */ GIM_Reject,
     /*  104256 */ // Label 1609: @104256
     /*  104256 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(104370),
     /*  104261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  104264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  104267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104279 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(104324), // Rule ID 51158 //
     /*  104284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  104287 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  104287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  104290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  104304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  104319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104322 */     GIR_RootConstrainSelectedInstOperands,
     /*  104323 */     // GIR_Coverage, 51158,
     /*  104323 */     GIR_EraseRootFromParent_Done,
     /*  104324 */   // Label 1649: @104324
     /*  104324 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(104369), // Rule ID 51159 //
     /*  104329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  104332 */     // (sdiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  104332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  104335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  104349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  104364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104367 */     GIR_RootConstrainSelectedInstOperands,
     /*  104368 */     // GIR_Coverage, 51159,
     /*  104368 */     GIR_EraseRootFromParent_Done,
     /*  104369 */   // Label 1650: @104369
     /*  104369 */   GIM_Reject,
     /*  104370 */ // Label 1648: @104370
     /*  104370 */ GIM_Reject,
     /*  104371 */ // Label 1610: @104371
     /*  104371 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(104485),
     /*  104376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  104379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  104382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104394 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(104439), // Rule ID 51090 //
     /*  104399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104402 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  104402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  104405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  104419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104437 */     GIR_RootConstrainSelectedInstOperands,
     /*  104438 */     // GIR_Coverage, 51090,
     /*  104438 */     GIR_EraseRootFromParent_Done,
     /*  104439 */   // Label 1652: @104439
     /*  104439 */   GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(104484), // Rule ID 51091 //
     /*  104444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104447 */     // (sdiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  104447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  104450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  104464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104482 */     GIR_RootConstrainSelectedInstOperands,
     /*  104483 */     // GIR_Coverage, 51091,
     /*  104483 */     GIR_EraseRootFromParent_Done,
     /*  104484 */   // Label 1653: @104484
     /*  104484 */   GIM_Reject,
     /*  104485 */ // Label 1651: @104485
     /*  104485 */ GIM_Reject,
     /*  104486 */ // Label 1611: @104486
     /*  104486 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(104600),
     /*  104491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  104494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  104497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104509 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(104554), // Rule ID 51110 //
     /*  104514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104517 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  104520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  104534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104552 */     GIR_RootConstrainSelectedInstOperands,
     /*  104553 */     // GIR_Coverage, 51110,
     /*  104553 */     GIR_EraseRootFromParent_Done,
     /*  104554 */   // Label 1655: @104554
     /*  104554 */   GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(104599), // Rule ID 51111 //
     /*  104559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104562 */     // (sdiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  104562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  104565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  104579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  104594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104597 */     GIR_RootConstrainSelectedInstOperands,
     /*  104598 */     // GIR_Coverage, 51111,
     /*  104598 */     GIR_EraseRootFromParent_Done,
     /*  104599 */   // Label 1656: @104599
     /*  104599 */   GIM_Reject,
     /*  104600 */ // Label 1654: @104600
     /*  104600 */ GIM_Reject,
     /*  104601 */ // Label 1612: @104601
     /*  104601 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(104715),
     /*  104606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  104609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  104612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104624 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(104669), // Rule ID 51146 //
     /*  104629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104632 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  104632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  104635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  104649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  104664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104667 */     GIR_RootConstrainSelectedInstOperands,
     /*  104668 */     // GIR_Coverage, 51146,
     /*  104668 */     GIR_EraseRootFromParent_Done,
     /*  104669 */   // Label 1658: @104669
     /*  104669 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(104714), // Rule ID 51147 //
     /*  104674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104677 */     // (sdiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  104677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  104680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  104694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  104709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104712 */     GIR_RootConstrainSelectedInstOperands,
     /*  104713 */     // GIR_Coverage, 51147,
     /*  104713 */     GIR_EraseRootFromParent_Done,
     /*  104714 */   // Label 1659: @104714
     /*  104714 */   GIM_Reject,
     /*  104715 */ // Label 1657: @104715
     /*  104715 */ GIM_Reject,
     /*  104716 */ // Label 1613: @104716
     /*  104716 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(104830),
     /*  104721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  104724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  104727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  104739 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(104784), // Rule ID 51162 //
     /*  104744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  104747 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  104747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  104750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  104764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  104779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104782 */     GIR_RootConstrainSelectedInstOperands,
     /*  104783 */     // GIR_Coverage, 51162,
     /*  104783 */     GIR_EraseRootFromParent_Done,
     /*  104784 */   // Label 1661: @104784
     /*  104784 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(104829), // Rule ID 51163 //
     /*  104789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  104792 */     // (sdiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  104792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  104795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  104809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  104824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104827 */     GIR_RootConstrainSelectedInstOperands,
     /*  104828 */     // GIR_Coverage, 51163,
     /*  104828 */     GIR_EraseRootFromParent_Done,
     /*  104829 */   // Label 1662: @104829
     /*  104829 */   GIM_Reject,
     /*  104830 */ // Label 1660: @104830
     /*  104830 */ GIM_Reject,
     /*  104831 */ // Label 1614: @104831
     /*  104831 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(104945),
     /*  104836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  104839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  104842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  104854 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(104899), // Rule ID 51106 //
     /*  104859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104862 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  104862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  104865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  104879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104897 */     GIR_RootConstrainSelectedInstOperands,
     /*  104898 */     // GIR_Coverage, 51106,
     /*  104898 */     GIR_EraseRootFromParent_Done,
     /*  104899 */   // Label 1664: @104899
     /*  104899 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(104944), // Rule ID 51107 //
     /*  104904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  104907 */     // (sdiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  104907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  104910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  104924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  104931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  104933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  104936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  104942 */     GIR_RootConstrainSelectedInstOperands,
     /*  104943 */     // GIR_Coverage, 51107,
     /*  104943 */     GIR_EraseRootFromParent_Done,
     /*  104944 */   // Label 1665: @104944
     /*  104944 */   GIM_Reject,
     /*  104945 */ // Label 1663: @104945
     /*  104945 */ GIM_Reject,
     /*  104946 */ // Label 1615: @104946
     /*  104946 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(105060),
     /*  104951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  104954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  104957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  104969 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(105014), // Rule ID 51134 //
     /*  104974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  104977 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  104977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  104980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  104984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  104989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  104991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  104994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  104996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  104999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105012 */     GIR_RootConstrainSelectedInstOperands,
     /*  105013 */     // GIR_Coverage, 51134,
     /*  105013 */     GIR_EraseRootFromParent_Done,
     /*  105014 */   // Label 1667: @105014
     /*  105014 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(105059), // Rule ID 51135 //
     /*  105019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105022 */     // (sdiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  105025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  105039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105057 */     GIR_RootConstrainSelectedInstOperands,
     /*  105058 */     // GIR_Coverage, 51135,
     /*  105058 */     GIR_EraseRootFromParent_Done,
     /*  105059 */   // Label 1668: @105059
     /*  105059 */   GIM_Reject,
     /*  105060 */ // Label 1666: @105060
     /*  105060 */ GIM_Reject,
     /*  105061 */ // Label 1616: @105061
     /*  105061 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(105175),
     /*  105066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  105069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  105072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105084 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(105129), // Rule ID 51150 //
     /*  105089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105092 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  105095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  105109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105127 */     GIR_RootConstrainSelectedInstOperands,
     /*  105128 */     // GIR_Coverage, 51150,
     /*  105128 */     GIR_EraseRootFromParent_Done,
     /*  105129 */   // Label 1670: @105129
     /*  105129 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(105174), // Rule ID 51151 //
     /*  105134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105137 */     // (sdiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  105140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  105154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105172 */     GIR_RootConstrainSelectedInstOperands,
     /*  105173 */     // GIR_Coverage, 51151,
     /*  105173 */     GIR_EraseRootFromParent_Done,
     /*  105174 */   // Label 1671: @105174
     /*  105174 */   GIM_Reject,
     /*  105175 */ // Label 1669: @105175
     /*  105175 */ GIM_Reject,
     /*  105176 */ // Label 1617: @105176
     /*  105176 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(105290),
     /*  105181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  105184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  105187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105199 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(105244), // Rule ID 51166 //
     /*  105204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  105207 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  105207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  105210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  105224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  105239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105242 */     GIR_RootConstrainSelectedInstOperands,
     /*  105243 */     // GIR_Coverage, 51166,
     /*  105243 */     GIR_EraseRootFromParent_Done,
     /*  105244 */   // Label 1673: @105244
     /*  105244 */   GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(105289), // Rule ID 51167 //
     /*  105249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  105252 */     // (sdiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  105252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  105255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  105269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  105284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105287 */     GIR_RootConstrainSelectedInstOperands,
     /*  105288 */     // GIR_Coverage, 51167,
     /*  105288 */     GIR_EraseRootFromParent_Done,
     /*  105289 */   // Label 1674: @105289
     /*  105289 */   GIM_Reject,
     /*  105290 */ // Label 1672: @105290
     /*  105290 */ GIM_Reject,
     /*  105291 */ // Label 1618: @105291
     /*  105291 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(105405),
     /*  105296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  105299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  105302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  105306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  105310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  105314 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(105359), // Rule ID 51122 //
     /*  105319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105322 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  105325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  105339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105357 */     GIR_RootConstrainSelectedInstOperands,
     /*  105358 */     // GIR_Coverage, 51122,
     /*  105358 */     GIR_EraseRootFromParent_Done,
     /*  105359 */   // Label 1676: @105359
     /*  105359 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(105404), // Rule ID 51123 //
     /*  105364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105367 */     // (sdiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  105370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  105384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105402 */     GIR_RootConstrainSelectedInstOperands,
     /*  105403 */     // GIR_Coverage, 51123,
     /*  105403 */     GIR_EraseRootFromParent_Done,
     /*  105404 */   // Label 1677: @105404
     /*  105404 */   GIM_Reject,
     /*  105405 */ // Label 1675: @105405
     /*  105405 */ GIM_Reject,
     /*  105406 */ // Label 1619: @105406
     /*  105406 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(105520),
     /*  105411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  105414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  105417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105429 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(105474), // Rule ID 51138 //
     /*  105434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105437 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  105440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  105454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105472 */     GIR_RootConstrainSelectedInstOperands,
     /*  105473 */     // GIR_Coverage, 51138,
     /*  105473 */     GIR_EraseRootFromParent_Done,
     /*  105474 */   // Label 1679: @105474
     /*  105474 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(105519), // Rule ID 51139 //
     /*  105479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105482 */     // (sdiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  105485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  105499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105517 */     GIR_RootConstrainSelectedInstOperands,
     /*  105518 */     // GIR_Coverage, 51139,
     /*  105518 */     GIR_EraseRootFromParent_Done,
     /*  105519 */   // Label 1680: @105519
     /*  105519 */   GIM_Reject,
     /*  105520 */ // Label 1678: @105520
     /*  105520 */ GIM_Reject,
     /*  105521 */ // Label 1620: @105521
     /*  105521 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(105635),
     /*  105526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  105529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  105532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105544 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(105589), // Rule ID 51154 //
     /*  105549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105552 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  105552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  105569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105587 */     GIR_RootConstrainSelectedInstOperands,
     /*  105588 */     // GIR_Coverage, 51154,
     /*  105588 */     GIR_EraseRootFromParent_Done,
     /*  105589 */   // Label 1682: @105589
     /*  105589 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(105634), // Rule ID 51155 //
     /*  105594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105597 */     // (sdiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  105597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  105600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  105614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  105629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105632 */     GIR_RootConstrainSelectedInstOperands,
     /*  105633 */     // GIR_Coverage, 51155,
     /*  105633 */     GIR_EraseRootFromParent_Done,
     /*  105634 */   // Label 1683: @105634
     /*  105634 */   GIM_Reject,
     /*  105635 */ // Label 1681: @105635
     /*  105635 */ GIM_Reject,
     /*  105636 */ // Label 1621: @105636
     /*  105636 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(105750),
     /*  105641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  105644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  105647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  105659 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(105704), // Rule ID 51126 //
     /*  105664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105667 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  105684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105702 */     GIR_RootConstrainSelectedInstOperands,
     /*  105703 */     // GIR_Coverage, 51126,
     /*  105703 */     GIR_EraseRootFromParent_Done,
     /*  105704 */   // Label 1685: @105704
     /*  105704 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(105749), // Rule ID 51127 //
     /*  105709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105712 */     // (sdiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  105715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  105729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105747 */     GIR_RootConstrainSelectedInstOperands,
     /*  105748 */     // GIR_Coverage, 51127,
     /*  105748 */     GIR_EraseRootFromParent_Done,
     /*  105749 */   // Label 1686: @105749
     /*  105749 */   GIM_Reject,
     /*  105750 */ // Label 1684: @105750
     /*  105750 */ GIM_Reject,
     /*  105751 */ // Label 1622: @105751
     /*  105751 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(105865),
     /*  105756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  105759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  105762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105774 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(105819), // Rule ID 51142 //
     /*  105779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105782 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  105782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  105799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105817 */     GIR_RootConstrainSelectedInstOperands,
     /*  105818 */     // GIR_Coverage, 51142,
     /*  105818 */     GIR_EraseRootFromParent_Done,
     /*  105819 */   // Label 1688: @105819
     /*  105819 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(105864), // Rule ID 51143 //
     /*  105824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105827 */     // (sdiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  105827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  105830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  105844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  105859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105862 */     GIR_RootConstrainSelectedInstOperands,
     /*  105863 */     // GIR_Coverage, 51143,
     /*  105863 */     GIR_EraseRootFromParent_Done,
     /*  105864 */   // Label 1689: @105864
     /*  105864 */   GIM_Reject,
     /*  105865 */ // Label 1687: @105865
     /*  105865 */ GIM_Reject,
     /*  105866 */ // Label 1623: @105866
     /*  105866 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(105980),
     /*  105871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  105874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  105877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  105889 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(105934), // Rule ID 51130 //
     /*  105894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  105897 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  105897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  105900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  105914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105932 */     GIR_RootConstrainSelectedInstOperands,
     /*  105933 */     // GIR_Coverage, 51130,
     /*  105933 */     GIR_EraseRootFromParent_Done,
     /*  105934 */   // Label 1691: @105934
     /*  105934 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(105979), // Rule ID 51131 //
     /*  105939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  105942 */     // (sdiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  105942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  105945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  105949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  105954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  105956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  105959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  105961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  105964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  105966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  105968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  105971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  105977 */     GIR_RootConstrainSelectedInstOperands,
     /*  105978 */     // GIR_Coverage, 51131,
     /*  105978 */     GIR_EraseRootFromParent_Done,
     /*  105979 */   // Label 1692: @105979
     /*  105979 */   GIM_Reject,
     /*  105980 */ // Label 1690: @105980
     /*  105980 */ GIM_Reject,
     /*  105981 */ // Label 1624: @105981
     /*  105981 */ GIM_Reject,
     /*  105982 */ // Label 4: @105982
     /*  105982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1717*/ GIMT_Encode4(108715),
     /*  105993 */ /*GILLT_s32*//*Label 1693*/ GIMT_Encode4(106117),
     /*  105997 */ /*GILLT_s64*//*Label 1694*/ GIMT_Encode4(106151), GIMT_Encode4(0),
     /*  106005 */ /*GILLT_nxv1s8*//*Label 1695*/ GIMT_Encode4(106185),
     /*  106009 */ /*GILLT_nxv1s16*//*Label 1696*/ GIMT_Encode4(106300),
     /*  106013 */ /*GILLT_nxv1s32*//*Label 1697*/ GIMT_Encode4(106415),
     /*  106017 */ /*GILLT_nxv1s64*//*Label 1698*/ GIMT_Encode4(106530), GIMT_Encode4(0),
     /*  106025 */ /*GILLT_nxv2s8*//*Label 1699*/ GIMT_Encode4(106645),
     /*  106029 */ /*GILLT_nxv2s16*//*Label 1700*/ GIMT_Encode4(106760),
     /*  106033 */ /*GILLT_nxv2s32*//*Label 1701*/ GIMT_Encode4(106875),
     /*  106037 */ /*GILLT_nxv2s64*//*Label 1702*/ GIMT_Encode4(106990), GIMT_Encode4(0),
     /*  106045 */ /*GILLT_nxv4s8*//*Label 1703*/ GIMT_Encode4(107105),
     /*  106049 */ /*GILLT_nxv4s16*//*Label 1704*/ GIMT_Encode4(107220),
     /*  106053 */ /*GILLT_nxv4s32*//*Label 1705*/ GIMT_Encode4(107335),
     /*  106057 */ /*GILLT_nxv4s64*//*Label 1706*/ GIMT_Encode4(107450), GIMT_Encode4(0),
     /*  106065 */ /*GILLT_nxv8s8*//*Label 1707*/ GIMT_Encode4(107565),
     /*  106069 */ /*GILLT_nxv8s16*//*Label 1708*/ GIMT_Encode4(107680),
     /*  106073 */ /*GILLT_nxv8s32*//*Label 1709*/ GIMT_Encode4(107795),
     /*  106077 */ /*GILLT_nxv8s64*//*Label 1710*/ GIMT_Encode4(107910), GIMT_Encode4(0),
     /*  106085 */ /*GILLT_nxv16s8*//*Label 1711*/ GIMT_Encode4(108025),
     /*  106089 */ /*GILLT_nxv16s16*//*Label 1712*/ GIMT_Encode4(108140),
     /*  106093 */ /*GILLT_nxv16s32*//*Label 1713*/ GIMT_Encode4(108255), GIMT_Encode4(0),
     /*  106101 */ /*GILLT_nxv32s8*//*Label 1714*/ GIMT_Encode4(108370),
     /*  106105 */ /*GILLT_nxv32s16*//*Label 1715*/ GIMT_Encode4(108485), GIMT_Encode4(0),
     /*  106113 */ /*GILLT_nxv64s8*//*Label 1716*/ GIMT_Encode4(108600),
     /*  106117 */ // Label 1693: @106117
     /*  106117 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(106150), // Rule ID 300 //
     /*  106122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  106125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  106128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  106131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106139 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106143 */   // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (DIVU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  106143 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  106148 */   GIR_RootConstrainSelectedInstOperands,
     /*  106149 */   // GIR_Coverage, 300,
     /*  106149 */   GIR_Done,
     /*  106150 */ // Label 1718: @106150
     /*  106150 */ GIM_Reject,
     /*  106151 */ // Label 1694: @106151
     /*  106151 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(106184), // Rule ID 299 //
     /*  106156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  106159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  106162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  106165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  106177 */   // (udiv:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  106177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVU),
     /*  106182 */   GIR_RootConstrainSelectedInstOperands,
     /*  106183 */   // GIR_Coverage, 299,
     /*  106183 */   GIR_Done,
     /*  106184 */ // Label 1719: @106184
     /*  106184 */ GIM_Reject,
     /*  106185 */ // Label 1695: @106185
     /*  106185 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(106299),
     /*  106190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  106193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  106196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106208 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(106253), // Rule ID 50994 //
     /*  106213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106216 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  106219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  106233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106251 */     GIR_RootConstrainSelectedInstOperands,
     /*  106252 */     // GIR_Coverage, 50994,
     /*  106252 */     GIR_EraseRootFromParent_Done,
     /*  106253 */   // Label 1721: @106253
     /*  106253 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(106298), // Rule ID 50995 //
     /*  106258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106261 */     // (udiv:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  106264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  106278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106296 */     GIR_RootConstrainSelectedInstOperands,
     /*  106297 */     // GIR_Coverage, 50995,
     /*  106297 */     GIR_EraseRootFromParent_Done,
     /*  106298 */   // Label 1722: @106298
     /*  106298 */   GIM_Reject,
     /*  106299 */ // Label 1720: @106299
     /*  106299 */ GIM_Reject,
     /*  106300 */ // Label 1696: @106300
     /*  106300 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(106414),
     /*  106305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  106308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  106311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106319 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106323 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(106368), // Rule ID 51006 //
     /*  106328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106331 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  106331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  106334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  106348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  106363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106366 */     GIR_RootConstrainSelectedInstOperands,
     /*  106367 */     // GIR_Coverage, 51006,
     /*  106367 */     GIR_EraseRootFromParent_Done,
     /*  106368 */   // Label 1724: @106368
     /*  106368 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(106413), // Rule ID 51007 //
     /*  106373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106376 */     // (udiv:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  106376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  106379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  106393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  106408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106411 */     GIR_RootConstrainSelectedInstOperands,
     /*  106412 */     // GIR_Coverage, 51007,
     /*  106412 */     GIR_EraseRootFromParent_Done,
     /*  106413 */   // Label 1725: @106413
     /*  106413 */   GIM_Reject,
     /*  106414 */ // Label 1723: @106414
     /*  106414 */ GIM_Reject,
     /*  106415 */ // Label 1697: @106415
     /*  106415 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(106529),
     /*  106420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  106423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  106426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106434 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106438 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(106483), // Rule ID 51014 //
     /*  106443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106446 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  106446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  106449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  106463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  106478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106481 */     GIR_RootConstrainSelectedInstOperands,
     /*  106482 */     // GIR_Coverage, 51014,
     /*  106482 */     GIR_EraseRootFromParent_Done,
     /*  106483 */   // Label 1727: @106483
     /*  106483 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(106528), // Rule ID 51015 //
     /*  106488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106491 */     // (udiv:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  106491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  106494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  106508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  106523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106526 */     GIR_RootConstrainSelectedInstOperands,
     /*  106527 */     // GIR_Coverage, 51015,
     /*  106527 */     GIR_EraseRootFromParent_Done,
     /*  106528 */   // Label 1728: @106528
     /*  106528 */   GIM_Reject,
     /*  106529 */ // Label 1726: @106529
     /*  106529 */ GIM_Reject,
     /*  106530 */ // Label 1698: @106530
     /*  106530 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(106644),
     /*  106535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  106538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  106541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106553 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(106598), // Rule ID 51030 //
     /*  106558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  106561 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  106561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  106564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  106578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  106593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106596 */     GIR_RootConstrainSelectedInstOperands,
     /*  106597 */     // GIR_Coverage, 51030,
     /*  106597 */     GIR_EraseRootFromParent_Done,
     /*  106598 */   // Label 1730: @106598
     /*  106598 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(106643), // Rule ID 51031 //
     /*  106603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  106606 */     // (udiv:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  106606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  106609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  106623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  106638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106641 */     GIR_RootConstrainSelectedInstOperands,
     /*  106642 */     // GIR_Coverage, 51031,
     /*  106642 */     GIR_EraseRootFromParent_Done,
     /*  106643 */   // Label 1731: @106643
     /*  106643 */   GIM_Reject,
     /*  106644 */ // Label 1729: @106644
     /*  106644 */ GIM_Reject,
     /*  106645 */ // Label 1699: @106645
     /*  106645 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(106759),
     /*  106650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  106653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  106656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106668 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(106713), // Rule ID 50998 //
     /*  106673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106676 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  106676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  106679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  106693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106711 */     GIR_RootConstrainSelectedInstOperands,
     /*  106712 */     // GIR_Coverage, 50998,
     /*  106712 */     GIR_EraseRootFromParent_Done,
     /*  106713 */   // Label 1733: @106713
     /*  106713 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(106758), // Rule ID 50999 //
     /*  106718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106721 */     // (udiv:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  106721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  106724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  106738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106756 */     GIR_RootConstrainSelectedInstOperands,
     /*  106757 */     // GIR_Coverage, 50999,
     /*  106757 */     GIR_EraseRootFromParent_Done,
     /*  106758 */   // Label 1734: @106758
     /*  106758 */   GIM_Reject,
     /*  106759 */ // Label 1732: @106759
     /*  106759 */ GIM_Reject,
     /*  106760 */ // Label 1700: @106760
     /*  106760 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(106874),
     /*  106765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  106768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  106771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106783 */   GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(106828), // Rule ID 51010 //
     /*  106788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106791 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  106791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  106794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  106808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  106823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106826 */     GIR_RootConstrainSelectedInstOperands,
     /*  106827 */     // GIR_Coverage, 51010,
     /*  106827 */     GIR_EraseRootFromParent_Done,
     /*  106828 */   // Label 1736: @106828
     /*  106828 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(106873), // Rule ID 51011 //
     /*  106833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106836 */     // (udiv:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  106836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  106839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  106853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  106868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106871 */     GIR_RootConstrainSelectedInstOperands,
     /*  106872 */     // GIR_Coverage, 51011,
     /*  106872 */     GIR_EraseRootFromParent_Done,
     /*  106873 */   // Label 1737: @106873
     /*  106873 */   GIM_Reject,
     /*  106874 */ // Label 1735: @106874
     /*  106874 */ GIM_Reject,
     /*  106875 */ // Label 1701: @106875
     /*  106875 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(106989),
     /*  106880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  106883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  106886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  106898 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(106943), // Rule ID 51026 //
     /*  106903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  106906 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  106906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  106909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  106923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  106938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106941 */     GIR_RootConstrainSelectedInstOperands,
     /*  106942 */     // GIR_Coverage, 51026,
     /*  106942 */     GIR_EraseRootFromParent_Done,
     /*  106943 */   // Label 1739: @106943
     /*  106943 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(106988), // Rule ID 51027 //
     /*  106948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  106951 */     // (udiv:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  106951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  106954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  106958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  106963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  106965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  106968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  106970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  106973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  106975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  106977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  106980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  106983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  106986 */     GIR_RootConstrainSelectedInstOperands,
     /*  106987 */     // GIR_Coverage, 51027,
     /*  106987 */     GIR_EraseRootFromParent_Done,
     /*  106988 */   // Label 1740: @106988
     /*  106988 */   GIM_Reject,
     /*  106989 */ // Label 1738: @106989
     /*  106989 */ GIM_Reject,
     /*  106990 */ // Label 1702: @106990
     /*  106990 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(107104),
     /*  106995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  106998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  107001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107013 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(107058), // Rule ID 51070 //
     /*  107018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107021 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  107024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  107038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107056 */     GIR_RootConstrainSelectedInstOperands,
     /*  107057 */     // GIR_Coverage, 51070,
     /*  107057 */     GIR_EraseRootFromParent_Done,
     /*  107058 */   // Label 1742: @107058
     /*  107058 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(107103), // Rule ID 51071 //
     /*  107063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107066 */     // (udiv:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  107069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  107083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107101 */     GIR_RootConstrainSelectedInstOperands,
     /*  107102 */     // GIR_Coverage, 51071,
     /*  107102 */     GIR_EraseRootFromParent_Done,
     /*  107103 */   // Label 1743: @107103
     /*  107103 */   GIM_Reject,
     /*  107104 */ // Label 1741: @107104
     /*  107104 */ GIM_Reject,
     /*  107105 */ // Label 1703: @107105
     /*  107105 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(107219),
     /*  107110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  107113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  107116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107128 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(107173), // Rule ID 51002 //
     /*  107133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107136 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  107139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  107153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107171 */     GIR_RootConstrainSelectedInstOperands,
     /*  107172 */     // GIR_Coverage, 51002,
     /*  107172 */     GIR_EraseRootFromParent_Done,
     /*  107173 */   // Label 1745: @107173
     /*  107173 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(107218), // Rule ID 51003 //
     /*  107178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107181 */     // (udiv:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  107184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  107198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107200 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107216 */     GIR_RootConstrainSelectedInstOperands,
     /*  107217 */     // GIR_Coverage, 51003,
     /*  107217 */     GIR_EraseRootFromParent_Done,
     /*  107218 */   // Label 1746: @107218
     /*  107218 */   GIM_Reject,
     /*  107219 */ // Label 1744: @107219
     /*  107219 */ GIM_Reject,
     /*  107220 */ // Label 1704: @107220
     /*  107220 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(107334),
     /*  107225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  107228 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  107231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107235 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107243 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(107288), // Rule ID 51022 //
     /*  107248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107251 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  107254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  107268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107286 */     GIR_RootConstrainSelectedInstOperands,
     /*  107287 */     // GIR_Coverage, 51022,
     /*  107287 */     GIR_EraseRootFromParent_Done,
     /*  107288 */   // Label 1748: @107288
     /*  107288 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(107333), // Rule ID 51023 //
     /*  107293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107296 */     // (udiv:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  107299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  107313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107331 */     GIR_RootConstrainSelectedInstOperands,
     /*  107332 */     // GIR_Coverage, 51023,
     /*  107332 */     GIR_EraseRootFromParent_Done,
     /*  107333 */   // Label 1749: @107333
     /*  107333 */   GIM_Reject,
     /*  107334 */ // Label 1747: @107334
     /*  107334 */ GIM_Reject,
     /*  107335 */ // Label 1705: @107335
     /*  107335 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(107449),
     /*  107340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  107343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  107346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107350 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107354 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107358 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(107403), // Rule ID 51058 //
     /*  107363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107366 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  107369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  107383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107401 */     GIR_RootConstrainSelectedInstOperands,
     /*  107402 */     // GIR_Coverage, 51058,
     /*  107402 */     GIR_EraseRootFromParent_Done,
     /*  107403 */   // Label 1751: @107403
     /*  107403 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(107448), // Rule ID 51059 //
     /*  107408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107411 */     // (udiv:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  107414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  107428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107446 */     GIR_RootConstrainSelectedInstOperands,
     /*  107447 */     // GIR_Coverage, 51059,
     /*  107447 */     GIR_EraseRootFromParent_Done,
     /*  107448 */   // Label 1752: @107448
     /*  107448 */   GIM_Reject,
     /*  107449 */ // Label 1750: @107449
     /*  107449 */ GIM_Reject,
     /*  107450 */ // Label 1706: @107450
     /*  107450 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(107564),
     /*  107455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  107458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  107461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107473 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(107518), // Rule ID 51074 //
     /*  107478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107481 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  107484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  107498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107516 */     GIR_RootConstrainSelectedInstOperands,
     /*  107517 */     // GIR_Coverage, 51074,
     /*  107517 */     GIR_EraseRootFromParent_Done,
     /*  107518 */   // Label 1754: @107518
     /*  107518 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(107563), // Rule ID 51075 //
     /*  107523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107526 */     // (udiv:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  107529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  107543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107561 */     GIR_RootConstrainSelectedInstOperands,
     /*  107562 */     // GIR_Coverage, 51075,
     /*  107562 */     GIR_EraseRootFromParent_Done,
     /*  107563 */   // Label 1755: @107563
     /*  107563 */   GIM_Reject,
     /*  107564 */ // Label 1753: @107564
     /*  107564 */ GIM_Reject,
     /*  107565 */ // Label 1707: @107565
     /*  107565 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(107679),
     /*  107570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  107573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  107576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  107588 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(107633), // Rule ID 51018 //
     /*  107593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107596 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  107596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  107599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  107613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107631 */     GIR_RootConstrainSelectedInstOperands,
     /*  107632 */     // GIR_Coverage, 51018,
     /*  107632 */     GIR_EraseRootFromParent_Done,
     /*  107633 */   // Label 1757: @107633
     /*  107633 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(107678), // Rule ID 51019 //
     /*  107638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107641 */     // (udiv:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  107641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  107644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107653 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  107658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107676 */     GIR_RootConstrainSelectedInstOperands,
     /*  107677 */     // GIR_Coverage, 51019,
     /*  107677 */     GIR_EraseRootFromParent_Done,
     /*  107678 */   // Label 1758: @107678
     /*  107678 */   GIM_Reject,
     /*  107679 */ // Label 1756: @107679
     /*  107679 */ GIM_Reject,
     /*  107680 */ // Label 1708: @107680
     /*  107680 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(107794),
     /*  107685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  107688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  107691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  107703 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(107748), // Rule ID 51046 //
     /*  107708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107711 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  107711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  107714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  107728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107746 */     GIR_RootConstrainSelectedInstOperands,
     /*  107747 */     // GIR_Coverage, 51046,
     /*  107747 */     GIR_EraseRootFromParent_Done,
     /*  107748 */   // Label 1760: @107748
     /*  107748 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(107793), // Rule ID 51047 //
     /*  107753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107756 */     // (udiv:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  107756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  107759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  107773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  107788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107791 */     GIR_RootConstrainSelectedInstOperands,
     /*  107792 */     // GIR_Coverage, 51047,
     /*  107792 */     GIR_EraseRootFromParent_Done,
     /*  107793 */   // Label 1761: @107793
     /*  107793 */   GIM_Reject,
     /*  107794 */ // Label 1759: @107794
     /*  107794 */ GIM_Reject,
     /*  107795 */ // Label 1709: @107795
     /*  107795 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(107909),
     /*  107800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  107803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  107806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  107818 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(107863), // Rule ID 51062 //
     /*  107823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  107826 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  107826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  107829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  107843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107861 */     GIR_RootConstrainSelectedInstOperands,
     /*  107862 */     // GIR_Coverage, 51062,
     /*  107862 */     GIR_EraseRootFromParent_Done,
     /*  107863 */   // Label 1763: @107863
     /*  107863 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(107908), // Rule ID 51063 //
     /*  107868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  107871 */     // (udiv:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  107871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  107874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  107888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  107903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107906 */     GIR_RootConstrainSelectedInstOperands,
     /*  107907 */     // GIR_Coverage, 51063,
     /*  107907 */     GIR_EraseRootFromParent_Done,
     /*  107908 */   // Label 1764: @107908
     /*  107908 */   GIM_Reject,
     /*  107909 */ // Label 1762: @107909
     /*  107909 */ GIM_Reject,
     /*  107910 */ // Label 1710: @107910
     /*  107910 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(108024),
     /*  107915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  107918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  107921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  107933 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(107978), // Rule ID 51078 //
     /*  107938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  107941 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  107941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  107944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  107955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  107958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  107960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  107963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  107965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  107967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  107970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  107973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  107976 */     GIR_RootConstrainSelectedInstOperands,
     /*  107977 */     // GIR_Coverage, 51078,
     /*  107977 */     GIR_EraseRootFromParent_Done,
     /*  107978 */   // Label 1766: @107978
     /*  107978 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(108023), // Rule ID 51079 //
     /*  107983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  107986 */     // (udiv:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  107986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  107989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  107993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  107998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  108003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  108018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108021 */     GIR_RootConstrainSelectedInstOperands,
     /*  108022 */     // GIR_Coverage, 51079,
     /*  108022 */     GIR_EraseRootFromParent_Done,
     /*  108023 */   // Label 1767: @108023
     /*  108023 */   GIM_Reject,
     /*  108024 */ // Label 1765: @108024
     /*  108024 */ GIM_Reject,
     /*  108025 */ // Label 1711: @108025
     /*  108025 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(108139),
     /*  108030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  108033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  108036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  108048 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(108093), // Rule ID 51034 //
     /*  108053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108056 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  108059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  108073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108091 */     GIR_RootConstrainSelectedInstOperands,
     /*  108092 */     // GIR_Coverage, 51034,
     /*  108092 */     GIR_EraseRootFromParent_Done,
     /*  108093 */   // Label 1769: @108093
     /*  108093 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(108138), // Rule ID 51035 //
     /*  108098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108101 */     // (udiv:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  108104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  108118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108136 */     GIR_RootConstrainSelectedInstOperands,
     /*  108137 */     // GIR_Coverage, 51035,
     /*  108137 */     GIR_EraseRootFromParent_Done,
     /*  108138 */   // Label 1770: @108138
     /*  108138 */   GIM_Reject,
     /*  108139 */ // Label 1768: @108139
     /*  108139 */ GIM_Reject,
     /*  108140 */ // Label 1712: @108140
     /*  108140 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(108254),
     /*  108145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  108148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  108151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108163 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(108208), // Rule ID 51050 //
     /*  108168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108171 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  108174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  108188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108206 */     GIR_RootConstrainSelectedInstOperands,
     /*  108207 */     // GIR_Coverage, 51050,
     /*  108207 */     GIR_EraseRootFromParent_Done,
     /*  108208 */   // Label 1772: @108208
     /*  108208 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(108253), // Rule ID 51051 //
     /*  108213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108216 */     // (udiv:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  108219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  108233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108251 */     GIR_RootConstrainSelectedInstOperands,
     /*  108252 */     // GIR_Coverage, 51051,
     /*  108252 */     GIR_EraseRootFromParent_Done,
     /*  108253 */   // Label 1773: @108253
     /*  108253 */   GIM_Reject,
     /*  108254 */ // Label 1771: @108254
     /*  108254 */ GIM_Reject,
     /*  108255 */ // Label 1713: @108255
     /*  108255 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(108369),
     /*  108260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  108263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  108266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108278 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(108323), // Rule ID 51066 //
     /*  108283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108286 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  108286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  108289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  108303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108321 */     GIR_RootConstrainSelectedInstOperands,
     /*  108322 */     // GIR_Coverage, 51066,
     /*  108322 */     GIR_EraseRootFromParent_Done,
     /*  108323 */   // Label 1775: @108323
     /*  108323 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(108368), // Rule ID 51067 //
     /*  108328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108331 */     // (udiv:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  108331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  108334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  108348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  108363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108366 */     GIR_RootConstrainSelectedInstOperands,
     /*  108367 */     // GIR_Coverage, 51067,
     /*  108367 */     GIR_EraseRootFromParent_Done,
     /*  108368 */   // Label 1776: @108368
     /*  108368 */   GIM_Reject,
     /*  108369 */ // Label 1774: @108369
     /*  108369 */ GIM_Reject,
     /*  108370 */ // Label 1714: @108370
     /*  108370 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(108484),
     /*  108375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  108378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  108381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  108393 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(108438), // Rule ID 51038 //
     /*  108398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108401 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  108404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  108418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108436 */     GIR_RootConstrainSelectedInstOperands,
     /*  108437 */     // GIR_Coverage, 51038,
     /*  108437 */     GIR_EraseRootFromParent_Done,
     /*  108438 */   // Label 1778: @108438
     /*  108438 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(108483), // Rule ID 51039 //
     /*  108443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108446 */     // (udiv:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  108449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  108463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108468 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108481 */     GIR_RootConstrainSelectedInstOperands,
     /*  108482 */     // GIR_Coverage, 51039,
     /*  108482 */     GIR_EraseRootFromParent_Done,
     /*  108483 */   // Label 1779: @108483
     /*  108483 */   GIM_Reject,
     /*  108484 */ // Label 1777: @108484
     /*  108484 */ GIM_Reject,
     /*  108485 */ // Label 1715: @108485
     /*  108485 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(108599),
     /*  108490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  108493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  108496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108508 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(108553), // Rule ID 51054 //
     /*  108513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108516 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  108516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  108519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  108533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108551 */     GIR_RootConstrainSelectedInstOperands,
     /*  108552 */     // GIR_Coverage, 51054,
     /*  108552 */     GIR_EraseRootFromParent_Done,
     /*  108553 */   // Label 1781: @108553
     /*  108553 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(108598), // Rule ID 51055 //
     /*  108558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108561 */     // (udiv:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  108561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  108564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  108578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  108593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108596 */     GIR_RootConstrainSelectedInstOperands,
     /*  108597 */     // GIR_Coverage, 51055,
     /*  108597 */     GIR_EraseRootFromParent_Done,
     /*  108598 */   // Label 1782: @108598
     /*  108598 */   GIM_Reject,
     /*  108599 */ // Label 1780: @108599
     /*  108599 */ GIM_Reject,
     /*  108600 */ // Label 1716: @108600
     /*  108600 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(108714),
     /*  108605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  108608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  108611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108619 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  108623 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(108668), // Rule ID 51042 //
     /*  108628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108631 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  108634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  108648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108666 */     GIR_RootConstrainSelectedInstOperands,
     /*  108667 */     // GIR_Coverage, 51042,
     /*  108667 */     GIR_EraseRootFromParent_Done,
     /*  108668 */   // Label 1784: @108668
     /*  108668 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(108713), // Rule ID 51043 //
     /*  108673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  108676 */     // (udiv:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  108676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  108679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  108683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  108688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  108690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  108693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  108698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  108700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  108702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  108705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  108711 */     GIR_RootConstrainSelectedInstOperands,
     /*  108712 */     // GIR_Coverage, 51043,
     /*  108712 */     GIR_EraseRootFromParent_Done,
     /*  108713 */   // Label 1785: @108713
     /*  108713 */   GIM_Reject,
     /*  108714 */ // Label 1783: @108714
     /*  108714 */ GIM_Reject,
     /*  108715 */ // Label 1717: @108715
     /*  108715 */ GIM_Reject,
     /*  108716 */ // Label 5: @108716
     /*  108716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1810*/ GIMT_Encode4(111494),
     /*  108727 */ /*GILLT_s32*//*Label 1786*/ GIMT_Encode4(108851),
     /*  108731 */ /*GILLT_s64*//*Label 1787*/ GIMT_Encode4(108885), GIMT_Encode4(0),
     /*  108739 */ /*GILLT_nxv1s8*//*Label 1788*/ GIMT_Encode4(108964),
     /*  108743 */ /*GILLT_nxv1s16*//*Label 1789*/ GIMT_Encode4(109079),
     /*  108747 */ /*GILLT_nxv1s32*//*Label 1790*/ GIMT_Encode4(109194),
     /*  108751 */ /*GILLT_nxv1s64*//*Label 1791*/ GIMT_Encode4(109309), GIMT_Encode4(0),
     /*  108759 */ /*GILLT_nxv2s8*//*Label 1792*/ GIMT_Encode4(109424),
     /*  108763 */ /*GILLT_nxv2s16*//*Label 1793*/ GIMT_Encode4(109539),
     /*  108767 */ /*GILLT_nxv2s32*//*Label 1794*/ GIMT_Encode4(109654),
     /*  108771 */ /*GILLT_nxv2s64*//*Label 1795*/ GIMT_Encode4(109769), GIMT_Encode4(0),
     /*  108779 */ /*GILLT_nxv4s8*//*Label 1796*/ GIMT_Encode4(109884),
     /*  108783 */ /*GILLT_nxv4s16*//*Label 1797*/ GIMT_Encode4(109999),
     /*  108787 */ /*GILLT_nxv4s32*//*Label 1798*/ GIMT_Encode4(110114),
     /*  108791 */ /*GILLT_nxv4s64*//*Label 1799*/ GIMT_Encode4(110229), GIMT_Encode4(0),
     /*  108799 */ /*GILLT_nxv8s8*//*Label 1800*/ GIMT_Encode4(110344),
     /*  108803 */ /*GILLT_nxv8s16*//*Label 1801*/ GIMT_Encode4(110459),
     /*  108807 */ /*GILLT_nxv8s32*//*Label 1802*/ GIMT_Encode4(110574),
     /*  108811 */ /*GILLT_nxv8s64*//*Label 1803*/ GIMT_Encode4(110689), GIMT_Encode4(0),
     /*  108819 */ /*GILLT_nxv16s8*//*Label 1804*/ GIMT_Encode4(110804),
     /*  108823 */ /*GILLT_nxv16s16*//*Label 1805*/ GIMT_Encode4(110919),
     /*  108827 */ /*GILLT_nxv16s32*//*Label 1806*/ GIMT_Encode4(111034), GIMT_Encode4(0),
     /*  108835 */ /*GILLT_nxv32s8*//*Label 1807*/ GIMT_Encode4(111149),
     /*  108839 */ /*GILLT_nxv32s16*//*Label 1808*/ GIMT_Encode4(111264), GIMT_Encode4(0),
     /*  108847 */ /*GILLT_nxv64s8*//*Label 1809*/ GIMT_Encode4(111379),
     /*  108851 */ // Label 1786: @108851
     /*  108851 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(108884), // Rule ID 302 //
     /*  108856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  108859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  108862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  108865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108877 */   // (srem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REM:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  108877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  108882 */   GIR_RootConstrainSelectedInstOperands,
     /*  108883 */   // GIR_Coverage, 302,
     /*  108883 */   GIR_Done,
     /*  108884 */ // Label 1811: @108884
     /*  108884 */ GIM_Reject,
     /*  108885 */ // Label 1787: @108885
     /*  108885 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(108963),
     /*  108890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  108893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  108896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108900 */   GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(108939), // Rule ID 311 //
     /*  108905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /*  108908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /*  108915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_sexti32),
     /*  108922 */     // (srem:{ *:[i64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (REMW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::REMW),
     /*  108925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  108927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  108932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  108937 */     GIR_RootConstrainSelectedInstOperands,
     /*  108938 */     // GIR_Coverage, 311,
     /*  108938 */     GIR_EraseRootFromParent_Done,
     /*  108939 */   // Label 1813: @108939
     /*  108939 */   GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(108962), // Rule ID 301 //
     /*  108944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  108947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  108955 */     // (srem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  108955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REM),
     /*  108960 */     GIR_RootConstrainSelectedInstOperands,
     /*  108961 */     // GIR_Coverage, 301,
     /*  108961 */     GIR_Done,
     /*  108962 */   // Label 1814: @108962
     /*  108962 */   GIM_Reject,
     /*  108963 */ // Label 1812: @108963
     /*  108963 */ GIM_Reject,
     /*  108964 */ // Label 1788: @108964
     /*  108964 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(109078),
     /*  108969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  108972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  108975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  108987 */   GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(109032), // Rule ID 51258 //
     /*  108992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  108995 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  108995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  108998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  109012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109030 */     GIR_RootConstrainSelectedInstOperands,
     /*  109031 */     // GIR_Coverage, 51258,
     /*  109031 */     GIR_EraseRootFromParent_Done,
     /*  109032 */   // Label 1816: @109032
     /*  109032 */   GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(109077), // Rule ID 51259 //
     /*  109037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109040 */     // (srem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  109043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  109057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109075 */     GIR_RootConstrainSelectedInstOperands,
     /*  109076 */     // GIR_Coverage, 51259,
     /*  109076 */     GIR_EraseRootFromParent_Done,
     /*  109077 */   // Label 1817: @109077
     /*  109077 */   GIM_Reject,
     /*  109078 */ // Label 1815: @109078
     /*  109078 */ GIM_Reject,
     /*  109079 */ // Label 1789: @109079
     /*  109079 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(109193),
     /*  109084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  109087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  109090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109102 */   GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(109147), // Rule ID 51270 //
     /*  109107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109110 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  109113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  109127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109145 */     GIR_RootConstrainSelectedInstOperands,
     /*  109146 */     // GIR_Coverage, 51270,
     /*  109146 */     GIR_EraseRootFromParent_Done,
     /*  109147 */   // Label 1819: @109147
     /*  109147 */   GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(109192), // Rule ID 51271 //
     /*  109152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109155 */     // (srem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  109158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  109172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109190 */     GIR_RootConstrainSelectedInstOperands,
     /*  109191 */     // GIR_Coverage, 51271,
     /*  109191 */     GIR_EraseRootFromParent_Done,
     /*  109192 */   // Label 1820: @109192
     /*  109192 */   GIM_Reject,
     /*  109193 */ // Label 1818: @109193
     /*  109193 */ GIM_Reject,
     /*  109194 */ // Label 1790: @109194
     /*  109194 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(109308),
     /*  109199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  109202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  109205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109217 */   GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(109262), // Rule ID 51278 //
     /*  109222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109225 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  109228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  109242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109260 */     GIR_RootConstrainSelectedInstOperands,
     /*  109261 */     // GIR_Coverage, 51278,
     /*  109261 */     GIR_EraseRootFromParent_Done,
     /*  109262 */   // Label 1822: @109262
     /*  109262 */   GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(109307), // Rule ID 51279 //
     /*  109267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109270 */     // (srem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  109273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  109287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109305 */     GIR_RootConstrainSelectedInstOperands,
     /*  109306 */     // GIR_Coverage, 51279,
     /*  109306 */     GIR_EraseRootFromParent_Done,
     /*  109307 */   // Label 1823: @109307
     /*  109307 */   GIM_Reject,
     /*  109308 */ // Label 1821: @109308
     /*  109308 */ GIM_Reject,
     /*  109309 */ // Label 1791: @109309
     /*  109309 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(109423),
     /*  109314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  109317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  109320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109328 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109332 */   GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(109377), // Rule ID 51294 //
     /*  109337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109340 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  109343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  109357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109375 */     GIR_RootConstrainSelectedInstOperands,
     /*  109376 */     // GIR_Coverage, 51294,
     /*  109376 */     GIR_EraseRootFromParent_Done,
     /*  109377 */   // Label 1825: @109377
     /*  109377 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(109422), // Rule ID 51295 //
     /*  109382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109385 */     // (srem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  109388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  109402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109420 */     GIR_RootConstrainSelectedInstOperands,
     /*  109421 */     // GIR_Coverage, 51295,
     /*  109421 */     GIR_EraseRootFromParent_Done,
     /*  109422 */   // Label 1826: @109422
     /*  109422 */   GIM_Reject,
     /*  109423 */ // Label 1824: @109423
     /*  109423 */ GIM_Reject,
     /*  109424 */ // Label 1792: @109424
     /*  109424 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(109538),
     /*  109429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  109432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  109435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109443 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109447 */   GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(109492), // Rule ID 51262 //
     /*  109452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109455 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  109458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  109472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109490 */     GIR_RootConstrainSelectedInstOperands,
     /*  109491 */     // GIR_Coverage, 51262,
     /*  109491 */     GIR_EraseRootFromParent_Done,
     /*  109492 */   // Label 1828: @109492
     /*  109492 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(109537), // Rule ID 51263 //
     /*  109497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109500 */     // (srem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  109503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  109517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109535 */     GIR_RootConstrainSelectedInstOperands,
     /*  109536 */     // GIR_Coverage, 51263,
     /*  109536 */     GIR_EraseRootFromParent_Done,
     /*  109537 */   // Label 1829: @109537
     /*  109537 */   GIM_Reject,
     /*  109538 */ // Label 1827: @109538
     /*  109538 */ GIM_Reject,
     /*  109539 */ // Label 1793: @109539
     /*  109539 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(109653),
     /*  109544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  109547 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  109550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109562 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(109607), // Rule ID 51274 //
     /*  109567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109570 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  109570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  109573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  109587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109605 */     GIR_RootConstrainSelectedInstOperands,
     /*  109606 */     // GIR_Coverage, 51274,
     /*  109606 */     GIR_EraseRootFromParent_Done,
     /*  109607 */   // Label 1831: @109607
     /*  109607 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(109652), // Rule ID 51275 //
     /*  109612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109615 */     // (srem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  109615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  109618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  109632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  109647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109650 */     GIR_RootConstrainSelectedInstOperands,
     /*  109651 */     // GIR_Coverage, 51275,
     /*  109651 */     GIR_EraseRootFromParent_Done,
     /*  109652 */   // Label 1832: @109652
     /*  109652 */   GIM_Reject,
     /*  109653 */ // Label 1830: @109653
     /*  109653 */ GIM_Reject,
     /*  109654 */ // Label 1794: @109654
     /*  109654 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(109768),
     /*  109659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  109662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  109665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109677 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(109722), // Rule ID 51290 //
     /*  109682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109685 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  109685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  109688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  109702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109720 */     GIR_RootConstrainSelectedInstOperands,
     /*  109721 */     // GIR_Coverage, 51290,
     /*  109721 */     GIR_EraseRootFromParent_Done,
     /*  109722 */   // Label 1834: @109722
     /*  109722 */   GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(109767), // Rule ID 51291 //
     /*  109727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109730 */     // (srem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  109730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  109733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109742 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  109747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109749 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109752 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  109762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109765 */     GIR_RootConstrainSelectedInstOperands,
     /*  109766 */     // GIR_Coverage, 51291,
     /*  109766 */     GIR_EraseRootFromParent_Done,
     /*  109767 */   // Label 1835: @109767
     /*  109767 */   GIM_Reject,
     /*  109768 */ // Label 1833: @109768
     /*  109768 */ GIM_Reject,
     /*  109769 */ // Label 1795: @109769
     /*  109769 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(109883),
     /*  109774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  109777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  109780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  109792 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(109837), // Rule ID 51334 //
     /*  109797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  109800 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  109800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  109803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  109817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109835 */     GIR_RootConstrainSelectedInstOperands,
     /*  109836 */     // GIR_Coverage, 51334,
     /*  109836 */     GIR_EraseRootFromParent_Done,
     /*  109837 */   // Label 1837: @109837
     /*  109837 */   GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(109882), // Rule ID 51335 //
     /*  109842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  109845 */     // (srem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  109845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  109848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  109862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  109877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109880 */     GIR_RootConstrainSelectedInstOperands,
     /*  109881 */     // GIR_Coverage, 51335,
     /*  109881 */     GIR_EraseRootFromParent_Done,
     /*  109882 */   // Label 1838: @109882
     /*  109882 */   GIM_Reject,
     /*  109883 */ // Label 1836: @109883
     /*  109883 */ GIM_Reject,
     /*  109884 */ // Label 1796: @109884
     /*  109884 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(109998),
     /*  109889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  109892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  109895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  109907 */   GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(109952), // Rule ID 51266 //
     /*  109912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  109915 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  109915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  109918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  109932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109950 */     GIR_RootConstrainSelectedInstOperands,
     /*  109951 */     // GIR_Coverage, 51266,
     /*  109951 */     GIR_EraseRootFromParent_Done,
     /*  109952 */   // Label 1840: @109952
     /*  109952 */   GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(109997), // Rule ID 51267 //
     /*  109957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  109960 */     // (srem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  109960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  109963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  109967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  109972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  109974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  109977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  109979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  109982 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  109984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  109986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  109989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  109995 */     GIR_RootConstrainSelectedInstOperands,
     /*  109996 */     // GIR_Coverage, 51267,
     /*  109996 */     GIR_EraseRootFromParent_Done,
     /*  109997 */   // Label 1841: @109997
     /*  109997 */   GIM_Reject,
     /*  109998 */ // Label 1839: @109998
     /*  109998 */ GIM_Reject,
     /*  109999 */ // Label 1797: @109999
     /*  109999 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(110113),
     /*  110004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  110007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  110010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110022 */   GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(110067), // Rule ID 51286 //
     /*  110027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110030 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  110033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  110047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110065 */     GIR_RootConstrainSelectedInstOperands,
     /*  110066 */     // GIR_Coverage, 51286,
     /*  110066 */     GIR_EraseRootFromParent_Done,
     /*  110067 */   // Label 1843: @110067
     /*  110067 */   GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(110112), // Rule ID 51287 //
     /*  110072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110075 */     // (srem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  110078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  110092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110110 */     GIR_RootConstrainSelectedInstOperands,
     /*  110111 */     // GIR_Coverage, 51287,
     /*  110111 */     GIR_EraseRootFromParent_Done,
     /*  110112 */   // Label 1844: @110112
     /*  110112 */   GIM_Reject,
     /*  110113 */ // Label 1842: @110113
     /*  110113 */ GIM_Reject,
     /*  110114 */ // Label 1798: @110114
     /*  110114 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(110228),
     /*  110119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  110122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  110125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110137 */   GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(110182), // Rule ID 51322 //
     /*  110142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110145 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  110148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  110162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110180 */     GIR_RootConstrainSelectedInstOperands,
     /*  110181 */     // GIR_Coverage, 51322,
     /*  110181 */     GIR_EraseRootFromParent_Done,
     /*  110182 */   // Label 1846: @110182
     /*  110182 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(110227), // Rule ID 51323 //
     /*  110187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110190 */     // (srem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  110193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  110207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110225 */     GIR_RootConstrainSelectedInstOperands,
     /*  110226 */     // GIR_Coverage, 51323,
     /*  110226 */     GIR_EraseRootFromParent_Done,
     /*  110227 */   // Label 1847: @110227
     /*  110227 */   GIM_Reject,
     /*  110228 */ // Label 1845: @110228
     /*  110228 */ GIM_Reject,
     /*  110229 */ // Label 1799: @110229
     /*  110229 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(110343),
     /*  110234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  110237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  110240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110252 */   GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(110297), // Rule ID 51338 //
     /*  110257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110260 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  110263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  110277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110295 */     GIR_RootConstrainSelectedInstOperands,
     /*  110296 */     // GIR_Coverage, 51338,
     /*  110296 */     GIR_EraseRootFromParent_Done,
     /*  110297 */   // Label 1849: @110297
     /*  110297 */   GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(110342), // Rule ID 51339 //
     /*  110302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110305 */     // (srem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  110308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  110322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110340 */     GIR_RootConstrainSelectedInstOperands,
     /*  110341 */     // GIR_Coverage, 51339,
     /*  110341 */     GIR_EraseRootFromParent_Done,
     /*  110342 */   // Label 1850: @110342
     /*  110342 */   GIM_Reject,
     /*  110343 */ // Label 1848: @110343
     /*  110343 */ GIM_Reject,
     /*  110344 */ // Label 1800: @110344
     /*  110344 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(110458),
     /*  110349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  110352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  110355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  110367 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(110412), // Rule ID 51282 //
     /*  110372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110375 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  110378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  110392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110410 */     GIR_RootConstrainSelectedInstOperands,
     /*  110411 */     // GIR_Coverage, 51282,
     /*  110411 */     GIR_EraseRootFromParent_Done,
     /*  110412 */   // Label 1852: @110412
     /*  110412 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(110457), // Rule ID 51283 //
     /*  110417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110420 */     // (srem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  110423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  110437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110442 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110455 */     GIR_RootConstrainSelectedInstOperands,
     /*  110456 */     // GIR_Coverage, 51283,
     /*  110456 */     GIR_EraseRootFromParent_Done,
     /*  110457 */   // Label 1853: @110457
     /*  110457 */   GIM_Reject,
     /*  110458 */ // Label 1851: @110458
     /*  110458 */ GIM_Reject,
     /*  110459 */ // Label 1801: @110459
     /*  110459 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(110573),
     /*  110464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  110467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  110470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110482 */   GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(110527), // Rule ID 51310 //
     /*  110487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110490 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  110493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  110507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110525 */     GIR_RootConstrainSelectedInstOperands,
     /*  110526 */     // GIR_Coverage, 51310,
     /*  110526 */     GIR_EraseRootFromParent_Done,
     /*  110527 */   // Label 1855: @110527
     /*  110527 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(110572), // Rule ID 51311 //
     /*  110532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110535 */     // (srem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  110538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  110552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110570 */     GIR_RootConstrainSelectedInstOperands,
     /*  110571 */     // GIR_Coverage, 51311,
     /*  110571 */     GIR_EraseRootFromParent_Done,
     /*  110572 */   // Label 1856: @110572
     /*  110572 */   GIM_Reject,
     /*  110573 */ // Label 1854: @110573
     /*  110573 */ GIM_Reject,
     /*  110574 */ // Label 1802: @110574
     /*  110574 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(110688),
     /*  110579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  110582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  110585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110597 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(110642), // Rule ID 51326 //
     /*  110602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110605 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  110605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  110608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  110622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110640 */     GIR_RootConstrainSelectedInstOperands,
     /*  110641 */     // GIR_Coverage, 51326,
     /*  110641 */     GIR_EraseRootFromParent_Done,
     /*  110642 */   // Label 1858: @110642
     /*  110642 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(110687), // Rule ID 51327 //
     /*  110647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110650 */     // (srem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  110650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  110653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  110667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110672 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  110682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110685 */     GIR_RootConstrainSelectedInstOperands,
     /*  110686 */     // GIR_Coverage, 51327,
     /*  110686 */     GIR_EraseRootFromParent_Done,
     /*  110687 */   // Label 1859: @110687
     /*  110687 */   GIM_Reject,
     /*  110688 */ // Label 1857: @110688
     /*  110688 */ GIM_Reject,
     /*  110689 */ // Label 1803: @110689
     /*  110689 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(110803),
     /*  110694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  110697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  110712 */   GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(110757), // Rule ID 51342 //
     /*  110717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  110720 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  110720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  110723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  110737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110755 */     GIR_RootConstrainSelectedInstOperands,
     /*  110756 */     // GIR_Coverage, 51342,
     /*  110756 */     GIR_EraseRootFromParent_Done,
     /*  110757 */   // Label 1861: @110757
     /*  110757 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(110802), // Rule ID 51343 //
     /*  110762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  110765 */     // (srem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  110765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  110768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  110782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  110797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110800 */     GIR_RootConstrainSelectedInstOperands,
     /*  110801 */     // GIR_Coverage, 51343,
     /*  110801 */     GIR_EraseRootFromParent_Done,
     /*  110802 */   // Label 1862: @110802
     /*  110802 */   GIM_Reject,
     /*  110803 */ // Label 1860: @110803
     /*  110803 */ GIM_Reject,
     /*  110804 */ // Label 1804: @110804
     /*  110804 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(110918),
     /*  110809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  110812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  110815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  110827 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(110872), // Rule ID 51298 //
     /*  110832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110835 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  110835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  110838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  110852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110870 */     GIR_RootConstrainSelectedInstOperands,
     /*  110871 */     // GIR_Coverage, 51298,
     /*  110871 */     GIR_EraseRootFromParent_Done,
     /*  110872 */   // Label 1864: @110872
     /*  110872 */   GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(110917), // Rule ID 51299 //
     /*  110877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110880 */     // (srem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  110880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  110883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  110897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110915 */     GIR_RootConstrainSelectedInstOperands,
     /*  110916 */     // GIR_Coverage, 51299,
     /*  110916 */     GIR_EraseRootFromParent_Done,
     /*  110917 */   // Label 1865: @110917
     /*  110917 */   GIM_Reject,
     /*  110918 */ // Label 1863: @110918
     /*  110918 */ GIM_Reject,
     /*  110919 */ // Label 1805: @110919
     /*  110919 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(111033),
     /*  110924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  110927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  110930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  110942 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(110987), // Rule ID 51314 //
     /*  110947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  110950 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  110950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  110957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  110962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  110964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  110967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  110969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  110972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  110974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  110976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  110979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  110982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  110985 */     GIR_RootConstrainSelectedInstOperands,
     /*  110986 */     // GIR_Coverage, 51314,
     /*  110986 */     GIR_EraseRootFromParent_Done,
     /*  110987 */   // Label 1867: @110987
     /*  110987 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(111032), // Rule ID 51315 //
     /*  110992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  110995 */     // (srem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  110995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  110998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  111012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111030 */     GIR_RootConstrainSelectedInstOperands,
     /*  111031 */     // GIR_Coverage, 51315,
     /*  111031 */     GIR_EraseRootFromParent_Done,
     /*  111032 */   // Label 1868: @111032
     /*  111032 */   GIM_Reject,
     /*  111033 */ // Label 1866: @111033
     /*  111033 */ GIM_Reject,
     /*  111034 */ // Label 1806: @111034
     /*  111034 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(111148),
     /*  111039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  111042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  111045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111057 */   GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(111102), // Rule ID 51330 //
     /*  111062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111065 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  111068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  111082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111100 */     GIR_RootConstrainSelectedInstOperands,
     /*  111101 */     // GIR_Coverage, 51330,
     /*  111101 */     GIR_EraseRootFromParent_Done,
     /*  111102 */   // Label 1870: @111102
     /*  111102 */   GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(111147), // Rule ID 51331 //
     /*  111107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111110 */     // (srem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  111110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  111113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  111127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111145 */     GIR_RootConstrainSelectedInstOperands,
     /*  111146 */     // GIR_Coverage, 51331,
     /*  111146 */     GIR_EraseRootFromParent_Done,
     /*  111147 */   // Label 1871: @111147
     /*  111147 */   GIM_Reject,
     /*  111148 */ // Label 1869: @111148
     /*  111148 */ GIM_Reject,
     /*  111149 */ // Label 1807: @111149
     /*  111149 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(111263),
     /*  111154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  111157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  111160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  111172 */   GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(111217), // Rule ID 51302 //
     /*  111177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111180 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  111183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  111197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111215 */     GIR_RootConstrainSelectedInstOperands,
     /*  111216 */     // GIR_Coverage, 51302,
     /*  111216 */     GIR_EraseRootFromParent_Done,
     /*  111217 */   // Label 1873: @111217
     /*  111217 */   GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(111262), // Rule ID 51303 //
     /*  111222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111225 */     // (srem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  111228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  111242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111260 */     GIR_RootConstrainSelectedInstOperands,
     /*  111261 */     // GIR_Coverage, 51303,
     /*  111261 */     GIR_EraseRootFromParent_Done,
     /*  111262 */   // Label 1874: @111262
     /*  111262 */   GIM_Reject,
     /*  111263 */ // Label 1872: @111263
     /*  111263 */ GIM_Reject,
     /*  111264 */ // Label 1808: @111264
     /*  111264 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(111378),
     /*  111269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  111272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  111275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111287 */   GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(111332), // Rule ID 51318 //
     /*  111292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111295 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  111298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  111312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111330 */     GIR_RootConstrainSelectedInstOperands,
     /*  111331 */     // GIR_Coverage, 51318,
     /*  111331 */     GIR_EraseRootFromParent_Done,
     /*  111332 */   // Label 1876: @111332
     /*  111332 */   GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(111377), // Rule ID 51319 //
     /*  111337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111340 */     // (srem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  111343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  111357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111362 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111375 */     GIR_RootConstrainSelectedInstOperands,
     /*  111376 */     // GIR_Coverage, 51319,
     /*  111376 */     GIR_EraseRootFromParent_Done,
     /*  111377 */   // Label 1877: @111377
     /*  111377 */   GIM_Reject,
     /*  111378 */ // Label 1875: @111378
     /*  111378 */ GIM_Reject,
     /*  111379 */ // Label 1809: @111379
     /*  111379 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(111493),
     /*  111384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  111387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  111390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  111402 */   GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(111447), // Rule ID 51306 //
     /*  111407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111410 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  111413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  111427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111445 */     GIR_RootConstrainSelectedInstOperands,
     /*  111446 */     // GIR_Coverage, 51306,
     /*  111446 */     GIR_EraseRootFromParent_Done,
     /*  111447 */   // Label 1879: @111447
     /*  111447 */   GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(111492), // Rule ID 51307 //
     /*  111452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111455 */     // (srem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  111458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  111472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111490 */     GIR_RootConstrainSelectedInstOperands,
     /*  111491 */     // GIR_Coverage, 51307,
     /*  111491 */     GIR_EraseRootFromParent_Done,
     /*  111492 */   // Label 1880: @111492
     /*  111492 */   GIM_Reject,
     /*  111493 */ // Label 1878: @111493
     /*  111493 */ GIM_Reject,
     /*  111494 */ // Label 1810: @111494
     /*  111494 */ GIM_Reject,
     /*  111495 */ // Label 6: @111495
     /*  111495 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 1905*/ GIMT_Encode4(114228),
     /*  111506 */ /*GILLT_s32*//*Label 1881*/ GIMT_Encode4(111630),
     /*  111510 */ /*GILLT_s64*//*Label 1882*/ GIMT_Encode4(111664), GIMT_Encode4(0),
     /*  111518 */ /*GILLT_nxv1s8*//*Label 1883*/ GIMT_Encode4(111698),
     /*  111522 */ /*GILLT_nxv1s16*//*Label 1884*/ GIMT_Encode4(111813),
     /*  111526 */ /*GILLT_nxv1s32*//*Label 1885*/ GIMT_Encode4(111928),
     /*  111530 */ /*GILLT_nxv1s64*//*Label 1886*/ GIMT_Encode4(112043), GIMT_Encode4(0),
     /*  111538 */ /*GILLT_nxv2s8*//*Label 1887*/ GIMT_Encode4(112158),
     /*  111542 */ /*GILLT_nxv2s16*//*Label 1888*/ GIMT_Encode4(112273),
     /*  111546 */ /*GILLT_nxv2s32*//*Label 1889*/ GIMT_Encode4(112388),
     /*  111550 */ /*GILLT_nxv2s64*//*Label 1890*/ GIMT_Encode4(112503), GIMT_Encode4(0),
     /*  111558 */ /*GILLT_nxv4s8*//*Label 1891*/ GIMT_Encode4(112618),
     /*  111562 */ /*GILLT_nxv4s16*//*Label 1892*/ GIMT_Encode4(112733),
     /*  111566 */ /*GILLT_nxv4s32*//*Label 1893*/ GIMT_Encode4(112848),
     /*  111570 */ /*GILLT_nxv4s64*//*Label 1894*/ GIMT_Encode4(112963), GIMT_Encode4(0),
     /*  111578 */ /*GILLT_nxv8s8*//*Label 1895*/ GIMT_Encode4(113078),
     /*  111582 */ /*GILLT_nxv8s16*//*Label 1896*/ GIMT_Encode4(113193),
     /*  111586 */ /*GILLT_nxv8s32*//*Label 1897*/ GIMT_Encode4(113308),
     /*  111590 */ /*GILLT_nxv8s64*//*Label 1898*/ GIMT_Encode4(113423), GIMT_Encode4(0),
     /*  111598 */ /*GILLT_nxv16s8*//*Label 1899*/ GIMT_Encode4(113538),
     /*  111602 */ /*GILLT_nxv16s16*//*Label 1900*/ GIMT_Encode4(113653),
     /*  111606 */ /*GILLT_nxv16s32*//*Label 1901*/ GIMT_Encode4(113768), GIMT_Encode4(0),
     /*  111614 */ /*GILLT_nxv32s8*//*Label 1902*/ GIMT_Encode4(113883),
     /*  111618 */ /*GILLT_nxv32s16*//*Label 1903*/ GIMT_Encode4(113998), GIMT_Encode4(0),
     /*  111626 */ /*GILLT_nxv64s8*//*Label 1904*/ GIMT_Encode4(114113),
     /*  111630 */ // Label 1881: @111630
     /*  111630 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(111663), // Rule ID 304 //
     /*  111635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode1),
     /*  111638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  111641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  111644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111652 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111656 */   // (urem:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (REMU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  111656 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  111661 */   GIR_RootConstrainSelectedInstOperands,
     /*  111662 */   // GIR_Coverage, 304,
     /*  111662 */   GIR_Done,
     /*  111663 */ // Label 1906: @111663
     /*  111663 */ GIM_Reject,
     /*  111664 */ // Label 1882: @111664
     /*  111664 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(111697), // Rule ID 303 //
     /*  111669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_HwMode0),
     /*  111672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  111675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  111678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  111690 */   // (urem:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  111690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMU),
     /*  111695 */   GIR_RootConstrainSelectedInstOperands,
     /*  111696 */   // GIR_Coverage, 303,
     /*  111696 */   GIR_Done,
     /*  111697 */ // Label 1907: @111697
     /*  111697 */ GIM_Reject,
     /*  111698 */ // Label 1883: @111698
     /*  111698 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(111812),
     /*  111703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  111706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  111709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111721 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(111766), // Rule ID 51170 //
     /*  111726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111729 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  111729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  111732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  111746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111764 */     GIR_RootConstrainSelectedInstOperands,
     /*  111765 */     // GIR_Coverage, 51170,
     /*  111765 */     GIR_EraseRootFromParent_Done,
     /*  111766 */   // Label 1909: @111766
     /*  111766 */   GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(111811), // Rule ID 51171 //
     /*  111771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111774 */     // (urem:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  111774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  111777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  111791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111809 */     GIR_RootConstrainSelectedInstOperands,
     /*  111810 */     // GIR_Coverage, 51171,
     /*  111810 */     GIR_EraseRootFromParent_Done,
     /*  111811 */   // Label 1910: @111811
     /*  111811 */   GIM_Reject,
     /*  111812 */ // Label 1908: @111812
     /*  111812 */ GIM_Reject,
     /*  111813 */ // Label 1884: @111813
     /*  111813 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(111927),
     /*  111818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  111821 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  111824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111836 */   GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(111881), // Rule ID 51182 //
     /*  111841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111844 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  111844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  111847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  111861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111879 */     GIR_RootConstrainSelectedInstOperands,
     /*  111880 */     // GIR_Coverage, 51182,
     /*  111880 */     GIR_EraseRootFromParent_Done,
     /*  111881 */   // Label 1912: @111881
     /*  111881 */   GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(111926), // Rule ID 51183 //
     /*  111886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  111889 */     // (urem:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  111889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  111892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  111906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  111921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111924 */     GIR_RootConstrainSelectedInstOperands,
     /*  111925 */     // GIR_Coverage, 51183,
     /*  111925 */     GIR_EraseRootFromParent_Done,
     /*  111926 */   // Label 1913: @111926
     /*  111926 */   GIM_Reject,
     /*  111927 */ // Label 1911: @111927
     /*  111927 */ GIM_Reject,
     /*  111928 */ // Label 1885: @111928
     /*  111928 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(112042),
     /*  111933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  111936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  111939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  111951 */   GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(111996), // Rule ID 51190 //
     /*  111956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  111959 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  111959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  111962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  111966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  111971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  111973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  111976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  111978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  111981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  111983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  111985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  111988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  111991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  111994 */     GIR_RootConstrainSelectedInstOperands,
     /*  111995 */     // GIR_Coverage, 51190,
     /*  111995 */     GIR_EraseRootFromParent_Done,
     /*  111996 */   // Label 1915: @111996
     /*  111996 */   GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(112041), // Rule ID 51191 //
     /*  112001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112004 */     // (urem:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  112007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  112021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112039 */     GIR_RootConstrainSelectedInstOperands,
     /*  112040 */     // GIR_Coverage, 51191,
     /*  112040 */     GIR_EraseRootFromParent_Done,
     /*  112041 */   // Label 1916: @112041
     /*  112041 */   GIM_Reject,
     /*  112042 */ // Label 1914: @112042
     /*  112042 */ GIM_Reject,
     /*  112043 */ // Label 1886: @112043
     /*  112043 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(112157),
     /*  112048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  112051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  112054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112066 */   GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(112111), // Rule ID 51206 //
     /*  112071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112074 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  112077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  112091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112109 */     GIR_RootConstrainSelectedInstOperands,
     /*  112110 */     // GIR_Coverage, 51206,
     /*  112110 */     GIR_EraseRootFromParent_Done,
     /*  112111 */   // Label 1918: @112111
     /*  112111 */   GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(112156), // Rule ID 51207 //
     /*  112116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112119 */     // (urem:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  112122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  112136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112154 */     GIR_RootConstrainSelectedInstOperands,
     /*  112155 */     // GIR_Coverage, 51207,
     /*  112155 */     GIR_EraseRootFromParent_Done,
     /*  112156 */   // Label 1919: @112156
     /*  112156 */   GIM_Reject,
     /*  112157 */ // Label 1917: @112157
     /*  112157 */ GIM_Reject,
     /*  112158 */ // Label 1887: @112158
     /*  112158 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(112272),
     /*  112163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  112166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  112169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112177 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112181 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(112226), // Rule ID 51174 //
     /*  112186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112189 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  112192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  112206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112224 */     GIR_RootConstrainSelectedInstOperands,
     /*  112225 */     // GIR_Coverage, 51174,
     /*  112225 */     GIR_EraseRootFromParent_Done,
     /*  112226 */   // Label 1921: @112226
     /*  112226 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(112271), // Rule ID 51175 //
     /*  112231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112234 */     // (urem:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  112237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  112251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112269 */     GIR_RootConstrainSelectedInstOperands,
     /*  112270 */     // GIR_Coverage, 51175,
     /*  112270 */     GIR_EraseRootFromParent_Done,
     /*  112271 */   // Label 1922: @112271
     /*  112271 */   GIM_Reject,
     /*  112272 */ // Label 1920: @112272
     /*  112272 */ GIM_Reject,
     /*  112273 */ // Label 1888: @112273
     /*  112273 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(112387),
     /*  112278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  112281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  112284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112296 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(112341), // Rule ID 51186 //
     /*  112301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112304 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  112307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  112321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112339 */     GIR_RootConstrainSelectedInstOperands,
     /*  112340 */     // GIR_Coverage, 51186,
     /*  112340 */     GIR_EraseRootFromParent_Done,
     /*  112341 */   // Label 1924: @112341
     /*  112341 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(112386), // Rule ID 51187 //
     /*  112346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112349 */     // (urem:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  112352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  112366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112384 */     GIR_RootConstrainSelectedInstOperands,
     /*  112385 */     // GIR_Coverage, 51187,
     /*  112385 */     GIR_EraseRootFromParent_Done,
     /*  112386 */   // Label 1925: @112386
     /*  112386 */   GIM_Reject,
     /*  112387 */ // Label 1923: @112387
     /*  112387 */ GIM_Reject,
     /*  112388 */ // Label 1889: @112388
     /*  112388 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(112502),
     /*  112393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  112396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  112399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112411 */   GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(112456), // Rule ID 51202 //
     /*  112416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112419 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  112422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  112436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112438 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112454 */     GIR_RootConstrainSelectedInstOperands,
     /*  112455 */     // GIR_Coverage, 51202,
     /*  112455 */     GIR_EraseRootFromParent_Done,
     /*  112456 */   // Label 1927: @112456
     /*  112456 */   GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(112501), // Rule ID 51203 //
     /*  112461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112464 */     // (urem:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  112467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  112481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112499 */     GIR_RootConstrainSelectedInstOperands,
     /*  112500 */     // GIR_Coverage, 51203,
     /*  112500 */     GIR_EraseRootFromParent_Done,
     /*  112501 */   // Label 1928: @112501
     /*  112501 */   GIM_Reject,
     /*  112502 */ // Label 1926: @112502
     /*  112502 */ GIM_Reject,
     /*  112503 */ // Label 1890: @112503
     /*  112503 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(112617),
     /*  112508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  112511 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  112514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112522 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112526 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(112571), // Rule ID 51246 //
     /*  112531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112534 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  112537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  112551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112569 */     GIR_RootConstrainSelectedInstOperands,
     /*  112570 */     // GIR_Coverage, 51246,
     /*  112570 */     GIR_EraseRootFromParent_Done,
     /*  112571 */   // Label 1930: @112571
     /*  112571 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(112616), // Rule ID 51247 //
     /*  112576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  112579 */     // (urem:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  112579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  112582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  112596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  112611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112614 */     GIR_RootConstrainSelectedInstOperands,
     /*  112615 */     // GIR_Coverage, 51247,
     /*  112615 */     GIR_EraseRootFromParent_Done,
     /*  112616 */   // Label 1931: @112616
     /*  112616 */   GIM_Reject,
     /*  112617 */ // Label 1929: @112617
     /*  112617 */ GIM_Reject,
     /*  112618 */ // Label 1891: @112618
     /*  112618 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(112732),
     /*  112623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  112626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  112629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112641 */   GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(112686), // Rule ID 51178 //
     /*  112646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112649 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  112649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  112652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  112666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112684 */     GIR_RootConstrainSelectedInstOperands,
     /*  112685 */     // GIR_Coverage, 51178,
     /*  112685 */     GIR_EraseRootFromParent_Done,
     /*  112686 */   // Label 1933: @112686
     /*  112686 */   GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(112731), // Rule ID 51179 //
     /*  112691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112694 */     // (urem:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  112694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  112697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  112711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112729 */     GIR_RootConstrainSelectedInstOperands,
     /*  112730 */     // GIR_Coverage, 51179,
     /*  112730 */     GIR_EraseRootFromParent_Done,
     /*  112731 */   // Label 1934: @112731
     /*  112731 */   GIM_Reject,
     /*  112732 */ // Label 1932: @112732
     /*  112732 */ GIM_Reject,
     /*  112733 */ // Label 1892: @112733
     /*  112733 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(112847),
     /*  112738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  112741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  112744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  112756 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(112801), // Rule ID 51198 //
     /*  112761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112764 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  112764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  112767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  112781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112799 */     GIR_RootConstrainSelectedInstOperands,
     /*  112800 */     // GIR_Coverage, 51198,
     /*  112800 */     GIR_EraseRootFromParent_Done,
     /*  112801 */   // Label 1936: @112801
     /*  112801 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(112846), // Rule ID 51199 //
     /*  112806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112809 */     // (urem:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  112809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  112812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  112826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  112841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112844 */     GIR_RootConstrainSelectedInstOperands,
     /*  112845 */     // GIR_Coverage, 51199,
     /*  112845 */     GIR_EraseRootFromParent_Done,
     /*  112846 */   // Label 1937: @112846
     /*  112846 */   GIM_Reject,
     /*  112847 */ // Label 1935: @112847
     /*  112847 */ GIM_Reject,
     /*  112848 */ // Label 1893: @112848
     /*  112848 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(112962),
     /*  112853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  112856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  112859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  112871 */   GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(112916), // Rule ID 51234 //
     /*  112876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  112879 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  112879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  112882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  112896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112914 */     GIR_RootConstrainSelectedInstOperands,
     /*  112915 */     // GIR_Coverage, 51234,
     /*  112915 */     GIR_EraseRootFromParent_Done,
     /*  112916 */   // Label 1939: @112916
     /*  112916 */   GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(112961), // Rule ID 51235 //
     /*  112921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  112924 */     // (urem:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  112924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  112927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  112931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  112936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  112938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  112941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  112943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  112946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  112948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  112950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  112953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  112956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  112959 */     GIR_RootConstrainSelectedInstOperands,
     /*  112960 */     // GIR_Coverage, 51235,
     /*  112960 */     GIR_EraseRootFromParent_Done,
     /*  112961 */   // Label 1940: @112961
     /*  112961 */   GIM_Reject,
     /*  112962 */ // Label 1938: @112962
     /*  112962 */ GIM_Reject,
     /*  112963 */ // Label 1894: @112963
     /*  112963 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(113077),
     /*  112968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  112971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  112974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  112986 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(113031), // Rule ID 51250 //
     /*  112991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  112994 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  112994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  112997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  113011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113029 */     GIR_RootConstrainSelectedInstOperands,
     /*  113030 */     // GIR_Coverage, 51250,
     /*  113030 */     GIR_EraseRootFromParent_Done,
     /*  113031 */   // Label 1942: @113031
     /*  113031 */   GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(113076), // Rule ID 51251 //
     /*  113036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113039 */     // (urem:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  113042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  113056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113074 */     GIR_RootConstrainSelectedInstOperands,
     /*  113075 */     // GIR_Coverage, 51251,
     /*  113075 */     GIR_EraseRootFromParent_Done,
     /*  113076 */   // Label 1943: @113076
     /*  113076 */   GIM_Reject,
     /*  113077 */ // Label 1941: @113077
     /*  113077 */ GIM_Reject,
     /*  113078 */ // Label 1895: @113078
     /*  113078 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(113192),
     /*  113083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  113086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  113089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  113101 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(113146), // Rule ID 51194 //
     /*  113106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113109 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  113112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113121 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  113126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113144 */     GIR_RootConstrainSelectedInstOperands,
     /*  113145 */     // GIR_Coverage, 51194,
     /*  113145 */     GIR_EraseRootFromParent_Done,
     /*  113146 */   // Label 1945: @113146
     /*  113146 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(113191), // Rule ID 51195 //
     /*  113151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113154 */     // (urem:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  113157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  113171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113189 */     GIR_RootConstrainSelectedInstOperands,
     /*  113190 */     // GIR_Coverage, 51195,
     /*  113190 */     GIR_EraseRootFromParent_Done,
     /*  113191 */   // Label 1946: @113191
     /*  113191 */   GIM_Reject,
     /*  113192 */ // Label 1944: @113192
     /*  113192 */ GIM_Reject,
     /*  113193 */ // Label 1896: @113193
     /*  113193 */ GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(113307),
     /*  113198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  113201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  113204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113216 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(113261), // Rule ID 51222 //
     /*  113221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113224 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  113227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  113241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113259 */     GIR_RootConstrainSelectedInstOperands,
     /*  113260 */     // GIR_Coverage, 51222,
     /*  113260 */     GIR_EraseRootFromParent_Done,
     /*  113261 */   // Label 1948: @113261
     /*  113261 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(113306), // Rule ID 51223 //
     /*  113266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113269 */     // (urem:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  113272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  113286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113291 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113304 */     GIR_RootConstrainSelectedInstOperands,
     /*  113305 */     // GIR_Coverage, 51223,
     /*  113305 */     GIR_EraseRootFromParent_Done,
     /*  113306 */   // Label 1949: @113306
     /*  113306 */   GIM_Reject,
     /*  113307 */ // Label 1947: @113307
     /*  113307 */ GIM_Reject,
     /*  113308 */ // Label 1897: @113308
     /*  113308 */ GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(113422),
     /*  113313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  113316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  113319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113331 */   GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(113376), // Rule ID 51238 //
     /*  113336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113339 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  113342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  113356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113374 */     GIR_RootConstrainSelectedInstOperands,
     /*  113375 */     // GIR_Coverage, 51238,
     /*  113375 */     GIR_EraseRootFromParent_Done,
     /*  113376 */   // Label 1951: @113376
     /*  113376 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(113421), // Rule ID 51239 //
     /*  113381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113384 */     // (urem:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  113387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  113401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113406 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113419 */     GIR_RootConstrainSelectedInstOperands,
     /*  113420 */     // GIR_Coverage, 51239,
     /*  113420 */     GIR_EraseRootFromParent_Done,
     /*  113421 */   // Label 1952: @113421
     /*  113421 */   GIM_Reject,
     /*  113422 */ // Label 1950: @113422
     /*  113422 */ GIM_Reject,
     /*  113423 */ // Label 1898: @113423
     /*  113423 */ GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(113537),
     /*  113428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  113431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  113434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113442 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113446 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(113491), // Rule ID 51254 //
     /*  113451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  113454 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  113454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  113457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  113471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113489 */     GIR_RootConstrainSelectedInstOperands,
     /*  113490 */     // GIR_Coverage, 51254,
     /*  113490 */     GIR_EraseRootFromParent_Done,
     /*  113491 */   // Label 1954: @113491
     /*  113491 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(113536), // Rule ID 51255 //
     /*  113496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  113499 */     // (urem:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  113499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  113502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  113516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  113531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113534 */     GIR_RootConstrainSelectedInstOperands,
     /*  113535 */     // GIR_Coverage, 51255,
     /*  113535 */     GIR_EraseRootFromParent_Done,
     /*  113536 */   // Label 1955: @113536
     /*  113536 */   GIM_Reject,
     /*  113537 */ // Label 1953: @113537
     /*  113537 */ GIM_Reject,
     /*  113538 */ // Label 1899: @113538
     /*  113538 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(113652),
     /*  113543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  113546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  113549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  113561 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(113606), // Rule ID 51210 //
     /*  113566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113569 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  113572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  113586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113604 */     GIR_RootConstrainSelectedInstOperands,
     /*  113605 */     // GIR_Coverage, 51210,
     /*  113605 */     GIR_EraseRootFromParent_Done,
     /*  113606 */   // Label 1957: @113606
     /*  113606 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(113651), // Rule ID 51211 //
     /*  113611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113614 */     // (urem:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  113617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  113631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113649 */     GIR_RootConstrainSelectedInstOperands,
     /*  113650 */     // GIR_Coverage, 51211,
     /*  113650 */     GIR_EraseRootFromParent_Done,
     /*  113651 */   // Label 1958: @113651
     /*  113651 */   GIM_Reject,
     /*  113652 */ // Label 1956: @113652
     /*  113652 */ GIM_Reject,
     /*  113653 */ // Label 1900: @113653
     /*  113653 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(113767),
     /*  113658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  113661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  113664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113676 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(113721), // Rule ID 51226 //
     /*  113681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113684 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  113684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  113687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113696 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  113701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113719 */     GIR_RootConstrainSelectedInstOperands,
     /*  113720 */     // GIR_Coverage, 51226,
     /*  113720 */     GIR_EraseRootFromParent_Done,
     /*  113721 */   // Label 1960: @113721
     /*  113721 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(113766), // Rule ID 51227 //
     /*  113726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113729 */     // (urem:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  113729 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  113732 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113736 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  113746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113751 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  113761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113764 */     GIR_RootConstrainSelectedInstOperands,
     /*  113765 */     // GIR_Coverage, 51227,
     /*  113765 */     GIR_EraseRootFromParent_Done,
     /*  113766 */   // Label 1961: @113766
     /*  113766 */   GIM_Reject,
     /*  113767 */ // Label 1959: @113767
     /*  113767 */ GIM_Reject,
     /*  113768 */ // Label 1901: @113768
     /*  113768 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(113882),
     /*  113773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  113776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  113779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  113791 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(113836), // Rule ID 51242 //
     /*  113796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113799 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  113799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  113802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  113816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113834 */     GIR_RootConstrainSelectedInstOperands,
     /*  113835 */     // GIR_Coverage, 51242,
     /*  113835 */     GIR_EraseRootFromParent_Done,
     /*  113836 */   // Label 1963: @113836
     /*  113836 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(113881), // Rule ID 51243 //
     /*  113841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113844 */     // (urem:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  113844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  113847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  113861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113866 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  113876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113879 */     GIR_RootConstrainSelectedInstOperands,
     /*  113880 */     // GIR_Coverage, 51243,
     /*  113880 */     GIR_EraseRootFromParent_Done,
     /*  113881 */   // Label 1964: @113881
     /*  113881 */   GIM_Reject,
     /*  113882 */ // Label 1962: @113882
     /*  113882 */ GIM_Reject,
     /*  113883 */ // Label 1902: @113883
     /*  113883 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(113997),
     /*  113888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  113891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  113894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113902 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  113906 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(113951), // Rule ID 51214 //
     /*  113911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  113914 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  113914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  113917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  113931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113949 */     GIR_RootConstrainSelectedInstOperands,
     /*  113950 */     // GIR_Coverage, 51214,
     /*  113950 */     GIR_EraseRootFromParent_Done,
     /*  113951 */   // Label 1966: @113951
     /*  113951 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(113996), // Rule ID 51215 //
     /*  113956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  113959 */     // (urem:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  113959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  113962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  113966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  113971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  113973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  113976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  113978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  113981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  113983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  113985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  113988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  113994 */     GIR_RootConstrainSelectedInstOperands,
     /*  113995 */     // GIR_Coverage, 51215,
     /*  113995 */     GIR_EraseRootFromParent_Done,
     /*  113996 */   // Label 1967: @113996
     /*  113996 */   GIM_Reject,
     /*  113997 */ // Label 1965: @113997
     /*  113997 */ GIM_Reject,
     /*  113998 */ // Label 1903: @113998
     /*  113998 */ GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(114112),
     /*  114003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  114006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  114009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114021 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(114066), // Rule ID 51230 //
     /*  114026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114029 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  114029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  114032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  114046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114064 */     GIR_RootConstrainSelectedInstOperands,
     /*  114065 */     // GIR_Coverage, 51230,
     /*  114065 */     GIR_EraseRootFromParent_Done,
     /*  114066 */   // Label 1969: @114066
     /*  114066 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(114111), // Rule ID 51231 //
     /*  114071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114074 */     // (urem:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  114074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  114077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  114091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114093 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  114106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114109 */     GIR_RootConstrainSelectedInstOperands,
     /*  114110 */     // GIR_Coverage, 51231,
     /*  114110 */     GIR_EraseRootFromParent_Done,
     /*  114111 */   // Label 1970: @114111
     /*  114111 */   GIM_Reject,
     /*  114112 */ // Label 1968: @114112
     /*  114112 */ GIM_Reject,
     /*  114113 */ // Label 1904: @114113
     /*  114113 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(114227),
     /*  114118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  114121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  114124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  114136 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(114181), // Rule ID 51218 //
     /*  114141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  114144 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  114144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  114147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  114161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114179 */     GIR_RootConstrainSelectedInstOperands,
     /*  114180 */     // GIR_Coverage, 51218,
     /*  114180 */     GIR_EraseRootFromParent_Done,
     /*  114181 */   // Label 1972: @114181
     /*  114181 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(114226), // Rule ID 51219 //
     /*  114186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  114189 */     // (urem:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  114189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  114192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  114196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  114201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  114203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  114206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  114211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  114215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  114218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  114224 */     GIR_RootConstrainSelectedInstOperands,
     /*  114225 */     // GIR_Coverage, 51219,
     /*  114225 */     GIR_EraseRootFromParent_Done,
     /*  114226 */   // Label 1973: @114226
     /*  114226 */   GIM_Reject,
     /*  114227 */ // Label 1971: @114227
     /*  114227 */ GIM_Reject,
     /*  114228 */ // Label 1905: @114228
     /*  114228 */ GIM_Reject,
     /*  114229 */ // Label 7: @114229
     /*  114229 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2005*/ GIMT_Encode4(123672),
     /*  114240 */ /*GILLT_s32*//*Label 1974*/ GIMT_Encode4(114364),
     /*  114244 */ /*GILLT_s64*//*Label 1975*/ GIMT_Encode4(115582),
     /*  114248 */ /*GILLT_nxv1s1*//*Label 1976*/ GIMT_Encode4(116865),
     /*  114252 */ /*GILLT_nxv1s8*//*Label 1977*/ GIMT_Encode4(117476),
     /*  114256 */ /*GILLT_nxv1s16*//*Label 1978*/ GIMT_Encode4(117591),
     /*  114260 */ /*GILLT_nxv1s32*//*Label 1979*/ GIMT_Encode4(117706),
     /*  114264 */ /*GILLT_nxv1s64*//*Label 1980*/ GIMT_Encode4(117821),
     /*  114268 */ /*GILLT_nxv2s1*//*Label 1981*/ GIMT_Encode4(117936),
     /*  114272 */ /*GILLT_nxv2s8*//*Label 1982*/ GIMT_Encode4(118547),
     /*  114276 */ /*GILLT_nxv2s16*//*Label 1983*/ GIMT_Encode4(118662),
     /*  114280 */ /*GILLT_nxv2s32*//*Label 1984*/ GIMT_Encode4(118777),
     /*  114284 */ /*GILLT_nxv2s64*//*Label 1985*/ GIMT_Encode4(118892),
     /*  114288 */ /*GILLT_nxv4s1*//*Label 1986*/ GIMT_Encode4(119007),
     /*  114292 */ /*GILLT_nxv4s8*//*Label 1987*/ GIMT_Encode4(119618),
     /*  114296 */ /*GILLT_nxv4s16*//*Label 1988*/ GIMT_Encode4(119733),
     /*  114300 */ /*GILLT_nxv4s32*//*Label 1989*/ GIMT_Encode4(119848),
     /*  114304 */ /*GILLT_nxv4s64*//*Label 1990*/ GIMT_Encode4(119963),
     /*  114308 */ /*GILLT_nxv8s1*//*Label 1991*/ GIMT_Encode4(120078),
     /*  114312 */ /*GILLT_nxv8s8*//*Label 1992*/ GIMT_Encode4(120689),
     /*  114316 */ /*GILLT_nxv8s16*//*Label 1993*/ GIMT_Encode4(120804),
     /*  114320 */ /*GILLT_nxv8s32*//*Label 1994*/ GIMT_Encode4(120919),
     /*  114324 */ /*GILLT_nxv8s64*//*Label 1995*/ GIMT_Encode4(121034),
     /*  114328 */ /*GILLT_nxv16s1*//*Label 1996*/ GIMT_Encode4(121149),
     /*  114332 */ /*GILLT_nxv16s8*//*Label 1997*/ GIMT_Encode4(121760),
     /*  114336 */ /*GILLT_nxv16s16*//*Label 1998*/ GIMT_Encode4(121875),
     /*  114340 */ /*GILLT_nxv16s32*//*Label 1999*/ GIMT_Encode4(121990),
     /*  114344 */ /*GILLT_nxv32s1*//*Label 2000*/ GIMT_Encode4(122105),
     /*  114348 */ /*GILLT_nxv32s8*//*Label 2001*/ GIMT_Encode4(122716),
     /*  114352 */ /*GILLT_nxv32s16*//*Label 2002*/ GIMT_Encode4(122831),
     /*  114356 */ /*GILLT_nxv64s1*//*Label 2003*/ GIMT_Encode4(122946),
     /*  114360 */ /*GILLT_nxv64s8*//*Label 2004*/ GIMT_Encode4(123557),
     /*  114364 */ // Label 1974: @114364
     /*  114364 */ GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(115581),
     /*  114369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  114372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  114375 */   GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(114464), // Rule ID 65144 //
     /*  114380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  114383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  114395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  114407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  114411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  114415 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  114419 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  114428 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  114439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  114448 */     // (and:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] })), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  114451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  114458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  114462 */     GIR_RootConstrainSelectedInstOperands,
     /*  114463 */     // GIR_Coverage, 65144,
     /*  114463 */     GIR_EraseRootFromParent_Done,
     /*  114464 */   // Label 2007: @114464
     /*  114464 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(114553), // Rule ID 2434 //
     /*  114469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  114472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  114484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  114496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  114500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  114504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  114508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114513 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  114517 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  114528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  114537 */     // (and:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1)), 65535:{ *:[i32] })  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  114540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  114547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  114551 */     GIR_RootConstrainSelectedInstOperands,
     /*  114552 */     // GIR_Coverage, 2434,
     /*  114552 */     GIR_EraseRootFromParent_Done,
     /*  114553 */   // Label 2008: @114553
     /*  114553 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(114632), // Rule ID 2361 //
     /*  114558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  114561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  114573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  114585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  114589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  114593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  114597 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  114601 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  114605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114611 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  114618 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  114621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  114630 */     GIR_RootConstrainSelectedInstOperands,
     /*  114631 */     // GIR_Coverage, 2361,
     /*  114631 */     GIR_EraseRootFromParent_Done,
     /*  114632 */   // Label 2009: @114632
     /*  114632 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(114711), // Rule ID 65132 //
     /*  114637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  114640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  114652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  114656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  114668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  114672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  114676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  114680 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  114684 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  114688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114690 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  114697 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] }))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  114700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  114704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  114709 */     GIR_RootConstrainSelectedInstOperands,
     /*  114710 */     // GIR_Coverage, 65132,
     /*  114710 */     GIR_EraseRootFromParent_Done,
     /*  114711 */   // Label 2010: @114711
     /*  114711 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(114776), // Rule ID 2381 //
     /*  114716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  114719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  114731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  114748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  114752 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  114756 */     // MIs[2] Operand 1
     /*  114756 */     // No operand predicates
     /*  114756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  114760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114762 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (BEXTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  114762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  114765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  114771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  114774 */     GIR_RootConstrainSelectedInstOperands,
     /*  114775 */     // GIR_Coverage, 2381,
     /*  114775 */     GIR_EraseRootFromParent_Done,
     /*  114776 */   // Label 2011: @114776
     /*  114776 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(114841), // Rule ID 62546 //
     /*  114781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode1),
     /*  114784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  114796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  114813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  114817 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  114821 */     // MIs[2] Operand 1
     /*  114821 */     // No operand predicates
     /*  114821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  114825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  114827 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i32] })  =>  (TH_TST:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  114827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  114830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  114836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  114839 */     GIR_RootConstrainSelectedInstOperands,
     /*  114840 */     // GIR_Coverage, 62546,
     /*  114840 */     GIR_EraseRootFromParent_Done,
     /*  114841 */   // Label 2012: @114841
     /*  114841 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(114903), // Rule ID 2369 //
     /*  114846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  114849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  114861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  114878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  114880 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  114887 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), 1:{ *:[i32] })  =>  (BEXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  114890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  114896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  114901 */     GIR_RootConstrainSelectedInstOperands,
     /*  114902 */     // GIR_Coverage, 2369,
     /*  114902 */     GIR_EraseRootFromParent_Done,
     /*  114903 */   // Label 2013: @114903
     /*  114903 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(114959), // Rule ID 2363 //
     /*  114908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  114911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  114923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114931 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  114935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  114946 */     // (and:{ *:[i32] } (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), GPR:{ *:[i32] }:$rs1)  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  114946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  114949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  114951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  114953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  114957 */     GIR_RootConstrainSelectedInstOperands,
     /*  114958 */     // GIR_Coverage, 2363,
     /*  114958 */     GIR_EraseRootFromParent_Done,
     /*  114959 */   // Label 2014: @114959
     /*  114959 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(115015), // Rule ID 65118 //
     /*  114964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  114967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  114975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  114979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  114983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  114987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  114992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  114996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115002 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  115005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  115013 */     GIR_RootConstrainSelectedInstOperands,
     /*  115014 */     // GIR_Coverage, 65118,
     /*  115014 */     GIR_EraseRootFromParent_Done,
     /*  115015 */   // Label 2015: @115015
     /*  115015 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(115071), // Rule ID 65134 //
     /*  115020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  115023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  115039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  115043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  115047 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  115051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115058 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (rotl:{ *:[i32] } -2:{ *:[i32] }, GPR:{ *:[i32] }:$rs2))  =>  (BCLR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  115061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115063 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  115069 */     GIR_RootConstrainSelectedInstOperands,
     /*  115070 */     // GIR_Coverage, 65134,
     /*  115070 */     GIR_EraseRootFromParent_Done,
     /*  115071 */   // Label 2016: @115071
     /*  115071 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(115127), // Rule ID 2337 //
     /*  115076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  115079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  115095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  115099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  115103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115108 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  115112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115114 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ANDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  115117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115119 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  115125 */     GIR_RootConstrainSelectedInstOperands,
     /*  115126 */     // GIR_Coverage, 2337,
     /*  115126 */     GIR_EraseRootFromParent_Done,
     /*  115127 */   // Label 2017: @115127
     /*  115127 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(115163), // Rule ID 64447 //
     /*  115132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  115135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115143 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115154 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 65535:{ *:[i32] })  =>  (CV_EXTHZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  115154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  115157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115161 */     GIR_RootConstrainSelectedInstOperands,
     /*  115162 */     // GIR_Coverage, 64447,
     /*  115162 */     GIR_EraseRootFromParent_Done,
     /*  115163 */   // Label 2018: @115163
     /*  115163 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(115199), // Rule ID 64449 //
     /*  115168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  115171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115179 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  115190 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 255:{ *:[i32] })  =>  (CV_EXTBZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  115190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  115193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115197 */     GIR_RootConstrainSelectedInstOperands,
     /*  115198 */     // GIR_Coverage, 64449,
     /*  115198 */     GIR_EraseRootFromParent_Done,
     /*  115199 */   // Label 2019: @115199
     /*  115199 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(115235), // Rule ID 2445 //
     /*  115204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /*  115207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115215 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115226 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  115226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  115229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  115233 */     GIR_RootConstrainSelectedInstOperands,
     /*  115234 */     // GIR_Coverage, 2445,
     /*  115234 */     GIR_EraseRootFromParent_Done,
     /*  115235 */   // Label 2020: @115235
     /*  115235 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(115271), // Rule ID 2446 //
     /*  115240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /*  115243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115251 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115262 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs)
     /*  115262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /*  115265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  115269 */     GIR_RootConstrainSelectedInstOperands,
     /*  115270 */     // GIR_Coverage, 2446,
     /*  115270 */     GIR_EraseRootFromParent_Done,
     /*  115271 */   // Label 2021: @115271
     /*  115271 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(115313), // Rule ID 2448 //
     /*  115276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /*  115279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115287 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115298 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i64] })
     /*  115298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  115301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  115305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  115311 */     GIR_RootConstrainSelectedInstOperands,
     /*  115312 */     // GIR_Coverage, 2448,
     /*  115312 */     GIR_EraseRootFromParent_Done,
     /*  115313 */   // Label 2022: @115313
     /*  115313 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(115355), // Rule ID 2449 //
     /*  115318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /*  115321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115329 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115340 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, 65535:{ *:[i32] })  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs, X0:{ *:[i32] })
     /*  115340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  115343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  115347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  115353 */     GIR_RootConstrainSelectedInstOperands,
     /*  115354 */     // GIR_Coverage, 2449,
     /*  115354 */     GIR_EraseRootFromParent_Done,
     /*  115355 */   // Label 2023: @115355
     /*  115355 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(115397), // Rule ID 85 //
     /*  115360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  115379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  115383 */     // MIs[1] Operand 1
     /*  115383 */     // No operand predicates
     /*  115383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115385 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  115385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  115388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  115395 */     GIR_RootConstrainSelectedInstOperands,
     /*  115396 */     // GIR_Coverage, 85,
     /*  115396 */     GIR_EraseRootFromParent_Done,
     /*  115397 */   // Label 2024: @115397
     /*  115397 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(115469), // Rule ID 103 //
     /*  115402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  115421 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  115425 */     // MIs[1] Operand 1
     /*  115425 */     // No operand predicates
     /*  115425 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9936),
     /*  115429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115431 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs, (imm:{ *:[i32] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9936>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } ?:{ *:[i32] }:$rs, (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask)), (XLenSubTrailingOnes:{ *:[i32] } (imm:{ *:[i32] }):$mask))
     /*  115431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  115434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  115438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  115443 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  115447 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  115452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  115454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  115457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  115462 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  115467 */     GIR_RootConstrainSelectedInstOperands,
     /*  115468 */     // GIR_Coverage, 103,
     /*  115468 */     GIR_EraseRootFromParent_Done,
     /*  115469 */   // Label 2025: @115469
     /*  115469 */   GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(115511), // Rule ID 64500 //
     /*  115474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  115477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  115481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  115485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  115493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  115497 */     // MIs[1] Operand 1
     /*  115497 */     // No operand predicates
     /*  115497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115499 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ANDAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  115499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDAI),
     /*  115502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  115504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  115509 */     GIR_RootConstrainSelectedInstOperands,
     /*  115510 */     // GIR_Coverage, 64500,
     /*  115510 */     GIR_EraseRootFromParent_Done,
     /*  115511 */   // Label 2026: @115511
     /*  115511 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(115553), // Rule ID 64504 //
     /*  115516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  115519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  115523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  115527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  115535 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  115539 */     // MIs[1] Operand 1
     /*  115539 */     // No operand predicates
     /*  115539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  115541 */     // (and:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ANDI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  115541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ANDI),
     /*  115544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  115551 */     GIR_RootConstrainSelectedInstOperands,
     /*  115552 */     // GIR_Coverage, 64504,
     /*  115552 */     GIR_EraseRootFromParent_Done,
     /*  115553 */   // Label 2027: @115553
     /*  115553 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(115580), // Rule ID 83 //
     /*  115558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  115561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115573 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (AND:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  115573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  115578 */     GIR_RootConstrainSelectedInstOperands,
     /*  115579 */     // GIR_Coverage, 83,
     /*  115579 */     GIR_Done,
     /*  115580 */   // Label 2028: @115580
     /*  115580 */   GIM_Reject,
     /*  115581 */ // Label 2006: @115581
     /*  115581 */ GIM_Reject,
     /*  115582 */ // Label 1975: @115582
     /*  115582 */ GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(116864),
     /*  115587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  115590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  115593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115597 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(115682), // Rule ID 65143 //
     /*  115602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  115605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  115609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  115613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  115621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  115625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  115629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  115633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  115637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115642 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  115646 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  115659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  115666 */     // (and:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] })), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  115669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  115676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  115680 */     GIR_RootConstrainSelectedInstOperands,
     /*  115681 */     // GIR_Coverage, 65143,
     /*  115681 */     GIR_EraseRootFromParent_Done,
     /*  115682 */   // Label 2030: @115682
     /*  115682 */   GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(115767), // Rule ID 2433 //
     /*  115687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  115690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  115694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  115698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  115706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  115710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  115714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  115718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  115722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115727 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  115731 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  115742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  115744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  115751 */     // (and:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1)), 65535:{ *:[i64] })  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  115754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  115761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  115765 */     GIR_RootConstrainSelectedInstOperands,
     /*  115766 */     // GIR_Coverage, 2433,
     /*  115766 */     GIR_EraseRootFromParent_Done,
     /*  115767 */   // Label 2031: @115767
     /*  115767 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(115842), // Rule ID 2360 //
     /*  115772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  115775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  115779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  115783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  115791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  115795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  115799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  115803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  115807 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  115811 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  115815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  115821 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  115828 */     // (and:{ *:[i64] } (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  115831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  115835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  115840 */     GIR_RootConstrainSelectedInstOperands,
     /*  115841 */     // GIR_Coverage, 2360,
     /*  115841 */     GIR_EraseRootFromParent_Done,
     /*  115842 */   // Label 2032: @115842
     /*  115842 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(115917), // Rule ID 65131 //
     /*  115847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  115850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  115858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  115862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  115870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  115874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  115878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  115882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  115886 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, 1,
     /*  115890 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  115894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  115896 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  115903 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] }))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  115903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  115906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  115910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  115915 */     GIR_RootConstrainSelectedInstOperands,
     /*  115916 */     // GIR_Coverage, 65131,
     /*  115916 */     GIR_EraseRootFromParent_Done,
     /*  115917 */   // Label 2033: @115917
     /*  115917 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(115978), // Rule ID 2380 //
     /*  115922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  115925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  115929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  115933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  115941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  115946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  115950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  115954 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  115958 */     // MIs[2] Operand 1
     /*  115958 */     // No operand predicates
     /*  115958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  115962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  115964 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (BEXTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  115964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXTI),
     /*  115967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  115969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  115973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  115976 */     GIR_RootConstrainSelectedInstOperands,
     /*  115977 */     // GIR_Coverage, 2380,
     /*  115977 */     GIR_EraseRootFromParent_Done,
     /*  115978 */   // Label 2034: @115978
     /*  115978 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(116039), // Rule ID 62545 //
     /*  115983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBs_HwMode0),
     /*  115986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  115990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  115994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  115998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  116011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116015 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /*  116019 */     // MIs[2] Operand 1
     /*  116019 */     // No operand predicates
     /*  116019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  116023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  116025 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt), 1:{ *:[i64] })  =>  (TH_TST:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)
     /*  116025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_TST),
     /*  116028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  116034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /*  116037 */     GIR_RootConstrainSelectedInstOperands,
     /*  116038 */     // GIR_Coverage, 62545,
     /*  116038 */     GIR_EraseRootFromParent_Done,
     /*  116039 */   // Label 2035: @116039
     /*  116039 */   GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(116097), // Rule ID 2368 //
     /*  116044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  116047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  116051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  116055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  116059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116068 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  116072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116074 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  116081 */     // (and:{ *:[i64] } (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), 1:{ *:[i64] })  =>  (BEXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BEXT),
     /*  116084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  116090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  116095 */     GIR_RootConstrainSelectedInstOperands,
     /*  116096 */     // GIR_Coverage, 2368,
     /*  116096 */     GIR_EraseRootFromParent_Done,
     /*  116097 */   // Label 2036: @116097
     /*  116097 */   GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(116149), // Rule ID 2362 //
     /*  116102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  116105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  116109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  116113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  116117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116121 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  116125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116136 */     // (and:{ *:[i64] } (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), GPR:{ *:[i64] }:$rs1)  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  116139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  116147 */     GIR_RootConstrainSelectedInstOperands,
     /*  116148 */     // GIR_Coverage, 2362,
     /*  116148 */     GIR_EraseRootFromParent_Done,
     /*  116149 */   // Label 2037: @116149
     /*  116149 */   GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(116201), // Rule ID 65117 //
     /*  116154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  116157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  116161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  116165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  116169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116178 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  116182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116188 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  116191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  116199 */     GIR_RootConstrainSelectedInstOperands,
     /*  116200 */     // GIR_Coverage, 65117,
     /*  116200 */     GIR_EraseRootFromParent_Done,
     /*  116201 */   // Label 2038: @116201
     /*  116201 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(116253), // Rule ID 65133 //
     /*  116206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  116209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTL),
     /*  116221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  116225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116229 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-2),
     /*  116233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116240 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (rotl:{ *:[i64] } -2:{ *:[i64] }, GPR:{ *:[i64] }:$rs2))  =>  (BCLR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BCLR),
     /*  116243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  116251 */     GIR_RootConstrainSelectedInstOperands,
     /*  116252 */     // GIR_Coverage, 65133,
     /*  116252 */     GIR_EraseRootFromParent_Done,
     /*  116253 */   // Label 2039: @116253
     /*  116253 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(116305), // Rule ID 2336 //
     /*  116258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  116261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  116273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  116277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  116281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116286 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  116290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116292 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ANDN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDN),
     /*  116295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  116303 */     GIR_RootConstrainSelectedInstOperands,
     /*  116304 */     // GIR_Coverage, 2336,
     /*  116304 */     GIR_EraseRootFromParent_Done,
     /*  116305 */   // Label 2040: @116305
     /*  116305 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(116337), // Rule ID 64446 //
     /*  116310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  116313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116317 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  116328 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 65535:{ *:[i64] })  =>  (CV_EXTHZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  116328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHZ),
     /*  116331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116335 */     GIR_RootConstrainSelectedInstOperands,
     /*  116336 */     // GIR_Coverage, 64446,
     /*  116336 */     GIR_EraseRootFromParent_Done,
     /*  116337 */   // Label 2041: @116337
     /*  116337 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(116369), // Rule ID 64448 //
     /*  116342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  116345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116349 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  116360 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 255:{ *:[i64] })  =>  (CV_EXTBZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  116360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBZ),
     /*  116363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116367 */     GIR_RootConstrainSelectedInstOperands,
     /*  116368 */     // GIR_Coverage, 64448,
     /*  116368 */     GIR_EraseRootFromParent_Done,
     /*  116369 */   // Label 2042: @116369
     /*  116369 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(116426), // Rule ID 252 //
     /*  116374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /*  116377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116381 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  116392 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] })  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), 32:{ *:[i64] })
     /*  116392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  116395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  116399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116404 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  116408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /*  116411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  116416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116418 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /*  116424 */     GIR_RootConstrainSelectedInstOperands,
     /*  116425 */     // GIR_Coverage, 252,
     /*  116425 */     GIR_EraseRootFromParent_Done,
     /*  116426 */   // Label 2043: @116426
     /*  116426 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(116458), // Rule ID 2447 //
     /*  116431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /*  116434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116438 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  116449 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs)
     /*  116449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /*  116452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  116456 */     GIR_RootConstrainSelectedInstOperands,
     /*  116457 */     // GIR_Coverage, 2447,
     /*  116457 */     GIR_EraseRootFromParent_Done,
     /*  116458 */   // Label 2044: @116458
     /*  116458 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(116496), // Rule ID 2450 //
     /*  116463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /*  116466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116470 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  116481 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 65535:{ *:[i64] })  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  116481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  116484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  116488 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  116494 */     GIR_RootConstrainSelectedInstOperands,
     /*  116495 */     // GIR_Coverage, 2450,
     /*  116495 */     GIR_EraseRootFromParent_Done,
     /*  116496 */   // Label 2045: @116496
     /*  116496 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(116534), // Rule ID 2493 //
     /*  116501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  116504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116508 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  116519 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, 4294967295:{ *:[i64] })  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs, X0:{ *:[i64] })
     /*  116519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /*  116522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  116526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  116532 */     GIR_RootConstrainSelectedInstOperands,
     /*  116533 */     // GIR_Coverage, 2493,
     /*  116533 */     GIR_EraseRootFromParent_Done,
     /*  116534 */   // Label 2046: @116534
     /*  116534 */   GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(116572), // Rule ID 84 //
     /*  116539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  116558 */     // MIs[1] Operand 1
     /*  116558 */     // No operand predicates
     /*  116558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116560 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ANDI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  116560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ANDI),
     /*  116563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  116567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  116570 */     GIR_RootConstrainSelectedInstOperands,
     /*  116571 */     // GIR_Coverage, 84,
     /*  116571 */     GIR_EraseRootFromParent_Done,
     /*  116572 */   // Label 2047: @116572
     /*  116572 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(116640), // Rule ID 101 //
     /*  116577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesMask),
     /*  116596 */     // MIs[1] Operand 1
     /*  116596 */     // No operand predicates
     /*  116596 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9934),
     /*  116600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116602 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesMask>><<P:Predicate_anonymous_9934>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  116602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  116605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  116609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  116618 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  116628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116633 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116638 */     GIR_RootConstrainSelectedInstOperands,
     /*  116639 */     // GIR_Coverage, 101,
     /*  116639 */     GIR_EraseRootFromParent_Done,
     /*  116640 */   // Label 2048: @116640
     /*  116640 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(116708), // Rule ID 102 //
     /*  116645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116660 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_TrailingOnesMask),
     /*  116664 */     // MIs[1] Operand 1
     /*  116664 */     // No operand predicates
     /*  116664 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_9936),
     /*  116668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116670 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_TrailingOnesMask>><<P:Predicate_anonymous_9936>><<X:XLenSubTrailingOnes>>:$mask)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } ?:{ *:[i64] }:$rs, (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (XLenSubTrailingOnes:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  116670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  116673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  116677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  116686 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  116691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  116696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116701 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderXLenSubTrailingOnes), // mask
     /*  116706 */     GIR_RootConstrainSelectedInstOperands,
     /*  116707 */     // GIR_Coverage, 102,
     /*  116707 */     GIR_EraseRootFromParent_Done,
     /*  116708 */   // Label 2049: @116708
     /*  116708 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(116776), // Rule ID 254 //
     /*  116713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  116716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_LeadingOnesWMask),
     /*  116732 */     // MIs[1] Operand 1
     /*  116732 */     // No operand predicates
     /*  116732 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10024),
     /*  116736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116738 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs, (imm:{ *:[i64] })<<P:Predicate_LeadingOnesWMask>><<P:Predicate_anonymous_10024>><<X:TrailingZeros>>:$mask)  =>  (SLLI:{ *:[i64] } (SRLIW:{ *:[i64] } ?:{ *:[i64] }:$rs, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] }):$mask))
     /*  116738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  116741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /*  116745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs
     /*  116754 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  116764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116769 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116774 */     GIR_RootConstrainSelectedInstOperands,
     /*  116775 */     // GIR_Coverage, 254,
     /*  116775 */     GIR_EraseRootFromParent_Done,
     /*  116776 */   // Label 2050: @116776
     /*  116776 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(116840), // Rule ID 2490 //
     /*  116781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /*  116784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  116792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  116796 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_Shifted32OnesMask),
     /*  116800 */     // MIs[1] Operand 1
     /*  116800 */     // No operand predicates
     /*  116800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  116802 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>><<X:TrailingZeros>>:$mask)  =>  (SLLI_UW:{ *:[i64] } (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask)), (TrailingZeros:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_Shifted32OnesMask>>:$mask))
     /*  116802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  116805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /*  116809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  116814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /*  116818 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  116825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /*  116828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  116833 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTrailingZeros), // mask
     /*  116838 */     GIR_RootConstrainSelectedInstOperands,
     /*  116839 */     // GIR_Coverage, 2490,
     /*  116839 */     GIR_EraseRootFromParent_Done,
     /*  116840 */   // Label 2051: @116840
     /*  116840 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(116863), // Rule ID 82 //
     /*  116845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  116848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  116856 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AND:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  116856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AND),
     /*  116861 */     GIR_RootConstrainSelectedInstOperands,
     /*  116862 */     // GIR_Coverage, 82,
     /*  116862 */     GIR_Done,
     /*  116863 */   // Label 2052: @116863
     /*  116863 */   GIM_Reject,
     /*  116864 */ // Label 2029: @116864
     /*  116864 */ GIM_Reject,
     /*  116865 */ // Label 1976: @116865
     /*  116865 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(117475),
     /*  116870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  116873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  116876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116880 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(116946), // Rule ID 71333 //
     /*  116885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  116888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  116892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  116896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  116900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  116904 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  116908 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  116912 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  116916 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  116927 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  116927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  116930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  116934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  116938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  116941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  116944 */     GIR_RootConstrainSelectedInstOperands,
     /*  116945 */     // GIR_Coverage, 71333,
     /*  116945 */     GIR_EraseRootFromParent_Done,
     /*  116946 */   // Label 2054: @116946
     /*  116946 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(117012), // Rule ID 71334 //
     /*  116951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  116954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  116958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  116962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  116966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  116970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  116974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  116978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  116982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  116991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  116993 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  116993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  116996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  116998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  117000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  117004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117010 */     GIR_RootConstrainSelectedInstOperands,
     /*  117011 */     // GIR_Coverage, 71334,
     /*  117011 */     GIR_EraseRootFromParent_Done,
     /*  117012 */   // Label 2055: @117012
     /*  117012 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(117078), // Rule ID 71331 //
     /*  117017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  117024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  117045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  117053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117059 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  117059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  117066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  117070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117076 */     GIR_RootConstrainSelectedInstOperands,
     /*  117077 */     // GIR_Coverage, 71331,
     /*  117077 */     GIR_EraseRootFromParent_Done,
     /*  117078 */   // Label 2056: @117078
     /*  117078 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(117144), // Rule ID 71332 //
     /*  117083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  117090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  117111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  117119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117125 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  117125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  117132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  117136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117142 */     GIR_RootConstrainSelectedInstOperands,
     /*  117143 */     // GIR_Coverage, 71332,
     /*  117143 */     GIR_EraseRootFromParent_Done,
     /*  117144 */   // Label 2057: @117144
     /*  117144 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(117210), // Rule ID 71329 //
     /*  117149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  117160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117168 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  117176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  117184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117191 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  117191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  117202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117208 */     GIR_RootConstrainSelectedInstOperands,
     /*  117209 */     // GIR_Coverage, 71329,
     /*  117209 */     GIR_EraseRootFromParent_Done,
     /*  117210 */   // Label 2058: @117210
     /*  117210 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(117276), // Rule ID 71330 //
     /*  117215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  117226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  117242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  117250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117257 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  117257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  117268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117274 */     GIR_RootConstrainSelectedInstOperands,
     /*  117275 */     // GIR_Coverage, 71330,
     /*  117275 */     GIR_EraseRootFromParent_Done,
     /*  117276 */   // Label 2059: @117276
     /*  117276 */   GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(117342), // Rule ID 53046 //
     /*  117281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  117292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  117313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  117321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117323 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  117323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117328 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  117334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117340 */     GIR_RootConstrainSelectedInstOperands,
     /*  117341 */     // GIR_Coverage, 53046,
     /*  117341 */     GIR_EraseRootFromParent_Done,
     /*  117342 */   // Label 2060: @117342
     /*  117342 */   GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(117408), // Rule ID 53047 //
     /*  117347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  117358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  117366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  117370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  117379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  117387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117389 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  117389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  117392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  117400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117406 */     GIR_RootConstrainSelectedInstOperands,
     /*  117407 */     // GIR_Coverage, 53047,
     /*  117407 */     GIR_EraseRootFromParent_Done,
     /*  117408 */   // Label 2061: @117408
     /*  117408 */   GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(117441), // Rule ID 53034 //
     /*  117413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117424 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  117424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  117427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117439 */     GIR_RootConstrainSelectedInstOperands,
     /*  117440 */     // GIR_Coverage, 53034,
     /*  117440 */     GIR_EraseRootFromParent_Done,
     /*  117441 */   // Label 2062: @117441
     /*  117441 */   GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(117474), // Rule ID 53035 //
     /*  117446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117457 */     // (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  117457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  117460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  117472 */     GIR_RootConstrainSelectedInstOperands,
     /*  117473 */     // GIR_Coverage, 53035,
     /*  117473 */     GIR_EraseRootFromParent_Done,
     /*  117474 */   // Label 2063: @117474
     /*  117474 */   GIM_Reject,
     /*  117475 */ // Label 2053: @117475
     /*  117475 */ GIM_Reject,
     /*  117476 */ // Label 1977: @117476
     /*  117476 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(117590),
     /*  117481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  117484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  117487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117499 */   GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(117544), // Rule ID 47526 //
     /*  117504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117507 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  117507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  117510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  117524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117542 */     GIR_RootConstrainSelectedInstOperands,
     /*  117543 */     // GIR_Coverage, 47526,
     /*  117543 */     GIR_EraseRootFromParent_Done,
     /*  117544 */   // Label 2065: @117544
     /*  117544 */   GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(117589), // Rule ID 47527 //
     /*  117549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117552 */     // (and:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  117552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  117555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  117569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117587 */     GIR_RootConstrainSelectedInstOperands,
     /*  117588 */     // GIR_Coverage, 47527,
     /*  117588 */     GIR_EraseRootFromParent_Done,
     /*  117589 */   // Label 2066: @117589
     /*  117589 */   GIM_Reject,
     /*  117590 */ // Label 2064: @117590
     /*  117590 */ GIM_Reject,
     /*  117591 */ // Label 1978: @117591
     /*  117591 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(117705),
     /*  117596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  117599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  117602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117614 */   GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(117659), // Rule ID 47538 //
     /*  117619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117622 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  117622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  117625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  117639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117657 */     GIR_RootConstrainSelectedInstOperands,
     /*  117658 */     // GIR_Coverage, 47538,
     /*  117658 */     GIR_EraseRootFromParent_Done,
     /*  117659 */   // Label 2068: @117659
     /*  117659 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(117704), // Rule ID 47539 //
     /*  117664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117667 */     // (and:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  117667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  117670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  117684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  117699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117702 */     GIR_RootConstrainSelectedInstOperands,
     /*  117703 */     // GIR_Coverage, 47539,
     /*  117703 */     GIR_EraseRootFromParent_Done,
     /*  117704 */   // Label 2069: @117704
     /*  117704 */   GIM_Reject,
     /*  117705 */ // Label 2067: @117705
     /*  117705 */ GIM_Reject,
     /*  117706 */ // Label 1979: @117706
     /*  117706 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(117820),
     /*  117711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  117714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  117717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117729 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(117774), // Rule ID 47546 //
     /*  117734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117737 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  117737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  117740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  117754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117772 */     GIR_RootConstrainSelectedInstOperands,
     /*  117773 */     // GIR_Coverage, 47546,
     /*  117773 */     GIR_EraseRootFromParent_Done,
     /*  117774 */   // Label 2071: @117774
     /*  117774 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(117819), // Rule ID 47547 //
     /*  117779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  117782 */     // (and:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  117782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  117785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  117799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  117814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117817 */     GIR_RootConstrainSelectedInstOperands,
     /*  117818 */     // GIR_Coverage, 47547,
     /*  117818 */     GIR_EraseRootFromParent_Done,
     /*  117819 */   // Label 2072: @117819
     /*  117819 */   GIM_Reject,
     /*  117820 */ // Label 2070: @117820
     /*  117820 */ GIM_Reject,
     /*  117821 */ // Label 1980: @117821
     /*  117821 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(117935),
     /*  117826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  117829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  117832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117844 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(117889), // Rule ID 47562 //
     /*  117849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  117852 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  117852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  117855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  117869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117887 */     GIR_RootConstrainSelectedInstOperands,
     /*  117888 */     // GIR_Coverage, 47562,
     /*  117888 */     GIR_EraseRootFromParent_Done,
     /*  117889 */   // Label 2074: @117889
     /*  117889 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(117934), // Rule ID 47563 //
     /*  117894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  117897 */     // (and:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  117897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  117900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  117904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  117909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  117911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  117914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  117916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  117919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  117921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  117923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  117926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  117929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  117932 */     GIR_RootConstrainSelectedInstOperands,
     /*  117933 */     // GIR_Coverage, 47563,
     /*  117933 */     GIR_EraseRootFromParent_Done,
     /*  117934 */   // Label 2075: @117934
     /*  117934 */   GIM_Reject,
     /*  117935 */ // Label 2073: @117935
     /*  117935 */ GIM_Reject,
     /*  117936 */ // Label 1981: @117936
     /*  117936 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(118546),
     /*  117941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  117944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  117947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117951 */   GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(118017), // Rule ID 71361 //
     /*  117956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  117959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  117963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  117967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  117971 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  117975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  117979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  117983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  117987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  117996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  117998 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  117998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  118009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118015 */     GIR_RootConstrainSelectedInstOperands,
     /*  118016 */     // GIR_Coverage, 71361,
     /*  118016 */     GIR_EraseRootFromParent_Done,
     /*  118017 */   // Label 2077: @118017
     /*  118017 */   GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(118083), // Rule ID 71362 //
     /*  118022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118064 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  118064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  118075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118081 */     GIR_RootConstrainSelectedInstOperands,
     /*  118082 */     // GIR_Coverage, 71362,
     /*  118082 */     GIR_EraseRootFromParent_Done,
     /*  118083 */   // Label 2078: @118083
     /*  118083 */   GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(118149), // Rule ID 71359 //
     /*  118088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  118124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118130 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  118130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  118141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118147 */     GIR_RootConstrainSelectedInstOperands,
     /*  118148 */     // GIR_Coverage, 71359,
     /*  118148 */     GIR_EraseRootFromParent_Done,
     /*  118149 */   // Label 2079: @118149
     /*  118149 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(118215), // Rule ID 71360 //
     /*  118154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  118161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118196 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  118196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  118203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  118207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118213 */     GIR_RootConstrainSelectedInstOperands,
     /*  118214 */     // GIR_Coverage, 71360,
     /*  118214 */     GIR_EraseRootFromParent_Done,
     /*  118215 */   // Label 2080: @118215
     /*  118215 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(118281), // Rule ID 71357 //
     /*  118220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  118255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118260 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118262 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  118262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  118273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118279 */     GIR_RootConstrainSelectedInstOperands,
     /*  118280 */     // GIR_Coverage, 71357,
     /*  118280 */     GIR_EraseRootFromParent_Done,
     /*  118281 */   // Label 2081: @118281
     /*  118281 */   GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(118347), // Rule ID 71358 //
     /*  118286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  118313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118328 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  118328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  118339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118345 */     GIR_RootConstrainSelectedInstOperands,
     /*  118346 */     // GIR_Coverage, 71358,
     /*  118346 */     GIR_EraseRootFromParent_Done,
     /*  118347 */   // Label 2082: @118347
     /*  118347 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(118413), // Rule ID 53064 //
     /*  118352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  118392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118394 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  118394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  118405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118411 */     GIR_RootConstrainSelectedInstOperands,
     /*  118412 */     // GIR_Coverage, 53064,
     /*  118412 */     GIR_EraseRootFromParent_Done,
     /*  118413 */   // Label 2083: @118413
     /*  118413 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(118479), // Rule ID 53065 //
     /*  118418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  118429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  118433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  118437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  118441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  118450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  118454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  118458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  118460 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  118460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  118463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  118471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118477 */     GIR_RootConstrainSelectedInstOperands,
     /*  118478 */     // GIR_Coverage, 53065,
     /*  118478 */     GIR_EraseRootFromParent_Done,
     /*  118479 */   // Label 2084: @118479
     /*  118479 */   GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(118512), // Rule ID 53052 //
     /*  118484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118495 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  118495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  118498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118510 */     GIR_RootConstrainSelectedInstOperands,
     /*  118511 */     // GIR_Coverage, 53052,
     /*  118511 */     GIR_EraseRootFromParent_Done,
     /*  118512 */   // Label 2085: @118512
     /*  118512 */   GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(118545), // Rule ID 53053 //
     /*  118517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118528 */     // (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  118528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  118531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  118543 */     GIR_RootConstrainSelectedInstOperands,
     /*  118544 */     // GIR_Coverage, 53053,
     /*  118544 */     GIR_EraseRootFromParent_Done,
     /*  118545 */   // Label 2086: @118545
     /*  118545 */   GIM_Reject,
     /*  118546 */ // Label 2076: @118546
     /*  118546 */ GIM_Reject,
     /*  118547 */ // Label 1982: @118547
     /*  118547 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(118661),
     /*  118552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  118555 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  118558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118566 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118570 */   GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(118615), // Rule ID 47530 //
     /*  118575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118578 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  118578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  118581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  118595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118613 */     GIR_RootConstrainSelectedInstOperands,
     /*  118614 */     // GIR_Coverage, 47530,
     /*  118614 */     GIR_EraseRootFromParent_Done,
     /*  118615 */   // Label 2088: @118615
     /*  118615 */   GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(118660), // Rule ID 47531 //
     /*  118620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118623 */     // (and:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  118623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  118626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  118640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118658 */     GIR_RootConstrainSelectedInstOperands,
     /*  118659 */     // GIR_Coverage, 47531,
     /*  118659 */     GIR_EraseRootFromParent_Done,
     /*  118660 */   // Label 2089: @118660
     /*  118660 */   GIM_Reject,
     /*  118661 */ // Label 2087: @118661
     /*  118661 */ GIM_Reject,
     /*  118662 */ // Label 1983: @118662
     /*  118662 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(118776),
     /*  118667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  118670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  118673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118681 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118685 */   GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(118730), // Rule ID 47542 //
     /*  118690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118693 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  118693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  118696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  118710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118728 */     GIR_RootConstrainSelectedInstOperands,
     /*  118729 */     // GIR_Coverage, 47542,
     /*  118729 */     GIR_EraseRootFromParent_Done,
     /*  118730 */   // Label 2091: @118730
     /*  118730 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(118775), // Rule ID 47543 //
     /*  118735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118738 */     // (and:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  118738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  118741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  118755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  118770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118773 */     GIR_RootConstrainSelectedInstOperands,
     /*  118774 */     // GIR_Coverage, 47543,
     /*  118774 */     GIR_EraseRootFromParent_Done,
     /*  118775 */   // Label 2092: @118775
     /*  118775 */   GIM_Reject,
     /*  118776 */ // Label 2090: @118776
     /*  118776 */ GIM_Reject,
     /*  118777 */ // Label 1984: @118777
     /*  118777 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(118891),
     /*  118782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  118785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  118788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118796 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  118800 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(118845), // Rule ID 47558 //
     /*  118805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  118808 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  118808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  118811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  118825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118843 */     GIR_RootConstrainSelectedInstOperands,
     /*  118844 */     // GIR_Coverage, 47558,
     /*  118844 */     GIR_EraseRootFromParent_Done,
     /*  118845 */   // Label 2094: @118845
     /*  118845 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(118890), // Rule ID 47559 //
     /*  118850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  118853 */     // (and:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  118853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  118856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  118870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  118885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118888 */     GIR_RootConstrainSelectedInstOperands,
     /*  118889 */     // GIR_Coverage, 47559,
     /*  118889 */     GIR_EraseRootFromParent_Done,
     /*  118890 */   // Label 2095: @118890
     /*  118890 */   GIM_Reject,
     /*  118891 */ // Label 2093: @118891
     /*  118891 */ GIM_Reject,
     /*  118892 */ // Label 1985: @118892
     /*  118892 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(119006),
     /*  118897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  118900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  118903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  118915 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(118960), // Rule ID 47602 //
     /*  118920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  118923 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  118923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  118926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  118940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  118955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  118958 */     GIR_RootConstrainSelectedInstOperands,
     /*  118959 */     // GIR_Coverage, 47602,
     /*  118959 */     GIR_EraseRootFromParent_Done,
     /*  118960 */   // Label 2097: @118960
     /*  118960 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(119005), // Rule ID 47603 //
     /*  118965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  118968 */     // (and:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  118968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  118971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  118975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  118980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  118982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  118985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  118987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  118990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  118992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  118994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  118997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  119000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119003 */     GIR_RootConstrainSelectedInstOperands,
     /*  119004 */     // GIR_Coverage, 47603,
     /*  119004 */     GIR_EraseRootFromParent_Done,
     /*  119005 */   // Label 2098: @119005
     /*  119005 */   GIM_Reject,
     /*  119006 */ // Label 2096: @119006
     /*  119006 */ GIM_Reject,
     /*  119007 */ // Label 1986: @119007
     /*  119007 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(119617),
     /*  119012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119022 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(119088), // Rule ID 71389 //
     /*  119027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119069 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  119069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119086 */     GIR_RootConstrainSelectedInstOperands,
     /*  119087 */     // GIR_Coverage, 71389,
     /*  119087 */     GIR_EraseRootFromParent_Done,
     /*  119088 */   // Label 2100: @119088
     /*  119088 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(119154), // Rule ID 71390 //
     /*  119093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119135 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  119135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119152 */     GIR_RootConstrainSelectedInstOperands,
     /*  119153 */     // GIR_Coverage, 71390,
     /*  119153 */     GIR_EraseRootFromParent_Done,
     /*  119154 */   // Label 2101: @119154
     /*  119154 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(119220), // Rule ID 71387 //
     /*  119159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119201 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  119201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119218 */     GIR_RootConstrainSelectedInstOperands,
     /*  119219 */     // GIR_Coverage, 71387,
     /*  119219 */     GIR_EraseRootFromParent_Done,
     /*  119220 */   // Label 2102: @119220
     /*  119220 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(119286), // Rule ID 71388 //
     /*  119225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  119232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119267 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  119267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  119274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119284 */     GIR_RootConstrainSelectedInstOperands,
     /*  119285 */     // GIR_Coverage, 71388,
     /*  119285 */     GIR_EraseRootFromParent_Done,
     /*  119286 */   // Label 2103: @119286
     /*  119286 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(119352), // Rule ID 71385 //
     /*  119291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119333 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  119333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119338 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119350 */     GIR_RootConstrainSelectedInstOperands,
     /*  119351 */     // GIR_Coverage, 71385,
     /*  119351 */     GIR_EraseRootFromParent_Done,
     /*  119352 */   // Label 2104: @119352
     /*  119352 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(119418), // Rule ID 71386 //
     /*  119357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  119384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119399 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  119399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  119410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119416 */     GIR_RootConstrainSelectedInstOperands,
     /*  119417 */     // GIR_Coverage, 71386,
     /*  119417 */     GIR_EraseRootFromParent_Done,
     /*  119418 */   // Label 2105: @119418
     /*  119418 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(119484), // Rule ID 53082 //
     /*  119423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  119463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119465 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  119465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119482 */     GIR_RootConstrainSelectedInstOperands,
     /*  119483 */     // GIR_Coverage, 53082,
     /*  119483 */     GIR_EraseRootFromParent_Done,
     /*  119484 */   // Label 2106: @119484
     /*  119484 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(119550), // Rule ID 53083 //
     /*  119489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  119500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  119504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  119508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  119512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  119521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  119525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  119529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  119531 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  119531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  119534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  119542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119548 */     GIR_RootConstrainSelectedInstOperands,
     /*  119549 */     // GIR_Coverage, 53083,
     /*  119549 */     GIR_EraseRootFromParent_Done,
     /*  119550 */   // Label 2107: @119550
     /*  119550 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(119583), // Rule ID 53070 //
     /*  119555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119566 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  119566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  119569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119581 */     GIR_RootConstrainSelectedInstOperands,
     /*  119582 */     // GIR_Coverage, 53070,
     /*  119582 */     GIR_EraseRootFromParent_Done,
     /*  119583 */   // Label 2108: @119583
     /*  119583 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(119616), // Rule ID 53071 //
     /*  119588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119599 */     // (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  119599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  119602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  119614 */     GIR_RootConstrainSelectedInstOperands,
     /*  119615 */     // GIR_Coverage, 53071,
     /*  119615 */     GIR_EraseRootFromParent_Done,
     /*  119616 */   // Label 2109: @119616
     /*  119616 */   GIM_Reject,
     /*  119617 */ // Label 2099: @119617
     /*  119617 */ GIM_Reject,
     /*  119618 */ // Label 1987: @119618
     /*  119618 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(119732),
     /*  119623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  119626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  119629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119641 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(119686), // Rule ID 47534 //
     /*  119646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119649 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  119649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  119652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  119666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119684 */     GIR_RootConstrainSelectedInstOperands,
     /*  119685 */     // GIR_Coverage, 47534,
     /*  119685 */     GIR_EraseRootFromParent_Done,
     /*  119686 */   // Label 2111: @119686
     /*  119686 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(119731), // Rule ID 47535 //
     /*  119691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119694 */     // (and:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  119694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  119697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  119711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119729 */     GIR_RootConstrainSelectedInstOperands,
     /*  119730 */     // GIR_Coverage, 47535,
     /*  119730 */     GIR_EraseRootFromParent_Done,
     /*  119731 */   // Label 2112: @119731
     /*  119731 */   GIM_Reject,
     /*  119732 */ // Label 2110: @119732
     /*  119732 */ GIM_Reject,
     /*  119733 */ // Label 1988: @119733
     /*  119733 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(119847),
     /*  119738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  119741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  119744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  119756 */   GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(119801), // Rule ID 47554 //
     /*  119761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119764 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  119764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  119767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  119781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119799 */     GIR_RootConstrainSelectedInstOperands,
     /*  119800 */     // GIR_Coverage, 47554,
     /*  119800 */     GIR_EraseRootFromParent_Done,
     /*  119801 */   // Label 2114: @119801
     /*  119801 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(119846), // Rule ID 47555 //
     /*  119806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119809 */     // (and:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  119809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  119812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  119826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119828 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  119841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119844 */     GIR_RootConstrainSelectedInstOperands,
     /*  119845 */     // GIR_Coverage, 47555,
     /*  119845 */     GIR_EraseRootFromParent_Done,
     /*  119846 */   // Label 2115: @119846
     /*  119846 */   GIM_Reject,
     /*  119847 */ // Label 2113: @119847
     /*  119847 */ GIM_Reject,
     /*  119848 */ // Label 1989: @119848
     /*  119848 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(119962),
     /*  119853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  119856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  119859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  119871 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(119916), // Rule ID 47590 //
     /*  119876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  119879 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  119879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  119882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  119896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119914 */     GIR_RootConstrainSelectedInstOperands,
     /*  119915 */     // GIR_Coverage, 47590,
     /*  119915 */     GIR_EraseRootFromParent_Done,
     /*  119916 */   // Label 2117: @119916
     /*  119916 */   GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(119961), // Rule ID 47591 //
     /*  119921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  119924 */     // (and:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  119924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  119927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  119931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  119936 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  119938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  119941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  119943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  119946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  119948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  119950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  119953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  119956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  119959 */     GIR_RootConstrainSelectedInstOperands,
     /*  119960 */     // GIR_Coverage, 47591,
     /*  119960 */     GIR_EraseRootFromParent_Done,
     /*  119961 */   // Label 2118: @119961
     /*  119961 */   GIM_Reject,
     /*  119962 */ // Label 2116: @119962
     /*  119962 */ GIM_Reject,
     /*  119963 */ // Label 1990: @119963
     /*  119963 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(120077),
     /*  119968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  119971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  119974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  119986 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(120031), // Rule ID 47606 //
     /*  119991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  119994 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  119994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  119997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  120011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120029 */     GIR_RootConstrainSelectedInstOperands,
     /*  120030 */     // GIR_Coverage, 47606,
     /*  120030 */     GIR_EraseRootFromParent_Done,
     /*  120031 */   // Label 2120: @120031
     /*  120031 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(120076), // Rule ID 47607 //
     /*  120036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  120039 */     // (and:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  120039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  120042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  120056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  120071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120074 */     GIR_RootConstrainSelectedInstOperands,
     /*  120075 */     // GIR_Coverage, 47607,
     /*  120075 */     GIR_EraseRootFromParent_Done,
     /*  120076 */   // Label 2121: @120076
     /*  120076 */   GIM_Reject,
     /*  120077 */ // Label 2119: @120077
     /*  120077 */ GIM_Reject,
     /*  120078 */ // Label 1991: @120078
     /*  120078 */ GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(120688),
     /*  120083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120093 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(120159), // Rule ID 71417 //
     /*  120098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120140 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  120140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120157 */     GIR_RootConstrainSelectedInstOperands,
     /*  120158 */     // GIR_Coverage, 71417,
     /*  120158 */     GIR_EraseRootFromParent_Done,
     /*  120159 */   // Label 2123: @120159
     /*  120159 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(120225), // Rule ID 71418 //
     /*  120164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  120195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120206 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  120206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120223 */     GIR_RootConstrainSelectedInstOperands,
     /*  120224 */     // GIR_Coverage, 71418,
     /*  120224 */     GIR_EraseRootFromParent_Done,
     /*  120225 */   // Label 2124: @120225
     /*  120225 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(120291), // Rule ID 71415 //
     /*  120230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120272 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  120272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120289 */     GIR_RootConstrainSelectedInstOperands,
     /*  120290 */     // GIR_Coverage, 71415,
     /*  120290 */     GIR_EraseRootFromParent_Done,
     /*  120291 */   // Label 2125: @120291
     /*  120291 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(120357), // Rule ID 71416 //
     /*  120296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  120303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  120332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120338 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  120338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  120345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120355 */     GIR_RootConstrainSelectedInstOperands,
     /*  120356 */     // GIR_Coverage, 71416,
     /*  120356 */     GIR_EraseRootFromParent_Done,
     /*  120357 */   // Label 2126: @120357
     /*  120357 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(120423), // Rule ID 71413 //
     /*  120362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120404 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  120404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120421 */     GIR_RootConstrainSelectedInstOperands,
     /*  120422 */     // GIR_Coverage, 71413,
     /*  120422 */     GIR_EraseRootFromParent_Done,
     /*  120423 */   // Label 2127: @120423
     /*  120423 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(120489), // Rule ID 71414 //
     /*  120428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  120455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  120463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120470 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  120470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  120481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120487 */     GIR_RootConstrainSelectedInstOperands,
     /*  120488 */     // GIR_Coverage, 71414,
     /*  120488 */     GIR_EraseRootFromParent_Done,
     /*  120489 */   // Label 2128: @120489
     /*  120489 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(120555), // Rule ID 53100 //
     /*  120494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  120534 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120536 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  120536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120553 */     GIR_RootConstrainSelectedInstOperands,
     /*  120554 */     // GIR_Coverage, 53100,
     /*  120554 */     GIR_EraseRootFromParent_Done,
     /*  120555 */   // Label 2129: @120555
     /*  120555 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(120621), // Rule ID 53101 //
     /*  120560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  120571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  120575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  120579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  120583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  120592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  120596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  120600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  120602 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  120602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  120605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  120613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120619 */     GIR_RootConstrainSelectedInstOperands,
     /*  120620 */     // GIR_Coverage, 53101,
     /*  120620 */     GIR_EraseRootFromParent_Done,
     /*  120621 */   // Label 2130: @120621
     /*  120621 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(120654), // Rule ID 53088 //
     /*  120626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120637 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  120637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  120640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120652 */     GIR_RootConstrainSelectedInstOperands,
     /*  120653 */     // GIR_Coverage, 53088,
     /*  120653 */     GIR_EraseRootFromParent_Done,
     /*  120654 */   // Label 2131: @120654
     /*  120654 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(120687), // Rule ID 53089 //
     /*  120659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120670 */     // (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  120670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  120673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  120685 */     GIR_RootConstrainSelectedInstOperands,
     /*  120686 */     // GIR_Coverage, 53089,
     /*  120686 */     GIR_EraseRootFromParent_Done,
     /*  120687 */   // Label 2132: @120687
     /*  120687 */   GIM_Reject,
     /*  120688 */ // Label 2122: @120688
     /*  120688 */ GIM_Reject,
     /*  120689 */ // Label 1992: @120689
     /*  120689 */ GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(120803),
     /*  120694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  120697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  120700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  120712 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(120757), // Rule ID 47550 //
     /*  120717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120720 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  120720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  120723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  120737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120755 */     GIR_RootConstrainSelectedInstOperands,
     /*  120756 */     // GIR_Coverage, 47550,
     /*  120756 */     GIR_EraseRootFromParent_Done,
     /*  120757 */   // Label 2134: @120757
     /*  120757 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(120802), // Rule ID 47551 //
     /*  120762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120765 */     // (and:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  120765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  120768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  120782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120800 */     GIR_RootConstrainSelectedInstOperands,
     /*  120801 */     // GIR_Coverage, 47551,
     /*  120801 */     GIR_EraseRootFromParent_Done,
     /*  120802 */   // Label 2135: @120802
     /*  120802 */   GIM_Reject,
     /*  120803 */ // Label 2133: @120803
     /*  120803 */ GIM_Reject,
     /*  120804 */ // Label 1993: @120804
     /*  120804 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(120918),
     /*  120809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  120812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  120815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  120827 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(120872), // Rule ID 47578 //
     /*  120832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120835 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  120835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  120838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  120852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120857 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120870 */     GIR_RootConstrainSelectedInstOperands,
     /*  120871 */     // GIR_Coverage, 47578,
     /*  120871 */     GIR_EraseRootFromParent_Done,
     /*  120872 */   // Label 2137: @120872
     /*  120872 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(120917), // Rule ID 47579 //
     /*  120877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120880 */     // (and:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  120880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  120883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  120897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120902 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  120912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120915 */     GIR_RootConstrainSelectedInstOperands,
     /*  120916 */     // GIR_Coverage, 47579,
     /*  120916 */     GIR_EraseRootFromParent_Done,
     /*  120917 */   // Label 2138: @120917
     /*  120917 */   GIM_Reject,
     /*  120918 */ // Label 2136: @120918
     /*  120918 */ GIM_Reject,
     /*  120919 */ // Label 1994: @120919
     /*  120919 */ GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(121033),
     /*  120924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  120927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  120930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  120942 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(120987), // Rule ID 47594 //
     /*  120947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  120950 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  120950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  120953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  120957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  120962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  120964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  120967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  120969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  120972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  120974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  120976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  120979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  120982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  120985 */     GIR_RootConstrainSelectedInstOperands,
     /*  120986 */     // GIR_Coverage, 47594,
     /*  120986 */     GIR_EraseRootFromParent_Done,
     /*  120987 */   // Label 2140: @120987
     /*  120987 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(121032), // Rule ID 47595 //
     /*  120992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  120995 */     // (and:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  120995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  120998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  121012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  121027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121030 */     GIR_RootConstrainSelectedInstOperands,
     /*  121031 */     // GIR_Coverage, 47595,
     /*  121031 */     GIR_EraseRootFromParent_Done,
     /*  121032 */   // Label 2141: @121032
     /*  121032 */   GIM_Reject,
     /*  121033 */ // Label 2139: @121033
     /*  121033 */ GIM_Reject,
     /*  121034 */ // Label 1995: @121034
     /*  121034 */ GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(121148),
     /*  121039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  121042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  121045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  121057 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(121102), // Rule ID 47610 //
     /*  121062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  121065 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  121065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  121068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  121082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  121097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121100 */     GIR_RootConstrainSelectedInstOperands,
     /*  121101 */     // GIR_Coverage, 47610,
     /*  121101 */     GIR_EraseRootFromParent_Done,
     /*  121102 */   // Label 2143: @121102
     /*  121102 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(121147), // Rule ID 47611 //
     /*  121107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  121110 */     // (and:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  121110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  121113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  121127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  121142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121145 */     GIR_RootConstrainSelectedInstOperands,
     /*  121146 */     // GIR_Coverage, 47611,
     /*  121146 */     GIR_EraseRootFromParent_Done,
     /*  121147 */   // Label 2144: @121147
     /*  121147 */   GIM_Reject,
     /*  121148 */ // Label 2142: @121148
     /*  121148 */ GIM_Reject,
     /*  121149 */ // Label 1996: @121149
     /*  121149 */ GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(121759),
     /*  121154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121164 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(121230), // Rule ID 71445 //
     /*  121169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121211 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121228 */     GIR_RootConstrainSelectedInstOperands,
     /*  121229 */     // GIR_Coverage, 71445,
     /*  121229 */     GIR_EraseRootFromParent_Done,
     /*  121230 */   // Label 2146: @121230
     /*  121230 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(121296), // Rule ID 71446 //
     /*  121235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121277 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121294 */     GIR_RootConstrainSelectedInstOperands,
     /*  121295 */     // GIR_Coverage, 71446,
     /*  121295 */     GIR_EraseRootFromParent_Done,
     /*  121296 */   // Label 2147: @121296
     /*  121296 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(121362), // Rule ID 71443 //
     /*  121301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121343 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121360 */     GIR_RootConstrainSelectedInstOperands,
     /*  121361 */     // GIR_Coverage, 71443,
     /*  121361 */     GIR_EraseRootFromParent_Done,
     /*  121362 */   // Label 2148: @121362
     /*  121362 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(121428), // Rule ID 71444 //
     /*  121367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  121374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121409 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  121416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121426 */     GIR_RootConstrainSelectedInstOperands,
     /*  121427 */     // GIR_Coverage, 71444,
     /*  121427 */     GIR_EraseRootFromParent_Done,
     /*  121428 */   // Label 2149: @121428
     /*  121428 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(121494), // Rule ID 71441 //
     /*  121433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121475 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121492 */     GIR_RootConstrainSelectedInstOperands,
     /*  121493 */     // GIR_Coverage, 71441,
     /*  121493 */     GIR_EraseRootFromParent_Done,
     /*  121494 */   // Label 2150: @121494
     /*  121494 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(121560), // Rule ID 71442 //
     /*  121499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  121526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121541 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  121552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121558 */     GIR_RootConstrainSelectedInstOperands,
     /*  121559 */     // GIR_Coverage, 71442,
     /*  121559 */     GIR_EraseRootFromParent_Done,
     /*  121560 */   // Label 2151: @121560
     /*  121560 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(121626), // Rule ID 53118 //
     /*  121565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  121605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121607 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121624 */     GIR_RootConstrainSelectedInstOperands,
     /*  121625 */     // GIR_Coverage, 53118,
     /*  121625 */     GIR_EraseRootFromParent_Done,
     /*  121626 */   // Label 2152: @121626
     /*  121626 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(121692), // Rule ID 53119 //
     /*  121631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  121642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  121646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  121650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  121654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  121663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  121667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  121671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  121673 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  121676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  121684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121690 */     GIR_RootConstrainSelectedInstOperands,
     /*  121691 */     // GIR_Coverage, 53119,
     /*  121691 */     GIR_EraseRootFromParent_Done,
     /*  121692 */   // Label 2153: @121692
     /*  121692 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(121725), // Rule ID 53106 //
     /*  121697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121708 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  121708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  121711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121723 */     GIR_RootConstrainSelectedInstOperands,
     /*  121724 */     // GIR_Coverage, 53106,
     /*  121724 */     GIR_EraseRootFromParent_Done,
     /*  121725 */   // Label 2154: @121725
     /*  121725 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(121758), // Rule ID 53107 //
     /*  121730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  121741 */     // (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  121741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  121744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  121756 */     GIR_RootConstrainSelectedInstOperands,
     /*  121757 */     // GIR_Coverage, 53107,
     /*  121757 */     GIR_EraseRootFromParent_Done,
     /*  121758 */   // Label 2155: @121758
     /*  121758 */   GIM_Reject,
     /*  121759 */ // Label 2145: @121759
     /*  121759 */ GIM_Reject,
     /*  121760 */ // Label 1997: @121760
     /*  121760 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(121874),
     /*  121765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  121768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  121771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  121775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  121779 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  121783 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(121828), // Rule ID 47566 //
     /*  121788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121791 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  121791 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  121794 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121798 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  121808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121826 */     GIR_RootConstrainSelectedInstOperands,
     /*  121827 */     // GIR_Coverage, 47566,
     /*  121827 */     GIR_EraseRootFromParent_Done,
     /*  121828 */   // Label 2157: @121828
     /*  121828 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(121873), // Rule ID 47567 //
     /*  121833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121836 */     // (and:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  121836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  121839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  121853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121871 */     GIR_RootConstrainSelectedInstOperands,
     /*  121872 */     // GIR_Coverage, 47567,
     /*  121872 */     GIR_EraseRootFromParent_Done,
     /*  121873 */   // Label 2158: @121873
     /*  121873 */   GIM_Reject,
     /*  121874 */ // Label 2156: @121874
     /*  121874 */ GIM_Reject,
     /*  121875 */ // Label 1998: @121875
     /*  121875 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(121989),
     /*  121880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  121883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  121886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  121890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  121894 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  121898 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(121943), // Rule ID 47582 //
     /*  121903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  121906 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  121906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  121909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  121923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121941 */     GIR_RootConstrainSelectedInstOperands,
     /*  121942 */     // GIR_Coverage, 47582,
     /*  121942 */     GIR_EraseRootFromParent_Done,
     /*  121943 */   // Label 2160: @121943
     /*  121943 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(121988), // Rule ID 47583 //
     /*  121948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  121951 */     // (and:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  121951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  121954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  121958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  121963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  121965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  121968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  121970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  121973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  121975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  121977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  121980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  121983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  121986 */     GIR_RootConstrainSelectedInstOperands,
     /*  121987 */     // GIR_Coverage, 47583,
     /*  121987 */     GIR_EraseRootFromParent_Done,
     /*  121988 */   // Label 2161: @121988
     /*  121988 */   GIM_Reject,
     /*  121989 */ // Label 2159: @121989
     /*  121989 */ GIM_Reject,
     /*  121990 */ // Label 1999: @121990
     /*  121990 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(122104),
     /*  121995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  121998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  122001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122013 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(122058), // Rule ID 47598 //
     /*  122018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122021 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  122021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  122024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  122038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122056 */     GIR_RootConstrainSelectedInstOperands,
     /*  122057 */     // GIR_Coverage, 47598,
     /*  122057 */     GIR_EraseRootFromParent_Done,
     /*  122058 */   // Label 2163: @122058
     /*  122058 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(122103), // Rule ID 47599 //
     /*  122063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122066 */     // (and:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  122066 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  122069 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122073 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  122083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  122098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122101 */     GIR_RootConstrainSelectedInstOperands,
     /*  122102 */     // GIR_Coverage, 47599,
     /*  122102 */     GIR_EraseRootFromParent_Done,
     /*  122103 */   // Label 2164: @122103
     /*  122103 */   GIM_Reject,
     /*  122104 */ // Label 2162: @122104
     /*  122104 */ GIM_Reject,
     /*  122105 */ // Label 2000: @122105
     /*  122105 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(122715),
     /*  122110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122120 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(122186), // Rule ID 71473 //
     /*  122125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122144 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122148 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122152 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122167 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122184 */     GIR_RootConstrainSelectedInstOperands,
     /*  122185 */     // GIR_Coverage, 71473,
     /*  122185 */     GIR_EraseRootFromParent_Done,
     /*  122186 */   // Label 2166: @122186
     /*  122186 */   GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(122252), // Rule ID 71474 //
     /*  122191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122233 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122250 */     GIR_RootConstrainSelectedInstOperands,
     /*  122251 */     // GIR_Coverage, 71474,
     /*  122251 */     GIR_EraseRootFromParent_Done,
     /*  122252 */   // Label 2167: @122252
     /*  122252 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(122318), // Rule ID 71471 //
     /*  122257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122299 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122316 */     GIR_RootConstrainSelectedInstOperands,
     /*  122317 */     // GIR_Coverage, 71471,
     /*  122317 */     GIR_EraseRootFromParent_Done,
     /*  122318 */   // Label 2168: @122318
     /*  122318 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(122384), // Rule ID 71472 //
     /*  122323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122365 */     // (and:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  122372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122382 */     GIR_RootConstrainSelectedInstOperands,
     /*  122383 */     // GIR_Coverage, 71472,
     /*  122383 */     GIR_EraseRootFromParent_Done,
     /*  122384 */   // Label 2169: @122384
     /*  122384 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(122450), // Rule ID 71469 //
     /*  122389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122431 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122448 */     GIR_RootConstrainSelectedInstOperands,
     /*  122449 */     // GIR_Coverage, 71469,
     /*  122449 */     GIR_EraseRootFromParent_Done,
     /*  122450 */   // Label 2170: @122450
     /*  122450 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(122516), // Rule ID 71470 //
     /*  122455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122490 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122495 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122497 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  122508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122514 */     GIR_RootConstrainSelectedInstOperands,
     /*  122515 */     // GIR_Coverage, 71470,
     /*  122515 */     GIR_EraseRootFromParent_Done,
     /*  122516 */   // Label 2171: @122516
     /*  122516 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(122582), // Rule ID 53136 //
     /*  122521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122563 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122580 */     GIR_RootConstrainSelectedInstOperands,
     /*  122581 */     // GIR_Coverage, 53136,
     /*  122581 */     GIR_EraseRootFromParent_Done,
     /*  122582 */   // Label 2172: @122582
     /*  122582 */   GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(122648), // Rule ID 53137 //
     /*  122587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  122598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  122606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  122610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  122619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  122627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  122629 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  122632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  122640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122646 */     GIR_RootConstrainSelectedInstOperands,
     /*  122647 */     // GIR_Coverage, 53137,
     /*  122647 */     GIR_EraseRootFromParent_Done,
     /*  122648 */   // Label 2173: @122648
     /*  122648 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(122681), // Rule ID 53124 //
     /*  122653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122664 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  122664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  122667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122679 */     GIR_RootConstrainSelectedInstOperands,
     /*  122680 */     // GIR_Coverage, 53124,
     /*  122680 */     GIR_EraseRootFromParent_Done,
     /*  122681 */   // Label 2174: @122681
     /*  122681 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(122714), // Rule ID 53125 //
     /*  122686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122697 */     // (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  122697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  122700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  122712 */     GIR_RootConstrainSelectedInstOperands,
     /*  122713 */     // GIR_Coverage, 53125,
     /*  122713 */     GIR_EraseRootFromParent_Done,
     /*  122714 */   // Label 2175: @122714
     /*  122714 */   GIM_Reject,
     /*  122715 */ // Label 2165: @122715
     /*  122715 */ GIM_Reject,
     /*  122716 */ // Label 2001: @122716
     /*  122716 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(122830),
     /*  122721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  122724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  122727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  122731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  122735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  122739 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(122784), // Rule ID 47570 //
     /*  122744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122747 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  122747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  122750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  122764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122782 */     GIR_RootConstrainSelectedInstOperands,
     /*  122783 */     // GIR_Coverage, 47570,
     /*  122783 */     GIR_EraseRootFromParent_Done,
     /*  122784 */   // Label 2177: @122784
     /*  122784 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(122829), // Rule ID 47571 //
     /*  122789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122792 */     // (and:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  122792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  122795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  122809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122827 */     GIR_RootConstrainSelectedInstOperands,
     /*  122828 */     // GIR_Coverage, 47571,
     /*  122828 */     GIR_EraseRootFromParent_Done,
     /*  122829 */   // Label 2178: @122829
     /*  122829 */   GIM_Reject,
     /*  122830 */ // Label 2176: @122830
     /*  122830 */ GIM_Reject,
     /*  122831 */ // Label 2002: @122831
     /*  122831 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(122945),
     /*  122836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  122839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  122842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  122854 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(122899), // Rule ID 47586 //
     /*  122859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122862 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  122862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  122865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  122879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122897 */     GIR_RootConstrainSelectedInstOperands,
     /*  122898 */     // GIR_Coverage, 47586,
     /*  122898 */     GIR_EraseRootFromParent_Done,
     /*  122899 */   // Label 2180: @122899
     /*  122899 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(122944), // Rule ID 47587 //
     /*  122904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  122907 */     // (and:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  122907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  122910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  122914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  122919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  122921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  122924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  122926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  122929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  122931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  122933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  122936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  122939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  122942 */     GIR_RootConstrainSelectedInstOperands,
     /*  122943 */     // GIR_Coverage, 47587,
     /*  122943 */     GIR_EraseRootFromParent_Done,
     /*  122944 */   // Label 2181: @122944
     /*  122944 */   GIM_Reject,
     /*  122945 */ // Label 2179: @122945
     /*  122945 */ GIM_Reject,
     /*  122946 */ // Label 2003: @122946
     /*  122946 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(123556),
     /*  122951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  122954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  122957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  122961 */   GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(123027), // Rule ID 71501 //
     /*  122966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  122969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  122973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  122977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  122981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  122985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  122989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  122993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  122997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123008 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123025 */     GIR_RootConstrainSelectedInstOperands,
     /*  123026 */     // GIR_Coverage, 71501,
     /*  123026 */     GIR_EraseRootFromParent_Done,
     /*  123027 */   // Label 2183: @123027
     /*  123027 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(123093), // Rule ID 71502 //
     /*  123032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123074 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123091 */     GIR_RootConstrainSelectedInstOperands,
     /*  123092 */     // GIR_Coverage, 71502,
     /*  123092 */     GIR_EraseRootFromParent_Done,
     /*  123093 */   // Label 2184: @123093
     /*  123093 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(123159), // Rule ID 71499 //
     /*  123098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123140 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123157 */     GIR_RootConstrainSelectedInstOperands,
     /*  123158 */     // GIR_Coverage, 71499,
     /*  123158 */     GIR_EraseRootFromParent_Done,
     /*  123159 */   // Label 2185: @123159
     /*  123159 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(123225), // Rule ID 71500 //
     /*  123164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123188 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123192 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123196 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123204 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123206 */     // (and:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  123213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123223 */     GIR_RootConstrainSelectedInstOperands,
     /*  123224 */     // GIR_Coverage, 71500,
     /*  123224 */     GIR_EraseRootFromParent_Done,
     /*  123225 */   // Label 2186: @123225
     /*  123225 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(123291), // Rule ID 71497 //
     /*  123230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123272 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123277 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123289 */     GIR_RootConstrainSelectedInstOperands,
     /*  123290 */     // GIR_Coverage, 71497,
     /*  123290 */     GIR_EraseRootFromParent_Done,
     /*  123291 */   // Label 2187: @123291
     /*  123291 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(123357), // Rule ID 71498 //
     /*  123296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  123323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123338 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  123349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123355 */     GIR_RootConstrainSelectedInstOperands,
     /*  123356 */     // GIR_Coverage, 71498,
     /*  123356 */     GIR_EraseRootFromParent_Done,
     /*  123357 */   // Label 2188: @123357
     /*  123357 */   GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(123423), // Rule ID 53154 //
     /*  123362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  123402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123404 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123421 */     GIR_RootConstrainSelectedInstOperands,
     /*  123422 */     // GIR_Coverage, 53154,
     /*  123422 */     GIR_EraseRootFromParent_Done,
     /*  123423 */   // Label 2189: @123423
     /*  123423 */   GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(123489), // Rule ID 53155 //
     /*  123428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  123439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  123443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  123447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  123451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  123464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  123470 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  123473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  123481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123487 */     GIR_RootConstrainSelectedInstOperands,
     /*  123488 */     // GIR_Coverage, 53155,
     /*  123488 */     GIR_EraseRootFromParent_Done,
     /*  123489 */   // Label 2190: @123489
     /*  123489 */   GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(123522), // Rule ID 53142 //
     /*  123494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123505 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  123505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  123508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123520 */     GIR_RootConstrainSelectedInstOperands,
     /*  123521 */     // GIR_Coverage, 53142,
     /*  123521 */     GIR_EraseRootFromParent_Done,
     /*  123522 */   // Label 2191: @123522
     /*  123522 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(123555), // Rule ID 53143 //
     /*  123527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  123538 */     // (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  123538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  123541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  123553 */     GIR_RootConstrainSelectedInstOperands,
     /*  123554 */     // GIR_Coverage, 53143,
     /*  123554 */     GIR_EraseRootFromParent_Done,
     /*  123555 */   // Label 2192: @123555
     /*  123555 */   GIM_Reject,
     /*  123556 */ // Label 2182: @123556
     /*  123556 */ GIM_Reject,
     /*  123557 */ // Label 2004: @123557
     /*  123557 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(123671),
     /*  123562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  123565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  123568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  123572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  123576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  123580 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(123625), // Rule ID 47574 //
     /*  123585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  123588 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  123588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  123591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  123605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123623 */     GIR_RootConstrainSelectedInstOperands,
     /*  123624 */     // GIR_Coverage, 47574,
     /*  123624 */     GIR_EraseRootFromParent_Done,
     /*  123625 */   // Label 2194: @123625
     /*  123625 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(123670), // Rule ID 47575 //
     /*  123630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  123633 */     // (and:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  123633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  123636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  123640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  123647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  123650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  123652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  123655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  123657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  123659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  123662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  123668 */     GIR_RootConstrainSelectedInstOperands,
     /*  123669 */     // GIR_Coverage, 47575,
     /*  123669 */     GIR_EraseRootFromParent_Done,
     /*  123670 */   // Label 2195: @123670
     /*  123670 */   GIM_Reject,
     /*  123671 */ // Label 2193: @123671
     /*  123671 */ GIM_Reject,
     /*  123672 */ // Label 2005: @123672
     /*  123672 */ GIM_Reject,
     /*  123673 */ // Label 8: @123673
     /*  123673 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(136293),
     /*  123684 */ /*GILLT_s32*//*Label 2196*/ GIMT_Encode4(123808),
     /*  123688 */ /*GILLT_s64*//*Label 2197*/ GIMT_Encode4(126538),
     /*  123692 */ /*GILLT_nxv1s1*//*Label 2198*/ GIMT_Encode4(129486),
     /*  123696 */ /*GILLT_nxv1s8*//*Label 2199*/ GIMT_Encode4(130097),
     /*  123700 */ /*GILLT_nxv1s16*//*Label 2200*/ GIMT_Encode4(130212),
     /*  123704 */ /*GILLT_nxv1s32*//*Label 2201*/ GIMT_Encode4(130327),
     /*  123708 */ /*GILLT_nxv1s64*//*Label 2202*/ GIMT_Encode4(130442),
     /*  123712 */ /*GILLT_nxv2s1*//*Label 2203*/ GIMT_Encode4(130557),
     /*  123716 */ /*GILLT_nxv2s8*//*Label 2204*/ GIMT_Encode4(131168),
     /*  123720 */ /*GILLT_nxv2s16*//*Label 2205*/ GIMT_Encode4(131283),
     /*  123724 */ /*GILLT_nxv2s32*//*Label 2206*/ GIMT_Encode4(131398),
     /*  123728 */ /*GILLT_nxv2s64*//*Label 2207*/ GIMT_Encode4(131513),
     /*  123732 */ /*GILLT_nxv4s1*//*Label 2208*/ GIMT_Encode4(131628),
     /*  123736 */ /*GILLT_nxv4s8*//*Label 2209*/ GIMT_Encode4(132239),
     /*  123740 */ /*GILLT_nxv4s16*//*Label 2210*/ GIMT_Encode4(132354),
     /*  123744 */ /*GILLT_nxv4s32*//*Label 2211*/ GIMT_Encode4(132469),
     /*  123748 */ /*GILLT_nxv4s64*//*Label 2212*/ GIMT_Encode4(132584),
     /*  123752 */ /*GILLT_nxv8s1*//*Label 2213*/ GIMT_Encode4(132699),
     /*  123756 */ /*GILLT_nxv8s8*//*Label 2214*/ GIMT_Encode4(133310),
     /*  123760 */ /*GILLT_nxv8s16*//*Label 2215*/ GIMT_Encode4(133425),
     /*  123764 */ /*GILLT_nxv8s32*//*Label 2216*/ GIMT_Encode4(133540),
     /*  123768 */ /*GILLT_nxv8s64*//*Label 2217*/ GIMT_Encode4(133655),
     /*  123772 */ /*GILLT_nxv16s1*//*Label 2218*/ GIMT_Encode4(133770),
     /*  123776 */ /*GILLT_nxv16s8*//*Label 2219*/ GIMT_Encode4(134381),
     /*  123780 */ /*GILLT_nxv16s16*//*Label 2220*/ GIMT_Encode4(134496),
     /*  123784 */ /*GILLT_nxv16s32*//*Label 2221*/ GIMT_Encode4(134611),
     /*  123788 */ /*GILLT_nxv32s1*//*Label 2222*/ GIMT_Encode4(134726),
     /*  123792 */ /*GILLT_nxv32s8*//*Label 2223*/ GIMT_Encode4(135337),
     /*  123796 */ /*GILLT_nxv32s16*//*Label 2224*/ GIMT_Encode4(135452),
     /*  123800 */ /*GILLT_nxv64s1*//*Label 2225*/ GIMT_Encode4(135567),
     /*  123804 */ /*GILLT_nxv64s8*//*Label 2226*/ GIMT_Encode4(136178),
     /*  123808 */ // Label 2196: @123808
     /*  123808 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(126537),
     /*  123813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  123816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  123819 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(124014), // Rule ID 65161 //
     /*  123824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  123827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  123831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  123835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  123839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  123843 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  123847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  123851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  123855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  123859 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  123863 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  123867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  123871 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  123875 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  123879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  123883 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  123887 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  123891 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  123895 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  123899 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  123903 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  123907 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  123911 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  123915 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  123919 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  123923 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  123925 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  123932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  123939 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  123946 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  123953 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  123953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  123956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  123960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  123970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  123975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  123977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  123980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  123984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  123989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  123994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  123999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124012 */     GIR_RootConstrainSelectedInstOperands,
     /*  124013 */     // GIR_Coverage, 65161,
     /*  124013 */     GIR_EraseRootFromParent_Done,
     /*  124014 */   // Label 2229: @124014
     /*  124014 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(124209), // Rule ID 65163 //
     /*  124019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  124026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  124038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  124042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  124046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  124058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  124062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  124066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124070 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  124074 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  124078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  124082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124086 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  124090 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  124094 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  124098 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  124102 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124106 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  124110 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  124114 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  124118 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  124120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  124127 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  124134 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  124141 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  124148 */     // (or:{ *:[i32] } (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  124148 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  124151 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124155 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  124165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  124170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  124172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  124175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  124189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  124194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124207 */     GIR_RootConstrainSelectedInstOperands,
     /*  124208 */     // GIR_Coverage, 65163,
     /*  124208 */     GIR_EraseRootFromParent_Done,
     /*  124209 */   // Label 2230: @124209
     /*  124209 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(124404), // Rule ID 65157 //
     /*  124214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  124221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  124233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  124237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124245 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124249 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  124253 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  124257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  124261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  124269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  124273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  124277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124281 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  124285 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  124289 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  124293 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  124297 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124301 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  124305 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  124309 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  124313 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  124315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  124322 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  124329 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  124336 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  124343 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  124343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  124346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  124360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  124365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  124367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  124370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  124384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  124389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124402 */     GIR_RootConstrainSelectedInstOperands,
     /*  124403 */     // GIR_Coverage, 65157,
     /*  124403 */     GIR_EraseRootFromParent_Done,
     /*  124404 */   // Label 2231: @124404
     /*  124404 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(124599), // Rule ID 65159 //
     /*  124409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  124416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  124428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  124432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  124448 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  124452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  124456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124460 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  124464 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  124468 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  124472 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124476 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  124480 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  124484 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  124488 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  124492 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124496 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  124500 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  124504 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  124508 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  124510 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  124517 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  124524 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  124531 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  124538 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  124538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  124541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  124555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  124560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  124562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  124565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  124579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  124584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124597 */     GIR_RootConstrainSelectedInstOperands,
     /*  124598 */     // GIR_Coverage, 65159,
     /*  124598 */     GIR_EraseRootFromParent_Done,
     /*  124599 */   // Label 2232: @124599
     /*  124599 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(124794), // Rule ID 65151 //
     /*  124604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  124611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  124623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  124627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  124643 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  124647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  124651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  124659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  124663 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  124667 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  124671 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124675 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  124679 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  124683 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  124687 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124691 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  124695 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  124699 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  124703 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  124705 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  124712 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  124719 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  124726 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  124733 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  124733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  124736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  124750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  124755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  124757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  124760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  124774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  124779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124792 */     GIR_RootConstrainSelectedInstOperands,
     /*  124793 */     // GIR_Coverage, 65151,
     /*  124793 */     GIR_EraseRootFromParent_Done,
     /*  124794 */   // Label 2233: @124794
     /*  124794 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(124989), // Rule ID 65155 //
     /*  124799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  124806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  124810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  124818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  124822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  124826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  124834 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  124838 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  124842 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  124846 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124850 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  124854 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  124858 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  124862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  124866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  124870 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  124874 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  124878 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  124882 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  124886 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  124890 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  124894 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  124898 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  124900 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  124907 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  124914 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  124921 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  124928 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] })))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  124928 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  124931 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124935 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  124945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  124950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  124952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  124955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  124959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  124964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  124969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  124974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  124976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  124979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  124981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  124984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  124987 */     GIR_RootConstrainSelectedInstOperands,
     /*  124988 */     // GIR_Coverage, 65155,
     /*  124988 */     GIR_EraseRootFromParent_Done,
     /*  124989 */   // Label 2234: @124989
     /*  124989 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(125184), // Rule ID 2441 //
     /*  124994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  124997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  125009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125033 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  125037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  125041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  125049 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  125053 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  125057 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  125061 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  125065 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  125069 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  125073 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  125077 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125081 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  125085 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  125089 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  125093 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  125095 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125102 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125109 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  125116 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  125123 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  125123 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  125126 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125130 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  125140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  125145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  125147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  125150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  125164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  125169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  125174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  125182 */     GIR_RootConstrainSelectedInstOperands,
     /*  125183 */     // GIR_Coverage, 2441,
     /*  125183 */     GIR_EraseRootFromParent_Done,
     /*  125184 */   // Label 2235: @125184
     /*  125184 */   GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(125379), // Rule ID 65153 //
     /*  125189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  125192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  125204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125228 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  125232 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  125236 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125240 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  125244 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  125248 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  125252 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  125256 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  125260 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  125264 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  125268 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  125272 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125276 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s32,
     /*  125280 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s32,
     /*  125284 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  125288 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  125290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125297 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125304 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  125311 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  125318 */     // (or:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op1rs2), 24:{ *:[i32] })), (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1)))  =>  (PACK:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op0rs1, GPR:{ *:[i32] }:$op0rs2), (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$op1rs1, GPR:{ *:[i32] }:$op1rs2))
     /*  125318 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  125321 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125325 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  125335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  125340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  125342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  125345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  125359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  125364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  125369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  125377 */     GIR_RootConstrainSelectedInstOperands,
     /*  125378 */     // GIR_Coverage, 65153,
     /*  125378 */     GIR_EraseRootFromParent_Done,
     /*  125379 */   // Label 2236: @125379
     /*  125379 */   GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(125484), // Rule ID 2436 //
     /*  125384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125399 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125403 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125407 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  125411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  125415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125427 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  125431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125433 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125440 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125447 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  125447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  125450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  125464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  125469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  125474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  125482 */     GIR_RootConstrainSelectedInstOperands,
     /*  125483 */     // GIR_Coverage, 2436,
     /*  125483 */     GIR_EraseRootFromParent_Done,
     /*  125484 */   // Label 2237: @125484
     /*  125484 */   GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(125589), // Rule ID 65146 //
     /*  125489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125512 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  125516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  125520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125532 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  125536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125545 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125552 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), 16:{ *:[i32] }), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 24:{ *:[i32] }))  =>  (SLLI:{ *:[i32] } (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 16:{ *:[i32] })
     /*  125552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  125555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  125564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  125569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  125574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  125576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  125579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  125584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  125587 */     GIR_RootConstrainSelectedInstOperands,
     /*  125588 */     // GIR_Coverage, 65146,
     /*  125588 */     GIR_EraseRootFromParent_Done,
     /*  125589 */   // Label 2238: @125589
     /*  125589 */   GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(125678), // Rule ID 65140 //
     /*  125594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  125609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125638 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  125642 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  125653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125662 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  125662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  125672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  125676 */     GIR_RootConstrainSelectedInstOperands,
     /*  125677 */     // GIR_Coverage, 65140,
     /*  125677 */     GIR_EraseRootFromParent_Done,
     /*  125678 */   // Label 2239: @125678
     /*  125678 */   GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(125767), // Rule ID 2430 //
     /*  125683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  125698 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125702 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  125710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125714 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  125718 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  125722 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125727 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  125731 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  125742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  125744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125751 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), 65535:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  125751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  125761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  125765 */     GIR_RootConstrainSelectedInstOperands,
     /*  125766 */     // GIR_Coverage, 2430,
     /*  125766 */     GIR_EraseRootFromParent_Done,
     /*  125767 */   // Label 2240: @125767
     /*  125767 */   GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(125832), // Rule ID 65142 //
     /*  125772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125795 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  125799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125808 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125815 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  125815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  125825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  125830 */     GIR_RootConstrainSelectedInstOperands,
     /*  125831 */     // GIR_Coverage, 65142,
     /*  125831 */     GIR_EraseRootFromParent_Done,
     /*  125832 */   // Label 2241: @125832
     /*  125832 */   GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(125897), // Rule ID 2432 //
     /*  125837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125860 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  125864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  125873 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125880 */     // (or:{ *:[i32] } (shl:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs2), 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  125880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  125890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  125895 */     GIR_RootConstrainSelectedInstOperands,
     /*  125896 */     // GIR_Coverage, 2432,
     /*  125896 */     GIR_EraseRootFromParent_Done,
     /*  125897 */   // Label 2242: @125897
     /*  125897 */   GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(125963), // Rule ID 65148 //
     /*  125902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  125913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125930 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  125934 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11211),
     /*  125938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  125940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  125947 */     // (or:{ *:[i32] } (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }))<<P:Predicate_anonymous_11211>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  125957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  125961 */     GIR_RootConstrainSelectedInstOperands,
     /*  125962 */     // GIR_Coverage, 65148,
     /*  125962 */     GIR_EraseRootFromParent_Done,
     /*  125963 */   // Label 2243: @125963
     /*  125963 */   GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(126029), // Rule ID 2438 //
     /*  125968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode1),
     /*  125971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  125979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  125983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  125987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  125991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  125996 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  126000 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11211),
     /*  126004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  126013 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 8:{ *:[i32] }), (zexti8:{ *:[i32] } GPR:{ *:[i32] }:$rs1))<<P:Predicate_anonymous_11211>>  =>  (PACKH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  126016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  126023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126027 */     GIR_RootConstrainSelectedInstOperands,
     /*  126028 */     // GIR_Coverage, 2438,
     /*  126028 */     GIR_EraseRootFromParent_Done,
     /*  126029 */   // Label 2244: @126029
     /*  126029 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(126091), // Rule ID 2439 //
     /*  126034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  126037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126062 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  126066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  126075 */     // (or:{ *:[i32] } (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1), (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  126078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  126085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126089 */     GIR_RootConstrainSelectedInstOperands,
     /*  126090 */     // GIR_Coverage, 2439,
     /*  126090 */     GIR_EraseRootFromParent_Done,
     /*  126091 */   // Label 2245: @126091
     /*  126091 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(126153), // Rule ID 65149 //
     /*  126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode1),
     /*  126099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126124 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  126128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  126137 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs2, 16:{ *:[i32] }), (zexti16:{ *:[i32] } GPR:{ *:[i32] }:$rs1))  =>  (PACK:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  126140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  126147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126151 */     GIR_RootConstrainSelectedInstOperands,
     /*  126152 */     // GIR_Coverage, 65149,
     /*  126152 */     GIR_EraseRootFromParent_Done,
     /*  126153 */   // Label 2246: @126153
     /*  126153 */   GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(126212), // Rule ID 2365 //
     /*  126158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  126161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  126185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126191 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  126198 */     // (or:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  126201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  126210 */     GIR_RootConstrainSelectedInstOperands,
     /*  126211 */     // GIR_Coverage, 2365,
     /*  126211 */     GIR_EraseRootFromParent_Done,
     /*  126212 */   // Label 2247: @126212
     /*  126212 */   GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(126271), // Rule ID 65136 //
     /*  126217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  126220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126244 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  126248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126250 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  126257 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BSET:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  126260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  126269 */     GIR_RootConstrainSelectedInstOperands,
     /*  126270 */     // GIR_Coverage, 65136,
     /*  126270 */     GIR_EraseRootFromParent_Done,
     /*  126271 */   // Label 2248: @126271
     /*  126271 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(126327), // Rule ID 65120 //
     /*  126276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  126279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126304 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  126308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126314 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs1)  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  126317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  126321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126325 */     GIR_RootConstrainSelectedInstOperands,
     /*  126326 */     // GIR_Coverage, 65120,
     /*  126326 */     GIR_EraseRootFromParent_Done,
     /*  126327 */   // Label 2249: @126327
     /*  126327 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(126383), // Rule ID 2339 //
     /*  126332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  126335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  126351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  126355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  126359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126364 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  126368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126370 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (ORN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  126373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  126381 */     GIR_RootConstrainSelectedInstOperands,
     /*  126382 */     // GIR_Coverage, 2339,
     /*  126382 */     GIR_EraseRootFromParent_Done,
     /*  126383 */   // Label 2250: @126383
     /*  126383 */   GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(126425), // Rule ID 81 //
     /*  126388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  126391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  126411 */     // MIs[1] Operand 1
     /*  126411 */     // No operand predicates
     /*  126411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126413 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  126413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  126416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  126423 */     GIR_RootConstrainSelectedInstOperands,
     /*  126424 */     // GIR_Coverage, 81,
     /*  126424 */     GIR_EraseRootFromParent_Done,
     /*  126425 */   // Label 2251: @126425
     /*  126425 */   GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(126467), // Rule ID 64501 //
     /*  126430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  126433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  126437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  126441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  126453 */     // MIs[1] Operand 1
     /*  126453 */     // No operand predicates
     /*  126453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126455 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_ORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  126455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORAI),
     /*  126458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  126460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  126465 */     GIR_RootConstrainSelectedInstOperands,
     /*  126466 */     // GIR_Coverage, 64501,
     /*  126466 */     GIR_EraseRootFromParent_Done,
     /*  126467 */   // Label 2252: @126467
     /*  126467 */   GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(126509), // Rule ID 64505 //
     /*  126472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  126475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  126479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  126483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  126487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  126491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  126495 */     // MIs[1] Operand 1
     /*  126495 */     // No operand predicates
     /*  126495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  126497 */     // (or:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_ORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  126497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_ORI),
     /*  126500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  126504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  126507 */     GIR_RootConstrainSelectedInstOperands,
     /*  126508 */     // GIR_Coverage, 64505,
     /*  126508 */     GIR_EraseRootFromParent_Done,
     /*  126509 */   // Label 2253: @126509
     /*  126509 */   GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(126536), // Rule ID 79 //
     /*  126514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  126517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126529 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (OR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  126529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  126534 */     GIR_RootConstrainSelectedInstOperands,
     /*  126535 */     // GIR_Coverage, 79,
     /*  126535 */     GIR_Done,
     /*  126536 */   // Label 2254: @126536
     /*  126536 */   GIM_Reject,
     /*  126537 */ // Label 2228: @126537
     /*  126537 */ GIM_Reject,
     /*  126538 */ // Label 2197: @126538
     /*  126538 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(129485),
     /*  126543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  126546 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  126549 */   GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(126744), // Rule ID 65160 //
     /*  126554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  126557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  126573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  126577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  126593 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  126597 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  126601 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126605 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  126609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  126613 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  126617 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126621 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  126625 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  126629 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  126633 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  126637 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126641 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  126645 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  126649 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  126653 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  126655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  126662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  126669 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  126676 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  126683 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  126683 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  126686 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  126690 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  126700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  126705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  126707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  126710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  126714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  126724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  126729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  126734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  126742 */     GIR_RootConstrainSelectedInstOperands,
     /*  126743 */     // GIR_Coverage, 65160,
     /*  126743 */     GIR_EraseRootFromParent_Done,
     /*  126744 */   // Label 2256: @126744
     /*  126744 */   GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(126939), // Rule ID 65162 //
     /*  126749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  126752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  126768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  126772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  126776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  126788 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  126792 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  126796 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126800 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  126804 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  126808 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  126812 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126816 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  126820 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  126824 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  126828 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  126832 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126836 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  126840 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  126844 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  126848 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  126850 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  126857 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  126864 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  126871 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  126878 */     // (or:{ *:[i64] } (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  126878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  126881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  126885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  126895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  126900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  126902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  126905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  126909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  126914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs1
     /*  126919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs2
     /*  126924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  126926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  126929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  126931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  126934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  126937 */     GIR_RootConstrainSelectedInstOperands,
     /*  126938 */     // GIR_Coverage, 65162,
     /*  126938 */     GIR_EraseRootFromParent_Done,
     /*  126939 */   // Label 2257: @126939
     /*  126939 */   GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(127134), // Rule ID 65156 //
     /*  126944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  126947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  126951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  126955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  126963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  126967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  126971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  126975 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  126979 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  126983 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  126987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  126991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  126995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  126999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127003 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  127007 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127011 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127015 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127019 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  127023 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  127027 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127031 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  127035 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  127039 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 16,
     /*  127043 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  127045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  127052 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  127059 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  127066 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  127073 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  127073 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  127076 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127080 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs1
     /*  127090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs2
     /*  127095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  127097 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  127100 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127104 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  127114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  127119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  127124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  127132 */     GIR_RootConstrainSelectedInstOperands,
     /*  127133 */     // GIR_Coverage, 65156,
     /*  127133 */     GIR_EraseRootFromParent_Done,
     /*  127134 */   // Label 2258: @127134
     /*  127134 */   GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(127329), // Rule ID 65158 //
     /*  127139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  127142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  127158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  127162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127174 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  127178 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  127182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  127186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127190 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  127194 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  127202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127206 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127214 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 16,
     /*  127218 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/3, /*OpIdx*/2, // MIs[5]
     /*  127222 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127226 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  127230 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  127234 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 24,
     /*  127238 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  127240 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  127247 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  127254 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  127261 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  127268 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  127268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  127271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op1rs1
     /*  127285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op1rs2
     /*  127290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  127292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  127295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op0rs1
     /*  127309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op0rs2
     /*  127314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  127319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  127327 */     GIR_RootConstrainSelectedInstOperands,
     /*  127328 */     // GIR_Coverage, 65158,
     /*  127328 */     GIR_EraseRootFromParent_Done,
     /*  127329 */   // Label 2259: @127329
     /*  127329 */   GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(127524), // Rule ID 65150 //
     /*  127334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  127337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  127353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  127357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  127373 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  127377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  127381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127385 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  127389 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127393 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  127397 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  127401 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127405 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127409 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127413 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  127417 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127421 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  127425 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  127429 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  127433 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  127435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  127442 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  127449 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  127456 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  127463 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  127463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  127466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  127480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  127485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  127487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  127490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  127504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  127509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  127514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  127522 */     GIR_RootConstrainSelectedInstOperands,
     /*  127523 */     // GIR_Coverage, 65150,
     /*  127523 */     GIR_EraseRootFromParent_Done,
     /*  127524 */   // Label 2260: @127524
     /*  127524 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(127719), // Rule ID 65154 //
     /*  127529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  127532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  127548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  127552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  127568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  127572 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  127576 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127580 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  127584 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127588 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  127592 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  127596 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127600 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127604 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127608 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  127612 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127616 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  127620 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  127624 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  127628 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  127630 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  127637 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  127644 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  127651 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  127658 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] })))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  127658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  127661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  127675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  127680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  127682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  127685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs1
     /*  127699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs2
     /*  127704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  127709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  127717 */     GIR_RootConstrainSelectedInstOperands,
     /*  127718 */     // GIR_Coverage, 65154,
     /*  127718 */     GIR_EraseRootFromParent_Done,
     /*  127719 */   // Label 2261: @127719
     /*  127719 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(127914), // Rule ID 2440 //
     /*  127724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  127727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  127743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  127747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  127763 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  127767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  127771 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127775 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  127779 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127783 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  127787 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  127791 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127795 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127799 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127803 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  127807 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127811 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  127815 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  127819 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  127823 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  127825 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  127832 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  127839 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  127846 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  127853 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  127853 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  127856 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127860 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs1
     /*  127870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs2
     /*  127875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  127877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  127880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  127884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  127889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  127894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  127899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  127901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  127904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  127906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  127909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  127912 */     GIR_RootConstrainSelectedInstOperands,
     /*  127913 */     // GIR_Coverage, 2440,
     /*  127913 */     GIR_EraseRootFromParent_Done,
     /*  127914 */   // Label 2262: @127914
     /*  127914 */   GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(128109), // Rule ID 65152 //
     /*  127919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_HwMode0),
     /*  127922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  127926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  127930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  127938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  127942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  127946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  127954 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  127958 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  127962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  127966 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  127970 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  127974 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  127978 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*  127982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  127986 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_OR),
     /*  127990 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  127994 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  127998 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  128002 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128006 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_s64,
     /*  128010 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_s64,
     /*  128014 */     GIM_CheckConstantInt8, /*MI*/5, /*Op*/2, 8,
     /*  128018 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  128020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128027 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128034 */     GIM_CheckComplexPattern, /*MI*/4, /*Op*/2, /*Renderer*/GIMT_Encode2(3), GIMT_Encode2(GICP_gi_zexti8),
     /*  128041 */     GIM_CheckComplexPattern, /*MI*/5, /*Op*/1, /*Renderer*/GIMT_Encode2(2), GIMT_Encode2(GICP_gi_zexti8),
     /*  128048 */     // (or:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op1rs2), 24:{ *:[i64] })), (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1)))  =>  (PACK:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op0rs1, GPR:{ *:[i64] }:$op0rs2), (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$op1rs1, GPR:{ *:[i64] }:$op1rs2))
     /*  128048 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  128051 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128055 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // op1rs1
     /*  128065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/2, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // op1rs2
     /*  128070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  128072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  128075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(3), /*SubOperand*/0, // op0rs1
     /*  128089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(2), /*SubOperand*/0, // op0rs2
     /*  128094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  128099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  128107 */     GIR_RootConstrainSelectedInstOperands,
     /*  128108 */     // GIR_Coverage, 65152,
     /*  128108 */     GIR_EraseRootFromParent_Done,
     /*  128109 */   // Label 2263: @128109
     /*  128109 */   GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(128214), // Rule ID 2435 //
     /*  128114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128137 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 24,
     /*  128141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  128145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128149 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128153 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128157 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  128161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128170 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128177 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  128177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  128180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  128194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  128199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  128204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  128212 */     GIR_RootConstrainSelectedInstOperands,
     /*  128213 */     // GIR_Coverage, 2435,
     /*  128213 */     GIR_EraseRootFromParent_Done,
     /*  128214 */   // Label 2264: @128214
     /*  128214 */   GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(128319), // Rule ID 65145 //
     /*  128219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128242 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  128246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  128250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128262 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  128266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128268 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128275 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128282 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), 16:{ *:[i64] }), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 24:{ *:[i64] }))  =>  (SLLI:{ *:[i64] } (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 16:{ *:[i64] })
     /*  128282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  128285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  128294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  128304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  128306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /*  128309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  128314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /*  128317 */     GIR_RootConstrainSelectedInstOperands,
     /*  128318 */     // GIR_Coverage, 65145,
     /*  128318 */     GIR_EraseRootFromParent_Done,
     /*  128319 */   // Label 2265: @128319
     /*  128319 */   GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(128408), // Rule ID 65139 //
     /*  128324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  128339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128363 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128368 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128372 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  128383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128392 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  128406 */     GIR_RootConstrainSelectedInstOperands,
     /*  128407 */     // GIR_Coverage, 65139,
     /*  128407 */     GIR_EraseRootFromParent_Done,
     /*  128408 */   // Label 2266: @128408
     /*  128408 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(128497), // Rule ID 2429 //
     /*  128413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  128428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128457 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  128461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  128472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128481 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), 65535:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  128495 */     GIR_RootConstrainSelectedInstOperands,
     /*  128496 */     // GIR_Coverage, 2429,
     /*  128496 */     GIR_EraseRootFromParent_Done,
     /*  128497 */   // Label 2267: @128497
     /*  128497 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(128562), // Rule ID 65141 //
     /*  128502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128525 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  128529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128538 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128545 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs2
     /*  128560 */     GIR_RootConstrainSelectedInstOperands,
     /*  128561 */     // GIR_Coverage, 65141,
     /*  128561 */     GIR_EraseRootFromParent_Done,
     /*  128562 */   // Label 2268: @128562
     /*  128562 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(128627), // Rule ID 2431 //
     /*  128567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128590 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  128594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_zexti8),
     /*  128603 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128610 */     // (or:{ *:[i64] } (shl:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs2), 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // rs1
     /*  128620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  128625 */     GIR_RootConstrainSelectedInstOperands,
     /*  128626 */     // GIR_Coverage, 2431,
     /*  128626 */     GIR_EraseRootFromParent_Done,
     /*  128627 */   // Label 2269: @128627
     /*  128627 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(128712), // Rule ID 65166 //
     /*  128632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  128635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  128647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128663 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128672 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  128676 */     // MIs[1] Operand 2
     /*  128676 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  128687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  128696 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  128699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  128710 */     GIR_RootConstrainSelectedInstOperands,
     /*  128711 */     // GIR_Coverage, 65166,
     /*  128711 */     GIR_EraseRootFromParent_Done,
     /*  128712 */   // Label 2270: @128712
     /*  128712 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(128797), // Rule ID 2444 //
     /*  128717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  128720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  128732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  128740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  128748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  128752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128757 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  128761 */     // MIs[1] Operand 2
     /*  128761 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  128772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  128774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  128781 */     // (or:{ *:[i64] } (sext_inreg:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), i32:{ *:[Other] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  128784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  128795 */     GIR_RootConstrainSelectedInstOperands,
     /*  128796 */     // GIR_Coverage, 2444,
     /*  128796 */     GIR_EraseRootFromParent_Done,
     /*  128797 */   // Label 2271: @128797
     /*  128797 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(128863), // Rule ID 65147 //
     /*  128802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  128834 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11211),
     /*  128838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128847 */     // (or:{ *:[i64] } (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }))<<P:Predicate_anonymous_11211>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128861 */     GIR_RootConstrainSelectedInstOperands,
     /*  128862 */     // GIR_Coverage, 65147,
     /*  128862 */     GIR_EraseRootFromParent_Done,
     /*  128863 */   // Label 2272: @128863
     /*  128863 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(128929), // Rule ID 65165 //
     /*  128868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  128871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  128879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  128900 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10051),
     /*  128904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  128913 */     // (or:{ *:[i64] } (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }))<<P:Predicate_anonymous_10051>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  128916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128927 */     GIR_RootConstrainSelectedInstOperands,
     /*  128928 */     // GIR_Coverage, 65165,
     /*  128928 */     GIR_EraseRootFromParent_Done,
     /*  128929 */   // Label 2273: @128929
     /*  128929 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(128995), // Rule ID 2437 //
     /*  128934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_HwMode0),
     /*  128937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  128945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  128949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  128953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  128957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  128962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  128966 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_11211),
     /*  128970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  128972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti8),
     /*  128979 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 8:{ *:[i64] }), (zexti8:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_11211>>  =>  (PACKH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  128979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKH),
     /*  128982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  128984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  128989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  128993 */     GIR_RootConstrainSelectedInstOperands,
     /*  128994 */     // GIR_Coverage, 2437,
     /*  128994 */     GIR_EraseRootFromParent_Done,
     /*  128995 */   // Label 2274: @128995
     /*  128995 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(129061), // Rule ID 2443 //
     /*  129000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  129003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  129032 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10051),
     /*  129036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti16),
     /*  129045 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 16:{ *:[i64] }), (zexti16:{ *:[i64] } GPR:{ *:[i64] }:$rs1))<<P:Predicate_anonymous_10051>>  =>  (PACKW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /*  129048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129059 */     GIR_RootConstrainSelectedInstOperands,
     /*  129060 */     // GIR_Coverage, 2443,
     /*  129060 */     GIR_EraseRootFromParent_Done,
     /*  129061 */   // Label 2275: @129061
     /*  129061 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(129123), // Rule ID 2442 //
     /*  129066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  129069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129094 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  129098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  129107 */     // (or:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1), (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129121 */     GIR_RootConstrainSelectedInstOperands,
     /*  129122 */     // GIR_Coverage, 2442,
     /*  129122 */     GIR_EraseRootFromParent_Done,
     /*  129123 */   // Label 2276: @129123
     /*  129123 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(129185), // Rule ID 65164 //
     /*  129128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_HwMode0),
     /*  129131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129156 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /*  129160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /*  129169 */     // (or:{ *:[i64] } (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs2, 32:{ *:[i64] }), (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (PACK:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /*  129172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  129179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129183 */     GIR_RootConstrainSelectedInstOperands,
     /*  129184 */     // GIR_Coverage, 65164,
     /*  129184 */     GIR_EraseRootFromParent_Done,
     /*  129185 */   // Label 2277: @129185
     /*  129185 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(129244), // Rule ID 2364 //
     /*  129190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  129193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  129217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  129230 */     // (or:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  129233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  129242 */     GIR_RootConstrainSelectedInstOperands,
     /*  129243 */     // GIR_Coverage, 2364,
     /*  129243 */     GIR_EraseRootFromParent_Done,
     /*  129244 */   // Label 2278: @129244
     /*  129244 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(129303), // Rule ID 65135 //
     /*  129249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  129252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  129268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129276 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  129280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129282 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  129289 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BSET:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  129292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  129301 */     GIR_RootConstrainSelectedInstOperands,
     /*  129302 */     // GIR_Coverage, 65135,
     /*  129302 */     GIR_EraseRootFromParent_Done,
     /*  129303 */   // Label 2279: @129303
     /*  129303 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(129359), // Rule ID 65119 //
     /*  129308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  129311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129336 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  129340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129346 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs1)  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  129349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129357 */     GIR_RootConstrainSelectedInstOperands,
     /*  129358 */     // GIR_Coverage, 65119,
     /*  129358 */     GIR_EraseRootFromParent_Done,
     /*  129359 */   // Label 2280: @129359
     /*  129359 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(129415), // Rule ID 2338 //
     /*  129364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  129367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  129387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  129391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129396 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  129400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129402 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (ORN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORN),
     /*  129405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129413 */     GIR_RootConstrainSelectedInstOperands,
     /*  129414 */     // GIR_Coverage, 2338,
     /*  129414 */     GIR_EraseRootFromParent_Done,
     /*  129415 */   // Label 2281: @129415
     /*  129415 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(129457), // Rule ID 80 //
     /*  129420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  129423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  129439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  129443 */     // MIs[1] Operand 1
     /*  129443 */     // No operand predicates
     /*  129443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  129445 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (ORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  129445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ORI),
     /*  129448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  129455 */     GIR_RootConstrainSelectedInstOperands,
     /*  129456 */     // GIR_Coverage, 80,
     /*  129456 */     GIR_EraseRootFromParent_Done,
     /*  129457 */   // Label 2282: @129457
     /*  129457 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(129484), // Rule ID 78 //
     /*  129462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  129465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  129477 */     // (or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (OR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  129477 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::OR),
     /*  129482 */     GIR_RootConstrainSelectedInstOperands,
     /*  129483 */     // GIR_Coverage, 78,
     /*  129483 */     GIR_Done,
     /*  129484 */   // Label 2283: @129484
     /*  129484 */   GIM_Reject,
     /*  129485 */ // Label 2255: @129485
     /*  129485 */ GIM_Reject,
     /*  129486 */ // Label 2198: @129486
     /*  129486 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(130096),
     /*  129491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129501 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(129567), // Rule ID 71339 //
     /*  129506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129521 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  129537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129548 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  129548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  129559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129565 */     GIR_RootConstrainSelectedInstOperands,
     /*  129566 */     // GIR_Coverage, 71339,
     /*  129566 */     GIR_EraseRootFromParent_Done,
     /*  129567 */   // Label 2285: @129567
     /*  129567 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(129633), // Rule ID 71340 //
     /*  129572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129614 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  129614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  129625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129631 */     GIR_RootConstrainSelectedInstOperands,
     /*  129632 */     // GIR_Coverage, 71340,
     /*  129632 */     GIR_EraseRootFromParent_Done,
     /*  129633 */   // Label 2286: @129633
     /*  129633 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(129699), // Rule ID 71337 //
     /*  129638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  129666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  129674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129678 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129680 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  129680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129697 */     GIR_RootConstrainSelectedInstOperands,
     /*  129698 */     // GIR_Coverage, 71337,
     /*  129698 */     GIR_EraseRootFromParent_Done,
     /*  129699 */   // Label 2287: @129699
     /*  129699 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(129765), // Rule ID 71338 //
     /*  129704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  129711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  129732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129746 */     // (or:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs1)  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  129746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  129753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129763 */     GIR_RootConstrainSelectedInstOperands,
     /*  129764 */     // GIR_Coverage, 71338,
     /*  129764 */     GIR_EraseRootFromParent_Done,
     /*  129765 */   // Label 2288: @129765
     /*  129765 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(129831), // Rule ID 71335 //
     /*  129770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129789 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  129805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129812 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  129812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  129823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129829 */     GIR_RootConstrainSelectedInstOperands,
     /*  129830 */     // GIR_Coverage, 71335,
     /*  129830 */     GIR_EraseRootFromParent_Done,
     /*  129831 */   // Label 2289: @129831
     /*  129831 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(129897), // Rule ID 71336 //
     /*  129836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  129863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  129871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129878 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  129878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  129889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129895 */     GIR_RootConstrainSelectedInstOperands,
     /*  129896 */     // GIR_Coverage, 71336,
     /*  129896 */     GIR_EraseRootFromParent_Done,
     /*  129897 */   // Label 2290: @129897
     /*  129897 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(129963), // Rule ID 53048 //
     /*  129902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  129905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  129934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  129938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  129942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  129944 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  129944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  129947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  129949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  129951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  129955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  129958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  129961 */     GIR_RootConstrainSelectedInstOperands,
     /*  129962 */     // GIR_Coverage, 53048,
     /*  129962 */     GIR_EraseRootFromParent_Done,
     /*  129963 */   // Label 2291: @129963
     /*  129963 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(130029), // Rule ID 53049 //
     /*  129968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  129971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  129979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  129983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  129987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  129991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  129996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130010 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  130010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  130013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130027 */     GIR_RootConstrainSelectedInstOperands,
     /*  130028 */     // GIR_Coverage, 53049,
     /*  130028 */     GIR_EraseRootFromParent_Done,
     /*  130029 */   // Label 2292: @130029
     /*  130029 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(130062), // Rule ID 53036 //
     /*  130034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130045 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  130045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  130048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130060 */     GIR_RootConstrainSelectedInstOperands,
     /*  130061 */     // GIR_Coverage, 53036,
     /*  130061 */     GIR_EraseRootFromParent_Done,
     /*  130062 */   // Label 2293: @130062
     /*  130062 */   GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(130095), // Rule ID 53037 //
     /*  130067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130078 */     // (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  130078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  130081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130093 */     GIR_RootConstrainSelectedInstOperands,
     /*  130094 */     // GIR_Coverage, 53037,
     /*  130094 */     GIR_EraseRootFromParent_Done,
     /*  130095 */   // Label 2294: @130095
     /*  130095 */   GIM_Reject,
     /*  130096 */ // Label 2284: @130096
     /*  130096 */ GIM_Reject,
     /*  130097 */ // Label 2199: @130097
     /*  130097 */ GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(130211),
     /*  130102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  130105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  130108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130120 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(130165), // Rule ID 47658 //
     /*  130125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130128 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  130128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  130131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  130145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130163 */     GIR_RootConstrainSelectedInstOperands,
     /*  130164 */     // GIR_Coverage, 47658,
     /*  130164 */     GIR_EraseRootFromParent_Done,
     /*  130165 */   // Label 2296: @130165
     /*  130165 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(130210), // Rule ID 47659 //
     /*  130170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130173 */     // (or:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  130173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  130176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  130190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130208 */     GIR_RootConstrainSelectedInstOperands,
     /*  130209 */     // GIR_Coverage, 47659,
     /*  130209 */     GIR_EraseRootFromParent_Done,
     /*  130210 */   // Label 2297: @130210
     /*  130210 */   GIM_Reject,
     /*  130211 */ // Label 2295: @130211
     /*  130211 */ GIM_Reject,
     /*  130212 */ // Label 2200: @130212
     /*  130212 */ GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(130326),
     /*  130217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  130220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  130223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130235 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(130280), // Rule ID 47670 //
     /*  130240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130243 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  130243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  130246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  130260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130278 */     GIR_RootConstrainSelectedInstOperands,
     /*  130279 */     // GIR_Coverage, 47670,
     /*  130279 */     GIR_EraseRootFromParent_Done,
     /*  130280 */   // Label 2299: @130280
     /*  130280 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(130325), // Rule ID 47671 //
     /*  130285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130288 */     // (or:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  130288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  130291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  130305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  130320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130323 */     GIR_RootConstrainSelectedInstOperands,
     /*  130324 */     // GIR_Coverage, 47671,
     /*  130324 */     GIR_EraseRootFromParent_Done,
     /*  130325 */   // Label 2300: @130325
     /*  130325 */   GIM_Reject,
     /*  130326 */ // Label 2298: @130326
     /*  130326 */ GIM_Reject,
     /*  130327 */ // Label 2201: @130327
     /*  130327 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(130441),
     /*  130332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  130335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  130338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130350 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(130395), // Rule ID 47678 //
     /*  130355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130358 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  130358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  130361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  130375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  130390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130393 */     GIR_RootConstrainSelectedInstOperands,
     /*  130394 */     // GIR_Coverage, 47678,
     /*  130394 */     GIR_EraseRootFromParent_Done,
     /*  130395 */   // Label 2302: @130395
     /*  130395 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(130440), // Rule ID 47679 //
     /*  130400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130403 */     // (or:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  130403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  130406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  130420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  130435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130438 */     GIR_RootConstrainSelectedInstOperands,
     /*  130439 */     // GIR_Coverage, 47679,
     /*  130439 */     GIR_EraseRootFromParent_Done,
     /*  130440 */   // Label 2303: @130440
     /*  130440 */   GIM_Reject,
     /*  130441 */ // Label 2301: @130441
     /*  130441 */ GIM_Reject,
     /*  130442 */ // Label 2202: @130442
     /*  130442 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(130556),
     /*  130447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  130450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  130453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130465 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(130510), // Rule ID 47694 //
     /*  130470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  130473 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  130473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  130476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  130490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  130505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130508 */     GIR_RootConstrainSelectedInstOperands,
     /*  130509 */     // GIR_Coverage, 47694,
     /*  130509 */     GIR_EraseRootFromParent_Done,
     /*  130510 */   // Label 2305: @130510
     /*  130510 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(130555), // Rule ID 47695 //
     /*  130515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  130518 */     // (or:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  130518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  130521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  130525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  130530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  130532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  130535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  130540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  130544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  130550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  130553 */     GIR_RootConstrainSelectedInstOperands,
     /*  130554 */     // GIR_Coverage, 47695,
     /*  130554 */     GIR_EraseRootFromParent_Done,
     /*  130555 */   // Label 2306: @130555
     /*  130555 */   GIM_Reject,
     /*  130556 */ // Label 2304: @130556
     /*  130556 */ GIM_Reject,
     /*  130557 */ // Label 2203: @130557
     /*  130557 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(131167),
     /*  130562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130572 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(130638), // Rule ID 71367 //
     /*  130577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130619 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  130619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  130630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130636 */     GIR_RootConstrainSelectedInstOperands,
     /*  130637 */     // GIR_Coverage, 71367,
     /*  130637 */     GIR_EraseRootFromParent_Done,
     /*  130638 */   // Label 2308: @130638
     /*  130638 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(130704), // Rule ID 71368 //
     /*  130643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130670 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130685 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  130685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  130696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130702 */     GIR_RootConstrainSelectedInstOperands,
     /*  130703 */     // GIR_Coverage, 71368,
     /*  130703 */     GIR_EraseRootFromParent_Done,
     /*  130704 */   // Label 2309: @130704
     /*  130704 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(130770), // Rule ID 71365 //
     /*  130709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130751 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  130751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130768 */     GIR_RootConstrainSelectedInstOperands,
     /*  130769 */     // GIR_Coverage, 71365,
     /*  130769 */     GIR_EraseRootFromParent_Done,
     /*  130770 */   // Label 2310: @130770
     /*  130770 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(130836), // Rule ID 71366 //
     /*  130775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  130782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  130803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130807 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130817 */     // (or:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs1)  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  130817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  130824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  130828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130834 */     GIR_RootConstrainSelectedInstOperands,
     /*  130835 */     // GIR_Coverage, 71366,
     /*  130835 */     GIR_EraseRootFromParent_Done,
     /*  130836 */   // Label 2311: @130836
     /*  130836 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(130902), // Rule ID 71363 //
     /*  130841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  130876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130883 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  130883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  130894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130900 */     GIR_RootConstrainSelectedInstOperands,
     /*  130901 */     // GIR_Coverage, 71363,
     /*  130901 */     GIR_EraseRootFromParent_Done,
     /*  130902 */   // Label 2312: @130902
     /*  130902 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(130968), // Rule ID 71364 //
     /*  130907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  130910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  130934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  130938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  130942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  130949 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  130949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  130952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  130954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  130956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  130960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  130963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  130966 */     GIR_RootConstrainSelectedInstOperands,
     /*  130967 */     // GIR_Coverage, 71364,
     /*  130967 */     GIR_EraseRootFromParent_Done,
     /*  130968 */   // Label 2313: @130968
     /*  130968 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131034), // Rule ID 53066 //
     /*  130973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  130976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  130980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  130984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  130988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  130992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  130996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131015 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  131015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  131018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131032 */     GIR_RootConstrainSelectedInstOperands,
     /*  131033 */     // GIR_Coverage, 53066,
     /*  131033 */     GIR_EraseRootFromParent_Done,
     /*  131034 */   // Label 2314: @131034
     /*  131034 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131100), // Rule ID 53067 //
     /*  131039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  131058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  131062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131075 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  131079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131081 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  131081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  131084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131098 */     GIR_RootConstrainSelectedInstOperands,
     /*  131099 */     // GIR_Coverage, 53067,
     /*  131099 */     GIR_EraseRootFromParent_Done,
     /*  131100 */   // Label 2315: @131100
     /*  131100 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(131133), // Rule ID 53054 //
     /*  131105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131116 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  131116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  131119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131131 */     GIR_RootConstrainSelectedInstOperands,
     /*  131132 */     // GIR_Coverage, 53054,
     /*  131132 */     GIR_EraseRootFromParent_Done,
     /*  131133 */   // Label 2316: @131133
     /*  131133 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131166), // Rule ID 53055 //
     /*  131138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131149 */     // (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  131149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  131152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131164 */     GIR_RootConstrainSelectedInstOperands,
     /*  131165 */     // GIR_Coverage, 53055,
     /*  131165 */     GIR_EraseRootFromParent_Done,
     /*  131166 */   // Label 2317: @131166
     /*  131166 */   GIM_Reject,
     /*  131167 */ // Label 2307: @131167
     /*  131167 */ GIM_Reject,
     /*  131168 */ // Label 2204: @131168
     /*  131168 */ GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131282),
     /*  131173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  131176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  131179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131191 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131236), // Rule ID 47662 //
     /*  131196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131199 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  131199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  131202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131211 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  131216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131221 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131234 */     GIR_RootConstrainSelectedInstOperands,
     /*  131235 */     // GIR_Coverage, 47662,
     /*  131235 */     GIR_EraseRootFromParent_Done,
     /*  131236 */   // Label 2319: @131236
     /*  131236 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(131281), // Rule ID 47663 //
     /*  131241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131244 */     // (or:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  131244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  131247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  131261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131279 */     GIR_RootConstrainSelectedInstOperands,
     /*  131280 */     // GIR_Coverage, 47663,
     /*  131280 */     GIR_EraseRootFromParent_Done,
     /*  131281 */   // Label 2320: @131281
     /*  131281 */   GIM_Reject,
     /*  131282 */ // Label 2318: @131282
     /*  131282 */ GIM_Reject,
     /*  131283 */ // Label 2205: @131283
     /*  131283 */ GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(131397),
     /*  131288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  131291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  131294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131306 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(131351), // Rule ID 47674 //
     /*  131311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131314 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  131314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  131317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  131331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  131346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131349 */     GIR_RootConstrainSelectedInstOperands,
     /*  131350 */     // GIR_Coverage, 47674,
     /*  131350 */     GIR_EraseRootFromParent_Done,
     /*  131351 */   // Label 2322: @131351
     /*  131351 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(131396), // Rule ID 47675 //
     /*  131356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131359 */     // (or:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  131359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  131362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  131376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  131391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131394 */     GIR_RootConstrainSelectedInstOperands,
     /*  131395 */     // GIR_Coverage, 47675,
     /*  131395 */     GIR_EraseRootFromParent_Done,
     /*  131396 */   // Label 2323: @131396
     /*  131396 */   GIM_Reject,
     /*  131397 */ // Label 2321: @131397
     /*  131397 */ GIM_Reject,
     /*  131398 */ // Label 2206: @131398
     /*  131398 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(131512),
     /*  131403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  131406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  131409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131417 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131421 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(131466), // Rule ID 47690 //
     /*  131426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131429 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  131429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  131432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  131446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131448 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131451 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131464 */     GIR_RootConstrainSelectedInstOperands,
     /*  131465 */     // GIR_Coverage, 47690,
     /*  131465 */     GIR_EraseRootFromParent_Done,
     /*  131466 */   // Label 2325: @131466
     /*  131466 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(131511), // Rule ID 47691 //
     /*  131471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131474 */     // (or:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  131474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  131477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  131491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  131506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131509 */     GIR_RootConstrainSelectedInstOperands,
     /*  131510 */     // GIR_Coverage, 47691,
     /*  131510 */     GIR_EraseRootFromParent_Done,
     /*  131511 */   // Label 2326: @131511
     /*  131511 */   GIM_Reject,
     /*  131512 */ // Label 2324: @131512
     /*  131512 */ GIM_Reject,
     /*  131513 */ // Label 2207: @131513
     /*  131513 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(131627),
     /*  131518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  131521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  131524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  131536 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(131581), // Rule ID 47734 //
     /*  131541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  131544 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  131544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  131547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  131561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131579 */     GIR_RootConstrainSelectedInstOperands,
     /*  131580 */     // GIR_Coverage, 47734,
     /*  131580 */     GIR_EraseRootFromParent_Done,
     /*  131581 */   // Label 2328: @131581
     /*  131581 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(131626), // Rule ID 47735 //
     /*  131586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  131589 */     // (or:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  131589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  131592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  131596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  131601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  131603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  131606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  131611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  131615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  131621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  131624 */     GIR_RootConstrainSelectedInstOperands,
     /*  131625 */     // GIR_Coverage, 47735,
     /*  131625 */     GIR_EraseRootFromParent_Done,
     /*  131626 */   // Label 2329: @131626
     /*  131626 */   GIM_Reject,
     /*  131627 */ // Label 2327: @131627
     /*  131627 */ GIM_Reject,
     /*  131628 */ // Label 2208: @131628
     /*  131628 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132238),
     /*  131633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131643 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(131709), // Rule ID 71395 //
     /*  131648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131690 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  131690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  131693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  131701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131707 */     GIR_RootConstrainSelectedInstOperands,
     /*  131708 */     // GIR_Coverage, 71395,
     /*  131708 */     GIR_EraseRootFromParent_Done,
     /*  131709 */   // Label 2331: @131709
     /*  131709 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(131775), // Rule ID 71396 //
     /*  131714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  131745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131756 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  131756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  131759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  131767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131773 */     GIR_RootConstrainSelectedInstOperands,
     /*  131774 */     // GIR_Coverage, 71396,
     /*  131774 */     GIR_EraseRootFromParent_Done,
     /*  131775 */   // Label 2332: @131775
     /*  131775 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(131841), // Rule ID 71393 //
     /*  131780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131822 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  131822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  131825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131839 */     GIR_RootConstrainSelectedInstOperands,
     /*  131840 */     // GIR_Coverage, 71393,
     /*  131840 */     GIR_EraseRootFromParent_Done,
     /*  131841 */   // Label 2333: @131841
     /*  131841 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(131907), // Rule ID 71394 //
     /*  131846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  131853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  131874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  131882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131888 */     // (or:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs1)  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  131888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  131891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  131895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  131899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131905 */     GIR_RootConstrainSelectedInstOperands,
     /*  131906 */     // GIR_Coverage, 71394,
     /*  131906 */     GIR_EraseRootFromParent_Done,
     /*  131907 */   // Label 2334: @131907
     /*  131907 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(131973), // Rule ID 71391 //
     /*  131912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  131915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131931 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  131935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  131939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  131943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  131947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  131954 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  131954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  131957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  131959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  131961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  131965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  131968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  131971 */     GIR_RootConstrainSelectedInstOperands,
     /*  131972 */     // GIR_Coverage, 71391,
     /*  131972 */     GIR_EraseRootFromParent_Done,
     /*  131973 */   // Label 2335: @131973
     /*  131973 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(132039), // Rule ID 71392 //
     /*  131978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  131981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  131985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  131989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  131993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  131997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  132001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  132013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132020 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  132020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  132023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  132031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132037 */     GIR_RootConstrainSelectedInstOperands,
     /*  132038 */     // GIR_Coverage, 71392,
     /*  132038 */     GIR_EraseRootFromParent_Done,
     /*  132039 */   // Label 2336: @132039
     /*  132039 */   GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(132105), // Rule ID 53084 //
     /*  132044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  132063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  132067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  132076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132086 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  132086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  132089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  132097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132103 */     GIR_RootConstrainSelectedInstOperands,
     /*  132104 */     // GIR_Coverage, 53084,
     /*  132104 */     GIR_EraseRootFromParent_Done,
     /*  132105 */   // Label 2337: @132105
     /*  132105 */   GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(132171), // Rule ID 53085 //
     /*  132110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  132129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  132133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  132142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  132150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132152 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  132152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  132155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  132163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132169 */     GIR_RootConstrainSelectedInstOperands,
     /*  132170 */     // GIR_Coverage, 53085,
     /*  132170 */     GIR_EraseRootFromParent_Done,
     /*  132171 */   // Label 2338: @132171
     /*  132171 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(132204), // Rule ID 53072 //
     /*  132176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132187 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  132187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  132190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132202 */     GIR_RootConstrainSelectedInstOperands,
     /*  132203 */     // GIR_Coverage, 53072,
     /*  132203 */     GIR_EraseRootFromParent_Done,
     /*  132204 */   // Label 2339: @132204
     /*  132204 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(132237), // Rule ID 53073 //
     /*  132209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132220 */     // (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  132220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  132223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132235 */     GIR_RootConstrainSelectedInstOperands,
     /*  132236 */     // GIR_Coverage, 53073,
     /*  132236 */     GIR_EraseRootFromParent_Done,
     /*  132237 */   // Label 2340: @132237
     /*  132237 */   GIM_Reject,
     /*  132238 */ // Label 2330: @132238
     /*  132238 */ GIM_Reject,
     /*  132239 */ // Label 2209: @132239
     /*  132239 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(132353),
     /*  132244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  132247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  132250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132258 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132262 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(132307), // Rule ID 47666 //
     /*  132267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132270 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  132270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  132273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  132287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132305 */     GIR_RootConstrainSelectedInstOperands,
     /*  132306 */     // GIR_Coverage, 47666,
     /*  132306 */     GIR_EraseRootFromParent_Done,
     /*  132307 */   // Label 2342: @132307
     /*  132307 */   GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(132352), // Rule ID 47667 //
     /*  132312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132315 */     // (or:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  132315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  132318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  132332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132350 */     GIR_RootConstrainSelectedInstOperands,
     /*  132351 */     // GIR_Coverage, 47667,
     /*  132351 */     GIR_EraseRootFromParent_Done,
     /*  132352 */   // Label 2343: @132352
     /*  132352 */   GIM_Reject,
     /*  132353 */ // Label 2341: @132353
     /*  132353 */ GIM_Reject,
     /*  132354 */ // Label 2210: @132354
     /*  132354 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(132468),
     /*  132359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  132362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  132365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132369 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132377 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(132422), // Rule ID 47686 //
     /*  132382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132385 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  132385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  132388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  132402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132420 */     GIR_RootConstrainSelectedInstOperands,
     /*  132421 */     // GIR_Coverage, 47686,
     /*  132421 */     GIR_EraseRootFromParent_Done,
     /*  132422 */   // Label 2345: @132422
     /*  132422 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(132467), // Rule ID 47687 //
     /*  132427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132430 */     // (or:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  132430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  132433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  132447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  132462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132465 */     GIR_RootConstrainSelectedInstOperands,
     /*  132466 */     // GIR_Coverage, 47687,
     /*  132466 */     GIR_EraseRootFromParent_Done,
     /*  132467 */   // Label 2346: @132467
     /*  132467 */   GIM_Reject,
     /*  132468 */ // Label 2344: @132468
     /*  132468 */ GIM_Reject,
     /*  132469 */ // Label 2211: @132469
     /*  132469 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(132583),
     /*  132474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  132477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  132480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  132484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  132488 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  132492 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(132537), // Rule ID 47722 //
     /*  132497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132500 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  132500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  132503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  132517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  132532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132535 */     GIR_RootConstrainSelectedInstOperands,
     /*  132536 */     // GIR_Coverage, 47722,
     /*  132536 */     GIR_EraseRootFromParent_Done,
     /*  132537 */   // Label 2348: @132537
     /*  132537 */   GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(132582), // Rule ID 47723 //
     /*  132542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132545 */     // (or:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  132545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  132548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  132562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  132577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132580 */     GIR_RootConstrainSelectedInstOperands,
     /*  132581 */     // GIR_Coverage, 47723,
     /*  132581 */     GIR_EraseRootFromParent_Done,
     /*  132582 */   // Label 2349: @132582
     /*  132582 */   GIM_Reject,
     /*  132583 */ // Label 2347: @132583
     /*  132583 */ GIM_Reject,
     /*  132584 */ // Label 2212: @132584
     /*  132584 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(132698),
     /*  132589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  132592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  132595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  132599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  132603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  132607 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(132652), // Rule ID 47738 //
     /*  132612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  132615 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  132615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  132618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  132632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  132647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132650 */     GIR_RootConstrainSelectedInstOperands,
     /*  132651 */     // GIR_Coverage, 47738,
     /*  132651 */     GIR_EraseRootFromParent_Done,
     /*  132652 */   // Label 2351: @132652
     /*  132652 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(132697), // Rule ID 47739 //
     /*  132657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  132660 */     // (or:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  132660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  132663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  132667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  132672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  132674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  132677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  132682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  132684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  132686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  132692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  132695 */     GIR_RootConstrainSelectedInstOperands,
     /*  132696 */     // GIR_Coverage, 47739,
     /*  132696 */     GIR_EraseRootFromParent_Done,
     /*  132697 */   // Label 2352: @132697
     /*  132697 */   GIM_Reject,
     /*  132698 */ // Label 2350: @132698
     /*  132698 */ GIM_Reject,
     /*  132699 */ // Label 2213: @132699
     /*  132699 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(133309),
     /*  132704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  132707 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  132710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132714 */   GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(132780), // Rule ID 71423 //
     /*  132719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  132734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  132738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132761 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  132761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  132764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  132772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132778 */     GIR_RootConstrainSelectedInstOperands,
     /*  132779 */     // GIR_Coverage, 71423,
     /*  132779 */     GIR_EraseRootFromParent_Done,
     /*  132780 */   // Label 2354: @132780
     /*  132780 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(132846), // Rule ID 71424 //
     /*  132785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  132800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  132804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  132808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  132816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132827 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  132827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  132830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  132838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132844 */     GIR_RootConstrainSelectedInstOperands,
     /*  132845 */     // GIR_Coverage, 71424,
     /*  132845 */     GIR_EraseRootFromParent_Done,
     /*  132846 */   // Label 2355: @132846
     /*  132846 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(132912), // Rule ID 71421 //
     /*  132851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  132866 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  132870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  132879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  132887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132893 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  132893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  132896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  132904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132910 */     GIR_RootConstrainSelectedInstOperands,
     /*  132911 */     // GIR_Coverage, 71421,
     /*  132911 */     GIR_EraseRootFromParent_Done,
     /*  132912 */   // Label 2356: @132912
     /*  132912 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(132978), // Rule ID 71422 //
     /*  132917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  132920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  132924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  132932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  132936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  132945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  132949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  132953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  132959 */     // (or:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs1)  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  132959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  132962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  132964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  132966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  132970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  132973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  132976 */     GIR_RootConstrainSelectedInstOperands,
     /*  132977 */     // GIR_Coverage, 71422,
     /*  132977 */     GIR_EraseRootFromParent_Done,
     /*  132978 */   // Label 2357: @132978
     /*  132978 */   GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(133044), // Rule ID 71419 //
     /*  132983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  132986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  132990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  132994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  132998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  133002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  133006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133014 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133025 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  133028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133042 */     GIR_RootConstrainSelectedInstOperands,
     /*  133043 */     // GIR_Coverage, 71419,
     /*  133043 */     GIR_EraseRootFromParent_Done,
     /*  133044 */   // Label 2358: @133044
     /*  133044 */   GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(133110), // Rule ID 71420 //
     /*  133049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  133068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  133072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133091 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  133094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133108 */     GIR_RootConstrainSelectedInstOperands,
     /*  133109 */     // GIR_Coverage, 71420,
     /*  133109 */     GIR_EraseRootFromParent_Done,
     /*  133110 */   // Label 2359: @133110
     /*  133110 */   GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(133176), // Rule ID 53102 //
     /*  133115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  133134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  133138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133157 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  133160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133174 */     GIR_RootConstrainSelectedInstOperands,
     /*  133175 */     // GIR_Coverage, 53102,
     /*  133175 */     GIR_EraseRootFromParent_Done,
     /*  133176 */   // Label 2360: @133176
     /*  133176 */   GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(133242), // Rule ID 53103 //
     /*  133181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  133192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  133200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  133204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133223 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  133226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133240 */     GIR_RootConstrainSelectedInstOperands,
     /*  133241 */     // GIR_Coverage, 53103,
     /*  133241 */     GIR_EraseRootFromParent_Done,
     /*  133242 */   // Label 2361: @133242
     /*  133242 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(133275), // Rule ID 53090 //
     /*  133247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133258 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  133261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133273 */     GIR_RootConstrainSelectedInstOperands,
     /*  133274 */     // GIR_Coverage, 53090,
     /*  133274 */     GIR_EraseRootFromParent_Done,
     /*  133275 */   // Label 2362: @133275
     /*  133275 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(133308), // Rule ID 53091 //
     /*  133280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133283 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133291 */     // (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  133294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133306 */     GIR_RootConstrainSelectedInstOperands,
     /*  133307 */     // GIR_Coverage, 53091,
     /*  133307 */     GIR_EraseRootFromParent_Done,
     /*  133308 */   // Label 2363: @133308
     /*  133308 */   GIM_Reject,
     /*  133309 */ // Label 2353: @133309
     /*  133309 */ GIM_Reject,
     /*  133310 */ // Label 2214: @133310
     /*  133310 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(133424),
     /*  133315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  133318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  133321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133333 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(133378), // Rule ID 47682 //
     /*  133338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133341 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  133341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  133344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  133358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133376 */     GIR_RootConstrainSelectedInstOperands,
     /*  133377 */     // GIR_Coverage, 47682,
     /*  133377 */     GIR_EraseRootFromParent_Done,
     /*  133378 */   // Label 2365: @133378
     /*  133378 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(133423), // Rule ID 47683 //
     /*  133383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133386 */     // (or:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  133386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  133389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  133403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133421 */     GIR_RootConstrainSelectedInstOperands,
     /*  133422 */     // GIR_Coverage, 47683,
     /*  133422 */     GIR_EraseRootFromParent_Done,
     /*  133423 */   // Label 2366: @133423
     /*  133423 */   GIM_Reject,
     /*  133424 */ // Label 2364: @133424
     /*  133424 */ GIM_Reject,
     /*  133425 */ // Label 2215: @133425
     /*  133425 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(133539),
     /*  133430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  133433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  133436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  133448 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(133493), // Rule ID 47710 //
     /*  133453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133456 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  133456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  133459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  133473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133491 */     GIR_RootConstrainSelectedInstOperands,
     /*  133492 */     // GIR_Coverage, 47710,
     /*  133492 */     GIR_EraseRootFromParent_Done,
     /*  133493 */   // Label 2368: @133493
     /*  133493 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(133538), // Rule ID 47711 //
     /*  133498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133501 */     // (or:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  133501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  133504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  133518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  133533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133536 */     GIR_RootConstrainSelectedInstOperands,
     /*  133537 */     // GIR_Coverage, 47711,
     /*  133537 */     GIR_EraseRootFromParent_Done,
     /*  133538 */   // Label 2369: @133538
     /*  133538 */   GIM_Reject,
     /*  133539 */ // Label 2367: @133539
     /*  133539 */ GIM_Reject,
     /*  133540 */ // Label 2216: @133540
     /*  133540 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(133654),
     /*  133545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  133548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  133551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133559 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  133563 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(133608), // Rule ID 47726 //
     /*  133568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133571 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  133571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  133574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  133588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  133603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133606 */     GIR_RootConstrainSelectedInstOperands,
     /*  133607 */     // GIR_Coverage, 47726,
     /*  133607 */     GIR_EraseRootFromParent_Done,
     /*  133608 */   // Label 2371: @133608
     /*  133608 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(133653), // Rule ID 47727 //
     /*  133613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133616 */     // (or:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  133616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  133619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  133633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  133648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133651 */     GIR_RootConstrainSelectedInstOperands,
     /*  133652 */     // GIR_Coverage, 47727,
     /*  133652 */     GIR_EraseRootFromParent_Done,
     /*  133653 */   // Label 2372: @133653
     /*  133653 */   GIM_Reject,
     /*  133654 */ // Label 2370: @133654
     /*  133654 */ GIM_Reject,
     /*  133655 */ // Label 2217: @133655
     /*  133655 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(133769),
     /*  133660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  133663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  133666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  133670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  133674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  133678 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(133723), // Rule ID 47742 //
     /*  133683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  133686 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  133686 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  133689 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133693 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  133703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133708 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  133718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133721 */     GIR_RootConstrainSelectedInstOperands,
     /*  133722 */     // GIR_Coverage, 47742,
     /*  133722 */     GIR_EraseRootFromParent_Done,
     /*  133723 */   // Label 2374: @133723
     /*  133723 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(133768), // Rule ID 47743 //
     /*  133728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  133731 */     // (or:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  133731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  133734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  133738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  133743 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  133745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  133748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  133753 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  133755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  133757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  133763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  133766 */     GIR_RootConstrainSelectedInstOperands,
     /*  133767 */     // GIR_Coverage, 47743,
     /*  133767 */     GIR_EraseRootFromParent_Done,
     /*  133768 */   // Label 2375: @133768
     /*  133768 */   GIM_Reject,
     /*  133769 */ // Label 2373: @133769
     /*  133769 */ GIM_Reject,
     /*  133770 */ // Label 2218: @133770
     /*  133770 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(134380),
     /*  133775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  133778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  133781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133785 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(133851), // Rule ID 71451 //
     /*  133790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  133805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  133809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133832 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  133835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133849 */     GIR_RootConstrainSelectedInstOperands,
     /*  133850 */     // GIR_Coverage, 71451,
     /*  133850 */     GIR_EraseRootFromParent_Done,
     /*  133851 */   // Label 2377: @133851
     /*  133851 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(133917), // Rule ID 71452 //
     /*  133856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  133871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  133875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  133879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  133887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133898 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  133898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  133901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  133909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133915 */     GIR_RootConstrainSelectedInstOperands,
     /*  133916 */     // GIR_Coverage, 71452,
     /*  133916 */     GIR_EraseRootFromParent_Done,
     /*  133917 */   // Label 2378: @133917
     /*  133917 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(133983), // Rule ID 71449 //
     /*  133922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  133925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  133937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  133941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  133950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  133954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  133958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  133962 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  133964 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  133964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  133967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  133969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  133971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  133975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  133978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  133981 */     GIR_RootConstrainSelectedInstOperands,
     /*  133982 */     // GIR_Coverage, 71449,
     /*  133982 */     GIR_EraseRootFromParent_Done,
     /*  133983 */   // Label 2379: @133983
     /*  133983 */   GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(134049), // Rule ID 71450 //
     /*  133988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  133991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  133995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  133999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  134003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  134007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134030 */     // (or:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs1)  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  134033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134047 */     GIR_RootConstrainSelectedInstOperands,
     /*  134048 */     // GIR_Coverage, 71450,
     /*  134048 */     GIR_EraseRootFromParent_Done,
     /*  134049 */   // Label 2380: @134049
     /*  134049 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(134115), // Rule ID 71447 //
     /*  134054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  134073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  134077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134096 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  134099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134113 */     GIR_RootConstrainSelectedInstOperands,
     /*  134114 */     // GIR_Coverage, 71447,
     /*  134114 */     GIR_EraseRootFromParent_Done,
     /*  134115 */   // Label 2381: @134115
     /*  134115 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(134181), // Rule ID 71448 //
     /*  134120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  134139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  134143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134160 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134162 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  134165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134179 */     GIR_RootConstrainSelectedInstOperands,
     /*  134180 */     // GIR_Coverage, 71448,
     /*  134180 */     GIR_EraseRootFromParent_Done,
     /*  134181 */   // Label 2382: @134181
     /*  134181 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(134247), // Rule ID 53120 //
     /*  134186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134201 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  134205 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  134209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134214 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134218 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134222 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134228 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  134231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134245 */     GIR_RootConstrainSelectedInstOperands,
     /*  134246 */     // GIR_Coverage, 53120,
     /*  134246 */     GIR_EraseRootFromParent_Done,
     /*  134247 */   // Label 2383: @134247
     /*  134247 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(134313), // Rule ID 53121 //
     /*  134252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  134263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  134271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  134275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134294 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  134297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134311 */     GIR_RootConstrainSelectedInstOperands,
     /*  134312 */     // GIR_Coverage, 53121,
     /*  134312 */     GIR_EraseRootFromParent_Done,
     /*  134313 */   // Label 2384: @134313
     /*  134313 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(134346), // Rule ID 53108 //
     /*  134318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134329 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  134332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134344 */     GIR_RootConstrainSelectedInstOperands,
     /*  134345 */     // GIR_Coverage, 53108,
     /*  134345 */     GIR_EraseRootFromParent_Done,
     /*  134346 */   // Label 2385: @134346
     /*  134346 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(134379), // Rule ID 53109 //
     /*  134351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134362 */     // (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  134365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134377 */     GIR_RootConstrainSelectedInstOperands,
     /*  134378 */     // GIR_Coverage, 53109,
     /*  134378 */     GIR_EraseRootFromParent_Done,
     /*  134379 */   // Label 2386: @134379
     /*  134379 */   GIM_Reject,
     /*  134380 */ // Label 2376: @134380
     /*  134380 */ GIM_Reject,
     /*  134381 */ // Label 2219: @134381
     /*  134381 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(134495),
     /*  134386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  134389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  134392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  134404 */   GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(134449), // Rule ID 47698 //
     /*  134409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134412 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  134412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  134415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  134429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134447 */     GIR_RootConstrainSelectedInstOperands,
     /*  134448 */     // GIR_Coverage, 47698,
     /*  134448 */     GIR_EraseRootFromParent_Done,
     /*  134449 */   // Label 2388: @134449
     /*  134449 */   GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(134494), // Rule ID 47699 //
     /*  134454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134457 */     // (or:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  134457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  134460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  134474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134492 */     GIR_RootConstrainSelectedInstOperands,
     /*  134493 */     // GIR_Coverage, 47699,
     /*  134493 */     GIR_EraseRootFromParent_Done,
     /*  134494 */   // Label 2389: @134494
     /*  134494 */   GIM_Reject,
     /*  134495 */ // Label 2387: @134495
     /*  134495 */ GIM_Reject,
     /*  134496 */ // Label 2220: @134496
     /*  134496 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(134610),
     /*  134501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  134504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  134507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  134519 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(134564), // Rule ID 47714 //
     /*  134524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134527 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  134527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  134530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  134544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134562 */     GIR_RootConstrainSelectedInstOperands,
     /*  134563 */     // GIR_Coverage, 47714,
     /*  134563 */     GIR_EraseRootFromParent_Done,
     /*  134564 */   // Label 2391: @134564
     /*  134564 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(134609), // Rule ID 47715 //
     /*  134569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134572 */     // (or:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  134572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  134575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  134589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  134604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134607 */     GIR_RootConstrainSelectedInstOperands,
     /*  134608 */     // GIR_Coverage, 47715,
     /*  134608 */     GIR_EraseRootFromParent_Done,
     /*  134609 */   // Label 2392: @134609
     /*  134609 */   GIM_Reject,
     /*  134610 */ // Label 2390: @134610
     /*  134610 */ GIM_Reject,
     /*  134611 */ // Label 2221: @134611
     /*  134611 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(134725),
     /*  134616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  134619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  134622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  134634 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(134679), // Rule ID 47730 //
     /*  134639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134642 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  134642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  134645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  134659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134677 */     GIR_RootConstrainSelectedInstOperands,
     /*  134678 */     // GIR_Coverage, 47730,
     /*  134678 */     GIR_EraseRootFromParent_Done,
     /*  134679 */   // Label 2394: @134679
     /*  134679 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(134724), // Rule ID 47731 //
     /*  134684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134687 */     // (or:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  134687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  134690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  134694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  134699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  134701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  134704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  134709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  134711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  134713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  134719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  134722 */     GIR_RootConstrainSelectedInstOperands,
     /*  134723 */     // GIR_Coverage, 47731,
     /*  134723 */     GIR_EraseRootFromParent_Done,
     /*  134724 */   // Label 2395: @134724
     /*  134724 */   GIM_Reject,
     /*  134725 */ // Label 2393: @134725
     /*  134725 */ GIM_Reject,
     /*  134726 */ // Label 2222: @134726
     /*  134726 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(135336),
     /*  134731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  134734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  134737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134741 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(134807), // Rule ID 71479 //
     /*  134746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  134761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  134765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134788 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  134791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134805 */     GIR_RootConstrainSelectedInstOperands,
     /*  134806 */     // GIR_Coverage, 71479,
     /*  134806 */     GIR_EraseRootFromParent_Done,
     /*  134807 */   // Label 2397: @134807
     /*  134807 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(134873), // Rule ID 71480 //
     /*  134812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  134827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  134831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  134835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134843 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134854 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  134857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  134865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134871 */     GIR_RootConstrainSelectedInstOperands,
     /*  134872 */     // GIR_Coverage, 71480,
     /*  134872 */     GIR_EraseRootFromParent_Done,
     /*  134873 */   // Label 2398: @134873
     /*  134873 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(134939), // Rule ID 71477 //
     /*  134878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  134881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  134893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  134897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  134914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134920 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  134920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  134923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  134934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  134937 */     GIR_RootConstrainSelectedInstOperands,
     /*  134938 */     // GIR_Coverage, 71477,
     /*  134938 */     GIR_EraseRootFromParent_Done,
     /*  134939 */   // Label 2399: @134939
     /*  134939 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(135005), // Rule ID 71478 //
     /*  134944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  134947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  134951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  134955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  134959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  134963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  134972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  134976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  134980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  134984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  134986 */     // (or:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs1)  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  134986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  134989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  134991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  134993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  134997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135003 */     GIR_RootConstrainSelectedInstOperands,
     /*  135004 */     // GIR_Coverage, 71478,
     /*  135004 */     GIR_EraseRootFromParent_Done,
     /*  135005 */   // Label 2400: @135005
     /*  135005 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(135071), // Rule ID 71475 //
     /*  135010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  135029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  135033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135041 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135052 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  135055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135069 */     GIR_RootConstrainSelectedInstOperands,
     /*  135070 */     // GIR_Coverage, 71475,
     /*  135070 */     GIR_EraseRootFromParent_Done,
     /*  135071 */   // Label 2401: @135071
     /*  135071 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(135137), // Rule ID 71476 //
     /*  135076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  135095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  135099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135118 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  135121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135135 */     GIR_RootConstrainSelectedInstOperands,
     /*  135136 */     // GIR_Coverage, 71476,
     /*  135136 */     GIR_EraseRootFromParent_Done,
     /*  135137 */   // Label 2402: @135137
     /*  135137 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(135203), // Rule ID 53138 //
     /*  135142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  135161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  135165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135184 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  135187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135201 */     GIR_RootConstrainSelectedInstOperands,
     /*  135202 */     // GIR_Coverage, 53138,
     /*  135202 */     GIR_EraseRootFromParent_Done,
     /*  135203 */   // Label 2403: @135203
     /*  135203 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(135269), // Rule ID 53139 //
     /*  135208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  135227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  135231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135250 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  135253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135267 */     GIR_RootConstrainSelectedInstOperands,
     /*  135268 */     // GIR_Coverage, 53139,
     /*  135268 */     GIR_EraseRootFromParent_Done,
     /*  135269 */   // Label 2404: @135269
     /*  135269 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(135302), // Rule ID 53126 //
     /*  135274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135285 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  135288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135300 */     GIR_RootConstrainSelectedInstOperands,
     /*  135301 */     // GIR_Coverage, 53126,
     /*  135301 */     GIR_EraseRootFromParent_Done,
     /*  135302 */   // Label 2405: @135302
     /*  135302 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(135335), // Rule ID 53127 //
     /*  135307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135318 */     // (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  135321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135333 */     GIR_RootConstrainSelectedInstOperands,
     /*  135334 */     // GIR_Coverage, 53127,
     /*  135334 */     GIR_EraseRootFromParent_Done,
     /*  135335 */   // Label 2406: @135335
     /*  135335 */   GIM_Reject,
     /*  135336 */ // Label 2396: @135336
     /*  135336 */ GIM_Reject,
     /*  135337 */ // Label 2223: @135337
     /*  135337 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(135451),
     /*  135342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  135345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  135348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  135352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  135356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  135360 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(135405), // Rule ID 47702 //
     /*  135365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135368 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  135368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  135371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  135385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135403 */     GIR_RootConstrainSelectedInstOperands,
     /*  135404 */     // GIR_Coverage, 47702,
     /*  135404 */     GIR_EraseRootFromParent_Done,
     /*  135405 */   // Label 2408: @135405
     /*  135405 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(135450), // Rule ID 47703 //
     /*  135410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135413 */     // (or:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  135413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  135416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  135430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135448 */     GIR_RootConstrainSelectedInstOperands,
     /*  135449 */     // GIR_Coverage, 47703,
     /*  135449 */     GIR_EraseRootFromParent_Done,
     /*  135450 */   // Label 2409: @135450
     /*  135450 */   GIM_Reject,
     /*  135451 */ // Label 2407: @135451
     /*  135451 */ GIM_Reject,
     /*  135452 */ // Label 2224: @135452
     /*  135452 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(135566),
     /*  135457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  135460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  135463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  135467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  135471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  135475 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(135520), // Rule ID 47718 //
     /*  135480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135483 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  135483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  135486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  135500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135518 */     GIR_RootConstrainSelectedInstOperands,
     /*  135519 */     // GIR_Coverage, 47718,
     /*  135519 */     GIR_EraseRootFromParent_Done,
     /*  135520 */   // Label 2411: @135520
     /*  135520 */   GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(135565), // Rule ID 47719 //
     /*  135525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135528 */     // (or:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  135528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  135531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  135535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  135540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  135542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  135545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  135550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  135554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  135560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  135563 */     GIR_RootConstrainSelectedInstOperands,
     /*  135564 */     // GIR_Coverage, 47719,
     /*  135564 */     GIR_EraseRootFromParent_Done,
     /*  135565 */   // Label 2412: @135565
     /*  135565 */   GIM_Reject,
     /*  135566 */ // Label 2410: @135566
     /*  135566 */ GIM_Reject,
     /*  135567 */ // Label 2225: @135567
     /*  135567 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(136177),
     /*  135572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135582 */   GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(135648), // Rule ID 71507 //
     /*  135587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135627 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135629 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135646 */     GIR_RootConstrainSelectedInstOperands,
     /*  135647 */     // GIR_Coverage, 71507,
     /*  135647 */     GIR_EraseRootFromParent_Done,
     /*  135648 */   // Label 2414: @135648
     /*  135648 */   GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(135714), // Rule ID 71508 //
     /*  135653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135695 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135712 */     GIR_RootConstrainSelectedInstOperands,
     /*  135713 */     // GIR_Coverage, 71508,
     /*  135713 */     GIR_EraseRootFromParent_Done,
     /*  135714 */   // Label 2415: @135714
     /*  135714 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(135780), // Rule ID 71505 //
     /*  135719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135761 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135778 */     GIR_RootConstrainSelectedInstOperands,
     /*  135779 */     // GIR_Coverage, 71505,
     /*  135779 */     GIR_EraseRootFromParent_Done,
     /*  135780 */   // Label 2416: @135780
     /*  135780 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(135846), // Rule ID 71506 //
     /*  135785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  135792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  135813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135827 */     // (or:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs1)  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  135834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  135838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135844 */     GIR_RootConstrainSelectedInstOperands,
     /*  135845 */     // GIR_Coverage, 71506,
     /*  135845 */     GIR_EraseRootFromParent_Done,
     /*  135846 */   // Label 2417: @135846
     /*  135846 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(135912), // Rule ID 71503 //
     /*  135851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  135886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135893 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  135893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135910 */     GIR_RootConstrainSelectedInstOperands,
     /*  135911 */     // GIR_Coverage, 71503,
     /*  135911 */     GIR_EraseRootFromParent_Done,
     /*  135912 */   // Label 2418: @135912
     /*  135912 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(135978), // Rule ID 71504 //
     /*  135917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  135920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  135936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  135940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  135944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  135948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  135952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  135959 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  135959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  135962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  135964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  135966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  135970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  135973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  135976 */     GIR_RootConstrainSelectedInstOperands,
     /*  135977 */     // GIR_Coverage, 71504,
     /*  135977 */     GIR_EraseRootFromParent_Done,
     /*  135978 */   // Label 2419: @135978
     /*  135978 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(136044), // Rule ID 53156 //
     /*  135983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  135986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  135990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  135994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  135998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  136002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  136006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  136023 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136025 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  136028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136042 */     GIR_RootConstrainSelectedInstOperands,
     /*  136043 */     // GIR_Coverage, 53156,
     /*  136043 */     GIR_EraseRootFromParent_Done,
     /*  136044 */   // Label 2420: @136044
     /*  136044 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(136110), // Rule ID 53157 //
     /*  136049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  136068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  136072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  136081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  136085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  136089 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  136091 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  136094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136108 */     GIR_RootConstrainSelectedInstOperands,
     /*  136109 */     // GIR_Coverage, 53157,
     /*  136109 */     GIR_EraseRootFromParent_Done,
     /*  136110 */   // Label 2421: @136110
     /*  136110 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(136143), // Rule ID 53144 //
     /*  136115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136126 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  136126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  136129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136131 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136141 */     GIR_RootConstrainSelectedInstOperands,
     /*  136142 */     // GIR_Coverage, 53144,
     /*  136142 */     GIR_EraseRootFromParent_Done,
     /*  136143 */   // Label 2422: @136143
     /*  136143 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(136176), // Rule ID 53145 //
     /*  136148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  136159 */     // (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  136159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  136162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  136174 */     GIR_RootConstrainSelectedInstOperands,
     /*  136175 */     // GIR_Coverage, 53145,
     /*  136175 */     GIR_EraseRootFromParent_Done,
     /*  136176 */   // Label 2423: @136176
     /*  136176 */   GIM_Reject,
     /*  136177 */ // Label 2413: @136177
     /*  136177 */ GIM_Reject,
     /*  136178 */ // Label 2226: @136178
     /*  136178 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(136292),
     /*  136183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  136186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  136189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  136193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  136197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  136201 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(136246), // Rule ID 47706 //
     /*  136206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  136209 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  136209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  136212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  136226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136244 */     GIR_RootConstrainSelectedInstOperands,
     /*  136245 */     // GIR_Coverage, 47706,
     /*  136245 */     GIR_EraseRootFromParent_Done,
     /*  136246 */   // Label 2425: @136246
     /*  136246 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(136291), // Rule ID 47707 //
     /*  136251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  136254 */     // (or:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  136254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  136257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  136261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  136271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  136289 */     GIR_RootConstrainSelectedInstOperands,
     /*  136290 */     // GIR_Coverage, 47707,
     /*  136290 */     GIR_EraseRootFromParent_Done,
     /*  136291 */   // Label 2426: @136291
     /*  136291 */   GIM_Reject,
     /*  136292 */ // Label 2424: @136292
     /*  136292 */ GIM_Reject,
     /*  136293 */ // Label 2227: @136293
     /*  136293 */ GIM_Reject,
     /*  136294 */ // Label 9: @136294
     /*  136294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 2458*/ GIMT_Encode4(151200),
     /*  136305 */ /*GILLT_s32*//*Label 2427*/ GIMT_Encode4(136429),
     /*  136309 */ /*GILLT_s64*//*Label 2428*/ GIMT_Encode4(136967),
     /*  136313 */ /*GILLT_nxv1s1*//*Label 2429*/ GIMT_Encode4(137393),
     /*  136317 */ /*GILLT_nxv1s8*//*Label 2430*/ GIMT_Encode4(139004),
     /*  136321 */ /*GILLT_nxv1s16*//*Label 2431*/ GIMT_Encode4(139119),
     /*  136325 */ /*GILLT_nxv1s32*//*Label 2432*/ GIMT_Encode4(139234),
     /*  136329 */ /*GILLT_nxv1s64*//*Label 2433*/ GIMT_Encode4(139349),
     /*  136333 */ /*GILLT_nxv2s1*//*Label 2434*/ GIMT_Encode4(139464),
     /*  136337 */ /*GILLT_nxv2s8*//*Label 2435*/ GIMT_Encode4(141075),
     /*  136341 */ /*GILLT_nxv2s16*//*Label 2436*/ GIMT_Encode4(141190),
     /*  136345 */ /*GILLT_nxv2s32*//*Label 2437*/ GIMT_Encode4(141305),
     /*  136349 */ /*GILLT_nxv2s64*//*Label 2438*/ GIMT_Encode4(141420),
     /*  136353 */ /*GILLT_nxv4s1*//*Label 2439*/ GIMT_Encode4(141535),
     /*  136357 */ /*GILLT_nxv4s8*//*Label 2440*/ GIMT_Encode4(143146),
     /*  136361 */ /*GILLT_nxv4s16*//*Label 2441*/ GIMT_Encode4(143261),
     /*  136365 */ /*GILLT_nxv4s32*//*Label 2442*/ GIMT_Encode4(143376),
     /*  136369 */ /*GILLT_nxv4s64*//*Label 2443*/ GIMT_Encode4(143491),
     /*  136373 */ /*GILLT_nxv8s1*//*Label 2444*/ GIMT_Encode4(143606),
     /*  136377 */ /*GILLT_nxv8s8*//*Label 2445*/ GIMT_Encode4(145217),
     /*  136381 */ /*GILLT_nxv8s16*//*Label 2446*/ GIMT_Encode4(145332),
     /*  136385 */ /*GILLT_nxv8s32*//*Label 2447*/ GIMT_Encode4(145447),
     /*  136389 */ /*GILLT_nxv8s64*//*Label 2448*/ GIMT_Encode4(145562),
     /*  136393 */ /*GILLT_nxv16s1*//*Label 2449*/ GIMT_Encode4(145677),
     /*  136397 */ /*GILLT_nxv16s8*//*Label 2450*/ GIMT_Encode4(147288),
     /*  136401 */ /*GILLT_nxv16s16*//*Label 2451*/ GIMT_Encode4(147403),
     /*  136405 */ /*GILLT_nxv16s32*//*Label 2452*/ GIMT_Encode4(147518),
     /*  136409 */ /*GILLT_nxv32s1*//*Label 2453*/ GIMT_Encode4(147633),
     /*  136413 */ /*GILLT_nxv32s8*//*Label 2454*/ GIMT_Encode4(149244),
     /*  136417 */ /*GILLT_nxv32s16*//*Label 2455*/ GIMT_Encode4(149359),
     /*  136421 */ /*GILLT_nxv64s1*//*Label 2456*/ GIMT_Encode4(149474),
     /*  136425 */ /*GILLT_nxv64s8*//*Label 2457*/ GIMT_Encode4(151085),
     /*  136429 */ // Label 2427: @136429
     /*  136429 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(136966),
     /*  136434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  136437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  136440 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(136523), // Rule ID 2373 //
     /*  136445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  136448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  136460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136464 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136468 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  136472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  136476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136478 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  136485 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } -1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), -1:{ *:[i32] })  =>  (ADDI:{ *:[i32] } (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })
     /*  136485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  136488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  136492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  136497 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  136503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  136508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  136510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  136513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  136518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  136521 */     GIR_RootConstrainSelectedInstOperands,
     /*  136522 */     // GIR_Coverage, 2373,
     /*  136522 */     GIR_EraseRootFromParent_Done,
     /*  136523 */   // Label 2460: @136523
     /*  136523 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(136582), // Rule ID 2367 //
     /*  136528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  136531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  136543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  136555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136561 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  136568 */     // (xor:{ *:[i32] } (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)), GPR:{ *:[i32] }:$rs1)  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  136571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  136575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  136580 */     GIR_RootConstrainSelectedInstOperands,
     /*  136581 */     // GIR_Coverage, 2367,
     /*  136581 */     GIR_EraseRootFromParent_Done,
     /*  136582 */   // Label 2461: @136582
     /*  136582 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(136641), // Rule ID 65138 //
     /*  136587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /*  136590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  136606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136614 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  136618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136620 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  136627 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2)))  =>  (BINV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  136630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  136639 */     GIR_RootConstrainSelectedInstOperands,
     /*  136640 */     // GIR_Coverage, 65138,
     /*  136640 */     GIR_EraseRootFromParent_Done,
     /*  136641 */   // Label 2462: @136641
     /*  136641 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(136697), // Rule ID 65124 //
     /*  136646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  136649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136674 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  136678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136684 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }), GPR:{ *:[i32] }:$rs2)  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  136687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  136693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  136695 */     GIR_RootConstrainSelectedInstOperands,
     /*  136696 */     // GIR_Coverage, 65124,
     /*  136696 */     GIR_EraseRootFromParent_Done,
     /*  136697 */   // Label 2463: @136697
     /*  136697 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(136756), // Rule ID 65122 //
     /*  136702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  136705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  136739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136741 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), -1:{ *:[i32] })  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  136744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  136750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  136754 */     GIR_RootConstrainSelectedInstOperands,
     /*  136755 */     // GIR_Coverage, 65122,
     /*  136755 */     GIR_EraseRootFromParent_Done,
     /*  136756 */   // Label 2464: @136756
     /*  136756 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(136812), // Rule ID 2341 //
     /*  136761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /*  136764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  136780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  136784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  136788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  136797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136799 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs2, -1:{ *:[i32] }))  =>  (XNOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  136802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  136810 */     GIR_RootConstrainSelectedInstOperands,
     /*  136811 */     // GIR_Coverage, 2341,
     /*  136811 */     GIR_EraseRootFromParent_Done,
     /*  136812 */   // Label 2465: @136812
     /*  136812 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(136854), // Rule ID 89 //
     /*  136817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  136820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  136840 */     // MIs[1] Operand 1
     /*  136840 */     // No operand predicates
     /*  136840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136842 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /*  136842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  136845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136847 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  136852 */     GIR_RootConstrainSelectedInstOperands,
     /*  136853 */     // GIR_Coverage, 89,
     /*  136853 */     GIR_EraseRootFromParent_Done,
     /*  136854 */   // Label 2466: @136854
     /*  136854 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(136896), // Rule ID 64502 //
     /*  136859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  136862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  136866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  136870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm32_nosimm26),
     /*  136882 */     // MIs[1] Operand 1
     /*  136882 */     // No operand predicates
     /*  136882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136884 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)  =>  (QC_E_XORAI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm32_nosimm26>>:$imm)
     /*  136884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORAI),
     /*  136887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  136889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  136894 */     GIR_RootConstrainSelectedInstOperands,
     /*  136895 */     // GIR_Coverage, 64502,
     /*  136895 */     GIR_EraseRootFromParent_Done,
     /*  136896 */   // Label 2467: @136896
     /*  136896 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(136938), // Rule ID 64506 //
     /*  136901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcilia_IsRV32_HwMode1),
     /*  136904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  136908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  136912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  136916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  136920 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm26_nosimm12),
     /*  136924 */     // MIs[1] Operand 1
     /*  136924 */     // No operand predicates
     /*  136924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  136926 */     // (xor:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)  =>  (QC_E_XORI:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm26_nosimm12>>:$imm)
     /*  136926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_E_XORI),
     /*  136929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  136931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  136933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  136936 */     GIR_RootConstrainSelectedInstOperands,
     /*  136937 */     // GIR_Coverage, 64506,
     /*  136937 */     GIR_EraseRootFromParent_Done,
     /*  136938 */   // Label 2468: @136938
     /*  136938 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(136965), // Rule ID 87 //
     /*  136943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  136946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136958 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XOR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  136958 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  136963 */     GIR_RootConstrainSelectedInstOperands,
     /*  136964 */     // GIR_Coverage, 87,
     /*  136964 */     GIR_Done,
     /*  136965 */   // Label 2469: @136965
     /*  136965 */   GIM_Reject,
     /*  136966 */ // Label 2459: @136966
     /*  136966 */ GIM_Reject,
     /*  136967 */ // Label 2428: @136967
     /*  136967 */ GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(137392),
     /*  136972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  136975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  136978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  136982 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(137061), // Rule ID 2372 //
     /*  136987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  136990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  136994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  136998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137002 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137006 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  137010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  137014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137016 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  137023 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } -1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), -1:{ *:[i64] })  =>  (ADDI:{ *:[i64] } (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })
     /*  137023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  137026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /*  137030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  137035 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  137041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  137046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  137048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  137051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  137056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137059 */     GIR_RootConstrainSelectedInstOperands,
     /*  137060 */     // GIR_Coverage, 2372,
     /*  137060 */     GIR_EraseRootFromParent_Done,
     /*  137061 */   // Label 2471: @137061
     /*  137061 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(137116), // Rule ID 2366 //
     /*  137066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  137069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  137077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  137089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137095 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  137102 */     // (xor:{ *:[i64] } (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)), GPR:{ *:[i64] }:$rs1)  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  137105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  137109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  137114 */     GIR_RootConstrainSelectedInstOperands,
     /*  137115 */     // GIR_Coverage, 2366,
     /*  137115 */     GIR_EraseRootFromParent_Done,
     /*  137116 */   // Label 2472: @137116
     /*  137116 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(137171), // Rule ID 65137 //
     /*  137121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /*  137124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  137136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137144 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 1,
     /*  137148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137150 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /*  137157 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2)))  =>  (BINV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BINV),
     /*  137160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /*  137169 */     GIR_RootConstrainSelectedInstOperands,
     /*  137170 */     // GIR_Coverage, 65137,
     /*  137170 */     GIR_EraseRootFromParent_Done,
     /*  137171 */   // Label 2473: @137171
     /*  137171 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(137223), // Rule ID 65123 //
     /*  137176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  137179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137200 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  137204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137210 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }), GPR:{ *:[i64] }:$rs2)  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  137213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137221 */     GIR_RootConstrainSelectedInstOperands,
     /*  137222 */     // GIR_Coverage, 65123,
     /*  137222 */     GIR_EraseRootFromParent_Done,
     /*  137223 */   // Label 2474: @137223
     /*  137223 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(137278), // Rule ID 65121 //
     /*  137228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  137231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137257 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  137261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137263 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), -1:{ *:[i64] })  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  137266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137276 */     GIR_RootConstrainSelectedInstOperands,
     /*  137277 */     // GIR_Coverage, 65121,
     /*  137277 */     GIR_EraseRootFromParent_Done,
     /*  137278 */   // Label 2475: @137278
     /*  137278 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(137330), // Rule ID 2340 //
     /*  137283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /*  137286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  137302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  137306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  137315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137317 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs2, -1:{ *:[i64] }))  =>  (XNOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XNOR),
     /*  137320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /*  137328 */     GIR_RootConstrainSelectedInstOperands,
     /*  137329 */     // GIR_Coverage, 2340,
     /*  137329 */     GIR_EraseRootFromParent_Done,
     /*  137330 */   // Label 2476: @137330
     /*  137330 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(137368), // Rule ID 88 //
     /*  137335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  137338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  137346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  137350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /*  137354 */     // MIs[1] Operand 1
     /*  137354 */     // No operand predicates
     /*  137354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  137356 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)  =>  (XORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /*  137356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /*  137359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  137363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  137366 */     GIR_RootConstrainSelectedInstOperands,
     /*  137367 */     // GIR_Coverage, 88,
     /*  137367 */     GIR_EraseRootFromParent_Done,
     /*  137368 */   // Label 2477: @137368
     /*  137368 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(137391), // Rule ID 86 //
     /*  137373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  137376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  137384 */     // (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XOR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  137384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /*  137389 */     GIR_RootConstrainSelectedInstOperands,
     /*  137390 */     // GIR_Coverage, 86,
     /*  137390 */     GIR_Done,
     /*  137391 */   // Label 2478: @137391
     /*  137391 */   GIM_Reject,
     /*  137392 */ // Label 2470: @137392
     /*  137392 */ GIM_Reject,
     /*  137393 */ // Label 2429: @137393
     /*  137393 */ GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(139003),
     /*  137398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137408 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(137477), // Rule ID 53040 //
     /*  137413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  137424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137442 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  137446 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137450 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137456 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  137459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137475 */     GIR_RootConstrainSelectedInstOperands,
     /*  137476 */     // GIR_Coverage, 53040,
     /*  137476 */     GIR_EraseRootFromParent_Done,
     /*  137477 */   // Label 2480: @137477
     /*  137477 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(137546), // Rule ID 53041 //
     /*  137482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  137493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  137515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137525 */     // (xor:{ *:[nxv1i1] } (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  137528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137544 */     GIR_RootConstrainSelectedInstOperands,
     /*  137545 */     // GIR_Coverage, 53041,
     /*  137545 */     GIR_EraseRootFromParent_Done,
     /*  137546 */   // Label 2481: @137546
     /*  137546 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(137615), // Rule ID 53042 //
     /*  137551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  137562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  137584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137594 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  137597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137613 */     GIR_RootConstrainSelectedInstOperands,
     /*  137614 */     // GIR_Coverage, 53042,
     /*  137614 */     GIR_EraseRootFromParent_Done,
     /*  137615 */   // Label 2482: @137615
     /*  137615 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(137684), // Rule ID 53043 //
     /*  137620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  137631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137635 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  137653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137663 */     // (xor:{ *:[nxv1i1] } (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  137666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  137676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137682 */     GIR_RootConstrainSelectedInstOperands,
     /*  137683 */     // GIR_Coverage, 53043,
     /*  137683 */     GIR_EraseRootFromParent_Done,
     /*  137684 */   // Label 2483: @137684
     /*  137684 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(137750), // Rule ID 71321 //
     /*  137689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137704 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137731 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  137734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  137740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137748 */     GIR_RootConstrainSelectedInstOperands,
     /*  137749 */     // GIR_Coverage, 71321,
     /*  137749 */     GIR_EraseRootFromParent_Done,
     /*  137750 */   // Label 2484: @137750
     /*  137750 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(137816), // Rule ID 71322 //
     /*  137755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137770 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  137778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137797 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  137800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  137806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137814 */     GIR_RootConstrainSelectedInstOperands,
     /*  137815 */     // GIR_Coverage, 71322,
     /*  137815 */     GIR_EraseRootFromParent_Done,
     /*  137816 */   // Label 2485: @137816
     /*  137816 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(137882), // Rule ID 71319 //
     /*  137821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137863 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  137866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137880 */     GIR_RootConstrainSelectedInstOperands,
     /*  137881 */     // GIR_Coverage, 71319,
     /*  137881 */     GIR_EraseRootFromParent_Done,
     /*  137882 */   // Label 2486: @137882
     /*  137882 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(137948), // Rule ID 71320 //
     /*  137887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  137890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  137915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  137923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137929 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  137929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  137932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  137934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  137938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  137940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  137943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  137946 */     GIR_RootConstrainSelectedInstOperands,
     /*  137947 */     // GIR_Coverage, 71320,
     /*  137947 */     GIR_EraseRootFromParent_Done,
     /*  137948 */   // Label 2487: @137948
     /*  137948 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(138017), // Rule ID 53044 //
     /*  137953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  137956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  137960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  137964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  137968 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  137972 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  137982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  137986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  137990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  137994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  137996 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  137996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  137999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  138005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138015 */     GIR_RootConstrainSelectedInstOperands,
     /*  138016 */     // GIR_Coverage, 53044,
     /*  138016 */     GIR_EraseRootFromParent_Done,
     /*  138017 */   // Label 2488: @138017
     /*  138017 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(138086), // Rule ID 53045 //
     /*  138022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138063 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138065 */     // (xor:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  138074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  138078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138084 */     GIR_RootConstrainSelectedInstOperands,
     /*  138085 */     // GIR_Coverage, 53045,
     /*  138085 */     GIR_EraseRootFromParent_Done,
     /*  138086 */   // Label 2489: @138086
     /*  138086 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(138155), // Rule ID 71315 //
     /*  138091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  138106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  138114 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138118 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138122 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138134 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138153 */     GIR_RootConstrainSelectedInstOperands,
     /*  138154 */     // GIR_Coverage, 71315,
     /*  138154 */     GIR_EraseRootFromParent_Done,
     /*  138155 */   // Label 2490: @138155
     /*  138155 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(138224), // Rule ID 71316 //
     /*  138160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  138175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  138183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138187 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138203 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138222 */     GIR_RootConstrainSelectedInstOperands,
     /*  138223 */     // GIR_Coverage, 71316,
     /*  138223 */     GIR_EraseRootFromParent_Done,
     /*  138224 */   // Label 2491: @138224
     /*  138224 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(138293), // Rule ID 71317 //
     /*  138229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  138244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  138252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138272 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  138275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138291 */     GIR_RootConstrainSelectedInstOperands,
     /*  138292 */     // GIR_Coverage, 71317,
     /*  138292 */     GIR_EraseRootFromParent_Done,
     /*  138293 */   // Label 2492: @138293
     /*  138293 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(138362), // Rule ID 71318 //
     /*  138298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  138313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  138321 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138325 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138339 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138341 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  138344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138360 */     GIR_RootConstrainSelectedInstOperands,
     /*  138361 */     // GIR_Coverage, 71318,
     /*  138361 */     GIR_EraseRootFromParent_Done,
     /*  138362 */   // Label 2493: @138362
     /*  138362 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(138431), // Rule ID 71323 //
     /*  138367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  138382 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138386 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138390 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138394 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138398 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138410 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138429 */     GIR_RootConstrainSelectedInstOperands,
     /*  138430 */     // GIR_Coverage, 71323,
     /*  138430 */     GIR_EraseRootFromParent_Done,
     /*  138431 */   // Label 2494: @138431
     /*  138431 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(138500), // Rule ID 71324 //
     /*  138436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  138451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  138455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138463 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138479 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  138488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  138492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138498 */     GIR_RootConstrainSelectedInstOperands,
     /*  138499 */     // GIR_Coverage, 71324,
     /*  138499 */     GIR_EraseRootFromParent_Done,
     /*  138500 */   // Label 2495: @138500
     /*  138500 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(138566), // Rule ID 71327 //
     /*  138505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138547 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  138556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  138558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138564 */     GIR_RootConstrainSelectedInstOperands,
     /*  138565 */     // GIR_Coverage, 71327,
     /*  138565 */     GIR_EraseRootFromParent_Done,
     /*  138566 */   // Label 2496: @138566
     /*  138566 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(138632), // Rule ID 71328 //
     /*  138571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  138598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138613 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  138622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  138624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138630 */     GIR_RootConstrainSelectedInstOperands,
     /*  138631 */     // GIR_Coverage, 71328,
     /*  138631 */     GIR_EraseRootFromParent_Done,
     /*  138632 */   // Label 2497: @138632
     /*  138632 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(138698), // Rule ID 71325 //
     /*  138637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  138677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138679 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  138688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  138690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138696 */     GIR_RootConstrainSelectedInstOperands,
     /*  138697 */     // GIR_Coverage, 71325,
     /*  138697 */     GIR_EraseRootFromParent_Done,
     /*  138698 */   // Label 2498: @138698
     /*  138698 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(138764), // Rule ID 71326 //
     /*  138703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  138718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  138722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  138726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  138735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  138743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  138745 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  138748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  138754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  138756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138762 */     GIR_RootConstrainSelectedInstOperands,
     /*  138763 */     // GIR_Coverage, 71326,
     /*  138763 */     GIR_EraseRootFromParent_Done,
     /*  138764 */   // Label 2499: @138764
     /*  138764 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(138807), // Rule ID 71341 //
     /*  138769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  138784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138790 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  138797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  138799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138805 */     GIR_RootConstrainSelectedInstOperands,
     /*  138806 */     // GIR_Coverage, 71341,
     /*  138806 */     GIR_EraseRootFromParent_Done,
     /*  138807 */   // Label 2500: @138807
     /*  138807 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(138850), // Rule ID 71342 //
     /*  138812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  138819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  138827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138833 */     // (xor:{ *:[nxv1i1] } (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv1i1] }:$rs)  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  138840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  138842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138848 */     GIR_RootConstrainSelectedInstOperands,
     /*  138849 */     // GIR_Coverage, 71342,
     /*  138849 */     GIR_EraseRootFromParent_Done,
     /*  138850 */   // Label 2501: @138850
     /*  138850 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(138893), // Rule ID 53050 //
     /*  138855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  138874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138876 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  138883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  138885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138891 */     GIR_RootConstrainSelectedInstOperands,
     /*  138892 */     // GIR_Coverage, 53050,
     /*  138892 */     GIR_EraseRootFromParent_Done,
     /*  138893 */   // Label 2502: @138893
     /*  138893 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(138936), // Rule ID 53051 //
     /*  138898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  138909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  138913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  138917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  138919 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, (riscv_vmset_vl:{ *:[nxv1i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs, VR:{ *:[nxv1i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  138922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  138926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  138928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138934 */     GIR_RootConstrainSelectedInstOperands,
     /*  138935 */     // GIR_Coverage, 53051,
     /*  138935 */     GIR_EraseRootFromParent_Done,
     /*  138936 */   // Label 2503: @138936
     /*  138936 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(138969), // Rule ID 53038 //
     /*  138941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  138944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138952 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  138952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  138955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  138967 */     GIR_RootConstrainSelectedInstOperands,
     /*  138968 */     // GIR_Coverage, 53038,
     /*  138968 */     GIR_EraseRootFromParent_Done,
     /*  138969 */   // Label 2504: @138969
     /*  138969 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(139002), // Rule ID 53039 //
     /*  138974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  138977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  138985 */     // (xor:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2)  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  138985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  138988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  138990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  138992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  138994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  138997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139000 */     GIR_RootConstrainSelectedInstOperands,
     /*  139001 */     // GIR_Coverage, 53039,
     /*  139001 */     GIR_EraseRootFromParent_Done,
     /*  139002 */   // Label 2505: @139002
     /*  139002 */   GIM_Reject,
     /*  139003 */ // Label 2479: @139003
     /*  139003 */ GIM_Reject,
     /*  139004 */ // Label 2430: @139004
     /*  139004 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(139118),
     /*  139009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /*  139012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  139015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139027 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(139072), // Rule ID 47790 //
     /*  139032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139035 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  139035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  139038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  139052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139070 */     GIR_RootConstrainSelectedInstOperands,
     /*  139071 */     // GIR_Coverage, 47790,
     /*  139071 */     GIR_EraseRootFromParent_Done,
     /*  139072 */   // Label 2507: @139072
     /*  139072 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(139117), // Rule ID 47791 //
     /*  139077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139080 */     // (xor:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  139080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  139083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  139097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139115 */     GIR_RootConstrainSelectedInstOperands,
     /*  139116 */     // GIR_Coverage, 47791,
     /*  139116 */     GIR_EraseRootFromParent_Done,
     /*  139117 */   // Label 2508: @139117
     /*  139117 */   GIM_Reject,
     /*  139118 */ // Label 2506: @139118
     /*  139118 */ GIM_Reject,
     /*  139119 */ // Label 2431: @139119
     /*  139119 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(139233),
     /*  139124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /*  139127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  139130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139142 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(139187), // Rule ID 47802 //
     /*  139147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139150 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  139150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  139153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  139167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139185 */     GIR_RootConstrainSelectedInstOperands,
     /*  139186 */     // GIR_Coverage, 47802,
     /*  139186 */     GIR_EraseRootFromParent_Done,
     /*  139187 */   // Label 2510: @139187
     /*  139187 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(139232), // Rule ID 47803 //
     /*  139192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139195 */     // (xor:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  139195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  139198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  139212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  139227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139230 */     GIR_RootConstrainSelectedInstOperands,
     /*  139231 */     // GIR_Coverage, 47803,
     /*  139231 */     GIR_EraseRootFromParent_Done,
     /*  139232 */   // Label 2511: @139232
     /*  139232 */   GIM_Reject,
     /*  139233 */ // Label 2509: @139233
     /*  139233 */ GIM_Reject,
     /*  139234 */ // Label 2432: @139234
     /*  139234 */ GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(139348),
     /*  139239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /*  139242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  139245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139257 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(139302), // Rule ID 47810 //
     /*  139262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139265 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  139265 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  139268 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139272 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  139282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139300 */     GIR_RootConstrainSelectedInstOperands,
     /*  139301 */     // GIR_Coverage, 47810,
     /*  139301 */     GIR_EraseRootFromParent_Done,
     /*  139302 */   // Label 2513: @139302
     /*  139302 */   GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(139347), // Rule ID 47811 //
     /*  139307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139310 */     // (xor:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  139310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  139313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  139327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  139342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139345 */     GIR_RootConstrainSelectedInstOperands,
     /*  139346 */     // GIR_Coverage, 47811,
     /*  139346 */     GIR_EraseRootFromParent_Done,
     /*  139347 */   // Label 2514: @139347
     /*  139347 */   GIM_Reject,
     /*  139348 */ // Label 2512: @139348
     /*  139348 */ GIM_Reject,
     /*  139349 */ // Label 2433: @139349
     /*  139349 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(139463),
     /*  139354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /*  139357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  139360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139372 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(139417), // Rule ID 47826 //
     /*  139377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  139380 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  139380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  139383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  139397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  139412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139415 */     GIR_RootConstrainSelectedInstOperands,
     /*  139416 */     // GIR_Coverage, 47826,
     /*  139416 */     GIR_EraseRootFromParent_Done,
     /*  139417 */   // Label 2516: @139417
     /*  139417 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(139462), // Rule ID 47827 //
     /*  139422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  139425 */     // (xor:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  139425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  139428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  139432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  139437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  139439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  139442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  139447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  139449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  139457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  139460 */     GIR_RootConstrainSelectedInstOperands,
     /*  139461 */     // GIR_Coverage, 47827,
     /*  139461 */     GIR_EraseRootFromParent_Done,
     /*  139462 */   // Label 2517: @139462
     /*  139462 */   GIM_Reject,
     /*  139463 */ // Label 2515: @139463
     /*  139463 */ GIM_Reject,
     /*  139464 */ // Label 2434: @139464
     /*  139464 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(141074),
     /*  139469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139479 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(139548), // Rule ID 53058 //
     /*  139484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  139495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  139517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139527 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  139530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  139536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139546 */     GIR_RootConstrainSelectedInstOperands,
     /*  139547 */     // GIR_Coverage, 53058,
     /*  139547 */     GIR_EraseRootFromParent_Done,
     /*  139548 */   // Label 2519: @139548
     /*  139548 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(139617), // Rule ID 53059 //
     /*  139553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  139564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139577 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  139586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139590 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139596 */     // (xor:{ *:[nxv2i1] } (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  139599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  139605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139615 */     GIR_RootConstrainSelectedInstOperands,
     /*  139616 */     // GIR_Coverage, 53059,
     /*  139616 */     GIR_EraseRootFromParent_Done,
     /*  139617 */   // Label 2520: @139617
     /*  139617 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(139686), // Rule ID 53060 //
     /*  139622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  139633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  139655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139659 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139665 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  139668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  139674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139684 */     GIR_RootConstrainSelectedInstOperands,
     /*  139685 */     // GIR_Coverage, 53060,
     /*  139685 */     GIR_EraseRootFromParent_Done,
     /*  139686 */   // Label 2521: @139686
     /*  139686 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(139755), // Rule ID 53061 //
     /*  139691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  139702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  139724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139734 */     // (xor:{ *:[nxv2i1] } (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  139737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  139743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  139747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139753 */     GIR_RootConstrainSelectedInstOperands,
     /*  139754 */     // GIR_Coverage, 53061,
     /*  139754 */     GIR_EraseRootFromParent_Done,
     /*  139755 */   // Label 2522: @139755
     /*  139755 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(139821), // Rule ID 71349 //
     /*  139760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139787 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139802 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  139805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  139811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139819 */     GIR_RootConstrainSelectedInstOperands,
     /*  139820 */     // GIR_Coverage, 71349,
     /*  139820 */     GIR_EraseRootFromParent_Done,
     /*  139821 */   // Label 2523: @139821
     /*  139821 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(139887), // Rule ID 71350 //
     /*  139826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139841 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  139849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139853 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139868 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  139868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  139871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  139877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139885 */     GIR_RootConstrainSelectedInstOperands,
     /*  139886 */     // GIR_Coverage, 71350,
     /*  139886 */     GIR_EraseRootFromParent_Done,
     /*  139887 */   // Label 2524: @139887
     /*  139887 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(139953), // Rule ID 71347 //
     /*  139892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  139895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  139928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  139934 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  139934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  139937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  139939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  139943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  139945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  139948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  139951 */     GIR_RootConstrainSelectedInstOperands,
     /*  139952 */     // GIR_Coverage, 71347,
     /*  139952 */     GIR_EraseRootFromParent_Done,
     /*  139953 */   // Label 2525: @139953
     /*  139953 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(140019), // Rule ID 71348 //
     /*  139958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  139961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  139965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  139969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  139973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  139977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  139986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  139990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  139994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  139998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140000 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  140011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140017 */     GIR_RootConstrainSelectedInstOperands,
     /*  140018 */     // GIR_Coverage, 71348,
     /*  140018 */     GIR_EraseRootFromParent_Done,
     /*  140019 */   // Label 2526: @140019
     /*  140019 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(140088), // Rule ID 53062 //
     /*  140024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140067 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140086 */     GIR_RootConstrainSelectedInstOperands,
     /*  140087 */     // GIR_Coverage, 53062,
     /*  140087 */     GIR_EraseRootFromParent_Done,
     /*  140088 */   // Label 2527: @140088
     /*  140088 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(140157), // Rule ID 53063 //
     /*  140093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140136 */     // (xor:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  140149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140155 */     GIR_RootConstrainSelectedInstOperands,
     /*  140156 */     // GIR_Coverage, 53063,
     /*  140156 */     GIR_EraseRootFromParent_Done,
     /*  140157 */   // Label 2528: @140157
     /*  140157 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(140226), // Rule ID 71343 //
     /*  140162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  140177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  140185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140205 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140224 */     GIR_RootConstrainSelectedInstOperands,
     /*  140225 */     // GIR_Coverage, 71343,
     /*  140225 */     GIR_EraseRootFromParent_Done,
     /*  140226 */   // Label 2529: @140226
     /*  140226 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(140295), // Rule ID 71344 //
     /*  140231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  140254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140274 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140293 */     GIR_RootConstrainSelectedInstOperands,
     /*  140294 */     // GIR_Coverage, 71344,
     /*  140294 */     GIR_EraseRootFromParent_Done,
     /*  140295 */   // Label 2530: @140295
     /*  140295 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(140364), // Rule ID 71345 //
     /*  140300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  140315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  140323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140343 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  140346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140348 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140362 */     GIR_RootConstrainSelectedInstOperands,
     /*  140363 */     // GIR_Coverage, 71345,
     /*  140363 */     GIR_EraseRootFromParent_Done,
     /*  140364 */   // Label 2531: @140364
     /*  140364 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(140433), // Rule ID 71346 //
     /*  140369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  140392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140412 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  140415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140431 */     GIR_RootConstrainSelectedInstOperands,
     /*  140432 */     // GIR_Coverage, 71346,
     /*  140432 */     GIR_EraseRootFromParent_Done,
     /*  140433 */   // Label 2532: @140433
     /*  140433 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(140502), // Rule ID 71351 //
     /*  140438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  140453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140481 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140500 */     GIR_RootConstrainSelectedInstOperands,
     /*  140501 */     // GIR_Coverage, 71351,
     /*  140501 */     GIR_EraseRootFromParent_Done,
     /*  140502 */   // Label 2533: @140502
     /*  140502 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(140571), // Rule ID 71352 //
     /*  140507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  140526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140550 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  140559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  140563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140569 */     GIR_RootConstrainSelectedInstOperands,
     /*  140570 */     // GIR_Coverage, 71352,
     /*  140570 */     GIR_EraseRootFromParent_Done,
     /*  140571 */   // Label 2534: @140571
     /*  140571 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(140637), // Rule ID 71355 //
     /*  140576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140618 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  140627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  140629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140635 */     GIR_RootConstrainSelectedInstOperands,
     /*  140636 */     // GIR_Coverage, 71355,
     /*  140636 */     GIR_EraseRootFromParent_Done,
     /*  140637 */   // Label 2535: @140637
     /*  140637 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(140703), // Rule ID 71356 //
     /*  140642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140661 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  140669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140684 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  140693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  140695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140701 */     GIR_RootConstrainSelectedInstOperands,
     /*  140702 */     // GIR_Coverage, 71356,
     /*  140702 */     GIR_EraseRootFromParent_Done,
     /*  140703 */   // Label 2536: @140703
     /*  140703 */   GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(140769), // Rule ID 71353 //
     /*  140708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  140748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140750 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  140761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140767 */     GIR_RootConstrainSelectedInstOperands,
     /*  140768 */     // GIR_Coverage, 71353,
     /*  140768 */     GIR_EraseRootFromParent_Done,
     /*  140769 */   // Label 2537: @140769
     /*  140769 */   GIM_Try, /*On fail goto*//*Label 2538*/ GIMT_Encode4(140835), // Rule ID 71354 //
     /*  140774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  140789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  140793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  140797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  140806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  140814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  140816 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  140819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  140825 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  140827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140833 */     GIR_RootConstrainSelectedInstOperands,
     /*  140834 */     // GIR_Coverage, 71354,
     /*  140834 */     GIR_EraseRootFromParent_Done,
     /*  140835 */   // Label 2538: @140835
     /*  140835 */   GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(140878), // Rule ID 71369 //
     /*  140840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  140855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140861 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  140868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  140870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140876 */     GIR_RootConstrainSelectedInstOperands,
     /*  140877 */     // GIR_Coverage, 71369,
     /*  140877 */     GIR_EraseRootFromParent_Done,
     /*  140878 */   // Label 2539: @140878
     /*  140878 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(140921), // Rule ID 71370 //
     /*  140883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  140890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140904 */     // (xor:{ *:[nxv2i1] } (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv2i1] }:$rs)  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  140911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  140913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140919 */     GIR_RootConstrainSelectedInstOperands,
     /*  140920 */     // GIR_Coverage, 71370,
     /*  140920 */     GIR_EraseRootFromParent_Done,
     /*  140921 */   // Label 2540: @140921
     /*  140921 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(140964), // Rule ID 53068 //
     /*  140926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  140929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  140945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140947 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  140947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140952 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  140954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  140956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  140959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  140962 */     GIR_RootConstrainSelectedInstOperands,
     /*  140963 */     // GIR_Coverage, 53068,
     /*  140963 */     GIR_EraseRootFromParent_Done,
     /*  140964 */   // Label 2541: @140964
     /*  140964 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(141007), // Rule ID 53069 //
     /*  140969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  140972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  140976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  140980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  140984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  140988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  140990 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, (riscv_vmset_vl:{ *:[nxv2i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs, VR:{ *:[nxv2i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  140990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  140993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  140995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  140997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  140999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141005 */     GIR_RootConstrainSelectedInstOperands,
     /*  141006 */     // GIR_Coverage, 53069,
     /*  141006 */     GIR_EraseRootFromParent_Done,
     /*  141007 */   // Label 2542: @141007
     /*  141007 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(141040), // Rule ID 53056 //
     /*  141012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141023 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  141026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141038 */     GIR_RootConstrainSelectedInstOperands,
     /*  141039 */     // GIR_Coverage, 53056,
     /*  141039 */     GIR_EraseRootFromParent_Done,
     /*  141040 */   // Label 2543: @141040
     /*  141040 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(141073), // Rule ID 53057 //
     /*  141045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141056 */     // (xor:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2)  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  141059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141071 */     GIR_RootConstrainSelectedInstOperands,
     /*  141072 */     // GIR_Coverage, 53057,
     /*  141072 */     GIR_EraseRootFromParent_Done,
     /*  141073 */   // Label 2544: @141073
     /*  141073 */   GIM_Reject,
     /*  141074 */ // Label 2518: @141074
     /*  141074 */ GIM_Reject,
     /*  141075 */ // Label 2435: @141075
     /*  141075 */ GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(141189),
     /*  141080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /*  141083 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  141086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141094 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141098 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(141143), // Rule ID 47794 //
     /*  141103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141106 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  141106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  141109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  141123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141141 */     GIR_RootConstrainSelectedInstOperands,
     /*  141142 */     // GIR_Coverage, 47794,
     /*  141142 */     GIR_EraseRootFromParent_Done,
     /*  141143 */   // Label 2546: @141143
     /*  141143 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(141188), // Rule ID 47795 //
     /*  141148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141151 */     // (xor:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  141151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  141154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  141168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141186 */     GIR_RootConstrainSelectedInstOperands,
     /*  141187 */     // GIR_Coverage, 47795,
     /*  141187 */     GIR_EraseRootFromParent_Done,
     /*  141188 */   // Label 2547: @141188
     /*  141188 */   GIM_Reject,
     /*  141189 */ // Label 2545: @141189
     /*  141189 */ GIM_Reject,
     /*  141190 */ // Label 2436: @141190
     /*  141190 */ GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(141304),
     /*  141195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  141198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  141201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141213 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(141258), // Rule ID 47806 //
     /*  141218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141221 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  141221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  141224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  141238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  141253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141256 */     GIR_RootConstrainSelectedInstOperands,
     /*  141257 */     // GIR_Coverage, 47806,
     /*  141257 */     GIR_EraseRootFromParent_Done,
     /*  141258 */   // Label 2549: @141258
     /*  141258 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(141303), // Rule ID 47807 //
     /*  141263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141266 */     // (xor:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  141266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  141269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  141283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141285 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  141298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141301 */     GIR_RootConstrainSelectedInstOperands,
     /*  141302 */     // GIR_Coverage, 47807,
     /*  141302 */     GIR_EraseRootFromParent_Done,
     /*  141303 */   // Label 2550: @141303
     /*  141303 */   GIM_Reject,
     /*  141304 */ // Label 2548: @141304
     /*  141304 */ GIM_Reject,
     /*  141305 */ // Label 2437: @141305
     /*  141305 */ GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(141419),
     /*  141310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  141313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  141316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141328 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(141373), // Rule ID 47822 //
     /*  141333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141336 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  141336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  141339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  141353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  141368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141371 */     GIR_RootConstrainSelectedInstOperands,
     /*  141372 */     // GIR_Coverage, 47822,
     /*  141372 */     GIR_EraseRootFromParent_Done,
     /*  141373 */   // Label 2552: @141373
     /*  141373 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(141418), // Rule ID 47823 //
     /*  141378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141381 */     // (xor:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  141381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  141384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  141398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  141413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141416 */     GIR_RootConstrainSelectedInstOperands,
     /*  141417 */     // GIR_Coverage, 47823,
     /*  141417 */     GIR_EraseRootFromParent_Done,
     /*  141418 */   // Label 2553: @141418
     /*  141418 */   GIM_Reject,
     /*  141419 */ // Label 2551: @141419
     /*  141419 */ GIM_Reject,
     /*  141420 */ // Label 2438: @141420
     /*  141420 */ GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(141534),
     /*  141425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  141428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  141431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  141435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  141439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  141443 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(141488), // Rule ID 47866 //
     /*  141448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  141451 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  141451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  141454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  141468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141486 */     GIR_RootConstrainSelectedInstOperands,
     /*  141487 */     // GIR_Coverage, 47866,
     /*  141487 */     GIR_EraseRootFromParent_Done,
     /*  141488 */   // Label 2555: @141488
     /*  141488 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(141533), // Rule ID 47867 //
     /*  141493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  141496 */     // (xor:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  141496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  141499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  141503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  141508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  141510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  141513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  141518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  141520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  141528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  141531 */     GIR_RootConstrainSelectedInstOperands,
     /*  141532 */     // GIR_Coverage, 47867,
     /*  141532 */     GIR_EraseRootFromParent_Done,
     /*  141533 */   // Label 2556: @141533
     /*  141533 */   GIM_Reject,
     /*  141534 */ // Label 2554: @141534
     /*  141534 */ GIM_Reject,
     /*  141535 */ // Label 2439: @141535
     /*  141535 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(143145),
     /*  141540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141550 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(141619), // Rule ID 53076 //
     /*  141555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141598 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  141601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141617 */     GIR_RootConstrainSelectedInstOperands,
     /*  141618 */     // GIR_Coverage, 53076,
     /*  141618 */     GIR_EraseRootFromParent_Done,
     /*  141619 */   // Label 2558: @141619
     /*  141619 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(141688), // Rule ID 53077 //
     /*  141624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  141635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141648 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141667 */     // (xor:{ *:[nxv4i1] } (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  141670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141686 */     GIR_RootConstrainSelectedInstOperands,
     /*  141687 */     // GIR_Coverage, 53077,
     /*  141687 */     GIR_EraseRootFromParent_Done,
     /*  141688 */   // Label 2559: @141688
     /*  141688 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(141757), // Rule ID 53078 //
     /*  141693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141736 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  141739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141755 */     GIR_RootConstrainSelectedInstOperands,
     /*  141756 */     // GIR_Coverage, 53078,
     /*  141756 */     GIR_EraseRootFromParent_Done,
     /*  141757 */   // Label 2560: @141757
     /*  141757 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(141826), // Rule ID 53079 //
     /*  141762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  141773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141777 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  141795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141805 */     // (xor:{ *:[nxv4i1] } (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  141808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  141814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  141818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141824 */     GIR_RootConstrainSelectedInstOperands,
     /*  141825 */     // GIR_Coverage, 53079,
     /*  141825 */     GIR_EraseRootFromParent_Done,
     /*  141826 */   // Label 2561: @141826
     /*  141826 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(141892), // Rule ID 71377 //
     /*  141831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141850 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141854 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141858 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141873 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  141873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  141876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141890 */     GIR_RootConstrainSelectedInstOperands,
     /*  141891 */     // GIR_Coverage, 71377,
     /*  141891 */     GIR_EraseRootFromParent_Done,
     /*  141892 */   // Label 2562: @141892
     /*  141892 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(141958), // Rule ID 71378 //
     /*  141897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  141900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141912 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  141920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  141928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  141939 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  141939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  141942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  141944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  141948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  141950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  141953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  141956 */     GIR_RootConstrainSelectedInstOperands,
     /*  141957 */     // GIR_Coverage, 71378,
     /*  141957 */     GIR_EraseRootFromParent_Done,
     /*  141958 */   // Label 2563: @141958
     /*  141958 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(142024), // Rule ID 71375 //
     /*  141963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  141966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  141970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  141974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  141978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  141982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  141987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  141991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  141995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  141999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142005 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142022 */     GIR_RootConstrainSelectedInstOperands,
     /*  142023 */     // GIR_Coverage, 71375,
     /*  142023 */     GIR_EraseRootFromParent_Done,
     /*  142024 */   // Label 2564: @142024
     /*  142024 */   GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(142090), // Rule ID 71376 //
     /*  142029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142053 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142057 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142061 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142071 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  142082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142088 */     GIR_RootConstrainSelectedInstOperands,
     /*  142089 */     // GIR_Coverage, 71376,
     /*  142089 */     GIR_EraseRootFromParent_Done,
     /*  142090 */   // Label 2565: @142090
     /*  142090 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(142159), // Rule ID 53080 //
     /*  142095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142138 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142157 */     GIR_RootConstrainSelectedInstOperands,
     /*  142158 */     // GIR_Coverage, 53080,
     /*  142158 */     GIR_EraseRootFromParent_Done,
     /*  142159 */   // Label 2566: @142159
     /*  142159 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(142228), // Rule ID 53081 //
     /*  142164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142205 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142207 */     // (xor:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142216 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  142220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142226 */     GIR_RootConstrainSelectedInstOperands,
     /*  142227 */     // GIR_Coverage, 53081,
     /*  142227 */     GIR_EraseRootFromParent_Done,
     /*  142228 */   // Label 2567: @142228
     /*  142228 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(142297), // Rule ID 71371 //
     /*  142233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142276 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  142279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142295 */     GIR_RootConstrainSelectedInstOperands,
     /*  142296 */     // GIR_Coverage, 71371,
     /*  142296 */     GIR_EraseRootFromParent_Done,
     /*  142297 */   // Label 2568: @142297
     /*  142297 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(142366), // Rule ID 71372 //
     /*  142302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  142325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142329 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142338 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142345 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  142348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142364 */     GIR_RootConstrainSelectedInstOperands,
     /*  142365 */     // GIR_Coverage, 71372,
     /*  142365 */     GIR_EraseRootFromParent_Done,
     /*  142366 */   // Label 2569: @142366
     /*  142366 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(142435), // Rule ID 71373 //
     /*  142371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142398 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142407 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142412 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142414 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  142417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142433 */     GIR_RootConstrainSelectedInstOperands,
     /*  142434 */     // GIR_Coverage, 71373,
     /*  142434 */     GIR_EraseRootFromParent_Done,
     /*  142435 */   // Label 2570: @142435
     /*  142435 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(142504), // Rule ID 71374 //
     /*  142440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  142463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142471 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142483 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  142486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142502 */     GIR_RootConstrainSelectedInstOperands,
     /*  142503 */     // GIR_Coverage, 71374,
     /*  142503 */     GIR_EraseRootFromParent_Done,
     /*  142504 */   // Label 2571: @142504
     /*  142504 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(142573), // Rule ID 71379 //
     /*  142509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142532 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142536 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142552 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142571 */     GIR_RootConstrainSelectedInstOperands,
     /*  142572 */     // GIR_Coverage, 71379,
     /*  142572 */     GIR_EraseRootFromParent_Done,
     /*  142573 */   // Label 2572: @142573
     /*  142573 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(142642), // Rule ID 71380 //
     /*  142578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  142597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142605 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142609 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142614 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142621 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  142630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  142634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142640 */     GIR_RootConstrainSelectedInstOperands,
     /*  142641 */     // GIR_Coverage, 71380,
     /*  142641 */     GIR_EraseRootFromParent_Done,
     /*  142642 */   // Label 2573: @142642
     /*  142642 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(142708), // Rule ID 71383 //
     /*  142647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142689 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142706 */     GIR_RootConstrainSelectedInstOperands,
     /*  142707 */     // GIR_Coverage, 71383,
     /*  142707 */     GIR_EraseRootFromParent_Done,
     /*  142708 */   // Label 2574: @142708
     /*  142708 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(142774), // Rule ID 71384 //
     /*  142713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  142740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142755 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  142764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142772 */     GIR_RootConstrainSelectedInstOperands,
     /*  142773 */     // GIR_Coverage, 71384,
     /*  142773 */     GIR_EraseRootFromParent_Done,
     /*  142774 */   // Label 2575: @142774
     /*  142774 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(142840), // Rule ID 71381 //
     /*  142779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142798 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  142819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142821 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142838 */     GIR_RootConstrainSelectedInstOperands,
     /*  142839 */     // GIR_Coverage, 71381,
     /*  142839 */     GIR_EraseRootFromParent_Done,
     /*  142840 */   // Label 2576: @142840
     /*  142840 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(142906), // Rule ID 71382 //
     /*  142845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  142856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  142860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  142864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  142868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  142877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  142885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  142887 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  142890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  142896 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  142898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142904 */     GIR_RootConstrainSelectedInstOperands,
     /*  142905 */     // GIR_Coverage, 71382,
     /*  142905 */     GIR_EraseRootFromParent_Done,
     /*  142906 */   // Label 2577: @142906
     /*  142906 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(142949), // Rule ID 71397 //
     /*  142911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  142914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  142926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142932 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  142932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  142935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142947 */     GIR_RootConstrainSelectedInstOperands,
     /*  142948 */     // GIR_Coverage, 71397,
     /*  142948 */     GIR_EraseRootFromParent_Done,
     /*  142949 */   // Label 2578: @142949
     /*  142949 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(142992), // Rule ID 71398 //
     /*  142954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  142957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  142961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  142965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  142969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  142973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  142975 */     // (xor:{ *:[nxv4i1] } (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv4i1] }:$rs)  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  142975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  142978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  142980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  142984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  142987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  142990 */     GIR_RootConstrainSelectedInstOperands,
     /*  142991 */     // GIR_Coverage, 71398,
     /*  142991 */     GIR_EraseRootFromParent_Done,
     /*  142992 */   // Label 2579: @142992
     /*  142992 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(143035), // Rule ID 53086 //
     /*  142997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  143016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143018 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  143021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143033 */     GIR_RootConstrainSelectedInstOperands,
     /*  143034 */     // GIR_Coverage, 53086,
     /*  143034 */     GIR_EraseRootFromParent_Done,
     /*  143035 */   // Label 2580: @143035
     /*  143035 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(143078), // Rule ID 53087 //
     /*  143040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  143051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  143059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  143061 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, (riscv_vmset_vl:{ *:[nxv4i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs, VR:{ *:[nxv4i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  143064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  143070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143076 */     GIR_RootConstrainSelectedInstOperands,
     /*  143077 */     // GIR_Coverage, 53087,
     /*  143077 */     GIR_EraseRootFromParent_Done,
     /*  143078 */   // Label 2581: @143078
     /*  143078 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(143111), // Rule ID 53074 //
     /*  143083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143094 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  143097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143109 */     GIR_RootConstrainSelectedInstOperands,
     /*  143110 */     // GIR_Coverage, 53074,
     /*  143110 */     GIR_EraseRootFromParent_Done,
     /*  143111 */   // Label 2582: @143111
     /*  143111 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(143144), // Rule ID 53075 //
     /*  143116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143127 */     // (xor:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2)  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  143130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143142 */     GIR_RootConstrainSelectedInstOperands,
     /*  143143 */     // GIR_Coverage, 53075,
     /*  143143 */     GIR_EraseRootFromParent_Done,
     /*  143144 */   // Label 2583: @143144
     /*  143144 */   GIM_Reject,
     /*  143145 */ // Label 2557: @143145
     /*  143145 */ GIM_Reject,
     /*  143146 */ // Label 2440: @143146
     /*  143146 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(143260),
     /*  143151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /*  143154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  143157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143169 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(143214), // Rule ID 47798 //
     /*  143174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143177 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  143177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  143180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143212 */     GIR_RootConstrainSelectedInstOperands,
     /*  143213 */     // GIR_Coverage, 47798,
     /*  143213 */     GIR_EraseRootFromParent_Done,
     /*  143214 */   // Label 2585: @143214
     /*  143214 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(143259), // Rule ID 47799 //
     /*  143219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143222 */     // (xor:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  143222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  143225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  143239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143257 */     GIR_RootConstrainSelectedInstOperands,
     /*  143258 */     // GIR_Coverage, 47799,
     /*  143258 */     GIR_EraseRootFromParent_Done,
     /*  143259 */   // Label 2586: @143259
     /*  143259 */   GIM_Reject,
     /*  143260 */ // Label 2584: @143260
     /*  143260 */ GIM_Reject,
     /*  143261 */ // Label 2441: @143261
     /*  143261 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(143375),
     /*  143266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  143269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  143272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143284 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(143329), // Rule ID 47818 //
     /*  143289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143292 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  143292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  143295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143327 */     GIR_RootConstrainSelectedInstOperands,
     /*  143328 */     // GIR_Coverage, 47818,
     /*  143328 */     GIR_EraseRootFromParent_Done,
     /*  143329 */   // Label 2588: @143329
     /*  143329 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(143374), // Rule ID 47819 //
     /*  143334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143337 */     // (xor:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  143337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  143340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  143354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  143369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143372 */     GIR_RootConstrainSelectedInstOperands,
     /*  143373 */     // GIR_Coverage, 47819,
     /*  143373 */     GIR_EraseRootFromParent_Done,
     /*  143374 */   // Label 2589: @143374
     /*  143374 */   GIM_Reject,
     /*  143375 */ // Label 2587: @143375
     /*  143375 */ GIM_Reject,
     /*  143376 */ // Label 2442: @143376
     /*  143376 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(143490),
     /*  143381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  143384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  143387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  143399 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(143444), // Rule ID 47854 //
     /*  143404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143407 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  143407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  143410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  143424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143442 */     GIR_RootConstrainSelectedInstOperands,
     /*  143443 */     // GIR_Coverage, 47854,
     /*  143443 */     GIR_EraseRootFromParent_Done,
     /*  143444 */   // Label 2591: @143444
     /*  143444 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(143489), // Rule ID 47855 //
     /*  143449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143452 */     // (xor:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  143452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  143455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  143469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  143484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143487 */     GIR_RootConstrainSelectedInstOperands,
     /*  143488 */     // GIR_Coverage, 47855,
     /*  143488 */     GIR_EraseRootFromParent_Done,
     /*  143489 */   // Label 2592: @143489
     /*  143489 */   GIM_Reject,
     /*  143490 */ // Label 2590: @143490
     /*  143490 */ GIM_Reject,
     /*  143491 */ // Label 2443: @143491
     /*  143491 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(143605),
     /*  143496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /*  143499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  143502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  143514 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(143559), // Rule ID 47870 //
     /*  143519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  143522 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  143522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  143525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  143539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143557 */     GIR_RootConstrainSelectedInstOperands,
     /*  143558 */     // GIR_Coverage, 47870,
     /*  143558 */     GIR_EraseRootFromParent_Done,
     /*  143559 */   // Label 2594: @143559
     /*  143559 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(143604), // Rule ID 47871 //
     /*  143564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  143567 */     // (xor:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  143567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  143570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  143574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  143579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  143581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  143584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  143589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  143591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  143599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  143602 */     GIR_RootConstrainSelectedInstOperands,
     /*  143603 */     // GIR_Coverage, 47871,
     /*  143603 */     GIR_EraseRootFromParent_Done,
     /*  143604 */   // Label 2595: @143604
     /*  143604 */   GIM_Reject,
     /*  143605 */ // Label 2593: @143605
     /*  143605 */ GIM_Reject,
     /*  143606 */ // Label 2444: @143606
     /*  143606 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(145216),
     /*  143611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143621 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(143690), // Rule ID 53094 //
     /*  143626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143669 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  143672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143688 */     GIR_RootConstrainSelectedInstOperands,
     /*  143689 */     // GIR_Coverage, 53094,
     /*  143689 */     GIR_EraseRootFromParent_Done,
     /*  143690 */   // Label 2597: @143690
     /*  143690 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(143759), // Rule ID 53095 //
     /*  143695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  143706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143738 */     // (xor:{ *:[nxv8i1] } (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  143741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143757 */     GIR_RootConstrainSelectedInstOperands,
     /*  143758 */     // GIR_Coverage, 53095,
     /*  143758 */     GIR_EraseRootFromParent_Done,
     /*  143759 */   // Label 2598: @143759
     /*  143759 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(143828), // Rule ID 53096 //
     /*  143764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143801 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143807 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  143810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143826 */     GIR_RootConstrainSelectedInstOperands,
     /*  143827 */     // GIR_Coverage, 53096,
     /*  143827 */     GIR_EraseRootFromParent_Done,
     /*  143828 */   // Label 2599: @143828
     /*  143828 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(143897), // Rule ID 53097 //
     /*  143833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  143844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  143866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143876 */     // (xor:{ *:[nxv8i1] } (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  143876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  143879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  143885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  143889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143895 */     GIR_RootConstrainSelectedInstOperands,
     /*  143896 */     // GIR_Coverage, 53097,
     /*  143896 */     GIR_EraseRootFromParent_Done,
     /*  143897 */   // Label 2600: @143897
     /*  143897 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(143963), // Rule ID 71405 //
     /*  143902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  143905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143929 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  143933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  143942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  143944 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  143944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  143947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  143949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  143953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  143955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  143958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  143961 */     GIR_RootConstrainSelectedInstOperands,
     /*  143962 */     // GIR_Coverage, 71405,
     /*  143962 */     GIR_EraseRootFromParent_Done,
     /*  143963 */   // Label 2601: @143963
     /*  143963 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(144029), // Rule ID 71406 //
     /*  143968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  143971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  143975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  143979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  143983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  143987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  143991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  143995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  143999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144010 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144027 */     GIR_RootConstrainSelectedInstOperands,
     /*  144028 */     // GIR_Coverage, 71406,
     /*  144028 */     GIR_EraseRootFromParent_Done,
     /*  144029 */   // Label 2602: @144029
     /*  144029 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(144095), // Rule ID 71403 //
     /*  144034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144076 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144093 */     GIR_RootConstrainSelectedInstOperands,
     /*  144094 */     // GIR_Coverage, 71403,
     /*  144094 */     GIR_EraseRootFromParent_Done,
     /*  144095 */   // Label 2603: @144095
     /*  144095 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(144161), // Rule ID 71404 //
     /*  144100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144115 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144142 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  144153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144159 */     GIR_RootConstrainSelectedInstOperands,
     /*  144160 */     // GIR_Coverage, 71404,
     /*  144160 */     GIR_EraseRootFromParent_Done,
     /*  144161 */   // Label 2604: @144161
     /*  144161 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(144230), // Rule ID 53098 //
     /*  144166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144209 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144228 */     GIR_RootConstrainSelectedInstOperands,
     /*  144229 */     // GIR_Coverage, 53098,
     /*  144229 */     GIR_EraseRootFromParent_Done,
     /*  144230 */   // Label 2605: @144230
     /*  144230 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(144299), // Rule ID 53099 //
     /*  144235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144278 */     // (xor:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  144291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144297 */     GIR_RootConstrainSelectedInstOperands,
     /*  144298 */     // GIR_Coverage, 53099,
     /*  144298 */     GIR_EraseRootFromParent_Done,
     /*  144299 */   // Label 2606: @144299
     /*  144299 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(144368), // Rule ID 71399 //
     /*  144304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144335 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144340 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144345 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144347 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  144350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144366 */     GIR_RootConstrainSelectedInstOperands,
     /*  144367 */     // GIR_Coverage, 71399,
     /*  144367 */     GIR_EraseRootFromParent_Done,
     /*  144368 */   // Label 2607: @144368
     /*  144368 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(144437), // Rule ID 71400 //
     /*  144373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  144396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144400 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144409 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144416 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  144419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144435 */     GIR_RootConstrainSelectedInstOperands,
     /*  144436 */     // GIR_Coverage, 71400,
     /*  144436 */     GIR_EraseRootFromParent_Done,
     /*  144437 */   // Label 2608: @144437
     /*  144437 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(144506), // Rule ID 71401 //
     /*  144442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144485 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  144488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144504 */     GIR_RootConstrainSelectedInstOperands,
     /*  144505 */     // GIR_Coverage, 71401,
     /*  144505 */     GIR_EraseRootFromParent_Done,
     /*  144506 */   // Label 2609: @144506
     /*  144506 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(144575), // Rule ID 71402 //
     /*  144511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  144534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144554 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  144557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144573 */     GIR_RootConstrainSelectedInstOperands,
     /*  144574 */     // GIR_Coverage, 71402,
     /*  144574 */     GIR_EraseRootFromParent_Done,
     /*  144575 */   // Label 2610: @144575
     /*  144575 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(144644), // Rule ID 71407 //
     /*  144580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144621 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144623 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144642 */     GIR_RootConstrainSelectedInstOperands,
     /*  144643 */     // GIR_Coverage, 71407,
     /*  144643 */     GIR_EraseRootFromParent_Done,
     /*  144644 */   // Label 2611: @144644
     /*  144644 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(144713), // Rule ID 71408 //
     /*  144649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  144664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  144668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144692 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  144701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  144705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144711 */     GIR_RootConstrainSelectedInstOperands,
     /*  144712 */     // GIR_Coverage, 71408,
     /*  144712 */     GIR_EraseRootFromParent_Done,
     /*  144713 */   // Label 2612: @144713
     /*  144713 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(144779), // Rule ID 71411 //
     /*  144718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144760 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144777 */     GIR_RootConstrainSelectedInstOperands,
     /*  144778 */     // GIR_Coverage, 71411,
     /*  144778 */     GIR_EraseRootFromParent_Done,
     /*  144779 */   // Label 2613: @144779
     /*  144779 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(144845), // Rule ID 71412 //
     /*  144784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  144811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144826 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  144835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144843 */     GIR_RootConstrainSelectedInstOperands,
     /*  144844 */     // GIR_Coverage, 71412,
     /*  144844 */     GIR_EraseRootFromParent_Done,
     /*  144845 */   // Label 2614: @144845
     /*  144845 */   GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(144911), // Rule ID 71409 //
     /*  144850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  144890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144892 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  144892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144909 */     GIR_RootConstrainSelectedInstOperands,
     /*  144910 */     // GIR_Coverage, 71409,
     /*  144910 */     GIR_EraseRootFromParent_Done,
     /*  144911 */   // Label 2615: @144911
     /*  144911 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(144977), // Rule ID 71410 //
     /*  144916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  144919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  144927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  144931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  144935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  144939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  144944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  144948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144952 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  144956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  144958 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  144958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  144961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  144963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  144967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  144969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  144972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  144975 */     GIR_RootConstrainSelectedInstOperands,
     /*  144976 */     // GIR_Coverage, 71410,
     /*  144976 */     GIR_EraseRootFromParent_Done,
     /*  144977 */   // Label 2616: @144977
     /*  144977 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(145020), // Rule ID 71425 //
     /*  144982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  144985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  144989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  144993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  144997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145003 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  145006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145018 */     GIR_RootConstrainSelectedInstOperands,
     /*  145019 */     // GIR_Coverage, 71425,
     /*  145019 */     GIR_EraseRootFromParent_Done,
     /*  145020 */   // Label 2617: @145020
     /*  145020 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(145063), // Rule ID 71426 //
     /*  145025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145046 */     // (xor:{ *:[nxv8i1] } (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv8i1] }:$rs)  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  145049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  145055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145061 */     GIR_RootConstrainSelectedInstOperands,
     /*  145062 */     // GIR_Coverage, 71426,
     /*  145062 */     GIR_EraseRootFromParent_Done,
     /*  145063 */   // Label 2618: @145063
     /*  145063 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(145106), // Rule ID 53104 //
     /*  145068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  145087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145089 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  145092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145104 */     GIR_RootConstrainSelectedInstOperands,
     /*  145105 */     // GIR_Coverage, 53104,
     /*  145105 */     GIR_EraseRootFromParent_Done,
     /*  145106 */   // Label 2619: @145106
     /*  145106 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(145149), // Rule ID 53105 //
     /*  145111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  145122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  145130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  145132 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, (riscv_vmset_vl:{ *:[nxv8i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs, VR:{ *:[nxv8i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  145135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  145141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145147 */     GIR_RootConstrainSelectedInstOperands,
     /*  145148 */     // GIR_Coverage, 53105,
     /*  145148 */     GIR_EraseRootFromParent_Done,
     /*  145149 */   // Label 2620: @145149
     /*  145149 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(145182), // Rule ID 53092 //
     /*  145154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145165 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  145168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145180 */     GIR_RootConstrainSelectedInstOperands,
     /*  145181 */     // GIR_Coverage, 53092,
     /*  145181 */     GIR_EraseRootFromParent_Done,
     /*  145182 */   // Label 2621: @145182
     /*  145182 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(145215), // Rule ID 53093 //
     /*  145187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145198 */     // (xor:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2)  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  145201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145213 */     GIR_RootConstrainSelectedInstOperands,
     /*  145214 */     // GIR_Coverage, 53093,
     /*  145214 */     GIR_EraseRootFromParent_Done,
     /*  145215 */   // Label 2622: @145215
     /*  145215 */   GIM_Reject,
     /*  145216 */ // Label 2596: @145216
     /*  145216 */ GIM_Reject,
     /*  145217 */ // Label 2445: @145217
     /*  145217 */ GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(145331),
     /*  145222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /*  145225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  145228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145240 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(145285), // Rule ID 47814 //
     /*  145245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145248 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  145248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  145251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145283 */     GIR_RootConstrainSelectedInstOperands,
     /*  145284 */     // GIR_Coverage, 47814,
     /*  145284 */     GIR_EraseRootFromParent_Done,
     /*  145285 */   // Label 2624: @145285
     /*  145285 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(145330), // Rule ID 47815 //
     /*  145290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145293 */     // (xor:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  145293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  145296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145305 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  145310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145328 */     GIR_RootConstrainSelectedInstOperands,
     /*  145329 */     // GIR_Coverage, 47815,
     /*  145329 */     GIR_EraseRootFromParent_Done,
     /*  145330 */   // Label 2625: @145330
     /*  145330 */   GIM_Reject,
     /*  145331 */ // Label 2623: @145331
     /*  145331 */ GIM_Reject,
     /*  145332 */ // Label 2446: @145332
     /*  145332 */ GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(145446),
     /*  145337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  145340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  145343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  145355 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(145400), // Rule ID 47842 //
     /*  145360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145363 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  145363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  145366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145398 */     GIR_RootConstrainSelectedInstOperands,
     /*  145399 */     // GIR_Coverage, 47842,
     /*  145399 */     GIR_EraseRootFromParent_Done,
     /*  145400 */   // Label 2627: @145400
     /*  145400 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(145445), // Rule ID 47843 //
     /*  145405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145408 */     // (xor:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  145408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  145411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  145425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145427 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145430 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  145440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145443 */     GIR_RootConstrainSelectedInstOperands,
     /*  145444 */     // GIR_Coverage, 47843,
     /*  145444 */     GIR_EraseRootFromParent_Done,
     /*  145445 */   // Label 2628: @145445
     /*  145445 */   GIM_Reject,
     /*  145446 */ // Label 2626: @145446
     /*  145446 */ GIM_Reject,
     /*  145447 */ // Label 2447: @145447
     /*  145447 */ GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(145561),
     /*  145452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /*  145455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  145458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  145462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  145466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  145470 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(145515), // Rule ID 47858 //
     /*  145475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145478 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  145478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  145481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  145495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145513 */     GIR_RootConstrainSelectedInstOperands,
     /*  145514 */     // GIR_Coverage, 47858,
     /*  145514 */     GIR_EraseRootFromParent_Done,
     /*  145515 */   // Label 2630: @145515
     /*  145515 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(145560), // Rule ID 47859 //
     /*  145520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145523 */     // (xor:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  145523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  145526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  145540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  145555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145558 */     GIR_RootConstrainSelectedInstOperands,
     /*  145559 */     // GIR_Coverage, 47859,
     /*  145559 */     GIR_EraseRootFromParent_Done,
     /*  145560 */   // Label 2631: @145560
     /*  145560 */   GIM_Reject,
     /*  145561 */ // Label 2629: @145561
     /*  145561 */ GIM_Reject,
     /*  145562 */ // Label 2448: @145562
     /*  145562 */ GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(145676),
     /*  145567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /*  145570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  145573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  145577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  145581 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  145585 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(145630), // Rule ID 47874 //
     /*  145590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  145593 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  145593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  145596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  145610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145628 */     GIR_RootConstrainSelectedInstOperands,
     /*  145629 */     // GIR_Coverage, 47874,
     /*  145629 */     GIR_EraseRootFromParent_Done,
     /*  145630 */   // Label 2633: @145630
     /*  145630 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(145675), // Rule ID 47875 //
     /*  145635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  145638 */     // (xor:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  145638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  145641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  145645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  145650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  145652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  145655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  145660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  145662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  145664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  145670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  145673 */     GIR_RootConstrainSelectedInstOperands,
     /*  145674 */     // GIR_Coverage, 47875,
     /*  145674 */     GIR_EraseRootFromParent_Done,
     /*  145675 */   // Label 2634: @145675
     /*  145675 */   GIM_Reject,
     /*  145676 */ // Label 2632: @145676
     /*  145676 */ GIM_Reject,
     /*  145677 */ // Label 2449: @145677
     /*  145677 */ GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(147287),
     /*  145682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145692 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(145761), // Rule ID 53112 //
     /*  145697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145740 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  145743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145759 */     GIR_RootConstrainSelectedInstOperands,
     /*  145760 */     // GIR_Coverage, 53112,
     /*  145760 */     GIR_EraseRootFromParent_Done,
     /*  145761 */   // Label 2636: @145761
     /*  145761 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(145830), // Rule ID 53113 //
     /*  145766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  145777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145809 */     // (xor:{ *:[nxv16i1] } (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  145812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145828 */     GIR_RootConstrainSelectedInstOperands,
     /*  145829 */     // GIR_Coverage, 53113,
     /*  145829 */     GIR_EraseRootFromParent_Done,
     /*  145830 */   // Label 2637: @145830
     /*  145830 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(145899), // Rule ID 53114 //
     /*  145835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  145876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145878 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  145878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  145881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145897 */     GIR_RootConstrainSelectedInstOperands,
     /*  145898 */     // GIR_Coverage, 53114,
     /*  145898 */     GIR_EraseRootFromParent_Done,
     /*  145899 */   // Label 2638: @145899
     /*  145899 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(145968), // Rule ID 53115 //
     /*  145904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  145907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  145915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  145933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  145937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  145941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  145945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  145947 */     // (xor:{ *:[nxv16i1] } (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  145947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  145950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  145952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  145956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  145960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  145963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  145966 */     GIR_RootConstrainSelectedInstOperands,
     /*  145967 */     // GIR_Coverage, 53115,
     /*  145967 */     GIR_EraseRootFromParent_Done,
     /*  145968 */   // Label 2639: @145968
     /*  145968 */   GIM_Try, /*On fail goto*//*Label 2640*/ GIMT_Encode4(146034), // Rule ID 71433 //
     /*  145973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  145976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  145980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  145984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  145988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  145992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  145996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146015 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146032 */     GIR_RootConstrainSelectedInstOperands,
     /*  146033 */     // GIR_Coverage, 71433,
     /*  146033 */     GIR_EraseRootFromParent_Done,
     /*  146034 */   // Label 2640: @146034
     /*  146034 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(146100), // Rule ID 71434 //
     /*  146039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146050 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146081 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146098 */     GIR_RootConstrainSelectedInstOperands,
     /*  146099 */     // GIR_Coverage, 71434,
     /*  146099 */     GIR_EraseRootFromParent_Done,
     /*  146100 */   // Label 2641: @146100
     /*  146100 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(146166), // Rule ID 71431 //
     /*  146105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146147 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146164 */     GIR_RootConstrainSelectedInstOperands,
     /*  146165 */     // GIR_Coverage, 71431,
     /*  146165 */     GIR_EraseRootFromParent_Done,
     /*  146166 */   // Label 2642: @146166
     /*  146166 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(146232), // Rule ID 71432 //
     /*  146171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146203 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146213 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  146224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146230 */     GIR_RootConstrainSelectedInstOperands,
     /*  146231 */     // GIR_Coverage, 71432,
     /*  146231 */     GIR_EraseRootFromParent_Done,
     /*  146232 */   // Label 2643: @146232
     /*  146232 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(146301), // Rule ID 53116 //
     /*  146237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146280 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146299 */     GIR_RootConstrainSelectedInstOperands,
     /*  146300 */     // GIR_Coverage, 53116,
     /*  146300 */     GIR_EraseRootFromParent_Done,
     /*  146301 */   // Label 2644: @146301
     /*  146301 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(146370), // Rule ID 53117 //
     /*  146306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146349 */     // (xor:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  146362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146368 */     GIR_RootConstrainSelectedInstOperands,
     /*  146369 */     // GIR_Coverage, 53117,
     /*  146369 */     GIR_EraseRootFromParent_Done,
     /*  146370 */   // Label 2645: @146370
     /*  146370 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(146439), // Rule ID 71427 //
     /*  146375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146418 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  146421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146437 */     GIR_RootConstrainSelectedInstOperands,
     /*  146438 */     // GIR_Coverage, 71427,
     /*  146438 */     GIR_EraseRootFromParent_Done,
     /*  146439 */   // Label 2646: @146439
     /*  146439 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(146508), // Rule ID 71428 //
     /*  146444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  146467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146487 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  146490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146506 */     GIR_RootConstrainSelectedInstOperands,
     /*  146507 */     // GIR_Coverage, 71428,
     /*  146507 */     GIR_EraseRootFromParent_Done,
     /*  146508 */   // Label 2647: @146508
     /*  146508 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(146577), // Rule ID 71429 //
     /*  146513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146556 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  146559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146575 */     GIR_RootConstrainSelectedInstOperands,
     /*  146576 */     // GIR_Coverage, 71429,
     /*  146576 */     GIR_EraseRootFromParent_Done,
     /*  146577 */   // Label 2648: @146577
     /*  146577 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(146646), // Rule ID 71430 //
     /*  146582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  146605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146613 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146623 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146625 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  146628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146644 */     GIR_RootConstrainSelectedInstOperands,
     /*  146645 */     // GIR_Coverage, 71430,
     /*  146645 */     GIR_EraseRootFromParent_Done,
     /*  146646 */   // Label 2649: @146646
     /*  146646 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(146715), // Rule ID 71435 //
     /*  146651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  146666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146694 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146713 */     GIR_RootConstrainSelectedInstOperands,
     /*  146714 */     // GIR_Coverage, 71435,
     /*  146714 */     GIR_EraseRootFromParent_Done,
     /*  146715 */   // Label 2650: @146715
     /*  146715 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(146784), // Rule ID 71436 //
     /*  146720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  146727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  146735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  146739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146747 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146763 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  146772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  146776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146782 */     GIR_RootConstrainSelectedInstOperands,
     /*  146783 */     // GIR_Coverage, 71436,
     /*  146783 */     GIR_EraseRootFromParent_Done,
     /*  146784 */   // Label 2651: @146784
     /*  146784 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(146850), // Rule ID 71439 //
     /*  146789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146808 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146831 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146836 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146848 */     GIR_RootConstrainSelectedInstOperands,
     /*  146849 */     // GIR_Coverage, 71439,
     /*  146849 */     GIR_EraseRootFromParent_Done,
     /*  146850 */   // Label 2652: @146850
     /*  146850 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(146916), // Rule ID 71440 //
     /*  146855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  146882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  146890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146897 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  146897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  146906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146914 */     GIR_RootConstrainSelectedInstOperands,
     /*  146915 */     // GIR_Coverage, 71440,
     /*  146915 */     GIR_EraseRootFromParent_Done,
     /*  146916 */   // Label 2653: @146916
     /*  146916 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(146982), // Rule ID 71437 //
     /*  146921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  146924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  146936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  146940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  146944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  146953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  146957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  146961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  146963 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  146963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  146966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  146968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  146972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  146974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  146977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  146980 */     GIR_RootConstrainSelectedInstOperands,
     /*  146981 */     // GIR_Coverage, 71437,
     /*  146981 */     GIR_EraseRootFromParent_Done,
     /*  146982 */   // Label 2654: @146982
     /*  146982 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(147048), // Rule ID 71438 //
     /*  146987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  146990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  146994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  146998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  147006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  147010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  147019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147029 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  147032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  147040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147046 */     GIR_RootConstrainSelectedInstOperands,
     /*  147047 */     // GIR_Coverage, 71438,
     /*  147047 */     GIR_EraseRootFromParent_Done,
     /*  147048 */   // Label 2655: @147048
     /*  147048 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(147091), // Rule ID 71453 //
     /*  147053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147074 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  147077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147089 */     GIR_RootConstrainSelectedInstOperands,
     /*  147090 */     // GIR_Coverage, 71453,
     /*  147090 */     GIR_EraseRootFromParent_Done,
     /*  147091 */   // Label 2656: @147091
     /*  147091 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(147134), // Rule ID 71454 //
     /*  147096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147117 */     // (xor:{ *:[nxv16i1] } (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv16i1] }:$rs)  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  147120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  147126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147132 */     GIR_RootConstrainSelectedInstOperands,
     /*  147133 */     // GIR_Coverage, 71454,
     /*  147133 */     GIR_EraseRootFromParent_Done,
     /*  147134 */   // Label 2657: @147134
     /*  147134 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(147177), // Rule ID 53122 //
     /*  147139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147142 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  147158 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147160 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  147163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147175 */     GIR_RootConstrainSelectedInstOperands,
     /*  147176 */     // GIR_Coverage, 53122,
     /*  147176 */     GIR_EraseRootFromParent_Done,
     /*  147177 */   // Label 2658: @147177
     /*  147177 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(147220), // Rule ID 53123 //
     /*  147182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  147193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  147201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  147203 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, (riscv_vmset_vl:{ *:[nxv16i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs, VR:{ *:[nxv16i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  147206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  147212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147218 */     GIR_RootConstrainSelectedInstOperands,
     /*  147219 */     // GIR_Coverage, 53123,
     /*  147219 */     GIR_EraseRootFromParent_Done,
     /*  147220 */   // Label 2659: @147220
     /*  147220 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(147253), // Rule ID 53110 //
     /*  147225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147236 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  147239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147241 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147251 */     GIR_RootConstrainSelectedInstOperands,
     /*  147252 */     // GIR_Coverage, 53110,
     /*  147252 */     GIR_EraseRootFromParent_Done,
     /*  147253 */   // Label 2660: @147253
     /*  147253 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(147286), // Rule ID 53111 //
     /*  147258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147269 */     // (xor:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2)  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  147272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147284 */     GIR_RootConstrainSelectedInstOperands,
     /*  147285 */     // GIR_Coverage, 53111,
     /*  147285 */     GIR_EraseRootFromParent_Done,
     /*  147286 */   // Label 2661: @147286
     /*  147286 */   GIM_Reject,
     /*  147287 */ // Label 2635: @147287
     /*  147287 */ GIM_Reject,
     /*  147288 */ // Label 2450: @147288
     /*  147288 */ GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(147402),
     /*  147293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  147296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  147299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147307 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  147311 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(147356), // Rule ID 47830 //
     /*  147316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147319 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  147319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  147322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147354 */     GIR_RootConstrainSelectedInstOperands,
     /*  147355 */     // GIR_Coverage, 47830,
     /*  147355 */     GIR_EraseRootFromParent_Done,
     /*  147356 */   // Label 2663: @147356
     /*  147356 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(147401), // Rule ID 47831 //
     /*  147361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147364 */     // (xor:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  147364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  147367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  147381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147399 */     GIR_RootConstrainSelectedInstOperands,
     /*  147400 */     // GIR_Coverage, 47831,
     /*  147400 */     GIR_EraseRootFromParent_Done,
     /*  147401 */   // Label 2664: @147401
     /*  147401 */   GIM_Reject,
     /*  147402 */ // Label 2662: @147402
     /*  147402 */ GIM_Reject,
     /*  147403 */ // Label 2451: @147403
     /*  147403 */ GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(147517),
     /*  147408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /*  147411 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  147414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  147426 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(147471), // Rule ID 47846 //
     /*  147431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147434 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  147434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  147437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147469 */     GIR_RootConstrainSelectedInstOperands,
     /*  147470 */     // GIR_Coverage, 47846,
     /*  147470 */     GIR_EraseRootFromParent_Done,
     /*  147471 */   // Label 2666: @147471
     /*  147471 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(147516), // Rule ID 47847 //
     /*  147476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147479 */     // (xor:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  147479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  147482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  147496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  147511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147514 */     GIR_RootConstrainSelectedInstOperands,
     /*  147515 */     // GIR_Coverage, 47847,
     /*  147515 */     GIR_EraseRootFromParent_Done,
     /*  147516 */   // Label 2667: @147516
     /*  147516 */   GIM_Reject,
     /*  147517 */ // Label 2665: @147517
     /*  147517 */ GIM_Reject,
     /*  147518 */ // Label 2452: @147518
     /*  147518 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(147632),
     /*  147523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /*  147526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  147529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147537 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  147541 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(147586), // Rule ID 47862 //
     /*  147546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147549 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  147549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  147552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  147566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147584 */     GIR_RootConstrainSelectedInstOperands,
     /*  147585 */     // GIR_Coverage, 47862,
     /*  147585 */     GIR_EraseRootFromParent_Done,
     /*  147586 */   // Label 2669: @147586
     /*  147586 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(147631), // Rule ID 47863 //
     /*  147591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147594 */     // (xor:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  147594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  147597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  147601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  147606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  147608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  147611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  147616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  147618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  147626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  147629 */     GIR_RootConstrainSelectedInstOperands,
     /*  147630 */     // GIR_Coverage, 47863,
     /*  147630 */     GIR_EraseRootFromParent_Done,
     /*  147631 */   // Label 2670: @147631
     /*  147631 */   GIM_Reject,
     /*  147632 */ // Label 2668: @147632
     /*  147632 */ GIM_Reject,
     /*  147633 */ // Label 2453: @147633
     /*  147633 */ GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(149243),
     /*  147638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147648 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(147717), // Rule ID 53130 //
     /*  147653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147696 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  147699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147715 */     GIR_RootConstrainSelectedInstOperands,
     /*  147716 */     // GIR_Coverage, 53130,
     /*  147716 */     GIR_EraseRootFromParent_Done,
     /*  147717 */   // Label 2672: @147717
     /*  147717 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(147786), // Rule ID 53131 //
     /*  147722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  147733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147765 */     // (xor:{ *:[nxv32i1] } (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  147768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147784 */     GIR_RootConstrainSelectedInstOperands,
     /*  147785 */     // GIR_Coverage, 53131,
     /*  147785 */     GIR_EraseRootFromParent_Done,
     /*  147786 */   // Label 2673: @147786
     /*  147786 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(147855), // Rule ID 53132 //
     /*  147791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147834 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  147837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147853 */     GIR_RootConstrainSelectedInstOperands,
     /*  147854 */     // GIR_Coverage, 53132,
     /*  147854 */     GIR_EraseRootFromParent_Done,
     /*  147855 */   // Label 2674: @147855
     /*  147855 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(147924), // Rule ID 53133 //
     /*  147860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  147871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  147893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  147901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147903 */     // (xor:{ *:[nxv32i1] } (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  147903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  147906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  147912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  147916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147922 */     GIR_RootConstrainSelectedInstOperands,
     /*  147923 */     // GIR_Coverage, 53133,
     /*  147923 */     GIR_EraseRootFromParent_Done,
     /*  147924 */   // Label 2675: @147924
     /*  147924 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(147990), // Rule ID 71461 //
     /*  147929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  147932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  147936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  147940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  147944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  147948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  147952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  147956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  147960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  147969 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  147971 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  147971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  147974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  147976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  147980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  147982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  147985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  147988 */     GIR_RootConstrainSelectedInstOperands,
     /*  147989 */     // GIR_Coverage, 71461,
     /*  147989 */     GIR_EraseRootFromParent_Done,
     /*  147990 */   // Label 2676: @147990
     /*  147990 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(148056), // Rule ID 71462 //
     /*  147995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  147998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148037 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148054 */     GIR_RootConstrainSelectedInstOperands,
     /*  148055 */     // GIR_Coverage, 71462,
     /*  148055 */     GIR_EraseRootFromParent_Done,
     /*  148056 */   // Label 2677: @148056
     /*  148056 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(148122), // Rule ID 71459 //
     /*  148061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148072 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148103 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148120 */     GIR_RootConstrainSelectedInstOperands,
     /*  148121 */     // GIR_Coverage, 71459,
     /*  148121 */     GIR_EraseRootFromParent_Done,
     /*  148122 */   // Label 2678: @148122
     /*  148122 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(148188), // Rule ID 71460 //
     /*  148127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148169 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  148180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148186 */     GIR_RootConstrainSelectedInstOperands,
     /*  148187 */     // GIR_Coverage, 71460,
     /*  148187 */     GIR_EraseRootFromParent_Done,
     /*  148188 */   // Label 2679: @148188
     /*  148188 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(148257), // Rule ID 53134 //
     /*  148193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148236 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148255 */     GIR_RootConstrainSelectedInstOperands,
     /*  148256 */     // GIR_Coverage, 53134,
     /*  148256 */     GIR_EraseRootFromParent_Done,
     /*  148257 */   // Label 2680: @148257
     /*  148257 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(148326), // Rule ID 53135 //
     /*  148262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148305 */     // (xor:{ *:[nxv32i1] } (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  148318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148324 */     GIR_RootConstrainSelectedInstOperands,
     /*  148325 */     // GIR_Coverage, 53135,
     /*  148325 */     GIR_EraseRootFromParent_Done,
     /*  148326 */   // Label 2681: @148326
     /*  148326 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(148395), // Rule ID 71455 //
     /*  148331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148358 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148374 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  148377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148393 */     GIR_RootConstrainSelectedInstOperands,
     /*  148394 */     // GIR_Coverage, 71455,
     /*  148394 */     GIR_EraseRootFromParent_Done,
     /*  148395 */   // Label 2682: @148395
     /*  148395 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(148464), // Rule ID 71456 //
     /*  148400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  148423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148443 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  148446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148462 */     GIR_RootConstrainSelectedInstOperands,
     /*  148463 */     // GIR_Coverage, 71456,
     /*  148463 */     GIR_EraseRootFromParent_Done,
     /*  148464 */   // Label 2683: @148464
     /*  148464 */   GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(148533), // Rule ID 71457 //
     /*  148469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148512 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  148515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148531 */     GIR_RootConstrainSelectedInstOperands,
     /*  148532 */     // GIR_Coverage, 71457,
     /*  148532 */     GIR_EraseRootFromParent_Done,
     /*  148533 */   // Label 2684: @148533
     /*  148533 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(148602), // Rule ID 71458 //
     /*  148538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  148561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148569 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148574 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148581 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  148584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148600 */     GIR_RootConstrainSelectedInstOperands,
     /*  148601 */     // GIR_Coverage, 71458,
     /*  148601 */     GIR_EraseRootFromParent_Done,
     /*  148602 */   // Label 2685: @148602
     /*  148602 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(148671), // Rule ID 71463 //
     /*  148607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  148622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148634 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148638 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148643 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148650 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148669 */     GIR_RootConstrainSelectedInstOperands,
     /*  148670 */     // GIR_Coverage, 71463,
     /*  148670 */     GIR_EraseRootFromParent_Done,
     /*  148671 */   // Label 2686: @148671
     /*  148671 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(148740), // Rule ID 71464 //
     /*  148676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  148683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  148691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  148695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148707 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148719 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  148728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  148732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148738 */     GIR_RootConstrainSelectedInstOperands,
     /*  148739 */     // GIR_Coverage, 71464,
     /*  148739 */     GIR_EraseRootFromParent_Done,
     /*  148740 */   // Label 2687: @148740
     /*  148740 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(148806), // Rule ID 71467 //
     /*  148745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148787 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148804 */     GIR_RootConstrainSelectedInstOperands,
     /*  148805 */     // GIR_Coverage, 71467,
     /*  148805 */     GIR_EraseRootFromParent_Done,
     /*  148806 */   // Label 2688: @148806
     /*  148806 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(148872), // Rule ID 71468 //
     /*  148811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  148838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148846 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148851 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148853 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  148862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148870 */     GIR_RootConstrainSelectedInstOperands,
     /*  148871 */     // GIR_Coverage, 71468,
     /*  148871 */     GIR_EraseRootFromParent_Done,
     /*  148872 */   // Label 2689: @148872
     /*  148872 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(148938), // Rule ID 71465 //
     /*  148877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  148880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  148917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148919 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  148919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  148936 */     GIR_RootConstrainSelectedInstOperands,
     /*  148937 */     // GIR_Coverage, 71465,
     /*  148937 */     GIR_EraseRootFromParent_Done,
     /*  148938 */   // Label 2690: @148938
     /*  148938 */   GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(149004), // Rule ID 71466 //
     /*  148943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  148946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  148954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  148958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /*  148962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  148966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  148971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  148975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  148979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  148983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  148985 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  148985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  148988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  148990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  148994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  148996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  148999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149002 */     GIR_RootConstrainSelectedInstOperands,
     /*  149003 */     // GIR_Coverage, 71466,
     /*  149003 */     GIR_EraseRootFromParent_Done,
     /*  149004 */   // Label 2691: @149004
     /*  149004 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(149047), // Rule ID 71481 //
     /*  149009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149030 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  149033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149045 */     GIR_RootConstrainSelectedInstOperands,
     /*  149046 */     // GIR_Coverage, 71481,
     /*  149046 */     GIR_EraseRootFromParent_Done,
     /*  149047 */   // Label 2692: @149047
     /*  149047 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(149090), // Rule ID 71482 //
     /*  149052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149073 */     // (xor:{ *:[nxv32i1] } (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv32i1] }:$rs)  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  149076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  149082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149088 */     GIR_RootConstrainSelectedInstOperands,
     /*  149089 */     // GIR_Coverage, 71482,
     /*  149089 */     GIR_EraseRootFromParent_Done,
     /*  149090 */   // Label 2693: @149090
     /*  149090 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(149133), // Rule ID 53140 //
     /*  149095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  149114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149116 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  149119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149131 */     GIR_RootConstrainSelectedInstOperands,
     /*  149132 */     // GIR_Coverage, 53140,
     /*  149132 */     GIR_EraseRootFromParent_Done,
     /*  149133 */   // Label 2694: @149133
     /*  149133 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(149176), // Rule ID 53141 //
     /*  149138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  149149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  149157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  149159 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, (riscv_vmset_vl:{ *:[nxv32i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs, VR:{ *:[nxv32i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  149162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  149168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149174 */     GIR_RootConstrainSelectedInstOperands,
     /*  149175 */     // GIR_Coverage, 53141,
     /*  149175 */     GIR_EraseRootFromParent_Done,
     /*  149176 */   // Label 2695: @149176
     /*  149176 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(149209), // Rule ID 53128 //
     /*  149181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149192 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  149195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149207 */     GIR_RootConstrainSelectedInstOperands,
     /*  149208 */     // GIR_Coverage, 53128,
     /*  149208 */     GIR_EraseRootFromParent_Done,
     /*  149209 */   // Label 2696: @149209
     /*  149209 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(149242), // Rule ID 53129 //
     /*  149214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149225 */     // (xor:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2)  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  149228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149240 */     GIR_RootConstrainSelectedInstOperands,
     /*  149241 */     // GIR_Coverage, 53129,
     /*  149241 */     GIR_EraseRootFromParent_Done,
     /*  149242 */   // Label 2697: @149242
     /*  149242 */   GIM_Reject,
     /*  149243 */ // Label 2671: @149243
     /*  149243 */ GIM_Reject,
     /*  149244 */ // Label 2454: @149244
     /*  149244 */ GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(149358),
     /*  149249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /*  149252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  149255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149263 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  149267 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(149312), // Rule ID 47834 //
     /*  149272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149275 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  149275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  149278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149310 */     GIR_RootConstrainSelectedInstOperands,
     /*  149311 */     // GIR_Coverage, 47834,
     /*  149311 */     GIR_EraseRootFromParent_Done,
     /*  149312 */   // Label 2699: @149312
     /*  149312 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(149357), // Rule ID 47835 //
     /*  149317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149320 */     // (xor:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  149320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  149323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  149337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149355 */     GIR_RootConstrainSelectedInstOperands,
     /*  149356 */     // GIR_Coverage, 47835,
     /*  149356 */     GIR_EraseRootFromParent_Done,
     /*  149357 */   // Label 2700: @149357
     /*  149357 */   GIM_Reject,
     /*  149358 */ // Label 2698: @149358
     /*  149358 */ GIM_Reject,
     /*  149359 */ // Label 2455: @149359
     /*  149359 */ GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(149473),
     /*  149364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /*  149367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  149370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149378 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  149382 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(149427), // Rule ID 47850 //
     /*  149387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149390 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  149390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  149393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149425 */     GIR_RootConstrainSelectedInstOperands,
     /*  149426 */     // GIR_Coverage, 47850,
     /*  149426 */     GIR_EraseRootFromParent_Done,
     /*  149427 */   // Label 2702: @149427
     /*  149427 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(149472), // Rule ID 47851 //
     /*  149432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149435 */     // (xor:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  149435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  149438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  149442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  149447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  149449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  149452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  149457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  149459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  149467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  149470 */     GIR_RootConstrainSelectedInstOperands,
     /*  149471 */     // GIR_Coverage, 47851,
     /*  149471 */     GIR_EraseRootFromParent_Done,
     /*  149472 */   // Label 2703: @149472
     /*  149472 */   GIM_Reject,
     /*  149473 */ // Label 2701: @149473
     /*  149473 */ GIM_Reject,
     /*  149474 */ // Label 2456: @149474
     /*  149474 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(151084),
     /*  149479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149489 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(149558), // Rule ID 53148 //
     /*  149494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149509 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149513 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149518 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149537 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  149540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149556 */     GIR_RootConstrainSelectedInstOperands,
     /*  149557 */     // GIR_Coverage, 53148,
     /*  149557 */     GIR_EraseRootFromParent_Done,
     /*  149558 */   // Label 2705: @149558
     /*  149558 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(149627), // Rule ID 53149 //
     /*  149563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  149574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149578 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149606 */     // (xor:{ *:[nxv64i1] } (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  149609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149625 */     GIR_RootConstrainSelectedInstOperands,
     /*  149626 */     // GIR_Coverage, 53149,
     /*  149626 */     GIR_EraseRootFromParent_Done,
     /*  149627 */   // Label 2706: @149627
     /*  149627 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(149696), // Rule ID 53150 //
     /*  149632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149647 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149651 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149661 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149665 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149669 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149675 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  149678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149694 */     GIR_RootConstrainSelectedInstOperands,
     /*  149695 */     // GIR_Coverage, 53150,
     /*  149695 */     GIR_EraseRootFromParent_Done,
     /*  149696 */   // Label 2707: @149696
     /*  149696 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(149765), // Rule ID 53151 //
     /*  149701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  149712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  149734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149744 */     // (xor:{ *:[nxv64i1] } (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  149747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  149757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149763 */     GIR_RootConstrainSelectedInstOperands,
     /*  149764 */     // GIR_Coverage, 53151,
     /*  149764 */     GIR_EraseRootFromParent_Done,
     /*  149765 */   // Label 2708: @149765
     /*  149765 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(149831), // Rule ID 71489 //
     /*  149770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149812 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  149815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149829 */     GIR_RootConstrainSelectedInstOperands,
     /*  149830 */     // GIR_Coverage, 71489,
     /*  149830 */     GIR_EraseRootFromParent_Done,
     /*  149831 */   // Label 2709: @149831
     /*  149831 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(149897), // Rule ID 71490 //
     /*  149836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  149859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  149867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149878 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  149878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  149881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  149887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149895 */     GIR_RootConstrainSelectedInstOperands,
     /*  149896 */     // GIR_Coverage, 71490,
     /*  149896 */     GIR_EraseRootFromParent_Done,
     /*  149897 */   // Label 2710: @149897
     /*  149897 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(149963), // Rule ID 71487 //
     /*  149902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  149905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  149934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  149938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  149944 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  149944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  149947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  149949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  149953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  149955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  149958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  149961 */     GIR_RootConstrainSelectedInstOperands,
     /*  149962 */     // GIR_Coverage, 71487,
     /*  149962 */     GIR_EraseRootFromParent_Done,
     /*  149963 */   // Label 2711: @149963
     /*  149963 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(150029), // Rule ID 71488 //
     /*  149968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  149971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  149975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  149979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  149983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  149987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  149992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  149996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150010 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })), VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  150021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150027 */     GIR_RootConstrainSelectedInstOperands,
     /*  150028 */     // GIR_Coverage, 71488,
     /*  150028 */     GIR_EraseRootFromParent_Done,
     /*  150029 */   // Label 2712: @150029
     /*  150029 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(150098), // Rule ID 53152 //
     /*  150034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150077 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150096 */     GIR_RootConstrainSelectedInstOperands,
     /*  150097 */     // GIR_Coverage, 53152,
     /*  150097 */     GIR_EraseRootFromParent_Done,
     /*  150098 */   // Label 2713: @150098
     /*  150098 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(150167), // Rule ID 53153 //
     /*  150103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150146 */     // (xor:{ *:[nxv64i1] } (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2), (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs2
     /*  150159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150165 */     GIR_RootConstrainSelectedInstOperands,
     /*  150166 */     // GIR_Coverage, 53153,
     /*  150166 */     GIR_EraseRootFromParent_Done,
     /*  150167 */   // Label 2714: @150167
     /*  150167 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(150236), // Rule ID 71483 //
     /*  150172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150199 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150208 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150215 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  150218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150234 */     GIR_RootConstrainSelectedInstOperands,
     /*  150235 */     // GIR_Coverage, 71483,
     /*  150235 */     GIR_EraseRootFromParent_Done,
     /*  150236 */   // Label 2715: @150236
     /*  150236 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(150305), // Rule ID 71484 //
     /*  150241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  150264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150268 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150272 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150282 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150284 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (and:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  150287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150303 */     GIR_RootConstrainSelectedInstOperands,
     /*  150304 */     // GIR_Coverage, 71484,
     /*  150304 */     GIR_EraseRootFromParent_Done,
     /*  150305 */   // Label 2716: @150305
     /*  150305 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(150374), // Rule ID 71485 //
     /*  150310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150353 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  150356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150372 */     GIR_RootConstrainSelectedInstOperands,
     /*  150373 */     // GIR_Coverage, 71485,
     /*  150373 */     GIR_EraseRootFromParent_Done,
     /*  150374 */   // Label 2717: @150374
     /*  150374 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(150443), // Rule ID 71486 //
     /*  150379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  150402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150422 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (or:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  150425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150441 */     GIR_RootConstrainSelectedInstOperands,
     /*  150442 */     // GIR_Coverage, 71486,
     /*  150442 */     GIR_EraseRootFromParent_Done,
     /*  150443 */   // Label 2718: @150443
     /*  150443 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(150512), // Rule ID 71491 //
     /*  150448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150484 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150491 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150510 */     GIR_RootConstrainSelectedInstOperands,
     /*  150511 */     // GIR_Coverage, 71491,
     /*  150511 */     GIR_EraseRootFromParent_Done,
     /*  150512 */   // Label 2719: @150512
     /*  150512 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(150581), // Rule ID 71492 //
     /*  150517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  150536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150560 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /*  150569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // rs2
     /*  150573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150579 */     GIR_RootConstrainSelectedInstOperands,
     /*  150580 */     // GIR_Coverage, 71492,
     /*  150580 */     GIR_EraseRootFromParent_Done,
     /*  150581 */   // Label 2720: @150581
     /*  150581 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(150647), // Rule ID 71495 //
     /*  150586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150626 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150628 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150645 */     GIR_RootConstrainSelectedInstOperands,
     /*  150646 */     // GIR_Coverage, 71495,
     /*  150646 */     GIR_EraseRootFromParent_Done,
     /*  150647 */   // Label 2721: @150647
     /*  150647 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(150713), // Rule ID 71496 //
     /*  150652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  150679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150694 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs1))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  150703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150711 */     GIR_RootConstrainSelectedInstOperands,
     /*  150712 */     // GIR_Coverage, 71496,
     /*  150712 */     GIR_EraseRootFromParent_Done,
     /*  150713 */   // Label 2722: @150713
     /*  150713 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(150779), // Rule ID 71493 //
     /*  150718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  150758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150760 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150777 */     GIR_RootConstrainSelectedInstOperands,
     /*  150778 */     // GIR_Coverage, 71493,
     /*  150778 */     GIR_EraseRootFromParent_Done,
     /*  150779 */   // Label 2723: @150779
     /*  150779 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(150845), // Rule ID 71494 //
     /*  150784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  150799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /*  150803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  150807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  150816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  150824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  150826 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] })))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  150829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  150835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /*  150837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150843 */     GIR_RootConstrainSelectedInstOperands,
     /*  150844 */     // GIR_Coverage, 71494,
     /*  150844 */     GIR_EraseRootFromParent_Done,
     /*  150845 */   // Label 2724: @150845
     /*  150845 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(150888), // Rule ID 71509 //
     /*  150850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150871 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  150874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150886 */     GIR_RootConstrainSelectedInstOperands,
     /*  150887 */     // GIR_Coverage, 71509,
     /*  150887 */     GIR_EraseRootFromParent_Done,
     /*  150888 */   // Label 2725: @150888
     /*  150888 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(150931), // Rule ID 71510 //
     /*  150893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  150900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150914 */     // (xor:{ *:[nxv64i1] } (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }), VR:{ *:[nxv64i1] }:$rs)  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  150914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  150917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs
     /*  150923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150929 */     GIR_RootConstrainSelectedInstOperands,
     /*  150930 */     // GIR_Coverage, 71510,
     /*  150930 */     GIR_EraseRootFromParent_Done,
     /*  150931 */   // Label 2726: @150931
     /*  150931 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(150974), // Rule ID 53158 //
     /*  150936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  150939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  150955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  150957 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i64] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  150957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  150960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  150962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  150966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  150969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  150972 */     GIR_RootConstrainSelectedInstOperands,
     /*  150973 */     // GIR_Coverage, 53158,
     /*  150973 */     GIR_EraseRootFromParent_Done,
     /*  150974 */   // Label 2727: @150974
     /*  150974 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(151017), // Rule ID 53159 //
     /*  150979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  150982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  150986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  150990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(RISCV::G_VMSET_VL),
     /*  150994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  150998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  151000 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, (riscv_vmset_vl:{ *:[nxv64i1] } srcvalue:{ *:[i32] }))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs, VR:{ *:[nxv64i1] }:$rs, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  151003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151007 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /*  151009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151015 */     GIR_RootConstrainSelectedInstOperands,
     /*  151016 */     // GIR_Coverage, 53159,
     /*  151016 */     GIR_EraseRootFromParent_Done,
     /*  151017 */   // Label 2728: @151017
     /*  151017 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(151050), // Rule ID 53146 //
     /*  151022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151033 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  151033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  151036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151048 */     GIR_RootConstrainSelectedInstOperands,
     /*  151049 */     // GIR_Coverage, 53146,
     /*  151049 */     GIR_EraseRootFromParent_Done,
     /*  151050 */   // Label 2729: @151050
     /*  151050 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(151083), // Rule ID 53147 //
     /*  151055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  151066 */     // (xor:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2)  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  151066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  151069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151081 */     GIR_RootConstrainSelectedInstOperands,
     /*  151082 */     // GIR_Coverage, 53147,
     /*  151082 */     GIR_EraseRootFromParent_Done,
     /*  151083 */   // Label 2730: @151083
     /*  151083 */   GIM_Reject,
     /*  151084 */ // Label 2704: @151084
     /*  151084 */ GIM_Reject,
     /*  151085 */ // Label 2457: @151085
     /*  151085 */ GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(151199),
     /*  151090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /*  151093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  151096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  151108 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(151153), // Rule ID 47838 //
     /*  151113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  151116 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  151116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  151119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151151 */     GIR_RootConstrainSelectedInstOperands,
     /*  151152 */     // GIR_Coverage, 47838,
     /*  151152 */     GIR_EraseRootFromParent_Done,
     /*  151153 */   // Label 2732: @151153
     /*  151153 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(151198), // Rule ID 47839 //
     /*  151158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  151161 */     // (xor:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  151161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  151164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  151178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  151187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  151190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  151196 */     GIR_RootConstrainSelectedInstOperands,
     /*  151197 */     // GIR_Coverage, 47839,
     /*  151197 */     GIR_EraseRootFromParent_Done,
     /*  151198 */   // Label 2733: @151198
     /*  151198 */   GIM_Reject,
     /*  151199 */ // Label 2731: @151199
     /*  151199 */ GIM_Reject,
     /*  151200 */ // Label 2458: @151200
     /*  151200 */ GIM_Reject,
     /*  151201 */ // Label 10: @151201
     /*  151201 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(151261),
     /*  151206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/0, /*SizeInBits*/0,
     /*  151210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151214 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(151237), // Rule ID 110 //
     /*  151219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  151222 */     // MIs[0] Operand 1
     /*  151222 */     // No operand predicates
     /*  151222 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i64] })
     /*  151222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  151225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151227 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  151232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151235 */     GIR_RootConstrainSelectedInstOperands,
     /*  151236 */     // GIR_Coverage, 110,
     /*  151236 */     GIR_EraseRootFromParent_Done,
     /*  151237 */   // Label 2735: @151237
     /*  151237 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(151260), // Rule ID 111 //
     /*  151242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  151245 */     // MIs[0] Operand 1
     /*  151245 */     // No operand predicates
     /*  151245 */     // (frameindex:{ *:[iPTR] }):$fi  =>  (ADDI:{ *:[iPTR] } (to_tframeindex:{ *:[iPTR] } ?:{ *:[iPTR] }:$fi), 0:{ *:[i32] })
     /*  151245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /*  151248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151250 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFrameIndex), // fi
     /*  151255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  151258 */     GIR_RootConstrainSelectedInstOperands,
     /*  151259 */     // GIR_Coverage, 111,
     /*  151259 */     GIR_EraseRootFromParent_Done,
     /*  151260 */   // Label 2736: @151260
     /*  151260 */   GIM_Reject,
     /*  151261 */ // Label 2734: @151261
     /*  151261 */ GIM_Reject,
     /*  151262 */ // Label 11: @151262
     /*  151262 */ GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(151322),
     /*  151267 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  151270 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  151273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  151276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  151279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151291 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(151306), // Rule ID 50 //
     /*  151296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  151299 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  151299 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  151304 */     GIR_RootConstrainSelectedInstOperands,
     /*  151305 */     // GIR_Coverage, 50,
     /*  151305 */     GIR_Done,
     /*  151306 */   // Label 2738: @151306
     /*  151306 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(151321), // Rule ID 51 //
     /*  151311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  151314 */     // (RISCVSplitF64:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)  =>  (SplitF64Pseudo:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$src)
     /*  151314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SplitF64Pseudo),
     /*  151319 */     GIR_RootConstrainSelectedInstOperands,
     /*  151320 */     // GIR_Coverage, 51,
     /*  151320 */     GIR_Done,
     /*  151321 */   // Label 2739: @151321
     /*  151321 */   GIM_Reject,
     /*  151322 */ // Label 2737: @151322
     /*  151322 */ GIM_Reject,
     /*  151323 */ // Label 12: @151323
     /*  151323 */ GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(151413),
     /*  151328 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  151331 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  151334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  151337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  151340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151352 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(151367), // Rule ID 48 //
     /*  151357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode0),
     /*  151360 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  151360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  151365 */     GIR_RootConstrainSelectedInstOperands,
     /*  151366 */     // GIR_Coverage, 48,
     /*  151366 */     GIR_Done,
     /*  151367 */   // Label 2741: @151367
     /*  151367 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(151382), // Rule ID 49 //
     /*  151372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_NoStdExtZfa_HwMode1),
     /*  151375 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)  =>  (BuildPairF64Pseudo:{ *:[f64] } GPR:{ *:[i32] }:$src1, GPR:{ *:[i32] }:$src2)
     /*  151375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::BuildPairF64Pseudo),
     /*  151380 */     GIR_RootConstrainSelectedInstOperands,
     /*  151381 */     // GIR_Coverage, 49,
     /*  151381 */     GIR_Done,
     /*  151382 */   // Label 2742: @151382
     /*  151382 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(151397), // Rule ID 2294 //
     /*  151387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode0),
     /*  151390 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  151390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  151395 */     GIR_RootConstrainSelectedInstOperands,
     /*  151396 */     // GIR_Coverage, 2294,
     /*  151396 */     GIR_Done,
     /*  151397 */   // Label 2743: @151397
     /*  151397 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(151412), // Rule ID 2295 //
     /*  151402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_IsRV32_HwMode1),
     /*  151405 */     // (RISCVBuildPairF64:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (FMVP_D_X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  151405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMVP_D_X),
     /*  151410 */     GIR_RootConstrainSelectedInstOperands,
     /*  151411 */     // GIR_Coverage, 2295,
     /*  151411 */     GIR_Done,
     /*  151412 */   // Label 2744: @151412
     /*  151412 */   GIM_Reject,
     /*  151413 */ // Label 2740: @151413
     /*  151413 */ GIM_Reject,
     /*  151414 */ // Label 13: @151414
     /*  151414 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2747*/ GIMT_Encode4(151780),
     /*  151425 */ /*GILLT_s32*//*Label 2745*/ GIMT_Encode4(151433),
     /*  151429 */ /*GILLT_s64*//*Label 2746*/ GIMT_Encode4(151670),
     /*  151433 */ // Label 2745: @151433
     /*  151433 */ GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(151669),
     /*  151438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  151441 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(151464), // Rule ID 1337 //
     /*  151446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  151449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151457 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  151457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  151462 */     GIR_RootConstrainSelectedInstOperands,
     /*  151463 */     // GIR_Coverage, 1337,
     /*  151463 */     GIR_Done,
     /*  151464 */   // Label 2749: @151464
     /*  151464 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(151487), // Rule ID 1338 //
     /*  151469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  151472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151480 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FMV_W_X:{ *:[f32] } GPR:{ *:[i32] }:$rs1)
     /*  151480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_W_X),
     /*  151485 */     GIR_RootConstrainSelectedInstOperands,
     /*  151486 */     // GIR_Coverage, 1338,
     /*  151486 */     GIR_Done,
     /*  151487 */   // Label 2750: @151487
     /*  151487 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(151510), // Rule ID 1339 //
     /*  151492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  151495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151503 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  151503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  151508 */     GIR_RootConstrainSelectedInstOperands,
     /*  151509 */     // GIR_Coverage, 1339,
     /*  151509 */     GIR_Done,
     /*  151510 */   // Label 2751: @151510
     /*  151510 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(151533), // Rule ID 1340 //
     /*  151515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  151518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151526 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMV_X_W:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)
     /*  151526 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_W),
     /*  151531 */     GIR_RootConstrainSelectedInstOperands,
     /*  151532 */     // GIR_Coverage, 1340,
     /*  151532 */     GIR_Done,
     /*  151533 */   // Label 2752: @151533
     /*  151533 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(151571), // Rule ID 1341 //
     /*  151538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  151541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151549 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  151549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  151552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  151554 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  151560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151570 */     // GIR_Coverage, 1341,
     /*  151570 */     GIR_EraseRootFromParent_Done,
     /*  151571 */   // Label 2753: @151571
     /*  151571 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(151609), // Rule ID 1342 //
     /*  151576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  151579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151587 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (EXTRACT_SUBREG:{ *:[f32] } GPR:{ *:[i32] }:$rs1, sub_32:{ *:[i32] })
     /*  151587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  151590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  151592 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(2), // rs1
     /*  151598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151608 */     // GIR_Coverage, 1342,
     /*  151608 */     GIR_EraseRootFromParent_Done,
     /*  151609 */   // Label 2754: @151609
     /*  151609 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(151668), // Rule ID 1343 //
     /*  151614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  151617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151625 */     // (bitconvert:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), FPR32INX:{ *:[f32] }:$rs1, sub_32:{ *:[i32] })
     /*  151625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  151628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  151632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  151637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  151639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  151642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  151644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  151647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  151652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  151667 */     // GIR_Coverage, 1343,
     /*  151667 */     GIR_EraseRootFromParent_Done,
     /*  151668 */   // Label 2755: @151668
     /*  151668 */   GIM_Reject,
     /*  151669 */ // Label 2748: @151669
     /*  151669 */ GIM_Reject,
     /*  151670 */ // Label 2746: @151670
     /*  151670 */ GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(151779),
     /*  151675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  151678 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(151701), // Rule ID 1790 //
     /*  151683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  151686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151694 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FMV_D_X:{ *:[f64] } GPR:{ *:[i64] }:$rs1)
     /*  151694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_D_X),
     /*  151699 */     GIR_RootConstrainSelectedInstOperands,
     /*  151700 */     // GIR_Coverage, 1790,
     /*  151700 */     GIR_Done,
     /*  151701 */   // Label 2757: @151701
     /*  151701 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(151724), // Rule ID 1791 //
     /*  151706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  151709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151717 */     // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMV_X_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)
     /*  151717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMV_X_D),
     /*  151722 */     GIR_RootConstrainSelectedInstOperands,
     /*  151723 */     // GIR_Coverage, 1791,
     /*  151723 */     GIR_Done,
     /*  151724 */   // Label 2758: @151724
     /*  151724 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(151751), // Rule ID 1818 //
     /*  151729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  151732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151740 */     // (bitconvert:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i32] })
     /*  151740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  151745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151750 */     // GIR_Coverage, 1818,
     /*  151750 */     GIR_Done,
     /*  151751 */   // Label 2759: @151751
     /*  151751 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(151778), // Rule ID 1819 //
     /*  151756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  151759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151767 */     // (bitconvert:{ *:[i64] } GPR:{ *:[f64] }:$rs1)  =>  (COPY_TO_REGCLASS:{ *:[i64] } GPR:{ *:[f64] }:$rs1, GPR:{ *:[i32] })
     /*  151767 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  151772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(RISCV::GPRRegClassID),
     /*  151777 */     // GIR_Coverage, 1819,
     /*  151777 */     GIR_Done,
     /*  151778 */   // Label 2760: @151778
     /*  151778 */   GIM_Reject,
     /*  151779 */ // Label 2756: @151779
     /*  151779 */ GIM_Reject,
     /*  151780 */ // Label 2747: @151780
     /*  151780 */ GIM_Reject,
     /*  151781 */ // Label 14: @151781
     /*  151781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2764*/ GIMT_Encode4(151978),
     /*  151792 */ /*GILLT_s16*//*Label 2761*/ GIMT_Encode4(151804),
     /*  151796 */ /*GILLT_s32*//*Label 2762*/ GIMT_Encode4(151862),
     /*  151800 */ /*GILLT_s64*//*Label 2763*/ GIMT_Encode4(151920),
     /*  151804 */ // Label 2761: @151804
     /*  151804 */ GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(151861),
     /*  151809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  151812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  151816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  151820 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(151840), // Rule ID 2326 //
     /*  151825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  151828 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /*  151828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  151831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151838 */     GIR_RootConstrainSelectedInstOperands,
     /*  151839 */     // GIR_Coverage, 2326,
     /*  151839 */     GIR_EraseRootFromParent_Done,
     /*  151840 */   // Label 2766: @151840
     /*  151840 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(151860), // Rule ID 2327 //
     /*  151845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  151848 */     // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /*  151848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  151851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151858 */     GIR_RootConstrainSelectedInstOperands,
     /*  151859 */     // GIR_Coverage, 2327,
     /*  151859 */     GIR_EraseRootFromParent_Done,
     /*  151860 */   // Label 2767: @151860
     /*  151860 */   GIM_Reject,
     /*  151861 */ // Label 2765: @151861
     /*  151861 */ GIM_Reject,
     /*  151862 */ // Label 2762: @151862
     /*  151862 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(151919),
     /*  151867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  151870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  151878 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(151898), // Rule ID 2244 //
     /*  151883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  151886 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /*  151886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  151889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151896 */     GIR_RootConstrainSelectedInstOperands,
     /*  151897 */     // GIR_Coverage, 2244,
     /*  151897 */     GIR_EraseRootFromParent_Done,
     /*  151898 */   // Label 2769: @151898
     /*  151898 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(151918), // Rule ID 2245 //
     /*  151903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  151906 */     // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /*  151906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  151909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151916 */     GIR_RootConstrainSelectedInstOperands,
     /*  151917 */     // GIR_Coverage, 2245,
     /*  151917 */     GIR_EraseRootFromParent_Done,
     /*  151918 */   // Label 2770: @151918
     /*  151918 */   GIM_Reject,
     /*  151919 */ // Label 2768: @151919
     /*  151919 */ GIM_Reject,
     /*  151920 */ // Label 2763: @151920
     /*  151920 */ GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(151977),
     /*  151925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  151928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  151936 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(151956), // Rule ID 2284 //
     /*  151941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  151944 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /*  151944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  151947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151954 */     GIR_RootConstrainSelectedInstOperands,
     /*  151955 */     // GIR_Coverage, 2284,
     /*  151955 */     GIR_EraseRootFromParent_Done,
     /*  151956 */   // Label 2772: @151956
     /*  151956 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(151976), // Rule ID 2285 //
     /*  151961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  151964 */     // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /*  151964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  151967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  151969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  151971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  151974 */     GIR_RootConstrainSelectedInstOperands,
     /*  151975 */     // GIR_Coverage, 2285,
     /*  151975 */     GIR_EraseRootFromParent_Done,
     /*  151976 */   // Label 2773: @151976
     /*  151976 */   GIM_Reject,
     /*  151977 */ // Label 2771: @151977
     /*  151977 */ GIM_Reject,
     /*  151978 */ // Label 2764: @151978
     /*  151978 */ GIM_Reject,
     /*  151979 */ // Label 15: @151979
     /*  151979 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2777*/ GIMT_Encode4(152176),
     /*  151990 */ /*GILLT_s16*//*Label 2774*/ GIMT_Encode4(152002),
     /*  151994 */ /*GILLT_s32*//*Label 2775*/ GIMT_Encode4(152060),
     /*  151998 */ /*GILLT_s64*//*Label 2776*/ GIMT_Encode4(152118),
     /*  152002 */ // Label 2774: @152002
     /*  152002 */ GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(152059),
     /*  152007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152018 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(152038), // Rule ID 2310 //
     /*  152023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  152026 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /*  152026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  152029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152036 */     GIR_RootConstrainSelectedInstOperands,
     /*  152037 */     // GIR_Coverage, 2310,
     /*  152037 */     GIR_EraseRootFromParent_Done,
     /*  152038 */   // Label 2779: @152038
     /*  152038 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(152058), // Rule ID 2311 //
     /*  152043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  152046 */     // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /*  152046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  152049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152051 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152056 */     GIR_RootConstrainSelectedInstOperands,
     /*  152057 */     // GIR_Coverage, 2311,
     /*  152057 */     GIR_EraseRootFromParent_Done,
     /*  152058 */   // Label 2780: @152058
     /*  152058 */   GIM_Reject,
     /*  152059 */ // Label 2778: @152059
     /*  152059 */ GIM_Reject,
     /*  152060 */ // Label 2775: @152060
     /*  152060 */ GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(152117),
     /*  152065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152076 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(152096), // Rule ID 2228 //
     /*  152081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  152084 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /*  152084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  152087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152094 */     GIR_RootConstrainSelectedInstOperands,
     /*  152095 */     // GIR_Coverage, 2228,
     /*  152095 */     GIR_EraseRootFromParent_Done,
     /*  152096 */   // Label 2782: @152096
     /*  152096 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(152116), // Rule ID 2229 //
     /*  152101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  152104 */     // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /*  152104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  152107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152109 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152114 */     GIR_RootConstrainSelectedInstOperands,
     /*  152115 */     // GIR_Coverage, 2229,
     /*  152115 */     GIR_EraseRootFromParent_Done,
     /*  152116 */   // Label 2783: @152116
     /*  152116 */   GIM_Reject,
     /*  152117 */ // Label 2781: @152117
     /*  152117 */ GIM_Reject,
     /*  152118 */ // Label 2776: @152118
     /*  152118 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(152175),
     /*  152123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152134 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(152154), // Rule ID 2268 //
     /*  152139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  152142 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /*  152142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  152145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152152 */     GIR_RootConstrainSelectedInstOperands,
     /*  152153 */     // GIR_Coverage, 2268,
     /*  152153 */     GIR_EraseRootFromParent_Done,
     /*  152154 */   // Label 2785: @152154
     /*  152154 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(152174), // Rule ID 2269 //
     /*  152159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  152162 */     // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /*  152162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  152165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  152172 */     GIR_RootConstrainSelectedInstOperands,
     /*  152173 */     // GIR_Coverage, 2269,
     /*  152173 */     GIR_EraseRootFromParent_Done,
     /*  152174 */   // Label 2786: @152174
     /*  152174 */   GIM_Reject,
     /*  152175 */ // Label 2784: @152175
     /*  152175 */ GIM_Reject,
     /*  152176 */ // Label 2777: @152176
     /*  152176 */ GIM_Reject,
     /*  152177 */ // Label 16: @152177
     /*  152177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 2789*/ GIMT_Encode4(152756),
     /*  152188 */ /*GILLT_s32*//*Label 2787*/ GIMT_Encode4(152196),
     /*  152192 */ /*GILLT_s64*//*Label 2788*/ GIMT_Encode4(152569),
     /*  152196 */ // Label 2787: @152196
     /*  152196 */ GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(152227), // Rule ID 1356 //
     /*  152201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /*  152204 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152211 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152215 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  152218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152220 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152225 */   GIR_RootConstrainSelectedInstOperands,
     /*  152226 */   // GIR_Coverage, 1356,
     /*  152226 */   GIR_EraseRootFromParent_Done,
     /*  152227 */ // Label 2790: @152227
     /*  152227 */ GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(152258), // Rule ID 1357 //
     /*  152232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /*  152235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152246 */   // (lrint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  152246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /*  152249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152251 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152256 */   GIR_RootConstrainSelectedInstOperands,
     /*  152257 */   // GIR_Coverage, 1357,
     /*  152257 */   GIR_EraseRootFromParent_Done,
     /*  152258 */ // Label 2791: @152258
     /*  152258 */ GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(152289), // Rule ID 1382 //
     /*  152263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /*  152266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  152277 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  152280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152282 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152287 */   GIR_RootConstrainSelectedInstOperands,
     /*  152288 */   // GIR_Coverage, 1382,
     /*  152288 */   GIR_EraseRootFromParent_Done,
     /*  152289 */ // Label 2792: @152289
     /*  152289 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(152320), // Rule ID 1383 //
     /*  152294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /*  152297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  152308 */   // (lrint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /*  152308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /*  152311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152313 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152318 */   GIR_RootConstrainSelectedInstOperands,
     /*  152319 */   // GIR_Coverage, 1383,
     /*  152319 */   GIR_EraseRootFromParent_Done,
     /*  152320 */ // Label 2793: @152320
     /*  152320 */ GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(152351), // Rule ID 1750 //
     /*  152325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /*  152328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152339 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  152342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152344 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152349 */   GIR_RootConstrainSelectedInstOperands,
     /*  152350 */   // GIR_Coverage, 1750,
     /*  152350 */   GIR_EraseRootFromParent_Done,
     /*  152351 */ // Label 2794: @152351
     /*  152351 */ GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(152382), // Rule ID 1751 //
     /*  152356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /*  152359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152370 */   // (lrint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  152370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /*  152373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152380 */   GIR_RootConstrainSelectedInstOperands,
     /*  152381 */   // GIR_Coverage, 1751,
     /*  152381 */   GIR_EraseRootFromParent_Done,
     /*  152382 */ // Label 2795: @152382
     /*  152382 */ GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(152413), // Rule ID 1776 //
     /*  152387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /*  152390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  152401 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  152404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152411 */   GIR_RootConstrainSelectedInstOperands,
     /*  152412 */   // GIR_Coverage, 1776,
     /*  152412 */   GIR_EraseRootFromParent_Done,
     /*  152413 */ // Label 2796: @152413
     /*  152413 */ GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(152444), // Rule ID 1777 //
     /*  152418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /*  152421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /*  152432 */   // (lrint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /*  152432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /*  152435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152442 */   GIR_RootConstrainSelectedInstOperands,
     /*  152443 */   // GIR_Coverage, 1777,
     /*  152443 */   GIR_EraseRootFromParent_Done,
     /*  152444 */ // Label 2797: @152444
     /*  152444 */ GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(152475), // Rule ID 2092 //
     /*  152449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /*  152452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152463 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  152466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152468 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152473 */   GIR_RootConstrainSelectedInstOperands,
     /*  152474 */   // GIR_Coverage, 2092,
     /*  152474 */   GIR_EraseRootFromParent_Done,
     /*  152475 */ // Label 2798: @152475
     /*  152475 */ GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(152506), // Rule ID 2093 //
     /*  152480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /*  152483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152494 */   // (lrint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  152494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /*  152497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152499 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152504 */   GIR_RootConstrainSelectedInstOperands,
     /*  152505 */   // GIR_Coverage, 2093,
     /*  152505 */   GIR_EraseRootFromParent_Done,
     /*  152506 */ // Label 2799: @152506
     /*  152506 */ GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(152537), // Rule ID 2118 //
     /*  152511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /*  152514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  152525 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  152528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152530 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152535 */   GIR_RootConstrainSelectedInstOperands,
     /*  152536 */   // GIR_Coverage, 2118,
     /*  152536 */   GIR_EraseRootFromParent_Done,
     /*  152537 */ // Label 2800: @152537
     /*  152537 */ GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(152568), // Rule ID 2119 //
     /*  152542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /*  152545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  152556 */   // (lrint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /*  152556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /*  152559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152561 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152566 */   GIR_RootConstrainSelectedInstOperands,
     /*  152567 */   // GIR_Coverage, 2119,
     /*  152567 */   GIR_EraseRootFromParent_Done,
     /*  152568 */ // Label 2801: @152568
     /*  152568 */ GIM_Reject,
     /*  152569 */ // Label 2788: @152569
     /*  152569 */ GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(152600), // Rule ID 1409 //
     /*  152574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  152577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152588 */   // (lrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  152591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152593 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152598 */   GIR_RootConstrainSelectedInstOperands,
     /*  152599 */   // GIR_Coverage, 1409,
     /*  152599 */   GIR_EraseRootFromParent_Done,
     /*  152600 */ // Label 2802: @152600
     /*  152600 */ GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(152631), // Rule ID 1437 //
     /*  152605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  152608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  152611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  152619 */   // (lrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  152622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152629 */   GIR_RootConstrainSelectedInstOperands,
     /*  152630 */   // GIR_Coverage, 1437,
     /*  152630 */   GIR_EraseRootFromParent_Done,
     /*  152631 */ // Label 2803: @152631
     /*  152631 */ GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(152662), // Rule ID 1807 //
     /*  152636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  152639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152650 */   // (lrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152650 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  152653 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152660 */   GIR_RootConstrainSelectedInstOperands,
     /*  152661 */   // GIR_Coverage, 1807,
     /*  152661 */   GIR_EraseRootFromParent_Done,
     /*  152662 */ // Label 2804: @152662
     /*  152662 */ GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(152693), // Rule ID 1835 //
     /*  152667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  152670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  152673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152681 */   // (lrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  152684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152686 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152691 */   GIR_RootConstrainSelectedInstOperands,
     /*  152692 */   // GIR_Coverage, 1835,
     /*  152692 */   GIR_EraseRootFromParent_Done,
     /*  152693 */ // Label 2805: @152693
     /*  152693 */ GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(152724), // Rule ID 2143 //
     /*  152698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  152701 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152712 */   // (lrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  152715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152717 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152722 */   GIR_RootConstrainSelectedInstOperands,
     /*  152723 */   // GIR_Coverage, 2143,
     /*  152723 */   GIR_EraseRootFromParent_Done,
     /*  152724 */ // Label 2806: @152724
     /*  152724 */ GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(152755), // Rule ID 2169 //
     /*  152729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  152732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  152743 */   // (lrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  152746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152748 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152753 */   GIR_RootConstrainSelectedInstOperands,
     /*  152754 */   // GIR_Coverage, 2169,
     /*  152754 */   GIR_EraseRootFromParent_Done,
     /*  152755 */ // Label 2807: @152755
     /*  152755 */ GIM_Reject,
     /*  152756 */ // Label 2789: @152756
     /*  152756 */ GIM_Reject,
     /*  152757 */ // Label 17: @152757
     /*  152757 */ GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(152966),
     /*  152762 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  152765 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2812*/ GIMT_Encode4(152965),
     /*  152776 */   /*GILLT_s16*//*Label 2809*/ GIMT_Encode4(152788),
     /*  152780 */   /*GILLT_s32*//*Label 2810*/ GIMT_Encode4(152847),
     /*  152784 */   /*GILLT_s64*//*Label 2811*/ GIMT_Encode4(152906),
     /*  152788 */   // Label 2809: @152788
     /*  152788 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(152846),
     /*  152793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152797 */     GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(152821), // Rule ID 2145 //
     /*  152802 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /*  152805 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  152809 */       // (llrint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152809 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /*  152812 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152814 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152816 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152819 */       GIR_RootConstrainSelectedInstOperands,
     /*  152820 */       // GIR_Coverage, 2145,
     /*  152820 */       GIR_EraseRootFromParent_Done,
     /*  152821 */     // Label 2814: @152821
     /*  152821 */     GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(152845), // Rule ID 2171 //
     /*  152826 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /*  152829 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  152833 */       // (llrint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /*  152833 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /*  152836 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152838 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152840 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152843 */       GIR_RootConstrainSelectedInstOperands,
     /*  152844 */       // GIR_Coverage, 2171,
     /*  152844 */       GIR_EraseRootFromParent_Done,
     /*  152845 */     // Label 2815: @152845
     /*  152845 */     GIM_Reject,
     /*  152846 */   // Label 2813: @152846
     /*  152846 */   GIM_Reject,
     /*  152847 */   // Label 2810: @152847
     /*  152847 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(152905),
     /*  152852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152856 */     GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(152880), // Rule ID 1411 //
     /*  152861 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /*  152864 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  152868 */       // (llrint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152868 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /*  152871 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152873 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152875 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152878 */       GIR_RootConstrainSelectedInstOperands,
     /*  152879 */       // GIR_Coverage, 1411,
     /*  152879 */       GIR_EraseRootFromParent_Done,
     /*  152880 */     // Label 2817: @152880
     /*  152880 */     GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(152904), // Rule ID 1439 //
     /*  152885 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /*  152888 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  152892 */       // (llrint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /*  152892 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /*  152895 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152897 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152899 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152902 */       GIR_RootConstrainSelectedInstOperands,
     /*  152903 */       // GIR_Coverage, 1439,
     /*  152903 */       GIR_EraseRootFromParent_Done,
     /*  152904 */     // Label 2818: @152904
     /*  152904 */     GIM_Reject,
     /*  152905 */   // Label 2816: @152905
     /*  152905 */   GIM_Reject,
     /*  152906 */   // Label 2811: @152906
     /*  152906 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(152964),
     /*  152911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152915 */     GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(152939), // Rule ID 1809 //
     /*  152920 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /*  152923 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  152927 */       // (llrint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152927 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /*  152930 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152932 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152934 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152937 */       GIR_RootConstrainSelectedInstOperands,
     /*  152938 */       // GIR_Coverage, 1809,
     /*  152938 */       GIR_EraseRootFromParent_Done,
     /*  152939 */     // Label 2820: @152939
     /*  152939 */     GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(152963), // Rule ID 1837 //
     /*  152944 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  152947 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  152951 */       // (llrint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /*  152951 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /*  152954 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  152956 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  152958 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  152961 */       GIR_RootConstrainSelectedInstOperands,
     /*  152962 */       // GIR_Coverage, 1837,
     /*  152962 */       GIR_EraseRootFromParent_Done,
     /*  152963 */     // Label 2821: @152963
     /*  152963 */     GIM_Reject,
     /*  152964 */   // Label 2819: @152964
     /*  152964 */   GIM_Reject,
     /*  152965 */   // Label 2812: @152965
     /*  152965 */   GIM_Reject,
     /*  152966 */ // Label 2808: @152966
     /*  152966 */ GIM_Reject,
     /*  152967 */ // Label 18: @152967
     /*  152967 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 2825*/ GIMT_Encode4(153164),
     /*  152978 */ /*GILLT_s16*//*Label 2822*/ GIMT_Encode4(152990),
     /*  152982 */ /*GILLT_s32*//*Label 2823*/ GIMT_Encode4(153048),
     /*  152986 */ /*GILLT_s64*//*Label 2824*/ GIMT_Encode4(153106),
     /*  152990 */ // Label 2822: @152990
     /*  152990 */ GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(153047),
     /*  152995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  152998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  153002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  153006 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(153026), // Rule ID 2314 //
     /*  153011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /*  153014 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /*  153014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  153017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153024 */     GIR_RootConstrainSelectedInstOperands,
     /*  153025 */     // GIR_Coverage, 2314,
     /*  153025 */     GIR_EraseRootFromParent_Done,
     /*  153026 */   // Label 2827: @153026
     /*  153026 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(153046), // Rule ID 2315 //
     /*  153031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /*  153034 */     // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /*  153034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /*  153037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153044 */     GIR_RootConstrainSelectedInstOperands,
     /*  153045 */     // GIR_Coverage, 2315,
     /*  153045 */     GIR_EraseRootFromParent_Done,
     /*  153046 */   // Label 2828: @153046
     /*  153046 */   GIM_Reject,
     /*  153047 */ // Label 2826: @153047
     /*  153047 */ GIM_Reject,
     /*  153048 */ // Label 2823: @153048
     /*  153048 */ GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(153105),
     /*  153053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  153056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  153060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  153064 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(153084), // Rule ID 2232 //
     /*  153069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /*  153072 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /*  153072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  153075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153077 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153082 */     GIR_RootConstrainSelectedInstOperands,
     /*  153083 */     // GIR_Coverage, 2232,
     /*  153083 */     GIR_EraseRootFromParent_Done,
     /*  153084 */   // Label 2830: @153084
     /*  153084 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(153104), // Rule ID 2233 //
     /*  153089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /*  153092 */     // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /*  153092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /*  153095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153102 */     GIR_RootConstrainSelectedInstOperands,
     /*  153103 */     // GIR_Coverage, 2233,
     /*  153103 */     GIR_EraseRootFromParent_Done,
     /*  153104 */   // Label 2831: @153104
     /*  153104 */   GIM_Reject,
     /*  153105 */ // Label 2829: @153105
     /*  153105 */ GIM_Reject,
     /*  153106 */ // Label 2824: @153106
     /*  153106 */ GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(153163),
     /*  153111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  153114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  153118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  153122 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(153142), // Rule ID 2272 //
     /*  153127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /*  153130 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i64] })
     /*  153130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  153133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153140 */     GIR_RootConstrainSelectedInstOperands,
     /*  153141 */     // GIR_Coverage, 2272,
     /*  153141 */     GIR_EraseRootFromParent_Done,
     /*  153142 */   // Label 2833: @153142
     /*  153142 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(153162), // Rule ID 2273 //
     /*  153147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /*  153150 */     // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 0:{ *:[i32] })
     /*  153150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /*  153153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  153157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  153160 */     GIR_RootConstrainSelectedInstOperands,
     /*  153161 */     // GIR_Coverage, 2273,
     /*  153161 */     GIR_EraseRootFromParent_Done,
     /*  153162 */   // Label 2834: @153162
     /*  153162 */   GIM_Reject,
     /*  153163 */ // Label 2832: @153163
     /*  153163 */ GIM_Reject,
     /*  153164 */ // Label 2825: @153164
     /*  153164 */ GIM_Reject,
     /*  153165 */ // Label 19: @153165
     /*  153165 */ GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(153203), // Rule ID 281 //
     /*  153170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  153173 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  153176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153180 */   // (readcyclecounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3072:{ *:[i64] }, X0:{ *:[i64] })
     /*  153180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  153183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153185 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3072),
     /*  153195 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  153201 */   GIR_RootConstrainSelectedInstOperands,
     /*  153202 */   // GIR_Coverage, 281,
     /*  153202 */   GIR_EraseRootFromParent_Done,
     /*  153203 */ // Label 2835: @153203
     /*  153203 */ GIM_Reject,
     /*  153204 */ // Label 20: @153204
     /*  153204 */ GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(153242), // Rule ID 282 //
     /*  153209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  153212 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  153215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153219 */   // (readsteadycounter:{ *:[i64] })  =>  (CSRRS:{ *:[i64] } 3073:{ *:[i64] }, X0:{ *:[i64] })
     /*  153219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CSRRS),
     /*  153222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153224 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(3073),
     /*  153234 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  153240 */   GIR_RootConstrainSelectedInstOperands,
     /*  153241 */   // GIR_Coverage, 282,
     /*  153241 */   GIR_EraseRootFromParent_Done,
     /*  153242 */ // Label 2836: @153242
     /*  153242 */ GIM_Reject,
     /*  153243 */ // Label 21: @153243
     /*  153243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 2871*/ GIMT_Encode4(163422),
     /*  153254 */ /*GILLT_p0s32*//*Label 2837*/ GIMT_Encode4(153390),
     /*  153258 */ /*GILLT_p0s64*//*Label 2838*/ GIMT_Encode4(153484),
     /*  153262 */ /*GILLT_s16*//*Label 2839*/ GIMT_Encode4(153578),
     /*  153266 */ /*GILLT_s32*//*Label 2840*/ GIMT_Encode4(154233),
     /*  153270 */ /*GILLT_s64*//*Label 2841*/ GIMT_Encode4(156992),
     /*  153274 */ /*GILLT_nxv1s1*//*Label 2842*/ GIMT_Encode4(158116),
     /*  153278 */ /*GILLT_nxv1s8*//*Label 2843*/ GIMT_Encode4(158236),
     /*  153282 */ /*GILLT_nxv1s16*//*Label 2844*/ GIMT_Encode4(158364),
     /*  153286 */ /*GILLT_nxv1s32*//*Label 2845*/ GIMT_Encode4(158602),
     /*  153290 */ /*GILLT_nxv1s64*//*Label 2846*/ GIMT_Encode4(158840),
     /*  153294 */ /*GILLT_nxv2s1*//*Label 2847*/ GIMT_Encode4(159078),
     /*  153298 */ /*GILLT_nxv2s8*//*Label 2848*/ GIMT_Encode4(159198),
     /*  153302 */ /*GILLT_nxv2s16*//*Label 2849*/ GIMT_Encode4(159326),
     /*  153306 */ /*GILLT_nxv2s32*//*Label 2850*/ GIMT_Encode4(159564),
     /*  153310 */ /*GILLT_nxv2s64*//*Label 2851*/ GIMT_Encode4(159802),
     /*  153314 */ /*GILLT_nxv4s1*//*Label 2852*/ GIMT_Encode4(160040),
     /*  153318 */ /*GILLT_nxv4s8*//*Label 2853*/ GIMT_Encode4(160160),
     /*  153322 */ /*GILLT_nxv4s16*//*Label 2854*/ GIMT_Encode4(160288),
     /*  153326 */ /*GILLT_nxv4s32*//*Label 2855*/ GIMT_Encode4(160526),
     /*  153330 */ /*GILLT_nxv4s64*//*Label 2856*/ GIMT_Encode4(160764),
     /*  153334 */ /*GILLT_nxv8s1*//*Label 2857*/ GIMT_Encode4(161002),
     /*  153338 */ /*GILLT_nxv8s8*//*Label 2858*/ GIMT_Encode4(161122),
     /*  153342 */ /*GILLT_nxv8s16*//*Label 2859*/ GIMT_Encode4(161250),
     /*  153346 */ /*GILLT_nxv8s32*//*Label 2860*/ GIMT_Encode4(161488),
     /*  153350 */ /*GILLT_nxv8s64*//*Label 2861*/ GIMT_Encode4(161726),
     /*  153354 */ /*GILLT_nxv16s1*//*Label 2862*/ GIMT_Encode4(161964),
     /*  153358 */ /*GILLT_nxv16s8*//*Label 2863*/ GIMT_Encode4(162084),
     /*  153362 */ /*GILLT_nxv16s16*//*Label 2864*/ GIMT_Encode4(162212),
     /*  153366 */ /*GILLT_nxv16s32*//*Label 2865*/ GIMT_Encode4(162450),
     /*  153370 */ /*GILLT_nxv32s1*//*Label 2866*/ GIMT_Encode4(162688),
     /*  153374 */ /*GILLT_nxv32s8*//*Label 2867*/ GIMT_Encode4(162808),
     /*  153378 */ /*GILLT_nxv32s16*//*Label 2868*/ GIMT_Encode4(162936),
     /*  153382 */ /*GILLT_nxv64s1*//*Label 2869*/ GIMT_Encode4(163174),
     /*  153386 */ /*GILLT_nxv64s8*//*Label 2870*/ GIMT_Encode4(163294),
     /*  153390 */ // Label 2837: @153390
     /*  153390 */ GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(153483),
     /*  153395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153406 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153410 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(153446), // Rule ID 64999 //
     /*  153415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  153418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153425 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  153428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153444 */     GIR_RootConstrainSelectedInstOperands,
     /*  153445 */     // GIR_Coverage, 64999,
     /*  153445 */     GIR_EraseRootFromParent_Done,
     /*  153446 */   // Label 2873: @153446
     /*  153446 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(153482), // Rule ID 65003 //
     /*  153451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  153454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153461 */     // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  153464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153480 */     GIR_RootConstrainSelectedInstOperands,
     /*  153481 */     // GIR_Coverage, 65003,
     /*  153481 */     GIR_EraseRootFromParent_Done,
     /*  153482 */   // Label 2874: @153482
     /*  153482 */   GIM_Reject,
     /*  153483 */ // Label 2872: @153483
     /*  153483 */ GIM_Reject,
     /*  153484 */ // Label 2838: @153484
     /*  153484 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(153577),
     /*  153489 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153492 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153504 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(153540), // Rule ID 64998 //
     /*  153509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  153512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153519 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  153522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153538 */     GIR_RootConstrainSelectedInstOperands,
     /*  153539 */     // GIR_Coverage, 64998,
     /*  153539 */     GIR_EraseRootFromParent_Done,
     /*  153540 */   // Label 2876: @153540
     /*  153540 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(153576), // Rule ID 65002 //
     /*  153545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  153548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153555 */     // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  153558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153574 */     GIR_RootConstrainSelectedInstOperands,
     /*  153575 */     // GIR_Coverage, 65002,
     /*  153575 */     GIR_EraseRootFromParent_Done,
     /*  153576 */   // Label 2877: @153576
     /*  153576 */   GIM_Reject,
     /*  153577 */ // Label 2875: @153577
     /*  153577 */ GIM_Reject,
     /*  153578 */ // Label 2839: @153578
     /*  153578 */ GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(153629), // Rule ID 2040 //
     /*  153583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  153586 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153589 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  153597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153608 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  153611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153627 */   GIR_RootConstrainSelectedInstOperands,
     /*  153628 */   // GIR_Coverage, 2040,
     /*  153628 */   GIR_EraseRootFromParent_Done,
     /*  153629 */ // Label 2878: @153629
     /*  153629 */ GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(153680), // Rule ID 2041 //
     /*  153634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  153637 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153640 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  153648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153652 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153659 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLH:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLH),
     /*  153662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153669 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153674 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153678 */   GIR_RootConstrainSelectedInstOperands,
     /*  153679 */   // GIR_Coverage, 2041,
     /*  153679 */   GIR_EraseRootFromParent_Done,
     /*  153680 */ // Label 2879: @153680
     /*  153680 */ GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(153731), // Rule ID 2046 //
     /*  153685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  153688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153691 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  153699 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153703 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153710 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  153713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153715 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153725 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153729 */   GIR_RootConstrainSelectedInstOperands,
     /*  153730 */   // GIR_Coverage, 2046,
     /*  153730 */   GIR_EraseRootFromParent_Done,
     /*  153731 */ // Label 2880: @153731
     /*  153731 */ GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(153782), // Rule ID 2047 //
     /*  153736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  153739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153742 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  153750 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153754 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153761 */   // (ld:{ *:[f16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH_INX:{ *:[f16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH_INX),
     /*  153764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153776 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153780 */   GIR_RootConstrainSelectedInstOperands,
     /*  153781 */   // GIR_Coverage, 2047,
     /*  153781 */   GIR_EraseRootFromParent_Done,
     /*  153782 */ // Label 2881: @153782
     /*  153782 */ GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(153833), // Rule ID 65006 //
     /*  153787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  153790 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153793 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153812 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  153815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153827 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153831 */   GIR_RootConstrainSelectedInstOperands,
     /*  153832 */   // GIR_Coverage, 65006,
     /*  153832 */   GIR_EraseRootFromParent_Done,
     /*  153833 */ // Label 2882: @153833
     /*  153833 */ GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(153884), // Rule ID 65007 //
     /*  153838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  153841 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153844 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153852 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153856 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153863 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  153866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153868 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153878 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153882 */   GIR_RootConstrainSelectedInstOperands,
     /*  153883 */   // GIR_Coverage, 65007,
     /*  153883 */   GIR_EraseRootFromParent_Done,
     /*  153884 */ // Label 2883: @153884
     /*  153884 */ GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(153942), // Rule ID 65010 //
     /*  153889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  153892 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153895 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153899 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  153906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153910 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153914 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153921 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  153921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  153924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153926 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153936 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153940 */   GIR_RootConstrainSelectedInstOperands,
     /*  153941 */   // GIR_Coverage, 65010,
     /*  153941 */   GIR_EraseRootFromParent_Done,
     /*  153942 */ // Label 2884: @153942
     /*  153942 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(154000), // Rule ID 65011 //
     /*  153947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  153950 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  153953 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  153957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  153964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  153968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  153972 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  153979 */   // (ld:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  153979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  153982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  153984 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  153989 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  153994 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  153998 */   GIR_RootConstrainSelectedInstOperands,
     /*  153999 */   // GIR_Coverage, 65011,
     /*  153999 */   GIR_EraseRootFromParent_Done,
     /*  154000 */ // Label 2885: @154000
     /*  154000 */ GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(154058), // Rule ID 65014 //
     /*  154005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  154008 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  154011 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154015 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  154022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  154030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  154037 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  154037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  154040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  154047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  154052 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  154056 */   GIR_RootConstrainSelectedInstOperands,
     /*  154057 */   // GIR_Coverage, 65014,
     /*  154057 */   GIR_EraseRootFromParent_Done,
     /*  154058 */ // Label 2886: @154058
     /*  154058 */ GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(154116), // Rule ID 65015 //
     /*  154063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  154066 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  154069 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  154080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154084 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  154088 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  154095 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>  =>  (LB:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  154095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  154098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  154105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  154110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  154114 */   GIR_RootConstrainSelectedInstOperands,
     /*  154115 */   // GIR_Coverage, 65015,
     /*  154115 */   GIR_EraseRootFromParent_Done,
     /*  154116 */ // Label 2887: @154116
     /*  154116 */ GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(154174), // Rule ID 65016 //
     /*  154121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  154124 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  154127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154131 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  154138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154142 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  154146 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  154153 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  154153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  154156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154158 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  154163 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  154168 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  154172 */   GIR_RootConstrainSelectedInstOperands,
     /*  154173 */   // GIR_Coverage, 65016,
     /*  154173 */   GIR_EraseRootFromParent_Done,
     /*  154174 */ // Label 2888: @154174
     /*  154174 */ GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(154232), // Rule ID 65017 //
     /*  154179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  154182 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  154185 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154189 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  154196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  154204 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  154211 */   // (atomic_load:{ *:[i16] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_16>>  =>  (LH:{ *:[i16] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  154211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  154214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  154221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  154226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  154230 */   GIR_RootConstrainSelectedInstOperands,
     /*  154231 */   // GIR_Coverage, 65017,
     /*  154231 */   GIR_EraseRootFromParent_Done,
     /*  154232 */ // Label 2889: @154232
     /*  154232 */ GIM_Reject,
     /*  154233 */ // Label 2840: @154233
     /*  154233 */ GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(154344), // Rule ID 74014 //
     /*  154238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  154241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154244 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154248 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  154255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154259 */   // MIs[0] Operand 1
     /*  154259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154263 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154267 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154271 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154279 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154283 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154287 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154291 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  154295 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154300 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154304 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154308 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154312 */   // MIs[3] Operand 1
     /*  154312 */   // No operand predicates
     /*  154312 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154317 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154319 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  154319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  154322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154324 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154328 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154332 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154335 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154342 */   GIR_RootConstrainSelectedInstOperands,
     /*  154343 */   // GIR_Coverage, 74014,
     /*  154343 */   GIR_EraseRootFromParent_Done,
     /*  154344 */ // Label 2890: @154344
     /*  154344 */ GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(154455), // Rule ID 74015 //
     /*  154349 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  154352 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154355 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154359 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  154366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154370 */   // MIs[0] Operand 1
     /*  154370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154374 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154378 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154382 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154386 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154390 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154394 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154398 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154402 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  154406 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154411 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154415 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154419 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154423 */   // MIs[3] Operand 1
     /*  154423 */   // No operand predicates
     /*  154423 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154428 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154430 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  154430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  154433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154435 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154439 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154443 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154446 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154453 */   GIR_RootConstrainSelectedInstOperands,
     /*  154454 */   // GIR_Coverage, 74015,
     /*  154454 */   GIR_EraseRootFromParent_Done,
     /*  154455 */ // Label 2891: @154455
     /*  154455 */ GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(154566), // Rule ID 74018 //
     /*  154460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  154463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154466 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154470 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  154477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154481 */   // MIs[0] Operand 1
     /*  154481 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154485 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154489 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154493 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154497 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154501 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154505 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154509 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154513 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  154517 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154522 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154526 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154530 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154534 */   // MIs[3] Operand 1
     /*  154534 */   // No operand predicates
     /*  154534 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154539 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154541 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  154541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  154544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154546 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154550 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154554 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154557 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154564 */   GIR_RootConstrainSelectedInstOperands,
     /*  154565 */   // GIR_Coverage, 74018,
     /*  154565 */   GIR_EraseRootFromParent_Done,
     /*  154566 */ // Label 2892: @154566
     /*  154566 */ GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(154677), // Rule ID 74019 //
     /*  154571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  154574 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154577 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154581 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  154588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154592 */   // MIs[0] Operand 1
     /*  154592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154604 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154608 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154612 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154616 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154620 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154624 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  154628 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154633 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154637 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154641 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154645 */   // MIs[3] Operand 1
     /*  154645 */   // No operand predicates
     /*  154645 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154650 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154652 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  154652 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  154655 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154657 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154661 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154665 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154668 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154675 */   GIR_RootConstrainSelectedInstOperands,
     /*  154676 */   // GIR_Coverage, 74019,
     /*  154676 */   GIR_EraseRootFromParent_Done,
     /*  154677 */ // Label 2893: @154677
     /*  154677 */ GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(154781), // Rule ID 74020 //
     /*  154682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  154685 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154688 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154696 */   // MIs[0] Operand 1
     /*  154696 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154700 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154704 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154708 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154712 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154716 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154720 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154724 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154728 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  154732 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154737 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154741 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154745 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154749 */   // MIs[3] Operand 1
     /*  154749 */   // No operand predicates
     /*  154749 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154754 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154756 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  154756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  154759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154761 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154765 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154769 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154779 */   GIR_RootConstrainSelectedInstOperands,
     /*  154780 */   // GIR_Coverage, 74020,
     /*  154780 */   GIR_EraseRootFromParent_Done,
     /*  154781 */ // Label 2894: @154781
     /*  154781 */ GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(154885), // Rule ID 74021 //
     /*  154786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  154789 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154792 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154800 */   // MIs[0] Operand 1
     /*  154800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154812 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154816 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154820 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  154824 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154828 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154832 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  154836 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154841 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154845 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154849 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154853 */   // MIs[3] Operand 1
     /*  154853 */   // No operand predicates
     /*  154853 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154858 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154860 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  154860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  154863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154865 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  154869 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154873 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154883 */   GIR_RootConstrainSelectedInstOperands,
     /*  154884 */   // GIR_Coverage, 74021,
     /*  154884 */   GIR_EraseRootFromParent_Done,
     /*  154885 */ // Label 2895: @154885
     /*  154885 */ GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(154996), // Rule ID 64529 //
     /*  154890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  154893 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  154896 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  154900 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  154907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154911 */   // MIs[0] Operand 1
     /*  154911 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  154915 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  154919 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  154923 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  154927 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  154931 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  154936 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  154940 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  154944 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  154948 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  154952 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  154957 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  154961 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  154965 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  154969 */   // MIs[3] Operand 1
     /*  154969 */   // No operand predicates
     /*  154969 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  154971 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  154971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  154974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  154976 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  154980 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  154984 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  154987 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  154994 */   GIR_RootConstrainSelectedInstOperands,
     /*  154995 */   // GIR_Coverage, 64529,
     /*  154995 */   GIR_EraseRootFromParent_Done,
     /*  154996 */ // Label 2896: @154996
     /*  154996 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(155107), // Rule ID 64530 //
     /*  155001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  155004 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155007 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155011 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  155018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155022 */   // MIs[0] Operand 1
     /*  155022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  155026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  155034 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155038 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  155042 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155047 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155051 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  155055 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155059 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  155063 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  155068 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  155072 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  155076 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  155080 */   // MIs[3] Operand 1
     /*  155080 */   // No operand predicates
     /*  155080 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  155082 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  155082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  155085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155087 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155091 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  155095 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  155098 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  155105 */   GIR_RootConstrainSelectedInstOperands,
     /*  155106 */   // GIR_Coverage, 64530,
     /*  155106 */   GIR_EraseRootFromParent_Done,
     /*  155107 */ // Label 2897: @155107
     /*  155107 */ GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(155218), // Rule ID 64533 //
     /*  155112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  155115 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155118 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155122 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  155129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155133 */   // MIs[0] Operand 1
     /*  155133 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  155137 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155141 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  155145 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155149 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  155153 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155158 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155162 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  155166 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155170 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  155174 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  155179 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  155183 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  155187 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  155191 */   // MIs[3] Operand 1
     /*  155191 */   // No operand predicates
     /*  155191 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  155193 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  155193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  155196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155198 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155202 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  155206 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  155209 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  155216 */   GIR_RootConstrainSelectedInstOperands,
     /*  155217 */   // GIR_Coverage, 64533,
     /*  155217 */   GIR_EraseRootFromParent_Done,
     /*  155218 */ // Label 2898: @155218
     /*  155218 */ GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(155329), // Rule ID 64534 //
     /*  155223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  155226 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155229 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155233 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  155240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155244 */   // MIs[0] Operand 1
     /*  155244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  155248 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155252 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  155256 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155260 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  155264 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155269 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155273 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  155277 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155281 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  155285 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  155290 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  155294 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  155298 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  155302 */   // MIs[3] Operand 1
     /*  155302 */   // No operand predicates
     /*  155302 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  155304 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  155304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  155307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155309 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155313 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  155317 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  155320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  155327 */   GIR_RootConstrainSelectedInstOperands,
     /*  155328 */   // GIR_Coverage, 64534,
     /*  155328 */   GIR_EraseRootFromParent_Done,
     /*  155329 */ // Label 2899: @155329
     /*  155329 */ GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(155433), // Rule ID 64535 //
     /*  155334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  155337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155348 */   // MIs[0] Operand 1
     /*  155348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  155352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  155360 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155364 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  155368 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155373 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155377 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  155381 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155385 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  155389 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  155394 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  155398 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  155402 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  155406 */   // MIs[3] Operand 1
     /*  155406 */   // No operand predicates
     /*  155406 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  155408 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  155408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  155411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155413 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155417 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  155421 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  155424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  155431 */   GIR_RootConstrainSelectedInstOperands,
     /*  155432 */   // GIR_Coverage, 64535,
     /*  155432 */   GIR_EraseRootFromParent_Done,
     /*  155433 */ // Label 2900: @155433
     /*  155433 */ GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(155537), // Rule ID 64536 //
     /*  155438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  155441 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155444 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155452 */   // MIs[0] Operand 1
     /*  155452 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  155456 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  155460 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  155464 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  155468 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  155472 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155477 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  155481 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  155485 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  155489 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  155493 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  155498 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  155502 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  155506 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  155510 */   // MIs[3] Operand 1
     /*  155510 */   // No operand predicates
     /*  155510 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  155512 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (QC_LRW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  155512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRW),
     /*  155515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155517 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  155521 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  155525 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  155528 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  155535 */   GIR_RootConstrainSelectedInstOperands,
     /*  155536 */   // GIR_Coverage, 64536,
     /*  155536 */   GIR_EraseRootFromParent_Done,
     /*  155537 */ // Label 2901: @155537
     /*  155537 */ GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(155595), // Rule ID 227 //
     /*  155542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155545 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155548 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155552 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  155559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155567 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155574 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  155577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155579 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155584 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155589 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155593 */   GIR_RootConstrainSelectedInstOperands,
     /*  155594 */   // GIR_Coverage, 227,
     /*  155594 */   GIR_EraseRootFromParent_Done,
     /*  155595 */ // Label 2902: @155595
     /*  155595 */ GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(155653), // Rule ID 231 //
     /*  155600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  155617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155632 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  155635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155651 */   GIR_RootConstrainSelectedInstOperands,
     /*  155652 */   // GIR_Coverage, 231,
     /*  155652 */   GIR_EraseRootFromParent_Done,
     /*  155653 */ // Label 2903: @155653
     /*  155653 */ GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(155704), // Rule ID 232 //
     /*  155658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  155661 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155664 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155683 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  155683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  155686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155698 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155702 */   GIR_RootConstrainSelectedInstOperands,
     /*  155703 */   // GIR_Coverage, 232,
     /*  155703 */   GIR_EraseRootFromParent_Done,
     /*  155704 */ // Label 2904: @155704
     /*  155704 */ GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(155755), // Rule ID 233 //
     /*  155709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  155712 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  155715 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155723 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155727 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155734 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  155737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155739 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155749 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155753 */   GIR_RootConstrainSelectedInstOperands,
     /*  155754 */   // GIR_Coverage, 233,
     /*  155754 */   GIR_EraseRootFromParent_Done,
     /*  155755 */ // Label 2905: @155755
     /*  155755 */ GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(155816), // Rule ID 314 //
     /*  155760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  155763 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  155766 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155770 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  155777 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  155780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155784 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155788 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155795 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10087>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  155798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155805 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155810 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155814 */   GIR_RootConstrainSelectedInstOperands,
     /*  155815 */   // GIR_Coverage, 314,
     /*  155815 */   GIR_EraseRootFromParent_Done,
     /*  155816 */ // Label 2906: @155816
     /*  155816 */ GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(155877), // Rule ID 318 //
     /*  155821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  155824 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  155827 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155831 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  155838 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  155841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155845 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155849 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155856 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10089>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  155859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155875 */   GIR_RootConstrainSelectedInstOperands,
     /*  155876 */   // GIR_Coverage, 318,
     /*  155876 */   GIR_EraseRootFromParent_Done,
     /*  155877 */ // Label 2907: @155877
     /*  155877 */ GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(155938), // Rule ID 332 //
     /*  155882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode1),
     /*  155885 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  155888 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  155899 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  155902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155917 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10101>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  155920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155932 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155936 */   GIR_RootConstrainSelectedInstOperands,
     /*  155937 */   // GIR_Coverage, 332,
     /*  155937 */   GIR_EraseRootFromParent_Done,
     /*  155938 */ // Label 2908: @155938
     /*  155938 */ GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(155999), // Rule ID 334 //
     /*  155943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  155946 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  155949 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  155953 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  155960 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  155963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  155967 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  155971 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  155978 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10103>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  155978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  155981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  155983 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  155988 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  155993 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  155997 */   GIR_RootConstrainSelectedInstOperands,
     /*  155998 */   // GIR_Coverage, 334,
     /*  155998 */   GIR_EraseRootFromParent_Done,
     /*  155999 */ // Label 2909: @155999
     /*  155999 */ GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(156050), // Rule ID 1327 //
     /*  156004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  156007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156010 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156029 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  156029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  156032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156048 */   GIR_RootConstrainSelectedInstOperands,
     /*  156049 */   // GIR_Coverage, 1327,
     /*  156049 */   GIR_EraseRootFromParent_Done,
     /*  156050 */ // Label 2910: @156050
     /*  156050 */ GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(156101), // Rule ID 1328 //
     /*  156055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  156058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156061 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  156069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156080 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLW:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  156080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLW),
     /*  156083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156085 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156090 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156095 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156099 */   GIR_RootConstrainSelectedInstOperands,
     /*  156100 */   // GIR_Coverage, 1328,
     /*  156100 */   GIR_EraseRootFromParent_Done,
     /*  156101 */ // Label 2911: @156101
     /*  156101 */ GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(156152), // Rule ID 1333 //
     /*  156106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  156109 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156112 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156120 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156124 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156131 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  156131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  156134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156136 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156146 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156150 */   GIR_RootConstrainSelectedInstOperands,
     /*  156151 */   // GIR_Coverage, 1333,
     /*  156151 */   GIR_EraseRootFromParent_Done,
     /*  156152 */ // Label 2912: @156152
     /*  156152 */ GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(156203), // Rule ID 1334 //
     /*  156157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  156160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  156171 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156175 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156182 */   // (ld:{ *:[f32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LW_INX:{ *:[f32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  156182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW_INX),
     /*  156185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156197 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156201 */   GIR_RootConstrainSelectedInstOperands,
     /*  156202 */   // GIR_Coverage, 1334,
     /*  156202 */   GIR_EraseRootFromParent_Done,
     /*  156203 */ // Label 2913: @156203
     /*  156203 */ GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(156261), // Rule ID 65022 //
     /*  156208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  156211 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156218 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156233 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156240 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  156240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  156243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156259 */   GIR_RootConstrainSelectedInstOperands,
     /*  156260 */   // GIR_Coverage, 65022,
     /*  156260 */   GIR_EraseRootFromParent_Done,
     /*  156261 */ // Label 2914: @156261
     /*  156261 */ GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(156319), // Rule ID 65023 //
     /*  156266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  156269 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156276 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156287 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156291 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156298 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  156298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  156301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156303 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156308 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156313 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156317 */   GIR_RootConstrainSelectedInstOperands,
     /*  156318 */   // GIR_Coverage, 65023,
     /*  156318 */   GIR_EraseRootFromParent_Done,
     /*  156319 */ // Label 2915: @156319
     /*  156319 */ GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(156377), // Rule ID 65026 //
     /*  156324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  156327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156330 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156334 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  156341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156345 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156349 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156356 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  156356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  156359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156361 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156371 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156375 */   GIR_RootConstrainSelectedInstOperands,
     /*  156376 */   // GIR_Coverage, 65026,
     /*  156376 */   GIR_EraseRootFromParent_Done,
     /*  156377 */ // Label 2916: @156377
     /*  156377 */ GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(156435), // Rule ID 65027 //
     /*  156382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  156385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156388 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156392 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  156399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156407 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156414 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  156414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  156417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156429 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156433 */   GIR_RootConstrainSelectedInstOperands,
     /*  156434 */   // GIR_Coverage, 65027,
     /*  156434 */   GIR_EraseRootFromParent_Done,
     /*  156435 */ // Label 2917: @156435
     /*  156435 */ GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(156493), // Rule ID 65028 //
     /*  156440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  156443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156446 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156450 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  156457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156461 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156465 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156472 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  156472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  156475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156477 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156487 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156491 */   GIR_RootConstrainSelectedInstOperands,
     /*  156492 */   // GIR_Coverage, 65028,
     /*  156492 */   GIR_EraseRootFromParent_Done,
     /*  156493 */ // Label 2918: @156493
     /*  156493 */ GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(156551), // Rule ID 65029 //
     /*  156498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  156501 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  156504 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  156515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  156523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  156530 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  156530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  156533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  156535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  156540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  156545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  156549 */   GIR_RootConstrainSelectedInstOperands,
     /*  156550 */   // GIR_Coverage, 65029,
     /*  156550 */   GIR_EraseRootFromParent_Done,
     /*  156551 */ // Label 2919: @156551
     /*  156551 */ GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(156595), // Rule ID 1090 //
     /*  156556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  156559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156562 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156566 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  156573 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  156576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156580 */   // MIs[0] rs1
     /*  156580 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156588 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10591>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  156593 */   GIR_RootConstrainSelectedInstOperands,
     /*  156594 */   // GIR_Coverage, 1090,
     /*  156594 */   GIR_Done,
     /*  156595 */ // Label 2920: @156595
     /*  156595 */ GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(156639), // Rule ID 1094 //
     /*  156600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  156603 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  156617 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  156620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156624 */   // MIs[0] rs1
     /*  156624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156632 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10593>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  156637 */   GIR_RootConstrainSelectedInstOperands,
     /*  156638 */   // GIR_Coverage, 1094,
     /*  156638 */   GIR_Done,
     /*  156639 */ // Label 2921: @156639
     /*  156639 */ GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(156683), // Rule ID 1098 //
     /*  156644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  156647 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156650 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  156661 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  156664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156668 */   // MIs[0] rs1
     /*  156668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156676 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10595>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  156681 */   GIR_RootConstrainSelectedInstOperands,
     /*  156682 */   // GIR_Coverage, 1098,
     /*  156682 */   GIR_Done,
     /*  156683 */ // Label 2922: @156683
     /*  156683 */ GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(156727), // Rule ID 1102 //
     /*  156688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  156691 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156694 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156698 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  156705 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  156708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156712 */   // MIs[0] rs1
     /*  156712 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156720 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10597>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156720 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  156725 */   GIR_RootConstrainSelectedInstOperands,
     /*  156726 */   // GIR_Coverage, 1102,
     /*  156726 */   GIR_Done,
     /*  156727 */ // Label 2923: @156727
     /*  156727 */ GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(156771), // Rule ID 1118 //
     /*  156732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  156735 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156742 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  156752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156756 */   // MIs[0] rs1
     /*  156756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156764 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10611>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156764 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  156769 */   GIR_RootConstrainSelectedInstOperands,
     /*  156770 */   // GIR_Coverage, 1118,
     /*  156770 */   GIR_Done,
     /*  156771 */ // Label 2924: @156771
     /*  156771 */ GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(156815), // Rule ID 1120 //
     /*  156776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode1),
     /*  156779 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156782 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156786 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156793 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  156796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156800 */   // MIs[0] rs1
     /*  156800 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156808 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10613>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  156813 */   GIR_RootConstrainSelectedInstOperands,
     /*  156814 */   // GIR_Coverage, 1120,
     /*  156814 */   GIR_Done,
     /*  156815 */ // Label 2925: @156815
     /*  156815 */ GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(156859), // Rule ID 1122 //
     /*  156820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  156823 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156826 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156830 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156837 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  156840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156844 */   // MIs[0] rs1
     /*  156844 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156852 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  156857 */   GIR_RootConstrainSelectedInstOperands,
     /*  156858 */   // GIR_Coverage, 1122,
     /*  156858 */   GIR_Done,
     /*  156859 */ // Label 2926: @156859
     /*  156859 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(156903), // Rule ID 1126 //
     /*  156864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  156867 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156870 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156874 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  156881 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  156884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156888 */   // MIs[0] rs1
     /*  156888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156896 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  156901 */   GIR_RootConstrainSelectedInstOperands,
     /*  156902 */   // GIR_Coverage, 1126,
     /*  156902 */   GIR_Done,
     /*  156903 */ // Label 2927: @156903
     /*  156903 */ GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(156947), // Rule ID 1130 //
     /*  156908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  156911 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156914 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156918 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  156925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  156928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156932 */   // MIs[0] rs1
     /*  156932 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156940 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10619>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156940 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  156945 */   GIR_RootConstrainSelectedInstOperands,
     /*  156946 */   // GIR_Coverage, 1130,
     /*  156946 */   GIR_Done,
     /*  156947 */ // Label 2928: @156947
     /*  156947 */ GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(156991), // Rule ID 1132 //
     /*  156952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  156955 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  156958 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  156962 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  156969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  156972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156976 */   // MIs[0] rs1
     /*  156976 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  156980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  156984 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10621>>  =>  (LD_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  156984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  156989 */   GIR_RootConstrainSelectedInstOperands,
     /*  156990 */   // GIR_Coverage, 1132,
     /*  156990 */   GIR_Done,
     /*  156991 */ // Label 2929: @156991
     /*  156991 */ GIM_Reject,
     /*  156992 */ // Label 2841: @156992
     /*  156992 */ GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(157050), // Rule ID 226 //
     /*  156997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  157000 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157003 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  157014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157029 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  157032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157048 */   GIR_RootConstrainSelectedInstOperands,
     /*  157049 */   // GIR_Coverage, 226,
     /*  157049 */   GIR_EraseRootFromParent_Done,
     /*  157050 */ // Label 2930: @157050
     /*  157050 */ GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(157108), // Rule ID 230 //
     /*  157055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  157058 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157061 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  157072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157080 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157087 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  157090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157106 */   GIR_RootConstrainSelectedInstOperands,
     /*  157107 */   // GIR_Coverage, 230,
     /*  157107 */   GIR_EraseRootFromParent_Done,
     /*  157108 */ // Label 2931: @157108
     /*  157108 */ GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(157166), // Rule ID 276 //
     /*  157113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157119 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157123 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157134 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157145 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157160 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157164 */   GIR_RootConstrainSelectedInstOperands,
     /*  157165 */   // GIR_Coverage, 276,
     /*  157165 */   GIR_EraseRootFromParent_Done,
     /*  157166 */ // Label 2932: @157166
     /*  157166 */ GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(157217), // Rule ID 278 //
     /*  157171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  157174 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157177 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157185 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157189 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157196 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157201 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157211 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157215 */   GIR_RootConstrainSelectedInstOperands,
     /*  157216 */   // GIR_Coverage, 278,
     /*  157216 */   GIR_EraseRootFromParent_Done,
     /*  157217 */ // Label 2933: @157217
     /*  157217 */ GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(157278), // Rule ID 313 //
     /*  157222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  157225 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157228 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157232 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  157239 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157246 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157257 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10087>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  157260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157276 */   GIR_RootConstrainSelectedInstOperands,
     /*  157277 */   // GIR_Coverage, 313,
     /*  157277 */   GIR_EraseRootFromParent_Done,
     /*  157278 */ // Label 2934: @157278
     /*  157278 */ GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(157339), // Rule ID 317 //
     /*  157283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  157286 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157289 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157293 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  157300 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157318 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10089>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  157321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157333 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157337 */   GIR_RootConstrainSelectedInstOperands,
     /*  157338 */   // GIR_Coverage, 317,
     /*  157338 */   GIR_EraseRootFromParent_Done,
     /*  157339 */ // Label 2935: @157339
     /*  157339 */ GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(157400), // Rule ID 331 //
     /*  157344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV32_HwMode0),
     /*  157347 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157350 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157354 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157361 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157368 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157372 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157379 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10101>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157379 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157382 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157394 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157398 */   GIR_RootConstrainSelectedInstOperands,
     /*  157399 */   // GIR_Coverage, 331,
     /*  157399 */   GIR_EraseRootFromParent_Done,
     /*  157400 */ // Label 2936: @157400
     /*  157400 */ GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(157461), // Rule ID 333 //
     /*  157405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  157408 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157411 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157415 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157422 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157429 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157440 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10103>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  157443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157450 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157455 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157459 */   GIR_RootConstrainSelectedInstOperands,
     /*  157460 */   // GIR_Coverage, 333,
     /*  157460 */   GIR_EraseRootFromParent_Done,
     /*  157461 */ // Label 2937: @157461
     /*  157461 */ GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(157522), // Rule ID 339 //
     /*  157466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  157469 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  157483 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157501 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10107>>  =>  (LD:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157504 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157520 */   GIR_RootConstrainSelectedInstOperands,
     /*  157521 */   // GIR_Coverage, 339,
     /*  157521 */   GIR_EraseRootFromParent_Done,
     /*  157522 */ // Label 2938: @157522
     /*  157522 */ GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(157573), // Rule ID 1725 //
     /*  157527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  157530 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157533 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157545 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157552 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  157555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157571 */   GIR_RootConstrainSelectedInstOperands,
     /*  157572 */   // GIR_Coverage, 1725,
     /*  157572 */   GIR_EraseRootFromParent_Done,
     /*  157573 */ // Label 2939: @157573
     /*  157573 */ GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(157624), // Rule ID 1726 //
     /*  157578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  157581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  157592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157603 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (FLD:{ *:[f64] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  157603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLD),
     /*  157606 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157622 */   GIR_RootConstrainSelectedInstOperands,
     /*  157623 */   // GIR_Coverage, 1726,
     /*  157623 */   GIR_EraseRootFromParent_Done,
     /*  157624 */ // Label 2940: @157624
     /*  157624 */ GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(157675), // Rule ID 1730 //
     /*  157629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  157632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  157635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157643 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  157647 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  157654 */   // (ld:{ *:[f64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD:{ *:[f64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  157654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LD),
     /*  157657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  157659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  157664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  157669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  157673 */   GIR_RootConstrainSelectedInstOperands,
     /*  157674 */   // GIR_Coverage, 1730,
     /*  157674 */   GIR_EraseRootFromParent_Done,
     /*  157675 */ // Label 2941: @157675
     /*  157675 */ GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(157719), // Rule ID 1089 //
     /*  157680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  157683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  157697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157704 */   // MIs[0] rs1
     /*  157704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157712 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10591>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  157717 */   GIR_RootConstrainSelectedInstOperands,
     /*  157718 */   // GIR_Coverage, 1089,
     /*  157718 */   GIR_Done,
     /*  157719 */ // Label 2942: @157719
     /*  157719 */ GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(157763), // Rule ID 1093 //
     /*  157724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  157727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157730 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  157741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  157744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157748 */   // MIs[0] rs1
     /*  157748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157756 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_10593>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  157761 */   GIR_RootConstrainSelectedInstOperands,
     /*  157762 */   // GIR_Coverage, 1093,
     /*  157762 */   GIR_Done,
     /*  157763 */ // Label 2943: @157763
     /*  157763 */ GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(157807), // Rule ID 1097 //
     /*  157768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  157771 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157774 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  157785 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157792 */   // MIs[0] rs1
     /*  157792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157800 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10595>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  157805 */   GIR_RootConstrainSelectedInstOperands,
     /*  157806 */   // GIR_Coverage, 1097,
     /*  157806 */   GIR_Done,
     /*  157807 */ // Label 2944: @157807
     /*  157807 */ GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(157851), // Rule ID 1101 //
     /*  157812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  157815 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157818 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157822 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  157829 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  157832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157836 */   // MIs[0] rs1
     /*  157836 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157844 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_10597>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157844 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  157849 */   GIR_RootConstrainSelectedInstOperands,
     /*  157850 */   // GIR_Coverage, 1101,
     /*  157850 */   GIR_Done,
     /*  157851 */ // Label 2945: @157851
     /*  157851 */ GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(157895), // Rule ID 1117 //
     /*  157856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  157859 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157862 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157880 */   // MIs[0] rs1
     /*  157880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157888 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10611>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  157893 */   GIR_RootConstrainSelectedInstOperands,
     /*  157894 */   // GIR_Coverage, 1117,
     /*  157894 */   GIR_Done,
     /*  157895 */ // Label 2946: @157895
     /*  157895 */ GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(157939), // Rule ID 1119 //
     /*  157900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV32_HwMode0),
     /*  157903 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157906 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157910 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157917 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  157920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157924 */   // MIs[0] rs1
     /*  157924 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157932 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_10613>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  157937 */   GIR_RootConstrainSelectedInstOperands,
     /*  157938 */   // GIR_Coverage, 1119,
     /*  157938 */   GIR_Done,
     /*  157939 */ // Label 2947: @157939
     /*  157939 */ GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(157983), // Rule ID 1121 //
     /*  157944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  157947 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157950 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  157961 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  157964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157968 */   // MIs[0] rs1
     /*  157968 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  157972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  157976 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  157976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  157981 */   GIR_RootConstrainSelectedInstOperands,
     /*  157982 */   // GIR_Coverage, 1121,
     /*  157982 */   GIR_Done,
     /*  157983 */ // Label 2948: @157983
     /*  157983 */ GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(158027), // Rule ID 1125 //
     /*  157988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  157991 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  157994 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  157998 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  158005 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  158008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158012 */   // MIs[0] rs1
     /*  158012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158020 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  158020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  158025 */   GIR_RootConstrainSelectedInstOperands,
     /*  158026 */   // GIR_Coverage, 1125,
     /*  158026 */   GIR_Done,
     /*  158027 */ // Label 2949: @158027
     /*  158027 */ GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(158071), // Rule ID 1129 //
     /*  158032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  158035 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158042 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  158049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  158052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158056 */   // MIs[0] rs1
     /*  158056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158064 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10619>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  158064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  158069 */   GIR_RootConstrainSelectedInstOperands,
     /*  158070 */   // GIR_Coverage, 1129,
     /*  158070 */   GIR_Done,
     /*  158071 */ // Label 2950: @158071
     /*  158071 */ GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(158115), // Rule ID 1131 //
     /*  158076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  158079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  158082 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  158093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  158096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158100 */   // MIs[0] rs1
     /*  158100 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158108 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_10621>>  =>  (LD_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  158108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LD_AQ),
     /*  158113 */   GIR_RootConstrainSelectedInstOperands,
     /*  158114 */   // GIR_Coverage, 1131,
     /*  158114 */   GIR_Done,
     /*  158115 */ // Label 2951: @158115
     /*  158115 */ GIM_Reject,
     /*  158116 */ // Label 2842: @158116
     /*  158116 */ GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(158235),
     /*  158121 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158124 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  158136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158140 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(158187), // Rule ID 45620 //
     /*  158145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158148 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  158148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  158151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  158165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158181 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158185 */     GIR_RootConstrainSelectedInstOperands,
     /*  158186 */     // GIR_Coverage, 45620,
     /*  158186 */     GIR_EraseRootFromParent_Done,
     /*  158187 */   // Label 2953: @158187
     /*  158187 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(158234), // Rule ID 45621 //
     /*  158192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158195 */     // (ld:{ *:[nxv1i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B64:{ *:[nxv1i1] } (IMPLICIT_DEF:{ *:[nxv1i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  158195 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  158198 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158202 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B64),
     /*  158212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158217 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  158225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158232 */     GIR_RootConstrainSelectedInstOperands,
     /*  158233 */     // GIR_Coverage, 45621,
     /*  158233 */     GIR_EraseRootFromParent_Done,
     /*  158234 */   // Label 2954: @158234
     /*  158234 */   GIM_Reject,
     /*  158235 */ // Label 2952: @158235
     /*  158235 */ GIM_Reject,
     /*  158236 */ // Label 2843: @158236
     /*  158236 */ GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(158363),
     /*  158241 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158244 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158252 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(158307), // Rule ID 45616 //
     /*  158257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158260 */     // MIs[0] rs1
     /*  158260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158268 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  158268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  158271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  158285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158305 */     GIR_RootConstrainSelectedInstOperands,
     /*  158306 */     // GIR_Coverage, 45616,
     /*  158306 */     GIR_EraseRootFromParent_Done,
     /*  158307 */   // Label 2956: @158307
     /*  158307 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(158362), // Rule ID 45617 //
     /*  158312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158315 */     // MIs[0] rs1
     /*  158315 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158323 */     // (ld:{ *:[nxv1i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  158323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /*  158326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF8),
     /*  158340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158360 */     GIR_RootConstrainSelectedInstOperands,
     /*  158361 */     // GIR_Coverage, 45617,
     /*  158361 */     GIR_EraseRootFromParent_Done,
     /*  158362 */   // Label 2957: @158362
     /*  158362 */   GIM_Reject,
     /*  158363 */ // Label 2955: @158363
     /*  158363 */ GIM_Reject,
     /*  158364 */ // Label 2844: @158364
     /*  158364 */ GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(158601),
     /*  158369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158372 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158380 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(158435), // Rule ID 45812 //
     /*  158385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158388 */     // MIs[0] rs1
     /*  158388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158396 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  158396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  158399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  158413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158418 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  158426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158433 */     GIR_RootConstrainSelectedInstOperands,
     /*  158434 */     // GIR_Coverage, 45812,
     /*  158434 */     GIR_EraseRootFromParent_Done,
     /*  158435 */   // Label 2959: @158435
     /*  158435 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(158490), // Rule ID 45813 //
     /*  158440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158443 */     // MIs[0] rs1
     /*  158443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158451 */     // (ld:{ *:[nxv1i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  158451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  158454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  158468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158473 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  158481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158488 */     GIR_RootConstrainSelectedInstOperands,
     /*  158489 */     // GIR_Coverage, 45813,
     /*  158489 */     GIR_EraseRootFromParent_Done,
     /*  158490 */   // Label 2960: @158490
     /*  158490 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(158545), // Rule ID 45888 //
     /*  158495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  158498 */     // MIs[0] rs1
     /*  158498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158506 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  158506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  158509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  158523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  158536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158543 */     GIR_RootConstrainSelectedInstOperands,
     /*  158544 */     // GIR_Coverage, 45888,
     /*  158544 */     GIR_EraseRootFromParent_Done,
     /*  158545 */   // Label 2961: @158545
     /*  158545 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(158600), // Rule ID 45889 //
     /*  158550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  158553 */     // MIs[0] rs1
     /*  158553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158561 */     // (ld:{ *:[nxv1f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  158561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /*  158564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158573 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF4),
     /*  158578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  158591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158598 */     GIR_RootConstrainSelectedInstOperands,
     /*  158599 */     // GIR_Coverage, 45889,
     /*  158599 */     GIR_EraseRootFromParent_Done,
     /*  158600 */   // Label 2962: @158600
     /*  158600 */   GIM_Reject,
     /*  158601 */ // Label 2958: @158601
     /*  158601 */ GIM_Reject,
     /*  158602 */ // Label 2845: @158602
     /*  158602 */ GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(158839),
     /*  158607 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158610 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158618 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(158673), // Rule ID 45820 //
     /*  158623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  158626 */     // MIs[0] rs1
     /*  158626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158634 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  158634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  158637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  158651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158671 */     GIR_RootConstrainSelectedInstOperands,
     /*  158672 */     // GIR_Coverage, 45820,
     /*  158672 */     GIR_EraseRootFromParent_Done,
     /*  158673 */   // Label 2964: @158673
     /*  158673 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(158728), // Rule ID 45821 //
     /*  158678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  158681 */     // MIs[0] rs1
     /*  158681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158689 */     // (ld:{ *:[nxv1i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  158689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  158692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  158706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158726 */     GIR_RootConstrainSelectedInstOperands,
     /*  158727 */     // GIR_Coverage, 45821,
     /*  158727 */     GIR_EraseRootFromParent_Done,
     /*  158728 */   // Label 2965: @158728
     /*  158728 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(158783), // Rule ID 45896 //
     /*  158733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  158736 */     // MIs[0] rs1
     /*  158736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158744 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  158744 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  158747 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158751 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158756 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  158761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158781 */     GIR_RootConstrainSelectedInstOperands,
     /*  158782 */     // GIR_Coverage, 45896,
     /*  158782 */     GIR_EraseRootFromParent_Done,
     /*  158783 */   // Label 2966: @158783
     /*  158783 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(158838), // Rule ID 45897 //
     /*  158788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  158791 */     // MIs[0] rs1
     /*  158791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158799 */     // (ld:{ *:[nxv1f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  158799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /*  158802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_MF2),
     /*  158816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  158829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158836 */     GIR_RootConstrainSelectedInstOperands,
     /*  158837 */     // GIR_Coverage, 45897,
     /*  158837 */     GIR_EraseRootFromParent_Done,
     /*  158838 */   // Label 2967: @158838
     /*  158838 */   GIM_Reject,
     /*  158839 */ // Label 2963: @158839
     /*  158839 */ GIM_Reject,
     /*  158840 */ // Label 2846: @158840
     /*  158840 */ GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(159077),
     /*  158845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  158848 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  158852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  158856 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(158911), // Rule ID 45836 //
     /*  158861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  158864 */     // MIs[0] rs1
     /*  158864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158872 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  158872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  158875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  158889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158909 */     GIR_RootConstrainSelectedInstOperands,
     /*  158910 */     // GIR_Coverage, 45836,
     /*  158910 */     GIR_EraseRootFromParent_Done,
     /*  158911 */   // Label 2969: @158911
     /*  158911 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(158966), // Rule ID 45837 //
     /*  158916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  158919 */     // MIs[0] rs1
     /*  158919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  158923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158927 */     // (ld:{ *:[nxv1i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  158927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  158930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  158944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  158946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  158949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  158951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  158954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  158957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  158960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  158964 */     GIR_RootConstrainSelectedInstOperands,
     /*  158965 */     // GIR_Coverage, 45837,
     /*  158965 */     GIR_EraseRootFromParent_Done,
     /*  158966 */   // Label 2970: @158966
     /*  158966 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(159021), // Rule ID 45908 //
     /*  158971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  158974 */     // MIs[0] rs1
     /*  158974 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  158978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  158982 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  158982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  158985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  158989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  158994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  158996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  158999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159019 */     GIR_RootConstrainSelectedInstOperands,
     /*  159020 */     // GIR_Coverage, 45908,
     /*  159020 */     GIR_EraseRootFromParent_Done,
     /*  159021 */   // Label 2971: @159021
     /*  159021 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(159076), // Rule ID 45909 //
     /*  159026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  159029 */     // MIs[0] rs1
     /*  159029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159037 */     // (ld:{ *:[nxv1f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  159037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /*  159040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M1),
     /*  159054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159070 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159074 */     GIR_RootConstrainSelectedInstOperands,
     /*  159075 */     // GIR_Coverage, 45909,
     /*  159075 */     GIR_EraseRootFromParent_Done,
     /*  159076 */   // Label 2972: @159076
     /*  159076 */   GIM_Reject,
     /*  159077 */ // Label 2968: @159077
     /*  159077 */ GIM_Reject,
     /*  159078 */ // Label 2847: @159078
     /*  159078 */ GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(159197),
     /*  159083 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159086 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  159098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159102 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(159149), // Rule ID 45948 //
     /*  159107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159110 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  159110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  159113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  159127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  159140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159143 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159147 */     GIR_RootConstrainSelectedInstOperands,
     /*  159148 */     // GIR_Coverage, 45948,
     /*  159148 */     GIR_EraseRootFromParent_Done,
     /*  159149 */   // Label 2974: @159149
     /*  159149 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(159196), // Rule ID 45949 //
     /*  159154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159157 */     // (ld:{ *:[nxv2i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B32:{ *:[nxv2i1] } (IMPLICIT_DEF:{ *:[nxv2i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  159157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s1,
     /*  159160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B32),
     /*  159174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159179 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  159187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159194 */     GIR_RootConstrainSelectedInstOperands,
     /*  159195 */     // GIR_Coverage, 45949,
     /*  159195 */     GIR_EraseRootFromParent_Done,
     /*  159196 */   // Label 2975: @159196
     /*  159196 */   GIM_Reject,
     /*  159197 */ // Label 2973: @159197
     /*  159197 */ GIM_Reject,
     /*  159198 */ // Label 2848: @159198
     /*  159198 */ GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(159325),
     /*  159203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159206 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159214 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(159269), // Rule ID 45804 //
     /*  159219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159222 */     // MIs[0] rs1
     /*  159222 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159230 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  159230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  159233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  159247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159267 */     GIR_RootConstrainSelectedInstOperands,
     /*  159268 */     // GIR_Coverage, 45804,
     /*  159268 */     GIR_EraseRootFromParent_Done,
     /*  159269 */   // Label 2977: @159269
     /*  159269 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(159324), // Rule ID 45805 //
     /*  159274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159277 */     // MIs[0] rs1
     /*  159277 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159285 */     // (ld:{ *:[nxv2i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  159285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /*  159288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF4),
     /*  159302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159318 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159322 */     GIR_RootConstrainSelectedInstOperands,
     /*  159323 */     // GIR_Coverage, 45805,
     /*  159323 */     GIR_EraseRootFromParent_Done,
     /*  159324 */   // Label 2978: @159324
     /*  159324 */   GIM_Reject,
     /*  159325 */ // Label 2976: @159325
     /*  159325 */ GIM_Reject,
     /*  159326 */ // Label 2849: @159326
     /*  159326 */ GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(159563),
     /*  159331 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159334 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159342 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(159397), // Rule ID 45816 //
     /*  159347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159350 */     // MIs[0] rs1
     /*  159350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159358 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  159358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  159361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  159375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159391 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159395 */     GIR_RootConstrainSelectedInstOperands,
     /*  159396 */     // GIR_Coverage, 45816,
     /*  159396 */     GIR_EraseRootFromParent_Done,
     /*  159397 */   // Label 2980: @159397
     /*  159397 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(159452), // Rule ID 45817 //
     /*  159402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159405 */     // MIs[0] rs1
     /*  159405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159413 */     // (ld:{ *:[nxv2i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  159413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  159416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159425 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  159430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159450 */     GIR_RootConstrainSelectedInstOperands,
     /*  159451 */     // GIR_Coverage, 45817,
     /*  159451 */     GIR_EraseRootFromParent_Done,
     /*  159452 */   // Label 2981: @159452
     /*  159452 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(159507), // Rule ID 45892 //
     /*  159457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  159460 */     // MIs[0] rs1
     /*  159460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159468 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  159468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  159471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159505 */     GIR_RootConstrainSelectedInstOperands,
     /*  159506 */     // GIR_Coverage, 45892,
     /*  159506 */     GIR_EraseRootFromParent_Done,
     /*  159507 */   // Label 2982: @159507
     /*  159507 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(159562), // Rule ID 45893 //
     /*  159512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  159515 */     // MIs[0] rs1
     /*  159515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159523 */     // (ld:{ *:[nxv2f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  159523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /*  159526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_MF2),
     /*  159540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  159553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159560 */     GIR_RootConstrainSelectedInstOperands,
     /*  159561 */     // GIR_Coverage, 45893,
     /*  159561 */     GIR_EraseRootFromParent_Done,
     /*  159562 */   // Label 2983: @159562
     /*  159562 */   GIM_Reject,
     /*  159563 */ // Label 2979: @159563
     /*  159563 */ GIM_Reject,
     /*  159564 */ // Label 2850: @159564
     /*  159564 */ GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(159801),
     /*  159569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  159580 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(159635), // Rule ID 45832 //
     /*  159585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  159588 */     // MIs[0] rs1
     /*  159588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159596 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  159596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  159599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  159613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159633 */     GIR_RootConstrainSelectedInstOperands,
     /*  159634 */     // GIR_Coverage, 45832,
     /*  159634 */     GIR_EraseRootFromParent_Done,
     /*  159635 */   // Label 2985: @159635
     /*  159635 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(159690), // Rule ID 45833 //
     /*  159640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  159643 */     // MIs[0] rs1
     /*  159643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159651 */     // (ld:{ *:[nxv2i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  159651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  159654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  159668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159688 */     GIR_RootConstrainSelectedInstOperands,
     /*  159689 */     // GIR_Coverage, 45833,
     /*  159689 */     GIR_EraseRootFromParent_Done,
     /*  159690 */   // Label 2986: @159690
     /*  159690 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(159745), // Rule ID 45904 //
     /*  159695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  159698 */     // MIs[0] rs1
     /*  159698 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159706 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  159706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  159709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  159723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159739 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159743 */     GIR_RootConstrainSelectedInstOperands,
     /*  159744 */     // GIR_Coverage, 45904,
     /*  159744 */     GIR_EraseRootFromParent_Done,
     /*  159745 */   // Label 2987: @159745
     /*  159745 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(159800), // Rule ID 45905 //
     /*  159750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  159753 */     // MIs[0] rs1
     /*  159753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159761 */     // (ld:{ *:[nxv2f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  159761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /*  159764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M1),
     /*  159778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  159791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159798 */     GIR_RootConstrainSelectedInstOperands,
     /*  159799 */     // GIR_Coverage, 45905,
     /*  159799 */     GIR_EraseRootFromParent_Done,
     /*  159800 */   // Label 2988: @159800
     /*  159800 */   GIM_Reject,
     /*  159801 */ // Label 2984: @159801
     /*  159801 */ GIM_Reject,
     /*  159802 */ // Label 2851: @159802
     /*  159802 */ GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(160039),
     /*  159807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  159810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  159814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  159818 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(159873), // Rule ID 45876 //
     /*  159823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  159826 */     // MIs[0] rs1
     /*  159826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159834 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  159834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  159837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  159851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159871 */     GIR_RootConstrainSelectedInstOperands,
     /*  159872 */     // GIR_Coverage, 45876,
     /*  159872 */     GIR_EraseRootFromParent_Done,
     /*  159873 */   // Label 2990: @159873
     /*  159873 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(159928), // Rule ID 45877 //
     /*  159878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  159881 */     // MIs[0] rs1
     /*  159881 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159889 */     // (ld:{ *:[nxv2i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  159889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  159892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  159906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159926 */     GIR_RootConstrainSelectedInstOperands,
     /*  159927 */     // GIR_Coverage, 45877,
     /*  159927 */     GIR_EraseRootFromParent_Done,
     /*  159928 */   // Label 2991: @159928
     /*  159928 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(159983), // Rule ID 45936 //
     /*  159933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  159936 */     // MIs[0] rs1
     /*  159936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  159940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159944 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  159944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  159947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  159951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  159956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  159958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  159961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  159963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  159966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  159968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  159971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  159974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  159977 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  159981 */     GIR_RootConstrainSelectedInstOperands,
     /*  159982 */     // GIR_Coverage, 45936,
     /*  159982 */     GIR_EraseRootFromParent_Done,
     /*  159983 */   // Label 2992: @159983
     /*  159983 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(160038), // Rule ID 45937 //
     /*  159988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  159991 */     // MIs[0] rs1
     /*  159991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  159995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  159999 */     // (ld:{ *:[nxv2f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  159999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /*  160002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M2),
     /*  160016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160036 */     GIR_RootConstrainSelectedInstOperands,
     /*  160037 */     // GIR_Coverage, 45937,
     /*  160037 */     GIR_EraseRootFromParent_Done,
     /*  160038 */   // Label 2993: @160038
     /*  160038 */   GIM_Reject,
     /*  160039 */ // Label 2989: @160039
     /*  160039 */ GIM_Reject,
     /*  160040 */ // Label 2852: @160040
     /*  160040 */ GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(160159),
     /*  160045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160048 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160056 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  160060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160064 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(160111), // Rule ID 45952 //
     /*  160069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160072 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  160072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  160075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  160089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  160102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160109 */     GIR_RootConstrainSelectedInstOperands,
     /*  160110 */     // GIR_Coverage, 45952,
     /*  160110 */     GIR_EraseRootFromParent_Done,
     /*  160111 */   // Label 2995: @160111
     /*  160111 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(160158), // Rule ID 45953 //
     /*  160116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160119 */     // (ld:{ *:[nxv4i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B16:{ *:[nxv4i1] } (IMPLICIT_DEF:{ *:[nxv4i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  160119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s1,
     /*  160122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B16),
     /*  160136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  160149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160156 */     GIR_RootConstrainSelectedInstOperands,
     /*  160157 */     // GIR_Coverage, 45953,
     /*  160157 */     GIR_EraseRootFromParent_Done,
     /*  160158 */   // Label 2996: @160158
     /*  160158 */   GIM_Reject,
     /*  160159 */ // Label 2994: @160159
     /*  160159 */ GIM_Reject,
     /*  160160 */ // Label 2853: @160160
     /*  160160 */ GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(160287),
     /*  160165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160176 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(160231), // Rule ID 45808 //
     /*  160181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160184 */     // MIs[0] rs1
     /*  160184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160192 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  160192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  160195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  160209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160229 */     GIR_RootConstrainSelectedInstOperands,
     /*  160230 */     // GIR_Coverage, 45808,
     /*  160230 */     GIR_EraseRootFromParent_Done,
     /*  160231 */   // Label 2998: @160231
     /*  160231 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(160286), // Rule ID 45809 //
     /*  160236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160239 */     // MIs[0] rs1
     /*  160239 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160247 */     // (ld:{ *:[nxv4i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  160247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /*  160250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_MF2),
     /*  160264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160284 */     GIR_RootConstrainSelectedInstOperands,
     /*  160285 */     // GIR_Coverage, 45809,
     /*  160285 */     GIR_EraseRootFromParent_Done,
     /*  160286 */   // Label 2999: @160286
     /*  160286 */   GIM_Reject,
     /*  160287 */ // Label 2997: @160287
     /*  160287 */ GIM_Reject,
     /*  160288 */ // Label 2854: @160288
     /*  160288 */ GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(160525),
     /*  160293 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160296 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  160304 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(160359), // Rule ID 45828 //
     /*  160309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160312 */     // MIs[0] rs1
     /*  160312 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160320 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  160320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  160323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  160337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160342 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160353 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160357 */     GIR_RootConstrainSelectedInstOperands,
     /*  160358 */     // GIR_Coverage, 45828,
     /*  160358 */     GIR_EraseRootFromParent_Done,
     /*  160359 */   // Label 3001: @160359
     /*  160359 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(160414), // Rule ID 45829 //
     /*  160364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160367 */     // MIs[0] rs1
     /*  160367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160375 */     // (ld:{ *:[nxv4i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  160375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  160378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  160392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160412 */     GIR_RootConstrainSelectedInstOperands,
     /*  160413 */     // GIR_Coverage, 45829,
     /*  160413 */     GIR_EraseRootFromParent_Done,
     /*  160414 */   // Label 3002: @160414
     /*  160414 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(160469), // Rule ID 45900 //
     /*  160419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  160422 */     // MIs[0] rs1
     /*  160422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160430 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  160430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  160433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  160447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160467 */     GIR_RootConstrainSelectedInstOperands,
     /*  160468 */     // GIR_Coverage, 45900,
     /*  160468 */     GIR_EraseRootFromParent_Done,
     /*  160469 */   // Label 3003: @160469
     /*  160469 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(160524), // Rule ID 45901 //
     /*  160474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  160477 */     // MIs[0] rs1
     /*  160477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160485 */     // (ld:{ *:[nxv4f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  160485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /*  160488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M1),
     /*  160502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160507 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  160515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160522 */     GIR_RootConstrainSelectedInstOperands,
     /*  160523 */     // GIR_Coverage, 45901,
     /*  160523 */     GIR_EraseRootFromParent_Done,
     /*  160524 */   // Label 3004: @160524
     /*  160524 */   GIM_Reject,
     /*  160525 */ // Label 3000: @160525
     /*  160525 */ GIM_Reject,
     /*  160526 */ // Label 2855: @160526
     /*  160526 */ GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(160763),
     /*  160531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160534 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  160542 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(160597), // Rule ID 45864 //
     /*  160547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  160550 */     // MIs[0] rs1
     /*  160550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160558 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  160558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  160561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  160575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160595 */     GIR_RootConstrainSelectedInstOperands,
     /*  160596 */     // GIR_Coverage, 45864,
     /*  160596 */     GIR_EraseRootFromParent_Done,
     /*  160597 */   // Label 3006: @160597
     /*  160597 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(160652), // Rule ID 45865 //
     /*  160602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  160605 */     // MIs[0] rs1
     /*  160605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160613 */     // (ld:{ *:[nxv4i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  160613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  160616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  160630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160646 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160650 */     GIR_RootConstrainSelectedInstOperands,
     /*  160651 */     // GIR_Coverage, 45865,
     /*  160651 */     GIR_EraseRootFromParent_Done,
     /*  160652 */   // Label 3007: @160652
     /*  160652 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(160707), // Rule ID 45924 //
     /*  160657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  160660 */     // MIs[0] rs1
     /*  160660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160668 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  160668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  160671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  160685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160705 */     GIR_RootConstrainSelectedInstOperands,
     /*  160706 */     // GIR_Coverage, 45924,
     /*  160706 */     GIR_EraseRootFromParent_Done,
     /*  160707 */   // Label 3008: @160707
     /*  160707 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(160762), // Rule ID 45925 //
     /*  160712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  160715 */     // MIs[0] rs1
     /*  160715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160723 */     // (ld:{ *:[nxv4f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  160723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /*  160726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M2),
     /*  160740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160745 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  160753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160760 */     GIR_RootConstrainSelectedInstOperands,
     /*  160761 */     // GIR_Coverage, 45925,
     /*  160761 */     GIR_EraseRootFromParent_Done,
     /*  160762 */   // Label 3009: @160762
     /*  160762 */   GIM_Reject,
     /*  160763 */ // Label 3005: @160763
     /*  160763 */ GIM_Reject,
     /*  160764 */ // Label 2856: @160764
     /*  160764 */ GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(161001),
     /*  160769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  160772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  160776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  160780 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(160835), // Rule ID 45880 //
     /*  160785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  160788 */     // MIs[0] rs1
     /*  160788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160796 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  160796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  160799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  160813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160833 */     GIR_RootConstrainSelectedInstOperands,
     /*  160834 */     // GIR_Coverage, 45880,
     /*  160834 */     GIR_EraseRootFromParent_Done,
     /*  160835 */   // Label 3011: @160835
     /*  160835 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(160890), // Rule ID 45881 //
     /*  160840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  160843 */     // MIs[0] rs1
     /*  160843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160851 */     // (ld:{ *:[nxv4i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  160851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  160854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160863 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  160868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160888 */     GIR_RootConstrainSelectedInstOperands,
     /*  160889 */     // GIR_Coverage, 45881,
     /*  160889 */     GIR_EraseRootFromParent_Done,
     /*  160890 */   // Label 3012: @160890
     /*  160890 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(160945), // Rule ID 45940 //
     /*  160895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  160898 */     // MIs[0] rs1
     /*  160898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  160902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160906 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  160906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  160909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  160923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160939 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160943 */     GIR_RootConstrainSelectedInstOperands,
     /*  160944 */     // GIR_Coverage, 45940,
     /*  160944 */     GIR_EraseRootFromParent_Done,
     /*  160945 */   // Label 3013: @160945
     /*  160945 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(161000), // Rule ID 45941 //
     /*  160950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  160953 */     // MIs[0] rs1
     /*  160953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  160957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  160961 */     // (ld:{ *:[nxv4f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  160961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /*  160964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  160968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  160973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  160975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M4),
     /*  160978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  160980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  160983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  160985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  160988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  160991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  160994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  160998 */     GIR_RootConstrainSelectedInstOperands,
     /*  160999 */     // GIR_Coverage, 45941,
     /*  160999 */     GIR_EraseRootFromParent_Done,
     /*  161000 */   // Label 3014: @161000
     /*  161000 */   GIM_Reject,
     /*  161001 */ // Label 3010: @161001
     /*  161001 */ GIM_Reject,
     /*  161002 */ // Label 2857: @161002
     /*  161002 */ GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(161121),
     /*  161007 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161010 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161018 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161026 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(161073), // Rule ID 45956 //
     /*  161031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161034 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  161034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  161037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  161051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161067 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161071 */     GIR_RootConstrainSelectedInstOperands,
     /*  161072 */     // GIR_Coverage, 45956,
     /*  161072 */     GIR_EraseRootFromParent_Done,
     /*  161073 */   // Label 3016: @161073
     /*  161073 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(161120), // Rule ID 45957 //
     /*  161078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161081 */     // (ld:{ *:[nxv8i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B8:{ *:[nxv8i1] } (IMPLICIT_DEF:{ *:[nxv8i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  161081 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s1,
     /*  161084 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161088 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161093 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B8),
     /*  161098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  161111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161114 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161118 */     GIR_RootConstrainSelectedInstOperands,
     /*  161119 */     // GIR_Coverage, 45957,
     /*  161119 */     GIR_EraseRootFromParent_Done,
     /*  161120 */   // Label 3017: @161120
     /*  161120 */   GIM_Reject,
     /*  161121 */ // Label 3015: @161121
     /*  161121 */ GIM_Reject,
     /*  161122 */ // Label 2858: @161122
     /*  161122 */ GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(161249),
     /*  161127 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161130 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161138 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(161193), // Rule ID 45824 //
     /*  161143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161146 */     // MIs[0] rs1
     /*  161146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161154 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  161154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  161157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  161171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161191 */     GIR_RootConstrainSelectedInstOperands,
     /*  161192 */     // GIR_Coverage, 45824,
     /*  161192 */     GIR_EraseRootFromParent_Done,
     /*  161193 */   // Label 3019: @161193
     /*  161193 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(161248), // Rule ID 45825 //
     /*  161198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161201 */     // MIs[0] rs1
     /*  161201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161209 */     // (ld:{ *:[nxv8i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  161209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /*  161212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M1),
     /*  161226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161246 */     GIR_RootConstrainSelectedInstOperands,
     /*  161247 */     // GIR_Coverage, 45825,
     /*  161247 */     GIR_EraseRootFromParent_Done,
     /*  161248 */   // Label 3020: @161248
     /*  161248 */   GIM_Reject,
     /*  161249 */ // Label 3018: @161249
     /*  161249 */ GIM_Reject,
     /*  161250 */ // Label 2859: @161250
     /*  161250 */ GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(161487),
     /*  161255 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161258 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  161266 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(161321), // Rule ID 45852 //
     /*  161271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161274 */     // MIs[0] rs1
     /*  161274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161282 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  161285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  161299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161304 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161319 */     GIR_RootConstrainSelectedInstOperands,
     /*  161320 */     // GIR_Coverage, 45852,
     /*  161320 */     GIR_EraseRootFromParent_Done,
     /*  161321 */   // Label 3022: @161321
     /*  161321 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(161376), // Rule ID 45853 //
     /*  161326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161329 */     // MIs[0] rs1
     /*  161329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161337 */     // (ld:{ *:[nxv8i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  161340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  161354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161374 */     GIR_RootConstrainSelectedInstOperands,
     /*  161375 */     // GIR_Coverage, 45853,
     /*  161375 */     GIR_EraseRootFromParent_Done,
     /*  161376 */   // Label 3023: @161376
     /*  161376 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(161431), // Rule ID 45912 //
     /*  161381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  161384 */     // MIs[0] rs1
     /*  161384 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161392 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  161392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  161395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  161409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161429 */     GIR_RootConstrainSelectedInstOperands,
     /*  161430 */     // GIR_Coverage, 45912,
     /*  161430 */     GIR_EraseRootFromParent_Done,
     /*  161431 */   // Label 3024: @161431
     /*  161431 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(161486), // Rule ID 45913 //
     /*  161436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  161439 */     // MIs[0] rs1
     /*  161439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161447 */     // (ld:{ *:[nxv8f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  161447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /*  161450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M2),
     /*  161464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  161477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161480 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161484 */     GIR_RootConstrainSelectedInstOperands,
     /*  161485 */     // GIR_Coverage, 45913,
     /*  161485 */     GIR_EraseRootFromParent_Done,
     /*  161486 */   // Label 3025: @161486
     /*  161486 */   GIM_Reject,
     /*  161487 */ // Label 3021: @161487
     /*  161487 */ GIM_Reject,
     /*  161488 */ // Label 2860: @161488
     /*  161488 */ GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(161725),
     /*  161493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  161504 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(161559), // Rule ID 45868 //
     /*  161509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161512 */     // MIs[0] rs1
     /*  161512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161520 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  161520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  161523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  161537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161557 */     GIR_RootConstrainSelectedInstOperands,
     /*  161558 */     // GIR_Coverage, 45868,
     /*  161558 */     GIR_EraseRootFromParent_Done,
     /*  161559 */   // Label 3027: @161559
     /*  161559 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(161614), // Rule ID 45869 //
     /*  161564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  161567 */     // MIs[0] rs1
     /*  161567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161575 */     // (ld:{ *:[nxv8i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  161575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  161578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  161592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161612 */     GIR_RootConstrainSelectedInstOperands,
     /*  161613 */     // GIR_Coverage, 45869,
     /*  161613 */     GIR_EraseRootFromParent_Done,
     /*  161614 */   // Label 3028: @161614
     /*  161614 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(161669), // Rule ID 45928 //
     /*  161619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  161622 */     // MIs[0] rs1
     /*  161622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161630 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  161630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  161633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  161647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161667 */     GIR_RootConstrainSelectedInstOperands,
     /*  161668 */     // GIR_Coverage, 45928,
     /*  161668 */     GIR_EraseRootFromParent_Done,
     /*  161669 */   // Label 3029: @161669
     /*  161669 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(161724), // Rule ID 45929 //
     /*  161674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  161677 */     // MIs[0] rs1
     /*  161677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161685 */     // (ld:{ *:[nxv8f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  161685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /*  161688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M4),
     /*  161702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  161715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161722 */     GIR_RootConstrainSelectedInstOperands,
     /*  161723 */     // GIR_Coverage, 45929,
     /*  161723 */     GIR_EraseRootFromParent_Done,
     /*  161724 */   // Label 3030: @161724
     /*  161724 */   GIM_Reject,
     /*  161725 */ // Label 3026: @161725
     /*  161725 */ GIM_Reject,
     /*  161726 */ // Label 2861: @161726
     /*  161726 */ GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(161963),
     /*  161731 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161734 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  161742 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(161797), // Rule ID 45884 //
     /*  161747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  161750 */     // MIs[0] rs1
     /*  161750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161758 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  161758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  161761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  161775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161791 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161795 */     GIR_RootConstrainSelectedInstOperands,
     /*  161796 */     // GIR_Coverage, 45884,
     /*  161796 */     GIR_EraseRootFromParent_Done,
     /*  161797 */   // Label 3032: @161797
     /*  161797 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(161852), // Rule ID 45885 //
     /*  161802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  161805 */     // MIs[0] rs1
     /*  161805 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161813 */     // (ld:{ *:[nxv8i64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  161813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  161816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  161830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161850 */     GIR_RootConstrainSelectedInstOperands,
     /*  161851 */     // GIR_Coverage, 45885,
     /*  161851 */     GIR_EraseRootFromParent_Done,
     /*  161852 */   // Label 3033: @161852
     /*  161852 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(161907), // Rule ID 45944 //
     /*  161857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  161860 */     // MIs[0] rs1
     /*  161860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  161864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161868 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /*  161868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  161871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  161885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161901 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161905 */     GIR_RootConstrainSelectedInstOperands,
     /*  161906 */     // GIR_Coverage, 45944,
     /*  161906 */     GIR_EraseRootFromParent_Done,
     /*  161907 */   // Label 3034: @161907
     /*  161907 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(161962), // Rule ID 45945 //
     /*  161912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  161915 */     // MIs[0] rs1
     /*  161915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  161919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161923 */     // (ld:{ *:[nxv8f64] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE64_V_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /*  161923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /*  161926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  161930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  161935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  161937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE64_V_M8),
     /*  161940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  161942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  161945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  161947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  161950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  161953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  161956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  161960 */     GIR_RootConstrainSelectedInstOperands,
     /*  161961 */     // GIR_Coverage, 45945,
     /*  161961 */     GIR_EraseRootFromParent_Done,
     /*  161962 */   // Label 3035: @161962
     /*  161962 */   GIM_Reject,
     /*  161963 */ // Label 3031: @161963
     /*  161963 */ GIM_Reject,
     /*  161964 */ // Label 2862: @161964
     /*  161964 */ GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(162083),
     /*  161969 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  161972 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  161976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  161980 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  161984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  161988 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(162035), // Rule ID 45960 //
     /*  161993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  161996 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  161996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  161999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  162013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162033 */     GIR_RootConstrainSelectedInstOperands,
     /*  162034 */     // GIR_Coverage, 45960,
     /*  162034 */     GIR_EraseRootFromParent_Done,
     /*  162035 */   // Label 3037: @162035
     /*  162035 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(162082), // Rule ID 45961 //
     /*  162040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162043 */     // (ld:{ *:[nxv16i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B4:{ *:[nxv16i1] } (IMPLICIT_DEF:{ *:[nxv16i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s1,
     /*  162046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B4),
     /*  162060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162080 */     GIR_RootConstrainSelectedInstOperands,
     /*  162081 */     // GIR_Coverage, 45961,
     /*  162081 */     GIR_EraseRootFromParent_Done,
     /*  162082 */   // Label 3038: @162082
     /*  162082 */   GIM_Reject,
     /*  162083 */ // Label 3036: @162083
     /*  162083 */ GIM_Reject,
     /*  162084 */ // Label 2863: @162084
     /*  162084 */ GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(162211),
     /*  162089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162092 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  162100 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(162155), // Rule ID 45840 //
     /*  162105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162108 */     // MIs[0] rs1
     /*  162108 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162116 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  162119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  162133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162153 */     GIR_RootConstrainSelectedInstOperands,
     /*  162154 */     // GIR_Coverage, 45840,
     /*  162154 */     GIR_EraseRootFromParent_Done,
     /*  162155 */   // Label 3040: @162155
     /*  162155 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(162210), // Rule ID 45841 //
     /*  162160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162163 */     // MIs[0] rs1
     /*  162163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162171 */     // (ld:{ *:[nxv16i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /*  162174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M2),
     /*  162188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162208 */     GIR_RootConstrainSelectedInstOperands,
     /*  162209 */     // GIR_Coverage, 45841,
     /*  162209 */     GIR_EraseRootFromParent_Done,
     /*  162210 */   // Label 3041: @162210
     /*  162210 */   GIM_Reject,
     /*  162211 */ // Label 3039: @162211
     /*  162211 */ GIM_Reject,
     /*  162212 */ // Label 2864: @162212
     /*  162212 */ GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(162449),
     /*  162217 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162220 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  162228 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(162283), // Rule ID 45856 //
     /*  162233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162236 */     // MIs[0] rs1
     /*  162236 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162244 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  162247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  162261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162281 */     GIR_RootConstrainSelectedInstOperands,
     /*  162282 */     // GIR_Coverage, 45856,
     /*  162282 */     GIR_EraseRootFromParent_Done,
     /*  162283 */   // Label 3043: @162283
     /*  162283 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(162338), // Rule ID 45857 //
     /*  162288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162291 */     // MIs[0] rs1
     /*  162291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162299 */     // (ld:{ *:[nxv16i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  162302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  162316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162318 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162336 */     GIR_RootConstrainSelectedInstOperands,
     /*  162337 */     // GIR_Coverage, 45857,
     /*  162337 */     GIR_EraseRootFromParent_Done,
     /*  162338 */   // Label 3044: @162338
     /*  162338 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(162393), // Rule ID 45916 //
     /*  162343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  162346 */     // MIs[0] rs1
     /*  162346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162354 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  162357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  162371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162391 */     GIR_RootConstrainSelectedInstOperands,
     /*  162392 */     // GIR_Coverage, 45916,
     /*  162392 */     GIR_EraseRootFromParent_Done,
     /*  162393 */   // Label 3045: @162393
     /*  162393 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(162448), // Rule ID 45917 //
     /*  162398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  162401 */     // MIs[0] rs1
     /*  162401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162409 */     // (ld:{ *:[nxv16f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  162409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /*  162412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M4),
     /*  162426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162442 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162446 */     GIR_RootConstrainSelectedInstOperands,
     /*  162447 */     // GIR_Coverage, 45917,
     /*  162447 */     GIR_EraseRootFromParent_Done,
     /*  162448 */   // Label 3046: @162448
     /*  162448 */   GIM_Reject,
     /*  162449 */ // Label 3042: @162449
     /*  162449 */ GIM_Reject,
     /*  162450 */ // Label 2865: @162450
     /*  162450 */ GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(162687),
     /*  162455 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162458 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  162466 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(162521), // Rule ID 45872 //
     /*  162471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162474 */     // MIs[0] rs1
     /*  162474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162482 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  162485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  162499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162519 */     GIR_RootConstrainSelectedInstOperands,
     /*  162520 */     // GIR_Coverage, 45872,
     /*  162520 */     GIR_EraseRootFromParent_Done,
     /*  162521 */   // Label 3048: @162521
     /*  162521 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(162576), // Rule ID 45873 //
     /*  162526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162529 */     // MIs[0] rs1
     /*  162529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162537 */     // (ld:{ *:[nxv16i32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  162540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  162554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162559 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162570 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162574 */     GIR_RootConstrainSelectedInstOperands,
     /*  162575 */     // GIR_Coverage, 45873,
     /*  162575 */     GIR_EraseRootFromParent_Done,
     /*  162576 */   // Label 3049: @162576
     /*  162576 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(162631), // Rule ID 45932 //
     /*  162581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  162584 */     // MIs[0] rs1
     /*  162584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162592 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /*  162592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  162595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  162609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162629 */     GIR_RootConstrainSelectedInstOperands,
     /*  162630 */     // GIR_Coverage, 45932,
     /*  162630 */     GIR_EraseRootFromParent_Done,
     /*  162631 */   // Label 3050: @162631
     /*  162631 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(162686), // Rule ID 45933 //
     /*  162636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  162639 */     // MIs[0] rs1
     /*  162639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162647 */     // (ld:{ *:[nxv16f32] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE32_V_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /*  162647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /*  162650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE32_V_M8),
     /*  162664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  162677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162684 */     GIR_RootConstrainSelectedInstOperands,
     /*  162685 */     // GIR_Coverage, 45933,
     /*  162685 */     GIR_EraseRootFromParent_Done,
     /*  162686 */   // Label 3051: @162686
     /*  162686 */   GIM_Reject,
     /*  162687 */ // Label 3047: @162687
     /*  162687 */ GIM_Reject,
     /*  162688 */ // Label 2866: @162688
     /*  162688 */ GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(162807),
     /*  162693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  162704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  162708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162712 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(162759), // Rule ID 45964 //
     /*  162717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162720 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  162720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  162723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  162737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162753 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162757 */     GIR_RootConstrainSelectedInstOperands,
     /*  162758 */     // GIR_Coverage, 45964,
     /*  162758 */     GIR_EraseRootFromParent_Done,
     /*  162759 */   // Label 3053: @162759
     /*  162759 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(162806), // Rule ID 45965 //
     /*  162764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162767 */     // (ld:{ *:[nxv32i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B2:{ *:[nxv32i1] } (IMPLICIT_DEF:{ *:[nxv32i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  162767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s1,
     /*  162770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B2),
     /*  162784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  162797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162804 */     GIR_RootConstrainSelectedInstOperands,
     /*  162805 */     // GIR_Coverage, 45965,
     /*  162805 */     GIR_EraseRootFromParent_Done,
     /*  162806 */   // Label 3054: @162806
     /*  162806 */   GIM_Reject,
     /*  162807 */ // Label 3052: @162807
     /*  162807 */ GIM_Reject,
     /*  162808 */ // Label 2867: @162808
     /*  162808 */ GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(162935),
     /*  162813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162816 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  162824 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(162879), // Rule ID 45844 //
     /*  162829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162832 */     // MIs[0] rs1
     /*  162832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162840 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  162840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  162843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  162857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162862 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162873 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162877 */     GIR_RootConstrainSelectedInstOperands,
     /*  162878 */     // GIR_Coverage, 45844,
     /*  162878 */     GIR_EraseRootFromParent_Done,
     /*  162879 */   // Label 3056: @162879
     /*  162879 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(162934), // Rule ID 45845 //
     /*  162884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  162887 */     // MIs[0] rs1
     /*  162887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  162891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162895 */     // (ld:{ *:[nxv32i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  162895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /*  162898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M4),
     /*  162912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  162928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  162932 */     GIR_RootConstrainSelectedInstOperands,
     /*  162933 */     // GIR_Coverage, 45845,
     /*  162933 */     GIR_EraseRootFromParent_Done,
     /*  162934 */   // Label 3057: @162934
     /*  162934 */   GIM_Reject,
     /*  162935 */ // Label 3055: @162935
     /*  162935 */ GIM_Reject,
     /*  162936 */ // Label 2868: @162936
     /*  162936 */ GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(163173),
     /*  162941 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  162944 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  162948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  162952 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(163007), // Rule ID 45860 //
     /*  162957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  162960 */     // MIs[0] rs1
     /*  162960 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  162964 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  162968 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  162968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  162971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  162975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  162980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  162982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  162985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  162987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  162990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  162992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  162995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  162998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163001 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163005 */     GIR_RootConstrainSelectedInstOperands,
     /*  163006 */     // GIR_Coverage, 45860,
     /*  163006 */     GIR_EraseRootFromParent_Done,
     /*  163007 */   // Label 3059: @163007
     /*  163007 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(163062), // Rule ID 45861 //
     /*  163012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163015 */     // MIs[0] rs1
     /*  163015 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163023 */     // (ld:{ *:[nxv32i16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  163026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  163040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163045 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163056 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163060 */     GIR_RootConstrainSelectedInstOperands,
     /*  163061 */     // GIR_Coverage, 45861,
     /*  163061 */     GIR_EraseRootFromParent_Done,
     /*  163062 */   // Label 3060: @163062
     /*  163062 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(163117), // Rule ID 45920 //
     /*  163067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  163070 */     // MIs[0] rs1
     /*  163070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163078 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /*  163078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  163081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  163095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163115 */     GIR_RootConstrainSelectedInstOperands,
     /*  163116 */     // GIR_Coverage, 45920,
     /*  163116 */     GIR_EraseRootFromParent_Done,
     /*  163117 */   // Label 3061: @163117
     /*  163117 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(163172), // Rule ID 45921 //
     /*  163122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  163125 */     // MIs[0] rs1
     /*  163125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163133 */     // (ld:{ *:[nxv32f16] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE16_V_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /*  163133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /*  163136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE16_V_M8),
     /*  163150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  163163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163170 */     GIR_RootConstrainSelectedInstOperands,
     /*  163171 */     // GIR_Coverage, 45921,
     /*  163171 */     GIR_EraseRootFromParent_Done,
     /*  163172 */   // Label 3062: @163172
     /*  163172 */   GIM_Reject,
     /*  163173 */ // Label 3058: @163173
     /*  163173 */ GIM_Reject,
     /*  163174 */ // Label 2869: @163174
     /*  163174 */ GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(163293),
     /*  163179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  163190 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  163194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163198 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(163245), // Rule ID 45968 //
     /*  163203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163206 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] }, 3:{ *:[i64] })
     /*  163206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  163209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  163223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163243 */     GIR_RootConstrainSelectedInstOperands,
     /*  163244 */     // GIR_Coverage, 45968,
     /*  163244 */     GIR_EraseRootFromParent_Done,
     /*  163245 */   // Label 3064: @163245
     /*  163245 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(163292), // Rule ID 45969 //
     /*  163250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163253 */     // (ld:{ *:[nxv64i1] } GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLM_V_B1:{ *:[nxv64i1] } (IMPLICIT_DEF:{ *:[nxv64i1] }), GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] }, 3:{ *:[i32] })
     /*  163253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s1,
     /*  163256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLM_V_B1),
     /*  163270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  163283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163290 */     GIR_RootConstrainSelectedInstOperands,
     /*  163291 */     // GIR_Coverage, 45969,
     /*  163291 */     GIR_EraseRootFromParent_Done,
     /*  163292 */   // Label 3065: @163292
     /*  163292 */   GIM_Reject,
     /*  163293 */ // Label 3063: @163293
     /*  163293 */ GIM_Reject,
     /*  163294 */ // Label 2870: @163294
     /*  163294 */ GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(163421),
     /*  163299 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163302 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  163306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  163310 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(163365), // Rule ID 45848 //
     /*  163315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  163318 */     // MIs[0] rs1
     /*  163318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  163322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163326 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  163326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  163329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  163343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163359 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163363 */     GIR_RootConstrainSelectedInstOperands,
     /*  163364 */     // GIR_Coverage, 45848,
     /*  163364 */     GIR_EraseRootFromParent_Done,
     /*  163365 */   // Label 3067: @163365
     /*  163365 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(163420), // Rule ID 45849 //
     /*  163370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  163373 */     // MIs[0] rs1
     /*  163373 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163381 */     // (ld:{ *:[nxv64i8] } GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (PseudoVLE8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  163381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /*  163384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  163388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  163393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  163395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVLE8_V_M8),
     /*  163398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  163403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  163405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  163408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  163414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  163418 */     GIR_RootConstrainSelectedInstOperands,
     /*  163419 */     // GIR_Coverage, 45849,
     /*  163419 */     GIR_EraseRootFromParent_Done,
     /*  163420 */   // Label 3068: @163420
     /*  163420 */   GIM_Reject,
     /*  163421 */ // Label 3066: @163421
     /*  163421 */ GIM_Reject,
     /*  163422 */ // Label 2871: @163422
     /*  163422 */ GIM_Reject,
     /*  163423 */ // Label 22: @163423
     /*  163423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3071*/ GIMT_Encode4(165392),
     /*  163434 */ /*GILLT_s32*//*Label 3069*/ GIMT_Encode4(163442),
     /*  163438 */ /*GILLT_s64*//*Label 3070*/ GIMT_Encode4(164818),
     /*  163442 */ // Label 3069: @163442
     /*  163442 */ GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(163549), // Rule ID 74012 //
     /*  163447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  163450 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163453 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  163460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163464 */   // MIs[0] Operand 1
     /*  163464 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163468 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  163472 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  163476 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  163480 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  163484 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  163488 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  163492 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  163496 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  163500 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  163505 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  163509 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  163513 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  163517 */   // MIs[3] Operand 1
     /*  163517 */   // No operand predicates
     /*  163517 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163522 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  163524 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  163524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  163527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163529 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  163533 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  163537 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  163540 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  163547 */   GIR_RootConstrainSelectedInstOperands,
     /*  163548 */   // GIR_Coverage, 74012,
     /*  163548 */   GIR_EraseRootFromParent_Done,
     /*  163549 */ // Label 3072: @163549
     /*  163549 */ GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(163656), // Rule ID 74013 //
     /*  163554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  163557 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163560 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  163567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163571 */   // MIs[0] Operand 1
     /*  163571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  163579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  163583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  163587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  163591 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  163595 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  163599 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  163603 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  163607 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  163612 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  163616 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  163620 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  163624 */   // MIs[3] Operand 1
     /*  163624 */   // No operand predicates
     /*  163624 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163629 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  163631 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  163631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  163634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163636 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  163640 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  163644 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  163647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  163654 */   GIR_RootConstrainSelectedInstOperands,
     /*  163655 */   // GIR_Coverage, 74013,
     /*  163655 */   GIR_EraseRootFromParent_Done,
     /*  163656 */ // Label 3073: @163656
     /*  163656 */ GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(163763), // Rule ID 74016 //
     /*  163661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  163664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  163674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163678 */   // MIs[0] Operand 1
     /*  163678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  163686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  163690 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  163694 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  163698 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  163702 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  163706 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  163710 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  163714 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  163719 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  163723 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  163727 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  163731 */   // MIs[3] Operand 1
     /*  163731 */   // No operand predicates
     /*  163731 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163736 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  163738 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  163738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  163741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163743 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  163747 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  163751 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  163754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  163761 */   GIR_RootConstrainSelectedInstOperands,
     /*  163762 */   // GIR_Coverage, 74016,
     /*  163762 */   GIR_EraseRootFromParent_Done,
     /*  163763 */ // Label 3074: @163763
     /*  163763 */ GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(163870), // Rule ID 74017 //
     /*  163768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  163771 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163774 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  163781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163785 */   // MIs[0] Operand 1
     /*  163785 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  163793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  163797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  163801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  163805 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  163809 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  163813 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  163817 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  163821 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  163826 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  163830 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  163834 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  163838 */   // MIs[3] Operand 1
     /*  163838 */   // No operand predicates
     /*  163838 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163843 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  163845 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  163845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  163848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  163854 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  163858 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  163861 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  163868 */   GIR_RootConstrainSelectedInstOperands,
     /*  163869 */   // GIR_Coverage, 74017,
     /*  163869 */   GIR_EraseRootFromParent_Done,
     /*  163870 */ // Label 3075: @163870
     /*  163870 */ GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(163977), // Rule ID 64527 //
     /*  163875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  163878 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163881 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  163888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163892 */   // MIs[0] Operand 1
     /*  163892 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  163896 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  163900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  163904 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  163908 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  163912 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163917 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  163921 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  163925 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  163929 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  163933 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  163938 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  163942 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  163946 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  163950 */   // MIs[3] Operand 1
     /*  163950 */   // No operand predicates
     /*  163950 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  163952 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  163952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  163955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  163957 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  163961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  163965 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  163968 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  163975 */   GIR_RootConstrainSelectedInstOperands,
     /*  163976 */   // GIR_Coverage, 64527,
     /*  163976 */   GIR_EraseRootFromParent_Done,
     /*  163977 */ // Label 3076: @163977
     /*  163977 */ GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(164084), // Rule ID 64528 //
     /*  163982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  163985 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  163988 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  163995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  163999 */   // MIs[0] Operand 1
     /*  163999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164003 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  164007 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  164011 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  164015 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  164019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164024 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  164028 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  164032 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  164036 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  164040 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  164045 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  164049 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  164053 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  164057 */   // MIs[3] Operand 1
     /*  164057 */   // No operand predicates
     /*  164057 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  164059 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (QC_LRB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  164059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRB),
     /*  164062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164064 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  164068 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  164072 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  164075 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  164082 */   GIR_RootConstrainSelectedInstOperands,
     /*  164083 */   // GIR_Coverage, 64528,
     /*  164083 */   GIR_EraseRootFromParent_Done,
     /*  164084 */ // Label 3077: @164084
     /*  164084 */ GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(164191), // Rule ID 64531 //
     /*  164089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  164092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164095 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164106 */   // MIs[0] Operand 1
     /*  164106 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  164114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  164118 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  164122 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  164126 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164131 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  164135 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  164139 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  164143 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  164147 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  164152 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  164156 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  164160 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  164164 */   // MIs[3] Operand 1
     /*  164164 */   // No operand predicates
     /*  164164 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  164166 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  164166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  164169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164171 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  164175 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  164179 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  164182 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  164189 */   GIR_RootConstrainSelectedInstOperands,
     /*  164190 */   // GIR_Coverage, 64531,
     /*  164190 */   GIR_EraseRootFromParent_Done,
     /*  164191 */ // Label 3078: @164191
     /*  164191 */ GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(164298), // Rule ID 64532 //
     /*  164196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  164199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164213 */   // MIs[0] Operand 1
     /*  164213 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  164221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  164225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  164229 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  164233 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164238 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  164242 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  164246 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  164250 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  164254 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  164259 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  164263 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  164267 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  164271 */   // MIs[3] Operand 1
     /*  164271 */   // No operand predicates
     /*  164271 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  164273 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (QC_LRH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  164273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRH),
     /*  164276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164278 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  164282 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  164286 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  164289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  164296 */   GIR_RootConstrainSelectedInstOperands,
     /*  164297 */   // GIR_Coverage, 64532,
     /*  164297 */   GIR_EraseRootFromParent_Done,
     /*  164298 */ // Label 3079: @164298
     /*  164298 */ GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(164352), // Rule ID 225 //
     /*  164303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  164306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164309 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164324 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164331 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  164331 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  164334 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164346 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164350 */   GIR_RootConstrainSelectedInstOperands,
     /*  164351 */   // GIR_Coverage, 225,
     /*  164351 */   GIR_EraseRootFromParent_Done,
     /*  164352 */ // Label 3080: @164352
     /*  164352 */ GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(164406), // Rule ID 229 //
     /*  164357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  164360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164363 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164374 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164378 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164385 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  164385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  164388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164400 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164404 */   GIR_RootConstrainSelectedInstOperands,
     /*  164405 */   // GIR_Coverage, 229,
     /*  164405 */   GIR_EraseRootFromParent_Done,
     /*  164406 */ // Label 3081: @164406
     /*  164406 */ GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(164463), // Rule ID 316 //
     /*  164411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  164414 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164417 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164424 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164431 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164435 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164442 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10087>>  =>  (LB:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  164442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  164445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164461 */   GIR_RootConstrainSelectedInstOperands,
     /*  164462 */   // GIR_Coverage, 316,
     /*  164462 */   GIR_EraseRootFromParent_Done,
     /*  164463 */ // Label 3082: @164463
     /*  164463 */ GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(164520), // Rule ID 320 //
     /*  164468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  164471 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164481 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164499 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10089>>  =>  (LH:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  164499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  164502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164518 */   GIR_RootConstrainSelectedInstOperands,
     /*  164519 */   // GIR_Coverage, 320,
     /*  164519 */   GIR_EraseRootFromParent_Done,
     /*  164520 */ // Label 3083: @164520
     /*  164520 */ GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(164577), // Rule ID 336 //
     /*  164525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  164528 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  164538 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164556 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10103>>  =>  (LW:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  164556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  164559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164575 */   GIR_RootConstrainSelectedInstOperands,
     /*  164576 */   // GIR_Coverage, 336,
     /*  164576 */   GIR_EraseRootFromParent_Done,
     /*  164577 */ // Label 3084: @164577
     /*  164577 */ GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(164617), // Rule ID 1092 //
     /*  164582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  164585 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164602 */   // MIs[0] rs1
     /*  164602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164610 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10591>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  164615 */   GIR_RootConstrainSelectedInstOperands,
     /*  164616 */   // GIR_Coverage, 1092,
     /*  164616 */   GIR_Done,
     /*  164617 */ // Label 3085: @164617
     /*  164617 */ GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(164657), // Rule ID 1096 //
     /*  164622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  164625 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164635 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  164638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164642 */   // MIs[0] rs1
     /*  164642 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164650 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10593>>  =>  (LB_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  164655 */   GIR_RootConstrainSelectedInstOperands,
     /*  164656 */   // GIR_Coverage, 1096,
     /*  164656 */   GIR_Done,
     /*  164657 */ // Label 3086: @164657
     /*  164657 */ GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(164697), // Rule ID 1100 //
     /*  164662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  164665 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164668 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164675 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164682 */   // MIs[0] rs1
     /*  164682 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164690 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10595>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  164695 */   GIR_RootConstrainSelectedInstOperands,
     /*  164696 */   // GIR_Coverage, 1100,
     /*  164696 */   GIR_Done,
     /*  164697 */ // Label 3087: @164697
     /*  164697 */ GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(164737), // Rule ID 1104 //
     /*  164702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  164705 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164708 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164715 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  164718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164722 */   // MIs[0] rs1
     /*  164722 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164730 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10597>>  =>  (LH_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164730 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  164735 */   GIR_RootConstrainSelectedInstOperands,
     /*  164736 */   // GIR_Coverage, 1104,
     /*  164736 */   GIR_Done,
     /*  164737 */ // Label 3088: @164737
     /*  164737 */ GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(164777), // Rule ID 1124 //
     /*  164742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  164745 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  164755 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  164758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164762 */   // MIs[0] rs1
     /*  164762 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164770 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  164775 */   GIR_RootConstrainSelectedInstOperands,
     /*  164776 */   // GIR_Coverage, 1124,
     /*  164776 */   GIR_Done,
     /*  164777 */ // Label 3089: @164777
     /*  164777 */ GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(164817), // Rule ID 1128 //
     /*  164782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  164785 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  164795 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  164798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164802 */   // MIs[0] rs1
     /*  164802 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  164806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164810 */   // (atomic_load:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i32] } GPRMemZeroOffset:{ *:[i32] }:$rs1)
     /*  164810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  164815 */   GIR_RootConstrainSelectedInstOperands,
     /*  164816 */   // GIR_Coverage, 1128,
     /*  164816 */   GIR_Done,
     /*  164817 */ // Label 3090: @164817
     /*  164817 */ GIM_Reject,
     /*  164818 */ // Label 3070: @164818
     /*  164818 */ GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(164872), // Rule ID 224 //
     /*  164823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  164826 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164829 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164840 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164844 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164851 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  164851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  164854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164856 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164866 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164870 */   GIR_RootConstrainSelectedInstOperands,
     /*  164871 */   // GIR_Coverage, 224,
     /*  164871 */   GIR_EraseRootFromParent_Done,
     /*  164872 */ // Label 3091: @164872
     /*  164872 */ GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(164926), // Rule ID 228 //
     /*  164877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  164880 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164883 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  164890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164894 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164905 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  164905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  164908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164924 */   GIR_RootConstrainSelectedInstOperands,
     /*  164925 */   // GIR_Coverage, 228,
     /*  164925 */   GIR_EraseRootFromParent_Done,
     /*  164926 */ // Label 3092: @164926
     /*  164926 */ GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(164980), // Rule ID 275 //
     /*  164931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  164934 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  164937 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  164944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  164948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  164952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  164959 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  164959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  164962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  164964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  164969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  164974 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  164978 */   GIR_RootConstrainSelectedInstOperands,
     /*  164979 */   // GIR_Coverage, 275,
     /*  164979 */   GIR_EraseRootFromParent_Done,
     /*  164980 */ // Label 3093: @164980
     /*  164980 */ GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(165037), // Rule ID 315 //
     /*  164985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  164988 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  164991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  164998 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165009 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  165016 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10087>>  =>  (LB:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  165016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LB),
     /*  165019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  165026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  165031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165035 */   GIR_RootConstrainSelectedInstOperands,
     /*  165036 */   // GIR_Coverage, 315,
     /*  165036 */   GIR_EraseRootFromParent_Done,
     /*  165037 */ // Label 3094: @165037
     /*  165037 */ GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(165094), // Rule ID 319 //
     /*  165042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  165045 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165048 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  165055 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  165073 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10089>>  =>  (LH:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  165073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LH),
     /*  165076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  165083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  165088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165092 */   GIR_RootConstrainSelectedInstOperands,
     /*  165093 */   // GIR_Coverage, 319,
     /*  165093 */   GIR_EraseRootFromParent_Done,
     /*  165094 */ // Label 3095: @165094
     /*  165094 */ GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(165151), // Rule ID 335 //
     /*  165099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  165102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  165112 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  165123 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  165130 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10103>>  =>  (LW:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  165130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LW),
     /*  165133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  165140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  165145 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  165149 */   GIR_RootConstrainSelectedInstOperands,
     /*  165150 */   // GIR_Coverage, 335,
     /*  165150 */   GIR_EraseRootFromParent_Done,
     /*  165151 */ // Label 3096: @165151
     /*  165151 */ GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(165191), // Rule ID 1091 //
     /*  165156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  165159 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165162 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165176 */   // MIs[0] rs1
     /*  165176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165184 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10591>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  165189 */   GIR_RootConstrainSelectedInstOperands,
     /*  165190 */   // GIR_Coverage, 1091,
     /*  165190 */   GIR_Done,
     /*  165191 */ // Label 3097: @165191
     /*  165191 */ GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(165231), // Rule ID 1095 //
     /*  165196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  165199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165209 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  165212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165216 */   // MIs[0] rs1
     /*  165216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165224 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_8>><<P:Predicate_anonymous_10593>>  =>  (LB_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LB_AQ),
     /*  165229 */   GIR_RootConstrainSelectedInstOperands,
     /*  165230 */   // GIR_Coverage, 1095,
     /*  165230 */   GIR_Done,
     /*  165231 */ // Label 3098: @165231
     /*  165231 */ GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(165271), // Rule ID 1099 //
     /*  165236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  165239 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165242 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  165249 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165256 */   // MIs[0] rs1
     /*  165256 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165264 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10595>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165264 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  165269 */   GIR_RootConstrainSelectedInstOperands,
     /*  165270 */   // GIR_Coverage, 1099,
     /*  165270 */   GIR_Done,
     /*  165271 */ // Label 3099: @165271
     /*  165271 */ GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(165311), // Rule ID 1103 //
     /*  165276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  165279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  165289 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  165292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165296 */   // MIs[0] rs1
     /*  165296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165304 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_16>><<P:Predicate_anonymous_10597>>  =>  (LH_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LH_AQ),
     /*  165309 */   GIR_RootConstrainSelectedInstOperands,
     /*  165310 */   // GIR_Coverage, 1103,
     /*  165310 */   GIR_Done,
     /*  165311 */ // Label 3100: @165311
     /*  165311 */ GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(165351), // Rule ID 1123 //
     /*  165316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  165319 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165322 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  165329 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  165332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165336 */   // MIs[0] rs1
     /*  165336 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165344 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10615>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  165349 */   GIR_RootConstrainSelectedInstOperands,
     /*  165350 */   // GIR_Coverage, 1123,
     /*  165350 */   GIR_Done,
     /*  165351 */ // Label 3101: @165351
     /*  165351 */ GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(165391), // Rule ID 1127 //
     /*  165356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  165359 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  165362 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  165369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  165372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165376 */   // MIs[0] rs1
     /*  165376 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  165380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165384 */   // (atomic_load:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_load_sext>><<P:Predicate_atomic_load_sext_32>><<P:Predicate_anonymous_10617>>  =>  (LW_AQ:{ *:[i64] } GPRMemZeroOffset:{ *:[i64] }:$rs1)
     /*  165384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::LW_AQ),
     /*  165389 */   GIR_RootConstrainSelectedInstOperands,
     /*  165390 */   // GIR_Coverage, 1127,
     /*  165390 */   GIR_Done,
     /*  165391 */ // Label 3102: @165391
     /*  165391 */ GIM_Reject,
     /*  165392 */ // Label 3071: @165392
     /*  165392 */ GIM_Reject,
     /*  165393 */ // Label 23: @165393
     /*  165393 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3105*/ GIMT_Encode4(166882),
     /*  165404 */ /*GILLT_s32*//*Label 3103*/ GIMT_Encode4(165412),
     /*  165408 */ /*GILLT_s64*//*Label 3104*/ GIMT_Encode4(166548),
     /*  165412 */ // Label 3103: @165412
     /*  165412 */ GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(165519), // Rule ID 74022 //
     /*  165417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  165420 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165423 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165434 */   // MIs[0] Operand 1
     /*  165434 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165438 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165442 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165446 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165450 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165454 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  165458 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  165462 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  165466 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  165470 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  165475 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  165479 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  165483 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  165487 */   // MIs[3] Operand 1
     /*  165487 */   // No operand predicates
     /*  165487 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165492 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  165494 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  165494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  165497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165499 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  165503 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  165507 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  165510 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  165517 */   GIR_RootConstrainSelectedInstOperands,
     /*  165518 */   // GIR_Coverage, 74022,
     /*  165518 */   GIR_EraseRootFromParent_Done,
     /*  165519 */ // Label 3106: @165519
     /*  165519 */ GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(165626), // Rule ID 74023 //
     /*  165524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  165527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165541 */   // MIs[0] Operand 1
     /*  165541 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165557 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165561 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  165565 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  165569 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  165573 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  165577 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  165582 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  165586 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  165590 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  165594 */   // MIs[3] Operand 1
     /*  165594 */   // No operand predicates
     /*  165594 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165599 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  165601 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  165601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  165604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165606 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  165610 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  165614 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  165617 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  165624 */   GIR_RootConstrainSelectedInstOperands,
     /*  165625 */   // GIR_Coverage, 74023,
     /*  165625 */   GIR_EraseRootFromParent_Done,
     /*  165626 */ // Label 3107: @165626
     /*  165626 */ GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(165733), // Rule ID 74024 //
     /*  165631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  165634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  165644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165648 */   // MIs[0] Operand 1
     /*  165648 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165664 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165668 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  165672 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  165676 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  165680 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  165684 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  165689 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  165693 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  165697 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  165701 */   // MIs[3] Operand 1
     /*  165701 */   // No operand predicates
     /*  165701 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165706 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  165708 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  165708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  165711 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  165717 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  165721 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  165724 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  165731 */   GIR_RootConstrainSelectedInstOperands,
     /*  165732 */   // GIR_Coverage, 74024,
     /*  165732 */   GIR_EraseRootFromParent_Done,
     /*  165733 */ // Label 3108: @165733
     /*  165733 */ GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(165840), // Rule ID 74025 //
     /*  165738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  165741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165744 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  165751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165755 */   // MIs[0] Operand 1
     /*  165755 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165767 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165771 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165775 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  165779 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  165783 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  165787 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  165791 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  165796 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  165800 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  165804 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  165808 */   // MIs[3] Operand 1
     /*  165808 */   // No operand predicates
     /*  165808 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165813 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  165815 */   // (ld:{ *:[i32] } (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  165815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  165818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165820 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  165824 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  165828 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  165831 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  165838 */   GIR_RootConstrainSelectedInstOperands,
     /*  165839 */   // GIR_Coverage, 74025,
     /*  165839 */   GIR_EraseRootFromParent_Done,
     /*  165840 */ // Label 3109: @165840
     /*  165840 */ GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(165947), // Rule ID 64537 //
     /*  165845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  165848 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165851 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165862 */   // MIs[0] Operand 1
     /*  165862 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165866 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165870 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165874 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165878 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165882 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165887 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  165891 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  165895 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  165899 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  165903 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  165908 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  165912 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  165916 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  165920 */   // MIs[3] Operand 1
     /*  165920 */   // No operand predicates
     /*  165920 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  165922 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  165922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  165925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  165927 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  165931 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  165935 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  165938 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  165945 */   GIR_RootConstrainSelectedInstOperands,
     /*  165946 */   // GIR_Coverage, 64537,
     /*  165946 */   GIR_EraseRootFromParent_Done,
     /*  165947 */ // Label 3110: @165947
     /*  165947 */ GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(166054), // Rule ID 64538 //
     /*  165952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  165955 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  165958 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  165965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165969 */   // MIs[0] Operand 1
     /*  165969 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  165973 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  165977 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  165981 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  165985 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  165989 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  165994 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  165998 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  166002 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  166006 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  166010 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  166015 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  166019 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  166023 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  166027 */   // MIs[3] Operand 1
     /*  166027 */   // No operand predicates
     /*  166027 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  166029 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (QC_LRBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  166029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRBU),
     /*  166032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166034 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  166038 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  166042 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  166045 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  166052 */   GIR_RootConstrainSelectedInstOperands,
     /*  166053 */   // GIR_Coverage, 64538,
     /*  166053 */   GIR_EraseRootFromParent_Done,
     /*  166054 */ // Label 3111: @166054
     /*  166054 */ GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(166161), // Rule ID 64539 //
     /*  166059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  166062 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166065 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166076 */   // MIs[0] Operand 1
     /*  166076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  166084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  166088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  166092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  166096 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166101 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  166105 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  166109 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  166113 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  166117 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  166122 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  166126 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  166130 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  166134 */   // MIs[3] Operand 1
     /*  166134 */   // No operand predicates
     /*  166134 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  166136 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  166136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  166139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166141 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  166145 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  166149 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  166152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  166159 */   GIR_RootConstrainSelectedInstOperands,
     /*  166160 */   // GIR_Coverage, 64539,
     /*  166160 */   GIR_EraseRootFromParent_Done,
     /*  166161 */ // Label 3112: @166161
     /*  166161 */ GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(166268), // Rule ID 64540 //
     /*  166166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  166169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166183 */   // MIs[0] Operand 1
     /*  166183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  166187 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  166191 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  166195 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  166199 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  166203 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166208 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  166212 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  166216 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  166220 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  166224 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  166229 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  166233 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  166237 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  166241 */   // MIs[3] Operand 1
     /*  166241 */   // No operand predicates
     /*  166241 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  166243 */   // (ld:{ *:[i32] } (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (QC_LRHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  166243 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_LRHU),
     /*  166246 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166248 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  166252 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  166256 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  166259 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  166266 */   GIR_RootConstrainSelectedInstOperands,
     /*  166267 */   // GIR_Coverage, 64540,
     /*  166267 */   GIR_EraseRootFromParent_Done,
     /*  166268 */ // Label 3113: @166268
     /*  166268 */ GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(166322), // Rule ID 235 //
     /*  166273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166276 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166279 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166290 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166294 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166301 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  166304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166306 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166316 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166320 */   GIR_RootConstrainSelectedInstOperands,
     /*  166321 */   // GIR_Coverage, 235,
     /*  166321 */   GIR_EraseRootFromParent_Done,
     /*  166322 */ // Label 3114: @166322
     /*  166322 */ GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(166376), // Rule ID 237 //
     /*  166327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  166330 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166333 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166348 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166355 */   // (ld:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  166358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166370 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166374 */   GIR_RootConstrainSelectedInstOperands,
     /*  166375 */   // GIR_Coverage, 237,
     /*  166375 */   GIR_EraseRootFromParent_Done,
     /*  166376 */ // Label 3115: @166376
     /*  166376 */ GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(166433), // Rule ID 322 //
     /*  166381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  166384 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166387 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166394 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166401 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166405 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166412 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10091>>  =>  (LBU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  166415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166431 */   GIR_RootConstrainSelectedInstOperands,
     /*  166432 */   // GIR_Coverage, 322,
     /*  166432 */   GIR_EraseRootFromParent_Done,
     /*  166433 */ // Label 3116: @166433
     /*  166433 */ GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(166490), // Rule ID 324 //
     /*  166438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  166441 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166444 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166451 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166469 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10093>>  =>  (LHU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  166472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166488 */   GIR_RootConstrainSelectedInstOperands,
     /*  166489 */   // GIR_Coverage, 324,
     /*  166489 */   GIR_EraseRootFromParent_Done,
     /*  166490 */ // Label 3117: @166490
     /*  166490 */ GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(166547), // Rule ID 338 //
     /*  166495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  166498 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166501 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  166508 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166515 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166519 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166526 */   // (atomic_load:{ *:[i32] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10105>>  =>  (LWU:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  166526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  166529 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166536 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166541 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166545 */   GIR_RootConstrainSelectedInstOperands,
     /*  166546 */   // GIR_Coverage, 338,
     /*  166546 */   GIR_EraseRootFromParent_Done,
     /*  166547 */ // Label 3118: @166547
     /*  166547 */ GIM_Reject,
     /*  166548 */ // Label 3104: @166548
     /*  166548 */ GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(166602), // Rule ID 234 //
     /*  166553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  166556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166581 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  166584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166600 */   GIR_RootConstrainSelectedInstOperands,
     /*  166601 */   // GIR_Coverage, 234,
     /*  166601 */   GIR_EraseRootFromParent_Done,
     /*  166602 */ // Label 3119: @166602
     /*  166602 */ GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(166656), // Rule ID 236 //
     /*  166607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  166610 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166613 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166635 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  166638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166650 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166654 */   GIR_RootConstrainSelectedInstOperands,
     /*  166655 */   // GIR_Coverage, 236,
     /*  166655 */   GIR_EraseRootFromParent_Done,
     /*  166656 */ // Label 3120: @166656
     /*  166656 */ GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(166710), // Rule ID 277 //
     /*  166661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  166664 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  166667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  166674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166678 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166682 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166689 */   // (ld:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  166692 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166704 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166708 */   GIR_RootConstrainSelectedInstOperands,
     /*  166709 */   // GIR_Coverage, 277,
     /*  166709 */   GIR_EraseRootFromParent_Done,
     /*  166710 */ // Label 3121: @166710
     /*  166710 */ GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(166767), // Rule ID 321 //
     /*  166715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  166718 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166721 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  166728 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166735 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166739 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166746 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_10091>>  =>  (LBU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LBU),
     /*  166749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166751 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166761 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166765 */   GIR_RootConstrainSelectedInstOperands,
     /*  166766 */   // GIR_Coverage, 321,
     /*  166766 */   GIR_EraseRootFromParent_Done,
     /*  166767 */ // Label 3122: @166767
     /*  166767 */ GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(166824), // Rule ID 323 //
     /*  166772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  166775 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166778 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  166785 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166792 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166796 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166803 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_10093>>  =>  (LHU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LHU),
     /*  166806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166818 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166822 */   GIR_RootConstrainSelectedInstOperands,
     /*  166823 */   // GIR_Coverage, 323,
     /*  166823 */   GIR_EraseRootFromParent_Done,
     /*  166824 */ // Label 3123: @166824
     /*  166824 */ GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(166881), // Rule ID 337 //
     /*  166829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  166832 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  166835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  166842 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  166845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  166849 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  166853 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  166860 */   // (atomic_load:{ *:[i64] } (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_32>><<P:Predicate_anonymous_10105>>  =>  (LWU:{ *:[i64] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  166860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::LWU),
     /*  166863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  166865 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  166870 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  166875 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  166879 */   GIR_RootConstrainSelectedInstOperands,
     /*  166880 */   // GIR_Coverage, 337,
     /*  166880 */   GIR_EraseRootFromParent_Done,
     /*  166881 */ // Label 3124: @166881
     /*  166881 */ GIM_Reject,
     /*  166882 */ // Label 3105: @166882
     /*  166882 */ GIM_Reject,
     /*  166883 */ // Label 24: @166883
     /*  166883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(34), /*)*//*default:*//*Label 3159*/ GIMT_Encode4(174984),
     /*  166894 */ /*GILLT_p0s32*//*Label 3125*/ GIMT_Encode4(167030),
     /*  166898 */ /*GILLT_p0s64*//*Label 3126*/ GIMT_Encode4(167124),
     /*  166902 */ /*GILLT_s16*//*Label 3127*/ GIMT_Encode4(167218),
     /*  166906 */ /*GILLT_s32*//*Label 3128*/ GIMT_Encode4(167857),
     /*  166910 */ /*GILLT_s64*//*Label 3129*/ GIMT_Encode4(170463),
     /*  166914 */ /*GILLT_nxv1s1*//*Label 3130*/ GIMT_Encode4(171438),
     /*  166918 */ /*GILLT_nxv1s8*//*Label 3131*/ GIMT_Encode4(171518),
     /*  166922 */ /*GILLT_nxv1s16*//*Label 3132*/ GIMT_Encode4(171606),
     /*  166926 */ /*GILLT_nxv1s32*//*Label 3133*/ GIMT_Encode4(171764),
     /*  166930 */ /*GILLT_nxv1s64*//*Label 3134*/ GIMT_Encode4(171922),
     /*  166934 */ /*GILLT_nxv2s1*//*Label 3135*/ GIMT_Encode4(172080),
     /*  166938 */ /*GILLT_nxv2s8*//*Label 3136*/ GIMT_Encode4(172160),
     /*  166942 */ /*GILLT_nxv2s16*//*Label 3137*/ GIMT_Encode4(172248),
     /*  166946 */ /*GILLT_nxv2s32*//*Label 3138*/ GIMT_Encode4(172406),
     /*  166950 */ /*GILLT_nxv2s64*//*Label 3139*/ GIMT_Encode4(172564),
     /*  166954 */ /*GILLT_nxv4s1*//*Label 3140*/ GIMT_Encode4(172722),
     /*  166958 */ /*GILLT_nxv4s8*//*Label 3141*/ GIMT_Encode4(172802),
     /*  166962 */ /*GILLT_nxv4s16*//*Label 3142*/ GIMT_Encode4(172890),
     /*  166966 */ /*GILLT_nxv4s32*//*Label 3143*/ GIMT_Encode4(173048),
     /*  166970 */ /*GILLT_nxv4s64*//*Label 3144*/ GIMT_Encode4(173206),
     /*  166974 */ /*GILLT_nxv8s1*//*Label 3145*/ GIMT_Encode4(173364),
     /*  166978 */ /*GILLT_nxv8s8*//*Label 3146*/ GIMT_Encode4(173444),
     /*  166982 */ /*GILLT_nxv8s16*//*Label 3147*/ GIMT_Encode4(173532),
     /*  166986 */ /*GILLT_nxv8s32*//*Label 3148*/ GIMT_Encode4(173690),
     /*  166990 */ /*GILLT_nxv8s64*//*Label 3149*/ GIMT_Encode4(173848),
     /*  166994 */ /*GILLT_nxv16s1*//*Label 3150*/ GIMT_Encode4(174006),
     /*  166998 */ /*GILLT_nxv16s8*//*Label 3151*/ GIMT_Encode4(174086),
     /*  167002 */ /*GILLT_nxv16s16*//*Label 3152*/ GIMT_Encode4(174174),
     /*  167006 */ /*GILLT_nxv16s32*//*Label 3153*/ GIMT_Encode4(174332),
     /*  167010 */ /*GILLT_nxv32s1*//*Label 3154*/ GIMT_Encode4(174490),
     /*  167014 */ /*GILLT_nxv32s8*//*Label 3155*/ GIMT_Encode4(174570),
     /*  167018 */ /*GILLT_nxv32s16*//*Label 3156*/ GIMT_Encode4(174658),
     /*  167022 */ /*GILLT_nxv64s1*//*Label 3157*/ GIMT_Encode4(174816),
     /*  167026 */ /*GILLT_nxv64s8*//*Label 3158*/ GIMT_Encode4(174896),
     /*  167030 */ // Label 3125: @167030
     /*  167030 */ GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(167123),
     /*  167035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167050 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(167086), // Rule ID 65001 //
     /*  167055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode1),
     /*  167058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167065 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  167068 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167084 */     GIR_RootConstrainSelectedInstOperands,
     /*  167085 */     // GIR_Coverage, 65001,
     /*  167085 */     GIR_EraseRootFromParent_Done,
     /*  167086 */   // Label 3161: @167086
     /*  167086 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(167122), // Rule ID 65005 //
     /*  167091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  167094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167101 */     // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  167104 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167120 */     GIR_RootConstrainSelectedInstOperands,
     /*  167121 */     // GIR_Coverage, 65005,
     /*  167121 */     GIR_EraseRootFromParent_Done,
     /*  167122 */   // Label 3162: @167122
     /*  167122 */   GIM_Reject,
     /*  167123 */ // Label 3160: @167123
     /*  167123 */ GIM_Reject,
     /*  167124 */ // Label 3126: @167124
     /*  167124 */ GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(167217),
     /*  167129 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167132 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167144 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(167180), // Rule ID 65000 //
     /*  167149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_HwMode0),
     /*  167152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167159 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  167162 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167178 */     GIR_RootConstrainSelectedInstOperands,
     /*  167179 */     // GIR_Coverage, 65000,
     /*  167179 */     GIR_EraseRootFromParent_Done,
     /*  167180 */   // Label 3164: @167180
     /*  167180 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(167216), // Rule ID 65004 //
     /*  167185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  167188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167195 */     // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  167198 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167214 */     GIR_RootConstrainSelectedInstOperands,
     /*  167215 */     // GIR_Coverage, 65004,
     /*  167215 */     GIR_EraseRootFromParent_Done,
     /*  167216 */   // Label 3165: @167216
     /*  167216 */   GIM_Reject,
     /*  167217 */ // Label 3163: @167217
     /*  167217 */ GIM_Reject,
     /*  167218 */ // Label 3127: @167218
     /*  167218 */ GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(167272), // Rule ID 65018 //
     /*  167223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167226 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167240 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167251 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167251 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  167254 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167256 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167261 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167266 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167270 */   GIR_RootConstrainSelectedInstOperands,
     /*  167271 */   // GIR_Coverage, 65018,
     /*  167271 */   GIR_EraseRootFromParent_Done,
     /*  167272 */ // Label 3166: @167272
     /*  167272 */ GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(167326), // Rule ID 65019 //
     /*  167277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167283 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167294 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167305 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  167308 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167320 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167324 */   GIR_RootConstrainSelectedInstOperands,
     /*  167325 */   // GIR_Coverage, 65019,
     /*  167325 */   GIR_EraseRootFromParent_Done,
     /*  167326 */ // Label 3167: @167326
     /*  167326 */ GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(167380), // Rule ID 65020 //
     /*  167331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  167334 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167337 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167348 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167352 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167359 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  167362 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167364 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167369 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167374 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167378 */   GIR_RootConstrainSelectedInstOperands,
     /*  167379 */   // GIR_Coverage, 65020,
     /*  167379 */   GIR_EraseRootFromParent_Done,
     /*  167380 */ // Label 3168: @167380
     /*  167380 */ GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(167434), // Rule ID 65021 //
     /*  167385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  167388 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  167391 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  167398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167406 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167413 */   // (atomic_store GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  167416 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167428 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167432 */   GIR_RootConstrainSelectedInstOperands,
     /*  167433 */   // GIR_Coverage, 65021,
     /*  167433 */   GIR_EraseRootFromParent_Done,
     /*  167434 */ // Label 3169: @167434
     /*  167434 */ GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(167485), // Rule ID 2042 //
     /*  167439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /*  167442 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167445 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  167453 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167457 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167464 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  167467 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167469 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167479 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167483 */   GIR_RootConstrainSelectedInstOperands,
     /*  167484 */   // GIR_Coverage, 2042,
     /*  167484 */   GIR_EraseRootFromParent_Done,
     /*  167485 */ // Label 3170: @167485
     /*  167485 */ GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(167536), // Rule ID 2043 //
     /*  167490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /*  167493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167496 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  167504 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167508 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167515 */   // (st FPR16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSH FPR16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSH),
     /*  167518 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167534 */   GIR_RootConstrainSelectedInstOperands,
     /*  167535 */   // GIR_Coverage, 2043,
     /*  167535 */   GIR_EraseRootFromParent_Done,
     /*  167536 */ // Label 3171: @167536
     /*  167536 */ GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(167587), // Rule ID 2048 //
     /*  167541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /*  167544 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167547 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  167555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167566 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  167569 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167585 */   GIR_RootConstrainSelectedInstOperands,
     /*  167586 */   // GIR_Coverage, 2048,
     /*  167586 */   GIR_EraseRootFromParent_Done,
     /*  167587 */ // Label 3172: @167587
     /*  167587 */ GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(167638), // Rule ID 2049 //
     /*  167592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /*  167595 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167598 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /*  167606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167610 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167617 */   // (st GPRF16:{ *:[f16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH_INX GPRF16:{ *:[f16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_INX),
     /*  167620 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167622 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167627 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167632 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167636 */   GIR_RootConstrainSelectedInstOperands,
     /*  167637 */   // GIR_Coverage, 2049,
     /*  167637 */   GIR_EraseRootFromParent_Done,
     /*  167638 */ // Label 3173: @167638
     /*  167638 */ GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(167689), // Rule ID 65008 //
     /*  167643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167646 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167649 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167657 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167661 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167668 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  167671 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167673 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167678 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167683 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167687 */   GIR_RootConstrainSelectedInstOperands,
     /*  167688 */   // GIR_Coverage, 65008,
     /*  167688 */   GIR_EraseRootFromParent_Done,
     /*  167689 */ // Label 3174: @167689
     /*  167689 */ GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(167740), // Rule ID 65009 //
     /*  167694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167700 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167708 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167712 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167719 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SH GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  167722 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167734 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167738 */   GIR_RootConstrainSelectedInstOperands,
     /*  167739 */   // GIR_Coverage, 65009,
     /*  167739 */   GIR_EraseRootFromParent_Done,
     /*  167740 */ // Label 3175: @167740
     /*  167740 */ GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(167798), // Rule ID 65012 //
     /*  167745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  167748 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167751 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167755 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167766 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167770 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167777 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  167777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  167780 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167796 */   GIR_RootConstrainSelectedInstOperands,
     /*  167797 */   // GIR_Coverage, 65012,
     /*  167797 */   GIR_EraseRootFromParent_Done,
     /*  167798 */ // Label 3176: @167798
     /*  167798 */ GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(167856), // Rule ID 65013 //
     /*  167803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  167806 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167809 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167813 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167824 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  167828 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  167835 */   // (st GPR:{ *:[i16] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i16] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  167835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  167838 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  167840 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  167845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  167850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  167854 */   GIR_RootConstrainSelectedInstOperands,
     /*  167855 */   // GIR_Coverage, 65013,
     /*  167855 */   GIR_EraseRootFromParent_Done,
     /*  167856 */ // Label 3177: @167856
     /*  167856 */ GIM_Reject,
     /*  167857 */ // Label 3128: @167857
     /*  167857 */ GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(167968), // Rule ID 74026 //
     /*  167862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  167865 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167868 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167883 */   // MIs[0] Operand 1
     /*  167883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167887 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  167891 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  167895 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  167899 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  167903 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  167907 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  167911 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  167915 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  167919 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  167924 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  167928 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  167932 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  167936 */   // MIs[3] Operand 1
     /*  167936 */   // No operand predicates
     /*  167936 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167941 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  167943 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  167943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  167946 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  167948 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  167952 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  167956 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  167959 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  167966 */   GIR_RootConstrainSelectedInstOperands,
     /*  167967 */   // GIR_Coverage, 74026,
     /*  167967 */   GIR_EraseRootFromParent_Done,
     /*  167968 */ // Label 3178: @167968
     /*  167968 */ GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(168079), // Rule ID 74027 //
     /*  167973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  167976 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  167979 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  167983 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  167990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  167994 */   // MIs[0] Operand 1
     /*  167994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  167998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168014 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168018 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168022 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168026 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168030 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168035 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168039 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168043 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168047 */   // MIs[3] Operand 1
     /*  168047 */   // No operand predicates
     /*  168047 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168052 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168054 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  168057 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168059 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168063 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168067 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168070 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168077 */   GIR_RootConstrainSelectedInstOperands,
     /*  168078 */   // GIR_Coverage, 74027,
     /*  168078 */   GIR_EraseRootFromParent_Done,
     /*  168079 */ // Label 3179: @168079
     /*  168079 */ GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(168190), // Rule ID 74028 //
     /*  168084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168090 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168094 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168105 */   // MIs[0] Operand 1
     /*  168105 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168109 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168117 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168121 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168125 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168129 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168133 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168137 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168141 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168146 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168150 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168154 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168158 */   // MIs[3] Operand 1
     /*  168158 */   // No operand predicates
     /*  168158 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168163 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168165 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  168168 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168170 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168174 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168178 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168188 */   GIR_RootConstrainSelectedInstOperands,
     /*  168189 */   // GIR_Coverage, 74028,
     /*  168189 */   GIR_EraseRootFromParent_Done,
     /*  168190 */ // Label 3180: @168190
     /*  168190 */ GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(168301), // Rule ID 74029 //
     /*  168195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168198 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168201 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168205 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168216 */   // MIs[0] Operand 1
     /*  168216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168220 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168224 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168228 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168232 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168236 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168240 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168244 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168248 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168252 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168257 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168261 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168265 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168269 */   // MIs[3] Operand 1
     /*  168269 */   // No operand predicates
     /*  168269 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168274 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168276 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  168279 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168281 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168285 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168289 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168292 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168299 */   GIR_RootConstrainSelectedInstOperands,
     /*  168300 */   // GIR_Coverage, 74029,
     /*  168300 */   GIR_EraseRootFromParent_Done,
     /*  168301 */ // Label 3181: @168301
     /*  168301 */ GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(168405), // Rule ID 74030 //
     /*  168306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168309 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168312 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168320 */   // MIs[0] Operand 1
     /*  168320 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168324 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168328 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168332 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168336 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168340 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168344 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168348 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168352 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168356 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168361 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168365 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168369 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168373 */   // MIs[3] Operand 1
     /*  168373 */   // No operand predicates
     /*  168373 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168378 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168380 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  168383 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168385 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168389 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168393 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168403 */   GIR_RootConstrainSelectedInstOperands,
     /*  168404 */   // GIR_Coverage, 74030,
     /*  168404 */   GIR_EraseRootFromParent_Done,
     /*  168405 */ // Label 3182: @168405
     /*  168405 */ GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(168509), // Rule ID 74031 //
     /*  168410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168413 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168416 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168424 */   // MIs[0] Operand 1
     /*  168424 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168436 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168440 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168444 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  168448 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168452 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168456 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168460 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168465 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168469 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168473 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168477 */   // MIs[3] Operand 1
     /*  168477 */   // No operand predicates
     /*  168477 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168482 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168484 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt), GPRMem:{ *:[i32] }:$rs1))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  168487 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168489 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // rs1
     /*  168493 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168497 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168500 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168507 */   GIR_RootConstrainSelectedInstOperands,
     /*  168508 */   // GIR_Coverage, 74031,
     /*  168508 */   GIR_EraseRootFromParent_Done,
     /*  168509 */ // Label 3183: @168509
     /*  168509 */ GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(168620), // Rule ID 64541 //
     /*  168514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168517 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168535 */   // MIs[0] Operand 1
     /*  168535 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168539 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168543 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168547 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168551 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168555 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168560 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168564 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168568 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168572 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168576 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168581 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168585 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168589 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168593 */   // MIs[3] Operand 1
     /*  168593 */   // No operand predicates
     /*  168593 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168595 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  168598 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168600 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168604 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168611 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168618 */   GIR_RootConstrainSelectedInstOperands,
     /*  168619 */   // GIR_Coverage, 64541,
     /*  168619 */   GIR_EraseRootFromParent_Done,
     /*  168620 */ // Label 3184: @168620
     /*  168620 */ GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(168731), // Rule ID 64542 //
     /*  168625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168628 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168631 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168635 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  168642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168646 */   // MIs[0] Operand 1
     /*  168646 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168658 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168662 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168666 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168671 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168675 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168679 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168683 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168687 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168692 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168696 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168700 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168704 */   // MIs[3] Operand 1
     /*  168704 */   // No operand predicates
     /*  168704 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168706 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (QC_SRB GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168706 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRB),
     /*  168709 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168711 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168715 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168719 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168729 */   GIR_RootConstrainSelectedInstOperands,
     /*  168730 */   // GIR_Coverage, 64542,
     /*  168730 */   GIR_EraseRootFromParent_Done,
     /*  168731 */ // Label 3185: @168731
     /*  168731 */ GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(168842), // Rule ID 64543 //
     /*  168736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168739 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168742 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168746 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168757 */   // MIs[0] Operand 1
     /*  168757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168769 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168773 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168777 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168782 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168786 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168790 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168794 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  168798 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168803 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168807 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168811 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168815 */   // MIs[3] Operand 1
     /*  168815 */   // No operand predicates
     /*  168815 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168817 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  168817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  168820 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168822 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168826 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168830 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168833 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168840 */   GIR_RootConstrainSelectedInstOperands,
     /*  168841 */   // GIR_Coverage, 64543,
     /*  168841 */   GIR_EraseRootFromParent_Done,
     /*  168842 */ // Label 3186: @168842
     /*  168842 */ GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(168953), // Rule ID 64544 //
     /*  168847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  168850 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  168864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168868 */   // MIs[0] Operand 1
     /*  168868 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168872 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168880 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168884 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168888 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168893 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  168897 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  168901 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  168905 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  168909 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  168914 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  168918 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  168922 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  168926 */   // MIs[3] Operand 1
     /*  168926 */   // No operand predicates
     /*  168926 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  168928 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (QC_SRH GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  168928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRH),
     /*  168931 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  168933 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  168937 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  168941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  168944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  168951 */   GIR_RootConstrainSelectedInstOperands,
     /*  168952 */   // GIR_Coverage, 64544,
     /*  168952 */   GIR_EraseRootFromParent_Done,
     /*  168953 */ // Label 3187: @168953
     /*  168953 */ GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(169057), // Rule ID 64545 //
     /*  168958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode0),
     /*  168961 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  168964 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  168968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168972 */   // MIs[0] Operand 1
     /*  168972 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  168976 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  168980 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  168984 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  168988 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  168992 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  168997 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  169001 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169005 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169009 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  169013 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169018 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169022 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169026 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169030 */   // MIs[3] Operand 1
     /*  169030 */   // No operand predicates
     /*  169030 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169032 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i64] })<<P:Predicate_uimm3>>:$shamt)
     /*  169032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  169035 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  169037 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  169041 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169045 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169048 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169055 */   GIR_RootConstrainSelectedInstOperands,
     /*  169056 */   // GIR_Coverage, 64545,
     /*  169056 */   GIR_EraseRootFromParent_Done,
     /*  169057 */ // Label 3188: @169057
     /*  169057 */ GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(169161), // Rule ID 64546 //
     /*  169062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcisls_IsRV32_HwMode1),
     /*  169065 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169068 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169076 */   // MIs[0] Operand 1
     /*  169076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  169080 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  169084 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  169088 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  169092 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  169096 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169101 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  169105 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  169109 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  169113 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  169117 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /*  169122 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  169126 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  169130 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm3),
     /*  169134 */   // MIs[3] Operand 1
     /*  169134 */   // No operand predicates
     /*  169134 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  169136 */   // (st GPR:{ *:[i32] }:$rd, (add:{ *:[i32] } GPRMem:{ *:[i32] }:$rs1, (shl:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (QC_SRW GPR:{ *:[i32] }:$rd, GPRMem:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm3>>:$shamt)
     /*  169136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::QC_SRW),
     /*  169139 */   GIR_RootToRootCopy, /*OpIdx*/0, // rd
     /*  169141 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /*  169145 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /*  169149 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // shamt
     /*  169152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /*  169159 */   GIR_RootConstrainSelectedInstOperands,
     /*  169160 */   // GIR_Coverage, 64546,
     /*  169160 */   GIR_EraseRootFromParent_Done,
     /*  169161 */ // Label 3189: @169161
     /*  169161 */ GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(169218), // Rule ID 326 //
     /*  169166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169169 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169179 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169190 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169197 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10095>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169200 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169212 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169216 */   GIR_RootConstrainSelectedInstOperands,
     /*  169217 */   // GIR_Coverage, 326,
     /*  169217 */   GIR_EraseRootFromParent_Done,
     /*  169218 */ // Label 3190: @169218
     /*  169218 */ GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(169275), // Rule ID 328 //
     /*  169223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169226 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169236 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169254 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10097>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169257 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169273 */   GIR_RootConstrainSelectedInstOperands,
     /*  169274 */   // GIR_Coverage, 328,
     /*  169274 */   GIR_EraseRootFromParent_Done,
     /*  169275 */ // Label 3191: @169275
     /*  169275 */ GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(169332), // Rule ID 330 //
     /*  169280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode1),
     /*  169283 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169293 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  169296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169304 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169311 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10099>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169314 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169330 */   GIR_RootConstrainSelectedInstOperands,
     /*  169331 */   // GIR_Coverage, 330,
     /*  169331 */   GIR_EraseRootFromParent_Done,
     /*  169332 */ // Label 3192: @169332
     /*  169332 */ GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(169386), // Rule ID 65024 //
     /*  169337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  169340 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169343 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169354 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169358 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169365 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169368 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169384 */   GIR_RootConstrainSelectedInstOperands,
     /*  169385 */   // GIR_Coverage, 65024,
     /*  169385 */   GIR_EraseRootFromParent_Done,
     /*  169386 */ // Label 3193: @169386
     /*  169386 */ GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(169440), // Rule ID 65025 //
     /*  169391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode1),
     /*  169394 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  169397 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  169404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169408 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169412 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169419 */   // (atomic_store GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169422 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169438 */   GIR_RootConstrainSelectedInstOperands,
     /*  169439 */   // GIR_Coverage, 65025,
     /*  169439 */   GIR_EraseRootFromParent_Done,
     /*  169440 */ // Label 3194: @169440
     /*  169440 */ GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(169498), // Rule ID 239 //
     /*  169445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169448 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169451 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169455 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169466 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169470 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169477 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169480 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169482 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169487 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169492 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169496 */   GIR_RootConstrainSelectedInstOperands,
     /*  169497 */   // GIR_Coverage, 239,
     /*  169497 */   GIR_EraseRootFromParent_Done,
     /*  169498 */ // Label 3195: @169498
     /*  169498 */ GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(169556), // Rule ID 241 //
     /*  169503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169506 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169509 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169513 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  169520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169524 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169528 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169535 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  169538 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169550 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169554 */   GIR_RootConstrainSelectedInstOperands,
     /*  169555 */   // GIR_Coverage, 241,
     /*  169555 */   GIR_EraseRootFromParent_Done,
     /*  169556 */ // Label 3196: @169556
     /*  169556 */ GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(169607), // Rule ID 242 //
     /*  169561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  169564 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169567 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169575 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169579 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169586 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169589 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169596 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169601 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169605 */   GIR_RootConstrainSelectedInstOperands,
     /*  169606 */   // GIR_Coverage, 242,
     /*  169606 */   GIR_EraseRootFromParent_Done,
     /*  169607 */ // Label 3197: @169607
     /*  169607 */ GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(169658), // Rule ID 243 //
     /*  169612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  169615 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169618 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169626 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169630 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169637 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  169640 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169652 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169656 */   GIR_RootConstrainSelectedInstOperands,
     /*  169657 */   // GIR_Coverage, 243,
     /*  169657 */   GIR_EraseRootFromParent_Done,
     /*  169658 */ // Label 3198: @169658
     /*  169658 */ GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(169709), // Rule ID 1329 //
     /*  169663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /*  169666 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169669 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  169677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169688 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  169691 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169707 */   GIR_RootConstrainSelectedInstOperands,
     /*  169708 */   // GIR_Coverage, 1329,
     /*  169708 */   GIR_EraseRootFromParent_Done,
     /*  169709 */ // Label 3199: @169709
     /*  169709 */ GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(169760), // Rule ID 1330 //
     /*  169714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /*  169717 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169720 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  169728 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169732 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169739 */   // (st FPR32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSW FPR32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSW),
     /*  169742 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169744 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169749 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169754 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169758 */   GIR_RootConstrainSelectedInstOperands,
     /*  169759 */   // GIR_Coverage, 1330,
     /*  169759 */   GIR_EraseRootFromParent_Done,
     /*  169760 */ // Label 3200: @169760
     /*  169760 */ GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(169811), // Rule ID 1335 //
     /*  169765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /*  169768 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169771 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  169779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169790 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  169793 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169795 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169800 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169805 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169809 */   GIR_RootConstrainSelectedInstOperands,
     /*  169810 */   // GIR_Coverage, 1335,
     /*  169810 */   GIR_EraseRootFromParent_Done,
     /*  169811 */ // Label 3201: @169811
     /*  169811 */ GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(169862), // Rule ID 1336 //
     /*  169816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /*  169819 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169822 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /*  169830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169834 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169841 */   // (st GPRF32:{ *:[f32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SW_INX GPRF32:{ *:[f32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_INX),
     /*  169844 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169846 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169851 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169856 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169860 */   GIR_RootConstrainSelectedInstOperands,
     /*  169861 */   // GIR_Coverage, 1336,
     /*  169861 */   GIR_EraseRootFromParent_Done,
     /*  169862 */ // Label 3202: @169862
     /*  169862 */ GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(169920), // Rule ID 65030 //
     /*  169867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169899 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  169899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169902 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169914 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169918 */   GIR_RootConstrainSelectedInstOperands,
     /*  169919 */   // GIR_Coverage, 65030,
     /*  169919 */   GIR_EraseRootFromParent_Done,
     /*  169920 */ // Label 3203: @169920
     /*  169920 */ GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(169978), // Rule ID 65031 //
     /*  169925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  169928 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169931 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169935 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  169942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  169946 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  169950 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  169957 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  169957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  169960 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  169962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  169967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  169972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  169976 */   GIR_RootConstrainSelectedInstOperands,
     /*  169977 */   // GIR_Coverage, 65031,
     /*  169977 */   GIR_EraseRootFromParent_Done,
     /*  169978 */ // Label 3204: @169978
     /*  169978 */ GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(170036), // Rule ID 65032 //
     /*  169983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  169986 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  169989 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  169993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170004 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170008 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170015 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170018 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170020 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170025 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170030 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170034 */   GIR_RootConstrainSelectedInstOperands,
     /*  170035 */   // GIR_Coverage, 65032,
     /*  170035 */   GIR_EraseRootFromParent_Done,
     /*  170036 */ // Label 3205: @170036
     /*  170036 */ GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(170094), // Rule ID 65033 //
     /*  170041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode1),
     /*  170044 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170047 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170051 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170062 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170066 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170073 */   // (st GPR:{ *:[i32] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i32] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170076 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170092 */   GIR_RootConstrainSelectedInstOperands,
     /*  170093 */   // GIR_Coverage, 65033,
     /*  170093 */   GIR_EraseRootFromParent_Done,
     /*  170094 */ // Label 3206: @170094
     /*  170094 */ GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(170140), // Rule ID 1106 //
     /*  170099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170102 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170112 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170119 */   // MIs[0] rs1
     /*  170119 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170127 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10599>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170130 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170132 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170138 */   GIR_RootConstrainSelectedInstOperands,
     /*  170139 */   // GIR_Coverage, 1106,
     /*  170139 */   GIR_EraseRootFromParent_Done,
     /*  170140 */ // Label 3207: @170140
     /*  170140 */ GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(170186), // Rule ID 1108 //
     /*  170145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170148 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170151 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170165 */   // MIs[0] rs1
     /*  170165 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170173 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10601>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  170176 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170178 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170184 */   GIR_RootConstrainSelectedInstOperands,
     /*  170185 */   // GIR_Coverage, 1108,
     /*  170185 */   GIR_EraseRootFromParent_Done,
     /*  170186 */ // Label 3208: @170186
     /*  170186 */ GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(170232), // Rule ID 1110 //
     /*  170191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170197 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170204 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170211 */   // MIs[0] rs1
     /*  170211 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170219 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10603>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170222 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170224 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170226 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170230 */   GIR_RootConstrainSelectedInstOperands,
     /*  170231 */   // GIR_Coverage, 1110,
     /*  170231 */   GIR_EraseRootFromParent_Done,
     /*  170232 */ // Label 3209: @170232
     /*  170232 */ GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(170278), // Rule ID 1112 //
     /*  170237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170240 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170243 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170257 */   // MIs[0] rs1
     /*  170257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170265 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10605>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  170268 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170270 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170272 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170276 */   GIR_RootConstrainSelectedInstOperands,
     /*  170277 */   // GIR_Coverage, 1112,
     /*  170277 */   GIR_EraseRootFromParent_Done,
     /*  170278 */ // Label 3210: @170278
     /*  170278 */ GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(170324), // Rule ID 1114 //
     /*  170283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170286 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170289 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170303 */   // MIs[0] rs1
     /*  170303 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170311 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10607>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170314 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170316 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170318 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170322 */   GIR_RootConstrainSelectedInstOperands,
     /*  170323 */   // GIR_Coverage, 1114,
     /*  170323 */   GIR_EraseRootFromParent_Done,
     /*  170324 */ // Label 3211: @170324
     /*  170324 */ GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(170370), // Rule ID 1116 //
     /*  170329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode1),
     /*  170332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170342 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170349 */   // MIs[0] rs1
     /*  170349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170357 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10609>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  170360 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170362 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170364 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170368 */   GIR_RootConstrainSelectedInstOperands,
     /*  170369 */   // GIR_Coverage, 1116,
     /*  170369 */   GIR_EraseRootFromParent_Done,
     /*  170370 */ // Label 3212: @170370
     /*  170370 */ GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(170416), // Rule ID 1134 //
     /*  170375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170378 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170381 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170388 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170395 */   // MIs[0] rs1
     /*  170395 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170403 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10623>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170406 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170408 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170410 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170414 */   GIR_RootConstrainSelectedInstOperands,
     /*  170415 */   // GIR_Coverage, 1134,
     /*  170415 */   GIR_EraseRootFromParent_Done,
     /*  170416 */ // Label 3213: @170416
     /*  170416 */ GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(170462), // Rule ID 1136 //
     /*  170421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode1),
     /*  170424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170427 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170434 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  170437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170441 */   // MIs[0] rs1
     /*  170441 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  170445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170449 */   // (atomic_store GPR:{ *:[i32] }:$rs2, GPRMemZeroOffset:{ *:[i32] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10625>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  170449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  170452 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  170454 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170456 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170460 */   GIR_RootConstrainSelectedInstOperands,
     /*  170461 */   // GIR_Coverage, 1136,
     /*  170461 */   GIR_EraseRootFromParent_Done,
     /*  170462 */ // Label 3214: @170462
     /*  170462 */ GIM_Reject,
     /*  170463 */ // Label 3129: @170463
     /*  170463 */ GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(170520), // Rule ID 325 //
     /*  170468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170471 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170474 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170481 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170488 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170492 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170499 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10095>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170502 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170504 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170514 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170518 */   GIR_RootConstrainSelectedInstOperands,
     /*  170519 */   // GIR_Coverage, 325,
     /*  170519 */   GIR_EraseRootFromParent_Done,
     /*  170520 */ // Label 3215: @170520
     /*  170520 */ GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(170577), // Rule ID 327 //
     /*  170525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170528 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170538 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170556 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10097>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170559 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170561 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170571 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170575 */   GIR_RootConstrainSelectedInstOperands,
     /*  170576 */   // GIR_Coverage, 327,
     /*  170576 */   GIR_EraseRootFromParent_Done,
     /*  170577 */ // Label 3216: @170577
     /*  170577 */ GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(170634), // Rule ID 329 //
     /*  170582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_HwMode0),
     /*  170585 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170588 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170595 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170613 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10099>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170616 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170623 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170628 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170632 */   GIR_RootConstrainSelectedInstOperands,
     /*  170633 */   // GIR_Coverage, 329,
     /*  170633 */   GIR_EraseRootFromParent_Done,
     /*  170634 */ // Label 3217: @170634
     /*  170634 */ GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(170691), // Rule ID 340 //
     /*  170639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAtomicLdSt_IsRV64_HwMode0),
     /*  170642 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  170645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  170652 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  170655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170659 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170663 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170670 */   // (atomic_store GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10109>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  170673 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170685 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170689 */   GIR_RootConstrainSelectedInstOperands,
     /*  170690 */   // GIR_Coverage, 340,
     /*  170690 */   GIR_EraseRootFromParent_Done,
     /*  170691 */ // Label 3218: @170691
     /*  170691 */ GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(170749), // Rule ID 238 //
     /*  170696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170699 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170702 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170706 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  170713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170728 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (SB GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB),
     /*  170731 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170733 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170738 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170743 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170747 */   GIR_RootConstrainSelectedInstOperands,
     /*  170748 */   // GIR_Coverage, 238,
     /*  170748 */   GIR_EraseRootFromParent_Done,
     /*  170749 */ // Label 3219: @170749
     /*  170749 */ GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(170807), // Rule ID 240 //
     /*  170754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  170757 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170760 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170764 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  170771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170786 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (SH GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH),
     /*  170789 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170805 */   GIR_RootConstrainSelectedInstOperands,
     /*  170806 */   // GIR_Coverage, 240,
     /*  170806 */   GIR_EraseRootFromParent_Done,
     /*  170807 */ // Label 3220: @170807
     /*  170807 */ GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(170865), // Rule ID 279 //
     /*  170812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170815 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170818 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170822 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  170829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170833 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170837 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170844 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (SW GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW),
     /*  170847 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170863 */   GIR_RootConstrainSelectedInstOperands,
     /*  170864 */   // GIR_Coverage, 279,
     /*  170864 */   GIR_EraseRootFromParent_Done,
     /*  170865 */ // Label 3221: @170865
     /*  170865 */ GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(170916), // Rule ID 280 //
     /*  170870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /*  170873 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  170884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170888 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170895 */   // (st GPR:{ *:[i64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[i64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  170898 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170914 */   GIR_RootConstrainSelectedInstOperands,
     /*  170915 */   // GIR_Coverage, 280,
     /*  170915 */   GIR_EraseRootFromParent_Done,
     /*  170916 */ // Label 3222: @170916
     /*  170916 */ GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(170967), // Rule ID 1727 //
     /*  170921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /*  170924 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170927 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  170935 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170939 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170946 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  170946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  170949 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  170951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  170956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  170961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  170965 */   GIR_RootConstrainSelectedInstOperands,
     /*  170966 */   // GIR_Coverage, 1727,
     /*  170966 */   GIR_EraseRootFromParent_Done,
     /*  170967 */ // Label 3223: @170967
     /*  170967 */ GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(171018), // Rule ID 1728 //
     /*  170972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /*  170975 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  170978 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  170982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  170986 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  170990 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  170997 */   // (st FPR64:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (FSD FPR64:{ *:[f64] }:$rs2, GPRMem:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /*  170997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSD),
     /*  171000 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171002 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171012 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171016 */   GIR_RootConstrainSelectedInstOperands,
     /*  171017 */   // GIR_Coverage, 1728,
     /*  171017 */   GIR_EraseRootFromParent_Done,
     /*  171018 */ // Label 3224: @171018
     /*  171018 */ GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(171069), // Rule ID 1731 //
     /*  171023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /*  171026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171029 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIAddrRegImm),
     /*  171048 */   // (st GPR:{ *:[f64] }:$rs2, (AddrRegImm:{ *:[iPTR] } GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (SD GPR:{ *:[f64] }:$rs2, GPRMem:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /*  171048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD),
     /*  171051 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /*  171058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // imm12
     /*  171063 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171067 */   GIR_RootConstrainSelectedInstOperands,
     /*  171068 */   // GIR_Coverage, 1731,
     /*  171068 */   GIR_EraseRootFromParent_Done,
     /*  171069 */ // Label 3225: @171069
     /*  171069 */ GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(171115), // Rule ID 1105 //
     /*  171074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171077 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171080 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171087 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171094 */   // MIs[0] rs1
     /*  171094 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171102 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10599>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171105 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171107 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171109 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171113 */   GIR_RootConstrainSelectedInstOperands,
     /*  171114 */   // GIR_Coverage, 1105,
     /*  171114 */   GIR_EraseRootFromParent_Done,
     /*  171115 */ // Label 3226: @171115
     /*  171115 */ GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(171161), // Rule ID 1107 //
     /*  171120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171123 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171126 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  171133 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171140 */   // MIs[0] rs1
     /*  171140 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171148 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_10601>>  =>  (SB_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SB_RL),
     /*  171151 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171153 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171155 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171159 */   GIR_RootConstrainSelectedInstOperands,
     /*  171160 */   // GIR_Coverage, 1107,
     /*  171160 */   GIR_EraseRootFromParent_Done,
     /*  171161 */ // Label 3227: @171161
     /*  171161 */ GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(171207), // Rule ID 1109 //
     /*  171166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171169 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171186 */   // MIs[0] rs1
     /*  171186 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171194 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10603>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171197 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171199 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171201 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171205 */   GIR_RootConstrainSelectedInstOperands,
     /*  171206 */   // GIR_Coverage, 1109,
     /*  171206 */   GIR_EraseRootFromParent_Done,
     /*  171207 */ // Label 3228: @171207
     /*  171207 */ GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(171253), // Rule ID 1111 //
     /*  171212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171215 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171218 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  171225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171232 */   // MIs[0] rs1
     /*  171232 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171240 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_10605>>  =>  (SH_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SH_RL),
     /*  171243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171245 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171251 */   GIR_RootConstrainSelectedInstOperands,
     /*  171252 */   // GIR_Coverage, 1111,
     /*  171252 */   GIR_EraseRootFromParent_Done,
     /*  171253 */ // Label 3229: @171253
     /*  171253 */ GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(171299), // Rule ID 1113 //
     /*  171258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171261 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171264 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171271 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171278 */   // MIs[0] rs1
     /*  171278 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171286 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10607>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171289 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171291 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171297 */   GIR_RootConstrainSelectedInstOperands,
     /*  171298 */   // GIR_Coverage, 1113,
     /*  171298 */   GIR_EraseRootFromParent_Done,
     /*  171299 */ // Label 3230: @171299
     /*  171299 */ GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(171345), // Rule ID 1115 //
     /*  171304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_HwMode0),
     /*  171307 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171310 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  171317 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171324 */   // MIs[0] rs1
     /*  171324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171332 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_10609>>  =>  (SW_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SW_RL),
     /*  171335 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171337 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171343 */   GIR_RootConstrainSelectedInstOperands,
     /*  171344 */   // GIR_Coverage, 1115,
     /*  171344 */   GIR_EraseRootFromParent_Done,
     /*  171345 */ // Label 3231: @171345
     /*  171345 */ GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(171391), // Rule ID 1133 //
     /*  171350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171353 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171356 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  171366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171370 */   // MIs[0] rs1
     /*  171370 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171378 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10623>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171383 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171385 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171389 */   GIR_RootConstrainSelectedInstOperands,
     /*  171390 */   // GIR_Coverage, 1133,
     /*  171390 */   GIR_EraseRootFromParent_Done,
     /*  171391 */ // Label 3232: @171391
     /*  171391 */ GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(171437), // Rule ID 1135 //
     /*  171396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZalasr_IsRV64_HwMode0),
     /*  171399 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  171402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  171409 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  171412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171416 */   // MIs[0] rs1
     /*  171416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171420 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171424 */   // (atomic_store GPR:{ *:[i64] }:$rs2, GPRMemZeroOffset:{ *:[i64] }:$rs1)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_10625>>  =>  (SD_RL GPRMemZeroOffset:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  171424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SD_RL),
     /*  171427 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171429 */   GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171431 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171435 */   GIR_RootConstrainSelectedInstOperands,
     /*  171436 */   // GIR_Coverage, 1135,
     /*  171436 */   GIR_EraseRootFromParent_Done,
     /*  171437 */ // Label 3233: @171437
     /*  171437 */ GIM_Reject,
     /*  171438 */ // Label 3130: @171438
     /*  171438 */ GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(171517),
     /*  171443 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171446 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171454 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  171458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171462 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(171489), // Rule ID 45622 //
     /*  171467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171470 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  171470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  171473 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  171483 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171487 */     GIR_RootConstrainSelectedInstOperands,
     /*  171488 */     // GIR_Coverage, 45622,
     /*  171488 */     GIR_EraseRootFromParent_Done,
     /*  171489 */   // Label 3235: @171489
     /*  171489 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(171516), // Rule ID 45623 //
     /*  171494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171497 */     // (st VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B64 VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  171497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B64),
     /*  171500 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  171510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171514 */     GIR_RootConstrainSelectedInstOperands,
     /*  171515 */     // GIR_Coverage, 45623,
     /*  171515 */     GIR_EraseRootFromParent_Done,
     /*  171516 */   // Label 3236: @171516
     /*  171516 */   GIM_Reject,
     /*  171517 */ // Label 3234: @171517
     /*  171517 */ GIM_Reject,
     /*  171518 */ // Label 3131: @171518
     /*  171518 */ GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(171605),
     /*  171523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171534 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(171569), // Rule ID 45618 //
     /*  171539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171542 */     // MIs[0] rs1
     /*  171542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171550 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  171550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  171553 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171563 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171567 */     GIR_RootConstrainSelectedInstOperands,
     /*  171568 */     // GIR_Coverage, 45618,
     /*  171568 */     GIR_EraseRootFromParent_Done,
     /*  171569 */   // Label 3238: @171569
     /*  171569 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(171604), // Rule ID 45619 //
     /*  171574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171577 */     // MIs[0] rs1
     /*  171577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171585 */     // (st VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF8 VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  171585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF8),
     /*  171588 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  171598 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171602 */     GIR_RootConstrainSelectedInstOperands,
     /*  171603 */     // GIR_Coverage, 45619,
     /*  171603 */     GIR_EraseRootFromParent_Done,
     /*  171604 */   // Label 3239: @171604
     /*  171604 */   GIM_Reject,
     /*  171605 */ // Label 3237: @171605
     /*  171605 */ GIM_Reject,
     /*  171606 */ // Label 3132: @171606
     /*  171606 */ GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(171763),
     /*  171611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171622 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(171657), // Rule ID 45814 //
     /*  171627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171630 */     // MIs[0] rs1
     /*  171630 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171638 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  171638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  171641 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171655 */     GIR_RootConstrainSelectedInstOperands,
     /*  171656 */     // GIR_Coverage, 45814,
     /*  171656 */     GIR_EraseRootFromParent_Done,
     /*  171657 */   // Label 3241: @171657
     /*  171657 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(171692), // Rule ID 45815 //
     /*  171662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171665 */     // MIs[0] rs1
     /*  171665 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171673 */     // (st VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  171673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  171676 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171690 */     GIR_RootConstrainSelectedInstOperands,
     /*  171691 */     // GIR_Coverage, 45815,
     /*  171691 */     GIR_EraseRootFromParent_Done,
     /*  171692 */   // Label 3242: @171692
     /*  171692 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(171727), // Rule ID 45890 //
     /*  171697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  171700 */     // MIs[0] rs1
     /*  171700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171708 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  171708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  171711 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171725 */     GIR_RootConstrainSelectedInstOperands,
     /*  171726 */     // GIR_Coverage, 45890,
     /*  171726 */     GIR_EraseRootFromParent_Done,
     /*  171727 */   // Label 3243: @171727
     /*  171727 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(171762), // Rule ID 45891 //
     /*  171732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  171735 */     // MIs[0] rs1
     /*  171735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171743 */     // (st VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF4 VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  171743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF4),
     /*  171746 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  171756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171760 */     GIR_RootConstrainSelectedInstOperands,
     /*  171761 */     // GIR_Coverage, 45891,
     /*  171761 */     GIR_EraseRootFromParent_Done,
     /*  171762 */   // Label 3244: @171762
     /*  171762 */   GIM_Reject,
     /*  171763 */ // Label 3240: @171763
     /*  171763 */ GIM_Reject,
     /*  171764 */ // Label 3133: @171764
     /*  171764 */ GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(171921),
     /*  171769 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171772 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171780 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(171815), // Rule ID 45822 //
     /*  171785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  171788 */     // MIs[0] rs1
     /*  171788 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171796 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  171796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  171799 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171809 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171813 */     GIR_RootConstrainSelectedInstOperands,
     /*  171814 */     // GIR_Coverage, 45822,
     /*  171814 */     GIR_EraseRootFromParent_Done,
     /*  171815 */   // Label 3246: @171815
     /*  171815 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(171850), // Rule ID 45823 //
     /*  171820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  171823 */     // MIs[0] rs1
     /*  171823 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171831 */     // (st VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  171831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  171834 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171848 */     GIR_RootConstrainSelectedInstOperands,
     /*  171849 */     // GIR_Coverage, 45823,
     /*  171849 */     GIR_EraseRootFromParent_Done,
     /*  171850 */   // Label 3247: @171850
     /*  171850 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(171885), // Rule ID 45898 //
     /*  171855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  171858 */     // MIs[0] rs1
     /*  171858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171866 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  171866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  171869 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171883 */     GIR_RootConstrainSelectedInstOperands,
     /*  171884 */     // GIR_Coverage, 45898,
     /*  171884 */     GIR_EraseRootFromParent_Done,
     /*  171885 */   // Label 3248: @171885
     /*  171885 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(171920), // Rule ID 45899 //
     /*  171890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  171893 */     // MIs[0] rs1
     /*  171893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171901 */     // (st VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_MF2 VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  171901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_MF2),
     /*  171904 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  171914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171918 */     GIR_RootConstrainSelectedInstOperands,
     /*  171919 */     // GIR_Coverage, 45899,
     /*  171919 */     GIR_EraseRootFromParent_Done,
     /*  171920 */   // Label 3249: @171920
     /*  171920 */   GIM_Reject,
     /*  171921 */ // Label 3245: @171921
     /*  171921 */ GIM_Reject,
     /*  171922 */ // Label 3134: @171922
     /*  171922 */ GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(172079),
     /*  171927 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  171930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  171934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  171938 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(171973), // Rule ID 45838 //
     /*  171943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  171946 */     // MIs[0] rs1
     /*  171946 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  171950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171954 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  171954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  171957 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  171967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  171971 */     GIR_RootConstrainSelectedInstOperands,
     /*  171972 */     // GIR_Coverage, 45838,
     /*  171972 */     GIR_EraseRootFromParent_Done,
     /*  171973 */   // Label 3251: @171973
     /*  171973 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(172008), // Rule ID 45839 //
     /*  171978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  171981 */     // MIs[0] rs1
     /*  171981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  171985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  171989 */     // (st VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  171989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  171992 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  171994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  171996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  171999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172006 */     GIR_RootConstrainSelectedInstOperands,
     /*  172007 */     // GIR_Coverage, 45839,
     /*  172007 */     GIR_EraseRootFromParent_Done,
     /*  172008 */   // Label 3252: @172008
     /*  172008 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(172043), // Rule ID 45910 //
     /*  172013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172016 */     // MIs[0] rs1
     /*  172016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172024 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172027 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172041 */     GIR_RootConstrainSelectedInstOperands,
     /*  172042 */     // GIR_Coverage, 45910,
     /*  172042 */     GIR_EraseRootFromParent_Done,
     /*  172043 */   // Label 3253: @172043
     /*  172043 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(172078), // Rule ID 45911 //
     /*  172048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  172051 */     // MIs[0] rs1
     /*  172051 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172059 */     // (st VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M1 VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M1),
     /*  172062 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172064 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172072 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172076 */     GIR_RootConstrainSelectedInstOperands,
     /*  172077 */     // GIR_Coverage, 45911,
     /*  172077 */     GIR_EraseRootFromParent_Done,
     /*  172078 */   // Label 3254: @172078
     /*  172078 */   GIM_Reject,
     /*  172079 */ // Label 3250: @172079
     /*  172079 */ GIM_Reject,
     /*  172080 */ // Label 3135: @172080
     /*  172080 */ GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(172159),
     /*  172085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172104 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(172131), // Rule ID 45950 //
     /*  172109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172112 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172115 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172129 */     GIR_RootConstrainSelectedInstOperands,
     /*  172130 */     // GIR_Coverage, 45950,
     /*  172130 */     GIR_EraseRootFromParent_Done,
     /*  172131 */   // Label 3256: @172131
     /*  172131 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(172158), // Rule ID 45951 //
     /*  172136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172139 */     // (st VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B32 VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B32),
     /*  172142 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172156 */     GIR_RootConstrainSelectedInstOperands,
     /*  172157 */     // GIR_Coverage, 45951,
     /*  172157 */     GIR_EraseRootFromParent_Done,
     /*  172158 */   // Label 3257: @172158
     /*  172158 */   GIM_Reject,
     /*  172159 */ // Label 3255: @172159
     /*  172159 */ GIM_Reject,
     /*  172160 */ // Label 3136: @172160
     /*  172160 */ GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(172247),
     /*  172165 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172168 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172176 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(172211), // Rule ID 45806 //
     /*  172181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172184 */     // MIs[0] rs1
     /*  172184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172192 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172195 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172209 */     GIR_RootConstrainSelectedInstOperands,
     /*  172210 */     // GIR_Coverage, 45806,
     /*  172210 */     GIR_EraseRootFromParent_Done,
     /*  172211 */   // Label 3259: @172211
     /*  172211 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(172246), // Rule ID 45807 //
     /*  172216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172219 */     // MIs[0] rs1
     /*  172219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172227 */     // (st VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF4 VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF4),
     /*  172230 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172244 */     GIR_RootConstrainSelectedInstOperands,
     /*  172245 */     // GIR_Coverage, 45807,
     /*  172245 */     GIR_EraseRootFromParent_Done,
     /*  172246 */   // Label 3260: @172246
     /*  172246 */   GIM_Reject,
     /*  172247 */ // Label 3258: @172247
     /*  172247 */ GIM_Reject,
     /*  172248 */ // Label 3137: @172248
     /*  172248 */ GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(172405),
     /*  172253 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172256 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172264 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(172299), // Rule ID 45818 //
     /*  172269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172272 */     // MIs[0] rs1
     /*  172272 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172280 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172283 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172293 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172297 */     GIR_RootConstrainSelectedInstOperands,
     /*  172298 */     // GIR_Coverage, 45818,
     /*  172298 */     GIR_EraseRootFromParent_Done,
     /*  172299 */   // Label 3262: @172299
     /*  172299 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(172334), // Rule ID 45819 //
     /*  172304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172307 */     // MIs[0] rs1
     /*  172307 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172315 */     // (st VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172318 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172332 */     GIR_RootConstrainSelectedInstOperands,
     /*  172333 */     // GIR_Coverage, 45819,
     /*  172333 */     GIR_EraseRootFromParent_Done,
     /*  172334 */   // Label 3263: @172334
     /*  172334 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(172369), // Rule ID 45894 //
     /*  172339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172342 */     // MIs[0] rs1
     /*  172342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172350 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172353 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172367 */     GIR_RootConstrainSelectedInstOperands,
     /*  172368 */     // GIR_Coverage, 45894,
     /*  172368 */     GIR_EraseRootFromParent_Done,
     /*  172369 */   // Label 3264: @172369
     /*  172369 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(172404), // Rule ID 45895 //
     /*  172374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  172377 */     // MIs[0] rs1
     /*  172377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172385 */     // (st VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_MF2 VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_MF2),
     /*  172388 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172402 */     GIR_RootConstrainSelectedInstOperands,
     /*  172403 */     // GIR_Coverage, 45895,
     /*  172403 */     GIR_EraseRootFromParent_Done,
     /*  172404 */   // Label 3265: @172404
     /*  172404 */   GIM_Reject,
     /*  172405 */ // Label 3261: @172405
     /*  172405 */ GIM_Reject,
     /*  172406 */ // Label 3138: @172406
     /*  172406 */ GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(172563),
     /*  172411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172414 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172422 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(172457), // Rule ID 45834 //
     /*  172427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172430 */     // MIs[0] rs1
     /*  172430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172438 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172441 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172455 */     GIR_RootConstrainSelectedInstOperands,
     /*  172456 */     // GIR_Coverage, 45834,
     /*  172456 */     GIR_EraseRootFromParent_Done,
     /*  172457 */   // Label 3267: @172457
     /*  172457 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(172492), // Rule ID 45835 //
     /*  172462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172465 */     // MIs[0] rs1
     /*  172465 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172473 */     // (st VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172476 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172490 */     GIR_RootConstrainSelectedInstOperands,
     /*  172491 */     // GIR_Coverage, 45835,
     /*  172491 */     GIR_EraseRootFromParent_Done,
     /*  172492 */   // Label 3268: @172492
     /*  172492 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(172527), // Rule ID 45906 //
     /*  172497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  172500 */     // MIs[0] rs1
     /*  172500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172508 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  172508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172511 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172525 */     GIR_RootConstrainSelectedInstOperands,
     /*  172526 */     // GIR_Coverage, 45906,
     /*  172526 */     GIR_EraseRootFromParent_Done,
     /*  172527 */   // Label 3269: @172527
     /*  172527 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(172562), // Rule ID 45907 //
     /*  172532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  172535 */     // MIs[0] rs1
     /*  172535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172543 */     // (st VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M1 VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  172543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M1),
     /*  172546 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  172556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172560 */     GIR_RootConstrainSelectedInstOperands,
     /*  172561 */     // GIR_Coverage, 45907,
     /*  172561 */     GIR_EraseRootFromParent_Done,
     /*  172562 */   // Label 3270: @172562
     /*  172562 */   GIM_Reject,
     /*  172563 */ // Label 3266: @172563
     /*  172563 */ GIM_Reject,
     /*  172564 */ // Label 3139: @172564
     /*  172564 */ GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(172721),
     /*  172569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172572 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  172580 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(172615), // Rule ID 45878 //
     /*  172585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  172588 */     // MIs[0] rs1
     /*  172588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172596 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  172599 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172609 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172613 */     GIR_RootConstrainSelectedInstOperands,
     /*  172614 */     // GIR_Coverage, 45878,
     /*  172614 */     GIR_EraseRootFromParent_Done,
     /*  172615 */   // Label 3272: @172615
     /*  172615 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(172650), // Rule ID 45879 //
     /*  172620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  172623 */     // MIs[0] rs1
     /*  172623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172631 */     // (st VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  172634 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172636 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172648 */     GIR_RootConstrainSelectedInstOperands,
     /*  172649 */     // GIR_Coverage, 45879,
     /*  172649 */     GIR_EraseRootFromParent_Done,
     /*  172650 */   // Label 3273: @172650
     /*  172650 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(172685), // Rule ID 45938 //
     /*  172655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  172658 */     // MIs[0] rs1
     /*  172658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172666 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  172666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  172669 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172683 */     GIR_RootConstrainSelectedInstOperands,
     /*  172684 */     // GIR_Coverage, 45938,
     /*  172684 */     GIR_EraseRootFromParent_Done,
     /*  172685 */   // Label 3274: @172685
     /*  172685 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(172720), // Rule ID 45939 //
     /*  172690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  172693 */     // MIs[0] rs1
     /*  172693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172701 */     // (st VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M2 VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  172701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M2),
     /*  172704 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172706 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  172714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172718 */     GIR_RootConstrainSelectedInstOperands,
     /*  172719 */     // GIR_Coverage, 45939,
     /*  172719 */     GIR_EraseRootFromParent_Done,
     /*  172720 */   // Label 3275: @172720
     /*  172720 */   GIM_Reject,
     /*  172721 */ // Label 3271: @172721
     /*  172721 */ GIM_Reject,
     /*  172722 */ // Label 3140: @172722
     /*  172722 */ GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(172801),
     /*  172727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  172742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172746 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(172773), // Rule ID 45954 //
     /*  172751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172754 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  172754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  172757 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172771 */     GIR_RootConstrainSelectedInstOperands,
     /*  172772 */     // GIR_Coverage, 45954,
     /*  172772 */     GIR_EraseRootFromParent_Done,
     /*  172773 */   // Label 3277: @172773
     /*  172773 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(172800), // Rule ID 45955 //
     /*  172778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172781 */     // (st VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B16 VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  172781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B16),
     /*  172784 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  172794 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172798 */     GIR_RootConstrainSelectedInstOperands,
     /*  172799 */     // GIR_Coverage, 45955,
     /*  172799 */     GIR_EraseRootFromParent_Done,
     /*  172800 */   // Label 3278: @172800
     /*  172800 */   GIM_Reject,
     /*  172801 */ // Label 3276: @172801
     /*  172801 */ GIM_Reject,
     /*  172802 */ // Label 3141: @172802
     /*  172802 */ GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(172889),
     /*  172807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172810 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172818 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(172853), // Rule ID 45810 //
     /*  172823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172826 */     // MIs[0] rs1
     /*  172826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172834 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  172834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  172837 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172851 */     GIR_RootConstrainSelectedInstOperands,
     /*  172852 */     // GIR_Coverage, 45810,
     /*  172852 */     GIR_EraseRootFromParent_Done,
     /*  172853 */   // Label 3280: @172853
     /*  172853 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(172888), // Rule ID 45811 //
     /*  172858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172861 */     // MIs[0] rs1
     /*  172861 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172869 */     // (st VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_MF2 VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  172869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_MF2),
     /*  172872 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  172882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172886 */     GIR_RootConstrainSelectedInstOperands,
     /*  172887 */     // GIR_Coverage, 45811,
     /*  172887 */     GIR_EraseRootFromParent_Done,
     /*  172888 */   // Label 3281: @172888
     /*  172888 */   GIM_Reject,
     /*  172889 */ // Label 3279: @172889
     /*  172889 */ GIM_Reject,
     /*  172890 */ // Label 3142: @172890
     /*  172890 */ GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(173047),
     /*  172895 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  172898 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  172902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  172906 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(172941), // Rule ID 45830 //
     /*  172911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  172914 */     // MIs[0] rs1
     /*  172914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172922 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  172925 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172939 */     GIR_RootConstrainSelectedInstOperands,
     /*  172940 */     // GIR_Coverage, 45830,
     /*  172940 */     GIR_EraseRootFromParent_Done,
     /*  172941 */   // Label 3283: @172941
     /*  172941 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(172976), // Rule ID 45831 //
     /*  172946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  172949 */     // MIs[0] rs1
     /*  172949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  172953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172957 */     // (st VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  172957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  172960 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  172967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  172970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  172974 */     GIR_RootConstrainSelectedInstOperands,
     /*  172975 */     // GIR_Coverage, 45831,
     /*  172975 */     GIR_EraseRootFromParent_Done,
     /*  172976 */   // Label 3284: @172976
     /*  172976 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(173011), // Rule ID 45902 //
     /*  172981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  172984 */     // MIs[0] rs1
     /*  172984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  172988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  172992 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  172992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  172995 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  172997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  172999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173009 */     GIR_RootConstrainSelectedInstOperands,
     /*  173010 */     // GIR_Coverage, 45902,
     /*  173010 */     GIR_EraseRootFromParent_Done,
     /*  173011 */   // Label 3285: @173011
     /*  173011 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(173046), // Rule ID 45903 //
     /*  173016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173019 */     // MIs[0] rs1
     /*  173019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173027 */     // (st VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M1 VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M1),
     /*  173030 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173044 */     GIR_RootConstrainSelectedInstOperands,
     /*  173045 */     // GIR_Coverage, 45903,
     /*  173045 */     GIR_EraseRootFromParent_Done,
     /*  173046 */   // Label 3286: @173046
     /*  173046 */   GIM_Reject,
     /*  173047 */ // Label 3282: @173047
     /*  173047 */ GIM_Reject,
     /*  173048 */ // Label 3143: @173048
     /*  173048 */ GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(173205),
     /*  173053 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173056 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173064 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(173099), // Rule ID 45866 //
     /*  173069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173072 */     // MIs[0] rs1
     /*  173072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173080 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173083 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173097 */     GIR_RootConstrainSelectedInstOperands,
     /*  173098 */     // GIR_Coverage, 45866,
     /*  173098 */     GIR_EraseRootFromParent_Done,
     /*  173099 */   // Label 3288: @173099
     /*  173099 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(173134), // Rule ID 45867 //
     /*  173104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173107 */     // MIs[0] rs1
     /*  173107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173115 */     // (st VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173118 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173132 */     GIR_RootConstrainSelectedInstOperands,
     /*  173133 */     // GIR_Coverage, 45867,
     /*  173133 */     GIR_EraseRootFromParent_Done,
     /*  173134 */   // Label 3289: @173134
     /*  173134 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(173169), // Rule ID 45926 //
     /*  173139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173142 */     // MIs[0] rs1
     /*  173142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173150 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173153 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173167 */     GIR_RootConstrainSelectedInstOperands,
     /*  173168 */     // GIR_Coverage, 45926,
     /*  173168 */     GIR_EraseRootFromParent_Done,
     /*  173169 */   // Label 3290: @173169
     /*  173169 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(173204), // Rule ID 45927 //
     /*  173174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173177 */     // MIs[0] rs1
     /*  173177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173185 */     // (st VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M2 VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M2),
     /*  173188 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173202 */     GIR_RootConstrainSelectedInstOperands,
     /*  173203 */     // GIR_Coverage, 45927,
     /*  173203 */     GIR_EraseRootFromParent_Done,
     /*  173204 */   // Label 3291: @173204
     /*  173204 */   GIM_Reject,
     /*  173205 */ // Label 3287: @173205
     /*  173205 */ GIM_Reject,
     /*  173206 */ // Label 3144: @173206
     /*  173206 */ GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(173363),
     /*  173211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173214 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173222 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(173257), // Rule ID 45882 //
     /*  173227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173230 */     // MIs[0] rs1
     /*  173230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173238 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173241 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173251 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173255 */     GIR_RootConstrainSelectedInstOperands,
     /*  173256 */     // GIR_Coverage, 45882,
     /*  173256 */     GIR_EraseRootFromParent_Done,
     /*  173257 */   // Label 3293: @173257
     /*  173257 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(173292), // Rule ID 45883 //
     /*  173262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173265 */     // MIs[0] rs1
     /*  173265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173273 */     // (st VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173276 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173290 */     GIR_RootConstrainSelectedInstOperands,
     /*  173291 */     // GIR_Coverage, 45883,
     /*  173291 */     GIR_EraseRootFromParent_Done,
     /*  173292 */   // Label 3294: @173292
     /*  173292 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(173327), // Rule ID 45942 //
     /*  173297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173300 */     // MIs[0] rs1
     /*  173300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173308 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173311 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173325 */     GIR_RootConstrainSelectedInstOperands,
     /*  173326 */     // GIR_Coverage, 45942,
     /*  173326 */     GIR_EraseRootFromParent_Done,
     /*  173327 */   // Label 3295: @173327
     /*  173327 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(173362), // Rule ID 45943 //
     /*  173332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173335 */     // MIs[0] rs1
     /*  173335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173343 */     // (st VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M4 VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M4),
     /*  173346 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173356 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173360 */     GIR_RootConstrainSelectedInstOperands,
     /*  173361 */     // GIR_Coverage, 45943,
     /*  173361 */     GIR_EraseRootFromParent_Done,
     /*  173362 */   // Label 3296: @173362
     /*  173362 */   GIM_Reject,
     /*  173363 */ // Label 3292: @173363
     /*  173363 */ GIM_Reject,
     /*  173364 */ // Label 3145: @173364
     /*  173364 */ GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(173443),
     /*  173369 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173372 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173380 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  173384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173388 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(173415), // Rule ID 45958 //
     /*  173393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173396 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  173396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173399 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173413 */     GIR_RootConstrainSelectedInstOperands,
     /*  173414 */     // GIR_Coverage, 45958,
     /*  173414 */     GIR_EraseRootFromParent_Done,
     /*  173415 */   // Label 3298: @173415
     /*  173415 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(173442), // Rule ID 45959 //
     /*  173420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173423 */     // (st VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B8 VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  173423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B8),
     /*  173426 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  173436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173440 */     GIR_RootConstrainSelectedInstOperands,
     /*  173441 */     // GIR_Coverage, 45959,
     /*  173441 */     GIR_EraseRootFromParent_Done,
     /*  173442 */   // Label 3299: @173442
     /*  173442 */   GIM_Reject,
     /*  173443 */ // Label 3297: @173443
     /*  173443 */ GIM_Reject,
     /*  173444 */ // Label 3146: @173444
     /*  173444 */ GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(173531),
     /*  173449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  173460 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(173495), // Rule ID 45826 //
     /*  173465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173468 */     // MIs[0] rs1
     /*  173468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173476 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  173476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  173479 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173489 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173493 */     GIR_RootConstrainSelectedInstOperands,
     /*  173494 */     // GIR_Coverage, 45826,
     /*  173494 */     GIR_EraseRootFromParent_Done,
     /*  173495 */   // Label 3301: @173495
     /*  173495 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(173530), // Rule ID 45827 //
     /*  173500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173503 */     // MIs[0] rs1
     /*  173503 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173507 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173511 */     // (st VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M1 VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  173511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M1),
     /*  173514 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  173524 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173528 */     GIR_RootConstrainSelectedInstOperands,
     /*  173529 */     // GIR_Coverage, 45827,
     /*  173529 */     GIR_EraseRootFromParent_Done,
     /*  173530 */   // Label 3302: @173530
     /*  173530 */   GIM_Reject,
     /*  173531 */ // Label 3300: @173531
     /*  173531 */ GIM_Reject,
     /*  173532 */ // Label 3147: @173532
     /*  173532 */ GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(173689),
     /*  173537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173540 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  173548 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(173583), // Rule ID 45854 //
     /*  173553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173556 */     // MIs[0] rs1
     /*  173556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173564 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  173567 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173577 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173581 */     GIR_RootConstrainSelectedInstOperands,
     /*  173582 */     // GIR_Coverage, 45854,
     /*  173582 */     GIR_EraseRootFromParent_Done,
     /*  173583 */   // Label 3304: @173583
     /*  173583 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(173618), // Rule ID 45855 //
     /*  173588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173591 */     // MIs[0] rs1
     /*  173591 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173599 */     // (st VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  173602 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173616 */     GIR_RootConstrainSelectedInstOperands,
     /*  173617 */     // GIR_Coverage, 45855,
     /*  173617 */     GIR_EraseRootFromParent_Done,
     /*  173618 */   // Label 3305: @173618
     /*  173618 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(173653), // Rule ID 45914 //
     /*  173623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  173626 */     // MIs[0] rs1
     /*  173626 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173634 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  173634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  173637 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173651 */     GIR_RootConstrainSelectedInstOperands,
     /*  173652 */     // GIR_Coverage, 45914,
     /*  173652 */     GIR_EraseRootFromParent_Done,
     /*  173653 */   // Label 3306: @173653
     /*  173653 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(173688), // Rule ID 45915 //
     /*  173658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  173661 */     // MIs[0] rs1
     /*  173661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173669 */     // (st VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M2 VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  173669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M2),
     /*  173672 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  173682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173686 */     GIR_RootConstrainSelectedInstOperands,
     /*  173687 */     // GIR_Coverage, 45915,
     /*  173687 */     GIR_EraseRootFromParent_Done,
     /*  173688 */   // Label 3307: @173688
     /*  173688 */   GIM_Reject,
     /*  173689 */ // Label 3303: @173689
     /*  173689 */ GIM_Reject,
     /*  173690 */ // Label 3148: @173690
     /*  173690 */ GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(173847),
     /*  173695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173698 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  173706 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(173741), // Rule ID 45870 //
     /*  173711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  173714 */     // MIs[0] rs1
     /*  173714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173722 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  173725 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173739 */     GIR_RootConstrainSelectedInstOperands,
     /*  173740 */     // GIR_Coverage, 45870,
     /*  173740 */     GIR_EraseRootFromParent_Done,
     /*  173741 */   // Label 3309: @173741
     /*  173741 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(173776), // Rule ID 45871 //
     /*  173746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  173749 */     // MIs[0] rs1
     /*  173749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173757 */     // (st VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  173760 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173774 */     GIR_RootConstrainSelectedInstOperands,
     /*  173775 */     // GIR_Coverage, 45871,
     /*  173775 */     GIR_EraseRootFromParent_Done,
     /*  173776 */   // Label 3310: @173776
     /*  173776 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(173811), // Rule ID 45930 //
     /*  173781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  173784 */     // MIs[0] rs1
     /*  173784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173792 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  173792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  173795 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173805 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173809 */     GIR_RootConstrainSelectedInstOperands,
     /*  173810 */     // GIR_Coverage, 45930,
     /*  173810 */     GIR_EraseRootFromParent_Done,
     /*  173811 */   // Label 3311: @173811
     /*  173811 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(173846), // Rule ID 45931 //
     /*  173816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  173819 */     // MIs[0] rs1
     /*  173819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173827 */     // (st VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M4 VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  173827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M4),
     /*  173830 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173832 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  173840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173844 */     GIR_RootConstrainSelectedInstOperands,
     /*  173845 */     // GIR_Coverage, 45931,
     /*  173845 */     GIR_EraseRootFromParent_Done,
     /*  173846 */   // Label 3312: @173846
     /*  173846 */   GIM_Reject,
     /*  173847 */ // Label 3308: @173847
     /*  173847 */ GIM_Reject,
     /*  173848 */ // Label 3149: @173848
     /*  173848 */ GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(174005),
     /*  173853 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  173856 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  173860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  173864 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(173899), // Rule ID 45886 //
     /*  173869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  173872 */     // MIs[0] rs1
     /*  173872 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173876 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173880 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  173883 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173893 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173897 */     GIR_RootConstrainSelectedInstOperands,
     /*  173898 */     // GIR_Coverage, 45886,
     /*  173898 */     GIR_EraseRootFromParent_Done,
     /*  173899 */   // Label 3314: @173899
     /*  173899 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(173934), // Rule ID 45887 //
     /*  173904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  173907 */     // MIs[0] rs1
     /*  173907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173915 */     // (st VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  173918 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173932 */     GIR_RootConstrainSelectedInstOperands,
     /*  173933 */     // GIR_Coverage, 45887,
     /*  173933 */     GIR_EraseRootFromParent_Done,
     /*  173934 */   // Label 3315: @173934
     /*  173934 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(173969), // Rule ID 45946 //
     /*  173939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  173942 */     // MIs[0] rs1
     /*  173942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  173946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173950 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] })
     /*  173950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  173953 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  173967 */     GIR_RootConstrainSelectedInstOperands,
     /*  173968 */     // GIR_Coverage, 45946,
     /*  173968 */     GIR_EraseRootFromParent_Done,
     /*  173969 */   // Label 3316: @173969
     /*  173969 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(174004), // Rule ID 45947 //
     /*  173974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  173977 */     // MIs[0] rs1
     /*  173977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  173981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  173985 */     // (st VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE64_V_M8 VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] })
     /*  173985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE64_V_M8),
     /*  173988 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  173990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  173992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  173995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  173998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174002 */     GIR_RootConstrainSelectedInstOperands,
     /*  174003 */     // GIR_Coverage, 45947,
     /*  174003 */     GIR_EraseRootFromParent_Done,
     /*  174004 */   // Label 3317: @174004
     /*  174004 */   GIM_Reject,
     /*  174005 */ // Label 3313: @174005
     /*  174005 */ GIM_Reject,
     /*  174006 */ // Label 3150: @174006
     /*  174006 */ GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(174085),
     /*  174011 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174014 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174022 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174030 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(174057), // Rule ID 45962 //
     /*  174035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174038 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174041 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174055 */     GIR_RootConstrainSelectedInstOperands,
     /*  174056 */     // GIR_Coverage, 45962,
     /*  174056 */     GIR_EraseRootFromParent_Done,
     /*  174057 */   // Label 3319: @174057
     /*  174057 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(174084), // Rule ID 45963 //
     /*  174062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174065 */     // (st VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B4 VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B4),
     /*  174068 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174078 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174082 */     GIR_RootConstrainSelectedInstOperands,
     /*  174083 */     // GIR_Coverage, 45963,
     /*  174083 */     GIR_EraseRootFromParent_Done,
     /*  174084 */   // Label 3320: @174084
     /*  174084 */   GIM_Reject,
     /*  174085 */ // Label 3318: @174085
     /*  174085 */ GIM_Reject,
     /*  174086 */ // Label 3151: @174086
     /*  174086 */ GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(174173),
     /*  174091 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174094 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  174102 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(174137), // Rule ID 45842 //
     /*  174107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174110 */     // MIs[0] rs1
     /*  174110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174118 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174121 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174135 */     GIR_RootConstrainSelectedInstOperands,
     /*  174136 */     // GIR_Coverage, 45842,
     /*  174136 */     GIR_EraseRootFromParent_Done,
     /*  174137 */   // Label 3322: @174137
     /*  174137 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(174172), // Rule ID 45843 //
     /*  174142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174145 */     // MIs[0] rs1
     /*  174145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174153 */     // (st VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M2 VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M2),
     /*  174156 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174170 */     GIR_RootConstrainSelectedInstOperands,
     /*  174171 */     // GIR_Coverage, 45843,
     /*  174171 */     GIR_EraseRootFromParent_Done,
     /*  174172 */   // Label 3323: @174172
     /*  174172 */   GIM_Reject,
     /*  174173 */ // Label 3321: @174173
     /*  174173 */ GIM_Reject,
     /*  174174 */ // Label 3152: @174174
     /*  174174 */ GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(174331),
     /*  174179 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174182 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174190 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(174225), // Rule ID 45858 //
     /*  174195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174198 */     // MIs[0] rs1
     /*  174198 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174206 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174209 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174223 */     GIR_RootConstrainSelectedInstOperands,
     /*  174224 */     // GIR_Coverage, 45858,
     /*  174224 */     GIR_EraseRootFromParent_Done,
     /*  174225 */   // Label 3325: @174225
     /*  174225 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(174260), // Rule ID 45859 //
     /*  174230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174233 */     // MIs[0] rs1
     /*  174233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174241 */     // (st VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174244 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174258 */     GIR_RootConstrainSelectedInstOperands,
     /*  174259 */     // GIR_Coverage, 45859,
     /*  174259 */     GIR_EraseRootFromParent_Done,
     /*  174260 */   // Label 3326: @174260
     /*  174260 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(174295), // Rule ID 45918 //
     /*  174265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174268 */     // MIs[0] rs1
     /*  174268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174276 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174279 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174293 */     GIR_RootConstrainSelectedInstOperands,
     /*  174294 */     // GIR_Coverage, 45918,
     /*  174294 */     GIR_EraseRootFromParent_Done,
     /*  174295 */   // Label 3327: @174295
     /*  174295 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(174330), // Rule ID 45919 //
     /*  174300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174303 */     // MIs[0] rs1
     /*  174303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174311 */     // (st VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M4 VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M4),
     /*  174314 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174328 */     GIR_RootConstrainSelectedInstOperands,
     /*  174329 */     // GIR_Coverage, 45919,
     /*  174329 */     GIR_EraseRootFromParent_Done,
     /*  174330 */   // Label 3328: @174330
     /*  174330 */   GIM_Reject,
     /*  174331 */ // Label 3324: @174331
     /*  174331 */ GIM_Reject,
     /*  174332 */ // Label 3153: @174332
     /*  174332 */ GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(174489),
     /*  174337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174348 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(174383), // Rule ID 45874 //
     /*  174353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174356 */     // MIs[0] rs1
     /*  174356 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174364 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174367 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174381 */     GIR_RootConstrainSelectedInstOperands,
     /*  174382 */     // GIR_Coverage, 45874,
     /*  174382 */     GIR_EraseRootFromParent_Done,
     /*  174383 */   // Label 3330: @174383
     /*  174383 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(174418), // Rule ID 45875 //
     /*  174388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174391 */     // MIs[0] rs1
     /*  174391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174399 */     // (st VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174402 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174416 */     GIR_RootConstrainSelectedInstOperands,
     /*  174417 */     // GIR_Coverage, 45875,
     /*  174417 */     GIR_EraseRootFromParent_Done,
     /*  174418 */   // Label 3331: @174418
     /*  174418 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(174453), // Rule ID 45934 //
     /*  174423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  174426 */     // MIs[0] rs1
     /*  174426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174434 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] })
     /*  174434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174437 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174451 */     GIR_RootConstrainSelectedInstOperands,
     /*  174452 */     // GIR_Coverage, 45934,
     /*  174452 */     GIR_EraseRootFromParent_Done,
     /*  174453 */   // Label 3332: @174453
     /*  174453 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(174488), // Rule ID 45935 //
     /*  174458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  174461 */     // MIs[0] rs1
     /*  174461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174469 */     // (st VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE32_V_M8 VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] })
     /*  174469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE32_V_M8),
     /*  174472 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  174482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174486 */     GIR_RootConstrainSelectedInstOperands,
     /*  174487 */     // GIR_Coverage, 45935,
     /*  174487 */     GIR_EraseRootFromParent_Done,
     /*  174488 */   // Label 3333: @174488
     /*  174488 */   GIM_Reject,
     /*  174489 */ // Label 3329: @174489
     /*  174489 */ GIM_Reject,
     /*  174490 */ // Label 3154: @174490
     /*  174490 */ GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(174569),
     /*  174495 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174498 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174506 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174514 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(174541), // Rule ID 45966 //
     /*  174519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174522 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  174525 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174535 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174539 */     GIR_RootConstrainSelectedInstOperands,
     /*  174540 */     // GIR_Coverage, 45966,
     /*  174540 */     GIR_EraseRootFromParent_Done,
     /*  174541 */   // Label 3335: @174541
     /*  174541 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(174568), // Rule ID 45967 //
     /*  174546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174549 */     // (st VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B2 VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B2),
     /*  174552 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174566 */     GIR_RootConstrainSelectedInstOperands,
     /*  174567 */     // GIR_Coverage, 45967,
     /*  174567 */     GIR_EraseRootFromParent_Done,
     /*  174568 */   // Label 3336: @174568
     /*  174568 */   GIM_Reject,
     /*  174569 */ // Label 3334: @174569
     /*  174569 */ GIM_Reject,
     /*  174570 */ // Label 3155: @174570
     /*  174570 */ GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(174657),
     /*  174575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  174586 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(174621), // Rule ID 45846 //
     /*  174591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174594 */     // MIs[0] rs1
     /*  174594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174602 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  174605 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174619 */     GIR_RootConstrainSelectedInstOperands,
     /*  174620 */     // GIR_Coverage, 45846,
     /*  174620 */     GIR_EraseRootFromParent_Done,
     /*  174621 */   // Label 3338: @174621
     /*  174621 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(174656), // Rule ID 45847 //
     /*  174626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174629 */     // MIs[0] rs1
     /*  174629 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174637 */     // (st VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M4 VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M4),
     /*  174640 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174650 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174654 */     GIR_RootConstrainSelectedInstOperands,
     /*  174655 */     // GIR_Coverage, 45847,
     /*  174655 */     GIR_EraseRootFromParent_Done,
     /*  174656 */   // Label 3339: @174656
     /*  174656 */   GIM_Reject,
     /*  174657 */ // Label 3337: @174657
     /*  174657 */ GIM_Reject,
     /*  174658 */ // Label 3156: @174658
     /*  174658 */ GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(174815),
     /*  174663 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174666 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174674 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(174709), // Rule ID 45862 //
     /*  174679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174682 */     // MIs[0] rs1
     /*  174682 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174690 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  174693 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174703 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174707 */     GIR_RootConstrainSelectedInstOperands,
     /*  174708 */     // GIR_Coverage, 45862,
     /*  174708 */     GIR_EraseRootFromParent_Done,
     /*  174709 */   // Label 3341: @174709
     /*  174709 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(174744), // Rule ID 45863 //
     /*  174714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174717 */     // MIs[0] rs1
     /*  174717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174725 */     // (st VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  174728 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174742 */     GIR_RootConstrainSelectedInstOperands,
     /*  174743 */     // GIR_Coverage, 45863,
     /*  174743 */     GIR_EraseRootFromParent_Done,
     /*  174744 */   // Label 3342: @174744
     /*  174744 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(174779), // Rule ID 45922 //
     /*  174749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  174752 */     // MIs[0] rs1
     /*  174752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174760 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] })
     /*  174760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  174763 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174777 */     GIR_RootConstrainSelectedInstOperands,
     /*  174778 */     // GIR_Coverage, 45922,
     /*  174778 */     GIR_EraseRootFromParent_Done,
     /*  174779 */   // Label 3343: @174779
     /*  174779 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(174814), // Rule ID 45923 //
     /*  174784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  174787 */     // MIs[0] rs1
     /*  174787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174795 */     // (st VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE16_V_M8 VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] })
     /*  174795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE16_V_M8),
     /*  174798 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  174808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174812 */     GIR_RootConstrainSelectedInstOperands,
     /*  174813 */     // GIR_Coverage, 45923,
     /*  174813 */     GIR_EraseRootFromParent_Done,
     /*  174814 */   // Label 3344: @174814
     /*  174814 */   GIM_Reject,
     /*  174815 */ // Label 3340: @174815
     /*  174815 */ GIM_Reject,
     /*  174816 */ // Label 3157: @174816
     /*  174816 */ GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(174895),
     /*  174821 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174824 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  174832 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  174836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174840 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(174867), // Rule ID 45970 //
     /*  174845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174848 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i64] }, 0:{ *:[i64] })
     /*  174848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  174851 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174865 */     GIR_RootConstrainSelectedInstOperands,
     /*  174866 */     // GIR_Coverage, 45970,
     /*  174866 */     GIR_EraseRootFromParent_Done,
     /*  174867 */   // Label 3346: @174867
     /*  174867 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(174894), // Rule ID 45971 //
     /*  174872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174875 */     // (st VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSM_V_B1 VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[iPTR] }:$rs1, -1:{ *:[i32] }, 0:{ *:[i32] })
     /*  174875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM_V_B1),
     /*  174878 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  174888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174892 */     GIR_RootConstrainSelectedInstOperands,
     /*  174893 */     // GIR_Coverage, 45971,
     /*  174893 */     GIR_EraseRootFromParent_Done,
     /*  174894 */   // Label 3347: @174894
     /*  174894 */   GIM_Reject,
     /*  174895 */ // Label 3345: @174895
     /*  174895 */ GIM_Reject,
     /*  174896 */ // Label 3158: @174896
     /*  174896 */ GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(174983),
     /*  174901 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  174904 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  174908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  174912 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(174947), // Rule ID 45850 //
     /*  174917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  174920 */     // MIs[0] rs1
     /*  174920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  174924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174928 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] })
     /*  174928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  174931 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174945 */     GIR_RootConstrainSelectedInstOperands,
     /*  174946 */     // GIR_Coverage, 45850,
     /*  174946 */     GIR_EraseRootFromParent_Done,
     /*  174947 */   // Label 3349: @174947
     /*  174947 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(174982), // Rule ID 45851 //
     /*  174952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  174955 */     // MIs[0] rs1
     /*  174955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  174959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  174963 */     // (st VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (PseudoVSE8_V_M8 VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] })
     /*  174963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSE8_V_M8),
     /*  174966 */     GIR_RootToRootCopy, /*OpIdx*/0, // rs2
     /*  174968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /*  174970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /*  174973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  174976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  174980 */     GIR_RootConstrainSelectedInstOperands,
     /*  174981 */     // GIR_Coverage, 45851,
     /*  174981 */     GIR_EraseRootFromParent_Done,
     /*  174982 */   // Label 3350: @174982
     /*  174982 */   GIM_Reject,
     /*  174983 */ // Label 3348: @174983
     /*  174983 */ GIM_Reject,
     /*  174984 */ // Label 3159: @174984
     /*  174984 */ GIM_Reject,
     /*  174985 */ // Label 25: @174985
     /*  174985 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3353*/ GIMT_Encode4(179870),
     /*  174996 */ /*GILLT_s32*//*Label 3351*/ GIMT_Encode4(175004),
     /*  175000 */ /*GILLT_s64*//*Label 3352*/ GIMT_Encode4(176997),
     /*  175004 */ // Label 3351: @175004
     /*  175004 */ GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(176996),
     /*  175009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  175012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  175015 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(175081), // Rule ID 643 //
     /*  175020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175023 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175030 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175037 */     // MIs[0] addr
     /*  175037 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175053 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 2:{ *:[i32] })
     /*  175053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175061 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175066 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175068 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175070 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  175075 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175079 */     GIR_RootConstrainSelectedInstOperands,
     /*  175080 */     // GIR_Coverage, 643,
     /*  175080 */     GIR_EraseRootFromParent_Done,
     /*  175081 */   // Label 3355: @175081
     /*  175081 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(175147), // Rule ID 645 //
     /*  175086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175103 */     // MIs[0] addr
     /*  175103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175119 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 4:{ *:[i32] })
     /*  175119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175127 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175132 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175134 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175136 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  175141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175145 */     GIR_RootConstrainSelectedInstOperands,
     /*  175146 */     // GIR_Coverage, 645,
     /*  175146 */     GIR_EraseRootFromParent_Done,
     /*  175147 */   // Label 3356: @175147
     /*  175147 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(175213), // Rule ID 647 //
     /*  175152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175169 */     // MIs[0] addr
     /*  175169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175185 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 5:{ *:[i32] })
     /*  175185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175193 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175198 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175200 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175202 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  175207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175211 */     GIR_RootConstrainSelectedInstOperands,
     /*  175212 */     // GIR_Coverage, 647,
     /*  175212 */     GIR_EraseRootFromParent_Done,
     /*  175213 */   // Label 3357: @175213
     /*  175213 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(175279), // Rule ID 649 //
     /*  175218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  175231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175235 */     // MIs[0] addr
     /*  175235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175251 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 6:{ *:[i32] })
     /*  175251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175259 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175264 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175266 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175268 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  175273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175277 */     GIR_RootConstrainSelectedInstOperands,
     /*  175278 */     // GIR_Coverage, 649,
     /*  175278 */     GIR_EraseRootFromParent_Done,
     /*  175279 */   // Label 3358: @175279
     /*  175279 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(175345), // Rule ID 651 //
     /*  175284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode1),
     /*  175287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175301 */     // MIs[0] addr
     /*  175301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  175305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175317 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new, 7:{ *:[i32] })
     /*  175317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  175320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  175323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  175325 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  175330 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175332 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175334 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  175339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175343 */     GIR_RootConstrainSelectedInstOperands,
     /*  175344 */     // GIR_Coverage, 651,
     /*  175344 */     GIR_EraseRootFromParent_Done,
     /*  175345 */   // Label 3359: @175345
     /*  175345 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(175400), // Rule ID 660 //
     /*  175350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175353 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175360 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175367 */     // MIs[0] addr
     /*  175367 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175383 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175388 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175390 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175392 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175394 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175398 */     GIR_RootConstrainSelectedInstOperands,
     /*  175399 */     // GIR_Coverage, 660,
     /*  175399 */     GIR_EraseRootFromParent_Done,
     /*  175400 */   // Label 3360: @175400
     /*  175400 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(175455), // Rule ID 662 //
     /*  175405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175408 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175415 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175422 */     // MIs[0] addr
     /*  175422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175438 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  175441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175443 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175445 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175447 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175453 */     GIR_RootConstrainSelectedInstOperands,
     /*  175454 */     // GIR_Coverage, 662,
     /*  175454 */     GIR_EraseRootFromParent_Done,
     /*  175455 */   // Label 3361: @175455
     /*  175455 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(175510), // Rule ID 664 //
     /*  175460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175463 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175477 */     // MIs[0] addr
     /*  175477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175493 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  175496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175498 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175500 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175502 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175508 */     GIR_RootConstrainSelectedInstOperands,
     /*  175509 */     // GIR_Coverage, 664,
     /*  175509 */     GIR_EraseRootFromParent_Done,
     /*  175510 */   // Label 3362: @175510
     /*  175510 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(175565), // Rule ID 666 //
     /*  175515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  175528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175532 */     // MIs[0] addr
     /*  175532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175548 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  175551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175553 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175555 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175557 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175563 */     GIR_RootConstrainSelectedInstOperands,
     /*  175564 */     // GIR_Coverage, 666,
     /*  175564 */     GIR_EraseRootFromParent_Done,
     /*  175565 */   // Label 3363: @175565
     /*  175565 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(175620), // Rule ID 668 //
     /*  175570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175587 */     // MIs[0] addr
     /*  175587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175603 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  175606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175608 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175610 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175612 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175618 */     GIR_RootConstrainSelectedInstOperands,
     /*  175619 */     // GIR_Coverage, 668,
     /*  175619 */     GIR_EraseRootFromParent_Done,
     /*  175620 */   // Label 3364: @175620
     /*  175620 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(175675), // Rule ID 670 //
     /*  175625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  175628 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175642 */     // MIs[0] addr
     /*  175642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175658 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175663 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175665 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175667 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175673 */     GIR_RootConstrainSelectedInstOperands,
     /*  175674 */     // GIR_Coverage, 670,
     /*  175674 */     GIR_EraseRootFromParent_Done,
     /*  175675 */   // Label 3365: @175675
     /*  175675 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(175730), // Rule ID 672 //
     /*  175680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  175683 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175697 */     // MIs[0] addr
     /*  175697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175713 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175718 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175720 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175722 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175724 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175728 */     GIR_RootConstrainSelectedInstOperands,
     /*  175729 */     // GIR_Coverage, 672,
     /*  175729 */     GIR_EraseRootFromParent_Done,
     /*  175730 */   // Label 3366: @175730
     /*  175730 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(175785), // Rule ID 674 //
     /*  175735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  175738 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175745 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  175748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175752 */     // MIs[0] addr
     /*  175752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175768 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175773 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175775 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175777 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175783 */     GIR_RootConstrainSelectedInstOperands,
     /*  175784 */     // GIR_Coverage, 674,
     /*  175784 */     GIR_EraseRootFromParent_Done,
     /*  175785 */   // Label 3367: @175785
     /*  175785 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(175840), // Rule ID 676 //
     /*  175790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  175793 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  175803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175807 */     // MIs[0] addr
     /*  175807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175823 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175828 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175830 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175832 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175834 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175838 */     GIR_RootConstrainSelectedInstOperands,
     /*  175839 */     // GIR_Coverage, 676,
     /*  175839 */     GIR_EraseRootFromParent_Done,
     /*  175840 */   // Label 3368: @175840
     /*  175840 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(175895), // Rule ID 678 //
     /*  175845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  175848 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  175855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  175858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175862 */     // MIs[0] addr
     /*  175862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175878 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  175881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175883 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175885 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175887 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175893 */     GIR_RootConstrainSelectedInstOperands,
     /*  175894 */     // GIR_Coverage, 678,
     /*  175894 */     GIR_EraseRootFromParent_Done,
     /*  175895 */   // Label 3369: @175895
     /*  175895 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(175950), // Rule ID 1050 //
     /*  175900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  175913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175917 */     // MIs[0] addr
     /*  175917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175933 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  175936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175938 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175940 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175942 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  175948 */     GIR_RootConstrainSelectedInstOperands,
     /*  175949 */     // GIR_Coverage, 1050,
     /*  175949 */     GIR_EraseRootFromParent_Done,
     /*  175950 */   // Label 3370: @175950
     /*  175950 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(176005), // Rule ID 1052 //
     /*  175955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  175958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  175965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  175968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175972 */     // MIs[0] addr
     /*  175972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  175976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  175988 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  175988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  175991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  175993 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  175995 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  175997 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  175999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176003 */     GIR_RootConstrainSelectedInstOperands,
     /*  176004 */     // GIR_Coverage, 1052,
     /*  176004 */     GIR_EraseRootFromParent_Done,
     /*  176005 */   // Label 3371: @176005
     /*  176005 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(176060), // Rule ID 1054 //
     /*  176010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176027 */     // MIs[0] addr
     /*  176027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176043 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  176046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176048 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176050 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176052 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176058 */     GIR_RootConstrainSelectedInstOperands,
     /*  176059 */     // GIR_Coverage, 1054,
     /*  176059 */     GIR_EraseRootFromParent_Done,
     /*  176060 */   // Label 3372: @176060
     /*  176060 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(176115), // Rule ID 1056 //
     /*  176065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176068 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176075 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176082 */     // MIs[0] addr
     /*  176082 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176086 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176098 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176103 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176105 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176107 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176113 */     GIR_RootConstrainSelectedInstOperands,
     /*  176114 */     // GIR_Coverage, 1056,
     /*  176114 */     GIR_EraseRootFromParent_Done,
     /*  176115 */   // Label 3373: @176115
     /*  176115 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(176170), // Rule ID 1058 //
     /*  176120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176137 */     // MIs[0] addr
     /*  176137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176153 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  176156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176158 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176160 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176162 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176168 */     GIR_RootConstrainSelectedInstOperands,
     /*  176169 */     // GIR_Coverage, 1058,
     /*  176169 */     GIR_EraseRootFromParent_Done,
     /*  176170 */   // Label 3374: @176170
     /*  176170 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(176225), // Rule ID 1060 //
     /*  176175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176192 */     // MIs[0] addr
     /*  176192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176208 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176213 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176215 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176217 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176223 */     GIR_RootConstrainSelectedInstOperands,
     /*  176224 */     // GIR_Coverage, 1060,
     /*  176224 */     GIR_EraseRootFromParent_Done,
     /*  176225 */   // Label 3375: @176225
     /*  176225 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(176280), // Rule ID 1062 //
     /*  176230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176247 */     // MIs[0] addr
     /*  176247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176263 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176268 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176270 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176272 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176274 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176278 */     GIR_RootConstrainSelectedInstOperands,
     /*  176279 */     // GIR_Coverage, 1062,
     /*  176279 */     GIR_EraseRootFromParent_Done,
     /*  176280 */   // Label 3376: @176280
     /*  176280 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(176335), // Rule ID 1064 //
     /*  176285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176288 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176295 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176302 */     // MIs[0] addr
     /*  176302 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176318 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176323 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176325 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176327 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176333 */     GIR_RootConstrainSelectedInstOperands,
     /*  176334 */     // GIR_Coverage, 1064,
     /*  176334 */     GIR_EraseRootFromParent_Done,
     /*  176335 */   // Label 3377: @176335
     /*  176335 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(176390), // Rule ID 1066 //
     /*  176340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176357 */     // MIs[0] addr
     /*  176357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176373 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176378 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176380 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176382 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176388 */     GIR_RootConstrainSelectedInstOperands,
     /*  176389 */     // GIR_Coverage, 1066,
     /*  176389 */     GIR_EraseRootFromParent_Done,
     /*  176390 */   // Label 3378: @176390
     /*  176390 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(176445), // Rule ID 1068 //
     /*  176395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  176405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176412 */     // MIs[0] addr
     /*  176412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176428 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  176431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176433 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176435 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176437 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176443 */     GIR_RootConstrainSelectedInstOperands,
     /*  176444 */     // GIR_Coverage, 1068,
     /*  176444 */     GIR_EraseRootFromParent_Done,
     /*  176445 */   // Label 3379: @176445
     /*  176445 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(176500), // Rule ID 1070 //
     /*  176450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176467 */     // MIs[0] addr
     /*  176467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176483 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176488 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176490 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176492 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176498 */     GIR_RootConstrainSelectedInstOperands,
     /*  176499 */     // GIR_Coverage, 1070,
     /*  176499 */     GIR_EraseRootFromParent_Done,
     /*  176500 */   // Label 3380: @176500
     /*  176500 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(176555), // Rule ID 1072 //
     /*  176505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176522 */     // MIs[0] addr
     /*  176522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176538 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  176541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176543 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176545 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176547 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176549 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176553 */     GIR_RootConstrainSelectedInstOperands,
     /*  176554 */     // GIR_Coverage, 1072,
     /*  176554 */     GIR_EraseRootFromParent_Done,
     /*  176555 */   // Label 3381: @176555
     /*  176555 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(176610), // Rule ID 1074 //
     /*  176560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176563 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176570 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176577 */     // MIs[0] addr
     /*  176577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176593 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  176596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176598 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176600 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176602 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176608 */     GIR_RootConstrainSelectedInstOperands,
     /*  176609 */     // GIR_Coverage, 1074,
     /*  176609 */     GIR_EraseRootFromParent_Done,
     /*  176610 */   // Label 3382: @176610
     /*  176610 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(176665), // Rule ID 1076 //
     /*  176615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176632 */     // MIs[0] addr
     /*  176632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176648 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  176651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176653 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176655 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176657 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176659 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176663 */     GIR_RootConstrainSelectedInstOperands,
     /*  176664 */     // GIR_Coverage, 1076,
     /*  176664 */     GIR_EraseRootFromParent_Done,
     /*  176665 */   // Label 3383: @176665
     /*  176665 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(176720), // Rule ID 1078 //
     /*  176670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode1),
     /*  176673 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176680 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176687 */     // MIs[0] addr
     /*  176687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176703 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  176706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176708 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176710 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176712 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176718 */     GIR_RootConstrainSelectedInstOperands,
     /*  176719 */     // GIR_Coverage, 1078,
     /*  176719 */     GIR_EraseRootFromParent_Done,
     /*  176720 */   // Label 3384: @176720
     /*  176720 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(176775), // Rule ID 1080 //
     /*  176725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  176738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176742 */     // MIs[0] addr
     /*  176742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176758 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176763 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176765 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176767 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176769 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176773 */     GIR_RootConstrainSelectedInstOperands,
     /*  176774 */     // GIR_Coverage, 1080,
     /*  176774 */     GIR_EraseRootFromParent_Done,
     /*  176775 */   // Label 3385: @176775
     /*  176775 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(176830), // Rule ID 1082 //
     /*  176780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176783 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176790 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  176793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176797 */     // MIs[0] addr
     /*  176797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176813 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176818 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176820 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176822 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176824 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176828 */     GIR_RootConstrainSelectedInstOperands,
     /*  176829 */     // GIR_Coverage, 1082,
     /*  176829 */     GIR_EraseRootFromParent_Done,
     /*  176830 */   // Label 3386: @176830
     /*  176830 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(176885), // Rule ID 1084 //
     /*  176835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  176848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176852 */     // MIs[0] addr
     /*  176852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176868 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176873 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176875 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176877 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176883 */     GIR_RootConstrainSelectedInstOperands,
     /*  176884 */     // GIR_Coverage, 1084,
     /*  176884 */     GIR_EraseRootFromParent_Done,
     /*  176885 */   // Label 3387: @176885
     /*  176885 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(176940), // Rule ID 1086 //
     /*  176890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  176903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176907 */     // MIs[0] addr
     /*  176907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176923 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176928 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176930 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176932 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176938 */     GIR_RootConstrainSelectedInstOperands,
     /*  176939 */     // GIR_Coverage, 1086,
     /*  176939 */     GIR_EraseRootFromParent_Done,
     /*  176940 */   // Label 3388: @176940
     /*  176940 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(176995), // Rule ID 1088 //
     /*  176945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode1),
     /*  176948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  176955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  176958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176962 */     // MIs[0] addr
     /*  176962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  176966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  176978 */     // (atomic_cmp_swap:{ *:[i32] } GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i32] } GPR:{ *:[i32] }:$cmp, GPR:{ *:[i32] }:$addr, GPR:{ *:[i32] }:$new)
     /*  176978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  176981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  176983 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  176985 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  176987 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  176989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  176993 */     GIR_RootConstrainSelectedInstOperands,
     /*  176994 */     // GIR_Coverage, 1088,
     /*  176994 */     GIR_EraseRootFromParent_Done,
     /*  176995 */   // Label 3389: @176995
     /*  176995 */   GIM_Reject,
     /*  176996 */ // Label 3354: @176996
     /*  176996 */ GIM_Reject,
     /*  176997 */ // Label 3352: @176997
     /*  176997 */ GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(179869),
     /*  177002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  177005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  177008 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(177074), // Rule ID 642 //
     /*  177013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177030 */     // MIs[0] addr
     /*  177030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177046 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177054 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177059 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177061 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177063 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177072 */     GIR_RootConstrainSelectedInstOperands,
     /*  177073 */     // GIR_Coverage, 642,
     /*  177073 */     GIR_EraseRootFromParent_Done,
     /*  177074 */   // Label 3391: @177074
     /*  177074 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(177140), // Rule ID 644 //
     /*  177079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177096 */     // MIs[0] addr
     /*  177096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177112 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177120 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177125 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177127 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177129 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177138 */     GIR_RootConstrainSelectedInstOperands,
     /*  177139 */     // GIR_Coverage, 644,
     /*  177139 */     GIR_EraseRootFromParent_Done,
     /*  177140 */   // Label 3392: @177140
     /*  177140 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(177206), // Rule ID 646 //
     /*  177145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177162 */     // MIs[0] addr
     /*  177162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177178 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  177178 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177186 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177191 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177193 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177195 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177204 */     GIR_RootConstrainSelectedInstOperands,
     /*  177205 */     // GIR_Coverage, 646,
     /*  177205 */     GIR_EraseRootFromParent_Done,
     /*  177206 */   // Label 3393: @177206
     /*  177206 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(177272), // Rule ID 648 //
     /*  177211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177214 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177221 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177228 */     // MIs[0] addr
     /*  177228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177244 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  177244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177252 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177257 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177259 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177261 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177270 */     GIR_RootConstrainSelectedInstOperands,
     /*  177271 */     // GIR_Coverage, 648,
     /*  177271 */     GIR_EraseRootFromParent_Done,
     /*  177272 */   // Label 3394: @177272
     /*  177272 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(177338), // Rule ID 650 //
     /*  177277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NoStdExtZacas_HwMode0),
     /*  177280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177294 */     // MIs[0] addr
     /*  177294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177310 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (PseudoCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  177310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg32),
     /*  177316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177318 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177323 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177325 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177327 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  177332 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177336 */     GIR_RootConstrainSelectedInstOperands,
     /*  177337 */     // GIR_Coverage, 650,
     /*  177337 */     GIR_EraseRootFromParent_Done,
     /*  177338 */   // Label 3395: @177338
     /*  177338 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(177404), // Rule ID 652 //
     /*  177343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177360 */     // MIs[0] addr
     /*  177360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177376 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 2:{ *:[i64] })
     /*  177376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177384 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177389 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177391 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177393 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  177398 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177402 */     GIR_RootConstrainSelectedInstOperands,
     /*  177403 */     // GIR_Coverage, 652,
     /*  177403 */     GIR_EraseRootFromParent_Done,
     /*  177404 */   // Label 3396: @177404
     /*  177404 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(177470), // Rule ID 653 //
     /*  177409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177426 */     // MIs[0] addr
     /*  177426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177442 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 4:{ *:[i64] })
     /*  177442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177450 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177455 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177457 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177459 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  177464 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177468 */     GIR_RootConstrainSelectedInstOperands,
     /*  177469 */     // GIR_Coverage, 653,
     /*  177469 */     GIR_EraseRootFromParent_Done,
     /*  177470 */   // Label 3397: @177470
     /*  177470 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(177536), // Rule ID 654 //
     /*  177475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177478 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177492 */     // MIs[0] addr
     /*  177492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177508 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 5:{ *:[i64] })
     /*  177508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177516 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177521 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177523 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177525 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  177530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177534 */     GIR_RootConstrainSelectedInstOperands,
     /*  177535 */     // GIR_Coverage, 654,
     /*  177535 */     GIR_EraseRootFromParent_Done,
     /*  177536 */   // Label 3398: @177536
     /*  177536 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(177602), // Rule ID 655 //
     /*  177541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177558 */     // MIs[0] addr
     /*  177558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177574 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 6:{ *:[i64] })
     /*  177574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177582 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177587 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177589 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177591 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  177596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177600 */     GIR_RootConstrainSelectedInstOperands,
     /*  177601 */     // GIR_Coverage, 655,
     /*  177601 */     GIR_EraseRootFromParent_Done,
     /*  177602 */   // Label 3399: @177602
     /*  177602 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(177668), // Rule ID 656 //
     /*  177607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NoStdExtZacas_HwMode0),
     /*  177610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  177617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177624 */     // MIs[0] addr
     /*  177624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  177628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177640 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (PseudoCmpXchg64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new, 7:{ *:[i64] })
     /*  177640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  177643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCmpXchg64),
     /*  177646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  177648 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  177653 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177655 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177657 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  177662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177666 */     GIR_RootConstrainSelectedInstOperands,
     /*  177667 */     // GIR_Coverage, 656,
     /*  177667 */     GIR_EraseRootFromParent_Done,
     /*  177668 */   // Label 3400: @177668
     /*  177668 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(177723), // Rule ID 659 //
     /*  177673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  177676 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177683 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177690 */     // MIs[0] addr
     /*  177690 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177706 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  177709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177711 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177713 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177715 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177721 */     GIR_RootConstrainSelectedInstOperands,
     /*  177722 */     // GIR_Coverage, 659,
     /*  177722 */     GIR_EraseRootFromParent_Done,
     /*  177723 */   // Label 3401: @177723
     /*  177723 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(177778), // Rule ID 661 //
     /*  177728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  177731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  177741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177745 */     // MIs[0] addr
     /*  177745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177761 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ),
     /*  177764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177766 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177768 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177770 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177776 */     GIR_RootConstrainSelectedInstOperands,
     /*  177777 */     // GIR_Coverage, 661,
     /*  177777 */     GIR_EraseRootFromParent_Done,
     /*  177778 */   // Label 3402: @177778
     /*  177778 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(177833), // Rule ID 663 //
     /*  177783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  177786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  177796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177800 */     // MIs[0] addr
     /*  177800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177816 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_RL),
     /*  177819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177821 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177823 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177825 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177831 */     GIR_RootConstrainSelectedInstOperands,
     /*  177832 */     // GIR_Coverage, 663,
     /*  177832 */     GIR_EraseRootFromParent_Done,
     /*  177833 */   // Label 3403: @177833
     /*  177833 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(177888), // Rule ID 665 //
     /*  177838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  177841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  177851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177855 */     // MIs[0] addr
     /*  177855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177871 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  177874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177876 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177878 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177880 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177886 */     GIR_RootConstrainSelectedInstOperands,
     /*  177887 */     // GIR_Coverage, 665,
     /*  177887 */     GIR_EraseRootFromParent_Done,
     /*  177888 */   // Label 3404: @177888
     /*  177888 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(177943), // Rule ID 667 //
     /*  177893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  177896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  177906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177910 */     // MIs[0] addr
     /*  177910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177926 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W_AQ_RL),
     /*  177929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177931 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177933 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177935 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177941 */     GIR_RootConstrainSelectedInstOperands,
     /*  177942 */     // GIR_Coverage, 667,
     /*  177942 */     GIR_EraseRootFromParent_Done,
     /*  177943 */   // Label 3405: @177943
     /*  177943 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(177998), // Rule ID 669 //
     /*  177948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  177951 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  177958 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  177961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177965 */     // MIs[0] addr
     /*  177965 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  177969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  177981 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  177981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  177984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  177986 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  177988 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  177990 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  177992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  177996 */     GIR_RootConstrainSelectedInstOperands,
     /*  177997 */     // GIR_Coverage, 669,
     /*  177997 */     GIR_EraseRootFromParent_Done,
     /*  177998 */   // Label 3406: @177998
     /*  177998 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(178053), // Rule ID 671 //
     /*  178003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178020 */     // MIs[0] addr
     /*  178020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178036 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178041 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178043 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178045 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178051 */     GIR_RootConstrainSelectedInstOperands,
     /*  178052 */     // GIR_Coverage, 671,
     /*  178052 */     GIR_EraseRootFromParent_Done,
     /*  178053 */   // Label 3407: @178053
     /*  178053 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(178108), // Rule ID 673 //
     /*  178058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178061 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178068 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178075 */     // MIs[0] addr
     /*  178075 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178091 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178096 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178098 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178100 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178102 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178106 */     GIR_RootConstrainSelectedInstOperands,
     /*  178107 */     // GIR_Coverage, 673,
     /*  178107 */     GIR_EraseRootFromParent_Done,
     /*  178108 */   // Label 3408: @178108
     /*  178108 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(178163), // Rule ID 675 //
     /*  178113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178130 */     // MIs[0] addr
     /*  178130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178146 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178151 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178153 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178155 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178157 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178161 */     GIR_RootConstrainSelectedInstOperands,
     /*  178162 */     // GIR_Coverage, 675,
     /*  178162 */     GIR_EraseRootFromParent_Done,
     /*  178163 */   // Label 3409: @178163
     /*  178163 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(178218), // Rule ID 677 //
     /*  178168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  178171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  178178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178185 */     // MIs[0] addr
     /*  178185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178201 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (AMOCAS_W:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_W),
     /*  178204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178206 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178208 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178210 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178216 */     GIR_RootConstrainSelectedInstOperands,
     /*  178217 */     // GIR_Coverage, 677,
     /*  178217 */     GIR_EraseRootFromParent_Done,
     /*  178218 */   // Label 3410: @178218
     /*  178218 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(178273), // Rule ID 679 //
     /*  178223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178240 */     // MIs[0] addr
     /*  178240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178256 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178261 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178263 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178265 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178271 */     GIR_RootConstrainSelectedInstOperands,
     /*  178272 */     // GIR_Coverage, 679,
     /*  178272 */     GIR_EraseRootFromParent_Done,
     /*  178273 */   // Label 3411: @178273
     /*  178273 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(178328), // Rule ID 680 //
     /*  178278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178295 */     // MIs[0] addr
     /*  178295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178311 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ),
     /*  178314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178316 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178318 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178320 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178326 */     GIR_RootConstrainSelectedInstOperands,
     /*  178327 */     // GIR_Coverage, 680,
     /*  178327 */     GIR_EraseRootFromParent_Done,
     /*  178328 */   // Label 3412: @178328
     /*  178328 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(178383), // Rule ID 681 //
     /*  178333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178350 */     // MIs[0] addr
     /*  178350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178366 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_RL),
     /*  178369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178371 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178373 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178375 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178381 */     GIR_RootConstrainSelectedInstOperands,
     /*  178382 */     // GIR_Coverage, 681,
     /*  178382 */     GIR_EraseRootFromParent_Done,
     /*  178383 */   // Label 3413: @178383
     /*  178383 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(178438), // Rule ID 682 //
     /*  178388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178391 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178398 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178405 */     // MIs[0] addr
     /*  178405 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178421 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178426 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178428 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178430 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178436 */     GIR_RootConstrainSelectedInstOperands,
     /*  178437 */     // GIR_Coverage, 682,
     /*  178437 */     GIR_EraseRootFromParent_Done,
     /*  178438 */   // Label 3414: @178438
     /*  178438 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(178493), // Rule ID 683 //
     /*  178443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  178446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178460 */     // MIs[0] addr
     /*  178460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178476 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64_AQ_RL),
     /*  178479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178481 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178483 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178485 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178487 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178491 */     GIR_RootConstrainSelectedInstOperands,
     /*  178492 */     // GIR_Coverage, 683,
     /*  178492 */     GIR_EraseRootFromParent_Done,
     /*  178493 */   // Label 3415: @178493
     /*  178493 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(178548), // Rule ID 684 //
     /*  178498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  178501 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178508 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178515 */     // MIs[0] addr
     /*  178515 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178531 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178536 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178538 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178540 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178546 */     GIR_RootConstrainSelectedInstOperands,
     /*  178547 */     // GIR_Coverage, 684,
     /*  178547 */     GIR_EraseRootFromParent_Done,
     /*  178548 */   // Label 3416: @178548
     /*  178548 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(178603), // Rule ID 685 //
     /*  178553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  178556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178570 */     // MIs[0] addr
     /*  178570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178586 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178591 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178593 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178595 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178597 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178601 */     GIR_RootConstrainSelectedInstOperands,
     /*  178602 */     // GIR_Coverage, 685,
     /*  178602 */     GIR_EraseRootFromParent_Done,
     /*  178603 */   // Label 3417: @178603
     /*  178603 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(178658), // Rule ID 686 //
     /*  178608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  178611 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178618 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178625 */     // MIs[0] addr
     /*  178625 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178641 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178646 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178648 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178650 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178656 */     GIR_RootConstrainSelectedInstOperands,
     /*  178657 */     // GIR_Coverage, 686,
     /*  178657 */     GIR_EraseRootFromParent_Done,
     /*  178658 */   // Label 3418: @178658
     /*  178658 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(178713), // Rule ID 687 //
     /*  178663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  178666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178680 */     // MIs[0] addr
     /*  178680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178696 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178701 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178703 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178705 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178711 */     GIR_RootConstrainSelectedInstOperands,
     /*  178712 */     // GIR_Coverage, 687,
     /*  178712 */     GIR_EraseRootFromParent_Done,
     /*  178713 */   // Label 3419: @178713
     /*  178713 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(178768), // Rule ID 688 //
     /*  178718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZacas_HasStdExtZtso_IsRV64_HwMode0),
     /*  178721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  178728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  178731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178735 */     // MIs[0] addr
     /*  178735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178751 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (AMOCAS_D_RV64:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_D_RV64),
     /*  178754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178756 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178758 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178760 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178766 */     GIR_RootConstrainSelectedInstOperands,
     /*  178767 */     // GIR_Coverage, 688,
     /*  178767 */     GIR_EraseRootFromParent_Done,
     /*  178768 */   // Label 3420: @178768
     /*  178768 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(178823), // Rule ID 1049 //
     /*  178773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178776 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  178783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  178786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178790 */     // MIs[0] addr
     /*  178790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178806 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  178809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178811 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178813 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178815 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178821 */     GIR_RootConstrainSelectedInstOperands,
     /*  178822 */     // GIR_Coverage, 1049,
     /*  178822 */     GIR_EraseRootFromParent_Done,
     /*  178823 */   // Label 3421: @178823
     /*  178823 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(178878), // Rule ID 1051 //
     /*  178828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178831 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  178838 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  178841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178845 */     // MIs[0] addr
     /*  178845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178861 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ),
     /*  178864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178866 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178868 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178870 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178876 */     GIR_RootConstrainSelectedInstOperands,
     /*  178877 */     // GIR_Coverage, 1051,
     /*  178877 */     GIR_EraseRootFromParent_Done,
     /*  178878 */   // Label 3422: @178878
     /*  178878 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(178933), // Rule ID 1053 //
     /*  178883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  178893 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  178896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178900 */     // MIs[0] addr
     /*  178900 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178916 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_RL),
     /*  178919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178921 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178923 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178925 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178931 */     GIR_RootConstrainSelectedInstOperands,
     /*  178932 */     // GIR_Coverage, 1053,
     /*  178932 */     GIR_EraseRootFromParent_Done,
     /*  178933 */   // Label 3423: @178933
     /*  178933 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(178988), // Rule ID 1055 //
     /*  178938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  178948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  178951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178955 */     // MIs[0] addr
     /*  178955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  178959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  178971 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  178971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  178974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  178976 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  178978 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  178980 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  178982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  178986 */     GIR_RootConstrainSelectedInstOperands,
     /*  178987 */     // GIR_Coverage, 1055,
     /*  178987 */     GIR_EraseRootFromParent_Done,
     /*  178988 */   // Label 3424: @178988
     /*  178988 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(179043), // Rule ID 1057 //
     /*  178993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  178996 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179003 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179010 */     // MIs[0] addr
     /*  179010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179026 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B_AQ_RL),
     /*  179029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179031 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179033 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179035 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179037 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179041 */     GIR_RootConstrainSelectedInstOperands,
     /*  179042 */     // GIR_Coverage, 1057,
     /*  179042 */     GIR_EraseRootFromParent_Done,
     /*  179043 */   // Label 3425: @179043
     /*  179043 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(179098), // Rule ID 1059 //
     /*  179048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179065 */     // MIs[0] addr
     /*  179065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179081 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179086 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179088 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179090 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179096 */     GIR_RootConstrainSelectedInstOperands,
     /*  179097 */     // GIR_Coverage, 1059,
     /*  179097 */     GIR_EraseRootFromParent_Done,
     /*  179098 */   // Label 3426: @179098
     /*  179098 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(179153), // Rule ID 1061 //
     /*  179103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179120 */     // MIs[0] addr
     /*  179120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179136 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179141 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179143 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179145 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179151 */     GIR_RootConstrainSelectedInstOperands,
     /*  179152 */     // GIR_Coverage, 1061,
     /*  179152 */     GIR_EraseRootFromParent_Done,
     /*  179153 */   // Label 3427: @179153
     /*  179153 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(179208), // Rule ID 1063 //
     /*  179158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179175 */     // MIs[0] addr
     /*  179175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179191 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179196 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179198 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179200 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179206 */     GIR_RootConstrainSelectedInstOperands,
     /*  179207 */     // GIR_Coverage, 1063,
     /*  179207 */     GIR_EraseRootFromParent_Done,
     /*  179208 */   // Label 3428: @179208
     /*  179208 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(179263), // Rule ID 1065 //
     /*  179213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179223 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179230 */     // MIs[0] addr
     /*  179230 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179246 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179251 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179253 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179255 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179261 */     GIR_RootConstrainSelectedInstOperands,
     /*  179262 */     // GIR_Coverage, 1065,
     /*  179262 */     GIR_EraseRootFromParent_Done,
     /*  179263 */   // Label 3429: @179263
     /*  179263 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(179318), // Rule ID 1067 //
     /*  179268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179271 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  179278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179285 */     // MIs[0] addr
     /*  179285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179301 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (AMOCAS_B:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_B),
     /*  179304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179306 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179308 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179310 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179312 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179316 */     GIR_RootConstrainSelectedInstOperands,
     /*  179317 */     // GIR_Coverage, 1067,
     /*  179317 */     GIR_EraseRootFromParent_Done,
     /*  179318 */   // Label 3430: @179318
     /*  179318 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(179373), // Rule ID 1069 //
     /*  179323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179333 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179340 */     // MIs[0] addr
     /*  179340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179356 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179361 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179363 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179365 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179371 */     GIR_RootConstrainSelectedInstOperands,
     /*  179372 */     // GIR_Coverage, 1069,
     /*  179372 */     GIR_EraseRootFromParent_Done,
     /*  179373 */   // Label 3431: @179373
     /*  179373 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(179428), // Rule ID 1071 //
     /*  179378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179381 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179388 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179395 */     // MIs[0] addr
     /*  179395 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179411 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ),
     /*  179414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179416 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179418 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179420 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179426 */     GIR_RootConstrainSelectedInstOperands,
     /*  179427 */     // GIR_Coverage, 1071,
     /*  179427 */     GIR_EraseRootFromParent_Done,
     /*  179428 */   // Label 3432: @179428
     /*  179428 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(179483), // Rule ID 1073 //
     /*  179433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179450 */     // MIs[0] addr
     /*  179450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179466 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_RL),
     /*  179469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179471 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179473 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179475 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179481 */     GIR_RootConstrainSelectedInstOperands,
     /*  179482 */     // GIR_Coverage, 1073,
     /*  179482 */     GIR_EraseRootFromParent_Done,
     /*  179483 */   // Label 3433: @179483
     /*  179483 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(179538), // Rule ID 1075 //
     /*  179488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179505 */     // MIs[0] addr
     /*  179505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179521 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  179524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179526 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179528 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179530 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179536 */     GIR_RootConstrainSelectedInstOperands,
     /*  179537 */     // GIR_Coverage, 1075,
     /*  179537 */     GIR_EraseRootFromParent_Done,
     /*  179538 */   // Label 3434: @179538
     /*  179538 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(179593), // Rule ID 1077 //
     /*  179543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_NotHasStdExtZtso_HwMode0),
     /*  179546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179560 */     // MIs[0] addr
     /*  179560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179576 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H_AQ_RL),
     /*  179579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179581 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179583 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179585 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179591 */     GIR_RootConstrainSelectedInstOperands,
     /*  179592 */     // GIR_Coverage, 1077,
     /*  179592 */     GIR_EraseRootFromParent_Done,
     /*  179593 */   // Label 3435: @179593
     /*  179593 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(179648), // Rule ID 1079 //
     /*  179598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179601 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179615 */     // MIs[0] addr
     /*  179615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179631 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179636 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179638 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179640 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179646 */     GIR_RootConstrainSelectedInstOperands,
     /*  179647 */     // GIR_Coverage, 1079,
     /*  179647 */     GIR_EraseRootFromParent_Done,
     /*  179648 */   // Label 3436: @179648
     /*  179648 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(179703), // Rule ID 1081 //
     /*  179653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179670 */     // MIs[0] addr
     /*  179670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179686 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179691 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179693 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179695 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179701 */     GIR_RootConstrainSelectedInstOperands,
     /*  179702 */     // GIR_Coverage, 1081,
     /*  179702 */     GIR_EraseRootFromParent_Done,
     /*  179703 */   // Label 3437: @179703
     /*  179703 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(179758), // Rule ID 1083 //
     /*  179708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179725 */     // MIs[0] addr
     /*  179725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179741 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179746 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179748 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179750 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179756 */     GIR_RootConstrainSelectedInstOperands,
     /*  179757 */     // GIR_Coverage, 1083,
     /*  179757 */     GIR_EraseRootFromParent_Done,
     /*  179758 */   // Label 3438: @179758
     /*  179758 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(179813), // Rule ID 1085 //
     /*  179763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179766 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179773 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  179776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179780 */     // MIs[0] addr
     /*  179780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179796 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179801 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179803 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179805 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179811 */     GIR_RootConstrainSelectedInstOperands,
     /*  179812 */     // GIR_Coverage, 1085,
     /*  179812 */     GIR_EraseRootFromParent_Done,
     /*  179813 */   // Label 3439: @179813
     /*  179813 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(179868), // Rule ID 1087 //
     /*  179818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZabha_HasStdExtZacas_HasStdExtZtso_HwMode0),
     /*  179821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  179828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  179831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179835 */     // MIs[0] addr
     /*  179835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  179839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179851 */     // (atomic_cmp_swap:{ *:[i64] } GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (AMOCAS_H:{ *:[i64] } GPR:{ *:[i64] }:$cmp, GPR:{ *:[i64] }:$addr, GPR:{ *:[i64] }:$new)
     /*  179851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AMOCAS_H),
     /*  179854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  179856 */     GIR_RootToRootCopy, /*OpIdx*/2, // cmp
     /*  179858 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  179860 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /*  179862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  179866 */     GIR_RootConstrainSelectedInstOperands,
     /*  179867 */     // GIR_Coverage, 1087,
     /*  179867 */     GIR_EraseRootFromParent_Done,
     /*  179868 */   // Label 3440: @179868
     /*  179868 */   GIM_Reject,
     /*  179869 */ // Label 3390: @179869
     /*  179869 */ GIM_Reject,
     /*  179870 */ // Label 3353: @179870
     /*  179870 */ GIM_Reject,
     /*  179871 */ // Label 26: @179871
     /*  179871 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3443*/ GIMT_Encode4(182780),
     /*  179882 */ /*GILLT_s32*//*Label 3441*/ GIMT_Encode4(179890),
     /*  179886 */ /*GILLT_s64*//*Label 3442*/ GIMT_Encode4(181130),
     /*  179890 */ // Label 3441: @179890
     /*  179890 */ GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(181129),
     /*  179895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  179898 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(179939), // Rule ID 342 //
     /*  179903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  179906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179913 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  179916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179920 */     // MIs[0] rs1
     /*  179920 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179932 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  179932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  179937 */     GIR_RootConstrainSelectedInstOperands,
     /*  179938 */     // GIR_Coverage, 342,
     /*  179938 */     GIR_Done,
     /*  179939 */   // Label 3445: @179939
     /*  179939 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(179980), // Rule ID 344 //
     /*  179944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  179947 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  179957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179961 */     // MIs[0] rs1
     /*  179961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  179965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  179973 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  179973 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  179978 */     GIR_RootConstrainSelectedInstOperands,
     /*  179979 */     // GIR_Coverage, 344,
     /*  179979 */     GIR_Done,
     /*  179980 */   // Label 3446: @179980
     /*  179980 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(180021), // Rule ID 346 //
     /*  179985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  179988 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  179995 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  179998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180002 */     // MIs[0] rs1
     /*  180002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180014 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  180019 */     GIR_RootConstrainSelectedInstOperands,
     /*  180020 */     // GIR_Coverage, 346,
     /*  180020 */     GIR_Done,
     /*  180021 */   // Label 3447: @180021
     /*  180021 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(180062), // Rule ID 348 //
     /*  180026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180036 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180043 */     // MIs[0] rs1
     /*  180043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180055 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180055 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180060 */     GIR_RootConstrainSelectedInstOperands,
     /*  180061 */     // GIR_Coverage, 348,
     /*  180061 */     GIR_Done,
     /*  180062 */   // Label 3448: @180062
     /*  180062 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(180103), // Rule ID 350 //
     /*  180067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  180070 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180077 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180084 */     // MIs[0] rs1
     /*  180084 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180096 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180096 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  180101 */     GIR_RootConstrainSelectedInstOperands,
     /*  180102 */     // GIR_Coverage, 350,
     /*  180102 */     GIR_Done,
     /*  180103 */   // Label 3449: @180103
     /*  180103 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(180144), // Rule ID 352 //
     /*  180108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180111 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180118 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180125 */     // MIs[0] rs1
     /*  180125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180137 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180142 */     GIR_RootConstrainSelectedInstOperands,
     /*  180143 */     // GIR_Coverage, 352,
     /*  180143 */     GIR_Done,
     /*  180144 */   // Label 3450: @180144
     /*  180144 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(180185), // Rule ID 354 //
     /*  180149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180166 */     // MIs[0] rs1
     /*  180166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180178 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180183 */     GIR_RootConstrainSelectedInstOperands,
     /*  180184 */     // GIR_Coverage, 354,
     /*  180184 */     GIR_Done,
     /*  180185 */   // Label 3451: @180185
     /*  180185 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(180226), // Rule ID 356 //
     /*  180190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180207 */     // MIs[0] rs1
     /*  180207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180219 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180224 */     GIR_RootConstrainSelectedInstOperands,
     /*  180225 */     // GIR_Coverage, 356,
     /*  180225 */     GIR_Done,
     /*  180226 */   // Label 3452: @180226
     /*  180226 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(180267), // Rule ID 358 //
     /*  180231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180234 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180241 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180248 */     // MIs[0] rs1
     /*  180248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180260 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180265 */     GIR_RootConstrainSelectedInstOperands,
     /*  180266 */     // GIR_Coverage, 358,
     /*  180266 */     GIR_Done,
     /*  180267 */   // Label 3453: @180267
     /*  180267 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(180308), // Rule ID 360 //
     /*  180272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  180275 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  180282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180289 */     // MIs[0] rs1
     /*  180289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180301 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  180306 */     GIR_RootConstrainSelectedInstOperands,
     /*  180307 */     // GIR_Coverage, 360,
     /*  180307 */     GIR_Done,
     /*  180308 */   // Label 3454: @180308
     /*  180308 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(180349), // Rule ID 690 //
     /*  180313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180330 */     // MIs[0] rs1
     /*  180330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180342 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180342 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180347 */     GIR_RootConstrainSelectedInstOperands,
     /*  180348 */     // GIR_Coverage, 690,
     /*  180348 */     GIR_Done,
     /*  180349 */   // Label 3455: @180349
     /*  180349 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(180390), // Rule ID 692 //
     /*  180354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180371 */     // MIs[0] rs1
     /*  180371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180383 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  180388 */     GIR_RootConstrainSelectedInstOperands,
     /*  180389 */     // GIR_Coverage, 692,
     /*  180389 */     GIR_Done,
     /*  180390 */   // Label 3456: @180390
     /*  180390 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(180431), // Rule ID 694 //
     /*  180395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180412 */     // MIs[0] rs1
     /*  180412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180424 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180424 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  180429 */     GIR_RootConstrainSelectedInstOperands,
     /*  180430 */     // GIR_Coverage, 694,
     /*  180430 */     GIR_Done,
     /*  180431 */   // Label 3457: @180431
     /*  180431 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(180472), // Rule ID 696 //
     /*  180436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180446 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180453 */     // MIs[0] rs1
     /*  180453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180465 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  180470 */     GIR_RootConstrainSelectedInstOperands,
     /*  180471 */     // GIR_Coverage, 696,
     /*  180471 */     GIR_Done,
     /*  180472 */   // Label 3458: @180472
     /*  180472 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(180513), // Rule ID 698 //
     /*  180477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180494 */     // MIs[0] rs1
     /*  180494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180506 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  180511 */     GIR_RootConstrainSelectedInstOperands,
     /*  180512 */     // GIR_Coverage, 698,
     /*  180512 */     GIR_Done,
     /*  180513 */   // Label 3459: @180513
     /*  180513 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(180554), // Rule ID 700 //
     /*  180518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180535 */     // MIs[0] rs1
     /*  180535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180547 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180552 */     GIR_RootConstrainSelectedInstOperands,
     /*  180553 */     // GIR_Coverage, 700,
     /*  180553 */     GIR_Done,
     /*  180554 */   // Label 3460: @180554
     /*  180554 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(180595), // Rule ID 702 //
     /*  180559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180562 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180569 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180576 */     // MIs[0] rs1
     /*  180576 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180588 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180593 */     GIR_RootConstrainSelectedInstOperands,
     /*  180594 */     // GIR_Coverage, 702,
     /*  180594 */     GIR_Done,
     /*  180595 */   // Label 3461: @180595
     /*  180595 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(180636), // Rule ID 704 //
     /*  180600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180603 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180610 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180617 */     // MIs[0] rs1
     /*  180617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180629 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180629 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180634 */     GIR_RootConstrainSelectedInstOperands,
     /*  180635 */     // GIR_Coverage, 704,
     /*  180635 */     GIR_Done,
     /*  180636 */   // Label 3462: @180636
     /*  180636 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(180677), // Rule ID 706 //
     /*  180641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180644 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180651 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180658 */     // MIs[0] rs1
     /*  180658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180670 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180670 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180675 */     GIR_RootConstrainSelectedInstOperands,
     /*  180676 */     // GIR_Coverage, 706,
     /*  180676 */     GIR_Done,
     /*  180677 */   // Label 3463: @180677
     /*  180677 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(180718), // Rule ID 708 //
     /*  180682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180685 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  180692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180699 */     // MIs[0] rs1
     /*  180699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180711 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  180716 */     GIR_RootConstrainSelectedInstOperands,
     /*  180717 */     // GIR_Coverage, 708,
     /*  180717 */     GIR_Done,
     /*  180718 */   // Label 3464: @180718
     /*  180718 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(180759), // Rule ID 870 //
     /*  180723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180740 */     // MIs[0] rs1
     /*  180740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180752 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  180757 */     GIR_RootConstrainSelectedInstOperands,
     /*  180758 */     // GIR_Coverage, 870,
     /*  180758 */     GIR_Done,
     /*  180759 */   // Label 3465: @180759
     /*  180759 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(180800), // Rule ID 872 //
     /*  180764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180767 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180781 */     // MIs[0] rs1
     /*  180781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180793 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  180798 */     GIR_RootConstrainSelectedInstOperands,
     /*  180799 */     // GIR_Coverage, 872,
     /*  180799 */     GIR_Done,
     /*  180800 */   // Label 3466: @180800
     /*  180800 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(180841), // Rule ID 874 //
     /*  180805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  180818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180822 */     // MIs[0] rs1
     /*  180822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180834 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  180839 */     GIR_RootConstrainSelectedInstOperands,
     /*  180840 */     // GIR_Coverage, 874,
     /*  180840 */     GIR_Done,
     /*  180841 */   // Label 3467: @180841
     /*  180841 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(180882), // Rule ID 876 //
     /*  180846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  180859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180863 */     // MIs[0] rs1
     /*  180863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180875 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  180880 */     GIR_RootConstrainSelectedInstOperands,
     /*  180881 */     // GIR_Coverage, 876,
     /*  180881 */     GIR_Done,
     /*  180882 */   // Label 3468: @180882
     /*  180882 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(180923), // Rule ID 878 //
     /*  180887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  180890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  180900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180904 */     // MIs[0] rs1
     /*  180904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180916 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  180921 */     GIR_RootConstrainSelectedInstOperands,
     /*  180922 */     // GIR_Coverage, 878,
     /*  180922 */     GIR_Done,
     /*  180923 */   // Label 3469: @180923
     /*  180923 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(180964), // Rule ID 880 //
     /*  180928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  180941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180945 */     // MIs[0] rs1
     /*  180945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180957 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  180962 */     GIR_RootConstrainSelectedInstOperands,
     /*  180963 */     // GIR_Coverage, 880,
     /*  180963 */     GIR_Done,
     /*  180964 */   // Label 3470: @180964
     /*  180964 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(181005), // Rule ID 882 //
     /*  180969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  180972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  180979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  180982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180986 */     // MIs[0] rs1
     /*  180986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  180990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  180998 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  180998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181003 */     GIR_RootConstrainSelectedInstOperands,
     /*  181004 */     // GIR_Coverage, 882,
     /*  181004 */     GIR_Done,
     /*  181005 */   // Label 3471: @181005
     /*  181005 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(181046), // Rule ID 884 //
     /*  181010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181027 */     // MIs[0] rs1
     /*  181027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181039 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181044 */     GIR_RootConstrainSelectedInstOperands,
     /*  181045 */     // GIR_Coverage, 884,
     /*  181045 */     GIR_Done,
     /*  181046 */   // Label 3472: @181046
     /*  181046 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(181087), // Rule ID 886 //
     /*  181051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181068 */     // MIs[0] rs1
     /*  181068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181080 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181085 */     GIR_RootConstrainSelectedInstOperands,
     /*  181086 */     // GIR_Coverage, 886,
     /*  181086 */     GIR_Done,
     /*  181087 */   // Label 3473: @181087
     /*  181087 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(181128), // Rule ID 888 //
     /*  181092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  181095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  181102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181109 */     // MIs[0] rs1
     /*  181109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  181113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181121 */     // (atomic_swap:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  181121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  181126 */     GIR_RootConstrainSelectedInstOperands,
     /*  181127 */     // GIR_Coverage, 888,
     /*  181127 */     GIR_Done,
     /*  181128 */   // Label 3474: @181128
     /*  181128 */   GIM_Reject,
     /*  181129 */ // Label 3444: @181129
     /*  181129 */ GIM_Reject,
     /*  181130 */ // Label 3442: @181130
     /*  181130 */ GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(182779),
     /*  181135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  181138 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(181179), // Rule ID 341 //
     /*  181143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181146 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181153 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181160 */     // MIs[0] rs1
     /*  181160 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181172 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181172 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181177 */     GIR_RootConstrainSelectedInstOperands,
     /*  181178 */     // GIR_Coverage, 341,
     /*  181178 */     GIR_Done,
     /*  181179 */   // Label 3476: @181179
     /*  181179 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(181220), // Rule ID 343 //
     /*  181184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181187 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181201 */     // MIs[0] rs1
     /*  181201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181213 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ),
     /*  181218 */     GIR_RootConstrainSelectedInstOperands,
     /*  181219 */     // GIR_Coverage, 343,
     /*  181219 */     GIR_Done,
     /*  181220 */   // Label 3477: @181220
     /*  181220 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(181261), // Rule ID 345 //
     /*  181225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181228 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181235 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181242 */     // MIs[0] rs1
     /*  181242 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181254 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181254 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_RL),
     /*  181259 */     GIR_RootConstrainSelectedInstOperands,
     /*  181260 */     // GIR_Coverage, 345,
     /*  181260 */     GIR_Done,
     /*  181261 */   // Label 3478: @181261
     /*  181261 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(181302), // Rule ID 347 //
     /*  181266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181276 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181283 */     // MIs[0] rs1
     /*  181283 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181295 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181300 */     GIR_RootConstrainSelectedInstOperands,
     /*  181301 */     // GIR_Coverage, 347,
     /*  181301 */     GIR_Done,
     /*  181302 */   // Label 3479: @181302
     /*  181302 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(181343), // Rule ID 349 //
     /*  181307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  181310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181324 */     // MIs[0] rs1
     /*  181324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181336 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W_AQ_RL),
     /*  181341 */     GIR_RootConstrainSelectedInstOperands,
     /*  181342 */     // GIR_Coverage, 349,
     /*  181342 */     GIR_Done,
     /*  181343 */   // Label 3480: @181343
     /*  181343 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(181384), // Rule ID 351 //
     /*  181348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181365 */     // MIs[0] rs1
     /*  181365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181377 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181382 */     GIR_RootConstrainSelectedInstOperands,
     /*  181383 */     // GIR_Coverage, 351,
     /*  181383 */     GIR_Done,
     /*  181384 */   // Label 3481: @181384
     /*  181384 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(181425), // Rule ID 353 //
     /*  181389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181406 */     // MIs[0] rs1
     /*  181406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181418 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181423 */     GIR_RootConstrainSelectedInstOperands,
     /*  181424 */     // GIR_Coverage, 353,
     /*  181424 */     GIR_Done,
     /*  181425 */   // Label 3482: @181425
     /*  181425 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(181466), // Rule ID 355 //
     /*  181430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181440 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181447 */     // MIs[0] rs1
     /*  181447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181459 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181459 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181464 */     GIR_RootConstrainSelectedInstOperands,
     /*  181465 */     // GIR_Coverage, 355,
     /*  181465 */     GIR_Done,
     /*  181466 */   // Label 3483: @181466
     /*  181466 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(181507), // Rule ID 357 //
     /*  181471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181474 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181481 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181488 */     // MIs[0] rs1
     /*  181488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181500 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181505 */     GIR_RootConstrainSelectedInstOperands,
     /*  181506 */     // GIR_Coverage, 357,
     /*  181506 */     GIR_Done,
     /*  181507 */   // Label 3484: @181507
     /*  181507 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(181548), // Rule ID 359 //
     /*  181512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  181515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  181522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181529 */     // MIs[0] rs1
     /*  181529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181541 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (AMOSWAP_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181541 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_W),
     /*  181546 */     GIR_RootConstrainSelectedInstOperands,
     /*  181547 */     // GIR_Coverage, 359,
     /*  181547 */     GIR_Done,
     /*  181548 */   // Label 3485: @181548
     /*  181548 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(181589), // Rule ID 521 //
     /*  181553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  181556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181570 */     // MIs[0] rs1
     /*  181570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181582 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181582 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181587 */     GIR_RootConstrainSelectedInstOperands,
     /*  181588 */     // GIR_Coverage, 521,
     /*  181588 */     GIR_Done,
     /*  181589 */   // Label 3486: @181589
     /*  181589 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(181630), // Rule ID 522 //
     /*  181594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  181597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181611 */     // MIs[0] rs1
     /*  181611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181623 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ),
     /*  181628 */     GIR_RootConstrainSelectedInstOperands,
     /*  181629 */     // GIR_Coverage, 522,
     /*  181629 */     GIR_Done,
     /*  181630 */   // Label 3487: @181630
     /*  181630 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(181671), // Rule ID 523 //
     /*  181635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  181638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181652 */     // MIs[0] rs1
     /*  181652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181664 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_RL),
     /*  181669 */     GIR_RootConstrainSelectedInstOperands,
     /*  181670 */     // GIR_Coverage, 523,
     /*  181670 */     GIR_Done,
     /*  181671 */   // Label 3488: @181671
     /*  181671 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(181712), // Rule ID 524 //
     /*  181676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  181679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181693 */     // MIs[0] rs1
     /*  181693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181705 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  181710 */     GIR_RootConstrainSelectedInstOperands,
     /*  181711 */     // GIR_Coverage, 524,
     /*  181711 */     GIR_Done,
     /*  181712 */   // Label 3489: @181712
     /*  181712 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(181753), // Rule ID 525 //
     /*  181717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  181720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181734 */     // MIs[0] rs1
     /*  181734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181746 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181746 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D_AQ_RL),
     /*  181751 */     GIR_RootConstrainSelectedInstOperands,
     /*  181752 */     // GIR_Coverage, 525,
     /*  181752 */     GIR_Done,
     /*  181753 */   // Label 3490: @181753
     /*  181753 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(181794), // Rule ID 526 //
     /*  181758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  181761 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181768 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181775 */     // MIs[0] rs1
     /*  181775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181787 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181792 */     GIR_RootConstrainSelectedInstOperands,
     /*  181793 */     // GIR_Coverage, 526,
     /*  181793 */     GIR_Done,
     /*  181794 */   // Label 3491: @181794
     /*  181794 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(181835), // Rule ID 527 //
     /*  181799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  181802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  181812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181816 */     // MIs[0] rs1
     /*  181816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181828 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181828 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181833 */     GIR_RootConstrainSelectedInstOperands,
     /*  181834 */     // GIR_Coverage, 527,
     /*  181834 */     GIR_Done,
     /*  181835 */   // Label 3492: @181835
     /*  181835 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(181876), // Rule ID 528 //
     /*  181840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  181843 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  181853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181857 */     // MIs[0] rs1
     /*  181857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181869 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181874 */     GIR_RootConstrainSelectedInstOperands,
     /*  181875 */     // GIR_Coverage, 528,
     /*  181875 */     GIR_Done,
     /*  181876 */   // Label 3493: @181876
     /*  181876 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(181917), // Rule ID 529 //
     /*  181881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  181884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  181894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181898 */     // MIs[0] rs1
     /*  181898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181910 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181910 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181915 */     GIR_RootConstrainSelectedInstOperands,
     /*  181916 */     // GIR_Coverage, 529,
     /*  181916 */     GIR_Done,
     /*  181917 */   // Label 3494: @181917
     /*  181917 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(181958), // Rule ID 530 //
     /*  181922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  181925 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  181932 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  181935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181939 */     // MIs[0] rs1
     /*  181939 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181951 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (AMOSWAP_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_D),
     /*  181956 */     GIR_RootConstrainSelectedInstOperands,
     /*  181957 */     // GIR_Coverage, 530,
     /*  181957 */     GIR_Done,
     /*  181958 */   // Label 3495: @181958
     /*  181958 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(181999), // Rule ID 689 //
     /*  181963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  181966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  181973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  181976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181980 */     // MIs[0] rs1
     /*  181980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  181984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  181992 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  181992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  181997 */     GIR_RootConstrainSelectedInstOperands,
     /*  181998 */     // GIR_Coverage, 689,
     /*  181998 */     GIR_Done,
     /*  181999 */   // Label 3496: @181999
     /*  181999 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(182040), // Rule ID 691 //
     /*  182004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182021 */     // MIs[0] rs1
     /*  182021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182033 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ),
     /*  182038 */     GIR_RootConstrainSelectedInstOperands,
     /*  182039 */     // GIR_Coverage, 691,
     /*  182039 */     GIR_Done,
     /*  182040 */   // Label 3497: @182040
     /*  182040 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(182081), // Rule ID 693 //
     /*  182045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182062 */     // MIs[0] rs1
     /*  182062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182074 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_RL),
     /*  182079 */     GIR_RootConstrainSelectedInstOperands,
     /*  182080 */     // GIR_Coverage, 693,
     /*  182080 */     GIR_Done,
     /*  182081 */   // Label 3498: @182081
     /*  182081 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(182122), // Rule ID 695 //
     /*  182086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182103 */     // MIs[0] rs1
     /*  182103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182115 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182120 */     GIR_RootConstrainSelectedInstOperands,
     /*  182121 */     // GIR_Coverage, 695,
     /*  182121 */     GIR_Done,
     /*  182122 */   // Label 3499: @182122
     /*  182122 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(182163), // Rule ID 697 //
     /*  182127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182144 */     // MIs[0] rs1
     /*  182144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182156 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B_AQ_RL),
     /*  182161 */     GIR_RootConstrainSelectedInstOperands,
     /*  182162 */     // GIR_Coverage, 697,
     /*  182162 */     GIR_Done,
     /*  182163 */   // Label 3500: @182163
     /*  182163 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(182204), // Rule ID 699 //
     /*  182168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182185 */     // MIs[0] rs1
     /*  182185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182197 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182202 */     GIR_RootConstrainSelectedInstOperands,
     /*  182203 */     // GIR_Coverage, 699,
     /*  182203 */     GIR_Done,
     /*  182204 */   // Label 3501: @182204
     /*  182204 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(182245), // Rule ID 701 //
     /*  182209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182226 */     // MIs[0] rs1
     /*  182226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182238 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182243 */     GIR_RootConstrainSelectedInstOperands,
     /*  182244 */     // GIR_Coverage, 701,
     /*  182244 */     GIR_Done,
     /*  182245 */   // Label 3502: @182245
     /*  182245 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(182286), // Rule ID 703 //
     /*  182250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182267 */     // MIs[0] rs1
     /*  182267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182279 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182284 */     GIR_RootConstrainSelectedInstOperands,
     /*  182285 */     // GIR_Coverage, 703,
     /*  182285 */     GIR_Done,
     /*  182286 */   // Label 3503: @182286
     /*  182286 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(182327), // Rule ID 705 //
     /*  182291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182308 */     // MIs[0] rs1
     /*  182308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182320 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182325 */     GIR_RootConstrainSelectedInstOperands,
     /*  182326 */     // GIR_Coverage, 705,
     /*  182326 */     GIR_Done,
     /*  182327 */   // Label 3504: @182327
     /*  182327 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(182368), // Rule ID 707 //
     /*  182332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  182342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182349 */     // MIs[0] rs1
     /*  182349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182361 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (AMOSWAP_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_B),
     /*  182366 */     GIR_RootConstrainSelectedInstOperands,
     /*  182367 */     // GIR_Coverage, 707,
     /*  182367 */     GIR_Done,
     /*  182368 */   // Label 3505: @182368
     /*  182368 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(182409), // Rule ID 869 //
     /*  182373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182390 */     // MIs[0] rs1
     /*  182390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182402 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182407 */     GIR_RootConstrainSelectedInstOperands,
     /*  182408 */     // GIR_Coverage, 869,
     /*  182408 */     GIR_Done,
     /*  182409 */   // Label 3506: @182409
     /*  182409 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(182450), // Rule ID 871 //
     /*  182414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182431 */     // MIs[0] rs1
     /*  182431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182443 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ),
     /*  182448 */     GIR_RootConstrainSelectedInstOperands,
     /*  182449 */     // GIR_Coverage, 871,
     /*  182449 */     GIR_Done,
     /*  182450 */   // Label 3507: @182450
     /*  182450 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(182491), // Rule ID 873 //
     /*  182455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182472 */     // MIs[0] rs1
     /*  182472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182484 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_RL),
     /*  182489 */     GIR_RootConstrainSelectedInstOperands,
     /*  182490 */     // GIR_Coverage, 873,
     /*  182490 */     GIR_Done,
     /*  182491 */   // Label 3508: @182491
     /*  182491 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(182532), // Rule ID 875 //
     /*  182496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182513 */     // MIs[0] rs1
     /*  182513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182525 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  182530 */     GIR_RootConstrainSelectedInstOperands,
     /*  182531 */     // GIR_Coverage, 875,
     /*  182531 */     GIR_Done,
     /*  182532 */   // Label 3509: @182532
     /*  182532 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(182573), // Rule ID 877 //
     /*  182537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  182540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182554 */     // MIs[0] rs1
     /*  182554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182566 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H_AQ_RL),
     /*  182571 */     GIR_RootConstrainSelectedInstOperands,
     /*  182572 */     // GIR_Coverage, 877,
     /*  182572 */     GIR_Done,
     /*  182573 */   // Label 3510: @182573
     /*  182573 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(182614), // Rule ID 879 //
     /*  182578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182595 */     // MIs[0] rs1
     /*  182595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182607 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182612 */     GIR_RootConstrainSelectedInstOperands,
     /*  182613 */     // GIR_Coverage, 879,
     /*  182613 */     GIR_Done,
     /*  182614 */   // Label 3511: @182614
     /*  182614 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(182655), // Rule ID 881 //
     /*  182619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182636 */     // MIs[0] rs1
     /*  182636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182648 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182653 */     GIR_RootConstrainSelectedInstOperands,
     /*  182654 */     // GIR_Coverage, 881,
     /*  182654 */     GIR_Done,
     /*  182655 */   // Label 3512: @182655
     /*  182655 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(182696), // Rule ID 883 //
     /*  182660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182677 */     // MIs[0] rs1
     /*  182677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182689 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182694 */     GIR_RootConstrainSelectedInstOperands,
     /*  182695 */     // GIR_Coverage, 883,
     /*  182695 */     GIR_Done,
     /*  182696 */   // Label 3513: @182696
     /*  182696 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(182737), // Rule ID 885 //
     /*  182701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182718 */     // MIs[0] rs1
     /*  182718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182730 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182735 */     GIR_RootConstrainSelectedInstOperands,
     /*  182736 */     // GIR_Coverage, 885,
     /*  182736 */     GIR_Done,
     /*  182737 */   // Label 3514: @182737
     /*  182737 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(182778), // Rule ID 887 //
     /*  182742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  182745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  182752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182759 */     // MIs[0] rs1
     /*  182759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  182763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182771 */     // (atomic_swap:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (AMOSWAP_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  182771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOSWAP_H),
     /*  182776 */     GIR_RootConstrainSelectedInstOperands,
     /*  182777 */     // GIR_Coverage, 887,
     /*  182777 */     GIR_Done,
     /*  182778 */   // Label 3515: @182778
     /*  182778 */   GIM_Reject,
     /*  182779 */ // Label 3475: @182779
     /*  182779 */ GIM_Reject,
     /*  182780 */ // Label 3443: @182780
     /*  182780 */ GIM_Reject,
     /*  182781 */ // Label 27: @182781
     /*  182781 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3518*/ GIMT_Encode4(185690),
     /*  182792 */ /*GILLT_s32*//*Label 3516*/ GIMT_Encode4(182800),
     /*  182796 */ /*GILLT_s64*//*Label 3517*/ GIMT_Encode4(184040),
     /*  182800 */ // Label 3516: @182800
     /*  182800 */ GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(184039),
     /*  182805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  182808 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(182849), // Rule ID 362 //
     /*  182813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  182816 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182823 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  182826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182830 */     // MIs[0] rs1
     /*  182830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182842 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  182847 */     GIR_RootConstrainSelectedInstOperands,
     /*  182848 */     // GIR_Coverage, 362,
     /*  182848 */     GIR_Done,
     /*  182849 */   // Label 3520: @182849
     /*  182849 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(182890), // Rule ID 364 //
     /*  182854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  182857 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182864 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  182867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182871 */     // MIs[0] rs1
     /*  182871 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182883 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182883 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  182888 */     GIR_RootConstrainSelectedInstOperands,
     /*  182889 */     // GIR_Coverage, 364,
     /*  182889 */     GIR_Done,
     /*  182890 */   // Label 3521: @182890
     /*  182890 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(182931), // Rule ID 366 //
     /*  182895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  182898 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182905 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  182908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182912 */     // MIs[0] rs1
     /*  182912 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182924 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  182929 */     GIR_RootConstrainSelectedInstOperands,
     /*  182930 */     // GIR_Coverage, 366,
     /*  182930 */     GIR_Done,
     /*  182931 */   // Label 3522: @182931
     /*  182931 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(182972), // Rule ID 368 //
     /*  182936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  182939 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182946 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  182949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182953 */     // MIs[0] rs1
     /*  182953 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182965 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  182965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  182970 */     GIR_RootConstrainSelectedInstOperands,
     /*  182971 */     // GIR_Coverage, 368,
     /*  182971 */     GIR_Done,
     /*  182972 */   // Label 3523: @182972
     /*  182972 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(183013), // Rule ID 370 //
     /*  182977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  182980 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  182987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  182990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  182994 */     // MIs[0] rs1
     /*  182994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  182998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183006 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183006 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  183011 */     GIR_RootConstrainSelectedInstOperands,
     /*  183012 */     // GIR_Coverage, 370,
     /*  183012 */     GIR_Done,
     /*  183013 */   // Label 3524: @183013
     /*  183013 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(183054), // Rule ID 372 //
     /*  183018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183021 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183028 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183035 */     // MIs[0] rs1
     /*  183035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183047 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183052 */     GIR_RootConstrainSelectedInstOperands,
     /*  183053 */     // GIR_Coverage, 372,
     /*  183053 */     GIR_Done,
     /*  183054 */   // Label 3525: @183054
     /*  183054 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(183095), // Rule ID 374 //
     /*  183059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183062 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183076 */     // MIs[0] rs1
     /*  183076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183088 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183088 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183093 */     GIR_RootConstrainSelectedInstOperands,
     /*  183094 */     // GIR_Coverage, 374,
     /*  183094 */     GIR_Done,
     /*  183095 */   // Label 3526: @183095
     /*  183095 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(183136), // Rule ID 376 //
     /*  183100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183117 */     // MIs[0] rs1
     /*  183117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183129 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183134 */     GIR_RootConstrainSelectedInstOperands,
     /*  183135 */     // GIR_Coverage, 376,
     /*  183135 */     GIR_Done,
     /*  183136 */   // Label 3527: @183136
     /*  183136 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(183177), // Rule ID 378 //
     /*  183141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183158 */     // MIs[0] rs1
     /*  183158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183170 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183175 */     GIR_RootConstrainSelectedInstOperands,
     /*  183176 */     // GIR_Coverage, 378,
     /*  183176 */     GIR_Done,
     /*  183177 */   // Label 3528: @183177
     /*  183177 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(183218), // Rule ID 380 //
     /*  183182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  183185 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  183192 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183199 */     // MIs[0] rs1
     /*  183199 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183211 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  183216 */     GIR_RootConstrainSelectedInstOperands,
     /*  183217 */     // GIR_Coverage, 380,
     /*  183217 */     GIR_Done,
     /*  183218 */   // Label 3529: @183218
     /*  183218 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(183259), // Rule ID 710 //
     /*  183223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183233 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183240 */     // MIs[0] rs1
     /*  183240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183252 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183257 */     GIR_RootConstrainSelectedInstOperands,
     /*  183258 */     // GIR_Coverage, 710,
     /*  183258 */     GIR_Done,
     /*  183259 */   // Label 3530: @183259
     /*  183259 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(183300), // Rule ID 712 //
     /*  183264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183281 */     // MIs[0] rs1
     /*  183281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183293 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  183298 */     GIR_RootConstrainSelectedInstOperands,
     /*  183299 */     // GIR_Coverage, 712,
     /*  183299 */     GIR_Done,
     /*  183300 */   // Label 3531: @183300
     /*  183300 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(183341), // Rule ID 714 //
     /*  183305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183322 */     // MIs[0] rs1
     /*  183322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183334 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183334 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  183339 */     GIR_RootConstrainSelectedInstOperands,
     /*  183340 */     // GIR_Coverage, 714,
     /*  183340 */     GIR_Done,
     /*  183341 */   // Label 3532: @183341
     /*  183341 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(183382), // Rule ID 716 //
     /*  183346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183363 */     // MIs[0] rs1
     /*  183363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183375 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183380 */     GIR_RootConstrainSelectedInstOperands,
     /*  183381 */     // GIR_Coverage, 716,
     /*  183381 */     GIR_Done,
     /*  183382 */   // Label 3533: @183382
     /*  183382 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(183423), // Rule ID 718 //
     /*  183387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183404 */     // MIs[0] rs1
     /*  183404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183416 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183416 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  183421 */     GIR_RootConstrainSelectedInstOperands,
     /*  183422 */     // GIR_Coverage, 718,
     /*  183422 */     GIR_Done,
     /*  183423 */   // Label 3534: @183423
     /*  183423 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(183464), // Rule ID 720 //
     /*  183428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183438 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183445 */     // MIs[0] rs1
     /*  183445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183457 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183462 */     GIR_RootConstrainSelectedInstOperands,
     /*  183463 */     // GIR_Coverage, 720,
     /*  183463 */     GIR_Done,
     /*  183464 */   // Label 3535: @183464
     /*  183464 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(183505), // Rule ID 722 //
     /*  183469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183486 */     // MIs[0] rs1
     /*  183486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183498 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183498 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183503 */     GIR_RootConstrainSelectedInstOperands,
     /*  183504 */     // GIR_Coverage, 722,
     /*  183504 */     GIR_Done,
     /*  183505 */   // Label 3536: @183505
     /*  183505 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(183546), // Rule ID 724 //
     /*  183510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183513 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183520 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183527 */     // MIs[0] rs1
     /*  183527 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183539 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183539 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183544 */     GIR_RootConstrainSelectedInstOperands,
     /*  183545 */     // GIR_Coverage, 724,
     /*  183545 */     GIR_Done,
     /*  183546 */   // Label 3537: @183546
     /*  183546 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(183587), // Rule ID 726 //
     /*  183551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183554 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183561 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183568 */     // MIs[0] rs1
     /*  183568 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183580 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183580 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183585 */     GIR_RootConstrainSelectedInstOperands,
     /*  183586 */     // GIR_Coverage, 726,
     /*  183586 */     GIR_Done,
     /*  183587 */   // Label 3538: @183587
     /*  183587 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(183628), // Rule ID 728 //
     /*  183592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183595 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  183602 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183609 */     // MIs[0] rs1
     /*  183609 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183621 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  183626 */     GIR_RootConstrainSelectedInstOperands,
     /*  183627 */     // GIR_Coverage, 728,
     /*  183627 */     GIR_Done,
     /*  183628 */   // Label 3539: @183628
     /*  183628 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(183669), // Rule ID 890 //
     /*  183633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183650 */     // MIs[0] rs1
     /*  183650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183662 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  183667 */     GIR_RootConstrainSelectedInstOperands,
     /*  183668 */     // GIR_Coverage, 890,
     /*  183668 */     GIR_Done,
     /*  183669 */   // Label 3540: @183669
     /*  183669 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(183710), // Rule ID 892 //
     /*  183674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183677 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183684 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183691 */     // MIs[0] rs1
     /*  183691 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183703 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  183708 */     GIR_RootConstrainSelectedInstOperands,
     /*  183709 */     // GIR_Coverage, 892,
     /*  183709 */     GIR_Done,
     /*  183710 */   // Label 3541: @183710
     /*  183710 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(183751), // Rule ID 894 //
     /*  183715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183732 */     // MIs[0] rs1
     /*  183732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183744 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  183749 */     GIR_RootConstrainSelectedInstOperands,
     /*  183750 */     // GIR_Coverage, 894,
     /*  183750 */     GIR_Done,
     /*  183751 */   // Label 3542: @183751
     /*  183751 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(183792), // Rule ID 896 //
     /*  183756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183759 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183766 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183773 */     // MIs[0] rs1
     /*  183773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183785 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183785 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  183790 */     GIR_RootConstrainSelectedInstOperands,
     /*  183791 */     // GIR_Coverage, 896,
     /*  183791 */     GIR_Done,
     /*  183792 */   // Label 3543: @183792
     /*  183792 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(183833), // Rule ID 898 //
     /*  183797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  183800 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183807 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  183810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183814 */     // MIs[0] rs1
     /*  183814 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183826 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183826 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  183831 */     GIR_RootConstrainSelectedInstOperands,
     /*  183832 */     // GIR_Coverage, 898,
     /*  183832 */     GIR_Done,
     /*  183833 */   // Label 3544: @183833
     /*  183833 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(183874), // Rule ID 900 //
     /*  183838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183841 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183848 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  183851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183855 */     // MIs[0] rs1
     /*  183855 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183867 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183867 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  183872 */     GIR_RootConstrainSelectedInstOperands,
     /*  183873 */     // GIR_Coverage, 900,
     /*  183873 */     GIR_Done,
     /*  183874 */   // Label 3545: @183874
     /*  183874 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(183915), // Rule ID 902 //
     /*  183879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183882 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183889 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  183892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183896 */     // MIs[0] rs1
     /*  183896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183908 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183908 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  183913 */     GIR_RootConstrainSelectedInstOperands,
     /*  183914 */     // GIR_Coverage, 902,
     /*  183914 */     GIR_Done,
     /*  183915 */   // Label 3546: @183915
     /*  183915 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(183956), // Rule ID 904 //
     /*  183920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  183933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183937 */     // MIs[0] rs1
     /*  183937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183949 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  183954 */     GIR_RootConstrainSelectedInstOperands,
     /*  183955 */     // GIR_Coverage, 904,
     /*  183955 */     GIR_Done,
     /*  183956 */   // Label 3547: @183956
     /*  183956 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(183997), // Rule ID 906 //
     /*  183961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  183964 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  183971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  183974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183978 */     // MIs[0] rs1
     /*  183978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  183982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  183990 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  183990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  183995 */     GIR_RootConstrainSelectedInstOperands,
     /*  183996 */     // GIR_Coverage, 906,
     /*  183996 */     GIR_Done,
     /*  183997 */   // Label 3548: @183997
     /*  183997 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(184038), // Rule ID 908 //
     /*  184002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  184005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  184012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184019 */     // MIs[0] rs1
     /*  184019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  184023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184031 */     // (atomic_load_add:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  184031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  184036 */     GIR_RootConstrainSelectedInstOperands,
     /*  184037 */     // GIR_Coverage, 908,
     /*  184037 */     GIR_Done,
     /*  184038 */   // Label 3549: @184038
     /*  184038 */   GIM_Reject,
     /*  184039 */ // Label 3519: @184039
     /*  184039 */ GIM_Reject,
     /*  184040 */ // Label 3517: @184040
     /*  184040 */ GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(185689),
     /*  184045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  184048 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(184089), // Rule ID 361 //
     /*  184053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184063 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184070 */     // MIs[0] rs1
     /*  184070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184082 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184087 */     GIR_RootConstrainSelectedInstOperands,
     /*  184088 */     // GIR_Coverage, 361,
     /*  184088 */     GIR_Done,
     /*  184089 */   // Label 3551: @184089
     /*  184089 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(184130), // Rule ID 363 //
     /*  184094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184097 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184104 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184111 */     // MIs[0] rs1
     /*  184111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184123 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184123 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ),
     /*  184128 */     GIR_RootConstrainSelectedInstOperands,
     /*  184129 */     // GIR_Coverage, 363,
     /*  184129 */     GIR_Done,
     /*  184130 */   // Label 3552: @184130
     /*  184130 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(184171), // Rule ID 365 //
     /*  184135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184138 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184145 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184152 */     // MIs[0] rs1
     /*  184152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184164 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184164 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_RL),
     /*  184169 */     GIR_RootConstrainSelectedInstOperands,
     /*  184170 */     // GIR_Coverage, 365,
     /*  184170 */     GIR_Done,
     /*  184171 */   // Label 3553: @184171
     /*  184171 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(184212), // Rule ID 367 //
     /*  184176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184179 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184186 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184193 */     // MIs[0] rs1
     /*  184193 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184205 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184205 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184210 */     GIR_RootConstrainSelectedInstOperands,
     /*  184211 */     // GIR_Coverage, 367,
     /*  184211 */     GIR_Done,
     /*  184212 */   // Label 3554: @184212
     /*  184212 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(184253), // Rule ID 369 //
     /*  184217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  184220 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184227 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184234 */     // MIs[0] rs1
     /*  184234 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184246 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W_AQ_RL),
     /*  184251 */     GIR_RootConstrainSelectedInstOperands,
     /*  184252 */     // GIR_Coverage, 369,
     /*  184252 */     GIR_Done,
     /*  184253 */   // Label 3555: @184253
     /*  184253 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(184294), // Rule ID 371 //
     /*  184258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184261 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184275 */     // MIs[0] rs1
     /*  184275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184287 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184292 */     GIR_RootConstrainSelectedInstOperands,
     /*  184293 */     // GIR_Coverage, 371,
     /*  184293 */     GIR_Done,
     /*  184294 */   // Label 3556: @184294
     /*  184294 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(184335), // Rule ID 373 //
     /*  184299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184316 */     // MIs[0] rs1
     /*  184316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184328 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184333 */     GIR_RootConstrainSelectedInstOperands,
     /*  184334 */     // GIR_Coverage, 373,
     /*  184334 */     GIR_Done,
     /*  184335 */   // Label 3557: @184335
     /*  184335 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(184376), // Rule ID 375 //
     /*  184340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184357 */     // MIs[0] rs1
     /*  184357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184369 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184374 */     GIR_RootConstrainSelectedInstOperands,
     /*  184375 */     // GIR_Coverage, 375,
     /*  184375 */     GIR_Done,
     /*  184376 */   // Label 3558: @184376
     /*  184376 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(184417), // Rule ID 377 //
     /*  184381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184398 */     // MIs[0] rs1
     /*  184398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184410 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184410 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184415 */     GIR_RootConstrainSelectedInstOperands,
     /*  184416 */     // GIR_Coverage, 377,
     /*  184416 */     GIR_Done,
     /*  184417 */   // Label 3559: @184417
     /*  184417 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(184458), // Rule ID 379 //
     /*  184422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  184425 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  184432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184439 */     // MIs[0] rs1
     /*  184439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184451 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (AMOADD_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_W),
     /*  184456 */     GIR_RootConstrainSelectedInstOperands,
     /*  184457 */     // GIR_Coverage, 379,
     /*  184457 */     GIR_Done,
     /*  184458 */   // Label 3560: @184458
     /*  184458 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(184499), // Rule ID 531 //
     /*  184463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184480 */     // MIs[0] rs1
     /*  184480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184492 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184497 */     GIR_RootConstrainSelectedInstOperands,
     /*  184498 */     // GIR_Coverage, 531,
     /*  184498 */     GIR_Done,
     /*  184499 */   // Label 3561: @184499
     /*  184499 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(184540), // Rule ID 532 //
     /*  184504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184521 */     // MIs[0] rs1
     /*  184521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184533 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ),
     /*  184538 */     GIR_RootConstrainSelectedInstOperands,
     /*  184539 */     // GIR_Coverage, 532,
     /*  184539 */     GIR_Done,
     /*  184540 */   // Label 3562: @184540
     /*  184540 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(184581), // Rule ID 533 //
     /*  184545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184562 */     // MIs[0] rs1
     /*  184562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184574 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_RL),
     /*  184579 */     GIR_RootConstrainSelectedInstOperands,
     /*  184580 */     // GIR_Coverage, 533,
     /*  184580 */     GIR_Done,
     /*  184581 */   // Label 3563: @184581
     /*  184581 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(184622), // Rule ID 534 //
     /*  184586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184603 */     // MIs[0] rs1
     /*  184603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184615 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  184620 */     GIR_RootConstrainSelectedInstOperands,
     /*  184621 */     // GIR_Coverage, 534,
     /*  184621 */     GIR_Done,
     /*  184622 */   // Label 3564: @184622
     /*  184622 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(184663), // Rule ID 535 //
     /*  184627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  184630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184644 */     // MIs[0] rs1
     /*  184644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184656 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D_AQ_RL),
     /*  184661 */     GIR_RootConstrainSelectedInstOperands,
     /*  184662 */     // GIR_Coverage, 535,
     /*  184662 */     GIR_Done,
     /*  184663 */   // Label 3565: @184663
     /*  184663 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(184704), // Rule ID 536 //
     /*  184668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  184671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184685 */     // MIs[0] rs1
     /*  184685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184697 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184702 */     GIR_RootConstrainSelectedInstOperands,
     /*  184703 */     // GIR_Coverage, 536,
     /*  184703 */     GIR_Done,
     /*  184704 */   // Label 3566: @184704
     /*  184704 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(184745), // Rule ID 537 //
     /*  184709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  184712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184726 */     // MIs[0] rs1
     /*  184726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184738 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184743 */     GIR_RootConstrainSelectedInstOperands,
     /*  184744 */     // GIR_Coverage, 537,
     /*  184744 */     GIR_Done,
     /*  184745 */   // Label 3567: @184745
     /*  184745 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(184786), // Rule ID 538 //
     /*  184750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  184753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184767 */     // MIs[0] rs1
     /*  184767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184779 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184784 */     GIR_RootConstrainSelectedInstOperands,
     /*  184785 */     // GIR_Coverage, 538,
     /*  184785 */     GIR_Done,
     /*  184786 */   // Label 3568: @184786
     /*  184786 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(184827), // Rule ID 539 //
     /*  184791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  184794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  184804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184808 */     // MIs[0] rs1
     /*  184808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184820 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184825 */     GIR_RootConstrainSelectedInstOperands,
     /*  184826 */     // GIR_Coverage, 539,
     /*  184826 */     GIR_Done,
     /*  184827 */   // Label 3569: @184827
     /*  184827 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(184868), // Rule ID 540 //
     /*  184832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  184835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  184842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  184845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184849 */     // MIs[0] rs1
     /*  184849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184861 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (AMOADD_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_D),
     /*  184866 */     GIR_RootConstrainSelectedInstOperands,
     /*  184867 */     // GIR_Coverage, 540,
     /*  184867 */     GIR_Done,
     /*  184868 */   // Label 3570: @184868
     /*  184868 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(184909), // Rule ID 709 //
     /*  184873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  184876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  184886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184890 */     // MIs[0] rs1
     /*  184890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184902 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  184907 */     GIR_RootConstrainSelectedInstOperands,
     /*  184908 */     // GIR_Coverage, 709,
     /*  184908 */     GIR_Done,
     /*  184909 */   // Label 3571: @184909
     /*  184909 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(184950), // Rule ID 711 //
     /*  184914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  184917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  184927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184931 */     // MIs[0] rs1
     /*  184931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184943 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ),
     /*  184948 */     GIR_RootConstrainSelectedInstOperands,
     /*  184949 */     // GIR_Coverage, 711,
     /*  184949 */     GIR_Done,
     /*  184950 */   // Label 3572: @184950
     /*  184950 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(184991), // Rule ID 713 //
     /*  184955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  184958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  184965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  184968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184972 */     // MIs[0] rs1
     /*  184972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  184976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  184984 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  184984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_RL),
     /*  184989 */     GIR_RootConstrainSelectedInstOperands,
     /*  184990 */     // GIR_Coverage, 713,
     /*  184990 */     GIR_Done,
     /*  184991 */   // Label 3573: @184991
     /*  184991 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(185032), // Rule ID 715 //
     /*  184996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  184999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185013 */     // MIs[0] rs1
     /*  185013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185025 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185030 */     GIR_RootConstrainSelectedInstOperands,
     /*  185031 */     // GIR_Coverage, 715,
     /*  185031 */     GIR_Done,
     /*  185032 */   // Label 3574: @185032
     /*  185032 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(185073), // Rule ID 717 //
     /*  185037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185054 */     // MIs[0] rs1
     /*  185054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185066 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B_AQ_RL),
     /*  185071 */     GIR_RootConstrainSelectedInstOperands,
     /*  185072 */     // GIR_Coverage, 717,
     /*  185072 */     GIR_Done,
     /*  185073 */   // Label 3575: @185073
     /*  185073 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(185114), // Rule ID 719 //
     /*  185078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185095 */     // MIs[0] rs1
     /*  185095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185107 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185112 */     GIR_RootConstrainSelectedInstOperands,
     /*  185113 */     // GIR_Coverage, 719,
     /*  185113 */     GIR_Done,
     /*  185114 */   // Label 3576: @185114
     /*  185114 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(185155), // Rule ID 721 //
     /*  185119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185136 */     // MIs[0] rs1
     /*  185136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185148 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185153 */     GIR_RootConstrainSelectedInstOperands,
     /*  185154 */     // GIR_Coverage, 721,
     /*  185154 */     GIR_Done,
     /*  185155 */   // Label 3577: @185155
     /*  185155 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(185196), // Rule ID 723 //
     /*  185160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185177 */     // MIs[0] rs1
     /*  185177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185189 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185194 */     GIR_RootConstrainSelectedInstOperands,
     /*  185195 */     // GIR_Coverage, 723,
     /*  185195 */     GIR_Done,
     /*  185196 */   // Label 3578: @185196
     /*  185196 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(185237), // Rule ID 725 //
     /*  185201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185218 */     // MIs[0] rs1
     /*  185218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185230 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185235 */     GIR_RootConstrainSelectedInstOperands,
     /*  185236 */     // GIR_Coverage, 725,
     /*  185236 */     GIR_Done,
     /*  185237 */   // Label 3579: @185237
     /*  185237 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(185278), // Rule ID 727 //
     /*  185242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  185252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185259 */     // MIs[0] rs1
     /*  185259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185271 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (AMOADD_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_B),
     /*  185276 */     GIR_RootConstrainSelectedInstOperands,
     /*  185277 */     // GIR_Coverage, 727,
     /*  185277 */     GIR_Done,
     /*  185278 */   // Label 3580: @185278
     /*  185278 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(185319), // Rule ID 889 //
     /*  185283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185300 */     // MIs[0] rs1
     /*  185300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185312 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185317 */     GIR_RootConstrainSelectedInstOperands,
     /*  185318 */     // GIR_Coverage, 889,
     /*  185318 */     GIR_Done,
     /*  185319 */   // Label 3581: @185319
     /*  185319 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(185360), // Rule ID 891 //
     /*  185324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185341 */     // MIs[0] rs1
     /*  185341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185353 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ),
     /*  185358 */     GIR_RootConstrainSelectedInstOperands,
     /*  185359 */     // GIR_Coverage, 891,
     /*  185359 */     GIR_Done,
     /*  185360 */   // Label 3582: @185360
     /*  185360 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(185401), // Rule ID 893 //
     /*  185365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185382 */     // MIs[0] rs1
     /*  185382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185394 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_RL),
     /*  185399 */     GIR_RootConstrainSelectedInstOperands,
     /*  185400 */     // GIR_Coverage, 893,
     /*  185400 */     GIR_Done,
     /*  185401 */   // Label 3583: @185401
     /*  185401 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(185442), // Rule ID 895 //
     /*  185406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185423 */     // MIs[0] rs1
     /*  185423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185435 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  185440 */     GIR_RootConstrainSelectedInstOperands,
     /*  185441 */     // GIR_Coverage, 895,
     /*  185441 */     GIR_Done,
     /*  185442 */   // Label 3584: @185442
     /*  185442 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(185483), // Rule ID 897 //
     /*  185447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  185450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185464 */     // MIs[0] rs1
     /*  185464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185476 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H_AQ_RL),
     /*  185481 */     GIR_RootConstrainSelectedInstOperands,
     /*  185482 */     // GIR_Coverage, 897,
     /*  185482 */     GIR_Done,
     /*  185483 */   // Label 3585: @185483
     /*  185483 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(185524), // Rule ID 899 //
     /*  185488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185505 */     // MIs[0] rs1
     /*  185505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185517 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185522 */     GIR_RootConstrainSelectedInstOperands,
     /*  185523 */     // GIR_Coverage, 899,
     /*  185523 */     GIR_Done,
     /*  185524 */   // Label 3586: @185524
     /*  185524 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(185565), // Rule ID 901 //
     /*  185529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185546 */     // MIs[0] rs1
     /*  185546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185558 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185563 */     GIR_RootConstrainSelectedInstOperands,
     /*  185564 */     // GIR_Coverage, 901,
     /*  185564 */     GIR_Done,
     /*  185565 */   // Label 3587: @185565
     /*  185565 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(185606), // Rule ID 903 //
     /*  185570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185587 */     // MIs[0] rs1
     /*  185587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185599 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185604 */     GIR_RootConstrainSelectedInstOperands,
     /*  185605 */     // GIR_Coverage, 903,
     /*  185605 */     GIR_Done,
     /*  185606 */   // Label 3588: @185606
     /*  185606 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(185647), // Rule ID 905 //
     /*  185611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185628 */     // MIs[0] rs1
     /*  185628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185640 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185645 */     GIR_RootConstrainSelectedInstOperands,
     /*  185646 */     // GIR_Coverage, 905,
     /*  185646 */     GIR_Done,
     /*  185647 */   // Label 3589: @185647
     /*  185647 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(185688), // Rule ID 907 //
     /*  185652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  185655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  185662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185669 */     // MIs[0] rs1
     /*  185669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  185673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185681 */     // (atomic_load_add:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (AMOADD_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  185681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOADD_H),
     /*  185686 */     GIR_RootConstrainSelectedInstOperands,
     /*  185687 */     // GIR_Coverage, 907,
     /*  185687 */     GIR_Done,
     /*  185688 */   // Label 3590: @185688
     /*  185688 */   GIM_Reject,
     /*  185689 */ // Label 3550: @185689
     /*  185689 */ GIM_Reject,
     /*  185690 */ // Label 3518: @185690
     /*  185690 */ GIM_Reject,
     /*  185691 */ // Label 28: @185691
     /*  185691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3593*/ GIMT_Encode4(188600),
     /*  185702 */ /*GILLT_s32*//*Label 3591*/ GIMT_Encode4(185710),
     /*  185706 */ /*GILLT_s64*//*Label 3592*/ GIMT_Encode4(186950),
     /*  185710 */ // Label 3591: @185710
     /*  185710 */ GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(186949),
     /*  185715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  185718 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(185759), // Rule ID 382 //
     /*  185723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  185726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185733 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185740 */     // MIs[0] rs1
     /*  185740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185752 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  185757 */     GIR_RootConstrainSelectedInstOperands,
     /*  185758 */     // GIR_Coverage, 382,
     /*  185758 */     GIR_Done,
     /*  185759 */   // Label 3595: @185759
     /*  185759 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(185800), // Rule ID 384 //
     /*  185764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  185767 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185781 */     // MIs[0] rs1
     /*  185781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185793 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185793 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  185798 */     GIR_RootConstrainSelectedInstOperands,
     /*  185799 */     // GIR_Coverage, 384,
     /*  185799 */     GIR_Done,
     /*  185800 */   // Label 3596: @185800
     /*  185800 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(185841), // Rule ID 386 //
     /*  185805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  185808 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185815 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  185818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185822 */     // MIs[0] rs1
     /*  185822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185834 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  185839 */     GIR_RootConstrainSelectedInstOperands,
     /*  185840 */     // GIR_Coverage, 386,
     /*  185840 */     GIR_Done,
     /*  185841 */   // Label 3597: @185841
     /*  185841 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(185882), // Rule ID 388 //
     /*  185846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  185849 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185856 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  185859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185863 */     // MIs[0] rs1
     /*  185863 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185875 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  185880 */     GIR_RootConstrainSelectedInstOperands,
     /*  185881 */     // GIR_Coverage, 388,
     /*  185881 */     GIR_Done,
     /*  185882 */   // Label 3598: @185882
     /*  185882 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(185923), // Rule ID 390 //
     /*  185887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  185890 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185897 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  185900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185904 */     // MIs[0] rs1
     /*  185904 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185916 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185916 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  185921 */     GIR_RootConstrainSelectedInstOperands,
     /*  185922 */     // GIR_Coverage, 390,
     /*  185922 */     GIR_Done,
     /*  185923 */   // Label 3599: @185923
     /*  185923 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(185964), // Rule ID 392 //
     /*  185928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  185931 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185938 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  185941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185945 */     // MIs[0] rs1
     /*  185945 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185957 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185957 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  185962 */     GIR_RootConstrainSelectedInstOperands,
     /*  185963 */     // GIR_Coverage, 392,
     /*  185963 */     GIR_Done,
     /*  185964 */   // Label 3600: @185964
     /*  185964 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(186005), // Rule ID 394 //
     /*  185969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  185972 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  185979 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  185982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185986 */     // MIs[0] rs1
     /*  185986 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  185990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  185998 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  185998 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186003 */     GIR_RootConstrainSelectedInstOperands,
     /*  186004 */     // GIR_Coverage, 394,
     /*  186004 */     GIR_Done,
     /*  186005 */   // Label 3601: @186005
     /*  186005 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(186046), // Rule ID 396 //
     /*  186010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186013 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186020 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186027 */     // MIs[0] rs1
     /*  186027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186039 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186044 */     GIR_RootConstrainSelectedInstOperands,
     /*  186045 */     // GIR_Coverage, 396,
     /*  186045 */     GIR_Done,
     /*  186046 */   // Label 3602: @186046
     /*  186046 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(186087), // Rule ID 398 //
     /*  186051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186068 */     // MIs[0] rs1
     /*  186068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186080 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186085 */     GIR_RootConstrainSelectedInstOperands,
     /*  186086 */     // GIR_Coverage, 398,
     /*  186086 */     GIR_Done,
     /*  186087 */   // Label 3603: @186087
     /*  186087 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(186128), // Rule ID 400 //
     /*  186092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  186095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186109 */     // MIs[0] rs1
     /*  186109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186121 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186121 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186126 */     GIR_RootConstrainSelectedInstOperands,
     /*  186127 */     // GIR_Coverage, 400,
     /*  186127 */     GIR_Done,
     /*  186128 */   // Label 3604: @186128
     /*  186128 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(186169), // Rule ID 730 //
     /*  186133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186136 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186143 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186150 */     // MIs[0] rs1
     /*  186150 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186162 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186167 */     GIR_RootConstrainSelectedInstOperands,
     /*  186168 */     // GIR_Coverage, 730,
     /*  186168 */     GIR_Done,
     /*  186169 */   // Label 3605: @186169
     /*  186169 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(186210), // Rule ID 732 //
     /*  186174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186177 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186184 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186191 */     // MIs[0] rs1
     /*  186191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186203 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186203 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  186208 */     GIR_RootConstrainSelectedInstOperands,
     /*  186209 */     // GIR_Coverage, 732,
     /*  186209 */     GIR_Done,
     /*  186210 */   // Label 3606: @186210
     /*  186210 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(186251), // Rule ID 734 //
     /*  186215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186232 */     // MIs[0] rs1
     /*  186232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186244 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  186249 */     GIR_RootConstrainSelectedInstOperands,
     /*  186250 */     // GIR_Coverage, 734,
     /*  186250 */     GIR_Done,
     /*  186251 */   // Label 3607: @186251
     /*  186251 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(186292), // Rule ID 736 //
     /*  186256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186273 */     // MIs[0] rs1
     /*  186273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186285 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186290 */     GIR_RootConstrainSelectedInstOperands,
     /*  186291 */     // GIR_Coverage, 736,
     /*  186291 */     GIR_Done,
     /*  186292 */   // Label 3608: @186292
     /*  186292 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(186333), // Rule ID 738 //
     /*  186297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186314 */     // MIs[0] rs1
     /*  186314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186326 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  186331 */     GIR_RootConstrainSelectedInstOperands,
     /*  186332 */     // GIR_Coverage, 738,
     /*  186332 */     GIR_Done,
     /*  186333 */   // Label 3609: @186333
     /*  186333 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(186374), // Rule ID 740 //
     /*  186338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186355 */     // MIs[0] rs1
     /*  186355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186367 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186367 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186372 */     GIR_RootConstrainSelectedInstOperands,
     /*  186373 */     // GIR_Coverage, 740,
     /*  186373 */     GIR_Done,
     /*  186374 */   // Label 3610: @186374
     /*  186374 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(186415), // Rule ID 742 //
     /*  186379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186396 */     // MIs[0] rs1
     /*  186396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186408 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186413 */     GIR_RootConstrainSelectedInstOperands,
     /*  186414 */     // GIR_Coverage, 742,
     /*  186414 */     GIR_Done,
     /*  186415 */   // Label 3611: @186415
     /*  186415 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(186456), // Rule ID 744 //
     /*  186420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186437 */     // MIs[0] rs1
     /*  186437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186449 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186454 */     GIR_RootConstrainSelectedInstOperands,
     /*  186455 */     // GIR_Coverage, 744,
     /*  186455 */     GIR_Done,
     /*  186456 */   // Label 3612: @186456
     /*  186456 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(186497), // Rule ID 746 //
     /*  186461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186464 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186471 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186478 */     // MIs[0] rs1
     /*  186478 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186490 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186490 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186495 */     GIR_RootConstrainSelectedInstOperands,
     /*  186496 */     // GIR_Coverage, 746,
     /*  186496 */     GIR_Done,
     /*  186497 */   // Label 3613: @186497
     /*  186497 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(186538), // Rule ID 748 //
     /*  186502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186505 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  186512 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186519 */     // MIs[0] rs1
     /*  186519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186523 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186531 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  186536 */     GIR_RootConstrainSelectedInstOperands,
     /*  186537 */     // GIR_Coverage, 748,
     /*  186537 */     GIR_Done,
     /*  186538 */   // Label 3614: @186538
     /*  186538 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(186579), // Rule ID 910 //
     /*  186543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186546 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186553 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186560 */     // MIs[0] rs1
     /*  186560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186572 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186577 */     GIR_RootConstrainSelectedInstOperands,
     /*  186578 */     // GIR_Coverage, 910,
     /*  186578 */     GIR_Done,
     /*  186579 */   // Label 3615: @186579
     /*  186579 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(186620), // Rule ID 912 //
     /*  186584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186587 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186594 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186601 */     // MIs[0] rs1
     /*  186601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186613 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186613 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  186618 */     GIR_RootConstrainSelectedInstOperands,
     /*  186619 */     // GIR_Coverage, 912,
     /*  186619 */     GIR_Done,
     /*  186620 */   // Label 3616: @186620
     /*  186620 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(186661), // Rule ID 914 //
     /*  186625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186628 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186635 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186642 */     // MIs[0] rs1
     /*  186642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186654 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  186659 */     GIR_RootConstrainSelectedInstOperands,
     /*  186660 */     // GIR_Coverage, 914,
     /*  186660 */     GIR_Done,
     /*  186661 */   // Label 3617: @186661
     /*  186661 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(186702), // Rule ID 916 //
     /*  186666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186669 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186683 */     // MIs[0] rs1
     /*  186683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186695 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186695 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  186700 */     GIR_RootConstrainSelectedInstOperands,
     /*  186701 */     // GIR_Coverage, 916,
     /*  186701 */     GIR_Done,
     /*  186702 */   // Label 3618: @186702
     /*  186702 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(186743), // Rule ID 918 //
     /*  186707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  186710 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186717 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186724 */     // MIs[0] rs1
     /*  186724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186736 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  186741 */     GIR_RootConstrainSelectedInstOperands,
     /*  186742 */     // GIR_Coverage, 918,
     /*  186742 */     GIR_Done,
     /*  186743 */   // Label 3619: @186743
     /*  186743 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(186784), // Rule ID 920 //
     /*  186748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186751 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186765 */     // MIs[0] rs1
     /*  186765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186777 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186782 */     GIR_RootConstrainSelectedInstOperands,
     /*  186783 */     // GIR_Coverage, 920,
     /*  186783 */     GIR_Done,
     /*  186784 */   // Label 3620: @186784
     /*  186784 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(186825), // Rule ID 922 //
     /*  186789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  186802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186806 */     // MIs[0] rs1
     /*  186806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186818 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186818 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186823 */     GIR_RootConstrainSelectedInstOperands,
     /*  186824 */     // GIR_Coverage, 922,
     /*  186824 */     GIR_Done,
     /*  186825 */   // Label 3621: @186825
     /*  186825 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(186866), // Rule ID 924 //
     /*  186830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186833 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186840 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  186843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186847 */     // MIs[0] rs1
     /*  186847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186859 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186859 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186864 */     GIR_RootConstrainSelectedInstOperands,
     /*  186865 */     // GIR_Coverage, 924,
     /*  186865 */     GIR_Done,
     /*  186866 */   // Label 3622: @186866
     /*  186866 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(186907), // Rule ID 926 //
     /*  186871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186874 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186881 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  186884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186888 */     // MIs[0] rs1
     /*  186888 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186900 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186900 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186905 */     GIR_RootConstrainSelectedInstOperands,
     /*  186906 */     // GIR_Coverage, 926,
     /*  186906 */     GIR_Done,
     /*  186907 */   // Label 3623: @186907
     /*  186907 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(186948), // Rule ID 928 //
     /*  186912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  186915 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  186922 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  186925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186929 */     // MIs[0] rs1
     /*  186929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  186933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186941 */     // (atomic_load_and:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  186941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  186946 */     GIR_RootConstrainSelectedInstOperands,
     /*  186947 */     // GIR_Coverage, 928,
     /*  186947 */     GIR_Done,
     /*  186948 */   // Label 3624: @186948
     /*  186948 */   GIM_Reject,
     /*  186949 */ // Label 3594: @186949
     /*  186949 */ GIM_Reject,
     /*  186950 */ // Label 3592: @186950
     /*  186950 */ GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(188599),
     /*  186955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  186958 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(186999), // Rule ID 381 //
     /*  186963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  186966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  186973 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  186976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186980 */     // MIs[0] rs1
     /*  186980 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  186984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  186992 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  186992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  186997 */     GIR_RootConstrainSelectedInstOperands,
     /*  186998 */     // GIR_Coverage, 381,
     /*  186998 */     GIR_Done,
     /*  186999 */   // Label 3626: @186999
     /*  186999 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(187040), // Rule ID 383 //
     /*  187004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187007 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187014 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187021 */     // MIs[0] rs1
     /*  187021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187033 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187033 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ),
     /*  187038 */     GIR_RootConstrainSelectedInstOperands,
     /*  187039 */     // GIR_Coverage, 383,
     /*  187039 */     GIR_Done,
     /*  187040 */   // Label 3627: @187040
     /*  187040 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(187081), // Rule ID 385 //
     /*  187045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187062 */     // MIs[0] rs1
     /*  187062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187074 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_RL),
     /*  187079 */     GIR_RootConstrainSelectedInstOperands,
     /*  187080 */     // GIR_Coverage, 385,
     /*  187080 */     GIR_Done,
     /*  187081 */   // Label 3628: @187081
     /*  187081 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(187122), // Rule ID 387 //
     /*  187086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187089 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187096 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187103 */     // MIs[0] rs1
     /*  187103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187115 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187120 */     GIR_RootConstrainSelectedInstOperands,
     /*  187121 */     // GIR_Coverage, 387,
     /*  187121 */     GIR_Done,
     /*  187122 */   // Label 3629: @187122
     /*  187122 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(187163), // Rule ID 389 //
     /*  187127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  187130 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187144 */     // MIs[0] rs1
     /*  187144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187156 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187156 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W_AQ_RL),
     /*  187161 */     GIR_RootConstrainSelectedInstOperands,
     /*  187162 */     // GIR_Coverage, 389,
     /*  187162 */     GIR_Done,
     /*  187163 */   // Label 3630: @187163
     /*  187163 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(187204), // Rule ID 391 //
     /*  187168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187171 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187178 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187185 */     // MIs[0] rs1
     /*  187185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187197 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187202 */     GIR_RootConstrainSelectedInstOperands,
     /*  187203 */     // GIR_Coverage, 391,
     /*  187203 */     GIR_Done,
     /*  187204 */   // Label 3631: @187204
     /*  187204 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(187245), // Rule ID 393 //
     /*  187209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187212 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187219 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187226 */     // MIs[0] rs1
     /*  187226 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187238 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187238 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187243 */     GIR_RootConstrainSelectedInstOperands,
     /*  187244 */     // GIR_Coverage, 393,
     /*  187244 */     GIR_Done,
     /*  187245 */   // Label 3632: @187245
     /*  187245 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(187286), // Rule ID 395 //
     /*  187250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187267 */     // MIs[0] rs1
     /*  187267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187279 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187284 */     GIR_RootConstrainSelectedInstOperands,
     /*  187285 */     // GIR_Coverage, 395,
     /*  187285 */     GIR_Done,
     /*  187286 */   // Label 3633: @187286
     /*  187286 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(187327), // Rule ID 397 //
     /*  187291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187308 */     // MIs[0] rs1
     /*  187308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187320 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187325 */     GIR_RootConstrainSelectedInstOperands,
     /*  187326 */     // GIR_Coverage, 397,
     /*  187326 */     GIR_Done,
     /*  187327 */   // Label 3634: @187327
     /*  187327 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(187368), // Rule ID 399 //
     /*  187332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  187335 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  187342 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187349 */     // MIs[0] rs1
     /*  187349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187361 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (AMOAND_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_W),
     /*  187366 */     GIR_RootConstrainSelectedInstOperands,
     /*  187367 */     // GIR_Coverage, 399,
     /*  187367 */     GIR_Done,
     /*  187368 */   // Label 3635: @187368
     /*  187368 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(187409), // Rule ID 541 //
     /*  187373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187376 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187390 */     // MIs[0] rs1
     /*  187390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187402 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187402 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187407 */     GIR_RootConstrainSelectedInstOperands,
     /*  187408 */     // GIR_Coverage, 541,
     /*  187408 */     GIR_Done,
     /*  187409 */   // Label 3636: @187409
     /*  187409 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(187450), // Rule ID 542 //
     /*  187414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187431 */     // MIs[0] rs1
     /*  187431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187443 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ),
     /*  187448 */     GIR_RootConstrainSelectedInstOperands,
     /*  187449 */     // GIR_Coverage, 542,
     /*  187449 */     GIR_Done,
     /*  187450 */   // Label 3637: @187450
     /*  187450 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(187491), // Rule ID 543 //
     /*  187455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187472 */     // MIs[0] rs1
     /*  187472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187484 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_RL),
     /*  187489 */     GIR_RootConstrainSelectedInstOperands,
     /*  187490 */     // GIR_Coverage, 543,
     /*  187490 */     GIR_Done,
     /*  187491 */   // Label 3638: @187491
     /*  187491 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(187532), // Rule ID 544 //
     /*  187496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187513 */     // MIs[0] rs1
     /*  187513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187525 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  187530 */     GIR_RootConstrainSelectedInstOperands,
     /*  187531 */     // GIR_Coverage, 544,
     /*  187531 */     GIR_Done,
     /*  187532 */   // Label 3639: @187532
     /*  187532 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(187573), // Rule ID 545 //
     /*  187537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  187540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187554 */     // MIs[0] rs1
     /*  187554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187566 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D_AQ_RL),
     /*  187571 */     GIR_RootConstrainSelectedInstOperands,
     /*  187572 */     // GIR_Coverage, 545,
     /*  187572 */     GIR_Done,
     /*  187573 */   // Label 3640: @187573
     /*  187573 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(187614), // Rule ID 546 //
     /*  187578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  187581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187595 */     // MIs[0] rs1
     /*  187595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187607 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187612 */     GIR_RootConstrainSelectedInstOperands,
     /*  187613 */     // GIR_Coverage, 546,
     /*  187613 */     GIR_Done,
     /*  187614 */   // Label 3641: @187614
     /*  187614 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(187655), // Rule ID 547 //
     /*  187619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  187622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187636 */     // MIs[0] rs1
     /*  187636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187648 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187653 */     GIR_RootConstrainSelectedInstOperands,
     /*  187654 */     // GIR_Coverage, 547,
     /*  187654 */     GIR_Done,
     /*  187655 */   // Label 3642: @187655
     /*  187655 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(187696), // Rule ID 548 //
     /*  187660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  187663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187677 */     // MIs[0] rs1
     /*  187677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187689 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187694 */     GIR_RootConstrainSelectedInstOperands,
     /*  187695 */     // GIR_Coverage, 548,
     /*  187695 */     GIR_Done,
     /*  187696 */   // Label 3643: @187696
     /*  187696 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(187737), // Rule ID 549 //
     /*  187701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  187704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187718 */     // MIs[0] rs1
     /*  187718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187730 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187735 */     GIR_RootConstrainSelectedInstOperands,
     /*  187736 */     // GIR_Coverage, 549,
     /*  187736 */     GIR_Done,
     /*  187737 */   // Label 3644: @187737
     /*  187737 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(187778), // Rule ID 550 //
     /*  187742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  187745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  187752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187759 */     // MIs[0] rs1
     /*  187759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187771 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (AMOAND_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_D),
     /*  187776 */     GIR_RootConstrainSelectedInstOperands,
     /*  187777 */     // GIR_Coverage, 550,
     /*  187777 */     GIR_Done,
     /*  187778 */   // Label 3645: @187778
     /*  187778 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(187819), // Rule ID 729 //
     /*  187783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  187786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  187796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187800 */     // MIs[0] rs1
     /*  187800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187812 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  187817 */     GIR_RootConstrainSelectedInstOperands,
     /*  187818 */     // GIR_Coverage, 729,
     /*  187818 */     GIR_Done,
     /*  187819 */   // Label 3646: @187819
     /*  187819 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(187860), // Rule ID 731 //
     /*  187824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  187827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  187837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187841 */     // MIs[0] rs1
     /*  187841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187853 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ),
     /*  187858 */     GIR_RootConstrainSelectedInstOperands,
     /*  187859 */     // GIR_Coverage, 731,
     /*  187859 */     GIR_Done,
     /*  187860 */   // Label 3647: @187860
     /*  187860 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(187901), // Rule ID 733 //
     /*  187865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  187868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  187878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187882 */     // MIs[0] rs1
     /*  187882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187894 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_RL),
     /*  187899 */     GIR_RootConstrainSelectedInstOperands,
     /*  187900 */     // GIR_Coverage, 733,
     /*  187900 */     GIR_Done,
     /*  187901 */   // Label 3648: @187901
     /*  187901 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(187942), // Rule ID 735 //
     /*  187906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  187909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  187919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187923 */     // MIs[0] rs1
     /*  187923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187935 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187940 */     GIR_RootConstrainSelectedInstOperands,
     /*  187941 */     // GIR_Coverage, 735,
     /*  187941 */     GIR_Done,
     /*  187942 */   // Label 3649: @187942
     /*  187942 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(187983), // Rule ID 737 //
     /*  187947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  187950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  187960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187964 */     // MIs[0] rs1
     /*  187964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  187968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  187976 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  187976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B_AQ_RL),
     /*  187981 */     GIR_RootConstrainSelectedInstOperands,
     /*  187982 */     // GIR_Coverage, 737,
     /*  187982 */     GIR_Done,
     /*  187983 */   // Label 3650: @187983
     /*  187983 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(188024), // Rule ID 739 //
     /*  187988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  187991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  187998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188005 */     // MIs[0] rs1
     /*  188005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188017 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188022 */     GIR_RootConstrainSelectedInstOperands,
     /*  188023 */     // GIR_Coverage, 739,
     /*  188023 */     GIR_Done,
     /*  188024 */   // Label 3651: @188024
     /*  188024 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(188065), // Rule ID 741 //
     /*  188029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188046 */     // MIs[0] rs1
     /*  188046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188058 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188063 */     GIR_RootConstrainSelectedInstOperands,
     /*  188064 */     // GIR_Coverage, 741,
     /*  188064 */     GIR_Done,
     /*  188065 */   // Label 3652: @188065
     /*  188065 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(188106), // Rule ID 743 //
     /*  188070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188087 */     // MIs[0] rs1
     /*  188087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188099 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188104 */     GIR_RootConstrainSelectedInstOperands,
     /*  188105 */     // GIR_Coverage, 743,
     /*  188105 */     GIR_Done,
     /*  188106 */   // Label 3653: @188106
     /*  188106 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(188147), // Rule ID 745 //
     /*  188111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188128 */     // MIs[0] rs1
     /*  188128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188140 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188145 */     GIR_RootConstrainSelectedInstOperands,
     /*  188146 */     // GIR_Coverage, 745,
     /*  188146 */     GIR_Done,
     /*  188147 */   // Label 3654: @188147
     /*  188147 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(188188), // Rule ID 747 //
     /*  188152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  188162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188169 */     // MIs[0] rs1
     /*  188169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188181 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (AMOAND_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_B),
     /*  188186 */     GIR_RootConstrainSelectedInstOperands,
     /*  188187 */     // GIR_Coverage, 747,
     /*  188187 */     GIR_Done,
     /*  188188 */   // Label 3655: @188188
     /*  188188 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(188229), // Rule ID 909 //
     /*  188193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188210 */     // MIs[0] rs1
     /*  188210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188222 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188227 */     GIR_RootConstrainSelectedInstOperands,
     /*  188228 */     // GIR_Coverage, 909,
     /*  188228 */     GIR_Done,
     /*  188229 */   // Label 3656: @188229
     /*  188229 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(188270), // Rule ID 911 //
     /*  188234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188251 */     // MIs[0] rs1
     /*  188251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188263 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ),
     /*  188268 */     GIR_RootConstrainSelectedInstOperands,
     /*  188269 */     // GIR_Coverage, 911,
     /*  188269 */     GIR_Done,
     /*  188270 */   // Label 3657: @188270
     /*  188270 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(188311), // Rule ID 913 //
     /*  188275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188292 */     // MIs[0] rs1
     /*  188292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188304 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_RL),
     /*  188309 */     GIR_RootConstrainSelectedInstOperands,
     /*  188310 */     // GIR_Coverage, 913,
     /*  188310 */     GIR_Done,
     /*  188311 */   // Label 3658: @188311
     /*  188311 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(188352), // Rule ID 915 //
     /*  188316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188333 */     // MIs[0] rs1
     /*  188333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188345 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188350 */     GIR_RootConstrainSelectedInstOperands,
     /*  188351 */     // GIR_Coverage, 915,
     /*  188351 */     GIR_Done,
     /*  188352 */   // Label 3659: @188352
     /*  188352 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(188393), // Rule ID 917 //
     /*  188357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  188360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188374 */     // MIs[0] rs1
     /*  188374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188386 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H_AQ_RL),
     /*  188391 */     GIR_RootConstrainSelectedInstOperands,
     /*  188392 */     // GIR_Coverage, 917,
     /*  188392 */     GIR_Done,
     /*  188393 */   // Label 3660: @188393
     /*  188393 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(188434), // Rule ID 919 //
     /*  188398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188415 */     // MIs[0] rs1
     /*  188415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188427 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188432 */     GIR_RootConstrainSelectedInstOperands,
     /*  188433 */     // GIR_Coverage, 919,
     /*  188433 */     GIR_Done,
     /*  188434 */   // Label 3661: @188434
     /*  188434 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(188475), // Rule ID 921 //
     /*  188439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188456 */     // MIs[0] rs1
     /*  188456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188468 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188473 */     GIR_RootConstrainSelectedInstOperands,
     /*  188474 */     // GIR_Coverage, 921,
     /*  188474 */     GIR_Done,
     /*  188475 */   // Label 3662: @188475
     /*  188475 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(188516), // Rule ID 923 //
     /*  188480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188497 */     // MIs[0] rs1
     /*  188497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188509 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188514 */     GIR_RootConstrainSelectedInstOperands,
     /*  188515 */     // GIR_Coverage, 923,
     /*  188515 */     GIR_Done,
     /*  188516 */   // Label 3663: @188516
     /*  188516 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(188557), // Rule ID 925 //
     /*  188521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188538 */     // MIs[0] rs1
     /*  188538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188550 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188555 */     GIR_RootConstrainSelectedInstOperands,
     /*  188556 */     // GIR_Coverage, 925,
     /*  188556 */     GIR_Done,
     /*  188557 */   // Label 3664: @188557
     /*  188557 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(188598), // Rule ID 927 //
     /*  188562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  188565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  188572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188579 */     // MIs[0] rs1
     /*  188579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  188583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188591 */     // (atomic_load_and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (AMOAND_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  188591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOAND_H),
     /*  188596 */     GIR_RootConstrainSelectedInstOperands,
     /*  188597 */     // GIR_Coverage, 927,
     /*  188597 */     GIR_Done,
     /*  188598 */   // Label 3665: @188598
     /*  188598 */   GIM_Reject,
     /*  188599 */ // Label 3625: @188599
     /*  188599 */ GIM_Reject,
     /*  188600 */ // Label 3593: @188600
     /*  188600 */ GIM_Reject,
     /*  188601 */ // Label 29: @188601
     /*  188601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3668*/ GIMT_Encode4(189512),
     /*  188612 */ /*GILLT_s32*//*Label 3666*/ GIMT_Encode4(188620),
     /*  188616 */ /*GILLT_s64*//*Label 3667*/ GIMT_Encode4(188902),
     /*  188620 */ // Label 3666: @188620
     /*  188620 */ GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(188901),
     /*  188625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  188628 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188635 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(188688), // Rule ID 612 //
     /*  188640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  188643 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188650 */     // MIs[0] addr
     /*  188650 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188662 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 2:{ *:[i32] })
     /*  188662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188670 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188675 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188677 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  188682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188686 */     GIR_RootConstrainSelectedInstOperands,
     /*  188687 */     // GIR_Coverage, 612,
     /*  188687 */     GIR_EraseRootFromParent_Done,
     /*  188688 */   // Label 3670: @188688
     /*  188688 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(188741), // Rule ID 614 //
     /*  188693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  188696 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188703 */     // MIs[0] addr
     /*  188703 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188715 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 4:{ *:[i32] })
     /*  188715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188723 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188728 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188730 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  188735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188739 */     GIR_RootConstrainSelectedInstOperands,
     /*  188740 */     // GIR_Coverage, 614,
     /*  188740 */     GIR_EraseRootFromParent_Done,
     /*  188741 */   // Label 3671: @188741
     /*  188741 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(188794), // Rule ID 616 //
     /*  188746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  188749 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  188752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188756 */     // MIs[0] addr
     /*  188756 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188768 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 5:{ *:[i32] })
     /*  188768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188776 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188781 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188783 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  188788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188792 */     GIR_RootConstrainSelectedInstOperands,
     /*  188793 */     // GIR_Coverage, 616,
     /*  188793 */     GIR_EraseRootFromParent_Done,
     /*  188794 */   // Label 3672: @188794
     /*  188794 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(188847), // Rule ID 618 //
     /*  188799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  188802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  188805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188809 */     // MIs[0] addr
     /*  188809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188821 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 6:{ *:[i32] })
     /*  188821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188829 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188834 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188836 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  188841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188845 */     GIR_RootConstrainSelectedInstOperands,
     /*  188846 */     // GIR_Coverage, 618,
     /*  188846 */     GIR_EraseRootFromParent_Done,
     /*  188847 */   // Label 3673: @188847
     /*  188847 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(188900), // Rule ID 620 //
     /*  188852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /*  188855 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  188858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188862 */     // MIs[0] addr
     /*  188862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188866 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188874 */     // (atomic_load_nand:{ *:[i32] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, 7:{ *:[i32] })
     /*  188874 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188882 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188887 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188889 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  188894 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188898 */     GIR_RootConstrainSelectedInstOperands,
     /*  188899 */     // GIR_Coverage, 620,
     /*  188899 */     GIR_EraseRootFromParent_Done,
     /*  188900 */   // Label 3674: @188900
     /*  188900 */   GIM_Reject,
     /*  188901 */ // Label 3669: @188901
     /*  188901 */ GIM_Reject,
     /*  188902 */ // Label 3667: @188902
     /*  188902 */ GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(189511),
     /*  188907 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  188910 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(188970), // Rule ID 611 //
     /*  188915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  188918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  188928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188932 */     // MIs[0] addr
     /*  188932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188944 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_monotonic>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  188944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  188947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  188950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  188952 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  188957 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  188959 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  188961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  188964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  188968 */     GIR_RootConstrainSelectedInstOperands,
     /*  188969 */     // GIR_Coverage, 611,
     /*  188969 */     GIR_EraseRootFromParent_Done,
     /*  188970 */   // Label 3676: @188970
     /*  188970 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(189030), // Rule ID 613 //
     /*  188975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  188978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  188985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  188988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  188992 */     // MIs[0] addr
     /*  188992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  188996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189004 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acquire>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189012 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189017 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189019 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189024 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189028 */     GIR_RootConstrainSelectedInstOperands,
     /*  189029 */     // GIR_Coverage, 613,
     /*  189029 */     GIR_EraseRootFromParent_Done,
     /*  189030 */   // Label 3677: @189030
     /*  189030 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(189090), // Rule ID 615 //
     /*  189035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189038 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189045 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189052 */     // MIs[0] addr
     /*  189052 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189064 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_release>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189072 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189077 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189079 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189088 */     GIR_RootConstrainSelectedInstOperands,
     /*  189089 */     // GIR_Coverage, 615,
     /*  189089 */     GIR_EraseRootFromParent_Done,
     /*  189090 */   // Label 3678: @189090
     /*  189090 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(189150), // Rule ID 617 //
     /*  189095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189112 */     // MIs[0] addr
     /*  189112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189124 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_acq_rel>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189132 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189137 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189139 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189148 */     GIR_RootConstrainSelectedInstOperands,
     /*  189149 */     // GIR_Coverage, 617,
     /*  189149 */     GIR_EraseRootFromParent_Done,
     /*  189150 */   // Label 3679: @189150
     /*  189150 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(189210), // Rule ID 619 //
     /*  189155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode0),
     /*  189158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189172 */     // MIs[0] addr
     /*  189172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189184 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i32>><<P:Predicate_atomic_load_nand_i32_seq_cst>>  =>  (PseudoAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  189184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand32),
     /*  189190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189192 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189197 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189199 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189208 */     GIR_RootConstrainSelectedInstOperands,
     /*  189209 */     // GIR_Coverage, 619,
     /*  189209 */     GIR_EraseRootFromParent_Done,
     /*  189210 */   // Label 3680: @189210
     /*  189210 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(189270), // Rule ID 629 //
     /*  189215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189232 */     // MIs[0] addr
     /*  189232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189244 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_monotonic>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 2:{ *:[i64] })
     /*  189244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189252 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189257 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189259 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  189264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189268 */     GIR_RootConstrainSelectedInstOperands,
     /*  189269 */     // GIR_Coverage, 629,
     /*  189269 */     GIR_EraseRootFromParent_Done,
     /*  189270 */   // Label 3681: @189270
     /*  189270 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(189330), // Rule ID 630 //
     /*  189275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189292 */     // MIs[0] addr
     /*  189292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189304 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acquire>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 4:{ *:[i64] })
     /*  189304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189312 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189317 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189319 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  189324 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189328 */     GIR_RootConstrainSelectedInstOperands,
     /*  189329 */     // GIR_Coverage, 630,
     /*  189329 */     GIR_EraseRootFromParent_Done,
     /*  189330 */   // Label 3682: @189330
     /*  189330 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(189390), // Rule ID 631 //
     /*  189335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189352 */     // MIs[0] addr
     /*  189352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189364 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_release>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 5:{ *:[i64] })
     /*  189364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189372 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189377 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189379 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  189384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189388 */     GIR_RootConstrainSelectedInstOperands,
     /*  189389 */     // GIR_Coverage, 631,
     /*  189389 */     GIR_EraseRootFromParent_Done,
     /*  189390 */   // Label 3683: @189390
     /*  189390 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(189450), // Rule ID 632 //
     /*  189395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189412 */     // MIs[0] addr
     /*  189412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189424 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_acq_rel>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 6:{ *:[i64] })
     /*  189424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189432 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189437 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189439 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  189444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189448 */     GIR_RootConstrainSelectedInstOperands,
     /*  189449 */     // GIR_Coverage, 632,
     /*  189449 */     GIR_EraseRootFromParent_Done,
     /*  189450 */   // Label 3684: @189450
     /*  189450 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(189510), // Rule ID 633 //
     /*  189455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /*  189458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  189465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189472 */     // MIs[0] addr
     /*  189472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  189476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189484 */     // (atomic_load_nand:{ *:[i64] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr)<<P:Predicate_atomic_load_nand_i64>><<P:Predicate_atomic_load_nand_i64_seq_cst>>  =>  (PseudoAtomicLoadNand64:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, 7:{ *:[i64] })
     /*  189484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  189487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoAtomicLoadNand64),
     /*  189490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /*  189492 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /*  189497 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  189499 */     GIR_RootToRootCopy, /*OpIdx*/2, // incr
     /*  189501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /*  189504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  189508 */     GIR_RootConstrainSelectedInstOperands,
     /*  189509 */     // GIR_Coverage, 633,
     /*  189509 */     GIR_EraseRootFromParent_Done,
     /*  189510 */   // Label 3685: @189510
     /*  189510 */   GIM_Reject,
     /*  189511 */ // Label 3675: @189511
     /*  189511 */ GIM_Reject,
     /*  189512 */ // Label 3668: @189512
     /*  189512 */ GIM_Reject,
     /*  189513 */ // Label 30: @189513
     /*  189513 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3688*/ GIMT_Encode4(192422),
     /*  189524 */ /*GILLT_s32*//*Label 3686*/ GIMT_Encode4(189532),
     /*  189528 */ /*GILLT_s64*//*Label 3687*/ GIMT_Encode4(190772),
     /*  189532 */ // Label 3686: @189532
     /*  189532 */ GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(190771),
     /*  189537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  189540 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(189581), // Rule ID 402 //
     /*  189545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  189548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189562 */     // MIs[0] rs1
     /*  189562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189574 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189579 */     GIR_RootConstrainSelectedInstOperands,
     /*  189580 */     // GIR_Coverage, 402,
     /*  189580 */     GIR_Done,
     /*  189581 */   // Label 3690: @189581
     /*  189581 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(189622), // Rule ID 404 //
     /*  189586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  189589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189603 */     // MIs[0] rs1
     /*  189603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189615 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  189620 */     GIR_RootConstrainSelectedInstOperands,
     /*  189621 */     // GIR_Coverage, 404,
     /*  189621 */     GIR_Done,
     /*  189622 */   // Label 3691: @189622
     /*  189622 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(189663), // Rule ID 406 //
     /*  189627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  189630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189644 */     // MIs[0] rs1
     /*  189644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189656 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  189661 */     GIR_RootConstrainSelectedInstOperands,
     /*  189662 */     // GIR_Coverage, 406,
     /*  189662 */     GIR_Done,
     /*  189663 */   // Label 3692: @189663
     /*  189663 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(189704), // Rule ID 408 //
     /*  189668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  189671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189685 */     // MIs[0] rs1
     /*  189685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189697 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189697 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  189702 */     GIR_RootConstrainSelectedInstOperands,
     /*  189703 */     // GIR_Coverage, 408,
     /*  189703 */     GIR_Done,
     /*  189704 */   // Label 3693: @189704
     /*  189704 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(189745), // Rule ID 410 //
     /*  189709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  189712 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189719 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189726 */     // MIs[0] rs1
     /*  189726 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189738 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189738 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  189743 */     GIR_RootConstrainSelectedInstOperands,
     /*  189744 */     // GIR_Coverage, 410,
     /*  189744 */     GIR_Done,
     /*  189745 */   // Label 3694: @189745
     /*  189745 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(189786), // Rule ID 412 //
     /*  189750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  189753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189767 */     // MIs[0] rs1
     /*  189767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189779 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189784 */     GIR_RootConstrainSelectedInstOperands,
     /*  189785 */     // GIR_Coverage, 412,
     /*  189785 */     GIR_Done,
     /*  189786 */   // Label 3695: @189786
     /*  189786 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(189827), // Rule ID 414 //
     /*  189791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  189794 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189801 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  189804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189808 */     // MIs[0] rs1
     /*  189808 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189820 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189825 */     GIR_RootConstrainSelectedInstOperands,
     /*  189826 */     // GIR_Coverage, 414,
     /*  189826 */     GIR_Done,
     /*  189827 */   // Label 3696: @189827
     /*  189827 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(189868), // Rule ID 416 //
     /*  189832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  189835 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  189845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189849 */     // MIs[0] rs1
     /*  189849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189861 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189866 */     GIR_RootConstrainSelectedInstOperands,
     /*  189867 */     // GIR_Coverage, 416,
     /*  189867 */     GIR_Done,
     /*  189868 */   // Label 3697: @189868
     /*  189868 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(189909), // Rule ID 418 //
     /*  189873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  189876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  189886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189890 */     // MIs[0] rs1
     /*  189890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189902 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189907 */     GIR_RootConstrainSelectedInstOperands,
     /*  189908 */     // GIR_Coverage, 418,
     /*  189908 */     GIR_Done,
     /*  189909 */   // Label 3698: @189909
     /*  189909 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(189950), // Rule ID 420 //
     /*  189914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  189917 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  189924 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  189927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189931 */     // MIs[0] rs1
     /*  189931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189943 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189943 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  189948 */     GIR_RootConstrainSelectedInstOperands,
     /*  189949 */     // GIR_Coverage, 420,
     /*  189949 */     GIR_Done,
     /*  189950 */   // Label 3699: @189950
     /*  189950 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(189991), // Rule ID 750 //
     /*  189955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  189958 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  189965 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  189968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189972 */     // MIs[0] rs1
     /*  189972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  189976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  189984 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  189984 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  189989 */     GIR_RootConstrainSelectedInstOperands,
     /*  189990 */     // GIR_Coverage, 750,
     /*  189990 */     GIR_Done,
     /*  189991 */   // Label 3700: @189991
     /*  189991 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(190032), // Rule ID 752 //
     /*  189996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  189999 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190006 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190013 */     // MIs[0] rs1
     /*  190013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190025 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190025 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  190030 */     GIR_RootConstrainSelectedInstOperands,
     /*  190031 */     // GIR_Coverage, 752,
     /*  190031 */     GIR_Done,
     /*  190032 */   // Label 3701: @190032
     /*  190032 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(190073), // Rule ID 754 //
     /*  190037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190040 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190047 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190054 */     // MIs[0] rs1
     /*  190054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190066 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190066 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  190071 */     GIR_RootConstrainSelectedInstOperands,
     /*  190072 */     // GIR_Coverage, 754,
     /*  190072 */     GIR_Done,
     /*  190073 */   // Label 3702: @190073
     /*  190073 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(190114), // Rule ID 756 //
     /*  190078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190081 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190095 */     // MIs[0] rs1
     /*  190095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190107 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190112 */     GIR_RootConstrainSelectedInstOperands,
     /*  190113 */     // GIR_Coverage, 756,
     /*  190113 */     GIR_Done,
     /*  190114 */   // Label 3703: @190114
     /*  190114 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(190155), // Rule ID 758 //
     /*  190119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190122 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190129 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190136 */     // MIs[0] rs1
     /*  190136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190148 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  190153 */     GIR_RootConstrainSelectedInstOperands,
     /*  190154 */     // GIR_Coverage, 758,
     /*  190154 */     GIR_Done,
     /*  190155 */   // Label 3704: @190155
     /*  190155 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(190196), // Rule ID 760 //
     /*  190160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190170 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190177 */     // MIs[0] rs1
     /*  190177 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190189 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190189 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190194 */     GIR_RootConstrainSelectedInstOperands,
     /*  190195 */     // GIR_Coverage, 760,
     /*  190195 */     GIR_Done,
     /*  190196 */   // Label 3705: @190196
     /*  190196 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(190237), // Rule ID 762 //
     /*  190201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190218 */     // MIs[0] rs1
     /*  190218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190230 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190230 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190235 */     GIR_RootConstrainSelectedInstOperands,
     /*  190236 */     // GIR_Coverage, 762,
     /*  190236 */     GIR_Done,
     /*  190237 */   // Label 3706: @190237
     /*  190237 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(190278), // Rule ID 764 //
     /*  190242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190259 */     // MIs[0] rs1
     /*  190259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190271 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190271 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190276 */     GIR_RootConstrainSelectedInstOperands,
     /*  190277 */     // GIR_Coverage, 764,
     /*  190277 */     GIR_Done,
     /*  190278 */   // Label 3707: @190278
     /*  190278 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(190319), // Rule ID 766 //
     /*  190283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190293 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190300 */     // MIs[0] rs1
     /*  190300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190312 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190312 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190317 */     GIR_RootConstrainSelectedInstOperands,
     /*  190318 */     // GIR_Coverage, 766,
     /*  190318 */     GIR_Done,
     /*  190319 */   // Label 3708: @190319
     /*  190319 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(190360), // Rule ID 768 //
     /*  190324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190327 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  190334 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190341 */     // MIs[0] rs1
     /*  190341 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190353 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190353 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  190358 */     GIR_RootConstrainSelectedInstOperands,
     /*  190359 */     // GIR_Coverage, 768,
     /*  190359 */     GIR_Done,
     /*  190360 */   // Label 3709: @190360
     /*  190360 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(190401), // Rule ID 930 //
     /*  190365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190382 */     // MIs[0] rs1
     /*  190382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190394 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190399 */     GIR_RootConstrainSelectedInstOperands,
     /*  190400 */     // GIR_Coverage, 930,
     /*  190400 */     GIR_Done,
     /*  190401 */   // Label 3710: @190401
     /*  190401 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(190442), // Rule ID 932 //
     /*  190406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190423 */     // MIs[0] rs1
     /*  190423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190435 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  190440 */     GIR_RootConstrainSelectedInstOperands,
     /*  190441 */     // GIR_Coverage, 932,
     /*  190441 */     GIR_Done,
     /*  190442 */   // Label 3711: @190442
     /*  190442 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(190483), // Rule ID 934 //
     /*  190447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190464 */     // MIs[0] rs1
     /*  190464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190476 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  190481 */     GIR_RootConstrainSelectedInstOperands,
     /*  190482 */     // GIR_Coverage, 934,
     /*  190482 */     GIR_Done,
     /*  190483 */   // Label 3712: @190483
     /*  190483 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(190524), // Rule ID 936 //
     /*  190488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190505 */     // MIs[0] rs1
     /*  190505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190517 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  190522 */     GIR_RootConstrainSelectedInstOperands,
     /*  190523 */     // GIR_Coverage, 936,
     /*  190523 */     GIR_Done,
     /*  190524 */   // Label 3713: @190524
     /*  190524 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(190565), // Rule ID 938 //
     /*  190529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  190532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190546 */     // MIs[0] rs1
     /*  190546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190558 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  190563 */     GIR_RootConstrainSelectedInstOperands,
     /*  190564 */     // GIR_Coverage, 938,
     /*  190564 */     GIR_Done,
     /*  190565 */   // Label 3714: @190565
     /*  190565 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(190606), // Rule ID 940 //
     /*  190570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190587 */     // MIs[0] rs1
     /*  190587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190599 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190604 */     GIR_RootConstrainSelectedInstOperands,
     /*  190605 */     // GIR_Coverage, 940,
     /*  190605 */     GIR_Done,
     /*  190606 */   // Label 3715: @190606
     /*  190606 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(190647), // Rule ID 942 //
     /*  190611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190628 */     // MIs[0] rs1
     /*  190628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190640 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190645 */     GIR_RootConstrainSelectedInstOperands,
     /*  190646 */     // GIR_Coverage, 942,
     /*  190646 */     GIR_Done,
     /*  190647 */   // Label 3716: @190647
     /*  190647 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(190688), // Rule ID 944 //
     /*  190652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190669 */     // MIs[0] rs1
     /*  190669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190681 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190686 */     GIR_RootConstrainSelectedInstOperands,
     /*  190687 */     // GIR_Coverage, 944,
     /*  190687 */     GIR_Done,
     /*  190688 */   // Label 3717: @190688
     /*  190688 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(190729), // Rule ID 946 //
     /*  190693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190710 */     // MIs[0] rs1
     /*  190710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190722 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190727 */     GIR_RootConstrainSelectedInstOperands,
     /*  190728 */     // GIR_Coverage, 946,
     /*  190728 */     GIR_Done,
     /*  190729 */   // Label 3718: @190729
     /*  190729 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(190770), // Rule ID 948 //
     /*  190734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  190737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  190744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190751 */     // MIs[0] rs1
     /*  190751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  190755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190763 */     // (atomic_load_or:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  190763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  190768 */     GIR_RootConstrainSelectedInstOperands,
     /*  190769 */     // GIR_Coverage, 948,
     /*  190769 */     GIR_Done,
     /*  190770 */   // Label 3719: @190770
     /*  190770 */   GIM_Reject,
     /*  190771 */ // Label 3689: @190771
     /*  190771 */ GIM_Reject,
     /*  190772 */ // Label 3687: @190772
     /*  190772 */ GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(192421),
     /*  190777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  190780 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(190821), // Rule ID 401 //
     /*  190785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  190788 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190795 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  190798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190802 */     // MIs[0] rs1
     /*  190802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190814 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  190819 */     GIR_RootConstrainSelectedInstOperands,
     /*  190820 */     // GIR_Coverage, 401,
     /*  190820 */     GIR_Done,
     /*  190821 */   // Label 3721: @190821
     /*  190821 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(190862), // Rule ID 403 //
     /*  190826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  190829 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  190839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190843 */     // MIs[0] rs1
     /*  190843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190855 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ),
     /*  190860 */     GIR_RootConstrainSelectedInstOperands,
     /*  190861 */     // GIR_Coverage, 403,
     /*  190861 */     GIR_Done,
     /*  190862 */   // Label 3722: @190862
     /*  190862 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(190903), // Rule ID 405 //
     /*  190867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  190870 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  190880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190884 */     // MIs[0] rs1
     /*  190884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190896 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190896 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_RL),
     /*  190901 */     GIR_RootConstrainSelectedInstOperands,
     /*  190902 */     // GIR_Coverage, 405,
     /*  190902 */     GIR_Done,
     /*  190903 */   // Label 3723: @190903
     /*  190903 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(190944), // Rule ID 407 //
     /*  190908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  190911 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190918 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  190921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190925 */     // MIs[0] rs1
     /*  190925 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190937 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190942 */     GIR_RootConstrainSelectedInstOperands,
     /*  190943 */     // GIR_Coverage, 407,
     /*  190943 */     GIR_Done,
     /*  190944 */   // Label 3724: @190944
     /*  190944 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(190985), // Rule ID 409 //
     /*  190949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  190952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  190959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  190962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190966 */     // MIs[0] rs1
     /*  190966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  190970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  190978 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  190978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W_AQ_RL),
     /*  190983 */     GIR_RootConstrainSelectedInstOperands,
     /*  190984 */     // GIR_Coverage, 409,
     /*  190984 */     GIR_Done,
     /*  190985 */   // Label 3725: @190985
     /*  190985 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(191026), // Rule ID 411 //
     /*  190990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  190993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191007 */     // MIs[0] rs1
     /*  191007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191019 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191024 */     GIR_RootConstrainSelectedInstOperands,
     /*  191025 */     // GIR_Coverage, 411,
     /*  191025 */     GIR_Done,
     /*  191026 */   // Label 3726: @191026
     /*  191026 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(191067), // Rule ID 413 //
     /*  191031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191048 */     // MIs[0] rs1
     /*  191048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191060 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191060 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191065 */     GIR_RootConstrainSelectedInstOperands,
     /*  191066 */     // GIR_Coverage, 413,
     /*  191066 */     GIR_Done,
     /*  191067 */   // Label 3727: @191067
     /*  191067 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(191108), // Rule ID 415 //
     /*  191072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191075 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191082 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191089 */     // MIs[0] rs1
     /*  191089 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191101 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191101 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191106 */     GIR_RootConstrainSelectedInstOperands,
     /*  191107 */     // GIR_Coverage, 415,
     /*  191107 */     GIR_Done,
     /*  191108 */   // Label 3728: @191108
     /*  191108 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(191149), // Rule ID 417 //
     /*  191113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191123 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191130 */     // MIs[0] rs1
     /*  191130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191142 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191142 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191147 */     GIR_RootConstrainSelectedInstOperands,
     /*  191148 */     // GIR_Coverage, 417,
     /*  191148 */     GIR_Done,
     /*  191149 */   // Label 3729: @191149
     /*  191149 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(191190), // Rule ID 419 //
     /*  191154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  191157 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  191164 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191171 */     // MIs[0] rs1
     /*  191171 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191183 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (AMOOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_W),
     /*  191188 */     GIR_RootConstrainSelectedInstOperands,
     /*  191189 */     // GIR_Coverage, 419,
     /*  191189 */     GIR_Done,
     /*  191190 */   // Label 3730: @191190
     /*  191190 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(191231), // Rule ID 551 //
     /*  191195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191212 */     // MIs[0] rs1
     /*  191212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191224 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191229 */     GIR_RootConstrainSelectedInstOperands,
     /*  191230 */     // GIR_Coverage, 551,
     /*  191230 */     GIR_Done,
     /*  191231 */   // Label 3731: @191231
     /*  191231 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(191272), // Rule ID 552 //
     /*  191236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191239 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191246 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191253 */     // MIs[0] rs1
     /*  191253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191265 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ),
     /*  191270 */     GIR_RootConstrainSelectedInstOperands,
     /*  191271 */     // GIR_Coverage, 552,
     /*  191271 */     GIR_Done,
     /*  191272 */   // Label 3732: @191272
     /*  191272 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(191313), // Rule ID 553 //
     /*  191277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191280 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191287 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191294 */     // MIs[0] rs1
     /*  191294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191306 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191306 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_RL),
     /*  191311 */     GIR_RootConstrainSelectedInstOperands,
     /*  191312 */     // GIR_Coverage, 553,
     /*  191312 */     GIR_Done,
     /*  191313 */   // Label 3733: @191313
     /*  191313 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(191354), // Rule ID 554 //
     /*  191318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191321 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191328 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191335 */     // MIs[0] rs1
     /*  191335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191347 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191352 */     GIR_RootConstrainSelectedInstOperands,
     /*  191353 */     // GIR_Coverage, 554,
     /*  191353 */     GIR_Done,
     /*  191354 */   // Label 3734: @191354
     /*  191354 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(191395), // Rule ID 555 //
     /*  191359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  191362 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191369 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191376 */     // MIs[0] rs1
     /*  191376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191388 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D_AQ_RL),
     /*  191393 */     GIR_RootConstrainSelectedInstOperands,
     /*  191394 */     // GIR_Coverage, 555,
     /*  191394 */     GIR_Done,
     /*  191395 */   // Label 3735: @191395
     /*  191395 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(191436), // Rule ID 556 //
     /*  191400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191403 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191410 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191417 */     // MIs[0] rs1
     /*  191417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191429 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191434 */     GIR_RootConstrainSelectedInstOperands,
     /*  191435 */     // GIR_Coverage, 556,
     /*  191435 */     GIR_Done,
     /*  191436 */   // Label 3736: @191436
     /*  191436 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(191477), // Rule ID 557 //
     /*  191441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191444 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191451 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191458 */     // MIs[0] rs1
     /*  191458 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191470 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191475 */     GIR_RootConstrainSelectedInstOperands,
     /*  191476 */     // GIR_Coverage, 557,
     /*  191476 */     GIR_Done,
     /*  191477 */   // Label 3737: @191477
     /*  191477 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(191518), // Rule ID 558 //
     /*  191482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191485 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191492 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191499 */     // MIs[0] rs1
     /*  191499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191511 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191516 */     GIR_RootConstrainSelectedInstOperands,
     /*  191517 */     // GIR_Coverage, 558,
     /*  191517 */     GIR_Done,
     /*  191518 */   // Label 3738: @191518
     /*  191518 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(191559), // Rule ID 559 //
     /*  191523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191526 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191540 */     // MIs[0] rs1
     /*  191540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191552 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191557 */     GIR_RootConstrainSelectedInstOperands,
     /*  191558 */     // GIR_Coverage, 559,
     /*  191558 */     GIR_Done,
     /*  191559 */   // Label 3739: @191559
     /*  191559 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(191600), // Rule ID 560 //
     /*  191564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  191567 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  191574 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191581 */     // MIs[0] rs1
     /*  191581 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191593 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (AMOOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_D),
     /*  191598 */     GIR_RootConstrainSelectedInstOperands,
     /*  191599 */     // GIR_Coverage, 560,
     /*  191599 */     GIR_Done,
     /*  191600 */   // Label 3740: @191600
     /*  191600 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(191641), // Rule ID 749 //
     /*  191605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  191608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191622 */     // MIs[0] rs1
     /*  191622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191634 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191639 */     GIR_RootConstrainSelectedInstOperands,
     /*  191640 */     // GIR_Coverage, 749,
     /*  191640 */     GIR_Done,
     /*  191641 */   // Label 3741: @191641
     /*  191641 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(191682), // Rule ID 751 //
     /*  191646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  191649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191663 */     // MIs[0] rs1
     /*  191663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191675 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ),
     /*  191680 */     GIR_RootConstrainSelectedInstOperands,
     /*  191681 */     // GIR_Coverage, 751,
     /*  191681 */     GIR_Done,
     /*  191682 */   // Label 3742: @191682
     /*  191682 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(191723), // Rule ID 753 //
     /*  191687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  191690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191704 */     // MIs[0] rs1
     /*  191704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191716 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_RL),
     /*  191721 */     GIR_RootConstrainSelectedInstOperands,
     /*  191722 */     // GIR_Coverage, 753,
     /*  191722 */     GIR_Done,
     /*  191723 */   // Label 3743: @191723
     /*  191723 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(191764), // Rule ID 755 //
     /*  191728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  191731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191745 */     // MIs[0] rs1
     /*  191745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191757 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191762 */     GIR_RootConstrainSelectedInstOperands,
     /*  191763 */     // GIR_Coverage, 755,
     /*  191763 */     GIR_Done,
     /*  191764 */   // Label 3744: @191764
     /*  191764 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(191805), // Rule ID 757 //
     /*  191769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  191772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191786 */     // MIs[0] rs1
     /*  191786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191798 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B_AQ_RL),
     /*  191803 */     GIR_RootConstrainSelectedInstOperands,
     /*  191804 */     // GIR_Coverage, 757,
     /*  191804 */     GIR_Done,
     /*  191805 */   // Label 3745: @191805
     /*  191805 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(191846), // Rule ID 759 //
     /*  191810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  191813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  191823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191827 */     // MIs[0] rs1
     /*  191827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191839 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191844 */     GIR_RootConstrainSelectedInstOperands,
     /*  191845 */     // GIR_Coverage, 759,
     /*  191845 */     GIR_Done,
     /*  191846 */   // Label 3746: @191846
     /*  191846 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(191887), // Rule ID 761 //
     /*  191851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  191854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  191864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191868 */     // MIs[0] rs1
     /*  191868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191880 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191885 */     GIR_RootConstrainSelectedInstOperands,
     /*  191886 */     // GIR_Coverage, 761,
     /*  191886 */     GIR_Done,
     /*  191887 */   // Label 3747: @191887
     /*  191887 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(191928), // Rule ID 763 //
     /*  191892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  191895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  191905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191909 */     // MIs[0] rs1
     /*  191909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191921 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191926 */     GIR_RootConstrainSelectedInstOperands,
     /*  191927 */     // GIR_Coverage, 763,
     /*  191927 */     GIR_Done,
     /*  191928 */   // Label 3748: @191928
     /*  191928 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(191969), // Rule ID 765 //
     /*  191933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  191936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  191946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191950 */     // MIs[0] rs1
     /*  191950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191962 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  191962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  191967 */     GIR_RootConstrainSelectedInstOperands,
     /*  191968 */     // GIR_Coverage, 765,
     /*  191968 */     GIR_Done,
     /*  191969 */   // Label 3749: @191969
     /*  191969 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(192010), // Rule ID 767 //
     /*  191974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  191977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  191984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  191987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191991 */     // MIs[0] rs1
     /*  191991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  191995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  191999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192003 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (AMOOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_B),
     /*  192008 */     GIR_RootConstrainSelectedInstOperands,
     /*  192009 */     // GIR_Coverage, 767,
     /*  192009 */     GIR_Done,
     /*  192010 */   // Label 3750: @192010
     /*  192010 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(192051), // Rule ID 929 //
     /*  192015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192032 */     // MIs[0] rs1
     /*  192032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192044 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192049 */     GIR_RootConstrainSelectedInstOperands,
     /*  192050 */     // GIR_Coverage, 929,
     /*  192050 */     GIR_Done,
     /*  192051 */   // Label 3751: @192051
     /*  192051 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(192092), // Rule ID 931 //
     /*  192056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192073 */     // MIs[0] rs1
     /*  192073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192085 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ),
     /*  192090 */     GIR_RootConstrainSelectedInstOperands,
     /*  192091 */     // GIR_Coverage, 931,
     /*  192091 */     GIR_Done,
     /*  192092 */   // Label 3752: @192092
     /*  192092 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(192133), // Rule ID 933 //
     /*  192097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192114 */     // MIs[0] rs1
     /*  192114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192126 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_RL),
     /*  192131 */     GIR_RootConstrainSelectedInstOperands,
     /*  192132 */     // GIR_Coverage, 933,
     /*  192132 */     GIR_Done,
     /*  192133 */   // Label 3753: @192133
     /*  192133 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(192174), // Rule ID 935 //
     /*  192138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192155 */     // MIs[0] rs1
     /*  192155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192167 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192172 */     GIR_RootConstrainSelectedInstOperands,
     /*  192173 */     // GIR_Coverage, 935,
     /*  192173 */     GIR_Done,
     /*  192174 */   // Label 3754: @192174
     /*  192174 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(192215), // Rule ID 937 //
     /*  192179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  192182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192196 */     // MIs[0] rs1
     /*  192196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192208 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H_AQ_RL),
     /*  192213 */     GIR_RootConstrainSelectedInstOperands,
     /*  192214 */     // GIR_Coverage, 937,
     /*  192214 */     GIR_Done,
     /*  192215 */   // Label 3755: @192215
     /*  192215 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(192256), // Rule ID 939 //
     /*  192220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192237 */     // MIs[0] rs1
     /*  192237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192249 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192254 */     GIR_RootConstrainSelectedInstOperands,
     /*  192255 */     // GIR_Coverage, 939,
     /*  192255 */     GIR_Done,
     /*  192256 */   // Label 3756: @192256
     /*  192256 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(192297), // Rule ID 941 //
     /*  192261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192278 */     // MIs[0] rs1
     /*  192278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192290 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192295 */     GIR_RootConstrainSelectedInstOperands,
     /*  192296 */     // GIR_Coverage, 941,
     /*  192296 */     GIR_Done,
     /*  192297 */   // Label 3757: @192297
     /*  192297 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(192338), // Rule ID 943 //
     /*  192302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192319 */     // MIs[0] rs1
     /*  192319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192331 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192336 */     GIR_RootConstrainSelectedInstOperands,
     /*  192337 */     // GIR_Coverage, 943,
     /*  192337 */     GIR_Done,
     /*  192338 */   // Label 3758: @192338
     /*  192338 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(192379), // Rule ID 945 //
     /*  192343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192360 */     // MIs[0] rs1
     /*  192360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192372 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192377 */     GIR_RootConstrainSelectedInstOperands,
     /*  192378 */     // GIR_Coverage, 945,
     /*  192378 */     GIR_Done,
     /*  192379 */   // Label 3759: @192379
     /*  192379 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(192420), // Rule ID 947 //
     /*  192384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  192387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  192394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192401 */     // MIs[0] rs1
     /*  192401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  192405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192413 */     // (atomic_load_or:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (AMOOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  192413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOOR_H),
     /*  192418 */     GIR_RootConstrainSelectedInstOperands,
     /*  192419 */     // GIR_Coverage, 947,
     /*  192419 */     GIR_Done,
     /*  192420 */   // Label 3760: @192420
     /*  192420 */   GIM_Reject,
     /*  192421 */ // Label 3720: @192421
     /*  192421 */ GIM_Reject,
     /*  192422 */ // Label 3688: @192422
     /*  192422 */ GIM_Reject,
     /*  192423 */ // Label 31: @192423
     /*  192423 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3763*/ GIMT_Encode4(195332),
     /*  192434 */ /*GILLT_s32*//*Label 3761*/ GIMT_Encode4(192442),
     /*  192438 */ /*GILLT_s64*//*Label 3762*/ GIMT_Encode4(193682),
     /*  192442 */ // Label 3761: @192442
     /*  192442 */ GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(193681),
     /*  192447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  192450 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(192491), // Rule ID 422 //
     /*  192455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192472 */     // MIs[0] rs1
     /*  192472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192484 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192489 */     GIR_RootConstrainSelectedInstOperands,
     /*  192490 */     // GIR_Coverage, 422,
     /*  192490 */     GIR_Done,
     /*  192491 */   // Label 3765: @192491
     /*  192491 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(192532), // Rule ID 424 //
     /*  192496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192513 */     // MIs[0] rs1
     /*  192513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192525 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  192530 */     GIR_RootConstrainSelectedInstOperands,
     /*  192531 */     // GIR_Coverage, 424,
     /*  192531 */     GIR_Done,
     /*  192532 */   // Label 3766: @192532
     /*  192532 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(192573), // Rule ID 426 //
     /*  192537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192554 */     // MIs[0] rs1
     /*  192554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192566 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192566 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  192571 */     GIR_RootConstrainSelectedInstOperands,
     /*  192572 */     // GIR_Coverage, 426,
     /*  192572 */     GIR_Done,
     /*  192573 */   // Label 3767: @192573
     /*  192573 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(192614), // Rule ID 428 //
     /*  192578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192595 */     // MIs[0] rs1
     /*  192595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192607 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192607 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  192612 */     GIR_RootConstrainSelectedInstOperands,
     /*  192613 */     // GIR_Coverage, 428,
     /*  192613 */     GIR_Done,
     /*  192614 */   // Label 3768: @192614
     /*  192614 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(192655), // Rule ID 430 //
     /*  192619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  192622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192636 */     // MIs[0] rs1
     /*  192636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192648 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  192653 */     GIR_RootConstrainSelectedInstOperands,
     /*  192654 */     // GIR_Coverage, 430,
     /*  192654 */     GIR_Done,
     /*  192655 */   // Label 3769: @192655
     /*  192655 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(192696), // Rule ID 432 //
     /*  192660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  192663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192677 */     // MIs[0] rs1
     /*  192677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192689 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192689 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192694 */     GIR_RootConstrainSelectedInstOperands,
     /*  192695 */     // GIR_Coverage, 432,
     /*  192695 */     GIR_Done,
     /*  192696 */   // Label 3770: @192696
     /*  192696 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(192737), // Rule ID 434 //
     /*  192701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  192704 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192711 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192718 */     // MIs[0] rs1
     /*  192718 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192730 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192735 */     GIR_RootConstrainSelectedInstOperands,
     /*  192736 */     // GIR_Coverage, 434,
     /*  192736 */     GIR_Done,
     /*  192737 */   // Label 3771: @192737
     /*  192737 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(192778), // Rule ID 436 //
     /*  192742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  192745 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192759 */     // MIs[0] rs1
     /*  192759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192771 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192771 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192776 */     GIR_RootConstrainSelectedInstOperands,
     /*  192777 */     // GIR_Coverage, 436,
     /*  192777 */     GIR_Done,
     /*  192778 */   // Label 3772: @192778
     /*  192778 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(192819), // Rule ID 438 //
     /*  192783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  192786 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  192796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192800 */     // MIs[0] rs1
     /*  192800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192812 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192812 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192817 */     GIR_RootConstrainSelectedInstOperands,
     /*  192818 */     // GIR_Coverage, 438,
     /*  192818 */     GIR_Done,
     /*  192819 */   // Label 3773: @192819
     /*  192819 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(192860), // Rule ID 440 //
     /*  192824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  192827 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  192834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  192837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192841 */     // MIs[0] rs1
     /*  192841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192853 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  192858 */     GIR_RootConstrainSelectedInstOperands,
     /*  192859 */     // GIR_Coverage, 440,
     /*  192859 */     GIR_Done,
     /*  192860 */   // Label 3774: @192860
     /*  192860 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(192901), // Rule ID 770 //
     /*  192865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  192868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  192878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192882 */     // MIs[0] rs1
     /*  192882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192894 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192894 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  192899 */     GIR_RootConstrainSelectedInstOperands,
     /*  192900 */     // GIR_Coverage, 770,
     /*  192900 */     GIR_Done,
     /*  192901 */   // Label 3775: @192901
     /*  192901 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(192942), // Rule ID 772 //
     /*  192906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  192909 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192916 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  192919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192923 */     // MIs[0] rs1
     /*  192923 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192935 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192935 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  192940 */     GIR_RootConstrainSelectedInstOperands,
     /*  192941 */     // GIR_Coverage, 772,
     /*  192941 */     GIR_Done,
     /*  192942 */   // Label 3776: @192942
     /*  192942 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(192983), // Rule ID 774 //
     /*  192947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  192950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  192960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192964 */     // MIs[0] rs1
     /*  192964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  192968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  192976 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  192976 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  192981 */     GIR_RootConstrainSelectedInstOperands,
     /*  192982 */     // GIR_Coverage, 774,
     /*  192982 */     GIR_Done,
     /*  192983 */   // Label 3777: @192983
     /*  192983 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(193024), // Rule ID 776 //
     /*  192988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  192991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  192998 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193005 */     // MIs[0] rs1
     /*  193005 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193017 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193017 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193022 */     GIR_RootConstrainSelectedInstOperands,
     /*  193023 */     // GIR_Coverage, 776,
     /*  193023 */     GIR_Done,
     /*  193024 */   // Label 3778: @193024
     /*  193024 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(193065), // Rule ID 778 //
     /*  193029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193032 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193039 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193046 */     // MIs[0] rs1
     /*  193046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193058 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193058 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  193063 */     GIR_RootConstrainSelectedInstOperands,
     /*  193064 */     // GIR_Coverage, 778,
     /*  193064 */     GIR_Done,
     /*  193065 */   // Label 3779: @193065
     /*  193065 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(193106), // Rule ID 780 //
     /*  193070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193073 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193080 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193087 */     // MIs[0] rs1
     /*  193087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193099 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193099 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193104 */     GIR_RootConstrainSelectedInstOperands,
     /*  193105 */     // GIR_Coverage, 780,
     /*  193105 */     GIR_Done,
     /*  193106 */   // Label 3780: @193106
     /*  193106 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(193147), // Rule ID 782 //
     /*  193111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193114 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193128 */     // MIs[0] rs1
     /*  193128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193140 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193145 */     GIR_RootConstrainSelectedInstOperands,
     /*  193146 */     // GIR_Coverage, 782,
     /*  193146 */     GIR_Done,
     /*  193147 */   // Label 3781: @193147
     /*  193147 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(193188), // Rule ID 784 //
     /*  193152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193169 */     // MIs[0] rs1
     /*  193169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193181 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193186 */     GIR_RootConstrainSelectedInstOperands,
     /*  193187 */     // GIR_Coverage, 784,
     /*  193187 */     GIR_Done,
     /*  193188 */   // Label 3782: @193188
     /*  193188 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(193229), // Rule ID 786 //
     /*  193193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193210 */     // MIs[0] rs1
     /*  193210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193222 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193227 */     GIR_RootConstrainSelectedInstOperands,
     /*  193228 */     // GIR_Coverage, 786,
     /*  193228 */     GIR_Done,
     /*  193229 */   // Label 3783: @193229
     /*  193229 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(193270), // Rule ID 788 //
     /*  193234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193237 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  193244 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193251 */     // MIs[0] rs1
     /*  193251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193263 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193263 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  193268 */     GIR_RootConstrainSelectedInstOperands,
     /*  193269 */     // GIR_Coverage, 788,
     /*  193269 */     GIR_Done,
     /*  193270 */   // Label 3784: @193270
     /*  193270 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(193311), // Rule ID 950 //
     /*  193275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193292 */     // MIs[0] rs1
     /*  193292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193304 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193309 */     GIR_RootConstrainSelectedInstOperands,
     /*  193310 */     // GIR_Coverage, 950,
     /*  193310 */     GIR_Done,
     /*  193311 */   // Label 3785: @193311
     /*  193311 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(193352), // Rule ID 952 //
     /*  193316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193333 */     // MIs[0] rs1
     /*  193333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193345 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  193350 */     GIR_RootConstrainSelectedInstOperands,
     /*  193351 */     // GIR_Coverage, 952,
     /*  193351 */     GIR_Done,
     /*  193352 */   // Label 3786: @193352
     /*  193352 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(193393), // Rule ID 954 //
     /*  193357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193374 */     // MIs[0] rs1
     /*  193374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193386 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  193391 */     GIR_RootConstrainSelectedInstOperands,
     /*  193392 */     // GIR_Coverage, 954,
     /*  193392 */     GIR_Done,
     /*  193393 */   // Label 3787: @193393
     /*  193393 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(193434), // Rule ID 956 //
     /*  193398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193415 */     // MIs[0] rs1
     /*  193415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193427 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193432 */     GIR_RootConstrainSelectedInstOperands,
     /*  193433 */     // GIR_Coverage, 956,
     /*  193433 */     GIR_Done,
     /*  193434 */   // Label 3788: @193434
     /*  193434 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(193475), // Rule ID 958 //
     /*  193439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  193442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193456 */     // MIs[0] rs1
     /*  193456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193468 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  193473 */     GIR_RootConstrainSelectedInstOperands,
     /*  193474 */     // GIR_Coverage, 958,
     /*  193474 */     GIR_Done,
     /*  193475 */   // Label 3789: @193475
     /*  193475 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(193516), // Rule ID 960 //
     /*  193480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193497 */     // MIs[0] rs1
     /*  193497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193509 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193514 */     GIR_RootConstrainSelectedInstOperands,
     /*  193515 */     // GIR_Coverage, 960,
     /*  193515 */     GIR_Done,
     /*  193516 */   // Label 3790: @193516
     /*  193516 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(193557), // Rule ID 962 //
     /*  193521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193538 */     // MIs[0] rs1
     /*  193538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193550 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193555 */     GIR_RootConstrainSelectedInstOperands,
     /*  193556 */     // GIR_Coverage, 962,
     /*  193556 */     GIR_Done,
     /*  193557 */   // Label 3791: @193557
     /*  193557 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(193598), // Rule ID 964 //
     /*  193562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193579 */     // MIs[0] rs1
     /*  193579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193591 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193596 */     GIR_RootConstrainSelectedInstOperands,
     /*  193597 */     // GIR_Coverage, 964,
     /*  193597 */     GIR_Done,
     /*  193598 */   // Label 3792: @193598
     /*  193598 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(193639), // Rule ID 966 //
     /*  193603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193620 */     // MIs[0] rs1
     /*  193620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193632 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193637 */     GIR_RootConstrainSelectedInstOperands,
     /*  193638 */     // GIR_Coverage, 966,
     /*  193638 */     GIR_Done,
     /*  193639 */   // Label 3793: @193639
     /*  193639 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(193680), // Rule ID 968 //
     /*  193644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  193647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  193654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193661 */     // MIs[0] rs1
     /*  193661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  193665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193673 */     // (atomic_load_xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  193673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  193678 */     GIR_RootConstrainSelectedInstOperands,
     /*  193679 */     // GIR_Coverage, 968,
     /*  193679 */     GIR_Done,
     /*  193680 */   // Label 3794: @193680
     /*  193680 */   GIM_Reject,
     /*  193681 */ // Label 3764: @193681
     /*  193681 */ GIM_Reject,
     /*  193682 */ // Label 3762: @193682
     /*  193682 */ GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(195331),
     /*  193687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  193690 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(193731), // Rule ID 421 //
     /*  193695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  193698 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193705 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193712 */     // MIs[0] rs1
     /*  193712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193724 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193724 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193729 */     GIR_RootConstrainSelectedInstOperands,
     /*  193730 */     // GIR_Coverage, 421,
     /*  193730 */     GIR_Done,
     /*  193731 */   // Label 3796: @193731
     /*  193731 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(193772), // Rule ID 423 //
     /*  193736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  193739 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193746 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193753 */     // MIs[0] rs1
     /*  193753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193765 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ),
     /*  193770 */     GIR_RootConstrainSelectedInstOperands,
     /*  193771 */     // GIR_Coverage, 423,
     /*  193771 */     GIR_Done,
     /*  193772 */   // Label 3797: @193772
     /*  193772 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(193813), // Rule ID 425 //
     /*  193777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  193780 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193787 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193794 */     // MIs[0] rs1
     /*  193794 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193806 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193806 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_RL),
     /*  193811 */     GIR_RootConstrainSelectedInstOperands,
     /*  193812 */     // GIR_Coverage, 425,
     /*  193812 */     GIR_Done,
     /*  193813 */   // Label 3798: @193813
     /*  193813 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(193854), // Rule ID 427 //
     /*  193818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  193821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  193831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193835 */     // MIs[0] rs1
     /*  193835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193847 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193852 */     GIR_RootConstrainSelectedInstOperands,
     /*  193853 */     // GIR_Coverage, 427,
     /*  193853 */     GIR_Done,
     /*  193854 */   // Label 3799: @193854
     /*  193854 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(193895), // Rule ID 429 //
     /*  193859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  193862 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193869 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  193872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193876 */     // MIs[0] rs1
     /*  193876 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193888 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W_AQ_RL),
     /*  193893 */     GIR_RootConstrainSelectedInstOperands,
     /*  193894 */     // GIR_Coverage, 429,
     /*  193894 */     GIR_Done,
     /*  193895 */   // Label 3800: @193895
     /*  193895 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(193936), // Rule ID 431 //
     /*  193900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  193903 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  193913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193917 */     // MIs[0] rs1
     /*  193917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193929 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193934 */     GIR_RootConstrainSelectedInstOperands,
     /*  193935 */     // GIR_Coverage, 431,
     /*  193935 */     GIR_Done,
     /*  193936 */   // Label 3801: @193936
     /*  193936 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(193977), // Rule ID 433 //
     /*  193941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  193944 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193951 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  193954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193958 */     // MIs[0] rs1
     /*  193958 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  193962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193970 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  193970 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  193975 */     GIR_RootConstrainSelectedInstOperands,
     /*  193976 */     // GIR_Coverage, 433,
     /*  193976 */     GIR_Done,
     /*  193977 */   // Label 3802: @193977
     /*  193977 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(194018), // Rule ID 435 //
     /*  193982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  193985 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  193992 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  193995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  193999 */     // MIs[0] rs1
     /*  193999 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194011 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194016 */     GIR_RootConstrainSelectedInstOperands,
     /*  194017 */     // GIR_Coverage, 435,
     /*  194017 */     GIR_Done,
     /*  194018 */   // Label 3803: @194018
     /*  194018 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(194059), // Rule ID 437 //
     /*  194023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194040 */     // MIs[0] rs1
     /*  194040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194052 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194057 */     GIR_RootConstrainSelectedInstOperands,
     /*  194058 */     // GIR_Coverage, 437,
     /*  194058 */     GIR_Done,
     /*  194059 */   // Label 3804: @194059
     /*  194059 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(194100), // Rule ID 439 //
     /*  194064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  194067 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  194074 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194081 */     // MIs[0] rs1
     /*  194081 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194093 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (AMOXOR_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194093 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_W),
     /*  194098 */     GIR_RootConstrainSelectedInstOperands,
     /*  194099 */     // GIR_Coverage, 439,
     /*  194099 */     GIR_Done,
     /*  194100 */   // Label 3805: @194100
     /*  194100 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(194141), // Rule ID 561 //
     /*  194105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194108 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194115 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194122 */     // MIs[0] rs1
     /*  194122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194134 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194139 */     GIR_RootConstrainSelectedInstOperands,
     /*  194140 */     // GIR_Coverage, 561,
     /*  194140 */     GIR_Done,
     /*  194141 */   // Label 3806: @194141
     /*  194141 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(194182), // Rule ID 562 //
     /*  194146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194149 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194163 */     // MIs[0] rs1
     /*  194163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194175 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ),
     /*  194180 */     GIR_RootConstrainSelectedInstOperands,
     /*  194181 */     // GIR_Coverage, 562,
     /*  194181 */     GIR_Done,
     /*  194182 */   // Label 3807: @194182
     /*  194182 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(194223), // Rule ID 563 //
     /*  194187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194190 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194197 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194204 */     // MIs[0] rs1
     /*  194204 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194216 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194216 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_RL),
     /*  194221 */     GIR_RootConstrainSelectedInstOperands,
     /*  194222 */     // GIR_Coverage, 563,
     /*  194222 */     GIR_Done,
     /*  194223 */   // Label 3808: @194223
     /*  194223 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(194264), // Rule ID 564 //
     /*  194228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194231 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194245 */     // MIs[0] rs1
     /*  194245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194257 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194262 */     GIR_RootConstrainSelectedInstOperands,
     /*  194263 */     // GIR_Coverage, 564,
     /*  194263 */     GIR_Done,
     /*  194264 */   // Label 3809: @194264
     /*  194264 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(194305), // Rule ID 565 //
     /*  194269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  194272 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194279 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194286 */     // MIs[0] rs1
     /*  194286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194290 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194298 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D_AQ_RL),
     /*  194303 */     GIR_RootConstrainSelectedInstOperands,
     /*  194304 */     // GIR_Coverage, 565,
     /*  194304 */     GIR_Done,
     /*  194305 */   // Label 3810: @194305
     /*  194305 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(194346), // Rule ID 566 //
     /*  194310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194313 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194327 */     // MIs[0] rs1
     /*  194327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194339 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194339 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194344 */     GIR_RootConstrainSelectedInstOperands,
     /*  194345 */     // GIR_Coverage, 566,
     /*  194345 */     GIR_Done,
     /*  194346 */   // Label 3811: @194346
     /*  194346 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(194387), // Rule ID 567 //
     /*  194351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194354 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194361 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194368 */     // MIs[0] rs1
     /*  194368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194380 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194385 */     GIR_RootConstrainSelectedInstOperands,
     /*  194386 */     // GIR_Coverage, 567,
     /*  194386 */     GIR_Done,
     /*  194387 */   // Label 3812: @194387
     /*  194387 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(194428), // Rule ID 568 //
     /*  194392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194395 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194402 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194409 */     // MIs[0] rs1
     /*  194409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194421 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194426 */     GIR_RootConstrainSelectedInstOperands,
     /*  194427 */     // GIR_Coverage, 568,
     /*  194427 */     GIR_Done,
     /*  194428 */   // Label 3813: @194428
     /*  194428 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(194469), // Rule ID 569 //
     /*  194433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194436 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194443 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194450 */     // MIs[0] rs1
     /*  194450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194462 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194467 */     GIR_RootConstrainSelectedInstOperands,
     /*  194468 */     // GIR_Coverage, 569,
     /*  194468 */     GIR_Done,
     /*  194469 */   // Label 3814: @194469
     /*  194469 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(194510), // Rule ID 570 //
     /*  194474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  194477 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  194484 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194491 */     // MIs[0] rs1
     /*  194491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194503 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (AMOXOR_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194503 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_D),
     /*  194508 */     GIR_RootConstrainSelectedInstOperands,
     /*  194509 */     // GIR_Coverage, 570,
     /*  194509 */     GIR_Done,
     /*  194510 */   // Label 3815: @194510
     /*  194510 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(194551), // Rule ID 769 //
     /*  194515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194532 */     // MIs[0] rs1
     /*  194532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194544 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194549 */     GIR_RootConstrainSelectedInstOperands,
     /*  194550 */     // GIR_Coverage, 769,
     /*  194550 */     GIR_Done,
     /*  194551 */   // Label 3816: @194551
     /*  194551 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(194592), // Rule ID 771 //
     /*  194556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194573 */     // MIs[0] rs1
     /*  194573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194585 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ),
     /*  194590 */     GIR_RootConstrainSelectedInstOperands,
     /*  194591 */     // GIR_Coverage, 771,
     /*  194591 */     GIR_Done,
     /*  194592 */   // Label 3817: @194592
     /*  194592 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(194633), // Rule ID 773 //
     /*  194597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194614 */     // MIs[0] rs1
     /*  194614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194626 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_RL),
     /*  194631 */     GIR_RootConstrainSelectedInstOperands,
     /*  194632 */     // GIR_Coverage, 773,
     /*  194632 */     GIR_Done,
     /*  194633 */   // Label 3818: @194633
     /*  194633 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(194674), // Rule ID 775 //
     /*  194638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194655 */     // MIs[0] rs1
     /*  194655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194667 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  194672 */     GIR_RootConstrainSelectedInstOperands,
     /*  194673 */     // GIR_Coverage, 775,
     /*  194673 */     GIR_Done,
     /*  194674 */   // Label 3819: @194674
     /*  194674 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(194715), // Rule ID 777 //
     /*  194679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194696 */     // MIs[0] rs1
     /*  194696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194708 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B_AQ_RL),
     /*  194713 */     GIR_RootConstrainSelectedInstOperands,
     /*  194714 */     // GIR_Coverage, 777,
     /*  194714 */     GIR_Done,
     /*  194715 */   // Label 3820: @194715
     /*  194715 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(194756), // Rule ID 779 //
     /*  194720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  194723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194737 */     // MIs[0] rs1
     /*  194737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194749 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194754 */     GIR_RootConstrainSelectedInstOperands,
     /*  194755 */     // GIR_Coverage, 779,
     /*  194755 */     GIR_Done,
     /*  194756 */   // Label 3821: @194756
     /*  194756 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(194797), // Rule ID 781 //
     /*  194761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  194764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194778 */     // MIs[0] rs1
     /*  194778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194790 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194795 */     GIR_RootConstrainSelectedInstOperands,
     /*  194796 */     // GIR_Coverage, 781,
     /*  194796 */     GIR_Done,
     /*  194797 */   // Label 3822: @194797
     /*  194797 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(194838), // Rule ID 783 //
     /*  194802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  194805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  194815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194819 */     // MIs[0] rs1
     /*  194819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194831 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194836 */     GIR_RootConstrainSelectedInstOperands,
     /*  194837 */     // GIR_Coverage, 783,
     /*  194837 */     GIR_Done,
     /*  194838 */   // Label 3823: @194838
     /*  194838 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(194879), // Rule ID 785 //
     /*  194843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  194846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  194856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194860 */     // MIs[0] rs1
     /*  194860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194872 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194877 */     GIR_RootConstrainSelectedInstOperands,
     /*  194878 */     // GIR_Coverage, 785,
     /*  194878 */     GIR_Done,
     /*  194879 */   // Label 3824: @194879
     /*  194879 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(194920), // Rule ID 787 //
     /*  194884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  194887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  194894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  194897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194901 */     // MIs[0] rs1
     /*  194901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194913 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (AMOXOR_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_B),
     /*  194918 */     GIR_RootConstrainSelectedInstOperands,
     /*  194919 */     // GIR_Coverage, 787,
     /*  194919 */     GIR_Done,
     /*  194920 */   // Label 3825: @194920
     /*  194920 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(194961), // Rule ID 949 //
     /*  194925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  194938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194942 */     // MIs[0] rs1
     /*  194942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194954 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  194959 */     GIR_RootConstrainSelectedInstOperands,
     /*  194960 */     // GIR_Coverage, 949,
     /*  194960 */     GIR_Done,
     /*  194961 */   // Label 3826: @194961
     /*  194961 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(195002), // Rule ID 951 //
     /*  194966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  194969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  194976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  194979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194983 */     // MIs[0] rs1
     /*  194983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  194987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  194995 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  194995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ),
     /*  195000 */     GIR_RootConstrainSelectedInstOperands,
     /*  195001 */     // GIR_Coverage, 951,
     /*  195001 */     GIR_Done,
     /*  195002 */   // Label 3827: @195002
     /*  195002 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(195043), // Rule ID 953 //
     /*  195007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195024 */     // MIs[0] rs1
     /*  195024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195036 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_RL),
     /*  195041 */     GIR_RootConstrainSelectedInstOperands,
     /*  195042 */     // GIR_Coverage, 953,
     /*  195042 */     GIR_Done,
     /*  195043 */   // Label 3828: @195043
     /*  195043 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(195084), // Rule ID 955 //
     /*  195048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195065 */     // MIs[0] rs1
     /*  195065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195077 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195082 */     GIR_RootConstrainSelectedInstOperands,
     /*  195083 */     // GIR_Coverage, 955,
     /*  195083 */     GIR_Done,
     /*  195084 */   // Label 3829: @195084
     /*  195084 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(195125), // Rule ID 957 //
     /*  195089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  195092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195106 */     // MIs[0] rs1
     /*  195106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195118 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H_AQ_RL),
     /*  195123 */     GIR_RootConstrainSelectedInstOperands,
     /*  195124 */     // GIR_Coverage, 957,
     /*  195124 */     GIR_Done,
     /*  195125 */   // Label 3830: @195125
     /*  195125 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(195166), // Rule ID 959 //
     /*  195130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195147 */     // MIs[0] rs1
     /*  195147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195159 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195164 */     GIR_RootConstrainSelectedInstOperands,
     /*  195165 */     // GIR_Coverage, 959,
     /*  195165 */     GIR_Done,
     /*  195166 */   // Label 3831: @195166
     /*  195166 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(195207), // Rule ID 961 //
     /*  195171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195188 */     // MIs[0] rs1
     /*  195188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195200 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195205 */     GIR_RootConstrainSelectedInstOperands,
     /*  195206 */     // GIR_Coverage, 961,
     /*  195206 */     GIR_Done,
     /*  195207 */   // Label 3832: @195207
     /*  195207 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(195248), // Rule ID 963 //
     /*  195212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195229 */     // MIs[0] rs1
     /*  195229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195241 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195246 */     GIR_RootConstrainSelectedInstOperands,
     /*  195247 */     // GIR_Coverage, 963,
     /*  195247 */     GIR_Done,
     /*  195248 */   // Label 3833: @195248
     /*  195248 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(195289), // Rule ID 965 //
     /*  195253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195270 */     // MIs[0] rs1
     /*  195270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195282 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195287 */     GIR_RootConstrainSelectedInstOperands,
     /*  195288 */     // GIR_Coverage, 965,
     /*  195288 */     GIR_Done,
     /*  195289 */   // Label 3834: @195289
     /*  195289 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(195330), // Rule ID 967 //
     /*  195294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  195297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  195304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195311 */     // MIs[0] rs1
     /*  195311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  195315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195323 */     // (atomic_load_xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (AMOXOR_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  195323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOXOR_H),
     /*  195328 */     GIR_RootConstrainSelectedInstOperands,
     /*  195329 */     // GIR_Coverage, 967,
     /*  195329 */     GIR_Done,
     /*  195330 */   // Label 3835: @195330
     /*  195330 */   GIM_Reject,
     /*  195331 */ // Label 3795: @195331
     /*  195331 */ GIM_Reject,
     /*  195332 */ // Label 3763: @195332
     /*  195332 */ GIM_Reject,
     /*  195333 */ // Label 32: @195333
     /*  195333 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3838*/ GIMT_Encode4(198242),
     /*  195344 */ /*GILLT_s32*//*Label 3836*/ GIMT_Encode4(195352),
     /*  195348 */ /*GILLT_s64*//*Label 3837*/ GIMT_Encode4(196592),
     /*  195352 */ // Label 3836: @195352
     /*  195352 */ GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(196591),
     /*  195357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  195360 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(195401), // Rule ID 442 //
     /*  195365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195382 */     // MIs[0] rs1
     /*  195382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195394 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195394 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195399 */     GIR_RootConstrainSelectedInstOperands,
     /*  195400 */     // GIR_Coverage, 442,
     /*  195400 */     GIR_Done,
     /*  195401 */   // Label 3840: @195401
     /*  195401 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(195442), // Rule ID 444 //
     /*  195406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195423 */     // MIs[0] rs1
     /*  195423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195435 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  195440 */     GIR_RootConstrainSelectedInstOperands,
     /*  195441 */     // GIR_Coverage, 444,
     /*  195441 */     GIR_Done,
     /*  195442 */   // Label 3841: @195442
     /*  195442 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(195483), // Rule ID 446 //
     /*  195447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195464 */     // MIs[0] rs1
     /*  195464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195476 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195476 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  195481 */     GIR_RootConstrainSelectedInstOperands,
     /*  195482 */     // GIR_Coverage, 446,
     /*  195482 */     GIR_Done,
     /*  195483 */   // Label 3842: @195483
     /*  195483 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(195524), // Rule ID 448 //
     /*  195488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195505 */     // MIs[0] rs1
     /*  195505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195517 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195517 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  195522 */     GIR_RootConstrainSelectedInstOperands,
     /*  195523 */     // GIR_Coverage, 448,
     /*  195523 */     GIR_Done,
     /*  195524 */   // Label 3843: @195524
     /*  195524 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(195565), // Rule ID 450 //
     /*  195529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  195532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195546 */     // MIs[0] rs1
     /*  195546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195558 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  195563 */     GIR_RootConstrainSelectedInstOperands,
     /*  195564 */     // GIR_Coverage, 450,
     /*  195564 */     GIR_Done,
     /*  195565 */   // Label 3844: @195565
     /*  195565 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(195606), // Rule ID 452 //
     /*  195570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  195573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195587 */     // MIs[0] rs1
     /*  195587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195599 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195599 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195604 */     GIR_RootConstrainSelectedInstOperands,
     /*  195605 */     // GIR_Coverage, 452,
     /*  195605 */     GIR_Done,
     /*  195606 */   // Label 3845: @195606
     /*  195606 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(195647), // Rule ID 454 //
     /*  195611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  195614 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195621 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195628 */     // MIs[0] rs1
     /*  195628 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195640 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195640 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195645 */     GIR_RootConstrainSelectedInstOperands,
     /*  195646 */     // GIR_Coverage, 454,
     /*  195646 */     GIR_Done,
     /*  195647 */   // Label 3846: @195647
     /*  195647 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(195688), // Rule ID 456 //
     /*  195652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  195655 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195662 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195669 */     // MIs[0] rs1
     /*  195669 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195681 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195681 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195686 */     GIR_RootConstrainSelectedInstOperands,
     /*  195687 */     // GIR_Coverage, 456,
     /*  195687 */     GIR_Done,
     /*  195688 */   // Label 3847: @195688
     /*  195688 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(195729), // Rule ID 458 //
     /*  195693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  195696 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195703 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195710 */     // MIs[0] rs1
     /*  195710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195722 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195727 */     GIR_RootConstrainSelectedInstOperands,
     /*  195728 */     // GIR_Coverage, 458,
     /*  195728 */     GIR_Done,
     /*  195729 */   // Label 3848: @195729
     /*  195729 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(195770), // Rule ID 460 //
     /*  195734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  195737 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  195744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195751 */     // MIs[0] rs1
     /*  195751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195763 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195763 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  195768 */     GIR_RootConstrainSelectedInstOperands,
     /*  195769 */     // GIR_Coverage, 460,
     /*  195769 */     GIR_Done,
     /*  195770 */   // Label 3849: @195770
     /*  195770 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(195811), // Rule ID 790 //
     /*  195775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  195778 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195785 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195792 */     // MIs[0] rs1
     /*  195792 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195804 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195804 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  195809 */     GIR_RootConstrainSelectedInstOperands,
     /*  195810 */     // GIR_Coverage, 790,
     /*  195810 */     GIR_Done,
     /*  195811 */   // Label 3850: @195811
     /*  195811 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(195852), // Rule ID 792 //
     /*  195816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  195819 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  195829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195833 */     // MIs[0] rs1
     /*  195833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195845 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195845 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  195850 */     GIR_RootConstrainSelectedInstOperands,
     /*  195851 */     // GIR_Coverage, 792,
     /*  195851 */     GIR_Done,
     /*  195852 */   // Label 3851: @195852
     /*  195852 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(195893), // Rule ID 794 //
     /*  195857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  195860 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195867 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  195870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195874 */     // MIs[0] rs1
     /*  195874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195886 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  195891 */     GIR_RootConstrainSelectedInstOperands,
     /*  195892 */     // GIR_Coverage, 794,
     /*  195892 */     GIR_Done,
     /*  195893 */   // Label 3852: @195893
     /*  195893 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(195934), // Rule ID 796 //
     /*  195898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  195901 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195908 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  195911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195915 */     // MIs[0] rs1
     /*  195915 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195927 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  195932 */     GIR_RootConstrainSelectedInstOperands,
     /*  195933 */     // GIR_Coverage, 796,
     /*  195933 */     GIR_Done,
     /*  195934 */   // Label 3853: @195934
     /*  195934 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(195975), // Rule ID 798 //
     /*  195939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  195942 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195949 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  195952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195956 */     // MIs[0] rs1
     /*  195956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  195960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195968 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  195968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  195973 */     GIR_RootConstrainSelectedInstOperands,
     /*  195974 */     // GIR_Coverage, 798,
     /*  195974 */     GIR_Done,
     /*  195975 */   // Label 3854: @195975
     /*  195975 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(196016), // Rule ID 800 //
     /*  195980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  195983 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  195990 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  195993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  195997 */     // MIs[0] rs1
     /*  195997 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196009 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196009 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196014 */     GIR_RootConstrainSelectedInstOperands,
     /*  196015 */     // GIR_Coverage, 800,
     /*  196015 */     GIR_Done,
     /*  196016 */   // Label 3855: @196016
     /*  196016 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(196057), // Rule ID 802 //
     /*  196021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196038 */     // MIs[0] rs1
     /*  196038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196050 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196050 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196055 */     GIR_RootConstrainSelectedInstOperands,
     /*  196056 */     // GIR_Coverage, 802,
     /*  196056 */     GIR_Done,
     /*  196057 */   // Label 3856: @196057
     /*  196057 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(196098), // Rule ID 804 //
     /*  196062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196065 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196072 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196079 */     // MIs[0] rs1
     /*  196079 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196091 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196091 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196096 */     GIR_RootConstrainSelectedInstOperands,
     /*  196097 */     // GIR_Coverage, 804,
     /*  196097 */     GIR_Done,
     /*  196098 */   // Label 3857: @196098
     /*  196098 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(196139), // Rule ID 806 //
     /*  196103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196120 */     // MIs[0] rs1
     /*  196120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196132 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196137 */     GIR_RootConstrainSelectedInstOperands,
     /*  196138 */     // GIR_Coverage, 806,
     /*  196138 */     GIR_Done,
     /*  196139 */   // Label 3858: @196139
     /*  196139 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(196180), // Rule ID 808 //
     /*  196144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  196154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196161 */     // MIs[0] rs1
     /*  196161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196173 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  196178 */     GIR_RootConstrainSelectedInstOperands,
     /*  196179 */     // GIR_Coverage, 808,
     /*  196179 */     GIR_Done,
     /*  196180 */   // Label 3859: @196180
     /*  196180 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(196221), // Rule ID 970 //
     /*  196185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196202 */     // MIs[0] rs1
     /*  196202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196214 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196219 */     GIR_RootConstrainSelectedInstOperands,
     /*  196220 */     // GIR_Coverage, 970,
     /*  196220 */     GIR_Done,
     /*  196221 */   // Label 3860: @196221
     /*  196221 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(196262), // Rule ID 972 //
     /*  196226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196243 */     // MIs[0] rs1
     /*  196243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196255 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  196260 */     GIR_RootConstrainSelectedInstOperands,
     /*  196261 */     // GIR_Coverage, 972,
     /*  196261 */     GIR_Done,
     /*  196262 */   // Label 3861: @196262
     /*  196262 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(196303), // Rule ID 974 //
     /*  196267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196284 */     // MIs[0] rs1
     /*  196284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196296 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  196301 */     GIR_RootConstrainSelectedInstOperands,
     /*  196302 */     // GIR_Coverage, 974,
     /*  196302 */     GIR_Done,
     /*  196303 */   // Label 3862: @196303
     /*  196303 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(196344), // Rule ID 976 //
     /*  196308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196325 */     // MIs[0] rs1
     /*  196325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196337 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196342 */     GIR_RootConstrainSelectedInstOperands,
     /*  196343 */     // GIR_Coverage, 976,
     /*  196343 */     GIR_Done,
     /*  196344 */   // Label 3863: @196344
     /*  196344 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(196385), // Rule ID 978 //
     /*  196349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  196352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196366 */     // MIs[0] rs1
     /*  196366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196378 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  196383 */     GIR_RootConstrainSelectedInstOperands,
     /*  196384 */     // GIR_Coverage, 978,
     /*  196384 */     GIR_Done,
     /*  196385 */   // Label 3864: @196385
     /*  196385 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(196426), // Rule ID 980 //
     /*  196390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196407 */     // MIs[0] rs1
     /*  196407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196419 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196424 */     GIR_RootConstrainSelectedInstOperands,
     /*  196425 */     // GIR_Coverage, 980,
     /*  196425 */     GIR_Done,
     /*  196426 */   // Label 3865: @196426
     /*  196426 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(196467), // Rule ID 982 //
     /*  196431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196448 */     // MIs[0] rs1
     /*  196448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196460 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196465 */     GIR_RootConstrainSelectedInstOperands,
     /*  196466 */     // GIR_Coverage, 982,
     /*  196466 */     GIR_Done,
     /*  196467 */   // Label 3866: @196467
     /*  196467 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(196508), // Rule ID 984 //
     /*  196472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196489 */     // MIs[0] rs1
     /*  196489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196501 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196506 */     GIR_RootConstrainSelectedInstOperands,
     /*  196507 */     // GIR_Coverage, 984,
     /*  196507 */     GIR_Done,
     /*  196508 */   // Label 3867: @196508
     /*  196508 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(196549), // Rule ID 986 //
     /*  196513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196530 */     // MIs[0] rs1
     /*  196530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196542 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196547 */     GIR_RootConstrainSelectedInstOperands,
     /*  196548 */     // GIR_Coverage, 986,
     /*  196548 */     GIR_Done,
     /*  196549 */   // Label 3868: @196549
     /*  196549 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(196590), // Rule ID 988 //
     /*  196554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  196557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  196564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196571 */     // MIs[0] rs1
     /*  196571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  196575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196583 */     // (atomic_load_max:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  196583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  196588 */     GIR_RootConstrainSelectedInstOperands,
     /*  196589 */     // GIR_Coverage, 988,
     /*  196589 */     GIR_Done,
     /*  196590 */   // Label 3869: @196590
     /*  196590 */   GIM_Reject,
     /*  196591 */ // Label 3839: @196591
     /*  196591 */ GIM_Reject,
     /*  196592 */ // Label 3837: @196592
     /*  196592 */ GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(198241),
     /*  196597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  196600 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(196641), // Rule ID 441 //
     /*  196605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  196608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196622 */     // MIs[0] rs1
     /*  196622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196634 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196639 */     GIR_RootConstrainSelectedInstOperands,
     /*  196640 */     // GIR_Coverage, 441,
     /*  196640 */     GIR_Done,
     /*  196641 */   // Label 3871: @196641
     /*  196641 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(196682), // Rule ID 443 //
     /*  196646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  196649 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196656 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196663 */     // MIs[0] rs1
     /*  196663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196675 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196675 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ),
     /*  196680 */     GIR_RootConstrainSelectedInstOperands,
     /*  196681 */     // GIR_Coverage, 443,
     /*  196681 */     GIR_Done,
     /*  196682 */   // Label 3872: @196682
     /*  196682 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(196723), // Rule ID 445 //
     /*  196687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  196690 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196697 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196704 */     // MIs[0] rs1
     /*  196704 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196708 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196716 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_RL),
     /*  196721 */     GIR_RootConstrainSelectedInstOperands,
     /*  196722 */     // GIR_Coverage, 445,
     /*  196722 */     GIR_Done,
     /*  196723 */   // Label 3873: @196723
     /*  196723 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(196764), // Rule ID 447 //
     /*  196728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  196731 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196738 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196745 */     // MIs[0] rs1
     /*  196745 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196757 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196757 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196762 */     GIR_RootConstrainSelectedInstOperands,
     /*  196763 */     // GIR_Coverage, 447,
     /*  196763 */     GIR_Done,
     /*  196764 */   // Label 3874: @196764
     /*  196764 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(196805), // Rule ID 449 //
     /*  196769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  196772 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196779 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196786 */     // MIs[0] rs1
     /*  196786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196798 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196798 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W_AQ_RL),
     /*  196803 */     GIR_RootConstrainSelectedInstOperands,
     /*  196804 */     // GIR_Coverage, 449,
     /*  196804 */     GIR_Done,
     /*  196805 */   // Label 3875: @196805
     /*  196805 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(196846), // Rule ID 451 //
     /*  196810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  196813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  196823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196827 */     // MIs[0] rs1
     /*  196827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196839 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196844 */     GIR_RootConstrainSelectedInstOperands,
     /*  196845 */     // GIR_Coverage, 451,
     /*  196845 */     GIR_Done,
     /*  196846 */   // Label 3876: @196846
     /*  196846 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(196887), // Rule ID 453 //
     /*  196851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  196854 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  196864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196868 */     // MIs[0] rs1
     /*  196868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196880 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196885 */     GIR_RootConstrainSelectedInstOperands,
     /*  196886 */     // GIR_Coverage, 453,
     /*  196886 */     GIR_Done,
     /*  196887 */   // Label 3877: @196887
     /*  196887 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(196928), // Rule ID 455 //
     /*  196892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  196895 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  196905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196909 */     // MIs[0] rs1
     /*  196909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196921 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196921 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196926 */     GIR_RootConstrainSelectedInstOperands,
     /*  196927 */     // GIR_Coverage, 455,
     /*  196927 */     GIR_Done,
     /*  196928 */   // Label 3878: @196928
     /*  196928 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(196969), // Rule ID 457 //
     /*  196933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  196936 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  196946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196950 */     // MIs[0] rs1
     /*  196950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196962 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  196962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  196967 */     GIR_RootConstrainSelectedInstOperands,
     /*  196968 */     // GIR_Coverage, 457,
     /*  196968 */     GIR_Done,
     /*  196969 */   // Label 3879: @196969
     /*  196969 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(197010), // Rule ID 459 //
     /*  196974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  196977 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  196984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  196987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196991 */     // MIs[0] rs1
     /*  196991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  196995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  196999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197003 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (AMOMAX_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197003 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_W),
     /*  197008 */     GIR_RootConstrainSelectedInstOperands,
     /*  197009 */     // GIR_Coverage, 459,
     /*  197009 */     GIR_Done,
     /*  197010 */   // Label 3880: @197010
     /*  197010 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(197051), // Rule ID 571 //
     /*  197015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197018 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197032 */     // MIs[0] rs1
     /*  197032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197044 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197044 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197049 */     GIR_RootConstrainSelectedInstOperands,
     /*  197050 */     // GIR_Coverage, 571,
     /*  197050 */     GIR_Done,
     /*  197051 */   // Label 3881: @197051
     /*  197051 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(197092), // Rule ID 572 //
     /*  197056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197059 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197066 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197073 */     // MIs[0] rs1
     /*  197073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197085 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ),
     /*  197090 */     GIR_RootConstrainSelectedInstOperands,
     /*  197091 */     // GIR_Coverage, 572,
     /*  197091 */     GIR_Done,
     /*  197092 */   // Label 3882: @197092
     /*  197092 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(197133), // Rule ID 573 //
     /*  197097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197114 */     // MIs[0] rs1
     /*  197114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197126 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197126 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_RL),
     /*  197131 */     GIR_RootConstrainSelectedInstOperands,
     /*  197132 */     // GIR_Coverage, 573,
     /*  197132 */     GIR_Done,
     /*  197133 */   // Label 3883: @197133
     /*  197133 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(197174), // Rule ID 574 //
     /*  197138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197148 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197155 */     // MIs[0] rs1
     /*  197155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197167 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197167 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197172 */     GIR_RootConstrainSelectedInstOperands,
     /*  197173 */     // GIR_Coverage, 574,
     /*  197173 */     GIR_Done,
     /*  197174 */   // Label 3884: @197174
     /*  197174 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(197215), // Rule ID 575 //
     /*  197179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  197182 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197189 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197196 */     // MIs[0] rs1
     /*  197196 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197208 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197208 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D_AQ_RL),
     /*  197213 */     GIR_RootConstrainSelectedInstOperands,
     /*  197214 */     // GIR_Coverage, 575,
     /*  197214 */     GIR_Done,
     /*  197215 */   // Label 3885: @197215
     /*  197215 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(197256), // Rule ID 576 //
     /*  197220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197223 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197230 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197237 */     // MIs[0] rs1
     /*  197237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197249 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197249 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197254 */     GIR_RootConstrainSelectedInstOperands,
     /*  197255 */     // GIR_Coverage, 576,
     /*  197255 */     GIR_Done,
     /*  197256 */   // Label 3886: @197256
     /*  197256 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(197297), // Rule ID 577 //
     /*  197261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197264 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197271 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197278 */     // MIs[0] rs1
     /*  197278 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197290 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197295 */     GIR_RootConstrainSelectedInstOperands,
     /*  197296 */     // GIR_Coverage, 577,
     /*  197296 */     GIR_Done,
     /*  197297 */   // Label 3887: @197297
     /*  197297 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(197338), // Rule ID 578 //
     /*  197302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197305 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197312 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197319 */     // MIs[0] rs1
     /*  197319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197331 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197331 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197336 */     GIR_RootConstrainSelectedInstOperands,
     /*  197337 */     // GIR_Coverage, 578,
     /*  197337 */     GIR_Done,
     /*  197338 */   // Label 3888: @197338
     /*  197338 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(197379), // Rule ID 579 //
     /*  197343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197346 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197360 */     // MIs[0] rs1
     /*  197360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197372 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197377 */     GIR_RootConstrainSelectedInstOperands,
     /*  197378 */     // GIR_Coverage, 579,
     /*  197378 */     GIR_Done,
     /*  197379 */   // Label 3889: @197379
     /*  197379 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(197420), // Rule ID 580 //
     /*  197384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  197387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  197394 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197401 */     // MIs[0] rs1
     /*  197401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197413 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (AMOMAX_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197413 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_D),
     /*  197418 */     GIR_RootConstrainSelectedInstOperands,
     /*  197419 */     // GIR_Coverage, 580,
     /*  197419 */     GIR_Done,
     /*  197420 */   // Label 3890: @197420
     /*  197420 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(197461), // Rule ID 789 //
     /*  197425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197442 */     // MIs[0] rs1
     /*  197442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197454 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197459 */     GIR_RootConstrainSelectedInstOperands,
     /*  197460 */     // GIR_Coverage, 789,
     /*  197460 */     GIR_Done,
     /*  197461 */   // Label 3891: @197461
     /*  197461 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(197502), // Rule ID 791 //
     /*  197466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197483 */     // MIs[0] rs1
     /*  197483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197495 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ),
     /*  197500 */     GIR_RootConstrainSelectedInstOperands,
     /*  197501 */     // GIR_Coverage, 791,
     /*  197501 */     GIR_Done,
     /*  197502 */   // Label 3892: @197502
     /*  197502 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(197543), // Rule ID 793 //
     /*  197507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197524 */     // MIs[0] rs1
     /*  197524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197536 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_RL),
     /*  197541 */     GIR_RootConstrainSelectedInstOperands,
     /*  197542 */     // GIR_Coverage, 793,
     /*  197542 */     GIR_Done,
     /*  197543 */   // Label 3893: @197543
     /*  197543 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(197584), // Rule ID 795 //
     /*  197548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197565 */     // MIs[0] rs1
     /*  197565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197577 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  197582 */     GIR_RootConstrainSelectedInstOperands,
     /*  197583 */     // GIR_Coverage, 795,
     /*  197583 */     GIR_Done,
     /*  197584 */   // Label 3894: @197584
     /*  197584 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(197625), // Rule ID 797 //
     /*  197589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197606 */     // MIs[0] rs1
     /*  197606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197618 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B_AQ_RL),
     /*  197623 */     GIR_RootConstrainSelectedInstOperands,
     /*  197624 */     // GIR_Coverage, 797,
     /*  197624 */     GIR_Done,
     /*  197625 */   // Label 3895: @197625
     /*  197625 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(197666), // Rule ID 799 //
     /*  197630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  197633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197647 */     // MIs[0] rs1
     /*  197647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197659 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197664 */     GIR_RootConstrainSelectedInstOperands,
     /*  197665 */     // GIR_Coverage, 799,
     /*  197665 */     GIR_Done,
     /*  197666 */   // Label 3896: @197666
     /*  197666 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(197707), // Rule ID 801 //
     /*  197671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  197674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197688 */     // MIs[0] rs1
     /*  197688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197700 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197705 */     GIR_RootConstrainSelectedInstOperands,
     /*  197706 */     // GIR_Coverage, 801,
     /*  197706 */     GIR_Done,
     /*  197707 */   // Label 3897: @197707
     /*  197707 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(197748), // Rule ID 803 //
     /*  197712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  197715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197729 */     // MIs[0] rs1
     /*  197729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197741 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197746 */     GIR_RootConstrainSelectedInstOperands,
     /*  197747 */     // GIR_Coverage, 803,
     /*  197747 */     GIR_Done,
     /*  197748 */   // Label 3898: @197748
     /*  197748 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(197789), // Rule ID 805 //
     /*  197753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  197756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197770 */     // MIs[0] rs1
     /*  197770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197782 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197787 */     GIR_RootConstrainSelectedInstOperands,
     /*  197788 */     // GIR_Coverage, 805,
     /*  197788 */     GIR_Done,
     /*  197789 */   // Label 3899: @197789
     /*  197789 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(197830), // Rule ID 807 //
     /*  197794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  197797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  197804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  197807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197811 */     // MIs[0] rs1
     /*  197811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197823 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (AMOMAX_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_B),
     /*  197828 */     GIR_RootConstrainSelectedInstOperands,
     /*  197829 */     // GIR_Coverage, 807,
     /*  197829 */     GIR_Done,
     /*  197830 */   // Label 3900: @197830
     /*  197830 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(197871), // Rule ID 969 //
     /*  197835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  197848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197852 */     // MIs[0] rs1
     /*  197852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197864 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  197869 */     GIR_RootConstrainSelectedInstOperands,
     /*  197870 */     // GIR_Coverage, 969,
     /*  197870 */     GIR_Done,
     /*  197871 */   // Label 3901: @197871
     /*  197871 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(197912), // Rule ID 971 //
     /*  197876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  197889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197893 */     // MIs[0] rs1
     /*  197893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197905 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ),
     /*  197910 */     GIR_RootConstrainSelectedInstOperands,
     /*  197911 */     // GIR_Coverage, 971,
     /*  197911 */     GIR_Done,
     /*  197912 */   // Label 3902: @197912
     /*  197912 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(197953), // Rule ID 973 //
     /*  197917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  197930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197934 */     // MIs[0] rs1
     /*  197934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197946 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_RL),
     /*  197951 */     GIR_RootConstrainSelectedInstOperands,
     /*  197952 */     // GIR_Coverage, 973,
     /*  197952 */     GIR_Done,
     /*  197953 */   // Label 3903: @197953
     /*  197953 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(197994), // Rule ID 975 //
     /*  197958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  197961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  197968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  197971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197975 */     // MIs[0] rs1
     /*  197975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  197979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  197987 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  197987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  197992 */     GIR_RootConstrainSelectedInstOperands,
     /*  197993 */     // GIR_Coverage, 975,
     /*  197993 */     GIR_Done,
     /*  197994 */   // Label 3904: @197994
     /*  197994 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(198035), // Rule ID 977 //
     /*  197999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  198002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198016 */     // MIs[0] rs1
     /*  198016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198028 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H_AQ_RL),
     /*  198033 */     GIR_RootConstrainSelectedInstOperands,
     /*  198034 */     // GIR_Coverage, 977,
     /*  198034 */     GIR_Done,
     /*  198035 */   // Label 3905: @198035
     /*  198035 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(198076), // Rule ID 979 //
     /*  198040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198057 */     // MIs[0] rs1
     /*  198057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198069 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198074 */     GIR_RootConstrainSelectedInstOperands,
     /*  198075 */     // GIR_Coverage, 979,
     /*  198075 */     GIR_Done,
     /*  198076 */   // Label 3906: @198076
     /*  198076 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(198117), // Rule ID 981 //
     /*  198081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198098 */     // MIs[0] rs1
     /*  198098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198110 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198115 */     GIR_RootConstrainSelectedInstOperands,
     /*  198116 */     // GIR_Coverage, 981,
     /*  198116 */     GIR_Done,
     /*  198117 */   // Label 3907: @198117
     /*  198117 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(198158), // Rule ID 983 //
     /*  198122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198139 */     // MIs[0] rs1
     /*  198139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198151 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198156 */     GIR_RootConstrainSelectedInstOperands,
     /*  198157 */     // GIR_Coverage, 983,
     /*  198157 */     GIR_Done,
     /*  198158 */   // Label 3908: @198158
     /*  198158 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(198199), // Rule ID 985 //
     /*  198163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198180 */     // MIs[0] rs1
     /*  198180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198192 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198197 */     GIR_RootConstrainSelectedInstOperands,
     /*  198198 */     // GIR_Coverage, 985,
     /*  198198 */     GIR_Done,
     /*  198199 */   // Label 3909: @198199
     /*  198199 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(198240), // Rule ID 987 //
     /*  198204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  198207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  198214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198221 */     // MIs[0] rs1
     /*  198221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  198225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198233 */     // (atomic_load_max:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (AMOMAX_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  198233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAX_H),
     /*  198238 */     GIR_RootConstrainSelectedInstOperands,
     /*  198239 */     // GIR_Coverage, 987,
     /*  198239 */     GIR_Done,
     /*  198240 */   // Label 3910: @198240
     /*  198240 */   GIM_Reject,
     /*  198241 */ // Label 3870: @198241
     /*  198241 */ GIM_Reject,
     /*  198242 */ // Label 3838: @198242
     /*  198242 */ GIM_Reject,
     /*  198243 */ // Label 33: @198243
     /*  198243 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3913*/ GIMT_Encode4(201152),
     /*  198254 */ /*GILLT_s32*//*Label 3911*/ GIMT_Encode4(198262),
     /*  198258 */ /*GILLT_s64*//*Label 3912*/ GIMT_Encode4(199502),
     /*  198262 */ // Label 3911: @198262
     /*  198262 */ GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(199501),
     /*  198267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  198270 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(198311), // Rule ID 462 //
     /*  198275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198278 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198285 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198292 */     // MIs[0] rs1
     /*  198292 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198304 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198304 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198309 */     GIR_RootConstrainSelectedInstOperands,
     /*  198310 */     // GIR_Coverage, 462,
     /*  198310 */     GIR_Done,
     /*  198311 */   // Label 3915: @198311
     /*  198311 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(198352), // Rule ID 464 //
     /*  198316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198333 */     // MIs[0] rs1
     /*  198333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198345 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  198350 */     GIR_RootConstrainSelectedInstOperands,
     /*  198351 */     // GIR_Coverage, 464,
     /*  198351 */     GIR_Done,
     /*  198352 */   // Label 3916: @198352
     /*  198352 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(198393), // Rule ID 466 //
     /*  198357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198374 */     // MIs[0] rs1
     /*  198374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198386 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  198391 */     GIR_RootConstrainSelectedInstOperands,
     /*  198392 */     // GIR_Coverage, 466,
     /*  198392 */     GIR_Done,
     /*  198393 */   // Label 3917: @198393
     /*  198393 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(198434), // Rule ID 468 //
     /*  198398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198415 */     // MIs[0] rs1
     /*  198415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198427 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198432 */     GIR_RootConstrainSelectedInstOperands,
     /*  198433 */     // GIR_Coverage, 468,
     /*  198433 */     GIR_Done,
     /*  198434 */   // Label 3918: @198434
     /*  198434 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(198475), // Rule ID 470 //
     /*  198439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  198442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198456 */     // MIs[0] rs1
     /*  198456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198468 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  198473 */     GIR_RootConstrainSelectedInstOperands,
     /*  198474 */     // GIR_Coverage, 470,
     /*  198474 */     GIR_Done,
     /*  198475 */   // Label 3919: @198475
     /*  198475 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(198516), // Rule ID 472 //
     /*  198480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198497 */     // MIs[0] rs1
     /*  198497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198509 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198514 */     GIR_RootConstrainSelectedInstOperands,
     /*  198515 */     // GIR_Coverage, 472,
     /*  198515 */     GIR_Done,
     /*  198516 */   // Label 3920: @198516
     /*  198516 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(198557), // Rule ID 474 //
     /*  198521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198538 */     // MIs[0] rs1
     /*  198538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198550 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198550 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198555 */     GIR_RootConstrainSelectedInstOperands,
     /*  198556 */     // GIR_Coverage, 474,
     /*  198556 */     GIR_Done,
     /*  198557 */   // Label 3921: @198557
     /*  198557 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(198598), // Rule ID 476 //
     /*  198562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198565 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198572 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198579 */     // MIs[0] rs1
     /*  198579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198591 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198591 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198596 */     GIR_RootConstrainSelectedInstOperands,
     /*  198597 */     // GIR_Coverage, 476,
     /*  198597 */     GIR_Done,
     /*  198598 */   // Label 3922: @198598
     /*  198598 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(198639), // Rule ID 478 //
     /*  198603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198620 */     // MIs[0] rs1
     /*  198620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198632 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198632 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198637 */     GIR_RootConstrainSelectedInstOperands,
     /*  198638 */     // GIR_Coverage, 478,
     /*  198638 */     GIR_Done,
     /*  198639 */   // Label 3923: @198639
     /*  198639 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(198680), // Rule ID 480 //
     /*  198644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  198647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  198654 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198661 */     // MIs[0] rs1
     /*  198661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198673 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  198678 */     GIR_RootConstrainSelectedInstOperands,
     /*  198679 */     // GIR_Coverage, 480,
     /*  198679 */     GIR_Done,
     /*  198680 */   // Label 3924: @198680
     /*  198680 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(198721), // Rule ID 810 //
     /*  198685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  198688 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198695 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198702 */     // MIs[0] rs1
     /*  198702 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198714 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  198719 */     GIR_RootConstrainSelectedInstOperands,
     /*  198720 */     // GIR_Coverage, 810,
     /*  198720 */     GIR_Done,
     /*  198721 */   // Label 3925: @198721
     /*  198721 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(198762), // Rule ID 812 //
     /*  198726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  198729 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198743 */     // MIs[0] rs1
     /*  198743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198755 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  198760 */     GIR_RootConstrainSelectedInstOperands,
     /*  198761 */     // GIR_Coverage, 812,
     /*  198761 */     GIR_Done,
     /*  198762 */   // Label 3926: @198762
     /*  198762 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(198803), // Rule ID 814 //
     /*  198767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  198770 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198784 */     // MIs[0] rs1
     /*  198784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198796 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  198801 */     GIR_RootConstrainSelectedInstOperands,
     /*  198802 */     // GIR_Coverage, 814,
     /*  198802 */     GIR_Done,
     /*  198803 */   // Label 3927: @198803
     /*  198803 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(198844), // Rule ID 816 //
     /*  198808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  198811 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  198821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198825 */     // MIs[0] rs1
     /*  198825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198837 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198837 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  198842 */     GIR_RootConstrainSelectedInstOperands,
     /*  198843 */     // GIR_Coverage, 816,
     /*  198843 */     GIR_Done,
     /*  198844 */   // Label 3928: @198844
     /*  198844 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(198885), // Rule ID 818 //
     /*  198849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  198852 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198859 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  198862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198866 */     // MIs[0] rs1
     /*  198866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198878 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  198883 */     GIR_RootConstrainSelectedInstOperands,
     /*  198884 */     // GIR_Coverage, 818,
     /*  198884 */     GIR_Done,
     /*  198885 */   // Label 3929: @198885
     /*  198885 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(198926), // Rule ID 820 //
     /*  198890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  198893 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  198903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198907 */     // MIs[0] rs1
     /*  198907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198919 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198919 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  198924 */     GIR_RootConstrainSelectedInstOperands,
     /*  198925 */     // GIR_Coverage, 820,
     /*  198925 */     GIR_Done,
     /*  198926 */   // Label 3930: @198926
     /*  198926 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(198967), // Rule ID 822 //
     /*  198931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  198934 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  198944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198948 */     // MIs[0] rs1
     /*  198948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198960 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  198960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  198965 */     GIR_RootConstrainSelectedInstOperands,
     /*  198966 */     // GIR_Coverage, 822,
     /*  198966 */     GIR_Done,
     /*  198967 */   // Label 3931: @198967
     /*  198967 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(199008), // Rule ID 824 //
     /*  198972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  198975 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  198982 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  198985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198989 */     // MIs[0] rs1
     /*  198989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  198993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  198997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199001 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199006 */     GIR_RootConstrainSelectedInstOperands,
     /*  199007 */     // GIR_Coverage, 824,
     /*  199007 */     GIR_Done,
     /*  199008 */   // Label 3932: @199008
     /*  199008 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(199049), // Rule ID 826 //
     /*  199013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199016 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199023 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199030 */     // MIs[0] rs1
     /*  199030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199042 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199047 */     GIR_RootConstrainSelectedInstOperands,
     /*  199048 */     // GIR_Coverage, 826,
     /*  199048 */     GIR_Done,
     /*  199049 */   // Label 3933: @199049
     /*  199049 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(199090), // Rule ID 828 //
     /*  199054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  199064 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199071 */     // MIs[0] rs1
     /*  199071 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199083 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  199088 */     GIR_RootConstrainSelectedInstOperands,
     /*  199089 */     // GIR_Coverage, 828,
     /*  199089 */     GIR_Done,
     /*  199090 */   // Label 3934: @199090
     /*  199090 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(199131), // Rule ID 990 //
     /*  199095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199112 */     // MIs[0] rs1
     /*  199112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199124 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199129 */     GIR_RootConstrainSelectedInstOperands,
     /*  199130 */     // GIR_Coverage, 990,
     /*  199130 */     GIR_Done,
     /*  199131 */   // Label 3935: @199131
     /*  199131 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(199172), // Rule ID 992 //
     /*  199136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199139 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199153 */     // MIs[0] rs1
     /*  199153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199165 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  199170 */     GIR_RootConstrainSelectedInstOperands,
     /*  199171 */     // GIR_Coverage, 992,
     /*  199171 */     GIR_Done,
     /*  199172 */   // Label 3936: @199172
     /*  199172 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(199213), // Rule ID 994 //
     /*  199177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199194 */     // MIs[0] rs1
     /*  199194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199206 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  199211 */     GIR_RootConstrainSelectedInstOperands,
     /*  199212 */     // GIR_Coverage, 994,
     /*  199212 */     GIR_Done,
     /*  199213 */   // Label 3937: @199213
     /*  199213 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(199254), // Rule ID 996 //
     /*  199218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199235 */     // MIs[0] rs1
     /*  199235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199247 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199252 */     GIR_RootConstrainSelectedInstOperands,
     /*  199253 */     // GIR_Coverage, 996,
     /*  199253 */     GIR_Done,
     /*  199254 */   // Label 3938: @199254
     /*  199254 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(199295), // Rule ID 998 //
     /*  199259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  199262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199276 */     // MIs[0] rs1
     /*  199276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199288 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  199293 */     GIR_RootConstrainSelectedInstOperands,
     /*  199294 */     // GIR_Coverage, 998,
     /*  199294 */     GIR_Done,
     /*  199295 */   // Label 3939: @199295
     /*  199295 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(199336), // Rule ID 1000 //
     /*  199300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199317 */     // MIs[0] rs1
     /*  199317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199329 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199334 */     GIR_RootConstrainSelectedInstOperands,
     /*  199335 */     // GIR_Coverage, 1000,
     /*  199335 */     GIR_Done,
     /*  199336 */   // Label 3940: @199336
     /*  199336 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(199377), // Rule ID 1002 //
     /*  199341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199358 */     // MIs[0] rs1
     /*  199358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199370 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199375 */     GIR_RootConstrainSelectedInstOperands,
     /*  199376 */     // GIR_Coverage, 1002,
     /*  199376 */     GIR_Done,
     /*  199377 */   // Label 3941: @199377
     /*  199377 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(199418), // Rule ID 1004 //
     /*  199382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199399 */     // MIs[0] rs1
     /*  199399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199411 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199416 */     GIR_RootConstrainSelectedInstOperands,
     /*  199417 */     // GIR_Coverage, 1004,
     /*  199417 */     GIR_Done,
     /*  199418 */   // Label 3942: @199418
     /*  199418 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(199459), // Rule ID 1006 //
     /*  199423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199440 */     // MIs[0] rs1
     /*  199440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199452 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199457 */     GIR_RootConstrainSelectedInstOperands,
     /*  199458 */     // GIR_Coverage, 1006,
     /*  199458 */     GIR_Done,
     /*  199459 */   // Label 3943: @199459
     /*  199459 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(199500), // Rule ID 1008 //
     /*  199464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  199467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  199474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199481 */     // MIs[0] rs1
     /*  199481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  199485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199493 */     // (atomic_load_min:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  199493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  199498 */     GIR_RootConstrainSelectedInstOperands,
     /*  199499 */     // GIR_Coverage, 1008,
     /*  199499 */     GIR_Done,
     /*  199500 */   // Label 3944: @199500
     /*  199500 */   GIM_Reject,
     /*  199501 */ // Label 3914: @199501
     /*  199501 */ GIM_Reject,
     /*  199502 */ // Label 3912: @199502
     /*  199502 */ GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(201151),
     /*  199507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  199510 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(199551), // Rule ID 461 //
     /*  199515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  199518 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199525 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199532 */     // MIs[0] rs1
     /*  199532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199544 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199544 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199549 */     GIR_RootConstrainSelectedInstOperands,
     /*  199550 */     // GIR_Coverage, 461,
     /*  199550 */     GIR_Done,
     /*  199551 */   // Label 3946: @199551
     /*  199551 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(199592), // Rule ID 463 //
     /*  199556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  199559 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199573 */     // MIs[0] rs1
     /*  199573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199585 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199585 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ),
     /*  199590 */     GIR_RootConstrainSelectedInstOperands,
     /*  199591 */     // GIR_Coverage, 463,
     /*  199591 */     GIR_Done,
     /*  199592 */   // Label 3947: @199592
     /*  199592 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(199633), // Rule ID 465 //
     /*  199597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  199600 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199607 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199614 */     // MIs[0] rs1
     /*  199614 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199626 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_RL),
     /*  199631 */     GIR_RootConstrainSelectedInstOperands,
     /*  199632 */     // GIR_Coverage, 465,
     /*  199632 */     GIR_Done,
     /*  199633 */   // Label 3948: @199633
     /*  199633 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(199674), // Rule ID 467 //
     /*  199638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  199641 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199655 */     // MIs[0] rs1
     /*  199655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199667 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199672 */     GIR_RootConstrainSelectedInstOperands,
     /*  199673 */     // GIR_Coverage, 467,
     /*  199673 */     GIR_Done,
     /*  199674 */   // Label 3949: @199674
     /*  199674 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(199715), // Rule ID 469 //
     /*  199679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  199682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199696 */     // MIs[0] rs1
     /*  199696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199708 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199708 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W_AQ_RL),
     /*  199713 */     GIR_RootConstrainSelectedInstOperands,
     /*  199714 */     // GIR_Coverage, 469,
     /*  199714 */     GIR_Done,
     /*  199715 */   // Label 3950: @199715
     /*  199715 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(199756), // Rule ID 471 //
     /*  199720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  199723 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199730 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199737 */     // MIs[0] rs1
     /*  199737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199749 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199749 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199754 */     GIR_RootConstrainSelectedInstOperands,
     /*  199755 */     // GIR_Coverage, 471,
     /*  199755 */     GIR_Done,
     /*  199756 */   // Label 3951: @199756
     /*  199756 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(199797), // Rule ID 473 //
     /*  199761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  199764 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199771 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199778 */     // MIs[0] rs1
     /*  199778 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199790 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199795 */     GIR_RootConstrainSelectedInstOperands,
     /*  199796 */     // GIR_Coverage, 473,
     /*  199796 */     GIR_Done,
     /*  199797 */   // Label 3952: @199797
     /*  199797 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(199838), // Rule ID 475 //
     /*  199802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  199805 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  199815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199819 */     // MIs[0] rs1
     /*  199819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199831 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199836 */     GIR_RootConstrainSelectedInstOperands,
     /*  199837 */     // GIR_Coverage, 475,
     /*  199837 */     GIR_Done,
     /*  199838 */   // Label 3953: @199838
     /*  199838 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(199879), // Rule ID 477 //
     /*  199843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  199846 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199853 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  199856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199860 */     // MIs[0] rs1
     /*  199860 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199872 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199877 */     GIR_RootConstrainSelectedInstOperands,
     /*  199878 */     // GIR_Coverage, 477,
     /*  199878 */     GIR_Done,
     /*  199879 */   // Label 3954: @199879
     /*  199879 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(199920), // Rule ID 479 //
     /*  199884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  199887 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  199894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  199897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199901 */     // MIs[0] rs1
     /*  199901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199913 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (AMOMIN_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_W),
     /*  199918 */     GIR_RootConstrainSelectedInstOperands,
     /*  199919 */     // GIR_Coverage, 479,
     /*  199919 */     GIR_Done,
     /*  199920 */   // Label 3955: @199920
     /*  199920 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(199961), // Rule ID 581 //
     /*  199925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  199928 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  199935 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  199938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199942 */     // MIs[0] rs1
     /*  199942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199954 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199954 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  199959 */     GIR_RootConstrainSelectedInstOperands,
     /*  199960 */     // GIR_Coverage, 581,
     /*  199960 */     GIR_Done,
     /*  199961 */   // Label 3956: @199961
     /*  199961 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(200002), // Rule ID 582 //
     /*  199966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  199969 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  199976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  199979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199983 */     // MIs[0] rs1
     /*  199983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  199987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  199995 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  199995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ),
     /*  200000 */     GIR_RootConstrainSelectedInstOperands,
     /*  200001 */     // GIR_Coverage, 582,
     /*  200001 */     GIR_Done,
     /*  200002 */   // Label 3957: @200002
     /*  200002 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(200043), // Rule ID 583 //
     /*  200007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200010 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200017 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200024 */     // MIs[0] rs1
     /*  200024 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200036 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_RL),
     /*  200041 */     GIR_RootConstrainSelectedInstOperands,
     /*  200042 */     // GIR_Coverage, 583,
     /*  200042 */     GIR_Done,
     /*  200043 */   // Label 3958: @200043
     /*  200043 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(200084), // Rule ID 584 //
     /*  200048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200058 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200065 */     // MIs[0] rs1
     /*  200065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200069 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200077 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200082 */     GIR_RootConstrainSelectedInstOperands,
     /*  200083 */     // GIR_Coverage, 584,
     /*  200083 */     GIR_Done,
     /*  200084 */   // Label 3959: @200084
     /*  200084 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(200125), // Rule ID 585 //
     /*  200089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  200092 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200099 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200106 */     // MIs[0] rs1
     /*  200106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200118 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D_AQ_RL),
     /*  200123 */     GIR_RootConstrainSelectedInstOperands,
     /*  200124 */     // GIR_Coverage, 585,
     /*  200124 */     GIR_Done,
     /*  200125 */   // Label 3960: @200125
     /*  200125 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(200166), // Rule ID 586 //
     /*  200130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200133 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200140 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200147 */     // MIs[0] rs1
     /*  200147 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200159 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200164 */     GIR_RootConstrainSelectedInstOperands,
     /*  200165 */     // GIR_Coverage, 586,
     /*  200165 */     GIR_Done,
     /*  200166 */   // Label 3961: @200166
     /*  200166 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(200207), // Rule ID 587 //
     /*  200171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200188 */     // MIs[0] rs1
     /*  200188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200200 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200200 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200205 */     GIR_RootConstrainSelectedInstOperands,
     /*  200206 */     // GIR_Coverage, 587,
     /*  200206 */     GIR_Done,
     /*  200207 */   // Label 3962: @200207
     /*  200207 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(200248), // Rule ID 588 //
     /*  200212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200215 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200222 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200229 */     // MIs[0] rs1
     /*  200229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200241 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200246 */     GIR_RootConstrainSelectedInstOperands,
     /*  200247 */     // GIR_Coverage, 588,
     /*  200247 */     GIR_Done,
     /*  200248 */   // Label 3963: @200248
     /*  200248 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(200289), // Rule ID 589 //
     /*  200253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200256 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200263 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200270 */     // MIs[0] rs1
     /*  200270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200282 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200282 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200287 */     GIR_RootConstrainSelectedInstOperands,
     /*  200288 */     // GIR_Coverage, 589,
     /*  200288 */     GIR_Done,
     /*  200289 */   // Label 3964: @200289
     /*  200289 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(200330), // Rule ID 590 //
     /*  200294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  200297 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  200304 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200311 */     // MIs[0] rs1
     /*  200311 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200323 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (AMOMIN_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_D),
     /*  200328 */     GIR_RootConstrainSelectedInstOperands,
     /*  200329 */     // GIR_Coverage, 590,
     /*  200329 */     GIR_Done,
     /*  200330 */   // Label 3965: @200330
     /*  200330 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(200371), // Rule ID 809 //
     /*  200335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200352 */     // MIs[0] rs1
     /*  200352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200364 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200369 */     GIR_RootConstrainSelectedInstOperands,
     /*  200370 */     // GIR_Coverage, 809,
     /*  200370 */     GIR_Done,
     /*  200371 */   // Label 3966: @200371
     /*  200371 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(200412), // Rule ID 811 //
     /*  200376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200393 */     // MIs[0] rs1
     /*  200393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200405 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ),
     /*  200410 */     GIR_RootConstrainSelectedInstOperands,
     /*  200411 */     // GIR_Coverage, 811,
     /*  200411 */     GIR_Done,
     /*  200412 */   // Label 3967: @200412
     /*  200412 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(200453), // Rule ID 813 //
     /*  200417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200434 */     // MIs[0] rs1
     /*  200434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200446 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_RL),
     /*  200451 */     GIR_RootConstrainSelectedInstOperands,
     /*  200452 */     // GIR_Coverage, 813,
     /*  200452 */     GIR_Done,
     /*  200453 */   // Label 3968: @200453
     /*  200453 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(200494), // Rule ID 815 //
     /*  200458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200475 */     // MIs[0] rs1
     /*  200475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200487 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  200492 */     GIR_RootConstrainSelectedInstOperands,
     /*  200493 */     // GIR_Coverage, 815,
     /*  200493 */     GIR_Done,
     /*  200494 */   // Label 3969: @200494
     /*  200494 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(200535), // Rule ID 817 //
     /*  200499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200516 */     // MIs[0] rs1
     /*  200516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200528 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B_AQ_RL),
     /*  200533 */     GIR_RootConstrainSelectedInstOperands,
     /*  200534 */     // GIR_Coverage, 817,
     /*  200534 */     GIR_Done,
     /*  200535 */   // Label 3970: @200535
     /*  200535 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(200576), // Rule ID 819 //
     /*  200540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200557 */     // MIs[0] rs1
     /*  200557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200569 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200574 */     GIR_RootConstrainSelectedInstOperands,
     /*  200575 */     // GIR_Coverage, 819,
     /*  200575 */     GIR_Done,
     /*  200576 */   // Label 3971: @200576
     /*  200576 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(200617), // Rule ID 821 //
     /*  200581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200598 */     // MIs[0] rs1
     /*  200598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200610 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200615 */     GIR_RootConstrainSelectedInstOperands,
     /*  200616 */     // GIR_Coverage, 821,
     /*  200616 */     GIR_Done,
     /*  200617 */   // Label 3972: @200617
     /*  200617 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(200658), // Rule ID 823 //
     /*  200622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200639 */     // MIs[0] rs1
     /*  200639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200651 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200656 */     GIR_RootConstrainSelectedInstOperands,
     /*  200657 */     // GIR_Coverage, 823,
     /*  200657 */     GIR_Done,
     /*  200658 */   // Label 3973: @200658
     /*  200658 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(200699), // Rule ID 825 //
     /*  200663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200680 */     // MIs[0] rs1
     /*  200680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200692 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200697 */     GIR_RootConstrainSelectedInstOperands,
     /*  200698 */     // GIR_Coverage, 825,
     /*  200698 */     GIR_Done,
     /*  200699 */   // Label 3974: @200699
     /*  200699 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(200740), // Rule ID 827 //
     /*  200704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  200714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200721 */     // MIs[0] rs1
     /*  200721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200733 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (AMOMIN_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_B),
     /*  200738 */     GIR_RootConstrainSelectedInstOperands,
     /*  200739 */     // GIR_Coverage, 827,
     /*  200739 */     GIR_Done,
     /*  200740 */   // Label 3975: @200740
     /*  200740 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(200781), // Rule ID 989 //
     /*  200745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200762 */     // MIs[0] rs1
     /*  200762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200774 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200779 */     GIR_RootConstrainSelectedInstOperands,
     /*  200780 */     // GIR_Coverage, 989,
     /*  200780 */     GIR_Done,
     /*  200781 */   // Label 3976: @200781
     /*  200781 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(200822), // Rule ID 991 //
     /*  200786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  200799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200803 */     // MIs[0] rs1
     /*  200803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200815 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ),
     /*  200820 */     GIR_RootConstrainSelectedInstOperands,
     /*  200821 */     // GIR_Coverage, 991,
     /*  200821 */     GIR_Done,
     /*  200822 */   // Label 3977: @200822
     /*  200822 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(200863), // Rule ID 993 //
     /*  200827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  200840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200844 */     // MIs[0] rs1
     /*  200844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200856 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_RL),
     /*  200861 */     GIR_RootConstrainSelectedInstOperands,
     /*  200862 */     // GIR_Coverage, 993,
     /*  200862 */     GIR_Done,
     /*  200863 */   // Label 3978: @200863
     /*  200863 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(200904), // Rule ID 995 //
     /*  200868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  200881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200885 */     // MIs[0] rs1
     /*  200885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200897 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200902 */     GIR_RootConstrainSelectedInstOperands,
     /*  200903 */     // GIR_Coverage, 995,
     /*  200903 */     GIR_Done,
     /*  200904 */   // Label 3979: @200904
     /*  200904 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(200945), // Rule ID 997 //
     /*  200909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  200912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  200922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200926 */     // MIs[0] rs1
     /*  200926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200938 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H_AQ_RL),
     /*  200943 */     GIR_RootConstrainSelectedInstOperands,
     /*  200944 */     // GIR_Coverage, 997,
     /*  200944 */     GIR_Done,
     /*  200945 */   // Label 3980: @200945
     /*  200945 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(200986), // Rule ID 999 //
     /*  200950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  200960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  200963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200967 */     // MIs[0] rs1
     /*  200967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  200971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  200979 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  200979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  200984 */     GIR_RootConstrainSelectedInstOperands,
     /*  200985 */     // GIR_Coverage, 999,
     /*  200985 */     GIR_Done,
     /*  200986 */   // Label 3981: @200986
     /*  200986 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(201027), // Rule ID 1001 //
     /*  200991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  200994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201008 */     // MIs[0] rs1
     /*  201008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201020 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201025 */     GIR_RootConstrainSelectedInstOperands,
     /*  201026 */     // GIR_Coverage, 1001,
     /*  201026 */     GIR_Done,
     /*  201027 */   // Label 3982: @201027
     /*  201027 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(201068), // Rule ID 1003 //
     /*  201032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201049 */     // MIs[0] rs1
     /*  201049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201061 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201066 */     GIR_RootConstrainSelectedInstOperands,
     /*  201067 */     // GIR_Coverage, 1003,
     /*  201067 */     GIR_Done,
     /*  201068 */   // Label 3983: @201068
     /*  201068 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(201109), // Rule ID 1005 //
     /*  201073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201090 */     // MIs[0] rs1
     /*  201090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201102 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201107 */     GIR_RootConstrainSelectedInstOperands,
     /*  201108 */     // GIR_Coverage, 1005,
     /*  201108 */     GIR_Done,
     /*  201109 */   // Label 3984: @201109
     /*  201109 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(201150), // Rule ID 1007 //
     /*  201114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  201117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  201124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201131 */     // MIs[0] rs1
     /*  201131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  201135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201143 */     // (atomic_load_min:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (AMOMIN_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  201143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMIN_H),
     /*  201148 */     GIR_RootConstrainSelectedInstOperands,
     /*  201149 */     // GIR_Coverage, 1007,
     /*  201149 */     GIR_Done,
     /*  201150 */   // Label 3985: @201150
     /*  201150 */   GIM_Reject,
     /*  201151 */ // Label 3945: @201151
     /*  201151 */ GIM_Reject,
     /*  201152 */ // Label 3913: @201152
     /*  201152 */ GIM_Reject,
     /*  201153 */ // Label 34: @201153
     /*  201153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 3988*/ GIMT_Encode4(204062),
     /*  201164 */ /*GILLT_s32*//*Label 3986*/ GIMT_Encode4(201172),
     /*  201168 */ /*GILLT_s64*//*Label 3987*/ GIMT_Encode4(202412),
     /*  201172 */ // Label 3986: @201172
     /*  201172 */ GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(202411),
     /*  201177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  201180 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(201221), // Rule ID 482 //
     /*  201185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201188 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201195 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201202 */     // MIs[0] rs1
     /*  201202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201214 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201219 */     GIR_RootConstrainSelectedInstOperands,
     /*  201220 */     // GIR_Coverage, 482,
     /*  201220 */     GIR_Done,
     /*  201221 */   // Label 3990: @201221
     /*  201221 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(201262), // Rule ID 484 //
     /*  201226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201229 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201243 */     // MIs[0] rs1
     /*  201243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201255 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  201260 */     GIR_RootConstrainSelectedInstOperands,
     /*  201261 */     // GIR_Coverage, 484,
     /*  201261 */     GIR_Done,
     /*  201262 */   // Label 3991: @201262
     /*  201262 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(201303), // Rule ID 486 //
     /*  201267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201284 */     // MIs[0] rs1
     /*  201284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201296 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  201301 */     GIR_RootConstrainSelectedInstOperands,
     /*  201302 */     // GIR_Coverage, 486,
     /*  201302 */     GIR_Done,
     /*  201303 */   // Label 3992: @201303
     /*  201303 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(201344), // Rule ID 488 //
     /*  201308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201325 */     // MIs[0] rs1
     /*  201325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201337 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201342 */     GIR_RootConstrainSelectedInstOperands,
     /*  201343 */     // GIR_Coverage, 488,
     /*  201343 */     GIR_Done,
     /*  201344 */   // Label 3993: @201344
     /*  201344 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(201385), // Rule ID 490 //
     /*  201349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  201352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201366 */     // MIs[0] rs1
     /*  201366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201378 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  201383 */     GIR_RootConstrainSelectedInstOperands,
     /*  201384 */     // GIR_Coverage, 490,
     /*  201384 */     GIR_Done,
     /*  201385 */   // Label 3994: @201385
     /*  201385 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(201426), // Rule ID 492 //
     /*  201390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201407 */     // MIs[0] rs1
     /*  201407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201419 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201424 */     GIR_RootConstrainSelectedInstOperands,
     /*  201425 */     // GIR_Coverage, 492,
     /*  201425 */     GIR_Done,
     /*  201426 */   // Label 3995: @201426
     /*  201426 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(201467), // Rule ID 494 //
     /*  201431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201448 */     // MIs[0] rs1
     /*  201448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201460 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201465 */     GIR_RootConstrainSelectedInstOperands,
     /*  201466 */     // GIR_Coverage, 494,
     /*  201466 */     GIR_Done,
     /*  201467 */   // Label 3996: @201467
     /*  201467 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(201508), // Rule ID 496 //
     /*  201472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201489 */     // MIs[0] rs1
     /*  201489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201501 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201506 */     GIR_RootConstrainSelectedInstOperands,
     /*  201507 */     // GIR_Coverage, 496,
     /*  201507 */     GIR_Done,
     /*  201508 */   // Label 3997: @201508
     /*  201508 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(201549), // Rule ID 498 //
     /*  201513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201516 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201523 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201530 */     // MIs[0] rs1
     /*  201530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201542 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201547 */     GIR_RootConstrainSelectedInstOperands,
     /*  201548 */     // GIR_Coverage, 498,
     /*  201548 */     GIR_Done,
     /*  201549 */   // Label 3998: @201549
     /*  201549 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(201590), // Rule ID 500 //
     /*  201554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  201557 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  201564 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201571 */     // MIs[0] rs1
     /*  201571 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201583 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  201588 */     GIR_RootConstrainSelectedInstOperands,
     /*  201589 */     // GIR_Coverage, 500,
     /*  201589 */     GIR_Done,
     /*  201590 */   // Label 3999: @201590
     /*  201590 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(201631), // Rule ID 830 //
     /*  201595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  201598 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201605 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201612 */     // MIs[0] rs1
     /*  201612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201616 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201624 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201629 */     GIR_RootConstrainSelectedInstOperands,
     /*  201630 */     // GIR_Coverage, 830,
     /*  201630 */     GIR_Done,
     /*  201631 */   // Label 4000: @201631
     /*  201631 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(201672), // Rule ID 832 //
     /*  201636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  201639 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201646 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201653 */     // MIs[0] rs1
     /*  201653 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201665 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  201670 */     GIR_RootConstrainSelectedInstOperands,
     /*  201671 */     // GIR_Coverage, 832,
     /*  201671 */     GIR_Done,
     /*  201672 */   // Label 4001: @201672
     /*  201672 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(201713), // Rule ID 834 //
     /*  201677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  201680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201694 */     // MIs[0] rs1
     /*  201694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201706 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201706 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  201711 */     GIR_RootConstrainSelectedInstOperands,
     /*  201712 */     // GIR_Coverage, 834,
     /*  201712 */     GIR_Done,
     /*  201713 */   // Label 4002: @201713
     /*  201713 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201754), // Rule ID 836 //
     /*  201718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  201721 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201735 */     // MIs[0] rs1
     /*  201735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201747 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  201752 */     GIR_RootConstrainSelectedInstOperands,
     /*  201753 */     // GIR_Coverage, 836,
     /*  201753 */     GIR_Done,
     /*  201754 */   // Label 4003: @201754
     /*  201754 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201795), // Rule ID 838 //
     /*  201759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  201762 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201769 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201776 */     // MIs[0] rs1
     /*  201776 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201788 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  201793 */     GIR_RootConstrainSelectedInstOperands,
     /*  201794 */     // GIR_Coverage, 838,
     /*  201794 */     GIR_Done,
     /*  201795 */   // Label 4004: @201795
     /*  201795 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201836), // Rule ID 840 //
     /*  201800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  201803 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  201813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201817 */     // MIs[0] rs1
     /*  201817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201829 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201834 */     GIR_RootConstrainSelectedInstOperands,
     /*  201835 */     // GIR_Coverage, 840,
     /*  201835 */     GIR_Done,
     /*  201836 */   // Label 4005: @201836
     /*  201836 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201877), // Rule ID 842 //
     /*  201841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  201844 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201851 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  201854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201858 */     // MIs[0] rs1
     /*  201858 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201870 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201870 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201875 */     GIR_RootConstrainSelectedInstOperands,
     /*  201876 */     // GIR_Coverage, 842,
     /*  201876 */     GIR_Done,
     /*  201877 */   // Label 4006: @201877
     /*  201877 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201918), // Rule ID 844 //
     /*  201882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  201885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  201895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201899 */     // MIs[0] rs1
     /*  201899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201911 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201911 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201916 */     GIR_RootConstrainSelectedInstOperands,
     /*  201917 */     // GIR_Coverage, 844,
     /*  201917 */     GIR_Done,
     /*  201918 */   // Label 4007: @201918
     /*  201918 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201959), // Rule ID 846 //
     /*  201923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  201926 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201933 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  201936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201940 */     // MIs[0] rs1
     /*  201940 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201952 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201952 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201957 */     GIR_RootConstrainSelectedInstOperands,
     /*  201958 */     // GIR_Coverage, 846,
     /*  201958 */     GIR_Done,
     /*  201959 */   // Label 4008: @201959
     /*  201959 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(202000), // Rule ID 848 //
     /*  201964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  201967 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  201974 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  201977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201981 */     // MIs[0] rs1
     /*  201981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  201985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  201993 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  201993 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  201998 */     GIR_RootConstrainSelectedInstOperands,
     /*  201999 */     // GIR_Coverage, 848,
     /*  201999 */     GIR_Done,
     /*  202000 */   // Label 4009: @202000
     /*  202000 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(202041), // Rule ID 1010 //
     /*  202005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202008 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202015 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202022 */     // MIs[0] rs1
     /*  202022 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202034 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202039 */     GIR_RootConstrainSelectedInstOperands,
     /*  202040 */     // GIR_Coverage, 1010,
     /*  202040 */     GIR_Done,
     /*  202041 */   // Label 4010: @202041
     /*  202041 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(202082), // Rule ID 1012 //
     /*  202046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202049 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202056 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202063 */     // MIs[0] rs1
     /*  202063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202075 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  202080 */     GIR_RootConstrainSelectedInstOperands,
     /*  202081 */     // GIR_Coverage, 1012,
     /*  202081 */     GIR_Done,
     /*  202082 */   // Label 4011: @202082
     /*  202082 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(202123), // Rule ID 1014 //
     /*  202087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202104 */     // MIs[0] rs1
     /*  202104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202116 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  202121 */     GIR_RootConstrainSelectedInstOperands,
     /*  202122 */     // GIR_Coverage, 1014,
     /*  202122 */     GIR_Done,
     /*  202123 */   // Label 4012: @202123
     /*  202123 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(202164), // Rule ID 1016 //
     /*  202128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202131 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202138 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202145 */     // MIs[0] rs1
     /*  202145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202157 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202162 */     GIR_RootConstrainSelectedInstOperands,
     /*  202163 */     // GIR_Coverage, 1016,
     /*  202163 */     GIR_Done,
     /*  202164 */   // Label 4013: @202164
     /*  202164 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(202205), // Rule ID 1018 //
     /*  202169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  202172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202186 */     // MIs[0] rs1
     /*  202186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202198 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202198 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  202203 */     GIR_RootConstrainSelectedInstOperands,
     /*  202204 */     // GIR_Coverage, 1018,
     /*  202204 */     GIR_Done,
     /*  202205 */   // Label 4014: @202205
     /*  202205 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(202246), // Rule ID 1020 //
     /*  202210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202227 */     // MIs[0] rs1
     /*  202227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202239 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202239 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202244 */     GIR_RootConstrainSelectedInstOperands,
     /*  202245 */     // GIR_Coverage, 1020,
     /*  202245 */     GIR_Done,
     /*  202246 */   // Label 4015: @202246
     /*  202246 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(202287), // Rule ID 1022 //
     /*  202251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202268 */     // MIs[0] rs1
     /*  202268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202280 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202285 */     GIR_RootConstrainSelectedInstOperands,
     /*  202286 */     // GIR_Coverage, 1022,
     /*  202286 */     GIR_Done,
     /*  202287 */   // Label 4016: @202287
     /*  202287 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(202328), // Rule ID 1024 //
     /*  202292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202309 */     // MIs[0] rs1
     /*  202309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202321 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202321 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202326 */     GIR_RootConstrainSelectedInstOperands,
     /*  202327 */     // GIR_Coverage, 1024,
     /*  202327 */     GIR_Done,
     /*  202328 */   // Label 4017: @202328
     /*  202328 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(202369), // Rule ID 1026 //
     /*  202333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202350 */     // MIs[0] rs1
     /*  202350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202362 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202362 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202367 */     GIR_RootConstrainSelectedInstOperands,
     /*  202368 */     // GIR_Coverage, 1026,
     /*  202368 */     GIR_Done,
     /*  202369 */   // Label 4018: @202369
     /*  202369 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(202410), // Rule ID 1028 //
     /*  202374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  202377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  202384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202391 */     // MIs[0] rs1
     /*  202391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  202395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202403 */     // (atomic_load_umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  202403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  202408 */     GIR_RootConstrainSelectedInstOperands,
     /*  202409 */     // GIR_Coverage, 1028,
     /*  202409 */     GIR_Done,
     /*  202410 */   // Label 4019: @202410
     /*  202410 */   GIM_Reject,
     /*  202411 */ // Label 3989: @202411
     /*  202411 */ GIM_Reject,
     /*  202412 */ // Label 3987: @202412
     /*  202412 */ GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(204061),
     /*  202417 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  202420 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202461), // Rule ID 481 //
     /*  202425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202428 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202435 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202442 */     // MIs[0] rs1
     /*  202442 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202454 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202454 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202459 */     GIR_RootConstrainSelectedInstOperands,
     /*  202460 */     // GIR_Coverage, 481,
     /*  202460 */     GIR_Done,
     /*  202461 */   // Label 4021: @202461
     /*  202461 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202502), // Rule ID 483 //
     /*  202466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202469 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202476 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202483 */     // MIs[0] rs1
     /*  202483 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202495 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ),
     /*  202500 */     GIR_RootConstrainSelectedInstOperands,
     /*  202501 */     // GIR_Coverage, 483,
     /*  202501 */     GIR_Done,
     /*  202502 */   // Label 4022: @202502
     /*  202502 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202543), // Rule ID 485 //
     /*  202507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202510 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202517 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202524 */     // MIs[0] rs1
     /*  202524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202536 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202536 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_RL),
     /*  202541 */     GIR_RootConstrainSelectedInstOperands,
     /*  202542 */     // GIR_Coverage, 485,
     /*  202542 */     GIR_Done,
     /*  202543 */   // Label 4023: @202543
     /*  202543 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202584), // Rule ID 487 //
     /*  202548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202551 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202558 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202565 */     // MIs[0] rs1
     /*  202565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202577 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202577 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202582 */     GIR_RootConstrainSelectedInstOperands,
     /*  202583 */     // GIR_Coverage, 487,
     /*  202583 */     GIR_Done,
     /*  202584 */   // Label 4024: @202584
     /*  202584 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202625), // Rule ID 489 //
     /*  202589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  202592 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202599 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202606 */     // MIs[0] rs1
     /*  202606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202618 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W_AQ_RL),
     /*  202623 */     GIR_RootConstrainSelectedInstOperands,
     /*  202624 */     // GIR_Coverage, 489,
     /*  202624 */     GIR_Done,
     /*  202625 */   // Label 4025: @202625
     /*  202625 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202666), // Rule ID 491 //
     /*  202630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  202633 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202640 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202647 */     // MIs[0] rs1
     /*  202647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202659 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202659 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202664 */     GIR_RootConstrainSelectedInstOperands,
     /*  202665 */     // GIR_Coverage, 491,
     /*  202665 */     GIR_Done,
     /*  202666 */   // Label 4026: @202666
     /*  202666 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202707), // Rule ID 493 //
     /*  202671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  202674 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202688 */     // MIs[0] rs1
     /*  202688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202700 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202705 */     GIR_RootConstrainSelectedInstOperands,
     /*  202706 */     // GIR_Coverage, 493,
     /*  202706 */     GIR_Done,
     /*  202707 */   // Label 4027: @202707
     /*  202707 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202748), // Rule ID 495 //
     /*  202712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  202715 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202722 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202729 */     // MIs[0] rs1
     /*  202729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202741 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202746 */     GIR_RootConstrainSelectedInstOperands,
     /*  202747 */     // GIR_Coverage, 495,
     /*  202747 */     GIR_Done,
     /*  202748 */   // Label 4028: @202748
     /*  202748 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202789), // Rule ID 497 //
     /*  202753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  202756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202770 */     // MIs[0] rs1
     /*  202770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202782 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202782 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202787 */     GIR_RootConstrainSelectedInstOperands,
     /*  202788 */     // GIR_Coverage, 497,
     /*  202788 */     GIR_Done,
     /*  202789 */   // Label 4029: @202789
     /*  202789 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202830), // Rule ID 499 //
     /*  202794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  202797 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  202804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  202807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202811 */     // MIs[0] rs1
     /*  202811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202823 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (AMOMAXU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_W),
     /*  202828 */     GIR_RootConstrainSelectedInstOperands,
     /*  202829 */     // GIR_Coverage, 499,
     /*  202829 */     GIR_Done,
     /*  202830 */   // Label 4030: @202830
     /*  202830 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202871), // Rule ID 591 //
     /*  202835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  202838 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  202845 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  202848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202852 */     // MIs[0] rs1
     /*  202852 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202864 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202864 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  202869 */     GIR_RootConstrainSelectedInstOperands,
     /*  202870 */     // GIR_Coverage, 591,
     /*  202870 */     GIR_Done,
     /*  202871 */   // Label 4031: @202871
     /*  202871 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202912), // Rule ID 592 //
     /*  202876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  202879 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  202886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  202889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202893 */     // MIs[0] rs1
     /*  202893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202905 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ),
     /*  202910 */     GIR_RootConstrainSelectedInstOperands,
     /*  202911 */     // GIR_Coverage, 592,
     /*  202911 */     GIR_Done,
     /*  202912 */   // Label 4032: @202912
     /*  202912 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202953), // Rule ID 593 //
     /*  202917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  202920 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  202927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  202930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202934 */     // MIs[0] rs1
     /*  202934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202946 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202946 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_RL),
     /*  202951 */     GIR_RootConstrainSelectedInstOperands,
     /*  202952 */     // GIR_Coverage, 593,
     /*  202952 */     GIR_Done,
     /*  202953 */   // Label 4033: @202953
     /*  202953 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202994), // Rule ID 594 //
     /*  202958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  202961 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  202968 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  202971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202975 */     // MIs[0] rs1
     /*  202975 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  202979 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  202987 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  202987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  202992 */     GIR_RootConstrainSelectedInstOperands,
     /*  202993 */     // GIR_Coverage, 594,
     /*  202993 */     GIR_Done,
     /*  202994 */   // Label 4034: @202994
     /*  202994 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(203035), // Rule ID 595 //
     /*  202999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  203002 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203009 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203016 */     // MIs[0] rs1
     /*  203016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203028 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D_AQ_RL),
     /*  203033 */     GIR_RootConstrainSelectedInstOperands,
     /*  203034 */     // GIR_Coverage, 595,
     /*  203034 */     GIR_Done,
     /*  203035 */   // Label 4035: @203035
     /*  203035 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(203076), // Rule ID 596 //
     /*  203040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203043 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203050 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203057 */     // MIs[0] rs1
     /*  203057 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203069 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203069 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203074 */     GIR_RootConstrainSelectedInstOperands,
     /*  203075 */     // GIR_Coverage, 596,
     /*  203075 */     GIR_Done,
     /*  203076 */   // Label 4036: @203076
     /*  203076 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(203117), // Rule ID 597 //
     /*  203081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203084 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203091 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203098 */     // MIs[0] rs1
     /*  203098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203110 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203110 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203115 */     GIR_RootConstrainSelectedInstOperands,
     /*  203116 */     // GIR_Coverage, 597,
     /*  203116 */     GIR_Done,
     /*  203117 */   // Label 4037: @203117
     /*  203117 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203158), // Rule ID 598 //
     /*  203122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203125 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203132 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203139 */     // MIs[0] rs1
     /*  203139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203151 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203151 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203156 */     GIR_RootConstrainSelectedInstOperands,
     /*  203157 */     // GIR_Coverage, 598,
     /*  203157 */     GIR_Done,
     /*  203158 */   // Label 4038: @203158
     /*  203158 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203199), // Rule ID 599 //
     /*  203163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203166 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203173 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203180 */     // MIs[0] rs1
     /*  203180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203192 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203197 */     GIR_RootConstrainSelectedInstOperands,
     /*  203198 */     // GIR_Coverage, 599,
     /*  203198 */     GIR_Done,
     /*  203199 */   // Label 4039: @203199
     /*  203199 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203240), // Rule ID 600 //
     /*  203204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  203207 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  203214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203221 */     // MIs[0] rs1
     /*  203221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203233 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (AMOMAXU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_D),
     /*  203238 */     GIR_RootConstrainSelectedInstOperands,
     /*  203239 */     // GIR_Coverage, 600,
     /*  203239 */     GIR_Done,
     /*  203240 */   // Label 4040: @203240
     /*  203240 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(203281), // Rule ID 829 //
     /*  203245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203262 */     // MIs[0] rs1
     /*  203262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203274 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203279 */     GIR_RootConstrainSelectedInstOperands,
     /*  203280 */     // GIR_Coverage, 829,
     /*  203280 */     GIR_Done,
     /*  203281 */   // Label 4041: @203281
     /*  203281 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(203322), // Rule ID 831 //
     /*  203286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203289 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203296 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203303 */     // MIs[0] rs1
     /*  203303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203315 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ),
     /*  203320 */     GIR_RootConstrainSelectedInstOperands,
     /*  203321 */     // GIR_Coverage, 831,
     /*  203321 */     GIR_Done,
     /*  203322 */   // Label 4042: @203322
     /*  203322 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203363), // Rule ID 833 //
     /*  203327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203330 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203337 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203344 */     // MIs[0] rs1
     /*  203344 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203356 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203356 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_RL),
     /*  203361 */     GIR_RootConstrainSelectedInstOperands,
     /*  203362 */     // GIR_Coverage, 833,
     /*  203362 */     GIR_Done,
     /*  203363 */   // Label 4043: @203363
     /*  203363 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203404), // Rule ID 835 //
     /*  203368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203371 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203378 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203385 */     // MIs[0] rs1
     /*  203385 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203397 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203402 */     GIR_RootConstrainSelectedInstOperands,
     /*  203403 */     // GIR_Coverage, 835,
     /*  203403 */     GIR_Done,
     /*  203404 */   // Label 4044: @203404
     /*  203404 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203445), // Rule ID 837 //
     /*  203409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203412 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203419 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203426 */     // MIs[0] rs1
     /*  203426 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203438 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B_AQ_RL),
     /*  203443 */     GIR_RootConstrainSelectedInstOperands,
     /*  203444 */     // GIR_Coverage, 837,
     /*  203444 */     GIR_Done,
     /*  203445 */   // Label 4045: @203445
     /*  203445 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203486), // Rule ID 839 //
     /*  203450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203453 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203460 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203467 */     // MIs[0] rs1
     /*  203467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203479 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203484 */     GIR_RootConstrainSelectedInstOperands,
     /*  203485 */     // GIR_Coverage, 839,
     /*  203485 */     GIR_Done,
     /*  203486 */   // Label 4046: @203486
     /*  203486 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203527), // Rule ID 841 //
     /*  203491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203494 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203501 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203508 */     // MIs[0] rs1
     /*  203508 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203520 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203525 */     GIR_RootConstrainSelectedInstOperands,
     /*  203526 */     // GIR_Coverage, 841,
     /*  203526 */     GIR_Done,
     /*  203527 */   // Label 4047: @203527
     /*  203527 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203568), // Rule ID 843 //
     /*  203532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203535 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203542 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203549 */     // MIs[0] rs1
     /*  203549 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203561 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203566 */     GIR_RootConstrainSelectedInstOperands,
     /*  203567 */     // GIR_Coverage, 843,
     /*  203567 */     GIR_Done,
     /*  203568 */   // Label 4048: @203568
     /*  203568 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(203609), // Rule ID 845 //
     /*  203573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203576 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203583 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203590 */     // MIs[0] rs1
     /*  203590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203602 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203602 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203607 */     GIR_RootConstrainSelectedInstOperands,
     /*  203608 */     // GIR_Coverage, 845,
     /*  203608 */     GIR_Done,
     /*  203609 */   // Label 4049: @203609
     /*  203609 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(203650), // Rule ID 847 //
     /*  203614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203617 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  203624 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203631 */     // MIs[0] rs1
     /*  203631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203643 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (AMOMAXU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_B),
     /*  203648 */     GIR_RootConstrainSelectedInstOperands,
     /*  203649 */     // GIR_Coverage, 847,
     /*  203649 */     GIR_Done,
     /*  203650 */   // Label 4050: @203650
     /*  203650 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(203691), // Rule ID 1009 //
     /*  203655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203658 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203665 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203672 */     // MIs[0] rs1
     /*  203672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203684 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203684 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203689 */     GIR_RootConstrainSelectedInstOperands,
     /*  203690 */     // GIR_Coverage, 1009,
     /*  203690 */     GIR_Done,
     /*  203691 */   // Label 4051: @203691
     /*  203691 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(203732), // Rule ID 1011 //
     /*  203696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203699 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203706 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203713 */     // MIs[0] rs1
     /*  203713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203725 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ),
     /*  203730 */     GIR_RootConstrainSelectedInstOperands,
     /*  203731 */     // GIR_Coverage, 1011,
     /*  203731 */     GIR_Done,
     /*  203732 */   // Label 4052: @203732
     /*  203732 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(203773), // Rule ID 1013 //
     /*  203737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203740 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203747 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203754 */     // MIs[0] rs1
     /*  203754 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203766 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_RL),
     /*  203771 */     GIR_RootConstrainSelectedInstOperands,
     /*  203772 */     // GIR_Coverage, 1013,
     /*  203772 */     GIR_Done,
     /*  203773 */   // Label 4053: @203773
     /*  203773 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(203814), // Rule ID 1015 //
     /*  203778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203781 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203788 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203795 */     // MIs[0] rs1
     /*  203795 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203807 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203807 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203812 */     GIR_RootConstrainSelectedInstOperands,
     /*  203813 */     // GIR_Coverage, 1015,
     /*  203813 */     GIR_Done,
     /*  203814 */   // Label 4054: @203814
     /*  203814 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(203855), // Rule ID 1017 //
     /*  203819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  203822 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203829 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  203832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203836 */     // MIs[0] rs1
     /*  203836 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203848 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203848 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H_AQ_RL),
     /*  203853 */     GIR_RootConstrainSelectedInstOperands,
     /*  203854 */     // GIR_Coverage, 1017,
     /*  203854 */     GIR_Done,
     /*  203855 */   // Label 4055: @203855
     /*  203855 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(203896), // Rule ID 1019 //
     /*  203860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203863 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  203873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203877 */     // MIs[0] rs1
     /*  203877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203889 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203889 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203894 */     GIR_RootConstrainSelectedInstOperands,
     /*  203895 */     // GIR_Coverage, 1019,
     /*  203895 */     GIR_Done,
     /*  203896 */   // Label 4056: @203896
     /*  203896 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(203937), // Rule ID 1021 //
     /*  203901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  203914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203918 */     // MIs[0] rs1
     /*  203918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203930 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203930 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203935 */     GIR_RootConstrainSelectedInstOperands,
     /*  203936 */     // GIR_Coverage, 1021,
     /*  203936 */     GIR_Done,
     /*  203937 */   // Label 4057: @203937
     /*  203937 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(203978), // Rule ID 1023 //
     /*  203942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203945 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  203955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203959 */     // MIs[0] rs1
     /*  203959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  203963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  203971 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  203971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  203976 */     GIR_RootConstrainSelectedInstOperands,
     /*  203977 */     // GIR_Coverage, 1023,
     /*  203977 */     GIR_Done,
     /*  203978 */   // Label 4058: @203978
     /*  203978 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204019), // Rule ID 1025 //
     /*  203983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  203986 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  203993 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  203996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204000 */     // MIs[0] rs1
     /*  204000 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204012 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204012 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204017 */     GIR_RootConstrainSelectedInstOperands,
     /*  204018 */     // GIR_Coverage, 1025,
     /*  204018 */     GIR_Done,
     /*  204019 */   // Label 4059: @204019
     /*  204019 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(204060), // Rule ID 1027 //
     /*  204024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  204027 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204034 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204041 */     // MIs[0] rs1
     /*  204041 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  204045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204053 */     // (atomic_load_umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (AMOMAXU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  204053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMAXU_H),
     /*  204058 */     GIR_RootConstrainSelectedInstOperands,
     /*  204059 */     // GIR_Coverage, 1027,
     /*  204059 */     GIR_Done,
     /*  204060 */   // Label 4060: @204060
     /*  204060 */   GIM_Reject,
     /*  204061 */ // Label 4020: @204061
     /*  204061 */ GIM_Reject,
     /*  204062 */ // Label 3988: @204062
     /*  204062 */ GIM_Reject,
     /*  204063 */ // Label 35: @204063
     /*  204063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4063*/ GIMT_Encode4(206972),
     /*  204074 */ /*GILLT_s32*//*Label 4061*/ GIMT_Encode4(204082),
     /*  204078 */ /*GILLT_s64*//*Label 4062*/ GIMT_Encode4(205322),
     /*  204082 */ // Label 4061: @204082
     /*  204082 */ GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205321),
     /*  204087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  204090 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(204131), // Rule ID 502 //
     /*  204095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204112 */     // MIs[0] rs1
     /*  204112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204124 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204129 */     GIR_RootConstrainSelectedInstOperands,
     /*  204130 */     // GIR_Coverage, 502,
     /*  204130 */     GIR_Done,
     /*  204131 */   // Label 4065: @204131
     /*  204131 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(204172), // Rule ID 504 //
     /*  204136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204139 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204146 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204153 */     // MIs[0] rs1
     /*  204153 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204165 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204165 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  204170 */     GIR_RootConstrainSelectedInstOperands,
     /*  204171 */     // GIR_Coverage, 504,
     /*  204171 */     GIR_Done,
     /*  204172 */   // Label 4066: @204172
     /*  204172 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(204213), // Rule ID 506 //
     /*  204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204187 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204194 */     // MIs[0] rs1
     /*  204194 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204206 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  204211 */     GIR_RootConstrainSelectedInstOperands,
     /*  204212 */     // GIR_Coverage, 506,
     /*  204212 */     GIR_Done,
     /*  204213 */   // Label 4067: @204213
     /*  204213 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(204254), // Rule ID 508 //
     /*  204218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204235 */     // MIs[0] rs1
     /*  204235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204247 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204252 */     GIR_RootConstrainSelectedInstOperands,
     /*  204253 */     // GIR_Coverage, 508,
     /*  204253 */     GIR_Done,
     /*  204254 */   // Label 4068: @204254
     /*  204254 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(204295), // Rule ID 510 //
     /*  204259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode1),
     /*  204262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204276 */     // MIs[0] rs1
     /*  204276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204288 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  204293 */     GIR_RootConstrainSelectedInstOperands,
     /*  204294 */     // GIR_Coverage, 510,
     /*  204294 */     GIR_Done,
     /*  204295 */   // Label 4069: @204295
     /*  204295 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(204336), // Rule ID 512 //
     /*  204300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204317 */     // MIs[0] rs1
     /*  204317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204329 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204334 */     GIR_RootConstrainSelectedInstOperands,
     /*  204335 */     // GIR_Coverage, 512,
     /*  204335 */     GIR_Done,
     /*  204336 */   // Label 4070: @204336
     /*  204336 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(204377), // Rule ID 514 //
     /*  204341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204358 */     // MIs[0] rs1
     /*  204358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204370 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204375 */     GIR_RootConstrainSelectedInstOperands,
     /*  204376 */     // GIR_Coverage, 514,
     /*  204376 */     GIR_Done,
     /*  204377 */   // Label 4071: @204377
     /*  204377 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(204418), // Rule ID 516 //
     /*  204382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204399 */     // MIs[0] rs1
     /*  204399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204411 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204416 */     GIR_RootConstrainSelectedInstOperands,
     /*  204417 */     // GIR_Coverage, 516,
     /*  204417 */     GIR_Done,
     /*  204418 */   // Label 4072: @204418
     /*  204418 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(204459), // Rule ID 518 //
     /*  204423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204440 */     // MIs[0] rs1
     /*  204440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204452 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204452 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204457 */     GIR_RootConstrainSelectedInstOperands,
     /*  204458 */     // GIR_Coverage, 518,
     /*  204458 */     GIR_Done,
     /*  204459 */   // Label 4073: @204459
     /*  204459 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(204500), // Rule ID 520 //
     /*  204464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode1),
     /*  204467 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  204474 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204481 */     // MIs[0] rs1
     /*  204481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204485 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204493 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  204498 */     GIR_RootConstrainSelectedInstOperands,
     /*  204499 */     // GIR_Coverage, 520,
     /*  204499 */     GIR_Done,
     /*  204500 */   // Label 4074: @204500
     /*  204500 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(204541), // Rule ID 850 //
     /*  204505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204508 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204515 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204522 */     // MIs[0] rs1
     /*  204522 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204534 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204539 */     GIR_RootConstrainSelectedInstOperands,
     /*  204540 */     // GIR_Coverage, 850,
     /*  204540 */     GIR_Done,
     /*  204541 */   // Label 4075: @204541
     /*  204541 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(204582), // Rule ID 852 //
     /*  204546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204549 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204556 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204563 */     // MIs[0] rs1
     /*  204563 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204575 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204575 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  204580 */     GIR_RootConstrainSelectedInstOperands,
     /*  204581 */     // GIR_Coverage, 852,
     /*  204581 */     GIR_Done,
     /*  204582 */   // Label 4076: @204582
     /*  204582 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(204623), // Rule ID 854 //
     /*  204587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204590 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204597 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204604 */     // MIs[0] rs1
     /*  204604 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204616 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204616 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  204621 */     GIR_RootConstrainSelectedInstOperands,
     /*  204622 */     // GIR_Coverage, 854,
     /*  204622 */     GIR_Done,
     /*  204623 */   // Label 4077: @204623
     /*  204623 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(204664), // Rule ID 856 //
     /*  204628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204631 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204638 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204645 */     // MIs[0] rs1
     /*  204645 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204657 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204657 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  204662 */     GIR_RootConstrainSelectedInstOperands,
     /*  204663 */     // GIR_Coverage, 856,
     /*  204663 */     GIR_Done,
     /*  204664 */   // Label 4078: @204664
     /*  204664 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(204705), // Rule ID 858 //
     /*  204669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204672 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204679 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204686 */     // MIs[0] rs1
     /*  204686 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204698 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  204703 */     GIR_RootConstrainSelectedInstOperands,
     /*  204704 */     // GIR_Coverage, 858,
     /*  204704 */     GIR_Done,
     /*  204705 */   // Label 4079: @204705
     /*  204705 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(204746), // Rule ID 860 //
     /*  204710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  204713 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204727 */     // MIs[0] rs1
     /*  204727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204739 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204744 */     GIR_RootConstrainSelectedInstOperands,
     /*  204745 */     // GIR_Coverage, 860,
     /*  204745 */     GIR_Done,
     /*  204746 */   // Label 4080: @204746
     /*  204746 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(204787), // Rule ID 862 //
     /*  204751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  204754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204768 */     // MIs[0] rs1
     /*  204768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204780 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204785 */     GIR_RootConstrainSelectedInstOperands,
     /*  204786 */     // GIR_Coverage, 862,
     /*  204786 */     GIR_Done,
     /*  204787 */   // Label 4081: @204787
     /*  204787 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(204828), // Rule ID 864 //
     /*  204792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  204795 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  204805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204809 */     // MIs[0] rs1
     /*  204809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204821 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204826 */     GIR_RootConstrainSelectedInstOperands,
     /*  204827 */     // GIR_Coverage, 864,
     /*  204827 */     GIR_Done,
     /*  204828 */   // Label 4082: @204828
     /*  204828 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(204869), // Rule ID 866 //
     /*  204833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  204836 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  204846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204850 */     // MIs[0] rs1
     /*  204850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204862 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204862 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204867 */     GIR_RootConstrainSelectedInstOperands,
     /*  204868 */     // GIR_Coverage, 866,
     /*  204868 */     GIR_Done,
     /*  204869 */   // Label 4083: @204869
     /*  204869 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(204910), // Rule ID 868 //
     /*  204874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  204877 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  204884 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  204887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204891 */     // MIs[0] rs1
     /*  204891 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204903 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204903 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  204908 */     GIR_RootConstrainSelectedInstOperands,
     /*  204909 */     // GIR_Coverage, 868,
     /*  204909 */     GIR_Done,
     /*  204910 */   // Label 4084: @204910
     /*  204910 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(204951), // Rule ID 1030 //
     /*  204915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204918 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204925 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  204928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204932 */     // MIs[0] rs1
     /*  204932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204944 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204944 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  204949 */     GIR_RootConstrainSelectedInstOperands,
     /*  204950 */     // GIR_Coverage, 1030,
     /*  204950 */     GIR_Done,
     /*  204951 */   // Label 4085: @204951
     /*  204951 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(204992), // Rule ID 1032 //
     /*  204956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  204959 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  204966 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  204969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204973 */     // MIs[0] rs1
     /*  204973 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  204977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  204985 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  204985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  204990 */     GIR_RootConstrainSelectedInstOperands,
     /*  204991 */     // GIR_Coverage, 1032,
     /*  204991 */     GIR_Done,
     /*  204992 */   // Label 4086: @204992
     /*  204992 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(205033), // Rule ID 1034 //
     /*  204997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205000 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205007 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205014 */     // MIs[0] rs1
     /*  205014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205026 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205026 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  205031 */     GIR_RootConstrainSelectedInstOperands,
     /*  205032 */     // GIR_Coverage, 1034,
     /*  205032 */     GIR_Done,
     /*  205033 */   // Label 4087: @205033
     /*  205033 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(205074), // Rule ID 1036 //
     /*  205038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205041 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205048 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205055 */     // MIs[0] rs1
     /*  205055 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205067 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205072 */     GIR_RootConstrainSelectedInstOperands,
     /*  205073 */     // GIR_Coverage, 1036,
     /*  205073 */     GIR_Done,
     /*  205074 */   // Label 4088: @205074
     /*  205074 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(205115), // Rule ID 1038 //
     /*  205079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode1),
     /*  205082 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205089 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205096 */     // MIs[0] rs1
     /*  205096 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205108 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  205113 */     GIR_RootConstrainSelectedInstOperands,
     /*  205114 */     // GIR_Coverage, 1038,
     /*  205114 */     GIR_Done,
     /*  205115 */   // Label 4089: @205115
     /*  205115 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(205156), // Rule ID 1040 //
     /*  205120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205137 */     // MIs[0] rs1
     /*  205137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205149 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205149 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205154 */     GIR_RootConstrainSelectedInstOperands,
     /*  205155 */     // GIR_Coverage, 1040,
     /*  205155 */     GIR_Done,
     /*  205156 */   // Label 4090: @205156
     /*  205156 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(205197), // Rule ID 1042 //
     /*  205161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205178 */     // MIs[0] rs1
     /*  205178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205190 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205190 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205195 */     GIR_RootConstrainSelectedInstOperands,
     /*  205196 */     // GIR_Coverage, 1042,
     /*  205196 */     GIR_Done,
     /*  205197 */   // Label 4091: @205197
     /*  205197 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(205238), // Rule ID 1044 //
     /*  205202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205219 */     // MIs[0] rs1
     /*  205219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205231 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205236 */     GIR_RootConstrainSelectedInstOperands,
     /*  205237 */     // GIR_Coverage, 1044,
     /*  205237 */     GIR_Done,
     /*  205238 */   // Label 4092: @205238
     /*  205238 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(205279), // Rule ID 1046 //
     /*  205243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205260 */     // MIs[0] rs1
     /*  205260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205272 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205277 */     GIR_RootConstrainSelectedInstOperands,
     /*  205278 */     // GIR_Coverage, 1046,
     /*  205278 */     GIR_Done,
     /*  205279 */   // Label 4093: @205279
     /*  205279 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(205320), // Rule ID 1048 //
     /*  205284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode1),
     /*  205287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  205294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205301 */     // MIs[0] rs1
     /*  205301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  205305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205313 */     // (atomic_load_umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  205313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  205318 */     GIR_RootConstrainSelectedInstOperands,
     /*  205319 */     // GIR_Coverage, 1048,
     /*  205319 */     GIR_Done,
     /*  205320 */   // Label 4094: @205320
     /*  205320 */   GIM_Reject,
     /*  205321 */ // Label 4064: @205321
     /*  205321 */ GIM_Reject,
     /*  205322 */ // Label 4062: @205322
     /*  205322 */ GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(206971),
     /*  205327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  205330 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(205371), // Rule ID 501 //
     /*  205335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205338 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205345 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205352 */     // MIs[0] rs1
     /*  205352 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205364 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205364 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205369 */     GIR_RootConstrainSelectedInstOperands,
     /*  205370 */     // GIR_Coverage, 501,
     /*  205370 */     GIR_Done,
     /*  205371 */   // Label 4096: @205371
     /*  205371 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(205412), // Rule ID 503 //
     /*  205376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205379 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205386 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205393 */     // MIs[0] rs1
     /*  205393 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205405 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ),
     /*  205410 */     GIR_RootConstrainSelectedInstOperands,
     /*  205411 */     // GIR_Coverage, 503,
     /*  205411 */     GIR_Done,
     /*  205412 */   // Label 4097: @205412
     /*  205412 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(205453), // Rule ID 505 //
     /*  205417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205420 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205427 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205434 */     // MIs[0] rs1
     /*  205434 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205446 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_RL),
     /*  205451 */     GIR_RootConstrainSelectedInstOperands,
     /*  205452 */     // GIR_Coverage, 505,
     /*  205452 */     GIR_Done,
     /*  205453 */   // Label 4098: @205453
     /*  205453 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(205494), // Rule ID 507 //
     /*  205458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205461 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205468 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205475 */     // MIs[0] rs1
     /*  205475 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205487 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205492 */     GIR_RootConstrainSelectedInstOperands,
     /*  205493 */     // GIR_Coverage, 507,
     /*  205493 */     GIR_Done,
     /*  205494 */   // Label 4099: @205494
     /*  205494 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(205535), // Rule ID 509 //
     /*  205499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_NotHasStdExtZtso_HwMode0),
     /*  205502 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205516 */     // MIs[0] rs1
     /*  205516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205528 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W_AQ_RL),
     /*  205533 */     GIR_RootConstrainSelectedInstOperands,
     /*  205534 */     // GIR_Coverage, 509,
     /*  205534 */     GIR_Done,
     /*  205535 */   // Label 4100: @205535
     /*  205535 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(205576), // Rule ID 511 //
     /*  205540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  205543 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205550 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205557 */     // MIs[0] rs1
     /*  205557 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205569 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205574 */     GIR_RootConstrainSelectedInstOperands,
     /*  205575 */     // GIR_Coverage, 511,
     /*  205575 */     GIR_Done,
     /*  205576 */   // Label 4101: @205576
     /*  205576 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(205617), // Rule ID 513 //
     /*  205581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  205584 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205591 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205598 */     // MIs[0] rs1
     /*  205598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205610 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205610 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205615 */     GIR_RootConstrainSelectedInstOperands,
     /*  205616 */     // GIR_Coverage, 513,
     /*  205616 */     GIR_Done,
     /*  205617 */   // Label 4102: @205617
     /*  205617 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(205658), // Rule ID 515 //
     /*  205622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  205625 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205632 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205639 */     // MIs[0] rs1
     /*  205639 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205651 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205651 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205656 */     GIR_RootConstrainSelectedInstOperands,
     /*  205657 */     // GIR_Coverage, 515,
     /*  205657 */     GIR_Done,
     /*  205658 */   // Label 4103: @205658
     /*  205658 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(205699), // Rule ID 517 //
     /*  205663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  205666 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205673 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205680 */     // MIs[0] rs1
     /*  205680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205692 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205692 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205697 */     GIR_RootConstrainSelectedInstOperands,
     /*  205698 */     // GIR_Coverage, 517,
     /*  205698 */     GIR_Done,
     /*  205699 */   // Label 4104: @205699
     /*  205699 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(205740), // Rule ID 519 //
     /*  205704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_HwMode0),
     /*  205707 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  205714 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205721 */     // MIs[0] rs1
     /*  205721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205733 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (AMOMINU_W:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_W),
     /*  205738 */     GIR_RootConstrainSelectedInstOperands,
     /*  205739 */     // GIR_Coverage, 519,
     /*  205739 */     GIR_Done,
     /*  205740 */   // Label 4105: @205740
     /*  205740 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(205781), // Rule ID 601 //
     /*  205745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  205748 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205755 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205762 */     // MIs[0] rs1
     /*  205762 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205774 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  205779 */     GIR_RootConstrainSelectedInstOperands,
     /*  205780 */     // GIR_Coverage, 601,
     /*  205780 */     GIR_Done,
     /*  205781 */   // Label 4106: @205781
     /*  205781 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(205822), // Rule ID 602 //
     /*  205786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  205789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205796 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  205799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205803 */     // MIs[0] rs1
     /*  205803 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205815 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205815 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ),
     /*  205820 */     GIR_RootConstrainSelectedInstOperands,
     /*  205821 */     // GIR_Coverage, 602,
     /*  205821 */     GIR_Done,
     /*  205822 */   // Label 4107: @205822
     /*  205822 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(205863), // Rule ID 603 //
     /*  205827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  205830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  205840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205844 */     // MIs[0] rs1
     /*  205844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205856 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205856 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_RL),
     /*  205861 */     GIR_RootConstrainSelectedInstOperands,
     /*  205862 */     // GIR_Coverage, 603,
     /*  205862 */     GIR_Done,
     /*  205863 */   // Label 4108: @205863
     /*  205863 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(205904), // Rule ID 604 //
     /*  205868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  205871 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  205881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205885 */     // MIs[0] rs1
     /*  205885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205897 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205897 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  205902 */     GIR_RootConstrainSelectedInstOperands,
     /*  205903 */     // GIR_Coverage, 604,
     /*  205903 */     GIR_Done,
     /*  205904 */   // Label 4109: @205904
     /*  205904 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(205945), // Rule ID 605 //
     /*  205909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_NotHasStdExtZtso_HwMode0),
     /*  205912 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  205922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205926 */     // MIs[0] rs1
     /*  205926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205938 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D_AQ_RL),
     /*  205943 */     GIR_RootConstrainSelectedInstOperands,
     /*  205944 */     // GIR_Coverage, 605,
     /*  205944 */     GIR_Done,
     /*  205945 */   // Label 4110: @205945
     /*  205945 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(205986), // Rule ID 606 //
     /*  205950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  205953 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  205960 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  205963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205967 */     // MIs[0] rs1
     /*  205967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  205971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  205979 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  205979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  205984 */     GIR_RootConstrainSelectedInstOperands,
     /*  205985 */     // GIR_Coverage, 606,
     /*  205985 */     GIR_Done,
     /*  205986 */   // Label 4111: @205986
     /*  205986 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(206027), // Rule ID 607 //
     /*  205991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  205994 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206001 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206008 */     // MIs[0] rs1
     /*  206008 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206020 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206020 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206025 */     GIR_RootConstrainSelectedInstOperands,
     /*  206026 */     // GIR_Coverage, 607,
     /*  206026 */     GIR_Done,
     /*  206027 */   // Label 4112: @206027
     /*  206027 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(206068), // Rule ID 608 //
     /*  206032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206035 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206042 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206049 */     // MIs[0] rs1
     /*  206049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206061 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206066 */     GIR_RootConstrainSelectedInstOperands,
     /*  206067 */     // GIR_Coverage, 608,
     /*  206067 */     GIR_Done,
     /*  206068 */   // Label 4113: @206068
     /*  206068 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(206109), // Rule ID 609 //
     /*  206073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206083 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206090 */     // MIs[0] rs1
     /*  206090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206102 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206102 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206107 */     GIR_RootConstrainSelectedInstOperands,
     /*  206108 */     // GIR_Coverage, 609,
     /*  206108 */     GIR_Done,
     /*  206109 */   // Label 4114: @206109
     /*  206109 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(206150), // Rule ID 610 //
     /*  206114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZtso_IsRV64_HwMode0),
     /*  206117 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  206124 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206131 */     // MIs[0] rs1
     /*  206131 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206143 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (AMOMINU_D:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_D),
     /*  206148 */     GIR_RootConstrainSelectedInstOperands,
     /*  206149 */     // GIR_Coverage, 610,
     /*  206149 */     GIR_Done,
     /*  206150 */   // Label 4115: @206150
     /*  206150 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(206191), // Rule ID 849 //
     /*  206155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206172 */     // MIs[0] rs1
     /*  206172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206184 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206184 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206189 */     GIR_RootConstrainSelectedInstOperands,
     /*  206190 */     // GIR_Coverage, 849,
     /*  206190 */     GIR_Done,
     /*  206191 */   // Label 4116: @206191
     /*  206191 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(206232), // Rule ID 851 //
     /*  206196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206199 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206206 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206213 */     // MIs[0] rs1
     /*  206213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206225 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ),
     /*  206230 */     GIR_RootConstrainSelectedInstOperands,
     /*  206231 */     // GIR_Coverage, 851,
     /*  206231 */     GIR_Done,
     /*  206232 */   // Label 4117: @206232
     /*  206232 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(206273), // Rule ID 853 //
     /*  206237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206240 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206247 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206254 */     // MIs[0] rs1
     /*  206254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206266 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206266 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_RL),
     /*  206271 */     GIR_RootConstrainSelectedInstOperands,
     /*  206272 */     // GIR_Coverage, 853,
     /*  206272 */     GIR_Done,
     /*  206273 */   // Label 4118: @206273
     /*  206273 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(206314), // Rule ID 855 //
     /*  206278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206281 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206288 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206295 */     // MIs[0] rs1
     /*  206295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206307 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206307 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206312 */     GIR_RootConstrainSelectedInstOperands,
     /*  206313 */     // GIR_Coverage, 855,
     /*  206313 */     GIR_Done,
     /*  206314 */   // Label 4119: @206314
     /*  206314 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(206355), // Rule ID 857 //
     /*  206319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206336 */     // MIs[0] rs1
     /*  206336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206348 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206348 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B_AQ_RL),
     /*  206353 */     GIR_RootConstrainSelectedInstOperands,
     /*  206354 */     // GIR_Coverage, 857,
     /*  206354 */     GIR_Done,
     /*  206355 */   // Label 4120: @206355
     /*  206355 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(206396), // Rule ID 859 //
     /*  206360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206377 */     // MIs[0] rs1
     /*  206377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206389 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206394 */     GIR_RootConstrainSelectedInstOperands,
     /*  206395 */     // GIR_Coverage, 859,
     /*  206395 */     GIR_Done,
     /*  206396 */   // Label 4121: @206396
     /*  206396 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(206437), // Rule ID 861 //
     /*  206401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206404 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206411 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206418 */     // MIs[0] rs1
     /*  206418 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206430 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206435 */     GIR_RootConstrainSelectedInstOperands,
     /*  206436 */     // GIR_Coverage, 861,
     /*  206436 */     GIR_Done,
     /*  206437 */   // Label 4122: @206437
     /*  206437 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(206478), // Rule ID 863 //
     /*  206442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206445 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206452 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206459 */     // MIs[0] rs1
     /*  206459 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206471 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206471 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206476 */     GIR_RootConstrainSelectedInstOperands,
     /*  206477 */     // GIR_Coverage, 863,
     /*  206477 */     GIR_Done,
     /*  206478 */   // Label 4123: @206478
     /*  206478 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(206519), // Rule ID 865 //
     /*  206483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206493 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206500 */     // MIs[0] rs1
     /*  206500 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206512 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206517 */     GIR_RootConstrainSelectedInstOperands,
     /*  206518 */     // GIR_Coverage, 865,
     /*  206518 */     GIR_Done,
     /*  206519 */   // Label 4124: @206519
     /*  206519 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(206560), // Rule ID 867 //
     /*  206524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206527 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  206534 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206541 */     // MIs[0] rs1
     /*  206541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206553 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (AMOMINU_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206553 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_B),
     /*  206558 */     GIR_RootConstrainSelectedInstOperands,
     /*  206559 */     // GIR_Coverage, 867,
     /*  206559 */     GIR_Done,
     /*  206560 */   // Label 4125: @206560
     /*  206560 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(206601), // Rule ID 1029 //
     /*  206565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206568 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206582 */     // MIs[0] rs1
     /*  206582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206594 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206599 */     GIR_RootConstrainSelectedInstOperands,
     /*  206600 */     // GIR_Coverage, 1029,
     /*  206600 */     GIR_Done,
     /*  206601 */   // Label 4126: @206601
     /*  206601 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(206642), // Rule ID 1031 //
     /*  206606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206609 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206616 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206623 */     // MIs[0] rs1
     /*  206623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206627 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206635 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H_AQ:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ),
     /*  206640 */     GIR_RootConstrainSelectedInstOperands,
     /*  206641 */     // GIR_Coverage, 1031,
     /*  206641 */     GIR_Done,
     /*  206642 */   // Label 4127: @206642
     /*  206642 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(206683), // Rule ID 1033 //
     /*  206647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206650 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206657 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206664 */     // MIs[0] rs1
     /*  206664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206676 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206676 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_RL),
     /*  206681 */     GIR_RootConstrainSelectedInstOperands,
     /*  206682 */     // GIR_Coverage, 1033,
     /*  206682 */     GIR_Done,
     /*  206683 */   // Label 4128: @206683
     /*  206683 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(206724), // Rule ID 1035 //
     /*  206688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206691 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206698 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206705 */     // MIs[0] rs1
     /*  206705 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206717 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206722 */     GIR_RootConstrainSelectedInstOperands,
     /*  206723 */     // GIR_Coverage, 1035,
     /*  206723 */     GIR_Done,
     /*  206724 */   // Label 4129: @206724
     /*  206724 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(206765), // Rule ID 1037 //
     /*  206729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_NotHasStdExtZtso_HwMode0),
     /*  206732 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206739 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206746 */     // MIs[0] rs1
     /*  206746 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206758 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H_AQ_RL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206758 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H_AQ_RL),
     /*  206763 */     GIR_RootConstrainSelectedInstOperands,
     /*  206764 */     // GIR_Coverage, 1037,
     /*  206764 */     GIR_Done,
     /*  206765 */   // Label 4130: @206765
     /*  206765 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(206806), // Rule ID 1039 //
     /*  206770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /*  206783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206787 */     // MIs[0] rs1
     /*  206787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206799 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206799 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206804 */     GIR_RootConstrainSelectedInstOperands,
     /*  206805 */     // GIR_Coverage, 1039,
     /*  206805 */     GIR_Done,
     /*  206806 */   // Label 4131: @206806
     /*  206806 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(206847), // Rule ID 1041 //
     /*  206811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206814 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206821 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  206824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206828 */     // MIs[0] rs1
     /*  206828 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206840 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206845 */     GIR_RootConstrainSelectedInstOperands,
     /*  206846 */     // GIR_Coverage, 1041,
     /*  206846 */     GIR_Done,
     /*  206847 */   // Label 4132: @206847
     /*  206847 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(206888), // Rule ID 1043 //
     /*  206852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206855 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206862 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /*  206865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206869 */     // MIs[0] rs1
     /*  206869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206881 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206881 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206886 */     GIR_RootConstrainSelectedInstOperands,
     /*  206887 */     // GIR_Coverage, 1043,
     /*  206887 */     GIR_Done,
     /*  206888 */   // Label 4133: @206888
     /*  206888 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(206929), // Rule ID 1045 //
     /*  206893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206896 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /*  206906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206910 */     // MIs[0] rs1
     /*  206910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206922 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206927 */     GIR_RootConstrainSelectedInstOperands,
     /*  206928 */     // GIR_Coverage, 1045,
     /*  206928 */     GIR_Done,
     /*  206929 */   // Label 4134: @206929
     /*  206929 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(206970), // Rule ID 1047 //
     /*  206934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HasStdExtZabha_HasStdExtZtso_HwMode0),
     /*  206937 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  206944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /*  206947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206951 */     // MIs[0] rs1
     /*  206951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /*  206955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  206963 */     // (atomic_load_umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (AMOMINU_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  206963 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::AMOMINU_H),
     /*  206968 */     GIR_RootConstrainSelectedInstOperands,
     /*  206969 */     // GIR_Coverage, 1047,
     /*  206969 */     GIR_Done,
     /*  206970 */   // Label 4135: @206970
     /*  206970 */   GIM_Reject,
     /*  206971 */ // Label 4095: @206971
     /*  206971 */ GIM_Reject,
     /*  206972 */ // Label 4063: @206972
     /*  206972 */ GIM_Reject,
     /*  206973 */ // Label 36: @206973
     /*  206973 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 4138*/ GIMT_Encode4(207190),
     /*  206984 */ /*GILLT_s32*//*Label 4136*/ GIMT_Encode4(206992),
     /*  206988 */ /*GILLT_s64*//*Label 4137*/ GIMT_Encode4(207091),
     /*  206992 */ // Label 4136: @206992
     /*  206992 */ GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(207018), // Rule ID 245 //
     /*  206997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207000 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207004 */   // MIs[0] Operand 1
     /*  207004 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207007 */   // (atomic_fence 4:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 2:{ *:[i32] }, 3:{ *:[i32] })
     /*  207007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207010 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207016 */   GIR_RootConstrainSelectedInstOperands,
     /*  207017 */   // GIR_Coverage, 245,
     /*  207017 */   GIR_EraseRootFromParent_Done,
     /*  207018 */ // Label 4139: @207018
     /*  207018 */ GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(207044), // Rule ID 247 //
     /*  207023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207026 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207030 */   // MIs[0] Operand 1
     /*  207030 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207033 */   // (atomic_fence 5:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  207033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207042 */   GIR_RootConstrainSelectedInstOperands,
     /*  207043 */   // GIR_Coverage, 247,
     /*  207043 */   GIR_EraseRootFromParent_Done,
     /*  207044 */ // Label 4140: @207044
     /*  207044 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(207064), // Rule ID 249 //
     /*  207049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207052 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207056 */   // MIs[0] Operand 1
     /*  207056 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207059 */   // (atomic_fence 6:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE_TSO)
     /*  207059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207062 */   GIR_RootConstrainSelectedInstOperands,
     /*  207063 */   // GIR_Coverage, 249,
     /*  207063 */   GIR_EraseRootFromParent_Done,
     /*  207064 */ // Label 4141: @207064
     /*  207064 */ GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(207090), // Rule ID 251 //
     /*  207069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207072 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207076 */   // MIs[0] Operand 1
     /*  207076 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207079 */   // (atomic_fence 7:{ *:[i32] }, (timm:{ *:[i32] }))  =>  (FENCE 3:{ *:[i32] }, 3:{ *:[i32] })
     /*  207079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207088 */   GIR_RootConstrainSelectedInstOperands,
     /*  207089 */   // GIR_Coverage, 251,
     /*  207089 */   GIR_EraseRootFromParent_Done,
     /*  207090 */ // Label 4142: @207090
     /*  207090 */ GIM_Reject,
     /*  207091 */ // Label 4137: @207091
     /*  207091 */ GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(207117), // Rule ID 244 //
     /*  207096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207099 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /*  207103 */   // MIs[0] Operand 1
     /*  207103 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207106 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 2:{ *:[i64] }, 3:{ *:[i64] })
     /*  207106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /*  207112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207115 */   GIR_RootConstrainSelectedInstOperands,
     /*  207116 */   // GIR_Coverage, 244,
     /*  207116 */   GIR_EraseRootFromParent_Done,
     /*  207117 */ // Label 4143: @207117
     /*  207117 */ GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(207143), // Rule ID 246 //
     /*  207122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207125 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 5,
     /*  207129 */   // MIs[0] Operand 1
     /*  207129 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207132 */   // (atomic_fence 5:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  207132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  207141 */   GIR_RootConstrainSelectedInstOperands,
     /*  207142 */   // GIR_Coverage, 246,
     /*  207142 */   GIR_EraseRootFromParent_Done,
     /*  207143 */ // Label 4144: @207143
     /*  207143 */ GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(207163), // Rule ID 248 //
     /*  207148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207151 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 6,
     /*  207155 */   // MIs[0] Operand 1
     /*  207155 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207158 */   // (atomic_fence 6:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE_TSO)
     /*  207158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE_TSO),
     /*  207161 */   GIR_RootConstrainSelectedInstOperands,
     /*  207162 */   // GIR_Coverage, 248,
     /*  207162 */   GIR_EraseRootFromParent_Done,
     /*  207163 */ // Label 4145: @207163
     /*  207163 */ GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(207189), // Rule ID 250 //
     /*  207168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207171 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 7,
     /*  207175 */   // MIs[0] Operand 1
     /*  207175 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  207178 */   // (atomic_fence 7:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (FENCE 3:{ *:[i64] }, 3:{ *:[i64] })
     /*  207178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FENCE),
     /*  207181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207184 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  207187 */   GIR_RootConstrainSelectedInstOperands,
     /*  207188 */   // GIR_Coverage, 250,
     /*  207188 */   GIR_EraseRootFromParent_Done,
     /*  207189 */ // Label 4146: @207189
     /*  207189 */ GIM_Reject,
     /*  207190 */ // Label 4138: @207190
     /*  207190 */ GIM_Reject,
     /*  207191 */ // Label 37: @207191
     /*  207191 */ GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(208676),
     /*  207196 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  207199 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(207244), // Rule ID 2604 //
     /*  207204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207229 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207242 */     GIR_RootConstrainSelectedInstOperands,
     /*  207243 */     // GIR_Coverage, 2604,
     /*  207243 */     GIR_EraseRootFromParent_Done,
     /*  207244 */   // Label 4148: @207244
     /*  207244 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(207289), // Rule ID 2605 //
     /*  207249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207274 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /*  207277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207287 */     GIR_RootConstrainSelectedInstOperands,
     /*  207288 */     // GIR_Coverage, 2605,
     /*  207288 */     GIR_EraseRootFromParent_Done,
     /*  207289 */   // Label 4149: @207289
     /*  207289 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(207334), // Rule ID 23146 //
     /*  207294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207319 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207332 */     GIR_RootConstrainSelectedInstOperands,
     /*  207333 */     // GIR_Coverage, 23146,
     /*  207333 */     GIR_EraseRootFromParent_Done,
     /*  207334 */   // Label 4150: @207334
     /*  207334 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(207379), // Rule ID 23147 //
     /*  207339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207364 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /*  207367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207377 */     GIR_RootConstrainSelectedInstOperands,
     /*  207378 */     // GIR_Coverage, 23147,
     /*  207378 */     GIR_EraseRootFromParent_Done,
     /*  207379 */   // Label 4151: @207379
     /*  207379 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(207424), // Rule ID 23148 //
     /*  207384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207409 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207422 */     GIR_RootConstrainSelectedInstOperands,
     /*  207423 */     // GIR_Coverage, 23148,
     /*  207423 */     GIR_EraseRootFromParent_Done,
     /*  207424 */   // Label 4152: @207424
     /*  207424 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(207469), // Rule ID 23149 //
     /*  207429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  207440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /*  207457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207467 */     GIR_RootConstrainSelectedInstOperands,
     /*  207468 */     // GIR_Coverage, 23149,
     /*  207468 */     GIR_EraseRootFromParent_Done,
     /*  207469 */   // Label 4153: @207469
     /*  207469 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(207514), // Rule ID 23150 //
     /*  207474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  207502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207512 */     GIR_RootConstrainSelectedInstOperands,
     /*  207513 */     // GIR_Coverage, 23150,
     /*  207513 */     GIR_EraseRootFromParent_Done,
     /*  207514 */   // Label 4154: @207514
     /*  207514 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(207559), // Rule ID 23151 //
     /*  207519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  207530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /*  207547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207557 */     GIR_RootConstrainSelectedInstOperands,
     /*  207558 */     // GIR_Coverage, 23151,
     /*  207558 */     GIR_EraseRootFromParent_Done,
     /*  207559 */   // Label 4155: @207559
     /*  207559 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(207604), // Rule ID 23152 //
     /*  207564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  207592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207602 */     GIR_RootConstrainSelectedInstOperands,
     /*  207603 */     // GIR_Coverage, 23152,
     /*  207603 */     GIR_EraseRootFromParent_Done,
     /*  207604 */   // Label 4156: @207604
     /*  207604 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(207649), // Rule ID 23153 //
     /*  207609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  207620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /*  207637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207647 */     GIR_RootConstrainSelectedInstOperands,
     /*  207648 */     // GIR_Coverage, 23153,
     /*  207648 */     GIR_EraseRootFromParent_Done,
     /*  207649 */   // Label 4157: @207649
     /*  207649 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(207694), // Rule ID 23154 //
     /*  207654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207679 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  207682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207692 */     GIR_RootConstrainSelectedInstOperands,
     /*  207693 */     // GIR_Coverage, 23154,
     /*  207693 */     GIR_EraseRootFromParent_Done,
     /*  207694 */   // Label 4158: @207694
     /*  207694 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(207739), // Rule ID 23155 //
     /*  207699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  207710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207724 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /*  207727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207737 */     GIR_RootConstrainSelectedInstOperands,
     /*  207738 */     // GIR_Coverage, 23155,
     /*  207738 */     GIR_EraseRootFromParent_Done,
     /*  207739 */   // Label 4159: @207739
     /*  207739 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(207784), // Rule ID 23156 //
     /*  207744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  207755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207769 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  207772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207782 */     GIR_RootConstrainSelectedInstOperands,
     /*  207783 */     // GIR_Coverage, 23156,
     /*  207783 */     GIR_EraseRootFromParent_Done,
     /*  207784 */   // Label 4160: @207784
     /*  207784 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(207829), // Rule ID 23157 //
     /*  207789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmclr),
     /*  207797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  207800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207814 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11349:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /*  207817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207827 */     GIR_RootConstrainSelectedInstOperands,
     /*  207828 */     // GIR_Coverage, 23157,
     /*  207828 */     GIR_EraseRootFromParent_Done,
     /*  207829 */   // Label 4161: @207829
     /*  207829 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(207874), // Rule ID 23158 //
     /*  207834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  207842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  207862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207872 */     GIR_RootConstrainSelectedInstOperands,
     /*  207873 */     // GIR_Coverage, 23158,
     /*  207873 */     GIR_EraseRootFromParent_Done,
     /*  207874 */   // Label 4162: @207874
     /*  207874 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(207919), // Rule ID 23159 //
     /*  207879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  207887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  207890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207904 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /*  207907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207917 */     GIR_RootConstrainSelectedInstOperands,
     /*  207918 */     // GIR_Coverage, 23159,
     /*  207918 */     GIR_EraseRootFromParent_Done,
     /*  207919 */   // Label 4163: @207919
     /*  207919 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(207964), // Rule ID 23160 //
     /*  207924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  207927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  207932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  207938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207949 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  207949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  207952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  207959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  207962 */     GIR_RootConstrainSelectedInstOperands,
     /*  207963 */     // GIR_Coverage, 23160,
     /*  207963 */     GIR_EraseRootFromParent_Done,
     /*  207964 */   // Label 4164: @207964
     /*  207964 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(208009), // Rule ID 23161 //
     /*  207969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  207972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  207977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  207980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  207983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  207987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  207994 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  207994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /*  207997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  207999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208007 */     GIR_RootConstrainSelectedInstOperands,
     /*  208008 */     // GIR_Coverage, 23161,
     /*  208008 */     GIR_EraseRootFromParent_Done,
     /*  208009 */   // Label 4165: @208009
     /*  208009 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(208054), // Rule ID 23162 //
     /*  208014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208039 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208052 */     GIR_RootConstrainSelectedInstOperands,
     /*  208053 */     // GIR_Coverage, 23162,
     /*  208053 */     GIR_EraseRootFromParent_Done,
     /*  208054 */   // Label 4166: @208054
     /*  208054 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(208099), // Rule ID 23163 //
     /*  208059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  208070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /*  208087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208097 */     GIR_RootConstrainSelectedInstOperands,
     /*  208098 */     // GIR_Coverage, 23163,
     /*  208098 */     GIR_EraseRootFromParent_Done,
     /*  208099 */   // Label 4167: @208099
     /*  208099 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(208144), // Rule ID 23164 //
     /*  208104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208129 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208142 */     GIR_RootConstrainSelectedInstOperands,
     /*  208143 */     // GIR_Coverage, 23164,
     /*  208143 */     GIR_EraseRootFromParent_Done,
     /*  208144 */   // Label 4168: @208144
     /*  208144 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(208189), // Rule ID 23165 //
     /*  208149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  208160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /*  208177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208187 */     GIR_RootConstrainSelectedInstOperands,
     /*  208188 */     // GIR_Coverage, 23165,
     /*  208188 */     GIR_EraseRootFromParent_Done,
     /*  208189 */   // Label 4169: @208189
     /*  208189 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(208234), // Rule ID 23166 //
     /*  208194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208219 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208232 */     GIR_RootConstrainSelectedInstOperands,
     /*  208233 */     // GIR_Coverage, 23166,
     /*  208233 */     GIR_EraseRootFromParent_Done,
     /*  208234 */   // Label 4170: @208234
     /*  208234 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(208279), // Rule ID 23167 //
     /*  208239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  208250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208264 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /*  208267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208277 */     GIR_RootConstrainSelectedInstOperands,
     /*  208278 */     // GIR_Coverage, 23167,
     /*  208278 */     GIR_EraseRootFromParent_Done,
     /*  208279 */   // Label 4171: @208279
     /*  208279 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(208324), // Rule ID 23168 //
     /*  208284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208309 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208322 */     GIR_RootConstrainSelectedInstOperands,
     /*  208323 */     // GIR_Coverage, 23168,
     /*  208323 */     GIR_EraseRootFromParent_Done,
     /*  208324 */   // Label 4172: @208324
     /*  208324 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(208369), // Rule ID 23169 //
     /*  208329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  208340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208354 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /*  208357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208367 */     GIR_RootConstrainSelectedInstOperands,
     /*  208368 */     // GIR_Coverage, 23169,
     /*  208368 */     GIR_EraseRootFromParent_Done,
     /*  208369 */   // Label 4173: @208369
     /*  208369 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(208414), // Rule ID 23170 //
     /*  208374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208399 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208412 */     GIR_RootConstrainSelectedInstOperands,
     /*  208413 */     // GIR_Coverage, 23170,
     /*  208413 */     GIR_EraseRootFromParent_Done,
     /*  208414 */   // Label 4174: @208414
     /*  208414 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(208459), // Rule ID 23171 //
     /*  208419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmset),
     /*  208427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  208430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208444 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11377:{ *:[iPTR] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /*  208447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208457 */     GIR_RootConstrainSelectedInstOperands,
     /*  208458 */     // GIR_Coverage, 23171,
     /*  208458 */     GIR_EraseRootFromParent_Done,
     /*  208459 */   // Label 4175: @208459
     /*  208459 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(208495), // Rule ID 2541 //
     /*  208464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  208467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64im),
     /*  208472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208486 */     // (intrinsic_wo_chain:{ *:[i64] } 10908:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (AES64IM:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64IM),
     /*  208489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208493 */     GIR_RootConstrainSelectedInstOperands,
     /*  208494 */     // GIR_Coverage, 2541,
     /*  208494 */     GIR_EraseRootFromParent_Done,
     /*  208495 */   // Label 4176: @208495
     /*  208495 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(208531), // Rule ID 2562 //
     /*  208500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  208503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0),
     /*  208508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208522 */     // (intrinsic_wo_chain:{ *:[i64] } 11044:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0),
     /*  208525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208529 */     GIR_RootConstrainSelectedInstOperands,
     /*  208530 */     // GIR_Coverage, 2562,
     /*  208530 */     GIR_EraseRootFromParent_Done,
     /*  208531 */   // Label 4177: @208531
     /*  208531 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(208567), // Rule ID 2563 //
     /*  208536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  208539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1),
     /*  208544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208558 */     // (intrinsic_wo_chain:{ *:[i64] } 11047:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SIG1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1),
     /*  208561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208565 */     GIR_RootConstrainSelectedInstOperands,
     /*  208566 */     // GIR_Coverage, 2563,
     /*  208566 */     GIR_EraseRootFromParent_Done,
     /*  208567 */   // Label 4178: @208567
     /*  208567 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(208603), // Rule ID 2564 //
     /*  208572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  208575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0),
     /*  208580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208594 */     // (intrinsic_wo_chain:{ *:[i64] } 11050:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0),
     /*  208597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208601 */     GIR_RootConstrainSelectedInstOperands,
     /*  208602 */     // GIR_Coverage, 2564,
     /*  208602 */     GIR_EraseRootFromParent_Done,
     /*  208603 */   // Label 4179: @208603
     /*  208603 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(208639), // Rule ID 2565 //
     /*  208608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV64_HwMode0),
     /*  208611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1),
     /*  208616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  208622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208630 */     // (intrinsic_wo_chain:{ *:[i64] } 11052:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1)  =>  (SHA512SUM1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /*  208630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1),
     /*  208633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208637 */     GIR_RootConstrainSelectedInstOperands,
     /*  208638 */     // GIR_Coverage, 2565,
     /*  208638 */     GIR_EraseRootFromParent_Done,
     /*  208639 */   // Label 4180: @208639
     /*  208639 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(208675), // Rule ID 64415 //
     /*  208644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  208647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_clb),
     /*  208652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  208655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  208658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208666 */     // (intrinsic_wo_chain:{ *:[i32] } 10928:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1)  =>  (CV_CLB:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /*  208666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLB),
     /*  208669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208673 */     GIR_RootConstrainSelectedInstOperands,
     /*  208674 */     // GIR_Coverage, 64415,
     /*  208674 */     GIR_EraseRootFromParent_Done,
     /*  208675 */   // Label 4181: @208675
     /*  208675 */   GIM_Reject,
     /*  208676 */ // Label 4147: @208676
     /*  208676 */ GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(215964),
     /*  208681 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  208684 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(208738), // Rule ID 2574 //
     /*  208689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  208697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  208700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  208703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  208706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208721 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  208724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208736 */     GIR_RootConstrainSelectedInstOperands,
     /*  208737 */     // GIR_Coverage, 2574,
     /*  208737 */     GIR_EraseRootFromParent_Done,
     /*  208738 */   // Label 4183: @208738
     /*  208738 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(208792), // Rule ID 2575 //
     /*  208743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  208751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  208754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  208757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  208760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  208764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208775 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64),
     /*  208778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  208782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208790 */     GIR_RootConstrainSelectedInstOperands,
     /*  208791 */     // GIR_Coverage, 2575,
     /*  208791 */     GIR_EraseRootFromParent_Done,
     /*  208792 */   // Label 4184: @208792
     /*  208792 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(208846), // Rule ID 2580 //
     /*  208797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  208800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  208805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  208811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  208814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208829 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  208829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  208832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208844 */     GIR_RootConstrainSelectedInstOperands,
     /*  208845 */     // GIR_Coverage, 2580,
     /*  208845 */     GIR_EraseRootFromParent_Done,
     /*  208846 */   // Label 4185: @208846
     /*  208846 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(208900), // Rule ID 2581 //
     /*  208851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  208854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  208859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  208862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  208865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  208868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208883 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  208883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64),
     /*  208886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  208890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208898 */     GIR_RootConstrainSelectedInstOperands,
     /*  208899 */     // GIR_Coverage, 2581,
     /*  208899 */     GIR_EraseRootFromParent_Done,
     /*  208900 */   // Label 4186: @208900
     /*  208900 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(208957), // Rule ID 2600 //
     /*  208905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  208908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  208913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  208916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  208919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  208922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208937 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  208937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  208940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  208944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  208949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  208952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  208955 */     GIR_RootConstrainSelectedInstOperands,
     /*  208956 */     // GIR_Coverage, 2600,
     /*  208956 */     GIR_EraseRootFromParent_Done,
     /*  208957 */   // Label 4187: @208957
     /*  208957 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(209014), // Rule ID 2601 //
     /*  208962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  208965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  208970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  208973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  208976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  208979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  208987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  208994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  208994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8),
     /*  208997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  208999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  209001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  209009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209012 */     GIR_RootConstrainSelectedInstOperands,
     /*  209013 */     // GIR_Coverage, 2601,
     /*  209013 */     GIR_EraseRootFromParent_Done,
     /*  209014 */   // Label 4188: @209014
     /*  209014 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(209068), // Rule ID 23172 //
     /*  209019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209051 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209066 */     GIR_RootConstrainSelectedInstOperands,
     /*  209067 */     // GIR_Coverage, 23172,
     /*  209067 */     GIR_EraseRootFromParent_Done,
     /*  209068 */   // Label 4189: @209068
     /*  209068 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(209122), // Rule ID 23173 //
     /*  209073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209105 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32),
     /*  209108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209120 */     GIR_RootConstrainSelectedInstOperands,
     /*  209121 */     // GIR_Coverage, 23173,
     /*  209121 */     GIR_EraseRootFromParent_Done,
     /*  209122 */   // Label 4190: @209122
     /*  209122 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(209176), // Rule ID 23176 //
     /*  209127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209159 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209174 */     GIR_RootConstrainSelectedInstOperands,
     /*  209175 */     // GIR_Coverage, 23176,
     /*  209175 */     GIR_EraseRootFromParent_Done,
     /*  209176 */   // Label 4191: @209176
     /*  209176 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(209230), // Rule ID 23177 //
     /*  209181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209213 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16),
     /*  209216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209228 */     GIR_RootConstrainSelectedInstOperands,
     /*  209229 */     // GIR_Coverage, 23177,
     /*  209229 */     GIR_EraseRootFromParent_Done,
     /*  209230 */   // Label 4192: @209230
     /*  209230 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(209284), // Rule ID 23180 //
     /*  209235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209267 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209282 */     GIR_RootConstrainSelectedInstOperands,
     /*  209283 */     // GIR_Coverage, 23180,
     /*  209283 */     GIR_EraseRootFromParent_Done,
     /*  209284 */   // Label 4193: @209284
     /*  209284 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(209338), // Rule ID 23181 //
     /*  209289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  209303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209321 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8),
     /*  209324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209336 */     GIR_RootConstrainSelectedInstOperands,
     /*  209337 */     // GIR_Coverage, 23181,
     /*  209337 */     GIR_EraseRootFromParent_Done,
     /*  209338 */   // Label 4194: @209338
     /*  209338 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(209392), // Rule ID 23184 //
     /*  209343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209375 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209390 */     GIR_RootConstrainSelectedInstOperands,
     /*  209391 */     // GIR_Coverage, 23184,
     /*  209391 */     GIR_EraseRootFromParent_Done,
     /*  209392 */   // Label 4195: @209392
     /*  209392 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(209446), // Rule ID 23185 //
     /*  209397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  209411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209429 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4),
     /*  209432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209444 */     GIR_RootConstrainSelectedInstOperands,
     /*  209445 */     // GIR_Coverage, 23185,
     /*  209445 */     GIR_EraseRootFromParent_Done,
     /*  209446 */   // Label 4196: @209446
     /*  209446 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(209500), // Rule ID 23188 //
     /*  209451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  209465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209483 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  209486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209498 */     GIR_RootConstrainSelectedInstOperands,
     /*  209499 */     // GIR_Coverage, 23188,
     /*  209499 */     GIR_EraseRootFromParent_Done,
     /*  209500 */   // Label 4197: @209500
     /*  209500 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(209554), // Rule ID 23189 //
     /*  209505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  209519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209537 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2),
     /*  209540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209552 */     GIR_RootConstrainSelectedInstOperands,
     /*  209553 */     // GIR_Coverage, 23189,
     /*  209553 */     GIR_EraseRootFromParent_Done,
     /*  209554 */   // Label 4198: @209554
     /*  209554 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(209608), // Rule ID 23192 //
     /*  209559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  209573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209591 */     // (intrinsic_wo_chain:{ *:[i64] } 11106:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  209594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209606 */     GIR_RootConstrainSelectedInstOperands,
     /*  209607 */     // GIR_Coverage, 23192,
     /*  209607 */     GIR_EraseRootFromParent_Done,
     /*  209608 */   // Label 4199: @209608
     /*  209608 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(209662), // Rule ID 23193 //
     /*  209613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop),
     /*  209621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  209627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209645 */     // (intrinsic_wo_chain:{ *:[i32] } 11106:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1),
     /*  209648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209660 */     GIR_RootConstrainSelectedInstOperands,
     /*  209661 */     // GIR_Coverage, 23193,
     /*  209661 */     GIR_EraseRootFromParent_Done,
     /*  209662 */   // Label 4200: @209662
     /*  209662 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(209716), // Rule ID 23196 //
     /*  209667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209699 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  209702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209714 */     GIR_RootConstrainSelectedInstOperands,
     /*  209715 */     // GIR_Coverage, 23196,
     /*  209715 */     GIR_EraseRootFromParent_Done,
     /*  209716 */   // Label 4201: @209716
     /*  209716 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(209770), // Rule ID 23197 //
     /*  209721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  209735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209753 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64),
     /*  209756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209768 */     GIR_RootConstrainSelectedInstOperands,
     /*  209769 */     // GIR_Coverage, 23197,
     /*  209769 */     GIR_EraseRootFromParent_Done,
     /*  209770 */   // Label 4202: @209770
     /*  209770 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(209824), // Rule ID 23200 //
     /*  209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209807 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  209810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209822 */     GIR_RootConstrainSelectedInstOperands,
     /*  209823 */     // GIR_Coverage, 23200,
     /*  209823 */     GIR_EraseRootFromParent_Done,
     /*  209824 */   // Label 4203: @209824
     /*  209824 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(209878), // Rule ID 23201 //
     /*  209829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  209843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209861 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32),
     /*  209864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209876 */     GIR_RootConstrainSelectedInstOperands,
     /*  209877 */     // GIR_Coverage, 23201,
     /*  209877 */     GIR_EraseRootFromParent_Done,
     /*  209878 */   // Label 4204: @209878
     /*  209878 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(209932), // Rule ID 23204 //
     /*  209883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  209894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  209900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209915 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  209915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  209918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209930 */     GIR_RootConstrainSelectedInstOperands,
     /*  209931 */     // GIR_Coverage, 23204,
     /*  209931 */     GIR_EraseRootFromParent_Done,
     /*  209932 */   // Label 4205: @209932
     /*  209932 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(209986), // Rule ID 23205 //
     /*  209937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  209940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  209948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  209951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  209954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  209958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  209962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  209969 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  209969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16),
     /*  209972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  209974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  209976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  209981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  209984 */     GIR_RootConstrainSelectedInstOperands,
     /*  209985 */     // GIR_Coverage, 23205,
     /*  209985 */     GIR_EraseRootFromParent_Done,
     /*  209986 */   // Label 4206: @209986
     /*  209986 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(210040), // Rule ID 23208 //
     /*  209991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  209994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  209999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210023 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210038 */     GIR_RootConstrainSelectedInstOperands,
     /*  210039 */     // GIR_Coverage, 23208,
     /*  210039 */     GIR_EraseRootFromParent_Done,
     /*  210040 */   // Label 4207: @210040
     /*  210040 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(210094), // Rule ID 23209 //
     /*  210045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210077 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8),
     /*  210080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210092 */     GIR_RootConstrainSelectedInstOperands,
     /*  210093 */     // GIR_Coverage, 23209,
     /*  210093 */     GIR_EraseRootFromParent_Done,
     /*  210094 */   // Label 4208: @210094
     /*  210094 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(210148), // Rule ID 23212 //
     /*  210099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210131 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210146 */     GIR_RootConstrainSelectedInstOperands,
     /*  210147 */     // GIR_Coverage, 23212,
     /*  210147 */     GIR_EraseRootFromParent_Done,
     /*  210148 */   // Label 4209: @210148
     /*  210148 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(210202), // Rule ID 23213 //
     /*  210153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210185 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4),
     /*  210188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210200 */     GIR_RootConstrainSelectedInstOperands,
     /*  210201 */     // GIR_Coverage, 23213,
     /*  210201 */     GIR_EraseRootFromParent_Done,
     /*  210202 */   // Label 4210: @210202
     /*  210202 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(210256), // Rule ID 23216 //
     /*  210207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210239 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210254 */     GIR_RootConstrainSelectedInstOperands,
     /*  210255 */     // GIR_Coverage, 23216,
     /*  210255 */     GIR_EraseRootFromParent_Done,
     /*  210256 */   // Label 4211: @210256
     /*  210256 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(210310), // Rule ID 23217 //
     /*  210261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210293 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2),
     /*  210296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210308 */     GIR_RootConstrainSelectedInstOperands,
     /*  210309 */     // GIR_Coverage, 23217,
     /*  210309 */     GIR_EraseRootFromParent_Done,
     /*  210310 */   // Label 4212: @210310
     /*  210310 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(210364), // Rule ID 23220 //
     /*  210315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  210326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210347 */     // (intrinsic_wo_chain:{ *:[i64] } 11134:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210362 */     GIR_RootConstrainSelectedInstOperands,
     /*  210363 */     // GIR_Coverage, 23220,
     /*  210363 */     GIR_EraseRootFromParent_Done,
     /*  210364 */   // Label 4213: @210364
     /*  210364 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(210418), // Rule ID 23221 //
     /*  210369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst),
     /*  210377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  210380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  210390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210401 */     // (intrinsic_wo_chain:{ *:[i32] } 11134:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1),
     /*  210404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  210408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210416 */     GIR_RootConstrainSelectedInstOperands,
     /*  210417 */     // GIR_Coverage, 23221,
     /*  210417 */     GIR_EraseRootFromParent_Done,
     /*  210418 */   // Label 4214: @210418
     /*  210418 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(210472), // Rule ID 23224 //
     /*  210423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  210458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210470 */     GIR_RootConstrainSelectedInstOperands,
     /*  210471 */     // GIR_Coverage, 23224,
     /*  210471 */     GIR_EraseRootFromParent_Done,
     /*  210472 */   // Label 4215: @210472
     /*  210472 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(210526), // Rule ID 23225 //
     /*  210477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  210488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  210491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210509 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32),
     /*  210512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210524 */     GIR_RootConstrainSelectedInstOperands,
     /*  210525 */     // GIR_Coverage, 23225,
     /*  210525 */     GIR_EraseRootFromParent_Done,
     /*  210526 */   // Label 4216: @210526
     /*  210526 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(210580), // Rule ID 23228 //
     /*  210531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  210542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210563 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  210566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210578 */     GIR_RootConstrainSelectedInstOperands,
     /*  210579 */     // GIR_Coverage, 23228,
     /*  210579 */     GIR_EraseRootFromParent_Done,
     /*  210580 */   // Label 4217: @210580
     /*  210580 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(210634), // Rule ID 23229 //
     /*  210585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  210596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  210599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210617 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16),
     /*  210620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210632 */     GIR_RootConstrainSelectedInstOperands,
     /*  210633 */     // GIR_Coverage, 23229,
     /*  210633 */     GIR_EraseRootFromParent_Done,
     /*  210634 */   // Label 4218: @210634
     /*  210634 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(210688), // Rule ID 23232 //
     /*  210639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210671 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  210674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210686 */     GIR_RootConstrainSelectedInstOperands,
     /*  210687 */     // GIR_Coverage, 23232,
     /*  210687 */     GIR_EraseRootFromParent_Done,
     /*  210688 */   // Label 4219: @210688
     /*  210688 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(210742), // Rule ID 23233 //
     /*  210693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  210704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  210707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210725 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8),
     /*  210728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210740 */     GIR_RootConstrainSelectedInstOperands,
     /*  210741 */     // GIR_Coverage, 23233,
     /*  210741 */     GIR_EraseRootFromParent_Done,
     /*  210742 */   // Label 4220: @210742
     /*  210742 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(210796), // Rule ID 23236 //
     /*  210747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210779 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  210782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210794 */     GIR_RootConstrainSelectedInstOperands,
     /*  210795 */     // GIR_Coverage, 23236,
     /*  210795 */     GIR_EraseRootFromParent_Done,
     /*  210796 */   // Label 4221: @210796
     /*  210796 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(210850), // Rule ID 23237 //
     /*  210801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  210812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  210815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210833 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4),
     /*  210836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210848 */     GIR_RootConstrainSelectedInstOperands,
     /*  210849 */     // GIR_Coverage, 23237,
     /*  210849 */     GIR_EraseRootFromParent_Done,
     /*  210850 */   // Label 4222: @210850
     /*  210850 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(210904), // Rule ID 23240 //
     /*  210855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  210866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210887 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  210890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210902 */     GIR_RootConstrainSelectedInstOperands,
     /*  210903 */     // GIR_Coverage, 23240,
     /*  210903 */     GIR_EraseRootFromParent_Done,
     /*  210904 */   // Label 4223: @210904
     /*  210904 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(210958), // Rule ID 23241 //
     /*  210909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  210912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  210920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  210923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  210926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210941 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  210941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2),
     /*  210944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  210946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  210948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  210953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  210956 */     GIR_RootConstrainSelectedInstOperands,
     /*  210957 */     // GIR_Coverage, 23241,
     /*  210957 */     GIR_EraseRootFromParent_Done,
     /*  210958 */   // Label 4224: @210958
     /*  210958 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(211012), // Rule ID 23244 //
     /*  210963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  210966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  210971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  210974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  210977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  210980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  210988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  210995 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  210995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  210998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211010 */     GIR_RootConstrainSelectedInstOperands,
     /*  211011 */     // GIR_Coverage, 23244,
     /*  211011 */     GIR_EraseRootFromParent_Done,
     /*  211012 */   // Label 4225: @211012
     /*  211012 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(211066), // Rule ID 23245 //
     /*  211017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf),
     /*  211025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211049 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11373:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1),
     /*  211052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211064 */     GIR_RootConstrainSelectedInstOperands,
     /*  211065 */     // GIR_Coverage, 23245,
     /*  211065 */     GIR_EraseRootFromParent_Done,
     /*  211066 */   // Label 4226: @211066
     /*  211066 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(211120), // Rule ID 23248 //
     /*  211071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211118 */     GIR_RootConstrainSelectedInstOperands,
     /*  211119 */     // GIR_Coverage, 23248,
     /*  211119 */     GIR_EraseRootFromParent_Done,
     /*  211120 */   // Label 4227: @211120
     /*  211120 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(211174), // Rule ID 23249 //
     /*  211125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211157 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64),
     /*  211160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211172 */     GIR_RootConstrainSelectedInstOperands,
     /*  211173 */     // GIR_Coverage, 23249,
     /*  211173 */     GIR_EraseRootFromParent_Done,
     /*  211174 */   // Label 4228: @211174
     /*  211174 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(211228), // Rule ID 23252 //
     /*  211179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211211 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211226 */     GIR_RootConstrainSelectedInstOperands,
     /*  211227 */     // GIR_Coverage, 23252,
     /*  211227 */     GIR_EraseRootFromParent_Done,
     /*  211228 */   // Label 4229: @211228
     /*  211228 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(211282), // Rule ID 23253 //
     /*  211233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211265 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32),
     /*  211268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211280 */     GIR_RootConstrainSelectedInstOperands,
     /*  211281 */     // GIR_Coverage, 23253,
     /*  211281 */     GIR_EraseRootFromParent_Done,
     /*  211282 */   // Label 4230: @211282
     /*  211282 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(211336), // Rule ID 23256 //
     /*  211287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211319 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211334 */     GIR_RootConstrainSelectedInstOperands,
     /*  211335 */     // GIR_Coverage, 23256,
     /*  211335 */     GIR_EraseRootFromParent_Done,
     /*  211336 */   // Label 4231: @211336
     /*  211336 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(211390), // Rule ID 23257 //
     /*  211341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  211352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  211355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211373 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16),
     /*  211376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211388 */     GIR_RootConstrainSelectedInstOperands,
     /*  211389 */     // GIR_Coverage, 23257,
     /*  211389 */     GIR_EraseRootFromParent_Done,
     /*  211390 */   // Label 4232: @211390
     /*  211390 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(211444), // Rule ID 23260 //
     /*  211395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211427 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  211430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211442 */     GIR_RootConstrainSelectedInstOperands,
     /*  211443 */     // GIR_Coverage, 23260,
     /*  211443 */     GIR_EraseRootFromParent_Done,
     /*  211444 */   // Label 4233: @211444
     /*  211444 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(211498), // Rule ID 23261 //
     /*  211449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  211460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  211463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8),
     /*  211484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211496 */     GIR_RootConstrainSelectedInstOperands,
     /*  211497 */     // GIR_Coverage, 23261,
     /*  211497 */     GIR_EraseRootFromParent_Done,
     /*  211498 */   // Label 4234: @211498
     /*  211498 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(211552), // Rule ID 23264 //
     /*  211503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211535 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  211538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211550 */     GIR_RootConstrainSelectedInstOperands,
     /*  211551 */     // GIR_Coverage, 23264,
     /*  211551 */     GIR_EraseRootFromParent_Done,
     /*  211552 */   // Label 4235: @211552
     /*  211552 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(211606), // Rule ID 23265 //
     /*  211557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  211568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  211571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211589 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4),
     /*  211592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211604 */     GIR_RootConstrainSelectedInstOperands,
     /*  211605 */     // GIR_Coverage, 23265,
     /*  211605 */     GIR_EraseRootFromParent_Done,
     /*  211606 */   // Label 4236: @211606
     /*  211606 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(211660), // Rule ID 23268 //
     /*  211611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211643 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  211646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211658 */     GIR_RootConstrainSelectedInstOperands,
     /*  211659 */     // GIR_Coverage, 23268,
     /*  211659 */     GIR_EraseRootFromParent_Done,
     /*  211660 */   // Label 4237: @211660
     /*  211660 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(211714), // Rule ID 23269 //
     /*  211665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  211676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  211679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211697 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2),
     /*  211700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211712 */     GIR_RootConstrainSelectedInstOperands,
     /*  211713 */     // GIR_Coverage, 23269,
     /*  211713 */     GIR_EraseRootFromParent_Done,
     /*  211714 */   // Label 4238: @211714
     /*  211714 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(211768), // Rule ID 23272 //
     /*  211719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211751 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  211754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211766 */     GIR_RootConstrainSelectedInstOperands,
     /*  211767 */     // GIR_Coverage, 23272,
     /*  211767 */     GIR_EraseRootFromParent_Done,
     /*  211768 */   // Label 4239: @211768
     /*  211768 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(211822), // Rule ID 23273 //
     /*  211773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif),
     /*  211781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  211784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  211787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211805 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11386:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1),
     /*  211808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211820 */     GIR_RootConstrainSelectedInstOperands,
     /*  211821 */     // GIR_Coverage, 23273,
     /*  211821 */     GIR_EraseRootFromParent_Done,
     /*  211822 */   // Label 4240: @211822
     /*  211822 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(211876), // Rule ID 23276 //
     /*  211827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  211835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  211862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211874 */     GIR_RootConstrainSelectedInstOperands,
     /*  211875 */     // GIR_Coverage, 23276,
     /*  211875 */     GIR_EraseRootFromParent_Done,
     /*  211876 */   // Label 4241: @211876
     /*  211876 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(211930), // Rule ID 23277 //
     /*  211881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  211889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  211892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  211895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  211898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211913 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  211913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64),
     /*  211916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211928 */     GIR_RootConstrainSelectedInstOperands,
     /*  211929 */     // GIR_Coverage, 23277,
     /*  211929 */     GIR_EraseRootFromParent_Done,
     /*  211930 */   // Label 4242: @211930
     /*  211930 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(211984), // Rule ID 23280 //
     /*  211935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  211938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  211943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  211946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  211949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  211952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  211960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  211967 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  211967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  211970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  211972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  211974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  211979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  211982 */     GIR_RootConstrainSelectedInstOperands,
     /*  211983 */     // GIR_Coverage, 23280,
     /*  211983 */     GIR_EraseRootFromParent_Done,
     /*  211984 */   // Label 4243: @211984
     /*  211984 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(212038), // Rule ID 23281 //
     /*  211989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  211992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  211997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  212000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  212003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212021 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32),
     /*  212024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212036 */     GIR_RootConstrainSelectedInstOperands,
     /*  212037 */     // GIR_Coverage, 23281,
     /*  212037 */     GIR_EraseRootFromParent_Done,
     /*  212038 */   // Label 4244: @212038
     /*  212038 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(212092), // Rule ID 23284 //
     /*  212043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212090 */     GIR_RootConstrainSelectedInstOperands,
     /*  212091 */     // GIR_Coverage, 23284,
     /*  212091 */     GIR_EraseRootFromParent_Done,
     /*  212092 */   // Label 4245: @212092
     /*  212092 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(212146), // Rule ID 23285 //
     /*  212097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  212108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  212111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212129 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16),
     /*  212132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212144 */     GIR_RootConstrainSelectedInstOperands,
     /*  212145 */     // GIR_Coverage, 23285,
     /*  212145 */     GIR_EraseRootFromParent_Done,
     /*  212146 */   // Label 4246: @212146
     /*  212146 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(212200), // Rule ID 23288 //
     /*  212151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212183 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212198 */     GIR_RootConstrainSelectedInstOperands,
     /*  212199 */     // GIR_Coverage, 23288,
     /*  212199 */     GIR_EraseRootFromParent_Done,
     /*  212200 */   // Label 4247: @212200
     /*  212200 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(212254), // Rule ID 23289 //
     /*  212205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  212216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  212219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212237 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8),
     /*  212240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212252 */     GIR_RootConstrainSelectedInstOperands,
     /*  212253 */     // GIR_Coverage, 23289,
     /*  212253 */     GIR_EraseRootFromParent_Done,
     /*  212254 */   // Label 4248: @212254
     /*  212254 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(212308), // Rule ID 23292 //
     /*  212259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212291 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212306 */     GIR_RootConstrainSelectedInstOperands,
     /*  212307 */     // GIR_Coverage, 23292,
     /*  212307 */     GIR_EraseRootFromParent_Done,
     /*  212308 */   // Label 4249: @212308
     /*  212308 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(212362), // Rule ID 23293 //
     /*  212313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  212324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  212327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212345 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4),
     /*  212348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212360 */     GIR_RootConstrainSelectedInstOperands,
     /*  212361 */     // GIR_Coverage, 23293,
     /*  212361 */     GIR_EraseRootFromParent_Done,
     /*  212362 */   // Label 4250: @212362
     /*  212362 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(212416), // Rule ID 23296 //
     /*  212367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212399 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212414 */     GIR_RootConstrainSelectedInstOperands,
     /*  212415 */     // GIR_Coverage, 23296,
     /*  212415 */     GIR_EraseRootFromParent_Done,
     /*  212416 */   // Label 4251: @212416
     /*  212416 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(212470), // Rule ID 23297 //
     /*  212421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  212432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  212435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212453 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2),
     /*  212456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212468 */     GIR_RootConstrainSelectedInstOperands,
     /*  212469 */     // GIR_Coverage, 23297,
     /*  212469 */     GIR_EraseRootFromParent_Done,
     /*  212470 */   // Label 4252: @212470
     /*  212470 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(212524), // Rule ID 23300 //
     /*  212475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  212478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212507 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  212507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  212510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212522 */     GIR_RootConstrainSelectedInstOperands,
     /*  212523 */     // GIR_Coverage, 23300,
     /*  212523 */     GIR_EraseRootFromParent_Done,
     /*  212524 */   // Label 4253: @212524
     /*  212524 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(212578), // Rule ID 23301 //
     /*  212529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  212532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof),
     /*  212537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  212540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  212543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212561 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11398:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  212561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1),
     /*  212564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  212568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212576 */     GIR_RootConstrainSelectedInstOperands,
     /*  212577 */     // GIR_Coverage, 23301,
     /*  212577 */     GIR_EraseRootFromParent_Done,
     /*  212578 */   // Label 4254: @212578
     /*  212578 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(212635), // Rule ID 23388 //
     /*  212583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  212594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  212597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212615 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  212615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  212618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212633 */     GIR_RootConstrainSelectedInstOperands,
     /*  212634 */     // GIR_Coverage, 23388,
     /*  212634 */     GIR_EraseRootFromParent_Done,
     /*  212635 */   // Label 4255: @212635
     /*  212635 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(212692), // Rule ID 23389 //
     /*  212640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  212651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  212654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212672 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  212672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  212675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212690 */     GIR_RootConstrainSelectedInstOperands,
     /*  212691 */     // GIR_Coverage, 23389,
     /*  212691 */     GIR_EraseRootFromParent_Done,
     /*  212692 */   // Label 4256: @212692
     /*  212692 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(212749), // Rule ID 23392 //
     /*  212697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  212708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  212711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212729 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  212729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  212732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212747 */     GIR_RootConstrainSelectedInstOperands,
     /*  212748 */     // GIR_Coverage, 23392,
     /*  212748 */     GIR_EraseRootFromParent_Done,
     /*  212749 */   // Label 4257: @212749
     /*  212749 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(212806), // Rule ID 23393 //
     /*  212754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  212765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  212768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  212786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  212789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  212801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212804 */     GIR_RootConstrainSelectedInstOperands,
     /*  212805 */     // GIR_Coverage, 23393,
     /*  212805 */     GIR_EraseRootFromParent_Done,
     /*  212806 */   // Label 4258: @212806
     /*  212806 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(212863), // Rule ID 23396 //
     /*  212811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  212822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  212825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212843 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  212843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  212846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212861 */     GIR_RootConstrainSelectedInstOperands,
     /*  212862 */     // GIR_Coverage, 23396,
     /*  212862 */     GIR_EraseRootFromParent_Done,
     /*  212863 */   // Label 4259: @212863
     /*  212863 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(212920), // Rule ID 23397 //
     /*  212868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  212879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  212882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  212900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4),
     /*  212903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212918 */     GIR_RootConstrainSelectedInstOperands,
     /*  212919 */     // GIR_Coverage, 23397,
     /*  212919 */     GIR_EraseRootFromParent_Done,
     /*  212920 */   // Label 4260: @212920
     /*  212920 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(212977), // Rule ID 23400 //
     /*  212925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  212928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  212936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  212939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  212942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  212950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  212957 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  212957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  212960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  212962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  212964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  212969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  212972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  212975 */     GIR_RootConstrainSelectedInstOperands,
     /*  212976 */     // GIR_Coverage, 23400,
     /*  212976 */     GIR_EraseRootFromParent_Done,
     /*  212977 */   // Label 4261: @212977
     /*  212977 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(213034), // Rule ID 23401 //
     /*  212982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  212985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  212990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  212993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  212996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  212999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213014 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213032 */     GIR_RootConstrainSelectedInstOperands,
     /*  213033 */     // GIR_Coverage, 23401,
     /*  213033 */     GIR_EraseRootFromParent_Done,
     /*  213034 */   // Label 4262: @213034
     /*  213034 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(213091), // Rule ID 23404 //
     /*  213039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213071 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213089 */     GIR_RootConstrainSelectedInstOperands,
     /*  213090 */     // GIR_Coverage, 23404,
     /*  213090 */     GIR_EraseRootFromParent_Done,
     /*  213091 */   // Label 4263: @213091
     /*  213091 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(213148), // Rule ID 23405 //
     /*  213096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  213107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  213110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2),
     /*  213131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213146 */     GIR_RootConstrainSelectedInstOperands,
     /*  213147 */     // GIR_Coverage, 23405,
     /*  213147 */     GIR_EraseRootFromParent_Done,
     /*  213148 */   // Label 4264: @213148
     /*  213148 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(213205), // Rule ID 23408 //
     /*  213153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213185 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213203 */     GIR_RootConstrainSelectedInstOperands,
     /*  213204 */     // GIR_Coverage, 23408,
     /*  213204 */     GIR_EraseRootFromParent_Done,
     /*  213205 */   // Label 4265: @213205
     /*  213205 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(213262), // Rule ID 23409 //
     /*  213210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  213221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  213224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213242 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11252:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213260 */     GIR_RootConstrainSelectedInstOperands,
     /*  213261 */     // GIR_Coverage, 23409,
     /*  213261 */     GIR_EraseRootFromParent_Done,
     /*  213262 */   // Label 4266: @213262
     /*  213262 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(213319), // Rule ID 23412 //
     /*  213267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213299 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213317 */     GIR_RootConstrainSelectedInstOperands,
     /*  213318 */     // GIR_Coverage, 23412,
     /*  213318 */     GIR_EraseRootFromParent_Done,
     /*  213319 */   // Label 4267: @213319
     /*  213319 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(213376), // Rule ID 23413 //
     /*  213324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  213335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  213338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213356 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11252:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  213356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213374 */     GIR_RootConstrainSelectedInstOperands,
     /*  213375 */     // GIR_Coverage, 23413,
     /*  213375 */     GIR_EraseRootFromParent_Done,
     /*  213376 */   // Label 4268: @213376
     /*  213376 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(213433), // Rule ID 23416 //
     /*  213381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213413 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  213413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213431 */     GIR_RootConstrainSelectedInstOperands,
     /*  213432 */     // GIR_Coverage, 23416,
     /*  213432 */     GIR_EraseRootFromParent_Done,
     /*  213433 */   // Label 4269: @213433
     /*  213433 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(213490), // Rule ID 23417 //
     /*  213438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  213449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  213452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213470 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11252:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  213470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  213485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213488 */     GIR_RootConstrainSelectedInstOperands,
     /*  213489 */     // GIR_Coverage, 23417,
     /*  213489 */     GIR_EraseRootFromParent_Done,
     /*  213490 */   // Label 4270: @213490
     /*  213490 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(213547), // Rule ID 23420 //
     /*  213495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  213498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  213506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  213509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213527 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  213527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213545 */     GIR_RootConstrainSelectedInstOperands,
     /*  213546 */     // GIR_Coverage, 23420,
     /*  213546 */     GIR_EraseRootFromParent_Done,
     /*  213547 */   // Label 4271: @213547
     /*  213547 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(213604), // Rule ID 23421 //
     /*  213552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  213555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  213563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  213566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  213577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11252:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  213584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1),
     /*  213587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  213599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213602 */     GIR_RootConstrainSelectedInstOperands,
     /*  213603 */     // GIR_Coverage, 23421,
     /*  213603 */     GIR_EraseRootFromParent_Done,
     /*  213604 */   // Label 4272: @213604
     /*  213604 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(213661), // Rule ID 23424 //
     /*  213609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  213620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  213623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  213644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213659 */     GIR_RootConstrainSelectedInstOperands,
     /*  213660 */     // GIR_Coverage, 23424,
     /*  213660 */     GIR_EraseRootFromParent_Done,
     /*  213661 */   // Label 4273: @213661
     /*  213661 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(213718), // Rule ID 23425 //
     /*  213666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  213677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  213680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  213701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213716 */     GIR_RootConstrainSelectedInstOperands,
     /*  213717 */     // GIR_Coverage, 23425,
     /*  213717 */     GIR_EraseRootFromParent_Done,
     /*  213718 */   // Label 4274: @213718
     /*  213718 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(213775), // Rule ID 23428 //
     /*  213723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  213734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  213737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213755 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  213758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213773 */     GIR_RootConstrainSelectedInstOperands,
     /*  213774 */     // GIR_Coverage, 23428,
     /*  213774 */     GIR_EraseRootFromParent_Done,
     /*  213775 */   // Label 4275: @213775
     /*  213775 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(213832), // Rule ID 23429 //
     /*  213780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  213791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  213794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  213805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213812 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  213815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213830 */     GIR_RootConstrainSelectedInstOperands,
     /*  213831 */     // GIR_Coverage, 23429,
     /*  213831 */     GIR_EraseRootFromParent_Done,
     /*  213832 */   // Label 4276: @213832
     /*  213832 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(213889), // Rule ID 23432 //
     /*  213837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  213848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  213851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213869 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  213869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  213872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213887 */     GIR_RootConstrainSelectedInstOperands,
     /*  213888 */     // GIR_Coverage, 23432,
     /*  213888 */     GIR_EraseRootFromParent_Done,
     /*  213889 */   // Label 4277: @213889
     /*  213889 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(213946), // Rule ID 23433 //
     /*  213894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  213897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  213905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  213908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  213911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  213919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213926 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  213926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  213929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  213941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  213944 */     GIR_RootConstrainSelectedInstOperands,
     /*  213945 */     // GIR_Coverage, 23433,
     /*  213945 */     GIR_EraseRootFromParent_Done,
     /*  213946 */   // Label 4278: @213946
     /*  213946 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(214003), // Rule ID 23436 //
     /*  213951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  213954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  213959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  213962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  213965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  213968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  213976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  213983 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  213983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  213986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  213988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  213990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  213995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  213998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214001 */     GIR_RootConstrainSelectedInstOperands,
     /*  214002 */     // GIR_Coverage, 23436,
     /*  214002 */     GIR_EraseRootFromParent_Done,
     /*  214003 */   // Label 4279: @214003
     /*  214003 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(214060), // Rule ID 23437 //
     /*  214008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  214019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  214022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214040 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214058 */     GIR_RootConstrainSelectedInstOperands,
     /*  214059 */     // GIR_Coverage, 23437,
     /*  214059 */     GIR_EraseRootFromParent_Done,
     /*  214060 */   // Label 4280: @214060
     /*  214060 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(214117), // Rule ID 23440 //
     /*  214065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214097 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214115 */     GIR_RootConstrainSelectedInstOperands,
     /*  214116 */     // GIR_Coverage, 23440,
     /*  214116 */     GIR_EraseRootFromParent_Done,
     /*  214117 */   // Label 4281: @214117
     /*  214117 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(214174), // Rule ID 23441 //
     /*  214122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  214133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  214136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214154 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214172 */     GIR_RootConstrainSelectedInstOperands,
     /*  214173 */     // GIR_Coverage, 23441,
     /*  214173 */     GIR_EraseRootFromParent_Done,
     /*  214174 */   // Label 4282: @214174
     /*  214174 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(214231), // Rule ID 23444 //
     /*  214179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214211 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  214211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214229 */     GIR_RootConstrainSelectedInstOperands,
     /*  214230 */     // GIR_Coverage, 23444,
     /*  214230 */     GIR_EraseRootFromParent_Done,
     /*  214231 */   // Label 4283: @214231
     /*  214231 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(214288), // Rule ID 23445 //
     /*  214236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  214247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  214250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214268 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  214268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  214283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214286 */     GIR_RootConstrainSelectedInstOperands,
     /*  214287 */     // GIR_Coverage, 23445,
     /*  214287 */     GIR_EraseRootFromParent_Done,
     /*  214288 */   // Label 4284: @214288
     /*  214288 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(214345), // Rule ID 23448 //
     /*  214293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214343 */     GIR_RootConstrainSelectedInstOperands,
     /*  214344 */     // GIR_Coverage, 23448,
     /*  214344 */     GIR_EraseRootFromParent_Done,
     /*  214345 */   // Label 4285: @214345
     /*  214345 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(214402), // Rule ID 23449 //
     /*  214350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  214361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  214364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214400 */     GIR_RootConstrainSelectedInstOperands,
     /*  214401 */     // GIR_Coverage, 23449,
     /*  214401 */     GIR_EraseRootFromParent_Done,
     /*  214402 */   // Label 4286: @214402
     /*  214402 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(214459), // Rule ID 23452 //
     /*  214407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214439 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214457 */     GIR_RootConstrainSelectedInstOperands,
     /*  214458 */     // GIR_Coverage, 23452,
     /*  214458 */     GIR_EraseRootFromParent_Done,
     /*  214459 */   // Label 4287: @214459
     /*  214459 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(214516), // Rule ID 23453 //
     /*  214464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  214475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  214478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214514 */     GIR_RootConstrainSelectedInstOperands,
     /*  214515 */     // GIR_Coverage, 23453,
     /*  214515 */     GIR_EraseRootFromParent_Done,
     /*  214516 */   // Label 4288: @214516
     /*  214516 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(214573), // Rule ID 23456 //
     /*  214521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  214524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  214532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  214535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214553 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  214553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214571 */     GIR_RootConstrainSelectedInstOperands,
     /*  214572 */     // GIR_Coverage, 23456,
     /*  214572 */     GIR_EraseRootFromParent_Done,
     /*  214573 */   // Label 4289: @214573
     /*  214573 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(214630), // Rule ID 23457 //
     /*  214578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  214581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  214589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  214592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  214610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  214625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214628 */     GIR_RootConstrainSelectedInstOperands,
     /*  214629 */     // GIR_Coverage, 23457,
     /*  214629 */     GIR_EraseRootFromParent_Done,
     /*  214630 */   // Label 4290: @214630
     /*  214630 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(214687), // Rule ID 23460 //
     /*  214635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  214646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  214649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214685 */     GIR_RootConstrainSelectedInstOperands,
     /*  214686 */     // GIR_Coverage, 23460,
     /*  214686 */     GIR_EraseRootFromParent_Done,
     /*  214687 */   // Label 4291: @214687
     /*  214687 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(214744), // Rule ID 23461 //
     /*  214692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  214703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  214706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  214717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11252:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2),
     /*  214727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214742 */     GIR_RootConstrainSelectedInstOperands,
     /*  214743 */     // GIR_Coverage, 23461,
     /*  214743 */     GIR_EraseRootFromParent_Done,
     /*  214744 */   // Label 4292: @214744
     /*  214744 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(214801), // Rule ID 23464 //
     /*  214749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  214760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  214763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214781 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214799 */     GIR_RootConstrainSelectedInstOperands,
     /*  214800 */     // GIR_Coverage, 23464,
     /*  214800 */     GIR_EraseRootFromParent_Done,
     /*  214801 */   // Label 4293: @214801
     /*  214801 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(214858), // Rule ID 23465 //
     /*  214806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  214817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  214820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  214831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11252:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4),
     /*  214841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214856 */     GIR_RootConstrainSelectedInstOperands,
     /*  214857 */     // GIR_Coverage, 23465,
     /*  214857 */     GIR_EraseRootFromParent_Done,
     /*  214858 */   // Label 4294: @214858
     /*  214858 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(214915), // Rule ID 23468 //
     /*  214863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  214866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  214874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  214877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  214880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214895 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  214895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214913 */     GIR_RootConstrainSelectedInstOperands,
     /*  214914 */     // GIR_Coverage, 23468,
     /*  214914 */     GIR_EraseRootFromParent_Done,
     /*  214915 */   // Label 4295: @214915
     /*  214915 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(214972), // Rule ID 23469 //
     /*  214920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  214923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid),
     /*  214928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  214931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  214934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  214937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  214945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  214952 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11252:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVID_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  214952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8),
     /*  214955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  214957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  214959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  214964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  214967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  214970 */     GIR_RootConstrainSelectedInstOperands,
     /*  214971 */     // GIR_Coverage, 23469,
     /*  214971 */     GIR_EraseRootFromParent_Done,
     /*  214972 */   // Label 4296: @214972
     /*  214972 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(215018), // Rule ID 2543 //
     /*  214977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  214980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks1i),
     /*  214985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  214988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  214991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  214999 */     // MIs[0] rnum
     /*  214999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  215002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_rnum),
     /*  215007 */     // (intrinsic_wo_chain:{ *:[i64] } 10909:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)  =>  (AES64KS1I:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_rnum>>:$rnum)
     /*  215007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS1I),
     /*  215010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rnum
     /*  215016 */     GIR_RootConstrainSelectedInstOperands,
     /*  215017 */     // GIR_Coverage, 2543,
     /*  215017 */     GIR_EraseRootFromParent_Done,
     /*  215018 */   // Label 4297: @215018
     /*  215018 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(215063), // Rule ID 64423 //
     /*  215023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clip),
     /*  215031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215052 */     // (intrinsic_wo_chain:{ *:[i32] } 10919:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPR),
     /*  215055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215061 */     GIR_RootConstrainSelectedInstOperands,
     /*  215062 */     // GIR_Coverage, 64423,
     /*  215062 */     GIR_EraseRootFromParent_Done,
     /*  215063 */   // Label 4298: @215063
     /*  215063 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(215108), // Rule ID 64450 //
     /*  215068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  215071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_clipu),
     /*  215076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215097 */     // (intrinsic_wo_chain:{ *:[i32] } 10920:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_CLIPUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_CLIPUR),
     /*  215100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215106 */     GIR_RootConstrainSelectedInstOperands,
     /*  215107 */     // GIR_Coverage, 64450,
     /*  215107 */     GIR_EraseRootFromParent_Done,
     /*  215108 */   // Label 4299: @215108
     /*  215108 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(215153), // Rule ID 2533 //
     /*  215113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215142 */     // (intrinsic_wo_chain:{ *:[i64] } 11610:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM4:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215151 */     GIR_RootConstrainSelectedInstOperands,
     /*  215152 */     // GIR_Coverage, 2533,
     /*  215152 */     GIR_EraseRootFromParent_Done,
     /*  215153 */   // Label 4300: @215153
     /*  215153 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(215198), // Rule ID 2534 //
     /*  215158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm4),
     /*  215166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215187 */     // (intrinsic_wo_chain:{ *:[i32] } 11610:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM4:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM4),
     /*  215190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215196 */     GIR_RootConstrainSelectedInstOperands,
     /*  215197 */     // GIR_Coverage, 2534,
     /*  215197 */     GIR_EraseRootFromParent_Done,
     /*  215198 */   // Label 4301: @215198
     /*  215198 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(215243), // Rule ID 2535 //
     /*  215203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode0),
     /*  215206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215232 */     // (intrinsic_wo_chain:{ *:[i64] } 11611:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (XPERM8:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215241 */     GIR_RootConstrainSelectedInstOperands,
     /*  215242 */     // GIR_Coverage, 2535,
     /*  215242 */     GIR_EraseRootFromParent_Done,
     /*  215243 */   // Label 4302: @215243
     /*  215243 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(215288), // Rule ID 2536 //
     /*  215248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkx_HwMode1),
     /*  215251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_xperm8),
     /*  215256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215277 */     // (intrinsic_wo_chain:{ *:[i32] } 11611:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (XPERM8:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XPERM8),
     /*  215280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215286 */     GIR_RootConstrainSelectedInstOperands,
     /*  215287 */     // GIR_Coverage, 2536,
     /*  215287 */     GIR_EraseRootFromParent_Done,
     /*  215288 */   // Label 4303: @215288
     /*  215288 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(215333), // Rule ID 2539 //
     /*  215293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ds),
     /*  215301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215322 */     // (intrinsic_wo_chain:{ *:[i64] } 10904:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DS:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DS),
     /*  215325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215331 */     GIR_RootConstrainSelectedInstOperands,
     /*  215332 */     // GIR_Coverage, 2539,
     /*  215332 */     GIR_EraseRootFromParent_Done,
     /*  215333 */   // Label 4304: @215333
     /*  215333 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(215378), // Rule ID 2540 //
     /*  215338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV64_HwMode0),
     /*  215341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64dsm),
     /*  215346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215367 */     // (intrinsic_wo_chain:{ *:[i64] } 10905:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64DSM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64DSM),
     /*  215370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215376 */     GIR_RootConstrainSelectedInstOperands,
     /*  215377 */     // GIR_Coverage, 2540,
     /*  215377 */     GIR_EraseRootFromParent_Done,
     /*  215378 */   // Label 4305: @215378
     /*  215378 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(215423), // Rule ID 2542 //
     /*  215383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkndOrZkne_IsRV64_HwMode0),
     /*  215386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64ks2),
     /*  215391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215412 */     // (intrinsic_wo_chain:{ *:[i64] } 10910:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64KS2:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64KS2),
     /*  215415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215421 */     GIR_RootConstrainSelectedInstOperands,
     /*  215422 */     // GIR_Coverage, 2542,
     /*  215422 */     GIR_EraseRootFromParent_Done,
     /*  215423 */   // Label 4306: @215423
     /*  215423 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(215468), // Rule ID 2546 //
     /*  215428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64es),
     /*  215436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215457 */     // (intrinsic_wo_chain:{ *:[i64] } 10906:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ES:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ES),
     /*  215460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215466 */     GIR_RootConstrainSelectedInstOperands,
     /*  215467 */     // GIR_Coverage, 2546,
     /*  215467 */     GIR_EraseRootFromParent_Done,
     /*  215468 */   // Label 4307: @215468
     /*  215468 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(215513), // Rule ID 2547 //
     /*  215473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV64_HwMode0),
     /*  215476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes64esm),
     /*  215481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  215484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  215487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215502 */     // (intrinsic_wo_chain:{ *:[i64] } 10907:{ *:[iPTR] }, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (AES64ESM:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /*  215502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES64ESM),
     /*  215505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215511 */     GIR_RootConstrainSelectedInstOperands,
     /*  215512 */     // GIR_Coverage, 2547,
     /*  215512 */     GIR_EraseRootFromParent_Done,
     /*  215513 */   // Label 4308: @215513
     /*  215513 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(215558), // Rule ID 2556 //
     /*  215518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0l),
     /*  215526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215547 */     // (intrinsic_wo_chain:{ *:[i32] } 11046:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0L),
     /*  215550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215556 */     GIR_RootConstrainSelectedInstOperands,
     /*  215557 */     // GIR_Coverage, 2556,
     /*  215557 */     GIR_EraseRootFromParent_Done,
     /*  215558 */   // Label 4309: @215558
     /*  215558 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(215603), // Rule ID 2557 //
     /*  215563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig0h),
     /*  215571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215592 */     // (intrinsic_wo_chain:{ *:[i32] } 11045:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG0H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG0H),
     /*  215595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215601 */     GIR_RootConstrainSelectedInstOperands,
     /*  215602 */     // GIR_Coverage, 2557,
     /*  215602 */     GIR_EraseRootFromParent_Done,
     /*  215603 */   // Label 4310: @215603
     /*  215603 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(215648), // Rule ID 2558 //
     /*  215608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1l),
     /*  215616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215637 */     // (intrinsic_wo_chain:{ *:[i32] } 11049:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1L:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1L),
     /*  215640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215646 */     GIR_RootConstrainSelectedInstOperands,
     /*  215647 */     // GIR_Coverage, 2558,
     /*  215647 */     GIR_EraseRootFromParent_Done,
     /*  215648 */   // Label 4311: @215648
     /*  215648 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(215693), // Rule ID 2559 //
     /*  215653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sig1h),
     /*  215661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215682 */     // (intrinsic_wo_chain:{ *:[i32] } 11048:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SIG1H:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SIG1H),
     /*  215685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215691 */     GIR_RootConstrainSelectedInstOperands,
     /*  215692 */     // GIR_Coverage, 2559,
     /*  215692 */     GIR_EraseRootFromParent_Done,
     /*  215693 */   // Label 4312: @215693
     /*  215693 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(215738), // Rule ID 2560 //
     /*  215698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum0r),
     /*  215706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215727 */     // (intrinsic_wo_chain:{ *:[i32] } 11051:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM0R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM0R),
     /*  215730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215736 */     GIR_RootConstrainSelectedInstOperands,
     /*  215737 */     // GIR_Coverage, 2560,
     /*  215737 */     GIR_EraseRootFromParent_Done,
     /*  215738 */   // Label 4313: @215738
     /*  215738 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(215783), // Rule ID 2561 //
     /*  215743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknh_IsRV32_HwMode1),
     /*  215746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sha512sum1r),
     /*  215751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215772 */     // (intrinsic_wo_chain:{ *:[i32] } 11053:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (SHA512SUM1R:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SHA512SUM1R),
     /*  215775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215781 */     GIR_RootConstrainSelectedInstOperands,
     /*  215782 */     // GIR_Coverage, 2561,
     /*  215782 */     GIR_EraseRootFromParent_Done,
     /*  215783 */   // Label 4314: @215783
     /*  215783 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(215828), // Rule ID 64400 //
     /*  215788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  215791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extract),
     /*  215796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215817 */     // (intrinsic_wo_chain:{ *:[i32] } 10929:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTR),
     /*  215820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215826 */     GIR_RootConstrainSelectedInstOperands,
     /*  215827 */     // GIR_Coverage, 64400,
     /*  215827 */     GIR_EraseRootFromParent_Done,
     /*  215828 */   // Label 4315: @215828
     /*  215828 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(215873), // Rule ID 64402 //
     /*  215833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  215836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_extractu),
     /*  215841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215862 */     // (intrinsic_wo_chain:{ *:[i32] } 10930:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_EXTRACTUR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTRACTUR),
     /*  215865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215871 */     GIR_RootConstrainSelectedInstOperands,
     /*  215872 */     // GIR_Coverage, 64402,
     /*  215872 */     GIR_EraseRootFromParent_Done,
     /*  215873 */   // Label 4316: @215873
     /*  215873 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(215918), // Rule ID 64404 //
     /*  215878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  215881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bclr),
     /*  215886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215907 */     // (intrinsic_wo_chain:{ *:[i32] } 10925:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BCLRR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BCLRR),
     /*  215910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215916 */     GIR_RootConstrainSelectedInstOperands,
     /*  215917 */     // GIR_Coverage, 64404,
     /*  215917 */     GIR_EraseRootFromParent_Done,
     /*  215918 */   // Label 4317: @215918
     /*  215918 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(215963), // Rule ID 64406 //
     /*  215923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  215926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bset),
     /*  215931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  215934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  215937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  215940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  215952 */     // (intrinsic_wo_chain:{ *:[i32] } 10927:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_BSETR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  215952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BSETR),
     /*  215955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  215957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  215959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  215961 */     GIR_RootConstrainSelectedInstOperands,
     /*  215962 */     // GIR_Coverage, 64406,
     /*  215962 */     GIR_EraseRootFromParent_Done,
     /*  215963 */   // Label 4318: @215963
     /*  215963 */   GIM_Reject,
     /*  215964 */ // Label 4182: @215964
     /*  215964 */ GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(386869),
     /*  215969 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  215972 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(216046), // Rule ID 5346 //
     /*  215977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  215980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  215985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  215988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  215991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  215994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  215997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216017 */     // MIs[1] Operand 1
     /*  216017 */     // No operand predicates
     /*  216017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216026 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216044 */     GIR_RootConstrainSelectedInstOperands,
     /*  216045 */     // GIR_Coverage, 5346,
     /*  216045 */     GIR_EraseRootFromParent_Done,
     /*  216046 */   // Label 4320: @216046
     /*  216046 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(216120), // Rule ID 5347 //
     /*  216051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  216065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216091 */     // MIs[1] Operand 1
     /*  216091 */     // No operand predicates
     /*  216091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216100 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF8),
     /*  216103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216118 */     GIR_RootConstrainSelectedInstOperands,
     /*  216119 */     // GIR_Coverage, 5347,
     /*  216119 */     GIR_EraseRootFromParent_Done,
     /*  216120 */   // Label 4321: @216120
     /*  216120 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(216194), // Rule ID 5348 //
     /*  216125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216165 */     // MIs[1] Operand 1
     /*  216165 */     // No operand predicates
     /*  216165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216174 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216192 */     GIR_RootConstrainSelectedInstOperands,
     /*  216193 */     // GIR_Coverage, 5348,
     /*  216193 */     GIR_EraseRootFromParent_Done,
     /*  216194 */   // Label 4322: @216194
     /*  216194 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(216268), // Rule ID 5349 //
     /*  216199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  216213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216239 */     // MIs[1] Operand 1
     /*  216239 */     // No operand predicates
     /*  216239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216248 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216266 */     GIR_RootConstrainSelectedInstOperands,
     /*  216267 */     // GIR_Coverage, 5349,
     /*  216267 */     GIR_EraseRootFromParent_Done,
     /*  216268 */   // Label 4323: @216268
     /*  216268 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(216342), // Rule ID 5350 //
     /*  216273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216313 */     // MIs[1] Operand 1
     /*  216313 */     // No operand predicates
     /*  216313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216322 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216340 */     GIR_RootConstrainSelectedInstOperands,
     /*  216341 */     // GIR_Coverage, 5350,
     /*  216341 */     GIR_EraseRootFromParent_Done,
     /*  216342 */   // Label 4324: @216342
     /*  216342 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(216416), // Rule ID 5351 //
     /*  216347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  216358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  216361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216387 */     // MIs[1] Operand 1
     /*  216387 */     // No operand predicates
     /*  216387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216414 */     GIR_RootConstrainSelectedInstOperands,
     /*  216415 */     // GIR_Coverage, 5351,
     /*  216415 */     GIR_EraseRootFromParent_Done,
     /*  216416 */   // Label 4325: @216416
     /*  216416 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(216490), // Rule ID 5352 //
     /*  216421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216461 */     // MIs[1] Operand 1
     /*  216461 */     // No operand predicates
     /*  216461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216470 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  216470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216488 */     GIR_RootConstrainSelectedInstOperands,
     /*  216489 */     // GIR_Coverage, 5352,
     /*  216489 */     GIR_EraseRootFromParent_Done,
     /*  216490 */   // Label 4326: @216490
     /*  216490 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(216564), // Rule ID 5353 //
     /*  216495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  216509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216535 */     // MIs[1] Operand 1
     /*  216535 */     // No operand predicates
     /*  216535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  216544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF4),
     /*  216547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216562 */     GIR_RootConstrainSelectedInstOperands,
     /*  216563 */     // GIR_Coverage, 5353,
     /*  216563 */     GIR_EraseRootFromParent_Done,
     /*  216564 */   // Label 4327: @216564
     /*  216564 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(216638), // Rule ID 5354 //
     /*  216569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  216583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216609 */     // MIs[1] Operand 1
     /*  216609 */     // No operand predicates
     /*  216609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  216618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216636 */     GIR_RootConstrainSelectedInstOperands,
     /*  216637 */     // GIR_Coverage, 5354,
     /*  216637 */     GIR_EraseRootFromParent_Done,
     /*  216638 */   // Label 4328: @216638
     /*  216638 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(216712), // Rule ID 5355 //
     /*  216643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  216654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  216657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216683 */     // MIs[1] Operand 1
     /*  216683 */     // No operand predicates
     /*  216683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  216692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  216710 */     GIR_RootConstrainSelectedInstOperands,
     /*  216711 */     // GIR_Coverage, 5355,
     /*  216711 */     GIR_EraseRootFromParent_Done,
     /*  216712 */   // Label 4329: @216712
     /*  216712 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(216786), // Rule ID 5356 //
     /*  216717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  216731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216757 */     // MIs[1] Operand 1
     /*  216757 */     // No operand predicates
     /*  216757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216766 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  216766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216784 */     GIR_RootConstrainSelectedInstOperands,
     /*  216785 */     // GIR_Coverage, 5356,
     /*  216785 */     GIR_EraseRootFromParent_Done,
     /*  216786 */   // Label 4330: @216786
     /*  216786 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(216860), // Rule ID 5357 //
     /*  216791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  216802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  216805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216831 */     // MIs[1] Operand 1
     /*  216831 */     // No operand predicates
     /*  216831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  216840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_MF2),
     /*  216843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  216858 */     GIR_RootConstrainSelectedInstOperands,
     /*  216859 */     // GIR_Coverage, 5357,
     /*  216859 */     GIR_EraseRootFromParent_Done,
     /*  216860 */   // Label 4331: @216860
     /*  216860 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(216934), // Rule ID 5358 //
     /*  216865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  216868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  216879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  216882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  216885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216905 */     // MIs[1] Operand 1
     /*  216905 */     // No operand predicates
     /*  216905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  216914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  216917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  216929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  216932 */     GIR_RootConstrainSelectedInstOperands,
     /*  216933 */     // GIR_Coverage, 5358,
     /*  216933 */     GIR_EraseRootFromParent_Done,
     /*  216934 */   // Label 4332: @216934
     /*  216934 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(217008), // Rule ID 5359 //
     /*  216939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  216942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  216947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  216950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  216953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  216956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  216959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  216967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  216971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  216975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  216979 */     // MIs[1] Operand 1
     /*  216979 */     // No operand predicates
     /*  216979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  216981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  216988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  216988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  216991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  216993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  216995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  216998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217006 */     GIR_RootConstrainSelectedInstOperands,
     /*  217007 */     // GIR_Coverage, 5359,
     /*  217007 */     GIR_EraseRootFromParent_Done,
     /*  217008 */   // Label 4333: @217008
     /*  217008 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(217082), // Rule ID 5360 //
     /*  217013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217053 */     // MIs[1] Operand 1
     /*  217053 */     // No operand predicates
     /*  217053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217062 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217080 */     GIR_RootConstrainSelectedInstOperands,
     /*  217081 */     // GIR_Coverage, 5360,
     /*  217081 */     GIR_EraseRootFromParent_Done,
     /*  217082 */   // Label 4334: @217082
     /*  217082 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(217156), // Rule ID 5361 //
     /*  217087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  217098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  217101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217127 */     // MIs[1] Operand 1
     /*  217127 */     // No operand predicates
     /*  217127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  217136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217154 */     GIR_RootConstrainSelectedInstOperands,
     /*  217155 */     // GIR_Coverage, 5361,
     /*  217155 */     GIR_EraseRootFromParent_Done,
     /*  217156 */   // Label 4335: @217156
     /*  217156 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(217230), // Rule ID 5362 //
     /*  217161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217201 */     // MIs[1] Operand 1
     /*  217201 */     // No operand predicates
     /*  217201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  217210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217228 */     GIR_RootConstrainSelectedInstOperands,
     /*  217229 */     // GIR_Coverage, 5362,
     /*  217229 */     GIR_EraseRootFromParent_Done,
     /*  217230 */   // Label 4336: @217230
     /*  217230 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(217304), // Rule ID 5363 //
     /*  217235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  217246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  217249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217275 */     // MIs[1] Operand 1
     /*  217275 */     // No operand predicates
     /*  217275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  217284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  217302 */     GIR_RootConstrainSelectedInstOperands,
     /*  217303 */     // GIR_Coverage, 5363,
     /*  217303 */     GIR_EraseRootFromParent_Done,
     /*  217304 */   // Label 4337: @217304
     /*  217304 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(217378), // Rule ID 5364 //
     /*  217309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  217312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217349 */     // MIs[1] Operand 1
     /*  217349 */     // No operand predicates
     /*  217349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217358 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  217358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217376 */     GIR_RootConstrainSelectedInstOperands,
     /*  217377 */     // GIR_Coverage, 5364,
     /*  217377 */     GIR_EraseRootFromParent_Done,
     /*  217378 */   // Label 4338: @217378
     /*  217378 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(217452), // Rule ID 5365 //
     /*  217383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  217386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  217394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  217397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217423 */     // MIs[1] Operand 1
     /*  217423 */     // No operand predicates
     /*  217423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  217432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M1),
     /*  217435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  217450 */     GIR_RootConstrainSelectedInstOperands,
     /*  217451 */     // GIR_Coverage, 5365,
     /*  217451 */     GIR_EraseRootFromParent_Done,
     /*  217452 */   // Label 4339: @217452
     /*  217452 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(217526), // Rule ID 5366 //
     /*  217457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  217468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217497 */     // MIs[1] Operand 1
     /*  217497 */     // No operand predicates
     /*  217497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217506 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  217509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217524 */     GIR_RootConstrainSelectedInstOperands,
     /*  217525 */     // GIR_Coverage, 5366,
     /*  217525 */     GIR_EraseRootFromParent_Done,
     /*  217526 */   // Label 4340: @217526
     /*  217526 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(217600), // Rule ID 5367 //
     /*  217531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  217542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  217545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217571 */     // MIs[1] Operand 1
     /*  217571 */     // No operand predicates
     /*  217571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217580 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  217583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217598 */     GIR_RootConstrainSelectedInstOperands,
     /*  217599 */     // GIR_Coverage, 5367,
     /*  217599 */     GIR_EraseRootFromParent_Done,
     /*  217600 */   // Label 4341: @217600
     /*  217600 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(217674), // Rule ID 5368 //
     /*  217605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  217616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  217619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217645 */     // MIs[1] Operand 1
     /*  217645 */     // No operand predicates
     /*  217645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217654 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  217657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217672 */     GIR_RootConstrainSelectedInstOperands,
     /*  217673 */     // GIR_Coverage, 5368,
     /*  217673 */     GIR_EraseRootFromParent_Done,
     /*  217674 */   // Label 4342: @217674
     /*  217674 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(217748), // Rule ID 5369 //
     /*  217679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  217690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  217693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  217707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217719 */     // MIs[1] Operand 1
     /*  217719 */     // No operand predicates
     /*  217719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217728 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  217731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217746 */     GIR_RootConstrainSelectedInstOperands,
     /*  217747 */     // GIR_Coverage, 5369,
     /*  217747 */     GIR_EraseRootFromParent_Done,
     /*  217748 */   // Label 4343: @217748
     /*  217748 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(217822), // Rule ID 5370 //
     /*  217753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  217764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  217767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  217781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217793 */     // MIs[1] Operand 1
     /*  217793 */     // No operand predicates
     /*  217793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217802 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  217802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  217805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217820 */     GIR_RootConstrainSelectedInstOperands,
     /*  217821 */     // GIR_Coverage, 5370,
     /*  217821 */     GIR_EraseRootFromParent_Done,
     /*  217822 */   // Label 4344: @217822
     /*  217822 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(217896), // Rule ID 5371 //
     /*  217827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  217838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  217841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  217855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217867 */     // MIs[1] Operand 1
     /*  217867 */     // No operand predicates
     /*  217867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217876 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  217876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  217879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  217894 */     GIR_RootConstrainSelectedInstOperands,
     /*  217895 */     // GIR_Coverage, 5371,
     /*  217895 */     GIR_EraseRootFromParent_Done,
     /*  217896 */   // Label 4345: @217896
     /*  217896 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(217970), // Rule ID 5372 //
     /*  217901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  217904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  217915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  217918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  217921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  217929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  217933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  217937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  217941 */     // MIs[1] Operand 1
     /*  217941 */     // No operand predicates
     /*  217941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  217943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  217950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  217950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  217953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  217955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  217957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  217960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  217965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  217968 */     GIR_RootConstrainSelectedInstOperands,
     /*  217969 */     // GIR_Coverage, 5372,
     /*  217969 */     GIR_EraseRootFromParent_Done,
     /*  217970 */   // Label 4346: @217970
     /*  217970 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(218044), // Rule ID 5373 //
     /*  217975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  217978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  217983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  217986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  217989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  217992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  217995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  217999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218015 */     // MIs[1] Operand 1
     /*  218015 */     // No operand predicates
     /*  218015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218042 */     GIR_RootConstrainSelectedInstOperands,
     /*  218043 */     // GIR_Coverage, 5373,
     /*  218043 */     GIR_EraseRootFromParent_Done,
     /*  218044 */   // Label 4347: @218044
     /*  218044 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(218118), // Rule ID 5374 //
     /*  218049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218089 */     // MIs[1] Operand 1
     /*  218089 */     // No operand predicates
     /*  218089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218098 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218116 */     GIR_RootConstrainSelectedInstOperands,
     /*  218117 */     // GIR_Coverage, 5374,
     /*  218117 */     GIR_EraseRootFromParent_Done,
     /*  218118 */   // Label 4348: @218118
     /*  218118 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(218192), // Rule ID 5375 //
     /*  218123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  218137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218163 */     // MIs[1] Operand 1
     /*  218163 */     // No operand predicates
     /*  218163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218190 */     GIR_RootConstrainSelectedInstOperands,
     /*  218191 */     // GIR_Coverage, 5375,
     /*  218191 */     GIR_EraseRootFromParent_Done,
     /*  218192 */   // Label 4349: @218192
     /*  218192 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(218266), // Rule ID 5376 //
     /*  218197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218237 */     // MIs[1] Operand 1
     /*  218237 */     // No operand predicates
     /*  218237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218246 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  218246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218264 */     GIR_RootConstrainSelectedInstOperands,
     /*  218265 */     // GIR_Coverage, 5376,
     /*  218265 */     GIR_EraseRootFromParent_Done,
     /*  218266 */   // Label 4350: @218266
     /*  218266 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(218340), // Rule ID 5377 //
     /*  218271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  218282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  218285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218311 */     // MIs[1] Operand 1
     /*  218311 */     // No operand predicates
     /*  218311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218320 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  218320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  218338 */     GIR_RootConstrainSelectedInstOperands,
     /*  218339 */     // GIR_Coverage, 5377,
     /*  218339 */     GIR_EraseRootFromParent_Done,
     /*  218340 */   // Label 4351: @218340
     /*  218340 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(218414), // Rule ID 5378 //
     /*  218345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218385 */     // MIs[1] Operand 1
     /*  218385 */     // No operand predicates
     /*  218385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218412 */     GIR_RootConstrainSelectedInstOperands,
     /*  218413 */     // GIR_Coverage, 5378,
     /*  218413 */     GIR_EraseRootFromParent_Done,
     /*  218414 */   // Label 4352: @218414
     /*  218414 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(218488), // Rule ID 5379 //
     /*  218419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  218433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218459 */     // MIs[1] Operand 1
     /*  218459 */     // No operand predicates
     /*  218459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218468 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218486 */     GIR_RootConstrainSelectedInstOperands,
     /*  218487 */     // GIR_Coverage, 5379,
     /*  218487 */     GIR_EraseRootFromParent_Done,
     /*  218488 */   // Label 4353: @218488
     /*  218488 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(218562), // Rule ID 5380 //
     /*  218493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218533 */     // MIs[1] Operand 1
     /*  218533 */     // No operand predicates
     /*  218533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218542 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218560 */     GIR_RootConstrainSelectedInstOperands,
     /*  218561 */     // GIR_Coverage, 5380,
     /*  218561 */     GIR_EraseRootFromParent_Done,
     /*  218562 */   // Label 4354: @218562
     /*  218562 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(218636), // Rule ID 5381 //
     /*  218567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  218578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  218581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218607 */     // MIs[1] Operand 1
     /*  218607 */     // No operand predicates
     /*  218607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218634 */     GIR_RootConstrainSelectedInstOperands,
     /*  218635 */     // GIR_Coverage, 5381,
     /*  218635 */     GIR_EraseRootFromParent_Done,
     /*  218636 */   // Label 4355: @218636
     /*  218636 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(218710), // Rule ID 5382 //
     /*  218641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  218644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218681 */     // MIs[1] Operand 1
     /*  218681 */     // No operand predicates
     /*  218681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218690 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  218690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218708 */     GIR_RootConstrainSelectedInstOperands,
     /*  218709 */     // GIR_Coverage, 5382,
     /*  218709 */     GIR_EraseRootFromParent_Done,
     /*  218710 */   // Label 4356: @218710
     /*  218710 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(218784), // Rule ID 5383 //
     /*  218715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  218718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  218726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  218729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  218743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218755 */     // MIs[1] Operand 1
     /*  218755 */     // No operand predicates
     /*  218755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  218764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  218767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  218782 */     GIR_RootConstrainSelectedInstOperands,
     /*  218783 */     // GIR_Coverage, 5383,
     /*  218783 */     GIR_EraseRootFromParent_Done,
     /*  218784 */   // Label 4357: @218784
     /*  218784 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(218858), // Rule ID 5384 //
     /*  218789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  218803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218829 */     // MIs[1] Operand 1
     /*  218829 */     // No operand predicates
     /*  218829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218838 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  218838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218856 */     GIR_RootConstrainSelectedInstOperands,
     /*  218857 */     // GIR_Coverage, 5384,
     /*  218857 */     GIR_EraseRootFromParent_Done,
     /*  218858 */   // Label 4358: @218858
     /*  218858 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(218932), // Rule ID 5385 //
     /*  218863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  218866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  218874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  218877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  218880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  218883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  218891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218903 */     // MIs[1] Operand 1
     /*  218903 */     // No operand predicates
     /*  218903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  218912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M2),
     /*  218915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  218927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  218930 */     GIR_RootConstrainSelectedInstOperands,
     /*  218931 */     // GIR_Coverage, 5385,
     /*  218931 */     GIR_EraseRootFromParent_Done,
     /*  218932 */   // Label 4359: @218932
     /*  218932 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(219006), // Rule ID 5386 //
     /*  218937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  218940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  218945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  218948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  218951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  218954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  218957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  218961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  218965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  218969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  218973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  218977 */     // MIs[1] Operand 1
     /*  218977 */     // No operand predicates
     /*  218977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  218979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  218986 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  218986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  218989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  218991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  218993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  218996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219004 */     GIR_RootConstrainSelectedInstOperands,
     /*  219005 */     // GIR_Coverage, 5386,
     /*  219005 */     GIR_EraseRootFromParent_Done,
     /*  219006 */   // Label 4360: @219006
     /*  219006 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(219080), // Rule ID 5387 //
     /*  219011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  219025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  219039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219051 */     // MIs[1] Operand 1
     /*  219051 */     // No operand predicates
     /*  219051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M4),
     /*  219063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219078 */     GIR_RootConstrainSelectedInstOperands,
     /*  219079 */     // GIR_Coverage, 5387,
     /*  219079 */     GIR_EraseRootFromParent_Done,
     /*  219080 */   // Label 4361: @219080
     /*  219080 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(219154), // Rule ID 5388 //
     /*  219085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  219088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219125 */     // MIs[1] Operand 1
     /*  219125 */     // No operand predicates
     /*  219125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219134 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  219134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219152 */     GIR_RootConstrainSelectedInstOperands,
     /*  219153 */     // GIR_Coverage, 5388,
     /*  219153 */     GIR_EraseRootFromParent_Done,
     /*  219154 */   // Label 4362: @219154
     /*  219154 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(219228), // Rule ID 5389 //
     /*  219159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  219162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  219167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  219170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  219173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  219187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219199 */     // MIs[1] Operand 1
     /*  219199 */     // No operand predicates
     /*  219199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  219208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VI_M8),
     /*  219211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  219226 */     GIR_RootConstrainSelectedInstOperands,
     /*  219227 */     // GIR_Coverage, 5389,
     /*  219227 */     GIR_EraseRootFromParent_Done,
     /*  219228 */   // Label 4363: @219228
     /*  219228 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(219302), // Rule ID 7858 //
     /*  219233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219273 */     // MIs[1] Operand 1
     /*  219273 */     // No operand predicates
     /*  219273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219282 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219300 */     GIR_RootConstrainSelectedInstOperands,
     /*  219301 */     // GIR_Coverage, 7858,
     /*  219301 */     GIR_EraseRootFromParent_Done,
     /*  219302 */   // Label 4364: @219302
     /*  219302 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(219376), // Rule ID 7859 //
     /*  219307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  219321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219347 */     // MIs[1] Operand 1
     /*  219347 */     // No operand predicates
     /*  219347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  219356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8),
     /*  219359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219374 */     GIR_RootConstrainSelectedInstOperands,
     /*  219375 */     // GIR_Coverage, 7859,
     /*  219375 */     GIR_EraseRootFromParent_Done,
     /*  219376 */   // Label 4365: @219376
     /*  219376 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(219450), // Rule ID 7862 //
     /*  219381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219417 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219421 */     // MIs[1] Operand 1
     /*  219421 */     // No operand predicates
     /*  219421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219448 */     GIR_RootConstrainSelectedInstOperands,
     /*  219449 */     // GIR_Coverage, 7862,
     /*  219449 */     GIR_EraseRootFromParent_Done,
     /*  219450 */   // Label 4366: @219450
     /*  219450 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(219524), // Rule ID 7863 //
     /*  219455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  219469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219495 */     // MIs[1] Operand 1
     /*  219495 */     // No operand predicates
     /*  219495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219504 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  219504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219522 */     GIR_RootConstrainSelectedInstOperands,
     /*  219523 */     // GIR_Coverage, 7863,
     /*  219523 */     GIR_EraseRootFromParent_Done,
     /*  219524 */   // Label 4367: @219524
     /*  219524 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(219598), // Rule ID 7866 //
     /*  219529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  219543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219569 */     // MIs[1] Operand 1
     /*  219569 */     // No operand predicates
     /*  219569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219578 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  219578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  219581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219596 */     GIR_RootConstrainSelectedInstOperands,
     /*  219597 */     // GIR_Coverage, 7866,
     /*  219597 */     GIR_EraseRootFromParent_Done,
     /*  219598 */   // Label 4368: @219598
     /*  219598 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(219672), // Rule ID 7867 //
     /*  219603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  219614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  219617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219643 */     // MIs[1] Operand 1
     /*  219643 */     // No operand predicates
     /*  219643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  219652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  219655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  219670 */     GIR_RootConstrainSelectedInstOperands,
     /*  219671 */     // GIR_Coverage, 7867,
     /*  219671 */     GIR_EraseRootFromParent_Done,
     /*  219672 */   // Label 4369: @219672
     /*  219672 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(219746), // Rule ID 7870 //
     /*  219677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  219691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219717 */     // MIs[1] Operand 1
     /*  219717 */     // No operand predicates
     /*  219717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219726 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219744 */     GIR_RootConstrainSelectedInstOperands,
     /*  219745 */     // GIR_Coverage, 7870,
     /*  219745 */     GIR_EraseRootFromParent_Done,
     /*  219746 */   // Label 4370: @219746
     /*  219746 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(219820), // Rule ID 7871 //
     /*  219751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  219765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219791 */     // MIs[1] Operand 1
     /*  219791 */     // No operand predicates
     /*  219791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219800 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4),
     /*  219803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219818 */     GIR_RootConstrainSelectedInstOperands,
     /*  219819 */     // GIR_Coverage, 7871,
     /*  219819 */     GIR_EraseRootFromParent_Done,
     /*  219820 */   // Label 4371: @219820
     /*  219820 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(219894), // Rule ID 7874 //
     /*  219825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  219839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219865 */     // MIs[1] Operand 1
     /*  219865 */     // No operand predicates
     /*  219865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219874 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  219874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  219877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219892 */     GIR_RootConstrainSelectedInstOperands,
     /*  219893 */     // GIR_Coverage, 7874,
     /*  219893 */     GIR_EraseRootFromParent_Done,
     /*  219894 */   // Label 4372: @219894
     /*  219894 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(219968), // Rule ID 7875 //
     /*  219899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  219902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  219910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  219913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  219916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  219919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  219931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  219935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  219939 */     // MIs[1] Operand 1
     /*  219939 */     // No operand predicates
     /*  219939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  219941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  219948 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  219948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  219951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  219953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  219955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  219958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  219963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  219966 */     GIR_RootConstrainSelectedInstOperands,
     /*  219967 */     // GIR_Coverage, 7875,
     /*  219967 */     GIR_EraseRootFromParent_Done,
     /*  219968 */   // Label 4373: @219968
     /*  219968 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(220042), // Rule ID 7878 //
     /*  219973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  219976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  219981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  219984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  219987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  219990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  219993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  219997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220013 */     // MIs[1] Operand 1
     /*  220013 */     // No operand predicates
     /*  220013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220022 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220040 */     GIR_RootConstrainSelectedInstOperands,
     /*  220041 */     // GIR_Coverage, 7878,
     /*  220041 */     GIR_EraseRootFromParent_Done,
     /*  220042 */   // Label 4374: @220042
     /*  220042 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(220116), // Rule ID 7879 //
     /*  220047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  220061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220087 */     // MIs[1] Operand 1
     /*  220087 */     // No operand predicates
     /*  220087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  220096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2),
     /*  220099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220114 */     GIR_RootConstrainSelectedInstOperands,
     /*  220115 */     // GIR_Coverage, 7879,
     /*  220115 */     GIR_EraseRootFromParent_Done,
     /*  220116 */   // Label 4375: @220116
     /*  220116 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(220190), // Rule ID 7882 //
     /*  220121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220161 */     // MIs[1] Operand 1
     /*  220161 */     // No operand predicates
     /*  220161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220170 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220188 */     GIR_RootConstrainSelectedInstOperands,
     /*  220189 */     // GIR_Coverage, 7882,
     /*  220189 */     GIR_EraseRootFromParent_Done,
     /*  220190 */   // Label 4376: @220190
     /*  220190 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(220264), // Rule ID 7883 //
     /*  220195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  220206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  220209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220235 */     // MIs[1] Operand 1
     /*  220235 */     // No operand predicates
     /*  220235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220262 */     GIR_RootConstrainSelectedInstOperands,
     /*  220263 */     // GIR_Coverage, 7883,
     /*  220263 */     GIR_EraseRootFromParent_Done,
     /*  220264 */   // Label 4377: @220264
     /*  220264 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(220338), // Rule ID 7886 //
     /*  220269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220309 */     // MIs[1] Operand 1
     /*  220309 */     // No operand predicates
     /*  220309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  220318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220336 */     GIR_RootConstrainSelectedInstOperands,
     /*  220337 */     // GIR_Coverage, 7886,
     /*  220337 */     GIR_EraseRootFromParent_Done,
     /*  220338 */   // Label 4378: @220338
     /*  220338 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(220412), // Rule ID 7887 //
     /*  220343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  220354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  220357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220383 */     // MIs[1] Operand 1
     /*  220383 */     // No operand predicates
     /*  220383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  220392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  220410 */     GIR_RootConstrainSelectedInstOperands,
     /*  220411 */     // GIR_Coverage, 7887,
     /*  220411 */     GIR_EraseRootFromParent_Done,
     /*  220412 */   // Label 4379: @220412
     /*  220412 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(220486), // Rule ID 7890 //
     /*  220417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  220431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220457 */     // MIs[1] Operand 1
     /*  220457 */     // No operand predicates
     /*  220457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220466 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  220466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220484 */     GIR_RootConstrainSelectedInstOperands,
     /*  220485 */     // GIR_Coverage, 7890,
     /*  220485 */     GIR_EraseRootFromParent_Done,
     /*  220486 */   // Label 4380: @220486
     /*  220486 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(220560), // Rule ID 7891 //
     /*  220491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  220502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  220505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220531 */     // MIs[1] Operand 1
     /*  220531 */     // No operand predicates
     /*  220531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  220540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  220558 */     GIR_RootConstrainSelectedInstOperands,
     /*  220559 */     // GIR_Coverage, 7891,
     /*  220559 */     GIR_EraseRootFromParent_Done,
     /*  220560 */   // Label 4381: @220560
     /*  220560 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(220634), // Rule ID 7894 //
     /*  220565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  220568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  220579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220605 */     // MIs[1] Operand 1
     /*  220605 */     // No operand predicates
     /*  220605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220614 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  220614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220632 */     GIR_RootConstrainSelectedInstOperands,
     /*  220633 */     // GIR_Coverage, 7894,
     /*  220633 */     GIR_EraseRootFromParent_Done,
     /*  220634 */   // Label 4382: @220634
     /*  220634 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(220708), // Rule ID 7895 //
     /*  220639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  220642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  220650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  220653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220679 */     // MIs[1] Operand 1
     /*  220679 */     // No operand predicates
     /*  220679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  220688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1),
     /*  220691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  220706 */     GIR_RootConstrainSelectedInstOperands,
     /*  220707 */     // GIR_Coverage, 7895,
     /*  220707 */     GIR_EraseRootFromParent_Done,
     /*  220708 */   // Label 4383: @220708
     /*  220708 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(220782), // Rule ID 7898 //
     /*  220713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  220724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  220727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220753 */     // MIs[1] Operand 1
     /*  220753 */     // No operand predicates
     /*  220753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  220765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220780 */     GIR_RootConstrainSelectedInstOperands,
     /*  220781 */     // GIR_Coverage, 7898,
     /*  220781 */     GIR_EraseRootFromParent_Done,
     /*  220782 */   // Label 4384: @220782
     /*  220782 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(220856), // Rule ID 7899 //
     /*  220787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  220798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  220801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  220815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220827 */     // MIs[1] Operand 1
     /*  220827 */     // No operand predicates
     /*  220827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220836 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  220839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220854 */     GIR_RootConstrainSelectedInstOperands,
     /*  220855 */     // GIR_Coverage, 7899,
     /*  220855 */     GIR_EraseRootFromParent_Done,
     /*  220856 */   // Label 4385: @220856
     /*  220856 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(220930), // Rule ID 7902 //
     /*  220861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  220864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  220872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  220875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  220878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  220881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220901 */     // MIs[1] Operand 1
     /*  220901 */     // No operand predicates
     /*  220901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220910 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  220910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  220913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  220928 */     GIR_RootConstrainSelectedInstOperands,
     /*  220929 */     // GIR_Coverage, 7902,
     /*  220929 */     GIR_EraseRootFromParent_Done,
     /*  220930 */   // Label 4386: @220930
     /*  220930 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(221004), // Rule ID 7903 //
     /*  220935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  220938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  220943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  220946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  220949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  220952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  220955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  220959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  220963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  220967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  220971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  220975 */     // MIs[1] Operand 1
     /*  220975 */     // No operand predicates
     /*  220975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  220977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  220984 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  220984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  220987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  220989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  220991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  220994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  220999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221002 */     GIR_RootConstrainSelectedInstOperands,
     /*  221003 */     // GIR_Coverage, 7903,
     /*  221003 */     GIR_EraseRootFromParent_Done,
     /*  221004 */   // Label 4387: @221004
     /*  221004 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(221078), // Rule ID 7906 //
     /*  221009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221049 */     // MIs[1] Operand 1
     /*  221049 */     // No operand predicates
     /*  221049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221058 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  221058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221076 */     GIR_RootConstrainSelectedInstOperands,
     /*  221077 */     // GIR_Coverage, 7906,
     /*  221077 */     GIR_EraseRootFromParent_Done,
     /*  221078 */   // Label 4388: @221078
     /*  221078 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(221152), // Rule ID 7907 //
     /*  221083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  221094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  221097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221123 */     // MIs[1] Operand 1
     /*  221123 */     // No operand predicates
     /*  221123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221132 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  221132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  221150 */     GIR_RootConstrainSelectedInstOperands,
     /*  221151 */     // GIR_Coverage, 7907,
     /*  221151 */     GIR_EraseRootFromParent_Done,
     /*  221152 */   // Label 4389: @221152
     /*  221152 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(221226), // Rule ID 7910 //
     /*  221157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221197 */     // MIs[1] Operand 1
     /*  221197 */     // No operand predicates
     /*  221197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221224 */     GIR_RootConstrainSelectedInstOperands,
     /*  221225 */     // GIR_Coverage, 7910,
     /*  221225 */     GIR_EraseRootFromParent_Done,
     /*  221226 */   // Label 4390: @221226
     /*  221226 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(221300), // Rule ID 7911 //
     /*  221231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  221245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221271 */     // MIs[1] Operand 1
     /*  221271 */     // No operand predicates
     /*  221271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221298 */     GIR_RootConstrainSelectedInstOperands,
     /*  221299 */     // GIR_Coverage, 7911,
     /*  221299 */     GIR_EraseRootFromParent_Done,
     /*  221300 */   // Label 4391: @221300
     /*  221300 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(221374), // Rule ID 7914 //
     /*  221305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221345 */     // MIs[1] Operand 1
     /*  221345 */     // No operand predicates
     /*  221345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221354 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221372 */     GIR_RootConstrainSelectedInstOperands,
     /*  221373 */     // GIR_Coverage, 7914,
     /*  221373 */     GIR_EraseRootFromParent_Done,
     /*  221374 */   // Label 4392: @221374
     /*  221374 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(221448), // Rule ID 7915 //
     /*  221379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  221393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221419 */     // MIs[1] Operand 1
     /*  221419 */     // No operand predicates
     /*  221419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221446 */     GIR_RootConstrainSelectedInstOperands,
     /*  221447 */     // GIR_Coverage, 7915,
     /*  221447 */     GIR_EraseRootFromParent_Done,
     /*  221448 */   // Label 4393: @221448
     /*  221448 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(221522), // Rule ID 7918 //
     /*  221453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221493 */     // MIs[1] Operand 1
     /*  221493 */     // No operand predicates
     /*  221493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  221502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221520 */     GIR_RootConstrainSelectedInstOperands,
     /*  221521 */     // GIR_Coverage, 7918,
     /*  221521 */     GIR_EraseRootFromParent_Done,
     /*  221522 */   // Label 4394: @221522
     /*  221522 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(221596), // Rule ID 7919 //
     /*  221527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  221538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  221541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221567 */     // MIs[1] Operand 1
     /*  221567 */     // No operand predicates
     /*  221567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  221576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  221594 */     GIR_RootConstrainSelectedInstOperands,
     /*  221595 */     // GIR_Coverage, 7919,
     /*  221595 */     GIR_EraseRootFromParent_Done,
     /*  221596 */   // Label 4395: @221596
     /*  221596 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(221670), // Rule ID 7922 //
     /*  221601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  221615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221641 */     // MIs[1] Operand 1
     /*  221641 */     // No operand predicates
     /*  221641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221650 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221668 */     GIR_RootConstrainSelectedInstOperands,
     /*  221669 */     // GIR_Coverage, 7922,
     /*  221669 */     GIR_EraseRootFromParent_Done,
     /*  221670 */   // Label 4396: @221670
     /*  221670 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(221744), // Rule ID 7923 //
     /*  221675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  221686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  221689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  221703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221715 */     // MIs[1] Operand 1
     /*  221715 */     // No operand predicates
     /*  221715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  221727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221742 */     GIR_RootConstrainSelectedInstOperands,
     /*  221743 */     // GIR_Coverage, 7923,
     /*  221743 */     GIR_EraseRootFromParent_Done,
     /*  221744 */   // Label 4397: @221744
     /*  221744 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(221818), // Rule ID 7926 //
     /*  221749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  221763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221789 */     // MIs[1] Operand 1
     /*  221789 */     // No operand predicates
     /*  221789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221798 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221816 */     GIR_RootConstrainSelectedInstOperands,
     /*  221817 */     // GIR_Coverage, 7926,
     /*  221817 */     GIR_EraseRootFromParent_Done,
     /*  221818 */   // Label 4398: @221818
     /*  221818 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(221892), // Rule ID 7927 //
     /*  221823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  221834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  221837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  221851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221863 */     // MIs[1] Operand 1
     /*  221863 */     // No operand predicates
     /*  221863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  221872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  221875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221890 */     GIR_RootConstrainSelectedInstOperands,
     /*  221891 */     // GIR_Coverage, 7927,
     /*  221891 */     GIR_EraseRootFromParent_Done,
     /*  221892 */   // Label 4399: @221892
     /*  221892 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(221966), // Rule ID 7930 //
     /*  221897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  221900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  221911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  221914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  221917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  221929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  221933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  221937 */     // MIs[1] Operand 1
     /*  221937 */     // No operand predicates
     /*  221937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  221939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  221946 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  221946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  221949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  221951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  221953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  221956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  221961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  221964 */     GIR_RootConstrainSelectedInstOperands,
     /*  221965 */     // GIR_Coverage, 7930,
     /*  221965 */     GIR_EraseRootFromParent_Done,
     /*  221966 */   // Label 4400: @221966
     /*  221966 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222040), // Rule ID 7931 //
     /*  221971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  221974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  221979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  221982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  221985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  221988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  221991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  221995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  221999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222011 */     // MIs[1] Operand 1
     /*  222011 */     // No operand predicates
     /*  222011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  222020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  222038 */     GIR_RootConstrainSelectedInstOperands,
     /*  222039 */     // GIR_Coverage, 7931,
     /*  222039 */     GIR_EraseRootFromParent_Done,
     /*  222040 */   // Label 4401: @222040
     /*  222040 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222114), // Rule ID 7934 //
     /*  222045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222085 */     // MIs[1] Operand 1
     /*  222085 */     // No operand predicates
     /*  222085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222112 */     GIR_RootConstrainSelectedInstOperands,
     /*  222113 */     // GIR_Coverage, 7934,
     /*  222113 */     GIR_EraseRootFromParent_Done,
     /*  222114 */   // Label 4402: @222114
     /*  222114 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222188), // Rule ID 7935 //
     /*  222119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  222133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  222147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222159 */     // MIs[1] Operand 1
     /*  222159 */     // No operand predicates
     /*  222159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222168 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2),
     /*  222171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222186 */     GIR_RootConstrainSelectedInstOperands,
     /*  222187 */     // GIR_Coverage, 7935,
     /*  222187 */     GIR_EraseRootFromParent_Done,
     /*  222188 */   // Label 4403: @222188
     /*  222188 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222262), // Rule ID 7938 //
     /*  222193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222233 */     // MIs[1] Operand 1
     /*  222233 */     // No operand predicates
     /*  222233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222260 */     GIR_RootConstrainSelectedInstOperands,
     /*  222261 */     // GIR_Coverage, 7938,
     /*  222261 */     GIR_EraseRootFromParent_Done,
     /*  222262 */   // Label 4404: @222262
     /*  222262 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(222336), // Rule ID 7939 //
     /*  222267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  222281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  222295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222307 */     // MIs[1] Operand 1
     /*  222307 */     // No operand predicates
     /*  222307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4),
     /*  222319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222334 */     GIR_RootConstrainSelectedInstOperands,
     /*  222335 */     // GIR_Coverage, 7939,
     /*  222335 */     GIR_EraseRootFromParent_Done,
     /*  222336 */   // Label 4405: @222336
     /*  222336 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(222410), // Rule ID 7942 //
     /*  222341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  222344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222381 */     // MIs[1] Operand 1
     /*  222381 */     // No operand predicates
     /*  222381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222390 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  222390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222408 */     GIR_RootConstrainSelectedInstOperands,
     /*  222409 */     // GIR_Coverage, 7942,
     /*  222409 */     GIR_EraseRootFromParent_Done,
     /*  222410 */   // Label 4406: @222410
     /*  222410 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(222484), // Rule ID 7943 //
     /*  222415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  222418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  222423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  222426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  222429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  222443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222455 */     // MIs[1] Operand 1
     /*  222455 */     // No operand predicates
     /*  222455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222464 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  222464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8),
     /*  222467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  222482 */     GIR_RootConstrainSelectedInstOperands,
     /*  222483 */     // GIR_Coverage, 7943,
     /*  222483 */     GIR_EraseRootFromParent_Done,
     /*  222484 */   // Label 4407: @222484
     /*  222484 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(222558), // Rule ID 8122 //
     /*  222489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  222503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222529 */     // MIs[1] Operand 1
     /*  222529 */     // No operand predicates
     /*  222529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  222541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222556 */     GIR_RootConstrainSelectedInstOperands,
     /*  222557 */     // GIR_Coverage, 8122,
     /*  222557 */     GIR_EraseRootFromParent_Done,
     /*  222558 */   // Label 4408: @222558
     /*  222558 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(222632), // Rule ID 8123 //
     /*  222563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  222577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222603 */     // MIs[1] Operand 1
     /*  222603 */     // No operand predicates
     /*  222603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8),
     /*  222615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222630 */     GIR_RootConstrainSelectedInstOperands,
     /*  222631 */     // GIR_Coverage, 8123,
     /*  222631 */     GIR_EraseRootFromParent_Done,
     /*  222632 */   // Label 4409: @222632
     /*  222632 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(222706), // Rule ID 8126 //
     /*  222637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  222651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222677 */     // MIs[1] Operand 1
     /*  222677 */     // No operand predicates
     /*  222677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222686 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  222689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222704 */     GIR_RootConstrainSelectedInstOperands,
     /*  222705 */     // GIR_Coverage, 8126,
     /*  222705 */     GIR_EraseRootFromParent_Done,
     /*  222706 */   // Label 4410: @222706
     /*  222706 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(222780), // Rule ID 8127 //
     /*  222711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  222722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  222725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222751 */     // MIs[1] Operand 1
     /*  222751 */     // No operand predicates
     /*  222751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  222763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222778 */     GIR_RootConstrainSelectedInstOperands,
     /*  222779 */     // GIR_Coverage, 8127,
     /*  222779 */     GIR_EraseRootFromParent_Done,
     /*  222780 */   // Label 4411: @222780
     /*  222780 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(222854), // Rule ID 8130 //
     /*  222785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  222799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222825 */     // MIs[1] Operand 1
     /*  222825 */     // No operand predicates
     /*  222825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222834 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  222834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  222837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222852 */     GIR_RootConstrainSelectedInstOperands,
     /*  222853 */     // GIR_Coverage, 8130,
     /*  222853 */     GIR_EraseRootFromParent_Done,
     /*  222854 */   // Label 4412: @222854
     /*  222854 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(222928), // Rule ID 8131 //
     /*  222859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  222862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  222870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  222873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  222876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  222879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222899 */     // MIs[1] Operand 1
     /*  222899 */     // No operand predicates
     /*  222899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222908 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  222908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  222911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  222926 */     GIR_RootConstrainSelectedInstOperands,
     /*  222927 */     // GIR_Coverage, 8131,
     /*  222927 */     GIR_EraseRootFromParent_Done,
     /*  222928 */   // Label 4413: @222928
     /*  222928 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223002), // Rule ID 8134 //
     /*  222933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  222936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  222941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  222944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  222947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  222950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  222953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  222961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  222965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  222969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  222973 */     // MIs[1] Operand 1
     /*  222973 */     // No operand predicates
     /*  222973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  222975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  222982 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  222982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  222985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  222987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  222989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  222992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  222997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223000 */     GIR_RootConstrainSelectedInstOperands,
     /*  223001 */     // GIR_Coverage, 8134,
     /*  223001 */     GIR_EraseRootFromParent_Done,
     /*  223002 */   // Label 4414: @223002
     /*  223002 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223076), // Rule ID 8135 //
     /*  223007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  223021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223047 */     // MIs[1] Operand 1
     /*  223047 */     // No operand predicates
     /*  223047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4),
     /*  223059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223074 */     GIR_RootConstrainSelectedInstOperands,
     /*  223075 */     // GIR_Coverage, 8135,
     /*  223075 */     GIR_EraseRootFromParent_Done,
     /*  223076 */   // Label 4415: @223076
     /*  223076 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223150), // Rule ID 8138 //
     /*  223081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223121 */     // MIs[1] Operand 1
     /*  223121 */     // No operand predicates
     /*  223121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223130 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223148 */     GIR_RootConstrainSelectedInstOperands,
     /*  223149 */     // GIR_Coverage, 8138,
     /*  223149 */     GIR_EraseRootFromParent_Done,
     /*  223150 */   // Label 4416: @223150
     /*  223150 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223224), // Rule ID 8139 //
     /*  223155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  223169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223195 */     // MIs[1] Operand 1
     /*  223195 */     // No operand predicates
     /*  223195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223222 */     GIR_RootConstrainSelectedInstOperands,
     /*  223223 */     // GIR_Coverage, 8139,
     /*  223223 */     GIR_EraseRootFromParent_Done,
     /*  223224 */   // Label 4417: @223224
     /*  223224 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223298), // Rule ID 8142 //
     /*  223229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223269 */     // MIs[1] Operand 1
     /*  223269 */     // No operand predicates
     /*  223269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223278 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223296 */     GIR_RootConstrainSelectedInstOperands,
     /*  223297 */     // GIR_Coverage, 8142,
     /*  223297 */     GIR_EraseRootFromParent_Done,
     /*  223298 */   // Label 4418: @223298
     /*  223298 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223372), // Rule ID 8143 //
     /*  223303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  223317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223343 */     // MIs[1] Operand 1
     /*  223343 */     // No operand predicates
     /*  223343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2),
     /*  223355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223370 */     GIR_RootConstrainSelectedInstOperands,
     /*  223371 */     // GIR_Coverage, 8143,
     /*  223371 */     GIR_EraseRootFromParent_Done,
     /*  223372 */   // Label 4419: @223372
     /*  223372 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223446), // Rule ID 8146 //
     /*  223377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223417 */     // MIs[1] Operand 1
     /*  223417 */     // No operand predicates
     /*  223417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223426 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  223426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223444 */     GIR_RootConstrainSelectedInstOperands,
     /*  223445 */     // GIR_Coverage, 8146,
     /*  223445 */     GIR_EraseRootFromParent_Done,
     /*  223446 */   // Label 4420: @223446
     /*  223446 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223520), // Rule ID 8147 //
     /*  223451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  223462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  223465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223491 */     // MIs[1] Operand 1
     /*  223491 */     // No operand predicates
     /*  223491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  223500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  223518 */     GIR_RootConstrainSelectedInstOperands,
     /*  223519 */     // GIR_Coverage, 8147,
     /*  223519 */     GIR_EraseRootFromParent_Done,
     /*  223520 */   // Label 4421: @223520
     /*  223520 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223594), // Rule ID 8150 //
     /*  223525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  223539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223565 */     // MIs[1] Operand 1
     /*  223565 */     // No operand predicates
     /*  223565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223574 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  223574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223592 */     GIR_RootConstrainSelectedInstOperands,
     /*  223593 */     // GIR_Coverage, 8150,
     /*  223593 */     GIR_EraseRootFromParent_Done,
     /*  223594 */   // Label 4422: @223594
     /*  223594 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223668), // Rule ID 8151 //
     /*  223599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  223610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  223613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223639 */     // MIs[1] Operand 1
     /*  223639 */     // No operand predicates
     /*  223639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223648 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  223648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  223666 */     GIR_RootConstrainSelectedInstOperands,
     /*  223667 */     // GIR_Coverage, 8151,
     /*  223667 */     GIR_EraseRootFromParent_Done,
     /*  223668 */   // Label 4423: @223668
     /*  223668 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223742), // Rule ID 8154 //
     /*  223673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  223687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223713 */     // MIs[1] Operand 1
     /*  223713 */     // No operand predicates
     /*  223713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223722 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  223722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223740 */     GIR_RootConstrainSelectedInstOperands,
     /*  223741 */     // GIR_Coverage, 8154,
     /*  223741 */     GIR_EraseRootFromParent_Done,
     /*  223742 */   // Label 4424: @223742
     /*  223742 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223816), // Rule ID 8155 //
     /*  223747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  223750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  223758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  223761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223787 */     // MIs[1] Operand 1
     /*  223787 */     // No operand predicates
     /*  223787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  223796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  223814 */     GIR_RootConstrainSelectedInstOperands,
     /*  223815 */     // GIR_Coverage, 8155,
     /*  223815 */     GIR_EraseRootFromParent_Done,
     /*  223816 */   // Label 4425: @223816
     /*  223816 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223890), // Rule ID 8158 //
     /*  223821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  223824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  223835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223861 */     // MIs[1] Operand 1
     /*  223861 */     // No operand predicates
     /*  223861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223870 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  223870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223888 */     GIR_RootConstrainSelectedInstOperands,
     /*  223889 */     // GIR_Coverage, 8158,
     /*  223889 */     GIR_EraseRootFromParent_Done,
     /*  223890 */   // Label 4426: @223890
     /*  223890 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223964), // Rule ID 8159 //
     /*  223895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  223898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  223906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  223909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  223912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  223915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  223927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  223931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  223935 */     // MIs[1] Operand 1
     /*  223935 */     // No operand predicates
     /*  223935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  223937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  223944 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  223944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1),
     /*  223947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  223949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  223951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  223954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  223959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  223962 */     GIR_RootConstrainSelectedInstOperands,
     /*  223963 */     // GIR_Coverage, 8159,
     /*  223963 */     GIR_EraseRootFromParent_Done,
     /*  223964 */   // Label 4427: @223964
     /*  223964 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(224038), // Rule ID 8162 //
     /*  223969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  223972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  223977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  223980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  223983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  223986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  223989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  223993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  223997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224009 */     // MIs[1] Operand 1
     /*  224009 */     // No operand predicates
     /*  224009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224036 */     GIR_RootConstrainSelectedInstOperands,
     /*  224037 */     // GIR_Coverage, 8162,
     /*  224037 */     GIR_EraseRootFromParent_Done,
     /*  224038 */   // Label 4428: @224038
     /*  224038 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224112), // Rule ID 8163 //
     /*  224043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  224057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224083 */     // MIs[1] Operand 1
     /*  224083 */     // No operand predicates
     /*  224083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224110 */     GIR_RootConstrainSelectedInstOperands,
     /*  224111 */     // GIR_Coverage, 8163,
     /*  224111 */     GIR_EraseRootFromParent_Done,
     /*  224112 */   // Label 4429: @224112
     /*  224112 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224186), // Rule ID 8166 //
     /*  224117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224157 */     // MIs[1] Operand 1
     /*  224157 */     // No operand predicates
     /*  224157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224184 */     GIR_RootConstrainSelectedInstOperands,
     /*  224185 */     // GIR_Coverage, 8166,
     /*  224185 */     GIR_EraseRootFromParent_Done,
     /*  224186 */   // Label 4430: @224186
     /*  224186 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224260), // Rule ID 8167 //
     /*  224191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  224205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224231 */     // MIs[1] Operand 1
     /*  224231 */     // No operand predicates
     /*  224231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224240 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224258 */     GIR_RootConstrainSelectedInstOperands,
     /*  224259 */     // GIR_Coverage, 8167,
     /*  224259 */     GIR_EraseRootFromParent_Done,
     /*  224260 */   // Label 4431: @224260
     /*  224260 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224334), // Rule ID 8170 //
     /*  224265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224305 */     // MIs[1] Operand 1
     /*  224305 */     // No operand predicates
     /*  224305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224314 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  224314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224332 */     GIR_RootConstrainSelectedInstOperands,
     /*  224333 */     // GIR_Coverage, 8170,
     /*  224333 */     GIR_EraseRootFromParent_Done,
     /*  224334 */   // Label 4432: @224334
     /*  224334 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224408), // Rule ID 8171 //
     /*  224339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  224350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  224353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224379 */     // MIs[1] Operand 1
     /*  224379 */     // No operand predicates
     /*  224379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224388 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  224388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  224406 */     GIR_RootConstrainSelectedInstOperands,
     /*  224407 */     // GIR_Coverage, 8171,
     /*  224407 */     GIR_EraseRootFromParent_Done,
     /*  224408 */   // Label 4433: @224408
     /*  224408 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224482), // Rule ID 8174 //
     /*  224413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  224427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224449 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224453 */     // MIs[1] Operand 1
     /*  224453 */     // No operand predicates
     /*  224453 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224462 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224480 */     GIR_RootConstrainSelectedInstOperands,
     /*  224481 */     // GIR_Coverage, 8174,
     /*  224481 */     GIR_EraseRootFromParent_Done,
     /*  224482 */   // Label 4434: @224482
     /*  224482 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224556), // Rule ID 8175 //
     /*  224487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  224498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  224501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224527 */     // MIs[1] Operand 1
     /*  224527 */     // No operand predicates
     /*  224527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224536 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224554 */     GIR_RootConstrainSelectedInstOperands,
     /*  224555 */     // GIR_Coverage, 8175,
     /*  224555 */     GIR_EraseRootFromParent_Done,
     /*  224556 */   // Label 4435: @224556
     /*  224556 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224630), // Rule ID 8178 //
     /*  224561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  224575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224601 */     // MIs[1] Operand 1
     /*  224601 */     // No operand predicates
     /*  224601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224610 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224628 */     GIR_RootConstrainSelectedInstOperands,
     /*  224629 */     // GIR_Coverage, 8178,
     /*  224629 */     GIR_EraseRootFromParent_Done,
     /*  224630 */   // Label 4436: @224630
     /*  224630 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224704), // Rule ID 8179 //
     /*  224635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  224646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  224649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  224663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224675 */     // MIs[1] Operand 1
     /*  224675 */     // No operand predicates
     /*  224675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  224687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224702 */     GIR_RootConstrainSelectedInstOperands,
     /*  224703 */     // GIR_Coverage, 8179,
     /*  224703 */     GIR_EraseRootFromParent_Done,
     /*  224704 */   // Label 4437: @224704
     /*  224704 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224778), // Rule ID 8182 //
     /*  224709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  224723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224749 */     // MIs[1] Operand 1
     /*  224749 */     // No operand predicates
     /*  224749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224758 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  224758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224776 */     GIR_RootConstrainSelectedInstOperands,
     /*  224777 */     // GIR_Coverage, 8182,
     /*  224777 */     GIR_EraseRootFromParent_Done,
     /*  224778 */   // Label 4438: @224778
     /*  224778 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224852), // Rule ID 8183 //
     /*  224783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  224794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  224797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  224811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224823 */     // MIs[1] Operand 1
     /*  224823 */     // No operand predicates
     /*  224823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224832 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  224832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  224835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  224850 */     GIR_RootConstrainSelectedInstOperands,
     /*  224851 */     // GIR_Coverage, 8183,
     /*  224851 */     GIR_EraseRootFromParent_Done,
     /*  224852 */   // Label 4439: @224852
     /*  224852 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224926), // Rule ID 8186 //
     /*  224857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  224860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  224871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  224874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  224877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224897 */     // MIs[1] Operand 1
     /*  224897 */     // No operand predicates
     /*  224897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  224906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224924 */     GIR_RootConstrainSelectedInstOperands,
     /*  224925 */     // GIR_Coverage, 8186,
     /*  224925 */     GIR_EraseRootFromParent_Done,
     /*  224926 */   // Label 4440: @224926
     /*  224926 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(225000), // Rule ID 8187 //
     /*  224931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  224934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  224939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  224942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  224945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  224948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  224951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  224955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  224959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  224963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  224967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  224971 */     // MIs[1] Operand 1
     /*  224971 */     // No operand predicates
     /*  224971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  224973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  224980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  224980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  224983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  224985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  224987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  224990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  224995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  224998 */     GIR_RootConstrainSelectedInstOperands,
     /*  224999 */     // GIR_Coverage, 8187,
     /*  224999 */     GIR_EraseRootFromParent_Done,
     /*  225000 */   // Label 4441: @225000
     /*  225000 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(225074), // Rule ID 8190 //
     /*  225005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225045 */     // MIs[1] Operand 1
     /*  225045 */     // No operand predicates
     /*  225045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225072 */     GIR_RootConstrainSelectedInstOperands,
     /*  225073 */     // GIR_Coverage, 8190,
     /*  225073 */     GIR_EraseRootFromParent_Done,
     /*  225074 */   // Label 4442: @225074
     /*  225074 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(225148), // Rule ID 8191 //
     /*  225079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  225093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225119 */     // MIs[1] Operand 1
     /*  225119 */     // No operand predicates
     /*  225119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225128 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225146 */     GIR_RootConstrainSelectedInstOperands,
     /*  225147 */     // GIR_Coverage, 8191,
     /*  225147 */     GIR_EraseRootFromParent_Done,
     /*  225148 */   // Label 4443: @225148
     /*  225148 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(225222), // Rule ID 8194 //
     /*  225153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225193 */     // MIs[1] Operand 1
     /*  225193 */     // No operand predicates
     /*  225193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  225202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225220 */     GIR_RootConstrainSelectedInstOperands,
     /*  225221 */     // GIR_Coverage, 8194,
     /*  225221 */     GIR_EraseRootFromParent_Done,
     /*  225222 */   // Label 4444: @225222
     /*  225222 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(225296), // Rule ID 8195 //
     /*  225227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  225238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  225241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225267 */     // MIs[1] Operand 1
     /*  225267 */     // No operand predicates
     /*  225267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225276 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  225276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  225294 */     GIR_RootConstrainSelectedInstOperands,
     /*  225295 */     // GIR_Coverage, 8195,
     /*  225295 */     GIR_EraseRootFromParent_Done,
     /*  225296 */   // Label 4445: @225296
     /*  225296 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(225370), // Rule ID 8198 //
     /*  225301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225341 */     // MIs[1] Operand 1
     /*  225341 */     // No operand predicates
     /*  225341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225350 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225368 */     GIR_RootConstrainSelectedInstOperands,
     /*  225369 */     // GIR_Coverage, 8198,
     /*  225369 */     GIR_EraseRootFromParent_Done,
     /*  225370 */   // Label 4446: @225370
     /*  225370 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(225444), // Rule ID 8199 //
     /*  225375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  225378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  225389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  225403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225415 */     // MIs[1] Operand 1
     /*  225415 */     // No operand predicates
     /*  225415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2),
     /*  225427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225442 */     GIR_RootConstrainSelectedInstOperands,
     /*  225443 */     // GIR_Coverage, 8199,
     /*  225443 */     GIR_EraseRootFromParent_Done,
     /*  225444 */   // Label 4447: @225444
     /*  225444 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(225518), // Rule ID 8202 //
     /*  225449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  225463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225489 */     // MIs[1] Operand 1
     /*  225489 */     // No operand predicates
     /*  225489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225516 */     GIR_RootConstrainSelectedInstOperands,
     /*  225517 */     // GIR_Coverage, 8202,
     /*  225517 */     GIR_EraseRootFromParent_Done,
     /*  225518 */   // Label 4448: @225518
     /*  225518 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(225592), // Rule ID 8203 //
     /*  225523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  225526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  225534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  225537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  225551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225563 */     // MIs[1] Operand 1
     /*  225563 */     // No operand predicates
     /*  225563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4),
     /*  225575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225590 */     GIR_RootConstrainSelectedInstOperands,
     /*  225591 */     // GIR_Coverage, 8203,
     /*  225591 */     GIR_EraseRootFromParent_Done,
     /*  225592 */   // Label 4449: @225592
     /*  225592 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(225666), // Rule ID 8206 //
     /*  225597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  225600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  225611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225637 */     // MIs[1] Operand 1
     /*  225637 */     // No operand predicates
     /*  225637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  225646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225664 */     GIR_RootConstrainSelectedInstOperands,
     /*  225665 */     // GIR_Coverage, 8206,
     /*  225665 */     GIR_EraseRootFromParent_Done,
     /*  225666 */   // Label 4450: @225666
     /*  225666 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(225740), // Rule ID 8207 //
     /*  225671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  225674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  225679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  225682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  225685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  225699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225711 */     // MIs[1] Operand 1
     /*  225711 */     // No operand predicates
     /*  225711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  225720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8),
     /*  225723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  225738 */     GIR_RootConstrainSelectedInstOperands,
     /*  225739 */     // GIR_Coverage, 8207,
     /*  225739 */     GIR_EraseRootFromParent_Done,
     /*  225740 */   // Label 4451: @225740
     /*  225740 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(225814), // Rule ID 8738 //
     /*  225745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  225753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  225759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225785 */     // MIs[1] Operand 1
     /*  225785 */     // No operand predicates
     /*  225785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225794 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  225797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225812 */     GIR_RootConstrainSelectedInstOperands,
     /*  225813 */     // GIR_Coverage, 8738,
     /*  225813 */     GIR_EraseRootFromParent_Done,
     /*  225814 */   // Label 4452: @225814
     /*  225814 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225888), // Rule ID 8739 //
     /*  225819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  225827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  225830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  225833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225859 */     // MIs[1] Operand 1
     /*  225859 */     // No operand predicates
     /*  225859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  225868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8),
     /*  225871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225886 */     GIR_RootConstrainSelectedInstOperands,
     /*  225887 */     // GIR_Coverage, 8739,
     /*  225887 */     GIR_EraseRootFromParent_Done,
     /*  225888 */   // Label 4453: @225888
     /*  225888 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225962), // Rule ID 8742 //
     /*  225893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  225896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  225901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  225907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  225910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  225913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  225929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  225933 */     // MIs[1] Operand 1
     /*  225933 */     // No operand predicates
     /*  225933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  225935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  225942 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  225942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  225945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  225947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  225949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  225952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  225957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  225960 */     GIR_RootConstrainSelectedInstOperands,
     /*  225961 */     // GIR_Coverage, 8742,
     /*  225961 */     GIR_EraseRootFromParent_Done,
     /*  225962 */   // Label 4454: @225962
     /*  225962 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(226036), // Rule ID 8743 //
     /*  225967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  225970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  225975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  225978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  225981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  225984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  225987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  225995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  225999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226007 */     // MIs[1] Operand 1
     /*  226007 */     // No operand predicates
     /*  226007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226034 */     GIR_RootConstrainSelectedInstOperands,
     /*  226035 */     // GIR_Coverage, 8743,
     /*  226035 */     GIR_EraseRootFromParent_Done,
     /*  226036 */   // Label 4455: @226036
     /*  226036 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(226110), // Rule ID 8746 //
     /*  226041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226081 */     // MIs[1] Operand 1
     /*  226081 */     // No operand predicates
     /*  226081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226108 */     GIR_RootConstrainSelectedInstOperands,
     /*  226109 */     // GIR_Coverage, 8746,
     /*  226109 */     GIR_EraseRootFromParent_Done,
     /*  226110 */   // Label 4456: @226110
     /*  226110 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(226184), // Rule ID 8747 //
     /*  226115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  226129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226155 */     // MIs[1] Operand 1
     /*  226155 */     // No operand predicates
     /*  226155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226171 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226182 */     GIR_RootConstrainSelectedInstOperands,
     /*  226183 */     // GIR_Coverage, 8747,
     /*  226183 */     GIR_EraseRootFromParent_Done,
     /*  226184 */   // Label 4457: @226184
     /*  226184 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(226258), // Rule ID 8750 //
     /*  226189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226225 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226229 */     // MIs[1] Operand 1
     /*  226229 */     // No operand predicates
     /*  226229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226238 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226256 */     GIR_RootConstrainSelectedInstOperands,
     /*  226257 */     // GIR_Coverage, 8750,
     /*  226257 */     GIR_EraseRootFromParent_Done,
     /*  226258 */   // Label 4458: @226258
     /*  226258 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(226332), // Rule ID 8751 //
     /*  226263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  226277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226303 */     // MIs[1] Operand 1
     /*  226303 */     // No operand predicates
     /*  226303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4),
     /*  226315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226330 */     GIR_RootConstrainSelectedInstOperands,
     /*  226331 */     // GIR_Coverage, 8751,
     /*  226331 */     GIR_EraseRootFromParent_Done,
     /*  226332 */   // Label 4459: @226332
     /*  226332 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(226406), // Rule ID 8754 //
     /*  226337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226377 */     // MIs[1] Operand 1
     /*  226377 */     // No operand predicates
     /*  226377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226386 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226404 */     GIR_RootConstrainSelectedInstOperands,
     /*  226405 */     // GIR_Coverage, 8754,
     /*  226405 */     GIR_EraseRootFromParent_Done,
     /*  226406 */   // Label 4460: @226406
     /*  226406 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(226480), // Rule ID 8755 //
     /*  226411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  226425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226451 */     // MIs[1] Operand 1
     /*  226451 */     // No operand predicates
     /*  226451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226478 */     GIR_RootConstrainSelectedInstOperands,
     /*  226479 */     // GIR_Coverage, 8755,
     /*  226479 */     GIR_EraseRootFromParent_Done,
     /*  226480 */   // Label 4461: @226480
     /*  226480 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(226554), // Rule ID 8758 //
     /*  226485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  226499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226525 */     // MIs[1] Operand 1
     /*  226525 */     // No operand predicates
     /*  226525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226552 */     GIR_RootConstrainSelectedInstOperands,
     /*  226553 */     // GIR_Coverage, 8758,
     /*  226553 */     GIR_EraseRootFromParent_Done,
     /*  226554 */   // Label 4462: @226554
     /*  226554 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(226628), // Rule ID 8759 //
     /*  226559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  226570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  226573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226599 */     // MIs[1] Operand 1
     /*  226599 */     // No operand predicates
     /*  226599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  226608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2),
     /*  226611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226626 */     GIR_RootConstrainSelectedInstOperands,
     /*  226627 */     // GIR_Coverage, 8759,
     /*  226627 */     GIR_EraseRootFromParent_Done,
     /*  226628 */   // Label 4463: @226628
     /*  226628 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(226702), // Rule ID 8762 //
     /*  226633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  226647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226673 */     // MIs[1] Operand 1
     /*  226673 */     // No operand predicates
     /*  226673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226682 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  226682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  226685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226700 */     GIR_RootConstrainSelectedInstOperands,
     /*  226701 */     // GIR_Coverage, 8762,
     /*  226701 */     GIR_EraseRootFromParent_Done,
     /*  226702 */   // Label 4464: @226702
     /*  226702 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(226776), // Rule ID 8763 //
     /*  226707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  226718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  226721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226747 */     // MIs[1] Operand 1
     /*  226747 */     // No operand predicates
     /*  226747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  226756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  226759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  226774 */     GIR_RootConstrainSelectedInstOperands,
     /*  226775 */     // GIR_Coverage, 8763,
     /*  226775 */     GIR_EraseRootFromParent_Done,
     /*  226776 */   // Label 4465: @226776
     /*  226776 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(226850), // Rule ID 8766 //
     /*  226781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  226795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226821 */     // MIs[1] Operand 1
     /*  226821 */     // No operand predicates
     /*  226821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226830 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  226830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  226833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226848 */     GIR_RootConstrainSelectedInstOperands,
     /*  226849 */     // GIR_Coverage, 8766,
     /*  226849 */     GIR_EraseRootFromParent_Done,
     /*  226850 */   // Label 4466: @226850
     /*  226850 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(226924), // Rule ID 8767 //
     /*  226855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  226858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  226866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  226869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  226872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  226875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226895 */     // MIs[1] Operand 1
     /*  226895 */     // No operand predicates
     /*  226895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  226904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  226907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  226922 */     GIR_RootConstrainSelectedInstOperands,
     /*  226923 */     // GIR_Coverage, 8767,
     /*  226923 */     GIR_EraseRootFromParent_Done,
     /*  226924 */   // Label 4467: @226924
     /*  226924 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(226998), // Rule ID 8770 //
     /*  226929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  226932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  226937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  226940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  226943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  226946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  226949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  226957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  226961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  226965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  226969 */     // MIs[1] Operand 1
     /*  226969 */     // No operand predicates
     /*  226969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  226971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  226978 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  226978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  226981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  226983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  226985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  226988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  226993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  226996 */     GIR_RootConstrainSelectedInstOperands,
     /*  226997 */     // GIR_Coverage, 8770,
     /*  226997 */     GIR_EraseRootFromParent_Done,
     /*  226998 */   // Label 4468: @226998
     /*  226998 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(227072), // Rule ID 8771 //
     /*  227003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  227014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  227017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227043 */     // MIs[1] Operand 1
     /*  227043 */     // No operand predicates
     /*  227043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  227052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  227070 */     GIR_RootConstrainSelectedInstOperands,
     /*  227071 */     // GIR_Coverage, 8771,
     /*  227071 */     GIR_EraseRootFromParent_Done,
     /*  227072 */   // Label 4469: @227072
     /*  227072 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(227146), // Rule ID 8774 //
     /*  227077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  227080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227117 */     // MIs[1] Operand 1
     /*  227117 */     // No operand predicates
     /*  227117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227126 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  227126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227144 */     GIR_RootConstrainSelectedInstOperands,
     /*  227145 */     // GIR_Coverage, 8774,
     /*  227145 */     GIR_EraseRootFromParent_Done,
     /*  227146 */   // Label 4470: @227146
     /*  227146 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(227220), // Rule ID 8775 //
     /*  227151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  227154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  227162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  227165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227191 */     // MIs[1] Operand 1
     /*  227191 */     // No operand predicates
     /*  227191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  227200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1),
     /*  227203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  227218 */     GIR_RootConstrainSelectedInstOperands,
     /*  227219 */     // GIR_Coverage, 8775,
     /*  227219 */     GIR_EraseRootFromParent_Done,
     /*  227220 */   // Label 4471: @227220
     /*  227220 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(227294), // Rule ID 8778 //
     /*  227225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227265 */     // MIs[1] Operand 1
     /*  227265 */     // No operand predicates
     /*  227265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227274 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227292 */     GIR_RootConstrainSelectedInstOperands,
     /*  227293 */     // GIR_Coverage, 8778,
     /*  227293 */     GIR_EraseRootFromParent_Done,
     /*  227294 */   // Label 4472: @227294
     /*  227294 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(227368), // Rule ID 8779 //
     /*  227299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  227313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227339 */     // MIs[1] Operand 1
     /*  227339 */     // No operand predicates
     /*  227339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227366 */     GIR_RootConstrainSelectedInstOperands,
     /*  227367 */     // GIR_Coverage, 8779,
     /*  227367 */     GIR_EraseRootFromParent_Done,
     /*  227368 */   // Label 4473: @227368
     /*  227368 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(227442), // Rule ID 8782 //
     /*  227373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227413 */     // MIs[1] Operand 1
     /*  227413 */     // No operand predicates
     /*  227413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227422 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227440 */     GIR_RootConstrainSelectedInstOperands,
     /*  227441 */     // GIR_Coverage, 8782,
     /*  227441 */     GIR_EraseRootFromParent_Done,
     /*  227442 */   // Label 4474: @227442
     /*  227442 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(227516), // Rule ID 8783 //
     /*  227447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  227461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227487 */     // MIs[1] Operand 1
     /*  227487 */     // No operand predicates
     /*  227487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227496 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227514 */     GIR_RootConstrainSelectedInstOperands,
     /*  227515 */     // GIR_Coverage, 8783,
     /*  227515 */     GIR_EraseRootFromParent_Done,
     /*  227516 */   // Label 4475: @227516
     /*  227516 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(227590), // Rule ID 8786 //
     /*  227521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  227532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  227535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227561 */     // MIs[1] Operand 1
     /*  227561 */     // No operand predicates
     /*  227561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227570 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  227570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  227573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227588 */     GIR_RootConstrainSelectedInstOperands,
     /*  227589 */     // GIR_Coverage, 8786,
     /*  227589 */     GIR_EraseRootFromParent_Done,
     /*  227590 */   // Label 4476: @227590
     /*  227590 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(227664), // Rule ID 8787 //
     /*  227595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  227606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  227609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227635 */     // MIs[1] Operand 1
     /*  227635 */     // No operand predicates
     /*  227635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227644 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  227644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  227647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  227662 */     GIR_RootConstrainSelectedInstOperands,
     /*  227663 */     // GIR_Coverage, 8787,
     /*  227663 */     GIR_EraseRootFromParent_Done,
     /*  227664 */   // Label 4477: @227664
     /*  227664 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(227738), // Rule ID 8790 //
     /*  227669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  227683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227709 */     // MIs[1] Operand 1
     /*  227709 */     // No operand predicates
     /*  227709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227718 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227736 */     GIR_RootConstrainSelectedInstOperands,
     /*  227737 */     // GIR_Coverage, 8790,
     /*  227737 */     GIR_EraseRootFromParent_Done,
     /*  227738 */   // Label 4478: @227738
     /*  227738 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(227812), // Rule ID 8791 //
     /*  227743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  227754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  227757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  227771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227783 */     // MIs[1] Operand 1
     /*  227783 */     // No operand predicates
     /*  227783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  227795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227810 */     GIR_RootConstrainSelectedInstOperands,
     /*  227811 */     // GIR_Coverage, 8791,
     /*  227811 */     GIR_EraseRootFromParent_Done,
     /*  227812 */   // Label 4479: @227812
     /*  227812 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(227886), // Rule ID 8794 //
     /*  227817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  227831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227857 */     // MIs[1] Operand 1
     /*  227857 */     // No operand predicates
     /*  227857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227866 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  227866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227884 */     GIR_RootConstrainSelectedInstOperands,
     /*  227885 */     // GIR_Coverage, 8794,
     /*  227885 */     GIR_EraseRootFromParent_Done,
     /*  227886 */   // Label 4480: @227886
     /*  227886 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(227960), // Rule ID 8795 //
     /*  227891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  227894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  227902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  227905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  227908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  227911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  227919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  227927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  227931 */     // MIs[1] Operand 1
     /*  227931 */     // No operand predicates
     /*  227931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  227933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  227940 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  227940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  227943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  227945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  227947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  227950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  227955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  227958 */     GIR_RootConstrainSelectedInstOperands,
     /*  227959 */     // GIR_Coverage, 8795,
     /*  227959 */     GIR_EraseRootFromParent_Done,
     /*  227960 */   // Label 4481: @227960
     /*  227960 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(228034), // Rule ID 8798 //
     /*  227965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  227968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  227973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  227976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  227979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  227982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  227985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  227989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  227993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  227997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228005 */     // MIs[1] Operand 1
     /*  228005 */     // No operand predicates
     /*  228005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228014 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  228014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228032 */     GIR_RootConstrainSelectedInstOperands,
     /*  228033 */     // GIR_Coverage, 8798,
     /*  228033 */     GIR_EraseRootFromParent_Done,
     /*  228034 */   // Label 4482: @228034
     /*  228034 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(228108), // Rule ID 8799 //
     /*  228039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  228050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  228053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228079 */     // MIs[1] Operand 1
     /*  228079 */     // No operand predicates
     /*  228079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228088 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  228088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  228106 */     GIR_RootConstrainSelectedInstOperands,
     /*  228107 */     // GIR_Coverage, 8799,
     /*  228107 */     GIR_EraseRootFromParent_Done,
     /*  228108 */   // Label 4483: @228108
     /*  228108 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(228182), // Rule ID 8802 //
     /*  228113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228153 */     // MIs[1] Operand 1
     /*  228153 */     // No operand predicates
     /*  228153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228162 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228180 */     GIR_RootConstrainSelectedInstOperands,
     /*  228181 */     // GIR_Coverage, 8802,
     /*  228181 */     GIR_EraseRootFromParent_Done,
     /*  228182 */   // Label 4484: @228182
     /*  228182 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(228256), // Rule ID 8803 //
     /*  228187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  228201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228227 */     // MIs[1] Operand 1
     /*  228227 */     // No operand predicates
     /*  228227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228254 */     GIR_RootConstrainSelectedInstOperands,
     /*  228255 */     // GIR_Coverage, 8803,
     /*  228255 */     GIR_EraseRootFromParent_Done,
     /*  228256 */   // Label 4485: @228256
     /*  228256 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(228330), // Rule ID 8806 //
     /*  228261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228301 */     // MIs[1] Operand 1
     /*  228301 */     // No operand predicates
     /*  228301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228310 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228328 */     GIR_RootConstrainSelectedInstOperands,
     /*  228329 */     // GIR_Coverage, 8806,
     /*  228329 */     GIR_EraseRootFromParent_Done,
     /*  228330 */   // Label 4486: @228330
     /*  228330 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(228404), // Rule ID 8807 //
     /*  228335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  228349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228375 */     // MIs[1] Operand 1
     /*  228375 */     // No operand predicates
     /*  228375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228402 */     GIR_RootConstrainSelectedInstOperands,
     /*  228403 */     // GIR_Coverage, 8807,
     /*  228403 */     GIR_EraseRootFromParent_Done,
     /*  228404 */   // Label 4487: @228404
     /*  228404 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(228478), // Rule ID 8810 //
     /*  228409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  228412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  228423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228449 */     // MIs[1] Operand 1
     /*  228449 */     // No operand predicates
     /*  228449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  228458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228476 */     GIR_RootConstrainSelectedInstOperands,
     /*  228477 */     // GIR_Coverage, 8810,
     /*  228477 */     GIR_EraseRootFromParent_Done,
     /*  228478 */   // Label 4488: @228478
     /*  228478 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(228552), // Rule ID 8811 //
     /*  228483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  228486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  228494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  228497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228523 */     // MIs[1] Operand 1
     /*  228523 */     // No operand predicates
     /*  228523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  228532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  228550 */     GIR_RootConstrainSelectedInstOperands,
     /*  228551 */     // GIR_Coverage, 8811,
     /*  228551 */     GIR_EraseRootFromParent_Done,
     /*  228552 */   // Label 4489: @228552
     /*  228552 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(228626), // Rule ID 8814 //
     /*  228557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  228571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228597 */     // MIs[1] Operand 1
     /*  228597 */     // No operand predicates
     /*  228597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228606 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228624 */     GIR_RootConstrainSelectedInstOperands,
     /*  228625 */     // GIR_Coverage, 8814,
     /*  228625 */     GIR_EraseRootFromParent_Done,
     /*  228626 */   // Label 4490: @228626
     /*  228626 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(228700), // Rule ID 8815 //
     /*  228631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  228642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  228645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  228659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228671 */     // MIs[1] Operand 1
     /*  228671 */     // No operand predicates
     /*  228671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2),
     /*  228683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228698 */     GIR_RootConstrainSelectedInstOperands,
     /*  228699 */     // GIR_Coverage, 8815,
     /*  228699 */     GIR_EraseRootFromParent_Done,
     /*  228700 */   // Label 4491: @228700
     /*  228700 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(228774), // Rule ID 8818 //
     /*  228705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  228719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228745 */     // MIs[1] Operand 1
     /*  228745 */     // No operand predicates
     /*  228745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228754 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228772 */     GIR_RootConstrainSelectedInstOperands,
     /*  228773 */     // GIR_Coverage, 8818,
     /*  228773 */     GIR_EraseRootFromParent_Done,
     /*  228774 */   // Label 4492: @228774
     /*  228774 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(228848), // Rule ID 8819 //
     /*  228779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  228790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  228793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  228807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228819 */     // MIs[1] Operand 1
     /*  228819 */     // No operand predicates
     /*  228819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4),
     /*  228831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228846 */     GIR_RootConstrainSelectedInstOperands,
     /*  228847 */     // GIR_Coverage, 8819,
     /*  228847 */     GIR_EraseRootFromParent_Done,
     /*  228848 */   // Label 4493: @228848
     /*  228848 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(228922), // Rule ID 8822 //
     /*  228853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  228856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  228867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  228870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  228873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228893 */     // MIs[1] Operand 1
     /*  228893 */     // No operand predicates
     /*  228893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228902 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  228902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228920 */     GIR_RootConstrainSelectedInstOperands,
     /*  228921 */     // GIR_Coverage, 8822,
     /*  228921 */     GIR_EraseRootFromParent_Done,
     /*  228922 */   // Label 4494: @228922
     /*  228922 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(228996), // Rule ID 8823 //
     /*  228927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  228930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  228935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  228938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  228941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  228944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  228947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  228951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  228955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  228959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  228963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  228967 */     // MIs[1] Operand 1
     /*  228967 */     // No operand predicates
     /*  228967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  228969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  228976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  228976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8),
     /*  228979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  228981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  228983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  228986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  228991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  228994 */     GIR_RootConstrainSelectedInstOperands,
     /*  228995 */     // GIR_Coverage, 8823,
     /*  228995 */     GIR_EraseRootFromParent_Done,
     /*  228996 */   // Label 4495: @228996
     /*  228996 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(229070), // Rule ID 9002 //
     /*  229001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229041 */     // MIs[1] Operand 1
     /*  229041 */     // No operand predicates
     /*  229041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229050 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229068 */     GIR_RootConstrainSelectedInstOperands,
     /*  229069 */     // GIR_Coverage, 9002,
     /*  229069 */     GIR_EraseRootFromParent_Done,
     /*  229070 */   // Label 4496: @229070
     /*  229070 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(229144), // Rule ID 9003 //
     /*  229075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  229089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229115 */     // MIs[1] Operand 1
     /*  229115 */     // No operand predicates
     /*  229115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8),
     /*  229127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229142 */     GIR_RootConstrainSelectedInstOperands,
     /*  229143 */     // GIR_Coverage, 9003,
     /*  229143 */     GIR_EraseRootFromParent_Done,
     /*  229144 */   // Label 4497: @229144
     /*  229144 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(229218), // Rule ID 9006 //
     /*  229149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229189 */     // MIs[1] Operand 1
     /*  229189 */     // No operand predicates
     /*  229189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229198 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229216 */     GIR_RootConstrainSelectedInstOperands,
     /*  229217 */     // GIR_Coverage, 9006,
     /*  229217 */     GIR_EraseRootFromParent_Done,
     /*  229218 */   // Label 4498: @229218
     /*  229218 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(229292), // Rule ID 9007 //
     /*  229223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  229237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229263 */     // MIs[1] Operand 1
     /*  229263 */     // No operand predicates
     /*  229263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229272 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229290 */     GIR_RootConstrainSelectedInstOperands,
     /*  229291 */     // GIR_Coverage, 9007,
     /*  229291 */     GIR_EraseRootFromParent_Done,
     /*  229292 */   // Label 4499: @229292
     /*  229292 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(229366), // Rule ID 9010 //
     /*  229297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229337 */     // MIs[1] Operand 1
     /*  229337 */     // No operand predicates
     /*  229337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229346 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229364 */     GIR_RootConstrainSelectedInstOperands,
     /*  229365 */     // GIR_Coverage, 9010,
     /*  229365 */     GIR_EraseRootFromParent_Done,
     /*  229366 */   // Label 4500: @229366
     /*  229366 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(229440), // Rule ID 9011 //
     /*  229371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  229382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  229385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229411 */     // MIs[1] Operand 1
     /*  229411 */     // No operand predicates
     /*  229411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229420 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  229420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229438 */     GIR_RootConstrainSelectedInstOperands,
     /*  229439 */     // GIR_Coverage, 9011,
     /*  229439 */     GIR_EraseRootFromParent_Done,
     /*  229440 */   // Label 4501: @229440
     /*  229440 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(229514), // Rule ID 9014 //
     /*  229445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  229459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229485 */     // MIs[1] Operand 1
     /*  229485 */     // No operand predicates
     /*  229485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229512 */     GIR_RootConstrainSelectedInstOperands,
     /*  229513 */     // GIR_Coverage, 9014,
     /*  229513 */     GIR_EraseRootFromParent_Done,
     /*  229514 */   // Label 4502: @229514
     /*  229514 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(229588), // Rule ID 9015 //
     /*  229519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  229533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229559 */     // MIs[1] Operand 1
     /*  229559 */     // No operand predicates
     /*  229559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4),
     /*  229571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229586 */     GIR_RootConstrainSelectedInstOperands,
     /*  229587 */     // GIR_Coverage, 9015,
     /*  229587 */     GIR_EraseRootFromParent_Done,
     /*  229588 */   // Label 4503: @229588
     /*  229588 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(229662), // Rule ID 9018 //
     /*  229593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  229607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229633 */     // MIs[1] Operand 1
     /*  229633 */     // No operand predicates
     /*  229633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  229642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229660 */     GIR_RootConstrainSelectedInstOperands,
     /*  229661 */     // GIR_Coverage, 9018,
     /*  229661 */     GIR_EraseRootFromParent_Done,
     /*  229662 */   // Label 4504: @229662
     /*  229662 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(229736), // Rule ID 9019 //
     /*  229667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  229678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  229681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229707 */     // MIs[1] Operand 1
     /*  229707 */     // No operand predicates
     /*  229707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229716 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  229716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  229734 */     GIR_RootConstrainSelectedInstOperands,
     /*  229735 */     // GIR_Coverage, 9019,
     /*  229735 */     GIR_EraseRootFromParent_Done,
     /*  229736 */   // Label 4505: @229736
     /*  229736 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(229810), // Rule ID 9022 //
     /*  229741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  229755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229781 */     // MIs[1] Operand 1
     /*  229781 */     // No operand predicates
     /*  229781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229790 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  229790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229808 */     GIR_RootConstrainSelectedInstOperands,
     /*  229809 */     // GIR_Coverage, 9022,
     /*  229809 */     GIR_EraseRootFromParent_Done,
     /*  229810 */   // Label 4506: @229810
     /*  229810 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(229884), // Rule ID 9023 //
     /*  229815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  229826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  229829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229855 */     // MIs[1] Operand 1
     /*  229855 */     // No operand predicates
     /*  229855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  229864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2),
     /*  229867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  229882 */     GIR_RootConstrainSelectedInstOperands,
     /*  229883 */     // GIR_Coverage, 9023,
     /*  229883 */     GIR_EraseRootFromParent_Done,
     /*  229884 */   // Label 4507: @229884
     /*  229884 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(229958), // Rule ID 9026 //
     /*  229889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  229892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  229903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  229906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  229909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  229929 */     // MIs[1] Operand 1
     /*  229929 */     // No operand predicates
     /*  229929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  229931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  229938 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  229938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  229941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  229943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  229945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  229948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  229953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  229956 */     GIR_RootConstrainSelectedInstOperands,
     /*  229957 */     // GIR_Coverage, 9026,
     /*  229957 */     GIR_EraseRootFromParent_Done,
     /*  229958 */   // Label 4508: @229958
     /*  229958 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(230032), // Rule ID 9027 //
     /*  229963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  229966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  229971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  229974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  229977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  229980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  229983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  229991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  229995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  229999 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230003 */     // MIs[1] Operand 1
     /*  230003 */     // No operand predicates
     /*  230003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230012 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230030 */     GIR_RootConstrainSelectedInstOperands,
     /*  230031 */     // GIR_Coverage, 9027,
     /*  230031 */     GIR_EraseRootFromParent_Done,
     /*  230032 */   // Label 4509: @230032
     /*  230032 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(230106), // Rule ID 9030 //
     /*  230037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230077 */     // MIs[1] Operand 1
     /*  230077 */     // No operand predicates
     /*  230077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230086 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230104 */     GIR_RootConstrainSelectedInstOperands,
     /*  230105 */     // GIR_Coverage, 9030,
     /*  230105 */     GIR_EraseRootFromParent_Done,
     /*  230106 */   // Label 4510: @230106
     /*  230106 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(230180), // Rule ID 9031 //
     /*  230111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  230122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  230125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230151 */     // MIs[1] Operand 1
     /*  230151 */     // No operand predicates
     /*  230151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  230160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230178 */     GIR_RootConstrainSelectedInstOperands,
     /*  230179 */     // GIR_Coverage, 9031,
     /*  230179 */     GIR_EraseRootFromParent_Done,
     /*  230180 */   // Label 4511: @230180
     /*  230180 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(230254), // Rule ID 9034 //
     /*  230185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230225 */     // MIs[1] Operand 1
     /*  230225 */     // No operand predicates
     /*  230225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230234 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  230234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230252 */     GIR_RootConstrainSelectedInstOperands,
     /*  230253 */     // GIR_Coverage, 9034,
     /*  230253 */     GIR_EraseRootFromParent_Done,
     /*  230254 */   // Label 4512: @230254
     /*  230254 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(230328), // Rule ID 9035 //
     /*  230259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  230270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  230273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230299 */     // MIs[1] Operand 1
     /*  230299 */     // No operand predicates
     /*  230299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  230308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  230326 */     GIR_RootConstrainSelectedInstOperands,
     /*  230327 */     // GIR_Coverage, 9035,
     /*  230327 */     GIR_EraseRootFromParent_Done,
     /*  230328 */   // Label 4513: @230328
     /*  230328 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(230402), // Rule ID 9038 //
     /*  230333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  230336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230373 */     // MIs[1] Operand 1
     /*  230373 */     // No operand predicates
     /*  230373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  230382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230400 */     GIR_RootConstrainSelectedInstOperands,
     /*  230401 */     // GIR_Coverage, 9038,
     /*  230401 */     GIR_EraseRootFromParent_Done,
     /*  230402 */   // Label 4514: @230402
     /*  230402 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(230476), // Rule ID 9039 //
     /*  230407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  230410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  230418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  230421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230447 */     // MIs[1] Operand 1
     /*  230447 */     // No operand predicates
     /*  230447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230456 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  230456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1),
     /*  230459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  230474 */     GIR_RootConstrainSelectedInstOperands,
     /*  230475 */     // GIR_Coverage, 9039,
     /*  230475 */     GIR_EraseRootFromParent_Done,
     /*  230476 */   // Label 4515: @230476
     /*  230476 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(230550), // Rule ID 9042 //
     /*  230481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  230492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  230495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  230509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230521 */     // MIs[1] Operand 1
     /*  230521 */     // No operand predicates
     /*  230521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  230533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230548 */     GIR_RootConstrainSelectedInstOperands,
     /*  230549 */     // GIR_Coverage, 9042,
     /*  230549 */     GIR_EraseRootFromParent_Done,
     /*  230550 */   // Label 4516: @230550
     /*  230550 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(230624), // Rule ID 9043 //
     /*  230555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  230566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  230569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  230583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230595 */     // MIs[1] Operand 1
     /*  230595 */     // No operand predicates
     /*  230595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  230607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230622 */     GIR_RootConstrainSelectedInstOperands,
     /*  230623 */     // GIR_Coverage, 9043,
     /*  230623 */     GIR_EraseRootFromParent_Done,
     /*  230624 */   // Label 4517: @230624
     /*  230624 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(230698), // Rule ID 9046 //
     /*  230629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  230640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  230643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  230657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230669 */     // MIs[1] Operand 1
     /*  230669 */     // No operand predicates
     /*  230669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230678 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  230681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230696 */     GIR_RootConstrainSelectedInstOperands,
     /*  230697 */     // GIR_Coverage, 9046,
     /*  230697 */     GIR_EraseRootFromParent_Done,
     /*  230698 */   // Label 4518: @230698
     /*  230698 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(230772), // Rule ID 9047 //
     /*  230703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  230714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  230717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  230731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230743 */     // MIs[1] Operand 1
     /*  230743 */     // No operand predicates
     /*  230743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230752 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  230755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230770 */     GIR_RootConstrainSelectedInstOperands,
     /*  230771 */     // GIR_Coverage, 9047,
     /*  230771 */     GIR_EraseRootFromParent_Done,
     /*  230772 */   // Label 4519: @230772
     /*  230772 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(230846), // Rule ID 9050 //
     /*  230777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  230788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  230791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230817 */     // MIs[1] Operand 1
     /*  230817 */     // No operand predicates
     /*  230817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230826 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  230826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  230829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230844 */     GIR_RootConstrainSelectedInstOperands,
     /*  230845 */     // GIR_Coverage, 9050,
     /*  230845 */     GIR_EraseRootFromParent_Done,
     /*  230846 */   // Label 4520: @230846
     /*  230846 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(230920), // Rule ID 9051 //
     /*  230851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  230854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  230862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  230865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  230868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  230871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  230879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230891 */     // MIs[1] Operand 1
     /*  230891 */     // No operand predicates
     /*  230891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230900 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  230900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  230903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  230918 */     GIR_RootConstrainSelectedInstOperands,
     /*  230919 */     // GIR_Coverage, 9051,
     /*  230919 */     GIR_EraseRootFromParent_Done,
     /*  230920 */   // Label 4521: @230920
     /*  230920 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(230994), // Rule ID 9054 //
     /*  230925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  230928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  230933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  230936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  230939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  230942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  230945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  230949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  230953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  230957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  230961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  230965 */     // MIs[1] Operand 1
     /*  230965 */     // No operand predicates
     /*  230965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  230967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  230974 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  230974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  230977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  230979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  230981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  230984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  230989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  230992 */     GIR_RootConstrainSelectedInstOperands,
     /*  230993 */     // GIR_Coverage, 9054,
     /*  230993 */     GIR_EraseRootFromParent_Done,
     /*  230994 */   // Label 4522: @230994
     /*  230994 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(231068), // Rule ID 9055 //
     /*  230999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  231013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231039 */     // MIs[1] Operand 1
     /*  231039 */     // No operand predicates
     /*  231039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231048 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231066 */     GIR_RootConstrainSelectedInstOperands,
     /*  231067 */     // GIR_Coverage, 9055,
     /*  231067 */     GIR_EraseRootFromParent_Done,
     /*  231068 */   // Label 4523: @231068
     /*  231068 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(231142), // Rule ID 9058 //
     /*  231073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231113 */     // MIs[1] Operand 1
     /*  231113 */     // No operand predicates
     /*  231113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231122 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231140 */     GIR_RootConstrainSelectedInstOperands,
     /*  231141 */     // GIR_Coverage, 9058,
     /*  231141 */     GIR_EraseRootFromParent_Done,
     /*  231142 */   // Label 4524: @231142
     /*  231142 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(231216), // Rule ID 9059 //
     /*  231147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  231161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231187 */     // MIs[1] Operand 1
     /*  231187 */     // No operand predicates
     /*  231187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231214 */     GIR_RootConstrainSelectedInstOperands,
     /*  231215 */     // GIR_Coverage, 9059,
     /*  231215 */     GIR_EraseRootFromParent_Done,
     /*  231216 */   // Label 4525: @231216
     /*  231216 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(231290), // Rule ID 9062 //
     /*  231221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231261 */     // MIs[1] Operand 1
     /*  231261 */     // No operand predicates
     /*  231261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231270 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  231270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231288 */     GIR_RootConstrainSelectedInstOperands,
     /*  231289 */     // GIR_Coverage, 9062,
     /*  231289 */     GIR_EraseRootFromParent_Done,
     /*  231290 */   // Label 4526: @231290
     /*  231290 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(231364), // Rule ID 9063 //
     /*  231295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  231306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  231309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231335 */     // MIs[1] Operand 1
     /*  231335 */     // No operand predicates
     /*  231335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231344 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  231344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  231362 */     GIR_RootConstrainSelectedInstOperands,
     /*  231363 */     // GIR_Coverage, 9063,
     /*  231363 */     GIR_EraseRootFromParent_Done,
     /*  231364 */   // Label 4527: @231364
     /*  231364 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(231438), // Rule ID 9066 //
     /*  231369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231409 */     // MIs[1] Operand 1
     /*  231409 */     // No operand predicates
     /*  231409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231418 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231436 */     GIR_RootConstrainSelectedInstOperands,
     /*  231437 */     // GIR_Coverage, 9066,
     /*  231437 */     GIR_EraseRootFromParent_Done,
     /*  231438 */   // Label 4528: @231438
     /*  231438 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(231512), // Rule ID 9067 //
     /*  231443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  231457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231483 */     // MIs[1] Operand 1
     /*  231483 */     // No operand predicates
     /*  231483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231510 */     GIR_RootConstrainSelectedInstOperands,
     /*  231511 */     // GIR_Coverage, 9067,
     /*  231511 */     GIR_EraseRootFromParent_Done,
     /*  231512 */   // Label 4529: @231512
     /*  231512 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(231586), // Rule ID 9070 //
     /*  231517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  231531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231557 */     // MIs[1] Operand 1
     /*  231557 */     // No operand predicates
     /*  231557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231584 */     GIR_RootConstrainSelectedInstOperands,
     /*  231585 */     // GIR_Coverage, 9070,
     /*  231585 */     GIR_EraseRootFromParent_Done,
     /*  231586 */   // Label 4530: @231586
     /*  231586 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(231660), // Rule ID 9071 //
     /*  231591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  231602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  231605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231631 */     // MIs[1] Operand 1
     /*  231631 */     // No operand predicates
     /*  231631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  231643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231658 */     GIR_RootConstrainSelectedInstOperands,
     /*  231659 */     // GIR_Coverage, 9071,
     /*  231659 */     GIR_EraseRootFromParent_Done,
     /*  231660 */   // Label 4531: @231660
     /*  231660 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(231734), // Rule ID 9074 //
     /*  231665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  231668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  231679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231705 */     // MIs[1] Operand 1
     /*  231705 */     // No operand predicates
     /*  231705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231714 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  231714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231732 */     GIR_RootConstrainSelectedInstOperands,
     /*  231733 */     // GIR_Coverage, 9074,
     /*  231733 */     GIR_EraseRootFromParent_Done,
     /*  231734 */   // Label 4532: @231734
     /*  231734 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(231808), // Rule ID 9075 //
     /*  231739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  231742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  231750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  231753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  231767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231779 */     // MIs[1] Operand 1
     /*  231779 */     // No operand predicates
     /*  231779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  231788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  231791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  231806 */     GIR_RootConstrainSelectedInstOperands,
     /*  231807 */     // GIR_Coverage, 9075,
     /*  231807 */     GIR_EraseRootFromParent_Done,
     /*  231808 */   // Label 4533: @231808
     /*  231808 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(231882), // Rule ID 9078 //
     /*  231813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  231827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231853 */     // MIs[1] Operand 1
     /*  231853 */     // No operand predicates
     /*  231853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  231862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231880 */     GIR_RootConstrainSelectedInstOperands,
     /*  231881 */     // GIR_Coverage, 9078,
     /*  231881 */     GIR_EraseRootFromParent_Done,
     /*  231882 */   // Label 4534: @231882
     /*  231882 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(231956), // Rule ID 9079 //
     /*  231887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  231890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  231898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  231901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  231904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  231907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  231915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  231927 */     // MIs[1] Operand 1
     /*  231927 */     // No operand predicates
     /*  231927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  231929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  231936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  231936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2),
     /*  231939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  231941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  231943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  231946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  231951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  231954 */     GIR_RootConstrainSelectedInstOperands,
     /*  231955 */     // GIR_Coverage, 9079,
     /*  231955 */     GIR_EraseRootFromParent_Done,
     /*  231956 */   // Label 4535: @231956
     /*  231956 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(232030), // Rule ID 9082 //
     /*  231961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  231964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  231969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  231972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  231975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  231978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  231981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  231985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  231989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  231993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  231997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232001 */     // MIs[1] Operand 1
     /*  232001 */     // No operand predicates
     /*  232001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232010 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232028 */     GIR_RootConstrainSelectedInstOperands,
     /*  232029 */     // GIR_Coverage, 9082,
     /*  232029 */     GIR_EraseRootFromParent_Done,
     /*  232030 */   // Label 4536: @232030
     /*  232030 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(232104), // Rule ID 9083 //
     /*  232035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  232049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  232063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232075 */     // MIs[1] Operand 1
     /*  232075 */     // No operand predicates
     /*  232075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232084 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4),
     /*  232087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232102 */     GIR_RootConstrainSelectedInstOperands,
     /*  232103 */     // GIR_Coverage, 9083,
     /*  232103 */     GIR_EraseRootFromParent_Done,
     /*  232104 */   // Label 4537: @232104
     /*  232104 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(232178), // Rule ID 9086 //
     /*  232109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  232112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232149 */     // MIs[1] Operand 1
     /*  232149 */     // No operand predicates
     /*  232149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232158 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  232158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232176 */     GIR_RootConstrainSelectedInstOperands,
     /*  232177 */     // GIR_Coverage, 9086,
     /*  232177 */     GIR_EraseRootFromParent_Done,
     /*  232178 */   // Label 4538: @232178
     /*  232178 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(232252), // Rule ID 9087 //
     /*  232183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  232186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  232191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  232194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  232197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  232211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232223 */     // MIs[1] Operand 1
     /*  232223 */     // No operand predicates
     /*  232223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  232232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8),
     /*  232235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  232250 */     GIR_RootConstrainSelectedInstOperands,
     /*  232251 */     // GIR_Coverage, 9087,
     /*  232251 */     GIR_EraseRootFromParent_Done,
     /*  232252 */   // Label 4539: @232252
     /*  232252 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(232326), // Rule ID 9178 //
     /*  232257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232297 */     // MIs[1] Operand 1
     /*  232297 */     // No operand predicates
     /*  232297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232324 */     GIR_RootConstrainSelectedInstOperands,
     /*  232325 */     // GIR_Coverage, 9178,
     /*  232325 */     GIR_EraseRootFromParent_Done,
     /*  232326 */   // Label 4540: @232326
     /*  232326 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(232400), // Rule ID 9179 //
     /*  232331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  232345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232371 */     // MIs[1] Operand 1
     /*  232371 */     // No operand predicates
     /*  232371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  232380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8),
     /*  232383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232398 */     GIR_RootConstrainSelectedInstOperands,
     /*  232399 */     // GIR_Coverage, 9179,
     /*  232399 */     GIR_EraseRootFromParent_Done,
     /*  232400 */   // Label 4541: @232400
     /*  232400 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(232474), // Rule ID 9182 //
     /*  232405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  232419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232445 */     // MIs[1] Operand 1
     /*  232445 */     // No operand predicates
     /*  232445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232454 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232472 */     GIR_RootConstrainSelectedInstOperands,
     /*  232473 */     // GIR_Coverage, 9182,
     /*  232473 */     GIR_EraseRootFromParent_Done,
     /*  232474 */   // Label 4542: @232474
     /*  232474 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(232548), // Rule ID 9183 //
     /*  232479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  232493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232519 */     // MIs[1] Operand 1
     /*  232519 */     // No operand predicates
     /*  232519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  232528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232546 */     GIR_RootConstrainSelectedInstOperands,
     /*  232547 */     // GIR_Coverage, 9183,
     /*  232547 */     GIR_EraseRootFromParent_Done,
     /*  232548 */   // Label 4543: @232548
     /*  232548 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(232622), // Rule ID 9186 //
     /*  232553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  232567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232593 */     // MIs[1] Operand 1
     /*  232593 */     // No operand predicates
     /*  232593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  232602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  232605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232620 */     GIR_RootConstrainSelectedInstOperands,
     /*  232621 */     // GIR_Coverage, 9186,
     /*  232621 */     GIR_EraseRootFromParent_Done,
     /*  232622 */   // Label 4544: @232622
     /*  232622 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(232696), // Rule ID 9187 //
     /*  232627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  232638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  232641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232667 */     // MIs[1] Operand 1
     /*  232667 */     // No operand predicates
     /*  232667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232676 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  232676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  232679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  232694 */     GIR_RootConstrainSelectedInstOperands,
     /*  232695 */     // GIR_Coverage, 9187,
     /*  232695 */     GIR_EraseRootFromParent_Done,
     /*  232696 */   // Label 4545: @232696
     /*  232696 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(232770), // Rule ID 9190 //
     /*  232701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  232715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232741 */     // MIs[1] Operand 1
     /*  232741 */     // No operand predicates
     /*  232741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232750 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232768 */     GIR_RootConstrainSelectedInstOperands,
     /*  232769 */     // GIR_Coverage, 9190,
     /*  232769 */     GIR_EraseRootFromParent_Done,
     /*  232770 */   // Label 4546: @232770
     /*  232770 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(232844), // Rule ID 9191 //
     /*  232775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  232786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  232789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232815 */     // MIs[1] Operand 1
     /*  232815 */     // No operand predicates
     /*  232815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232824 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4),
     /*  232827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232842 */     GIR_RootConstrainSelectedInstOperands,
     /*  232843 */     // GIR_Coverage, 9191,
     /*  232843 */     GIR_EraseRootFromParent_Done,
     /*  232844 */   // Label 4547: @232844
     /*  232844 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(232918), // Rule ID 9194 //
     /*  232849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  232852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  232863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  232866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  232869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232889 */     // MIs[1] Operand 1
     /*  232889 */     // No operand predicates
     /*  232889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  232898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  232901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232916 */     GIR_RootConstrainSelectedInstOperands,
     /*  232917 */     // GIR_Coverage, 9194,
     /*  232917 */     GIR_EraseRootFromParent_Done,
     /*  232918 */   // Label 4548: @232918
     /*  232918 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(232992), // Rule ID 9195 //
     /*  232923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  232926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  232931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  232934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  232937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  232940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  232943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  232951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  232955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  232959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  232963 */     // MIs[1] Operand 1
     /*  232963 */     // No operand predicates
     /*  232963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  232965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  232972 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  232972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  232975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  232977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  232979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  232982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  232987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  232990 */     GIR_RootConstrainSelectedInstOperands,
     /*  232991 */     // GIR_Coverage, 9195,
     /*  232991 */     GIR_EraseRootFromParent_Done,
     /*  232992 */   // Label 4549: @232992
     /*  232992 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(233066), // Rule ID 9198 //
     /*  232997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233037 */     // MIs[1] Operand 1
     /*  233037 */     // No operand predicates
     /*  233037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233046 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233064 */     GIR_RootConstrainSelectedInstOperands,
     /*  233065 */     // GIR_Coverage, 9198,
     /*  233065 */     GIR_EraseRootFromParent_Done,
     /*  233066 */   // Label 4550: @233066
     /*  233066 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(233140), // Rule ID 9199 //
     /*  233071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  233085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233111 */     // MIs[1] Operand 1
     /*  233111 */     // No operand predicates
     /*  233111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233120 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2),
     /*  233123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233138 */     GIR_RootConstrainSelectedInstOperands,
     /*  233139 */     // GIR_Coverage, 9199,
     /*  233139 */     GIR_EraseRootFromParent_Done,
     /*  233140 */   // Label 4551: @233140
     /*  233140 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(233214), // Rule ID 9202 //
     /*  233145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233185 */     // MIs[1] Operand 1
     /*  233185 */     // No operand predicates
     /*  233185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233194 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233212 */     GIR_RootConstrainSelectedInstOperands,
     /*  233213 */     // GIR_Coverage, 9202,
     /*  233213 */     GIR_EraseRootFromParent_Done,
     /*  233214 */   // Label 4552: @233214
     /*  233214 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(233288), // Rule ID 9203 //
     /*  233219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  233230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  233233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233259 */     // MIs[1] Operand 1
     /*  233259 */     // No operand predicates
     /*  233259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233268 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233286 */     GIR_RootConstrainSelectedInstOperands,
     /*  233287 */     // GIR_Coverage, 9203,
     /*  233287 */     GIR_EraseRootFromParent_Done,
     /*  233288 */   // Label 4553: @233288
     /*  233288 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(233362), // Rule ID 9206 //
     /*  233293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233333 */     // MIs[1] Operand 1
     /*  233333 */     // No operand predicates
     /*  233333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233342 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  233342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233360 */     GIR_RootConstrainSelectedInstOperands,
     /*  233361 */     // GIR_Coverage, 9206,
     /*  233361 */     GIR_EraseRootFromParent_Done,
     /*  233362 */   // Label 4554: @233362
     /*  233362 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(233436), // Rule ID 9207 //
     /*  233367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  233378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  233381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233407 */     // MIs[1] Operand 1
     /*  233407 */     // No operand predicates
     /*  233407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  233416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  233434 */     GIR_RootConstrainSelectedInstOperands,
     /*  233435 */     // GIR_Coverage, 9207,
     /*  233435 */     GIR_EraseRootFromParent_Done,
     /*  233436 */   // Label 4555: @233436
     /*  233436 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(233510), // Rule ID 9210 //
     /*  233441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  233455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233481 */     // MIs[1] Operand 1
     /*  233481 */     // No operand predicates
     /*  233481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233490 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  233490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233508 */     GIR_RootConstrainSelectedInstOperands,
     /*  233509 */     // GIR_Coverage, 9210,
     /*  233509 */     GIR_EraseRootFromParent_Done,
     /*  233510 */   // Label 4556: @233510
     /*  233510 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(233584), // Rule ID 9211 //
     /*  233515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  233526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  233529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233555 */     // MIs[1] Operand 1
     /*  233555 */     // No operand predicates
     /*  233555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  233564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  233582 */     GIR_RootConstrainSelectedInstOperands,
     /*  233583 */     // GIR_Coverage, 9211,
     /*  233583 */     GIR_EraseRootFromParent_Done,
     /*  233584 */   // Label 4557: @233584
     /*  233584 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(233658), // Rule ID 9214 //
     /*  233589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  233592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  233603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233629 */     // MIs[1] Operand 1
     /*  233629 */     // No operand predicates
     /*  233629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  233638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233656 */     GIR_RootConstrainSelectedInstOperands,
     /*  233657 */     // GIR_Coverage, 9214,
     /*  233657 */     GIR_EraseRootFromParent_Done,
     /*  233658 */   // Label 4558: @233658
     /*  233658 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(233732), // Rule ID 9215 //
     /*  233663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  233666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  233674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  233677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233703 */     // MIs[1] Operand 1
     /*  233703 */     // No operand predicates
     /*  233703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  233712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1),
     /*  233715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  233730 */     GIR_RootConstrainSelectedInstOperands,
     /*  233731 */     // GIR_Coverage, 9215,
     /*  233731 */     GIR_EraseRootFromParent_Done,
     /*  233732 */   // Label 4559: @233732
     /*  233732 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(233806), // Rule ID 9218 //
     /*  233737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  233748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  233751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233777 */     // MIs[1] Operand 1
     /*  233777 */     // No operand predicates
     /*  233777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  233789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233804 */     GIR_RootConstrainSelectedInstOperands,
     /*  233805 */     // GIR_Coverage, 9218,
     /*  233805 */     GIR_EraseRootFromParent_Done,
     /*  233806 */   // Label 4560: @233806
     /*  233806 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(233880), // Rule ID 9219 //
     /*  233811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  233822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  233825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  233839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233851 */     // MIs[1] Operand 1
     /*  233851 */     // No operand predicates
     /*  233851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  233860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  233863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233878 */     GIR_RootConstrainSelectedInstOperands,
     /*  233879 */     // GIR_Coverage, 9219,
     /*  233879 */     GIR_EraseRootFromParent_Done,
     /*  233880 */   // Label 4561: @233880
     /*  233880 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(233954), // Rule ID 9222 //
     /*  233885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  233888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  233896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  233899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  233902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  233905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233925 */     // MIs[1] Operand 1
     /*  233925 */     // No operand predicates
     /*  233925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  233927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  233934 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  233934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  233937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  233939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  233941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  233944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  233949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  233952 */     GIR_RootConstrainSelectedInstOperands,
     /*  233953 */     // GIR_Coverage, 9222,
     /*  233953 */     GIR_EraseRootFromParent_Done,
     /*  233954 */   // Label 4562: @233954
     /*  233954 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(234028), // Rule ID 9223 //
     /*  233959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  233962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  233967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  233970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  233973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  233976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  233979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  233983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  233987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  233991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  233995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  233999 */     // MIs[1] Operand 1
     /*  233999 */     // No operand predicates
     /*  233999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234008 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234026 */     GIR_RootConstrainSelectedInstOperands,
     /*  234027 */     // GIR_Coverage, 9223,
     /*  234027 */     GIR_EraseRootFromParent_Done,
     /*  234028 */   // Label 4563: @234028
     /*  234028 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(234102), // Rule ID 9226 //
     /*  234033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234073 */     // MIs[1] Operand 1
     /*  234073 */     // No operand predicates
     /*  234073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234082 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  234082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234100 */     GIR_RootConstrainSelectedInstOperands,
     /*  234101 */     // GIR_Coverage, 9226,
     /*  234101 */     GIR_EraseRootFromParent_Done,
     /*  234102 */   // Label 4564: @234102
     /*  234102 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(234176), // Rule ID 9227 //
     /*  234107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  234118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  234121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234147 */     // MIs[1] Operand 1
     /*  234147 */     // No operand predicates
     /*  234147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234156 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  234156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  234174 */     GIR_RootConstrainSelectedInstOperands,
     /*  234175 */     // GIR_Coverage, 9227,
     /*  234175 */     GIR_EraseRootFromParent_Done,
     /*  234176 */   // Label 4565: @234176
     /*  234176 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(234250), // Rule ID 9230 //
     /*  234181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234221 */     // MIs[1] Operand 1
     /*  234221 */     // No operand predicates
     /*  234221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234248 */     GIR_RootConstrainSelectedInstOperands,
     /*  234249 */     // GIR_Coverage, 9230,
     /*  234249 */     GIR_EraseRootFromParent_Done,
     /*  234250 */   // Label 4566: @234250
     /*  234250 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(234324), // Rule ID 9231 //
     /*  234255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  234269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234295 */     // MIs[1] Operand 1
     /*  234295 */     // No operand predicates
     /*  234295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234322 */     GIR_RootConstrainSelectedInstOperands,
     /*  234323 */     // GIR_Coverage, 9231,
     /*  234323 */     GIR_EraseRootFromParent_Done,
     /*  234324 */   // Label 4567: @234324
     /*  234324 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(234398), // Rule ID 9234 //
     /*  234329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234369 */     // MIs[1] Operand 1
     /*  234369 */     // No operand predicates
     /*  234369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234396 */     GIR_RootConstrainSelectedInstOperands,
     /*  234397 */     // GIR_Coverage, 9234,
     /*  234397 */     GIR_EraseRootFromParent_Done,
     /*  234398 */   // Label 4568: @234398
     /*  234398 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(234472), // Rule ID 9235 //
     /*  234403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  234417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234443 */     // MIs[1] Operand 1
     /*  234443 */     // No operand predicates
     /*  234443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234452 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234470 */     GIR_RootConstrainSelectedInstOperands,
     /*  234471 */     // GIR_Coverage, 9235,
     /*  234471 */     GIR_EraseRootFromParent_Done,
     /*  234472 */   // Label 4569: @234472
     /*  234472 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(234546), // Rule ID 9238 //
     /*  234477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  234491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234517 */     // MIs[1] Operand 1
     /*  234517 */     // No operand predicates
     /*  234517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234526 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  234526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234544 */     GIR_RootConstrainSelectedInstOperands,
     /*  234545 */     // GIR_Coverage, 9238,
     /*  234545 */     GIR_EraseRootFromParent_Done,
     /*  234546 */   // Label 4570: @234546
     /*  234546 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(234620), // Rule ID 9239 //
     /*  234551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  234562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  234565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234591 */     // MIs[1] Operand 1
     /*  234591 */     // No operand predicates
     /*  234591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234600 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  234600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  234618 */     GIR_RootConstrainSelectedInstOperands,
     /*  234619 */     // GIR_Coverage, 9239,
     /*  234619 */     GIR_EraseRootFromParent_Done,
     /*  234620 */   // Label 4571: @234620
     /*  234620 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(234694), // Rule ID 9242 //
     /*  234625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  234639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234665 */     // MIs[1] Operand 1
     /*  234665 */     // No operand predicates
     /*  234665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234692 */     GIR_RootConstrainSelectedInstOperands,
     /*  234693 */     // GIR_Coverage, 9242,
     /*  234693 */     GIR_EraseRootFromParent_Done,
     /*  234694 */   // Label 4572: @234694
     /*  234694 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(234768), // Rule ID 9243 //
     /*  234699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  234710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  234713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  234727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234739 */     // MIs[1] Operand 1
     /*  234739 */     // No operand predicates
     /*  234739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  234751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234766 */     GIR_RootConstrainSelectedInstOperands,
     /*  234767 */     // GIR_Coverage, 9243,
     /*  234767 */     GIR_EraseRootFromParent_Done,
     /*  234768 */   // Label 4573: @234768
     /*  234768 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(234842), // Rule ID 9246 //
     /*  234773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  234787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234813 */     // MIs[1] Operand 1
     /*  234813 */     // No operand predicates
     /*  234813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234840 */     GIR_RootConstrainSelectedInstOperands,
     /*  234841 */     // GIR_Coverage, 9246,
     /*  234841 */     GIR_EraseRootFromParent_Done,
     /*  234842 */   // Label 4574: @234842
     /*  234842 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(234916), // Rule ID 9247 //
     /*  234847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  234858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  234861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  234864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  234867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  234875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234887 */     // MIs[1] Operand 1
     /*  234887 */     // No operand predicates
     /*  234887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  234896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  234899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234914 */     GIR_RootConstrainSelectedInstOperands,
     /*  234915 */     // GIR_Coverage, 9247,
     /*  234915 */     GIR_EraseRootFromParent_Done,
     /*  234916 */   // Label 4575: @234916
     /*  234916 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(234990), // Rule ID 9250 //
     /*  234921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  234924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  234929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  234932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  234935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  234938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  234941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  234945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  234949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  234953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  234957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  234961 */     // MIs[1] Operand 1
     /*  234961 */     // No operand predicates
     /*  234961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  234963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  234970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  234970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  234973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  234975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  234977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  234980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  234985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  234988 */     GIR_RootConstrainSelectedInstOperands,
     /*  234989 */     // GIR_Coverage, 9250,
     /*  234989 */     GIR_EraseRootFromParent_Done,
     /*  234990 */   // Label 4576: @234990
     /*  234990 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(235064), // Rule ID 9251 //
     /*  234995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  234998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  235006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  235009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235031 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235035 */     // MIs[1] Operand 1
     /*  235035 */     // No operand predicates
     /*  235035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  235044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  235062 */     GIR_RootConstrainSelectedInstOperands,
     /*  235063 */     // GIR_Coverage, 9251,
     /*  235063 */     GIR_EraseRootFromParent_Done,
     /*  235064 */   // Label 4577: @235064
     /*  235064 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(235138), // Rule ID 9254 //
     /*  235069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235109 */     // MIs[1] Operand 1
     /*  235109 */     // No operand predicates
     /*  235109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235118 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235136 */     GIR_RootConstrainSelectedInstOperands,
     /*  235137 */     // GIR_Coverage, 9254,
     /*  235137 */     GIR_EraseRootFromParent_Done,
     /*  235138 */   // Label 4578: @235138
     /*  235138 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(235212), // Rule ID 9255 //
     /*  235143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  235157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  235171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235183 */     // MIs[1] Operand 1
     /*  235183 */     // No operand predicates
     /*  235183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2),
     /*  235195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235210 */     GIR_RootConstrainSelectedInstOperands,
     /*  235211 */     // GIR_Coverage, 9255,
     /*  235211 */     GIR_EraseRootFromParent_Done,
     /*  235212 */   // Label 4579: @235212
     /*  235212 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(235286), // Rule ID 9258 //
     /*  235217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235257 */     // MIs[1] Operand 1
     /*  235257 */     // No operand predicates
     /*  235257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235266 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235284 */     GIR_RootConstrainSelectedInstOperands,
     /*  235285 */     // GIR_Coverage, 9258,
     /*  235285 */     GIR_EraseRootFromParent_Done,
     /*  235286 */   // Label 4580: @235286
     /*  235286 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(235360), // Rule ID 9259 //
     /*  235291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  235305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  235319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235331 */     // MIs[1] Operand 1
     /*  235331 */     // No operand predicates
     /*  235331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4),
     /*  235343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235358 */     GIR_RootConstrainSelectedInstOperands,
     /*  235359 */     // GIR_Coverage, 9259,
     /*  235359 */     GIR_EraseRootFromParent_Done,
     /*  235360 */   // Label 4581: @235360
     /*  235360 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(235434), // Rule ID 9262 //
     /*  235365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  235368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235405 */     // MIs[1] Operand 1
     /*  235405 */     // No operand predicates
     /*  235405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235414 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  235414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235432 */     GIR_RootConstrainSelectedInstOperands,
     /*  235433 */     // GIR_Coverage, 9262,
     /*  235433 */     GIR_EraseRootFromParent_Done,
     /*  235434 */   // Label 4582: @235434
     /*  235434 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(235508), // Rule ID 9263 //
     /*  235439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  235442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  235447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  235450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  235453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  235467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235479 */     // MIs[1] Operand 1
     /*  235479 */     // No operand predicates
     /*  235479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  235488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8),
     /*  235491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  235506 */     GIR_RootConstrainSelectedInstOperands,
     /*  235507 */     // GIR_Coverage, 9263,
     /*  235507 */     GIR_EraseRootFromParent_Done,
     /*  235508 */   // Label 4583: @235508
     /*  235508 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(235582), // Rule ID 9354 //
     /*  235513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  235524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  235527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235553 */     // MIs[1] Operand 1
     /*  235553 */     // No operand predicates
     /*  235553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235562 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  235565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235580 */     GIR_RootConstrainSelectedInstOperands,
     /*  235581 */     // GIR_Coverage, 9354,
     /*  235581 */     GIR_EraseRootFromParent_Done,
     /*  235582 */   // Label 4584: @235582
     /*  235582 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(235656), // Rule ID 9355 //
     /*  235587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  235598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  235601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235627 */     // MIs[1] Operand 1
     /*  235627 */     // No operand predicates
     /*  235627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8),
     /*  235639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235654 */     GIR_RootConstrainSelectedInstOperands,
     /*  235655 */     // GIR_Coverage, 9355,
     /*  235655 */     GIR_EraseRootFromParent_Done,
     /*  235656 */   // Label 4585: @235656
     /*  235656 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(235730), // Rule ID 9358 //
     /*  235661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  235675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235701 */     // MIs[1] Operand 1
     /*  235701 */     // No operand predicates
     /*  235701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  235713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235728 */     GIR_RootConstrainSelectedInstOperands,
     /*  235729 */     // GIR_Coverage, 9358,
     /*  235729 */     GIR_EraseRootFromParent_Done,
     /*  235730 */   // Label 4586: @235730
     /*  235730 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(235804), // Rule ID 9359 //
     /*  235735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  235746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  235749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235775 */     // MIs[1] Operand 1
     /*  235775 */     // No operand predicates
     /*  235775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  235787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235802 */     GIR_RootConstrainSelectedInstOperands,
     /*  235803 */     // GIR_Coverage, 9359,
     /*  235803 */     GIR_EraseRootFromParent_Done,
     /*  235804 */   // Label 4587: @235804
     /*  235804 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(235878), // Rule ID 9362 //
     /*  235809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  235823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235849 */     // MIs[1] Operand 1
     /*  235849 */     // No operand predicates
     /*  235849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235858 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  235858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  235861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235876 */     GIR_RootConstrainSelectedInstOperands,
     /*  235877 */     // GIR_Coverage, 9362,
     /*  235877 */     GIR_EraseRootFromParent_Done,
     /*  235878 */   // Label 4588: @235878
     /*  235878 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(235952), // Rule ID 9363 //
     /*  235883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  235886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  235894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  235897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  235900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  235903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235923 */     // MIs[1] Operand 1
     /*  235923 */     // No operand predicates
     /*  235923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  235932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  235932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  235935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  235937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  235939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  235942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  235947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  235950 */     GIR_RootConstrainSelectedInstOperands,
     /*  235951 */     // GIR_Coverage, 9363,
     /*  235951 */     GIR_EraseRootFromParent_Done,
     /*  235952 */   // Label 4589: @235952
     /*  235952 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(236026), // Rule ID 9366 //
     /*  235957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  235960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  235965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  235968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  235971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  235974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  235977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  235985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  235989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  235993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  235997 */     // MIs[1] Operand 1
     /*  235997 */     // No operand predicates
     /*  235997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  235999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236006 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236024 */     GIR_RootConstrainSelectedInstOperands,
     /*  236025 */     // GIR_Coverage, 9366,
     /*  236025 */     GIR_EraseRootFromParent_Done,
     /*  236026 */   // Label 4590: @236026
     /*  236026 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(236100), // Rule ID 9367 //
     /*  236031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  236045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236071 */     // MIs[1] Operand 1
     /*  236071 */     // No operand predicates
     /*  236071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4),
     /*  236083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236098 */     GIR_RootConstrainSelectedInstOperands,
     /*  236099 */     // GIR_Coverage, 9367,
     /*  236099 */     GIR_EraseRootFromParent_Done,
     /*  236100 */   // Label 4591: @236100
     /*  236100 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(236174), // Rule ID 9370 //
     /*  236105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236145 */     // MIs[1] Operand 1
     /*  236145 */     // No operand predicates
     /*  236145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236154 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236172 */     GIR_RootConstrainSelectedInstOperands,
     /*  236173 */     // GIR_Coverage, 9370,
     /*  236173 */     GIR_EraseRootFromParent_Done,
     /*  236174 */   // Label 4592: @236174
     /*  236174 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(236248), // Rule ID 9371 //
     /*  236179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  236193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236219 */     // MIs[1] Operand 1
     /*  236219 */     // No operand predicates
     /*  236219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236246 */     GIR_RootConstrainSelectedInstOperands,
     /*  236247 */     // GIR_Coverage, 9371,
     /*  236247 */     GIR_EraseRootFromParent_Done,
     /*  236248 */   // Label 4593: @236248
     /*  236248 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(236322), // Rule ID 9374 //
     /*  236253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236293 */     // MIs[1] Operand 1
     /*  236293 */     // No operand predicates
     /*  236293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236302 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236320 */     GIR_RootConstrainSelectedInstOperands,
     /*  236321 */     // GIR_Coverage, 9374,
     /*  236321 */     GIR_EraseRootFromParent_Done,
     /*  236322 */   // Label 4594: @236322
     /*  236322 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(236396), // Rule ID 9375 //
     /*  236327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  236341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236367 */     // MIs[1] Operand 1
     /*  236367 */     // No operand predicates
     /*  236367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2),
     /*  236379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236394 */     GIR_RootConstrainSelectedInstOperands,
     /*  236395 */     // GIR_Coverage, 9375,
     /*  236395 */     GIR_EraseRootFromParent_Done,
     /*  236396 */   // Label 4595: @236396
     /*  236396 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(236470), // Rule ID 9378 //
     /*  236401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  236415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236441 */     // MIs[1] Operand 1
     /*  236441 */     // No operand predicates
     /*  236441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236450 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  236450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236468 */     GIR_RootConstrainSelectedInstOperands,
     /*  236469 */     // GIR_Coverage, 9378,
     /*  236469 */     GIR_EraseRootFromParent_Done,
     /*  236470 */   // Label 4596: @236470
     /*  236470 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(236544), // Rule ID 9379 //
     /*  236475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  236486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  236489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236515 */     // MIs[1] Operand 1
     /*  236515 */     // No operand predicates
     /*  236515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  236524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  236542 */     GIR_RootConstrainSelectedInstOperands,
     /*  236543 */     // GIR_Coverage, 9379,
     /*  236543 */     GIR_EraseRootFromParent_Done,
     /*  236544 */   // Label 4597: @236544
     /*  236544 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(236618), // Rule ID 9382 //
     /*  236549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  236563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236589 */     // MIs[1] Operand 1
     /*  236589 */     // No operand predicates
     /*  236589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  236598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236616 */     GIR_RootConstrainSelectedInstOperands,
     /*  236617 */     // GIR_Coverage, 9382,
     /*  236617 */     GIR_EraseRootFromParent_Done,
     /*  236618 */   // Label 4598: @236618
     /*  236618 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(236692), // Rule ID 9383 //
     /*  236623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  236634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  236637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236663 */     // MIs[1] Operand 1
     /*  236663 */     // No operand predicates
     /*  236663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236672 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  236672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  236690 */     GIR_RootConstrainSelectedInstOperands,
     /*  236691 */     // GIR_Coverage, 9383,
     /*  236691 */     GIR_EraseRootFromParent_Done,
     /*  236692 */   // Label 4599: @236692
     /*  236692 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(236766), // Rule ID 9386 //
     /*  236697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  236711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236737 */     // MIs[1] Operand 1
     /*  236737 */     // No operand predicates
     /*  236737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  236746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236764 */     GIR_RootConstrainSelectedInstOperands,
     /*  236765 */     // GIR_Coverage, 9386,
     /*  236765 */     GIR_EraseRootFromParent_Done,
     /*  236766 */   // Label 4600: @236766
     /*  236766 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(236840), // Rule ID 9387 //
     /*  236771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  236774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  236782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  236785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236811 */     // MIs[1] Operand 1
     /*  236811 */     // No operand predicates
     /*  236811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  236820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  236838 */     GIR_RootConstrainSelectedInstOperands,
     /*  236839 */     // GIR_Coverage, 9387,
     /*  236839 */     GIR_EraseRootFromParent_Done,
     /*  236840 */   // Label 4601: @236840
     /*  236840 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(236914), // Rule ID 9390 //
     /*  236845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  236848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  236859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  236862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  236865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236885 */     // MIs[1] Operand 1
     /*  236885 */     // No operand predicates
     /*  236885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236894 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  236894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236912 */     GIR_RootConstrainSelectedInstOperands,
     /*  236913 */     // GIR_Coverage, 9390,
     /*  236913 */     GIR_EraseRootFromParent_Done,
     /*  236914 */   // Label 4602: @236914
     /*  236914 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(236988), // Rule ID 9391 //
     /*  236919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  236922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  236927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  236930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  236933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  236936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  236939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  236947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  236951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  236955 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  236959 */     // MIs[1] Operand 1
     /*  236959 */     // No operand predicates
     /*  236959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  236961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  236968 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  236968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1),
     /*  236971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  236973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  236975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  236978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  236983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  236986 */     GIR_RootConstrainSelectedInstOperands,
     /*  236987 */     // GIR_Coverage, 9391,
     /*  236987 */     GIR_EraseRootFromParent_Done,
     /*  236988 */   // Label 4603: @236988
     /*  236988 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(237062), // Rule ID 9394 //
     /*  236993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  236996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237033 */     // MIs[1] Operand 1
     /*  237033 */     // No operand predicates
     /*  237033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237042 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237060 */     GIR_RootConstrainSelectedInstOperands,
     /*  237061 */     // GIR_Coverage, 9394,
     /*  237061 */     GIR_EraseRootFromParent_Done,
     /*  237062 */   // Label 4604: @237062
     /*  237062 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(237136), // Rule ID 9395 //
     /*  237067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  237081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237107 */     // MIs[1] Operand 1
     /*  237107 */     // No operand predicates
     /*  237107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237134 */     GIR_RootConstrainSelectedInstOperands,
     /*  237135 */     // GIR_Coverage, 9395,
     /*  237135 */     GIR_EraseRootFromParent_Done,
     /*  237136 */   // Label 4605: @237136
     /*  237136 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(237210), // Rule ID 9398 //
     /*  237141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237181 */     // MIs[1] Operand 1
     /*  237181 */     // No operand predicates
     /*  237181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237190 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237208 */     GIR_RootConstrainSelectedInstOperands,
     /*  237209 */     // GIR_Coverage, 9398,
     /*  237209 */     GIR_EraseRootFromParent_Done,
     /*  237210 */   // Label 4606: @237210
     /*  237210 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(237284), // Rule ID 9399 //
     /*  237215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  237229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237255 */     // MIs[1] Operand 1
     /*  237255 */     // No operand predicates
     /*  237255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237264 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237282 */     GIR_RootConstrainSelectedInstOperands,
     /*  237283 */     // GIR_Coverage, 9399,
     /*  237283 */     GIR_EraseRootFromParent_Done,
     /*  237284 */   // Label 4607: @237284
     /*  237284 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(237358), // Rule ID 9402 //
     /*  237289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237329 */     // MIs[1] Operand 1
     /*  237329 */     // No operand predicates
     /*  237329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237338 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  237338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237356 */     GIR_RootConstrainSelectedInstOperands,
     /*  237357 */     // GIR_Coverage, 9402,
     /*  237357 */     GIR_EraseRootFromParent_Done,
     /*  237358 */   // Label 4608: @237358
     /*  237358 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(237432), // Rule ID 9403 //
     /*  237363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  237374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  237377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237403 */     // MIs[1] Operand 1
     /*  237403 */     // No operand predicates
     /*  237403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237412 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  237412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  237430 */     GIR_RootConstrainSelectedInstOperands,
     /*  237431 */     // GIR_Coverage, 9403,
     /*  237431 */     GIR_EraseRootFromParent_Done,
     /*  237432 */   // Label 4609: @237432
     /*  237432 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(237506), // Rule ID 9406 //
     /*  237437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  237451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237477 */     // MIs[1] Operand 1
     /*  237477 */     // No operand predicates
     /*  237477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237504 */     GIR_RootConstrainSelectedInstOperands,
     /*  237505 */     // GIR_Coverage, 9406,
     /*  237505 */     GIR_EraseRootFromParent_Done,
     /*  237506 */   // Label 4610: @237506
     /*  237506 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(237580), // Rule ID 9407 //
     /*  237511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  237522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  237525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237551 */     // MIs[1] Operand 1
     /*  237551 */     // No operand predicates
     /*  237551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237578 */     GIR_RootConstrainSelectedInstOperands,
     /*  237579 */     // GIR_Coverage, 9407,
     /*  237579 */     GIR_EraseRootFromParent_Done,
     /*  237580 */   // Label 4611: @237580
     /*  237580 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(237654), // Rule ID 9410 //
     /*  237585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  237599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237625 */     // MIs[1] Operand 1
     /*  237625 */     // No operand predicates
     /*  237625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237634 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237652 */     GIR_RootConstrainSelectedInstOperands,
     /*  237653 */     // GIR_Coverage, 9410,
     /*  237653 */     GIR_EraseRootFromParent_Done,
     /*  237654 */   // Label 4612: @237654
     /*  237654 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(237728), // Rule ID 9411 //
     /*  237659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  237670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  237673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  237687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237699 */     // MIs[1] Operand 1
     /*  237699 */     // No operand predicates
     /*  237699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237708 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  237711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237726 */     GIR_RootConstrainSelectedInstOperands,
     /*  237727 */     // GIR_Coverage, 9411,
     /*  237727 */     GIR_EraseRootFromParent_Done,
     /*  237728 */   // Label 4613: @237728
     /*  237728 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(237802), // Rule ID 9414 //
     /*  237733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  237747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237773 */     // MIs[1] Operand 1
     /*  237773 */     // No operand predicates
     /*  237773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237782 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  237782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237800 */     GIR_RootConstrainSelectedInstOperands,
     /*  237801 */     // GIR_Coverage, 9414,
     /*  237801 */     GIR_EraseRootFromParent_Done,
     /*  237802 */   // Label 4614: @237802
     /*  237802 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(237876), // Rule ID 9415 //
     /*  237807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  237818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  237821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  237835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237847 */     // MIs[1] Operand 1
     /*  237847 */     // No operand predicates
     /*  237847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237856 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  237856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  237859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  237874 */     GIR_RootConstrainSelectedInstOperands,
     /*  237875 */     // GIR_Coverage, 9415,
     /*  237875 */     GIR_EraseRootFromParent_Done,
     /*  237876 */   // Label 4615: @237876
     /*  237876 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(237950), // Rule ID 9418 //
     /*  237881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  237884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  237895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  237898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  237901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237921 */     // MIs[1] Operand 1
     /*  237921 */     // No operand predicates
     /*  237921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  237930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  237930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  237933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  237935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  237937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  237940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  237945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  237948 */     GIR_RootConstrainSelectedInstOperands,
     /*  237949 */     // GIR_Coverage, 9418,
     /*  237949 */     GIR_EraseRootFromParent_Done,
     /*  237950 */   // Label 4616: @237950
     /*  237950 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(238024), // Rule ID 9419 //
     /*  237955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  237958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  237963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  237966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  237969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  237972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  237975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  237979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  237983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  237987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  237991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  237995 */     // MIs[1] Operand 1
     /*  237995 */     // No operand predicates
     /*  237995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  237997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238022 */     GIR_RootConstrainSelectedInstOperands,
     /*  238023 */     // GIR_Coverage, 9419,
     /*  238023 */     GIR_EraseRootFromParent_Done,
     /*  238024 */   // Label 4617: @238024
     /*  238024 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(238098), // Rule ID 9422 //
     /*  238029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238069 */     // MIs[1] Operand 1
     /*  238069 */     // No operand predicates
     /*  238069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238078 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238096 */     GIR_RootConstrainSelectedInstOperands,
     /*  238097 */     // GIR_Coverage, 9422,
     /*  238097 */     GIR_EraseRootFromParent_Done,
     /*  238098 */   // Label 4618: @238098
     /*  238098 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(238172), // Rule ID 9423 //
     /*  238103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  238117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238143 */     // MIs[1] Operand 1
     /*  238143 */     // No operand predicates
     /*  238143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238170 */     GIR_RootConstrainSelectedInstOperands,
     /*  238171 */     // GIR_Coverage, 9423,
     /*  238171 */     GIR_EraseRootFromParent_Done,
     /*  238172 */   // Label 4619: @238172
     /*  238172 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(238246), // Rule ID 9426 //
     /*  238177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238217 */     // MIs[1] Operand 1
     /*  238217 */     // No operand predicates
     /*  238217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238226 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  238226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238244 */     GIR_RootConstrainSelectedInstOperands,
     /*  238245 */     // GIR_Coverage, 9426,
     /*  238245 */     GIR_EraseRootFromParent_Done,
     /*  238246 */   // Label 4620: @238246
     /*  238246 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(238320), // Rule ID 9427 //
     /*  238251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  238254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  238262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  238265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238291 */     // MIs[1] Operand 1
     /*  238291 */     // No operand predicates
     /*  238291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  238300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  238318 */     GIR_RootConstrainSelectedInstOperands,
     /*  238319 */     // GIR_Coverage, 9427,
     /*  238319 */     GIR_EraseRootFromParent_Done,
     /*  238320 */   // Label 4621: @238320
     /*  238320 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(238394), // Rule ID 9430 //
     /*  238325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238365 */     // MIs[1] Operand 1
     /*  238365 */     // No operand predicates
     /*  238365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238374 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238392 */     GIR_RootConstrainSelectedInstOperands,
     /*  238393 */     // GIR_Coverage, 9430,
     /*  238393 */     GIR_EraseRootFromParent_Done,
     /*  238394 */   // Label 4622: @238394
     /*  238394 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(238468), // Rule ID 9431 //
     /*  238399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  238410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  238413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  238427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238439 */     // MIs[1] Operand 1
     /*  238439 */     // No operand predicates
     /*  238439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2),
     /*  238451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238466 */     GIR_RootConstrainSelectedInstOperands,
     /*  238467 */     // GIR_Coverage, 9431,
     /*  238467 */     GIR_EraseRootFromParent_Done,
     /*  238468 */   // Label 4623: @238468
     /*  238468 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(238542), // Rule ID 9434 //
     /*  238473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  238487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238513 */     // MIs[1] Operand 1
     /*  238513 */     // No operand predicates
     /*  238513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238522 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238540 */     GIR_RootConstrainSelectedInstOperands,
     /*  238541 */     // GIR_Coverage, 9434,
     /*  238541 */     GIR_EraseRootFromParent_Done,
     /*  238542 */   // Label 4624: @238542
     /*  238542 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(238616), // Rule ID 9435 //
     /*  238547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  238558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  238561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  238575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238587 */     // MIs[1] Operand 1
     /*  238587 */     // No operand predicates
     /*  238587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4),
     /*  238599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238614 */     GIR_RootConstrainSelectedInstOperands,
     /*  238615 */     // GIR_Coverage, 9435,
     /*  238615 */     GIR_EraseRootFromParent_Done,
     /*  238616 */   // Label 4625: @238616
     /*  238616 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(238690), // Rule ID 9438 //
     /*  238621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  238624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  238635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  238638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238661 */     // MIs[1] Operand 1
     /*  238661 */     // No operand predicates
     /*  238661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  238670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238688 */     GIR_RootConstrainSelectedInstOperands,
     /*  238689 */     // GIR_Coverage, 9438,
     /*  238689 */     GIR_EraseRootFromParent_Done,
     /*  238690 */   // Label 4626: @238690
     /*  238690 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(238764), // Rule ID 9439 //
     /*  238695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  238698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  238703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  238706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  238709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  238712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  238723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  238727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  238731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  238735 */     // MIs[1] Operand 1
     /*  238735 */     // No operand predicates
     /*  238735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  238737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  238744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8),
     /*  238747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  238754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  238762 */     GIR_RootConstrainSelectedInstOperands,
     /*  238763 */     // GIR_Coverage, 9439,
     /*  238763 */     GIR_EraseRootFromParent_Done,
     /*  238764 */   // Label 4627: @238764
     /*  238764 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(238820), // Rule ID 64420 //
     /*  238769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  238772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_bitrev),
     /*  238777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  238780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  238783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  238787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  238791 */     // MIs[0] pts
     /*  238791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  238794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  238799 */     // MIs[0] radix
     /*  238799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  238802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm2),
     /*  238807 */     // (intrinsic_wo_chain:{ *:[i32] } 10926:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm2>>:$radix, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$pts)
     /*  238807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /*  238810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238814 */     GIR_RootToRootCopy, /*OpIdx*/4, // radix
     /*  238816 */     GIR_RootToRootCopy, /*OpIdx*/3, // pts
     /*  238818 */     GIR_RootConstrainSelectedInstOperands,
     /*  238819 */     // GIR_Coverage, 64420,
     /*  238819 */     GIR_EraseRootFromParent_Done,
     /*  238820 */   // Label 4628: @238820
     /*  238820 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(238883), // Rule ID 2576 //
     /*  238825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  238828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  238833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  238836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  238839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  238842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  238849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  238857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238864 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  238864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  238867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238871 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  238873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  238881 */     GIR_RootConstrainSelectedInstOperands,
     /*  238882 */     // GIR_Coverage, 2576,
     /*  238882 */     GIR_EraseRootFromParent_Done,
     /*  238883 */   // Label 4629: @238883
     /*  238883 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(238946), // Rule ID 2577 //
     /*  238888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  238891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  238896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  238899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  238902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  238905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  238908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  238912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  238920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238927 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  238927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B64_MASK),
     /*  238930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  238934 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  238936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  238941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  238944 */     GIR_RootConstrainSelectedInstOperands,
     /*  238945 */     // GIR_Coverage, 2577,
     /*  238945 */     GIR_EraseRootFromParent_Done,
     /*  238946 */   // Label 4630: @238946
     /*  238946 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(239012), // Rule ID 2584 //
     /*  238951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  238954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  238959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  238962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  238965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  238968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  238971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  238983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  238990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  238990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  238993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  238995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  238997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  238999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239010 */     GIR_RootConstrainSelectedInstOperands,
     /*  239011 */     // GIR_Coverage, 2584,
     /*  239011 */     GIR_EraseRootFromParent_Done,
     /*  239012 */   // Label 4631: @239012
     /*  239012 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(239078), // Rule ID 2585 //
     /*  239017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  239025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  239028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239056 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  239056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8),
     /*  239059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239076 */     GIR_RootConstrainSelectedInstOperands,
     /*  239077 */     // GIR_Coverage, 2585,
     /*  239077 */     GIR_EraseRootFromParent_Done,
     /*  239078 */   // Label 4632: @239078
     /*  239078 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(239144), // Rule ID 2588 //
     /*  239083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239142 */     GIR_RootConstrainSelectedInstOperands,
     /*  239143 */     // GIR_Coverage, 2588,
     /*  239143 */     GIR_EraseRootFromParent_Done,
     /*  239144 */   // Label 4633: @239144
     /*  239144 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(239210), // Rule ID 2589 //
     /*  239149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /*  239191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239208 */     GIR_RootConstrainSelectedInstOperands,
     /*  239209 */     // GIR_Coverage, 2589,
     /*  239209 */     GIR_EraseRootFromParent_Done,
     /*  239210 */   // Label 4634: @239210
     /*  239210 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(239276), // Rule ID 2592 //
     /*  239215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  239218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239254 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239274 */     GIR_RootConstrainSelectedInstOperands,
     /*  239275 */     // GIR_Coverage, 2592,
     /*  239275 */     GIR_EraseRootFromParent_Done,
     /*  239276 */   // Label 4635: @239276
     /*  239276 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(239342), // Rule ID 2593 //
     /*  239281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  239284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  239289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16),
     /*  239323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239340 */     GIR_RootConstrainSelectedInstOperands,
     /*  239341 */     // GIR_Coverage, 2593,
     /*  239341 */     GIR_EraseRootFromParent_Done,
     /*  239342 */   // Label 4636: @239342
     /*  239342 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(239405), // Rule ID 2606 //
     /*  239347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239386 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239403 */     GIR_RootConstrainSelectedInstOperands,
     /*  239404 */     // GIR_Coverage, 2606,
     /*  239404 */     GIR_EraseRootFromParent_Done,
     /*  239405 */   // Label 4637: @239405
     /*  239405 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(239468), // Rule ID 2607 //
     /*  239410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  239418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239449 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /*  239452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239466 */     GIR_RootConstrainSelectedInstOperands,
     /*  239467 */     // GIR_Coverage, 2607,
     /*  239467 */     GIR_EraseRootFromParent_Done,
     /*  239468 */   // Label 4638: @239468
     /*  239468 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(239531), // Rule ID 2618 //
     /*  239473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  239515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239529 */     GIR_RootConstrainSelectedInstOperands,
     /*  239530 */     // GIR_Coverage, 2618,
     /*  239530 */     GIR_EraseRootFromParent_Done,
     /*  239531 */   // Label 4639: @239531
     /*  239531 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(239594), // Rule ID 2619 //
     /*  239536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  239544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239575 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  239578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  239582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  239584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239592 */     GIR_RootConstrainSelectedInstOperands,
     /*  239593 */     // GIR_Coverage, 2619,
     /*  239593 */     GIR_EraseRootFromParent_Done,
     /*  239594 */   // Label 4640: @239594
     /*  239594 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(239657), // Rule ID 2626 //
     /*  239599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  239607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239638 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  239638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  239641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239655 */     GIR_RootConstrainSelectedInstOperands,
     /*  239656 */     // GIR_Coverage, 2626,
     /*  239656 */     GIR_EraseRootFromParent_Done,
     /*  239657 */   // Label 4641: @239657
     /*  239657 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(239720), // Rule ID 2627 //
     /*  239662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  239670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  239676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  239679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239701 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  239701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF8),
     /*  239704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  239718 */     GIR_RootConstrainSelectedInstOperands,
     /*  239719 */     // GIR_Coverage, 2627,
     /*  239719 */     GIR_EraseRootFromParent_Done,
     /*  239720 */   // Label 4642: @239720
     /*  239720 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(239786), // Rule ID 2628 //
     /*  239725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  239728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  239733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239764 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  239764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  239767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239784 */     GIR_RootConstrainSelectedInstOperands,
     /*  239785 */     // GIR_Coverage, 2628,
     /*  239785 */     GIR_EraseRootFromParent_Done,
     /*  239786 */   // Label 4643: @239786
     /*  239786 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(239852), // Rule ID 2629 //
     /*  239791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  239794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  239799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  239802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  239805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  239808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  239830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4),
     /*  239833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  239837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  239847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239850 */     GIR_RootConstrainSelectedInstOperands,
     /*  239851 */     // GIR_Coverage, 2629,
     /*  239851 */     GIR_EraseRootFromParent_Done,
     /*  239852 */   // Label 4644: @239852
     /*  239852 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(239915), // Rule ID 2640 //
     /*  239857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  239865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  239877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  239896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  239899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239913 */     GIR_RootConstrainSelectedInstOperands,
     /*  239914 */     // GIR_Coverage, 2640,
     /*  239914 */     GIR_EraseRootFromParent_Done,
     /*  239915 */   // Label 4645: @239915
     /*  239915 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(239978), // Rule ID 2641 //
     /*  239920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  239923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  239928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  239931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  239934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  239937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  239940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  239952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  239959 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  239959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B64),
     /*  239962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  239964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  239966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  239968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  239973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  239976 */     GIR_RootConstrainSelectedInstOperands,
     /*  239977 */     // GIR_Coverage, 2641,
     /*  239977 */     GIR_EraseRootFromParent_Done,
     /*  239978 */   // Label 4646: @239978
     /*  239978 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(240044), // Rule ID 4780 //
     /*  239983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  239986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  239991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  239994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  239997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240022 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240042 */     GIR_RootConstrainSelectedInstOperands,
     /*  240043 */     // GIR_Coverage, 4780,
     /*  240043 */     GIR_EraseRootFromParent_Done,
     /*  240044 */   // Label 4647: @240044
     /*  240044 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(240110), // Rule ID 4781 //
     /*  240049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  240060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  240063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  240066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240088 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240108 */     GIR_RootConstrainSelectedInstOperands,
     /*  240109 */     // GIR_Coverage, 4781,
     /*  240109 */     GIR_EraseRootFromParent_Done,
     /*  240110 */   // Label 4648: @240110
     /*  240110 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(240176), // Rule ID 4784 //
     /*  240115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240174 */     GIR_RootConstrainSelectedInstOperands,
     /*  240175 */     // GIR_Coverage, 4784,
     /*  240175 */     GIR_EraseRootFromParent_Done,
     /*  240176 */   // Label 4649: @240176
     /*  240176 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(240242), // Rule ID 4785 //
     /*  240181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  240192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  240195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  240198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240220 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11608:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240240 */     GIR_RootConstrainSelectedInstOperands,
     /*  240241 */     // GIR_Coverage, 4785,
     /*  240241 */     GIR_EraseRootFromParent_Done,
     /*  240242 */   // Label 4650: @240242
     /*  240242 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(240308), // Rule ID 4788 //
     /*  240247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240286 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240306 */     GIR_RootConstrainSelectedInstOperands,
     /*  240307 */     // GIR_Coverage, 4788,
     /*  240307 */     GIR_EraseRootFromParent_Done,
     /*  240308 */   // Label 4651: @240308
     /*  240308 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(240374), // Rule ID 4789 //
     /*  240313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  240324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  240327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  240330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240372 */     GIR_RootConstrainSelectedInstOperands,
     /*  240373 */     // GIR_Coverage, 4789,
     /*  240373 */     GIR_EraseRootFromParent_Done,
     /*  240374 */   // Label 4652: @240374
     /*  240374 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(240440), // Rule ID 4792 //
     /*  240379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  240421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240438 */     GIR_RootConstrainSelectedInstOperands,
     /*  240439 */     // GIR_Coverage, 4792,
     /*  240439 */     GIR_EraseRootFromParent_Done,
     /*  240440 */   // Label 4653: @240440
     /*  240440 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(240506), // Rule ID 4793 //
     /*  240445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  240456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  240459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  240462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  240487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240504 */     GIR_RootConstrainSelectedInstOperands,
     /*  240505 */     // GIR_Coverage, 4793,
     /*  240505 */     GIR_EraseRootFromParent_Done,
     /*  240506 */   // Label 4654: @240506
     /*  240506 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(240572), // Rule ID 4796 //
     /*  240511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  240522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  240525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  240528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240550 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  240550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  240553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240570 */     GIR_RootConstrainSelectedInstOperands,
     /*  240571 */     // GIR_Coverage, 4796,
     /*  240571 */     GIR_EraseRootFromParent_Done,
     /*  240572 */   // Label 4655: @240572
     /*  240572 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(240638), // Rule ID 4797 //
     /*  240577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  240588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  240591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  240594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  240605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  240609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  240616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  240619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  240633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240636 */     GIR_RootConstrainSelectedInstOperands,
     /*  240637 */     // GIR_Coverage, 4797,
     /*  240637 */     GIR_EraseRootFromParent_Done,
     /*  240638 */   // Label 4656: @240638
     /*  240638 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(240704), // Rule ID 4800 //
     /*  240643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  240654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240682 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  240682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240702 */     GIR_RootConstrainSelectedInstOperands,
     /*  240703 */     // GIR_Coverage, 4800,
     /*  240703 */     GIR_EraseRootFromParent_Done,
     /*  240704 */   // Label 4657: @240704
     /*  240704 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(240770), // Rule ID 4801 //
     /*  240709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  240720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  240723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  240726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240748 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  240748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /*  240751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240768 */     GIR_RootConstrainSelectedInstOperands,
     /*  240769 */     // GIR_Coverage, 4801,
     /*  240769 */     GIR_EraseRootFromParent_Done,
     /*  240770 */   // Label 4658: @240770
     /*  240770 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(240836), // Rule ID 4804 //
     /*  240775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  240786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  240789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  240792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  240814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240834 */     GIR_RootConstrainSelectedInstOperands,
     /*  240835 */     // GIR_Coverage, 4804,
     /*  240835 */     GIR_EraseRootFromParent_Done,
     /*  240836 */   // Label 4659: @240836
     /*  240836 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(240902), // Rule ID 4805 //
     /*  240841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  240852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  240855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  240858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  240880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  240883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240900 */     GIR_RootConstrainSelectedInstOperands,
     /*  240901 */     // GIR_Coverage, 4805,
     /*  240901 */     GIR_EraseRootFromParent_Done,
     /*  240902 */   // Label 4660: @240902
     /*  240902 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(240968), // Rule ID 4808 //
     /*  240907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  240910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  240918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  240921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  240924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  240927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  240939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  240946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  240946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  240949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  240951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  240953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  240955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  240960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  240963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  240966 */     GIR_RootConstrainSelectedInstOperands,
     /*  240967 */     // GIR_Coverage, 4808,
     /*  240967 */     GIR_EraseRootFromParent_Done,
     /*  240968 */   // Label 4661: @240968
     /*  240968 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(241034), // Rule ID 4809 //
     /*  240973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  240976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  240981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  240984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  240987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  240990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  240993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  240997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241032 */     GIR_RootConstrainSelectedInstOperands,
     /*  241033 */     // GIR_Coverage, 4809,
     /*  241033 */     GIR_EraseRootFromParent_Done,
     /*  241034 */   // Label 4662: @241034
     /*  241034 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(241100), // Rule ID 4812 //
     /*  241039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241098 */     GIR_RootConstrainSelectedInstOperands,
     /*  241099 */     // GIR_Coverage, 4812,
     /*  241099 */     GIR_EraseRootFromParent_Done,
     /*  241100 */   // Label 4663: @241100
     /*  241100 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(241166), // Rule ID 4813 //
     /*  241105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  241116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  241119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  241122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241164 */     GIR_RootConstrainSelectedInstOperands,
     /*  241165 */     // GIR_Coverage, 4813,
     /*  241165 */     GIR_EraseRootFromParent_Done,
     /*  241166 */   // Label 4664: @241166
     /*  241166 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(241232), // Rule ID 4816 //
     /*  241171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241230 */     GIR_RootConstrainSelectedInstOperands,
     /*  241231 */     // GIR_Coverage, 4816,
     /*  241231 */     GIR_EraseRootFromParent_Done,
     /*  241232 */   // Label 4665: @241232
     /*  241232 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(241298), // Rule ID 4817 //
     /*  241237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  241248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  241251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  241254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241296 */     GIR_RootConstrainSelectedInstOperands,
     /*  241297 */     // GIR_Coverage, 4817,
     /*  241297 */     GIR_EraseRootFromParent_Done,
     /*  241298 */   // Label 4666: @241298
     /*  241298 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(241364), // Rule ID 4820 //
     /*  241303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241362 */     GIR_RootConstrainSelectedInstOperands,
     /*  241363 */     // GIR_Coverage, 4820,
     /*  241363 */     GIR_EraseRootFromParent_Done,
     /*  241364 */   // Label 4667: @241364
     /*  241364 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(241430), // Rule ID 4821 //
     /*  241369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  241380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  241383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  241386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /*  241411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241428 */     GIR_RootConstrainSelectedInstOperands,
     /*  241429 */     // GIR_Coverage, 4821,
     /*  241429 */     GIR_EraseRootFromParent_Done,
     /*  241430 */   // Label 4668: @241430
     /*  241430 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(241496), // Rule ID 4824 //
     /*  241435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  241446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  241452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241474 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241494 */     GIR_RootConstrainSelectedInstOperands,
     /*  241495 */     // GIR_Coverage, 4824,
     /*  241495 */     GIR_EraseRootFromParent_Done,
     /*  241496 */   // Label 4669: @241496
     /*  241496 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(241562), // Rule ID 4825 //
     /*  241501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  241512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  241515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  241518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /*  241543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241560 */     GIR_RootConstrainSelectedInstOperands,
     /*  241561 */     // GIR_Coverage, 4825,
     /*  241561 */     GIR_EraseRootFromParent_Done,
     /*  241562 */   // Label 4670: @241562
     /*  241562 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(241628), // Rule ID 4828 //
     /*  241567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  241578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  241581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  241584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241626 */     GIR_RootConstrainSelectedInstOperands,
     /*  241627 */     // GIR_Coverage, 4828,
     /*  241627 */     GIR_EraseRootFromParent_Done,
     /*  241628 */   // Label 4671: @241628
     /*  241628 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(241694), // Rule ID 4829 //
     /*  241633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  241644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  241647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  241650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  241665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /*  241675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241692 */     GIR_RootConstrainSelectedInstOperands,
     /*  241693 */     // GIR_Coverage, 4829,
     /*  241693 */     GIR_EraseRootFromParent_Done,
     /*  241694 */   // Label 4672: @241694
     /*  241694 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(241760), // Rule ID 4832 //
     /*  241699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  241702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  241710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  241713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  241716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  241738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241758 */     GIR_RootConstrainSelectedInstOperands,
     /*  241759 */     // GIR_Coverage, 4832,
     /*  241759 */     GIR_EraseRootFromParent_Done,
     /*  241760 */   // Label 4673: @241760
     /*  241760 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(241826), // Rule ID 4833 //
     /*  241765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  241768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  241776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  241779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  241782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  241793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  241797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241804 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  241804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /*  241807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  241821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241824 */     GIR_RootConstrainSelectedInstOperands,
     /*  241825 */     // GIR_Coverage, 4833,
     /*  241825 */     GIR_EraseRootFromParent_Done,
     /*  241826 */   // Label 4674: @241826
     /*  241826 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(241892), // Rule ID 4836 //
     /*  241831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  241848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  241870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  241873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241890 */     GIR_RootConstrainSelectedInstOperands,
     /*  241891 */     // GIR_Coverage, 4836,
     /*  241891 */     GIR_EraseRootFromParent_Done,
     /*  241892 */   // Label 4675: @241892
     /*  241892 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(241958), // Rule ID 4837 //
     /*  241897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  241900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  241908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  241911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  241914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  241917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  241936 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  241936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /*  241939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  241941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  241943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  241945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  241950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  241953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  241956 */     GIR_RootConstrainSelectedInstOperands,
     /*  241957 */     // GIR_Coverage, 4837,
     /*  241957 */     GIR_EraseRootFromParent_Done,
     /*  241958 */   // Label 4676: @241958
     /*  241958 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(242024), // Rule ID 4840 //
     /*  241963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  241966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  241971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  241974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  241977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  241980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  241983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  241995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242022 */     GIR_RootConstrainSelectedInstOperands,
     /*  242023 */     // GIR_Coverage, 4840,
     /*  242023 */     GIR_EraseRootFromParent_Done,
     /*  242024 */   // Label 4677: @242024
     /*  242024 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(242090), // Rule ID 4841 //
     /*  242029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  242040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  242043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  242046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11608:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242088 */     GIR_RootConstrainSelectedInstOperands,
     /*  242089 */     // GIR_Coverage, 4841,
     /*  242089 */     GIR_EraseRootFromParent_Done,
     /*  242090 */   // Label 4678: @242090
     /*  242090 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(242156), // Rule ID 4844 //
     /*  242095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242154 */     GIR_RootConstrainSelectedInstOperands,
     /*  242155 */     // GIR_Coverage, 4844,
     /*  242155 */     GIR_EraseRootFromParent_Done,
     /*  242156 */   // Label 4679: @242156
     /*  242156 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(242222), // Rule ID 4845 //
     /*  242161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  242172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  242175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  242178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242220 */     GIR_RootConstrainSelectedInstOperands,
     /*  242221 */     // GIR_Coverage, 4845,
     /*  242221 */     GIR_EraseRootFromParent_Done,
     /*  242222 */   // Label 4680: @242222
     /*  242222 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(242288), // Rule ID 4848 //
     /*  242227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242286 */     GIR_RootConstrainSelectedInstOperands,
     /*  242287 */     // GIR_Coverage, 4848,
     /*  242287 */     GIR_EraseRootFromParent_Done,
     /*  242288 */   // Label 4681: @242288
     /*  242288 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(242354), // Rule ID 4849 //
     /*  242293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  242304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  242307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  242310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242332 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242352 */     GIR_RootConstrainSelectedInstOperands,
     /*  242353 */     // GIR_Coverage, 4849,
     /*  242353 */     GIR_EraseRootFromParent_Done,
     /*  242354 */   // Label 4682: @242354
     /*  242354 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(242420), // Rule ID 4852 //
     /*  242359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  242362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  242398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242418 */     GIR_RootConstrainSelectedInstOperands,
     /*  242419 */     // GIR_Coverage, 4852,
     /*  242419 */     GIR_EraseRootFromParent_Done,
     /*  242420 */   // Label 4683: @242420
     /*  242420 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(242486), // Rule ID 4853 //
     /*  242425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  242428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  242436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  242439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  242442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  242464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  242481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242484 */     GIR_RootConstrainSelectedInstOperands,
     /*  242485 */     // GIR_Coverage, 4853,
     /*  242485 */     GIR_EraseRootFromParent_Done,
     /*  242486 */   // Label 4684: @242486
     /*  242486 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(242552), // Rule ID 4856 //
     /*  242491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  242508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242530 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242550 */     GIR_RootConstrainSelectedInstOperands,
     /*  242551 */     // GIR_Coverage, 4856,
     /*  242551 */     GIR_EraseRootFromParent_Done,
     /*  242552 */   // Label 4685: @242552
     /*  242552 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(242618), // Rule ID 4857 //
     /*  242557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  242568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  242571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  242574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /*  242599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242616 */     GIR_RootConstrainSelectedInstOperands,
     /*  242617 */     // GIR_Coverage, 4857,
     /*  242617 */     GIR_EraseRootFromParent_Done,
     /*  242618 */   // Label 4686: @242618
     /*  242618 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(242684), // Rule ID 4860 //
     /*  242623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  242640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242682 */     GIR_RootConstrainSelectedInstOperands,
     /*  242683 */     // GIR_Coverage, 4860,
     /*  242683 */     GIR_EraseRootFromParent_Done,
     /*  242684 */   // Label 4687: @242684
     /*  242684 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(242750), // Rule ID 4861 //
     /*  242689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  242700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  242703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  242706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /*  242731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242748 */     GIR_RootConstrainSelectedInstOperands,
     /*  242749 */     // GIR_Coverage, 4861,
     /*  242749 */     GIR_EraseRootFromParent_Done,
     /*  242750 */   // Label 4688: @242750
     /*  242750 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(242816), // Rule ID 4864 //
     /*  242755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  242772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242814 */     GIR_RootConstrainSelectedInstOperands,
     /*  242815 */     // GIR_Coverage, 4864,
     /*  242815 */     GIR_EraseRootFromParent_Done,
     /*  242816 */   // Label 4689: @242816
     /*  242816 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(242882), // Rule ID 4865 //
     /*  242821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  242832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  242835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  242838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  242849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  242853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /*  242863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242880 */     GIR_RootConstrainSelectedInstOperands,
     /*  242881 */     // GIR_Coverage, 4865,
     /*  242881 */     GIR_EraseRootFromParent_Done,
     /*  242882 */   // Label 4690: @242882
     /*  242882 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(242948), // Rule ID 4868 //
     /*  242887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  242890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  242907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  242926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  242935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  242940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  242943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  242946 */     GIR_RootConstrainSelectedInstOperands,
     /*  242947 */     // GIR_Coverage, 4868,
     /*  242947 */     GIR_EraseRootFromParent_Done,
     /*  242948 */   // Label 4691: @242948
     /*  242948 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(243014), // Rule ID 4869 //
     /*  242953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  242956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  242961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  242964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  242967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  242970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  242973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  242981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  242985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  242992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  242992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /*  242995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  242997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  242999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243012 */     GIR_RootConstrainSelectedInstOperands,
     /*  243013 */     // GIR_Coverage, 4869,
     /*  243013 */     GIR_EraseRootFromParent_Done,
     /*  243014 */   // Label 4692: @243014
     /*  243014 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(243080), // Rule ID 4872 //
     /*  243019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243078 */     GIR_RootConstrainSelectedInstOperands,
     /*  243079 */     // GIR_Coverage, 4872,
     /*  243079 */     GIR_EraseRootFromParent_Done,
     /*  243080 */   // Label 4693: @243080
     /*  243080 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(243146), // Rule ID 4873 //
     /*  243085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  243096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  243099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11608:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /*  243127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243144 */     GIR_RootConstrainSelectedInstOperands,
     /*  243145 */     // GIR_Coverage, 4873,
     /*  243145 */     GIR_EraseRootFromParent_Done,
     /*  243146 */   // Label 4694: @243146
     /*  243146 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(243212), // Rule ID 4876 //
     /*  243151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243210 */     GIR_RootConstrainSelectedInstOperands,
     /*  243211 */     // GIR_Coverage, 4876,
     /*  243211 */     GIR_EraseRootFromParent_Done,
     /*  243212 */   // Label 4695: @243212
     /*  243212 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(243278), // Rule ID 4877 //
     /*  243217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  243228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  243231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11608:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /*  243259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243276 */     GIR_RootConstrainSelectedInstOperands,
     /*  243277 */     // GIR_Coverage, 4877,
     /*  243277 */     GIR_EraseRootFromParent_Done,
     /*  243278 */   // Label 4696: @243278
     /*  243278 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(243344), // Rule ID 4880 //
     /*  243283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243322 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243342 */     GIR_RootConstrainSelectedInstOperands,
     /*  243343 */     // GIR_Coverage, 4880,
     /*  243343 */     GIR_EraseRootFromParent_Done,
     /*  243344 */   // Label 4697: @243344
     /*  243344 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(243410), // Rule ID 4881 //
     /*  243349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  243360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  243363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  243377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11608:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /*  243391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243408 */     GIR_RootConstrainSelectedInstOperands,
     /*  243409 */     // GIR_Coverage, 4881,
     /*  243409 */     GIR_EraseRootFromParent_Done,
     /*  243410 */   // Label 4698: @243410
     /*  243410 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(243476), // Rule ID 4884 //
     /*  243415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  243418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  243454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  243457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243474 */     GIR_RootConstrainSelectedInstOperands,
     /*  243475 */     // GIR_Coverage, 4884,
     /*  243475 */     GIR_EraseRootFromParent_Done,
     /*  243476 */   // Label 4699: @243476
     /*  243476 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(243542), // Rule ID 4885 //
     /*  243481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  243484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext),
     /*  243489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  243492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  243495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  243509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11608:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  243520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /*  243523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  243537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243540 */     GIR_RootConstrainSelectedInstOperands,
     /*  243541 */     // GIR_Coverage, 4885,
     /*  243541 */     GIR_EraseRootFromParent_Done,
     /*  243542 */   // Label 4700: @243542
     /*  243542 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(243608), // Rule ID 4888 //
     /*  243547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  243589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243606 */     GIR_RootConstrainSelectedInstOperands,
     /*  243607 */     // GIR_Coverage, 4888,
     /*  243607 */     GIR_EraseRootFromParent_Done,
     /*  243608 */   // Label 4701: @243608
     /*  243608 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(243674), // Rule ID 4889 //
     /*  243613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  243624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  243627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  243630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243652 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /*  243655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243672 */     GIR_RootConstrainSelectedInstOperands,
     /*  243673 */     // GIR_Coverage, 4889,
     /*  243673 */     GIR_EraseRootFromParent_Done,
     /*  243674 */   // Label 4702: @243674
     /*  243674 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(243740), // Rule ID 4892 //
     /*  243679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  243690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  243693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  243721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243738 */     GIR_RootConstrainSelectedInstOperands,
     /*  243739 */     // GIR_Coverage, 4892,
     /*  243739 */     GIR_EraseRootFromParent_Done,
     /*  243740 */   // Label 4703: @243740
     /*  243740 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(243806), // Rule ID 4893 //
     /*  243745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  243756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  243759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  243762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  243787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243804 */     GIR_RootConstrainSelectedInstOperands,
     /*  243805 */     // GIR_Coverage, 4893,
     /*  243805 */     GIR_EraseRootFromParent_Done,
     /*  243806 */   // Label 4704: @243806
     /*  243806 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(243872), // Rule ID 4896 //
     /*  243811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  243822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  243825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  243853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243870 */     GIR_RootConstrainSelectedInstOperands,
     /*  243871 */     // GIR_Coverage, 4896,
     /*  243871 */     GIR_EraseRootFromParent_Done,
     /*  243872 */   // Label 4705: @243872
     /*  243872 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(243938), // Rule ID 4897 //
     /*  243877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  243880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  243888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  243891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  243894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  243897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11471:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  243916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  243919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  243936 */     GIR_RootConstrainSelectedInstOperands,
     /*  243937 */     // GIR_Coverage, 4897,
     /*  243937 */     GIR_EraseRootFromParent_Done,
     /*  243938 */   // Label 4706: @243938
     /*  243938 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(244004), // Rule ID 4900 //
     /*  243943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  243946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  243951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  243954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  243957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  243960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  243963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  243971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  243975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  243982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  243982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  243985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  243987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  243989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  243991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  243996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  243999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244002 */     GIR_RootConstrainSelectedInstOperands,
     /*  244003 */     // GIR_Coverage, 4900,
     /*  244003 */     GIR_EraseRootFromParent_Done,
     /*  244004 */   // Label 4707: @244004
     /*  244004 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(244070), // Rule ID 4901 //
     /*  244009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  244020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  244023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  244026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244068 */     GIR_RootConstrainSelectedInstOperands,
     /*  244069 */     // GIR_Coverage, 4901,
     /*  244069 */     GIR_EraseRootFromParent_Done,
     /*  244070 */   // Label 4708: @244070
     /*  244070 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(244136), // Rule ID 4904 //
     /*  244075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244134 */     GIR_RootConstrainSelectedInstOperands,
     /*  244135 */     // GIR_Coverage, 4904,
     /*  244135 */     GIR_EraseRootFromParent_Done,
     /*  244136 */   // Label 4709: @244136
     /*  244136 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(244202), // Rule ID 4905 //
     /*  244141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  244152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  244155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  244158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244200 */     GIR_RootConstrainSelectedInstOperands,
     /*  244201 */     // GIR_Coverage, 4905,
     /*  244201 */     GIR_EraseRootFromParent_Done,
     /*  244202 */   // Label 4710: @244202
     /*  244202 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(244268), // Rule ID 4908 //
     /*  244207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  244246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244266 */     GIR_RootConstrainSelectedInstOperands,
     /*  244267 */     // GIR_Coverage, 4908,
     /*  244267 */     GIR_EraseRootFromParent_Done,
     /*  244268 */   // Label 4711: @244268
     /*  244268 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(244334), // Rule ID 4909 //
     /*  244273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  244284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  244287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  244290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  244312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  244329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244332 */     GIR_RootConstrainSelectedInstOperands,
     /*  244333 */     // GIR_Coverage, 4909,
     /*  244333 */     GIR_EraseRootFromParent_Done,
     /*  244334 */   // Label 4712: @244334
     /*  244334 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(244400), // Rule ID 4912 //
     /*  244339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244398 */     GIR_RootConstrainSelectedInstOperands,
     /*  244399 */     // GIR_Coverage, 4912,
     /*  244399 */     GIR_EraseRootFromParent_Done,
     /*  244400 */   // Label 4713: @244400
     /*  244400 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(244466), // Rule ID 4913 //
     /*  244405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  244416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  244419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  244422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /*  244447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244464 */     GIR_RootConstrainSelectedInstOperands,
     /*  244465 */     // GIR_Coverage, 4913,
     /*  244465 */     GIR_EraseRootFromParent_Done,
     /*  244466 */   // Label 4714: @244466
     /*  244466 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(244532), // Rule ID 4916 //
     /*  244471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  244482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  244485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  244488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244530 */     GIR_RootConstrainSelectedInstOperands,
     /*  244531 */     // GIR_Coverage, 4916,
     /*  244531 */     GIR_EraseRootFromParent_Done,
     /*  244532 */   // Label 4715: @244532
     /*  244532 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(244598), // Rule ID 4917 //
     /*  244537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  244548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  244551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  244554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  244579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244596 */     GIR_RootConstrainSelectedInstOperands,
     /*  244597 */     // GIR_Coverage, 4917,
     /*  244597 */     GIR_EraseRootFromParent_Done,
     /*  244598 */   // Label 4716: @244598
     /*  244598 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(244664), // Rule ID 4920 //
     /*  244603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  244614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  244617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  244620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244662 */     GIR_RootConstrainSelectedInstOperands,
     /*  244663 */     // GIR_Coverage, 4920,
     /*  244663 */     GIR_EraseRootFromParent_Done,
     /*  244664 */   // Label 4717: @244664
     /*  244664 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(244730), // Rule ID 4921 //
     /*  244669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  244680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  244683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  244686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  244701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244708 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  244711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244728 */     GIR_RootConstrainSelectedInstOperands,
     /*  244729 */     // GIR_Coverage, 4921,
     /*  244729 */     GIR_EraseRootFromParent_Done,
     /*  244730 */   // Label 4718: @244730
     /*  244730 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(244796), // Rule ID 4924 //
     /*  244735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  244746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  244749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  244752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244794 */     GIR_RootConstrainSelectedInstOperands,
     /*  244795 */     // GIR_Coverage, 4924,
     /*  244795 */     GIR_EraseRootFromParent_Done,
     /*  244796 */   // Label 4719: @244796
     /*  244796 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(244862), // Rule ID 4925 //
     /*  244801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  244812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  244815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  244818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  244833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  244843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244860 */     GIR_RootConstrainSelectedInstOperands,
     /*  244861 */     // GIR_Coverage, 4925,
     /*  244861 */     GIR_EraseRootFromParent_Done,
     /*  244862 */   // Label 4720: @244862
     /*  244862 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(244928), // Rule ID 4928 //
     /*  244867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  244870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  244878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  244881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  244884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  244887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244906 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  244906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244926 */     GIR_RootConstrainSelectedInstOperands,
     /*  244927 */     // GIR_Coverage, 4928,
     /*  244927 */     GIR_EraseRootFromParent_Done,
     /*  244928 */   // Label 4721: @244928
     /*  244928 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(244994), // Rule ID 4929 //
     /*  244933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  244936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  244941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  244944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  244947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  244950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  244953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  244961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  244965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  244972 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  244972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  244975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  244977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  244979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  244981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  244986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  244989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  244992 */     GIR_RootConstrainSelectedInstOperands,
     /*  244993 */     // GIR_Coverage, 4929,
     /*  244993 */     GIR_EraseRootFromParent_Done,
     /*  244994 */   // Label 4722: @244994
     /*  244994 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(245060), // Rule ID 4932 //
     /*  244999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245058 */     GIR_RootConstrainSelectedInstOperands,
     /*  245059 */     // GIR_Coverage, 4932,
     /*  245059 */     GIR_EraseRootFromParent_Done,
     /*  245060 */   // Label 4723: @245060
     /*  245060 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(245126), // Rule ID 4933 //
     /*  245065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  245076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  245079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  245082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /*  245107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245124 */     GIR_RootConstrainSelectedInstOperands,
     /*  245125 */     // GIR_Coverage, 4933,
     /*  245125 */     GIR_EraseRootFromParent_Done,
     /*  245126 */   // Label 4724: @245126
     /*  245126 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(245192), // Rule ID 4936 //
     /*  245131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245170 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245190 */     GIR_RootConstrainSelectedInstOperands,
     /*  245191 */     // GIR_Coverage, 4936,
     /*  245191 */     GIR_EraseRootFromParent_Done,
     /*  245192 */   // Label 4725: @245192
     /*  245192 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(245258), // Rule ID 4937 //
     /*  245197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  245208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  245211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  245214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245236 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /*  245239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245256 */     GIR_RootConstrainSelectedInstOperands,
     /*  245257 */     // GIR_Coverage, 4937,
     /*  245257 */     GIR_EraseRootFromParent_Done,
     /*  245258 */   // Label 4726: @245258
     /*  245258 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(245324), // Rule ID 4940 //
     /*  245263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245302 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245322 */     GIR_RootConstrainSelectedInstOperands,
     /*  245323 */     // GIR_Coverage, 4940,
     /*  245323 */     GIR_EraseRootFromParent_Done,
     /*  245324 */   // Label 4727: @245324
     /*  245324 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(245390), // Rule ID 4941 //
     /*  245329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  245340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  245343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  245346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /*  245371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245388 */     GIR_RootConstrainSelectedInstOperands,
     /*  245389 */     // GIR_Coverage, 4941,
     /*  245389 */     GIR_EraseRootFromParent_Done,
     /*  245390 */   // Label 4728: @245390
     /*  245390 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(245456), // Rule ID 4944 //
     /*  245395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  245398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  245434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245454 */     GIR_RootConstrainSelectedInstOperands,
     /*  245455 */     // GIR_Coverage, 4944,
     /*  245455 */     GIR_EraseRootFromParent_Done,
     /*  245456 */   // Label 4729: @245456
     /*  245456 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(245522), // Rule ID 4945 //
     /*  245461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  245464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  245472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  245475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  245478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  245489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  245500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /*  245503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  245517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245520 */     GIR_RootConstrainSelectedInstOperands,
     /*  245521 */     // GIR_Coverage, 4945,
     /*  245521 */     GIR_EraseRootFromParent_Done,
     /*  245522 */   // Label 4730: @245522
     /*  245522 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(245588), // Rule ID 4948 //
     /*  245527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  245544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  245569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245586 */     GIR_RootConstrainSelectedInstOperands,
     /*  245587 */     // GIR_Coverage, 4948,
     /*  245587 */     GIR_EraseRootFromParent_Done,
     /*  245588 */   // Label 4731: @245588
     /*  245588 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(245654), // Rule ID 4949 //
     /*  245593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  245604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  245607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  245610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245632 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /*  245635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245652 */     GIR_RootConstrainSelectedInstOperands,
     /*  245653 */     // GIR_Coverage, 4949,
     /*  245653 */     GIR_EraseRootFromParent_Done,
     /*  245654 */   // Label 4732: @245654
     /*  245654 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(245720), // Rule ID 4952 //
     /*  245659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  245676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245698 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  245701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245718 */     GIR_RootConstrainSelectedInstOperands,
     /*  245719 */     // GIR_Coverage, 4952,
     /*  245719 */     GIR_EraseRootFromParent_Done,
     /*  245720 */   // Label 4733: @245720
     /*  245720 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(245786), // Rule ID 4953 //
     /*  245725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  245736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  245739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  245742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245764 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11471:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  245767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245784 */     GIR_RootConstrainSelectedInstOperands,
     /*  245785 */     // GIR_Coverage, 4953,
     /*  245785 */     GIR_EraseRootFromParent_Done,
     /*  245786 */   // Label 4734: @245786
     /*  245786 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(245852), // Rule ID 4956 //
     /*  245791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  245808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245830 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  245833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245850 */     GIR_RootConstrainSelectedInstOperands,
     /*  245851 */     // GIR_Coverage, 4956,
     /*  245851 */     GIR_EraseRootFromParent_Done,
     /*  245852 */   // Label 4735: @245852
     /*  245852 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(245918), // Rule ID 4957 //
     /*  245857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  245868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  245871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  245874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  245877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  245885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  245896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  245899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245916 */     GIR_RootConstrainSelectedInstOperands,
     /*  245917 */     // GIR_Coverage, 4957,
     /*  245917 */     GIR_EraseRootFromParent_Done,
     /*  245918 */   // Label 4736: @245918
     /*  245918 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(245984), // Rule ID 4960 //
     /*  245923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  245926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  245934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  245937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  245940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  245943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  245951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  245955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  245962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  245962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  245965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  245967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  245969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  245971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  245976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  245979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  245982 */     GIR_RootConstrainSelectedInstOperands,
     /*  245983 */     // GIR_Coverage, 4960,
     /*  245983 */     GIR_EraseRootFromParent_Done,
     /*  245984 */   // Label 4737: @245984
     /*  245984 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246050), // Rule ID 4961 //
     /*  245989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  245992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  245997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  246000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  246003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  246006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246028 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246048 */     GIR_RootConstrainSelectedInstOperands,
     /*  246049 */     // GIR_Coverage, 4961,
     /*  246049 */     GIR_EraseRootFromParent_Done,
     /*  246050 */   // Label 4738: @246050
     /*  246050 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246116), // Rule ID 4964 //
     /*  246055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  246058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  246094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246114 */     GIR_RootConstrainSelectedInstOperands,
     /*  246115 */     // GIR_Coverage, 4964,
     /*  246115 */     GIR_EraseRootFromParent_Done,
     /*  246116 */   // Label 4739: @246116
     /*  246116 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246182), // Rule ID 4965 //
     /*  246121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  246124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  246132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  246135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  246138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246160 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  246160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  246177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246180 */     GIR_RootConstrainSelectedInstOperands,
     /*  246181 */     // GIR_Coverage, 4965,
     /*  246181 */     GIR_EraseRootFromParent_Done,
     /*  246182 */   // Label 4740: @246182
     /*  246182 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246248), // Rule ID 4968 //
     /*  246187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246226 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246246 */     GIR_RootConstrainSelectedInstOperands,
     /*  246247 */     // GIR_Coverage, 4968,
     /*  246247 */     GIR_EraseRootFromParent_Done,
     /*  246248 */   // Label 4741: @246248
     /*  246248 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(246314), // Rule ID 4969 //
     /*  246253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  246270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /*  246295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246312 */     GIR_RootConstrainSelectedInstOperands,
     /*  246313 */     // GIR_Coverage, 4969,
     /*  246313 */     GIR_EraseRootFromParent_Done,
     /*  246314 */   // Label 4742: @246314
     /*  246314 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(246380), // Rule ID 4972 //
     /*  246319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246378 */     GIR_RootConstrainSelectedInstOperands,
     /*  246379 */     // GIR_Coverage, 4972,
     /*  246379 */     GIR_EraseRootFromParent_Done,
     /*  246380 */   // Label 4743: @246380
     /*  246380 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(246446), // Rule ID 4973 //
     /*  246385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  246402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /*  246427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246444 */     GIR_RootConstrainSelectedInstOperands,
     /*  246445 */     // GIR_Coverage, 4973,
     /*  246445 */     GIR_EraseRootFromParent_Done,
     /*  246446 */   // Label 4744: @246446
     /*  246446 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(246512), // Rule ID 4976 //
     /*  246451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  246468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246490 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246510 */     GIR_RootConstrainSelectedInstOperands,
     /*  246511 */     // GIR_Coverage, 4976,
     /*  246511 */     GIR_EraseRootFromParent_Done,
     /*  246512 */   // Label 4745: @246512
     /*  246512 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(246578), // Rule ID 4977 //
     /*  246517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  246534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  246545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /*  246559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246576 */     GIR_RootConstrainSelectedInstOperands,
     /*  246577 */     // GIR_Coverage, 4977,
     /*  246577 */     GIR_EraseRootFromParent_Done,
     /*  246578 */   // Label 4746: @246578
     /*  246578 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(246644), // Rule ID 4980 //
     /*  246583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  246600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246642 */     GIR_RootConstrainSelectedInstOperands,
     /*  246643 */     // GIR_Coverage, 4980,
     /*  246643 */     GIR_EraseRootFromParent_Done,
     /*  246644 */   // Label 4747: @246644
     /*  246644 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(246710), // Rule ID 4981 //
     /*  246649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  246660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  246663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  246666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  246677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246688 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /*  246691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246708 */     GIR_RootConstrainSelectedInstOperands,
     /*  246709 */     // GIR_Coverage, 4981,
     /*  246709 */     GIR_EraseRootFromParent_Done,
     /*  246710 */   // Label 4748: @246710
     /*  246710 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(246776), // Rule ID 4984 //
     /*  246715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  246757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246774 */     GIR_RootConstrainSelectedInstOperands,
     /*  246775 */     // GIR_Coverage, 4984,
     /*  246775 */     GIR_EraseRootFromParent_Done,
     /*  246776 */   // Label 4749: @246776
     /*  246776 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(246842), // Rule ID 4985 //
     /*  246781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  246792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  246795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  246798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11471:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /*  246823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246840 */     GIR_RootConstrainSelectedInstOperands,
     /*  246841 */     // GIR_Coverage, 4985,
     /*  246841 */     GIR_EraseRootFromParent_Done,
     /*  246842 */   // Label 4750: @246842
     /*  246842 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(246908), // Rule ID 4988 //
     /*  246847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  246886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  246889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246906 */     GIR_RootConstrainSelectedInstOperands,
     /*  246907 */     // GIR_Coverage, 4988,
     /*  246907 */     GIR_EraseRootFromParent_Done,
     /*  246908 */   // Label 4751: @246908
     /*  246908 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(246974), // Rule ID 4989 //
     /*  246913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  246916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  246924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  246927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  246930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  246933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  246941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  246945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  246952 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11471:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  246952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /*  246955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  246957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  246959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  246961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  246966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  246969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  246972 */     GIR_RootConstrainSelectedInstOperands,
     /*  246973 */     // GIR_Coverage, 4989,
     /*  246973 */     GIR_EraseRootFromParent_Done,
     /*  246974 */   // Label 4752: @246974
     /*  246974 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247040), // Rule ID 4992 //
     /*  246979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  246982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  246987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  246990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  246993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  246996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  246999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247038 */     GIR_RootConstrainSelectedInstOperands,
     /*  247039 */     // GIR_Coverage, 4992,
     /*  247039 */     GIR_EraseRootFromParent_Done,
     /*  247040 */   // Label 4753: @247040
     /*  247040 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247106), // Rule ID 4993 //
     /*  247045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  247056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  247059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  247073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11471:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /*  247087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247104 */     GIR_RootConstrainSelectedInstOperands,
     /*  247105 */     // GIR_Coverage, 4993,
     /*  247105 */     GIR_EraseRootFromParent_Done,
     /*  247106 */   // Label 4754: @247106
     /*  247106 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247172), // Rule ID 4996 //
     /*  247111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  247114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247150 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  247150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247170 */     GIR_RootConstrainSelectedInstOperands,
     /*  247171 */     // GIR_Coverage, 4996,
     /*  247171 */     GIR_EraseRootFromParent_Done,
     /*  247172 */   // Label 4755: @247172
     /*  247172 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247238), // Rule ID 4997 //
     /*  247177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  247180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext),
     /*  247185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  247188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  247191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  247205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11471:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  247216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /*  247219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  247223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  247233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  247236 */     GIR_RootConstrainSelectedInstOperands,
     /*  247237 */     // GIR_Coverage, 4997,
     /*  247237 */     GIR_EraseRootFromParent_Done,
     /*  247238 */   // Label 4756: @247238
     /*  247238 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247301), // Rule ID 5260 //
     /*  247243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247299 */     GIR_RootConstrainSelectedInstOperands,
     /*  247300 */     // GIR_Coverage, 5260,
     /*  247300 */     GIR_EraseRootFromParent_Done,
     /*  247301 */   // Label 4757: @247301
     /*  247301 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247364), // Rule ID 5261 //
     /*  247306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  247320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  247323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247345 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247362 */     GIR_RootConstrainSelectedInstOperands,
     /*  247363 */     // GIR_Coverage, 5261,
     /*  247363 */     GIR_EraseRootFromParent_Done,
     /*  247364 */   // Label 4758: @247364
     /*  247364 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247427), // Rule ID 5262 //
     /*  247369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247425 */     GIR_RootConstrainSelectedInstOperands,
     /*  247426 */     // GIR_Coverage, 5262,
     /*  247426 */     GIR_EraseRootFromParent_Done,
     /*  247427 */   // Label 4759: @247427
     /*  247427 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247490), // Rule ID 5263 //
     /*  247432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  247443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  247446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  247449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247471 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247488 */     GIR_RootConstrainSelectedInstOperands,
     /*  247489 */     // GIR_Coverage, 5263,
     /*  247489 */     GIR_EraseRootFromParent_Done,
     /*  247490 */   // Label 4760: @247490
     /*  247490 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247553), // Rule ID 5264 //
     /*  247495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  247506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247534 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  247534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247551 */     GIR_RootConstrainSelectedInstOperands,
     /*  247552 */     // GIR_Coverage, 5264,
     /*  247552 */     GIR_EraseRootFromParent_Done,
     /*  247553 */   // Label 4761: @247553
     /*  247553 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247616), // Rule ID 5265 //
     /*  247558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  247569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  247572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  247575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247597 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  247597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF4),
     /*  247600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247614 */     GIR_RootConstrainSelectedInstOperands,
     /*  247615 */     // GIR_Coverage, 5265,
     /*  247615 */     GIR_EraseRootFromParent_Done,
     /*  247616 */   // Label 4762: @247616
     /*  247616 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247679), // Rule ID 5266 //
     /*  247621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  247635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  247660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247677 */     GIR_RootConstrainSelectedInstOperands,
     /*  247678 */     // GIR_Coverage, 5266,
     /*  247678 */     GIR_EraseRootFromParent_Done,
     /*  247679 */   // Label 4763: @247679
     /*  247679 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247742), // Rule ID 5267 //
     /*  247684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  247695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  247698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  247701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247723 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  247723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  247740 */     GIR_RootConstrainSelectedInstOperands,
     /*  247741 */     // GIR_Coverage, 5267,
     /*  247741 */     GIR_EraseRootFromParent_Done,
     /*  247742 */   // Label 4764: @247742
     /*  247742 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247805), // Rule ID 5268 //
     /*  247747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  247758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  247761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  247764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247786 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  247786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247803 */     GIR_RootConstrainSelectedInstOperands,
     /*  247804 */     // GIR_Coverage, 5268,
     /*  247804 */     GIR_EraseRootFromParent_Done,
     /*  247805 */   // Label 4765: @247805
     /*  247805 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(247868), // Rule ID 5269 //
     /*  247810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  247821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  247824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  247827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247849 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  247849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_MF2),
     /*  247852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  247866 */     GIR_RootConstrainSelectedInstOperands,
     /*  247867 */     // GIR_Coverage, 5269,
     /*  247867 */     GIR_EraseRootFromParent_Done,
     /*  247868 */   // Label 4766: @247868
     /*  247868 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(247931), // Rule ID 5270 //
     /*  247873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  247876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  247884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  247887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  247893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  247912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  247915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247929 */     GIR_RootConstrainSelectedInstOperands,
     /*  247930 */     // GIR_Coverage, 5270,
     /*  247930 */     GIR_EraseRootFromParent_Done,
     /*  247931 */   // Label 4767: @247931
     /*  247931 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(247994), // Rule ID 5271 //
     /*  247936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  247939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  247944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  247947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  247950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  247953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  247956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  247968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  247975 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  247975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  247978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  247980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  247982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  247984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  247989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  247992 */     GIR_RootConstrainSelectedInstOperands,
     /*  247993 */     // GIR_Coverage, 5271,
     /*  247993 */     GIR_EraseRootFromParent_Done,
     /*  247994 */   // Label 4768: @247994
     /*  247994 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248057), // Rule ID 5272 //
     /*  247999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248055 */     GIR_RootConstrainSelectedInstOperands,
     /*  248056 */     // GIR_Coverage, 5272,
     /*  248056 */     GIR_EraseRootFromParent_Done,
     /*  248057 */   // Label 4769: @248057
     /*  248057 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248120), // Rule ID 5273 //
     /*  248062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  248073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  248076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  248079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248118 */     GIR_RootConstrainSelectedInstOperands,
     /*  248119 */     // GIR_Coverage, 5273,
     /*  248119 */     GIR_EraseRootFromParent_Done,
     /*  248120 */   // Label 4770: @248120
     /*  248120 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248183), // Rule ID 5274 //
     /*  248125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  248164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248181 */     GIR_RootConstrainSelectedInstOperands,
     /*  248182 */     // GIR_Coverage, 5274,
     /*  248182 */     GIR_EraseRootFromParent_Done,
     /*  248183 */   // Label 4771: @248183
     /*  248183 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248246), // Rule ID 5275 //
     /*  248188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  248199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  248202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  248205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248227 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  248227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  248244 */     GIR_RootConstrainSelectedInstOperands,
     /*  248245 */     // GIR_Coverage, 5275,
     /*  248245 */     GIR_EraseRootFromParent_Done,
     /*  248246 */   // Label 4772: @248246
     /*  248246 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248309), // Rule ID 5276 //
     /*  248251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  248254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248290 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  248290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248307 */     GIR_RootConstrainSelectedInstOperands,
     /*  248308 */     // GIR_Coverage, 5276,
     /*  248308 */     GIR_EraseRootFromParent_Done,
     /*  248309 */   // Label 4773: @248309
     /*  248309 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248372), // Rule ID 5277 //
     /*  248314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  248317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  248325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  248328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  248331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248353 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  248353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M1),
     /*  248356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  248370 */     GIR_RootConstrainSelectedInstOperands,
     /*  248371 */     // GIR_Coverage, 5277,
     /*  248371 */     GIR_EraseRootFromParent_Done,
     /*  248372 */   // Label 4774: @248372
     /*  248372 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248435), // Rule ID 5278 //
     /*  248377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248416 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248433 */     GIR_RootConstrainSelectedInstOperands,
     /*  248434 */     // GIR_Coverage, 5278,
     /*  248434 */     GIR_EraseRootFromParent_Done,
     /*  248435 */   // Label 4775: @248435
     /*  248435 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248498), // Rule ID 5279 //
     /*  248440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  248454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  248457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248479 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248496 */     GIR_RootConstrainSelectedInstOperands,
     /*  248497 */     // GIR_Coverage, 5279,
     /*  248497 */     GIR_EraseRootFromParent_Done,
     /*  248498 */   // Label 4776: @248498
     /*  248498 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248561), // Rule ID 5280 //
     /*  248503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  248514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  248517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248542 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  248545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248559 */     GIR_RootConstrainSelectedInstOperands,
     /*  248560 */     // GIR_Coverage, 5280,
     /*  248560 */     GIR_EraseRootFromParent_Done,
     /*  248561 */   // Label 4777: @248561
     /*  248561 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(248624), // Rule ID 5281 //
     /*  248566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  248577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  248580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  248583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248605 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  248608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248622 */     GIR_RootConstrainSelectedInstOperands,
     /*  248623 */     // GIR_Coverage, 5281,
     /*  248623 */     GIR_EraseRootFromParent_Done,
     /*  248624 */   // Label 4778: @248624
     /*  248624 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(248687), // Rule ID 5282 //
     /*  248629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  248640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  248643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  248646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248668 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  248668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  248671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248685 */     GIR_RootConstrainSelectedInstOperands,
     /*  248686 */     // GIR_Coverage, 5282,
     /*  248686 */     GIR_EraseRootFromParent_Done,
     /*  248687 */   // Label 4779: @248687
     /*  248687 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(248750), // Rule ID 5283 //
     /*  248692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  248703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  248706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  248709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  248724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248731 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  248731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  248734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  248748 */     GIR_RootConstrainSelectedInstOperands,
     /*  248749 */     // GIR_Coverage, 5283,
     /*  248749 */     GIR_EraseRootFromParent_Done,
     /*  248750 */   // Label 4780: @248750
     /*  248750 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(248813), // Rule ID 5284 //
     /*  248755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  248772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248794 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248811 */     GIR_RootConstrainSelectedInstOperands,
     /*  248812 */     // GIR_Coverage, 5284,
     /*  248812 */     GIR_EraseRootFromParent_Done,
     /*  248813 */   // Label 4781: @248813
     /*  248813 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(248876), // Rule ID 5285 //
     /*  248818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  248829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  248832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  248835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  248850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248857 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  248860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248874 */     GIR_RootConstrainSelectedInstOperands,
     /*  248875 */     // GIR_Coverage, 5285,
     /*  248875 */     GIR_EraseRootFromParent_Done,
     /*  248876 */   // Label 4782: @248876
     /*  248876 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(248939), // Rule ID 5286 //
     /*  248881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  248884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  248898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  248901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248920 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  248920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  248923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  248937 */     GIR_RootConstrainSelectedInstOperands,
     /*  248938 */     // GIR_Coverage, 5286,
     /*  248938 */     GIR_EraseRootFromParent_Done,
     /*  248939 */   // Label 4783: @248939
     /*  248939 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(249002), // Rule ID 5287 //
     /*  248944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  248947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  248952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  248955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  248958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  248961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  248964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  248968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  248976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  248983 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  248983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  248986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  248988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  248990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  248992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  248997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249000 */     GIR_RootConstrainSelectedInstOperands,
     /*  249001 */     // GIR_Coverage, 5287,
     /*  249001 */     GIR_EraseRootFromParent_Done,
     /*  249002 */   // Label 4784: @249002
     /*  249002 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(249065), // Rule ID 5288 //
     /*  249007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249046 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  249046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249063 */     GIR_RootConstrainSelectedInstOperands,
     /*  249064 */     // GIR_Coverage, 5288,
     /*  249064 */     GIR_EraseRootFromParent_Done,
     /*  249065 */   // Label 4785: @249065
     /*  249065 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(249128), // Rule ID 5289 //
     /*  249070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  249081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  249084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  249087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249109 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  249109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  249126 */     GIR_RootConstrainSelectedInstOperands,
     /*  249127 */     // GIR_Coverage, 5289,
     /*  249127 */     GIR_EraseRootFromParent_Done,
     /*  249128 */   // Label 4786: @249128
     /*  249128 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(249191), // Rule ID 5290 //
     /*  249133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249189 */     GIR_RootConstrainSelectedInstOperands,
     /*  249190 */     // GIR_Coverage, 5290,
     /*  249190 */     GIR_EraseRootFromParent_Done,
     /*  249191 */   // Label 4787: @249191
     /*  249191 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(249254), // Rule ID 5291 //
     /*  249196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  249210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  249213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249235 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249252 */     GIR_RootConstrainSelectedInstOperands,
     /*  249253 */     // GIR_Coverage, 5291,
     /*  249253 */     GIR_EraseRootFromParent_Done,
     /*  249254 */   // Label 4788: @249254
     /*  249254 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(249317), // Rule ID 5292 //
     /*  249259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249298 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249315 */     GIR_RootConstrainSelectedInstOperands,
     /*  249316 */     // GIR_Coverage, 5292,
     /*  249316 */     GIR_EraseRootFromParent_Done,
     /*  249317 */   // Label 4789: @249317
     /*  249317 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249380), // Rule ID 5293 //
     /*  249322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  249336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  249339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249361 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249378 */     GIR_RootConstrainSelectedInstOperands,
     /*  249379 */     // GIR_Coverage, 5293,
     /*  249379 */     GIR_EraseRootFromParent_Done,
     /*  249380 */   // Label 4790: @249380
     /*  249380 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249443), // Rule ID 5294 //
     /*  249385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249424 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  249424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249441 */     GIR_RootConstrainSelectedInstOperands,
     /*  249442 */     // GIR_Coverage, 5294,
     /*  249442 */     GIR_EraseRootFromParent_Done,
     /*  249443 */   // Label 4791: @249443
     /*  249443 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249506), // Rule ID 5295 //
     /*  249448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  249459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  249462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  249465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249487 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  249487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  249504 */     GIR_RootConstrainSelectedInstOperands,
     /*  249505 */     // GIR_Coverage, 5295,
     /*  249505 */     GIR_EraseRootFromParent_Done,
     /*  249506 */   // Label 4792: @249506
     /*  249506 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249569), // Rule ID 5296 //
     /*  249511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  249514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  249528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249550 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  249550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249567 */     GIR_RootConstrainSelectedInstOperands,
     /*  249568 */     // GIR_Coverage, 5296,
     /*  249568 */     GIR_EraseRootFromParent_Done,
     /*  249569 */   // Label 4793: @249569
     /*  249569 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249632), // Rule ID 5297 //
     /*  249574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  249577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  249585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  249588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  249591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  249606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249613 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  249613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M2),
     /*  249616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249630 */     GIR_RootConstrainSelectedInstOperands,
     /*  249631 */     // GIR_Coverage, 5297,
     /*  249631 */     GIR_EraseRootFromParent_Done,
     /*  249632 */   // Label 4794: @249632
     /*  249632 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249695), // Rule ID 5298 //
     /*  249637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  249640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  249654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249676 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  249676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249693 */     GIR_RootConstrainSelectedInstOperands,
     /*  249694 */     // GIR_Coverage, 5298,
     /*  249694 */     GIR_EraseRootFromParent_Done,
     /*  249695 */   // Label 4795: @249695
     /*  249695 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249758), // Rule ID 5299 //
     /*  249700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  249703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  249711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  249714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  249717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  249732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249739 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  249739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M4),
     /*  249742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249756 */     GIR_RootConstrainSelectedInstOperands,
     /*  249757 */     // GIR_Coverage, 5299,
     /*  249757 */     GIR_EraseRootFromParent_Done,
     /*  249758 */   // Label 4796: @249758
     /*  249758 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249821), // Rule ID 5300 //
     /*  249763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  249766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  249780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249802 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  249802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249819 */     GIR_RootConstrainSelectedInstOperands,
     /*  249820 */     // GIR_Coverage, 5300,
     /*  249820 */     GIR_EraseRootFromParent_Done,
     /*  249821 */   // Label 4797: @249821
     /*  249821 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249884), // Rule ID 5301 //
     /*  249826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  249829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  249837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  249840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  249843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  249858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249865 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  249865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VV_M8),
     /*  249868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  249882 */     GIR_RootConstrainSelectedInstOperands,
     /*  249883 */     // GIR_Coverage, 5301,
     /*  249883 */     GIR_EraseRootFromParent_Done,
     /*  249884 */   // Label 4798: @249884
     /*  249884 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(249947), // Rule ID 5302 //
     /*  249889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  249892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  249903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  249906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  249909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  249921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  249928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  249931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  249937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  249942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  249945 */     GIR_RootConstrainSelectedInstOperands,
     /*  249946 */     // GIR_Coverage, 5302,
     /*  249946 */     GIR_EraseRootFromParent_Done,
     /*  249947 */   // Label 4799: @249947
     /*  249947 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(250010), // Rule ID 5303 //
     /*  249952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  249955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  249960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  249963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  249966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  249969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  249972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  249980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  249984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  249991 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  249991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF8),
     /*  249994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  249996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  249998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250008 */     GIR_RootConstrainSelectedInstOperands,
     /*  250009 */     // GIR_Coverage, 5303,
     /*  250009 */     GIR_EraseRootFromParent_Done,
     /*  250010 */   // Label 4800: @250010
     /*  250010 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(250073), // Rule ID 5304 //
     /*  250015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250054 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250071 */     GIR_RootConstrainSelectedInstOperands,
     /*  250072 */     // GIR_Coverage, 5304,
     /*  250072 */     GIR_EraseRootFromParent_Done,
     /*  250073 */   // Label 4801: @250073
     /*  250073 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(250136), // Rule ID 5305 //
     /*  250078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  250092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250117 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250134 */     GIR_RootConstrainSelectedInstOperands,
     /*  250135 */     // GIR_Coverage, 5305,
     /*  250135 */     GIR_EraseRootFromParent_Done,
     /*  250136 */   // Label 4802: @250136
     /*  250136 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(250199), // Rule ID 5306 //
     /*  250141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250197 */     GIR_RootConstrainSelectedInstOperands,
     /*  250198 */     // GIR_Coverage, 5306,
     /*  250198 */     GIR_EraseRootFromParent_Done,
     /*  250199 */   // Label 4803: @250199
     /*  250199 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(250262), // Rule ID 5307 //
     /*  250204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  250218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250243 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250260 */     GIR_RootConstrainSelectedInstOperands,
     /*  250261 */     // GIR_Coverage, 5307,
     /*  250261 */     GIR_EraseRootFromParent_Done,
     /*  250262 */   // Label 4804: @250262
     /*  250262 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(250325), // Rule ID 5308 //
     /*  250267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250306 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250323 */     GIR_RootConstrainSelectedInstOperands,
     /*  250324 */     // GIR_Coverage, 5308,
     /*  250324 */     GIR_EraseRootFromParent_Done,
     /*  250325 */   // Label 4805: @250325
     /*  250325 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(250388), // Rule ID 5309 //
     /*  250330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  250344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250369 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF4),
     /*  250372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250386 */     GIR_RootConstrainSelectedInstOperands,
     /*  250387 */     // GIR_Coverage, 5309,
     /*  250387 */     GIR_EraseRootFromParent_Done,
     /*  250388 */   // Label 4806: @250388
     /*  250388 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(250451), // Rule ID 5310 //
     /*  250393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250449 */     GIR_RootConstrainSelectedInstOperands,
     /*  250450 */     // GIR_Coverage, 5310,
     /*  250450 */     GIR_EraseRootFromParent_Done,
     /*  250451 */   // Label 4807: @250451
     /*  250451 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(250514), // Rule ID 5311 //
     /*  250456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  250470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250495 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250512 */     GIR_RootConstrainSelectedInstOperands,
     /*  250513 */     // GIR_Coverage, 5311,
     /*  250513 */     GIR_EraseRootFromParent_Done,
     /*  250514 */   // Label 4808: @250514
     /*  250514 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(250577), // Rule ID 5312 //
     /*  250519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  250533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250558 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250575 */     GIR_RootConstrainSelectedInstOperands,
     /*  250576 */     // GIR_Coverage, 5312,
     /*  250576 */     GIR_EraseRootFromParent_Done,
     /*  250577 */   // Label 4809: @250577
     /*  250577 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(250640), // Rule ID 5313 //
     /*  250582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  250593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  250596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250621 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_MF2),
     /*  250624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250638 */     GIR_RootConstrainSelectedInstOperands,
     /*  250639 */     // GIR_Coverage, 5313,
     /*  250639 */     GIR_EraseRootFromParent_Done,
     /*  250640 */   // Label 4810: @250640
     /*  250640 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(250703), // Rule ID 5314 //
     /*  250645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  250659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  250684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  250687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250701 */     GIR_RootConstrainSelectedInstOperands,
     /*  250702 */     // GIR_Coverage, 5314,
     /*  250702 */     GIR_EraseRootFromParent_Done,
     /*  250703 */   // Label 4811: @250703
     /*  250703 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(250766), // Rule ID 5315 //
     /*  250708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  250719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  250722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250747 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  250747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  250750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  250764 */     GIR_RootConstrainSelectedInstOperands,
     /*  250765 */     // GIR_Coverage, 5315,
     /*  250765 */     GIR_EraseRootFromParent_Done,
     /*  250766 */   // Label 4812: @250766
     /*  250766 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(250829), // Rule ID 5316 //
     /*  250771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  250785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250810 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  250810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  250813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250827 */     GIR_RootConstrainSelectedInstOperands,
     /*  250828 */     // GIR_Coverage, 5316,
     /*  250828 */     GIR_EraseRootFromParent_Done,
     /*  250829 */   // Label 4813: @250829
     /*  250829 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250892), // Rule ID 5317 //
     /*  250834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  250845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  250848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250873 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  250873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  250876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  250890 */     GIR_RootConstrainSelectedInstOperands,
     /*  250891 */     // GIR_Coverage, 5317,
     /*  250891 */     GIR_EraseRootFromParent_Done,
     /*  250892 */   // Label 4814: @250892
     /*  250892 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250955), // Rule ID 5318 //
     /*  250897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  250900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  250914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  250917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250936 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  250936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  250939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  250941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  250943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  250945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  250950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  250953 */     GIR_RootConstrainSelectedInstOperands,
     /*  250954 */     // GIR_Coverage, 5318,
     /*  250954 */     GIR_EraseRootFromParent_Done,
     /*  250955 */   // Label 4815: @250955
     /*  250955 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(251018), // Rule ID 5319 //
     /*  250960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  250963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  250968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  250971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  250974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  250977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  250980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  250988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  250992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  250999 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  250999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251016 */     GIR_RootConstrainSelectedInstOperands,
     /*  251017 */     // GIR_Coverage, 5319,
     /*  251017 */     GIR_EraseRootFromParent_Done,
     /*  251018 */   // Label 4816: @251018
     /*  251018 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(251081), // Rule ID 5320 //
     /*  251023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  251026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251062 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  251062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251079 */     GIR_RootConstrainSelectedInstOperands,
     /*  251080 */     // GIR_Coverage, 5320,
     /*  251080 */     GIR_EraseRootFromParent_Done,
     /*  251081 */   // Label 4817: @251081
     /*  251081 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(251144), // Rule ID 5321 //
     /*  251086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  251089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  251097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  251100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251125 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11339:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  251125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M1),
     /*  251128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  251142 */     GIR_RootConstrainSelectedInstOperands,
     /*  251143 */     // GIR_Coverage, 5321,
     /*  251143 */     GIR_EraseRootFromParent_Done,
     /*  251144 */   // Label 4818: @251144
     /*  251144 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(251207), // Rule ID 5322 //
     /*  251149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251188 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251205 */     GIR_RootConstrainSelectedInstOperands,
     /*  251206 */     // GIR_Coverage, 5322,
     /*  251206 */     GIR_EraseRootFromParent_Done,
     /*  251207 */   // Label 4819: @251207
     /*  251207 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(251270), // Rule ID 5323 //
     /*  251212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  251226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251251 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251268 */     GIR_RootConstrainSelectedInstOperands,
     /*  251269 */     // GIR_Coverage, 5323,
     /*  251269 */     GIR_EraseRootFromParent_Done,
     /*  251270 */   // Label 4820: @251270
     /*  251270 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(251333), // Rule ID 5324 //
     /*  251275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251314 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251331 */     GIR_RootConstrainSelectedInstOperands,
     /*  251332 */     // GIR_Coverage, 5324,
     /*  251332 */     GIR_EraseRootFromParent_Done,
     /*  251333 */   // Label 4821: @251333
     /*  251333 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(251396), // Rule ID 5325 //
     /*  251338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  251352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251377 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251394 */     GIR_RootConstrainSelectedInstOperands,
     /*  251395 */     // GIR_Coverage, 5325,
     /*  251395 */     GIR_EraseRootFromParent_Done,
     /*  251396 */   // Label 4822: @251396
     /*  251396 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(251459), // Rule ID 5326 //
     /*  251401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251440 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  251440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251457 */     GIR_RootConstrainSelectedInstOperands,
     /*  251458 */     // GIR_Coverage, 5326,
     /*  251458 */     GIR_EraseRootFromParent_Done,
     /*  251459 */   // Label 4823: @251459
     /*  251459 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(251522), // Rule ID 5327 //
     /*  251464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  251475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  251478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251503 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  251503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  251520 */     GIR_RootConstrainSelectedInstOperands,
     /*  251521 */     // GIR_Coverage, 5327,
     /*  251521 */     GIR_EraseRootFromParent_Done,
     /*  251522 */   // Label 4824: @251522
     /*  251522 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(251585), // Rule ID 5328 //
     /*  251527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  251541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251566 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251583 */     GIR_RootConstrainSelectedInstOperands,
     /*  251584 */     // GIR_Coverage, 5328,
     /*  251584 */     GIR_EraseRootFromParent_Done,
     /*  251585 */   // Label 4825: @251585
     /*  251585 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(251648), // Rule ID 5329 //
     /*  251590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  251601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  251604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251629 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251646 */     GIR_RootConstrainSelectedInstOperands,
     /*  251647 */     // GIR_Coverage, 5329,
     /*  251647 */     GIR_EraseRootFromParent_Done,
     /*  251648 */   // Label 4826: @251648
     /*  251648 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(251711), // Rule ID 5330 //
     /*  251653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  251667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251709 */     GIR_RootConstrainSelectedInstOperands,
     /*  251710 */     // GIR_Coverage, 5330,
     /*  251710 */     GIR_EraseRootFromParent_Done,
     /*  251711 */   // Label 4827: @251711
     /*  251711 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(251774), // Rule ID 5331 //
     /*  251716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  251727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  251730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  251744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  251758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251772 */     GIR_RootConstrainSelectedInstOperands,
     /*  251773 */     // GIR_Coverage, 5331,
     /*  251773 */     GIR_EraseRootFromParent_Done,
     /*  251774 */   // Label 4828: @251774
     /*  251774 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(251837), // Rule ID 5332 //
     /*  251779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  251793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251818 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  251818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251835 */     GIR_RootConstrainSelectedInstOperands,
     /*  251836 */     // GIR_Coverage, 5332,
     /*  251836 */     GIR_EraseRootFromParent_Done,
     /*  251837 */   // Label 4829: @251837
     /*  251837 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(251900), // Rule ID 5333 //
     /*  251842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  251853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  251856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  251870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251881 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  251881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  251884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  251898 */     GIR_RootConstrainSelectedInstOperands,
     /*  251899 */     // GIR_Coverage, 5333,
     /*  251899 */     GIR_EraseRootFromParent_Done,
     /*  251900 */   // Label 4830: @251900
     /*  251900 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(251963), // Rule ID 5334 //
     /*  251905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  251908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  251919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  251922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  251925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  251937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  251944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  251944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  251947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  251949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  251951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  251953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  251958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  251961 */     GIR_RootConstrainSelectedInstOperands,
     /*  251962 */     // GIR_Coverage, 5334,
     /*  251962 */     GIR_EraseRootFromParent_Done,
     /*  251963 */   // Label 4831: @251963
     /*  251963 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(252026), // Rule ID 5335 //
     /*  251968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  251971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  251976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  251979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  251982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  251985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  251988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  251992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  251996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252007 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252024 */     GIR_RootConstrainSelectedInstOperands,
     /*  252025 */     // GIR_Coverage, 5335,
     /*  252025 */     GIR_EraseRootFromParent_Done,
     /*  252026 */   // Label 4832: @252026
     /*  252026 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(252089), // Rule ID 5336 //
     /*  252031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252087 */     GIR_RootConstrainSelectedInstOperands,
     /*  252088 */     // GIR_Coverage, 5336,
     /*  252088 */     GIR_EraseRootFromParent_Done,
     /*  252089 */   // Label 4833: @252089
     /*  252089 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(252152), // Rule ID 5337 //
     /*  252094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  252108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252133 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252150 */     GIR_RootConstrainSelectedInstOperands,
     /*  252151 */     // GIR_Coverage, 5337,
     /*  252151 */     GIR_EraseRootFromParent_Done,
     /*  252152 */   // Label 4834: @252152
     /*  252152 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(252215), // Rule ID 5338 //
     /*  252157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252196 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  252196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252213 */     GIR_RootConstrainSelectedInstOperands,
     /*  252214 */     // GIR_Coverage, 5338,
     /*  252214 */     GIR_EraseRootFromParent_Done,
     /*  252215 */   // Label 4835: @252215
     /*  252215 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(252278), // Rule ID 5339 //
     /*  252220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  252231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  252234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252259 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  252259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  252276 */     GIR_RootConstrainSelectedInstOperands,
     /*  252277 */     // GIR_Coverage, 5339,
     /*  252277 */     GIR_EraseRootFromParent_Done,
     /*  252278 */   // Label 4836: @252278
     /*  252278 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(252341), // Rule ID 5340 //
     /*  252283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252339 */     GIR_RootConstrainSelectedInstOperands,
     /*  252340 */     // GIR_Coverage, 5340,
     /*  252340 */     GIR_EraseRootFromParent_Done,
     /*  252341 */   // Label 4837: @252341
     /*  252341 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(252404), // Rule ID 5341 //
     /*  252346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  252360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  252374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252385 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11339:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M2),
     /*  252388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252402 */     GIR_RootConstrainSelectedInstOperands,
     /*  252403 */     // GIR_Coverage, 5341,
     /*  252403 */     GIR_EraseRootFromParent_Done,
     /*  252404 */   // Label 4838: @252404
     /*  252404 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(252467), // Rule ID 5342 //
     /*  252409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  252423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252465 */     GIR_RootConstrainSelectedInstOperands,
     /*  252466 */     // GIR_Coverage, 5342,
     /*  252466 */     GIR_EraseRootFromParent_Done,
     /*  252467 */   // Label 4839: @252467
     /*  252467 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(252530), // Rule ID 5343 //
     /*  252472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  252486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  252500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252511 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11339:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M4),
     /*  252514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252528 */     GIR_RootConstrainSelectedInstOperands,
     /*  252529 */     // GIR_Coverage, 5343,
     /*  252529 */     GIR_EraseRootFromParent_Done,
     /*  252530 */   // Label 4840: @252530
     /*  252530 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(252593), // Rule ID 5344 //
     /*  252535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  252538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  252549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  252552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252574 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  252574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252591 */     GIR_RootConstrainSelectedInstOperands,
     /*  252592 */     // GIR_Coverage, 5344,
     /*  252592 */     GIR_EraseRootFromParent_Done,
     /*  252593 */   // Label 4841: @252593
     /*  252593 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(252656), // Rule ID 5345 //
     /*  252598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  252601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc),
     /*  252606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  252609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  252612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  252615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  252626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  252630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252637 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11339:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  252637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VX_M8),
     /*  252640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  252654 */     GIR_RootConstrainSelectedInstOperands,
     /*  252655 */     // GIR_Coverage, 5345,
     /*  252655 */     GIR_EraseRootFromParent_Done,
     /*  252656 */   // Label 4842: @252656
     /*  252656 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(252719), // Rule ID 5566 //
     /*  252661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  252675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  252678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  252703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252717 */     GIR_RootConstrainSelectedInstOperands,
     /*  252718 */     // GIR_Coverage, 5566,
     /*  252718 */     GIR_EraseRootFromParent_Done,
     /*  252719 */   // Label 4843: @252719
     /*  252719 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(252782), // Rule ID 5567 //
     /*  252724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  252735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  252738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  252741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252763 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF8),
     /*  252766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252780 */     GIR_RootConstrainSelectedInstOperands,
     /*  252781 */     // GIR_Coverage, 5567,
     /*  252781 */     GIR_EraseRootFromParent_Done,
     /*  252782 */   // Label 4844: @252782
     /*  252782 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(252845), // Rule ID 5568 //
     /*  252787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  252801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  252804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252826 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  252829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252843 */     GIR_RootConstrainSelectedInstOperands,
     /*  252844 */     // GIR_Coverage, 5568,
     /*  252844 */     GIR_EraseRootFromParent_Done,
     /*  252845 */   // Label 4845: @252845
     /*  252845 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(252908), // Rule ID 5569 //
     /*  252850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  252861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  252864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  252867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252889 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  252889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  252892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252906 */     GIR_RootConstrainSelectedInstOperands,
     /*  252907 */     // GIR_Coverage, 5569,
     /*  252907 */     GIR_EraseRootFromParent_Done,
     /*  252908 */   // Label 4846: @252908
     /*  252908 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(252971), // Rule ID 5570 //
     /*  252913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  252916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  252927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  252930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  252933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  252945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  252952 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  252952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  252955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  252957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  252959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  252961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  252966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  252969 */     GIR_RootConstrainSelectedInstOperands,
     /*  252970 */     // GIR_Coverage, 5570,
     /*  252970 */     GIR_EraseRootFromParent_Done,
     /*  252971 */   // Label 4847: @252971
     /*  252971 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(253034), // Rule ID 5571 //
     /*  252976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  252979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  252984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  252987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  252990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  252993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  252996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253015 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253032 */     GIR_RootConstrainSelectedInstOperands,
     /*  253033 */     // GIR_Coverage, 5571,
     /*  253033 */     GIR_EraseRootFromParent_Done,
     /*  253034 */   // Label 4848: @253034
     /*  253034 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(253097), // Rule ID 5572 //
     /*  253039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253078 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253095 */     GIR_RootConstrainSelectedInstOperands,
     /*  253096 */     // GIR_Coverage, 5572,
     /*  253096 */     GIR_EraseRootFromParent_Done,
     /*  253097 */   // Label 4849: @253097
     /*  253097 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(253160), // Rule ID 5573 //
     /*  253102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  253116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  253119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253141 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF4),
     /*  253144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253158 */     GIR_RootConstrainSelectedInstOperands,
     /*  253159 */     // GIR_Coverage, 5573,
     /*  253159 */     GIR_EraseRootFromParent_Done,
     /*  253160 */   // Label 4850: @253160
     /*  253160 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(253223), // Rule ID 5574 //
     /*  253165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253221 */     GIR_RootConstrainSelectedInstOperands,
     /*  253222 */     // GIR_Coverage, 5574,
     /*  253222 */     GIR_EraseRootFromParent_Done,
     /*  253223 */   // Label 4851: @253223
     /*  253223 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(253286), // Rule ID 5575 //
     /*  253228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  253242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  253245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253267 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253284 */     GIR_RootConstrainSelectedInstOperands,
     /*  253285 */     // GIR_Coverage, 5575,
     /*  253285 */     GIR_EraseRootFromParent_Done,
     /*  253286 */   // Label 4852: @253286
     /*  253286 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(253349), // Rule ID 5576 //
     /*  253291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253330 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253347 */     GIR_RootConstrainSelectedInstOperands,
     /*  253348 */     // GIR_Coverage, 5576,
     /*  253348 */     GIR_EraseRootFromParent_Done,
     /*  253349 */   // Label 4853: @253349
     /*  253349 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(253412), // Rule ID 5577 //
     /*  253354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  253368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  253371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253393 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_MF2),
     /*  253396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253410 */     GIR_RootConstrainSelectedInstOperands,
     /*  253411 */     // GIR_Coverage, 5577,
     /*  253411 */     GIR_EraseRootFromParent_Done,
     /*  253412 */   // Label 4854: @253412
     /*  253412 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(253475), // Rule ID 5578 //
     /*  253417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  253431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  253434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253473 */     GIR_RootConstrainSelectedInstOperands,
     /*  253474 */     // GIR_Coverage, 5578,
     /*  253474 */     GIR_EraseRootFromParent_Done,
     /*  253475 */   // Label 4855: @253475
     /*  253475 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(253538), // Rule ID 5579 //
     /*  253480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  253491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  253494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  253497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253519 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  253519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253536 */     GIR_RootConstrainSelectedInstOperands,
     /*  253537 */     // GIR_Coverage, 5579,
     /*  253537 */     GIR_EraseRootFromParent_Done,
     /*  253538 */   // Label 4856: @253538
     /*  253538 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(253601), // Rule ID 5580 //
     /*  253543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  253557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  253560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253582 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  253582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253599 */     GIR_RootConstrainSelectedInstOperands,
     /*  253600 */     // GIR_Coverage, 5580,
     /*  253600 */     GIR_EraseRootFromParent_Done,
     /*  253601 */   // Label 4857: @253601
     /*  253601 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(253664), // Rule ID 5581 //
     /*  253606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  253617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  253620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  253623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253645 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  253645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  253662 */     GIR_RootConstrainSelectedInstOperands,
     /*  253663 */     // GIR_Coverage, 5581,
     /*  253663 */     GIR_EraseRootFromParent_Done,
     /*  253664 */   // Label 4858: @253664
     /*  253664 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(253727), // Rule ID 5582 //
     /*  253669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  253683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  253686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  253708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253725 */     GIR_RootConstrainSelectedInstOperands,
     /*  253726 */     // GIR_Coverage, 5582,
     /*  253726 */     GIR_EraseRootFromParent_Done,
     /*  253727 */   // Label 4859: @253727
     /*  253727 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(253790), // Rule ID 5583 //
     /*  253732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  253743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  253746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  253749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253771 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  253771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  253788 */     GIR_RootConstrainSelectedInstOperands,
     /*  253789 */     // GIR_Coverage, 5583,
     /*  253789 */     GIR_EraseRootFromParent_Done,
     /*  253790 */   // Label 4860: @253790
     /*  253790 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(253853), // Rule ID 5584 //
     /*  253795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  253798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  253809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  253812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253834 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  253834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253851 */     GIR_RootConstrainSelectedInstOperands,
     /*  253852 */     // GIR_Coverage, 5584,
     /*  253852 */     GIR_EraseRootFromParent_Done,
     /*  253853 */   // Label 4861: @253853
     /*  253853 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(253916), // Rule ID 5585 //
     /*  253858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  253861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  253869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  253872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  253875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  253878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253897 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  253897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M1),
     /*  253900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  253914 */     GIR_RootConstrainSelectedInstOperands,
     /*  253915 */     // GIR_Coverage, 5585,
     /*  253915 */     GIR_EraseRootFromParent_Done,
     /*  253916 */   // Label 4862: @253916
     /*  253916 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(253979), // Rule ID 5586 //
     /*  253921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  253924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  253935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  253938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  253941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  253945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  253953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  253960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  253960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  253963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  253965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  253967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  253969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  253974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  253977 */     GIR_RootConstrainSelectedInstOperands,
     /*  253978 */     // GIR_Coverage, 5586,
     /*  253978 */     GIR_EraseRootFromParent_Done,
     /*  253979 */   // Label 4863: @253979
     /*  253979 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(254042), // Rule ID 5587 //
     /*  253984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  253987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  253992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  253995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  253998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  254001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254023 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254040 */     GIR_RootConstrainSelectedInstOperands,
     /*  254041 */     // GIR_Coverage, 5587,
     /*  254041 */     GIR_EraseRootFromParent_Done,
     /*  254042 */   // Label 4864: @254042
     /*  254042 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(254105), // Rule ID 5588 //
     /*  254047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254086 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254103 */     GIR_RootConstrainSelectedInstOperands,
     /*  254104 */     // GIR_Coverage, 5588,
     /*  254104 */     GIR_EraseRootFromParent_Done,
     /*  254105 */   // Label 4865: @254105
     /*  254105 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(254168), // Rule ID 5589 //
     /*  254110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  254124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  254127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254149 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254166 */     GIR_RootConstrainSelectedInstOperands,
     /*  254167 */     // GIR_Coverage, 5589,
     /*  254167 */     GIR_EraseRootFromParent_Done,
     /*  254168 */   // Label 4866: @254168
     /*  254168 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(254231), // Rule ID 5590 //
     /*  254173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254212 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  254212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254229 */     GIR_RootConstrainSelectedInstOperands,
     /*  254230 */     // GIR_Coverage, 5590,
     /*  254230 */     GIR_EraseRootFromParent_Done,
     /*  254231 */   // Label 4867: @254231
     /*  254231 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(254294), // Rule ID 5591 //
     /*  254236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  254247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  254250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  254253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254275 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  254275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  254292 */     GIR_RootConstrainSelectedInstOperands,
     /*  254293 */     // GIR_Coverage, 5591,
     /*  254293 */     GIR_EraseRootFromParent_Done,
     /*  254294 */   // Label 4868: @254294
     /*  254294 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(254357), // Rule ID 5592 //
     /*  254299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254355 */     GIR_RootConstrainSelectedInstOperands,
     /*  254356 */     // GIR_Coverage, 5592,
     /*  254356 */     GIR_EraseRootFromParent_Done,
     /*  254357 */   // Label 4869: @254357
     /*  254357 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(254420), // Rule ID 5593 //
     /*  254362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  254376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  254379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254401 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254418 */     GIR_RootConstrainSelectedInstOperands,
     /*  254419 */     // GIR_Coverage, 5593,
     /*  254419 */     GIR_EraseRootFromParent_Done,
     /*  254420 */   // Label 4870: @254420
     /*  254420 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(254483), // Rule ID 5594 //
     /*  254425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254481 */     GIR_RootConstrainSelectedInstOperands,
     /*  254482 */     // GIR_Coverage, 5594,
     /*  254482 */     GIR_EraseRootFromParent_Done,
     /*  254483 */   // Label 4871: @254483
     /*  254483 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(254546), // Rule ID 5595 //
     /*  254488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  254502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  254505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254527 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254544 */     GIR_RootConstrainSelectedInstOperands,
     /*  254545 */     // GIR_Coverage, 5595,
     /*  254545 */     GIR_EraseRootFromParent_Done,
     /*  254546 */   // Label 4872: @254546
     /*  254546 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(254609), // Rule ID 5596 //
     /*  254551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  254565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  254568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254590 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  254590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254607 */     GIR_RootConstrainSelectedInstOperands,
     /*  254608 */     // GIR_Coverage, 5596,
     /*  254608 */     GIR_EraseRootFromParent_Done,
     /*  254609 */   // Label 4873: @254609
     /*  254609 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(254672), // Rule ID 5597 //
     /*  254614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  254625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  254628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  254631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254653 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  254653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  254670 */     GIR_RootConstrainSelectedInstOperands,
     /*  254671 */     // GIR_Coverage, 5597,
     /*  254671 */     GIR_EraseRootFromParent_Done,
     /*  254672 */   // Label 4874: @254672
     /*  254672 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(254735), // Rule ID 5598 //
     /*  254677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  254691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  254694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254716 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254733 */     GIR_RootConstrainSelectedInstOperands,
     /*  254734 */     // GIR_Coverage, 5598,
     /*  254734 */     GIR_EraseRootFromParent_Done,
     /*  254735 */   // Label 4875: @254735
     /*  254735 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(254798), // Rule ID 5599 //
     /*  254740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  254751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  254754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  254757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  254772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254779 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  254782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254796 */     GIR_RootConstrainSelectedInstOperands,
     /*  254797 */     // GIR_Coverage, 5599,
     /*  254797 */     GIR_EraseRootFromParent_Done,
     /*  254798 */   // Label 4876: @254798
     /*  254798 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(254861), // Rule ID 5600 //
     /*  254803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  254817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  254820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254842 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254859 */     GIR_RootConstrainSelectedInstOperands,
     /*  254860 */     // GIR_Coverage, 5600,
     /*  254860 */     GIR_EraseRootFromParent_Done,
     /*  254861 */   // Label 4877: @254861
     /*  254861 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(254924), // Rule ID 5601 //
     /*  254866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  254877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  254880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  254883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  254886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  254898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254905 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  254905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  254908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254922 */     GIR_RootConstrainSelectedInstOperands,
     /*  254923 */     // GIR_Coverage, 5601,
     /*  254923 */     GIR_EraseRootFromParent_Done,
     /*  254924 */   // Label 4878: @254924
     /*  254924 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(254987), // Rule ID 5602 //
     /*  254929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  254932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  254937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  254940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  254943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  254946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  254949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  254953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  254961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  254968 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  254968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  254971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  254973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  254975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  254977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  254982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  254985 */     GIR_RootConstrainSelectedInstOperands,
     /*  254986 */     // GIR_Coverage, 5602,
     /*  254986 */     GIR_EraseRootFromParent_Done,
     /*  254987 */   // Label 4879: @254987
     /*  254987 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(255050), // Rule ID 5603 //
     /*  254992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  254995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  255003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  255006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  255009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255031 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  255031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  255048 */     GIR_RootConstrainSelectedInstOperands,
     /*  255049 */     // GIR_Coverage, 5603,
     /*  255049 */     GIR_EraseRootFromParent_Done,
     /*  255050 */   // Label 4880: @255050
     /*  255050 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(255113), // Rule ID 5604 //
     /*  255055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255094 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255111 */     GIR_RootConstrainSelectedInstOperands,
     /*  255112 */     // GIR_Coverage, 5604,
     /*  255112 */     GIR_EraseRootFromParent_Done,
     /*  255113 */   // Label 4881: @255113
     /*  255113 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(255176), // Rule ID 5605 //
     /*  255118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  255132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  255135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  255150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255157 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M2),
     /*  255160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255174 */     GIR_RootConstrainSelectedInstOperands,
     /*  255175 */     // GIR_Coverage, 5605,
     /*  255175 */     GIR_EraseRootFromParent_Done,
     /*  255176 */   // Label 4882: @255176
     /*  255176 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(255239), // Rule ID 5606 //
     /*  255181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255237 */     GIR_RootConstrainSelectedInstOperands,
     /*  255238 */     // GIR_Coverage, 5606,
     /*  255238 */     GIR_EraseRootFromParent_Done,
     /*  255239 */   // Label 4883: @255239
     /*  255239 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(255302), // Rule ID 5607 //
     /*  255244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  255258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  255261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  255276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255283 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M4),
     /*  255286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255300 */     GIR_RootConstrainSelectedInstOperands,
     /*  255301 */     // GIR_Coverage, 5607,
     /*  255301 */     GIR_EraseRootFromParent_Done,
     /*  255302 */   // Label 4884: @255302
     /*  255302 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(255365), // Rule ID 5608 //
     /*  255307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  255310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255346 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  255346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255363 */     GIR_RootConstrainSelectedInstOperands,
     /*  255364 */     // GIR_Coverage, 5608,
     /*  255364 */     GIR_EraseRootFromParent_Done,
     /*  255365 */   // Label 4885: @255365
     /*  255365 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(255428), // Rule ID 5609 //
     /*  255370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  255373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  255381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  255384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  255387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  255402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255409 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  255409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VV_M8),
     /*  255412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  255426 */     GIR_RootConstrainSelectedInstOperands,
     /*  255427 */     // GIR_Coverage, 5609,
     /*  255427 */     GIR_EraseRootFromParent_Done,
     /*  255428 */   // Label 4886: @255428
     /*  255428 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(255491), // Rule ID 5610 //
     /*  255433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  255447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  255475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255489 */     GIR_RootConstrainSelectedInstOperands,
     /*  255490 */     // GIR_Coverage, 5610,
     /*  255490 */     GIR_EraseRootFromParent_Done,
     /*  255491 */   // Label 4887: @255491
     /*  255491 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(255554), // Rule ID 5611 //
     /*  255496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  255510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255535 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF8),
     /*  255538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255552 */     GIR_RootConstrainSelectedInstOperands,
     /*  255553 */     // GIR_Coverage, 5611,
     /*  255553 */     GIR_EraseRootFromParent_Done,
     /*  255554 */   // Label 4888: @255554
     /*  255554 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(255617), // Rule ID 5612 //
     /*  255559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  255573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255598 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  255601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255615 */     GIR_RootConstrainSelectedInstOperands,
     /*  255616 */     // GIR_Coverage, 5612,
     /*  255616 */     GIR_EraseRootFromParent_Done,
     /*  255617 */   // Label 4889: @255617
     /*  255617 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(255680), // Rule ID 5613 //
     /*  255622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  255636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255661 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  255664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255678 */     GIR_RootConstrainSelectedInstOperands,
     /*  255679 */     // GIR_Coverage, 5613,
     /*  255679 */     GIR_EraseRootFromParent_Done,
     /*  255680 */   // Label 4890: @255680
     /*  255680 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(255743), // Rule ID 5614 //
     /*  255685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  255699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  255724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  255727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255741 */     GIR_RootConstrainSelectedInstOperands,
     /*  255742 */     // GIR_Coverage, 5614,
     /*  255742 */     GIR_EraseRootFromParent_Done,
     /*  255743 */   // Label 4891: @255743
     /*  255743 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(255806), // Rule ID 5615 //
     /*  255748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  255759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  255762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255787 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  255787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  255790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  255804 */     GIR_RootConstrainSelectedInstOperands,
     /*  255805 */     // GIR_Coverage, 5615,
     /*  255805 */     GIR_EraseRootFromParent_Done,
     /*  255806 */   // Label 4892: @255806
     /*  255806 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(255869), // Rule ID 5616 //
     /*  255811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  255825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  255853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255867 */     GIR_RootConstrainSelectedInstOperands,
     /*  255868 */     // GIR_Coverage, 5616,
     /*  255868 */     GIR_EraseRootFromParent_Done,
     /*  255869 */   // Label 4893: @255869
     /*  255869 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(255932), // Rule ID 5617 //
     /*  255874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  255877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  255885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  255888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  255891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  255894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255913 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  255913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF4),
     /*  255916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255930 */     GIR_RootConstrainSelectedInstOperands,
     /*  255931 */     // GIR_Coverage, 5617,
     /*  255931 */     GIR_EraseRootFromParent_Done,
     /*  255932 */   // Label 4894: @255932
     /*  255932 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(255995), // Rule ID 5618 //
     /*  255937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  255940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  255945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  255948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  255951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  255954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  255957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  255965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  255969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  255976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  255976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  255979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  255981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  255983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  255985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  255990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  255993 */     GIR_RootConstrainSelectedInstOperands,
     /*  255994 */     // GIR_Coverage, 5618,
     /*  255994 */     GIR_EraseRootFromParent_Done,
     /*  255995 */   // Label 4895: @255995
     /*  255995 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(256058), // Rule ID 5619 //
     /*  256000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  256014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256056 */     GIR_RootConstrainSelectedInstOperands,
     /*  256057 */     // GIR_Coverage, 5619,
     /*  256057 */     GIR_EraseRootFromParent_Done,
     /*  256058 */   // Label 4896: @256058
     /*  256058 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(256121), // Rule ID 5620 //
     /*  256063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256119 */     GIR_RootConstrainSelectedInstOperands,
     /*  256120 */     // GIR_Coverage, 5620,
     /*  256120 */     GIR_EraseRootFromParent_Done,
     /*  256121 */   // Label 4897: @256121
     /*  256121 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(256184), // Rule ID 5621 //
     /*  256126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  256140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_MF2),
     /*  256168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256182 */     GIR_RootConstrainSelectedInstOperands,
     /*  256183 */     // GIR_Coverage, 5621,
     /*  256183 */     GIR_EraseRootFromParent_Done,
     /*  256184 */   // Label 4898: @256184
     /*  256184 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(256247), // Rule ID 5622 //
     /*  256189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256228 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256245 */     GIR_RootConstrainSelectedInstOperands,
     /*  256246 */     // GIR_Coverage, 5622,
     /*  256246 */     GIR_EraseRootFromParent_Done,
     /*  256247 */   // Label 4899: @256247
     /*  256247 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(256310), // Rule ID 5623 //
     /*  256252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  256263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  256266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256291 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256308 */     GIR_RootConstrainSelectedInstOperands,
     /*  256309 */     // GIR_Coverage, 5623,
     /*  256309 */     GIR_EraseRootFromParent_Done,
     /*  256310 */   // Label 4900: @256310
     /*  256310 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(256373), // Rule ID 5624 //
     /*  256315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256354 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  256354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256371 */     GIR_RootConstrainSelectedInstOperands,
     /*  256372 */     // GIR_Coverage, 5624,
     /*  256372 */     GIR_EraseRootFromParent_Done,
     /*  256373 */   // Label 4901: @256373
     /*  256373 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(256436), // Rule ID 5625 //
     /*  256378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  256389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  256392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256417 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  256417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  256434 */     GIR_RootConstrainSelectedInstOperands,
     /*  256435 */     // GIR_Coverage, 5625,
     /*  256435 */     GIR_EraseRootFromParent_Done,
     /*  256436 */   // Label 4902: @256436
     /*  256436 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(256499), // Rule ID 5626 //
     /*  256441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  256455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  256480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256497 */     GIR_RootConstrainSelectedInstOperands,
     /*  256498 */     // GIR_Coverage, 5626,
     /*  256498 */     GIR_EraseRootFromParent_Done,
     /*  256499 */   // Label 4903: @256499
     /*  256499 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(256562), // Rule ID 5627 //
     /*  256504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  256515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  256518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256543 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  256543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  256560 */     GIR_RootConstrainSelectedInstOperands,
     /*  256561 */     // GIR_Coverage, 5627,
     /*  256561 */     GIR_EraseRootFromParent_Done,
     /*  256562 */   // Label 4904: @256562
     /*  256562 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(256625), // Rule ID 5628 //
     /*  256567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  256570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  256581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256606 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  256606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256623 */     GIR_RootConstrainSelectedInstOperands,
     /*  256624 */     // GIR_Coverage, 5628,
     /*  256624 */     GIR_EraseRootFromParent_Done,
     /*  256625 */   // Label 4905: @256625
     /*  256625 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(256688), // Rule ID 5629 //
     /*  256630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  256633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  256641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  256644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256669 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11371:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  256669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M1),
     /*  256672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  256686 */     GIR_RootConstrainSelectedInstOperands,
     /*  256687 */     // GIR_Coverage, 5629,
     /*  256687 */     GIR_EraseRootFromParent_Done,
     /*  256688 */   // Label 4906: @256688
     /*  256688 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(256751), // Rule ID 5630 //
     /*  256693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  256707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  256735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256749 */     GIR_RootConstrainSelectedInstOperands,
     /*  256750 */     // GIR_Coverage, 5630,
     /*  256750 */     GIR_EraseRootFromParent_Done,
     /*  256751 */   // Label 4907: @256751
     /*  256751 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(256814), // Rule ID 5631 //
     /*  256756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  256767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  256770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  256784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  256798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256812 */     GIR_RootConstrainSelectedInstOperands,
     /*  256813 */     // GIR_Coverage, 5631,
     /*  256813 */     GIR_EraseRootFromParent_Done,
     /*  256814 */   // Label 4908: @256814
     /*  256814 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(256877), // Rule ID 5632 //
     /*  256819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  256833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256858 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  256861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256875 */     GIR_RootConstrainSelectedInstOperands,
     /*  256876 */     // GIR_Coverage, 5632,
     /*  256876 */     GIR_EraseRootFromParent_Done,
     /*  256877 */   // Label 4909: @256877
     /*  256877 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(256940), // Rule ID 5633 //
     /*  256882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  256885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  256893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  256896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  256899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  256902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  256910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256921 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  256921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  256924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  256938 */     GIR_RootConstrainSelectedInstOperands,
     /*  256939 */     // GIR_Coverage, 5633,
     /*  256939 */     GIR_EraseRootFromParent_Done,
     /*  256940 */   // Label 4910: @256940
     /*  256940 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(257003), // Rule ID 5634 //
     /*  256945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  256948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  256953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  256956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  256959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  256962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  256965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  256969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  256973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  256977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  256984 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  256984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  256987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  256989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  256991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  256993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  256998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257001 */     GIR_RootConstrainSelectedInstOperands,
     /*  257002 */     // GIR_Coverage, 5634,
     /*  257002 */     GIR_EraseRootFromParent_Done,
     /*  257003 */   // Label 4911: @257003
     /*  257003 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(257066), // Rule ID 5635 //
     /*  257008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  257019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  257022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257047 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  257047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  257064 */     GIR_RootConstrainSelectedInstOperands,
     /*  257065 */     // GIR_Coverage, 5635,
     /*  257065 */     GIR_EraseRootFromParent_Done,
     /*  257066 */   // Label 4912: @257066
     /*  257066 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(257129), // Rule ID 5636 //
     /*  257071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257127 */     GIR_RootConstrainSelectedInstOperands,
     /*  257128 */     // GIR_Coverage, 5636,
     /*  257128 */     GIR_EraseRootFromParent_Done,
     /*  257129 */   // Label 4913: @257129
     /*  257129 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(257192), // Rule ID 5637 //
     /*  257134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  257148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257173 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257190 */     GIR_RootConstrainSelectedInstOperands,
     /*  257191 */     // GIR_Coverage, 5637,
     /*  257191 */     GIR_EraseRootFromParent_Done,
     /*  257192 */   // Label 4914: @257192
     /*  257192 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(257255), // Rule ID 5638 //
     /*  257197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257253 */     GIR_RootConstrainSelectedInstOperands,
     /*  257254 */     // GIR_Coverage, 5638,
     /*  257254 */     GIR_EraseRootFromParent_Done,
     /*  257255 */   // Label 4915: @257255
     /*  257255 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(257318), // Rule ID 5639 //
     /*  257260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  257274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257299 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257316 */     GIR_RootConstrainSelectedInstOperands,
     /*  257317 */     // GIR_Coverage, 5639,
     /*  257317 */     GIR_EraseRootFromParent_Done,
     /*  257318 */   // Label 4916: @257318
     /*  257318 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(257381), // Rule ID 5640 //
     /*  257323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257362 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  257362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257379 */     GIR_RootConstrainSelectedInstOperands,
     /*  257380 */     // GIR_Coverage, 5640,
     /*  257380 */     GIR_EraseRootFromParent_Done,
     /*  257381 */   // Label 4917: @257381
     /*  257381 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(257444), // Rule ID 5641 //
     /*  257386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  257397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  257400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257425 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  257425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  257442 */     GIR_RootConstrainSelectedInstOperands,
     /*  257443 */     // GIR_Coverage, 5641,
     /*  257443 */     GIR_EraseRootFromParent_Done,
     /*  257444 */   // Label 4918: @257444
     /*  257444 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(257507), // Rule ID 5642 //
     /*  257449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  257463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257505 */     GIR_RootConstrainSelectedInstOperands,
     /*  257506 */     // GIR_Coverage, 5642,
     /*  257506 */     GIR_EraseRootFromParent_Done,
     /*  257507 */   // Label 4919: @257507
     /*  257507 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(257570), // Rule ID 5643 //
     /*  257512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  257526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257551 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257568 */     GIR_RootConstrainSelectedInstOperands,
     /*  257569 */     // GIR_Coverage, 5643,
     /*  257569 */     GIR_EraseRootFromParent_Done,
     /*  257570 */   // Label 4920: @257570
     /*  257570 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(257633), // Rule ID 5644 //
     /*  257575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  257589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257631 */     GIR_RootConstrainSelectedInstOperands,
     /*  257632 */     // GIR_Coverage, 5644,
     /*  257632 */     GIR_EraseRootFromParent_Done,
     /*  257633 */   // Label 4921: @257633
     /*  257633 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(257696), // Rule ID 5645 //
     /*  257638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  257649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  257652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257694 */     GIR_RootConstrainSelectedInstOperands,
     /*  257695 */     // GIR_Coverage, 5645,
     /*  257695 */     GIR_EraseRootFromParent_Done,
     /*  257696 */   // Label 4922: @257696
     /*  257696 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(257759), // Rule ID 5646 //
     /*  257701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  257704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  257715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  257740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257757 */     GIR_RootConstrainSelectedInstOperands,
     /*  257758 */     // GIR_Coverage, 5646,
     /*  257758 */     GIR_EraseRootFromParent_Done,
     /*  257759 */   // Label 4923: @257759
     /*  257759 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(257822), // Rule ID 5647 //
     /*  257764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  257767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  257775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  257778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  257792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257803 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  257803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  257806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  257820 */     GIR_RootConstrainSelectedInstOperands,
     /*  257821 */     // GIR_Coverage, 5647,
     /*  257821 */     GIR_EraseRootFromParent_Done,
     /*  257822 */   // Label 4924: @257822
     /*  257822 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(257885), // Rule ID 5648 //
     /*  257827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  257841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257883 */     GIR_RootConstrainSelectedInstOperands,
     /*  257884 */     // GIR_Coverage, 5648,
     /*  257884 */     GIR_EraseRootFromParent_Done,
     /*  257885 */   // Label 4925: @257885
     /*  257885 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(257948), // Rule ID 5649 //
     /*  257890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  257893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  257901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  257904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  257907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  257910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  257918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257929 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11371:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  257929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M2),
     /*  257932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  257938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  257943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  257946 */     GIR_RootConstrainSelectedInstOperands,
     /*  257947 */     // GIR_Coverage, 5649,
     /*  257947 */     GIR_EraseRootFromParent_Done,
     /*  257948 */   // Label 4926: @257948
     /*  257948 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(258011), // Rule ID 5650 //
     /*  257953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  257956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  257961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  257964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  257967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  257970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  257973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  257977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  257981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  257985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  257992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  257992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  257995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  257997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  257999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258009 */     GIR_RootConstrainSelectedInstOperands,
     /*  258010 */     // GIR_Coverage, 5650,
     /*  258010 */     GIR_EraseRootFromParent_Done,
     /*  258011 */   // Label 4927: @258011
     /*  258011 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(258074), // Rule ID 5651 //
     /*  258016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  258030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  258044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258055 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11371:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M4),
     /*  258058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258072 */     GIR_RootConstrainSelectedInstOperands,
     /*  258073 */     // GIR_Coverage, 5651,
     /*  258073 */     GIR_EraseRootFromParent_Done,
     /*  258074 */   // Label 4928: @258074
     /*  258074 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(258137), // Rule ID 5652 //
     /*  258079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  258082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  258096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258118 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  258118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258135 */     GIR_RootConstrainSelectedInstOperands,
     /*  258136 */     // GIR_Coverage, 5652,
     /*  258136 */     GIR_EraseRootFromParent_Done,
     /*  258137 */   // Label 4929: @258137
     /*  258137 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(258200), // Rule ID 5653 //
     /*  258142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  258145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc),
     /*  258150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  258156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  258159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  258170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  258174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258181 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11371:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  258181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VX_M8),
     /*  258184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  258198 */     GIR_RootConstrainSelectedInstOperands,
     /*  258199 */     // GIR_Coverage, 5653,
     /*  258199 */     GIR_EraseRootFromParent_Done,
     /*  258200 */   // Label 4930: @258200
     /*  258200 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(258263), // Rule ID 7686 //
     /*  258205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258261 */     GIR_RootConstrainSelectedInstOperands,
     /*  258262 */     // GIR_Coverage, 7686,
     /*  258262 */     GIR_EraseRootFromParent_Done,
     /*  258263 */   // Label 4931: @258263
     /*  258263 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(258326), // Rule ID 7687 //
     /*  258268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  258282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  258285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258324 */     GIR_RootConstrainSelectedInstOperands,
     /*  258325 */     // GIR_Coverage, 7687,
     /*  258325 */     GIR_EraseRootFromParent_Done,
     /*  258326 */   // Label 4932: @258326
     /*  258326 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(258389), // Rule ID 7690 //
     /*  258331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258370 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258387 */     GIR_RootConstrainSelectedInstOperands,
     /*  258388 */     // GIR_Coverage, 7690,
     /*  258388 */     GIR_EraseRootFromParent_Done,
     /*  258389 */   // Label 4933: @258389
     /*  258389 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(258452), // Rule ID 7691 //
     /*  258394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  258408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  258411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258450 */     GIR_RootConstrainSelectedInstOperands,
     /*  258451 */     // GIR_Coverage, 7691,
     /*  258451 */     GIR_EraseRootFromParent_Done,
     /*  258452 */   // Label 4934: @258452
     /*  258452 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(258515), // Rule ID 7694 //
     /*  258457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  258471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258496 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258513 */     GIR_RootConstrainSelectedInstOperands,
     /*  258514 */     // GIR_Coverage, 7694,
     /*  258514 */     GIR_EraseRootFromParent_Done,
     /*  258515 */   // Label 4935: @258515
     /*  258515 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(258578), // Rule ID 7695 //
     /*  258520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  258534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  258537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258559 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /*  258562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258576 */     GIR_RootConstrainSelectedInstOperands,
     /*  258577 */     // GIR_Coverage, 7695,
     /*  258577 */     GIR_EraseRootFromParent_Done,
     /*  258578 */   // Label 4936: @258578
     /*  258578 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(258641), // Rule ID 7698 //
     /*  258583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  258597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  258600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258622 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  258622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258639 */     GIR_RootConstrainSelectedInstOperands,
     /*  258640 */     // GIR_Coverage, 7698,
     /*  258640 */     GIR_EraseRootFromParent_Done,
     /*  258641 */   // Label 4937: @258641
     /*  258641 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(258704), // Rule ID 7699 //
     /*  258646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  258657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  258660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  258663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258685 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  258685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  258702 */     GIR_RootConstrainSelectedInstOperands,
     /*  258703 */     // GIR_Coverage, 7699,
     /*  258703 */     GIR_EraseRootFromParent_Done,
     /*  258704 */   // Label 4938: @258704
     /*  258704 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(258767), // Rule ID 7702 //
     /*  258709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  258723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  258726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  258748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258765 */     GIR_RootConstrainSelectedInstOperands,
     /*  258766 */     // GIR_Coverage, 7702,
     /*  258766 */     GIR_EraseRootFromParent_Done,
     /*  258767 */   // Label 4939: @258767
     /*  258767 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(258830), // Rule ID 7703 //
     /*  258772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  258783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  258786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  258789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258811 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  258811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /*  258814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  258828 */     GIR_RootConstrainSelectedInstOperands,
     /*  258829 */     // GIR_Coverage, 7703,
     /*  258829 */     GIR_EraseRootFromParent_Done,
     /*  258830 */   // Label 4940: @258830
     /*  258830 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(258893), // Rule ID 7706 //
     /*  258835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  258849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  258852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258874 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  258874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  258877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258891 */     GIR_RootConstrainSelectedInstOperands,
     /*  258892 */     // GIR_Coverage, 7706,
     /*  258892 */     GIR_EraseRootFromParent_Done,
     /*  258893 */   // Label 4941: @258893
     /*  258893 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(258956), // Rule ID 7707 //
     /*  258898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  258901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  258909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  258912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  258915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  258918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  258937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  258937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  258940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  258942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  258944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  258946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  258951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  258954 */     GIR_RootConstrainSelectedInstOperands,
     /*  258955 */     // GIR_Coverage, 7707,
     /*  258955 */     GIR_EraseRootFromParent_Done,
     /*  258956 */   // Label 4942: @258956
     /*  258956 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(259019), // Rule ID 7710 //
     /*  258961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  258964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  258969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  258972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  258975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  258978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  258981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  258993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259017 */     GIR_RootConstrainSelectedInstOperands,
     /*  259018 */     // GIR_Coverage, 7710,
     /*  259018 */     GIR_EraseRootFromParent_Done,
     /*  259019 */   // Label 4943: @259019
     /*  259019 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(259082), // Rule ID 7711 //
     /*  259024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  259035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  259038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  259041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259063 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259080 */     GIR_RootConstrainSelectedInstOperands,
     /*  259081 */     // GIR_Coverage, 7711,
     /*  259081 */     GIR_EraseRootFromParent_Done,
     /*  259082 */   // Label 4944: @259082
     /*  259082 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(259145), // Rule ID 7714 //
     /*  259087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259126 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  259126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259143 */     GIR_RootConstrainSelectedInstOperands,
     /*  259144 */     // GIR_Coverage, 7714,
     /*  259144 */     GIR_EraseRootFromParent_Done,
     /*  259145 */   // Label 4945: @259145
     /*  259145 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(259208), // Rule ID 7715 //
     /*  259150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  259161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  259164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  259167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259189 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  259189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  259206 */     GIR_RootConstrainSelectedInstOperands,
     /*  259207 */     // GIR_Coverage, 7715,
     /*  259207 */     GIR_EraseRootFromParent_Done,
     /*  259208 */   // Label 4946: @259208
     /*  259208 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(259271), // Rule ID 7718 //
     /*  259213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  259216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259252 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  259252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259269 */     GIR_RootConstrainSelectedInstOperands,
     /*  259270 */     // GIR_Coverage, 7718,
     /*  259270 */     GIR_EraseRootFromParent_Done,
     /*  259271 */   // Label 4947: @259271
     /*  259271 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(259334), // Rule ID 7719 //
     /*  259276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  259279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  259287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  259290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  259293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259315 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  259315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /*  259318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  259332 */     GIR_RootConstrainSelectedInstOperands,
     /*  259333 */     // GIR_Coverage, 7719,
     /*  259333 */     GIR_EraseRootFromParent_Done,
     /*  259334 */   // Label 4948: @259334
     /*  259334 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(259397), // Rule ID 7722 //
     /*  259339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259378 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259395 */     GIR_RootConstrainSelectedInstOperands,
     /*  259396 */     // GIR_Coverage, 7722,
     /*  259396 */     GIR_EraseRootFromParent_Done,
     /*  259397 */   // Label 4949: @259397
     /*  259397 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(259460), // Rule ID 7723 //
     /*  259402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  259416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  259419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259441 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259458 */     GIR_RootConstrainSelectedInstOperands,
     /*  259459 */     // GIR_Coverage, 7723,
     /*  259459 */     GIR_EraseRootFromParent_Done,
     /*  259460 */   // Label 4950: @259460
     /*  259460 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(259523), // Rule ID 7726 //
     /*  259465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  259476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  259482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259504 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  259507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259521 */     GIR_RootConstrainSelectedInstOperands,
     /*  259522 */     // GIR_Coverage, 7726,
     /*  259522 */     GIR_EraseRootFromParent_Done,
     /*  259523 */   // Label 4951: @259523
     /*  259523 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(259586), // Rule ID 7727 //
     /*  259528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  259539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  259542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  259545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259567 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  259570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259584 */     GIR_RootConstrainSelectedInstOperands,
     /*  259585 */     // GIR_Coverage, 7727,
     /*  259585 */     GIR_EraseRootFromParent_Done,
     /*  259586 */   // Label 4952: @259586
     /*  259586 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(259649), // Rule ID 7730 //
     /*  259591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  259602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  259605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  259608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259630 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  259630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  259633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259647 */     GIR_RootConstrainSelectedInstOperands,
     /*  259648 */     // GIR_Coverage, 7730,
     /*  259648 */     GIR_EraseRootFromParent_Done,
     /*  259649 */   // Label 4953: @259649
     /*  259649 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(259712), // Rule ID 7731 //
     /*  259654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  259665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  259668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  259671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259693 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  259693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  259696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  259710 */     GIR_RootConstrainSelectedInstOperands,
     /*  259711 */     // GIR_Coverage, 7731,
     /*  259711 */     GIR_EraseRootFromParent_Done,
     /*  259712 */   // Label 4954: @259712
     /*  259712 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(259775), // Rule ID 7734 //
     /*  259717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  259731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  259734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259773 */     GIR_RootConstrainSelectedInstOperands,
     /*  259774 */     // GIR_Coverage, 7734,
     /*  259774 */     GIR_EraseRootFromParent_Done,
     /*  259775 */   // Label 4955: @259775
     /*  259775 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(259838), // Rule ID 7735 //
     /*  259780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  259791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  259794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  259797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  259812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259819 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  259822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259836 */     GIR_RootConstrainSelectedInstOperands,
     /*  259837 */     // GIR_Coverage, 7735,
     /*  259837 */     GIR_EraseRootFromParent_Done,
     /*  259838 */   // Label 4956: @259838
     /*  259838 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(259901), // Rule ID 7738 //
     /*  259843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  259857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  259860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259882 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  259882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  259885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259899 */     GIR_RootConstrainSelectedInstOperands,
     /*  259900 */     // GIR_Coverage, 7738,
     /*  259900 */     GIR_EraseRootFromParent_Done,
     /*  259901 */   // Label 4957: @259901
     /*  259901 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(259964), // Rule ID 7739 //
     /*  259906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  259909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  259917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  259920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  259923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  259926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  259938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  259945 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  259945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  259948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  259950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  259952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  259954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  259959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  259962 */     GIR_RootConstrainSelectedInstOperands,
     /*  259963 */     // GIR_Coverage, 7739,
     /*  259963 */     GIR_EraseRootFromParent_Done,
     /*  259964 */   // Label 4958: @259964
     /*  259964 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(260027), // Rule ID 7742 //
     /*  259969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  259972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  259977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  259980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  259983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  259986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  259989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  259993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  259997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260008 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  260008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260025 */     GIR_RootConstrainSelectedInstOperands,
     /*  260026 */     // GIR_Coverage, 7742,
     /*  260026 */     GIR_EraseRootFromParent_Done,
     /*  260027 */   // Label 4959: @260027
     /*  260027 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(260090), // Rule ID 7743 //
     /*  260032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  260043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  260046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  260049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260071 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  260071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  260088 */     GIR_RootConstrainSelectedInstOperands,
     /*  260089 */     // GIR_Coverage, 7743,
     /*  260089 */     GIR_EraseRootFromParent_Done,
     /*  260090 */   // Label 4960: @260090
     /*  260090 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(260153), // Rule ID 7746 //
     /*  260095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260134 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260151 */     GIR_RootConstrainSelectedInstOperands,
     /*  260152 */     // GIR_Coverage, 7746,
     /*  260152 */     GIR_EraseRootFromParent_Done,
     /*  260153 */   // Label 4961: @260153
     /*  260153 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(260216), // Rule ID 7747 //
     /*  260158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  260172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  260175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260197 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260214 */     GIR_RootConstrainSelectedInstOperands,
     /*  260215 */     // GIR_Coverage, 7747,
     /*  260215 */     GIR_EraseRootFromParent_Done,
     /*  260216 */   // Label 4962: @260216
     /*  260216 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(260279), // Rule ID 7750 //
     /*  260221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260260 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260277 */     GIR_RootConstrainSelectedInstOperands,
     /*  260278 */     // GIR_Coverage, 7750,
     /*  260278 */     GIR_EraseRootFromParent_Done,
     /*  260279 */   // Label 4963: @260279
     /*  260279 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(260342), // Rule ID 7751 //
     /*  260284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  260298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  260301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260323 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260340 */     GIR_RootConstrainSelectedInstOperands,
     /*  260341 */     // GIR_Coverage, 7751,
     /*  260341 */     GIR_EraseRootFromParent_Done,
     /*  260342 */   // Label 4964: @260342
     /*  260342 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(260405), // Rule ID 7754 //
     /*  260347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260386 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  260386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260403 */     GIR_RootConstrainSelectedInstOperands,
     /*  260404 */     // GIR_Coverage, 7754,
     /*  260404 */     GIR_EraseRootFromParent_Done,
     /*  260405 */   // Label 4965: @260405
     /*  260405 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(260468), // Rule ID 7755 //
     /*  260410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  260421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  260424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  260427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  260449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  260466 */     GIR_RootConstrainSelectedInstOperands,
     /*  260467 */     // GIR_Coverage, 7755,
     /*  260467 */     GIR_EraseRootFromParent_Done,
     /*  260468 */   // Label 4966: @260468
     /*  260468 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(260531), // Rule ID 7758 //
     /*  260473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  260487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  260490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260529 */     GIR_RootConstrainSelectedInstOperands,
     /*  260530 */     // GIR_Coverage, 7758,
     /*  260530 */     GIR_EraseRootFromParent_Done,
     /*  260531 */   // Label 4967: @260531
     /*  260531 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(260594), // Rule ID 7759 //
     /*  260536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  260550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  260553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  260568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  260575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /*  260578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260592 */     GIR_RootConstrainSelectedInstOperands,
     /*  260593 */     // GIR_Coverage, 7759,
     /*  260593 */     GIR_EraseRootFromParent_Done,
     /*  260594 */   // Label 4968: @260594
     /*  260594 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(260657), // Rule ID 7762 //
     /*  260599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  260613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  260616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260638 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260655 */     GIR_RootConstrainSelectedInstOperands,
     /*  260656 */     // GIR_Coverage, 7762,
     /*  260656 */     GIR_EraseRootFromParent_Done,
     /*  260657 */   // Label 4969: @260657
     /*  260657 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(260720), // Rule ID 7763 //
     /*  260662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  260673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  260676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  260679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  260694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260701 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  260701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /*  260704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260718 */     GIR_RootConstrainSelectedInstOperands,
     /*  260719 */     // GIR_Coverage, 7763,
     /*  260719 */     GIR_EraseRootFromParent_Done,
     /*  260720 */   // Label 4970: @260720
     /*  260720 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(260783), // Rule ID 7766 //
     /*  260725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  260728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  260739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  260742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  260764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260781 */     GIR_RootConstrainSelectedInstOperands,
     /*  260782 */     // GIR_Coverage, 7766,
     /*  260782 */     GIR_EraseRootFromParent_Done,
     /*  260783 */   // Label 4971: @260783
     /*  260783 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(260846), // Rule ID 7767 //
     /*  260788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  260791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  260799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  260802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  260805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  260820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260827 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  260827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /*  260830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  260844 */     GIR_RootConstrainSelectedInstOperands,
     /*  260845 */     // GIR_Coverage, 7767,
     /*  260845 */     GIR_EraseRootFromParent_Done,
     /*  260846 */   // Label 4972: @260846
     /*  260846 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(260909), // Rule ID 7770 //
     /*  260851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  260865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260890 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  260890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  260893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260907 */     GIR_RootConstrainSelectedInstOperands,
     /*  260908 */     // GIR_Coverage, 7770,
     /*  260908 */     GIR_EraseRootFromParent_Done,
     /*  260909 */   // Label 4973: @260909
     /*  260909 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(260972), // Rule ID 7771 //
     /*  260914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  260917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  260925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  260928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  260931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  260934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  260942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  260946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  260953 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  260953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8),
     /*  260956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  260958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  260960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  260962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  260967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  260970 */     GIR_RootConstrainSelectedInstOperands,
     /*  260971 */     // GIR_Coverage, 7771,
     /*  260971 */     GIR_EraseRootFromParent_Done,
     /*  260972 */   // Label 4974: @260972
     /*  260972 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(261035), // Rule ID 7774 //
     /*  260977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  260980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  260985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  260988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  260991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  260994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  260997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261033 */     GIR_RootConstrainSelectedInstOperands,
     /*  261034 */     // GIR_Coverage, 7774,
     /*  261034 */     GIR_EraseRootFromParent_Done,
     /*  261035 */   // Label 4975: @261035
     /*  261035 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(261098), // Rule ID 7775 //
     /*  261040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  261054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261079 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261096 */     GIR_RootConstrainSelectedInstOperands,
     /*  261097 */     // GIR_Coverage, 7775,
     /*  261097 */     GIR_EraseRootFromParent_Done,
     /*  261098 */   // Label 4976: @261098
     /*  261098 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(261161), // Rule ID 7778 //
     /*  261103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261142 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261159 */     GIR_RootConstrainSelectedInstOperands,
     /*  261160 */     // GIR_Coverage, 7778,
     /*  261160 */     GIR_EraseRootFromParent_Done,
     /*  261161 */   // Label 4977: @261161
     /*  261161 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(261224), // Rule ID 7779 //
     /*  261166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  261180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261222 */     GIR_RootConstrainSelectedInstOperands,
     /*  261223 */     // GIR_Coverage, 7779,
     /*  261223 */     GIR_EraseRootFromParent_Done,
     /*  261224 */   // Label 4978: @261224
     /*  261224 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(261287), // Rule ID 7782 //
     /*  261229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261285 */     GIR_RootConstrainSelectedInstOperands,
     /*  261286 */     // GIR_Coverage, 7782,
     /*  261286 */     GIR_EraseRootFromParent_Done,
     /*  261287 */   // Label 4979: @261287
     /*  261287 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(261350), // Rule ID 7783 //
     /*  261292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  261306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261331 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4),
     /*  261334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261348 */     GIR_RootConstrainSelectedInstOperands,
     /*  261349 */     // GIR_Coverage, 7783,
     /*  261349 */     GIR_EraseRootFromParent_Done,
     /*  261350 */   // Label 4980: @261350
     /*  261350 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(261413), // Rule ID 7786 //
     /*  261355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261394 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261411 */     GIR_RootConstrainSelectedInstOperands,
     /*  261412 */     // GIR_Coverage, 7786,
     /*  261412 */     GIR_EraseRootFromParent_Done,
     /*  261413 */   // Label 4981: @261413
     /*  261413 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(261476), // Rule ID 7787 //
     /*  261418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  261432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261457 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261474 */     GIR_RootConstrainSelectedInstOperands,
     /*  261475 */     // GIR_Coverage, 7787,
     /*  261475 */     GIR_EraseRootFromParent_Done,
     /*  261476 */   // Label 4982: @261476
     /*  261476 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(261539), // Rule ID 7790 //
     /*  261481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  261495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261537 */     GIR_RootConstrainSelectedInstOperands,
     /*  261538 */     // GIR_Coverage, 7790,
     /*  261538 */     GIR_EraseRootFromParent_Done,
     /*  261539 */   // Label 4983: @261539
     /*  261539 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(261602), // Rule ID 7791 //
     /*  261544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  261558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261583 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2),
     /*  261586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261600 */     GIR_RootConstrainSelectedInstOperands,
     /*  261601 */     // GIR_Coverage, 7791,
     /*  261601 */     GIR_EraseRootFromParent_Done,
     /*  261602 */   // Label 4984: @261602
     /*  261602 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(261665), // Rule ID 7794 //
     /*  261607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  261621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261646 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  261646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261663 */     GIR_RootConstrainSelectedInstOperands,
     /*  261664 */     // GIR_Coverage, 7794,
     /*  261664 */     GIR_EraseRootFromParent_Done,
     /*  261665 */   // Label 4985: @261665
     /*  261665 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(261728), // Rule ID 7795 //
     /*  261670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  261681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  261684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261709 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  261709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  261726 */     GIR_RootConstrainSelectedInstOperands,
     /*  261727 */     // GIR_Coverage, 7795,
     /*  261727 */     GIR_EraseRootFromParent_Done,
     /*  261728 */   // Label 4986: @261728
     /*  261728 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(261791), // Rule ID 7798 //
     /*  261733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  261747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  261772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261789 */     GIR_RootConstrainSelectedInstOperands,
     /*  261790 */     // GIR_Coverage, 7798,
     /*  261790 */     GIR_EraseRootFromParent_Done,
     /*  261791 */   // Label 4987: @261791
     /*  261791 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(261854), // Rule ID 7799 //
     /*  261796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  261807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  261810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261835 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  261835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  261852 */     GIR_RootConstrainSelectedInstOperands,
     /*  261853 */     // GIR_Coverage, 7799,
     /*  261853 */     GIR_EraseRootFromParent_Done,
     /*  261854 */   // Label 4988: @261854
     /*  261854 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(261917), // Rule ID 7802 //
     /*  261859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  261862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  261873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  261876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  261879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261898 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  261898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261915 */     GIR_RootConstrainSelectedInstOperands,
     /*  261916 */     // GIR_Coverage, 7802,
     /*  261916 */     GIR_EraseRootFromParent_Done,
     /*  261917 */   // Label 4989: @261917
     /*  261917 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(261980), // Rule ID 7803 //
     /*  261922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  261925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  261933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  261936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  261939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  261942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  261950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  261954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  261961 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  261961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  261964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  261966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  261968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  261970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  261975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  261978 */     GIR_RootConstrainSelectedInstOperands,
     /*  261979 */     // GIR_Coverage, 7803,
     /*  261979 */     GIR_EraseRootFromParent_Done,
     /*  261980 */   // Label 4990: @261980
     /*  261980 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(262043), // Rule ID 7806 //
     /*  261985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  261988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  261993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  261996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  261999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  262024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262041 */     GIR_RootConstrainSelectedInstOperands,
     /*  262042 */     // GIR_Coverage, 7806,
     /*  262042 */     GIR_EraseRootFromParent_Done,
     /*  262043 */   // Label 4991: @262043
     /*  262043 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(262106), // Rule ID 7807 //
     /*  262048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  262051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  262059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  262062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262087 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11375:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  262087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1),
     /*  262090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  262104 */     GIR_RootConstrainSelectedInstOperands,
     /*  262105 */     // GIR_Coverage, 7807,
     /*  262105 */     GIR_EraseRootFromParent_Done,
     /*  262106 */   // Label 4992: @262106
     /*  262106 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(262169), // Rule ID 7810 //
     /*  262111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262150 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262167 */     GIR_RootConstrainSelectedInstOperands,
     /*  262168 */     // GIR_Coverage, 7810,
     /*  262168 */     GIR_EraseRootFromParent_Done,
     /*  262169 */   // Label 4993: @262169
     /*  262169 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(262232), // Rule ID 7811 //
     /*  262174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  262188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262213 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262230 */     GIR_RootConstrainSelectedInstOperands,
     /*  262231 */     // GIR_Coverage, 7811,
     /*  262231 */     GIR_EraseRootFromParent_Done,
     /*  262232 */   // Label 4994: @262232
     /*  262232 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(262295), // Rule ID 7814 //
     /*  262237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262276 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262293 */     GIR_RootConstrainSelectedInstOperands,
     /*  262294 */     // GIR_Coverage, 7814,
     /*  262294 */     GIR_EraseRootFromParent_Done,
     /*  262295 */   // Label 4995: @262295
     /*  262295 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(262358), // Rule ID 7815 //
     /*  262300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  262314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262339 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262356 */     GIR_RootConstrainSelectedInstOperands,
     /*  262357 */     // GIR_Coverage, 7815,
     /*  262357 */     GIR_EraseRootFromParent_Done,
     /*  262358 */   // Label 4996: @262358
     /*  262358 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(262421), // Rule ID 7818 //
     /*  262363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262402 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  262402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262419 */     GIR_RootConstrainSelectedInstOperands,
     /*  262420 */     // GIR_Coverage, 7818,
     /*  262420 */     GIR_EraseRootFromParent_Done,
     /*  262421 */   // Label 4997: @262421
     /*  262421 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(262484), // Rule ID 7819 //
     /*  262426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  262437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  262440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262465 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  262465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262470 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  262482 */     GIR_RootConstrainSelectedInstOperands,
     /*  262483 */     // GIR_Coverage, 7819,
     /*  262483 */     GIR_EraseRootFromParent_Done,
     /*  262484 */   // Label 4998: @262484
     /*  262484 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(262547), // Rule ID 7822 //
     /*  262489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  262503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262528 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262545 */     GIR_RootConstrainSelectedInstOperands,
     /*  262546 */     // GIR_Coverage, 7822,
     /*  262546 */     GIR_EraseRootFromParent_Done,
     /*  262547 */   // Label 4999: @262547
     /*  262547 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(262610), // Rule ID 7823 //
     /*  262552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  262563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  262566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262591 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262608 */     GIR_RootConstrainSelectedInstOperands,
     /*  262609 */     // GIR_Coverage, 7823,
     /*  262609 */     GIR_EraseRootFromParent_Done,
     /*  262610 */   // Label 5000: @262610
     /*  262610 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(262673), // Rule ID 7826 //
     /*  262615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  262629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262654 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262671 */     GIR_RootConstrainSelectedInstOperands,
     /*  262672 */     // GIR_Coverage, 7826,
     /*  262672 */     GIR_EraseRootFromParent_Done,
     /*  262673 */   // Label 5001: @262673
     /*  262673 */   GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(262736), // Rule ID 7827 //
     /*  262678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  262689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  262692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  262706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  262720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262734 */     GIR_RootConstrainSelectedInstOperands,
     /*  262735 */     // GIR_Coverage, 7827,
     /*  262735 */     GIR_EraseRootFromParent_Done,
     /*  262736 */   // Label 5002: @262736
     /*  262736 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(262799), // Rule ID 7830 //
     /*  262741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  262755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262780 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  262780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262797 */     GIR_RootConstrainSelectedInstOperands,
     /*  262798 */     // GIR_Coverage, 7830,
     /*  262798 */     GIR_EraseRootFromParent_Done,
     /*  262799 */   // Label 5003: @262799
     /*  262799 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(262862), // Rule ID 7831 //
     /*  262804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  262815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  262818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  262832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262843 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  262843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  262846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  262860 */     GIR_RootConstrainSelectedInstOperands,
     /*  262861 */     // GIR_Coverage, 7831,
     /*  262861 */     GIR_EraseRootFromParent_Done,
     /*  262862 */   // Label 5004: @262862
     /*  262862 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(262925), // Rule ID 7834 //
     /*  262867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  262881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  262884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  262887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  262906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262923 */     GIR_RootConstrainSelectedInstOperands,
     /*  262924 */     // GIR_Coverage, 7834,
     /*  262924 */     GIR_EraseRootFromParent_Done,
     /*  262925 */   // Label 5005: @262925
     /*  262925 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(262988), // Rule ID 7835 //
     /*  262930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  262933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  262938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  262941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  262944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  262947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  262950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  262954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  262958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  262962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  262969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  262969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  262972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  262974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  262976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  262978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  262983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  262986 */     GIR_RootConstrainSelectedInstOperands,
     /*  262987 */     // GIR_Coverage, 7835,
     /*  262987 */     GIR_EraseRootFromParent_Done,
     /*  262988 */   // Label 5006: @262988
     /*  262988 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(263051), // Rule ID 7838 //
     /*  262993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  262996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263049 */     GIR_RootConstrainSelectedInstOperands,
     /*  263050 */     // GIR_Coverage, 7838,
     /*  263050 */     GIR_EraseRootFromParent_Done,
     /*  263051 */   // Label 5007: @263051
     /*  263051 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(263114), // Rule ID 7839 //
     /*  263056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  263070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263112 */     GIR_RootConstrainSelectedInstOperands,
     /*  263113 */     // GIR_Coverage, 7839,
     /*  263113 */     GIR_EraseRootFromParent_Done,
     /*  263114 */   // Label 5008: @263114
     /*  263114 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(263177), // Rule ID 7842 //
     /*  263119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  263158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263175 */     GIR_RootConstrainSelectedInstOperands,
     /*  263176 */     // GIR_Coverage, 7842,
     /*  263176 */     GIR_EraseRootFromParent_Done,
     /*  263177 */   // Label 5009: @263177
     /*  263177 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(263240), // Rule ID 7843 //
     /*  263182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  263193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  263196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263221 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  263221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  263238 */     GIR_RootConstrainSelectedInstOperands,
     /*  263239 */     // GIR_Coverage, 7843,
     /*  263239 */     GIR_EraseRootFromParent_Done,
     /*  263240 */   // Label 5010: @263240
     /*  263240 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(263303), // Rule ID 7846 //
     /*  263245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263301 */     GIR_RootConstrainSelectedInstOperands,
     /*  263302 */     // GIR_Coverage, 7846,
     /*  263302 */     GIR_EraseRootFromParent_Done,
     /*  263303 */   // Label 5011: @263303
     /*  263303 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(263366), // Rule ID 7847 //
     /*  263308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  263322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  263336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263347 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11375:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2),
     /*  263350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263364 */     GIR_RootConstrainSelectedInstOperands,
     /*  263365 */     // GIR_Coverage, 7847,
     /*  263365 */     GIR_EraseRootFromParent_Done,
     /*  263366 */   // Label 5012: @263366
     /*  263366 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(263429), // Rule ID 7850 //
     /*  263371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263410 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263427 */     GIR_RootConstrainSelectedInstOperands,
     /*  263428 */     // GIR_Coverage, 7850,
     /*  263428 */     GIR_EraseRootFromParent_Done,
     /*  263429 */   // Label 5013: @263429
     /*  263429 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(263492), // Rule ID 7851 //
     /*  263434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  263448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  263462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263473 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11375:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4),
     /*  263476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263490 */     GIR_RootConstrainSelectedInstOperands,
     /*  263491 */     // GIR_Coverage, 7851,
     /*  263491 */     GIR_EraseRootFromParent_Done,
     /*  263492 */   // Label 5014: @263492
     /*  263492 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(263555), // Rule ID 7854 //
     /*  263497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  263500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  263511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  263514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263536 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  263536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263553 */     GIR_RootConstrainSelectedInstOperands,
     /*  263554 */     // GIR_Coverage, 7854,
     /*  263554 */     GIR_EraseRootFromParent_Done,
     /*  263555 */   // Label 5015: @263555
     /*  263555 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(263618), // Rule ID 7855 //
     /*  263560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  263563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq),
     /*  263568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  263571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  263574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  263577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  263588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  263592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263599 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11375:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  263599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8),
     /*  263602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  263616 */     GIR_RootConstrainSelectedInstOperands,
     /*  263617 */     // GIR_Coverage, 7855,
     /*  263617 */     GIR_EraseRootFromParent_Done,
     /*  263618 */   // Label 5016: @263618
     /*  263618 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(263681), // Rule ID 7946 //
     /*  263623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  263637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  263640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  263665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263679 */     GIR_RootConstrainSelectedInstOperands,
     /*  263680 */     // GIR_Coverage, 7946,
     /*  263680 */     GIR_EraseRootFromParent_Done,
     /*  263681 */   // Label 5017: @263681
     /*  263681 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(263744), // Rule ID 7947 //
     /*  263686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  263697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  263700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  263703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263725 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /*  263728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263742 */     GIR_RootConstrainSelectedInstOperands,
     /*  263743 */     // GIR_Coverage, 7947,
     /*  263743 */     GIR_EraseRootFromParent_Done,
     /*  263744 */   // Label 5018: @263744
     /*  263744 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(263807), // Rule ID 7950 //
     /*  263749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  263763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  263766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263788 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  263791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263805 */     GIR_RootConstrainSelectedInstOperands,
     /*  263806 */     // GIR_Coverage, 7950,
     /*  263806 */     GIR_EraseRootFromParent_Done,
     /*  263807 */   // Label 5019: @263807
     /*  263807 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(263870), // Rule ID 7951 //
     /*  263812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  263823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  263826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  263829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263851 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  263854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263868 */     GIR_RootConstrainSelectedInstOperands,
     /*  263869 */     // GIR_Coverage, 7951,
     /*  263869 */     GIR_EraseRootFromParent_Done,
     /*  263870 */   // Label 5020: @263870
     /*  263870 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(263933), // Rule ID 7954 //
     /*  263875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  263878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  263889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  263892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  263895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263914 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  263914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  263917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263931 */     GIR_RootConstrainSelectedInstOperands,
     /*  263932 */     // GIR_Coverage, 7954,
     /*  263932 */     GIR_EraseRootFromParent_Done,
     /*  263933 */   // Label 5021: @263933
     /*  263933 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(263996), // Rule ID 7955 //
     /*  263938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  263941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  263946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  263949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  263952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  263955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  263958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  263970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  263977 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  263977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  263980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  263982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  263984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  263986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  263991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  263994 */     GIR_RootConstrainSelectedInstOperands,
     /*  263995 */     // GIR_Coverage, 7955,
     /*  263995 */     GIR_EraseRootFromParent_Done,
     /*  263996 */   // Label 5022: @263996
     /*  263996 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(264059), // Rule ID 7958 //
     /*  264001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264057 */     GIR_RootConstrainSelectedInstOperands,
     /*  264058 */     // GIR_Coverage, 7958,
     /*  264058 */     GIR_EraseRootFromParent_Done,
     /*  264059 */   // Label 5023: @264059
     /*  264059 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(264122), // Rule ID 7959 //
     /*  264064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  264078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  264081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /*  264106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264120 */     GIR_RootConstrainSelectedInstOperands,
     /*  264121 */     // GIR_Coverage, 7959,
     /*  264121 */     GIR_EraseRootFromParent_Done,
     /*  264122 */   // Label 5024: @264122
     /*  264122 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(264185), // Rule ID 7962 //
     /*  264127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264166 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264183 */     GIR_RootConstrainSelectedInstOperands,
     /*  264184 */     // GIR_Coverage, 7962,
     /*  264184 */     GIR_EraseRootFromParent_Done,
     /*  264185 */   // Label 5025: @264185
     /*  264185 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(264248), // Rule ID 7963 //
     /*  264190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  264204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  264207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264229 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264246 */     GIR_RootConstrainSelectedInstOperands,
     /*  264247 */     // GIR_Coverage, 7963,
     /*  264247 */     GIR_EraseRootFromParent_Done,
     /*  264248 */   // Label 5026: @264248
     /*  264248 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(264311), // Rule ID 7966 //
     /*  264253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264309 */     GIR_RootConstrainSelectedInstOperands,
     /*  264310 */     // GIR_Coverage, 7966,
     /*  264310 */     GIR_EraseRootFromParent_Done,
     /*  264311 */   // Label 5027: @264311
     /*  264311 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(264374), // Rule ID 7967 //
     /*  264316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  264330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  264333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264355 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /*  264358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264372 */     GIR_RootConstrainSelectedInstOperands,
     /*  264373 */     // GIR_Coverage, 7967,
     /*  264373 */     GIR_EraseRootFromParent_Done,
     /*  264374 */   // Label 5028: @264374
     /*  264374 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(264437), // Rule ID 7970 //
     /*  264379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264418 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264435 */     GIR_RootConstrainSelectedInstOperands,
     /*  264436 */     // GIR_Coverage, 7970,
     /*  264436 */     GIR_EraseRootFromParent_Done,
     /*  264437 */   // Label 5029: @264437
     /*  264437 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(264500), // Rule ID 7971 //
     /*  264442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  264453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  264456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  264459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264481 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264498 */     GIR_RootConstrainSelectedInstOperands,
     /*  264499 */     // GIR_Coverage, 7971,
     /*  264499 */     GIR_EraseRootFromParent_Done,
     /*  264500 */   // Label 5030: @264500
     /*  264500 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(264563), // Rule ID 7974 //
     /*  264505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  264519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  264522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  264544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264561 */     GIR_RootConstrainSelectedInstOperands,
     /*  264562 */     // GIR_Coverage, 7974,
     /*  264562 */     GIR_EraseRootFromParent_Done,
     /*  264563 */   // Label 5031: @264563
     /*  264563 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(264626), // Rule ID 7975 //
     /*  264568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  264579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  264582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  264585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  264607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  264624 */     GIR_RootConstrainSelectedInstOperands,
     /*  264625 */     // GIR_Coverage, 7975,
     /*  264625 */     GIR_EraseRootFromParent_Done,
     /*  264626 */   // Label 5032: @264626
     /*  264626 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(264689), // Rule ID 7978 //
     /*  264631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  264645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  264648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264670 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  264670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264687 */     GIR_RootConstrainSelectedInstOperands,
     /*  264688 */     // GIR_Coverage, 7978,
     /*  264688 */     GIR_EraseRootFromParent_Done,
     /*  264689 */   // Label 5033: @264689
     /*  264689 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(264752), // Rule ID 7979 //
     /*  264694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  264705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  264708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  264711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264733 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  264733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  264750 */     GIR_RootConstrainSelectedInstOperands,
     /*  264751 */     // GIR_Coverage, 7979,
     /*  264751 */     GIR_EraseRootFromParent_Done,
     /*  264752 */   // Label 5034: @264752
     /*  264752 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(264815), // Rule ID 7982 //
     /*  264757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  264760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  264771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  264774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  264796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264813 */     GIR_RootConstrainSelectedInstOperands,
     /*  264814 */     // GIR_Coverage, 7982,
     /*  264814 */     GIR_EraseRootFromParent_Done,
     /*  264815 */   // Label 5035: @264815
     /*  264815 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(264878), // Rule ID 7983 //
     /*  264820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  264823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  264831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  264834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  264837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264859 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  264859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /*  264862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  264876 */     GIR_RootConstrainSelectedInstOperands,
     /*  264877 */     // GIR_Coverage, 7983,
     /*  264877 */     GIR_EraseRootFromParent_Done,
     /*  264878 */   // Label 5036: @264878
     /*  264878 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(264941), // Rule ID 7986 //
     /*  264883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  264886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  264897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  264900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  264903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  264922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  264925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  264939 */     GIR_RootConstrainSelectedInstOperands,
     /*  264940 */     // GIR_Coverage, 7986,
     /*  264940 */     GIR_EraseRootFromParent_Done,
     /*  264941 */   // Label 5037: @264941
     /*  264941 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(265004), // Rule ID 7987 //
     /*  264946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  264949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  264954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  264957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  264960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  264963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  264966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  264970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  264978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  264985 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  264985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  264988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  264990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  264992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  264994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  264999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265002 */     GIR_RootConstrainSelectedInstOperands,
     /*  265003 */     // GIR_Coverage, 7987,
     /*  265003 */     GIR_EraseRootFromParent_Done,
     /*  265004 */   // Label 5038: @265004
     /*  265004 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(265067), // Rule ID 7990 //
     /*  265009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265065 */     GIR_RootConstrainSelectedInstOperands,
     /*  265066 */     // GIR_Coverage, 7990,
     /*  265066 */     GIR_EraseRootFromParent_Done,
     /*  265067 */   // Label 5039: @265067
     /*  265067 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(265130), // Rule ID 7991 //
     /*  265072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  265086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  265089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265128 */     GIR_RootConstrainSelectedInstOperands,
     /*  265129 */     // GIR_Coverage, 7991,
     /*  265129 */     GIR_EraseRootFromParent_Done,
     /*  265130 */   // Label 5040: @265130
     /*  265130 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(265193), // Rule ID 7994 //
     /*  265135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265174 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  265174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265191 */     GIR_RootConstrainSelectedInstOperands,
     /*  265192 */     // GIR_Coverage, 7994,
     /*  265192 */     GIR_EraseRootFromParent_Done,
     /*  265193 */   // Label 5041: @265193
     /*  265193 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(265256), // Rule ID 7995 //
     /*  265198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  265209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  265212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  265215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265237 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  265237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  265254 */     GIR_RootConstrainSelectedInstOperands,
     /*  265255 */     // GIR_Coverage, 7995,
     /*  265255 */     GIR_EraseRootFromParent_Done,
     /*  265256 */   // Label 5042: @265256
     /*  265256 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(265319), // Rule ID 7998 //
     /*  265261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265317 */     GIR_RootConstrainSelectedInstOperands,
     /*  265318 */     // GIR_Coverage, 7998,
     /*  265318 */     GIR_EraseRootFromParent_Done,
     /*  265319 */   // Label 5043: @265319
     /*  265319 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(265382), // Rule ID 7999 //
     /*  265324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  265338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  265341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265363 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265380 */     GIR_RootConstrainSelectedInstOperands,
     /*  265381 */     // GIR_Coverage, 7999,
     /*  265381 */     GIR_EraseRootFromParent_Done,
     /*  265382 */   // Label 5044: @265382
     /*  265382 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(265445), // Rule ID 8002 //
     /*  265387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265426 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265443 */     GIR_RootConstrainSelectedInstOperands,
     /*  265444 */     // GIR_Coverage, 8002,
     /*  265444 */     GIR_EraseRootFromParent_Done,
     /*  265445 */   // Label 5045: @265445
     /*  265445 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(265508), // Rule ID 8003 //
     /*  265450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  265464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  265467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265489 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265506 */     GIR_RootConstrainSelectedInstOperands,
     /*  265507 */     // GIR_Coverage, 8003,
     /*  265507 */     GIR_EraseRootFromParent_Done,
     /*  265508 */   // Label 5046: @265508
     /*  265508 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(265571), // Rule ID 8006 //
     /*  265513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  265527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  265530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265552 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  265552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265569 */     GIR_RootConstrainSelectedInstOperands,
     /*  265570 */     // GIR_Coverage, 8006,
     /*  265570 */     GIR_EraseRootFromParent_Done,
     /*  265571 */   // Label 5047: @265571
     /*  265571 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(265634), // Rule ID 8007 //
     /*  265576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  265587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  265590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  265593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265615 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  265615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  265632 */     GIR_RootConstrainSelectedInstOperands,
     /*  265633 */     // GIR_Coverage, 8007,
     /*  265633 */     GIR_EraseRootFromParent_Done,
     /*  265634 */   // Label 5048: @265634
     /*  265634 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(265697), // Rule ID 8010 //
     /*  265639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  265653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  265656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265678 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265695 */     GIR_RootConstrainSelectedInstOperands,
     /*  265696 */     // GIR_Coverage, 8010,
     /*  265696 */     GIR_EraseRootFromParent_Done,
     /*  265697 */   // Label 5049: @265697
     /*  265697 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(265760), // Rule ID 8011 //
     /*  265702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  265713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  265716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  265719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  265734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265741 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  265744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265758 */     GIR_RootConstrainSelectedInstOperands,
     /*  265759 */     // GIR_Coverage, 8011,
     /*  265759 */     GIR_EraseRootFromParent_Done,
     /*  265760 */   // Label 5050: @265760
     /*  265760 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(265823), // Rule ID 8014 //
     /*  265765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  265779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  265782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265821 */     GIR_RootConstrainSelectedInstOperands,
     /*  265822 */     // GIR_Coverage, 8014,
     /*  265822 */     GIR_EraseRootFromParent_Done,
     /*  265823 */   // Label 5051: @265823
     /*  265823 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(265886), // Rule ID 8015 //
     /*  265828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  265839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  265842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  265845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  265860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265867 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  265870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265884 */     GIR_RootConstrainSelectedInstOperands,
     /*  265885 */     // GIR_Coverage, 8015,
     /*  265885 */     GIR_EraseRootFromParent_Done,
     /*  265886 */   // Label 5052: @265886
     /*  265886 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(265949), // Rule ID 8018 //
     /*  265891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  265894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  265905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  265908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  265911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265930 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  265930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  265937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  265939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  265944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  265947 */     GIR_RootConstrainSelectedInstOperands,
     /*  265948 */     // GIR_Coverage, 8018,
     /*  265948 */     GIR_EraseRootFromParent_Done,
     /*  265949 */   // Label 5053: @265949
     /*  265949 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(266012), // Rule ID 8019 //
     /*  265954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  265957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  265962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  265965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  265968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  265971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  265974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  265978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  265986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  265993 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  265993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  265996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  265998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  266010 */     GIR_RootConstrainSelectedInstOperands,
     /*  266011 */     // GIR_Coverage, 8019,
     /*  266011 */     GIR_EraseRootFromParent_Done,
     /*  266012 */   // Label 5054: @266012
     /*  266012 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(266075), // Rule ID 8022 //
     /*  266017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266056 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266073 */     GIR_RootConstrainSelectedInstOperands,
     /*  266074 */     // GIR_Coverage, 8022,
     /*  266074 */     GIR_EraseRootFromParent_Done,
     /*  266075 */   // Label 5055: @266075
     /*  266075 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(266138), // Rule ID 8023 //
     /*  266080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  266094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  266097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  266112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266119 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /*  266122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266136 */     GIR_RootConstrainSelectedInstOperands,
     /*  266137 */     // GIR_Coverage, 8023,
     /*  266137 */     GIR_EraseRootFromParent_Done,
     /*  266138 */   // Label 5056: @266138
     /*  266138 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(266201), // Rule ID 8026 //
     /*  266143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266182 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266199 */     GIR_RootConstrainSelectedInstOperands,
     /*  266200 */     // GIR_Coverage, 8026,
     /*  266200 */     GIR_EraseRootFromParent_Done,
     /*  266201 */   // Label 5057: @266201
     /*  266201 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(266264), // Rule ID 8027 //
     /*  266206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  266220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  266223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  266238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266245 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /*  266248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266262 */     GIR_RootConstrainSelectedInstOperands,
     /*  266263 */     // GIR_Coverage, 8027,
     /*  266263 */     GIR_EraseRootFromParent_Done,
     /*  266264 */   // Label 5058: @266264
     /*  266264 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(266327), // Rule ID 8030 //
     /*  266269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  266272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  266308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266325 */     GIR_RootConstrainSelectedInstOperands,
     /*  266326 */     // GIR_Coverage, 8030,
     /*  266326 */     GIR_EraseRootFromParent_Done,
     /*  266327 */   // Label 5059: @266327
     /*  266327 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(266390), // Rule ID 8031 //
     /*  266332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  266335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  266343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  266346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  266349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  266364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266371 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  266371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /*  266374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  266388 */     GIR_RootConstrainSelectedInstOperands,
     /*  266389 */     // GIR_Coverage, 8031,
     /*  266389 */     GIR_EraseRootFromParent_Done,
     /*  266390 */   // Label 5060: @266390
     /*  266390 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(266453), // Rule ID 8034 //
     /*  266395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266434 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  266437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266451 */     GIR_RootConstrainSelectedInstOperands,
     /*  266452 */     // GIR_Coverage, 8034,
     /*  266452 */     GIR_EraseRootFromParent_Done,
     /*  266453 */   // Label 5061: @266453
     /*  266453 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(266516), // Rule ID 8035 //
     /*  266458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  266472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266497 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8),
     /*  266500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266514 */     GIR_RootConstrainSelectedInstOperands,
     /*  266515 */     // GIR_Coverage, 8035,
     /*  266515 */     GIR_EraseRootFromParent_Done,
     /*  266516 */   // Label 5062: @266516
     /*  266516 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(266579), // Rule ID 8038 //
     /*  266521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  266535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266560 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  266563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266577 */     GIR_RootConstrainSelectedInstOperands,
     /*  266578 */     // GIR_Coverage, 8038,
     /*  266578 */     GIR_EraseRootFromParent_Done,
     /*  266579 */   // Label 5063: @266579
     /*  266579 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(266642), // Rule ID 8039 //
     /*  266584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  266598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266623 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  266626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266640 */     GIR_RootConstrainSelectedInstOperands,
     /*  266641 */     // GIR_Coverage, 8039,
     /*  266641 */     GIR_EraseRootFromParent_Done,
     /*  266642 */   // Label 5064: @266642
     /*  266642 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(266705), // Rule ID 8042 //
     /*  266647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  266661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266686 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  266686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  266689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266703 */     GIR_RootConstrainSelectedInstOperands,
     /*  266704 */     // GIR_Coverage, 8042,
     /*  266704 */     GIR_EraseRootFromParent_Done,
     /*  266705 */   // Label 5065: @266705
     /*  266705 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(266768), // Rule ID 8043 //
     /*  266710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  266721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  266724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266749 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  266749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  266752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  266766 */     GIR_RootConstrainSelectedInstOperands,
     /*  266767 */     // GIR_Coverage, 8043,
     /*  266767 */     GIR_EraseRootFromParent_Done,
     /*  266768 */   // Label 5066: @266768
     /*  266768 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(266831), // Rule ID 8046 //
     /*  266773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  266787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  266815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266829 */     GIR_RootConstrainSelectedInstOperands,
     /*  266830 */     // GIR_Coverage, 8046,
     /*  266830 */     GIR_EraseRootFromParent_Done,
     /*  266831 */   // Label 5067: @266831
     /*  266831 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(266894), // Rule ID 8047 //
     /*  266836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  266847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  266850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  266875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4),
     /*  266878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266892 */     GIR_RootConstrainSelectedInstOperands,
     /*  266893 */     // GIR_Coverage, 8047,
     /*  266893 */     GIR_EraseRootFromParent_Done,
     /*  266894 */   // Label 5068: @266894
     /*  266894 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(266957), // Rule ID 8050 //
     /*  266899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  266902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  266913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  266916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  266919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  266938 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  266938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  266941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  266943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  266945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  266947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  266952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  266955 */     GIR_RootConstrainSelectedInstOperands,
     /*  266956 */     // GIR_Coverage, 8050,
     /*  266956 */     GIR_EraseRootFromParent_Done,
     /*  266957 */   // Label 5069: @266957
     /*  266957 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(267020), // Rule ID 8051 //
     /*  266962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  266965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  266970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  266973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  266976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  266979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  266982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  266990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  266994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267018 */     GIR_RootConstrainSelectedInstOperands,
     /*  267019 */     // GIR_Coverage, 8051,
     /*  267019 */     GIR_EraseRootFromParent_Done,
     /*  267020 */   // Label 5070: @267020
     /*  267020 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(267083), // Rule ID 8054 //
     /*  267025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267081 */     GIR_RootConstrainSelectedInstOperands,
     /*  267082 */     // GIR_Coverage, 8054,
     /*  267082 */     GIR_EraseRootFromParent_Done,
     /*  267083 */   // Label 5071: @267083
     /*  267083 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(267146), // Rule ID 8055 //
     /*  267088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  267102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267127 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2),
     /*  267130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267144 */     GIR_RootConstrainSelectedInstOperands,
     /*  267145 */     // GIR_Coverage, 8055,
     /*  267145 */     GIR_EraseRootFromParent_Done,
     /*  267146 */   // Label 5072: @267146
     /*  267146 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(267209), // Rule ID 8058 //
     /*  267151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267207 */     GIR_RootConstrainSelectedInstOperands,
     /*  267208 */     // GIR_Coverage, 8058,
     /*  267208 */     GIR_EraseRootFromParent_Done,
     /*  267209 */   // Label 5073: @267209
     /*  267209 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(267272), // Rule ID 8059 //
     /*  267214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  267225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  267228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267253 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267270 */     GIR_RootConstrainSelectedInstOperands,
     /*  267271 */     // GIR_Coverage, 8059,
     /*  267271 */     GIR_EraseRootFromParent_Done,
     /*  267272 */   // Label 5074: @267272
     /*  267272 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(267335), // Rule ID 8062 //
     /*  267277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  267316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267333 */     GIR_RootConstrainSelectedInstOperands,
     /*  267334 */     // GIR_Coverage, 8062,
     /*  267334 */     GIR_EraseRootFromParent_Done,
     /*  267335 */   // Label 5075: @267335
     /*  267335 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(267398), // Rule ID 8063 //
     /*  267340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  267351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  267354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267379 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  267379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  267396 */     GIR_RootConstrainSelectedInstOperands,
     /*  267397 */     // GIR_Coverage, 8063,
     /*  267397 */     GIR_EraseRootFromParent_Done,
     /*  267398 */   // Label 5076: @267398
     /*  267398 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(267461), // Rule ID 8066 //
     /*  267403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  267417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  267442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267459 */     GIR_RootConstrainSelectedInstOperands,
     /*  267460 */     // GIR_Coverage, 8066,
     /*  267460 */     GIR_EraseRootFromParent_Done,
     /*  267461 */   // Label 5077: @267461
     /*  267461 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(267524), // Rule ID 8067 //
     /*  267466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  267477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  267480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267505 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  267505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  267522 */     GIR_RootConstrainSelectedInstOperands,
     /*  267523 */     // GIR_Coverage, 8067,
     /*  267523 */     GIR_EraseRootFromParent_Done,
     /*  267524 */   // Label 5078: @267524
     /*  267524 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(267587), // Rule ID 8070 //
     /*  267529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  267532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  267543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  267568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267585 */     GIR_RootConstrainSelectedInstOperands,
     /*  267586 */     // GIR_Coverage, 8070,
     /*  267586 */     GIR_EraseRootFromParent_Done,
     /*  267587 */   // Label 5079: @267587
     /*  267587 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(267650), // Rule ID 8071 //
     /*  267592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  267595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  267603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  267606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267631 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11396:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  267631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1),
     /*  267634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  267648 */     GIR_RootConstrainSelectedInstOperands,
     /*  267649 */     // GIR_Coverage, 8071,
     /*  267649 */     GIR_EraseRootFromParent_Done,
     /*  267650 */   // Label 5080: @267650
     /*  267650 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(267713), // Rule ID 8074 //
     /*  267655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  267669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267694 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  267697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267711 */     GIR_RootConstrainSelectedInstOperands,
     /*  267712 */     // GIR_Coverage, 8074,
     /*  267712 */     GIR_EraseRootFromParent_Done,
     /*  267713 */   // Label 5081: @267713
     /*  267713 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(267776), // Rule ID 8075 //
     /*  267718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  267729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  267732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  267746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267757 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  267760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267774 */     GIR_RootConstrainSelectedInstOperands,
     /*  267775 */     // GIR_Coverage, 8075,
     /*  267775 */     GIR_EraseRootFromParent_Done,
     /*  267776 */   // Label 5082: @267776
     /*  267776 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(267839), // Rule ID 8078 //
     /*  267781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  267795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267820 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  267823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267837 */     GIR_RootConstrainSelectedInstOperands,
     /*  267838 */     // GIR_Coverage, 8078,
     /*  267838 */     GIR_EraseRootFromParent_Done,
     /*  267839 */   // Label 5083: @267839
     /*  267839 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(267902), // Rule ID 8079 //
     /*  267844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  267855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  267858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  267872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267883 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  267883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  267886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267900 */     GIR_RootConstrainSelectedInstOperands,
     /*  267901 */     // GIR_Coverage, 8079,
     /*  267901 */     GIR_EraseRootFromParent_Done,
     /*  267902 */   // Label 5084: @267902
     /*  267902 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(267965), // Rule ID 8082 //
     /*  267907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  267910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  267918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  267921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  267924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  267927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  267939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  267946 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  267946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  267949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  267951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  267953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  267955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  267960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  267963 */     GIR_RootConstrainSelectedInstOperands,
     /*  267964 */     // GIR_Coverage, 8082,
     /*  267964 */     GIR_EraseRootFromParent_Done,
     /*  267965 */   // Label 5085: @267965
     /*  267965 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(268028), // Rule ID 8083 //
     /*  267970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  267973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  267978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  267981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  267984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  267987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  267990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  267994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  267998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268009 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  268009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  268026 */     GIR_RootConstrainSelectedInstOperands,
     /*  268027 */     // GIR_Coverage, 8083,
     /*  268027 */     GIR_EraseRootFromParent_Done,
     /*  268028 */   // Label 5086: @268028
     /*  268028 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(268091), // Rule ID 8086 //
     /*  268033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268089 */     GIR_RootConstrainSelectedInstOperands,
     /*  268090 */     // GIR_Coverage, 8086,
     /*  268090 */     GIR_EraseRootFromParent_Done,
     /*  268091 */   // Label 5087: @268091
     /*  268091 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(268154), // Rule ID 8087 //
     /*  268096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  268110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268135 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268152 */     GIR_RootConstrainSelectedInstOperands,
     /*  268153 */     // GIR_Coverage, 8087,
     /*  268153 */     GIR_EraseRootFromParent_Done,
     /*  268154 */   // Label 5088: @268154
     /*  268154 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(268217), // Rule ID 8090 //
     /*  268159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268198 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268215 */     GIR_RootConstrainSelectedInstOperands,
     /*  268216 */     // GIR_Coverage, 8090,
     /*  268216 */     GIR_EraseRootFromParent_Done,
     /*  268217 */   // Label 5089: @268217
     /*  268217 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(268280), // Rule ID 8091 //
     /*  268222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  268236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268261 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268278 */     GIR_RootConstrainSelectedInstOperands,
     /*  268279 */     // GIR_Coverage, 8091,
     /*  268279 */     GIR_EraseRootFromParent_Done,
     /*  268280 */   // Label 5090: @268280
     /*  268280 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(268343), // Rule ID 8094 //
     /*  268285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268324 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  268324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268341 */     GIR_RootConstrainSelectedInstOperands,
     /*  268342 */     // GIR_Coverage, 8094,
     /*  268342 */     GIR_EraseRootFromParent_Done,
     /*  268343 */   // Label 5091: @268343
     /*  268343 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(268406), // Rule ID 8095 //
     /*  268348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  268359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  268362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268387 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  268387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  268404 */     GIR_RootConstrainSelectedInstOperands,
     /*  268405 */     // GIR_Coverage, 8095,
     /*  268405 */     GIR_EraseRootFromParent_Done,
     /*  268406 */   // Label 5092: @268406
     /*  268406 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(268469), // Rule ID 8098 //
     /*  268411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  268425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268450 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268467 */     GIR_RootConstrainSelectedInstOperands,
     /*  268468 */     // GIR_Coverage, 8098,
     /*  268468 */     GIR_EraseRootFromParent_Done,
     /*  268469 */   // Label 5093: @268469
     /*  268469 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(268532), // Rule ID 8099 //
     /*  268474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  268488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268513 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268530 */     GIR_RootConstrainSelectedInstOperands,
     /*  268531 */     // GIR_Coverage, 8099,
     /*  268531 */     GIR_EraseRootFromParent_Done,
     /*  268532 */   // Label 5094: @268532
     /*  268532 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(268595), // Rule ID 8102 //
     /*  268537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  268551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268576 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268593 */     GIR_RootConstrainSelectedInstOperands,
     /*  268594 */     // GIR_Coverage, 8102,
     /*  268594 */     GIR_EraseRootFromParent_Done,
     /*  268595 */   // Label 5095: @268595
     /*  268595 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(268658), // Rule ID 8103 //
     /*  268600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  268611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  268614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268639 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268656 */     GIR_RootConstrainSelectedInstOperands,
     /*  268657 */     // GIR_Coverage, 8103,
     /*  268657 */     GIR_EraseRootFromParent_Done,
     /*  268658 */   // Label 5096: @268658
     /*  268658 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(268721), // Rule ID 8106 //
     /*  268663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  268666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  268677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  268702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268719 */     GIR_RootConstrainSelectedInstOperands,
     /*  268720 */     // GIR_Coverage, 8106,
     /*  268720 */     GIR_EraseRootFromParent_Done,
     /*  268721 */   // Label 5097: @268721
     /*  268721 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(268784), // Rule ID 8107 //
     /*  268726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  268729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  268737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  268740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  268754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268765 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  268765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  268768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  268782 */     GIR_RootConstrainSelectedInstOperands,
     /*  268783 */     // GIR_Coverage, 8107,
     /*  268783 */     GIR_EraseRootFromParent_Done,
     /*  268784 */   // Label 5098: @268784
     /*  268784 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(268847), // Rule ID 8110 //
     /*  268789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  268803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268828 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268845 */     GIR_RootConstrainSelectedInstOperands,
     /*  268846 */     // GIR_Coverage, 8110,
     /*  268846 */     GIR_EraseRootFromParent_Done,
     /*  268847 */   // Label 5099: @268847
     /*  268847 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(268910), // Rule ID 8111 //
     /*  268852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  268863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  268866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  268880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268891 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11396:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  268891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2),
     /*  268894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268908 */     GIR_RootConstrainSelectedInstOperands,
     /*  268909 */     // GIR_Coverage, 8111,
     /*  268909 */     GIR_EraseRootFromParent_Done,
     /*  268910 */   // Label 5100: @268910
     /*  268910 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(268973), // Rule ID 8114 //
     /*  268915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  268918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  268929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  268932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  268935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  268939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  268943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  268947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  268954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  268954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  268957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  268959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  268961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  268963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  268968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  268971 */     GIR_RootConstrainSelectedInstOperands,
     /*  268972 */     // GIR_Coverage, 8114,
     /*  268972 */     GIR_EraseRootFromParent_Done,
     /*  268973 */   // Label 5101: @268973
     /*  268973 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(269036), // Rule ID 8115 //
     /*  268978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  268981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  268986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  268989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  268992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  268995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  268998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  269006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269017 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11396:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4),
     /*  269020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269034 */     GIR_RootConstrainSelectedInstOperands,
     /*  269035 */     // GIR_Coverage, 8115,
     /*  269035 */     GIR_EraseRootFromParent_Done,
     /*  269036 */   // Label 5102: @269036
     /*  269036 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(269099), // Rule ID 8118 //
     /*  269041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  269044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  269058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  269080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269097 */     GIR_RootConstrainSelectedInstOperands,
     /*  269098 */     // GIR_Coverage, 8118,
     /*  269098 */     GIR_EraseRootFromParent_Done,
     /*  269099 */   // Label 5103: @269099
     /*  269099 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(269162), // Rule ID 8119 //
     /*  269104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  269107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne),
     /*  269112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  269118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  269121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  269132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  269136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269143 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11396:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  269143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8),
     /*  269146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  269160 */     GIR_RootConstrainSelectedInstOperands,
     /*  269161 */     // GIR_Coverage, 8119,
     /*  269161 */     GIR_EraseRootFromParent_Done,
     /*  269162 */   // Label 5104: @269162
     /*  269162 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(269225), // Rule ID 8210 //
     /*  269167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269206 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269223 */     GIR_RootConstrainSelectedInstOperands,
     /*  269224 */     // GIR_Coverage, 8210,
     /*  269224 */     GIR_EraseRootFromParent_Done,
     /*  269225 */   // Label 5105: @269225
     /*  269225 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(269288), // Rule ID 8211 //
     /*  269230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  269244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  269247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269269 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /*  269272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269286 */     GIR_RootConstrainSelectedInstOperands,
     /*  269287 */     // GIR_Coverage, 8211,
     /*  269287 */     GIR_EraseRootFromParent_Done,
     /*  269288 */   // Label 5106: @269288
     /*  269288 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(269351), // Rule ID 8214 //
     /*  269293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269332 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269349 */     GIR_RootConstrainSelectedInstOperands,
     /*  269350 */     // GIR_Coverage, 8214,
     /*  269350 */     GIR_EraseRootFromParent_Done,
     /*  269351 */   // Label 5107: @269351
     /*  269351 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(269414), // Rule ID 8215 //
     /*  269356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  269370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  269373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269395 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269412 */     GIR_RootConstrainSelectedInstOperands,
     /*  269413 */     // GIR_Coverage, 8215,
     /*  269413 */     GIR_EraseRootFromParent_Done,
     /*  269414 */   // Label 5108: @269414
     /*  269414 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(269477), // Rule ID 8218 //
     /*  269419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  269433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  269436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269458 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269475 */     GIR_RootConstrainSelectedInstOperands,
     /*  269476 */     // GIR_Coverage, 8218,
     /*  269476 */     GIR_EraseRootFromParent_Done,
     /*  269477 */   // Label 5109: @269477
     /*  269477 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(269540), // Rule ID 8219 //
     /*  269482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  269493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  269496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  269499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269521 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  269521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269538 */     GIR_RootConstrainSelectedInstOperands,
     /*  269539 */     // GIR_Coverage, 8219,
     /*  269539 */     GIR_EraseRootFromParent_Done,
     /*  269540 */   // Label 5110: @269540
     /*  269540 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(269603), // Rule ID 8222 //
     /*  269545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  269559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  269562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269584 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269601 */     GIR_RootConstrainSelectedInstOperands,
     /*  269602 */     // GIR_Coverage, 8222,
     /*  269602 */     GIR_EraseRootFromParent_Done,
     /*  269603 */   // Label 5111: @269603
     /*  269603 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(269666), // Rule ID 8223 //
     /*  269608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  269622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  269625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269647 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  269650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269664 */     GIR_RootConstrainSelectedInstOperands,
     /*  269665 */     // GIR_Coverage, 8223,
     /*  269665 */     GIR_EraseRootFromParent_Done,
     /*  269666 */   // Label 5112: @269666
     /*  269666 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(269729), // Rule ID 8226 //
     /*  269671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  269685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  269688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269710 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  269710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269727 */     GIR_RootConstrainSelectedInstOperands,
     /*  269728 */     // GIR_Coverage, 8226,
     /*  269728 */     GIR_EraseRootFromParent_Done,
     /*  269729 */   // Label 5113: @269729
     /*  269729 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(269792), // Rule ID 8227 //
     /*  269734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  269745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  269748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  269751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269773 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  269773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  269790 */     GIR_RootConstrainSelectedInstOperands,
     /*  269791 */     // GIR_Coverage, 8227,
     /*  269791 */     GIR_EraseRootFromParent_Done,
     /*  269792 */   // Label 5114: @269792
     /*  269792 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(269855), // Rule ID 8230 //
     /*  269797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  269811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  269814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269836 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  269836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269853 */     GIR_RootConstrainSelectedInstOperands,
     /*  269854 */     // GIR_Coverage, 8230,
     /*  269854 */     GIR_EraseRootFromParent_Done,
     /*  269855 */   // Label 5115: @269855
     /*  269855 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(269918), // Rule ID 8231 //
     /*  269860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  269871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  269874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  269877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  269880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269899 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  269899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  269902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  269916 */     GIR_RootConstrainSelectedInstOperands,
     /*  269917 */     // GIR_Coverage, 8231,
     /*  269917 */     GIR_EraseRootFromParent_Done,
     /*  269918 */   // Label 5116: @269918
     /*  269918 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(269981), // Rule ID 8234 //
     /*  269923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  269926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  269937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  269940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  269943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  269955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  269962 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  269962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  269965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  269967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  269969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  269971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  269976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  269979 */     GIR_RootConstrainSelectedInstOperands,
     /*  269980 */     // GIR_Coverage, 8234,
     /*  269980 */     GIR_EraseRootFromParent_Done,
     /*  269981 */   // Label 5117: @269981
     /*  269981 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(270044), // Rule ID 8235 //
     /*  269986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  269989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  269994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  269997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  270000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  270003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270025 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270042 */     GIR_RootConstrainSelectedInstOperands,
     /*  270043 */     // GIR_Coverage, 8235,
     /*  270043 */     GIR_EraseRootFromParent_Done,
     /*  270044 */   // Label 5118: @270044
     /*  270044 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(270107), // Rule ID 8238 //
     /*  270049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270105 */     GIR_RootConstrainSelectedInstOperands,
     /*  270106 */     // GIR_Coverage, 8238,
     /*  270106 */     GIR_EraseRootFromParent_Done,
     /*  270107 */   // Label 5119: @270107
     /*  270107 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(270170), // Rule ID 8239 //
     /*  270112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  270123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  270126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  270129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270151 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270168 */     GIR_RootConstrainSelectedInstOperands,
     /*  270169 */     // GIR_Coverage, 8239,
     /*  270169 */     GIR_EraseRootFromParent_Done,
     /*  270170 */   // Label 5120: @270170
     /*  270170 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(270233), // Rule ID 8242 //
     /*  270175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270214 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  270214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270231 */     GIR_RootConstrainSelectedInstOperands,
     /*  270232 */     // GIR_Coverage, 8242,
     /*  270232 */     GIR_EraseRootFromParent_Done,
     /*  270233 */   // Label 5121: @270233
     /*  270233 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(270296), // Rule ID 8243 //
     /*  270238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  270249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  270252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  270255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270277 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  270277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  270294 */     GIR_RootConstrainSelectedInstOperands,
     /*  270295 */     // GIR_Coverage, 8243,
     /*  270295 */     GIR_EraseRootFromParent_Done,
     /*  270296 */   // Label 5122: @270296
     /*  270296 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(270359), // Rule ID 8246 //
     /*  270301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  270304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270340 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  270340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270357 */     GIR_RootConstrainSelectedInstOperands,
     /*  270358 */     // GIR_Coverage, 8246,
     /*  270358 */     GIR_EraseRootFromParent_Done,
     /*  270359 */   // Label 5123: @270359
     /*  270359 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(270422), // Rule ID 8247 //
     /*  270364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  270367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  270375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  270378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  270381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270403 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  270403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  270406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  270420 */     GIR_RootConstrainSelectedInstOperands,
     /*  270421 */     // GIR_Coverage, 8247,
     /*  270421 */     GIR_EraseRootFromParent_Done,
     /*  270422 */   // Label 5124: @270422
     /*  270422 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(270485), // Rule ID 8250 //
     /*  270427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  270441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  270444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270466 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270483 */     GIR_RootConstrainSelectedInstOperands,
     /*  270484 */     // GIR_Coverage, 8250,
     /*  270484 */     GIR_EraseRootFromParent_Done,
     /*  270485 */   // Label 5125: @270485
     /*  270485 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(270548), // Rule ID 8251 //
     /*  270490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  270504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  270507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270529 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270546 */     GIR_RootConstrainSelectedInstOperands,
     /*  270547 */     // GIR_Coverage, 8251,
     /*  270547 */     GIR_EraseRootFromParent_Done,
     /*  270548 */   // Label 5126: @270548
     /*  270548 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(270611), // Rule ID 8254 //
     /*  270553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  270564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  270567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  270570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270592 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  270595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270609 */     GIR_RootConstrainSelectedInstOperands,
     /*  270610 */     // GIR_Coverage, 8254,
     /*  270610 */     GIR_EraseRootFromParent_Done,
     /*  270611 */   // Label 5127: @270611
     /*  270611 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(270674), // Rule ID 8255 //
     /*  270616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  270627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  270630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  270633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270655 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  270658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270672 */     GIR_RootConstrainSelectedInstOperands,
     /*  270673 */     // GIR_Coverage, 8255,
     /*  270673 */     GIR_EraseRootFromParent_Done,
     /*  270674 */   // Label 5128: @270674
     /*  270674 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(270737), // Rule ID 8258 //
     /*  270679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  270690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  270693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  270696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270718 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  270718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  270721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270735 */     GIR_RootConstrainSelectedInstOperands,
     /*  270736 */     // GIR_Coverage, 8258,
     /*  270736 */     GIR_EraseRootFromParent_Done,
     /*  270737 */   // Label 5129: @270737
     /*  270737 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(270800), // Rule ID 8259 //
     /*  270742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  270753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  270756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  270759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  270774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270781 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  270781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  270784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  270798 */     GIR_RootConstrainSelectedInstOperands,
     /*  270799 */     // GIR_Coverage, 8259,
     /*  270799 */     GIR_EraseRootFromParent_Done,
     /*  270800 */   // Label 5130: @270800
     /*  270800 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(270863), // Rule ID 8262 //
     /*  270805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  270819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  270822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270844 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270861 */     GIR_RootConstrainSelectedInstOperands,
     /*  270862 */     // GIR_Coverage, 8262,
     /*  270862 */     GIR_EraseRootFromParent_Done,
     /*  270863 */   // Label 5131: @270863
     /*  270863 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(270926), // Rule ID 8263 //
     /*  270868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  270879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  270882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  270885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  270888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  270900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270907 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  270907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  270910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270924 */     GIR_RootConstrainSelectedInstOperands,
     /*  270925 */     // GIR_Coverage, 8263,
     /*  270925 */     GIR_EraseRootFromParent_Done,
     /*  270926 */   // Label 5132: @270926
     /*  270926 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(270989), // Rule ID 8266 //
     /*  270931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  270934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  270939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  270942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  270945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  270948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  270951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  270955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  270963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  270970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  270970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  270973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  270975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  270977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  270979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  270984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  270987 */     GIR_RootConstrainSelectedInstOperands,
     /*  270988 */     // GIR_Coverage, 8266,
     /*  270988 */     GIR_EraseRootFromParent_Done,
     /*  270989 */   // Label 5133: @270989
     /*  270989 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(271052), // Rule ID 8267 //
     /*  270994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  270997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  271008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  271011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271050 */     GIR_RootConstrainSelectedInstOperands,
     /*  271051 */     // GIR_Coverage, 8267,
     /*  271051 */     GIR_EraseRootFromParent_Done,
     /*  271052 */   // Label 5134: @271052
     /*  271052 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(271115), // Rule ID 8270 //
     /*  271057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  271096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271113 */     GIR_RootConstrainSelectedInstOperands,
     /*  271114 */     // GIR_Coverage, 8270,
     /*  271114 */     GIR_EraseRootFromParent_Done,
     /*  271115 */   // Label 5135: @271115
     /*  271115 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(271178), // Rule ID 8271 //
     /*  271120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  271131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  271134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  271137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271159 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  271159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  271176 */     GIR_RootConstrainSelectedInstOperands,
     /*  271177 */     // GIR_Coverage, 8271,
     /*  271177 */     GIR_EraseRootFromParent_Done,
     /*  271178 */   // Label 5136: @271178
     /*  271178 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(271241), // Rule ID 8274 //
     /*  271183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271222 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271239 */     GIR_RootConstrainSelectedInstOperands,
     /*  271240 */     // GIR_Coverage, 8274,
     /*  271240 */     GIR_EraseRootFromParent_Done,
     /*  271241 */   // Label 5137: @271241
     /*  271241 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(271304), // Rule ID 8275 //
     /*  271246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  271260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  271263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271285 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271302 */     GIR_RootConstrainSelectedInstOperands,
     /*  271303 */     // GIR_Coverage, 8275,
     /*  271303 */     GIR_EraseRootFromParent_Done,
     /*  271304 */   // Label 5138: @271304
     /*  271304 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(271367), // Rule ID 8278 //
     /*  271309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271365 */     GIR_RootConstrainSelectedInstOperands,
     /*  271366 */     // GIR_Coverage, 8278,
     /*  271366 */     GIR_EraseRootFromParent_Done,
     /*  271367 */   // Label 5139: @271367
     /*  271367 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(271430), // Rule ID 8279 //
     /*  271372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  271386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  271389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271411 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271428 */     GIR_RootConstrainSelectedInstOperands,
     /*  271429 */     // GIR_Coverage, 8279,
     /*  271429 */     GIR_EraseRootFromParent_Done,
     /*  271430 */   // Label 5140: @271430
     /*  271430 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(271493), // Rule ID 8282 //
     /*  271435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  271449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  271452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271474 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  271474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271491 */     GIR_RootConstrainSelectedInstOperands,
     /*  271492 */     // GIR_Coverage, 8282,
     /*  271492 */     GIR_EraseRootFromParent_Done,
     /*  271493 */   // Label 5141: @271493
     /*  271493 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(271556), // Rule ID 8283 //
     /*  271498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  271501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  271509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  271512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  271515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271537 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  271537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  271554 */     GIR_RootConstrainSelectedInstOperands,
     /*  271555 */     // GIR_Coverage, 8283,
     /*  271555 */     GIR_EraseRootFromParent_Done,
     /*  271556 */   // Label 5142: @271556
     /*  271556 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(271619), // Rule ID 8286 //
     /*  271561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  271575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  271578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271617 */     GIR_RootConstrainSelectedInstOperands,
     /*  271618 */     // GIR_Coverage, 8286,
     /*  271618 */     GIR_EraseRootFromParent_Done,
     /*  271619 */   // Label 5143: @271619
     /*  271619 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(271682), // Rule ID 8287 //
     /*  271624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  271635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  271638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  271641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  271656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271663 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  271666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271680 */     GIR_RootConstrainSelectedInstOperands,
     /*  271681 */     // GIR_Coverage, 8287,
     /*  271681 */     GIR_EraseRootFromParent_Done,
     /*  271682 */   // Label 5144: @271682
     /*  271682 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(271745), // Rule ID 8290 //
     /*  271687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  271701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  271704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271726 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271743 */     GIR_RootConstrainSelectedInstOperands,
     /*  271744 */     // GIR_Coverage, 8290,
     /*  271744 */     GIR_EraseRootFromParent_Done,
     /*  271745 */   // Label 5145: @271745
     /*  271745 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(271808), // Rule ID 8291 //
     /*  271750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  271761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  271764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  271767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  271782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271789 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  271792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271806 */     GIR_RootConstrainSelectedInstOperands,
     /*  271807 */     // GIR_Coverage, 8291,
     /*  271807 */     GIR_EraseRootFromParent_Done,
     /*  271808 */   // Label 5146: @271808
     /*  271808 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(271871), // Rule ID 8294 //
     /*  271813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  271816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  271827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  271830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  271852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271869 */     GIR_RootConstrainSelectedInstOperands,
     /*  271870 */     // GIR_Coverage, 8294,
     /*  271870 */     GIR_EraseRootFromParent_Done,
     /*  271871 */   // Label 5147: @271871
     /*  271871 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(271934), // Rule ID 8295 //
     /*  271876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  271879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  271887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  271890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  271893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  271896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  271908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271915 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  271915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  271918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  271932 */     GIR_RootConstrainSelectedInstOperands,
     /*  271933 */     // GIR_Coverage, 8295,
     /*  271933 */     GIR_EraseRootFromParent_Done,
     /*  271934 */   // Label 5148: @271934
     /*  271934 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(271997), // Rule ID 8298 //
     /*  271939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  271942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  271947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  271950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  271953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  271956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  271959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  271967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  271971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  271978 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  271978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  271981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  271983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  271985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  271987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  271992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  271995 */     GIR_RootConstrainSelectedInstOperands,
     /*  271996 */     // GIR_Coverage, 8298,
     /*  271996 */     GIR_EraseRootFromParent_Done,
     /*  271997 */   // Label 5149: @271997
     /*  271997 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(272060), // Rule ID 8299 //
     /*  272002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  272016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272041 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8),
     /*  272044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272058 */     GIR_RootConstrainSelectedInstOperands,
     /*  272059 */     // GIR_Coverage, 8299,
     /*  272059 */     GIR_EraseRootFromParent_Done,
     /*  272060 */   // Label 5150: @272060
     /*  272060 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(272123), // Rule ID 8302 //
     /*  272065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272121 */     GIR_RootConstrainSelectedInstOperands,
     /*  272122 */     // GIR_Coverage, 8302,
     /*  272122 */     GIR_EraseRootFromParent_Done,
     /*  272123 */   // Label 5151: @272123
     /*  272123 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(272186), // Rule ID 8303 //
     /*  272128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  272142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272167 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272184 */     GIR_RootConstrainSelectedInstOperands,
     /*  272185 */     // GIR_Coverage, 8303,
     /*  272185 */     GIR_EraseRootFromParent_Done,
     /*  272186 */   // Label 5152: @272186
     /*  272186 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(272249), // Rule ID 8306 //
     /*  272191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272230 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272247 */     GIR_RootConstrainSelectedInstOperands,
     /*  272248 */     // GIR_Coverage, 8306,
     /*  272248 */     GIR_EraseRootFromParent_Done,
     /*  272249 */   // Label 5153: @272249
     /*  272249 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(272312), // Rule ID 8307 //
     /*  272254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  272268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272293 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272310 */     GIR_RootConstrainSelectedInstOperands,
     /*  272311 */     // GIR_Coverage, 8307,
     /*  272311 */     GIR_EraseRootFromParent_Done,
     /*  272312 */   // Label 5154: @272312
     /*  272312 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(272375), // Rule ID 8310 //
     /*  272317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272356 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272373 */     GIR_RootConstrainSelectedInstOperands,
     /*  272374 */     // GIR_Coverage, 8310,
     /*  272374 */     GIR_EraseRootFromParent_Done,
     /*  272375 */   // Label 5155: @272375
     /*  272375 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(272438), // Rule ID 8311 //
     /*  272380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  272394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272419 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4),
     /*  272422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272436 */     GIR_RootConstrainSelectedInstOperands,
     /*  272437 */     // GIR_Coverage, 8311,
     /*  272437 */     GIR_EraseRootFromParent_Done,
     /*  272438 */   // Label 5156: @272438
     /*  272438 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(272501), // Rule ID 8314 //
     /*  272443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  272457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272499 */     GIR_RootConstrainSelectedInstOperands,
     /*  272500 */     // GIR_Coverage, 8314,
     /*  272500 */     GIR_EraseRootFromParent_Done,
     /*  272501 */   // Label 5157: @272501
     /*  272501 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(272564), // Rule ID 8315 //
     /*  272506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  272520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272545 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272562 */     GIR_RootConstrainSelectedInstOperands,
     /*  272563 */     // GIR_Coverage, 8315,
     /*  272563 */     GIR_EraseRootFromParent_Done,
     /*  272564 */   // Label 5158: @272564
     /*  272564 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(272627), // Rule ID 8318 //
     /*  272569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  272583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272625 */     GIR_RootConstrainSelectedInstOperands,
     /*  272626 */     // GIR_Coverage, 8318,
     /*  272626 */     GIR_EraseRootFromParent_Done,
     /*  272627 */   // Label 5159: @272627
     /*  272627 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(272690), // Rule ID 8319 //
     /*  272632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  272643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  272646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272671 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  272671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2),
     /*  272674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  272688 */     GIR_RootConstrainSelectedInstOperands,
     /*  272689 */     // GIR_Coverage, 8319,
     /*  272689 */     GIR_EraseRootFromParent_Done,
     /*  272690 */   // Label 5160: @272690
     /*  272690 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(272753), // Rule ID 8322 //
     /*  272695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  272709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272734 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  272734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  272737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272751 */     GIR_RootConstrainSelectedInstOperands,
     /*  272752 */     // GIR_Coverage, 8322,
     /*  272752 */     GIR_EraseRootFromParent_Done,
     /*  272753 */   // Label 5161: @272753
     /*  272753 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(272816), // Rule ID 8323 //
     /*  272758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  272769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  272772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272797 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  272797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  272800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  272814 */     GIR_RootConstrainSelectedInstOperands,
     /*  272815 */     // GIR_Coverage, 8323,
     /*  272815 */     GIR_EraseRootFromParent_Done,
     /*  272816 */   // Label 5162: @272816
     /*  272816 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(272879), // Rule ID 8326 //
     /*  272821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  272835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272860 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  272860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  272863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272877 */     GIR_RootConstrainSelectedInstOperands,
     /*  272878 */     // GIR_Coverage, 8326,
     /*  272878 */     GIR_EraseRootFromParent_Done,
     /*  272879 */   // Label 5163: @272879
     /*  272879 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(272942), // Rule ID 8327 //
     /*  272884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  272887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  272895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  272898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  272901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  272904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272923 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  272923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  272926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  272937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  272940 */     GIR_RootConstrainSelectedInstOperands,
     /*  272941 */     // GIR_Coverage, 8327,
     /*  272941 */     GIR_EraseRootFromParent_Done,
     /*  272942 */   // Label 5164: @272942
     /*  272942 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(273005), // Rule ID 8330 //
     /*  272947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  272950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  272955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  272958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  272961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  272964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  272967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  272975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  272979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  272986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  272986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  272989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  272991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  272993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  272995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273003 */     GIR_RootConstrainSelectedInstOperands,
     /*  273004 */     // GIR_Coverage, 8330,
     /*  273004 */     GIR_EraseRootFromParent_Done,
     /*  273005 */   // Label 5165: @273005
     /*  273005 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(273068), // Rule ID 8331 //
     /*  273010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  273021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  273024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273049 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  273049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  273066 */     GIR_RootConstrainSelectedInstOperands,
     /*  273067 */     // GIR_Coverage, 8331,
     /*  273067 */     GIR_EraseRootFromParent_Done,
     /*  273068 */   // Label 5166: @273068
     /*  273068 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(273131), // Rule ID 8334 //
     /*  273073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  273076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  273112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273129 */     GIR_RootConstrainSelectedInstOperands,
     /*  273130 */     // GIR_Coverage, 8334,
     /*  273130 */     GIR_EraseRootFromParent_Done,
     /*  273131 */   // Label 5167: @273131
     /*  273131 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(273194), // Rule ID 8335 //
     /*  273136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  273139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  273147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  273150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273175 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11394:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  273175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1),
     /*  273178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  273192 */     GIR_RootConstrainSelectedInstOperands,
     /*  273193 */     // GIR_Coverage, 8335,
     /*  273193 */     GIR_EraseRootFromParent_Done,
     /*  273194 */   // Label 5168: @273194
     /*  273194 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(273257), // Rule ID 8338 //
     /*  273199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273238 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273255 */     GIR_RootConstrainSelectedInstOperands,
     /*  273256 */     // GIR_Coverage, 8338,
     /*  273256 */     GIR_EraseRootFromParent_Done,
     /*  273257 */   // Label 5169: @273257
     /*  273257 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(273320), // Rule ID 8339 //
     /*  273262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  273276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273301 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273318 */     GIR_RootConstrainSelectedInstOperands,
     /*  273319 */     // GIR_Coverage, 8339,
     /*  273319 */     GIR_EraseRootFromParent_Done,
     /*  273320 */   // Label 5170: @273320
     /*  273320 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(273383), // Rule ID 8342 //
     /*  273325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273364 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273381 */     GIR_RootConstrainSelectedInstOperands,
     /*  273382 */     // GIR_Coverage, 8342,
     /*  273382 */     GIR_EraseRootFromParent_Done,
     /*  273383 */   // Label 5171: @273383
     /*  273383 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(273446), // Rule ID 8343 //
     /*  273388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  273402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273427 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273444 */     GIR_RootConstrainSelectedInstOperands,
     /*  273445 */     // GIR_Coverage, 8343,
     /*  273445 */     GIR_EraseRootFromParent_Done,
     /*  273446 */   // Label 5172: @273446
     /*  273446 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(273509), // Rule ID 8346 //
     /*  273451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  273462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  273465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273490 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  273490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  273493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273507 */     GIR_RootConstrainSelectedInstOperands,
     /*  273508 */     // GIR_Coverage, 8346,
     /*  273508 */     GIR_EraseRootFromParent_Done,
     /*  273509 */   // Label 5173: @273509
     /*  273509 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(273572), // Rule ID 8347 //
     /*  273514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  273525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  273528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273553 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  273553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  273556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  273570 */     GIR_RootConstrainSelectedInstOperands,
     /*  273571 */     // GIR_Coverage, 8347,
     /*  273571 */     GIR_EraseRootFromParent_Done,
     /*  273572 */   // Label 5174: @273572
     /*  273572 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(273635), // Rule ID 8350 //
     /*  273577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  273591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273633 */     GIR_RootConstrainSelectedInstOperands,
     /*  273634 */     // GIR_Coverage, 8350,
     /*  273634 */     GIR_EraseRootFromParent_Done,
     /*  273635 */   // Label 5175: @273635
     /*  273635 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(273698), // Rule ID 8351 //
     /*  273640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  273651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  273654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273679 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273696 */     GIR_RootConstrainSelectedInstOperands,
     /*  273697 */     // GIR_Coverage, 8351,
     /*  273697 */     GIR_EraseRootFromParent_Done,
     /*  273698 */   // Label 5176: @273698
     /*  273698 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(273761), // Rule ID 8354 //
     /*  273703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  273717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273759 */     GIR_RootConstrainSelectedInstOperands,
     /*  273760 */     // GIR_Coverage, 8354,
     /*  273760 */     GIR_EraseRootFromParent_Done,
     /*  273761 */   // Label 5177: @273761
     /*  273761 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(273824), // Rule ID 8355 //
     /*  273766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  273777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  273780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  273794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273805 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  273808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273822 */     GIR_RootConstrainSelectedInstOperands,
     /*  273823 */     // GIR_Coverage, 8355,
     /*  273823 */     GIR_EraseRootFromParent_Done,
     /*  273824 */   // Label 5178: @273824
     /*  273824 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(273887), // Rule ID 8358 //
     /*  273829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  273843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273868 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  273868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  273871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273885 */     GIR_RootConstrainSelectedInstOperands,
     /*  273886 */     // GIR_Coverage, 8358,
     /*  273886 */     GIR_EraseRootFromParent_Done,
     /*  273887 */   // Label 5179: @273887
     /*  273887 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(273950), // Rule ID 8359 //
     /*  273892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  273895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  273903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  273906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  273909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  273912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  273920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273931 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  273931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  273934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  273938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  273940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  273945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  273948 */     GIR_RootConstrainSelectedInstOperands,
     /*  273949 */     // GIR_Coverage, 8359,
     /*  273949 */     GIR_EraseRootFromParent_Done,
     /*  273950 */   // Label 5180: @273950
     /*  273950 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(274013), // Rule ID 8362 //
     /*  273955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  273958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  273963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  273966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  273969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  273972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  273975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  273979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  273983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  273987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  273994 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  273994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  273997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  273999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274011 */     GIR_RootConstrainSelectedInstOperands,
     /*  274012 */     // GIR_Coverage, 8362,
     /*  274012 */     GIR_EraseRootFromParent_Done,
     /*  274013 */   // Label 5181: @274013
     /*  274013 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(274076), // Rule ID 8363 //
     /*  274018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  274032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274057 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274074 */     GIR_RootConstrainSelectedInstOperands,
     /*  274075 */     // GIR_Coverage, 8363,
     /*  274075 */     GIR_EraseRootFromParent_Done,
     /*  274076 */   // Label 5182: @274076
     /*  274076 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(274139), // Rule ID 8366 //
     /*  274081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274120 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274137 */     GIR_RootConstrainSelectedInstOperands,
     /*  274138 */     // GIR_Coverage, 8366,
     /*  274138 */     GIR_EraseRootFromParent_Done,
     /*  274139 */   // Label 5183: @274139
     /*  274139 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(274202), // Rule ID 8367 //
     /*  274144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  274158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274183 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274200 */     GIR_RootConstrainSelectedInstOperands,
     /*  274201 */     // GIR_Coverage, 8367,
     /*  274201 */     GIR_EraseRootFromParent_Done,
     /*  274202 */   // Label 5184: @274202
     /*  274202 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(274265), // Rule ID 8370 //
     /*  274207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274246 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  274246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274263 */     GIR_RootConstrainSelectedInstOperands,
     /*  274264 */     // GIR_Coverage, 8370,
     /*  274264 */     GIR_EraseRootFromParent_Done,
     /*  274265 */   // Label 5185: @274265
     /*  274265 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(274328), // Rule ID 8371 //
     /*  274270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  274281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  274284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274309 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  274309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  274326 */     GIR_RootConstrainSelectedInstOperands,
     /*  274327 */     // GIR_Coverage, 8371,
     /*  274327 */     GIR_EraseRootFromParent_Done,
     /*  274328 */   // Label 5186: @274328
     /*  274328 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(274391), // Rule ID 8374 //
     /*  274333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274372 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274389 */     GIR_RootConstrainSelectedInstOperands,
     /*  274390 */     // GIR_Coverage, 8374,
     /*  274390 */     GIR_EraseRootFromParent_Done,
     /*  274391 */   // Label 5187: @274391
     /*  274391 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(274454), // Rule ID 8375 //
     /*  274396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  274410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  274424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274435 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11394:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2),
     /*  274438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274452 */     GIR_RootConstrainSelectedInstOperands,
     /*  274453 */     // GIR_Coverage, 8375,
     /*  274453 */     GIR_EraseRootFromParent_Done,
     /*  274454 */   // Label 5188: @274454
     /*  274454 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(274517), // Rule ID 8378 //
     /*  274459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  274473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274498 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274515 */     GIR_RootConstrainSelectedInstOperands,
     /*  274516 */     // GIR_Coverage, 8378,
     /*  274516 */     GIR_EraseRootFromParent_Done,
     /*  274517 */   // Label 5189: @274517
     /*  274517 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(274580), // Rule ID 8379 //
     /*  274522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  274536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  274550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274561 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11394:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4),
     /*  274564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274578 */     GIR_RootConstrainSelectedInstOperands,
     /*  274579 */     // GIR_Coverage, 8379,
     /*  274579 */     GIR_EraseRootFromParent_Done,
     /*  274580 */   // Label 5190: @274580
     /*  274580 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(274643), // Rule ID 8382 //
     /*  274585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  274588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  274599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  274602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274624 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  274624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274641 */     GIR_RootConstrainSelectedInstOperands,
     /*  274642 */     // GIR_Coverage, 8382,
     /*  274642 */     GIR_EraseRootFromParent_Done,
     /*  274643 */   // Label 5191: @274643
     /*  274643 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(274706), // Rule ID 8383 //
     /*  274648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  274651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu),
     /*  274656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  274659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  274662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  274665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  274676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  274680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274687 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11394:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  274687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8),
     /*  274690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  274704 */     GIR_RootConstrainSelectedInstOperands,
     /*  274705 */     // GIR_Coverage, 8383,
     /*  274705 */     GIR_EraseRootFromParent_Done,
     /*  274706 */   // Label 5192: @274706
     /*  274706 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(274769), // Rule ID 8386 //
     /*  274711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  274719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  274725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  274728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274750 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  274753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274767 */     GIR_RootConstrainSelectedInstOperands,
     /*  274768 */     // GIR_Coverage, 8386,
     /*  274768 */     GIR_EraseRootFromParent_Done,
     /*  274769 */   // Label 5193: @274769
     /*  274769 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(274832), // Rule ID 8387 //
     /*  274774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  274782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  274785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  274788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  274791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274813 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  274816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274830 */     GIR_RootConstrainSelectedInstOperands,
     /*  274831 */     // GIR_Coverage, 8387,
     /*  274831 */     GIR_EraseRootFromParent_Done,
     /*  274832 */   // Label 5194: @274832
     /*  274832 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(274895), // Rule ID 8390 //
     /*  274837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  274845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  274851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  274854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  274876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  274879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274893 */     GIR_RootConstrainSelectedInstOperands,
     /*  274894 */     // GIR_Coverage, 8390,
     /*  274894 */     GIR_EraseRootFromParent_Done,
     /*  274895 */   // Label 5195: @274895
     /*  274895 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(274958), // Rule ID 8391 //
     /*  274900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  274903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  274908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  274911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  274914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  274917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  274920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  274939 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  274939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  274942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  274944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  274946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  274948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  274953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  274956 */     GIR_RootConstrainSelectedInstOperands,
     /*  274957 */     // GIR_Coverage, 8391,
     /*  274957 */     GIR_EraseRootFromParent_Done,
     /*  274958 */   // Label 5196: @274958
     /*  274958 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(275021), // Rule ID 8394 //
     /*  274963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  274966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  274971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  274974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  274977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  274980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  274983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  274995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275002 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275019 */     GIR_RootConstrainSelectedInstOperands,
     /*  275020 */     // GIR_Coverage, 8394,
     /*  275020 */     GIR_EraseRootFromParent_Done,
     /*  275021 */   // Label 5197: @275021
     /*  275021 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(275084), // Rule ID 8395 //
     /*  275026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  275040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  275043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275065 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275082 */     GIR_RootConstrainSelectedInstOperands,
     /*  275083 */     // GIR_Coverage, 8395,
     /*  275083 */     GIR_EraseRootFromParent_Done,
     /*  275084 */   // Label 5198: @275084
     /*  275084 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(275147), // Rule ID 8398 //
     /*  275089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275145 */     GIR_RootConstrainSelectedInstOperands,
     /*  275146 */     // GIR_Coverage, 8398,
     /*  275146 */     GIR_EraseRootFromParent_Done,
     /*  275147 */   // Label 5199: @275147
     /*  275147 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(275210), // Rule ID 8399 //
     /*  275152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  275166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  275169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275191 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  275194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275208 */     GIR_RootConstrainSelectedInstOperands,
     /*  275209 */     // GIR_Coverage, 8399,
     /*  275209 */     GIR_EraseRootFromParent_Done,
     /*  275210 */   // Label 5200: @275210
     /*  275210 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(275273), // Rule ID 8402 //
     /*  275215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275254 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275271 */     GIR_RootConstrainSelectedInstOperands,
     /*  275272 */     // GIR_Coverage, 8402,
     /*  275272 */     GIR_EraseRootFromParent_Done,
     /*  275273 */   // Label 5201: @275273
     /*  275273 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(275336), // Rule ID 8403 //
     /*  275278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  275292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  275295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275317 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275334 */     GIR_RootConstrainSelectedInstOperands,
     /*  275335 */     // GIR_Coverage, 8403,
     /*  275335 */     GIR_EraseRootFromParent_Done,
     /*  275336 */   // Label 5202: @275336
     /*  275336 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(275399), // Rule ID 8406 //
     /*  275341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275380 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275397 */     GIR_RootConstrainSelectedInstOperands,
     /*  275398 */     // GIR_Coverage, 8406,
     /*  275398 */     GIR_EraseRootFromParent_Done,
     /*  275399 */   // Label 5203: @275399
     /*  275399 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(275462), // Rule ID 8407 //
     /*  275404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  275418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  275421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275443 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  275446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275460 */     GIR_RootConstrainSelectedInstOperands,
     /*  275461 */     // GIR_Coverage, 8407,
     /*  275461 */     GIR_EraseRootFromParent_Done,
     /*  275462 */   // Label 5204: @275462
     /*  275462 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(275525), // Rule ID 8410 //
     /*  275467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  275481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  275484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275506 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  275506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275523 */     GIR_RootConstrainSelectedInstOperands,
     /*  275524 */     // GIR_Coverage, 8410,
     /*  275524 */     GIR_EraseRootFromParent_Done,
     /*  275525 */   // Label 5205: @275525
     /*  275525 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(275588), // Rule ID 8411 //
     /*  275530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  275541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  275544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  275547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275569 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  275569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  275586 */     GIR_RootConstrainSelectedInstOperands,
     /*  275587 */     // GIR_Coverage, 8411,
     /*  275587 */     GIR_EraseRootFromParent_Done,
     /*  275588 */   // Label 5206: @275588
     /*  275588 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(275651), // Rule ID 8414 //
     /*  275593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  275607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  275610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  275632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275649 */     GIR_RootConstrainSelectedInstOperands,
     /*  275650 */     // GIR_Coverage, 8414,
     /*  275650 */     GIR_EraseRootFromParent_Done,
     /*  275651 */   // Label 5207: @275651
     /*  275651 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(275714), // Rule ID 8415 //
     /*  275656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  275667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  275670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  275673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275695 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  275695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  275712 */     GIR_RootConstrainSelectedInstOperands,
     /*  275713 */     // GIR_Coverage, 8415,
     /*  275713 */     GIR_EraseRootFromParent_Done,
     /*  275714 */   // Label 5208: @275714
     /*  275714 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(275777), // Rule ID 8418 //
     /*  275719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  275733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  275736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275758 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  275758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275775 */     GIR_RootConstrainSelectedInstOperands,
     /*  275776 */     // GIR_Coverage, 8418,
     /*  275776 */     GIR_EraseRootFromParent_Done,
     /*  275777 */   // Label 5209: @275777
     /*  275777 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(275840), // Rule ID 8419 //
     /*  275782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  275785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  275793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  275796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  275799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275821 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  275821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  275838 */     GIR_RootConstrainSelectedInstOperands,
     /*  275839 */     // GIR_Coverage, 8419,
     /*  275839 */     GIR_EraseRootFromParent_Done,
     /*  275840 */   // Label 5210: @275840
     /*  275840 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(275903), // Rule ID 8422 //
     /*  275845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  275848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  275859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  275862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  275884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275901 */     GIR_RootConstrainSelectedInstOperands,
     /*  275902 */     // GIR_Coverage, 8422,
     /*  275902 */     GIR_EraseRootFromParent_Done,
     /*  275903 */   // Label 5211: @275903
     /*  275903 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(275966), // Rule ID 8423 //
     /*  275908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  275911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  275919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  275922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  275925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  275928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  275947 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  275947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  275950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  275952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  275954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  275956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  275961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  275964 */     GIR_RootConstrainSelectedInstOperands,
     /*  275965 */     // GIR_Coverage, 8423,
     /*  275965 */     GIR_EraseRootFromParent_Done,
     /*  275966 */   // Label 5212: @275966
     /*  275966 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(276029), // Rule ID 8426 //
     /*  275971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  275974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  275979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  275982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  275985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  275988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  275991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  275995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  275999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276010 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276027 */     GIR_RootConstrainSelectedInstOperands,
     /*  276028 */     // GIR_Coverage, 8426,
     /*  276028 */     GIR_EraseRootFromParent_Done,
     /*  276029 */   // Label 5213: @276029
     /*  276029 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(276092), // Rule ID 8427 //
     /*  276034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  276048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  276051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276073 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276090 */     GIR_RootConstrainSelectedInstOperands,
     /*  276091 */     // GIR_Coverage, 8427,
     /*  276091 */     GIR_EraseRootFromParent_Done,
     /*  276092 */   // Label 5214: @276092
     /*  276092 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(276155), // Rule ID 8430 //
     /*  276097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276136 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276153 */     GIR_RootConstrainSelectedInstOperands,
     /*  276154 */     // GIR_Coverage, 8430,
     /*  276154 */     GIR_EraseRootFromParent_Done,
     /*  276155 */   // Label 5215: @276155
     /*  276155 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(276218), // Rule ID 8431 //
     /*  276160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  276174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  276177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276199 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276216 */     GIR_RootConstrainSelectedInstOperands,
     /*  276217 */     // GIR_Coverage, 8431,
     /*  276217 */     GIR_EraseRootFromParent_Done,
     /*  276218 */   // Label 5216: @276218
     /*  276218 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(276281), // Rule ID 8434 //
     /*  276223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276262 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  276262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276279 */     GIR_RootConstrainSelectedInstOperands,
     /*  276280 */     // GIR_Coverage, 8434,
     /*  276280 */     GIR_EraseRootFromParent_Done,
     /*  276281 */   // Label 5217: @276281
     /*  276281 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(276344), // Rule ID 8435 //
     /*  276286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  276297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  276300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  276303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276325 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  276325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  276342 */     GIR_RootConstrainSelectedInstOperands,
     /*  276343 */     // GIR_Coverage, 8435,
     /*  276343 */     GIR_EraseRootFromParent_Done,
     /*  276344 */   // Label 5218: @276344
     /*  276344 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(276407), // Rule ID 8438 //
     /*  276349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276405 */     GIR_RootConstrainSelectedInstOperands,
     /*  276406 */     // GIR_Coverage, 8438,
     /*  276406 */     GIR_EraseRootFromParent_Done,
     /*  276407 */   // Label 5219: @276407
     /*  276407 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(276470), // Rule ID 8439 //
     /*  276412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  276426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  276429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276451 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276468 */     GIR_RootConstrainSelectedInstOperands,
     /*  276469 */     // GIR_Coverage, 8439,
     /*  276469 */     GIR_EraseRootFromParent_Done,
     /*  276470 */   // Label 5220: @276470
     /*  276470 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(276533), // Rule ID 8442 //
     /*  276475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  276489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  276492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276514 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276531 */     GIR_RootConstrainSelectedInstOperands,
     /*  276532 */     // GIR_Coverage, 8442,
     /*  276532 */     GIR_EraseRootFromParent_Done,
     /*  276533 */   // Label 5221: @276533
     /*  276533 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(276596), // Rule ID 8443 //
     /*  276538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  276552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  276555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276577 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276594 */     GIR_RootConstrainSelectedInstOperands,
     /*  276595 */     // GIR_Coverage, 8443,
     /*  276595 */     GIR_EraseRootFromParent_Done,
     /*  276596 */   // Label 5222: @276596
     /*  276596 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(276659), // Rule ID 8446 //
     /*  276601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  276615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  276618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276640 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  276640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276657 */     GIR_RootConstrainSelectedInstOperands,
     /*  276658 */     // GIR_Coverage, 8446,
     /*  276658 */     GIR_EraseRootFromParent_Done,
     /*  276659 */   // Label 5223: @276659
     /*  276659 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(276722), // Rule ID 8447 //
     /*  276664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  276675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  276678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  276681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  276696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276703 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  276703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  276706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  276720 */     GIR_RootConstrainSelectedInstOperands,
     /*  276721 */     // GIR_Coverage, 8447,
     /*  276721 */     GIR_EraseRootFromParent_Done,
     /*  276722 */   // Label 5224: @276722
     /*  276722 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(276785), // Rule ID 8450 //
     /*  276727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  276741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  276744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276766 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276783 */     GIR_RootConstrainSelectedInstOperands,
     /*  276784 */     // GIR_Coverage, 8450,
     /*  276784 */     GIR_EraseRootFromParent_Done,
     /*  276785 */   // Label 5225: @276785
     /*  276785 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(276848), // Rule ID 8451 //
     /*  276790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  276801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  276804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  276807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  276822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276829 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  276832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276846 */     GIR_RootConstrainSelectedInstOperands,
     /*  276847 */     // GIR_Coverage, 8451,
     /*  276847 */     GIR_EraseRootFromParent_Done,
     /*  276848 */   // Label 5226: @276848
     /*  276848 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(276911), // Rule ID 8454 //
     /*  276853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  276867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  276870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  276892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276909 */     GIR_RootConstrainSelectedInstOperands,
     /*  276910 */     // GIR_Coverage, 8454,
     /*  276910 */     GIR_EraseRootFromParent_Done,
     /*  276911 */   // Label 5227: @276911
     /*  276911 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(276974), // Rule ID 8455 //
     /*  276916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  276919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  276927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  276930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  276933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  276936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  276940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  276948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  276955 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  276955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  276958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  276960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  276962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  276964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  276969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  276972 */     GIR_RootConstrainSelectedInstOperands,
     /*  276973 */     // GIR_Coverage, 8455,
     /*  276973 */     GIR_EraseRootFromParent_Done,
     /*  276974 */   // Label 5228: @276974
     /*  276974 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(277037), // Rule ID 8458 //
     /*  276979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  276982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  276987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  276990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  276993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  276996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  276999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277018 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  277018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277035 */     GIR_RootConstrainSelectedInstOperands,
     /*  277036 */     // GIR_Coverage, 8458,
     /*  277036 */     GIR_EraseRootFromParent_Done,
     /*  277037 */   // Label 5229: @277037
     /*  277037 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(277100), // Rule ID 8459 //
     /*  277042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  277053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  277056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  277059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277081 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  277081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  277098 */     GIR_RootConstrainSelectedInstOperands,
     /*  277099 */     // GIR_Coverage, 8459,
     /*  277099 */     GIR_EraseRootFromParent_Done,
     /*  277100 */   // Label 5230: @277100
     /*  277100 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(277163), // Rule ID 8462 //
     /*  277105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277144 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277161 */     GIR_RootConstrainSelectedInstOperands,
     /*  277162 */     // GIR_Coverage, 8462,
     /*  277162 */     GIR_EraseRootFromParent_Done,
     /*  277163 */   // Label 5231: @277163
     /*  277163 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(277226), // Rule ID 8463 //
     /*  277168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  277182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  277185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  277200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277207 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  277210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277224 */     GIR_RootConstrainSelectedInstOperands,
     /*  277225 */     // GIR_Coverage, 8463,
     /*  277225 */     GIR_EraseRootFromParent_Done,
     /*  277226 */   // Label 5232: @277226
     /*  277226 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(277289), // Rule ID 8466 //
     /*  277231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277270 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277287 */     GIR_RootConstrainSelectedInstOperands,
     /*  277288 */     // GIR_Coverage, 8466,
     /*  277288 */     GIR_EraseRootFromParent_Done,
     /*  277289 */   // Label 5233: @277289
     /*  277289 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(277352), // Rule ID 8467 //
     /*  277294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  277308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  277311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  277326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277333 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  277336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277350 */     GIR_RootConstrainSelectedInstOperands,
     /*  277351 */     // GIR_Coverage, 8467,
     /*  277351 */     GIR_EraseRootFromParent_Done,
     /*  277352 */   // Label 5234: @277352
     /*  277352 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(277415), // Rule ID 8470 //
     /*  277357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  277360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277396 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  277396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277413 */     GIR_RootConstrainSelectedInstOperands,
     /*  277414 */     // GIR_Coverage, 8470,
     /*  277414 */     GIR_EraseRootFromParent_Done,
     /*  277415 */   // Label 5235: @277415
     /*  277415 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(277478), // Rule ID 8471 //
     /*  277420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  277423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  277431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  277434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  277437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  277452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  277459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  277462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  277476 */     GIR_RootConstrainSelectedInstOperands,
     /*  277477 */     // GIR_Coverage, 8471,
     /*  277477 */     GIR_EraseRootFromParent_Done,
     /*  277478 */   // Label 5236: @277478
     /*  277478 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(277541), // Rule ID 8474 //
     /*  277483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  277497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277522 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  277525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277539 */     GIR_RootConstrainSelectedInstOperands,
     /*  277540 */     // GIR_Coverage, 8474,
     /*  277540 */     GIR_EraseRootFromParent_Done,
     /*  277541 */   // Label 5237: @277541
     /*  277541 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(277604), // Rule ID 8475 //
     /*  277546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  277560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277585 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8),
     /*  277588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277602 */     GIR_RootConstrainSelectedInstOperands,
     /*  277603 */     // GIR_Coverage, 8475,
     /*  277603 */     GIR_EraseRootFromParent_Done,
     /*  277604 */   // Label 5238: @277604
     /*  277604 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(277667), // Rule ID 8478 //
     /*  277609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  277623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277648 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  277651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277665 */     GIR_RootConstrainSelectedInstOperands,
     /*  277666 */     // GIR_Coverage, 8478,
     /*  277666 */     GIR_EraseRootFromParent_Done,
     /*  277667 */   // Label 5239: @277667
     /*  277667 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(277730), // Rule ID 8479 //
     /*  277672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  277686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277711 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  277714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277728 */     GIR_RootConstrainSelectedInstOperands,
     /*  277729 */     // GIR_Coverage, 8479,
     /*  277729 */     GIR_EraseRootFromParent_Done,
     /*  277730 */   // Label 5240: @277730
     /*  277730 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(277793), // Rule ID 8482 //
     /*  277735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  277749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  277774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  277777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277791 */     GIR_RootConstrainSelectedInstOperands,
     /*  277792 */     // GIR_Coverage, 8482,
     /*  277792 */     GIR_EraseRootFromParent_Done,
     /*  277793 */   // Label 5241: @277793
     /*  277793 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(277856), // Rule ID 8483 //
     /*  277798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  277809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  277812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277837 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  277837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  277840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  277854 */     GIR_RootConstrainSelectedInstOperands,
     /*  277855 */     // GIR_Coverage, 8483,
     /*  277855 */     GIR_EraseRootFromParent_Done,
     /*  277856 */   // Label 5242: @277856
     /*  277856 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(277919), // Rule ID 8486 //
     /*  277861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  277875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  277878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  277881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  277900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  277903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277917 */     GIR_RootConstrainSelectedInstOperands,
     /*  277918 */     // GIR_Coverage, 8486,
     /*  277918 */     GIR_EraseRootFromParent_Done,
     /*  277919 */   // Label 5243: @277919
     /*  277919 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(277982), // Rule ID 8487 //
     /*  277924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  277927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  277935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  277938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  277941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  277944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  277952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  277956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  277963 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  277963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4),
     /*  277966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  277968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  277970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  277972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  277977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  277980 */     GIR_RootConstrainSelectedInstOperands,
     /*  277981 */     // GIR_Coverage, 8487,
     /*  277981 */     GIR_EraseRootFromParent_Done,
     /*  277982 */   // Label 5244: @277982
     /*  277982 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(278045), // Rule ID 8490 //
     /*  277987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  277990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  277995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  277998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278026 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278043 */     GIR_RootConstrainSelectedInstOperands,
     /*  278044 */     // GIR_Coverage, 8490,
     /*  278044 */     GIR_EraseRootFromParent_Done,
     /*  278045 */   // Label 5245: @278045
     /*  278045 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(278108), // Rule ID 8491 //
     /*  278050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  278064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278089 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278106 */     GIR_RootConstrainSelectedInstOperands,
     /*  278107 */     // GIR_Coverage, 8491,
     /*  278107 */     GIR_EraseRootFromParent_Done,
     /*  278108 */   // Label 5246: @278108
     /*  278108 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(278171), // Rule ID 8494 //
     /*  278113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278169 */     GIR_RootConstrainSelectedInstOperands,
     /*  278170 */     // GIR_Coverage, 8494,
     /*  278170 */     GIR_EraseRootFromParent_Done,
     /*  278171 */   // Label 5247: @278171
     /*  278171 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(278234), // Rule ID 8495 //
     /*  278176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  278190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278215 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2),
     /*  278218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278232 */     GIR_RootConstrainSelectedInstOperands,
     /*  278233 */     // GIR_Coverage, 8495,
     /*  278233 */     GIR_EraseRootFromParent_Done,
     /*  278234 */   // Label 5248: @278234
     /*  278234 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(278297), // Rule ID 8498 //
     /*  278239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278278 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278295 */     GIR_RootConstrainSelectedInstOperands,
     /*  278296 */     // GIR_Coverage, 8498,
     /*  278296 */     GIR_EraseRootFromParent_Done,
     /*  278297 */   // Label 5249: @278297
     /*  278297 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(278360), // Rule ID 8499 //
     /*  278302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  278313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  278316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278341 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278358 */     GIR_RootConstrainSelectedInstOperands,
     /*  278359 */     // GIR_Coverage, 8499,
     /*  278359 */     GIR_EraseRootFromParent_Done,
     /*  278360 */   // Label 5250: @278360
     /*  278360 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(278423), // Rule ID 8502 //
     /*  278365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  278404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278421 */     GIR_RootConstrainSelectedInstOperands,
     /*  278422 */     // GIR_Coverage, 8502,
     /*  278422 */     GIR_EraseRootFromParent_Done,
     /*  278423 */   // Label 5251: @278423
     /*  278423 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(278486), // Rule ID 8503 //
     /*  278428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  278439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  278442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278467 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  278467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  278484 */     GIR_RootConstrainSelectedInstOperands,
     /*  278485 */     // GIR_Coverage, 8503,
     /*  278485 */     GIR_EraseRootFromParent_Done,
     /*  278486 */   // Label 5252: @278486
     /*  278486 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(278549), // Rule ID 8506 //
     /*  278491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  278505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278530 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  278530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278547 */     GIR_RootConstrainSelectedInstOperands,
     /*  278548 */     // GIR_Coverage, 8506,
     /*  278548 */     GIR_EraseRootFromParent_Done,
     /*  278549 */   // Label 5253: @278549
     /*  278549 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(278612), // Rule ID 8507 //
     /*  278554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  278565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  278568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278593 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  278593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  278610 */     GIR_RootConstrainSelectedInstOperands,
     /*  278611 */     // GIR_Coverage, 8507,
     /*  278611 */     GIR_EraseRootFromParent_Done,
     /*  278612 */   // Label 5254: @278612
     /*  278612 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(278675), // Rule ID 8510 //
     /*  278617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  278620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  278631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  278656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278673 */     GIR_RootConstrainSelectedInstOperands,
     /*  278674 */     // GIR_Coverage, 8510,
     /*  278674 */     GIR_EraseRootFromParent_Done,
     /*  278675 */   // Label 5255: @278675
     /*  278675 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(278738), // Rule ID 8511 //
     /*  278680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  278683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  278691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  278694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278719 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11392:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  278719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1),
     /*  278722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  278736 */     GIR_RootConstrainSelectedInstOperands,
     /*  278737 */     // GIR_Coverage, 8511,
     /*  278737 */     GIR_EraseRootFromParent_Done,
     /*  278738 */   // Label 5256: @278738
     /*  278738 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(278801), // Rule ID 8514 //
     /*  278743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  278757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278782 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  278785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278799 */     GIR_RootConstrainSelectedInstOperands,
     /*  278800 */     // GIR_Coverage, 8514,
     /*  278800 */     GIR_EraseRootFromParent_Done,
     /*  278801 */   // Label 5257: @278801
     /*  278801 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(278864), // Rule ID 8515 //
     /*  278806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  278817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  278820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  278834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278845 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  278848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278862 */     GIR_RootConstrainSelectedInstOperands,
     /*  278863 */     // GIR_Coverage, 8515,
     /*  278863 */     GIR_EraseRootFromParent_Done,
     /*  278864 */   // Label 5258: @278864
     /*  278864 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(278927), // Rule ID 8518 //
     /*  278869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  278883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  278886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  278889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278908 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  278908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  278911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278925 */     GIR_RootConstrainSelectedInstOperands,
     /*  278926 */     // GIR_Coverage, 8518,
     /*  278926 */     GIR_EraseRootFromParent_Done,
     /*  278927 */   // Label 5259: @278927
     /*  278927 */   GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(278990), // Rule ID 8519 //
     /*  278932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  278935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  278940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  278943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  278946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  278949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  278952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  278956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  278960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  278964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  278971 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  278971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  278974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  278976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  278978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  278980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  278985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  278988 */     GIR_RootConstrainSelectedInstOperands,
     /*  278989 */     // GIR_Coverage, 8519,
     /*  278989 */     GIR_EraseRootFromParent_Done,
     /*  278990 */   // Label 5260: @278990
     /*  278990 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(279053), // Rule ID 8522 //
     /*  278995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  278998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279034 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  279034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279051 */     GIR_RootConstrainSelectedInstOperands,
     /*  279052 */     // GIR_Coverage, 8522,
     /*  279052 */     GIR_EraseRootFromParent_Done,
     /*  279053 */   // Label 5261: @279053
     /*  279053 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(279116), // Rule ID 8523 //
     /*  279058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  279069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  279072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279097 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  279097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  279114 */     GIR_RootConstrainSelectedInstOperands,
     /*  279115 */     // GIR_Coverage, 8523,
     /*  279115 */     GIR_EraseRootFromParent_Done,
     /*  279116 */   // Label 5262: @279116
     /*  279116 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(279179), // Rule ID 8526 //
     /*  279121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279177 */     GIR_RootConstrainSelectedInstOperands,
     /*  279178 */     // GIR_Coverage, 8526,
     /*  279178 */     GIR_EraseRootFromParent_Done,
     /*  279179 */   // Label 5263: @279179
     /*  279179 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(279242), // Rule ID 8527 //
     /*  279184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  279198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279223 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279240 */     GIR_RootConstrainSelectedInstOperands,
     /*  279241 */     // GIR_Coverage, 8527,
     /*  279241 */     GIR_EraseRootFromParent_Done,
     /*  279242 */   // Label 5264: @279242
     /*  279242 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(279305), // Rule ID 8530 //
     /*  279247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279286 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279303 */     GIR_RootConstrainSelectedInstOperands,
     /*  279304 */     // GIR_Coverage, 8530,
     /*  279304 */     GIR_EraseRootFromParent_Done,
     /*  279305 */   // Label 5265: @279305
     /*  279305 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(279368), // Rule ID 8531 //
     /*  279310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  279324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279349 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279366 */     GIR_RootConstrainSelectedInstOperands,
     /*  279367 */     // GIR_Coverage, 8531,
     /*  279367 */     GIR_EraseRootFromParent_Done,
     /*  279368 */   // Label 5266: @279368
     /*  279368 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(279431), // Rule ID 8534 //
     /*  279373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279412 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  279412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279429 */     GIR_RootConstrainSelectedInstOperands,
     /*  279430 */     // GIR_Coverage, 8534,
     /*  279430 */     GIR_EraseRootFromParent_Done,
     /*  279431 */   // Label 5267: @279431
     /*  279431 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(279494), // Rule ID 8535 //
     /*  279436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  279447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  279450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279475 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  279475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  279492 */     GIR_RootConstrainSelectedInstOperands,
     /*  279493 */     // GIR_Coverage, 8535,
     /*  279493 */     GIR_EraseRootFromParent_Done,
     /*  279494 */   // Label 5268: @279494
     /*  279494 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(279557), // Rule ID 8538 //
     /*  279499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  279513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279538 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279555 */     GIR_RootConstrainSelectedInstOperands,
     /*  279556 */     // GIR_Coverage, 8538,
     /*  279556 */     GIR_EraseRootFromParent_Done,
     /*  279557 */   // Label 5269: @279557
     /*  279557 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(279620), // Rule ID 8539 //
     /*  279562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  279573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  279576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279601 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279618 */     GIR_RootConstrainSelectedInstOperands,
     /*  279619 */     // GIR_Coverage, 8539,
     /*  279619 */     GIR_EraseRootFromParent_Done,
     /*  279620 */   // Label 5270: @279620
     /*  279620 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(279683), // Rule ID 8542 //
     /*  279625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  279639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279681 */     GIR_RootConstrainSelectedInstOperands,
     /*  279682 */     // GIR_Coverage, 8542,
     /*  279682 */     GIR_EraseRootFromParent_Done,
     /*  279683 */   // Label 5271: @279683
     /*  279683 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(279746), // Rule ID 8543 //
     /*  279688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  279699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  279702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  279716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279727 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  279730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279744 */     GIR_RootConstrainSelectedInstOperands,
     /*  279745 */     // GIR_Coverage, 8543,
     /*  279745 */     GIR_EraseRootFromParent_Done,
     /*  279746 */   // Label 5272: @279746
     /*  279746 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(279809), // Rule ID 8546 //
     /*  279751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  279754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  279765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279790 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  279790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279807 */     GIR_RootConstrainSelectedInstOperands,
     /*  279808 */     // GIR_Coverage, 8546,
     /*  279808 */     GIR_EraseRootFromParent_Done,
     /*  279809 */   // Label 5273: @279809
     /*  279809 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(279872), // Rule ID 8547 //
     /*  279814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  279817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  279825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  279828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  279842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279853 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  279853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  279856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  279870 */     GIR_RootConstrainSelectedInstOperands,
     /*  279871 */     // GIR_Coverage, 8547,
     /*  279871 */     GIR_EraseRootFromParent_Done,
     /*  279872 */   // Label 5274: @279872
     /*  279872 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(279935), // Rule ID 8550 //
     /*  279877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  279880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  279891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  279894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  279897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  279916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279933 */     GIR_RootConstrainSelectedInstOperands,
     /*  279934 */     // GIR_Coverage, 8550,
     /*  279934 */     GIR_EraseRootFromParent_Done,
     /*  279935 */   // Label 5275: @279935
     /*  279935 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(279998), // Rule ID 8551 //
     /*  279940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  279943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  279948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  279951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  279954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  279957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  279960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  279964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  279968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  279972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  279979 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11392:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  279979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2),
     /*  279982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  279984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  279986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  279988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  279993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  279996 */     GIR_RootConstrainSelectedInstOperands,
     /*  279997 */     // GIR_Coverage, 8551,
     /*  279997 */     GIR_EraseRootFromParent_Done,
     /*  279998 */   // Label 5276: @279998
     /*  279998 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(280061), // Rule ID 8554 //
     /*  280003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280042 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280059 */     GIR_RootConstrainSelectedInstOperands,
     /*  280060 */     // GIR_Coverage, 8554,
     /*  280060 */     GIR_EraseRootFromParent_Done,
     /*  280061 */   // Label 5277: @280061
     /*  280061 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(280124), // Rule ID 8555 //
     /*  280066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  280080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  280094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280105 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11392:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4),
     /*  280108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280122 */     GIR_RootConstrainSelectedInstOperands,
     /*  280123 */     // GIR_Coverage, 8555,
     /*  280123 */     GIR_EraseRootFromParent_Done,
     /*  280124 */   // Label 5278: @280124
     /*  280124 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(280187), // Rule ID 8558 //
     /*  280129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  280132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  280146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280168 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  280168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280185 */     GIR_RootConstrainSelectedInstOperands,
     /*  280186 */     // GIR_Coverage, 8558,
     /*  280186 */     GIR_EraseRootFromParent_Done,
     /*  280187 */   // Label 5279: @280187
     /*  280187 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(280250), // Rule ID 8559 //
     /*  280192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  280195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt),
     /*  280200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  280203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  280206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  280209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  280220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  280224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280231 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11392:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  280231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8),
     /*  280234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  280248 */     GIR_RootConstrainSelectedInstOperands,
     /*  280249 */     // GIR_Coverage, 8559,
     /*  280249 */     GIR_EraseRootFromParent_Done,
     /*  280250 */   // Label 5280: @280250
     /*  280250 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(280313), // Rule ID 8562 //
     /*  280255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280294 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280311 */     GIR_RootConstrainSelectedInstOperands,
     /*  280312 */     // GIR_Coverage, 8562,
     /*  280312 */     GIR_EraseRootFromParent_Done,
     /*  280313 */   // Label 5281: @280313
     /*  280313 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(280376), // Rule ID 8563 //
     /*  280318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  280332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  280335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280357 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  280360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280374 */     GIR_RootConstrainSelectedInstOperands,
     /*  280375 */     // GIR_Coverage, 8563,
     /*  280375 */     GIR_EraseRootFromParent_Done,
     /*  280376 */   // Label 5282: @280376
     /*  280376 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(280439), // Rule ID 8566 //
     /*  280381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280437 */     GIR_RootConstrainSelectedInstOperands,
     /*  280438 */     // GIR_Coverage, 8566,
     /*  280438 */     GIR_EraseRootFromParent_Done,
     /*  280439 */   // Label 5283: @280439
     /*  280439 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(280502), // Rule ID 8567 //
     /*  280444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  280458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  280461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280483 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280500 */     GIR_RootConstrainSelectedInstOperands,
     /*  280501 */     // GIR_Coverage, 8567,
     /*  280501 */     GIR_EraseRootFromParent_Done,
     /*  280502 */   // Label 5284: @280502
     /*  280502 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(280565), // Rule ID 8570 //
     /*  280507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  280521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  280524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280546 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  280546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280563 */     GIR_RootConstrainSelectedInstOperands,
     /*  280564 */     // GIR_Coverage, 8570,
     /*  280564 */     GIR_EraseRootFromParent_Done,
     /*  280565 */   // Label 5285: @280565
     /*  280565 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(280628), // Rule ID 8571 //
     /*  280570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  280581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  280584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  280587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280609 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  280609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  280626 */     GIR_RootConstrainSelectedInstOperands,
     /*  280627 */     // GIR_Coverage, 8571,
     /*  280627 */     GIR_EraseRootFromParent_Done,
     /*  280628 */   // Label 5286: @280628
     /*  280628 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(280691), // Rule ID 8574 //
     /*  280633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  280647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  280650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280689 */     GIR_RootConstrainSelectedInstOperands,
     /*  280690 */     // GIR_Coverage, 8574,
     /*  280690 */     GIR_EraseRootFromParent_Done,
     /*  280691 */   // Label 5287: @280691
     /*  280691 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(280754), // Rule ID 8575 //
     /*  280696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  280710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  280713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280735 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  280738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280752 */     GIR_RootConstrainSelectedInstOperands,
     /*  280753 */     // GIR_Coverage, 8575,
     /*  280753 */     GIR_EraseRootFromParent_Done,
     /*  280754 */   // Label 5288: @280754
     /*  280754 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(280817), // Rule ID 8578 //
     /*  280759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  280773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  280776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280798 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  280798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280815 */     GIR_RootConstrainSelectedInstOperands,
     /*  280816 */     // GIR_Coverage, 8578,
     /*  280816 */     GIR_EraseRootFromParent_Done,
     /*  280817 */   // Label 5289: @280817
     /*  280817 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(280880), // Rule ID 8579 //
     /*  280822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  280833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  280836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  280839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  280861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  280878 */     GIR_RootConstrainSelectedInstOperands,
     /*  280879 */     // GIR_Coverage, 8579,
     /*  280879 */     GIR_EraseRootFromParent_Done,
     /*  280880 */   // Label 5290: @280880
     /*  280880 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(280943), // Rule ID 8582 //
     /*  280885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  280888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  280899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  280902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  280905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  280924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  280938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  280941 */     GIR_RootConstrainSelectedInstOperands,
     /*  280942 */     // GIR_Coverage, 8582,
     /*  280942 */     GIR_EraseRootFromParent_Done,
     /*  280943 */   // Label 5291: @280943
     /*  280943 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(281006), // Rule ID 8583 //
     /*  280948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  280951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  280956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  280959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  280962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  280965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  280968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  280980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  280987 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  280987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  280990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  280992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  280994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  280996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281004 */     GIR_RootConstrainSelectedInstOperands,
     /*  281005 */     // GIR_Coverage, 8583,
     /*  281005 */     GIR_EraseRootFromParent_Done,
     /*  281006 */   // Label 5292: @281006
     /*  281006 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(281069), // Rule ID 8586 //
     /*  281011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281050 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281067 */     GIR_RootConstrainSelectedInstOperands,
     /*  281068 */     // GIR_Coverage, 8586,
     /*  281068 */     GIR_EraseRootFromParent_Done,
     /*  281069 */   // Label 5293: @281069
     /*  281069 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(281132), // Rule ID 8587 //
     /*  281074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  281088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  281091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281113 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281130 */     GIR_RootConstrainSelectedInstOperands,
     /*  281131 */     // GIR_Coverage, 8587,
     /*  281131 */     GIR_EraseRootFromParent_Done,
     /*  281132 */   // Label 5294: @281132
     /*  281132 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(281195), // Rule ID 8590 //
     /*  281137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281193 */     GIR_RootConstrainSelectedInstOperands,
     /*  281194 */     // GIR_Coverage, 8590,
     /*  281194 */     GIR_EraseRootFromParent_Done,
     /*  281195 */   // Label 5295: @281195
     /*  281195 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(281258), // Rule ID 8591 //
     /*  281200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  281211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  281214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  281217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281239 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281256 */     GIR_RootConstrainSelectedInstOperands,
     /*  281257 */     // GIR_Coverage, 8591,
     /*  281257 */     GIR_EraseRootFromParent_Done,
     /*  281258 */   // Label 5296: @281258
     /*  281258 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(281321), // Rule ID 8594 //
     /*  281263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281302 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  281302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281319 */     GIR_RootConstrainSelectedInstOperands,
     /*  281320 */     // GIR_Coverage, 8594,
     /*  281320 */     GIR_EraseRootFromParent_Done,
     /*  281321 */   // Label 5297: @281321
     /*  281321 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(281384), // Rule ID 8595 //
     /*  281326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  281337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  281340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  281343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281365 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  281365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  281382 */     GIR_RootConstrainSelectedInstOperands,
     /*  281383 */     // GIR_Coverage, 8595,
     /*  281383 */     GIR_EraseRootFromParent_Done,
     /*  281384 */   // Label 5298: @281384
     /*  281384 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(281447), // Rule ID 8598 //
     /*  281389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  281392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  281428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281445 */     GIR_RootConstrainSelectedInstOperands,
     /*  281446 */     // GIR_Coverage, 8598,
     /*  281446 */     GIR_EraseRootFromParent_Done,
     /*  281447 */   // Label 5299: @281447
     /*  281447 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(281510), // Rule ID 8599 //
     /*  281452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  281455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  281463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  281466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  281469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281491 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  281491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  281494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  281508 */     GIR_RootConstrainSelectedInstOperands,
     /*  281509 */     // GIR_Coverage, 8599,
     /*  281509 */     GIR_EraseRootFromParent_Done,
     /*  281510 */   // Label 5300: @281510
     /*  281510 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(281573), // Rule ID 8602 //
     /*  281515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  281529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  281532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281554 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  281557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281571 */     GIR_RootConstrainSelectedInstOperands,
     /*  281572 */     // GIR_Coverage, 8602,
     /*  281572 */     GIR_EraseRootFromParent_Done,
     /*  281573 */   // Label 5301: @281573
     /*  281573 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(281636), // Rule ID 8603 //
     /*  281578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  281589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  281592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  281595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281617 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  281620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281634 */     GIR_RootConstrainSelectedInstOperands,
     /*  281635 */     // GIR_Coverage, 8603,
     /*  281635 */     GIR_EraseRootFromParent_Done,
     /*  281636 */   // Label 5302: @281636
     /*  281636 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(281699), // Rule ID 8606 //
     /*  281641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  281652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  281655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  281658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281680 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  281683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281697 */     GIR_RootConstrainSelectedInstOperands,
     /*  281698 */     // GIR_Coverage, 8606,
     /*  281698 */     GIR_EraseRootFromParent_Done,
     /*  281699 */   // Label 5303: @281699
     /*  281699 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(281762), // Rule ID 8607 //
     /*  281704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  281715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  281718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  281721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  281736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281743 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  281746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281760 */     GIR_RootConstrainSelectedInstOperands,
     /*  281761 */     // GIR_Coverage, 8607,
     /*  281761 */     GIR_EraseRootFromParent_Done,
     /*  281762 */   // Label 5304: @281762
     /*  281762 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(281825), // Rule ID 8610 //
     /*  281767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  281778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  281781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  281784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281806 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  281806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  281809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281823 */     GIR_RootConstrainSelectedInstOperands,
     /*  281824 */     // GIR_Coverage, 8610,
     /*  281824 */     GIR_EraseRootFromParent_Done,
     /*  281825 */   // Label 5305: @281825
     /*  281825 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(281888), // Rule ID 8611 //
     /*  281830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  281841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  281844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  281847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  281862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281869 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  281869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  281872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  281886 */     GIR_RootConstrainSelectedInstOperands,
     /*  281887 */     // GIR_Coverage, 8611,
     /*  281887 */     GIR_EraseRootFromParent_Done,
     /*  281888 */   // Label 5306: @281888
     /*  281888 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(281951), // Rule ID 8614 //
     /*  281893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  281896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  281907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  281910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  281913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281932 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  281932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  281935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  281937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  281939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  281941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  281946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  281949 */     GIR_RootConstrainSelectedInstOperands,
     /*  281950 */     // GIR_Coverage, 8614,
     /*  281950 */     GIR_EraseRootFromParent_Done,
     /*  281951 */   // Label 5307: @281951
     /*  281951 */   GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(282014), // Rule ID 8615 //
     /*  281956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  281959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  281964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  281967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  281970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  281973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  281976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  281980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  281988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  281995 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  281995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  281998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282012 */     GIR_RootConstrainSelectedInstOperands,
     /*  282013 */     // GIR_Coverage, 8615,
     /*  282013 */     GIR_EraseRootFromParent_Done,
     /*  282014 */   // Label 5308: @282014
     /*  282014 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(282077), // Rule ID 8618 //
     /*  282019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282058 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282075 */     GIR_RootConstrainSelectedInstOperands,
     /*  282076 */     // GIR_Coverage, 8618,
     /*  282076 */     GIR_EraseRootFromParent_Done,
     /*  282077 */   // Label 5309: @282077
     /*  282077 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(282140), // Rule ID 8619 //
     /*  282082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  282096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  282099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282121 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282138 */     GIR_RootConstrainSelectedInstOperands,
     /*  282139 */     // GIR_Coverage, 8619,
     /*  282139 */     GIR_EraseRootFromParent_Done,
     /*  282140 */   // Label 5310: @282140
     /*  282140 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(282203), // Rule ID 8622 //
     /*  282145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  282184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282201 */     GIR_RootConstrainSelectedInstOperands,
     /*  282202 */     // GIR_Coverage, 8622,
     /*  282202 */     GIR_EraseRootFromParent_Done,
     /*  282203 */   // Label 5311: @282203
     /*  282203 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(282266), // Rule ID 8623 //
     /*  282208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  282219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  282222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  282225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282247 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  282247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  282264 */     GIR_RootConstrainSelectedInstOperands,
     /*  282265 */     // GIR_Coverage, 8623,
     /*  282265 */     GIR_EraseRootFromParent_Done,
     /*  282266 */   // Label 5312: @282266
     /*  282266 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(282329), // Rule ID 8626 //
     /*  282271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282310 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282327 */     GIR_RootConstrainSelectedInstOperands,
     /*  282328 */     // GIR_Coverage, 8626,
     /*  282328 */     GIR_EraseRootFromParent_Done,
     /*  282329 */   // Label 5313: @282329
     /*  282329 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(282392), // Rule ID 8627 //
     /*  282334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  282348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  282351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282373 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282390 */     GIR_RootConstrainSelectedInstOperands,
     /*  282391 */     // GIR_Coverage, 8627,
     /*  282391 */     GIR_EraseRootFromParent_Done,
     /*  282392 */   // Label 5314: @282392
     /*  282392 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(282455), // Rule ID 8630 //
     /*  282397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282453 */     GIR_RootConstrainSelectedInstOperands,
     /*  282454 */     // GIR_Coverage, 8630,
     /*  282454 */     GIR_EraseRootFromParent_Done,
     /*  282455 */   // Label 5315: @282455
     /*  282455 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(282518), // Rule ID 8631 //
     /*  282460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  282474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  282477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282499 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282516 */     GIR_RootConstrainSelectedInstOperands,
     /*  282517 */     // GIR_Coverage, 8631,
     /*  282517 */     GIR_EraseRootFromParent_Done,
     /*  282518 */   // Label 5316: @282518
     /*  282518 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(282581), // Rule ID 8634 //
     /*  282523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  282526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  282537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  282540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282562 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  282562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282579 */     GIR_RootConstrainSelectedInstOperands,
     /*  282580 */     // GIR_Coverage, 8634,
     /*  282580 */     GIR_EraseRootFromParent_Done,
     /*  282581 */   // Label 5317: @282581
     /*  282581 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(282644), // Rule ID 8635 //
     /*  282586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  282589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  282597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  282600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  282603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282625 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  282625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  282642 */     GIR_RootConstrainSelectedInstOperands,
     /*  282643 */     // GIR_Coverage, 8635,
     /*  282643 */     GIR_EraseRootFromParent_Done,
     /*  282644 */   // Label 5318: @282644
     /*  282644 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(282707), // Rule ID 8638 //
     /*  282649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  282663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  282666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  282688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282705 */     GIR_RootConstrainSelectedInstOperands,
     /*  282706 */     // GIR_Coverage, 8638,
     /*  282706 */     GIR_EraseRootFromParent_Done,
     /*  282707 */   // Label 5319: @282707
     /*  282707 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(282770), // Rule ID 8639 //
     /*  282712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  282715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  282723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  282726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  282729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  282744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282751 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  282751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  282754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282768 */     GIR_RootConstrainSelectedInstOperands,
     /*  282769 */     // GIR_Coverage, 8639,
     /*  282769 */     GIR_EraseRootFromParent_Done,
     /*  282770 */   // Label 5320: @282770
     /*  282770 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(282833), // Rule ID 8642 //
     /*  282775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  282789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  282792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282814 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  282814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282831 */     GIR_RootConstrainSelectedInstOperands,
     /*  282832 */     // GIR_Coverage, 8642,
     /*  282832 */     GIR_EraseRootFromParent_Done,
     /*  282833 */   // Label 5321: @282833
     /*  282833 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(282896), // Rule ID 8643 //
     /*  282838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  282841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  282849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  282852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  282855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  282870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282877 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  282877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  282880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282894 */     GIR_RootConstrainSelectedInstOperands,
     /*  282895 */     // GIR_Coverage, 8643,
     /*  282895 */     GIR_EraseRootFromParent_Done,
     /*  282896 */   // Label 5322: @282896
     /*  282896 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(282959), // Rule ID 8646 //
     /*  282901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  282904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  282915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  282918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  282921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  282940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  282940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  282943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  282945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  282947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  282949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  282954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  282957 */     GIR_RootConstrainSelectedInstOperands,
     /*  282958 */     // GIR_Coverage, 8646,
     /*  282958 */     GIR_EraseRootFromParent_Done,
     /*  282959 */   // Label 5323: @282959
     /*  282959 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(283022), // Rule ID 8647 //
     /*  282964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  282967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  282972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  282975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  282978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  282981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  282984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  282988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  282996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283003 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  283003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  283006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283008 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  283020 */     GIR_RootConstrainSelectedInstOperands,
     /*  283021 */     // GIR_Coverage, 8647,
     /*  283021 */     GIR_EraseRootFromParent_Done,
     /*  283022 */   // Label 5324: @283022
     /*  283022 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(283085), // Rule ID 8650 //
     /*  283027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283066 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283083 */     GIR_RootConstrainSelectedInstOperands,
     /*  283084 */     // GIR_Coverage, 8650,
     /*  283084 */     GIR_EraseRootFromParent_Done,
     /*  283085 */   // Label 5325: @283085
     /*  283085 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(283148), // Rule ID 8651 //
     /*  283090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  283104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283129 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8),
     /*  283132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283146 */     GIR_RootConstrainSelectedInstOperands,
     /*  283147 */     // GIR_Coverage, 8651,
     /*  283147 */     GIR_EraseRootFromParent_Done,
     /*  283148 */   // Label 5326: @283148
     /*  283148 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(283211), // Rule ID 8654 //
     /*  283153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283209 */     GIR_RootConstrainSelectedInstOperands,
     /*  283210 */     // GIR_Coverage, 8654,
     /*  283210 */     GIR_EraseRootFromParent_Done,
     /*  283211 */   // Label 5327: @283211
     /*  283211 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(283274), // Rule ID 8655 //
     /*  283216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  283230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283255 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283272 */     GIR_RootConstrainSelectedInstOperands,
     /*  283273 */     // GIR_Coverage, 8655,
     /*  283273 */     GIR_EraseRootFromParent_Done,
     /*  283274 */   // Label 5328: @283274
     /*  283274 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(283337), // Rule ID 8658 //
     /*  283279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283318 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283335 */     GIR_RootConstrainSelectedInstOperands,
     /*  283336 */     // GIR_Coverage, 8658,
     /*  283336 */     GIR_EraseRootFromParent_Done,
     /*  283337 */   // Label 5329: @283337
     /*  283337 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(283400), // Rule ID 8659 //
     /*  283342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  283356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283381 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283386 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283398 */     GIR_RootConstrainSelectedInstOperands,
     /*  283399 */     // GIR_Coverage, 8659,
     /*  283399 */     GIR_EraseRootFromParent_Done,
     /*  283400 */   // Label 5330: @283400
     /*  283400 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(283463), // Rule ID 8662 //
     /*  283405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  283419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283461 */     GIR_RootConstrainSelectedInstOperands,
     /*  283462 */     // GIR_Coverage, 8662,
     /*  283462 */     GIR_EraseRootFromParent_Done,
     /*  283463 */   // Label 5331: @283463
     /*  283463 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(283526), // Rule ID 8663 //
     /*  283468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  283482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283507 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4),
     /*  283510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283524 */     GIR_RootConstrainSelectedInstOperands,
     /*  283525 */     // GIR_Coverage, 8663,
     /*  283525 */     GIR_EraseRootFromParent_Done,
     /*  283526 */   // Label 5332: @283526
     /*  283526 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(283589), // Rule ID 8666 //
     /*  283531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  283545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283587 */     GIR_RootConstrainSelectedInstOperands,
     /*  283588 */     // GIR_Coverage, 8666,
     /*  283588 */     GIR_EraseRootFromParent_Done,
     /*  283589 */   // Label 5333: @283589
     /*  283589 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(283652), // Rule ID 8667 //
     /*  283594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  283605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  283608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  283633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283650 */     GIR_RootConstrainSelectedInstOperands,
     /*  283651 */     // GIR_Coverage, 8667,
     /*  283651 */     GIR_EraseRootFromParent_Done,
     /*  283652 */   // Label 5334: @283652
     /*  283652 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(283715), // Rule ID 8670 //
     /*  283657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  283671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  283696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283713 */     GIR_RootConstrainSelectedInstOperands,
     /*  283714 */     // GIR_Coverage, 8670,
     /*  283714 */     GIR_EraseRootFromParent_Done,
     /*  283715 */   // Label 5335: @283715
     /*  283715 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(283778), // Rule ID 8671 //
     /*  283720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  283731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  283734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  283759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2),
     /*  283762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  283776 */     GIR_RootConstrainSelectedInstOperands,
     /*  283777 */     // GIR_Coverage, 8671,
     /*  283777 */     GIR_EraseRootFromParent_Done,
     /*  283778 */   // Label 5336: @283778
     /*  283778 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(283841), // Rule ID 8674 //
     /*  283783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  283797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283822 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  283822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  283825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283839 */     GIR_RootConstrainSelectedInstOperands,
     /*  283840 */     // GIR_Coverage, 8674,
     /*  283840 */     GIR_EraseRootFromParent_Done,
     /*  283841 */   // Label 5337: @283841
     /*  283841 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(283904), // Rule ID 8675 //
     /*  283846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  283857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  283860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283885 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  283885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  283888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  283902 */     GIR_RootConstrainSelectedInstOperands,
     /*  283903 */     // GIR_Coverage, 8675,
     /*  283903 */     GIR_EraseRootFromParent_Done,
     /*  283904 */   // Label 5338: @283904
     /*  283904 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(283967), // Rule ID 8678 //
     /*  283909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  283912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  283923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  283926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  283929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  283941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  283948 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  283948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  283951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  283953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  283955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  283957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  283962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  283965 */     GIR_RootConstrainSelectedInstOperands,
     /*  283966 */     // GIR_Coverage, 8678,
     /*  283966 */     GIR_EraseRootFromParent_Done,
     /*  283967 */   // Label 5339: @283967
     /*  283967 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(284030), // Rule ID 8679 //
     /*  283972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  283975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  283980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  283983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  283986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  283989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  283992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  283996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284011 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284028 */     GIR_RootConstrainSelectedInstOperands,
     /*  284029 */     // GIR_Coverage, 8679,
     /*  284029 */     GIR_EraseRootFromParent_Done,
     /*  284030 */   // Label 5340: @284030
     /*  284030 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(284093), // Rule ID 8682 //
     /*  284035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284074 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  284074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284091 */     GIR_RootConstrainSelectedInstOperands,
     /*  284092 */     // GIR_Coverage, 8682,
     /*  284092 */     GIR_EraseRootFromParent_Done,
     /*  284093 */   // Label 5341: @284093
     /*  284093 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(284156), // Rule ID 8683 //
     /*  284098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  284109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  284112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284137 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  284137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  284154 */     GIR_RootConstrainSelectedInstOperands,
     /*  284155 */     // GIR_Coverage, 8683,
     /*  284155 */     GIR_EraseRootFromParent_Done,
     /*  284156 */   // Label 5342: @284156
     /*  284156 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(284219), // Rule ID 8686 //
     /*  284161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  284164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  284200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284217 */     GIR_RootConstrainSelectedInstOperands,
     /*  284218 */     // GIR_Coverage, 8686,
     /*  284218 */     GIR_EraseRootFromParent_Done,
     /*  284219 */   // Label 5343: @284219
     /*  284219 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(284282), // Rule ID 8687 //
     /*  284224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  284227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  284235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  284238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284263 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11390:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  284263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1),
     /*  284266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  284280 */     GIR_RootConstrainSelectedInstOperands,
     /*  284281 */     // GIR_Coverage, 8687,
     /*  284281 */     GIR_EraseRootFromParent_Done,
     /*  284282 */   // Label 5344: @284282
     /*  284282 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(284345), // Rule ID 8690 //
     /*  284287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284326 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284343 */     GIR_RootConstrainSelectedInstOperands,
     /*  284344 */     // GIR_Coverage, 8690,
     /*  284344 */     GIR_EraseRootFromParent_Done,
     /*  284345 */   // Label 5345: @284345
     /*  284345 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(284408), // Rule ID 8691 //
     /*  284350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  284364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284389 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284406 */     GIR_RootConstrainSelectedInstOperands,
     /*  284407 */     // GIR_Coverage, 8691,
     /*  284407 */     GIR_EraseRootFromParent_Done,
     /*  284408 */   // Label 5346: @284408
     /*  284408 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(284471), // Rule ID 8694 //
     /*  284413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  284427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284452 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284469 */     GIR_RootConstrainSelectedInstOperands,
     /*  284470 */     // GIR_Coverage, 8694,
     /*  284470 */     GIR_EraseRootFromParent_Done,
     /*  284471 */   // Label 5347: @284471
     /*  284471 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(284534), // Rule ID 8695 //
     /*  284476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  284490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284515 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284532 */     GIR_RootConstrainSelectedInstOperands,
     /*  284533 */     // GIR_Coverage, 8695,
     /*  284533 */     GIR_EraseRootFromParent_Done,
     /*  284534 */   // Label 5348: @284534
     /*  284534 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(284597), // Rule ID 8698 //
     /*  284539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  284550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  284553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284578 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  284578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  284581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284595 */     GIR_RootConstrainSelectedInstOperands,
     /*  284596 */     // GIR_Coverage, 8698,
     /*  284596 */     GIR_EraseRootFromParent_Done,
     /*  284597 */   // Label 5349: @284597
     /*  284597 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(284660), // Rule ID 8699 //
     /*  284602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  284613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  284616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284641 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  284641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  284644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  284658 */     GIR_RootConstrainSelectedInstOperands,
     /*  284659 */     // GIR_Coverage, 8699,
     /*  284659 */     GIR_EraseRootFromParent_Done,
     /*  284660 */   // Label 5350: @284660
     /*  284660 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(284723), // Rule ID 8702 //
     /*  284665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  284679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284704 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284721 */     GIR_RootConstrainSelectedInstOperands,
     /*  284722 */     // GIR_Coverage, 8702,
     /*  284722 */     GIR_EraseRootFromParent_Done,
     /*  284723 */   // Label 5351: @284723
     /*  284723 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(284786), // Rule ID 8703 //
     /*  284728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  284739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  284742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  284756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284767 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  284770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284784 */     GIR_RootConstrainSelectedInstOperands,
     /*  284785 */     // GIR_Coverage, 8703,
     /*  284785 */     GIR_EraseRootFromParent_Done,
     /*  284786 */   // Label 5352: @284786
     /*  284786 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(284849), // Rule ID 8706 //
     /*  284791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  284805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284830 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284847 */     GIR_RootConstrainSelectedInstOperands,
     /*  284848 */     // GIR_Coverage, 8706,
     /*  284848 */     GIR_EraseRootFromParent_Done,
     /*  284849 */   // Label 5353: @284849
     /*  284849 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(284912), // Rule ID 8707 //
     /*  284854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  284865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  284868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  284874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  284882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284893 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  284893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  284896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284910 */     GIR_RootConstrainSelectedInstOperands,
     /*  284911 */     // GIR_Coverage, 8707,
     /*  284911 */     GIR_EraseRootFromParent_Done,
     /*  284912 */   // Label 5354: @284912
     /*  284912 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(284975), // Rule ID 8710 //
     /*  284917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  284920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  284931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  284934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  284937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  284941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  284945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  284949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  284956 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  284956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  284959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  284961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  284963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  284965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  284970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  284973 */     GIR_RootConstrainSelectedInstOperands,
     /*  284974 */     // GIR_Coverage, 8710,
     /*  284974 */     GIR_EraseRootFromParent_Done,
     /*  284975 */   // Label 5355: @284975
     /*  284975 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(285038), // Rule ID 8711 //
     /*  284980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  284983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  284988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  284991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  284994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  284997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285019 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  285019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  285036 */     GIR_RootConstrainSelectedInstOperands,
     /*  285037 */     // GIR_Coverage, 8711,
     /*  285037 */     GIR_EraseRootFromParent_Done,
     /*  285038 */   // Label 5356: @285038
     /*  285038 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(285101), // Rule ID 8714 //
     /*  285043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285099 */     GIR_RootConstrainSelectedInstOperands,
     /*  285100 */     // GIR_Coverage, 8714,
     /*  285100 */     GIR_EraseRootFromParent_Done,
     /*  285101 */   // Label 5357: @285101
     /*  285101 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(285164), // Rule ID 8715 //
     /*  285106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  285120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285145 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285162 */     GIR_RootConstrainSelectedInstOperands,
     /*  285163 */     // GIR_Coverage, 8715,
     /*  285163 */     GIR_EraseRootFromParent_Done,
     /*  285164 */   // Label 5358: @285164
     /*  285164 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(285227), // Rule ID 8718 //
     /*  285169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285208 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285225 */     GIR_RootConstrainSelectedInstOperands,
     /*  285226 */     // GIR_Coverage, 8718,
     /*  285226 */     GIR_EraseRootFromParent_Done,
     /*  285227 */   // Label 5359: @285227
     /*  285227 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(285290), // Rule ID 8719 //
     /*  285232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  285246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285271 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285288 */     GIR_RootConstrainSelectedInstOperands,
     /*  285289 */     // GIR_Coverage, 8719,
     /*  285289 */     GIR_EraseRootFromParent_Done,
     /*  285290 */   // Label 5360: @285290
     /*  285290 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(285353), // Rule ID 8722 //
     /*  285295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285334 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  285334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285351 */     GIR_RootConstrainSelectedInstOperands,
     /*  285352 */     // GIR_Coverage, 8722,
     /*  285352 */     GIR_EraseRootFromParent_Done,
     /*  285353 */   // Label 5361: @285353
     /*  285353 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(285416), // Rule ID 8723 //
     /*  285358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  285369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  285372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285397 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  285397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  285414 */     GIR_RootConstrainSelectedInstOperands,
     /*  285415 */     // GIR_Coverage, 8723,
     /*  285415 */     GIR_EraseRootFromParent_Done,
     /*  285416 */   // Label 5362: @285416
     /*  285416 */   GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(285479), // Rule ID 8726 //
     /*  285421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  285435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285477 */     GIR_RootConstrainSelectedInstOperands,
     /*  285478 */     // GIR_Coverage, 8726,
     /*  285478 */     GIR_EraseRootFromParent_Done,
     /*  285479 */   // Label 5363: @285479
     /*  285479 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(285542), // Rule ID 8727 //
     /*  285484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  285498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  285512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285523 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11390:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2),
     /*  285526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285540 */     GIR_RootConstrainSelectedInstOperands,
     /*  285541 */     // GIR_Coverage, 8727,
     /*  285541 */     GIR_EraseRootFromParent_Done,
     /*  285542 */   // Label 5364: @285542
     /*  285542 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(285605), // Rule ID 8730 //
     /*  285547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  285561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285586 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285603 */     GIR_RootConstrainSelectedInstOperands,
     /*  285604 */     // GIR_Coverage, 8730,
     /*  285604 */     GIR_EraseRootFromParent_Done,
     /*  285605 */   // Label 5365: @285605
     /*  285605 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(285668), // Rule ID 8731 //
     /*  285610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  285621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  285624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  285638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285649 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11390:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4),
     /*  285652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285666 */     GIR_RootConstrainSelectedInstOperands,
     /*  285667 */     // GIR_Coverage, 8731,
     /*  285667 */     GIR_EraseRootFromParent_Done,
     /*  285668 */   // Label 5366: @285668
     /*  285668 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(285731), // Rule ID 8734 //
     /*  285673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  285676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  285687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  285690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285712 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  285712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285729 */     GIR_RootConstrainSelectedInstOperands,
     /*  285730 */     // GIR_Coverage, 8734,
     /*  285730 */     GIR_EraseRootFromParent_Done,
     /*  285731 */   // Label 5367: @285731
     /*  285731 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(285794), // Rule ID 8735 //
     /*  285736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  285739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu),
     /*  285744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  285747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  285750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  285753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  285764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  285768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285775 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11390:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  285775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8),
     /*  285778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  285792 */     GIR_RootConstrainSelectedInstOperands,
     /*  285793 */     // GIR_Coverage, 8735,
     /*  285793 */     GIR_EraseRootFromParent_Done,
     /*  285794 */   // Label 5368: @285794
     /*  285794 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(285857), // Rule ID 8826 //
     /*  285799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  285807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  285813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  285816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285838 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  285841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285855 */     GIR_RootConstrainSelectedInstOperands,
     /*  285856 */     // GIR_Coverage, 8826,
     /*  285856 */     GIR_EraseRootFromParent_Done,
     /*  285857 */   // Label 5369: @285857
     /*  285857 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(285920), // Rule ID 8827 //
     /*  285862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  285870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  285873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  285876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  285879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  285882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285901 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  285901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  285904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285918 */     GIR_RootConstrainSelectedInstOperands,
     /*  285919 */     // GIR_Coverage, 8827,
     /*  285919 */     GIR_EraseRootFromParent_Done,
     /*  285920 */   // Label 5370: @285920
     /*  285920 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(285983), // Rule ID 8830 //
     /*  285925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  285928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  285933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  285939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  285942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  285945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  285957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  285964 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  285964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  285967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  285969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  285971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  285973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  285978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  285981 */     GIR_RootConstrainSelectedInstOperands,
     /*  285982 */     // GIR_Coverage, 8830,
     /*  285982 */     GIR_EraseRootFromParent_Done,
     /*  285983 */   // Label 5371: @285983
     /*  285983 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(286046), // Rule ID 8831 //
     /*  285988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  285991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  285996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  285999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  286002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  286005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286027 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286044 */     GIR_RootConstrainSelectedInstOperands,
     /*  286045 */     // GIR_Coverage, 8831,
     /*  286045 */     GIR_EraseRootFromParent_Done,
     /*  286046 */   // Label 5372: @286046
     /*  286046 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(286109), // Rule ID 8834 //
     /*  286051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286090 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286107 */     GIR_RootConstrainSelectedInstOperands,
     /*  286108 */     // GIR_Coverage, 8834,
     /*  286108 */     GIR_EraseRootFromParent_Done,
     /*  286109 */   // Label 5373: @286109
     /*  286109 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(286172), // Rule ID 8835 //
     /*  286114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  286128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  286131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286153 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286170 */     GIR_RootConstrainSelectedInstOperands,
     /*  286171 */     // GIR_Coverage, 8835,
     /*  286171 */     GIR_EraseRootFromParent_Done,
     /*  286172 */   // Label 5374: @286172
     /*  286172 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(286235), // Rule ID 8838 //
     /*  286177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286216 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286233 */     GIR_RootConstrainSelectedInstOperands,
     /*  286234 */     // GIR_Coverage, 8838,
     /*  286234 */     GIR_EraseRootFromParent_Done,
     /*  286235 */   // Label 5375: @286235
     /*  286235 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(286298), // Rule ID 8839 //
     /*  286240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  286254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  286257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286279 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  286282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286296 */     GIR_RootConstrainSelectedInstOperands,
     /*  286297 */     // GIR_Coverage, 8839,
     /*  286297 */     GIR_EraseRootFromParent_Done,
     /*  286298 */   // Label 5376: @286298
     /*  286298 */   GIM_Try, /*On fail goto*//*Label 5377*/ GIMT_Encode4(286361), // Rule ID 8842 //
     /*  286303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286342 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286359 */     GIR_RootConstrainSelectedInstOperands,
     /*  286360 */     // GIR_Coverage, 8842,
     /*  286360 */     GIR_EraseRootFromParent_Done,
     /*  286361 */   // Label 5377: @286361
     /*  286361 */   GIM_Try, /*On fail goto*//*Label 5378*/ GIMT_Encode4(286424), // Rule ID 8843 //
     /*  286366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  286380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  286383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286405 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286422 */     GIR_RootConstrainSelectedInstOperands,
     /*  286423 */     // GIR_Coverage, 8843,
     /*  286423 */     GIR_EraseRootFromParent_Done,
     /*  286424 */   // Label 5378: @286424
     /*  286424 */   GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(286487), // Rule ID 8846 //
     /*  286429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  286443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  286446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286485 */     GIR_RootConstrainSelectedInstOperands,
     /*  286486 */     // GIR_Coverage, 8846,
     /*  286486 */     GIR_EraseRootFromParent_Done,
     /*  286487 */   // Label 5379: @286487
     /*  286487 */   GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(286550), // Rule ID 8847 //
     /*  286492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  286506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  286509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286531 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  286534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286548 */     GIR_RootConstrainSelectedInstOperands,
     /*  286549 */     // GIR_Coverage, 8847,
     /*  286549 */     GIR_EraseRootFromParent_Done,
     /*  286550 */   // Label 5380: @286550
     /*  286550 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(286613), // Rule ID 8850 //
     /*  286555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  286569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  286572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286594 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  286594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286611 */     GIR_RootConstrainSelectedInstOperands,
     /*  286612 */     // GIR_Coverage, 8850,
     /*  286612 */     GIR_EraseRootFromParent_Done,
     /*  286613 */   // Label 5381: @286613
     /*  286613 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(286676), // Rule ID 8851 //
     /*  286618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  286629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  286632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  286635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286657 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  286657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  286674 */     GIR_RootConstrainSelectedInstOperands,
     /*  286675 */     // GIR_Coverage, 8851,
     /*  286675 */     GIR_EraseRootFromParent_Done,
     /*  286676 */   // Label 5382: @286676
     /*  286676 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(286739), // Rule ID 8854 //
     /*  286681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  286695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  286698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  286720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286737 */     GIR_RootConstrainSelectedInstOperands,
     /*  286738 */     // GIR_Coverage, 8854,
     /*  286738 */     GIR_EraseRootFromParent_Done,
     /*  286739 */   // Label 5383: @286739
     /*  286739 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(286802), // Rule ID 8855 //
     /*  286744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  286755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  286758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  286761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286783 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  286783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  286800 */     GIR_RootConstrainSelectedInstOperands,
     /*  286801 */     // GIR_Coverage, 8855,
     /*  286801 */     GIR_EraseRootFromParent_Done,
     /*  286802 */   // Label 5384: @286802
     /*  286802 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(286865), // Rule ID 8858 //
     /*  286807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  286810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  286821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  286824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286846 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  286846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286863 */     GIR_RootConstrainSelectedInstOperands,
     /*  286864 */     // GIR_Coverage, 8858,
     /*  286864 */     GIR_EraseRootFromParent_Done,
     /*  286865 */   // Label 5385: @286865
     /*  286865 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(286928), // Rule ID 8859 //
     /*  286870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  286873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  286881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  286884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  286887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  286890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286909 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  286909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  286926 */     GIR_RootConstrainSelectedInstOperands,
     /*  286927 */     // GIR_Coverage, 8859,
     /*  286927 */     GIR_EraseRootFromParent_Done,
     /*  286928 */   // Label 5386: @286928
     /*  286928 */   GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(286991), // Rule ID 8862 //
     /*  286933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  286936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  286941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  286944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  286947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  286950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  286953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  286965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  286972 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  286972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  286975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  286977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  286979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  286981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  286986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  286989 */     GIR_RootConstrainSelectedInstOperands,
     /*  286990 */     // GIR_Coverage, 8862,
     /*  286990 */     GIR_EraseRootFromParent_Done,
     /*  286991 */   // Label 5387: @286991
     /*  286991 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(287054), // Rule ID 8863 //
     /*  286996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  286999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  287007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  287010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  287013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287035 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  287035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  287038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  287052 */     GIR_RootConstrainSelectedInstOperands,
     /*  287053 */     // GIR_Coverage, 8863,
     /*  287053 */     GIR_EraseRootFromParent_Done,
     /*  287054 */   // Label 5388: @287054
     /*  287054 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(287117), // Rule ID 8866 //
     /*  287059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287098 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287115 */     GIR_RootConstrainSelectedInstOperands,
     /*  287116 */     // GIR_Coverage, 8866,
     /*  287116 */     GIR_EraseRootFromParent_Done,
     /*  287117 */   // Label 5389: @287117
     /*  287117 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(287180), // Rule ID 8867 //
     /*  287122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  287136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  287139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287161 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287178 */     GIR_RootConstrainSelectedInstOperands,
     /*  287179 */     // GIR_Coverage, 8867,
     /*  287179 */     GIR_EraseRootFromParent_Done,
     /*  287180 */   // Label 5390: @287180
     /*  287180 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(287243), // Rule ID 8870 //
     /*  287185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287224 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287241 */     GIR_RootConstrainSelectedInstOperands,
     /*  287242 */     // GIR_Coverage, 8870,
     /*  287242 */     GIR_EraseRootFromParent_Done,
     /*  287243 */   // Label 5391: @287243
     /*  287243 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(287306), // Rule ID 8871 //
     /*  287248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  287262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  287265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287287 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287304 */     GIR_RootConstrainSelectedInstOperands,
     /*  287305 */     // GIR_Coverage, 8871,
     /*  287305 */     GIR_EraseRootFromParent_Done,
     /*  287306 */   // Label 5392: @287306
     /*  287306 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(287369), // Rule ID 8874 //
     /*  287311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287350 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  287350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287367 */     GIR_RootConstrainSelectedInstOperands,
     /*  287368 */     // GIR_Coverage, 8874,
     /*  287368 */     GIR_EraseRootFromParent_Done,
     /*  287369 */   // Label 5393: @287369
     /*  287369 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(287432), // Rule ID 8875 //
     /*  287374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  287385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  287388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  287391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287413 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  287413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  287430 */     GIR_RootConstrainSelectedInstOperands,
     /*  287431 */     // GIR_Coverage, 8875,
     /*  287431 */     GIR_EraseRootFromParent_Done,
     /*  287432 */   // Label 5394: @287432
     /*  287432 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(287495), // Rule ID 8878 //
     /*  287437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  287451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  287454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287476 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287493 */     GIR_RootConstrainSelectedInstOperands,
     /*  287494 */     // GIR_Coverage, 8878,
     /*  287494 */     GIR_EraseRootFromParent_Done,
     /*  287495 */   // Label 5395: @287495
     /*  287495 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(287558), // Rule ID 8879 //
     /*  287500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  287514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  287517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287539 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287556 */     GIR_RootConstrainSelectedInstOperands,
     /*  287557 */     // GIR_Coverage, 8879,
     /*  287557 */     GIR_EraseRootFromParent_Done,
     /*  287558 */   // Label 5396: @287558
     /*  287558 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(287621), // Rule ID 8882 //
     /*  287563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  287577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  287580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287602 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287619 */     GIR_RootConstrainSelectedInstOperands,
     /*  287620 */     // GIR_Coverage, 8882,
     /*  287620 */     GIR_EraseRootFromParent_Done,
     /*  287621 */   // Label 5397: @287621
     /*  287621 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(287684), // Rule ID 8883 //
     /*  287626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  287637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  287640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  287643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287665 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287682 */     GIR_RootConstrainSelectedInstOperands,
     /*  287683 */     // GIR_Coverage, 8883,
     /*  287683 */     GIR_EraseRootFromParent_Done,
     /*  287684 */   // Label 5398: @287684
     /*  287684 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(287747), // Rule ID 8886 //
     /*  287689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  287703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  287706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287728 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  287728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287745 */     GIR_RootConstrainSelectedInstOperands,
     /*  287746 */     // GIR_Coverage, 8886,
     /*  287746 */     GIR_EraseRootFromParent_Done,
     /*  287747 */   // Label 5399: @287747
     /*  287747 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(287810), // Rule ID 8887 //
     /*  287752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  287763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  287766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  287769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  287784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287791 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  287791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  287794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  287808 */     GIR_RootConstrainSelectedInstOperands,
     /*  287809 */     // GIR_Coverage, 8887,
     /*  287809 */     GIR_EraseRootFromParent_Done,
     /*  287810 */   // Label 5400: @287810
     /*  287810 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(287873), // Rule ID 8890 //
     /*  287815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  287829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  287832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287854 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287871 */     GIR_RootConstrainSelectedInstOperands,
     /*  287872 */     // GIR_Coverage, 8890,
     /*  287872 */     GIR_EraseRootFromParent_Done,
     /*  287873 */   // Label 5401: @287873
     /*  287873 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(287936), // Rule ID 8891 //
     /*  287878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  287881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  287889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  287892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  287895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  287898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  287910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287917 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  287917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  287920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287934 */     GIR_RootConstrainSelectedInstOperands,
     /*  287935 */     // GIR_Coverage, 8891,
     /*  287935 */     GIR_EraseRootFromParent_Done,
     /*  287936 */   // Label 5402: @287936
     /*  287936 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(287999), // Rule ID 8894 //
     /*  287941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  287944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  287949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  287952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  287955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  287958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  287961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  287965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  287973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  287980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  287980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  287983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  287985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  287987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  287989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  287994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  287997 */     GIR_RootConstrainSelectedInstOperands,
     /*  287998 */     // GIR_Coverage, 8894,
     /*  287998 */     GIR_EraseRootFromParent_Done,
     /*  287999 */   // Label 5403: @287999
     /*  287999 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(288062), // Rule ID 8895 //
     /*  288004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  288018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  288021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288043 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288060 */     GIR_RootConstrainSelectedInstOperands,
     /*  288061 */     // GIR_Coverage, 8895,
     /*  288061 */     GIR_EraseRootFromParent_Done,
     /*  288062 */   // Label 5404: @288062
     /*  288062 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(288125), // Rule ID 8898 //
     /*  288067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288106 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  288106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288123 */     GIR_RootConstrainSelectedInstOperands,
     /*  288124 */     // GIR_Coverage, 8898,
     /*  288124 */     GIR_EraseRootFromParent_Done,
     /*  288125 */   // Label 5405: @288125
     /*  288125 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(288188), // Rule ID 8899 //
     /*  288130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  288141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  288144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  288147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288169 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  288169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  288186 */     GIR_RootConstrainSelectedInstOperands,
     /*  288187 */     // GIR_Coverage, 8899,
     /*  288187 */     GIR_EraseRootFromParent_Done,
     /*  288188 */   // Label 5406: @288188
     /*  288188 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(288251), // Rule ID 8902 //
     /*  288193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288232 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288249 */     GIR_RootConstrainSelectedInstOperands,
     /*  288250 */     // GIR_Coverage, 8902,
     /*  288250 */     GIR_EraseRootFromParent_Done,
     /*  288251 */   // Label 5407: @288251
     /*  288251 */   GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(288314), // Rule ID 8903 //
     /*  288256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  288270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  288273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  288288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288295 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  288298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288312 */     GIR_RootConstrainSelectedInstOperands,
     /*  288313 */     // GIR_Coverage, 8903,
     /*  288313 */     GIR_EraseRootFromParent_Done,
     /*  288314 */   // Label 5408: @288314
     /*  288314 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(288377), // Rule ID 8906 //
     /*  288319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288358 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288375 */     GIR_RootConstrainSelectedInstOperands,
     /*  288376 */     // GIR_Coverage, 8906,
     /*  288376 */     GIR_EraseRootFromParent_Done,
     /*  288377 */   // Label 5409: @288377
     /*  288377 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(288440), // Rule ID 8907 //
     /*  288382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  288396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  288399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  288414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288421 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  288424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288438 */     GIR_RootConstrainSelectedInstOperands,
     /*  288439 */     // GIR_Coverage, 8907,
     /*  288439 */     GIR_EraseRootFromParent_Done,
     /*  288440 */   // Label 5410: @288440
     /*  288440 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(288503), // Rule ID 8910 //
     /*  288445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  288448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  288459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  288462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288484 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  288484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288501 */     GIR_RootConstrainSelectedInstOperands,
     /*  288502 */     // GIR_Coverage, 8910,
     /*  288502 */     GIR_EraseRootFromParent_Done,
     /*  288503 */   // Label 5411: @288503
     /*  288503 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(288566), // Rule ID 8911 //
     /*  288508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  288511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  288519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  288522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  288525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  288540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288547 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  288547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  288550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  288564 */     GIR_RootConstrainSelectedInstOperands,
     /*  288565 */     // GIR_Coverage, 8911,
     /*  288565 */     GIR_EraseRootFromParent_Done,
     /*  288566 */   // Label 5412: @288566
     /*  288566 */   GIM_Try, /*On fail goto*//*Label 5413*/ GIMT_Encode4(288629), // Rule ID 8914 //
     /*  288571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  288585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288610 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  288613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288627 */     GIR_RootConstrainSelectedInstOperands,
     /*  288628 */     // GIR_Coverage, 8914,
     /*  288628 */     GIR_EraseRootFromParent_Done,
     /*  288629 */   // Label 5413: @288629
     /*  288629 */   GIM_Try, /*On fail goto*//*Label 5414*/ GIMT_Encode4(288692), // Rule ID 8915 //
     /*  288634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  288648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288673 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8),
     /*  288676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288690 */     GIR_RootConstrainSelectedInstOperands,
     /*  288691 */     // GIR_Coverage, 8915,
     /*  288691 */     GIR_EraseRootFromParent_Done,
     /*  288692 */   // Label 5414: @288692
     /*  288692 */   GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(288755), // Rule ID 8918 //
     /*  288697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  288711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288736 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  288739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288753 */     GIR_RootConstrainSelectedInstOperands,
     /*  288754 */     // GIR_Coverage, 8918,
     /*  288754 */     GIR_EraseRootFromParent_Done,
     /*  288755 */   // Label 5415: @288755
     /*  288755 */   GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(288818), // Rule ID 8919 //
     /*  288760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  288771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  288774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288799 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  288802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288816 */     GIR_RootConstrainSelectedInstOperands,
     /*  288817 */     // GIR_Coverage, 8919,
     /*  288817 */     GIR_EraseRootFromParent_Done,
     /*  288818 */   // Label 5416: @288818
     /*  288818 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(288881), // Rule ID 8922 //
     /*  288823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  288837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  288862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  288865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288879 */     GIR_RootConstrainSelectedInstOperands,
     /*  288880 */     // GIR_Coverage, 8922,
     /*  288880 */     GIR_EraseRootFromParent_Done,
     /*  288881 */   // Label 5417: @288881
     /*  288881 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(288944), // Rule ID 8923 //
     /*  288886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  288889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  288897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  288900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  288903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  288906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288925 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  288925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  288928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  288939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  288942 */     GIR_RootConstrainSelectedInstOperands,
     /*  288943 */     // GIR_Coverage, 8923,
     /*  288943 */     GIR_EraseRootFromParent_Done,
     /*  288944 */   // Label 5418: @288944
     /*  288944 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(289007), // Rule ID 8926 //
     /*  288949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  288952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  288957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  288960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  288963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  288966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  288969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  288977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  288981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  288988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  288988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  288991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  288993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  288995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  288997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289005 */     GIR_RootConstrainSelectedInstOperands,
     /*  289006 */     // GIR_Coverage, 8926,
     /*  289006 */     GIR_EraseRootFromParent_Done,
     /*  289007 */   // Label 5419: @289007
     /*  289007 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(289070), // Rule ID 8927 //
     /*  289012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  289026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289051 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4),
     /*  289054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289068 */     GIR_RootConstrainSelectedInstOperands,
     /*  289069 */     // GIR_Coverage, 8927,
     /*  289069 */     GIR_EraseRootFromParent_Done,
     /*  289070 */   // Label 5420: @289070
     /*  289070 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(289133), // Rule ID 8930 //
     /*  289075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289114 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289131 */     GIR_RootConstrainSelectedInstOperands,
     /*  289132 */     // GIR_Coverage, 8930,
     /*  289132 */     GIR_EraseRootFromParent_Done,
     /*  289133 */   // Label 5421: @289133
     /*  289133 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(289196), // Rule ID 8931 //
     /*  289138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  289152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289177 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289194 */     GIR_RootConstrainSelectedInstOperands,
     /*  289195 */     // GIR_Coverage, 8931,
     /*  289195 */     GIR_EraseRootFromParent_Done,
     /*  289196 */   // Label 5422: @289196
     /*  289196 */   GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(289259), // Rule ID 8934 //
     /*  289201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289257 */     GIR_RootConstrainSelectedInstOperands,
     /*  289258 */     // GIR_Coverage, 8934,
     /*  289258 */     GIR_EraseRootFromParent_Done,
     /*  289259 */   // Label 5423: @289259
     /*  289259 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(289322), // Rule ID 8935 //
     /*  289264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  289278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289303 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2),
     /*  289306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289320 */     GIR_RootConstrainSelectedInstOperands,
     /*  289321 */     // GIR_Coverage, 8935,
     /*  289321 */     GIR_EraseRootFromParent_Done,
     /*  289322 */   // Label 5424: @289322
     /*  289322 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(289385), // Rule ID 8938 //
     /*  289327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289366 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289383 */     GIR_RootConstrainSelectedInstOperands,
     /*  289384 */     // GIR_Coverage, 8938,
     /*  289384 */     GIR_EraseRootFromParent_Done,
     /*  289385 */   // Label 5425: @289385
     /*  289385 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(289448), // Rule ID 8939 //
     /*  289390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  289401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  289404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289429 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289446 */     GIR_RootConstrainSelectedInstOperands,
     /*  289447 */     // GIR_Coverage, 8939,
     /*  289447 */     GIR_EraseRootFromParent_Done,
     /*  289448 */   // Label 5426: @289448
     /*  289448 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(289511), // Rule ID 8942 //
     /*  289453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  289467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  289492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289509 */     GIR_RootConstrainSelectedInstOperands,
     /*  289510 */     // GIR_Coverage, 8942,
     /*  289510 */     GIR_EraseRootFromParent_Done,
     /*  289511 */   // Label 5427: @289511
     /*  289511 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(289574), // Rule ID 8943 //
     /*  289516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  289527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  289530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  289555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  289572 */     GIR_RootConstrainSelectedInstOperands,
     /*  289573 */     // GIR_Coverage, 8943,
     /*  289573 */     GIR_EraseRootFromParent_Done,
     /*  289574 */   // Label 5428: @289574
     /*  289574 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(289637), // Rule ID 8946 //
     /*  289579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  289593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289618 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  289618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289635 */     GIR_RootConstrainSelectedInstOperands,
     /*  289636 */     // GIR_Coverage, 8946,
     /*  289636 */     GIR_EraseRootFromParent_Done,
     /*  289637 */   // Label 5429: @289637
     /*  289637 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(289700), // Rule ID 8947 //
     /*  289642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  289653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  289656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289681 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  289681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  289698 */     GIR_RootConstrainSelectedInstOperands,
     /*  289699 */     // GIR_Coverage, 8947,
     /*  289699 */     GIR_EraseRootFromParent_Done,
     /*  289700 */   // Label 5430: @289700
     /*  289700 */   GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(289763), // Rule ID 8950 //
     /*  289705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  289708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  289719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  289744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289761 */     GIR_RootConstrainSelectedInstOperands,
     /*  289762 */     // GIR_Coverage, 8950,
     /*  289762 */     GIR_EraseRootFromParent_Done,
     /*  289763 */   // Label 5431: @289763
     /*  289763 */   GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(289826), // Rule ID 8951 //
     /*  289768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  289771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  289779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  289782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289807 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11388:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  289807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1),
     /*  289810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  289824 */     GIR_RootConstrainSelectedInstOperands,
     /*  289825 */     // GIR_Coverage, 8951,
     /*  289825 */     GIR_EraseRootFromParent_Done,
     /*  289826 */   // Label 5432: @289826
     /*  289826 */   GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(289889), // Rule ID 8954 //
     /*  289831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  289845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289870 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  289873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289887 */     GIR_RootConstrainSelectedInstOperands,
     /*  289888 */     // GIR_Coverage, 8954,
     /*  289888 */     GIR_EraseRootFromParent_Done,
     /*  289889 */   // Label 5433: @289889
     /*  289889 */   GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(289952), // Rule ID 8955 //
     /*  289894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  289897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  289905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  289908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  289911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  289914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  289922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289933 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  289933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  289936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  289938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  289940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  289942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  289947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  289950 */     GIR_RootConstrainSelectedInstOperands,
     /*  289951 */     // GIR_Coverage, 8955,
     /*  289951 */     GIR_EraseRootFromParent_Done,
     /*  289952 */   // Label 5434: @289952
     /*  289952 */   GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(290015), // Rule ID 8958 //
     /*  289957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  289960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  289965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  289968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  289971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  289974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  289977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  289981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  289985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  289989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  289996 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  289996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  289999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290013 */     GIR_RootConstrainSelectedInstOperands,
     /*  290014 */     // GIR_Coverage, 8958,
     /*  290014 */     GIR_EraseRootFromParent_Done,
     /*  290015 */   // Label 5435: @290015
     /*  290015 */   GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(290078), // Rule ID 8959 //
     /*  290020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  290034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290059 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290076 */     GIR_RootConstrainSelectedInstOperands,
     /*  290077 */     // GIR_Coverage, 8959,
     /*  290077 */     GIR_EraseRootFromParent_Done,
     /*  290078 */   // Label 5436: @290078
     /*  290078 */   GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(290141), // Rule ID 8962 //
     /*  290083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290122 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  290122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290139 */     GIR_RootConstrainSelectedInstOperands,
     /*  290140 */     // GIR_Coverage, 8962,
     /*  290140 */     GIR_EraseRootFromParent_Done,
     /*  290141 */   // Label 5437: @290141
     /*  290141 */   GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(290204), // Rule ID 8963 //
     /*  290146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  290157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  290160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290185 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  290185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  290202 */     GIR_RootConstrainSelectedInstOperands,
     /*  290203 */     // GIR_Coverage, 8963,
     /*  290203 */     GIR_EraseRootFromParent_Done,
     /*  290204 */   // Label 5438: @290204
     /*  290204 */   GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(290267), // Rule ID 8966 //
     /*  290209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290265 */     GIR_RootConstrainSelectedInstOperands,
     /*  290266 */     // GIR_Coverage, 8966,
     /*  290266 */     GIR_EraseRootFromParent_Done,
     /*  290267 */   // Label 5439: @290267
     /*  290267 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(290330), // Rule ID 8967 //
     /*  290272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  290286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290311 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290328 */     GIR_RootConstrainSelectedInstOperands,
     /*  290329 */     // GIR_Coverage, 8967,
     /*  290329 */     GIR_EraseRootFromParent_Done,
     /*  290330 */   // Label 5440: @290330
     /*  290330 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(290393), // Rule ID 8970 //
     /*  290335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290374 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290391 */     GIR_RootConstrainSelectedInstOperands,
     /*  290392 */     // GIR_Coverage, 8970,
     /*  290392 */     GIR_EraseRootFromParent_Done,
     /*  290393 */   // Label 5441: @290393
     /*  290393 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(290456), // Rule ID 8971 //
     /*  290398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  290412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290437 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290454 */     GIR_RootConstrainSelectedInstOperands,
     /*  290455 */     // GIR_Coverage, 8971,
     /*  290455 */     GIR_EraseRootFromParent_Done,
     /*  290456 */   // Label 5442: @290456
     /*  290456 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(290519), // Rule ID 8974 //
     /*  290461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  290475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290500 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  290500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290517 */     GIR_RootConstrainSelectedInstOperands,
     /*  290518 */     // GIR_Coverage, 8974,
     /*  290518 */     GIR_EraseRootFromParent_Done,
     /*  290519 */   // Label 5443: @290519
     /*  290519 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(290582), // Rule ID 8975 //
     /*  290524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  290535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  290538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290563 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  290563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  290580 */     GIR_RootConstrainSelectedInstOperands,
     /*  290581 */     // GIR_Coverage, 8975,
     /*  290581 */     GIR_EraseRootFromParent_Done,
     /*  290582 */   // Label 5444: @290582
     /*  290582 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(290645), // Rule ID 8978 //
     /*  290587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  290601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290626 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290643 */     GIR_RootConstrainSelectedInstOperands,
     /*  290644 */     // GIR_Coverage, 8978,
     /*  290644 */     GIR_EraseRootFromParent_Done,
     /*  290645 */   // Label 5445: @290645
     /*  290645 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(290708), // Rule ID 8979 //
     /*  290650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  290661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  290664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290689 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  290692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290706 */     GIR_RootConstrainSelectedInstOperands,
     /*  290707 */     // GIR_Coverage, 8979,
     /*  290707 */     GIR_EraseRootFromParent_Done,
     /*  290708 */   // Label 5446: @290708
     /*  290708 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(290771), // Rule ID 8982 //
     /*  290713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  290727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290752 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290769 */     GIR_RootConstrainSelectedInstOperands,
     /*  290770 */     // GIR_Coverage, 8982,
     /*  290770 */     GIR_EraseRootFromParent_Done,
     /*  290771 */   // Label 5447: @290771
     /*  290771 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(290834), // Rule ID 8983 //
     /*  290776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  290787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  290790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  290804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290815 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  290818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290832 */     GIR_RootConstrainSelectedInstOperands,
     /*  290833 */     // GIR_Coverage, 8983,
     /*  290833 */     GIR_EraseRootFromParent_Done,
     /*  290834 */   // Label 5448: @290834
     /*  290834 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(290897), // Rule ID 8986 //
     /*  290839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  290842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  290853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290878 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  290878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290895 */     GIR_RootConstrainSelectedInstOperands,
     /*  290896 */     // GIR_Coverage, 8986,
     /*  290896 */     GIR_EraseRootFromParent_Done,
     /*  290897 */   // Label 5449: @290897
     /*  290897 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(290960), // Rule ID 8987 //
     /*  290902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  290905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  290913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  290916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  290919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  290922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  290930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  290941 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  290941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  290944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  290946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  290948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  290950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  290955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  290958 */     GIR_RootConstrainSelectedInstOperands,
     /*  290959 */     // GIR_Coverage, 8987,
     /*  290959 */     GIR_EraseRootFromParent_Done,
     /*  290960 */   // Label 5450: @290960
     /*  290960 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(291023), // Rule ID 8990 //
     /*  290965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  290968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  290973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  290976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  290979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  290982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  290985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  290989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  290993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  290997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291021 */     GIR_RootConstrainSelectedInstOperands,
     /*  291022 */     // GIR_Coverage, 8990,
     /*  291022 */     GIR_EraseRootFromParent_Done,
     /*  291023 */   // Label 5451: @291023
     /*  291023 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(291086), // Rule ID 8991 //
     /*  291028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  291042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  291056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291067 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11388:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2),
     /*  291070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291084 */     GIR_RootConstrainSelectedInstOperands,
     /*  291085 */     // GIR_Coverage, 8991,
     /*  291085 */     GIR_EraseRootFromParent_Done,
     /*  291086 */   // Label 5452: @291086
     /*  291086 */   GIM_Try, /*On fail goto*//*Label 5453*/ GIMT_Encode4(291149), // Rule ID 8994 //
     /*  291091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291130 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291147 */     GIR_RootConstrainSelectedInstOperands,
     /*  291148 */     // GIR_Coverage, 8994,
     /*  291148 */     GIR_EraseRootFromParent_Done,
     /*  291149 */   // Label 5453: @291149
     /*  291149 */   GIM_Try, /*On fail goto*//*Label 5454*/ GIMT_Encode4(291212), // Rule ID 8995 //
     /*  291154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  291168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  291182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291193 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11388:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4),
     /*  291196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291210 */     GIR_RootConstrainSelectedInstOperands,
     /*  291211 */     // GIR_Coverage, 8995,
     /*  291211 */     GIR_EraseRootFromParent_Done,
     /*  291212 */   // Label 5454: @291212
     /*  291212 */   GIM_Try, /*On fail goto*//*Label 5455*/ GIMT_Encode4(291275), // Rule ID 8998 //
     /*  291217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  291220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291256 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  291256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291273 */     GIR_RootConstrainSelectedInstOperands,
     /*  291274 */     // GIR_Coverage, 8998,
     /*  291274 */     GIR_EraseRootFromParent_Done,
     /*  291275 */   // Label 5455: @291275
     /*  291275 */   GIM_Try, /*On fail goto*//*Label 5456*/ GIMT_Encode4(291338), // Rule ID 8999 //
     /*  291280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  291283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle),
     /*  291288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  291291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  291294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  291308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291319 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11388:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  291319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8),
     /*  291322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  291336 */     GIR_RootConstrainSelectedInstOperands,
     /*  291337 */     // GIR_Coverage, 8999,
     /*  291337 */     GIR_EraseRootFromParent_Done,
     /*  291338 */   // Label 5456: @291338
     /*  291338 */   GIM_Try, /*On fail goto*//*Label 5457*/ GIMT_Encode4(291401), // Rule ID 9090 //
     /*  291343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291382 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291399 */     GIR_RootConstrainSelectedInstOperands,
     /*  291400 */     // GIR_Coverage, 9090,
     /*  291400 */     GIR_EraseRootFromParent_Done,
     /*  291401 */   // Label 5457: @291401
     /*  291401 */   GIM_Try, /*On fail goto*//*Label 5458*/ GIMT_Encode4(291464), // Rule ID 9091 //
     /*  291406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  291420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8),
     /*  291448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291462 */     GIR_RootConstrainSelectedInstOperands,
     /*  291463 */     // GIR_Coverage, 9091,
     /*  291463 */     GIR_EraseRootFromParent_Done,
     /*  291464 */   // Label 5458: @291464
     /*  291464 */   GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(291527), // Rule ID 9094 //
     /*  291469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  291483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291508 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  291511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291525 */     GIR_RootConstrainSelectedInstOperands,
     /*  291526 */     // GIR_Coverage, 9094,
     /*  291526 */     GIR_EraseRootFromParent_Done,
     /*  291527 */   // Label 5459: @291527
     /*  291527 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(291590), // Rule ID 9095 //
     /*  291532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  291546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291571 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  291574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291588 */     GIR_RootConstrainSelectedInstOperands,
     /*  291589 */     // GIR_Coverage, 9095,
     /*  291589 */     GIR_EraseRootFromParent_Done,
     /*  291590 */   // Label 5460: @291590
     /*  291590 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(291653), // Rule ID 9098 //
     /*  291595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  291609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291634 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  291634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  291637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291651 */     GIR_RootConstrainSelectedInstOperands,
     /*  291652 */     // GIR_Coverage, 9098,
     /*  291652 */     GIR_EraseRootFromParent_Done,
     /*  291653 */   // Label 5461: @291653
     /*  291653 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(291716), // Rule ID 9099 //
     /*  291658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  291669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  291672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291697 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  291697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  291700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  291714 */     GIR_RootConstrainSelectedInstOperands,
     /*  291715 */     // GIR_Coverage, 9099,
     /*  291715 */     GIR_EraseRootFromParent_Done,
     /*  291716 */   // Label 5462: @291716
     /*  291716 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(291779), // Rule ID 9102 //
     /*  291721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  291735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  291763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291777 */     GIR_RootConstrainSelectedInstOperands,
     /*  291778 */     // GIR_Coverage, 9102,
     /*  291778 */     GIR_EraseRootFromParent_Done,
     /*  291779 */   // Label 5463: @291779
     /*  291779 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(291842), // Rule ID 9103 //
     /*  291784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  291798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291823 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4),
     /*  291826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291840 */     GIR_RootConstrainSelectedInstOperands,
     /*  291841 */     // GIR_Coverage, 9103,
     /*  291841 */     GIR_EraseRootFromParent_Done,
     /*  291842 */   // Label 5464: @291842
     /*  291842 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(291905), // Rule ID 9106 //
     /*  291847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  291861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291886 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  291886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  291889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291903 */     GIR_RootConstrainSelectedInstOperands,
     /*  291904 */     // GIR_Coverage, 9106,
     /*  291904 */     GIR_EraseRootFromParent_Done,
     /*  291905 */   // Label 5465: @291905
     /*  291905 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(291968), // Rule ID 9107 //
     /*  291910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  291913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  291921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  291924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  291927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  291930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  291942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  291949 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  291949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  291952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  291954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  291956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  291958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  291963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  291966 */     GIR_RootConstrainSelectedInstOperands,
     /*  291967 */     // GIR_Coverage, 9107,
     /*  291967 */     GIR_EraseRootFromParent_Done,
     /*  291968 */   // Label 5466: @291968
     /*  291968 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(292031), // Rule ID 9110 //
     /*  291973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  291976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  291981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  291984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  291987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  291990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  291993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  291997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292012 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292029 */     GIR_RootConstrainSelectedInstOperands,
     /*  292030 */     // GIR_Coverage, 9110,
     /*  292030 */     GIR_EraseRootFromParent_Done,
     /*  292031 */   // Label 5467: @292031
     /*  292031 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(292094), // Rule ID 9111 //
     /*  292036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  292050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292075 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2),
     /*  292078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292092 */     GIR_RootConstrainSelectedInstOperands,
     /*  292093 */     // GIR_Coverage, 9111,
     /*  292093 */     GIR_EraseRootFromParent_Done,
     /*  292094 */   // Label 5468: @292094
     /*  292094 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(292157), // Rule ID 9114 //
     /*  292099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292138 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292155 */     GIR_RootConstrainSelectedInstOperands,
     /*  292156 */     // GIR_Coverage, 9114,
     /*  292156 */     GIR_EraseRootFromParent_Done,
     /*  292157 */   // Label 5469: @292157
     /*  292157 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(292220), // Rule ID 9115 //
     /*  292162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  292176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292201 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292218 */     GIR_RootConstrainSelectedInstOperands,
     /*  292219 */     // GIR_Coverage, 9115,
     /*  292219 */     GIR_EraseRootFromParent_Done,
     /*  292220 */   // Label 5470: @292220
     /*  292220 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(292283), // Rule ID 9118 //
     /*  292225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  292264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292281 */     GIR_RootConstrainSelectedInstOperands,
     /*  292282 */     // GIR_Coverage, 9118,
     /*  292282 */     GIR_EraseRootFromParent_Done,
     /*  292283 */   // Label 5471: @292283
     /*  292283 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(292346), // Rule ID 9119 //
     /*  292288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  292299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  292302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292327 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  292327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  292344 */     GIR_RootConstrainSelectedInstOperands,
     /*  292345 */     // GIR_Coverage, 9119,
     /*  292345 */     GIR_EraseRootFromParent_Done,
     /*  292346 */   // Label 5472: @292346
     /*  292346 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(292409), // Rule ID 9122 //
     /*  292351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  292390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292407 */     GIR_RootConstrainSelectedInstOperands,
     /*  292408 */     // GIR_Coverage, 9122,
     /*  292408 */     GIR_EraseRootFromParent_Done,
     /*  292409 */   // Label 5473: @292409
     /*  292409 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(292472), // Rule ID 9123 //
     /*  292414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  292425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  292428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292453 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  292453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  292470 */     GIR_RootConstrainSelectedInstOperands,
     /*  292471 */     // GIR_Coverage, 9123,
     /*  292471 */     GIR_EraseRootFromParent_Done,
     /*  292472 */   // Label 5474: @292472
     /*  292472 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(292535), // Rule ID 9126 //
     /*  292477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  292480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  292491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  292516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292533 */     GIR_RootConstrainSelectedInstOperands,
     /*  292534 */     // GIR_Coverage, 9126,
     /*  292534 */     GIR_EraseRootFromParent_Done,
     /*  292535 */   // Label 5475: @292535
     /*  292535 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(292598), // Rule ID 9127 //
     /*  292540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  292543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  292551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  292554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292579 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  292579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1),
     /*  292582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  292596 */     GIR_RootConstrainSelectedInstOperands,
     /*  292597 */     // GIR_Coverage, 9127,
     /*  292597 */     GIR_EraseRootFromParent_Done,
     /*  292598 */   // Label 5476: @292598
     /*  292598 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(292661), // Rule ID 9130 //
     /*  292603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  292617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292642 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  292645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292659 */     GIR_RootConstrainSelectedInstOperands,
     /*  292660 */     // GIR_Coverage, 9130,
     /*  292660 */     GIR_EraseRootFromParent_Done,
     /*  292661 */   // Label 5477: @292661
     /*  292661 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(292724), // Rule ID 9131 //
     /*  292666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  292677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  292680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  292694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292705 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  292708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292722 */     GIR_RootConstrainSelectedInstOperands,
     /*  292723 */     // GIR_Coverage, 9131,
     /*  292723 */     GIR_EraseRootFromParent_Done,
     /*  292724 */   // Label 5478: @292724
     /*  292724 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(292787), // Rule ID 9134 //
     /*  292729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  292743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292768 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  292771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292785 */     GIR_RootConstrainSelectedInstOperands,
     /*  292786 */     // GIR_Coverage, 9134,
     /*  292786 */     GIR_EraseRootFromParent_Done,
     /*  292787 */   // Label 5479: @292787
     /*  292787 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(292850), // Rule ID 9135 //
     /*  292792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  292803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  292806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  292820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292831 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  292834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292848 */     GIR_RootConstrainSelectedInstOperands,
     /*  292849 */     // GIR_Coverage, 9135,
     /*  292849 */     GIR_EraseRootFromParent_Done,
     /*  292850 */   // Label 5480: @292850
     /*  292850 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(292913), // Rule ID 9138 //
     /*  292855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  292866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  292869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  292875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292894 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  292894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  292897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292911 */     GIR_RootConstrainSelectedInstOperands,
     /*  292912 */     // GIR_Coverage, 9138,
     /*  292912 */     GIR_EraseRootFromParent_Done,
     /*  292913 */   // Label 5481: @292913
     /*  292913 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(292976), // Rule ID 9139 //
     /*  292918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  292921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  292929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  292932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  292935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  292938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  292942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  292946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  292950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  292957 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  292957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  292960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  292962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  292964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  292966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  292971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  292974 */     GIR_RootConstrainSelectedInstOperands,
     /*  292975 */     // GIR_Coverage, 9139,
     /*  292975 */     GIR_EraseRootFromParent_Done,
     /*  292976 */   // Label 5482: @292976
     /*  292976 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(293039), // Rule ID 9142 //
     /*  292981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  292984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  292989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  292992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  292995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  292998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293037 */     GIR_RootConstrainSelectedInstOperands,
     /*  293038 */     // GIR_Coverage, 9142,
     /*  293038 */     GIR_EraseRootFromParent_Done,
     /*  293039 */   // Label 5483: @293039
     /*  293039 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(293102), // Rule ID 9143 //
     /*  293044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  293058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293083 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293100 */     GIR_RootConstrainSelectedInstOperands,
     /*  293101 */     // GIR_Coverage, 9143,
     /*  293101 */     GIR_EraseRootFromParent_Done,
     /*  293102 */   // Label 5484: @293102
     /*  293102 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(293165), // Rule ID 9146 //
     /*  293107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293146 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293163 */     GIR_RootConstrainSelectedInstOperands,
     /*  293164 */     // GIR_Coverage, 9146,
     /*  293164 */     GIR_EraseRootFromParent_Done,
     /*  293165 */   // Label 5485: @293165
     /*  293165 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(293228), // Rule ID 9147 //
     /*  293170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  293184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293209 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293226 */     GIR_RootConstrainSelectedInstOperands,
     /*  293227 */     // GIR_Coverage, 9147,
     /*  293227 */     GIR_EraseRootFromParent_Done,
     /*  293228 */   // Label 5486: @293228
     /*  293228 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(293291), // Rule ID 9150 //
     /*  293233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  293272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293289 */     GIR_RootConstrainSelectedInstOperands,
     /*  293290 */     // GIR_Coverage, 9150,
     /*  293290 */     GIR_EraseRootFromParent_Done,
     /*  293291 */   // Label 5487: @293291
     /*  293291 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(293354), // Rule ID 9151 //
     /*  293296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  293307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  293310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293335 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  293335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  293352 */     GIR_RootConstrainSelectedInstOperands,
     /*  293353 */     // GIR_Coverage, 9151,
     /*  293353 */     GIR_EraseRootFromParent_Done,
     /*  293354 */   // Label 5488: @293354
     /*  293354 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(293417), // Rule ID 9154 //
     /*  293359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293398 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293415 */     GIR_RootConstrainSelectedInstOperands,
     /*  293416 */     // GIR_Coverage, 9154,
     /*  293416 */     GIR_EraseRootFromParent_Done,
     /*  293417 */   // Label 5489: @293417
     /*  293417 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(293480), // Rule ID 9155 //
     /*  293422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  293436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293461 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293478 */     GIR_RootConstrainSelectedInstOperands,
     /*  293479 */     // GIR_Coverage, 9155,
     /*  293479 */     GIR_EraseRootFromParent_Done,
     /*  293480 */   // Label 5490: @293480
     /*  293480 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(293543), // Rule ID 9158 //
     /*  293485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  293499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293541 */     GIR_RootConstrainSelectedInstOperands,
     /*  293542 */     // GIR_Coverage, 9158,
     /*  293542 */     GIR_EraseRootFromParent_Done,
     /*  293543 */   // Label 5491: @293543
     /*  293543 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(293606), // Rule ID 9159 //
     /*  293548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  293559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  293562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293587 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293604 */     GIR_RootConstrainSelectedInstOperands,
     /*  293605 */     // GIR_Coverage, 9159,
     /*  293605 */     GIR_EraseRootFromParent_Done,
     /*  293606 */   // Label 5492: @293606
     /*  293606 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(293669), // Rule ID 9162 //
     /*  293611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  293614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  293625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293650 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  293650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293667 */     GIR_RootConstrainSelectedInstOperands,
     /*  293668 */     // GIR_Coverage, 9162,
     /*  293668 */     GIR_EraseRootFromParent_Done,
     /*  293669 */   // Label 5493: @293669
     /*  293669 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(293732), // Rule ID 9163 //
     /*  293674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  293677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  293685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  293688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  293702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  293713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  293716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  293730 */     GIR_RootConstrainSelectedInstOperands,
     /*  293731 */     // GIR_Coverage, 9163,
     /*  293731 */     GIR_EraseRootFromParent_Done,
     /*  293732 */   // Label 5494: @293732
     /*  293732 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(293795), // Rule ID 9166 //
     /*  293737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  293751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293793 */     GIR_RootConstrainSelectedInstOperands,
     /*  293794 */     // GIR_Coverage, 9166,
     /*  293794 */     GIR_EraseRootFromParent_Done,
     /*  293795 */   // Label 5495: @293795
     /*  293795 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(293858), // Rule ID 9167 //
     /*  293800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  293811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  293814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  293828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293839 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2),
     /*  293842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293856 */     GIR_RootConstrainSelectedInstOperands,
     /*  293857 */     // GIR_Coverage, 9167,
     /*  293857 */     GIR_EraseRootFromParent_Done,
     /*  293858 */   // Label 5496: @293858
     /*  293858 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(293921), // Rule ID 9170 //
     /*  293863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  293877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  293880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  293883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293902 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  293902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293919 */     GIR_RootConstrainSelectedInstOperands,
     /*  293920 */     // GIR_Coverage, 9170,
     /*  293920 */     GIR_EraseRootFromParent_Done,
     /*  293921 */   // Label 5497: @293921
     /*  293921 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(293984), // Rule ID 9171 //
     /*  293926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  293929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  293937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  293940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  293943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  293946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  293950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  293954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  293958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  293965 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  293965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4),
     /*  293968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  293970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  293972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  293974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  293979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  293982 */     GIR_RootConstrainSelectedInstOperands,
     /*  293983 */     // GIR_Coverage, 9171,
     /*  293983 */     GIR_EraseRootFromParent_Done,
     /*  293984 */   // Label 5498: @293984
     /*  293984 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(294047), // Rule ID 9174 //
     /*  293989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  293992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  293997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294028 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  294028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294045 */     GIR_RootConstrainSelectedInstOperands,
     /*  294046 */     // GIR_Coverage, 9174,
     /*  294046 */     GIR_EraseRootFromParent_Done,
     /*  294047 */   // Label 5499: @294047
     /*  294047 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(294110), // Rule ID 9175 //
     /*  294052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  294055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  294060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  294066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  294080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294091 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  294091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8),
     /*  294094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  294108 */     GIR_RootConstrainSelectedInstOperands,
     /*  294109 */     // GIR_Coverage, 9175,
     /*  294109 */     GIR_EraseRootFromParent_Done,
     /*  294110 */   // Label 5500: @294110
     /*  294110 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(294173), // Rule ID 9266 //
     /*  294115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294154 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294171 */     GIR_RootConstrainSelectedInstOperands,
     /*  294172 */     // GIR_Coverage, 9266,
     /*  294172 */     GIR_EraseRootFromParent_Done,
     /*  294173 */   // Label 5501: @294173
     /*  294173 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(294236), // Rule ID 9267 //
     /*  294178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  294192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294217 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8),
     /*  294220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294234 */     GIR_RootConstrainSelectedInstOperands,
     /*  294235 */     // GIR_Coverage, 9267,
     /*  294235 */     GIR_EraseRootFromParent_Done,
     /*  294236 */   // Label 5502: @294236
     /*  294236 */   GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(294299), // Rule ID 9270 //
     /*  294241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294280 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294297 */     GIR_RootConstrainSelectedInstOperands,
     /*  294298 */     // GIR_Coverage, 9270,
     /*  294298 */     GIR_EraseRootFromParent_Done,
     /*  294299 */   // Label 5503: @294299
     /*  294299 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(294362), // Rule ID 9271 //
     /*  294304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  294318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294343 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294360 */     GIR_RootConstrainSelectedInstOperands,
     /*  294361 */     // GIR_Coverage, 9271,
     /*  294361 */     GIR_EraseRootFromParent_Done,
     /*  294362 */   // Label 5504: @294362
     /*  294362 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(294425), // Rule ID 9274 //
     /*  294367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294406 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294423 */     GIR_RootConstrainSelectedInstOperands,
     /*  294424 */     // GIR_Coverage, 9274,
     /*  294424 */     GIR_EraseRootFromParent_Done,
     /*  294425 */   // Label 5505: @294425
     /*  294425 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(294488), // Rule ID 9275 //
     /*  294430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  294441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  294444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294469 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294486 */     GIR_RootConstrainSelectedInstOperands,
     /*  294487 */     // GIR_Coverage, 9275,
     /*  294487 */     GIR_EraseRootFromParent_Done,
     /*  294488 */   // Label 5506: @294488
     /*  294488 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(294551), // Rule ID 9278 //
     /*  294493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  294507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294532 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294549 */     GIR_RootConstrainSelectedInstOperands,
     /*  294550 */     // GIR_Coverage, 9278,
     /*  294550 */     GIR_EraseRootFromParent_Done,
     /*  294551 */   // Label 5507: @294551
     /*  294551 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(294614), // Rule ID 9279 //
     /*  294556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  294570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294595 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4),
     /*  294598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294612 */     GIR_RootConstrainSelectedInstOperands,
     /*  294613 */     // GIR_Coverage, 9279,
     /*  294613 */     GIR_EraseRootFromParent_Done,
     /*  294614 */   // Label 5508: @294614
     /*  294614 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(294677), // Rule ID 9282 //
     /*  294619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  294633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294658 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  294658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294675 */     GIR_RootConstrainSelectedInstOperands,
     /*  294676 */     // GIR_Coverage, 9282,
     /*  294676 */     GIR_EraseRootFromParent_Done,
     /*  294677 */   // Label 5509: @294677
     /*  294677 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(294740), // Rule ID 9283 //
     /*  294682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  294693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  294696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294721 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  294721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  294738 */     GIR_RootConstrainSelectedInstOperands,
     /*  294739 */     // GIR_Coverage, 9283,
     /*  294739 */     GIR_EraseRootFromParent_Done,
     /*  294740 */   // Label 5510: @294740
     /*  294740 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(294803), // Rule ID 9286 //
     /*  294745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  294759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  294784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294801 */     GIR_RootConstrainSelectedInstOperands,
     /*  294802 */     // GIR_Coverage, 9286,
     /*  294802 */     GIR_EraseRootFromParent_Done,
     /*  294803 */   // Label 5511: @294803
     /*  294803 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(294866), // Rule ID 9287 //
     /*  294808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  294819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  294822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294847 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  294847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2),
     /*  294850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  294864 */     GIR_RootConstrainSelectedInstOperands,
     /*  294865 */     // GIR_Coverage, 9287,
     /*  294865 */     GIR_EraseRootFromParent_Done,
     /*  294866 */   // Label 5512: @294866
     /*  294866 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(294929), // Rule ID 9290 //
     /*  294871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  294874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  294885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  294888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  294891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294910 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  294910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  294913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294927 */     GIR_RootConstrainSelectedInstOperands,
     /*  294928 */     // GIR_Coverage, 9290,
     /*  294928 */     GIR_EraseRootFromParent_Done,
     /*  294929 */   // Label 5513: @294929
     /*  294929 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(294992), // Rule ID 9291 //
     /*  294934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  294937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  294942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  294945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  294948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  294951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  294954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  294962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  294966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  294973 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  294973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  294976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  294978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  294980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  294982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  294987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  294990 */     GIR_RootConstrainSelectedInstOperands,
     /*  294991 */     // GIR_Coverage, 9291,
     /*  294991 */     GIR_EraseRootFromParent_Done,
     /*  294992 */   // Label 5514: @294992
     /*  294992 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(295055), // Rule ID 9294 //
     /*  294997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295053 */     GIR_RootConstrainSelectedInstOperands,
     /*  295054 */     // GIR_Coverage, 9294,
     /*  295054 */     GIR_EraseRootFromParent_Done,
     /*  295055 */   // Label 5515: @295055
     /*  295055 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(295118), // Rule ID 9295 //
     /*  295060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  295071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  295074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295099 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295116 */     GIR_RootConstrainSelectedInstOperands,
     /*  295117 */     // GIR_Coverage, 9295,
     /*  295117 */     GIR_EraseRootFromParent_Done,
     /*  295118 */   // Label 5516: @295118
     /*  295118 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(295181), // Rule ID 9298 //
     /*  295123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295162 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  295162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295179 */     GIR_RootConstrainSelectedInstOperands,
     /*  295180 */     // GIR_Coverage, 9298,
     /*  295180 */     GIR_EraseRootFromParent_Done,
     /*  295181 */   // Label 5517: @295181
     /*  295181 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(295244), // Rule ID 9299 //
     /*  295186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  295197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  295200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295225 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  295225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  295242 */     GIR_RootConstrainSelectedInstOperands,
     /*  295243 */     // GIR_Coverage, 9299,
     /*  295243 */     GIR_EraseRootFromParent_Done,
     /*  295244 */   // Label 5518: @295244
     /*  295244 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(295307), // Rule ID 9302 //
     /*  295249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  295252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  295288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295305 */     GIR_RootConstrainSelectedInstOperands,
     /*  295306 */     // GIR_Coverage, 9302,
     /*  295306 */     GIR_EraseRootFromParent_Done,
     /*  295307 */   // Label 5519: @295307
     /*  295307 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(295370), // Rule ID 9303 //
     /*  295312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  295315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  295323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  295326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295351 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  295351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1),
     /*  295354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  295368 */     GIR_RootConstrainSelectedInstOperands,
     /*  295369 */     // GIR_Coverage, 9303,
     /*  295369 */     GIR_EraseRootFromParent_Done,
     /*  295370 */   // Label 5520: @295370
     /*  295370 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(295433), // Rule ID 9306 //
     /*  295375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295431 */     GIR_RootConstrainSelectedInstOperands,
     /*  295432 */     // GIR_Coverage, 9306,
     /*  295432 */     GIR_EraseRootFromParent_Done,
     /*  295433 */   // Label 5521: @295433
     /*  295433 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(295496), // Rule ID 9307 //
     /*  295438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  295452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295477 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295494 */     GIR_RootConstrainSelectedInstOperands,
     /*  295495 */     // GIR_Coverage, 9307,
     /*  295495 */     GIR_EraseRootFromParent_Done,
     /*  295496 */   // Label 5522: @295496
     /*  295496 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(295559), // Rule ID 9310 //
     /*  295501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  295512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  295515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295540 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  295543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295557 */     GIR_RootConstrainSelectedInstOperands,
     /*  295558 */     // GIR_Coverage, 9310,
     /*  295558 */     GIR_EraseRootFromParent_Done,
     /*  295559 */   // Label 5523: @295559
     /*  295559 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(295622), // Rule ID 9311 //
     /*  295564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  295575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  295578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295603 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  295606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295620 */     GIR_RootConstrainSelectedInstOperands,
     /*  295621 */     // GIR_Coverage, 9311,
     /*  295621 */     GIR_EraseRootFromParent_Done,
     /*  295622 */   // Label 5524: @295622
     /*  295622 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(295685), // Rule ID 9314 //
     /*  295627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  295638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  295641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295666 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  295666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  295669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295683 */     GIR_RootConstrainSelectedInstOperands,
     /*  295684 */     // GIR_Coverage, 9314,
     /*  295684 */     GIR_EraseRootFromParent_Done,
     /*  295685 */   // Label 5525: @295685
     /*  295685 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(295748), // Rule ID 9315 //
     /*  295690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  295701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  295704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  295718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295729 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  295729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  295732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  295746 */     GIR_RootConstrainSelectedInstOperands,
     /*  295747 */     // GIR_Coverage, 9315,
     /*  295747 */     GIR_EraseRootFromParent_Done,
     /*  295748 */   // Label 5526: @295748
     /*  295748 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(295811), // Rule ID 9318 //
     /*  295753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  295767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295792 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295809 */     GIR_RootConstrainSelectedInstOperands,
     /*  295810 */     // GIR_Coverage, 9318,
     /*  295810 */     GIR_EraseRootFromParent_Done,
     /*  295811 */   // Label 5527: @295811
     /*  295811 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(295874), // Rule ID 9319 //
     /*  295816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  295827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  295830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  295844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295855 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  295858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295872 */     GIR_RootConstrainSelectedInstOperands,
     /*  295873 */     // GIR_Coverage, 9319,
     /*  295873 */     GIR_EraseRootFromParent_Done,
     /*  295874 */   // Label 5528: @295874
     /*  295874 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(295937), // Rule ID 9322 //
     /*  295879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  295882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  295893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  295896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  295899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295918 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  295918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  295921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295935 */     GIR_RootConstrainSelectedInstOperands,
     /*  295936 */     // GIR_Coverage, 9322,
     /*  295936 */     GIR_EraseRootFromParent_Done,
     /*  295937 */   // Label 5529: @295937
     /*  295937 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(296000), // Rule ID 9323 //
     /*  295942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  295945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  295950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  295953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  295956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  295959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  295962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  295966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  295970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  295974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  295981 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  295981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  295984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  295986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  295988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  295990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  295995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  295998 */     GIR_RootConstrainSelectedInstOperands,
     /*  295999 */     // GIR_Coverage, 9323,
     /*  295999 */     GIR_EraseRootFromParent_Done,
     /*  296000 */   // Label 5530: @296000
     /*  296000 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(296063), // Rule ID 9326 //
     /*  296005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296044 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  296044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296061 */     GIR_RootConstrainSelectedInstOperands,
     /*  296062 */     // GIR_Coverage, 9326,
     /*  296062 */     GIR_EraseRootFromParent_Done,
     /*  296063 */   // Label 5531: @296063
     /*  296063 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(296126), // Rule ID 9327 //
     /*  296068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  296079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  296082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296107 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  296107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  296124 */     GIR_RootConstrainSelectedInstOperands,
     /*  296125 */     // GIR_Coverage, 9327,
     /*  296125 */     GIR_EraseRootFromParent_Done,
     /*  296126 */   // Label 5532: @296126
     /*  296126 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(296189), // Rule ID 9330 //
     /*  296131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296170 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296187 */     GIR_RootConstrainSelectedInstOperands,
     /*  296188 */     // GIR_Coverage, 9330,
     /*  296188 */     GIR_EraseRootFromParent_Done,
     /*  296189 */   // Label 5533: @296189
     /*  296189 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(296252), // Rule ID 9331 //
     /*  296194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  296208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296233 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296250 */     GIR_RootConstrainSelectedInstOperands,
     /*  296251 */     // GIR_Coverage, 9331,
     /*  296251 */     GIR_EraseRootFromParent_Done,
     /*  296252 */   // Label 5534: @296252
     /*  296252 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(296315), // Rule ID 9334 //
     /*  296257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296296 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296313 */     GIR_RootConstrainSelectedInstOperands,
     /*  296314 */     // GIR_Coverage, 9334,
     /*  296314 */     GIR_EraseRootFromParent_Done,
     /*  296315 */   // Label 5535: @296315
     /*  296315 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(296378), // Rule ID 9335 //
     /*  296320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  296334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296359 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296376 */     GIR_RootConstrainSelectedInstOperands,
     /*  296377 */     // GIR_Coverage, 9335,
     /*  296377 */     GIR_EraseRootFromParent_Done,
     /*  296378 */   // Label 5536: @296378
     /*  296378 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(296441), // Rule ID 9338 //
     /*  296383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296422 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  296422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296439 */     GIR_RootConstrainSelectedInstOperands,
     /*  296440 */     // GIR_Coverage, 9338,
     /*  296440 */     GIR_EraseRootFromParent_Done,
     /*  296441 */   // Label 5537: @296441
     /*  296441 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(296504), // Rule ID 9339 //
     /*  296446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  296457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  296460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296485 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  296485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  296502 */     GIR_RootConstrainSelectedInstOperands,
     /*  296503 */     // GIR_Coverage, 9339,
     /*  296503 */     GIR_EraseRootFromParent_Done,
     /*  296504 */   // Label 5538: @296504
     /*  296504 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(296567), // Rule ID 9342 //
     /*  296509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  296523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296548 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296565 */     GIR_RootConstrainSelectedInstOperands,
     /*  296566 */     // GIR_Coverage, 9342,
     /*  296566 */     GIR_EraseRootFromParent_Done,
     /*  296567 */   // Label 5539: @296567
     /*  296567 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(296630), // Rule ID 9343 //
     /*  296572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  296586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  296600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296611 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2),
     /*  296614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296628 */     GIR_RootConstrainSelectedInstOperands,
     /*  296629 */     // GIR_Coverage, 9343,
     /*  296629 */     GIR_EraseRootFromParent_Done,
     /*  296630 */   // Label 5540: @296630
     /*  296630 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(296693), // Rule ID 9346 //
     /*  296635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  296649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296691 */     GIR_RootConstrainSelectedInstOperands,
     /*  296692 */     // GIR_Coverage, 9346,
     /*  296692 */     GIR_EraseRootFromParent_Done,
     /*  296693 */   // Label 5541: @296693
     /*  296693 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(296756), // Rule ID 9347 //
     /*  296698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  296709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  296712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  296726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296737 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4),
     /*  296740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296754 */     GIR_RootConstrainSelectedInstOperands,
     /*  296755 */     // GIR_Coverage, 9347,
     /*  296755 */     GIR_EraseRootFromParent_Done,
     /*  296756 */   // Label 5542: @296756
     /*  296756 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(296819), // Rule ID 9350 //
     /*  296761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  296764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  296775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  296778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  296800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296817 */     GIR_RootConstrainSelectedInstOperands,
     /*  296818 */     // GIR_Coverage, 9350,
     /*  296818 */     GIR_EraseRootFromParent_Done,
     /*  296819 */   // Label 5543: @296819
     /*  296819 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(296882), // Rule ID 9351 //
     /*  296824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  296827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  296832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  296835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  296838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  296841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  296852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  296856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296863 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  296863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8),
     /*  296866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  296870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  296872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  296880 */     GIR_RootConstrainSelectedInstOperands,
     /*  296881 */     // GIR_Coverage, 9351,
     /*  296881 */     GIR_EraseRootFromParent_Done,
     /*  296882 */   // Label 5544: @296882
     /*  296882 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(296945), // Rule ID 9442 //
     /*  296887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  296890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  296901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  296904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  296907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296926 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  296926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  296929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  296933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  296935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  296940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  296943 */     GIR_RootConstrainSelectedInstOperands,
     /*  296944 */     // GIR_Coverage, 9442,
     /*  296944 */     GIR_EraseRootFromParent_Done,
     /*  296945 */   // Label 5545: @296945
     /*  296945 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(297008), // Rule ID 9443 //
     /*  296950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  296953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  296958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  296961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  296964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  296967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  296970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  296982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  296989 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  296989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  296992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  296994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  296996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  296998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297006 */     GIR_RootConstrainSelectedInstOperands,
     /*  297007 */     // GIR_Coverage, 9443,
     /*  297007 */     GIR_EraseRootFromParent_Done,
     /*  297008 */   // Label 5546: @297008
     /*  297008 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(297071), // Rule ID 9446 //
     /*  297013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297069 */     GIR_RootConstrainSelectedInstOperands,
     /*  297070 */     // GIR_Coverage, 9446,
     /*  297070 */     GIR_EraseRootFromParent_Done,
     /*  297071 */   // Label 5547: @297071
     /*  297071 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(297134), // Rule ID 9447 //
     /*  297076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  297090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  297093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297115 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297132 */     GIR_RootConstrainSelectedInstOperands,
     /*  297133 */     // GIR_Coverage, 9447,
     /*  297133 */     GIR_EraseRootFromParent_Done,
     /*  297134 */   // Label 5548: @297134
     /*  297134 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(297197), // Rule ID 9450 //
     /*  297139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297178 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297195 */     GIR_RootConstrainSelectedInstOperands,
     /*  297196 */     // GIR_Coverage, 9450,
     /*  297196 */     GIR_EraseRootFromParent_Done,
     /*  297197 */   // Label 5549: @297197
     /*  297197 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(297260), // Rule ID 9451 //
     /*  297202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  297216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  297219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297241 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /*  297244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297258 */     GIR_RootConstrainSelectedInstOperands,
     /*  297259 */     // GIR_Coverage, 9451,
     /*  297259 */     GIR_EraseRootFromParent_Done,
     /*  297260 */   // Label 5550: @297260
     /*  297260 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(297323), // Rule ID 9454 //
     /*  297265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297304 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297321 */     GIR_RootConstrainSelectedInstOperands,
     /*  297322 */     // GIR_Coverage, 9454,
     /*  297322 */     GIR_EraseRootFromParent_Done,
     /*  297323 */   // Label 5551: @297323
     /*  297323 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(297386), // Rule ID 9455 //
     /*  297328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  297342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  297345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297367 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297384 */     GIR_RootConstrainSelectedInstOperands,
     /*  297385 */     // GIR_Coverage, 9455,
     /*  297385 */     GIR_EraseRootFromParent_Done,
     /*  297386 */   // Label 5552: @297386
     /*  297386 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(297449), // Rule ID 9458 //
     /*  297391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297430 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297447 */     GIR_RootConstrainSelectedInstOperands,
     /*  297448 */     // GIR_Coverage, 9458,
     /*  297448 */     GIR_EraseRootFromParent_Done,
     /*  297449 */   // Label 5553: @297449
     /*  297449 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(297512), // Rule ID 9459 //
     /*  297454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  297468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  297471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297493 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /*  297496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297510 */     GIR_RootConstrainSelectedInstOperands,
     /*  297511 */     // GIR_Coverage, 9459,
     /*  297511 */     GIR_EraseRootFromParent_Done,
     /*  297512 */   // Label 5554: @297512
     /*  297512 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(297575), // Rule ID 9462 //
     /*  297517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  297531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  297534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  297556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297573 */     GIR_RootConstrainSelectedInstOperands,
     /*  297574 */     // GIR_Coverage, 9462,
     /*  297574 */     GIR_EraseRootFromParent_Done,
     /*  297575 */   // Label 5555: @297575
     /*  297575 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(297638), // Rule ID 9463 //
     /*  297580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  297591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  297594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  297597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297619 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  297619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  297636 */     GIR_RootConstrainSelectedInstOperands,
     /*  297637 */     // GIR_Coverage, 9463,
     /*  297637 */     GIR_EraseRootFromParent_Done,
     /*  297638 */   // Label 5556: @297638
     /*  297638 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(297701), // Rule ID 9466 //
     /*  297643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  297657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  297660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297682 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  297682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297699 */     GIR_RootConstrainSelectedInstOperands,
     /*  297700 */     // GIR_Coverage, 9466,
     /*  297700 */     GIR_EraseRootFromParent_Done,
     /*  297701 */   // Label 5557: @297701
     /*  297701 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(297764), // Rule ID 9467 //
     /*  297706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  297717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  297720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  297723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297745 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  297745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  297762 */     GIR_RootConstrainSelectedInstOperands,
     /*  297763 */     // GIR_Coverage, 9467,
     /*  297763 */     GIR_EraseRootFromParent_Done,
     /*  297764 */   // Label 5558: @297764
     /*  297764 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(297827), // Rule ID 9470 //
     /*  297769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  297772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  297783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  297786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  297808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297825 */     GIR_RootConstrainSelectedInstOperands,
     /*  297826 */     // GIR_Coverage, 9470,
     /*  297826 */     GIR_EraseRootFromParent_Done,
     /*  297827 */   // Label 5559: @297827
     /*  297827 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(297890), // Rule ID 9471 //
     /*  297832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  297835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  297843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  297846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  297849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297871 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  297871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  297888 */     GIR_RootConstrainSelectedInstOperands,
     /*  297889 */     // GIR_Coverage, 9471,
     /*  297889 */     GIR_EraseRootFromParent_Done,
     /*  297890 */   // Label 5560: @297890
     /*  297890 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(297953), // Rule ID 9474 //
     /*  297895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  297898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  297909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  297912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  297915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297934 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  297934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  297937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  297939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  297941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  297943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  297948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  297951 */     GIR_RootConstrainSelectedInstOperands,
     /*  297952 */     // GIR_Coverage, 9474,
     /*  297952 */     GIR_EraseRootFromParent_Done,
     /*  297953 */   // Label 5561: @297953
     /*  297953 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(298016), // Rule ID 9475 //
     /*  297958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  297961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  297966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  297969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  297972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  297975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  297978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  297990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  297997 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11384:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  297997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /*  298000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  298014 */     GIR_RootConstrainSelectedInstOperands,
     /*  298015 */     // GIR_Coverage, 9475,
     /*  298015 */     GIR_EraseRootFromParent_Done,
     /*  298016 */   // Label 5562: @298016
     /*  298016 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(298079), // Rule ID 9478 //
     /*  298021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298060 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298077 */     GIR_RootConstrainSelectedInstOperands,
     /*  298078 */     // GIR_Coverage, 9478,
     /*  298078 */     GIR_EraseRootFromParent_Done,
     /*  298079 */   // Label 5563: @298079
     /*  298079 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(298142), // Rule ID 9479 //
     /*  298084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  298098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  298101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298123 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298140 */     GIR_RootConstrainSelectedInstOperands,
     /*  298141 */     // GIR_Coverage, 9479,
     /*  298141 */     GIR_EraseRootFromParent_Done,
     /*  298142 */   // Label 5564: @298142
     /*  298142 */   GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(298205), // Rule ID 9482 //
     /*  298147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298186 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298203 */     GIR_RootConstrainSelectedInstOperands,
     /*  298204 */     // GIR_Coverage, 9482,
     /*  298204 */     GIR_EraseRootFromParent_Done,
     /*  298205 */   // Label 5565: @298205
     /*  298205 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(298268), // Rule ID 9483 //
     /*  298210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  298224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  298227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298249 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298266 */     GIR_RootConstrainSelectedInstOperands,
     /*  298267 */     // GIR_Coverage, 9483,
     /*  298267 */     GIR_EraseRootFromParent_Done,
     /*  298268 */   // Label 5566: @298268
     /*  298268 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(298331), // Rule ID 9486 //
     /*  298273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298312 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  298312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298329 */     GIR_RootConstrainSelectedInstOperands,
     /*  298330 */     // GIR_Coverage, 9486,
     /*  298330 */     GIR_EraseRootFromParent_Done,
     /*  298331 */   // Label 5567: @298331
     /*  298331 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(298394), // Rule ID 9487 //
     /*  298336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  298347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  298350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  298353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298375 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  298375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  298392 */     GIR_RootConstrainSelectedInstOperands,
     /*  298393 */     // GIR_Coverage, 9487,
     /*  298393 */     GIR_EraseRootFromParent_Done,
     /*  298394 */   // Label 5568: @298394
     /*  298394 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(298457), // Rule ID 9490 //
     /*  298399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298438 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298455 */     GIR_RootConstrainSelectedInstOperands,
     /*  298456 */     // GIR_Coverage, 9490,
     /*  298456 */     GIR_EraseRootFromParent_Done,
     /*  298457 */   // Label 5569: @298457
     /*  298457 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(298520), // Rule ID 9491 //
     /*  298462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  298476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  298479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298501 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298518 */     GIR_RootConstrainSelectedInstOperands,
     /*  298519 */     // GIR_Coverage, 9491,
     /*  298519 */     GIR_EraseRootFromParent_Done,
     /*  298520 */   // Label 5570: @298520
     /*  298520 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(298583), // Rule ID 9494 //
     /*  298525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  298539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  298542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298581 */     GIR_RootConstrainSelectedInstOperands,
     /*  298582 */     // GIR_Coverage, 9494,
     /*  298582 */     GIR_EraseRootFromParent_Done,
     /*  298583 */   // Label 5571: @298583
     /*  298583 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(298646), // Rule ID 9495 //
     /*  298588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  298599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  298602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  298605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298627 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298644 */     GIR_RootConstrainSelectedInstOperands,
     /*  298645 */     // GIR_Coverage, 9495,
     /*  298645 */     GIR_EraseRootFromParent_Done,
     /*  298646 */   // Label 5572: @298646
     /*  298646 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(298709), // Rule ID 9498 //
     /*  298651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  298665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  298668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298690 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  298690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298707 */     GIR_RootConstrainSelectedInstOperands,
     /*  298708 */     // GIR_Coverage, 9498,
     /*  298708 */     GIR_EraseRootFromParent_Done,
     /*  298709 */   // Label 5573: @298709
     /*  298709 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(298772), // Rule ID 9499 //
     /*  298714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  298725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  298728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  298731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  298746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298753 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  298753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  298756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  298770 */     GIR_RootConstrainSelectedInstOperands,
     /*  298771 */     // GIR_Coverage, 9499,
     /*  298771 */     GIR_EraseRootFromParent_Done,
     /*  298772 */   // Label 5574: @298772
     /*  298772 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(298835), // Rule ID 9502 //
     /*  298777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  298791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  298794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298833 */     GIR_RootConstrainSelectedInstOperands,
     /*  298834 */     // GIR_Coverage, 9502,
     /*  298834 */     GIR_EraseRootFromParent_Done,
     /*  298835 */   // Label 5575: @298835
     /*  298835 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(298898), // Rule ID 9503 //
     /*  298840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  298851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  298854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  298857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  298872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298879 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  298879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  298882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298896 */     GIR_RootConstrainSelectedInstOperands,
     /*  298897 */     // GIR_Coverage, 9503,
     /*  298897 */     GIR_EraseRootFromParent_Done,
     /*  298898 */   // Label 5576: @298898
     /*  298898 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(298961), // Rule ID 9506 //
     /*  298903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  298906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  298917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  298920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  298923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  298942 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  298942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  298945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  298947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  298949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  298951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  298956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  298959 */     GIR_RootConstrainSelectedInstOperands,
     /*  298960 */     // GIR_Coverage, 9506,
     /*  298960 */     GIR_EraseRootFromParent_Done,
     /*  298961 */   // Label 5577: @298961
     /*  298961 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(299024), // Rule ID 9507 //
     /*  298966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  298969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  298974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  298977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  298980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  298983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  298986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  298990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  298998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299005 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299022 */     GIR_RootConstrainSelectedInstOperands,
     /*  299023 */     // GIR_Coverage, 9507,
     /*  299023 */     GIR_EraseRootFromParent_Done,
     /*  299024 */   // Label 5578: @299024
     /*  299024 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(299087), // Rule ID 9510 //
     /*  299029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299068 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  299068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299085 */     GIR_RootConstrainSelectedInstOperands,
     /*  299086 */     // GIR_Coverage, 9510,
     /*  299086 */     GIR_EraseRootFromParent_Done,
     /*  299087 */   // Label 5579: @299087
     /*  299087 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(299150), // Rule ID 9511 //
     /*  299092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  299103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  299106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  299109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299131 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  299131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  299148 */     GIR_RootConstrainSelectedInstOperands,
     /*  299149 */     // GIR_Coverage, 9511,
     /*  299149 */     GIR_EraseRootFromParent_Done,
     /*  299150 */   // Label 5580: @299150
     /*  299150 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(299213), // Rule ID 9514 //
     /*  299155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299194 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299211 */     GIR_RootConstrainSelectedInstOperands,
     /*  299212 */     // GIR_Coverage, 9514,
     /*  299212 */     GIR_EraseRootFromParent_Done,
     /*  299213 */   // Label 5581: @299213
     /*  299213 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(299276), // Rule ID 9515 //
     /*  299218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  299232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  299235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  299250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299257 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11384:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /*  299260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299274 */     GIR_RootConstrainSelectedInstOperands,
     /*  299275 */     // GIR_Coverage, 9515,
     /*  299275 */     GIR_EraseRootFromParent_Done,
     /*  299276 */   // Label 5582: @299276
     /*  299276 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(299339), // Rule ID 9518 //
     /*  299281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299337 */     GIR_RootConstrainSelectedInstOperands,
     /*  299338 */     // GIR_Coverage, 9518,
     /*  299338 */     GIR_EraseRootFromParent_Done,
     /*  299339 */   // Label 5583: @299339
     /*  299339 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(299402), // Rule ID 9519 //
     /*  299344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  299358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  299361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  299376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11384:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /*  299386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299400 */     GIR_RootConstrainSelectedInstOperands,
     /*  299401 */     // GIR_Coverage, 9519,
     /*  299401 */     GIR_EraseRootFromParent_Done,
     /*  299402 */   // Label 5584: @299402
     /*  299402 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(299465), // Rule ID 9522 //
     /*  299407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  299410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  299421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  299424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299446 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  299446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299463 */     GIR_RootConstrainSelectedInstOperands,
     /*  299464 */     // GIR_Coverage, 9522,
     /*  299464 */     GIR_EraseRootFromParent_Done,
     /*  299465 */   // Label 5585: @299465
     /*  299465 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(299528), // Rule ID 9523 //
     /*  299470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  299473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu),
     /*  299478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  299481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  299484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  299487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  299502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299509 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11384:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  299509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /*  299512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  299526 */     GIR_RootConstrainSelectedInstOperands,
     /*  299527 */     // GIR_Coverage, 9523,
     /*  299527 */     GIR_EraseRootFromParent_Done,
     /*  299528 */   // Label 5586: @299528
     /*  299528 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(299591), // Rule ID 9526 //
     /*  299533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  299547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  299550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  299575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299589 */     GIR_RootConstrainSelectedInstOperands,
     /*  299590 */     // GIR_Coverage, 9526,
     /*  299590 */     GIR_EraseRootFromParent_Done,
     /*  299591 */   // Label 5587: @299591
     /*  299591 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(299654), // Rule ID 9527 //
     /*  299596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  299610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  299613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299635 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /*  299638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299652 */     GIR_RootConstrainSelectedInstOperands,
     /*  299653 */     // GIR_Coverage, 9527,
     /*  299653 */     GIR_EraseRootFromParent_Done,
     /*  299654 */   // Label 5588: @299654
     /*  299654 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(299717), // Rule ID 9530 //
     /*  299659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  299673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  299676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299698 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  299701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299715 */     GIR_RootConstrainSelectedInstOperands,
     /*  299716 */     // GIR_Coverage, 9530,
     /*  299716 */     GIR_EraseRootFromParent_Done,
     /*  299717 */   // Label 5589: @299717
     /*  299717 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(299780), // Rule ID 9531 //
     /*  299722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  299733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  299736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  299739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299761 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  299764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299778 */     GIR_RootConstrainSelectedInstOperands,
     /*  299779 */     // GIR_Coverage, 9531,
     /*  299779 */     GIR_EraseRootFromParent_Done,
     /*  299780 */   // Label 5590: @299780
     /*  299780 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(299843), // Rule ID 9534 //
     /*  299785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  299799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  299802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  299824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  299827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299841 */     GIR_RootConstrainSelectedInstOperands,
     /*  299842 */     // GIR_Coverage, 9534,
     /*  299842 */     GIR_EraseRootFromParent_Done,
     /*  299843 */   // Label 5591: @299843
     /*  299843 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(299906), // Rule ID 9535 //
     /*  299848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  299859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  299862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  299865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299887 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  299887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  299890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  299904 */     GIR_RootConstrainSelectedInstOperands,
     /*  299905 */     // GIR_Coverage, 9535,
     /*  299905 */     GIR_EraseRootFromParent_Done,
     /*  299906 */   // Label 5592: @299906
     /*  299906 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(299969), // Rule ID 9538 //
     /*  299911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  299914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  299925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  299928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  299931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  299950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  299950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  299953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  299955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  299957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  299959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  299964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  299967 */     GIR_RootConstrainSelectedInstOperands,
     /*  299968 */     // GIR_Coverage, 9538,
     /*  299968 */     GIR_EraseRootFromParent_Done,
     /*  299969 */   // Label 5593: @299969
     /*  299969 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(300032), // Rule ID 9539 //
     /*  299974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  299977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  299982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  299985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  299988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  299991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  299994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  299998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300013 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /*  300016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300030 */     GIR_RootConstrainSelectedInstOperands,
     /*  300031 */     // GIR_Coverage, 9539,
     /*  300031 */     GIR_EraseRootFromParent_Done,
     /*  300032 */   // Label 5594: @300032
     /*  300032 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(300095), // Rule ID 9542 //
     /*  300037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300093 */     GIR_RootConstrainSelectedInstOperands,
     /*  300094 */     // GIR_Coverage, 9542,
     /*  300094 */     GIR_EraseRootFromParent_Done,
     /*  300095 */   // Label 5595: @300095
     /*  300095 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(300158), // Rule ID 9543 //
     /*  300100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  300114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  300117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300139 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300156 */     GIR_RootConstrainSelectedInstOperands,
     /*  300157 */     // GIR_Coverage, 9543,
     /*  300157 */     GIR_EraseRootFromParent_Done,
     /*  300158 */   // Label 5596: @300158
     /*  300158 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(300221), // Rule ID 9546 //
     /*  300163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300202 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300219 */     GIR_RootConstrainSelectedInstOperands,
     /*  300220 */     // GIR_Coverage, 9546,
     /*  300220 */     GIR_EraseRootFromParent_Done,
     /*  300221 */   // Label 5597: @300221
     /*  300221 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(300284), // Rule ID 9547 //
     /*  300226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  300240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  300243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /*  300268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300282 */     GIR_RootConstrainSelectedInstOperands,
     /*  300283 */     // GIR_Coverage, 9547,
     /*  300283 */     GIR_EraseRootFromParent_Done,
     /*  300284 */   // Label 5598: @300284
     /*  300284 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(300347), // Rule ID 9550 //
     /*  300289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300345 */     GIR_RootConstrainSelectedInstOperands,
     /*  300346 */     // GIR_Coverage, 9550,
     /*  300346 */     GIR_EraseRootFromParent_Done,
     /*  300347 */   // Label 5599: @300347
     /*  300347 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(300410), // Rule ID 9551 //
     /*  300352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  300363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  300366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  300369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300391 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300408 */     GIR_RootConstrainSelectedInstOperands,
     /*  300409 */     // GIR_Coverage, 9551,
     /*  300409 */     GIR_EraseRootFromParent_Done,
     /*  300410 */   // Label 5600: @300410
     /*  300410 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(300473), // Rule ID 9554 //
     /*  300415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  300429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  300454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300471 */     GIR_RootConstrainSelectedInstOperands,
     /*  300472 */     // GIR_Coverage, 9554,
     /*  300472 */     GIR_EraseRootFromParent_Done,
     /*  300473 */   // Label 5601: @300473
     /*  300473 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(300536), // Rule ID 9555 //
     /*  300478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  300489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  300492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  300495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300517 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  300517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  300534 */     GIR_RootConstrainSelectedInstOperands,
     /*  300535 */     // GIR_Coverage, 9555,
     /*  300535 */     GIR_EraseRootFromParent_Done,
     /*  300536 */   // Label 5602: @300536
     /*  300536 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(300599), // Rule ID 9558 //
     /*  300541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  300555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  300558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300580 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  300580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300597 */     GIR_RootConstrainSelectedInstOperands,
     /*  300598 */     // GIR_Coverage, 9558,
     /*  300598 */     GIR_EraseRootFromParent_Done,
     /*  300599 */   // Label 5603: @300599
     /*  300599 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(300662), // Rule ID 9559 //
     /*  300604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  300615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  300618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  300621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300643 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  300643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  300660 */     GIR_RootConstrainSelectedInstOperands,
     /*  300661 */     // GIR_Coverage, 9559,
     /*  300661 */     GIR_EraseRootFromParent_Done,
     /*  300662 */   // Label 5604: @300662
     /*  300662 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(300725), // Rule ID 9562 //
     /*  300667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  300670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  300681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  300684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300706 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  300706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300723 */     GIR_RootConstrainSelectedInstOperands,
     /*  300724 */     // GIR_Coverage, 9562,
     /*  300724 */     GIR_EraseRootFromParent_Done,
     /*  300725 */   // Label 5605: @300725
     /*  300725 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(300788), // Rule ID 9563 //
     /*  300730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  300733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  300741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  300744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  300747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300769 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11382:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  300769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /*  300772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  300786 */     GIR_RootConstrainSelectedInstOperands,
     /*  300787 */     // GIR_Coverage, 9563,
     /*  300787 */     GIR_EraseRootFromParent_Done,
     /*  300788 */   // Label 5606: @300788
     /*  300788 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(300851), // Rule ID 9566 //
     /*  300793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  300807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  300810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  300835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300849 */     GIR_RootConstrainSelectedInstOperands,
     /*  300850 */     // GIR_Coverage, 9566,
     /*  300850 */     GIR_EraseRootFromParent_Done,
     /*  300851 */   // Label 5607: @300851
     /*  300851 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(300914), // Rule ID 9567 //
     /*  300856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  300867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  300870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  300873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  300876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  300888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  300895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  300898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300912 */     GIR_RootConstrainSelectedInstOperands,
     /*  300913 */     // GIR_Coverage, 9567,
     /*  300913 */     GIR_EraseRootFromParent_Done,
     /*  300914 */   // Label 5608: @300914
     /*  300914 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(300977), // Rule ID 9570 //
     /*  300919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  300922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  300933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  300936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  300939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  300943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  300951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  300958 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  300958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  300961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  300963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  300965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  300967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  300972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  300975 */     GIR_RootConstrainSelectedInstOperands,
     /*  300976 */     // GIR_Coverage, 9570,
     /*  300976 */     GIR_EraseRootFromParent_Done,
     /*  300977 */   // Label 5609: @300977
     /*  300977 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(301040), // Rule ID 9571 //
     /*  300982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  300985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  300990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  300993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  300996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  300999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301021 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301038 */     GIR_RootConstrainSelectedInstOperands,
     /*  301039 */     // GIR_Coverage, 9571,
     /*  301039 */     GIR_EraseRootFromParent_Done,
     /*  301040 */   // Label 5610: @301040
     /*  301040 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(301103), // Rule ID 9574 //
     /*  301045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301084 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  301084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301101 */     GIR_RootConstrainSelectedInstOperands,
     /*  301102 */     // GIR_Coverage, 9574,
     /*  301102 */     GIR_EraseRootFromParent_Done,
     /*  301103 */   // Label 5611: @301103
     /*  301103 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(301166), // Rule ID 9575 //
     /*  301108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  301119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  301122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  301125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301147 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  301147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  301164 */     GIR_RootConstrainSelectedInstOperands,
     /*  301165 */     // GIR_Coverage, 9575,
     /*  301165 */     GIR_EraseRootFromParent_Done,
     /*  301166 */   // Label 5612: @301166
     /*  301166 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(301229), // Rule ID 9578 //
     /*  301171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301210 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301227 */     GIR_RootConstrainSelectedInstOperands,
     /*  301228 */     // GIR_Coverage, 9578,
     /*  301228 */     GIR_EraseRootFromParent_Done,
     /*  301229 */   // Label 5613: @301229
     /*  301229 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(301292), // Rule ID 9579 //
     /*  301234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  301248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  301251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301273 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301290 */     GIR_RootConstrainSelectedInstOperands,
     /*  301291 */     // GIR_Coverage, 9579,
     /*  301291 */     GIR_EraseRootFromParent_Done,
     /*  301292 */   // Label 5614: @301292
     /*  301292 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(301355), // Rule ID 9582 //
     /*  301297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301353 */     GIR_RootConstrainSelectedInstOperands,
     /*  301354 */     // GIR_Coverage, 9582,
     /*  301354 */     GIR_EraseRootFromParent_Done,
     /*  301355 */   // Label 5615: @301355
     /*  301355 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(301418), // Rule ID 9583 //
     /*  301360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  301374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  301377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301399 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301416 */     GIR_RootConstrainSelectedInstOperands,
     /*  301417 */     // GIR_Coverage, 9583,
     /*  301417 */     GIR_EraseRootFromParent_Done,
     /*  301418 */   // Label 5616: @301418
     /*  301418 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(301481), // Rule ID 9586 //
     /*  301423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  301437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301462 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  301462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301479 */     GIR_RootConstrainSelectedInstOperands,
     /*  301480 */     // GIR_Coverage, 9586,
     /*  301480 */     GIR_EraseRootFromParent_Done,
     /*  301481 */   // Label 5617: @301481
     /*  301481 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(301544), // Rule ID 9587 //
     /*  301486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  301497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  301500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  301503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301525 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  301525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  301542 */     GIR_RootConstrainSelectedInstOperands,
     /*  301543 */     // GIR_Coverage, 9587,
     /*  301543 */     GIR_EraseRootFromParent_Done,
     /*  301544 */   // Label 5618: @301544
     /*  301544 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(301607), // Rule ID 9590 //
     /*  301549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  301563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  301566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301588 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301605 */     GIR_RootConstrainSelectedInstOperands,
     /*  301606 */     // GIR_Coverage, 9590,
     /*  301606 */     GIR_EraseRootFromParent_Done,
     /*  301607 */   // Label 5619: @301607
     /*  301607 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(301670), // Rule ID 9591 //
     /*  301612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  301623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  301626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  301629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301651 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301668 */     GIR_RootConstrainSelectedInstOperands,
     /*  301669 */     // GIR_Coverage, 9591,
     /*  301669 */     GIR_EraseRootFromParent_Done,
     /*  301670 */   // Label 5620: @301670
     /*  301670 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(301733), // Rule ID 9594 //
     /*  301675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  301689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  301692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301714 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301731 */     GIR_RootConstrainSelectedInstOperands,
     /*  301732 */     // GIR_Coverage, 9594,
     /*  301732 */     GIR_EraseRootFromParent_Done,
     /*  301733 */   // Label 5621: @301733
     /*  301733 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(301796), // Rule ID 9595 //
     /*  301738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  301749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  301752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  301755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  301770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301777 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  301780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301794 */     GIR_RootConstrainSelectedInstOperands,
     /*  301795 */     // GIR_Coverage, 9595,
     /*  301795 */     GIR_EraseRootFromParent_Done,
     /*  301796 */   // Label 5622: @301796
     /*  301796 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(301859), // Rule ID 9598 //
     /*  301801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  301804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  301815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  301818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  301840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301857 */     GIR_RootConstrainSelectedInstOperands,
     /*  301858 */     // GIR_Coverage, 9598,
     /*  301858 */     GIR_EraseRootFromParent_Done,
     /*  301859 */   // Label 5623: @301859
     /*  301859 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(301922), // Rule ID 9599 //
     /*  301864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  301867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  301875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  301878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  301881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  301884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  301896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301903 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  301903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  301906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  301920 */     GIR_RootConstrainSelectedInstOperands,
     /*  301921 */     // GIR_Coverage, 9599,
     /*  301921 */     GIR_EraseRootFromParent_Done,
     /*  301922 */   // Label 5624: @301922
     /*  301922 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(301985), // Rule ID 9602 //
     /*  301927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  301930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  301938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  301941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  301944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  301947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  301951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  301959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  301966 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  301966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  301969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  301971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  301973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  301975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  301980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  301983 */     GIR_RootConstrainSelectedInstOperands,
     /*  301984 */     // GIR_Coverage, 9602,
     /*  301984 */     GIR_EraseRootFromParent_Done,
     /*  301985 */   // Label 5625: @301985
     /*  301985 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(302048), // Rule ID 9603 //
     /*  301990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  301993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  301998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  302004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  302007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  302022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302029 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11382:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /*  302032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302046 */     GIR_RootConstrainSelectedInstOperands,
     /*  302047 */     // GIR_Coverage, 9603,
     /*  302047 */     GIR_EraseRootFromParent_Done,
     /*  302048 */   // Label 5626: @302048
     /*  302048 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(302111), // Rule ID 9606 //
     /*  302053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302109 */     GIR_RootConstrainSelectedInstOperands,
     /*  302110 */     // GIR_Coverage, 9606,
     /*  302110 */     GIR_EraseRootFromParent_Done,
     /*  302111 */   // Label 5627: @302111
     /*  302111 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(302174), // Rule ID 9607 //
     /*  302116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  302130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  302133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  302148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302155 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11382:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /*  302158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302172 */     GIR_RootConstrainSelectedInstOperands,
     /*  302173 */     // GIR_Coverage, 9607,
     /*  302173 */     GIR_EraseRootFromParent_Done,
     /*  302174 */   // Label 5628: @302174
     /*  302174 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(302237), // Rule ID 9610 //
     /*  302179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  302182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302218 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  302218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302235 */     GIR_RootConstrainSelectedInstOperands,
     /*  302236 */     // GIR_Coverage, 9610,
     /*  302236 */     GIR_EraseRootFromParent_Done,
     /*  302237 */   // Label 5629: @302237
     /*  302237 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(302300), // Rule ID 9611 //
     /*  302242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  302245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt),
     /*  302250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  302253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  302256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  302259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  302274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302281 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11382:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  302281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /*  302284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  302298 */     GIR_RootConstrainSelectedInstOperands,
     /*  302299 */     // GIR_Coverage, 9611,
     /*  302299 */     GIR_EraseRootFromParent_Done,
     /*  302300 */   // Label 5630: @302300
     /*  302300 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(302363), // Rule ID 9614 //
     /*  302305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302361 */     GIR_RootConstrainSelectedInstOperands,
     /*  302362 */     // GIR_Coverage, 9614,
     /*  302362 */     GIR_EraseRootFromParent_Done,
     /*  302363 */   // Label 5631: @302363
     /*  302363 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(302426), // Rule ID 9615 //
     /*  302368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  302382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  302385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302407 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /*  302410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302424 */     GIR_RootConstrainSelectedInstOperands,
     /*  302425 */     // GIR_Coverage, 9615,
     /*  302425 */     GIR_EraseRootFromParent_Done,
     /*  302426 */   // Label 5632: @302426
     /*  302426 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(302489), // Rule ID 9618 //
     /*  302431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  302445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  302448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302470 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302487 */     GIR_RootConstrainSelectedInstOperands,
     /*  302488 */     // GIR_Coverage, 9618,
     /*  302488 */     GIR_EraseRootFromParent_Done,
     /*  302489 */   // Label 5633: @302489
     /*  302489 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(302552), // Rule ID 9619 //
     /*  302494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  302508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  302511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302533 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302550 */     GIR_RootConstrainSelectedInstOperands,
     /*  302551 */     // GIR_Coverage, 9619,
     /*  302551 */     GIR_EraseRootFromParent_Done,
     /*  302552 */   // Label 5634: @302552
     /*  302552 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(302615), // Rule ID 9622 //
     /*  302557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  302571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  302574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302596 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  302596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  302599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302613 */     GIR_RootConstrainSelectedInstOperands,
     /*  302614 */     // GIR_Coverage, 9622,
     /*  302614 */     GIR_EraseRootFromParent_Done,
     /*  302615 */   // Label 5635: @302615
     /*  302615 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(302678), // Rule ID 9623 //
     /*  302620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  302631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  302634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  302637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302659 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  302659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  302662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  302676 */     GIR_RootConstrainSelectedInstOperands,
     /*  302677 */     // GIR_Coverage, 9623,
     /*  302677 */     GIR_EraseRootFromParent_Done,
     /*  302678 */   // Label 5636: @302678
     /*  302678 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(302741), // Rule ID 9626 //
     /*  302683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  302697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  302700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302722 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302739 */     GIR_RootConstrainSelectedInstOperands,
     /*  302740 */     // GIR_Coverage, 9626,
     /*  302740 */     GIR_EraseRootFromParent_Done,
     /*  302741 */   // Label 5637: @302741
     /*  302741 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(302804), // Rule ID 9627 //
     /*  302746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  302760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  302763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302785 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /*  302788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302802 */     GIR_RootConstrainSelectedInstOperands,
     /*  302803 */     // GIR_Coverage, 9627,
     /*  302803 */     GIR_EraseRootFromParent_Done,
     /*  302804 */   // Label 5638: @302804
     /*  302804 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(302867), // Rule ID 9630 //
     /*  302809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  302823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  302826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  302848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  302851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302865 */     GIR_RootConstrainSelectedInstOperands,
     /*  302866 */     // GIR_Coverage, 9630,
     /*  302866 */     GIR_EraseRootFromParent_Done,
     /*  302867 */   // Label 5639: @302867
     /*  302867 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(302930), // Rule ID 9631 //
     /*  302872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  302875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  302883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  302886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  302889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  302892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302911 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  302911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  302914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  302928 */     GIR_RootConstrainSelectedInstOperands,
     /*  302929 */     // GIR_Coverage, 9631,
     /*  302929 */     GIR_EraseRootFromParent_Done,
     /*  302930 */   // Label 5640: @302930
     /*  302930 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(302993), // Rule ID 9634 //
     /*  302935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  302938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  302943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  302946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  302949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  302952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  302955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  302967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  302974 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  302974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  302977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  302979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  302981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  302983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  302988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  302991 */     GIR_RootConstrainSelectedInstOperands,
     /*  302992 */     // GIR_Coverage, 9634,
     /*  302992 */     GIR_EraseRootFromParent_Done,
     /*  302993 */   // Label 5641: @302993
     /*  302993 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(303056), // Rule ID 9635 //
     /*  302998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  303012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  303015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303037 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /*  303040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303054 */     GIR_RootConstrainSelectedInstOperands,
     /*  303055 */     // GIR_Coverage, 9635,
     /*  303055 */     GIR_EraseRootFromParent_Done,
     /*  303056 */   // Label 5642: @303056
     /*  303056 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(303119), // Rule ID 9638 //
     /*  303061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303117 */     GIR_RootConstrainSelectedInstOperands,
     /*  303118 */     // GIR_Coverage, 9638,
     /*  303118 */     GIR_EraseRootFromParent_Done,
     /*  303119 */   // Label 5643: @303119
     /*  303119 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(303182), // Rule ID 9639 //
     /*  303124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  303138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  303141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303163 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303180 */     GIR_RootConstrainSelectedInstOperands,
     /*  303181 */     // GIR_Coverage, 9639,
     /*  303181 */     GIR_EraseRootFromParent_Done,
     /*  303182 */   // Label 5644: @303182
     /*  303182 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(303245), // Rule ID 9642 //
     /*  303187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303226 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303243 */     GIR_RootConstrainSelectedInstOperands,
     /*  303244 */     // GIR_Coverage, 9642,
     /*  303244 */     GIR_EraseRootFromParent_Done,
     /*  303245 */   // Label 5645: @303245
     /*  303245 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(303308), // Rule ID 9643 //
     /*  303250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  303261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  303264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  303267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303289 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  303289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303306 */     GIR_RootConstrainSelectedInstOperands,
     /*  303307 */     // GIR_Coverage, 9643,
     /*  303307 */     GIR_EraseRootFromParent_Done,
     /*  303308 */   // Label 5646: @303308
     /*  303308 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(303371), // Rule ID 9646 //
     /*  303313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  303352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303369 */     GIR_RootConstrainSelectedInstOperands,
     /*  303370 */     // GIR_Coverage, 9646,
     /*  303370 */     GIR_EraseRootFromParent_Done,
     /*  303371 */   // Label 5647: @303371
     /*  303371 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(303434), // Rule ID 9647 //
     /*  303376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  303387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  303390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  303393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303415 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  303415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  303432 */     GIR_RootConstrainSelectedInstOperands,
     /*  303433 */     // GIR_Coverage, 9647,
     /*  303433 */     GIR_EraseRootFromParent_Done,
     /*  303434 */   // Label 5648: @303434
     /*  303434 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(303497), // Rule ID 9650 //
     /*  303439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  303442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  303453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  303456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303478 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  303478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303495 */     GIR_RootConstrainSelectedInstOperands,
     /*  303496 */     // GIR_Coverage, 9650,
     /*  303496 */     GIR_EraseRootFromParent_Done,
     /*  303497 */   // Label 5649: @303497
     /*  303497 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(303560), // Rule ID 9651 //
     /*  303502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  303505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  303513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  303516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  303519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303541 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11380:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  303541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /*  303544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  303558 */     GIR_RootConstrainSelectedInstOperands,
     /*  303559 */     // GIR_Coverage, 9651,
     /*  303559 */     GIR_EraseRootFromParent_Done,
     /*  303560 */   // Label 5650: @303560
     /*  303560 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(303623), // Rule ID 9654 //
     /*  303565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  303579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  303582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  303607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303621 */     GIR_RootConstrainSelectedInstOperands,
     /*  303622 */     // GIR_Coverage, 9654,
     /*  303622 */     GIR_EraseRootFromParent_Done,
     /*  303623 */   // Label 5651: @303623
     /*  303623 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(303686), // Rule ID 9655 //
     /*  303628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  303639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  303642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  303645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303667 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  303670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303684 */     GIR_RootConstrainSelectedInstOperands,
     /*  303685 */     // GIR_Coverage, 9655,
     /*  303685 */     GIR_EraseRootFromParent_Done,
     /*  303686 */   // Label 5652: @303686
     /*  303686 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(303749), // Rule ID 9658 //
     /*  303691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  303705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  303708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303730 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  303733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303747 */     GIR_RootConstrainSelectedInstOperands,
     /*  303748 */     // GIR_Coverage, 9658,
     /*  303748 */     GIR_EraseRootFromParent_Done,
     /*  303749 */   // Label 5653: @303749
     /*  303749 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(303812), // Rule ID 9659 //
     /*  303754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  303765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  303768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  303771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  303786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303793 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  303796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303810 */     GIR_RootConstrainSelectedInstOperands,
     /*  303811 */     // GIR_Coverage, 9659,
     /*  303811 */     GIR_EraseRootFromParent_Done,
     /*  303812 */   // Label 5654: @303812
     /*  303812 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(303875), // Rule ID 9662 //
     /*  303817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  303828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  303831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  303834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303856 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  303856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  303859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303873 */     GIR_RootConstrainSelectedInstOperands,
     /*  303874 */     // GIR_Coverage, 9662,
     /*  303874 */     GIR_EraseRootFromParent_Done,
     /*  303875 */   // Label 5655: @303875
     /*  303875 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(303938), // Rule ID 9663 //
     /*  303880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  303883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  303891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  303894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  303897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  303900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  303912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303919 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  303919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  303922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  303936 */     GIR_RootConstrainSelectedInstOperands,
     /*  303937 */     // GIR_Coverage, 9663,
     /*  303937 */     GIR_EraseRootFromParent_Done,
     /*  303938 */   // Label 5656: @303938
     /*  303938 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(304001), // Rule ID 9666 //
     /*  303943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  303946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  303951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  303954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  303957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  303960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  303963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  303967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  303975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  303982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  303982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  303985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  303987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  303989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  303991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  303996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  303999 */     GIR_RootConstrainSelectedInstOperands,
     /*  304000 */     // GIR_Coverage, 9666,
     /*  304000 */     GIR_EraseRootFromParent_Done,
     /*  304001 */   // Label 5657: @304001
     /*  304001 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(304064), // Rule ID 9667 //
     /*  304006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  304020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  304023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304045 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304062 */     GIR_RootConstrainSelectedInstOperands,
     /*  304063 */     // GIR_Coverage, 9667,
     /*  304063 */     GIR_EraseRootFromParent_Done,
     /*  304064 */   // Label 5658: @304064
     /*  304064 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(304127), // Rule ID 9670 //
     /*  304069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304125 */     GIR_RootConstrainSelectedInstOperands,
     /*  304126 */     // GIR_Coverage, 9670,
     /*  304126 */     GIR_EraseRootFromParent_Done,
     /*  304127 */   // Label 5659: @304127
     /*  304127 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(304190), // Rule ID 9671 //
     /*  304132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  304146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  304149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304171 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304188 */     GIR_RootConstrainSelectedInstOperands,
     /*  304189 */     // GIR_Coverage, 9671,
     /*  304189 */     GIR_EraseRootFromParent_Done,
     /*  304190 */   // Label 5660: @304190
     /*  304190 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(304253), // Rule ID 9674 //
     /*  304195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304234 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  304234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304251 */     GIR_RootConstrainSelectedInstOperands,
     /*  304252 */     // GIR_Coverage, 9674,
     /*  304252 */     GIR_EraseRootFromParent_Done,
     /*  304253 */   // Label 5661: @304253
     /*  304253 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(304316), // Rule ID 9675 //
     /*  304258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  304269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  304272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  304275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304297 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  304297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  304314 */     GIR_RootConstrainSelectedInstOperands,
     /*  304315 */     // GIR_Coverage, 9675,
     /*  304315 */     GIR_EraseRootFromParent_Done,
     /*  304316 */   // Label 5662: @304316
     /*  304316 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(304379), // Rule ID 9678 //
     /*  304321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304377 */     GIR_RootConstrainSelectedInstOperands,
     /*  304378 */     // GIR_Coverage, 9678,
     /*  304378 */     GIR_EraseRootFromParent_Done,
     /*  304379 */   // Label 5663: @304379
     /*  304379 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(304442), // Rule ID 9679 //
     /*  304384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  304398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  304401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304423 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304440 */     GIR_RootConstrainSelectedInstOperands,
     /*  304441 */     // GIR_Coverage, 9679,
     /*  304441 */     GIR_EraseRootFromParent_Done,
     /*  304442 */   // Label 5664: @304442
     /*  304442 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(304505), // Rule ID 9682 //
     /*  304447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  304461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  304464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304486 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304503 */     GIR_RootConstrainSelectedInstOperands,
     /*  304504 */     // GIR_Coverage, 9682,
     /*  304504 */     GIR_EraseRootFromParent_Done,
     /*  304505 */   // Label 5665: @304505
     /*  304505 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(304568), // Rule ID 9683 //
     /*  304510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  304524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  304527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304549 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304566 */     GIR_RootConstrainSelectedInstOperands,
     /*  304567 */     // GIR_Coverage, 9683,
     /*  304567 */     GIR_EraseRootFromParent_Done,
     /*  304568 */   // Label 5666: @304568
     /*  304568 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(304631), // Rule ID 9686 //
     /*  304573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  304576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  304587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  304590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304612 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  304612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304629 */     GIR_RootConstrainSelectedInstOperands,
     /*  304630 */     // GIR_Coverage, 9686,
     /*  304630 */     GIR_EraseRootFromParent_Done,
     /*  304631 */   // Label 5667: @304631
     /*  304631 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(304694), // Rule ID 9687 //
     /*  304636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  304639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  304647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  304650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  304653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304675 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  304675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  304692 */     GIR_RootConstrainSelectedInstOperands,
     /*  304693 */     // GIR_Coverage, 9687,
     /*  304693 */     GIR_EraseRootFromParent_Done,
     /*  304694 */   // Label 5668: @304694
     /*  304694 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(304757), // Rule ID 9690 //
     /*  304699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  304713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  304716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304738 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  304738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304755 */     GIR_RootConstrainSelectedInstOperands,
     /*  304756 */     // GIR_Coverage, 9690,
     /*  304756 */     GIR_EraseRootFromParent_Done,
     /*  304757 */   // Label 5669: @304757
     /*  304757 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(304820), // Rule ID 9691 //
     /*  304762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  304773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  304776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  304779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  304794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304801 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11380:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /*  304804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304818 */     GIR_RootConstrainSelectedInstOperands,
     /*  304819 */     // GIR_Coverage, 9691,
     /*  304819 */     GIR_EraseRootFromParent_Done,
     /*  304820 */   // Label 5670: @304820
     /*  304820 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(304883), // Rule ID 9694 //
     /*  304825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  304839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  304842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  304864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304881 */     GIR_RootConstrainSelectedInstOperands,
     /*  304882 */     // GIR_Coverage, 9694,
     /*  304882 */     GIR_EraseRootFromParent_Done,
     /*  304883 */   // Label 5671: @304883
     /*  304883 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(304946), // Rule ID 9695 //
     /*  304888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  304891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  304899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  304902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  304905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  304908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  304920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304927 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11380:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  304927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /*  304930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  304941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  304944 */     GIR_RootConstrainSelectedInstOperands,
     /*  304945 */     // GIR_Coverage, 9695,
     /*  304945 */     GIR_EraseRootFromParent_Done,
     /*  304946 */   // Label 5672: @304946
     /*  304946 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(305009), // Rule ID 9698 //
     /*  304951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  304954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  304959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  304962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  304965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  304968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  304971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  304975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  304983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  304990 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  304990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  304993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  304995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  304997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  304999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305007 */     GIR_RootConstrainSelectedInstOperands,
     /*  305008 */     // GIR_Coverage, 9698,
     /*  305008 */     GIR_EraseRootFromParent_Done,
     /*  305009 */   // Label 5673: @305009
     /*  305009 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(305072), // Rule ID 9699 //
     /*  305014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  305017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu),
     /*  305022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  305028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  305031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  305046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305053 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11380:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  305053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /*  305056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  305070 */     GIR_RootConstrainSelectedInstOperands,
     /*  305071 */     // GIR_Coverage, 9699,
     /*  305071 */     GIR_EraseRootFromParent_Done,
     /*  305072 */   // Label 5674: @305072
     /*  305072 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(305135), // Rule ID 9702 //
     /*  305077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305133 */     GIR_RootConstrainSelectedInstOperands,
     /*  305134 */     // GIR_Coverage, 9702,
     /*  305134 */     GIR_EraseRootFromParent_Done,
     /*  305135 */   // Label 5675: @305135
     /*  305135 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(305198), // Rule ID 9703 //
     /*  305140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  305154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  305157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305179 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /*  305182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305196 */     GIR_RootConstrainSelectedInstOperands,
     /*  305197 */     // GIR_Coverage, 9703,
     /*  305197 */     GIR_EraseRootFromParent_Done,
     /*  305198 */   // Label 5676: @305198
     /*  305198 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(305261), // Rule ID 9706 //
     /*  305203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305242 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305259 */     GIR_RootConstrainSelectedInstOperands,
     /*  305260 */     // GIR_Coverage, 9706,
     /*  305260 */     GIR_EraseRootFromParent_Done,
     /*  305261 */   // Label 5677: @305261
     /*  305261 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(305324), // Rule ID 9707 //
     /*  305266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  305280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  305283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305305 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305322 */     GIR_RootConstrainSelectedInstOperands,
     /*  305323 */     // GIR_Coverage, 9707,
     /*  305323 */     GIR_EraseRootFromParent_Done,
     /*  305324 */   // Label 5678: @305324
     /*  305324 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(305387), // Rule ID 9710 //
     /*  305329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305368 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305385 */     GIR_RootConstrainSelectedInstOperands,
     /*  305386 */     // GIR_Coverage, 9710,
     /*  305386 */     GIR_EraseRootFromParent_Done,
     /*  305387 */   // Label 5679: @305387
     /*  305387 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(305450), // Rule ID 9711 //
     /*  305392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  305406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  305409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305431 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305448 */     GIR_RootConstrainSelectedInstOperands,
     /*  305449 */     // GIR_Coverage, 9711,
     /*  305449 */     GIR_EraseRootFromParent_Done,
     /*  305450 */   // Label 5680: @305450
     /*  305450 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(305513), // Rule ID 9714 //
     /*  305455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  305469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  305472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305494 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305511 */     GIR_RootConstrainSelectedInstOperands,
     /*  305512 */     // GIR_Coverage, 9714,
     /*  305512 */     GIR_EraseRootFromParent_Done,
     /*  305513 */   // Label 5681: @305513
     /*  305513 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(305576), // Rule ID 9715 //
     /*  305518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  305532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  305535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305557 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /*  305560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305574 */     GIR_RootConstrainSelectedInstOperands,
     /*  305575 */     // GIR_Coverage, 9715,
     /*  305575 */     GIR_EraseRootFromParent_Done,
     /*  305576 */   // Label 5682: @305576
     /*  305576 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(305639), // Rule ID 9718 //
     /*  305581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  305595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  305598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305637 */     GIR_RootConstrainSelectedInstOperands,
     /*  305638 */     // GIR_Coverage, 9718,
     /*  305638 */     GIR_EraseRootFromParent_Done,
     /*  305639 */   // Label 5683: @305639
     /*  305639 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(305702), // Rule ID 9719 //
     /*  305644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  305655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  305658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  305661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305683 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  305683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  305700 */     GIR_RootConstrainSelectedInstOperands,
     /*  305701 */     // GIR_Coverage, 9719,
     /*  305701 */     GIR_EraseRootFromParent_Done,
     /*  305702 */   // Label 5684: @305702
     /*  305702 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(305765), // Rule ID 9722 //
     /*  305707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  305721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  305724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305746 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  305746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305763 */     GIR_RootConstrainSelectedInstOperands,
     /*  305764 */     // GIR_Coverage, 9722,
     /*  305764 */     GIR_EraseRootFromParent_Done,
     /*  305765 */   // Label 5685: @305765
     /*  305765 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(305828), // Rule ID 9723 //
     /*  305770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  305781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  305784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  305787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305809 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  305809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /*  305812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  305826 */     GIR_RootConstrainSelectedInstOperands,
     /*  305827 */     // GIR_Coverage, 9723,
     /*  305827 */     GIR_EraseRootFromParent_Done,
     /*  305828 */   // Label 5686: @305828
     /*  305828 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(305891), // Rule ID 9726 //
     /*  305833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  305847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  305850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  305872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  305875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305889 */     GIR_RootConstrainSelectedInstOperands,
     /*  305890 */     // GIR_Coverage, 9726,
     /*  305890 */     GIR_EraseRootFromParent_Done,
     /*  305891 */   // Label 5687: @305891
     /*  305891 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(305954), // Rule ID 9727 //
     /*  305896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  305899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  305907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  305910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  305913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  305916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305935 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  305935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  305938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  305940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  305942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  305944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  305949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  305952 */     GIR_RootConstrainSelectedInstOperands,
     /*  305953 */     // GIR_Coverage, 9727,
     /*  305953 */     GIR_EraseRootFromParent_Done,
     /*  305954 */   // Label 5688: @305954
     /*  305954 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(306017), // Rule ID 9730 //
     /*  305959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  305962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  305967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  305970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  305973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  305976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  305979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  305991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  305998 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  305998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306015 */     GIR_RootConstrainSelectedInstOperands,
     /*  306016 */     // GIR_Coverage, 9730,
     /*  306016 */     GIR_EraseRootFromParent_Done,
     /*  306017 */   // Label 5689: @306017
     /*  306017 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(306080), // Rule ID 9731 //
     /*  306022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  306033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  306036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  306039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306061 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306078 */     GIR_RootConstrainSelectedInstOperands,
     /*  306079 */     // GIR_Coverage, 9731,
     /*  306079 */     GIR_EraseRootFromParent_Done,
     /*  306080 */   // Label 5690: @306080
     /*  306080 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(306143), // Rule ID 9734 //
     /*  306085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  306124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306141 */     GIR_RootConstrainSelectedInstOperands,
     /*  306142 */     // GIR_Coverage, 9734,
     /*  306142 */     GIR_EraseRootFromParent_Done,
     /*  306143 */   // Label 5691: @306143
     /*  306143 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(306206), // Rule ID 9735 //
     /*  306148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  306159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  306162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  306165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306187 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  306187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  306204 */     GIR_RootConstrainSelectedInstOperands,
     /*  306205 */     // GIR_Coverage, 9735,
     /*  306205 */     GIR_EraseRootFromParent_Done,
     /*  306206 */   // Label 5692: @306206
     /*  306206 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(306269), // Rule ID 9738 //
     /*  306211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  306214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  306250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306267 */     GIR_RootConstrainSelectedInstOperands,
     /*  306268 */     // GIR_Coverage, 9738,
     /*  306268 */     GIR_EraseRootFromParent_Done,
     /*  306269 */   // Label 5693: @306269
     /*  306269 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(306332), // Rule ID 9739 //
     /*  306274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  306277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  306285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  306288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  306291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306313 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11378:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  306313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /*  306316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  306330 */     GIR_RootConstrainSelectedInstOperands,
     /*  306331 */     // GIR_Coverage, 9739,
     /*  306331 */     GIR_EraseRootFromParent_Done,
     /*  306332 */   // Label 5694: @306332
     /*  306332 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(306395), // Rule ID 9742 //
     /*  306337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306376 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306393 */     GIR_RootConstrainSelectedInstOperands,
     /*  306394 */     // GIR_Coverage, 9742,
     /*  306394 */     GIR_EraseRootFromParent_Done,
     /*  306395 */   // Label 5695: @306395
     /*  306395 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(306458), // Rule ID 9743 //
     /*  306400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  306414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  306417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306439 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306456 */     GIR_RootConstrainSelectedInstOperands,
     /*  306457 */     // GIR_Coverage, 9743,
     /*  306457 */     GIR_EraseRootFromParent_Done,
     /*  306458 */   // Label 5696: @306458
     /*  306458 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(306521), // Rule ID 9746 //
     /*  306463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  306474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  306477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  306480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  306505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306519 */     GIR_RootConstrainSelectedInstOperands,
     /*  306520 */     // GIR_Coverage, 9746,
     /*  306520 */     GIR_EraseRootFromParent_Done,
     /*  306521 */   // Label 5697: @306521
     /*  306521 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(306584), // Rule ID 9747 //
     /*  306526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  306537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  306540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  306543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306565 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  306568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306582 */     GIR_RootConstrainSelectedInstOperands,
     /*  306583 */     // GIR_Coverage, 9747,
     /*  306583 */     GIR_EraseRootFromParent_Done,
     /*  306584 */   // Label 5698: @306584
     /*  306584 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(306647), // Rule ID 9750 //
     /*  306589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  306600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  306603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  306606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306628 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  306628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  306631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306645 */     GIR_RootConstrainSelectedInstOperands,
     /*  306646 */     // GIR_Coverage, 9750,
     /*  306646 */     GIR_EraseRootFromParent_Done,
     /*  306647 */   // Label 5699: @306647
     /*  306647 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(306710), // Rule ID 9751 //
     /*  306652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  306663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  306666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  306669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306691 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  306691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  306694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  306708 */     GIR_RootConstrainSelectedInstOperands,
     /*  306709 */     // GIR_Coverage, 9751,
     /*  306709 */     GIR_EraseRootFromParent_Done,
     /*  306710 */   // Label 5700: @306710
     /*  306710 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(306773), // Rule ID 9754 //
     /*  306715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  306729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  306732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306754 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306771 */     GIR_RootConstrainSelectedInstOperands,
     /*  306772 */     // GIR_Coverage, 9754,
     /*  306772 */     GIR_EraseRootFromParent_Done,
     /*  306773 */   // Label 5701: @306773
     /*  306773 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(306836), // Rule ID 9755 //
     /*  306778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  306789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  306792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  306795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  306810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306817 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  306820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306834 */     GIR_RootConstrainSelectedInstOperands,
     /*  306835 */     // GIR_Coverage, 9755,
     /*  306835 */     GIR_EraseRootFromParent_Done,
     /*  306836 */   // Label 5702: @306836
     /*  306836 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(306899), // Rule ID 9758 //
     /*  306841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  306855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  306858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306880 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  306880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  306883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306897 */     GIR_RootConstrainSelectedInstOperands,
     /*  306898 */     // GIR_Coverage, 9758,
     /*  306898 */     GIR_EraseRootFromParent_Done,
     /*  306899 */   // Label 5703: @306899
     /*  306899 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(306962), // Rule ID 9759 //
     /*  306904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  306907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  306915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  306918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  306921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  306924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  306936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  306943 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  306943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  306946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  306948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  306950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  306952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  306957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  306960 */     GIR_RootConstrainSelectedInstOperands,
     /*  306961 */     // GIR_Coverage, 9759,
     /*  306961 */     GIR_EraseRootFromParent_Done,
     /*  306962 */   // Label 5704: @306962
     /*  306962 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(307025), // Rule ID 9762 //
     /*  306967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  306970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  306975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  306978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  306981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  306984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  306987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  306991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  306999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307006 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  307006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307023 */     GIR_RootConstrainSelectedInstOperands,
     /*  307024 */     // GIR_Coverage, 9762,
     /*  307024 */     GIR_EraseRootFromParent_Done,
     /*  307025 */   // Label 5705: @307025
     /*  307025 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(307088), // Rule ID 9763 //
     /*  307030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  307041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  307044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  307047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307069 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  307069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  307086 */     GIR_RootConstrainSelectedInstOperands,
     /*  307087 */     // GIR_Coverage, 9763,
     /*  307087 */     GIR_EraseRootFromParent_Done,
     /*  307088 */   // Label 5706: @307088
     /*  307088 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(307151), // Rule ID 9766 //
     /*  307093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307149 */     GIR_RootConstrainSelectedInstOperands,
     /*  307150 */     // GIR_Coverage, 9766,
     /*  307150 */     GIR_EraseRootFromParent_Done,
     /*  307151 */   // Label 5707: @307151
     /*  307151 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(307214), // Rule ID 9767 //
     /*  307156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  307170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  307173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307212 */     GIR_RootConstrainSelectedInstOperands,
     /*  307213 */     // GIR_Coverage, 9767,
     /*  307213 */     GIR_EraseRootFromParent_Done,
     /*  307214 */   // Label 5708: @307214
     /*  307214 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(307277), // Rule ID 9770 //
     /*  307219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307258 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307275 */     GIR_RootConstrainSelectedInstOperands,
     /*  307276 */     // GIR_Coverage, 9770,
     /*  307276 */     GIR_EraseRootFromParent_Done,
     /*  307277 */   // Label 5709: @307277
     /*  307277 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(307340), // Rule ID 9771 //
     /*  307282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  307296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  307299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307338 */     GIR_RootConstrainSelectedInstOperands,
     /*  307339 */     // GIR_Coverage, 9771,
     /*  307339 */     GIR_EraseRootFromParent_Done,
     /*  307340 */   // Label 5710: @307340
     /*  307340 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(307403), // Rule ID 9774 //
     /*  307345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  307384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307401 */     GIR_RootConstrainSelectedInstOperands,
     /*  307402 */     // GIR_Coverage, 9774,
     /*  307402 */     GIR_EraseRootFromParent_Done,
     /*  307403 */   // Label 5711: @307403
     /*  307403 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(307466), // Rule ID 9775 //
     /*  307408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  307419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  307422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  307425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307447 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  307447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  307464 */     GIR_RootConstrainSelectedInstOperands,
     /*  307465 */     // GIR_Coverage, 9775,
     /*  307465 */     GIR_EraseRootFromParent_Done,
     /*  307466 */   // Label 5712: @307466
     /*  307466 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(307529), // Rule ID 9778 //
     /*  307471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  307485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  307488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307510 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307527 */     GIR_RootConstrainSelectedInstOperands,
     /*  307528 */     // GIR_Coverage, 9778,
     /*  307528 */     GIR_EraseRootFromParent_Done,
     /*  307529 */   // Label 5713: @307529
     /*  307529 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(307592), // Rule ID 9779 //
     /*  307534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  307545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  307548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  307551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  307566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307573 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11378:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /*  307576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307590 */     GIR_RootConstrainSelectedInstOperands,
     /*  307591 */     // GIR_Coverage, 9779,
     /*  307591 */     GIR_EraseRootFromParent_Done,
     /*  307592 */   // Label 5714: @307592
     /*  307592 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(307655), // Rule ID 9782 //
     /*  307597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  307611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  307614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307636 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307653 */     GIR_RootConstrainSelectedInstOperands,
     /*  307654 */     // GIR_Coverage, 9782,
     /*  307654 */     GIR_EraseRootFromParent_Done,
     /*  307655 */   // Label 5715: @307655
     /*  307655 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(307718), // Rule ID 9783 //
     /*  307660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  307671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  307674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  307677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  307692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307699 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11378:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /*  307702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307716 */     GIR_RootConstrainSelectedInstOperands,
     /*  307717 */     // GIR_Coverage, 9783,
     /*  307717 */     GIR_EraseRootFromParent_Done,
     /*  307718 */   // Label 5716: @307718
     /*  307718 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(307781), // Rule ID 9786 //
     /*  307723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  307726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  307737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  307740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307762 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  307762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307779 */     GIR_RootConstrainSelectedInstOperands,
     /*  307780 */     // GIR_Coverage, 9786,
     /*  307780 */     GIR_EraseRootFromParent_Done,
     /*  307781 */   // Label 5717: @307781
     /*  307781 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(307844), // Rule ID 9787 //
     /*  307786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  307789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge),
     /*  307794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  307797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  307800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  307803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  307818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307825 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11378:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  307825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /*  307828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  307834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  307842 */     GIR_RootConstrainSelectedInstOperands,
     /*  307843 */     // GIR_Coverage, 9787,
     /*  307843 */     GIR_EraseRootFromParent_Done,
     /*  307844 */   // Label 5718: @307844
     /*  307844 */   GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(307910), // Rule ID 13862 //
     /*  307849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  307857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  307860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  307863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  307866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  307869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307888 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  307888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  307891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307908 */     GIR_RootConstrainSelectedInstOperands,
     /*  307909 */     // GIR_Coverage, 13862,
     /*  307909 */     GIR_EraseRootFromParent_Done,
     /*  307910 */   // Label 5719: @307910
     /*  307910 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(307976), // Rule ID 13863 //
     /*  307915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  307918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  307923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  307926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  307929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  307932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  307935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  307947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  307954 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } ?:{ *:[nxv1i8] }:$passthru, ?:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  307954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /*  307957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  307959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  307961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  307963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  307968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  307971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  307974 */     GIR_RootConstrainSelectedInstOperands,
     /*  307975 */     // GIR_Coverage, 13863,
     /*  307975 */     GIR_EraseRootFromParent_Done,
     /*  307976 */   // Label 5720: @307976
     /*  307976 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(308042), // Rule ID 13864 //
     /*  307981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  307984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  307989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  307992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  307995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  307998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308020 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308040 */     GIR_RootConstrainSelectedInstOperands,
     /*  308041 */     // GIR_Coverage, 13864,
     /*  308041 */     GIR_EraseRootFromParent_Done,
     /*  308042 */   // Label 5721: @308042
     /*  308042 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(308108), // Rule ID 13865 //
     /*  308047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  308058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  308061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  308064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308086 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } ?:{ *:[nxv2i8] }:$passthru, ?:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308106 */     GIR_RootConstrainSelectedInstOperands,
     /*  308107 */     // GIR_Coverage, 13865,
     /*  308107 */     GIR_EraseRootFromParent_Done,
     /*  308108 */   // Label 5722: @308108
     /*  308108 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(308174), // Rule ID 13866 //
     /*  308113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308152 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308172 */     GIR_RootConstrainSelectedInstOperands,
     /*  308173 */     // GIR_Coverage, 13866,
     /*  308173 */     GIR_EraseRootFromParent_Done,
     /*  308174 */   // Label 5723: @308174
     /*  308174 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(308240), // Rule ID 13867 //
     /*  308179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  308190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  308193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  308196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } ?:{ *:[nxv4i8] }:$passthru, ?:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308238 */     GIR_RootConstrainSelectedInstOperands,
     /*  308239 */     // GIR_Coverage, 13867,
     /*  308239 */     GIR_EraseRootFromParent_Done,
     /*  308240 */   // Label 5724: @308240
     /*  308240 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(308306), // Rule ID 13868 //
     /*  308245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308304 */     GIR_RootConstrainSelectedInstOperands,
     /*  308305 */     // GIR_Coverage, 13868,
     /*  308305 */     GIR_EraseRootFromParent_Done,
     /*  308306 */   // Label 5725: @308306
     /*  308306 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(308372), // Rule ID 13869 //
     /*  308311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  308322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  308325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  308328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308350 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } ?:{ *:[nxv1i16] }:$passthru, ?:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  308353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308370 */     GIR_RootConstrainSelectedInstOperands,
     /*  308371 */     // GIR_Coverage, 13869,
     /*  308371 */     GIR_EraseRootFromParent_Done,
     /*  308372 */   // Label 5726: @308372
     /*  308372 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(308438), // Rule ID 13870 //
     /*  308377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308436 */     GIR_RootConstrainSelectedInstOperands,
     /*  308437 */     // GIR_Coverage, 13870,
     /*  308437 */     GIR_EraseRootFromParent_Done,
     /*  308438 */   // Label 5727: @308438
     /*  308438 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(308504), // Rule ID 13871 //
     /*  308443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  308454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  308457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  308460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } ?:{ *:[nxv2i16] }:$passthru, ?:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308502 */     GIR_RootConstrainSelectedInstOperands,
     /*  308503 */     // GIR_Coverage, 13871,
     /*  308503 */     GIR_EraseRootFromParent_Done,
     /*  308504 */   // Label 5728: @308504
     /*  308504 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(308570), // Rule ID 13872 //
     /*  308509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  308520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  308523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  308526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308548 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  308548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308568 */     GIR_RootConstrainSelectedInstOperands,
     /*  308569 */     // GIR_Coverage, 13872,
     /*  308569 */     GIR_EraseRootFromParent_Done,
     /*  308570 */   // Label 5729: @308570
     /*  308570 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(308636), // Rule ID 13873 //
     /*  308575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  308586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  308589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  308592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } ?:{ *:[nxv1i32] }:$passthru, ?:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  308614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  308617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308634 */     GIR_RootConstrainSelectedInstOperands,
     /*  308635 */     // GIR_Coverage, 13873,
     /*  308635 */     GIR_EraseRootFromParent_Done,
     /*  308636 */   // Label 5730: @308636
     /*  308636 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(308702), // Rule ID 13874 //
     /*  308641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  308652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  308655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  308658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  308680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  308683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308700 */     GIR_RootConstrainSelectedInstOperands,
     /*  308701 */     // GIR_Coverage, 13874,
     /*  308701 */     GIR_EraseRootFromParent_Done,
     /*  308702 */   // Label 5731: @308702
     /*  308702 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(308768), // Rule ID 13875 //
     /*  308707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  308718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  308721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  308724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308746 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11409:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } ?:{ *:[nxv8i8] }:$passthru, ?:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  308746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  308749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  308763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308766 */     GIR_RootConstrainSelectedInstOperands,
     /*  308767 */     // GIR_Coverage, 13875,
     /*  308767 */     GIR_EraseRootFromParent_Done,
     /*  308768 */   // Label 5732: @308768
     /*  308768 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(308834), // Rule ID 13876 //
     /*  308773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  308784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  308787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  308790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  308812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  308815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308832 */     GIR_RootConstrainSelectedInstOperands,
     /*  308833 */     // GIR_Coverage, 13876,
     /*  308833 */     GIR_EraseRootFromParent_Done,
     /*  308834 */   // Label 5733: @308834
     /*  308834 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(308900), // Rule ID 13877 //
     /*  308839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  308850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  308853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  308856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } ?:{ *:[nxv4i16] }:$passthru, ?:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  308878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  308881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  308895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308898 */     GIR_RootConstrainSelectedInstOperands,
     /*  308899 */     // GIR_Coverage, 13877,
     /*  308899 */     GIR_EraseRootFromParent_Done,
     /*  308900 */   // Label 5734: @308900
     /*  308900 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(308966), // Rule ID 13878 //
     /*  308905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  308908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  308916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  308919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  308922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  308925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  308944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  308944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  308947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  308949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  308951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  308953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  308958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  308961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  308964 */     GIR_RootConstrainSelectedInstOperands,
     /*  308965 */     // GIR_Coverage, 13878,
     /*  308965 */     GIR_EraseRootFromParent_Done,
     /*  308966 */   // Label 5735: @308966
     /*  308966 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(309032), // Rule ID 13879 //
     /*  308971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  308974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  308979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  308982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  308985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  308988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  308991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  308999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309010 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } ?:{ *:[nxv2i32] }:$passthru, ?:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  309010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  309027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309030 */     GIR_RootConstrainSelectedInstOperands,
     /*  309031 */     // GIR_Coverage, 13879,
     /*  309031 */     GIR_EraseRootFromParent_Done,
     /*  309032 */   // Label 5736: @309032
     /*  309032 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(309098), // Rule ID 13880 //
     /*  309037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  309040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  309076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309096 */     GIR_RootConstrainSelectedInstOperands,
     /*  309097 */     // GIR_Coverage, 13880,
     /*  309097 */     GIR_EraseRootFromParent_Done,
     /*  309098 */   // Label 5737: @309098
     /*  309098 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(309164), // Rule ID 13881 //
     /*  309103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  309106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  309114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  309117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  309120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  309135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309142 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } ?:{ *:[nxv1i64] }:$passthru, ?:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  309142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  309145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  309159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309162 */     GIR_RootConstrainSelectedInstOperands,
     /*  309163 */     // GIR_Coverage, 13881,
     /*  309163 */     GIR_EraseRootFromParent_Done,
     /*  309164 */   // Label 5738: @309164
     /*  309164 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(309230), // Rule ID 13882 //
     /*  309169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309228 */     GIR_RootConstrainSelectedInstOperands,
     /*  309229 */     // GIR_Coverage, 13882,
     /*  309229 */     GIR_EraseRootFromParent_Done,
     /*  309230 */   // Label 5739: @309230
     /*  309230 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(309296), // Rule ID 13883 //
     /*  309235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  309246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  309249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  309252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$passthru, ?:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309294 */     GIR_RootConstrainSelectedInstOperands,
     /*  309295 */     // GIR_Coverage, 13883,
     /*  309295 */     GIR_EraseRootFromParent_Done,
     /*  309296 */   // Label 5740: @309296
     /*  309296 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(309362), // Rule ID 13884 //
     /*  309301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309340 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309360 */     GIR_RootConstrainSelectedInstOperands,
     /*  309361 */     // GIR_Coverage, 13884,
     /*  309361 */     GIR_EraseRootFromParent_Done,
     /*  309362 */   // Label 5741: @309362
     /*  309362 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(309428), // Rule ID 13885 //
     /*  309367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  309378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  309381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  309384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309406 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } ?:{ *:[nxv32i8] }:$passthru, ?:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309426 */     GIR_RootConstrainSelectedInstOperands,
     /*  309427 */     // GIR_Coverage, 13885,
     /*  309427 */     GIR_EraseRootFromParent_Done,
     /*  309428 */   // Label 5742: @309428
     /*  309428 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(309494), // Rule ID 13886 //
     /*  309433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  309444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  309447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  309450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309472 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  309472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309492 */     GIR_RootConstrainSelectedInstOperands,
     /*  309493 */     // GIR_Coverage, 13886,
     /*  309493 */     GIR_EraseRootFromParent_Done,
     /*  309494 */   // Label 5743: @309494
     /*  309494 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(309560), // Rule ID 13887 //
     /*  309499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  309510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  309513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  309516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309538 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } ?:{ *:[nxv64i8] }:$passthru, ?:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  309538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  309555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309558 */     GIR_RootConstrainSelectedInstOperands,
     /*  309559 */     // GIR_Coverage, 13887,
     /*  309559 */     GIR_EraseRootFromParent_Done,
     /*  309560 */   // Label 5744: @309560
     /*  309560 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(309626), // Rule ID 13888 //
     /*  309565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  309576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  309579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  309582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309604 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309624 */     GIR_RootConstrainSelectedInstOperands,
     /*  309625 */     // GIR_Coverage, 13888,
     /*  309625 */     GIR_EraseRootFromParent_Done,
     /*  309626 */   // Label 5745: @309626
     /*  309626 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(309692), // Rule ID 13889 //
     /*  309631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  309642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  309645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  309648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$passthru, ?:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  309673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309690 */     GIR_RootConstrainSelectedInstOperands,
     /*  309691 */     // GIR_Coverage, 13889,
     /*  309691 */     GIR_EraseRootFromParent_Done,
     /*  309692 */   // Label 5746: @309692
     /*  309692 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(309758), // Rule ID 13890 //
     /*  309697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  309708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  309711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  309714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309736 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309756 */     GIR_RootConstrainSelectedInstOperands,
     /*  309757 */     // GIR_Coverage, 13890,
     /*  309757 */     GIR_EraseRootFromParent_Done,
     /*  309758 */   // Label 5747: @309758
     /*  309758 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(309824), // Rule ID 13891 //
     /*  309763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  309774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  309777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  309780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  309795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } ?:{ *:[nxv16i16] }:$passthru, ?:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  309805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309822 */     GIR_RootConstrainSelectedInstOperands,
     /*  309823 */     // GIR_Coverage, 13891,
     /*  309823 */     GIR_EraseRootFromParent_Done,
     /*  309824 */   // Label 5748: @309824
     /*  309824 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(309890), // Rule ID 13892 //
     /*  309829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  309840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  309843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  309846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  309868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309888 */     GIR_RootConstrainSelectedInstOperands,
     /*  309889 */     // GIR_Coverage, 13892,
     /*  309889 */     GIR_EraseRootFromParent_Done,
     /*  309890 */   // Label 5749: @309890
     /*  309890 */   GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(309956), // Rule ID 13893 //
     /*  309895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  309898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  309906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  309909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  309912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  309915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  309927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  309934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } ?:{ *:[nxv32i16] }:$passthru, ?:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  309934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  309937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  309939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  309941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  309943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  309948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  309951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  309954 */     GIR_RootConstrainSelectedInstOperands,
     /*  309955 */     // GIR_Coverage, 13893,
     /*  309955 */     GIR_EraseRootFromParent_Done,
     /*  309956 */   // Label 5750: @309956
     /*  309956 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(310022), // Rule ID 13894 //
     /*  309961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  309964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  309969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  309972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  309975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  309978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  309981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  309993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310020 */     GIR_RootConstrainSelectedInstOperands,
     /*  310021 */     // GIR_Coverage, 13894,
     /*  310021 */     GIR_EraseRootFromParent_Done,
     /*  310022 */   // Label 5751: @310022
     /*  310022 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(310088), // Rule ID 13895 //
     /*  310027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  310038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  310041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  310044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$passthru, ?:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310086 */     GIR_RootConstrainSelectedInstOperands,
     /*  310087 */     // GIR_Coverage, 13895,
     /*  310087 */     GIR_EraseRootFromParent_Done,
     /*  310088 */   // Label 5752: @310088
     /*  310088 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(310154), // Rule ID 13896 //
     /*  310093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310152 */     GIR_RootConstrainSelectedInstOperands,
     /*  310153 */     // GIR_Coverage, 13896,
     /*  310153 */     GIR_EraseRootFromParent_Done,
     /*  310154 */   // Label 5753: @310154
     /*  310154 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(310220), // Rule ID 13897 //
     /*  310159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  310170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  310173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  310176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } ?:{ *:[nxv8i32] }:$passthru, ?:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310218 */     GIR_RootConstrainSelectedInstOperands,
     /*  310219 */     // GIR_Coverage, 13897,
     /*  310219 */     GIR_EraseRootFromParent_Done,
     /*  310220 */   // Label 5754: @310220
     /*  310220 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(310286), // Rule ID 13898 //
     /*  310225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  310228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310264 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  310264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310284 */     GIR_RootConstrainSelectedInstOperands,
     /*  310285 */     // GIR_Coverage, 13898,
     /*  310285 */     GIR_EraseRootFromParent_Done,
     /*  310286 */   // Label 5755: @310286
     /*  310286 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(310352), // Rule ID 13899 //
     /*  310291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  310294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  310302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  310305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  310308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } ?:{ *:[nxv16i32] }:$passthru, ?:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  310330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  310347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310350 */     GIR_RootConstrainSelectedInstOperands,
     /*  310351 */     // GIR_Coverage, 13899,
     /*  310351 */     GIR_EraseRootFromParent_Done,
     /*  310352 */   // Label 5756: @310352
     /*  310352 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(310418), // Rule ID 13900 //
     /*  310357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310396 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310416 */     GIR_RootConstrainSelectedInstOperands,
     /*  310417 */     // GIR_Coverage, 13900,
     /*  310417 */     GIR_EraseRootFromParent_Done,
     /*  310418 */   // Label 5757: @310418
     /*  310418 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(310484), // Rule ID 13901 //
     /*  310423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  310434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  310437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  310440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  310455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$passthru, ?:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  310465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310482 */     GIR_RootConstrainSelectedInstOperands,
     /*  310483 */     // GIR_Coverage, 13901,
     /*  310483 */     GIR_EraseRootFromParent_Done,
     /*  310484 */   // Label 5758: @310484
     /*  310484 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(310550), // Rule ID 13902 //
     /*  310489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  310500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  310503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  310506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310528 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310548 */     GIR_RootConstrainSelectedInstOperands,
     /*  310549 */     // GIR_Coverage, 13902,
     /*  310549 */     GIR_EraseRootFromParent_Done,
     /*  310550 */   // Label 5759: @310550
     /*  310550 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(310616), // Rule ID 13903 //
     /*  310555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  310566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  310569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  310572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  310587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } ?:{ *:[nxv4i64] }:$passthru, ?:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  310597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310614 */     GIR_RootConstrainSelectedInstOperands,
     /*  310615 */     // GIR_Coverage, 13903,
     /*  310615 */     GIR_EraseRootFromParent_Done,
     /*  310616 */   // Label 5760: @310616
     /*  310616 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(310682), // Rule ID 13904 //
     /*  310621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  310624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  310632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  310635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  310638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  310660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310680 */     GIR_RootConstrainSelectedInstOperands,
     /*  310681 */     // GIR_Coverage, 13904,
     /*  310681 */     GIR_EraseRootFromParent_Done,
     /*  310682 */   // Label 5761: @310682
     /*  310682 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(310748), // Rule ID 13905 //
     /*  310687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  310690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  310698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  310701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  310704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  310719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } ?:{ *:[nxv8i64] }:$passthru, ?:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  310726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  310729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  310743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310746 */     GIR_RootConstrainSelectedInstOperands,
     /*  310747 */     // GIR_Coverage, 13905,
     /*  310747 */     GIR_EraseRootFromParent_Done,
     /*  310748 */   // Label 5762: @310748
     /*  310748 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(310814), // Rule ID 13906 //
     /*  310753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  310756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  310764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  310767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  310770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310792 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  310795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310812 */     GIR_RootConstrainSelectedInstOperands,
     /*  310813 */     // GIR_Coverage, 13906,
     /*  310813 */     GIR_EraseRootFromParent_Done,
     /*  310814 */   // Label 5763: @310814
     /*  310814 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(310880), // Rule ID 13907 //
     /*  310819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  310822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  310830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  310833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  310836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310858 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } ?:{ *:[nxv1f16] }:$passthru, ?:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /*  310861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310878 */     GIR_RootConstrainSelectedInstOperands,
     /*  310879 */     // GIR_Coverage, 13907,
     /*  310879 */     GIR_EraseRootFromParent_Done,
     /*  310880 */   // Label 5764: @310880
     /*  310880 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(310946), // Rule ID 13908 //
     /*  310885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  310888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  310896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  310899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  310905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310924 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  310924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  310927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  310938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  310941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  310944 */     GIR_RootConstrainSelectedInstOperands,
     /*  310945 */     // GIR_Coverage, 13908,
     /*  310945 */     GIR_EraseRootFromParent_Done,
     /*  310946 */   // Label 5765: @310946
     /*  310946 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(311012), // Rule ID 13909 //
     /*  310951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  310954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  310959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  310962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  310965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  310968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  310971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  310983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  310990 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$passthru, ?:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  310990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  310993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  310995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  310997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  310999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311010 */     GIR_RootConstrainSelectedInstOperands,
     /*  311011 */     // GIR_Coverage, 13909,
     /*  311011 */     GIR_EraseRootFromParent_Done,
     /*  311012 */   // Label 5766: @311012
     /*  311012 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(311078), // Rule ID 13910 //
     /*  311017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311056 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311076 */     GIR_RootConstrainSelectedInstOperands,
     /*  311077 */     // GIR_Coverage, 13910,
     /*  311077 */     GIR_EraseRootFromParent_Done,
     /*  311078 */   // Label 5767: @311078
     /*  311078 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(311144), // Rule ID 13911 //
     /*  311083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  311094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  311097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  311100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311122 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } ?:{ *:[nxv1f32] }:$passthru, ?:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /*  311125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311142 */     GIR_RootConstrainSelectedInstOperands,
     /*  311143 */     // GIR_Coverage, 13911,
     /*  311143 */     GIR_EraseRootFromParent_Done,
     /*  311144 */   // Label 5768: @311144
     /*  311144 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(311210), // Rule ID 13912 //
     /*  311149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311188 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311208 */     GIR_RootConstrainSelectedInstOperands,
     /*  311209 */     // GIR_Coverage, 13912,
     /*  311209 */     GIR_EraseRootFromParent_Done,
     /*  311210 */   // Label 5769: @311210
     /*  311210 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(311276), // Rule ID 13913 //
     /*  311215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  311226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  311229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  311232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311254 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11409:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$passthru, ?:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311274 */     GIR_RootConstrainSelectedInstOperands,
     /*  311275 */     // GIR_Coverage, 13913,
     /*  311275 */     GIR_EraseRootFromParent_Done,
     /*  311276 */   // Label 5770: @311276
     /*  311276 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(311342), // Rule ID 13914 //
     /*  311281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311320 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311340 */     GIR_RootConstrainSelectedInstOperands,
     /*  311341 */     // GIR_Coverage, 13914,
     /*  311341 */     GIR_EraseRootFromParent_Done,
     /*  311342 */   // Label 5771: @311342
     /*  311342 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(311408), // Rule ID 13915 //
     /*  311347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  311350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  311358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  311361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  311364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311386 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11409:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$passthru, ?:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  311386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311406 */     GIR_RootConstrainSelectedInstOperands,
     /*  311407 */     // GIR_Coverage, 13915,
     /*  311407 */     GIR_EraseRootFromParent_Done,
     /*  311408 */   // Label 5772: @311408
     /*  311408 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(311474), // Rule ID 13916 //
     /*  311413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  311416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  311430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311452 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  311452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311472 */     GIR_RootConstrainSelectedInstOperands,
     /*  311473 */     // GIR_Coverage, 13916,
     /*  311473 */     GIR_EraseRootFromParent_Done,
     /*  311474 */   // Label 5773: @311474
     /*  311474 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(311540), // Rule ID 13917 //
     /*  311479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  311482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  311490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  311493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  311496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  311511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311518 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11409:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } ?:{ *:[nxv1f64] }:$passthru, ?:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  311518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /*  311521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  311535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311538 */     GIR_RootConstrainSelectedInstOperands,
     /*  311539 */     // GIR_Coverage, 13917,
     /*  311539 */     GIR_EraseRootFromParent_Done,
     /*  311540 */   // Label 5774: @311540
     /*  311540 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(311606), // Rule ID 13918 //
     /*  311545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  311556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311584 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311604 */     GIR_RootConstrainSelectedInstOperands,
     /*  311605 */     // GIR_Coverage, 13918,
     /*  311605 */     GIR_EraseRootFromParent_Done,
     /*  311606 */   // Label 5775: @311606
     /*  311606 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(311672), // Rule ID 13919 //
     /*  311611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  311622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  311625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  311628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311650 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$passthru, ?:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311670 */     GIR_RootConstrainSelectedInstOperands,
     /*  311671 */     // GIR_Coverage, 13919,
     /*  311671 */     GIR_EraseRootFromParent_Done,
     /*  311672 */   // Label 5776: @311672
     /*  311672 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(311738), // Rule ID 13920 //
     /*  311677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  311688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311716 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311736 */     GIR_RootConstrainSelectedInstOperands,
     /*  311737 */     // GIR_Coverage, 13920,
     /*  311737 */     GIR_EraseRootFromParent_Done,
     /*  311738 */   // Label 5777: @311738
     /*  311738 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(311804), // Rule ID 13921 //
     /*  311743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  311754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  311757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  311760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  311775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311782 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } ?:{ *:[nxv16f16] }:$passthru, ?:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  311785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311802 */     GIR_RootConstrainSelectedInstOperands,
     /*  311803 */     // GIR_Coverage, 13921,
     /*  311803 */     GIR_EraseRootFromParent_Done,
     /*  311804 */   // Label 5778: @311804
     /*  311804 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(311870), // Rule ID 13922 //
     /*  311809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  311812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  311820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311848 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  311848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311868 */     GIR_RootConstrainSelectedInstOperands,
     /*  311869 */     // GIR_Coverage, 13922,
     /*  311869 */     GIR_EraseRootFromParent_Done,
     /*  311870 */   // Label 5779: @311870
     /*  311870 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(311936), // Rule ID 13923 //
     /*  311875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  311878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  311886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  311889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  311892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  311895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  311907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311914 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } ?:{ *:[nxv32f16] }:$passthru, ?:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  311914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  311917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  311931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  311934 */     GIR_RootConstrainSelectedInstOperands,
     /*  311935 */     // GIR_Coverage, 13923,
     /*  311935 */     GIR_EraseRootFromParent_Done,
     /*  311936 */   // Label 5780: @311936
     /*  311936 */   GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(312002), // Rule ID 13924 //
     /*  311941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  311944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  311949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  311952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  311955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  311958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  311961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  311973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  311980 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  311980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  311983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  311985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  311987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  311989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  311994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  311997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312000 */     GIR_RootConstrainSelectedInstOperands,
     /*  312001 */     // GIR_Coverage, 13924,
     /*  312001 */     GIR_EraseRootFromParent_Done,
     /*  312002 */   // Label 5781: @312002
     /*  312002 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(312068), // Rule ID 13925 //
     /*  312007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  312018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  312021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  312024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312046 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$passthru, ?:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312066 */     GIR_RootConstrainSelectedInstOperands,
     /*  312067 */     // GIR_Coverage, 13925,
     /*  312067 */     GIR_EraseRootFromParent_Done,
     /*  312068 */   // Label 5782: @312068
     /*  312068 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(312134), // Rule ID 13926 //
     /*  312073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312112 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312132 */     GIR_RootConstrainSelectedInstOperands,
     /*  312133 */     // GIR_Coverage, 13926,
     /*  312133 */     GIR_EraseRootFromParent_Done,
     /*  312134 */   // Label 5783: @312134
     /*  312134 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(312200), // Rule ID 13927 //
     /*  312139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  312150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  312153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  312156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312178 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } ?:{ *:[nxv8f32] }:$passthru, ?:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312198 */     GIR_RootConstrainSelectedInstOperands,
     /*  312199 */     // GIR_Coverage, 13927,
     /*  312199 */     GIR_EraseRootFromParent_Done,
     /*  312200 */   // Label 5784: @312200
     /*  312200 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(312266), // Rule ID 13928 //
     /*  312205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312244 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312264 */     GIR_RootConstrainSelectedInstOperands,
     /*  312265 */     // GIR_Coverage, 13928,
     /*  312265 */     GIR_EraseRootFromParent_Done,
     /*  312266 */   // Label 5785: @312266
     /*  312266 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(312332), // Rule ID 13929 //
     /*  312271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  312282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  312285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  312288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312310 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } ?:{ *:[nxv16f32] }:$passthru, ?:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312330 */     GIR_RootConstrainSelectedInstOperands,
     /*  312331 */     // GIR_Coverage, 13929,
     /*  312331 */     GIR_EraseRootFromParent_Done,
     /*  312332 */   // Label 5786: @312332
     /*  312332 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(312398), // Rule ID 13930 //
     /*  312337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312396 */     GIR_RootConstrainSelectedInstOperands,
     /*  312397 */     // GIR_Coverage, 13930,
     /*  312397 */     GIR_EraseRootFromParent_Done,
     /*  312398 */   // Label 5787: @312398
     /*  312398 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(312464), // Rule ID 13931 //
     /*  312403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  312414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  312417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  312420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  312435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312442 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11409:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$passthru, ?:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /*  312445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312462 */     GIR_RootConstrainSelectedInstOperands,
     /*  312463 */     // GIR_Coverage, 13931,
     /*  312463 */     GIR_EraseRootFromParent_Done,
     /*  312464 */   // Label 5788: @312464
     /*  312464 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(312530), // Rule ID 13932 //
     /*  312469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  312480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  312483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  312486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312528 */     GIR_RootConstrainSelectedInstOperands,
     /*  312529 */     // GIR_Coverage, 13932,
     /*  312529 */     GIR_EraseRootFromParent_Done,
     /*  312530 */   // Label 5789: @312530
     /*  312530 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(312596), // Rule ID 13933 //
     /*  312535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  312546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  312549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  312552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  312567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312574 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11409:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } ?:{ *:[nxv4f64] }:$passthru, ?:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /*  312577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312594 */     GIR_RootConstrainSelectedInstOperands,
     /*  312595 */     // GIR_Coverage, 13933,
     /*  312595 */     GIR_EraseRootFromParent_Done,
     /*  312596 */   // Label 5790: @312596
     /*  312596 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(312662), // Rule ID 13934 //
     /*  312601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  312604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  312612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312640 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  312640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312660 */     GIR_RootConstrainSelectedInstOperands,
     /*  312661 */     // GIR_Coverage, 13934,
     /*  312661 */     GIR_EraseRootFromParent_Done,
     /*  312662 */   // Label 5791: @312662
     /*  312662 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(312728), // Rule ID 13935 //
     /*  312667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  312670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmv_v_v),
     /*  312675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  312678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  312681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  312684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  312699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312706 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11409:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } ?:{ *:[nxv8f64] }:$passthru, ?:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  312706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /*  312709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  312715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  312723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312726 */     GIR_RootConstrainSelectedInstOperands,
     /*  312727 */     // GIR_Coverage, 13935,
     /*  312727 */     GIR_EraseRootFromParent_Done,
     /*  312728 */   // Label 5792: @312728
     /*  312728 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(312794), // Rule ID 18938 //
     /*  312733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  312736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  312741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312772 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  312772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  312775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312792 */     GIR_RootConstrainSelectedInstOperands,
     /*  312793 */     // GIR_Coverage, 18938,
     /*  312793 */     GIR_EraseRootFromParent_Done,
     /*  312794 */   // Label 5793: @312794
     /*  312794 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(312860), // Rule ID 18939 //
     /*  312799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  312802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  312807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  312810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  312813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  312816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312838 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  312838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16),
     /*  312841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  312855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312858 */     GIR_RootConstrainSelectedInstOperands,
     /*  312859 */     // GIR_Coverage, 18939,
     /*  312859 */     GIR_EraseRootFromParent_Done,
     /*  312860 */   // Label 5794: @312860
     /*  312860 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(312926), // Rule ID 18942 //
     /*  312865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  312868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  312873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  312885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312904 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  312904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  312907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312924 */     GIR_RootConstrainSelectedInstOperands,
     /*  312925 */     // GIR_Coverage, 18942,
     /*  312925 */     GIR_EraseRootFromParent_Done,
     /*  312926 */   // Label 5795: @312926
     /*  312926 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(312992), // Rule ID 18943 //
     /*  312931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  312934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  312939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  312942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  312945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  312948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  312951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  312963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  312970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  312970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32),
     /*  312973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  312975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  312977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  312979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  312984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  312987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  312990 */     GIR_RootConstrainSelectedInstOperands,
     /*  312991 */     // GIR_Coverage, 18943,
     /*  312991 */     GIR_EraseRootFromParent_Done,
     /*  312992 */   // Label 5796: @312992
     /*  312992 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(313058), // Rule ID 18946 //
     /*  312997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313036 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313056 */     GIR_RootConstrainSelectedInstOperands,
     /*  313057 */     // GIR_Coverage, 18946,
     /*  313057 */     GIR_EraseRootFromParent_Done,
     /*  313058 */   // Label 5797: @313058
     /*  313058 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(313124), // Rule ID 18947 //
     /*  313063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  313074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  313077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  313080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313102 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11192:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16),
     /*  313105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313122 */     GIR_RootConstrainSelectedInstOperands,
     /*  313123 */     // GIR_Coverage, 18947,
     /*  313123 */     GIR_EraseRootFromParent_Done,
     /*  313124 */   // Label 5798: @313124
     /*  313124 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(313190), // Rule ID 18950 //
     /*  313129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313168 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313188 */     GIR_RootConstrainSelectedInstOperands,
     /*  313189 */     // GIR_Coverage, 18950,
     /*  313189 */     GIR_EraseRootFromParent_Done,
     /*  313190 */   // Label 5799: @313190
     /*  313190 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(313256), // Rule ID 18951 //
     /*  313195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  313206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  313209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  313212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313234 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11192:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32),
     /*  313237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313254 */     GIR_RootConstrainSelectedInstOperands,
     /*  313255 */     // GIR_Coverage, 18951,
     /*  313255 */     GIR_EraseRootFromParent_Done,
     /*  313256 */   // Label 5800: @313256
     /*  313256 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(313322), // Rule ID 18954 //
     /*  313261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  313264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  313300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313320 */     GIR_RootConstrainSelectedInstOperands,
     /*  313321 */     // GIR_Coverage, 18954,
     /*  313321 */     GIR_EraseRootFromParent_Done,
     /*  313322 */   // Label 5801: @313322
     /*  313322 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(313388), // Rule ID 18955 //
     /*  313327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  313330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  313338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  313341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  313344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  313359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313366 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11192:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  313366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64),
     /*  313369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  313383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313386 */     GIR_RootConstrainSelectedInstOperands,
     /*  313387 */     // GIR_Coverage, 18955,
     /*  313387 */     GIR_EraseRootFromParent_Done,
     /*  313388 */   // Label 5802: @313388
     /*  313388 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(313454), // Rule ID 18958 //
     /*  313393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313432 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  313435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313452 */     GIR_RootConstrainSelectedInstOperands,
     /*  313453 */     // GIR_Coverage, 18958,
     /*  313453 */     GIR_EraseRootFromParent_Done,
     /*  313454 */   // Label 5803: @313454
     /*  313454 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(313520), // Rule ID 18959 //
     /*  313459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  313470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  313473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  313476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313498 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16),
     /*  313501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313518 */     GIR_RootConstrainSelectedInstOperands,
     /*  313519 */     // GIR_Coverage, 18959,
     /*  313519 */     GIR_EraseRootFromParent_Done,
     /*  313520 */   // Label 5804: @313520
     /*  313520 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(313586), // Rule ID 18962 //
     /*  313525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  313536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  313539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  313542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313564 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  313567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313584 */     GIR_RootConstrainSelectedInstOperands,
     /*  313585 */     // GIR_Coverage, 18962,
     /*  313585 */     GIR_EraseRootFromParent_Done,
     /*  313586 */   // Label 5805: @313586
     /*  313586 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(313652), // Rule ID 18963 //
     /*  313591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  313602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  313605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  313608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313630 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16),
     /*  313633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313650 */     GIR_RootConstrainSelectedInstOperands,
     /*  313651 */     // GIR_Coverage, 18963,
     /*  313651 */     GIR_EraseRootFromParent_Done,
     /*  313652 */   // Label 5806: @313652
     /*  313652 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(313718), // Rule ID 18966 //
     /*  313657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  313660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  313668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  313671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  313674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313696 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  313696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  313699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313716 */     GIR_RootConstrainSelectedInstOperands,
     /*  313717 */     // GIR_Coverage, 18966,
     /*  313717 */     GIR_EraseRootFromParent_Done,
     /*  313718 */   // Label 5807: @313718
     /*  313718 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(313784), // Rule ID 18967 //
     /*  313723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  313726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  313734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  313737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  313740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  313755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313762 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  313762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16),
     /*  313765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  313779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313782 */     GIR_RootConstrainSelectedInstOperands,
     /*  313783 */     // GIR_Coverage, 18967,
     /*  313783 */     GIR_EraseRootFromParent_Done,
     /*  313784 */   // Label 5808: @313784
     /*  313784 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(313850), // Rule ID 18970 //
     /*  313789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  313800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  313803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  313806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313828 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  313831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313848 */     GIR_RootConstrainSelectedInstOperands,
     /*  313849 */     // GIR_Coverage, 18970,
     /*  313849 */     GIR_EraseRootFromParent_Done,
     /*  313850 */   // Label 5809: @313850
     /*  313850 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(313916), // Rule ID 18971 //
     /*  313855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  313866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  313869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  313872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  313875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  313887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  313894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32),
     /*  313897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313914 */     GIR_RootConstrainSelectedInstOperands,
     /*  313915 */     // GIR_Coverage, 18971,
     /*  313915 */     GIR_EraseRootFromParent_Done,
     /*  313916 */   // Label 5810: @313916
     /*  313916 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(313982), // Rule ID 18974 //
     /*  313921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  313924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  313935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  313938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  313941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  313953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  313960 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  313960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  313963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  313965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  313967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  313969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  313974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  313977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  313980 */     GIR_RootConstrainSelectedInstOperands,
     /*  313981 */     // GIR_Coverage, 18974,
     /*  313981 */     GIR_EraseRootFromParent_Done,
     /*  313982 */   // Label 5811: @313982
     /*  313982 */   GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(314048), // Rule ID 18975 //
     /*  313987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  313990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  313995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  313998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  314001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  314004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314026 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32),
     /*  314029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314046 */     GIR_RootConstrainSelectedInstOperands,
     /*  314047 */     // GIR_Coverage, 18975,
     /*  314047 */     GIR_EraseRootFromParent_Done,
     /*  314048 */   // Label 5812: @314048
     /*  314048 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(314114), // Rule ID 18978 //
     /*  314053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314092 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  314092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314112 */     GIR_RootConstrainSelectedInstOperands,
     /*  314113 */     // GIR_Coverage, 18978,
     /*  314113 */     GIR_EraseRootFromParent_Done,
     /*  314114 */   // Label 5813: @314114
     /*  314114 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(314180), // Rule ID 18979 //
     /*  314119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  314130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  314133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  314136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314158 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  314158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32),
     /*  314161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314178 */     GIR_RootConstrainSelectedInstOperands,
     /*  314179 */     // GIR_Coverage, 18979,
     /*  314179 */     GIR_EraseRootFromParent_Done,
     /*  314180 */   // Label 5814: @314180
     /*  314180 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(314246), // Rule ID 18982 //
     /*  314185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314224 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314244 */     GIR_RootConstrainSelectedInstOperands,
     /*  314245 */     // GIR_Coverage, 18982,
     /*  314245 */     GIR_EraseRootFromParent_Done,
     /*  314246 */   // Label 5815: @314246
     /*  314246 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(314312), // Rule ID 18983 //
     /*  314251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  314262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  314265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  314268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  314283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314290 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11192:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64),
     /*  314293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314310 */     GIR_RootConstrainSelectedInstOperands,
     /*  314311 */     // GIR_Coverage, 18983,
     /*  314311 */     GIR_EraseRootFromParent_Done,
     /*  314312 */   // Label 5816: @314312
     /*  314312 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(314378), // Rule ID 18986 //
     /*  314317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314356 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314376 */     GIR_RootConstrainSelectedInstOperands,
     /*  314377 */     // GIR_Coverage, 18986,
     /*  314377 */     GIR_EraseRootFromParent_Done,
     /*  314378 */   // Label 5817: @314378
     /*  314378 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(314444), // Rule ID 18987 //
     /*  314383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  314394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  314397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  314400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  314415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314422 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11192:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64),
     /*  314425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314442 */     GIR_RootConstrainSelectedInstOperands,
     /*  314443 */     // GIR_Coverage, 18987,
     /*  314443 */     GIR_EraseRootFromParent_Done,
     /*  314444 */   // Label 5818: @314444
     /*  314444 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(314510), // Rule ID 18990 //
     /*  314449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  314452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314488 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  314488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  314491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314508 */     GIR_RootConstrainSelectedInstOperands,
     /*  314509 */     // GIR_Coverage, 18990,
     /*  314509 */     GIR_EraseRootFromParent_Done,
     /*  314510 */   // Label 5819: @314510
     /*  314510 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(314576), // Rule ID 18991 //
     /*  314515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  314518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7),
     /*  314523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  314526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  314529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  314532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  314547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314554 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11192:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSQRT7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  314554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64),
     /*  314557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  314561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  314571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  314574 */     GIR_RootConstrainSelectedInstOperands,
     /*  314575 */     // GIR_Coverage, 18991,
     /*  314575 */     GIR_EraseRootFromParent_Done,
     /*  314576 */   // Label 5820: @314576
     /*  314576 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(314639), // Rule ID 19654 //
     /*  314581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  314592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  314595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  314598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314620 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  314620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  314623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314637 */     GIR_RootConstrainSelectedInstOperands,
     /*  314638 */     // GIR_Coverage, 19654,
     /*  314638 */     GIR_EraseRootFromParent_Done,
     /*  314639 */   // Label 5821: @314639
     /*  314639 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(314702), // Rule ID 19655 //
     /*  314644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  314655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  314658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  314661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314683 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  314683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /*  314686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314700 */     GIR_RootConstrainSelectedInstOperands,
     /*  314701 */     // GIR_Coverage, 19655,
     /*  314701 */     GIR_EraseRootFromParent_Done,
     /*  314702 */   // Label 5822: @314702
     /*  314702 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(314765), // Rule ID 19658 //
     /*  314707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  314718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  314721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  314724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314746 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  314746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  314749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314763 */     GIR_RootConstrainSelectedInstOperands,
     /*  314764 */     // GIR_Coverage, 19658,
     /*  314764 */     GIR_EraseRootFromParent_Done,
     /*  314765 */   // Label 5823: @314765
     /*  314765 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(314828), // Rule ID 19659 //
     /*  314770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  314773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  314781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  314784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  314787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314809 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  314809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  314812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  314826 */     GIR_RootConstrainSelectedInstOperands,
     /*  314827 */     // GIR_Coverage, 19659,
     /*  314827 */     GIR_EraseRootFromParent_Done,
     /*  314828 */   // Label 5824: @314828
     /*  314828 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(314891), // Rule ID 19662 //
     /*  314833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  314836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  314844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  314847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  314850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  314872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  314875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314889 */     GIR_RootConstrainSelectedInstOperands,
     /*  314890 */     // GIR_Coverage, 19662,
     /*  314890 */     GIR_EraseRootFromParent_Done,
     /*  314891 */   // Label 5825: @314891
     /*  314891 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(314954), // Rule ID 19663 //
     /*  314896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  314899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  314907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  314910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  314913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  314916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314935 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  314935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /*  314938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  314940 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  314942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  314944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  314949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  314952 */     GIR_RootConstrainSelectedInstOperands,
     /*  314953 */     // GIR_Coverage, 19663,
     /*  314953 */     GIR_EraseRootFromParent_Done,
     /*  314954 */   // Label 5826: @314954
     /*  314954 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(315017), // Rule ID 19666 //
     /*  314959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  314962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  314967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  314970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  314973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  314976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  314979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  314991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  314998 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  314998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315015 */     GIR_RootConstrainSelectedInstOperands,
     /*  315016 */     // GIR_Coverage, 19666,
     /*  315016 */     GIR_EraseRootFromParent_Done,
     /*  315017 */   // Label 5827: @315017
     /*  315017 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(315080), // Rule ID 19667 //
     /*  315022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  315036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  315039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315061 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315078 */     GIR_RootConstrainSelectedInstOperands,
     /*  315079 */     // GIR_Coverage, 19667,
     /*  315079 */     GIR_EraseRootFromParent_Done,
     /*  315080 */   // Label 5828: @315080
     /*  315080 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(315143), // Rule ID 19670 //
     /*  315085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315141 */     GIR_RootConstrainSelectedInstOperands,
     /*  315142 */     // GIR_Coverage, 19670,
     /*  315142 */     GIR_EraseRootFromParent_Done,
     /*  315143 */   // Label 5829: @315143
     /*  315143 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(315206), // Rule ID 19671 //
     /*  315148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  315159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  315162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  315165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315187 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315204 */     GIR_RootConstrainSelectedInstOperands,
     /*  315205 */     // GIR_Coverage, 19671,
     /*  315205 */     GIR_EraseRootFromParent_Done,
     /*  315206 */   // Label 5830: @315206
     /*  315206 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(315269), // Rule ID 19674 //
     /*  315211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  315214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315250 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  315250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315267 */     GIR_RootConstrainSelectedInstOperands,
     /*  315268 */     // GIR_Coverage, 19674,
     /*  315268 */     GIR_EraseRootFromParent_Done,
     /*  315269 */   // Label 5831: @315269
     /*  315269 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(315332), // Rule ID 19675 //
     /*  315274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  315277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  315285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  315288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  315291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315313 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  315313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /*  315316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  315330 */     GIR_RootConstrainSelectedInstOperands,
     /*  315331 */     // GIR_Coverage, 19675,
     /*  315331 */     GIR_EraseRootFromParent_Done,
     /*  315332 */   // Label 5832: @315332
     /*  315332 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(315395), // Rule ID 19678 //
     /*  315337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315393 */     GIR_RootConstrainSelectedInstOperands,
     /*  315394 */     // GIR_Coverage, 19678,
     /*  315394 */     GIR_EraseRootFromParent_Done,
     /*  315395 */   // Label 5833: @315395
     /*  315395 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(315458), // Rule ID 19679 //
     /*  315400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  315414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  315417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315456 */     GIR_RootConstrainSelectedInstOperands,
     /*  315457 */     // GIR_Coverage, 19679,
     /*  315457 */     GIR_EraseRootFromParent_Done,
     /*  315458 */   // Label 5834: @315458
     /*  315458 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(315521), // Rule ID 19682 //
     /*  315463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  315474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  315480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315502 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  315505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315519 */     GIR_RootConstrainSelectedInstOperands,
     /*  315520 */     // GIR_Coverage, 19682,
     /*  315520 */     GIR_EraseRootFromParent_Done,
     /*  315521 */   // Label 5835: @315521
     /*  315521 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(315584), // Rule ID 19683 //
     /*  315526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  315537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  315540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  315543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315565 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  315568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315582 */     GIR_RootConstrainSelectedInstOperands,
     /*  315583 */     // GIR_Coverage, 19683,
     /*  315583 */     GIR_EraseRootFromParent_Done,
     /*  315584 */   // Label 5836: @315584
     /*  315584 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(315647), // Rule ID 19686 //
     /*  315589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  315592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  315600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  315603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  315606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315628 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  315628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  315631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315645 */     GIR_RootConstrainSelectedInstOperands,
     /*  315646 */     // GIR_Coverage, 19686,
     /*  315646 */     GIR_EraseRootFromParent_Done,
     /*  315647 */   // Label 5837: @315647
     /*  315647 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(315710), // Rule ID 19687 //
     /*  315652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  315655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  315663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  315666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  315669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315691 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  315691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  315694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  315708 */     GIR_RootConstrainSelectedInstOperands,
     /*  315709 */     // GIR_Coverage, 19687,
     /*  315709 */     GIR_EraseRootFromParent_Done,
     /*  315710 */   // Label 5838: @315710
     /*  315710 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(315773), // Rule ID 19690 //
     /*  315715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  315729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  315732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315754 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315771 */     GIR_RootConstrainSelectedInstOperands,
     /*  315772 */     // GIR_Coverage, 19690,
     /*  315772 */     GIR_EraseRootFromParent_Done,
     /*  315773 */   // Label 5839: @315773
     /*  315773 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(315836), // Rule ID 19691 //
     /*  315778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  315789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  315792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  315795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  315810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315817 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  315820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315834 */     GIR_RootConstrainSelectedInstOperands,
     /*  315835 */     // GIR_Coverage, 19691,
     /*  315835 */     GIR_EraseRootFromParent_Done,
     /*  315836 */   // Label 5840: @315836
     /*  315836 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(315899), // Rule ID 19694 //
     /*  315841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  315855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  315858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  315880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  315883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315897 */     GIR_RootConstrainSelectedInstOperands,
     /*  315898 */     // GIR_Coverage, 19694,
     /*  315898 */     GIR_EraseRootFromParent_Done,
     /*  315899 */   // Label 5841: @315899
     /*  315899 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(315962), // Rule ID 19695 //
     /*  315904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  315907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  315915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  315918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  315921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  315924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  315936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  315943 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  315943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  315946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  315948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  315950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  315952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  315957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  315960 */     GIR_RootConstrainSelectedInstOperands,
     /*  315961 */     // GIR_Coverage, 19695,
     /*  315961 */     GIR_EraseRootFromParent_Done,
     /*  315962 */   // Label 5842: @315962
     /*  315962 */   GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(316025), // Rule ID 19698 //
     /*  315967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  315970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  315975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  315978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  315981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  315984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  315987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  315991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  315999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316006 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316023 */     GIR_RootConstrainSelectedInstOperands,
     /*  316024 */     // GIR_Coverage, 19698,
     /*  316024 */     GIR_EraseRootFromParent_Done,
     /*  316025 */   // Label 5843: @316025
     /*  316025 */   GIM_Try, /*On fail goto*//*Label 5844*/ GIMT_Encode4(316088), // Rule ID 19699 //
     /*  316030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  316041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  316044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  316047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316069 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316086 */     GIR_RootConstrainSelectedInstOperands,
     /*  316087 */     // GIR_Coverage, 19699,
     /*  316087 */     GIR_EraseRootFromParent_Done,
     /*  316088 */   // Label 5844: @316088
     /*  316088 */   GIM_Try, /*On fail goto*//*Label 5845*/ GIMT_Encode4(316151), // Rule ID 19702 //
     /*  316093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316132 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316149 */     GIR_RootConstrainSelectedInstOperands,
     /*  316150 */     // GIR_Coverage, 19702,
     /*  316150 */     GIR_EraseRootFromParent_Done,
     /*  316151 */   // Label 5845: @316151
     /*  316151 */   GIM_Try, /*On fail goto*//*Label 5846*/ GIMT_Encode4(316214), // Rule ID 19703 //
     /*  316156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  316170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  316173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  316188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316195 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /*  316198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316212 */     GIR_RootConstrainSelectedInstOperands,
     /*  316213 */     // GIR_Coverage, 19703,
     /*  316213 */     GIR_EraseRootFromParent_Done,
     /*  316214 */   // Label 5846: @316214
     /*  316214 */   GIM_Try, /*On fail goto*//*Label 5847*/ GIMT_Encode4(316277), // Rule ID 19706 //
     /*  316219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316258 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316275 */     GIR_RootConstrainSelectedInstOperands,
     /*  316276 */     // GIR_Coverage, 19706,
     /*  316276 */     GIR_EraseRootFromParent_Done,
     /*  316277 */   // Label 5847: @316277
     /*  316277 */   GIM_Try, /*On fail goto*//*Label 5848*/ GIMT_Encode4(316340), // Rule ID 19707 //
     /*  316282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  316296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  316299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  316314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316321 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /*  316324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316338 */     GIR_RootConstrainSelectedInstOperands,
     /*  316339 */     // GIR_Coverage, 19707,
     /*  316339 */     GIR_EraseRootFromParent_Done,
     /*  316340 */   // Label 5848: @316340
     /*  316340 */   GIM_Try, /*On fail goto*//*Label 5849*/ GIMT_Encode4(316403), // Rule ID 19710 //
     /*  316345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  316348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316384 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  316384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316401 */     GIR_RootConstrainSelectedInstOperands,
     /*  316402 */     // GIR_Coverage, 19710,
     /*  316402 */     GIR_EraseRootFromParent_Done,
     /*  316403 */   // Label 5849: @316403
     /*  316403 */   GIM_Try, /*On fail goto*//*Label 5850*/ GIMT_Encode4(316466), // Rule ID 19711 //
     /*  316408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  316411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  316419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  316422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  316425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  316440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316447 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  316447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /*  316450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  316464 */     GIR_RootConstrainSelectedInstOperands,
     /*  316465 */     // GIR_Coverage, 19711,
     /*  316465 */     GIR_EraseRootFromParent_Done,
     /*  316466 */   // Label 5850: @316466
     /*  316466 */   GIM_Try, /*On fail goto*//*Label 5851*/ GIMT_Encode4(316529), // Rule ID 19714 //
     /*  316471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  316485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316510 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  316513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316527 */     GIR_RootConstrainSelectedInstOperands,
     /*  316528 */     // GIR_Coverage, 19714,
     /*  316528 */     GIR_EraseRootFromParent_Done,
     /*  316529 */   // Label 5851: @316529
     /*  316529 */   GIM_Try, /*On fail goto*//*Label 5852*/ GIMT_Encode4(316592), // Rule ID 19715 //
     /*  316534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  316548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316573 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4),
     /*  316576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316590 */     GIR_RootConstrainSelectedInstOperands,
     /*  316591 */     // GIR_Coverage, 19715,
     /*  316591 */     GIR_EraseRootFromParent_Done,
     /*  316592 */   // Label 5852: @316592
     /*  316592 */   GIM_Try, /*On fail goto*//*Label 5853*/ GIMT_Encode4(316655), // Rule ID 19718 //
     /*  316597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  316611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316636 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  316639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316653 */     GIR_RootConstrainSelectedInstOperands,
     /*  316654 */     // GIR_Coverage, 19718,
     /*  316654 */     GIR_EraseRootFromParent_Done,
     /*  316655 */   // Label 5853: @316655
     /*  316655 */   GIM_Try, /*On fail goto*//*Label 5854*/ GIMT_Encode4(316718), // Rule ID 19719 //
     /*  316660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  316674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316699 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2),
     /*  316702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316716 */     GIR_RootConstrainSelectedInstOperands,
     /*  316717 */     // GIR_Coverage, 19719,
     /*  316717 */     GIR_EraseRootFromParent_Done,
     /*  316718 */   // Label 5854: @316718
     /*  316718 */   GIM_Try, /*On fail goto*//*Label 5855*/ GIMT_Encode4(316781), // Rule ID 19722 //
     /*  316723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  316737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  316740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  316755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316762 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  316762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  316765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316779 */     GIR_RootConstrainSelectedInstOperands,
     /*  316780 */     // GIR_Coverage, 19722,
     /*  316780 */     GIR_EraseRootFromParent_Done,
     /*  316781 */   // Label 5855: @316781
     /*  316781 */   GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(316844), // Rule ID 19723 //
     /*  316786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  316789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  316797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  316800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  316803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  316818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316825 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  316825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2),
     /*  316828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  316842 */     GIR_RootConstrainSelectedInstOperands,
     /*  316843 */     // GIR_Coverage, 19723,
     /*  316843 */     GIR_EraseRootFromParent_Done,
     /*  316844 */   // Label 5856: @316844
     /*  316844 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(316907), // Rule ID 19726 //
     /*  316849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  316852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  316863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316888 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  316888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  316891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316905 */     GIR_RootConstrainSelectedInstOperands,
     /*  316906 */     // GIR_Coverage, 19726,
     /*  316906 */     GIR_EraseRootFromParent_Done,
     /*  316907 */   // Label 5857: @316907
     /*  316907 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(316970), // Rule ID 19727 //
     /*  316912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  316915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  316923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  316926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  316929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  316932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  316944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  316951 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  316951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1),
     /*  316954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  316956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  316958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  316960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  316965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  316968 */     GIR_RootConstrainSelectedInstOperands,
     /*  316969 */     // GIR_Coverage, 19727,
     /*  316969 */     GIR_EraseRootFromParent_Done,
     /*  316970 */   // Label 5858: @316970
     /*  316970 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(317033), // Rule ID 19730 //
     /*  316975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  316978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  316983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  316986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  316989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  316992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  316995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  316999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317014 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317031 */     GIR_RootConstrainSelectedInstOperands,
     /*  317032 */     // GIR_Coverage, 19730,
     /*  317032 */     GIR_EraseRootFromParent_Done,
     /*  317033 */   // Label 5859: @317033
     /*  317033 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(317096), // Rule ID 19731 //
     /*  317038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  317052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317077 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1),
     /*  317080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317094 */     GIR_RootConstrainSelectedInstOperands,
     /*  317095 */     // GIR_Coverage, 19731,
     /*  317095 */     GIR_EraseRootFromParent_Done,
     /*  317096 */   // Label 5860: @317096
     /*  317096 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(317159), // Rule ID 19734 //
     /*  317101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  317140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317157 */     GIR_RootConstrainSelectedInstOperands,
     /*  317158 */     // GIR_Coverage, 19734,
     /*  317158 */     GIR_EraseRootFromParent_Done,
     /*  317159 */   // Label 5861: @317159
     /*  317159 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(317222), // Rule ID 19735 //
     /*  317164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  317167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  317175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  317178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  317181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  317196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317203 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11351:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  317203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1),
     /*  317206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  317220 */     GIR_RootConstrainSelectedInstOperands,
     /*  317221 */     // GIR_Coverage, 19735,
     /*  317221 */     GIR_EraseRootFromParent_Done,
     /*  317222 */   // Label 5862: @317222
     /*  317222 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(317285), // Rule ID 19738 //
     /*  317227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317266 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317283 */     GIR_RootConstrainSelectedInstOperands,
     /*  317284 */     // GIR_Coverage, 19738,
     /*  317284 */     GIR_EraseRootFromParent_Done,
     /*  317285 */   // Label 5863: @317285
     /*  317285 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(317348), // Rule ID 19739 //
     /*  317290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  317304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317329 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2),
     /*  317332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317346 */     GIR_RootConstrainSelectedInstOperands,
     /*  317347 */     // GIR_Coverage, 19739,
     /*  317347 */     GIR_EraseRootFromParent_Done,
     /*  317348 */   // Label 5864: @317348
     /*  317348 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(317411), // Rule ID 19742 //
     /*  317353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317409 */     GIR_RootConstrainSelectedInstOperands,
     /*  317410 */     // GIR_Coverage, 19742,
     /*  317410 */     GIR_EraseRootFromParent_Done,
     /*  317411 */   // Label 5865: @317411
     /*  317411 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(317474), // Rule ID 19743 //
     /*  317416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  317430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317455 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4),
     /*  317458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317472 */     GIR_RootConstrainSelectedInstOperands,
     /*  317473 */     // GIR_Coverage, 19743,
     /*  317473 */     GIR_EraseRootFromParent_Done,
     /*  317474 */   // Label 5866: @317474
     /*  317474 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(317537), // Rule ID 19746 //
     /*  317479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  317482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  317490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  317493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317518 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  317518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  317521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317535 */     GIR_RootConstrainSelectedInstOperands,
     /*  317536 */     // GIR_Coverage, 19746,
     /*  317536 */     GIR_EraseRootFromParent_Done,
     /*  317537 */   // Label 5867: @317537
     /*  317537 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(317600), // Rule ID 19747 //
     /*  317542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  317545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  317553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  317556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  317559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  317574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317581 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  317581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8),
     /*  317584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  317598 */     GIR_RootConstrainSelectedInstOperands,
     /*  317599 */     // GIR_Coverage, 19747,
     /*  317599 */     GIR_EraseRootFromParent_Done,
     /*  317600 */   // Label 5868: @317600
     /*  317600 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(317663), // Rule ID 19750 //
     /*  317605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  317619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317644 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  317647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317661 */     GIR_RootConstrainSelectedInstOperands,
     /*  317662 */     // GIR_Coverage, 19750,
     /*  317662 */     GIR_EraseRootFromParent_Done,
     /*  317663 */   // Label 5869: @317663
     /*  317663 */   GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(317726), // Rule ID 19751 //
     /*  317668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  317679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  317682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  317696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317707 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2),
     /*  317710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317724 */     GIR_RootConstrainSelectedInstOperands,
     /*  317725 */     // GIR_Coverage, 19751,
     /*  317725 */     GIR_EraseRootFromParent_Done,
     /*  317726 */   // Label 5870: @317726
     /*  317726 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(317789), // Rule ID 19754 //
     /*  317731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  317745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  317773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317787 */     GIR_RootConstrainSelectedInstOperands,
     /*  317788 */     // GIR_Coverage, 19754,
     /*  317788 */     GIR_EraseRootFromParent_Done,
     /*  317789 */   // Label 5871: @317789
     /*  317789 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(317852), // Rule ID 19755 //
     /*  317794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  317805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  317808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  317822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317833 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4),
     /*  317836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317850 */     GIR_RootConstrainSelectedInstOperands,
     /*  317851 */     // GIR_Coverage, 19755,
     /*  317851 */     GIR_EraseRootFromParent_Done,
     /*  317852 */   // Label 5872: @317852
     /*  317852 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(317915), // Rule ID 19758 //
     /*  317857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  317860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  317871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  317877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  317896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  317899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317913 */     GIR_RootConstrainSelectedInstOperands,
     /*  317914 */     // GIR_Coverage, 19758,
     /*  317914 */     GIR_EraseRootFromParent_Done,
     /*  317915 */   // Label 5873: @317915
     /*  317915 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(317978), // Rule ID 19759 //
     /*  317920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  317923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  317931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  317934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  317937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  317940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  317944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  317948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  317952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  317959 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  317959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8),
     /*  317962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  317964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  317966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  317968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  317973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  317976 */     GIR_RootConstrainSelectedInstOperands,
     /*  317977 */     // GIR_Coverage, 19759,
     /*  317977 */     GIR_EraseRootFromParent_Done,
     /*  317978 */   // Label 5874: @317978
     /*  317978 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(318041), // Rule ID 19762 //
     /*  317983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  317986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  317991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  317994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  317997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318022 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318039 */     GIR_RootConstrainSelectedInstOperands,
     /*  318040 */     // GIR_Coverage, 19762,
     /*  318040 */     GIR_EraseRootFromParent_Done,
     /*  318041 */   // Label 5875: @318041
     /*  318041 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(318104), // Rule ID 19763 //
     /*  318046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  318060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  318074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318085 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11351:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2),
     /*  318088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318102 */     GIR_RootConstrainSelectedInstOperands,
     /*  318103 */     // GIR_Coverage, 19763,
     /*  318103 */     GIR_EraseRootFromParent_Done,
     /*  318104 */   // Label 5876: @318104
     /*  318104 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(318167), // Rule ID 19766 //
     /*  318109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318148 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318165 */     GIR_RootConstrainSelectedInstOperands,
     /*  318166 */     // GIR_Coverage, 19766,
     /*  318166 */     GIR_EraseRootFromParent_Done,
     /*  318167 */   // Label 5877: @318167
     /*  318167 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(318230), // Rule ID 19767 //
     /*  318172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  318186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  318200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318211 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11351:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4),
     /*  318214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318228 */     GIR_RootConstrainSelectedInstOperands,
     /*  318229 */     // GIR_Coverage, 19767,
     /*  318229 */     GIR_EraseRootFromParent_Done,
     /*  318230 */   // Label 5878: @318230
     /*  318230 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(318293), // Rule ID 19770 //
     /*  318235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318274 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  318274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318291 */     GIR_RootConstrainSelectedInstOperands,
     /*  318292 */     // GIR_Coverage, 19770,
     /*  318292 */     GIR_EraseRootFromParent_Done,
     /*  318293 */   // Label 5879: @318293
     /*  318293 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(318356), // Rule ID 19771 //
     /*  318298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  318301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq),
     /*  318306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  318309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  318312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  318315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  318326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  318330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318337 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11351:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  318337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8),
     /*  318340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  318354 */     GIR_RootConstrainSelectedInstOperands,
     /*  318355 */     // GIR_Coverage, 19771,
     /*  318355 */     GIR_EraseRootFromParent_Done,
     /*  318356 */   // Label 5880: @318356
     /*  318356 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(318419), // Rule ID 19774 //
     /*  318361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318400 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318417 */     GIR_RootConstrainSelectedInstOperands,
     /*  318418 */     // GIR_Coverage, 19774,
     /*  318418 */     GIR_EraseRootFromParent_Done,
     /*  318419 */   // Label 5881: @318419
     /*  318419 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(318482), // Rule ID 19775 //
     /*  318424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  318438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  318441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318463 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  318466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318480 */     GIR_RootConstrainSelectedInstOperands,
     /*  318481 */     // GIR_Coverage, 19775,
     /*  318481 */     GIR_EraseRootFromParent_Done,
     /*  318482 */   // Label 5882: @318482
     /*  318482 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(318545), // Rule ID 19778 //
     /*  318487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  318501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  318504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318526 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  318529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318543 */     GIR_RootConstrainSelectedInstOperands,
     /*  318544 */     // GIR_Coverage, 19778,
     /*  318544 */     GIR_EraseRootFromParent_Done,
     /*  318545 */   // Label 5883: @318545
     /*  318545 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(318608), // Rule ID 19779 //
     /*  318550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  318564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  318567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318589 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  318592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318606 */     GIR_RootConstrainSelectedInstOperands,
     /*  318607 */     // GIR_Coverage, 19779,
     /*  318607 */     GIR_EraseRootFromParent_Done,
     /*  318608 */   // Label 5884: @318608
     /*  318608 */   GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(318671), // Rule ID 19782 //
     /*  318613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  318627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  318630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  318655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318669 */     GIR_RootConstrainSelectedInstOperands,
     /*  318670 */     // GIR_Coverage, 19782,
     /*  318670 */     GIR_EraseRootFromParent_Done,
     /*  318671 */   // Label 5885: @318671
     /*  318671 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(318734), // Rule ID 19783 //
     /*  318676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  318687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  318690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  318693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318715 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  318718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318732 */     GIR_RootConstrainSelectedInstOperands,
     /*  318733 */     // GIR_Coverage, 19783,
     /*  318733 */     GIR_EraseRootFromParent_Done,
     /*  318734 */   // Label 5886: @318734
     /*  318734 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(318797), // Rule ID 19786 //
     /*  318739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  318742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  318753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  318756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318778 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  318778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  318781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318795 */     GIR_RootConstrainSelectedInstOperands,
     /*  318796 */     // GIR_Coverage, 19786,
     /*  318796 */     GIR_EraseRootFromParent_Done,
     /*  318797 */   // Label 5887: @318797
     /*  318797 */   GIM_Try, /*On fail goto*//*Label 5888*/ GIMT_Encode4(318860), // Rule ID 19787 //
     /*  318802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  318805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  318813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  318816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  318819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318841 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  318841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  318844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  318858 */     GIR_RootConstrainSelectedInstOperands,
     /*  318859 */     // GIR_Coverage, 19787,
     /*  318859 */     GIR_EraseRootFromParent_Done,
     /*  318860 */   // Label 5888: @318860
     /*  318860 */   GIM_Try, /*On fail goto*//*Label 5889*/ GIMT_Encode4(318923), // Rule ID 19790 //
     /*  318865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  318868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  318879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  318882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  318885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  318904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  318907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318921 */     GIR_RootConstrainSelectedInstOperands,
     /*  318922 */     // GIR_Coverage, 19790,
     /*  318922 */     GIR_EraseRootFromParent_Done,
     /*  318923 */   // Label 5889: @318923
     /*  318923 */   GIM_Try, /*On fail goto*//*Label 5890*/ GIMT_Encode4(318986), // Rule ID 19791 //
     /*  318928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  318931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  318939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  318942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  318945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  318948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  318960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  318967 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  318967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  318970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  318972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  318974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  318976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  318981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  318984 */     GIR_RootConstrainSelectedInstOperands,
     /*  318985 */     // GIR_Coverage, 19791,
     /*  318985 */     GIR_EraseRootFromParent_Done,
     /*  318986 */   // Label 5890: @318986
     /*  318986 */   GIM_Try, /*On fail goto*//*Label 5891*/ GIMT_Encode4(319049), // Rule ID 19794 //
     /*  318991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  318994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  318999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319030 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319047 */     GIR_RootConstrainSelectedInstOperands,
     /*  319048 */     // GIR_Coverage, 19794,
     /*  319048 */     GIR_EraseRootFromParent_Done,
     /*  319049 */   // Label 5891: @319049
     /*  319049 */   GIM_Try, /*On fail goto*//*Label 5892*/ GIMT_Encode4(319112), // Rule ID 19795 //
     /*  319054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  319065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  319068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  319071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319093 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  319096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319110 */     GIR_RootConstrainSelectedInstOperands,
     /*  319111 */     // GIR_Coverage, 19795,
     /*  319111 */     GIR_EraseRootFromParent_Done,
     /*  319112 */   // Label 5892: @319112
     /*  319112 */   GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(319175), // Rule ID 19798 //
     /*  319117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319173 */     GIR_RootConstrainSelectedInstOperands,
     /*  319174 */     // GIR_Coverage, 19798,
     /*  319174 */     GIR_EraseRootFromParent_Done,
     /*  319175 */   // Label 5893: @319175
     /*  319175 */   GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(319238), // Rule ID 19799 //
     /*  319180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  319194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  319197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319219 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319236 */     GIR_RootConstrainSelectedInstOperands,
     /*  319237 */     // GIR_Coverage, 19799,
     /*  319237 */     GIR_EraseRootFromParent_Done,
     /*  319238 */   // Label 5894: @319238
     /*  319238 */   GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(319301), // Rule ID 19802 //
     /*  319243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319282 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319299 */     GIR_RootConstrainSelectedInstOperands,
     /*  319300 */     // GIR_Coverage, 19802,
     /*  319300 */     GIR_EraseRootFromParent_Done,
     /*  319301 */   // Label 5895: @319301
     /*  319301 */   GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(319364), // Rule ID 19803 //
     /*  319306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  319320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  319323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319345 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319362 */     GIR_RootConstrainSelectedInstOperands,
     /*  319363 */     // GIR_Coverage, 19803,
     /*  319363 */     GIR_EraseRootFromParent_Done,
     /*  319364 */   // Label 5896: @319364
     /*  319364 */   GIM_Try, /*On fail goto*//*Label 5897*/ GIMT_Encode4(319427), // Rule ID 19806 //
     /*  319369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  319372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319408 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  319408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319425 */     GIR_RootConstrainSelectedInstOperands,
     /*  319426 */     // GIR_Coverage, 19806,
     /*  319426 */     GIR_EraseRootFromParent_Done,
     /*  319427 */   // Label 5897: @319427
     /*  319427 */   GIM_Try, /*On fail goto*//*Label 5898*/ GIMT_Encode4(319490), // Rule ID 19807 //
     /*  319432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  319435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  319443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  319446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  319449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319471 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  319471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  319488 */     GIR_RootConstrainSelectedInstOperands,
     /*  319489 */     // GIR_Coverage, 19807,
     /*  319489 */     GIR_EraseRootFromParent_Done,
     /*  319490 */   // Label 5898: @319490
     /*  319490 */   GIM_Try, /*On fail goto*//*Label 5899*/ GIMT_Encode4(319553), // Rule ID 19810 //
     /*  319495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  319509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  319512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319534 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319551 */     GIR_RootConstrainSelectedInstOperands,
     /*  319552 */     // GIR_Coverage, 19810,
     /*  319552 */     GIR_EraseRootFromParent_Done,
     /*  319553 */   // Label 5899: @319553
     /*  319553 */   GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(319616), // Rule ID 19811 //
     /*  319558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  319569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  319572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  319575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319597 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319614 */     GIR_RootConstrainSelectedInstOperands,
     /*  319615 */     // GIR_Coverage, 19811,
     /*  319615 */     GIR_EraseRootFromParent_Done,
     /*  319616 */   // Label 5900: @319616
     /*  319616 */   GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(319679), // Rule ID 19814 //
     /*  319621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  319635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  319638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319677 */     GIR_RootConstrainSelectedInstOperands,
     /*  319678 */     // GIR_Coverage, 19814,
     /*  319678 */     GIR_EraseRootFromParent_Done,
     /*  319679 */   // Label 5901: @319679
     /*  319679 */   GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(319742), // Rule ID 19815 //
     /*  319684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  319695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  319698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  319701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  319716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319723 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  319726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319740 */     GIR_RootConstrainSelectedInstOperands,
     /*  319741 */     // GIR_Coverage, 19815,
     /*  319741 */     GIR_EraseRootFromParent_Done,
     /*  319742 */   // Label 5902: @319742
     /*  319742 */   GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(319805), // Rule ID 19818 //
     /*  319747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  319750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  319761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  319764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  319786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319803 */     GIR_RootConstrainSelectedInstOperands,
     /*  319804 */     // GIR_Coverage, 19818,
     /*  319804 */     GIR_EraseRootFromParent_Done,
     /*  319805 */   // Label 5903: @319805
     /*  319805 */   GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(319868), // Rule ID 19819 //
     /*  319810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  319813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  319821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  319824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  319827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  319842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319849 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  319849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  319852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  319866 */     GIR_RootConstrainSelectedInstOperands,
     /*  319867 */     // GIR_Coverage, 19819,
     /*  319867 */     GIR_EraseRootFromParent_Done,
     /*  319868 */   // Label 5904: @319868
     /*  319868 */   GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(319931), // Rule ID 19822 //
     /*  319873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  319876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  319887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  319890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  319893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319912 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  319912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319929 */     GIR_RootConstrainSelectedInstOperands,
     /*  319930 */     // GIR_Coverage, 19822,
     /*  319930 */     GIR_EraseRootFromParent_Done,
     /*  319931 */   // Label 5905: @319931
     /*  319931 */   GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(319994), // Rule ID 19823 //
     /*  319936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  319939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  319944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  319947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  319950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  319953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  319956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  319960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  319968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  319975 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  319975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  319978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  319980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  319982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  319984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  319989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  319992 */     GIR_RootConstrainSelectedInstOperands,
     /*  319993 */     // GIR_Coverage, 19823,
     /*  319993 */     GIR_EraseRootFromParent_Done,
     /*  319994 */   // Label 5906: @319994
     /*  319994 */   GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(320057), // Rule ID 19826 //
     /*  319999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320038 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320055 */     GIR_RootConstrainSelectedInstOperands,
     /*  320056 */     // GIR_Coverage, 19826,
     /*  320056 */     GIR_EraseRootFromParent_Done,
     /*  320057 */   // Label 5907: @320057
     /*  320057 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(320120), // Rule ID 19827 //
     /*  320062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  320076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  320079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  320094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320101 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  320104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320118 */     GIR_RootConstrainSelectedInstOperands,
     /*  320119 */     // GIR_Coverage, 19827,
     /*  320119 */     GIR_EraseRootFromParent_Done,
     /*  320120 */   // Label 5908: @320120
     /*  320120 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(320183), // Rule ID 19830 //
     /*  320125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320164 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320181 */     GIR_RootConstrainSelectedInstOperands,
     /*  320182 */     // GIR_Coverage, 19830,
     /*  320182 */     GIR_EraseRootFromParent_Done,
     /*  320183 */   // Label 5909: @320183
     /*  320183 */   GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(320246), // Rule ID 19831 //
     /*  320188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  320199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  320202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  320205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  320220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320227 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  320230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320244 */     GIR_RootConstrainSelectedInstOperands,
     /*  320245 */     // GIR_Coverage, 19831,
     /*  320245 */     GIR_EraseRootFromParent_Done,
     /*  320246 */   // Label 5910: @320246
     /*  320246 */   GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(320309), // Rule ID 19834 //
     /*  320251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320290 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320307 */     GIR_RootConstrainSelectedInstOperands,
     /*  320308 */     // GIR_Coverage, 19834,
     /*  320308 */     GIR_EraseRootFromParent_Done,
     /*  320309 */   // Label 5911: @320309
     /*  320309 */   GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(320372), // Rule ID 19835 //
     /*  320314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  320328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320353 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4),
     /*  320356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320370 */     GIR_RootConstrainSelectedInstOperands,
     /*  320371 */     // GIR_Coverage, 19835,
     /*  320371 */     GIR_EraseRootFromParent_Done,
     /*  320372 */   // Label 5912: @320372
     /*  320372 */   GIM_Try, /*On fail goto*//*Label 5913*/ GIMT_Encode4(320435), // Rule ID 19838 //
     /*  320377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320416 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  320419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320433 */     GIR_RootConstrainSelectedInstOperands,
     /*  320434 */     // GIR_Coverage, 19838,
     /*  320434 */     GIR_EraseRootFromParent_Done,
     /*  320435 */   // Label 5913: @320435
     /*  320435 */   GIM_Try, /*On fail goto*//*Label 5914*/ GIMT_Encode4(320498), // Rule ID 19839 //
     /*  320440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  320454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320479 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2),
     /*  320482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320496 */     GIR_RootConstrainSelectedInstOperands,
     /*  320497 */     // GIR_Coverage, 19839,
     /*  320497 */     GIR_EraseRootFromParent_Done,
     /*  320498 */   // Label 5914: @320498
     /*  320498 */   GIM_Try, /*On fail goto*//*Label 5915*/ GIMT_Encode4(320561), // Rule ID 19842 //
     /*  320503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  320517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  320520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320542 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  320545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320559 */     GIR_RootConstrainSelectedInstOperands,
     /*  320560 */     // GIR_Coverage, 19842,
     /*  320560 */     GIR_EraseRootFromParent_Done,
     /*  320561 */   // Label 5915: @320561
     /*  320561 */   GIM_Try, /*On fail goto*//*Label 5916*/ GIMT_Encode4(320624), // Rule ID 19843 //
     /*  320566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  320580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  320583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320605 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2),
     /*  320608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320622 */     GIR_RootConstrainSelectedInstOperands,
     /*  320623 */     // GIR_Coverage, 19843,
     /*  320623 */     GIR_EraseRootFromParent_Done,
     /*  320624 */   // Label 5916: @320624
     /*  320624 */   GIM_Try, /*On fail goto*//*Label 5917*/ GIMT_Encode4(320687), // Rule ID 19846 //
     /*  320629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  320632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  320643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  320668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  320671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320685 */     GIR_RootConstrainSelectedInstOperands,
     /*  320686 */     // GIR_Coverage, 19846,
     /*  320686 */     GIR_EraseRootFromParent_Done,
     /*  320687 */   // Label 5917: @320687
     /*  320687 */   GIM_Try, /*On fail goto*//*Label 5918*/ GIMT_Encode4(320750), // Rule ID 19847 //
     /*  320692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  320695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  320703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  320706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  320709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  320724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320731 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  320731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1),
     /*  320734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  320748 */     GIR_RootConstrainSelectedInstOperands,
     /*  320749 */     // GIR_Coverage, 19847,
     /*  320749 */     GIR_EraseRootFromParent_Done,
     /*  320750 */   // Label 5918: @320750
     /*  320750 */   GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(320813), // Rule ID 19850 //
     /*  320755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  320758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  320769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  320772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320794 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  320794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  320797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320811 */     GIR_RootConstrainSelectedInstOperands,
     /*  320812 */     // GIR_Coverage, 19850,
     /*  320812 */     GIR_EraseRootFromParent_Done,
     /*  320813 */   // Label 5919: @320813
     /*  320813 */   GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(320876), // Rule ID 19851 //
     /*  320818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  320821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  320829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  320832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  320835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  320850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320857 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  320857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1),
     /*  320860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  320874 */     GIR_RootConstrainSelectedInstOperands,
     /*  320875 */     // GIR_Coverage, 19851,
     /*  320875 */     GIR_EraseRootFromParent_Done,
     /*  320876 */   // Label 5920: @320876
     /*  320876 */   GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(320939), // Rule ID 19854 //
     /*  320881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  320884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  320895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  320898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  320901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  320913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320920 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  320920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  320923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  320937 */     GIR_RootConstrainSelectedInstOperands,
     /*  320938 */     // GIR_Coverage, 19854,
     /*  320938 */     GIR_EraseRootFromParent_Done,
     /*  320939 */   // Label 5921: @320939
     /*  320939 */   GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(321002), // Rule ID 19855 //
     /*  320944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  320947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  320952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  320955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  320958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  320961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  320964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  320972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  320976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  320983 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11357:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  320983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1),
     /*  320986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  320988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  320990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  320992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  320997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321000 */     GIR_RootConstrainSelectedInstOperands,
     /*  321001 */     // GIR_Coverage, 19855,
     /*  321001 */     GIR_EraseRootFromParent_Done,
     /*  321002 */   // Label 5922: @321002
     /*  321002 */   GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(321065), // Rule ID 19858 //
     /*  321007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321046 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321063 */     GIR_RootConstrainSelectedInstOperands,
     /*  321064 */     // GIR_Coverage, 19858,
     /*  321064 */     GIR_EraseRootFromParent_Done,
     /*  321065 */   // Label 5923: @321065
     /*  321065 */   GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(321128), // Rule ID 19859 //
     /*  321070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  321084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321109 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2),
     /*  321112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321126 */     GIR_RootConstrainSelectedInstOperands,
     /*  321127 */     // GIR_Coverage, 19859,
     /*  321127 */     GIR_EraseRootFromParent_Done,
     /*  321128 */   // Label 5924: @321128
     /*  321128 */   GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(321191), // Rule ID 19862 //
     /*  321133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321189 */     GIR_RootConstrainSelectedInstOperands,
     /*  321190 */     // GIR_Coverage, 19862,
     /*  321190 */     GIR_EraseRootFromParent_Done,
     /*  321191 */   // Label 5925: @321191
     /*  321191 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(321254), // Rule ID 19863 //
     /*  321196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  321210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4),
     /*  321238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321252 */     GIR_RootConstrainSelectedInstOperands,
     /*  321253 */     // GIR_Coverage, 19863,
     /*  321253 */     GIR_EraseRootFromParent_Done,
     /*  321254 */   // Label 5926: @321254
     /*  321254 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(321317), // Rule ID 19866 //
     /*  321259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  321262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321298 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  321298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321315 */     GIR_RootConstrainSelectedInstOperands,
     /*  321316 */     // GIR_Coverage, 19866,
     /*  321316 */     GIR_EraseRootFromParent_Done,
     /*  321317 */   // Label 5927: @321317
     /*  321317 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(321380), // Rule ID 19867 //
     /*  321322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  321325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  321333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  321336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  321339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  321354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321361 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  321361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8),
     /*  321364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  321378 */     GIR_RootConstrainSelectedInstOperands,
     /*  321379 */     // GIR_Coverage, 19867,
     /*  321379 */     GIR_EraseRootFromParent_Done,
     /*  321380 */   // Label 5928: @321380
     /*  321380 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(321443), // Rule ID 19870 //
     /*  321385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321424 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  321427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321441 */     GIR_RootConstrainSelectedInstOperands,
     /*  321442 */     // GIR_Coverage, 19870,
     /*  321442 */     GIR_EraseRootFromParent_Done,
     /*  321443 */   // Label 5929: @321443
     /*  321443 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(321506), // Rule ID 19871 //
     /*  321448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  321462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321487 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2),
     /*  321490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321504 */     GIR_RootConstrainSelectedInstOperands,
     /*  321505 */     // GIR_Coverage, 19871,
     /*  321505 */     GIR_EraseRootFromParent_Done,
     /*  321506 */   // Label 5930: @321506
     /*  321506 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(321569), // Rule ID 19874 //
     /*  321511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  321525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321550 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  321553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321567 */     GIR_RootConstrainSelectedInstOperands,
     /*  321568 */     // GIR_Coverage, 19874,
     /*  321568 */     GIR_EraseRootFromParent_Done,
     /*  321569 */   // Label 5931: @321569
     /*  321569 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(321632), // Rule ID 19875 //
     /*  321574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  321585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  321588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321613 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4),
     /*  321616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321630 */     GIR_RootConstrainSelectedInstOperands,
     /*  321631 */     // GIR_Coverage, 19875,
     /*  321631 */     GIR_EraseRootFromParent_Done,
     /*  321632 */   // Label 5932: @321632
     /*  321632 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(321695), // Rule ID 19878 //
     /*  321637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  321640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  321651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321676 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  321676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  321679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321693 */     GIR_RootConstrainSelectedInstOperands,
     /*  321694 */     // GIR_Coverage, 19878,
     /*  321694 */     GIR_EraseRootFromParent_Done,
     /*  321695 */   // Label 5933: @321695
     /*  321695 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(321758), // Rule ID 19879 //
     /*  321700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  321703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  321711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  321714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  321717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  321728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  321732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321739 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  321739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8),
     /*  321742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  321756 */     GIR_RootConstrainSelectedInstOperands,
     /*  321757 */     // GIR_Coverage, 19879,
     /*  321757 */     GIR_EraseRootFromParent_Done,
     /*  321758 */   // Label 5934: @321758
     /*  321758 */   GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(321821), // Rule ID 19882 //
     /*  321763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  321777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  321805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321819 */     GIR_RootConstrainSelectedInstOperands,
     /*  321820 */     // GIR_Coverage, 19882,
     /*  321820 */     GIR_EraseRootFromParent_Done,
     /*  321821 */   // Label 5935: @321821
     /*  321821 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(321884), // Rule ID 19883 //
     /*  321826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  321837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  321840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  321854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321865 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11357:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2),
     /*  321868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321882 */     GIR_RootConstrainSelectedInstOperands,
     /*  321883 */     // GIR_Coverage, 19883,
     /*  321883 */     GIR_EraseRootFromParent_Done,
     /*  321884 */   // Label 5936: @321884
     /*  321884 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(321947), // Rule ID 19886 //
     /*  321889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  321892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  321903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  321909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  321928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  321931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  321937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  321942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  321945 */     GIR_RootConstrainSelectedInstOperands,
     /*  321946 */     // GIR_Coverage, 19886,
     /*  321946 */     GIR_EraseRootFromParent_Done,
     /*  321947 */   // Label 5937: @321947
     /*  321947 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(322010), // Rule ID 19887 //
     /*  321952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  321955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  321960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  321963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  321966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  321969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  321972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  321976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  321980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  321984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  321991 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11357:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  321991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4),
     /*  321994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  321996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  321998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322008 */     GIR_RootConstrainSelectedInstOperands,
     /*  322009 */     // GIR_Coverage, 19887,
     /*  322009 */     GIR_EraseRootFromParent_Done,
     /*  322010 */   // Label 5938: @322010
     /*  322010 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(322073), // Rule ID 19890 //
     /*  322015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322071 */     GIR_RootConstrainSelectedInstOperands,
     /*  322072 */     // GIR_Coverage, 19890,
     /*  322072 */     GIR_EraseRootFromParent_Done,
     /*  322073 */   // Label 5939: @322073
     /*  322073 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(322136), // Rule ID 19891 //
     /*  322078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle),
     /*  322086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  322092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  322095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  322106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  322110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322117 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11357:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8),
     /*  322120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322134 */     GIR_RootConstrainSelectedInstOperands,
     /*  322135 */     // GIR_Coverage, 19891,
     /*  322135 */     GIR_EraseRootFromParent_Done,
     /*  322136 */   // Label 5940: @322136
     /*  322136 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(322199), // Rule ID 19894 //
     /*  322141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322197 */     GIR_RootConstrainSelectedInstOperands,
     /*  322198 */     // GIR_Coverage, 19894,
     /*  322198 */     GIR_EraseRootFromParent_Done,
     /*  322199 */   // Label 5941: @322199
     /*  322199 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(322262), // Rule ID 19895 //
     /*  322204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  322218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  322221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322243 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  322246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322260 */     GIR_RootConstrainSelectedInstOperands,
     /*  322261 */     // GIR_Coverage, 19895,
     /*  322261 */     GIR_EraseRootFromParent_Done,
     /*  322262 */   // Label 5942: @322262
     /*  322262 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(322325), // Rule ID 19898 //
     /*  322267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322306 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322323 */     GIR_RootConstrainSelectedInstOperands,
     /*  322324 */     // GIR_Coverage, 19898,
     /*  322324 */     GIR_EraseRootFromParent_Done,
     /*  322325 */   // Label 5943: @322325
     /*  322325 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(322388), // Rule ID 19899 //
     /*  322330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  322344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  322347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322369 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322386 */     GIR_RootConstrainSelectedInstOperands,
     /*  322387 */     // GIR_Coverage, 19899,
     /*  322387 */     GIR_EraseRootFromParent_Done,
     /*  322388 */   // Label 5944: @322388
     /*  322388 */   GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(322451), // Rule ID 19902 //
     /*  322393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322432 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322449 */     GIR_RootConstrainSelectedInstOperands,
     /*  322450 */     // GIR_Coverage, 19902,
     /*  322450 */     GIR_EraseRootFromParent_Done,
     /*  322451 */   // Label 5945: @322451
     /*  322451 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(322514), // Rule ID 19903 //
     /*  322456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  322470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  322473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322495 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  322498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322512 */     GIR_RootConstrainSelectedInstOperands,
     /*  322513 */     // GIR_Coverage, 19903,
     /*  322513 */     GIR_EraseRootFromParent_Done,
     /*  322514 */   // Label 5946: @322514
     /*  322514 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(322577), // Rule ID 19906 //
     /*  322519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  322533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  322536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322558 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322575 */     GIR_RootConstrainSelectedInstOperands,
     /*  322576 */     // GIR_Coverage, 19906,
     /*  322576 */     GIR_EraseRootFromParent_Done,
     /*  322577 */   // Label 5947: @322577
     /*  322577 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(322640), // Rule ID 19907 //
     /*  322582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  322593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  322596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  322599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322621 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322638 */     GIR_RootConstrainSelectedInstOperands,
     /*  322639 */     // GIR_Coverage, 19907,
     /*  322639 */     GIR_EraseRootFromParent_Done,
     /*  322640 */   // Label 5948: @322640
     /*  322640 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(322703), // Rule ID 19910 //
     /*  322645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  322648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  322659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  322662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  322684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322701 */     GIR_RootConstrainSelectedInstOperands,
     /*  322702 */     // GIR_Coverage, 19910,
     /*  322702 */     GIR_EraseRootFromParent_Done,
     /*  322703 */   // Label 5949: @322703
     /*  322703 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(322766), // Rule ID 19911 //
     /*  322708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  322711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  322719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  322722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  322725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322747 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  322747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  322764 */     GIR_RootConstrainSelectedInstOperands,
     /*  322765 */     // GIR_Coverage, 19911,
     /*  322765 */     GIR_EraseRootFromParent_Done,
     /*  322766 */   // Label 5950: @322766
     /*  322766 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(322829), // Rule ID 19914 //
     /*  322771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  322774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  322785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  322788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  322810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322827 */     GIR_RootConstrainSelectedInstOperands,
     /*  322828 */     // GIR_Coverage, 19914,
     /*  322828 */     GIR_EraseRootFromParent_Done,
     /*  322829 */   // Label 5951: @322829
     /*  322829 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(322892), // Rule ID 19915 //
     /*  322834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  322837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  322845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  322848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  322851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322873 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  322873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  322876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  322890 */     GIR_RootConstrainSelectedInstOperands,
     /*  322891 */     // GIR_Coverage, 19915,
     /*  322891 */     GIR_EraseRootFromParent_Done,
     /*  322892 */   // Label 5952: @322892
     /*  322892 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(322955), // Rule ID 19918 //
     /*  322897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  322900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  322911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  322914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  322917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  322936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  322939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  322941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  322943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  322945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  322950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  322953 */     GIR_RootConstrainSelectedInstOperands,
     /*  322954 */     // GIR_Coverage, 19918,
     /*  322954 */     GIR_EraseRootFromParent_Done,
     /*  322955 */   // Label 5953: @322955
     /*  322955 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(323018), // Rule ID 19919 //
     /*  322960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  322963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  322968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  322971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  322974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  322977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  322980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  322984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  322992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  322999 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  322999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323016 */     GIR_RootConstrainSelectedInstOperands,
     /*  323017 */     // GIR_Coverage, 19919,
     /*  323017 */     GIR_EraseRootFromParent_Done,
     /*  323018 */   // Label 5954: @323018
     /*  323018 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(323081), // Rule ID 19922 //
     /*  323023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323062 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323079 */     GIR_RootConstrainSelectedInstOperands,
     /*  323080 */     // GIR_Coverage, 19922,
     /*  323080 */     GIR_EraseRootFromParent_Done,
     /*  323081 */   // Label 5955: @323081
     /*  323081 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(323144), // Rule ID 19923 //
     /*  323086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  323100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  323103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323125 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323142 */     GIR_RootConstrainSelectedInstOperands,
     /*  323143 */     // GIR_Coverage, 19923,
     /*  323143 */     GIR_EraseRootFromParent_Done,
     /*  323144 */   // Label 5956: @323144
     /*  323144 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(323207), // Rule ID 19926 //
     /*  323149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  323152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323188 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  323188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323205 */     GIR_RootConstrainSelectedInstOperands,
     /*  323206 */     // GIR_Coverage, 19926,
     /*  323206 */     GIR_EraseRootFromParent_Done,
     /*  323207 */   // Label 5957: @323207
     /*  323207 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(323270), // Rule ID 19927 //
     /*  323212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  323215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  323223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  323226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  323229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323251 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  323251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  323268 */     GIR_RootConstrainSelectedInstOperands,
     /*  323269 */     // GIR_Coverage, 19927,
     /*  323269 */     GIR_EraseRootFromParent_Done,
     /*  323270 */   // Label 5958: @323270
     /*  323270 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(323333), // Rule ID 19930 //
     /*  323275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323314 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323331 */     GIR_RootConstrainSelectedInstOperands,
     /*  323332 */     // GIR_Coverage, 19930,
     /*  323332 */     GIR_EraseRootFromParent_Done,
     /*  323333 */   // Label 5959: @323333
     /*  323333 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(323396), // Rule ID 19931 //
     /*  323338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  323352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  323355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323377 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323394 */     GIR_RootConstrainSelectedInstOperands,
     /*  323395 */     // GIR_Coverage, 19931,
     /*  323395 */     GIR_EraseRootFromParent_Done,
     /*  323396 */   // Label 5960: @323396
     /*  323396 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(323459), // Rule ID 19934 //
     /*  323401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323440 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323457 */     GIR_RootConstrainSelectedInstOperands,
     /*  323458 */     // GIR_Coverage, 19934,
     /*  323458 */     GIR_EraseRootFromParent_Done,
     /*  323459 */   // Label 5961: @323459
     /*  323459 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(323522), // Rule ID 19935 //
     /*  323464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  323478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  323481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323503 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323520 */     GIR_RootConstrainSelectedInstOperands,
     /*  323521 */     // GIR_Coverage, 19935,
     /*  323521 */     GIR_EraseRootFromParent_Done,
     /*  323522 */   // Label 5962: @323522
     /*  323522 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(323585), // Rule ID 19938 //
     /*  323527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  323530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  323541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  323544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323566 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  323566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323583 */     GIR_RootConstrainSelectedInstOperands,
     /*  323584 */     // GIR_Coverage, 19938,
     /*  323584 */     GIR_EraseRootFromParent_Done,
     /*  323585 */   // Label 5963: @323585
     /*  323585 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(323648), // Rule ID 19939 //
     /*  323590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  323593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  323601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  323604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  323607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323629 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  323629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  323646 */     GIR_RootConstrainSelectedInstOperands,
     /*  323647 */     // GIR_Coverage, 19939,
     /*  323647 */     GIR_EraseRootFromParent_Done,
     /*  323648 */   // Label 5964: @323648
     /*  323648 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(323711), // Rule ID 19942 //
     /*  323653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  323667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  323670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323692 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323709 */     GIR_RootConstrainSelectedInstOperands,
     /*  323710 */     // GIR_Coverage, 19942,
     /*  323710 */     GIR_EraseRootFromParent_Done,
     /*  323711 */   // Label 5965: @323711
     /*  323711 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(323774), // Rule ID 19943 //
     /*  323716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  323727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  323730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  323733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  323748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  323758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323772 */     GIR_RootConstrainSelectedInstOperands,
     /*  323773 */     // GIR_Coverage, 19943,
     /*  323773 */     GIR_EraseRootFromParent_Done,
     /*  323774 */   // Label 5966: @323774
     /*  323774 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(323837), // Rule ID 19946 //
     /*  323779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  323793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  323796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323818 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323835 */     GIR_RootConstrainSelectedInstOperands,
     /*  323836 */     // GIR_Coverage, 19946,
     /*  323836 */     GIR_EraseRootFromParent_Done,
     /*  323837 */   // Label 5967: @323837
     /*  323837 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(323900), // Rule ID 19947 //
     /*  323842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  323853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  323856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  323859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  323874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323881 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  323881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  323884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323898 */     GIR_RootConstrainSelectedInstOperands,
     /*  323899 */     // GIR_Coverage, 19947,
     /*  323899 */     GIR_EraseRootFromParent_Done,
     /*  323900 */   // Label 5968: @323900
     /*  323900 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(323963), // Rule ID 19950 //
     /*  323905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  323908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  323922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  323925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  323944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  323944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  323947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  323949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  323951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  323953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  323958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  323961 */     GIR_RootConstrainSelectedInstOperands,
     /*  323962 */     // GIR_Coverage, 19950,
     /*  323962 */     GIR_EraseRootFromParent_Done,
     /*  323963 */   // Label 5969: @323963
     /*  323963 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(324026), // Rule ID 19951 //
     /*  323968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  323971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  323976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  323979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  323982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  323985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  323988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  323992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  323996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  324000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324007 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  324010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324024 */     GIR_RootConstrainSelectedInstOperands,
     /*  324025 */     // GIR_Coverage, 19951,
     /*  324025 */     GIR_EraseRootFromParent_Done,
     /*  324026 */   // Label 5970: @324026
     /*  324026 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(324089), // Rule ID 19954 //
     /*  324031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324070 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324087 */     GIR_RootConstrainSelectedInstOperands,
     /*  324088 */     // GIR_Coverage, 19954,
     /*  324088 */     GIR_EraseRootFromParent_Done,
     /*  324089 */   // Label 5971: @324089
     /*  324089 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(324152), // Rule ID 19955 //
     /*  324094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  324108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324133 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4),
     /*  324136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324150 */     GIR_RootConstrainSelectedInstOperands,
     /*  324151 */     // GIR_Coverage, 19955,
     /*  324151 */     GIR_EraseRootFromParent_Done,
     /*  324152 */   // Label 5972: @324152
     /*  324152 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(324215), // Rule ID 19958 //
     /*  324157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324196 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324213 */     GIR_RootConstrainSelectedInstOperands,
     /*  324214 */     // GIR_Coverage, 19958,
     /*  324214 */     GIR_EraseRootFromParent_Done,
     /*  324215 */   // Label 5973: @324215
     /*  324215 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(324278), // Rule ID 19959 //
     /*  324220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  324234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324259 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2),
     /*  324262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324276 */     GIR_RootConstrainSelectedInstOperands,
     /*  324277 */     // GIR_Coverage, 19959,
     /*  324277 */     GIR_EraseRootFromParent_Done,
     /*  324278 */   // Label 5974: @324278
     /*  324278 */   GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(324341), // Rule ID 19962 //
     /*  324283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324322 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324339 */     GIR_RootConstrainSelectedInstOperands,
     /*  324340 */     // GIR_Coverage, 19962,
     /*  324340 */     GIR_EraseRootFromParent_Done,
     /*  324341 */   // Label 5975: @324341
     /*  324341 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(324404), // Rule ID 19963 //
     /*  324346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  324360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324385 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2),
     /*  324388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324402 */     GIR_RootConstrainSelectedInstOperands,
     /*  324403 */     // GIR_Coverage, 19963,
     /*  324403 */     GIR_EraseRootFromParent_Done,
     /*  324404 */   // Label 5976: @324404
     /*  324404 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(324467), // Rule ID 19966 //
     /*  324409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  324451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324465 */     GIR_RootConstrainSelectedInstOperands,
     /*  324466 */     // GIR_Coverage, 19966,
     /*  324466 */     GIR_EraseRootFromParent_Done,
     /*  324467 */   // Label 5977: @324467
     /*  324467 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(324530), // Rule ID 19967 //
     /*  324472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  324483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  324486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324511 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1),
     /*  324514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324528 */     GIR_RootConstrainSelectedInstOperands,
     /*  324529 */     // GIR_Coverage, 19967,
     /*  324529 */     GIR_EraseRootFromParent_Done,
     /*  324530 */   // Label 5978: @324530
     /*  324530 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(324593), // Rule ID 19970 //
     /*  324535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  324538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  324549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324574 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  324574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  324577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324591 */     GIR_RootConstrainSelectedInstOperands,
     /*  324592 */     // GIR_Coverage, 19970,
     /*  324592 */     GIR_EraseRootFromParent_Done,
     /*  324593 */   // Label 5979: @324593
     /*  324593 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(324656), // Rule ID 19971 //
     /*  324598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  324601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  324609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  324612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  324615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  324630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324637 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  324637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1),
     /*  324640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  324654 */     GIR_RootConstrainSelectedInstOperands,
     /*  324655 */     // GIR_Coverage, 19971,
     /*  324655 */     GIR_EraseRootFromParent_Done,
     /*  324656 */   // Label 5980: @324656
     /*  324656 */   GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(324719), // Rule ID 19974 //
     /*  324661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  324664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  324675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  324678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  324693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  324700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  324703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324717 */     GIR_RootConstrainSelectedInstOperands,
     /*  324718 */     // GIR_Coverage, 19974,
     /*  324718 */     GIR_EraseRootFromParent_Done,
     /*  324719 */   // Label 5981: @324719
     /*  324719 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(324782), // Rule ID 19975 //
     /*  324724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  324727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  324735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  324738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  324741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  324756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324763 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11359:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  324763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1),
     /*  324766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  324780 */     GIR_RootConstrainSelectedInstOperands,
     /*  324781 */     // GIR_Coverage, 19975,
     /*  324781 */     GIR_EraseRootFromParent_Done,
     /*  324782 */   // Label 5982: @324782
     /*  324782 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(324845), // Rule ID 19978 //
     /*  324787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  324801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324826 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  324829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324843 */     GIR_RootConstrainSelectedInstOperands,
     /*  324844 */     // GIR_Coverage, 19978,
     /*  324844 */     GIR_EraseRootFromParent_Done,
     /*  324845 */   // Label 5983: @324845
     /*  324845 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(324908), // Rule ID 19979 //
     /*  324850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  324861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  324864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  324878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324889 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  324889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2),
     /*  324892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324906 */     GIR_RootConstrainSelectedInstOperands,
     /*  324907 */     // GIR_Coverage, 19979,
     /*  324907 */     GIR_EraseRootFromParent_Done,
     /*  324908 */   // Label 5984: @324908
     /*  324908 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(324971), // Rule ID 19982 //
     /*  324913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  324916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  324933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  324937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  324941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  324945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  324952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  324952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  324955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  324957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  324959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  324961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  324966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  324969 */     GIR_RootConstrainSelectedInstOperands,
     /*  324970 */     // GIR_Coverage, 19982,
     /*  324970 */     GIR_EraseRootFromParent_Done,
     /*  324971 */   // Label 5985: @324971
     /*  324971 */   GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(325034), // Rule ID 19983 //
     /*  324976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  324979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  324984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  324987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  324990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  324993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  324996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325015 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4),
     /*  325018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325032 */     GIR_RootConstrainSelectedInstOperands,
     /*  325033 */     // GIR_Coverage, 19983,
     /*  325033 */     GIR_EraseRootFromParent_Done,
     /*  325034 */   // Label 5986: @325034
     /*  325034 */   GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(325097), // Rule ID 19986 //
     /*  325039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325078 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325095 */     GIR_RootConstrainSelectedInstOperands,
     /*  325096 */     // GIR_Coverage, 19986,
     /*  325096 */     GIR_EraseRootFromParent_Done,
     /*  325097 */   // Label 5987: @325097
     /*  325097 */   GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(325160), // Rule ID 19987 //
     /*  325102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  325113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  325116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  325119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  325134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325141 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  325141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8),
     /*  325144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325158 */     GIR_RootConstrainSelectedInstOperands,
     /*  325159 */     // GIR_Coverage, 19987,
     /*  325159 */     GIR_EraseRootFromParent_Done,
     /*  325160 */   // Label 5988: @325160
     /*  325160 */   GIM_Try, /*On fail goto*//*Label 5989*/ GIMT_Encode4(325223), // Rule ID 19990 //
     /*  325165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325204 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325221 */     GIR_RootConstrainSelectedInstOperands,
     /*  325222 */     // GIR_Coverage, 19990,
     /*  325222 */     GIR_EraseRootFromParent_Done,
     /*  325223 */   // Label 5989: @325223
     /*  325223 */   GIM_Try, /*On fail goto*//*Label 5990*/ GIMT_Encode4(325286), // Rule ID 19991 //
     /*  325228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  325242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325267 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2),
     /*  325270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325284 */     GIR_RootConstrainSelectedInstOperands,
     /*  325285 */     // GIR_Coverage, 19991,
     /*  325285 */     GIR_EraseRootFromParent_Done,
     /*  325286 */   // Label 5990: @325286
     /*  325286 */   GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(325349), // Rule ID 19994 //
     /*  325291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325330 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325347 */     GIR_RootConstrainSelectedInstOperands,
     /*  325348 */     // GIR_Coverage, 19994,
     /*  325348 */     GIR_EraseRootFromParent_Done,
     /*  325349 */   // Label 5991: @325349
     /*  325349 */   GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(325412), // Rule ID 19995 //
     /*  325354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  325368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4),
     /*  325396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325410 */     GIR_RootConstrainSelectedInstOperands,
     /*  325411 */     // GIR_Coverage, 19995,
     /*  325411 */     GIR_EraseRootFromParent_Done,
     /*  325412 */   // Label 5992: @325412
     /*  325412 */   GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(325475), // Rule ID 19998 //
     /*  325417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  325420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  325431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325456 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  325456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  325459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325473 */     GIR_RootConstrainSelectedInstOperands,
     /*  325474 */     // GIR_Coverage, 19998,
     /*  325474 */     GIR_EraseRootFromParent_Done,
     /*  325475 */   // Label 5993: @325475
     /*  325475 */   GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(325538), // Rule ID 19999 //
     /*  325480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  325483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  325491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  325494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  325497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  325512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325519 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  325519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8),
     /*  325522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  325536 */     GIR_RootConstrainSelectedInstOperands,
     /*  325537 */     // GIR_Coverage, 19999,
     /*  325537 */     GIR_EraseRootFromParent_Done,
     /*  325538 */   // Label 5994: @325538
     /*  325538 */   GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(325601), // Rule ID 20002 //
     /*  325543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  325557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325582 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  325585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325599 */     GIR_RootConstrainSelectedInstOperands,
     /*  325600 */     // GIR_Coverage, 20002,
     /*  325600 */     GIR_EraseRootFromParent_Done,
     /*  325601 */   // Label 5995: @325601
     /*  325601 */   GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(325664), // Rule ID 20003 //
     /*  325606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  325617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  325620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  325634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325645 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11359:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2),
     /*  325648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325662 */     GIR_RootConstrainSelectedInstOperands,
     /*  325663 */     // GIR_Coverage, 20003,
     /*  325663 */     GIR_EraseRootFromParent_Done,
     /*  325664 */   // Label 5996: @325664
     /*  325664 */   GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(325727), // Rule ID 20006 //
     /*  325669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  325683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  325711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325725 */     GIR_RootConstrainSelectedInstOperands,
     /*  325726 */     // GIR_Coverage, 20006,
     /*  325726 */     GIR_EraseRootFromParent_Done,
     /*  325727 */   // Label 5997: @325727
     /*  325727 */   GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(325790), // Rule ID 20007 //
     /*  325732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  325743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  325746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  325760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325771 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11359:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4),
     /*  325774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325788 */     GIR_RootConstrainSelectedInstOperands,
     /*  325789 */     // GIR_Coverage, 20007,
     /*  325789 */     GIR_EraseRootFromParent_Done,
     /*  325790 */   // Label 5998: @325790
     /*  325790 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(325853), // Rule ID 20010 //
     /*  325795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  325798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  325809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  325834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  325837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325851 */     GIR_RootConstrainSelectedInstOperands,
     /*  325852 */     // GIR_Coverage, 20010,
     /*  325852 */     GIR_EraseRootFromParent_Done,
     /*  325853 */   // Label 5999: @325853
     /*  325853 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(325916), // Rule ID 20011 //
     /*  325858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  325861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt),
     /*  325866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  325869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  325872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  325875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  325878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  325886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  325890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325897 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11359:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  325897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8),
     /*  325900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  325914 */     GIR_RootConstrainSelectedInstOperands,
     /*  325915 */     // GIR_Coverage, 20011,
     /*  325915 */     GIR_EraseRootFromParent_Done,
     /*  325916 */   // Label 6000: @325916
     /*  325916 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(325979), // Rule ID 20014 //
     /*  325921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  325924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  325929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  325938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  325941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  325953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  325960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  325960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  325963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  325965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  325967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  325969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  325974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  325977 */     GIR_RootConstrainSelectedInstOperands,
     /*  325978 */     // GIR_Coverage, 20014,
     /*  325978 */     GIR_EraseRootFromParent_Done,
     /*  325979 */   // Label 6001: @325979
     /*  325979 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(326042), // Rule ID 20015 //
     /*  325984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  325987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  325992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  325995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  325998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  326001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326023 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /*  326026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326040 */     GIR_RootConstrainSelectedInstOperands,
     /*  326041 */     // GIR_Coverage, 20015,
     /*  326041 */     GIR_EraseRootFromParent_Done,
     /*  326042 */   // Label 6002: @326042
     /*  326042 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(326105), // Rule ID 20018 //
     /*  326047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326086 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326103 */     GIR_RootConstrainSelectedInstOperands,
     /*  326104 */     // GIR_Coverage, 20018,
     /*  326104 */     GIR_EraseRootFromParent_Done,
     /*  326105 */   // Label 6003: @326105
     /*  326105 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(326168), // Rule ID 20019 //
     /*  326110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  326124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  326127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326149 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326166 */     GIR_RootConstrainSelectedInstOperands,
     /*  326167 */     // GIR_Coverage, 20019,
     /*  326167 */     GIR_EraseRootFromParent_Done,
     /*  326168 */   // Label 6004: @326168
     /*  326168 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(326231), // Rule ID 20022 //
     /*  326173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326212 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326229 */     GIR_RootConstrainSelectedInstOperands,
     /*  326230 */     // GIR_Coverage, 20022,
     /*  326230 */     GIR_EraseRootFromParent_Done,
     /*  326231 */   // Label 6005: @326231
     /*  326231 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(326294), // Rule ID 20023 //
     /*  326236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  326250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  326253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326275 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /*  326278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326292 */     GIR_RootConstrainSelectedInstOperands,
     /*  326293 */     // GIR_Coverage, 20023,
     /*  326293 */     GIR_EraseRootFromParent_Done,
     /*  326294 */   // Label 6006: @326294
     /*  326294 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(326357), // Rule ID 20026 //
     /*  326299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326338 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326355 */     GIR_RootConstrainSelectedInstOperands,
     /*  326356 */     // GIR_Coverage, 20026,
     /*  326356 */     GIR_EraseRootFromParent_Done,
     /*  326357 */   // Label 6007: @326357
     /*  326357 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(326420), // Rule ID 20027 //
     /*  326362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  326373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  326376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  326379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326401 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326418 */     GIR_RootConstrainSelectedInstOperands,
     /*  326419 */     // GIR_Coverage, 20027,
     /*  326419 */     GIR_EraseRootFromParent_Done,
     /*  326420 */   // Label 6008: @326420
     /*  326420 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(326483), // Rule ID 20030 //
     /*  326425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  326428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  326439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  326442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  326464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326481 */     GIR_RootConstrainSelectedInstOperands,
     /*  326482 */     // GIR_Coverage, 20030,
     /*  326482 */     GIR_EraseRootFromParent_Done,
     /*  326483 */   // Label 6009: @326483
     /*  326483 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(326546), // Rule ID 20031 //
     /*  326488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  326491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  326499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  326502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  326505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326527 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  326527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  326544 */     GIR_RootConstrainSelectedInstOperands,
     /*  326545 */     // GIR_Coverage, 20031,
     /*  326545 */     GIR_EraseRootFromParent_Done,
     /*  326546 */   // Label 6010: @326546
     /*  326546 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(326609), // Rule ID 20034 //
     /*  326551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  326554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  326565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  326568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326590 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  326590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326607 */     GIR_RootConstrainSelectedInstOperands,
     /*  326608 */     // GIR_Coverage, 20034,
     /*  326608 */     GIR_EraseRootFromParent_Done,
     /*  326609 */   // Label 6011: @326609
     /*  326609 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(326672), // Rule ID 20035 //
     /*  326614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  326617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  326625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  326628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  326631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326653 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  326653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /*  326656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  326670 */     GIR_RootConstrainSelectedInstOperands,
     /*  326671 */     // GIR_Coverage, 20035,
     /*  326671 */     GIR_EraseRootFromParent_Done,
     /*  326672 */   // Label 6012: @326672
     /*  326672 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(326735), // Rule ID 20038 //
     /*  326677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  326691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  326694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  326719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326733 */     GIR_RootConstrainSelectedInstOperands,
     /*  326734 */     // GIR_Coverage, 20038,
     /*  326734 */     GIR_EraseRootFromParent_Done,
     /*  326735 */   // Label 6013: @326735
     /*  326735 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(326798), // Rule ID 20039 //
     /*  326740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  326751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  326754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  326757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  326772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326779 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  326782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326796 */     GIR_RootConstrainSelectedInstOperands,
     /*  326797 */     // GIR_Coverage, 20039,
     /*  326797 */     GIR_EraseRootFromParent_Done,
     /*  326798 */   // Label 6014: @326798
     /*  326798 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(326861), // Rule ID 20042 //
     /*  326803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  326817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  326820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  326845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326859 */     GIR_RootConstrainSelectedInstOperands,
     /*  326860 */     // GIR_Coverage, 20042,
     /*  326860 */     GIR_EraseRootFromParent_Done,
     /*  326861 */   // Label 6015: @326861
     /*  326861 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(326924), // Rule ID 20043 //
     /*  326866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  326877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  326880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  326883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  326886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  326898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326905 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  326905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  326908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326922 */     GIR_RootConstrainSelectedInstOperands,
     /*  326923 */     // GIR_Coverage, 20043,
     /*  326923 */     GIR_EraseRootFromParent_Done,
     /*  326924 */   // Label 6016: @326924
     /*  326924 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(326987), // Rule ID 20046 //
     /*  326929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  326932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  326937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  326940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  326943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  326946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  326949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  326953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  326961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  326968 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  326968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  326971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  326973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  326975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  326977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  326982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  326985 */     GIR_RootConstrainSelectedInstOperands,
     /*  326986 */     // GIR_Coverage, 20046,
     /*  326986 */     GIR_EraseRootFromParent_Done,
     /*  326987 */   // Label 6017: @326987
     /*  326987 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(327050), // Rule ID 20047 //
     /*  326992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  326995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  327003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  327006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  327009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327031 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327048 */     GIR_RootConstrainSelectedInstOperands,
     /*  327049 */     // GIR_Coverage, 20047,
     /*  327049 */     GIR_EraseRootFromParent_Done,
     /*  327050 */   // Label 6018: @327050
     /*  327050 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(327113), // Rule ID 20050 //
     /*  327055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327094 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327111 */     GIR_RootConstrainSelectedInstOperands,
     /*  327112 */     // GIR_Coverage, 20050,
     /*  327112 */     GIR_EraseRootFromParent_Done,
     /*  327113 */   // Label 6019: @327113
     /*  327113 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(327176), // Rule ID 20051 //
     /*  327118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  327132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  327135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327157 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327174 */     GIR_RootConstrainSelectedInstOperands,
     /*  327175 */     // GIR_Coverage, 20051,
     /*  327175 */     GIR_EraseRootFromParent_Done,
     /*  327176 */   // Label 6020: @327176
     /*  327176 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(327239), // Rule ID 20054 //
     /*  327181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327237 */     GIR_RootConstrainSelectedInstOperands,
     /*  327238 */     // GIR_Coverage, 20054,
     /*  327238 */     GIR_EraseRootFromParent_Done,
     /*  327239 */   // Label 6021: @327239
     /*  327239 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(327302), // Rule ID 20055 //
     /*  327244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  327258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  327261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327283 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327300 */     GIR_RootConstrainSelectedInstOperands,
     /*  327301 */     // GIR_Coverage, 20055,
     /*  327301 */     GIR_EraseRootFromParent_Done,
     /*  327302 */   // Label 6022: @327302
     /*  327302 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(327365), // Rule ID 20058 //
     /*  327307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  327310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327346 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  327346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327363 */     GIR_RootConstrainSelectedInstOperands,
     /*  327364 */     // GIR_Coverage, 20058,
     /*  327364 */     GIR_EraseRootFromParent_Done,
     /*  327365 */   // Label 6023: @327365
     /*  327365 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(327428), // Rule ID 20059 //
     /*  327370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  327373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  327381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  327384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  327387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327409 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  327409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  327426 */     GIR_RootConstrainSelectedInstOperands,
     /*  327427 */     // GIR_Coverage, 20059,
     /*  327427 */     GIR_EraseRootFromParent_Done,
     /*  327428 */   // Label 6024: @327428
     /*  327428 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(327491), // Rule ID 20062 //
     /*  327433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  327447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  327450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327472 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327489 */     GIR_RootConstrainSelectedInstOperands,
     /*  327490 */     // GIR_Coverage, 20062,
     /*  327490 */     GIR_EraseRootFromParent_Done,
     /*  327491 */   // Label 6025: @327491
     /*  327491 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(327554), // Rule ID 20063 //
     /*  327496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  327510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  327513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  327528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327535 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /*  327538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327552 */     GIR_RootConstrainSelectedInstOperands,
     /*  327553 */     // GIR_Coverage, 20063,
     /*  327553 */     GIR_EraseRootFromParent_Done,
     /*  327554 */   // Label 6026: @327554
     /*  327554 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(327617), // Rule ID 20066 //
     /*  327559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  327573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  327576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327598 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327615 */     GIR_RootConstrainSelectedInstOperands,
     /*  327616 */     // GIR_Coverage, 20066,
     /*  327616 */     GIR_EraseRootFromParent_Done,
     /*  327617 */   // Label 6027: @327617
     /*  327617 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(327680), // Rule ID 20067 //
     /*  327622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  327633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  327636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  327639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  327654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327661 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /*  327664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327678 */     GIR_RootConstrainSelectedInstOperands,
     /*  327679 */     // GIR_Coverage, 20067,
     /*  327679 */     GIR_EraseRootFromParent_Done,
     /*  327680 */   // Label 6028: @327680
     /*  327680 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(327743), // Rule ID 20070 //
     /*  327685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  327688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  327699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  327702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327724 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  327724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327741 */     GIR_RootConstrainSelectedInstOperands,
     /*  327742 */     // GIR_Coverage, 20070,
     /*  327742 */     GIR_EraseRootFromParent_Done,
     /*  327743 */   // Label 6029: @327743
     /*  327743 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(327806), // Rule ID 20071 //
     /*  327748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  327751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  327759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  327762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  327765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  327780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327787 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  327787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /*  327790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  327804 */     GIR_RootConstrainSelectedInstOperands,
     /*  327805 */     // GIR_Coverage, 20071,
     /*  327805 */     GIR_EraseRootFromParent_Done,
     /*  327806 */   // Label 6030: @327806
     /*  327806 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(327869), // Rule ID 20074 //
     /*  327811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  327825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  327828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  327843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  327853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327867 */     GIR_RootConstrainSelectedInstOperands,
     /*  327868 */     // GIR_Coverage, 20074,
     /*  327868 */     GIR_EraseRootFromParent_Done,
     /*  327869 */   // Label 6031: @327869
     /*  327869 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(327932), // Rule ID 20075 //
     /*  327874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  327877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  327885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  327888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  327891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  327894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  327906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327913 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  327913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4),
     /*  327916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327930 */     GIR_RootConstrainSelectedInstOperands,
     /*  327931 */     // GIR_Coverage, 20075,
     /*  327931 */     GIR_EraseRootFromParent_Done,
     /*  327932 */   // Label 6032: @327932
     /*  327932 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(327995), // Rule ID 20078 //
     /*  327937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  327940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  327945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  327948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  327951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  327954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  327957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  327965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  327969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  327976 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  327976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  327979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  327981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  327983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  327985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  327990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  327993 */     GIR_RootConstrainSelectedInstOperands,
     /*  327994 */     // GIR_Coverage, 20078,
     /*  327994 */     GIR_EraseRootFromParent_Done,
     /*  327995 */   // Label 6033: @327995
     /*  327995 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(328058), // Rule ID 20079 //
     /*  328000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  328014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328039 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2),
     /*  328042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328056 */     GIR_RootConstrainSelectedInstOperands,
     /*  328057 */     // GIR_Coverage, 20079,
     /*  328057 */     GIR_EraseRootFromParent_Done,
     /*  328058 */   // Label 6034: @328058
     /*  328058 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(328121), // Rule ID 20082 //
     /*  328063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328102 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328119 */     GIR_RootConstrainSelectedInstOperands,
     /*  328120 */     // GIR_Coverage, 20082,
     /*  328120 */     GIR_EraseRootFromParent_Done,
     /*  328121 */   // Label 6035: @328121
     /*  328121 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(328184), // Rule ID 20083 //
     /*  328126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  328140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328165 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2),
     /*  328168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328182 */     GIR_RootConstrainSelectedInstOperands,
     /*  328183 */     // GIR_Coverage, 20083,
     /*  328183 */     GIR_EraseRootFromParent_Done,
     /*  328184 */   // Label 6036: @328184
     /*  328184 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(328247), // Rule ID 20086 //
     /*  328189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328228 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328245 */     GIR_RootConstrainSelectedInstOperands,
     /*  328246 */     // GIR_Coverage, 20086,
     /*  328246 */     GIR_EraseRootFromParent_Done,
     /*  328247 */   // Label 6037: @328247
     /*  328247 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(328310), // Rule ID 20087 //
     /*  328252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  328266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328291 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1),
     /*  328294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328308 */     GIR_RootConstrainSelectedInstOperands,
     /*  328309 */     // GIR_Coverage, 20087,
     /*  328309 */     GIR_EraseRootFromParent_Done,
     /*  328310 */   // Label 6038: @328310
     /*  328310 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(328373), // Rule ID 20090 //
     /*  328315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328354 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328371 */     GIR_RootConstrainSelectedInstOperands,
     /*  328372 */     // GIR_Coverage, 20090,
     /*  328372 */     GIR_EraseRootFromParent_Done,
     /*  328373 */   // Label 6039: @328373
     /*  328373 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(328436), // Rule ID 20091 //
     /*  328378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  328381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  328389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  328392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328417 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  328417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1),
     /*  328420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  328434 */     GIR_RootConstrainSelectedInstOperands,
     /*  328435 */     // GIR_Coverage, 20091,
     /*  328435 */     GIR_EraseRootFromParent_Done,
     /*  328436 */   // Label 6040: @328436
     /*  328436 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(328499), // Rule ID 20094 //
     /*  328441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  328444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  328473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  328480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  328483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328497 */     GIR_RootConstrainSelectedInstOperands,
     /*  328498 */     // GIR_Coverage, 20094,
     /*  328498 */     GIR_EraseRootFromParent_Done,
     /*  328499 */   // Label 6041: @328499
     /*  328499 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(328562), // Rule ID 20095 //
     /*  328504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  328507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  328515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  328518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  328521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  328536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328543 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11361:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  328543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1),
     /*  328546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  328560 */     GIR_RootConstrainSelectedInstOperands,
     /*  328561 */     // GIR_Coverage, 20095,
     /*  328561 */     GIR_EraseRootFromParent_Done,
     /*  328562 */   // Label 6042: @328562
     /*  328562 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(328625), // Rule ID 20098 //
     /*  328567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  328581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328606 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  328609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328623 */     GIR_RootConstrainSelectedInstOperands,
     /*  328624 */     // GIR_Coverage, 20098,
     /*  328624 */     GIR_EraseRootFromParent_Done,
     /*  328625 */   // Label 6043: @328625
     /*  328625 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(328688), // Rule ID 20099 //
     /*  328630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  328641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  328644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328669 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2),
     /*  328672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328686 */     GIR_RootConstrainSelectedInstOperands,
     /*  328687 */     // GIR_Coverage, 20099,
     /*  328687 */     GIR_EraseRootFromParent_Done,
     /*  328688 */   // Label 6044: @328688
     /*  328688 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(328751), // Rule ID 20102 //
     /*  328693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  328707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328732 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  328735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328749 */     GIR_RootConstrainSelectedInstOperands,
     /*  328750 */     // GIR_Coverage, 20102,
     /*  328750 */     GIR_EraseRootFromParent_Done,
     /*  328751 */   // Label 6045: @328751
     /*  328751 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(328814), // Rule ID 20103 //
     /*  328756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  328767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  328770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  328784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4),
     /*  328798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328812 */     GIR_RootConstrainSelectedInstOperands,
     /*  328813 */     // GIR_Coverage, 20103,
     /*  328813 */     GIR_EraseRootFromParent_Done,
     /*  328814 */   // Label 6046: @328814
     /*  328814 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(328877), // Rule ID 20106 //
     /*  328819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  328822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  328830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  328833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328858 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  328858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  328861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328875 */     GIR_RootConstrainSelectedInstOperands,
     /*  328876 */     // GIR_Coverage, 20106,
     /*  328876 */     GIR_EraseRootFromParent_Done,
     /*  328877 */   // Label 6047: @328877
     /*  328877 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(328940), // Rule ID 20107 //
     /*  328882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  328885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  328893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  328896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  328899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  328902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  328910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  328914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328921 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  328921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8),
     /*  328924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  328938 */     GIR_RootConstrainSelectedInstOperands,
     /*  328939 */     // GIR_Coverage, 20107,
     /*  328939 */     GIR_EraseRootFromParent_Done,
     /*  328940 */   // Label 6048: @328940
     /*  328940 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(329003), // Rule ID 20110 //
     /*  328945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  328948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  328953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  328956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  328959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  328962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  328965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  328969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  328973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  328977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  328984 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  328984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  328987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  328989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  328991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  328993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  328998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329001 */     GIR_RootConstrainSelectedInstOperands,
     /*  329002 */     // GIR_Coverage, 20110,
     /*  329002 */     GIR_EraseRootFromParent_Done,
     /*  329003 */   // Label 6049: @329003
     /*  329003 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(329066), // Rule ID 20111 //
     /*  329008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  329022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329047 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2),
     /*  329050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329064 */     GIR_RootConstrainSelectedInstOperands,
     /*  329065 */     // GIR_Coverage, 20111,
     /*  329065 */     GIR_EraseRootFromParent_Done,
     /*  329066 */   // Label 6050: @329066
     /*  329066 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(329129), // Rule ID 20114 //
     /*  329071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329110 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329127 */     GIR_RootConstrainSelectedInstOperands,
     /*  329128 */     // GIR_Coverage, 20114,
     /*  329128 */     GIR_EraseRootFromParent_Done,
     /*  329129 */   // Label 6051: @329129
     /*  329129 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(329192), // Rule ID 20115 //
     /*  329134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  329148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329173 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4),
     /*  329176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329190 */     GIR_RootConstrainSelectedInstOperands,
     /*  329191 */     // GIR_Coverage, 20115,
     /*  329191 */     GIR_EraseRootFromParent_Done,
     /*  329192 */   // Label 6052: @329192
     /*  329192 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(329255), // Rule ID 20118 //
     /*  329197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329253 */     GIR_RootConstrainSelectedInstOperands,
     /*  329254 */     // GIR_Coverage, 20118,
     /*  329254 */     GIR_EraseRootFromParent_Done,
     /*  329255 */   // Label 6053: @329255
     /*  329255 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(329318), // Rule ID 20119 //
     /*  329260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  329263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  329271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  329274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329299 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  329299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8),
     /*  329302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  329316 */     GIR_RootConstrainSelectedInstOperands,
     /*  329317 */     // GIR_Coverage, 20119,
     /*  329317 */     GIR_EraseRootFromParent_Done,
     /*  329318 */   // Label 6054: @329318
     /*  329318 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(329381), // Rule ID 20122 //
     /*  329323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329362 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329379 */     GIR_RootConstrainSelectedInstOperands,
     /*  329380 */     // GIR_Coverage, 20122,
     /*  329380 */     GIR_EraseRootFromParent_Done,
     /*  329381 */   // Label 6055: @329381
     /*  329381 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(329444), // Rule ID 20123 //
     /*  329386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  329400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  329414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329425 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11361:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2),
     /*  329428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329442 */     GIR_RootConstrainSelectedInstOperands,
     /*  329443 */     // GIR_Coverage, 20123,
     /*  329443 */     GIR_EraseRootFromParent_Done,
     /*  329444 */   // Label 6056: @329444
     /*  329444 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(329507), // Rule ID 20126 //
     /*  329449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  329463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  329491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329505 */     GIR_RootConstrainSelectedInstOperands,
     /*  329506 */     // GIR_Coverage, 20126,
     /*  329506 */     GIR_EraseRootFromParent_Done,
     /*  329507 */   // Label 6057: @329507
     /*  329507 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(329570), // Rule ID 20127 //
     /*  329512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  329523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  329526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  329540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329551 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11361:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4),
     /*  329554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329568 */     GIR_RootConstrainSelectedInstOperands,
     /*  329569 */     // GIR_Coverage, 20127,
     /*  329569 */     GIR_EraseRootFromParent_Done,
     /*  329570 */   // Label 6058: @329570
     /*  329570 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(329633), // Rule ID 20130 //
     /*  329575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  329578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  329589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329614 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  329614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  329617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329631 */     GIR_RootConstrainSelectedInstOperands,
     /*  329632 */     // GIR_Coverage, 20130,
     /*  329632 */     GIR_EraseRootFromParent_Done,
     /*  329633 */   // Label 6059: @329633
     /*  329633 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(329696), // Rule ID 20131 //
     /*  329638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  329641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne),
     /*  329646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  329649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  329652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  329655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  329666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  329670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329677 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11361:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  329677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8),
     /*  329680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  329694 */     GIR_RootConstrainSelectedInstOperands,
     /*  329695 */     // GIR_Coverage, 20131,
     /*  329695 */     GIR_EraseRootFromParent_Done,
     /*  329696 */   // Label 6060: @329696
     /*  329696 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(329759), // Rule ID 20134 //
     /*  329701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  329709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  329715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329740 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  329743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329757 */     GIR_RootConstrainSelectedInstOperands,
     /*  329758 */     // GIR_Coverage, 20134,
     /*  329758 */     GIR_EraseRootFromParent_Done,
     /*  329759 */   // Label 6061: @329759
     /*  329759 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(329822), // Rule ID 20135 //
     /*  329764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  329772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  329778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329803 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4),
     /*  329806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329820 */     GIR_RootConstrainSelectedInstOperands,
     /*  329821 */     // GIR_Coverage, 20135,
     /*  329821 */     GIR_EraseRootFromParent_Done,
     /*  329822 */   // Label 6062: @329822
     /*  329822 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(329885), // Rule ID 20138 //
     /*  329827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  329830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  329835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  329841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  329866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  329869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329883 */     GIR_RootConstrainSelectedInstOperands,
     /*  329884 */     // GIR_Coverage, 20138,
     /*  329884 */     GIR_EraseRootFromParent_Done,
     /*  329885 */   // Label 6063: @329885
     /*  329885 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(329948), // Rule ID 20139 //
     /*  329890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  329893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  329898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  329901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  329904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  329907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  329910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  329922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329929 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  329929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2),
     /*  329932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  329938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  329943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  329946 */     GIR_RootConstrainSelectedInstOperands,
     /*  329947 */     // GIR_Coverage, 20139,
     /*  329947 */     GIR_EraseRootFromParent_Done,
     /*  329948 */   // Label 6064: @329948
     /*  329948 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(330011), // Rule ID 20142 //
     /*  329953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  329956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  329961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  329964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  329967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  329970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  329973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  329981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  329985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  329992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  329992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  329995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  329997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  329999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330009 */     GIR_RootConstrainSelectedInstOperands,
     /*  330010 */     // GIR_Coverage, 20142,
     /*  330010 */     GIR_EraseRootFromParent_Done,
     /*  330011 */   // Label 6065: @330011
     /*  330011 */   GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(330074), // Rule ID 20143 //
     /*  330016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  330030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330055 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2),
     /*  330058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330072 */     GIR_RootConstrainSelectedInstOperands,
     /*  330073 */     // GIR_Coverage, 20143,
     /*  330073 */     GIR_EraseRootFromParent_Done,
     /*  330074 */   // Label 6066: @330074
     /*  330074 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(330137), // Rule ID 20146 //
     /*  330079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330118 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330135 */     GIR_RootConstrainSelectedInstOperands,
     /*  330136 */     // GIR_Coverage, 20146,
     /*  330136 */     GIR_EraseRootFromParent_Done,
     /*  330137 */   // Label 6067: @330137
     /*  330137 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(330200), // Rule ID 20147 //
     /*  330142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  330156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330181 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1),
     /*  330184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330198 */     GIR_RootConstrainSelectedInstOperands,
     /*  330199 */     // GIR_Coverage, 20147,
     /*  330199 */     GIR_EraseRootFromParent_Done,
     /*  330200 */   // Label 6068: @330200
     /*  330200 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(330263), // Rule ID 20150 //
     /*  330205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330261 */     GIR_RootConstrainSelectedInstOperands,
     /*  330262 */     // GIR_Coverage, 20150,
     /*  330262 */     GIR_EraseRootFromParent_Done,
     /*  330263 */   // Label 6069: @330263
     /*  330263 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(330326), // Rule ID 20151 //
     /*  330268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  330279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  330282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330307 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1),
     /*  330310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330324 */     GIR_RootConstrainSelectedInstOperands,
     /*  330325 */     // GIR_Coverage, 20151,
     /*  330325 */     GIR_EraseRootFromParent_Done,
     /*  330326 */   // Label 6070: @330326
     /*  330326 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(330389), // Rule ID 20154 //
     /*  330331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  330334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  330370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330387 */     GIR_RootConstrainSelectedInstOperands,
     /*  330388 */     // GIR_Coverage, 20154,
     /*  330388 */     GIR_EraseRootFromParent_Done,
     /*  330389 */   // Label 6071: @330389
     /*  330389 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(330452), // Rule ID 20155 //
     /*  330394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  330397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  330405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  330408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  330411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  330426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330433 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  330433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1),
     /*  330436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  330450 */     GIR_RootConstrainSelectedInstOperands,
     /*  330451 */     // GIR_Coverage, 20155,
     /*  330451 */     GIR_EraseRootFromParent_Done,
     /*  330452 */   // Label 6072: @330452
     /*  330452 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(330515), // Rule ID 20158 //
     /*  330457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  330471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  330499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330513 */     GIR_RootConstrainSelectedInstOperands,
     /*  330514 */     // GIR_Coverage, 20158,
     /*  330514 */     GIR_EraseRootFromParent_Done,
     /*  330515 */   // Label 6073: @330515
     /*  330515 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(330578), // Rule ID 20159 //
     /*  330520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  330534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330559 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2),
     /*  330562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330576 */     GIR_RootConstrainSelectedInstOperands,
     /*  330577 */     // GIR_Coverage, 20159,
     /*  330577 */     GIR_EraseRootFromParent_Done,
     /*  330578 */   // Label 6074: @330578
     /*  330578 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(330641), // Rule ID 20162 //
     /*  330583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  330597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330622 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  330625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330639 */     GIR_RootConstrainSelectedInstOperands,
     /*  330640 */     // GIR_Coverage, 20162,
     /*  330640 */     GIR_EraseRootFromParent_Done,
     /*  330641 */   // Label 6075: @330641
     /*  330641 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(330704), // Rule ID 20163 //
     /*  330646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  330657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  330660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330685 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4),
     /*  330688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330702 */     GIR_RootConstrainSelectedInstOperands,
     /*  330703 */     // GIR_Coverage, 20163,
     /*  330703 */     GIR_EraseRootFromParent_Done,
     /*  330704 */   // Label 6076: @330704
     /*  330704 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(330767), // Rule ID 20166 //
     /*  330709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  330712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  330720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  330723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330748 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  330748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  330751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330765 */     GIR_RootConstrainSelectedInstOperands,
     /*  330766 */     // GIR_Coverage, 20166,
     /*  330766 */     GIR_EraseRootFromParent_Done,
     /*  330767 */   // Label 6077: @330767
     /*  330767 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(330830), // Rule ID 20167 //
     /*  330772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  330775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  330783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  330786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  330789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  330800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  330804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330811 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  330811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8),
     /*  330814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  330828 */     GIR_RootConstrainSelectedInstOperands,
     /*  330829 */     // GIR_Coverage, 20167,
     /*  330829 */     GIR_EraseRootFromParent_Done,
     /*  330830 */   // Label 6078: @330830
     /*  330830 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(330893), // Rule ID 20170 //
     /*  330835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  330849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330874 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  330874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  330877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330891 */     GIR_RootConstrainSelectedInstOperands,
     /*  330892 */     // GIR_Coverage, 20170,
     /*  330892 */     GIR_EraseRootFromParent_Done,
     /*  330893 */   // Label 6079: @330893
     /*  330893 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(330956), // Rule ID 20171 //
     /*  330898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  330901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  330909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  330912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  330918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  330926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  330937 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  330937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2),
     /*  330940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  330942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  330944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  330946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  330951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  330954 */     GIR_RootConstrainSelectedInstOperands,
     /*  330955 */     // GIR_Coverage, 20171,
     /*  330955 */     GIR_EraseRootFromParent_Done,
     /*  330956 */   // Label 6080: @330956
     /*  330956 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(331019), // Rule ID 20174 //
     /*  330961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  330964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  330969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  330972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  330975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  330978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  330981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  330985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  330989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  330993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331017 */     GIR_RootConstrainSelectedInstOperands,
     /*  331018 */     // GIR_Coverage, 20174,
     /*  331018 */     GIR_EraseRootFromParent_Done,
     /*  331019 */   // Label 6081: @331019
     /*  331019 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(331082), // Rule ID 20175 //
     /*  331024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  331038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331063 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4),
     /*  331066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331080 */     GIR_RootConstrainSelectedInstOperands,
     /*  331081 */     // GIR_Coverage, 20175,
     /*  331081 */     GIR_EraseRootFromParent_Done,
     /*  331082 */   // Label 6082: @331082
     /*  331082 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(331145), // Rule ID 20178 //
     /*  331087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331126 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331143 */     GIR_RootConstrainSelectedInstOperands,
     /*  331144 */     // GIR_Coverage, 20178,
     /*  331144 */     GIR_EraseRootFromParent_Done,
     /*  331145 */   // Label 6083: @331145
     /*  331145 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(331208), // Rule ID 20179 //
     /*  331150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  331161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  331164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331189 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8),
     /*  331192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331206 */     GIR_RootConstrainSelectedInstOperands,
     /*  331207 */     // GIR_Coverage, 20179,
     /*  331207 */     GIR_EraseRootFromParent_Done,
     /*  331208 */   // Label 6084: @331208
     /*  331208 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(331271), // Rule ID 20182 //
     /*  331213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331269 */     GIR_RootConstrainSelectedInstOperands,
     /*  331270 */     // GIR_Coverage, 20182,
     /*  331270 */     GIR_EraseRootFromParent_Done,
     /*  331271 */   // Label 6085: @331271
     /*  331271 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(331334), // Rule ID 20183 //
     /*  331276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  331290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  331304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331315 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2),
     /*  331318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331332 */     GIR_RootConstrainSelectedInstOperands,
     /*  331333 */     // GIR_Coverage, 20183,
     /*  331333 */     GIR_EraseRootFromParent_Done,
     /*  331334 */   // Label 6086: @331334
     /*  331334 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(331397), // Rule ID 20186 //
     /*  331339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331378 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331395 */     GIR_RootConstrainSelectedInstOperands,
     /*  331396 */     // GIR_Coverage, 20186,
     /*  331396 */     GIR_EraseRootFromParent_Done,
     /*  331397 */   // Label 6087: @331397
     /*  331397 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(331460), // Rule ID 20187 //
     /*  331402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  331416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  331430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331441 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4),
     /*  331444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331458 */     GIR_RootConstrainSelectedInstOperands,
     /*  331459 */     // GIR_Coverage, 20187,
     /*  331459 */     GIR_EraseRootFromParent_Done,
     /*  331460 */   // Label 6088: @331460
     /*  331460 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(331523), // Rule ID 20190 //
     /*  331465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  331468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  331479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331504 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  331504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  331507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331521 */     GIR_RootConstrainSelectedInstOperands,
     /*  331522 */     // GIR_Coverage, 20190,
     /*  331522 */     GIR_EraseRootFromParent_Done,
     /*  331523 */   // Label 6089: @331523
     /*  331523 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(331586), // Rule ID 20191 //
     /*  331528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  331531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  331536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  331539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  331542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  331545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  331556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  331560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331567 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  331567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8),
     /*  331570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  331584 */     GIR_RootConstrainSelectedInstOperands,
     /*  331585 */     // GIR_Coverage, 20191,
     /*  331585 */     GIR_EraseRootFromParent_Done,
     /*  331586 */   // Label 6090: @331586
     /*  331586 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(331649), // Rule ID 20194 //
     /*  331591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  331605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331630 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  331633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331647 */     GIR_RootConstrainSelectedInstOperands,
     /*  331648 */     // GIR_Coverage, 20194,
     /*  331648 */     GIR_EraseRootFromParent_Done,
     /*  331649 */   // Label 6091: @331649
     /*  331649 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(331712), // Rule ID 20195 //
     /*  331654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  331668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331693 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4),
     /*  331696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331710 */     GIR_RootConstrainSelectedInstOperands,
     /*  331711 */     // GIR_Coverage, 20195,
     /*  331711 */     GIR_EraseRootFromParent_Done,
     /*  331712 */   // Label 6092: @331712
     /*  331712 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(331775), // Rule ID 20198 //
     /*  331717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  331731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  331756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  331759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331773 */     GIR_RootConstrainSelectedInstOperands,
     /*  331774 */     // GIR_Coverage, 20198,
     /*  331774 */     GIR_EraseRootFromParent_Done,
     /*  331775 */   // Label 6093: @331775
     /*  331775 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(331838), // Rule ID 20199 //
     /*  331780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  331783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  331791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  331794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  331812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331819 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  331819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2),
     /*  331822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  331836 */     GIR_RootConstrainSelectedInstOperands,
     /*  331837 */     // GIR_Coverage, 20199,
     /*  331837 */     GIR_EraseRootFromParent_Done,
     /*  331838 */   // Label 6094: @331838
     /*  331838 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(331901), // Rule ID 20202 //
     /*  331843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  331846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331882 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  331882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  331885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331899 */     GIR_RootConstrainSelectedInstOperands,
     /*  331900 */     // GIR_Coverage, 20202,
     /*  331900 */     GIR_EraseRootFromParent_Done,
     /*  331901 */   // Label 6095: @331901
     /*  331901 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(331964), // Rule ID 20203 //
     /*  331906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  331909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  331917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  331920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  331923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  331926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  331938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  331945 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  331945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2),
     /*  331948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  331950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  331952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  331954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  331959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  331962 */     GIR_RootConstrainSelectedInstOperands,
     /*  331963 */     // GIR_Coverage, 20203,
     /*  331963 */     GIR_EraseRootFromParent_Done,
     /*  331964 */   // Label 6096: @331964
     /*  331964 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(332027), // Rule ID 20206 //
     /*  331969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  331972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  331977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  331980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  331983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  331986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  331989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  331997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332008 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332025 */     GIR_RootConstrainSelectedInstOperands,
     /*  332026 */     // GIR_Coverage, 20206,
     /*  332026 */     GIR_EraseRootFromParent_Done,
     /*  332027 */   // Label 6097: @332027
     /*  332027 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(332090), // Rule ID 20207 //
     /*  332032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  332046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332071 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1),
     /*  332074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332088 */     GIR_RootConstrainSelectedInstOperands,
     /*  332089 */     // GIR_Coverage, 20207,
     /*  332089 */     GIR_EraseRootFromParent_Done,
     /*  332090 */   // Label 6098: @332090
     /*  332090 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(332153), // Rule ID 20210 //
     /*  332095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332134 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332151 */     GIR_RootConstrainSelectedInstOperands,
     /*  332152 */     // GIR_Coverage, 20210,
     /*  332152 */     GIR_EraseRootFromParent_Done,
     /*  332153 */   // Label 6099: @332153
     /*  332153 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(332216), // Rule ID 20211 //
     /*  332158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  332169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  332172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332197 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1),
     /*  332200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332214 */     GIR_RootConstrainSelectedInstOperands,
     /*  332215 */     // GIR_Coverage, 20211,
     /*  332215 */     GIR_EraseRootFromParent_Done,
     /*  332216 */   // Label 6100: @332216
     /*  332216 */   GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(332279), // Rule ID 20214 //
     /*  332221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  332224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  332260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332277 */     GIR_RootConstrainSelectedInstOperands,
     /*  332278 */     // GIR_Coverage, 20214,
     /*  332278 */     GIR_EraseRootFromParent_Done,
     /*  332279 */   // Label 6101: @332279
     /*  332279 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(332342), // Rule ID 20215 //
     /*  332284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  332287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  332295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  332298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  332301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  332316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332323 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  332323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1),
     /*  332326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  332340 */     GIR_RootConstrainSelectedInstOperands,
     /*  332341 */     // GIR_Coverage, 20215,
     /*  332341 */     GIR_EraseRootFromParent_Done,
     /*  332342 */   // Label 6102: @332342
     /*  332342 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(332405), // Rule ID 20218 //
     /*  332347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332386 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332403 */     GIR_RootConstrainSelectedInstOperands,
     /*  332404 */     // GIR_Coverage, 20218,
     /*  332404 */     GIR_EraseRootFromParent_Done,
     /*  332405 */   // Label 6103: @332405
     /*  332405 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(332468), // Rule ID 20219 //
     /*  332410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  332424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332449 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2),
     /*  332452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332466 */     GIR_RootConstrainSelectedInstOperands,
     /*  332467 */     // GIR_Coverage, 20219,
     /*  332467 */     GIR_EraseRootFromParent_Done,
     /*  332468 */   // Label 6104: @332468
     /*  332468 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(332531), // Rule ID 20222 //
     /*  332473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  332487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332512 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  332515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332529 */     GIR_RootConstrainSelectedInstOperands,
     /*  332530 */     // GIR_Coverage, 20222,
     /*  332530 */     GIR_EraseRootFromParent_Done,
     /*  332531 */   // Label 6105: @332531
     /*  332531 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(332594), // Rule ID 20223 //
     /*  332536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  332550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332575 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4),
     /*  332578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332592 */     GIR_RootConstrainSelectedInstOperands,
     /*  332593 */     // GIR_Coverage, 20223,
     /*  332593 */     GIR_EraseRootFromParent_Done,
     /*  332594 */   // Label 6106: @332594
     /*  332594 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(332657), // Rule ID 20226 //
     /*  332599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  332602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  332610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  332613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332638 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  332638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  332641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332655 */     GIR_RootConstrainSelectedInstOperands,
     /*  332656 */     // GIR_Coverage, 20226,
     /*  332656 */     GIR_EraseRootFromParent_Done,
     /*  332657 */   // Label 6107: @332657
     /*  332657 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(332720), // Rule ID 20227 //
     /*  332662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  332665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  332673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  332676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /*  332679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  332690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  332694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332701 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  332701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8),
     /*  332704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  332718 */     GIR_RootConstrainSelectedInstOperands,
     /*  332719 */     // GIR_Coverage, 20227,
     /*  332719 */     GIR_EraseRootFromParent_Done,
     /*  332720 */   // Label 6108: @332720
     /*  332720 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(332783), // Rule ID 20230 //
     /*  332725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  332739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332764 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  332767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332781 */     GIR_RootConstrainSelectedInstOperands,
     /*  332782 */     // GIR_Coverage, 20230,
     /*  332782 */     GIR_EraseRootFromParent_Done,
     /*  332783 */   // Label 6109: @332783
     /*  332783 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(332846), // Rule ID 20231 //
     /*  332788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  332799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  332802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  332816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332827 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2),
     /*  332830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332844 */     GIR_RootConstrainSelectedInstOperands,
     /*  332845 */     // GIR_Coverage, 20231,
     /*  332845 */     GIR_EraseRootFromParent_Done,
     /*  332846 */   // Label 6110: @332846
     /*  332846 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(332909), // Rule ID 20234 //
     /*  332851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  332865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  332890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  332893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332907 */     GIR_RootConstrainSelectedInstOperands,
     /*  332908 */     // GIR_Coverage, 20234,
     /*  332908 */     GIR_EraseRootFromParent_Done,
     /*  332909 */   // Label 6111: @332909
     /*  332909 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(332972), // Rule ID 20235 //
     /*  332914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  332917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  332925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  332928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  332934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  332938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  332942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  332946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  332953 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  332953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4),
     /*  332956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  332958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  332960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  332962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  332967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  332970 */     GIR_RootConstrainSelectedInstOperands,
     /*  332971 */     // GIR_Coverage, 20235,
     /*  332971 */     GIR_EraseRootFromParent_Done,
     /*  332972 */   // Label 6112: @332972
     /*  332972 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(333035), // Rule ID 20238 //
     /*  332977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  332980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  332985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  332988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  332991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  332994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  332997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333033 */     GIR_RootConstrainSelectedInstOperands,
     /*  333034 */     // GIR_Coverage, 20238,
     /*  333034 */     GIR_EraseRootFromParent_Done,
     /*  333035 */   // Label 6113: @333035
     /*  333035 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(333098), // Rule ID 20239 //
     /*  333040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  333051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  333054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  333057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  333072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333079 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8),
     /*  333082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333096 */     GIR_RootConstrainSelectedInstOperands,
     /*  333097 */     // GIR_Coverage, 20239,
     /*  333097 */     GIR_EraseRootFromParent_Done,
     /*  333098 */   // Label 6114: @333098
     /*  333098 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(333161), // Rule ID 20242 //
     /*  333103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333142 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333159 */     GIR_RootConstrainSelectedInstOperands,
     /*  333160 */     // GIR_Coverage, 20242,
     /*  333160 */     GIR_EraseRootFromParent_Done,
     /*  333161 */   // Label 6115: @333161
     /*  333161 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(333224), // Rule ID 20243 //
     /*  333166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  333180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  333194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333205 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2),
     /*  333208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333222 */     GIR_RootConstrainSelectedInstOperands,
     /*  333223 */     // GIR_Coverage, 20243,
     /*  333223 */     GIR_EraseRootFromParent_Done,
     /*  333224 */   // Label 6116: @333224
     /*  333224 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(333287), // Rule ID 20246 //
     /*  333229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333285 */     GIR_RootConstrainSelectedInstOperands,
     /*  333286 */     // GIR_Coverage, 20246,
     /*  333286 */     GIR_EraseRootFromParent_Done,
     /*  333287 */   // Label 6117: @333287
     /*  333287 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(333350), // Rule ID 20247 //
     /*  333292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  333306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  333320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333331 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4),
     /*  333334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333348 */     GIR_RootConstrainSelectedInstOperands,
     /*  333349 */     // GIR_Coverage, 20247,
     /*  333349 */     GIR_EraseRootFromParent_Done,
     /*  333350 */   // Label 6118: @333350
     /*  333350 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(333413), // Rule ID 20250 //
     /*  333355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  333358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333394 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  333394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333411 */     GIR_RootConstrainSelectedInstOperands,
     /*  333412 */     // GIR_Coverage, 20250,
     /*  333412 */     GIR_EraseRootFromParent_Done,
     /*  333413 */   // Label 6119: @333413
     /*  333413 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(333476), // Rule ID 20251 //
     /*  333418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  333421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  333426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  333429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  333432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  333435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  333446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  333450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333457 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  333457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8),
     /*  333460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  333464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  333466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  333474 */     GIR_RootConstrainSelectedInstOperands,
     /*  333475 */     // GIR_Coverage, 20251,
     /*  333475 */     GIR_EraseRootFromParent_Done,
     /*  333476 */   // Label 6120: @333476
     /*  333476 */   GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(333539), // Rule ID 20254 //
     /*  333481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  333495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  333498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333520 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  333523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333537 */     GIR_RootConstrainSelectedInstOperands,
     /*  333538 */     // GIR_Coverage, 20254,
     /*  333538 */     GIR_EraseRootFromParent_Done,
     /*  333539 */   // Label 6121: @333539
     /*  333539 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(333602), // Rule ID 20255 //
     /*  333544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  333558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  333561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333583 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /*  333586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333600 */     GIR_RootConstrainSelectedInstOperands,
     /*  333601 */     // GIR_Coverage, 20255,
     /*  333601 */     GIR_EraseRootFromParent_Done,
     /*  333602 */   // Label 6122: @333602
     /*  333602 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(333665), // Rule ID 20258 //
     /*  333607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  333621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  333624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333646 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  333649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333663 */     GIR_RootConstrainSelectedInstOperands,
     /*  333664 */     // GIR_Coverage, 20258,
     /*  333664 */     GIR_EraseRootFromParent_Done,
     /*  333665 */   // Label 6123: @333665
     /*  333665 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(333728), // Rule ID 20259 //
     /*  333670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  333684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  333687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333709 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  333712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333726 */     GIR_RootConstrainSelectedInstOperands,
     /*  333727 */     // GIR_Coverage, 20259,
     /*  333727 */     GIR_EraseRootFromParent_Done,
     /*  333728 */   // Label 6124: @333728
     /*  333728 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(333791), // Rule ID 20262 //
     /*  333733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  333747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  333750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  333772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  333775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333789 */     GIR_RootConstrainSelectedInstOperands,
     /*  333790 */     // GIR_Coverage, 20262,
     /*  333790 */     GIR_EraseRootFromParent_Done,
     /*  333791 */   // Label 6125: @333791
     /*  333791 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(333854), // Rule ID 20263 //
     /*  333796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  333799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  333807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  333810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  333813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333835 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  333835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /*  333838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  333852 */     GIR_RootConstrainSelectedInstOperands,
     /*  333853 */     // GIR_Coverage, 20263,
     /*  333853 */     GIR_EraseRootFromParent_Done,
     /*  333854 */   // Label 6126: @333854
     /*  333854 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(333917), // Rule ID 20266 //
     /*  333859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  333862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  333876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  333879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333898 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  333898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  333901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333915 */     GIR_RootConstrainSelectedInstOperands,
     /*  333916 */     // GIR_Coverage, 20266,
     /*  333916 */     GIR_EraseRootFromParent_Done,
     /*  333917 */   // Label 6127: @333917
     /*  333917 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(333980), // Rule ID 20267 //
     /*  333922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  333925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  333933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  333936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  333939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  333942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  333954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  333961 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  333961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  333964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  333966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  333968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  333970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  333975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  333978 */     GIR_RootConstrainSelectedInstOperands,
     /*  333979 */     // GIR_Coverage, 20267,
     /*  333979 */     GIR_EraseRootFromParent_Done,
     /*  333980 */   // Label 6128: @333980
     /*  333980 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(334043), // Rule ID 20270 //
     /*  333985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  333988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  333993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  333996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  333999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334041 */     GIR_RootConstrainSelectedInstOperands,
     /*  334042 */     // GIR_Coverage, 20270,
     /*  334042 */     GIR_EraseRootFromParent_Done,
     /*  334043 */   // Label 6129: @334043
     /*  334043 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(334106), // Rule ID 20271 //
     /*  334048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  334059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  334062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  334065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334087 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334104 */     GIR_RootConstrainSelectedInstOperands,
     /*  334105 */     // GIR_Coverage, 20271,
     /*  334105 */     GIR_EraseRootFromParent_Done,
     /*  334106 */   // Label 6130: @334106
     /*  334106 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(334169), // Rule ID 20274 //
     /*  334111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334150 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  334150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334167 */     GIR_RootConstrainSelectedInstOperands,
     /*  334168 */     // GIR_Coverage, 20274,
     /*  334168 */     GIR_EraseRootFromParent_Done,
     /*  334169 */   // Label 6131: @334169
     /*  334169 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(334232), // Rule ID 20275 //
     /*  334174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  334177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  334185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  334188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  334191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334213 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11355:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  334213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /*  334216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  334230 */     GIR_RootConstrainSelectedInstOperands,
     /*  334231 */     // GIR_Coverage, 20275,
     /*  334231 */     GIR_EraseRootFromParent_Done,
     /*  334232 */   // Label 6132: @334232
     /*  334232 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(334295), // Rule ID 20278 //
     /*  334237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334293 */     GIR_RootConstrainSelectedInstOperands,
     /*  334294 */     // GIR_Coverage, 20278,
     /*  334294 */     GIR_EraseRootFromParent_Done,
     /*  334295 */   // Label 6133: @334295
     /*  334295 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(334358), // Rule ID 20279 //
     /*  334300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  334314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  334317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334339 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334356 */     GIR_RootConstrainSelectedInstOperands,
     /*  334357 */     // GIR_Coverage, 20279,
     /*  334357 */     GIR_EraseRootFromParent_Done,
     /*  334358 */   // Label 6134: @334358
     /*  334358 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(334421), // Rule ID 20282 //
     /*  334363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334402 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334419 */     GIR_RootConstrainSelectedInstOperands,
     /*  334420 */     // GIR_Coverage, 20282,
     /*  334420 */     GIR_EraseRootFromParent_Done,
     /*  334421 */   // Label 6135: @334421
     /*  334421 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(334484), // Rule ID 20283 //
     /*  334426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  334440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  334443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334465 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334482 */     GIR_RootConstrainSelectedInstOperands,
     /*  334483 */     // GIR_Coverage, 20283,
     /*  334483 */     GIR_EraseRootFromParent_Done,
     /*  334484 */   // Label 6136: @334484
     /*  334484 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(334547), // Rule ID 20286 //
     /*  334489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  334492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  334500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  334503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  334506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334528 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  334528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  334531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334545 */     GIR_RootConstrainSelectedInstOperands,
     /*  334546 */     // GIR_Coverage, 20286,
     /*  334546 */     GIR_EraseRootFromParent_Done,
     /*  334547 */   // Label 6137: @334547
     /*  334547 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(334610), // Rule ID 20287 //
     /*  334552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  334555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  334563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  334566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  334569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334591 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  334591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  334594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  334608 */     GIR_RootConstrainSelectedInstOperands,
     /*  334609 */     // GIR_Coverage, 20287,
     /*  334609 */     GIR_EraseRootFromParent_Done,
     /*  334610 */   // Label 6138: @334610
     /*  334610 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(334673), // Rule ID 20290 //
     /*  334615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  334629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  334632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334654 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334671 */     GIR_RootConstrainSelectedInstOperands,
     /*  334672 */     // GIR_Coverage, 20290,
     /*  334672 */     GIR_EraseRootFromParent_Done,
     /*  334673 */   // Label 6139: @334673
     /*  334673 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(334736), // Rule ID 20291 //
     /*  334678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  334689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  334692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  334695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  334710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334717 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  334720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334734 */     GIR_RootConstrainSelectedInstOperands,
     /*  334735 */     // GIR_Coverage, 20291,
     /*  334735 */     GIR_EraseRootFromParent_Done,
     /*  334736 */   // Label 6140: @334736
     /*  334736 */   GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(334799), // Rule ID 20294 //
     /*  334741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  334755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  334758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334780 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334797 */     GIR_RootConstrainSelectedInstOperands,
     /*  334798 */     // GIR_Coverage, 20294,
     /*  334798 */     GIR_EraseRootFromParent_Done,
     /*  334799 */   // Label 6141: @334799
     /*  334799 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(334862), // Rule ID 20295 //
     /*  334804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  334815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  334818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  334821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  334836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334843 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  334846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334860 */     GIR_RootConstrainSelectedInstOperands,
     /*  334861 */     // GIR_Coverage, 20295,
     /*  334861 */     GIR_EraseRootFromParent_Done,
     /*  334862 */   // Label 6142: @334862
     /*  334862 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(334925), // Rule ID 20298 //
     /*  334867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  334870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  334881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  334884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  334887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334906 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  334906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  334909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334923 */     GIR_RootConstrainSelectedInstOperands,
     /*  334924 */     // GIR_Coverage, 20298,
     /*  334924 */     GIR_EraseRootFromParent_Done,
     /*  334925 */   // Label 6143: @334925
     /*  334925 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(334988), // Rule ID 20299 //
     /*  334930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  334933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  334938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  334941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  334944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  334947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  334950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  334954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  334962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  334969 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  334969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  334972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  334974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  334976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  334978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  334983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  334986 */     GIR_RootConstrainSelectedInstOperands,
     /*  334987 */     // GIR_Coverage, 20299,
     /*  334987 */     GIR_EraseRootFromParent_Done,
     /*  334988 */   // Label 6144: @334988
     /*  334988 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(335051), // Rule ID 20302 //
     /*  334993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  334996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335049 */     GIR_RootConstrainSelectedInstOperands,
     /*  335050 */     // GIR_Coverage, 20302,
     /*  335050 */     GIR_EraseRootFromParent_Done,
     /*  335051 */   // Label 6145: @335051
     /*  335051 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(335114), // Rule ID 20303 //
     /*  335056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  335070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  335073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  335088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335095 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11355:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /*  335098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335112 */     GIR_RootConstrainSelectedInstOperands,
     /*  335113 */     // GIR_Coverage, 20303,
     /*  335113 */     GIR_EraseRootFromParent_Done,
     /*  335114 */   // Label 6146: @335114
     /*  335114 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(335177), // Rule ID 20306 //
     /*  335119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335158 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335175 */     GIR_RootConstrainSelectedInstOperands,
     /*  335176 */     // GIR_Coverage, 20306,
     /*  335176 */     GIR_EraseRootFromParent_Done,
     /*  335177 */   // Label 6147: @335177
     /*  335177 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(335240), // Rule ID 20307 //
     /*  335182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  335196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  335199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  335214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335221 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11355:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /*  335224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335238 */     GIR_RootConstrainSelectedInstOperands,
     /*  335239 */     // GIR_Coverage, 20307,
     /*  335239 */     GIR_EraseRootFromParent_Done,
     /*  335240 */   // Label 6148: @335240
     /*  335240 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(335303), // Rule ID 20310 //
     /*  335245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  335248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  335284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335301 */     GIR_RootConstrainSelectedInstOperands,
     /*  335302 */     // GIR_Coverage, 20310,
     /*  335302 */     GIR_EraseRootFromParent_Done,
     /*  335303 */   // Label 6149: @335303
     /*  335303 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(335366), // Rule ID 20311 //
     /*  335308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  335311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt),
     /*  335316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  335319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  335322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  335325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  335340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335347 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11355:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  335347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /*  335350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  335364 */     GIR_RootConstrainSelectedInstOperands,
     /*  335365 */     // GIR_Coverage, 20311,
     /*  335365 */     GIR_EraseRootFromParent_Done,
     /*  335366 */   // Label 6150: @335366
     /*  335366 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(335429), // Rule ID 20314 //
     /*  335371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335410 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335427 */     GIR_RootConstrainSelectedInstOperands,
     /*  335428 */     // GIR_Coverage, 20314,
     /*  335428 */     GIR_EraseRootFromParent_Done,
     /*  335429 */   // Label 6151: @335429
     /*  335429 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(335492), // Rule ID 20315 //
     /*  335434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  335448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  335451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335473 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /*  335476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335490 */     GIR_RootConstrainSelectedInstOperands,
     /*  335491 */     // GIR_Coverage, 20315,
     /*  335491 */     GIR_EraseRootFromParent_Done,
     /*  335492 */   // Label 6152: @335492
     /*  335492 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(335555), // Rule ID 20318 //
     /*  335497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  335511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  335514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335536 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  335539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335553 */     GIR_RootConstrainSelectedInstOperands,
     /*  335554 */     // GIR_Coverage, 20318,
     /*  335554 */     GIR_EraseRootFromParent_Done,
     /*  335555 */   // Label 6153: @335555
     /*  335555 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(335618), // Rule ID 20319 //
     /*  335560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  335574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  335577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335599 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  335602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335616 */     GIR_RootConstrainSelectedInstOperands,
     /*  335617 */     // GIR_Coverage, 20319,
     /*  335617 */     GIR_EraseRootFromParent_Done,
     /*  335618 */   // Label 6154: @335618
     /*  335618 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(335681), // Rule ID 20322 //
     /*  335623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  335637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  335640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335662 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  335665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335679 */     GIR_RootConstrainSelectedInstOperands,
     /*  335680 */     // GIR_Coverage, 20322,
     /*  335680 */     GIR_EraseRootFromParent_Done,
     /*  335681 */   // Label 6155: @335681
     /*  335681 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(335744), // Rule ID 20323 //
     /*  335686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  335697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  335700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  335703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335725 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /*  335728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335742 */     GIR_RootConstrainSelectedInstOperands,
     /*  335743 */     // GIR_Coverage, 20323,
     /*  335743 */     GIR_EraseRootFromParent_Done,
     /*  335744 */   // Label 6156: @335744
     /*  335744 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(335807), // Rule ID 20326 //
     /*  335749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  335752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  335763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  335766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  335788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  335791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335805 */     GIR_RootConstrainSelectedInstOperands,
     /*  335806 */     // GIR_Coverage, 20326,
     /*  335806 */     GIR_EraseRootFromParent_Done,
     /*  335807 */   // Label 6157: @335807
     /*  335807 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(335870), // Rule ID 20327 //
     /*  335812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  335815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  335823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  335826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  335829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  335851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  335854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  335868 */     GIR_RootConstrainSelectedInstOperands,
     /*  335869 */     // GIR_Coverage, 20327,
     /*  335869 */     GIR_EraseRootFromParent_Done,
     /*  335870 */   // Label 6158: @335870
     /*  335870 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(335933), // Rule ID 20330 //
     /*  335875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  335878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  335889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  335892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  335895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335914 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  335914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  335917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335931 */     GIR_RootConstrainSelectedInstOperands,
     /*  335932 */     // GIR_Coverage, 20330,
     /*  335932 */     GIR_EraseRootFromParent_Done,
     /*  335933 */   // Label 6159: @335933
     /*  335933 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(335996), // Rule ID 20331 //
     /*  335938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  335941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  335946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  335949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  335952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  335955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  335958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  335970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  335977 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  335977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  335980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  335982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  335984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  335986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  335991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  335994 */     GIR_RootConstrainSelectedInstOperands,
     /*  335995 */     // GIR_Coverage, 20331,
     /*  335995 */     GIR_EraseRootFromParent_Done,
     /*  335996 */   // Label 6160: @335996
     /*  335996 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(336059), // Rule ID 20334 //
     /*  336001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336057 */     GIR_RootConstrainSelectedInstOperands,
     /*  336058 */     // GIR_Coverage, 20334,
     /*  336058 */     GIR_EraseRootFromParent_Done,
     /*  336059 */   // Label 6161: @336059
     /*  336059 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(336122), // Rule ID 20335 //
     /*  336064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  336075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  336078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  336081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336103 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11353:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /*  336106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336120 */     GIR_RootConstrainSelectedInstOperands,
     /*  336121 */     // GIR_Coverage, 20335,
     /*  336121 */     GIR_EraseRootFromParent_Done,
     /*  336122 */   // Label 6162: @336122
     /*  336122 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(336185), // Rule ID 20338 //
     /*  336127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336166 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336183 */     GIR_RootConstrainSelectedInstOperands,
     /*  336184 */     // GIR_Coverage, 20338,
     /*  336184 */     GIR_EraseRootFromParent_Done,
     /*  336185 */   // Label 6163: @336185
     /*  336185 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(336248), // Rule ID 20339 //
     /*  336190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  336204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  336207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336229 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336246 */     GIR_RootConstrainSelectedInstOperands,
     /*  336247 */     // GIR_Coverage, 20339,
     /*  336247 */     GIR_EraseRootFromParent_Done,
     /*  336248 */   // Label 6164: @336248
     /*  336248 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(336311), // Rule ID 20342 //
     /*  336253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336292 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336309 */     GIR_RootConstrainSelectedInstOperands,
     /*  336310 */     // GIR_Coverage, 20342,
     /*  336310 */     GIR_EraseRootFromParent_Done,
     /*  336311 */   // Label 6165: @336311
     /*  336311 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(336374), // Rule ID 20343 //
     /*  336316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  336330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  336333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336355 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336372 */     GIR_RootConstrainSelectedInstOperands,
     /*  336373 */     // GIR_Coverage, 20343,
     /*  336373 */     GIR_EraseRootFromParent_Done,
     /*  336374 */   // Label 6166: @336374
     /*  336374 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(336437), // Rule ID 20346 //
     /*  336379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  336382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336418 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  336418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336435 */     GIR_RootConstrainSelectedInstOperands,
     /*  336436 */     // GIR_Coverage, 20346,
     /*  336436 */     GIR_EraseRootFromParent_Done,
     /*  336437 */   // Label 6167: @336437
     /*  336437 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(336500), // Rule ID 20347 //
     /*  336442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  336445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  336453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  336456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  336459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336481 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  336481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  336498 */     GIR_RootConstrainSelectedInstOperands,
     /*  336499 */     // GIR_Coverage, 20347,
     /*  336499 */     GIR_EraseRootFromParent_Done,
     /*  336500 */   // Label 6168: @336500
     /*  336500 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(336563), // Rule ID 20350 //
     /*  336505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  336519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  336522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336561 */     GIR_RootConstrainSelectedInstOperands,
     /*  336562 */     // GIR_Coverage, 20350,
     /*  336562 */     GIR_EraseRootFromParent_Done,
     /*  336563 */   // Label 6169: @336563
     /*  336563 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(336626), // Rule ID 20351 //
     /*  336568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  336579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  336582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  336585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336607 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336624 */     GIR_RootConstrainSelectedInstOperands,
     /*  336625 */     // GIR_Coverage, 20351,
     /*  336625 */     GIR_EraseRootFromParent_Done,
     /*  336626 */   // Label 6170: @336626
     /*  336626 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(336689), // Rule ID 20354 //
     /*  336631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  336645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  336648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336670 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336687 */     GIR_RootConstrainSelectedInstOperands,
     /*  336688 */     // GIR_Coverage, 20354,
     /*  336688 */     GIR_EraseRootFromParent_Done,
     /*  336689 */   // Label 6171: @336689
     /*  336689 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(336752), // Rule ID 20355 //
     /*  336694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  336705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  336708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  336711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  336726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336733 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  336736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336750 */     GIR_RootConstrainSelectedInstOperands,
     /*  336751 */     // GIR_Coverage, 20355,
     /*  336751 */     GIR_EraseRootFromParent_Done,
     /*  336752 */   // Label 6172: @336752
     /*  336752 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(336815), // Rule ID 20358 //
     /*  336757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  336760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  336771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  336774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336796 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  336796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336813 */     GIR_RootConstrainSelectedInstOperands,
     /*  336814 */     // GIR_Coverage, 20358,
     /*  336814 */     GIR_EraseRootFromParent_Done,
     /*  336815 */   // Label 6173: @336815
     /*  336815 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(336878), // Rule ID 20359 //
     /*  336820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  336823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  336831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  336834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  336837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  336852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336859 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  336859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  336862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  336876 */     GIR_RootConstrainSelectedInstOperands,
     /*  336877 */     // GIR_Coverage, 20359,
     /*  336877 */     GIR_EraseRootFromParent_Done,
     /*  336878 */   // Label 6174: @336878
     /*  336878 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(336941), // Rule ID 20362 //
     /*  336883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  336886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  336897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  336900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  336903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336922 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  336922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  336939 */     GIR_RootConstrainSelectedInstOperands,
     /*  336940 */     // GIR_Coverage, 20362,
     /*  336940 */     GIR_EraseRootFromParent_Done,
     /*  336941 */   // Label 6175: @336941
     /*  336941 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(337004), // Rule ID 20363 //
     /*  336946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  336949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  336954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  336957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  336960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  336963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  336966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  336970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  336978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  336985 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11353:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  336985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /*  336988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  336990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  336992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  336994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  336999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337002 */     GIR_RootConstrainSelectedInstOperands,
     /*  337003 */     // GIR_Coverage, 20363,
     /*  337003 */     GIR_EraseRootFromParent_Done,
     /*  337004 */   // Label 6176: @337004
     /*  337004 */   GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(337067), // Rule ID 20366 //
     /*  337009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337048 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337065 */     GIR_RootConstrainSelectedInstOperands,
     /*  337066 */     // GIR_Coverage, 20366,
     /*  337066 */     GIR_EraseRootFromParent_Done,
     /*  337067 */   // Label 6177: @337067
     /*  337067 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(337130), // Rule ID 20367 //
     /*  337072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  337083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  337086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  337089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  337104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337111 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11353:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /*  337114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337128 */     GIR_RootConstrainSelectedInstOperands,
     /*  337129 */     // GIR_Coverage, 20367,
     /*  337129 */     GIR_EraseRootFromParent_Done,
     /*  337130 */   // Label 6178: @337130
     /*  337130 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(337193), // Rule ID 20370 //
     /*  337135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  337138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337174 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  337174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337191 */     GIR_RootConstrainSelectedInstOperands,
     /*  337192 */     // GIR_Coverage, 20370,
     /*  337192 */     GIR_EraseRootFromParent_Done,
     /*  337193 */   // Label 6179: @337193
     /*  337193 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(337256), // Rule ID 20371 //
     /*  337198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  337201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge),
     /*  337206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  337209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  337212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  337215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  337230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337237 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11353:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  337237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /*  337240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  337244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /*  337246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337254 */     GIR_RootConstrainSelectedInstOperands,
     /*  337255 */     // GIR_Coverage, 20371,
     /*  337255 */     GIR_EraseRootFromParent_Done,
     /*  337256 */   // Label 6180: @337256
     /*  337256 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(337322), // Rule ID 20374 //
     /*  337261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  337264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337320 */     GIR_RootConstrainSelectedInstOperands,
     /*  337321 */     // GIR_Coverage, 20374,
     /*  337321 */     GIR_EraseRootFromParent_Done,
     /*  337322 */   // Label 6181: @337322
     /*  337322 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(337388), // Rule ID 20375 //
     /*  337327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  337330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  337338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  337341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  337344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337366 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  337366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337386 */     GIR_RootConstrainSelectedInstOperands,
     /*  337387 */     // GIR_Coverage, 20375,
     /*  337387 */     GIR_EraseRootFromParent_Done,
     /*  337388 */   // Label 6182: @337388
     /*  337388 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(337454), // Rule ID 20378 //
     /*  337393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  337396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337432 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  337432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337452 */     GIR_RootConstrainSelectedInstOperands,
     /*  337453 */     // GIR_Coverage, 20378,
     /*  337453 */     GIR_EraseRootFromParent_Done,
     /*  337454 */   // Label 6183: @337454
     /*  337454 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(337520), // Rule ID 20379 //
     /*  337459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  337462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  337470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  337473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  337476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  337498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2),
     /*  337501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337518 */     GIR_RootConstrainSelectedInstOperands,
     /*  337519 */     // GIR_Coverage, 20379,
     /*  337519 */     GIR_EraseRootFromParent_Done,
     /*  337520 */   // Label 6184: @337520
     /*  337520 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(337586), // Rule ID 20382 //
     /*  337525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  337528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  337536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  337539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  337542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337584 */     GIR_RootConstrainSelectedInstOperands,
     /*  337585 */     // GIR_Coverage, 20382,
     /*  337585 */     GIR_EraseRootFromParent_Done,
     /*  337586 */   // Label 6185: @337586
     /*  337586 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(337652), // Rule ID 20383 //
     /*  337591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  337594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  337602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  337605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  337608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11118:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  337630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337650 */     GIR_RootConstrainSelectedInstOperands,
     /*  337651 */     // GIR_Coverage, 20383,
     /*  337651 */     GIR_EraseRootFromParent_Done,
     /*  337652 */   // Label 6186: @337652
     /*  337652 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(337718), // Rule ID 20386 //
     /*  337657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  337660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  337668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  337671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  337674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  337696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337716 */     GIR_RootConstrainSelectedInstOperands,
     /*  337717 */     // GIR_Coverage, 20386,
     /*  337717 */     GIR_EraseRootFromParent_Done,
     /*  337718 */   // Label 6187: @337718
     /*  337718 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(337784), // Rule ID 20387 //
     /*  337723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  337726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  337734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  337737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  337740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11118:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  337762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  337779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337782 */     GIR_RootConstrainSelectedInstOperands,
     /*  337783 */     // GIR_Coverage, 20387,
     /*  337783 */     GIR_EraseRootFromParent_Done,
     /*  337784 */   // Label 6188: @337784
     /*  337784 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(337850), // Rule ID 20390 //
     /*  337789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  337792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  337800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  337828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337848 */     GIR_RootConstrainSelectedInstOperands,
     /*  337849 */     // GIR_Coverage, 20390,
     /*  337849 */     GIR_EraseRootFromParent_Done,
     /*  337850 */   // Label 6189: @337850
     /*  337850 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(337916), // Rule ID 20391 //
     /*  337855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  337858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  337866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  337869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  337872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  337875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  337887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11118:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  337894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1),
     /*  337897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  337911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337914 */     GIR_RootConstrainSelectedInstOperands,
     /*  337915 */     // GIR_Coverage, 20391,
     /*  337915 */     GIR_EraseRootFromParent_Done,
     /*  337916 */   // Label 6190: @337916
     /*  337916 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(337982), // Rule ID 20394 //
     /*  337921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  337924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  337932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  337935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  337938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  337941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  337953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  337960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  337960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  337963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  337965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  337967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  337969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  337974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  337977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  337980 */     GIR_RootConstrainSelectedInstOperands,
     /*  337981 */     // GIR_Coverage, 20394,
     /*  337981 */     GIR_EraseRootFromParent_Done,
     /*  337982 */   // Label 6191: @337982
     /*  337982 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(338048), // Rule ID 20395 //
     /*  337987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  337990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  337995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  337998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  338001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  338004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338046 */     GIR_RootConstrainSelectedInstOperands,
     /*  338047 */     // GIR_Coverage, 20395,
     /*  338047 */     GIR_EraseRootFromParent_Done,
     /*  338048 */   // Label 6192: @338048
     /*  338048 */   GIM_Try, /*On fail goto*//*Label 6193*/ GIMT_Encode4(338114), // Rule ID 20398 //
     /*  338053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338092 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338112 */     GIR_RootConstrainSelectedInstOperands,
     /*  338113 */     // GIR_Coverage, 20398,
     /*  338113 */     GIR_EraseRootFromParent_Done,
     /*  338114 */   // Label 6193: @338114
     /*  338114 */   GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(338180), // Rule ID 20399 //
     /*  338119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  338130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  338133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  338136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338158 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338178 */     GIR_RootConstrainSelectedInstOperands,
     /*  338179 */     // GIR_Coverage, 20399,
     /*  338179 */     GIR_EraseRootFromParent_Done,
     /*  338180 */   // Label 6194: @338180
     /*  338180 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(338246), // Rule ID 20402 //
     /*  338185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  338188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338224 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  338224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338244 */     GIR_RootConstrainSelectedInstOperands,
     /*  338245 */     // GIR_Coverage, 20402,
     /*  338245 */     GIR_EraseRootFromParent_Done,
     /*  338246 */   // Label 6195: @338246
     /*  338246 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(338312), // Rule ID 20403 //
     /*  338251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  338254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  338262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  338265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  338268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338290 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  338290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  338307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338310 */     GIR_RootConstrainSelectedInstOperands,
     /*  338311 */     // GIR_Coverage, 20403,
     /*  338311 */     GIR_EraseRootFromParent_Done,
     /*  338312 */   // Label 6196: @338312
     /*  338312 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(338378), // Rule ID 20406 //
     /*  338317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338376 */     GIR_RootConstrainSelectedInstOperands,
     /*  338377 */     // GIR_Coverage, 20406,
     /*  338377 */     GIR_EraseRootFromParent_Done,
     /*  338378 */   // Label 6197: @338378
     /*  338378 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(338444), // Rule ID 20407 //
     /*  338383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  338394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  338397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  338400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338442 */     GIR_RootConstrainSelectedInstOperands,
     /*  338443 */     // GIR_Coverage, 20407,
     /*  338443 */     GIR_EraseRootFromParent_Done,
     /*  338444 */   // Label 6198: @338444
     /*  338444 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(338510), // Rule ID 20410 //
     /*  338449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338488 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338508 */     GIR_RootConstrainSelectedInstOperands,
     /*  338509 */     // GIR_Coverage, 20410,
     /*  338509 */     GIR_EraseRootFromParent_Done,
     /*  338510 */   // Label 6199: @338510
     /*  338510 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(338576), // Rule ID 20411 //
     /*  338515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  338526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  338529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  338532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338554 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338574 */     GIR_RootConstrainSelectedInstOperands,
     /*  338575 */     // GIR_Coverage, 20411,
     /*  338575 */     GIR_EraseRootFromParent_Done,
     /*  338576 */   // Label 6200: @338576
     /*  338576 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(338642), // Rule ID 20414 //
     /*  338581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  338584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  338592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  338595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  338598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  338620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338640 */     GIR_RootConstrainSelectedInstOperands,
     /*  338641 */     // GIR_Coverage, 20414,
     /*  338641 */     GIR_EraseRootFromParent_Done,
     /*  338642 */   // Label 6201: @338642
     /*  338642 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(338708), // Rule ID 20415 //
     /*  338647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  338650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  338658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  338661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  338664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  338679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  338686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  338689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  338703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338706 */     GIR_RootConstrainSelectedInstOperands,
     /*  338707 */     // GIR_Coverage, 20415,
     /*  338707 */     GIR_EraseRootFromParent_Done,
     /*  338708 */   // Label 6202: @338708
     /*  338708 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(338774), // Rule ID 20418 //
     /*  338713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  338724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  338727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  338730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338772 */     GIR_RootConstrainSelectedInstOperands,
     /*  338773 */     // GIR_Coverage, 20418,
     /*  338773 */     GIR_EraseRootFromParent_Done,
     /*  338774 */   // Label 6203: @338774
     /*  338774 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(338840), // Rule ID 20419 //
     /*  338779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  338790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  338793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  338796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  338811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11118:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2),
     /*  338821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338838 */     GIR_RootConstrainSelectedInstOperands,
     /*  338839 */     // GIR_Coverage, 20419,
     /*  338839 */     GIR_EraseRootFromParent_Done,
     /*  338840 */   // Label 6204: @338840
     /*  338840 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(338906), // Rule ID 20422 //
     /*  338845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  338856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  338859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  338884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338904 */     GIR_RootConstrainSelectedInstOperands,
     /*  338905 */     // GIR_Coverage, 20422,
     /*  338905 */     GIR_EraseRootFromParent_Done,
     /*  338906 */   // Label 6205: @338906
     /*  338906 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(338972), // Rule ID 20423 //
     /*  338911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  338914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  338922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  338925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  338928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  338931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  338943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  338950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11118:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  338950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4),
     /*  338953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  338955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  338957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  338959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  338964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  338967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  338970 */     GIR_RootConstrainSelectedInstOperands,
     /*  338971 */     // GIR_Coverage, 20423,
     /*  338971 */     GIR_EraseRootFromParent_Done,
     /*  338972 */   // Label 6206: @338972
     /*  338972 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(339038), // Rule ID 20426 //
     /*  338977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  338980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  338985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  338988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  338991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  338994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  338997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339036 */     GIR_RootConstrainSelectedInstOperands,
     /*  339037 */     // GIR_Coverage, 20426,
     /*  339037 */     GIR_EraseRootFromParent_Done,
     /*  339038 */   // Label 6207: @339038
     /*  339038 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(339104), // Rule ID 20427 //
     /*  339043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass),
     /*  339051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  339054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  339057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  339060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  339075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339082 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11118:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCLASS_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8),
     /*  339085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339102 */     GIR_RootConstrainSelectedInstOperands,
     /*  339103 */     // GIR_Coverage, 20427,
     /*  339103 */     GIR_EraseRootFromParent_Done,
     /*  339104 */   // Label 6208: @339104
     /*  339104 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(339170), // Rule ID 20752 //
     /*  339109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339168 */     GIR_RootConstrainSelectedInstOperands,
     /*  339169 */     // GIR_Coverage, 20752,
     /*  339169 */     GIR_EraseRootFromParent_Done,
     /*  339170 */   // Label 6209: @339170
     /*  339170 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(339236), // Rule ID 20753 //
     /*  339175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  339186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  339189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  339192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  339217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339234 */     GIR_RootConstrainSelectedInstOperands,
     /*  339235 */     // GIR_Coverage, 20753,
     /*  339235 */     GIR_EraseRootFromParent_Done,
     /*  339236 */   // Label 6210: @339236
     /*  339236 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(339302), // Rule ID 20756 //
     /*  339241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339300 */     GIR_RootConstrainSelectedInstOperands,
     /*  339301 */     // GIR_Coverage, 20756,
     /*  339301 */     GIR_EraseRootFromParent_Done,
     /*  339302 */   // Label 6211: @339302
     /*  339302 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(339368), // Rule ID 20757 //
     /*  339307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  339318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  339321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  339324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339346 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339366 */     GIR_RootConstrainSelectedInstOperands,
     /*  339367 */     // GIR_Coverage, 20757,
     /*  339367 */     GIR_EraseRootFromParent_Done,
     /*  339368 */   // Label 6212: @339368
     /*  339368 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(339434), // Rule ID 20760 //
     /*  339373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339412 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339432 */     GIR_RootConstrainSelectedInstOperands,
     /*  339433 */     // GIR_Coverage, 20760,
     /*  339433 */     GIR_EraseRootFromParent_Done,
     /*  339434 */   // Label 6213: @339434
     /*  339434 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(339500), // Rule ID 20761 //
     /*  339439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  339450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  339453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  339456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  339481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339498 */     GIR_RootConstrainSelectedInstOperands,
     /*  339499 */     // GIR_Coverage, 20761,
     /*  339499 */     GIR_EraseRootFromParent_Done,
     /*  339500 */   // Label 6214: @339500
     /*  339500 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(339566), // Rule ID 20764 //
     /*  339505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  339516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  339519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  339522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339564 */     GIR_RootConstrainSelectedInstOperands,
     /*  339565 */     // GIR_Coverage, 20764,
     /*  339565 */     GIR_EraseRootFromParent_Done,
     /*  339566 */   // Label 6215: @339566
     /*  339566 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(339632), // Rule ID 20765 //
     /*  339571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  339582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  339585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  339588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339610 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11126:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  339610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339630 */     GIR_RootConstrainSelectedInstOperands,
     /*  339631 */     // GIR_Coverage, 20765,
     /*  339631 */     GIR_EraseRootFromParent_Done,
     /*  339632 */   // Label 6216: @339632
     /*  339632 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(339698), // Rule ID 20768 //
     /*  339637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  339640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  339648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  339651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  339654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  339676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339696 */     GIR_RootConstrainSelectedInstOperands,
     /*  339697 */     // GIR_Coverage, 20768,
     /*  339697 */     GIR_EraseRootFromParent_Done,
     /*  339698 */   // Label 6217: @339698
     /*  339698 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(339764), // Rule ID 20769 //
     /*  339703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  339706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  339714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  339717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  339720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339742 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11126:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  339742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  339759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339762 */     GIR_RootConstrainSelectedInstOperands,
     /*  339763 */     // GIR_Coverage, 20769,
     /*  339763 */     GIR_EraseRootFromParent_Done,
     /*  339764 */   // Label 6218: @339764
     /*  339764 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(339830), // Rule ID 20772 //
     /*  339769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  339772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  339780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  339783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  339786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  339808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339828 */     GIR_RootConstrainSelectedInstOperands,
     /*  339829 */     // GIR_Coverage, 20772,
     /*  339829 */     GIR_EraseRootFromParent_Done,
     /*  339830 */   // Label 6219: @339830
     /*  339830 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(339896), // Rule ID 20773 //
     /*  339835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  339838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  339846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  339849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  339852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  339867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339874 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11126:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  339874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  339877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  339891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339894 */     GIR_RootConstrainSelectedInstOperands,
     /*  339895 */     // GIR_Coverage, 20773,
     /*  339895 */     GIR_EraseRootFromParent_Done,
     /*  339896 */   // Label 6220: @339896
     /*  339896 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(339962), // Rule ID 20776 //
     /*  339901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  339904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  339912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  339915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  339918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  339921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  339940 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  339940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  339943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  339945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  339947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  339949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  339954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  339957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  339960 */     GIR_RootConstrainSelectedInstOperands,
     /*  339961 */     // GIR_Coverage, 20776,
     /*  339961 */     GIR_EraseRootFromParent_Done,
     /*  339962 */   // Label 6221: @339962
     /*  339962 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(340028), // Rule ID 20777 //
     /*  339967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  339970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  339975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  339978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  339981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  339984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  339987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  339999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340026 */     GIR_RootConstrainSelectedInstOperands,
     /*  340027 */     // GIR_Coverage, 20777,
     /*  340027 */     GIR_EraseRootFromParent_Done,
     /*  340028 */   // Label 6222: @340028
     /*  340028 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(340094), // Rule ID 20780 //
     /*  340033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340072 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340092 */     GIR_RootConstrainSelectedInstOperands,
     /*  340093 */     // GIR_Coverage, 20780,
     /*  340093 */     GIR_EraseRootFromParent_Done,
     /*  340094 */   // Label 6223: @340094
     /*  340094 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(340160), // Rule ID 20781 //
     /*  340099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  340110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  340113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  340116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340138 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340158 */     GIR_RootConstrainSelectedInstOperands,
     /*  340159 */     // GIR_Coverage, 20781,
     /*  340159 */     GIR_EraseRootFromParent_Done,
     /*  340160 */   // Label 6224: @340160
     /*  340160 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(340226), // Rule ID 20784 //
     /*  340165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  340168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340204 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  340204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340224 */     GIR_RootConstrainSelectedInstOperands,
     /*  340225 */     // GIR_Coverage, 20784,
     /*  340225 */     GIR_EraseRootFromParent_Done,
     /*  340226 */   // Label 6225: @340226
     /*  340226 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(340292), // Rule ID 20785 //
     /*  340231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  340234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  340242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  340245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  340248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340270 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  340270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  340287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340290 */     GIR_RootConstrainSelectedInstOperands,
     /*  340291 */     // GIR_Coverage, 20785,
     /*  340291 */     GIR_EraseRootFromParent_Done,
     /*  340292 */   // Label 6226: @340292
     /*  340292 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(340358), // Rule ID 20788 //
     /*  340297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340356 */     GIR_RootConstrainSelectedInstOperands,
     /*  340357 */     // GIR_Coverage, 20788,
     /*  340357 */     GIR_EraseRootFromParent_Done,
     /*  340358 */   // Label 6227: @340358
     /*  340358 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(340424), // Rule ID 20789 //
     /*  340363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  340374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  340377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  340380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340402 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340422 */     GIR_RootConstrainSelectedInstOperands,
     /*  340423 */     // GIR_Coverage, 20789,
     /*  340423 */     GIR_EraseRootFromParent_Done,
     /*  340424 */   // Label 6228: @340424
     /*  340424 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(340490), // Rule ID 20792 //
     /*  340429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  340440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  340446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340468 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340488 */     GIR_RootConstrainSelectedInstOperands,
     /*  340489 */     // GIR_Coverage, 20792,
     /*  340489 */     GIR_EraseRootFromParent_Done,
     /*  340490 */   // Label 6229: @340490
     /*  340490 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(340556), // Rule ID 20793 //
     /*  340495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  340506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  340509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  340512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340554 */     GIR_RootConstrainSelectedInstOperands,
     /*  340555 */     // GIR_Coverage, 20793,
     /*  340555 */     GIR_EraseRootFromParent_Done,
     /*  340556 */   // Label 6230: @340556
     /*  340556 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(340622), // Rule ID 20796 //
     /*  340561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  340564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  340572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  340575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  340578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  340600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340620 */     GIR_RootConstrainSelectedInstOperands,
     /*  340621 */     // GIR_Coverage, 20796,
     /*  340621 */     GIR_EraseRootFromParent_Done,
     /*  340622 */   // Label 6231: @340622
     /*  340622 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(340688), // Rule ID 20797 //
     /*  340627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  340630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  340638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  340641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  340644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  340666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  340683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340686 */     GIR_RootConstrainSelectedInstOperands,
     /*  340687 */     // GIR_Coverage, 20797,
     /*  340687 */     GIR_EraseRootFromParent_Done,
     /*  340688 */   // Label 6232: @340688
     /*  340688 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(340754), // Rule ID 20800 //
     /*  340693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  340704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  340707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  340710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340732 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340752 */     GIR_RootConstrainSelectedInstOperands,
     /*  340753 */     // GIR_Coverage, 20800,
     /*  340753 */     GIR_EraseRootFromParent_Done,
     /*  340754 */   // Label 6233: @340754
     /*  340754 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(340820), // Rule ID 20801 //
     /*  340759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  340770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  340773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  340776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  340791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11126:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  340801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340818 */     GIR_RootConstrainSelectedInstOperands,
     /*  340819 */     // GIR_Coverage, 20801,
     /*  340819 */     GIR_EraseRootFromParent_Done,
     /*  340820 */   // Label 6234: @340820
     /*  340820 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(340886), // Rule ID 20804 //
     /*  340825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  340836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  340839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  340842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340884 */     GIR_RootConstrainSelectedInstOperands,
     /*  340885 */     // GIR_Coverage, 20804,
     /*  340885 */     GIR_EraseRootFromParent_Done,
     /*  340886 */   // Label 6235: @340886
     /*  340886 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(340952), // Rule ID 20805 //
     /*  340891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  340894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  340902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  340905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  340908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  340911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  340923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11126:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  340930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  340933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  340935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  340937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  340939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  340944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  340947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  340950 */     GIR_RootConstrainSelectedInstOperands,
     /*  340951 */     // GIR_Coverage, 20805,
     /*  340951 */     GIR_EraseRootFromParent_Done,
     /*  340952 */   // Label 6236: @340952
     /*  340952 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(341018), // Rule ID 20808 //
     /*  340957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  340960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  340965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  340968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  340971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  340974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  340977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  340989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  340996 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  340996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  340999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341016 */     GIR_RootConstrainSelectedInstOperands,
     /*  341017 */     // GIR_Coverage, 20808,
     /*  341017 */     GIR_EraseRootFromParent_Done,
     /*  341018 */   // Label 6237: @341018
     /*  341018 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(341084), // Rule ID 20809 //
     /*  341023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v),
     /*  341031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  341034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  341037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  341040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  341055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11126:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  341065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341082 */     GIR_RootConstrainSelectedInstOperands,
     /*  341083 */     // GIR_Coverage, 20809,
     /*  341083 */     GIR_EraseRootFromParent_Done,
     /*  341084 */   // Label 6238: @341084
     /*  341084 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(341150), // Rule ID 20812 //
     /*  341089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341148 */     GIR_RootConstrainSelectedInstOperands,
     /*  341149 */     // GIR_Coverage, 20812,
     /*  341149 */     GIR_EraseRootFromParent_Done,
     /*  341150 */   // Label 6239: @341150
     /*  341150 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(341216), // Rule ID 20813 //
     /*  341155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  341166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  341169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  341172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  341197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341214 */     GIR_RootConstrainSelectedInstOperands,
     /*  341215 */     // GIR_Coverage, 20813,
     /*  341215 */     GIR_EraseRootFromParent_Done,
     /*  341216 */   // Label 6240: @341216
     /*  341216 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(341282), // Rule ID 20816 //
     /*  341221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341260 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341280 */     GIR_RootConstrainSelectedInstOperands,
     /*  341281 */     // GIR_Coverage, 20816,
     /*  341281 */     GIR_EraseRootFromParent_Done,
     /*  341282 */   // Label 6241: @341282
     /*  341282 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(341348), // Rule ID 20817 //
     /*  341287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  341298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  341301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  341304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341326 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341346 */     GIR_RootConstrainSelectedInstOperands,
     /*  341347 */     // GIR_Coverage, 20817,
     /*  341347 */     GIR_EraseRootFromParent_Done,
     /*  341348 */   // Label 6242: @341348
     /*  341348 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(341414), // Rule ID 20820 //
     /*  341353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341392 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341412 */     GIR_RootConstrainSelectedInstOperands,
     /*  341413 */     // GIR_Coverage, 20820,
     /*  341413 */     GIR_EraseRootFromParent_Done,
     /*  341414 */   // Label 6243: @341414
     /*  341414 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(341480), // Rule ID 20821 //
     /*  341419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  341430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  341433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  341436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341458 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  341461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341478 */     GIR_RootConstrainSelectedInstOperands,
     /*  341479 */     // GIR_Coverage, 20821,
     /*  341479 */     GIR_EraseRootFromParent_Done,
     /*  341480 */   // Label 6244: @341480
     /*  341480 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(341546), // Rule ID 20824 //
     /*  341485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341544 */     GIR_RootConstrainSelectedInstOperands,
     /*  341545 */     // GIR_Coverage, 20824,
     /*  341545 */     GIR_EraseRootFromParent_Done,
     /*  341546 */   // Label 6245: @341546
     /*  341546 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(341612), // Rule ID 20825 //
     /*  341551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  341562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  341565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  341568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341590 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11124:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341610 */     GIR_RootConstrainSelectedInstOperands,
     /*  341611 */     // GIR_Coverage, 20825,
     /*  341611 */     GIR_EraseRootFromParent_Done,
     /*  341612 */   // Label 6246: @341612
     /*  341612 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(341678), // Rule ID 20828 //
     /*  341617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  341620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  341628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  341631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  341634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  341656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341676 */     GIR_RootConstrainSelectedInstOperands,
     /*  341677 */     // GIR_Coverage, 20828,
     /*  341677 */     GIR_EraseRootFromParent_Done,
     /*  341678 */   // Label 6247: @341678
     /*  341678 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(341744), // Rule ID 20829 //
     /*  341683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  341686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  341694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  341697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  341700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341722 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11124:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  341722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  341739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341742 */     GIR_RootConstrainSelectedInstOperands,
     /*  341743 */     // GIR_Coverage, 20829,
     /*  341743 */     GIR_EraseRootFromParent_Done,
     /*  341744 */   // Label 6248: @341744
     /*  341744 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(341810), // Rule ID 20832 //
     /*  341749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  341752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  341760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  341763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  341766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341788 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  341788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341808 */     GIR_RootConstrainSelectedInstOperands,
     /*  341809 */     // GIR_Coverage, 20832,
     /*  341809 */     GIR_EraseRootFromParent_Done,
     /*  341810 */   // Label 6249: @341810
     /*  341810 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(341876), // Rule ID 20833 //
     /*  341815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  341818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  341826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  341829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  341832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  341847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341854 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11124:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  341854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  341857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  341871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341874 */     GIR_RootConstrainSelectedInstOperands,
     /*  341875 */     // GIR_Coverage, 20833,
     /*  341875 */     GIR_EraseRootFromParent_Done,
     /*  341876 */   // Label 6250: @341876
     /*  341876 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(341942), // Rule ID 20836 //
     /*  341881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  341884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  341892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  341895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  341898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  341901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  341920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  341923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  341934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  341937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  341940 */     GIR_RootConstrainSelectedInstOperands,
     /*  341941 */     // GIR_Coverage, 20836,
     /*  341941 */     GIR_EraseRootFromParent_Done,
     /*  341942 */   // Label 6251: @341942
     /*  341942 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(342008), // Rule ID 20837 //
     /*  341947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  341950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  341955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  341958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  341961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  341964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  341967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  341979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  341986 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  341986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  341989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  341991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  341993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  341995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342006 */     GIR_RootConstrainSelectedInstOperands,
     /*  342007 */     // GIR_Coverage, 20837,
     /*  342007 */     GIR_EraseRootFromParent_Done,
     /*  342008 */   // Label 6252: @342008
     /*  342008 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(342074), // Rule ID 20840 //
     /*  342013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342072 */     GIR_RootConstrainSelectedInstOperands,
     /*  342073 */     // GIR_Coverage, 20840,
     /*  342073 */     GIR_EraseRootFromParent_Done,
     /*  342074 */   // Label 6253: @342074
     /*  342074 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(342140), // Rule ID 20841 //
     /*  342079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  342090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  342093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  342096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342118 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342138 */     GIR_RootConstrainSelectedInstOperands,
     /*  342139 */     // GIR_Coverage, 20841,
     /*  342139 */     GIR_EraseRootFromParent_Done,
     /*  342140 */   // Label 6254: @342140
     /*  342140 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(342206), // Rule ID 20844 //
     /*  342145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  342148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  342184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342204 */     GIR_RootConstrainSelectedInstOperands,
     /*  342205 */     // GIR_Coverage, 20844,
     /*  342205 */     GIR_EraseRootFromParent_Done,
     /*  342206 */   // Label 6255: @342206
     /*  342206 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(342272), // Rule ID 20845 //
     /*  342211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  342214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  342222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  342225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  342228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342250 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  342250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  342267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342270 */     GIR_RootConstrainSelectedInstOperands,
     /*  342271 */     // GIR_Coverage, 20845,
     /*  342271 */     GIR_EraseRootFromParent_Done,
     /*  342272 */   // Label 6256: @342272
     /*  342272 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(342338), // Rule ID 20848 //
     /*  342277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342316 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342336 */     GIR_RootConstrainSelectedInstOperands,
     /*  342337 */     // GIR_Coverage, 20848,
     /*  342337 */     GIR_EraseRootFromParent_Done,
     /*  342338 */   // Label 6257: @342338
     /*  342338 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(342404), // Rule ID 20849 //
     /*  342343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  342354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  342357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  342360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342402 */     GIR_RootConstrainSelectedInstOperands,
     /*  342403 */     // GIR_Coverage, 20849,
     /*  342403 */     GIR_EraseRootFromParent_Done,
     /*  342404 */   // Label 6258: @342404
     /*  342404 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(342470), // Rule ID 20852 //
     /*  342409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342468 */     GIR_RootConstrainSelectedInstOperands,
     /*  342469 */     // GIR_Coverage, 20852,
     /*  342469 */     GIR_EraseRootFromParent_Done,
     /*  342470 */   // Label 6259: @342470
     /*  342470 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(342536), // Rule ID 20853 //
     /*  342475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  342486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  342489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  342492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342534 */     GIR_RootConstrainSelectedInstOperands,
     /*  342535 */     // GIR_Coverage, 20853,
     /*  342535 */     GIR_EraseRootFromParent_Done,
     /*  342536 */   // Label 6260: @342536
     /*  342536 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(342602), // Rule ID 20856 //
     /*  342541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  342544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  342580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342600 */     GIR_RootConstrainSelectedInstOperands,
     /*  342601 */     // GIR_Coverage, 20856,
     /*  342601 */     GIR_EraseRootFromParent_Done,
     /*  342602 */   // Label 6261: @342602
     /*  342602 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(342668), // Rule ID 20857 //
     /*  342607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  342610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  342618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  342621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  342624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342646 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  342646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  342663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342666 */     GIR_RootConstrainSelectedInstOperands,
     /*  342667 */     // GIR_Coverage, 20857,
     /*  342667 */     GIR_EraseRootFromParent_Done,
     /*  342668 */   // Label 6262: @342668
     /*  342668 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(342734), // Rule ID 20860 //
     /*  342673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  342684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  342687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  342690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342732 */     GIR_RootConstrainSelectedInstOperands,
     /*  342733 */     // GIR_Coverage, 20860,
     /*  342733 */     GIR_EraseRootFromParent_Done,
     /*  342734 */   // Label 6263: @342734
     /*  342734 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(342800), // Rule ID 20861 //
     /*  342739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  342750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  342753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  342756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  342771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11124:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  342781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342798 */     GIR_RootConstrainSelectedInstOperands,
     /*  342799 */     // GIR_Coverage, 20861,
     /*  342799 */     GIR_EraseRootFromParent_Done,
     /*  342800 */   // Label 6264: @342800
     /*  342800 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(342866), // Rule ID 20864 //
     /*  342805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  342816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  342819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  342822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342864 */     GIR_RootConstrainSelectedInstOperands,
     /*  342865 */     // GIR_Coverage, 20864,
     /*  342865 */     GIR_EraseRootFromParent_Done,
     /*  342866 */   // Label 6265: @342866
     /*  342866 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(342932), // Rule ID 20865 //
     /*  342871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  342874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  342882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  342885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  342888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  342891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  342903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342910 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11124:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  342910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  342913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342930 */     GIR_RootConstrainSelectedInstOperands,
     /*  342931 */     // GIR_Coverage, 20865,
     /*  342931 */     GIR_EraseRootFromParent_Done,
     /*  342932 */   // Label 6266: @342932
     /*  342932 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(342998), // Rule ID 20868 //
     /*  342937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  342940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  342945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  342948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  342951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  342954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  342957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  342969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  342976 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  342976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  342979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  342981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  342983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  342985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  342990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  342993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  342996 */     GIR_RootConstrainSelectedInstOperands,
     /*  342997 */     // GIR_Coverage, 20868,
     /*  342997 */     GIR_EraseRootFromParent_Done,
     /*  342998 */   // Label 6267: @342998
     /*  342998 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(343064), // Rule ID 20869 //
     /*  343003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  343006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v),
     /*  343011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  343014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  343017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  343020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11124:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  343042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  343045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  343059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343062 */     GIR_RootConstrainSelectedInstOperands,
     /*  343063 */     // GIR_Coverage, 20869,
     /*  343063 */     GIR_EraseRootFromParent_Done,
     /*  343064 */   // Label 6268: @343064
     /*  343064 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(343130), // Rule ID 21136 //
     /*  343069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343128 */     GIR_RootConstrainSelectedInstOperands,
     /*  343129 */     // GIR_Coverage, 21136,
     /*  343129 */     GIR_EraseRootFromParent_Done,
     /*  343130 */   // Label 6269: @343130
     /*  343130 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(343196), // Rule ID 21137 //
     /*  343135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  343146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  343149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  343152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343174 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  343177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343194 */     GIR_RootConstrainSelectedInstOperands,
     /*  343195 */     // GIR_Coverage, 21137,
     /*  343195 */     GIR_EraseRootFromParent_Done,
     /*  343196 */   // Label 6270: @343196
     /*  343196 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(343262), // Rule ID 21140 //
     /*  343201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343260 */     GIR_RootConstrainSelectedInstOperands,
     /*  343261 */     // GIR_Coverage, 21140,
     /*  343261 */     GIR_EraseRootFromParent_Done,
     /*  343262 */   // Label 6271: @343262
     /*  343262 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(343328), // Rule ID 21141 //
     /*  343267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  343278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  343281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  343284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11222:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343326 */     GIR_RootConstrainSelectedInstOperands,
     /*  343327 */     // GIR_Coverage, 21141,
     /*  343327 */     GIR_EraseRootFromParent_Done,
     /*  343328 */   // Label 6272: @343328
     /*  343328 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(343394), // Rule ID 21144 //
     /*  343333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343392 */     GIR_RootConstrainSelectedInstOperands,
     /*  343393 */     // GIR_Coverage, 21144,
     /*  343393 */     GIR_EraseRootFromParent_Done,
     /*  343394 */   // Label 6273: @343394
     /*  343394 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(343460), // Rule ID 21145 //
     /*  343399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  343410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  343413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  343416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343458 */     GIR_RootConstrainSelectedInstOperands,
     /*  343459 */     // GIR_Coverage, 21145,
     /*  343459 */     GIR_EraseRootFromParent_Done,
     /*  343460 */   // Label 6274: @343460
     /*  343460 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(343526), // Rule ID 21148 //
     /*  343465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  343482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343504 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  343507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343524 */     GIR_RootConstrainSelectedInstOperands,
     /*  343525 */     // GIR_Coverage, 21148,
     /*  343525 */     GIR_EraseRootFromParent_Done,
     /*  343526 */   // Label 6275: @343526
     /*  343526 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(343592), // Rule ID 21149 //
     /*  343531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  343542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  343545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  343548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  343573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343590 */     GIR_RootConstrainSelectedInstOperands,
     /*  343591 */     // GIR_Coverage, 21149,
     /*  343591 */     GIR_EraseRootFromParent_Done,
     /*  343592 */   // Label 6276: @343592
     /*  343592 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(343658), // Rule ID 21152 //
     /*  343597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  343600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  343636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  343639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343656 */     GIR_RootConstrainSelectedInstOperands,
     /*  343657 */     // GIR_Coverage, 21152,
     /*  343657 */     GIR_EraseRootFromParent_Done,
     /*  343658 */   // Label 6277: @343658
     /*  343658 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(343724), // Rule ID 21153 //
     /*  343663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  343666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  343674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  343677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  343680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  343691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  343695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  343702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  343705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  343719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343722 */     GIR_RootConstrainSelectedInstOperands,
     /*  343723 */     // GIR_Coverage, 21153,
     /*  343723 */     GIR_EraseRootFromParent_Done,
     /*  343724 */   // Label 6278: @343724
     /*  343724 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(343790), // Rule ID 21156 //
     /*  343729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  343732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  343740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  343743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343768 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343788 */     GIR_RootConstrainSelectedInstOperands,
     /*  343789 */     // GIR_Coverage, 21156,
     /*  343789 */     GIR_EraseRootFromParent_Done,
     /*  343790 */   // Label 6279: @343790
     /*  343790 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(343856), // Rule ID 21157 //
     /*  343795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  343798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  343806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  343809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  343812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11222:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  343837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343854 */     GIR_RootConstrainSelectedInstOperands,
     /*  343855 */     // GIR_Coverage, 21157,
     /*  343855 */     GIR_EraseRootFromParent_Done,
     /*  343856 */   // Label 6280: @343856
     /*  343856 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(343922), // Rule ID 21160 //
     /*  343861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  343864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  343878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  343881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  343900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343920 */     GIR_RootConstrainSelectedInstOperands,
     /*  343921 */     // GIR_Coverage, 21160,
     /*  343921 */     GIR_EraseRootFromParent_Done,
     /*  343922 */   // Label 6281: @343922
     /*  343922 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(343988), // Rule ID 21161 //
     /*  343927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  343930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  343935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  343938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  343941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  343944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  343947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  343955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  343959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  343966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11222:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  343966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  343969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  343971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  343973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  343975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  343980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  343983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  343986 */     GIR_RootConstrainSelectedInstOperands,
     /*  343987 */     // GIR_Coverage, 21161,
     /*  343987 */     GIR_EraseRootFromParent_Done,
     /*  343988 */   // Label 6282: @343988
     /*  343988 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(344054), // Rule ID 21164 //
     /*  343993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  343996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344052 */     GIR_RootConstrainSelectedInstOperands,
     /*  344053 */     // GIR_Coverage, 21164,
     /*  344053 */     GIR_EraseRootFromParent_Done,
     /*  344054 */   // Label 6283: @344054
     /*  344054 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(344120), // Rule ID 21165 //
     /*  344059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  344070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  344073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  344076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11222:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  344101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344118 */     GIR_RootConstrainSelectedInstOperands,
     /*  344119 */     // GIR_Coverage, 21165,
     /*  344119 */     GIR_EraseRootFromParent_Done,
     /*  344120 */   // Label 6284: @344120
     /*  344120 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(344186), // Rule ID 21168 //
     /*  344125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344164 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344184 */     GIR_RootConstrainSelectedInstOperands,
     /*  344185 */     // GIR_Coverage, 21168,
     /*  344185 */     GIR_EraseRootFromParent_Done,
     /*  344186 */   // Label 6285: @344186
     /*  344186 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(344252), // Rule ID 21169 //
     /*  344191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v),
     /*  344199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  344202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  344205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  344208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11222:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  344230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  344233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344250 */     GIR_RootConstrainSelectedInstOperands,
     /*  344251 */     // GIR_Coverage, 21169,
     /*  344251 */     GIR_EraseRootFromParent_Done,
     /*  344252 */   // Label 6286: @344252
     /*  344252 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(344318), // Rule ID 21172 //
     /*  344257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344296 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344316 */     GIR_RootConstrainSelectedInstOperands,
     /*  344317 */     // GIR_Coverage, 21172,
     /*  344317 */     GIR_EraseRootFromParent_Done,
     /*  344318 */   // Label 6287: @344318
     /*  344318 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(344384), // Rule ID 21173 //
     /*  344323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  344334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  344337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  344340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  344365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344382 */     GIR_RootConstrainSelectedInstOperands,
     /*  344383 */     // GIR_Coverage, 21173,
     /*  344383 */     GIR_EraseRootFromParent_Done,
     /*  344384 */   // Label 6288: @344384
     /*  344384 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(344450), // Rule ID 21176 //
     /*  344389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  344431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344448 */     GIR_RootConstrainSelectedInstOperands,
     /*  344449 */     // GIR_Coverage, 21176,
     /*  344449 */     GIR_EraseRootFromParent_Done,
     /*  344450 */   // Label 6289: @344450
     /*  344450 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(344516), // Rule ID 21177 //
     /*  344455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  344466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  344469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  344472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11220:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  344497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344514 */     GIR_RootConstrainSelectedInstOperands,
     /*  344515 */     // GIR_Coverage, 21177,
     /*  344515 */     GIR_EraseRootFromParent_Done,
     /*  344516 */   // Label 6290: @344516
     /*  344516 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(344582), // Rule ID 21180 //
     /*  344521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  344563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344580 */     GIR_RootConstrainSelectedInstOperands,
     /*  344581 */     // GIR_Coverage, 21180,
     /*  344581 */     GIR_EraseRootFromParent_Done,
     /*  344582 */   // Label 6291: @344582
     /*  344582 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(344648), // Rule ID 21181 //
     /*  344587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  344598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  344601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  344604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  344629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344646 */     GIR_RootConstrainSelectedInstOperands,
     /*  344647 */     // GIR_Coverage, 21181,
     /*  344647 */     GIR_EraseRootFromParent_Done,
     /*  344648 */   // Label 6292: @344648
     /*  344648 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(344714), // Rule ID 21184 //
     /*  344653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344692 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  344695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344712 */     GIR_RootConstrainSelectedInstOperands,
     /*  344713 */     // GIR_Coverage, 21184,
     /*  344713 */     GIR_EraseRootFromParent_Done,
     /*  344714 */   // Label 6293: @344714
     /*  344714 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(344780), // Rule ID 21185 //
     /*  344719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  344730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  344733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  344736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  344751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344758 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  344761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344778 */     GIR_RootConstrainSelectedInstOperands,
     /*  344779 */     // GIR_Coverage, 21185,
     /*  344779 */     GIR_EraseRootFromParent_Done,
     /*  344780 */   // Label 6294: @344780
     /*  344780 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(344846), // Rule ID 21188 //
     /*  344785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  344788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  344824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  344827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344844 */     GIR_RootConstrainSelectedInstOperands,
     /*  344845 */     // GIR_Coverage, 21188,
     /*  344845 */     GIR_EraseRootFromParent_Done,
     /*  344846 */   // Label 6295: @344846
     /*  344846 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(344912), // Rule ID 21189 //
     /*  344851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  344854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  344862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  344865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  344868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  344871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  344879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  344883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  344890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  344893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  344907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344910 */     GIR_RootConstrainSelectedInstOperands,
     /*  344911 */     // GIR_Coverage, 21189,
     /*  344911 */     GIR_EraseRootFromParent_Done,
     /*  344912 */   // Label 6296: @344912
     /*  344912 */   GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(344978), // Rule ID 21192 //
     /*  344917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  344920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  344934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  344937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  344949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  344956 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  344956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  344959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  344961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  344963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  344965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  344970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  344973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  344976 */     GIR_RootConstrainSelectedInstOperands,
     /*  344977 */     // GIR_Coverage, 21192,
     /*  344977 */     GIR_EraseRootFromParent_Done,
     /*  344978 */   // Label 6297: @344978
     /*  344978 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(345044), // Rule ID 21193 //
     /*  344983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  344986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  344991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  344994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  344997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  345000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11220:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  345025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345042 */     GIR_RootConstrainSelectedInstOperands,
     /*  345043 */     // GIR_Coverage, 21193,
     /*  345043 */     GIR_EraseRootFromParent_Done,
     /*  345044 */   // Label 6298: @345044
     /*  345044 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(345110), // Rule ID 21196 //
     /*  345049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345108 */     GIR_RootConstrainSelectedInstOperands,
     /*  345109 */     // GIR_Coverage, 21196,
     /*  345109 */     GIR_EraseRootFromParent_Done,
     /*  345110 */   // Label 6299: @345110
     /*  345110 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(345176), // Rule ID 21197 //
     /*  345115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  345126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  345129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  345132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11220:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  345157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345174 */     GIR_RootConstrainSelectedInstOperands,
     /*  345175 */     // GIR_Coverage, 21197,
     /*  345175 */     GIR_EraseRootFromParent_Done,
     /*  345176 */   // Label 6300: @345176
     /*  345176 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(345242), // Rule ID 21200 //
     /*  345181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345220 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345240 */     GIR_RootConstrainSelectedInstOperands,
     /*  345241 */     // GIR_Coverage, 21200,
     /*  345241 */     GIR_EraseRootFromParent_Done,
     /*  345242 */   // Label 6301: @345242
     /*  345242 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(345308), // Rule ID 21201 //
     /*  345247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  345258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  345261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  345264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11220:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  345289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345306 */     GIR_RootConstrainSelectedInstOperands,
     /*  345307 */     // GIR_Coverage, 21201,
     /*  345307 */     GIR_EraseRootFromParent_Done,
     /*  345308 */   // Label 6302: @345308
     /*  345308 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(345374), // Rule ID 21204 //
     /*  345313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  345316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345352 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  345352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345372 */     GIR_RootConstrainSelectedInstOperands,
     /*  345373 */     // GIR_Coverage, 21204,
     /*  345373 */     GIR_EraseRootFromParent_Done,
     /*  345374 */   // Label 6303: @345374
     /*  345374 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(345440), // Rule ID 21205 //
     /*  345379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  345382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v),
     /*  345387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  345390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  345393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  345396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  345407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11220:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  345418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  345421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  345435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345438 */     GIR_RootConstrainSelectedInstOperands,
     /*  345439 */     // GIR_Coverage, 21205,
     /*  345439 */     GIR_EraseRootFromParent_Done,
     /*  345440 */   // Label 6304: @345440
     /*  345440 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(345506), // Rule ID 21208 //
     /*  345445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  345462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345484 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  345487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345504 */     GIR_RootConstrainSelectedInstOperands,
     /*  345505 */     // GIR_Coverage, 21208,
     /*  345505 */     GIR_EraseRootFromParent_Done,
     /*  345506 */   // Label 6305: @345506
     /*  345506 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(345572), // Rule ID 21209 //
     /*  345511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  345522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  345525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  345528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345550 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /*  345553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345570 */     GIR_RootConstrainSelectedInstOperands,
     /*  345571 */     // GIR_Coverage, 21209,
     /*  345571 */     GIR_EraseRootFromParent_Done,
     /*  345572 */   // Label 6306: @345572
     /*  345572 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(345638), // Rule ID 21212 //
     /*  345577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  345594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345616 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  345619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345636 */     GIR_RootConstrainSelectedInstOperands,
     /*  345637 */     // GIR_Coverage, 21212,
     /*  345637 */     GIR_EraseRootFromParent_Done,
     /*  345638 */   // Label 6307: @345638
     /*  345638 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(345704), // Rule ID 21213 //
     /*  345643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  345654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  345657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  345660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345682 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /*  345685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345702 */     GIR_RootConstrainSelectedInstOperands,
     /*  345703 */     // GIR_Coverage, 21213,
     /*  345703 */     GIR_EraseRootFromParent_Done,
     /*  345704 */   // Label 6308: @345704
     /*  345704 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(345770), // Rule ID 21216 //
     /*  345709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  345726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345748 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  345751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345768 */     GIR_RootConstrainSelectedInstOperands,
     /*  345769 */     // GIR_Coverage, 21216,
     /*  345769 */     GIR_EraseRootFromParent_Done,
     /*  345770 */   // Label 6309: @345770
     /*  345770 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(345836), // Rule ID 21217 //
     /*  345775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  345786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  345789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  345792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345814 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11218:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /*  345817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345834 */     GIR_RootConstrainSelectedInstOperands,
     /*  345835 */     // GIR_Coverage, 21217,
     /*  345835 */     GIR_EraseRootFromParent_Done,
     /*  345836 */   // Label 6310: @345836
     /*  345836 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(345902), // Rule ID 21220 //
     /*  345841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  345852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  345855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  345858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345880 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  345880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  345883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345900 */     GIR_RootConstrainSelectedInstOperands,
     /*  345901 */     // GIR_Coverage, 21220,
     /*  345901 */     GIR_EraseRootFromParent_Done,
     /*  345902 */   // Label 6311: @345902
     /*  345902 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(345968), // Rule ID 21221 //
     /*  345907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  345910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  345918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  345921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  345924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  345927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  345935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  345939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  345946 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  345946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /*  345949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  345951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  345953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  345955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  345960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  345963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  345966 */     GIR_RootConstrainSelectedInstOperands,
     /*  345967 */     // GIR_Coverage, 21221,
     /*  345967 */     GIR_EraseRootFromParent_Done,
     /*  345968 */   // Label 6312: @345968
     /*  345968 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(346034), // Rule ID 21224 //
     /*  345973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  345976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  345981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  345984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  345987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  345990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  345993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  345997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346012 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346032 */     GIR_RootConstrainSelectedInstOperands,
     /*  346033 */     // GIR_Coverage, 21224,
     /*  346033 */     GIR_EraseRootFromParent_Done,
     /*  346034 */   // Label 6313: @346034
     /*  346034 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(346100), // Rule ID 21225 //
     /*  346039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  346050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  346053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  346056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346078 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /*  346081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346098 */     GIR_RootConstrainSelectedInstOperands,
     /*  346099 */     // GIR_Coverage, 21225,
     /*  346099 */     GIR_EraseRootFromParent_Done,
     /*  346100 */   // Label 6314: @346100
     /*  346100 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(346166), // Rule ID 21228 //
     /*  346105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  346108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346144 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  346144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346164 */     GIR_RootConstrainSelectedInstOperands,
     /*  346165 */     // GIR_Coverage, 21228,
     /*  346165 */     GIR_EraseRootFromParent_Done,
     /*  346166 */   // Label 6315: @346166
     /*  346166 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(346232), // Rule ID 21229 //
     /*  346171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  346174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  346182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  346185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  346188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346210 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  346210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /*  346213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  346227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346230 */     GIR_RootConstrainSelectedInstOperands,
     /*  346231 */     // GIR_Coverage, 21229,
     /*  346231 */     GIR_EraseRootFromParent_Done,
     /*  346232 */   // Label 6316: @346232
     /*  346232 */   GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(346298), // Rule ID 21232 //
     /*  346237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346276 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346296 */     GIR_RootConstrainSelectedInstOperands,
     /*  346297 */     // GIR_Coverage, 21232,
     /*  346297 */     GIR_EraseRootFromParent_Done,
     /*  346298 */   // Label 6317: @346298
     /*  346298 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(346364), // Rule ID 21233 //
     /*  346303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  346314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  346317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  346320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346342 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /*  346345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346362 */     GIR_RootConstrainSelectedInstOperands,
     /*  346363 */     // GIR_Coverage, 21233,
     /*  346363 */     GIR_EraseRootFromParent_Done,
     /*  346364 */   // Label 6318: @346364
     /*  346364 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(346430), // Rule ID 21236 //
     /*  346369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346408 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346428 */     GIR_RootConstrainSelectedInstOperands,
     /*  346429 */     // GIR_Coverage, 21236,
     /*  346429 */     GIR_EraseRootFromParent_Done,
     /*  346430 */   // Label 6319: @346430
     /*  346430 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(346496), // Rule ID 21237 //
     /*  346435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  346446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  346449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  346452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346474 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11218:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /*  346477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346494 */     GIR_RootConstrainSelectedInstOperands,
     /*  346495 */     // GIR_Coverage, 21237,
     /*  346495 */     GIR_EraseRootFromParent_Done,
     /*  346496 */   // Label 6320: @346496
     /*  346496 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(346562), // Rule ID 21240 //
     /*  346501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  346518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346540 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  346543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346560 */     GIR_RootConstrainSelectedInstOperands,
     /*  346561 */     // GIR_Coverage, 21240,
     /*  346561 */     GIR_EraseRootFromParent_Done,
     /*  346562 */   // Label 6321: @346562
     /*  346562 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(346628), // Rule ID 21241 //
     /*  346567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  346578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  346581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  346584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346606 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /*  346609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346626 */     GIR_RootConstrainSelectedInstOperands,
     /*  346627 */     // GIR_Coverage, 21241,
     /*  346627 */     GIR_EraseRootFromParent_Done,
     /*  346628 */   // Label 6322: @346628
     /*  346628 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(346694), // Rule ID 21244 //
     /*  346633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346672 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  346675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346692 */     GIR_RootConstrainSelectedInstOperands,
     /*  346693 */     // GIR_Coverage, 21244,
     /*  346693 */     GIR_EraseRootFromParent_Done,
     /*  346694 */   // Label 6323: @346694
     /*  346694 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(346760), // Rule ID 21245 //
     /*  346699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  346710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  346713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  346716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  346731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346738 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /*  346741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346758 */     GIR_RootConstrainSelectedInstOperands,
     /*  346759 */     // GIR_Coverage, 21245,
     /*  346759 */     GIR_EraseRootFromParent_Done,
     /*  346760 */   // Label 6324: @346760
     /*  346760 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(346826), // Rule ID 21248 //
     /*  346765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  346768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346804 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  346804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  346807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346824 */     GIR_RootConstrainSelectedInstOperands,
     /*  346825 */     // GIR_Coverage, 21248,
     /*  346825 */     GIR_EraseRootFromParent_Done,
     /*  346826 */   // Label 6325: @346826
     /*  346826 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(346892), // Rule ID 21249 //
     /*  346831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  346834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  346842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  346845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  346848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  346859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  346863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346870 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  346870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /*  346873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  346887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346890 */     GIR_RootConstrainSelectedInstOperands,
     /*  346891 */     // GIR_Coverage, 21249,
     /*  346891 */     GIR_EraseRootFromParent_Done,
     /*  346892 */   // Label 6326: @346892
     /*  346892 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(346958), // Rule ID 21252 //
     /*  346897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  346900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  346914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  346917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  346936 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  346936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  346939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  346941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  346943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  346945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  346950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  346953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  346956 */     GIR_RootConstrainSelectedInstOperands,
     /*  346957 */     // GIR_Coverage, 21252,
     /*  346957 */     GIR_EraseRootFromParent_Done,
     /*  346958 */   // Label 6327: @346958
     /*  346958 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(347024), // Rule ID 21253 //
     /*  346963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  346966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  346971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  346974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  346977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  346980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  346983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  346995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347002 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11218:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /*  347005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347022 */     GIR_RootConstrainSelectedInstOperands,
     /*  347023 */     // GIR_Coverage, 21253,
     /*  347023 */     GIR_EraseRootFromParent_Done,
     /*  347024 */   // Label 6328: @347024
     /*  347024 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(347090), // Rule ID 21256 //
     /*  347029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347068 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347088 */     GIR_RootConstrainSelectedInstOperands,
     /*  347089 */     // GIR_Coverage, 21256,
     /*  347089 */     GIR_EraseRootFromParent_Done,
     /*  347090 */   // Label 6329: @347090
     /*  347090 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(347156), // Rule ID 21257 //
     /*  347095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  347106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  347109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  347112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347134 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11218:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /*  347137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347154 */     GIR_RootConstrainSelectedInstOperands,
     /*  347155 */     // GIR_Coverage, 21257,
     /*  347155 */     GIR_EraseRootFromParent_Done,
     /*  347156 */   // Label 6330: @347156
     /*  347156 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(347222), // Rule ID 21260 //
     /*  347161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347200 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347220 */     GIR_RootConstrainSelectedInstOperands,
     /*  347221 */     // GIR_Coverage, 21260,
     /*  347221 */     GIR_EraseRootFromParent_Done,
     /*  347222 */   // Label 6331: @347222
     /*  347222 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(347288), // Rule ID 21261 //
     /*  347227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  347238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  347241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  347244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347266 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11218:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /*  347269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347286 */     GIR_RootConstrainSelectedInstOperands,
     /*  347287 */     // GIR_Coverage, 21261,
     /*  347287 */     GIR_EraseRootFromParent_Done,
     /*  347288 */   // Label 6332: @347288
     /*  347288 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(347354), // Rule ID 21264 //
     /*  347293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  347296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347332 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  347332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347352 */     GIR_RootConstrainSelectedInstOperands,
     /*  347353 */     // GIR_Coverage, 21264,
     /*  347353 */     GIR_EraseRootFromParent_Done,
     /*  347354 */   // Label 6333: @347354
     /*  347354 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(347420), // Rule ID 21265 //
     /*  347359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  347362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v),
     /*  347367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  347370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  347373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  347376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  347387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347398 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11218:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  347398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /*  347401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  347415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347418 */     GIR_RootConstrainSelectedInstOperands,
     /*  347419 */     // GIR_Coverage, 21265,
     /*  347419 */     GIR_EraseRootFromParent_Done,
     /*  347420 */   // Label 6334: @347420
     /*  347420 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(347486), // Rule ID 21268 //
     /*  347425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347464 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  347467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347484 */     GIR_RootConstrainSelectedInstOperands,
     /*  347485 */     // GIR_Coverage, 21268,
     /*  347485 */     GIR_EraseRootFromParent_Done,
     /*  347486 */   // Label 6335: @347486
     /*  347486 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(347552), // Rule ID 21269 //
     /*  347491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  347502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  347505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  347508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347530 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /*  347533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347550 */     GIR_RootConstrainSelectedInstOperands,
     /*  347551 */     // GIR_Coverage, 21269,
     /*  347551 */     GIR_EraseRootFromParent_Done,
     /*  347552 */   // Label 6336: @347552
     /*  347552 */   GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(347618), // Rule ID 21272 //
     /*  347557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  347568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  347571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  347574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347596 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  347599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347616 */     GIR_RootConstrainSelectedInstOperands,
     /*  347617 */     // GIR_Coverage, 21272,
     /*  347617 */     GIR_EraseRootFromParent_Done,
     /*  347618 */   // Label 6337: @347618
     /*  347618 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(347684), // Rule ID 21273 //
     /*  347623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  347634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  347637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  347640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347662 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /*  347665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347682 */     GIR_RootConstrainSelectedInstOperands,
     /*  347683 */     // GIR_Coverage, 21273,
     /*  347683 */     GIR_EraseRootFromParent_Done,
     /*  347684 */   // Label 6338: @347684
     /*  347684 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(347750), // Rule ID 21276 //
     /*  347689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  347700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  347703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  347706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347728 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  347731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347748 */     GIR_RootConstrainSelectedInstOperands,
     /*  347749 */     // GIR_Coverage, 21276,
     /*  347749 */     GIR_EraseRootFromParent_Done,
     /*  347750 */   // Label 6339: @347750
     /*  347750 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(347816), // Rule ID 21277 //
     /*  347755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  347766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  347769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  347772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347794 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11216:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /*  347797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347814 */     GIR_RootConstrainSelectedInstOperands,
     /*  347815 */     // GIR_Coverage, 21277,
     /*  347815 */     GIR_EraseRootFromParent_Done,
     /*  347816 */   // Label 6340: @347816
     /*  347816 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(347882), // Rule ID 21280 //
     /*  347821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  347832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  347835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  347838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  347863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347880 */     GIR_RootConstrainSelectedInstOperands,
     /*  347881 */     // GIR_Coverage, 21280,
     /*  347881 */     GIR_EraseRootFromParent_Done,
     /*  347882 */   // Label 6341: @347882
     /*  347882 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(347948), // Rule ID 21281 //
     /*  347887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  347890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  347898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  347901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  347904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  347907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  347919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  347926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /*  347929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  347935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  347940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  347943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  347946 */     GIR_RootConstrainSelectedInstOperands,
     /*  347947 */     // GIR_Coverage, 21281,
     /*  347947 */     GIR_EraseRootFromParent_Done,
     /*  347948 */   // Label 6342: @347948
     /*  347948 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(348014), // Rule ID 21284 //
     /*  347953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  347956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  347961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  347964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  347967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  347970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  347973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  347981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  347985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  347992 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  347992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  347995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  347997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  347999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348012 */     GIR_RootConstrainSelectedInstOperands,
     /*  348013 */     // GIR_Coverage, 21284,
     /*  348013 */     GIR_EraseRootFromParent_Done,
     /*  348014 */   // Label 6343: @348014
     /*  348014 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(348080), // Rule ID 21285 //
     /*  348019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  348030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  348033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  348036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348058 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /*  348061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348078 */     GIR_RootConstrainSelectedInstOperands,
     /*  348079 */     // GIR_Coverage, 21285,
     /*  348079 */     GIR_EraseRootFromParent_Done,
     /*  348080 */   // Label 6344: @348080
     /*  348080 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(348146), // Rule ID 21288 //
     /*  348085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  348088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348124 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  348124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348144 */     GIR_RootConstrainSelectedInstOperands,
     /*  348145 */     // GIR_Coverage, 21288,
     /*  348145 */     GIR_EraseRootFromParent_Done,
     /*  348146 */   // Label 6345: @348146
     /*  348146 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(348212), // Rule ID 21289 //
     /*  348151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  348154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  348162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  348165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  348168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348190 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  348190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /*  348193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  348207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348210 */     GIR_RootConstrainSelectedInstOperands,
     /*  348211 */     // GIR_Coverage, 21289,
     /*  348211 */     GIR_EraseRootFromParent_Done,
     /*  348212 */   // Label 6346: @348212
     /*  348212 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(348278), // Rule ID 21292 //
     /*  348217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348256 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348276 */     GIR_RootConstrainSelectedInstOperands,
     /*  348277 */     // GIR_Coverage, 21292,
     /*  348277 */     GIR_EraseRootFromParent_Done,
     /*  348278 */   // Label 6347: @348278
     /*  348278 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(348344), // Rule ID 21293 //
     /*  348283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  348294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  348297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  348300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348322 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /*  348325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348342 */     GIR_RootConstrainSelectedInstOperands,
     /*  348343 */     // GIR_Coverage, 21293,
     /*  348343 */     GIR_EraseRootFromParent_Done,
     /*  348344 */   // Label 6348: @348344
     /*  348344 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(348410), // Rule ID 21296 //
     /*  348349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348388 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348408 */     GIR_RootConstrainSelectedInstOperands,
     /*  348409 */     // GIR_Coverage, 21296,
     /*  348409 */     GIR_EraseRootFromParent_Done,
     /*  348410 */   // Label 6349: @348410
     /*  348410 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(348476), // Rule ID 21297 //
     /*  348415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  348426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  348429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  348432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348454 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11216:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /*  348457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348474 */     GIR_RootConstrainSelectedInstOperands,
     /*  348475 */     // GIR_Coverage, 21297,
     /*  348475 */     GIR_EraseRootFromParent_Done,
     /*  348476 */   // Label 6350: @348476
     /*  348476 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(348542), // Rule ID 21300 //
     /*  348481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  348523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348540 */     GIR_RootConstrainSelectedInstOperands,
     /*  348541 */     // GIR_Coverage, 21300,
     /*  348541 */     GIR_EraseRootFromParent_Done,
     /*  348542 */   // Label 6351: @348542
     /*  348542 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(348608), // Rule ID 21301 //
     /*  348547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  348558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  348561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  348564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348586 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /*  348589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348606 */     GIR_RootConstrainSelectedInstOperands,
     /*  348607 */     // GIR_Coverage, 21301,
     /*  348607 */     GIR_EraseRootFromParent_Done,
     /*  348608 */   // Label 6352: @348608
     /*  348608 */   GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(348674), // Rule ID 21304 //
     /*  348613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  348624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  348627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  348630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  348655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348672 */     GIR_RootConstrainSelectedInstOperands,
     /*  348673 */     // GIR_Coverage, 21304,
     /*  348673 */     GIR_EraseRootFromParent_Done,
     /*  348674 */   // Label 6353: @348674
     /*  348674 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(348740), // Rule ID 21305 //
     /*  348679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  348690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  348693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  348696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  348711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /*  348721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348738 */     GIR_RootConstrainSelectedInstOperands,
     /*  348739 */     // GIR_Coverage, 21305,
     /*  348739 */     GIR_EraseRootFromParent_Done,
     /*  348740 */   // Label 6354: @348740
     /*  348740 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(348806), // Rule ID 21308 //
     /*  348745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  348748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  348756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  348759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  348762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348784 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  348784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  348787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348804 */     GIR_RootConstrainSelectedInstOperands,
     /*  348805 */     // GIR_Coverage, 21308,
     /*  348805 */     GIR_EraseRootFromParent_Done,
     /*  348806 */   // Label 6355: @348806
     /*  348806 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(348872), // Rule ID 21309 //
     /*  348811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  348814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  348822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  348825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  348828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  348839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  348843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348850 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  348850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /*  348853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  348867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348870 */     GIR_RootConstrainSelectedInstOperands,
     /*  348871 */     // GIR_Coverage, 21309,
     /*  348871 */     GIR_EraseRootFromParent_Done,
     /*  348872 */   // Label 6356: @348872
     /*  348872 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(348938), // Rule ID 21312 //
     /*  348877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  348880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  348897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348916 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  348916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  348919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  348936 */     GIR_RootConstrainSelectedInstOperands,
     /*  348937 */     // GIR_Coverage, 21312,
     /*  348937 */     GIR_EraseRootFromParent_Done,
     /*  348938 */   // Label 6357: @348938
     /*  348938 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(349004), // Rule ID 21313 //
     /*  348943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  348946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  348951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  348954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  348957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  348960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  348963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  348975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  348982 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11216:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  348982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /*  348985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  348987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  348989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  348991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  348996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  348999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349002 */     GIR_RootConstrainSelectedInstOperands,
     /*  349003 */     // GIR_Coverage, 21313,
     /*  349003 */     GIR_EraseRootFromParent_Done,
     /*  349004 */   // Label 6358: @349004
     /*  349004 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(349070), // Rule ID 21316 //
     /*  349009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349048 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349068 */     GIR_RootConstrainSelectedInstOperands,
     /*  349069 */     // GIR_Coverage, 21316,
     /*  349069 */     GIR_EraseRootFromParent_Done,
     /*  349070 */   // Label 6359: @349070
     /*  349070 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(349136), // Rule ID 21317 //
     /*  349075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  349086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  349089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  349092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349114 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11216:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /*  349117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349134 */     GIR_RootConstrainSelectedInstOperands,
     /*  349135 */     // GIR_Coverage, 21317,
     /*  349135 */     GIR_EraseRootFromParent_Done,
     /*  349136 */   // Label 6360: @349136
     /*  349136 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(349202), // Rule ID 21320 //
     /*  349141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349200 */     GIR_RootConstrainSelectedInstOperands,
     /*  349201 */     // GIR_Coverage, 21320,
     /*  349201 */     GIR_EraseRootFromParent_Done,
     /*  349202 */   // Label 6361: @349202
     /*  349202 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(349268), // Rule ID 21321 //
     /*  349207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  349218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  349221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  349224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349246 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11216:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /*  349249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349266 */     GIR_RootConstrainSelectedInstOperands,
     /*  349267 */     // GIR_Coverage, 21321,
     /*  349267 */     GIR_EraseRootFromParent_Done,
     /*  349268 */   // Label 6362: @349268
     /*  349268 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(349334), // Rule ID 21324 //
     /*  349273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  349276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349312 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  349312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349332 */     GIR_RootConstrainSelectedInstOperands,
     /*  349333 */     // GIR_Coverage, 21324,
     /*  349333 */     GIR_EraseRootFromParent_Done,
     /*  349334 */   // Label 6363: @349334
     /*  349334 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(349400), // Rule ID 21325 //
     /*  349339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  349342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v),
     /*  349347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  349350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  349353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  349356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349378 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11216:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  349378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /*  349381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  349395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349398 */     GIR_RootConstrainSelectedInstOperands,
     /*  349399 */     // GIR_Coverage, 21325,
     /*  349399 */     GIR_EraseRootFromParent_Done,
     /*  349400 */   // Label 6364: @349400
     /*  349400 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(349466), // Rule ID 21328 //
     /*  349405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  349408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349444 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  349447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349464 */     GIR_RootConstrainSelectedInstOperands,
     /*  349465 */     // GIR_Coverage, 21328,
     /*  349465 */     GIR_EraseRootFromParent_Done,
     /*  349466 */   // Label 6365: @349466
     /*  349466 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(349532), // Rule ID 21329 //
     /*  349471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  349474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  349482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  349485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  349488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349510 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16),
     /*  349513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349530 */     GIR_RootConstrainSelectedInstOperands,
     /*  349531 */     // GIR_Coverage, 21329,
     /*  349531 */     GIR_EraseRootFromParent_Done,
     /*  349532 */   // Label 6366: @349532
     /*  349532 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(349598), // Rule ID 21332 //
     /*  349537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  349540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349576 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  349579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349596 */     GIR_RootConstrainSelectedInstOperands,
     /*  349597 */     // GIR_Coverage, 21332,
     /*  349597 */     GIR_EraseRootFromParent_Done,
     /*  349598 */   // Label 6367: @349598
     /*  349598 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(349664), // Rule ID 21333 //
     /*  349603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  349606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  349614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  349617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  349620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349642 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11214:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16),
     /*  349645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349662 */     GIR_RootConstrainSelectedInstOperands,
     /*  349663 */     // GIR_Coverage, 21333,
     /*  349663 */     GIR_EraseRootFromParent_Done,
     /*  349664 */   // Label 6368: @349664
     /*  349664 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(349730), // Rule ID 21336 //
     /*  349669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  349672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349708 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  349711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349728 */     GIR_RootConstrainSelectedInstOperands,
     /*  349729 */     // GIR_Coverage, 21336,
     /*  349729 */     GIR_EraseRootFromParent_Done,
     /*  349730 */   // Label 6369: @349730
     /*  349730 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(349796), // Rule ID 21337 //
     /*  349735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  349738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  349746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  349749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  349752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  349767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349774 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16),
     /*  349777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349794 */     GIR_RootConstrainSelectedInstOperands,
     /*  349795 */     // GIR_Coverage, 21337,
     /*  349795 */     GIR_EraseRootFromParent_Done,
     /*  349796 */   // Label 6370: @349796
     /*  349796 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(349862), // Rule ID 21340 //
     /*  349801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  349804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349840 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  349843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349860 */     GIR_RootConstrainSelectedInstOperands,
     /*  349861 */     // GIR_Coverage, 21340,
     /*  349861 */     GIR_EraseRootFromParent_Done,
     /*  349862 */   // Label 6371: @349862
     /*  349862 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(349928), // Rule ID 21341 //
     /*  349867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  349870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  349878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  349881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  349884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  349887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  349899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349906 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  349906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16),
     /*  349909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349926 */     GIR_RootConstrainSelectedInstOperands,
     /*  349927 */     // GIR_Coverage, 21341,
     /*  349927 */     GIR_EraseRootFromParent_Done,
     /*  349928 */   // Label 6372: @349928
     /*  349928 */   GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(349994), // Rule ID 21344 //
     /*  349933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  349936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  349941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  349944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  349947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  349950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  349953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  349961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  349965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  349972 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  349972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  349975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  349977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  349979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  349981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  349986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  349989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  349992 */     GIR_RootConstrainSelectedInstOperands,
     /*  349993 */     // GIR_Coverage, 21344,
     /*  349993 */     GIR_EraseRootFromParent_Done,
     /*  349994 */   // Label 6373: @349994
     /*  349994 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(350060), // Rule ID 21345 //
     /*  349999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  350002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  350010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  350013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  350016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350038 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  350038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16),
     /*  350041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  350055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350058 */     GIR_RootConstrainSelectedInstOperands,
     /*  350059 */     // GIR_Coverage, 21345,
     /*  350059 */     GIR_EraseRootFromParent_Done,
     /*  350060 */   // Label 6374: @350060
     /*  350060 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(350126), // Rule ID 21348 //
     /*  350065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350104 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350124 */     GIR_RootConstrainSelectedInstOperands,
     /*  350125 */     // GIR_Coverage, 21348,
     /*  350125 */     GIR_EraseRootFromParent_Done,
     /*  350126 */   // Label 6375: @350126
     /*  350126 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(350192), // Rule ID 21349 //
     /*  350131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  350142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  350145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  350148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350170 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11214:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32),
     /*  350173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350190 */     GIR_RootConstrainSelectedInstOperands,
     /*  350191 */     // GIR_Coverage, 21349,
     /*  350191 */     GIR_EraseRootFromParent_Done,
     /*  350192 */   // Label 6376: @350192
     /*  350192 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(350258), // Rule ID 21352 //
     /*  350197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350236 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350256 */     GIR_RootConstrainSelectedInstOperands,
     /*  350257 */     // GIR_Coverage, 21352,
     /*  350257 */     GIR_EraseRootFromParent_Done,
     /*  350258 */   // Label 6377: @350258
     /*  350258 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(350324), // Rule ID 21353 //
     /*  350263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  350274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  350277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  350280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350302 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11214:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32),
     /*  350305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350322 */     GIR_RootConstrainSelectedInstOperands,
     /*  350323 */     // GIR_Coverage, 21353,
     /*  350323 */     GIR_EraseRootFromParent_Done,
     /*  350324 */   // Label 6378: @350324
     /*  350324 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(350390), // Rule ID 21356 //
     /*  350329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350388 */     GIR_RootConstrainSelectedInstOperands,
     /*  350389 */     // GIR_Coverage, 21356,
     /*  350389 */     GIR_EraseRootFromParent_Done,
     /*  350390 */   // Label 6379: @350390
     /*  350390 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(350456), // Rule ID 21357 //
     /*  350395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  350406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  350409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  350412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  350427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350434 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11214:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32),
     /*  350437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350454 */     GIR_RootConstrainSelectedInstOperands,
     /*  350455 */     // GIR_Coverage, 21357,
     /*  350455 */     GIR_EraseRootFromParent_Done,
     /*  350456 */   // Label 6380: @350456
     /*  350456 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(350522), // Rule ID 21360 //
     /*  350461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  350464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350500 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  350500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  350503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350520 */     GIR_RootConstrainSelectedInstOperands,
     /*  350521 */     // GIR_Coverage, 21360,
     /*  350521 */     GIR_EraseRootFromParent_Done,
     /*  350522 */   // Label 6381: @350522
     /*  350522 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(350588), // Rule ID 21361 //
     /*  350527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  350530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v),
     /*  350535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  350538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  350541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  350544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  350555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  350559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350566 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11214:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_F_F_V_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  350566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32),
     /*  350569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  350583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350586 */     GIR_RootConstrainSelectedInstOperands,
     /*  350587 */     // GIR_Coverage, 21361,
     /*  350587 */     GIR_EraseRootFromParent_Done,
     /*  350588 */   // Label 6382: @350588
     /*  350588 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(350654), // Rule ID 21604 //
     /*  350593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  350604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  350607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350632 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  350635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350652 */     GIR_RootConstrainSelectedInstOperands,
     /*  350653 */     // GIR_Coverage, 21604,
     /*  350653 */     GIR_EraseRootFromParent_Done,
     /*  350654 */   // Label 6383: @350654
     /*  350654 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(350720), // Rule ID 21605 //
     /*  350659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  350670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  350673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  350676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350698 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  350701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350718 */     GIR_RootConstrainSelectedInstOperands,
     /*  350719 */     // GIR_Coverage, 21605,
     /*  350719 */     GIR_EraseRootFromParent_Done,
     /*  350720 */   // Label 6384: @350720
     /*  350720 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(350786), // Rule ID 21608 //
     /*  350725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  350736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  350739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350764 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  350767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350784 */     GIR_RootConstrainSelectedInstOperands,
     /*  350785 */     // GIR_Coverage, 21608,
     /*  350785 */     GIR_EraseRootFromParent_Done,
     /*  350786 */   // Label 6385: @350786
     /*  350786 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(350852), // Rule ID 21609 //
     /*  350791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  350802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  350805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  350808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350830 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  350833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350850 */     GIR_RootConstrainSelectedInstOperands,
     /*  350851 */     // GIR_Coverage, 21609,
     /*  350851 */     GIR_EraseRootFromParent_Done,
     /*  350852 */   // Label 6386: @350852
     /*  350852 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(350918), // Rule ID 21612 //
     /*  350857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  350868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  350871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  350877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350896 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  350896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  350899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350916 */     GIR_RootConstrainSelectedInstOperands,
     /*  350917 */     // GIR_Coverage, 21612,
     /*  350917 */     GIR_EraseRootFromParent_Done,
     /*  350918 */   // Label 6387: @350918
     /*  350918 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(350984), // Rule ID 21613 //
     /*  350923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  350926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  350934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  350937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  350940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  350943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  350955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  350962 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  350962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  350965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  350967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  350969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  350971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  350976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  350979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  350982 */     GIR_RootConstrainSelectedInstOperands,
     /*  350983 */     // GIR_Coverage, 21613,
     /*  350983 */     GIR_EraseRootFromParent_Done,
     /*  350984 */   // Label 6388: @350984
     /*  350984 */   GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(351050), // Rule ID 21616 //
     /*  350989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  350992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  350997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351048 */     GIR_RootConstrainSelectedInstOperands,
     /*  351049 */     // GIR_Coverage, 21616,
     /*  351049 */     GIR_EraseRootFromParent_Done,
     /*  351050 */   // Label 6389: @351050
     /*  351050 */   GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(351116), // Rule ID 21617 //
     /*  351055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  351066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  351069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  351072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351094 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11164:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351114 */     GIR_RootConstrainSelectedInstOperands,
     /*  351115 */     // GIR_Coverage, 21617,
     /*  351115 */     GIR_EraseRootFromParent_Done,
     /*  351116 */   // Label 6390: @351116
     /*  351116 */   GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(351182), // Rule ID 21620 //
     /*  351121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351180 */     GIR_RootConstrainSelectedInstOperands,
     /*  351181 */     // GIR_Coverage, 21620,
     /*  351181 */     GIR_EraseRootFromParent_Done,
     /*  351182 */   // Label 6391: @351182
     /*  351182 */   GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(351248), // Rule ID 21621 //
     /*  351187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  351198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  351201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  351204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351246 */     GIR_RootConstrainSelectedInstOperands,
     /*  351247 */     // GIR_Coverage, 21621,
     /*  351247 */     GIR_EraseRootFromParent_Done,
     /*  351248 */   // Label 6392: @351248
     /*  351248 */   GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(351314), // Rule ID 21624 //
     /*  351253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  351256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351292 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  351292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351312 */     GIR_RootConstrainSelectedInstOperands,
     /*  351313 */     // GIR_Coverage, 21624,
     /*  351313 */     GIR_EraseRootFromParent_Done,
     /*  351314 */   // Label 6393: @351314
     /*  351314 */   GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(351380), // Rule ID 21625 //
     /*  351319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  351322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  351330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  351333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  351336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  351358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  351375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351378 */     GIR_RootConstrainSelectedInstOperands,
     /*  351379 */     // GIR_Coverage, 21625,
     /*  351379 */     GIR_EraseRootFromParent_Done,
     /*  351380 */   // Label 6394: @351380
     /*  351380 */   GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(351446), // Rule ID 21628 //
     /*  351385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351424 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351444 */     GIR_RootConstrainSelectedInstOperands,
     /*  351445 */     // GIR_Coverage, 21628,
     /*  351445 */     GIR_EraseRootFromParent_Done,
     /*  351446 */   // Label 6395: @351446
     /*  351446 */   GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(351512), // Rule ID 21629 //
     /*  351451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  351462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  351465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  351468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351490 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  351493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351510 */     GIR_RootConstrainSelectedInstOperands,
     /*  351511 */     // GIR_Coverage, 21629,
     /*  351511 */     GIR_EraseRootFromParent_Done,
     /*  351512 */   // Label 6396: @351512
     /*  351512 */   GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(351578), // Rule ID 21632 //
     /*  351517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351576 */     GIR_RootConstrainSelectedInstOperands,
     /*  351577 */     // GIR_Coverage, 21632,
     /*  351577 */     GIR_EraseRootFromParent_Done,
     /*  351578 */   // Label 6397: @351578
     /*  351578 */   GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(351644), // Rule ID 21633 //
     /*  351583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  351594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  351597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  351600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351622 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  351625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351642 */     GIR_RootConstrainSelectedInstOperands,
     /*  351643 */     // GIR_Coverage, 21633,
     /*  351643 */     GIR_EraseRootFromParent_Done,
     /*  351644 */   // Label 6398: @351644
     /*  351644 */   GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(351710), // Rule ID 21636 //
     /*  351649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  351660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  351663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351708 */     GIR_RootConstrainSelectedInstOperands,
     /*  351709 */     // GIR_Coverage, 21636,
     /*  351709 */     GIR_EraseRootFromParent_Done,
     /*  351710 */   // Label 6399: @351710
     /*  351710 */   GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(351776), // Rule ID 21637 //
     /*  351715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  351726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  351729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  351732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  351743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11164:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  351757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351774 */     GIR_RootConstrainSelectedInstOperands,
     /*  351775 */     // GIR_Coverage, 21637,
     /*  351775 */     GIR_EraseRootFromParent_Done,
     /*  351776 */   // Label 6400: @351776
     /*  351776 */   GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(351842), // Rule ID 21640 //
     /*  351781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  351792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  351795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351820 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351840 */     GIR_RootConstrainSelectedInstOperands,
     /*  351841 */     // GIR_Coverage, 21640,
     /*  351841 */     GIR_EraseRootFromParent_Done,
     /*  351842 */   // Label 6401: @351842
     /*  351842 */   GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(351908), // Rule ID 21641 //
     /*  351847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  351858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  351861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  351864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  351875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  351886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  351889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351906 */     GIR_RootConstrainSelectedInstOperands,
     /*  351907 */     // GIR_Coverage, 21641,
     /*  351907 */     GIR_EraseRootFromParent_Done,
     /*  351908 */   // Label 6402: @351908
     /*  351908 */   GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(351974), // Rule ID 21644 //
     /*  351913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  351916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  351924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  351927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  351930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  351933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  351941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  351945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  351952 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  351952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  351955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  351957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  351959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  351961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  351966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  351969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  351972 */     GIR_RootConstrainSelectedInstOperands,
     /*  351973 */     // GIR_Coverage, 21644,
     /*  351973 */     GIR_EraseRootFromParent_Done,
     /*  351974 */   // Label 6403: @351974
     /*  351974 */   GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(352040), // Rule ID 21645 //
     /*  351979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  351982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  351987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  351990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  351993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  351996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  351999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  352018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  352035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352038 */     GIR_RootConstrainSelectedInstOperands,
     /*  352039 */     // GIR_Coverage, 21645,
     /*  352039 */     GIR_EraseRootFromParent_Done,
     /*  352040 */   // Label 6404: @352040
     /*  352040 */   GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(352106), // Rule ID 21648 //
     /*  352045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352084 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352104 */     GIR_RootConstrainSelectedInstOperands,
     /*  352105 */     // GIR_Coverage, 21648,
     /*  352105 */     GIR_EraseRootFromParent_Done,
     /*  352106 */   // Label 6405: @352106
     /*  352106 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(352172), // Rule ID 21649 //
     /*  352111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  352122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  352125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  352128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352150 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  352153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352170 */     GIR_RootConstrainSelectedInstOperands,
     /*  352171 */     // GIR_Coverage, 21649,
     /*  352171 */     GIR_EraseRootFromParent_Done,
     /*  352172 */   // Label 6406: @352172
     /*  352172 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(352238), // Rule ID 21652 //
     /*  352177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352236 */     GIR_RootConstrainSelectedInstOperands,
     /*  352237 */     // GIR_Coverage, 21652,
     /*  352237 */     GIR_EraseRootFromParent_Done,
     /*  352238 */   // Label 6407: @352238
     /*  352238 */   GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(352304), // Rule ID 21653 //
     /*  352243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  352254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  352257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  352260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352282 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11164:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  352285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352302 */     GIR_RootConstrainSelectedInstOperands,
     /*  352303 */     // GIR_Coverage, 21653,
     /*  352303 */     GIR_EraseRootFromParent_Done,
     /*  352304 */   // Label 6408: @352304
     /*  352304 */   GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(352370), // Rule ID 21656 //
     /*  352309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352368 */     GIR_RootConstrainSelectedInstOperands,
     /*  352369 */     // GIR_Coverage, 21656,
     /*  352369 */     GIR_EraseRootFromParent_Done,
     /*  352370 */   // Label 6409: @352370
     /*  352370 */   GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(352436), // Rule ID 21657 //
     /*  352375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  352386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  352389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  352392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  352403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11164:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  352417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352434 */     GIR_RootConstrainSelectedInstOperands,
     /*  352435 */     // GIR_Coverage, 21657,
     /*  352435 */     GIR_EraseRootFromParent_Done,
     /*  352436 */   // Label 6410: @352436
     /*  352436 */   GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(352502), // Rule ID 21660 //
     /*  352441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  352444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  352458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352480 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  352480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352500 */     GIR_RootConstrainSelectedInstOperands,
     /*  352501 */     // GIR_Coverage, 21660,
     /*  352501 */     GIR_EraseRootFromParent_Done,
     /*  352502 */   // Label 6411: @352502
     /*  352502 */   GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(352568), // Rule ID 21661 //
     /*  352507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  352510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w),
     /*  352515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  352518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  352521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  352524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  352535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  352539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11164:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  352546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  352549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  352563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352566 */     GIR_RootConstrainSelectedInstOperands,
     /*  352567 */     // GIR_Coverage, 21661,
     /*  352567 */     GIR_EraseRootFromParent_Done,
     /*  352568 */   // Label 6412: @352568
     /*  352568 */   GIM_Try, /*On fail goto*//*Label 6413*/ GIMT_Encode4(352634), // Rule ID 21664 //
     /*  352573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  352584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  352587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352612 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  352615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352632 */     GIR_RootConstrainSelectedInstOperands,
     /*  352633 */     // GIR_Coverage, 21664,
     /*  352633 */     GIR_EraseRootFromParent_Done,
     /*  352634 */   // Label 6413: @352634
     /*  352634 */   GIM_Try, /*On fail goto*//*Label 6414*/ GIMT_Encode4(352700), // Rule ID 21665 //
     /*  352639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  352650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  352653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  352656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352678 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  352681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352698 */     GIR_RootConstrainSelectedInstOperands,
     /*  352699 */     // GIR_Coverage, 21665,
     /*  352699 */     GIR_EraseRootFromParent_Done,
     /*  352700 */   // Label 6414: @352700
     /*  352700 */   GIM_Try, /*On fail goto*//*Label 6415*/ GIMT_Encode4(352766), // Rule ID 21668 //
     /*  352705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  352716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  352719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  352747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352764 */     GIR_RootConstrainSelectedInstOperands,
     /*  352765 */     // GIR_Coverage, 21668,
     /*  352765 */     GIR_EraseRootFromParent_Done,
     /*  352766 */   // Label 6415: @352766
     /*  352766 */   GIM_Try, /*On fail goto*//*Label 6416*/ GIMT_Encode4(352832), // Rule ID 21669 //
     /*  352771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  352782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  352785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  352788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352810 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  352813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352830 */     GIR_RootConstrainSelectedInstOperands,
     /*  352831 */     // GIR_Coverage, 21669,
     /*  352831 */     GIR_EraseRootFromParent_Done,
     /*  352832 */   // Label 6416: @352832
     /*  352832 */   GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(352898), // Rule ID 21672 //
     /*  352837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  352848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  352851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352876 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  352876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  352879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352896 */     GIR_RootConstrainSelectedInstOperands,
     /*  352897 */     // GIR_Coverage, 21672,
     /*  352897 */     GIR_EraseRootFromParent_Done,
     /*  352898 */   // Label 6417: @352898
     /*  352898 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(352964), // Rule ID 21673 //
     /*  352903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  352906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  352914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  352917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  352920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  352923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  352942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  352942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  352945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  352947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  352949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  352951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  352956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  352959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  352962 */     GIR_RootConstrainSelectedInstOperands,
     /*  352963 */     // GIR_Coverage, 21673,
     /*  352963 */     GIR_EraseRootFromParent_Done,
     /*  352964 */   // Label 6418: @352964
     /*  352964 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(353030), // Rule ID 21676 //
     /*  352969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  352972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  352977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  352980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  352983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  352986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  352989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  352997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353028 */     GIR_RootConstrainSelectedInstOperands,
     /*  353029 */     // GIR_Coverage, 21676,
     /*  353029 */     GIR_EraseRootFromParent_Done,
     /*  353030 */   // Label 6419: @353030
     /*  353030 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(353096), // Rule ID 21677 //
     /*  353035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  353046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  353049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  353052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11162:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353094 */     GIR_RootConstrainSelectedInstOperands,
     /*  353095 */     // GIR_Coverage, 21677,
     /*  353095 */     GIR_EraseRootFromParent_Done,
     /*  353096 */   // Label 6420: @353096
     /*  353096 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(353162), // Rule ID 21680 //
     /*  353101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353160 */     GIR_RootConstrainSelectedInstOperands,
     /*  353161 */     // GIR_Coverage, 21680,
     /*  353161 */     GIR_EraseRootFromParent_Done,
     /*  353162 */   // Label 6421: @353162
     /*  353162 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(353228), // Rule ID 21681 //
     /*  353167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  353178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  353181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  353184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353226 */     GIR_RootConstrainSelectedInstOperands,
     /*  353227 */     // GIR_Coverage, 21681,
     /*  353227 */     GIR_EraseRootFromParent_Done,
     /*  353228 */   // Label 6422: @353228
     /*  353228 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(353294), // Rule ID 21684 //
     /*  353233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  353236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  353272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353292 */     GIR_RootConstrainSelectedInstOperands,
     /*  353293 */     // GIR_Coverage, 21684,
     /*  353293 */     GIR_EraseRootFromParent_Done,
     /*  353294 */   // Label 6423: @353294
     /*  353294 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(353360), // Rule ID 21685 //
     /*  353299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  353302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  353310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  353313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  353316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353338 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  353338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  353355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353358 */     GIR_RootConstrainSelectedInstOperands,
     /*  353359 */     // GIR_Coverage, 21685,
     /*  353359 */     GIR_EraseRootFromParent_Done,
     /*  353360 */   // Label 6424: @353360
     /*  353360 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(353426), // Rule ID 21688 //
     /*  353365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353404 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353424 */     GIR_RootConstrainSelectedInstOperands,
     /*  353425 */     // GIR_Coverage, 21688,
     /*  353425 */     GIR_EraseRootFromParent_Done,
     /*  353426 */   // Label 6425: @353426
     /*  353426 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(353492), // Rule ID 21689 //
     /*  353431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  353442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  353445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  353448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353470 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  353473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353490 */     GIR_RootConstrainSelectedInstOperands,
     /*  353491 */     // GIR_Coverage, 21689,
     /*  353491 */     GIR_EraseRootFromParent_Done,
     /*  353492 */   // Label 6426: @353492
     /*  353492 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(353558), // Rule ID 21692 //
     /*  353497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  353508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  353511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353536 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353556 */     GIR_RootConstrainSelectedInstOperands,
     /*  353557 */     // GIR_Coverage, 21692,
     /*  353557 */     GIR_EraseRootFromParent_Done,
     /*  353558 */   // Label 6427: @353558
     /*  353558 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(353624), // Rule ID 21693 //
     /*  353563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  353574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  353577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  353580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353602 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  353605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353622 */     GIR_RootConstrainSelectedInstOperands,
     /*  353623 */     // GIR_Coverage, 21693,
     /*  353623 */     GIR_EraseRootFromParent_Done,
     /*  353624 */   // Label 6428: @353624
     /*  353624 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(353690), // Rule ID 21696 //
     /*  353629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  353640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  353643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353688 */     GIR_RootConstrainSelectedInstOperands,
     /*  353689 */     // GIR_Coverage, 21696,
     /*  353689 */     GIR_EraseRootFromParent_Done,
     /*  353690 */   // Label 6429: @353690
     /*  353690 */   GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(353756), // Rule ID 21697 //
     /*  353695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  353706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  353709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  353712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  353723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11162:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  353737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353754 */     GIR_RootConstrainSelectedInstOperands,
     /*  353755 */     // GIR_Coverage, 21697,
     /*  353755 */     GIR_EraseRootFromParent_Done,
     /*  353756 */   // Label 6430: @353756
     /*  353756 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(353822), // Rule ID 21700 //
     /*  353761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  353772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  353775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353820 */     GIR_RootConstrainSelectedInstOperands,
     /*  353821 */     // GIR_Coverage, 21700,
     /*  353821 */     GIR_EraseRootFromParent_Done,
     /*  353822 */   // Label 6431: @353822
     /*  353822 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(353888), // Rule ID 21701 //
     /*  353827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  353838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  353841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  353844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  353855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  353869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353886 */     GIR_RootConstrainSelectedInstOperands,
     /*  353887 */     // GIR_Coverage, 21701,
     /*  353887 */     GIR_EraseRootFromParent_Done,
     /*  353888 */   // Label 6432: @353888
     /*  353888 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(353954), // Rule ID 21704 //
     /*  353893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  353896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  353904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  353907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  353910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  353913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  353932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  353935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  353937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  353939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  353941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  353946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  353949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  353952 */     GIR_RootConstrainSelectedInstOperands,
     /*  353953 */     // GIR_Coverage, 21704,
     /*  353953 */     GIR_EraseRootFromParent_Done,
     /*  353954 */   // Label 6433: @353954
     /*  353954 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(354020), // Rule ID 21705 //
     /*  353959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  353962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  353967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  353970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  353973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  353976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  353979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  353987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  353991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  353998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  353998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354018 */     GIR_RootConstrainSelectedInstOperands,
     /*  354019 */     // GIR_Coverage, 21705,
     /*  354019 */     GIR_EraseRootFromParent_Done,
     /*  354020 */   // Label 6434: @354020
     /*  354020 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(354086), // Rule ID 21708 //
     /*  354025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354084 */     GIR_RootConstrainSelectedInstOperands,
     /*  354085 */     // GIR_Coverage, 21708,
     /*  354085 */     GIR_EraseRootFromParent_Done,
     /*  354086 */   // Label 6435: @354086
     /*  354086 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(354152), // Rule ID 21709 //
     /*  354091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  354102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  354105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  354108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  354133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354150 */     GIR_RootConstrainSelectedInstOperands,
     /*  354151 */     // GIR_Coverage, 21709,
     /*  354151 */     GIR_EraseRootFromParent_Done,
     /*  354152 */   // Label 6436: @354152
     /*  354152 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(354218), // Rule ID 21712 //
     /*  354157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354216 */     GIR_RootConstrainSelectedInstOperands,
     /*  354217 */     // GIR_Coverage, 21712,
     /*  354217 */     GIR_EraseRootFromParent_Done,
     /*  354218 */   // Label 6437: @354218
     /*  354218 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(354284), // Rule ID 21713 //
     /*  354223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  354234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  354237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  354240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354262 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11162:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  354265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354282 */     GIR_RootConstrainSelectedInstOperands,
     /*  354283 */     // GIR_Coverage, 21713,
     /*  354283 */     GIR_EraseRootFromParent_Done,
     /*  354284 */   // Label 6438: @354284
     /*  354284 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(354350), // Rule ID 21716 //
     /*  354289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354348 */     GIR_RootConstrainSelectedInstOperands,
     /*  354349 */     // GIR_Coverage, 21716,
     /*  354349 */     GIR_EraseRootFromParent_Done,
     /*  354350 */   // Label 6439: @354350
     /*  354350 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(354416), // Rule ID 21717 //
     /*  354355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  354366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  354369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  354372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11162:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  354397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354414 */     GIR_RootConstrainSelectedInstOperands,
     /*  354415 */     // GIR_Coverage, 21717,
     /*  354415 */     GIR_EraseRootFromParent_Done,
     /*  354416 */   // Label 6440: @354416
     /*  354416 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(354482), // Rule ID 21720 //
     /*  354421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  354424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  354460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354480 */     GIR_RootConstrainSelectedInstOperands,
     /*  354481 */     // GIR_Coverage, 21720,
     /*  354481 */     GIR_EraseRootFromParent_Done,
     /*  354482 */   // Label 6441: @354482
     /*  354482 */   GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(354548), // Rule ID 21721 //
     /*  354487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  354490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w),
     /*  354495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  354498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  354501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  354504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  354519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11162:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  354526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  354529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  354543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354546 */     GIR_RootConstrainSelectedInstOperands,
     /*  354547 */     // GIR_Coverage, 21721,
     /*  354547 */     GIR_EraseRootFromParent_Done,
     /*  354548 */   // Label 6442: @354548
     /*  354548 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(354614), // Rule ID 21832 //
     /*  354553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  354556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354592 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  354595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354612 */     GIR_RootConstrainSelectedInstOperands,
     /*  354613 */     // GIR_Coverage, 21832,
     /*  354613 */     GIR_EraseRootFromParent_Done,
     /*  354614 */   // Label 6443: @354614
     /*  354614 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(354680), // Rule ID 21833 //
     /*  354619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  354622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  354630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  354633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  354636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354658 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16),
     /*  354661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354678 */     GIR_RootConstrainSelectedInstOperands,
     /*  354679 */     // GIR_Coverage, 21833,
     /*  354679 */     GIR_EraseRootFromParent_Done,
     /*  354680 */   // Label 6444: @354680
     /*  354680 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(354746), // Rule ID 21836 //
     /*  354685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  354688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354724 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  354727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354744 */     GIR_RootConstrainSelectedInstOperands,
     /*  354745 */     // GIR_Coverage, 21836,
     /*  354745 */     GIR_EraseRootFromParent_Done,
     /*  354746 */   // Label 6445: @354746
     /*  354746 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(354812), // Rule ID 21837 //
     /*  354751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  354754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  354762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  354765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  354768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354790 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16),
     /*  354793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354810 */     GIR_RootConstrainSelectedInstOperands,
     /*  354811 */     // GIR_Coverage, 21837,
     /*  354811 */     GIR_EraseRootFromParent_Done,
     /*  354812 */   // Label 6446: @354812
     /*  354812 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(354878), // Rule ID 21840 //
     /*  354817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  354820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354856 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  354859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354876 */     GIR_RootConstrainSelectedInstOperands,
     /*  354877 */     // GIR_Coverage, 21840,
     /*  354877 */     GIR_EraseRootFromParent_Done,
     /*  354878 */   // Label 6447: @354878
     /*  354878 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(354944), // Rule ID 21841 //
     /*  354883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  354886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  354894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  354897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  354900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  354903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  354911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354922 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11160:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  354922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16),
     /*  354925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  354936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  354939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  354942 */     GIR_RootConstrainSelectedInstOperands,
     /*  354943 */     // GIR_Coverage, 21841,
     /*  354943 */     GIR_EraseRootFromParent_Done,
     /*  354944 */   // Label 6448: @354944
     /*  354944 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(355010), // Rule ID 21844 //
     /*  354949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  354952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  354957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  354960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  354963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  354966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  354969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  354977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  354981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  354988 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  354988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  354991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  354993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  354995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  354997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355008 */     GIR_RootConstrainSelectedInstOperands,
     /*  355009 */     // GIR_Coverage, 21844,
     /*  355009 */     GIR_EraseRootFromParent_Done,
     /*  355010 */   // Label 6449: @355010
     /*  355010 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(355076), // Rule ID 21845 //
     /*  355015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  355026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  355029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  355032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355054 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16),
     /*  355057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355074 */     GIR_RootConstrainSelectedInstOperands,
     /*  355075 */     // GIR_Coverage, 21845,
     /*  355075 */     GIR_EraseRootFromParent_Done,
     /*  355076 */   // Label 6450: @355076
     /*  355076 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(355142), // Rule ID 21848 //
     /*  355081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  355084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355120 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  355120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355140 */     GIR_RootConstrainSelectedInstOperands,
     /*  355141 */     // GIR_Coverage, 21848,
     /*  355141 */     GIR_EraseRootFromParent_Done,
     /*  355142 */   // Label 6451: @355142
     /*  355142 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(355208), // Rule ID 21849 //
     /*  355147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  355150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  355158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  355161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  355164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355186 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  355186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16),
     /*  355189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  355203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355206 */     GIR_RootConstrainSelectedInstOperands,
     /*  355207 */     // GIR_Coverage, 21849,
     /*  355207 */     GIR_EraseRootFromParent_Done,
     /*  355208 */   // Label 6452: @355208
     /*  355208 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(355274), // Rule ID 21852 //
     /*  355213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355252 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355272 */     GIR_RootConstrainSelectedInstOperands,
     /*  355273 */     // GIR_Coverage, 21852,
     /*  355273 */     GIR_EraseRootFromParent_Done,
     /*  355274 */   // Label 6453: @355274
     /*  355274 */   GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(355340), // Rule ID 21853 //
     /*  355279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  355290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  355293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  355296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355318 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32),
     /*  355321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355338 */     GIR_RootConstrainSelectedInstOperands,
     /*  355339 */     // GIR_Coverage, 21853,
     /*  355339 */     GIR_EraseRootFromParent_Done,
     /*  355340 */   // Label 6454: @355340
     /*  355340 */   GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(355406), // Rule ID 21856 //
     /*  355345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355404 */     GIR_RootConstrainSelectedInstOperands,
     /*  355405 */     // GIR_Coverage, 21856,
     /*  355405 */     GIR_EraseRootFromParent_Done,
     /*  355406 */   // Label 6455: @355406
     /*  355406 */   GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(355472), // Rule ID 21857 //
     /*  355411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  355422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  355425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  355428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355450 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11160:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32),
     /*  355453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355470 */     GIR_RootConstrainSelectedInstOperands,
     /*  355471 */     // GIR_Coverage, 21857,
     /*  355471 */     GIR_EraseRootFromParent_Done,
     /*  355472 */   // Label 6456: @355472
     /*  355472 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(355538), // Rule ID 21860 //
     /*  355477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355516 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  355519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355536 */     GIR_RootConstrainSelectedInstOperands,
     /*  355537 */     // GIR_Coverage, 21860,
     /*  355537 */     GIR_EraseRootFromParent_Done,
     /*  355538 */   // Label 6457: @355538
     /*  355538 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(355604), // Rule ID 21861 //
     /*  355543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  355554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  355557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  355560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  355571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355582 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11160:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32),
     /*  355585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355602 */     GIR_RootConstrainSelectedInstOperands,
     /*  355603 */     // GIR_Coverage, 21861,
     /*  355603 */     GIR_EraseRootFromParent_Done,
     /*  355604 */   // Label 6458: @355604
     /*  355604 */   GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(355670), // Rule ID 21864 //
     /*  355609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  355612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355648 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  355648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  355651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355668 */     GIR_RootConstrainSelectedInstOperands,
     /*  355669 */     // GIR_Coverage, 21864,
     /*  355669 */     GIR_EraseRootFromParent_Done,
     /*  355670 */   // Label 6459: @355670
     /*  355670 */   GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(355736), // Rule ID 21865 //
     /*  355675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  355678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w),
     /*  355683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  355686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  355689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  355692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  355703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  355707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355714 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11160:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  355714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32),
     /*  355717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  355721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  355731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355734 */     GIR_RootConstrainSelectedInstOperands,
     /*  355735 */     // GIR_Coverage, 21865,
     /*  355735 */     GIR_EraseRootFromParent_Done,
     /*  355736 */   // Label 6460: @355736
     /*  355736 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(355799), // Rule ID 23036 //
     /*  355741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  355749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  355752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  355755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  355758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  355780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  355783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  355787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355797 */     GIR_RootConstrainSelectedInstOperands,
     /*  355798 */     // GIR_Coverage, 23036,
     /*  355798 */     GIR_EraseRootFromParent_Done,
     /*  355799 */   // Label 6461: @355799
     /*  355799 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(355862), // Rule ID 23037 //
     /*  355804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  355812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  355815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  355818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  355821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355843 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  355843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B32),
     /*  355846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  355850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355860 */     GIR_RootConstrainSelectedInstOperands,
     /*  355861 */     // GIR_Coverage, 23037,
     /*  355861 */     GIR_EraseRootFromParent_Done,
     /*  355862 */   // Label 6462: @355862
     /*  355862 */   GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(355925), // Rule ID 23038 //
     /*  355867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  355875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  355878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  355881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  355884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  355887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355906 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  355906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  355909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  355913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355923 */     GIR_RootConstrainSelectedInstOperands,
     /*  355924 */     // GIR_Coverage, 23038,
     /*  355924 */     GIR_EraseRootFromParent_Done,
     /*  355925 */   // Label 6463: @355925
     /*  355925 */   GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(355988), // Rule ID 23039 //
     /*  355930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  355933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  355938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  355941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  355944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  355947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  355950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  355962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  355969 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  355969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B16),
     /*  355972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  355974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  355976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  355978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  355983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  355986 */     GIR_RootConstrainSelectedInstOperands,
     /*  355987 */     // GIR_Coverage, 23039,
     /*  355987 */     GIR_EraseRootFromParent_Done,
     /*  355988 */   // Label 6464: @355988
     /*  355988 */   GIM_Try, /*On fail goto*//*Label 6465*/ GIMT_Encode4(356051), // Rule ID 23040 //
     /*  355993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  355996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356049 */     GIR_RootConstrainSelectedInstOperands,
     /*  356050 */     // GIR_Coverage, 23040,
     /*  356050 */     GIR_EraseRootFromParent_Done,
     /*  356051 */   // Label 6465: @356051
     /*  356051 */   GIM_Try, /*On fail goto*//*Label 6466*/ GIMT_Encode4(356114), // Rule ID 23041 //
     /*  356056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356095 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B8),
     /*  356098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356112 */     GIR_RootConstrainSelectedInstOperands,
     /*  356113 */     // GIR_Coverage, 23041,
     /*  356113 */     GIR_EraseRootFromParent_Done,
     /*  356114 */   // Label 6466: @356114
     /*  356114 */   GIM_Try, /*On fail goto*//*Label 6467*/ GIMT_Encode4(356177), // Rule ID 23042 //
     /*  356119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356175 */     GIR_RootConstrainSelectedInstOperands,
     /*  356176 */     // GIR_Coverage, 23042,
     /*  356176 */     GIR_EraseRootFromParent_Done,
     /*  356177 */   // Label 6467: @356177
     /*  356177 */   GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(356240), // Rule ID 23043 //
     /*  356182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  356193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  356196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  356199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356221 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B4),
     /*  356224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356238 */     GIR_RootConstrainSelectedInstOperands,
     /*  356239 */     // GIR_Coverage, 23043,
     /*  356239 */     GIR_EraseRootFromParent_Done,
     /*  356240 */   // Label 6468: @356240
     /*  356240 */   GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(356303), // Rule ID 23044 //
     /*  356245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356284 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356301 */     GIR_RootConstrainSelectedInstOperands,
     /*  356302 */     // GIR_Coverage, 23044,
     /*  356302 */     GIR_EraseRootFromParent_Done,
     /*  356303 */   // Label 6469: @356303
     /*  356303 */   GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(356366), // Rule ID 23045 //
     /*  356308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  356319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  356322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  356325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356347 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B2),
     /*  356350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356364 */     GIR_RootConstrainSelectedInstOperands,
     /*  356365 */     // GIR_Coverage, 23045,
     /*  356365 */     GIR_EraseRootFromParent_Done,
     /*  356366 */   // Label 6470: @356366
     /*  356366 */   GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(356429), // Rule ID 23046 //
     /*  356371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356410 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356427 */     GIR_RootConstrainSelectedInstOperands,
     /*  356428 */     // GIR_Coverage, 23046,
     /*  356428 */     GIR_EraseRootFromParent_Done,
     /*  356429 */   // Label 6471: @356429
     /*  356429 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(356492), // Rule ID 23047 //
     /*  356434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmand),
     /*  356442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  356445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  356448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  356451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356473 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11343:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAND_MM_B1),
     /*  356476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356490 */     GIR_RootConstrainSelectedInstOperands,
     /*  356491 */     // GIR_Coverage, 23047,
     /*  356491 */     GIR_EraseRootFromParent_Done,
     /*  356492 */   // Label 6472: @356492
     /*  356492 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(356555), // Rule ID 23048 //
     /*  356497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  356508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  356511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  356514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  356539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356553 */     GIR_RootConstrainSelectedInstOperands,
     /*  356554 */     // GIR_Coverage, 23048,
     /*  356554 */     GIR_EraseRootFromParent_Done,
     /*  356555 */   // Label 6473: @356555
     /*  356555 */   GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(356618), // Rule ID 23049 //
     /*  356560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  356571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  356574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  356577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356599 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B64),
     /*  356602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356616 */     GIR_RootConstrainSelectedInstOperands,
     /*  356617 */     // GIR_Coverage, 23049,
     /*  356617 */     GIR_EraseRootFromParent_Done,
     /*  356618 */   // Label 6474: @356618
     /*  356618 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(356681), // Rule ID 23050 //
     /*  356623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  356665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356679 */     GIR_RootConstrainSelectedInstOperands,
     /*  356680 */     // GIR_Coverage, 23050,
     /*  356680 */     GIR_EraseRootFromParent_Done,
     /*  356681 */   // Label 6475: @356681
     /*  356681 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(356744), // Rule ID 23051 //
     /*  356686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  356697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  356700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  356703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356725 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B32),
     /*  356728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356742 */     GIR_RootConstrainSelectedInstOperands,
     /*  356743 */     // GIR_Coverage, 23051,
     /*  356743 */     GIR_EraseRootFromParent_Done,
     /*  356744 */   // Label 6476: @356744
     /*  356744 */   GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(356807), // Rule ID 23052 //
     /*  356749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  356791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356805 */     GIR_RootConstrainSelectedInstOperands,
     /*  356806 */     // GIR_Coverage, 23052,
     /*  356806 */     GIR_EraseRootFromParent_Done,
     /*  356807 */   // Label 6477: @356807
     /*  356807 */   GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(356870), // Rule ID 23053 //
     /*  356812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  356823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  356826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  356829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356851 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B16),
     /*  356854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356868 */     GIR_RootConstrainSelectedInstOperands,
     /*  356869 */     // GIR_Coverage, 23053,
     /*  356869 */     GIR_EraseRootFromParent_Done,
     /*  356870 */   // Label 6478: @356870
     /*  356870 */   GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(356933), // Rule ID 23054 //
     /*  356875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  356878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  356895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356914 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  356914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  356917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356931 */     GIR_RootConstrainSelectedInstOperands,
     /*  356932 */     // GIR_Coverage, 23054,
     /*  356932 */     GIR_EraseRootFromParent_Done,
     /*  356933 */   // Label 6479: @356933
     /*  356933 */   GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(356996), // Rule ID 23055 //
     /*  356938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  356941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  356946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  356949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  356952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  356955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  356958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  356970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  356977 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  356977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B8),
     /*  356980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  356982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  356984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  356986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  356991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  356994 */     GIR_RootConstrainSelectedInstOperands,
     /*  356995 */     // GIR_Coverage, 23055,
     /*  356995 */     GIR_EraseRootFromParent_Done,
     /*  356996 */   // Label 6480: @356996
     /*  356996 */   GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(357059), // Rule ID 23056 //
     /*  357001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357057 */     GIR_RootConstrainSelectedInstOperands,
     /*  357058 */     // GIR_Coverage, 23056,
     /*  357058 */     GIR_EraseRootFromParent_Done,
     /*  357059 */   // Label 6481: @357059
     /*  357059 */   GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(357122), // Rule ID 23057 //
     /*  357064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357103 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B4),
     /*  357106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357120 */     GIR_RootConstrainSelectedInstOperands,
     /*  357121 */     // GIR_Coverage, 23057,
     /*  357121 */     GIR_EraseRootFromParent_Done,
     /*  357122 */   // Label 6482: @357122
     /*  357122 */   GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(357185), // Rule ID 23058 //
     /*  357127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357183 */     GIR_RootConstrainSelectedInstOperands,
     /*  357184 */     // GIR_Coverage, 23058,
     /*  357184 */     GIR_EraseRootFromParent_Done,
     /*  357185 */   // Label 6483: @357185
     /*  357185 */   GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(357248), // Rule ID 23059 //
     /*  357190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  357201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  357204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  357207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357229 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B2),
     /*  357232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357246 */     GIR_RootConstrainSelectedInstOperands,
     /*  357247 */     // GIR_Coverage, 23059,
     /*  357247 */     GIR_EraseRootFromParent_Done,
     /*  357248 */   // Label 6484: @357248
     /*  357248 */   GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(357311), // Rule ID 23060 //
     /*  357253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357292 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357309 */     GIR_RootConstrainSelectedInstOperands,
     /*  357310 */     // GIR_Coverage, 23060,
     /*  357310 */     GIR_EraseRootFromParent_Done,
     /*  357311 */   // Label 6485: @357311
     /*  357311 */   GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(357374), // Rule ID 23061 //
     /*  357316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnand),
     /*  357324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  357327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  357330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  357333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357355 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11367:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNAND_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNAND_MM_B1),
     /*  357358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357372 */     GIR_RootConstrainSelectedInstOperands,
     /*  357373 */     // GIR_Coverage, 23061,
     /*  357373 */     GIR_EraseRootFromParent_Done,
     /*  357374 */   // Label 6486: @357374
     /*  357374 */   GIM_Try, /*On fail goto*//*Label 6487*/ GIMT_Encode4(357437), // Rule ID 23062 //
     /*  357379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357418 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  357421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357435 */     GIR_RootConstrainSelectedInstOperands,
     /*  357436 */     // GIR_Coverage, 23062,
     /*  357436 */     GIR_EraseRootFromParent_Done,
     /*  357437 */   // Label 6487: @357437
     /*  357437 */   GIM_Try, /*On fail goto*//*Label 6488*/ GIMT_Encode4(357500), // Rule ID 23063 //
     /*  357442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  357453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  357456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  357459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357481 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B64),
     /*  357484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357498 */     GIR_RootConstrainSelectedInstOperands,
     /*  357499 */     // GIR_Coverage, 23063,
     /*  357499 */     GIR_EraseRootFromParent_Done,
     /*  357500 */   // Label 6488: @357500
     /*  357500 */   GIM_Try, /*On fail goto*//*Label 6489*/ GIMT_Encode4(357563), // Rule ID 23064 //
     /*  357505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  357547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357561 */     GIR_RootConstrainSelectedInstOperands,
     /*  357562 */     // GIR_Coverage, 23064,
     /*  357562 */     GIR_EraseRootFromParent_Done,
     /*  357563 */   // Label 6489: @357563
     /*  357563 */   GIM_Try, /*On fail goto*//*Label 6490*/ GIMT_Encode4(357626), // Rule ID 23065 //
     /*  357568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  357579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  357582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  357585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357607 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B32),
     /*  357610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357624 */     GIR_RootConstrainSelectedInstOperands,
     /*  357625 */     // GIR_Coverage, 23065,
     /*  357625 */     GIR_EraseRootFromParent_Done,
     /*  357626 */   // Label 6490: @357626
     /*  357626 */   GIM_Try, /*On fail goto*//*Label 6491*/ GIMT_Encode4(357689), // Rule ID 23066 //
     /*  357631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357670 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  357673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357687 */     GIR_RootConstrainSelectedInstOperands,
     /*  357688 */     // GIR_Coverage, 23066,
     /*  357688 */     GIR_EraseRootFromParent_Done,
     /*  357689 */   // Label 6491: @357689
     /*  357689 */   GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(357752), // Rule ID 23067 //
     /*  357694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  357705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  357708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  357711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357733 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B16),
     /*  357736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357750 */     GIR_RootConstrainSelectedInstOperands,
     /*  357751 */     // GIR_Coverage, 23067,
     /*  357751 */     GIR_EraseRootFromParent_Done,
     /*  357752 */   // Label 6492: @357752
     /*  357752 */   GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(357815), // Rule ID 23068 //
     /*  357757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  357799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357813 */     GIR_RootConstrainSelectedInstOperands,
     /*  357814 */     // GIR_Coverage, 23068,
     /*  357814 */     GIR_EraseRootFromParent_Done,
     /*  357815 */   // Label 6493: @357815
     /*  357815 */   GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(357878), // Rule ID 23069 //
     /*  357820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  357831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  357834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  357837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357859 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B8),
     /*  357862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357876 */     GIR_RootConstrainSelectedInstOperands,
     /*  357877 */     // GIR_Coverage, 23069,
     /*  357877 */     GIR_EraseRootFromParent_Done,
     /*  357878 */   // Label 6494: @357878
     /*  357878 */   GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(357941), // Rule ID 23070 //
     /*  357883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  357886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  357903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357922 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  357922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  357925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  357939 */     GIR_RootConstrainSelectedInstOperands,
     /*  357940 */     // GIR_Coverage, 23070,
     /*  357940 */     GIR_EraseRootFromParent_Done,
     /*  357941 */   // Label 6495: @357941
     /*  357941 */   GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(358004), // Rule ID 23071 //
     /*  357946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  357949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  357954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  357957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  357960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  357963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  357966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  357978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  357985 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  357985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B4),
     /*  357988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  357990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  357992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  357994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  357999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358002 */     GIR_RootConstrainSelectedInstOperands,
     /*  358003 */     // GIR_Coverage, 23071,
     /*  358003 */     GIR_EraseRootFromParent_Done,
     /*  358004 */   // Label 6496: @358004
     /*  358004 */   GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(358067), // Rule ID 23072 //
     /*  358009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358048 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358065 */     GIR_RootConstrainSelectedInstOperands,
     /*  358066 */     // GIR_Coverage, 23072,
     /*  358066 */     GIR_EraseRootFromParent_Done,
     /*  358067 */   // Label 6497: @358067
     /*  358067 */   GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(358130), // Rule ID 23073 //
     /*  358072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358111 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B2),
     /*  358114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358128 */     GIR_RootConstrainSelectedInstOperands,
     /*  358129 */     // GIR_Coverage, 23073,
     /*  358129 */     GIR_EraseRootFromParent_Done,
     /*  358130 */   // Label 6498: @358130
     /*  358130 */   GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(358193), // Rule ID 23074 //
     /*  358135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358174 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358191 */     GIR_RootConstrainSelectedInstOperands,
     /*  358192 */     // GIR_Coverage, 23074,
     /*  358192 */     GIR_EraseRootFromParent_Done,
     /*  358193 */   // Label 6499: @358193
     /*  358193 */   GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(358256), // Rule ID 23075 //
     /*  358198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmandn),
     /*  358206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  358209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  358212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  358215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358237 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11344:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMANDN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMANDN_MM_B1),
     /*  358240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358254 */     GIR_RootConstrainSelectedInstOperands,
     /*  358255 */     // GIR_Coverage, 23075,
     /*  358255 */     GIR_EraseRootFromParent_Done,
     /*  358256 */   // Label 6500: @358256
     /*  358256 */   GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(358319), // Rule ID 23076 //
     /*  358261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358300 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358317 */     GIR_RootConstrainSelectedInstOperands,
     /*  358318 */     // GIR_Coverage, 23076,
     /*  358318 */     GIR_EraseRootFromParent_Done,
     /*  358319 */   // Label 6501: @358319
     /*  358319 */   GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(358382), // Rule ID 23077 //
     /*  358324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  358335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  358338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  358341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358363 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B64),
     /*  358366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358380 */     GIR_RootConstrainSelectedInstOperands,
     /*  358381 */     // GIR_Coverage, 23077,
     /*  358381 */     GIR_EraseRootFromParent_Done,
     /*  358382 */   // Label 6502: @358382
     /*  358382 */   GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(358445), // Rule ID 23078 //
     /*  358387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358426 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  358429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358443 */     GIR_RootConstrainSelectedInstOperands,
     /*  358444 */     // GIR_Coverage, 23078,
     /*  358444 */     GIR_EraseRootFromParent_Done,
     /*  358445 */   // Label 6503: @358445
     /*  358445 */   GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(358508), // Rule ID 23079 //
     /*  358450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  358461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  358464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  358467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358489 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B32),
     /*  358492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358506 */     GIR_RootConstrainSelectedInstOperands,
     /*  358507 */     // GIR_Coverage, 23079,
     /*  358507 */     GIR_EraseRootFromParent_Done,
     /*  358508 */   // Label 6504: @358508
     /*  358508 */   GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(358571), // Rule ID 23080 //
     /*  358513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358552 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  358555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358569 */     GIR_RootConstrainSelectedInstOperands,
     /*  358570 */     // GIR_Coverage, 23080,
     /*  358570 */     GIR_EraseRootFromParent_Done,
     /*  358571 */   // Label 6505: @358571
     /*  358571 */   GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(358634), // Rule ID 23081 //
     /*  358576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  358587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  358590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  358593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358615 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B16),
     /*  358618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358632 */     GIR_RootConstrainSelectedInstOperands,
     /*  358633 */     // GIR_Coverage, 23081,
     /*  358633 */     GIR_EraseRootFromParent_Done,
     /*  358634 */   // Label 6506: @358634
     /*  358634 */   GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(358697), // Rule ID 23082 //
     /*  358639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358678 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  358681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358695 */     GIR_RootConstrainSelectedInstOperands,
     /*  358696 */     // GIR_Coverage, 23082,
     /*  358696 */     GIR_EraseRootFromParent_Done,
     /*  358697 */   // Label 6507: @358697
     /*  358697 */   GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(358760), // Rule ID 23083 //
     /*  358702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  358713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  358716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  358719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358741 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B8),
     /*  358744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358758 */     GIR_RootConstrainSelectedInstOperands,
     /*  358759 */     // GIR_Coverage, 23083,
     /*  358759 */     GIR_EraseRootFromParent_Done,
     /*  358760 */   // Label 6508: @358760
     /*  358760 */   GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(358823), // Rule ID 23084 //
     /*  358765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  358807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358821 */     GIR_RootConstrainSelectedInstOperands,
     /*  358822 */     // GIR_Coverage, 23084,
     /*  358822 */     GIR_EraseRootFromParent_Done,
     /*  358823 */   // Label 6509: @358823
     /*  358823 */   GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(358886), // Rule ID 23085 //
     /*  358828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  358839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  358842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  358845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358867 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B4),
     /*  358870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358884 */     GIR_RootConstrainSelectedInstOperands,
     /*  358885 */     // GIR_Coverage, 23085,
     /*  358885 */     GIR_EraseRootFromParent_Done,
     /*  358886 */   // Label 6510: @358886
     /*  358886 */   GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(358949), // Rule ID 23086 //
     /*  358891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  358894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  358911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358930 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  358930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  358933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  358937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  358939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  358944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  358947 */     GIR_RootConstrainSelectedInstOperands,
     /*  358948 */     // GIR_Coverage, 23086,
     /*  358948 */     GIR_EraseRootFromParent_Done,
     /*  358949 */   // Label 6511: @358949
     /*  358949 */   GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(359012), // Rule ID 23087 //
     /*  358954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  358957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  358962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  358965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  358968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  358971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  358974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  358986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  358993 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  358993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B2),
     /*  358996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  358998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359010 */     GIR_RootConstrainSelectedInstOperands,
     /*  359011 */     // GIR_Coverage, 23087,
     /*  359011 */     GIR_EraseRootFromParent_Done,
     /*  359012 */   // Label 6512: @359012
     /*  359012 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(359075), // Rule ID 23088 //
     /*  359017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359056 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359073 */     GIR_RootConstrainSelectedInstOperands,
     /*  359074 */     // GIR_Coverage, 23088,
     /*  359074 */     GIR_EraseRootFromParent_Done,
     /*  359075 */   // Label 6513: @359075
     /*  359075 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(359138), // Rule ID 23089 //
     /*  359080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxor),
     /*  359088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359119 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11413:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXOR_MM_B1),
     /*  359122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359136 */     GIR_RootConstrainSelectedInstOperands,
     /*  359137 */     // GIR_Coverage, 23089,
     /*  359137 */     GIR_EraseRootFromParent_Done,
     /*  359138 */   // Label 6514: @359138
     /*  359138 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(359201), // Rule ID 23090 //
     /*  359143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359182 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359199 */     GIR_RootConstrainSelectedInstOperands,
     /*  359200 */     // GIR_Coverage, 23090,
     /*  359200 */     GIR_EraseRootFromParent_Done,
     /*  359201 */   // Label 6515: @359201
     /*  359201 */   GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(359264), // Rule ID 23091 //
     /*  359206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  359217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  359220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  359223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359245 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B64),
     /*  359248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359262 */     GIR_RootConstrainSelectedInstOperands,
     /*  359263 */     // GIR_Coverage, 23091,
     /*  359263 */     GIR_EraseRootFromParent_Done,
     /*  359264 */   // Label 6516: @359264
     /*  359264 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(359327), // Rule ID 23092 //
     /*  359269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359308 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359325 */     GIR_RootConstrainSelectedInstOperands,
     /*  359326 */     // GIR_Coverage, 23092,
     /*  359326 */     GIR_EraseRootFromParent_Done,
     /*  359327 */   // Label 6517: @359327
     /*  359327 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(359390), // Rule ID 23093 //
     /*  359332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  359343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  359346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  359349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359371 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B32),
     /*  359374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359388 */     GIR_RootConstrainSelectedInstOperands,
     /*  359389 */     // GIR_Coverage, 23093,
     /*  359389 */     GIR_EraseRootFromParent_Done,
     /*  359390 */   // Label 6518: @359390
     /*  359390 */   GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(359453), // Rule ID 23094 //
     /*  359395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359434 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  359437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359451 */     GIR_RootConstrainSelectedInstOperands,
     /*  359452 */     // GIR_Coverage, 23094,
     /*  359452 */     GIR_EraseRootFromParent_Done,
     /*  359453 */   // Label 6519: @359453
     /*  359453 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(359516), // Rule ID 23095 //
     /*  359458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  359469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  359472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  359475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359497 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B16),
     /*  359500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359514 */     GIR_RootConstrainSelectedInstOperands,
     /*  359515 */     // GIR_Coverage, 23095,
     /*  359515 */     GIR_EraseRootFromParent_Done,
     /*  359516 */   // Label 6520: @359516
     /*  359516 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(359579), // Rule ID 23096 //
     /*  359521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  359563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359577 */     GIR_RootConstrainSelectedInstOperands,
     /*  359578 */     // GIR_Coverage, 23096,
     /*  359578 */     GIR_EraseRootFromParent_Done,
     /*  359579 */   // Label 6521: @359579
     /*  359579 */   GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(359642), // Rule ID 23097 //
     /*  359584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  359595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  359598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  359601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359623 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B8),
     /*  359626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359640 */     GIR_RootConstrainSelectedInstOperands,
     /*  359641 */     // GIR_Coverage, 23097,
     /*  359641 */     GIR_EraseRootFromParent_Done,
     /*  359642 */   // Label 6522: @359642
     /*  359642 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(359705), // Rule ID 23098 //
     /*  359647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359686 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  359689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359703 */     GIR_RootConstrainSelectedInstOperands,
     /*  359704 */     // GIR_Coverage, 23098,
     /*  359704 */     GIR_EraseRootFromParent_Done,
     /*  359705 */   // Label 6523: @359705
     /*  359705 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(359768), // Rule ID 23099 //
     /*  359710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  359721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  359724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  359727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359749 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B4),
     /*  359752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359766 */     GIR_RootConstrainSelectedInstOperands,
     /*  359767 */     // GIR_Coverage, 23099,
     /*  359767 */     GIR_EraseRootFromParent_Done,
     /*  359768 */   // Label 6524: @359768
     /*  359768 */   GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(359831), // Rule ID 23100 //
     /*  359773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359812 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  359815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359829 */     GIR_RootConstrainSelectedInstOperands,
     /*  359830 */     // GIR_Coverage, 23100,
     /*  359830 */     GIR_EraseRootFromParent_Done,
     /*  359831 */   // Label 6525: @359831
     /*  359831 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(359894), // Rule ID 23101 //
     /*  359836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  359847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  359850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  359853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359875 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  359875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B2),
     /*  359878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359892 */     GIR_RootConstrainSelectedInstOperands,
     /*  359893 */     // GIR_Coverage, 23101,
     /*  359893 */     GIR_EraseRootFromParent_Done,
     /*  359894 */   // Label 6526: @359894
     /*  359894 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(359957), // Rule ID 23102 //
     /*  359899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  359902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  359919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  359938 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  359938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  359941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  359943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  359945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  359947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  359952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  359955 */     GIR_RootConstrainSelectedInstOperands,
     /*  359956 */     // GIR_Coverage, 23102,
     /*  359956 */     GIR_EraseRootFromParent_Done,
     /*  359957 */   // Label 6527: @359957
     /*  359957 */   GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(360020), // Rule ID 23103 //
     /*  359962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  359965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmor),
     /*  359970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  359973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  359976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  359979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  359982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  359994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360001 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11369:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMOR_MM_B1),
     /*  360004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360018 */     GIR_RootConstrainSelectedInstOperands,
     /*  360019 */     // GIR_Coverage, 23103,
     /*  360019 */     GIR_EraseRootFromParent_Done,
     /*  360020 */   // Label 6528: @360020
     /*  360020 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(360083), // Rule ID 23104 //
     /*  360025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360064 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360081 */     GIR_RootConstrainSelectedInstOperands,
     /*  360082 */     // GIR_Coverage, 23104,
     /*  360082 */     GIR_EraseRootFromParent_Done,
     /*  360083 */   // Label 6529: @360083
     /*  360083 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(360146), // Rule ID 23105 //
     /*  360088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360127 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B64),
     /*  360130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360144 */     GIR_RootConstrainSelectedInstOperands,
     /*  360145 */     // GIR_Coverage, 23105,
     /*  360145 */     GIR_EraseRootFromParent_Done,
     /*  360146 */   // Label 6530: @360146
     /*  360146 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(360209), // Rule ID 23106 //
     /*  360151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360190 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360207 */     GIR_RootConstrainSelectedInstOperands,
     /*  360208 */     // GIR_Coverage, 23106,
     /*  360208 */     GIR_EraseRootFromParent_Done,
     /*  360209 */   // Label 6531: @360209
     /*  360209 */   GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(360272), // Rule ID 23107 //
     /*  360214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  360225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  360228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  360231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360253 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B32),
     /*  360256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360270 */     GIR_RootConstrainSelectedInstOperands,
     /*  360271 */     // GIR_Coverage, 23107,
     /*  360271 */     GIR_EraseRootFromParent_Done,
     /*  360272 */   // Label 6532: @360272
     /*  360272 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(360335), // Rule ID 23108 //
     /*  360277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360316 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360333 */     GIR_RootConstrainSelectedInstOperands,
     /*  360334 */     // GIR_Coverage, 23108,
     /*  360334 */     GIR_EraseRootFromParent_Done,
     /*  360335 */   // Label 6533: @360335
     /*  360335 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(360398), // Rule ID 23109 //
     /*  360340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  360351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  360354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  360357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360379 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B16),
     /*  360382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360396 */     GIR_RootConstrainSelectedInstOperands,
     /*  360397 */     // GIR_Coverage, 23109,
     /*  360397 */     GIR_EraseRootFromParent_Done,
     /*  360398 */   // Label 6534: @360398
     /*  360398 */   GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(360461), // Rule ID 23110 //
     /*  360403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360442 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  360445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360459 */     GIR_RootConstrainSelectedInstOperands,
     /*  360460 */     // GIR_Coverage, 23110,
     /*  360460 */     GIR_EraseRootFromParent_Done,
     /*  360461 */   // Label 6535: @360461
     /*  360461 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(360524), // Rule ID 23111 //
     /*  360466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  360477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  360480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  360483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360505 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B8),
     /*  360508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360522 */     GIR_RootConstrainSelectedInstOperands,
     /*  360523 */     // GIR_Coverage, 23111,
     /*  360523 */     GIR_EraseRootFromParent_Done,
     /*  360524 */   // Label 6536: @360524
     /*  360524 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(360587), // Rule ID 23112 //
     /*  360529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  360571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360585 */     GIR_RootConstrainSelectedInstOperands,
     /*  360586 */     // GIR_Coverage, 23112,
     /*  360586 */     GIR_EraseRootFromParent_Done,
     /*  360587 */   // Label 6537: @360587
     /*  360587 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(360650), // Rule ID 23113 //
     /*  360592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  360603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  360606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  360609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360631 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B4),
     /*  360634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360648 */     GIR_RootConstrainSelectedInstOperands,
     /*  360649 */     // GIR_Coverage, 23113,
     /*  360649 */     GIR_EraseRootFromParent_Done,
     /*  360650 */   // Label 6538: @360650
     /*  360650 */   GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(360713), // Rule ID 23114 //
     /*  360655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360694 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  360697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360711 */     GIR_RootConstrainSelectedInstOperands,
     /*  360712 */     // GIR_Coverage, 23114,
     /*  360712 */     GIR_EraseRootFromParent_Done,
     /*  360713 */   // Label 6539: @360713
     /*  360713 */   GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(360776), // Rule ID 23115 //
     /*  360718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  360729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  360732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  360735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360757 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B2),
     /*  360760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360774 */     GIR_RootConstrainSelectedInstOperands,
     /*  360775 */     // GIR_Coverage, 23115,
     /*  360775 */     GIR_EraseRootFromParent_Done,
     /*  360776 */   // Label 6540: @360776
     /*  360776 */   GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(360839), // Rule ID 23116 //
     /*  360781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360820 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  360823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360837 */     GIR_RootConstrainSelectedInstOperands,
     /*  360838 */     // GIR_Coverage, 23116,
     /*  360838 */     GIR_EraseRootFromParent_Done,
     /*  360839 */   // Label 6541: @360839
     /*  360839 */   GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(360902), // Rule ID 23117 //
     /*  360844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmnor),
     /*  360852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  360855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  360858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  360861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360883 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11368:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  360883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMNOR_MM_B1),
     /*  360886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360900 */     GIR_RootConstrainSelectedInstOperands,
     /*  360901 */     // GIR_Coverage, 23117,
     /*  360901 */     GIR_EraseRootFromParent_Done,
     /*  360902 */   // Label 6542: @360902
     /*  360902 */   GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(360965), // Rule ID 23118 //
     /*  360907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  360910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  360915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  360927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  360946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  360946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  360949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  360951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  360953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  360955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  360960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  360963 */     GIR_RootConstrainSelectedInstOperands,
     /*  360964 */     // GIR_Coverage, 23118,
     /*  360964 */     GIR_EraseRootFromParent_Done,
     /*  360965 */   // Label 6543: @360965
     /*  360965 */   GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(361028), // Rule ID 23119 //
     /*  360970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  360973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  360978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  360981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  360984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  360987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  360990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  360998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361009 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B64),
     /*  361012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361026 */     GIR_RootConstrainSelectedInstOperands,
     /*  361027 */     // GIR_Coverage, 23119,
     /*  361027 */     GIR_EraseRootFromParent_Done,
     /*  361028 */   // Label 6544: @361028
     /*  361028 */   GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(361091), // Rule ID 23120 //
     /*  361033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361089 */     GIR_RootConstrainSelectedInstOperands,
     /*  361090 */     // GIR_Coverage, 23120,
     /*  361090 */     GIR_EraseRootFromParent_Done,
     /*  361091 */   // Label 6545: @361091
     /*  361091 */   GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(361154), // Rule ID 23121 //
     /*  361096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361135 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B32),
     /*  361138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361152 */     GIR_RootConstrainSelectedInstOperands,
     /*  361153 */     // GIR_Coverage, 23121,
     /*  361153 */     GIR_EraseRootFromParent_Done,
     /*  361154 */   // Label 6546: @361154
     /*  361154 */   GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(361217), // Rule ID 23122 //
     /*  361159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361198 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361215 */     GIR_RootConstrainSelectedInstOperands,
     /*  361216 */     // GIR_Coverage, 23122,
     /*  361216 */     GIR_EraseRootFromParent_Done,
     /*  361217 */   // Label 6547: @361217
     /*  361217 */   GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(361280), // Rule ID 23123 //
     /*  361222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  361233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  361236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  361239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361261 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B16),
     /*  361264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361278 */     GIR_RootConstrainSelectedInstOperands,
     /*  361279 */     // GIR_Coverage, 23123,
     /*  361279 */     GIR_EraseRootFromParent_Done,
     /*  361280 */   // Label 6548: @361280
     /*  361280 */   GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(361343), // Rule ID 23124 //
     /*  361285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361341 */     GIR_RootConstrainSelectedInstOperands,
     /*  361342 */     // GIR_Coverage, 23124,
     /*  361342 */     GIR_EraseRootFromParent_Done,
     /*  361343 */   // Label 6549: @361343
     /*  361343 */   GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(361406), // Rule ID 23125 //
     /*  361348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  361359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  361362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  361365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361387 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B8),
     /*  361390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361404 */     GIR_RootConstrainSelectedInstOperands,
     /*  361405 */     // GIR_Coverage, 23125,
     /*  361405 */     GIR_EraseRootFromParent_Done,
     /*  361406 */   // Label 6550: @361406
     /*  361406 */   GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(361469), // Rule ID 23126 //
     /*  361411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  361453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361467 */     GIR_RootConstrainSelectedInstOperands,
     /*  361468 */     // GIR_Coverage, 23126,
     /*  361468 */     GIR_EraseRootFromParent_Done,
     /*  361469 */   // Label 6551: @361469
     /*  361469 */   GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(361532), // Rule ID 23127 //
     /*  361474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  361485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  361488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  361491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B4),
     /*  361516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361530 */     GIR_RootConstrainSelectedInstOperands,
     /*  361531 */     // GIR_Coverage, 23127,
     /*  361531 */     GIR_EraseRootFromParent_Done,
     /*  361532 */   // Label 6552: @361532
     /*  361532 */   GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(361595), // Rule ID 23128 //
     /*  361537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  361579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361593 */     GIR_RootConstrainSelectedInstOperands,
     /*  361594 */     // GIR_Coverage, 23128,
     /*  361594 */     GIR_EraseRootFromParent_Done,
     /*  361595 */   // Label 6553: @361595
     /*  361595 */   GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(361658), // Rule ID 23129 //
     /*  361600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  361611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  361614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  361617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361639 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B2),
     /*  361642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361656 */     GIR_RootConstrainSelectedInstOperands,
     /*  361657 */     // GIR_Coverage, 23129,
     /*  361657 */     GIR_EraseRootFromParent_Done,
     /*  361658 */   // Label 6554: @361658
     /*  361658 */   GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(361721), // Rule ID 23130 //
     /*  361663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361702 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  361705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361719 */     GIR_RootConstrainSelectedInstOperands,
     /*  361720 */     // GIR_Coverage, 23130,
     /*  361720 */     GIR_EraseRootFromParent_Done,
     /*  361721 */   // Label 6555: @361721
     /*  361721 */   GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(361784), // Rule ID 23131 //
     /*  361726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmorn),
     /*  361734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  361737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  361740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  361743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361765 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11370:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMORN_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMORN_MM_B1),
     /*  361768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361782 */     GIR_RootConstrainSelectedInstOperands,
     /*  361783 */     // GIR_Coverage, 23131,
     /*  361783 */     GIR_EraseRootFromParent_Done,
     /*  361784 */   // Label 6556: @361784
     /*  361784 */   GIM_Try, /*On fail goto*//*Label 6557*/ GIMT_Encode4(361847), // Rule ID 23132 //
     /*  361789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  361797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361828 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  361831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361845 */     GIR_RootConstrainSelectedInstOperands,
     /*  361846 */     // GIR_Coverage, 23132,
     /*  361846 */     GIR_EraseRootFromParent_Done,
     /*  361847 */   // Label 6557: @361847
     /*  361847 */   GIM_Try, /*On fail goto*//*Label 6558*/ GIMT_Encode4(361910), // Rule ID 23133 //
     /*  361852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  361860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  361863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  361866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  361869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361891 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B64:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  361891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B64),
     /*  361894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361908 */     GIR_RootConstrainSelectedInstOperands,
     /*  361909 */     // GIR_Coverage, 23133,
     /*  361909 */     GIR_EraseRootFromParent_Done,
     /*  361910 */   // Label 6558: @361910
     /*  361910 */   GIM_Try, /*On fail goto*//*Label 6559*/ GIMT_Encode4(361973), // Rule ID 23134 //
     /*  361915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  361918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  361923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  361935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  361947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  361954 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  361954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  361957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  361959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  361961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  361963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  361968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  361971 */     GIR_RootConstrainSelectedInstOperands,
     /*  361972 */     // GIR_Coverage, 23134,
     /*  361972 */     GIR_EraseRootFromParent_Done,
     /*  361973 */   // Label 6559: @361973
     /*  361973 */   GIM_Try, /*On fail goto*//*Label 6560*/ GIMT_Encode4(362036), // Rule ID 23135 //
     /*  361978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  361981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  361986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  361989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  361992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  361995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  361998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362017 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B32:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B32),
     /*  362020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362034 */     GIR_RootConstrainSelectedInstOperands,
     /*  362035 */     // GIR_Coverage, 23135,
     /*  362035 */     GIR_EraseRootFromParent_Done,
     /*  362036 */   // Label 6560: @362036
     /*  362036 */   GIM_Try, /*On fail goto*//*Label 6561*/ GIMT_Encode4(362099), // Rule ID 23136 //
     /*  362041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362080 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362097 */     GIR_RootConstrainSelectedInstOperands,
     /*  362098 */     // GIR_Coverage, 23136,
     /*  362098 */     GIR_EraseRootFromParent_Done,
     /*  362099 */   // Label 6561: @362099
     /*  362099 */   GIM_Try, /*On fail goto*//*Label 6562*/ GIMT_Encode4(362162), // Rule ID 23137 //
     /*  362104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  362115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362143 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B16:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B16),
     /*  362146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362160 */     GIR_RootConstrainSelectedInstOperands,
     /*  362161 */     // GIR_Coverage, 23137,
     /*  362161 */     GIR_EraseRootFromParent_Done,
     /*  362162 */   // Label 6562: @362162
     /*  362162 */   GIM_Try, /*On fail goto*//*Label 6563*/ GIMT_Encode4(362225), // Rule ID 23138 //
     /*  362167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362206 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362223 */     GIR_RootConstrainSelectedInstOperands,
     /*  362224 */     // GIR_Coverage, 23138,
     /*  362224 */     GIR_EraseRootFromParent_Done,
     /*  362225 */   // Label 6563: @362225
     /*  362225 */   GIM_Try, /*On fail goto*//*Label 6564*/ GIMT_Encode4(362288), // Rule ID 23139 //
     /*  362230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  362241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362269 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B8:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B8),
     /*  362272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362286 */     GIR_RootConstrainSelectedInstOperands,
     /*  362287 */     // GIR_Coverage, 23139,
     /*  362287 */     GIR_EraseRootFromParent_Done,
     /*  362288 */   // Label 6564: @362288
     /*  362288 */   GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(362351), // Rule ID 23140 //
     /*  362293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362332 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362349 */     GIR_RootConstrainSelectedInstOperands,
     /*  362350 */     // GIR_Coverage, 23140,
     /*  362350 */     GIR_EraseRootFromParent_Done,
     /*  362351 */   // Label 6565: @362351
     /*  362351 */   GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(362414), // Rule ID 23141 //
     /*  362356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  362367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  362370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  362373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362395 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B4:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B4),
     /*  362398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362412 */     GIR_RootConstrainSelectedInstOperands,
     /*  362413 */     // GIR_Coverage, 23141,
     /*  362413 */     GIR_EraseRootFromParent_Done,
     /*  362414 */   // Label 6566: @362414
     /*  362414 */   GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(362477), // Rule ID 23142 //
     /*  362419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362458 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  362461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362475 */     GIR_RootConstrainSelectedInstOperands,
     /*  362476 */     // GIR_Coverage, 23142,
     /*  362476 */     GIR_EraseRootFromParent_Done,
     /*  362477 */   // Label 6567: @362477
     /*  362477 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(362540), // Rule ID 23143 //
     /*  362482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  362493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  362496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  362499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362521 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B2:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B2),
     /*  362524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362538 */     GIR_RootConstrainSelectedInstOperands,
     /*  362539 */     // GIR_Coverage, 23143,
     /*  362539 */     GIR_EraseRootFromParent_Done,
     /*  362540 */   // Label 6568: @362540
     /*  362540 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(362603), // Rule ID 23144 //
     /*  362545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  362548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362584 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  362587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362601 */     GIR_RootConstrainSelectedInstOperands,
     /*  362602 */     // GIR_Coverage, 23144,
     /*  362602 */     GIR_EraseRootFromParent_Done,
     /*  362603 */   // Label 6569: @362603
     /*  362603 */   GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(362666), // Rule ID 23145 //
     /*  362608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  362611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmxnor),
     /*  362616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  362619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  362622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  362625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362647 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11412:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMXNOR_MM_B1:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMXNOR_MM_B1),
     /*  362650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  362656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362664 */     GIR_RootConstrainSelectedInstOperands,
     /*  362665 */     // GIR_Coverage, 23145,
     /*  362665 */     GIR_EraseRootFromParent_Done,
     /*  362666 */   // Label 6570: @362666
     /*  362666 */   GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(362729), // Rule ID 23174 //
     /*  362671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  362674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  362682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  362695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  362703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362710 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  362713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362717 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  362719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362727 */     GIR_RootConstrainSelectedInstOperands,
     /*  362728 */     // GIR_Coverage, 23174,
     /*  362728 */     GIR_EraseRootFromParent_Done,
     /*  362729 */   // Label 6571: @362729
     /*  362729 */   GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(362792), // Rule ID 23175 //
     /*  362734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  362737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  362745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  362748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  362751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  362758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  362766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362773 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B32_MASK),
     /*  362776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362780 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  362782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362790 */     GIR_RootConstrainSelectedInstOperands,
     /*  362791 */     // GIR_Coverage, 23175,
     /*  362791 */     GIR_EraseRootFromParent_Done,
     /*  362792 */   // Label 6572: @362792
     /*  362792 */   GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(362855), // Rule ID 23178 //
     /*  362797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  362800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  362808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  362821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  362829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362836 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  362839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362843 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  362845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362853 */     GIR_RootConstrainSelectedInstOperands,
     /*  362854 */     // GIR_Coverage, 23178,
     /*  362854 */     GIR_EraseRootFromParent_Done,
     /*  362855 */   // Label 6573: @362855
     /*  362855 */   GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(362918), // Rule ID 23179 //
     /*  362860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  362863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  362871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  362874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  362877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  362880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  362884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  362892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362899 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  362899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B16_MASK),
     /*  362902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362906 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  362908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362916 */     GIR_RootConstrainSelectedInstOperands,
     /*  362917 */     // GIR_Coverage, 23179,
     /*  362917 */     GIR_EraseRootFromParent_Done,
     /*  362918 */   // Label 6574: @362918
     /*  362918 */   GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(362981), // Rule ID 23182 //
     /*  362923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  362926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  362934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  362937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  362940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  362943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  362947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  362951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  362955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  362962 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  362962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  362965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  362967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  362969 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  362971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  362976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  362979 */     GIR_RootConstrainSelectedInstOperands,
     /*  362980 */     // GIR_Coverage, 23182,
     /*  362980 */     GIR_EraseRootFromParent_Done,
     /*  362981 */   // Label 6575: @362981
     /*  362981 */   GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(363044), // Rule ID 23183 //
     /*  362986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  362989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  362994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  362997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363025 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B8_MASK),
     /*  363028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363032 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363042 */     GIR_RootConstrainSelectedInstOperands,
     /*  363043 */     // GIR_Coverage, 23183,
     /*  363043 */     GIR_EraseRootFromParent_Done,
     /*  363044 */   // Label 6576: @363044
     /*  363044 */   GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(363107), // Rule ID 23186 //
     /*  363049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363088 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363095 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363105 */     GIR_RootConstrainSelectedInstOperands,
     /*  363106 */     // GIR_Coverage, 23186,
     /*  363106 */     GIR_EraseRootFromParent_Done,
     /*  363107 */   // Label 6577: @363107
     /*  363107 */   GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(363170), // Rule ID 23187 //
     /*  363112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363151 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B4_MASK),
     /*  363154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363158 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363168 */     GIR_RootConstrainSelectedInstOperands,
     /*  363169 */     // GIR_Coverage, 23187,
     /*  363169 */     GIR_EraseRootFromParent_Done,
     /*  363170 */   // Label 6578: @363170
     /*  363170 */   GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(363233), // Rule ID 23190 //
     /*  363175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363214 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363221 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363231 */     GIR_RootConstrainSelectedInstOperands,
     /*  363232 */     // GIR_Coverage, 23190,
     /*  363232 */     GIR_EraseRootFromParent_Done,
     /*  363233 */   // Label 6579: @363233
     /*  363233 */   GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(363296), // Rule ID 23191 //
     /*  363238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  363252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  363255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363277 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B2_MASK),
     /*  363280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363284 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363294 */     GIR_RootConstrainSelectedInstOperands,
     /*  363295 */     // GIR_Coverage, 23191,
     /*  363295 */     GIR_EraseRootFromParent_Done,
     /*  363296 */   // Label 6580: @363296
     /*  363296 */   GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(363359), // Rule ID 23194 //
     /*  363301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363340 */     // (intrinsic_wo_chain:{ *:[i64] } 11107:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363347 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363357 */     GIR_RootConstrainSelectedInstOperands,
     /*  363358 */     // GIR_Coverage, 23194,
     /*  363358 */     GIR_EraseRootFromParent_Done,
     /*  363359 */   // Label 6581: @363359
     /*  363359 */   GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(363422), // Rule ID 23195 //
     /*  363364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpop_mask),
     /*  363372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  363378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  363381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363403 */     // (intrinsic_wo_chain:{ *:[i32] } 11107:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_M_B1_MASK),
     /*  363406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363410 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363420 */     GIR_RootConstrainSelectedInstOperands,
     /*  363421 */     // GIR_Coverage, 23195,
     /*  363421 */     GIR_EraseRootFromParent_Done,
     /*  363422 */   // Label 6582: @363422
     /*  363422 */   GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(363485), // Rule ID 23198 //
     /*  363427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363466 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i64] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  363469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363473 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363483 */     GIR_RootConstrainSelectedInstOperands,
     /*  363484 */     // GIR_Coverage, 23198,
     /*  363484 */     GIR_EraseRootFromParent_Done,
     /*  363485 */   // Label 6583: @363485
     /*  363485 */   GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(363548), // Rule ID 23199 //
     /*  363490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  363504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  363507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363529 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B64_MASK:{ *:[i32] } ?:{ *:[nxv1i1] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B64_MASK),
     /*  363532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363536 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363546 */     GIR_RootConstrainSelectedInstOperands,
     /*  363547 */     // GIR_Coverage, 23199,
     /*  363547 */     GIR_EraseRootFromParent_Done,
     /*  363548 */   // Label 6584: @363548
     /*  363548 */   GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(363611), // Rule ID 23202 //
     /*  363553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363592 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i64] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  363595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363599 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363609 */     GIR_RootConstrainSelectedInstOperands,
     /*  363610 */     // GIR_Coverage, 23202,
     /*  363610 */     GIR_EraseRootFromParent_Done,
     /*  363611 */   // Label 6585: @363611
     /*  363611 */   GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(363674), // Rule ID 23203 //
     /*  363616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  363630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  363633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363655 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B32_MASK:{ *:[i32] } ?:{ *:[nxv2i1] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B32_MASK),
     /*  363658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363662 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363672 */     GIR_RootConstrainSelectedInstOperands,
     /*  363673 */     // GIR_Coverage, 23203,
     /*  363673 */     GIR_EraseRootFromParent_Done,
     /*  363674 */   // Label 6586: @363674
     /*  363674 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(363737), // Rule ID 23206 //
     /*  363679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363718 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i64] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  363721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363725 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363735 */     GIR_RootConstrainSelectedInstOperands,
     /*  363736 */     // GIR_Coverage, 23206,
     /*  363736 */     GIR_EraseRootFromParent_Done,
     /*  363737 */   // Label 6587: @363737
     /*  363737 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(363800), // Rule ID 23207 //
     /*  363742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  363756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  363759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363781 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B16_MASK:{ *:[i32] } ?:{ *:[nxv4i1] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B16_MASK),
     /*  363784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363788 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363798 */     GIR_RootConstrainSelectedInstOperands,
     /*  363799 */     // GIR_Coverage, 23207,
     /*  363799 */     GIR_EraseRootFromParent_Done,
     /*  363800 */   // Label 6588: @363800
     /*  363800 */   GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(363863), // Rule ID 23210 //
     /*  363805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363844 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i64] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  363847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363851 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363861 */     GIR_RootConstrainSelectedInstOperands,
     /*  363862 */     // GIR_Coverage, 23210,
     /*  363862 */     GIR_EraseRootFromParent_Done,
     /*  363863 */   // Label 6589: @363863
     /*  363863 */   GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(363926), // Rule ID 23211 //
     /*  363868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  363879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  363882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  363885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  363888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363907 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B8_MASK:{ *:[i32] } ?:{ *:[nxv8i1] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  363907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B8_MASK),
     /*  363910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363914 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363924 */     GIR_RootConstrainSelectedInstOperands,
     /*  363925 */     // GIR_Coverage, 23211,
     /*  363925 */     GIR_EraseRootFromParent_Done,
     /*  363926 */   // Label 6590: @363926
     /*  363926 */   GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(363989), // Rule ID 23214 //
     /*  363931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  363934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  363939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  363942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  363945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  363948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  363951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  363955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  363959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  363963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  363970 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i64] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  363970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  363973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  363975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  363977 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  363979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  363984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  363987 */     GIR_RootConstrainSelectedInstOperands,
     /*  363988 */     // GIR_Coverage, 23214,
     /*  363988 */     GIR_EraseRootFromParent_Done,
     /*  363989 */   // Label 6591: @363989
     /*  363989 */   GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(364052), // Rule ID 23215 //
     /*  363994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  363997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  364008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  364011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364033 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B4_MASK:{ *:[i32] } ?:{ *:[nxv16i1] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B4_MASK),
     /*  364036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364040 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364050 */     GIR_RootConstrainSelectedInstOperands,
     /*  364051 */     // GIR_Coverage, 23215,
     /*  364051 */     GIR_EraseRootFromParent_Done,
     /*  364052 */   // Label 6592: @364052
     /*  364052 */   GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(364115), // Rule ID 23218 //
     /*  364057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364096 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i64] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364103 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364113 */     GIR_RootConstrainSelectedInstOperands,
     /*  364114 */     // GIR_Coverage, 23218,
     /*  364114 */     GIR_EraseRootFromParent_Done,
     /*  364115 */   // Label 6593: @364115
     /*  364115 */   GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(364178), // Rule ID 23219 //
     /*  364120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  364134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  364137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364159 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B2_MASK:{ *:[i32] } ?:{ *:[nxv32i1] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B2_MASK),
     /*  364162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364166 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364176 */     GIR_RootConstrainSelectedInstOperands,
     /*  364177 */     // GIR_Coverage, 23219,
     /*  364177 */     GIR_EraseRootFromParent_Done,
     /*  364178 */   // Label 6594: @364178
     /*  364178 */   GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(364241), // Rule ID 23222 //
     /*  364183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  364186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  364194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364222 */     // (intrinsic_wo_chain:{ *:[i64] } 11135:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i64] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /*  364222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364229 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364239 */     GIR_RootConstrainSelectedInstOperands,
     /*  364240 */     // GIR_Coverage, 23222,
     /*  364240 */     GIR_EraseRootFromParent_Done,
     /*  364241 */   // Label 6595: @364241
     /*  364241 */   GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(364304), // Rule ID 23223 //
     /*  364246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  364249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfirst_mask),
     /*  364254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  364257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  364260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  364263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  364270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  364278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364285 */     // (intrinsic_wo_chain:{ *:[i32] } 11135:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFIRST_M_B1_MASK:{ *:[i32] } ?:{ *:[nxv64i1] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /*  364285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFIRST_M_B1_MASK),
     /*  364288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  364292 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  364294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364302 */     GIR_RootConstrainSelectedInstOperands,
     /*  364303 */     // GIR_Coverage, 23223,
     /*  364303 */     GIR_EraseRootFromParent_Done,
     /*  364304 */   // Label 6596: @364304
     /*  364304 */   GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(364370), // Rule ID 23304 //
     /*  364309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364368 */     GIR_RootConstrainSelectedInstOperands,
     /*  364369 */     // GIR_Coverage, 23304,
     /*  364369 */     GIR_EraseRootFromParent_Done,
     /*  364370 */   // Label 6597: @364370
     /*  364370 */   GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(364436), // Rule ID 23305 //
     /*  364375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  364386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  364389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364414 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364434 */     GIR_RootConstrainSelectedInstOperands,
     /*  364435 */     // GIR_Coverage, 23305,
     /*  364435 */     GIR_EraseRootFromParent_Done,
     /*  364436 */   // Label 6598: @364436
     /*  364436 */   GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(364502), // Rule ID 23308 //
     /*  364441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  364452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  364455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  364480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364500 */     GIR_RootConstrainSelectedInstOperands,
     /*  364501 */     // GIR_Coverage, 23308,
     /*  364501 */     GIR_EraseRootFromParent_Done,
     /*  364502 */   // Label 6599: @364502
     /*  364502 */   GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(364568), // Rule ID 23309 //
     /*  364507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  364518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  364521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  364524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  364546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  364563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364566 */     GIR_RootConstrainSelectedInstOperands,
     /*  364567 */     // GIR_Coverage, 23309,
     /*  364567 */     GIR_EraseRootFromParent_Done,
     /*  364568 */   // Label 6600: @364568
     /*  364568 */   GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(364634), // Rule ID 23312 //
     /*  364573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  364584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  364587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364612 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  364612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364632 */     GIR_RootConstrainSelectedInstOperands,
     /*  364633 */     // GIR_Coverage, 23312,
     /*  364633 */     GIR_EraseRootFromParent_Done,
     /*  364634 */   // Label 6601: @364634
     /*  364634 */   GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(364700), // Rule ID 23313 //
     /*  364639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  364650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  364653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  364678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4),
     /*  364681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364698 */     GIR_RootConstrainSelectedInstOperands,
     /*  364699 */     // GIR_Coverage, 23313,
     /*  364699 */     GIR_EraseRootFromParent_Done,
     /*  364700 */   // Label 6602: @364700
     /*  364700 */   GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(364766), // Rule ID 23316 //
     /*  364705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  364716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  364719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  364744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364764 */     GIR_RootConstrainSelectedInstOperands,
     /*  364765 */     // GIR_Coverage, 23316,
     /*  364765 */     GIR_EraseRootFromParent_Done,
     /*  364766 */   // Label 6603: @364766
     /*  364766 */   GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(364832), // Rule ID 23317 //
     /*  364771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  364782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  364785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  364788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364810 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  364810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  364827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364830 */     GIR_RootConstrainSelectedInstOperands,
     /*  364831 */     // GIR_Coverage, 23317,
     /*  364831 */     GIR_EraseRootFromParent_Done,
     /*  364832 */   // Label 6604: @364832
     /*  364832 */   GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(364898), // Rule ID 23320 //
     /*  364837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  364848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  364851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364876 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  364876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  364893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364896 */     GIR_RootConstrainSelectedInstOperands,
     /*  364897 */     // GIR_Coverage, 23320,
     /*  364897 */     GIR_EraseRootFromParent_Done,
     /*  364898 */   // Label 6605: @364898
     /*  364898 */   GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(364964), // Rule ID 23321 //
     /*  364903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  364906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  364914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  364917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  364920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  364923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  364942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  364942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2),
     /*  364945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  364947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  364949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  364951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  364956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  364959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  364962 */     GIR_RootConstrainSelectedInstOperands,
     /*  364963 */     // GIR_Coverage, 23321,
     /*  364963 */     GIR_EraseRootFromParent_Done,
     /*  364964 */   // Label 6606: @364964
     /*  364964 */   GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(365030), // Rule ID 23324 //
     /*  364969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  364972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  364977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  364980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  364983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  364986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  364989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  364997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365028 */     GIR_RootConstrainSelectedInstOperands,
     /*  365029 */     // GIR_Coverage, 23324,
     /*  365029 */     GIR_EraseRootFromParent_Done,
     /*  365030 */   // Label 6607: @365030
     /*  365030 */   GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(365096), // Rule ID 23325 //
     /*  365035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  365046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  365049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365074 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11254:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365094 */     GIR_RootConstrainSelectedInstOperands,
     /*  365095 */     // GIR_Coverage, 23325,
     /*  365095 */     GIR_EraseRootFromParent_Done,
     /*  365096 */   // Label 6608: @365096
     /*  365096 */   GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(365162), // Rule ID 23328 //
     /*  365101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365140 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365160 */     GIR_RootConstrainSelectedInstOperands,
     /*  365161 */     // GIR_Coverage, 23328,
     /*  365161 */     GIR_EraseRootFromParent_Done,
     /*  365162 */   // Label 6609: @365162
     /*  365162 */   GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(365228), // Rule ID 23329 //
     /*  365167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  365178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  365181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  365184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11254:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365226 */     GIR_RootConstrainSelectedInstOperands,
     /*  365227 */     // GIR_Coverage, 23329,
     /*  365227 */     GIR_EraseRootFromParent_Done,
     /*  365228 */   // Label 6610: @365228
     /*  365228 */   GIM_Try, /*On fail goto*//*Label 6611*/ GIMT_Encode4(365294), // Rule ID 23332 //
     /*  365233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  365272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365292 */     GIR_RootConstrainSelectedInstOperands,
     /*  365293 */     // GIR_Coverage, 23332,
     /*  365293 */     GIR_EraseRootFromParent_Done,
     /*  365294 */   // Label 6611: @365294
     /*  365294 */   GIM_Try, /*On fail goto*//*Label 6612*/ GIMT_Encode4(365360), // Rule ID 23333 //
     /*  365299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  365310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  365313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  365316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11254:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  365338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  365355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365358 */     GIR_RootConstrainSelectedInstOperands,
     /*  365359 */     // GIR_Coverage, 23333,
     /*  365359 */     GIR_EraseRootFromParent_Done,
     /*  365360 */   // Label 6612: @365360
     /*  365360 */   GIM_Try, /*On fail goto*//*Label 6613*/ GIMT_Encode4(365426), // Rule ID 23336 //
     /*  365365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  365368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  365404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365424 */     GIR_RootConstrainSelectedInstOperands,
     /*  365425 */     // GIR_Coverage, 23336,
     /*  365425 */     GIR_EraseRootFromParent_Done,
     /*  365426 */   // Label 6613: @365426
     /*  365426 */   GIM_Try, /*On fail goto*//*Label 6614*/ GIMT_Encode4(365492), // Rule ID 23337 //
     /*  365431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  365434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  365442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  365445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  365448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11254:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  365470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1),
     /*  365473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  365487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365490 */     GIR_RootConstrainSelectedInstOperands,
     /*  365491 */     // GIR_Coverage, 23337,
     /*  365491 */     GIR_EraseRootFromParent_Done,
     /*  365492 */   // Label 6614: @365492
     /*  365492 */   GIM_Try, /*On fail goto*//*Label 6615*/ GIMT_Encode4(365558), // Rule ID 23340 //
     /*  365497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  365508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  365511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  365539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365556 */     GIR_RootConstrainSelectedInstOperands,
     /*  365557 */     // GIR_Coverage, 23340,
     /*  365557 */     GIR_EraseRootFromParent_Done,
     /*  365558 */   // Label 6615: @365558
     /*  365558 */   GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(365624), // Rule ID 23341 //
     /*  365563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  365574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  365577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  365580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365602 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  365605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365622 */     GIR_RootConstrainSelectedInstOperands,
     /*  365623 */     // GIR_Coverage, 23341,
     /*  365623 */     GIR_EraseRootFromParent_Done,
     /*  365624 */   // Label 6616: @365624
     /*  365624 */   GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(365690), // Rule ID 23344 //
     /*  365629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  365640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  365643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365668 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  365671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365688 */     GIR_RootConstrainSelectedInstOperands,
     /*  365689 */     // GIR_Coverage, 23344,
     /*  365689 */     GIR_EraseRootFromParent_Done,
     /*  365690 */   // Label 6617: @365690
     /*  365690 */   GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(365756), // Rule ID 23345 //
     /*  365695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  365706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  365709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  365712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  365723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  365737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365754 */     GIR_RootConstrainSelectedInstOperands,
     /*  365755 */     // GIR_Coverage, 23345,
     /*  365755 */     GIR_EraseRootFromParent_Done,
     /*  365756 */   // Label 6618: @365756
     /*  365756 */   GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(365822), // Rule ID 23348 //
     /*  365761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  365772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  365775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  365800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  365803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365820 */     GIR_RootConstrainSelectedInstOperands,
     /*  365821 */     // GIR_Coverage, 23348,
     /*  365821 */     GIR_EraseRootFromParent_Done,
     /*  365822 */   // Label 6619: @365822
     /*  365822 */   GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(365888), // Rule ID 23349 //
     /*  365827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  365838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  365841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  365844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  365855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365866 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  365866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  365869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  365883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365886 */     GIR_RootConstrainSelectedInstOperands,
     /*  365887 */     // GIR_Coverage, 23349,
     /*  365887 */     GIR_EraseRootFromParent_Done,
     /*  365888 */   // Label 6620: @365888
     /*  365888 */   GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(365954), // Rule ID 23352 //
     /*  365893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  365896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  365904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  365907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  365913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365932 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  365932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  365935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  365937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  365939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  365941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  365946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  365949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  365952 */     GIR_RootConstrainSelectedInstOperands,
     /*  365953 */     // GIR_Coverage, 23352,
     /*  365953 */     GIR_EraseRootFromParent_Done,
     /*  365954 */   // Label 6621: @365954
     /*  365954 */   GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(366020), // Rule ID 23353 //
     /*  365959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  365962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  365967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  365970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  365973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  365976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  365979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  365987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  365991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  365998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  365998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366018 */     GIR_RootConstrainSelectedInstOperands,
     /*  366019 */     // GIR_Coverage, 23353,
     /*  366019 */     GIR_EraseRootFromParent_Done,
     /*  366020 */   // Label 6622: @366020
     /*  366020 */   GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(366086), // Rule ID 23356 //
     /*  366025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366084 */     GIR_RootConstrainSelectedInstOperands,
     /*  366085 */     // GIR_Coverage, 23356,
     /*  366085 */     GIR_EraseRootFromParent_Done,
     /*  366086 */   // Label 6623: @366086
     /*  366086 */   GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(366152), // Rule ID 23357 //
     /*  366091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  366102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  366105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366150 */     GIR_RootConstrainSelectedInstOperands,
     /*  366151 */     // GIR_Coverage, 23357,
     /*  366151 */     GIR_EraseRootFromParent_Done,
     /*  366152 */   // Label 6624: @366152
     /*  366152 */   GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(366218), // Rule ID 23360 //
     /*  366157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  366196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366216 */     GIR_RootConstrainSelectedInstOperands,
     /*  366217 */     // GIR_Coverage, 23360,
     /*  366217 */     GIR_EraseRootFromParent_Done,
     /*  366218 */   // Label 6625: @366218
     /*  366218 */   GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(366284), // Rule ID 23361 //
     /*  366223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  366234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  366237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  366240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  366262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  366279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366282 */     GIR_RootConstrainSelectedInstOperands,
     /*  366283 */     // GIR_Coverage, 23361,
     /*  366283 */     GIR_EraseRootFromParent_Done,
     /*  366284 */   // Label 6626: @366284
     /*  366284 */   GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(366350), // Rule ID 23364 //
     /*  366289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366328 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366348 */     GIR_RootConstrainSelectedInstOperands,
     /*  366349 */     // GIR_Coverage, 23364,
     /*  366349 */     GIR_EraseRootFromParent_Done,
     /*  366350 */   // Label 6627: @366350
     /*  366350 */   GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(366416), // Rule ID 23365 //
     /*  366355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  366366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  366369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366414 */     GIR_RootConstrainSelectedInstOperands,
     /*  366415 */     // GIR_Coverage, 23365,
     /*  366415 */     GIR_EraseRootFromParent_Done,
     /*  366416 */   // Label 6628: @366416
     /*  366416 */   GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(366482), // Rule ID 23368 //
     /*  366421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  366432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  366435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366480 */     GIR_RootConstrainSelectedInstOperands,
     /*  366481 */     // GIR_Coverage, 23368,
     /*  366481 */     GIR_EraseRootFromParent_Done,
     /*  366482 */   // Label 6629: @366482
     /*  366482 */   GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(366548), // Rule ID 23369 //
     /*  366487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  366498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  366501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366546 */     GIR_RootConstrainSelectedInstOperands,
     /*  366547 */     // GIR_Coverage, 23369,
     /*  366547 */     GIR_EraseRootFromParent_Done,
     /*  366548 */   // Label 6630: @366548
     /*  366548 */   GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(366614), // Rule ID 23372 //
     /*  366553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  366556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  366564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  366567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366592 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  366592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366612 */     GIR_RootConstrainSelectedInstOperands,
     /*  366613 */     // GIR_Coverage, 23372,
     /*  366613 */     GIR_EraseRootFromParent_Done,
     /*  366614 */   // Label 6631: @366614
     /*  366614 */   GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(366680), // Rule ID 23373 //
     /*  366619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  366622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  366630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  366633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  366636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  366658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  366675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366678 */     GIR_RootConstrainSelectedInstOperands,
     /*  366679 */     // GIR_Coverage, 23373,
     /*  366679 */     GIR_EraseRootFromParent_Done,
     /*  366680 */   // Label 6632: @366680
     /*  366680 */   GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(366746), // Rule ID 23376 //
     /*  366685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  366688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  366696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  366699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  366724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366744 */     GIR_RootConstrainSelectedInstOperands,
     /*  366745 */     // GIR_Coverage, 23376,
     /*  366745 */     GIR_EraseRootFromParent_Done,
     /*  366746 */   // Label 6633: @366746
     /*  366746 */   GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(366812), // Rule ID 23377 //
     /*  366751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  366754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  366762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  366765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  366768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  366779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366790 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11254:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  366790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2),
     /*  366793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366810 */     GIR_RootConstrainSelectedInstOperands,
     /*  366811 */     // GIR_Coverage, 23377,
     /*  366811 */     GIR_EraseRootFromParent_Done,
     /*  366812 */   // Label 6634: @366812
     /*  366812 */   GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(366878), // Rule ID 23380 //
     /*  366817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  366820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  366828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  366831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  366856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366876 */     GIR_RootConstrainSelectedInstOperands,
     /*  366877 */     // GIR_Coverage, 23380,
     /*  366877 */     GIR_EraseRootFromParent_Done,
     /*  366878 */   // Label 6635: @366878
     /*  366878 */   GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(366944), // Rule ID 23381 //
     /*  366883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  366886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  366894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  366897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  366900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  366903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  366911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366922 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11254:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  366922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4),
     /*  366925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  366936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  366939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  366942 */     GIR_RootConstrainSelectedInstOperands,
     /*  366943 */     // GIR_Coverage, 23381,
     /*  366943 */     GIR_EraseRootFromParent_Done,
     /*  366944 */   // Label 6636: @366944
     /*  366944 */   GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(367010), // Rule ID 23384 //
     /*  366949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  366952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  366957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  366960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  366963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  366966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  366969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  366977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  366981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  366988 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  366988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  366991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  366993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  366995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  366997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367008 */     GIR_RootConstrainSelectedInstOperands,
     /*  367009 */     // GIR_Coverage, 23384,
     /*  367009 */     GIR_EraseRootFromParent_Done,
     /*  367010 */   // Label 6637: @367010
     /*  367010 */   GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(367076), // Rule ID 23385 //
     /*  367015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  367018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota),
     /*  367023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  367026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  367029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  367032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  367043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11254:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVIOTA_M_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  367054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8),
     /*  367057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  367071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367074 */     GIR_RootConstrainSelectedInstOperands,
     /*  367075 */     // GIR_Coverage, 23385,
     /*  367075 */     GIR_EraseRootFromParent_Done,
     /*  367076 */   // Label 6638: @367076
     /*  367076 */   GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(367142), // Rule ID 60492 //
     /*  367081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367140 */     GIR_RootConstrainSelectedInstOperands,
     /*  367141 */     // GIR_Coverage, 60492,
     /*  367141 */     GIR_EraseRootFromParent_Done,
     /*  367142 */   // Label 6639: @367142
     /*  367142 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(367208), // Rule ID 60493 //
     /*  367147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  367158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  367161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  367164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /*  367189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367206 */     GIR_RootConstrainSelectedInstOperands,
     /*  367207 */     // GIR_Coverage, 60493,
     /*  367207 */     GIR_EraseRootFromParent_Done,
     /*  367208 */   // Label 6640: @367208
     /*  367208 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(367274), // Rule ID 60496 //
     /*  367213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367272 */     GIR_RootConstrainSelectedInstOperands,
     /*  367273 */     // GIR_Coverage, 60496,
     /*  367273 */     GIR_EraseRootFromParent_Done,
     /*  367274 */   // Label 6641: @367274
     /*  367274 */   GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(367340), // Rule ID 60497 //
     /*  367279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  367290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  367293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  367296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367338 */     GIR_RootConstrainSelectedInstOperands,
     /*  367339 */     // GIR_Coverage, 60497,
     /*  367339 */     GIR_EraseRootFromParent_Done,
     /*  367340 */   // Label 6642: @367340
     /*  367340 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(367406), // Rule ID 60500 //
     /*  367345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367404 */     GIR_RootConstrainSelectedInstOperands,
     /*  367405 */     // GIR_Coverage, 60500,
     /*  367405 */     GIR_EraseRootFromParent_Done,
     /*  367406 */   // Label 6643: @367406
     /*  367406 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(367472), // Rule ID 60501 //
     /*  367411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  367422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  367425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  367428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367470 */     GIR_RootConstrainSelectedInstOperands,
     /*  367471 */     // GIR_Coverage, 60501,
     /*  367471 */     GIR_EraseRootFromParent_Done,
     /*  367472 */   // Label 6644: @367472
     /*  367472 */   GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(367538), // Rule ID 60504 //
     /*  367477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  367488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  367491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  367494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367536 */     GIR_RootConstrainSelectedInstOperands,
     /*  367537 */     // GIR_Coverage, 60504,
     /*  367537 */     GIR_EraseRootFromParent_Done,
     /*  367538 */   // Label 6645: @367538
     /*  367538 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(367604), // Rule ID 60505 //
     /*  367543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  367554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  367557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  367560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367582 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /*  367585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367602 */     GIR_RootConstrainSelectedInstOperands,
     /*  367603 */     // GIR_Coverage, 60505,
     /*  367603 */     GIR_EraseRootFromParent_Done,
     /*  367604 */   // Label 6646: @367604
     /*  367604 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(367670), // Rule ID 60508 //
     /*  367609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  367620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  367623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  367626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  367648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367668 */     GIR_RootConstrainSelectedInstOperands,
     /*  367669 */     // GIR_Coverage, 60508,
     /*  367669 */     GIR_EraseRootFromParent_Done,
     /*  367670 */   // Label 6647: @367670
     /*  367670 */   GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(367736), // Rule ID 60509 //
     /*  367675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  367686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  367689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  367692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367714 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  367714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  367731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367734 */     GIR_RootConstrainSelectedInstOperands,
     /*  367735 */     // GIR_Coverage, 60509,
     /*  367735 */     GIR_EraseRootFromParent_Done,
     /*  367736 */   // Label 6648: @367736
     /*  367736 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(367802), // Rule ID 60512 //
     /*  367741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  367752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  367755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  367758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  367780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367800 */     GIR_RootConstrainSelectedInstOperands,
     /*  367801 */     // GIR_Coverage, 60512,
     /*  367801 */     GIR_EraseRootFromParent_Done,
     /*  367802 */   // Label 6649: @367802
     /*  367802 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(367868), // Rule ID 60513 //
     /*  367807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  367818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  367821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  367824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367846 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  367846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /*  367849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  367863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367866 */     GIR_RootConstrainSelectedInstOperands,
     /*  367867 */     // GIR_Coverage, 60513,
     /*  367867 */     GIR_EraseRootFromParent_Done,
     /*  367868 */   // Label 6650: @367868
     /*  367868 */   GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(367934), // Rule ID 60516 //
     /*  367873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  367876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  367884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  367887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  367890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  367893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  367912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  367915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367932 */     GIR_RootConstrainSelectedInstOperands,
     /*  367933 */     // GIR_Coverage, 60516,
     /*  367933 */     GIR_EraseRootFromParent_Done,
     /*  367934 */   // Label 6651: @367934
     /*  367934 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(368000), // Rule ID 60517 //
     /*  367939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  367942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  367947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  367950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  367953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  367956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  367959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  367971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  367978 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11095:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  367978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  367981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  367983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  367985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  367987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  367992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  367995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  367998 */     GIR_RootConstrainSelectedInstOperands,
     /*  367999 */     // GIR_Coverage, 60517,
     /*  367999 */     GIR_EraseRootFromParent_Done,
     /*  368000 */   // Label 6652: @368000
     /*  368000 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(368066), // Rule ID 60520 //
     /*  368005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368064 */     GIR_RootConstrainSelectedInstOperands,
     /*  368065 */     // GIR_Coverage, 60520,
     /*  368065 */     GIR_EraseRootFromParent_Done,
     /*  368066 */   // Label 6653: @368066
     /*  368066 */   GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(368132), // Rule ID 60521 //
     /*  368071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  368082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  368085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  368088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368110 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11095:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368130 */     GIR_RootConstrainSelectedInstOperands,
     /*  368131 */     // GIR_Coverage, 60521,
     /*  368131 */     GIR_EraseRootFromParent_Done,
     /*  368132 */   // Label 6654: @368132
     /*  368132 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(368198), // Rule ID 60524 //
     /*  368137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  368176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368196 */     GIR_RootConstrainSelectedInstOperands,
     /*  368197 */     // GIR_Coverage, 60524,
     /*  368197 */     GIR_EraseRootFromParent_Done,
     /*  368198 */   // Label 6655: @368198
     /*  368198 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(368264), // Rule ID 60525 //
     /*  368203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  368214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  368217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  368220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368242 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11095:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  368242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  368259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368262 */     GIR_RootConstrainSelectedInstOperands,
     /*  368263 */     // GIR_Coverage, 60525,
     /*  368263 */     GIR_EraseRootFromParent_Done,
     /*  368264 */   // Label 6656: @368264
     /*  368264 */   GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(368330), // Rule ID 60528 //
     /*  368269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  368308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368328 */     GIR_RootConstrainSelectedInstOperands,
     /*  368329 */     // GIR_Coverage, 60528,
     /*  368329 */     GIR_EraseRootFromParent_Done,
     /*  368330 */   // Label 6657: @368330
     /*  368330 */   GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(368396), // Rule ID 60529 //
     /*  368335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  368346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  368349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  368352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  368367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11095:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  368374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /*  368377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  368391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368394 */     GIR_RootConstrainSelectedInstOperands,
     /*  368395 */     // GIR_Coverage, 60529,
     /*  368395 */     GIR_EraseRootFromParent_Done,
     /*  368396 */   // Label 6658: @368396
     /*  368396 */   GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(368462), // Rule ID 60532 //
     /*  368401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  368415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  368418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368460 */     GIR_RootConstrainSelectedInstOperands,
     /*  368461 */     // GIR_Coverage, 60532,
     /*  368461 */     GIR_EraseRootFromParent_Done,
     /*  368462 */   // Label 6659: @368462
     /*  368462 */   GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(368528), // Rule ID 60533 //
     /*  368467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  368478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  368481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  368484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368526 */     GIR_RootConstrainSelectedInstOperands,
     /*  368527 */     // GIR_Coverage, 60533,
     /*  368527 */     GIR_EraseRootFromParent_Done,
     /*  368528 */   // Label 6660: @368528
     /*  368528 */   GIM_Try, /*On fail goto*//*Label 6661*/ GIMT_Encode4(368594), // Rule ID 60536 //
     /*  368533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  368544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  368547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  368550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368572 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  368575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368592 */     GIR_RootConstrainSelectedInstOperands,
     /*  368593 */     // GIR_Coverage, 60536,
     /*  368593 */     GIR_EraseRootFromParent_Done,
     /*  368594 */   // Label 6661: @368594
     /*  368594 */   GIM_Try, /*On fail goto*//*Label 6662*/ GIMT_Encode4(368660), // Rule ID 60537 //
     /*  368599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  368610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  368613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  368616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  368641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368658 */     GIR_RootConstrainSelectedInstOperands,
     /*  368659 */     // GIR_Coverage, 60537,
     /*  368659 */     GIR_EraseRootFromParent_Done,
     /*  368660 */   // Label 6662: @368660
     /*  368660 */   GIM_Try, /*On fail goto*//*Label 6663*/ GIMT_Encode4(368726), // Rule ID 60540 //
     /*  368665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  368676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  368679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  368682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  368704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  368707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368724 */     GIR_RootConstrainSelectedInstOperands,
     /*  368725 */     // GIR_Coverage, 60540,
     /*  368725 */     GIR_EraseRootFromParent_Done,
     /*  368726 */   // Label 6663: @368726
     /*  368726 */   GIM_Try, /*On fail goto*//*Label 6664*/ GIMT_Encode4(368792), // Rule ID 60541 //
     /*  368731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  368742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  368745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  368748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  368763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  368770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  368773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  368787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368790 */     GIR_RootConstrainSelectedInstOperands,
     /*  368791 */     // GIR_Coverage, 60541,
     /*  368791 */     GIR_EraseRootFromParent_Done,
     /*  368792 */   // Label 6664: @368792
     /*  368792 */   GIM_Try, /*On fail goto*//*Label 6665*/ GIMT_Encode4(368858), // Rule ID 60544 //
     /*  368797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  368808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  368811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  368814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368836 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368856 */     GIR_RootConstrainSelectedInstOperands,
     /*  368857 */     // GIR_Coverage, 60544,
     /*  368857 */     GIR_EraseRootFromParent_Done,
     /*  368858 */   // Label 6665: @368858
     /*  368858 */   GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(368924), // Rule ID 60545 //
     /*  368863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  368874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  368877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  368880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  368883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  368895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  368902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  368905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368922 */     GIR_RootConstrainSelectedInstOperands,
     /*  368923 */     // GIR_Coverage, 60545,
     /*  368923 */     GIR_EraseRootFromParent_Done,
     /*  368924 */   // Label 6666: @368924
     /*  368924 */   GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(368990), // Rule ID 60548 //
     /*  368929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  368932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  368937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  368940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  368943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  368946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  368949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  368961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  368968 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  368968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  368971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  368973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  368975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  368977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  368982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  368985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  368988 */     GIR_RootConstrainSelectedInstOperands,
     /*  368989 */     // GIR_Coverage, 60548,
     /*  368989 */     GIR_EraseRootFromParent_Done,
     /*  368990 */   // Label 6667: @368990
     /*  368990 */   GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(369056), // Rule ID 60549 //
     /*  368995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  368998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  369006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  369009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  369012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369054 */     GIR_RootConstrainSelectedInstOperands,
     /*  369055 */     // GIR_Coverage, 60549,
     /*  369055 */     GIR_EraseRootFromParent_Done,
     /*  369056 */   // Label 6668: @369056
     /*  369056 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(369122), // Rule ID 60552 //
     /*  369061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369100 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  369100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369120 */     GIR_RootConstrainSelectedInstOperands,
     /*  369121 */     // GIR_Coverage, 60552,
     /*  369121 */     GIR_EraseRootFromParent_Done,
     /*  369122 */   // Label 6669: @369122
     /*  369122 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(369188), // Rule ID 60553 //
     /*  369127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  369138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  369141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  369144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  369166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  369183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369186 */     GIR_RootConstrainSelectedInstOperands,
     /*  369187 */     // GIR_Coverage, 60553,
     /*  369187 */     GIR_EraseRootFromParent_Done,
     /*  369188 */   // Label 6670: @369188
     /*  369188 */   GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(369254), // Rule ID 60556 //
     /*  369193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369252 */     GIR_RootConstrainSelectedInstOperands,
     /*  369253 */     // GIR_Coverage, 60556,
     /*  369253 */     GIR_EraseRootFromParent_Done,
     /*  369254 */   // Label 6671: @369254
     /*  369254 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(369320), // Rule ID 60557 //
     /*  369259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  369270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  369273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  369276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369318 */     GIR_RootConstrainSelectedInstOperands,
     /*  369319 */     // GIR_Coverage, 60557,
     /*  369319 */     GIR_EraseRootFromParent_Done,
     /*  369320 */   // Label 6672: @369320
     /*  369320 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(369386), // Rule ID 60560 //
     /*  369325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369384 */     GIR_RootConstrainSelectedInstOperands,
     /*  369385 */     // GIR_Coverage, 60560,
     /*  369385 */     GIR_EraseRootFromParent_Done,
     /*  369386 */   // Label 6673: @369386
     /*  369386 */   GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(369452), // Rule ID 60561 //
     /*  369391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  369402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  369405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  369408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369450 */     GIR_RootConstrainSelectedInstOperands,
     /*  369451 */     // GIR_Coverage, 60561,
     /*  369451 */     GIR_EraseRootFromParent_Done,
     /*  369452 */   // Label 6674: @369452
     /*  369452 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(369518), // Rule ID 60564 //
     /*  369457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  369468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  369471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  369474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  369496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369516 */     GIR_RootConstrainSelectedInstOperands,
     /*  369517 */     // GIR_Coverage, 60564,
     /*  369517 */     GIR_EraseRootFromParent_Done,
     /*  369518 */   // Label 6675: @369518
     /*  369518 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(369584), // Rule ID 60565 //
     /*  369523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  369534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  369537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  369540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  369562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  369579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369582 */     GIR_RootConstrainSelectedInstOperands,
     /*  369583 */     // GIR_Coverage, 60565,
     /*  369583 */     GIR_EraseRootFromParent_Done,
     /*  369584 */   // Label 6676: @369584
     /*  369584 */   GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(369650), // Rule ID 60568 //
     /*  369589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  369600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  369603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  369606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369648 */     GIR_RootConstrainSelectedInstOperands,
     /*  369649 */     // GIR_Coverage, 60568,
     /*  369649 */     GIR_EraseRootFromParent_Done,
     /*  369650 */   // Label 6677: @369650
     /*  369650 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(369716), // Rule ID 60569 //
     /*  369655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  369666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  369669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  369672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  369687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11095:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /*  369697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369714 */     GIR_RootConstrainSelectedInstOperands,
     /*  369715 */     // GIR_Coverage, 60569,
     /*  369715 */     GIR_EraseRootFromParent_Done,
     /*  369716 */   // Label 6678: @369716
     /*  369716 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(369782), // Rule ID 60572 //
     /*  369721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  369732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  369735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  369738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369780 */     GIR_RootConstrainSelectedInstOperands,
     /*  369781 */     // GIR_Coverage, 60572,
     /*  369781 */     GIR_EraseRootFromParent_Done,
     /*  369782 */   // Label 6679: @369782
     /*  369782 */   GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(369848), // Rule ID 60573 //
     /*  369787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  369798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  369801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  369804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  369819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369826 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11095:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /*  369829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369846 */     GIR_RootConstrainSelectedInstOperands,
     /*  369847 */     // GIR_Coverage, 60573,
     /*  369847 */     GIR_EraseRootFromParent_Done,
     /*  369848 */   // Label 6680: @369848
     /*  369848 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(369914), // Rule ID 60576 //
     /*  369853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  369864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  369867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  369870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  369873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369892 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  369892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369912 */     GIR_RootConstrainSelectedInstOperands,
     /*  369913 */     // GIR_Coverage, 60576,
     /*  369913 */     GIR_EraseRootFromParent_Done,
     /*  369914 */   // Label 6681: @369914
     /*  369914 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(369980), // Rule ID 60577 //
     /*  369919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  369922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev),
     /*  369927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  369930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  369933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  369936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  369939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  369951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  369958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11095:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  369958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /*  369961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  369963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  369965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  369967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  369972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  369975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  369978 */     GIR_RootConstrainSelectedInstOperands,
     /*  369979 */     // GIR_Coverage, 60577,
     /*  369979 */     GIR_EraseRootFromParent_Done,
     /*  369980 */   // Label 6682: @369980
     /*  369980 */   GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(370046), // Rule ID 60580 //
     /*  369985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  369988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  369993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  369996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  369999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370044 */     GIR_RootConstrainSelectedInstOperands,
     /*  370045 */     // GIR_Coverage, 60580,
     /*  370045 */     GIR_EraseRootFromParent_Done,
     /*  370046 */   // Label 6683: @370046
     /*  370046 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(370112), // Rule ID 60581 //
     /*  370051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  370062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  370065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  370068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /*  370093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370110 */     GIR_RootConstrainSelectedInstOperands,
     /*  370111 */     // GIR_Coverage, 60581,
     /*  370111 */     GIR_EraseRootFromParent_Done,
     /*  370112 */   // Label 6684: @370112
     /*  370112 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(370178), // Rule ID 60584 //
     /*  370117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370156 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370176 */     GIR_RootConstrainSelectedInstOperands,
     /*  370177 */     // GIR_Coverage, 60584,
     /*  370177 */     GIR_EraseRootFromParent_Done,
     /*  370178 */   // Label 6685: @370178
     /*  370178 */   GIM_Try, /*On fail goto*//*Label 6686*/ GIMT_Encode4(370244), // Rule ID 60585 //
     /*  370183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  370194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  370197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  370200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370222 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370242 */     GIR_RootConstrainSelectedInstOperands,
     /*  370243 */     // GIR_Coverage, 60585,
     /*  370243 */     GIR_EraseRootFromParent_Done,
     /*  370244 */   // Label 6686: @370244
     /*  370244 */   GIM_Try, /*On fail goto*//*Label 6687*/ GIMT_Encode4(370310), // Rule ID 60588 //
     /*  370249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370308 */     GIR_RootConstrainSelectedInstOperands,
     /*  370309 */     // GIR_Coverage, 60588,
     /*  370309 */     GIR_EraseRootFromParent_Done,
     /*  370310 */   // Label 6687: @370310
     /*  370310 */   GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(370376), // Rule ID 60589 //
     /*  370315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  370326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  370329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  370332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370354 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370374 */     GIR_RootConstrainSelectedInstOperands,
     /*  370375 */     // GIR_Coverage, 60589,
     /*  370375 */     GIR_EraseRootFromParent_Done,
     /*  370376 */   // Label 6688: @370376
     /*  370376 */   GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(370442), // Rule ID 60592 //
     /*  370381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370420 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370440 */     GIR_RootConstrainSelectedInstOperands,
     /*  370441 */     // GIR_Coverage, 60592,
     /*  370441 */     GIR_EraseRootFromParent_Done,
     /*  370442 */   // Label 6689: @370442
     /*  370442 */   GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(370508), // Rule ID 60593 //
     /*  370447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  370458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  370461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  370464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370486 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /*  370489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370506 */     GIR_RootConstrainSelectedInstOperands,
     /*  370507 */     // GIR_Coverage, 60593,
     /*  370507 */     GIR_EraseRootFromParent_Done,
     /*  370508 */   // Label 6690: @370508
     /*  370508 */   GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(370574), // Rule ID 60596 //
     /*  370513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  370524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  370527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  370530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370572 */     GIR_RootConstrainSelectedInstOperands,
     /*  370573 */     // GIR_Coverage, 60596,
     /*  370573 */     GIR_EraseRootFromParent_Done,
     /*  370574 */   // Label 6691: @370574
     /*  370574 */   GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(370640), // Rule ID 60597 //
     /*  370579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  370590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  370593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  370596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  370618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370638 */     GIR_RootConstrainSelectedInstOperands,
     /*  370639 */     // GIR_Coverage, 60597,
     /*  370639 */     GIR_EraseRootFromParent_Done,
     /*  370640 */   // Label 6692: @370640
     /*  370640 */   GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(370706), // Rule ID 60600 //
     /*  370645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  370656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  370659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  370662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370684 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  370684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370704 */     GIR_RootConstrainSelectedInstOperands,
     /*  370705 */     // GIR_Coverage, 60600,
     /*  370705 */     GIR_EraseRootFromParent_Done,
     /*  370706 */   // Label 6693: @370706
     /*  370706 */   GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(370772), // Rule ID 60601 //
     /*  370711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  370722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  370725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  370728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  370750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /*  370753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  370767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370770 */     GIR_RootConstrainSelectedInstOperands,
     /*  370771 */     // GIR_Coverage, 60601,
     /*  370771 */     GIR_EraseRootFromParent_Done,
     /*  370772 */   // Label 6694: @370772
     /*  370772 */   GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(370838), // Rule ID 60604 //
     /*  370777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  370788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  370791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  370794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  370816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  370819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370836 */     GIR_RootConstrainSelectedInstOperands,
     /*  370837 */     // GIR_Coverage, 60604,
     /*  370837 */     GIR_EraseRootFromParent_Done,
     /*  370838 */   // Label 6695: @370838
     /*  370838 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(370904), // Rule ID 60605 //
     /*  370843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  370854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  370857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  370860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11103:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  370882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  370885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  370899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370902 */     GIR_RootConstrainSelectedInstOperands,
     /*  370903 */     // GIR_Coverage, 60605,
     /*  370903 */     GIR_EraseRootFromParent_Done,
     /*  370904 */   // Label 6696: @370904
     /*  370904 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(370970), // Rule ID 60608 //
     /*  370909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  370912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  370920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  370923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  370926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  370929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  370948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  370948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  370951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  370953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  370955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  370957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  370962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  370965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  370968 */     GIR_RootConstrainSelectedInstOperands,
     /*  370969 */     // GIR_Coverage, 60608,
     /*  370969 */     GIR_EraseRootFromParent_Done,
     /*  370970 */   // Label 6697: @370970
     /*  370970 */   GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(371036), // Rule ID 60609 //
     /*  370975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  370978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  370983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  370986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  370989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  370992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  370995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  370999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11103:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371034 */     GIR_RootConstrainSelectedInstOperands,
     /*  371035 */     // GIR_Coverage, 60609,
     /*  371035 */     GIR_EraseRootFromParent_Done,
     /*  371036 */   // Label 6698: @371036
     /*  371036 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(371102), // Rule ID 60612 //
     /*  371041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  371080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371100 */     GIR_RootConstrainSelectedInstOperands,
     /*  371101 */     // GIR_Coverage, 60612,
     /*  371101 */     GIR_EraseRootFromParent_Done,
     /*  371102 */   // Label 6699: @371102
     /*  371102 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(371168), // Rule ID 60613 //
     /*  371107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  371118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  371121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  371124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11103:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  371146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  371163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371166 */     GIR_RootConstrainSelectedInstOperands,
     /*  371167 */     // GIR_Coverage, 60613,
     /*  371167 */     GIR_EraseRootFromParent_Done,
     /*  371168 */   // Label 6700: @371168
     /*  371168 */   GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(371234), // Rule ID 60616 //
     /*  371173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371212 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  371212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371232 */     GIR_RootConstrainSelectedInstOperands,
     /*  371233 */     // GIR_Coverage, 60616,
     /*  371233 */     GIR_EraseRootFromParent_Done,
     /*  371234 */   // Label 6701: @371234
     /*  371234 */   GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(371300), // Rule ID 60617 //
     /*  371239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  371250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  371253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  371256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  371271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11103:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  371278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /*  371281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  371295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371298 */     GIR_RootConstrainSelectedInstOperands,
     /*  371299 */     // GIR_Coverage, 60617,
     /*  371299 */     GIR_EraseRootFromParent_Done,
     /*  371300 */   // Label 6702: @371300
     /*  371300 */   GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(371366), // Rule ID 60620 //
     /*  371305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371364 */     GIR_RootConstrainSelectedInstOperands,
     /*  371365 */     // GIR_Coverage, 60620,
     /*  371365 */     GIR_EraseRootFromParent_Done,
     /*  371366 */   // Label 6703: @371366
     /*  371366 */   GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(371432), // Rule ID 60621 //
     /*  371371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  371382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  371385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  371388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371410 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371430 */     GIR_RootConstrainSelectedInstOperands,
     /*  371431 */     // GIR_Coverage, 60621,
     /*  371431 */     GIR_EraseRootFromParent_Done,
     /*  371432 */   // Label 6704: @371432
     /*  371432 */   GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(371498), // Rule ID 60624 //
     /*  371437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  371448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  371451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  371454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371476 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371496 */     GIR_RootConstrainSelectedInstOperands,
     /*  371497 */     // GIR_Coverage, 60624,
     /*  371497 */     GIR_EraseRootFromParent_Done,
     /*  371498 */   // Label 6705: @371498
     /*  371498 */   GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(371564), // Rule ID 60625 //
     /*  371503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  371514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  371517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  371520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371542 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371562 */     GIR_RootConstrainSelectedInstOperands,
     /*  371563 */     // GIR_Coverage, 60625,
     /*  371563 */     GIR_EraseRootFromParent_Done,
     /*  371564 */   // Label 6706: @371564
     /*  371564 */   GIM_Try, /*On fail goto*//*Label 6707*/ GIMT_Encode4(371630), // Rule ID 60628 //
     /*  371569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  371580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  371583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  371586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  371608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  371611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371628 */     GIR_RootConstrainSelectedInstOperands,
     /*  371629 */     // GIR_Coverage, 60628,
     /*  371629 */     GIR_EraseRootFromParent_Done,
     /*  371630 */   // Label 6707: @371630
     /*  371630 */   GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(371696), // Rule ID 60629 //
     /*  371635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  371646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  371649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  371652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371674 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  371674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  371677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  371691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371694 */     GIR_RootConstrainSelectedInstOperands,
     /*  371695 */     // GIR_Coverage, 60629,
     /*  371695 */     GIR_EraseRootFromParent_Done,
     /*  371696 */   // Label 6708: @371696
     /*  371696 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(371762), // Rule ID 60632 //
     /*  371701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  371712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  371715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  371718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371760 */     GIR_RootConstrainSelectedInstOperands,
     /*  371761 */     // GIR_Coverage, 60632,
     /*  371761 */     GIR_EraseRootFromParent_Done,
     /*  371762 */   // Label 6709: @371762
     /*  371762 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(371828), // Rule ID 60633 //
     /*  371767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  371778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  371781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  371784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  371799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  371809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371826 */     GIR_RootConstrainSelectedInstOperands,
     /*  371827 */     // GIR_Coverage, 60633,
     /*  371827 */     GIR_EraseRootFromParent_Done,
     /*  371828 */   // Label 6710: @371828
     /*  371828 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(371894), // Rule ID 60636 //
     /*  371833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  371844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  371847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  371850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371872 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  371872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371892 */     GIR_RootConstrainSelectedInstOperands,
     /*  371893 */     // GIR_Coverage, 60636,
     /*  371893 */     GIR_EraseRootFromParent_Done,
     /*  371894 */   // Label 6711: @371894
     /*  371894 */   GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(371960), // Rule ID 60637 //
     /*  371899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  371902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  371910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  371913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  371916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  371919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  371931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  371938 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  371938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  371941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  371943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  371945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  371947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  371952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  371955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  371958 */     GIR_RootConstrainSelectedInstOperands,
     /*  371959 */     // GIR_Coverage, 60637,
     /*  371959 */     GIR_EraseRootFromParent_Done,
     /*  371960 */   // Label 6712: @371960
     /*  371960 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(372026), // Rule ID 60640 //
     /*  371965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  371968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  371973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  371976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  371979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  371982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  371985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  371997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  372004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372024 */     GIR_RootConstrainSelectedInstOperands,
     /*  372025 */     // GIR_Coverage, 60640,
     /*  372025 */     GIR_EraseRootFromParent_Done,
     /*  372026 */   // Label 6713: @372026
     /*  372026 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(372092), // Rule ID 60641 //
     /*  372031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  372042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  372045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  372048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  372070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  372087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372090 */     GIR_RootConstrainSelectedInstOperands,
     /*  372091 */     // GIR_Coverage, 60641,
     /*  372091 */     GIR_EraseRootFromParent_Done,
     /*  372092 */   // Label 6714: @372092
     /*  372092 */   GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(372158), // Rule ID 60644 //
     /*  372097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372156 */     GIR_RootConstrainSelectedInstOperands,
     /*  372157 */     // GIR_Coverage, 60644,
     /*  372157 */     GIR_EraseRootFromParent_Done,
     /*  372158 */   // Label 6715: @372158
     /*  372158 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(372224), // Rule ID 60645 //
     /*  372163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  372174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  372177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  372180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372222 */     GIR_RootConstrainSelectedInstOperands,
     /*  372223 */     // GIR_Coverage, 60645,
     /*  372223 */     GIR_EraseRootFromParent_Done,
     /*  372224 */   // Label 6716: @372224
     /*  372224 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(372290), // Rule ID 60648 //
     /*  372229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372288 */     GIR_RootConstrainSelectedInstOperands,
     /*  372289 */     // GIR_Coverage, 60648,
     /*  372289 */     GIR_EraseRootFromParent_Done,
     /*  372290 */   // Label 6717: @372290
     /*  372290 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(372356), // Rule ID 60649 //
     /*  372295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  372306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  372309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  372312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372354 */     GIR_RootConstrainSelectedInstOperands,
     /*  372355 */     // GIR_Coverage, 60649,
     /*  372355 */     GIR_EraseRootFromParent_Done,
     /*  372356 */   // Label 6718: @372356
     /*  372356 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(372422), // Rule ID 60652 //
     /*  372361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  372400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372420 */     GIR_RootConstrainSelectedInstOperands,
     /*  372421 */     // GIR_Coverage, 60652,
     /*  372421 */     GIR_EraseRootFromParent_Done,
     /*  372422 */   // Label 6719: @372422
     /*  372422 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(372488), // Rule ID 60653 //
     /*  372427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  372438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  372441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  372444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  372466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  372483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372486 */     GIR_RootConstrainSelectedInstOperands,
     /*  372487 */     // GIR_Coverage, 60653,
     /*  372487 */     GIR_EraseRootFromParent_Done,
     /*  372488 */   // Label 6720: @372488
     /*  372488 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(372554), // Rule ID 60656 //
     /*  372493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  372504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  372507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  372510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372532 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372552 */     GIR_RootConstrainSelectedInstOperands,
     /*  372553 */     // GIR_Coverage, 60656,
     /*  372553 */     GIR_EraseRootFromParent_Done,
     /*  372554 */   // Label 6721: @372554
     /*  372554 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(372620), // Rule ID 60657 //
     /*  372559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  372570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  372573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  372576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  372591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11103:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /*  372601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372618 */     GIR_RootConstrainSelectedInstOperands,
     /*  372619 */     // GIR_Coverage, 60657,
     /*  372619 */     GIR_EraseRootFromParent_Done,
     /*  372620 */   // Label 6722: @372620
     /*  372620 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(372686), // Rule ID 60660 //
     /*  372625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  372636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  372639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  372642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372684 */     GIR_RootConstrainSelectedInstOperands,
     /*  372685 */     // GIR_Coverage, 60660,
     /*  372685 */     GIR_EraseRootFromParent_Done,
     /*  372686 */   // Label 6723: @372686
     /*  372686 */   GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(372752), // Rule ID 60661 //
     /*  372691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  372702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  372705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  372708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  372723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372730 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11103:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /*  372733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372750 */     GIR_RootConstrainSelectedInstOperands,
     /*  372751 */     // GIR_Coverage, 60661,
     /*  372751 */     GIR_EraseRootFromParent_Done,
     /*  372752 */   // Label 6724: @372752
     /*  372752 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(372818), // Rule ID 60664 //
     /*  372757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  372768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  372771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  372774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  372796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372816 */     GIR_RootConstrainSelectedInstOperands,
     /*  372817 */     // GIR_Coverage, 60664,
     /*  372817 */     GIR_EraseRootFromParent_Done,
     /*  372818 */   // Label 6725: @372818
     /*  372818 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(372884), // Rule ID 60665 //
     /*  372823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz),
     /*  372831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  372834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  372837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  372840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  372855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11103:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  372862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /*  372865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  372879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372882 */     GIR_RootConstrainSelectedInstOperands,
     /*  372883 */     // GIR_Coverage, 60665,
     /*  372883 */     GIR_EraseRootFromParent_Done,
     /*  372884 */   // Label 6726: @372884
     /*  372884 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(372950), // Rule ID 60668 //
     /*  372889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  372892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  372897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  372900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  372903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  372906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  372909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  372928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  372931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  372935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  372937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  372942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  372945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  372948 */     GIR_RootConstrainSelectedInstOperands,
     /*  372949 */     // GIR_Coverage, 60668,
     /*  372949 */     GIR_EraseRootFromParent_Done,
     /*  372950 */   // Label 6727: @372950
     /*  372950 */   GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(373016), // Rule ID 60669 //
     /*  372955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  372958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  372963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  372966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  372969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  372972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  372975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  372987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  372994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  372994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /*  372997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  372999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373014 */     GIR_RootConstrainSelectedInstOperands,
     /*  373015 */     // GIR_Coverage, 60669,
     /*  373015 */     GIR_EraseRootFromParent_Done,
     /*  373016 */   // Label 6728: @373016
     /*  373016 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(373082), // Rule ID 60672 //
     /*  373021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373060 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373080 */     GIR_RootConstrainSelectedInstOperands,
     /*  373081 */     // GIR_Coverage, 60672,
     /*  373081 */     GIR_EraseRootFromParent_Done,
     /*  373082 */   // Label 6729: @373082
     /*  373082 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(373148), // Rule ID 60673 //
     /*  373087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  373098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  373101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  373104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373126 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373146 */     GIR_RootConstrainSelectedInstOperands,
     /*  373147 */     // GIR_Coverage, 60673,
     /*  373147 */     GIR_EraseRootFromParent_Done,
     /*  373148 */   // Label 6730: @373148
     /*  373148 */   GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(373214), // Rule ID 60676 //
     /*  373153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373192 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373212 */     GIR_RootConstrainSelectedInstOperands,
     /*  373213 */     // GIR_Coverage, 60676,
     /*  373213 */     GIR_EraseRootFromParent_Done,
     /*  373214 */   // Label 6731: @373214
     /*  373214 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(373280), // Rule ID 60677 //
     /*  373219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  373230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  373233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  373236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373278 */     GIR_RootConstrainSelectedInstOperands,
     /*  373279 */     // GIR_Coverage, 60677,
     /*  373279 */     GIR_EraseRootFromParent_Done,
     /*  373280 */   // Label 6732: @373280
     /*  373280 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(373346), // Rule ID 60680 //
     /*  373285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373324 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373344 */     GIR_RootConstrainSelectedInstOperands,
     /*  373345 */     // GIR_Coverage, 60680,
     /*  373345 */     GIR_EraseRootFromParent_Done,
     /*  373346 */   // Label 6733: @373346
     /*  373346 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(373412), // Rule ID 60681 //
     /*  373351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  373362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  373365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  373368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /*  373393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373410 */     GIR_RootConstrainSelectedInstOperands,
     /*  373411 */     // GIR_Coverage, 60681,
     /*  373411 */     GIR_EraseRootFromParent_Done,
     /*  373412 */   // Label 6734: @373412
     /*  373412 */   GIM_Try, /*On fail goto*//*Label 6735*/ GIMT_Encode4(373478), // Rule ID 60684 //
     /*  373417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  373428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  373431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  373434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373456 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373476 */     GIR_RootConstrainSelectedInstOperands,
     /*  373477 */     // GIR_Coverage, 60684,
     /*  373477 */     GIR_EraseRootFromParent_Done,
     /*  373478 */   // Label 6735: @373478
     /*  373478 */   GIM_Try, /*On fail goto*//*Label 6736*/ GIMT_Encode4(373544), // Rule ID 60685 //
     /*  373483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  373494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  373497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  373500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373522 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373542 */     GIR_RootConstrainSelectedInstOperands,
     /*  373543 */     // GIR_Coverage, 60685,
     /*  373543 */     GIR_EraseRootFromParent_Done,
     /*  373544 */   // Label 6736: @373544
     /*  373544 */   GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(373610), // Rule ID 60688 //
     /*  373549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  373560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  373563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  373566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373608 */     GIR_RootConstrainSelectedInstOperands,
     /*  373609 */     // GIR_Coverage, 60688,
     /*  373609 */     GIR_EraseRootFromParent_Done,
     /*  373610 */   // Label 6737: @373610
     /*  373610 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(373676), // Rule ID 60689 //
     /*  373615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  373626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  373629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  373632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  373654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /*  373657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  373671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373674 */     GIR_RootConstrainSelectedInstOperands,
     /*  373675 */     // GIR_Coverage, 60689,
     /*  373675 */     GIR_EraseRootFromParent_Done,
     /*  373676 */   // Label 6738: @373676
     /*  373676 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(373742), // Rule ID 60692 //
     /*  373681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  373692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  373695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  373698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373720 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  373720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  373723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373740 */     GIR_RootConstrainSelectedInstOperands,
     /*  373741 */     // GIR_Coverage, 60692,
     /*  373741 */     GIR_EraseRootFromParent_Done,
     /*  373742 */   // Label 6739: @373742
     /*  373742 */   GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(373808), // Rule ID 60693 //
     /*  373747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  373758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  373761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  373764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373786 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11110:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  373786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  373789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  373803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373806 */     GIR_RootConstrainSelectedInstOperands,
     /*  373807 */     // GIR_Coverage, 60693,
     /*  373807 */     GIR_EraseRootFromParent_Done,
     /*  373808 */   // Label 6740: @373808
     /*  373808 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(373874), // Rule ID 60696 //
     /*  373813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  373824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  373827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  373830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  373852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  373855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373872 */     GIR_RootConstrainSelectedInstOperands,
     /*  373873 */     // GIR_Coverage, 60696,
     /*  373873 */     GIR_EraseRootFromParent_Done,
     /*  373874 */   // Label 6741: @373874
     /*  373874 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(373940), // Rule ID 60697 //
     /*  373879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  373882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  373890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  373893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  373896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  373899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373918 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11110:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  373918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  373921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  373935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  373938 */     GIR_RootConstrainSelectedInstOperands,
     /*  373939 */     // GIR_Coverage, 60697,
     /*  373939 */     GIR_EraseRootFromParent_Done,
     /*  373940 */   // Label 6742: @373940
     /*  373940 */   GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(374006), // Rule ID 60700 //
     /*  373945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  373948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  373953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  373956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  373959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  373962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  373965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  373977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  373984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  373984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  373987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  373989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  373991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  373993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  373998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374004 */     GIR_RootConstrainSelectedInstOperands,
     /*  374005 */     // GIR_Coverage, 60700,
     /*  374005 */     GIR_EraseRootFromParent_Done,
     /*  374006 */   // Label 6743: @374006
     /*  374006 */   GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(374072), // Rule ID 60701 //
     /*  374011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  374022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  374025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  374028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11110:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  374050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  374067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374070 */     GIR_RootConstrainSelectedInstOperands,
     /*  374071 */     // GIR_Coverage, 60701,
     /*  374071 */     GIR_EraseRootFromParent_Done,
     /*  374072 */   // Label 6744: @374072
     /*  374072 */   GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(374138), // Rule ID 60704 //
     /*  374077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  374116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374136 */     GIR_RootConstrainSelectedInstOperands,
     /*  374137 */     // GIR_Coverage, 60704,
     /*  374137 */     GIR_EraseRootFromParent_Done,
     /*  374138 */   // Label 6745: @374138
     /*  374138 */   GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(374204), // Rule ID 60705 //
     /*  374143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  374154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  374157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  374160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  374175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374182 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11110:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  374182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /*  374185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  374199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374202 */     GIR_RootConstrainSelectedInstOperands,
     /*  374203 */     // GIR_Coverage, 60705,
     /*  374203 */     GIR_EraseRootFromParent_Done,
     /*  374204 */   // Label 6746: @374204
     /*  374204 */   GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(374270), // Rule ID 60708 //
     /*  374209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374268 */     GIR_RootConstrainSelectedInstOperands,
     /*  374269 */     // GIR_Coverage, 60708,
     /*  374269 */     GIR_EraseRootFromParent_Done,
     /*  374270 */   // Label 6747: @374270
     /*  374270 */   GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(374336), // Rule ID 60709 //
     /*  374275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  374286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  374289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  374292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374314 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374334 */     GIR_RootConstrainSelectedInstOperands,
     /*  374335 */     // GIR_Coverage, 60709,
     /*  374335 */     GIR_EraseRootFromParent_Done,
     /*  374336 */   // Label 6748: @374336
     /*  374336 */   GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(374402), // Rule ID 60712 //
     /*  374341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374400 */     GIR_RootConstrainSelectedInstOperands,
     /*  374401 */     // GIR_Coverage, 60712,
     /*  374401 */     GIR_EraseRootFromParent_Done,
     /*  374402 */   // Label 6749: @374402
     /*  374402 */   GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(374468), // Rule ID 60713 //
     /*  374407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  374418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  374421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  374424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374466 */     GIR_RootConstrainSelectedInstOperands,
     /*  374467 */     // GIR_Coverage, 60713,
     /*  374467 */     GIR_EraseRootFromParent_Done,
     /*  374468 */   // Label 6750: @374468
     /*  374468 */   GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(374534), // Rule ID 60716 //
     /*  374473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  374484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  374487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  374490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374512 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  374512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  374515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374532 */     GIR_RootConstrainSelectedInstOperands,
     /*  374533 */     // GIR_Coverage, 60716,
     /*  374533 */     GIR_EraseRootFromParent_Done,
     /*  374534 */   // Label 6751: @374534
     /*  374534 */   GIM_Try, /*On fail goto*//*Label 6752*/ GIMT_Encode4(374600), // Rule ID 60717 //
     /*  374539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  374550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  374553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  374556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374578 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  374578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  374581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  374595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374598 */     GIR_RootConstrainSelectedInstOperands,
     /*  374599 */     // GIR_Coverage, 60717,
     /*  374599 */     GIR_EraseRootFromParent_Done,
     /*  374600 */   // Label 6752: @374600
     /*  374600 */   GIM_Try, /*On fail goto*//*Label 6753*/ GIMT_Encode4(374666), // Rule ID 60720 //
     /*  374605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  374616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  374619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  374622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374664 */     GIR_RootConstrainSelectedInstOperands,
     /*  374665 */     // GIR_Coverage, 60720,
     /*  374665 */     GIR_EraseRootFromParent_Done,
     /*  374666 */   // Label 6753: @374666
     /*  374666 */   GIM_Try, /*On fail goto*//*Label 6754*/ GIMT_Encode4(374732), // Rule ID 60721 //
     /*  374671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  374682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  374685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  374688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  374703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  374713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374730 */     GIR_RootConstrainSelectedInstOperands,
     /*  374731 */     // GIR_Coverage, 60721,
     /*  374731 */     GIR_EraseRootFromParent_Done,
     /*  374732 */   // Label 6754: @374732
     /*  374732 */   GIM_Try, /*On fail goto*//*Label 6755*/ GIMT_Encode4(374798), // Rule ID 60724 //
     /*  374737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  374748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  374751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  374754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374776 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374796 */     GIR_RootConstrainSelectedInstOperands,
     /*  374797 */     // GIR_Coverage, 60724,
     /*  374797 */     GIR_EraseRootFromParent_Done,
     /*  374798 */   // Label 6755: @374798
     /*  374798 */   GIM_Try, /*On fail goto*//*Label 6756*/ GIMT_Encode4(374864), // Rule ID 60725 //
     /*  374803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  374814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  374817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  374820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  374835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374842 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  374845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374862 */     GIR_RootConstrainSelectedInstOperands,
     /*  374863 */     // GIR_Coverage, 60725,
     /*  374863 */     GIR_EraseRootFromParent_Done,
     /*  374864 */   // Label 6756: @374864
     /*  374864 */   GIM_Try, /*On fail goto*//*Label 6757*/ GIMT_Encode4(374930), // Rule ID 60728 //
     /*  374869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  374872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  374880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  374883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  374886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  374889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374908 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  374908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  374911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374928 */     GIR_RootConstrainSelectedInstOperands,
     /*  374929 */     // GIR_Coverage, 60728,
     /*  374929 */     GIR_EraseRootFromParent_Done,
     /*  374930 */   // Label 6757: @374930
     /*  374930 */   GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(374996), // Rule ID 60729 //
     /*  374935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  374938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  374943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  374946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  374949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  374952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  374955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  374967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  374974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  374974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  374977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  374979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  374981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  374983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  374988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  374991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  374994 */     GIR_RootConstrainSelectedInstOperands,
     /*  374995 */     // GIR_Coverage, 60729,
     /*  374995 */     GIR_EraseRootFromParent_Done,
     /*  374996 */   // Label 6758: @374996
     /*  374996 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(375062), // Rule ID 60732 //
     /*  375001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375060 */     GIR_RootConstrainSelectedInstOperands,
     /*  375061 */     // GIR_Coverage, 60732,
     /*  375061 */     GIR_EraseRootFromParent_Done,
     /*  375062 */   // Label 6759: @375062
     /*  375062 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(375128), // Rule ID 60733 //
     /*  375067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  375078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  375081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  375084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375126 */     GIR_RootConstrainSelectedInstOperands,
     /*  375127 */     // GIR_Coverage, 60733,
     /*  375127 */     GIR_EraseRootFromParent_Done,
     /*  375128 */   // Label 6760: @375128
     /*  375128 */   GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(375194), // Rule ID 60736 //
     /*  375133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375192 */     GIR_RootConstrainSelectedInstOperands,
     /*  375193 */     // GIR_Coverage, 60736,
     /*  375193 */     GIR_EraseRootFromParent_Done,
     /*  375194 */   // Label 6761: @375194
     /*  375194 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(375260), // Rule ID 60737 //
     /*  375199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  375210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  375213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  375216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375258 */     GIR_RootConstrainSelectedInstOperands,
     /*  375259 */     // GIR_Coverage, 60737,
     /*  375259 */     GIR_EraseRootFromParent_Done,
     /*  375260 */   // Label 6762: @375260
     /*  375260 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(375326), // Rule ID 60740 //
     /*  375265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  375304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375324 */     GIR_RootConstrainSelectedInstOperands,
     /*  375325 */     // GIR_Coverage, 60740,
     /*  375325 */     GIR_EraseRootFromParent_Done,
     /*  375326 */   // Label 6763: @375326
     /*  375326 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(375392), // Rule ID 60741 //
     /*  375331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  375342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  375345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  375348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  375370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  375387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375390 */     GIR_RootConstrainSelectedInstOperands,
     /*  375391 */     // GIR_Coverage, 60741,
     /*  375391 */     GIR_EraseRootFromParent_Done,
     /*  375392 */   // Label 6764: @375392
     /*  375392 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(375458), // Rule ID 60744 //
     /*  375397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  375414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375436 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375456 */     GIR_RootConstrainSelectedInstOperands,
     /*  375457 */     // GIR_Coverage, 60744,
     /*  375457 */     GIR_EraseRootFromParent_Done,
     /*  375458 */   // Label 6765: @375458
     /*  375458 */   GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(375524), // Rule ID 60745 //
     /*  375463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  375474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  375477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  375480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  375495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375502 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11110:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /*  375505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375522 */     GIR_RootConstrainSelectedInstOperands,
     /*  375523 */     // GIR_Coverage, 60745,
     /*  375523 */     GIR_EraseRootFromParent_Done,
     /*  375524 */   // Label 6766: @375524
     /*  375524 */   GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(375590), // Rule ID 60748 //
     /*  375529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  375540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  375543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  375546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375568 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375588 */     GIR_RootConstrainSelectedInstOperands,
     /*  375589 */     // GIR_Coverage, 60748,
     /*  375589 */     GIR_EraseRootFromParent_Done,
     /*  375590 */   // Label 6767: @375590
     /*  375590 */   GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(375656), // Rule ID 60749 //
     /*  375595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  375606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  375609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  375612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  375627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11110:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /*  375637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375654 */     GIR_RootConstrainSelectedInstOperands,
     /*  375655 */     // GIR_Coverage, 60749,
     /*  375655 */     GIR_EraseRootFromParent_Done,
     /*  375656 */   // Label 6768: @375656
     /*  375656 */   GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(375722), // Rule ID 60752 //
     /*  375661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  375672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  375675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  375678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375700 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  375700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375720 */     GIR_RootConstrainSelectedInstOperands,
     /*  375721 */     // GIR_Coverage, 60752,
     /*  375721 */     GIR_EraseRootFromParent_Done,
     /*  375722 */   // Label 6769: @375722
     /*  375722 */   GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(375788), // Rule ID 60753 //
     /*  375727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz),
     /*  375735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  375738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  375741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  375744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  375759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11110:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  375766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /*  375769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  375783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375786 */     GIR_RootConstrainSelectedInstOperands,
     /*  375787 */     // GIR_Coverage, 60753,
     /*  375787 */     GIR_EraseRootFromParent_Done,
     /*  375788 */   // Label 6770: @375788
     /*  375788 */   GIM_Try, /*On fail goto*//*Label 6771*/ GIMT_Encode4(375854), // Rule ID 60756 //
     /*  375793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  375801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  375804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  375807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  375810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375832 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  375835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375852 */     GIR_RootConstrainSelectedInstOperands,
     /*  375853 */     // GIR_Coverage, 60756,
     /*  375853 */     GIR_EraseRootFromParent_Done,
     /*  375854 */   // Label 6771: @375854
     /*  375854 */   GIM_Try, /*On fail goto*//*Label 6772*/ GIMT_Encode4(375920), // Rule ID 60757 //
     /*  375859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  375867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  375870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  375873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  375876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  375879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  375898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /*  375901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375918 */     GIR_RootConstrainSelectedInstOperands,
     /*  375919 */     // GIR_Coverage, 60757,
     /*  375919 */     GIR_EraseRootFromParent_Done,
     /*  375920 */   // Label 6772: @375920
     /*  375920 */   GIM_Try, /*On fail goto*//*Label 6773*/ GIMT_Encode4(375986), // Rule ID 60760 //
     /*  375925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  375928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  375933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  375936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  375939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  375942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  375945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  375957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  375964 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  375964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  375967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  375969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  375971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  375973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  375978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  375981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  375984 */     GIR_RootConstrainSelectedInstOperands,
     /*  375985 */     // GIR_Coverage, 60760,
     /*  375985 */     GIR_EraseRootFromParent_Done,
     /*  375986 */   // Label 6773: @375986
     /*  375986 */   GIM_Try, /*On fail goto*//*Label 6774*/ GIMT_Encode4(376052), // Rule ID 60761 //
     /*  375991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  375994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  375999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  376002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  376005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  376008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376030 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376050 */     GIR_RootConstrainSelectedInstOperands,
     /*  376051 */     // GIR_Coverage, 60761,
     /*  376051 */     GIR_EraseRootFromParent_Done,
     /*  376052 */   // Label 6774: @376052
     /*  376052 */   GIM_Try, /*On fail goto*//*Label 6775*/ GIMT_Encode4(376118), // Rule ID 60764 //
     /*  376057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376116 */     GIR_RootConstrainSelectedInstOperands,
     /*  376117 */     // GIR_Coverage, 60764,
     /*  376117 */     GIR_EraseRootFromParent_Done,
     /*  376118 */   // Label 6775: @376118
     /*  376118 */   GIM_Try, /*On fail goto*//*Label 6776*/ GIMT_Encode4(376184), // Rule ID 60765 //
     /*  376123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  376134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  376137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  376140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376182 */     GIR_RootConstrainSelectedInstOperands,
     /*  376183 */     // GIR_Coverage, 60765,
     /*  376183 */     GIR_EraseRootFromParent_Done,
     /*  376184 */   // Label 6776: @376184
     /*  376184 */   GIM_Try, /*On fail goto*//*Label 6777*/ GIMT_Encode4(376250), // Rule ID 60768 //
     /*  376189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376248 */     GIR_RootConstrainSelectedInstOperands,
     /*  376249 */     // GIR_Coverage, 60768,
     /*  376249 */     GIR_EraseRootFromParent_Done,
     /*  376250 */   // Label 6777: @376250
     /*  376250 */   GIM_Try, /*On fail goto*//*Label 6778*/ GIMT_Encode4(376316), // Rule ID 60769 //
     /*  376255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  376266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  376269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  376272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /*  376297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376314 */     GIR_RootConstrainSelectedInstOperands,
     /*  376315 */     // GIR_Coverage, 60769,
     /*  376315 */     GIR_EraseRootFromParent_Done,
     /*  376316 */   // Label 6778: @376316
     /*  376316 */   GIM_Try, /*On fail goto*//*Label 6779*/ GIMT_Encode4(376382), // Rule ID 60772 //
     /*  376321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376380 */     GIR_RootConstrainSelectedInstOperands,
     /*  376381 */     // GIR_Coverage, 60772,
     /*  376381 */     GIR_EraseRootFromParent_Done,
     /*  376382 */   // Label 6779: @376382
     /*  376382 */   GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(376448), // Rule ID 60773 //
     /*  376387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  376398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  376401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  376404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376426 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376446 */     GIR_RootConstrainSelectedInstOperands,
     /*  376447 */     // GIR_Coverage, 60773,
     /*  376447 */     GIR_EraseRootFromParent_Done,
     /*  376448 */   // Label 6780: @376448
     /*  376448 */   GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(376514), // Rule ID 60776 //
     /*  376453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376512 */     GIR_RootConstrainSelectedInstOperands,
     /*  376513 */     // GIR_Coverage, 60776,
     /*  376513 */     GIR_EraseRootFromParent_Done,
     /*  376514 */   // Label 6781: @376514
     /*  376514 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(376580), // Rule ID 60777 //
     /*  376519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  376530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  376533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  376536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /*  376561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376578 */     GIR_RootConstrainSelectedInstOperands,
     /*  376579 */     // GIR_Coverage, 60777,
     /*  376579 */     GIR_EraseRootFromParent_Done,
     /*  376580 */   // Label 6782: @376580
     /*  376580 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(376646), // Rule ID 60780 //
     /*  376585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  376596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  376599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  376602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  376624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376644 */     GIR_RootConstrainSelectedInstOperands,
     /*  376645 */     // GIR_Coverage, 60780,
     /*  376645 */     GIR_EraseRootFromParent_Done,
     /*  376646 */   // Label 6783: @376646
     /*  376646 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(376712), // Rule ID 60781 //
     /*  376651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  376662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  376665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  376668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376690 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11108:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  376690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  376707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376710 */     GIR_RootConstrainSelectedInstOperands,
     /*  376711 */     // GIR_Coverage, 60781,
     /*  376711 */     GIR_EraseRootFromParent_Done,
     /*  376712 */   // Label 6784: @376712
     /*  376712 */   GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(376778), // Rule ID 60784 //
     /*  376717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  376728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  376731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  376734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  376756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376776 */     GIR_RootConstrainSelectedInstOperands,
     /*  376777 */     // GIR_Coverage, 60784,
     /*  376777 */     GIR_EraseRootFromParent_Done,
     /*  376778 */   // Label 6785: @376778
     /*  376778 */   GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(376844), // Rule ID 60785 //
     /*  376783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  376794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  376797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  376800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376822 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11108:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  376822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  376839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376842 */     GIR_RootConstrainSelectedInstOperands,
     /*  376843 */     // GIR_Coverage, 60785,
     /*  376843 */     GIR_EraseRootFromParent_Done,
     /*  376844 */   // Label 6786: @376844
     /*  376844 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(376910), // Rule ID 60788 //
     /*  376849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  376860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  376863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  376866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  376869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  376888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376908 */     GIR_RootConstrainSelectedInstOperands,
     /*  376909 */     // GIR_Coverage, 60788,
     /*  376909 */     GIR_EraseRootFromParent_Done,
     /*  376910 */   // Label 6787: @376910
     /*  376910 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(376976), // Rule ID 60789 //
     /*  376915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  376918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  376926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  376929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  376932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  376935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  376947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  376954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11108:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  376954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  376957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  376959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  376961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  376963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  376968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  376971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  376974 */     GIR_RootConstrainSelectedInstOperands,
     /*  376975 */     // GIR_Coverage, 60789,
     /*  376975 */     GIR_EraseRootFromParent_Done,
     /*  376976 */   // Label 6788: @376976
     /*  376976 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(377042), // Rule ID 60792 //
     /*  376981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  376984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  376989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  376992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  376995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  376998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  377020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377040 */     GIR_RootConstrainSelectedInstOperands,
     /*  377041 */     // GIR_Coverage, 60792,
     /*  377041 */     GIR_EraseRootFromParent_Done,
     /*  377042 */   // Label 6789: @377042
     /*  377042 */   GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(377108), // Rule ID 60793 //
     /*  377047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  377058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  377061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  377064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  377079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11108:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  377086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /*  377089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  377103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377106 */     GIR_RootConstrainSelectedInstOperands,
     /*  377107 */     // GIR_Coverage, 60793,
     /*  377107 */     GIR_EraseRootFromParent_Done,
     /*  377108 */   // Label 6790: @377108
     /*  377108 */   GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(377174), // Rule ID 60796 //
     /*  377113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377152 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377172 */     GIR_RootConstrainSelectedInstOperands,
     /*  377173 */     // GIR_Coverage, 60796,
     /*  377173 */     GIR_EraseRootFromParent_Done,
     /*  377174 */   // Label 6791: @377174
     /*  377174 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(377240), // Rule ID 60797 //
     /*  377179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  377190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  377193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  377196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377218 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377238 */     GIR_RootConstrainSelectedInstOperands,
     /*  377239 */     // GIR_Coverage, 60797,
     /*  377239 */     GIR_EraseRootFromParent_Done,
     /*  377240 */   // Label 6792: @377240
     /*  377240 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(377306), // Rule ID 60800 //
     /*  377245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377304 */     GIR_RootConstrainSelectedInstOperands,
     /*  377305 */     // GIR_Coverage, 60800,
     /*  377305 */     GIR_EraseRootFromParent_Done,
     /*  377306 */   // Label 6793: @377306
     /*  377306 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(377372), // Rule ID 60801 //
     /*  377311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  377322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  377325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  377328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377350 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377370 */     GIR_RootConstrainSelectedInstOperands,
     /*  377371 */     // GIR_Coverage, 60801,
     /*  377371 */     GIR_EraseRootFromParent_Done,
     /*  377372 */   // Label 6794: @377372
     /*  377372 */   GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(377438), // Rule ID 60804 //
     /*  377377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377416 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  377416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377436 */     GIR_RootConstrainSelectedInstOperands,
     /*  377437 */     // GIR_Coverage, 60804,
     /*  377437 */     GIR_EraseRootFromParent_Done,
     /*  377438 */   // Label 6795: @377438
     /*  377438 */   GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(377504), // Rule ID 60805 //
     /*  377443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  377454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  377457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  377460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377482 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  377482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  377499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377502 */     GIR_RootConstrainSelectedInstOperands,
     /*  377503 */     // GIR_Coverage, 60805,
     /*  377503 */     GIR_EraseRootFromParent_Done,
     /*  377504 */   // Label 6796: @377504
     /*  377504 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(377570), // Rule ID 60808 //
     /*  377509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  377520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  377523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  377526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377568 */     GIR_RootConstrainSelectedInstOperands,
     /*  377569 */     // GIR_Coverage, 60808,
     /*  377569 */     GIR_EraseRootFromParent_Done,
     /*  377570 */   // Label 6797: @377570
     /*  377570 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(377636), // Rule ID 60809 //
     /*  377575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  377586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  377589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  377592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377634 */     GIR_RootConstrainSelectedInstOperands,
     /*  377635 */     // GIR_Coverage, 60809,
     /*  377635 */     GIR_EraseRootFromParent_Done,
     /*  377636 */   // Label 6798: @377636
     /*  377636 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(377702), // Rule ID 60812 //
     /*  377641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  377652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  377655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  377658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377700 */     GIR_RootConstrainSelectedInstOperands,
     /*  377701 */     // GIR_Coverage, 60812,
     /*  377701 */     GIR_EraseRootFromParent_Done,
     /*  377702 */   // Label 6799: @377702
     /*  377702 */   GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(377768), // Rule ID 60813 //
     /*  377707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  377718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  377721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  377724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  377739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377746 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  377749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377766 */     GIR_RootConstrainSelectedInstOperands,
     /*  377767 */     // GIR_Coverage, 60813,
     /*  377767 */     GIR_EraseRootFromParent_Done,
     /*  377768 */   // Label 6800: @377768
     /*  377768 */   GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(377834), // Rule ID 60816 //
     /*  377773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  377784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  377787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  377790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377812 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  377812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377832 */     GIR_RootConstrainSelectedInstOperands,
     /*  377833 */     // GIR_Coverage, 60816,
     /*  377833 */     GIR_EraseRootFromParent_Done,
     /*  377834 */   // Label 6801: @377834
     /*  377834 */   GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(377900), // Rule ID 60817 //
     /*  377839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  377850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  377853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  377856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  377871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  377878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  377881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  377895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377898 */     GIR_RootConstrainSelectedInstOperands,
     /*  377899 */     // GIR_Coverage, 60817,
     /*  377899 */     GIR_EraseRootFromParent_Done,
     /*  377900 */   // Label 6802: @377900
     /*  377900 */   GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(377966), // Rule ID 60820 //
     /*  377905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  377908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  377916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  377919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  377922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  377925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  377944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  377944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  377947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  377949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  377951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  377953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  377958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  377961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  377964 */     GIR_RootConstrainSelectedInstOperands,
     /*  377965 */     // GIR_Coverage, 60820,
     /*  377965 */     GIR_EraseRootFromParent_Done,
     /*  377966 */   // Label 6803: @377966
     /*  377966 */   GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(378032), // Rule ID 60821 //
     /*  377971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  377974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  377979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  377982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  377985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  377988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  377991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  377999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378030 */     GIR_RootConstrainSelectedInstOperands,
     /*  378031 */     // GIR_Coverage, 60821,
     /*  378031 */     GIR_EraseRootFromParent_Done,
     /*  378032 */   // Label 6804: @378032
     /*  378032 */   GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(378098), // Rule ID 60824 //
     /*  378037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378096 */     GIR_RootConstrainSelectedInstOperands,
     /*  378097 */     // GIR_Coverage, 60824,
     /*  378097 */     GIR_EraseRootFromParent_Done,
     /*  378098 */   // Label 6805: @378098
     /*  378098 */   GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(378164), // Rule ID 60825 //
     /*  378103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  378114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  378117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  378120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378142 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378162 */     GIR_RootConstrainSelectedInstOperands,
     /*  378163 */     // GIR_Coverage, 60825,
     /*  378163 */     GIR_EraseRootFromParent_Done,
     /*  378164 */   // Label 6806: @378164
     /*  378164 */   GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(378230), // Rule ID 60828 //
     /*  378169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378208 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  378208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378228 */     GIR_RootConstrainSelectedInstOperands,
     /*  378229 */     // GIR_Coverage, 60828,
     /*  378229 */     GIR_EraseRootFromParent_Done,
     /*  378230 */   // Label 6807: @378230
     /*  378230 */   GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(378296), // Rule ID 60829 //
     /*  378235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  378246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  378249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  378252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  378274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  378291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378294 */     GIR_RootConstrainSelectedInstOperands,
     /*  378295 */     // GIR_Coverage, 60829,
     /*  378295 */     GIR_EraseRootFromParent_Done,
     /*  378296 */   // Label 6808: @378296
     /*  378296 */   GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(378362), // Rule ID 60832 //
     /*  378301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378360 */     GIR_RootConstrainSelectedInstOperands,
     /*  378361 */     // GIR_Coverage, 60832,
     /*  378361 */     GIR_EraseRootFromParent_Done,
     /*  378362 */   // Label 6809: @378362
     /*  378362 */   GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(378428), // Rule ID 60833 //
     /*  378367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  378378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  378381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  378384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  378399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11108:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /*  378409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378426 */     GIR_RootConstrainSelectedInstOperands,
     /*  378427 */     // GIR_Coverage, 60833,
     /*  378427 */     GIR_EraseRootFromParent_Done,
     /*  378428 */   // Label 6810: @378428
     /*  378428 */   GIM_Try, /*On fail goto*//*Label 6811*/ GIMT_Encode4(378494), // Rule ID 60836 //
     /*  378433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378472 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378492 */     GIR_RootConstrainSelectedInstOperands,
     /*  378493 */     // GIR_Coverage, 60836,
     /*  378493 */     GIR_EraseRootFromParent_Done,
     /*  378494 */   // Label 6811: @378494
     /*  378494 */   GIM_Try, /*On fail goto*//*Label 6812*/ GIMT_Encode4(378560), // Rule ID 60837 //
     /*  378499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  378510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  378513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  378516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  378531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378538 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11108:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /*  378541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378558 */     GIR_RootConstrainSelectedInstOperands,
     /*  378559 */     // GIR_Coverage, 60837,
     /*  378559 */     GIR_EraseRootFromParent_Done,
     /*  378560 */   // Label 6812: @378560
     /*  378560 */   GIM_Try, /*On fail goto*//*Label 6813*/ GIMT_Encode4(378626), // Rule ID 60840 //
     /*  378565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  378568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  378576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  378579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  378582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378604 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  378604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378624 */     GIR_RootConstrainSelectedInstOperands,
     /*  378625 */     // GIR_Coverage, 60840,
     /*  378625 */     GIR_EraseRootFromParent_Done,
     /*  378626 */   // Label 6813: @378626
     /*  378626 */   GIM_Try, /*On fail goto*//*Label 6814*/ GIMT_Encode4(378692), // Rule ID 60841 //
     /*  378631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  378634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv),
     /*  378639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  378642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  378645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  378648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  378663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11108:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  378670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /*  378673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  378687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378690 */     GIR_RootConstrainSelectedInstOperands,
     /*  378691 */     // GIR_Coverage, 60841,
     /*  378691 */     GIR_EraseRootFromParent_Done,
     /*  378692 */   // Label 6814: @378692
     /*  378692 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(378758), // Rule ID 61264 //
     /*  378697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  378700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  378705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  378708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  378711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  378714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378736 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  378739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378756 */     GIR_RootConstrainSelectedInstOperands,
     /*  378757 */     // GIR_Coverage, 61264,
     /*  378757 */     GIR_EraseRootFromParent_Done,
     /*  378758 */   // Label 6815: @378758
     /*  378758 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(378824), // Rule ID 61265 //
     /*  378763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  378766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  378771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  378774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  378777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  378780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378802 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8),
     /*  378805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378822 */     GIR_RootConstrainSelectedInstOperands,
     /*  378823 */     // GIR_Coverage, 61265,
     /*  378823 */     GIR_EraseRootFromParent_Done,
     /*  378824 */   // Label 6816: @378824
     /*  378824 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(378890), // Rule ID 61268 //
     /*  378829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  378832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  378837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  378840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  378843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  378846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  378868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  378871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378888 */     GIR_RootConstrainSelectedInstOperands,
     /*  378889 */     // GIR_Coverage, 61268,
     /*  378889 */     GIR_EraseRootFromParent_Done,
     /*  378890 */   // Label 6817: @378890
     /*  378890 */   GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(378956), // Rule ID 61269 //
     /*  378895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  378898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  378903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  378906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  378909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  378912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  378915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  378934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  378934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  378937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  378939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  378941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  378943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  378948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  378951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  378954 */     GIR_RootConstrainSelectedInstOperands,
     /*  378955 */     // GIR_Coverage, 61269,
     /*  378955 */     GIR_EraseRootFromParent_Done,
     /*  378956 */   // Label 6818: @378956
     /*  378956 */   GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(379022), // Rule ID 61272 //
     /*  378961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  378964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  378969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  378972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  378975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  378978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  378981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  378993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379020 */     GIR_RootConstrainSelectedInstOperands,
     /*  379021 */     // GIR_Coverage, 61272,
     /*  379021 */     GIR_EraseRootFromParent_Done,
     /*  379022 */   // Label 6819: @379022
     /*  379022 */   GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(379088), // Rule ID 61273 //
     /*  379027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  379038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  379041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  379044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379086 */     GIR_RootConstrainSelectedInstOperands,
     /*  379087 */     // GIR_Coverage, 61273,
     /*  379087 */     GIR_EraseRootFromParent_Done,
     /*  379088 */   // Label 6820: @379088
     /*  379088 */   GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(379154), // Rule ID 61276 //
     /*  379093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379132 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379152 */     GIR_RootConstrainSelectedInstOperands,
     /*  379153 */     // GIR_Coverage, 61276,
     /*  379153 */     GIR_EraseRootFromParent_Done,
     /*  379154 */   // Label 6821: @379154
     /*  379154 */   GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(379220), // Rule ID 61277 //
     /*  379159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  379170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  379173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  379176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4),
     /*  379201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379218 */     GIR_RootConstrainSelectedInstOperands,
     /*  379219 */     // GIR_Coverage, 61277,
     /*  379219 */     GIR_EraseRootFromParent_Done,
     /*  379220 */   // Label 6822: @379220
     /*  379220 */   GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(379286), // Rule ID 61280 //
     /*  379225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379264 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379284 */     GIR_RootConstrainSelectedInstOperands,
     /*  379285 */     // GIR_Coverage, 61280,
     /*  379285 */     GIR_EraseRootFromParent_Done,
     /*  379286 */   // Label 6823: @379286
     /*  379286 */   GIM_Try, /*On fail goto*//*Label 6824*/ GIMT_Encode4(379352), // Rule ID 61281 //
     /*  379291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  379302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  379305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  379308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379350 */     GIR_RootConstrainSelectedInstOperands,
     /*  379351 */     // GIR_Coverage, 61281,
     /*  379351 */     GIR_EraseRootFromParent_Done,
     /*  379352 */   // Label 6824: @379352
     /*  379352 */   GIM_Try, /*On fail goto*//*Label 6825*/ GIMT_Encode4(379418), // Rule ID 61284 //
     /*  379357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379416 */     GIR_RootConstrainSelectedInstOperands,
     /*  379417 */     // GIR_Coverage, 61284,
     /*  379417 */     GIR_EraseRootFromParent_Done,
     /*  379418 */   // Label 6825: @379418
     /*  379418 */   GIM_Try, /*On fail goto*//*Label 6826*/ GIMT_Encode4(379484), // Rule ID 61285 //
     /*  379423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  379434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  379437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  379440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2),
     /*  379465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379482 */     GIR_RootConstrainSelectedInstOperands,
     /*  379483 */     // GIR_Coverage, 61285,
     /*  379483 */     GIR_EraseRootFromParent_Done,
     /*  379484 */   // Label 6826: @379484
     /*  379484 */   GIM_Try, /*On fail goto*//*Label 6827*/ GIMT_Encode4(379550), // Rule ID 61288 //
     /*  379489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  379500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  379503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  379506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  379528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379548 */     GIR_RootConstrainSelectedInstOperands,
     /*  379549 */     // GIR_Coverage, 61288,
     /*  379549 */     GIR_EraseRootFromParent_Done,
     /*  379550 */   // Label 6827: @379550
     /*  379550 */   GIM_Try, /*On fail goto*//*Label 6828*/ GIMT_Encode4(379616), // Rule ID 61289 //
     /*  379555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  379566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  379569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  379572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11097:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  379594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  379611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379614 */     GIR_RootConstrainSelectedInstOperands,
     /*  379615 */     // GIR_Coverage, 61289,
     /*  379615 */     GIR_EraseRootFromParent_Done,
     /*  379616 */   // Label 6828: @379616
     /*  379616 */   GIM_Try, /*On fail goto*//*Label 6829*/ GIMT_Encode4(379682), // Rule ID 61292 //
     /*  379621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  379632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  379635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  379638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  379660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379680 */     GIR_RootConstrainSelectedInstOperands,
     /*  379681 */     // GIR_Coverage, 61292,
     /*  379681 */     GIR_EraseRootFromParent_Done,
     /*  379682 */   // Label 6829: @379682
     /*  379682 */   GIM_Try, /*On fail goto*//*Label 6830*/ GIMT_Encode4(379748), // Rule ID 61293 //
     /*  379687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  379698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  379701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  379704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379726 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11097:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  379726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  379743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379746 */     GIR_RootConstrainSelectedInstOperands,
     /*  379747 */     // GIR_Coverage, 61293,
     /*  379747 */     GIR_EraseRootFromParent_Done,
     /*  379748 */   // Label 6830: @379748
     /*  379748 */   GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(379814), // Rule ID 61296 //
     /*  379753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  379764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  379767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  379770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  379792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379812 */     GIR_RootConstrainSelectedInstOperands,
     /*  379813 */     // GIR_Coverage, 61296,
     /*  379813 */     GIR_EraseRootFromParent_Done,
     /*  379814 */   // Label 6831: @379814
     /*  379814 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(379880), // Rule ID 61297 //
     /*  379819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  379830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  379833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  379836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379858 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11097:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  379858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  379875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379878 */     GIR_RootConstrainSelectedInstOperands,
     /*  379879 */     // GIR_Coverage, 61297,
     /*  379879 */     GIR_EraseRootFromParent_Done,
     /*  379880 */   // Label 6832: @379880
     /*  379880 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(379946), // Rule ID 61300 //
     /*  379885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  379888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  379896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  379899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  379902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  379905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379924 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  379924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  379938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  379941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  379944 */     GIR_RootConstrainSelectedInstOperands,
     /*  379945 */     // GIR_Coverage, 61300,
     /*  379945 */     GIR_EraseRootFromParent_Done,
     /*  379946 */   // Label 6833: @379946
     /*  379946 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(380012), // Rule ID 61301 //
     /*  379951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  379954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  379959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  379962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  379965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  379968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  379971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  379983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  379990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11097:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  379990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1),
     /*  379993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  379995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  379997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  379999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  380007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380010 */     GIR_RootConstrainSelectedInstOperands,
     /*  380011 */     // GIR_Coverage, 61301,
     /*  380011 */     GIR_EraseRootFromParent_Done,
     /*  380012 */   // Label 6834: @380012
     /*  380012 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(380078), // Rule ID 61304 //
     /*  380017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380076 */     GIR_RootConstrainSelectedInstOperands,
     /*  380077 */     // GIR_Coverage, 61304,
     /*  380077 */     GIR_EraseRootFromParent_Done,
     /*  380078 */   // Label 6835: @380078
     /*  380078 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(380144), // Rule ID 61305 //
     /*  380083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  380094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  380097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  380100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380122 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380142 */     GIR_RootConstrainSelectedInstOperands,
     /*  380143 */     // GIR_Coverage, 61305,
     /*  380143 */     GIR_EraseRootFromParent_Done,
     /*  380144 */   // Label 6836: @380144
     /*  380144 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(380210), // Rule ID 61308 //
     /*  380149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380208 */     GIR_RootConstrainSelectedInstOperands,
     /*  380209 */     // GIR_Coverage, 61308,
     /*  380209 */     GIR_EraseRootFromParent_Done,
     /*  380210 */   // Label 6837: @380210
     /*  380210 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(380276), // Rule ID 61309 //
     /*  380215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  380226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  380229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  380232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380274 */     GIR_RootConstrainSelectedInstOperands,
     /*  380275 */     // GIR_Coverage, 61309,
     /*  380275 */     GIR_EraseRootFromParent_Done,
     /*  380276 */   // Label 6838: @380276
     /*  380276 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(380342), // Rule ID 61312 //
     /*  380281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  380320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380340 */     GIR_RootConstrainSelectedInstOperands,
     /*  380341 */     // GIR_Coverage, 61312,
     /*  380341 */     GIR_EraseRootFromParent_Done,
     /*  380342 */   // Label 6839: @380342
     /*  380342 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(380408), // Rule ID 61313 //
     /*  380347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  380358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  380361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  380364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  380386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  380403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380406 */     GIR_RootConstrainSelectedInstOperands,
     /*  380407 */     // GIR_Coverage, 61313,
     /*  380407 */     GIR_EraseRootFromParent_Done,
     /*  380408 */   // Label 6840: @380408
     /*  380408 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(380474), // Rule ID 61316 //
     /*  380413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  380424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  380427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  380430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380472 */     GIR_RootConstrainSelectedInstOperands,
     /*  380473 */     // GIR_Coverage, 61316,
     /*  380473 */     GIR_EraseRootFromParent_Done,
     /*  380474 */   // Label 6841: @380474
     /*  380474 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(380540), // Rule ID 61317 //
     /*  380479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  380490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  380493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  380496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380518 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380538 */     GIR_RootConstrainSelectedInstOperands,
     /*  380539 */     // GIR_Coverage, 61317,
     /*  380539 */     GIR_EraseRootFromParent_Done,
     /*  380540 */   // Label 6842: @380540
     /*  380540 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(380606), // Rule ID 61320 //
     /*  380545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  380556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  380559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  380562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380604 */     GIR_RootConstrainSelectedInstOperands,
     /*  380605 */     // GIR_Coverage, 61320,
     /*  380605 */     GIR_EraseRootFromParent_Done,
     /*  380606 */   // Label 6843: @380606
     /*  380606 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(380672), // Rule ID 61321 //
     /*  380611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  380622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  380625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  380628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380650 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380670 */     GIR_RootConstrainSelectedInstOperands,
     /*  380671 */     // GIR_Coverage, 61321,
     /*  380671 */     GIR_EraseRootFromParent_Done,
     /*  380672 */   // Label 6844: @380672
     /*  380672 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(380738), // Rule ID 61324 //
     /*  380677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  380688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  380691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  380694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  380716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380736 */     GIR_RootConstrainSelectedInstOperands,
     /*  380737 */     // GIR_Coverage, 61324,
     /*  380737 */     GIR_EraseRootFromParent_Done,
     /*  380738 */   // Label 6845: @380738
     /*  380738 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(380804), // Rule ID 61325 //
     /*  380743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  380754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  380757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  380760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  380775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  380782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  380785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  380799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380802 */     GIR_RootConstrainSelectedInstOperands,
     /*  380803 */     // GIR_Coverage, 61325,
     /*  380803 */     GIR_EraseRootFromParent_Done,
     /*  380804 */   // Label 6846: @380804
     /*  380804 */   GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(380870), // Rule ID 61328 //
     /*  380809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  380820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  380823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  380826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380868 */     GIR_RootConstrainSelectedInstOperands,
     /*  380869 */     // GIR_Coverage, 61328,
     /*  380869 */     GIR_EraseRootFromParent_Done,
     /*  380870 */   // Label 6847: @380870
     /*  380870 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(380936), // Rule ID 61329 //
     /*  380875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  380878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  380886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  380889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  380892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  380895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  380907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380914 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  380914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  380917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  380934 */     GIR_RootConstrainSelectedInstOperands,
     /*  380935 */     // GIR_Coverage, 61329,
     /*  380935 */     GIR_EraseRootFromParent_Done,
     /*  380936 */   // Label 6848: @380936
     /*  380936 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(381002), // Rule ID 61332 //
     /*  380941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  380944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  380949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  380952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  380955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  380958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  380961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  380973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  380980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  380980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  380983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  380985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  380987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  380989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  380994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  380997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381000 */     GIR_RootConstrainSelectedInstOperands,
     /*  381001 */     // GIR_Coverage, 61332,
     /*  381001 */     GIR_EraseRootFromParent_Done,
     /*  381002 */   // Label 6849: @381002
     /*  381002 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(381068), // Rule ID 61333 //
     /*  381007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  381018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  381021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  381024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381046 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381066 */     GIR_RootConstrainSelectedInstOperands,
     /*  381067 */     // GIR_Coverage, 61333,
     /*  381067 */     GIR_EraseRootFromParent_Done,
     /*  381068 */   // Label 6850: @381068
     /*  381068 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(381134), // Rule ID 61336 //
     /*  381073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  381112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381132 */     GIR_RootConstrainSelectedInstOperands,
     /*  381133 */     // GIR_Coverage, 61336,
     /*  381133 */     GIR_EraseRootFromParent_Done,
     /*  381134 */   // Label 6851: @381134
     /*  381134 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(381200), // Rule ID 61337 //
     /*  381139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  381150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  381153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  381156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381178 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  381178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  381195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381198 */     GIR_RootConstrainSelectedInstOperands,
     /*  381199 */     // GIR_Coverage, 61337,
     /*  381199 */     GIR_EraseRootFromParent_Done,
     /*  381200 */   // Label 6852: @381200
     /*  381200 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(381266), // Rule ID 61340 //
     /*  381205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381244 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381264 */     GIR_RootConstrainSelectedInstOperands,
     /*  381265 */     // GIR_Coverage, 61340,
     /*  381265 */     GIR_EraseRootFromParent_Done,
     /*  381266 */   // Label 6853: @381266
     /*  381266 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(381332), // Rule ID 61341 //
     /*  381271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  381282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  381285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  381288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  381303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381310 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11097:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2),
     /*  381313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381330 */     GIR_RootConstrainSelectedInstOperands,
     /*  381331 */     // GIR_Coverage, 61341,
     /*  381331 */     GIR_EraseRootFromParent_Done,
     /*  381332 */   // Label 6854: @381332
     /*  381332 */   GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(381398), // Rule ID 61344 //
     /*  381337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381376 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381396 */     GIR_RootConstrainSelectedInstOperands,
     /*  381397 */     // GIR_Coverage, 61344,
     /*  381397 */     GIR_EraseRootFromParent_Done,
     /*  381398 */   // Label 6855: @381398
     /*  381398 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(381464), // Rule ID 61345 //
     /*  381403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  381414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  381417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  381420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  381435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381442 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11097:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4),
     /*  381445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381462 */     GIR_RootConstrainSelectedInstOperands,
     /*  381463 */     // GIR_Coverage, 61345,
     /*  381463 */     GIR_EraseRootFromParent_Done,
     /*  381464 */   // Label 6856: @381464
     /*  381464 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(381530), // Rule ID 61348 //
     /*  381469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  381480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  381483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  381486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381508 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  381508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381528 */     GIR_RootConstrainSelectedInstOperands,
     /*  381529 */     // GIR_Coverage, 61348,
     /*  381529 */     GIR_EraseRootFromParent_Done,
     /*  381530 */   // Label 6857: @381530
     /*  381530 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(381596), // Rule ID 61349 //
     /*  381535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8),
     /*  381543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  381546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  381549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  381552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  381567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11097:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVBREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  381574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8),
     /*  381577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  381591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381594 */     GIR_RootConstrainSelectedInstOperands,
     /*  381595 */     // GIR_Coverage, 61349,
     /*  381595 */     GIR_EraseRootFromParent_Done,
     /*  381596 */   // Label 6858: @381596
     /*  381596 */   GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(381662), // Rule ID 61352 //
     /*  381601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  381612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  381615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  381618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  381643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381660 */     GIR_RootConstrainSelectedInstOperands,
     /*  381661 */     // GIR_Coverage, 61352,
     /*  381661 */     GIR_EraseRootFromParent_Done,
     /*  381662 */   // Label 6859: @381662
     /*  381662 */   GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(381728), // Rule ID 61353 //
     /*  381667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  381678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  381681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  381684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /*  381709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381726 */     GIR_RootConstrainSelectedInstOperands,
     /*  381727 */     // GIR_Coverage, 61353,
     /*  381727 */     GIR_EraseRootFromParent_Done,
     /*  381728 */   // Label 6860: @381728
     /*  381728 */   GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(381794), // Rule ID 61356 //
     /*  381733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  381744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  381747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  381750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381772 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  381775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381792 */     GIR_RootConstrainSelectedInstOperands,
     /*  381793 */     // GIR_Coverage, 61356,
     /*  381793 */     GIR_EraseRootFromParent_Done,
     /*  381794 */   // Label 6861: @381794
     /*  381794 */   GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(381860), // Rule ID 61357 //
     /*  381799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  381810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  381813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  381816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381838 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  381841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381858 */     GIR_RootConstrainSelectedInstOperands,
     /*  381859 */     // GIR_Coverage, 61357,
     /*  381859 */     GIR_EraseRootFromParent_Done,
     /*  381860 */   // Label 6862: @381860
     /*  381860 */   GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(381926), // Rule ID 61360 //
     /*  381865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  381868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  381876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  381879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  381882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  381885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  381904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  381907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381924 */     GIR_RootConstrainSelectedInstOperands,
     /*  381925 */     // GIR_Coverage, 61360,
     /*  381925 */     GIR_EraseRootFromParent_Done,
     /*  381926 */   // Label 6863: @381926
     /*  381926 */   GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(381992), // Rule ID 61361 //
     /*  381931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  381934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  381939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  381942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  381945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  381948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  381951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  381963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  381970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  381970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  381973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  381975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  381977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  381979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  381984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  381987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  381990 */     GIR_RootConstrainSelectedInstOperands,
     /*  381991 */     // GIR_Coverage, 61361,
     /*  381991 */     GIR_EraseRootFromParent_Done,
     /*  381992 */   // Label 6864: @381992
     /*  381992 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(382058), // Rule ID 61364 //
     /*  381997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382056 */     GIR_RootConstrainSelectedInstOperands,
     /*  382057 */     // GIR_Coverage, 61364,
     /*  382057 */     GIR_EraseRootFromParent_Done,
     /*  382058 */   // Label 6865: @382058
     /*  382058 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(382124), // Rule ID 61365 //
     /*  382063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  382074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  382077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  382080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /*  382105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382122 */     GIR_RootConstrainSelectedInstOperands,
     /*  382123 */     // GIR_Coverage, 61365,
     /*  382123 */     GIR_EraseRootFromParent_Done,
     /*  382124 */   // Label 6866: @382124
     /*  382124 */   GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(382190), // Rule ID 61368 //
     /*  382129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382168 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382188 */     GIR_RootConstrainSelectedInstOperands,
     /*  382189 */     // GIR_Coverage, 61368,
     /*  382189 */     GIR_EraseRootFromParent_Done,
     /*  382190 */   // Label 6867: @382190
     /*  382190 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(382256), // Rule ID 61369 //
     /*  382195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  382206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  382209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  382212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382254 */     GIR_RootConstrainSelectedInstOperands,
     /*  382255 */     // GIR_Coverage, 61369,
     /*  382255 */     GIR_EraseRootFromParent_Done,
     /*  382256 */   // Label 6868: @382256
     /*  382256 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(382322), // Rule ID 61372 //
     /*  382261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382320 */     GIR_RootConstrainSelectedInstOperands,
     /*  382321 */     // GIR_Coverage, 61372,
     /*  382321 */     GIR_EraseRootFromParent_Done,
     /*  382322 */   // Label 6869: @382322
     /*  382322 */   GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(382388), // Rule ID 61373 //
     /*  382327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  382338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  382341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  382344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /*  382369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382386 */     GIR_RootConstrainSelectedInstOperands,
     /*  382387 */     // GIR_Coverage, 61373,
     /*  382387 */     GIR_EraseRootFromParent_Done,
     /*  382388 */   // Label 6870: @382388
     /*  382388 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(382454), // Rule ID 61376 //
     /*  382393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382452 */     GIR_RootConstrainSelectedInstOperands,
     /*  382453 */     // GIR_Coverage, 61376,
     /*  382453 */     GIR_EraseRootFromParent_Done,
     /*  382454 */   // Label 6871: @382454
     /*  382454 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(382520), // Rule ID 61377 //
     /*  382459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  382470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  382473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  382476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11448:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  382498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382518 */     GIR_RootConstrainSelectedInstOperands,
     /*  382519 */     // GIR_Coverage, 61377,
     /*  382519 */     GIR_EraseRootFromParent_Done,
     /*  382520 */   // Label 6872: @382520
     /*  382520 */   GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(382586), // Rule ID 61380 //
     /*  382525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  382536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  382539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  382542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  382564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382584 */     GIR_RootConstrainSelectedInstOperands,
     /*  382585 */     // GIR_Coverage, 61380,
     /*  382585 */     GIR_EraseRootFromParent_Done,
     /*  382586 */   // Label 6873: @382586
     /*  382586 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(382652), // Rule ID 61381 //
     /*  382591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  382602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  382605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  382608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11448:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  382630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  382647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382650 */     GIR_RootConstrainSelectedInstOperands,
     /*  382651 */     // GIR_Coverage, 61381,
     /*  382651 */     GIR_EraseRootFromParent_Done,
     /*  382652 */   // Label 6874: @382652
     /*  382652 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(382718), // Rule ID 61384 //
     /*  382657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  382668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  382671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  382674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  382696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382716 */     GIR_RootConstrainSelectedInstOperands,
     /*  382717 */     // GIR_Coverage, 61384,
     /*  382717 */     GIR_EraseRootFromParent_Done,
     /*  382718 */   // Label 6875: @382718
     /*  382718 */   GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(382784), // Rule ID 61385 //
     /*  382723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  382734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  382737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  382740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11448:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  382762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  382779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382782 */     GIR_RootConstrainSelectedInstOperands,
     /*  382783 */     // GIR_Coverage, 61385,
     /*  382783 */     GIR_EraseRootFromParent_Done,
     /*  382784 */   // Label 6876: @382784
     /*  382784 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(382850), // Rule ID 61388 //
     /*  382789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  382800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  382803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  382806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  382828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382848 */     GIR_RootConstrainSelectedInstOperands,
     /*  382849 */     // GIR_Coverage, 61388,
     /*  382849 */     GIR_EraseRootFromParent_Done,
     /*  382850 */   // Label 6877: @382850
     /*  382850 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(382916), // Rule ID 61389 //
     /*  382855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  382866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  382869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  382872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  382875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  382887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11448:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  382894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /*  382897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  382911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382914 */     GIR_RootConstrainSelectedInstOperands,
     /*  382915 */     // GIR_Coverage, 61389,
     /*  382915 */     GIR_EraseRootFromParent_Done,
     /*  382916 */   // Label 6878: @382916
     /*  382916 */   GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(382982), // Rule ID 61392 //
     /*  382921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  382924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  382932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  382935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  382938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  382941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  382953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  382960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  382960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  382963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  382965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  382967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  382969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  382974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  382977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  382980 */     GIR_RootConstrainSelectedInstOperands,
     /*  382981 */     // GIR_Coverage, 61392,
     /*  382981 */     GIR_EraseRootFromParent_Done,
     /*  382982 */   // Label 6879: @382982
     /*  382982 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(383048), // Rule ID 61393 //
     /*  382987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  382990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  382995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  382998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  383001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  383004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383026 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383046 */     GIR_RootConstrainSelectedInstOperands,
     /*  383047 */     // GIR_Coverage, 61393,
     /*  383047 */     GIR_EraseRootFromParent_Done,
     /*  383048 */   // Label 6880: @383048
     /*  383048 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(383114), // Rule ID 61396 //
     /*  383053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383092 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383112 */     GIR_RootConstrainSelectedInstOperands,
     /*  383113 */     // GIR_Coverage, 61396,
     /*  383113 */     GIR_EraseRootFromParent_Done,
     /*  383114 */   // Label 6881: @383114
     /*  383114 */   GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(383180), // Rule ID 61397 //
     /*  383119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  383130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  383133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  383136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383158 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383178 */     GIR_RootConstrainSelectedInstOperands,
     /*  383179 */     // GIR_Coverage, 61397,
     /*  383179 */     GIR_EraseRootFromParent_Done,
     /*  383180 */   // Label 6882: @383180
     /*  383180 */   GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(383246), // Rule ID 61400 //
     /*  383185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383224 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  383224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383244 */     GIR_RootConstrainSelectedInstOperands,
     /*  383245 */     // GIR_Coverage, 61400,
     /*  383245 */     GIR_EraseRootFromParent_Done,
     /*  383246 */   // Label 6883: @383246
     /*  383246 */   GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(383312), // Rule ID 61401 //
     /*  383251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  383262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  383265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  383268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  383290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  383307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383310 */     GIR_RootConstrainSelectedInstOperands,
     /*  383311 */     // GIR_Coverage, 61401,
     /*  383311 */     GIR_EraseRootFromParent_Done,
     /*  383312 */   // Label 6884: @383312
     /*  383312 */   GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(383378), // Rule ID 61404 //
     /*  383317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383376 */     GIR_RootConstrainSelectedInstOperands,
     /*  383377 */     // GIR_Coverage, 61404,
     /*  383377 */     GIR_EraseRootFromParent_Done,
     /*  383378 */   // Label 6885: @383378
     /*  383378 */   GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(383444), // Rule ID 61405 //
     /*  383383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  383394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  383397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  383400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383442 */     GIR_RootConstrainSelectedInstOperands,
     /*  383443 */     // GIR_Coverage, 61405,
     /*  383443 */     GIR_EraseRootFromParent_Done,
     /*  383444 */   // Label 6886: @383444
     /*  383444 */   GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(383510), // Rule ID 61408 //
     /*  383449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  383460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  383463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  383466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383508 */     GIR_RootConstrainSelectedInstOperands,
     /*  383509 */     // GIR_Coverage, 61408,
     /*  383509 */     GIR_EraseRootFromParent_Done,
     /*  383510 */   // Label 6887: @383510
     /*  383510 */   GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(383576), // Rule ID 61409 //
     /*  383515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  383526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  383529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  383532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383574 */     GIR_RootConstrainSelectedInstOperands,
     /*  383575 */     // GIR_Coverage, 61409,
     /*  383575 */     GIR_EraseRootFromParent_Done,
     /*  383576 */   // Label 6888: @383576
     /*  383576 */   GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(383642), // Rule ID 61412 //
     /*  383581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  383592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  383595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  383598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383620 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  383620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383640 */     GIR_RootConstrainSelectedInstOperands,
     /*  383641 */     // GIR_Coverage, 61412,
     /*  383641 */     GIR_EraseRootFromParent_Done,
     /*  383642 */   // Label 6889: @383642
     /*  383642 */   GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(383708), // Rule ID 61413 //
     /*  383647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  383658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  383661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  383664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  383679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383686 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  383686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  383689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  383703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383706 */     GIR_RootConstrainSelectedInstOperands,
     /*  383707 */     // GIR_Coverage, 61413,
     /*  383707 */     GIR_EraseRootFromParent_Done,
     /*  383708 */   // Label 6890: @383708
     /*  383708 */   GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(383774), // Rule ID 61416 //
     /*  383713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  383724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  383727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  383730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383772 */     GIR_RootConstrainSelectedInstOperands,
     /*  383773 */     // GIR_Coverage, 61416,
     /*  383773 */     GIR_EraseRootFromParent_Done,
     /*  383774 */   // Label 6891: @383774
     /*  383774 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(383840), // Rule ID 61417 //
     /*  383779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  383790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  383793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  383796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  383811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383818 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  383821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383838 */     GIR_RootConstrainSelectedInstOperands,
     /*  383839 */     // GIR_Coverage, 61417,
     /*  383839 */     GIR_EraseRootFromParent_Done,
     /*  383840 */   // Label 6892: @383840
     /*  383840 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(383906), // Rule ID 61420 //
     /*  383845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  383856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  383859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  383862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  383884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383904 */     GIR_RootConstrainSelectedInstOperands,
     /*  383905 */     // GIR_Coverage, 61420,
     /*  383905 */     GIR_EraseRootFromParent_Done,
     /*  383906 */   // Label 6893: @383906
     /*  383906 */   GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(383972), // Rule ID 61421 //
     /*  383911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  383914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  383922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  383925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  383928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  383931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  383943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  383950 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  383950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  383953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  383955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  383957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  383959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  383964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  383967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  383970 */     GIR_RootConstrainSelectedInstOperands,
     /*  383971 */     // GIR_Coverage, 61421,
     /*  383971 */     GIR_EraseRootFromParent_Done,
     /*  383972 */   // Label 6894: @383972
     /*  383972 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(384038), // Rule ID 61424 //
     /*  383977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  383980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  383985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  383988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  383991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  383994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  383997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  384016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384036 */     GIR_RootConstrainSelectedInstOperands,
     /*  384037 */     // GIR_Coverage, 61424,
     /*  384037 */     GIR_EraseRootFromParent_Done,
     /*  384038 */   // Label 6895: @384038
     /*  384038 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(384104), // Rule ID 61425 //
     /*  384043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  384054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  384057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  384060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  384082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  384099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384102 */     GIR_RootConstrainSelectedInstOperands,
     /*  384103 */     // GIR_Coverage, 61425,
     /*  384103 */     GIR_EraseRootFromParent_Done,
     /*  384104 */   // Label 6896: @384104
     /*  384104 */   GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(384170), // Rule ID 61428 //
     /*  384109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384148 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384168 */     GIR_RootConstrainSelectedInstOperands,
     /*  384169 */     // GIR_Coverage, 61428,
     /*  384169 */     GIR_EraseRootFromParent_Done,
     /*  384170 */   // Label 6897: @384170
     /*  384170 */   GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(384236), // Rule ID 61429 //
     /*  384175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  384186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  384189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  384192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  384207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11448:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /*  384217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384234 */     GIR_RootConstrainSelectedInstOperands,
     /*  384235 */     // GIR_Coverage, 61429,
     /*  384235 */     GIR_EraseRootFromParent_Done,
     /*  384236 */   // Label 6898: @384236
     /*  384236 */   GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(384302), // Rule ID 61432 //
     /*  384241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384300 */     GIR_RootConstrainSelectedInstOperands,
     /*  384301 */     // GIR_Coverage, 61432,
     /*  384301 */     GIR_EraseRootFromParent_Done,
     /*  384302 */   // Label 6899: @384302
     /*  384302 */   GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(384368), // Rule ID 61433 //
     /*  384307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  384318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  384321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  384324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  384339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11448:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /*  384349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384366 */     GIR_RootConstrainSelectedInstOperands,
     /*  384367 */     // GIR_Coverage, 61433,
     /*  384367 */     GIR_EraseRootFromParent_Done,
     /*  384368 */   // Label 6900: @384368
     /*  384368 */   GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(384434), // Rule ID 61436 //
     /*  384373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  384376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  384393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384412 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  384412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384432 */     GIR_RootConstrainSelectedInstOperands,
     /*  384433 */     // GIR_Coverage, 61436,
     /*  384433 */     GIR_EraseRootFromParent_Done,
     /*  384434 */   // Label 6901: @384434
     /*  384434 */   GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(384500), // Rule ID 61437 //
     /*  384439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  384442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8),
     /*  384447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  384450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  384453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  384456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  384471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  384478 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11448:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  384478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /*  384481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  384485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  384492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  384495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  384498 */     GIR_RootConstrainSelectedInstOperands,
     /*  384499 */     // GIR_Coverage, 61437,
     /*  384499 */     GIR_EraseRootFromParent_Done,
     /*  384500 */   // Label 6902: @384500
     /*  384500 */   GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(384565), // Rule ID 64427 //
     /*  384505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  384513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384549 */     // MIs[1] Operand 1
     /*  384549 */     // No operand predicates
     /*  384549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384551 */     // (intrinsic_wo_chain:{ *:[i32] } 10915:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDN),
     /*  384554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384563 */     GIR_RootConstrainSelectedInstOperands,
     /*  384564 */     // GIR_Coverage, 64427,
     /*  384564 */     GIR_EraseRootFromParent_Done,
     /*  384565 */   // Label 6903: @384565
     /*  384565 */   GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(384630), // Rule ID 64454 //
     /*  384570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  384578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384614 */     // MIs[1] Operand 1
     /*  384614 */     // No operand predicates
     /*  384614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384616 */     // (intrinsic_wo_chain:{ *:[i32] } 10917:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUN),
     /*  384619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384628 */     GIR_RootConstrainSelectedInstOperands,
     /*  384629 */     // GIR_Coverage, 64454,
     /*  384629 */     GIR_EraseRootFromParent_Done,
     /*  384630 */   // Label 6904: @384630
     /*  384630 */   GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(384695), // Rule ID 64457 //
     /*  384635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  384643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384679 */     // MIs[1] Operand 1
     /*  384679 */     // No operand predicates
     /*  384679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384681 */     // (intrinsic_wo_chain:{ *:[i32] } 10916:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRN),
     /*  384684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384693 */     GIR_RootConstrainSelectedInstOperands,
     /*  384694 */     // GIR_Coverage, 64457,
     /*  384694 */     GIR_EraseRootFromParent_Done,
     /*  384695 */   // Label 6905: @384695
     /*  384695 */   GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(384760), // Rule ID 64460 //
     /*  384700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  384708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384744 */     // MIs[1] Operand 1
     /*  384744 */     // No operand predicates
     /*  384744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384746 */     // (intrinsic_wo_chain:{ *:[i32] } 10918:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_ADDURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURN),
     /*  384749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384758 */     GIR_RootConstrainSelectedInstOperands,
     /*  384759 */     // GIR_Coverage, 64460,
     /*  384759 */     GIR_EraseRootFromParent_Done,
     /*  384760 */   // Label 6906: @384760
     /*  384760 */   GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(384825), // Rule ID 64463 //
     /*  384765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  384773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384805 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384809 */     // MIs[1] Operand 1
     /*  384809 */     // No operand predicates
     /*  384809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384811 */     // (intrinsic_wo_chain:{ *:[i32] } 10921:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBN),
     /*  384814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384823 */     GIR_RootConstrainSelectedInstOperands,
     /*  384824 */     // GIR_Coverage, 64463,
     /*  384824 */     GIR_EraseRootFromParent_Done,
     /*  384825 */   // Label 6907: @384825
     /*  384825 */   GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(384890), // Rule ID 64466 //
     /*  384830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  384838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384874 */     // MIs[1] Operand 1
     /*  384874 */     // No operand predicates
     /*  384874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384876 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUN),
     /*  384879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384888 */     GIR_RootConstrainSelectedInstOperands,
     /*  384889 */     // GIR_Coverage, 64466,
     /*  384889 */     GIR_EraseRootFromParent_Done,
     /*  384890 */   // Label 6908: @384890
     /*  384890 */   GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(384955), // Rule ID 64469 //
     /*  384895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  384903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  384935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  384939 */     // MIs[1] Operand 1
     /*  384939 */     // No operand predicates
     /*  384939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  384941 */     // (intrinsic_wo_chain:{ *:[i32] } 10922:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  384941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRN),
     /*  384944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  384946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  384948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  384950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  384953 */     GIR_RootConstrainSelectedInstOperands,
     /*  384954 */     // GIR_Coverage, 64469,
     /*  384954 */     GIR_EraseRootFromParent_Done,
     /*  384955 */   // Label 6909: @384955
     /*  384955 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(385020), // Rule ID 64472 //
     /*  384960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  384963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  384968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  384971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  384974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  384977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  384980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  384992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  384996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  385000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  385004 */     // MIs[1] Operand 1
     /*  385004 */     // No operand predicates
     /*  385004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  385006 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)  =>  (CV_SUBURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$imm)
     /*  385006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURN),
     /*  385009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  385018 */     GIR_RootConstrainSelectedInstOperands,
     /*  385019 */     // GIR_Coverage, 64472,
     /*  385019 */     GIR_EraseRootFromParent_Done,
     /*  385020 */   // Label 6910: @385020
     /*  385020 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(385075), // Rule ID 2537 //
     /*  385025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsi),
     /*  385033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385054 */     // MIs[0] imm
     /*  385054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385062 */     // (intrinsic_wo_chain:{ *:[i32] } 10900:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSI),
     /*  385065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385071 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385073 */     GIR_RootConstrainSelectedInstOperands,
     /*  385074 */     // GIR_Coverage, 2537,
     /*  385074 */     GIR_EraseRootFromParent_Done,
     /*  385075 */   // Label 6911: @385075
     /*  385075 */   GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(385130), // Rule ID 2538 //
     /*  385080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZknd_IsRV32_HwMode1),
     /*  385083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32dsmi),
     /*  385088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385109 */     // MIs[0] imm
     /*  385109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385117 */     // (intrinsic_wo_chain:{ *:[i32] } 10901:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32DSMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32DSMI),
     /*  385120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385126 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385128 */     GIR_RootConstrainSelectedInstOperands,
     /*  385129 */     // GIR_Coverage, 2538,
     /*  385129 */     GIR_EraseRootFromParent_Done,
     /*  385130 */   // Label 6912: @385130
     /*  385130 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(385185), // Rule ID 2544 //
     /*  385135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esi),
     /*  385143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385164 */     // MIs[0] imm
     /*  385164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385167 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385172 */     // (intrinsic_wo_chain:{ *:[i32] } 10902:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESI),
     /*  385175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385181 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385183 */     GIR_RootConstrainSelectedInstOperands,
     /*  385184 */     // GIR_Coverage, 2544,
     /*  385184 */     GIR_EraseRootFromParent_Done,
     /*  385185 */   // Label 6913: @385185
     /*  385185 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(385240), // Rule ID 2545 //
     /*  385190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZkne_IsRV32_HwMode1),
     /*  385193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_aes32esmi),
     /*  385198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385219 */     // MIs[0] imm
     /*  385219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_byteselect),
     /*  385227 */     // (intrinsic_wo_chain:{ *:[i32] } 10903:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)  =>  (AES32ESMI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_byteselect>>:$imm)
     /*  385227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::AES32ESMI),
     /*  385230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385236 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /*  385238 */     GIR_RootConstrainSelectedInstOperands,
     /*  385239 */     // GIR_Coverage, 2545,
     /*  385239 */     GIR_EraseRootFromParent_Done,
     /*  385240 */   // Label 6914: @385240
     /*  385240 */   GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(385295), // Rule ID 64483 //
     /*  385245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluN),
     /*  385253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385274 */     // MIs[0] imm5
     /*  385274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385277 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385282 */     // (intrinsic_wo_chain:{ *:[i32] } 10948:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULUN),
     /*  385285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385291 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385293 */     GIR_RootConstrainSelectedInstOperands,
     /*  385294 */     // GIR_Coverage, 64483,
     /*  385294 */     GIR_EraseRootFromParent_Done,
     /*  385295 */   // Label 6915: @385295
     /*  385295 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(385350), // Rule ID 64484 //
     /*  385300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuN),
     /*  385308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385329 */     // MIs[0] imm5
     /*  385329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385337 */     // (intrinsic_wo_chain:{ *:[i32] } 10944:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHUN),
     /*  385340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385346 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385348 */     GIR_RootConstrainSelectedInstOperands,
     /*  385349 */     // GIR_Coverage, 64484,
     /*  385349 */     GIR_EraseRootFromParent_Done,
     /*  385350 */   // Label 6916: @385350
     /*  385350 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(385405), // Rule ID 64485 //
     /*  385355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsN),
     /*  385363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385384 */     // MIs[0] imm5
     /*  385384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385392 */     // (intrinsic_wo_chain:{ *:[i32] } 10946:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSN),
     /*  385395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385401 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385403 */     GIR_RootConstrainSelectedInstOperands,
     /*  385404 */     // GIR_Coverage, 64485,
     /*  385404 */     GIR_EraseRootFromParent_Done,
     /*  385405 */   // Label 6917: @385405
     /*  385405 */   GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(385460), // Rule ID 64486 //
     /*  385410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsN),
     /*  385418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385439 */     // MIs[0] imm5
     /*  385439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385447 */     // (intrinsic_wo_chain:{ *:[i32] } 10942:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSN),
     /*  385450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385456 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385458 */     GIR_RootConstrainSelectedInstOperands,
     /*  385459 */     // GIR_Coverage, 64486,
     /*  385459 */     GIR_EraseRootFromParent_Done,
     /*  385460 */   // Label 6918: @385460
     /*  385460 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(385515), // Rule ID 64487 //
     /*  385465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_muluRN),
     /*  385473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385494 */     // MIs[0] imm5
     /*  385494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385502 */     // (intrinsic_wo_chain:{ *:[i32] } 10949:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULURN),
     /*  385505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385511 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385513 */     GIR_RootConstrainSelectedInstOperands,
     /*  385514 */     // GIR_Coverage, 64487,
     /*  385514 */     GIR_EraseRootFromParent_Done,
     /*  385515 */   // Label 6919: @385515
     /*  385515 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(385570), // Rule ID 64488 //
     /*  385520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhuRN),
     /*  385528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385549 */     // MIs[0] imm5
     /*  385549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385557 */     // (intrinsic_wo_chain:{ *:[i32] } 10945:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHURN),
     /*  385560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385566 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385568 */     GIR_RootConstrainSelectedInstOperands,
     /*  385569 */     // GIR_Coverage, 64488,
     /*  385569 */     GIR_EraseRootFromParent_Done,
     /*  385570 */   // Label 6920: @385570
     /*  385570 */   GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(385625), // Rule ID 64489 //
     /*  385575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulsRN),
     /*  385583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385604 */     // MIs[0] imm5
     /*  385604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385612 */     // (intrinsic_wo_chain:{ *:[i32] } 10947:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULSRN),
     /*  385615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385621 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385623 */     GIR_RootConstrainSelectedInstOperands,
     /*  385624 */     // GIR_Coverage, 64489,
     /*  385624 */     GIR_EraseRootFromParent_Done,
     /*  385625 */   // Label 6921: @385625
     /*  385625 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(385680), // Rule ID 64490 //
     /*  385630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  385633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mulhhsRN),
     /*  385638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385659 */     // MIs[0] imm5
     /*  385659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  385662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  385667 */     // (intrinsic_wo_chain:{ *:[i32] } 10943:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MULHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  385667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MULHHSRN),
     /*  385670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  385672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385676 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm5
     /*  385678 */     GIR_RootConstrainSelectedInstOperands,
     /*  385679 */     // GIR_Coverage, 64490,
     /*  385679 */     GIR_EraseRootFromParent_Done,
     /*  385680 */   // Label 6922: @385680
     /*  385680 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(385734), // Rule ID 64425 //
     /*  385685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  385688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385721 */     // (intrinsic_wo_chain:{ *:[i32] } 10915:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  385724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  385732 */     GIR_RootConstrainSelectedInstOperands,
     /*  385733 */     // GIR_Coverage, 64425,
     /*  385733 */     GIR_EraseRootFromParent_Done,
     /*  385734 */   // Label 6923: @385734
     /*  385734 */   GIM_Try, /*On fail goto*//*Label 6924*/ GIMT_Encode4(385788), // Rule ID 64426 //
     /*  385739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addN),
     /*  385747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385775 */     // (intrinsic_wo_chain:{ *:[i32] } 10915:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDNR),
     /*  385778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  385786 */     GIR_RootConstrainSelectedInstOperands,
     /*  385787 */     // GIR_Coverage, 64426,
     /*  385787 */     GIR_EraseRootFromParent_Done,
     /*  385788 */   // Label 6924: @385788
     /*  385788 */   GIM_Try, /*On fail goto*//*Label 6925*/ GIMT_Encode4(385842), // Rule ID 64452 //
     /*  385793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  385796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385829 */     // (intrinsic_wo_chain:{ *:[i32] } 10917:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  385832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  385840 */     GIR_RootConstrainSelectedInstOperands,
     /*  385841 */     // GIR_Coverage, 64452,
     /*  385841 */     GIR_EraseRootFromParent_Done,
     /*  385842 */   // Label 6925: @385842
     /*  385842 */   GIM_Try, /*On fail goto*//*Label 6926*/ GIMT_Encode4(385896), // Rule ID 64453 //
     /*  385847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduN),
     /*  385855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385883 */     // (intrinsic_wo_chain:{ *:[i32] } 10917:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDUNR),
     /*  385886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  385894 */     GIR_RootConstrainSelectedInstOperands,
     /*  385895 */     // GIR_Coverage, 64453,
     /*  385895 */     GIR_EraseRootFromParent_Done,
     /*  385896 */   // Label 6926: @385896
     /*  385896 */   GIM_Try, /*On fail goto*//*Label 6927*/ GIMT_Encode4(385950), // Rule ID 64455 //
     /*  385901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  385904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385937 */     // (intrinsic_wo_chain:{ *:[i32] } 10916:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  385940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385942 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  385946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  385948 */     GIR_RootConstrainSelectedInstOperands,
     /*  385949 */     // GIR_Coverage, 64455,
     /*  385949 */     GIR_EraseRootFromParent_Done,
     /*  385950 */   // Label 6927: @385950
     /*  385950 */   GIM_Try, /*On fail goto*//*Label 6928*/ GIMT_Encode4(386004), // Rule ID 64456 //
     /*  385955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  385958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_addRN),
     /*  385963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  385966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  385969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  385972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  385975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  385991 */     // (intrinsic_wo_chain:{ *:[i32] } 10916:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  385991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDRNR),
     /*  385994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  385996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  385998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386002 */     GIR_RootConstrainSelectedInstOperands,
     /*  386003 */     // GIR_Coverage, 64456,
     /*  386003 */     GIR_EraseRootFromParent_Done,
     /*  386004 */   // Label 6928: @386004
     /*  386004 */   GIM_Try, /*On fail goto*//*Label 6929*/ GIMT_Encode4(386058), // Rule ID 64458 //
     /*  386009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386045 */     // (intrinsic_wo_chain:{ *:[i32] } 10918:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386056 */     GIR_RootConstrainSelectedInstOperands,
     /*  386057 */     // GIR_Coverage, 64458,
     /*  386057 */     GIR_EraseRootFromParent_Done,
     /*  386058 */   // Label 6929: @386058
     /*  386058 */   GIM_Try, /*On fail goto*//*Label 6930*/ GIMT_Encode4(386112), // Rule ID 64459 //
     /*  386063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_adduRN),
     /*  386071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386099 */     // (intrinsic_wo_chain:{ *:[i32] } 10918:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_ADDURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_ADDURNR),
     /*  386102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386110 */     GIR_RootConstrainSelectedInstOperands,
     /*  386111 */     // GIR_Coverage, 64459,
     /*  386111 */     GIR_EraseRootFromParent_Done,
     /*  386112 */   // Label 6930: @386112
     /*  386112 */   GIM_Try, /*On fail goto*//*Label 6931*/ GIMT_Encode4(386166), // Rule ID 64461 //
     /*  386117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386153 */     // (intrinsic_wo_chain:{ *:[i32] } 10921:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386164 */     GIR_RootConstrainSelectedInstOperands,
     /*  386165 */     // GIR_Coverage, 64461,
     /*  386165 */     GIR_EraseRootFromParent_Done,
     /*  386166 */   // Label 6931: @386166
     /*  386166 */   GIM_Try, /*On fail goto*//*Label 6932*/ GIMT_Encode4(386220), // Rule ID 64462 //
     /*  386171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subN),
     /*  386179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386207 */     // (intrinsic_wo_chain:{ *:[i32] } 10921:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBNR),
     /*  386210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386218 */     GIR_RootConstrainSelectedInstOperands,
     /*  386219 */     // GIR_Coverage, 64462,
     /*  386219 */     GIR_EraseRootFromParent_Done,
     /*  386220 */   // Label 6932: @386220
     /*  386220 */   GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(386274), // Rule ID 64464 //
     /*  386225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386261 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386272 */     GIR_RootConstrainSelectedInstOperands,
     /*  386273 */     // GIR_Coverage, 64464,
     /*  386273 */     GIR_EraseRootFromParent_Done,
     /*  386274 */   // Label 6933: @386274
     /*  386274 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(386328), // Rule ID 64465 //
     /*  386279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuN),
     /*  386287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386315 */     // (intrinsic_wo_chain:{ *:[i32] } 10923:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBUNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBUNR),
     /*  386318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386326 */     GIR_RootConstrainSelectedInstOperands,
     /*  386327 */     // GIR_Coverage, 64465,
     /*  386327 */     GIR_EraseRootFromParent_Done,
     /*  386328 */   // Label 6934: @386328
     /*  386328 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(386382), // Rule ID 64467 //
     /*  386333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386369 */     // (intrinsic_wo_chain:{ *:[i32] } 10922:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386380 */     GIR_RootConstrainSelectedInstOperands,
     /*  386381 */     // GIR_Coverage, 64467,
     /*  386381 */     GIR_EraseRootFromParent_Done,
     /*  386382 */   // Label 6935: @386382
     /*  386382 */   GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(386436), // Rule ID 64468 //
     /*  386387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subRN),
     /*  386395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386423 */     // (intrinsic_wo_chain:{ *:[i32] } 10922:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBRNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBRNR),
     /*  386426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386434 */     GIR_RootConstrainSelectedInstOperands,
     /*  386435 */     // GIR_Coverage, 64468,
     /*  386435 */     GIR_EraseRootFromParent_Done,
     /*  386436 */   // Label 6936: @386436
     /*  386436 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(386490), // Rule ID 64470 //
     /*  386441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /*  386444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  386449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386477 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  386480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386488 */     GIR_RootConstrainSelectedInstOperands,
     /*  386489 */     // GIR_Coverage, 64470,
     /*  386489 */     GIR_EraseRootFromParent_Done,
     /*  386490 */   // Label 6937: @386490
     /*  386490 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(386544), // Rule ID 64471 //
     /*  386495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /*  386498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_alu_subuRN),
     /*  386503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386531 */     // (intrinsic_wo_chain:{ *:[i32] } 10924:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)  =>  (CV_SUBURNR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /*  386531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SUBURNR),
     /*  386534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs3
     /*  386542 */     GIR_RootConstrainSelectedInstOperands,
     /*  386543 */     // GIR_Coverage, 64471,
     /*  386543 */     GIR_EraseRootFromParent_Done,
     /*  386544 */   // Label 6938: @386544
     /*  386544 */   GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(386598), // Rule ID 64408 //
     /*  386549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /*  386552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  386557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386585 */     // (intrinsic_wo_chain:{ *:[i32] } 10931:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  386588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386596 */     GIR_RootConstrainSelectedInstOperands,
     /*  386597 */     // GIR_Coverage, 64408,
     /*  386597 */     GIR_EraseRootFromParent_Done,
     /*  386598 */   // Label 6939: @386598
     /*  386598 */   GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(386652), // Rule ID 64409 //
     /*  386603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /*  386606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_bitmanip_insert),
     /*  386611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386639 */     // (intrinsic_wo_chain:{ *:[i32] } 10931:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_INSERTR:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_INSERTR),
     /*  386642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386650 */     GIR_RootConstrainSelectedInstOperands,
     /*  386651 */     // GIR_Coverage, 64409,
     /*  386651 */     GIR_EraseRootFromParent_Done,
     /*  386652 */   // Label 6940: @386652
     /*  386652 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(386706), // Rule ID 64479 //
     /*  386657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  386660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  386665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386693 */     // (intrinsic_wo_chain:{ *:[i32] } 10932:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  386696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386704 */     GIR_RootConstrainSelectedInstOperands,
     /*  386705 */     // GIR_Coverage, 64479,
     /*  386705 */     GIR_EraseRootFromParent_Done,
     /*  386706 */   // Label 6941: @386706
     /*  386706 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(386760), // Rule ID 64480 //
     /*  386711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_mac),
     /*  386719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386747 */     // (intrinsic_wo_chain:{ *:[i32] } 10932:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MAC:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MAC),
     /*  386750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386758 */     GIR_RootConstrainSelectedInstOperands,
     /*  386759 */     // GIR_Coverage, 64480,
     /*  386759 */     GIR_EraseRootFromParent_Done,
     /*  386760 */   // Label 6942: @386760
     /*  386760 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(386814), // Rule ID 64481 //
     /*  386765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode0),
     /*  386768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  386773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386801 */     // (intrinsic_wo_chain:{ *:[i32] } 10941:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  386804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386812 */     GIR_RootConstrainSelectedInstOperands,
     /*  386813 */     // GIR_Coverage, 64481,
     /*  386813 */     GIR_EraseRootFromParent_Done,
     /*  386814 */   // Label 6943: @386814
     /*  386814 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(386868), // Rule ID 64482 //
     /*  386819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  386822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_msu),
     /*  386827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  386830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  386833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  386836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  386839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  386855 */     // (intrinsic_wo_chain:{ *:[i32] } 10941:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd)  =>  (CV_MSU:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /*  386855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MSU),
     /*  386858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  386860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  386862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  386864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  386866 */     GIR_RootConstrainSelectedInstOperands,
     /*  386867 */     // GIR_Coverage, 64482,
     /*  386867 */     GIR_EraseRootFromParent_Done,
     /*  386868 */   // Label 6944: @386868
     /*  386868 */   GIM_Reject,
     /*  386869 */ // Label 4319: @386869
     /*  386869 */ GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(905646),
     /*  386874 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  386877 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(386952), // Rule ID 62812 //
     /*  386882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  386885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  386890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  386893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  386896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386900 */     // MIs[0] op1
     /*  386900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  386903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  386908 */     // MIs[0] op2
     /*  386908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  386911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  386916 */     // MIs[0] op3
     /*  386916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  386924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  386931 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  386931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  386934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  386936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  386938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  386940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  386942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  386947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  386950 */     GIR_RootConstrainSelectedInstOperands,
     /*  386951 */     // GIR_Coverage, 62812,
     /*  386951 */     GIR_EraseRootFromParent_Done,
     /*  386952 */   // Label 6946: @386952
     /*  386952 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(387027), // Rule ID 62813 //
     /*  386957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  386960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  386965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  386968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  386971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  386975 */     // MIs[0] op1
     /*  386975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  386978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  386983 */     // MIs[0] op2
     /*  386983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  386986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  386991 */     // MIs[0] op3
     /*  386991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  386994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  386999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387006 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF8),
     /*  387009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387011 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387013 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387015 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387025 */     GIR_RootConstrainSelectedInstOperands,
     /*  387026 */     // GIR_Coverage, 62813,
     /*  387026 */     GIR_EraseRootFromParent_Done,
     /*  387027 */   // Label 6947: @387027
     /*  387027 */   GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(387102), // Rule ID 62844 //
     /*  387032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387050 */     // MIs[0] op1
     /*  387050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387058 */     // MIs[0] op2
     /*  387058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387066 */     // MIs[0] op3
     /*  387066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387081 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387100 */     GIR_RootConstrainSelectedInstOperands,
     /*  387101 */     // GIR_Coverage, 62844,
     /*  387101 */     GIR_EraseRootFromParent_Done,
     /*  387102 */   // Label 6948: @387102
     /*  387102 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(387177), // Rule ID 62845 //
     /*  387107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  387118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387125 */     // MIs[0] op1
     /*  387125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387133 */     // MIs[0] op2
     /*  387133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387141 */     // MIs[0] op3
     /*  387141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387156 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387161 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387163 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387165 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387175 */     GIR_RootConstrainSelectedInstOperands,
     /*  387176 */     // GIR_Coverage, 62845,
     /*  387176 */     GIR_EraseRootFromParent_Done,
     /*  387177 */   // Label 6949: @387177
     /*  387177 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(387252), // Rule ID 62888 //
     /*  387182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387200 */     // MIs[0] op1
     /*  387200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387208 */     // MIs[0] op2
     /*  387208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387216 */     // MIs[0] op3
     /*  387216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387231 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387236 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387238 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387240 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387250 */     GIR_RootConstrainSelectedInstOperands,
     /*  387251 */     // GIR_Coverage, 62888,
     /*  387251 */     GIR_EraseRootFromParent_Done,
     /*  387252 */   // Label 6950: @387252
     /*  387252 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(387327), // Rule ID 62889 //
     /*  387257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  387268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387275 */     // MIs[0] op1
     /*  387275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387283 */     // MIs[0] op2
     /*  387283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387291 */     // MIs[0] op3
     /*  387291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387294 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387306 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387311 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387313 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387315 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387325 */     GIR_RootConstrainSelectedInstOperands,
     /*  387326 */     // GIR_Coverage, 62889,
     /*  387326 */     GIR_EraseRootFromParent_Done,
     /*  387327 */   // Label 6951: @387327
     /*  387327 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(387402), // Rule ID 62932 //
     /*  387332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387350 */     // MIs[0] op1
     /*  387350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387358 */     // MIs[0] op2
     /*  387358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387366 */     // MIs[0] op3
     /*  387366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387381 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  387381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387386 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387388 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387390 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387400 */     GIR_RootConstrainSelectedInstOperands,
     /*  387401 */     // GIR_Coverage, 62932,
     /*  387401 */     GIR_EraseRootFromParent_Done,
     /*  387402 */   // Label 6952: @387402
     /*  387402 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(387477), // Rule ID 62933 //
     /*  387407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  387418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387425 */     // MIs[0] op1
     /*  387425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387433 */     // MIs[0] op2
     /*  387433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387441 */     // MIs[0] op3
     /*  387441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387444 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387456 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  387456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF4),
     /*  387459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387461 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387463 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387465 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387475 */     GIR_RootConstrainSelectedInstOperands,
     /*  387476 */     // GIR_Coverage, 62933,
     /*  387476 */     GIR_EraseRootFromParent_Done,
     /*  387477 */   // Label 6953: @387477
     /*  387477 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(387552), // Rule ID 62988 //
     /*  387482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  387493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387500 */     // MIs[0] op1
     /*  387500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387508 */     // MIs[0] op2
     /*  387508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387516 */     // MIs[0] op3
     /*  387516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387531 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  387531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387536 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387538 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387540 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387550 */     GIR_RootConstrainSelectedInstOperands,
     /*  387551 */     // GIR_Coverage, 62988,
     /*  387551 */     GIR_EraseRootFromParent_Done,
     /*  387552 */   // Label 6954: @387552
     /*  387552 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(387627), // Rule ID 62989 //
     /*  387557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  387568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387575 */     // MIs[0] op1
     /*  387575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387578 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387583 */     // MIs[0] op2
     /*  387583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387586 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387591 */     // MIs[0] op3
     /*  387591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  387606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387611 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387613 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387615 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  387625 */     GIR_RootConstrainSelectedInstOperands,
     /*  387626 */     // GIR_Coverage, 62989,
     /*  387626 */     GIR_EraseRootFromParent_Done,
     /*  387627 */   // Label 6955: @387627
     /*  387627 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(387702), // Rule ID 63044 //
     /*  387632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  387643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387650 */     // MIs[0] op1
     /*  387650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387653 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387658 */     // MIs[0] op2
     /*  387658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387666 */     // MIs[0] op3
     /*  387666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387669 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387681 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  387681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387700 */     GIR_RootConstrainSelectedInstOperands,
     /*  387701 */     // GIR_Coverage, 63044,
     /*  387701 */     GIR_EraseRootFromParent_Done,
     /*  387702 */   // Label 6956: @387702
     /*  387702 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(387777), // Rule ID 63045 //
     /*  387707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  387718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387725 */     // MIs[0] op1
     /*  387725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387728 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387733 */     // MIs[0] op2
     /*  387733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387741 */     // MIs[0] op3
     /*  387741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387756 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  387756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_MF2),
     /*  387759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387761 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387763 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387765 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  387775 */     GIR_RootConstrainSelectedInstOperands,
     /*  387776 */     // GIR_Coverage, 63045,
     /*  387776 */     GIR_EraseRootFromParent_Done,
     /*  387777 */   // Label 6957: @387777
     /*  387777 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(387852), // Rule ID 63100 //
     /*  387782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  387793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387800 */     // MIs[0] op1
     /*  387800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387808 */     // MIs[0] op2
     /*  387808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387816 */     // MIs[0] op3
     /*  387816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387831 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  387831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  387834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387836 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387838 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387840 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387850 */     GIR_RootConstrainSelectedInstOperands,
     /*  387851 */     // GIR_Coverage, 63100,
     /*  387851 */     GIR_EraseRootFromParent_Done,
     /*  387852 */   // Label 6958: @387852
     /*  387852 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(387927), // Rule ID 63101 //
     /*  387857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  387860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  387868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  387871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387875 */     // MIs[0] op1
     /*  387875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387883 */     // MIs[0] op2
     /*  387883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387886 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387891 */     // MIs[0] op3
     /*  387891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387906 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  387906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  387909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387911 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387913 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387915 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  387925 */     GIR_RootConstrainSelectedInstOperands,
     /*  387926 */     // GIR_Coverage, 63101,
     /*  387926 */     GIR_EraseRootFromParent_Done,
     /*  387927 */   // Label 6959: @387927
     /*  387927 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(388002), // Rule ID 63144 //
     /*  387932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  387935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  387940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  387943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  387946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  387950 */     // MIs[0] op1
     /*  387950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  387953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  387958 */     // MIs[0] op2
     /*  387958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  387961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  387966 */     // MIs[0] op3
     /*  387966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  387969 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  387974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  387981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  387981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  387984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  387986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  387988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  387990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  387992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  387997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388000 */     GIR_RootConstrainSelectedInstOperands,
     /*  388001 */     // GIR_Coverage, 63144,
     /*  388001 */     GIR_EraseRootFromParent_Done,
     /*  388002 */   // Label 6960: @388002
     /*  388002 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(388077), // Rule ID 63145 //
     /*  388007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  388018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388025 */     // MIs[0] op1
     /*  388025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388033 */     // MIs[0] op2
     /*  388033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388041 */     // MIs[0] op3
     /*  388041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388044 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388061 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388063 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388065 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388075 */     GIR_RootConstrainSelectedInstOperands,
     /*  388076 */     // GIR_Coverage, 63145,
     /*  388076 */     GIR_EraseRootFromParent_Done,
     /*  388077 */   // Label 6961: @388077
     /*  388077 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(388152), // Rule ID 63200 //
     /*  388082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388100 */     // MIs[0] op1
     /*  388100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388103 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388108 */     // MIs[0] op2
     /*  388108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388111 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388116 */     // MIs[0] op3
     /*  388116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388119 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388131 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  388131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388150 */     GIR_RootConstrainSelectedInstOperands,
     /*  388151 */     // GIR_Coverage, 63200,
     /*  388151 */     GIR_EraseRootFromParent_Done,
     /*  388152 */   // Label 6962: @388152
     /*  388152 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(388227), // Rule ID 63201 //
     /*  388157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  388168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388175 */     // MIs[0] op1
     /*  388175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388183 */     // MIs[0] op2
     /*  388183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388191 */     // MIs[0] op3
     /*  388191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  388206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388211 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388213 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388215 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  388225 */     GIR_RootConstrainSelectedInstOperands,
     /*  388226 */     // GIR_Coverage, 63201,
     /*  388226 */     GIR_EraseRootFromParent_Done,
     /*  388227 */   // Label 6963: @388227
     /*  388227 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(388302), // Rule ID 63256 //
     /*  388232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388250 */     // MIs[0] op1
     /*  388250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388258 */     // MIs[0] op2
     /*  388258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388266 */     // MIs[0] op3
     /*  388266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388281 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  388281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388300 */     GIR_RootConstrainSelectedInstOperands,
     /*  388301 */     // GIR_Coverage, 63256,
     /*  388301 */     GIR_EraseRootFromParent_Done,
     /*  388302 */   // Label 6964: @388302
     /*  388302 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(388377), // Rule ID 63257 //
     /*  388307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  388318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  388325 */     // MIs[0] op1
     /*  388325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388328 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388333 */     // MIs[0] op2
     /*  388333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388341 */     // MIs[0] op3
     /*  388341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388344 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  388356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M1),
     /*  388359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388361 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388363 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388365 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  388375 */     GIR_RootConstrainSelectedInstOperands,
     /*  388376 */     // GIR_Coverage, 63257,
     /*  388376 */     GIR_EraseRootFromParent_Done,
     /*  388377 */   // Label 6965: @388377
     /*  388377 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(388452), // Rule ID 63312 //
     /*  388382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388400 */     // MIs[0] op1
     /*  388400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388408 */     // MIs[0] op2
     /*  388408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388411 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388416 */     // MIs[0] op3
     /*  388416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388431 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  388434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388436 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388438 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388440 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388450 */     GIR_RootConstrainSelectedInstOperands,
     /*  388451 */     // GIR_Coverage, 63312,
     /*  388451 */     GIR_EraseRootFromParent_Done,
     /*  388452 */   // Label 6966: @388452
     /*  388452 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(388527), // Rule ID 63313 //
     /*  388457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  388468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388475 */     // MIs[0] op1
     /*  388475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388478 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388483 */     // MIs[0] op2
     /*  388483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388491 */     // MIs[0] op3
     /*  388491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388494 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  388509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388525 */     GIR_RootConstrainSelectedInstOperands,
     /*  388526 */     // GIR_Coverage, 63313,
     /*  388526 */     GIR_EraseRootFromParent_Done,
     /*  388527 */   // Label 6967: @388527
     /*  388527 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(388602), // Rule ID 63356 //
     /*  388532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  388543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388550 */     // MIs[0] op1
     /*  388550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388553 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388558 */     // MIs[0] op2
     /*  388558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388566 */     // MIs[0] op3
     /*  388566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388581 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  388584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388586 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388588 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388590 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388600 */     GIR_RootConstrainSelectedInstOperands,
     /*  388601 */     // GIR_Coverage, 63356,
     /*  388601 */     GIR_EraseRootFromParent_Done,
     /*  388602 */   // Label 6968: @388602
     /*  388602 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(388677), // Rule ID 63357 //
     /*  388607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  388618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  388625 */     // MIs[0] op1
     /*  388625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388628 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388633 */     // MIs[0] op2
     /*  388633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388636 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388641 */     // MIs[0] op3
     /*  388641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388656 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  388659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388661 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388663 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388665 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388675 */     GIR_RootConstrainSelectedInstOperands,
     /*  388676 */     // GIR_Coverage, 63357,
     /*  388676 */     GIR_EraseRootFromParent_Done,
     /*  388677 */   // Label 6969: @388677
     /*  388677 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(388752), // Rule ID 63400 //
     /*  388682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  388693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388700 */     // MIs[0] op1
     /*  388700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388703 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388708 */     // MIs[0] op2
     /*  388708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388716 */     // MIs[0] op3
     /*  388716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388731 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  388731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  388734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388736 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388738 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388740 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388750 */     GIR_RootConstrainSelectedInstOperands,
     /*  388751 */     // GIR_Coverage, 63400,
     /*  388751 */     GIR_EraseRootFromParent_Done,
     /*  388752 */   // Label 6970: @388752
     /*  388752 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(388827), // Rule ID 63401 //
     /*  388757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  388768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  388775 */     // MIs[0] op1
     /*  388775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388783 */     // MIs[0] op2
     /*  388783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388791 */     // MIs[0] op3
     /*  388791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388806 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  388806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  388809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388811 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388813 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388815 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  388825 */     GIR_RootConstrainSelectedInstOperands,
     /*  388826 */     // GIR_Coverage, 63401,
     /*  388826 */     GIR_EraseRootFromParent_Done,
     /*  388827 */   // Label 6971: @388827
     /*  388827 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(388902), // Rule ID 63444 //
     /*  388832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  388843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388850 */     // MIs[0] op1
     /*  388850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388858 */     // MIs[0] op2
     /*  388858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388866 */     // MIs[0] op3
     /*  388866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388869 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388881 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  388881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  388884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388886 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388888 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388890 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388900 */     GIR_RootConstrainSelectedInstOperands,
     /*  388901 */     // GIR_Coverage, 63444,
     /*  388901 */     GIR_EraseRootFromParent_Done,
     /*  388902 */   // Label 6972: @388902
     /*  388902 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(388977), // Rule ID 63445 //
     /*  388907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  388910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  388918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  388921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  388925 */     // MIs[0] op1
     /*  388925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  388928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  388933 */     // MIs[0] op2
     /*  388933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  388936 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  388941 */     // MIs[0] op3
     /*  388941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  388944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  388949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  388956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  388956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  388959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  388961 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  388963 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  388965 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  388967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  388972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  388975 */     GIR_RootConstrainSelectedInstOperands,
     /*  388976 */     // GIR_Coverage, 63445,
     /*  388976 */     GIR_EraseRootFromParent_Done,
     /*  388977 */   // Label 6973: @388977
     /*  388977 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(389052), // Rule ID 63500 //
     /*  388982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  388985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  388990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  388993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  388996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389000 */     // MIs[0] op1
     /*  389000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389003 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389008 */     // MIs[0] op2
     /*  389008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389016 */     // MIs[0] op3
     /*  389016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389031 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389036 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389038 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389040 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389050 */     GIR_RootConstrainSelectedInstOperands,
     /*  389051 */     // GIR_Coverage, 63500,
     /*  389051 */     GIR_EraseRootFromParent_Done,
     /*  389052 */   // Label 6974: @389052
     /*  389052 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(389127), // Rule ID 63501 //
     /*  389057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  389068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389075 */     // MIs[0] op1
     /*  389075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389083 */     // MIs[0] op2
     /*  389083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389091 */     // MIs[0] op3
     /*  389091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389111 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389113 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389115 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389125 */     GIR_RootConstrainSelectedInstOperands,
     /*  389126 */     // GIR_Coverage, 63501,
     /*  389126 */     GIR_EraseRootFromParent_Done,
     /*  389127 */   // Label 6975: @389127
     /*  389127 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(389202), // Rule ID 63556 //
     /*  389132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389150 */     // MIs[0] op1
     /*  389150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389158 */     // MIs[0] op2
     /*  389158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389166 */     // MIs[0] op3
     /*  389166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389181 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  389181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389200 */     GIR_RootConstrainSelectedInstOperands,
     /*  389201 */     // GIR_Coverage, 63556,
     /*  389201 */     GIR_EraseRootFromParent_Done,
     /*  389202 */   // Label 6976: @389202
     /*  389202 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(389277), // Rule ID 63557 //
     /*  389207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  389218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389225 */     // MIs[0] op1
     /*  389225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389228 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389233 */     // MIs[0] op2
     /*  389233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389236 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389241 */     // MIs[0] op3
     /*  389241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  389256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389261 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389263 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389265 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  389275 */     GIR_RootConstrainSelectedInstOperands,
     /*  389276 */     // GIR_Coverage, 63557,
     /*  389276 */     GIR_EraseRootFromParent_Done,
     /*  389277 */   // Label 6977: @389277
     /*  389277 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(389352), // Rule ID 63612 //
     /*  389282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389300 */     // MIs[0] op1
     /*  389300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389308 */     // MIs[0] op2
     /*  389308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389316 */     // MIs[0] op3
     /*  389316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389336 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389338 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389340 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389350 */     GIR_RootConstrainSelectedInstOperands,
     /*  389351 */     // GIR_Coverage, 63612,
     /*  389351 */     GIR_EraseRootFromParent_Done,
     /*  389352 */   // Label 6978: @389352
     /*  389352 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(389427), // Rule ID 63613 //
     /*  389357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  389368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389375 */     // MIs[0] op1
     /*  389375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389378 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389383 */     // MIs[0] op2
     /*  389383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389391 */     // MIs[0] op3
     /*  389391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389411 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389413 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389415 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389425 */     GIR_RootConstrainSelectedInstOperands,
     /*  389426 */     // GIR_Coverage, 63613,
     /*  389426 */     GIR_EraseRootFromParent_Done,
     /*  389427 */   // Label 6979: @389427
     /*  389427 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(389502), // Rule ID 63668 //
     /*  389432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  389443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389450 */     // MIs[0] op1
     /*  389450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389458 */     // MIs[0] op2
     /*  389458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389461 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389466 */     // MIs[0] op3
     /*  389466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389486 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389488 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389490 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389500 */     GIR_RootConstrainSelectedInstOperands,
     /*  389501 */     // GIR_Coverage, 63668,
     /*  389501 */     GIR_EraseRootFromParent_Done,
     /*  389502 */   // Label 6980: @389502
     /*  389502 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(389577), // Rule ID 63669 //
     /*  389507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  389518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389525 */     // MIs[0] op1
     /*  389525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389533 */     // MIs[0] op2
     /*  389533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389541 */     // MIs[0] op3
     /*  389541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389561 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389563 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389565 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389575 */     GIR_RootConstrainSelectedInstOperands,
     /*  389576 */     // GIR_Coverage, 63669,
     /*  389576 */     GIR_EraseRootFromParent_Done,
     /*  389577 */   // Label 6981: @389577
     /*  389577 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(389652), // Rule ID 63724 //
     /*  389582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  389593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389600 */     // MIs[0] op1
     /*  389600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389608 */     // MIs[0] op2
     /*  389608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389616 */     // MIs[0] op3
     /*  389616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389619 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389631 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  389631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389636 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389638 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389640 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389650 */     GIR_RootConstrainSelectedInstOperands,
     /*  389651 */     // GIR_Coverage, 63724,
     /*  389651 */     GIR_EraseRootFromParent_Done,
     /*  389652 */   // Label 6982: @389652
     /*  389652 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(389727), // Rule ID 63725 //
     /*  389657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  389668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  389675 */     // MIs[0] op1
     /*  389675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389683 */     // MIs[0] op2
     /*  389683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389691 */     // MIs[0] op3
     /*  389691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  389706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  389709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389711 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389713 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389715 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  389725 */     GIR_RootConstrainSelectedInstOperands,
     /*  389726 */     // GIR_Coverage, 63725,
     /*  389726 */     GIR_EraseRootFromParent_Done,
     /*  389727 */   // Label 6983: @389727
     /*  389727 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(389802), // Rule ID 63780 //
     /*  389732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  389743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389750 */     // MIs[0] op1
     /*  389750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389758 */     // MIs[0] op2
     /*  389758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389766 */     // MIs[0] op3
     /*  389766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  389781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389786 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389788 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389790 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389800 */     GIR_RootConstrainSelectedInstOperands,
     /*  389801 */     // GIR_Coverage, 63780,
     /*  389801 */     GIR_EraseRootFromParent_Done,
     /*  389802 */   // Label 6984: @389802
     /*  389802 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(389877), // Rule ID 63781 //
     /*  389807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  389818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  389825 */     // MIs[0] op1
     /*  389825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389833 */     // MIs[0] op2
     /*  389833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389841 */     // MIs[0] op3
     /*  389841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389856 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  389856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M2),
     /*  389859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389861 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389863 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389865 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389875 */     GIR_RootConstrainSelectedInstOperands,
     /*  389876 */     // GIR_Coverage, 63781,
     /*  389876 */     GIR_EraseRootFromParent_Done,
     /*  389877 */   // Label 6985: @389877
     /*  389877 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(389952), // Rule ID 63836 //
     /*  389882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  389885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  389893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  389896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389900 */     // MIs[0] op1
     /*  389900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389908 */     // MIs[0] op2
     /*  389908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389916 */     // MIs[0] op3
     /*  389916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  389931 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  389931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  389934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  389936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  389938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  389940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  389942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  389947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  389950 */     GIR_RootConstrainSelectedInstOperands,
     /*  389951 */     // GIR_Coverage, 63836,
     /*  389951 */     GIR_EraseRootFromParent_Done,
     /*  389952 */   // Label 6986: @389952
     /*  389952 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(390027), // Rule ID 63837 //
     /*  389957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  389960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  389965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  389968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  389971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  389975 */     // MIs[0] op1
     /*  389975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  389978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  389983 */     // MIs[0] op2
     /*  389983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  389986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  389991 */     // MIs[0] op3
     /*  389991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  389994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  389999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390006 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M4),
     /*  390009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390011 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390013 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390015 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390025 */     GIR_RootConstrainSelectedInstOperands,
     /*  390026 */     // GIR_Coverage, 63837,
     /*  390026 */     GIR_EraseRootFromParent_Done,
     /*  390027 */   // Label 6987: @390027
     /*  390027 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(390102), // Rule ID 63892 //
     /*  390032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390050 */     // MIs[0] op1
     /*  390050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390053 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390058 */     // MIs[0] op2
     /*  390058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390066 */     // MIs[0] op3
     /*  390066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390069 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390081 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  390081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390100 */     GIR_RootConstrainSelectedInstOperands,
     /*  390101 */     // GIR_Coverage, 63892,
     /*  390101 */     GIR_EraseRootFromParent_Done,
     /*  390102 */   // Label 6988: @390102
     /*  390102 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(390177), // Rule ID 63893 //
     /*  390107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_i),
     /*  390115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  390118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  390125 */     // MIs[0] op1
     /*  390125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390133 */     // MIs[0] op2
     /*  390133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390141 */     // MIs[0] op3
     /*  390141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  390144 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  390149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390156 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10998:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_I_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  390156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_I_M8),
     /*  390159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390161 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390163 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390165 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  390175 */     GIR_RootConstrainSelectedInstOperands,
     /*  390176 */     // GIR_Coverage, 63893,
     /*  390176 */     GIR_EraseRootFromParent_Done,
     /*  390177 */   // Label 6989: @390177
     /*  390177 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(390251), // Rule ID 62794 //
     /*  390182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390203 */     // MIs[0] op1
     /*  390203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390211 */     // MIs[0] op2
     /*  390211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390230 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  390233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390235 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390237 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390239 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390249 */     GIR_RootConstrainSelectedInstOperands,
     /*  390250 */     // GIR_Coverage, 62794,
     /*  390250 */     GIR_EraseRootFromParent_Done,
     /*  390251 */   // Label 6990: @390251
     /*  390251 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(390325), // Rule ID 62795 //
     /*  390256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  390267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390277 */     // MIs[0] op1
     /*  390277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390280 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390285 */     // MIs[0] op2
     /*  390285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390304 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF8),
     /*  390307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390309 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390311 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390313 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390323 */     GIR_RootConstrainSelectedInstOperands,
     /*  390324 */     // GIR_Coverage, 62795,
     /*  390324 */     GIR_EraseRootFromParent_Done,
     /*  390325 */   // Label 6991: @390325
     /*  390325 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(390399), // Rule ID 62840 //
     /*  390330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390351 */     // MIs[0] op1
     /*  390351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390359 */     // MIs[0] op2
     /*  390359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390378 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390397 */     GIR_RootConstrainSelectedInstOperands,
     /*  390398 */     // GIR_Coverage, 62840,
     /*  390398 */     GIR_EraseRootFromParent_Done,
     /*  390399 */   // Label 6992: @390399
     /*  390399 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(390473), // Rule ID 62841 //
     /*  390404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  390415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390425 */     // MIs[0] op1
     /*  390425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390433 */     // MIs[0] op2
     /*  390433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390452 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390457 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390459 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390461 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390471 */     GIR_RootConstrainSelectedInstOperands,
     /*  390472 */     // GIR_Coverage, 62841,
     /*  390472 */     GIR_EraseRootFromParent_Done,
     /*  390473 */   // Label 6993: @390473
     /*  390473 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(390547), // Rule ID 62884 //
     /*  390478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  390489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390499 */     // MIs[0] op1
     /*  390499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390507 */     // MIs[0] op2
     /*  390507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  390526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  390529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390531 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390533 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390535 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390545 */     GIR_RootConstrainSelectedInstOperands,
     /*  390546 */     // GIR_Coverage, 62884,
     /*  390546 */     GIR_EraseRootFromParent_Done,
     /*  390547 */   // Label 6994: @390547
     /*  390547 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(390621), // Rule ID 62885 //
     /*  390552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  390563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390573 */     // MIs[0] op1
     /*  390573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390581 */     // MIs[0] op2
     /*  390581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390600 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  390600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  390603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390605 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390607 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390609 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  390619 */     GIR_RootConstrainSelectedInstOperands,
     /*  390620 */     // GIR_Coverage, 62885,
     /*  390620 */     GIR_EraseRootFromParent_Done,
     /*  390621 */   // Label 6995: @390621
     /*  390621 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(390695), // Rule ID 62928 //
     /*  390626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  390637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390647 */     // MIs[0] op1
     /*  390647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390650 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390655 */     // MIs[0] op2
     /*  390655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390679 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390681 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390683 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390693 */     GIR_RootConstrainSelectedInstOperands,
     /*  390694 */     // GIR_Coverage, 62928,
     /*  390694 */     GIR_EraseRootFromParent_Done,
     /*  390695 */   // Label 6996: @390695
     /*  390695 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(390769), // Rule ID 62929 //
     /*  390700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  390711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390721 */     // MIs[0] op1
     /*  390721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390729 */     // MIs[0] op2
     /*  390729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390748 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF4),
     /*  390751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390753 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390755 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390757 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390767 */     GIR_RootConstrainSelectedInstOperands,
     /*  390768 */     // GIR_Coverage, 62929,
     /*  390768 */     GIR_EraseRootFromParent_Done,
     /*  390769 */   // Label 6997: @390769
     /*  390769 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(390843), // Rule ID 62984 //
     /*  390774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  390785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390795 */     // MIs[0] op1
     /*  390795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390803 */     // MIs[0] op2
     /*  390803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390822 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  390822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  390825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390827 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390829 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390831 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390841 */     GIR_RootConstrainSelectedInstOperands,
     /*  390842 */     // GIR_Coverage, 62984,
     /*  390842 */     GIR_EraseRootFromParent_Done,
     /*  390843 */   // Label 6998: @390843
     /*  390843 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(390917), // Rule ID 62985 //
     /*  390848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  390859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  390862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  390865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390869 */     // MIs[0] op1
     /*  390869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390872 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390877 */     // MIs[0] op2
     /*  390877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  390896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  390899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390901 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390903 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390905 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  390915 */     GIR_RootConstrainSelectedInstOperands,
     /*  390916 */     // GIR_Coverage, 62985,
     /*  390916 */     GIR_EraseRootFromParent_Done,
     /*  390917 */   // Label 6999: @390917
     /*  390917 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(390991), // Rule ID 63040 //
     /*  390922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  390925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  390930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  390933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  390936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  390939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  390943 */     // MIs[0] op1
     /*  390943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  390946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  390951 */     // MIs[0] op2
     /*  390951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  390954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  390959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  390963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  390970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  390970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  390973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  390975 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  390977 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  390979 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  390981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  390986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  390989 */     GIR_RootConstrainSelectedInstOperands,
     /*  390990 */     // GIR_Coverage, 63040,
     /*  390990 */     GIR_EraseRootFromParent_Done,
     /*  390991 */   // Label 7000: @390991
     /*  390991 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(391065), // Rule ID 63041 //
     /*  390996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  390999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  391007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391017 */     // MIs[0] op1
     /*  391017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391025 */     // MIs[0] op2
     /*  391025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  391044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_MF2),
     /*  391047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391049 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391051 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391053 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391063 */     GIR_RootConstrainSelectedInstOperands,
     /*  391064 */     // GIR_Coverage, 63041,
     /*  391064 */     GIR_EraseRootFromParent_Done,
     /*  391065 */   // Label 7001: @391065
     /*  391065 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(391139), // Rule ID 63096 //
     /*  391070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391091 */     // MIs[0] op1
     /*  391091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391094 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391099 */     // MIs[0] op2
     /*  391099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391118 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391123 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391125 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391127 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391137 */     GIR_RootConstrainSelectedInstOperands,
     /*  391138 */     // GIR_Coverage, 63096,
     /*  391138 */     GIR_EraseRootFromParent_Done,
     /*  391139 */   // Label 7002: @391139
     /*  391139 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(391213), // Rule ID 63097 //
     /*  391144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  391155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391165 */     // MIs[0] op1
     /*  391165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391173 */     // MIs[0] op2
     /*  391173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391192 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391197 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391199 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391201 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391211 */     GIR_RootConstrainSelectedInstOperands,
     /*  391212 */     // GIR_Coverage, 63097,
     /*  391212 */     GIR_EraseRootFromParent_Done,
     /*  391213 */   // Label 7003: @391213
     /*  391213 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(391287), // Rule ID 63140 //
     /*  391218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391239 */     // MIs[0] op1
     /*  391239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391247 */     // MIs[0] op2
     /*  391247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391266 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  391266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391271 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391273 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391275 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391285 */     GIR_RootConstrainSelectedInstOperands,
     /*  391286 */     // GIR_Coverage, 63140,
     /*  391286 */     GIR_EraseRootFromParent_Done,
     /*  391287 */   // Label 7004: @391287
     /*  391287 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(391361), // Rule ID 63141 //
     /*  391292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  391303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391313 */     // MIs[0] op1
     /*  391313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391316 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391321 */     // MIs[0] op2
     /*  391321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  391340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391345 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391347 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391349 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  391359 */     GIR_RootConstrainSelectedInstOperands,
     /*  391360 */     // GIR_Coverage, 63141,
     /*  391360 */     GIR_EraseRootFromParent_Done,
     /*  391361 */   // Label 7005: @391361
     /*  391361 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(391435), // Rule ID 63196 //
     /*  391366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391387 */     // MIs[0] op1
     /*  391387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391395 */     // MIs[0] op2
     /*  391395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391414 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  391414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391419 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391421 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391423 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391433 */     GIR_RootConstrainSelectedInstOperands,
     /*  391434 */     // GIR_Coverage, 63196,
     /*  391434 */     GIR_EraseRootFromParent_Done,
     /*  391435 */   // Label 7006: @391435
     /*  391435 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(391509), // Rule ID 63197 //
     /*  391440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  391451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391461 */     // MIs[0] op1
     /*  391461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391469 */     // MIs[0] op2
     /*  391469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  391488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391493 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391495 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391497 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  391507 */     GIR_RootConstrainSelectedInstOperands,
     /*  391508 */     // GIR_Coverage, 63197,
     /*  391508 */     GIR_EraseRootFromParent_Done,
     /*  391509 */   // Label 7007: @391509
     /*  391509 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(391583), // Rule ID 63252 //
     /*  391514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  391525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391535 */     // MIs[0] op1
     /*  391535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391543 */     // MIs[0] op2
     /*  391543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  391562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391567 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391569 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391571 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391581 */     GIR_RootConstrainSelectedInstOperands,
     /*  391582 */     // GIR_Coverage, 63252,
     /*  391582 */     GIR_EraseRootFromParent_Done,
     /*  391583 */   // Label 7008: @391583
     /*  391583 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(391657), // Rule ID 63253 //
     /*  391588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  391599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  391609 */     // MIs[0] op1
     /*  391609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391612 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391617 */     // MIs[0] op2
     /*  391617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391636 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  391636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M1),
     /*  391639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391641 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391643 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391645 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  391655 */     GIR_RootConstrainSelectedInstOperands,
     /*  391656 */     // GIR_Coverage, 63253,
     /*  391656 */     GIR_EraseRootFromParent_Done,
     /*  391657 */   // Label 7009: @391657
     /*  391657 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(391731), // Rule ID 63308 //
     /*  391662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  391673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391683 */     // MIs[0] op1
     /*  391683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391691 */     // MIs[0] op2
     /*  391691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  391713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391729 */     GIR_RootConstrainSelectedInstOperands,
     /*  391730 */     // GIR_Coverage, 63308,
     /*  391730 */     GIR_EraseRootFromParent_Done,
     /*  391731 */   // Label 7010: @391731
     /*  391731 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(391805), // Rule ID 63309 //
     /*  391736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  391747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  391757 */     // MIs[0] op1
     /*  391757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391760 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391765 */     // MIs[0] op2
     /*  391765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  391787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391789 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391791 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391793 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391803 */     GIR_RootConstrainSelectedInstOperands,
     /*  391804 */     // GIR_Coverage, 63309,
     /*  391804 */     GIR_EraseRootFromParent_Done,
     /*  391805 */   // Label 7011: @391805
     /*  391805 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(391879), // Rule ID 63352 //
     /*  391810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  391821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391831 */     // MIs[0] op1
     /*  391831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391839 */     // MIs[0] op2
     /*  391839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391858 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  391858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  391861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391863 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391865 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391867 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391877 */     GIR_RootConstrainSelectedInstOperands,
     /*  391878 */     // GIR_Coverage, 63352,
     /*  391878 */     GIR_EraseRootFromParent_Done,
     /*  391879 */   // Label 7012: @391879
     /*  391879 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(391953), // Rule ID 63353 //
     /*  391884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  391887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  391895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  391898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  391901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  391905 */     // MIs[0] op1
     /*  391905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391913 */     // MIs[0] op2
     /*  391913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  391932 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  391932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  391935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  391937 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  391939 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  391941 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  391943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  391948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  391951 */     GIR_RootConstrainSelectedInstOperands,
     /*  391952 */     // GIR_Coverage, 63353,
     /*  391952 */     GIR_EraseRootFromParent_Done,
     /*  391953 */   // Label 7013: @391953
     /*  391953 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(392027), // Rule ID 63396 //
     /*  391958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  391961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  391966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  391969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  391972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  391975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  391979 */     // MIs[0] op1
     /*  391979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  391982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  391987 */     // MIs[0] op2
     /*  391987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  391990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  391995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  391999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  392006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392011 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392013 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392015 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392025 */     GIR_RootConstrainSelectedInstOperands,
     /*  392026 */     // GIR_Coverage, 63396,
     /*  392026 */     GIR_EraseRootFromParent_Done,
     /*  392027 */   // Label 7014: @392027
     /*  392027 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(392101), // Rule ID 63397 //
     /*  392032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  392043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392053 */     // MIs[0] op1
     /*  392053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392056 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392061 */     // MIs[0] op2
     /*  392061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392080 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  392080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392085 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392087 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392089 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  392099 */     GIR_RootConstrainSelectedInstOperands,
     /*  392100 */     // GIR_Coverage, 63397,
     /*  392100 */     GIR_EraseRootFromParent_Done,
     /*  392101 */   // Label 7015: @392101
     /*  392101 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(392175), // Rule ID 63440 //
     /*  392106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392127 */     // MIs[0] op1
     /*  392127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392135 */     // MIs[0] op2
     /*  392135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392154 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392159 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392161 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392163 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392173 */     GIR_RootConstrainSelectedInstOperands,
     /*  392174 */     // GIR_Coverage, 63440,
     /*  392174 */     GIR_EraseRootFromParent_Done,
     /*  392175 */   // Label 7016: @392175
     /*  392175 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(392249), // Rule ID 63441 //
     /*  392180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  392191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392201 */     // MIs[0] op1
     /*  392201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392209 */     // MIs[0] op2
     /*  392209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392233 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392235 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392237 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392247 */     GIR_RootConstrainSelectedInstOperands,
     /*  392248 */     // GIR_Coverage, 63441,
     /*  392248 */     GIR_EraseRootFromParent_Done,
     /*  392249 */   // Label 7017: @392249
     /*  392249 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(392323), // Rule ID 63496 //
     /*  392254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392275 */     // MIs[0] op1
     /*  392275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392278 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392283 */     // MIs[0] op2
     /*  392283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392302 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392307 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392309 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392311 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392321 */     GIR_RootConstrainSelectedInstOperands,
     /*  392322 */     // GIR_Coverage, 63496,
     /*  392322 */     GIR_EraseRootFromParent_Done,
     /*  392323 */   // Label 7018: @392323
     /*  392323 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(392397), // Rule ID 63497 //
     /*  392328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  392339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392349 */     // MIs[0] op1
     /*  392349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392352 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392357 */     // MIs[0] op2
     /*  392357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392376 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392381 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392383 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392385 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392395 */     GIR_RootConstrainSelectedInstOperands,
     /*  392396 */     // GIR_Coverage, 63497,
     /*  392396 */     GIR_EraseRootFromParent_Done,
     /*  392397 */   // Label 7019: @392397
     /*  392397 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(392471), // Rule ID 63552 //
     /*  392402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392423 */     // MIs[0] op1
     /*  392423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392426 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392431 */     // MIs[0] op2
     /*  392431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392450 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  392450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392455 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392457 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392459 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392469 */     GIR_RootConstrainSelectedInstOperands,
     /*  392470 */     // GIR_Coverage, 63552,
     /*  392470 */     GIR_EraseRootFromParent_Done,
     /*  392471 */   // Label 7020: @392471
     /*  392471 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(392545), // Rule ID 63553 //
     /*  392476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  392487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392497 */     // MIs[0] op1
     /*  392497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392505 */     // MIs[0] op2
     /*  392505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392524 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  392524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392529 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392531 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392533 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  392543 */     GIR_RootConstrainSelectedInstOperands,
     /*  392544 */     // GIR_Coverage, 63553,
     /*  392544 */     GIR_EraseRootFromParent_Done,
     /*  392545 */   // Label 7021: @392545
     /*  392545 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(392619), // Rule ID 63608 //
     /*  392550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  392561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392571 */     // MIs[0] op1
     /*  392571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392579 */     // MIs[0] op2
     /*  392579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392603 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392605 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392607 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392617 */     GIR_RootConstrainSelectedInstOperands,
     /*  392618 */     // GIR_Coverage, 63608,
     /*  392618 */     GIR_EraseRootFromParent_Done,
     /*  392619 */   // Label 7022: @392619
     /*  392619 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(392693), // Rule ID 63609 //
     /*  392624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  392635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  392645 */     // MIs[0] op1
     /*  392645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392653 */     // MIs[0] op2
     /*  392653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  392675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392677 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392679 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392681 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392691 */     GIR_RootConstrainSelectedInstOperands,
     /*  392692 */     // GIR_Coverage, 63609,
     /*  392692 */     GIR_EraseRootFromParent_Done,
     /*  392693 */   // Label 7023: @392693
     /*  392693 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(392767), // Rule ID 63664 //
     /*  392698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  392709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392719 */     // MIs[0] op1
     /*  392719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392727 */     // MIs[0] op2
     /*  392727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392746 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392751 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392753 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392755 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392765 */     GIR_RootConstrainSelectedInstOperands,
     /*  392766 */     // GIR_Coverage, 63664,
     /*  392766 */     GIR_EraseRootFromParent_Done,
     /*  392767 */   // Label 7024: @392767
     /*  392767 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(392841), // Rule ID 63665 //
     /*  392772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  392783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  392793 */     // MIs[0] op1
     /*  392793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392801 */     // MIs[0] op2
     /*  392801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  392823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392825 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392827 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392829 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392839 */     GIR_RootConstrainSelectedInstOperands,
     /*  392840 */     // GIR_Coverage, 63665,
     /*  392840 */     GIR_EraseRootFromParent_Done,
     /*  392841 */   // Label 7025: @392841
     /*  392841 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(392915), // Rule ID 63720 //
     /*  392846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  392857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  392860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  392863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392867 */     // MIs[0] op1
     /*  392867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392875 */     // MIs[0] op2
     /*  392875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392878 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392894 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  392894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392899 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392901 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392903 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392913 */     GIR_RootConstrainSelectedInstOperands,
     /*  392914 */     // GIR_Coverage, 63720,
     /*  392914 */     GIR_EraseRootFromParent_Done,
     /*  392915 */   // Label 7026: @392915
     /*  392915 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(392989), // Rule ID 63721 //
     /*  392920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  392923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  392928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  392931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  392934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  392937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  392941 */     // MIs[0] op1
     /*  392941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  392944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  392949 */     // MIs[0] op2
     /*  392949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  392952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  392957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  392961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  392968 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  392968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  392971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  392973 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  392975 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  392977 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  392979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  392984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  392987 */     GIR_RootConstrainSelectedInstOperands,
     /*  392988 */     // GIR_Coverage, 63721,
     /*  392988 */     GIR_EraseRootFromParent_Done,
     /*  392989 */   // Label 7027: @392989
     /*  392989 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(393063), // Rule ID 63776 //
     /*  392994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  392997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393015 */     // MIs[0] op1
     /*  393015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393023 */     // MIs[0] op2
     /*  393023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393061 */     GIR_RootConstrainSelectedInstOperands,
     /*  393062 */     // GIR_Coverage, 63776,
     /*  393062 */     GIR_EraseRootFromParent_Done,
     /*  393063 */   // Label 7028: @393063
     /*  393063 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(393137), // Rule ID 63777 //
     /*  393068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  393079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  393089 */     // MIs[0] op1
     /*  393089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393097 */     // MIs[0] op2
     /*  393097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393100 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M2),
     /*  393119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393121 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393123 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393125 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393135 */     GIR_RootConstrainSelectedInstOperands,
     /*  393136 */     // GIR_Coverage, 63777,
     /*  393136 */     GIR_EraseRootFromParent_Done,
     /*  393137 */   // Label 7029: @393137
     /*  393137 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(393211), // Rule ID 63832 //
     /*  393142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393163 */     // MIs[0] op1
     /*  393163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393166 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393171 */     // MIs[0] op2
     /*  393171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393190 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393195 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393197 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393199 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393209 */     GIR_RootConstrainSelectedInstOperands,
     /*  393210 */     // GIR_Coverage, 63832,
     /*  393210 */     GIR_EraseRootFromParent_Done,
     /*  393211 */   // Label 7030: @393211
     /*  393211 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(393285), // Rule ID 63833 //
     /*  393216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  393227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  393237 */     // MIs[0] op1
     /*  393237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393245 */     // MIs[0] op2
     /*  393245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M4),
     /*  393267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393269 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393271 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393273 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393283 */     GIR_RootConstrainSelectedInstOperands,
     /*  393284 */     // GIR_Coverage, 63833,
     /*  393284 */     GIR_EraseRootFromParent_Done,
     /*  393285 */   // Label 7031: @393285
     /*  393285 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(393359), // Rule ID 63888 //
     /*  393290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  393304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393311 */     // MIs[0] op1
     /*  393311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393314 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393319 */     // MIs[0] op2
     /*  393319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i64] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  393338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393343 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393345 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393347 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393357 */     GIR_RootConstrainSelectedInstOperands,
     /*  393358 */     // GIR_Coverage, 63888,
     /*  393358 */     GIR_EraseRootFromParent_Done,
     /*  393359 */   // Label 7032: @393359
     /*  393359 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(393433), // Rule ID 63889 //
     /*  393364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_x),
     /*  393372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  393375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  393378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  393385 */     // MIs[0] op1
     /*  393385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393393 */     // MIs[0] op2
     /*  393393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  393396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload5),
     /*  393401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  393405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393412 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11012:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_X_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, (timm:{ *:[i32] })<<P:Predicate_payload5>>:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  393412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_X_M8),
     /*  393415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393417 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393419 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393421 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  393431 */     GIR_RootConstrainSelectedInstOperands,
     /*  393432 */     // GIR_Coverage, 63889,
     /*  393432 */     GIR_EraseRootFromParent_Done,
     /*  393433 */   // Label 7033: @393433
     /*  393433 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(393507), // Rule ID 62818 //
     /*  393438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  393449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  393452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393459 */     // MIs[0] op1
     /*  393459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393471 */     // MIs[0] op3
     /*  393471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393474 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393486 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  393489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393491 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393493 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393495 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393505 */     GIR_RootConstrainSelectedInstOperands,
     /*  393506 */     // GIR_Coverage, 62818,
     /*  393506 */     GIR_EraseRootFromParent_Done,
     /*  393507 */   // Label 7034: @393507
     /*  393507 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(393581), // Rule ID 62819 //
     /*  393512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  393523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  393526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393533 */     // MIs[0] op1
     /*  393533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393545 */     // MIs[0] op3
     /*  393545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393560 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF8),
     /*  393563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393565 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393567 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393569 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393579 */     GIR_RootConstrainSelectedInstOperands,
     /*  393580 */     // GIR_Coverage, 62819,
     /*  393580 */     GIR_EraseRootFromParent_Done,
     /*  393581 */   // Label 7035: @393581
     /*  393581 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(393655), // Rule ID 62856 //
     /*  393586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  393597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  393600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393607 */     // MIs[0] op1
     /*  393607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393619 */     // MIs[0] op3
     /*  393619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393634 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  393637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393639 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393641 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393643 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393653 */     GIR_RootConstrainSelectedInstOperands,
     /*  393654 */     // GIR_Coverage, 62856,
     /*  393654 */     GIR_EraseRootFromParent_Done,
     /*  393655 */   // Label 7036: @393655
     /*  393655 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(393729), // Rule ID 62857 //
     /*  393660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  393671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  393674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393681 */     // MIs[0] op1
     /*  393681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393684 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393693 */     // MIs[0] op3
     /*  393693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393696 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393708 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  393711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393713 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393715 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393717 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393727 */     GIR_RootConstrainSelectedInstOperands,
     /*  393728 */     // GIR_Coverage, 62857,
     /*  393728 */     GIR_EraseRootFromParent_Done,
     /*  393729 */   // Label 7037: @393729
     /*  393729 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(393803), // Rule ID 62900 //
     /*  393734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  393745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  393748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393755 */     // MIs[0] op1
     /*  393755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393758 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393767 */     // MIs[0] op3
     /*  393767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393782 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  393782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  393785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393787 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393789 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393791 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393801 */     GIR_RootConstrainSelectedInstOperands,
     /*  393802 */     // GIR_Coverage, 62900,
     /*  393802 */     GIR_EraseRootFromParent_Done,
     /*  393803 */   // Label 7038: @393803
     /*  393803 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(393877), // Rule ID 62901 //
     /*  393808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  393819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  393822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393829 */     // MIs[0] op1
     /*  393829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393841 */     // MIs[0] op3
     /*  393841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  393856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  393859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393861 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393863 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393865 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  393875 */     GIR_RootConstrainSelectedInstOperands,
     /*  393876 */     // GIR_Coverage, 62901,
     /*  393876 */     GIR_EraseRootFromParent_Done,
     /*  393877 */   // Label 7039: @393877
     /*  393877 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(393951), // Rule ID 62944 //
     /*  393882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  393885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  393893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  393896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  393899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393903 */     // MIs[0] op1
     /*  393903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393915 */     // MIs[0] op3
     /*  393915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393918 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  393930 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  393930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  393933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  393935 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  393937 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  393939 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  393941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  393946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  393949 */     GIR_RootConstrainSelectedInstOperands,
     /*  393950 */     // GIR_Coverage, 62944,
     /*  393950 */     GIR_EraseRootFromParent_Done,
     /*  393951 */   // Label 7040: @393951
     /*  393951 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(394025), // Rule ID 62945 //
     /*  393956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  393959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  393964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  393967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  393970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  393973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393977 */     // MIs[0] op1
     /*  393977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  393980 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  393985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  393989 */     // MIs[0] op3
     /*  393989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  393992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  393997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394004 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF4),
     /*  394007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394009 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394011 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394013 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394023 */     GIR_RootConstrainSelectedInstOperands,
     /*  394024 */     // GIR_Coverage, 62945,
     /*  394024 */     GIR_EraseRootFromParent_Done,
     /*  394025 */   // Label 7041: @394025
     /*  394025 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(394099), // Rule ID 63000 //
     /*  394030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394051 */     // MIs[0] op1
     /*  394051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394063 */     // MIs[0] op3
     /*  394063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394078 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394083 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394085 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394087 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394097 */     GIR_RootConstrainSelectedInstOperands,
     /*  394098 */     // GIR_Coverage, 63000,
     /*  394098 */     GIR_EraseRootFromParent_Done,
     /*  394099 */   // Label 7042: @394099
     /*  394099 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(394173), // Rule ID 63001 //
     /*  394104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  394115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  394118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394125 */     // MIs[0] op1
     /*  394125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394137 */     // MIs[0] op3
     /*  394137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394157 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394159 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394161 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394171 */     GIR_RootConstrainSelectedInstOperands,
     /*  394172 */     // GIR_Coverage, 63001,
     /*  394172 */     GIR_EraseRootFromParent_Done,
     /*  394173 */   // Label 7043: @394173
     /*  394173 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(394247), // Rule ID 63056 //
     /*  394178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394199 */     // MIs[0] op1
     /*  394199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394211 */     // MIs[0] op3
     /*  394211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394214 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394226 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  394226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394231 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394233 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394235 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394245 */     GIR_RootConstrainSelectedInstOperands,
     /*  394246 */     // GIR_Coverage, 63056,
     /*  394246 */     GIR_EraseRootFromParent_Done,
     /*  394247 */   // Label 7044: @394247
     /*  394247 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(394321), // Rule ID 63057 //
     /*  394252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  394263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  394266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394273 */     // MIs[0] op1
     /*  394273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394285 */     // MIs[0] op3
     /*  394285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_MF2),
     /*  394303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394305 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394307 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394309 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394319 */     GIR_RootConstrainSelectedInstOperands,
     /*  394320 */     // GIR_Coverage, 63057,
     /*  394320 */     GIR_EraseRootFromParent_Done,
     /*  394321 */   // Label 7045: @394321
     /*  394321 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(394395), // Rule ID 63112 //
     /*  394326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394347 */     // MIs[0] op1
     /*  394347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394359 */     // MIs[0] op3
     /*  394359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394379 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394381 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394383 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394393 */     GIR_RootConstrainSelectedInstOperands,
     /*  394394 */     // GIR_Coverage, 63112,
     /*  394394 */     GIR_EraseRootFromParent_Done,
     /*  394395 */   // Label 7046: @394395
     /*  394395 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(394469), // Rule ID 63113 //
     /*  394400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  394411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  394414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394421 */     // MIs[0] op1
     /*  394421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394433 */     // MIs[0] op3
     /*  394433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394436 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394448 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  394448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394453 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394455 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394457 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394467 */     GIR_RootConstrainSelectedInstOperands,
     /*  394468 */     // GIR_Coverage, 63113,
     /*  394468 */     GIR_EraseRootFromParent_Done,
     /*  394469 */   // Label 7047: @394469
     /*  394469 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(394543), // Rule ID 63156 //
     /*  394474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  394485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  394488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394495 */     // MIs[0] op1
     /*  394495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394507 */     // MIs[0] op3
     /*  394507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394510 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394522 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  394522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394527 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394529 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394531 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394541 */     GIR_RootConstrainSelectedInstOperands,
     /*  394542 */     // GIR_Coverage, 63156,
     /*  394542 */     GIR_EraseRootFromParent_Done,
     /*  394543 */   // Label 7048: @394543
     /*  394543 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(394617), // Rule ID 63157 //
     /*  394548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  394559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  394562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394569 */     // MIs[0] op1
     /*  394569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394572 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394581 */     // MIs[0] op3
     /*  394581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  394596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394601 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394603 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394605 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  394615 */     GIR_RootConstrainSelectedInstOperands,
     /*  394616 */     // GIR_Coverage, 63157,
     /*  394616 */     GIR_EraseRootFromParent_Done,
     /*  394617 */   // Label 7049: @394617
     /*  394617 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(394691), // Rule ID 63212 //
     /*  394622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  394633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  394636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394643 */     // MIs[0] op1
     /*  394643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394646 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394655 */     // MIs[0] op3
     /*  394655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  394670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394675 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394677 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394679 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394689 */     GIR_RootConstrainSelectedInstOperands,
     /*  394690 */     // GIR_Coverage, 63212,
     /*  394690 */     GIR_EraseRootFromParent_Done,
     /*  394691 */   // Label 7050: @394691
     /*  394691 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(394765), // Rule ID 63213 //
     /*  394696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  394707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  394710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394717 */     // MIs[0] op1
     /*  394717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394720 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394729 */     // MIs[0] op3
     /*  394729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394732 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  394744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394749 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394751 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394753 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  394763 */     GIR_RootConstrainSelectedInstOperands,
     /*  394764 */     // GIR_Coverage, 63213,
     /*  394764 */     GIR_EraseRootFromParent_Done,
     /*  394765 */   // Label 7051: @394765
     /*  394765 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(394839), // Rule ID 63268 //
     /*  394770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  394781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  394784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394791 */     // MIs[0] op1
     /*  394791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394803 */     // MIs[0] op3
     /*  394803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394818 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  394818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394823 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394825 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394827 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394837 */     GIR_RootConstrainSelectedInstOperands,
     /*  394838 */     // GIR_Coverage, 63268,
     /*  394838 */     GIR_EraseRootFromParent_Done,
     /*  394839 */   // Label 7052: @394839
     /*  394839 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(394913), // Rule ID 63269 //
     /*  394844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  394855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  394858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  394861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394865 */     // MIs[0] op1
     /*  394865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  394877 */     // MIs[0] op3
     /*  394877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394892 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  394892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M1),
     /*  394895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394897 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394899 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394901 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  394911 */     GIR_RootConstrainSelectedInstOperands,
     /*  394912 */     // GIR_Coverage, 63269,
     /*  394912 */     GIR_EraseRootFromParent_Done,
     /*  394913 */   // Label 7053: @394913
     /*  394913 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(394987), // Rule ID 63324 //
     /*  394918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  394921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  394926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  394929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  394932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  394935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394939 */     // MIs[0] op1
     /*  394939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  394942 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  394947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  394951 */     // MIs[0] op3
     /*  394951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  394954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  394959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  394966 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  394966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  394969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  394971 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  394973 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  394975 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  394977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  394982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  394985 */     GIR_RootConstrainSelectedInstOperands,
     /*  394986 */     // GIR_Coverage, 63324,
     /*  394986 */     GIR_EraseRootFromParent_Done,
     /*  394987 */   // Label 7054: @394987
     /*  394987 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(395061), // Rule ID 63325 //
     /*  394992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  394995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  395003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  395006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395013 */     // MIs[0] op1
     /*  395013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395016 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395025 */     // MIs[0] op3
     /*  395025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395028 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395040 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395045 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395047 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395049 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395059 */     GIR_RootConstrainSelectedInstOperands,
     /*  395060 */     // GIR_Coverage, 63325,
     /*  395060 */     GIR_EraseRootFromParent_Done,
     /*  395061 */   // Label 7055: @395061
     /*  395061 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(395135), // Rule ID 63368 //
     /*  395066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395087 */     // MIs[0] op1
     /*  395087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395090 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395099 */     // MIs[0] op3
     /*  395099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395119 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395121 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395123 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395133 */     GIR_RootConstrainSelectedInstOperands,
     /*  395134 */     // GIR_Coverage, 63368,
     /*  395134 */     GIR_EraseRootFromParent_Done,
     /*  395135 */   // Label 7056: @395135
     /*  395135 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(395209), // Rule ID 63369 //
     /*  395140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  395151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  395154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395161 */     // MIs[0] op1
     /*  395161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395173 */     // MIs[0] op3
     /*  395173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395193 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395195 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395197 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395207 */     GIR_RootConstrainSelectedInstOperands,
     /*  395208 */     // GIR_Coverage, 63369,
     /*  395208 */     GIR_EraseRootFromParent_Done,
     /*  395209 */   // Label 7057: @395209
     /*  395209 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(395283), // Rule ID 63412 //
     /*  395214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395235 */     // MIs[0] op1
     /*  395235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395247 */     // MIs[0] op3
     /*  395247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395250 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395262 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  395262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395267 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395269 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395271 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395281 */     GIR_RootConstrainSelectedInstOperands,
     /*  395282 */     // GIR_Coverage, 63412,
     /*  395282 */     GIR_EraseRootFromParent_Done,
     /*  395283 */   // Label 7058: @395283
     /*  395283 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(395357), // Rule ID 63413 //
     /*  395288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  395299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  395302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395309 */     // MIs[0] op1
     /*  395309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395312 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395321 */     // MIs[0] op3
     /*  395321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395336 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  395336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395341 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395343 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395345 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  395355 */     GIR_RootConstrainSelectedInstOperands,
     /*  395356 */     // GIR_Coverage, 63413,
     /*  395356 */     GIR_EraseRootFromParent_Done,
     /*  395357 */   // Label 7059: @395357
     /*  395357 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(395431), // Rule ID 63456 //
     /*  395362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395383 */     // MIs[0] op1
     /*  395383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395395 */     // MIs[0] op3
     /*  395395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395415 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395417 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395419 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395429 */     GIR_RootConstrainSelectedInstOperands,
     /*  395430 */     // GIR_Coverage, 63456,
     /*  395430 */     GIR_EraseRootFromParent_Done,
     /*  395431 */   // Label 7060: @395431
     /*  395431 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(395505), // Rule ID 63457 //
     /*  395436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  395447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  395450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395457 */     // MIs[0] op1
     /*  395457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395469 */     // MIs[0] op3
     /*  395469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395472 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395489 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395491 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395493 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395503 */     GIR_RootConstrainSelectedInstOperands,
     /*  395504 */     // GIR_Coverage, 63457,
     /*  395504 */     GIR_EraseRootFromParent_Done,
     /*  395505 */   // Label 7061: @395505
     /*  395505 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(395579), // Rule ID 63512 //
     /*  395510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  395521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  395524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395531 */     // MIs[0] op1
     /*  395531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395543 */     // MIs[0] op3
     /*  395543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395546 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395558 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395563 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395565 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395567 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395577 */     GIR_RootConstrainSelectedInstOperands,
     /*  395578 */     // GIR_Coverage, 63512,
     /*  395578 */     GIR_EraseRootFromParent_Done,
     /*  395579 */   // Label 7062: @395579
     /*  395579 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(395653), // Rule ID 63513 //
     /*  395584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  395595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  395598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395605 */     // MIs[0] op1
     /*  395605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395617 */     // MIs[0] op3
     /*  395617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395632 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  395635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395637 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395639 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395641 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395651 */     GIR_RootConstrainSelectedInstOperands,
     /*  395652 */     // GIR_Coverage, 63513,
     /*  395652 */     GIR_EraseRootFromParent_Done,
     /*  395653 */   // Label 7063: @395653
     /*  395653 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(395727), // Rule ID 63568 //
     /*  395658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  395669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  395672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395679 */     // MIs[0] op1
     /*  395679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395691 */     // MIs[0] op3
     /*  395691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395706 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  395706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395711 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395713 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395715 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395725 */     GIR_RootConstrainSelectedInstOperands,
     /*  395726 */     // GIR_Coverage, 63568,
     /*  395726 */     GIR_EraseRootFromParent_Done,
     /*  395727 */   // Label 7064: @395727
     /*  395727 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(395801), // Rule ID 63569 //
     /*  395732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  395743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  395746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395753 */     // MIs[0] op1
     /*  395753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  395765 */     // MIs[0] op3
     /*  395765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395768 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  395780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  395783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395785 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395787 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395789 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  395799 */     GIR_RootConstrainSelectedInstOperands,
     /*  395800 */     // GIR_Coverage, 63569,
     /*  395800 */     GIR_EraseRootFromParent_Done,
     /*  395801 */   // Label 7065: @395801
     /*  395801 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(395875), // Rule ID 63624 //
     /*  395806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  395817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  395820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395827 */     // MIs[0] op1
     /*  395827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395839 */     // MIs[0] op3
     /*  395839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  395854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395859 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395861 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395863 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395873 */     GIR_RootConstrainSelectedInstOperands,
     /*  395874 */     // GIR_Coverage, 63624,
     /*  395874 */     GIR_EraseRootFromParent_Done,
     /*  395875 */   // Label 7066: @395875
     /*  395875 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(395949), // Rule ID 63625 //
     /*  395880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  395883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  395891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  395894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  395897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395901 */     // MIs[0] op1
     /*  395901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  395913 */     // MIs[0] op3
     /*  395913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395916 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  395928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  395928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  395931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  395933 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  395935 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  395937 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  395939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  395944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  395947 */     GIR_RootConstrainSelectedInstOperands,
     /*  395948 */     // GIR_Coverage, 63625,
     /*  395948 */     GIR_EraseRootFromParent_Done,
     /*  395949 */   // Label 7067: @395949
     /*  395949 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(396023), // Rule ID 63680 //
     /*  395954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  395957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  395962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  395965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  395968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  395971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395975 */     // MIs[0] op1
     /*  395975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  395978 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  395983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  395987 */     // MIs[0] op3
     /*  395987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  395990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  395995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396007 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396009 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396011 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396021 */     GIR_RootConstrainSelectedInstOperands,
     /*  396022 */     // GIR_Coverage, 63680,
     /*  396022 */     GIR_EraseRootFromParent_Done,
     /*  396023 */   // Label 7068: @396023
     /*  396023 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(396097), // Rule ID 63681 //
     /*  396028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  396039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  396042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396049 */     // MIs[0] op1
     /*  396049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396061 */     // MIs[0] op3
     /*  396061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396081 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396083 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396085 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396095 */     GIR_RootConstrainSelectedInstOperands,
     /*  396096 */     // GIR_Coverage, 63681,
     /*  396096 */     GIR_EraseRootFromParent_Done,
     /*  396097 */   // Label 7069: @396097
     /*  396097 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(396171), // Rule ID 63736 //
     /*  396102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396123 */     // MIs[0] op1
     /*  396123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396126 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396135 */     // MIs[0] op3
     /*  396135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396138 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396150 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  396150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396155 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396157 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396159 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396169 */     GIR_RootConstrainSelectedInstOperands,
     /*  396170 */     // GIR_Coverage, 63736,
     /*  396170 */     GIR_EraseRootFromParent_Done,
     /*  396171 */   // Label 7070: @396171
     /*  396171 */   GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(396245), // Rule ID 63737 //
     /*  396176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  396187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  396190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396197 */     // MIs[0] op1
     /*  396197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396209 */     // MIs[0] op3
     /*  396209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396212 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396224 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  396224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396229 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396231 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396233 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  396243 */     GIR_RootConstrainSelectedInstOperands,
     /*  396244 */     // GIR_Coverage, 63737,
     /*  396244 */     GIR_EraseRootFromParent_Done,
     /*  396245 */   // Label 7071: @396245
     /*  396245 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(396319), // Rule ID 63792 //
     /*  396250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396271 */     // MIs[0] op1
     /*  396271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396283 */     // MIs[0] op3
     /*  396283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396286 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396298 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396303 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396305 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396307 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396317 */     GIR_RootConstrainSelectedInstOperands,
     /*  396318 */     // GIR_Coverage, 63792,
     /*  396318 */     GIR_EraseRootFromParent_Done,
     /*  396319 */   // Label 7072: @396319
     /*  396319 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(396393), // Rule ID 63793 //
     /*  396324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  396335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  396338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396345 */     // MIs[0] op1
     /*  396345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  396357 */     // MIs[0] op3
     /*  396357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  396372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M2),
     /*  396375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396377 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396379 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396381 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396391 */     GIR_RootConstrainSelectedInstOperands,
     /*  396392 */     // GIR_Coverage, 63793,
     /*  396392 */     GIR_EraseRootFromParent_Done,
     /*  396393 */   // Label 7073: @396393
     /*  396393 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(396467), // Rule ID 63848 //
     /*  396398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396419 */     // MIs[0] op1
     /*  396419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396422 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396431 */     // MIs[0] op3
     /*  396431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396434 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396451 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396453 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396455 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396465 */     GIR_RootConstrainSelectedInstOperands,
     /*  396466 */     // GIR_Coverage, 63848,
     /*  396466 */     GIR_EraseRootFromParent_Done,
     /*  396467 */   // Label 7074: @396467
     /*  396467 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(396541), // Rule ID 63849 //
     /*  396472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  396483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  396486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396493 */     // MIs[0] op1
     /*  396493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  396505 */     // MIs[0] op3
     /*  396505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  396520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M4),
     /*  396523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396525 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396527 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396529 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396539 */     GIR_RootConstrainSelectedInstOperands,
     /*  396540 */     // GIR_Coverage, 63849,
     /*  396540 */     GIR_EraseRootFromParent_Done,
     /*  396541 */   // Label 7075: @396541
     /*  396541 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(396615), // Rule ID 63904 //
     /*  396546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  396549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  396557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  396560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396567 */     // MIs[0] op1
     /*  396567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396579 */     // MIs[0] op3
     /*  396579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  396594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396599 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396601 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396603 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396613 */     GIR_RootConstrainSelectedInstOperands,
     /*  396614 */     // GIR_Coverage, 63904,
     /*  396614 */     GIR_EraseRootFromParent_Done,
     /*  396615 */   // Label 7076: @396615
     /*  396615 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(396689), // Rule ID 63905 //
     /*  396620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  396623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_iv),
     /*  396628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  396631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  396634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396641 */     // MIs[0] op1
     /*  396641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  396644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  396649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  396653 */     // MIs[0] op3
     /*  396653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  396656 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  396661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396668 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11000:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  396668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IV_M8),
     /*  396671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396673 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  396675 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  396677 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  396679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  396687 */     GIR_RootConstrainSelectedInstOperands,
     /*  396688 */     // GIR_Coverage, 63905,
     /*  396688 */     GIR_EraseRootFromParent_Done,
     /*  396689 */   // Label 7077: @396689
     /*  396689 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(396764), // Rule ID 7238 //
     /*  396694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  396702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  396705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  396708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  396711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  396733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396740 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  396740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  396743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  396747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  396762 */     GIR_RootConstrainSelectedInstOperands,
     /*  396763 */     // GIR_Coverage, 7238,
     /*  396763 */     GIR_EraseRootFromParent_Done,
     /*  396764 */   // Label 7078: @396764
     /*  396764 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(396839), // Rule ID 7239 //
     /*  396769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  396772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  396777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  396780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  396783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  396786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  396808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396815 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  396815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  396818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  396822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  396837 */     GIR_RootConstrainSelectedInstOperands,
     /*  396838 */     // GIR_Coverage, 7239,
     /*  396838 */     GIR_EraseRootFromParent_Done,
     /*  396839 */   // Label 7079: @396839
     /*  396839 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(396914), // Rule ID 7242 //
     /*  396844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  396852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  396855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  396858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  396861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  396864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  396867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  396883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396890 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  396890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  396893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  396897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  396912 */     GIR_RootConstrainSelectedInstOperands,
     /*  396913 */     // GIR_Coverage, 7242,
     /*  396913 */     GIR_EraseRootFromParent_Done,
     /*  396914 */   // Label 7080: @396914
     /*  396914 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(396989), // Rule ID 7243 //
     /*  396919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  396922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  396927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  396930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  396933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  396936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  396939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  396942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  396954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  396958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  396965 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  396965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  396968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  396970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  396972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  396976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  396981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  396984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  396987 */     GIR_RootConstrainSelectedInstOperands,
     /*  396988 */     // GIR_Coverage, 7243,
     /*  396988 */     GIR_EraseRootFromParent_Done,
     /*  396989 */   // Label 7081: @396989
     /*  396989 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(397064), // Rule ID 7246 //
     /*  396994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  396997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397029 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397062 */     GIR_RootConstrainSelectedInstOperands,
     /*  397063 */     // GIR_Coverage, 7246,
     /*  397063 */     GIR_EraseRootFromParent_Done,
     /*  397064 */   // Label 7082: @397064
     /*  397064 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(397139), // Rule ID 7247 //
     /*  397069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  397080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  397083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  397086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397115 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397137 */     GIR_RootConstrainSelectedInstOperands,
     /*  397138 */     // GIR_Coverage, 7247,
     /*  397138 */     GIR_EraseRootFromParent_Done,
     /*  397139 */   // Label 7083: @397139
     /*  397139 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(397214), // Rule ID 7250 //
     /*  397144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397212 */     GIR_RootConstrainSelectedInstOperands,
     /*  397213 */     // GIR_Coverage, 7250,
     /*  397213 */     GIR_EraseRootFromParent_Done,
     /*  397214 */   // Label 7084: @397214
     /*  397214 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(397289), // Rule ID 7251 //
     /*  397219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  397230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  397233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  397236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397265 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  397268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397287 */     GIR_RootConstrainSelectedInstOperands,
     /*  397288 */     // GIR_Coverage, 7251,
     /*  397288 */     GIR_EraseRootFromParent_Done,
     /*  397289 */   // Label 7085: @397289
     /*  397289 */   GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(397364), // Rule ID 7254 //
     /*  397294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397340 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397362 */     GIR_RootConstrainSelectedInstOperands,
     /*  397363 */     // GIR_Coverage, 7254,
     /*  397363 */     GIR_EraseRootFromParent_Done,
     /*  397364 */   // Label 7086: @397364
     /*  397364 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(397439), // Rule ID 7255 //
     /*  397369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  397380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  397383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  397386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397404 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397415 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397437 */     GIR_RootConstrainSelectedInstOperands,
     /*  397438 */     // GIR_Coverage, 7255,
     /*  397438 */     GIR_EraseRootFromParent_Done,
     /*  397439 */   // Label 7087: @397439
     /*  397439 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(397514), // Rule ID 7258 //
     /*  397444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397490 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  397490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397512 */     GIR_RootConstrainSelectedInstOperands,
     /*  397513 */     // GIR_Coverage, 7258,
     /*  397513 */     GIR_EraseRootFromParent_Done,
     /*  397514 */   // Label 7088: @397514
     /*  397514 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(397589), // Rule ID 7259 //
     /*  397519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  397530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  397533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  397536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397565 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  397565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  397568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397587 */     GIR_RootConstrainSelectedInstOperands,
     /*  397588 */     // GIR_Coverage, 7259,
     /*  397588 */     GIR_EraseRootFromParent_Done,
     /*  397589 */   // Label 7089: @397589
     /*  397589 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(397664), // Rule ID 7262 //
     /*  397594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  397605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  397608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  397611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  397640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  397643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397662 */     GIR_RootConstrainSelectedInstOperands,
     /*  397663 */     // GIR_Coverage, 7262,
     /*  397663 */     GIR_EraseRootFromParent_Done,
     /*  397664 */   // Label 7090: @397664
     /*  397664 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(397739), // Rule ID 7263 //
     /*  397669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  397680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  397683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  397686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397715 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  397715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  397718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  397734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397737 */     GIR_RootConstrainSelectedInstOperands,
     /*  397738 */     // GIR_Coverage, 7263,
     /*  397738 */     GIR_EraseRootFromParent_Done,
     /*  397739 */   // Label 7091: @397739
     /*  397739 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(397814), // Rule ID 7266 //
     /*  397744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  397755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  397758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  397761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  397790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  397793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397812 */     GIR_RootConstrainSelectedInstOperands,
     /*  397813 */     // GIR_Coverage, 7266,
     /*  397813 */     GIR_EraseRootFromParent_Done,
     /*  397814 */   // Label 7092: @397814
     /*  397814 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(397889), // Rule ID 7267 //
     /*  397819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  397830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  397833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  397836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397865 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  397865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  397868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  397884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397887 */     GIR_RootConstrainSelectedInstOperands,
     /*  397888 */     // GIR_Coverage, 7267,
     /*  397888 */     GIR_EraseRootFromParent_Done,
     /*  397889 */   // Label 7093: @397889
     /*  397889 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(397964), // Rule ID 7270 //
     /*  397894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  397897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  397905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  397908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  397911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  397914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  397917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  397933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  397940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  397940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  397943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  397945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  397947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  397951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  397956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  397959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  397962 */     GIR_RootConstrainSelectedInstOperands,
     /*  397963 */     // GIR_Coverage, 7270,
     /*  397963 */     GIR_EraseRootFromParent_Done,
     /*  397964 */   // Label 7094: @397964
     /*  397964 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(398039), // Rule ID 7271 //
     /*  397969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  397972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  397977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  397980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  397983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  397986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  397989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  397992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  397996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398015 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  398015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  398034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398037 */     GIR_RootConstrainSelectedInstOperands,
     /*  398038 */     // GIR_Coverage, 7271,
     /*  398038 */     GIR_EraseRootFromParent_Done,
     /*  398039 */   // Label 7095: @398039
     /*  398039 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(398114), // Rule ID 7274 //
     /*  398044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  398047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398090 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  398090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398112 */     GIR_RootConstrainSelectedInstOperands,
     /*  398113 */     // GIR_Coverage, 7274,
     /*  398113 */     GIR_EraseRootFromParent_Done,
     /*  398114 */   // Label 7096: @398114
     /*  398114 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(398189), // Rule ID 7275 //
     /*  398119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  398122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  398130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  398133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  398136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  398154 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398165 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  398165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  398168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  398184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398187 */     GIR_RootConstrainSelectedInstOperands,
     /*  398188 */     // GIR_Coverage, 7275,
     /*  398188 */     GIR_EraseRootFromParent_Done,
     /*  398189 */   // Label 7097: @398189
     /*  398189 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(398264), // Rule ID 7278 //
     /*  398194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398262 */     GIR_RootConstrainSelectedInstOperands,
     /*  398263 */     // GIR_Coverage, 7278,
     /*  398263 */     GIR_EraseRootFromParent_Done,
     /*  398264 */   // Label 7098: @398264
     /*  398264 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(398339), // Rule ID 7279 //
     /*  398269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  398280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  398283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  398286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398304 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398315 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398337 */     GIR_RootConstrainSelectedInstOperands,
     /*  398338 */     // GIR_Coverage, 7279,
     /*  398338 */     GIR_EraseRootFromParent_Done,
     /*  398339 */   // Label 7099: @398339
     /*  398339 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(398414), // Rule ID 7282 //
     /*  398344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398390 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398412 */     GIR_RootConstrainSelectedInstOperands,
     /*  398413 */     // GIR_Coverage, 7282,
     /*  398413 */     GIR_EraseRootFromParent_Done,
     /*  398414 */   // Label 7100: @398414
     /*  398414 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(398489), // Rule ID 7283 //
     /*  398419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  398430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  398433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  398436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398465 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398487 */     GIR_RootConstrainSelectedInstOperands,
     /*  398488 */     // GIR_Coverage, 7283,
     /*  398488 */     GIR_EraseRootFromParent_Done,
     /*  398489 */   // Label 7101: @398489
     /*  398489 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(398564), // Rule ID 7286 //
     /*  398494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  398505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  398508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  398511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398540 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  398540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  398543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398562 */     GIR_RootConstrainSelectedInstOperands,
     /*  398563 */     // GIR_Coverage, 7286,
     /*  398563 */     GIR_EraseRootFromParent_Done,
     /*  398564 */   // Label 7102: @398564
     /*  398564 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(398639), // Rule ID 7287 //
     /*  398569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  398580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  398583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  398586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398615 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  398615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  398618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  398634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398637 */     GIR_RootConstrainSelectedInstOperands,
     /*  398638 */     // GIR_Coverage, 7287,
     /*  398638 */     GIR_EraseRootFromParent_Done,
     /*  398639 */   // Label 7103: @398639
     /*  398639 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(398714), // Rule ID 7290 //
     /*  398644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  398655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  398658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  398661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398690 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398712 */     GIR_RootConstrainSelectedInstOperands,
     /*  398713 */     // GIR_Coverage, 7290,
     /*  398713 */     GIR_EraseRootFromParent_Done,
     /*  398714 */   // Label 7104: @398714
     /*  398714 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(398789), // Rule ID 7291 //
     /*  398719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  398730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  398733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  398736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  398754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398765 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  398768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398787 */     GIR_RootConstrainSelectedInstOperands,
     /*  398788 */     // GIR_Coverage, 7291,
     /*  398788 */     GIR_EraseRootFromParent_Done,
     /*  398789 */   // Label 7105: @398789
     /*  398789 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(398864), // Rule ID 7294 //
     /*  398794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  398805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  398808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  398811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398829 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398862 */     GIR_RootConstrainSelectedInstOperands,
     /*  398863 */     // GIR_Coverage, 7294,
     /*  398863 */     GIR_EraseRootFromParent_Done,
     /*  398864 */   // Label 7106: @398864
     /*  398864 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(398939), // Rule ID 7295 //
     /*  398869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  398872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  398880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  398883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  398886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  398889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  398892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  398904 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398915 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  398915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  398918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  398931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  398934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  398937 */     GIR_RootConstrainSelectedInstOperands,
     /*  398938 */     // GIR_Coverage, 7295,
     /*  398938 */     GIR_EraseRootFromParent_Done,
     /*  398939 */   // Label 7107: @398939
     /*  398939 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(399014), // Rule ID 7298 //
     /*  398944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  398947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  398952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  398955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  398958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  398961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  398964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  398967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  398979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  398983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  398990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  398990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  398993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  398995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  398997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  398999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399012 */     GIR_RootConstrainSelectedInstOperands,
     /*  399013 */     // GIR_Coverage, 7298,
     /*  399013 */     GIR_EraseRootFromParent_Done,
     /*  399014 */   // Label 7108: @399014
     /*  399014 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(399089), // Rule ID 7299 //
     /*  399019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  399030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  399033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  399036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399054 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399065 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  399065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  399084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399087 */     GIR_RootConstrainSelectedInstOperands,
     /*  399088 */     // GIR_Coverage, 7299,
     /*  399088 */     GIR_EraseRootFromParent_Done,
     /*  399089 */   // Label 7109: @399089
     /*  399089 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(399164), // Rule ID 7302 //
     /*  399094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399162 */     GIR_RootConstrainSelectedInstOperands,
     /*  399163 */     // GIR_Coverage, 7302,
     /*  399163 */     GIR_EraseRootFromParent_Done,
     /*  399164 */   // Label 7110: @399164
     /*  399164 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(399239), // Rule ID 7303 //
     /*  399169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  399180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  399183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  399186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399215 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399237 */     GIR_RootConstrainSelectedInstOperands,
     /*  399238 */     // GIR_Coverage, 7303,
     /*  399238 */     GIR_EraseRootFromParent_Done,
     /*  399239 */   // Label 7111: @399239
     /*  399239 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(399314), // Rule ID 7306 //
     /*  399244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399290 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399312 */     GIR_RootConstrainSelectedInstOperands,
     /*  399313 */     // GIR_Coverage, 7306,
     /*  399313 */     GIR_EraseRootFromParent_Done,
     /*  399314 */   // Label 7112: @399314
     /*  399314 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(399389), // Rule ID 7307 //
     /*  399319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  399330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  399333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  399336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399354 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399365 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399387 */     GIR_RootConstrainSelectedInstOperands,
     /*  399388 */     // GIR_Coverage, 7307,
     /*  399388 */     GIR_EraseRootFromParent_Done,
     /*  399389 */   // Label 7113: @399389
     /*  399389 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(399464), // Rule ID 7310 //
     /*  399394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  399397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  399405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  399408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  399411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  399440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399462 */     GIR_RootConstrainSelectedInstOperands,
     /*  399463 */     // GIR_Coverage, 7310,
     /*  399463 */     GIR_EraseRootFromParent_Done,
     /*  399464 */   // Label 7114: @399464
     /*  399464 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(399539), // Rule ID 7311 //
     /*  399469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  399472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  399480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  399483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  399486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  399515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  399534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399537 */     GIR_RootConstrainSelectedInstOperands,
     /*  399538 */     // GIR_Coverage, 7311,
     /*  399538 */     GIR_EraseRootFromParent_Done,
     /*  399539 */   // Label 7115: @399539
     /*  399539 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(399614), // Rule ID 7314 //
     /*  399544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  399547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  399555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  399558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  399561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  399590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399612 */     GIR_RootConstrainSelectedInstOperands,
     /*  399613 */     // GIR_Coverage, 7314,
     /*  399613 */     GIR_EraseRootFromParent_Done,
     /*  399614 */   // Label 7116: @399614
     /*  399614 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(399689), // Rule ID 7315 //
     /*  399619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  399622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  399630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  399633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  399636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  399654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  399665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  399668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399687 */     GIR_RootConstrainSelectedInstOperands,
     /*  399688 */     // GIR_Coverage, 7315,
     /*  399688 */     GIR_EraseRootFromParent_Done,
     /*  399689 */   // Label 7117: @399689
     /*  399689 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(399764), // Rule ID 7318 //
     /*  399694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  399697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  399705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  399708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  399711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399740 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  399740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399762 */     GIR_RootConstrainSelectedInstOperands,
     /*  399763 */     // GIR_Coverage, 7318,
     /*  399763 */     GIR_EraseRootFromParent_Done,
     /*  399764 */   // Label 7118: @399764
     /*  399764 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(399839), // Rule ID 7319 //
     /*  399769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  399772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  399780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  399783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  399786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  399804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399815 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  399815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  399818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399837 */     GIR_RootConstrainSelectedInstOperands,
     /*  399838 */     // GIR_Coverage, 7319,
     /*  399838 */     GIR_EraseRootFromParent_Done,
     /*  399839 */   // Label 7119: @399839
     /*  399839 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(399914), // Rule ID 7322 //
     /*  399844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  399847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  399855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  399858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  399861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  399864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  399867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399879 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399890 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  399890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399912 */     GIR_RootConstrainSelectedInstOperands,
     /*  399913 */     // GIR_Coverage, 7322,
     /*  399913 */     GIR_EraseRootFromParent_Done,
     /*  399914 */   // Label 7120: @399914
     /*  399914 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(399989), // Rule ID 7323 //
     /*  399919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  399922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  399927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  399930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  399933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  399936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  399939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  399942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  399954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  399958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  399965 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  399965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  399968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  399970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  399972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  399976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  399981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  399984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  399987 */     GIR_RootConstrainSelectedInstOperands,
     /*  399988 */     // GIR_Coverage, 7323,
     /*  399988 */     GIR_EraseRootFromParent_Done,
     /*  399989 */   // Label 7121: @399989
     /*  399989 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(400066), // Rule ID 2636 //
     /*  399994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  399997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400026 */     // MIs[0] Operand 4
     /*  400026 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400064 */     GIR_RootConstrainSelectedInstOperands,
     /*  400065 */     // GIR_Coverage, 2636,
     /*  400065 */     GIR_EraseRootFromParent_Done,
     /*  400066 */   // Label 7122: @400066
     /*  400066 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(400143), // Rule ID 2637 //
     /*  400071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  400082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  400085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  400088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400103 */     // MIs[0] Operand 4
     /*  400103 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400121 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /*  400124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400141 */     GIR_RootConstrainSelectedInstOperands,
     /*  400142 */     // GIR_Coverage, 2637,
     /*  400142 */     GIR_EraseRootFromParent_Done,
     /*  400143 */   // Label 7123: @400143
     /*  400143 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(400220), // Rule ID 20520 //
     /*  400148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400180 */     // MIs[0] Operand 4
     /*  400180 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400218 */     GIR_RootConstrainSelectedInstOperands,
     /*  400219 */     // GIR_Coverage, 20520,
     /*  400219 */     GIR_EraseRootFromParent_Done,
     /*  400220 */   // Label 7124: @400220
     /*  400220 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(400297), // Rule ID 20521 //
     /*  400225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  400236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  400239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  400242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400257 */     // MIs[0] Operand 4
     /*  400257 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400275 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400295 */     GIR_RootConstrainSelectedInstOperands,
     /*  400296 */     // GIR_Coverage, 20521,
     /*  400296 */     GIR_EraseRootFromParent_Done,
     /*  400297 */   // Label 7125: @400297
     /*  400297 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(400374), // Rule ID 20524 //
     /*  400302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  400305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400334 */     // MIs[0] Operand 4
     /*  400334 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400372 */     GIR_RootConstrainSelectedInstOperands,
     /*  400373 */     // GIR_Coverage, 20524,
     /*  400373 */     GIR_EraseRootFromParent_Done,
     /*  400374 */   // Label 7126: @400374
     /*  400374 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(400451), // Rule ID 20525 //
     /*  400379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  400382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  400390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  400393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  400396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400411 */     // MIs[0] Operand 4
     /*  400411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400429 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /*  400432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400449 */     GIR_RootConstrainSelectedInstOperands,
     /*  400450 */     // GIR_Coverage, 20525,
     /*  400450 */     GIR_EraseRootFromParent_Done,
     /*  400451 */   // Label 7127: @400451
     /*  400451 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(400528), // Rule ID 20528 //
     /*  400456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  400467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  400470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  400473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400488 */     // MIs[0] Operand 4
     /*  400488 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400506 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400526 */     GIR_RootConstrainSelectedInstOperands,
     /*  400527 */     // GIR_Coverage, 20528,
     /*  400527 */     GIR_EraseRootFromParent_Done,
     /*  400528 */   // Label 7128: @400528
     /*  400528 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(400605), // Rule ID 20529 //
     /*  400533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  400544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  400547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  400550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400565 */     // MIs[0] Operand 4
     /*  400565 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400583 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  400583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400603 */     GIR_RootConstrainSelectedInstOperands,
     /*  400604 */     // GIR_Coverage, 20529,
     /*  400604 */     GIR_EraseRootFromParent_Done,
     /*  400605 */   // Label 7129: @400605
     /*  400605 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(400682), // Rule ID 20532 //
     /*  400610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  400613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  400621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  400624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  400627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400642 */     // MIs[0] Operand 4
     /*  400642 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400660 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  400660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400680 */     GIR_RootConstrainSelectedInstOperands,
     /*  400681 */     // GIR_Coverage, 20532,
     /*  400681 */     GIR_EraseRootFromParent_Done,
     /*  400682 */   // Label 7130: @400682
     /*  400682 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(400759), // Rule ID 20533 //
     /*  400687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  400690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  400698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  400701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  400704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400719 */     // MIs[0] Operand 4
     /*  400719 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400737 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  400737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  400754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400757 */     GIR_RootConstrainSelectedInstOperands,
     /*  400758 */     // GIR_Coverage, 20533,
     /*  400758 */     GIR_EraseRootFromParent_Done,
     /*  400759 */   // Label 7131: @400759
     /*  400759 */   GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(400836), // Rule ID 20536 //
     /*  400764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  400767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  400775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  400778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  400781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400796 */     // MIs[0] Operand 4
     /*  400796 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400814 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  400814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400834 */     GIR_RootConstrainSelectedInstOperands,
     /*  400835 */     // GIR_Coverage, 20536,
     /*  400835 */     GIR_EraseRootFromParent_Done,
     /*  400836 */   // Label 7132: @400836
     /*  400836 */   GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(400913), // Rule ID 20537 //
     /*  400841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  400844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  400852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  400855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  400858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  400861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  400873 */     // MIs[0] Operand 4
     /*  400873 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400891 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  400891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /*  400894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  400908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400911 */     GIR_RootConstrainSelectedInstOperands,
     /*  400912 */     // GIR_Coverage, 20537,
     /*  400912 */     GIR_EraseRootFromParent_Done,
     /*  400913 */   // Label 7133: @400913
     /*  400913 */   GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(400990), // Rule ID 20540 //
     /*  400918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  400921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  400926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  400929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  400932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  400935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  400938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  400950 */     // MIs[0] Operand 4
     /*  400950 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  400961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  400968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  400968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  400971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  400973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  400975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  400977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  400982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  400985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  400988 */     GIR_RootConstrainSelectedInstOperands,
     /*  400989 */     // GIR_Coverage, 20540,
     /*  400989 */     GIR_EraseRootFromParent_Done,
     /*  400990 */   // Label 7134: @400990
     /*  400990 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(401067), // Rule ID 20541 //
     /*  400995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  400998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  401006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  401009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  401012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401027 */     // MIs[0] Operand 4
     /*  401027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401045 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401065 */     GIR_RootConstrainSelectedInstOperands,
     /*  401066 */     // GIR_Coverage, 20541,
     /*  401066 */     GIR_EraseRootFromParent_Done,
     /*  401067 */   // Label 7135: @401067
     /*  401067 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(401144), // Rule ID 20544 //
     /*  401072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401104 */     // MIs[0] Operand 4
     /*  401104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401122 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401142 */     GIR_RootConstrainSelectedInstOperands,
     /*  401143 */     // GIR_Coverage, 20544,
     /*  401143 */     GIR_EraseRootFromParent_Done,
     /*  401144 */   // Label 7136: @401144
     /*  401144 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(401221), // Rule ID 20545 //
     /*  401149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  401160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  401163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  401166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401181 */     // MIs[0] Operand 4
     /*  401181 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401199 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401219 */     GIR_RootConstrainSelectedInstOperands,
     /*  401220 */     // GIR_Coverage, 20545,
     /*  401220 */     GIR_EraseRootFromParent_Done,
     /*  401221 */   // Label 7137: @401221
     /*  401221 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(401298), // Rule ID 20548 //
     /*  401226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  401229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401258 */     // MIs[0] Operand 4
     /*  401258 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401276 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  401276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401296 */     GIR_RootConstrainSelectedInstOperands,
     /*  401297 */     // GIR_Coverage, 20548,
     /*  401297 */     GIR_EraseRootFromParent_Done,
     /*  401298 */   // Label 7138: @401298
     /*  401298 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(401375), // Rule ID 20549 //
     /*  401303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  401306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  401314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  401317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  401320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401335 */     // MIs[0] Operand 4
     /*  401335 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401353 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  401353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  401370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401373 */     GIR_RootConstrainSelectedInstOperands,
     /*  401374 */     // GIR_Coverage, 20549,
     /*  401374 */     GIR_EraseRootFromParent_Done,
     /*  401375 */   // Label 7139: @401375
     /*  401375 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(401452), // Rule ID 20552 //
     /*  401380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401412 */     // MIs[0] Operand 4
     /*  401412 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401450 */     GIR_RootConstrainSelectedInstOperands,
     /*  401451 */     // GIR_Coverage, 20552,
     /*  401451 */     GIR_EraseRootFromParent_Done,
     /*  401452 */   // Label 7140: @401452
     /*  401452 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(401529), // Rule ID 20553 //
     /*  401457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  401468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  401471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  401474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401489 */     // MIs[0] Operand 4
     /*  401489 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401507 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401527 */     GIR_RootConstrainSelectedInstOperands,
     /*  401528 */     // GIR_Coverage, 20553,
     /*  401528 */     GIR_EraseRootFromParent_Done,
     /*  401529 */   // Label 7141: @401529
     /*  401529 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(401606), // Rule ID 20556 //
     /*  401534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  401545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  401548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  401551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401566 */     // MIs[0] Operand 4
     /*  401566 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401584 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401604 */     GIR_RootConstrainSelectedInstOperands,
     /*  401605 */     // GIR_Coverage, 20556,
     /*  401605 */     GIR_EraseRootFromParent_Done,
     /*  401606 */   // Label 7142: @401606
     /*  401606 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(401683), // Rule ID 20557 //
     /*  401611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  401622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  401625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  401628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  401643 */     // MIs[0] Operand 4
     /*  401643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401661 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  401664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401681 */     GIR_RootConstrainSelectedInstOperands,
     /*  401682 */     // GIR_Coverage, 20557,
     /*  401682 */     GIR_EraseRootFromParent_Done,
     /*  401683 */   // Label 7143: @401683
     /*  401683 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(401760), // Rule ID 20560 //
     /*  401688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  401691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  401699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  401702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  401705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401720 */     // MIs[0] Operand 4
     /*  401720 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401738 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  401738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401758 */     GIR_RootConstrainSelectedInstOperands,
     /*  401759 */     // GIR_Coverage, 20560,
     /*  401759 */     GIR_EraseRootFromParent_Done,
     /*  401760 */   // Label 7144: @401760
     /*  401760 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(401837), // Rule ID 20561 //
     /*  401765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  401768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  401776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  401779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  401782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  401797 */     // MIs[0] Operand 4
     /*  401797 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401815 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  401815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  401818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  401832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401835 */     GIR_RootConstrainSelectedInstOperands,
     /*  401836 */     // GIR_Coverage, 20561,
     /*  401836 */     GIR_EraseRootFromParent_Done,
     /*  401837 */   // Label 7145: @401837
     /*  401837 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(401914), // Rule ID 20564 //
     /*  401842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  401853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  401856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  401859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  401862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401874 */     // MIs[0] Operand 4
     /*  401874 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  401892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401912 */     GIR_RootConstrainSelectedInstOperands,
     /*  401913 */     // GIR_Coverage, 20564,
     /*  401913 */     GIR_EraseRootFromParent_Done,
     /*  401914 */   // Label 7146: @401914
     /*  401914 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(401991), // Rule ID 20565 //
     /*  401919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  401922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  401927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  401930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  401933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  401936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  401939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  401951 */     // MIs[0] Operand 4
     /*  401951 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  401962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  401969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  401969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /*  401972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  401974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  401976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  401978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  401983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  401986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  401989 */     GIR_RootConstrainSelectedInstOperands,
     /*  401990 */     // GIR_Coverage, 20565,
     /*  401990 */     GIR_EraseRootFromParent_Done,
     /*  401991 */   // Label 7147: @401991
     /*  401991 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(402068), // Rule ID 20568 //
     /*  401996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  401999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402028 */     // MIs[0] Operand 4
     /*  402028 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402046 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402066 */     GIR_RootConstrainSelectedInstOperands,
     /*  402067 */     // GIR_Coverage, 20568,
     /*  402067 */     GIR_EraseRootFromParent_Done,
     /*  402068 */   // Label 7148: @402068
     /*  402068 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(402145), // Rule ID 20569 //
     /*  402073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  402084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  402087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  402090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  402105 */     // MIs[0] Operand 4
     /*  402105 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402123 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /*  402126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402143 */     GIR_RootConstrainSelectedInstOperands,
     /*  402144 */     // GIR_Coverage, 20569,
     /*  402144 */     GIR_EraseRootFromParent_Done,
     /*  402145 */   // Label 7149: @402145
     /*  402145 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(402222), // Rule ID 20572 //
     /*  402150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  402153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402182 */     // MIs[0] Operand 4
     /*  402182 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  402200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402220 */     GIR_RootConstrainSelectedInstOperands,
     /*  402221 */     // GIR_Coverage, 20572,
     /*  402221 */     GIR_EraseRootFromParent_Done,
     /*  402222 */   // Label 7150: @402222
     /*  402222 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(402299), // Rule ID 20573 //
     /*  402227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  402230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  402235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  402238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  402241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  402244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  402259 */     // MIs[0] Operand 4
     /*  402259 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402277 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  402277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /*  402280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  402294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402297 */     GIR_RootConstrainSelectedInstOperands,
     /*  402298 */     // GIR_Coverage, 20573,
     /*  402298 */     GIR_EraseRootFromParent_Done,
     /*  402299 */   // Label 7151: @402299
     /*  402299 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(402376), // Rule ID 20576 //
     /*  402304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402336 */     // MIs[0] Operand 4
     /*  402336 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402374 */     GIR_RootConstrainSelectedInstOperands,
     /*  402375 */     // GIR_Coverage, 20576,
     /*  402375 */     GIR_EraseRootFromParent_Done,
     /*  402376 */   // Label 7152: @402376
     /*  402376 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(402453), // Rule ID 20577 //
     /*  402381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  402392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  402395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  402398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402413 */     // MIs[0] Operand 4
     /*  402413 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402431 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /*  402434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402451 */     GIR_RootConstrainSelectedInstOperands,
     /*  402452 */     // GIR_Coverage, 20577,
     /*  402452 */     GIR_EraseRootFromParent_Done,
     /*  402453 */   // Label 7153: @402453
     /*  402453 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(402530), // Rule ID 20580 //
     /*  402458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  402469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  402472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  402475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402490 */     // MIs[0] Operand 4
     /*  402490 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  402511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402528 */     GIR_RootConstrainSelectedInstOperands,
     /*  402529 */     // GIR_Coverage, 20580,
     /*  402529 */     GIR_EraseRootFromParent_Done,
     /*  402530 */   // Label 7154: @402530
     /*  402530 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(402607), // Rule ID 20581 //
     /*  402535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  402546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  402549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  402552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402567 */     // MIs[0] Operand 4
     /*  402567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402585 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  402588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402605 */     GIR_RootConstrainSelectedInstOperands,
     /*  402606 */     // GIR_Coverage, 20581,
     /*  402606 */     GIR_EraseRootFromParent_Done,
     /*  402607 */   // Label 7155: @402607
     /*  402607 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(402684), // Rule ID 20584 //
     /*  402612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  402623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  402626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  402629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402644 */     // MIs[0] Operand 4
     /*  402644 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  402665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402682 */     GIR_RootConstrainSelectedInstOperands,
     /*  402683 */     // GIR_Coverage, 20584,
     /*  402683 */     GIR_EraseRootFromParent_Done,
     /*  402684 */   // Label 7156: @402684
     /*  402684 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(402761), // Rule ID 20585 //
     /*  402689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  402692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  402700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  402703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  402706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402721 */     // MIs[0] Operand 4
     /*  402721 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  402739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /*  402742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402759 */     GIR_RootConstrainSelectedInstOperands,
     /*  402760 */     // GIR_Coverage, 20585,
     /*  402760 */     GIR_EraseRootFromParent_Done,
     /*  402761 */   // Label 7157: @402761
     /*  402761 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(402838), // Rule ID 20588 //
     /*  402766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  402769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402798 */     // MIs[0] Operand 4
     /*  402798 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  402816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  402819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402836 */     GIR_RootConstrainSelectedInstOperands,
     /*  402837 */     // GIR_Coverage, 20588,
     /*  402837 */     GIR_EraseRootFromParent_Done,
     /*  402838 */   // Label 7158: @402838
     /*  402838 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(402915), // Rule ID 20589 //
     /*  402843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  402846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  402854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  402857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  402860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  402863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402875 */     // MIs[0] Operand 4
     /*  402875 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402893 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  402893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  402896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  402910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402913 */     GIR_RootConstrainSelectedInstOperands,
     /*  402914 */     // GIR_Coverage, 20589,
     /*  402914 */     GIR_EraseRootFromParent_Done,
     /*  402915 */   // Label 7159: @402915
     /*  402915 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(402992), // Rule ID 20592 //
     /*  402920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  402923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  402928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  402931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  402934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  402937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  402940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  402952 */     // MIs[0] Operand 4
     /*  402952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  402963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  402970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  402970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  402973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  402975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  402977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  402979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  402984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  402987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  402990 */     GIR_RootConstrainSelectedInstOperands,
     /*  402991 */     // GIR_Coverage, 20592,
     /*  402991 */     GIR_EraseRootFromParent_Done,
     /*  402992 */   // Label 7160: @402992
     /*  402992 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(403069), // Rule ID 20593 //
     /*  402997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  403008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  403011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  403014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403029 */     // MIs[0] Operand 4
     /*  403029 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403047 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403067 */     GIR_RootConstrainSelectedInstOperands,
     /*  403068 */     // GIR_Coverage, 20593,
     /*  403068 */     GIR_EraseRootFromParent_Done,
     /*  403069 */   // Label 7161: @403069
     /*  403069 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(403146), // Rule ID 20596 //
     /*  403074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  403077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403106 */     // MIs[0] Operand 4
     /*  403106 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403124 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  403124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403144 */     GIR_RootConstrainSelectedInstOperands,
     /*  403145 */     // GIR_Coverage, 20596,
     /*  403145 */     GIR_EraseRootFromParent_Done,
     /*  403146 */   // Label 7162: @403146
     /*  403146 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(403223), // Rule ID 20597 //
     /*  403151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  403154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  403162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  403165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  403168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  403183 */     // MIs[0] Operand 4
     /*  403183 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403201 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  403201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /*  403204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  403218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403221 */     GIR_RootConstrainSelectedInstOperands,
     /*  403222 */     // GIR_Coverage, 20597,
     /*  403222 */     GIR_EraseRootFromParent_Done,
     /*  403223 */   // Label 7163: @403223
     /*  403223 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(403300), // Rule ID 20600 //
     /*  403228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403260 */     // MIs[0] Operand 4
     /*  403260 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403298 */     GIR_RootConstrainSelectedInstOperands,
     /*  403299 */     // GIR_Coverage, 20600,
     /*  403299 */     GIR_EraseRootFromParent_Done,
     /*  403300 */   // Label 7164: @403300
     /*  403300 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(403377), // Rule ID 20601 //
     /*  403305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  403316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  403319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  403322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403337 */     // MIs[0] Operand 4
     /*  403337 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403375 */     GIR_RootConstrainSelectedInstOperands,
     /*  403376 */     // GIR_Coverage, 20601,
     /*  403376 */     GIR_EraseRootFromParent_Done,
     /*  403377 */   // Label 7165: @403377
     /*  403377 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(403454), // Rule ID 20604 //
     /*  403382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403414 */     // MIs[0] Operand 4
     /*  403414 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403452 */     GIR_RootConstrainSelectedInstOperands,
     /*  403453 */     // GIR_Coverage, 20604,
     /*  403453 */     GIR_EraseRootFromParent_Done,
     /*  403454 */   // Label 7166: @403454
     /*  403454 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(403531), // Rule ID 20605 //
     /*  403459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  403470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  403473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  403476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403491 */     // MIs[0] Operand 4
     /*  403491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403509 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403529 */     GIR_RootConstrainSelectedInstOperands,
     /*  403530 */     // GIR_Coverage, 20605,
     /*  403530 */     GIR_EraseRootFromParent_Done,
     /*  403531 */   // Label 7167: @403531
     /*  403531 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(403608), // Rule ID 20608 //
     /*  403536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  403539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403568 */     // MIs[0] Operand 4
     /*  403568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  403586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  403589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403606 */     GIR_RootConstrainSelectedInstOperands,
     /*  403607 */     // GIR_Coverage, 20608,
     /*  403607 */     GIR_EraseRootFromParent_Done,
     /*  403608 */   // Label 7168: @403608
     /*  403608 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(403685), // Rule ID 20609 //
     /*  403613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  403616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  403624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  403627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  403630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  403645 */     // MIs[0] Operand 4
     /*  403645 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403663 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  403663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  403666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  403680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403683 */     GIR_RootConstrainSelectedInstOperands,
     /*  403684 */     // GIR_Coverage, 20609,
     /*  403684 */     GIR_EraseRootFromParent_Done,
     /*  403685 */   // Label 7169: @403685
     /*  403685 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(403762), // Rule ID 20612 //
     /*  403690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403722 */     // MIs[0] Operand 4
     /*  403722 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403760 */     GIR_RootConstrainSelectedInstOperands,
     /*  403761 */     // GIR_Coverage, 20612,
     /*  403761 */     GIR_EraseRootFromParent_Done,
     /*  403762 */   // Label 7170: @403762
     /*  403762 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(403839), // Rule ID 20613 //
     /*  403767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  403778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  403781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  403784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  403799 */     // MIs[0] Operand 4
     /*  403799 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403817 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  403820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403837 */     GIR_RootConstrainSelectedInstOperands,
     /*  403838 */     // GIR_Coverage, 20613,
     /*  403838 */     GIR_EraseRootFromParent_Done,
     /*  403839 */   // Label 7171: @403839
     /*  403839 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(403916), // Rule ID 20616 //
     /*  403844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  403847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  403864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403876 */     // MIs[0] Operand 4
     /*  403876 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  403894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403914 */     GIR_RootConstrainSelectedInstOperands,
     /*  403915 */     // GIR_Coverage, 20616,
     /*  403915 */     GIR_EraseRootFromParent_Done,
     /*  403916 */   // Label 7172: @403916
     /*  403916 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(403993), // Rule ID 20617 //
     /*  403921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  403924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  403929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  403932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  403935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  403938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  403941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  403953 */     // MIs[0] Operand 4
     /*  403953 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  403964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  403971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  403971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  403974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  403976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  403978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  403980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  403985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  403988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  403991 */     GIR_RootConstrainSelectedInstOperands,
     /*  403992 */     // GIR_Coverage, 20617,
     /*  403992 */     GIR_EraseRootFromParent_Done,
     /*  403993 */   // Label 7173: @403993
     /*  403993 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(404070), // Rule ID 20620 //
     /*  403998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  404001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404030 */     // MIs[0] Operand 4
     /*  404030 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  404048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404068 */     GIR_RootConstrainSelectedInstOperands,
     /*  404069 */     // GIR_Coverage, 20620,
     /*  404069 */     GIR_EraseRootFromParent_Done,
     /*  404070 */   // Label 7174: @404070
     /*  404070 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(404147), // Rule ID 20621 //
     /*  404075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  404078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  404086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  404089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  404092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404107 */     // MIs[0] Operand 4
     /*  404107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404125 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  404125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  404142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404145 */     GIR_RootConstrainSelectedInstOperands,
     /*  404146 */     // GIR_Coverage, 20621,
     /*  404146 */     GIR_EraseRootFromParent_Done,
     /*  404147 */   // Label 7175: @404147
     /*  404147 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(404224), // Rule ID 20624 //
     /*  404152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404184 */     // MIs[0] Operand 4
     /*  404184 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404222 */     GIR_RootConstrainSelectedInstOperands,
     /*  404223 */     // GIR_Coverage, 20624,
     /*  404223 */     GIR_EraseRootFromParent_Done,
     /*  404224 */   // Label 7176: @404224
     /*  404224 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(404301), // Rule ID 20625 //
     /*  404229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  404240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  404243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  404246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404261 */     // MIs[0] Operand 4
     /*  404261 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404279 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /*  404282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404299 */     GIR_RootConstrainSelectedInstOperands,
     /*  404300 */     // GIR_Coverage, 20625,
     /*  404300 */     GIR_EraseRootFromParent_Done,
     /*  404301 */   // Label 7177: @404301
     /*  404301 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(404378), // Rule ID 20628 //
     /*  404306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404338 */     // MIs[0] Operand 4
     /*  404338 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404356 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404376 */     GIR_RootConstrainSelectedInstOperands,
     /*  404377 */     // GIR_Coverage, 20628,
     /*  404377 */     GIR_EraseRootFromParent_Done,
     /*  404378 */   // Label 7178: @404378
     /*  404378 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(404455), // Rule ID 20629 //
     /*  404383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  404394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  404397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  404400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  404415 */     // MIs[0] Operand 4
     /*  404415 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404433 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /*  404436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404453 */     GIR_RootConstrainSelectedInstOperands,
     /*  404454 */     // GIR_Coverage, 20629,
     /*  404454 */     GIR_EraseRootFromParent_Done,
     /*  404455 */   // Label 7179: @404455
     /*  404455 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(404532), // Rule ID 20632 //
     /*  404460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  404463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404492 */     // MIs[0] Operand 4
     /*  404492 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  404510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404530 */     GIR_RootConstrainSelectedInstOperands,
     /*  404531 */     // GIR_Coverage, 20632,
     /*  404531 */     GIR_EraseRootFromParent_Done,
     /*  404532 */   // Label 7180: @404532
     /*  404532 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(404609), // Rule ID 20633 //
     /*  404537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  404540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  404545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  404548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  404551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  404554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  404569 */     // MIs[0] Operand 4
     /*  404569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404587 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  404587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /*  404590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  404604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404607 */     GIR_RootConstrainSelectedInstOperands,
     /*  404608 */     // GIR_Coverage, 20633,
     /*  404608 */     GIR_EraseRootFromParent_Done,
     /*  404609 */   // Label 7181: @404609
     /*  404609 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(404686), // Rule ID 20992 //
     /*  404614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  404622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404646 */     // MIs[0] Operand 4
     /*  404646 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  404667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404684 */     GIR_RootConstrainSelectedInstOperands,
     /*  404685 */     // GIR_Coverage, 20992,
     /*  404685 */     GIR_EraseRootFromParent_Done,
     /*  404686 */   // Label 7182: @404686
     /*  404686 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(404763), // Rule ID 20993 //
     /*  404691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  404699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  404702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  404705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  404708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404723 */     // MIs[0] Operand 4
     /*  404723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404741 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /*  404744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404761 */     GIR_RootConstrainSelectedInstOperands,
     /*  404762 */     // GIR_Coverage, 20993,
     /*  404762 */     GIR_EraseRootFromParent_Done,
     /*  404763 */   // Label 7183: @404763
     /*  404763 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(404840), // Rule ID 20996 //
     /*  404768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  404776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404800 */     // MIs[0] Operand 4
     /*  404800 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  404821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404838 */     GIR_RootConstrainSelectedInstOperands,
     /*  404839 */     // GIR_Coverage, 20996,
     /*  404839 */     GIR_EraseRootFromParent_Done,
     /*  404840 */   // Label 7184: @404840
     /*  404840 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(404917), // Rule ID 20997 //
     /*  404845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  404848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  404853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  404856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  404859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  404862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  404865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404877 */     // MIs[0] Operand 4
     /*  404877 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  404895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  404898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404915 */     GIR_RootConstrainSelectedInstOperands,
     /*  404916 */     // GIR_Coverage, 20997,
     /*  404916 */     GIR_EraseRootFromParent_Done,
     /*  404917 */   // Label 7185: @404917
     /*  404917 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(404994), // Rule ID 21000 //
     /*  404922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  404925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  404930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  404933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  404936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  404939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  404942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  404950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  404954 */     // MIs[0] Operand 4
     /*  404954 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  404965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  404972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  404972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  404975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  404977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  404979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  404981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  404986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  404989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  404992 */     GIR_RootConstrainSelectedInstOperands,
     /*  404993 */     // GIR_Coverage, 21000,
     /*  404993 */     GIR_EraseRootFromParent_Done,
     /*  404994 */   // Label 7186: @404994
     /*  404994 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(405071), // Rule ID 21001 //
     /*  404999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  405010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  405013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  405016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405031 */     // MIs[0] Operand 4
     /*  405031 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405069 */     GIR_RootConstrainSelectedInstOperands,
     /*  405070 */     // GIR_Coverage, 21001,
     /*  405070 */     GIR_EraseRootFromParent_Done,
     /*  405071 */   // Label 7187: @405071
     /*  405071 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(405148), // Rule ID 21004 //
     /*  405076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405108 */     // MIs[0] Operand 4
     /*  405108 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405146 */     GIR_RootConstrainSelectedInstOperands,
     /*  405147 */     // GIR_Coverage, 21004,
     /*  405147 */     GIR_EraseRootFromParent_Done,
     /*  405148 */   // Label 7188: @405148
     /*  405148 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(405225), // Rule ID 21005 //
     /*  405153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  405164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  405167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  405170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405185 */     // MIs[0] Operand 4
     /*  405185 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405223 */     GIR_RootConstrainSelectedInstOperands,
     /*  405224 */     // GIR_Coverage, 21005,
     /*  405224 */     GIR_EraseRootFromParent_Done,
     /*  405225 */   // Label 7189: @405225
     /*  405225 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(405302), // Rule ID 21008 //
     /*  405230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  405233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405262 */     // MIs[0] Operand 4
     /*  405262 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  405280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405300 */     GIR_RootConstrainSelectedInstOperands,
     /*  405301 */     // GIR_Coverage, 21008,
     /*  405301 */     GIR_EraseRootFromParent_Done,
     /*  405302 */   // Label 7190: @405302
     /*  405302 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(405379), // Rule ID 21009 //
     /*  405307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  405310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  405318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  405321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  405324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405339 */     // MIs[0] Operand 4
     /*  405339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405357 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  405357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  405374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405377 */     GIR_RootConstrainSelectedInstOperands,
     /*  405378 */     // GIR_Coverage, 21009,
     /*  405378 */     GIR_EraseRootFromParent_Done,
     /*  405379 */   // Label 7191: @405379
     /*  405379 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(405456), // Rule ID 21012 //
     /*  405384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405416 */     // MIs[0] Operand 4
     /*  405416 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405454 */     GIR_RootConstrainSelectedInstOperands,
     /*  405455 */     // GIR_Coverage, 21012,
     /*  405455 */     GIR_EraseRootFromParent_Done,
     /*  405456 */   // Label 7192: @405456
     /*  405456 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(405533), // Rule ID 21013 //
     /*  405461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  405472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  405475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  405478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405493 */     // MIs[0] Operand 4
     /*  405493 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405511 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /*  405514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405531 */     GIR_RootConstrainSelectedInstOperands,
     /*  405532 */     // GIR_Coverage, 21013,
     /*  405532 */     GIR_EraseRootFromParent_Done,
     /*  405533 */   // Label 7193: @405533
     /*  405533 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(405610), // Rule ID 21016 //
     /*  405538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405570 */     // MIs[0] Operand 4
     /*  405570 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405588 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405608 */     GIR_RootConstrainSelectedInstOperands,
     /*  405609 */     // GIR_Coverage, 21016,
     /*  405609 */     GIR_EraseRootFromParent_Done,
     /*  405610 */   // Label 7194: @405610
     /*  405610 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(405687), // Rule ID 21017 //
     /*  405615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  405626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  405629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  405632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  405647 */     // MIs[0] Operand 4
     /*  405647 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /*  405668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405685 */     GIR_RootConstrainSelectedInstOperands,
     /*  405686 */     // GIR_Coverage, 21017,
     /*  405686 */     GIR_EraseRootFromParent_Done,
     /*  405687 */   // Label 7195: @405687
     /*  405687 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(405764), // Rule ID 21020 //
     /*  405692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405724 */     // MIs[0] Operand 4
     /*  405724 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405742 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405762 */     GIR_RootConstrainSelectedInstOperands,
     /*  405763 */     // GIR_Coverage, 21020,
     /*  405763 */     GIR_EraseRootFromParent_Done,
     /*  405764 */   // Label 7196: @405764
     /*  405764 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(405841), // Rule ID 21021 //
     /*  405769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  405780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  405783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  405786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  405801 */     // MIs[0] Operand 4
     /*  405801 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405819 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /*  405822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405839 */     GIR_RootConstrainSelectedInstOperands,
     /*  405840 */     // GIR_Coverage, 21021,
     /*  405840 */     GIR_EraseRootFromParent_Done,
     /*  405841 */   // Label 7197: @405841
     /*  405841 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(405918), // Rule ID 21024 //
     /*  405846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  405849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  405866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405878 */     // MIs[0] Operand 4
     /*  405878 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405896 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  405896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405916 */     GIR_RootConstrainSelectedInstOperands,
     /*  405917 */     // GIR_Coverage, 21024,
     /*  405917 */     GIR_EraseRootFromParent_Done,
     /*  405918 */   // Label 7198: @405918
     /*  405918 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(405995), // Rule ID 21025 //
     /*  405923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  405926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  405931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  405934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  405937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  405940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  405943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  405951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  405955 */     // MIs[0] Operand 4
     /*  405955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  405966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  405973 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  405973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /*  405976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  405978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  405980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  405982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  405987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  405990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  405993 */     GIR_RootConstrainSelectedInstOperands,
     /*  405994 */     // GIR_Coverage, 21025,
     /*  405994 */     GIR_EraseRootFromParent_Done,
     /*  405995 */   // Label 7199: @405995
     /*  405995 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(406072), // Rule ID 21028 //
     /*  406000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406032 */     // MIs[0] Operand 4
     /*  406032 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406070 */     GIR_RootConstrainSelectedInstOperands,
     /*  406071 */     // GIR_Coverage, 21028,
     /*  406071 */     GIR_EraseRootFromParent_Done,
     /*  406072 */   // Label 7200: @406072
     /*  406072 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(406149), // Rule ID 21029 //
     /*  406077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  406088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  406091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  406094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406109 */     // MIs[0] Operand 4
     /*  406109 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406127 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /*  406130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406147 */     GIR_RootConstrainSelectedInstOperands,
     /*  406148 */     // GIR_Coverage, 21029,
     /*  406148 */     GIR_EraseRootFromParent_Done,
     /*  406149 */   // Label 7201: @406149
     /*  406149 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(406226), // Rule ID 21032 //
     /*  406154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406186 */     // MIs[0] Operand 4
     /*  406186 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406204 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406224 */     GIR_RootConstrainSelectedInstOperands,
     /*  406225 */     // GIR_Coverage, 21032,
     /*  406225 */     GIR_EraseRootFromParent_Done,
     /*  406226 */   // Label 7202: @406226
     /*  406226 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(406303), // Rule ID 21033 //
     /*  406231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  406242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  406245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  406248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406263 */     // MIs[0] Operand 4
     /*  406263 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406281 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406301 */     GIR_RootConstrainSelectedInstOperands,
     /*  406302 */     // GIR_Coverage, 21033,
     /*  406302 */     GIR_EraseRootFromParent_Done,
     /*  406303 */   // Label 7203: @406303
     /*  406303 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(406380), // Rule ID 21036 //
     /*  406308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406340 */     // MIs[0] Operand 4
     /*  406340 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406378 */     GIR_RootConstrainSelectedInstOperands,
     /*  406379 */     // GIR_Coverage, 21036,
     /*  406379 */     GIR_EraseRootFromParent_Done,
     /*  406380 */   // Label 7204: @406380
     /*  406380 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(406457), // Rule ID 21037 //
     /*  406385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  406396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  406399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  406402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406417 */     // MIs[0] Operand 4
     /*  406417 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406455 */     GIR_RootConstrainSelectedInstOperands,
     /*  406456 */     // GIR_Coverage, 21037,
     /*  406456 */     GIR_EraseRootFromParent_Done,
     /*  406457 */   // Label 7205: @406457
     /*  406457 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(406534), // Rule ID 21040 //
     /*  406462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406494 */     // MIs[0] Operand 4
     /*  406494 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406512 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  406515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406532 */     GIR_RootConstrainSelectedInstOperands,
     /*  406533 */     // GIR_Coverage, 21040,
     /*  406533 */     GIR_EraseRootFromParent_Done,
     /*  406534 */   // Label 7206: @406534
     /*  406534 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(406611), // Rule ID 21041 //
     /*  406539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  406550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  406553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  406556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406571 */     // MIs[0] Operand 4
     /*  406571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406589 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  406592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406609 */     GIR_RootConstrainSelectedInstOperands,
     /*  406610 */     // GIR_Coverage, 21041,
     /*  406610 */     GIR_EraseRootFromParent_Done,
     /*  406611 */   // Label 7207: @406611
     /*  406611 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(406688), // Rule ID 21044 //
     /*  406616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  406619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406648 */     // MIs[0] Operand 4
     /*  406648 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  406666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  406669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406686 */     GIR_RootConstrainSelectedInstOperands,
     /*  406687 */     // GIR_Coverage, 21044,
     /*  406687 */     GIR_EraseRootFromParent_Done,
     /*  406688 */   // Label 7208: @406688
     /*  406688 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(406765), // Rule ID 21045 //
     /*  406693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  406696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  406704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  406707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  406710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  406721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  406725 */     // MIs[0] Operand 4
     /*  406725 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406743 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  406743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  406746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  406760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406763 */     GIR_RootConstrainSelectedInstOperands,
     /*  406764 */     // GIR_Coverage, 21045,
     /*  406764 */     GIR_EraseRootFromParent_Done,
     /*  406765 */   // Label 7209: @406765
     /*  406765 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(406842), // Rule ID 21048 //
     /*  406770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406802 */     // MIs[0] Operand 4
     /*  406802 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406820 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406840 */     GIR_RootConstrainSelectedInstOperands,
     /*  406841 */     // GIR_Coverage, 21048,
     /*  406841 */     GIR_EraseRootFromParent_Done,
     /*  406842 */   // Label 7210: @406842
     /*  406842 */   GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(406919), // Rule ID 21049 //
     /*  406847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  406850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  406858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  406861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  406864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  406867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406879 */     // MIs[0] Operand 4
     /*  406879 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406897 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  406897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /*  406900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406917 */     GIR_RootConstrainSelectedInstOperands,
     /*  406918 */     // GIR_Coverage, 21049,
     /*  406918 */     GIR_EraseRootFromParent_Done,
     /*  406919 */   // Label 7211: @406919
     /*  406919 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(406996), // Rule ID 21052 //
     /*  406924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  406927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  406932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  406935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  406938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  406941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  406944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  406952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  406956 */     // MIs[0] Operand 4
     /*  406956 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  406967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  406974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  406974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  406977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  406979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  406981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  406983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  406988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  406991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  406994 */     GIR_RootConstrainSelectedInstOperands,
     /*  406995 */     // GIR_Coverage, 21052,
     /*  406995 */     GIR_EraseRootFromParent_Done,
     /*  406996 */   // Label 7212: @406996
     /*  406996 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(407073), // Rule ID 21053 //
     /*  407001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  407012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  407015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  407018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407033 */     // MIs[0] Operand 4
     /*  407033 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407051 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /*  407054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407071 */     GIR_RootConstrainSelectedInstOperands,
     /*  407072 */     // GIR_Coverage, 21053,
     /*  407072 */     GIR_EraseRootFromParent_Done,
     /*  407073 */   // Label 7213: @407073
     /*  407073 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(407150), // Rule ID 21056 //
     /*  407078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407110 */     // MIs[0] Operand 4
     /*  407110 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407128 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407148 */     GIR_RootConstrainSelectedInstOperands,
     /*  407149 */     // GIR_Coverage, 21056,
     /*  407149 */     GIR_EraseRootFromParent_Done,
     /*  407150 */   // Label 7214: @407150
     /*  407150 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(407227), // Rule ID 21057 //
     /*  407155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  407166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  407169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  407172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407187 */     // MIs[0] Operand 4
     /*  407187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407205 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /*  407208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407225 */     GIR_RootConstrainSelectedInstOperands,
     /*  407226 */     // GIR_Coverage, 21057,
     /*  407226 */     GIR_EraseRootFromParent_Done,
     /*  407227 */   // Label 7215: @407227
     /*  407227 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(407304), // Rule ID 21060 //
     /*  407232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  407235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407264 */     // MIs[0] Operand 4
     /*  407264 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407282 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  407282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407302 */     GIR_RootConstrainSelectedInstOperands,
     /*  407303 */     // GIR_Coverage, 21060,
     /*  407303 */     GIR_EraseRootFromParent_Done,
     /*  407304 */   // Label 7216: @407304
     /*  407304 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(407381), // Rule ID 21061 //
     /*  407309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  407312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  407317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  407320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  407323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  407326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  407337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  407341 */     // MIs[0] Operand 4
     /*  407341 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407359 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  407359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /*  407362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  407376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407379 */     GIR_RootConstrainSelectedInstOperands,
     /*  407380 */     // GIR_Coverage, 21061,
     /*  407380 */     GIR_EraseRootFromParent_Done,
     /*  407381 */   // Label 7217: @407381
     /*  407381 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(407458), // Rule ID 21364 //
     /*  407386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407418 */     // MIs[0] Operand 4
     /*  407418 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  407439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407456 */     GIR_RootConstrainSelectedInstOperands,
     /*  407457 */     // GIR_Coverage, 21364,
     /*  407457 */     GIR_EraseRootFromParent_Done,
     /*  407458 */   // Label 7218: @407458
     /*  407458 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(407535), // Rule ID 21365 //
     /*  407463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  407474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  407477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  407480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407495 */     // MIs[0] Operand 4
     /*  407495 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407513 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  407513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /*  407516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407533 */     GIR_RootConstrainSelectedInstOperands,
     /*  407534 */     // GIR_Coverage, 21365,
     /*  407534 */     GIR_EraseRootFromParent_Done,
     /*  407535 */   // Label 7219: @407535
     /*  407535 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(407612), // Rule ID 21368 //
     /*  407540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  407551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  407554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407572 */     // MIs[0] Operand 4
     /*  407572 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407590 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  407593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407610 */     GIR_RootConstrainSelectedInstOperands,
     /*  407611 */     // GIR_Coverage, 21368,
     /*  407611 */     GIR_EraseRootFromParent_Done,
     /*  407612 */   // Label 7220: @407612
     /*  407612 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(407689), // Rule ID 21369 //
     /*  407617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  407628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  407631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  407634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407649 */     // MIs[0] Operand 4
     /*  407649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407667 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  407667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  407670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407687 */     GIR_RootConstrainSelectedInstOperands,
     /*  407688 */     // GIR_Coverage, 21369,
     /*  407688 */     GIR_EraseRootFromParent_Done,
     /*  407689 */   // Label 7221: @407689
     /*  407689 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(407766), // Rule ID 21372 //
     /*  407694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  407705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  407708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407726 */     // MIs[0] Operand 4
     /*  407726 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407744 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  407747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407764 */     GIR_RootConstrainSelectedInstOperands,
     /*  407765 */     // GIR_Coverage, 21372,
     /*  407765 */     GIR_EraseRootFromParent_Done,
     /*  407766 */   // Label 7222: @407766
     /*  407766 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(407843), // Rule ID 21373 //
     /*  407771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  407782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  407785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  407788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407803 */     // MIs[0] Operand 4
     /*  407803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407821 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  407821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  407824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407841 */     GIR_RootConstrainSelectedInstOperands,
     /*  407842 */     // GIR_Coverage, 21373,
     /*  407842 */     GIR_EraseRootFromParent_Done,
     /*  407843 */   // Label 7223: @407843
     /*  407843 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(407920), // Rule ID 21376 //
     /*  407848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  407851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  407859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  407862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  407868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407880 */     // MIs[0] Operand 4
     /*  407880 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  407898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  407901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407918 */     GIR_RootConstrainSelectedInstOperands,
     /*  407919 */     // GIR_Coverage, 21376,
     /*  407919 */     GIR_EraseRootFromParent_Done,
     /*  407920 */   // Label 7224: @407920
     /*  407920 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(407997), // Rule ID 21377 //
     /*  407925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  407928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  407933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  407936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  407939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  407942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  407945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  407953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  407957 */     // MIs[0] Operand 4
     /*  407957 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  407968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  407975 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  407975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  407978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  407980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  407982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  407984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  407989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  407992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  407995 */     GIR_RootConstrainSelectedInstOperands,
     /*  407996 */     // GIR_Coverage, 21377,
     /*  407996 */     GIR_EraseRootFromParent_Done,
     /*  407997 */   // Label 7225: @407997
     /*  407997 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(408074), // Rule ID 21380 //
     /*  408002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408034 */     // MIs[0] Operand 4
     /*  408034 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408072 */     GIR_RootConstrainSelectedInstOperands,
     /*  408073 */     // GIR_Coverage, 21380,
     /*  408073 */     GIR_EraseRootFromParent_Done,
     /*  408074 */   // Label 7226: @408074
     /*  408074 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(408151), // Rule ID 21381 //
     /*  408079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  408090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  408093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  408096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408111 */     // MIs[0] Operand 4
     /*  408111 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408149 */     GIR_RootConstrainSelectedInstOperands,
     /*  408150 */     // GIR_Coverage, 21381,
     /*  408150 */     GIR_EraseRootFromParent_Done,
     /*  408151 */   // Label 7227: @408151
     /*  408151 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(408228), // Rule ID 21384 //
     /*  408156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  408159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408188 */     // MIs[0] Operand 4
     /*  408188 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408206 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  408206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408226 */     GIR_RootConstrainSelectedInstOperands,
     /*  408227 */     // GIR_Coverage, 21384,
     /*  408227 */     GIR_EraseRootFromParent_Done,
     /*  408228 */   // Label 7228: @408228
     /*  408228 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(408305), // Rule ID 21385 //
     /*  408233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  408236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  408244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  408247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  408250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408265 */     // MIs[0] Operand 4
     /*  408265 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408283 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  408283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  408300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408303 */     GIR_RootConstrainSelectedInstOperands,
     /*  408304 */     // GIR_Coverage, 21385,
     /*  408304 */     GIR_EraseRootFromParent_Done,
     /*  408305 */   // Label 7229: @408305
     /*  408305 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(408382), // Rule ID 21388 //
     /*  408310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408342 */     // MIs[0] Operand 4
     /*  408342 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408380 */     GIR_RootConstrainSelectedInstOperands,
     /*  408381 */     // GIR_Coverage, 21388,
     /*  408381 */     GIR_EraseRootFromParent_Done,
     /*  408382 */   // Label 7230: @408382
     /*  408382 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(408459), // Rule ID 21389 //
     /*  408387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  408398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  408401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  408404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408419 */     // MIs[0] Operand 4
     /*  408419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /*  408440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408457 */     GIR_RootConstrainSelectedInstOperands,
     /*  408458 */     // GIR_Coverage, 21389,
     /*  408458 */     GIR_EraseRootFromParent_Done,
     /*  408459 */   // Label 7231: @408459
     /*  408459 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(408536), // Rule ID 21392 //
     /*  408464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  408475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  408478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408496 */     // MIs[0] Operand 4
     /*  408496 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408514 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408534 */     GIR_RootConstrainSelectedInstOperands,
     /*  408535 */     // GIR_Coverage, 21392,
     /*  408535 */     GIR_EraseRootFromParent_Done,
     /*  408536 */   // Label 7232: @408536
     /*  408536 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(408613), // Rule ID 21393 //
     /*  408541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  408552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  408555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  408558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408573 */     // MIs[0] Operand 4
     /*  408573 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408591 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  408594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408611 */     GIR_RootConstrainSelectedInstOperands,
     /*  408612 */     // GIR_Coverage, 21393,
     /*  408612 */     GIR_EraseRootFromParent_Done,
     /*  408613 */   // Label 7233: @408613
     /*  408613 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(408690), // Rule ID 21396 //
     /*  408618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  408629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  408632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408650 */     // MIs[0] Operand 4
     /*  408650 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408688 */     GIR_RootConstrainSelectedInstOperands,
     /*  408689 */     // GIR_Coverage, 21396,
     /*  408689 */     GIR_EraseRootFromParent_Done,
     /*  408690 */   // Label 7234: @408690
     /*  408690 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(408767), // Rule ID 21397 //
     /*  408695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  408706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  408709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  408712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  408723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408727 */     // MIs[0] Operand 4
     /*  408727 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408745 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  408748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408765 */     GIR_RootConstrainSelectedInstOperands,
     /*  408766 */     // GIR_Coverage, 21397,
     /*  408766 */     GIR_EraseRootFromParent_Done,
     /*  408767 */   // Label 7235: @408767
     /*  408767 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(408844), // Rule ID 21400 //
     /*  408772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  408783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  408786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408804 */     // MIs[0] Operand 4
     /*  408804 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408822 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408842 */     GIR_RootConstrainSelectedInstOperands,
     /*  408843 */     // GIR_Coverage, 21400,
     /*  408843 */     GIR_EraseRootFromParent_Done,
     /*  408844 */   // Label 7236: @408844
     /*  408844 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(408921), // Rule ID 21401 //
     /*  408849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  408852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  408860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  408863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  408866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  408869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  408877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408881 */     // MIs[0] Operand 4
     /*  408881 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  408899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  408902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408919 */     GIR_RootConstrainSelectedInstOperands,
     /*  408920 */     // GIR_Coverage, 21401,
     /*  408920 */     GIR_EraseRootFromParent_Done,
     /*  408921 */   // Label 7237: @408921
     /*  408921 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(408998), // Rule ID 21404 //
     /*  408926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  408929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  408934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  408937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  408940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  408943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  408946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  408954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  408958 */     // MIs[0] Operand 4
     /*  408958 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  408969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  408976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  408976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  408979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  408981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  408983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  408985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  408990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  408993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  408996 */     GIR_RootConstrainSelectedInstOperands,
     /*  408997 */     // GIR_Coverage, 21404,
     /*  408997 */     GIR_EraseRootFromParent_Done,
     /*  408998 */   // Label 7238: @408998
     /*  408998 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(409075), // Rule ID 21405 //
     /*  409003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  409006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  409014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  409017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  409020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409035 */     // MIs[0] Operand 4
     /*  409035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409053 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  409053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  409070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409073 */     GIR_RootConstrainSelectedInstOperands,
     /*  409074 */     // GIR_Coverage, 21405,
     /*  409074 */     GIR_EraseRootFromParent_Done,
     /*  409075 */   // Label 7239: @409075
     /*  409075 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(409152), // Rule ID 21408 //
     /*  409080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409112 */     // MIs[0] Operand 4
     /*  409112 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409150 */     GIR_RootConstrainSelectedInstOperands,
     /*  409151 */     // GIR_Coverage, 21408,
     /*  409151 */     GIR_EraseRootFromParent_Done,
     /*  409152 */   // Label 7240: @409152
     /*  409152 */   GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(409229), // Rule ID 21409 //
     /*  409157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  409168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  409171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  409174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409189 */     // MIs[0] Operand 4
     /*  409189 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409207 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /*  409210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409227 */     GIR_RootConstrainSelectedInstOperands,
     /*  409228 */     // GIR_Coverage, 21409,
     /*  409228 */     GIR_EraseRootFromParent_Done,
     /*  409229 */   // Label 7241: @409229
     /*  409229 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(409306), // Rule ID 21412 //
     /*  409234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409266 */     // MIs[0] Operand 4
     /*  409266 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409304 */     GIR_RootConstrainSelectedInstOperands,
     /*  409305 */     // GIR_Coverage, 21412,
     /*  409305 */     GIR_EraseRootFromParent_Done,
     /*  409306 */   // Label 7242: @409306
     /*  409306 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(409383), // Rule ID 21413 //
     /*  409311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  409322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  409325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  409328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409343 */     // MIs[0] Operand 4
     /*  409343 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409361 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /*  409364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409381 */     GIR_RootConstrainSelectedInstOperands,
     /*  409382 */     // GIR_Coverage, 21413,
     /*  409382 */     GIR_EraseRootFromParent_Done,
     /*  409383 */   // Label 7243: @409383
     /*  409383 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(409460), // Rule ID 21416 //
     /*  409388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  409405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409420 */     // MIs[0] Operand 4
     /*  409420 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409458 */     GIR_RootConstrainSelectedInstOperands,
     /*  409459 */     // GIR_Coverage, 21416,
     /*  409459 */     GIR_EraseRootFromParent_Done,
     /*  409460 */   // Label 7244: @409460
     /*  409460 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(409537), // Rule ID 21417 //
     /*  409465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  409476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  409479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  409482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  409493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409497 */     // MIs[0] Operand 4
     /*  409497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /*  409518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409535 */     GIR_RootConstrainSelectedInstOperands,
     /*  409536 */     // GIR_Coverage, 21417,
     /*  409536 */     GIR_EraseRootFromParent_Done,
     /*  409537 */   // Label 7245: @409537
     /*  409537 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(409614), // Rule ID 21420 //
     /*  409542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  409545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  409559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409574 */     // MIs[0] Operand 4
     /*  409574 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  409592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409612 */     GIR_RootConstrainSelectedInstOperands,
     /*  409613 */     // GIR_Coverage, 21420,
     /*  409613 */     GIR_EraseRootFromParent_Done,
     /*  409614 */   // Label 7246: @409614
     /*  409614 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(409691), // Rule ID 21421 //
     /*  409619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  409622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  409627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  409630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  409633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  409636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  409647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  409651 */     // MIs[0] Operand 4
     /*  409651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  409669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /*  409672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  409686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409689 */     GIR_RootConstrainSelectedInstOperands,
     /*  409690 */     // GIR_Coverage, 21421,
     /*  409690 */     GIR_EraseRootFromParent_Done,
     /*  409691 */   // Label 7247: @409691
     /*  409691 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(409768), // Rule ID 21424 //
     /*  409696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  409704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  409707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  409710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  409713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409728 */     // MIs[0] Operand 4
     /*  409728 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409746 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  409749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409766 */     GIR_RootConstrainSelectedInstOperands,
     /*  409767 */     // GIR_Coverage, 21424,
     /*  409767 */     GIR_EraseRootFromParent_Done,
     /*  409768 */   // Label 7248: @409768
     /*  409768 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(409845), // Rule ID 21425 //
     /*  409773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  409781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  409784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  409787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  409790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409805 */     // MIs[0] Operand 4
     /*  409805 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409823 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /*  409826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409843 */     GIR_RootConstrainSelectedInstOperands,
     /*  409844 */     // GIR_Coverage, 21425,
     /*  409844 */     GIR_EraseRootFromParent_Done,
     /*  409845 */   // Label 7249: @409845
     /*  409845 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(409922), // Rule ID 21428 //
     /*  409850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  409853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  409858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  409861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  409864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  409870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409882 */     // MIs[0] Operand 4
     /*  409882 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  409900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  409903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409920 */     GIR_RootConstrainSelectedInstOperands,
     /*  409921 */     // GIR_Coverage, 21428,
     /*  409921 */     GIR_EraseRootFromParent_Done,
     /*  409922 */   // Label 7250: @409922
     /*  409922 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(409999), // Rule ID 21429 //
     /*  409927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  409930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  409935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  409938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  409941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  409944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  409947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  409959 */     // MIs[0] Operand 4
     /*  409959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  409970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  409977 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  409977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  409980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  409982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  409984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  409986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  409991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  409994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  409997 */     GIR_RootConstrainSelectedInstOperands,
     /*  409998 */     // GIR_Coverage, 21429,
     /*  409998 */     GIR_EraseRootFromParent_Done,
     /*  409999 */   // Label 7251: @409999
     /*  409999 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(410076), // Rule ID 21432 //
     /*  410004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410036 */     // MIs[0] Operand 4
     /*  410036 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410054 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410074 */     GIR_RootConstrainSelectedInstOperands,
     /*  410075 */     // GIR_Coverage, 21432,
     /*  410075 */     GIR_EraseRootFromParent_Done,
     /*  410076 */   // Label 7252: @410076
     /*  410076 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(410153), // Rule ID 21433 //
     /*  410081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  410092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  410095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  410098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410113 */     // MIs[0] Operand 4
     /*  410113 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410131 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410151 */     GIR_RootConstrainSelectedInstOperands,
     /*  410152 */     // GIR_Coverage, 21433,
     /*  410152 */     GIR_EraseRootFromParent_Done,
     /*  410153 */   // Label 7253: @410153
     /*  410153 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(410230), // Rule ID 21436 //
     /*  410158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410190 */     // MIs[0] Operand 4
     /*  410190 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410228 */     GIR_RootConstrainSelectedInstOperands,
     /*  410229 */     // GIR_Coverage, 21436,
     /*  410229 */     GIR_EraseRootFromParent_Done,
     /*  410230 */   // Label 7254: @410230
     /*  410230 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(410307), // Rule ID 21437 //
     /*  410235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  410246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  410249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  410252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410267 */     // MIs[0] Operand 4
     /*  410267 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410285 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410305 */     GIR_RootConstrainSelectedInstOperands,
     /*  410306 */     // GIR_Coverage, 21437,
     /*  410306 */     GIR_EraseRootFromParent_Done,
     /*  410307 */   // Label 7255: @410307
     /*  410307 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(410384), // Rule ID 21440 //
     /*  410312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410344 */     // MIs[0] Operand 4
     /*  410344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410362 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410382 */     GIR_RootConstrainSelectedInstOperands,
     /*  410383 */     // GIR_Coverage, 21440,
     /*  410383 */     GIR_EraseRootFromParent_Done,
     /*  410384 */   // Label 7256: @410384
     /*  410384 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(410461), // Rule ID 21441 //
     /*  410389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  410400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  410403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  410406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410421 */     // MIs[0] Operand 4
     /*  410421 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410439 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  410442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410459 */     GIR_RootConstrainSelectedInstOperands,
     /*  410460 */     // GIR_Coverage, 21441,
     /*  410460 */     GIR_EraseRootFromParent_Done,
     /*  410461 */   // Label 7257: @410461
     /*  410461 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(410538), // Rule ID 21444 //
     /*  410466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  410469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  410477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  410480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  410483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410498 */     // MIs[0] Operand 4
     /*  410498 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410516 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  410516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  410519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410536 */     GIR_RootConstrainSelectedInstOperands,
     /*  410537 */     // GIR_Coverage, 21444,
     /*  410537 */     GIR_EraseRootFromParent_Done,
     /*  410538 */   // Label 7258: @410538
     /*  410538 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(410615), // Rule ID 21445 //
     /*  410543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  410546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  410554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  410557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  410560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  410571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  410575 */     // MIs[0] Operand 4
     /*  410575 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410593 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  410593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  410596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  410610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410613 */     GIR_RootConstrainSelectedInstOperands,
     /*  410614 */     // GIR_Coverage, 21445,
     /*  410614 */     GIR_EraseRootFromParent_Done,
     /*  410615 */   // Label 7259: @410615
     /*  410615 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(410692), // Rule ID 21448 //
     /*  410620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  410623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  410631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  410634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410652 */     // MIs[0] Operand 4
     /*  410652 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410670 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410690 */     GIR_RootConstrainSelectedInstOperands,
     /*  410691 */     // GIR_Coverage, 21448,
     /*  410691 */     GIR_EraseRootFromParent_Done,
     /*  410692 */   // Label 7260: @410692
     /*  410692 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(410769), // Rule ID 21449 //
     /*  410697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  410700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  410708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  410711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  410714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410729 */     // MIs[0] Operand 4
     /*  410729 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410747 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /*  410750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410767 */     GIR_RootConstrainSelectedInstOperands,
     /*  410768 */     // GIR_Coverage, 21449,
     /*  410768 */     GIR_EraseRootFromParent_Done,
     /*  410769 */   // Label 7261: @410769
     /*  410769 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(410846), // Rule ID 21452 //
     /*  410774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  410777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  410785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  410788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  410791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410806 */     // MIs[0] Operand 4
     /*  410806 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410844 */     GIR_RootConstrainSelectedInstOperands,
     /*  410845 */     // GIR_Coverage, 21452,
     /*  410845 */     GIR_EraseRootFromParent_Done,
     /*  410846 */   // Label 7262: @410846
     /*  410846 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(410923), // Rule ID 21453 //
     /*  410851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  410854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  410862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  410865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  410868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  410871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410883 */     // MIs[0] Operand 4
     /*  410883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410901 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  410901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  410904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410921 */     GIR_RootConstrainSelectedInstOperands,
     /*  410922 */     // GIR_Coverage, 21453,
     /*  410922 */     GIR_EraseRootFromParent_Done,
     /*  410923 */   // Label 7263: @410923
     /*  410923 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(411000), // Rule ID 21456 //
     /*  410928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  410931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  410936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  410939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  410942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  410945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  410948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  410956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  410960 */     // MIs[0] Operand 4
     /*  410960 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  410971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  410978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  410978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  410981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  410983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  410985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  410987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  410992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  410995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  410998 */     GIR_RootConstrainSelectedInstOperands,
     /*  410999 */     // GIR_Coverage, 21456,
     /*  410999 */     GIR_EraseRootFromParent_Done,
     /*  411000 */   // Label 7264: @411000
     /*  411000 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(411077), // Rule ID 21457 //
     /*  411005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  411016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  411019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  411022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411037 */     // MIs[0] Operand 4
     /*  411037 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411055 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411075 */     GIR_RootConstrainSelectedInstOperands,
     /*  411076 */     // GIR_Coverage, 21457,
     /*  411076 */     GIR_EraseRootFromParent_Done,
     /*  411077 */   // Label 7265: @411077
     /*  411077 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(411154), // Rule ID 21460 //
     /*  411082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411114 */     // MIs[0] Operand 4
     /*  411114 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411152 */     GIR_RootConstrainSelectedInstOperands,
     /*  411153 */     // GIR_Coverage, 21460,
     /*  411153 */     GIR_EraseRootFromParent_Done,
     /*  411154 */   // Label 7266: @411154
     /*  411154 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(411231), // Rule ID 21461 //
     /*  411159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  411170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  411173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  411176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411191 */     // MIs[0] Operand 4
     /*  411191 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411209 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411229 */     GIR_RootConstrainSelectedInstOperands,
     /*  411230 */     // GIR_Coverage, 21461,
     /*  411230 */     GIR_EraseRootFromParent_Done,
     /*  411231 */   // Label 7267: @411231
     /*  411231 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(411308), // Rule ID 21464 //
     /*  411236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  411239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411268 */     // MIs[0] Operand 4
     /*  411268 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411286 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  411286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411306 */     GIR_RootConstrainSelectedInstOperands,
     /*  411307 */     // GIR_Coverage, 21464,
     /*  411307 */     GIR_EraseRootFromParent_Done,
     /*  411308 */   // Label 7268: @411308
     /*  411308 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(411385), // Rule ID 21465 //
     /*  411313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  411316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  411324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  411327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  411330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411345 */     // MIs[0] Operand 4
     /*  411345 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411363 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  411363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  411380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411383 */     GIR_RootConstrainSelectedInstOperands,
     /*  411384 */     // GIR_Coverage, 21465,
     /*  411384 */     GIR_EraseRootFromParent_Done,
     /*  411385 */   // Label 7269: @411385
     /*  411385 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(411462), // Rule ID 21468 //
     /*  411390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  411404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  411407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411422 */     // MIs[0] Operand 4
     /*  411422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411460 */     GIR_RootConstrainSelectedInstOperands,
     /*  411461 */     // GIR_Coverage, 21468,
     /*  411461 */     GIR_EraseRootFromParent_Done,
     /*  411462 */   // Label 7270: @411462
     /*  411462 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(411539), // Rule ID 21469 //
     /*  411467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  411478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  411481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  411484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411499 */     // MIs[0] Operand 4
     /*  411499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411517 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /*  411520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411537 */     GIR_RootConstrainSelectedInstOperands,
     /*  411538 */     // GIR_Coverage, 21469,
     /*  411538 */     GIR_EraseRootFromParent_Done,
     /*  411539 */   // Label 7271: @411539
     /*  411539 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(411616), // Rule ID 21472 //
     /*  411544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  411555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  411558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  411561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411576 */     // MIs[0] Operand 4
     /*  411576 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411594 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411614 */     GIR_RootConstrainSelectedInstOperands,
     /*  411615 */     // GIR_Coverage, 21472,
     /*  411615 */     GIR_EraseRootFromParent_Done,
     /*  411616 */   // Label 7272: @411616
     /*  411616 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(411693), // Rule ID 21473 //
     /*  411621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  411632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  411635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  411638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  411649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411653 */     // MIs[0] Operand 4
     /*  411653 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /*  411674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411691 */     GIR_RootConstrainSelectedInstOperands,
     /*  411692 */     // GIR_Coverage, 21473,
     /*  411692 */     GIR_EraseRootFromParent_Done,
     /*  411693 */   // Label 7273: @411693
     /*  411693 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(411770), // Rule ID 21476 //
     /*  411698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  411715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411730 */     // MIs[0] Operand 4
     /*  411730 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411748 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411768 */     GIR_RootConstrainSelectedInstOperands,
     /*  411769 */     // GIR_Coverage, 21476,
     /*  411769 */     GIR_EraseRootFromParent_Done,
     /*  411770 */   // Label 7274: @411770
     /*  411770 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(411847), // Rule ID 21477 //
     /*  411775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  411786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  411789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  411792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  411803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411807 */     // MIs[0] Operand 4
     /*  411807 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /*  411828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411845 */     GIR_RootConstrainSelectedInstOperands,
     /*  411846 */     // GIR_Coverage, 21477,
     /*  411846 */     GIR_EraseRootFromParent_Done,
     /*  411847 */   // Label 7275: @411847
     /*  411847 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(411924), // Rule ID 21480 //
     /*  411852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  411855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  411869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  411872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411884 */     // MIs[0] Operand 4
     /*  411884 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  411902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411922 */     GIR_RootConstrainSelectedInstOperands,
     /*  411923 */     // GIR_Coverage, 21480,
     /*  411923 */     GIR_EraseRootFromParent_Done,
     /*  411924 */   // Label 7276: @411924
     /*  411924 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(412001), // Rule ID 21481 //
     /*  411929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  411932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  411937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  411940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  411943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  411946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  411949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  411957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  411961 */     // MIs[0] Operand 4
     /*  411961 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/4, GIMT_Encode8(1),
     /*  411972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  411979 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  411979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /*  411982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  411984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  411986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  411988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  411993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  411996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  411999 */     GIR_RootConstrainSelectedInstOperands,
     /*  412000 */     // GIR_Coverage, 21481,
     /*  412000 */     GIR_EraseRootFromParent_Done,
     /*  412001 */   // Label 7277: @412001
     /*  412001 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(412074), // Rule ID 62800 //
     /*  412006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412030 */     // MIs[0] op1
     /*  412030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412053 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  412056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412058 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412060 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412062 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412072 */     GIR_RootConstrainSelectedInstOperands,
     /*  412073 */     // GIR_Coverage, 62800,
     /*  412073 */     GIR_EraseRootFromParent_Done,
     /*  412074 */   // Label 7278: @412074
     /*  412074 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(412147), // Rule ID 62801 //
     /*  412079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412103 */     // MIs[0] op1
     /*  412103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412106 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412126 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF8),
     /*  412129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412131 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412133 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412135 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412145 */     GIR_RootConstrainSelectedInstOperands,
     /*  412146 */     // GIR_Coverage, 62801,
     /*  412146 */     GIR_EraseRootFromParent_Done,
     /*  412147 */   // Label 7279: @412147
     /*  412147 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(412220), // Rule ID 62824 //
     /*  412152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412176 */     // MIs[0] op1
     /*  412176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412179 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412199 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  412202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412204 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412206 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412208 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412218 */     GIR_RootConstrainSelectedInstOperands,
     /*  412219 */     // GIR_Coverage, 62824,
     /*  412219 */     GIR_EraseRootFromParent_Done,
     /*  412220 */   // Label 7280: @412220
     /*  412220 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(412293), // Rule ID 62825 //
     /*  412225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  412236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  412239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  412242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412249 */     // MIs[0] op1
     /*  412249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412252 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF8),
     /*  412275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412277 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412279 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412281 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412291 */     GIR_RootConstrainSelectedInstOperands,
     /*  412292 */     // GIR_Coverage, 62825,
     /*  412292 */     GIR_EraseRootFromParent_Done,
     /*  412293 */   // Label 7281: @412293
     /*  412293 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(412366), // Rule ID 62850 //
     /*  412298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412322 */     // MIs[0] op1
     /*  412322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412345 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  412348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412350 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412352 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412354 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412364 */     GIR_RootConstrainSelectedInstOperands,
     /*  412365 */     // GIR_Coverage, 62850,
     /*  412365 */     GIR_EraseRootFromParent_Done,
     /*  412366 */   // Label 7282: @412366
     /*  412366 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(412439), // Rule ID 62851 //
     /*  412371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412395 */     // MIs[0] op1
     /*  412395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412398 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412418 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  412421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412423 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412425 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412427 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412437 */     GIR_RootConstrainSelectedInstOperands,
     /*  412438 */     // GIR_Coverage, 62851,
     /*  412438 */     GIR_EraseRootFromParent_Done,
     /*  412439 */   // Label 7283: @412439
     /*  412439 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(412512), // Rule ID 62862 //
     /*  412444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  412461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412468 */     // MIs[0] op1
     /*  412468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  412494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412496 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412498 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412500 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412510 */     GIR_RootConstrainSelectedInstOperands,
     /*  412511 */     // GIR_Coverage, 62862,
     /*  412511 */     GIR_EraseRootFromParent_Done,
     /*  412512 */   // Label 7284: @412512
     /*  412512 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(412585), // Rule ID 62863 //
     /*  412517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  412528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  412531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  412534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412541 */     // MIs[0] op1
     /*  412541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  412567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412569 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412571 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412573 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412583 */     GIR_RootConstrainSelectedInstOperands,
     /*  412584 */     // GIR_Coverage, 62863,
     /*  412584 */     GIR_EraseRootFromParent_Done,
     /*  412585 */   // Label 7285: @412585
     /*  412585 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(412658), // Rule ID 62894 //
     /*  412590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  412604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412614 */     // MIs[0] op1
     /*  412614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412637 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  412640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412656 */     GIR_RootConstrainSelectedInstOperands,
     /*  412657 */     // GIR_Coverage, 62894,
     /*  412657 */     GIR_EraseRootFromParent_Done,
     /*  412658 */   // Label 7286: @412658
     /*  412658 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(412731), // Rule ID 62895 //
     /*  412663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  412677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412687 */     // MIs[0] op1
     /*  412687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412710 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  412713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412729 */     GIR_RootConstrainSelectedInstOperands,
     /*  412730 */     // GIR_Coverage, 62895,
     /*  412730 */     GIR_EraseRootFromParent_Done,
     /*  412731 */   // Label 7287: @412731
     /*  412731 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(412804), // Rule ID 62906 //
     /*  412736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  412750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  412753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412760 */     // MIs[0] op1
     /*  412760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412783 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  412783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  412786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412788 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412790 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412792 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412802 */     GIR_RootConstrainSelectedInstOperands,
     /*  412803 */     // GIR_Coverage, 62906,
     /*  412803 */     GIR_EraseRootFromParent_Done,
     /*  412804 */   // Label 7288: @412804
     /*  412804 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(412877), // Rule ID 62907 //
     /*  412809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  412817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  412820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  412823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  412826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412833 */     // MIs[0] op1
     /*  412833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  412856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  412859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412861 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412863 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412865 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  412875 */     GIR_RootConstrainSelectedInstOperands,
     /*  412876 */     // GIR_Coverage, 62907,
     /*  412876 */     GIR_EraseRootFromParent_Done,
     /*  412877 */   // Label 7289: @412877
     /*  412877 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(412950), // Rule ID 62938 //
     /*  412882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  412885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  412896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  412899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  412902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412906 */     // MIs[0] op1
     /*  412906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  412929 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  412929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  412932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  412934 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  412936 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  412938 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  412940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  412945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  412948 */     GIR_RootConstrainSelectedInstOperands,
     /*  412949 */     // GIR_Coverage, 62938,
     /*  412949 */     GIR_EraseRootFromParent_Done,
     /*  412950 */   // Label 7290: @412950
     /*  412950 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(413023), // Rule ID 62939 //
     /*  412955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  412958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  412963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  412966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  412969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  412972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  412975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412979 */     // MIs[0] op1
     /*  412979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  412982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  412987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  412991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  412995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413002 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF4),
     /*  413005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413007 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413009 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413011 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413021 */     GIR_RootConstrainSelectedInstOperands,
     /*  413022 */     // GIR_Coverage, 62939,
     /*  413022 */     GIR_EraseRootFromParent_Done,
     /*  413023 */   // Label 7291: @413023
     /*  413023 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(413096), // Rule ID 62950 //
     /*  413028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413052 */     // MIs[0] op1
     /*  413052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413075 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413080 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413082 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413084 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413094 */     GIR_RootConstrainSelectedInstOperands,
     /*  413095 */     // GIR_Coverage, 62950,
     /*  413095 */     GIR_EraseRootFromParent_Done,
     /*  413096 */   // Label 7292: @413096
     /*  413096 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(413169), // Rule ID 62951 //
     /*  413101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  413118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413125 */     // MIs[0] op1
     /*  413125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413148 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF4),
     /*  413151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413153 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413155 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413157 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413167 */     GIR_RootConstrainSelectedInstOperands,
     /*  413168 */     // GIR_Coverage, 62951,
     /*  413168 */     GIR_EraseRootFromParent_Done,
     /*  413169 */   // Label 7293: @413169
     /*  413169 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(413242), // Rule ID 62974 //
     /*  413174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413198 */     // MIs[0] op1
     /*  413198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413221 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  413224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413226 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413228 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413230 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413240 */     GIR_RootConstrainSelectedInstOperands,
     /*  413241 */     // GIR_Coverage, 62974,
     /*  413241 */     GIR_EraseRootFromParent_Done,
     /*  413242 */   // Label 7294: @413242
     /*  413242 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(413315), // Rule ID 62975 //
     /*  413247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  413258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  413261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413271 */     // MIs[0] op1
     /*  413271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF4),
     /*  413297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413299 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413301 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413303 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413313 */     GIR_RootConstrainSelectedInstOperands,
     /*  413314 */     // GIR_Coverage, 62975,
     /*  413314 */     GIR_EraseRootFromParent_Done,
     /*  413315 */   // Label 7295: @413315
     /*  413315 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(413388), // Rule ID 62994 //
     /*  413320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413344 */     // MIs[0] op1
     /*  413344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413367 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413372 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413374 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413376 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413386 */     GIR_RootConstrainSelectedInstOperands,
     /*  413387 */     // GIR_Coverage, 62994,
     /*  413387 */     GIR_EraseRootFromParent_Done,
     /*  413388 */   // Label 7296: @413388
     /*  413388 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(413461), // Rule ID 62995 //
     /*  413393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413417 */     // MIs[0] op1
     /*  413417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413440 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413445 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413447 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413449 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413459 */     GIR_RootConstrainSelectedInstOperands,
     /*  413460 */     // GIR_Coverage, 62995,
     /*  413460 */     GIR_EraseRootFromParent_Done,
     /*  413461 */   // Label 7297: @413461
     /*  413461 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(413534), // Rule ID 63006 //
     /*  413466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  413483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413490 */     // MIs[0] op1
     /*  413490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413493 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413513 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  413516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413518 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413520 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413522 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413532 */     GIR_RootConstrainSelectedInstOperands,
     /*  413533 */     // GIR_Coverage, 63006,
     /*  413533 */     GIR_EraseRootFromParent_Done,
     /*  413534 */   // Label 7298: @413534
     /*  413534 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(413607), // Rule ID 63007 //
     /*  413539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  413556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413563 */     // MIs[0] op1
     /*  413563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413566 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  413589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413591 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413593 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413595 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413605 */     GIR_RootConstrainSelectedInstOperands,
     /*  413606 */     // GIR_Coverage, 63007,
     /*  413606 */     GIR_EraseRootFromParent_Done,
     /*  413607 */   // Label 7299: @413607
     /*  413607 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(413680), // Rule ID 63030 //
     /*  413612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413636 */     // MIs[0] op1
     /*  413636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413639 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  413659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  413662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413664 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413666 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413668 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413678 */     GIR_RootConstrainSelectedInstOperands,
     /*  413679 */     // GIR_Coverage, 63030,
     /*  413679 */     GIR_EraseRootFromParent_Done,
     /*  413680 */   // Label 7300: @413680
     /*  413680 */   GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(413753), // Rule ID 63031 //
     /*  413685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  413693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  413696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  413699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  413702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413709 */     // MIs[0] op1
     /*  413709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  413717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  413725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  413732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_MF2),
     /*  413735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413737 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413739 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413741 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  413751 */     GIR_RootConstrainSelectedInstOperands,
     /*  413752 */     // GIR_Coverage, 63031,
     /*  413752 */     GIR_EraseRootFromParent_Done,
     /*  413753 */   // Label 7301: @413753
     /*  413753 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(413826), // Rule ID 63050 //
     /*  413758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  413775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413782 */     // MIs[0] op1
     /*  413782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413805 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  413805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413824 */     GIR_RootConstrainSelectedInstOperands,
     /*  413825 */     // GIR_Coverage, 63050,
     /*  413825 */     GIR_EraseRootFromParent_Done,
     /*  413826 */   // Label 7302: @413826
     /*  413826 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(413899), // Rule ID 63051 //
     /*  413831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  413839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  413848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413855 */     // MIs[0] op1
     /*  413855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  413871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413878 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  413878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_MF2),
     /*  413881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413883 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413885 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413887 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413897 */     GIR_RootConstrainSelectedInstOperands,
     /*  413898 */     // GIR_Coverage, 63051,
     /*  413898 */     GIR_EraseRootFromParent_Done,
     /*  413899 */   // Label 7303: @413899
     /*  413899 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(413972), // Rule ID 63062 //
     /*  413904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  413907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  413921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  413924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413928 */     // MIs[0] op1
     /*  413928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  413931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  413936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  413944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  413951 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  413951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  413954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  413956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  413958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  413960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  413962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  413967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  413970 */     GIR_RootConstrainSelectedInstOperands,
     /*  413971 */     // GIR_Coverage, 63062,
     /*  413971 */     GIR_EraseRootFromParent_Done,
     /*  413972 */   // Label 7304: @413972
     /*  413972 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(414045), // Rule ID 63063 //
     /*  413977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  413980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  413985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  413988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  413991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  413994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  413997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414001 */     // MIs[0] op1
     /*  414001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_MF2),
     /*  414027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414029 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414031 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414033 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414043 */     GIR_RootConstrainSelectedInstOperands,
     /*  414044 */     // GIR_Coverage, 63063,
     /*  414044 */     GIR_EraseRootFromParent_Done,
     /*  414045 */   // Label 7305: @414045
     /*  414045 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(414118), // Rule ID 63086 //
     /*  414050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414074 */     // MIs[0] op1
     /*  414074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414097 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  414100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414102 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414104 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414106 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414116 */     GIR_RootConstrainSelectedInstOperands,
     /*  414117 */     // GIR_Coverage, 63086,
     /*  414117 */     GIR_EraseRootFromParent_Done,
     /*  414118 */   // Label 7306: @414118
     /*  414118 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(414191), // Rule ID 63087 //
     /*  414123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  414134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  414137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414147 */     // MIs[0] op1
     /*  414147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414150 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  414163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  414170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_MF2),
     /*  414173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414175 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414177 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414179 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414189 */     GIR_RootConstrainSelectedInstOperands,
     /*  414190 */     // GIR_Coverage, 63087,
     /*  414190 */     GIR_EraseRootFromParent_Done,
     /*  414191 */   // Label 7307: @414191
     /*  414191 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(414264), // Rule ID 63106 //
     /*  414196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414220 */     // MIs[0] op1
     /*  414220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414243 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414248 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414250 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414252 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414262 */     GIR_RootConstrainSelectedInstOperands,
     /*  414263 */     // GIR_Coverage, 63106,
     /*  414263 */     GIR_EraseRootFromParent_Done,
     /*  414264 */   // Label 7308: @414264
     /*  414264 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(414337), // Rule ID 63107 //
     /*  414269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414293 */     // MIs[0] op1
     /*  414293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414321 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414323 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414325 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414335 */     GIR_RootConstrainSelectedInstOperands,
     /*  414336 */     // GIR_Coverage, 63107,
     /*  414336 */     GIR_EraseRootFromParent_Done,
     /*  414337 */   // Label 7309: @414337
     /*  414337 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(414410), // Rule ID 63118 //
     /*  414342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414366 */     // MIs[0] op1
     /*  414366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414389 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  414389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414394 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414396 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414398 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414408 */     GIR_RootConstrainSelectedInstOperands,
     /*  414409 */     // GIR_Coverage, 63118,
     /*  414409 */     GIR_EraseRootFromParent_Done,
     /*  414410 */   // Label 7310: @414410
     /*  414410 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(414483), // Rule ID 63119 //
     /*  414415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  414426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  414429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  414432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414439 */     // MIs[0] op1
     /*  414439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414462 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  414462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414467 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414469 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414471 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  414481 */     GIR_RootConstrainSelectedInstOperands,
     /*  414482 */     // GIR_Coverage, 63119,
     /*  414482 */     GIR_EraseRootFromParent_Done,
     /*  414483 */   // Label 7311: @414483
     /*  414483 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(414556), // Rule ID 63150 //
     /*  414488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414512 */     // MIs[0] op1
     /*  414512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414535 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414540 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414542 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414544 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414554 */     GIR_RootConstrainSelectedInstOperands,
     /*  414555 */     // GIR_Coverage, 63150,
     /*  414555 */     GIR_EraseRootFromParent_Done,
     /*  414556 */   // Label 7312: @414556
     /*  414556 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(414629), // Rule ID 63151 //
     /*  414561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  414578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414585 */     // MIs[0] op1
     /*  414585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414588 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414613 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414615 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414617 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414627 */     GIR_RootConstrainSelectedInstOperands,
     /*  414628 */     // GIR_Coverage, 63151,
     /*  414628 */     GIR_EraseRootFromParent_Done,
     /*  414629 */   // Label 7313: @414629
     /*  414629 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(414702), // Rule ID 63162 //
     /*  414634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  414651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414658 */     // MIs[0] op1
     /*  414658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414681 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414686 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414688 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414690 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414700 */     GIR_RootConstrainSelectedInstOperands,
     /*  414701 */     // GIR_Coverage, 63162,
     /*  414701 */     GIR_EraseRootFromParent_Done,
     /*  414702 */   // Label 7314: @414702
     /*  414702 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(414775), // Rule ID 63163 //
     /*  414707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  414715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  414724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414731 */     // MIs[0] op1
     /*  414731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414734 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414754 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  414757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414759 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414761 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414763 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414773 */     GIR_RootConstrainSelectedInstOperands,
     /*  414774 */     // GIR_Coverage, 63163,
     /*  414774 */     GIR_EraseRootFromParent_Done,
     /*  414775 */   // Label 7315: @414775
     /*  414775 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(414848), // Rule ID 63186 //
     /*  414780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414804 */     // MIs[0] op1
     /*  414804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414807 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414827 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  414827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  414830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414832 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414834 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414836 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414846 */     GIR_RootConstrainSelectedInstOperands,
     /*  414847 */     // GIR_Coverage, 63186,
     /*  414847 */     GIR_EraseRootFromParent_Done,
     /*  414848 */   // Label 7316: @414848
     /*  414848 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(414921), // Rule ID 63187 //
     /*  414853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  414856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  414861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  414864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  414867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  414870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  414873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414877 */     // MIs[0] op1
     /*  414877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  414885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  414893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  414900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M1),
     /*  414903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414905 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414907 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414909 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  414919 */     GIR_RootConstrainSelectedInstOperands,
     /*  414920 */     // GIR_Coverage, 63187,
     /*  414920 */     GIR_EraseRootFromParent_Done,
     /*  414921 */   // Label 7317: @414921
     /*  414921 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(414994), // Rule ID 63206 //
     /*  414926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  414929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  414934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  414937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  414940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  414943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  414946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414950 */     // MIs[0] op1
     /*  414950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  414953 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  414958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  414962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  414966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  414973 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  414973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  414976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  414978 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  414980 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  414982 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  414984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  414989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  414992 */     GIR_RootConstrainSelectedInstOperands,
     /*  414993 */     // GIR_Coverage, 63206,
     /*  414993 */     GIR_EraseRootFromParent_Done,
     /*  414994 */   // Label 7318: @414994
     /*  414994 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(415067), // Rule ID 63207 //
     /*  414999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415023 */     // MIs[0] op1
     /*  415023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415046 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415065 */     GIR_RootConstrainSelectedInstOperands,
     /*  415066 */     // GIR_Coverage, 63207,
     /*  415066 */     GIR_EraseRootFromParent_Done,
     /*  415067 */   // Label 7319: @415067
     /*  415067 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(415140), // Rule ID 63218 //
     /*  415072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415096 */     // MIs[0] op1
     /*  415096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415124 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415126 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415128 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415138 */     GIR_RootConstrainSelectedInstOperands,
     /*  415139 */     // GIR_Coverage, 63218,
     /*  415139 */     GIR_EraseRootFromParent_Done,
     /*  415140 */   // Label 7320: @415140
     /*  415140 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(415213), // Rule ID 63219 //
     /*  415145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  415162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415169 */     // MIs[0] op1
     /*  415169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415192 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415197 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415199 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415201 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415211 */     GIR_RootConstrainSelectedInstOperands,
     /*  415212 */     // GIR_Coverage, 63219,
     /*  415212 */     GIR_EraseRootFromParent_Done,
     /*  415213 */   // Label 7321: @415213
     /*  415213 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(415286), // Rule ID 63242 //
     /*  415218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415242 */     // MIs[0] op1
     /*  415242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415265 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  415265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  415268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415270 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415272 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415274 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415284 */     GIR_RootConstrainSelectedInstOperands,
     /*  415285 */     // GIR_Coverage, 63242,
     /*  415285 */     GIR_EraseRootFromParent_Done,
     /*  415286 */   // Label 7322: @415286
     /*  415286 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(415359), // Rule ID 63243 //
     /*  415291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  415302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  415305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415315 */     // MIs[0] op1
     /*  415315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  415331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415338 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  415338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M1),
     /*  415341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415343 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415345 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415347 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  415357 */     GIR_RootConstrainSelectedInstOperands,
     /*  415358 */     // GIR_Coverage, 63243,
     /*  415358 */     GIR_EraseRootFromParent_Done,
     /*  415359 */   // Label 7323: @415359
     /*  415359 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(415432), // Rule ID 63262 //
     /*  415364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415388 */     // MIs[0] op1
     /*  415388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415411 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  415411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415416 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415418 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415420 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415430 */     GIR_RootConstrainSelectedInstOperands,
     /*  415431 */     // GIR_Coverage, 63262,
     /*  415431 */     GIR_EraseRootFromParent_Done,
     /*  415432 */   // Label 7324: @415432
     /*  415432 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(415505), // Rule ID 63263 //
     /*  415437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415461 */     // MIs[0] op1
     /*  415461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415484 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  415484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M1),
     /*  415487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415489 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415491 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415493 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415503 */     GIR_RootConstrainSelectedInstOperands,
     /*  415504 */     // GIR_Coverage, 63263,
     /*  415504 */     GIR_EraseRootFromParent_Done,
     /*  415505 */   // Label 7325: @415505
     /*  415505 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(415578), // Rule ID 63274 //
     /*  415510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  415527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415534 */     // MIs[0] op1
     /*  415534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415557 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  415557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415562 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415564 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415566 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415576 */     GIR_RootConstrainSelectedInstOperands,
     /*  415577 */     // GIR_Coverage, 63274,
     /*  415577 */     GIR_EraseRootFromParent_Done,
     /*  415578 */   // Label 7326: @415578
     /*  415578 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(415651), // Rule ID 63275 //
     /*  415583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  415600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415607 */     // MIs[0] op1
     /*  415607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415630 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  415630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M1),
     /*  415633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415635 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415637 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415639 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415649 */     GIR_RootConstrainSelectedInstOperands,
     /*  415650 */     // GIR_Coverage, 63275,
     /*  415650 */     GIR_EraseRootFromParent_Done,
     /*  415651 */   // Label 7327: @415651
     /*  415651 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(415724), // Rule ID 63298 //
     /*  415656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415680 */     // MIs[0] op1
     /*  415680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  415696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415703 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  415703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  415706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415708 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415710 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415712 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415722 */     GIR_RootConstrainSelectedInstOperands,
     /*  415723 */     // GIR_Coverage, 63298,
     /*  415723 */     GIR_EraseRootFromParent_Done,
     /*  415724 */   // Label 7328: @415724
     /*  415724 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(415797), // Rule ID 63299 //
     /*  415729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  415737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  415740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  415743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415753 */     // MIs[0] op1
     /*  415753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415756 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  415761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  415765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  415769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  415776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M1),
     /*  415779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415781 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415783 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415785 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  415795 */     GIR_RootConstrainSelectedInstOperands,
     /*  415796 */     // GIR_Coverage, 63299,
     /*  415796 */     GIR_EraseRootFromParent_Done,
     /*  415797 */   // Label 7329: @415797
     /*  415797 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(415870), // Rule ID 63318 //
     /*  415802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  415813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  415816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  415819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415826 */     // MIs[0] op1
     /*  415826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415849 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  415852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415854 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415856 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415858 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415868 */     GIR_RootConstrainSelectedInstOperands,
     /*  415869 */     // GIR_Coverage, 63318,
     /*  415869 */     GIR_EraseRootFromParent_Done,
     /*  415870 */   // Label 7330: @415870
     /*  415870 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(415943), // Rule ID 63319 //
     /*  415875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  415878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  415883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  415886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  415889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  415892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  415895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415899 */     // MIs[0] op1
     /*  415899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  415915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  415922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  415925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  415927 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  415929 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  415931 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  415933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  415938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  415941 */     GIR_RootConstrainSelectedInstOperands,
     /*  415942 */     // GIR_Coverage, 63319,
     /*  415942 */     GIR_EraseRootFromParent_Done,
     /*  415943 */   // Label 7331: @415943
     /*  415943 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(416016), // Rule ID 63330 //
     /*  415948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  415951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  415956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  415959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  415962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  415965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  415968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415972 */     // MIs[0] op1
     /*  415972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  415975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  415980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  415988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  415995 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  415995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  415998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416000 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416002 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416004 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416014 */     GIR_RootConstrainSelectedInstOperands,
     /*  416015 */     // GIR_Coverage, 63330,
     /*  416015 */     GIR_EraseRootFromParent_Done,
     /*  416016 */   // Label 7332: @416016
     /*  416016 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(416089), // Rule ID 63331 //
     /*  416021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  416032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  416035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  416038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416045 */     // MIs[0] op1
     /*  416045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416048 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416068 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  416071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416073 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416075 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416077 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416087 */     GIR_RootConstrainSelectedInstOperands,
     /*  416088 */     // GIR_Coverage, 63331,
     /*  416088 */     GIR_EraseRootFromParent_Done,
     /*  416089 */   // Label 7333: @416089
     /*  416089 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(416162), // Rule ID 63362 //
     /*  416094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416118 */     // MIs[0] op1
     /*  416118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416141 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  416144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416146 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416148 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416150 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416160 */     GIR_RootConstrainSelectedInstOperands,
     /*  416161 */     // GIR_Coverage, 63362,
     /*  416161 */     GIR_EraseRootFromParent_Done,
     /*  416162 */   // Label 7334: @416162
     /*  416162 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(416235), // Rule ID 63363 //
     /*  416167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416191 */     // MIs[0] op1
     /*  416191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416194 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416214 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  416217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416219 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416221 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416223 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416233 */     GIR_RootConstrainSelectedInstOperands,
     /*  416234 */     // GIR_Coverage, 63363,
     /*  416234 */     GIR_EraseRootFromParent_Done,
     /*  416235 */   // Label 7335: @416235
     /*  416235 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(416308), // Rule ID 63374 //
     /*  416240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416264 */     // MIs[0] op1
     /*  416264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416287 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  416290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416306 */     GIR_RootConstrainSelectedInstOperands,
     /*  416307 */     // GIR_Coverage, 63374,
     /*  416307 */     GIR_EraseRootFromParent_Done,
     /*  416308 */   // Label 7336: @416308
     /*  416308 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(416381), // Rule ID 63375 //
     /*  416313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  416324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  416327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  416330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416337 */     // MIs[0] op1
     /*  416337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416340 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  416353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  416363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416365 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416367 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416369 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416379 */     GIR_RootConstrainSelectedInstOperands,
     /*  416380 */     // GIR_Coverage, 63375,
     /*  416380 */     GIR_EraseRootFromParent_Done,
     /*  416381 */   // Label 7337: @416381
     /*  416381 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(416454), // Rule ID 63406 //
     /*  416386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416410 */     // MIs[0] op1
     /*  416410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416433 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  416436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416438 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416440 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416442 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416452 */     GIR_RootConstrainSelectedInstOperands,
     /*  416453 */     // GIR_Coverage, 63406,
     /*  416453 */     GIR_EraseRootFromParent_Done,
     /*  416454 */   // Label 7338: @416454
     /*  416454 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(416527), // Rule ID 63407 //
     /*  416459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416483 */     // MIs[0] op1
     /*  416483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416486 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  416509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416511 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416513 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416515 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416525 */     GIR_RootConstrainSelectedInstOperands,
     /*  416526 */     // GIR_Coverage, 63407,
     /*  416526 */     GIR_EraseRootFromParent_Done,
     /*  416527 */   // Label 7339: @416527
     /*  416527 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(416600), // Rule ID 63418 //
     /*  416532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  416549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416556 */     // MIs[0] op1
     /*  416556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416579 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  416579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  416582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416584 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416586 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416588 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416598 */     GIR_RootConstrainSelectedInstOperands,
     /*  416599 */     // GIR_Coverage, 63418,
     /*  416599 */     GIR_EraseRootFromParent_Done,
     /*  416600 */   // Label 7340: @416600
     /*  416600 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(416673), // Rule ID 63419 //
     /*  416605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  416616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  416619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  416622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416629 */     // MIs[0] op1
     /*  416629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416632 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  416645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416652 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  416652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  416655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416657 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416659 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416661 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  416671 */     GIR_RootConstrainSelectedInstOperands,
     /*  416672 */     // GIR_Coverage, 63419,
     /*  416672 */     GIR_EraseRootFromParent_Done,
     /*  416673 */   // Label 7341: @416673
     /*  416673 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(416746), // Rule ID 63450 //
     /*  416678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  416689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  416692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  416695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416702 */     // MIs[0] op1
     /*  416702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416705 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  416725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  416728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416730 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416732 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416734 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  416744 */     GIR_RootConstrainSelectedInstOperands,
     /*  416745 */     // GIR_Coverage, 63450,
     /*  416745 */     GIR_EraseRootFromParent_Done,
     /*  416746 */   // Label 7342: @416746
     /*  416746 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(416819), // Rule ID 63451 //
     /*  416751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  416759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  416762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  416765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  416768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416775 */     // MIs[0] op1
     /*  416775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  416791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  416798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  416801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416803 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416805 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416807 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  416817 */     GIR_RootConstrainSelectedInstOperands,
     /*  416818 */     // GIR_Coverage, 63451,
     /*  416818 */     GIR_EraseRootFromParent_Done,
     /*  416819 */   // Label 7343: @416819
     /*  416819 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(416892), // Rule ID 63462 //
     /*  416824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  416835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  416838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  416841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416848 */     // MIs[0] op1
     /*  416848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416871 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  416871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  416874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416876 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416878 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416880 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  416890 */     GIR_RootConstrainSelectedInstOperands,
     /*  416891 */     // GIR_Coverage, 63462,
     /*  416891 */     GIR_EraseRootFromParent_Done,
     /*  416892 */   // Label 7344: @416892
     /*  416892 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(416965), // Rule ID 63463 //
     /*  416897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  416900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  416905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  416908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  416911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  416914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  416917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416921 */     // MIs[0] op1
     /*  416921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  416929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  416944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  416944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  416947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  416949 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  416951 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  416953 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  416955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  416960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  416963 */     GIR_RootConstrainSelectedInstOperands,
     /*  416964 */     // GIR_Coverage, 63463,
     /*  416964 */     GIR_EraseRootFromParent_Done,
     /*  416965 */   // Label 7345: @416965
     /*  416965 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(417038), // Rule ID 63486 //
     /*  416970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  416973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  416978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  416981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  416984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  416987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  416990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  416994 */     // MIs[0] op1
     /*  416994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  416997 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  417020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417022 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417024 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417026 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417036 */     GIR_RootConstrainSelectedInstOperands,
     /*  417037 */     // GIR_Coverage, 63486,
     /*  417037 */     GIR_EraseRootFromParent_Done,
     /*  417038 */   // Label 7346: @417038
     /*  417038 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(417111), // Rule ID 63487 //
     /*  417043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  417054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  417057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417067 */     // MIs[0] op1
     /*  417067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  417079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417090 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M2),
     /*  417093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417095 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417097 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417099 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417109 */     GIR_RootConstrainSelectedInstOperands,
     /*  417110 */     // GIR_Coverage, 63487,
     /*  417110 */     GIR_EraseRootFromParent_Done,
     /*  417111 */   // Label 7347: @417111
     /*  417111 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(417184), // Rule ID 63506 //
     /*  417116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417140 */     // MIs[0] op1
     /*  417140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417163 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  417166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417168 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417170 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417172 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417182 */     GIR_RootConstrainSelectedInstOperands,
     /*  417183 */     // GIR_Coverage, 63506,
     /*  417183 */     GIR_EraseRootFromParent_Done,
     /*  417184 */   // Label 7348: @417184
     /*  417184 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(417257), // Rule ID 63507 //
     /*  417189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417213 */     // MIs[0] op1
     /*  417213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417216 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  417239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417241 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417243 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417245 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417255 */     GIR_RootConstrainSelectedInstOperands,
     /*  417256 */     // GIR_Coverage, 63507,
     /*  417256 */     GIR_EraseRootFromParent_Done,
     /*  417257 */   // Label 7349: @417257
     /*  417257 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(417330), // Rule ID 63518 //
     /*  417262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417286 */     // MIs[0] op1
     /*  417286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417309 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  417312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417328 */     GIR_RootConstrainSelectedInstOperands,
     /*  417329 */     // GIR_Coverage, 63518,
     /*  417329 */     GIR_EraseRootFromParent_Done,
     /*  417330 */   // Label 7350: @417330
     /*  417330 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(417403), // Rule ID 63519 //
     /*  417335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  417352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417359 */     // MIs[0] op1
     /*  417359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417382 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  417385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417387 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417389 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417391 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417401 */     GIR_RootConstrainSelectedInstOperands,
     /*  417402 */     // GIR_Coverage, 63519,
     /*  417402 */     GIR_EraseRootFromParent_Done,
     /*  417403 */   // Label 7351: @417403
     /*  417403 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(417476), // Rule ID 63542 //
     /*  417408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417432 */     // MIs[0] op1
     /*  417432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417455 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  417458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417460 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417462 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417464 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417474 */     GIR_RootConstrainSelectedInstOperands,
     /*  417475 */     // GIR_Coverage, 63542,
     /*  417475 */     GIR_EraseRootFromParent_Done,
     /*  417476 */   // Label 7352: @417476
     /*  417476 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(417549), // Rule ID 63543 //
     /*  417481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  417492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  417495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417505 */     // MIs[0] op1
     /*  417505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  417517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417528 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M4),
     /*  417531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417533 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417535 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417537 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417547 */     GIR_RootConstrainSelectedInstOperands,
     /*  417548 */     // GIR_Coverage, 63543,
     /*  417548 */     GIR_EraseRootFromParent_Done,
     /*  417549 */   // Label 7353: @417549
     /*  417549 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(417622), // Rule ID 63562 //
     /*  417554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  417571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417578 */     // MIs[0] op1
     /*  417578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417601 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  417604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417606 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417608 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417610 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417620 */     GIR_RootConstrainSelectedInstOperands,
     /*  417621 */     // GIR_Coverage, 63562,
     /*  417621 */     GIR_EraseRootFromParent_Done,
     /*  417622 */   // Label 7354: @417622
     /*  417622 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(417695), // Rule ID 63563 //
     /*  417627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  417635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  417644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417651 */     // MIs[0] op1
     /*  417651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  417667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417674 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  417677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417679 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417681 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417683 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417693 */     GIR_RootConstrainSelectedInstOperands,
     /*  417694 */     // GIR_Coverage, 63563,
     /*  417694 */     GIR_EraseRootFromParent_Done,
     /*  417695 */   // Label 7355: @417695
     /*  417695 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(417768), // Rule ID 63574 //
     /*  417700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  417717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417724 */     // MIs[0] op1
     /*  417724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417747 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  417750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417752 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417754 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417756 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417766 */     GIR_RootConstrainSelectedInstOperands,
     /*  417767 */     // GIR_Coverage, 63574,
     /*  417767 */     GIR_EraseRootFromParent_Done,
     /*  417768 */   // Label 7356: @417768
     /*  417768 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(417841), // Rule ID 63575 //
     /*  417773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  417781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  417790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417797 */     // MIs[0] op1
     /*  417797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417800 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  417805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417820 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  417823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417825 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417827 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417829 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417839 */     GIR_RootConstrainSelectedInstOperands,
     /*  417840 */     // GIR_Coverage, 63575,
     /*  417840 */     GIR_EraseRootFromParent_Done,
     /*  417841 */   // Label 7357: @417841
     /*  417841 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(417914), // Rule ID 63598 //
     /*  417846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  417866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417870 */     // MIs[0] op1
     /*  417870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417873 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417893 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  417893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  417896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417898 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417900 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417902 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417912 */     GIR_RootConstrainSelectedInstOperands,
     /*  417913 */     // GIR_Coverage, 63598,
     /*  417913 */     GIR_EraseRootFromParent_Done,
     /*  417914 */   // Label 7358: @417914
     /*  417914 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(417987), // Rule ID 63599 //
     /*  417919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  417922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  417927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  417930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  417933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  417936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  417939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417943 */     // MIs[0] op1
     /*  417943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  417946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  417951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  417955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  417959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  417966 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16V_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, FPR16:{ *:[f16] }:$op3, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  417966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16V_M8),
     /*  417969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  417971 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  417973 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  417975 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  417977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  417982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  417985 */     GIR_RootConstrainSelectedInstOperands,
     /*  417986 */     // GIR_Coverage, 63599,
     /*  417986 */     GIR_EraseRootFromParent_Done,
     /*  417987 */   // Label 7359: @417987
     /*  417987 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(418060), // Rule ID 63618 //
     /*  417992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  417995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418016 */     // MIs[0] op1
     /*  418016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  418042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418044 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418046 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418048 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418058 */     GIR_RootConstrainSelectedInstOperands,
     /*  418059 */     // GIR_Coverage, 63618,
     /*  418059 */     GIR_EraseRootFromParent_Done,
     /*  418060 */   // Label 7360: @418060
     /*  418060 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(418133), // Rule ID 63619 //
     /*  418065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418089 */     // MIs[0] op1
     /*  418089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418092 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418112 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  418115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418117 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418119 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418121 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418131 */     GIR_RootConstrainSelectedInstOperands,
     /*  418132 */     // GIR_Coverage, 63619,
     /*  418132 */     GIR_EraseRootFromParent_Done,
     /*  418133 */   // Label 7361: @418133
     /*  418133 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(418206), // Rule ID 63630 //
     /*  418138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418162 */     // MIs[0] op1
     /*  418162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418165 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  418188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418190 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418192 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418194 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418204 */     GIR_RootConstrainSelectedInstOperands,
     /*  418205 */     // GIR_Coverage, 63630,
     /*  418205 */     GIR_EraseRootFromParent_Done,
     /*  418206 */   // Label 7362: @418206
     /*  418206 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(418279), // Rule ID 63631 //
     /*  418211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  418228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418235 */     // MIs[0] op1
     /*  418235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418238 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  418261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418263 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418265 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418267 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418277 */     GIR_RootConstrainSelectedInstOperands,
     /*  418278 */     // GIR_Coverage, 63631,
     /*  418278 */     GIR_EraseRootFromParent_Done,
     /*  418279 */   // Label 7363: @418279
     /*  418279 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(418352), // Rule ID 63654 //
     /*  418284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418308 */     // MIs[0] op1
     /*  418308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418311 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418331 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  418334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418336 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418338 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418340 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418350 */     GIR_RootConstrainSelectedInstOperands,
     /*  418351 */     // GIR_Coverage, 63654,
     /*  418351 */     GIR_EraseRootFromParent_Done,
     /*  418352 */   // Label 7364: @418352
     /*  418352 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(418425), // Rule ID 63655 //
     /*  418357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  418368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  418371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418381 */     // MIs[0] op1
     /*  418381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418384 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  418393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M2),
     /*  418407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418409 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418411 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418413 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418423 */     GIR_RootConstrainSelectedInstOperands,
     /*  418424 */     // GIR_Coverage, 63655,
     /*  418424 */     GIR_EraseRootFromParent_Done,
     /*  418425 */   // Label 7365: @418425
     /*  418425 */   GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(418498), // Rule ID 63674 //
     /*  418430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418454 */     // MIs[0] op1
     /*  418454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418457 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  418480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418496 */     GIR_RootConstrainSelectedInstOperands,
     /*  418497 */     // GIR_Coverage, 63674,
     /*  418497 */     GIR_EraseRootFromParent_Done,
     /*  418498 */   // Label 7366: @418498
     /*  418498 */   GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(418571), // Rule ID 63675 //
     /*  418503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418527 */     // MIs[0] op1
     /*  418527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418530 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  418553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418555 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418557 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418559 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418569 */     GIR_RootConstrainSelectedInstOperands,
     /*  418570 */     // GIR_Coverage, 63675,
     /*  418570 */     GIR_EraseRootFromParent_Done,
     /*  418571 */   // Label 7367: @418571
     /*  418571 */   GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(418644), // Rule ID 63686 //
     /*  418576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  418593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418600 */     // MIs[0] op1
     /*  418600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418623 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  418626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418628 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418630 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418632 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418642 */     GIR_RootConstrainSelectedInstOperands,
     /*  418643 */     // GIR_Coverage, 63686,
     /*  418643 */     GIR_EraseRootFromParent_Done,
     /*  418644 */   // Label 7368: @418644
     /*  418644 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(418717), // Rule ID 63687 //
     /*  418649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  418657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  418666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418673 */     // MIs[0] op1
     /*  418673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  418699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418701 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418703 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418705 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418715 */     GIR_RootConstrainSelectedInstOperands,
     /*  418716 */     // GIR_Coverage, 63687,
     /*  418716 */     GIR_EraseRootFromParent_Done,
     /*  418717 */   // Label 7369: @418717
     /*  418717 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(418790), // Rule ID 63710 //
     /*  418722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418746 */     // MIs[0] op1
     /*  418746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  418772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418774 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418776 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418778 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418788 */     GIR_RootConstrainSelectedInstOperands,
     /*  418789 */     // GIR_Coverage, 63710,
     /*  418789 */     GIR_EraseRootFromParent_Done,
     /*  418790 */   // Label 7370: @418790
     /*  418790 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(418863), // Rule ID 63711 //
     /*  418795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  418803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  418806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  418809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418819 */     // MIs[0] op1
     /*  418819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418822 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  418827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  418831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  418835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M4),
     /*  418845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418847 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418849 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418851 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418861 */     GIR_RootConstrainSelectedInstOperands,
     /*  418862 */     // GIR_Coverage, 63711,
     /*  418862 */     GIR_EraseRootFromParent_Done,
     /*  418863 */   // Label 7371: @418863
     /*  418863 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(418936), // Rule ID 63730 //
     /*  418868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  418871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  418879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  418882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  418885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  418888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418892 */     // MIs[0] op1
     /*  418892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418915 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  418915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  418918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418920 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418922 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418924 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  418931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  418934 */     GIR_RootConstrainSelectedInstOperands,
     /*  418935 */     // GIR_Coverage, 63730,
     /*  418935 */     GIR_EraseRootFromParent_Done,
     /*  418936 */   // Label 7372: @418936
     /*  418936 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(419009), // Rule ID 63731 //
     /*  418941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  418944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  418949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  418952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  418955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  418958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  418961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418965 */     // MIs[0] op1
     /*  418965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  418968 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  418973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  418977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  418981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  418988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  418988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  418991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  418993 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  418995 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  418997 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  418999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419007 */     GIR_RootConstrainSelectedInstOperands,
     /*  419008 */     // GIR_Coverage, 63731,
     /*  419008 */     GIR_EraseRootFromParent_Done,
     /*  419009 */   // Label 7373: @419009
     /*  419009 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(419082), // Rule ID 63742 //
     /*  419014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419038 */     // MIs[0] op1
     /*  419038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419061 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  419064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419066 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419068 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419070 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419080 */     GIR_RootConstrainSelectedInstOperands,
     /*  419081 */     // GIR_Coverage, 63742,
     /*  419081 */     GIR_EraseRootFromParent_Done,
     /*  419082 */   // Label 7374: @419082
     /*  419082 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(419155), // Rule ID 63743 //
     /*  419087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  419104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419111 */     // MIs[0] op1
     /*  419111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  419137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419139 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419141 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419143 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419153 */     GIR_RootConstrainSelectedInstOperands,
     /*  419154 */     // GIR_Coverage, 63743,
     /*  419154 */     GIR_EraseRootFromParent_Done,
     /*  419155 */   // Label 7375: @419155
     /*  419155 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(419228), // Rule ID 63766 //
     /*  419160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419184 */     // MIs[0] op1
     /*  419184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419207 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  419207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  419210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419212 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419214 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419216 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419226 */     GIR_RootConstrainSelectedInstOperands,
     /*  419227 */     // GIR_Coverage, 63766,
     /*  419227 */     GIR_EraseRootFromParent_Done,
     /*  419228 */   // Label 7376: @419228
     /*  419228 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(419301), // Rule ID 63767 //
     /*  419233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  419244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  419247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419257 */     // MIs[0] op1
     /*  419257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419260 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  419269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  419273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32V_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, FPR32:{ *:[f32] }:$op3, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  419280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32V_M8),
     /*  419283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419285 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419287 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419289 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  419299 */     GIR_RootConstrainSelectedInstOperands,
     /*  419300 */     // GIR_Coverage, 63767,
     /*  419300 */     GIR_EraseRootFromParent_Done,
     /*  419301 */   // Label 7377: @419301
     /*  419301 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(419374), // Rule ID 63786 //
     /*  419306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419330 */     // MIs[0] op1
     /*  419330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419353 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  419356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419358 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419360 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419362 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419372 */     GIR_RootConstrainSelectedInstOperands,
     /*  419373 */     // GIR_Coverage, 63786,
     /*  419373 */     GIR_EraseRootFromParent_Done,
     /*  419374 */   // Label 7378: @419374
     /*  419374 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(419447), // Rule ID 63787 //
     /*  419379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419403 */     // MIs[0] op1
     /*  419403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419406 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M2),
     /*  419429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419431 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419433 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419435 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419445 */     GIR_RootConstrainSelectedInstOperands,
     /*  419446 */     // GIR_Coverage, 63787,
     /*  419446 */     GIR_EraseRootFromParent_Done,
     /*  419447 */   // Label 7379: @419447
     /*  419447 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(419520), // Rule ID 63798 //
     /*  419452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  419469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419476 */     // MIs[0] op1
     /*  419476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419479 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419499 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  419502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419504 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419506 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419508 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419518 */     GIR_RootConstrainSelectedInstOperands,
     /*  419519 */     // GIR_Coverage, 63798,
     /*  419519 */     GIR_EraseRootFromParent_Done,
     /*  419520 */   // Label 7380: @419520
     /*  419520 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(419593), // Rule ID 63799 //
     /*  419525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  419542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419549 */     // MIs[0] op1
     /*  419549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419552 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419572 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M2),
     /*  419575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419577 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419579 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419581 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419591 */     GIR_RootConstrainSelectedInstOperands,
     /*  419592 */     // GIR_Coverage, 63799,
     /*  419592 */     GIR_EraseRootFromParent_Done,
     /*  419593 */   // Label 7381: @419593
     /*  419593 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(419666), // Rule ID 63822 //
     /*  419598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419622 */     // MIs[0] op1
     /*  419622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  419638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419645 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  419648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419650 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419652 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419654 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419664 */     GIR_RootConstrainSelectedInstOperands,
     /*  419665 */     // GIR_Coverage, 63822,
     /*  419665 */     GIR_EraseRootFromParent_Done,
     /*  419666 */   // Label 7382: @419666
     /*  419666 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(419739), // Rule ID 63823 //
     /*  419671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  419679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  419682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  419685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419695 */     // MIs[0] op1
     /*  419695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  419703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  419707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  419711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419718 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M2),
     /*  419721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419723 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419725 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419727 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419737 */     GIR_RootConstrainSelectedInstOperands,
     /*  419738 */     // GIR_Coverage, 63823,
     /*  419738 */     GIR_EraseRootFromParent_Done,
     /*  419739 */   // Label 7383: @419739
     /*  419739 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(419812), // Rule ID 63842 //
     /*  419744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  419755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  419758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  419761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419768 */     // MIs[0] op1
     /*  419768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419791 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  419794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419796 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419798 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419800 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419810 */     GIR_RootConstrainSelectedInstOperands,
     /*  419811 */     // GIR_Coverage, 63842,
     /*  419811 */     GIR_EraseRootFromParent_Done,
     /*  419812 */   // Label 7384: @419812
     /*  419812 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(419885), // Rule ID 63843 //
     /*  419817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  419825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  419828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  419831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  419834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419841 */     // MIs[0] op1
     /*  419841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  419857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  419864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M4),
     /*  419867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419869 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419871 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419873 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419883 */     GIR_RootConstrainSelectedInstOperands,
     /*  419884 */     // GIR_Coverage, 63843,
     /*  419884 */     GIR_EraseRootFromParent_Done,
     /*  419885 */   // Label 7385: @419885
     /*  419885 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(419958), // Rule ID 63854 //
     /*  419890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  419893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  419901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  419904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  419907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  419910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419914 */     // MIs[0] op1
     /*  419914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419917 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  419937 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  419937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  419940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  419942 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  419944 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  419946 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  419948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  419953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  419956 */     GIR_RootConstrainSelectedInstOperands,
     /*  419957 */     // GIR_Coverage, 63854,
     /*  419957 */     GIR_EraseRootFromParent_Done,
     /*  419958 */   // Label 7386: @419958
     /*  419958 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(420031), // Rule ID 63855 //
     /*  419963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  419966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  419971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  419974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  419977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  419980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  419983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419987 */     // MIs[0] op1
     /*  419987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  419990 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  419995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  419999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M4),
     /*  420013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420015 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420017 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420019 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420029 */     GIR_RootConstrainSelectedInstOperands,
     /*  420030 */     // GIR_Coverage, 63855,
     /*  420030 */     GIR_EraseRootFromParent_Done,
     /*  420031 */   // Label 7387: @420031
     /*  420031 */   GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(420104), // Rule ID 63878 //
     /*  420036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420060 */     // MIs[0] op1
     /*  420060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420083 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  420086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420102 */     GIR_RootConstrainSelectedInstOperands,
     /*  420103 */     // GIR_Coverage, 63878,
     /*  420103 */     GIR_EraseRootFromParent_Done,
     /*  420104 */   // Label 7388: @420104
     /*  420104 */   GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(420177), // Rule ID 63879 //
     /*  420109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  420120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  420123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420133 */     // MIs[0] op1
     /*  420133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420136 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  420145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420156 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M4),
     /*  420159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420161 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420163 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420165 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420175 */     GIR_RootConstrainSelectedInstOperands,
     /*  420176 */     // GIR_Coverage, 63879,
     /*  420176 */     GIR_EraseRootFromParent_Done,
     /*  420177 */   // Label 7389: @420177
     /*  420177 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(420250), // Rule ID 63898 //
     /*  420182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420206 */     // MIs[0] op1
     /*  420206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420209 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420229 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420234 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420236 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420238 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420248 */     GIR_RootConstrainSelectedInstOperands,
     /*  420249 */     // GIR_Coverage, 63898,
     /*  420249 */     GIR_EraseRootFromParent_Done,
     /*  420250 */   // Label 7390: @420250
     /*  420250 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(420323), // Rule ID 63899 //
     /*  420255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xv),
     /*  420263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  420272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420279 */     // MIs[0] op1
     /*  420279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  420295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11014:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, GPR:{ *:[i32] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XV_M8),
     /*  420305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420307 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420309 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420311 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420321 */     GIR_RootConstrainSelectedInstOperands,
     /*  420322 */     // GIR_Coverage, 63899,
     /*  420322 */     GIR_EraseRootFromParent_Done,
     /*  420323 */   // Label 7391: @420323
     /*  420323 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(420396), // Rule ID 63910 //
     /*  420328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420352 */     // MIs[0] op1
     /*  420352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420375 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420380 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420382 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420384 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420394 */     GIR_RootConstrainSelectedInstOperands,
     /*  420395 */     // GIR_Coverage, 63910,
     /*  420395 */     GIR_EraseRootFromParent_Done,
     /*  420396 */   // Label 7392: @420396
     /*  420396 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(420469), // Rule ID 63911 //
     /*  420401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vv),
     /*  420409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  420418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420425 */     // MIs[0] op1
     /*  420425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  420433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11006:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VV_M8),
     /*  420451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420453 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420455 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420457 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420467 */     GIR_RootConstrainSelectedInstOperands,
     /*  420468 */     // GIR_Coverage, 63911,
     /*  420468 */     GIR_EraseRootFromParent_Done,
     /*  420469 */   // Label 7393: @420469
     /*  420469 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(420542), // Rule ID 63934 //
     /*  420474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  420477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420498 */     // MIs[0] op1
     /*  420498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420521 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  420521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  420524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420540 */     GIR_RootConstrainSelectedInstOperands,
     /*  420541 */     // GIR_Coverage, 63934,
     /*  420541 */     GIR_EraseRootFromParent_Done,
     /*  420542 */   // Label 7394: @420542
     /*  420542 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(420615), // Rule ID 63935 //
     /*  420547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  420550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fv),
     /*  420555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  420558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  420561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  420564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420571 */     // MIs[0] op1
     /*  420571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  420574 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  420579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  420583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  420587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10992:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64V_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, FPR64:{ *:[f64] }:$op3, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  420594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64V_M8),
     /*  420597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420599 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  420601 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  420603 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  420605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  420613 */     GIR_RootConstrainSelectedInstOperands,
     /*  420614 */     // GIR_Coverage, 63935,
     /*  420614 */     GIR_EraseRootFromParent_Done,
     /*  420615 */   // Label 7395: @420615
     /*  420615 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(420698), // Rule ID 5216 //
     /*  420620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  420623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  420628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  420631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  420634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  420637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  420640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  420655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  420659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  420663 */     // MIs[1] Operand 1
     /*  420663 */     // No operand predicates
     /*  420663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  420667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  420669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420676 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  420679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  420683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  420686 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  420688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420696 */     GIR_RootConstrainSelectedInstOperands,
     /*  420697 */     // GIR_Coverage, 5216,
     /*  420697 */     GIR_EraseRootFromParent_Done,
     /*  420698 */   // Label 7396: @420698
     /*  420698 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(420781), // Rule ID 5217 //
     /*  420703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  420706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  420711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  420714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  420717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  420720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  420723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  420738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  420742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  420746 */     // MIs[1] Operand 1
     /*  420746 */     // No operand predicates
     /*  420746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  420750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  420752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420759 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF8),
     /*  420762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  420766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  420769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  420771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420779 */     GIR_RootConstrainSelectedInstOperands,
     /*  420780 */     // GIR_Coverage, 5217,
     /*  420780 */     GIR_EraseRootFromParent_Done,
     /*  420781 */   // Label 7397: @420781
     /*  420781 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(420864), // Rule ID 5218 //
     /*  420786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  420789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  420794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  420797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  420800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  420803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  420806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  420821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  420825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  420829 */     // MIs[1] Operand 1
     /*  420829 */     // No operand predicates
     /*  420829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  420833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  420835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420842 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  420842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  420845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  420849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  420852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  420854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420862 */     GIR_RootConstrainSelectedInstOperands,
     /*  420863 */     // GIR_Coverage, 5218,
     /*  420863 */     GIR_EraseRootFromParent_Done,
     /*  420864 */   // Label 7398: @420864
     /*  420864 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(420947), // Rule ID 5219 //
     /*  420869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  420872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  420877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  420880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  420883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  420886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  420889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  420892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  420904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  420908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  420912 */     // MIs[1] Operand 1
     /*  420912 */     // No operand predicates
     /*  420912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  420916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  420918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  420925 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  420925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  420928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  420930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  420932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  420935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  420937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  420942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  420945 */     GIR_RootConstrainSelectedInstOperands,
     /*  420946 */     // GIR_Coverage, 5219,
     /*  420946 */     GIR_EraseRootFromParent_Done,
     /*  420947 */   // Label 7399: @420947
     /*  420947 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(421030), // Rule ID 5220 //
     /*  420952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  420955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  420960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  420963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  420966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  420969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  420972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  420975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  420983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  420987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  420991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  420995 */     // MIs[1] Operand 1
     /*  420995 */     // No operand predicates
     /*  420995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  420999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421008 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421028 */     GIR_RootConstrainSelectedInstOperands,
     /*  421029 */     // GIR_Coverage, 5220,
     /*  421029 */     GIR_EraseRootFromParent_Done,
     /*  421030 */   // Label 7400: @421030
     /*  421030 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(421113), // Rule ID 5221 //
     /*  421035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  421049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421078 */     // MIs[1] Operand 1
     /*  421078 */     // No operand predicates
     /*  421078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421091 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421111 */     GIR_RootConstrainSelectedInstOperands,
     /*  421112 */     // GIR_Coverage, 5221,
     /*  421112 */     GIR_EraseRootFromParent_Done,
     /*  421113 */   // Label 7401: @421113
     /*  421113 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(421196), // Rule ID 5222 //
     /*  421118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421161 */     // MIs[1] Operand 1
     /*  421161 */     // No operand predicates
     /*  421161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421174 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421194 */     GIR_RootConstrainSelectedInstOperands,
     /*  421195 */     // GIR_Coverage, 5222,
     /*  421195 */     GIR_EraseRootFromParent_Done,
     /*  421196 */   // Label 7402: @421196
     /*  421196 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(421279), // Rule ID 5223 //
     /*  421201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  421215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421244 */     // MIs[1] Operand 1
     /*  421244 */     // No operand predicates
     /*  421244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421257 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF4),
     /*  421260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421277 */     GIR_RootConstrainSelectedInstOperands,
     /*  421278 */     // GIR_Coverage, 5223,
     /*  421278 */     GIR_EraseRootFromParent_Done,
     /*  421279 */   // Label 7403: @421279
     /*  421279 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(421362), // Rule ID 5224 //
     /*  421284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421327 */     // MIs[1] Operand 1
     /*  421327 */     // No operand predicates
     /*  421327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421360 */     GIR_RootConstrainSelectedInstOperands,
     /*  421361 */     // GIR_Coverage, 5224,
     /*  421361 */     GIR_EraseRootFromParent_Done,
     /*  421362 */   // Label 7404: @421362
     /*  421362 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(421445), // Rule ID 5225 //
     /*  421367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  421381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421410 */     // MIs[1] Operand 1
     /*  421410 */     // No operand predicates
     /*  421410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421423 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421443 */     GIR_RootConstrainSelectedInstOperands,
     /*  421444 */     // GIR_Coverage, 5225,
     /*  421444 */     GIR_EraseRootFromParent_Done,
     /*  421445 */   // Label 7405: @421445
     /*  421445 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(421528), // Rule ID 5226 //
     /*  421450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  421464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421493 */     // MIs[1] Operand 1
     /*  421493 */     // No operand predicates
     /*  421493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421506 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  421506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421526 */     GIR_RootConstrainSelectedInstOperands,
     /*  421527 */     // GIR_Coverage, 5226,
     /*  421527 */     GIR_EraseRootFromParent_Done,
     /*  421528 */   // Label 7406: @421528
     /*  421528 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(421611), // Rule ID 5227 //
     /*  421533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  421544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  421547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  421553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421576 */     // MIs[1] Operand 1
     /*  421576 */     // No operand predicates
     /*  421576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421589 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  421589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_MF2),
     /*  421592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  421609 */     GIR_RootConstrainSelectedInstOperands,
     /*  421610 */     // GIR_Coverage, 5227,
     /*  421610 */     GIR_EraseRootFromParent_Done,
     /*  421611 */   // Label 7407: @421611
     /*  421611 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(421694), // Rule ID 5228 //
     /*  421616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  421627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  421630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  421636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421655 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421659 */     // MIs[1] Operand 1
     /*  421659 */     // No operand predicates
     /*  421659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  421672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  421675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421692 */     GIR_RootConstrainSelectedInstOperands,
     /*  421693 */     // GIR_Coverage, 5228,
     /*  421693 */     GIR_EraseRootFromParent_Done,
     /*  421694 */   // Label 7408: @421694
     /*  421694 */   GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(421777), // Rule ID 5229 //
     /*  421699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  421710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  421713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  421719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421742 */     // MIs[1] Operand 1
     /*  421742 */     // No operand predicates
     /*  421742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421755 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  421755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  421758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  421775 */     GIR_RootConstrainSelectedInstOperands,
     /*  421776 */     // GIR_Coverage, 5229,
     /*  421776 */     GIR_EraseRootFromParent_Done,
     /*  421777 */   // Label 7409: @421777
     /*  421777 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(421860), // Rule ID 5230 //
     /*  421782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  421796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421825 */     // MIs[1] Operand 1
     /*  421825 */     // No operand predicates
     /*  421825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421838 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  421838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  421841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421858 */     GIR_RootConstrainSelectedInstOperands,
     /*  421859 */     // GIR_Coverage, 5230,
     /*  421859 */     GIR_EraseRootFromParent_Done,
     /*  421860 */   // Label 7410: @421860
     /*  421860 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(421943), // Rule ID 5231 //
     /*  421865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  421868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  421876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  421879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  421882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  421885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  421888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421908 */     // MIs[1] Operand 1
     /*  421908 */     // No operand predicates
     /*  421908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  421921 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  421921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  421924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  421926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  421928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  421931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  421933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  421938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  421941 */     GIR_RootConstrainSelectedInstOperands,
     /*  421942 */     // GIR_Coverage, 5231,
     /*  421942 */     GIR_EraseRootFromParent_Done,
     /*  421943 */   // Label 7411: @421943
     /*  421943 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(422026), // Rule ID 5232 //
     /*  421948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  421951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  421956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  421959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  421962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  421965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  421968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  421971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  421979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  421983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  421987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  421991 */     // MIs[1] Operand 1
     /*  421991 */     // No operand predicates
     /*  421991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  421995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  421997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422004 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  422004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422024 */     GIR_RootConstrainSelectedInstOperands,
     /*  422025 */     // GIR_Coverage, 5232,
     /*  422025 */     GIR_EraseRootFromParent_Done,
     /*  422026 */   // Label 7412: @422026
     /*  422026 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(422109), // Rule ID 5233 //
     /*  422031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  422042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  422045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  422051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422074 */     // MIs[1] Operand 1
     /*  422074 */     // No operand predicates
     /*  422074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422087 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  422087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  422107 */     GIR_RootConstrainSelectedInstOperands,
     /*  422108 */     // GIR_Coverage, 5233,
     /*  422108 */     GIR_EraseRootFromParent_Done,
     /*  422109 */   // Label 7413: @422109
     /*  422109 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(422192), // Rule ID 5234 //
     /*  422114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  422117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422157 */     // MIs[1] Operand 1
     /*  422157 */     // No operand predicates
     /*  422157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  422170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422190 */     GIR_RootConstrainSelectedInstOperands,
     /*  422191 */     // GIR_Coverage, 5234,
     /*  422191 */     GIR_EraseRootFromParent_Done,
     /*  422192 */   // Label 7414: @422192
     /*  422192 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(422275), // Rule ID 5235 //
     /*  422197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  422200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  422208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  422211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  422217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422240 */     // MIs[1] Operand 1
     /*  422240 */     // No operand predicates
     /*  422240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422253 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  422253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M1),
     /*  422256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  422273 */     GIR_RootConstrainSelectedInstOperands,
     /*  422274 */     // GIR_Coverage, 5235,
     /*  422274 */     GIR_EraseRootFromParent_Done,
     /*  422275 */   // Label 7415: @422275
     /*  422275 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(422358), // Rule ID 5236 //
     /*  422280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422323 */     // MIs[1] Operand 1
     /*  422323 */     // No operand predicates
     /*  422323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422336 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422356 */     GIR_RootConstrainSelectedInstOperands,
     /*  422357 */     // GIR_Coverage, 5236,
     /*  422357 */     GIR_EraseRootFromParent_Done,
     /*  422358 */   // Label 7416: @422358
     /*  422358 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(422441), // Rule ID 5237 //
     /*  422363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  422377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422406 */     // MIs[1] Operand 1
     /*  422406 */     // No operand predicates
     /*  422406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422419 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422439 */     GIR_RootConstrainSelectedInstOperands,
     /*  422440 */     // GIR_Coverage, 5237,
     /*  422440 */     GIR_EraseRootFromParent_Done,
     /*  422441 */   // Label 7417: @422441
     /*  422441 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(422524), // Rule ID 5238 //
     /*  422446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  422457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  422460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  422466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422489 */     // MIs[1] Operand 1
     /*  422489 */     // No operand predicates
     /*  422489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422502 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  422505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422522 */     GIR_RootConstrainSelectedInstOperands,
     /*  422523 */     // GIR_Coverage, 5238,
     /*  422523 */     GIR_EraseRootFromParent_Done,
     /*  422524 */   // Label 7418: @422524
     /*  422524 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(422607), // Rule ID 5239 //
     /*  422529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  422540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  422543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  422549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422572 */     // MIs[1] Operand 1
     /*  422572 */     // No operand predicates
     /*  422572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422585 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  422588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422605 */     GIR_RootConstrainSelectedInstOperands,
     /*  422606 */     // GIR_Coverage, 5239,
     /*  422606 */     GIR_EraseRootFromParent_Done,
     /*  422607 */   // Label 7419: @422607
     /*  422607 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(422690), // Rule ID 5240 //
     /*  422612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  422623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  422626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  422632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422655 */     // MIs[1] Operand 1
     /*  422655 */     // No operand predicates
     /*  422655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422668 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  422668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  422671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422678 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422688 */     GIR_RootConstrainSelectedInstOperands,
     /*  422689 */     // GIR_Coverage, 5240,
     /*  422689 */     GIR_EraseRootFromParent_Done,
     /*  422690 */   // Label 7420: @422690
     /*  422690 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(422773), // Rule ID 5241 //
     /*  422695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  422706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  422709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  422715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  422726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422738 */     // MIs[1] Operand 1
     /*  422738 */     // No operand predicates
     /*  422738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422751 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  422751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  422754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  422771 */     GIR_RootConstrainSelectedInstOperands,
     /*  422772 */     // GIR_Coverage, 5241,
     /*  422772 */     GIR_EraseRootFromParent_Done,
     /*  422773 */   // Label 7421: @422773
     /*  422773 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(422856), // Rule ID 5242 //
     /*  422778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  422792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422821 */     // MIs[1] Operand 1
     /*  422821 */     // No operand predicates
     /*  422821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422834 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  422834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422854 */     GIR_RootConstrainSelectedInstOperands,
     /*  422855 */     // GIR_Coverage, 5242,
     /*  422855 */     GIR_EraseRootFromParent_Done,
     /*  422856 */   // Label 7422: @422856
     /*  422856 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(422939), // Rule ID 5243 //
     /*  422861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  422864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  422872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  422875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  422878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  422881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  422884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  422892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422904 */     // MIs[1] Operand 1
     /*  422904 */     // No operand predicates
     /*  422904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  422917 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  422917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  422920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  422922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  422924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  422927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  422929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  422934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  422937 */     GIR_RootConstrainSelectedInstOperands,
     /*  422938 */     // GIR_Coverage, 5243,
     /*  422938 */     GIR_EraseRootFromParent_Done,
     /*  422939 */   // Label 7423: @422939
     /*  422939 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(423022), // Rule ID 5244 //
     /*  422944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  422947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  422952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  422955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  422958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  422961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  422964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  422967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  422971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  422975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  422979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  422983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  422987 */     // MIs[1] Operand 1
     /*  422987 */     // No operand predicates
     /*  422987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  422991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  422993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423000 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423020 */     GIR_RootConstrainSelectedInstOperands,
     /*  423021 */     // GIR_Coverage, 5244,
     /*  423021 */     GIR_EraseRootFromParent_Done,
     /*  423022 */   // Label 7424: @423022
     /*  423022 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(423105), // Rule ID 5245 //
     /*  423027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  423041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423070 */     // MIs[1] Operand 1
     /*  423070 */     // No operand predicates
     /*  423070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423083 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423103 */     GIR_RootConstrainSelectedInstOperands,
     /*  423104 */     // GIR_Coverage, 5245,
     /*  423104 */     GIR_EraseRootFromParent_Done,
     /*  423105 */   // Label 7425: @423105
     /*  423105 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(423188), // Rule ID 5246 //
     /*  423110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423153 */     // MIs[1] Operand 1
     /*  423153 */     // No operand predicates
     /*  423153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423166 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  423166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423186 */     GIR_RootConstrainSelectedInstOperands,
     /*  423187 */     // GIR_Coverage, 5246,
     /*  423187 */     GIR_EraseRootFromParent_Done,
     /*  423188 */   // Label 7426: @423188
     /*  423188 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(423271), // Rule ID 5247 //
     /*  423193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  423204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  423207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  423213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423232 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423236 */     // MIs[1] Operand 1
     /*  423236 */     // No operand predicates
     /*  423236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423249 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  423249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  423269 */     GIR_RootConstrainSelectedInstOperands,
     /*  423270 */     // GIR_Coverage, 5247,
     /*  423270 */     GIR_EraseRootFromParent_Done,
     /*  423271 */   // Label 7427: @423271
     /*  423271 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(423354), // Rule ID 5248 //
     /*  423276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423319 */     // MIs[1] Operand 1
     /*  423319 */     // No operand predicates
     /*  423319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423352 */     GIR_RootConstrainSelectedInstOperands,
     /*  423353 */     // GIR_Coverage, 5248,
     /*  423353 */     GIR_EraseRootFromParent_Done,
     /*  423354 */   // Label 7428: @423354
     /*  423354 */   GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(423437), // Rule ID 5249 //
     /*  423359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  423373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423402 */     // MIs[1] Operand 1
     /*  423402 */     // No operand predicates
     /*  423402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423415 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423435 */     GIR_RootConstrainSelectedInstOperands,
     /*  423436 */     // GIR_Coverage, 5249,
     /*  423436 */     GIR_EraseRootFromParent_Done,
     /*  423437 */   // Label 7429: @423437
     /*  423437 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(423520), // Rule ID 5250 //
     /*  423442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423485 */     // MIs[1] Operand 1
     /*  423485 */     // No operand predicates
     /*  423485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423498 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423518 */     GIR_RootConstrainSelectedInstOperands,
     /*  423519 */     // GIR_Coverage, 5250,
     /*  423519 */     GIR_EraseRootFromParent_Done,
     /*  423520 */   // Label 7430: @423520
     /*  423520 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(423603), // Rule ID 5251 //
     /*  423525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  423536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  423539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  423545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423568 */     // MIs[1] Operand 1
     /*  423568 */     // No operand predicates
     /*  423568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423581 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423601 */     GIR_RootConstrainSelectedInstOperands,
     /*  423602 */     // GIR_Coverage, 5251,
     /*  423602 */     GIR_EraseRootFromParent_Done,
     /*  423603 */   // Label 7431: @423603
     /*  423603 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(423686), // Rule ID 5252 //
     /*  423608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  423611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  423622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423651 */     // MIs[1] Operand 1
     /*  423651 */     // No operand predicates
     /*  423651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423664 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  423664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423684 */     GIR_RootConstrainSelectedInstOperands,
     /*  423685 */     // GIR_Coverage, 5252,
     /*  423685 */     GIR_EraseRootFromParent_Done,
     /*  423686 */   // Label 7432: @423686
     /*  423686 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(423769), // Rule ID 5253 //
     /*  423691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  423694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  423702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  423705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  423711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  423722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423734 */     // MIs[1] Operand 1
     /*  423734 */     // No operand predicates
     /*  423734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423747 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  423747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  423750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  423767 */     GIR_RootConstrainSelectedInstOperands,
     /*  423768 */     // GIR_Coverage, 5253,
     /*  423768 */     GIR_EraseRootFromParent_Done,
     /*  423769 */   // Label 7433: @423769
     /*  423769 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(423852), // Rule ID 5254 //
     /*  423774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  423777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  423785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  423788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  423794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423817 */     // MIs[1] Operand 1
     /*  423817 */     // No operand predicates
     /*  423817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423840 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423850 */     GIR_RootConstrainSelectedInstOperands,
     /*  423851 */     // GIR_Coverage, 5254,
     /*  423851 */     GIR_EraseRootFromParent_Done,
     /*  423852 */   // Label 7434: @423852
     /*  423852 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(423935), // Rule ID 5255 //
     /*  423857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  423860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  423868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  423871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  423874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  423877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  423880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  423888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423900 */     // MIs[1] Operand 1
     /*  423900 */     // No operand predicates
     /*  423900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423913 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  423913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M2),
     /*  423916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  423918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  423920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  423923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  423925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  423930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  423933 */     GIR_RootConstrainSelectedInstOperands,
     /*  423934 */     // GIR_Coverage, 5255,
     /*  423934 */     GIR_EraseRootFromParent_Done,
     /*  423935 */   // Label 7435: @423935
     /*  423935 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(424018), // Rule ID 5256 //
     /*  423940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  423943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  423948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  423951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  423954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  423957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  423960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  423963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  423967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  423971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  423975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  423979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  423983 */     // MIs[1] Operand 1
     /*  423983 */     // No operand predicates
     /*  423983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  423987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  423989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  423996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  423996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  423999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424016 */     GIR_RootConstrainSelectedInstOperands,
     /*  424017 */     // GIR_Coverage, 5256,
     /*  424017 */     GIR_EraseRootFromParent_Done,
     /*  424018 */   // Label 7436: @424018
     /*  424018 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(424101), // Rule ID 5257 //
     /*  424023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  424034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  424037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  424043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424066 */     // MIs[1] Operand 1
     /*  424066 */     // No operand predicates
     /*  424066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424079 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M4),
     /*  424082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424099 */     GIR_RootConstrainSelectedInstOperands,
     /*  424100 */     // GIR_Coverage, 5257,
     /*  424100 */     GIR_EraseRootFromParent_Done,
     /*  424101 */   // Label 7437: @424101
     /*  424101 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(424184), // Rule ID 5258 //
     /*  424106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  424109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  424123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424149 */     // MIs[1] Operand 1
     /*  424149 */     // No operand predicates
     /*  424149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424162 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  424162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424182 */     GIR_RootConstrainSelectedInstOperands,
     /*  424183 */     // GIR_Coverage, 5258,
     /*  424183 */     GIR_EraseRootFromParent_Done,
     /*  424184 */   // Label 7438: @424184
     /*  424184 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(424267), // Rule ID 5259 //
     /*  424189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  424192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  424197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  424200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  424203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  424206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  424209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  424224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  424228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  424232 */     // MIs[1] Operand 1
     /*  424232 */     // No operand predicates
     /*  424232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  424236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  424238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424245 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VIM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  424245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VIM_M8),
     /*  424248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  424252 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  424255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  424257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  424265 */     GIR_RootConstrainSelectedInstOperands,
     /*  424266 */     // GIR_Coverage, 5259,
     /*  424266 */     GIR_EraseRootFromParent_Done,
     /*  424267 */   // Label 7439: @424267
     /*  424267 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(424343), // Rule ID 60484 //
     /*  424272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424304 */     // MIs[0] rs2
     /*  424304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424341 */     GIR_RootConstrainSelectedInstOperands,
     /*  424342 */     // GIR_Coverage, 60484,
     /*  424342 */     GIR_EraseRootFromParent_Done,
     /*  424343 */   // Label 7440: @424343
     /*  424343 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(424419), // Rule ID 60485 //
     /*  424348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  424359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  424362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  424365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424380 */     // MIs[0] rs2
     /*  424380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424395 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_MF2),
     /*  424398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424417 */     GIR_RootConstrainSelectedInstOperands,
     /*  424418 */     // GIR_Coverage, 60485,
     /*  424418 */     GIR_EraseRootFromParent_Done,
     /*  424419 */   // Label 7441: @424419
     /*  424419 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(424495), // Rule ID 62130 //
     /*  424424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424456 */     // MIs[0] rs2
     /*  424456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424471 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  424474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424493 */     GIR_RootConstrainSelectedInstOperands,
     /*  424494 */     // GIR_Coverage, 62130,
     /*  424494 */     GIR_EraseRootFromParent_Done,
     /*  424495 */   // Label 7442: @424495
     /*  424495 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(424571), // Rule ID 62131 //
     /*  424500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  424511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  424514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  424517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  424532 */     // MIs[0] rs2
     /*  424532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424547 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11084:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M1),
     /*  424550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424569 */     GIR_RootConstrainSelectedInstOperands,
     /*  424570 */     // GIR_Coverage, 62131,
     /*  424570 */     GIR_EraseRootFromParent_Done,
     /*  424571 */   // Label 7443: @424571
     /*  424571 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(424647), // Rule ID 62132 //
     /*  424576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  424587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  424593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424608 */     // MIs[0] rs2
     /*  424608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  424626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424645 */     GIR_RootConstrainSelectedInstOperands,
     /*  424646 */     // GIR_Coverage, 62132,
     /*  424646 */     GIR_EraseRootFromParent_Done,
     /*  424647 */   // Label 7444: @424647
     /*  424647 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(424723), // Rule ID 62133 //
     /*  424652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  424663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  424666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  424669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  424684 */     // MIs[0] rs2
     /*  424684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424687 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424699 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11084:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M2),
     /*  424702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424721 */     GIR_RootConstrainSelectedInstOperands,
     /*  424722 */     // GIR_Coverage, 62133,
     /*  424722 */     GIR_EraseRootFromParent_Done,
     /*  424723 */   // Label 7445: @424723
     /*  424723 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(424799), // Rule ID 62134 //
     /*  424728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  424739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  424745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424760 */     // MIs[0] rs2
     /*  424760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424775 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  424778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424797 */     GIR_RootConstrainSelectedInstOperands,
     /*  424798 */     // GIR_Coverage, 62134,
     /*  424798 */     GIR_EraseRootFromParent_Done,
     /*  424799 */   // Label 7446: @424799
     /*  424799 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(424875), // Rule ID 62135 //
     /*  424804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  424815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  424818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  424821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  424836 */     // MIs[0] rs2
     /*  424836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424839 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424851 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11084:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  424851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M4),
     /*  424854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424873 */     GIR_RootConstrainSelectedInstOperands,
     /*  424874 */     // GIR_Coverage, 62135,
     /*  424874 */     GIR_EraseRootFromParent_Done,
     /*  424875 */   // Label 7447: @424875
     /*  424875 */   GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(424951), // Rule ID 62136 //
     /*  424880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  424883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  424891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  424897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  424900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424912 */     // MIs[0] rs2
     /*  424912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  424927 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  424927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  424930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  424932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  424934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  424936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  424938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  424943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  424946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  424949 */     GIR_RootConstrainSelectedInstOperands,
     /*  424950 */     // GIR_Coverage, 62136,
     /*  424950 */     GIR_EraseRootFromParent_Done,
     /*  424951 */   // Label 7448: @424951
     /*  424951 */   GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(425027), // Rule ID 62137 //
     /*  424956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  424959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf1),
     /*  424964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  424967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  424970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  424973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  424976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  424988 */     // MIs[0] rs2
     /*  424988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  424991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  424996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425003 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11084:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAESKF1_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF1_VI_M8),
     /*  425006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425025 */     GIR_RootConstrainSelectedInstOperands,
     /*  425026 */     // GIR_Coverage, 62137,
     /*  425026 */     GIR_EraseRootFromParent_Done,
     /*  425027 */   // Label 7449: @425027
     /*  425027 */   GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(425103), // Rule ID 62258 //
     /*  425032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425064 */     // MIs[0] rs2
     /*  425064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425079 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425101 */     GIR_RootConstrainSelectedInstOperands,
     /*  425102 */     // GIR_Coverage, 62258,
     /*  425102 */     GIR_EraseRootFromParent_Done,
     /*  425103 */   // Label 7450: @425103
     /*  425103 */   GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(425179), // Rule ID 62259 //
     /*  425108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  425119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  425122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  425125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425140 */     // MIs[0] rs2
     /*  425140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425143 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425155 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_MF2),
     /*  425158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425177 */     GIR_RootConstrainSelectedInstOperands,
     /*  425178 */     // GIR_Coverage, 62259,
     /*  425178 */     GIR_EraseRootFromParent_Done,
     /*  425179 */   // Label 7451: @425179
     /*  425179 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(425255), // Rule ID 62260 //
     /*  425184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425216 */     // MIs[0] rs2
     /*  425216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425231 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425253 */     GIR_RootConstrainSelectedInstOperands,
     /*  425254 */     // GIR_Coverage, 62260,
     /*  425254 */     GIR_EraseRootFromParent_Done,
     /*  425255 */   // Label 7452: @425255
     /*  425255 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(425331), // Rule ID 62261 //
     /*  425260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  425271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  425274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  425277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425292 */     // MIs[0] rs2
     /*  425292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425295 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425307 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11489:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M1),
     /*  425310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425329 */     GIR_RootConstrainSelectedInstOperands,
     /*  425330 */     // GIR_Coverage, 62261,
     /*  425330 */     GIR_EraseRootFromParent_Done,
     /*  425331 */   // Label 7453: @425331
     /*  425331 */   GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(425407), // Rule ID 62262 //
     /*  425336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425368 */     // MIs[0] rs2
     /*  425368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425383 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425405 */     GIR_RootConstrainSelectedInstOperands,
     /*  425406 */     // GIR_Coverage, 62262,
     /*  425406 */     GIR_EraseRootFromParent_Done,
     /*  425407 */   // Label 7454: @425407
     /*  425407 */   GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(425483), // Rule ID 62263 //
     /*  425412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  425423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  425426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  425429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  425444 */     // MIs[0] rs2
     /*  425444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11489:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M2),
     /*  425462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425481 */     GIR_RootConstrainSelectedInstOperands,
     /*  425482 */     // GIR_Coverage, 62263,
     /*  425482 */     GIR_EraseRootFromParent_Done,
     /*  425483 */   // Label 7455: @425483
     /*  425483 */   GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(425559), // Rule ID 62264 //
     /*  425488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425520 */     // MIs[0] rs2
     /*  425520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425535 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  425538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425557 */     GIR_RootConstrainSelectedInstOperands,
     /*  425558 */     // GIR_Coverage, 62264,
     /*  425558 */     GIR_EraseRootFromParent_Done,
     /*  425559 */   // Label 7456: @425559
     /*  425559 */   GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(425635), // Rule ID 62265 //
     /*  425564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  425575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  425578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  425581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  425596 */     // MIs[0] rs2
     /*  425596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425611 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11489:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M4),
     /*  425614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425633 */     GIR_RootConstrainSelectedInstOperands,
     /*  425634 */     // GIR_Coverage, 62265,
     /*  425634 */     GIR_EraseRootFromParent_Done,
     /*  425635 */   // Label 7457: @425635
     /*  425635 */   GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(425711), // Rule ID 62266 //
     /*  425640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  425643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425672 */     // MIs[0] rs2
     /*  425672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425675 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425687 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  425687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  425690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425709 */     GIR_RootConstrainSelectedInstOperands,
     /*  425710 */     // GIR_Coverage, 62266,
     /*  425710 */     GIR_EraseRootFromParent_Done,
     /*  425711 */   // Label 7458: @425711
     /*  425711 */   GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(425787), // Rule ID 62267 //
     /*  425716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  425719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4k),
     /*  425724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  425727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  425730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  425733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  425748 */     // MIs[0] rs2
     /*  425748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  425751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  425756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425763 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11489:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM4K_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  425763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4K_VI_M8),
     /*  425766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  425774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  425782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425785 */     GIR_RootConstrainSelectedInstOperands,
     /*  425786 */     // GIR_Coverage, 62267,
     /*  425786 */     GIR_EraseRootFromParent_Done,
     /*  425787 */   // Label 7459: @425787
     /*  425787 */   GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(425875), // Rule ID 2686 //
     /*  425792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  425800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  425803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  425806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  425809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  425812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  425831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  425839 */     // MIs[1] Operand 1
     /*  425839 */     // No operand predicates
     /*  425839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425848 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  425848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  425851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425857 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  425862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425873 */     GIR_RootConstrainSelectedInstOperands,
     /*  425874 */     // GIR_Coverage, 2686,
     /*  425874 */     GIR_EraseRootFromParent_Done,
     /*  425875 */   // Label 7460: @425875
     /*  425875 */   GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(425963), // Rule ID 2687 //
     /*  425880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  425883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  425888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  425891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  425894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  425897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  425900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  425903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  425919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  425923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  425927 */     // MIs[1] Operand 1
     /*  425927 */     // No operand predicates
     /*  425927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  425929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  425936 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  425936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  425939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  425941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  425943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  425945 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  425950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  425955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  425958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  425961 */     GIR_RootConstrainSelectedInstOperands,
     /*  425962 */     // GIR_Coverage, 2687,
     /*  425962 */     GIR_EraseRootFromParent_Done,
     /*  425963 */   // Label 7461: @425963
     /*  425963 */   GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(426051), // Rule ID 2694 //
     /*  425968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  425971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  425976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  425979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  425982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  425985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  425988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  425991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  425999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426015 */     // MIs[1] Operand 1
     /*  426015 */     // No operand predicates
     /*  426015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426033 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426049 */     GIR_RootConstrainSelectedInstOperands,
     /*  426050 */     // GIR_Coverage, 2694,
     /*  426050 */     GIR_EraseRootFromParent_Done,
     /*  426051 */   // Label 7462: @426051
     /*  426051 */   GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(426139), // Rule ID 2695 //
     /*  426056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  426067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  426070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  426073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426103 */     // MIs[1] Operand 1
     /*  426103 */     // No operand predicates
     /*  426103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426112 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426121 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426137 */     GIR_RootConstrainSelectedInstOperands,
     /*  426138 */     // GIR_Coverage, 2695,
     /*  426138 */     GIR_EraseRootFromParent_Done,
     /*  426139 */   // Label 7463: @426139
     /*  426139 */   GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(426227), // Rule ID 2702 //
     /*  426144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426191 */     // MIs[1] Operand 1
     /*  426191 */     // No operand predicates
     /*  426191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426209 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426225 */     GIR_RootConstrainSelectedInstOperands,
     /*  426226 */     // GIR_Coverage, 2702,
     /*  426226 */     GIR_EraseRootFromParent_Done,
     /*  426227 */   // Label 7464: @426227
     /*  426227 */   GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(426315), // Rule ID 2703 //
     /*  426232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  426243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  426246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  426249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426279 */     // MIs[1] Operand 1
     /*  426279 */     // No operand predicates
     /*  426279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426288 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426297 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426313 */     GIR_RootConstrainSelectedInstOperands,
     /*  426314 */     // GIR_Coverage, 2703,
     /*  426314 */     GIR_EraseRootFromParent_Done,
     /*  426315 */   // Label 7465: @426315
     /*  426315 */   GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(426403), // Rule ID 2710 //
     /*  426320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426367 */     // MIs[1] Operand 1
     /*  426367 */     // No operand predicates
     /*  426367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426376 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426385 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426401 */     GIR_RootConstrainSelectedInstOperands,
     /*  426402 */     // GIR_Coverage, 2710,
     /*  426402 */     GIR_EraseRootFromParent_Done,
     /*  426403 */   // Label 7466: @426403
     /*  426403 */   GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(426491), // Rule ID 2711 //
     /*  426408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  426419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  426422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  426425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426455 */     // MIs[1] Operand 1
     /*  426455 */     // No operand predicates
     /*  426455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  426467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426473 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426489 */     GIR_RootConstrainSelectedInstOperands,
     /*  426490 */     // GIR_Coverage, 2711,
     /*  426490 */     GIR_EraseRootFromParent_Done,
     /*  426491 */   // Label 7467: @426491
     /*  426491 */   GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(426579), // Rule ID 2718 //
     /*  426496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  426507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  426510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  426513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426543 */     // MIs[1] Operand 1
     /*  426543 */     // No operand predicates
     /*  426543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  426552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426561 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426577 */     GIR_RootConstrainSelectedInstOperands,
     /*  426578 */     // GIR_Coverage, 2718,
     /*  426578 */     GIR_EraseRootFromParent_Done,
     /*  426579 */   // Label 7468: @426579
     /*  426579 */   GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(426667), // Rule ID 2719 //
     /*  426584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  426595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  426598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  426601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426631 */     // MIs[1] Operand 1
     /*  426631 */     // No operand predicates
     /*  426631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  426640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426649 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  426662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426665 */     GIR_RootConstrainSelectedInstOperands,
     /*  426666 */     // GIR_Coverage, 2719,
     /*  426666 */     GIR_EraseRootFromParent_Done,
     /*  426667 */   // Label 7469: @426667
     /*  426667 */   GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(426755), // Rule ID 2726 //
     /*  426672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426719 */     // MIs[1] Operand 1
     /*  426719 */     // No operand predicates
     /*  426719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  426728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426737 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426753 */     GIR_RootConstrainSelectedInstOperands,
     /*  426754 */     // GIR_Coverage, 2726,
     /*  426754 */     GIR_EraseRootFromParent_Done,
     /*  426755 */   // Label 7470: @426755
     /*  426755 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(426843), // Rule ID 2727 //
     /*  426760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  426771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  426774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  426777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426807 */     // MIs[1] Operand 1
     /*  426807 */     // No operand predicates
     /*  426807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  426816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  426819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426825 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  426838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426841 */     GIR_RootConstrainSelectedInstOperands,
     /*  426842 */     // GIR_Coverage, 2727,
     /*  426842 */     GIR_EraseRootFromParent_Done,
     /*  426843 */   // Label 7471: @426843
     /*  426843 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(426931), // Rule ID 2734 //
     /*  426848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  426851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  426859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  426862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  426865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  426868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  426871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426895 */     // MIs[1] Operand 1
     /*  426895 */     // No operand predicates
     /*  426895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426904 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  426904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  426907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  426913 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  426918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  426923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  426926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  426929 */     GIR_RootConstrainSelectedInstOperands,
     /*  426930 */     // GIR_Coverage, 2734,
     /*  426930 */     GIR_EraseRootFromParent_Done,
     /*  426931 */   // Label 7472: @426931
     /*  426931 */   GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(427019), // Rule ID 2735 //
     /*  426936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  426939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  426944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  426947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  426950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  426953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  426956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  426959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  426971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  426975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  426979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  426983 */     // MIs[1] Operand 1
     /*  426983 */     // No operand predicates
     /*  426983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  426985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  426992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  426992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  426995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  426997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  426999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427001 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427017 */     GIR_RootConstrainSelectedInstOperands,
     /*  427018 */     // GIR_Coverage, 2735,
     /*  427018 */     GIR_EraseRootFromParent_Done,
     /*  427019 */   // Label 7473: @427019
     /*  427019 */   GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(427107), // Rule ID 2742 //
     /*  427024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427071 */     // MIs[1] Operand 1
     /*  427071 */     // No operand predicates
     /*  427071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427080 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  427080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427089 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427105 */     GIR_RootConstrainSelectedInstOperands,
     /*  427106 */     // GIR_Coverage, 2742,
     /*  427106 */     GIR_EraseRootFromParent_Done,
     /*  427107 */   // Label 7474: @427107
     /*  427107 */   GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(427195), // Rule ID 2743 //
     /*  427112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  427123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  427126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  427129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427159 */     // MIs[1] Operand 1
     /*  427159 */     // No operand predicates
     /*  427159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  427168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427177 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  427190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427193 */     GIR_RootConstrainSelectedInstOperands,
     /*  427194 */     // GIR_Coverage, 2743,
     /*  427194 */     GIR_EraseRootFromParent_Done,
     /*  427195 */   // Label 7475: @427195
     /*  427195 */   GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(427283), // Rule ID 2750 //
     /*  427200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427247 */     // MIs[1] Operand 1
     /*  427247 */     // No operand predicates
     /*  427247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  427256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427265 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427281 */     GIR_RootConstrainSelectedInstOperands,
     /*  427282 */     // GIR_Coverage, 2750,
     /*  427282 */     GIR_EraseRootFromParent_Done,
     /*  427283 */   // Label 7476: @427283
     /*  427283 */   GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(427371), // Rule ID 2751 //
     /*  427288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  427299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  427302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  427305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427335 */     // MIs[1] Operand 1
     /*  427335 */     // No operand predicates
     /*  427335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  427344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427353 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  427366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427369 */     GIR_RootConstrainSelectedInstOperands,
     /*  427370 */     // GIR_Coverage, 2751,
     /*  427370 */     GIR_EraseRootFromParent_Done,
     /*  427371 */   // Label 7477: @427371
     /*  427371 */   GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(427459), // Rule ID 2758 //
     /*  427376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  427379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  427393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427423 */     // MIs[1] Operand 1
     /*  427423 */     // No operand predicates
     /*  427423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  427432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427441 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427457 */     GIR_RootConstrainSelectedInstOperands,
     /*  427458 */     // GIR_Coverage, 2758,
     /*  427458 */     GIR_EraseRootFromParent_Done,
     /*  427459 */   // Label 7478: @427459
     /*  427459 */   GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(427547), // Rule ID 2759 //
     /*  427464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  427467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  427475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  427478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  427481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  427499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427511 */     // MIs[1] Operand 1
     /*  427511 */     // No operand predicates
     /*  427511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  427520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  427523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427529 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  427542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427545 */     GIR_RootConstrainSelectedInstOperands,
     /*  427546 */     // GIR_Coverage, 2759,
     /*  427546 */     GIR_EraseRootFromParent_Done,
     /*  427547 */   // Label 7479: @427547
     /*  427547 */   GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(427635), // Rule ID 2766 //
     /*  427552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  427563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  427566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  427569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427599 */     // MIs[1] Operand 1
     /*  427599 */     // No operand predicates
     /*  427599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427608 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  427611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427617 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427633 */     GIR_RootConstrainSelectedInstOperands,
     /*  427634 */     // GIR_Coverage, 2766,
     /*  427634 */     GIR_EraseRootFromParent_Done,
     /*  427635 */   // Label 7480: @427635
     /*  427635 */   GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(427723), // Rule ID 2767 //
     /*  427640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  427651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  427654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  427657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  427675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427687 */     // MIs[1] Operand 1
     /*  427687 */     // No operand predicates
     /*  427687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  427699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427705 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427721 */     GIR_RootConstrainSelectedInstOperands,
     /*  427722 */     // GIR_Coverage, 2767,
     /*  427722 */     GIR_EraseRootFromParent_Done,
     /*  427723 */   // Label 7481: @427723
     /*  427723 */   GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(427811), // Rule ID 2774 //
     /*  427728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  427739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  427742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  427745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427775 */     // MIs[1] Operand 1
     /*  427775 */     // No operand predicates
     /*  427775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  427787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427793 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427809 */     GIR_RootConstrainSelectedInstOperands,
     /*  427810 */     // GIR_Coverage, 2774,
     /*  427810 */     GIR_EraseRootFromParent_Done,
     /*  427811 */   // Label 7482: @427811
     /*  427811 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(427899), // Rule ID 2775 //
     /*  427816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  427827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  427830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  427833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  427836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  427839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  427851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427863 */     // MIs[1] Operand 1
     /*  427863 */     // No operand predicates
     /*  427863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427872 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  427872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  427875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427881 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427897 */     GIR_RootConstrainSelectedInstOperands,
     /*  427898 */     // GIR_Coverage, 2775,
     /*  427898 */     GIR_EraseRootFromParent_Done,
     /*  427899 */   // Label 7483: @427899
     /*  427899 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(427987), // Rule ID 2782 //
     /*  427904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  427907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  427912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  427915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  427918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  427921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  427924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  427927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  427939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  427943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  427947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  427951 */     // MIs[1] Operand 1
     /*  427951 */     // No operand predicates
     /*  427951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  427953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  427960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  427960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  427963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  427965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  427967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  427969 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  427974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  427979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  427982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  427985 */     GIR_RootConstrainSelectedInstOperands,
     /*  427986 */     // GIR_Coverage, 2782,
     /*  427986 */     GIR_EraseRootFromParent_Done,
     /*  427987 */   // Label 7484: @427987
     /*  427987 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(428075), // Rule ID 2783 //
     /*  427992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  427995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  428003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  428006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  428009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428039 */     // MIs[1] Operand 1
     /*  428039 */     // No operand predicates
     /*  428039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  428048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428057 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  428070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428073 */     GIR_RootConstrainSelectedInstOperands,
     /*  428074 */     // GIR_Coverage, 2783,
     /*  428074 */     GIR_EraseRootFromParent_Done,
     /*  428075 */   // Label 7485: @428075
     /*  428075 */   GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(428163), // Rule ID 2790 //
     /*  428080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428127 */     // MIs[1] Operand 1
     /*  428127 */     // No operand predicates
     /*  428127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428161 */     GIR_RootConstrainSelectedInstOperands,
     /*  428162 */     // GIR_Coverage, 2790,
     /*  428162 */     GIR_EraseRootFromParent_Done,
     /*  428163 */   // Label 7486: @428163
     /*  428163 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(428251), // Rule ID 2791 //
     /*  428168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  428179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  428182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  428185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428215 */     // MIs[1] Operand 1
     /*  428215 */     // No operand predicates
     /*  428215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428233 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428249 */     GIR_RootConstrainSelectedInstOperands,
     /*  428250 */     // GIR_Coverage, 2791,
     /*  428250 */     GIR_EraseRootFromParent_Done,
     /*  428251 */   // Label 7487: @428251
     /*  428251 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(428339), // Rule ID 2798 //
     /*  428256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428299 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428303 */     // MIs[1] Operand 1
     /*  428303 */     // No operand predicates
     /*  428303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428312 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428321 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428337 */     GIR_RootConstrainSelectedInstOperands,
     /*  428338 */     // GIR_Coverage, 2798,
     /*  428338 */     GIR_EraseRootFromParent_Done,
     /*  428339 */   // Label 7488: @428339
     /*  428339 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(428427), // Rule ID 2799 //
     /*  428344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  428355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  428358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  428361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428391 */     // MIs[1] Operand 1
     /*  428391 */     // No operand predicates
     /*  428391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428409 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428425 */     GIR_RootConstrainSelectedInstOperands,
     /*  428426 */     // GIR_Coverage, 2799,
     /*  428426 */     GIR_EraseRootFromParent_Done,
     /*  428427 */   // Label 7489: @428427
     /*  428427 */   GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(428515), // Rule ID 2806 //
     /*  428432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  428443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  428446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  428449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428479 */     // MIs[1] Operand 1
     /*  428479 */     // No operand predicates
     /*  428479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428488 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  428488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428497 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428513 */     GIR_RootConstrainSelectedInstOperands,
     /*  428514 */     // GIR_Coverage, 2806,
     /*  428514 */     GIR_EraseRootFromParent_Done,
     /*  428515 */   // Label 7490: @428515
     /*  428515 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(428603), // Rule ID 2807 //
     /*  428520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  428531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  428534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  428537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428567 */     // MIs[1] Operand 1
     /*  428567 */     // No operand predicates
     /*  428567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428576 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  428576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  428579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428585 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  428598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428601 */     GIR_RootConstrainSelectedInstOperands,
     /*  428602 */     // GIR_Coverage, 2807,
     /*  428602 */     GIR_EraseRootFromParent_Done,
     /*  428603 */   // Label 7491: @428603
     /*  428603 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(428691), // Rule ID 2814 //
     /*  428608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  428619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  428622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  428625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428655 */     // MIs[1] Operand 1
     /*  428655 */     // No operand predicates
     /*  428655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428673 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428689 */     GIR_RootConstrainSelectedInstOperands,
     /*  428690 */     // GIR_Coverage, 2814,
     /*  428690 */     GIR_EraseRootFromParent_Done,
     /*  428691 */   // Label 7492: @428691
     /*  428691 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(428779), // Rule ID 2815 //
     /*  428696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  428707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  428710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  428713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  428731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428743 */     // MIs[1] Operand 1
     /*  428743 */     // No operand predicates
     /*  428743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  428755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428761 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428777 */     GIR_RootConstrainSelectedInstOperands,
     /*  428778 */     // GIR_Coverage, 2815,
     /*  428778 */     GIR_EraseRootFromParent_Done,
     /*  428779 */   // Label 7493: @428779
     /*  428779 */   GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(428867), // Rule ID 2822 //
     /*  428784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  428795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  428798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  428801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428831 */     // MIs[1] Operand 1
     /*  428831 */     // No operand predicates
     /*  428831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  428840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428865 */     GIR_RootConstrainSelectedInstOperands,
     /*  428866 */     // GIR_Coverage, 2822,
     /*  428866 */     GIR_EraseRootFromParent_Done,
     /*  428867 */   // Label 7494: @428867
     /*  428867 */   GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(428955), // Rule ID 2823 //
     /*  428872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  428875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  428883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  428886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  428889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  428892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  428895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  428907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  428915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  428919 */     // MIs[1] Operand 1
     /*  428919 */     // No operand predicates
     /*  428919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  428921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  428928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  428928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  428931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  428933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  428935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  428937 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  428942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  428947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  428950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  428953 */     GIR_RootConstrainSelectedInstOperands,
     /*  428954 */     // GIR_Coverage, 2823,
     /*  428954 */     GIR_EraseRootFromParent_Done,
     /*  428955 */   // Label 7495: @428955
     /*  428955 */   GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(429043), // Rule ID 2830 //
     /*  428960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  428963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  428968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  428971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  428974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  428977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  428980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  428983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  428995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  428999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429007 */     // MIs[1] Operand 1
     /*  429007 */     // No operand predicates
     /*  429007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  429016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429025 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429041 */     GIR_RootConstrainSelectedInstOperands,
     /*  429042 */     // GIR_Coverage, 2830,
     /*  429042 */     GIR_EraseRootFromParent_Done,
     /*  429043 */   // Label 7496: @429043
     /*  429043 */   GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(429131), // Rule ID 2831 //
     /*  429048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  429059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  429062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  429065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429095 */     // MIs[1] Operand 1
     /*  429095 */     // No operand predicates
     /*  429095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429104 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  429104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429113 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  429126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429129 */     GIR_RootConstrainSelectedInstOperands,
     /*  429130 */     // GIR_Coverage, 2831,
     /*  429130 */     GIR_EraseRootFromParent_Done,
     /*  429131 */   // Label 7497: @429131
     /*  429131 */   GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(429219), // Rule ID 2838 //
     /*  429136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429183 */     // MIs[1] Operand 1
     /*  429183 */     // No operand predicates
     /*  429183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429201 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429217 */     GIR_RootConstrainSelectedInstOperands,
     /*  429218 */     // GIR_Coverage, 2838,
     /*  429218 */     GIR_EraseRootFromParent_Done,
     /*  429219 */   // Label 7498: @429219
     /*  429219 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(429307), // Rule ID 2839 //
     /*  429224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  429235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  429238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  429241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  429259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429271 */     // MIs[1] Operand 1
     /*  429271 */     // No operand predicates
     /*  429271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  429283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429289 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429305 */     GIR_RootConstrainSelectedInstOperands,
     /*  429306 */     // GIR_Coverage, 2839,
     /*  429306 */     GIR_EraseRootFromParent_Done,
     /*  429307 */   // Label 7499: @429307
     /*  429307 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(429395), // Rule ID 2846 //
     /*  429312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429359 */     // MIs[1] Operand 1
     /*  429359 */     // No operand predicates
     /*  429359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429377 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429393 */     GIR_RootConstrainSelectedInstOperands,
     /*  429394 */     // GIR_Coverage, 2846,
     /*  429394 */     GIR_EraseRootFromParent_Done,
     /*  429395 */   // Label 7500: @429395
     /*  429395 */   GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(429483), // Rule ID 2847 //
     /*  429400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  429411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  429414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  429417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  429435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429447 */     // MIs[1] Operand 1
     /*  429447 */     // No operand predicates
     /*  429447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429456 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  429459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429465 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429481 */     GIR_RootConstrainSelectedInstOperands,
     /*  429482 */     // GIR_Coverage, 2847,
     /*  429482 */     GIR_EraseRootFromParent_Done,
     /*  429483 */   // Label 7501: @429483
     /*  429483 */   GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(429571), // Rule ID 2854 //
     /*  429488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  429491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  429499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  429502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  429505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429535 */     // MIs[1] Operand 1
     /*  429535 */     // No operand predicates
     /*  429535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429544 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  429544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429553 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429569 */     GIR_RootConstrainSelectedInstOperands,
     /*  429570 */     // GIR_Coverage, 2854,
     /*  429570 */     GIR_EraseRootFromParent_Done,
     /*  429571 */   // Label 7502: @429571
     /*  429571 */   GIM_Try, /*On fail goto*//*Label 7503*/ GIMT_Encode4(429659), // Rule ID 2855 //
     /*  429576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  429579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  429584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  429587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  429590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  429593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  429611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /*  429623 */     // MIs[1] Operand 1
     /*  429623 */     // No operand predicates
     /*  429623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429632 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  429632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  429635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429641 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /*  429646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  429654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429657 */     GIR_RootConstrainSelectedInstOperands,
     /*  429658 */     // GIR_Coverage, 2855,
     /*  429658 */     GIR_EraseRootFromParent_Done,
     /*  429659 */   // Label 7503: @429659
     /*  429659 */   GIM_Try, /*On fail goto*//*Label 7504*/ GIMT_Encode4(429745), // Rule ID 3030 //
     /*  429664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  429672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  429675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  429678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  429681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  429711 */     // MIs[1] Operand 1
     /*  429711 */     // No operand predicates
     /*  429711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429720 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  429720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  429723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  429732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429743 */     GIR_RootConstrainSelectedInstOperands,
     /*  429744 */     // GIR_Coverage, 3030,
     /*  429744 */     GIR_EraseRootFromParent_Done,
     /*  429745 */   // Label 7504: @429745
     /*  429745 */   GIM_Try, /*On fail goto*//*Label 7505*/ GIMT_Encode4(429831), // Rule ID 3031 //
     /*  429750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  429758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  429761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  429764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  429767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  429797 */     // MIs[1] Operand 1
     /*  429797 */     // No operand predicates
     /*  429797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429806 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  429806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8),
     /*  429809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  429818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429829 */     GIR_RootConstrainSelectedInstOperands,
     /*  429830 */     // GIR_Coverage, 3031,
     /*  429830 */     GIR_EraseRootFromParent_Done,
     /*  429831 */   // Label 7505: @429831
     /*  429831 */   GIM_Try, /*On fail goto*//*Label 7506*/ GIMT_Encode4(429917), // Rule ID 3034 //
     /*  429836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  429839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  429844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  429847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  429850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  429853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  429856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  429859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  429883 */     // MIs[1] Operand 1
     /*  429883 */     // No operand predicates
     /*  429883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429892 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  429892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  429895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  429904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  429915 */     GIR_RootConstrainSelectedInstOperands,
     /*  429916 */     // GIR_Coverage, 3034,
     /*  429916 */     GIR_EraseRootFromParent_Done,
     /*  429917 */   // Label 7506: @429917
     /*  429917 */   GIM_Try, /*On fail goto*//*Label 7507*/ GIMT_Encode4(430003), // Rule ID 3035 //
     /*  429922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  429925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  429930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  429933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  429936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  429939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  429942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  429945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  429957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  429961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  429965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  429969 */     // MIs[1] Operand 1
     /*  429969 */     // No operand predicates
     /*  429969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  429971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  429978 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  429978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  429981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  429983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  429985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  429987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  429990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  429995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  429998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430001 */     GIR_RootConstrainSelectedInstOperands,
     /*  430002 */     // GIR_Coverage, 3035,
     /*  430002 */     GIR_EraseRootFromParent_Done,
     /*  430003 */   // Label 7507: @430003
     /*  430003 */   GIM_Try, /*On fail goto*//*Label 7508*/ GIMT_Encode4(430089), // Rule ID 3038 //
     /*  430008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430055 */     // MIs[1] Operand 1
     /*  430055 */     // No operand predicates
     /*  430055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430064 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430087 */     GIR_RootConstrainSelectedInstOperands,
     /*  430088 */     // GIR_Coverage, 3038,
     /*  430088 */     GIR_EraseRootFromParent_Done,
     /*  430089 */   // Label 7508: @430089
     /*  430089 */   GIM_Try, /*On fail goto*//*Label 7509*/ GIMT_Encode4(430175), // Rule ID 3039 //
     /*  430094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  430105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  430108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  430111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430141 */     // MIs[1] Operand 1
     /*  430141 */     // No operand predicates
     /*  430141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430150 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430173 */     GIR_RootConstrainSelectedInstOperands,
     /*  430174 */     // GIR_Coverage, 3039,
     /*  430174 */     GIR_EraseRootFromParent_Done,
     /*  430175 */   // Label 7509: @430175
     /*  430175 */   GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(430261), // Rule ID 3042 //
     /*  430180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430227 */     // MIs[1] Operand 1
     /*  430227 */     // No operand predicates
     /*  430227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430259 */     GIR_RootConstrainSelectedInstOperands,
     /*  430260 */     // GIR_Coverage, 3042,
     /*  430260 */     GIR_EraseRootFromParent_Done,
     /*  430261 */   // Label 7510: @430261
     /*  430261 */   GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(430347), // Rule ID 3043 //
     /*  430266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  430277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  430280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  430283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430313 */     // MIs[1] Operand 1
     /*  430313 */     // No operand predicates
     /*  430313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430322 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4),
     /*  430325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430345 */     GIR_RootConstrainSelectedInstOperands,
     /*  430346 */     // GIR_Coverage, 3043,
     /*  430346 */     GIR_EraseRootFromParent_Done,
     /*  430347 */   // Label 7511: @430347
     /*  430347 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(430433), // Rule ID 3046 //
     /*  430352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430399 */     // MIs[1] Operand 1
     /*  430399 */     // No operand predicates
     /*  430399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430408 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430431 */     GIR_RootConstrainSelectedInstOperands,
     /*  430432 */     // GIR_Coverage, 3046,
     /*  430432 */     GIR_EraseRootFromParent_Done,
     /*  430433 */   // Label 7512: @430433
     /*  430433 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(430519), // Rule ID 3047 //
     /*  430438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  430449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  430452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  430455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430485 */     // MIs[1] Operand 1
     /*  430485 */     // No operand predicates
     /*  430485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  430494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430517 */     GIR_RootConstrainSelectedInstOperands,
     /*  430518 */     // GIR_Coverage, 3047,
     /*  430518 */     GIR_EraseRootFromParent_Done,
     /*  430519 */   // Label 7513: @430519
     /*  430519 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(430605), // Rule ID 3050 //
     /*  430524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  430535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  430538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  430541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430571 */     // MIs[1] Operand 1
     /*  430571 */     // No operand predicates
     /*  430571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  430580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430603 */     GIR_RootConstrainSelectedInstOperands,
     /*  430604 */     // GIR_Coverage, 3050,
     /*  430604 */     GIR_EraseRootFromParent_Done,
     /*  430605 */   // Label 7514: @430605
     /*  430605 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(430691), // Rule ID 3051 //
     /*  430610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  430621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  430624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  430627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430657 */     // MIs[1] Operand 1
     /*  430657 */     // No operand predicates
     /*  430657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  430666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2),
     /*  430669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  430686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430689 */     GIR_RootConstrainSelectedInstOperands,
     /*  430690 */     // GIR_Coverage, 3051,
     /*  430690 */     GIR_EraseRootFromParent_Done,
     /*  430691 */   // Label 7515: @430691
     /*  430691 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(430777), // Rule ID 3054 //
     /*  430696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  430707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  430710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  430713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430743 */     // MIs[1] Operand 1
     /*  430743 */     // No operand predicates
     /*  430743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430752 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  430752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  430755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430775 */     GIR_RootConstrainSelectedInstOperands,
     /*  430776 */     // GIR_Coverage, 3054,
     /*  430776 */     GIR_EraseRootFromParent_Done,
     /*  430777 */   // Label 7516: @430777
     /*  430777 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(430863), // Rule ID 3055 //
     /*  430782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  430793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  430796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  430799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430829 */     // MIs[1] Operand 1
     /*  430829 */     // No operand predicates
     /*  430829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  430838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  430841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  430858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430861 */     GIR_RootConstrainSelectedInstOperands,
     /*  430862 */     // GIR_Coverage, 3055,
     /*  430862 */     GIR_EraseRootFromParent_Done,
     /*  430863 */   // Label 7517: @430863
     /*  430863 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(430949), // Rule ID 3058 //
     /*  430868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  430871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  430879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  430882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  430885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  430888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  430891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  430915 */     // MIs[1] Operand 1
     /*  430915 */     // No operand predicates
     /*  430915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  430917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  430924 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  430924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  430927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  430929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  430931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  430933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  430936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  430941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  430944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  430947 */     GIR_RootConstrainSelectedInstOperands,
     /*  430948 */     // GIR_Coverage, 3058,
     /*  430948 */     GIR_EraseRootFromParent_Done,
     /*  430949 */   // Label 7518: @430949
     /*  430949 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(431035), // Rule ID 3059 //
     /*  430954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  430957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  430962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  430965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  430968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  430971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  430974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  430977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  430989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  430993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  430997 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431001 */     // MIs[1] Operand 1
     /*  431001 */     // No operand predicates
     /*  431001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431010 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  431010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431033 */     GIR_RootConstrainSelectedInstOperands,
     /*  431034 */     // GIR_Coverage, 3059,
     /*  431034 */     GIR_EraseRootFromParent_Done,
     /*  431035 */   // Label 7519: @431035
     /*  431035 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(431121), // Rule ID 3062 //
     /*  431040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431087 */     // MIs[1] Operand 1
     /*  431087 */     // No operand predicates
     /*  431087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  431096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431119 */     GIR_RootConstrainSelectedInstOperands,
     /*  431120 */     // GIR_Coverage, 3062,
     /*  431120 */     GIR_EraseRootFromParent_Done,
     /*  431121 */   // Label 7520: @431121
     /*  431121 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(431207), // Rule ID 3063 //
     /*  431126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  431137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  431140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  431143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431173 */     // MIs[1] Operand 1
     /*  431173 */     // No operand predicates
     /*  431173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  431182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  431202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431205 */     GIR_RootConstrainSelectedInstOperands,
     /*  431206 */     // GIR_Coverage, 3063,
     /*  431206 */     GIR_EraseRootFromParent_Done,
     /*  431207 */   // Label 7521: @431207
     /*  431207 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(431293), // Rule ID 3066 //
     /*  431212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  431215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431255 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431259 */     // MIs[1] Operand 1
     /*  431259 */     // No operand predicates
     /*  431259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431268 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  431268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431291 */     GIR_RootConstrainSelectedInstOperands,
     /*  431292 */     // GIR_Coverage, 3066,
     /*  431292 */     GIR_EraseRootFromParent_Done,
     /*  431293 */   // Label 7522: @431293
     /*  431293 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(431379), // Rule ID 3067 //
     /*  431298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  431301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  431309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  431312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  431315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  431333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431345 */     // MIs[1] Operand 1
     /*  431345 */     // No operand predicates
     /*  431345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431354 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  431354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1),
     /*  431357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  431374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431377 */     GIR_RootConstrainSelectedInstOperands,
     /*  431378 */     // GIR_Coverage, 3067,
     /*  431378 */     GIR_EraseRootFromParent_Done,
     /*  431379 */   // Label 7523: @431379
     /*  431379 */   GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(431465), // Rule ID 3070 //
     /*  431384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431431 */     // MIs[1] Operand 1
     /*  431431 */     // No operand predicates
     /*  431431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431440 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431463 */     GIR_RootConstrainSelectedInstOperands,
     /*  431464 */     // GIR_Coverage, 3070,
     /*  431464 */     GIR_EraseRootFromParent_Done,
     /*  431465 */   // Label 7524: @431465
     /*  431465 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(431551), // Rule ID 3071 //
     /*  431470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  431481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  431484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  431487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431517 */     // MIs[1] Operand 1
     /*  431517 */     // No operand predicates
     /*  431517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431526 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431549 */     GIR_RootConstrainSelectedInstOperands,
     /*  431550 */     // GIR_Coverage, 3071,
     /*  431550 */     GIR_EraseRootFromParent_Done,
     /*  431551 */   // Label 7525: @431551
     /*  431551 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(431637), // Rule ID 3074 //
     /*  431556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  431567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  431570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  431573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431603 */     // MIs[1] Operand 1
     /*  431603 */     // No operand predicates
     /*  431603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431612 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  431615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431635 */     GIR_RootConstrainSelectedInstOperands,
     /*  431636 */     // GIR_Coverage, 3074,
     /*  431636 */     GIR_EraseRootFromParent_Done,
     /*  431637 */   // Label 7526: @431637
     /*  431637 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(431723), // Rule ID 3075 //
     /*  431642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  431653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  431656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  431659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  431677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431685 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431689 */     // MIs[1] Operand 1
     /*  431689 */     // No operand predicates
     /*  431689 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431698 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  431701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431721 */     GIR_RootConstrainSelectedInstOperands,
     /*  431722 */     // GIR_Coverage, 3075,
     /*  431722 */     GIR_EraseRootFromParent_Done,
     /*  431723 */   // Label 7527: @431723
     /*  431723 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(431809), // Rule ID 3078 //
     /*  431728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  431739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  431742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  431745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431775 */     // MIs[1] Operand 1
     /*  431775 */     // No operand predicates
     /*  431775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431784 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  431784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  431787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431807 */     GIR_RootConstrainSelectedInstOperands,
     /*  431808 */     // GIR_Coverage, 3078,
     /*  431808 */     GIR_EraseRootFromParent_Done,
     /*  431809 */   // Label 7528: @431809
     /*  431809 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(431895), // Rule ID 3079 //
     /*  431814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  431825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  431828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  431831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  431834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  431837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  431849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431861 */     // MIs[1] Operand 1
     /*  431861 */     // No operand predicates
     /*  431861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431870 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  431870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  431873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  431890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431893 */     GIR_RootConstrainSelectedInstOperands,
     /*  431894 */     // GIR_Coverage, 3079,
     /*  431894 */     GIR_EraseRootFromParent_Done,
     /*  431895 */   // Label 7529: @431895
     /*  431895 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(431981), // Rule ID 3082 //
     /*  431900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  431903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  431911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  431914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  431917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  431920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  431923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  431935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  431939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  431943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  431947 */     // MIs[1] Operand 1
     /*  431947 */     // No operand predicates
     /*  431947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  431949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  431956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  431956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  431959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  431961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  431963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  431965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  431968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  431973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  431976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  431979 */     GIR_RootConstrainSelectedInstOperands,
     /*  431980 */     // GIR_Coverage, 3082,
     /*  431980 */     GIR_EraseRootFromParent_Done,
     /*  431981 */   // Label 7530: @431981
     /*  431981 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(432067), // Rule ID 3083 //
     /*  431986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  431989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  431994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  431997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  432000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  432003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432033 */     // MIs[1] Operand 1
     /*  432033 */     // No operand predicates
     /*  432033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432042 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432065 */     GIR_RootConstrainSelectedInstOperands,
     /*  432066 */     // GIR_Coverage, 3083,
     /*  432066 */     GIR_EraseRootFromParent_Done,
     /*  432067 */   // Label 7531: @432067
     /*  432067 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(432153), // Rule ID 3086 //
     /*  432072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432119 */     // MIs[1] Operand 1
     /*  432119 */     // No operand predicates
     /*  432119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432128 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432151 */     GIR_RootConstrainSelectedInstOperands,
     /*  432152 */     // GIR_Coverage, 3086,
     /*  432152 */     GIR_EraseRootFromParent_Done,
     /*  432153 */   // Label 7532: @432153
     /*  432153 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(432239), // Rule ID 3087 //
     /*  432158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  432169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  432172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  432175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432205 */     // MIs[1] Operand 1
     /*  432205 */     // No operand predicates
     /*  432205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432237 */     GIR_RootConstrainSelectedInstOperands,
     /*  432238 */     // GIR_Coverage, 3087,
     /*  432238 */     GIR_EraseRootFromParent_Done,
     /*  432239 */   // Label 7533: @432239
     /*  432239 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(432325), // Rule ID 3090 //
     /*  432244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432291 */     // MIs[1] Operand 1
     /*  432291 */     // No operand predicates
     /*  432291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432300 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  432300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432323 */     GIR_RootConstrainSelectedInstOperands,
     /*  432324 */     // GIR_Coverage, 3090,
     /*  432324 */     GIR_EraseRootFromParent_Done,
     /*  432325 */   // Label 7534: @432325
     /*  432325 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(432411), // Rule ID 3091 //
     /*  432330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  432341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  432344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  432347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432377 */     // MIs[1] Operand 1
     /*  432377 */     // No operand predicates
     /*  432377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432386 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  432386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  432406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432409 */     GIR_RootConstrainSelectedInstOperands,
     /*  432410 */     // GIR_Coverage, 3091,
     /*  432410 */     GIR_EraseRootFromParent_Done,
     /*  432411 */   // Label 7535: @432411
     /*  432411 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(432497), // Rule ID 3094 //
     /*  432416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432463 */     // MIs[1] Operand 1
     /*  432463 */     // No operand predicates
     /*  432463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432472 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432495 */     GIR_RootConstrainSelectedInstOperands,
     /*  432496 */     // GIR_Coverage, 3094,
     /*  432496 */     GIR_EraseRootFromParent_Done,
     /*  432497 */   // Label 7536: @432497
     /*  432497 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(432583), // Rule ID 3095 //
     /*  432502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  432513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  432516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  432519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432549 */     // MIs[1] Operand 1
     /*  432549 */     // No operand predicates
     /*  432549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432558 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432581 */     GIR_RootConstrainSelectedInstOperands,
     /*  432582 */     // GIR_Coverage, 3095,
     /*  432582 */     GIR_EraseRootFromParent_Done,
     /*  432583 */   // Label 7537: @432583
     /*  432583 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(432669), // Rule ID 3098 //
     /*  432588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  432599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  432602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  432605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432635 */     // MIs[1] Operand 1
     /*  432635 */     // No operand predicates
     /*  432635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432667 */     GIR_RootConstrainSelectedInstOperands,
     /*  432668 */     // GIR_Coverage, 3098,
     /*  432668 */     GIR_EraseRootFromParent_Done,
     /*  432669 */   // Label 7538: @432669
     /*  432669 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(432755), // Rule ID 3099 //
     /*  432674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  432685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  432688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  432691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  432709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432717 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432721 */     // MIs[1] Operand 1
     /*  432721 */     // No operand predicates
     /*  432721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432730 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  432733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432753 */     GIR_RootConstrainSelectedInstOperands,
     /*  432754 */     // GIR_Coverage, 3099,
     /*  432754 */     GIR_EraseRootFromParent_Done,
     /*  432755 */   // Label 7539: @432755
     /*  432755 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(432841), // Rule ID 3102 //
     /*  432760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  432763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  432771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  432774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  432777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432807 */     // MIs[1] Operand 1
     /*  432807 */     // No operand predicates
     /*  432807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432816 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  432816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432839 */     GIR_RootConstrainSelectedInstOperands,
     /*  432840 */     // GIR_Coverage, 3102,
     /*  432840 */     GIR_EraseRootFromParent_Done,
     /*  432841 */   // Label 7540: @432841
     /*  432841 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(432927), // Rule ID 3103 //
     /*  432846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  432849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  432857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  432860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  432863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  432866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  432869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  432881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432893 */     // MIs[1] Operand 1
     /*  432893 */     // No operand predicates
     /*  432893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432902 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  432902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  432905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  432914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  432919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  432922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  432925 */     GIR_RootConstrainSelectedInstOperands,
     /*  432926 */     // GIR_Coverage, 3103,
     /*  432926 */     GIR_EraseRootFromParent_Done,
     /*  432927 */   // Label 7541: @432927
     /*  432927 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(433013), // Rule ID 3106 //
     /*  432932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  432935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  432940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  432943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  432946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  432949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  432952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  432955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  432967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  432971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  432975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  432979 */     // MIs[1] Operand 1
     /*  432979 */     // No operand predicates
     /*  432979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  432981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  432988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  432988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  432991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  432993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  432995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  432997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433011 */     GIR_RootConstrainSelectedInstOperands,
     /*  433012 */     // GIR_Coverage, 3106,
     /*  433012 */     GIR_EraseRootFromParent_Done,
     /*  433013 */   // Label 7542: @433013
     /*  433013 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(433099), // Rule ID 3107 //
     /*  433018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  433029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  433032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  433035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  433053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433065 */     // MIs[1] Operand 1
     /*  433065 */     // No operand predicates
     /*  433065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433074 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2),
     /*  433077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433097 */     GIR_RootConstrainSelectedInstOperands,
     /*  433098 */     // GIR_Coverage, 3107,
     /*  433098 */     GIR_EraseRootFromParent_Done,
     /*  433099 */   // Label 7543: @433099
     /*  433099 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(433185), // Rule ID 3110 //
     /*  433104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433147 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433151 */     // MIs[1] Operand 1
     /*  433151 */     // No operand predicates
     /*  433151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433160 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433183 */     GIR_RootConstrainSelectedInstOperands,
     /*  433184 */     // GIR_Coverage, 3110,
     /*  433184 */     GIR_EraseRootFromParent_Done,
     /*  433185 */   // Label 7544: @433185
     /*  433185 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(433271), // Rule ID 3111 //
     /*  433190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  433201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  433204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  433207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  433225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433237 */     // MIs[1] Operand 1
     /*  433237 */     // No operand predicates
     /*  433237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433246 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4),
     /*  433249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433269 */     GIR_RootConstrainSelectedInstOperands,
     /*  433270 */     // GIR_Coverage, 3111,
     /*  433270 */     GIR_EraseRootFromParent_Done,
     /*  433271 */   // Label 7545: @433271
     /*  433271 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(433357), // Rule ID 3114 //
     /*  433276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  433279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433323 */     // MIs[1] Operand 1
     /*  433323 */     // No operand predicates
     /*  433323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433332 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  433332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433355 */     GIR_RootConstrainSelectedInstOperands,
     /*  433356 */     // GIR_Coverage, 3114,
     /*  433356 */     GIR_EraseRootFromParent_Done,
     /*  433357 */   // Label 7546: @433357
     /*  433357 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(433443), // Rule ID 3115 //
     /*  433362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  433365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  433370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  433373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  433376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  433379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  433397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433409 */     // MIs[1] Operand 1
     /*  433409 */     // No operand predicates
     /*  433409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433418 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  433418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8),
     /*  433421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  433438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433441 */     GIR_RootConstrainSelectedInstOperands,
     /*  433442 */     // GIR_Coverage, 3115,
     /*  433442 */     GIR_EraseRootFromParent_Done,
     /*  433443 */   // Label 7547: @433443
     /*  433443 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(433529), // Rule ID 3382 //
     /*  433448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  433459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  433462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  433465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433491 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433495 */     // MIs[1] Operand 1
     /*  433495 */     // No operand predicates
     /*  433495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  433504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  433507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433527 */     GIR_RootConstrainSelectedInstOperands,
     /*  433528 */     // GIR_Coverage, 3382,
     /*  433528 */     GIR_EraseRootFromParent_Done,
     /*  433529 */   // Label 7548: @433529
     /*  433529 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(433615), // Rule ID 3383 //
     /*  433534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  433545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  433548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  433551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433581 */     // MIs[1] Operand 1
     /*  433581 */     // No operand predicates
     /*  433581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433590 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  433590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8),
     /*  433593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433613 */     GIR_RootConstrainSelectedInstOperands,
     /*  433614 */     // GIR_Coverage, 3383,
     /*  433614 */     GIR_EraseRootFromParent_Done,
     /*  433615 */   // Label 7549: @433615
     /*  433615 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(433701), // Rule ID 3386 //
     /*  433620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  433631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  433634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  433637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433667 */     // MIs[1] Operand 1
     /*  433667 */     // No operand predicates
     /*  433667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433676 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  433676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  433679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433699 */     GIR_RootConstrainSelectedInstOperands,
     /*  433700 */     // GIR_Coverage, 3386,
     /*  433700 */     GIR_EraseRootFromParent_Done,
     /*  433701 */   // Label 7550: @433701
     /*  433701 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(433787), // Rule ID 3387 //
     /*  433706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  433717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  433720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  433723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433753 */     // MIs[1] Operand 1
     /*  433753 */     // No operand predicates
     /*  433753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433762 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  433762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  433765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433785 */     GIR_RootConstrainSelectedInstOperands,
     /*  433786 */     // GIR_Coverage, 3387,
     /*  433786 */     GIR_EraseRootFromParent_Done,
     /*  433787 */   // Label 7551: @433787
     /*  433787 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(433873), // Rule ID 3390 //
     /*  433792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  433803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  433806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  433809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433839 */     // MIs[1] Operand 1
     /*  433839 */     // No operand predicates
     /*  433839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433848 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  433848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  433851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433871 */     GIR_RootConstrainSelectedInstOperands,
     /*  433872 */     // GIR_Coverage, 3390,
     /*  433872 */     GIR_EraseRootFromParent_Done,
     /*  433873 */   // Label 7552: @433873
     /*  433873 */   GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(433959), // Rule ID 3391 //
     /*  433878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  433881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  433889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  433892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  433895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  433898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  433901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  433917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  433921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  433925 */     // MIs[1] Operand 1
     /*  433925 */     // No operand predicates
     /*  433925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  433927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  433934 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  433934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  433937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  433939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  433941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  433943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  433946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  433951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  433954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  433957 */     GIR_RootConstrainSelectedInstOperands,
     /*  433958 */     // GIR_Coverage, 3391,
     /*  433958 */     GIR_EraseRootFromParent_Done,
     /*  433959 */   // Label 7553: @433959
     /*  433959 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(434045), // Rule ID 3394 //
     /*  433964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  433967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  433972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  433975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  433978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  433981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  433984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  433987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  433999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434011 */     // MIs[1] Operand 1
     /*  434011 */     // No operand predicates
     /*  434011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434020 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434043 */     GIR_RootConstrainSelectedInstOperands,
     /*  434044 */     // GIR_Coverage, 3394,
     /*  434044 */     GIR_EraseRootFromParent_Done,
     /*  434045 */   // Label 7554: @434045
     /*  434045 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(434131), // Rule ID 3395 //
     /*  434050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  434061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  434064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  434067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434097 */     // MIs[1] Operand 1
     /*  434097 */     // No operand predicates
     /*  434097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4),
     /*  434109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434129 */     GIR_RootConstrainSelectedInstOperands,
     /*  434130 */     // GIR_Coverage, 3395,
     /*  434130 */     GIR_EraseRootFromParent_Done,
     /*  434131 */   // Label 7555: @434131
     /*  434131 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(434217), // Rule ID 3398 //
     /*  434136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434179 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434183 */     // MIs[1] Operand 1
     /*  434183 */     // No operand predicates
     /*  434183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434192 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434215 */     GIR_RootConstrainSelectedInstOperands,
     /*  434216 */     // GIR_Coverage, 3398,
     /*  434216 */     GIR_EraseRootFromParent_Done,
     /*  434217 */   // Label 7556: @434217
     /*  434217 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(434303), // Rule ID 3399 //
     /*  434222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  434233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  434236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  434239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434269 */     // MIs[1] Operand 1
     /*  434269 */     // No operand predicates
     /*  434269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434278 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434301 */     GIR_RootConstrainSelectedInstOperands,
     /*  434302 */     // GIR_Coverage, 3399,
     /*  434302 */     GIR_EraseRootFromParent_Done,
     /*  434303 */   // Label 7557: @434303
     /*  434303 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(434389), // Rule ID 3402 //
     /*  434308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434355 */     // MIs[1] Operand 1
     /*  434355 */     // No operand predicates
     /*  434355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434364 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434387 */     GIR_RootConstrainSelectedInstOperands,
     /*  434388 */     // GIR_Coverage, 3402,
     /*  434388 */     GIR_EraseRootFromParent_Done,
     /*  434389 */   // Label 7558: @434389
     /*  434389 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(434475), // Rule ID 3403 //
     /*  434394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  434405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  434408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  434411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434441 */     // MIs[1] Operand 1
     /*  434441 */     // No operand predicates
     /*  434441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434450 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2),
     /*  434453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434473 */     GIR_RootConstrainSelectedInstOperands,
     /*  434474 */     // GIR_Coverage, 3403,
     /*  434474 */     GIR_EraseRootFromParent_Done,
     /*  434475 */   // Label 7559: @434475
     /*  434475 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(434561), // Rule ID 3406 //
     /*  434480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  434491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  434494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  434497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434527 */     // MIs[1] Operand 1
     /*  434527 */     // No operand predicates
     /*  434527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  434536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434559 */     GIR_RootConstrainSelectedInstOperands,
     /*  434560 */     // GIR_Coverage, 3406,
     /*  434560 */     GIR_EraseRootFromParent_Done,
     /*  434561 */   // Label 7560: @434561
     /*  434561 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(434647), // Rule ID 3407 //
     /*  434566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  434577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  434580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  434583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434609 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434613 */     // MIs[1] Operand 1
     /*  434613 */     // No operand predicates
     /*  434613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  434622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  434642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434645 */     GIR_RootConstrainSelectedInstOperands,
     /*  434646 */     // GIR_Coverage, 3407,
     /*  434646 */     GIR_EraseRootFromParent_Done,
     /*  434647 */   // Label 7561: @434647
     /*  434647 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(434733), // Rule ID 3410 //
     /*  434652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  434663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  434666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  434669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434699 */     // MIs[1] Operand 1
     /*  434699 */     // No operand predicates
     /*  434699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  434708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434731 */     GIR_RootConstrainSelectedInstOperands,
     /*  434732 */     // GIR_Coverage, 3410,
     /*  434732 */     GIR_EraseRootFromParent_Done,
     /*  434733 */   // Label 7562: @434733
     /*  434733 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(434819), // Rule ID 3411 //
     /*  434738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  434749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  434752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  434755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434785 */     // MIs[1] Operand 1
     /*  434785 */     // No operand predicates
     /*  434785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  434794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  434814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434817 */     GIR_RootConstrainSelectedInstOperands,
     /*  434818 */     // GIR_Coverage, 3411,
     /*  434818 */     GIR_EraseRootFromParent_Done,
     /*  434819 */   // Label 7563: @434819
     /*  434819 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(434905), // Rule ID 3414 //
     /*  434824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  434827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  434835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  434838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  434841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  434844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  434847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434871 */     // MIs[1] Operand 1
     /*  434871 */     // No operand predicates
     /*  434871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  434880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434903 */     GIR_RootConstrainSelectedInstOperands,
     /*  434904 */     // GIR_Coverage, 3414,
     /*  434904 */     GIR_EraseRootFromParent_Done,
     /*  434905 */   // Label 7564: @434905
     /*  434905 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(434991), // Rule ID 3415 //
     /*  434910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  434913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  434918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  434921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  434924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  434927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  434930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  434933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  434945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  434949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  434953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  434957 */     // MIs[1] Operand 1
     /*  434957 */     // No operand predicates
     /*  434957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  434959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  434966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  434966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  434969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  434971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  434973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  434975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  434978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  434983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  434986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  434989 */     GIR_RootConstrainSelectedInstOperands,
     /*  434990 */     // GIR_Coverage, 3415,
     /*  434990 */     GIR_EraseRootFromParent_Done,
     /*  434991 */   // Label 7565: @434991
     /*  434991 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(435077), // Rule ID 3418 //
     /*  434996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  434999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435043 */     // MIs[1] Operand 1
     /*  435043 */     // No operand predicates
     /*  435043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  435052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435075 */     GIR_RootConstrainSelectedInstOperands,
     /*  435076 */     // GIR_Coverage, 3418,
     /*  435076 */     GIR_EraseRootFromParent_Done,
     /*  435077 */   // Label 7566: @435077
     /*  435077 */   GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(435163), // Rule ID 3419 //
     /*  435082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  435085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  435093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  435096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  435099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  435117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435129 */     // MIs[1] Operand 1
     /*  435129 */     // No operand predicates
     /*  435129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435138 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  435138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1),
     /*  435141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  435158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435161 */     GIR_RootConstrainSelectedInstOperands,
     /*  435162 */     // GIR_Coverage, 3419,
     /*  435162 */     GIR_EraseRootFromParent_Done,
     /*  435163 */   // Label 7567: @435163
     /*  435163 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(435249), // Rule ID 3422 //
     /*  435168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435215 */     // MIs[1] Operand 1
     /*  435215 */     // No operand predicates
     /*  435215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435247 */     GIR_RootConstrainSelectedInstOperands,
     /*  435248 */     // GIR_Coverage, 3422,
     /*  435248 */     GIR_EraseRootFromParent_Done,
     /*  435249 */   // Label 7568: @435249
     /*  435249 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(435335), // Rule ID 3423 //
     /*  435254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  435265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  435268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  435271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435297 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435301 */     // MIs[1] Operand 1
     /*  435301 */     // No operand predicates
     /*  435301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435310 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435333 */     GIR_RootConstrainSelectedInstOperands,
     /*  435334 */     // GIR_Coverage, 3423,
     /*  435334 */     GIR_EraseRootFromParent_Done,
     /*  435335 */   // Label 7569: @435335
     /*  435335 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(435421), // Rule ID 3426 //
     /*  435340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435387 */     // MIs[1] Operand 1
     /*  435387 */     // No operand predicates
     /*  435387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435396 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435419 */     GIR_RootConstrainSelectedInstOperands,
     /*  435420 */     // GIR_Coverage, 3426,
     /*  435420 */     GIR_EraseRootFromParent_Done,
     /*  435421 */   // Label 7570: @435421
     /*  435421 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(435507), // Rule ID 3427 //
     /*  435426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  435437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  435440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  435443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435473 */     // MIs[1] Operand 1
     /*  435473 */     // No operand predicates
     /*  435473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435482 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435505 */     GIR_RootConstrainSelectedInstOperands,
     /*  435506 */     // GIR_Coverage, 3427,
     /*  435506 */     GIR_EraseRootFromParent_Done,
     /*  435507 */   // Label 7571: @435507
     /*  435507 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(435593), // Rule ID 3430 //
     /*  435512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  435523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  435526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  435529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435559 */     // MIs[1] Operand 1
     /*  435559 */     // No operand predicates
     /*  435559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435568 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  435568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  435571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435591 */     GIR_RootConstrainSelectedInstOperands,
     /*  435592 */     // GIR_Coverage, 3430,
     /*  435592 */     GIR_EraseRootFromParent_Done,
     /*  435593 */   // Label 7572: @435593
     /*  435593 */   GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(435679), // Rule ID 3431 //
     /*  435598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  435609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  435612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  435615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  435633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435645 */     // MIs[1] Operand 1
     /*  435645 */     // No operand predicates
     /*  435645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435654 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  435654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  435657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  435674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435677 */     GIR_RootConstrainSelectedInstOperands,
     /*  435678 */     // GIR_Coverage, 3431,
     /*  435678 */     GIR_EraseRootFromParent_Done,
     /*  435679 */   // Label 7573: @435679
     /*  435679 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(435765), // Rule ID 3434 //
     /*  435684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  435695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  435698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  435701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435731 */     // MIs[1] Operand 1
     /*  435731 */     // No operand predicates
     /*  435731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435740 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435763 */     GIR_RootConstrainSelectedInstOperands,
     /*  435764 */     // GIR_Coverage, 3434,
     /*  435764 */     GIR_EraseRootFromParent_Done,
     /*  435765 */   // Label 7574: @435765
     /*  435765 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(435851), // Rule ID 3435 //
     /*  435770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  435781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  435784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  435787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  435805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435817 */     // MIs[1] Operand 1
     /*  435817 */     // No operand predicates
     /*  435817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  435829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435849 */     GIR_RootConstrainSelectedInstOperands,
     /*  435850 */     // GIR_Coverage, 3435,
     /*  435850 */     GIR_EraseRootFromParent_Done,
     /*  435851 */   // Label 7575: @435851
     /*  435851 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(435937), // Rule ID 3438 //
     /*  435856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  435859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  435867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  435870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  435873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  435876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  435879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435903 */     // MIs[1] Operand 1
     /*  435903 */     // No operand predicates
     /*  435903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  435912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  435915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  435917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  435919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  435921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  435924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  435929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  435932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  435935 */     GIR_RootConstrainSelectedInstOperands,
     /*  435936 */     // GIR_Coverage, 3438,
     /*  435936 */     GIR_EraseRootFromParent_Done,
     /*  435937 */   // Label 7576: @435937
     /*  435937 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(436023), // Rule ID 3439 //
     /*  435942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  435945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  435950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  435953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  435956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  435959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  435962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  435965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  435977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  435981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  435985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  435989 */     // MIs[1] Operand 1
     /*  435989 */     // No operand predicates
     /*  435989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  435991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  435998 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  435998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436021 */     GIR_RootConstrainSelectedInstOperands,
     /*  436022 */     // GIR_Coverage, 3439,
     /*  436022 */     GIR_EraseRootFromParent_Done,
     /*  436023 */   // Label 7577: @436023
     /*  436023 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(436109), // Rule ID 3442 //
     /*  436028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436075 */     // MIs[1] Operand 1
     /*  436075 */     // No operand predicates
     /*  436075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436084 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  436084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436107 */     GIR_RootConstrainSelectedInstOperands,
     /*  436108 */     // GIR_Coverage, 3442,
     /*  436108 */     GIR_EraseRootFromParent_Done,
     /*  436109 */   // Label 7578: @436109
     /*  436109 */   GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(436195), // Rule ID 3443 //
     /*  436114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  436125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  436128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  436131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436161 */     // MIs[1] Operand 1
     /*  436161 */     // No operand predicates
     /*  436161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436170 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  436170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  436190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436193 */     GIR_RootConstrainSelectedInstOperands,
     /*  436194 */     // GIR_Coverage, 3443,
     /*  436194 */     GIR_EraseRootFromParent_Done,
     /*  436195 */   // Label 7579: @436195
     /*  436195 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(436281), // Rule ID 3446 //
     /*  436200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436247 */     // MIs[1] Operand 1
     /*  436247 */     // No operand predicates
     /*  436247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436279 */     GIR_RootConstrainSelectedInstOperands,
     /*  436280 */     // GIR_Coverage, 3446,
     /*  436280 */     GIR_EraseRootFromParent_Done,
     /*  436281 */   // Label 7580: @436281
     /*  436281 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(436367), // Rule ID 3447 //
     /*  436286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  436297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  436300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  436303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436329 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436333 */     // MIs[1] Operand 1
     /*  436333 */     // No operand predicates
     /*  436333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436365 */     GIR_RootConstrainSelectedInstOperands,
     /*  436366 */     // GIR_Coverage, 3447,
     /*  436366 */     GIR_EraseRootFromParent_Done,
     /*  436367 */   // Label 7581: @436367
     /*  436367 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(436453), // Rule ID 3450 //
     /*  436372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436419 */     // MIs[1] Operand 1
     /*  436419 */     // No operand predicates
     /*  436419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436451 */     GIR_RootConstrainSelectedInstOperands,
     /*  436452 */     // GIR_Coverage, 3450,
     /*  436452 */     GIR_EraseRootFromParent_Done,
     /*  436453 */   // Label 7582: @436453
     /*  436453 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(436539), // Rule ID 3451 //
     /*  436458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  436469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  436472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  436475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436505 */     // MIs[1] Operand 1
     /*  436505 */     // No operand predicates
     /*  436505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436537 */     GIR_RootConstrainSelectedInstOperands,
     /*  436538 */     // GIR_Coverage, 3451,
     /*  436538 */     GIR_EraseRootFromParent_Done,
     /*  436539 */   // Label 7583: @436539
     /*  436539 */   GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(436625), // Rule ID 3454 //
     /*  436544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  436547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  436555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  436558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  436561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436591 */     // MIs[1] Operand 1
     /*  436591 */     // No operand predicates
     /*  436591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  436600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436623 */     GIR_RootConstrainSelectedInstOperands,
     /*  436624 */     // GIR_Coverage, 3454,
     /*  436624 */     GIR_EraseRootFromParent_Done,
     /*  436625 */   // Label 7584: @436625
     /*  436625 */   GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(436711), // Rule ID 3455 //
     /*  436630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  436633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  436641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  436644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  436647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  436665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436677 */     // MIs[1] Operand 1
     /*  436677 */     // No operand predicates
     /*  436677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  436686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  436689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  436706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436709 */     GIR_RootConstrainSelectedInstOperands,
     /*  436710 */     // GIR_Coverage, 3455,
     /*  436710 */     GIR_EraseRootFromParent_Done,
     /*  436711 */   // Label 7585: @436711
     /*  436711 */   GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(436797), // Rule ID 3458 //
     /*  436716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  436719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  436727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  436730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  436733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436763 */     // MIs[1] Operand 1
     /*  436763 */     // No operand predicates
     /*  436763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  436772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436795 */     GIR_RootConstrainSelectedInstOperands,
     /*  436796 */     // GIR_Coverage, 3458,
     /*  436796 */     GIR_EraseRootFromParent_Done,
     /*  436797 */   // Label 7586: @436797
     /*  436797 */   GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(436883), // Rule ID 3459 //
     /*  436802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  436805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  436813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  436816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  436819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  436837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436849 */     // MIs[1] Operand 1
     /*  436849 */     // No operand predicates
     /*  436849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  436858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2),
     /*  436861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436881 */     GIR_RootConstrainSelectedInstOperands,
     /*  436882 */     // GIR_Coverage, 3459,
     /*  436882 */     GIR_EraseRootFromParent_Done,
     /*  436883 */   // Label 7587: @436883
     /*  436883 */   GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(436969), // Rule ID 3462 //
     /*  436888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  436891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  436899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  436902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  436905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  436908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  436911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  436923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  436927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  436931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  436935 */     // MIs[1] Operand 1
     /*  436935 */     // No operand predicates
     /*  436935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  436937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  436944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  436944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  436947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  436949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  436951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  436953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  436956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  436961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  436964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  436967 */     GIR_RootConstrainSelectedInstOperands,
     /*  436968 */     // GIR_Coverage, 3462,
     /*  436968 */     GIR_EraseRootFromParent_Done,
     /*  436969 */   // Label 7588: @436969
     /*  436969 */   GIM_Try, /*On fail goto*//*Label 7589*/ GIMT_Encode4(437055), // Rule ID 3463 //
     /*  436974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  436977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  436982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  436985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  436988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  436991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  436994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  436997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  437009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437017 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437021 */     // MIs[1] Operand 1
     /*  437021 */     // No operand predicates
     /*  437021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4),
     /*  437033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437053 */     GIR_RootConstrainSelectedInstOperands,
     /*  437054 */     // GIR_Coverage, 3463,
     /*  437054 */     GIR_EraseRootFromParent_Done,
     /*  437055 */   // Label 7589: @437055
     /*  437055 */   GIM_Try, /*On fail goto*//*Label 7590*/ GIMT_Encode4(437141), // Rule ID 3466 //
     /*  437060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  437063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437107 */     // MIs[1] Operand 1
     /*  437107 */     // No operand predicates
     /*  437107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  437116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437139 */     GIR_RootConstrainSelectedInstOperands,
     /*  437140 */     // GIR_Coverage, 3466,
     /*  437140 */     GIR_EraseRootFromParent_Done,
     /*  437141 */   // Label 7590: @437141
     /*  437141 */   GIM_Try, /*On fail goto*//*Label 7591*/ GIMT_Encode4(437227), // Rule ID 3467 //
     /*  437146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  437149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  437154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  437157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  437160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  437163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  437181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437193 */     // MIs[1] Operand 1
     /*  437193 */     // No operand predicates
     /*  437193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  437202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8),
     /*  437205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  437222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437225 */     GIR_RootConstrainSelectedInstOperands,
     /*  437226 */     // GIR_Coverage, 3467,
     /*  437226 */     GIR_EraseRootFromParent_Done,
     /*  437227 */   // Label 7591: @437227
     /*  437227 */   GIM_Try, /*On fail goto*//*Label 7592*/ GIMT_Encode4(437313), // Rule ID 5830 //
     /*  437232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437279 */     // MIs[1] Operand 1
     /*  437279 */     // No operand predicates
     /*  437279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437288 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437311 */     GIR_RootConstrainSelectedInstOperands,
     /*  437312 */     // GIR_Coverage, 5830,
     /*  437312 */     GIR_EraseRootFromParent_Done,
     /*  437313 */   // Label 7592: @437313
     /*  437313 */   GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(437399), // Rule ID 5831 //
     /*  437318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  437329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  437332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  437335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437365 */     // MIs[1] Operand 1
     /*  437365 */     // No operand predicates
     /*  437365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437374 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8),
     /*  437377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437397 */     GIR_RootConstrainSelectedInstOperands,
     /*  437398 */     // GIR_Coverage, 5831,
     /*  437398 */     GIR_EraseRootFromParent_Done,
     /*  437399 */   // Label 7593: @437399
     /*  437399 */   GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(437485), // Rule ID 5834 //
     /*  437404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437447 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437451 */     // MIs[1] Operand 1
     /*  437451 */     // No operand predicates
     /*  437451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437460 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437483 */     GIR_RootConstrainSelectedInstOperands,
     /*  437484 */     // GIR_Coverage, 5834,
     /*  437484 */     GIR_EraseRootFromParent_Done,
     /*  437485 */   // Label 7594: @437485
     /*  437485 */   GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(437571), // Rule ID 5835 //
     /*  437490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  437501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  437504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  437507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437537 */     // MIs[1] Operand 1
     /*  437537 */     // No operand predicates
     /*  437537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437546 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437569 */     GIR_RootConstrainSelectedInstOperands,
     /*  437570 */     // GIR_Coverage, 5835,
     /*  437570 */     GIR_EraseRootFromParent_Done,
     /*  437571 */   // Label 7595: @437571
     /*  437571 */   GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(437657), // Rule ID 5838 //
     /*  437576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  437587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  437590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  437593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437623 */     // MIs[1] Operand 1
     /*  437623 */     // No operand predicates
     /*  437623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437632 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  437632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  437635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437655 */     GIR_RootConstrainSelectedInstOperands,
     /*  437656 */     // GIR_Coverage, 5838,
     /*  437656 */     GIR_EraseRootFromParent_Done,
     /*  437657 */   // Label 7596: @437657
     /*  437657 */   GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(437743), // Rule ID 5839 //
     /*  437662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  437673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  437676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  437679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437709 */     // MIs[1] Operand 1
     /*  437709 */     // No operand predicates
     /*  437709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437718 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  437718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  437721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  437738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437741 */     GIR_RootConstrainSelectedInstOperands,
     /*  437742 */     // GIR_Coverage, 5839,
     /*  437742 */     GIR_EraseRootFromParent_Done,
     /*  437743 */   // Label 7597: @437743
     /*  437743 */   GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(437829), // Rule ID 5842 //
     /*  437748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  437759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  437762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  437765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437791 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437795 */     // MIs[1] Operand 1
     /*  437795 */     // No operand predicates
     /*  437795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437804 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  437804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437827 */     GIR_RootConstrainSelectedInstOperands,
     /*  437828 */     // GIR_Coverage, 5842,
     /*  437828 */     GIR_EraseRootFromParent_Done,
     /*  437829 */   // Label 7598: @437829
     /*  437829 */   GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(437915), // Rule ID 5843 //
     /*  437834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  437837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  437845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  437848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  437851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  437854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  437857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437881 */     // MIs[1] Operand 1
     /*  437881 */     // No operand predicates
     /*  437881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437890 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  437890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4),
     /*  437893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437913 */     GIR_RootConstrainSelectedInstOperands,
     /*  437914 */     // GIR_Coverage, 5843,
     /*  437914 */     GIR_EraseRootFromParent_Done,
     /*  437915 */   // Label 7599: @437915
     /*  437915 */   GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(438001), // Rule ID 5846 //
     /*  437920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  437923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  437928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  437931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  437934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  437937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  437940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  437943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  437955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  437959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  437963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  437967 */     // MIs[1] Operand 1
     /*  437967 */     // No operand predicates
     /*  437967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  437969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  437976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  437976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  437979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  437981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  437983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  437985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  437988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  437993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  437996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  437999 */     GIR_RootConstrainSelectedInstOperands,
     /*  438000 */     // GIR_Coverage, 5846,
     /*  438000 */     GIR_EraseRootFromParent_Done,
     /*  438001 */   // Label 7600: @438001
     /*  438001 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(438087), // Rule ID 5847 //
     /*  438006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  438017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  438020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  438023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438053 */     // MIs[1] Operand 1
     /*  438053 */     // No operand predicates
     /*  438053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438062 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438085 */     GIR_RootConstrainSelectedInstOperands,
     /*  438086 */     // GIR_Coverage, 5847,
     /*  438086 */     GIR_EraseRootFromParent_Done,
     /*  438087 */   // Label 7601: @438087
     /*  438087 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(438173), // Rule ID 5850 //
     /*  438092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438135 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438139 */     // MIs[1] Operand 1
     /*  438139 */     // No operand predicates
     /*  438139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438171 */     GIR_RootConstrainSelectedInstOperands,
     /*  438172 */     // GIR_Coverage, 5850,
     /*  438172 */     GIR_EraseRootFromParent_Done,
     /*  438173 */   // Label 7602: @438173
     /*  438173 */   GIM_Try, /*On fail goto*//*Label 7603*/ GIMT_Encode4(438259), // Rule ID 5851 //
     /*  438178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  438189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  438192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  438195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438225 */     // MIs[1] Operand 1
     /*  438225 */     // No operand predicates
     /*  438225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2),
     /*  438237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438257 */     GIR_RootConstrainSelectedInstOperands,
     /*  438258 */     // GIR_Coverage, 5851,
     /*  438258 */     GIR_EraseRootFromParent_Done,
     /*  438259 */   // Label 7603: @438259
     /*  438259 */   GIM_Try, /*On fail goto*//*Label 7604*/ GIMT_Encode4(438345), // Rule ID 5854 //
     /*  438264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438311 */     // MIs[1] Operand 1
     /*  438311 */     // No operand predicates
     /*  438311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438320 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  438320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438343 */     GIR_RootConstrainSelectedInstOperands,
     /*  438344 */     // GIR_Coverage, 5854,
     /*  438344 */     GIR_EraseRootFromParent_Done,
     /*  438345 */   // Label 7604: @438345
     /*  438345 */   GIM_Try, /*On fail goto*//*Label 7605*/ GIMT_Encode4(438431), // Rule ID 5855 //
     /*  438350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  438361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  438364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  438367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438397 */     // MIs[1] Operand 1
     /*  438397 */     // No operand predicates
     /*  438397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438406 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  438406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  438426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438429 */     GIR_RootConstrainSelectedInstOperands,
     /*  438430 */     // GIR_Coverage, 5855,
     /*  438430 */     GIR_EraseRootFromParent_Done,
     /*  438431 */   // Label 7605: @438431
     /*  438431 */   GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(438517), // Rule ID 5858 //
     /*  438436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  438453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438483 */     // MIs[1] Operand 1
     /*  438483 */     // No operand predicates
     /*  438483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438492 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  438492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438515 */     GIR_RootConstrainSelectedInstOperands,
     /*  438516 */     // GIR_Coverage, 5858,
     /*  438516 */     GIR_EraseRootFromParent_Done,
     /*  438517 */   // Label 7606: @438517
     /*  438517 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(438603), // Rule ID 5859 //
     /*  438522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  438533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  438536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  438539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438565 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438569 */     // MIs[1] Operand 1
     /*  438569 */     // No operand predicates
     /*  438569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438578 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  438578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  438598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438601 */     GIR_RootConstrainSelectedInstOperands,
     /*  438602 */     // GIR_Coverage, 5859,
     /*  438602 */     GIR_EraseRootFromParent_Done,
     /*  438603 */   // Label 7607: @438603
     /*  438603 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(438689), // Rule ID 5862 //
     /*  438608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  438619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  438622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  438625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438655 */     // MIs[1] Operand 1
     /*  438655 */     // No operand predicates
     /*  438655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  438664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438687 */     GIR_RootConstrainSelectedInstOperands,
     /*  438688 */     // GIR_Coverage, 5862,
     /*  438688 */     GIR_EraseRootFromParent_Done,
     /*  438689 */   // Label 7608: @438689
     /*  438689 */   GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(438775), // Rule ID 5863 //
     /*  438694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  438697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  438705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  438708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  438711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438741 */     // MIs[1] Operand 1
     /*  438741 */     // No operand predicates
     /*  438741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  438750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  438770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438773 */     GIR_RootConstrainSelectedInstOperands,
     /*  438774 */     // GIR_Coverage, 5863,
     /*  438774 */     GIR_EraseRootFromParent_Done,
     /*  438775 */   // Label 7609: @438775
     /*  438775 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(438861), // Rule ID 5866 //
     /*  438780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  438783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  438791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  438794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  438797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438827 */     // MIs[1] Operand 1
     /*  438827 */     // No operand predicates
     /*  438827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  438836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438859 */     GIR_RootConstrainSelectedInstOperands,
     /*  438860 */     // GIR_Coverage, 5866,
     /*  438860 */     GIR_EraseRootFromParent_Done,
     /*  438861 */   // Label 7610: @438861
     /*  438861 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(438947), // Rule ID 5867 //
     /*  438866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  438869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  438877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  438880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  438883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  438886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  438889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  438901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438909 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438913 */     // MIs[1] Operand 1
     /*  438913 */     // No operand predicates
     /*  438913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  438915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  438922 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  438922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1),
     /*  438925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  438927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  438929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  438931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  438934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  438939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  438942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  438945 */     GIR_RootConstrainSelectedInstOperands,
     /*  438946 */     // GIR_Coverage, 5867,
     /*  438946 */     GIR_EraseRootFromParent_Done,
     /*  438947 */   // Label 7611: @438947
     /*  438947 */   GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(439033), // Rule ID 5870 //
     /*  438952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  438955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  438960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  438963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  438966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  438969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  438972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  438975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  438987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  438991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  438995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  438999 */     // MIs[1] Operand 1
     /*  438999 */     // No operand predicates
     /*  438999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439008 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439031 */     GIR_RootConstrainSelectedInstOperands,
     /*  439032 */     // GIR_Coverage, 5870,
     /*  439032 */     GIR_EraseRootFromParent_Done,
     /*  439033 */   // Label 7612: @439033
     /*  439033 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(439119), // Rule ID 5871 //
     /*  439038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  439049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  439052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  439055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439085 */     // MIs[1] Operand 1
     /*  439085 */     // No operand predicates
     /*  439085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439094 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439117 */     GIR_RootConstrainSelectedInstOperands,
     /*  439118 */     // GIR_Coverage, 5871,
     /*  439118 */     GIR_EraseRootFromParent_Done,
     /*  439119 */   // Label 7613: @439119
     /*  439119 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(439205), // Rule ID 5874 //
     /*  439124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439171 */     // MIs[1] Operand 1
     /*  439171 */     // No operand predicates
     /*  439171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439180 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439203 */     GIR_RootConstrainSelectedInstOperands,
     /*  439204 */     // GIR_Coverage, 5874,
     /*  439204 */     GIR_EraseRootFromParent_Done,
     /*  439205 */   // Label 7614: @439205
     /*  439205 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(439291), // Rule ID 5875 //
     /*  439210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  439221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  439224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  439227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439257 */     // MIs[1] Operand 1
     /*  439257 */     // No operand predicates
     /*  439257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439266 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439289 */     GIR_RootConstrainSelectedInstOperands,
     /*  439290 */     // GIR_Coverage, 5875,
     /*  439290 */     GIR_EraseRootFromParent_Done,
     /*  439291 */   // Label 7615: @439291
     /*  439291 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(439377), // Rule ID 5878 //
     /*  439296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439343 */     // MIs[1] Operand 1
     /*  439343 */     // No operand predicates
     /*  439343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  439352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439375 */     GIR_RootConstrainSelectedInstOperands,
     /*  439376 */     // GIR_Coverage, 5878,
     /*  439376 */     GIR_EraseRootFromParent_Done,
     /*  439377 */   // Label 7616: @439377
     /*  439377 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(439463), // Rule ID 5879 //
     /*  439382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  439393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  439396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  439399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439429 */     // MIs[1] Operand 1
     /*  439429 */     // No operand predicates
     /*  439429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439438 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  439438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  439458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439461 */     GIR_RootConstrainSelectedInstOperands,
     /*  439462 */     // GIR_Coverage, 5879,
     /*  439462 */     GIR_EraseRootFromParent_Done,
     /*  439463 */   // Label 7617: @439463
     /*  439463 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(439549), // Rule ID 5882 //
     /*  439468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  439482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  439485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439515 */     // MIs[1] Operand 1
     /*  439515 */     // No operand predicates
     /*  439515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439547 */     GIR_RootConstrainSelectedInstOperands,
     /*  439548 */     // GIR_Coverage, 5882,
     /*  439548 */     GIR_EraseRootFromParent_Done,
     /*  439549 */   // Label 7618: @439549
     /*  439549 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(439635), // Rule ID 5883 //
     /*  439554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  439565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  439568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  439571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  439589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439601 */     // MIs[1] Operand 1
     /*  439601 */     // No operand predicates
     /*  439601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439610 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  439613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439633 */     GIR_RootConstrainSelectedInstOperands,
     /*  439634 */     // GIR_Coverage, 5883,
     /*  439634 */     GIR_EraseRootFromParent_Done,
     /*  439635 */   // Label 7619: @439635
     /*  439635 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(439721), // Rule ID 5886 //
     /*  439640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  439651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  439654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  439657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439687 */     // MIs[1] Operand 1
     /*  439687 */     // No operand predicates
     /*  439687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439719 */     GIR_RootConstrainSelectedInstOperands,
     /*  439720 */     // GIR_Coverage, 5886,
     /*  439720 */     GIR_EraseRootFromParent_Done,
     /*  439721 */   // Label 7620: @439721
     /*  439721 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(439807), // Rule ID 5887 //
     /*  439726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  439737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  439740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  439743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  439761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439773 */     // MIs[1] Operand 1
     /*  439773 */     // No operand predicates
     /*  439773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439782 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  439785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439805 */     GIR_RootConstrainSelectedInstOperands,
     /*  439806 */     // GIR_Coverage, 5887,
     /*  439806 */     GIR_EraseRootFromParent_Done,
     /*  439807 */   // Label 7621: @439807
     /*  439807 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(439893), // Rule ID 5890 //
     /*  439812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  439823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  439826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  439829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  439832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  439835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439859 */     // MIs[1] Operand 1
     /*  439859 */     // No operand predicates
     /*  439859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  439868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439891 */     GIR_RootConstrainSelectedInstOperands,
     /*  439892 */     // GIR_Coverage, 5890,
     /*  439892 */     GIR_EraseRootFromParent_Done,
     /*  439893 */   // Label 7622: @439893
     /*  439893 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(439979), // Rule ID 5891 //
     /*  439898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  439901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  439909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  439912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  439915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  439918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  439921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  439933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  439937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  439941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  439945 */     // MIs[1] Operand 1
     /*  439945 */     // No operand predicates
     /*  439945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  439947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  439954 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  439954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  439957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  439959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  439961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  439963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  439966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  439971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  439974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  439977 */     GIR_RootConstrainSelectedInstOperands,
     /*  439978 */     // GIR_Coverage, 5891,
     /*  439978 */     GIR_EraseRootFromParent_Done,
     /*  439979 */   // Label 7623: @439979
     /*  439979 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(440065), // Rule ID 5894 //
     /*  439984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  439987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  439992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  439995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  439998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440031 */     // MIs[1] Operand 1
     /*  440031 */     // No operand predicates
     /*  440031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440063 */     GIR_RootConstrainSelectedInstOperands,
     /*  440064 */     // GIR_Coverage, 5894,
     /*  440064 */     GIR_EraseRootFromParent_Done,
     /*  440065 */   // Label 7624: @440065
     /*  440065 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(440151), // Rule ID 5895 //
     /*  440070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  440081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  440084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  440087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440117 */     // MIs[1] Operand 1
     /*  440117 */     // No operand predicates
     /*  440117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440126 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440149 */     GIR_RootConstrainSelectedInstOperands,
     /*  440150 */     // GIR_Coverage, 5895,
     /*  440150 */     GIR_EraseRootFromParent_Done,
     /*  440151 */   // Label 7625: @440151
     /*  440151 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(440237), // Rule ID 5898 //
     /*  440156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440203 */     // MIs[1] Operand 1
     /*  440203 */     // No operand predicates
     /*  440203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440212 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440235 */     GIR_RootConstrainSelectedInstOperands,
     /*  440236 */     // GIR_Coverage, 5898,
     /*  440236 */     GIR_EraseRootFromParent_Done,
     /*  440237 */   // Label 7626: @440237
     /*  440237 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(440323), // Rule ID 5899 //
     /*  440242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  440253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  440256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  440259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440289 */     // MIs[1] Operand 1
     /*  440289 */     // No operand predicates
     /*  440289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440298 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440321 */     GIR_RootConstrainSelectedInstOperands,
     /*  440322 */     // GIR_Coverage, 5899,
     /*  440322 */     GIR_EraseRootFromParent_Done,
     /*  440323 */   // Label 7627: @440323
     /*  440323 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(440409), // Rule ID 5902 //
     /*  440328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  440331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440375 */     // MIs[1] Operand 1
     /*  440375 */     // No operand predicates
     /*  440375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  440384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440407 */     GIR_RootConstrainSelectedInstOperands,
     /*  440408 */     // GIR_Coverage, 5902,
     /*  440408 */     GIR_EraseRootFromParent_Done,
     /*  440409 */   // Label 7628: @440409
     /*  440409 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(440495), // Rule ID 5903 //
     /*  440414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  440417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  440425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  440428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  440431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440461 */     // MIs[1] Operand 1
     /*  440461 */     // No operand predicates
     /*  440461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  440470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  440490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440493 */     GIR_RootConstrainSelectedInstOperands,
     /*  440494 */     // GIR_Coverage, 5903,
     /*  440494 */     GIR_EraseRootFromParent_Done,
     /*  440495 */   // Label 7629: @440495
     /*  440495 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(440581), // Rule ID 5906 //
     /*  440500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  440503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  440511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  440514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  440517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440547 */     // MIs[1] Operand 1
     /*  440547 */     // No operand predicates
     /*  440547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  440556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  440576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440579 */     GIR_RootConstrainSelectedInstOperands,
     /*  440580 */     // GIR_Coverage, 5906,
     /*  440580 */     GIR_EraseRootFromParent_Done,
     /*  440581 */   // Label 7630: @440581
     /*  440581 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(440667), // Rule ID 5907 //
     /*  440586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  440589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  440597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  440600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  440603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  440621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440633 */     // MIs[1] Operand 1
     /*  440633 */     // No operand predicates
     /*  440633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440642 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  440642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2),
     /*  440645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  440662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440665 */     GIR_RootConstrainSelectedInstOperands,
     /*  440666 */     // GIR_Coverage, 5907,
     /*  440666 */     GIR_EraseRootFromParent_Done,
     /*  440667 */   // Label 7631: @440667
     /*  440667 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(440753), // Rule ID 5910 //
     /*  440672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  440675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  440683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  440686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  440689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440715 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440719 */     // MIs[1] Operand 1
     /*  440719 */     // No operand predicates
     /*  440719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440728 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  440728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440737 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  440748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440751 */     GIR_RootConstrainSelectedInstOperands,
     /*  440752 */     // GIR_Coverage, 5910,
     /*  440752 */     GIR_EraseRootFromParent_Done,
     /*  440753 */   // Label 7632: @440753
     /*  440753 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(440839), // Rule ID 5911 //
     /*  440758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  440761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  440769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  440772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  440775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  440793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440805 */     // MIs[1] Operand 1
     /*  440805 */     // No operand predicates
     /*  440805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440814 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  440814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4),
     /*  440817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  440834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440837 */     GIR_RootConstrainSelectedInstOperands,
     /*  440838 */     // GIR_Coverage, 5911,
     /*  440838 */     GIR_EraseRootFromParent_Done,
     /*  440839 */   // Label 7633: @440839
     /*  440839 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(440925), // Rule ID 5914 //
     /*  440844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  440847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  440855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  440858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  440861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  440864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  440867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440891 */     // MIs[1] Operand 1
     /*  440891 */     // No operand predicates
     /*  440891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440900 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  440900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  440917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  440920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  440923 */     GIR_RootConstrainSelectedInstOperands,
     /*  440924 */     // GIR_Coverage, 5914,
     /*  440924 */     GIR_EraseRootFromParent_Done,
     /*  440925 */   // Label 7634: @440925
     /*  440925 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(441011), // Rule ID 5915 //
     /*  440930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  440933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  440938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  440941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  440944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  440947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  440950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  440953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  440965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  440969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  440973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  440977 */     // MIs[1] Operand 1
     /*  440977 */     // No operand predicates
     /*  440977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  440979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  440986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  440986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8),
     /*  440989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  440991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  440993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  440995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  440998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  441006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441009 */     GIR_RootConstrainSelectedInstOperands,
     /*  441010 */     // GIR_Coverage, 5915,
     /*  441010 */     GIR_EraseRootFromParent_Done,
     /*  441011 */   // Label 7635: @441011
     /*  441011 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(441097), // Rule ID 6094 //
     /*  441016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441059 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441063 */     // MIs[1] Operand 1
     /*  441063 */     // No operand predicates
     /*  441063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441072 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441095 */     GIR_RootConstrainSelectedInstOperands,
     /*  441096 */     // GIR_Coverage, 6094,
     /*  441096 */     GIR_EraseRootFromParent_Done,
     /*  441097 */   // Label 7636: @441097
     /*  441097 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(441183), // Rule ID 6095 //
     /*  441102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  441113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  441116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  441119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441149 */     // MIs[1] Operand 1
     /*  441149 */     // No operand predicates
     /*  441149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441158 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8),
     /*  441161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441181 */     GIR_RootConstrainSelectedInstOperands,
     /*  441182 */     // GIR_Coverage, 6095,
     /*  441182 */     GIR_EraseRootFromParent_Done,
     /*  441183 */   // Label 7637: @441183
     /*  441183 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(441269), // Rule ID 6098 //
     /*  441188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441235 */     // MIs[1] Operand 1
     /*  441235 */     // No operand predicates
     /*  441235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441244 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441267 */     GIR_RootConstrainSelectedInstOperands,
     /*  441268 */     // GIR_Coverage, 6098,
     /*  441268 */     GIR_EraseRootFromParent_Done,
     /*  441269 */   // Label 7638: @441269
     /*  441269 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(441355), // Rule ID 6099 //
     /*  441274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  441285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  441288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  441291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441321 */     // MIs[1] Operand 1
     /*  441321 */     // No operand predicates
     /*  441321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441353 */     GIR_RootConstrainSelectedInstOperands,
     /*  441354 */     // GIR_Coverage, 6099,
     /*  441354 */     GIR_EraseRootFromParent_Done,
     /*  441355 */   // Label 7639: @441355
     /*  441355 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(441441), // Rule ID 6102 //
     /*  441360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441407 */     // MIs[1] Operand 1
     /*  441407 */     // No operand predicates
     /*  441407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  441416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441439 */     GIR_RootConstrainSelectedInstOperands,
     /*  441440 */     // GIR_Coverage, 6102,
     /*  441440 */     GIR_EraseRootFromParent_Done,
     /*  441441 */   // Label 7640: @441441
     /*  441441 */   GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(441527), // Rule ID 6103 //
     /*  441446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  441457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  441460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  441463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441493 */     // MIs[1] Operand 1
     /*  441493 */     // No operand predicates
     /*  441493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441502 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  441502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  441522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441525 */     GIR_RootConstrainSelectedInstOperands,
     /*  441526 */     // GIR_Coverage, 6103,
     /*  441526 */     GIR_EraseRootFromParent_Done,
     /*  441527 */   // Label 7641: @441527
     /*  441527 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(441613), // Rule ID 6106 //
     /*  441532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  441543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  441546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  441549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441579 */     // MIs[1] Operand 1
     /*  441579 */     // No operand predicates
     /*  441579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441588 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  441588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441611 */     GIR_RootConstrainSelectedInstOperands,
     /*  441612 */     // GIR_Coverage, 6106,
     /*  441612 */     GIR_EraseRootFromParent_Done,
     /*  441613 */   // Label 7642: @441613
     /*  441613 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(441699), // Rule ID 6107 //
     /*  441618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  441629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  441632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  441635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441665 */     // MIs[1] Operand 1
     /*  441665 */     // No operand predicates
     /*  441665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  441674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4),
     /*  441677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441697 */     GIR_RootConstrainSelectedInstOperands,
     /*  441698 */     // GIR_Coverage, 6107,
     /*  441698 */     GIR_EraseRootFromParent_Done,
     /*  441699 */   // Label 7643: @441699
     /*  441699 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(441785), // Rule ID 6110 //
     /*  441704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  441715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  441718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  441721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441751 */     // MIs[1] Operand 1
     /*  441751 */     // No operand predicates
     /*  441751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  441760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441783 */     GIR_RootConstrainSelectedInstOperands,
     /*  441784 */     // GIR_Coverage, 6110,
     /*  441784 */     GIR_EraseRootFromParent_Done,
     /*  441785 */   // Label 7644: @441785
     /*  441785 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(441871), // Rule ID 6111 //
     /*  441790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  441801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  441804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  441807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441837 */     // MIs[1] Operand 1
     /*  441837 */     // No operand predicates
     /*  441837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441846 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  441846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  441866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441869 */     GIR_RootConstrainSelectedInstOperands,
     /*  441870 */     // GIR_Coverage, 6111,
     /*  441870 */     GIR_EraseRootFromParent_Done,
     /*  441871 */   // Label 7645: @441871
     /*  441871 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(441957), // Rule ID 6114 //
     /*  441876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  441879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  441893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  441896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  441899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  441915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  441919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  441923 */     // MIs[1] Operand 1
     /*  441923 */     // No operand predicates
     /*  441923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  441925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  441932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  441932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  441935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  441937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  441939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  441941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  441944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  441949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  441952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  441955 */     GIR_RootConstrainSelectedInstOperands,
     /*  441956 */     // GIR_Coverage, 6114,
     /*  441956 */     GIR_EraseRootFromParent_Done,
     /*  441957 */   // Label 7646: @441957
     /*  441957 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(442043), // Rule ID 6115 //
     /*  441962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  441965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  441970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  441973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  441976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  441979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  441982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  441985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  441997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442009 */     // MIs[1] Operand 1
     /*  442009 */     // No operand predicates
     /*  442009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2),
     /*  442021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442041 */     GIR_RootConstrainSelectedInstOperands,
     /*  442042 */     // GIR_Coverage, 6115,
     /*  442042 */     GIR_EraseRootFromParent_Done,
     /*  442043 */   // Label 7647: @442043
     /*  442043 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(442129), // Rule ID 6118 //
     /*  442048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442095 */     // MIs[1] Operand 1
     /*  442095 */     // No operand predicates
     /*  442095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442104 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442127 */     GIR_RootConstrainSelectedInstOperands,
     /*  442128 */     // GIR_Coverage, 6118,
     /*  442128 */     GIR_EraseRootFromParent_Done,
     /*  442129 */   // Label 7648: @442129
     /*  442129 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(442215), // Rule ID 6119 //
     /*  442134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  442145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  442148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  442151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442177 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442181 */     // MIs[1] Operand 1
     /*  442181 */     // No operand predicates
     /*  442181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442190 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442213 */     GIR_RootConstrainSelectedInstOperands,
     /*  442214 */     // GIR_Coverage, 6119,
     /*  442214 */     GIR_EraseRootFromParent_Done,
     /*  442215 */   // Label 7649: @442215
     /*  442215 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(442301), // Rule ID 6122 //
     /*  442220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442267 */     // MIs[1] Operand 1
     /*  442267 */     // No operand predicates
     /*  442267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  442276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442299 */     GIR_RootConstrainSelectedInstOperands,
     /*  442300 */     // GIR_Coverage, 6122,
     /*  442300 */     GIR_EraseRootFromParent_Done,
     /*  442301 */   // Label 7650: @442301
     /*  442301 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(442387), // Rule ID 6123 //
     /*  442306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  442317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  442320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  442323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442353 */     // MIs[1] Operand 1
     /*  442353 */     // No operand predicates
     /*  442353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  442362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  442382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442385 */     GIR_RootConstrainSelectedInstOperands,
     /*  442386 */     // GIR_Coverage, 6123,
     /*  442386 */     GIR_EraseRootFromParent_Done,
     /*  442387 */   // Label 7651: @442387
     /*  442387 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(442473), // Rule ID 6126 //
     /*  442392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442439 */     // MIs[1] Operand 1
     /*  442439 */     // No operand predicates
     /*  442439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  442448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442471 */     GIR_RootConstrainSelectedInstOperands,
     /*  442472 */     // GIR_Coverage, 6126,
     /*  442472 */     GIR_EraseRootFromParent_Done,
     /*  442473 */   // Label 7652: @442473
     /*  442473 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(442559), // Rule ID 6127 //
     /*  442478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  442489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  442492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  442495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442525 */     // MIs[1] Operand 1
     /*  442525 */     // No operand predicates
     /*  442525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442534 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  442534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  442554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442557 */     GIR_RootConstrainSelectedInstOperands,
     /*  442558 */     // GIR_Coverage, 6127,
     /*  442558 */     GIR_EraseRootFromParent_Done,
     /*  442559 */   // Label 7653: @442559
     /*  442559 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(442645), // Rule ID 6130 //
     /*  442564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  442567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  442575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  442578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  442581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442611 */     // MIs[1] Operand 1
     /*  442611 */     // No operand predicates
     /*  442611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442620 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  442620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  442640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442643 */     GIR_RootConstrainSelectedInstOperands,
     /*  442644 */     // GIR_Coverage, 6130,
     /*  442644 */     GIR_EraseRootFromParent_Done,
     /*  442645 */   // Label 7654: @442645
     /*  442645 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(442731), // Rule ID 6131 //
     /*  442650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  442653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  442661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  442664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  442667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  442685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442697 */     // MIs[1] Operand 1
     /*  442697 */     // No operand predicates
     /*  442697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442706 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  442706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1),
     /*  442709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  442726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442729 */     GIR_RootConstrainSelectedInstOperands,
     /*  442730 */     // GIR_Coverage, 6131,
     /*  442730 */     GIR_EraseRootFromParent_Done,
     /*  442731 */   // Label 7655: @442731
     /*  442731 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(442817), // Rule ID 6134 //
     /*  442736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  442747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  442750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  442753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442783 */     // MIs[1] Operand 1
     /*  442783 */     // No operand predicates
     /*  442783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442792 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  442795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442815 */     GIR_RootConstrainSelectedInstOperands,
     /*  442816 */     // GIR_Coverage, 6134,
     /*  442816 */     GIR_EraseRootFromParent_Done,
     /*  442817 */   // Label 7656: @442817
     /*  442817 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(442903), // Rule ID 6135 //
     /*  442822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  442833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  442836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  442839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  442842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  442845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  442857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442869 */     // MIs[1] Operand 1
     /*  442869 */     // No operand predicates
     /*  442869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  442878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  442881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442901 */     GIR_RootConstrainSelectedInstOperands,
     /*  442902 */     // GIR_Coverage, 6135,
     /*  442902 */     GIR_EraseRootFromParent_Done,
     /*  442903 */   // Label 7657: @442903
     /*  442903 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(442989), // Rule ID 6138 //
     /*  442908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  442911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  442916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  442919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  442922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  442925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  442928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  442931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  442943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  442947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  442951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  442955 */     // MIs[1] Operand 1
     /*  442955 */     // No operand predicates
     /*  442955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  442957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  442964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  442964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  442967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  442969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  442971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  442973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  442976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  442981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  442984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  442987 */     GIR_RootConstrainSelectedInstOperands,
     /*  442988 */     // GIR_Coverage, 6138,
     /*  442988 */     GIR_EraseRootFromParent_Done,
     /*  442989 */   // Label 7658: @442989
     /*  442989 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(443075), // Rule ID 6139 //
     /*  442994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  442997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  443005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  443008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  443011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443041 */     // MIs[1] Operand 1
     /*  443041 */     // No operand predicates
     /*  443041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443050 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443073 */     GIR_RootConstrainSelectedInstOperands,
     /*  443074 */     // GIR_Coverage, 6139,
     /*  443074 */     GIR_EraseRootFromParent_Done,
     /*  443075 */   // Label 7659: @443075
     /*  443075 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(443161), // Rule ID 6142 //
     /*  443080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443127 */     // MIs[1] Operand 1
     /*  443127 */     // No operand predicates
     /*  443127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443136 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  443136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443159 */     GIR_RootConstrainSelectedInstOperands,
     /*  443160 */     // GIR_Coverage, 6142,
     /*  443160 */     GIR_EraseRootFromParent_Done,
     /*  443161 */   // Label 7660: @443161
     /*  443161 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(443247), // Rule ID 6143 //
     /*  443166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  443177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  443180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  443183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443213 */     // MIs[1] Operand 1
     /*  443213 */     // No operand predicates
     /*  443213 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443222 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  443222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  443242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443245 */     GIR_RootConstrainSelectedInstOperands,
     /*  443246 */     // GIR_Coverage, 6143,
     /*  443246 */     GIR_EraseRootFromParent_Done,
     /*  443247 */   // Label 7661: @443247
     /*  443247 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(443333), // Rule ID 6146 //
     /*  443252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443299 */     // MIs[1] Operand 1
     /*  443299 */     // No operand predicates
     /*  443299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443308 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443331 */     GIR_RootConstrainSelectedInstOperands,
     /*  443332 */     // GIR_Coverage, 6146,
     /*  443332 */     GIR_EraseRootFromParent_Done,
     /*  443333 */   // Label 7662: @443333
     /*  443333 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(443419), // Rule ID 6147 //
     /*  443338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  443349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  443352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  443355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443385 */     // MIs[1] Operand 1
     /*  443385 */     // No operand predicates
     /*  443385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443417 */     GIR_RootConstrainSelectedInstOperands,
     /*  443418 */     // GIR_Coverage, 6147,
     /*  443418 */     GIR_EraseRootFromParent_Done,
     /*  443419 */   // Label 7663: @443419
     /*  443419 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(443505), // Rule ID 6150 //
     /*  443424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  443441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443471 */     // MIs[1] Operand 1
     /*  443471 */     // No operand predicates
     /*  443471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443480 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443503 */     GIR_RootConstrainSelectedInstOperands,
     /*  443504 */     // GIR_Coverage, 6150,
     /*  443504 */     GIR_EraseRootFromParent_Done,
     /*  443505 */   // Label 7664: @443505
     /*  443505 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(443591), // Rule ID 6151 //
     /*  443510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  443521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  443524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  443527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443557 */     // MIs[1] Operand 1
     /*  443557 */     // No operand predicates
     /*  443557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443566 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443589 */     GIR_RootConstrainSelectedInstOperands,
     /*  443590 */     // GIR_Coverage, 6151,
     /*  443590 */     GIR_EraseRootFromParent_Done,
     /*  443591 */   // Label 7665: @443591
     /*  443591 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(443677), // Rule ID 6154 //
     /*  443596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  443607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  443610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  443613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443643 */     // MIs[1] Operand 1
     /*  443643 */     // No operand predicates
     /*  443643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443652 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  443652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443675 */     GIR_RootConstrainSelectedInstOperands,
     /*  443676 */     // GIR_Coverage, 6154,
     /*  443676 */     GIR_EraseRootFromParent_Done,
     /*  443677 */   // Label 7666: @443677
     /*  443677 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(443763), // Rule ID 6155 //
     /*  443682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  443693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  443696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  443699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  443717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443729 */     // MIs[1] Operand 1
     /*  443729 */     // No operand predicates
     /*  443729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  443738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  443741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  443758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443761 */     GIR_RootConstrainSelectedInstOperands,
     /*  443762 */     // GIR_Coverage, 6155,
     /*  443762 */     GIR_EraseRootFromParent_Done,
     /*  443763 */   // Label 7667: @443763
     /*  443763 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(443849), // Rule ID 6158 //
     /*  443768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  443779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  443782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  443785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443815 */     // MIs[1] Operand 1
     /*  443815 */     // No operand predicates
     /*  443815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443847 */     GIR_RootConstrainSelectedInstOperands,
     /*  443848 */     // GIR_Coverage, 6158,
     /*  443848 */     GIR_EraseRootFromParent_Done,
     /*  443849 */   // Label 7668: @443849
     /*  443849 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(443935), // Rule ID 6159 //
     /*  443854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  443857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  443865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  443868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  443871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  443874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  443877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  443889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443897 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443901 */     // MIs[1] Operand 1
     /*  443901 */     // No operand predicates
     /*  443901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  443910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  443913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  443915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  443917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  443919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  443922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  443927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  443930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  443933 */     GIR_RootConstrainSelectedInstOperands,
     /*  443934 */     // GIR_Coverage, 6159,
     /*  443934 */     GIR_EraseRootFromParent_Done,
     /*  443935 */   // Label 7669: @443935
     /*  443935 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(444021), // Rule ID 6162 //
     /*  443940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  443943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  443948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  443951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  443954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  443957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  443960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  443963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  443975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  443979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  443983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  443987 */     // MIs[1] Operand 1
     /*  443987 */     // No operand predicates
     /*  443987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  443989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  443996 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  443996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  443999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444019 */     GIR_RootConstrainSelectedInstOperands,
     /*  444020 */     // GIR_Coverage, 6162,
     /*  444020 */     GIR_EraseRootFromParent_Done,
     /*  444021 */   // Label 7670: @444021
     /*  444021 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(444107), // Rule ID 6163 //
     /*  444026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  444037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  444040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  444043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444073 */     // MIs[1] Operand 1
     /*  444073 */     // No operand predicates
     /*  444073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444082 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444105 */     GIR_RootConstrainSelectedInstOperands,
     /*  444106 */     // GIR_Coverage, 6163,
     /*  444106 */     GIR_EraseRootFromParent_Done,
     /*  444107 */   // Label 7671: @444107
     /*  444107 */   GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(444193), // Rule ID 6166 //
     /*  444112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444159 */     // MIs[1] Operand 1
     /*  444159 */     // No operand predicates
     /*  444159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444168 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  444168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444191 */     GIR_RootConstrainSelectedInstOperands,
     /*  444192 */     // GIR_Coverage, 6166,
     /*  444192 */     GIR_EraseRootFromParent_Done,
     /*  444193 */   // Label 7672: @444193
     /*  444193 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(444279), // Rule ID 6167 //
     /*  444198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  444209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  444212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  444215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444241 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444245 */     // MIs[1] Operand 1
     /*  444245 */     // No operand predicates
     /*  444245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444254 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  444254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  444274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444277 */     GIR_RootConstrainSelectedInstOperands,
     /*  444278 */     // GIR_Coverage, 6167,
     /*  444278 */     GIR_EraseRootFromParent_Done,
     /*  444279 */   // Label 7673: @444279
     /*  444279 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(444365), // Rule ID 6170 //
     /*  444284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444331 */     // MIs[1] Operand 1
     /*  444331 */     // No operand predicates
     /*  444331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444363 */     GIR_RootConstrainSelectedInstOperands,
     /*  444364 */     // GIR_Coverage, 6170,
     /*  444364 */     GIR_EraseRootFromParent_Done,
     /*  444365 */   // Label 7674: @444365
     /*  444365 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(444451), // Rule ID 6171 //
     /*  444370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  444381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  444384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  444387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  444405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444417 */     // MIs[1] Operand 1
     /*  444417 */     // No operand predicates
     /*  444417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2),
     /*  444429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444449 */     GIR_RootConstrainSelectedInstOperands,
     /*  444450 */     // GIR_Coverage, 6171,
     /*  444450 */     GIR_EraseRootFromParent_Done,
     /*  444451 */   // Label 7675: @444451
     /*  444451 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(444537), // Rule ID 6174 //
     /*  444456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  444467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  444470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  444473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444503 */     // MIs[1] Operand 1
     /*  444503 */     // No operand predicates
     /*  444503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444535 */     GIR_RootConstrainSelectedInstOperands,
     /*  444536 */     // GIR_Coverage, 6174,
     /*  444536 */     GIR_EraseRootFromParent_Done,
     /*  444537 */   // Label 7676: @444537
     /*  444537 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(444623), // Rule ID 6175 //
     /*  444542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  444553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  444556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  444559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  444577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444589 */     // MIs[1] Operand 1
     /*  444589 */     // No operand predicates
     /*  444589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4),
     /*  444601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444621 */     GIR_RootConstrainSelectedInstOperands,
     /*  444622 */     // GIR_Coverage, 6175,
     /*  444622 */     GIR_EraseRootFromParent_Done,
     /*  444623 */   // Label 7677: @444623
     /*  444623 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(444709), // Rule ID 6178 //
     /*  444628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  444631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  444639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  444642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  444645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444675 */     // MIs[1] Operand 1
     /*  444675 */     // No operand predicates
     /*  444675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  444684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444707 */     GIR_RootConstrainSelectedInstOperands,
     /*  444708 */     // GIR_Coverage, 6178,
     /*  444708 */     GIR_EraseRootFromParent_Done,
     /*  444709 */   // Label 7678: @444709
     /*  444709 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(444795), // Rule ID 6179 //
     /*  444714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  444717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  444722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  444725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  444728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  444731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  444749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444761 */     // MIs[1] Operand 1
     /*  444761 */     // No operand predicates
     /*  444761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  444770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8),
     /*  444773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  444790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444793 */     GIR_RootConstrainSelectedInstOperands,
     /*  444794 */     // GIR_Coverage, 6179,
     /*  444794 */     GIR_EraseRootFromParent_Done,
     /*  444795 */   // Label 7679: @444795
     /*  444795 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(444881), // Rule ID 6358 //
     /*  444800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  444808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  444811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  444814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  444817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444847 */     // MIs[1] Operand 1
     /*  444847 */     // No operand predicates
     /*  444847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  444856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  444859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444879 */     GIR_RootConstrainSelectedInstOperands,
     /*  444880 */     // GIR_Coverage, 6358,
     /*  444880 */     GIR_EraseRootFromParent_Done,
     /*  444881 */   // Label 7680: @444881
     /*  444881 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(444967), // Rule ID 6359 //
     /*  444886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  444889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  444894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  444897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  444900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  444903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  444906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  444909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  444925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  444929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  444933 */     // MIs[1] Operand 1
     /*  444933 */     // No operand predicates
     /*  444933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  444935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  444942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  444942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8),
     /*  444945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  444947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  444949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  444951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  444954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  444959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  444962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  444965 */     GIR_RootConstrainSelectedInstOperands,
     /*  444966 */     // GIR_Coverage, 6359,
     /*  444966 */     GIR_EraseRootFromParent_Done,
     /*  444967 */   // Label 7681: @444967
     /*  444967 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(445053), // Rule ID 6362 //
     /*  444972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  444975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  444980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  444983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  444986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  444989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  444992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  444995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  444999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445019 */     // MIs[1] Operand 1
     /*  445019 */     // No operand predicates
     /*  445019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445028 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445051 */     GIR_RootConstrainSelectedInstOperands,
     /*  445052 */     // GIR_Coverage, 6362,
     /*  445052 */     GIR_EraseRootFromParent_Done,
     /*  445053 */   // Label 7682: @445053
     /*  445053 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(445139), // Rule ID 6363 //
     /*  445058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  445069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  445072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  445075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445105 */     // MIs[1] Operand 1
     /*  445105 */     // No operand predicates
     /*  445105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445137 */     GIR_RootConstrainSelectedInstOperands,
     /*  445138 */     // GIR_Coverage, 6363,
     /*  445138 */     GIR_EraseRootFromParent_Done,
     /*  445139 */   // Label 7683: @445139
     /*  445139 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(445225), // Rule ID 6366 //
     /*  445144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445191 */     // MIs[1] Operand 1
     /*  445191 */     // No operand predicates
     /*  445191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445223 */     GIR_RootConstrainSelectedInstOperands,
     /*  445224 */     // GIR_Coverage, 6366,
     /*  445224 */     GIR_EraseRootFromParent_Done,
     /*  445225 */   // Label 7684: @445225
     /*  445225 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(445311), // Rule ID 6367 //
     /*  445230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  445241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  445244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  445247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445277 */     // MIs[1] Operand 1
     /*  445277 */     // No operand predicates
     /*  445277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445286 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445309 */     GIR_RootConstrainSelectedInstOperands,
     /*  445310 */     // GIR_Coverage, 6367,
     /*  445310 */     GIR_EraseRootFromParent_Done,
     /*  445311 */   // Label 7685: @445311
     /*  445311 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(445397), // Rule ID 6370 //
     /*  445316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445363 */     // MIs[1] Operand 1
     /*  445363 */     // No operand predicates
     /*  445363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445372 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445395 */     GIR_RootConstrainSelectedInstOperands,
     /*  445396 */     // GIR_Coverage, 6370,
     /*  445396 */     GIR_EraseRootFromParent_Done,
     /*  445397 */   // Label 7686: @445397
     /*  445397 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(445483), // Rule ID 6371 //
     /*  445402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  445413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  445416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  445419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445445 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445449 */     // MIs[1] Operand 1
     /*  445449 */     // No operand predicates
     /*  445449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  445458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4),
     /*  445461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445481 */     GIR_RootConstrainSelectedInstOperands,
     /*  445482 */     // GIR_Coverage, 6371,
     /*  445482 */     GIR_EraseRootFromParent_Done,
     /*  445483 */   // Label 7687: @445483
     /*  445483 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(445569), // Rule ID 6374 //
     /*  445488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  445499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  445502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  445505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445535 */     // MIs[1] Operand 1
     /*  445535 */     // No operand predicates
     /*  445535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  445544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445567 */     GIR_RootConstrainSelectedInstOperands,
     /*  445568 */     // GIR_Coverage, 6374,
     /*  445568 */     GIR_EraseRootFromParent_Done,
     /*  445569 */   // Label 7688: @445569
     /*  445569 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(445655), // Rule ID 6375 //
     /*  445574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  445585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  445588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  445591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445621 */     // MIs[1] Operand 1
     /*  445621 */     // No operand predicates
     /*  445621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445630 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  445630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  445650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445653 */     GIR_RootConstrainSelectedInstOperands,
     /*  445654 */     // GIR_Coverage, 6375,
     /*  445654 */     GIR_EraseRootFromParent_Done,
     /*  445655 */   // Label 7689: @445655
     /*  445655 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(445741), // Rule ID 6378 //
     /*  445660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  445671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  445674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  445677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445707 */     // MIs[1] Operand 1
     /*  445707 */     // No operand predicates
     /*  445707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  445716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445739 */     GIR_RootConstrainSelectedInstOperands,
     /*  445740 */     // GIR_Coverage, 6378,
     /*  445740 */     GIR_EraseRootFromParent_Done,
     /*  445741 */   // Label 7690: @445741
     /*  445741 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(445827), // Rule ID 6379 //
     /*  445746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  445757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  445760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  445763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445793 */     // MIs[1] Operand 1
     /*  445793 */     // No operand predicates
     /*  445793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445802 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  445802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2),
     /*  445805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  445822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445825 */     GIR_RootConstrainSelectedInstOperands,
     /*  445826 */     // GIR_Coverage, 6379,
     /*  445826 */     GIR_EraseRootFromParent_Done,
     /*  445827 */   // Label 7691: @445827
     /*  445827 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(445913), // Rule ID 6382 //
     /*  445832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  445835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  445843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  445846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  445849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  445852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  445855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445879 */     // MIs[1] Operand 1
     /*  445879 */     // No operand predicates
     /*  445879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445888 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  445888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  445891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445911 */     GIR_RootConstrainSelectedInstOperands,
     /*  445912 */     // GIR_Coverage, 6382,
     /*  445912 */     GIR_EraseRootFromParent_Done,
     /*  445913 */   // Label 7692: @445913
     /*  445913 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(445999), // Rule ID 6383 //
     /*  445918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  445921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  445926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  445929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  445932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  445935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  445938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  445941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  445953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  445957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  445961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  445965 */     // MIs[1] Operand 1
     /*  445965 */     // No operand predicates
     /*  445965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  445967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  445974 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  445974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  445977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  445979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  445981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  445983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  445986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  445991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  445994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  445997 */     GIR_RootConstrainSelectedInstOperands,
     /*  445998 */     // GIR_Coverage, 6383,
     /*  445998 */     GIR_EraseRootFromParent_Done,
     /*  445999 */   // Label 7693: @445999
     /*  445999 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(446085), // Rule ID 6386 //
     /*  446004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446051 */     // MIs[1] Operand 1
     /*  446051 */     // No operand predicates
     /*  446051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  446060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446083 */     GIR_RootConstrainSelectedInstOperands,
     /*  446084 */     // GIR_Coverage, 6386,
     /*  446084 */     GIR_EraseRootFromParent_Done,
     /*  446085 */   // Label 7694: @446085
     /*  446085 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(446171), // Rule ID 6387 //
     /*  446090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  446101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  446104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  446107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446137 */     // MIs[1] Operand 1
     /*  446137 */     // No operand predicates
     /*  446137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  446146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  446166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446169 */     GIR_RootConstrainSelectedInstOperands,
     /*  446170 */     // GIR_Coverage, 6387,
     /*  446170 */     GIR_EraseRootFromParent_Done,
     /*  446171 */   // Label 7695: @446171
     /*  446171 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(446257), // Rule ID 6390 //
     /*  446176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446223 */     // MIs[1] Operand 1
     /*  446223 */     // No operand predicates
     /*  446223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  446232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446255 */     GIR_RootConstrainSelectedInstOperands,
     /*  446256 */     // GIR_Coverage, 6390,
     /*  446256 */     GIR_EraseRootFromParent_Done,
     /*  446257 */   // Label 7696: @446257
     /*  446257 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(446343), // Rule ID 6391 //
     /*  446262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  446273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  446276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  446279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446309 */     // MIs[1] Operand 1
     /*  446309 */     // No operand predicates
     /*  446309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  446318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  446338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446341 */     GIR_RootConstrainSelectedInstOperands,
     /*  446342 */     // GIR_Coverage, 6391,
     /*  446342 */     GIR_EraseRootFromParent_Done,
     /*  446343 */   // Label 7697: @446343
     /*  446343 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(446429), // Rule ID 6394 //
     /*  446348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  446351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446395 */     // MIs[1] Operand 1
     /*  446395 */     // No operand predicates
     /*  446395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446404 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  446404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446427 */     GIR_RootConstrainSelectedInstOperands,
     /*  446428 */     // GIR_Coverage, 6394,
     /*  446428 */     GIR_EraseRootFromParent_Done,
     /*  446429 */   // Label 7698: @446429
     /*  446429 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(446515), // Rule ID 6395 //
     /*  446434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  446437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  446445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  446448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  446451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  446469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446481 */     // MIs[1] Operand 1
     /*  446481 */     // No operand predicates
     /*  446481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446490 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  446490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1),
     /*  446493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  446510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446513 */     GIR_RootConstrainSelectedInstOperands,
     /*  446514 */     // GIR_Coverage, 6395,
     /*  446514 */     GIR_EraseRootFromParent_Done,
     /*  446515 */   // Label 7699: @446515
     /*  446515 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(446601), // Rule ID 6398 //
     /*  446520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  446531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  446534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  446537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446567 */     // MIs[1] Operand 1
     /*  446567 */     // No operand predicates
     /*  446567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446576 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  446579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446599 */     GIR_RootConstrainSelectedInstOperands,
     /*  446600 */     // GIR_Coverage, 6398,
     /*  446600 */     GIR_EraseRootFromParent_Done,
     /*  446601 */   // Label 7700: @446601
     /*  446601 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(446687), // Rule ID 6399 //
     /*  446606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  446617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  446620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  446623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  446641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446653 */     // MIs[1] Operand 1
     /*  446653 */     // No operand predicates
     /*  446653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446662 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  446665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446685 */     GIR_RootConstrainSelectedInstOperands,
     /*  446686 */     // GIR_Coverage, 6399,
     /*  446686 */     GIR_EraseRootFromParent_Done,
     /*  446687 */   // Label 7701: @446687
     /*  446687 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(446773), // Rule ID 6402 //
     /*  446692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  446703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  446706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  446709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446739 */     // MIs[1] Operand 1
     /*  446739 */     // No operand predicates
     /*  446739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446748 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  446751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446771 */     GIR_RootConstrainSelectedInstOperands,
     /*  446772 */     // GIR_Coverage, 6402,
     /*  446772 */     GIR_EraseRootFromParent_Done,
     /*  446773 */   // Label 7702: @446773
     /*  446773 */   GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(446859), // Rule ID 6403 //
     /*  446778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  446789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  446792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  446795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  446813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446825 */     // MIs[1] Operand 1
     /*  446825 */     // No operand predicates
     /*  446825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446834 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  446834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  446837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446857 */     GIR_RootConstrainSelectedInstOperands,
     /*  446858 */     // GIR_Coverage, 6403,
     /*  446858 */     GIR_EraseRootFromParent_Done,
     /*  446859 */   // Label 7703: @446859
     /*  446859 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(446945), // Rule ID 6406 //
     /*  446864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  446867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  446875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  446878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  446881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  446884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  446887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446911 */     // MIs[1] Operand 1
     /*  446911 */     // No operand predicates
     /*  446911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  446920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  446920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  446923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  446925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  446927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  446929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  446932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  446937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  446940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  446943 */     GIR_RootConstrainSelectedInstOperands,
     /*  446944 */     // GIR_Coverage, 6406,
     /*  446944 */     GIR_EraseRootFromParent_Done,
     /*  446945 */   // Label 7704: @446945
     /*  446945 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(447031), // Rule ID 6407 //
     /*  446950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  446953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  446958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  446961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  446964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  446967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  446970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  446973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  446985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  446989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  446993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  446997 */     // MIs[1] Operand 1
     /*  446997 */     // No operand predicates
     /*  446997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  446999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447006 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  447006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  447026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447029 */     GIR_RootConstrainSelectedInstOperands,
     /*  447030 */     // GIR_Coverage, 6407,
     /*  447030 */     GIR_EraseRootFromParent_Done,
     /*  447031 */   // Label 7705: @447031
     /*  447031 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(447117), // Rule ID 6410 //
     /*  447036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447083 */     // MIs[1] Operand 1
     /*  447083 */     // No operand predicates
     /*  447083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447092 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447115 */     GIR_RootConstrainSelectedInstOperands,
     /*  447116 */     // GIR_Coverage, 6410,
     /*  447116 */     GIR_EraseRootFromParent_Done,
     /*  447117 */   // Label 7706: @447117
     /*  447117 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(447203), // Rule ID 6411 //
     /*  447122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  447133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  447136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  447139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447169 */     // MIs[1] Operand 1
     /*  447169 */     // No operand predicates
     /*  447169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447201 */     GIR_RootConstrainSelectedInstOperands,
     /*  447202 */     // GIR_Coverage, 6411,
     /*  447202 */     GIR_EraseRootFromParent_Done,
     /*  447203 */   // Label 7707: @447203
     /*  447203 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(447289), // Rule ID 6414 //
     /*  447208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447255 */     // MIs[1] Operand 1
     /*  447255 */     // No operand predicates
     /*  447255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447287 */     GIR_RootConstrainSelectedInstOperands,
     /*  447288 */     // GIR_Coverage, 6414,
     /*  447288 */     GIR_EraseRootFromParent_Done,
     /*  447289 */   // Label 7708: @447289
     /*  447289 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(447375), // Rule ID 6415 //
     /*  447294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  447305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  447308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  447311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447341 */     // MIs[1] Operand 1
     /*  447341 */     // No operand predicates
     /*  447341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447373 */     GIR_RootConstrainSelectedInstOperands,
     /*  447374 */     // GIR_Coverage, 6415,
     /*  447374 */     GIR_EraseRootFromParent_Done,
     /*  447375 */   // Label 7709: @447375
     /*  447375 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(447461), // Rule ID 6418 //
     /*  447380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447427 */     // MIs[1] Operand 1
     /*  447427 */     // No operand predicates
     /*  447427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447436 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  447436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447459 */     GIR_RootConstrainSelectedInstOperands,
     /*  447460 */     // GIR_Coverage, 6418,
     /*  447460 */     GIR_EraseRootFromParent_Done,
     /*  447461 */   // Label 7710: @447461
     /*  447461 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(447547), // Rule ID 6419 //
     /*  447466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  447477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  447480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  447483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447509 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447513 */     // MIs[1] Operand 1
     /*  447513 */     // No operand predicates
     /*  447513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447522 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  447522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  447542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447545 */     GIR_RootConstrainSelectedInstOperands,
     /*  447546 */     // GIR_Coverage, 6419,
     /*  447546 */     GIR_EraseRootFromParent_Done,
     /*  447547 */   // Label 7711: @447547
     /*  447547 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(447633), // Rule ID 6422 //
     /*  447552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  447563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  447566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  447569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447595 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447599 */     // MIs[1] Operand 1
     /*  447599 */     // No operand predicates
     /*  447599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447631 */     GIR_RootConstrainSelectedInstOperands,
     /*  447632 */     // GIR_Coverage, 6422,
     /*  447632 */     GIR_EraseRootFromParent_Done,
     /*  447633 */   // Label 7712: @447633
     /*  447633 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(447719), // Rule ID 6423 //
     /*  447638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  447649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  447652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  447655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  447673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447685 */     // MIs[1] Operand 1
     /*  447685 */     // No operand predicates
     /*  447685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  447697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447717 */     GIR_RootConstrainSelectedInstOperands,
     /*  447718 */     // GIR_Coverage, 6423,
     /*  447718 */     GIR_EraseRootFromParent_Done,
     /*  447719 */   // Label 7713: @447719
     /*  447719 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(447805), // Rule ID 6426 //
     /*  447724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  447735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  447738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  447741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447771 */     // MIs[1] Operand 1
     /*  447771 */     // No operand predicates
     /*  447771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447780 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447803 */     GIR_RootConstrainSelectedInstOperands,
     /*  447804 */     // GIR_Coverage, 6426,
     /*  447804 */     GIR_EraseRootFromParent_Done,
     /*  447805 */   // Label 7714: @447805
     /*  447805 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(447891), // Rule ID 6427 //
     /*  447810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  447821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  447824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  447827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  447830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  447833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  447845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447857 */     // MIs[1] Operand 1
     /*  447857 */     // No operand predicates
     /*  447857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  447866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  447869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447889 */     GIR_RootConstrainSelectedInstOperands,
     /*  447890 */     // GIR_Coverage, 6427,
     /*  447890 */     GIR_EraseRootFromParent_Done,
     /*  447891 */   // Label 7715: @447891
     /*  447891 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(447977), // Rule ID 6430 //
     /*  447896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  447899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  447907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  447910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  447913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  447916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  447919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  447931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  447935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  447939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  447943 */     // MIs[1] Operand 1
     /*  447943 */     // No operand predicates
     /*  447943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  447945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  447952 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  447952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  447955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  447957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  447959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  447961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  447964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  447969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  447972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  447975 */     GIR_RootConstrainSelectedInstOperands,
     /*  447976 */     // GIR_Coverage, 6430,
     /*  447976 */     GIR_EraseRootFromParent_Done,
     /*  447977 */   // Label 7716: @447977
     /*  447977 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(448063), // Rule ID 6431 //
     /*  447982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  447985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  447990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  447993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  447996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  447999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448029 */     // MIs[1] Operand 1
     /*  448029 */     // No operand predicates
     /*  448029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448038 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  448038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  448058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448061 */     GIR_RootConstrainSelectedInstOperands,
     /*  448062 */     // GIR_Coverage, 6431,
     /*  448062 */     GIR_EraseRootFromParent_Done,
     /*  448063 */   // Label 7717: @448063
     /*  448063 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(448149), // Rule ID 6434 //
     /*  448068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448115 */     // MIs[1] Operand 1
     /*  448115 */     // No operand predicates
     /*  448115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448124 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448147 */     GIR_RootConstrainSelectedInstOperands,
     /*  448148 */     // GIR_Coverage, 6434,
     /*  448148 */     GIR_EraseRootFromParent_Done,
     /*  448149 */   // Label 7718: @448149
     /*  448149 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(448235), // Rule ID 6435 //
     /*  448154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  448165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  448168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  448171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  448189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448201 */     // MIs[1] Operand 1
     /*  448201 */     // No operand predicates
     /*  448201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448210 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2),
     /*  448213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448233 */     GIR_RootConstrainSelectedInstOperands,
     /*  448234 */     // GIR_Coverage, 6435,
     /*  448234 */     GIR_EraseRootFromParent_Done,
     /*  448235 */   // Label 7719: @448235
     /*  448235 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(448321), // Rule ID 6438 //
     /*  448240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448287 */     // MIs[1] Operand 1
     /*  448287 */     // No operand predicates
     /*  448287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448319 */     GIR_RootConstrainSelectedInstOperands,
     /*  448320 */     // GIR_Coverage, 6438,
     /*  448320 */     GIR_EraseRootFromParent_Done,
     /*  448321 */   // Label 7720: @448321
     /*  448321 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(448407), // Rule ID 6439 //
     /*  448326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  448337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  448340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  448343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  448361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448373 */     // MIs[1] Operand 1
     /*  448373 */     // No operand predicates
     /*  448373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448382 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4),
     /*  448385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448405 */     GIR_RootConstrainSelectedInstOperands,
     /*  448406 */     // GIR_Coverage, 6439,
     /*  448406 */     GIR_EraseRootFromParent_Done,
     /*  448407 */   // Label 7721: @448407
     /*  448407 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(448493), // Rule ID 6442 //
     /*  448412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  448415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448459 */     // MIs[1] Operand 1
     /*  448459 */     // No operand predicates
     /*  448459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448468 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  448468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448491 */     GIR_RootConstrainSelectedInstOperands,
     /*  448492 */     // GIR_Coverage, 6442,
     /*  448492 */     GIR_EraseRootFromParent_Done,
     /*  448493 */   // Label 7722: @448493
     /*  448493 */   GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(448579), // Rule ID 6443 //
     /*  448498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  448501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  448506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  448509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  448512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  448515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  448533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  448545 */     // MIs[1] Operand 1
     /*  448545 */     // No operand predicates
     /*  448545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448554 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  448554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8),
     /*  448557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  448574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448577 */     GIR_RootConstrainSelectedInstOperands,
     /*  448578 */     // GIR_Coverage, 6443,
     /*  448578 */     GIR_EraseRootFromParent_Done,
     /*  448579 */   // Label 7723: @448579
     /*  448579 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(448665), // Rule ID 6622 //
     /*  448584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  448592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  448595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  448598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  448601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448627 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  448631 */     // MIs[1] Operand 1
     /*  448631 */     // No operand predicates
     /*  448631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  448640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  448643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448663 */     GIR_RootConstrainSelectedInstOperands,
     /*  448664 */     // GIR_Coverage, 6622,
     /*  448664 */     GIR_EraseRootFromParent_Done,
     /*  448665 */   // Label 7724: @448665
     /*  448665 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(448751), // Rule ID 6623 //
     /*  448670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  448678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  448681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  448684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  448687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  448717 */     // MIs[1] Operand 1
     /*  448717 */     // No operand predicates
     /*  448717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  448726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8),
     /*  448729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448735 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448749 */     GIR_RootConstrainSelectedInstOperands,
     /*  448750 */     // GIR_Coverage, 6623,
     /*  448750 */     GIR_EraseRootFromParent_Done,
     /*  448751 */   // Label 7725: @448751
     /*  448751 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(448837), // Rule ID 6626 //
     /*  448756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  448764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  448767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  448770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  448773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  448803 */     // MIs[1] Operand 1
     /*  448803 */     // No operand predicates
     /*  448803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448812 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  448812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  448815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448835 */     GIR_RootConstrainSelectedInstOperands,
     /*  448836 */     // GIR_Coverage, 6626,
     /*  448836 */     GIR_EraseRootFromParent_Done,
     /*  448837 */   // Label 7726: @448837
     /*  448837 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(448923), // Rule ID 6627 //
     /*  448842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  448845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  448850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  448853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  448856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  448859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  448862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  448865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  448889 */     // MIs[1] Operand 1
     /*  448889 */     // No operand predicates
     /*  448889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448898 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  448898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  448901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  448915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  448918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  448921 */     GIR_RootConstrainSelectedInstOperands,
     /*  448922 */     // GIR_Coverage, 6627,
     /*  448922 */     GIR_EraseRootFromParent_Done,
     /*  448923 */   // Label 7727: @448923
     /*  448923 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(449009), // Rule ID 6630 //
     /*  448928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  448931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  448936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  448939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  448942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  448945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  448948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  448951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  448963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  448967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  448971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  448975 */     // MIs[1] Operand 1
     /*  448975 */     // No operand predicates
     /*  448975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  448977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  448984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  448984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  448987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  448989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  448991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  448993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  448996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449007 */     GIR_RootConstrainSelectedInstOperands,
     /*  449008 */     // GIR_Coverage, 6630,
     /*  449008 */     GIR_EraseRootFromParent_Done,
     /*  449009 */   // Label 7728: @449009
     /*  449009 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(449095), // Rule ID 6631 //
     /*  449014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  449025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  449028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  449031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449061 */     // MIs[1] Operand 1
     /*  449061 */     // No operand predicates
     /*  449061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449070 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449093 */     GIR_RootConstrainSelectedInstOperands,
     /*  449094 */     // GIR_Coverage, 6631,
     /*  449094 */     GIR_EraseRootFromParent_Done,
     /*  449095 */   // Label 7729: @449095
     /*  449095 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(449181), // Rule ID 6634 //
     /*  449100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449147 */     // MIs[1] Operand 1
     /*  449147 */     // No operand predicates
     /*  449147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449156 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449179 */     GIR_RootConstrainSelectedInstOperands,
     /*  449180 */     // GIR_Coverage, 6634,
     /*  449180 */     GIR_EraseRootFromParent_Done,
     /*  449181 */   // Label 7730: @449181
     /*  449181 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(449267), // Rule ID 6635 //
     /*  449186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  449197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  449200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  449203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449233 */     // MIs[1] Operand 1
     /*  449233 */     // No operand predicates
     /*  449233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449242 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4),
     /*  449245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449265 */     GIR_RootConstrainSelectedInstOperands,
     /*  449266 */     // GIR_Coverage, 6635,
     /*  449266 */     GIR_EraseRootFromParent_Done,
     /*  449267 */   // Label 7731: @449267
     /*  449267 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(449353), // Rule ID 6638 //
     /*  449272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449319 */     // MIs[1] Operand 1
     /*  449319 */     // No operand predicates
     /*  449319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449328 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449351 */     GIR_RootConstrainSelectedInstOperands,
     /*  449352 */     // GIR_Coverage, 6638,
     /*  449352 */     GIR_EraseRootFromParent_Done,
     /*  449353 */   // Label 7732: @449353
     /*  449353 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(449439), // Rule ID 6639 //
     /*  449358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  449369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  449372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  449375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449405 */     // MIs[1] Operand 1
     /*  449405 */     // No operand predicates
     /*  449405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449414 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449437 */     GIR_RootConstrainSelectedInstOperands,
     /*  449438 */     // GIR_Coverage, 6639,
     /*  449438 */     GIR_EraseRootFromParent_Done,
     /*  449439 */   // Label 7733: @449439
     /*  449439 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(449525), // Rule ID 6642 //
     /*  449444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  449455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  449458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  449461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449491 */     // MIs[1] Operand 1
     /*  449491 */     // No operand predicates
     /*  449491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  449500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449523 */     GIR_RootConstrainSelectedInstOperands,
     /*  449524 */     // GIR_Coverage, 6642,
     /*  449524 */     GIR_EraseRootFromParent_Done,
     /*  449525 */   // Label 7734: @449525
     /*  449525 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(449611), // Rule ID 6643 //
     /*  449530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  449541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  449544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  449547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449577 */     // MIs[1] Operand 1
     /*  449577 */     // No operand predicates
     /*  449577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  449586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2),
     /*  449589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  449606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449609 */     GIR_RootConstrainSelectedInstOperands,
     /*  449610 */     // GIR_Coverage, 6643,
     /*  449610 */     GIR_EraseRootFromParent_Done,
     /*  449611 */   // Label 7735: @449611
     /*  449611 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(449697), // Rule ID 6646 //
     /*  449616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  449627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  449630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  449633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449663 */     // MIs[1] Operand 1
     /*  449663 */     // No operand predicates
     /*  449663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  449672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  449675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449695 */     GIR_RootConstrainSelectedInstOperands,
     /*  449696 */     // GIR_Coverage, 6646,
     /*  449696 */     GIR_EraseRootFromParent_Done,
     /*  449697 */   // Label 7736: @449697
     /*  449697 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(449783), // Rule ID 6647 //
     /*  449702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  449713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  449716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  449719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449749 */     // MIs[1] Operand 1
     /*  449749 */     // No operand predicates
     /*  449749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  449758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  449761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  449778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449781 */     GIR_RootConstrainSelectedInstOperands,
     /*  449782 */     // GIR_Coverage, 6647,
     /*  449782 */     GIR_EraseRootFromParent_Done,
     /*  449783 */   // Label 7737: @449783
     /*  449783 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(449869), // Rule ID 6650 //
     /*  449788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  449799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  449802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  449805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449835 */     // MIs[1] Operand 1
     /*  449835 */     // No operand predicates
     /*  449835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  449844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  449847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449867 */     GIR_RootConstrainSelectedInstOperands,
     /*  449868 */     // GIR_Coverage, 6650,
     /*  449868 */     GIR_EraseRootFromParent_Done,
     /*  449869 */   // Label 7738: @449869
     /*  449869 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(449955), // Rule ID 6651 //
     /*  449874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  449877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  449885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  449888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  449891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  449894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  449897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  449917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  449921 */     // MIs[1] Operand 1
     /*  449921 */     // No operand predicates
     /*  449921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  449923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  449930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  449930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  449933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  449935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  449937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  449939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  449942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  449947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  449950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  449953 */     GIR_RootConstrainSelectedInstOperands,
     /*  449954 */     // GIR_Coverage, 6651,
     /*  449954 */     GIR_EraseRootFromParent_Done,
     /*  449955 */   // Label 7739: @449955
     /*  449955 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(450041), // Rule ID 6654 //
     /*  449960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  449963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  449968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  449971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  449974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  449977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  449980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  449983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  449995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  449999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450007 */     // MIs[1] Operand 1
     /*  450007 */     // No operand predicates
     /*  450007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  450016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450039 */     GIR_RootConstrainSelectedInstOperands,
     /*  450040 */     // GIR_Coverage, 6654,
     /*  450040 */     GIR_EraseRootFromParent_Done,
     /*  450041 */   // Label 7740: @450041
     /*  450041 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(450127), // Rule ID 6655 //
     /*  450046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  450057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  450060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  450063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450093 */     // MIs[1] Operand 1
     /*  450093 */     // No operand predicates
     /*  450093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450102 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  450102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  450122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450125 */     GIR_RootConstrainSelectedInstOperands,
     /*  450126 */     // GIR_Coverage, 6655,
     /*  450126 */     GIR_EraseRootFromParent_Done,
     /*  450127 */   // Label 7741: @450127
     /*  450127 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(450213), // Rule ID 6658 //
     /*  450132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  450135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450179 */     // MIs[1] Operand 1
     /*  450179 */     // No operand predicates
     /*  450179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  450188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450211 */     GIR_RootConstrainSelectedInstOperands,
     /*  450212 */     // GIR_Coverage, 6658,
     /*  450212 */     GIR_EraseRootFromParent_Done,
     /*  450213 */   // Label 7742: @450213
     /*  450213 */   GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(450299), // Rule ID 6659 //
     /*  450218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  450221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  450229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  450232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  450235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  450253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450265 */     // MIs[1] Operand 1
     /*  450265 */     // No operand predicates
     /*  450265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450274 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  450274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1),
     /*  450277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  450294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450297 */     GIR_RootConstrainSelectedInstOperands,
     /*  450298 */     // GIR_Coverage, 6659,
     /*  450298 */     GIR_EraseRootFromParent_Done,
     /*  450299 */   // Label 7743: @450299
     /*  450299 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(450385), // Rule ID 6662 //
     /*  450304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450351 */     // MIs[1] Operand 1
     /*  450351 */     // No operand predicates
     /*  450351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450383 */     GIR_RootConstrainSelectedInstOperands,
     /*  450384 */     // GIR_Coverage, 6662,
     /*  450384 */     GIR_EraseRootFromParent_Done,
     /*  450385 */   // Label 7744: @450385
     /*  450385 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(450471), // Rule ID 6663 //
     /*  450390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  450401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  450404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  450407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450437 */     // MIs[1] Operand 1
     /*  450437 */     // No operand predicates
     /*  450437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450469 */     GIR_RootConstrainSelectedInstOperands,
     /*  450470 */     // GIR_Coverage, 6663,
     /*  450470 */     GIR_EraseRootFromParent_Done,
     /*  450471 */   // Label 7745: @450471
     /*  450471 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(450557), // Rule ID 6666 //
     /*  450476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  450487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  450490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  450493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450523 */     // MIs[1] Operand 1
     /*  450523 */     // No operand predicates
     /*  450523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450532 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  450535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450555 */     GIR_RootConstrainSelectedInstOperands,
     /*  450556 */     // GIR_Coverage, 6666,
     /*  450556 */     GIR_EraseRootFromParent_Done,
     /*  450557 */   // Label 7746: @450557
     /*  450557 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(450643), // Rule ID 6667 //
     /*  450562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  450573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  450576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  450579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  450597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450609 */     // MIs[1] Operand 1
     /*  450609 */     // No operand predicates
     /*  450609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450618 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  450621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450641 */     GIR_RootConstrainSelectedInstOperands,
     /*  450642 */     // GIR_Coverage, 6667,
     /*  450642 */     GIR_EraseRootFromParent_Done,
     /*  450643 */   // Label 7747: @450643
     /*  450643 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(450729), // Rule ID 6670 //
     /*  450648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  450659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  450662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  450665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450695 */     // MIs[1] Operand 1
     /*  450695 */     // No operand predicates
     /*  450695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450704 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  450704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  450707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450727 */     GIR_RootConstrainSelectedInstOperands,
     /*  450728 */     // GIR_Coverage, 6670,
     /*  450728 */     GIR_EraseRootFromParent_Done,
     /*  450729 */   // Label 7748: @450729
     /*  450729 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(450815), // Rule ID 6671 //
     /*  450734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  450745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  450748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  450751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  450769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450781 */     // MIs[1] Operand 1
     /*  450781 */     // No operand predicates
     /*  450781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450790 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  450790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  450793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  450810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450813 */     GIR_RootConstrainSelectedInstOperands,
     /*  450814 */     // GIR_Coverage, 6671,
     /*  450814 */     GIR_EraseRootFromParent_Done,
     /*  450815 */   // Label 7749: @450815
     /*  450815 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(450901), // Rule ID 6674 //
     /*  450820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  450831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  450834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  450837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  450840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  450843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450867 */     // MIs[1] Operand 1
     /*  450867 */     // No operand predicates
     /*  450867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  450876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450899 */     GIR_RootConstrainSelectedInstOperands,
     /*  450900 */     // GIR_Coverage, 6674,
     /*  450900 */     GIR_EraseRootFromParent_Done,
     /*  450901 */   // Label 7750: @450901
     /*  450901 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(450987), // Rule ID 6675 //
     /*  450906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  450909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  450914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  450917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  450920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  450923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  450926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  450929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  450941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  450945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  450949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  450953 */     // MIs[1] Operand 1
     /*  450953 */     // No operand predicates
     /*  450953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  450955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  450962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  450962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  450965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  450967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  450969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  450971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  450974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  450979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  450982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  450985 */     GIR_RootConstrainSelectedInstOperands,
     /*  450986 */     // GIR_Coverage, 6675,
     /*  450986 */     GIR_EraseRootFromParent_Done,
     /*  450987 */   // Label 7751: @450987
     /*  450987 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(451073), // Rule ID 6678 //
     /*  450992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  450995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451039 */     // MIs[1] Operand 1
     /*  451039 */     // No operand predicates
     /*  451039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451071 */     GIR_RootConstrainSelectedInstOperands,
     /*  451072 */     // GIR_Coverage, 6678,
     /*  451072 */     GIR_EraseRootFromParent_Done,
     /*  451073 */   // Label 7752: @451073
     /*  451073 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(451159), // Rule ID 6679 //
     /*  451078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  451089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  451092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  451095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451125 */     // MIs[1] Operand 1
     /*  451125 */     // No operand predicates
     /*  451125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451157 */     GIR_RootConstrainSelectedInstOperands,
     /*  451158 */     // GIR_Coverage, 6679,
     /*  451158 */     GIR_EraseRootFromParent_Done,
     /*  451159 */   // Label 7753: @451159
     /*  451159 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(451245), // Rule ID 6682 //
     /*  451164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451211 */     // MIs[1] Operand 1
     /*  451211 */     // No operand predicates
     /*  451211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  451220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451243 */     GIR_RootConstrainSelectedInstOperands,
     /*  451244 */     // GIR_Coverage, 6682,
     /*  451244 */     GIR_EraseRootFromParent_Done,
     /*  451245 */   // Label 7754: @451245
     /*  451245 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(451331), // Rule ID 6683 //
     /*  451250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  451261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  451264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  451267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451297 */     // MIs[1] Operand 1
     /*  451297 */     // No operand predicates
     /*  451297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  451306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  451326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451329 */     GIR_RootConstrainSelectedInstOperands,
     /*  451330 */     // GIR_Coverage, 6683,
     /*  451330 */     GIR_EraseRootFromParent_Done,
     /*  451331 */   // Label 7755: @451331
     /*  451331 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(451417), // Rule ID 6686 //
     /*  451336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451383 */     // MIs[1] Operand 1
     /*  451383 */     // No operand predicates
     /*  451383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451415 */     GIR_RootConstrainSelectedInstOperands,
     /*  451416 */     // GIR_Coverage, 6686,
     /*  451416 */     GIR_EraseRootFromParent_Done,
     /*  451417 */   // Label 7756: @451417
     /*  451417 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(451503), // Rule ID 6687 //
     /*  451422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  451433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  451436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  451439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451469 */     // MIs[1] Operand 1
     /*  451469 */     // No operand predicates
     /*  451469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451501 */     GIR_RootConstrainSelectedInstOperands,
     /*  451502 */     // GIR_Coverage, 6687,
     /*  451502 */     GIR_EraseRootFromParent_Done,
     /*  451503 */   // Label 7757: @451503
     /*  451503 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(451589), // Rule ID 6690 //
     /*  451508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  451519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  451522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  451525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451555 */     // MIs[1] Operand 1
     /*  451555 */     // No operand predicates
     /*  451555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451587 */     GIR_RootConstrainSelectedInstOperands,
     /*  451588 */     // GIR_Coverage, 6690,
     /*  451588 */     GIR_EraseRootFromParent_Done,
     /*  451589 */   // Label 7758: @451589
     /*  451589 */   GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(451675), // Rule ID 6691 //
     /*  451594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  451605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  451608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  451611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  451629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451641 */     // MIs[1] Operand 1
     /*  451641 */     // No operand predicates
     /*  451641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  451653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451673 */     GIR_RootConstrainSelectedInstOperands,
     /*  451674 */     // GIR_Coverage, 6691,
     /*  451674 */     GIR_EraseRootFromParent_Done,
     /*  451675 */   // Label 7759: @451675
     /*  451675 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(451761), // Rule ID 6694 //
     /*  451680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  451683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  451691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  451694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  451697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451727 */     // MIs[1] Operand 1
     /*  451727 */     // No operand predicates
     /*  451727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  451736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451759 */     GIR_RootConstrainSelectedInstOperands,
     /*  451760 */     // GIR_Coverage, 6694,
     /*  451760 */     GIR_EraseRootFromParent_Done,
     /*  451761 */   // Label 7760: @451761
     /*  451761 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(451847), // Rule ID 6695 //
     /*  451766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  451769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  451777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  451780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  451783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  451801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451813 */     // MIs[1] Operand 1
     /*  451813 */     // No operand predicates
     /*  451813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  451822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  451825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  451842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451845 */     GIR_RootConstrainSelectedInstOperands,
     /*  451846 */     // GIR_Coverage, 6695,
     /*  451846 */     GIR_EraseRootFromParent_Done,
     /*  451847 */   // Label 7761: @451847
     /*  451847 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(451933), // Rule ID 6698 //
     /*  451852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  451855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  451863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  451866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  451869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  451872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  451875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451899 */     // MIs[1] Operand 1
     /*  451899 */     // No operand predicates
     /*  451899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  451908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  451915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  451917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  451920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  451925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  451928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  451931 */     GIR_RootConstrainSelectedInstOperands,
     /*  451932 */     // GIR_Coverage, 6698,
     /*  451932 */     GIR_EraseRootFromParent_Done,
     /*  451933 */   // Label 7762: @451933
     /*  451933 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(452019), // Rule ID 6699 //
     /*  451938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  451941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  451946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  451949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  451952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  451955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  451958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  451961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  451973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  451977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  451981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  451985 */     // MIs[1] Operand 1
     /*  451985 */     // No operand predicates
     /*  451985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  451987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  451994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  451994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2),
     /*  451997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  451999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452017 */     GIR_RootConstrainSelectedInstOperands,
     /*  452018 */     // GIR_Coverage, 6699,
     /*  452018 */     GIR_EraseRootFromParent_Done,
     /*  452019 */   // Label 7763: @452019
     /*  452019 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(452105), // Rule ID 6702 //
     /*  452024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452071 */     // MIs[1] Operand 1
     /*  452071 */     // No operand predicates
     /*  452071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452103 */     GIR_RootConstrainSelectedInstOperands,
     /*  452104 */     // GIR_Coverage, 6702,
     /*  452104 */     GIR_EraseRootFromParent_Done,
     /*  452105 */   // Label 7764: @452105
     /*  452105 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(452191), // Rule ID 6703 //
     /*  452110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  452121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  452124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  452127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  452145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452157 */     // MIs[1] Operand 1
     /*  452157 */     // No operand predicates
     /*  452157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452166 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4),
     /*  452169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452189 */     GIR_RootConstrainSelectedInstOperands,
     /*  452190 */     // GIR_Coverage, 6703,
     /*  452190 */     GIR_EraseRootFromParent_Done,
     /*  452191 */   // Label 7765: @452191
     /*  452191 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(452277), // Rule ID 6706 //
     /*  452196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  452199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452243 */     // MIs[1] Operand 1
     /*  452243 */     // No operand predicates
     /*  452243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452252 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  452252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452275 */     GIR_RootConstrainSelectedInstOperands,
     /*  452276 */     // GIR_Coverage, 6706,
     /*  452276 */     GIR_EraseRootFromParent_Done,
     /*  452277 */   // Label 7766: @452277
     /*  452277 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(452363), // Rule ID 6707 //
     /*  452282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  452285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  452290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  452293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  452296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  452299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  452317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452329 */     // MIs[1] Operand 1
     /*  452329 */     // No operand predicates
     /*  452329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452338 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  452338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8),
     /*  452341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  452358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452361 */     GIR_RootConstrainSelectedInstOperands,
     /*  452362 */     // GIR_Coverage, 6707,
     /*  452362 */     GIR_EraseRootFromParent_Done,
     /*  452363 */   // Label 7767: @452363
     /*  452363 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(452449), // Rule ID 6886 //
     /*  452368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452415 */     // MIs[1] Operand 1
     /*  452415 */     // No operand predicates
     /*  452415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452424 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  452427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452447 */     GIR_RootConstrainSelectedInstOperands,
     /*  452448 */     // GIR_Coverage, 6886,
     /*  452448 */     GIR_EraseRootFromParent_Done,
     /*  452449 */   // Label 7768: @452449
     /*  452449 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(452535), // Rule ID 6887 //
     /*  452454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  452465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  452468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  452471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452501 */     // MIs[1] Operand 1
     /*  452501 */     // No operand predicates
     /*  452501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452510 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8),
     /*  452513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452533 */     GIR_RootConstrainSelectedInstOperands,
     /*  452534 */     // GIR_Coverage, 6887,
     /*  452534 */     GIR_EraseRootFromParent_Done,
     /*  452535 */   // Label 7769: @452535
     /*  452535 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(452621), // Rule ID 6890 //
     /*  452540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  452551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  452554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  452557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452587 */     // MIs[1] Operand 1
     /*  452587 */     // No operand predicates
     /*  452587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  452599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452619 */     GIR_RootConstrainSelectedInstOperands,
     /*  452620 */     // GIR_Coverage, 6890,
     /*  452620 */     GIR_EraseRootFromParent_Done,
     /*  452621 */   // Label 7770: @452621
     /*  452621 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(452707), // Rule ID 6891 //
     /*  452626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  452637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  452640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  452643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452673 */     // MIs[1] Operand 1
     /*  452673 */     // No operand predicates
     /*  452673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452682 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  452685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452705 */     GIR_RootConstrainSelectedInstOperands,
     /*  452706 */     // GIR_Coverage, 6891,
     /*  452706 */     GIR_EraseRootFromParent_Done,
     /*  452707 */   // Label 7771: @452707
     /*  452707 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(452793), // Rule ID 6894 //
     /*  452712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  452723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  452726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  452729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452759 */     // MIs[1] Operand 1
     /*  452759 */     // No operand predicates
     /*  452759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452768 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  452768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  452771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452791 */     GIR_RootConstrainSelectedInstOperands,
     /*  452792 */     // GIR_Coverage, 6894,
     /*  452792 */     GIR_EraseRootFromParent_Done,
     /*  452793 */   // Label 7772: @452793
     /*  452793 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(452879), // Rule ID 6895 //
     /*  452798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  452809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  452812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  452815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452845 */     // MIs[1] Operand 1
     /*  452845 */     // No operand predicates
     /*  452845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452854 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  452854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  452857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  452874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452877 */     GIR_RootConstrainSelectedInstOperands,
     /*  452878 */     // GIR_Coverage, 6895,
     /*  452878 */     GIR_EraseRootFromParent_Done,
     /*  452879 */   // Label 7773: @452879
     /*  452879 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(452965), // Rule ID 6898 //
     /*  452884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  452887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  452895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  452898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  452901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  452904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  452907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  452923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  452927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  452931 */     // MIs[1] Operand 1
     /*  452931 */     // No operand predicates
     /*  452931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  452933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  452940 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  452940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  452943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  452945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  452947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  452949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  452952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  452957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  452960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  452963 */     GIR_RootConstrainSelectedInstOperands,
     /*  452964 */     // GIR_Coverage, 6898,
     /*  452964 */     GIR_EraseRootFromParent_Done,
     /*  452965 */   // Label 7774: @452965
     /*  452965 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(453051), // Rule ID 6899 //
     /*  452970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  452973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  452978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  452981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  452984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  452987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  452990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  452993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  452997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453017 */     // MIs[1] Operand 1
     /*  453017 */     // No operand predicates
     /*  453017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4),
     /*  453029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453049 */     GIR_RootConstrainSelectedInstOperands,
     /*  453050 */     // GIR_Coverage, 6899,
     /*  453050 */     GIR_EraseRootFromParent_Done,
     /*  453051 */   // Label 7775: @453051
     /*  453051 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(453137), // Rule ID 6902 //
     /*  453056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453103 */     // MIs[1] Operand 1
     /*  453103 */     // No operand predicates
     /*  453103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453112 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453135 */     GIR_RootConstrainSelectedInstOperands,
     /*  453136 */     // GIR_Coverage, 6902,
     /*  453136 */     GIR_EraseRootFromParent_Done,
     /*  453137 */   // Label 7776: @453137
     /*  453137 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(453223), // Rule ID 6903 //
     /*  453142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  453153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  453156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  453159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453189 */     // MIs[1] Operand 1
     /*  453189 */     // No operand predicates
     /*  453189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453198 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453221 */     GIR_RootConstrainSelectedInstOperands,
     /*  453222 */     // GIR_Coverage, 6903,
     /*  453222 */     GIR_EraseRootFromParent_Done,
     /*  453223 */   // Label 7777: @453223
     /*  453223 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(453309), // Rule ID 6906 //
     /*  453228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453275 */     // MIs[1] Operand 1
     /*  453275 */     // No operand predicates
     /*  453275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453307 */     GIR_RootConstrainSelectedInstOperands,
     /*  453308 */     // GIR_Coverage, 6906,
     /*  453308 */     GIR_EraseRootFromParent_Done,
     /*  453309 */   // Label 7778: @453309
     /*  453309 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(453395), // Rule ID 6907 //
     /*  453314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  453325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  453328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  453331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453361 */     // MIs[1] Operand 1
     /*  453361 */     // No operand predicates
     /*  453361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2),
     /*  453373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453393 */     GIR_RootConstrainSelectedInstOperands,
     /*  453394 */     // GIR_Coverage, 6907,
     /*  453394 */     GIR_EraseRootFromParent_Done,
     /*  453395 */   // Label 7779: @453395
     /*  453395 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(453481), // Rule ID 6910 //
     /*  453400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453447 */     // MIs[1] Operand 1
     /*  453447 */     // No operand predicates
     /*  453447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  453456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453479 */     GIR_RootConstrainSelectedInstOperands,
     /*  453480 */     // GIR_Coverage, 6910,
     /*  453480 */     GIR_EraseRootFromParent_Done,
     /*  453481 */   // Label 7780: @453481
     /*  453481 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(453567), // Rule ID 6911 //
     /*  453486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  453497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  453500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  453503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453533 */     // MIs[1] Operand 1
     /*  453533 */     // No operand predicates
     /*  453533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453542 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  453542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  453562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453565 */     GIR_RootConstrainSelectedInstOperands,
     /*  453566 */     // GIR_Coverage, 6911,
     /*  453566 */     GIR_EraseRootFromParent_Done,
     /*  453567 */   // Label 7781: @453567
     /*  453567 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(453653), // Rule ID 6914 //
     /*  453572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  453583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  453586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  453589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453619 */     // MIs[1] Operand 1
     /*  453619 */     // No operand predicates
     /*  453619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  453628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453651 */     GIR_RootConstrainSelectedInstOperands,
     /*  453652 */     // GIR_Coverage, 6914,
     /*  453652 */     GIR_EraseRootFromParent_Done,
     /*  453653 */   // Label 7782: @453653
     /*  453653 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(453739), // Rule ID 6915 //
     /*  453658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  453669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  453672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  453675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453705 */     // MIs[1] Operand 1
     /*  453705 */     // No operand predicates
     /*  453705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453714 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  453714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  453734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453737 */     GIR_RootConstrainSelectedInstOperands,
     /*  453738 */     // GIR_Coverage, 6915,
     /*  453738 */     GIR_EraseRootFromParent_Done,
     /*  453739 */   // Label 7783: @453739
     /*  453739 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(453825), // Rule ID 6918 //
     /*  453744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  453747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  453755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  453758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  453761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453791 */     // MIs[1] Operand 1
     /*  453791 */     // No operand predicates
     /*  453791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  453800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453823 */     GIR_RootConstrainSelectedInstOperands,
     /*  453824 */     // GIR_Coverage, 6918,
     /*  453824 */     GIR_EraseRootFromParent_Done,
     /*  453825 */   // Label 7784: @453825
     /*  453825 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(453911), // Rule ID 6919 //
     /*  453830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  453833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  453841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  453844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  453847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  453850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  453853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453877 */     // MIs[1] Operand 1
     /*  453877 */     // No operand predicates
     /*  453877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  453886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  453906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453909 */     GIR_RootConstrainSelectedInstOperands,
     /*  453910 */     // GIR_Coverage, 6919,
     /*  453910 */     GIR_EraseRootFromParent_Done,
     /*  453911 */   // Label 7785: @453911
     /*  453911 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(453997), // Rule ID 6922 //
     /*  453916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  453919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  453924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  453927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  453930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  453933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  453936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  453939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  453951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  453955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  453959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  453963 */     // MIs[1] Operand 1
     /*  453963 */     // No operand predicates
     /*  453963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  453965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  453972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  453972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  453975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  453977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  453979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  453981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  453984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  453989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  453992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  453995 */     GIR_RootConstrainSelectedInstOperands,
     /*  453996 */     // GIR_Coverage, 6922,
     /*  453996 */     GIR_EraseRootFromParent_Done,
     /*  453997 */   // Label 7786: @453997
     /*  453997 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(454083), // Rule ID 6923 //
     /*  454002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  454005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  454013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  454016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  454019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  454037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454049 */     // MIs[1] Operand 1
     /*  454049 */     // No operand predicates
     /*  454049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  454058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1),
     /*  454061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  454078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454081 */     GIR_RootConstrainSelectedInstOperands,
     /*  454082 */     // GIR_Coverage, 6923,
     /*  454082 */     GIR_EraseRootFromParent_Done,
     /*  454083 */   // Label 7787: @454083
     /*  454083 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(454169), // Rule ID 6926 //
     /*  454088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454135 */     // MIs[1] Operand 1
     /*  454135 */     // No operand predicates
     /*  454135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454167 */     GIR_RootConstrainSelectedInstOperands,
     /*  454168 */     // GIR_Coverage, 6926,
     /*  454168 */     GIR_EraseRootFromParent_Done,
     /*  454169 */   // Label 7788: @454169
     /*  454169 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(454255), // Rule ID 6927 //
     /*  454174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  454185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  454188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  454191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454221 */     // MIs[1] Operand 1
     /*  454221 */     // No operand predicates
     /*  454221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454230 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454253 */     GIR_RootConstrainSelectedInstOperands,
     /*  454254 */     // GIR_Coverage, 6927,
     /*  454254 */     GIR_EraseRootFromParent_Done,
     /*  454255 */   // Label 7789: @454255
     /*  454255 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(454341), // Rule ID 6930 //
     /*  454260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454307 */     // MIs[1] Operand 1
     /*  454307 */     // No operand predicates
     /*  454307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454339 */     GIR_RootConstrainSelectedInstOperands,
     /*  454340 */     // GIR_Coverage, 6930,
     /*  454340 */     GIR_EraseRootFromParent_Done,
     /*  454341 */   // Label 7790: @454341
     /*  454341 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(454427), // Rule ID 6931 //
     /*  454346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  454357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  454360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  454363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454393 */     // MIs[1] Operand 1
     /*  454393 */     // No operand predicates
     /*  454393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454402 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454425 */     GIR_RootConstrainSelectedInstOperands,
     /*  454426 */     // GIR_Coverage, 6931,
     /*  454426 */     GIR_EraseRootFromParent_Done,
     /*  454427 */   // Label 7791: @454427
     /*  454427 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(454513), // Rule ID 6934 //
     /*  454432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454479 */     // MIs[1] Operand 1
     /*  454479 */     // No operand predicates
     /*  454479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454488 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  454488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  454491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454511 */     GIR_RootConstrainSelectedInstOperands,
     /*  454512 */     // GIR_Coverage, 6934,
     /*  454512 */     GIR_EraseRootFromParent_Done,
     /*  454513 */   // Label 7792: @454513
     /*  454513 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(454599), // Rule ID 6935 //
     /*  454518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  454529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  454532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  454535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454565 */     // MIs[1] Operand 1
     /*  454565 */     // No operand predicates
     /*  454565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  454574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  454577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  454594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454597 */     GIR_RootConstrainSelectedInstOperands,
     /*  454598 */     // GIR_Coverage, 6935,
     /*  454598 */     GIR_EraseRootFromParent_Done,
     /*  454599 */   // Label 7793: @454599
     /*  454599 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(454685), // Rule ID 6938 //
     /*  454604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  454615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  454618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  454621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454651 */     // MIs[1] Operand 1
     /*  454651 */     // No operand predicates
     /*  454651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454683 */     GIR_RootConstrainSelectedInstOperands,
     /*  454684 */     // GIR_Coverage, 6938,
     /*  454684 */     GIR_EraseRootFromParent_Done,
     /*  454685 */   // Label 7794: @454685
     /*  454685 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(454771), // Rule ID 6939 //
     /*  454690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  454701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  454704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  454707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  454725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454737 */     // MIs[1] Operand 1
     /*  454737 */     // No operand predicates
     /*  454737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454746 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  454749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454769 */     GIR_RootConstrainSelectedInstOperands,
     /*  454770 */     // GIR_Coverage, 6939,
     /*  454770 */     GIR_EraseRootFromParent_Done,
     /*  454771 */   // Label 7795: @454771
     /*  454771 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(454857), // Rule ID 6942 //
     /*  454776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  454787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  454790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  454793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454823 */     // MIs[1] Operand 1
     /*  454823 */     // No operand predicates
     /*  454823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454832 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  454832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454855 */     GIR_RootConstrainSelectedInstOperands,
     /*  454856 */     // GIR_Coverage, 6942,
     /*  454856 */     GIR_EraseRootFromParent_Done,
     /*  454857 */   // Label 7796: @454857
     /*  454857 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(454943), // Rule ID 6943 //
     /*  454862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  454865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  454873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  454876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  454879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  454882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  454885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  454897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454909 */     // MIs[1] Operand 1
     /*  454909 */     // No operand predicates
     /*  454909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  454918 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  454918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  454921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  454923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  454925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  454927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  454930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  454935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  454938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  454941 */     GIR_RootConstrainSelectedInstOperands,
     /*  454942 */     // GIR_Coverage, 6943,
     /*  454942 */     GIR_EraseRootFromParent_Done,
     /*  454943 */   // Label 7797: @454943
     /*  454943 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(455029), // Rule ID 6946 //
     /*  454948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  454951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  454956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  454959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  454962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  454965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  454968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  454971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  454983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  454987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  454991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  454995 */     // MIs[1] Operand 1
     /*  454995 */     // No operand predicates
     /*  454995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  454997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455004 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  455004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455027 */     GIR_RootConstrainSelectedInstOperands,
     /*  455028 */     // GIR_Coverage, 6946,
     /*  455028 */     GIR_EraseRootFromParent_Done,
     /*  455029 */   // Label 7798: @455029
     /*  455029 */   GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(455115), // Rule ID 6947 //
     /*  455034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  455045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  455048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  455051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455081 */     // MIs[1] Operand 1
     /*  455081 */     // No operand predicates
     /*  455081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455090 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  455090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  455110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455113 */     GIR_RootConstrainSelectedInstOperands,
     /*  455114 */     // GIR_Coverage, 6947,
     /*  455114 */     GIR_EraseRootFromParent_Done,
     /*  455115 */   // Label 7799: @455115
     /*  455115 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(455201), // Rule ID 6950 //
     /*  455120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455167 */     // MIs[1] Operand 1
     /*  455167 */     // No operand predicates
     /*  455167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455176 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455199 */     GIR_RootConstrainSelectedInstOperands,
     /*  455200 */     // GIR_Coverage, 6950,
     /*  455200 */     GIR_EraseRootFromParent_Done,
     /*  455201 */   // Label 7800: @455201
     /*  455201 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(455287), // Rule ID 6951 //
     /*  455206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  455217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  455220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  455223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455253 */     // MIs[1] Operand 1
     /*  455253 */     // No operand predicates
     /*  455253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455285 */     GIR_RootConstrainSelectedInstOperands,
     /*  455286 */     // GIR_Coverage, 6951,
     /*  455286 */     GIR_EraseRootFromParent_Done,
     /*  455287 */   // Label 7801: @455287
     /*  455287 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(455373), // Rule ID 6954 //
     /*  455292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455339 */     // MIs[1] Operand 1
     /*  455339 */     // No operand predicates
     /*  455339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455348 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455371 */     GIR_RootConstrainSelectedInstOperands,
     /*  455372 */     // GIR_Coverage, 6954,
     /*  455372 */     GIR_EraseRootFromParent_Done,
     /*  455373 */   // Label 7802: @455373
     /*  455373 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(455459), // Rule ID 6955 //
     /*  455378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  455389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  455392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  455395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455425 */     // MIs[1] Operand 1
     /*  455425 */     // No operand predicates
     /*  455425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455434 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455457 */     GIR_RootConstrainSelectedInstOperands,
     /*  455458 */     // GIR_Coverage, 6955,
     /*  455458 */     GIR_EraseRootFromParent_Done,
     /*  455459 */   // Label 7803: @455459
     /*  455459 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(455545), // Rule ID 6958 //
     /*  455464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  455467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  455481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455511 */     // MIs[1] Operand 1
     /*  455511 */     // No operand predicates
     /*  455511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  455520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455543 */     GIR_RootConstrainSelectedInstOperands,
     /*  455544 */     // GIR_Coverage, 6958,
     /*  455544 */     GIR_EraseRootFromParent_Done,
     /*  455545 */   // Label 7804: @455545
     /*  455545 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(455631), // Rule ID 6959 //
     /*  455550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  455553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  455561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  455564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  455567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  455585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455597 */     // MIs[1] Operand 1
     /*  455597 */     // No operand predicates
     /*  455597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  455606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  455609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  455626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455629 */     GIR_RootConstrainSelectedInstOperands,
     /*  455630 */     // GIR_Coverage, 6959,
     /*  455630 */     GIR_EraseRootFromParent_Done,
     /*  455631 */   // Label 7805: @455631
     /*  455631 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(455717), // Rule ID 6962 //
     /*  455636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  455647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  455650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  455653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455683 */     // MIs[1] Operand 1
     /*  455683 */     // No operand predicates
     /*  455683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  455692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455715 */     GIR_RootConstrainSelectedInstOperands,
     /*  455716 */     // GIR_Coverage, 6962,
     /*  455716 */     GIR_EraseRootFromParent_Done,
     /*  455717 */   // Label 7806: @455717
     /*  455717 */   GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(455803), // Rule ID 6963 //
     /*  455722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  455725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  455733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  455736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  455739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  455757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455769 */     // MIs[1] Operand 1
     /*  455769 */     // No operand predicates
     /*  455769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2),
     /*  455781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455801 */     GIR_RootConstrainSelectedInstOperands,
     /*  455802 */     // GIR_Coverage, 6963,
     /*  455802 */     GIR_EraseRootFromParent_Done,
     /*  455803 */   // Label 7807: @455803
     /*  455803 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(455889), // Rule ID 6966 //
     /*  455808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  455819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  455822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  455825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  455828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  455831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455855 */     // MIs[1] Operand 1
     /*  455855 */     // No operand predicates
     /*  455855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455864 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  455864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455887 */     GIR_RootConstrainSelectedInstOperands,
     /*  455888 */     // GIR_Coverage, 6966,
     /*  455888 */     GIR_EraseRootFromParent_Done,
     /*  455889 */   // Label 7808: @455889
     /*  455889 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(455975), // Rule ID 6967 //
     /*  455894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  455897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  455905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  455908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  455911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  455914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  455917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  455929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  455933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  455937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  455941 */     // MIs[1] Operand 1
     /*  455941 */     // No operand predicates
     /*  455941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  455943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  455950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  455950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4),
     /*  455953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  455955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  455957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  455959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  455962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  455967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  455970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  455973 */     GIR_RootConstrainSelectedInstOperands,
     /*  455974 */     // GIR_Coverage, 6967,
     /*  455974 */     GIR_EraseRootFromParent_Done,
     /*  455975 */   // Label 7809: @455975
     /*  455975 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(456061), // Rule ID 6970 //
     /*  455980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  455983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  455988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  455991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  455994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  455997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456027 */     // MIs[1] Operand 1
     /*  456027 */     // No operand predicates
     /*  456027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456036 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  456036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456059 */     GIR_RootConstrainSelectedInstOperands,
     /*  456060 */     // GIR_Coverage, 6970,
     /*  456060 */     GIR_EraseRootFromParent_Done,
     /*  456061 */   // Label 7810: @456061
     /*  456061 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(456147), // Rule ID 6971 //
     /*  456066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  456069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  456074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  456077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  456080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  456083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  456101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456113 */     // MIs[1] Operand 1
     /*  456113 */     // No operand predicates
     /*  456113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456122 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  456122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8),
     /*  456125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  456142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456145 */     GIR_RootConstrainSelectedInstOperands,
     /*  456146 */     // GIR_Coverage, 6971,
     /*  456146 */     GIR_EraseRootFromParent_Done,
     /*  456147 */   // Label 7811: @456147
     /*  456147 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(456233), // Rule ID 7150 //
     /*  456152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456199 */     // MIs[1] Operand 1
     /*  456199 */     // No operand predicates
     /*  456199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456208 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456231 */     GIR_RootConstrainSelectedInstOperands,
     /*  456232 */     // GIR_Coverage, 7150,
     /*  456232 */     GIR_EraseRootFromParent_Done,
     /*  456233 */   // Label 7812: @456233
     /*  456233 */   GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(456319), // Rule ID 7151 //
     /*  456238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  456249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  456252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  456255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456285 */     // MIs[1] Operand 1
     /*  456285 */     // No operand predicates
     /*  456285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456294 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8),
     /*  456297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456317 */     GIR_RootConstrainSelectedInstOperands,
     /*  456318 */     // GIR_Coverage, 7151,
     /*  456318 */     GIR_EraseRootFromParent_Done,
     /*  456319 */   // Label 7813: @456319
     /*  456319 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(456405), // Rule ID 7154 //
     /*  456324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456371 */     // MIs[1] Operand 1
     /*  456371 */     // No operand predicates
     /*  456371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456403 */     GIR_RootConstrainSelectedInstOperands,
     /*  456404 */     // GIR_Coverage, 7154,
     /*  456404 */     GIR_EraseRootFromParent_Done,
     /*  456405 */   // Label 7814: @456405
     /*  456405 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(456491), // Rule ID 7155 //
     /*  456410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  456421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  456424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  456427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456457 */     // MIs[1] Operand 1
     /*  456457 */     // No operand predicates
     /*  456457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456466 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456489 */     GIR_RootConstrainSelectedInstOperands,
     /*  456490 */     // GIR_Coverage, 7155,
     /*  456490 */     GIR_EraseRootFromParent_Done,
     /*  456491 */   // Label 7815: @456491
     /*  456491 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(456577), // Rule ID 7158 //
     /*  456496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  456507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  456510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  456513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456543 */     // MIs[1] Operand 1
     /*  456543 */     // No operand predicates
     /*  456543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456552 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  456552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  456555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456575 */     GIR_RootConstrainSelectedInstOperands,
     /*  456576 */     // GIR_Coverage, 7158,
     /*  456576 */     GIR_EraseRootFromParent_Done,
     /*  456577 */   // Label 7816: @456577
     /*  456577 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(456663), // Rule ID 7159 //
     /*  456582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  456593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  456596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  456599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456629 */     // MIs[1] Operand 1
     /*  456629 */     // No operand predicates
     /*  456629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456638 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  456638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  456641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  456658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456661 */     GIR_RootConstrainSelectedInstOperands,
     /*  456662 */     // GIR_Coverage, 7159,
     /*  456662 */     GIR_EraseRootFromParent_Done,
     /*  456663 */   // Label 7817: @456663
     /*  456663 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(456749), // Rule ID 7162 //
     /*  456668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  456679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  456682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  456685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456715 */     // MIs[1] Operand 1
     /*  456715 */     // No operand predicates
     /*  456715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456724 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  456724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456747 */     GIR_RootConstrainSelectedInstOperands,
     /*  456748 */     // GIR_Coverage, 7162,
     /*  456748 */     GIR_EraseRootFromParent_Done,
     /*  456749 */   // Label 7818: @456749
     /*  456749 */   GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(456835), // Rule ID 7163 //
     /*  456754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  456765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  456768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  456771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456801 */     // MIs[1] Operand 1
     /*  456801 */     // No operand predicates
     /*  456801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4),
     /*  456813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456833 */     GIR_RootConstrainSelectedInstOperands,
     /*  456834 */     // GIR_Coverage, 7163,
     /*  456834 */     GIR_EraseRootFromParent_Done,
     /*  456835 */   // Label 7819: @456835
     /*  456835 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(456921), // Rule ID 7166 //
     /*  456840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  456843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  456851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  456854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  456857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  456860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  456863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456887 */     // MIs[1] Operand 1
     /*  456887 */     // No operand predicates
     /*  456887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456896 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  456896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  456899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  456916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  456919 */     GIR_RootConstrainSelectedInstOperands,
     /*  456920 */     // GIR_Coverage, 7166,
     /*  456920 */     GIR_EraseRootFromParent_Done,
     /*  456921 */   // Label 7820: @456921
     /*  456921 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(457007), // Rule ID 7167 //
     /*  456926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  456929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  456934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  456937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  456940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  456943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  456946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  456949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  456961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  456965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  456969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  456973 */     // MIs[1] Operand 1
     /*  456973 */     // No operand predicates
     /*  456973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  456975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  456982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  456982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  456985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  456987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  456989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  456991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  456994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  456999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457005 */     GIR_RootConstrainSelectedInstOperands,
     /*  457006 */     // GIR_Coverage, 7167,
     /*  457006 */     GIR_EraseRootFromParent_Done,
     /*  457007 */   // Label 7821: @457007
     /*  457007 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(457093), // Rule ID 7170 //
     /*  457012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457059 */     // MIs[1] Operand 1
     /*  457059 */     // No operand predicates
     /*  457059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457091 */     GIR_RootConstrainSelectedInstOperands,
     /*  457092 */     // GIR_Coverage, 7170,
     /*  457092 */     GIR_EraseRootFromParent_Done,
     /*  457093 */   // Label 7822: @457093
     /*  457093 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(457179), // Rule ID 7171 //
     /*  457098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  457109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  457112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  457115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457145 */     // MIs[1] Operand 1
     /*  457145 */     // No operand predicates
     /*  457145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457154 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2),
     /*  457157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457177 */     GIR_RootConstrainSelectedInstOperands,
     /*  457178 */     // GIR_Coverage, 7171,
     /*  457178 */     GIR_EraseRootFromParent_Done,
     /*  457179 */   // Label 7823: @457179
     /*  457179 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(457265), // Rule ID 7174 //
     /*  457184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457231 */     // MIs[1] Operand 1
     /*  457231 */     // No operand predicates
     /*  457231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457263 */     GIR_RootConstrainSelectedInstOperands,
     /*  457264 */     // GIR_Coverage, 7174,
     /*  457264 */     GIR_EraseRootFromParent_Done,
     /*  457265 */   // Label 7824: @457265
     /*  457265 */   GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(457351), // Rule ID 7175 //
     /*  457270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  457281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  457284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  457287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457317 */     // MIs[1] Operand 1
     /*  457317 */     // No operand predicates
     /*  457317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457326 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  457326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457349 */     GIR_RootConstrainSelectedInstOperands,
     /*  457350 */     // GIR_Coverage, 7175,
     /*  457350 */     GIR_EraseRootFromParent_Done,
     /*  457351 */   // Label 7825: @457351
     /*  457351 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(457437), // Rule ID 7178 //
     /*  457356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457403 */     // MIs[1] Operand 1
     /*  457403 */     // No operand predicates
     /*  457403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457412 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  457412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457435 */     GIR_RootConstrainSelectedInstOperands,
     /*  457436 */     // GIR_Coverage, 7178,
     /*  457436 */     GIR_EraseRootFromParent_Done,
     /*  457437 */   // Label 7826: @457437
     /*  457437 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(457523), // Rule ID 7179 //
     /*  457442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  457453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  457456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  457459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457489 */     // MIs[1] Operand 1
     /*  457489 */     // No operand predicates
     /*  457489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  457498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  457518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457521 */     GIR_RootConstrainSelectedInstOperands,
     /*  457522 */     // GIR_Coverage, 7179,
     /*  457522 */     GIR_EraseRootFromParent_Done,
     /*  457523 */   // Label 7827: @457523
     /*  457523 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(457609), // Rule ID 7182 //
     /*  457528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  457539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  457542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  457545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457575 */     // MIs[1] Operand 1
     /*  457575 */     // No operand predicates
     /*  457575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  457584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457607 */     GIR_RootConstrainSelectedInstOperands,
     /*  457608 */     // GIR_Coverage, 7182,
     /*  457608 */     GIR_EraseRootFromParent_Done,
     /*  457609 */   // Label 7828: @457609
     /*  457609 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(457695), // Rule ID 7183 //
     /*  457614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  457625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  457628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  457631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457661 */     // MIs[1] Operand 1
     /*  457661 */     // No operand predicates
     /*  457661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457670 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  457670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  457690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457693 */     GIR_RootConstrainSelectedInstOperands,
     /*  457694 */     // GIR_Coverage, 7183,
     /*  457694 */     GIR_EraseRootFromParent_Done,
     /*  457695 */   // Label 7829: @457695
     /*  457695 */   GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(457781), // Rule ID 7186 //
     /*  457700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  457703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  457711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  457714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  457717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457747 */     // MIs[1] Operand 1
     /*  457747 */     // No operand predicates
     /*  457747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457756 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  457756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457779 */     GIR_RootConstrainSelectedInstOperands,
     /*  457780 */     // GIR_Coverage, 7186,
     /*  457780 */     GIR_EraseRootFromParent_Done,
     /*  457781 */   // Label 7830: @457781
     /*  457781 */   GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(457867), // Rule ID 7187 //
     /*  457786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  457789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  457797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  457800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  457803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  457821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457833 */     // MIs[1] Operand 1
     /*  457833 */     // No operand predicates
     /*  457833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  457842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1),
     /*  457845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  457862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457865 */     GIR_RootConstrainSelectedInstOperands,
     /*  457866 */     // GIR_Coverage, 7187,
     /*  457866 */     GIR_EraseRootFromParent_Done,
     /*  457867 */   // Label 7831: @457867
     /*  457867 */   GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(457953), // Rule ID 7190 //
     /*  457872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  457875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  457883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  457886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  457889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  457892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  457895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  457915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  457919 */     // MIs[1] Operand 1
     /*  457919 */     // No operand predicates
     /*  457919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  457921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  457928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  457928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  457931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  457933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  457935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  457937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  457940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  457945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  457948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  457951 */     GIR_RootConstrainSelectedInstOperands,
     /*  457952 */     // GIR_Coverage, 7190,
     /*  457952 */     GIR_EraseRootFromParent_Done,
     /*  457953 */   // Label 7832: @457953
     /*  457953 */   GIM_Try, /*On fail goto*//*Label 7833*/ GIMT_Encode4(458039), // Rule ID 7191 //
     /*  457958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  457961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  457966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  457969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  457972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  457975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  457978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  457981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  457993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  457997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458005 */     // MIs[1] Operand 1
     /*  458005 */     // No operand predicates
     /*  458005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458014 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458037 */     GIR_RootConstrainSelectedInstOperands,
     /*  458038 */     // GIR_Coverage, 7191,
     /*  458038 */     GIR_EraseRootFromParent_Done,
     /*  458039 */   // Label 7833: @458039
     /*  458039 */   GIM_Try, /*On fail goto*//*Label 7834*/ GIMT_Encode4(458125), // Rule ID 7194 //
     /*  458044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458091 */     // MIs[1] Operand 1
     /*  458091 */     // No operand predicates
     /*  458091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458100 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458123 */     GIR_RootConstrainSelectedInstOperands,
     /*  458124 */     // GIR_Coverage, 7194,
     /*  458124 */     GIR_EraseRootFromParent_Done,
     /*  458125 */   // Label 7834: @458125
     /*  458125 */   GIM_Try, /*On fail goto*//*Label 7835*/ GIMT_Encode4(458211), // Rule ID 7195 //
     /*  458130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  458141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  458144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  458147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458177 */     // MIs[1] Operand 1
     /*  458177 */     // No operand predicates
     /*  458177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458186 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458209 */     GIR_RootConstrainSelectedInstOperands,
     /*  458210 */     // GIR_Coverage, 7195,
     /*  458210 */     GIR_EraseRootFromParent_Done,
     /*  458211 */   // Label 7835: @458211
     /*  458211 */   GIM_Try, /*On fail goto*//*Label 7836*/ GIMT_Encode4(458297), // Rule ID 7198 //
     /*  458216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458263 */     // MIs[1] Operand 1
     /*  458263 */     // No operand predicates
     /*  458263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458272 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  458272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458295 */     GIR_RootConstrainSelectedInstOperands,
     /*  458296 */     // GIR_Coverage, 7198,
     /*  458296 */     GIR_EraseRootFromParent_Done,
     /*  458297 */   // Label 7836: @458297
     /*  458297 */   GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(458383), // Rule ID 7199 //
     /*  458302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  458313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  458316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  458319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458349 */     // MIs[1] Operand 1
     /*  458349 */     // No operand predicates
     /*  458349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458358 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  458358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  458378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458381 */     GIR_RootConstrainSelectedInstOperands,
     /*  458382 */     // GIR_Coverage, 7199,
     /*  458382 */     GIR_EraseRootFromParent_Done,
     /*  458383 */   // Label 7837: @458383
     /*  458383 */   GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(458469), // Rule ID 7202 //
     /*  458388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458435 */     // MIs[1] Operand 1
     /*  458435 */     // No operand predicates
     /*  458435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458467 */     GIR_RootConstrainSelectedInstOperands,
     /*  458468 */     // GIR_Coverage, 7202,
     /*  458468 */     GIR_EraseRootFromParent_Done,
     /*  458469 */   // Label 7838: @458469
     /*  458469 */   GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(458555), // Rule ID 7203 //
     /*  458474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  458485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  458488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  458491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458521 */     // MIs[1] Operand 1
     /*  458521 */     // No operand predicates
     /*  458521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458530 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458553 */     GIR_RootConstrainSelectedInstOperands,
     /*  458554 */     // GIR_Coverage, 7203,
     /*  458554 */     GIR_EraseRootFromParent_Done,
     /*  458555 */   // Label 7839: @458555
     /*  458555 */   GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(458641), // Rule ID 7206 //
     /*  458560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  458571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  458574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  458577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458607 */     // MIs[1] Operand 1
     /*  458607 */     // No operand predicates
     /*  458607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458639 */     GIR_RootConstrainSelectedInstOperands,
     /*  458640 */     // GIR_Coverage, 7206,
     /*  458640 */     GIR_EraseRootFromParent_Done,
     /*  458641 */   // Label 7840: @458641
     /*  458641 */   GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(458727), // Rule ID 7207 //
     /*  458646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  458657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  458660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  458663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  458681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458693 */     // MIs[1] Operand 1
     /*  458693 */     // No operand predicates
     /*  458693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  458705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458725 */     GIR_RootConstrainSelectedInstOperands,
     /*  458726 */     // GIR_Coverage, 7207,
     /*  458726 */     GIR_EraseRootFromParent_Done,
     /*  458727 */   // Label 7841: @458727
     /*  458727 */   GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(458813), // Rule ID 7210 //
     /*  458732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  458743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  458746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  458749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458779 */     // MIs[1] Operand 1
     /*  458779 */     // No operand predicates
     /*  458779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  458788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458811 */     GIR_RootConstrainSelectedInstOperands,
     /*  458812 */     // GIR_Coverage, 7210,
     /*  458812 */     GIR_EraseRootFromParent_Done,
     /*  458813 */   // Label 7842: @458813
     /*  458813 */   GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(458899), // Rule ID 7211 //
     /*  458818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  458829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  458832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  458835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  458838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  458841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  458853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458865 */     // MIs[1] Operand 1
     /*  458865 */     // No operand predicates
     /*  458865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  458874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  458877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  458894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458897 */     GIR_RootConstrainSelectedInstOperands,
     /*  458898 */     // GIR_Coverage, 7211,
     /*  458898 */     GIR_EraseRootFromParent_Done,
     /*  458899 */   // Label 7843: @458899
     /*  458899 */   GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(458985), // Rule ID 7214 //
     /*  458904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  458907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  458915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  458918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  458921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  458924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  458927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  458939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  458943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  458947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  458951 */     // MIs[1] Operand 1
     /*  458951 */     // No operand predicates
     /*  458951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  458953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  458960 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  458960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  458963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  458965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  458967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  458969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  458972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  458977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  458980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  458983 */     GIR_RootConstrainSelectedInstOperands,
     /*  458984 */     // GIR_Coverage, 7214,
     /*  458984 */     GIR_EraseRootFromParent_Done,
     /*  458985 */   // Label 7844: @458985
     /*  458985 */   GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(459071), // Rule ID 7215 //
     /*  458990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  458993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  458998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  459001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  459004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  459007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459037 */     // MIs[1] Operand 1
     /*  459037 */     // No operand predicates
     /*  459037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459069 */     GIR_RootConstrainSelectedInstOperands,
     /*  459070 */     // GIR_Coverage, 7215,
     /*  459070 */     GIR_EraseRootFromParent_Done,
     /*  459071 */   // Label 7845: @459071
     /*  459071 */   GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(459157), // Rule ID 7218 //
     /*  459076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459123 */     // MIs[1] Operand 1
     /*  459123 */     // No operand predicates
     /*  459123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459132 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459155 */     GIR_RootConstrainSelectedInstOperands,
     /*  459156 */     // GIR_Coverage, 7218,
     /*  459156 */     GIR_EraseRootFromParent_Done,
     /*  459157 */   // Label 7846: @459157
     /*  459157 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(459243), // Rule ID 7219 //
     /*  459162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  459173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  459176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  459179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459209 */     // MIs[1] Operand 1
     /*  459209 */     // No operand predicates
     /*  459209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459241 */     GIR_RootConstrainSelectedInstOperands,
     /*  459242 */     // GIR_Coverage, 7219,
     /*  459242 */     GIR_EraseRootFromParent_Done,
     /*  459243 */   // Label 7847: @459243
     /*  459243 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(459329), // Rule ID 7222 //
     /*  459248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459295 */     // MIs[1] Operand 1
     /*  459295 */     // No operand predicates
     /*  459295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  459304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459327 */     GIR_RootConstrainSelectedInstOperands,
     /*  459328 */     // GIR_Coverage, 7222,
     /*  459328 */     GIR_EraseRootFromParent_Done,
     /*  459329 */   // Label 7848: @459329
     /*  459329 */   GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(459415), // Rule ID 7223 //
     /*  459334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  459337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  459345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  459348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  459351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459381 */     // MIs[1] Operand 1
     /*  459381 */     // No operand predicates
     /*  459381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459390 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  459390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  459410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459413 */     GIR_RootConstrainSelectedInstOperands,
     /*  459414 */     // GIR_Coverage, 7223,
     /*  459414 */     GIR_EraseRootFromParent_Done,
     /*  459415 */   // Label 7849: @459415
     /*  459415 */   GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(459501), // Rule ID 7226 //
     /*  459420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  459434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  459437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459467 */     // MIs[1] Operand 1
     /*  459467 */     // No operand predicates
     /*  459467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459476 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  459476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459499 */     GIR_RootConstrainSelectedInstOperands,
     /*  459500 */     // GIR_Coverage, 7226,
     /*  459500 */     GIR_EraseRootFromParent_Done,
     /*  459501 */   // Label 7850: @459501
     /*  459501 */   GIM_Try, /*On fail goto*//*Label 7851*/ GIMT_Encode4(459587), // Rule ID 7227 //
     /*  459506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  459509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  459517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  459520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  459523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  459541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459553 */     // MIs[1] Operand 1
     /*  459553 */     // No operand predicates
     /*  459553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459562 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  459562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2),
     /*  459565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459585 */     GIR_RootConstrainSelectedInstOperands,
     /*  459586 */     // GIR_Coverage, 7227,
     /*  459586 */     GIR_EraseRootFromParent_Done,
     /*  459587 */   // Label 7851: @459587
     /*  459587 */   GIM_Try, /*On fail goto*//*Label 7852*/ GIMT_Encode4(459673), // Rule ID 7230 //
     /*  459592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  459603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  459606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  459609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459639 */     // MIs[1] Operand 1
     /*  459639 */     // No operand predicates
     /*  459639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459648 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  459648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459671 */     GIR_RootConstrainSelectedInstOperands,
     /*  459672 */     // GIR_Coverage, 7230,
     /*  459672 */     GIR_EraseRootFromParent_Done,
     /*  459673 */   // Label 7852: @459673
     /*  459673 */   GIM_Try, /*On fail goto*//*Label 7853*/ GIMT_Encode4(459759), // Rule ID 7231 //
     /*  459678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  459681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  459689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  459692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  459695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  459713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459725 */     // MIs[1] Operand 1
     /*  459725 */     // No operand predicates
     /*  459725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459734 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  459734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4),
     /*  459737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459757 */     GIR_RootConstrainSelectedInstOperands,
     /*  459758 */     // GIR_Coverage, 7231,
     /*  459758 */     GIR_EraseRootFromParent_Done,
     /*  459759 */   // Label 7853: @459759
     /*  459759 */   GIM_Try, /*On fail goto*//*Label 7854*/ GIMT_Encode4(459845), // Rule ID 7234 //
     /*  459764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  459767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  459775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  459778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  459781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459811 */     // MIs[1] Operand 1
     /*  459811 */     // No operand predicates
     /*  459811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459820 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  459820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459843 */     GIR_RootConstrainSelectedInstOperands,
     /*  459844 */     // GIR_Coverage, 7234,
     /*  459844 */     GIR_EraseRootFromParent_Done,
     /*  459845 */   // Label 7854: @459845
     /*  459845 */   GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(459931), // Rule ID 7235 //
     /*  459850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  459853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  459858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  459861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  459864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  459867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  459870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  459873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  459885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459897 */     // MIs[1] Operand 1
     /*  459897 */     // No operand predicates
     /*  459897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459906 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  459906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8),
     /*  459909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  459915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  459918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  459923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  459926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  459929 */     GIR_RootConstrainSelectedInstOperands,
     /*  459930 */     // GIR_Coverage, 7235,
     /*  459930 */     GIR_EraseRootFromParent_Done,
     /*  459931 */   // Label 7855: @459931
     /*  459931 */   GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(460017), // Rule ID 7446 //
     /*  459936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  459939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  459944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  459947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  459950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  459953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  459956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  459959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  459971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  459975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  459979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  459983 */     // MIs[1] Operand 1
     /*  459983 */     // No operand predicates
     /*  459983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  459985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  459992 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  459992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  459995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  459997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  459999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460015 */     GIR_RootConstrainSelectedInstOperands,
     /*  460016 */     // GIR_Coverage, 7446,
     /*  460016 */     GIR_EraseRootFromParent_Done,
     /*  460017 */   // Label 7856: @460017
     /*  460017 */   GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(460103), // Rule ID 7447 //
     /*  460022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  460033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  460036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  460039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460069 */     // MIs[1] Operand 1
     /*  460069 */     // No operand predicates
     /*  460069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460078 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8),
     /*  460081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460101 */     GIR_RootConstrainSelectedInstOperands,
     /*  460102 */     // GIR_Coverage, 7447,
     /*  460102 */     GIR_EraseRootFromParent_Done,
     /*  460103 */   // Label 7857: @460103
     /*  460103 */   GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(460189), // Rule ID 7450 //
     /*  460108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460155 */     // MIs[1] Operand 1
     /*  460155 */     // No operand predicates
     /*  460155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460164 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460187 */     GIR_RootConstrainSelectedInstOperands,
     /*  460188 */     // GIR_Coverage, 7450,
     /*  460188 */     GIR_EraseRootFromParent_Done,
     /*  460189 */   // Label 7858: @460189
     /*  460189 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(460275), // Rule ID 7451 //
     /*  460194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  460205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  460208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  460211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460241 */     // MIs[1] Operand 1
     /*  460241 */     // No operand predicates
     /*  460241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460250 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  460253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460273 */     GIR_RootConstrainSelectedInstOperands,
     /*  460274 */     // GIR_Coverage, 7451,
     /*  460274 */     GIR_EraseRootFromParent_Done,
     /*  460275 */   // Label 7859: @460275
     /*  460275 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(460361), // Rule ID 7454 //
     /*  460280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460327 */     // MIs[1] Operand 1
     /*  460327 */     // No operand predicates
     /*  460327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460359 */     GIR_RootConstrainSelectedInstOperands,
     /*  460360 */     // GIR_Coverage, 7454,
     /*  460360 */     GIR_EraseRootFromParent_Done,
     /*  460361 */   // Label 7860: @460361
     /*  460361 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(460447), // Rule ID 7455 //
     /*  460366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  460377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  460380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  460383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460413 */     // MIs[1] Operand 1
     /*  460413 */     // No operand predicates
     /*  460413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460422 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  460425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460445 */     GIR_RootConstrainSelectedInstOperands,
     /*  460446 */     // GIR_Coverage, 7455,
     /*  460446 */     GIR_EraseRootFromParent_Done,
     /*  460447 */   // Label 7861: @460447
     /*  460447 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(460533), // Rule ID 7458 //
     /*  460452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  460463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  460466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  460469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460499 */     // MIs[1] Operand 1
     /*  460499 */     // No operand predicates
     /*  460499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  460511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460531 */     GIR_RootConstrainSelectedInstOperands,
     /*  460532 */     // GIR_Coverage, 7458,
     /*  460532 */     GIR_EraseRootFromParent_Done,
     /*  460533 */   // Label 7862: @460533
     /*  460533 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(460619), // Rule ID 7459 //
     /*  460538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  460549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  460552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  460555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460585 */     // MIs[1] Operand 1
     /*  460585 */     // No operand predicates
     /*  460585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  460597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460617 */     GIR_RootConstrainSelectedInstOperands,
     /*  460618 */     // GIR_Coverage, 7459,
     /*  460618 */     GIR_EraseRootFromParent_Done,
     /*  460619 */   // Label 7863: @460619
     /*  460619 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(460705), // Rule ID 7462 //
     /*  460624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  460635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  460638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  460641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460671 */     // MIs[1] Operand 1
     /*  460671 */     // No operand predicates
     /*  460671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  460683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460703 */     GIR_RootConstrainSelectedInstOperands,
     /*  460704 */     // GIR_Coverage, 7462,
     /*  460704 */     GIR_EraseRootFromParent_Done,
     /*  460705 */   // Label 7864: @460705
     /*  460705 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(460791), // Rule ID 7463 //
     /*  460710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  460721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  460724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  460727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  460741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460757 */     // MIs[1] Operand 1
     /*  460757 */     // No operand predicates
     /*  460757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  460769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460789 */     GIR_RootConstrainSelectedInstOperands,
     /*  460790 */     // GIR_Coverage, 7463,
     /*  460790 */     GIR_EraseRootFromParent_Done,
     /*  460791 */   // Label 7865: @460791
     /*  460791 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(460877), // Rule ID 7466 //
     /*  460796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  460807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  460810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  460813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460843 */     // MIs[1] Operand 1
     /*  460843 */     // No operand predicates
     /*  460843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  460852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  460855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460875 */     GIR_RootConstrainSelectedInstOperands,
     /*  460876 */     // GIR_Coverage, 7466,
     /*  460876 */     GIR_EraseRootFromParent_Done,
     /*  460877 */   // Label 7866: @460877
     /*  460877 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(460963), // Rule ID 7467 //
     /*  460882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  460885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  460893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  460896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  460899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  460902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  460905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  460913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  460917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  460921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  460925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  460929 */     // MIs[1] Operand 1
     /*  460929 */     // No operand predicates
     /*  460929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  460931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  460938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  460938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  460941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  460943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  460945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  460947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  460950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  460955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  460958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  460961 */     GIR_RootConstrainSelectedInstOperands,
     /*  460962 */     // GIR_Coverage, 7467,
     /*  460962 */     GIR_EraseRootFromParent_Done,
     /*  460963 */   // Label 7867: @460963
     /*  460963 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(461049), // Rule ID 7470 //
     /*  460968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  460971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  460976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  460979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  460982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  460985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  460988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  460991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  460999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461015 */     // MIs[1] Operand 1
     /*  461015 */     // No operand predicates
     /*  461015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461047 */     GIR_RootConstrainSelectedInstOperands,
     /*  461048 */     // GIR_Coverage, 7470,
     /*  461048 */     GIR_EraseRootFromParent_Done,
     /*  461049 */   // Label 7868: @461049
     /*  461049 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(461135), // Rule ID 7471 //
     /*  461054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  461065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  461068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  461071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461101 */     // MIs[1] Operand 1
     /*  461101 */     // No operand predicates
     /*  461101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4),
     /*  461113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461133 */     GIR_RootConstrainSelectedInstOperands,
     /*  461134 */     // GIR_Coverage, 7471,
     /*  461134 */     GIR_EraseRootFromParent_Done,
     /*  461135 */   // Label 7869: @461135
     /*  461135 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(461221), // Rule ID 7474 //
     /*  461140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461187 */     // MIs[1] Operand 1
     /*  461187 */     // No operand predicates
     /*  461187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461219 */     GIR_RootConstrainSelectedInstOperands,
     /*  461220 */     // GIR_Coverage, 7474,
     /*  461220 */     GIR_EraseRootFromParent_Done,
     /*  461221 */   // Label 7870: @461221
     /*  461221 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(461307), // Rule ID 7475 //
     /*  461226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  461237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  461240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  461243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461273 */     // MIs[1] Operand 1
     /*  461273 */     // No operand predicates
     /*  461273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461305 */     GIR_RootConstrainSelectedInstOperands,
     /*  461306 */     // GIR_Coverage, 7475,
     /*  461306 */     GIR_EraseRootFromParent_Done,
     /*  461307 */   // Label 7871: @461307
     /*  461307 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(461393), // Rule ID 7478 //
     /*  461312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461359 */     // MIs[1] Operand 1
     /*  461359 */     // No operand predicates
     /*  461359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461391 */     GIR_RootConstrainSelectedInstOperands,
     /*  461392 */     // GIR_Coverage, 7478,
     /*  461392 */     GIR_EraseRootFromParent_Done,
     /*  461393 */   // Label 7872: @461393
     /*  461393 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(461479), // Rule ID 7479 //
     /*  461398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  461409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  461412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  461415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461445 */     // MIs[1] Operand 1
     /*  461445 */     // No operand predicates
     /*  461445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  461457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461477 */     GIR_RootConstrainSelectedInstOperands,
     /*  461478 */     // GIR_Coverage, 7479,
     /*  461478 */     GIR_EraseRootFromParent_Done,
     /*  461479 */   // Label 7873: @461479
     /*  461479 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(461565), // Rule ID 7482 //
     /*  461484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  461495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  461498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  461501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461531 */     // MIs[1] Operand 1
     /*  461531 */     // No operand predicates
     /*  461531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461563 */     GIR_RootConstrainSelectedInstOperands,
     /*  461564 */     // GIR_Coverage, 7482,
     /*  461564 */     GIR_EraseRootFromParent_Done,
     /*  461565 */   // Label 7874: @461565
     /*  461565 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(461651), // Rule ID 7483 //
     /*  461570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  461581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  461584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  461587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  461601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461617 */     // MIs[1] Operand 1
     /*  461617 */     // No operand predicates
     /*  461617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  461629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461649 */     GIR_RootConstrainSelectedInstOperands,
     /*  461650 */     // GIR_Coverage, 7483,
     /*  461650 */     GIR_EraseRootFromParent_Done,
     /*  461651 */   // Label 7875: @461651
     /*  461651 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(461737), // Rule ID 7486 //
     /*  461656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  461659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  461667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  461670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  461673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461703 */     // MIs[1] Operand 1
     /*  461703 */     // No operand predicates
     /*  461703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  461712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461735 */     GIR_RootConstrainSelectedInstOperands,
     /*  461736 */     // GIR_Coverage, 7486,
     /*  461736 */     GIR_EraseRootFromParent_Done,
     /*  461737 */   // Label 7876: @461737
     /*  461737 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(461823), // Rule ID 7487 //
     /*  461742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  461745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  461753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  461756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  461759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  461773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  461777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461789 */     // MIs[1] Operand 1
     /*  461789 */     // No operand predicates
     /*  461789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  461798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  461801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  461818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461821 */     GIR_RootConstrainSelectedInstOperands,
     /*  461822 */     // GIR_Coverage, 7487,
     /*  461822 */     GIR_EraseRootFromParent_Done,
     /*  461823 */   // Label 7877: @461823
     /*  461823 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(461909), // Rule ID 7490 //
     /*  461828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  461831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  461845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  461848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  461851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461875 */     // MIs[1] Operand 1
     /*  461875 */     // No operand predicates
     /*  461875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  461884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461907 */     GIR_RootConstrainSelectedInstOperands,
     /*  461908 */     // GIR_Coverage, 7490,
     /*  461908 */     GIR_EraseRootFromParent_Done,
     /*  461909 */   // Label 7878: @461909
     /*  461909 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(461995), // Rule ID 7491 //
     /*  461914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  461917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  461922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  461925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  461928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  461931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  461934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  461937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  461949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  461953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  461957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  461961 */     // MIs[1] Operand 1
     /*  461961 */     // No operand predicates
     /*  461961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  461963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  461970 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  461970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2),
     /*  461973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  461975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  461977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  461979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  461982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  461987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  461990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  461993 */     GIR_RootConstrainSelectedInstOperands,
     /*  461994 */     // GIR_Coverage, 7491,
     /*  461994 */     GIR_EraseRootFromParent_Done,
     /*  461995 */   // Label 7879: @461995
     /*  461995 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(462081), // Rule ID 7494 //
     /*  462000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462047 */     // MIs[1] Operand 1
     /*  462047 */     // No operand predicates
     /*  462047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462079 */     GIR_RootConstrainSelectedInstOperands,
     /*  462080 */     // GIR_Coverage, 7494,
     /*  462080 */     GIR_EraseRootFromParent_Done,
     /*  462081 */   // Label 7880: @462081
     /*  462081 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(462167), // Rule ID 7495 //
     /*  462086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  462097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  462100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  462103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462133 */     // MIs[1] Operand 1
     /*  462133 */     // No operand predicates
     /*  462133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462142 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1),
     /*  462145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462165 */     GIR_RootConstrainSelectedInstOperands,
     /*  462166 */     // GIR_Coverage, 7495,
     /*  462166 */     GIR_EraseRootFromParent_Done,
     /*  462167 */   // Label 7881: @462167
     /*  462167 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(462253), // Rule ID 7498 //
     /*  462172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462219 */     // MIs[1] Operand 1
     /*  462219 */     // No operand predicates
     /*  462219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462251 */     GIR_RootConstrainSelectedInstOperands,
     /*  462252 */     // GIR_Coverage, 7498,
     /*  462252 */     GIR_EraseRootFromParent_Done,
     /*  462253 */   // Label 7882: @462253
     /*  462253 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(462339), // Rule ID 7499 //
     /*  462258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  462269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  462272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  462275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  462289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462305 */     // MIs[1] Operand 1
     /*  462305 */     // No operand predicates
     /*  462305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2),
     /*  462317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462337 */     GIR_RootConstrainSelectedInstOperands,
     /*  462338 */     // GIR_Coverage, 7499,
     /*  462338 */     GIR_EraseRootFromParent_Done,
     /*  462339 */   // Label 7883: @462339
     /*  462339 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(462425), // Rule ID 7502 //
     /*  462344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  462347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462387 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462391 */     // MIs[1] Operand 1
     /*  462391 */     // No operand predicates
     /*  462391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462400 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  462400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462423 */     GIR_RootConstrainSelectedInstOperands,
     /*  462424 */     // GIR_Coverage, 7502,
     /*  462424 */     GIR_EraseRootFromParent_Done,
     /*  462425 */   // Label 7884: @462425
     /*  462425 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(462511), // Rule ID 7503 //
     /*  462430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  462433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  462438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  462441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  462444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  462447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  462461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  462465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462477 */     // MIs[1] Operand 1
     /*  462477 */     // No operand predicates
     /*  462477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462486 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  462486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4),
     /*  462489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  462506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462509 */     GIR_RootConstrainSelectedInstOperands,
     /*  462510 */     // GIR_Coverage, 7503,
     /*  462510 */     GIR_EraseRootFromParent_Done,
     /*  462511 */   // Label 7885: @462511
     /*  462511 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(462597), // Rule ID 7626 //
     /*  462516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  462527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  462530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  462533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462563 */     // MIs[1] Operand 1
     /*  462563 */     // No operand predicates
     /*  462563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  462575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462595 */     GIR_RootConstrainSelectedInstOperands,
     /*  462596 */     // GIR_Coverage, 7626,
     /*  462596 */     GIR_EraseRootFromParent_Done,
     /*  462597 */   // Label 7886: @462597
     /*  462597 */   GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(462683), // Rule ID 7627 //
     /*  462602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  462613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  462616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  462619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462649 */     // MIs[1] Operand 1
     /*  462649 */     // No operand predicates
     /*  462649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462658 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8),
     /*  462661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462681 */     GIR_RootConstrainSelectedInstOperands,
     /*  462682 */     // GIR_Coverage, 7627,
     /*  462682 */     GIR_EraseRootFromParent_Done,
     /*  462683 */   // Label 7887: @462683
     /*  462683 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(462769), // Rule ID 7630 //
     /*  462688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  462699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  462702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  462705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462735 */     // MIs[1] Operand 1
     /*  462735 */     // No operand predicates
     /*  462735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  462747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462767 */     GIR_RootConstrainSelectedInstOperands,
     /*  462768 */     // GIR_Coverage, 7630,
     /*  462768 */     GIR_EraseRootFromParent_Done,
     /*  462769 */   // Label 7888: @462769
     /*  462769 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(462855), // Rule ID 7631 //
     /*  462774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  462785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  462788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  462791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462821 */     // MIs[1] Operand 1
     /*  462821 */     // No operand predicates
     /*  462821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462830 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  462830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  462833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462853 */     GIR_RootConstrainSelectedInstOperands,
     /*  462854 */     // GIR_Coverage, 7631,
     /*  462854 */     GIR_EraseRootFromParent_Done,
     /*  462855 */   // Label 7889: @462855
     /*  462855 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(462941), // Rule ID 7634 //
     /*  462860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  462863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  462871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  462874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  462877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  462880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  462883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462907 */     // MIs[1] Operand 1
     /*  462907 */     // No operand predicates
     /*  462907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  462916 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  462916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  462919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  462921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  462923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  462925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  462928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  462933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  462936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  462939 */     GIR_RootConstrainSelectedInstOperands,
     /*  462940 */     // GIR_Coverage, 7634,
     /*  462940 */     GIR_EraseRootFromParent_Done,
     /*  462941 */   // Label 7890: @462941
     /*  462941 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(463027), // Rule ID 7635 //
     /*  462946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  462949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  462954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  462957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  462960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  462963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  462966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  462969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  462981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  462985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  462989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  462993 */     // MIs[1] Operand 1
     /*  462993 */     // No operand predicates
     /*  462993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  462995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463002 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463025 */     GIR_RootConstrainSelectedInstOperands,
     /*  463026 */     // GIR_Coverage, 7635,
     /*  463026 */     GIR_EraseRootFromParent_Done,
     /*  463027 */   // Label 7891: @463027
     /*  463027 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(463113), // Rule ID 7638 //
     /*  463032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463079 */     // MIs[1] Operand 1
     /*  463079 */     // No operand predicates
     /*  463079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463088 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463111 */     GIR_RootConstrainSelectedInstOperands,
     /*  463112 */     // GIR_Coverage, 7638,
     /*  463112 */     GIR_EraseRootFromParent_Done,
     /*  463113 */   // Label 7892: @463113
     /*  463113 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(463199), // Rule ID 7639 //
     /*  463118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  463129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  463132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  463135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463165 */     // MIs[1] Operand 1
     /*  463165 */     // No operand predicates
     /*  463165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463174 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463197 */     GIR_RootConstrainSelectedInstOperands,
     /*  463198 */     // GIR_Coverage, 7639,
     /*  463198 */     GIR_EraseRootFromParent_Done,
     /*  463199 */   // Label 7893: @463199
     /*  463199 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(463285), // Rule ID 7642 //
     /*  463204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463251 */     // MIs[1] Operand 1
     /*  463251 */     // No operand predicates
     /*  463251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463283 */     GIR_RootConstrainSelectedInstOperands,
     /*  463284 */     // GIR_Coverage, 7642,
     /*  463284 */     GIR_EraseRootFromParent_Done,
     /*  463285 */   // Label 7894: @463285
     /*  463285 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(463371), // Rule ID 7643 //
     /*  463290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  463301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  463304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  463307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463337 */     // MIs[1] Operand 1
     /*  463337 */     // No operand predicates
     /*  463337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  463349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463369 */     GIR_RootConstrainSelectedInstOperands,
     /*  463370 */     // GIR_Coverage, 7643,
     /*  463370 */     GIR_EraseRootFromParent_Done,
     /*  463371 */   // Label 7895: @463371
     /*  463371 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(463457), // Rule ID 7646 //
     /*  463376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463423 */     // MIs[1] Operand 1
     /*  463423 */     // No operand predicates
     /*  463423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  463432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  463435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463455 */     GIR_RootConstrainSelectedInstOperands,
     /*  463456 */     // GIR_Coverage, 7646,
     /*  463456 */     GIR_EraseRootFromParent_Done,
     /*  463457 */   // Label 7896: @463457
     /*  463457 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(463543), // Rule ID 7647 //
     /*  463462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  463473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  463476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  463479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  463493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  463497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463505 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463509 */     // MIs[1] Operand 1
     /*  463509 */     // No operand predicates
     /*  463509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  463518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  463521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  463538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463541 */     GIR_RootConstrainSelectedInstOperands,
     /*  463542 */     // GIR_Coverage, 7647,
     /*  463542 */     GIR_EraseRootFromParent_Done,
     /*  463543 */   // Label 7897: @463543
     /*  463543 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(463629), // Rule ID 7650 //
     /*  463548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  463559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  463562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  463565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463595 */     // MIs[1] Operand 1
     /*  463595 */     // No operand predicates
     /*  463595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463604 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463627 */     GIR_RootConstrainSelectedInstOperands,
     /*  463628 */     // GIR_Coverage, 7650,
     /*  463628 */     GIR_EraseRootFromParent_Done,
     /*  463629 */   // Label 7898: @463629
     /*  463629 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(463715), // Rule ID 7651 //
     /*  463634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  463645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  463648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  463651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463681 */     // MIs[1] Operand 1
     /*  463681 */     // No operand predicates
     /*  463681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4),
     /*  463693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463713 */     GIR_RootConstrainSelectedInstOperands,
     /*  463714 */     // GIR_Coverage, 7651,
     /*  463714 */     GIR_EraseRootFromParent_Done,
     /*  463715 */   // Label 7899: @463715
     /*  463715 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(463801), // Rule ID 7654 //
     /*  463720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  463731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  463734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  463737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463767 */     // MIs[1] Operand 1
     /*  463767 */     // No operand predicates
     /*  463767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463776 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463799 */     GIR_RootConstrainSelectedInstOperands,
     /*  463800 */     // GIR_Coverage, 7654,
     /*  463800 */     GIR_EraseRootFromParent_Done,
     /*  463801 */   // Label 7900: @463801
     /*  463801 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(463887), // Rule ID 7655 //
     /*  463806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  463817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  463820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  463823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  463829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463853 */     // MIs[1] Operand 1
     /*  463853 */     // No operand predicates
     /*  463853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  463862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  463865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463885 */     GIR_RootConstrainSelectedInstOperands,
     /*  463886 */     // GIR_Coverage, 7655,
     /*  463886 */     GIR_EraseRootFromParent_Done,
     /*  463887 */   // Label 7901: @463887
     /*  463887 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(463973), // Rule ID 7658 //
     /*  463892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  463895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  463903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  463906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  463912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  463915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  463923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  463927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  463931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  463935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  463939 */     // MIs[1] Operand 1
     /*  463939 */     // No operand predicates
     /*  463939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  463941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  463948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  463948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  463951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  463953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  463955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  463957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  463960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  463965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  463968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  463971 */     GIR_RootConstrainSelectedInstOperands,
     /*  463972 */     // GIR_Coverage, 7658,
     /*  463972 */     GIR_EraseRootFromParent_Done,
     /*  463973 */   // Label 7902: @463973
     /*  463973 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(464059), // Rule ID 7659 //
     /*  463978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  463981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  463986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  463989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  463992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  463995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  463998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464025 */     // MIs[1] Operand 1
     /*  464025 */     // No operand predicates
     /*  464025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464057 */     GIR_RootConstrainSelectedInstOperands,
     /*  464058 */     // GIR_Coverage, 7659,
     /*  464058 */     GIR_EraseRootFromParent_Done,
     /*  464059 */   // Label 7903: @464059
     /*  464059 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(464145), // Rule ID 7662 //
     /*  464064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464111 */     // MIs[1] Operand 1
     /*  464111 */     // No operand predicates
     /*  464111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464143 */     GIR_RootConstrainSelectedInstOperands,
     /*  464144 */     // GIR_Coverage, 7662,
     /*  464144 */     GIR_EraseRootFromParent_Done,
     /*  464145 */   // Label 7904: @464145
     /*  464145 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(464231), // Rule ID 7663 //
     /*  464150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  464161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  464164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  464167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464197 */     // MIs[1] Operand 1
     /*  464197 */     // No operand predicates
     /*  464197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464206 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464229 */     GIR_RootConstrainSelectedInstOperands,
     /*  464230 */     // GIR_Coverage, 7663,
     /*  464230 */     GIR_EraseRootFromParent_Done,
     /*  464231 */   // Label 7905: @464231
     /*  464231 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(464317), // Rule ID 7666 //
     /*  464236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  464239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464283 */     // MIs[1] Operand 1
     /*  464283 */     // No operand predicates
     /*  464283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464292 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  464292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464315 */     GIR_RootConstrainSelectedInstOperands,
     /*  464316 */     // GIR_Coverage, 7666,
     /*  464316 */     GIR_EraseRootFromParent_Done,
     /*  464317 */   // Label 7906: @464317
     /*  464317 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(464403), // Rule ID 7667 //
     /*  464322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  464325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  464333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  464336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  464339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464369 */     // MIs[1] Operand 1
     /*  464369 */     // No operand predicates
     /*  464369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464378 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  464378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  464398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464401 */     GIR_RootConstrainSelectedInstOperands,
     /*  464402 */     // GIR_Coverage, 7667,
     /*  464402 */     GIR_EraseRootFromParent_Done,
     /*  464403 */   // Label 7907: @464403
     /*  464403 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(464489), // Rule ID 7670 //
     /*  464408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  464419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  464422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  464425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464455 */     // MIs[1] Operand 1
     /*  464455 */     // No operand predicates
     /*  464455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464464 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464487 */     GIR_RootConstrainSelectedInstOperands,
     /*  464488 */     // GIR_Coverage, 7670,
     /*  464488 */     GIR_EraseRootFromParent_Done,
     /*  464489 */   // Label 7908: @464489
     /*  464489 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(464575), // Rule ID 7671 //
     /*  464494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  464497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  464505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  464508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  464511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464541 */     // MIs[1] Operand 1
     /*  464541 */     // No operand predicates
     /*  464541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464550 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  464550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2),
     /*  464553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464573 */     GIR_RootConstrainSelectedInstOperands,
     /*  464574 */     // GIR_Coverage, 7671,
     /*  464574 */     GIR_EraseRootFromParent_Done,
     /*  464575 */   // Label 7909: @464575
     /*  464575 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(464661), // Rule ID 7674 //
     /*  464580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  464591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  464594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  464597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464627 */     // MIs[1] Operand 1
     /*  464627 */     // No operand predicates
     /*  464627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464659 */     GIR_RootConstrainSelectedInstOperands,
     /*  464660 */     // GIR_Coverage, 7674,
     /*  464660 */     GIR_EraseRootFromParent_Done,
     /*  464661 */   // Label 7910: @464661
     /*  464661 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(464747), // Rule ID 7675 //
     /*  464666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  464669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  464677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  464680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  464683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  464697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464713 */     // MIs[1] Operand 1
     /*  464713 */     // No operand predicates
     /*  464713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464722 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  464722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1),
     /*  464725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464745 */     GIR_RootConstrainSelectedInstOperands,
     /*  464746 */     // GIR_Coverage, 7675,
     /*  464746 */     GIR_EraseRootFromParent_Done,
     /*  464747 */   // Label 7911: @464747
     /*  464747 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(464833), // Rule ID 7678 //
     /*  464752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  464763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  464766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  464769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464799 */     // MIs[1] Operand 1
     /*  464799 */     // No operand predicates
     /*  464799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464808 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464831 */     GIR_RootConstrainSelectedInstOperands,
     /*  464832 */     // GIR_Coverage, 7678,
     /*  464832 */     GIR_EraseRootFromParent_Done,
     /*  464833 */   // Label 7912: @464833
     /*  464833 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(464919), // Rule ID 7679 //
     /*  464838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  464841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  464849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  464852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  464855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  464858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  464861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  464869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464885 */     // MIs[1] Operand 1
     /*  464885 */     // No operand predicates
     /*  464885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  464894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2),
     /*  464897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  464914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  464917 */     GIR_RootConstrainSelectedInstOperands,
     /*  464918 */     // GIR_Coverage, 7679,
     /*  464918 */     GIR_EraseRootFromParent_Done,
     /*  464919 */   // Label 7913: @464919
     /*  464919 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(465005), // Rule ID 7682 //
     /*  464924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  464927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  464932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  464935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  464938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  464941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  464944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  464947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  464955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  464959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  464963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  464967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  464971 */     // MIs[1] Operand 1
     /*  464971 */     // No operand predicates
     /*  464971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  464973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  464980 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  464980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  464983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  464985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  464987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  464989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  464992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  464997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465003 */     GIR_RootConstrainSelectedInstOperands,
     /*  465004 */     // GIR_Coverage, 7682,
     /*  465004 */     GIR_EraseRootFromParent_Done,
     /*  465005 */   // Label 7914: @465005
     /*  465005 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(465091), // Rule ID 7683 //
     /*  465010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  465013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  465018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  465021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  465024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  465027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  465041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  465045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  465057 */     // MIs[1] Operand 1
     /*  465057 */     // No operand predicates
     /*  465057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  465066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4),
     /*  465069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  465086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465089 */     GIR_RootConstrainSelectedInstOperands,
     /*  465090 */     // GIR_Coverage, 7683,
     /*  465090 */     GIR_EraseRootFromParent_Done,
     /*  465091 */   // Label 7915: @465091
     /*  465091 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(465180), // Rule ID 14112 //
     /*  465096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465143 */     // MIs[1] Operand 1
     /*  465143 */     // No operand predicates
     /*  465143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465178 */     GIR_RootConstrainSelectedInstOperands,
     /*  465179 */     // GIR_Coverage, 14112,
     /*  465179 */     GIR_EraseRootFromParent_Done,
     /*  465180 */   // Label 7916: @465180
     /*  465180 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(465269), // Rule ID 14113 //
     /*  465185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  465196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  465199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  465202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465232 */     // MIs[1] Operand 1
     /*  465232 */     // No operand predicates
     /*  465232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465241 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8),
     /*  465244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465250 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465264 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465267 */     GIR_RootConstrainSelectedInstOperands,
     /*  465268 */     // GIR_Coverage, 14113,
     /*  465268 */     GIR_EraseRootFromParent_Done,
     /*  465269 */   // Label 7917: @465269
     /*  465269 */   GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(465358), // Rule ID 14116 //
     /*  465274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465321 */     // MIs[1] Operand 1
     /*  465321 */     // No operand predicates
     /*  465321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465356 */     GIR_RootConstrainSelectedInstOperands,
     /*  465357 */     // GIR_Coverage, 14116,
     /*  465357 */     GIR_EraseRootFromParent_Done,
     /*  465358 */   // Label 7918: @465358
     /*  465358 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(465447), // Rule ID 14117 //
     /*  465363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  465374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  465377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  465380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465410 */     // MIs[1] Operand 1
     /*  465410 */     // No operand predicates
     /*  465410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465419 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465445 */     GIR_RootConstrainSelectedInstOperands,
     /*  465446 */     // GIR_Coverage, 14117,
     /*  465446 */     GIR_EraseRootFromParent_Done,
     /*  465447 */   // Label 7919: @465447
     /*  465447 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(465536), // Rule ID 14120 //
     /*  465452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  465463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  465466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  465469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465499 */     // MIs[1] Operand 1
     /*  465499 */     // No operand predicates
     /*  465499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  465508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  465511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465534 */     GIR_RootConstrainSelectedInstOperands,
     /*  465535 */     // GIR_Coverage, 14120,
     /*  465535 */     GIR_EraseRootFromParent_Done,
     /*  465536 */   // Label 7920: @465536
     /*  465536 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(465625), // Rule ID 14121 //
     /*  465541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  465552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  465555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  465558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465588 */     // MIs[1] Operand 1
     /*  465588 */     // No operand predicates
     /*  465588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465597 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  465597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  465600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  465617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465623 */     GIR_RootConstrainSelectedInstOperands,
     /*  465624 */     // GIR_Coverage, 14121,
     /*  465624 */     GIR_EraseRootFromParent_Done,
     /*  465625 */   // Label 7921: @465625
     /*  465625 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(465714), // Rule ID 14124 //
     /*  465630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  465647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465677 */     // MIs[1] Operand 1
     /*  465677 */     // No operand predicates
     /*  465677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465712 */     GIR_RootConstrainSelectedInstOperands,
     /*  465713 */     // GIR_Coverage, 14124,
     /*  465713 */     GIR_EraseRootFromParent_Done,
     /*  465714 */   // Label 7922: @465714
     /*  465714 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(465803), // Rule ID 14125 //
     /*  465719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  465730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  465733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  465736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465766 */     // MIs[1] Operand 1
     /*  465766 */     // No operand predicates
     /*  465766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465775 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4),
     /*  465778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465801 */     GIR_RootConstrainSelectedInstOperands,
     /*  465802 */     // GIR_Coverage, 14125,
     /*  465802 */     GIR_EraseRootFromParent_Done,
     /*  465803 */   // Label 7923: @465803
     /*  465803 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(465892), // Rule ID 14128 //
     /*  465808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  465825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  465828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  465831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465855 */     // MIs[1] Operand 1
     /*  465855 */     // No operand predicates
     /*  465855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  465864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  465867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465890 */     GIR_RootConstrainSelectedInstOperands,
     /*  465891 */     // GIR_Coverage, 14128,
     /*  465891 */     GIR_EraseRootFromParent_Done,
     /*  465892 */   // Label 7924: @465892
     /*  465892 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(465981), // Rule ID 14129 //
     /*  465897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  465900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  465908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  465911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  465914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  465917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  465920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  465932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  465936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  465940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  465944 */     // MIs[1] Operand 1
     /*  465944 */     // No operand predicates
     /*  465944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  465946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  465953 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  465953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  465956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  465958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  465960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  465962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  465965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  465970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  465973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  465976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  465979 */     GIR_RootConstrainSelectedInstOperands,
     /*  465980 */     // GIR_Coverage, 14129,
     /*  465980 */     GIR_EraseRootFromParent_Done,
     /*  465981 */   // Label 7925: @465981
     /*  465981 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(466070), // Rule ID 14132 //
     /*  465986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  465989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  465994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  465997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466029 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466033 */     // MIs[1] Operand 1
     /*  466033 */     // No operand predicates
     /*  466033 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466068 */     GIR_RootConstrainSelectedInstOperands,
     /*  466069 */     // GIR_Coverage, 14132,
     /*  466069 */     GIR_EraseRootFromParent_Done,
     /*  466070 */   // Label 7926: @466070
     /*  466070 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(466159), // Rule ID 14133 //
     /*  466075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  466086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  466089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  466092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466122 */     // MIs[1] Operand 1
     /*  466122 */     // No operand predicates
     /*  466122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466131 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2),
     /*  466134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466157 */     GIR_RootConstrainSelectedInstOperands,
     /*  466158 */     // GIR_Coverage, 14133,
     /*  466158 */     GIR_EraseRootFromParent_Done,
     /*  466159 */   // Label 7927: @466159
     /*  466159 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(466248), // Rule ID 14136 //
     /*  466164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466211 */     // MIs[1] Operand 1
     /*  466211 */     // No operand predicates
     /*  466211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466246 */     GIR_RootConstrainSelectedInstOperands,
     /*  466247 */     // GIR_Coverage, 14136,
     /*  466247 */     GIR_EraseRootFromParent_Done,
     /*  466248 */   // Label 7928: @466248
     /*  466248 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(466337), // Rule ID 14137 //
     /*  466253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  466264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  466267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  466270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466300 */     // MIs[1] Operand 1
     /*  466300 */     // No operand predicates
     /*  466300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466309 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  466309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466335 */     GIR_RootConstrainSelectedInstOperands,
     /*  466336 */     // GIR_Coverage, 14137,
     /*  466336 */     GIR_EraseRootFromParent_Done,
     /*  466337 */   // Label 7929: @466337
     /*  466337 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(466426), // Rule ID 14140 //
     /*  466342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466385 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466389 */     // MIs[1] Operand 1
     /*  466389 */     // No operand predicates
     /*  466389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  466398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466424 */     GIR_RootConstrainSelectedInstOperands,
     /*  466425 */     // GIR_Coverage, 14140,
     /*  466425 */     GIR_EraseRootFromParent_Done,
     /*  466426 */   // Label 7930: @466426
     /*  466426 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(466515), // Rule ID 14141 //
     /*  466431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  466442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  466445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  466448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466478 */     // MIs[1] Operand 1
     /*  466478 */     // No operand predicates
     /*  466478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466487 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  466487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  466507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466513 */     GIR_RootConstrainSelectedInstOperands,
     /*  466514 */     // GIR_Coverage, 14141,
     /*  466514 */     GIR_EraseRootFromParent_Done,
     /*  466515 */   // Label 7931: @466515
     /*  466515 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(466604), // Rule ID 14144 //
     /*  466520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  466537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466567 */     // MIs[1] Operand 1
     /*  466567 */     // No operand predicates
     /*  466567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  466576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466602 */     GIR_RootConstrainSelectedInstOperands,
     /*  466603 */     // GIR_Coverage, 14144,
     /*  466603 */     GIR_EraseRootFromParent_Done,
     /*  466604 */   // Label 7932: @466604
     /*  466604 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(466693), // Rule ID 14145 //
     /*  466609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  466620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  466623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  466626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466656 */     // MIs[1] Operand 1
     /*  466656 */     // No operand predicates
     /*  466656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  466665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  466685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466691 */     GIR_RootConstrainSelectedInstOperands,
     /*  466692 */     // GIR_Coverage, 14145,
     /*  466692 */     GIR_EraseRootFromParent_Done,
     /*  466693 */   // Label 7933: @466693
     /*  466693 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(466782), // Rule ID 14148 //
     /*  466698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  466701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  466709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  466712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466745 */     // MIs[1] Operand 1
     /*  466745 */     // No operand predicates
     /*  466745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  466754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  466774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466777 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466780 */     GIR_RootConstrainSelectedInstOperands,
     /*  466781 */     // GIR_Coverage, 14148,
     /*  466781 */     GIR_EraseRootFromParent_Done,
     /*  466782 */   // Label 7934: @466782
     /*  466782 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(466871), // Rule ID 14149 //
     /*  466787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  466790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  466798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  466801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  466804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  466822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466830 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466834 */     // MIs[1] Operand 1
     /*  466834 */     // No operand predicates
     /*  466834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466843 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  466843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1),
     /*  466846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  466863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466869 */     GIR_RootConstrainSelectedInstOperands,
     /*  466870 */     // GIR_Coverage, 14149,
     /*  466870 */     GIR_EraseRootFromParent_Done,
     /*  466871 */   // Label 7935: @466871
     /*  466871 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(466960), // Rule ID 14152 //
     /*  466876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  466879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  466887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  466890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  466893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  466896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  466899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  466915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  466919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  466923 */     // MIs[1] Operand 1
     /*  466923 */     // No operand predicates
     /*  466923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  466925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  466932 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  466932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  466935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  466937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  466939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  466941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  466944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  466949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  466952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  466955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  466958 */     GIR_RootConstrainSelectedInstOperands,
     /*  466959 */     // GIR_Coverage, 14152,
     /*  466959 */     GIR_EraseRootFromParent_Done,
     /*  466960 */   // Label 7936: @466960
     /*  466960 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(467049), // Rule ID 14153 //
     /*  466965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  466968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  466973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  466976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  466979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  466982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  466985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  466988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  466996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467012 */     // MIs[1] Operand 1
     /*  467012 */     // No operand predicates
     /*  467012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467030 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467047 */     GIR_RootConstrainSelectedInstOperands,
     /*  467048 */     // GIR_Coverage, 14153,
     /*  467048 */     GIR_EraseRootFromParent_Done,
     /*  467049 */   // Label 7937: @467049
     /*  467049 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(467138), // Rule ID 14156 //
     /*  467054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467101 */     // MIs[1] Operand 1
     /*  467101 */     // No operand predicates
     /*  467101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467110 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467136 */     GIR_RootConstrainSelectedInstOperands,
     /*  467137 */     // GIR_Coverage, 14156,
     /*  467137 */     GIR_EraseRootFromParent_Done,
     /*  467138 */   // Label 7938: @467138
     /*  467138 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(467227), // Rule ID 14157 //
     /*  467143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  467154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  467157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  467160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467186 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467190 */     // MIs[1] Operand 1
     /*  467190 */     // No operand predicates
     /*  467190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467199 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467222 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467225 */     GIR_RootConstrainSelectedInstOperands,
     /*  467226 */     // GIR_Coverage, 14157,
     /*  467226 */     GIR_EraseRootFromParent_Done,
     /*  467227 */   // Label 7939: @467227
     /*  467227 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(467316), // Rule ID 14160 //
     /*  467232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467279 */     // MIs[1] Operand 1
     /*  467279 */     // No operand predicates
     /*  467279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467288 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  467288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467314 */     GIR_RootConstrainSelectedInstOperands,
     /*  467315 */     // GIR_Coverage, 14160,
     /*  467315 */     GIR_EraseRootFromParent_Done,
     /*  467316 */   // Label 7940: @467316
     /*  467316 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(467405), // Rule ID 14161 //
     /*  467321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  467332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  467335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  467338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467368 */     // MIs[1] Operand 1
     /*  467368 */     // No operand predicates
     /*  467368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467377 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  467377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  467397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467403 */     GIR_RootConstrainSelectedInstOperands,
     /*  467404 */     // GIR_Coverage, 14161,
     /*  467404 */     GIR_EraseRootFromParent_Done,
     /*  467405 */   // Label 7941: @467405
     /*  467405 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(467494), // Rule ID 14164 //
     /*  467410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467457 */     // MIs[1] Operand 1
     /*  467457 */     // No operand predicates
     /*  467457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467492 */     GIR_RootConstrainSelectedInstOperands,
     /*  467493 */     // GIR_Coverage, 14164,
     /*  467493 */     GIR_EraseRootFromParent_Done,
     /*  467494 */   // Label 7942: @467494
     /*  467494 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(467583), // Rule ID 14165 //
     /*  467499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  467510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  467513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  467516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467542 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467546 */     // MIs[1] Operand 1
     /*  467546 */     // No operand predicates
     /*  467546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467555 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  467558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467581 */     GIR_RootConstrainSelectedInstOperands,
     /*  467582 */     // GIR_Coverage, 14165,
     /*  467582 */     GIR_EraseRootFromParent_Done,
     /*  467583 */   // Label 7943: @467583
     /*  467583 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(467672), // Rule ID 14168 //
     /*  467588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  467599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  467602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467635 */     // MIs[1] Operand 1
     /*  467635 */     // No operand predicates
     /*  467635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467667 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467670 */     GIR_RootConstrainSelectedInstOperands,
     /*  467671 */     // GIR_Coverage, 14168,
     /*  467671 */     GIR_EraseRootFromParent_Done,
     /*  467672 */   // Label 7944: @467672
     /*  467672 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(467761), // Rule ID 14169 //
     /*  467677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  467688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  467691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  467694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  467712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467724 */     // MIs[1] Operand 1
     /*  467724 */     // No operand predicates
     /*  467724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467733 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  467736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467759 */     GIR_RootConstrainSelectedInstOperands,
     /*  467760 */     // GIR_Coverage, 14169,
     /*  467760 */     GIR_EraseRootFromParent_Done,
     /*  467761 */   // Label 7945: @467761
     /*  467761 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(467850), // Rule ID 14172 //
     /*  467766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  467777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  467780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467813 */     // MIs[1] Operand 1
     /*  467813 */     // No operand predicates
     /*  467813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467822 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  467822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467845 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467848 */     GIR_RootConstrainSelectedInstOperands,
     /*  467849 */     // GIR_Coverage, 14172,
     /*  467849 */     GIR_EraseRootFromParent_Done,
     /*  467850 */   // Label 7946: @467850
     /*  467850 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(467939), // Rule ID 14173 //
     /*  467855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  467858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  467866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  467869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  467872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  467875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  467878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  467890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467902 */     // MIs[1] Operand 1
     /*  467902 */     // No operand predicates
     /*  467902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  467911 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  467911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  467914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  467916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  467918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  467920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  467923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  467928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  467931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  467934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  467937 */     GIR_RootConstrainSelectedInstOperands,
     /*  467938 */     // GIR_Coverage, 14173,
     /*  467938 */     GIR_EraseRootFromParent_Done,
     /*  467939 */   // Label 7947: @467939
     /*  467939 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(468028), // Rule ID 14176 //
     /*  467944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  467947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  467952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  467955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  467958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  467961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  467964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  467967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  467979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  467983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  467987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  467991 */     // MIs[1] Operand 1
     /*  467991 */     // No operand predicates
     /*  467991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  467993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468026 */     GIR_RootConstrainSelectedInstOperands,
     /*  468027 */     // GIR_Coverage, 14176,
     /*  468027 */     GIR_EraseRootFromParent_Done,
     /*  468028 */   // Label 7948: @468028
     /*  468028 */   GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(468117), // Rule ID 14177 //
     /*  468033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  468044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  468047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  468050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468080 */     // MIs[1] Operand 1
     /*  468080 */     // No operand predicates
     /*  468080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468089 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468115 */     GIR_RootConstrainSelectedInstOperands,
     /*  468116 */     // GIR_Coverage, 14177,
     /*  468116 */     GIR_EraseRootFromParent_Done,
     /*  468117 */   // Label 7949: @468117
     /*  468117 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(468206), // Rule ID 14180 //
     /*  468122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468169 */     // MIs[1] Operand 1
     /*  468169 */     // No operand predicates
     /*  468169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468201 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468204 */     GIR_RootConstrainSelectedInstOperands,
     /*  468205 */     // GIR_Coverage, 14180,
     /*  468205 */     GIR_EraseRootFromParent_Done,
     /*  468206 */   // Label 7950: @468206
     /*  468206 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(468295), // Rule ID 14181 //
     /*  468211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  468222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  468225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  468228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468258 */     // MIs[1] Operand 1
     /*  468258 */     // No operand predicates
     /*  468258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468267 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468293 */     GIR_RootConstrainSelectedInstOperands,
     /*  468294 */     // GIR_Coverage, 14181,
     /*  468294 */     GIR_EraseRootFromParent_Done,
     /*  468295 */   // Label 7951: @468295
     /*  468295 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(468384), // Rule ID 14184 //
     /*  468300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  468303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468347 */     // MIs[1] Operand 1
     /*  468347 */     // No operand predicates
     /*  468347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468356 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  468356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468382 */     GIR_RootConstrainSelectedInstOperands,
     /*  468383 */     // GIR_Coverage, 14184,
     /*  468383 */     GIR_EraseRootFromParent_Done,
     /*  468384 */   // Label 7952: @468384
     /*  468384 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(468473), // Rule ID 14185 //
     /*  468389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  468392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  468400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  468403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  468406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468436 */     // MIs[1] Operand 1
     /*  468436 */     // No operand predicates
     /*  468436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468445 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  468445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  468465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468471 */     GIR_RootConstrainSelectedInstOperands,
     /*  468472 */     // GIR_Coverage, 14185,
     /*  468472 */     GIR_EraseRootFromParent_Done,
     /*  468473 */   // Label 7953: @468473
     /*  468473 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(468562), // Rule ID 14188 //
     /*  468478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  468489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  468492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468525 */     // MIs[1] Operand 1
     /*  468525 */     // No operand predicates
     /*  468525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468560 */     GIR_RootConstrainSelectedInstOperands,
     /*  468561 */     // GIR_Coverage, 14188,
     /*  468561 */     GIR_EraseRootFromParent_Done,
     /*  468562 */   // Label 7954: @468562
     /*  468562 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(468651), // Rule ID 14189 //
     /*  468567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  468578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  468581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  468584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  468602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468614 */     // MIs[1] Operand 1
     /*  468614 */     // No operand predicates
     /*  468614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2),
     /*  468626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468649 */     GIR_RootConstrainSelectedInstOperands,
     /*  468650 */     // GIR_Coverage, 14189,
     /*  468650 */     GIR_EraseRootFromParent_Done,
     /*  468651 */   // Label 7955: @468651
     /*  468651 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(468740), // Rule ID 14192 //
     /*  468656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  468667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  468670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  468673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468703 */     // MIs[1] Operand 1
     /*  468703 */     // No operand predicates
     /*  468703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468712 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468738 */     GIR_RootConstrainSelectedInstOperands,
     /*  468739 */     // GIR_Coverage, 14192,
     /*  468739 */     GIR_EraseRootFromParent_Done,
     /*  468740 */   // Label 7956: @468740
     /*  468740 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(468829), // Rule ID 14193 //
     /*  468745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  468756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  468759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  468762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  468780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468792 */     // MIs[1] Operand 1
     /*  468792 */     // No operand predicates
     /*  468792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468801 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4),
     /*  468804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468827 */     GIR_RootConstrainSelectedInstOperands,
     /*  468828 */     // GIR_Coverage, 14193,
     /*  468828 */     GIR_EraseRootFromParent_Done,
     /*  468829 */   // Label 7957: @468829
     /*  468829 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(468918), // Rule ID 14196 //
     /*  468834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  468837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  468845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  468848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  468851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  468854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  468857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468881 */     // MIs[1] Operand 1
     /*  468881 */     // No operand predicates
     /*  468881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468890 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  468890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  468913 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  468916 */     GIR_RootConstrainSelectedInstOperands,
     /*  468917 */     // GIR_Coverage, 14196,
     /*  468917 */     GIR_EraseRootFromParent_Done,
     /*  468918 */   // Label 7958: @468918
     /*  468918 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(469007), // Rule ID 14197 //
     /*  468923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  468926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  468931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  468934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  468937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  468940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  468943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  468946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  468958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  468962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  468966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  468970 */     // MIs[1] Operand 1
     /*  468970 */     // No operand predicates
     /*  468970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  468972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  468979 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  468979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8),
     /*  468982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  468984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  468986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  468988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  468991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  468996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  468999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469005 */     GIR_RootConstrainSelectedInstOperands,
     /*  469006 */     // GIR_Coverage, 14197,
     /*  469006 */     GIR_EraseRootFromParent_Done,
     /*  469007 */   // Label 7959: @469007
     /*  469007 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(469096), // Rule ID 14376 //
     /*  469012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469059 */     // MIs[1] Operand 1
     /*  469059 */     // No operand predicates
     /*  469059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469068 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469094 */     GIR_RootConstrainSelectedInstOperands,
     /*  469095 */     // GIR_Coverage, 14376,
     /*  469095 */     GIR_EraseRootFromParent_Done,
     /*  469096 */   // Label 7960: @469096
     /*  469096 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(469185), // Rule ID 14377 //
     /*  469101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  469112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  469115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  469118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469148 */     // MIs[1] Operand 1
     /*  469148 */     // No operand predicates
     /*  469148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469157 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8),
     /*  469160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469183 */     GIR_RootConstrainSelectedInstOperands,
     /*  469184 */     // GIR_Coverage, 14377,
     /*  469184 */     GIR_EraseRootFromParent_Done,
     /*  469185 */   // Label 7961: @469185
     /*  469185 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(469274), // Rule ID 14380 //
     /*  469190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469237 */     // MIs[1] Operand 1
     /*  469237 */     // No operand predicates
     /*  469237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469246 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469269 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469272 */     GIR_RootConstrainSelectedInstOperands,
     /*  469273 */     // GIR_Coverage, 14380,
     /*  469273 */     GIR_EraseRootFromParent_Done,
     /*  469274 */   // Label 7962: @469274
     /*  469274 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(469363), // Rule ID 14381 //
     /*  469279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  469290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  469293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  469296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469326 */     // MIs[1] Operand 1
     /*  469326 */     // No operand predicates
     /*  469326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469335 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469361 */     GIR_RootConstrainSelectedInstOperands,
     /*  469362 */     // GIR_Coverage, 14381,
     /*  469362 */     GIR_EraseRootFromParent_Done,
     /*  469363 */   // Label 7963: @469363
     /*  469363 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(469452), // Rule ID 14384 //
     /*  469368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469415 */     // MIs[1] Operand 1
     /*  469415 */     // No operand predicates
     /*  469415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  469424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469450 */     GIR_RootConstrainSelectedInstOperands,
     /*  469451 */     // GIR_Coverage, 14384,
     /*  469451 */     GIR_EraseRootFromParent_Done,
     /*  469452 */   // Label 7964: @469452
     /*  469452 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(469541), // Rule ID 14385 //
     /*  469457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  469468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  469471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  469474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469504 */     // MIs[1] Operand 1
     /*  469504 */     // No operand predicates
     /*  469504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469513 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  469513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  469533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469539 */     GIR_RootConstrainSelectedInstOperands,
     /*  469540 */     // GIR_Coverage, 14385,
     /*  469540 */     GIR_EraseRootFromParent_Done,
     /*  469541 */   // Label 7965: @469541
     /*  469541 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(469630), // Rule ID 14388 //
     /*  469546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469593 */     // MIs[1] Operand 1
     /*  469593 */     // No operand predicates
     /*  469593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469602 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  469602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469628 */     GIR_RootConstrainSelectedInstOperands,
     /*  469629 */     // GIR_Coverage, 14388,
     /*  469629 */     GIR_EraseRootFromParent_Done,
     /*  469630 */   // Label 7966: @469630
     /*  469630 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(469719), // Rule ID 14389 //
     /*  469635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  469646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  469649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  469652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469682 */     // MIs[1] Operand 1
     /*  469682 */     // No operand predicates
     /*  469682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469691 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  469691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4),
     /*  469694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469717 */     GIR_RootConstrainSelectedInstOperands,
     /*  469718 */     // GIR_Coverage, 14389,
     /*  469718 */     GIR_EraseRootFromParent_Done,
     /*  469719 */   // Label 7967: @469719
     /*  469719 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(469808), // Rule ID 14392 //
     /*  469724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  469735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  469738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  469741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469771 */     // MIs[1] Operand 1
     /*  469771 */     // No operand predicates
     /*  469771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  469780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469803 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469806 */     GIR_RootConstrainSelectedInstOperands,
     /*  469807 */     // GIR_Coverage, 14392,
     /*  469807 */     GIR_EraseRootFromParent_Done,
     /*  469808 */   // Label 7968: @469808
     /*  469808 */   GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(469897), // Rule ID 14393 //
     /*  469813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  469824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  469827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  469830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  469833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  469836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469856 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469860 */     // MIs[1] Operand 1
     /*  469860 */     // No operand predicates
     /*  469860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469869 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  469869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  469889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469895 */     GIR_RootConstrainSelectedInstOperands,
     /*  469896 */     // GIR_Coverage, 14393,
     /*  469896 */     GIR_EraseRootFromParent_Done,
     /*  469897 */   // Label 7969: @469897
     /*  469897 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(469986), // Rule ID 14396 //
     /*  469902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  469905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  469913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  469916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  469919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  469922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  469925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  469937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  469941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  469945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  469949 */     // MIs[1] Operand 1
     /*  469949 */     // No operand predicates
     /*  469949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  469951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  469958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  469958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  469961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  469963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  469965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  469967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  469970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  469975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  469978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  469981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  469984 */     GIR_RootConstrainSelectedInstOperands,
     /*  469985 */     // GIR_Coverage, 14396,
     /*  469985 */     GIR_EraseRootFromParent_Done,
     /*  469986 */   // Label 7970: @469986
     /*  469986 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(470075), // Rule ID 14397 //
     /*  469991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  469994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  469999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  470002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  470005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  470008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470038 */     // MIs[1] Operand 1
     /*  470038 */     // No operand predicates
     /*  470038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470047 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2),
     /*  470050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470056 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470073 */     GIR_RootConstrainSelectedInstOperands,
     /*  470074 */     // GIR_Coverage, 14397,
     /*  470074 */     GIR_EraseRootFromParent_Done,
     /*  470075 */   // Label 7971: @470075
     /*  470075 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(470164), // Rule ID 14400 //
     /*  470080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470127 */     // MIs[1] Operand 1
     /*  470127 */     // No operand predicates
     /*  470127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470136 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470162 */     GIR_RootConstrainSelectedInstOperands,
     /*  470163 */     // GIR_Coverage, 14400,
     /*  470163 */     GIR_EraseRootFromParent_Done,
     /*  470164 */   // Label 7972: @470164
     /*  470164 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(470253), // Rule ID 14401 //
     /*  470169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  470180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  470183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  470186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470216 */     // MIs[1] Operand 1
     /*  470216 */     // No operand predicates
     /*  470216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470251 */     GIR_RootConstrainSelectedInstOperands,
     /*  470252 */     // GIR_Coverage, 14401,
     /*  470252 */     GIR_EraseRootFromParent_Done,
     /*  470253 */   // Label 7973: @470253
     /*  470253 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(470342), // Rule ID 14404 //
     /*  470258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470305 */     // MIs[1] Operand 1
     /*  470305 */     // No operand predicates
     /*  470305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470314 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  470314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470340 */     GIR_RootConstrainSelectedInstOperands,
     /*  470341 */     // GIR_Coverage, 14404,
     /*  470341 */     GIR_EraseRootFromParent_Done,
     /*  470342 */   // Label 7974: @470342
     /*  470342 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(470431), // Rule ID 14405 //
     /*  470347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  470358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  470361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  470364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470394 */     // MIs[1] Operand 1
     /*  470394 */     // No operand predicates
     /*  470394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470403 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  470403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  470423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470429 */     GIR_RootConstrainSelectedInstOperands,
     /*  470430 */     // GIR_Coverage, 14405,
     /*  470430 */     GIR_EraseRootFromParent_Done,
     /*  470431 */   // Label 7975: @470431
     /*  470431 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(470520), // Rule ID 14408 //
     /*  470436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470483 */     // MIs[1] Operand 1
     /*  470483 */     // No operand predicates
     /*  470483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  470492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470518 */     GIR_RootConstrainSelectedInstOperands,
     /*  470519 */     // GIR_Coverage, 14408,
     /*  470519 */     GIR_EraseRootFromParent_Done,
     /*  470520 */   // Label 7976: @470520
     /*  470520 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(470609), // Rule ID 14409 //
     /*  470525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  470536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  470539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  470542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470572 */     // MIs[1] Operand 1
     /*  470572 */     // No operand predicates
     /*  470572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470581 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  470581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  470601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470604 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470607 */     GIR_RootConstrainSelectedInstOperands,
     /*  470608 */     // GIR_Coverage, 14409,
     /*  470608 */     GIR_EraseRootFromParent_Done,
     /*  470609 */   // Label 7977: @470609
     /*  470609 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(470698), // Rule ID 14412 //
     /*  470614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  470617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  470625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  470628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  470631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470661 */     // MIs[1] Operand 1
     /*  470661 */     // No operand predicates
     /*  470661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470670 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  470670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  470690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470696 */     GIR_RootConstrainSelectedInstOperands,
     /*  470697 */     // GIR_Coverage, 14412,
     /*  470697 */     GIR_EraseRootFromParent_Done,
     /*  470698 */   // Label 7978: @470698
     /*  470698 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(470787), // Rule ID 14413 //
     /*  470703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  470706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  470714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  470717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  470720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  470738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470750 */     // MIs[1] Operand 1
     /*  470750 */     // No operand predicates
     /*  470750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470759 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  470759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1),
     /*  470762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  470779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470782 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470785 */     GIR_RootConstrainSelectedInstOperands,
     /*  470786 */     // GIR_Coverage, 14413,
     /*  470786 */     GIR_EraseRootFromParent_Done,
     /*  470787 */   // Label 7979: @470787
     /*  470787 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(470876), // Rule ID 14416 //
     /*  470792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  470803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  470806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  470809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470835 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470839 */     // MIs[1] Operand 1
     /*  470839 */     // No operand predicates
     /*  470839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470848 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  470848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  470851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470874 */     GIR_RootConstrainSelectedInstOperands,
     /*  470875 */     // GIR_Coverage, 14416,
     /*  470875 */     GIR_EraseRootFromParent_Done,
     /*  470876 */   // Label 7980: @470876
     /*  470876 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(470965), // Rule ID 14417 //
     /*  470881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  470884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  470892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  470895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  470898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  470901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  470904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  470916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  470920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  470924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  470928 */     // MIs[1] Operand 1
     /*  470928 */     // No operand predicates
     /*  470928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  470930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  470937 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  470937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  470940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  470942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  470944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  470946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  470949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  470954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  470957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  470960 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  470963 */     GIR_RootConstrainSelectedInstOperands,
     /*  470964 */     // GIR_Coverage, 14417,
     /*  470964 */     GIR_EraseRootFromParent_Done,
     /*  470965 */   // Label 7981: @470965
     /*  470965 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(471054), // Rule ID 14420 //
     /*  470970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  470973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  470978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  470981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  470984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  470987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  470990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  470993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  470997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471017 */     // MIs[1] Operand 1
     /*  471017 */     // No operand predicates
     /*  471017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471026 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471052 */     GIR_RootConstrainSelectedInstOperands,
     /*  471053 */     // GIR_Coverage, 14420,
     /*  471053 */     GIR_EraseRootFromParent_Done,
     /*  471054 */   // Label 7982: @471054
     /*  471054 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(471143), // Rule ID 14421 //
     /*  471059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  471070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  471073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  471076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471106 */     // MIs[1] Operand 1
     /*  471106 */     // No operand predicates
     /*  471106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471115 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471141 */     GIR_RootConstrainSelectedInstOperands,
     /*  471142 */     // GIR_Coverage, 14421,
     /*  471142 */     GIR_EraseRootFromParent_Done,
     /*  471143 */   // Label 7983: @471143
     /*  471143 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(471232), // Rule ID 14424 //
     /*  471148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471195 */     // MIs[1] Operand 1
     /*  471195 */     // No operand predicates
     /*  471195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471204 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  471204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471230 */     GIR_RootConstrainSelectedInstOperands,
     /*  471231 */     // GIR_Coverage, 14424,
     /*  471231 */     GIR_EraseRootFromParent_Done,
     /*  471232 */   // Label 7984: @471232
     /*  471232 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(471321), // Rule ID 14425 //
     /*  471237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  471248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  471251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  471254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471284 */     // MIs[1] Operand 1
     /*  471284 */     // No operand predicates
     /*  471284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471293 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  471293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  471313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471319 */     GIR_RootConstrainSelectedInstOperands,
     /*  471320 */     // GIR_Coverage, 14425,
     /*  471320 */     GIR_EraseRootFromParent_Done,
     /*  471321 */   // Label 7985: @471321
     /*  471321 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(471410), // Rule ID 14428 //
     /*  471326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471373 */     // MIs[1] Operand 1
     /*  471373 */     // No operand predicates
     /*  471373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471408 */     GIR_RootConstrainSelectedInstOperands,
     /*  471409 */     // GIR_Coverage, 14428,
     /*  471409 */     GIR_EraseRootFromParent_Done,
     /*  471410 */   // Label 7986: @471410
     /*  471410 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(471499), // Rule ID 14429 //
     /*  471415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  471426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  471429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  471432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471462 */     // MIs[1] Operand 1
     /*  471462 */     // No operand predicates
     /*  471462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471471 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471497 */     GIR_RootConstrainSelectedInstOperands,
     /*  471498 */     // GIR_Coverage, 14429,
     /*  471498 */     GIR_EraseRootFromParent_Done,
     /*  471499 */   // Label 7987: @471499
     /*  471499 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(471588), // Rule ID 14432 //
     /*  471504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471551 */     // MIs[1] Operand 1
     /*  471551 */     // No operand predicates
     /*  471551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471586 */     GIR_RootConstrainSelectedInstOperands,
     /*  471587 */     // GIR_Coverage, 14432,
     /*  471587 */     GIR_EraseRootFromParent_Done,
     /*  471588 */   // Label 7988: @471588
     /*  471588 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(471677), // Rule ID 14433 //
     /*  471593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  471604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  471607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  471610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  471628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471640 */     // MIs[1] Operand 1
     /*  471640 */     // No operand predicates
     /*  471640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471649 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  471652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471675 */     GIR_RootConstrainSelectedInstOperands,
     /*  471676 */     // GIR_Coverage, 14433,
     /*  471676 */     GIR_EraseRootFromParent_Done,
     /*  471677 */   // Label 7989: @471677
     /*  471677 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(471766), // Rule ID 14436 //
     /*  471682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  471693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  471696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  471699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471729 */     // MIs[1] Operand 1
     /*  471729 */     // No operand predicates
     /*  471729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471738 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  471738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471764 */     GIR_RootConstrainSelectedInstOperands,
     /*  471765 */     // GIR_Coverage, 14436,
     /*  471765 */     GIR_EraseRootFromParent_Done,
     /*  471766 */   // Label 7990: @471766
     /*  471766 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(471855), // Rule ID 14437 //
     /*  471771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  471782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  471785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  471788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  471806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471814 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471818 */     // MIs[1] Operand 1
     /*  471818 */     // No operand predicates
     /*  471818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471827 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  471827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  471830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  471847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471853 */     GIR_RootConstrainSelectedInstOperands,
     /*  471854 */     // GIR_Coverage, 14437,
     /*  471854 */     GIR_EraseRootFromParent_Done,
     /*  471855 */   // Label 7991: @471855
     /*  471855 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(471944), // Rule ID 14440 //
     /*  471860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  471863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  471871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  471874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  471877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  471880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  471883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471907 */     // MIs[1] Operand 1
     /*  471907 */     // No operand predicates
     /*  471907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  471916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  471916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  471919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  471921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  471923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  471925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  471928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  471933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  471936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  471939 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  471942 */     GIR_RootConstrainSelectedInstOperands,
     /*  471943 */     // GIR_Coverage, 14440,
     /*  471943 */     GIR_EraseRootFromParent_Done,
     /*  471944 */   // Label 7992: @471944
     /*  471944 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(472033), // Rule ID 14441 //
     /*  471949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  471952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  471957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  471960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  471963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  471966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  471969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  471972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  471984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  471988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  471992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  471996 */     // MIs[1] Operand 1
     /*  471996 */     // No operand predicates
     /*  471996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  471998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472031 */     GIR_RootConstrainSelectedInstOperands,
     /*  472032 */     // GIR_Coverage, 14441,
     /*  472032 */     GIR_EraseRootFromParent_Done,
     /*  472033 */   // Label 7993: @472033
     /*  472033 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(472122), // Rule ID 14444 //
     /*  472038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472085 */     // MIs[1] Operand 1
     /*  472085 */     // No operand predicates
     /*  472085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472120 */     GIR_RootConstrainSelectedInstOperands,
     /*  472121 */     // GIR_Coverage, 14444,
     /*  472121 */     GIR_EraseRootFromParent_Done,
     /*  472122 */   // Label 7994: @472122
     /*  472122 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(472211), // Rule ID 14445 //
     /*  472127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  472138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  472141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  472144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472170 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472174 */     // MIs[1] Operand 1
     /*  472174 */     // No operand predicates
     /*  472174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472183 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472209 */     GIR_RootConstrainSelectedInstOperands,
     /*  472210 */     // GIR_Coverage, 14445,
     /*  472210 */     GIR_EraseRootFromParent_Done,
     /*  472211 */   // Label 7995: @472211
     /*  472211 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(472300), // Rule ID 14448 //
     /*  472216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472263 */     // MIs[1] Operand 1
     /*  472263 */     // No operand predicates
     /*  472263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  472272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472298 */     GIR_RootConstrainSelectedInstOperands,
     /*  472299 */     // GIR_Coverage, 14448,
     /*  472299 */     GIR_EraseRootFromParent_Done,
     /*  472300 */   // Label 7996: @472300
     /*  472300 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(472389), // Rule ID 14449 //
     /*  472305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  472308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  472316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  472319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  472322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472352 */     // MIs[1] Operand 1
     /*  472352 */     // No operand predicates
     /*  472352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472361 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  472361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  472381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472387 */     GIR_RootConstrainSelectedInstOperands,
     /*  472388 */     // GIR_Coverage, 14449,
     /*  472388 */     GIR_EraseRootFromParent_Done,
     /*  472389 */   // Label 7997: @472389
     /*  472389 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(472478), // Rule ID 14452 //
     /*  472394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472441 */     // MIs[1] Operand 1
     /*  472441 */     // No operand predicates
     /*  472441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472476 */     GIR_RootConstrainSelectedInstOperands,
     /*  472477 */     // GIR_Coverage, 14452,
     /*  472477 */     GIR_EraseRootFromParent_Done,
     /*  472478 */   // Label 7998: @472478
     /*  472478 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(472567), // Rule ID 14453 //
     /*  472483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  472494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  472497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  472500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  472518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472530 */     // MIs[1] Operand 1
     /*  472530 */     // No operand predicates
     /*  472530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2),
     /*  472542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472565 */     GIR_RootConstrainSelectedInstOperands,
     /*  472566 */     // GIR_Coverage, 14453,
     /*  472566 */     GIR_EraseRootFromParent_Done,
     /*  472567 */   // Label 7999: @472567
     /*  472567 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(472656), // Rule ID 14456 //
     /*  472572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  472583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  472586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  472589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472619 */     // MIs[1] Operand 1
     /*  472619 */     // No operand predicates
     /*  472619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472654 */     GIR_RootConstrainSelectedInstOperands,
     /*  472655 */     // GIR_Coverage, 14456,
     /*  472655 */     GIR_EraseRootFromParent_Done,
     /*  472656 */   // Label 8000: @472656
     /*  472656 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(472745), // Rule ID 14457 //
     /*  472661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  472672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  472675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  472678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  472696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472708 */     // MIs[1] Operand 1
     /*  472708 */     // No operand predicates
     /*  472708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472717 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4),
     /*  472720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472743 */     GIR_RootConstrainSelectedInstOperands,
     /*  472744 */     // GIR_Coverage, 14457,
     /*  472744 */     GIR_EraseRootFromParent_Done,
     /*  472745 */   // Label 8001: @472745
     /*  472745 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(472834), // Rule ID 14460 //
     /*  472750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  472753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  472761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  472764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  472767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472797 */     // MIs[1] Operand 1
     /*  472797 */     // No operand predicates
     /*  472797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  472806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472829 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472832 */     GIR_RootConstrainSelectedInstOperands,
     /*  472833 */     // GIR_Coverage, 14460,
     /*  472833 */     GIR_EraseRootFromParent_Done,
     /*  472834 */   // Label 8002: @472834
     /*  472834 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(472923), // Rule ID 14461 //
     /*  472839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  472842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  472847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  472850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  472853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  472856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  472859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  472862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  472874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  472886 */     // MIs[1] Operand 1
     /*  472886 */     // No operand predicates
     /*  472886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472895 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  472895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8),
     /*  472898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  472912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  472915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  472918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  472921 */     GIR_RootConstrainSelectedInstOperands,
     /*  472922 */     // GIR_Coverage, 14461,
     /*  472922 */     GIR_EraseRootFromParent_Done,
     /*  472923 */   // Label 8003: @472923
     /*  472923 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(473009), // Rule ID 24556 //
     /*  472928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  472931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  472936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  472939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  472942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  472945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  472948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  472951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  472963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  472967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  472971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  472975 */     // MIs[1] Operand 1
     /*  472975 */     // No operand predicates
     /*  472975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  472977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  472984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  472984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  472987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  472989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  472991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  472993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  472996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473007 */     GIR_RootConstrainSelectedInstOperands,
     /*  473008 */     // GIR_Coverage, 24556,
     /*  473008 */     GIR_EraseRootFromParent_Done,
     /*  473009 */   // Label 8004: @473009
     /*  473009 */   GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(473095), // Rule ID 24557 //
     /*  473014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  473025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  473028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  473031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473057 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473061 */     // MIs[1] Operand 1
     /*  473061 */     // No operand predicates
     /*  473061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473070 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8),
     /*  473073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473093 */     GIR_RootConstrainSelectedInstOperands,
     /*  473094 */     // GIR_Coverage, 24557,
     /*  473094 */     GIR_EraseRootFromParent_Done,
     /*  473095 */   // Label 8005: @473095
     /*  473095 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(473181), // Rule ID 24560 //
     /*  473100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473147 */     // MIs[1] Operand 1
     /*  473147 */     // No operand predicates
     /*  473147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473156 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473179 */     GIR_RootConstrainSelectedInstOperands,
     /*  473180 */     // GIR_Coverage, 24560,
     /*  473180 */     GIR_EraseRootFromParent_Done,
     /*  473181 */   // Label 8006: @473181
     /*  473181 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(473267), // Rule ID 24561 //
     /*  473186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  473197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  473200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  473203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473233 */     // MIs[1] Operand 1
     /*  473233 */     // No operand predicates
     /*  473233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473242 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473265 */     GIR_RootConstrainSelectedInstOperands,
     /*  473266 */     // GIR_Coverage, 24561,
     /*  473266 */     GIR_EraseRootFromParent_Done,
     /*  473267 */   // Label 8007: @473267
     /*  473267 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(473353), // Rule ID 24564 //
     /*  473272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473319 */     // MIs[1] Operand 1
     /*  473319 */     // No operand predicates
     /*  473319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473328 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  473328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473351 */     GIR_RootConstrainSelectedInstOperands,
     /*  473352 */     // GIR_Coverage, 24564,
     /*  473352 */     GIR_EraseRootFromParent_Done,
     /*  473353 */   // Label 8008: @473353
     /*  473353 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(473439), // Rule ID 24565 //
     /*  473358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  473369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  473372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  473375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473405 */     // MIs[1] Operand 1
     /*  473405 */     // No operand predicates
     /*  473405 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473414 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  473414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473423 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  473434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473437 */     GIR_RootConstrainSelectedInstOperands,
     /*  473438 */     // GIR_Coverage, 24565,
     /*  473438 */     GIR_EraseRootFromParent_Done,
     /*  473439 */   // Label 8009: @473439
     /*  473439 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(473525), // Rule ID 24568 //
     /*  473444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473491 */     // MIs[1] Operand 1
     /*  473491 */     // No operand predicates
     /*  473491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473523 */     GIR_RootConstrainSelectedInstOperands,
     /*  473524 */     // GIR_Coverage, 24568,
     /*  473524 */     GIR_EraseRootFromParent_Done,
     /*  473525 */   // Label 8010: @473525
     /*  473525 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(473611), // Rule ID 24569 //
     /*  473530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  473541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  473544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  473547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473577 */     // MIs[1] Operand 1
     /*  473577 */     // No operand predicates
     /*  473577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  473589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473609 */     GIR_RootConstrainSelectedInstOperands,
     /*  473610 */     // GIR_Coverage, 24569,
     /*  473610 */     GIR_EraseRootFromParent_Done,
     /*  473611 */   // Label 8011: @473611
     /*  473611 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(473697), // Rule ID 24572 //
     /*  473616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  473627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  473630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  473633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473663 */     // MIs[1] Operand 1
     /*  473663 */     // No operand predicates
     /*  473663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  473672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473695 */     GIR_RootConstrainSelectedInstOperands,
     /*  473696 */     // GIR_Coverage, 24572,
     /*  473696 */     GIR_EraseRootFromParent_Done,
     /*  473697 */   // Label 8012: @473697
     /*  473697 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(473783), // Rule ID 24573 //
     /*  473702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  473713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  473716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  473719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473745 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473749 */     // MIs[1] Operand 1
     /*  473749 */     // No operand predicates
     /*  473749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473758 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  473758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  473778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473781 */     GIR_RootConstrainSelectedInstOperands,
     /*  473782 */     // GIR_Coverage, 24573,
     /*  473782 */     GIR_EraseRootFromParent_Done,
     /*  473783 */   // Label 8013: @473783
     /*  473783 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(473869), // Rule ID 24576 //
     /*  473788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  473799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  473802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  473805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473835 */     // MIs[1] Operand 1
     /*  473835 */     // No operand predicates
     /*  473835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473844 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  473844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473867 */     GIR_RootConstrainSelectedInstOperands,
     /*  473868 */     // GIR_Coverage, 24576,
     /*  473868 */     GIR_EraseRootFromParent_Done,
     /*  473869 */   // Label 8014: @473869
     /*  473869 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(473955), // Rule ID 24577 //
     /*  473874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  473877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  473885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  473888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  473891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  473894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  473897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  473917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  473921 */     // MIs[1] Operand 1
     /*  473921 */     // No operand predicates
     /*  473921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  473923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  473930 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  473930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  473933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  473935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  473937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  473939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  473942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  473947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  473950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  473953 */     GIR_RootConstrainSelectedInstOperands,
     /*  473954 */     // GIR_Coverage, 24577,
     /*  473954 */     GIR_EraseRootFromParent_Done,
     /*  473955 */   // Label 8015: @473955
     /*  473955 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(474041), // Rule ID 24580 //
     /*  473960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  473963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  473968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  473971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  473974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  473977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  473980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  473983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  473995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  473999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474007 */     // MIs[1] Operand 1
     /*  474007 */     // No operand predicates
     /*  474007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474039 */     GIR_RootConstrainSelectedInstOperands,
     /*  474040 */     // GIR_Coverage, 24580,
     /*  474040 */     GIR_EraseRootFromParent_Done,
     /*  474041 */   // Label 8016: @474041
     /*  474041 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(474127), // Rule ID 24581 //
     /*  474046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  474057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  474060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  474063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474093 */     // MIs[1] Operand 1
     /*  474093 */     // No operand predicates
     /*  474093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474102 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474111 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474125 */     GIR_RootConstrainSelectedInstOperands,
     /*  474126 */     // GIR_Coverage, 24581,
     /*  474126 */     GIR_EraseRootFromParent_Done,
     /*  474127 */   // Label 8017: @474127
     /*  474127 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(474213), // Rule ID 24584 //
     /*  474132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474179 */     // MIs[1] Operand 1
     /*  474179 */     // No operand predicates
     /*  474179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  474188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474211 */     GIR_RootConstrainSelectedInstOperands,
     /*  474212 */     // GIR_Coverage, 24584,
     /*  474212 */     GIR_EraseRootFromParent_Done,
     /*  474213 */   // Label 8018: @474213
     /*  474213 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(474299), // Rule ID 24585 //
     /*  474218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  474229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  474232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  474235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474265 */     // MIs[1] Operand 1
     /*  474265 */     // No operand predicates
     /*  474265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  474274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  474294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474297 */     GIR_RootConstrainSelectedInstOperands,
     /*  474298 */     // GIR_Coverage, 24585,
     /*  474298 */     GIR_EraseRootFromParent_Done,
     /*  474299 */   // Label 8019: @474299
     /*  474299 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(474385), // Rule ID 24588 //
     /*  474304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474351 */     // MIs[1] Operand 1
     /*  474351 */     // No operand predicates
     /*  474351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  474360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474383 */     GIR_RootConstrainSelectedInstOperands,
     /*  474384 */     // GIR_Coverage, 24588,
     /*  474384 */     GIR_EraseRootFromParent_Done,
     /*  474385 */   // Label 8020: @474385
     /*  474385 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(474471), // Rule ID 24589 //
     /*  474390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  474401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  474404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  474407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474437 */     // MIs[1] Operand 1
     /*  474437 */     // No operand predicates
     /*  474437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474446 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  474446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  474466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474469 */     GIR_RootConstrainSelectedInstOperands,
     /*  474470 */     // GIR_Coverage, 24589,
     /*  474470 */     GIR_EraseRootFromParent_Done,
     /*  474471 */   // Label 8021: @474471
     /*  474471 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(474557), // Rule ID 24592 //
     /*  474476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  474479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  474487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  474490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  474493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474523 */     // MIs[1] Operand 1
     /*  474523 */     // No operand predicates
     /*  474523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  474532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  474552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474555 */     GIR_RootConstrainSelectedInstOperands,
     /*  474556 */     // GIR_Coverage, 24592,
     /*  474556 */     GIR_EraseRootFromParent_Done,
     /*  474557 */   // Label 8022: @474557
     /*  474557 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(474643), // Rule ID 24593 //
     /*  474562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  474565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  474573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  474576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  474579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  474597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474609 */     // MIs[1] Operand 1
     /*  474609 */     // No operand predicates
     /*  474609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474618 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  474618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  474621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  474638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474641 */     GIR_RootConstrainSelectedInstOperands,
     /*  474642 */     // GIR_Coverage, 24593,
     /*  474642 */     GIR_EraseRootFromParent_Done,
     /*  474643 */   // Label 8023: @474643
     /*  474643 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(474729), // Rule ID 24596 //
     /*  474648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  474659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  474662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  474665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474695 */     // MIs[1] Operand 1
     /*  474695 */     // No operand predicates
     /*  474695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  474707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474727 */     GIR_RootConstrainSelectedInstOperands,
     /*  474728 */     // GIR_Coverage, 24596,
     /*  474728 */     GIR_EraseRootFromParent_Done,
     /*  474729 */   // Label 8024: @474729
     /*  474729 */   GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(474815), // Rule ID 24597 //
     /*  474734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  474745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  474748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  474751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  474769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474781 */     // MIs[1] Operand 1
     /*  474781 */     // No operand predicates
     /*  474781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474790 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  474793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474813 */     GIR_RootConstrainSelectedInstOperands,
     /*  474814 */     // GIR_Coverage, 24597,
     /*  474814 */     GIR_EraseRootFromParent_Done,
     /*  474815 */   // Label 8025: @474815
     /*  474815 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(474901), // Rule ID 24600 //
     /*  474820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  474831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  474834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  474837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  474840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  474843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474867 */     // MIs[1] Operand 1
     /*  474867 */     // No operand predicates
     /*  474867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474876 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  474876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  474879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474899 */     GIR_RootConstrainSelectedInstOperands,
     /*  474900 */     // GIR_Coverage, 24600,
     /*  474900 */     GIR_EraseRootFromParent_Done,
     /*  474901 */   // Label 8026: @474901
     /*  474901 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(474987), // Rule ID 24601 //
     /*  474906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  474909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  474914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  474917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  474920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  474923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  474926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  474929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  474941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  474945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  474949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  474953 */     // MIs[1] Operand 1
     /*  474953 */     // No operand predicates
     /*  474953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  474955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  474962 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  474962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  474965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  474967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  474969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  474971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  474974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  474979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  474982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  474985 */     GIR_RootConstrainSelectedInstOperands,
     /*  474986 */     // GIR_Coverage, 24601,
     /*  474986 */     GIR_EraseRootFromParent_Done,
     /*  474987 */   // Label 8027: @474987
     /*  474987 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(475073), // Rule ID 24604 //
     /*  474992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  474995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475039 */     // MIs[1] Operand 1
     /*  475039 */     // No operand predicates
     /*  475039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475048 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  475048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475071 */     GIR_RootConstrainSelectedInstOperands,
     /*  475072 */     // GIR_Coverage, 24604,
     /*  475072 */     GIR_EraseRootFromParent_Done,
     /*  475073 */   // Label 8028: @475073
     /*  475073 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(475159), // Rule ID 24605 //
     /*  475078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  475089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  475092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  475095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475125 */     // MIs[1] Operand 1
     /*  475125 */     // No operand predicates
     /*  475125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  475134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  475154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475157 */     GIR_RootConstrainSelectedInstOperands,
     /*  475158 */     // GIR_Coverage, 24605,
     /*  475158 */     GIR_EraseRootFromParent_Done,
     /*  475159 */   // Label 8029: @475159
     /*  475159 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(475245), // Rule ID 24608 //
     /*  475164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475211 */     // MIs[1] Operand 1
     /*  475211 */     // No operand predicates
     /*  475211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475243 */     GIR_RootConstrainSelectedInstOperands,
     /*  475244 */     // GIR_Coverage, 24608,
     /*  475244 */     GIR_EraseRootFromParent_Done,
     /*  475245 */   // Label 8030: @475245
     /*  475245 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(475331), // Rule ID 24609 //
     /*  475250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  475261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  475264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  475267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475297 */     // MIs[1] Operand 1
     /*  475297 */     // No operand predicates
     /*  475297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475306 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475329 */     GIR_RootConstrainSelectedInstOperands,
     /*  475330 */     // GIR_Coverage, 24609,
     /*  475330 */     GIR_EraseRootFromParent_Done,
     /*  475331 */   // Label 8031: @475331
     /*  475331 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(475417), // Rule ID 24612 //
     /*  475336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475383 */     // MIs[1] Operand 1
     /*  475383 */     // No operand predicates
     /*  475383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475392 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475415 */     GIR_RootConstrainSelectedInstOperands,
     /*  475416 */     // GIR_Coverage, 24612,
     /*  475416 */     GIR_EraseRootFromParent_Done,
     /*  475417 */   // Label 8032: @475417
     /*  475417 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(475503), // Rule ID 24613 //
     /*  475422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  475433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  475436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  475439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475465 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475469 */     // MIs[1] Operand 1
     /*  475469 */     // No operand predicates
     /*  475469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475478 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475501 */     GIR_RootConstrainSelectedInstOperands,
     /*  475502 */     // GIR_Coverage, 24613,
     /*  475502 */     GIR_EraseRootFromParent_Done,
     /*  475503 */   // Label 8033: @475503
     /*  475503 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(475589), // Rule ID 24616 //
     /*  475508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  475519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  475522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  475525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475555 */     // MIs[1] Operand 1
     /*  475555 */     // No operand predicates
     /*  475555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475564 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  475564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475587 */     GIR_RootConstrainSelectedInstOperands,
     /*  475588 */     // GIR_Coverage, 24616,
     /*  475588 */     GIR_EraseRootFromParent_Done,
     /*  475589 */   // Label 8034: @475589
     /*  475589 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(475675), // Rule ID 24617 //
     /*  475594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  475605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  475608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  475611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  475629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475641 */     // MIs[1] Operand 1
     /*  475641 */     // No operand predicates
     /*  475641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  475650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  475653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  475670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475673 */     GIR_RootConstrainSelectedInstOperands,
     /*  475674 */     // GIR_Coverage, 24617,
     /*  475674 */     GIR_EraseRootFromParent_Done,
     /*  475675 */   // Label 8035: @475675
     /*  475675 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(475761), // Rule ID 24620 //
     /*  475680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  475691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  475694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  475697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475727 */     // MIs[1] Operand 1
     /*  475727 */     // No operand predicates
     /*  475727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  475736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475759 */     GIR_RootConstrainSelectedInstOperands,
     /*  475760 */     // GIR_Coverage, 24620,
     /*  475760 */     GIR_EraseRootFromParent_Done,
     /*  475761 */   // Label 8036: @475761
     /*  475761 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(475847), // Rule ID 24621 //
     /*  475766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  475777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  475780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  475783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  475801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475813 */     // MIs[1] Operand 1
     /*  475813 */     // No operand predicates
     /*  475813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  475822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  475825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475845 */     GIR_RootConstrainSelectedInstOperands,
     /*  475846 */     // GIR_Coverage, 24621,
     /*  475846 */     GIR_EraseRootFromParent_Done,
     /*  475847 */   // Label 8037: @475847
     /*  475847 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(475933), // Rule ID 24624 //
     /*  475852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  475855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  475863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  475866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  475869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  475872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  475875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475895 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475899 */     // MIs[1] Operand 1
     /*  475899 */     // No operand predicates
     /*  475899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  475908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  475915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  475917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  475920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  475925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  475928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  475931 */     GIR_RootConstrainSelectedInstOperands,
     /*  475932 */     // GIR_Coverage, 24624,
     /*  475932 */     GIR_EraseRootFromParent_Done,
     /*  475933 */   // Label 8038: @475933
     /*  475933 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(476019), // Rule ID 24625 //
     /*  475938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  475941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  475946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  475949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  475952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  475955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  475958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  475961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  475973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  475977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  475981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  475985 */     // MIs[1] Operand 1
     /*  475985 */     // No operand predicates
     /*  475985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  475987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  475994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  475994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  475997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  475999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476017 */     GIR_RootConstrainSelectedInstOperands,
     /*  476018 */     // GIR_Coverage, 24625,
     /*  476018 */     GIR_EraseRootFromParent_Done,
     /*  476019 */   // Label 8039: @476019
     /*  476019 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(476105), // Rule ID 24628 //
     /*  476024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  476027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476071 */     // MIs[1] Operand 1
     /*  476071 */     // No operand predicates
     /*  476071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476103 */     GIR_RootConstrainSelectedInstOperands,
     /*  476104 */     // GIR_Coverage, 24628,
     /*  476104 */     GIR_EraseRootFromParent_Done,
     /*  476105 */   // Label 8040: @476105
     /*  476105 */   GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(476191), // Rule ID 24629 //
     /*  476110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  476113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  476121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  476124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  476127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476157 */     // MIs[1] Operand 1
     /*  476157 */     // No operand predicates
     /*  476157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476189 */     GIR_RootConstrainSelectedInstOperands,
     /*  476190 */     // GIR_Coverage, 24629,
     /*  476190 */     GIR_EraseRootFromParent_Done,
     /*  476191 */   // Label 8041: @476191
     /*  476191 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(476277), // Rule ID 24632 //
     /*  476196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476239 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476243 */     // MIs[1] Operand 1
     /*  476243 */     // No operand predicates
     /*  476243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476275 */     GIR_RootConstrainSelectedInstOperands,
     /*  476276 */     // GIR_Coverage, 24632,
     /*  476276 */     GIR_EraseRootFromParent_Done,
     /*  476277 */   // Label 8042: @476277
     /*  476277 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(476363), // Rule ID 24633 //
     /*  476282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  476293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  476296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  476299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  476317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476329 */     // MIs[1] Operand 1
     /*  476329 */     // No operand predicates
     /*  476329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  476341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476361 */     GIR_RootConstrainSelectedInstOperands,
     /*  476362 */     // GIR_Coverage, 24633,
     /*  476362 */     GIR_EraseRootFromParent_Done,
     /*  476363 */   // Label 8043: @476363
     /*  476363 */   GIM_Try, /*On fail goto*//*Label 8044*/ GIMT_Encode4(476449), // Rule ID 24636 //
     /*  476368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476415 */     // MIs[1] Operand 1
     /*  476415 */     // No operand predicates
     /*  476415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476424 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476447 */     GIR_RootConstrainSelectedInstOperands,
     /*  476448 */     // GIR_Coverage, 24636,
     /*  476448 */     GIR_EraseRootFromParent_Done,
     /*  476449 */   // Label 8044: @476449
     /*  476449 */   GIM_Try, /*On fail goto*//*Label 8045*/ GIMT_Encode4(476535), // Rule ID 24637 //
     /*  476454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  476465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  476468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  476471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  476489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476501 */     // MIs[1] Operand 1
     /*  476501 */     // No operand predicates
     /*  476501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476510 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  476513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476533 */     GIR_RootConstrainSelectedInstOperands,
     /*  476534 */     // GIR_Coverage, 24637,
     /*  476534 */     GIR_EraseRootFromParent_Done,
     /*  476535 */   // Label 8045: @476535
     /*  476535 */   GIM_Try, /*On fail goto*//*Label 8046*/ GIMT_Encode4(476621), // Rule ID 24640 //
     /*  476540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  476543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  476551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  476554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  476557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476587 */     // MIs[1] Operand 1
     /*  476587 */     // No operand predicates
     /*  476587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  476596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476619 */     GIR_RootConstrainSelectedInstOperands,
     /*  476620 */     // GIR_Coverage, 24640,
     /*  476620 */     GIR_EraseRootFromParent_Done,
     /*  476621 */   // Label 8046: @476621
     /*  476621 */   GIM_Try, /*On fail goto*//*Label 8047*/ GIMT_Encode4(476707), // Rule ID 24641 //
     /*  476626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  476629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  476637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  476640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  476643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  476661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476669 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476673 */     // MIs[1] Operand 1
     /*  476673 */     // No operand predicates
     /*  476673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476682 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  476682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  476685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  476702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476705 */     GIR_RootConstrainSelectedInstOperands,
     /*  476706 */     // GIR_Coverage, 24641,
     /*  476706 */     GIR_EraseRootFromParent_Done,
     /*  476707 */   // Label 8047: @476707
     /*  476707 */   GIM_Try, /*On fail goto*//*Label 8048*/ GIMT_Encode4(476793), // Rule ID 24800 //
     /*  476712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  476715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  476723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  476726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  476729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476759 */     // MIs[1] Operand 1
     /*  476759 */     // No operand predicates
     /*  476759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476768 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  476771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476791 */     GIR_RootConstrainSelectedInstOperands,
     /*  476792 */     // GIR_Coverage, 24800,
     /*  476792 */     GIR_EraseRootFromParent_Done,
     /*  476793 */   // Label 8048: @476793
     /*  476793 */   GIM_Try, /*On fail goto*//*Label 8049*/ GIMT_Encode4(476879), // Rule ID 24801 //
     /*  476798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  476801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  476809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  476812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  476815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476845 */     // MIs[1] Operand 1
     /*  476845 */     // No operand predicates
     /*  476845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476854 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  476854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  476857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476877 */     GIR_RootConstrainSelectedInstOperands,
     /*  476878 */     // GIR_Coverage, 24801,
     /*  476878 */     GIR_EraseRootFromParent_Done,
     /*  476879 */   // Label 8049: @476879
     /*  476879 */   GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(476965), // Rule ID 24804 //
     /*  476884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  476887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  476895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  476898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  476901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  476904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  476907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  476923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  476927 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  476931 */     // MIs[1] Operand 1
     /*  476931 */     // No operand predicates
     /*  476931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  476933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  476940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  476940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  476943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  476945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  476947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  476949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  476952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  476957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  476960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  476963 */     GIR_RootConstrainSelectedInstOperands,
     /*  476964 */     // GIR_Coverage, 24804,
     /*  476964 */     GIR_EraseRootFromParent_Done,
     /*  476965 */   // Label 8050: @476965
     /*  476965 */   GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(477051), // Rule ID 24805 //
     /*  476970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  476973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  476978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  476981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  476984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  476987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  476990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  476993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  476997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477017 */     // MIs[1] Operand 1
     /*  477017 */     // No operand predicates
     /*  477017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477026 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477049 */     GIR_RootConstrainSelectedInstOperands,
     /*  477050 */     // GIR_Coverage, 24805,
     /*  477050 */     GIR_EraseRootFromParent_Done,
     /*  477051 */   // Label 8051: @477051
     /*  477051 */   GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(477137), // Rule ID 24808 //
     /*  477056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  477059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  477067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  477070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  477073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477103 */     // MIs[1] Operand 1
     /*  477103 */     // No operand predicates
     /*  477103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477112 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477135 */     GIR_RootConstrainSelectedInstOperands,
     /*  477136 */     // GIR_Coverage, 24808,
     /*  477136 */     GIR_EraseRootFromParent_Done,
     /*  477137 */   // Label 8052: @477137
     /*  477137 */   GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(477223), // Rule ID 24809 //
     /*  477142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  477145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  477153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  477156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  477159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  477177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477189 */     // MIs[1] Operand 1
     /*  477189 */     // No operand predicates
     /*  477189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477198 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  477201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477221 */     GIR_RootConstrainSelectedInstOperands,
     /*  477222 */     // GIR_Coverage, 24809,
     /*  477222 */     GIR_EraseRootFromParent_Done,
     /*  477223 */   // Label 8053: @477223
     /*  477223 */   GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(477309), // Rule ID 24812 //
     /*  477228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  477231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  477239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  477242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  477245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477275 */     // MIs[1] Operand 1
     /*  477275 */     // No operand predicates
     /*  477275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477307 */     GIR_RootConstrainSelectedInstOperands,
     /*  477308 */     // GIR_Coverage, 24812,
     /*  477308 */     GIR_EraseRootFromParent_Done,
     /*  477309 */   // Label 8054: @477309
     /*  477309 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(477395), // Rule ID 24813 //
     /*  477314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  477317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  477325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  477328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  477331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477357 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477361 */     // MIs[1] Operand 1
     /*  477361 */     // No operand predicates
     /*  477361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477370 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477393 */     GIR_RootConstrainSelectedInstOperands,
     /*  477394 */     // GIR_Coverage, 24813,
     /*  477394 */     GIR_EraseRootFromParent_Done,
     /*  477395 */   // Label 8055: @477395
     /*  477395 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(477481), // Rule ID 24816 //
     /*  477400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  477403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  477411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  477414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  477417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477447 */     // MIs[1] Operand 1
     /*  477447 */     // No operand predicates
     /*  477447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477456 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477479 */     GIR_RootConstrainSelectedInstOperands,
     /*  477480 */     // GIR_Coverage, 24816,
     /*  477480 */     GIR_EraseRootFromParent_Done,
     /*  477481 */   // Label 8056: @477481
     /*  477481 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(477567), // Rule ID 24817 //
     /*  477486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  477489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  477497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  477500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  477503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477533 */     // MIs[1] Operand 1
     /*  477533 */     // No operand predicates
     /*  477533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477542 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477565 */     GIR_RootConstrainSelectedInstOperands,
     /*  477566 */     // GIR_Coverage, 24817,
     /*  477566 */     GIR_EraseRootFromParent_Done,
     /*  477567 */   // Label 8057: @477567
     /*  477567 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(477653), // Rule ID 24820 //
     /*  477572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  477575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477619 */     // MIs[1] Operand 1
     /*  477619 */     // No operand predicates
     /*  477619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477628 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  477628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477651 */     GIR_RootConstrainSelectedInstOperands,
     /*  477652 */     // GIR_Coverage, 24820,
     /*  477652 */     GIR_EraseRootFromParent_Done,
     /*  477653 */   // Label 8058: @477653
     /*  477653 */   GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(477739), // Rule ID 24821 //
     /*  477658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  477661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  477669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  477672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  477675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  477693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477705 */     // MIs[1] Operand 1
     /*  477705 */     // No operand predicates
     /*  477705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477714 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  477714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  477717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  477734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477737 */     GIR_RootConstrainSelectedInstOperands,
     /*  477738 */     // GIR_Coverage, 24821,
     /*  477738 */     GIR_EraseRootFromParent_Done,
     /*  477739 */   // Label 8059: @477739
     /*  477739 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(477825), // Rule ID 24824 //
     /*  477744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  477747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477791 */     // MIs[1] Operand 1
     /*  477791 */     // No operand predicates
     /*  477791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477800 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477823 */     GIR_RootConstrainSelectedInstOperands,
     /*  477824 */     // GIR_Coverage, 24824,
     /*  477824 */     GIR_EraseRootFromParent_Done,
     /*  477825 */   // Label 8060: @477825
     /*  477825 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(477911), // Rule ID 24825 //
     /*  477830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  477833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  477841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  477844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  477847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  477850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  477853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  477865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477877 */     // MIs[1] Operand 1
     /*  477877 */     // No operand predicates
     /*  477877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477886 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  477886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  477889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477909 */     GIR_RootConstrainSelectedInstOperands,
     /*  477910 */     // GIR_Coverage, 24825,
     /*  477910 */     GIR_EraseRootFromParent_Done,
     /*  477911 */   // Label 8061: @477911
     /*  477911 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(477997), // Rule ID 24828 //
     /*  477916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  477919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  477924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  477927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  477930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  477933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  477936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  477939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  477951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  477955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  477959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  477963 */     // MIs[1] Operand 1
     /*  477963 */     // No operand predicates
     /*  477963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  477965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  477972 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  477972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  477975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  477977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  477979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  477981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  477984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  477989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  477992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  477995 */     GIR_RootConstrainSelectedInstOperands,
     /*  477996 */     // GIR_Coverage, 24828,
     /*  477996 */     GIR_EraseRootFromParent_Done,
     /*  477997 */   // Label 8062: @477997
     /*  477997 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(478083), // Rule ID 24829 //
     /*  478002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  478005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  478013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  478016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  478019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478045 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478049 */     // MIs[1] Operand 1
     /*  478049 */     // No operand predicates
     /*  478049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478058 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  478061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478081 */     GIR_RootConstrainSelectedInstOperands,
     /*  478082 */     // GIR_Coverage, 24829,
     /*  478082 */     GIR_EraseRootFromParent_Done,
     /*  478083 */   // Label 8063: @478083
     /*  478083 */   GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(478169), // Rule ID 24832 //
     /*  478088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  478091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  478099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  478102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  478105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478135 */     // MIs[1] Operand 1
     /*  478135 */     // No operand predicates
     /*  478135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478144 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  478144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478167 */     GIR_RootConstrainSelectedInstOperands,
     /*  478168 */     // GIR_Coverage, 24832,
     /*  478168 */     GIR_EraseRootFromParent_Done,
     /*  478169 */   // Label 8064: @478169
     /*  478169 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(478255), // Rule ID 24833 //
     /*  478174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  478177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  478185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  478188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  478191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  478209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478221 */     // MIs[1] Operand 1
     /*  478221 */     // No operand predicates
     /*  478221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478230 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  478230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  478233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  478250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478253 */     GIR_RootConstrainSelectedInstOperands,
     /*  478254 */     // GIR_Coverage, 24833,
     /*  478254 */     GIR_EraseRootFromParent_Done,
     /*  478255 */   // Label 8065: @478255
     /*  478255 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(478341), // Rule ID 24884 //
     /*  478260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  478271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  478274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  478277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478307 */     // MIs[1] Operand 1
     /*  478307 */     // No operand predicates
     /*  478307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478316 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  478319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478339 */     GIR_RootConstrainSelectedInstOperands,
     /*  478340 */     // GIR_Coverage, 24884,
     /*  478340 */     GIR_EraseRootFromParent_Done,
     /*  478341 */   // Label 8066: @478341
     /*  478341 */   GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(478427), // Rule ID 24885 //
     /*  478346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  478357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  478360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  478363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478389 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478393 */     // MIs[1] Operand 1
     /*  478393 */     // No operand predicates
     /*  478393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4),
     /*  478405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478411 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478425 */     GIR_RootConstrainSelectedInstOperands,
     /*  478426 */     // GIR_Coverage, 24885,
     /*  478426 */     GIR_EraseRootFromParent_Done,
     /*  478427 */   // Label 8067: @478427
     /*  478427 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(478513), // Rule ID 24888 //
     /*  478432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  478443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  478446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  478449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478479 */     // MIs[1] Operand 1
     /*  478479 */     // No operand predicates
     /*  478479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478488 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478511 */     GIR_RootConstrainSelectedInstOperands,
     /*  478512 */     // GIR_Coverage, 24888,
     /*  478512 */     GIR_EraseRootFromParent_Done,
     /*  478513 */   // Label 8068: @478513
     /*  478513 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(478599), // Rule ID 24889 //
     /*  478518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  478529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  478532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  478535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478565 */     // MIs[1] Operand 1
     /*  478565 */     // No operand predicates
     /*  478565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478574 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2),
     /*  478577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478597 */     GIR_RootConstrainSelectedInstOperands,
     /*  478598 */     // GIR_Coverage, 24889,
     /*  478598 */     GIR_EraseRootFromParent_Done,
     /*  478599 */   // Label 8069: @478599
     /*  478599 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(478685), // Rule ID 24892 //
     /*  478604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478651 */     // MIs[1] Operand 1
     /*  478651 */     // No operand predicates
     /*  478651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478660 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478683 */     GIR_RootConstrainSelectedInstOperands,
     /*  478684 */     // GIR_Coverage, 24892,
     /*  478684 */     GIR_EraseRootFromParent_Done,
     /*  478685 */   // Label 8070: @478685
     /*  478685 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(478771), // Rule ID 24893 //
     /*  478690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  478701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  478704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  478707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  478725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478737 */     // MIs[1] Operand 1
     /*  478737 */     // No operand predicates
     /*  478737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478746 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1),
     /*  478749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478769 */     GIR_RootConstrainSelectedInstOperands,
     /*  478770 */     // GIR_Coverage, 24893,
     /*  478770 */     GIR_EraseRootFromParent_Done,
     /*  478771 */   // Label 8071: @478771
     /*  478771 */   GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(478857), // Rule ID 24896 //
     /*  478776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478823 */     // MIs[1] Operand 1
     /*  478823 */     // No operand predicates
     /*  478823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478832 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  478832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478855 */     GIR_RootConstrainSelectedInstOperands,
     /*  478856 */     // GIR_Coverage, 24896,
     /*  478856 */     GIR_EraseRootFromParent_Done,
     /*  478857 */   // Label 8072: @478857
     /*  478857 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(478943), // Rule ID 24897 //
     /*  478862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  478865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  478873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  478876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  478879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  478882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  478885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  478897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478909 */     // MIs[1] Operand 1
     /*  478909 */     // No operand predicates
     /*  478909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  478918 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  478918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2),
     /*  478921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  478923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  478925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  478927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  478930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  478935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  478938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  478941 */     GIR_RootConstrainSelectedInstOperands,
     /*  478942 */     // GIR_Coverage, 24897,
     /*  478942 */     GIR_EraseRootFromParent_Done,
     /*  478943 */   // Label 8073: @478943
     /*  478943 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(479029), // Rule ID 24900 //
     /*  478948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  478951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  478956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  478959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  478962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  478965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  478968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  478971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  478983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  478987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  478991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  478995 */     // MIs[1] Operand 1
     /*  478995 */     // No operand predicates
     /*  478995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  478997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479027 */     GIR_RootConstrainSelectedInstOperands,
     /*  479028 */     // GIR_Coverage, 24900,
     /*  479028 */     GIR_EraseRootFromParent_Done,
     /*  479029 */   // Label 8074: @479029
     /*  479029 */   GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(479115), // Rule ID 24901 //
     /*  479034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  479037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  479051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  479069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479077 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479081 */     // MIs[1] Operand 1
     /*  479081 */     // No operand predicates
     /*  479081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4),
     /*  479093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479113 */     GIR_RootConstrainSelectedInstOperands,
     /*  479114 */     // GIR_Coverage, 24901,
     /*  479114 */     GIR_EraseRootFromParent_Done,
     /*  479115 */   // Label 8075: @479115
     /*  479115 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(479201), // Rule ID 24904 //
     /*  479120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  479123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479167 */     // MIs[1] Operand 1
     /*  479167 */     // No operand predicates
     /*  479167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479176 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  479176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479199 */     GIR_RootConstrainSelectedInstOperands,
     /*  479200 */     // GIR_Coverage, 24904,
     /*  479200 */     GIR_EraseRootFromParent_Done,
     /*  479201 */   // Label 8076: @479201
     /*  479201 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(479287), // Rule ID 24905 //
     /*  479206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  479209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  479214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  479217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  479220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  479223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  479241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479253 */     // MIs[1] Operand 1
     /*  479253 */     // No operand predicates
     /*  479253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479262 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  479262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8),
     /*  479265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  479282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479285 */     GIR_RootConstrainSelectedInstOperands,
     /*  479286 */     // GIR_Coverage, 24905,
     /*  479286 */     GIR_EraseRootFromParent_Done,
     /*  479287 */   // Label 8077: @479287
     /*  479287 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(479373), // Rule ID 60908 //
     /*  479292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479339 */     // MIs[1] Operand 1
     /*  479339 */     // No operand predicates
     /*  479339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479348 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479371 */     GIR_RootConstrainSelectedInstOperands,
     /*  479372 */     // GIR_Coverage, 60908,
     /*  479372 */     GIR_EraseRootFromParent_Done,
     /*  479373 */   // Label 8078: @479373
     /*  479373 */   GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(479459), // Rule ID 60909 //
     /*  479378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  479389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  479392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  479395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479425 */     // MIs[1] Operand 1
     /*  479425 */     // No operand predicates
     /*  479425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479434 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8),
     /*  479437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479457 */     GIR_RootConstrainSelectedInstOperands,
     /*  479458 */     // GIR_Coverage, 60909,
     /*  479458 */     GIR_EraseRootFromParent_Done,
     /*  479459 */   // Label 8079: @479459
     /*  479459 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(479545), // Rule ID 60916 //
     /*  479464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  479481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479507 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479511 */     // MIs[1] Operand 1
     /*  479511 */     // No operand predicates
     /*  479511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479520 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  479523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479543 */     GIR_RootConstrainSelectedInstOperands,
     /*  479544 */     // GIR_Coverage, 60916,
     /*  479544 */     GIR_EraseRootFromParent_Done,
     /*  479545 */   // Label 8080: @479545
     /*  479545 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(479631), // Rule ID 60917 //
     /*  479550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  479561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  479564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  479567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479597 */     // MIs[1] Operand 1
     /*  479597 */     // No operand predicates
     /*  479597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  479609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479629 */     GIR_RootConstrainSelectedInstOperands,
     /*  479630 */     // GIR_Coverage, 60917,
     /*  479630 */     GIR_EraseRootFromParent_Done,
     /*  479631 */   // Label 8081: @479631
     /*  479631 */   GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(479717), // Rule ID 60924 //
     /*  479636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  479647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  479650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  479653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479683 */     // MIs[1] Operand 1
     /*  479683 */     // No operand predicates
     /*  479683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  479695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479715 */     GIR_RootConstrainSelectedInstOperands,
     /*  479716 */     // GIR_Coverage, 60924,
     /*  479716 */     GIR_EraseRootFromParent_Done,
     /*  479717 */   // Label 8082: @479717
     /*  479717 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(479803), // Rule ID 60925 //
     /*  479722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  479733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  479736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  479739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479769 */     // MIs[1] Operand 1
     /*  479769 */     // No operand predicates
     /*  479769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479778 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  479781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479801 */     GIR_RootConstrainSelectedInstOperands,
     /*  479802 */     // GIR_Coverage, 60925,
     /*  479802 */     GIR_EraseRootFromParent_Done,
     /*  479803 */   // Label 8083: @479803
     /*  479803 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(479889), // Rule ID 60932 //
     /*  479808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  479825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  479828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  479831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479851 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479855 */     // MIs[1] Operand 1
     /*  479855 */     // No operand predicates
     /*  479855 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  479864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  479867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479887 */     GIR_RootConstrainSelectedInstOperands,
     /*  479888 */     // GIR_Coverage, 60932,
     /*  479888 */     GIR_EraseRootFromParent_Done,
     /*  479889 */   // Label 8084: @479889
     /*  479889 */   GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(479975), // Rule ID 60933 //
     /*  479894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  479897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  479905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  479908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  479911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  479914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  479917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  479925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  479929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  479933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  479937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  479941 */     // MIs[1] Operand 1
     /*  479941 */     // No operand predicates
     /*  479941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  479943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  479950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  479950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  479953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  479955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  479957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  479959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  479962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  479967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  479970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  479973 */     GIR_RootConstrainSelectedInstOperands,
     /*  479974 */     // GIR_Coverage, 60933,
     /*  479974 */     GIR_EraseRootFromParent_Done,
     /*  479975 */   // Label 8085: @479975
     /*  479975 */   GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(480061), // Rule ID 60940 //
     /*  479980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  479983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  479988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  479991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  479994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  479997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480027 */     // MIs[1] Operand 1
     /*  480027 */     // No operand predicates
     /*  480027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480036 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480059 */     GIR_RootConstrainSelectedInstOperands,
     /*  480060 */     // GIR_Coverage, 60940,
     /*  480060 */     GIR_EraseRootFromParent_Done,
     /*  480061 */   // Label 8086: @480061
     /*  480061 */   GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(480147), // Rule ID 60941 //
     /*  480066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  480077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  480080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  480083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480113 */     // MIs[1] Operand 1
     /*  480113 */     // No operand predicates
     /*  480113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480122 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480145 */     GIR_RootConstrainSelectedInstOperands,
     /*  480146 */     // GIR_Coverage, 60941,
     /*  480146 */     GIR_EraseRootFromParent_Done,
     /*  480147 */   // Label 8087: @480147
     /*  480147 */   GIM_Try, /*On fail goto*//*Label 8088*/ GIMT_Encode4(480233), // Rule ID 60948 //
     /*  480152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480195 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480199 */     // MIs[1] Operand 1
     /*  480199 */     // No operand predicates
     /*  480199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480208 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  480208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480231 */     GIR_RootConstrainSelectedInstOperands,
     /*  480232 */     // GIR_Coverage, 60948,
     /*  480232 */     GIR_EraseRootFromParent_Done,
     /*  480233 */   // Label 8088: @480233
     /*  480233 */   GIM_Try, /*On fail goto*//*Label 8089*/ GIMT_Encode4(480319), // Rule ID 60949 //
     /*  480238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  480249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  480252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  480255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  480269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480281 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480285 */     // MIs[1] Operand 1
     /*  480285 */     // No operand predicates
     /*  480285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  480294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  480297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  480314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480317 */     GIR_RootConstrainSelectedInstOperands,
     /*  480318 */     // GIR_Coverage, 60949,
     /*  480318 */     GIR_EraseRootFromParent_Done,
     /*  480319 */   // Label 8089: @480319
     /*  480319 */   GIM_Try, /*On fail goto*//*Label 8090*/ GIMT_Encode4(480405), // Rule ID 60956 //
     /*  480324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480371 */     // MIs[1] Operand 1
     /*  480371 */     // No operand predicates
     /*  480371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480403 */     GIR_RootConstrainSelectedInstOperands,
     /*  480404 */     // GIR_Coverage, 60956,
     /*  480404 */     GIR_EraseRootFromParent_Done,
     /*  480405 */   // Label 8090: @480405
     /*  480405 */   GIM_Try, /*On fail goto*//*Label 8091*/ GIMT_Encode4(480491), // Rule ID 60957 //
     /*  480410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  480421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  480424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  480427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480457 */     // MIs[1] Operand 1
     /*  480457 */     // No operand predicates
     /*  480457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480466 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4),
     /*  480469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480489 */     GIR_RootConstrainSelectedInstOperands,
     /*  480490 */     // GIR_Coverage, 60957,
     /*  480490 */     GIR_EraseRootFromParent_Done,
     /*  480491 */   // Label 8091: @480491
     /*  480491 */   GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(480577), // Rule ID 60964 //
     /*  480496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  480507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  480510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  480513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480543 */     // MIs[1] Operand 1
     /*  480543 */     // No operand predicates
     /*  480543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480561 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480575 */     GIR_RootConstrainSelectedInstOperands,
     /*  480576 */     // GIR_Coverage, 60964,
     /*  480576 */     GIR_EraseRootFromParent_Done,
     /*  480577 */   // Label 8092: @480577
     /*  480577 */   GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(480663), // Rule ID 60965 //
     /*  480582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  480593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  480596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  480599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480625 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480629 */     // MIs[1] Operand 1
     /*  480629 */     // No operand predicates
     /*  480629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  480641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480661 */     GIR_RootConstrainSelectedInstOperands,
     /*  480662 */     // GIR_Coverage, 60965,
     /*  480662 */     GIR_EraseRootFromParent_Done,
     /*  480663 */   // Label 8093: @480663
     /*  480663 */   GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(480749), // Rule ID 60972 //
     /*  480668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  480685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480715 */     // MIs[1] Operand 1
     /*  480715 */     // No operand predicates
     /*  480715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480747 */     GIR_RootConstrainSelectedInstOperands,
     /*  480748 */     // GIR_Coverage, 60972,
     /*  480748 */     GIR_EraseRootFromParent_Done,
     /*  480749 */   // Label 8094: @480749
     /*  480749 */   GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(480835), // Rule ID 60973 //
     /*  480754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  480765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  480768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  480771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  480789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480801 */     // MIs[1] Operand 1
     /*  480801 */     // No operand predicates
     /*  480801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  480813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480833 */     GIR_RootConstrainSelectedInstOperands,
     /*  480834 */     // GIR_Coverage, 60973,
     /*  480834 */     GIR_EraseRootFromParent_Done,
     /*  480835 */   // Label 8095: @480835
     /*  480835 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(480921), // Rule ID 60980 //
     /*  480840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  480843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  480857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  480860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  480863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480887 */     // MIs[1] Operand 1
     /*  480887 */     // No operand predicates
     /*  480887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  480896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  480916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  480919 */     GIR_RootConstrainSelectedInstOperands,
     /*  480920 */     // GIR_Coverage, 60980,
     /*  480920 */     GIR_EraseRootFromParent_Done,
     /*  480921 */   // Label 8096: @480921
     /*  480921 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(481007), // Rule ID 60981 //
     /*  480926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  480929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  480934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  480937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  480940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  480943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  480946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  480949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  480957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  480961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  480965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  480969 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  480973 */     // MIs[1] Operand 1
     /*  480973 */     // No operand predicates
     /*  480973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  480975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  480982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  480982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  480985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  480987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  480989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  480991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  480994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  480999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481005 */     GIR_RootConstrainSelectedInstOperands,
     /*  481006 */     // GIR_Coverage, 60981,
     /*  481006 */     GIR_EraseRootFromParent_Done,
     /*  481007 */   // Label 8097: @481007
     /*  481007 */   GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(481093), // Rule ID 60988 //
     /*  481012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481059 */     // MIs[1] Operand 1
     /*  481059 */     // No operand predicates
     /*  481059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  481068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481091 */     GIR_RootConstrainSelectedInstOperands,
     /*  481092 */     // GIR_Coverage, 60988,
     /*  481092 */     GIR_EraseRootFromParent_Done,
     /*  481093 */   // Label 8098: @481093
     /*  481093 */   GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(481179), // Rule ID 60989 //
     /*  481098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  481109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  481112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  481115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481145 */     // MIs[1] Operand 1
     /*  481145 */     // No operand predicates
     /*  481145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  481154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  481174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481177 */     GIR_RootConstrainSelectedInstOperands,
     /*  481178 */     // GIR_Coverage, 60989,
     /*  481178 */     GIR_EraseRootFromParent_Done,
     /*  481179 */   // Label 8099: @481179
     /*  481179 */   GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(481265), // Rule ID 60996 //
     /*  481184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481231 */     // MIs[1] Operand 1
     /*  481231 */     // No operand predicates
     /*  481231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481240 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481263 */     GIR_RootConstrainSelectedInstOperands,
     /*  481264 */     // GIR_Coverage, 60996,
     /*  481264 */     GIR_EraseRootFromParent_Done,
     /*  481265 */   // Label 8100: @481265
     /*  481265 */   GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(481351), // Rule ID 60997 //
     /*  481270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  481281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  481284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  481287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481317 */     // MIs[1] Operand 1
     /*  481317 */     // No operand predicates
     /*  481317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2),
     /*  481329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481349 */     GIR_RootConstrainSelectedInstOperands,
     /*  481350 */     // GIR_Coverage, 60997,
     /*  481350 */     GIR_EraseRootFromParent_Done,
     /*  481351 */   // Label 8101: @481351
     /*  481351 */   GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(481437), // Rule ID 61004 //
     /*  481356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481403 */     // MIs[1] Operand 1
     /*  481403 */     // No operand predicates
     /*  481403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481412 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481435 */     GIR_RootConstrainSelectedInstOperands,
     /*  481436 */     // GIR_Coverage, 61004,
     /*  481436 */     GIR_EraseRootFromParent_Done,
     /*  481437 */   // Label 8102: @481437
     /*  481437 */   GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(481523), // Rule ID 61005 //
     /*  481442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  481453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  481456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  481459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481489 */     // MIs[1] Operand 1
     /*  481489 */     // No operand predicates
     /*  481489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481498 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1),
     /*  481501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481521 */     GIR_RootConstrainSelectedInstOperands,
     /*  481522 */     // GIR_Coverage, 61005,
     /*  481522 */     GIR_EraseRootFromParent_Done,
     /*  481523 */   // Label 8103: @481523
     /*  481523 */   GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(481609), // Rule ID 61012 //
     /*  481528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  481539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  481542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481575 */     // MIs[1] Operand 1
     /*  481575 */     // No operand predicates
     /*  481575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481584 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481607 */     GIR_RootConstrainSelectedInstOperands,
     /*  481608 */     // GIR_Coverage, 61012,
     /*  481608 */     GIR_EraseRootFromParent_Done,
     /*  481609 */   // Label 8104: @481609
     /*  481609 */   GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(481695), // Rule ID 61013 //
     /*  481614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  481625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  481628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  481631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  481649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481661 */     // MIs[1] Operand 1
     /*  481661 */     // No operand predicates
     /*  481661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481670 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2),
     /*  481673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481693 */     GIR_RootConstrainSelectedInstOperands,
     /*  481694 */     // GIR_Coverage, 61013,
     /*  481694 */     GIR_EraseRootFromParent_Done,
     /*  481695 */   // Label 8105: @481695
     /*  481695 */   GIM_Try, /*On fail goto*//*Label 8106*/ GIMT_Encode4(481781), // Rule ID 61020 //
     /*  481700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  481703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  481711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  481714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481747 */     // MIs[1] Operand 1
     /*  481747 */     // No operand predicates
     /*  481747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481756 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  481756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481779 */     GIR_RootConstrainSelectedInstOperands,
     /*  481780 */     // GIR_Coverage, 61020,
     /*  481780 */     GIR_EraseRootFromParent_Done,
     /*  481781 */   // Label 8106: @481781
     /*  481781 */   GIM_Try, /*On fail goto*//*Label 8107*/ GIMT_Encode4(481867), // Rule ID 61021 //
     /*  481786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  481789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  481794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  481797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  481800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  481803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  481817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  481821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  481833 */     // MIs[1] Operand 1
     /*  481833 */     // No operand predicates
     /*  481833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481842 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VI_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  481842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4),
     /*  481845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  481862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481865 */     GIR_RootConstrainSelectedInstOperands,
     /*  481866 */     // GIR_Coverage, 61021,
     /*  481866 */     GIR_EraseRootFromParent_Done,
     /*  481867 */   // Label 8107: @481867
     /*  481867 */   GIM_Try, /*On fail goto*//*Label 8108*/ GIMT_Encode4(481953), // Rule ID 61876 //
     /*  481872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  481875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  481880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  481883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  481886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  481889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  481892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  481895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  481915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  481919 */     // MIs[1] Operand 1
     /*  481919 */     // No operand predicates
     /*  481919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  481921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  481928 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  481928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  481931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  481933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  481935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  481937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  481940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  481945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  481948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  481951 */     GIR_RootConstrainSelectedInstOperands,
     /*  481952 */     // GIR_Coverage, 61876,
     /*  481952 */     GIR_EraseRootFromParent_Done,
     /*  481953 */   // Label 8108: @481953
     /*  481953 */   GIM_Try, /*On fail goto*//*Label 8109*/ GIMT_Encode4(482039), // Rule ID 61877 //
     /*  481958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  481961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  481966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  481969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  481972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  481975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  481978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  481981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  481993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  481997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482005 */     // MIs[1] Operand 1
     /*  482005 */     // No operand predicates
     /*  482005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482014 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8),
     /*  482017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482037 */     GIR_RootConstrainSelectedInstOperands,
     /*  482038 */     // GIR_Coverage, 61877,
     /*  482038 */     GIR_EraseRootFromParent_Done,
     /*  482039 */   // Label 8109: @482039
     /*  482039 */   GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(482125), // Rule ID 61880 //
     /*  482044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482091 */     // MIs[1] Operand 1
     /*  482091 */     // No operand predicates
     /*  482091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482100 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482123 */     GIR_RootConstrainSelectedInstOperands,
     /*  482124 */     // GIR_Coverage, 61880,
     /*  482124 */     GIR_EraseRootFromParent_Done,
     /*  482125 */   // Label 8110: @482125
     /*  482125 */   GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(482211), // Rule ID 61881 //
     /*  482130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  482141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  482144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  482147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482177 */     // MIs[1] Operand 1
     /*  482177 */     // No operand predicates
     /*  482177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482209 */     GIR_RootConstrainSelectedInstOperands,
     /*  482210 */     // GIR_Coverage, 61881,
     /*  482210 */     GIR_EraseRootFromParent_Done,
     /*  482211 */   // Label 8111: @482211
     /*  482211 */   GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(482297), // Rule ID 61884 //
     /*  482216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482263 */     // MIs[1] Operand 1
     /*  482263 */     // No operand predicates
     /*  482263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482272 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482295 */     GIR_RootConstrainSelectedInstOperands,
     /*  482296 */     // GIR_Coverage, 61884,
     /*  482296 */     GIR_EraseRootFromParent_Done,
     /*  482297 */   // Label 8112: @482297
     /*  482297 */   GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(482383), // Rule ID 61885 //
     /*  482302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  482313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  482316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  482319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482349 */     // MIs[1] Operand 1
     /*  482349 */     // No operand predicates
     /*  482349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482358 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  482358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482381 */     GIR_RootConstrainSelectedInstOperands,
     /*  482382 */     // GIR_Coverage, 61885,
     /*  482382 */     GIR_EraseRootFromParent_Done,
     /*  482383 */   // Label 8113: @482383
     /*  482383 */   GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(482469), // Rule ID 61888 //
     /*  482388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482435 */     // MIs[1] Operand 1
     /*  482435 */     // No operand predicates
     /*  482435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482467 */     GIR_RootConstrainSelectedInstOperands,
     /*  482468 */     // GIR_Coverage, 61888,
     /*  482468 */     GIR_EraseRootFromParent_Done,
     /*  482469 */   // Label 8114: @482469
     /*  482469 */   GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(482555), // Rule ID 61889 //
     /*  482474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  482485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  482488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  482491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482521 */     // MIs[1] Operand 1
     /*  482521 */     // No operand predicates
     /*  482521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482530 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4),
     /*  482533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482553 */     GIR_RootConstrainSelectedInstOperands,
     /*  482554 */     // GIR_Coverage, 61889,
     /*  482554 */     GIR_EraseRootFromParent_Done,
     /*  482555 */   // Label 8115: @482555
     /*  482555 */   GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(482641), // Rule ID 61892 //
     /*  482560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482607 */     // MIs[1] Operand 1
     /*  482607 */     // No operand predicates
     /*  482607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  482616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482639 */     GIR_RootConstrainSelectedInstOperands,
     /*  482640 */     // GIR_Coverage, 61892,
     /*  482640 */     GIR_EraseRootFromParent_Done,
     /*  482641 */   // Label 8116: @482641
     /*  482641 */   GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(482727), // Rule ID 61893 //
     /*  482646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  482657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  482660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  482663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482693 */     // MIs[1] Operand 1
     /*  482693 */     // No operand predicates
     /*  482693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482702 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  482702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  482722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482725 */     GIR_RootConstrainSelectedInstOperands,
     /*  482726 */     // GIR_Coverage, 61893,
     /*  482726 */     GIR_EraseRootFromParent_Done,
     /*  482727 */   // Label 8117: @482727
     /*  482727 */   GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(482813), // Rule ID 61896 //
     /*  482732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  482743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  482746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482779 */     // MIs[1] Operand 1
     /*  482779 */     // No operand predicates
     /*  482779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482788 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  482788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482811 */     GIR_RootConstrainSelectedInstOperands,
     /*  482812 */     // GIR_Coverage, 61896,
     /*  482812 */     GIR_EraseRootFromParent_Done,
     /*  482813 */   // Label 8118: @482813
     /*  482813 */   GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(482899), // Rule ID 61897 //
     /*  482818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  482829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  482832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  482835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  482838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  482841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482865 */     // MIs[1] Operand 1
     /*  482865 */     // No operand predicates
     /*  482865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482874 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  482874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2),
     /*  482877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  482894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482897 */     GIR_RootConstrainSelectedInstOperands,
     /*  482898 */     // GIR_Coverage, 61897,
     /*  482898 */     GIR_EraseRootFromParent_Done,
     /*  482899 */   // Label 8119: @482899
     /*  482899 */   GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(482985), // Rule ID 61900 //
     /*  482904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  482907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  482915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  482918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  482921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  482924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  482927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  482939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  482943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  482947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  482951 */     // MIs[1] Operand 1
     /*  482951 */     // No operand predicates
     /*  482951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  482953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  482960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  482960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  482963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  482965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  482967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  482969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  482972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  482977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  482980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  482983 */     GIR_RootConstrainSelectedInstOperands,
     /*  482984 */     // GIR_Coverage, 61900,
     /*  482984 */     GIR_EraseRootFromParent_Done,
     /*  482985 */   // Label 8120: @482985
     /*  482985 */   GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(483071), // Rule ID 61901 //
     /*  482990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  482993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  482998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  483001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  483004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  483007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483037 */     // MIs[1] Operand 1
     /*  483037 */     // No operand predicates
     /*  483037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483046 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483069 */     GIR_RootConstrainSelectedInstOperands,
     /*  483070 */     // GIR_Coverage, 61901,
     /*  483070 */     GIR_EraseRootFromParent_Done,
     /*  483071 */   // Label 8121: @483071
     /*  483071 */   GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(483157), // Rule ID 61904 //
     /*  483076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483123 */     // MIs[1] Operand 1
     /*  483123 */     // No operand predicates
     /*  483123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  483132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483155 */     GIR_RootConstrainSelectedInstOperands,
     /*  483156 */     // GIR_Coverage, 61904,
     /*  483156 */     GIR_EraseRootFromParent_Done,
     /*  483157 */   // Label 8122: @483157
     /*  483157 */   GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(483243), // Rule ID 61905 //
     /*  483162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  483173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  483176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  483179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483209 */     // MIs[1] Operand 1
     /*  483209 */     // No operand predicates
     /*  483209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483218 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  483218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  483238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483241 */     GIR_RootConstrainSelectedInstOperands,
     /*  483242 */     // GIR_Coverage, 61905,
     /*  483242 */     GIR_EraseRootFromParent_Done,
     /*  483243 */   // Label 8123: @483243
     /*  483243 */   GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(483329), // Rule ID 61908 //
     /*  483248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483295 */     // MIs[1] Operand 1
     /*  483295 */     // No operand predicates
     /*  483295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  483304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483327 */     GIR_RootConstrainSelectedInstOperands,
     /*  483328 */     // GIR_Coverage, 61908,
     /*  483328 */     GIR_EraseRootFromParent_Done,
     /*  483329 */   // Label 8124: @483329
     /*  483329 */   GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(483415), // Rule ID 61909 //
     /*  483334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  483345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  483348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  483351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483381 */     // MIs[1] Operand 1
     /*  483381 */     // No operand predicates
     /*  483381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  483390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  483410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483413 */     GIR_RootConstrainSelectedInstOperands,
     /*  483414 */     // GIR_Coverage, 61909,
     /*  483414 */     GIR_EraseRootFromParent_Done,
     /*  483415 */   // Label 8125: @483415
     /*  483415 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(483501), // Rule ID 61912 //
     /*  483420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  483431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  483434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  483437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483467 */     // MIs[1] Operand 1
     /*  483467 */     // No operand predicates
     /*  483467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483476 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  483476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  483496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483499 */     GIR_RootConstrainSelectedInstOperands,
     /*  483500 */     // GIR_Coverage, 61912,
     /*  483500 */     GIR_EraseRootFromParent_Done,
     /*  483501 */   // Label 8126: @483501
     /*  483501 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(483587), // Rule ID 61913 //
     /*  483506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  483517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  483520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  483523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  483541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483553 */     // MIs[1] Operand 1
     /*  483553 */     // No operand predicates
     /*  483553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  483562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1),
     /*  483565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  483582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483585 */     GIR_RootConstrainSelectedInstOperands,
     /*  483586 */     // GIR_Coverage, 61913,
     /*  483586 */     GIR_EraseRootFromParent_Done,
     /*  483587 */   // Label 8127: @483587
     /*  483587 */   GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(483673), // Rule ID 61916 //
     /*  483592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  483603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  483606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  483609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483639 */     // MIs[1] Operand 1
     /*  483639 */     // No operand predicates
     /*  483639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483648 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  483651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483671 */     GIR_RootConstrainSelectedInstOperands,
     /*  483672 */     // GIR_Coverage, 61916,
     /*  483672 */     GIR_EraseRootFromParent_Done,
     /*  483673 */   // Label 8128: @483673
     /*  483673 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(483759), // Rule ID 61917 //
     /*  483678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  483689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  483692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  483695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  483713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483725 */     // MIs[1] Operand 1
     /*  483725 */     // No operand predicates
     /*  483725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483734 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  483737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483757 */     GIR_RootConstrainSelectedInstOperands,
     /*  483758 */     // GIR_Coverage, 61917,
     /*  483758 */     GIR_EraseRootFromParent_Done,
     /*  483759 */   // Label 8129: @483759
     /*  483759 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(483845), // Rule ID 61920 //
     /*  483764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  483775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  483778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  483781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483811 */     // MIs[1] Operand 1
     /*  483811 */     // No operand predicates
     /*  483811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483820 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  483823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483843 */     GIR_RootConstrainSelectedInstOperands,
     /*  483844 */     // GIR_Coverage, 61920,
     /*  483844 */     GIR_EraseRootFromParent_Done,
     /*  483845 */   // Label 8130: @483845
     /*  483845 */   GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(483931), // Rule ID 61921 //
     /*  483850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  483853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  483861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  483864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  483867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  483870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  483873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  483885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483897 */     // MIs[1] Operand 1
     /*  483897 */     // No operand predicates
     /*  483897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483906 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  483906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  483909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  483915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  483918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  483923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  483926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  483929 */     GIR_RootConstrainSelectedInstOperands,
     /*  483930 */     // GIR_Coverage, 61921,
     /*  483930 */     GIR_EraseRootFromParent_Done,
     /*  483931 */   // Label 8131: @483931
     /*  483931 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(484017), // Rule ID 61924 //
     /*  483936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  483939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  483944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  483947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  483950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  483953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  483956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  483959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  483971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  483975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  483979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  483983 */     // MIs[1] Operand 1
     /*  483983 */     // No operand predicates
     /*  483983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  483985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  483992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  483992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  483995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  483997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  483999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484015 */     GIR_RootConstrainSelectedInstOperands,
     /*  484016 */     // GIR_Coverage, 61924,
     /*  484016 */     GIR_EraseRootFromParent_Done,
     /*  484017 */   // Label 8132: @484017
     /*  484017 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(484103), // Rule ID 61925 //
     /*  484022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  484033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  484036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  484039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484069 */     // MIs[1] Operand 1
     /*  484069 */     // No operand predicates
     /*  484069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484078 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  484078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  484098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484101 */     GIR_RootConstrainSelectedInstOperands,
     /*  484102 */     // GIR_Coverage, 61925,
     /*  484102 */     GIR_EraseRootFromParent_Done,
     /*  484103 */   // Label 8133: @484103
     /*  484103 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(484189), // Rule ID 61928 //
     /*  484108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484155 */     // MIs[1] Operand 1
     /*  484155 */     // No operand predicates
     /*  484155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484187 */     GIR_RootConstrainSelectedInstOperands,
     /*  484188 */     // GIR_Coverage, 61928,
     /*  484188 */     GIR_EraseRootFromParent_Done,
     /*  484189 */   // Label 8134: @484189
     /*  484189 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(484275), // Rule ID 61929 //
     /*  484194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  484205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  484208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  484211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484237 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484241 */     // MIs[1] Operand 1
     /*  484241 */     // No operand predicates
     /*  484241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484273 */     GIR_RootConstrainSelectedInstOperands,
     /*  484274 */     // GIR_Coverage, 61929,
     /*  484274 */     GIR_EraseRootFromParent_Done,
     /*  484275 */   // Label 8135: @484275
     /*  484275 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(484361), // Rule ID 61932 //
     /*  484280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484327 */     // MIs[1] Operand 1
     /*  484327 */     // No operand predicates
     /*  484327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484359 */     GIR_RootConstrainSelectedInstOperands,
     /*  484360 */     // GIR_Coverage, 61932,
     /*  484360 */     GIR_EraseRootFromParent_Done,
     /*  484361 */   // Label 8136: @484361
     /*  484361 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(484447), // Rule ID 61933 //
     /*  484366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  484377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  484380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  484383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484413 */     // MIs[1] Operand 1
     /*  484413 */     // No operand predicates
     /*  484413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484445 */     GIR_RootConstrainSelectedInstOperands,
     /*  484446 */     // GIR_Coverage, 61933,
     /*  484446 */     GIR_EraseRootFromParent_Done,
     /*  484447 */   // Label 8137: @484447
     /*  484447 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(484533), // Rule ID 61936 //
     /*  484452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  484469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484499 */     // MIs[1] Operand 1
     /*  484499 */     // No operand predicates
     /*  484499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484508 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  484508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484531 */     GIR_RootConstrainSelectedInstOperands,
     /*  484532 */     // GIR_Coverage, 61936,
     /*  484532 */     GIR_EraseRootFromParent_Done,
     /*  484533 */   // Label 8138: @484533
     /*  484533 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(484619), // Rule ID 61937 //
     /*  484538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  484549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  484552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  484555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484585 */     // MIs[1] Operand 1
     /*  484585 */     // No operand predicates
     /*  484585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  484594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  484597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  484614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484617 */     GIR_RootConstrainSelectedInstOperands,
     /*  484618 */     // GIR_Coverage, 61937,
     /*  484618 */     GIR_EraseRootFromParent_Done,
     /*  484619 */   // Label 8139: @484619
     /*  484619 */   GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(484705), // Rule ID 61940 //
     /*  484624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  484635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  484638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  484641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484671 */     // MIs[1] Operand 1
     /*  484671 */     // No operand predicates
     /*  484671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  484680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484703 */     GIR_RootConstrainSelectedInstOperands,
     /*  484704 */     // GIR_Coverage, 61940,
     /*  484704 */     GIR_EraseRootFromParent_Done,
     /*  484705 */   // Label 8140: @484705
     /*  484705 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(484791), // Rule ID 61941 //
     /*  484710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  484721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  484724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  484727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  484745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484757 */     // MIs[1] Operand 1
     /*  484757 */     // No operand predicates
     /*  484757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  484766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  484769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484789 */     GIR_RootConstrainSelectedInstOperands,
     /*  484790 */     // GIR_Coverage, 61941,
     /*  484790 */     GIR_EraseRootFromParent_Done,
     /*  484791 */   // Label 8141: @484791
     /*  484791 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(484877), // Rule ID 61944 //
     /*  484796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  484807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  484810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  484813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484843 */     // MIs[1] Operand 1
     /*  484843 */     // No operand predicates
     /*  484843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484852 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  484852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484875 */     GIR_RootConstrainSelectedInstOperands,
     /*  484876 */     // GIR_Coverage, 61944,
     /*  484876 */     GIR_EraseRootFromParent_Done,
     /*  484877 */   // Label 8142: @484877
     /*  484877 */   GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(484963), // Rule ID 61945 //
     /*  484882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  484885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  484893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  484896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  484899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  484902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  484905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  484917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  484921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  484925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  484929 */     // MIs[1] Operand 1
     /*  484929 */     // No operand predicates
     /*  484929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  484931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  484938 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  484938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  484941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  484943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  484945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  484947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  484950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  484955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  484958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  484961 */     GIR_RootConstrainSelectedInstOperands,
     /*  484962 */     // GIR_Coverage, 61945,
     /*  484962 */     GIR_EraseRootFromParent_Done,
     /*  484963 */   // Label 8143: @484963
     /*  484963 */   GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(485049), // Rule ID 61948 //
     /*  484968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  484971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  484976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  484979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  484982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  484985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  484988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  484991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  484999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485015 */     // MIs[1] Operand 1
     /*  485015 */     // No operand predicates
     /*  485015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485024 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  485024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485047 */     GIR_RootConstrainSelectedInstOperands,
     /*  485048 */     // GIR_Coverage, 61948,
     /*  485048 */     GIR_EraseRootFromParent_Done,
     /*  485049 */   // Label 8144: @485049
     /*  485049 */   GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(485135), // Rule ID 61949 //
     /*  485054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  485065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  485068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  485071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485101 */     // MIs[1] Operand 1
     /*  485101 */     // No operand predicates
     /*  485101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485110 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  485110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  485130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485133 */     GIR_RootConstrainSelectedInstOperands,
     /*  485134 */     // GIR_Coverage, 61949,
     /*  485134 */     GIR_EraseRootFromParent_Done,
     /*  485135 */   // Label 8145: @485135
     /*  485135 */   GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(485221), // Rule ID 61952 //
     /*  485140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485187 */     // MIs[1] Operand 1
     /*  485187 */     // No operand predicates
     /*  485187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485196 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485219 */     GIR_RootConstrainSelectedInstOperands,
     /*  485220 */     // GIR_Coverage, 61952,
     /*  485220 */     GIR_EraseRootFromParent_Done,
     /*  485221 */   // Label 8146: @485221
     /*  485221 */   GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(485307), // Rule ID 61953 //
     /*  485226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  485237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  485240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  485243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  485261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485273 */     // MIs[1] Operand 1
     /*  485273 */     // No operand predicates
     /*  485273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485282 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2),
     /*  485285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485305 */     GIR_RootConstrainSelectedInstOperands,
     /*  485306 */     // GIR_Coverage, 61953,
     /*  485306 */     GIR_EraseRootFromParent_Done,
     /*  485307 */   // Label 8147: @485307
     /*  485307 */   GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(485393), // Rule ID 61956 //
     /*  485312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485359 */     // MIs[1] Operand 1
     /*  485359 */     // No operand predicates
     /*  485359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485368 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485391 */     GIR_RootConstrainSelectedInstOperands,
     /*  485392 */     // GIR_Coverage, 61956,
     /*  485392 */     GIR_EraseRootFromParent_Done,
     /*  485393 */   // Label 8148: @485393
     /*  485393 */   GIM_Try, /*On fail goto*//*Label 8149*/ GIMT_Encode4(485479), // Rule ID 61957 //
     /*  485398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  485409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  485412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  485415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  485433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485445 */     // MIs[1] Operand 1
     /*  485445 */     // No operand predicates
     /*  485445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4),
     /*  485457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485477 */     GIR_RootConstrainSelectedInstOperands,
     /*  485478 */     // GIR_Coverage, 61957,
     /*  485478 */     GIR_EraseRootFromParent_Done,
     /*  485479 */   // Label 8149: @485479
     /*  485479 */   GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(485565), // Rule ID 61960 //
     /*  485484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  485487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  485495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  485498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  485501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  485504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485531 */     // MIs[1] Operand 1
     /*  485531 */     // No operand predicates
     /*  485531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485540 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  485540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485563 */     GIR_RootConstrainSelectedInstOperands,
     /*  485564 */     // GIR_Coverage, 61960,
     /*  485564 */     GIR_EraseRootFromParent_Done,
     /*  485565 */   // Label 8150: @485565
     /*  485565 */   GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(485651), // Rule ID 61961 //
     /*  485570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  485573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  485578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  485581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  485584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  485587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  485590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  485605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  485609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  485613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /*  485617 */     // MIs[1] Operand 1
     /*  485617 */     // No operand predicates
     /*  485617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485626 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  485626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8),
     /*  485629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  485633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  485638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  485646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  485649 */     GIR_RootConstrainSelectedInstOperands,
     /*  485650 */     // GIR_Coverage, 61961,
     /*  485650 */     GIR_EraseRootFromParent_Done,
     /*  485651 */   // Label 8151: @485651
     /*  485651 */   GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(485730), // Rule ID 2642 //
     /*  485656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  485659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  485664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  485667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  485670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  485673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  485676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  485687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  485691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  485708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  485711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  485728 */     GIR_RootConstrainSelectedInstOperands,
     /*  485729 */     // GIR_Coverage, 2642,
     /*  485729 */     GIR_EraseRootFromParent_Done,
     /*  485730 */   // Label 8152: @485730
     /*  485730 */   GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(485809), // Rule ID 2643 //
     /*  485735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  485738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  485743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  485746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  485749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  485752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  485755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  485766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  485770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485787 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  485787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  485790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  485807 */     GIR_RootConstrainSelectedInstOperands,
     /*  485808 */     // GIR_Coverage, 2643,
     /*  485808 */     GIR_EraseRootFromParent_Done,
     /*  485809 */   // Label 8153: @485809
     /*  485809 */   GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(485888), // Rule ID 3950 //
     /*  485814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  485817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  485822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  485825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  485828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  485831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  485834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  485845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  485849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  485866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  485869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  485886 */     GIR_RootConstrainSelectedInstOperands,
     /*  485887 */     // GIR_Coverage, 3950,
     /*  485887 */     GIR_EraseRootFromParent_Done,
     /*  485888 */   // Label 8154: @485888
     /*  485888 */   GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(485967), // Rule ID 3951 //
     /*  485893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  485896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  485901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  485904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  485907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  485910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  485913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  485916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  485924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  485928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  485938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  485945 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  485945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  485948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  485950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  485952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  485954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  485959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  485962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  485965 */     GIR_RootConstrainSelectedInstOperands,
     /*  485966 */     // GIR_Coverage, 3951,
     /*  485966 */     GIR_EraseRootFromParent_Done,
     /*  485967 */   // Label 8155: @485967
     /*  485967 */   GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(486046), // Rule ID 3960 //
     /*  485972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  485975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  485980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  485983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  485986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  485989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  485992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  485995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  485999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486044 */     GIR_RootConstrainSelectedInstOperands,
     /*  486045 */     // GIR_Coverage, 3960,
     /*  486045 */     GIR_EraseRootFromParent_Done,
     /*  486046 */   // Label 8156: @486046
     /*  486046 */   GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(486125), // Rule ID 3961 //
     /*  486051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  486062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  486065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  486068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  486071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486103 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486123 */     GIR_RootConstrainSelectedInstOperands,
     /*  486124 */     // GIR_Coverage, 3961,
     /*  486124 */     GIR_EraseRootFromParent_Done,
     /*  486125 */   // Label 8157: @486125
     /*  486125 */   GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(486204), // Rule ID 3970 //
     /*  486130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486182 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486202 */     GIR_RootConstrainSelectedInstOperands,
     /*  486203 */     // GIR_Coverage, 3970,
     /*  486203 */     GIR_EraseRootFromParent_Done,
     /*  486204 */   // Label 8158: @486204
     /*  486204 */   GIM_Try, /*On fail goto*//*Label 8159*/ GIMT_Encode4(486283), // Rule ID 3971 //
     /*  486209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  486220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  486223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  486226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  486229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486261 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486281 */     GIR_RootConstrainSelectedInstOperands,
     /*  486282 */     // GIR_Coverage, 3971,
     /*  486282 */     GIR_EraseRootFromParent_Done,
     /*  486283 */   // Label 8159: @486283
     /*  486283 */   GIM_Try, /*On fail goto*//*Label 8160*/ GIMT_Encode4(486362), // Rule ID 3980 //
     /*  486288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486340 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486360 */     GIR_RootConstrainSelectedInstOperands,
     /*  486361 */     // GIR_Coverage, 3980,
     /*  486361 */     GIR_EraseRootFromParent_Done,
     /*  486362 */   // Label 8160: @486362
     /*  486362 */   GIM_Try, /*On fail goto*//*Label 8161*/ GIMT_Encode4(486441), // Rule ID 3981 //
     /*  486367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  486378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  486381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  486384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  486387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  486422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486439 */     GIR_RootConstrainSelectedInstOperands,
     /*  486440 */     // GIR_Coverage, 3981,
     /*  486440 */     GIR_EraseRootFromParent_Done,
     /*  486441 */   // Label 8161: @486441
     /*  486441 */   GIM_Try, /*On fail goto*//*Label 8162*/ GIMT_Encode4(486520), // Rule ID 3990 //
     /*  486446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  486463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  486498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  486501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486518 */     GIR_RootConstrainSelectedInstOperands,
     /*  486519 */     // GIR_Coverage, 3990,
     /*  486519 */     GIR_EraseRootFromParent_Done,
     /*  486520 */   // Label 8162: @486520
     /*  486520 */   GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(486599), // Rule ID 3991 //
     /*  486525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  486536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  486539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  486542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  486545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  486564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  486568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486577 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  486577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  486580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  486594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486597 */     GIR_RootConstrainSelectedInstOperands,
     /*  486598 */     // GIR_Coverage, 3991,
     /*  486598 */     GIR_EraseRootFromParent_Done,
     /*  486599 */   // Label 8163: @486599
     /*  486599 */   GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(486678), // Rule ID 4000 //
     /*  486604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  486615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  486618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  486621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  486624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486656 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  486656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486676 */     GIR_RootConstrainSelectedInstOperands,
     /*  486677 */     // GIR_Coverage, 4000,
     /*  486677 */     GIR_EraseRootFromParent_Done,
     /*  486678 */   // Label 8164: @486678
     /*  486678 */   GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(486757), // Rule ID 4001 //
     /*  486683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  486694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  486697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  486700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  486703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486735 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  486735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  486738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486755 */     GIR_RootConstrainSelectedInstOperands,
     /*  486756 */     // GIR_Coverage, 4001,
     /*  486756 */     GIR_EraseRootFromParent_Done,
     /*  486757 */   // Label 8165: @486757
     /*  486757 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(486836), // Rule ID 4010 //
     /*  486762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  486773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  486776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  486779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  486782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  486814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486834 */     GIR_RootConstrainSelectedInstOperands,
     /*  486835 */     // GIR_Coverage, 4010,
     /*  486835 */     GIR_EraseRootFromParent_Done,
     /*  486836 */   // Label 8166: @486836
     /*  486836 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(486915), // Rule ID 4011 //
     /*  486841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  486844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  486852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  486855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  486858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  486861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  486864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486893 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  486893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  486896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486913 */     GIR_RootConstrainSelectedInstOperands,
     /*  486914 */     // GIR_Coverage, 4011,
     /*  486914 */     GIR_EraseRootFromParent_Done,
     /*  486915 */   // Label 8167: @486915
     /*  486915 */   GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(486994), // Rule ID 4020 //
     /*  486920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  486923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  486928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  486931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  486934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  486937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  486940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  486943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  486951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  486955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  486959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  486963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  486965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  486972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  486972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  486975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  486977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  486979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  486981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  486986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  486989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  486992 */     GIR_RootConstrainSelectedInstOperands,
     /*  486993 */     // GIR_Coverage, 4020,
     /*  486993 */     GIR_EraseRootFromParent_Done,
     /*  486994 */   // Label 8168: @486994
     /*  486994 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(487073), // Rule ID 4021 //
     /*  486999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  487010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  487013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  487016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  487019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487071 */     GIR_RootConstrainSelectedInstOperands,
     /*  487072 */     // GIR_Coverage, 4021,
     /*  487072 */     GIR_EraseRootFromParent_Done,
     /*  487073 */   // Label 8169: @487073
     /*  487073 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(487152), // Rule ID 4030 //
     /*  487078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487130 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487150 */     GIR_RootConstrainSelectedInstOperands,
     /*  487151 */     // GIR_Coverage, 4030,
     /*  487151 */     GIR_EraseRootFromParent_Done,
     /*  487152 */   // Label 8170: @487152
     /*  487152 */   GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(487231), // Rule ID 4031 //
     /*  487157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  487168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  487171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  487174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  487177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487209 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487229 */     GIR_RootConstrainSelectedInstOperands,
     /*  487230 */     // GIR_Coverage, 4031,
     /*  487230 */     GIR_EraseRootFromParent_Done,
     /*  487231 */   // Label 8171: @487231
     /*  487231 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(487310), // Rule ID 4040 //
     /*  487236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  487239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487288 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  487288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487308 */     GIR_RootConstrainSelectedInstOperands,
     /*  487309 */     // GIR_Coverage, 4040,
     /*  487309 */     GIR_EraseRootFromParent_Done,
     /*  487310 */   // Label 8172: @487310
     /*  487310 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(487389), // Rule ID 4041 //
     /*  487315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  487318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  487326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  487329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  487332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  487335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487367 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  487367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  487384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487387 */     GIR_RootConstrainSelectedInstOperands,
     /*  487388 */     // GIR_Coverage, 4041,
     /*  487388 */     GIR_EraseRootFromParent_Done,
     /*  487389 */   // Label 8173: @487389
     /*  487389 */   GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(487468), // Rule ID 4050 //
     /*  487394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487466 */     GIR_RootConstrainSelectedInstOperands,
     /*  487467 */     // GIR_Coverage, 4050,
     /*  487467 */     GIR_EraseRootFromParent_Done,
     /*  487468 */   // Label 8174: @487468
     /*  487468 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(487547), // Rule ID 4051 //
     /*  487473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  487484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  487487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  487490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  487493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  487525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  487528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487545 */     GIR_RootConstrainSelectedInstOperands,
     /*  487546 */     // GIR_Coverage, 4051,
     /*  487546 */     GIR_EraseRootFromParent_Done,
     /*  487547 */   // Label 8175: @487547
     /*  487547 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(487626), // Rule ID 4060 //
     /*  487552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  487563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  487566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  487569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  487572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487604 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487624 */     GIR_RootConstrainSelectedInstOperands,
     /*  487625 */     // GIR_Coverage, 4060,
     /*  487625 */     GIR_EraseRootFromParent_Done,
     /*  487626 */   // Label 8176: @487626
     /*  487626 */   GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(487705), // Rule ID 4061 //
     /*  487631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  487642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  487645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  487648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  487651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  487674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  487683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  487686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487703 */     GIR_RootConstrainSelectedInstOperands,
     /*  487704 */     // GIR_Coverage, 4061,
     /*  487704 */     GIR_EraseRootFromParent_Done,
     /*  487705 */   // Label 8177: @487705
     /*  487705 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(487784), // Rule ID 4070 //
     /*  487710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  487721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  487724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  487727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  487730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487762 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487782 */     GIR_RootConstrainSelectedInstOperands,
     /*  487783 */     // GIR_Coverage, 4070,
     /*  487783 */     GIR_EraseRootFromParent_Done,
     /*  487784 */   // Label 8178: @487784
     /*  487784 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(487863), // Rule ID 4071 //
     /*  487789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  487800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  487803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  487806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  487809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  487832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  487841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  487844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487861 */     GIR_RootConstrainSelectedInstOperands,
     /*  487862 */     // GIR_Coverage, 4071,
     /*  487862 */     GIR_EraseRootFromParent_Done,
     /*  487863 */   // Label 8179: @487863
     /*  487863 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(487942), // Rule ID 4080 //
     /*  487868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  487871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  487879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  487882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  487885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  487888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  487891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  487920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  487923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  487925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  487927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  487929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  487934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  487937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  487940 */     GIR_RootConstrainSelectedInstOperands,
     /*  487941 */     // GIR_Coverage, 4080,
     /*  487941 */     GIR_EraseRootFromParent_Done,
     /*  487942 */   // Label 8180: @487942
     /*  487942 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(488021), // Rule ID 4081 //
     /*  487947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  487950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  487955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  487958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  487961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  487964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  487967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  487970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  487978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  487982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  487986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  487990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  487992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  487999 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  487999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  488002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  488016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488019 */     GIR_RootConstrainSelectedInstOperands,
     /*  488020 */     // GIR_Coverage, 4081,
     /*  488020 */     GIR_EraseRootFromParent_Done,
     /*  488021 */   // Label 8181: @488021
     /*  488021 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(488100), // Rule ID 4150 //
     /*  488026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488078 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488098 */     GIR_RootConstrainSelectedInstOperands,
     /*  488099 */     // GIR_Coverage, 4150,
     /*  488099 */     GIR_EraseRootFromParent_Done,
     /*  488100 */   // Label 8182: @488100
     /*  488100 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(488179), // Rule ID 4151 //
     /*  488105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  488116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  488119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  488122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  488125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488157 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  488160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488177 */     GIR_RootConstrainSelectedInstOperands,
     /*  488178 */     // GIR_Coverage, 4151,
     /*  488178 */     GIR_EraseRootFromParent_Done,
     /*  488179 */   // Label 8183: @488179
     /*  488179 */   GIM_Try, /*On fail goto*//*Label 8184*/ GIMT_Encode4(488258), // Rule ID 4160 //
     /*  488184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488236 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488256 */     GIR_RootConstrainSelectedInstOperands,
     /*  488257 */     // GIR_Coverage, 4160,
     /*  488257 */     GIR_EraseRootFromParent_Done,
     /*  488258 */   // Label 8184: @488258
     /*  488258 */   GIM_Try, /*On fail goto*//*Label 8185*/ GIMT_Encode4(488337), // Rule ID 4161 //
     /*  488263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  488274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  488277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  488280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  488283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  488318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488335 */     GIR_RootConstrainSelectedInstOperands,
     /*  488336 */     // GIR_Coverage, 4161,
     /*  488336 */     GIR_EraseRootFromParent_Done,
     /*  488337 */   // Label 8185: @488337
     /*  488337 */   GIM_Try, /*On fail goto*//*Label 8186*/ GIMT_Encode4(488416), // Rule ID 4170 //
     /*  488342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488414 */     GIR_RootConstrainSelectedInstOperands,
     /*  488415 */     // GIR_Coverage, 4170,
     /*  488415 */     GIR_EraseRootFromParent_Done,
     /*  488416 */   // Label 8186: @488416
     /*  488416 */   GIM_Try, /*On fail goto*//*Label 8187*/ GIMT_Encode4(488495), // Rule ID 4171 //
     /*  488421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  488432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  488435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  488438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  488441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488473 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  488476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488493 */     GIR_RootConstrainSelectedInstOperands,
     /*  488494 */     // GIR_Coverage, 4171,
     /*  488494 */     GIR_EraseRootFromParent_Done,
     /*  488495 */   // Label 8187: @488495
     /*  488495 */   GIM_Try, /*On fail goto*//*Label 8188*/ GIMT_Encode4(488574), // Rule ID 4180 //
     /*  488500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  488520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488552 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  488555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488572 */     GIR_RootConstrainSelectedInstOperands,
     /*  488573 */     // GIR_Coverage, 4180,
     /*  488573 */     GIR_EraseRootFromParent_Done,
     /*  488574 */   // Label 8188: @488574
     /*  488574 */   GIM_Try, /*On fail goto*//*Label 8189*/ GIMT_Encode4(488653), // Rule ID 4181 //
     /*  488579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  488590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  488593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  488596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  488599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  488622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488631 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  488634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488651 */     GIR_RootConstrainSelectedInstOperands,
     /*  488652 */     // GIR_Coverage, 4181,
     /*  488652 */     GIR_EraseRootFromParent_Done,
     /*  488653 */   // Label 8189: @488653
     /*  488653 */   GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(488732), // Rule ID 4190 //
     /*  488658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  488678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  488713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488730 */     GIR_RootConstrainSelectedInstOperands,
     /*  488731 */     // GIR_Coverage, 4190,
     /*  488731 */     GIR_EraseRootFromParent_Done,
     /*  488732 */   // Label 8190: @488732
     /*  488732 */   GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(488811), // Rule ID 4191 //
     /*  488737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  488748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  488751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  488754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  488757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  488780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488789 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  488792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488809 */     GIR_RootConstrainSelectedInstOperands,
     /*  488810 */     // GIR_Coverage, 4191,
     /*  488810 */     GIR_EraseRootFromParent_Done,
     /*  488811 */   // Label 8191: @488811
     /*  488811 */   GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(488890), // Rule ID 4200 //
     /*  488816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  488836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488868 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  488868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  488871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488888 */     GIR_RootConstrainSelectedInstOperands,
     /*  488889 */     // GIR_Coverage, 4200,
     /*  488889 */     GIR_EraseRootFromParent_Done,
     /*  488890 */   // Label 8192: @488890
     /*  488890 */   GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(488969), // Rule ID 4201 //
     /*  488895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  488898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  488906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  488909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  488912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  488915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  488918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  488926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  488930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  488934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  488938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  488940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  488947 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  488947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  488950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  488952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  488954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  488956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  488961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  488964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  488967 */     GIR_RootConstrainSelectedInstOperands,
     /*  488968 */     // GIR_Coverage, 4201,
     /*  488968 */     GIR_EraseRootFromParent_Done,
     /*  488969 */   // Label 8193: @488969
     /*  488969 */   GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(489048), // Rule ID 4210 //
     /*  488974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  488977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  488982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  488985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  488988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  488991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  488994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  488997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489017 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489046 */     GIR_RootConstrainSelectedInstOperands,
     /*  489047 */     // GIR_Coverage, 4210,
     /*  489047 */     GIR_EraseRootFromParent_Done,
     /*  489048 */   // Label 8194: @489048
     /*  489048 */   GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(489127), // Rule ID 4211 //
     /*  489053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  489064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  489067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  489070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  489073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489105 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  489108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489125 */     GIR_RootConstrainSelectedInstOperands,
     /*  489126 */     // GIR_Coverage, 4211,
     /*  489126 */     GIR_EraseRootFromParent_Done,
     /*  489127 */   // Label 8195: @489127
     /*  489127 */   GIM_Try, /*On fail goto*//*Label 8196*/ GIMT_Encode4(489206), // Rule ID 4220 //
     /*  489132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489204 */     GIR_RootConstrainSelectedInstOperands,
     /*  489205 */     // GIR_Coverage, 4220,
     /*  489205 */     GIR_EraseRootFromParent_Done,
     /*  489206 */   // Label 8196: @489206
     /*  489206 */   GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(489285), // Rule ID 4221 //
     /*  489211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  489222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  489225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  489228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  489231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489263 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489283 */     GIR_RootConstrainSelectedInstOperands,
     /*  489284 */     // GIR_Coverage, 4221,
     /*  489284 */     GIR_EraseRootFromParent_Done,
     /*  489285 */   // Label 8197: @489285
     /*  489285 */   GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(489364), // Rule ID 4230 //
     /*  489290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489362 */     GIR_RootConstrainSelectedInstOperands,
     /*  489363 */     // GIR_Coverage, 4230,
     /*  489363 */     GIR_EraseRootFromParent_Done,
     /*  489364 */   // Label 8198: @489364
     /*  489364 */   GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(489443), // Rule ID 4231 //
     /*  489369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  489380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  489383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  489386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  489389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489412 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489421 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489441 */     GIR_RootConstrainSelectedInstOperands,
     /*  489442 */     // GIR_Coverage, 4231,
     /*  489442 */     GIR_EraseRootFromParent_Done,
     /*  489443 */   // Label 8199: @489443
     /*  489443 */   GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(489522), // Rule ID 4240 //
     /*  489448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  489468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489520 */     GIR_RootConstrainSelectedInstOperands,
     /*  489521 */     // GIR_Coverage, 4240,
     /*  489521 */     GIR_EraseRootFromParent_Done,
     /*  489522 */   // Label 8200: @489522
     /*  489522 */   GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(489601), // Rule ID 4241 //
     /*  489527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  489538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  489541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  489544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  489547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489579 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  489582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489599 */     GIR_RootConstrainSelectedInstOperands,
     /*  489600 */     // GIR_Coverage, 4241,
     /*  489600 */     GIR_EraseRootFromParent_Done,
     /*  489601 */   // Label 8201: @489601
     /*  489601 */   GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(489680), // Rule ID 4250 //
     /*  489606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  489609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  489626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489658 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  489658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489678 */     GIR_RootConstrainSelectedInstOperands,
     /*  489679 */     // GIR_Coverage, 4250,
     /*  489679 */     GIR_EraseRootFromParent_Done,
     /*  489680 */   // Label 8202: @489680
     /*  489680 */   GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(489759), // Rule ID 4251 //
     /*  489685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  489688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  489696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  489699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  489702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  489705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  489724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  489728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489737 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  489737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  489740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  489754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489757 */     GIR_RootConstrainSelectedInstOperands,
     /*  489758 */     // GIR_Coverage, 4251,
     /*  489758 */     GIR_EraseRootFromParent_Done,
     /*  489759 */   // Label 8203: @489759
     /*  489759 */   GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(489838), // Rule ID 4260 //
     /*  489764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  489767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  489775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  489778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  489781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  489784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  489816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489836 */     GIR_RootConstrainSelectedInstOperands,
     /*  489837 */     // GIR_Coverage, 4260,
     /*  489837 */     GIR_EraseRootFromParent_Done,
     /*  489838 */   // Label 8204: @489838
     /*  489838 */   GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(489917), // Rule ID 4261 //
     /*  489843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  489846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  489854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  489857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  489860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  489863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  489866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489895 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  489895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  489898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489915 */     GIR_RootConstrainSelectedInstOperands,
     /*  489916 */     // GIR_Coverage, 4261,
     /*  489916 */     GIR_EraseRootFromParent_Done,
     /*  489917 */   // Label 8205: @489917
     /*  489917 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(489996), // Rule ID 4270 //
     /*  489922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  489925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  489930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  489933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  489936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  489939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  489942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  489945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  489953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  489957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  489961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  489965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  489967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  489974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  489974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  489977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  489979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  489981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  489983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  489988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  489991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  489994 */     GIR_RootConstrainSelectedInstOperands,
     /*  489995 */     // GIR_Coverage, 4270,
     /*  489995 */     GIR_EraseRootFromParent_Done,
     /*  489996 */   // Label 8206: @489996
     /*  489996 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(490075), // Rule ID 4271 //
     /*  490001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  490012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  490015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  490018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  490021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490053 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  490056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490073 */     GIR_RootConstrainSelectedInstOperands,
     /*  490074 */     // GIR_Coverage, 4271,
     /*  490074 */     GIR_EraseRootFromParent_Done,
     /*  490075 */   // Label 8207: @490075
     /*  490075 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(490154), // Rule ID 4280 //
     /*  490080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490152 */     GIR_RootConstrainSelectedInstOperands,
     /*  490153 */     // GIR_Coverage, 4280,
     /*  490153 */     GIR_EraseRootFromParent_Done,
     /*  490154 */   // Label 8208: @490154
     /*  490154 */   GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(490233), // Rule ID 4281 //
     /*  490159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  490170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  490173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  490176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  490179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490211 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  490214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490231 */     GIR_RootConstrainSelectedInstOperands,
     /*  490232 */     // GIR_Coverage, 4281,
     /*  490232 */     GIR_EraseRootFromParent_Done,
     /*  490233 */   // Label 8209: @490233
     /*  490233 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(490312), // Rule ID 4290 //
     /*  490238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  490241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490290 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  490290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490310 */     GIR_RootConstrainSelectedInstOperands,
     /*  490311 */     // GIR_Coverage, 4290,
     /*  490311 */     GIR_EraseRootFromParent_Done,
     /*  490312 */   // Label 8210: @490312
     /*  490312 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(490391), // Rule ID 4291 //
     /*  490317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  490320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  490325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  490328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  490331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  490334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  490337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  490356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  490360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  490369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  490372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  490386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490389 */     GIR_RootConstrainSelectedInstOperands,
     /*  490390 */     // GIR_Coverage, 4291,
     /*  490390 */     GIR_EraseRootFromParent_Done,
     /*  490391 */   // Label 8211: @490391
     /*  490391 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(490470), // Rule ID 4360 //
     /*  490396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490448 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  490451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490468 */     GIR_RootConstrainSelectedInstOperands,
     /*  490469 */     // GIR_Coverage, 4360,
     /*  490469 */     GIR_EraseRootFromParent_Done,
     /*  490470 */   // Label 8212: @490470
     /*  490470 */   GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(490549), // Rule ID 4361 //
     /*  490475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  490486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  490489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  490492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  490495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490527 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  490530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490547 */     GIR_RootConstrainSelectedInstOperands,
     /*  490548 */     // GIR_Coverage, 4361,
     /*  490548 */     GIR_EraseRootFromParent_Done,
     /*  490549 */   // Label 8213: @490549
     /*  490549 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(490628), // Rule ID 4370 //
     /*  490554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  490609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490626 */     GIR_RootConstrainSelectedInstOperands,
     /*  490627 */     // GIR_Coverage, 4370,
     /*  490627 */     GIR_EraseRootFromParent_Done,
     /*  490628 */   // Label 8214: @490628
     /*  490628 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(490707), // Rule ID 4371 //
     /*  490633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  490644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  490647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  490650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  490653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490685 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  490688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490705 */     GIR_RootConstrainSelectedInstOperands,
     /*  490706 */     // GIR_Coverage, 4371,
     /*  490706 */     GIR_EraseRootFromParent_Done,
     /*  490707 */   // Label 8215: @490707
     /*  490707 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(490786), // Rule ID 4380 //
     /*  490712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  490767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490784 */     GIR_RootConstrainSelectedInstOperands,
     /*  490785 */     // GIR_Coverage, 4380,
     /*  490785 */     GIR_EraseRootFromParent_Done,
     /*  490786 */   // Label 8216: @490786
     /*  490786 */   GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(490865), // Rule ID 4381 //
     /*  490791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  490802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  490805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  490808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  490811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490843 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  490843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  490846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490863 */     GIR_RootConstrainSelectedInstOperands,
     /*  490864 */     // GIR_Coverage, 4381,
     /*  490864 */     GIR_EraseRootFromParent_Done,
     /*  490865 */   // Label 8217: @490865
     /*  490865 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(490944), // Rule ID 4390 //
     /*  490870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  490873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  490893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  490922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  490922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  490925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  490927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  490929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  490931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  490936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  490939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  490942 */     GIR_RootConstrainSelectedInstOperands,
     /*  490943 */     // GIR_Coverage, 4390,
     /*  490943 */     GIR_EraseRootFromParent_Done,
     /*  490944 */   // Label 8218: @490944
     /*  490944 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(491023), // Rule ID 4391 //
     /*  490949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  490952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  490957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  490960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  490963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  490966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  490969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  490972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  490980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  490984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  490988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  490992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  490994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491021 */     GIR_RootConstrainSelectedInstOperands,
     /*  491022 */     // GIR_Coverage, 4391,
     /*  491022 */     GIR_EraseRootFromParent_Done,
     /*  491023 */   // Label 8219: @491023
     /*  491023 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(491102), // Rule ID 4400 //
     /*  491028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491080 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491100 */     GIR_RootConstrainSelectedInstOperands,
     /*  491101 */     // GIR_Coverage, 4400,
     /*  491101 */     GIR_EraseRootFromParent_Done,
     /*  491102 */   // Label 8220: @491102
     /*  491102 */   GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(491181), // Rule ID 4401 //
     /*  491107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  491118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  491121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  491124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  491127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491179 */     GIR_RootConstrainSelectedInstOperands,
     /*  491180 */     // GIR_Coverage, 4401,
     /*  491180 */     GIR_EraseRootFromParent_Done,
     /*  491181 */   // Label 8221: @491181
     /*  491181 */   GIM_Try, /*On fail goto*//*Label 8222*/ GIMT_Encode4(491260), // Rule ID 4410 //
     /*  491186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491238 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  491238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491258 */     GIR_RootConstrainSelectedInstOperands,
     /*  491259 */     // GIR_Coverage, 4410,
     /*  491259 */     GIR_EraseRootFromParent_Done,
     /*  491260 */   // Label 8222: @491260
     /*  491260 */   GIM_Try, /*On fail goto*//*Label 8223*/ GIMT_Encode4(491339), // Rule ID 4411 //
     /*  491265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  491276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  491279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  491282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  491285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  491304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491317 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  491317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  491320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  491334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491337 */     GIR_RootConstrainSelectedInstOperands,
     /*  491338 */     // GIR_Coverage, 4411,
     /*  491338 */     GIR_EraseRootFromParent_Done,
     /*  491339 */   // Label 8223: @491339
     /*  491339 */   GIM_Try, /*On fail goto*//*Label 8224*/ GIMT_Encode4(491418), // Rule ID 4420 //
     /*  491344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491396 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491416 */     GIR_RootConstrainSelectedInstOperands,
     /*  491417 */     // GIR_Coverage, 4420,
     /*  491417 */     GIR_EraseRootFromParent_Done,
     /*  491418 */   // Label 8224: @491418
     /*  491418 */   GIM_Try, /*On fail goto*//*Label 8225*/ GIMT_Encode4(491497), // Rule ID 4421 //
     /*  491423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  491434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  491437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  491440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  491443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  491478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491495 */     GIR_RootConstrainSelectedInstOperands,
     /*  491496 */     // GIR_Coverage, 4421,
     /*  491496 */     GIR_EraseRootFromParent_Done,
     /*  491497 */   // Label 8225: @491497
     /*  491497 */   GIM_Try, /*On fail goto*//*Label 8226*/ GIMT_Encode4(491576), // Rule ID 4430 //
     /*  491502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491574 */     GIR_RootConstrainSelectedInstOperands,
     /*  491575 */     // GIR_Coverage, 4430,
     /*  491575 */     GIR_EraseRootFromParent_Done,
     /*  491576 */   // Label 8226: @491576
     /*  491576 */   GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(491655), // Rule ID 4431 //
     /*  491581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  491592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  491595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  491598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  491601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491633 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  491636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491653 */     GIR_RootConstrainSelectedInstOperands,
     /*  491654 */     // GIR_Coverage, 4431,
     /*  491654 */     GIR_EraseRootFromParent_Done,
     /*  491655 */   // Label 8227: @491655
     /*  491655 */   GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(491734), // Rule ID 4440 //
     /*  491660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491732 */     GIR_RootConstrainSelectedInstOperands,
     /*  491733 */     // GIR_Coverage, 4440,
     /*  491733 */     GIR_EraseRootFromParent_Done,
     /*  491734 */   // Label 8228: @491734
     /*  491734 */   GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(491813), // Rule ID 4441 //
     /*  491739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  491750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  491753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  491756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  491759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  491782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  491794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491811 */     GIR_RootConstrainSelectedInstOperands,
     /*  491812 */     // GIR_Coverage, 4441,
     /*  491812 */     GIR_EraseRootFromParent_Done,
     /*  491813 */   // Label 8229: @491813
     /*  491813 */   GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(491892), // Rule ID 4450 //
     /*  491818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  491870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491890 */     GIR_RootConstrainSelectedInstOperands,
     /*  491891 */     // GIR_Coverage, 4450,
     /*  491891 */     GIR_EraseRootFromParent_Done,
     /*  491892 */   // Label 8230: @491892
     /*  491892 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(491971), // Rule ID 4451 //
     /*  491897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  491900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  491908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  491911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  491914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  491917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  491920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  491928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  491932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  491936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  491940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  491942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  491949 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  491949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  491952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  491954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  491956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  491958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  491963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  491966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  491969 */     GIR_RootConstrainSelectedInstOperands,
     /*  491970 */     // GIR_Coverage, 4451,
     /*  491970 */     GIR_EraseRootFromParent_Done,
     /*  491971 */   // Label 8231: @491971
     /*  491971 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(492050), // Rule ID 4460 //
     /*  491976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  491979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  491984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  491987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  491990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  491993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  491996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  491999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492028 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  492028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492048 */     GIR_RootConstrainSelectedInstOperands,
     /*  492049 */     // GIR_Coverage, 4460,
     /*  492049 */     GIR_EraseRootFromParent_Done,
     /*  492050 */   // Label 8232: @492050
     /*  492050 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(492129), // Rule ID 4461 //
     /*  492055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  492066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  492069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  492072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  492075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492107 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  492107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  492124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492127 */     GIR_RootConstrainSelectedInstOperands,
     /*  492128 */     // GIR_Coverage, 4461,
     /*  492128 */     GIR_EraseRootFromParent_Done,
     /*  492129 */   // Label 8233: @492129
     /*  492129 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(492208), // Rule ID 4470 //
     /*  492134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492186 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492206 */     GIR_RootConstrainSelectedInstOperands,
     /*  492207 */     // GIR_Coverage, 4470,
     /*  492207 */     GIR_EraseRootFromParent_Done,
     /*  492208 */   // Label 8234: @492208
     /*  492208 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(492287), // Rule ID 4471 //
     /*  492213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  492224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  492227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  492230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  492233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492265 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  492268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492285 */     GIR_RootConstrainSelectedInstOperands,
     /*  492286 */     // GIR_Coverage, 4471,
     /*  492286 */     GIR_EraseRootFromParent_Done,
     /*  492287 */   // Label 8235: @492287
     /*  492287 */   GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(492366), // Rule ID 4480 //
     /*  492292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492344 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492364 */     GIR_RootConstrainSelectedInstOperands,
     /*  492365 */     // GIR_Coverage, 4480,
     /*  492365 */     GIR_EraseRootFromParent_Done,
     /*  492366 */   // Label 8236: @492366
     /*  492366 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(492445), // Rule ID 4481 //
     /*  492371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  492382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  492385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  492388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  492391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492423 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  492426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492443 */     GIR_RootConstrainSelectedInstOperands,
     /*  492444 */     // GIR_Coverage, 4481,
     /*  492444 */     GIR_EraseRootFromParent_Done,
     /*  492445 */   // Label 8237: @492445
     /*  492445 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(492524), // Rule ID 4490 //
     /*  492450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492502 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492522 */     GIR_RootConstrainSelectedInstOperands,
     /*  492523 */     // GIR_Coverage, 4490,
     /*  492523 */     GIR_EraseRootFromParent_Done,
     /*  492524 */   // Label 8238: @492524
     /*  492524 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(492603), // Rule ID 4491 //
     /*  492529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  492540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  492543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  492546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  492549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  492572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492581 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  492584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492601 */     GIR_RootConstrainSelectedInstOperands,
     /*  492602 */     // GIR_Coverage, 4491,
     /*  492602 */     GIR_EraseRootFromParent_Done,
     /*  492603 */   // Label 8239: @492603
     /*  492603 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(492682), // Rule ID 4500 //
     /*  492608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  492611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492660 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  492660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492680 */     GIR_RootConstrainSelectedInstOperands,
     /*  492681 */     // GIR_Coverage, 4500,
     /*  492681 */     GIR_EraseRootFromParent_Done,
     /*  492682 */   // Label 8240: @492682
     /*  492682 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(492761), // Rule ID 4501 //
     /*  492687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  492690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  492695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  492698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  492701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  492704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  492707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  492726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  492730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492739 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  492739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  492742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  492756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492759 */     GIR_RootConstrainSelectedInstOperands,
     /*  492760 */     // GIR_Coverage, 4501,
     /*  492760 */     GIR_EraseRootFromParent_Done,
     /*  492761 */   // Label 8241: @492761
     /*  492761 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(492840), // Rule ID 4570 //
     /*  492766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  492774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492818 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  492821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492838 */     GIR_RootConstrainSelectedInstOperands,
     /*  492839 */     // GIR_Coverage, 4570,
     /*  492839 */     GIR_EraseRootFromParent_Done,
     /*  492840 */   // Label 8242: @492840
     /*  492840 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(492919), // Rule ID 4571 //
     /*  492845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  492848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  492853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  492856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  492859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  492862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  492865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  492868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492897 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  492897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  492900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492917 */     GIR_RootConstrainSelectedInstOperands,
     /*  492918 */     // GIR_Coverage, 4571,
     /*  492918 */     GIR_EraseRootFromParent_Done,
     /*  492919 */   // Label 8243: @492919
     /*  492919 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(492998), // Rule ID 4580 //
     /*  492924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  492927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  492932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  492935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  492938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  492941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  492944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  492947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  492955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  492959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  492967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  492969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  492976 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  492976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  492979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  492981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  492983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  492985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  492990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  492993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  492996 */     GIR_RootConstrainSelectedInstOperands,
     /*  492997 */     // GIR_Coverage, 4580,
     /*  492997 */     GIR_EraseRootFromParent_Done,
     /*  492998 */   // Label 8244: @492998
     /*  492998 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(493077), // Rule ID 4581 //
     /*  493003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  493014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  493017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  493020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  493023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493055 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493075 */     GIR_RootConstrainSelectedInstOperands,
     /*  493076 */     // GIR_Coverage, 4581,
     /*  493076 */     GIR_EraseRootFromParent_Done,
     /*  493077 */   // Label 8245: @493077
     /*  493077 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(493156), // Rule ID 4590 //
     /*  493082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493154 */     GIR_RootConstrainSelectedInstOperands,
     /*  493155 */     // GIR_Coverage, 4590,
     /*  493155 */     GIR_EraseRootFromParent_Done,
     /*  493156 */   // Label 8246: @493156
     /*  493156 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(493235), // Rule ID 4591 //
     /*  493161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  493172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  493175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  493178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  493181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493213 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493233 */     GIR_RootConstrainSelectedInstOperands,
     /*  493234 */     // GIR_Coverage, 4591,
     /*  493234 */     GIR_EraseRootFromParent_Done,
     /*  493235 */   // Label 8247: @493235
     /*  493235 */   GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(493314), // Rule ID 4600 //
     /*  493240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493312 */     GIR_RootConstrainSelectedInstOperands,
     /*  493313 */     // GIR_Coverage, 4600,
     /*  493313 */     GIR_EraseRootFromParent_Done,
     /*  493314 */   // Label 8248: @493314
     /*  493314 */   GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(493393), // Rule ID 4601 //
     /*  493319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  493330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  493333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  493336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  493339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  493374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493391 */     GIR_RootConstrainSelectedInstOperands,
     /*  493392 */     // GIR_Coverage, 4601,
     /*  493392 */     GIR_EraseRootFromParent_Done,
     /*  493393 */   // Label 8249: @493393
     /*  493393 */   GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(493472), // Rule ID 4610 //
     /*  493398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  493453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493470 */     GIR_RootConstrainSelectedInstOperands,
     /*  493471 */     // GIR_Coverage, 4610,
     /*  493471 */     GIR_EraseRootFromParent_Done,
     /*  493472 */   // Label 8250: @493472
     /*  493472 */   GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(493551), // Rule ID 4611 //
     /*  493477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  493488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  493491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  493494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  493497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  493520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493529 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  493532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493549 */     GIR_RootConstrainSelectedInstOperands,
     /*  493550 */     // GIR_Coverage, 4611,
     /*  493550 */     GIR_EraseRootFromParent_Done,
     /*  493551 */   // Label 8251: @493551
     /*  493551 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(493630), // Rule ID 4620 //
     /*  493556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  493608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  493611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493628 */     GIR_RootConstrainSelectedInstOperands,
     /*  493629 */     // GIR_Coverage, 4620,
     /*  493629 */     GIR_EraseRootFromParent_Done,
     /*  493630 */   // Label 8252: @493630
     /*  493630 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(493709), // Rule ID 4621 //
     /*  493635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  493646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  493649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  493652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  493655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  493674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  493678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493687 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  493687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  493690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  493704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493707 */     GIR_RootConstrainSelectedInstOperands,
     /*  493708 */     // GIR_Coverage, 4621,
     /*  493708 */     GIR_EraseRootFromParent_Done,
     /*  493709 */   // Label 8253: @493709
     /*  493709 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(493788), // Rule ID 4630 //
     /*  493714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493786 */     GIR_RootConstrainSelectedInstOperands,
     /*  493787 */     // GIR_Coverage, 4630,
     /*  493787 */     GIR_EraseRootFromParent_Done,
     /*  493788 */   // Label 8254: @493788
     /*  493788 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(493867), // Rule ID 4631 //
     /*  493793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  493804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  493807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  493810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  493813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  493845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  493848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493865 */     GIR_RootConstrainSelectedInstOperands,
     /*  493866 */     // GIR_Coverage, 4631,
     /*  493866 */     GIR_EraseRootFromParent_Done,
     /*  493867 */   // Label 8255: @493867
     /*  493867 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(493946), // Rule ID 4640 //
     /*  493872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  493875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  493895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  493924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  493924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  493927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  493929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  493931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  493933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  493938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  493941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  493944 */     GIR_RootConstrainSelectedInstOperands,
     /*  493945 */     // GIR_Coverage, 4640,
     /*  493945 */     GIR_EraseRootFromParent_Done,
     /*  493946 */   // Label 8256: @493946
     /*  493946 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(494025), // Rule ID 4641 //
     /*  493951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  493954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  493959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  493962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  493965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  493968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  493971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  493974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  493982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  493986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  493994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  493996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494003 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494023 */     GIR_RootConstrainSelectedInstOperands,
     /*  494024 */     // GIR_Coverage, 4641,
     /*  494024 */     GIR_EraseRootFromParent_Done,
     /*  494025 */   // Label 8257: @494025
     /*  494025 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(494104), // Rule ID 4650 //
     /*  494030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494102 */     GIR_RootConstrainSelectedInstOperands,
     /*  494103 */     // GIR_Coverage, 4650,
     /*  494103 */     GIR_EraseRootFromParent_Done,
     /*  494104 */   // Label 8258: @494104
     /*  494104 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(494183), // Rule ID 4651 //
     /*  494109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  494120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  494123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  494126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  494129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494161 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494181 */     GIR_RootConstrainSelectedInstOperands,
     /*  494182 */     // GIR_Coverage, 4651,
     /*  494182 */     GIR_EraseRootFromParent_Done,
     /*  494183 */   // Label 8259: @494183
     /*  494183 */   GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(494262), // Rule ID 4660 //
     /*  494188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494260 */     GIR_RootConstrainSelectedInstOperands,
     /*  494261 */     // GIR_Coverage, 4660,
     /*  494261 */     GIR_EraseRootFromParent_Done,
     /*  494262 */   // Label 8260: @494262
     /*  494262 */   GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(494341), // Rule ID 4661 //
     /*  494267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  494278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  494281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  494284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  494287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494319 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494339 */     GIR_RootConstrainSelectedInstOperands,
     /*  494340 */     // GIR_Coverage, 4661,
     /*  494340 */     GIR_EraseRootFromParent_Done,
     /*  494341 */   // Label 8261: @494341
     /*  494341 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(494420), // Rule ID 4670 //
     /*  494346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  494349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  494398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494418 */     GIR_RootConstrainSelectedInstOperands,
     /*  494419 */     // GIR_Coverage, 4670,
     /*  494419 */     GIR_EraseRootFromParent_Done,
     /*  494420 */   // Label 8262: @494420
     /*  494420 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(494499), // Rule ID 4671 //
     /*  494425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  494428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  494436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  494439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  494442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  494445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  494464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494477 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  494477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  494480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  494494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494497 */     GIR_RootConstrainSelectedInstOperands,
     /*  494498 */     // GIR_Coverage, 4671,
     /*  494498 */     GIR_EraseRootFromParent_Done,
     /*  494499 */   // Label 8263: @494499
     /*  494499 */   GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(494578), // Rule ID 4680 //
     /*  494504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494556 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494576 */     GIR_RootConstrainSelectedInstOperands,
     /*  494577 */     // GIR_Coverage, 4680,
     /*  494577 */     GIR_EraseRootFromParent_Done,
     /*  494578 */   // Label 8264: @494578
     /*  494578 */   GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(494657), // Rule ID 4681 //
     /*  494583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  494594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  494597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  494600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  494603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494635 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  494638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494655 */     GIR_RootConstrainSelectedInstOperands,
     /*  494656 */     // GIR_Coverage, 4681,
     /*  494656 */     GIR_EraseRootFromParent_Done,
     /*  494657 */   // Label 8265: @494657
     /*  494657 */   GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(494736), // Rule ID 4690 //
     /*  494662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494734 */     GIR_RootConstrainSelectedInstOperands,
     /*  494735 */     // GIR_Coverage, 4690,
     /*  494735 */     GIR_EraseRootFromParent_Done,
     /*  494736 */   // Label 8266: @494736
     /*  494736 */   GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(494815), // Rule ID 4691 //
     /*  494741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  494752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  494755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  494758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  494761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  494784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494793 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  494796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494813 */     GIR_RootConstrainSelectedInstOperands,
     /*  494814 */     // GIR_Coverage, 4691,
     /*  494814 */     GIR_EraseRootFromParent_Done,
     /*  494815 */   // Label 8267: @494815
     /*  494815 */   GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(494894), // Rule ID 4700 //
     /*  494820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  494843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  494872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494892 */     GIR_RootConstrainSelectedInstOperands,
     /*  494893 */     // GIR_Coverage, 4700,
     /*  494893 */     GIR_EraseRootFromParent_Done,
     /*  494894 */   // Label 8268: @494894
     /*  494894 */   GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(494973), // Rule ID 4701 //
     /*  494899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  494902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  494910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  494913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  494916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  494919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  494922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  494930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  494934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  494938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  494942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  494944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  494951 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  494951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  494954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  494956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  494958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  494960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  494965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  494968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  494971 */     GIR_RootConstrainSelectedInstOperands,
     /*  494972 */     // GIR_Coverage, 4701,
     /*  494972 */     GIR_EraseRootFromParent_Done,
     /*  494973 */   // Label 8269: @494973
     /*  494973 */   GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(495052), // Rule ID 4710 //
     /*  494978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  494981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  494986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  494989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  494992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  494995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  494998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  495001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495030 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  495030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495050 */     GIR_RootConstrainSelectedInstOperands,
     /*  495051 */     // GIR_Coverage, 4710,
     /*  495051 */     GIR_EraseRootFromParent_Done,
     /*  495052 */   // Label 8270: @495052
     /*  495052 */   GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(495131), // Rule ID 4711 //
     /*  495057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  495060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  495065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  495068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  495071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  495074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  495077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  495080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  495088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  495092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  495096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  495100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  495102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, (undef:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  495109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  495112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  495116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  495118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  495129 */     GIR_RootConstrainSelectedInstOperands,
     /*  495130 */     // GIR_Coverage, 4711,
     /*  495130 */     GIR_EraseRootFromParent_Done,
     /*  495131 */   // Label 8271: @495131
     /*  495131 */   GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(495199), // Rule ID 2602 //
     /*  495136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495168 */     // MIs[0] policy
     /*  495168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495178 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495185 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495197 */     GIR_RootConstrainSelectedInstOperands,
     /*  495198 */     // GIR_Coverage, 2602,
     /*  495198 */     GIR_EraseRootFromParent_Done,
     /*  495199 */   // Label 8272: @495199
     /*  495199 */   GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(495267), // Rule ID 2603 //
     /*  495204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  495215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  495218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495236 */     // MIs[0] policy
     /*  495236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF8_MASK),
     /*  495249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495253 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495265 */     GIR_RootConstrainSelectedInstOperands,
     /*  495266 */     // GIR_Coverage, 2603,
     /*  495266 */     GIR_EraseRootFromParent_Done,
     /*  495267 */   // Label 8273: @495267
     /*  495267 */   GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(495335), // Rule ID 23390 //
     /*  495272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495304 */     // MIs[0] policy
     /*  495304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495321 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495333 */     GIR_RootConstrainSelectedInstOperands,
     /*  495334 */     // GIR_Coverage, 23390,
     /*  495334 */     GIR_EraseRootFromParent_Done,
     /*  495335 */   // Label 8274: @495335
     /*  495335 */   GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(495403), // Rule ID 23391 //
     /*  495340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  495351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  495354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495372 */     // MIs[0] policy
     /*  495372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495382 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495389 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495401 */     GIR_RootConstrainSelectedInstOperands,
     /*  495402 */     // GIR_Coverage, 23391,
     /*  495402 */     GIR_EraseRootFromParent_Done,
     /*  495403 */   // Label 8275: @495403
     /*  495403 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(495471), // Rule ID 23394 //
     /*  495408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  495419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  495422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  495425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495440 */     // MIs[0] policy
     /*  495440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495450 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495457 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495469 */     GIR_RootConstrainSelectedInstOperands,
     /*  495470 */     // GIR_Coverage, 23394,
     /*  495470 */     GIR_EraseRootFromParent_Done,
     /*  495471 */   // Label 8276: @495471
     /*  495471 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(495539), // Rule ID 23395 //
     /*  495476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  495487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  495490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  495493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495508 */     // MIs[0] policy
     /*  495508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495518 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495525 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  495535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495537 */     GIR_RootConstrainSelectedInstOperands,
     /*  495538 */     // GIR_Coverage, 23395,
     /*  495538 */     GIR_EraseRootFromParent_Done,
     /*  495539 */   // Label 8277: @495539
     /*  495539 */   GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(495607), // Rule ID 23398 //
     /*  495544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  495555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  495558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495576 */     // MIs[0] policy
     /*  495576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495586 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495593 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495605 */     GIR_RootConstrainSelectedInstOperands,
     /*  495606 */     // GIR_Coverage, 23398,
     /*  495606 */     GIR_EraseRootFromParent_Done,
     /*  495607 */   // Label 8278: @495607
     /*  495607 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(495675), // Rule ID 23399 //
     /*  495612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  495623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  495626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495644 */     // MIs[0] policy
     /*  495644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF4_MASK),
     /*  495657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495661 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495673 */     GIR_RootConstrainSelectedInstOperands,
     /*  495674 */     // GIR_Coverage, 23399,
     /*  495674 */     GIR_EraseRootFromParent_Done,
     /*  495675 */   // Label 8279: @495675
     /*  495675 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(495743), // Rule ID 23402 //
     /*  495680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  495691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  495694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495712 */     // MIs[0] policy
     /*  495712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495722 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495729 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495741 */     GIR_RootConstrainSelectedInstOperands,
     /*  495742 */     // GIR_Coverage, 23402,
     /*  495742 */     GIR_EraseRootFromParent_Done,
     /*  495743 */   // Label 8280: @495743
     /*  495743 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(495811), // Rule ID 23403 //
     /*  495748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  495759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  495762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  495765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495780 */     // MIs[0] policy
     /*  495780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495790 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495797 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  495807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495809 */     GIR_RootConstrainSelectedInstOperands,
     /*  495810 */     // GIR_Coverage, 23403,
     /*  495810 */     GIR_EraseRootFromParent_Done,
     /*  495811 */   // Label 8281: @495811
     /*  495811 */   GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(495879), // Rule ID 23406 //
     /*  495816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495848 */     // MIs[0] policy
     /*  495848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495858 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495865 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495877 */     GIR_RootConstrainSelectedInstOperands,
     /*  495878 */     // GIR_Coverage, 23406,
     /*  495878 */     GIR_EraseRootFromParent_Done,
     /*  495879 */   // Label 8282: @495879
     /*  495879 */   GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(495947), // Rule ID 23407 //
     /*  495884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  495887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  495895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  495898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  495901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  495904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495916 */     // MIs[0] policy
     /*  495916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495926 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  495926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_MF2_MASK),
     /*  495929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  495933 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  495935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  495940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  495943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  495945 */     GIR_RootConstrainSelectedInstOperands,
     /*  495946 */     // GIR_Coverage, 23407,
     /*  495946 */     GIR_EraseRootFromParent_Done,
     /*  495947 */   // Label 8283: @495947
     /*  495947 */   GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(496015), // Rule ID 23410 //
     /*  495952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  495955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  495960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  495963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  495966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  495969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  495972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  495976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  495980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  495984 */     // MIs[0] policy
     /*  495984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  495987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  495994 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  495994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  495997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  495999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496001 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496013 */     GIR_RootConstrainSelectedInstOperands,
     /*  496014 */     // GIR_Coverage, 23410,
     /*  496014 */     GIR_EraseRootFromParent_Done,
     /*  496015 */   // Label 8284: @496015
     /*  496015 */   GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(496083), // Rule ID 23411 //
     /*  496020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  496031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  496034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496052 */     // MIs[0] policy
     /*  496052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496062 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11253:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496069 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496081 */     GIR_RootConstrainSelectedInstOperands,
     /*  496082 */     // GIR_Coverage, 23411,
     /*  496082 */     GIR_EraseRootFromParent_Done,
     /*  496083 */   // Label 8285: @496083
     /*  496083 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(496151), // Rule ID 23414 //
     /*  496088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496120 */     // MIs[0] policy
     /*  496120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496130 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496137 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496149 */     GIR_RootConstrainSelectedInstOperands,
     /*  496150 */     // GIR_Coverage, 23414,
     /*  496150 */     GIR_EraseRootFromParent_Done,
     /*  496151 */   // Label 8286: @496151
     /*  496151 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(496219), // Rule ID 23415 //
     /*  496156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  496167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  496170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  496173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496188 */     // MIs[0] policy
     /*  496188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496198 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11253:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496205 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496217 */     GIR_RootConstrainSelectedInstOperands,
     /*  496218 */     // GIR_Coverage, 23415,
     /*  496218 */     GIR_EraseRootFromParent_Done,
     /*  496219 */   // Label 8287: @496219
     /*  496219 */   GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(496287), // Rule ID 23418 //
     /*  496224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496256 */     // MIs[0] policy
     /*  496256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496273 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496285 */     GIR_RootConstrainSelectedInstOperands,
     /*  496286 */     // GIR_Coverage, 23418,
     /*  496286 */     GIR_EraseRootFromParent_Done,
     /*  496287 */   // Label 8288: @496287
     /*  496287 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(496355), // Rule ID 23419 //
     /*  496292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  496303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  496306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  496309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496324 */     // MIs[0] policy
     /*  496324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496334 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11253:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496341 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  496351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496353 */     GIR_RootConstrainSelectedInstOperands,
     /*  496354 */     // GIR_Coverage, 23419,
     /*  496354 */     GIR_EraseRootFromParent_Done,
     /*  496355 */   // Label 8289: @496355
     /*  496355 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(496423), // Rule ID 23422 //
     /*  496360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  496363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496392 */     // MIs[0] policy
     /*  496392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496409 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  496419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496421 */     GIR_RootConstrainSelectedInstOperands,
     /*  496422 */     // GIR_Coverage, 23422,
     /*  496422 */     GIR_EraseRootFromParent_Done,
     /*  496423 */   // Label 8290: @496423
     /*  496423 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(496491), // Rule ID 23423 //
     /*  496428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  496431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  496439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  496442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  496445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  496452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  496456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496460 */     // MIs[0] policy
     /*  496460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11253:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M1_MASK),
     /*  496473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496477 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  496487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496489 */     GIR_RootConstrainSelectedInstOperands,
     /*  496490 */     // GIR_Coverage, 23423,
     /*  496490 */     GIR_EraseRootFromParent_Done,
     /*  496491 */   // Label 8291: @496491
     /*  496491 */   GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(496559), // Rule ID 23426 //
     /*  496496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  496507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  496510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  496513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  496520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496528 */     // MIs[0] policy
     /*  496528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  496541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496545 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496557 */     GIR_RootConstrainSelectedInstOperands,
     /*  496558 */     // GIR_Coverage, 23426,
     /*  496558 */     GIR_EraseRootFromParent_Done,
     /*  496559 */   // Label 8292: @496559
     /*  496559 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(496627), // Rule ID 23427 //
     /*  496564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  496575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  496578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  496581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  496588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496596 */     // MIs[0] policy
     /*  496596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496606 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  496609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496613 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496625 */     GIR_RootConstrainSelectedInstOperands,
     /*  496626 */     // GIR_Coverage, 23427,
     /*  496626 */     GIR_EraseRootFromParent_Done,
     /*  496627 */   // Label 8293: @496627
     /*  496627 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(496695), // Rule ID 23430 //
     /*  496632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  496643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  496646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  496649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  496656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496664 */     // MIs[0] policy
     /*  496664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496674 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  496677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496681 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496691 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496693 */     GIR_RootConstrainSelectedInstOperands,
     /*  496694 */     // GIR_Coverage, 23430,
     /*  496694 */     GIR_EraseRootFromParent_Done,
     /*  496695 */   // Label 8294: @496695
     /*  496695 */   GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(496763), // Rule ID 23431 //
     /*  496700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  496711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  496714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  496717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  496724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  496728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496732 */     // MIs[0] policy
     /*  496732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496742 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  496745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496749 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496759 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496761 */     GIR_RootConstrainSelectedInstOperands,
     /*  496762 */     // GIR_Coverage, 23431,
     /*  496762 */     GIR_EraseRootFromParent_Done,
     /*  496763 */   // Label 8295: @496763
     /*  496763 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(496831), // Rule ID 23434 //
     /*  496768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  496779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  496782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  496785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  496792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496800 */     // MIs[0] policy
     /*  496800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496810 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  496813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496817 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496827 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496829 */     GIR_RootConstrainSelectedInstOperands,
     /*  496830 */     // GIR_Coverage, 23434,
     /*  496830 */     GIR_EraseRootFromParent_Done,
     /*  496831 */   // Label 8296: @496831
     /*  496831 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(496899), // Rule ID 23435 //
     /*  496836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  496847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  496850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  496853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  496860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  496864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496868 */     // MIs[0] policy
     /*  496868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496878 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  496878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  496881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496885 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  496895 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496897 */     GIR_RootConstrainSelectedInstOperands,
     /*  496898 */     // GIR_Coverage, 23435,
     /*  496898 */     GIR_EraseRootFromParent_Done,
     /*  496899 */   // Label 8297: @496899
     /*  496899 */   GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(496967), // Rule ID 23438 //
     /*  496904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  496907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  496915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  496918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  496924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  496928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  496932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  496936 */     // MIs[0] policy
     /*  496936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  496939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  496946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  496946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  496949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  496951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  496953 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  496955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  496960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  496963 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  496965 */     GIR_RootConstrainSelectedInstOperands,
     /*  496966 */     // GIR_Coverage, 23438,
     /*  496966 */     GIR_EraseRootFromParent_Done,
     /*  496967 */   // Label 8298: @496967
     /*  496967 */   GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(497035), // Rule ID 23439 //
     /*  496972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  496975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  496980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  496983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  496986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  496989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  496992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  496996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497004 */     // MIs[0] policy
     /*  497004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497021 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497031 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497033 */     GIR_RootConstrainSelectedInstOperands,
     /*  497034 */     // GIR_Coverage, 23439,
     /*  497034 */     GIR_EraseRootFromParent_Done,
     /*  497035 */   // Label 8299: @497035
     /*  497035 */   GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(497103), // Rule ID 23442 //
     /*  497040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497072 */     // MIs[0] policy
     /*  497072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497082 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497089 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497099 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497101 */     GIR_RootConstrainSelectedInstOperands,
     /*  497102 */     // GIR_Coverage, 23442,
     /*  497102 */     GIR_EraseRootFromParent_Done,
     /*  497103 */   // Label 8300: @497103
     /*  497103 */   GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(497171), // Rule ID 23443 //
     /*  497108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  497119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  497122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497140 */     // MIs[0] policy
     /*  497140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497157 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497167 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497169 */     GIR_RootConstrainSelectedInstOperands,
     /*  497170 */     // GIR_Coverage, 23443,
     /*  497170 */     GIR_EraseRootFromParent_Done,
     /*  497171 */   // Label 8301: @497171
     /*  497171 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(497239), // Rule ID 23446 //
     /*  497176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497208 */     // MIs[0] policy
     /*  497208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497218 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497225 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497235 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497237 */     GIR_RootConstrainSelectedInstOperands,
     /*  497238 */     // GIR_Coverage, 23446,
     /*  497238 */     GIR_EraseRootFromParent_Done,
     /*  497239 */   // Label 8302: @497239
     /*  497239 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(497307), // Rule ID 23447 //
     /*  497244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  497255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  497258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  497261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497276 */     // MIs[0] policy
     /*  497276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497293 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  497303 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497305 */     GIR_RootConstrainSelectedInstOperands,
     /*  497306 */     // GIR_Coverage, 23447,
     /*  497306 */     GIR_EraseRootFromParent_Done,
     /*  497307 */   // Label 8303: @497307
     /*  497307 */   GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(497375), // Rule ID 23450 //
     /*  497312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497344 */     // MIs[0] policy
     /*  497344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497361 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497371 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497373 */     GIR_RootConstrainSelectedInstOperands,
     /*  497374 */     // GIR_Coverage, 23450,
     /*  497374 */     GIR_EraseRootFromParent_Done,
     /*  497375 */   // Label 8304: @497375
     /*  497375 */   GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(497443), // Rule ID 23451 //
     /*  497380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  497391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  497394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497412 */     // MIs[0] policy
     /*  497412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497429 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497439 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497441 */     GIR_RootConstrainSelectedInstOperands,
     /*  497442 */     // GIR_Coverage, 23451,
     /*  497442 */     GIR_EraseRootFromParent_Done,
     /*  497443 */   // Label 8305: @497443
     /*  497443 */   GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(497511), // Rule ID 23454 //
     /*  497448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  497459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  497462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497480 */     // MIs[0] policy
     /*  497480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497497 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497507 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497509 */     GIR_RootConstrainSelectedInstOperands,
     /*  497510 */     // GIR_Coverage, 23454,
     /*  497510 */     GIR_EraseRootFromParent_Done,
     /*  497511 */   // Label 8306: @497511
     /*  497511 */   GIM_Try, /*On fail goto*//*Label 8307*/ GIMT_Encode4(497579), // Rule ID 23455 //
     /*  497516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  497527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  497530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  497533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497548 */     // MIs[0] policy
     /*  497548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497558 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497565 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497575 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497577 */     GIR_RootConstrainSelectedInstOperands,
     /*  497578 */     // GIR_Coverage, 23455,
     /*  497578 */     GIR_EraseRootFromParent_Done,
     /*  497579 */   // Label 8307: @497579
     /*  497579 */   GIM_Try, /*On fail goto*//*Label 8308*/ GIMT_Encode4(497647), // Rule ID 23458 //
     /*  497584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  497587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  497595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  497598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497616 */     // MIs[0] policy
     /*  497616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497633 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497643 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497645 */     GIR_RootConstrainSelectedInstOperands,
     /*  497646 */     // GIR_Coverage, 23458,
     /*  497646 */     GIR_EraseRootFromParent_Done,
     /*  497647 */   // Label 8308: @497647
     /*  497647 */   GIM_Try, /*On fail goto*//*Label 8309*/ GIMT_Encode4(497715), // Rule ID 23459 //
     /*  497652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  497655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  497663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  497666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  497669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  497676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  497680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497684 */     // MIs[0] policy
     /*  497684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  497697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497701 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  497711 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497713 */     GIR_RootConstrainSelectedInstOperands,
     /*  497714 */     // GIR_Coverage, 23459,
     /*  497714 */     GIR_EraseRootFromParent_Done,
     /*  497715 */   // Label 8309: @497715
     /*  497715 */   GIM_Try, /*On fail goto*//*Label 8310*/ GIMT_Encode4(497783), // Rule ID 23462 //
     /*  497720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  497723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  497731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  497734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497752 */     // MIs[0] policy
     /*  497752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497769 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497779 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497781 */     GIR_RootConstrainSelectedInstOperands,
     /*  497782 */     // GIR_Coverage, 23462,
     /*  497782 */     GIR_EraseRootFromParent_Done,
     /*  497783 */   // Label 8310: @497783
     /*  497783 */   GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(497851), // Rule ID 23463 //
     /*  497788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  497791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  497799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  497802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  497805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  497812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  497816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497820 */     // MIs[0] policy
     /*  497820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11253:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M2_MASK),
     /*  497833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497837 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497847 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497849 */     GIR_RootConstrainSelectedInstOperands,
     /*  497850 */     // GIR_Coverage, 23463,
     /*  497850 */     GIR_EraseRootFromParent_Done,
     /*  497851 */   // Label 8311: @497851
     /*  497851 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(497919), // Rule ID 23466 //
     /*  497856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  497859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  497867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  497870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  497876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497888 */     // MIs[0] policy
     /*  497888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497898 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  497898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497905 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497915 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497917 */     GIR_RootConstrainSelectedInstOperands,
     /*  497918 */     // GIR_Coverage, 23466,
     /*  497918 */     GIR_EraseRootFromParent_Done,
     /*  497919 */   // Label 8312: @497919
     /*  497919 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(497987), // Rule ID 23467 //
     /*  497924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  497927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  497932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  497935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  497938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  497941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  497944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  497948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  497952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  497956 */     // MIs[0] policy
     /*  497956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  497959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  497966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11253:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  497966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M4_MASK),
     /*  497969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  497971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  497973 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  497975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  497980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  497983 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  497985 */     GIR_RootConstrainSelectedInstOperands,
     /*  497986 */     // GIR_Coverage, 23467,
     /*  497986 */     GIR_EraseRootFromParent_Done,
     /*  497987 */   // Label 8313: @497987
     /*  497987 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(498055), // Rule ID 23470 //
     /*  497992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  497995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498024 */     // MIs[0] policy
     /*  498024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498041 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498051 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498053 */     GIR_RootConstrainSelectedInstOperands,
     /*  498054 */     // GIR_Coverage, 23470,
     /*  498054 */     GIR_EraseRootFromParent_Done,
     /*  498055 */   // Label 8314: @498055
     /*  498055 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(498123), // Rule ID 23471 //
     /*  498060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  498063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vid_mask),
     /*  498068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  498071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  498074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  498077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  498084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  498092 */     // MIs[0] policy
     /*  498092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11253:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVID_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVID_V_M8_MASK),
     /*  498105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  498107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  498109 */     GIR_RootToRootCopy, /*OpIdx*/3, // vm
     /*  498111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  498119 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498121 */     GIR_RootConstrainSelectedInstOperands,
     /*  498122 */     // GIR_Coverage, 23471,
     /*  498122 */     GIR_EraseRootFromParent_Done,
     /*  498123 */   // Label 8315: @498123
     /*  498123 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(498191), // Rule ID 60476 //
     /*  498128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498160 */     // MIs[0] policy
     /*  498160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498187 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498189 */     GIR_RootConstrainSelectedInstOperands,
     /*  498190 */     // GIR_Coverage, 60476,
     /*  498190 */     GIR_EraseRootFromParent_Done,
     /*  498191 */   // Label 8316: @498191
     /*  498191 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(498259), // Rule ID 60477 //
     /*  498196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498228 */     // MIs[0] policy
     /*  498228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498238 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_MF2),
     /*  498241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498255 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498257 */     GIR_RootConstrainSelectedInstOperands,
     /*  498258 */     // GIR_Coverage, 60477,
     /*  498258 */     GIR_EraseRootFromParent_Done,
     /*  498259 */   // Label 8317: @498259
     /*  498259 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(498327), // Rule ID 60478 //
     /*  498264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  498267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498296 */     // MIs[0] policy
     /*  498296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498323 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498325 */     GIR_RootConstrainSelectedInstOperands,
     /*  498326 */     // GIR_Coverage, 60478,
     /*  498326 */     GIR_EraseRootFromParent_Done,
     /*  498327 */   // Label 8318: @498327
     /*  498327 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(498395), // Rule ID 60479 //
     /*  498332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  498335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  498340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498364 */     // MIs[0] policy
     /*  498364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498374 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_MF2_MF2),
     /*  498377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498391 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498393 */     GIR_RootConstrainSelectedInstOperands,
     /*  498394 */     // GIR_Coverage, 60479,
     /*  498394 */     GIR_EraseRootFromParent_Done,
     /*  498395 */   // Label 8319: @498395
     /*  498395 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(498463), // Rule ID 61972 //
     /*  498400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498432 */     // MIs[0] policy
     /*  498432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498442 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  498445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498459 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498461 */     GIR_RootConstrainSelectedInstOperands,
     /*  498462 */     // GIR_Coverage, 61972,
     /*  498462 */     GIR_EraseRootFromParent_Done,
     /*  498463 */   // Label 8320: @498463
     /*  498463 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(498531), // Rule ID 61973 //
     /*  498468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  498479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  498482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  498485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498500 */     // MIs[0] policy
     /*  498500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498510 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11251:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M1),
     /*  498513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498527 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498529 */     GIR_RootConstrainSelectedInstOperands,
     /*  498530 */     // GIR_Coverage, 61973,
     /*  498530 */     GIR_EraseRootFromParent_Done,
     /*  498531 */   // Label 8321: @498531
     /*  498531 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(498599), // Rule ID 61974 //
     /*  498536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498568 */     // MIs[0] policy
     /*  498568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  498581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498595 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498597 */     GIR_RootConstrainSelectedInstOperands,
     /*  498598 */     // GIR_Coverage, 61974,
     /*  498598 */     GIR_EraseRootFromParent_Done,
     /*  498599 */   // Label 8322: @498599
     /*  498599 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(498667), // Rule ID 61975 //
     /*  498604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  498615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  498618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  498621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  498636 */     // MIs[0] policy
     /*  498636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11251:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M2),
     /*  498649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498663 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498665 */     GIR_RootConstrainSelectedInstOperands,
     /*  498666 */     // GIR_Coverage, 61975,
     /*  498666 */     GIR_EraseRootFromParent_Done,
     /*  498667 */   // Label 8323: @498667
     /*  498667 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(498735), // Rule ID 61976 //
     /*  498672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498704 */     // MIs[0] policy
     /*  498704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  498717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498731 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498733 */     GIR_RootConstrainSelectedInstOperands,
     /*  498734 */     // GIR_Coverage, 61976,
     /*  498734 */     GIR_EraseRootFromParent_Done,
     /*  498735 */   // Label 8324: @498735
     /*  498735 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(498803), // Rule ID 61977 //
     /*  498740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  498751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  498754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  498757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  498772 */     // MIs[0] policy
     /*  498772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498782 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11251:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M4),
     /*  498785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498799 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498801 */     GIR_RootConstrainSelectedInstOperands,
     /*  498802 */     // GIR_Coverage, 61977,
     /*  498802 */     GIR_EraseRootFromParent_Done,
     /*  498803 */   // Label 8325: @498803
     /*  498803 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(498871), // Rule ID 61978 //
     /*  498808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /*  498811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498840 */     // MIs[0] policy
     /*  498840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498850 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  498853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498867 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498869 */     GIR_RootConstrainSelectedInstOperands,
     /*  498870 */     // GIR_Coverage, 61978,
     /*  498870 */     GIR_EraseRootFromParent_Done,
     /*  498871 */   // Label 8326: @498871
     /*  498871 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(498939), // Rule ID 61979 //
     /*  498876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /*  498879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vgmul_vv),
     /*  498884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  498887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  498890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  498893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  498896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  498908 */     // MIs[0] policy
     /*  498908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498918 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11251:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  498918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGMUL_VV_M8),
     /*  498921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  498932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  498935 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  498937 */     GIR_RootConstrainSelectedInstOperands,
     /*  498938 */     // GIR_Coverage, 61979,
     /*  498938 */     GIR_EraseRootFromParent_Done,
     /*  498939 */   // Label 8327: @498939
     /*  498939 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(499007), // Rule ID 61980 //
     /*  498944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  498947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  498952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  498955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  498958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  498961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  498964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  498976 */     // MIs[0] policy
     /*  498976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  498979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  498986 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  498986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  498989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  498991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  498993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  498995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499003 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499005 */     GIR_RootConstrainSelectedInstOperands,
     /*  499006 */     // GIR_Coverage, 61980,
     /*  499006 */     GIR_EraseRootFromParent_Done,
     /*  499007 */   // Label 8328: @499007
     /*  499007 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(499075), // Rule ID 61981 //
     /*  499012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  499023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  499026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499044 */     // MIs[0] policy
     /*  499044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_MF2),
     /*  499057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499071 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499073 */     GIR_RootConstrainSelectedInstOperands,
     /*  499074 */     // GIR_Coverage, 61981,
     /*  499074 */     GIR_EraseRootFromParent_Done,
     /*  499075 */   // Label 8329: @499075
     /*  499075 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(499143), // Rule ID 61982 //
     /*  499080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499112 */     // MIs[0] policy
     /*  499112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499139 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499141 */     GIR_RootConstrainSelectedInstOperands,
     /*  499142 */     // GIR_Coverage, 61982,
     /*  499142 */     GIR_EraseRootFromParent_Done,
     /*  499143 */   // Label 8330: @499143
     /*  499143 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(499211), // Rule ID 61983 //
     /*  499148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499180 */     // MIs[0] policy
     /*  499180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11077:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M1),
     /*  499193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499207 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499209 */     GIR_RootConstrainSelectedInstOperands,
     /*  499210 */     // GIR_Coverage, 61983,
     /*  499210 */     GIR_EraseRootFromParent_Done,
     /*  499211 */   // Label 8331: @499211
     /*  499211 */   GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(499279), // Rule ID 61984 //
     /*  499216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499248 */     // MIs[0] policy
     /*  499248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499275 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499277 */     GIR_RootConstrainSelectedInstOperands,
     /*  499278 */     // GIR_Coverage, 61984,
     /*  499278 */     GIR_EraseRootFromParent_Done,
     /*  499279 */   // Label 8332: @499279
     /*  499279 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(499347), // Rule ID 61985 //
     /*  499284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  499301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499316 */     // MIs[0] policy
     /*  499316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499326 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11077:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M2),
     /*  499329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499343 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499345 */     GIR_RootConstrainSelectedInstOperands,
     /*  499346 */     // GIR_Coverage, 61985,
     /*  499346 */     GIR_EraseRootFromParent_Done,
     /*  499347 */   // Label 8333: @499347
     /*  499347 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(499415), // Rule ID 61986 //
     /*  499352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499384 */     // MIs[0] policy
     /*  499384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499411 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499413 */     GIR_RootConstrainSelectedInstOperands,
     /*  499414 */     // GIR_Coverage, 61986,
     /*  499414 */     GIR_EraseRootFromParent_Done,
     /*  499415 */   // Label 8334: @499415
     /*  499415 */   GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(499483), // Rule ID 61987 //
     /*  499420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  499431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  499434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  499437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  499452 */     // MIs[0] policy
     /*  499452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11077:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M4),
     /*  499465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499479 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499481 */     GIR_RootConstrainSelectedInstOperands,
     /*  499482 */     // GIR_Coverage, 61987,
     /*  499482 */     GIR_EraseRootFromParent_Done,
     /*  499483 */   // Label 8335: @499483
     /*  499483 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(499551), // Rule ID 61988 //
     /*  499488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499520 */     // MIs[0] policy
     /*  499520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499530 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  499533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499547 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499549 */     GIR_RootConstrainSelectedInstOperands,
     /*  499550 */     // GIR_Coverage, 61988,
     /*  499550 */     GIR_EraseRootFromParent_Done,
     /*  499551 */   // Label 8336: @499551
     /*  499551 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(499619), // Rule ID 61989 //
     /*  499556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vv),
     /*  499564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  499567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  499570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  499573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  499588 */     // MIs[0] policy
     /*  499588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11077:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VV_M8),
     /*  499601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499615 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499617 */     GIR_RootConstrainSelectedInstOperands,
     /*  499618 */     // GIR_Coverage, 61989,
     /*  499618 */     GIR_EraseRootFromParent_Done,
     /*  499619 */   // Label 8337: @499619
     /*  499619 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(499687), // Rule ID 61990 //
     /*  499624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499656 */     // MIs[0] policy
     /*  499656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499666 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  499669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499683 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499685 */     GIR_RootConstrainSelectedInstOperands,
     /*  499686 */     // GIR_Coverage, 61990,
     /*  499686 */     GIR_EraseRootFromParent_Done,
     /*  499687 */   // Label 8338: @499687
     /*  499687 */   GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(499755), // Rule ID 61991 //
     /*  499692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499724 */     // MIs[0] policy
     /*  499724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_MF2),
     /*  499737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499751 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499753 */     GIR_RootConstrainSelectedInstOperands,
     /*  499754 */     // GIR_Coverage, 61991,
     /*  499754 */     GIR_EraseRootFromParent_Done,
     /*  499755 */   // Label 8339: @499755
     /*  499755 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(499823), // Rule ID 61992 //
     /*  499760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499792 */     // MIs[0] policy
     /*  499792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  499805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499819 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499821 */     GIR_RootConstrainSelectedInstOperands,
     /*  499822 */     // GIR_Coverage, 61992,
     /*  499822 */     GIR_EraseRootFromParent_Done,
     /*  499823 */   // Label 8340: @499823
     /*  499823 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(499891), // Rule ID 61993 //
     /*  499828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  499839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  499842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  499845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499860 */     // MIs[0] policy
     /*  499860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499870 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11076:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  499870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M1_M1),
     /*  499873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499887 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499889 */     GIR_RootConstrainSelectedInstOperands,
     /*  499890 */     // GIR_Coverage, 61993,
     /*  499890 */     GIR_EraseRootFromParent_Done,
     /*  499891 */   // Label 8341: @499891
     /*  499891 */   GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(499959), // Rule ID 61994 //
     /*  499896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  499899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  499916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499928 */     // MIs[0] policy
     /*  499928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  499938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  499938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  499941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  499943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  499945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  499947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  499952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  499955 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  499957 */     GIR_RootConstrainSelectedInstOperands,
     /*  499958 */     // GIR_Coverage, 61994,
     /*  499958 */     GIR_EraseRootFromParent_Done,
     /*  499959 */   // Label 8342: @499959
     /*  499959 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(500027), // Rule ID 61995 //
     /*  499964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  499967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  499972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  499975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  499978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  499981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  499984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  499992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  499996 */     // MIs[0] policy
     /*  499996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  499999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500006 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_MF2),
     /*  500009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500023 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500025 */     GIR_RootConstrainSelectedInstOperands,
     /*  500026 */     // GIR_Coverage, 61995,
     /*  500026 */     GIR_EraseRootFromParent_Done,
     /*  500027 */   // Label 8343: @500027
     /*  500027 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(500095), // Rule ID 61996 //
     /*  500032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500064 */     // MIs[0] policy
     /*  500064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500091 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500093 */     GIR_RootConstrainSelectedInstOperands,
     /*  500094 */     // GIR_Coverage, 61996,
     /*  500094 */     GIR_EraseRootFromParent_Done,
     /*  500095 */   // Label 8344: @500095
     /*  500095 */   GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(500163), // Rule ID 61997 //
     /*  500100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500132 */     // MIs[0] policy
     /*  500132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500142 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M1),
     /*  500145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500159 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500161 */     GIR_RootConstrainSelectedInstOperands,
     /*  500162 */     // GIR_Coverage, 61997,
     /*  500162 */     GIR_EraseRootFromParent_Done,
     /*  500163 */   // Label 8345: @500163
     /*  500163 */   GIM_Try, /*On fail goto*//*Label 8346*/ GIMT_Encode4(500231), // Rule ID 61998 //
     /*  500168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500200 */     // MIs[0] policy
     /*  500200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500227 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500229 */     GIR_RootConstrainSelectedInstOperands,
     /*  500230 */     // GIR_Coverage, 61998,
     /*  500230 */     GIR_EraseRootFromParent_Done,
     /*  500231 */   // Label 8346: @500231
     /*  500231 */   GIM_Try, /*On fail goto*//*Label 8347*/ GIMT_Encode4(500299), // Rule ID 61999 //
     /*  500236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  500247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  500250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500268 */     // MIs[0] policy
     /*  500268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11076:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M2_M2),
     /*  500281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500295 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500297 */     GIR_RootConstrainSelectedInstOperands,
     /*  500298 */     // GIR_Coverage, 61999,
     /*  500298 */     GIR_EraseRootFromParent_Done,
     /*  500299 */   // Label 8347: @500299
     /*  500299 */   GIM_Try, /*On fail goto*//*Label 8348*/ GIMT_Encode4(500367), // Rule ID 62000 //
     /*  500304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500336 */     // MIs[0] policy
     /*  500336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500363 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500365 */     GIR_RootConstrainSelectedInstOperands,
     /*  500366 */     // GIR_Coverage, 62000,
     /*  500366 */     GIR_EraseRootFromParent_Done,
     /*  500367 */   // Label 8348: @500367
     /*  500367 */   GIM_Try, /*On fail goto*//*Label 8349*/ GIMT_Encode4(500435), // Rule ID 62001 //
     /*  500372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500404 */     // MIs[0] policy
     /*  500404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_MF2),
     /*  500417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500431 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500433 */     GIR_RootConstrainSelectedInstOperands,
     /*  500434 */     // GIR_Coverage, 62001,
     /*  500434 */     GIR_EraseRootFromParent_Done,
     /*  500435 */   // Label 8349: @500435
     /*  500435 */   GIM_Try, /*On fail goto*//*Label 8350*/ GIMT_Encode4(500503), // Rule ID 62002 //
     /*  500440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500472 */     // MIs[0] policy
     /*  500472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500482 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  500485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500499 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500501 */     GIR_RootConstrainSelectedInstOperands,
     /*  500502 */     // GIR_Coverage, 62002,
     /*  500502 */     GIR_EraseRootFromParent_Done,
     /*  500503 */   // Label 8350: @500503
     /*  500503 */   GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(500571), // Rule ID 62003 //
     /*  500508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  500525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500540 */     // MIs[0] policy
     /*  500540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M1),
     /*  500553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500567 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500569 */     GIR_RootConstrainSelectedInstOperands,
     /*  500570 */     // GIR_Coverage, 62003,
     /*  500570 */     GIR_EraseRootFromParent_Done,
     /*  500571 */   // Label 8351: @500571
     /*  500571 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(500639), // Rule ID 62004 //
     /*  500576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500608 */     // MIs[0] policy
     /*  500608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  500621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500635 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500637 */     GIR_RootConstrainSelectedInstOperands,
     /*  500638 */     // GIR_Coverage, 62004,
     /*  500638 */     GIR_EraseRootFromParent_Done,
     /*  500639 */   // Label 8352: @500639
     /*  500639 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(500707), // Rule ID 62005 //
     /*  500644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  500661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  500676 */     // MIs[0] policy
     /*  500676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M2),
     /*  500689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500703 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500705 */     GIR_RootConstrainSelectedInstOperands,
     /*  500706 */     // GIR_Coverage, 62005,
     /*  500706 */     GIR_EraseRootFromParent_Done,
     /*  500707 */   // Label 8353: @500707
     /*  500707 */   GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(500775), // Rule ID 62006 //
     /*  500712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500744 */     // MIs[0] policy
     /*  500744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  500757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500771 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500773 */     GIR_RootConstrainSelectedInstOperands,
     /*  500774 */     // GIR_Coverage, 62006,
     /*  500774 */     GIR_EraseRootFromParent_Done,
     /*  500775 */   // Label 8354: @500775
     /*  500775 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(500843), // Rule ID 62007 //
     /*  500780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  500791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  500794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  500797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  500812 */     // MIs[0] policy
     /*  500812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11076:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M4_M4),
     /*  500825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500839 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500841 */     GIR_RootConstrainSelectedInstOperands,
     /*  500842 */     // GIR_Coverage, 62007,
     /*  500842 */     GIR_EraseRootFromParent_Done,
     /*  500843 */   // Label 8355: @500843
     /*  500843 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(500911), // Rule ID 62008 //
     /*  500848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  500868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500880 */     // MIs[0] policy
     /*  500880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  500890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  500893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500907 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500909 */     GIR_RootConstrainSelectedInstOperands,
     /*  500910 */     // GIR_Coverage, 62008,
     /*  500910 */     GIR_EraseRootFromParent_Done,
     /*  500911 */   // Label 8356: @500911
     /*  500911 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(500979), // Rule ID 62009 //
     /*  500916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  500919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  500933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  500936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  500944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  500948 */     // MIs[0] policy
     /*  500948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  500951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  500958 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  500958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_MF2),
     /*  500961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  500963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  500965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  500967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  500972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  500975 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  500977 */     GIR_RootConstrainSelectedInstOperands,
     /*  500978 */     // GIR_Coverage, 62009,
     /*  500978 */     GIR_EraseRootFromParent_Done,
     /*  500979 */   // Label 8357: @500979
     /*  500979 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(501047), // Rule ID 62010 //
     /*  500984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  500987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  500992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  500995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  500998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501016 */     // MIs[0] policy
     /*  501016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501043 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501045 */     GIR_RootConstrainSelectedInstOperands,
     /*  501046 */     // GIR_Coverage, 62010,
     /*  501046 */     GIR_EraseRootFromParent_Done,
     /*  501047 */   // Label 8358: @501047
     /*  501047 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(501115), // Rule ID 62011 //
     /*  501052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501084 */     // MIs[0] policy
     /*  501084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M1),
     /*  501097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501111 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501113 */     GIR_RootConstrainSelectedInstOperands,
     /*  501114 */     // GIR_Coverage, 62011,
     /*  501114 */     GIR_EraseRootFromParent_Done,
     /*  501115 */   // Label 8359: @501115
     /*  501115 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(501183), // Rule ID 62012 //
     /*  501120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501152 */     // MIs[0] policy
     /*  501152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501179 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501181 */     GIR_RootConstrainSelectedInstOperands,
     /*  501182 */     // GIR_Coverage, 62012,
     /*  501182 */     GIR_EraseRootFromParent_Done,
     /*  501183 */   // Label 8360: @501183
     /*  501183 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(501251), // Rule ID 62013 //
     /*  501188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501220 */     // MIs[0] policy
     /*  501220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501230 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M2),
     /*  501233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501247 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501249 */     GIR_RootConstrainSelectedInstOperands,
     /*  501250 */     // GIR_Coverage, 62013,
     /*  501250 */     GIR_EraseRootFromParent_Done,
     /*  501251 */   // Label 8361: @501251
     /*  501251 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(501319), // Rule ID 62014 //
     /*  501256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501288 */     // MIs[0] policy
     /*  501288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501298 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501315 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501317 */     GIR_RootConstrainSelectedInstOperands,
     /*  501318 */     // GIR_Coverage, 62014,
     /*  501318 */     GIR_EraseRootFromParent_Done,
     /*  501319 */   // Label 8362: @501319
     /*  501319 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(501387), // Rule ID 62015 //
     /*  501324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdf_vs),
     /*  501332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501356 */     // MIs[0] policy
     /*  501356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11076:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDF_VS_M8_M4),
     /*  501369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501383 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501385 */     GIR_RootConstrainSelectedInstOperands,
     /*  501386 */     // GIR_Coverage, 62015,
     /*  501386 */     GIR_EraseRootFromParent_Done,
     /*  501387 */   // Label 8363: @501387
     /*  501387 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(501455), // Rule ID 62016 //
     /*  501392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501424 */     // MIs[0] policy
     /*  501424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  501437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501451 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501453 */     GIR_RootConstrainSelectedInstOperands,
     /*  501454 */     // GIR_Coverage, 62016,
     /*  501454 */     GIR_EraseRootFromParent_Done,
     /*  501455 */   // Label 8364: @501455
     /*  501455 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(501523), // Rule ID 62017 //
     /*  501460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  501471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  501474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  501477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501492 */     // MIs[0] policy
     /*  501492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501502 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_MF2),
     /*  501505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501519 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501521 */     GIR_RootConstrainSelectedInstOperands,
     /*  501522 */     // GIR_Coverage, 62017,
     /*  501522 */     GIR_EraseRootFromParent_Done,
     /*  501523 */   // Label 8365: @501523
     /*  501523 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(501591), // Rule ID 62018 //
     /*  501528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  501539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  501542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501560 */     // MIs[0] policy
     /*  501560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  501573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501587 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501589 */     GIR_RootConstrainSelectedInstOperands,
     /*  501590 */     // GIR_Coverage, 62018,
     /*  501590 */     GIR_EraseRootFromParent_Done,
     /*  501591 */   // Label 8366: @501591
     /*  501591 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(501659), // Rule ID 62019 //
     /*  501596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  501607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  501610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  501613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  501628 */     // MIs[0] policy
     /*  501628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11079:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M1),
     /*  501641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501655 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501657 */     GIR_RootConstrainSelectedInstOperands,
     /*  501658 */     // GIR_Coverage, 62019,
     /*  501658 */     GIR_EraseRootFromParent_Done,
     /*  501659 */   // Label 8367: @501659
     /*  501659 */   GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(501727), // Rule ID 62020 //
     /*  501664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501696 */     // MIs[0] policy
     /*  501696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  501709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501723 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501725 */     GIR_RootConstrainSelectedInstOperands,
     /*  501726 */     // GIR_Coverage, 62020,
     /*  501726 */     GIR_EraseRootFromParent_Done,
     /*  501727 */   // Label 8368: @501727
     /*  501727 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(501795), // Rule ID 62021 //
     /*  501732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  501743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  501746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  501749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  501764 */     // MIs[0] policy
     /*  501764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501774 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11079:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M2),
     /*  501777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501791 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501793 */     GIR_RootConstrainSelectedInstOperands,
     /*  501794 */     // GIR_Coverage, 62021,
     /*  501794 */     GIR_EraseRootFromParent_Done,
     /*  501795 */   // Label 8369: @501795
     /*  501795 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(501863), // Rule ID 62022 //
     /*  501800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501832 */     // MIs[0] policy
     /*  501832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501842 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  501845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501859 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501861 */     GIR_RootConstrainSelectedInstOperands,
     /*  501862 */     // GIR_Coverage, 62022,
     /*  501862 */     GIR_EraseRootFromParent_Done,
     /*  501863 */   // Label 8370: @501863
     /*  501863 */   GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(501931), // Rule ID 62023 //
     /*  501868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  501871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  501879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  501882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  501885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  501888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  501900 */     // MIs[0] policy
     /*  501900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11079:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  501910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M4),
     /*  501913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501927 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501929 */     GIR_RootConstrainSelectedInstOperands,
     /*  501930 */     // GIR_Coverage, 62023,
     /*  501930 */     GIR_EraseRootFromParent_Done,
     /*  501931 */   // Label 8371: @501931
     /*  501931 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(501999), // Rule ID 62024 //
     /*  501936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  501939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  501944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  501947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  501950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  501953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  501956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  501968 */     // MIs[0] policy
     /*  501968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  501971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  501978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  501978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  501981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  501983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  501985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  501987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  501992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  501995 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  501997 */     GIR_RootConstrainSelectedInstOperands,
     /*  501998 */     // GIR_Coverage, 62024,
     /*  501998 */     GIR_EraseRootFromParent_Done,
     /*  501999 */   // Label 8372: @501999
     /*  501999 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(502067), // Rule ID 62025 //
     /*  502004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vv),
     /*  502012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  502015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  502018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  502021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  502036 */     // MIs[0] policy
     /*  502036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11079:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VV_M8),
     /*  502049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502063 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502065 */     GIR_RootConstrainSelectedInstOperands,
     /*  502066 */     // GIR_Coverage, 62025,
     /*  502066 */     GIR_EraseRootFromParent_Done,
     /*  502067 */   // Label 8373: @502067
     /*  502067 */   GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(502135), // Rule ID 62026 //
     /*  502072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502104 */     // MIs[0] policy
     /*  502104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502114 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502131 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502133 */     GIR_RootConstrainSelectedInstOperands,
     /*  502134 */     // GIR_Coverage, 62026,
     /*  502134 */     GIR_EraseRootFromParent_Done,
     /*  502135 */   // Label 8374: @502135
     /*  502135 */   GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(502203), // Rule ID 62027 //
     /*  502140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  502151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  502154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502172 */     // MIs[0] policy
     /*  502172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502182 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_MF2_MF2),
     /*  502185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502199 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502201 */     GIR_RootConstrainSelectedInstOperands,
     /*  502202 */     // GIR_Coverage, 62027,
     /*  502202 */     GIR_EraseRootFromParent_Done,
     /*  502203 */   // Label 8375: @502203
     /*  502203 */   GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(502271), // Rule ID 62028 //
     /*  502208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502240 */     // MIs[0] policy
     /*  502240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502267 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502269 */     GIR_RootConstrainSelectedInstOperands,
     /*  502270 */     // GIR_Coverage, 62028,
     /*  502270 */     GIR_EraseRootFromParent_Done,
     /*  502271 */   // Label 8376: @502271
     /*  502271 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(502339), // Rule ID 62029 //
     /*  502276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502308 */     // MIs[0] policy
     /*  502308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_MF2),
     /*  502321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502335 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502337 */     GIR_RootConstrainSelectedInstOperands,
     /*  502338 */     // GIR_Coverage, 62029,
     /*  502338 */     GIR_EraseRootFromParent_Done,
     /*  502339 */   // Label 8377: @502339
     /*  502339 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(502407), // Rule ID 62030 //
     /*  502344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502376 */     // MIs[0] policy
     /*  502376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502403 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502405 */     GIR_RootConstrainSelectedInstOperands,
     /*  502406 */     // GIR_Coverage, 62030,
     /*  502406 */     GIR_EraseRootFromParent_Done,
     /*  502407 */   // Label 8378: @502407
     /*  502407 */   GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(502475), // Rule ID 62031 //
     /*  502412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  502423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  502426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502444 */     // MIs[0] policy
     /*  502444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502454 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11078:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M1_M1),
     /*  502457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502471 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502473 */     GIR_RootConstrainSelectedInstOperands,
     /*  502474 */     // GIR_Coverage, 62031,
     /*  502474 */     GIR_EraseRootFromParent_Done,
     /*  502475 */   // Label 8379: @502475
     /*  502475 */   GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(502543), // Rule ID 62032 //
     /*  502480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502512 */     // MIs[0] policy
     /*  502512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  502525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502539 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502541 */     GIR_RootConstrainSelectedInstOperands,
     /*  502542 */     // GIR_Coverage, 62032,
     /*  502542 */     GIR_EraseRootFromParent_Done,
     /*  502543 */   // Label 8380: @502543
     /*  502543 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(502611), // Rule ID 62033 //
     /*  502548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502580 */     // MIs[0] policy
     /*  502580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_MF2),
     /*  502593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502607 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502609 */     GIR_RootConstrainSelectedInstOperands,
     /*  502610 */     // GIR_Coverage, 62033,
     /*  502610 */     GIR_EraseRootFromParent_Done,
     /*  502611 */   // Label 8381: @502611
     /*  502611 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(502679), // Rule ID 62034 //
     /*  502616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502648 */     // MIs[0] policy
     /*  502648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502658 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  502661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502675 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502677 */     GIR_RootConstrainSelectedInstOperands,
     /*  502678 */     // GIR_Coverage, 62034,
     /*  502678 */     GIR_EraseRootFromParent_Done,
     /*  502679 */   // Label 8382: @502679
     /*  502679 */   GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(502747), // Rule ID 62035 //
     /*  502684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  502701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502716 */     // MIs[0] policy
     /*  502716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502726 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M1),
     /*  502729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502743 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502745 */     GIR_RootConstrainSelectedInstOperands,
     /*  502746 */     // GIR_Coverage, 62035,
     /*  502746 */     GIR_EraseRootFromParent_Done,
     /*  502747 */   // Label 8383: @502747
     /*  502747 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(502815), // Rule ID 62036 //
     /*  502752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502784 */     // MIs[0] policy
     /*  502784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  502797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502811 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502813 */     GIR_RootConstrainSelectedInstOperands,
     /*  502814 */     // GIR_Coverage, 62036,
     /*  502814 */     GIR_EraseRootFromParent_Done,
     /*  502815 */   // Label 8384: @502815
     /*  502815 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(502883), // Rule ID 62037 //
     /*  502820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  502831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  502834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  502837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  502852 */     // MIs[0] policy
     /*  502852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502862 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11078:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M2_M2),
     /*  502865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502879 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502881 */     GIR_RootConstrainSelectedInstOperands,
     /*  502882 */     // GIR_Coverage, 62037,
     /*  502882 */     GIR_EraseRootFromParent_Done,
     /*  502883 */   // Label 8385: @502883
     /*  502883 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(502951), // Rule ID 62038 //
     /*  502888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  502891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  502908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502920 */     // MIs[0] policy
     /*  502920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  502930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  502933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  502935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  502937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  502939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  502944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  502947 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  502949 */     GIR_RootConstrainSelectedInstOperands,
     /*  502950 */     // GIR_Coverage, 62038,
     /*  502950 */     GIR_EraseRootFromParent_Done,
     /*  502951 */   // Label 8386: @502951
     /*  502951 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(503019), // Rule ID 62039 //
     /*  502956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  502959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  502964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  502967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  502970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  502973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  502976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  502984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  502988 */     // MIs[0] policy
     /*  502988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  502991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  502998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  502998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_MF2),
     /*  503001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503015 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503017 */     GIR_RootConstrainSelectedInstOperands,
     /*  503018 */     // GIR_Coverage, 62039,
     /*  503018 */     GIR_EraseRootFromParent_Done,
     /*  503019 */   // Label 8387: @503019
     /*  503019 */   GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(503087), // Rule ID 62040 //
     /*  503024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503056 */     // MIs[0] policy
     /*  503056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503083 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503085 */     GIR_RootConstrainSelectedInstOperands,
     /*  503086 */     // GIR_Coverage, 62040,
     /*  503086 */     GIR_EraseRootFromParent_Done,
     /*  503087 */   // Label 8388: @503087
     /*  503087 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(503155), // Rule ID 62041 //
     /*  503092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503124 */     // MIs[0] policy
     /*  503124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M1),
     /*  503137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503151 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503153 */     GIR_RootConstrainSelectedInstOperands,
     /*  503154 */     // GIR_Coverage, 62041,
     /*  503154 */     GIR_EraseRootFromParent_Done,
     /*  503155 */   // Label 8389: @503155
     /*  503155 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(503223), // Rule ID 62042 //
     /*  503160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503192 */     // MIs[0] policy
     /*  503192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503202 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503219 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503221 */     GIR_RootConstrainSelectedInstOperands,
     /*  503222 */     // GIR_Coverage, 62042,
     /*  503222 */     GIR_EraseRootFromParent_Done,
     /*  503223 */   // Label 8390: @503223
     /*  503223 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(503291), // Rule ID 62043 //
     /*  503228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503260 */     // MIs[0] policy
     /*  503260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503270 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M2),
     /*  503273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503287 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503289 */     GIR_RootConstrainSelectedInstOperands,
     /*  503290 */     // GIR_Coverage, 62043,
     /*  503290 */     GIR_EraseRootFromParent_Done,
     /*  503291 */   // Label 8391: @503291
     /*  503291 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(503359), // Rule ID 62044 //
     /*  503296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503328 */     // MIs[0] policy
     /*  503328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503355 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503357 */     GIR_RootConstrainSelectedInstOperands,
     /*  503358 */     // GIR_Coverage, 62044,
     /*  503358 */     GIR_EraseRootFromParent_Done,
     /*  503359 */   // Label 8392: @503359
     /*  503359 */   GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(503427), // Rule ID 62045 //
     /*  503364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  503375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  503378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503396 */     // MIs[0] policy
     /*  503396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11078:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M4_M4),
     /*  503409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503423 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503425 */     GIR_RootConstrainSelectedInstOperands,
     /*  503426 */     // GIR_Coverage, 62045,
     /*  503426 */     GIR_EraseRootFromParent_Done,
     /*  503427 */   // Label 8393: @503427
     /*  503427 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(503495), // Rule ID 62046 //
     /*  503432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503464 */     // MIs[0] policy
     /*  503464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503474 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  503477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503491 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503493 */     GIR_RootConstrainSelectedInstOperands,
     /*  503494 */     // GIR_Coverage, 62046,
     /*  503494 */     GIR_EraseRootFromParent_Done,
     /*  503495 */   // Label 8394: @503495
     /*  503495 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(503563), // Rule ID 62047 //
     /*  503500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503532 */     // MIs[0] policy
     /*  503532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503542 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_MF2),
     /*  503545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503559 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503561 */     GIR_RootConstrainSelectedInstOperands,
     /*  503562 */     // GIR_Coverage, 62047,
     /*  503562 */     GIR_EraseRootFromParent_Done,
     /*  503563 */   // Label 8395: @503563
     /*  503563 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(503631), // Rule ID 62048 //
     /*  503568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503600 */     // MIs[0] policy
     /*  503600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503610 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  503613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503627 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503629 */     GIR_RootConstrainSelectedInstOperands,
     /*  503630 */     // GIR_Coverage, 62048,
     /*  503630 */     GIR_EraseRootFromParent_Done,
     /*  503631 */   // Label 8396: @503631
     /*  503631 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(503699), // Rule ID 62049 //
     /*  503636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  503653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  503668 */     // MIs[0] policy
     /*  503668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M1),
     /*  503681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503695 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503697 */     GIR_RootConstrainSelectedInstOperands,
     /*  503698 */     // GIR_Coverage, 62049,
     /*  503698 */     GIR_EraseRootFromParent_Done,
     /*  503699 */   // Label 8397: @503699
     /*  503699 */   GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(503767), // Rule ID 62050 //
     /*  503704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503736 */     // MIs[0] policy
     /*  503736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  503749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503763 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503765 */     GIR_RootConstrainSelectedInstOperands,
     /*  503766 */     // GIR_Coverage, 62050,
     /*  503766 */     GIR_EraseRootFromParent_Done,
     /*  503767 */   // Label 8398: @503767
     /*  503767 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(503835), // Rule ID 62051 //
     /*  503772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  503789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  503804 */     // MIs[0] policy
     /*  503804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503814 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M2),
     /*  503817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503831 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503833 */     GIR_RootConstrainSelectedInstOperands,
     /*  503834 */     // GIR_Coverage, 62051,
     /*  503834 */     GIR_EraseRootFromParent_Done,
     /*  503835 */   // Label 8399: @503835
     /*  503835 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(503903), // Rule ID 62052 //
     /*  503840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503872 */     // MIs[0] policy
     /*  503872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503882 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  503882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  503885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503899 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503901 */     GIR_RootConstrainSelectedInstOperands,
     /*  503902 */     // GIR_Coverage, 62052,
     /*  503902 */     GIR_EraseRootFromParent_Done,
     /*  503903 */   // Label 8400: @503903
     /*  503903 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(503971), // Rule ID 62053 //
     /*  503908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  503911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesdm_vs),
     /*  503916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  503919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  503922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  503925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  503928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  503936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  503940 */     // MIs[0] policy
     /*  503940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  503943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  503950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11078:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESDM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  503950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESDM_VS_M8_M4),
     /*  503953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  503955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  503957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  503959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  503964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  503967 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  503969 */     GIR_RootConstrainSelectedInstOperands,
     /*  503970 */     // GIR_Coverage, 62053,
     /*  503970 */     GIR_EraseRootFromParent_Done,
     /*  503971 */   // Label 8401: @503971
     /*  503971 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(504039), // Rule ID 62054 //
     /*  503976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  503979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  503984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  503987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  503990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  503993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  503996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504008 */     // MIs[0] policy
     /*  504008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504018 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504035 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504037 */     GIR_RootConstrainSelectedInstOperands,
     /*  504038 */     // GIR_Coverage, 62054,
     /*  504038 */     GIR_EraseRootFromParent_Done,
     /*  504039 */   // Label 8402: @504039
     /*  504039 */   GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(504107), // Rule ID 62055 //
     /*  504044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504076 */     // MIs[0] policy
     /*  504076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_MF2),
     /*  504089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504103 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504105 */     GIR_RootConstrainSelectedInstOperands,
     /*  504106 */     // GIR_Coverage, 62055,
     /*  504106 */     GIR_EraseRootFromParent_Done,
     /*  504107 */   // Label 8403: @504107
     /*  504107 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(504175), // Rule ID 62056 //
     /*  504112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504144 */     // MIs[0] policy
     /*  504144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504171 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504173 */     GIR_RootConstrainSelectedInstOperands,
     /*  504174 */     // GIR_Coverage, 62056,
     /*  504174 */     GIR_EraseRootFromParent_Done,
     /*  504175 */   // Label 8404: @504175
     /*  504175 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(504243), // Rule ID 62057 //
     /*  504180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504212 */     // MIs[0] policy
     /*  504212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504222 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11081:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M1),
     /*  504225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504239 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504241 */     GIR_RootConstrainSelectedInstOperands,
     /*  504242 */     // GIR_Coverage, 62057,
     /*  504242 */     GIR_EraseRootFromParent_Done,
     /*  504243 */   // Label 8405: @504243
     /*  504243 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(504311), // Rule ID 62058 //
     /*  504248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504280 */     // MIs[0] policy
     /*  504280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504307 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504309 */     GIR_RootConstrainSelectedInstOperands,
     /*  504310 */     // GIR_Coverage, 62058,
     /*  504310 */     GIR_EraseRootFromParent_Done,
     /*  504311 */   // Label 8406: @504311
     /*  504311 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(504379), // Rule ID 62059 //
     /*  504316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  504327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  504330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  504333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  504348 */     // MIs[0] policy
     /*  504348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504358 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11081:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M2),
     /*  504361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504375 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504377 */     GIR_RootConstrainSelectedInstOperands,
     /*  504378 */     // GIR_Coverage, 62059,
     /*  504378 */     GIR_EraseRootFromParent_Done,
     /*  504379 */   // Label 8407: @504379
     /*  504379 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(504447), // Rule ID 62060 //
     /*  504384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504416 */     // MIs[0] policy
     /*  504416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504426 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  504429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504443 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504445 */     GIR_RootConstrainSelectedInstOperands,
     /*  504446 */     // GIR_Coverage, 62060,
     /*  504446 */     GIR_EraseRootFromParent_Done,
     /*  504447 */   // Label 8408: @504447
     /*  504447 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(504515), // Rule ID 62061 //
     /*  504452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  504463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  504466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  504469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  504484 */     // MIs[0] policy
     /*  504484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11081:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M4),
     /*  504497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504511 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504513 */     GIR_RootConstrainSelectedInstOperands,
     /*  504514 */     // GIR_Coverage, 62061,
     /*  504514 */     GIR_EraseRootFromParent_Done,
     /*  504515 */   // Label 8409: @504515
     /*  504515 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(504583), // Rule ID 62062 //
     /*  504520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  504537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504552 */     // MIs[0] policy
     /*  504552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  504565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504579 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504581 */     GIR_RootConstrainSelectedInstOperands,
     /*  504582 */     // GIR_Coverage, 62062,
     /*  504582 */     GIR_EraseRootFromParent_Done,
     /*  504583 */   // Label 8410: @504583
     /*  504583 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(504651), // Rule ID 62063 //
     /*  504588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vv),
     /*  504596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  504599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  504602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  504605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  504620 */     // MIs[0] policy
     /*  504620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11081:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VV_M8),
     /*  504633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504647 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504649 */     GIR_RootConstrainSelectedInstOperands,
     /*  504650 */     // GIR_Coverage, 62063,
     /*  504650 */     GIR_EraseRootFromParent_Done,
     /*  504651 */   // Label 8411: @504651
     /*  504651 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(504719), // Rule ID 62064 //
     /*  504656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  504664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504688 */     // MIs[0] policy
     /*  504688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504698 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  504701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504715 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504717 */     GIR_RootConstrainSelectedInstOperands,
     /*  504718 */     // GIR_Coverage, 62064,
     /*  504718 */     GIR_EraseRootFromParent_Done,
     /*  504719 */   // Label 8412: @504719
     /*  504719 */   GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(504787), // Rule ID 62065 //
     /*  504724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  504732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  504735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  504738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504756 */     // MIs[0] policy
     /*  504756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_MF2_MF2),
     /*  504769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504783 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504785 */     GIR_RootConstrainSelectedInstOperands,
     /*  504786 */     // GIR_Coverage, 62065,
     /*  504786 */     GIR_EraseRootFromParent_Done,
     /*  504787 */   // Label 8413: @504787
     /*  504787 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(504855), // Rule ID 62066 //
     /*  504792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  504800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504824 */     // MIs[0] policy
     /*  504824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504834 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  504837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504851 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504853 */     GIR_RootConstrainSelectedInstOperands,
     /*  504854 */     // GIR_Coverage, 62066,
     /*  504854 */     GIR_EraseRootFromParent_Done,
     /*  504855 */   // Label 8414: @504855
     /*  504855 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(504923), // Rule ID 62067 //
     /*  504860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  504868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  504877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  504880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504892 */     // MIs[0] policy
     /*  504892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504902 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  504902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_MF2),
     /*  504905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504919 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504921 */     GIR_RootConstrainSelectedInstOperands,
     /*  504922 */     // GIR_Coverage, 62067,
     /*  504922 */     GIR_EraseRootFromParent_Done,
     /*  504923 */   // Label 8415: @504923
     /*  504923 */   GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(504991), // Rule ID 62068 //
     /*  504928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  504931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  504936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  504939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  504942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  504945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  504948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  504960 */     // MIs[0] policy
     /*  504960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  504963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  504970 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  504970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  504973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  504975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  504977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  504979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  504984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  504987 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  504989 */     GIR_RootConstrainSelectedInstOperands,
     /*  504990 */     // GIR_Coverage, 62068,
     /*  504990 */     GIR_EraseRootFromParent_Done,
     /*  504991 */   // Label 8416: @504991
     /*  504991 */   GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(505059), // Rule ID 62069 //
     /*  504996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  504999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  505007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  505010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505028 */     // MIs[0] policy
     /*  505028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11080:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M1_M1),
     /*  505041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505055 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505057 */     GIR_RootConstrainSelectedInstOperands,
     /*  505058 */     // GIR_Coverage, 62069,
     /*  505058 */     GIR_EraseRootFromParent_Done,
     /*  505059 */   // Label 8417: @505059
     /*  505059 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(505127), // Rule ID 62070 //
     /*  505064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505096 */     // MIs[0] policy
     /*  505096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505123 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505125 */     GIR_RootConstrainSelectedInstOperands,
     /*  505126 */     // GIR_Coverage, 62070,
     /*  505126 */     GIR_EraseRootFromParent_Done,
     /*  505127 */   // Label 8418: @505127
     /*  505127 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(505195), // Rule ID 62071 //
     /*  505132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505164 */     // MIs[0] policy
     /*  505164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_MF2),
     /*  505177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505191 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505193 */     GIR_RootConstrainSelectedInstOperands,
     /*  505194 */     // GIR_Coverage, 62071,
     /*  505194 */     GIR_EraseRootFromParent_Done,
     /*  505195 */   // Label 8419: @505195
     /*  505195 */   GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(505263), // Rule ID 62072 //
     /*  505200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505232 */     // MIs[0] policy
     /*  505232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505259 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505261 */     GIR_RootConstrainSelectedInstOperands,
     /*  505262 */     // GIR_Coverage, 62072,
     /*  505262 */     GIR_EraseRootFromParent_Done,
     /*  505263 */   // Label 8420: @505263
     /*  505263 */   GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(505331), // Rule ID 62073 //
     /*  505268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505300 */     // MIs[0] policy
     /*  505300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505310 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M1),
     /*  505313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505327 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505329 */     GIR_RootConstrainSelectedInstOperands,
     /*  505330 */     // GIR_Coverage, 62073,
     /*  505330 */     GIR_EraseRootFromParent_Done,
     /*  505331 */   // Label 8421: @505331
     /*  505331 */   GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(505399), // Rule ID 62074 //
     /*  505336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505368 */     // MIs[0] policy
     /*  505368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505395 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505397 */     GIR_RootConstrainSelectedInstOperands,
     /*  505398 */     // GIR_Coverage, 62074,
     /*  505398 */     GIR_EraseRootFromParent_Done,
     /*  505399 */   // Label 8422: @505399
     /*  505399 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(505467), // Rule ID 62075 //
     /*  505404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  505415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  505418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505436 */     // MIs[0] policy
     /*  505436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11080:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M2_M2),
     /*  505449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505463 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505465 */     GIR_RootConstrainSelectedInstOperands,
     /*  505466 */     // GIR_Coverage, 62075,
     /*  505466 */     GIR_EraseRootFromParent_Done,
     /*  505467 */   // Label 8423: @505467
     /*  505467 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(505535), // Rule ID 62076 //
     /*  505472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505504 */     // MIs[0] policy
     /*  505504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  505517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505531 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505533 */     GIR_RootConstrainSelectedInstOperands,
     /*  505534 */     // GIR_Coverage, 62076,
     /*  505534 */     GIR_EraseRootFromParent_Done,
     /*  505535 */   // Label 8424: @505535
     /*  505535 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(505603), // Rule ID 62077 //
     /*  505540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  505557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505572 */     // MIs[0] policy
     /*  505572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505582 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_MF2),
     /*  505585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505599 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505601 */     GIR_RootConstrainSelectedInstOperands,
     /*  505602 */     // GIR_Coverage, 62077,
     /*  505602 */     GIR_EraseRootFromParent_Done,
     /*  505603 */   // Label 8425: @505603
     /*  505603 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(505671), // Rule ID 62078 //
     /*  505608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505640 */     // MIs[0] policy
     /*  505640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  505653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505667 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505669 */     GIR_RootConstrainSelectedInstOperands,
     /*  505670 */     // GIR_Coverage, 62078,
     /*  505670 */     GIR_EraseRootFromParent_Done,
     /*  505671 */   // Label 8426: @505671
     /*  505671 */   GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(505739), // Rule ID 62079 //
     /*  505676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  505693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  505708 */     // MIs[0] policy
     /*  505708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M1),
     /*  505721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505735 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505737 */     GIR_RootConstrainSelectedInstOperands,
     /*  505738 */     // GIR_Coverage, 62079,
     /*  505738 */     GIR_EraseRootFromParent_Done,
     /*  505739 */   // Label 8427: @505739
     /*  505739 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(505807), // Rule ID 62080 //
     /*  505744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505776 */     // MIs[0] policy
     /*  505776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  505789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505803 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505805 */     GIR_RootConstrainSelectedInstOperands,
     /*  505806 */     // GIR_Coverage, 62080,
     /*  505806 */     GIR_EraseRootFromParent_Done,
     /*  505807 */   // Label 8428: @505807
     /*  505807 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(505875), // Rule ID 62081 //
     /*  505812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  505829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  505844 */     // MIs[0] policy
     /*  505844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M2),
     /*  505857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505871 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505873 */     GIR_RootConstrainSelectedInstOperands,
     /*  505874 */     // GIR_Coverage, 62081,
     /*  505874 */     GIR_EraseRootFromParent_Done,
     /*  505875 */   // Label 8429: @505875
     /*  505875 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(505943), // Rule ID 62082 //
     /*  505880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  505883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  505900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505912 */     // MIs[0] policy
     /*  505912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505922 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  505922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  505925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  505936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  505939 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  505941 */     GIR_RootConstrainSelectedInstOperands,
     /*  505942 */     // GIR_Coverage, 62082,
     /*  505942 */     GIR_EraseRootFromParent_Done,
     /*  505943 */   // Label 8430: @505943
     /*  505943 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(506011), // Rule ID 62083 //
     /*  505948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  505951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  505956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  505959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  505962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  505965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  505968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  505980 */     // MIs[0] policy
     /*  505980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  505983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  505990 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11080:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  505990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M4_M4),
     /*  505993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  505995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  505997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  505999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506007 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506009 */     GIR_RootConstrainSelectedInstOperands,
     /*  506010 */     // GIR_Coverage, 62083,
     /*  506010 */     GIR_EraseRootFromParent_Done,
     /*  506011 */   // Label 8431: @506011
     /*  506011 */   GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(506079), // Rule ID 62084 //
     /*  506016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506048 */     // MIs[0] policy
     /*  506048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506075 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506077 */     GIR_RootConstrainSelectedInstOperands,
     /*  506078 */     // GIR_Coverage, 62084,
     /*  506078 */     GIR_EraseRootFromParent_Done,
     /*  506079 */   // Label 8432: @506079
     /*  506079 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(506147), // Rule ID 62085 //
     /*  506084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506116 */     // MIs[0] policy
     /*  506116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506126 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_MF2),
     /*  506129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506143 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506145 */     GIR_RootConstrainSelectedInstOperands,
     /*  506146 */     // GIR_Coverage, 62085,
     /*  506146 */     GIR_EraseRootFromParent_Done,
     /*  506147 */   // Label 8433: @506147
     /*  506147 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(506215), // Rule ID 62086 //
     /*  506152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506184 */     // MIs[0] policy
     /*  506184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506211 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506213 */     GIR_RootConstrainSelectedInstOperands,
     /*  506214 */     // GIR_Coverage, 62086,
     /*  506214 */     GIR_EraseRootFromParent_Done,
     /*  506215 */   // Label 8434: @506215
     /*  506215 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(506283), // Rule ID 62087 //
     /*  506220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506252 */     // MIs[0] policy
     /*  506252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M1),
     /*  506265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506279 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506281 */     GIR_RootConstrainSelectedInstOperands,
     /*  506282 */     // GIR_Coverage, 62087,
     /*  506282 */     GIR_EraseRootFromParent_Done,
     /*  506283 */   // Label 8435: @506283
     /*  506283 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(506351), // Rule ID 62088 //
     /*  506288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506320 */     // MIs[0] policy
     /*  506320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506330 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506347 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506349 */     GIR_RootConstrainSelectedInstOperands,
     /*  506350 */     // GIR_Coverage, 62088,
     /*  506350 */     GIR_EraseRootFromParent_Done,
     /*  506351 */   // Label 8436: @506351
     /*  506351 */   GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(506419), // Rule ID 62089 //
     /*  506356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506388 */     // MIs[0] policy
     /*  506388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M2),
     /*  506401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506415 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506417 */     GIR_RootConstrainSelectedInstOperands,
     /*  506418 */     // GIR_Coverage, 62089,
     /*  506418 */     GIR_EraseRootFromParent_Done,
     /*  506419 */   // Label 8437: @506419
     /*  506419 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(506487), // Rule ID 62090 //
     /*  506424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506456 */     // MIs[0] policy
     /*  506456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506466 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  506469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506483 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506485 */     GIR_RootConstrainSelectedInstOperands,
     /*  506486 */     // GIR_Coverage, 62090,
     /*  506486 */     GIR_EraseRootFromParent_Done,
     /*  506487 */   // Label 8438: @506487
     /*  506487 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(506555), // Rule ID 62091 //
     /*  506492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesef_vs),
     /*  506500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  506503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  506506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  506520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506524 */     // MIs[0] policy
     /*  506524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506534 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11080:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEF_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEF_VS_M8_M4),
     /*  506537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506551 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506553 */     GIR_RootConstrainSelectedInstOperands,
     /*  506554 */     // GIR_Coverage, 62091,
     /*  506554 */     GIR_EraseRootFromParent_Done,
     /*  506555 */   // Label 8439: @506555
     /*  506555 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(506623), // Rule ID 62092 //
     /*  506560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506592 */     // MIs[0] policy
     /*  506592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  506605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506619 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506621 */     GIR_RootConstrainSelectedInstOperands,
     /*  506622 */     // GIR_Coverage, 62092,
     /*  506622 */     GIR_EraseRootFromParent_Done,
     /*  506623 */   // Label 8440: @506623
     /*  506623 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(506691), // Rule ID 62093 //
     /*  506628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  506639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  506642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  506645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506660 */     // MIs[0] policy
     /*  506660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506670 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_MF2),
     /*  506673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506687 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506689 */     GIR_RootConstrainSelectedInstOperands,
     /*  506690 */     // GIR_Coverage, 62093,
     /*  506690 */     GIR_EraseRootFromParent_Done,
     /*  506691 */   // Label 8441: @506691
     /*  506691 */   GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(506759), // Rule ID 62094 //
     /*  506696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506728 */     // MIs[0] policy
     /*  506728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  506741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506755 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506757 */     GIR_RootConstrainSelectedInstOperands,
     /*  506758 */     // GIR_Coverage, 62094,
     /*  506758 */     GIR_EraseRootFromParent_Done,
     /*  506759 */   // Label 8442: @506759
     /*  506759 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(506827), // Rule ID 62095 //
     /*  506764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  506775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  506778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  506781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  506796 */     // MIs[0] policy
     /*  506796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506806 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11083:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M1),
     /*  506809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506823 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506825 */     GIR_RootConstrainSelectedInstOperands,
     /*  506826 */     // GIR_Coverage, 62095,
     /*  506826 */     GIR_EraseRootFromParent_Done,
     /*  506827 */   // Label 8443: @506827
     /*  506827 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(506895), // Rule ID 62096 //
     /*  506832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506864 */     // MIs[0] policy
     /*  506864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506874 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  506874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  506877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506891 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506893 */     GIR_RootConstrainSelectedInstOperands,
     /*  506894 */     // GIR_Coverage, 62096,
     /*  506894 */     GIR_EraseRootFromParent_Done,
     /*  506895 */   // Label 8444: @506895
     /*  506895 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(506963), // Rule ID 62097 //
     /*  506900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  506903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  506911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  506914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  506917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  506920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  506932 */     // MIs[0] policy
     /*  506932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  506935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  506942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11083:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  506942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M2),
     /*  506945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  506947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  506949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  506951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  506956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  506959 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  506961 */     GIR_RootConstrainSelectedInstOperands,
     /*  506962 */     // GIR_Coverage, 62097,
     /*  506962 */     GIR_EraseRootFromParent_Done,
     /*  506963 */   // Label 8445: @506963
     /*  506963 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(507031), // Rule ID 62098 //
     /*  506968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  506971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  506976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  506979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  506982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  506985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  506988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  506996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507000 */     // MIs[0] policy
     /*  507000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507010 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507027 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507029 */     GIR_RootConstrainSelectedInstOperands,
     /*  507030 */     // GIR_Coverage, 62098,
     /*  507030 */     GIR_EraseRootFromParent_Done,
     /*  507031 */   // Label 8446: @507031
     /*  507031 */   GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(507099), // Rule ID 62099 //
     /*  507036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  507047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  507050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  507053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  507068 */     // MIs[0] policy
     /*  507068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11083:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M4),
     /*  507081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507095 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507097 */     GIR_RootConstrainSelectedInstOperands,
     /*  507098 */     // GIR_Coverage, 62099,
     /*  507098 */     GIR_EraseRootFromParent_Done,
     /*  507099 */   // Label 8447: @507099
     /*  507099 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(507167), // Rule ID 62100 //
     /*  507104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507136 */     // MIs[0] policy
     /*  507136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507163 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507165 */     GIR_RootConstrainSelectedInstOperands,
     /*  507166 */     // GIR_Coverage, 62100,
     /*  507166 */     GIR_EraseRootFromParent_Done,
     /*  507167 */   // Label 8448: @507167
     /*  507167 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(507235), // Rule ID 62101 //
     /*  507172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vv),
     /*  507180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  507183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  507186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  507189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  507204 */     // MIs[0] policy
     /*  507204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11083:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VV_M8),
     /*  507217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507231 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507233 */     GIR_RootConstrainSelectedInstOperands,
     /*  507234 */     // GIR_Coverage, 62101,
     /*  507234 */     GIR_EraseRootFromParent_Done,
     /*  507235 */   // Label 8449: @507235
     /*  507235 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(507303), // Rule ID 62102 //
     /*  507240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507272 */     // MIs[0] policy
     /*  507272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507282 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507299 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507301 */     GIR_RootConstrainSelectedInstOperands,
     /*  507302 */     // GIR_Coverage, 62102,
     /*  507302 */     GIR_EraseRootFromParent_Done,
     /*  507303 */   // Label 8450: @507303
     /*  507303 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(507371), // Rule ID 62103 //
     /*  507308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  507319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  507322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507340 */     // MIs[0] policy
     /*  507340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_MF2_MF2),
     /*  507353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507367 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507369 */     GIR_RootConstrainSelectedInstOperands,
     /*  507370 */     // GIR_Coverage, 62103,
     /*  507370 */     GIR_EraseRootFromParent_Done,
     /*  507371 */   // Label 8451: @507371
     /*  507371 */   GIM_Try, /*On fail goto*//*Label 8452*/ GIMT_Encode4(507439), // Rule ID 62104 //
     /*  507376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507408 */     // MIs[0] policy
     /*  507408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  507421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507435 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507437 */     GIR_RootConstrainSelectedInstOperands,
     /*  507438 */     // GIR_Coverage, 62104,
     /*  507438 */     GIR_EraseRootFromParent_Done,
     /*  507439 */   // Label 8452: @507439
     /*  507439 */   GIM_Try, /*On fail goto*//*Label 8453*/ GIMT_Encode4(507507), // Rule ID 62105 //
     /*  507444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507476 */     // MIs[0] policy
     /*  507476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507486 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_MF2),
     /*  507489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507503 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507505 */     GIR_RootConstrainSelectedInstOperands,
     /*  507506 */     // GIR_Coverage, 62105,
     /*  507506 */     GIR_EraseRootFromParent_Done,
     /*  507507 */   // Label 8453: @507507
     /*  507507 */   GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(507575), // Rule ID 62106 //
     /*  507512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507544 */     // MIs[0] policy
     /*  507544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  507557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507571 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507573 */     GIR_RootConstrainSelectedInstOperands,
     /*  507574 */     // GIR_Coverage, 62106,
     /*  507574 */     GIR_EraseRootFromParent_Done,
     /*  507575 */   // Label 8454: @507575
     /*  507575 */   GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(507643), // Rule ID 62107 //
     /*  507580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  507591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  507594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507612 */     // MIs[0] policy
     /*  507612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11082:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M1_M1),
     /*  507625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507639 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507641 */     GIR_RootConstrainSelectedInstOperands,
     /*  507642 */     // GIR_Coverage, 62107,
     /*  507642 */     GIR_EraseRootFromParent_Done,
     /*  507643 */   // Label 8455: @507643
     /*  507643 */   GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(507711), // Rule ID 62108 //
     /*  507648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507680 */     // MIs[0] policy
     /*  507680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  507693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507707 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507709 */     GIR_RootConstrainSelectedInstOperands,
     /*  507710 */     // GIR_Coverage, 62108,
     /*  507710 */     GIR_EraseRootFromParent_Done,
     /*  507711 */   // Label 8456: @507711
     /*  507711 */   GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(507779), // Rule ID 62109 //
     /*  507716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  507733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507748 */     // MIs[0] policy
     /*  507748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_MF2),
     /*  507761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507775 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507777 */     GIR_RootConstrainSelectedInstOperands,
     /*  507778 */     // GIR_Coverage, 62109,
     /*  507778 */     GIR_EraseRootFromParent_Done,
     /*  507779 */   // Label 8457: @507779
     /*  507779 */   GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(507847), // Rule ID 62110 //
     /*  507784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507816 */     // MIs[0] policy
     /*  507816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507826 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  507829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507843 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507845 */     GIR_RootConstrainSelectedInstOperands,
     /*  507846 */     // GIR_Coverage, 62110,
     /*  507846 */     GIR_EraseRootFromParent_Done,
     /*  507847 */   // Label 8458: @507847
     /*  507847 */   GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(507915), // Rule ID 62111 //
     /*  507852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  507869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  507872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  507884 */     // MIs[0] policy
     /*  507884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  507894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M1),
     /*  507897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507911 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507913 */     GIR_RootConstrainSelectedInstOperands,
     /*  507914 */     // GIR_Coverage, 62111,
     /*  507914 */     GIR_EraseRootFromParent_Done,
     /*  507915 */   // Label 8459: @507915
     /*  507915 */   GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(507983), // Rule ID 62112 //
     /*  507920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  507923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  507934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  507937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  507940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  507952 */     // MIs[0] policy
     /*  507952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  507955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  507962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  507962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  507965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  507967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  507969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  507971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  507976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  507979 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  507981 */     GIR_RootConstrainSelectedInstOperands,
     /*  507982 */     // GIR_Coverage, 62112,
     /*  507982 */     GIR_EraseRootFromParent_Done,
     /*  507983 */   // Label 8460: @507983
     /*  507983 */   GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(508051), // Rule ID 62113 //
     /*  507988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  507991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  507996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  507999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  508002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508020 */     // MIs[0] policy
     /*  508020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508030 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11082:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M2_M2),
     /*  508033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508047 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508049 */     GIR_RootConstrainSelectedInstOperands,
     /*  508050 */     // GIR_Coverage, 62113,
     /*  508050 */     GIR_EraseRootFromParent_Done,
     /*  508051 */   // Label 8461: @508051
     /*  508051 */   GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(508119), // Rule ID 62114 //
     /*  508056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508088 */     // MIs[0] policy
     /*  508088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508098 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508115 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508117 */     GIR_RootConstrainSelectedInstOperands,
     /*  508118 */     // GIR_Coverage, 62114,
     /*  508118 */     GIR_EraseRootFromParent_Done,
     /*  508119 */   // Label 8462: @508119
     /*  508119 */   GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(508187), // Rule ID 62115 //
     /*  508124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508156 */     // MIs[0] policy
     /*  508156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_MF2),
     /*  508169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508183 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508185 */     GIR_RootConstrainSelectedInstOperands,
     /*  508186 */     // GIR_Coverage, 62115,
     /*  508186 */     GIR_EraseRootFromParent_Done,
     /*  508187 */   // Label 8463: @508187
     /*  508187 */   GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(508255), // Rule ID 62116 //
     /*  508192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508224 */     // MIs[0] policy
     /*  508224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508251 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508253 */     GIR_RootConstrainSelectedInstOperands,
     /*  508254 */     // GIR_Coverage, 62116,
     /*  508254 */     GIR_EraseRootFromParent_Done,
     /*  508255 */   // Label 8464: @508255
     /*  508255 */   GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(508323), // Rule ID 62117 //
     /*  508260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508292 */     // MIs[0] policy
     /*  508292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M1),
     /*  508305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508319 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508321 */     GIR_RootConstrainSelectedInstOperands,
     /*  508322 */     // GIR_Coverage, 62117,
     /*  508322 */     GIR_EraseRootFromParent_Done,
     /*  508323 */   // Label 8465: @508323
     /*  508323 */   GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(508391), // Rule ID 62118 //
     /*  508328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508360 */     // MIs[0] policy
     /*  508360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508370 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508387 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508389 */     GIR_RootConstrainSelectedInstOperands,
     /*  508390 */     // GIR_Coverage, 62118,
     /*  508390 */     GIR_EraseRootFromParent_Done,
     /*  508391 */   // Label 8466: @508391
     /*  508391 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(508459), // Rule ID 62119 //
     /*  508396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508428 */     // MIs[0] policy
     /*  508428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M2),
     /*  508441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508455 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508457 */     GIR_RootConstrainSelectedInstOperands,
     /*  508458 */     // GIR_Coverage, 62119,
     /*  508458 */     GIR_EraseRootFromParent_Done,
     /*  508459 */   // Label 8467: @508459
     /*  508459 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(508527), // Rule ID 62120 //
     /*  508464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508496 */     // MIs[0] policy
     /*  508496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  508509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508523 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508525 */     GIR_RootConstrainSelectedInstOperands,
     /*  508526 */     // GIR_Coverage, 62120,
     /*  508526 */     GIR_EraseRootFromParent_Done,
     /*  508527 */   // Label 8468: @508527
     /*  508527 */   GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(508595), // Rule ID 62121 //
     /*  508532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  508543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  508546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  508549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  508564 */     // MIs[0] policy
     /*  508564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11082:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M4_M4),
     /*  508577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508591 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508593 */     GIR_RootConstrainSelectedInstOperands,
     /*  508594 */     // GIR_Coverage, 62121,
     /*  508594 */     GIR_EraseRootFromParent_Done,
     /*  508595 */   // Label 8469: @508595
     /*  508595 */   GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(508663), // Rule ID 62122 //
     /*  508600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508632 */     // MIs[0] policy
     /*  508632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  508645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508659 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508661 */     GIR_RootConstrainSelectedInstOperands,
     /*  508662 */     // GIR_Coverage, 62122,
     /*  508662 */     GIR_EraseRootFromParent_Done,
     /*  508663 */   // Label 8470: @508663
     /*  508663 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(508731), // Rule ID 62123 //
     /*  508668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  508685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508700 */     // MIs[0] policy
     /*  508700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_MF2),
     /*  508713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508727 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508729 */     GIR_RootConstrainSelectedInstOperands,
     /*  508730 */     // GIR_Coverage, 62123,
     /*  508730 */     GIR_EraseRootFromParent_Done,
     /*  508731 */   // Label 8471: @508731
     /*  508731 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(508799), // Rule ID 62124 //
     /*  508736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508768 */     // MIs[0] policy
     /*  508768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  508781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508795 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508797 */     GIR_RootConstrainSelectedInstOperands,
     /*  508798 */     // GIR_Coverage, 62124,
     /*  508798 */     GIR_EraseRootFromParent_Done,
     /*  508799 */   // Label 8472: @508799
     /*  508799 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(508867), // Rule ID 62125 //
     /*  508804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  508821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  508836 */     // MIs[0] policy
     /*  508836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M1),
     /*  508849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508863 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508865 */     GIR_RootConstrainSelectedInstOperands,
     /*  508866 */     // GIR_Coverage, 62125,
     /*  508866 */     GIR_EraseRootFromParent_Done,
     /*  508867 */   // Label 8473: @508867
     /*  508867 */   GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(508935), // Rule ID 62126 //
     /*  508872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  508875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  508892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508904 */     // MIs[0] policy
     /*  508904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  508914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  508917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508931 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  508933 */     GIR_RootConstrainSelectedInstOperands,
     /*  508934 */     // GIR_Coverage, 62126,
     /*  508934 */     GIR_EraseRootFromParent_Done,
     /*  508935 */   // Label 8474: @508935
     /*  508935 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(509003), // Rule ID 62127 //
     /*  508940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  508943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  508948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  508951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  508954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  508957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  508960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  508968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  508972 */     // MIs[0] policy
     /*  508972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  508975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  508982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  508982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M2),
     /*  508985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  508987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  508989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  508991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  508996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  508999 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509001 */     GIR_RootConstrainSelectedInstOperands,
     /*  509002 */     // GIR_Coverage, 62127,
     /*  509002 */     GIR_EraseRootFromParent_Done,
     /*  509003 */   // Label 8475: @509003
     /*  509003 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(509071), // Rule ID 62128 //
     /*  509008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509040 */     // MIs[0] policy
     /*  509040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509067 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509069 */     GIR_RootConstrainSelectedInstOperands,
     /*  509070 */     // GIR_Coverage, 62128,
     /*  509070 */     GIR_EraseRootFromParent_Done,
     /*  509071 */   // Label 8476: @509071
     /*  509071 */   GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(509139), // Rule ID 62129 //
     /*  509076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesem_vs),
     /*  509084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  509087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  509090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  509093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  509104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509108 */     // MIs[0] policy
     /*  509108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509118 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11082:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESEM_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESEM_VS_M8_M4),
     /*  509121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509135 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509137 */     GIR_RootConstrainSelectedInstOperands,
     /*  509138 */     // GIR_Coverage, 62129,
     /*  509138 */     GIR_EraseRootFromParent_Done,
     /*  509139 */   // Label 8477: @509139
     /*  509139 */   GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(509207), // Rule ID 62146 //
     /*  509144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509176 */     // MIs[0] policy
     /*  509176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509203 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509205 */     GIR_RootConstrainSelectedInstOperands,
     /*  509206 */     // GIR_Coverage, 62146,
     /*  509206 */     GIR_EraseRootFromParent_Done,
     /*  509207 */   // Label 8478: @509207
     /*  509207 */   GIM_Try, /*On fail goto*//*Label 8479*/ GIMT_Encode4(509275), // Rule ID 62147 //
     /*  509212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  509223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  509226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509244 */     // MIs[0] policy
     /*  509244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_MF2_MF2),
     /*  509257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509271 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509273 */     GIR_RootConstrainSelectedInstOperands,
     /*  509274 */     // GIR_Coverage, 62147,
     /*  509274 */     GIR_EraseRootFromParent_Done,
     /*  509275 */   // Label 8479: @509275
     /*  509275 */   GIM_Try, /*On fail goto*//*Label 8480*/ GIMT_Encode4(509343), // Rule ID 62148 //
     /*  509280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509312 */     // MIs[0] policy
     /*  509312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509322 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509339 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509341 */     GIR_RootConstrainSelectedInstOperands,
     /*  509342 */     // GIR_Coverage, 62148,
     /*  509342 */     GIR_EraseRootFromParent_Done,
     /*  509343 */   // Label 8480: @509343
     /*  509343 */   GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(509411), // Rule ID 62149 //
     /*  509348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509380 */     // MIs[0] policy
     /*  509380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509390 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_MF2),
     /*  509393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509407 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509409 */     GIR_RootConstrainSelectedInstOperands,
     /*  509410 */     // GIR_Coverage, 62149,
     /*  509410 */     GIR_EraseRootFromParent_Done,
     /*  509411 */   // Label 8481: @509411
     /*  509411 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(509479), // Rule ID 62150 //
     /*  509416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509448 */     // MIs[0] policy
     /*  509448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  509461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509475 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509477 */     GIR_RootConstrainSelectedInstOperands,
     /*  509478 */     // GIR_Coverage, 62150,
     /*  509478 */     GIR_EraseRootFromParent_Done,
     /*  509479 */   // Label 8482: @509479
     /*  509479 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(509547), // Rule ID 62151 //
     /*  509484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  509495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  509498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509516 */     // MIs[0] policy
     /*  509516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509526 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11086:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M1_M1),
     /*  509529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509543 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509545 */     GIR_RootConstrainSelectedInstOperands,
     /*  509546 */     // GIR_Coverage, 62151,
     /*  509546 */     GIR_EraseRootFromParent_Done,
     /*  509547 */   // Label 8483: @509547
     /*  509547 */   GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(509615), // Rule ID 62152 //
     /*  509552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509584 */     // MIs[0] policy
     /*  509584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  509597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509611 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509613 */     GIR_RootConstrainSelectedInstOperands,
     /*  509614 */     // GIR_Coverage, 62152,
     /*  509614 */     GIR_EraseRootFromParent_Done,
     /*  509615 */   // Label 8484: @509615
     /*  509615 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(509683), // Rule ID 62153 //
     /*  509620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509652 */     // MIs[0] policy
     /*  509652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_MF2),
     /*  509665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509679 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509681 */     GIR_RootConstrainSelectedInstOperands,
     /*  509682 */     // GIR_Coverage, 62153,
     /*  509682 */     GIR_EraseRootFromParent_Done,
     /*  509683 */   // Label 8485: @509683
     /*  509683 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(509751), // Rule ID 62154 //
     /*  509688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509720 */     // MIs[0] policy
     /*  509720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  509733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509747 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509749 */     GIR_RootConstrainSelectedInstOperands,
     /*  509750 */     // GIR_Coverage, 62154,
     /*  509750 */     GIR_EraseRootFromParent_Done,
     /*  509751 */   // Label 8486: @509751
     /*  509751 */   GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(509819), // Rule ID 62155 //
     /*  509756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  509773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509788 */     // MIs[0] policy
     /*  509788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M1),
     /*  509801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509815 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509817 */     GIR_RootConstrainSelectedInstOperands,
     /*  509818 */     // GIR_Coverage, 62155,
     /*  509818 */     GIR_EraseRootFromParent_Done,
     /*  509819 */   // Label 8487: @509819
     /*  509819 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(509887), // Rule ID 62156 //
     /*  509824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509856 */     // MIs[0] policy
     /*  509856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  509866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  509869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509883 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509885 */     GIR_RootConstrainSelectedInstOperands,
     /*  509886 */     // GIR_Coverage, 62156,
     /*  509886 */     GIR_EraseRootFromParent_Done,
     /*  509887 */   // Label 8488: @509887
     /*  509887 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(509955), // Rule ID 62157 //
     /*  509892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  509895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  509903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  509906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  509909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  509912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  509924 */     // MIs[0] policy
     /*  509924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  509934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11086:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  509934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M2_M2),
     /*  509937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  509939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  509941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  509943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  509948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  509951 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  509953 */     GIR_RootConstrainSelectedInstOperands,
     /*  509954 */     // GIR_Coverage, 62157,
     /*  509954 */     GIR_EraseRootFromParent_Done,
     /*  509955 */   // Label 8489: @509955
     /*  509955 */   GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(510023), // Rule ID 62158 //
     /*  509960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  509963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  509968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  509971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  509974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  509977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  509980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  509988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  509992 */     // MIs[0] policy
     /*  509992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  509995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510002 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510019 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510021 */     GIR_RootConstrainSelectedInstOperands,
     /*  510022 */     // GIR_Coverage, 62158,
     /*  510022 */     GIR_EraseRootFromParent_Done,
     /*  510023 */   // Label 8490: @510023
     /*  510023 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(510091), // Rule ID 62159 //
     /*  510028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510060 */     // MIs[0] policy
     /*  510060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_MF2),
     /*  510073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510087 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510089 */     GIR_RootConstrainSelectedInstOperands,
     /*  510090 */     // GIR_Coverage, 62159,
     /*  510090 */     GIR_EraseRootFromParent_Done,
     /*  510091 */   // Label 8491: @510091
     /*  510091 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(510159), // Rule ID 62160 //
     /*  510096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510128 */     // MIs[0] policy
     /*  510128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510138 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510155 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510157 */     GIR_RootConstrainSelectedInstOperands,
     /*  510158 */     // GIR_Coverage, 62160,
     /*  510158 */     GIR_EraseRootFromParent_Done,
     /*  510159 */   // Label 8492: @510159
     /*  510159 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(510227), // Rule ID 62161 //
     /*  510164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510196 */     // MIs[0] policy
     /*  510196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M1),
     /*  510209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510223 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510225 */     GIR_RootConstrainSelectedInstOperands,
     /*  510226 */     // GIR_Coverage, 62161,
     /*  510226 */     GIR_EraseRootFromParent_Done,
     /*  510227 */   // Label 8493: @510227
     /*  510227 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(510295), // Rule ID 62162 //
     /*  510232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510264 */     // MIs[0] policy
     /*  510264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510291 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510293 */     GIR_RootConstrainSelectedInstOperands,
     /*  510294 */     // GIR_Coverage, 62162,
     /*  510294 */     GIR_EraseRootFromParent_Done,
     /*  510295 */   // Label 8494: @510295
     /*  510295 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(510363), // Rule ID 62163 //
     /*  510300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510332 */     // MIs[0] policy
     /*  510332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M2),
     /*  510345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510359 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510361 */     GIR_RootConstrainSelectedInstOperands,
     /*  510362 */     // GIR_Coverage, 62163,
     /*  510362 */     GIR_EraseRootFromParent_Done,
     /*  510363 */   // Label 8495: @510363
     /*  510363 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(510431), // Rule ID 62164 //
     /*  510368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510400 */     // MIs[0] policy
     /*  510400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510410 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  510413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510427 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510429 */     GIR_RootConstrainSelectedInstOperands,
     /*  510430 */     // GIR_Coverage, 62164,
     /*  510430 */     GIR_EraseRootFromParent_Done,
     /*  510431 */   // Label 8496: @510431
     /*  510431 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(510499), // Rule ID 62165 //
     /*  510436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  510447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  510450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510468 */     // MIs[0] policy
     /*  510468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11086:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M4_M4),
     /*  510481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510495 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510497 */     GIR_RootConstrainSelectedInstOperands,
     /*  510498 */     // GIR_Coverage, 62165,
     /*  510498 */     GIR_EraseRootFromParent_Done,
     /*  510499 */   // Label 8497: @510499
     /*  510499 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(510567), // Rule ID 62166 //
     /*  510504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510536 */     // MIs[0] policy
     /*  510536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510546 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  510549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510563 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510565 */     GIR_RootConstrainSelectedInstOperands,
     /*  510566 */     // GIR_Coverage, 62166,
     /*  510566 */     GIR_EraseRootFromParent_Done,
     /*  510567 */   // Label 8498: @510567
     /*  510567 */   GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(510635), // Rule ID 62167 //
     /*  510572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  510589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510604 */     // MIs[0] policy
     /*  510604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_MF2),
     /*  510617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510631 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510633 */     GIR_RootConstrainSelectedInstOperands,
     /*  510634 */     // GIR_Coverage, 62167,
     /*  510634 */     GIR_EraseRootFromParent_Done,
     /*  510635 */   // Label 8499: @510635
     /*  510635 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(510703), // Rule ID 62168 //
     /*  510640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510672 */     // MIs[0] policy
     /*  510672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510682 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  510685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510699 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510701 */     GIR_RootConstrainSelectedInstOperands,
     /*  510702 */     // GIR_Coverage, 62168,
     /*  510702 */     GIR_EraseRootFromParent_Done,
     /*  510703 */   // Label 8500: @510703
     /*  510703 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(510771), // Rule ID 62169 //
     /*  510708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  510725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  510740 */     // MIs[0] policy
     /*  510740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M1),
     /*  510753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510767 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510769 */     GIR_RootConstrainSelectedInstOperands,
     /*  510770 */     // GIR_Coverage, 62169,
     /*  510770 */     GIR_EraseRootFromParent_Done,
     /*  510771 */   // Label 8501: @510771
     /*  510771 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(510839), // Rule ID 62170 //
     /*  510776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510808 */     // MIs[0] policy
     /*  510808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  510821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510835 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510837 */     GIR_RootConstrainSelectedInstOperands,
     /*  510838 */     // GIR_Coverage, 62170,
     /*  510838 */     GIR_EraseRootFromParent_Done,
     /*  510839 */   // Label 8502: @510839
     /*  510839 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(510907), // Rule ID 62171 //
     /*  510844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  510861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  510864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  510876 */     // MIs[0] policy
     /*  510876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  510886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M2),
     /*  510889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510903 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510905 */     GIR_RootConstrainSelectedInstOperands,
     /*  510906 */     // GIR_Coverage, 62171,
     /*  510906 */     GIR_EraseRootFromParent_Done,
     /*  510907 */   // Label 8503: @510907
     /*  510907 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(510975), // Rule ID 62172 //
     /*  510912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  510915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  510932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  510940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  510944 */     // MIs[0] policy
     /*  510944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  510947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  510954 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  510954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  510957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  510959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  510961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  510963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  510968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  510971 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  510973 */     GIR_RootConstrainSelectedInstOperands,
     /*  510974 */     // GIR_Coverage, 62172,
     /*  510974 */     GIR_EraseRootFromParent_Done,
     /*  510975 */   // Label 8504: @510975
     /*  510975 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(511043), // Rule ID 62173 //
     /*  510980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  510983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaesz_vs),
     /*  510988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  510991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  510994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  510997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511012 */     // MIs[0] policy
     /*  511012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11086:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESZ_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESZ_VS_M8_M4),
     /*  511025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511039 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511041 */     GIR_RootConstrainSelectedInstOperands,
     /*  511042 */     // GIR_Coverage, 62173,
     /*  511042 */     GIR_EraseRootFromParent_Done,
     /*  511043 */   // Label 8505: @511043
     /*  511043 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(511111), // Rule ID 62268 //
     /*  511048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511080 */     // MIs[0] policy
     /*  511080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511090 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511107 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511109 */     GIR_RootConstrainSelectedInstOperands,
     /*  511110 */     // GIR_Coverage, 62268,
     /*  511110 */     GIR_EraseRootFromParent_Done,
     /*  511111 */   // Label 8506: @511111
     /*  511111 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(511179), // Rule ID 62269 //
     /*  511116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511148 */     // MIs[0] policy
     /*  511148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_MF2),
     /*  511161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511175 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511177 */     GIR_RootConstrainSelectedInstOperands,
     /*  511178 */     // GIR_Coverage, 62269,
     /*  511178 */     GIR_EraseRootFromParent_Done,
     /*  511179 */   // Label 8507: @511179
     /*  511179 */   GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(511247), // Rule ID 62270 //
     /*  511184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511216 */     // MIs[0] policy
     /*  511216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511243 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511245 */     GIR_RootConstrainSelectedInstOperands,
     /*  511246 */     // GIR_Coverage, 62270,
     /*  511246 */     GIR_EraseRootFromParent_Done,
     /*  511247 */   // Label 8508: @511247
     /*  511247 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(511315), // Rule ID 62271 //
     /*  511252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  511269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511284 */     // MIs[0] policy
     /*  511284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511294 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11491:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M1),
     /*  511297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511311 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511313 */     GIR_RootConstrainSelectedInstOperands,
     /*  511314 */     // GIR_Coverage, 62271,
     /*  511314 */     GIR_EraseRootFromParent_Done,
     /*  511315 */   // Label 8509: @511315
     /*  511315 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(511383), // Rule ID 62272 //
     /*  511320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511352 */     // MIs[0] policy
     /*  511352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511379 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511381 */     GIR_RootConstrainSelectedInstOperands,
     /*  511382 */     // GIR_Coverage, 62272,
     /*  511382 */     GIR_EraseRootFromParent_Done,
     /*  511383 */   // Label 8510: @511383
     /*  511383 */   GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(511451), // Rule ID 62273 //
     /*  511388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  511399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  511402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  511405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  511420 */     // MIs[0] policy
     /*  511420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11491:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M2),
     /*  511433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511447 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511449 */     GIR_RootConstrainSelectedInstOperands,
     /*  511450 */     // GIR_Coverage, 62273,
     /*  511450 */     GIR_EraseRootFromParent_Done,
     /*  511451 */   // Label 8511: @511451
     /*  511451 */   GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(511519), // Rule ID 62274 //
     /*  511456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511488 */     // MIs[0] policy
     /*  511488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511498 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  511501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511515 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511517 */     GIR_RootConstrainSelectedInstOperands,
     /*  511518 */     // GIR_Coverage, 62274,
     /*  511518 */     GIR_EraseRootFromParent_Done,
     /*  511519 */   // Label 8512: @511519
     /*  511519 */   GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(511587), // Rule ID 62275 //
     /*  511524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  511535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  511538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  511541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  511556 */     // MIs[0] policy
     /*  511556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511566 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11491:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M4),
     /*  511569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511583 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511585 */     GIR_RootConstrainSelectedInstOperands,
     /*  511586 */     // GIR_Coverage, 62275,
     /*  511586 */     GIR_EraseRootFromParent_Done,
     /*  511587 */   // Label 8513: @511587
     /*  511587 */   GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(511655), // Rule ID 62276 //
     /*  511592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511624 */     // MIs[0] policy
     /*  511624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  511637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511651 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511653 */     GIR_RootConstrainSelectedInstOperands,
     /*  511654 */     // GIR_Coverage, 62276,
     /*  511654 */     GIR_EraseRootFromParent_Done,
     /*  511655 */   // Label 8514: @511655
     /*  511655 */   GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(511723), // Rule ID 62277 //
     /*  511660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vv),
     /*  511668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  511671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  511674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  511677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  511692 */     // MIs[0] policy
     /*  511692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11491:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VV_M8),
     /*  511705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511719 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511721 */     GIR_RootConstrainSelectedInstOperands,
     /*  511722 */     // GIR_Coverage, 62277,
     /*  511722 */     GIR_EraseRootFromParent_Done,
     /*  511723 */   // Label 8515: @511723
     /*  511723 */   GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(511791), // Rule ID 62278 //
     /*  511728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  511736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511760 */     // MIs[0] policy
     /*  511760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511770 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  511773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511787 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511789 */     GIR_RootConstrainSelectedInstOperands,
     /*  511790 */     // GIR_Coverage, 62278,
     /*  511790 */     GIR_EraseRootFromParent_Done,
     /*  511791 */   // Label 8516: @511791
     /*  511791 */   GIM_Try, /*On fail goto*//*Label 8517*/ GIMT_Encode4(511859), // Rule ID 62279 //
     /*  511796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  511804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  511807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  511810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511828 */     // MIs[0] policy
     /*  511828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_MF2_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_MF2_MF2),
     /*  511841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511855 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511857 */     GIR_RootConstrainSelectedInstOperands,
     /*  511858 */     // GIR_Coverage, 62279,
     /*  511858 */     GIR_EraseRootFromParent_Done,
     /*  511859 */   // Label 8517: @511859
     /*  511859 */   GIM_Try, /*On fail goto*//*Label 8518*/ GIMT_Encode4(511927), // Rule ID 62280 //
     /*  511864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  511867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  511872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  511884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511896 */     // MIs[0] policy
     /*  511896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  511906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  511909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511923 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511925 */     GIR_RootConstrainSelectedInstOperands,
     /*  511926 */     // GIR_Coverage, 62280,
     /*  511926 */     GIR_EraseRootFromParent_Done,
     /*  511927 */   // Label 8518: @511927
     /*  511927 */   GIM_Try, /*On fail goto*//*Label 8519*/ GIMT_Encode4(511995), // Rule ID 62281 //
     /*  511932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  511935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  511940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  511943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  511946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  511949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  511952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  511964 */     // MIs[0] policy
     /*  511964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  511967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  511974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  511974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_MF2),
     /*  511977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  511979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  511981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  511983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  511988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  511991 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  511993 */     GIR_RootConstrainSelectedInstOperands,
     /*  511994 */     // GIR_Coverage, 62281,
     /*  511994 */     GIR_EraseRootFromParent_Done,
     /*  511995 */   // Label 8519: @511995
     /*  511995 */   GIM_Try, /*On fail goto*//*Label 8520*/ GIMT_Encode4(512063), // Rule ID 62282 //
     /*  512000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512032 */     // MIs[0] policy
     /*  512032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512059 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512061 */     GIR_RootConstrainSelectedInstOperands,
     /*  512062 */     // GIR_Coverage, 62282,
     /*  512062 */     GIR_EraseRootFromParent_Done,
     /*  512063 */   // Label 8520: @512063
     /*  512063 */   GIM_Try, /*On fail goto*//*Label 8521*/ GIMT_Encode4(512131), // Rule ID 62283 //
     /*  512068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  512079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  512082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512100 */     // MIs[0] policy
     /*  512100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512110 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11490:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M1_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M1_M1),
     /*  512113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512127 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512129 */     GIR_RootConstrainSelectedInstOperands,
     /*  512130 */     // GIR_Coverage, 62283,
     /*  512130 */     GIR_EraseRootFromParent_Done,
     /*  512131 */   // Label 8521: @512131
     /*  512131 */   GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(512199), // Rule ID 62284 //
     /*  512136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512168 */     // MIs[0] policy
     /*  512168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512178 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512195 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512197 */     GIR_RootConstrainSelectedInstOperands,
     /*  512198 */     // GIR_Coverage, 62284,
     /*  512198 */     GIR_EraseRootFromParent_Done,
     /*  512199 */   // Label 8522: @512199
     /*  512199 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(512267), // Rule ID 62285 //
     /*  512204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512236 */     // MIs[0] policy
     /*  512236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512246 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_MF2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_MF2),
     /*  512249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512263 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512265 */     GIR_RootConstrainSelectedInstOperands,
     /*  512266 */     // GIR_Coverage, 62285,
     /*  512266 */     GIR_EraseRootFromParent_Done,
     /*  512267 */   // Label 8523: @512267
     /*  512267 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(512335), // Rule ID 62286 //
     /*  512272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512304 */     // MIs[0] policy
     /*  512304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512314 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512331 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512333 */     GIR_RootConstrainSelectedInstOperands,
     /*  512334 */     // GIR_Coverage, 62286,
     /*  512334 */     GIR_EraseRootFromParent_Done,
     /*  512335 */   // Label 8524: @512335
     /*  512335 */   GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(512403), // Rule ID 62287 //
     /*  512340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512372 */     // MIs[0] policy
     /*  512372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M1),
     /*  512385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512399 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512401 */     GIR_RootConstrainSelectedInstOperands,
     /*  512402 */     // GIR_Coverage, 62287,
     /*  512402 */     GIR_EraseRootFromParent_Done,
     /*  512403 */   // Label 8525: @512403
     /*  512403 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(512471), // Rule ID 62288 //
     /*  512408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512440 */     // MIs[0] policy
     /*  512440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  512453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512467 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512469 */     GIR_RootConstrainSelectedInstOperands,
     /*  512470 */     // GIR_Coverage, 62288,
     /*  512470 */     GIR_EraseRootFromParent_Done,
     /*  512471 */   // Label 8526: @512471
     /*  512471 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(512539), // Rule ID 62289 //
     /*  512476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  512487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  512490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512508 */     // MIs[0] policy
     /*  512508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11490:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M2_M2),
     /*  512521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512535 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512537 */     GIR_RootConstrainSelectedInstOperands,
     /*  512538 */     // GIR_Coverage, 62289,
     /*  512538 */     GIR_EraseRootFromParent_Done,
     /*  512539 */   // Label 8527: @512539
     /*  512539 */   GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(512607), // Rule ID 62290 //
     /*  512544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512576 */     // MIs[0] policy
     /*  512576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  512589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512603 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512605 */     GIR_RootConstrainSelectedInstOperands,
     /*  512606 */     // GIR_Coverage, 62290,
     /*  512606 */     GIR_EraseRootFromParent_Done,
     /*  512607 */   // Label 8528: @512607
     /*  512607 */   GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(512675), // Rule ID 62291 //
     /*  512612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  512629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512644 */     // MIs[0] policy
     /*  512644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512654 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_MF2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_MF2),
     /*  512657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512671 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512673 */     GIR_RootConstrainSelectedInstOperands,
     /*  512674 */     // GIR_Coverage, 62291,
     /*  512674 */     GIR_EraseRootFromParent_Done,
     /*  512675 */   // Label 8529: @512675
     /*  512675 */   GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(512743), // Rule ID 62292 //
     /*  512680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512712 */     // MIs[0] policy
     /*  512712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512722 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  512725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512739 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512741 */     GIR_RootConstrainSelectedInstOperands,
     /*  512742 */     // GIR_Coverage, 62292,
     /*  512742 */     GIR_EraseRootFromParent_Done,
     /*  512743 */   // Label 8530: @512743
     /*  512743 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(512811), // Rule ID 62293 //
     /*  512748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  512765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  512780 */     // MIs[0] policy
     /*  512780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M1:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M1),
     /*  512793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512807 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512809 */     GIR_RootConstrainSelectedInstOperands,
     /*  512810 */     // GIR_Coverage, 62293,
     /*  512810 */     GIR_EraseRootFromParent_Done,
     /*  512811 */   // Label 8531: @512811
     /*  512811 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(512879), // Rule ID 62294 //
     /*  512816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512848 */     // MIs[0] policy
     /*  512848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512858 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  512861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512875 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512877 */     GIR_RootConstrainSelectedInstOperands,
     /*  512878 */     // GIR_Coverage, 62294,
     /*  512878 */     GIR_EraseRootFromParent_Done,
     /*  512879 */   // Label 8532: @512879
     /*  512879 */   GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(512947), // Rule ID 62295 //
     /*  512884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  512887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  512901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  512904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  512916 */     // MIs[0] policy
     /*  512916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  512926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M2),
     /*  512929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  512933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  512935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  512940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  512943 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  512945 */     GIR_RootConstrainSelectedInstOperands,
     /*  512946 */     // GIR_Coverage, 62295,
     /*  512946 */     GIR_EraseRootFromParent_Done,
     /*  512947 */   // Label 8533: @512947
     /*  512947 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(513015), // Rule ID 62296 //
     /*  512952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  512955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  512960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  512963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  512966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  512969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  512972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  512984 */     // MIs[0] policy
     /*  512984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  512987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  512994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  512994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  512997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  512999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513011 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513013 */     GIR_RootConstrainSelectedInstOperands,
     /*  513014 */     // GIR_Coverage, 62296,
     /*  513014 */     GIR_EraseRootFromParent_Done,
     /*  513015 */   // Label 8534: @513015
     /*  513015 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(513083), // Rule ID 62297 //
     /*  513020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  513031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  513034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513052 */     // MIs[0] policy
     /*  513052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11490:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M4_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M4_M4),
     /*  513065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513079 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513081 */     GIR_RootConstrainSelectedInstOperands,
     /*  513082 */     // GIR_Coverage, 62297,
     /*  513082 */     GIR_EraseRootFromParent_Done,
     /*  513083 */   // Label 8535: @513083
     /*  513083 */   GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(513151), // Rule ID 62298 //
     /*  513088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513120 */     // MIs[0] policy
     /*  513120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513147 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513149 */     GIR_RootConstrainSelectedInstOperands,
     /*  513150 */     // GIR_Coverage, 62298,
     /*  513150 */     GIR_EraseRootFromParent_Done,
     /*  513151 */   // Label 8536: @513151
     /*  513151 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(513219), // Rule ID 62299 //
     /*  513156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  513173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513188 */     // MIs[0] policy
     /*  513188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513198 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_MF2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_MF2),
     /*  513201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513215 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513217 */     GIR_RootConstrainSelectedInstOperands,
     /*  513218 */     // GIR_Coverage, 62299,
     /*  513218 */     GIR_EraseRootFromParent_Done,
     /*  513219 */   // Label 8537: @513219
     /*  513219 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(513287), // Rule ID 62300 //
     /*  513224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513256 */     // MIs[0] policy
     /*  513256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513283 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513285 */     GIR_RootConstrainSelectedInstOperands,
     /*  513286 */     // GIR_Coverage, 62300,
     /*  513286 */     GIR_EraseRootFromParent_Done,
     /*  513287 */   // Label 8538: @513287
     /*  513287 */   GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(513355), // Rule ID 62301 //
     /*  513292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  513309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513324 */     // MIs[0] policy
     /*  513324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M1:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M1),
     /*  513337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513351 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513353 */     GIR_RootConstrainSelectedInstOperands,
     /*  513354 */     // GIR_Coverage, 62301,
     /*  513354 */     GIR_EraseRootFromParent_Done,
     /*  513355 */   // Label 8539: @513355
     /*  513355 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(513423), // Rule ID 62302 //
     /*  513360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513392 */     // MIs[0] policy
     /*  513392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513419 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513421 */     GIR_RootConstrainSelectedInstOperands,
     /*  513422 */     // GIR_Coverage, 62302,
     /*  513422 */     GIR_EraseRootFromParent_Done,
     /*  513423 */   // Label 8540: @513423
     /*  513423 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(513491), // Rule ID 62303 //
     /*  513428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  513445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  513460 */     // MIs[0] policy
     /*  513460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513470 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M2:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M2),
     /*  513473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513487 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513489 */     GIR_RootConstrainSelectedInstOperands,
     /*  513490 */     // GIR_Coverage, 62303,
     /*  513490 */     GIR_EraseRootFromParent_Done,
     /*  513491 */   // Label 8541: @513491
     /*  513491 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(513559), // Rule ID 62304 //
     /*  513496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode0),
     /*  513499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  513516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513528 */     // MIs[0] policy
     /*  513528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  513538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  513541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513555 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513557 */     GIR_RootConstrainSelectedInstOperands,
     /*  513558 */     // GIR_Coverage, 62304,
     /*  513558 */     GIR_EraseRootFromParent_Done,
     /*  513559 */   // Label 8542: @513559
     /*  513559 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(513627), // Rule ID 62305 //
     /*  513564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksed_HwMode1),
     /*  513567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm4r_vs),
     /*  513572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  513575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  513578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  513581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  513584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  513592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  513596 */     // MIs[0] policy
     /*  513596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  513599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/4, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513606 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11490:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM4R_VS_M8_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  513606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM4R_VS_M8_M4),
     /*  513609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  513611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /*  513613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  513623 */     GIR_RootToRootCopy, /*OpIdx*/5, // policy
     /*  513625 */     GIR_RootConstrainSelectedInstOperands,
     /*  513626 */     // GIR_Coverage, 62305,
     /*  513626 */     GIR_EraseRootFromParent_Done,
     /*  513627 */   // Label 8543: @513627
     /*  513627 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(513698), // Rule ID 2596 //
     /*  513632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  513635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  513640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  513643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  513646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  513649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513664 */     // MIs[0] round
     /*  513664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  513667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513674 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  513674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  513677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  513681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513683 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  513685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  513696 */     GIR_RootConstrainSelectedInstOperands,
     /*  513697 */     // GIR_Coverage, 2596,
     /*  513697 */     GIR_EraseRootFromParent_Done,
     /*  513698 */   // Label 8544: @513698
     /*  513698 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(513769), // Rule ID 2597 //
     /*  513703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  513706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  513711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  513714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  513717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  513720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513735 */     // MIs[0] round
     /*  513735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  513738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513745 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  513745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /*  513748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  513752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513754 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  513756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  513767 */     GIR_RootConstrainSelectedInstOperands,
     /*  513768 */     // GIR_Coverage, 2597,
     /*  513768 */     GIR_EraseRootFromParent_Done,
     /*  513769 */   // Label 8545: @513769
     /*  513769 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(513840), // Rule ID 2632 //
     /*  513774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  513777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  513782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  513785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  513788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  513791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513806 */     // MIs[0] round
     /*  513806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  513809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513816 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  513816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  513819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  513823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513825 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  513827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  513838 */     GIR_RootConstrainSelectedInstOperands,
     /*  513839 */     // GIR_Coverage, 2632,
     /*  513839 */     GIR_EraseRootFromParent_Done,
     /*  513840 */   // Label 8546: @513840
     /*  513840 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(513911), // Rule ID 2633 //
     /*  513845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  513848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  513853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  513856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  513859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  513862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  513865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513877 */     // MIs[0] round
     /*  513877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  513880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513887 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  513887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4),
     /*  513890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  513894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513896 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  513898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  513909 */     GIR_RootConstrainSelectedInstOperands,
     /*  513910 */     // GIR_Coverage, 2633,
     /*  513910 */     GIR_EraseRootFromParent_Done,
     /*  513911 */   // Label 8547: @513911
     /*  513911 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(513982), // Rule ID 18882 //
     /*  513916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  513919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  513924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  513927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  513930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  513933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  513936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  513948 */     // MIs[0] round
     /*  513948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  513951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  513958 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  513958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  513961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  513963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  513965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  513967 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  513969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  513974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  513977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  513980 */     GIR_RootConstrainSelectedInstOperands,
     /*  513981 */     // GIR_Coverage, 18882,
     /*  513981 */     GIR_EraseRootFromParent_Done,
     /*  513982 */   // Label 8548: @513982
     /*  513982 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(514053), // Rule ID 18883 //
     /*  513987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  513990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  513995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  513998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  514001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  514004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514019 */     // MIs[0] round
     /*  514019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514029 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /*  514032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514038 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514051 */     GIR_RootConstrainSelectedInstOperands,
     /*  514052 */     // GIR_Coverage, 18883,
     /*  514052 */     GIR_EraseRootFromParent_Done,
     /*  514053 */   // Label 8549: @514053
     /*  514053 */   GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(514124), // Rule ID 18886 //
     /*  514058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514090 */     // MIs[0] round
     /*  514090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514100 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514109 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514122 */     GIR_RootConstrainSelectedInstOperands,
     /*  514123 */     // GIR_Coverage, 18886,
     /*  514123 */     GIR_EraseRootFromParent_Done,
     /*  514124 */   // Label 8550: @514124
     /*  514124 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(514195), // Rule ID 18887 //
     /*  514129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  514140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  514143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  514146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514161 */     // MIs[0] round
     /*  514161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514171 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /*  514174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514180 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514193 */     GIR_RootConstrainSelectedInstOperands,
     /*  514194 */     // GIR_Coverage, 18887,
     /*  514194 */     GIR_EraseRootFromParent_Done,
     /*  514195 */   // Label 8551: @514195
     /*  514195 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(514266), // Rule ID 18890 //
     /*  514200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514232 */     // MIs[0] round
     /*  514232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514242 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514251 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514264 */     GIR_RootConstrainSelectedInstOperands,
     /*  514265 */     // GIR_Coverage, 18890,
     /*  514265 */     GIR_EraseRootFromParent_Done,
     /*  514266 */   // Label 8552: @514266
     /*  514266 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(514337), // Rule ID 18891 //
     /*  514271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  514282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  514285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  514288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514303 */     // MIs[0] round
     /*  514303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514313 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11206:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /*  514316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514322 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514335 */     GIR_RootConstrainSelectedInstOperands,
     /*  514336 */     // GIR_Coverage, 18891,
     /*  514336 */     GIR_EraseRootFromParent_Done,
     /*  514337 */   // Label 8553: @514337
     /*  514337 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(514408), // Rule ID 18894 //
     /*  514342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  514345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514374 */     // MIs[0] round
     /*  514374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  514384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514393 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514406 */     GIR_RootConstrainSelectedInstOperands,
     /*  514407 */     // GIR_Coverage, 18894,
     /*  514407 */     GIR_EraseRootFromParent_Done,
     /*  514408 */   // Label 8554: @514408
     /*  514408 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(514479), // Rule ID 18895 //
     /*  514413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  514416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  514424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  514427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  514430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514445 */     // MIs[0] round
     /*  514445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514455 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11206:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  514455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /*  514458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514464 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  514474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514477 */     GIR_RootConstrainSelectedInstOperands,
     /*  514478 */     // GIR_Coverage, 18895,
     /*  514478 */     GIR_EraseRootFromParent_Done,
     /*  514479 */   // Label 8555: @514479
     /*  514479 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(514550), // Rule ID 18898 //
     /*  514484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  514487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  514495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  514498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  514501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514516 */     // MIs[0] round
     /*  514516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514526 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  514526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  514529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514535 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514548 */     GIR_RootConstrainSelectedInstOperands,
     /*  514549 */     // GIR_Coverage, 18898,
     /*  514549 */     GIR_EraseRootFromParent_Done,
     /*  514550 */   // Label 8556: @514550
     /*  514550 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(514621), // Rule ID 18899 //
     /*  514555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  514558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  514566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  514569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  514572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  514587 */     // MIs[0] round
     /*  514587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514597 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11206:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  514597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /*  514600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514606 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  514616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514619 */     GIR_RootConstrainSelectedInstOperands,
     /*  514620 */     // GIR_Coverage, 18899,
     /*  514620 */     GIR_EraseRootFromParent_Done,
     /*  514621 */   // Label 8557: @514621
     /*  514621 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(514692), // Rule ID 18902 //
     /*  514626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  514637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  514640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  514643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514658 */     // MIs[0] round
     /*  514658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514668 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  514671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514677 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514690 */     GIR_RootConstrainSelectedInstOperands,
     /*  514691 */     // GIR_Coverage, 18902,
     /*  514691 */     GIR_EraseRootFromParent_Done,
     /*  514692 */   // Label 8558: @514692
     /*  514692 */   GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(514763), // Rule ID 18903 //
     /*  514697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  514708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  514711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  514714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  514729 */     // MIs[0] round
     /*  514729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /*  514742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514748 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514761 */     GIR_RootConstrainSelectedInstOperands,
     /*  514762 */     // GIR_Coverage, 18903,
     /*  514762 */     GIR_EraseRootFromParent_Done,
     /*  514763 */   // Label 8559: @514763
     /*  514763 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(514834), // Rule ID 18906 //
     /*  514768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  514779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  514782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  514785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514800 */     // MIs[0] round
     /*  514800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514810 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  514813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514819 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514832 */     GIR_RootConstrainSelectedInstOperands,
     /*  514833 */     // GIR_Coverage, 18906,
     /*  514833 */     GIR_EraseRootFromParent_Done,
     /*  514834 */   // Label 8560: @514834
     /*  514834 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(514905), // Rule ID 18907 //
     /*  514839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  514850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  514853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  514856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  514859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  514871 */     // MIs[0] round
     /*  514871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514881 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  514881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /*  514884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514890 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514903 */     GIR_RootConstrainSelectedInstOperands,
     /*  514904 */     // GIR_Coverage, 18907,
     /*  514904 */     GIR_EraseRootFromParent_Done,
     /*  514905 */   // Label 8561: @514905
     /*  514905 */   GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(514976), // Rule ID 18910 //
     /*  514910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  514913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  514921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  514924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  514927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  514930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  514942 */     // MIs[0] round
     /*  514942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  514945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  514952 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  514952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  514955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  514957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  514959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  514961 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  514963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  514968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  514971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  514974 */     GIR_RootConstrainSelectedInstOperands,
     /*  514975 */     // GIR_Coverage, 18910,
     /*  514975 */     GIR_EraseRootFromParent_Done,
     /*  514976 */   // Label 8562: @514976
     /*  514976 */   GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(515047), // Rule ID 18911 //
     /*  514981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  514984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  514989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  514992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  514995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  514998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515013 */     // MIs[0] round
     /*  515013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515023 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  515023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /*  515026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515032 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515045 */     GIR_RootConstrainSelectedInstOperands,
     /*  515046 */     // GIR_Coverage, 18911,
     /*  515046 */     GIR_EraseRootFromParent_Done,
     /*  515047 */   // Label 8563: @515047
     /*  515047 */   GIM_Try, /*On fail goto*//*Label 8564*/ GIMT_Encode4(515118), // Rule ID 18914 //
     /*  515052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515084 */     // MIs[0] round
     /*  515084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515103 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515116 */     GIR_RootConstrainSelectedInstOperands,
     /*  515117 */     // GIR_Coverage, 18914,
     /*  515117 */     GIR_EraseRootFromParent_Done,
     /*  515118 */   // Label 8564: @515118
     /*  515118 */   GIM_Try, /*On fail goto*//*Label 8565*/ GIMT_Encode4(515189), // Rule ID 18915 //
     /*  515123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  515134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  515137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  515140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515155 */     // MIs[0] round
     /*  515155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515165 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /*  515168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515174 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515187 */     GIR_RootConstrainSelectedInstOperands,
     /*  515188 */     // GIR_Coverage, 18915,
     /*  515188 */     GIR_EraseRootFromParent_Done,
     /*  515189 */   // Label 8565: @515189
     /*  515189 */   GIM_Try, /*On fail goto*//*Label 8566*/ GIMT_Encode4(515260), // Rule ID 18918 //
     /*  515194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515226 */     // MIs[0] round
     /*  515226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515245 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515258 */     GIR_RootConstrainSelectedInstOperands,
     /*  515259 */     // GIR_Coverage, 18918,
     /*  515259 */     GIR_EraseRootFromParent_Done,
     /*  515260 */   // Label 8566: @515260
     /*  515260 */   GIM_Try, /*On fail goto*//*Label 8567*/ GIMT_Encode4(515331), // Rule ID 18919 //
     /*  515265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  515276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  515279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  515282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515297 */     // MIs[0] round
     /*  515297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515307 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /*  515310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515316 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515329 */     GIR_RootConstrainSelectedInstOperands,
     /*  515330 */     // GIR_Coverage, 18919,
     /*  515330 */     GIR_EraseRootFromParent_Done,
     /*  515331 */   // Label 8567: @515331
     /*  515331 */   GIM_Try, /*On fail goto*//*Label 8568*/ GIMT_Encode4(515402), // Rule ID 18922 //
     /*  515336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  515339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515368 */     // MIs[0] round
     /*  515368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515378 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  515378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515387 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515400 */     GIR_RootConstrainSelectedInstOperands,
     /*  515401 */     // GIR_Coverage, 18922,
     /*  515401 */     GIR_EraseRootFromParent_Done,
     /*  515402 */   // Label 8568: @515402
     /*  515402 */   GIM_Try, /*On fail goto*//*Label 8569*/ GIMT_Encode4(515473), // Rule ID 18923 //
     /*  515407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  515410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  515418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  515421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  515424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515439 */     // MIs[0] round
     /*  515439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515449 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  515449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /*  515452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515458 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  515468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515471 */     GIR_RootConstrainSelectedInstOperands,
     /*  515472 */     // GIR_Coverage, 18923,
     /*  515472 */     GIR_EraseRootFromParent_Done,
     /*  515473 */   // Label 8569: @515473
     /*  515473 */   GIM_Try, /*On fail goto*//*Label 8570*/ GIMT_Encode4(515544), // Rule ID 18926 //
     /*  515478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  515489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  515492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  515495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515510 */     // MIs[0] round
     /*  515510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515520 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  515523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515529 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515542 */     GIR_RootConstrainSelectedInstOperands,
     /*  515543 */     // GIR_Coverage, 18926,
     /*  515543 */     GIR_EraseRootFromParent_Done,
     /*  515544 */   // Label 8570: @515544
     /*  515544 */   GIM_Try, /*On fail goto*//*Label 8571*/ GIMT_Encode4(515615), // Rule ID 18927 //
     /*  515549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  515560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  515563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  515566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  515581 */     // MIs[0] round
     /*  515581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515591 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11206:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /*  515594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515600 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515613 */     GIR_RootConstrainSelectedInstOperands,
     /*  515614 */     // GIR_Coverage, 18927,
     /*  515614 */     GIR_EraseRootFromParent_Done,
     /*  515615 */   // Label 8571: @515615
     /*  515615 */   GIM_Try, /*On fail goto*//*Label 8572*/ GIMT_Encode4(515686), // Rule ID 18930 //
     /*  515620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  515631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  515634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  515637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515652 */     // MIs[0] round
     /*  515652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515662 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  515665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515671 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515684 */     GIR_RootConstrainSelectedInstOperands,
     /*  515685 */     // GIR_Coverage, 18930,
     /*  515685 */     GIR_EraseRootFromParent_Done,
     /*  515686 */   // Label 8572: @515686
     /*  515686 */   GIM_Try, /*On fail goto*//*Label 8573*/ GIMT_Encode4(515757), // Rule ID 18931 //
     /*  515691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  515702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  515705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  515708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  515723 */     // MIs[0] round
     /*  515723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515733 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11206:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /*  515736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515742 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515755 */     GIR_RootConstrainSelectedInstOperands,
     /*  515756 */     // GIR_Coverage, 18931,
     /*  515756 */     GIR_EraseRootFromParent_Done,
     /*  515757 */   // Label 8573: @515757
     /*  515757 */   GIM_Try, /*On fail goto*//*Label 8574*/ GIMT_Encode4(515828), // Rule ID 18934 //
     /*  515762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  515765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  515773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  515776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  515779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515794 */     // MIs[0] round
     /*  515794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  515804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  515807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515813 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515826 */     GIR_RootConstrainSelectedInstOperands,
     /*  515827 */     // GIR_Coverage, 18934,
     /*  515827 */     GIR_EraseRootFromParent_Done,
     /*  515828 */   // Label 8574: @515828
     /*  515828 */   GIM_Try, /*On fail goto*//*Label 8575*/ GIMT_Encode4(515899), // Rule ID 18935 //
     /*  515833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  515836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt),
     /*  515841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  515844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  515847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  515850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  515865 */     // MIs[0] round
     /*  515865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515875 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11206:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  515875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /*  515878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515884 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  515894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515897 */     GIR_RootConstrainSelectedInstOperands,
     /*  515898 */     // GIR_Coverage, 18935,
     /*  515898 */     GIR_EraseRootFromParent_Done,
     /*  515899 */   // Label 8575: @515899
     /*  515899 */   GIM_Try, /*On fail goto*//*Label 8576*/ GIMT_Encode4(515970), // Rule ID 18994 //
     /*  515904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  515907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  515912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  515915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  515918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  515921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  515924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515936 */     // MIs[0] round
     /*  515936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  515939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  515946 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  515946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  515949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  515951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  515953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  515955 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  515957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  515962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  515965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  515968 */     GIR_RootConstrainSelectedInstOperands,
     /*  515969 */     // GIR_Coverage, 18994,
     /*  515969 */     GIR_EraseRootFromParent_Done,
     /*  515970 */   // Label 8576: @515970
     /*  515970 */   GIM_Try, /*On fail goto*//*Label 8577*/ GIMT_Encode4(516041), // Rule ID 18995 //
     /*  515975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  515978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  515983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  515986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  515989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  515992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  515995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  515999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516007 */     // MIs[0] round
     /*  516007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516017 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16),
     /*  516020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516026 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516039 */     GIR_RootConstrainSelectedInstOperands,
     /*  516040 */     // GIR_Coverage, 18995,
     /*  516040 */     GIR_EraseRootFromParent_Done,
     /*  516041 */   // Label 8577: @516041
     /*  516041 */   GIM_Try, /*On fail goto*//*Label 8578*/ GIMT_Encode4(516112), // Rule ID 18998 //
     /*  516046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516078 */     // MIs[0] round
     /*  516078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516088 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516097 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516110 */     GIR_RootConstrainSelectedInstOperands,
     /*  516111 */     // GIR_Coverage, 18998,
     /*  516111 */     GIR_EraseRootFromParent_Done,
     /*  516112 */   // Label 8578: @516112
     /*  516112 */   GIM_Try, /*On fail goto*//*Label 8579*/ GIMT_Encode4(516183), // Rule ID 18999 //
     /*  516117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  516128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  516131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  516134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516149 */     // MIs[0] round
     /*  516149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516159 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16),
     /*  516162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516168 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516181 */     GIR_RootConstrainSelectedInstOperands,
     /*  516182 */     // GIR_Coverage, 18999,
     /*  516182 */     GIR_EraseRootFromParent_Done,
     /*  516183 */   // Label 8579: @516183
     /*  516183 */   GIM_Try, /*On fail goto*//*Label 8580*/ GIMT_Encode4(516254), // Rule ID 19002 //
     /*  516188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516220 */     // MIs[0] round
     /*  516220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516239 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516252 */     GIR_RootConstrainSelectedInstOperands,
     /*  516253 */     // GIR_Coverage, 19002,
     /*  516253 */     GIR_EraseRootFromParent_Done,
     /*  516254 */   // Label 8580: @516254
     /*  516254 */   GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(516325), // Rule ID 19003 //
     /*  516259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  516270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  516273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  516276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516291 */     // MIs[0] round
     /*  516291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516301 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32),
     /*  516304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516310 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516323 */     GIR_RootConstrainSelectedInstOperands,
     /*  516324 */     // GIR_Coverage, 19003,
     /*  516324 */     GIR_EraseRootFromParent_Done,
     /*  516325 */   // Label 8581: @516325
     /*  516325 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(516396), // Rule ID 19006 //
     /*  516330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516362 */     // MIs[0] round
     /*  516362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516372 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516381 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516394 */     GIR_RootConstrainSelectedInstOperands,
     /*  516395 */     // GIR_Coverage, 19006,
     /*  516395 */     GIR_EraseRootFromParent_Done,
     /*  516396 */   // Label 8582: @516396
     /*  516396 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(516467), // Rule ID 19007 //
     /*  516401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  516412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  516415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  516418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516433 */     // MIs[0] round
     /*  516433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516443 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11182:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16),
     /*  516446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516452 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516465 */     GIR_RootConstrainSelectedInstOperands,
     /*  516466 */     // GIR_Coverage, 19007,
     /*  516466 */     GIR_EraseRootFromParent_Done,
     /*  516467 */   // Label 8583: @516467
     /*  516467 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(516538), // Rule ID 19010 //
     /*  516472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  516475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516504 */     // MIs[0] round
     /*  516504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516514 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  516514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  516517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516523 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516536 */     GIR_RootConstrainSelectedInstOperands,
     /*  516537 */     // GIR_Coverage, 19010,
     /*  516537 */     GIR_EraseRootFromParent_Done,
     /*  516538 */   // Label 8584: @516538
     /*  516538 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(516609), // Rule ID 19011 //
     /*  516543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  516546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  516554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  516557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  516560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516575 */     // MIs[0] round
     /*  516575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516585 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11182:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  516585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32),
     /*  516588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516594 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  516604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516607 */     GIR_RootConstrainSelectedInstOperands,
     /*  516608 */     // GIR_Coverage, 19011,
     /*  516608 */     GIR_EraseRootFromParent_Done,
     /*  516609 */   // Label 8585: @516609
     /*  516609 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(516680), // Rule ID 19014 //
     /*  516614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  516617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  516625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  516628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  516631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516646 */     // MIs[0] round
     /*  516646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  516656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  516659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516665 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516678 */     GIR_RootConstrainSelectedInstOperands,
     /*  516679 */     // GIR_Coverage, 19014,
     /*  516679 */     GIR_EraseRootFromParent_Done,
     /*  516680 */   // Label 8586: @516680
     /*  516680 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(516751), // Rule ID 19015 //
     /*  516685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  516688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  516696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  516699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  516702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  516717 */     // MIs[0] round
     /*  516717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516727 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11182:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  516727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64),
     /*  516730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516736 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  516746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516749 */     GIR_RootConstrainSelectedInstOperands,
     /*  516750 */     // GIR_Coverage, 19015,
     /*  516750 */     GIR_EraseRootFromParent_Done,
     /*  516751 */   // Label 8587: @516751
     /*  516751 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(516822), // Rule ID 19018 //
     /*  516756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  516767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  516770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  516773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516788 */     // MIs[0] round
     /*  516788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516798 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  516801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516807 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516820 */     GIR_RootConstrainSelectedInstOperands,
     /*  516821 */     // GIR_Coverage, 19018,
     /*  516821 */     GIR_EraseRootFromParent_Done,
     /*  516822 */   // Label 8588: @516822
     /*  516822 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(516893), // Rule ID 19019 //
     /*  516827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  516838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  516841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  516844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  516859 */     // MIs[0] round
     /*  516859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516869 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  516869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16),
     /*  516872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516878 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516891 */     GIR_RootConstrainSelectedInstOperands,
     /*  516892 */     // GIR_Coverage, 19019,
     /*  516892 */     GIR_EraseRootFromParent_Done,
     /*  516893 */   // Label 8589: @516893
     /*  516893 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(516964), // Rule ID 19022 //
     /*  516898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  516901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  516909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  516912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  516915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  516918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516930 */     // MIs[0] round
     /*  516930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  516933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  516940 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  516940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  516943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  516945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  516947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  516949 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  516951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  516956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  516959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  516962 */     GIR_RootConstrainSelectedInstOperands,
     /*  516963 */     // GIR_Coverage, 19022,
     /*  516963 */     GIR_EraseRootFromParent_Done,
     /*  516964 */   // Label 8590: @516964
     /*  516964 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(517035), // Rule ID 19023 //
     /*  516969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  516972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  516977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  516980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  516983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  516986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  516989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  516997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517001 */     // MIs[0] round
     /*  517001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517011 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16),
     /*  517014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517020 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517033 */     GIR_RootConstrainSelectedInstOperands,
     /*  517034 */     // GIR_Coverage, 19023,
     /*  517034 */     GIR_EraseRootFromParent_Done,
     /*  517035 */   // Label 8591: @517035
     /*  517035 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(517106), // Rule ID 19026 //
     /*  517040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  517043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517072 */     // MIs[0] round
     /*  517072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517082 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  517082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517091 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517104 */     GIR_RootConstrainSelectedInstOperands,
     /*  517105 */     // GIR_Coverage, 19026,
     /*  517105 */     GIR_EraseRootFromParent_Done,
     /*  517106 */   // Label 8592: @517106
     /*  517106 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(517177), // Rule ID 19027 //
     /*  517111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  517114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  517122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  517125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  517128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517143 */     // MIs[0] round
     /*  517143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517153 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  517153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16),
     /*  517156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517162 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  517172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517175 */     GIR_RootConstrainSelectedInstOperands,
     /*  517176 */     // GIR_Coverage, 19027,
     /*  517176 */     GIR_EraseRootFromParent_Done,
     /*  517177 */   // Label 8593: @517177
     /*  517177 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(517248), // Rule ID 19030 //
     /*  517182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517214 */     // MIs[0] round
     /*  517214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517233 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517246 */     GIR_RootConstrainSelectedInstOperands,
     /*  517247 */     // GIR_Coverage, 19030,
     /*  517247 */     GIR_EraseRootFromParent_Done,
     /*  517248 */   // Label 8594: @517248
     /*  517248 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(517319), // Rule ID 19031 //
     /*  517253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  517264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  517267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  517270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517285 */     // MIs[0] round
     /*  517285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517295 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32),
     /*  517298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517304 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517317 */     GIR_RootConstrainSelectedInstOperands,
     /*  517318 */     // GIR_Coverage, 19031,
     /*  517318 */     GIR_EraseRootFromParent_Done,
     /*  517319 */   // Label 8595: @517319
     /*  517319 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(517390), // Rule ID 19034 //
     /*  517324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517356 */     // MIs[0] round
     /*  517356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517366 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517375 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517388 */     GIR_RootConstrainSelectedInstOperands,
     /*  517389 */     // GIR_Coverage, 19034,
     /*  517389 */     GIR_EraseRootFromParent_Done,
     /*  517390 */   // Label 8596: @517390
     /*  517390 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(517461), // Rule ID 19035 //
     /*  517395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  517406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  517409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  517412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517427 */     // MIs[0] round
     /*  517427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517437 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32),
     /*  517440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517446 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517459 */     GIR_RootConstrainSelectedInstOperands,
     /*  517460 */     // GIR_Coverage, 19035,
     /*  517460 */     GIR_EraseRootFromParent_Done,
     /*  517461 */   // Label 8597: @517461
     /*  517461 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(517532), // Rule ID 19038 //
     /*  517466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  517469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  517483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517498 */     // MIs[0] round
     /*  517498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517508 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  517508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  517511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517517 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517530 */     GIR_RootConstrainSelectedInstOperands,
     /*  517531 */     // GIR_Coverage, 19038,
     /*  517531 */     GIR_EraseRootFromParent_Done,
     /*  517532 */   // Label 8598: @517532
     /*  517532 */   GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(517603), // Rule ID 19039 //
     /*  517537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  517540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  517548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  517551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  517554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517569 */     // MIs[0] round
     /*  517569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517579 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  517579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32),
     /*  517582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517588 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  517598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517601 */     GIR_RootConstrainSelectedInstOperands,
     /*  517602 */     // GIR_Coverage, 19039,
     /*  517602 */     GIR_EraseRootFromParent_Done,
     /*  517603 */   // Label 8599: @517603
     /*  517603 */   GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(517674), // Rule ID 19042 //
     /*  517608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  517619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  517622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  517625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517640 */     // MIs[0] round
     /*  517640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517650 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  517653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517659 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517672 */     GIR_RootConstrainSelectedInstOperands,
     /*  517673 */     // GIR_Coverage, 19042,
     /*  517673 */     GIR_EraseRootFromParent_Done,
     /*  517674 */   // Label 8600: @517674
     /*  517674 */   GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(517745), // Rule ID 19043 //
     /*  517679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  517690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  517693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  517696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  517711 */     // MIs[0] round
     /*  517711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517721 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11182:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64),
     /*  517724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517730 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517743 */     GIR_RootConstrainSelectedInstOperands,
     /*  517744 */     // GIR_Coverage, 19043,
     /*  517744 */     GIR_EraseRootFromParent_Done,
     /*  517745 */   // Label 8601: @517745
     /*  517745 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(517816), // Rule ID 19046 //
     /*  517750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  517761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  517764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  517767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517782 */     // MIs[0] round
     /*  517782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517792 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  517795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517801 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517814 */     GIR_RootConstrainSelectedInstOperands,
     /*  517815 */     // GIR_Coverage, 19046,
     /*  517815 */     GIR_EraseRootFromParent_Done,
     /*  517816 */   // Label 8602: @517816
     /*  517816 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(517887), // Rule ID 19047 //
     /*  517821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  517832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  517835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  517838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  517853 */     // MIs[0] round
     /*  517853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517863 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11182:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  517863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64),
     /*  517866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517872 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517885 */     GIR_RootConstrainSelectedInstOperands,
     /*  517886 */     // GIR_Coverage, 19047,
     /*  517886 */     GIR_EraseRootFromParent_Done,
     /*  517887 */   // Label 8603: @517887
     /*  517887 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(517958), // Rule ID 19050 //
     /*  517892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  517895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  517903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  517906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  517909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  517912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517924 */     // MIs[0] round
     /*  517924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  517934 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  517934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  517937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  517939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  517941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  517943 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  517945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  517950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  517953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  517956 */     GIR_RootConstrainSelectedInstOperands,
     /*  517957 */     // GIR_Coverage, 19050,
     /*  517957 */     GIR_EraseRootFromParent_Done,
     /*  517958 */   // Label 8604: @517958
     /*  517958 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(518029), // Rule ID 19051 //
     /*  517963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  517966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7),
     /*  517971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  517974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  517977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  517980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  517983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  517995 */     // MIs[0] round
     /*  517995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  517998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518005 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11182:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREC7_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64),
     /*  518008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518014 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518027 */     GIR_RootConstrainSelectedInstOperands,
     /*  518028 */     // GIR_Coverage, 19051,
     /*  518028 */     GIR_EraseRootFromParent_Done,
     /*  518029 */   // Label 8605: @518029
     /*  518029 */   GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(518100), // Rule ID 20636 //
     /*  518034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518066 */     // MIs[0] round
     /*  518066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518076 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518085 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518098 */     GIR_RootConstrainSelectedInstOperands,
     /*  518099 */     // GIR_Coverage, 20636,
     /*  518099 */     GIR_EraseRootFromParent_Done,
     /*  518100 */   // Label 8606: @518100
     /*  518100 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(518171), // Rule ID 20637 //
     /*  518105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  518116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  518119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  518122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518137 */     // MIs[0] round
     /*  518137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518147 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518156 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518169 */     GIR_RootConstrainSelectedInstOperands,
     /*  518170 */     // GIR_Coverage, 20637,
     /*  518170 */     GIR_EraseRootFromParent_Done,
     /*  518171 */   // Label 8607: @518171
     /*  518171 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(518242), // Rule ID 20640 //
     /*  518176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518208 */     // MIs[0] round
     /*  518208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518227 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518240 */     GIR_RootConstrainSelectedInstOperands,
     /*  518241 */     // GIR_Coverage, 20640,
     /*  518241 */     GIR_EraseRootFromParent_Done,
     /*  518242 */   // Label 8608: @518242
     /*  518242 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(518313), // Rule ID 20641 //
     /*  518247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  518250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  518258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  518261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  518264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518279 */     // MIs[0] round
     /*  518279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2),
     /*  518292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518298 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518311 */     GIR_RootConstrainSelectedInstOperands,
     /*  518312 */     // GIR_Coverage, 20641,
     /*  518312 */     GIR_EraseRootFromParent_Done,
     /*  518313 */   // Label 8609: @518313
     /*  518313 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(518384), // Rule ID 20644 //
     /*  518318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518350 */     // MIs[0] round
     /*  518350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518369 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518382 */     GIR_RootConstrainSelectedInstOperands,
     /*  518383 */     // GIR_Coverage, 20644,
     /*  518383 */     GIR_EraseRootFromParent_Done,
     /*  518384 */   // Label 8610: @518384
     /*  518384 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(518455), // Rule ID 20645 //
     /*  518389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  518400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  518403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  518406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518421 */     // MIs[0] round
     /*  518421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518431 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11128:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518440 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518453 */     GIR_RootConstrainSelectedInstOperands,
     /*  518454 */     // GIR_Coverage, 20645,
     /*  518454 */     GIR_EraseRootFromParent_Done,
     /*  518455 */   // Label 8611: @518455
     /*  518455 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(518526), // Rule ID 20648 //
     /*  518460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  518463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518492 */     // MIs[0] round
     /*  518492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518502 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  518502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518511 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518524 */     GIR_RootConstrainSelectedInstOperands,
     /*  518525 */     // GIR_Coverage, 20648,
     /*  518525 */     GIR_EraseRootFromParent_Done,
     /*  518526 */   // Label 8612: @518526
     /*  518526 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(518597), // Rule ID 20649 //
     /*  518531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  518534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  518542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  518545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  518548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518563 */     // MIs[0] round
     /*  518563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518573 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11128:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  518573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518582 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  518592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518595 */     GIR_RootConstrainSelectedInstOperands,
     /*  518596 */     // GIR_Coverage, 20649,
     /*  518596 */     GIR_EraseRootFromParent_Done,
     /*  518597 */   // Label 8613: @518597
     /*  518597 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(518668), // Rule ID 20652 //
     /*  518602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  518605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518634 */     // MIs[0] round
     /*  518634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  518644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518653 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518666 */     GIR_RootConstrainSelectedInstOperands,
     /*  518667 */     // GIR_Coverage, 20652,
     /*  518667 */     GIR_EraseRootFromParent_Done,
     /*  518668 */   // Label 8614: @518668
     /*  518668 */   GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(518739), // Rule ID 20653 //
     /*  518673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  518676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  518684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  518687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  518690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  518705 */     // MIs[0] round
     /*  518705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518715 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11128:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  518715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1),
     /*  518718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518724 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  518734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518737 */     GIR_RootConstrainSelectedInstOperands,
     /*  518738 */     // GIR_Coverage, 20653,
     /*  518738 */     GIR_EraseRootFromParent_Done,
     /*  518739 */   // Label 8615: @518739
     /*  518739 */   GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(518810), // Rule ID 20656 //
     /*  518744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  518755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  518758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  518761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518776 */     // MIs[0] round
     /*  518776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518786 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  518789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518795 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518808 */     GIR_RootConstrainSelectedInstOperands,
     /*  518809 */     // GIR_Coverage, 20656,
     /*  518809 */     GIR_EraseRootFromParent_Done,
     /*  518810 */   // Label 8616: @518810
     /*  518810 */   GIM_Try, /*On fail goto*//*Label 8617*/ GIMT_Encode4(518881), // Rule ID 20657 //
     /*  518815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  518826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  518829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  518832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  518847 */     // MIs[0] round
     /*  518847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518857 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  518860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518866 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518879 */     GIR_RootConstrainSelectedInstOperands,
     /*  518880 */     // GIR_Coverage, 20657,
     /*  518880 */     GIR_EraseRootFromParent_Done,
     /*  518881 */   // Label 8617: @518881
     /*  518881 */   GIM_Try, /*On fail goto*//*Label 8618*/ GIMT_Encode4(518952), // Rule ID 20660 //
     /*  518886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  518889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  518897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  518900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  518903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  518906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518918 */     // MIs[0] round
     /*  518918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  518928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  518931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  518933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  518935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  518937 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  518939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  518944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  518947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  518950 */     GIR_RootConstrainSelectedInstOperands,
     /*  518951 */     // GIR_Coverage, 20660,
     /*  518951 */     GIR_EraseRootFromParent_Done,
     /*  518952 */   // Label 8618: @518952
     /*  518952 */   GIM_Try, /*On fail goto*//*Label 8619*/ GIMT_Encode4(519023), // Rule ID 20661 //
     /*  518957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  518960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  518965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  518968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  518971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  518974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  518977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  518989 */     // MIs[0] round
     /*  518989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  518992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  518999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  518999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519008 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519021 */     GIR_RootConstrainSelectedInstOperands,
     /*  519022 */     // GIR_Coverage, 20661,
     /*  519022 */     GIR_EraseRootFromParent_Done,
     /*  519023 */   // Label 8619: @519023
     /*  519023 */   GIM_Try, /*On fail goto*//*Label 8620*/ GIMT_Encode4(519094), // Rule ID 20664 //
     /*  519028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  519031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519060 */     // MIs[0] round
     /*  519060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  519070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519079 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519092 */     GIR_RootConstrainSelectedInstOperands,
     /*  519093 */     // GIR_Coverage, 20664,
     /*  519093 */     GIR_EraseRootFromParent_Done,
     /*  519094 */   // Label 8620: @519094
     /*  519094 */   GIM_Try, /*On fail goto*//*Label 8621*/ GIMT_Encode4(519165), // Rule ID 20665 //
     /*  519099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  519102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  519110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  519113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  519116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519131 */     // MIs[0] round
     /*  519131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519141 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  519141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519150 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  519160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519163 */     GIR_RootConstrainSelectedInstOperands,
     /*  519164 */     // GIR_Coverage, 20665,
     /*  519164 */     GIR_EraseRootFromParent_Done,
     /*  519165 */   // Label 8621: @519165
     /*  519165 */   GIM_Try, /*On fail goto*//*Label 8622*/ GIMT_Encode4(519236), // Rule ID 20668 //
     /*  519170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519202 */     // MIs[0] round
     /*  519202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519221 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519234 */     GIR_RootConstrainSelectedInstOperands,
     /*  519235 */     // GIR_Coverage, 20668,
     /*  519235 */     GIR_EraseRootFromParent_Done,
     /*  519236 */   // Label 8622: @519236
     /*  519236 */   GIM_Try, /*On fail goto*//*Label 8623*/ GIMT_Encode4(519307), // Rule ID 20669 //
     /*  519241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  519252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  519255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  519258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519273 */     // MIs[0] round
     /*  519273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519283 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519292 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519305 */     GIR_RootConstrainSelectedInstOperands,
     /*  519306 */     // GIR_Coverage, 20669,
     /*  519306 */     GIR_EraseRootFromParent_Done,
     /*  519307 */   // Label 8623: @519307
     /*  519307 */   GIM_Try, /*On fail goto*//*Label 8624*/ GIMT_Encode4(519378), // Rule ID 20672 //
     /*  519312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519344 */     // MIs[0] round
     /*  519344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519363 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519376 */     GIR_RootConstrainSelectedInstOperands,
     /*  519377 */     // GIR_Coverage, 20672,
     /*  519377 */     GIR_EraseRootFromParent_Done,
     /*  519378 */   // Label 8624: @519378
     /*  519378 */   GIM_Try, /*On fail goto*//*Label 8625*/ GIMT_Encode4(519449), // Rule ID 20673 //
     /*  519383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  519394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  519397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  519400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519415 */     // MIs[0] round
     /*  519415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519425 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519434 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519447 */     GIR_RootConstrainSelectedInstOperands,
     /*  519448 */     // GIR_Coverage, 20673,
     /*  519448 */     GIR_EraseRootFromParent_Done,
     /*  519449 */   // Label 8625: @519449
     /*  519449 */   GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(519520), // Rule ID 20676 //
     /*  519454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  519457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519486 */     // MIs[0] round
     /*  519486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519496 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  519496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519505 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519518 */     GIR_RootConstrainSelectedInstOperands,
     /*  519519 */     // GIR_Coverage, 20676,
     /*  519519 */     GIR_EraseRootFromParent_Done,
     /*  519520 */   // Label 8626: @519520
     /*  519520 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(519591), // Rule ID 20677 //
     /*  519525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  519528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  519536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  519539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  519542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519557 */     // MIs[0] round
     /*  519557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519567 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  519567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519576 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  519586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519589 */     GIR_RootConstrainSelectedInstOperands,
     /*  519590 */     // GIR_Coverage, 20677,
     /*  519590 */     GIR_EraseRootFromParent_Done,
     /*  519591 */   // Label 8627: @519591
     /*  519591 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(519662), // Rule ID 20680 //
     /*  519596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519628 */     // MIs[0] round
     /*  519628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519638 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519647 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519660 */     GIR_RootConstrainSelectedInstOperands,
     /*  519661 */     // GIR_Coverage, 20680,
     /*  519661 */     GIR_EraseRootFromParent_Done,
     /*  519662 */   // Label 8628: @519662
     /*  519662 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(519733), // Rule ID 20681 //
     /*  519667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  519678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  519681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  519684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  519699 */     // MIs[0] round
     /*  519699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11128:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2),
     /*  519712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519718 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519731 */     GIR_RootConstrainSelectedInstOperands,
     /*  519732 */     // GIR_Coverage, 20681,
     /*  519732 */     GIR_EraseRootFromParent_Done,
     /*  519733 */   // Label 8629: @519733
     /*  519733 */   GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(519804), // Rule ID 20684 //
     /*  519738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  519749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  519752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  519755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519770 */     // MIs[0] round
     /*  519770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519789 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519802 */     GIR_RootConstrainSelectedInstOperands,
     /*  519803 */     // GIR_Coverage, 20684,
     /*  519803 */     GIR_EraseRootFromParent_Done,
     /*  519804 */   // Label 8630: @519804
     /*  519804 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(519875), // Rule ID 20685 //
     /*  519809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  519820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  519823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  519826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  519841 */     // MIs[0] round
     /*  519841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11128:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4),
     /*  519854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519860 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519873 */     GIR_RootConstrainSelectedInstOperands,
     /*  519874 */     // GIR_Coverage, 20685,
     /*  519874 */     GIR_EraseRootFromParent_Done,
     /*  519875 */   // Label 8631: @519875
     /*  519875 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(519946), // Rule ID 20688 //
     /*  519880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  519883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  519891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  519894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  519897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  519900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519912 */     // MIs[0] round
     /*  519912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519922 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  519922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  519929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  519931 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  519933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  519938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  519941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  519944 */     GIR_RootConstrainSelectedInstOperands,
     /*  519945 */     // GIR_Coverage, 20688,
     /*  519945 */     GIR_EraseRootFromParent_Done,
     /*  519946 */   // Label 8632: @519946
     /*  519946 */   GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(520017), // Rule ID 20689 //
     /*  519951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  519954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v),
     /*  519959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  519962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  519965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  519968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  519971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  519983 */     // MIs[0] round
     /*  519983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  519986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  519993 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11128:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_X_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  519993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8),
     /*  519996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  519998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520002 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520015 */     GIR_RootConstrainSelectedInstOperands,
     /*  520016 */     // GIR_Coverage, 20689,
     /*  520016 */     GIR_EraseRootFromParent_Done,
     /*  520017 */   // Label 8633: @520017
     /*  520017 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(520088), // Rule ID 20692 //
     /*  520022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520054 */     // MIs[0] round
     /*  520054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520073 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520086 */     GIR_RootConstrainSelectedInstOperands,
     /*  520087 */     // GIR_Coverage, 20692,
     /*  520087 */     GIR_EraseRootFromParent_Done,
     /*  520088 */   // Label 8634: @520088
     /*  520088 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(520159), // Rule ID 20693 //
     /*  520093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  520104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  520107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  520110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520125 */     // MIs[0] round
     /*  520125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520135 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4),
     /*  520138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520144 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520157 */     GIR_RootConstrainSelectedInstOperands,
     /*  520158 */     // GIR_Coverage, 20693,
     /*  520158 */     GIR_EraseRootFromParent_Done,
     /*  520159 */   // Label 8635: @520159
     /*  520159 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(520230), // Rule ID 20696 //
     /*  520164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520196 */     // MIs[0] round
     /*  520196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520206 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520215 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520228 */     GIR_RootConstrainSelectedInstOperands,
     /*  520229 */     // GIR_Coverage, 20696,
     /*  520229 */     GIR_EraseRootFromParent_Done,
     /*  520230 */   // Label 8636: @520230
     /*  520230 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(520301), // Rule ID 20697 //
     /*  520235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  520246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  520249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  520252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520267 */     // MIs[0] round
     /*  520267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520277 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520286 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520299 */     GIR_RootConstrainSelectedInstOperands,
     /*  520300 */     // GIR_Coverage, 20697,
     /*  520300 */     GIR_EraseRootFromParent_Done,
     /*  520301 */   // Label 8637: @520301
     /*  520301 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(520372), // Rule ID 20700 //
     /*  520306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520338 */     // MIs[0] round
     /*  520338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520357 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520370 */     GIR_RootConstrainSelectedInstOperands,
     /*  520371 */     // GIR_Coverage, 20700,
     /*  520371 */     GIR_EraseRootFromParent_Done,
     /*  520372 */   // Label 8638: @520372
     /*  520372 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(520443), // Rule ID 20701 //
     /*  520377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  520388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  520391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  520394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520409 */     // MIs[0] round
     /*  520409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2),
     /*  520422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520428 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520441 */     GIR_RootConstrainSelectedInstOperands,
     /*  520442 */     // GIR_Coverage, 20701,
     /*  520442 */     GIR_EraseRootFromParent_Done,
     /*  520443 */   // Label 8639: @520443
     /*  520443 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(520514), // Rule ID 20704 //
     /*  520448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520480 */     // MIs[0] round
     /*  520480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520490 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520499 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520512 */     GIR_RootConstrainSelectedInstOperands,
     /*  520513 */     // GIR_Coverage, 20704,
     /*  520513 */     GIR_EraseRootFromParent_Done,
     /*  520514 */   // Label 8640: @520514
     /*  520514 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(520585), // Rule ID 20705 //
     /*  520519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  520530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  520533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  520536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520551 */     // MIs[0] round
     /*  520551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520561 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11130:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520570 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520583 */     GIR_RootConstrainSelectedInstOperands,
     /*  520584 */     // GIR_Coverage, 20705,
     /*  520584 */     GIR_EraseRootFromParent_Done,
     /*  520585 */   // Label 8641: @520585
     /*  520585 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(520656), // Rule ID 20708 //
     /*  520590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  520593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520622 */     // MIs[0] round
     /*  520622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  520632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520641 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520654 */     GIR_RootConstrainSelectedInstOperands,
     /*  520655 */     // GIR_Coverage, 20708,
     /*  520655 */     GIR_EraseRootFromParent_Done,
     /*  520656 */   // Label 8642: @520656
     /*  520656 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(520727), // Rule ID 20709 //
     /*  520661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  520664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  520672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  520675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  520678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520693 */     // MIs[0] round
     /*  520693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520703 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11130:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  520703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520712 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  520722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520725 */     GIR_RootConstrainSelectedInstOperands,
     /*  520726 */     // GIR_Coverage, 20709,
     /*  520726 */     GIR_EraseRootFromParent_Done,
     /*  520727 */   // Label 8643: @520727
     /*  520727 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(520798), // Rule ID 20712 //
     /*  520732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  520735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  520743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  520746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  520749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520764 */     // MIs[0] round
     /*  520764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  520774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520783 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520796 */     GIR_RootConstrainSelectedInstOperands,
     /*  520797 */     // GIR_Coverage, 20712,
     /*  520797 */     GIR_EraseRootFromParent_Done,
     /*  520798 */   // Label 8644: @520798
     /*  520798 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(520869), // Rule ID 20713 //
     /*  520803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  520806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  520814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  520817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  520820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  520835 */     // MIs[0] round
     /*  520835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520845 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11130:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  520845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1),
     /*  520848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520854 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  520864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520867 */     GIR_RootConstrainSelectedInstOperands,
     /*  520868 */     // GIR_Coverage, 20713,
     /*  520868 */     GIR_EraseRootFromParent_Done,
     /*  520869 */   // Label 8645: @520869
     /*  520869 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(520940), // Rule ID 20716 //
     /*  520874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  520877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  520885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  520888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  520891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  520894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520906 */     // MIs[0] round
     /*  520906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  520916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  520919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520925 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  520932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  520935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  520938 */     GIR_RootConstrainSelectedInstOperands,
     /*  520939 */     // GIR_Coverage, 20716,
     /*  520939 */     GIR_EraseRootFromParent_Done,
     /*  520940 */   // Label 8646: @520940
     /*  520940 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(521011), // Rule ID 20717 //
     /*  520945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  520948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  520953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  520956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  520959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  520962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  520965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  520977 */     // MIs[0] round
     /*  520977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  520980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  520987 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  520987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  520990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  520992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  520994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  520996 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  520998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521009 */     GIR_RootConstrainSelectedInstOperands,
     /*  521010 */     // GIR_Coverage, 20717,
     /*  521010 */     GIR_EraseRootFromParent_Done,
     /*  521011 */   // Label 8647: @521011
     /*  521011 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(521082), // Rule ID 20720 //
     /*  521016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521048 */     // MIs[0] round
     /*  521048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521058 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521067 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521080 */     GIR_RootConstrainSelectedInstOperands,
     /*  521081 */     // GIR_Coverage, 20720,
     /*  521081 */     GIR_EraseRootFromParent_Done,
     /*  521082 */   // Label 8648: @521082
     /*  521082 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(521153), // Rule ID 20721 //
     /*  521087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  521098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  521101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  521104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521119 */     // MIs[0] round
     /*  521119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521129 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521138 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521151 */     GIR_RootConstrainSelectedInstOperands,
     /*  521152 */     // GIR_Coverage, 20721,
     /*  521152 */     GIR_EraseRootFromParent_Done,
     /*  521153 */   // Label 8649: @521153
     /*  521153 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(521224), // Rule ID 20724 //
     /*  521158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  521161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521190 */     // MIs[0] round
     /*  521190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  521200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521209 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521222 */     GIR_RootConstrainSelectedInstOperands,
     /*  521223 */     // GIR_Coverage, 20724,
     /*  521223 */     GIR_EraseRootFromParent_Done,
     /*  521224 */   // Label 8650: @521224
     /*  521224 */   GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(521295), // Rule ID 20725 //
     /*  521229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  521232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  521240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  521243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  521246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521261 */     // MIs[0] round
     /*  521261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521271 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  521271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521280 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  521290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521293 */     GIR_RootConstrainSelectedInstOperands,
     /*  521294 */     // GIR_Coverage, 20725,
     /*  521294 */     GIR_EraseRootFromParent_Done,
     /*  521295 */   // Label 8651: @521295
     /*  521295 */   GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(521366), // Rule ID 20728 //
     /*  521300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521332 */     // MIs[0] round
     /*  521332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521351 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521364 */     GIR_RootConstrainSelectedInstOperands,
     /*  521365 */     // GIR_Coverage, 20728,
     /*  521365 */     GIR_EraseRootFromParent_Done,
     /*  521366 */   // Label 8652: @521366
     /*  521366 */   GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(521437), // Rule ID 20729 //
     /*  521371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  521382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  521385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  521388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521403 */     // MIs[0] round
     /*  521403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521422 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521435 */     GIR_RootConstrainSelectedInstOperands,
     /*  521436 */     // GIR_Coverage, 20729,
     /*  521436 */     GIR_EraseRootFromParent_Done,
     /*  521437 */   // Label 8653: @521437
     /*  521437 */   GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(521508), // Rule ID 20732 //
     /*  521442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521474 */     // MIs[0] round
     /*  521474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521493 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521506 */     GIR_RootConstrainSelectedInstOperands,
     /*  521507 */     // GIR_Coverage, 20732,
     /*  521507 */     GIR_EraseRootFromParent_Done,
     /*  521508 */   // Label 8654: @521508
     /*  521508 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(521579), // Rule ID 20733 //
     /*  521513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  521524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  521527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  521530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521545 */     // MIs[0] round
     /*  521545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521564 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521577 */     GIR_RootConstrainSelectedInstOperands,
     /*  521578 */     // GIR_Coverage, 20733,
     /*  521578 */     GIR_EraseRootFromParent_Done,
     /*  521579 */   // Label 8655: @521579
     /*  521579 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(521650), // Rule ID 20736 //
     /*  521584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  521587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521616 */     // MIs[0] round
     /*  521616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521626 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  521626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521635 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521648 */     GIR_RootConstrainSelectedInstOperands,
     /*  521649 */     // GIR_Coverage, 20736,
     /*  521649 */     GIR_EraseRootFromParent_Done,
     /*  521650 */   // Label 8656: @521650
     /*  521650 */   GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(521721), // Rule ID 20737 //
     /*  521655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  521658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  521666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  521669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  521672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  521687 */     // MIs[0] round
     /*  521687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521697 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  521697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  521700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521706 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  521716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521719 */     GIR_RootConstrainSelectedInstOperands,
     /*  521720 */     // GIR_Coverage, 20737,
     /*  521720 */     GIR_EraseRootFromParent_Done,
     /*  521721 */   // Label 8657: @521721
     /*  521721 */   GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(521792), // Rule ID 20740 //
     /*  521726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  521737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  521740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  521743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521758 */     // MIs[0] round
     /*  521758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521768 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521777 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521790 */     GIR_RootConstrainSelectedInstOperands,
     /*  521791 */     // GIR_Coverage, 20740,
     /*  521791 */     GIR_EraseRootFromParent_Done,
     /*  521792 */   // Label 8658: @521792
     /*  521792 */   GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(521863), // Rule ID 20741 //
     /*  521797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  521808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  521811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  521814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  521829 */     // MIs[0] round
     /*  521829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521839 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11130:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2),
     /*  521842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521848 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521861 */     GIR_RootConstrainSelectedInstOperands,
     /*  521862 */     // GIR_Coverage, 20741,
     /*  521862 */     GIR_EraseRootFromParent_Done,
     /*  521863 */   // Label 8659: @521863
     /*  521863 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(521934), // Rule ID 20744 //
     /*  521868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  521871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  521879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  521882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  521885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  521888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521900 */     // MIs[0] round
     /*  521900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521910 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  521910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521919 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  521929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  521932 */     GIR_RootConstrainSelectedInstOperands,
     /*  521933 */     // GIR_Coverage, 20744,
     /*  521933 */     GIR_EraseRootFromParent_Done,
     /*  521934 */   // Label 8660: @521934
     /*  521934 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(522005), // Rule ID 20745 //
     /*  521939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  521942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  521947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  521950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  521953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  521956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  521959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  521971 */     // MIs[0] round
     /*  521971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  521974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  521981 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11130:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  521981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4),
     /*  521984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  521986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  521988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  521990 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  521992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  521997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522003 */     GIR_RootConstrainSelectedInstOperands,
     /*  522004 */     // GIR_Coverage, 20745,
     /*  522004 */     GIR_EraseRootFromParent_Done,
     /*  522005 */   // Label 8661: @522005
     /*  522005 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(522076), // Rule ID 20748 //
     /*  522010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522042 */     // MIs[0] round
     /*  522042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522052 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522061 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522074 */     GIR_RootConstrainSelectedInstOperands,
     /*  522075 */     // GIR_Coverage, 20748,
     /*  522075 */     GIR_EraseRootFromParent_Done,
     /*  522076 */   // Label 8662: @522076
     /*  522076 */   GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(522147), // Rule ID 20749 //
     /*  522081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v),
     /*  522089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  522092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  522095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  522098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  522113 */     // MIs[0] round
     /*  522113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522123 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11130:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_XU_F_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8),
     /*  522126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522132 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522145 */     GIR_RootConstrainSelectedInstOperands,
     /*  522146 */     // GIR_Coverage, 20749,
     /*  522146 */     GIR_EraseRootFromParent_Done,
     /*  522147 */   // Label 8663: @522147
     /*  522147 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(522218), // Rule ID 20872 //
     /*  522152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522184 */     // MIs[0] round
     /*  522184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522194 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522203 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522216 */     GIR_RootConstrainSelectedInstOperands,
     /*  522217 */     // GIR_Coverage, 20872,
     /*  522217 */     GIR_EraseRootFromParent_Done,
     /*  522218 */   // Label 8664: @522218
     /*  522218 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(522289), // Rule ID 20873 //
     /*  522223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  522234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  522237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  522240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522255 */     // MIs[0] round
     /*  522255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522265 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /*  522268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522274 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522287 */     GIR_RootConstrainSelectedInstOperands,
     /*  522288 */     // GIR_Coverage, 20873,
     /*  522288 */     GIR_EraseRootFromParent_Done,
     /*  522289 */   // Label 8665: @522289
     /*  522289 */   GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(522360), // Rule ID 20876 //
     /*  522294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522326 */     // MIs[0] round
     /*  522326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522336 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522345 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522358 */     GIR_RootConstrainSelectedInstOperands,
     /*  522359 */     // GIR_Coverage, 20876,
     /*  522359 */     GIR_EraseRootFromParent_Done,
     /*  522360 */   // Label 8666: @522360
     /*  522360 */   GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(522431), // Rule ID 20877 //
     /*  522365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  522376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  522379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  522382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522397 */     // MIs[0] round
     /*  522397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522407 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /*  522410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522416 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522429 */     GIR_RootConstrainSelectedInstOperands,
     /*  522430 */     // GIR_Coverage, 20877,
     /*  522430 */     GIR_EraseRootFromParent_Done,
     /*  522431 */   // Label 8667: @522431
     /*  522431 */   GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(522502), // Rule ID 20880 //
     /*  522436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522468 */     // MIs[0] round
     /*  522468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522478 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  522481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522487 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522500 */     GIR_RootConstrainSelectedInstOperands,
     /*  522501 */     // GIR_Coverage, 20880,
     /*  522501 */     GIR_EraseRootFromParent_Done,
     /*  522502 */   // Label 8668: @522502
     /*  522502 */   GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(522573), // Rule ID 20881 //
     /*  522507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  522518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  522521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  522524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522539 */     // MIs[0] round
     /*  522539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522549 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /*  522552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522558 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522571 */     GIR_RootConstrainSelectedInstOperands,
     /*  522572 */     // GIR_Coverage, 20881,
     /*  522572 */     GIR_EraseRootFromParent_Done,
     /*  522573 */   // Label 8669: @522573
     /*  522573 */   GIM_Try, /*On fail goto*//*Label 8670*/ GIMT_Encode4(522644), // Rule ID 20884 //
     /*  522578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  522581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522610 */     // MIs[0] round
     /*  522610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522620 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  522620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  522623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522629 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522642 */     GIR_RootConstrainSelectedInstOperands,
     /*  522643 */     // GIR_Coverage, 20884,
     /*  522643 */     GIR_EraseRootFromParent_Done,
     /*  522644 */   // Label 8670: @522644
     /*  522644 */   GIM_Try, /*On fail goto*//*Label 8671*/ GIMT_Encode4(522715), // Rule ID 20885 //
     /*  522649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  522652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  522660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  522663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  522666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522681 */     // MIs[0] round
     /*  522681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522691 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11120:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  522691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /*  522694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522700 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  522710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522713 */     GIR_RootConstrainSelectedInstOperands,
     /*  522714 */     // GIR_Coverage, 20885,
     /*  522714 */     GIR_EraseRootFromParent_Done,
     /*  522715 */   // Label 8671: @522715
     /*  522715 */   GIM_Try, /*On fail goto*//*Label 8672*/ GIMT_Encode4(522786), // Rule ID 20888 //
     /*  522720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  522723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522752 */     // MIs[0] round
     /*  522752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522762 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  522762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  522765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522771 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522784 */     GIR_RootConstrainSelectedInstOperands,
     /*  522785 */     // GIR_Coverage, 20888,
     /*  522785 */     GIR_EraseRootFromParent_Done,
     /*  522786 */   // Label 8672: @522786
     /*  522786 */   GIM_Try, /*On fail goto*//*Label 8673*/ GIMT_Encode4(522857), // Rule ID 20889 //
     /*  522791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  522794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  522802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  522805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  522808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522823 */     // MIs[0] round
     /*  522823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522833 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11120:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  522833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /*  522836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522842 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  522852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522855 */     GIR_RootConstrainSelectedInstOperands,
     /*  522856 */     // GIR_Coverage, 20889,
     /*  522856 */     GIR_EraseRootFromParent_Done,
     /*  522857 */   // Label 8673: @522857
     /*  522857 */   GIM_Try, /*On fail goto*//*Label 8674*/ GIMT_Encode4(522928), // Rule ID 20892 //
     /*  522862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  522865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  522873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  522876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  522879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  522882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522894 */     // MIs[0] round
     /*  522894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  522904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  522907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522913 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522926 */     GIR_RootConstrainSelectedInstOperands,
     /*  522927 */     // GIR_Coverage, 20892,
     /*  522927 */     GIR_EraseRootFromParent_Done,
     /*  522928 */   // Label 8674: @522928
     /*  522928 */   GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(522999), // Rule ID 20893 //
     /*  522933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  522936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  522941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  522944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  522947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  522950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  522953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  522965 */     // MIs[0] round
     /*  522965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  522968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  522975 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11120:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  522975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /*  522978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  522980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  522982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  522984 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  522986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  522991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  522994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  522997 */     GIR_RootConstrainSelectedInstOperands,
     /*  522998 */     // GIR_Coverage, 20893,
     /*  522998 */     GIR_EraseRootFromParent_Done,
     /*  522999 */   // Label 8675: @522999
     /*  522999 */   GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(523070), // Rule ID 20896 //
     /*  523004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523036 */     // MIs[0] round
     /*  523036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523046 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523055 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523068 */     GIR_RootConstrainSelectedInstOperands,
     /*  523069 */     // GIR_Coverage, 20896,
     /*  523069 */     GIR_EraseRootFromParent_Done,
     /*  523070 */   // Label 8676: @523070
     /*  523070 */   GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(523141), // Rule ID 20897 //
     /*  523075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  523086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  523089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  523092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523107 */     // MIs[0] round
     /*  523107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523117 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /*  523120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523126 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523139 */     GIR_RootConstrainSelectedInstOperands,
     /*  523140 */     // GIR_Coverage, 20897,
     /*  523140 */     GIR_EraseRootFromParent_Done,
     /*  523141 */   // Label 8677: @523141
     /*  523141 */   GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(523212), // Rule ID 20900 //
     /*  523146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523178 */     // MIs[0] round
     /*  523178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523188 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523197 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523210 */     GIR_RootConstrainSelectedInstOperands,
     /*  523211 */     // GIR_Coverage, 20900,
     /*  523211 */     GIR_EraseRootFromParent_Done,
     /*  523212 */   // Label 8678: @523212
     /*  523212 */   GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(523283), // Rule ID 20901 //
     /*  523217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  523228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  523231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  523234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523249 */     // MIs[0] round
     /*  523249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523259 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /*  523262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523268 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523281 */     GIR_RootConstrainSelectedInstOperands,
     /*  523282 */     // GIR_Coverage, 20901,
     /*  523282 */     GIR_EraseRootFromParent_Done,
     /*  523283 */   // Label 8679: @523283
     /*  523283 */   GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(523354), // Rule ID 20904 //
     /*  523288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  523291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523320 */     // MIs[0] round
     /*  523320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523330 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  523330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523339 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523352 */     GIR_RootConstrainSelectedInstOperands,
     /*  523353 */     // GIR_Coverage, 20904,
     /*  523353 */     GIR_EraseRootFromParent_Done,
     /*  523354 */   // Label 8680: @523354
     /*  523354 */   GIM_Try, /*On fail goto*//*Label 8681*/ GIMT_Encode4(523425), // Rule ID 20905 //
     /*  523359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  523362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  523370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  523373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  523376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523391 */     // MIs[0] round
     /*  523391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523401 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  523401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /*  523404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523410 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  523420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523423 */     GIR_RootConstrainSelectedInstOperands,
     /*  523424 */     // GIR_Coverage, 20905,
     /*  523424 */     GIR_EraseRootFromParent_Done,
     /*  523425 */   // Label 8681: @523425
     /*  523425 */   GIM_Try, /*On fail goto*//*Label 8682*/ GIMT_Encode4(523496), // Rule ID 20908 //
     /*  523430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523462 */     // MIs[0] round
     /*  523462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  523475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523481 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523494 */     GIR_RootConstrainSelectedInstOperands,
     /*  523495 */     // GIR_Coverage, 20908,
     /*  523495 */     GIR_EraseRootFromParent_Done,
     /*  523496 */   // Label 8682: @523496
     /*  523496 */   GIM_Try, /*On fail goto*//*Label 8683*/ GIMT_Encode4(523567), // Rule ID 20909 //
     /*  523501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  523512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  523515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  523518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523533 */     // MIs[0] round
     /*  523533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523543 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /*  523546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523552 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523565 */     GIR_RootConstrainSelectedInstOperands,
     /*  523566 */     // GIR_Coverage, 20909,
     /*  523566 */     GIR_EraseRootFromParent_Done,
     /*  523567 */   // Label 8683: @523567
     /*  523567 */   GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(523638), // Rule ID 20912 //
     /*  523572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523604 */     // MIs[0] round
     /*  523604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523614 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  523617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523623 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523636 */     GIR_RootConstrainSelectedInstOperands,
     /*  523637 */     // GIR_Coverage, 20912,
     /*  523637 */     GIR_EraseRootFromParent_Done,
     /*  523638 */   // Label 8684: @523638
     /*  523638 */   GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(523709), // Rule ID 20913 //
     /*  523643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  523654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  523657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  523660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  523675 */     // MIs[0] round
     /*  523675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523685 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /*  523688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523694 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523707 */     GIR_RootConstrainSelectedInstOperands,
     /*  523708 */     // GIR_Coverage, 20913,
     /*  523708 */     GIR_EraseRootFromParent_Done,
     /*  523709 */   // Label 8685: @523709
     /*  523709 */   GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(523780), // Rule ID 20916 //
     /*  523714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  523717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523746 */     // MIs[0] round
     /*  523746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  523756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  523759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523765 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523778 */     GIR_RootConstrainSelectedInstOperands,
     /*  523779 */     // GIR_Coverage, 20916,
     /*  523779 */     GIR_EraseRootFromParent_Done,
     /*  523780 */   // Label 8686: @523780
     /*  523780 */   GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(523851), // Rule ID 20917 //
     /*  523785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  523788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  523796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  523799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  523802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  523817 */     // MIs[0] round
     /*  523817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523827 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  523827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /*  523830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523836 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  523846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523849 */     GIR_RootConstrainSelectedInstOperands,
     /*  523850 */     // GIR_Coverage, 20917,
     /*  523850 */     GIR_EraseRootFromParent_Done,
     /*  523851 */   // Label 8687: @523851
     /*  523851 */   GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(523922), // Rule ID 20920 //
     /*  523856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  523859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  523876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523888 */     // MIs[0] round
     /*  523888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523898 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  523898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  523901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523907 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523920 */     GIR_RootConstrainSelectedInstOperands,
     /*  523921 */     // GIR_Coverage, 20920,
     /*  523921 */     GIR_EraseRootFromParent_Done,
     /*  523922 */   // Label 8688: @523922
     /*  523922 */   GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(523993), // Rule ID 20921 //
     /*  523927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  523930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  523935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  523938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  523941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  523944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  523947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  523959 */     // MIs[0] round
     /*  523959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  523962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  523969 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11120:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  523969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /*  523972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  523974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  523976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  523978 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  523980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  523985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  523988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  523991 */     GIR_RootConstrainSelectedInstOperands,
     /*  523992 */     // GIR_Coverage, 20921,
     /*  523992 */     GIR_EraseRootFromParent_Done,
     /*  523993 */   // Label 8689: @523993
     /*  523993 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(524064), // Rule ID 20924 //
     /*  523998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524030 */     // MIs[0] round
     /*  524030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524040 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524049 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524062 */     GIR_RootConstrainSelectedInstOperands,
     /*  524063 */     // GIR_Coverage, 20924,
     /*  524063 */     GIR_EraseRootFromParent_Done,
     /*  524064 */   // Label 8690: @524064
     /*  524064 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(524135), // Rule ID 20925 //
     /*  524069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  524080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  524083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  524086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  524101 */     // MIs[0] round
     /*  524101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524111 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11120:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /*  524114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524120 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524133 */     GIR_RootConstrainSelectedInstOperands,
     /*  524134 */     // GIR_Coverage, 20925,
     /*  524134 */     GIR_EraseRootFromParent_Done,
     /*  524135 */   // Label 8691: @524135
     /*  524135 */   GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(524206), // Rule ID 20928 //
     /*  524140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524172 */     // MIs[0] round
     /*  524172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524182 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  524182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524191 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524204 */     GIR_RootConstrainSelectedInstOperands,
     /*  524205 */     // GIR_Coverage, 20928,
     /*  524205 */     GIR_EraseRootFromParent_Done,
     /*  524206 */   // Label 8692: @524206
     /*  524206 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(524277), // Rule ID 20929 //
     /*  524211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  524214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v),
     /*  524219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  524222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  524225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  524228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  524243 */     // MIs[0] round
     /*  524243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524253 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11120:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  524253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /*  524256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524262 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  524272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524275 */     GIR_RootConstrainSelectedInstOperands,
     /*  524276 */     // GIR_Coverage, 20929,
     /*  524276 */     GIR_EraseRootFromParent_Done,
     /*  524277 */   // Label 8693: @524277
     /*  524277 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(524348), // Rule ID 20932 //
     /*  524282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524314 */     // MIs[0] round
     /*  524314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524324 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524333 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524346 */     GIR_RootConstrainSelectedInstOperands,
     /*  524347 */     // GIR_Coverage, 20932,
     /*  524347 */     GIR_EraseRootFromParent_Done,
     /*  524348 */   // Label 8694: @524348
     /*  524348 */   GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(524419), // Rule ID 20933 //
     /*  524353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  524364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  524367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  524370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524385 */     // MIs[0] round
     /*  524385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524395 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /*  524398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524404 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524417 */     GIR_RootConstrainSelectedInstOperands,
     /*  524418 */     // GIR_Coverage, 20933,
     /*  524418 */     GIR_EraseRootFromParent_Done,
     /*  524419 */   // Label 8695: @524419
     /*  524419 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(524490), // Rule ID 20936 //
     /*  524424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524456 */     // MIs[0] round
     /*  524456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524466 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  524469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524475 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524488 */     GIR_RootConstrainSelectedInstOperands,
     /*  524489 */     // GIR_Coverage, 20936,
     /*  524489 */     GIR_EraseRootFromParent_Done,
     /*  524490 */   // Label 8696: @524490
     /*  524490 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(524561), // Rule ID 20937 //
     /*  524495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  524506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  524509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  524512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524527 */     // MIs[0] round
     /*  524527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524537 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /*  524540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524546 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524559 */     GIR_RootConstrainSelectedInstOperands,
     /*  524560 */     // GIR_Coverage, 20937,
     /*  524560 */     GIR_EraseRootFromParent_Done,
     /*  524561 */   // Label 8697: @524561
     /*  524561 */   GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(524632), // Rule ID 20940 //
     /*  524566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524598 */     // MIs[0] round
     /*  524598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524608 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  524611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524617 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524630 */     GIR_RootConstrainSelectedInstOperands,
     /*  524631 */     // GIR_Coverage, 20940,
     /*  524631 */     GIR_EraseRootFromParent_Done,
     /*  524632 */   // Label 8698: @524632
     /*  524632 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(524703), // Rule ID 20941 //
     /*  524637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  524648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  524651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  524654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524669 */     // MIs[0] round
     /*  524669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524679 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /*  524682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524688 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524701 */     GIR_RootConstrainSelectedInstOperands,
     /*  524702 */     // GIR_Coverage, 20941,
     /*  524702 */     GIR_EraseRootFromParent_Done,
     /*  524703 */   // Label 8699: @524703
     /*  524703 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(524774), // Rule ID 20944 //
     /*  524708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  524711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524740 */     // MIs[0] round
     /*  524740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  524750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  524753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524759 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524772 */     GIR_RootConstrainSelectedInstOperands,
     /*  524773 */     // GIR_Coverage, 20944,
     /*  524773 */     GIR_EraseRootFromParent_Done,
     /*  524774 */   // Label 8700: @524774
     /*  524774 */   GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(524845), // Rule ID 20945 //
     /*  524779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  524782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  524790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  524793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  524796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524811 */     // MIs[0] round
     /*  524811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524821 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11122:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  524821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /*  524824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524830 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  524840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524843 */     GIR_RootConstrainSelectedInstOperands,
     /*  524844 */     // GIR_Coverage, 20945,
     /*  524844 */     GIR_EraseRootFromParent_Done,
     /*  524845 */   // Label 8701: @524845
     /*  524845 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(524916), // Rule ID 20948 //
     /*  524850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  524853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  524861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  524864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  524867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  524870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524882 */     // MIs[0] round
     /*  524882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  524892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  524895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524901 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524914 */     GIR_RootConstrainSelectedInstOperands,
     /*  524915 */     // GIR_Coverage, 20948,
     /*  524915 */     GIR_EraseRootFromParent_Done,
     /*  524916 */   // Label 8702: @524916
     /*  524916 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(524987), // Rule ID 20949 //
     /*  524921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  524924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  524929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  524932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  524935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  524938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  524941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  524953 */     // MIs[0] round
     /*  524953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  524956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  524963 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11122:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  524963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /*  524966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  524968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  524970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  524972 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  524974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  524979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  524982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  524985 */     GIR_RootConstrainSelectedInstOperands,
     /*  524986 */     // GIR_Coverage, 20949,
     /*  524986 */     GIR_EraseRootFromParent_Done,
     /*  524987 */   // Label 8703: @524987
     /*  524987 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(525058), // Rule ID 20952 //
     /*  524992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  524995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525024 */     // MIs[0] round
     /*  525024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525034 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  525034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525043 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525056 */     GIR_RootConstrainSelectedInstOperands,
     /*  525057 */     // GIR_Coverage, 20952,
     /*  525057 */     GIR_EraseRootFromParent_Done,
     /*  525058 */   // Label 8704: @525058
     /*  525058 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(525129), // Rule ID 20953 //
     /*  525063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  525066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  525074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  525077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  525080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  525095 */     // MIs[0] round
     /*  525095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525105 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11122:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  525105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /*  525108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525114 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  525124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525127 */     GIR_RootConstrainSelectedInstOperands,
     /*  525128 */     // GIR_Coverage, 20953,
     /*  525128 */     GIR_EraseRootFromParent_Done,
     /*  525129 */   // Label 8705: @525129
     /*  525129 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(525200), // Rule ID 20956 //
     /*  525134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525166 */     // MIs[0] round
     /*  525166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525176 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525185 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525198 */     GIR_RootConstrainSelectedInstOperands,
     /*  525199 */     // GIR_Coverage, 20956,
     /*  525199 */     GIR_EraseRootFromParent_Done,
     /*  525200 */   // Label 8706: @525200
     /*  525200 */   GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(525271), // Rule ID 20957 //
     /*  525205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  525216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  525219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  525222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525237 */     // MIs[0] round
     /*  525237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525247 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /*  525250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525256 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525269 */     GIR_RootConstrainSelectedInstOperands,
     /*  525270 */     // GIR_Coverage, 20957,
     /*  525270 */     GIR_EraseRootFromParent_Done,
     /*  525271 */   // Label 8707: @525271
     /*  525271 */   GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(525342), // Rule ID 20960 //
     /*  525276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525308 */     // MIs[0] round
     /*  525308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525318 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525327 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525340 */     GIR_RootConstrainSelectedInstOperands,
     /*  525341 */     // GIR_Coverage, 20960,
     /*  525341 */     GIR_EraseRootFromParent_Done,
     /*  525342 */   // Label 8708: @525342
     /*  525342 */   GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(525413), // Rule ID 20961 //
     /*  525347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  525358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  525361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  525364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525379 */     // MIs[0] round
     /*  525379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525389 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /*  525392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525398 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525411 */     GIR_RootConstrainSelectedInstOperands,
     /*  525412 */     // GIR_Coverage, 20961,
     /*  525412 */     GIR_EraseRootFromParent_Done,
     /*  525413 */   // Label 8709: @525413
     /*  525413 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(525484), // Rule ID 20964 //
     /*  525418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  525421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525450 */     // MIs[0] round
     /*  525450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525460 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  525460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  525463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525469 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525482 */     GIR_RootConstrainSelectedInstOperands,
     /*  525483 */     // GIR_Coverage, 20964,
     /*  525483 */     GIR_EraseRootFromParent_Done,
     /*  525484 */   // Label 8710: @525484
     /*  525484 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(525555), // Rule ID 20965 //
     /*  525489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  525492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  525500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  525503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  525506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525521 */     // MIs[0] round
     /*  525521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525531 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  525531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /*  525534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525540 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  525550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525553 */     GIR_RootConstrainSelectedInstOperands,
     /*  525554 */     // GIR_Coverage, 20965,
     /*  525554 */     GIR_EraseRootFromParent_Done,
     /*  525555 */   // Label 8711: @525555
     /*  525555 */   GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(525626), // Rule ID 20968 //
     /*  525560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525592 */     // MIs[0] round
     /*  525592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525602 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  525605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525611 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525624 */     GIR_RootConstrainSelectedInstOperands,
     /*  525625 */     // GIR_Coverage, 20968,
     /*  525625 */     GIR_EraseRootFromParent_Done,
     /*  525626 */   // Label 8712: @525626
     /*  525626 */   GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(525697), // Rule ID 20969 //
     /*  525631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  525642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  525645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  525648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  525663 */     // MIs[0] round
     /*  525663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525673 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /*  525676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525682 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525695 */     GIR_RootConstrainSelectedInstOperands,
     /*  525696 */     // GIR_Coverage, 20969,
     /*  525696 */     GIR_EraseRootFromParent_Done,
     /*  525697 */   // Label 8713: @525697
     /*  525697 */   GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(525768), // Rule ID 20972 //
     /*  525702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525734 */     // MIs[0] round
     /*  525734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  525747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525753 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525766 */     GIR_RootConstrainSelectedInstOperands,
     /*  525767 */     // GIR_Coverage, 20972,
     /*  525767 */     GIR_EraseRootFromParent_Done,
     /*  525768 */   // Label 8714: @525768
     /*  525768 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(525839), // Rule ID 20973 //
     /*  525773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  525784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  525787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  525790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  525805 */     // MIs[0] round
     /*  525805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525815 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /*  525818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525824 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525837 */     GIR_RootConstrainSelectedInstOperands,
     /*  525838 */     // GIR_Coverage, 20973,
     /*  525838 */     GIR_EraseRootFromParent_Done,
     /*  525839 */   // Label 8715: @525839
     /*  525839 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(525910), // Rule ID 20976 //
     /*  525844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  525847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  525855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  525858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  525861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  525864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525876 */     // MIs[0] round
     /*  525876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  525886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  525889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525895 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525908 */     GIR_RootConstrainSelectedInstOperands,
     /*  525909 */     // GIR_Coverage, 20976,
     /*  525909 */     GIR_EraseRootFromParent_Done,
     /*  525910 */   // Label 8716: @525910
     /*  525910 */   GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(525981), // Rule ID 20977 //
     /*  525915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  525918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  525926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  525929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  525932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  525935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  525947 */     // MIs[0] round
     /*  525947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  525950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  525957 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  525957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /*  525960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  525962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  525964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  525966 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  525968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  525973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  525976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  525979 */     GIR_RootConstrainSelectedInstOperands,
     /*  525980 */     // GIR_Coverage, 20977,
     /*  525980 */     GIR_EraseRootFromParent_Done,
     /*  525981 */   // Label 8717: @525981
     /*  525981 */   GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(526052), // Rule ID 20980 //
     /*  525986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  525989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  525994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  525997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526018 */     // MIs[0] round
     /*  526018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526028 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526037 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526050 */     GIR_RootConstrainSelectedInstOperands,
     /*  526051 */     // GIR_Coverage, 20980,
     /*  526051 */     GIR_EraseRootFromParent_Done,
     /*  526052 */   // Label 8718: @526052
     /*  526052 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(526123), // Rule ID 20981 //
     /*  526057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  526068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  526071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  526074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526089 */     // MIs[0] round
     /*  526089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526099 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11122:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /*  526102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526108 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526121 */     GIR_RootConstrainSelectedInstOperands,
     /*  526122 */     // GIR_Coverage, 20981,
     /*  526122 */     GIR_EraseRootFromParent_Done,
     /*  526123 */   // Label 8719: @526123
     /*  526123 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(526194), // Rule ID 20984 //
     /*  526128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526160 */     // MIs[0] round
     /*  526160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526179 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526192 */     GIR_RootConstrainSelectedInstOperands,
     /*  526193 */     // GIR_Coverage, 20984,
     /*  526193 */     GIR_EraseRootFromParent_Done,
     /*  526194 */   // Label 8720: @526194
     /*  526194 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(526265), // Rule ID 20985 //
     /*  526199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  526210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  526213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  526216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526231 */     // MIs[0] round
     /*  526231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526241 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11122:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /*  526244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526250 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526263 */     GIR_RootConstrainSelectedInstOperands,
     /*  526264 */     // GIR_Coverage, 20985,
     /*  526264 */     GIR_EraseRootFromParent_Done,
     /*  526265 */   // Label 8721: @526265
     /*  526265 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(526336), // Rule ID 20988 //
     /*  526270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /*  526273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526302 */     // MIs[0] round
     /*  526302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526312 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  526312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526321 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526334 */     GIR_RootConstrainSelectedInstOperands,
     /*  526335 */     // GIR_Coverage, 20988,
     /*  526335 */     GIR_EraseRootFromParent_Done,
     /*  526336 */   // Label 8722: @526336
     /*  526336 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(526407), // Rule ID 20989 //
     /*  526341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /*  526344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v),
     /*  526349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  526352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  526355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  526358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  526373 */     // MIs[0] round
     /*  526373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526383 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11122:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  526383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /*  526386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526392 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  526402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526405 */     GIR_RootConstrainSelectedInstOperands,
     /*  526406 */     // GIR_Coverage, 20989,
     /*  526406 */     GIR_EraseRootFromParent_Done,
     /*  526407 */   // Label 8723: @526407
     /*  526407 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(526478), // Rule ID 21064 //
     /*  526412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526444 */     // MIs[0] round
     /*  526444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526454 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  526457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526463 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526476 */     GIR_RootConstrainSelectedInstOperands,
     /*  526477 */     // GIR_Coverage, 21064,
     /*  526477 */     GIR_EraseRootFromParent_Done,
     /*  526478 */   // Label 8724: @526478
     /*  526478 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(526549), // Rule ID 21065 //
     /*  526483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  526494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  526497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  526500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526515 */     // MIs[0] round
     /*  526515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526525 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4),
     /*  526528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526534 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526547 */     GIR_RootConstrainSelectedInstOperands,
     /*  526548 */     // GIR_Coverage, 21065,
     /*  526548 */     GIR_EraseRootFromParent_Done,
     /*  526549 */   // Label 8725: @526549
     /*  526549 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(526620), // Rule ID 21068 //
     /*  526554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  526565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  526568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526586 */     // MIs[0] round
     /*  526586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  526599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526605 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526618 */     GIR_RootConstrainSelectedInstOperands,
     /*  526619 */     // GIR_Coverage, 21068,
     /*  526619 */     GIR_EraseRootFromParent_Done,
     /*  526620 */   // Label 8726: @526620
     /*  526620 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(526691), // Rule ID 21069 //
     /*  526625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  526636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  526639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  526642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526657 */     // MIs[0] round
     /*  526657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11226:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  526670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526676 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526689 */     GIR_RootConstrainSelectedInstOperands,
     /*  526690 */     // GIR_Coverage, 21069,
     /*  526690 */     GIR_EraseRootFromParent_Done,
     /*  526691 */   // Label 8727: @526691
     /*  526691 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(526762), // Rule ID 21072 //
     /*  526696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  526713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526728 */     // MIs[0] round
     /*  526728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  526741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526747 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526760 */     GIR_RootConstrainSelectedInstOperands,
     /*  526761 */     // GIR_Coverage, 21072,
     /*  526761 */     GIR_EraseRootFromParent_Done,
     /*  526762 */   // Label 8728: @526762
     /*  526762 */   GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(526833), // Rule ID 21073 //
     /*  526767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  526778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  526781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  526784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  526799 */     // MIs[0] round
     /*  526799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  526812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526818 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526831 */     GIR_RootConstrainSelectedInstOperands,
     /*  526832 */     // GIR_Coverage, 21073,
     /*  526832 */     GIR_EraseRootFromParent_Done,
     /*  526833 */   // Label 8729: @526833
     /*  526833 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(526904), // Rule ID 21076 //
     /*  526838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  526858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526870 */     // MIs[0] round
     /*  526870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  526880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  526883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526889 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526902 */     GIR_RootConstrainSelectedInstOperands,
     /*  526903 */     // GIR_Coverage, 21076,
     /*  526903 */     GIR_EraseRootFromParent_Done,
     /*  526904 */   // Label 8730: @526904
     /*  526904 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(526975), // Rule ID 21077 //
     /*  526909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  526912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  526920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  526923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  526926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  526929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  526937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  526941 */     // MIs[0] round
     /*  526941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  526944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  526951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  526951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  526954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  526956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  526958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  526960 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  526962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  526967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  526970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  526973 */     GIR_RootConstrainSelectedInstOperands,
     /*  526974 */     // GIR_Coverage, 21077,
     /*  526974 */     GIR_EraseRootFromParent_Done,
     /*  526975 */   // Label 8731: @526975
     /*  526975 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(527046), // Rule ID 21080 //
     /*  526980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  526983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  526988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  526991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  526994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  526997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527012 */     // MIs[0] round
     /*  527012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527022 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527031 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527044 */     GIR_RootConstrainSelectedInstOperands,
     /*  527045 */     // GIR_Coverage, 21080,
     /*  527045 */     GIR_EraseRootFromParent_Done,
     /*  527046 */   // Label 8732: @527046
     /*  527046 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(527117), // Rule ID 21081 //
     /*  527051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  527062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  527065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  527068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527083 */     // MIs[0] round
     /*  527083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527093 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527102 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527115 */     GIR_RootConstrainSelectedInstOperands,
     /*  527116 */     // GIR_Coverage, 21081,
     /*  527116 */     GIR_EraseRootFromParent_Done,
     /*  527117 */   // Label 8733: @527117
     /*  527117 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(527188), // Rule ID 21084 //
     /*  527122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527154 */     // MIs[0] round
     /*  527154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527164 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527173 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527186 */     GIR_RootConstrainSelectedInstOperands,
     /*  527187 */     // GIR_Coverage, 21084,
     /*  527187 */     GIR_EraseRootFromParent_Done,
     /*  527188 */   // Label 8734: @527188
     /*  527188 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(527259), // Rule ID 21085 //
     /*  527193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  527204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  527207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  527210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527225 */     // MIs[0] round
     /*  527225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527235 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11226:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2),
     /*  527238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527244 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527257 */     GIR_RootConstrainSelectedInstOperands,
     /*  527258 */     // GIR_Coverage, 21085,
     /*  527258 */     GIR_EraseRootFromParent_Done,
     /*  527259 */   // Label 8735: @527259
     /*  527259 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(527330), // Rule ID 21088 //
     /*  527264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527296 */     // MIs[0] round
     /*  527296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527315 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527328 */     GIR_RootConstrainSelectedInstOperands,
     /*  527329 */     // GIR_Coverage, 21088,
     /*  527329 */     GIR_EraseRootFromParent_Done,
     /*  527330 */   // Label 8736: @527330
     /*  527330 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(527401), // Rule ID 21089 //
     /*  527335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  527346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  527349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  527352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527367 */     // MIs[0] round
     /*  527367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11226:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1),
     /*  527380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527386 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527399 */     GIR_RootConstrainSelectedInstOperands,
     /*  527400 */     // GIR_Coverage, 21089,
     /*  527400 */     GIR_EraseRootFromParent_Done,
     /*  527401 */   // Label 8737: @527401
     /*  527401 */   GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(527472), // Rule ID 21092 //
     /*  527406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527438 */     // MIs[0] round
     /*  527438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527448 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527457 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527470 */     GIR_RootConstrainSelectedInstOperands,
     /*  527471 */     // GIR_Coverage, 21092,
     /*  527471 */     GIR_EraseRootFromParent_Done,
     /*  527472 */   // Label 8738: @527472
     /*  527472 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(527543), // Rule ID 21093 //
     /*  527477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  527488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  527491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  527494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527509 */     // MIs[0] round
     /*  527509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11226:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2),
     /*  527522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527528 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527541 */     GIR_RootConstrainSelectedInstOperands,
     /*  527542 */     // GIR_Coverage, 21093,
     /*  527542 */     GIR_EraseRootFromParent_Done,
     /*  527543 */   // Label 8739: @527543
     /*  527543 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(527614), // Rule ID 21096 //
     /*  527548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  527551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  527565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527580 */     // MIs[0] round
     /*  527580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  527590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527599 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527612 */     GIR_RootConstrainSelectedInstOperands,
     /*  527613 */     // GIR_Coverage, 21096,
     /*  527613 */     GIR_EraseRootFromParent_Done,
     /*  527614 */   // Label 8740: @527614
     /*  527614 */   GIM_Try, /*On fail goto*//*Label 8741*/ GIMT_Encode4(527685), // Rule ID 21097 //
     /*  527619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  527622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v),
     /*  527627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  527630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  527633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  527636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  527647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  527651 */     // MIs[0] round
     /*  527651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527661 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11226:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_XU_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  527661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4),
     /*  527664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527670 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  527680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527683 */     GIR_RootConstrainSelectedInstOperands,
     /*  527684 */     // GIR_Coverage, 21097,
     /*  527684 */     GIR_EraseRootFromParent_Done,
     /*  527685 */   // Label 8741: @527685
     /*  527685 */   GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(527756), // Rule ID 21100 //
     /*  527690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  527698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527722 */     // MIs[0] round
     /*  527722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527732 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  527735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527741 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527754 */     GIR_RootConstrainSelectedInstOperands,
     /*  527755 */     // GIR_Coverage, 21100,
     /*  527755 */     GIR_EraseRootFromParent_Done,
     /*  527756 */   // Label 8742: @527756
     /*  527756 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(527827), // Rule ID 21101 //
     /*  527761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  527769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  527772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  527775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  527778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527793 */     // MIs[0] round
     /*  527793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527803 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4),
     /*  527806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527812 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527825 */     GIR_RootConstrainSelectedInstOperands,
     /*  527826 */     // GIR_Coverage, 21101,
     /*  527826 */     GIR_EraseRootFromParent_Done,
     /*  527827 */   // Label 8743: @527827
     /*  527827 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(527898), // Rule ID 21104 //
     /*  527832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  527840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527864 */     // MIs[0] round
     /*  527864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527874 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  527874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  527877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527883 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527896 */     GIR_RootConstrainSelectedInstOperands,
     /*  527897 */     // GIR_Coverage, 21104,
     /*  527897 */     GIR_EraseRootFromParent_Done,
     /*  527898 */   // Label 8744: @527898
     /*  527898 */   GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(527969), // Rule ID 21105 //
     /*  527903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  527906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  527911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  527914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  527917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  527920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  527923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  527935 */     // MIs[0] round
     /*  527935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  527938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  527945 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11224:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  527945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  527948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  527950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  527952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  527954 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  527956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  527961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  527964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  527967 */     GIR_RootConstrainSelectedInstOperands,
     /*  527968 */     // GIR_Coverage, 21105,
     /*  527968 */     GIR_EraseRootFromParent_Done,
     /*  527969 */   // Label 8745: @527969
     /*  527969 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(528040), // Rule ID 21108 //
     /*  527974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  527977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  527982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  527985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  527988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  527991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  527994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  527998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528006 */     // MIs[0] round
     /*  528006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528016 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528025 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528038 */     GIR_RootConstrainSelectedInstOperands,
     /*  528039 */     // GIR_Coverage, 21108,
     /*  528039 */     GIR_EraseRootFromParent_Done,
     /*  528040 */   // Label 8746: @528040
     /*  528040 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(528111), // Rule ID 21109 //
     /*  528045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  528056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  528059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  528062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528077 */     // MIs[0] round
     /*  528077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528087 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528096 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528109 */     GIR_RootConstrainSelectedInstOperands,
     /*  528110 */     // GIR_Coverage, 21109,
     /*  528110 */     GIR_EraseRootFromParent_Done,
     /*  528111 */   // Label 8747: @528111
     /*  528111 */   GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(528182), // Rule ID 21112 //
     /*  528116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528148 */     // MIs[0] round
     /*  528148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528158 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528167 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528180 */     GIR_RootConstrainSelectedInstOperands,
     /*  528181 */     // GIR_Coverage, 21112,
     /*  528181 */     GIR_EraseRootFromParent_Done,
     /*  528182 */   // Label 8748: @528182
     /*  528182 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(528253), // Rule ID 21113 //
     /*  528187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  528198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  528201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  528204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528219 */     // MIs[0] round
     /*  528219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528229 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528238 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528251 */     GIR_RootConstrainSelectedInstOperands,
     /*  528252 */     // GIR_Coverage, 21113,
     /*  528252 */     GIR_EraseRootFromParent_Done,
     /*  528253 */   // Label 8749: @528253
     /*  528253 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(528324), // Rule ID 21116 //
     /*  528258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528290 */     // MIs[0] round
     /*  528290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528300 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  528300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528309 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528322 */     GIR_RootConstrainSelectedInstOperands,
     /*  528323 */     // GIR_Coverage, 21116,
     /*  528323 */     GIR_EraseRootFromParent_Done,
     /*  528324 */   // Label 8750: @528324
     /*  528324 */   GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(528395), // Rule ID 21117 //
     /*  528329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  528332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  528340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  528343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  528346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528361 */     // MIs[0] round
     /*  528361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  528371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528380 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  528390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528393 */     GIR_RootConstrainSelectedInstOperands,
     /*  528394 */     // GIR_Coverage, 21117,
     /*  528394 */     GIR_EraseRootFromParent_Done,
     /*  528395 */   // Label 8751: @528395
     /*  528395 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(528466), // Rule ID 21120 //
     /*  528400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528432 */     // MIs[0] round
     /*  528432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528442 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528451 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528464 */     GIR_RootConstrainSelectedInstOperands,
     /*  528465 */     // GIR_Coverage, 21120,
     /*  528465 */     GIR_EraseRootFromParent_Done,
     /*  528466 */   // Label 8752: @528466
     /*  528466 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(528537), // Rule ID 21121 //
     /*  528471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  528482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  528485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  528488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528503 */     // MIs[0] round
     /*  528503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528513 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11224:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2),
     /*  528516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528522 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528535 */     GIR_RootConstrainSelectedInstOperands,
     /*  528536 */     // GIR_Coverage, 21121,
     /*  528536 */     GIR_EraseRootFromParent_Done,
     /*  528537 */   // Label 8753: @528537
     /*  528537 */   GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(528608), // Rule ID 21124 //
     /*  528542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528574 */     // MIs[0] round
     /*  528574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528593 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528606 */     GIR_RootConstrainSelectedInstOperands,
     /*  528607 */     // GIR_Coverage, 21124,
     /*  528607 */     GIR_EraseRootFromParent_Done,
     /*  528608 */   // Label 8754: @528608
     /*  528608 */   GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(528679), // Rule ID 21125 //
     /*  528613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  528624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  528627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  528630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528645 */     // MIs[0] round
     /*  528645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528655 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11224:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1),
     /*  528658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528664 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528677 */     GIR_RootConstrainSelectedInstOperands,
     /*  528678 */     // GIR_Coverage, 21125,
     /*  528678 */     GIR_EraseRootFromParent_Done,
     /*  528679 */   // Label 8755: @528679
     /*  528679 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(528750), // Rule ID 21128 //
     /*  528684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528716 */     // MIs[0] round
     /*  528716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528726 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528735 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528748 */     GIR_RootConstrainSelectedInstOperands,
     /*  528749 */     // GIR_Coverage, 21128,
     /*  528749 */     GIR_EraseRootFromParent_Done,
     /*  528750 */   // Label 8756: @528750
     /*  528750 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(528821), // Rule ID 21129 //
     /*  528755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  528766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  528769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  528772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  528787 */     // MIs[0] round
     /*  528787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528797 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11224:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2),
     /*  528800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528806 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528819 */     GIR_RootConstrainSelectedInstOperands,
     /*  528820 */     // GIR_Coverage, 21129,
     /*  528820 */     GIR_EraseRootFromParent_Done,
     /*  528821 */   // Label 8757: @528821
     /*  528821 */   GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(528892), // Rule ID 21132 //
     /*  528826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  528829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528858 */     // MIs[0] round
     /*  528858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  528868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528877 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528890 */     GIR_RootConstrainSelectedInstOperands,
     /*  528891 */     // GIR_Coverage, 21132,
     /*  528891 */     GIR_EraseRootFromParent_Done,
     /*  528892 */   // Label 8758: @528892
     /*  528892 */   GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(528963), // Rule ID 21133 //
     /*  528897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  528900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v),
     /*  528905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  528908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  528911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  528914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  528917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  528925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  528929 */     // MIs[0] round
     /*  528929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  528932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  528939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11224:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWCVT_X_F_V_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  528939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4),
     /*  528942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  528944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  528946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  528948 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  528950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  528955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  528958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  528961 */     GIR_RootConstrainSelectedInstOperands,
     /*  528962 */     // GIR_Coverage, 21133,
     /*  528962 */     GIR_EraseRootFromParent_Done,
     /*  528963 */   // Label 8759: @528963
     /*  528963 */   GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(529034), // Rule ID 21484 //
     /*  528968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  528971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  528976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  528979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  528982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  528985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  528988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  528996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529000 */     // MIs[0] round
     /*  529000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529019 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529032 */     GIR_RootConstrainSelectedInstOperands,
     /*  529033 */     // GIR_Coverage, 21484,
     /*  529033 */     GIR_EraseRootFromParent_Done,
     /*  529034 */   // Label 8760: @529034
     /*  529034 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(529105), // Rule ID 21485 //
     /*  529039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  529050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  529053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  529056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529071 */     // MIs[0] round
     /*  529071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529081 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8),
     /*  529084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529090 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529103 */     GIR_RootConstrainSelectedInstOperands,
     /*  529104 */     // GIR_Coverage, 21485,
     /*  529104 */     GIR_EraseRootFromParent_Done,
     /*  529105 */   // Label 8761: @529105
     /*  529105 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(529176), // Rule ID 21488 //
     /*  529110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529142 */     // MIs[0] round
     /*  529142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529161 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529174 */     GIR_RootConstrainSelectedInstOperands,
     /*  529175 */     // GIR_Coverage, 21488,
     /*  529175 */     GIR_EraseRootFromParent_Done,
     /*  529176 */   // Label 8762: @529176
     /*  529176 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(529247), // Rule ID 21489 //
     /*  529181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  529192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  529195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  529198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529213 */     // MIs[0] round
     /*  529213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529223 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529232 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529245 */     GIR_RootConstrainSelectedInstOperands,
     /*  529246 */     // GIR_Coverage, 21489,
     /*  529246 */     GIR_EraseRootFromParent_Done,
     /*  529247 */   // Label 8763: @529247
     /*  529247 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(529318), // Rule ID 21492 //
     /*  529252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529284 */     // MIs[0] round
     /*  529284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529303 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529316 */     GIR_RootConstrainSelectedInstOperands,
     /*  529317 */     // GIR_Coverage, 21492,
     /*  529317 */     GIR_EraseRootFromParent_Done,
     /*  529318 */   // Label 8764: @529318
     /*  529318 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(529389), // Rule ID 21493 //
     /*  529323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  529334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  529337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  529340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529355 */     // MIs[0] round
     /*  529355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529365 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  529368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529374 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529387 */     GIR_RootConstrainSelectedInstOperands,
     /*  529388 */     // GIR_Coverage, 21493,
     /*  529388 */     GIR_EraseRootFromParent_Done,
     /*  529389 */   // Label 8765: @529389
     /*  529389 */   GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(529460), // Rule ID 21496 //
     /*  529394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529426 */     // MIs[0] round
     /*  529426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  529439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529445 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529458 */     GIR_RootConstrainSelectedInstOperands,
     /*  529459 */     // GIR_Coverage, 21496,
     /*  529459 */     GIR_EraseRootFromParent_Done,
     /*  529460 */   // Label 8766: @529460
     /*  529460 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(529531), // Rule ID 21497 //
     /*  529465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  529476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  529479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  529482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529497 */     // MIs[0] round
     /*  529497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529507 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11168:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  529510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529516 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529529 */     GIR_RootConstrainSelectedInstOperands,
     /*  529530 */     // GIR_Coverage, 21497,
     /*  529530 */     GIR_EraseRootFromParent_Done,
     /*  529531 */   // Label 8767: @529531
     /*  529531 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(529602), // Rule ID 21500 //
     /*  529536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  529547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  529550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529568 */     // MIs[0] round
     /*  529568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529578 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  529581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529587 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529600 */     GIR_RootConstrainSelectedInstOperands,
     /*  529601 */     // GIR_Coverage, 21500,
     /*  529601 */     GIR_EraseRootFromParent_Done,
     /*  529602 */   // Label 8768: @529602
     /*  529602 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(529673), // Rule ID 21501 //
     /*  529607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  529618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  529621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  529624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  529635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529639 */     // MIs[0] round
     /*  529639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  529652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529658 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529671 */     GIR_RootConstrainSelectedInstOperands,
     /*  529672 */     // GIR_Coverage, 21501,
     /*  529672 */     GIR_EraseRootFromParent_Done,
     /*  529673 */   // Label 8769: @529673
     /*  529673 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(529744), // Rule ID 21504 //
     /*  529678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  529681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  529689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  529692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529710 */     // MIs[0] round
     /*  529710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529720 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  529720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  529723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529729 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529742 */     GIR_RootConstrainSelectedInstOperands,
     /*  529743 */     // GIR_Coverage, 21504,
     /*  529743 */     GIR_EraseRootFromParent_Done,
     /*  529744 */   // Label 8770: @529744
     /*  529744 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(529815), // Rule ID 21505 //
     /*  529749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  529752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  529760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  529763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  529766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  529777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  529781 */     // MIs[0] round
     /*  529781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529791 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  529791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  529794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529800 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  529810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529813 */     GIR_RootConstrainSelectedInstOperands,
     /*  529814 */     // GIR_Coverage, 21505,
     /*  529814 */     GIR_EraseRootFromParent_Done,
     /*  529815 */   // Label 8771: @529815
     /*  529815 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(529886), // Rule ID 21508 //
     /*  529820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  529831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  529834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529852 */     // MIs[0] round
     /*  529852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  529862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529871 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529884 */     GIR_RootConstrainSelectedInstOperands,
     /*  529885 */     // GIR_Coverage, 21508,
     /*  529885 */     GIR_EraseRootFromParent_Done,
     /*  529886 */   // Label 8772: @529886
     /*  529886 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(529957), // Rule ID 21509 //
     /*  529891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  529894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  529902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  529905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  529908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  529911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529923 */     // MIs[0] round
     /*  529923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  529933 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  529933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4),
     /*  529936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  529938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  529940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  529942 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  529944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  529949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  529952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  529955 */     GIR_RootConstrainSelectedInstOperands,
     /*  529956 */     // GIR_Coverage, 21509,
     /*  529956 */     GIR_EraseRootFromParent_Done,
     /*  529957 */   // Label 8773: @529957
     /*  529957 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(530028), // Rule ID 21512 //
     /*  529962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  529965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  529970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  529973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  529976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  529979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  529982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  529994 */     // MIs[0] round
     /*  529994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  529997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530004 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530013 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530026 */     GIR_RootConstrainSelectedInstOperands,
     /*  530027 */     // GIR_Coverage, 21512,
     /*  530027 */     GIR_EraseRootFromParent_Done,
     /*  530028 */   // Label 8774: @530028
     /*  530028 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(530099), // Rule ID 21513 //
     /*  530033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  530044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  530047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  530050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530065 */     // MIs[0] round
     /*  530065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530075 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530084 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530097 */     GIR_RootConstrainSelectedInstOperands,
     /*  530098 */     // GIR_Coverage, 21513,
     /*  530098 */     GIR_EraseRootFromParent_Done,
     /*  530099 */   // Label 8775: @530099
     /*  530099 */   GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(530170), // Rule ID 21516 //
     /*  530104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530136 */     // MIs[0] round
     /*  530136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530155 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530168 */     GIR_RootConstrainSelectedInstOperands,
     /*  530169 */     // GIR_Coverage, 21516,
     /*  530169 */     GIR_EraseRootFromParent_Done,
     /*  530170 */   // Label 8776: @530170
     /*  530170 */   GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(530241), // Rule ID 21517 //
     /*  530175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  530186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  530189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  530192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530207 */     // MIs[0] round
     /*  530207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530217 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11168:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530226 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530239 */     GIR_RootConstrainSelectedInstOperands,
     /*  530240 */     // GIR_Coverage, 21517,
     /*  530240 */     GIR_EraseRootFromParent_Done,
     /*  530241 */   // Label 8777: @530241
     /*  530241 */   GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(530312), // Rule ID 21520 //
     /*  530246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530278 */     // MIs[0] round
     /*  530278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530297 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530310 */     GIR_RootConstrainSelectedInstOperands,
     /*  530311 */     // GIR_Coverage, 21520,
     /*  530311 */     GIR_EraseRootFromParent_Done,
     /*  530312 */   // Label 8778: @530312
     /*  530312 */   GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(530383), // Rule ID 21521 //
     /*  530317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  530328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  530331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  530334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530349 */     // MIs[0] round
     /*  530349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530368 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530381 */     GIR_RootConstrainSelectedInstOperands,
     /*  530382 */     // GIR_Coverage, 21521,
     /*  530382 */     GIR_EraseRootFromParent_Done,
     /*  530383 */   // Label 8779: @530383
     /*  530383 */   GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(530454), // Rule ID 21524 //
     /*  530388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  530391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530420 */     // MIs[0] round
     /*  530420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530430 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  530430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530439 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530452 */     GIR_RootConstrainSelectedInstOperands,
     /*  530453 */     // GIR_Coverage, 21524,
     /*  530453 */     GIR_EraseRootFromParent_Done,
     /*  530454 */   // Label 8780: @530454
     /*  530454 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(530525), // Rule ID 21525 //
     /*  530459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  530462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  530470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  530473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  530476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530491 */     // MIs[0] round
     /*  530491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530501 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  530501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  530504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530510 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  530520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530523 */     GIR_RootConstrainSelectedInstOperands,
     /*  530524 */     // GIR_Coverage, 21525,
     /*  530524 */     GIR_EraseRootFromParent_Done,
     /*  530525 */   // Label 8781: @530525
     /*  530525 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(530596), // Rule ID 21528 //
     /*  530530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  530533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  530547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530562 */     // MIs[0] round
     /*  530562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530581 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530594 */     GIR_RootConstrainSelectedInstOperands,
     /*  530595 */     // GIR_Coverage, 21528,
     /*  530595 */     GIR_EraseRootFromParent_Done,
     /*  530596 */   // Label 8782: @530596
     /*  530596 */   GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(530667), // Rule ID 21529 //
     /*  530601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  530604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  530612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  530615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  530618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530633 */     // MIs[0] round
     /*  530633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530643 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2),
     /*  530646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530652 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530665 */     GIR_RootConstrainSelectedInstOperands,
     /*  530666 */     // GIR_Coverage, 21529,
     /*  530666 */     GIR_EraseRootFromParent_Done,
     /*  530667 */   // Label 8783: @530667
     /*  530667 */   GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(530738), // Rule ID 21532 //
     /*  530672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  530675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530704 */     // MIs[0] round
     /*  530704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530714 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530723 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530736 */     GIR_RootConstrainSelectedInstOperands,
     /*  530737 */     // GIR_Coverage, 21532,
     /*  530737 */     GIR_EraseRootFromParent_Done,
     /*  530738 */   // Label 8784: @530738
     /*  530738 */   GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(530809), // Rule ID 21533 //
     /*  530743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  530746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  530754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  530757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  530760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  530771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530775 */     // MIs[0] round
     /*  530775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530785 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11168:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1),
     /*  530788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530794 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530807 */     GIR_RootConstrainSelectedInstOperands,
     /*  530808 */     // GIR_Coverage, 21533,
     /*  530808 */     GIR_EraseRootFromParent_Done,
     /*  530809 */   // Label 8785: @530809
     /*  530809 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(530880), // Rule ID 21536 //
     /*  530814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  530817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  530825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  530828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530846 */     // MIs[0] round
     /*  530846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530856 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530865 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530878 */     GIR_RootConstrainSelectedInstOperands,
     /*  530879 */     // GIR_Coverage, 21536,
     /*  530879 */     GIR_EraseRootFromParent_Done,
     /*  530880 */   // Label 8786: @530880
     /*  530880 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(530951), // Rule ID 21537 //
     /*  530885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  530888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  530896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  530899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  530902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  530905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  530913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530917 */     // MIs[0] round
     /*  530917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530927 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11168:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  530927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2),
     /*  530930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  530932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  530934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  530936 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  530938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  530943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  530946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  530949 */     GIR_RootConstrainSelectedInstOperands,
     /*  530950 */     // GIR_Coverage, 21537,
     /*  530950 */     GIR_EraseRootFromParent_Done,
     /*  530951 */   // Label 8787: @530951
     /*  530951 */   GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(531022), // Rule ID 21540 //
     /*  530956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  530959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  530964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  530967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  530970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  530973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  530976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  530984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  530988 */     // MIs[0] round
     /*  530988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  530991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  530998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  530998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531007 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531020 */     GIR_RootConstrainSelectedInstOperands,
     /*  531021 */     // GIR_Coverage, 21540,
     /*  531021 */     GIR_EraseRootFromParent_Done,
     /*  531022 */   // Label 8788: @531022
     /*  531022 */   GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(531093), // Rule ID 21541 //
     /*  531027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  531030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w),
     /*  531035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  531038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  531041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  531044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531059 */     // MIs[0] round
     /*  531059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11168:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_XU_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  531069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4),
     /*  531072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531078 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  531088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531091 */     GIR_RootConstrainSelectedInstOperands,
     /*  531092 */     // GIR_Coverage, 21541,
     /*  531092 */     GIR_EraseRootFromParent_Done,
     /*  531093 */   // Label 8789: @531093
     /*  531093 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(531164), // Rule ID 21544 //
     /*  531098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531130 */     // MIs[0] round
     /*  531130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531149 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531162 */     GIR_RootConstrainSelectedInstOperands,
     /*  531163 */     // GIR_Coverage, 21544,
     /*  531163 */     GIR_EraseRootFromParent_Done,
     /*  531164 */   // Label 8790: @531164
     /*  531164 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(531235), // Rule ID 21545 //
     /*  531169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  531180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  531183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  531186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531201 */     // MIs[0] round
     /*  531201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531211 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8),
     /*  531214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531220 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531233 */     GIR_RootConstrainSelectedInstOperands,
     /*  531234 */     // GIR_Coverage, 21545,
     /*  531234 */     GIR_EraseRootFromParent_Done,
     /*  531235 */   // Label 8791: @531235
     /*  531235 */   GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(531306), // Rule ID 21548 //
     /*  531240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531272 */     // MIs[0] round
     /*  531272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531282 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531291 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531304 */     GIR_RootConstrainSelectedInstOperands,
     /*  531305 */     // GIR_Coverage, 21548,
     /*  531305 */     GIR_EraseRootFromParent_Done,
     /*  531306 */   // Label 8792: @531306
     /*  531306 */   GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(531377), // Rule ID 21549 //
     /*  531311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  531322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  531325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  531328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531343 */     // MIs[0] round
     /*  531343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531353 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531362 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531375 */     GIR_RootConstrainSelectedInstOperands,
     /*  531376 */     // GIR_Coverage, 21549,
     /*  531376 */     GIR_EraseRootFromParent_Done,
     /*  531377 */   // Label 8793: @531377
     /*  531377 */   GIM_Try, /*On fail goto*//*Label 8794*/ GIMT_Encode4(531448), // Rule ID 21552 //
     /*  531382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531414 */     // MIs[0] round
     /*  531414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  531427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531433 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531446 */     GIR_RootConstrainSelectedInstOperands,
     /*  531447 */     // GIR_Coverage, 21552,
     /*  531447 */     GIR_EraseRootFromParent_Done,
     /*  531448 */   // Label 8794: @531448
     /*  531448 */   GIM_Try, /*On fail goto*//*Label 8795*/ GIMT_Encode4(531519), // Rule ID 21553 //
     /*  531453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  531464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  531467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  531470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531485 */     // MIs[0] round
     /*  531485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531495 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  531498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531504 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531517 */     GIR_RootConstrainSelectedInstOperands,
     /*  531518 */     // GIR_Coverage, 21553,
     /*  531518 */     GIR_EraseRootFromParent_Done,
     /*  531519 */   // Label 8795: @531519
     /*  531519 */   GIM_Try, /*On fail goto*//*Label 8796*/ GIMT_Encode4(531590), // Rule ID 21556 //
     /*  531524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  531535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  531538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531556 */     // MIs[0] round
     /*  531556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  531569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531575 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531588 */     GIR_RootConstrainSelectedInstOperands,
     /*  531589 */     // GIR_Coverage, 21556,
     /*  531589 */     GIR_EraseRootFromParent_Done,
     /*  531590 */   // Label 8796: @531590
     /*  531590 */   GIM_Try, /*On fail goto*//*Label 8797*/ GIMT_Encode4(531661), // Rule ID 21557 //
     /*  531595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  531606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  531609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  531612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531627 */     // MIs[0] round
     /*  531627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531637 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11166:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  531640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531646 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531659 */     GIR_RootConstrainSelectedInstOperands,
     /*  531660 */     // GIR_Coverage, 21557,
     /*  531660 */     GIR_EraseRootFromParent_Done,
     /*  531661 */   // Label 8797: @531661
     /*  531661 */   GIM_Try, /*On fail goto*//*Label 8798*/ GIMT_Encode4(531732), // Rule ID 21560 //
     /*  531666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  531677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  531680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531698 */     // MIs[0] round
     /*  531698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531708 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  531711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531717 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531730 */     GIR_RootConstrainSelectedInstOperands,
     /*  531731 */     // GIR_Coverage, 21560,
     /*  531731 */     GIR_EraseRootFromParent_Done,
     /*  531732 */   // Label 8798: @531732
     /*  531732 */   GIM_Try, /*On fail goto*//*Label 8799*/ GIMT_Encode4(531803), // Rule ID 21561 //
     /*  531737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  531748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  531751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  531754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  531765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531769 */     // MIs[0] round
     /*  531769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531779 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  531782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531788 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531801 */     GIR_RootConstrainSelectedInstOperands,
     /*  531802 */     // GIR_Coverage, 21561,
     /*  531802 */     GIR_EraseRootFromParent_Done,
     /*  531803 */   // Label 8799: @531803
     /*  531803 */   GIM_Try, /*On fail goto*//*Label 8800*/ GIMT_Encode4(531874), // Rule ID 21564 //
     /*  531808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  531811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  531819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  531822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  531825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531840 */     // MIs[0] round
     /*  531840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  531850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  531853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531859 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531872 */     GIR_RootConstrainSelectedInstOperands,
     /*  531873 */     // GIR_Coverage, 21564,
     /*  531873 */     GIR_EraseRootFromParent_Done,
     /*  531874 */   // Label 8800: @531874
     /*  531874 */   GIM_Try, /*On fail goto*//*Label 8801*/ GIMT_Encode4(531945), // Rule ID 21565 //
     /*  531879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  531882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  531890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  531893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  531896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  531899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  531907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  531911 */     // MIs[0] round
     /*  531911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531921 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  531921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  531924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  531930 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  531932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  531937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  531940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  531943 */     GIR_RootConstrainSelectedInstOperands,
     /*  531944 */     // GIR_Coverage, 21565,
     /*  531944 */     GIR_EraseRootFromParent_Done,
     /*  531945 */   // Label 8801: @531945
     /*  531945 */   GIM_Try, /*On fail goto*//*Label 8802*/ GIMT_Encode4(532016), // Rule ID 21568 //
     /*  531950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  531953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  531958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  531961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  531964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  531967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  531970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  531982 */     // MIs[0] round
     /*  531982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  531985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  531992 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  531992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  531995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  531997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  531999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532001 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532014 */     GIR_RootConstrainSelectedInstOperands,
     /*  532015 */     // GIR_Coverage, 21568,
     /*  532015 */     GIR_EraseRootFromParent_Done,
     /*  532016 */   // Label 8802: @532016
     /*  532016 */   GIM_Try, /*On fail goto*//*Label 8803*/ GIMT_Encode4(532087), // Rule ID 21569 //
     /*  532021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  532032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  532035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  532038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532053 */     // MIs[0] round
     /*  532053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532063 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4),
     /*  532066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532072 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532085 */     GIR_RootConstrainSelectedInstOperands,
     /*  532086 */     // GIR_Coverage, 21569,
     /*  532086 */     GIR_EraseRootFromParent_Done,
     /*  532087 */   // Label 8803: @532087
     /*  532087 */   GIM_Try, /*On fail goto*//*Label 8804*/ GIMT_Encode4(532158), // Rule ID 21572 //
     /*  532092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532124 */     // MIs[0] round
     /*  532124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532134 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532143 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532156 */     GIR_RootConstrainSelectedInstOperands,
     /*  532157 */     // GIR_Coverage, 21572,
     /*  532157 */     GIR_EraseRootFromParent_Done,
     /*  532158 */   // Label 8804: @532158
     /*  532158 */   GIM_Try, /*On fail goto*//*Label 8805*/ GIMT_Encode4(532229), // Rule ID 21573 //
     /*  532163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  532174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  532177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  532180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532195 */     // MIs[0] round
     /*  532195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532205 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532214 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532227 */     GIR_RootConstrainSelectedInstOperands,
     /*  532228 */     // GIR_Coverage, 21573,
     /*  532228 */     GIR_EraseRootFromParent_Done,
     /*  532229 */   // Label 8805: @532229
     /*  532229 */   GIM_Try, /*On fail goto*//*Label 8806*/ GIMT_Encode4(532300), // Rule ID 21576 //
     /*  532234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532266 */     // MIs[0] round
     /*  532266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532285 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532298 */     GIR_RootConstrainSelectedInstOperands,
     /*  532299 */     // GIR_Coverage, 21576,
     /*  532299 */     GIR_EraseRootFromParent_Done,
     /*  532300 */   // Label 8806: @532300
     /*  532300 */   GIM_Try, /*On fail goto*//*Label 8807*/ GIMT_Encode4(532371), // Rule ID 21577 //
     /*  532305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  532316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  532319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  532322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532337 */     // MIs[0] round
     /*  532337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532347 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11166:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532356 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532369 */     GIR_RootConstrainSelectedInstOperands,
     /*  532370 */     // GIR_Coverage, 21577,
     /*  532370 */     GIR_EraseRootFromParent_Done,
     /*  532371 */   // Label 8807: @532371
     /*  532371 */   GIM_Try, /*On fail goto*//*Label 8808*/ GIMT_Encode4(532442), // Rule ID 21580 //
     /*  532376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532408 */     // MIs[0] round
     /*  532408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532427 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532440 */     GIR_RootConstrainSelectedInstOperands,
     /*  532441 */     // GIR_Coverage, 21580,
     /*  532441 */     GIR_EraseRootFromParent_Done,
     /*  532442 */   // Label 8808: @532442
     /*  532442 */   GIM_Try, /*On fail goto*//*Label 8809*/ GIMT_Encode4(532513), // Rule ID 21581 //
     /*  532447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  532458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  532461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  532464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532479 */     // MIs[0] round
     /*  532479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532498 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532511 */     GIR_RootConstrainSelectedInstOperands,
     /*  532512 */     // GIR_Coverage, 21581,
     /*  532512 */     GIR_EraseRootFromParent_Done,
     /*  532513 */   // Label 8809: @532513
     /*  532513 */   GIM_Try, /*On fail goto*//*Label 8810*/ GIMT_Encode4(532584), // Rule ID 21584 //
     /*  532518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  532521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  532529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  532532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  532535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532550 */     // MIs[0] round
     /*  532550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  532560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532569 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532582 */     GIR_RootConstrainSelectedInstOperands,
     /*  532583 */     // GIR_Coverage, 21584,
     /*  532583 */     GIR_EraseRootFromParent_Done,
     /*  532584 */   // Label 8810: @532584
     /*  532584 */   GIM_Try, /*On fail goto*//*Label 8811*/ GIMT_Encode4(532655), // Rule ID 21585 //
     /*  532589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  532592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  532600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  532603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  532606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  532621 */     // MIs[0] round
     /*  532621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532631 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  532631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  532634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532640 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  532650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532653 */     GIR_RootConstrainSelectedInstOperands,
     /*  532654 */     // GIR_Coverage, 21585,
     /*  532654 */     GIR_EraseRootFromParent_Done,
     /*  532655 */   // Label 8811: @532655
     /*  532655 */   GIM_Try, /*On fail goto*//*Label 8812*/ GIMT_Encode4(532726), // Rule ID 21588 //
     /*  532660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  532663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  532677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532692 */     // MIs[0] round
     /*  532692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532711 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532724 */     GIR_RootConstrainSelectedInstOperands,
     /*  532725 */     // GIR_Coverage, 21588,
     /*  532725 */     GIR_EraseRootFromParent_Done,
     /*  532726 */   // Label 8812: @532726
     /*  532726 */   GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(532797), // Rule ID 21589 //
     /*  532731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  532734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  532742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  532745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  532748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532763 */     // MIs[0] round
     /*  532763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532773 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2),
     /*  532776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532782 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532795 */     GIR_RootConstrainSelectedInstOperands,
     /*  532796 */     // GIR_Coverage, 21589,
     /*  532796 */     GIR_EraseRootFromParent_Done,
     /*  532797 */   // Label 8813: @532797
     /*  532797 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(532868), // Rule ID 21592 //
     /*  532802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  532805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  532819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532834 */     // MIs[0] round
     /*  532834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532853 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532866 */     GIR_RootConstrainSelectedInstOperands,
     /*  532867 */     // GIR_Coverage, 21592,
     /*  532867 */     GIR_EraseRootFromParent_Done,
     /*  532868 */   // Label 8814: @532868
     /*  532868 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(532939), // Rule ID 21593 //
     /*  532873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  532876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  532884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  532887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  532890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  532893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  532901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532905 */     // MIs[0] round
     /*  532905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532915 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11166:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  532915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1),
     /*  532918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532924 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  532931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  532934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  532937 */     GIR_RootConstrainSelectedInstOperands,
     /*  532938 */     // GIR_Coverage, 21593,
     /*  532938 */     GIR_EraseRootFromParent_Done,
     /*  532939 */   // Label 8815: @532939
     /*  532939 */   GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(533010), // Rule ID 21596 //
     /*  532944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  532947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  532952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  532955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  532958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  532961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  532964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  532972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  532976 */     // MIs[0] round
     /*  532976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  532979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  532986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  532986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  532989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  532991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  532993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  532995 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  532997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533008 */     GIR_RootConstrainSelectedInstOperands,
     /*  533009 */     // GIR_Coverage, 21596,
     /*  533009 */     GIR_EraseRootFromParent_Done,
     /*  533010 */   // Label 8816: @533010
     /*  533010 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(533081), // Rule ID 21597 //
     /*  533015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  533026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  533029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  533032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533047 */     // MIs[0] round
     /*  533047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11166:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2),
     /*  533060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533066 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533079 */     GIR_RootConstrainSelectedInstOperands,
     /*  533080 */     // GIR_Coverage, 21597,
     /*  533080 */     GIR_EraseRootFromParent_Done,
     /*  533081 */   // Label 8817: @533081
     /*  533081 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(533152), // Rule ID 21600 //
     /*  533086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  533089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533118 */     // MIs[0] round
     /*  533118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533137 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533150 */     GIR_RootConstrainSelectedInstOperands,
     /*  533151 */     // GIR_Coverage, 21600,
     /*  533151 */     GIR_EraseRootFromParent_Done,
     /*  533152 */   // Label 8818: @533152
     /*  533152 */   GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(533223), // Rule ID 21601 //
     /*  533157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  533160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w),
     /*  533165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  533168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  533171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  533174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533189 */     // MIs[0] round
     /*  533189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11166:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_X_F_W_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  533199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4),
     /*  533202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533208 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533221 */     GIR_RootConstrainSelectedInstOperands,
     /*  533222 */     // GIR_Coverage, 21601,
     /*  533222 */     GIR_EraseRootFromParent_Done,
     /*  533223 */   // Label 8819: @533223
     /*  533223 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(533294), // Rule ID 21724 //
     /*  533228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533260 */     // MIs[0] round
     /*  533260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533270 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533279 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533292 */     GIR_RootConstrainSelectedInstOperands,
     /*  533293 */     // GIR_Coverage, 21724,
     /*  533293 */     GIR_EraseRootFromParent_Done,
     /*  533294 */   // Label 8820: @533294
     /*  533294 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(533365), // Rule ID 21725 //
     /*  533299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  533310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  533313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  533316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533331 */     // MIs[0] round
     /*  533331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533341 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /*  533344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533350 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533363 */     GIR_RootConstrainSelectedInstOperands,
     /*  533364 */     // GIR_Coverage, 21725,
     /*  533364 */     GIR_EraseRootFromParent_Done,
     /*  533365 */   // Label 8821: @533365
     /*  533365 */   GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(533436), // Rule ID 21728 //
     /*  533370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533402 */     // MIs[0] round
     /*  533402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533412 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  533415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533421 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533434 */     GIR_RootConstrainSelectedInstOperands,
     /*  533435 */     // GIR_Coverage, 21728,
     /*  533435 */     GIR_EraseRootFromParent_Done,
     /*  533436 */   // Label 8822: @533436
     /*  533436 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(533507), // Rule ID 21729 //
     /*  533441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  533452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  533455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  533458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533473 */     // MIs[0] round
     /*  533473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533483 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /*  533486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533492 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533505 */     GIR_RootConstrainSelectedInstOperands,
     /*  533506 */     // GIR_Coverage, 21729,
     /*  533506 */     GIR_EraseRootFromParent_Done,
     /*  533507 */   // Label 8823: @533507
     /*  533507 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(533578), // Rule ID 21732 //
     /*  533512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533544 */     // MIs[0] round
     /*  533544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533554 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  533557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533563 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533576 */     GIR_RootConstrainSelectedInstOperands,
     /*  533577 */     // GIR_Coverage, 21732,
     /*  533577 */     GIR_EraseRootFromParent_Done,
     /*  533578 */   // Label 8824: @533578
     /*  533578 */   GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(533649), // Rule ID 21733 //
     /*  533583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  533594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  533597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  533600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533615 */     // MIs[0] round
     /*  533615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533625 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11158:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /*  533628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533634 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533647 */     GIR_RootConstrainSelectedInstOperands,
     /*  533648 */     // GIR_Coverage, 21733,
     /*  533648 */     GIR_EraseRootFromParent_Done,
     /*  533649 */   // Label 8825: @533649
     /*  533649 */   GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(533720), // Rule ID 21736 //
     /*  533654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533686 */     // MIs[0] round
     /*  533686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533696 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  533699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533705 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533718 */     GIR_RootConstrainSelectedInstOperands,
     /*  533719 */     // GIR_Coverage, 21736,
     /*  533719 */     GIR_EraseRootFromParent_Done,
     /*  533720 */   // Label 8826: @533720
     /*  533720 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(533791), // Rule ID 21737 //
     /*  533725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  533736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  533739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  533742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  533753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533757 */     // MIs[0] round
     /*  533757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533767 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /*  533770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533776 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533789 */     GIR_RootConstrainSelectedInstOperands,
     /*  533790 */     // GIR_Coverage, 21737,
     /*  533790 */     GIR_EraseRootFromParent_Done,
     /*  533791 */   // Label 8827: @533791
     /*  533791 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(533862), // Rule ID 21740 //
     /*  533796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  533799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533828 */     // MIs[0] round
     /*  533828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533838 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  533838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  533841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533847 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533860 */     GIR_RootConstrainSelectedInstOperands,
     /*  533861 */     // GIR_Coverage, 21740,
     /*  533861 */     GIR_EraseRootFromParent_Done,
     /*  533862 */   // Label 8828: @533862
     /*  533862 */   GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(533933), // Rule ID 21741 //
     /*  533867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  533870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  533878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  533881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  533884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  533887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  533895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  533899 */     // MIs[0] round
     /*  533899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533909 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  533909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /*  533912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533918 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  533928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  533931 */     GIR_RootConstrainSelectedInstOperands,
     /*  533932 */     // GIR_Coverage, 21741,
     /*  533932 */     GIR_EraseRootFromParent_Done,
     /*  533933 */   // Label 8829: @533933
     /*  533933 */   GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(534004), // Rule ID 21744 //
     /*  533938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  533941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  533946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  533949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  533952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  533955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  533958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  533970 */     // MIs[0] round
     /*  533970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  533973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  533980 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  533980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  533983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  533985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  533987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  533989 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  533991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  533996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  533999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534002 */     GIR_RootConstrainSelectedInstOperands,
     /*  534003 */     // GIR_Coverage, 21744,
     /*  534003 */     GIR_EraseRootFromParent_Done,
     /*  534004 */   // Label 8830: @534004
     /*  534004 */   GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(534075), // Rule ID 21745 //
     /*  534009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  534020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  534023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  534026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534041 */     // MIs[0] round
     /*  534041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534051 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /*  534054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534060 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534073 */     GIR_RootConstrainSelectedInstOperands,
     /*  534074 */     // GIR_Coverage, 21745,
     /*  534074 */     GIR_EraseRootFromParent_Done,
     /*  534075 */   // Label 8831: @534075
     /*  534075 */   GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(534146), // Rule ID 21748 //
     /*  534080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534112 */     // MIs[0] round
     /*  534112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534122 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534131 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534144 */     GIR_RootConstrainSelectedInstOperands,
     /*  534145 */     // GIR_Coverage, 21748,
     /*  534145 */     GIR_EraseRootFromParent_Done,
     /*  534146 */   // Label 8832: @534146
     /*  534146 */   GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(534217), // Rule ID 21749 //
     /*  534151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  534162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  534165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  534168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534183 */     // MIs[0] round
     /*  534183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534193 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11158:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /*  534196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534202 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534215 */     GIR_RootConstrainSelectedInstOperands,
     /*  534216 */     // GIR_Coverage, 21749,
     /*  534216 */     GIR_EraseRootFromParent_Done,
     /*  534217 */   // Label 8833: @534217
     /*  534217 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(534288), // Rule ID 21752 //
     /*  534222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534254 */     // MIs[0] round
     /*  534254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534264 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534273 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534286 */     GIR_RootConstrainSelectedInstOperands,
     /*  534287 */     // GIR_Coverage, 21752,
     /*  534287 */     GIR_EraseRootFromParent_Done,
     /*  534288 */   // Label 8834: @534288
     /*  534288 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(534359), // Rule ID 21753 //
     /*  534293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  534304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  534307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  534310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534325 */     // MIs[0] round
     /*  534325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534335 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11158:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /*  534338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534344 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534357 */     GIR_RootConstrainSelectedInstOperands,
     /*  534358 */     // GIR_Coverage, 21753,
     /*  534358 */     GIR_EraseRootFromParent_Done,
     /*  534359 */   // Label 8835: @534359
     /*  534359 */   GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(534430), // Rule ID 21756 //
     /*  534364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  534367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534396 */     // MIs[0] round
     /*  534396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534406 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  534406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  534409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534415 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534428 */     GIR_RootConstrainSelectedInstOperands,
     /*  534429 */     // GIR_Coverage, 21756,
     /*  534429 */     GIR_EraseRootFromParent_Done,
     /*  534430 */   // Label 8836: @534430
     /*  534430 */   GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(534501), // Rule ID 21757 //
     /*  534435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  534438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w),
     /*  534443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  534446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  534449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  534452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  534467 */     // MIs[0] round
     /*  534467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534477 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11158:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  534477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /*  534480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534486 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  534496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534499 */     GIR_RootConstrainSelectedInstOperands,
     /*  534500 */     // GIR_Coverage, 21757,
     /*  534500 */     GIR_EraseRootFromParent_Done,
     /*  534501 */   // Label 8837: @534501
     /*  534501 */   GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(534572), // Rule ID 21760 //
     /*  534506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534538 */     // MIs[0] round
     /*  534538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534548 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  534551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534557 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534570 */     GIR_RootConstrainSelectedInstOperands,
     /*  534571 */     // GIR_Coverage, 21760,
     /*  534571 */     GIR_EraseRootFromParent_Done,
     /*  534572 */   // Label 8838: @534572
     /*  534572 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(534643), // Rule ID 21761 //
     /*  534577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  534588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  534591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  534594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534609 */     // MIs[0] round
     /*  534609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534619 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /*  534622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534628 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534641 */     GIR_RootConstrainSelectedInstOperands,
     /*  534642 */     // GIR_Coverage, 21761,
     /*  534642 */     GIR_EraseRootFromParent_Done,
     /*  534643 */   // Label 8839: @534643
     /*  534643 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(534714), // Rule ID 21764 //
     /*  534648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534680 */     // MIs[0] round
     /*  534680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534690 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  534693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534699 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534712 */     GIR_RootConstrainSelectedInstOperands,
     /*  534713 */     // GIR_Coverage, 21764,
     /*  534713 */     GIR_EraseRootFromParent_Done,
     /*  534714 */   // Label 8840: @534714
     /*  534714 */   GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(534785), // Rule ID 21765 //
     /*  534719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  534730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  534733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  534736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534751 */     // MIs[0] round
     /*  534751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534761 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /*  534764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534770 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534783 */     GIR_RootConstrainSelectedInstOperands,
     /*  534784 */     // GIR_Coverage, 21765,
     /*  534784 */     GIR_EraseRootFromParent_Done,
     /*  534785 */   // Label 8841: @534785
     /*  534785 */   GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(534856), // Rule ID 21768 //
     /*  534790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534822 */     // MIs[0] round
     /*  534822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  534835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534841 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534854 */     GIR_RootConstrainSelectedInstOperands,
     /*  534855 */     // GIR_Coverage, 21768,
     /*  534855 */     GIR_EraseRootFromParent_Done,
     /*  534856 */   // Label 8842: @534856
     /*  534856 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(534927), // Rule ID 21769 //
     /*  534861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  534864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  534872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  534875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  534878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  534881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  534889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534893 */     // MIs[0] round
     /*  534893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534903 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11156:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  534903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /*  534906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534912 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534925 */     GIR_RootConstrainSelectedInstOperands,
     /*  534926 */     // GIR_Coverage, 21769,
     /*  534926 */     GIR_EraseRootFromParent_Done,
     /*  534927 */   // Label 8843: @534927
     /*  534927 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(534998), // Rule ID 21772 //
     /*  534932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  534935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  534940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  534943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  534946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  534949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  534952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  534960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  534964 */     // MIs[0] round
     /*  534964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  534967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  534974 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  534974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  534977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  534979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  534981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  534983 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  534985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  534990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  534993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  534996 */     GIR_RootConstrainSelectedInstOperands,
     /*  534997 */     // GIR_Coverage, 21772,
     /*  534997 */     GIR_EraseRootFromParent_Done,
     /*  534998 */   // Label 8844: @534998
     /*  534998 */   GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(535069), // Rule ID 21773 //
     /*  535003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  535014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  535017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  535020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535035 */     // MIs[0] round
     /*  535035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535045 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /*  535048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535054 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535067 */     GIR_RootConstrainSelectedInstOperands,
     /*  535068 */     // GIR_Coverage, 21773,
     /*  535068 */     GIR_EraseRootFromParent_Done,
     /*  535069 */   // Label 8845: @535069
     /*  535069 */   GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(535140), // Rule ID 21776 //
     /*  535074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  535077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535106 */     // MIs[0] round
     /*  535106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535116 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  535116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535125 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535138 */     GIR_RootConstrainSelectedInstOperands,
     /*  535139 */     // GIR_Coverage, 21776,
     /*  535139 */     GIR_EraseRootFromParent_Done,
     /*  535140 */   // Label 8846: @535140
     /*  535140 */   GIM_Try, /*On fail goto*//*Label 8847*/ GIMT_Encode4(535211), // Rule ID 21777 //
     /*  535145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  535148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  535156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  535159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  535162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535177 */     // MIs[0] round
     /*  535177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535187 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  535187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /*  535190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535196 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  535206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535209 */     GIR_RootConstrainSelectedInstOperands,
     /*  535210 */     // GIR_Coverage, 21777,
     /*  535210 */     GIR_EraseRootFromParent_Done,
     /*  535211 */   // Label 8847: @535211
     /*  535211 */   GIM_Try, /*On fail goto*//*Label 8848*/ GIMT_Encode4(535282), // Rule ID 21780 //
     /*  535216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535248 */     // MIs[0] round
     /*  535248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535258 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535267 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535280 */     GIR_RootConstrainSelectedInstOperands,
     /*  535281 */     // GIR_Coverage, 21780,
     /*  535281 */     GIR_EraseRootFromParent_Done,
     /*  535282 */   // Label 8848: @535282
     /*  535282 */   GIM_Try, /*On fail goto*//*Label 8849*/ GIMT_Encode4(535353), // Rule ID 21781 //
     /*  535287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535319 */     // MIs[0] round
     /*  535319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535329 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /*  535332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535338 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535351 */     GIR_RootConstrainSelectedInstOperands,
     /*  535352 */     // GIR_Coverage, 21781,
     /*  535352 */     GIR_EraseRootFromParent_Done,
     /*  535353 */   // Label 8849: @535353
     /*  535353 */   GIM_Try, /*On fail goto*//*Label 8850*/ GIMT_Encode4(535424), // Rule ID 21784 //
     /*  535358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535390 */     // MIs[0] round
     /*  535390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535409 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535422 */     GIR_RootConstrainSelectedInstOperands,
     /*  535423 */     // GIR_Coverage, 21784,
     /*  535423 */     GIR_EraseRootFromParent_Done,
     /*  535424 */   // Label 8850: @535424
     /*  535424 */   GIM_Try, /*On fail goto*//*Label 8851*/ GIMT_Encode4(535495), // Rule ID 21785 //
     /*  535429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535461 */     // MIs[0] round
     /*  535461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535471 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11156:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /*  535474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535480 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535493 */     GIR_RootConstrainSelectedInstOperands,
     /*  535494 */     // GIR_Coverage, 21785,
     /*  535494 */     GIR_EraseRootFromParent_Done,
     /*  535495 */   // Label 8851: @535495
     /*  535495 */   GIM_Try, /*On fail goto*//*Label 8852*/ GIMT_Encode4(535566), // Rule ID 21788 //
     /*  535500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535532 */     // MIs[0] round
     /*  535532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  535545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535551 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535564 */     GIR_RootConstrainSelectedInstOperands,
     /*  535565 */     // GIR_Coverage, 21788,
     /*  535565 */     GIR_EraseRootFromParent_Done,
     /*  535566 */   // Label 8852: @535566
     /*  535566 */   GIM_Try, /*On fail goto*//*Label 8853*/ GIMT_Encode4(535637), // Rule ID 21789 //
     /*  535571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  535582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  535585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  535588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535603 */     // MIs[0] round
     /*  535603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535613 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11156:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /*  535616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535622 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535635 */     GIR_RootConstrainSelectedInstOperands,
     /*  535636 */     // GIR_Coverage, 21789,
     /*  535636 */     GIR_EraseRootFromParent_Done,
     /*  535637 */   // Label 8853: @535637
     /*  535637 */   GIM_Try, /*On fail goto*//*Label 8854*/ GIMT_Encode4(535708), // Rule ID 21792 //
     /*  535642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /*  535645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535674 */     // MIs[0] round
     /*  535674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535684 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  535687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535693 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535706 */     GIR_RootConstrainSelectedInstOperands,
     /*  535707 */     // GIR_Coverage, 21792,
     /*  535707 */     GIR_EraseRootFromParent_Done,
     /*  535708 */   // Label 8854: @535708
     /*  535708 */   GIM_Try, /*On fail goto*//*Label 8855*/ GIMT_Encode4(535779), // Rule ID 21793 //
     /*  535713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /*  535716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w),
     /*  535721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  535724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  535727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  535730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  535741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  535745 */     // MIs[0] round
     /*  535745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535755 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11156:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /*  535758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535764 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535777 */     GIR_RootConstrainSelectedInstOperands,
     /*  535778 */     // GIR_Coverage, 21793,
     /*  535778 */     GIR_EraseRootFromParent_Done,
     /*  535779 */   // Label 8855: @535779
     /*  535779 */   GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(535850), // Rule ID 21796 //
     /*  535784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  535787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  535792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535816 */     // MIs[0] round
     /*  535816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535826 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  535829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535835 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535848 */     GIR_RootConstrainSelectedInstOperands,
     /*  535849 */     // GIR_Coverage, 21796,
     /*  535849 */     GIR_EraseRootFromParent_Done,
     /*  535850 */   // Label 8856: @535850
     /*  535850 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(535921), // Rule ID 21797 //
     /*  535855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  535858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  535863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  535866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  535869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  535872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  535875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535887 */     // MIs[0] round
     /*  535887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535897 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  535897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /*  535900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535906 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535919 */     GIR_RootConstrainSelectedInstOperands,
     /*  535920 */     // GIR_Coverage, 21797,
     /*  535920 */     GIR_EraseRootFromParent_Done,
     /*  535921 */   // Label 8857: @535921
     /*  535921 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(535992), // Rule ID 21800 //
     /*  535926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  535929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  535934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  535937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  535940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  535943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  535946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  535954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  535958 */     // MIs[0] round
     /*  535958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  535961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  535968 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  535968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  535971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  535973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  535975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  535977 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  535979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  535984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  535987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  535990 */     GIR_RootConstrainSelectedInstOperands,
     /*  535991 */     // GIR_Coverage, 21800,
     /*  535991 */     GIR_EraseRootFromParent_Done,
     /*  535992 */   // Label 8858: @535992
     /*  535992 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(536063), // Rule ID 21801 //
     /*  535997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  536000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  536008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  536011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  536014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536029 */     // MIs[0] round
     /*  536029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536039 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /*  536042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536048 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536061 */     GIR_RootConstrainSelectedInstOperands,
     /*  536062 */     // GIR_Coverage, 21801,
     /*  536062 */     GIR_EraseRootFromParent_Done,
     /*  536063 */   // Label 8859: @536063
     /*  536063 */   GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(536134), // Rule ID 21804 //
     /*  536068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  536071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536100 */     // MIs[0] round
     /*  536100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536110 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  536113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536119 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536132 */     GIR_RootConstrainSelectedInstOperands,
     /*  536133 */     // GIR_Coverage, 21804,
     /*  536133 */     GIR_EraseRootFromParent_Done,
     /*  536134 */   // Label 8860: @536134
     /*  536134 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(536205), // Rule ID 21805 //
     /*  536139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  536142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  536150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  536153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  536156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536171 */     // MIs[0] round
     /*  536171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536181 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /*  536184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536190 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536203 */     GIR_RootConstrainSelectedInstOperands,
     /*  536204 */     // GIR_Coverage, 21805,
     /*  536204 */     GIR_EraseRootFromParent_Done,
     /*  536205 */   // Label 8861: @536205
     /*  536205 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(536276), // Rule ID 21808 //
     /*  536210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  536213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536242 */     // MIs[0] round
     /*  536242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  536252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  536255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536261 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536274 */     GIR_RootConstrainSelectedInstOperands,
     /*  536275 */     // GIR_Coverage, 21808,
     /*  536275 */     GIR_EraseRootFromParent_Done,
     /*  536276 */   // Label 8862: @536276
     /*  536276 */   GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(536347), // Rule ID 21809 //
     /*  536281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  536284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  536292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  536295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  536298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536313 */     // MIs[0] round
     /*  536313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536323 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  536323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /*  536326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536332 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  536342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536345 */     GIR_RootConstrainSelectedInstOperands,
     /*  536346 */     // GIR_Coverage, 21809,
     /*  536346 */     GIR_EraseRootFromParent_Done,
     /*  536347 */   // Label 8863: @536347
     /*  536347 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(536418), // Rule ID 21812 //
     /*  536352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  536355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536384 */     // MIs[0] round
     /*  536384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536394 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536403 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536416 */     GIR_RootConstrainSelectedInstOperands,
     /*  536417 */     // GIR_Coverage, 21812,
     /*  536417 */     GIR_EraseRootFromParent_Done,
     /*  536418 */   // Label 8864: @536418
     /*  536418 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(536489), // Rule ID 21813 //
     /*  536423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  536426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  536434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  536437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  536440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536455 */     // MIs[0] round
     /*  536455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536465 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /*  536468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536474 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536487 */     GIR_RootConstrainSelectedInstOperands,
     /*  536488 */     // GIR_Coverage, 21813,
     /*  536488 */     GIR_EraseRootFromParent_Done,
     /*  536489 */   // Label 8865: @536489
     /*  536489 */   GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(536560), // Rule ID 21816 //
     /*  536494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  536497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536526 */     // MIs[0] round
     /*  536526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536536 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536545 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536558 */     GIR_RootConstrainSelectedInstOperands,
     /*  536559 */     // GIR_Coverage, 21816,
     /*  536559 */     GIR_EraseRootFromParent_Done,
     /*  536560 */   // Label 8866: @536560
     /*  536560 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(536631), // Rule ID 21817 //
     /*  536565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  536568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  536576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  536579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  536582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536597 */     // MIs[0] round
     /*  536597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536607 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /*  536610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536616 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536629 */     GIR_RootConstrainSelectedInstOperands,
     /*  536630 */     // GIR_Coverage, 21817,
     /*  536630 */     GIR_EraseRootFromParent_Done,
     /*  536631 */   // Label 8867: @536631
     /*  536631 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(536702), // Rule ID 21820 //
     /*  536636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  536639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536668 */     // MIs[0] round
     /*  536668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536678 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536687 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536700 */     GIR_RootConstrainSelectedInstOperands,
     /*  536701 */     // GIR_Coverage, 21820,
     /*  536701 */     GIR_EraseRootFromParent_Done,
     /*  536702 */   // Label 8868: @536702
     /*  536702 */   GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(536773), // Rule ID 21821 //
     /*  536707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  536710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  536718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  536721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  536724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  536735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536739 */     // MIs[0] round
     /*  536739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536749 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11154:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /*  536752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536758 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536771 */     GIR_RootConstrainSelectedInstOperands,
     /*  536772 */     // GIR_Coverage, 21821,
     /*  536772 */     GIR_EraseRootFromParent_Done,
     /*  536773 */   // Label 8869: @536773
     /*  536773 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(536844), // Rule ID 21824 //
     /*  536778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  536781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536810 */     // MIs[0] round
     /*  536810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536829 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536842 */     GIR_RootConstrainSelectedInstOperands,
     /*  536843 */     // GIR_Coverage, 21824,
     /*  536843 */     GIR_EraseRootFromParent_Done,
     /*  536844 */   // Label 8870: @536844
     /*  536844 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(536915), // Rule ID 21825 //
     /*  536849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  536852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  536860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  536863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  536866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  536869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  536877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536881 */     // MIs[0] round
     /*  536881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536891 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11154:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  536891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /*  536894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536900 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536913 */     GIR_RootConstrainSelectedInstOperands,
     /*  536914 */     // GIR_Coverage, 21825,
     /*  536914 */     GIR_EraseRootFromParent_Done,
     /*  536915 */   // Label 8871: @536915
     /*  536915 */   GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(536986), // Rule ID 21828 //
     /*  536920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  536923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  536931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  536934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  536937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  536940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  536948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  536952 */     // MIs[0] round
     /*  536952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  536955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  536962 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  536962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  536965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  536967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  536969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  536971 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  536973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  536978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  536981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  536984 */     GIR_RootConstrainSelectedInstOperands,
     /*  536985 */     // GIR_Coverage, 21828,
     /*  536985 */     GIR_EraseRootFromParent_Done,
     /*  536986 */   // Label 8872: @536986
     /*  536986 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(537057), // Rule ID 21829 //
     /*  536991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  536994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w),
     /*  536999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  537008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537023 */     // MIs[0] round
     /*  537023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  537026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537033 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11154:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  537033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /*  537036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  537042 */     GIR_RootToRootCopy, /*OpIdx*/4, // round
     /*  537044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537055 */     GIR_RootConstrainSelectedInstOperands,
     /*  537056 */     // GIR_Coverage, 21829,
     /*  537056 */     GIR_EraseRootFromParent_Done,
     /*  537057 */   // Label 8873: @537057
     /*  537057 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(537128), // Rule ID 2646 //
     /*  537062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537090 */     // MIs[0] passthru
     /*  537090 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537106 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537126 */     GIR_RootConstrainSelectedInstOperands,
     /*  537127 */     // GIR_Coverage, 2646,
     /*  537127 */     GIR_EraseRootFromParent_Done,
     /*  537128 */   // Label 8874: @537128
     /*  537128 */   GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(537199), // Rule ID 2647 //
     /*  537133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  537144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  537147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  537150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537161 */     // MIs[0] passthru
     /*  537161 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_TIED),
     /*  537180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537197 */     GIR_RootConstrainSelectedInstOperands,
     /*  537198 */     // GIR_Coverage, 2647,
     /*  537198 */     GIR_EraseRootFromParent_Done,
     /*  537199 */   // Label 8875: @537199
     /*  537199 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(537270), // Rule ID 3954 //
     /*  537204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537232 */     // MIs[0] passthru
     /*  537232 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537248 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537268 */     GIR_RootConstrainSelectedInstOperands,
     /*  537269 */     // GIR_Coverage, 3954,
     /*  537269 */     GIR_EraseRootFromParent_Done,
     /*  537270 */   // Label 8876: @537270
     /*  537270 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(537341), // Rule ID 3955 //
     /*  537275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  537286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  537289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  537292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537303 */     // MIs[0] passthru
     /*  537303 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537339 */     GIR_RootConstrainSelectedInstOperands,
     /*  537340 */     // GIR_Coverage, 3955,
     /*  537340 */     GIR_EraseRootFromParent_Done,
     /*  537341 */   // Label 8877: @537341
     /*  537341 */   GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(537412), // Rule ID 3964 //
     /*  537346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537374 */     // MIs[0] passthru
     /*  537374 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537390 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537410 */     GIR_RootConstrainSelectedInstOperands,
     /*  537411 */     // GIR_Coverage, 3964,
     /*  537411 */     GIR_EraseRootFromParent_Done,
     /*  537412 */   // Label 8878: @537412
     /*  537412 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(537483), // Rule ID 3965 //
     /*  537417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  537428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  537431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  537434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537445 */     // MIs[0] passthru
     /*  537445 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537461 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  537464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537481 */     GIR_RootConstrainSelectedInstOperands,
     /*  537482 */     // GIR_Coverage, 3965,
     /*  537482 */     GIR_EraseRootFromParent_Done,
     /*  537483 */   // Label 8879: @537483
     /*  537483 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(537554), // Rule ID 3974 //
     /*  537488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  537505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537516 */     // MIs[0] passthru
     /*  537516 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  537535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537552 */     GIR_RootConstrainSelectedInstOperands,
     /*  537553 */     // GIR_Coverage, 3974,
     /*  537553 */     GIR_EraseRootFromParent_Done,
     /*  537554 */   // Label 8880: @537554
     /*  537554 */   GIM_Try, /*On fail goto*//*Label 8881*/ GIMT_Encode4(537625), // Rule ID 3975 //
     /*  537559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  537570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  537573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  537576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537587 */     // MIs[0] passthru
     /*  537587 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537603 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  537606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537623 */     GIR_RootConstrainSelectedInstOperands,
     /*  537624 */     // GIR_Coverage, 3975,
     /*  537624 */     GIR_EraseRootFromParent_Done,
     /*  537625 */   // Label 8881: @537625
     /*  537625 */   GIM_Try, /*On fail goto*//*Label 8882*/ GIMT_Encode4(537696), // Rule ID 3984 //
     /*  537630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  537647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537658 */     // MIs[0] passthru
     /*  537658 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  537677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537694 */     GIR_RootConstrainSelectedInstOperands,
     /*  537695 */     // GIR_Coverage, 3984,
     /*  537695 */     GIR_EraseRootFromParent_Done,
     /*  537696 */   // Label 8882: @537696
     /*  537696 */   GIM_Try, /*On fail goto*//*Label 8883*/ GIMT_Encode4(537767), // Rule ID 3985 //
     /*  537701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  537712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  537715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  537718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537729 */     // MIs[0] passthru
     /*  537729 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  537738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537745 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  537748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537765 */     GIR_RootConstrainSelectedInstOperands,
     /*  537766 */     // GIR_Coverage, 3985,
     /*  537766 */     GIR_EraseRootFromParent_Done,
     /*  537767 */   // Label 8883: @537767
     /*  537767 */   GIM_Try, /*On fail goto*//*Label 8884*/ GIMT_Encode4(537838), // Rule ID 3994 //
     /*  537772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  537783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  537786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  537789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537800 */     // MIs[0] passthru
     /*  537800 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537816 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  537816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  537819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537836 */     GIR_RootConstrainSelectedInstOperands,
     /*  537837 */     // GIR_Coverage, 3994,
     /*  537837 */     GIR_EraseRootFromParent_Done,
     /*  537838 */   // Label 8884: @537838
     /*  537838 */   GIM_Try, /*On fail goto*//*Label 8885*/ GIMT_Encode4(537909), // Rule ID 3995 //
     /*  537843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  537854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  537857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  537860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  537863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  537871 */     // MIs[0] passthru
     /*  537871 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  537880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537887 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  537887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  537890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  537904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537907 */     GIR_RootConstrainSelectedInstOperands,
     /*  537908 */     // GIR_Coverage, 3995,
     /*  537908 */     GIR_EraseRootFromParent_Done,
     /*  537909 */   // Label 8885: @537909
     /*  537909 */   GIM_Try, /*On fail goto*//*Label 8886*/ GIMT_Encode4(537980), // Rule ID 4004 //
     /*  537914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  537917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  537931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  537934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537942 */     // MIs[0] passthru
     /*  537942 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  537947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  537951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  537958 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  537958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  537961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  537963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  537965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  537967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  537972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  537975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  537978 */     GIR_RootConstrainSelectedInstOperands,
     /*  537979 */     // GIR_Coverage, 4004,
     /*  537979 */     GIR_EraseRootFromParent_Done,
     /*  537980 */   // Label 8886: @537980
     /*  537980 */   GIM_Try, /*On fail goto*//*Label 8887*/ GIMT_Encode4(538051), // Rule ID 4005 //
     /*  537985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  537988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  537993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  537996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  537999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  538002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538013 */     // MIs[0] passthru
     /*  538013 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538029 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_TIED),
     /*  538032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538049 */     GIR_RootConstrainSelectedInstOperands,
     /*  538050 */     // GIR_Coverage, 4005,
     /*  538050 */     GIR_EraseRootFromParent_Done,
     /*  538051 */   // Label 8887: @538051
     /*  538051 */   GIM_Try, /*On fail goto*//*Label 8888*/ GIMT_Encode4(538122), // Rule ID 4014 //
     /*  538056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538084 */     // MIs[0] passthru
     /*  538084 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538120 */     GIR_RootConstrainSelectedInstOperands,
     /*  538121 */     // GIR_Coverage, 4014,
     /*  538121 */     GIR_EraseRootFromParent_Done,
     /*  538122 */   // Label 8888: @538122
     /*  538122 */   GIM_Try, /*On fail goto*//*Label 8889*/ GIMT_Encode4(538193), // Rule ID 4015 //
     /*  538127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  538138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  538141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  538144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538155 */     // MIs[0] passthru
     /*  538155 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538171 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538191 */     GIR_RootConstrainSelectedInstOperands,
     /*  538192 */     // GIR_Coverage, 4015,
     /*  538192 */     GIR_EraseRootFromParent_Done,
     /*  538193 */   // Label 8889: @538193
     /*  538193 */   GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(538264), // Rule ID 4024 //
     /*  538198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538226 */     // MIs[0] passthru
     /*  538226 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538262 */     GIR_RootConstrainSelectedInstOperands,
     /*  538263 */     // GIR_Coverage, 4024,
     /*  538263 */     GIR_EraseRootFromParent_Done,
     /*  538264 */   // Label 8890: @538264
     /*  538264 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(538335), // Rule ID 4025 //
     /*  538269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  538280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  538283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  538286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538297 */     // MIs[0] passthru
     /*  538297 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538313 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538333 */     GIR_RootConstrainSelectedInstOperands,
     /*  538334 */     // GIR_Coverage, 4025,
     /*  538334 */     GIR_EraseRootFromParent_Done,
     /*  538335 */   // Label 8891: @538335
     /*  538335 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(538406), // Rule ID 4034 //
     /*  538340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538368 */     // MIs[0] passthru
     /*  538368 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538404 */     GIR_RootConstrainSelectedInstOperands,
     /*  538405 */     // GIR_Coverage, 4034,
     /*  538405 */     GIR_EraseRootFromParent_Done,
     /*  538406 */   // Label 8892: @538406
     /*  538406 */   GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(538477), // Rule ID 4035 //
     /*  538411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  538422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  538425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  538428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538439 */     // MIs[0] passthru
     /*  538439 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538455 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538475 */     GIR_RootConstrainSelectedInstOperands,
     /*  538476 */     // GIR_Coverage, 4035,
     /*  538476 */     GIR_EraseRootFromParent_Done,
     /*  538477 */   // Label 8893: @538477
     /*  538477 */   GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(538548), // Rule ID 4044 //
     /*  538482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  538485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  538493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  538496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  538499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538510 */     // MIs[0] passthru
     /*  538510 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  538526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538546 */     GIR_RootConstrainSelectedInstOperands,
     /*  538547 */     // GIR_Coverage, 4044,
     /*  538547 */     GIR_EraseRootFromParent_Done,
     /*  538548 */   // Label 8894: @538548
     /*  538548 */   GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(538619), // Rule ID 4045 //
     /*  538553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  538556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  538564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  538567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  538570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  538581 */     // MIs[0] passthru
     /*  538581 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538597 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  538597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  538600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  538614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538617 */     GIR_RootConstrainSelectedInstOperands,
     /*  538618 */     // GIR_Coverage, 4045,
     /*  538618 */     GIR_EraseRootFromParent_Done,
     /*  538619 */   // Label 8895: @538619
     /*  538619 */   GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(538690), // Rule ID 4054 //
     /*  538624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  538627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  538635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  538638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  538641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538652 */     // MIs[0] passthru
     /*  538652 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538688 */     GIR_RootConstrainSelectedInstOperands,
     /*  538689 */     // GIR_Coverage, 4054,
     /*  538689 */     GIR_EraseRootFromParent_Done,
     /*  538690 */   // Label 8896: @538690
     /*  538690 */   GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(538761), // Rule ID 4055 //
     /*  538695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  538698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  538706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  538709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  538712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538723 */     // MIs[0] passthru
     /*  538723 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538739 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_TIED),
     /*  538742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538759 */     GIR_RootConstrainSelectedInstOperands,
     /*  538760 */     // GIR_Coverage, 4055,
     /*  538760 */     GIR_EraseRootFromParent_Done,
     /*  538761 */   // Label 8897: @538761
     /*  538761 */   GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(538832), // Rule ID 4064 //
     /*  538766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  538769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  538777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  538780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  538783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538794 */     // MIs[0] passthru
     /*  538794 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538830 */     GIR_RootConstrainSelectedInstOperands,
     /*  538831 */     // GIR_Coverage, 4064,
     /*  538831 */     GIR_EraseRootFromParent_Done,
     /*  538832 */   // Label 8898: @538832
     /*  538832 */   GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(538903), // Rule ID 4065 //
     /*  538837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  538840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  538848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  538851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  538854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538865 */     // MIs[0] passthru
     /*  538865 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  538874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  538881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_TIED),
     /*  538884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538901 */     GIR_RootConstrainSelectedInstOperands,
     /*  538902 */     // GIR_Coverage, 4065,
     /*  538902 */     GIR_EraseRootFromParent_Done,
     /*  538903 */   // Label 8899: @538903
     /*  538903 */   GIM_Try, /*On fail goto*//*Label 8900*/ GIMT_Encode4(538974), // Rule ID 4074 //
     /*  538908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  538911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  538919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  538922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  538925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  538928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  538936 */     // MIs[0] passthru
     /*  538936 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  538941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  538945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  538952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  538952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  538955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  538957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  538959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  538961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  538966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  538969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  538972 */     GIR_RootConstrainSelectedInstOperands,
     /*  538973 */     // GIR_Coverage, 4074,
     /*  538973 */     GIR_EraseRootFromParent_Done,
     /*  538974 */   // Label 8900: @538974
     /*  538974 */   GIM_Try, /*On fail goto*//*Label 8901*/ GIMT_Encode4(539045), // Rule ID 4075 //
     /*  538979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  538982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  538987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  538990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  538993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  538996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  538999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539007 */     // MIs[0] passthru
     /*  539007 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539023 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_TIED),
     /*  539026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539043 */     GIR_RootConstrainSelectedInstOperands,
     /*  539044 */     // GIR_Coverage, 4075,
     /*  539044 */     GIR_EraseRootFromParent_Done,
     /*  539045 */   // Label 8901: @539045
     /*  539045 */   GIM_Try, /*On fail goto*//*Label 8902*/ GIMT_Encode4(539116), // Rule ID 4084 //
     /*  539050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  539053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539078 */     // MIs[0] passthru
     /*  539078 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  539094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539114 */     GIR_RootConstrainSelectedInstOperands,
     /*  539115 */     // GIR_Coverage, 4084,
     /*  539115 */     GIR_EraseRootFromParent_Done,
     /*  539116 */   // Label 8902: @539116
     /*  539116 */   GIM_Try, /*On fail goto*//*Label 8903*/ GIMT_Encode4(539187), // Rule ID 4085 //
     /*  539121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  539124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  539129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  539132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  539135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  539138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539149 */     // MIs[0] passthru
     /*  539149 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539165 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  539165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_TIED),
     /*  539168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  539182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539185 */     GIR_RootConstrainSelectedInstOperands,
     /*  539186 */     // GIR_Coverage, 4085,
     /*  539186 */     GIR_EraseRootFromParent_Done,
     /*  539187 */   // Label 8903: @539187
     /*  539187 */   GIM_Try, /*On fail goto*//*Label 8904*/ GIMT_Encode4(539258), // Rule ID 4154 //
     /*  539192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539220 */     // MIs[0] passthru
     /*  539220 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539236 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539256 */     GIR_RootConstrainSelectedInstOperands,
     /*  539257 */     // GIR_Coverage, 4154,
     /*  539257 */     GIR_EraseRootFromParent_Done,
     /*  539258 */   // Label 8904: @539258
     /*  539258 */   GIM_Try, /*On fail goto*//*Label 8905*/ GIMT_Encode4(539329), // Rule ID 4155 //
     /*  539263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  539274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  539277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  539280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539291 */     // MIs[0] passthru
     /*  539291 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539307 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_TIED),
     /*  539310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539327 */     GIR_RootConstrainSelectedInstOperands,
     /*  539328 */     // GIR_Coverage, 4155,
     /*  539328 */     GIR_EraseRootFromParent_Done,
     /*  539329 */   // Label 8905: @539329
     /*  539329 */   GIM_Try, /*On fail goto*//*Label 8906*/ GIMT_Encode4(539400), // Rule ID 4164 //
     /*  539334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539362 */     // MIs[0] passthru
     /*  539362 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539398 */     GIR_RootConstrainSelectedInstOperands,
     /*  539399 */     // GIR_Coverage, 4164,
     /*  539399 */     GIR_EraseRootFromParent_Done,
     /*  539400 */   // Label 8906: @539400
     /*  539400 */   GIM_Try, /*On fail goto*//*Label 8907*/ GIMT_Encode4(539471), // Rule ID 4165 //
     /*  539405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  539416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  539419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  539422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539433 */     // MIs[0] passthru
     /*  539433 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539449 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  539452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539469 */     GIR_RootConstrainSelectedInstOperands,
     /*  539470 */     // GIR_Coverage, 4165,
     /*  539470 */     GIR_EraseRootFromParent_Done,
     /*  539471 */   // Label 8907: @539471
     /*  539471 */   GIM_Try, /*On fail goto*//*Label 8908*/ GIMT_Encode4(539542), // Rule ID 4174 //
     /*  539476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  539493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539504 */     // MIs[0] passthru
     /*  539504 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  539523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539540 */     GIR_RootConstrainSelectedInstOperands,
     /*  539541 */     // GIR_Coverage, 4174,
     /*  539541 */     GIR_EraseRootFromParent_Done,
     /*  539542 */   // Label 8908: @539542
     /*  539542 */   GIM_Try, /*On fail goto*//*Label 8909*/ GIMT_Encode4(539613), // Rule ID 4175 //
     /*  539547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  539558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  539561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  539564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539575 */     // MIs[0] passthru
     /*  539575 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539591 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  539594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539611 */     GIR_RootConstrainSelectedInstOperands,
     /*  539612 */     // GIR_Coverage, 4175,
     /*  539612 */     GIR_EraseRootFromParent_Done,
     /*  539613 */   // Label 8909: @539613
     /*  539613 */   GIM_Try, /*On fail goto*//*Label 8910*/ GIMT_Encode4(539684), // Rule ID 4184 //
     /*  539618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  539635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539646 */     // MIs[0] passthru
     /*  539646 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539662 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  539665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539682 */     GIR_RootConstrainSelectedInstOperands,
     /*  539683 */     // GIR_Coverage, 4184,
     /*  539683 */     GIR_EraseRootFromParent_Done,
     /*  539684 */   // Label 8910: @539684
     /*  539684 */   GIM_Try, /*On fail goto*//*Label 8911*/ GIMT_Encode4(539755), // Rule ID 4185 //
     /*  539689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  539700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  539703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  539706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539717 */     // MIs[0] passthru
     /*  539717 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  539726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539733 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  539736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539753 */     GIR_RootConstrainSelectedInstOperands,
     /*  539754 */     // GIR_Coverage, 4185,
     /*  539754 */     GIR_EraseRootFromParent_Done,
     /*  539755 */   // Label 8911: @539755
     /*  539755 */   GIM_Try, /*On fail goto*//*Label 8912*/ GIMT_Encode4(539826), // Rule ID 4194 //
     /*  539760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  539777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539788 */     // MIs[0] passthru
     /*  539788 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  539807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539824 */     GIR_RootConstrainSelectedInstOperands,
     /*  539825 */     // GIR_Coverage, 4194,
     /*  539825 */     GIR_EraseRootFromParent_Done,
     /*  539826 */   // Label 8912: @539826
     /*  539826 */   GIM_Try, /*On fail goto*//*Label 8913*/ GIMT_Encode4(539897), // Rule ID 4195 //
     /*  539831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  539842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  539845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  539848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539859 */     // MIs[0] passthru
     /*  539859 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  539868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539875 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  539875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  539878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539895 */     GIR_RootConstrainSelectedInstOperands,
     /*  539896 */     // GIR_Coverage, 4195,
     /*  539896 */     GIR_EraseRootFromParent_Done,
     /*  539897 */   // Label 8913: @539897
     /*  539897 */   GIM_Try, /*On fail goto*//*Label 8914*/ GIMT_Encode4(539968), // Rule ID 4204 //
     /*  539902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  539905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  539913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  539916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  539919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  539922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539930 */     // MIs[0] passthru
     /*  539930 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  539935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  539939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  539946 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  539946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  539949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  539951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  539953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  539955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  539960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  539963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  539966 */     GIR_RootConstrainSelectedInstOperands,
     /*  539967 */     // GIR_Coverage, 4204,
     /*  539967 */     GIR_EraseRootFromParent_Done,
     /*  539968 */   // Label 8914: @539968
     /*  539968 */   GIM_Try, /*On fail goto*//*Label 8915*/ GIMT_Encode4(540039), // Rule ID 4205 //
     /*  539973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  539976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  539981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  539984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  539987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  539990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  539993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  539997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540001 */     // MIs[0] passthru
     /*  540001 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540017 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  540017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  540034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540037 */     GIR_RootConstrainSelectedInstOperands,
     /*  540038 */     // GIR_Coverage, 4205,
     /*  540038 */     GIR_EraseRootFromParent_Done,
     /*  540039 */   // Label 8915: @540039
     /*  540039 */   GIM_Try, /*On fail goto*//*Label 8916*/ GIMT_Encode4(540110), // Rule ID 4214 //
     /*  540044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540072 */     // MIs[0] passthru
     /*  540072 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540108 */     GIR_RootConstrainSelectedInstOperands,
     /*  540109 */     // GIR_Coverage, 4214,
     /*  540109 */     GIR_EraseRootFromParent_Done,
     /*  540110 */   // Label 8916: @540110
     /*  540110 */   GIM_Try, /*On fail goto*//*Label 8917*/ GIMT_Encode4(540181), // Rule ID 4215 //
     /*  540115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  540126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  540129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  540132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540143 */     // MIs[0] passthru
     /*  540143 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540159 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_TIED),
     /*  540162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540179 */     GIR_RootConstrainSelectedInstOperands,
     /*  540180 */     // GIR_Coverage, 4215,
     /*  540180 */     GIR_EraseRootFromParent_Done,
     /*  540181 */   // Label 8917: @540181
     /*  540181 */   GIM_Try, /*On fail goto*//*Label 8918*/ GIMT_Encode4(540252), // Rule ID 4224 //
     /*  540186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540214 */     // MIs[0] passthru
     /*  540214 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540230 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540250 */     GIR_RootConstrainSelectedInstOperands,
     /*  540251 */     // GIR_Coverage, 4224,
     /*  540251 */     GIR_EraseRootFromParent_Done,
     /*  540252 */   // Label 8918: @540252
     /*  540252 */   GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(540323), // Rule ID 4225 //
     /*  540257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  540268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  540271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  540274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540285 */     // MIs[0] passthru
     /*  540285 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540301 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540321 */     GIR_RootConstrainSelectedInstOperands,
     /*  540322 */     // GIR_Coverage, 4225,
     /*  540322 */     GIR_EraseRootFromParent_Done,
     /*  540323 */   // Label 8919: @540323
     /*  540323 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(540394), // Rule ID 4234 //
     /*  540328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540356 */     // MIs[0] passthru
     /*  540356 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540392 */     GIR_RootConstrainSelectedInstOperands,
     /*  540393 */     // GIR_Coverage, 4234,
     /*  540393 */     GIR_EraseRootFromParent_Done,
     /*  540394 */   // Label 8920: @540394
     /*  540394 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(540465), // Rule ID 4235 //
     /*  540399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  540410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  540413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  540416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540427 */     // MIs[0] passthru
     /*  540427 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540463 */     GIR_RootConstrainSelectedInstOperands,
     /*  540464 */     // GIR_Coverage, 4235,
     /*  540464 */     GIR_EraseRootFromParent_Done,
     /*  540465 */   // Label 8921: @540465
     /*  540465 */   GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(540536), // Rule ID 4244 //
     /*  540470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  540487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540498 */     // MIs[0] passthru
     /*  540498 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540534 */     GIR_RootConstrainSelectedInstOperands,
     /*  540535 */     // GIR_Coverage, 4244,
     /*  540535 */     GIR_EraseRootFromParent_Done,
     /*  540536 */   // Label 8922: @540536
     /*  540536 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(540607), // Rule ID 4245 //
     /*  540541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  540552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  540555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  540558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540569 */     // MIs[0] passthru
     /*  540569 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  540588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540605 */     GIR_RootConstrainSelectedInstOperands,
     /*  540606 */     // GIR_Coverage, 4245,
     /*  540606 */     GIR_EraseRootFromParent_Done,
     /*  540607 */   // Label 8923: @540607
     /*  540607 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(540678), // Rule ID 4254 //
     /*  540612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  540615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  540623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  540626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  540629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540640 */     // MIs[0] passthru
     /*  540640 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540656 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  540656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540676 */     GIR_RootConstrainSelectedInstOperands,
     /*  540677 */     // GIR_Coverage, 4254,
     /*  540677 */     GIR_EraseRootFromParent_Done,
     /*  540678 */   // Label 8924: @540678
     /*  540678 */   GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(540749), // Rule ID 4255 //
     /*  540683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  540686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  540694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  540697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  540700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  540711 */     // MIs[0] passthru
     /*  540711 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  540720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  540727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  540730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  540744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540747 */     GIR_RootConstrainSelectedInstOperands,
     /*  540748 */     // GIR_Coverage, 4255,
     /*  540748 */     GIR_EraseRootFromParent_Done,
     /*  540749 */   // Label 8925: @540749
     /*  540749 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(540820), // Rule ID 4264 //
     /*  540754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  540757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  540765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  540768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  540771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540782 */     // MIs[0] passthru
     /*  540782 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540818 */     GIR_RootConstrainSelectedInstOperands,
     /*  540819 */     // GIR_Coverage, 4264,
     /*  540819 */     GIR_EraseRootFromParent_Done,
     /*  540820 */   // Label 8926: @540820
     /*  540820 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(540891), // Rule ID 4265 //
     /*  540825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  540828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  540836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  540839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  540842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540853 */     // MIs[0] passthru
     /*  540853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  540869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_TIED),
     /*  540872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540889 */     GIR_RootConstrainSelectedInstOperands,
     /*  540890 */     // GIR_Coverage, 4265,
     /*  540890 */     GIR_EraseRootFromParent_Done,
     /*  540891 */   // Label 8927: @540891
     /*  540891 */   GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(540962), // Rule ID 4274 //
     /*  540896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  540899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  540907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  540910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  540913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  540916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540924 */     // MIs[0] passthru
     /*  540924 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  540929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  540933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  540940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  540940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  540943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  540945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  540947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  540949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  540954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  540957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  540960 */     GIR_RootConstrainSelectedInstOperands,
     /*  540961 */     // GIR_Coverage, 4274,
     /*  540961 */     GIR_EraseRootFromParent_Done,
     /*  540962 */   // Label 8928: @540962
     /*  540962 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(541033), // Rule ID 4275 //
     /*  540967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  540970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  540975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  540978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  540981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  540984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  540987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  540995 */     // MIs[0] passthru
     /*  540995 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541011 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_TIED),
     /*  541014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541031 */     GIR_RootConstrainSelectedInstOperands,
     /*  541032 */     // GIR_Coverage, 4275,
     /*  541032 */     GIR_EraseRootFromParent_Done,
     /*  541033 */   // Label 8929: @541033
     /*  541033 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(541104), // Rule ID 4284 //
     /*  541038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541066 */     // MIs[0] passthru
     /*  541066 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541102 */     GIR_RootConstrainSelectedInstOperands,
     /*  541103 */     // GIR_Coverage, 4284,
     /*  541103 */     GIR_EraseRootFromParent_Done,
     /*  541104 */   // Label 8930: @541104
     /*  541104 */   GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(541175), // Rule ID 4285 //
     /*  541109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  541120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  541123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  541126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541137 */     // MIs[0] passthru
     /*  541137 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541153 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_TIED),
     /*  541156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541173 */     GIR_RootConstrainSelectedInstOperands,
     /*  541174 */     // GIR_Coverage, 4285,
     /*  541174 */     GIR_EraseRootFromParent_Done,
     /*  541175 */   // Label 8931: @541175
     /*  541175 */   GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(541246), // Rule ID 4294 //
     /*  541180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  541183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541208 */     // MIs[0] passthru
     /*  541208 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541224 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  541224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541244 */     GIR_RootConstrainSelectedInstOperands,
     /*  541245 */     // GIR_Coverage, 4294,
     /*  541245 */     GIR_EraseRootFromParent_Done,
     /*  541246 */   // Label 8932: @541246
     /*  541246 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(541317), // Rule ID 4295 //
     /*  541251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  541254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  541259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  541262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  541265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  541268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  541279 */     // MIs[0] passthru
     /*  541279 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541295 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  541295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_TIED),
     /*  541298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  541312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541315 */     GIR_RootConstrainSelectedInstOperands,
     /*  541316 */     // GIR_Coverage, 4295,
     /*  541316 */     GIR_EraseRootFromParent_Done,
     /*  541317 */   // Label 8933: @541317
     /*  541317 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(541388), // Rule ID 4364 //
     /*  541322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541350 */     // MIs[0] passthru
     /*  541350 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541386 */     GIR_RootConstrainSelectedInstOperands,
     /*  541387 */     // GIR_Coverage, 4364,
     /*  541387 */     GIR_EraseRootFromParent_Done,
     /*  541388 */   // Label 8934: @541388
     /*  541388 */   GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(541459), // Rule ID 4365 //
     /*  541393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  541404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  541407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  541410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541421 */     // MIs[0] passthru
     /*  541421 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541437 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_TIED),
     /*  541440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541457 */     GIR_RootConstrainSelectedInstOperands,
     /*  541458 */     // GIR_Coverage, 4365,
     /*  541458 */     GIR_EraseRootFromParent_Done,
     /*  541459 */   // Label 8935: @541459
     /*  541459 */   GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(541530), // Rule ID 4374 //
     /*  541464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541492 */     // MIs[0] passthru
     /*  541492 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  541511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541528 */     GIR_RootConstrainSelectedInstOperands,
     /*  541529 */     // GIR_Coverage, 4374,
     /*  541529 */     GIR_EraseRootFromParent_Done,
     /*  541530 */   // Label 8936: @541530
     /*  541530 */   GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(541601), // Rule ID 4375 //
     /*  541535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  541546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  541549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  541552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541563 */     // MIs[0] passthru
     /*  541563 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541579 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  541582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541599 */     GIR_RootConstrainSelectedInstOperands,
     /*  541600 */     // GIR_Coverage, 4375,
     /*  541600 */     GIR_EraseRootFromParent_Done,
     /*  541601 */   // Label 8937: @541601
     /*  541601 */   GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(541672), // Rule ID 4384 //
     /*  541606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541634 */     // MIs[0] passthru
     /*  541634 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  541653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541670 */     GIR_RootConstrainSelectedInstOperands,
     /*  541671 */     // GIR_Coverage, 4384,
     /*  541671 */     GIR_EraseRootFromParent_Done,
     /*  541672 */   // Label 8938: @541672
     /*  541672 */   GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(541743), // Rule ID 4385 //
     /*  541677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  541688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  541691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  541694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541705 */     // MIs[0] passthru
     /*  541705 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541721 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  541724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541741 */     GIR_RootConstrainSelectedInstOperands,
     /*  541742 */     // GIR_Coverage, 4385,
     /*  541742 */     GIR_EraseRootFromParent_Done,
     /*  541743 */   // Label 8939: @541743
     /*  541743 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(541814), // Rule ID 4394 //
     /*  541748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541776 */     // MIs[0] passthru
     /*  541776 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  541795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541812 */     GIR_RootConstrainSelectedInstOperands,
     /*  541813 */     // GIR_Coverage, 4394,
     /*  541813 */     GIR_EraseRootFromParent_Done,
     /*  541814 */   // Label 8940: @541814
     /*  541814 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(541885), // Rule ID 4395 //
     /*  541819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  541830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  541833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  541836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541847 */     // MIs[0] passthru
     /*  541847 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  541856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541863 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  541863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  541866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541883 */     GIR_RootConstrainSelectedInstOperands,
     /*  541884 */     // GIR_Coverage, 4395,
     /*  541884 */     GIR_EraseRootFromParent_Done,
     /*  541885 */   // Label 8941: @541885
     /*  541885 */   GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(541956), // Rule ID 4404 //
     /*  541890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  541893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  541907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  541910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541918 */     // MIs[0] passthru
     /*  541918 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  541934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  541934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  541937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  541939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  541941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  541943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  541948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  541951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  541954 */     GIR_RootConstrainSelectedInstOperands,
     /*  541955 */     // GIR_Coverage, 4404,
     /*  541955 */     GIR_EraseRootFromParent_Done,
     /*  541956 */   // Label 8942: @541956
     /*  541956 */   GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(542027), // Rule ID 4405 //
     /*  541961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  541964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  541969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  541972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  541975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  541978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  541981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  541989 */     // MIs[0] passthru
     /*  541989 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  541994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  541998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542005 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542025 */     GIR_RootConstrainSelectedInstOperands,
     /*  542026 */     // GIR_Coverage, 4405,
     /*  542026 */     GIR_EraseRootFromParent_Done,
     /*  542027 */   // Label 8943: @542027
     /*  542027 */   GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(542098), // Rule ID 4414 //
     /*  542032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542060 */     // MIs[0] passthru
     /*  542060 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542076 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  542076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542096 */     GIR_RootConstrainSelectedInstOperands,
     /*  542097 */     // GIR_Coverage, 4414,
     /*  542097 */     GIR_EraseRootFromParent_Done,
     /*  542098 */   // Label 8944: @542098
     /*  542098 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(542169), // Rule ID 4415 //
     /*  542103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  542114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  542117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  542120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542131 */     // MIs[0] passthru
     /*  542131 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542147 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  542147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  542164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542167 */     GIR_RootConstrainSelectedInstOperands,
     /*  542168 */     // GIR_Coverage, 4415,
     /*  542168 */     GIR_EraseRootFromParent_Done,
     /*  542169 */   // Label 8945: @542169
     /*  542169 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(542240), // Rule ID 4424 //
     /*  542174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542202 */     // MIs[0] passthru
     /*  542202 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542218 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542238 */     GIR_RootConstrainSelectedInstOperands,
     /*  542239 */     // GIR_Coverage, 4424,
     /*  542239 */     GIR_EraseRootFromParent_Done,
     /*  542240 */   // Label 8946: @542240
     /*  542240 */   GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(542311), // Rule ID 4425 //
     /*  542245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  542256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  542259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  542262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542273 */     // MIs[0] passthru
     /*  542273 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_TIED),
     /*  542292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542309 */     GIR_RootConstrainSelectedInstOperands,
     /*  542310 */     // GIR_Coverage, 4425,
     /*  542310 */     GIR_EraseRootFromParent_Done,
     /*  542311 */   // Label 8947: @542311
     /*  542311 */   GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(542382), // Rule ID 4434 //
     /*  542316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542344 */     // MIs[0] passthru
     /*  542344 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542380 */     GIR_RootConstrainSelectedInstOperands,
     /*  542381 */     // GIR_Coverage, 4434,
     /*  542381 */     GIR_EraseRootFromParent_Done,
     /*  542382 */   // Label 8948: @542382
     /*  542382 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(542453), // Rule ID 4435 //
     /*  542387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  542398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  542401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  542404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542415 */     // MIs[0] passthru
     /*  542415 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542431 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542451 */     GIR_RootConstrainSelectedInstOperands,
     /*  542452 */     // GIR_Coverage, 4435,
     /*  542452 */     GIR_EraseRootFromParent_Done,
     /*  542453 */   // Label 8949: @542453
     /*  542453 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(542524), // Rule ID 4444 //
     /*  542458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542486 */     // MIs[0] passthru
     /*  542486 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542522 */     GIR_RootConstrainSelectedInstOperands,
     /*  542523 */     // GIR_Coverage, 4444,
     /*  542523 */     GIR_EraseRootFromParent_Done,
     /*  542524 */   // Label 8950: @542524
     /*  542524 */   GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(542595), // Rule ID 4445 //
     /*  542529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  542540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  542543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  542546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542557 */     // MIs[0] passthru
     /*  542557 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542573 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  542576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542593 */     GIR_RootConstrainSelectedInstOperands,
     /*  542594 */     // GIR_Coverage, 4445,
     /*  542594 */     GIR_EraseRootFromParent_Done,
     /*  542595 */   // Label 8951: @542595
     /*  542595 */   GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(542666), // Rule ID 4454 //
     /*  542600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542628 */     // MIs[0] passthru
     /*  542628 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542664 */     GIR_RootConstrainSelectedInstOperands,
     /*  542665 */     // GIR_Coverage, 4454,
     /*  542665 */     GIR_EraseRootFromParent_Done,
     /*  542666 */   // Label 8952: @542666
     /*  542666 */   GIM_Try, /*On fail goto*//*Label 8953*/ GIMT_Encode4(542737), // Rule ID 4455 //
     /*  542671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  542682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  542685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  542688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542699 */     // MIs[0] passthru
     /*  542699 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  542708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542715 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  542718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542735 */     GIR_RootConstrainSelectedInstOperands,
     /*  542736 */     // GIR_Coverage, 4455,
     /*  542736 */     GIR_EraseRootFromParent_Done,
     /*  542737 */   // Label 8953: @542737
     /*  542737 */   GIM_Try, /*On fail goto*//*Label 8954*/ GIMT_Encode4(542808), // Rule ID 4464 //
     /*  542742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  542745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542770 */     // MIs[0] passthru
     /*  542770 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542786 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  542786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542806 */     GIR_RootConstrainSelectedInstOperands,
     /*  542807 */     // GIR_Coverage, 4464,
     /*  542807 */     GIR_EraseRootFromParent_Done,
     /*  542808 */   // Label 8954: @542808
     /*  542808 */   GIM_Try, /*On fail goto*//*Label 8955*/ GIMT_Encode4(542879), // Rule ID 4465 //
     /*  542813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  542816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  542824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  542827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  542830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  542841 */     // MIs[0] passthru
     /*  542841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  542850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542857 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  542857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  542860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  542874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542877 */     GIR_RootConstrainSelectedInstOperands,
     /*  542878 */     // GIR_Coverage, 4465,
     /*  542878 */     GIR_EraseRootFromParent_Done,
     /*  542879 */   // Label 8955: @542879
     /*  542879 */   GIM_Try, /*On fail goto*//*Label 8956*/ GIMT_Encode4(542950), // Rule ID 4474 //
     /*  542884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  542887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  542895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  542898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  542901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  542904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542912 */     // MIs[0] passthru
     /*  542912 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  542928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  542931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  542933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  542935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  542937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  542942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  542945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  542948 */     GIR_RootConstrainSelectedInstOperands,
     /*  542949 */     // GIR_Coverage, 4474,
     /*  542949 */     GIR_EraseRootFromParent_Done,
     /*  542950 */   // Label 8956: @542950
     /*  542950 */   GIM_Try, /*On fail goto*//*Label 8957*/ GIMT_Encode4(543021), // Rule ID 4475 //
     /*  542955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  542958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  542963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  542966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  542969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  542972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  542975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542983 */     // MIs[0] passthru
     /*  542983 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  542988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  542992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  542999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  542999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_TIED),
     /*  543002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543019 */     GIR_RootConstrainSelectedInstOperands,
     /*  543020 */     // GIR_Coverage, 4475,
     /*  543020 */     GIR_EraseRootFromParent_Done,
     /*  543021 */   // Label 8957: @543021
     /*  543021 */   GIM_Try, /*On fail goto*//*Label 8958*/ GIMT_Encode4(543092), // Rule ID 4484 //
     /*  543026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543054 */     // MIs[0] passthru
     /*  543054 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543090 */     GIR_RootConstrainSelectedInstOperands,
     /*  543091 */     // GIR_Coverage, 4484,
     /*  543091 */     GIR_EraseRootFromParent_Done,
     /*  543092 */   // Label 8958: @543092
     /*  543092 */   GIM_Try, /*On fail goto*//*Label 8959*/ GIMT_Encode4(543163), // Rule ID 4485 //
     /*  543097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  543108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  543111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  543114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543125 */     // MIs[0] passthru
     /*  543125 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_TIED),
     /*  543144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543161 */     GIR_RootConstrainSelectedInstOperands,
     /*  543162 */     // GIR_Coverage, 4485,
     /*  543162 */     GIR_EraseRootFromParent_Done,
     /*  543163 */   // Label 8959: @543163
     /*  543163 */   GIM_Try, /*On fail goto*//*Label 8960*/ GIMT_Encode4(543234), // Rule ID 4494 //
     /*  543168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543196 */     // MIs[0] passthru
     /*  543196 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543232 */     GIR_RootConstrainSelectedInstOperands,
     /*  543233 */     // GIR_Coverage, 4494,
     /*  543233 */     GIR_EraseRootFromParent_Done,
     /*  543234 */   // Label 8960: @543234
     /*  543234 */   GIM_Try, /*On fail goto*//*Label 8961*/ GIMT_Encode4(543305), // Rule ID 4495 //
     /*  543239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  543250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  543253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  543256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543267 */     // MIs[0] passthru
     /*  543267 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543283 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_TIED),
     /*  543286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543303 */     GIR_RootConstrainSelectedInstOperands,
     /*  543304 */     // GIR_Coverage, 4495,
     /*  543304 */     GIR_EraseRootFromParent_Done,
     /*  543305 */   // Label 8961: @543305
     /*  543305 */   GIM_Try, /*On fail goto*//*Label 8962*/ GIMT_Encode4(543376), // Rule ID 4504 //
     /*  543310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  543313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543338 */     // MIs[0] passthru
     /*  543338 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543354 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  543354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543374 */     GIR_RootConstrainSelectedInstOperands,
     /*  543375 */     // GIR_Coverage, 4504,
     /*  543375 */     GIR_EraseRootFromParent_Done,
     /*  543376 */   // Label 8962: @543376
     /*  543376 */   GIM_Try, /*On fail goto*//*Label 8963*/ GIMT_Encode4(543447), // Rule ID 4505 //
     /*  543381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  543384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  543389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  543392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  543395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  543398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  543409 */     // MIs[0] passthru
     /*  543409 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  543418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543425 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  543425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_TIED),
     /*  543428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  543442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543445 */     GIR_RootConstrainSelectedInstOperands,
     /*  543446 */     // GIR_Coverage, 4505,
     /*  543446 */     GIR_EraseRootFromParent_Done,
     /*  543447 */   // Label 8963: @543447
     /*  543447 */   GIM_Try, /*On fail goto*//*Label 8964*/ GIMT_Encode4(543518), // Rule ID 4574 //
     /*  543452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543480 */     // MIs[0] passthru
     /*  543480 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543496 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  543499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543516 */     GIR_RootConstrainSelectedInstOperands,
     /*  543517 */     // GIR_Coverage, 4574,
     /*  543517 */     GIR_EraseRootFromParent_Done,
     /*  543518 */   // Label 8964: @543518
     /*  543518 */   GIM_Try, /*On fail goto*//*Label 8965*/ GIMT_Encode4(543589), // Rule ID 4575 //
     /*  543523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  543534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  543537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  543540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543551 */     // MIs[0] passthru
     /*  543551 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543567 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_TIED),
     /*  543570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543587 */     GIR_RootConstrainSelectedInstOperands,
     /*  543588 */     // GIR_Coverage, 4575,
     /*  543588 */     GIR_EraseRootFromParent_Done,
     /*  543589 */   // Label 8965: @543589
     /*  543589 */   GIM_Try, /*On fail goto*//*Label 8966*/ GIMT_Encode4(543660), // Rule ID 4584 //
     /*  543594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543622 */     // MIs[0] passthru
     /*  543622 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  543641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543658 */     GIR_RootConstrainSelectedInstOperands,
     /*  543659 */     // GIR_Coverage, 4584,
     /*  543659 */     GIR_EraseRootFromParent_Done,
     /*  543660 */   // Label 8966: @543660
     /*  543660 */   GIM_Try, /*On fail goto*//*Label 8967*/ GIMT_Encode4(543731), // Rule ID 4585 //
     /*  543665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  543676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  543679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  543682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543693 */     // MIs[0] passthru
     /*  543693 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543709 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  543712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543729 */     GIR_RootConstrainSelectedInstOperands,
     /*  543730 */     // GIR_Coverage, 4585,
     /*  543730 */     GIR_EraseRootFromParent_Done,
     /*  543731 */   // Label 8967: @543731
     /*  543731 */   GIM_Try, /*On fail goto*//*Label 8968*/ GIMT_Encode4(543802), // Rule ID 4594 //
     /*  543736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543764 */     // MIs[0] passthru
     /*  543764 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  543783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543800 */     GIR_RootConstrainSelectedInstOperands,
     /*  543801 */     // GIR_Coverage, 4594,
     /*  543801 */     GIR_EraseRootFromParent_Done,
     /*  543802 */   // Label 8968: @543802
     /*  543802 */   GIM_Try, /*On fail goto*//*Label 8969*/ GIMT_Encode4(543873), // Rule ID 4595 //
     /*  543807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  543818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  543821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  543824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543835 */     // MIs[0] passthru
     /*  543835 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543851 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  543854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543871 */     GIR_RootConstrainSelectedInstOperands,
     /*  543872 */     // GIR_Coverage, 4595,
     /*  543872 */     GIR_EraseRootFromParent_Done,
     /*  543873 */   // Label 8969: @543873
     /*  543873 */   GIM_Try, /*On fail goto*//*Label 8970*/ GIMT_Encode4(543944), // Rule ID 4604 //
     /*  543878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  543881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  543889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  543892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  543895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  543898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543906 */     // MIs[0] passthru
     /*  543906 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543922 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  543922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  543925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  543929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  543931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  543936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  543939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  543942 */     GIR_RootConstrainSelectedInstOperands,
     /*  543943 */     // GIR_Coverage, 4604,
     /*  543943 */     GIR_EraseRootFromParent_Done,
     /*  543944 */   // Label 8970: @543944
     /*  543944 */   GIM_Try, /*On fail goto*//*Label 8971*/ GIMT_Encode4(544015), // Rule ID 4605 //
     /*  543949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  543952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  543957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  543960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  543963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  543966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  543969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  543977 */     // MIs[0] passthru
     /*  543977 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  543982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  543986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  543993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  543993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  543996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  543998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544013 */     GIR_RootConstrainSelectedInstOperands,
     /*  544014 */     // GIR_Coverage, 4605,
     /*  544014 */     GIR_EraseRootFromParent_Done,
     /*  544015 */   // Label 8971: @544015
     /*  544015 */   GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(544086), // Rule ID 4614 //
     /*  544020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544048 */     // MIs[0] passthru
     /*  544048 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544064 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544084 */     GIR_RootConstrainSelectedInstOperands,
     /*  544085 */     // GIR_Coverage, 4614,
     /*  544085 */     GIR_EraseRootFromParent_Done,
     /*  544086 */   // Label 8972: @544086
     /*  544086 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(544157), // Rule ID 4615 //
     /*  544091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  544102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  544105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  544108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544119 */     // MIs[0] passthru
     /*  544119 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544135 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544155 */     GIR_RootConstrainSelectedInstOperands,
     /*  544156 */     // GIR_Coverage, 4615,
     /*  544156 */     GIR_EraseRootFromParent_Done,
     /*  544157 */   // Label 8973: @544157
     /*  544157 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(544228), // Rule ID 4624 //
     /*  544162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544190 */     // MIs[0] passthru
     /*  544190 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  544206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544226 */     GIR_RootConstrainSelectedInstOperands,
     /*  544227 */     // GIR_Coverage, 4624,
     /*  544227 */     GIR_EraseRootFromParent_Done,
     /*  544228 */   // Label 8974: @544228
     /*  544228 */   GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(544299), // Rule ID 4625 //
     /*  544233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  544244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  544247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  544250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544261 */     // MIs[0] passthru
     /*  544261 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  544277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  544294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544297 */     GIR_RootConstrainSelectedInstOperands,
     /*  544298 */     // GIR_Coverage, 4625,
     /*  544298 */     GIR_EraseRootFromParent_Done,
     /*  544299 */   // Label 8975: @544299
     /*  544299 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(544370), // Rule ID 4634 //
     /*  544304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544332 */     // MIs[0] passthru
     /*  544332 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544348 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544368 */     GIR_RootConstrainSelectedInstOperands,
     /*  544369 */     // GIR_Coverage, 4634,
     /*  544369 */     GIR_EraseRootFromParent_Done,
     /*  544370 */   // Label 8976: @544370
     /*  544370 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(544441), // Rule ID 4635 //
     /*  544375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  544386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  544389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  544392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544403 */     // MIs[0] passthru
     /*  544403 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544419 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_TIED),
     /*  544422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544439 */     GIR_RootConstrainSelectedInstOperands,
     /*  544440 */     // GIR_Coverage, 4635,
     /*  544440 */     GIR_EraseRootFromParent_Done,
     /*  544441 */   // Label 8977: @544441
     /*  544441 */   GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(544512), // Rule ID 4644 //
     /*  544446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544474 */     // MIs[0] passthru
     /*  544474 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544510 */     GIR_RootConstrainSelectedInstOperands,
     /*  544511 */     // GIR_Coverage, 4644,
     /*  544511 */     GIR_EraseRootFromParent_Done,
     /*  544512 */   // Label 8978: @544512
     /*  544512 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(544583), // Rule ID 4645 //
     /*  544517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  544528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  544531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  544534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544545 */     // MIs[0] passthru
     /*  544545 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544561 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  544564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544581 */     GIR_RootConstrainSelectedInstOperands,
     /*  544582 */     // GIR_Coverage, 4645,
     /*  544582 */     GIR_EraseRootFromParent_Done,
     /*  544583 */   // Label 8979: @544583
     /*  544583 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(544654), // Rule ID 4654 //
     /*  544588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544616 */     // MIs[0] passthru
     /*  544616 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544652 */     GIR_RootConstrainSelectedInstOperands,
     /*  544653 */     // GIR_Coverage, 4654,
     /*  544653 */     GIR_EraseRootFromParent_Done,
     /*  544654 */   // Label 8980: @544654
     /*  544654 */   GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(544725), // Rule ID 4655 //
     /*  544659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  544670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  544673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  544676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544687 */     // MIs[0] passthru
     /*  544687 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  544696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544703 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  544706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544723 */     GIR_RootConstrainSelectedInstOperands,
     /*  544724 */     // GIR_Coverage, 4655,
     /*  544724 */     GIR_EraseRootFromParent_Done,
     /*  544725 */   // Label 8981: @544725
     /*  544725 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(544796), // Rule ID 4664 //
     /*  544730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544758 */     // MIs[0] passthru
     /*  544758 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544774 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544794 */     GIR_RootConstrainSelectedInstOperands,
     /*  544795 */     // GIR_Coverage, 4664,
     /*  544795 */     GIR_EraseRootFromParent_Done,
     /*  544796 */   // Label 8982: @544796
     /*  544796 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(544867), // Rule ID 4665 //
     /*  544801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  544812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  544815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  544818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544829 */     // MIs[0] passthru
     /*  544829 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  544838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544845 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  544848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544865 */     GIR_RootConstrainSelectedInstOperands,
     /*  544866 */     // GIR_Coverage, 4665,
     /*  544866 */     GIR_EraseRootFromParent_Done,
     /*  544867 */   // Label 8983: @544867
     /*  544867 */   GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(544938), // Rule ID 4674 //
     /*  544872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  544875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  544883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  544886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  544889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  544892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544900 */     // MIs[0] passthru
     /*  544900 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  544916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  544930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  544933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  544936 */     GIR_RootConstrainSelectedInstOperands,
     /*  544937 */     // GIR_Coverage, 4674,
     /*  544937 */     GIR_EraseRootFromParent_Done,
     /*  544938 */   // Label 8984: @544938
     /*  544938 */   GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(545009), // Rule ID 4675 //
     /*  544943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  544946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  544951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  544954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  544957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  544960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  544963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  544971 */     // MIs[0] passthru
     /*  544971 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  544976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  544980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  544987 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  544987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  544990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  544992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  544994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  544996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  545004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545007 */     GIR_RootConstrainSelectedInstOperands,
     /*  545008 */     // GIR_Coverage, 4675,
     /*  545008 */     GIR_EraseRootFromParent_Done,
     /*  545009 */   // Label 8985: @545009
     /*  545009 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(545080), // Rule ID 4684 //
     /*  545014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545042 */     // MIs[0] passthru
     /*  545042 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545058 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545078 */     GIR_RootConstrainSelectedInstOperands,
     /*  545079 */     // GIR_Coverage, 4684,
     /*  545079 */     GIR_EraseRootFromParent_Done,
     /*  545080 */   // Label 8986: @545080
     /*  545080 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(545151), // Rule ID 4685 //
     /*  545085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  545096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  545099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  545102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545113 */     // MIs[0] passthru
     /*  545113 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_TIED),
     /*  545132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545149 */     GIR_RootConstrainSelectedInstOperands,
     /*  545150 */     // GIR_Coverage, 4685,
     /*  545150 */     GIR_EraseRootFromParent_Done,
     /*  545151 */   // Label 8987: @545151
     /*  545151 */   GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(545222), // Rule ID 4694 //
     /*  545156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545184 */     // MIs[0] passthru
     /*  545184 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545220 */     GIR_RootConstrainSelectedInstOperands,
     /*  545221 */     // GIR_Coverage, 4694,
     /*  545221 */     GIR_EraseRootFromParent_Done,
     /*  545222 */   // Label 8988: @545222
     /*  545222 */   GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(545293), // Rule ID 4695 //
     /*  545227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  545238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  545241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  545244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545255 */     // MIs[0] passthru
     /*  545255 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545271 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_TIED),
     /*  545274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545291 */     GIR_RootConstrainSelectedInstOperands,
     /*  545292 */     // GIR_Coverage, 4695,
     /*  545292 */     GIR_EraseRootFromParent_Done,
     /*  545293 */   // Label 8989: @545293
     /*  545293 */   GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(545364), // Rule ID 4704 //
     /*  545298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545326 */     // MIs[0] passthru
     /*  545326 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545342 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545362 */     GIR_RootConstrainSelectedInstOperands,
     /*  545363 */     // GIR_Coverage, 4704,
     /*  545363 */     GIR_EraseRootFromParent_Done,
     /*  545364 */   // Label 8990: @545364
     /*  545364 */   GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(545435), // Rule ID 4705 //
     /*  545369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  545380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  545383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  545386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545397 */     // MIs[0] passthru
     /*  545397 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  545406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545413 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_TIED),
     /*  545416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545433 */     GIR_RootConstrainSelectedInstOperands,
     /*  545434 */     // GIR_Coverage, 4705,
     /*  545434 */     GIR_EraseRootFromParent_Done,
     /*  545435 */   // Label 8991: @545435
     /*  545435 */   GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(545506), // Rule ID 4714 //
     /*  545440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  545443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545468 */     // MIs[0] passthru
     /*  545468 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  545484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545504 */     GIR_RootConstrainSelectedInstOperands,
     /*  545505 */     // GIR_Coverage, 4714,
     /*  545505 */     GIR_EraseRootFromParent_Done,
     /*  545506 */   // Label 8992: @545506
     /*  545506 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(545577), // Rule ID 4715 //
     /*  545511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  545514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  545519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  545522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  545525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  545528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  545539 */     // MIs[0] passthru
     /*  545539 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  545544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  545548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545555 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  545555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_TIED),
     /*  545558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  545572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545575 */     GIR_RootConstrainSelectedInstOperands,
     /*  545576 */     // GIR_Coverage, 4715,
     /*  545576 */     GIR_EraseRootFromParent_Done,
     /*  545577 */   // Label 8993: @545577
     /*  545577 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(545649), // Rule ID 2578 //
     /*  545582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  545590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  545593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  545596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  545599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  545602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545628 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  545628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  545631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545647 */     GIR_RootConstrainSelectedInstOperands,
     /*  545648 */     // GIR_Coverage, 2578,
     /*  545648 */     GIR_EraseRootFromParent_Done,
     /*  545649 */   // Label 8994: @545649
     /*  545649 */   GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(545721), // Rule ID 2579 //
     /*  545654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  545662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  545665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  545668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  545671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  545674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545700 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  545700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF8_E8),
     /*  545703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545719 */     GIR_RootConstrainSelectedInstOperands,
     /*  545720 */     // GIR_Coverage, 2579,
     /*  545720 */     GIR_EraseRootFromParent_Done,
     /*  545721 */   // Label 8995: @545721
     /*  545721 */   GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(545796), // Rule ID 2582 //
     /*  545726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  545729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  545734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  545737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  545740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  545743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  545746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  545753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  545765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545772 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  545772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  545775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  545781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  545783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  545794 */     GIR_RootConstrainSelectedInstOperands,
     /*  545795 */     // GIR_Coverage, 2582,
     /*  545795 */     GIR_EraseRootFromParent_Done,
     /*  545796 */   // Label 8996: @545796
     /*  545796 */   GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(545871), // Rule ID 2583 //
     /*  545801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  545804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  545809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  545812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  545815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  545818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  545821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  545828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  545840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545847 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  545847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B64_MASK),
     /*  545850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  545856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  545858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  545869 */     GIR_RootConstrainSelectedInstOperands,
     /*  545870 */     // GIR_Coverage, 2583,
     /*  545870 */     GIR_EraseRootFromParent_Done,
     /*  545871 */   // Label 8997: @545871
     /*  545871 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(545946), // Rule ID 2610 //
     /*  545876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  545879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  545884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  545887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  545890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  545893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  545899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  545922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  545925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  545927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  545929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  545931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  545933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  545938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  545941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  545944 */     GIR_RootConstrainSelectedInstOperands,
     /*  545945 */     // GIR_Coverage, 2610,
     /*  545945 */     GIR_EraseRootFromParent_Done,
     /*  545946 */   // Label 8998: @545946
     /*  545946 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(546021), // Rule ID 2611 //
     /*  545951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  545954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  545959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  545962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  545965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  545968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  545971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  545974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  545990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  545997 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  545997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8),
     /*  546000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546019 */     GIR_RootConstrainSelectedInstOperands,
     /*  546020 */     // GIR_Coverage, 2611,
     /*  546020 */     GIR_EraseRootFromParent_Done,
     /*  546021 */   // Label 8999: @546021
     /*  546021 */   GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(546093), // Rule ID 2624 //
     /*  546026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546072 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  546072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546091 */     GIR_RootConstrainSelectedInstOperands,
     /*  546092 */     // GIR_Coverage, 2624,
     /*  546092 */     GIR_EraseRootFromParent_Done,
     /*  546093 */   // Label 9000: @546093
     /*  546093 */   GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(546165), // Rule ID 2625 //
     /*  546098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  546106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  546109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  546118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  546137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  546144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF8),
     /*  546147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  546151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  546155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546163 */     GIR_RootConstrainSelectedInstOperands,
     /*  546164 */     // GIR_Coverage, 2625,
     /*  546164 */     GIR_EraseRootFromParent_Done,
     /*  546165 */   // Label 9001: @546165
     /*  546165 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(546240), // Rule ID 2644 //
     /*  546170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546216 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546238 */     GIR_RootConstrainSelectedInstOperands,
     /*  546239 */     // GIR_Coverage, 2644,
     /*  546239 */     GIR_EraseRootFromParent_Done,
     /*  546240 */   // Label 9002: @546240
     /*  546240 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(546315), // Rule ID 2645 //
     /*  546245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  546253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546291 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8),
     /*  546294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546313 */     GIR_RootConstrainSelectedInstOperands,
     /*  546314 */     // GIR_Coverage, 2645,
     /*  546314 */     GIR_EraseRootFromParent_Done,
     /*  546315 */   // Label 9003: @546315
     /*  546315 */   GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(546390), // Rule ID 2670 //
     /*  546320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546388 */     GIR_RootConstrainSelectedInstOperands,
     /*  546389 */     // GIR_Coverage, 2670,
     /*  546389 */     GIR_EraseRootFromParent_Done,
     /*  546390 */   // Label 9004: @546390
     /*  546390 */   GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(546465), // Rule ID 2671 //
     /*  546395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  546403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  546406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  546409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  546415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546441 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8),
     /*  546444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  546448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  546450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  546452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546463 */     GIR_RootConstrainSelectedInstOperands,
     /*  546464 */     // GIR_Coverage, 2671,
     /*  546464 */     GIR_EraseRootFromParent_Done,
     /*  546465 */   // Label 9005: @546465
     /*  546465 */   GIM_Try, /*On fail goto*//*Label 9006*/ GIMT_Encode4(546540), // Rule ID 2682 //
     /*  546470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  546519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546538 */     GIR_RootConstrainSelectedInstOperands,
     /*  546539 */     // GIR_Coverage, 2682,
     /*  546539 */     GIR_EraseRootFromParent_Done,
     /*  546540 */   // Label 9006: @546540
     /*  546540 */   GIM_Try, /*On fail goto*//*Label 9007*/ GIMT_Encode4(546615), // Rule ID 2683 //
     /*  546545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  546556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  546559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  546562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  546565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546591 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  546594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546613 */     GIR_RootConstrainSelectedInstOperands,
     /*  546614 */     // GIR_Coverage, 2683,
     /*  546614 */     GIR_EraseRootFromParent_Done,
     /*  546615 */   // Label 9007: @546615
     /*  546615 */   GIM_Try, /*On fail goto*//*Label 9008*/ GIMT_Encode4(546690), // Rule ID 2690 //
     /*  546620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  546631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  546634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  546637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  546640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546666 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  546669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546688 */     GIR_RootConstrainSelectedInstOperands,
     /*  546689 */     // GIR_Coverage, 2690,
     /*  546689 */     GIR_EraseRootFromParent_Done,
     /*  546690 */   // Label 9008: @546690
     /*  546690 */   GIM_Try, /*On fail goto*//*Label 9009*/ GIMT_Encode4(546765), // Rule ID 2691 //
     /*  546695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  546706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  546709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  546712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  546715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546741 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  546744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546763 */     GIR_RootConstrainSelectedInstOperands,
     /*  546764 */     // GIR_Coverage, 2691,
     /*  546764 */     GIR_EraseRootFromParent_Done,
     /*  546765 */   // Label 9009: @546765
     /*  546765 */   GIM_Try, /*On fail goto*//*Label 9010*/ GIMT_Encode4(546840), // Rule ID 2698 //
     /*  546770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  546781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  546784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  546787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  546790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  546816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  546819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546838 */     GIR_RootConstrainSelectedInstOperands,
     /*  546839 */     // GIR_Coverage, 2698,
     /*  546839 */     GIR_EraseRootFromParent_Done,
     /*  546840 */   // Label 9010: @546840
     /*  546840 */   GIM_Try, /*On fail goto*//*Label 9011*/ GIMT_Encode4(546915), // Rule ID 2699 //
     /*  546845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  546856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  546859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  546862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  546865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  546868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546891 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  546891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  546894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  546910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546913 */     GIR_RootConstrainSelectedInstOperands,
     /*  546914 */     // GIR_Coverage, 2699,
     /*  546914 */     GIR_EraseRootFromParent_Done,
     /*  546915 */   // Label 9011: @546915
     /*  546915 */   GIM_Try, /*On fail goto*//*Label 9012*/ GIMT_Encode4(546990), // Rule ID 2706 //
     /*  546920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  546923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  546928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  546931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  546934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  546937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  546940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  546943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  546959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  546966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  546966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  546969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  546971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  546973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  546975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  546977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  546982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  546985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  546988 */     GIR_RootConstrainSelectedInstOperands,
     /*  546989 */     // GIR_Coverage, 2706,
     /*  546989 */     GIR_EraseRootFromParent_Done,
     /*  546990 */   // Label 9012: @546990
     /*  546990 */   GIM_Try, /*On fail goto*//*Label 9013*/ GIMT_Encode4(547065), // Rule ID 2707 //
     /*  546995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  546998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  547006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  547009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  547012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  547015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547041 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  547044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547063 */     GIR_RootConstrainSelectedInstOperands,
     /*  547064 */     // GIR_Coverage, 2707,
     /*  547064 */     GIR_EraseRootFromParent_Done,
     /*  547065 */   // Label 9013: @547065
     /*  547065 */   GIM_Try, /*On fail goto*//*Label 9014*/ GIMT_Encode4(547140), // Rule ID 2714 //
     /*  547070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547116 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547138 */     GIR_RootConstrainSelectedInstOperands,
     /*  547139 */     // GIR_Coverage, 2714,
     /*  547139 */     GIR_EraseRootFromParent_Done,
     /*  547140 */   // Label 9014: @547140
     /*  547140 */   GIM_Try, /*On fail goto*//*Label 9015*/ GIMT_Encode4(547215), // Rule ID 2715 //
     /*  547145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  547156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  547159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  547162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  547165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547191 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547213 */     GIR_RootConstrainSelectedInstOperands,
     /*  547214 */     // GIR_Coverage, 2715,
     /*  547214 */     GIR_EraseRootFromParent_Done,
     /*  547215 */   // Label 9015: @547215
     /*  547215 */   GIM_Try, /*On fail goto*//*Label 9016*/ GIMT_Encode4(547290), // Rule ID 2722 //
     /*  547220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547266 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547288 */     GIR_RootConstrainSelectedInstOperands,
     /*  547289 */     // GIR_Coverage, 2722,
     /*  547289 */     GIR_EraseRootFromParent_Done,
     /*  547290 */   // Label 9016: @547290
     /*  547290 */   GIM_Try, /*On fail goto*//*Label 9017*/ GIMT_Encode4(547365), // Rule ID 2723 //
     /*  547295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  547306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  547309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  547312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  547315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547341 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  547344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547363 */     GIR_RootConstrainSelectedInstOperands,
     /*  547364 */     // GIR_Coverage, 2723,
     /*  547364 */     GIR_EraseRootFromParent_Done,
     /*  547365 */   // Label 9017: @547365
     /*  547365 */   GIM_Try, /*On fail goto*//*Label 9018*/ GIMT_Encode4(547440), // Rule ID 2730 //
     /*  547370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547416 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  547416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547438 */     GIR_RootConstrainSelectedInstOperands,
     /*  547439 */     // GIR_Coverage, 2730,
     /*  547439 */     GIR_EraseRootFromParent_Done,
     /*  547440 */   // Label 9018: @547440
     /*  547440 */   GIM_Try, /*On fail goto*//*Label 9019*/ GIMT_Encode4(547515), // Rule ID 2731 //
     /*  547445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  547456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  547459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  547462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  547465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547491 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  547491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  547510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547513 */     GIR_RootConstrainSelectedInstOperands,
     /*  547514 */     // GIR_Coverage, 2731,
     /*  547514 */     GIR_EraseRootFromParent_Done,
     /*  547515 */   // Label 9019: @547515
     /*  547515 */   GIM_Try, /*On fail goto*//*Label 9020*/ GIMT_Encode4(547590), // Rule ID 2738 //
     /*  547520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  547531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  547534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  547537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  547540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  547566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547588 */     GIR_RootConstrainSelectedInstOperands,
     /*  547589 */     // GIR_Coverage, 2738,
     /*  547589 */     GIR_EraseRootFromParent_Done,
     /*  547590 */   // Label 9020: @547590
     /*  547590 */   GIM_Try, /*On fail goto*//*Label 9021*/ GIMT_Encode4(547665), // Rule ID 2739 //
     /*  547595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  547606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  547609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  547612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  547615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547641 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  547641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  547660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547663 */     GIR_RootConstrainSelectedInstOperands,
     /*  547664 */     // GIR_Coverage, 2739,
     /*  547664 */     GIR_EraseRootFromParent_Done,
     /*  547665 */   // Label 9021: @547665
     /*  547665 */   GIM_Try, /*On fail goto*//*Label 9022*/ GIMT_Encode4(547740), // Rule ID 2746 //
     /*  547670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  547681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  547684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  547687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  547716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547738 */     GIR_RootConstrainSelectedInstOperands,
     /*  547739 */     // GIR_Coverage, 2746,
     /*  547739 */     GIR_EraseRootFromParent_Done,
     /*  547740 */   // Label 9022: @547740
     /*  547740 */   GIM_Try, /*On fail goto*//*Label 9023*/ GIMT_Encode4(547815), // Rule ID 2747 //
     /*  547745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  547748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  547756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  547759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  547762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  547765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547791 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  547791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  547810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547813 */     GIR_RootConstrainSelectedInstOperands,
     /*  547814 */     // GIR_Coverage, 2747,
     /*  547814 */     GIR_EraseRootFromParent_Done,
     /*  547815 */   // Label 9023: @547815
     /*  547815 */   GIM_Try, /*On fail goto*//*Label 9024*/ GIMT_Encode4(547890), // Rule ID 2754 //
     /*  547820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  547823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  547837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  547840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547866 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  547866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  547885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547888 */     GIR_RootConstrainSelectedInstOperands,
     /*  547889 */     // GIR_Coverage, 2754,
     /*  547889 */     GIR_EraseRootFromParent_Done,
     /*  547890 */   // Label 9024: @547890
     /*  547890 */   GIM_Try, /*On fail goto*//*Label 9025*/ GIMT_Encode4(547965), // Rule ID 2755 //
     /*  547895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  547898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  547906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  547909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  547912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  547915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  547918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  547934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  547941 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  547941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  547944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  547946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  547948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  547950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  547952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  547957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  547960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  547963 */     GIR_RootConstrainSelectedInstOperands,
     /*  547964 */     // GIR_Coverage, 2755,
     /*  547964 */     GIR_EraseRootFromParent_Done,
     /*  547965 */   // Label 9025: @547965
     /*  547965 */   GIM_Try, /*On fail goto*//*Label 9026*/ GIMT_Encode4(548040), // Rule ID 2762 //
     /*  547970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  547973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  547978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  547981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  547984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  547987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  547990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  547993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  547997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548038 */     GIR_RootConstrainSelectedInstOperands,
     /*  548039 */     // GIR_Coverage, 2762,
     /*  548039 */     GIR_EraseRootFromParent_Done,
     /*  548040 */   // Label 9026: @548040
     /*  548040 */   GIM_Try, /*On fail goto*//*Label 9027*/ GIMT_Encode4(548115), // Rule ID 2763 //
     /*  548045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  548056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  548059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  548062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  548065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548091 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548113 */     GIR_RootConstrainSelectedInstOperands,
     /*  548114 */     // GIR_Coverage, 2763,
     /*  548114 */     GIR_EraseRootFromParent_Done,
     /*  548115 */   // Label 9027: @548115
     /*  548115 */   GIM_Try, /*On fail goto*//*Label 9028*/ GIMT_Encode4(548190), // Rule ID 2770 //
     /*  548120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548188 */     GIR_RootConstrainSelectedInstOperands,
     /*  548189 */     // GIR_Coverage, 2770,
     /*  548189 */     GIR_EraseRootFromParent_Done,
     /*  548190 */   // Label 9028: @548190
     /*  548190 */   GIM_Try, /*On fail goto*//*Label 9029*/ GIMT_Encode4(548265), // Rule ID 2771 //
     /*  548195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  548206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  548209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  548212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  548215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548241 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548263 */     GIR_RootConstrainSelectedInstOperands,
     /*  548264 */     // GIR_Coverage, 2771,
     /*  548264 */     GIR_EraseRootFromParent_Done,
     /*  548265 */   // Label 9029: @548265
     /*  548265 */   GIM_Try, /*On fail goto*//*Label 9030*/ GIMT_Encode4(548340), // Rule ID 2778 //
     /*  548270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  548316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548338 */     GIR_RootConstrainSelectedInstOperands,
     /*  548339 */     // GIR_Coverage, 2778,
     /*  548339 */     GIR_EraseRootFromParent_Done,
     /*  548340 */   // Label 9030: @548340
     /*  548340 */   GIM_Try, /*On fail goto*//*Label 9031*/ GIMT_Encode4(548415), // Rule ID 2779 //
     /*  548345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  548356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  548359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  548362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  548365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548391 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  548391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  548410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548413 */     GIR_RootConstrainSelectedInstOperands,
     /*  548414 */     // GIR_Coverage, 2779,
     /*  548414 */     GIR_EraseRootFromParent_Done,
     /*  548415 */   // Label 9031: @548415
     /*  548415 */   GIM_Try, /*On fail goto*//*Label 9032*/ GIMT_Encode4(548490), // Rule ID 2786 //
     /*  548420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  548437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  548440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548488 */     GIR_RootConstrainSelectedInstOperands,
     /*  548489 */     // GIR_Coverage, 2786,
     /*  548489 */     GIR_EraseRootFromParent_Done,
     /*  548490 */   // Label 9032: @548490
     /*  548490 */   GIM_Try, /*On fail goto*//*Label 9033*/ GIMT_Encode4(548565), // Rule ID 2787 //
     /*  548495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  548506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  548509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  548512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  548515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548563 */     GIR_RootConstrainSelectedInstOperands,
     /*  548564 */     // GIR_Coverage, 2787,
     /*  548564 */     GIR_EraseRootFromParent_Done,
     /*  548565 */   // Label 9033: @548565
     /*  548565 */   GIM_Try, /*On fail goto*//*Label 9034*/ GIMT_Encode4(548640), // Rule ID 2794 //
     /*  548570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  548587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  548590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548638 */     GIR_RootConstrainSelectedInstOperands,
     /*  548639 */     // GIR_Coverage, 2794,
     /*  548639 */     GIR_EraseRootFromParent_Done,
     /*  548640 */   // Label 9034: @548640
     /*  548640 */   GIM_Try, /*On fail goto*//*Label 9035*/ GIMT_Encode4(548715), // Rule ID 2795 //
     /*  548645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  548656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  548659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  548662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  548665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  548684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548691 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  548694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548713 */     GIR_RootConstrainSelectedInstOperands,
     /*  548714 */     // GIR_Coverage, 2795,
     /*  548714 */     GIR_EraseRootFromParent_Done,
     /*  548715 */   // Label 9035: @548715
     /*  548715 */   GIM_Try, /*On fail goto*//*Label 9036*/ GIMT_Encode4(548790), // Rule ID 2802 //
     /*  548720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  548737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  548740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  548766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548788 */     GIR_RootConstrainSelectedInstOperands,
     /*  548789 */     // GIR_Coverage, 2802,
     /*  548789 */     GIR_EraseRootFromParent_Done,
     /*  548790 */   // Label 9036: @548790
     /*  548790 */   GIM_Try, /*On fail goto*//*Label 9037*/ GIMT_Encode4(548865), // Rule ID 2803 //
     /*  548795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  548806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  548809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  548812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  548815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  548834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548841 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  548841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  548844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  548860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548863 */     GIR_RootConstrainSelectedInstOperands,
     /*  548864 */     // GIR_Coverage, 2803,
     /*  548864 */     GIR_EraseRootFromParent_Done,
     /*  548865 */   // Label 9037: @548865
     /*  548865 */   GIM_Try, /*On fail goto*//*Label 9038*/ GIMT_Encode4(548940), // Rule ID 2810 //
     /*  548870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  548873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  548881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  548884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  548887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  548890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  548893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  548916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  548925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  548927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  548932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  548935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  548938 */     GIR_RootConstrainSelectedInstOperands,
     /*  548939 */     // GIR_Coverage, 2810,
     /*  548939 */     GIR_EraseRootFromParent_Done,
     /*  548940 */   // Label 9038: @548940
     /*  548940 */   GIM_Try, /*On fail goto*//*Label 9039*/ GIMT_Encode4(549015), // Rule ID 2811 //
     /*  548945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  548948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  548953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  548956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  548959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  548962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  548965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  548968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  548984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  548991 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  548991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  548994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  548996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  548998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549013 */     GIR_RootConstrainSelectedInstOperands,
     /*  549014 */     // GIR_Coverage, 2811,
     /*  549014 */     GIR_EraseRootFromParent_Done,
     /*  549015 */   // Label 9039: @549015
     /*  549015 */   GIM_Try, /*On fail goto*//*Label 9040*/ GIMT_Encode4(549090), // Rule ID 2818 //
     /*  549020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549066 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549088 */     GIR_RootConstrainSelectedInstOperands,
     /*  549089 */     // GIR_Coverage, 2818,
     /*  549089 */     GIR_EraseRootFromParent_Done,
     /*  549090 */   // Label 9040: @549090
     /*  549090 */   GIM_Try, /*On fail goto*//*Label 9041*/ GIMT_Encode4(549165), // Rule ID 2819 //
     /*  549095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  549106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  549109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  549112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  549115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549141 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549163 */     GIR_RootConstrainSelectedInstOperands,
     /*  549164 */     // GIR_Coverage, 2819,
     /*  549164 */     GIR_EraseRootFromParent_Done,
     /*  549165 */   // Label 9041: @549165
     /*  549165 */   GIM_Try, /*On fail goto*//*Label 9042*/ GIMT_Encode4(549240), // Rule ID 2826 //
     /*  549170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549216 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  549216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549238 */     GIR_RootConstrainSelectedInstOperands,
     /*  549239 */     // GIR_Coverage, 2826,
     /*  549239 */     GIR_EraseRootFromParent_Done,
     /*  549240 */   // Label 9042: @549240
     /*  549240 */   GIM_Try, /*On fail goto*//*Label 9043*/ GIMT_Encode4(549315), // Rule ID 2827 //
     /*  549245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  549256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  549259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  549262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  549265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549291 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  549291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  549310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549313 */     GIR_RootConstrainSelectedInstOperands,
     /*  549314 */     // GIR_Coverage, 2827,
     /*  549314 */     GIR_EraseRootFromParent_Done,
     /*  549315 */   // Label 9043: @549315
     /*  549315 */   GIM_Try, /*On fail goto*//*Label 9044*/ GIMT_Encode4(549390), // Rule ID 2834 //
     /*  549320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549366 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549388 */     GIR_RootConstrainSelectedInstOperands,
     /*  549389 */     // GIR_Coverage, 2834,
     /*  549389 */     GIR_EraseRootFromParent_Done,
     /*  549390 */   // Label 9044: @549390
     /*  549390 */   GIM_Try, /*On fail goto*//*Label 9045*/ GIMT_Encode4(549465), // Rule ID 2835 //
     /*  549395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  549406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  549409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  549412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  549415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  549434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  549444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549463 */     GIR_RootConstrainSelectedInstOperands,
     /*  549464 */     // GIR_Coverage, 2835,
     /*  549464 */     GIR_EraseRootFromParent_Done,
     /*  549465 */   // Label 9045: @549465
     /*  549465 */   GIM_Try, /*On fail goto*//*Label 9046*/ GIMT_Encode4(549540), // Rule ID 2842 //
     /*  549470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  549487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  549490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549516 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549538 */     GIR_RootConstrainSelectedInstOperands,
     /*  549539 */     // GIR_Coverage, 2842,
     /*  549539 */     GIR_EraseRootFromParent_Done,
     /*  549540 */   // Label 9046: @549540
     /*  549540 */   GIM_Try, /*On fail goto*//*Label 9047*/ GIMT_Encode4(549615), // Rule ID 2843 //
     /*  549545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  549556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  549559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  549562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  549565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  549584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549591 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  549594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549613 */     GIR_RootConstrainSelectedInstOperands,
     /*  549614 */     // GIR_Coverage, 2843,
     /*  549614 */     GIR_EraseRootFromParent_Done,
     /*  549615 */   // Label 9047: @549615
     /*  549615 */   GIM_Try, /*On fail goto*//*Label 9048*/ GIMT_Encode4(549690), // Rule ID 2850 //
     /*  549620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  549623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  549637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  549640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549666 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  549666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549688 */     GIR_RootConstrainSelectedInstOperands,
     /*  549689 */     // GIR_Coverage, 2850,
     /*  549689 */     GIR_EraseRootFromParent_Done,
     /*  549690 */   // Label 9048: @549690
     /*  549690 */   GIM_Try, /*On fail goto*//*Label 9049*/ GIMT_Encode4(549765), // Rule ID 2851 //
     /*  549695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  549698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  549703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  549706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  549709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  549712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  549715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  549734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549741 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  549741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  549744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /*  549750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  549752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  549760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549763 */     GIR_RootConstrainSelectedInstOperands,
     /*  549764 */     // GIR_Coverage, 2851,
     /*  549764 */     GIR_EraseRootFromParent_Done,
     /*  549765 */   // Label 9049: @549765
     /*  549765 */   GIM_Try, /*On fail goto*//*Label 9050*/ GIMT_Encode4(549840), // Rule ID 2858 //
     /*  549770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  549778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  549781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  549784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  549787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  549790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549816 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  549819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549838 */     GIR_RootConstrainSelectedInstOperands,
     /*  549839 */     // GIR_Coverage, 2858,
     /*  549839 */     GIR_EraseRootFromParent_Done,
     /*  549840 */   // Label 9050: @549840
     /*  549840 */   GIM_Try, /*On fail goto*//*Label 9051*/ GIMT_Encode4(549915), // Rule ID 2859 //
     /*  549845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  549853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  549856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  549859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  549862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  549865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  549868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549891 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  549891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  549894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549913 */     GIR_RootConstrainSelectedInstOperands,
     /*  549914 */     // GIR_Coverage, 2859,
     /*  549914 */     GIR_EraseRootFromParent_Done,
     /*  549915 */   // Label 9051: @549915
     /*  549915 */   GIM_Try, /*On fail goto*//*Label 9052*/ GIMT_Encode4(549990), // Rule ID 2862 //
     /*  549920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  549923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  549928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  549931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  549934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  549937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  549940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  549943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  549959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  549966 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  549966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  549969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  549971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  549973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  549975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  549977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  549982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  549985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  549988 */     GIR_RootConstrainSelectedInstOperands,
     /*  549989 */     // GIR_Coverage, 2862,
     /*  549989 */     GIR_EraseRootFromParent_Done,
     /*  549990 */   // Label 9052: @549990
     /*  549990 */   GIM_Try, /*On fail goto*//*Label 9053*/ GIMT_Encode4(550065), // Rule ID 2863 //
     /*  549995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  549998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  550006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  550009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  550012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  550015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550041 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550063 */     GIR_RootConstrainSelectedInstOperands,
     /*  550064 */     // GIR_Coverage, 2863,
     /*  550064 */     GIR_EraseRootFromParent_Done,
     /*  550065 */   // Label 9053: @550065
     /*  550065 */   GIM_Try, /*On fail goto*//*Label 9054*/ GIMT_Encode4(550140), // Rule ID 2866 //
     /*  550070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550116 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550138 */     GIR_RootConstrainSelectedInstOperands,
     /*  550139 */     // GIR_Coverage, 2866,
     /*  550139 */     GIR_EraseRootFromParent_Done,
     /*  550140 */   // Label 9054: @550140
     /*  550140 */   GIM_Try, /*On fail goto*//*Label 9055*/ GIMT_Encode4(550215), // Rule ID 2867 //
     /*  550145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  550156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  550159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  550162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  550165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550191 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4),
     /*  550194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550213 */     GIR_RootConstrainSelectedInstOperands,
     /*  550214 */     // GIR_Coverage, 2867,
     /*  550214 */     GIR_EraseRootFromParent_Done,
     /*  550215 */   // Label 9055: @550215
     /*  550215 */   GIM_Try, /*On fail goto*//*Label 9056*/ GIMT_Encode4(550290), // Rule ID 2870 //
     /*  550220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550288 */     GIR_RootConstrainSelectedInstOperands,
     /*  550289 */     // GIR_Coverage, 2870,
     /*  550289 */     GIR_EraseRootFromParent_Done,
     /*  550290 */   // Label 9056: @550290
     /*  550290 */   GIM_Try, /*On fail goto*//*Label 9057*/ GIMT_Encode4(550365), // Rule ID 2871 //
     /*  550295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  550306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  550309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  550312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  550315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550341 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550363 */     GIR_RootConstrainSelectedInstOperands,
     /*  550364 */     // GIR_Coverage, 2871,
     /*  550364 */     GIR_EraseRootFromParent_Done,
     /*  550365 */   // Label 9057: @550365
     /*  550365 */   GIM_Try, /*On fail goto*//*Label 9058*/ GIMT_Encode4(550440), // Rule ID 2874 //
     /*  550370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550438 */     GIR_RootConstrainSelectedInstOperands,
     /*  550439 */     // GIR_Coverage, 2874,
     /*  550439 */     GIR_EraseRootFromParent_Done,
     /*  550440 */   // Label 9058: @550440
     /*  550440 */   GIM_Try, /*On fail goto*//*Label 9059*/ GIMT_Encode4(550515), // Rule ID 2875 //
     /*  550445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  550456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  550459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  550462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  550465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2),
     /*  550494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550513 */     GIR_RootConstrainSelectedInstOperands,
     /*  550514 */     // GIR_Coverage, 2875,
     /*  550514 */     GIR_EraseRootFromParent_Done,
     /*  550515 */   // Label 9059: @550515
     /*  550515 */   GIM_Try, /*On fail goto*//*Label 9060*/ GIMT_Encode4(550590), // Rule ID 2878 //
     /*  550520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  550537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550566 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  550566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550588 */     GIR_RootConstrainSelectedInstOperands,
     /*  550589 */     // GIR_Coverage, 2878,
     /*  550589 */     GIR_EraseRootFromParent_Done,
     /*  550590 */   // Label 9060: @550590
     /*  550590 */   GIM_Try, /*On fail goto*//*Label 9061*/ GIMT_Encode4(550665), // Rule ID 2879 //
     /*  550595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  550606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  550609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  550612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  550615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550641 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  550641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  550660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550663 */     GIR_RootConstrainSelectedInstOperands,
     /*  550664 */     // GIR_Coverage, 2879,
     /*  550664 */     GIR_EraseRootFromParent_Done,
     /*  550665 */   // Label 9061: @550665
     /*  550665 */   GIM_Try, /*On fail goto*//*Label 9062*/ GIMT_Encode4(550740), // Rule ID 2882 //
     /*  550670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  550681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  550684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  550687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  550690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  550716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550738 */     GIR_RootConstrainSelectedInstOperands,
     /*  550739 */     // GIR_Coverage, 2882,
     /*  550739 */     GIR_EraseRootFromParent_Done,
     /*  550740 */   // Label 9062: @550740
     /*  550740 */   GIM_Try, /*On fail goto*//*Label 9063*/ GIMT_Encode4(550815), // Rule ID 2883 //
     /*  550745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  550756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  550759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  550762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  550765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  550791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  550810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550813 */     GIR_RootConstrainSelectedInstOperands,
     /*  550814 */     // GIR_Coverage, 2883,
     /*  550814 */     GIR_EraseRootFromParent_Done,
     /*  550815 */   // Label 9063: @550815
     /*  550815 */   GIM_Try, /*On fail goto*//*Label 9064*/ GIMT_Encode4(550890), // Rule ID 2886 //
     /*  550820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  550823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  550831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  550834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  550837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  550840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  550866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550888 */     GIR_RootConstrainSelectedInstOperands,
     /*  550889 */     // GIR_Coverage, 2886,
     /*  550889 */     GIR_EraseRootFromParent_Done,
     /*  550890 */   // Label 9064: @550890
     /*  550890 */   GIM_Try, /*On fail goto*//*Label 9065*/ GIMT_Encode4(550965), // Rule ID 2887 //
     /*  550895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  550898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  550906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  550909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  550912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  550915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  550918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  550941 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  550941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  550944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  550946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  550948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  550950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  550952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  550957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  550960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  550963 */     GIR_RootConstrainSelectedInstOperands,
     /*  550964 */     // GIR_Coverage, 2887,
     /*  550964 */     GIR_EraseRootFromParent_Done,
     /*  550965 */   // Label 9065: @550965
     /*  550965 */   GIM_Try, /*On fail goto*//*Label 9066*/ GIMT_Encode4(551040), // Rule ID 2890 //
     /*  550970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  550973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  550978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  550981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  550984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  550987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  550990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  550993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  550997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551016 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  551016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551038 */     GIR_RootConstrainSelectedInstOperands,
     /*  551039 */     // GIR_Coverage, 2890,
     /*  551039 */     GIR_EraseRootFromParent_Done,
     /*  551040 */   // Label 9066: @551040
     /*  551040 */   GIM_Try, /*On fail goto*//*Label 9067*/ GIMT_Encode4(551115), // Rule ID 2891 //
     /*  551045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  551048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  551056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  551059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  551062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  551065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  551084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551091 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  551091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1),
     /*  551094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  551110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551113 */     GIR_RootConstrainSelectedInstOperands,
     /*  551114 */     // GIR_Coverage, 2891,
     /*  551114 */     GIR_EraseRootFromParent_Done,
     /*  551115 */   // Label 9067: @551115
     /*  551115 */   GIM_Try, /*On fail goto*//*Label 9068*/ GIMT_Encode4(551190), // Rule ID 2894 //
     /*  551120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551166 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551188 */     GIR_RootConstrainSelectedInstOperands,
     /*  551189 */     // GIR_Coverage, 2894,
     /*  551189 */     GIR_EraseRootFromParent_Done,
     /*  551190 */   // Label 9068: @551190
     /*  551190 */   GIM_Try, /*On fail goto*//*Label 9069*/ GIMT_Encode4(551265), // Rule ID 2895 //
     /*  551195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  551206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  551209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  551212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  551215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551263 */     GIR_RootConstrainSelectedInstOperands,
     /*  551264 */     // GIR_Coverage, 2895,
     /*  551264 */     GIR_EraseRootFromParent_Done,
     /*  551265 */   // Label 9069: @551265
     /*  551265 */   GIM_Try, /*On fail goto*//*Label 9070*/ GIMT_Encode4(551340), // Rule ID 2898 //
     /*  551270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551338 */     GIR_RootConstrainSelectedInstOperands,
     /*  551339 */     // GIR_Coverage, 2898,
     /*  551339 */     GIR_EraseRootFromParent_Done,
     /*  551340 */   // Label 9070: @551340
     /*  551340 */   GIM_Try, /*On fail goto*//*Label 9071*/ GIMT_Encode4(551415), // Rule ID 2899 //
     /*  551345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  551356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  551359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  551362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  551365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551391 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551413 */     GIR_RootConstrainSelectedInstOperands,
     /*  551414 */     // GIR_Coverage, 2899,
     /*  551414 */     GIR_EraseRootFromParent_Done,
     /*  551415 */   // Label 9071: @551415
     /*  551415 */   GIM_Try, /*On fail goto*//*Label 9072*/ GIMT_Encode4(551490), // Rule ID 2902 //
     /*  551420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  551431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  551434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  551437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  551440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  551466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551488 */     GIR_RootConstrainSelectedInstOperands,
     /*  551489 */     // GIR_Coverage, 2902,
     /*  551489 */     GIR_EraseRootFromParent_Done,
     /*  551490 */   // Label 9072: @551490
     /*  551490 */   GIM_Try, /*On fail goto*//*Label 9073*/ GIMT_Encode4(551565), // Rule ID 2903 //
     /*  551495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  551506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  551509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  551512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  551515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551541 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  551541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  551560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551563 */     GIR_RootConstrainSelectedInstOperands,
     /*  551564 */     // GIR_Coverage, 2903,
     /*  551564 */     GIR_EraseRootFromParent_Done,
     /*  551565 */   // Label 9073: @551565
     /*  551565 */   GIM_Try, /*On fail goto*//*Label 9074*/ GIMT_Encode4(551640), // Rule ID 2906 //
     /*  551570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  551581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  551584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  551587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  551590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551638 */     GIR_RootConstrainSelectedInstOperands,
     /*  551639 */     // GIR_Coverage, 2906,
     /*  551639 */     GIR_EraseRootFromParent_Done,
     /*  551640 */   // Label 9074: @551640
     /*  551640 */   GIM_Try, /*On fail goto*//*Label 9075*/ GIMT_Encode4(551715), // Rule ID 2907 //
     /*  551645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  551656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  551659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  551662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  551665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  551684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  551694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551713 */     GIR_RootConstrainSelectedInstOperands,
     /*  551714 */     // GIR_Coverage, 2907,
     /*  551714 */     GIR_EraseRootFromParent_Done,
     /*  551715 */   // Label 9075: @551715
     /*  551715 */   GIM_Try, /*On fail goto*//*Label 9076*/ GIMT_Encode4(551790), // Rule ID 2910 //
     /*  551720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  551731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  551734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  551737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  551740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551788 */     GIR_RootConstrainSelectedInstOperands,
     /*  551789 */     // GIR_Coverage, 2910,
     /*  551789 */     GIR_EraseRootFromParent_Done,
     /*  551790 */   // Label 9076: @551790
     /*  551790 */   GIM_Try, /*On fail goto*//*Label 9077*/ GIMT_Encode4(551865), // Rule ID 2911 //
     /*  551795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  551806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  551809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  551812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  551815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  551834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  551844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551863 */     GIR_RootConstrainSelectedInstOperands,
     /*  551864 */     // GIR_Coverage, 2911,
     /*  551864 */     GIR_EraseRootFromParent_Done,
     /*  551865 */   // Label 9077: @551865
     /*  551865 */   GIM_Try, /*On fail goto*//*Label 9078*/ GIMT_Encode4(551940), // Rule ID 2914 //
     /*  551870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  551873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  551881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  551884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  551887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  551890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  551893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  551916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  551925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  551927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  551932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  551935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  551938 */     GIR_RootConstrainSelectedInstOperands,
     /*  551939 */     // GIR_Coverage, 2914,
     /*  551939 */     GIR_EraseRootFromParent_Done,
     /*  551940 */   // Label 9078: @551940
     /*  551940 */   GIM_Try, /*On fail goto*//*Label 9079*/ GIMT_Encode4(552015), // Rule ID 2915 //
     /*  551945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  551948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  551953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  551956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  551959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  551962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  551965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  551968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  551984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  551991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  551991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  551994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  551996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  551998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  552010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552013 */     GIR_RootConstrainSelectedInstOperands,
     /*  552014 */     // GIR_Coverage, 2915,
     /*  552014 */     GIR_EraseRootFromParent_Done,
     /*  552015 */   // Label 9079: @552015
     /*  552015 */   GIM_Try, /*On fail goto*//*Label 9080*/ GIMT_Encode4(552090), // Rule ID 2918 //
     /*  552020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552088 */     GIR_RootConstrainSelectedInstOperands,
     /*  552089 */     // GIR_Coverage, 2918,
     /*  552089 */     GIR_EraseRootFromParent_Done,
     /*  552090 */   // Label 9080: @552090
     /*  552090 */   GIM_Try, /*On fail goto*//*Label 9081*/ GIMT_Encode4(552165), // Rule ID 2919 //
     /*  552095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  552106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  552109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  552112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  552115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552163 */     GIR_RootConstrainSelectedInstOperands,
     /*  552164 */     // GIR_Coverage, 2919,
     /*  552164 */     GIR_EraseRootFromParent_Done,
     /*  552165 */   // Label 9081: @552165
     /*  552165 */   GIM_Try, /*On fail goto*//*Label 9082*/ GIMT_Encode4(552240), // Rule ID 2922 //
     /*  552170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552238 */     GIR_RootConstrainSelectedInstOperands,
     /*  552239 */     // GIR_Coverage, 2922,
     /*  552239 */     GIR_EraseRootFromParent_Done,
     /*  552240 */   // Label 9082: @552240
     /*  552240 */   GIM_Try, /*On fail goto*//*Label 9083*/ GIMT_Encode4(552315), // Rule ID 2923 //
     /*  552245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  552256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  552259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  552262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  552265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552291 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552313 */     GIR_RootConstrainSelectedInstOperands,
     /*  552314 */     // GIR_Coverage, 2923,
     /*  552314 */     GIR_EraseRootFromParent_Done,
     /*  552315 */   // Label 9083: @552315
     /*  552315 */   GIM_Try, /*On fail goto*//*Label 9084*/ GIMT_Encode4(552390), // Rule ID 2926 //
     /*  552320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552366 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  552366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552388 */     GIR_RootConstrainSelectedInstOperands,
     /*  552389 */     // GIR_Coverage, 2926,
     /*  552389 */     GIR_EraseRootFromParent_Done,
     /*  552390 */   // Label 9084: @552390
     /*  552390 */   GIM_Try, /*On fail goto*//*Label 9085*/ GIMT_Encode4(552465), // Rule ID 2927 //
     /*  552395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  552406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  552409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  552412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  552415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552441 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  552441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  552460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552463 */     GIR_RootConstrainSelectedInstOperands,
     /*  552464 */     // GIR_Coverage, 2927,
     /*  552464 */     GIR_EraseRootFromParent_Done,
     /*  552465 */   // Label 9085: @552465
     /*  552465 */   GIM_Try, /*On fail goto*//*Label 9086*/ GIMT_Encode4(552540), // Rule ID 2930 //
     /*  552470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  552481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  552484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  552487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  552490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  552516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552538 */     GIR_RootConstrainSelectedInstOperands,
     /*  552539 */     // GIR_Coverage, 2930,
     /*  552539 */     GIR_EraseRootFromParent_Done,
     /*  552540 */   // Label 9086: @552540
     /*  552540 */   GIM_Try, /*On fail goto*//*Label 9087*/ GIMT_Encode4(552615), // Rule ID 2931 //
     /*  552545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  552556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  552559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  552562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  552565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  552584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2),
     /*  552594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552613 */     GIR_RootConstrainSelectedInstOperands,
     /*  552614 */     // GIR_Coverage, 2931,
     /*  552614 */     GIR_EraseRootFromParent_Done,
     /*  552615 */   // Label 9087: @552615
     /*  552615 */   GIM_Try, /*On fail goto*//*Label 9088*/ GIMT_Encode4(552690), // Rule ID 2934 //
     /*  552620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  552631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  552634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  552637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  552640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  552666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552688 */     GIR_RootConstrainSelectedInstOperands,
     /*  552689 */     // GIR_Coverage, 2934,
     /*  552689 */     GIR_EraseRootFromParent_Done,
     /*  552690 */   // Label 9088: @552690
     /*  552690 */   GIM_Try, /*On fail goto*//*Label 9089*/ GIMT_Encode4(552765), // Rule ID 2935 //
     /*  552695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  552706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  552709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  552712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  552715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  552734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552741 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4),
     /*  552744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552763 */     GIR_RootConstrainSelectedInstOperands,
     /*  552764 */     // GIR_Coverage, 2935,
     /*  552764 */     GIR_EraseRootFromParent_Done,
     /*  552765 */   // Label 9089: @552765
     /*  552765 */   GIM_Try, /*On fail goto*//*Label 9090*/ GIMT_Encode4(552840), // Rule ID 2938 //
     /*  552770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  552773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  552781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  552784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  552787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  552790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552816 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  552816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552838 */     GIR_RootConstrainSelectedInstOperands,
     /*  552839 */     // GIR_Coverage, 2938,
     /*  552839 */     GIR_EraseRootFromParent_Done,
     /*  552840 */   // Label 9090: @552840
     /*  552840 */   GIM_Try, /*On fail goto*//*Label 9091*/ GIMT_Encode4(552915), // Rule ID 2939 //
     /*  552845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  552848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  552856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  552859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  552862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  552865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  552868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  552884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552891 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  552891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8),
     /*  552894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  552910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552913 */     GIR_RootConstrainSelectedInstOperands,
     /*  552914 */     // GIR_Coverage, 2939,
     /*  552914 */     GIR_EraseRootFromParent_Done,
     /*  552915 */   // Label 9091: @552915
     /*  552915 */   GIM_Try, /*On fail goto*//*Label 9092*/ GIMT_Encode4(552990), // Rule ID 2942 //
     /*  552920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  552923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  552928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  552931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  552934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  552937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  552940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  552943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  552955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  552959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  552966 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  552966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  552969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  552971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  552973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  552975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  552977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  552982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  552985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  552988 */     GIR_RootConstrainSelectedInstOperands,
     /*  552989 */     // GIR_Coverage, 2942,
     /*  552989 */     GIR_EraseRootFromParent_Done,
     /*  552990 */   // Label 9092: @552990
     /*  552990 */   GIM_Try, /*On fail goto*//*Label 9093*/ GIMT_Encode4(553065), // Rule ID 2943 //
     /*  552995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  552998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  553006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  553009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  553012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553041 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8),
     /*  553044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553063 */     GIR_RootConstrainSelectedInstOperands,
     /*  553064 */     // GIR_Coverage, 2943,
     /*  553064 */     GIR_EraseRootFromParent_Done,
     /*  553065 */   // Label 9093: @553065
     /*  553065 */   GIM_Try, /*On fail goto*//*Label 9094*/ GIMT_Encode4(553140), // Rule ID 2946 //
     /*  553070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553116 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553138 */     GIR_RootConstrainSelectedInstOperands,
     /*  553139 */     // GIR_Coverage, 2946,
     /*  553139 */     GIR_EraseRootFromParent_Done,
     /*  553140 */   // Label 9094: @553140
     /*  553140 */   GIM_Try, /*On fail goto*//*Label 9095*/ GIMT_Encode4(553215), // Rule ID 2947 //
     /*  553145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  553156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  553159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  553162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553191 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553213 */     GIR_RootConstrainSelectedInstOperands,
     /*  553214 */     // GIR_Coverage, 2947,
     /*  553214 */     GIR_EraseRootFromParent_Done,
     /*  553215 */   // Label 9095: @553215
     /*  553215 */   GIM_Try, /*On fail goto*//*Label 9096*/ GIMT_Encode4(553290), // Rule ID 2950 //
     /*  553220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553288 */     GIR_RootConstrainSelectedInstOperands,
     /*  553289 */     // GIR_Coverage, 2950,
     /*  553289 */     GIR_EraseRootFromParent_Done,
     /*  553290 */   // Label 9096: @553290
     /*  553290 */   GIM_Try, /*On fail goto*//*Label 9097*/ GIMT_Encode4(553365), // Rule ID 2951 //
     /*  553295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  553306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  553309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  553312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553341 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553363 */     GIR_RootConstrainSelectedInstOperands,
     /*  553364 */     // GIR_Coverage, 2951,
     /*  553364 */     GIR_EraseRootFromParent_Done,
     /*  553365 */   // Label 9097: @553365
     /*  553365 */   GIM_Try, /*On fail goto*//*Label 9098*/ GIMT_Encode4(553440), // Rule ID 2954 //
     /*  553370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553438 */     GIR_RootConstrainSelectedInstOperands,
     /*  553439 */     // GIR_Coverage, 2954,
     /*  553439 */     GIR_EraseRootFromParent_Done,
     /*  553440 */   // Label 9098: @553440
     /*  553440 */   GIM_Try, /*On fail goto*//*Label 9099*/ GIMT_Encode4(553515), // Rule ID 2955 //
     /*  553445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  553456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  553459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  553462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4),
     /*  553494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553513 */     GIR_RootConstrainSelectedInstOperands,
     /*  553514 */     // GIR_Coverage, 2955,
     /*  553514 */     GIR_EraseRootFromParent_Done,
     /*  553515 */   // Label 9099: @553515
     /*  553515 */   GIM_Try, /*On fail goto*//*Label 9100*/ GIMT_Encode4(553590), // Rule ID 2958 //
     /*  553520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  553531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  553534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  553537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  553566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553588 */     GIR_RootConstrainSelectedInstOperands,
     /*  553589 */     // GIR_Coverage, 2958,
     /*  553589 */     GIR_EraseRootFromParent_Done,
     /*  553590 */   // Label 9100: @553590
     /*  553590 */   GIM_Try, /*On fail goto*//*Label 9101*/ GIMT_Encode4(553665), // Rule ID 2959 //
     /*  553595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  553606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  553609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  553612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553641 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  553641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  553660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553663 */     GIR_RootConstrainSelectedInstOperands,
     /*  553664 */     // GIR_Coverage, 2959,
     /*  553664 */     GIR_EraseRootFromParent_Done,
     /*  553665 */   // Label 9101: @553665
     /*  553665 */   GIM_Try, /*On fail goto*//*Label 9102*/ GIMT_Encode4(553740), // Rule ID 2962 //
     /*  553670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  553681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  553684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  553687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553716 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  553716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553738 */     GIR_RootConstrainSelectedInstOperands,
     /*  553739 */     // GIR_Coverage, 2962,
     /*  553739 */     GIR_EraseRootFromParent_Done,
     /*  553740 */   // Label 9102: @553740
     /*  553740 */   GIM_Try, /*On fail goto*//*Label 9103*/ GIMT_Encode4(553815), // Rule ID 2963 //
     /*  553745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  553756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  553759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  553762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553791 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  553791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2),
     /*  553794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  553810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553813 */     GIR_RootConstrainSelectedInstOperands,
     /*  553814 */     // GIR_Coverage, 2963,
     /*  553814 */     GIR_EraseRootFromParent_Done,
     /*  553815 */   // Label 9103: @553815
     /*  553815 */   GIM_Try, /*On fail goto*//*Label 9104*/ GIMT_Encode4(553890), // Rule ID 2966 //
     /*  553820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  553831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  553834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  553837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553866 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  553866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  553869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553888 */     GIR_RootConstrainSelectedInstOperands,
     /*  553889 */     // GIR_Coverage, 2966,
     /*  553889 */     GIR_EraseRootFromParent_Done,
     /*  553890 */   // Label 9104: @553890
     /*  553890 */   GIM_Try, /*On fail goto*//*Label 9105*/ GIMT_Encode4(553965), // Rule ID 2967 //
     /*  553895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  553898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  553906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  553909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  553912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  553915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  553918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  553934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  553941 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11074:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  553941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  553944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  553946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  553948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  553950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  553952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  553957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  553960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  553963 */     GIR_RootConstrainSelectedInstOperands,
     /*  553964 */     // GIR_Coverage, 2967,
     /*  553964 */     GIR_EraseRootFromParent_Done,
     /*  553965 */   // Label 9105: @553965
     /*  553965 */   GIM_Try, /*On fail goto*//*Label 9106*/ GIMT_Encode4(554040), // Rule ID 2970 //
     /*  553970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  553973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  553978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  553981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  553984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  553987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  553990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  553993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  553997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554038 */     GIR_RootConstrainSelectedInstOperands,
     /*  554039 */     // GIR_Coverage, 2970,
     /*  554039 */     GIR_EraseRootFromParent_Done,
     /*  554040 */   // Label 9106: @554040
     /*  554040 */   GIM_Try, /*On fail goto*//*Label 9107*/ GIMT_Encode4(554115), // Rule ID 2971 //
     /*  554045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  554056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  554059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  554062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11074:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554113 */     GIR_RootConstrainSelectedInstOperands,
     /*  554114 */     // GIR_Coverage, 2971,
     /*  554114 */     GIR_EraseRootFromParent_Done,
     /*  554115 */   // Label 9107: @554115
     /*  554115 */   GIM_Try, /*On fail goto*//*Label 9108*/ GIMT_Encode4(554190), // Rule ID 2974 //
     /*  554120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554166 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  554166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554188 */     GIR_RootConstrainSelectedInstOperands,
     /*  554189 */     // GIR_Coverage, 2974,
     /*  554189 */     GIR_EraseRootFromParent_Done,
     /*  554190 */   // Label 9108: @554190
     /*  554190 */   GIM_Try, /*On fail goto*//*Label 9109*/ GIMT_Encode4(554265), // Rule ID 2975 //
     /*  554195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  554206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  554209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  554212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554241 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11074:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  554241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  554260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554263 */     GIR_RootConstrainSelectedInstOperands,
     /*  554264 */     // GIR_Coverage, 2975,
     /*  554264 */     GIR_EraseRootFromParent_Done,
     /*  554265 */   // Label 9109: @554265
     /*  554265 */   GIM_Try, /*On fail goto*//*Label 9110*/ GIMT_Encode4(554340), // Rule ID 2978 //
     /*  554270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  554273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  554316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554338 */     GIR_RootConstrainSelectedInstOperands,
     /*  554339 */     // GIR_Coverage, 2978,
     /*  554339 */     GIR_EraseRootFromParent_Done,
     /*  554340 */   // Label 9110: @554340
     /*  554340 */   GIM_Try, /*On fail goto*//*Label 9111*/ GIMT_Encode4(554415), // Rule ID 2979 //
     /*  554345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  554348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  554356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  554359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  554362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  554380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11074:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  554391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1),
     /*  554394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  554410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554413 */     GIR_RootConstrainSelectedInstOperands,
     /*  554414 */     // GIR_Coverage, 2979,
     /*  554414 */     GIR_EraseRootFromParent_Done,
     /*  554415 */   // Label 9111: @554415
     /*  554415 */   GIM_Try, /*On fail goto*//*Label 9112*/ GIMT_Encode4(554490), // Rule ID 2982 //
     /*  554420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  554431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  554434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  554437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554466 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554488 */     GIR_RootConstrainSelectedInstOperands,
     /*  554489 */     // GIR_Coverage, 2982,
     /*  554489 */     GIR_EraseRootFromParent_Done,
     /*  554490 */   // Label 9112: @554490
     /*  554490 */   GIM_Try, /*On fail goto*//*Label 9113*/ GIMT_Encode4(554565), // Rule ID 2983 //
     /*  554495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  554506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  554509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  554512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554541 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554563 */     GIR_RootConstrainSelectedInstOperands,
     /*  554564 */     // GIR_Coverage, 2983,
     /*  554564 */     GIR_EraseRootFromParent_Done,
     /*  554565 */   // Label 9113: @554565
     /*  554565 */   GIM_Try, /*On fail goto*//*Label 9114*/ GIMT_Encode4(554640), // Rule ID 2986 //
     /*  554570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  554581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  554584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  554587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554616 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  554619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554638 */     GIR_RootConstrainSelectedInstOperands,
     /*  554639 */     // GIR_Coverage, 2986,
     /*  554639 */     GIR_EraseRootFromParent_Done,
     /*  554640 */   // Label 9114: @554640
     /*  554640 */   GIM_Try, /*On fail goto*//*Label 9115*/ GIMT_Encode4(554715), // Rule ID 2987 //
     /*  554645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  554656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  554659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  554662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  554680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554691 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  554694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554713 */     GIR_RootConstrainSelectedInstOperands,
     /*  554714 */     // GIR_Coverage, 2987,
     /*  554714 */     GIR_EraseRootFromParent_Done,
     /*  554715 */   // Label 9115: @554715
     /*  554715 */   GIM_Try, /*On fail goto*//*Label 9116*/ GIMT_Encode4(554790), // Rule ID 2990 //
     /*  554720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  554731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  554734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  554737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554766 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  554766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  554769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554788 */     GIR_RootConstrainSelectedInstOperands,
     /*  554789 */     // GIR_Coverage, 2990,
     /*  554789 */     GIR_EraseRootFromParent_Done,
     /*  554790 */   // Label 9116: @554790
     /*  554790 */   GIM_Try, /*On fail goto*//*Label 9117*/ GIMT_Encode4(554865), // Rule ID 2991 //
     /*  554795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  554806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  554809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  554812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  554830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554841 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  554841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  554844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  554860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554863 */     GIR_RootConstrainSelectedInstOperands,
     /*  554864 */     // GIR_Coverage, 2991,
     /*  554864 */     GIR_EraseRootFromParent_Done,
     /*  554865 */   // Label 9117: @554865
     /*  554865 */   GIM_Try, /*On fail goto*//*Label 9118*/ GIMT_Encode4(554940), // Rule ID 2994 //
     /*  554870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  554873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  554881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  554884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  554887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  554890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  554893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  554916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  554925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  554927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  554932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  554935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  554938 */     GIR_RootConstrainSelectedInstOperands,
     /*  554939 */     // GIR_Coverage, 2994,
     /*  554939 */     GIR_EraseRootFromParent_Done,
     /*  554940 */   // Label 9118: @554940
     /*  554940 */   GIM_Try, /*On fail goto*//*Label 9119*/ GIMT_Encode4(555015), // Rule ID 2995 //
     /*  554945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  554948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  554953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  554956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  554959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  554962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  554965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  554968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  554980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  554984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  554991 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  554991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  554994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  554996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  554998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555013 */     GIR_RootConstrainSelectedInstOperands,
     /*  555014 */     // GIR_Coverage, 2995,
     /*  555014 */     GIR_EraseRootFromParent_Done,
     /*  555015 */   // Label 9119: @555015
     /*  555015 */   GIM_Try, /*On fail goto*//*Label 9120*/ GIMT_Encode4(555090), // Rule ID 2998 //
     /*  555020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555066 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555088 */     GIR_RootConstrainSelectedInstOperands,
     /*  555089 */     // GIR_Coverage, 2998,
     /*  555089 */     GIR_EraseRootFromParent_Done,
     /*  555090 */   // Label 9120: @555090
     /*  555090 */   GIM_Try, /*On fail goto*//*Label 9121*/ GIMT_Encode4(555165), // Rule ID 2999 //
     /*  555095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  555106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  555109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  555112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555141 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555163 */     GIR_RootConstrainSelectedInstOperands,
     /*  555164 */     // GIR_Coverage, 2999,
     /*  555164 */     GIR_EraseRootFromParent_Done,
     /*  555165 */   // Label 9121: @555165
     /*  555165 */   GIM_Try, /*On fail goto*//*Label 9122*/ GIMT_Encode4(555240), // Rule ID 3002 //
     /*  555170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555216 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  555216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555238 */     GIR_RootConstrainSelectedInstOperands,
     /*  555239 */     // GIR_Coverage, 3002,
     /*  555239 */     GIR_EraseRootFromParent_Done,
     /*  555240 */   // Label 9122: @555240
     /*  555240 */   GIM_Try, /*On fail goto*//*Label 9123*/ GIMT_Encode4(555315), // Rule ID 3003 //
     /*  555245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  555256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  555259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  555262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555291 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  555291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  555310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555313 */     GIR_RootConstrainSelectedInstOperands,
     /*  555314 */     // GIR_Coverage, 3003,
     /*  555314 */     GIR_EraseRootFromParent_Done,
     /*  555315 */   // Label 9123: @555315
     /*  555315 */   GIM_Try, /*On fail goto*//*Label 9124*/ GIMT_Encode4(555390), // Rule ID 3006 //
     /*  555320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555388 */     GIR_RootConstrainSelectedInstOperands,
     /*  555389 */     // GIR_Coverage, 3006,
     /*  555389 */     GIR_EraseRootFromParent_Done,
     /*  555390 */   // Label 9124: @555390
     /*  555390 */   GIM_Try, /*On fail goto*//*Label 9125*/ GIMT_Encode4(555465), // Rule ID 3007 //
     /*  555395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  555406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  555409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  555412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555463 */     GIR_RootConstrainSelectedInstOperands,
     /*  555464 */     // GIR_Coverage, 3007,
     /*  555464 */     GIR_EraseRootFromParent_Done,
     /*  555465 */   // Label 9125: @555465
     /*  555465 */   GIM_Try, /*On fail goto*//*Label 9126*/ GIMT_Encode4(555540), // Rule ID 3010 //
     /*  555470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  555481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  555484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  555487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555538 */     GIR_RootConstrainSelectedInstOperands,
     /*  555539 */     // GIR_Coverage, 3010,
     /*  555539 */     GIR_EraseRootFromParent_Done,
     /*  555540 */   // Label 9126: @555540
     /*  555540 */   GIM_Try, /*On fail goto*//*Label 9127*/ GIMT_Encode4(555615), // Rule ID 3011 //
     /*  555545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  555556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  555559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  555562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555591 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555613 */     GIR_RootConstrainSelectedInstOperands,
     /*  555614 */     // GIR_Coverage, 3011,
     /*  555614 */     GIR_EraseRootFromParent_Done,
     /*  555615 */   // Label 9127: @555615
     /*  555615 */   GIM_Try, /*On fail goto*//*Label 9128*/ GIMT_Encode4(555690), // Rule ID 3014 //
     /*  555620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  555623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  555631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  555634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  555637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  555666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555688 */     GIR_RootConstrainSelectedInstOperands,
     /*  555689 */     // GIR_Coverage, 3014,
     /*  555689 */     GIR_EraseRootFromParent_Done,
     /*  555690 */   // Label 9128: @555690
     /*  555690 */   GIM_Try, /*On fail goto*//*Label 9129*/ GIMT_Encode4(555765), // Rule ID 3015 //
     /*  555695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  555698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  555706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  555709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  555712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  555730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  555741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  555744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  555760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555763 */     GIR_RootConstrainSelectedInstOperands,
     /*  555764 */     // GIR_Coverage, 3015,
     /*  555764 */     GIR_EraseRootFromParent_Done,
     /*  555765 */   // Label 9129: @555765
     /*  555765 */   GIM_Try, /*On fail goto*//*Label 9130*/ GIMT_Encode4(555840), // Rule ID 3018 //
     /*  555770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  555781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  555784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  555787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555838 */     GIR_RootConstrainSelectedInstOperands,
     /*  555839 */     // GIR_Coverage, 3018,
     /*  555839 */     GIR_EraseRootFromParent_Done,
     /*  555840 */   // Label 9130: @555840
     /*  555840 */   GIM_Try, /*On fail goto*//*Label 9131*/ GIMT_Encode4(555915), // Rule ID 3019 //
     /*  555845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  555856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  555859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  555862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  555865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  555868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  555880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11074:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  555891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2),
     /*  555894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555913 */     GIR_RootConstrainSelectedInstOperands,
     /*  555914 */     // GIR_Coverage, 3019,
     /*  555914 */     GIR_EraseRootFromParent_Done,
     /*  555915 */   // Label 9131: @555915
     /*  555915 */   GIM_Try, /*On fail goto*//*Label 9132*/ GIMT_Encode4(555990), // Rule ID 3022 //
     /*  555920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  555923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  555928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  555931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  555934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  555937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  555940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  555943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  555955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  555959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  555966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  555966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  555969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  555971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  555973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  555975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  555977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  555982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  555985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  555988 */     GIR_RootConstrainSelectedInstOperands,
     /*  555989 */     // GIR_Coverage, 3022,
     /*  555989 */     GIR_EraseRootFromParent_Done,
     /*  555990 */   // Label 9132: @555990
     /*  555990 */   GIM_Try, /*On fail goto*//*Label 9133*/ GIMT_Encode4(556065), // Rule ID 3023 //
     /*  555995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  555998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  556006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  556009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  556012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  556030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556041 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11074:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4),
     /*  556044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556063 */     GIR_RootConstrainSelectedInstOperands,
     /*  556064 */     // GIR_Coverage, 3023,
     /*  556064 */     GIR_EraseRootFromParent_Done,
     /*  556065 */   // Label 9133: @556065
     /*  556065 */   GIM_Try, /*On fail goto*//*Label 9134*/ GIMT_Encode4(556140), // Rule ID 3026 //
     /*  556070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  556073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  556090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  556116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556138 */     GIR_RootConstrainSelectedInstOperands,
     /*  556139 */     // GIR_Coverage, 3026,
     /*  556139 */     GIR_EraseRootFromParent_Done,
     /*  556140 */   // Label 9134: @556140
     /*  556140 */   GIM_Try, /*On fail goto*//*Label 9135*/ GIMT_Encode4(556215), // Rule ID 3027 //
     /*  556145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  556148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd),
     /*  556153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  556156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  556159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  556162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  556165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  556180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  556184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556191 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11074:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  556191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8),
     /*  556194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  556210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556213 */     GIR_RootConstrainSelectedInstOperands,
     /*  556214 */     // GIR_Coverage, 3027,
     /*  556214 */     GIR_EraseRootFromParent_Done,
     /*  556215 */   // Label 9135: @556215
     /*  556215 */   GIM_Try, /*On fail goto*//*Label 9136*/ GIMT_Encode4(556290), // Rule ID 3118 //
     /*  556220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556266 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556288 */     GIR_RootConstrainSelectedInstOperands,
     /*  556289 */     // GIR_Coverage, 3118,
     /*  556289 */     GIR_EraseRootFromParent_Done,
     /*  556290 */   // Label 9136: @556290
     /*  556290 */   GIM_Try, /*On fail goto*//*Label 9137*/ GIMT_Encode4(556365), // Rule ID 3119 //
     /*  556295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  556306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  556309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  556312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  556315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556341 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8),
     /*  556344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556363 */     GIR_RootConstrainSelectedInstOperands,
     /*  556364 */     // GIR_Coverage, 3119,
     /*  556364 */     GIR_EraseRootFromParent_Done,
     /*  556365 */   // Label 9137: @556365
     /*  556365 */   GIM_Try, /*On fail goto*//*Label 9138*/ GIMT_Encode4(556440), // Rule ID 3122 //
     /*  556370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556438 */     GIR_RootConstrainSelectedInstOperands,
     /*  556439 */     // GIR_Coverage, 3122,
     /*  556439 */     GIR_EraseRootFromParent_Done,
     /*  556440 */   // Label 9138: @556440
     /*  556440 */   GIM_Try, /*On fail goto*//*Label 9139*/ GIMT_Encode4(556515), // Rule ID 3123 //
     /*  556445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  556456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  556459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  556462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  556465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556491 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556513 */     GIR_RootConstrainSelectedInstOperands,
     /*  556514 */     // GIR_Coverage, 3123,
     /*  556514 */     GIR_EraseRootFromParent_Done,
     /*  556515 */   // Label 9139: @556515
     /*  556515 */   GIM_Try, /*On fail goto*//*Label 9140*/ GIMT_Encode4(556590), // Rule ID 3126 //
     /*  556520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  556531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  556534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  556537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  556540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556566 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  556566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  556569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556588 */     GIR_RootConstrainSelectedInstOperands,
     /*  556589 */     // GIR_Coverage, 3126,
     /*  556589 */     GIR_EraseRootFromParent_Done,
     /*  556590 */   // Label 9140: @556590
     /*  556590 */   GIM_Try, /*On fail goto*//*Label 9141*/ GIMT_Encode4(556665), // Rule ID 3127 //
     /*  556595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  556606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  556609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  556612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  556615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556641 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  556641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  556644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  556660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556663 */     GIR_RootConstrainSelectedInstOperands,
     /*  556664 */     // GIR_Coverage, 3127,
     /*  556664 */     GIR_EraseRootFromParent_Done,
     /*  556665 */   // Label 9141: @556665
     /*  556665 */   GIM_Try, /*On fail goto*//*Label 9142*/ GIMT_Encode4(556740), // Rule ID 3130 //
     /*  556670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  556681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  556684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  556687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  556690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556738 */     GIR_RootConstrainSelectedInstOperands,
     /*  556739 */     // GIR_Coverage, 3130,
     /*  556739 */     GIR_EraseRootFromParent_Done,
     /*  556740 */   // Label 9142: @556740
     /*  556740 */   GIM_Try, /*On fail goto*//*Label 9143*/ GIMT_Encode4(556815), // Rule ID 3131 //
     /*  556745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  556756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  556759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  556762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  556765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556791 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4),
     /*  556794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556813 */     GIR_RootConstrainSelectedInstOperands,
     /*  556814 */     // GIR_Coverage, 3131,
     /*  556814 */     GIR_EraseRootFromParent_Done,
     /*  556815 */   // Label 9143: @556815
     /*  556815 */   GIM_Try, /*On fail goto*//*Label 9144*/ GIMT_Encode4(556890), // Rule ID 3134 //
     /*  556820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  556831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  556834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  556837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  556840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  556866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  556869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556888 */     GIR_RootConstrainSelectedInstOperands,
     /*  556889 */     // GIR_Coverage, 3134,
     /*  556889 */     GIR_EraseRootFromParent_Done,
     /*  556890 */   // Label 9144: @556890
     /*  556890 */   GIM_Try, /*On fail goto*//*Label 9145*/ GIMT_Encode4(556965), // Rule ID 3135 //
     /*  556895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  556898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  556906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  556909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  556912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  556915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  556918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  556941 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  556941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  556944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  556946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  556948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  556950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  556952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  556957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  556960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  556963 */     GIR_RootConstrainSelectedInstOperands,
     /*  556964 */     // GIR_Coverage, 3135,
     /*  556964 */     GIR_EraseRootFromParent_Done,
     /*  556965 */   // Label 9145: @556965
     /*  556965 */   GIM_Try, /*On fail goto*//*Label 9146*/ GIMT_Encode4(557040), // Rule ID 3138 //
     /*  556970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  556973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  556978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  556981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  556984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  556987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  556990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  556993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  556997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557038 */     GIR_RootConstrainSelectedInstOperands,
     /*  557039 */     // GIR_Coverage, 3138,
     /*  557039 */     GIR_EraseRootFromParent_Done,
     /*  557040 */   // Label 9146: @557040
     /*  557040 */   GIM_Try, /*On fail goto*//*Label 9147*/ GIMT_Encode4(557115), // Rule ID 3139 //
     /*  557045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  557056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  557059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  557062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  557065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557091 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  557091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2),
     /*  557094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557113 */     GIR_RootConstrainSelectedInstOperands,
     /*  557114 */     // GIR_Coverage, 3139,
     /*  557114 */     GIR_EraseRootFromParent_Done,
     /*  557115 */   // Label 9147: @557115
     /*  557115 */   GIM_Try, /*On fail goto*//*Label 9148*/ GIMT_Encode4(557190), // Rule ID 3142 //
     /*  557120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557166 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557188 */     GIR_RootConstrainSelectedInstOperands,
     /*  557189 */     // GIR_Coverage, 3142,
     /*  557189 */     GIR_EraseRootFromParent_Done,
     /*  557190 */   // Label 9148: @557190
     /*  557190 */   GIM_Try, /*On fail goto*//*Label 9149*/ GIMT_Encode4(557265), // Rule ID 3143 //
     /*  557195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  557206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  557209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  557212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  557215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557241 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557263 */     GIR_RootConstrainSelectedInstOperands,
     /*  557264 */     // GIR_Coverage, 3143,
     /*  557264 */     GIR_EraseRootFromParent_Done,
     /*  557265 */   // Label 9149: @557265
     /*  557265 */   GIM_Try, /*On fail goto*//*Label 9150*/ GIMT_Encode4(557340), // Rule ID 3146 //
     /*  557270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  557316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557338 */     GIR_RootConstrainSelectedInstOperands,
     /*  557339 */     // GIR_Coverage, 3146,
     /*  557339 */     GIR_EraseRootFromParent_Done,
     /*  557340 */   // Label 9150: @557340
     /*  557340 */   GIM_Try, /*On fail goto*//*Label 9151*/ GIMT_Encode4(557415), // Rule ID 3147 //
     /*  557345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  557356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  557359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  557362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  557365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  557391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  557410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557413 */     GIR_RootConstrainSelectedInstOperands,
     /*  557414 */     // GIR_Coverage, 3147,
     /*  557414 */     GIR_EraseRootFromParent_Done,
     /*  557415 */   // Label 9151: @557415
     /*  557415 */   GIM_Try, /*On fail goto*//*Label 9152*/ GIMT_Encode4(557490), // Rule ID 3150 //
     /*  557420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  557431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  557434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  557437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  557440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  557466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557488 */     GIR_RootConstrainSelectedInstOperands,
     /*  557489 */     // GIR_Coverage, 3150,
     /*  557489 */     GIR_EraseRootFromParent_Done,
     /*  557490 */   // Label 9152: @557490
     /*  557490 */   GIM_Try, /*On fail goto*//*Label 9153*/ GIMT_Encode4(557565), // Rule ID 3151 //
     /*  557495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  557506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  557509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  557512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  557515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557541 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  557541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  557560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557563 */     GIR_RootConstrainSelectedInstOperands,
     /*  557564 */     // GIR_Coverage, 3151,
     /*  557564 */     GIR_EraseRootFromParent_Done,
     /*  557565 */   // Label 9153: @557565
     /*  557565 */   GIM_Try, /*On fail goto*//*Label 9154*/ GIMT_Encode4(557640), // Rule ID 3154 //
     /*  557570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  557573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  557581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  557584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  557587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  557590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  557616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557638 */     GIR_RootConstrainSelectedInstOperands,
     /*  557639 */     // GIR_Coverage, 3154,
     /*  557639 */     GIR_EraseRootFromParent_Done,
     /*  557640 */   // Label 9154: @557640
     /*  557640 */   GIM_Try, /*On fail goto*//*Label 9155*/ GIMT_Encode4(557715), // Rule ID 3155 //
     /*  557645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  557648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  557656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  557659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  557662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  557665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  557684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557691 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  557691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1),
     /*  557694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  557710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557713 */     GIR_RootConstrainSelectedInstOperands,
     /*  557714 */     // GIR_Coverage, 3155,
     /*  557714 */     GIR_EraseRootFromParent_Done,
     /*  557715 */   // Label 9155: @557715
     /*  557715 */   GIM_Try, /*On fail goto*//*Label 9156*/ GIMT_Encode4(557790), // Rule ID 3158 //
     /*  557720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  557731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  557734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  557737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  557740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  557769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557788 */     GIR_RootConstrainSelectedInstOperands,
     /*  557789 */     // GIR_Coverage, 3158,
     /*  557789 */     GIR_EraseRootFromParent_Done,
     /*  557790 */   // Label 9156: @557790
     /*  557790 */   GIM_Try, /*On fail goto*//*Label 9157*/ GIMT_Encode4(557865), // Rule ID 3159 //
     /*  557795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  557806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  557809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  557812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  557815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  557834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  557844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557863 */     GIR_RootConstrainSelectedInstOperands,
     /*  557864 */     // GIR_Coverage, 3159,
     /*  557864 */     GIR_EraseRootFromParent_Done,
     /*  557865 */   // Label 9157: @557865
     /*  557865 */   GIM_Try, /*On fail goto*//*Label 9158*/ GIMT_Encode4(557940), // Rule ID 3162 //
     /*  557870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  557873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  557881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  557884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  557887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  557890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  557893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557916 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  557916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  557919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  557925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  557927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  557932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  557935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  557938 */     GIR_RootConstrainSelectedInstOperands,
     /*  557939 */     // GIR_Coverage, 3162,
     /*  557939 */     GIR_EraseRootFromParent_Done,
     /*  557940 */   // Label 9158: @557940
     /*  557940 */   GIM_Try, /*On fail goto*//*Label 9159*/ GIMT_Encode4(558015), // Rule ID 3163 //
     /*  557945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  557948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  557953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  557956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  557959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  557962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  557965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  557968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  557984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  557991 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  557991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  557994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  557996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  557998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558013 */     GIR_RootConstrainSelectedInstOperands,
     /*  558014 */     // GIR_Coverage, 3163,
     /*  558014 */     GIR_EraseRootFromParent_Done,
     /*  558015 */   // Label 9159: @558015
     /*  558015 */   GIM_Try, /*On fail goto*//*Label 9160*/ GIMT_Encode4(558090), // Rule ID 3166 //
     /*  558020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558066 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  558066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558088 */     GIR_RootConstrainSelectedInstOperands,
     /*  558089 */     // GIR_Coverage, 3166,
     /*  558089 */     GIR_EraseRootFromParent_Done,
     /*  558090 */   // Label 9160: @558090
     /*  558090 */   GIM_Try, /*On fail goto*//*Label 9161*/ GIMT_Encode4(558165), // Rule ID 3167 //
     /*  558095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  558106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  558109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  558112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  558115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558141 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  558141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  558160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558163 */     GIR_RootConstrainSelectedInstOperands,
     /*  558164 */     // GIR_Coverage, 3167,
     /*  558164 */     GIR_EraseRootFromParent_Done,
     /*  558165 */   // Label 9161: @558165
     /*  558165 */   GIM_Try, /*On fail goto*//*Label 9162*/ GIMT_Encode4(558240), // Rule ID 3170 //
     /*  558170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558238 */     GIR_RootConstrainSelectedInstOperands,
     /*  558239 */     // GIR_Coverage, 3170,
     /*  558239 */     GIR_EraseRootFromParent_Done,
     /*  558240 */   // Label 9162: @558240
     /*  558240 */   GIM_Try, /*On fail goto*//*Label 9163*/ GIMT_Encode4(558315), // Rule ID 3171 //
     /*  558245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  558256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  558259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  558262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  558265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558313 */     GIR_RootConstrainSelectedInstOperands,
     /*  558314 */     // GIR_Coverage, 3171,
     /*  558314 */     GIR_EraseRootFromParent_Done,
     /*  558315 */   // Label 9163: @558315
     /*  558315 */   GIM_Try, /*On fail goto*//*Label 9164*/ GIMT_Encode4(558390), // Rule ID 3174 //
     /*  558320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558388 */     GIR_RootConstrainSelectedInstOperands,
     /*  558389 */     // GIR_Coverage, 3174,
     /*  558389 */     GIR_EraseRootFromParent_Done,
     /*  558390 */   // Label 9164: @558390
     /*  558390 */   GIM_Try, /*On fail goto*//*Label 9165*/ GIMT_Encode4(558465), // Rule ID 3175 //
     /*  558395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  558406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  558409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  558412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  558415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558441 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558463 */     GIR_RootConstrainSelectedInstOperands,
     /*  558464 */     // GIR_Coverage, 3175,
     /*  558464 */     GIR_EraseRootFromParent_Done,
     /*  558465 */   // Label 9165: @558465
     /*  558465 */   GIM_Try, /*On fail goto*//*Label 9166*/ GIMT_Encode4(558540), // Rule ID 3178 //
     /*  558470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  558481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  558484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  558487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  558490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  558516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558538 */     GIR_RootConstrainSelectedInstOperands,
     /*  558539 */     // GIR_Coverage, 3178,
     /*  558539 */     GIR_EraseRootFromParent_Done,
     /*  558540 */   // Label 9166: @558540
     /*  558540 */   GIM_Try, /*On fail goto*//*Label 9167*/ GIMT_Encode4(558615), // Rule ID 3179 //
     /*  558545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  558556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  558559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  558562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  558565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  558591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  558610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558613 */     GIR_RootConstrainSelectedInstOperands,
     /*  558614 */     // GIR_Coverage, 3179,
     /*  558614 */     GIR_EraseRootFromParent_Done,
     /*  558615 */   // Label 9167: @558615
     /*  558615 */   GIM_Try, /*On fail goto*//*Label 9168*/ GIMT_Encode4(558690), // Rule ID 3182 //
     /*  558620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  558631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  558634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  558637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  558640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558688 */     GIR_RootConstrainSelectedInstOperands,
     /*  558689 */     // GIR_Coverage, 3182,
     /*  558689 */     GIR_EraseRootFromParent_Done,
     /*  558690 */   // Label 9168: @558690
     /*  558690 */   GIM_Try, /*On fail goto*//*Label 9169*/ GIMT_Encode4(558765), // Rule ID 3183 //
     /*  558695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  558706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  558709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  558712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  558715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  558734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  558744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558763 */     GIR_RootConstrainSelectedInstOperands,
     /*  558764 */     // GIR_Coverage, 3183,
     /*  558764 */     GIR_EraseRootFromParent_Done,
     /*  558765 */   // Label 9169: @558765
     /*  558765 */   GIM_Try, /*On fail goto*//*Label 9170*/ GIMT_Encode4(558840), // Rule ID 3186 //
     /*  558770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  558781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  558784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  558787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  558790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558838 */     GIR_RootConstrainSelectedInstOperands,
     /*  558839 */     // GIR_Coverage, 3186,
     /*  558839 */     GIR_EraseRootFromParent_Done,
     /*  558840 */   // Label 9170: @558840
     /*  558840 */   GIM_Try, /*On fail goto*//*Label 9171*/ GIMT_Encode4(558915), // Rule ID 3187 //
     /*  558845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  558856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  558859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  558862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  558865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  558868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  558884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558891 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  558891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  558894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558913 */     GIR_RootConstrainSelectedInstOperands,
     /*  558914 */     // GIR_Coverage, 3187,
     /*  558914 */     GIR_EraseRootFromParent_Done,
     /*  558915 */   // Label 9171: @558915
     /*  558915 */   GIM_Try, /*On fail goto*//*Label 9172*/ GIMT_Encode4(558990), // Rule ID 3190 //
     /*  558920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  558923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  558928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  558931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  558934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  558937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  558940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  558943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  558959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  558966 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  558966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  558969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  558971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  558973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  558975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  558977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  558982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  558985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  558988 */     GIR_RootConstrainSelectedInstOperands,
     /*  558989 */     // GIR_Coverage, 3190,
     /*  558989 */     GIR_EraseRootFromParent_Done,
     /*  558990 */   // Label 9172: @558990
     /*  558990 */   GIM_Try, /*On fail goto*//*Label 9173*/ GIMT_Encode4(559065), // Rule ID 3191 //
     /*  558995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  558998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  559006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  559009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  559012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  559015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559041 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  559041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  559060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559063 */     GIR_RootConstrainSelectedInstOperands,
     /*  559064 */     // GIR_Coverage, 3191,
     /*  559064 */     GIR_EraseRootFromParent_Done,
     /*  559065 */   // Label 9173: @559065
     /*  559065 */   GIM_Try, /*On fail goto*//*Label 9174*/ GIMT_Encode4(559140), // Rule ID 3194 //
     /*  559070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559116 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559138 */     GIR_RootConstrainSelectedInstOperands,
     /*  559139 */     // GIR_Coverage, 3194,
     /*  559139 */     GIR_EraseRootFromParent_Done,
     /*  559140 */   // Label 9174: @559140
     /*  559140 */   GIM_Try, /*On fail goto*//*Label 9175*/ GIMT_Encode4(559215), // Rule ID 3195 //
     /*  559145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  559156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  559159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  559162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  559165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  559184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2),
     /*  559194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559213 */     GIR_RootConstrainSelectedInstOperands,
     /*  559214 */     // GIR_Coverage, 3195,
     /*  559214 */     GIR_EraseRootFromParent_Done,
     /*  559215 */   // Label 9175: @559215
     /*  559215 */   GIM_Try, /*On fail goto*//*Label 9176*/ GIMT_Encode4(559290), // Rule ID 3198 //
     /*  559220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559266 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559288 */     GIR_RootConstrainSelectedInstOperands,
     /*  559289 */     // GIR_Coverage, 3198,
     /*  559289 */     GIR_EraseRootFromParent_Done,
     /*  559290 */   // Label 9176: @559290
     /*  559290 */   GIM_Try, /*On fail goto*//*Label 9177*/ GIMT_Encode4(559365), // Rule ID 3199 //
     /*  559295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  559306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  559309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  559312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  559315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  559334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559341 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4),
     /*  559344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559363 */     GIR_RootConstrainSelectedInstOperands,
     /*  559364 */     // GIR_Coverage, 3199,
     /*  559364 */     GIR_EraseRootFromParent_Done,
     /*  559365 */   // Label 9177: @559365
     /*  559365 */   GIM_Try, /*On fail goto*//*Label 9178*/ GIMT_Encode4(559440), // Rule ID 3202 //
     /*  559370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  559373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  559416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559438 */     GIR_RootConstrainSelectedInstOperands,
     /*  559439 */     // GIR_Coverage, 3202,
     /*  559439 */     GIR_EraseRootFromParent_Done,
     /*  559440 */   // Label 9178: @559440
     /*  559440 */   GIM_Try, /*On fail goto*//*Label 9179*/ GIMT_Encode4(559515), // Rule ID 3203 //
     /*  559445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  559448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  559456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  559459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  559462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  559465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  559484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559491 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  559491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8),
     /*  559494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  559510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559513 */     GIR_RootConstrainSelectedInstOperands,
     /*  559514 */     // GIR_Coverage, 3203,
     /*  559514 */     GIR_EraseRootFromParent_Done,
     /*  559515 */   // Label 9179: @559515
     /*  559515 */   GIM_Try, /*On fail goto*//*Label 9180*/ GIMT_Encode4(559590), // Rule ID 3206 //
     /*  559520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  559531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  559534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  559537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559566 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  559569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559588 */     GIR_RootConstrainSelectedInstOperands,
     /*  559589 */     // GIR_Coverage, 3206,
     /*  559589 */     GIR_EraseRootFromParent_Done,
     /*  559590 */   // Label 9180: @559590
     /*  559590 */   GIM_Try, /*On fail goto*//*Label 9181*/ GIMT_Encode4(559665), // Rule ID 3207 //
     /*  559595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  559606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  559609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  559612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559641 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8),
     /*  559644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559663 */     GIR_RootConstrainSelectedInstOperands,
     /*  559664 */     // GIR_Coverage, 3207,
     /*  559664 */     GIR_EraseRootFromParent_Done,
     /*  559665 */   // Label 9181: @559665
     /*  559665 */   GIM_Try, /*On fail goto*//*Label 9182*/ GIMT_Encode4(559740), // Rule ID 3210 //
     /*  559670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  559681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  559684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  559687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559716 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  559719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559738 */     GIR_RootConstrainSelectedInstOperands,
     /*  559739 */     // GIR_Coverage, 3210,
     /*  559739 */     GIR_EraseRootFromParent_Done,
     /*  559740 */   // Label 9182: @559740
     /*  559740 */   GIM_Try, /*On fail goto*//*Label 9183*/ GIMT_Encode4(559815), // Rule ID 3211 //
     /*  559745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  559756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  559759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  559762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559791 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  559794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559813 */     GIR_RootConstrainSelectedInstOperands,
     /*  559814 */     // GIR_Coverage, 3211,
     /*  559814 */     GIR_EraseRootFromParent_Done,
     /*  559815 */   // Label 9183: @559815
     /*  559815 */   GIM_Try, /*On fail goto*//*Label 9184*/ GIMT_Encode4(559890), // Rule ID 3214 //
     /*  559820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  559831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  559834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  559837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559866 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  559866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  559869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559888 */     GIR_RootConstrainSelectedInstOperands,
     /*  559889 */     // GIR_Coverage, 3214,
     /*  559889 */     GIR_EraseRootFromParent_Done,
     /*  559890 */   // Label 9184: @559890
     /*  559890 */   GIM_Try, /*On fail goto*//*Label 9185*/ GIMT_Encode4(559965), // Rule ID 3215 //
     /*  559895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  559898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  559906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  559909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  559912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  559915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  559918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  559934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  559941 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  559941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  559944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  559946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  559948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  559950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  559952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  559957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  559960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  559963 */     GIR_RootConstrainSelectedInstOperands,
     /*  559964 */     // GIR_Coverage, 3215,
     /*  559964 */     GIR_EraseRootFromParent_Done,
     /*  559965 */   // Label 9185: @559965
     /*  559965 */   GIM_Try, /*On fail goto*//*Label 9186*/ GIMT_Encode4(560040), // Rule ID 3218 //
     /*  559970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  559973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  559978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  559981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  559984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  559987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  559990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  559993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  559997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560016 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560038 */     GIR_RootConstrainSelectedInstOperands,
     /*  560039 */     // GIR_Coverage, 3218,
     /*  560039 */     GIR_EraseRootFromParent_Done,
     /*  560040 */   // Label 9186: @560040
     /*  560040 */   GIM_Try, /*On fail goto*//*Label 9187*/ GIMT_Encode4(560115), // Rule ID 3219 //
     /*  560045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  560056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  560059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  560062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560091 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4),
     /*  560094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560113 */     GIR_RootConstrainSelectedInstOperands,
     /*  560114 */     // GIR_Coverage, 3219,
     /*  560114 */     GIR_EraseRootFromParent_Done,
     /*  560115 */   // Label 9187: @560115
     /*  560115 */   GIM_Try, /*On fail goto*//*Label 9188*/ GIMT_Encode4(560190), // Rule ID 3222 //
     /*  560120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560188 */     GIR_RootConstrainSelectedInstOperands,
     /*  560189 */     // GIR_Coverage, 3222,
     /*  560189 */     GIR_EraseRootFromParent_Done,
     /*  560190 */   // Label 9188: @560190
     /*  560190 */   GIM_Try, /*On fail goto*//*Label 9189*/ GIMT_Encode4(560265), // Rule ID 3223 //
     /*  560195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  560206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  560209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  560212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560263 */     GIR_RootConstrainSelectedInstOperands,
     /*  560264 */     // GIR_Coverage, 3223,
     /*  560264 */     GIR_EraseRootFromParent_Done,
     /*  560265 */   // Label 9189: @560265
     /*  560265 */   GIM_Try, /*On fail goto*//*Label 9190*/ GIMT_Encode4(560340), // Rule ID 3226 //
     /*  560270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560338 */     GIR_RootConstrainSelectedInstOperands,
     /*  560339 */     // GIR_Coverage, 3226,
     /*  560339 */     GIR_EraseRootFromParent_Done,
     /*  560340 */   // Label 9190: @560340
     /*  560340 */   GIM_Try, /*On fail goto*//*Label 9191*/ GIMT_Encode4(560415), // Rule ID 3227 //
     /*  560345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  560356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  560359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  560362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560391 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2),
     /*  560394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560413 */     GIR_RootConstrainSelectedInstOperands,
     /*  560414 */     // GIR_Coverage, 3227,
     /*  560414 */     GIR_EraseRootFromParent_Done,
     /*  560415 */   // Label 9191: @560415
     /*  560415 */   GIM_Try, /*On fail goto*//*Label 9192*/ GIMT_Encode4(560490), // Rule ID 3230 //
     /*  560420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  560437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560466 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  560466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560488 */     GIR_RootConstrainSelectedInstOperands,
     /*  560489 */     // GIR_Coverage, 3230,
     /*  560489 */     GIR_EraseRootFromParent_Done,
     /*  560490 */   // Label 9192: @560490
     /*  560490 */   GIM_Try, /*On fail goto*//*Label 9193*/ GIMT_Encode4(560565), // Rule ID 3231 //
     /*  560495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  560506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  560509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  560512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560541 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11552:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  560541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  560560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560563 */     GIR_RootConstrainSelectedInstOperands,
     /*  560564 */     // GIR_Coverage, 3231,
     /*  560564 */     GIR_EraseRootFromParent_Done,
     /*  560565 */   // Label 9193: @560565
     /*  560565 */   GIM_Try, /*On fail goto*//*Label 9194*/ GIMT_Encode4(560640), // Rule ID 3234 //
     /*  560570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  560581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  560584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  560587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560616 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  560616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560638 */     GIR_RootConstrainSelectedInstOperands,
     /*  560639 */     // GIR_Coverage, 3234,
     /*  560639 */     GIR_EraseRootFromParent_Done,
     /*  560640 */   // Label 9194: @560640
     /*  560640 */   GIM_Try, /*On fail goto*//*Label 9195*/ GIMT_Encode4(560715), // Rule ID 3235 //
     /*  560645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  560656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  560659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  560662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560691 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11552:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  560691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  560710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560713 */     GIR_RootConstrainSelectedInstOperands,
     /*  560714 */     // GIR_Coverage, 3235,
     /*  560714 */     GIR_EraseRootFromParent_Done,
     /*  560715 */   // Label 9195: @560715
     /*  560715 */   GIM_Try, /*On fail goto*//*Label 9196*/ GIMT_Encode4(560790), // Rule ID 3238 //
     /*  560720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  560723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  560731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  560734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  560737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560766 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  560766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560788 */     GIR_RootConstrainSelectedInstOperands,
     /*  560789 */     // GIR_Coverage, 3238,
     /*  560789 */     GIR_EraseRootFromParent_Done,
     /*  560790 */   // Label 9196: @560790
     /*  560790 */   GIM_Try, /*On fail goto*//*Label 9197*/ GIMT_Encode4(560865), // Rule ID 3239 //
     /*  560795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  560798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  560806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  560809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  560812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560841 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11552:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  560841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  560860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560863 */     GIR_RootConstrainSelectedInstOperands,
     /*  560864 */     // GIR_Coverage, 3239,
     /*  560864 */     GIR_EraseRootFromParent_Done,
     /*  560865 */   // Label 9197: @560865
     /*  560865 */   GIM_Try, /*On fail goto*//*Label 9198*/ GIMT_Encode4(560940), // Rule ID 3242 //
     /*  560870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  560873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  560881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  560884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  560887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  560890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  560893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  560916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  560925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  560927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  560932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  560935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  560938 */     GIR_RootConstrainSelectedInstOperands,
     /*  560939 */     // GIR_Coverage, 3242,
     /*  560939 */     GIR_EraseRootFromParent_Done,
     /*  560940 */   // Label 9198: @560940
     /*  560940 */   GIM_Try, /*On fail goto*//*Label 9199*/ GIMT_Encode4(561015), // Rule ID 3243 //
     /*  560945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  560948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  560953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  560956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  560959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  560962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  560965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  560968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  560980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  560984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  560991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11552:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  560991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1),
     /*  560994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  560996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  560998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  561010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561013 */     GIR_RootConstrainSelectedInstOperands,
     /*  561014 */     // GIR_Coverage, 3243,
     /*  561014 */     GIR_EraseRootFromParent_Done,
     /*  561015 */   // Label 9199: @561015
     /*  561015 */   GIM_Try, /*On fail goto*//*Label 9200*/ GIMT_Encode4(561090), // Rule ID 3246 //
     /*  561020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561066 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561088 */     GIR_RootConstrainSelectedInstOperands,
     /*  561089 */     // GIR_Coverage, 3246,
     /*  561089 */     GIR_EraseRootFromParent_Done,
     /*  561090 */   // Label 9200: @561090
     /*  561090 */   GIM_Try, /*On fail goto*//*Label 9201*/ GIMT_Encode4(561165), // Rule ID 3247 //
     /*  561095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  561106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  561109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  561112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561141 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561163 */     GIR_RootConstrainSelectedInstOperands,
     /*  561164 */     // GIR_Coverage, 3247,
     /*  561164 */     GIR_EraseRootFromParent_Done,
     /*  561165 */   // Label 9201: @561165
     /*  561165 */   GIM_Try, /*On fail goto*//*Label 9202*/ GIMT_Encode4(561240), // Rule ID 3250 //
     /*  561170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561238 */     GIR_RootConstrainSelectedInstOperands,
     /*  561239 */     // GIR_Coverage, 3250,
     /*  561239 */     GIR_EraseRootFromParent_Done,
     /*  561240 */   // Label 9202: @561240
     /*  561240 */   GIM_Try, /*On fail goto*//*Label 9203*/ GIMT_Encode4(561315), // Rule ID 3251 //
     /*  561245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  561256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  561259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  561262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561291 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561313 */     GIR_RootConstrainSelectedInstOperands,
     /*  561314 */     // GIR_Coverage, 3251,
     /*  561314 */     GIR_EraseRootFromParent_Done,
     /*  561315 */   // Label 9203: @561315
     /*  561315 */   GIM_Try, /*On fail goto*//*Label 9204*/ GIMT_Encode4(561390), // Rule ID 3254 //
     /*  561320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561366 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  561366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561388 */     GIR_RootConstrainSelectedInstOperands,
     /*  561389 */     // GIR_Coverage, 3254,
     /*  561389 */     GIR_EraseRootFromParent_Done,
     /*  561390 */   // Label 9204: @561390
     /*  561390 */   GIM_Try, /*On fail goto*//*Label 9205*/ GIMT_Encode4(561465), // Rule ID 3255 //
     /*  561395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  561406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  561409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  561412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561441 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  561441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  561460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561463 */     GIR_RootConstrainSelectedInstOperands,
     /*  561464 */     // GIR_Coverage, 3255,
     /*  561464 */     GIR_EraseRootFromParent_Done,
     /*  561465 */   // Label 9205: @561465
     /*  561465 */   GIM_Try, /*On fail goto*//*Label 9206*/ GIMT_Encode4(561540), // Rule ID 3258 //
     /*  561470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  561481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  561484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  561487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561516 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561538 */     GIR_RootConstrainSelectedInstOperands,
     /*  561539 */     // GIR_Coverage, 3258,
     /*  561539 */     GIR_EraseRootFromParent_Done,
     /*  561540 */   // Label 9206: @561540
     /*  561540 */   GIM_Try, /*On fail goto*//*Label 9207*/ GIMT_Encode4(561615), // Rule ID 3259 //
     /*  561545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  561556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  561559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  561562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561613 */     GIR_RootConstrainSelectedInstOperands,
     /*  561614 */     // GIR_Coverage, 3259,
     /*  561614 */     GIR_EraseRootFromParent_Done,
     /*  561615 */   // Label 9207: @561615
     /*  561615 */   GIM_Try, /*On fail goto*//*Label 9208*/ GIMT_Encode4(561690), // Rule ID 3262 //
     /*  561620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  561631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  561634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  561637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561666 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561688 */     GIR_RootConstrainSelectedInstOperands,
     /*  561689 */     // GIR_Coverage, 3262,
     /*  561689 */     GIR_EraseRootFromParent_Done,
     /*  561690 */   // Label 9208: @561690
     /*  561690 */   GIM_Try, /*On fail goto*//*Label 9209*/ GIMT_Encode4(561765), // Rule ID 3263 //
     /*  561695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  561706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  561709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  561712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  561730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561741 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  561744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561763 */     GIR_RootConstrainSelectedInstOperands,
     /*  561764 */     // GIR_Coverage, 3263,
     /*  561764 */     GIR_EraseRootFromParent_Done,
     /*  561765 */   // Label 9209: @561765
     /*  561765 */   GIM_Try, /*On fail goto*//*Label 9210*/ GIMT_Encode4(561840), // Rule ID 3266 //
     /*  561770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  561781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  561784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  561787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561816 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  561816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561838 */     GIR_RootConstrainSelectedInstOperands,
     /*  561839 */     // GIR_Coverage, 3266,
     /*  561839 */     GIR_EraseRootFromParent_Done,
     /*  561840 */   // Label 9210: @561840
     /*  561840 */   GIM_Try, /*On fail goto*//*Label 9211*/ GIMT_Encode4(561915), // Rule ID 3267 //
     /*  561845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  561856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  561859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  561862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  561865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  561868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  561880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561891 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  561891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  561894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  561910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561913 */     GIR_RootConstrainSelectedInstOperands,
     /*  561914 */     // GIR_Coverage, 3267,
     /*  561914 */     GIR_EraseRootFromParent_Done,
     /*  561915 */   // Label 9211: @561915
     /*  561915 */   GIM_Try, /*On fail goto*//*Label 9212*/ GIMT_Encode4(561990), // Rule ID 3270 //
     /*  561920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  561923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  561928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  561931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  561934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  561937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  561940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  561943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  561955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  561959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  561966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  561966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  561969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  561971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  561973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  561975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  561977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  561982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  561985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  561988 */     GIR_RootConstrainSelectedInstOperands,
     /*  561989 */     // GIR_Coverage, 3270,
     /*  561989 */     GIR_EraseRootFromParent_Done,
     /*  561990 */   // Label 9212: @561990
     /*  561990 */   GIM_Try, /*On fail goto*//*Label 9213*/ GIMT_Encode4(562065), // Rule ID 3271 //
     /*  561995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  561998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  562006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  562009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  562012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562063 */     GIR_RootConstrainSelectedInstOperands,
     /*  562064 */     // GIR_Coverage, 3271,
     /*  562064 */     GIR_EraseRootFromParent_Done,
     /*  562065 */   // Label 9213: @562065
     /*  562065 */   GIM_Try, /*On fail goto*//*Label 9214*/ GIMT_Encode4(562140), // Rule ID 3274 //
     /*  562070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562138 */     GIR_RootConstrainSelectedInstOperands,
     /*  562139 */     // GIR_Coverage, 3274,
     /*  562139 */     GIR_EraseRootFromParent_Done,
     /*  562140 */   // Label 9214: @562140
     /*  562140 */   GIM_Try, /*On fail goto*//*Label 9215*/ GIMT_Encode4(562215), // Rule ID 3275 //
     /*  562145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  562156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  562159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  562162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562213 */     GIR_RootConstrainSelectedInstOperands,
     /*  562214 */     // GIR_Coverage, 3275,
     /*  562214 */     GIR_EraseRootFromParent_Done,
     /*  562215 */   // Label 9215: @562215
     /*  562215 */   GIM_Try, /*On fail goto*//*Label 9216*/ GIMT_Encode4(562290), // Rule ID 3278 //
     /*  562220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  562266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562288 */     GIR_RootConstrainSelectedInstOperands,
     /*  562289 */     // GIR_Coverage, 3278,
     /*  562289 */     GIR_EraseRootFromParent_Done,
     /*  562290 */   // Label 9216: @562290
     /*  562290 */   GIM_Try, /*On fail goto*//*Label 9217*/ GIMT_Encode4(562365), // Rule ID 3279 //
     /*  562295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  562306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  562309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  562312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562341 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  562341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  562360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562363 */     GIR_RootConstrainSelectedInstOperands,
     /*  562364 */     // GIR_Coverage, 3279,
     /*  562364 */     GIR_EraseRootFromParent_Done,
     /*  562365 */   // Label 9217: @562365
     /*  562365 */   GIM_Try, /*On fail goto*//*Label 9218*/ GIMT_Encode4(562440), // Rule ID 3282 //
     /*  562370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  562373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562416 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  562416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562438 */     GIR_RootConstrainSelectedInstOperands,
     /*  562439 */     // GIR_Coverage, 3282,
     /*  562439 */     GIR_EraseRootFromParent_Done,
     /*  562440 */   // Label 9218: @562440
     /*  562440 */   GIM_Try, /*On fail goto*//*Label 9219*/ GIMT_Encode4(562515), // Rule ID 3283 //
     /*  562445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  562456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  562459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  562462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  562480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562491 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11552:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2),
     /*  562494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562513 */     GIR_RootConstrainSelectedInstOperands,
     /*  562514 */     // GIR_Coverage, 3283,
     /*  562514 */     GIR_EraseRootFromParent_Done,
     /*  562515 */   // Label 9219: @562515
     /*  562515 */   GIM_Try, /*On fail goto*//*Label 9220*/ GIMT_Encode4(562590), // Rule ID 3286 //
     /*  562520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  562523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  562531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  562534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  562537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562566 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  562566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562588 */     GIR_RootConstrainSelectedInstOperands,
     /*  562589 */     // GIR_Coverage, 3286,
     /*  562589 */     GIR_EraseRootFromParent_Done,
     /*  562590 */   // Label 9220: @562590
     /*  562590 */   GIM_Try, /*On fail goto*//*Label 9221*/ GIMT_Encode4(562665), // Rule ID 3287 //
     /*  562595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  562606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  562609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  562612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  562630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562641 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11552:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4),
     /*  562644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562663 */     GIR_RootConstrainSelectedInstOperands,
     /*  562664 */     // GIR_Coverage, 3287,
     /*  562664 */     GIR_EraseRootFromParent_Done,
     /*  562665 */   // Label 9221: @562665
     /*  562665 */   GIM_Try, /*On fail goto*//*Label 9222*/ GIMT_Encode4(562740), // Rule ID 3290 //
     /*  562670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  562673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  562681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  562684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  562687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562716 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  562716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562738 */     GIR_RootConstrainSelectedInstOperands,
     /*  562739 */     // GIR_Coverage, 3290,
     /*  562739 */     GIR_EraseRootFromParent_Done,
     /*  562740 */   // Label 9222: @562740
     /*  562740 */   GIM_Try, /*On fail goto*//*Label 9223*/ GIMT_Encode4(562815), // Rule ID 3291 //
     /*  562745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  562748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub),
     /*  562753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  562756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  562759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  562762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  562780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562791 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11552:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  562791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8),
     /*  562794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  562810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562813 */     GIR_RootConstrainSelectedInstOperands,
     /*  562814 */     // GIR_Coverage, 3291,
     /*  562814 */     GIR_EraseRootFromParent_Done,
     /*  562815 */   // Label 9223: @562815
     /*  562815 */   GIM_Try, /*On fail goto*//*Label 9224*/ GIMT_Encode4(562890), // Rule ID 3294 //
     /*  562820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  562828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  562831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  562834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  562837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562866 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  562866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  562869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562888 */     GIR_RootConstrainSelectedInstOperands,
     /*  562889 */     // GIR_Coverage, 3294,
     /*  562889 */     GIR_EraseRootFromParent_Done,
     /*  562890 */   // Label 9224: @562890
     /*  562890 */   GIM_Try, /*On fail goto*//*Label 9225*/ GIMT_Encode4(562965), // Rule ID 3295 //
     /*  562895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  562898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  562903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  562906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  562909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  562912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  562915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  562918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  562934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  562941 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  562941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8),
     /*  562944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  562946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  562948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  562950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  562952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  562957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  562960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  562963 */     GIR_RootConstrainSelectedInstOperands,
     /*  562964 */     // GIR_Coverage, 3295,
     /*  562964 */     GIR_EraseRootFromParent_Done,
     /*  562965 */   // Label 9225: @562965
     /*  562965 */   GIM_Try, /*On fail goto*//*Label 9226*/ GIMT_Encode4(563040), // Rule ID 3298 //
     /*  562970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  562973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  562978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  562981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  562984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  562987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  562990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  562993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  562997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563016 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563038 */     GIR_RootConstrainSelectedInstOperands,
     /*  563039 */     // GIR_Coverage, 3298,
     /*  563039 */     GIR_EraseRootFromParent_Done,
     /*  563040 */   // Label 9226: @563040
     /*  563040 */   GIM_Try, /*On fail goto*//*Label 9227*/ GIMT_Encode4(563115), // Rule ID 3299 //
     /*  563045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  563056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  563059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  563062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563091 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563113 */     GIR_RootConstrainSelectedInstOperands,
     /*  563114 */     // GIR_Coverage, 3299,
     /*  563114 */     GIR_EraseRootFromParent_Done,
     /*  563115 */   // Label 9227: @563115
     /*  563115 */   GIM_Try, /*On fail goto*//*Label 9228*/ GIMT_Encode4(563190), // Rule ID 3302 //
     /*  563120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563166 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563188 */     GIR_RootConstrainSelectedInstOperands,
     /*  563189 */     // GIR_Coverage, 3302,
     /*  563189 */     GIR_EraseRootFromParent_Done,
     /*  563190 */   // Label 9228: @563190
     /*  563190 */   GIM_Try, /*On fail goto*//*Label 9229*/ GIMT_Encode4(563265), // Rule ID 3303 //
     /*  563195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  563206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  563209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  563212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563241 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563263 */     GIR_RootConstrainSelectedInstOperands,
     /*  563264 */     // GIR_Coverage, 3303,
     /*  563264 */     GIR_EraseRootFromParent_Done,
     /*  563265 */   // Label 9229: @563265
     /*  563265 */   GIM_Try, /*On fail goto*//*Label 9230*/ GIMT_Encode4(563340), // Rule ID 3306 //
     /*  563270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563316 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563338 */     GIR_RootConstrainSelectedInstOperands,
     /*  563339 */     // GIR_Coverage, 3306,
     /*  563339 */     GIR_EraseRootFromParent_Done,
     /*  563340 */   // Label 9230: @563340
     /*  563340 */   GIM_Try, /*On fail goto*//*Label 9231*/ GIMT_Encode4(563415), // Rule ID 3307 //
     /*  563345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  563356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  563359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  563362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563391 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4),
     /*  563394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563413 */     GIR_RootConstrainSelectedInstOperands,
     /*  563414 */     // GIR_Coverage, 3307,
     /*  563414 */     GIR_EraseRootFromParent_Done,
     /*  563415 */   // Label 9231: @563415
     /*  563415 */   GIM_Try, /*On fail goto*//*Label 9232*/ GIMT_Encode4(563490), // Rule ID 3310 //
     /*  563420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  563437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563466 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563488 */     GIR_RootConstrainSelectedInstOperands,
     /*  563489 */     // GIR_Coverage, 3310,
     /*  563489 */     GIR_EraseRootFromParent_Done,
     /*  563490 */   // Label 9232: @563490
     /*  563490 */   GIM_Try, /*On fail goto*//*Label 9233*/ GIMT_Encode4(563565), // Rule ID 3311 //
     /*  563495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  563506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  563509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  563512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563541 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563563 */     GIR_RootConstrainSelectedInstOperands,
     /*  563564 */     // GIR_Coverage, 3311,
     /*  563564 */     GIR_EraseRootFromParent_Done,
     /*  563565 */   // Label 9233: @563565
     /*  563565 */   GIM_Try, /*On fail goto*//*Label 9234*/ GIMT_Encode4(563640), // Rule ID 3314 //
     /*  563570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  563581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  563584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  563587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  563616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563638 */     GIR_RootConstrainSelectedInstOperands,
     /*  563639 */     // GIR_Coverage, 3314,
     /*  563639 */     GIR_EraseRootFromParent_Done,
     /*  563640 */   // Label 9234: @563640
     /*  563640 */   GIM_Try, /*On fail goto*//*Label 9235*/ GIMT_Encode4(563715), // Rule ID 3315 //
     /*  563645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  563656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  563659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  563662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563691 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  563691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2),
     /*  563694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  563710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563713 */     GIR_RootConstrainSelectedInstOperands,
     /*  563714 */     // GIR_Coverage, 3315,
     /*  563714 */     GIR_EraseRootFromParent_Done,
     /*  563715 */   // Label 9235: @563715
     /*  563715 */   GIM_Try, /*On fail goto*//*Label 9236*/ GIMT_Encode4(563790), // Rule ID 3318 //
     /*  563720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  563731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  563734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  563737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  563766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  563769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563788 */     GIR_RootConstrainSelectedInstOperands,
     /*  563789 */     // GIR_Coverage, 3318,
     /*  563789 */     GIR_EraseRootFromParent_Done,
     /*  563790 */   // Label 9236: @563790
     /*  563790 */   GIM_Try, /*On fail goto*//*Label 9237*/ GIMT_Encode4(563865), // Rule ID 3319 //
     /*  563795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  563806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  563809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  563812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563841 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11460:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  563841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  563844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  563860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563863 */     GIR_RootConstrainSelectedInstOperands,
     /*  563864 */     // GIR_Coverage, 3319,
     /*  563864 */     GIR_EraseRootFromParent_Done,
     /*  563865 */   // Label 9237: @563865
     /*  563865 */   GIM_Try, /*On fail goto*//*Label 9238*/ GIMT_Encode4(563940), // Rule ID 3322 //
     /*  563870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  563873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  563881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  563884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  563887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  563890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  563893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563916 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  563916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  563919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  563925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  563927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  563932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  563935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  563938 */     GIR_RootConstrainSelectedInstOperands,
     /*  563939 */     // GIR_Coverage, 3322,
     /*  563939 */     GIR_EraseRootFromParent_Done,
     /*  563940 */   // Label 9238: @563940
     /*  563940 */   GIM_Try, /*On fail goto*//*Label 9239*/ GIMT_Encode4(564015), // Rule ID 3323 //
     /*  563945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  563948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  563953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  563956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  563959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  563962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  563965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  563968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  563980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  563984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  563991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11460:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  563991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  563994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  563996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  563998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564013 */     GIR_RootConstrainSelectedInstOperands,
     /*  564014 */     // GIR_Coverage, 3323,
     /*  564014 */     GIR_EraseRootFromParent_Done,
     /*  564015 */   // Label 9239: @564015
     /*  564015 */   GIM_Try, /*On fail goto*//*Label 9240*/ GIMT_Encode4(564090), // Rule ID 3326 //
     /*  564020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  564066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564088 */     GIR_RootConstrainSelectedInstOperands,
     /*  564089 */     // GIR_Coverage, 3326,
     /*  564089 */     GIR_EraseRootFromParent_Done,
     /*  564090 */   // Label 9240: @564090
     /*  564090 */   GIM_Try, /*On fail goto*//*Label 9241*/ GIMT_Encode4(564165), // Rule ID 3327 //
     /*  564095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  564106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  564109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  564112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11460:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  564141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  564160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564163 */     GIR_RootConstrainSelectedInstOperands,
     /*  564164 */     // GIR_Coverage, 3327,
     /*  564164 */     GIR_EraseRootFromParent_Done,
     /*  564165 */   // Label 9241: @564165
     /*  564165 */   GIM_Try, /*On fail goto*//*Label 9242*/ GIMT_Encode4(564240), // Rule ID 3330 //
     /*  564170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  564173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564216 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  564216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564238 */     GIR_RootConstrainSelectedInstOperands,
     /*  564239 */     // GIR_Coverage, 3330,
     /*  564239 */     GIR_EraseRootFromParent_Done,
     /*  564240 */   // Label 9242: @564240
     /*  564240 */   GIM_Try, /*On fail goto*//*Label 9243*/ GIMT_Encode4(564315), // Rule ID 3331 //
     /*  564245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  564248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  564256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  564259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  564262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  564280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564291 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11460:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  564291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1),
     /*  564294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  564310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564313 */     GIR_RootConstrainSelectedInstOperands,
     /*  564314 */     // GIR_Coverage, 3331,
     /*  564314 */     GIR_EraseRootFromParent_Done,
     /*  564315 */   // Label 9243: @564315
     /*  564315 */   GIM_Try, /*On fail goto*//*Label 9244*/ GIMT_Encode4(564390), // Rule ID 3334 //
     /*  564320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564366 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564388 */     GIR_RootConstrainSelectedInstOperands,
     /*  564389 */     // GIR_Coverage, 3334,
     /*  564389 */     GIR_EraseRootFromParent_Done,
     /*  564390 */   // Label 9244: @564390
     /*  564390 */   GIM_Try, /*On fail goto*//*Label 9245*/ GIMT_Encode4(564465), // Rule ID 3335 //
     /*  564395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  564406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  564409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  564412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564441 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564463 */     GIR_RootConstrainSelectedInstOperands,
     /*  564464 */     // GIR_Coverage, 3335,
     /*  564464 */     GIR_EraseRootFromParent_Done,
     /*  564465 */   // Label 9245: @564465
     /*  564465 */   GIM_Try, /*On fail goto*//*Label 9246*/ GIMT_Encode4(564540), // Rule ID 3338 //
     /*  564470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  564481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  564484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  564487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564516 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  564519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564538 */     GIR_RootConstrainSelectedInstOperands,
     /*  564539 */     // GIR_Coverage, 3338,
     /*  564539 */     GIR_EraseRootFromParent_Done,
     /*  564540 */   // Label 9246: @564540
     /*  564540 */   GIM_Try, /*On fail goto*//*Label 9247*/ GIMT_Encode4(564615), // Rule ID 3339 //
     /*  564545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  564556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  564559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  564562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564591 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  564594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564613 */     GIR_RootConstrainSelectedInstOperands,
     /*  564614 */     // GIR_Coverage, 3339,
     /*  564614 */     GIR_EraseRootFromParent_Done,
     /*  564615 */   // Label 9247: @564615
     /*  564615 */   GIM_Try, /*On fail goto*//*Label 9248*/ GIMT_Encode4(564690), // Rule ID 3342 //
     /*  564620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  564631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  564634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  564637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  564666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  564669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564688 */     GIR_RootConstrainSelectedInstOperands,
     /*  564689 */     // GIR_Coverage, 3342,
     /*  564689 */     GIR_EraseRootFromParent_Done,
     /*  564690 */   // Label 9248: @564690
     /*  564690 */   GIM_Try, /*On fail goto*//*Label 9249*/ GIMT_Encode4(564765), // Rule ID 3343 //
     /*  564695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  564706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  564709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  564712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  564730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564741 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  564741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  564744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  564760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564763 */     GIR_RootConstrainSelectedInstOperands,
     /*  564764 */     // GIR_Coverage, 3343,
     /*  564764 */     GIR_EraseRootFromParent_Done,
     /*  564765 */   // Label 9249: @564765
     /*  564765 */   GIM_Try, /*On fail goto*//*Label 9250*/ GIMT_Encode4(564840), // Rule ID 3346 //
     /*  564770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  564781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  564784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  564787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564838 */     GIR_RootConstrainSelectedInstOperands,
     /*  564839 */     // GIR_Coverage, 3346,
     /*  564839 */     GIR_EraseRootFromParent_Done,
     /*  564840 */   // Label 9250: @564840
     /*  564840 */   GIM_Try, /*On fail goto*//*Label 9251*/ GIMT_Encode4(564915), // Rule ID 3347 //
     /*  564845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  564856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  564859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  564862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  564865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  564868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  564880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  564891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  564894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564913 */     GIR_RootConstrainSelectedInstOperands,
     /*  564914 */     // GIR_Coverage, 3347,
     /*  564914 */     GIR_EraseRootFromParent_Done,
     /*  564915 */   // Label 9251: @564915
     /*  564915 */   GIM_Try, /*On fail goto*//*Label 9252*/ GIMT_Encode4(564990), // Rule ID 3350 //
     /*  564920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  564923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  564928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  564931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  564934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  564937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  564940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  564943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  564955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  564959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  564966 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  564966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  564969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  564971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  564973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  564975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  564977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  564982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  564985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  564988 */     GIR_RootConstrainSelectedInstOperands,
     /*  564989 */     // GIR_Coverage, 3350,
     /*  564989 */     GIR_EraseRootFromParent_Done,
     /*  564990 */   // Label 9252: @564990
     /*  564990 */   GIM_Try, /*On fail goto*//*Label 9253*/ GIMT_Encode4(565065), // Rule ID 3351 //
     /*  564995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  564998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  565006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  565009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  565012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565041 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565063 */     GIR_RootConstrainSelectedInstOperands,
     /*  565064 */     // GIR_Coverage, 3351,
     /*  565064 */     GIR_EraseRootFromParent_Done,
     /*  565065 */   // Label 9253: @565065
     /*  565065 */   GIM_Try, /*On fail goto*//*Label 9254*/ GIMT_Encode4(565140), // Rule ID 3354 //
     /*  565070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  565116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565138 */     GIR_RootConstrainSelectedInstOperands,
     /*  565139 */     // GIR_Coverage, 3354,
     /*  565139 */     GIR_EraseRootFromParent_Done,
     /*  565140 */   // Label 9254: @565140
     /*  565140 */   GIM_Try, /*On fail goto*//*Label 9255*/ GIMT_Encode4(565215), // Rule ID 3355 //
     /*  565145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  565156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  565159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  565162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565191 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  565191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  565210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565213 */     GIR_RootConstrainSelectedInstOperands,
     /*  565214 */     // GIR_Coverage, 3355,
     /*  565214 */     GIR_EraseRootFromParent_Done,
     /*  565215 */   // Label 9255: @565215
     /*  565215 */   GIM_Try, /*On fail goto*//*Label 9256*/ GIMT_Encode4(565290), // Rule ID 3358 //
     /*  565220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565266 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565288 */     GIR_RootConstrainSelectedInstOperands,
     /*  565289 */     // GIR_Coverage, 3358,
     /*  565289 */     GIR_EraseRootFromParent_Done,
     /*  565290 */   // Label 9256: @565290
     /*  565290 */   GIM_Try, /*On fail goto*//*Label 9257*/ GIMT_Encode4(565365), // Rule ID 3359 //
     /*  565295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  565306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  565309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  565312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565363 */     GIR_RootConstrainSelectedInstOperands,
     /*  565364 */     // GIR_Coverage, 3359,
     /*  565364 */     GIR_EraseRootFromParent_Done,
     /*  565365 */   // Label 9257: @565365
     /*  565365 */   GIM_Try, /*On fail goto*//*Label 9258*/ GIMT_Encode4(565440), // Rule ID 3362 //
     /*  565370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565438 */     GIR_RootConstrainSelectedInstOperands,
     /*  565439 */     // GIR_Coverage, 3362,
     /*  565439 */     GIR_EraseRootFromParent_Done,
     /*  565440 */   // Label 9258: @565440
     /*  565440 */   GIM_Try, /*On fail goto*//*Label 9259*/ GIMT_Encode4(565515), // Rule ID 3363 //
     /*  565445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  565456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  565459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  565462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565491 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565513 */     GIR_RootConstrainSelectedInstOperands,
     /*  565514 */     // GIR_Coverage, 3363,
     /*  565514 */     GIR_EraseRootFromParent_Done,
     /*  565515 */   // Label 9259: @565515
     /*  565515 */   GIM_Try, /*On fail goto*//*Label 9260*/ GIMT_Encode4(565590), // Rule ID 3366 //
     /*  565520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  565523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  565531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  565534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  565537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565566 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  565566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565588 */     GIR_RootConstrainSelectedInstOperands,
     /*  565589 */     // GIR_Coverage, 3366,
     /*  565589 */     GIR_EraseRootFromParent_Done,
     /*  565590 */   // Label 9260: @565590
     /*  565590 */   GIM_Try, /*On fail goto*//*Label 9261*/ GIMT_Encode4(565665), // Rule ID 3367 //
     /*  565595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  565598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  565606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  565609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  565612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565641 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  565641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  565644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  565660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565663 */     GIR_RootConstrainSelectedInstOperands,
     /*  565664 */     // GIR_Coverage, 3367,
     /*  565664 */     GIR_EraseRootFromParent_Done,
     /*  565665 */   // Label 9261: @565665
     /*  565665 */   GIM_Try, /*On fail goto*//*Label 9262*/ GIMT_Encode4(565740), // Rule ID 3370 //
     /*  565670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  565681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  565684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  565687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565738 */     GIR_RootConstrainSelectedInstOperands,
     /*  565739 */     // GIR_Coverage, 3370,
     /*  565739 */     GIR_EraseRootFromParent_Done,
     /*  565740 */   // Label 9262: @565740
     /*  565740 */   GIM_Try, /*On fail goto*//*Label 9263*/ GIMT_Encode4(565815), // Rule ID 3371 //
     /*  565745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  565756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  565759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  565762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  565780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11460:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2),
     /*  565794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565813 */     GIR_RootConstrainSelectedInstOperands,
     /*  565814 */     // GIR_Coverage, 3371,
     /*  565814 */     GIR_EraseRootFromParent_Done,
     /*  565815 */   // Label 9263: @565815
     /*  565815 */   GIM_Try, /*On fail goto*//*Label 9264*/ GIMT_Encode4(565890), // Rule ID 3374 //
     /*  565820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  565831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  565834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  565837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  565866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565888 */     GIR_RootConstrainSelectedInstOperands,
     /*  565889 */     // GIR_Coverage, 3374,
     /*  565889 */     GIR_EraseRootFromParent_Done,
     /*  565890 */   // Label 9264: @565890
     /*  565890 */   GIM_Try, /*On fail goto*//*Label 9265*/ GIMT_Encode4(565965), // Rule ID 3375 //
     /*  565895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  565898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  565906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  565909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  565912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  565915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  565918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  565930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  565934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  565941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11460:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  565941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4),
     /*  565944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  565946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  565948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  565950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  565952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  565957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  565960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  565963 */     GIR_RootConstrainSelectedInstOperands,
     /*  565964 */     // GIR_Coverage, 3375,
     /*  565964 */     GIR_EraseRootFromParent_Done,
     /*  565965 */   // Label 9265: @565965
     /*  565965 */   GIM_Try, /*On fail goto*//*Label 9266*/ GIMT_Encode4(566040), // Rule ID 3378 //
     /*  565970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  565973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  565978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  565981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  565984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  565987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  565990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  565993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  565997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  566016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566038 */     GIR_RootConstrainSelectedInstOperands,
     /*  566039 */     // GIR_Coverage, 3378,
     /*  566039 */     GIR_EraseRootFromParent_Done,
     /*  566040 */   // Label 9266: @566040
     /*  566040 */   GIM_Try, /*On fail goto*//*Label 9267*/ GIMT_Encode4(566115), // Rule ID 3379 //
     /*  566045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  566048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub),
     /*  566053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  566056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  566059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  566062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  566065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  566084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11460:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  566091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8),
     /*  566094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  566110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566113 */     GIR_RootConstrainSelectedInstOperands,
     /*  566114 */     // GIR_Coverage, 3379,
     /*  566114 */     GIR_EraseRootFromParent_Done,
     /*  566115 */   // Label 9267: @566115
     /*  566115 */   GIM_Try, /*On fail goto*//*Label 9268*/ GIMT_Encode4(566190), // Rule ID 3470 //
     /*  566120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566166 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566188 */     GIR_RootConstrainSelectedInstOperands,
     /*  566189 */     // GIR_Coverage, 3470,
     /*  566189 */     GIR_EraseRootFromParent_Done,
     /*  566190 */   // Label 9268: @566190
     /*  566190 */   GIM_Try, /*On fail goto*//*Label 9269*/ GIMT_Encode4(566265), // Rule ID 3471 //
     /*  566195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  566206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  566209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  566212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  566215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8),
     /*  566244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566263 */     GIR_RootConstrainSelectedInstOperands,
     /*  566264 */     // GIR_Coverage, 3471,
     /*  566264 */     GIR_EraseRootFromParent_Done,
     /*  566265 */   // Label 9269: @566265
     /*  566265 */   GIM_Try, /*On fail goto*//*Label 9270*/ GIMT_Encode4(566340), // Rule ID 3474 //
     /*  566270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566338 */     GIR_RootConstrainSelectedInstOperands,
     /*  566339 */     // GIR_Coverage, 3474,
     /*  566339 */     GIR_EraseRootFromParent_Done,
     /*  566340 */   // Label 9270: @566340
     /*  566340 */   GIM_Try, /*On fail goto*//*Label 9271*/ GIMT_Encode4(566415), // Rule ID 3475 //
     /*  566345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  566356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  566359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  566362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  566365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566391 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  566394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566413 */     GIR_RootConstrainSelectedInstOperands,
     /*  566414 */     // GIR_Coverage, 3475,
     /*  566414 */     GIR_EraseRootFromParent_Done,
     /*  566415 */   // Label 9271: @566415
     /*  566415 */   GIM_Try, /*On fail goto*//*Label 9272*/ GIMT_Encode4(566490), // Rule ID 3478 //
     /*  566420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  566431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  566434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  566437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  566440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  566469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566488 */     GIR_RootConstrainSelectedInstOperands,
     /*  566489 */     // GIR_Coverage, 3478,
     /*  566489 */     GIR_EraseRootFromParent_Done,
     /*  566490 */   // Label 9272: @566490
     /*  566490 */   GIM_Try, /*On fail goto*//*Label 9273*/ GIMT_Encode4(566565), // Rule ID 3479 //
     /*  566495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  566506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  566509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  566512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  566515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566541 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  566544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566563 */     GIR_RootConstrainSelectedInstOperands,
     /*  566564 */     // GIR_Coverage, 3479,
     /*  566564 */     GIR_EraseRootFromParent_Done,
     /*  566565 */   // Label 9273: @566565
     /*  566565 */   GIM_Try, /*On fail goto*//*Label 9274*/ GIMT_Encode4(566640), // Rule ID 3482 //
     /*  566570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  566581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  566584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  566587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  566590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  566619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566638 */     GIR_RootConstrainSelectedInstOperands,
     /*  566639 */     // GIR_Coverage, 3482,
     /*  566639 */     GIR_EraseRootFromParent_Done,
     /*  566640 */   // Label 9274: @566640
     /*  566640 */   GIM_Try, /*On fail goto*//*Label 9275*/ GIMT_Encode4(566715), // Rule ID 3483 //
     /*  566645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  566656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  566659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  566662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  566665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  566684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  566694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566713 */     GIR_RootConstrainSelectedInstOperands,
     /*  566714 */     // GIR_Coverage, 3483,
     /*  566714 */     GIR_EraseRootFromParent_Done,
     /*  566715 */   // Label 9275: @566715
     /*  566715 */   GIM_Try, /*On fail goto*//*Label 9276*/ GIMT_Encode4(566790), // Rule ID 3486 //
     /*  566720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  566737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  566740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  566769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566788 */     GIR_RootConstrainSelectedInstOperands,
     /*  566789 */     // GIR_Coverage, 3486,
     /*  566789 */     GIR_EraseRootFromParent_Done,
     /*  566790 */   // Label 9276: @566790
     /*  566790 */   GIM_Try, /*On fail goto*//*Label 9277*/ GIMT_Encode4(566865), // Rule ID 3487 //
     /*  566795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  566806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  566809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  566812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  566815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  566834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  566844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566863 */     GIR_RootConstrainSelectedInstOperands,
     /*  566864 */     // GIR_Coverage, 3487,
     /*  566864 */     GIR_EraseRootFromParent_Done,
     /*  566865 */   // Label 9277: @566865
     /*  566865 */   GIM_Try, /*On fail goto*//*Label 9278*/ GIMT_Encode4(566940), // Rule ID 3490 //
     /*  566870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  566873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  566887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  566890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  566893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  566916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  566919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  566925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  566927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  566932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  566935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  566938 */     GIR_RootConstrainSelectedInstOperands,
     /*  566939 */     // GIR_Coverage, 3490,
     /*  566939 */     GIR_EraseRootFromParent_Done,
     /*  566940 */   // Label 9278: @566940
     /*  566940 */   GIM_Try, /*On fail goto*//*Label 9279*/ GIMT_Encode4(567015), // Rule ID 3491 //
     /*  566945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  566948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  566953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  566956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  566959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  566962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  566965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  566968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  566976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  566984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  566991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  566991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  566994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  566996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  566998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  567010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567013 */     GIR_RootConstrainSelectedInstOperands,
     /*  567014 */     // GIR_Coverage, 3491,
     /*  567014 */     GIR_EraseRootFromParent_Done,
     /*  567015 */   // Label 9279: @567015
     /*  567015 */   GIM_Try, /*On fail goto*//*Label 9280*/ GIMT_Encode4(567090), // Rule ID 3494 //
     /*  567020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567088 */     GIR_RootConstrainSelectedInstOperands,
     /*  567089 */     // GIR_Coverage, 3494,
     /*  567089 */     GIR_EraseRootFromParent_Done,
     /*  567090 */   // Label 9280: @567090
     /*  567090 */   GIM_Try, /*On fail goto*//*Label 9281*/ GIMT_Encode4(567165), // Rule ID 3495 //
     /*  567095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  567106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  567109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  567112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  567115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4),
     /*  567144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567163 */     GIR_RootConstrainSelectedInstOperands,
     /*  567164 */     // GIR_Coverage, 3495,
     /*  567164 */     GIR_EraseRootFromParent_Done,
     /*  567165 */   // Label 9281: @567165
     /*  567165 */   GIM_Try, /*On fail goto*//*Label 9282*/ GIMT_Encode4(567240), // Rule ID 3498 //
     /*  567170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567238 */     GIR_RootConstrainSelectedInstOperands,
     /*  567239 */     // GIR_Coverage, 3498,
     /*  567239 */     GIR_EraseRootFromParent_Done,
     /*  567240 */   // Label 9282: @567240
     /*  567240 */   GIM_Try, /*On fail goto*//*Label 9283*/ GIMT_Encode4(567315), // Rule ID 3499 //
     /*  567245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  567256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  567259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  567262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  567265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567291 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567313 */     GIR_RootConstrainSelectedInstOperands,
     /*  567314 */     // GIR_Coverage, 3499,
     /*  567314 */     GIR_EraseRootFromParent_Done,
     /*  567315 */   // Label 9283: @567315
     /*  567315 */   GIM_Try, /*On fail goto*//*Label 9284*/ GIMT_Encode4(567390), // Rule ID 3502 //
     /*  567320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567388 */     GIR_RootConstrainSelectedInstOperands,
     /*  567389 */     // GIR_Coverage, 3502,
     /*  567389 */     GIR_EraseRootFromParent_Done,
     /*  567390 */   // Label 9284: @567390
     /*  567390 */   GIM_Try, /*On fail goto*//*Label 9285*/ GIMT_Encode4(567465), // Rule ID 3503 //
     /*  567395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  567406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  567409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  567412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  567415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567463 */     GIR_RootConstrainSelectedInstOperands,
     /*  567464 */     // GIR_Coverage, 3503,
     /*  567464 */     GIR_EraseRootFromParent_Done,
     /*  567465 */   // Label 9285: @567465
     /*  567465 */   GIM_Try, /*On fail goto*//*Label 9286*/ GIMT_Encode4(567540), // Rule ID 3506 //
     /*  567470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  567481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  567484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  567487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  567490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567538 */     GIR_RootConstrainSelectedInstOperands,
     /*  567539 */     // GIR_Coverage, 3506,
     /*  567539 */     GIR_EraseRootFromParent_Done,
     /*  567540 */   // Label 9286: @567540
     /*  567540 */   GIM_Try, /*On fail goto*//*Label 9287*/ GIMT_Encode4(567615), // Rule ID 3507 //
     /*  567545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  567556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  567559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  567562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  567565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567591 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  567594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567613 */     GIR_RootConstrainSelectedInstOperands,
     /*  567614 */     // GIR_Coverage, 3507,
     /*  567614 */     GIR_EraseRootFromParent_Done,
     /*  567615 */   // Label 9287: @567615
     /*  567615 */   GIM_Try, /*On fail goto*//*Label 9288*/ GIMT_Encode4(567690), // Rule ID 3510 //
     /*  567620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  567623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  567631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  567634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  567637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  567640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  567666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567688 */     GIR_RootConstrainSelectedInstOperands,
     /*  567689 */     // GIR_Coverage, 3510,
     /*  567689 */     GIR_EraseRootFromParent_Done,
     /*  567690 */   // Label 9288: @567690
     /*  567690 */   GIM_Try, /*On fail goto*//*Label 9289*/ GIMT_Encode4(567765), // Rule ID 3511 //
     /*  567695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  567698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  567706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  567709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  567712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  567715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  567726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  567734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  567741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  567744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  567760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567763 */     GIR_RootConstrainSelectedInstOperands,
     /*  567764 */     // GIR_Coverage, 3511,
     /*  567764 */     GIR_EraseRootFromParent_Done,
     /*  567765 */   // Label 9289: @567765
     /*  567765 */   GIM_Try, /*On fail goto*//*Label 9290*/ GIMT_Encode4(567840), // Rule ID 3514 //
     /*  567770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  567773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  567781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  567784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  567790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  567816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  567835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567838 */     GIR_RootConstrainSelectedInstOperands,
     /*  567839 */     // GIR_Coverage, 3514,
     /*  567839 */     GIR_EraseRootFromParent_Done,
     /*  567840 */   // Label 9290: @567840
     /*  567840 */   GIM_Try, /*On fail goto*//*Label 9291*/ GIMT_Encode4(567915), // Rule ID 3515 //
     /*  567845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  567848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  567856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  567859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  567862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  567865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  567868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567891 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  567891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2),
     /*  567894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  567910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567913 */     GIR_RootConstrainSelectedInstOperands,
     /*  567914 */     // GIR_Coverage, 3515,
     /*  567914 */     GIR_EraseRootFromParent_Done,
     /*  567915 */   // Label 9291: @567915
     /*  567915 */   GIM_Try, /*On fail goto*//*Label 9292*/ GIMT_Encode4(567990), // Rule ID 3518 //
     /*  567920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  567923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  567928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  567931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  567934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  567937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  567940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  567943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  567951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  567959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  567966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  567966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  567969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  567971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  567973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  567975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  567977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  567982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  567985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  567988 */     GIR_RootConstrainSelectedInstOperands,
     /*  567989 */     // GIR_Coverage, 3518,
     /*  567989 */     GIR_EraseRootFromParent_Done,
     /*  567990 */   // Label 9292: @567990
     /*  567990 */   GIM_Try, /*On fail goto*//*Label 9293*/ GIMT_Encode4(568065), // Rule ID 3519 //
     /*  567995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  567998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  568006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  568009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  568012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  568015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1),
     /*  568044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568063 */     GIR_RootConstrainSelectedInstOperands,
     /*  568064 */     // GIR_Coverage, 3519,
     /*  568064 */     GIR_EraseRootFromParent_Done,
     /*  568065 */   // Label 9293: @568065
     /*  568065 */   GIM_Try, /*On fail goto*//*Label 9294*/ GIMT_Encode4(568140), // Rule ID 3522 //
     /*  568070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568138 */     GIR_RootConstrainSelectedInstOperands,
     /*  568139 */     // GIR_Coverage, 3522,
     /*  568139 */     GIR_EraseRootFromParent_Done,
     /*  568140 */   // Label 9294: @568140
     /*  568140 */   GIM_Try, /*On fail goto*//*Label 9295*/ GIMT_Encode4(568215), // Rule ID 3523 //
     /*  568145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  568156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  568159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  568162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  568165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568191 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2),
     /*  568194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568213 */     GIR_RootConstrainSelectedInstOperands,
     /*  568214 */     // GIR_Coverage, 3523,
     /*  568214 */     GIR_EraseRootFromParent_Done,
     /*  568215 */   // Label 9295: @568215
     /*  568215 */   GIM_Try, /*On fail goto*//*Label 9296*/ GIMT_Encode4(568290), // Rule ID 3526 //
     /*  568220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  568223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  568266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568288 */     GIR_RootConstrainSelectedInstOperands,
     /*  568289 */     // GIR_Coverage, 3526,
     /*  568289 */     GIR_EraseRootFromParent_Done,
     /*  568290 */   // Label 9296: @568290
     /*  568290 */   GIM_Try, /*On fail goto*//*Label 9297*/ GIMT_Encode4(568365), // Rule ID 3527 //
     /*  568295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  568298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  568306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  568309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  568312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  568315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  568326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  568341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4),
     /*  568344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  568360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568363 */     GIR_RootConstrainSelectedInstOperands,
     /*  568364 */     // GIR_Coverage, 3527,
     /*  568364 */     GIR_EraseRootFromParent_Done,
     /*  568365 */   // Label 9297: @568365
     /*  568365 */   GIM_Try, /*On fail goto*//*Label 9298*/ GIMT_Encode4(568440), // Rule ID 3530 //
     /*  568370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  568419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568438 */     GIR_RootConstrainSelectedInstOperands,
     /*  568439 */     // GIR_Coverage, 3530,
     /*  568439 */     GIR_EraseRootFromParent_Done,
     /*  568440 */   // Label 9298: @568440
     /*  568440 */   GIM_Try, /*On fail goto*//*Label 9299*/ GIMT_Encode4(568515), // Rule ID 3531 //
     /*  568445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  568456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  568459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  568462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8),
     /*  568494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568513 */     GIR_RootConstrainSelectedInstOperands,
     /*  568514 */     // GIR_Coverage, 3531,
     /*  568514 */     GIR_EraseRootFromParent_Done,
     /*  568515 */   // Label 9299: @568515
     /*  568515 */   GIM_Try, /*On fail goto*//*Label 9300*/ GIMT_Encode4(568590), // Rule ID 3534 //
     /*  568520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  568531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  568534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  568537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  568569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568588 */     GIR_RootConstrainSelectedInstOperands,
     /*  568589 */     // GIR_Coverage, 3534,
     /*  568589 */     GIR_EraseRootFromParent_Done,
     /*  568590 */   // Label 9300: @568590
     /*  568590 */   GIM_Try, /*On fail goto*//*Label 9301*/ GIMT_Encode4(568665), // Rule ID 3535 //
     /*  568595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  568606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  568609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  568612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568641 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  568644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568663 */     GIR_RootConstrainSelectedInstOperands,
     /*  568664 */     // GIR_Coverage, 3535,
     /*  568664 */     GIR_EraseRootFromParent_Done,
     /*  568665 */   // Label 9301: @568665
     /*  568665 */   GIM_Try, /*On fail goto*//*Label 9302*/ GIMT_Encode4(568740), // Rule ID 3538 //
     /*  568670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  568687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  568719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568738 */     GIR_RootConstrainSelectedInstOperands,
     /*  568739 */     // GIR_Coverage, 3538,
     /*  568739 */     GIR_EraseRootFromParent_Done,
     /*  568740 */   // Label 9302: @568740
     /*  568740 */   GIM_Try, /*On fail goto*//*Label 9303*/ GIMT_Encode4(568815), // Rule ID 3539 //
     /*  568745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  568756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  568759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  568762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11574:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  568794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568813 */     GIR_RootConstrainSelectedInstOperands,
     /*  568814 */     // GIR_Coverage, 3539,
     /*  568814 */     GIR_EraseRootFromParent_Done,
     /*  568815 */   // Label 9303: @568815
     /*  568815 */   GIM_Try, /*On fail goto*//*Label 9304*/ GIMT_Encode4(568890), // Rule ID 3542 //
     /*  568820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  568831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  568834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  568866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  568869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568888 */     GIR_RootConstrainSelectedInstOperands,
     /*  568889 */     // GIR_Coverage, 3542,
     /*  568889 */     GIR_EraseRootFromParent_Done,
     /*  568890 */   // Label 9304: @568890
     /*  568890 */   GIM_Try, /*On fail goto*//*Label 9305*/ GIMT_Encode4(568965), // Rule ID 3543 //
     /*  568895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  568898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  568906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  568909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  568912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  568915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  568918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  568926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  568930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  568934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  568941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  568941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  568944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  568946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  568948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  568950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  568952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  568957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  568960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  568963 */     GIR_RootConstrainSelectedInstOperands,
     /*  568964 */     // GIR_Coverage, 3543,
     /*  568964 */     GIR_EraseRootFromParent_Done,
     /*  568965 */   // Label 9305: @568965
     /*  568965 */   GIM_Try, /*On fail goto*//*Label 9306*/ GIMT_Encode4(569040), // Rule ID 3546 //
     /*  568970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  568973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  568978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  568981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  568984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  568987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  568990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  568993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  568997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569038 */     GIR_RootConstrainSelectedInstOperands,
     /*  569039 */     // GIR_Coverage, 3546,
     /*  569039 */     GIR_EraseRootFromParent_Done,
     /*  569040 */   // Label 9306: @569040
     /*  569040 */   GIM_Try, /*On fail goto*//*Label 9307*/ GIMT_Encode4(569115), // Rule ID 3547 //
     /*  569045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  569056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  569059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  569062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569091 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569113 */     GIR_RootConstrainSelectedInstOperands,
     /*  569114 */     // GIR_Coverage, 3547,
     /*  569114 */     GIR_EraseRootFromParent_Done,
     /*  569115 */   // Label 9307: @569115
     /*  569115 */   GIM_Try, /*On fail goto*//*Label 9308*/ GIMT_Encode4(569190), // Rule ID 3550 //
     /*  569120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  569166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569188 */     GIR_RootConstrainSelectedInstOperands,
     /*  569189 */     // GIR_Coverage, 3550,
     /*  569189 */     GIR_EraseRootFromParent_Done,
     /*  569190 */   // Label 9308: @569190
     /*  569190 */   GIM_Try, /*On fail goto*//*Label 9309*/ GIMT_Encode4(569265), // Rule ID 3551 //
     /*  569195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  569206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  569209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  569212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  569241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  569260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569263 */     GIR_RootConstrainSelectedInstOperands,
     /*  569264 */     // GIR_Coverage, 3551,
     /*  569264 */     GIR_EraseRootFromParent_Done,
     /*  569265 */   // Label 9309: @569265
     /*  569265 */   GIM_Try, /*On fail goto*//*Label 9310*/ GIMT_Encode4(569340), // Rule ID 3554 //
     /*  569270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569338 */     GIR_RootConstrainSelectedInstOperands,
     /*  569339 */     // GIR_Coverage, 3554,
     /*  569339 */     GIR_EraseRootFromParent_Done,
     /*  569340 */   // Label 9310: @569340
     /*  569340 */   GIM_Try, /*On fail goto*//*Label 9311*/ GIMT_Encode4(569415), // Rule ID 3555 //
     /*  569345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  569356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  569359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  569362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569391 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4),
     /*  569394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569413 */     GIR_RootConstrainSelectedInstOperands,
     /*  569414 */     // GIR_Coverage, 3555,
     /*  569414 */     GIR_EraseRootFromParent_Done,
     /*  569415 */   // Label 9311: @569415
     /*  569415 */   GIM_Try, /*On fail goto*//*Label 9312*/ GIMT_Encode4(569490), // Rule ID 3558 //
     /*  569420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  569431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  569434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569488 */     GIR_RootConstrainSelectedInstOperands,
     /*  569489 */     // GIR_Coverage, 3558,
     /*  569489 */     GIR_EraseRootFromParent_Done,
     /*  569490 */   // Label 9312: @569490
     /*  569490 */   GIM_Try, /*On fail goto*//*Label 9313*/ GIMT_Encode4(569565), // Rule ID 3559 //
     /*  569495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  569506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  569509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  569512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569541 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11574:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  569544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569563 */     GIR_RootConstrainSelectedInstOperands,
     /*  569564 */     // GIR_Coverage, 3559,
     /*  569564 */     GIR_EraseRootFromParent_Done,
     /*  569565 */   // Label 9313: @569565
     /*  569565 */   GIM_Try, /*On fail goto*//*Label 9314*/ GIMT_Encode4(569640), // Rule ID 3562 //
     /*  569570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  569587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569638 */     GIR_RootConstrainSelectedInstOperands,
     /*  569639 */     // GIR_Coverage, 3562,
     /*  569639 */     GIR_EraseRootFromParent_Done,
     /*  569640 */   // Label 9314: @569640
     /*  569640 */   GIM_Try, /*On fail goto*//*Label 9315*/ GIMT_Encode4(569715), // Rule ID 3563 //
     /*  569645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  569656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  569659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  569662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  569680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  569694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569713 */     GIR_RootConstrainSelectedInstOperands,
     /*  569714 */     // GIR_Coverage, 3563,
     /*  569714 */     GIR_EraseRootFromParent_Done,
     /*  569715 */   // Label 9315: @569715
     /*  569715 */   GIM_Try, /*On fail goto*//*Label 9316*/ GIMT_Encode4(569790), // Rule ID 3566 //
     /*  569720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569788 */     GIR_RootConstrainSelectedInstOperands,
     /*  569789 */     // GIR_Coverage, 3566,
     /*  569789 */     GIR_EraseRootFromParent_Done,
     /*  569790 */   // Label 9316: @569790
     /*  569790 */   GIM_Try, /*On fail goto*//*Label 9317*/ GIMT_Encode4(569865), // Rule ID 3567 //
     /*  569795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  569806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  569809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  569812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  569830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569841 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  569844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569863 */     GIR_RootConstrainSelectedInstOperands,
     /*  569864 */     // GIR_Coverage, 3567,
     /*  569864 */     GIR_EraseRootFromParent_Done,
     /*  569865 */   // Label 9317: @569865
     /*  569865 */   GIM_Try, /*On fail goto*//*Label 9318*/ GIMT_Encode4(569940), // Rule ID 3570 //
     /*  569870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  569873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  569890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  569893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  569916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  569925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  569927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  569932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  569935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  569938 */     GIR_RootConstrainSelectedInstOperands,
     /*  569939 */     // GIR_Coverage, 3570,
     /*  569939 */     GIR_EraseRootFromParent_Done,
     /*  569940 */   // Label 9318: @569940
     /*  569940 */   GIM_Try, /*On fail goto*//*Label 9319*/ GIMT_Encode4(570015), // Rule ID 3571 //
     /*  569945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  569948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  569953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  569956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  569959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  569962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  569965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  569968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  569976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  569980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  569984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  569991 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  569991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  569994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  569996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  569998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  570010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570013 */     GIR_RootConstrainSelectedInstOperands,
     /*  570014 */     // GIR_Coverage, 3571,
     /*  570014 */     GIR_EraseRootFromParent_Done,
     /*  570015 */   // Label 9319: @570015
     /*  570015 */   GIM_Try, /*On fail goto*//*Label 9320*/ GIMT_Encode4(570090), // Rule ID 3574 //
     /*  570020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570088 */     GIR_RootConstrainSelectedInstOperands,
     /*  570089 */     // GIR_Coverage, 3574,
     /*  570089 */     GIR_EraseRootFromParent_Done,
     /*  570090 */   // Label 9320: @570090
     /*  570090 */   GIM_Try, /*On fail goto*//*Label 9321*/ GIMT_Encode4(570165), // Rule ID 3575 //
     /*  570095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  570106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  570109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  570112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570141 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11574:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2),
     /*  570144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570163 */     GIR_RootConstrainSelectedInstOperands,
     /*  570164 */     // GIR_Coverage, 3575,
     /*  570164 */     GIR_EraseRootFromParent_Done,
     /*  570165 */   // Label 9321: @570165
     /*  570165 */   GIM_Try, /*On fail goto*//*Label 9322*/ GIMT_Encode4(570240), // Rule ID 3578 //
     /*  570170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570238 */     GIR_RootConstrainSelectedInstOperands,
     /*  570239 */     // GIR_Coverage, 3578,
     /*  570239 */     GIR_EraseRootFromParent_Done,
     /*  570240 */   // Label 9322: @570240
     /*  570240 */   GIM_Try, /*On fail goto*//*Label 9323*/ GIMT_Encode4(570315), // Rule ID 3579 //
     /*  570245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  570256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  570259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  570262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11574:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1),
     /*  570294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570313 */     GIR_RootConstrainSelectedInstOperands,
     /*  570314 */     // GIR_Coverage, 3579,
     /*  570314 */     GIR_EraseRootFromParent_Done,
     /*  570315 */   // Label 9323: @570315
     /*  570315 */   GIM_Try, /*On fail goto*//*Label 9324*/ GIMT_Encode4(570390), // Rule ID 3582 //
     /*  570320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570366 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570388 */     GIR_RootConstrainSelectedInstOperands,
     /*  570389 */     // GIR_Coverage, 3582,
     /*  570389 */     GIR_EraseRootFromParent_Done,
     /*  570390 */   // Label 9324: @570390
     /*  570390 */   GIM_Try, /*On fail goto*//*Label 9325*/ GIMT_Encode4(570465), // Rule ID 3583 //
     /*  570395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  570406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  570409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  570412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  570430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570441 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11574:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2),
     /*  570444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570463 */     GIR_RootConstrainSelectedInstOperands,
     /*  570464 */     // GIR_Coverage, 3583,
     /*  570464 */     GIR_EraseRootFromParent_Done,
     /*  570465 */   // Label 9325: @570465
     /*  570465 */   GIM_Try, /*On fail goto*//*Label 9326*/ GIMT_Encode4(570540), // Rule ID 3586 //
     /*  570470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  570473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  570487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  570490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  570516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570538 */     GIR_RootConstrainSelectedInstOperands,
     /*  570539 */     // GIR_Coverage, 3586,
     /*  570539 */     GIR_EraseRootFromParent_Done,
     /*  570540 */   // Label 9326: @570540
     /*  570540 */   GIM_Try, /*On fail goto*//*Label 9327*/ GIMT_Encode4(570615), // Rule ID 3587 //
     /*  570545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  570548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu),
     /*  570553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  570556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  570559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  570562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  570565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  570576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  570580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  570584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570591 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11574:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  570591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4),
     /*  570594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  570610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570613 */     GIR_RootConstrainSelectedInstOperands,
     /*  570614 */     // GIR_Coverage, 3587,
     /*  570614 */     GIR_EraseRootFromParent_Done,
     /*  570615 */   // Label 9327: @570615
     /*  570615 */   GIM_Try, /*On fail goto*//*Label 9328*/ GIMT_Encode4(570690), // Rule ID 3590 //
     /*  570620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  570628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  570669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570688 */     GIR_RootConstrainSelectedInstOperands,
     /*  570689 */     // GIR_Coverage, 3590,
     /*  570689 */     GIR_EraseRootFromParent_Done,
     /*  570690 */   // Label 9328: @570690
     /*  570690 */   GIM_Try, /*On fail goto*//*Label 9329*/ GIMT_Encode4(570765), // Rule ID 3591 //
     /*  570695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  570703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  570706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  570709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  570712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  570715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8),
     /*  570744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570763 */     GIR_RootConstrainSelectedInstOperands,
     /*  570764 */     // GIR_Coverage, 3591,
     /*  570764 */     GIR_EraseRootFromParent_Done,
     /*  570765 */   // Label 9329: @570765
     /*  570765 */   GIM_Try, /*On fail goto*//*Label 9330*/ GIMT_Encode4(570840), // Rule ID 3594 //
     /*  570770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  570778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  570819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570838 */     GIR_RootConstrainSelectedInstOperands,
     /*  570839 */     // GIR_Coverage, 3594,
     /*  570839 */     GIR_EraseRootFromParent_Done,
     /*  570840 */   // Label 9330: @570840
     /*  570840 */   GIM_Try, /*On fail goto*//*Label 9331*/ GIMT_Encode4(570915), // Rule ID 3595 //
     /*  570845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  570853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  570856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  570859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  570862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  570865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  570868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570891 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  570891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  570894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570913 */     GIR_RootConstrainSelectedInstOperands,
     /*  570914 */     // GIR_Coverage, 3595,
     /*  570914 */     GIR_EraseRootFromParent_Done,
     /*  570915 */   // Label 9331: @570915
     /*  570915 */   GIM_Try, /*On fail goto*//*Label 9332*/ GIMT_Encode4(570990), // Rule ID 3598 //
     /*  570920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  570923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  570928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  570931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  570934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  570937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  570940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  570943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  570959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  570966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  570966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  570969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  570971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  570973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  570975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  570977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  570982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  570985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  570988 */     GIR_RootConstrainSelectedInstOperands,
     /*  570989 */     // GIR_Coverage, 3598,
     /*  570989 */     GIR_EraseRootFromParent_Done,
     /*  570990 */   // Label 9332: @570990
     /*  570990 */   GIM_Try, /*On fail goto*//*Label 9333*/ GIMT_Encode4(571065), // Rule ID 3599 //
     /*  570995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  570998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  571006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  571009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  571012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  571015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571041 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571063 */     GIR_RootConstrainSelectedInstOperands,
     /*  571064 */     // GIR_Coverage, 3599,
     /*  571064 */     GIR_EraseRootFromParent_Done,
     /*  571065 */   // Label 9333: @571065
     /*  571065 */   GIM_Try, /*On fail goto*//*Label 9334*/ GIMT_Encode4(571140), // Rule ID 3602 //
     /*  571070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571138 */     GIR_RootConstrainSelectedInstOperands,
     /*  571139 */     // GIR_Coverage, 3602,
     /*  571139 */     GIR_EraseRootFromParent_Done,
     /*  571140 */   // Label 9334: @571140
     /*  571140 */   GIM_Try, /*On fail goto*//*Label 9335*/ GIMT_Encode4(571215), // Rule ID 3603 //
     /*  571145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  571156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  571159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  571162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  571165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571213 */     GIR_RootConstrainSelectedInstOperands,
     /*  571214 */     // GIR_Coverage, 3603,
     /*  571214 */     GIR_EraseRootFromParent_Done,
     /*  571215 */   // Label 9335: @571215
     /*  571215 */   GIM_Try, /*On fail goto*//*Label 9336*/ GIMT_Encode4(571290), // Rule ID 3606 //
     /*  571220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571288 */     GIR_RootConstrainSelectedInstOperands,
     /*  571289 */     // GIR_Coverage, 3606,
     /*  571289 */     GIR_EraseRootFromParent_Done,
     /*  571290 */   // Label 9336: @571290
     /*  571290 */   GIM_Try, /*On fail goto*//*Label 9337*/ GIMT_Encode4(571365), // Rule ID 3607 //
     /*  571295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  571306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  571309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  571312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  571315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  571344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571363 */     GIR_RootConstrainSelectedInstOperands,
     /*  571364 */     // GIR_Coverage, 3607,
     /*  571364 */     GIR_EraseRootFromParent_Done,
     /*  571365 */   // Label 9337: @571365
     /*  571365 */   GIM_Try, /*On fail goto*//*Label 9338*/ GIMT_Encode4(571440), // Rule ID 3610 //
     /*  571370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  571416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  571419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571438 */     GIR_RootConstrainSelectedInstOperands,
     /*  571439 */     // GIR_Coverage, 3610,
     /*  571439 */     GIR_EraseRootFromParent_Done,
     /*  571440 */   // Label 9338: @571440
     /*  571440 */   GIM_Try, /*On fail goto*//*Label 9339*/ GIMT_Encode4(571515), // Rule ID 3611 //
     /*  571445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  571456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  571459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  571462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  571465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  571476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571491 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  571491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  571494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  571510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571513 */     GIR_RootConstrainSelectedInstOperands,
     /*  571514 */     // GIR_Coverage, 3611,
     /*  571514 */     GIR_EraseRootFromParent_Done,
     /*  571515 */   // Label 9339: @571515
     /*  571515 */   GIM_Try, /*On fail goto*//*Label 9340*/ GIMT_Encode4(571590), // Rule ID 3614 //
     /*  571520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571588 */     GIR_RootConstrainSelectedInstOperands,
     /*  571589 */     // GIR_Coverage, 3614,
     /*  571589 */     GIR_EraseRootFromParent_Done,
     /*  571590 */   // Label 9340: @571590
     /*  571590 */   GIM_Try, /*On fail goto*//*Label 9341*/ GIMT_Encode4(571665), // Rule ID 3615 //
     /*  571595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  571606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  571609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  571612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  571615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4),
     /*  571644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571663 */     GIR_RootConstrainSelectedInstOperands,
     /*  571664 */     // GIR_Coverage, 3615,
     /*  571664 */     GIR_EraseRootFromParent_Done,
     /*  571665 */   // Label 9341: @571665
     /*  571665 */   GIM_Try, /*On fail goto*//*Label 9342*/ GIMT_Encode4(571740), // Rule ID 3618 //
     /*  571670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571738 */     GIR_RootConstrainSelectedInstOperands,
     /*  571739 */     // GIR_Coverage, 3618,
     /*  571739 */     GIR_EraseRootFromParent_Done,
     /*  571740 */   // Label 9342: @571740
     /*  571740 */   GIM_Try, /*On fail goto*//*Label 9343*/ GIMT_Encode4(571815), // Rule ID 3619 //
     /*  571745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  571756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  571759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  571762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  571765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571791 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  571794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571813 */     GIR_RootConstrainSelectedInstOperands,
     /*  571814 */     // GIR_Coverage, 3619,
     /*  571814 */     GIR_EraseRootFromParent_Done,
     /*  571815 */   // Label 9343: @571815
     /*  571815 */   GIM_Try, /*On fail goto*//*Label 9344*/ GIMT_Encode4(571890), // Rule ID 3622 //
     /*  571820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  571866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571888 */     GIR_RootConstrainSelectedInstOperands,
     /*  571889 */     // GIR_Coverage, 3622,
     /*  571889 */     GIR_EraseRootFromParent_Done,
     /*  571890 */   // Label 9344: @571890
     /*  571890 */   GIM_Try, /*On fail goto*//*Label 9345*/ GIMT_Encode4(571965), // Rule ID 3623 //
     /*  571895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  571898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  571906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  571909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  571912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  571915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  571918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  571926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  571934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  571941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  571941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  571944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  571946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  571948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  571950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  571952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  571957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  571960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  571963 */     GIR_RootConstrainSelectedInstOperands,
     /*  571964 */     // GIR_Coverage, 3623,
     /*  571964 */     GIR_EraseRootFromParent_Done,
     /*  571965 */   // Label 9345: @571965
     /*  571965 */   GIM_Try, /*On fail goto*//*Label 9346*/ GIMT_Encode4(572040), // Rule ID 3626 //
     /*  571970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  571973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  571978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  571981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  571984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  571987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  571990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  571993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  571997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572038 */     GIR_RootConstrainSelectedInstOperands,
     /*  572039 */     // GIR_Coverage, 3626,
     /*  572039 */     GIR_EraseRootFromParent_Done,
     /*  572040 */   // Label 9346: @572040
     /*  572040 */   GIM_Try, /*On fail goto*//*Label 9347*/ GIMT_Encode4(572115), // Rule ID 3627 //
     /*  572045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  572056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  572059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  572062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  572065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572113 */     GIR_RootConstrainSelectedInstOperands,
     /*  572114 */     // GIR_Coverage, 3627,
     /*  572114 */     GIR_EraseRootFromParent_Done,
     /*  572115 */   // Label 9347: @572115
     /*  572115 */   GIM_Try, /*On fail goto*//*Label 9348*/ GIMT_Encode4(572190), // Rule ID 3630 //
     /*  572120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  572166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572188 */     GIR_RootConstrainSelectedInstOperands,
     /*  572189 */     // GIR_Coverage, 3630,
     /*  572189 */     GIR_EraseRootFromParent_Done,
     /*  572190 */   // Label 9348: @572190
     /*  572190 */   GIM_Try, /*On fail goto*//*Label 9349*/ GIMT_Encode4(572265), // Rule ID 3631 //
     /*  572195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  572206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  572209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  572212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  572215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572241 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  572241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  572260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572263 */     GIR_RootConstrainSelectedInstOperands,
     /*  572264 */     // GIR_Coverage, 3631,
     /*  572264 */     GIR_EraseRootFromParent_Done,
     /*  572265 */   // Label 9349: @572265
     /*  572265 */   GIM_Try, /*On fail goto*//*Label 9350*/ GIMT_Encode4(572340), // Rule ID 3634 //
     /*  572270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572338 */     GIR_RootConstrainSelectedInstOperands,
     /*  572339 */     // GIR_Coverage, 3634,
     /*  572339 */     GIR_EraseRootFromParent_Done,
     /*  572340 */   // Label 9350: @572340
     /*  572340 */   GIM_Try, /*On fail goto*//*Label 9351*/ GIMT_Encode4(572415), // Rule ID 3635 //
     /*  572345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  572356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  572359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  572362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  572365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2),
     /*  572394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572413 */     GIR_RootConstrainSelectedInstOperands,
     /*  572414 */     // GIR_Coverage, 3635,
     /*  572414 */     GIR_EraseRootFromParent_Done,
     /*  572415 */   // Label 9351: @572415
     /*  572415 */   GIM_Try, /*On fail goto*//*Label 9352*/ GIMT_Encode4(572490), // Rule ID 3638 //
     /*  572420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572488 */     GIR_RootConstrainSelectedInstOperands,
     /*  572489 */     // GIR_Coverage, 3638,
     /*  572489 */     GIR_EraseRootFromParent_Done,
     /*  572490 */   // Label 9352: @572490
     /*  572490 */   GIM_Try, /*On fail goto*//*Label 9353*/ GIMT_Encode4(572565), // Rule ID 3639 //
     /*  572495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  572506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  572509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  572512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  572515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1),
     /*  572544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572563 */     GIR_RootConstrainSelectedInstOperands,
     /*  572564 */     // GIR_Coverage, 3639,
     /*  572564 */     GIR_EraseRootFromParent_Done,
     /*  572565 */   // Label 9353: @572565
     /*  572565 */   GIM_Try, /*On fail goto*//*Label 9354*/ GIMT_Encode4(572640), // Rule ID 3642 //
     /*  572570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572638 */     GIR_RootConstrainSelectedInstOperands,
     /*  572639 */     // GIR_Coverage, 3642,
     /*  572639 */     GIR_EraseRootFromParent_Done,
     /*  572640 */   // Label 9354: @572640
     /*  572640 */   GIM_Try, /*On fail goto*//*Label 9355*/ GIMT_Encode4(572715), // Rule ID 3643 //
     /*  572645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  572656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  572659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  572662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  572665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  572684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2),
     /*  572694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572713 */     GIR_RootConstrainSelectedInstOperands,
     /*  572714 */     // GIR_Coverage, 3643,
     /*  572714 */     GIR_EraseRootFromParent_Done,
     /*  572715 */   // Label 9355: @572715
     /*  572715 */   GIM_Try, /*On fail goto*//*Label 9356*/ GIMT_Encode4(572790), // Rule ID 3646 //
     /*  572720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  572723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  572766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572788 */     GIR_RootConstrainSelectedInstOperands,
     /*  572789 */     // GIR_Coverage, 3646,
     /*  572789 */     GIR_EraseRootFromParent_Done,
     /*  572790 */   // Label 9356: @572790
     /*  572790 */   GIM_Try, /*On fail goto*//*Label 9357*/ GIMT_Encode4(572865), // Rule ID 3647 //
     /*  572795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  572798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  572806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  572809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  572812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  572815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  572826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  572834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572841 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  572841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4),
     /*  572844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  572860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572863 */     GIR_RootConstrainSelectedInstOperands,
     /*  572864 */     // GIR_Coverage, 3647,
     /*  572864 */     GIR_EraseRootFromParent_Done,
     /*  572865 */   // Label 9357: @572865
     /*  572865 */   GIM_Try, /*On fail goto*//*Label 9358*/ GIMT_Encode4(572940), // Rule ID 3650 //
     /*  572870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  572873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  572890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  572893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  572916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  572919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  572925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  572927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  572932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  572935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  572938 */     GIR_RootConstrainSelectedInstOperands,
     /*  572939 */     // GIR_Coverage, 3650,
     /*  572939 */     GIR_EraseRootFromParent_Done,
     /*  572940 */   // Label 9358: @572940
     /*  572940 */   GIM_Try, /*On fail goto*//*Label 9359*/ GIMT_Encode4(573015), // Rule ID 3651 //
     /*  572945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  572948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  572953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  572956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  572959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  572962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  572965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  572968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  572980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  572984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  572991 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  572991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8),
     /*  572994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  572996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  572998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573013 */     GIR_RootConstrainSelectedInstOperands,
     /*  573014 */     // GIR_Coverage, 3651,
     /*  573014 */     GIR_EraseRootFromParent_Done,
     /*  573015 */   // Label 9359: @573015
     /*  573015 */   GIM_Try, /*On fail goto*//*Label 9360*/ GIMT_Encode4(573090), // Rule ID 3654 //
     /*  573020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573088 */     GIR_RootConstrainSelectedInstOperands,
     /*  573089 */     // GIR_Coverage, 3654,
     /*  573089 */     GIR_EraseRootFromParent_Done,
     /*  573090 */   // Label 9360: @573090
     /*  573090 */   GIM_Try, /*On fail goto*//*Label 9361*/ GIMT_Encode4(573165), // Rule ID 3655 //
     /*  573095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  573106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  573109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  573112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573141 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573163 */     GIR_RootConstrainSelectedInstOperands,
     /*  573164 */     // GIR_Coverage, 3655,
     /*  573164 */     GIR_EraseRootFromParent_Done,
     /*  573165 */   // Label 9361: @573165
     /*  573165 */   GIM_Try, /*On fail goto*//*Label 9362*/ GIMT_Encode4(573240), // Rule ID 3658 //
     /*  573170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573238 */     GIR_RootConstrainSelectedInstOperands,
     /*  573239 */     // GIR_Coverage, 3658,
     /*  573239 */     GIR_EraseRootFromParent_Done,
     /*  573240 */   // Label 9362: @573240
     /*  573240 */   GIM_Try, /*On fail goto*//*Label 9363*/ GIMT_Encode4(573315), // Rule ID 3659 //
     /*  573245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  573256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  573259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  573262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11602:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573313 */     GIR_RootConstrainSelectedInstOperands,
     /*  573314 */     // GIR_Coverage, 3659,
     /*  573314 */     GIR_EraseRootFromParent_Done,
     /*  573315 */   // Label 9363: @573315
     /*  573315 */   GIM_Try, /*On fail goto*//*Label 9364*/ GIMT_Encode4(573390), // Rule ID 3662 //
     /*  573320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573388 */     GIR_RootConstrainSelectedInstOperands,
     /*  573389 */     // GIR_Coverage, 3662,
     /*  573389 */     GIR_EraseRootFromParent_Done,
     /*  573390 */   // Label 9364: @573390
     /*  573390 */   GIM_Try, /*On fail goto*//*Label 9365*/ GIMT_Encode4(573465), // Rule ID 3663 //
     /*  573395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  573406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  573409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  573412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  573444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573463 */     GIR_RootConstrainSelectedInstOperands,
     /*  573464 */     // GIR_Coverage, 3663,
     /*  573464 */     GIR_EraseRootFromParent_Done,
     /*  573465 */   // Label 9365: @573465
     /*  573465 */   GIM_Try, /*On fail goto*//*Label 9366*/ GIMT_Encode4(573540), // Rule ID 3666 //
     /*  573470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  573519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573538 */     GIR_RootConstrainSelectedInstOperands,
     /*  573539 */     // GIR_Coverage, 3666,
     /*  573539 */     GIR_EraseRootFromParent_Done,
     /*  573540 */   // Label 9366: @573540
     /*  573540 */   GIM_Try, /*On fail goto*//*Label 9367*/ GIMT_Encode4(573615), // Rule ID 3667 //
     /*  573545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  573556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  573559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  573562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  573580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573591 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  573594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573613 */     GIR_RootConstrainSelectedInstOperands,
     /*  573614 */     // GIR_Coverage, 3667,
     /*  573614 */     GIR_EraseRootFromParent_Done,
     /*  573615 */   // Label 9367: @573615
     /*  573615 */   GIM_Try, /*On fail goto*//*Label 9368*/ GIMT_Encode4(573690), // Rule ID 3670 //
     /*  573620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  573666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  573669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573688 */     GIR_RootConstrainSelectedInstOperands,
     /*  573689 */     // GIR_Coverage, 3670,
     /*  573689 */     GIR_EraseRootFromParent_Done,
     /*  573690 */   // Label 9368: @573690
     /*  573690 */   GIM_Try, /*On fail goto*//*Label 9369*/ GIMT_Encode4(573765), // Rule ID 3671 //
     /*  573695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  573706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  573709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  573712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  573726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  573730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573741 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  573741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  573744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  573760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573763 */     GIR_RootConstrainSelectedInstOperands,
     /*  573764 */     // GIR_Coverage, 3671,
     /*  573764 */     GIR_EraseRootFromParent_Done,
     /*  573765 */   // Label 9369: @573765
     /*  573765 */   GIM_Try, /*On fail goto*//*Label 9370*/ GIMT_Encode4(573840), // Rule ID 3674 //
     /*  573770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573838 */     GIR_RootConstrainSelectedInstOperands,
     /*  573839 */     // GIR_Coverage, 3674,
     /*  573839 */     GIR_EraseRootFromParent_Done,
     /*  573840 */   // Label 9370: @573840
     /*  573840 */   GIM_Try, /*On fail goto*//*Label 9371*/ GIMT_Encode4(573915), // Rule ID 3675 //
     /*  573845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  573856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  573859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  573862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  573865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  573868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573891 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  573891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4),
     /*  573894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573913 */     GIR_RootConstrainSelectedInstOperands,
     /*  573914 */     // GIR_Coverage, 3675,
     /*  573914 */     GIR_EraseRootFromParent_Done,
     /*  573915 */   // Label 9371: @573915
     /*  573915 */   GIM_Try, /*On fail goto*//*Label 9372*/ GIMT_Encode4(573990), // Rule ID 3678 //
     /*  573920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  573923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  573928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  573931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  573934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  573937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  573940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  573943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  573955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  573959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  573966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  573966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  573969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  573971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  573973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  573975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  573977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  573982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  573985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  573988 */     GIR_RootConstrainSelectedInstOperands,
     /*  573989 */     // GIR_Coverage, 3678,
     /*  573989 */     GIR_EraseRootFromParent_Done,
     /*  573990 */   // Label 9372: @573990
     /*  573990 */   GIM_Try, /*On fail goto*//*Label 9373*/ GIMT_Encode4(574065), // Rule ID 3679 //
     /*  573995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  573998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  574006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  574009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  574012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574041 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11602:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574063 */     GIR_RootConstrainSelectedInstOperands,
     /*  574064 */     // GIR_Coverage, 3679,
     /*  574064 */     GIR_EraseRootFromParent_Done,
     /*  574065 */   // Label 9373: @574065
     /*  574065 */   GIM_Try, /*On fail goto*//*Label 9374*/ GIMT_Encode4(574140), // Rule ID 3682 //
     /*  574070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574138 */     GIR_RootConstrainSelectedInstOperands,
     /*  574139 */     // GIR_Coverage, 3682,
     /*  574139 */     GIR_EraseRootFromParent_Done,
     /*  574140 */   // Label 9374: @574140
     /*  574140 */   GIM_Try, /*On fail goto*//*Label 9375*/ GIMT_Encode4(574215), // Rule ID 3683 //
     /*  574145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  574156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  574159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  574162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574213 */     GIR_RootConstrainSelectedInstOperands,
     /*  574214 */     // GIR_Coverage, 3683,
     /*  574214 */     GIR_EraseRootFromParent_Done,
     /*  574215 */   // Label 9375: @574215
     /*  574215 */   GIM_Try, /*On fail goto*//*Label 9376*/ GIMT_Encode4(574290), // Rule ID 3686 //
     /*  574220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574288 */     GIR_RootConstrainSelectedInstOperands,
     /*  574289 */     // GIR_Coverage, 3686,
     /*  574289 */     GIR_EraseRootFromParent_Done,
     /*  574290 */   // Label 9376: @574290
     /*  574290 */   GIM_Try, /*On fail goto*//*Label 9377*/ GIMT_Encode4(574365), // Rule ID 3687 //
     /*  574295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  574306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  574309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  574312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574341 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574363 */     GIR_RootConstrainSelectedInstOperands,
     /*  574364 */     // GIR_Coverage, 3687,
     /*  574364 */     GIR_EraseRootFromParent_Done,
     /*  574365 */   // Label 9377: @574365
     /*  574365 */   GIM_Try, /*On fail goto*//*Label 9378*/ GIMT_Encode4(574440), // Rule ID 3690 //
     /*  574370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  574373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  574416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574438 */     GIR_RootConstrainSelectedInstOperands,
     /*  574439 */     // GIR_Coverage, 3690,
     /*  574439 */     GIR_EraseRootFromParent_Done,
     /*  574440 */   // Label 9378: @574440
     /*  574440 */   GIM_Try, /*On fail goto*//*Label 9379*/ GIMT_Encode4(574515), // Rule ID 3691 //
     /*  574445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  574448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  574456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  574459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  574462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  574491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  574494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  574510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574513 */     GIR_RootConstrainSelectedInstOperands,
     /*  574514 */     // GIR_Coverage, 3691,
     /*  574514 */     GIR_EraseRootFromParent_Done,
     /*  574515 */   // Label 9379: @574515
     /*  574515 */   GIM_Try, /*On fail goto*//*Label 9380*/ GIMT_Encode4(574590), // Rule ID 3694 //
     /*  574520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574588 */     GIR_RootConstrainSelectedInstOperands,
     /*  574589 */     // GIR_Coverage, 3694,
     /*  574589 */     GIR_EraseRootFromParent_Done,
     /*  574590 */   // Label 9380: @574590
     /*  574590 */   GIM_Try, /*On fail goto*//*Label 9381*/ GIMT_Encode4(574665), // Rule ID 3695 //
     /*  574595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  574606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  574609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  574612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11602:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2),
     /*  574644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574663 */     GIR_RootConstrainSelectedInstOperands,
     /*  574664 */     // GIR_Coverage, 3695,
     /*  574664 */     GIR_EraseRootFromParent_Done,
     /*  574665 */   // Label 9381: @574665
     /*  574665 */   GIM_Try, /*On fail goto*//*Label 9382*/ GIMT_Encode4(574740), // Rule ID 3698 //
     /*  574670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574738 */     GIR_RootConstrainSelectedInstOperands,
     /*  574739 */     // GIR_Coverage, 3698,
     /*  574739 */     GIR_EraseRootFromParent_Done,
     /*  574740 */   // Label 9382: @574740
     /*  574740 */   GIM_Try, /*On fail goto*//*Label 9383*/ GIMT_Encode4(574815), // Rule ID 3699 //
     /*  574745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  574756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  574759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  574762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  574780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11602:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1),
     /*  574794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574813 */     GIR_RootConstrainSelectedInstOperands,
     /*  574814 */     // GIR_Coverage, 3699,
     /*  574814 */     GIR_EraseRootFromParent_Done,
     /*  574815 */   // Label 9383: @574815
     /*  574815 */   GIM_Try, /*On fail goto*//*Label 9384*/ GIMT_Encode4(574890), // Rule ID 3702 //
     /*  574820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  574866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574888 */     GIR_RootConstrainSelectedInstOperands,
     /*  574889 */     // GIR_Coverage, 3702,
     /*  574889 */     GIR_EraseRootFromParent_Done,
     /*  574890 */   // Label 9384: @574890
     /*  574890 */   GIM_Try, /*On fail goto*//*Label 9385*/ GIMT_Encode4(574965), // Rule ID 3703 //
     /*  574895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  574898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  574906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  574909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  574912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  574915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  574918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  574926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  574930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  574934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  574941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11602:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  574941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2),
     /*  574944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  574946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  574948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  574950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  574952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  574957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  574960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  574963 */     GIR_RootConstrainSelectedInstOperands,
     /*  574964 */     // GIR_Coverage, 3703,
     /*  574964 */     GIR_EraseRootFromParent_Done,
     /*  574965 */   // Label 9385: @574965
     /*  574965 */   GIM_Try, /*On fail goto*//*Label 9386*/ GIMT_Encode4(575040), // Rule ID 3706 //
     /*  574970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  574973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  574978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  574981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  574984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  574987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  574990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  574993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  574997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  575016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575038 */     GIR_RootConstrainSelectedInstOperands,
     /*  575039 */     // GIR_Coverage, 3706,
     /*  575039 */     GIR_EraseRootFromParent_Done,
     /*  575040 */   // Label 9386: @575040
     /*  575040 */   GIM_Try, /*On fail goto*//*Label 9387*/ GIMT_Encode4(575115), // Rule ID 3707 //
     /*  575045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  575048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu),
     /*  575053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  575056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  575059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  575062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  575065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  575084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11602:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  575091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4),
     /*  575094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  575110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575113 */     GIR_RootConstrainSelectedInstOperands,
     /*  575114 */     // GIR_Coverage, 3707,
     /*  575114 */     GIR_EraseRootFromParent_Done,
     /*  575115 */   // Label 9387: @575115
     /*  575115 */   GIM_Try, /*On fail goto*//*Label 9388*/ GIMT_Encode4(575190), // Rule ID 3710 //
     /*  575120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575166 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575188 */     GIR_RootConstrainSelectedInstOperands,
     /*  575189 */     // GIR_Coverage, 3710,
     /*  575189 */     GIR_EraseRootFromParent_Done,
     /*  575190 */   // Label 9388: @575190
     /*  575190 */   GIM_Try, /*On fail goto*//*Label 9389*/ GIMT_Encode4(575265), // Rule ID 3711 //
     /*  575195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  575206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  575209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  575212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  575215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575241 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8),
     /*  575244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575263 */     GIR_RootConstrainSelectedInstOperands,
     /*  575264 */     // GIR_Coverage, 3711,
     /*  575264 */     GIR_EraseRootFromParent_Done,
     /*  575265 */   // Label 9389: @575265
     /*  575265 */   GIM_Try, /*On fail goto*//*Label 9390*/ GIMT_Encode4(575340), // Rule ID 3714 //
     /*  575270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575338 */     GIR_RootConstrainSelectedInstOperands,
     /*  575339 */     // GIR_Coverage, 3714,
     /*  575339 */     GIR_EraseRootFromParent_Done,
     /*  575340 */   // Label 9390: @575340
     /*  575340 */   GIM_Try, /*On fail goto*//*Label 9391*/ GIMT_Encode4(575415), // Rule ID 3715 //
     /*  575345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  575356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  575359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  575362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  575365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575391 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  575394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575413 */     GIR_RootConstrainSelectedInstOperands,
     /*  575414 */     // GIR_Coverage, 3715,
     /*  575414 */     GIR_EraseRootFromParent_Done,
     /*  575415 */   // Label 9391: @575415
     /*  575415 */   GIM_Try, /*On fail goto*//*Label 9392*/ GIMT_Encode4(575490), // Rule ID 3718 //
     /*  575420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  575469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575488 */     GIR_RootConstrainSelectedInstOperands,
     /*  575489 */     // GIR_Coverage, 3718,
     /*  575489 */     GIR_EraseRootFromParent_Done,
     /*  575490 */   // Label 9392: @575490
     /*  575490 */   GIM_Try, /*On fail goto*//*Label 9393*/ GIMT_Encode4(575565), // Rule ID 3719 //
     /*  575495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  575506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  575509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  575512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  575515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575541 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  575544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575563 */     GIR_RootConstrainSelectedInstOperands,
     /*  575564 */     // GIR_Coverage, 3719,
     /*  575564 */     GIR_EraseRootFromParent_Done,
     /*  575565 */   // Label 9393: @575565
     /*  575565 */   GIM_Try, /*On fail goto*//*Label 9394*/ GIMT_Encode4(575640), // Rule ID 3722 //
     /*  575570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  575619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575638 */     GIR_RootConstrainSelectedInstOperands,
     /*  575639 */     // GIR_Coverage, 3722,
     /*  575639 */     GIR_EraseRootFromParent_Done,
     /*  575640 */   // Label 9394: @575640
     /*  575640 */   GIM_Try, /*On fail goto*//*Label 9395*/ GIMT_Encode4(575715), // Rule ID 3723 //
     /*  575645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  575656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  575659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  575662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  575665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  575684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575691 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  575694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575713 */     GIR_RootConstrainSelectedInstOperands,
     /*  575714 */     // GIR_Coverage, 3723,
     /*  575714 */     GIR_EraseRootFromParent_Done,
     /*  575715 */   // Label 9395: @575715
     /*  575715 */   GIM_Try, /*On fail goto*//*Label 9396*/ GIMT_Encode4(575790), // Rule ID 3726 //
     /*  575720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575766 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  575769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575788 */     GIR_RootConstrainSelectedInstOperands,
     /*  575789 */     // GIR_Coverage, 3726,
     /*  575789 */     GIR_EraseRootFromParent_Done,
     /*  575790 */   // Label 9396: @575790
     /*  575790 */   GIM_Try, /*On fail goto*//*Label 9397*/ GIMT_Encode4(575865), // Rule ID 3727 //
     /*  575795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  575806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  575809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  575812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  575815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  575834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575841 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  575844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575863 */     GIR_RootConstrainSelectedInstOperands,
     /*  575864 */     // GIR_Coverage, 3727,
     /*  575864 */     GIR_EraseRootFromParent_Done,
     /*  575865 */   // Label 9397: @575865
     /*  575865 */   GIM_Try, /*On fail goto*//*Label 9398*/ GIMT_Encode4(575940), // Rule ID 3730 //
     /*  575870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  575873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  575893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575916 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  575916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  575919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  575925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  575927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  575932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  575935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  575938 */     GIR_RootConstrainSelectedInstOperands,
     /*  575939 */     // GIR_Coverage, 3730,
     /*  575939 */     GIR_EraseRootFromParent_Done,
     /*  575940 */   // Label 9398: @575940
     /*  575940 */   GIM_Try, /*On fail goto*//*Label 9399*/ GIMT_Encode4(576015), // Rule ID 3731 //
     /*  575945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  575948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  575953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  575956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  575959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  575962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  575965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  575968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  575976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  575984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  575991 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  575991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  575994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  575996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  575998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  576010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576013 */     GIR_RootConstrainSelectedInstOperands,
     /*  576014 */     // GIR_Coverage, 3731,
     /*  576014 */     GIR_EraseRootFromParent_Done,
     /*  576015 */   // Label 9399: @576015
     /*  576015 */   GIM_Try, /*On fail goto*//*Label 9400*/ GIMT_Encode4(576090), // Rule ID 3734 //
     /*  576020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576066 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576088 */     GIR_RootConstrainSelectedInstOperands,
     /*  576089 */     // GIR_Coverage, 3734,
     /*  576089 */     GIR_EraseRootFromParent_Done,
     /*  576090 */   // Label 9400: @576090
     /*  576090 */   GIM_Try, /*On fail goto*//*Label 9401*/ GIMT_Encode4(576165), // Rule ID 3735 //
     /*  576095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  576106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  576109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  576112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  576115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4),
     /*  576144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576163 */     GIR_RootConstrainSelectedInstOperands,
     /*  576164 */     // GIR_Coverage, 3735,
     /*  576164 */     GIR_EraseRootFromParent_Done,
     /*  576165 */   // Label 9401: @576165
     /*  576165 */   GIM_Try, /*On fail goto*//*Label 9402*/ GIMT_Encode4(576240), // Rule ID 3738 //
     /*  576170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576238 */     GIR_RootConstrainSelectedInstOperands,
     /*  576239 */     // GIR_Coverage, 3738,
     /*  576239 */     GIR_EraseRootFromParent_Done,
     /*  576240 */   // Label 9402: @576240
     /*  576240 */   GIM_Try, /*On fail goto*//*Label 9403*/ GIMT_Encode4(576315), // Rule ID 3739 //
     /*  576245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  576256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  576259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  576262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  576265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576291 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576313 */     GIR_RootConstrainSelectedInstOperands,
     /*  576314 */     // GIR_Coverage, 3739,
     /*  576314 */     GIR_EraseRootFromParent_Done,
     /*  576315 */   // Label 9403: @576315
     /*  576315 */   GIM_Try, /*On fail goto*//*Label 9404*/ GIMT_Encode4(576390), // Rule ID 3742 //
     /*  576320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576388 */     GIR_RootConstrainSelectedInstOperands,
     /*  576389 */     // GIR_Coverage, 3742,
     /*  576389 */     GIR_EraseRootFromParent_Done,
     /*  576390 */   // Label 9404: @576390
     /*  576390 */   GIM_Try, /*On fail goto*//*Label 9405*/ GIMT_Encode4(576465), // Rule ID 3743 //
     /*  576395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  576406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  576409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  576412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  576415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576441 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576463 */     GIR_RootConstrainSelectedInstOperands,
     /*  576464 */     // GIR_Coverage, 3743,
     /*  576464 */     GIR_EraseRootFromParent_Done,
     /*  576465 */   // Label 9405: @576465
     /*  576465 */   GIM_Try, /*On fail goto*//*Label 9406*/ GIMT_Encode4(576540), // Rule ID 3746 //
     /*  576470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576538 */     GIR_RootConstrainSelectedInstOperands,
     /*  576539 */     // GIR_Coverage, 3746,
     /*  576539 */     GIR_EraseRootFromParent_Done,
     /*  576540 */   // Label 9406: @576540
     /*  576540 */   GIM_Try, /*On fail goto*//*Label 9407*/ GIMT_Encode4(576615), // Rule ID 3747 //
     /*  576545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  576556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  576559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  576562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  576565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576591 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  576594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576613 */     GIR_RootConstrainSelectedInstOperands,
     /*  576614 */     // GIR_Coverage, 3747,
     /*  576614 */     GIR_EraseRootFromParent_Done,
     /*  576615 */   // Label 9407: @576615
     /*  576615 */   GIM_Try, /*On fail goto*//*Label 9408*/ GIMT_Encode4(576690), // Rule ID 3750 //
     /*  576620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  576623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  576666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576688 */     GIR_RootConstrainSelectedInstOperands,
     /*  576689 */     // GIR_Coverage, 3750,
     /*  576689 */     GIR_EraseRootFromParent_Done,
     /*  576690 */   // Label 9408: @576690
     /*  576690 */   GIM_Try, /*On fail goto*//*Label 9409*/ GIMT_Encode4(576765), // Rule ID 3751 //
     /*  576695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  576698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  576706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  576709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  576712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  576715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  576726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  576734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  576741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  576744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  576760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576763 */     GIR_RootConstrainSelectedInstOperands,
     /*  576764 */     // GIR_Coverage, 3751,
     /*  576764 */     GIR_EraseRootFromParent_Done,
     /*  576765 */   // Label 9409: @576765
     /*  576765 */   GIM_Try, /*On fail goto*//*Label 9410*/ GIMT_Encode4(576840), // Rule ID 3754 //
     /*  576770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576838 */     GIR_RootConstrainSelectedInstOperands,
     /*  576839 */     // GIR_Coverage, 3754,
     /*  576839 */     GIR_EraseRootFromParent_Done,
     /*  576840 */   // Label 9410: @576840
     /*  576840 */   GIM_Try, /*On fail goto*//*Label 9411*/ GIMT_Encode4(576915), // Rule ID 3755 //
     /*  576845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  576856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  576859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  576862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  576865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  576868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576891 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  576891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2),
     /*  576894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576913 */     GIR_RootConstrainSelectedInstOperands,
     /*  576914 */     // GIR_Coverage, 3755,
     /*  576914 */     GIR_EraseRootFromParent_Done,
     /*  576915 */   // Label 9411: @576915
     /*  576915 */   GIM_Try, /*On fail goto*//*Label 9412*/ GIMT_Encode4(576990), // Rule ID 3758 //
     /*  576920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  576923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  576928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  576931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  576934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  576937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  576940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  576943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  576951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  576959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  576966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  576966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  576969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  576971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  576973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  576975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  576977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  576982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  576985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  576988 */     GIR_RootConstrainSelectedInstOperands,
     /*  576989 */     // GIR_Coverage, 3758,
     /*  576989 */     GIR_EraseRootFromParent_Done,
     /*  576990 */   // Label 9412: @576990
     /*  576990 */   GIM_Try, /*On fail goto*//*Label 9413*/ GIMT_Encode4(577065), // Rule ID 3759 //
     /*  576995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  576998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  577006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  577009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  577012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  577015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1),
     /*  577044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577063 */     GIR_RootConstrainSelectedInstOperands,
     /*  577064 */     // GIR_Coverage, 3759,
     /*  577064 */     GIR_EraseRootFromParent_Done,
     /*  577065 */   // Label 9413: @577065
     /*  577065 */   GIM_Try, /*On fail goto*//*Label 9414*/ GIMT_Encode4(577140), // Rule ID 3762 //
     /*  577070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577138 */     GIR_RootConstrainSelectedInstOperands,
     /*  577139 */     // GIR_Coverage, 3762,
     /*  577139 */     GIR_EraseRootFromParent_Done,
     /*  577140 */   // Label 9414: @577140
     /*  577140 */   GIM_Try, /*On fail goto*//*Label 9415*/ GIMT_Encode4(577215), // Rule ID 3763 //
     /*  577145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  577156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  577159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  577162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  577165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577191 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2),
     /*  577194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577213 */     GIR_RootConstrainSelectedInstOperands,
     /*  577214 */     // GIR_Coverage, 3763,
     /*  577214 */     GIR_EraseRootFromParent_Done,
     /*  577215 */   // Label 9415: @577215
     /*  577215 */   GIM_Try, /*On fail goto*//*Label 9416*/ GIMT_Encode4(577290), // Rule ID 3766 //
     /*  577220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  577223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  577266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577288 */     GIR_RootConstrainSelectedInstOperands,
     /*  577289 */     // GIR_Coverage, 3766,
     /*  577289 */     GIR_EraseRootFromParent_Done,
     /*  577290 */   // Label 9416: @577290
     /*  577290 */   GIM_Try, /*On fail goto*//*Label 9417*/ GIMT_Encode4(577365), // Rule ID 3767 //
     /*  577295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  577298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  577306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  577309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  577312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  577315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  577326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  577341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4),
     /*  577344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  577360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577363 */     GIR_RootConstrainSelectedInstOperands,
     /*  577364 */     // GIR_Coverage, 3767,
     /*  577364 */     GIR_EraseRootFromParent_Done,
     /*  577365 */   // Label 9417: @577365
     /*  577365 */   GIM_Try, /*On fail goto*//*Label 9418*/ GIMT_Encode4(577440), // Rule ID 3770 //
     /*  577370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577416 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  577419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577438 */     GIR_RootConstrainSelectedInstOperands,
     /*  577439 */     // GIR_Coverage, 3770,
     /*  577439 */     GIR_EraseRootFromParent_Done,
     /*  577440 */   // Label 9418: @577440
     /*  577440 */   GIM_Try, /*On fail goto*//*Label 9419*/ GIMT_Encode4(577515), // Rule ID 3771 //
     /*  577445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  577456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  577459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  577462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8),
     /*  577494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577513 */     GIR_RootConstrainSelectedInstOperands,
     /*  577514 */     // GIR_Coverage, 3771,
     /*  577514 */     GIR_EraseRootFromParent_Done,
     /*  577515 */   // Label 9419: @577515
     /*  577515 */   GIM_Try, /*On fail goto*//*Label 9420*/ GIMT_Encode4(577590), // Rule ID 3774 //
     /*  577520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  577569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577588 */     GIR_RootConstrainSelectedInstOperands,
     /*  577589 */     // GIR_Coverage, 3774,
     /*  577589 */     GIR_EraseRootFromParent_Done,
     /*  577590 */   // Label 9420: @577590
     /*  577590 */   GIM_Try, /*On fail goto*//*Label 9421*/ GIMT_Encode4(577665), // Rule ID 3775 //
     /*  577595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  577606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  577609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  577612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577641 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  577644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577663 */     GIR_RootConstrainSelectedInstOperands,
     /*  577664 */     // GIR_Coverage, 3775,
     /*  577664 */     GIR_EraseRootFromParent_Done,
     /*  577665 */   // Label 9421: @577665
     /*  577665 */   GIM_Try, /*On fail goto*//*Label 9422*/ GIMT_Encode4(577740), // Rule ID 3778 //
     /*  577670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  577719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577738 */     GIR_RootConstrainSelectedInstOperands,
     /*  577739 */     // GIR_Coverage, 3778,
     /*  577739 */     GIR_EraseRootFromParent_Done,
     /*  577740 */   // Label 9422: @577740
     /*  577740 */   GIM_Try, /*On fail goto*//*Label 9423*/ GIMT_Encode4(577815), // Rule ID 3779 //
     /*  577745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  577756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  577759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  577762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11570:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  577794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577813 */     GIR_RootConstrainSelectedInstOperands,
     /*  577814 */     // GIR_Coverage, 3779,
     /*  577814 */     GIR_EraseRootFromParent_Done,
     /*  577815 */   // Label 9423: @577815
     /*  577815 */   GIM_Try, /*On fail goto*//*Label 9424*/ GIMT_Encode4(577890), // Rule ID 3782 //
     /*  577820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  577866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  577869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577888 */     GIR_RootConstrainSelectedInstOperands,
     /*  577889 */     // GIR_Coverage, 3782,
     /*  577889 */     GIR_EraseRootFromParent_Done,
     /*  577890 */   // Label 9424: @577890
     /*  577890 */   GIM_Try, /*On fail goto*//*Label 9425*/ GIMT_Encode4(577965), // Rule ID 3783 //
     /*  577895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  577898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  577906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  577909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  577912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  577915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  577918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  577926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  577930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  577934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  577941 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  577941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  577944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  577946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  577948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  577950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  577952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  577957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  577960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  577963 */     GIR_RootConstrainSelectedInstOperands,
     /*  577964 */     // GIR_Coverage, 3783,
     /*  577964 */     GIR_EraseRootFromParent_Done,
     /*  577965 */   // Label 9425: @577965
     /*  577965 */   GIM_Try, /*On fail goto*//*Label 9426*/ GIMT_Encode4(578040), // Rule ID 3786 //
     /*  577970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  577973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  577978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  577981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  577984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  577987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  577990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  577993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  577997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578038 */     GIR_RootConstrainSelectedInstOperands,
     /*  578039 */     // GIR_Coverage, 3786,
     /*  578039 */     GIR_EraseRootFromParent_Done,
     /*  578040 */   // Label 9426: @578040
     /*  578040 */   GIM_Try, /*On fail goto*//*Label 9427*/ GIMT_Encode4(578115), // Rule ID 3787 //
     /*  578045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  578056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  578059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  578062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578091 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578113 */     GIR_RootConstrainSelectedInstOperands,
     /*  578114 */     // GIR_Coverage, 3787,
     /*  578114 */     GIR_EraseRootFromParent_Done,
     /*  578115 */   // Label 9427: @578115
     /*  578115 */   GIM_Try, /*On fail goto*//*Label 9428*/ GIMT_Encode4(578190), // Rule ID 3790 //
     /*  578120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  578166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578188 */     GIR_RootConstrainSelectedInstOperands,
     /*  578189 */     // GIR_Coverage, 3790,
     /*  578189 */     GIR_EraseRootFromParent_Done,
     /*  578190 */   // Label 9428: @578190
     /*  578190 */   GIM_Try, /*On fail goto*//*Label 9429*/ GIMT_Encode4(578265), // Rule ID 3791 //
     /*  578195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  578206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  578209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  578212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578241 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  578241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  578260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578263 */     GIR_RootConstrainSelectedInstOperands,
     /*  578264 */     // GIR_Coverage, 3791,
     /*  578264 */     GIR_EraseRootFromParent_Done,
     /*  578265 */   // Label 9429: @578265
     /*  578265 */   GIM_Try, /*On fail goto*//*Label 9430*/ GIMT_Encode4(578340), // Rule ID 3794 //
     /*  578270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578316 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578338 */     GIR_RootConstrainSelectedInstOperands,
     /*  578339 */     // GIR_Coverage, 3794,
     /*  578339 */     GIR_EraseRootFromParent_Done,
     /*  578340 */   // Label 9430: @578340
     /*  578340 */   GIM_Try, /*On fail goto*//*Label 9431*/ GIMT_Encode4(578415), // Rule ID 3795 //
     /*  578345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  578356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  578359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  578362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578391 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4),
     /*  578394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578413 */     GIR_RootConstrainSelectedInstOperands,
     /*  578414 */     // GIR_Coverage, 3795,
     /*  578414 */     GIR_EraseRootFromParent_Done,
     /*  578415 */   // Label 9431: @578415
     /*  578415 */   GIM_Try, /*On fail goto*//*Label 9432*/ GIMT_Encode4(578490), // Rule ID 3798 //
     /*  578420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578488 */     GIR_RootConstrainSelectedInstOperands,
     /*  578489 */     // GIR_Coverage, 3798,
     /*  578489 */     GIR_EraseRootFromParent_Done,
     /*  578490 */   // Label 9432: @578490
     /*  578490 */   GIM_Try, /*On fail goto*//*Label 9433*/ GIMT_Encode4(578565), // Rule ID 3799 //
     /*  578495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  578506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  578509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  578512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578541 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11570:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  578544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578563 */     GIR_RootConstrainSelectedInstOperands,
     /*  578564 */     // GIR_Coverage, 3799,
     /*  578564 */     GIR_EraseRootFromParent_Done,
     /*  578565 */   // Label 9433: @578565
     /*  578565 */   GIM_Try, /*On fail goto*//*Label 9434*/ GIMT_Encode4(578640), // Rule ID 3802 //
     /*  578570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578638 */     GIR_RootConstrainSelectedInstOperands,
     /*  578639 */     // GIR_Coverage, 3802,
     /*  578639 */     GIR_EraseRootFromParent_Done,
     /*  578640 */   // Label 9434: @578640
     /*  578640 */   GIM_Try, /*On fail goto*//*Label 9435*/ GIMT_Encode4(578715), // Rule ID 3803 //
     /*  578645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  578656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  578659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  578662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  578680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578691 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  578694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578713 */     GIR_RootConstrainSelectedInstOperands,
     /*  578714 */     // GIR_Coverage, 3803,
     /*  578714 */     GIR_EraseRootFromParent_Done,
     /*  578715 */   // Label 9435: @578715
     /*  578715 */   GIM_Try, /*On fail goto*//*Label 9436*/ GIMT_Encode4(578790), // Rule ID 3806 //
     /*  578720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578788 */     GIR_RootConstrainSelectedInstOperands,
     /*  578789 */     // GIR_Coverage, 3806,
     /*  578789 */     GIR_EraseRootFromParent_Done,
     /*  578790 */   // Label 9436: @578790
     /*  578790 */   GIM_Try, /*On fail goto*//*Label 9437*/ GIMT_Encode4(578865), // Rule ID 3807 //
     /*  578795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  578806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  578809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  578812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  578830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578841 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  578844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578863 */     GIR_RootConstrainSelectedInstOperands,
     /*  578864 */     // GIR_Coverage, 3807,
     /*  578864 */     GIR_EraseRootFromParent_Done,
     /*  578865 */   // Label 9437: @578865
     /*  578865 */   GIM_Try, /*On fail goto*//*Label 9438*/ GIMT_Encode4(578940), // Rule ID 3810 //
     /*  578870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  578873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  578890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  578893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578916 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  578916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  578925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  578927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  578932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  578935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  578938 */     GIR_RootConstrainSelectedInstOperands,
     /*  578939 */     // GIR_Coverage, 3810,
     /*  578939 */     GIR_EraseRootFromParent_Done,
     /*  578940 */   // Label 9438: @578940
     /*  578940 */   GIM_Try, /*On fail goto*//*Label 9439*/ GIMT_Encode4(579015), // Rule ID 3811 //
     /*  578945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  578948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  578953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  578956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  578959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  578962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  578965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  578968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  578976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  578980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  578984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  578991 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  578991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  578994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  578996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  578998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  579010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579013 */     GIR_RootConstrainSelectedInstOperands,
     /*  579014 */     // GIR_Coverage, 3811,
     /*  579014 */     GIR_EraseRootFromParent_Done,
     /*  579015 */   // Label 9439: @579015
     /*  579015 */   GIM_Try, /*On fail goto*//*Label 9440*/ GIMT_Encode4(579090), // Rule ID 3814 //
     /*  579020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579088 */     GIR_RootConstrainSelectedInstOperands,
     /*  579089 */     // GIR_Coverage, 3814,
     /*  579089 */     GIR_EraseRootFromParent_Done,
     /*  579090 */   // Label 9440: @579090
     /*  579090 */   GIM_Try, /*On fail goto*//*Label 9441*/ GIMT_Encode4(579165), // Rule ID 3815 //
     /*  579095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  579106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  579109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  579112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579141 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11570:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2),
     /*  579144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579163 */     GIR_RootConstrainSelectedInstOperands,
     /*  579164 */     // GIR_Coverage, 3815,
     /*  579164 */     GIR_EraseRootFromParent_Done,
     /*  579165 */   // Label 9441: @579165
     /*  579165 */   GIM_Try, /*On fail goto*//*Label 9442*/ GIMT_Encode4(579240), // Rule ID 3818 //
     /*  579170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579238 */     GIR_RootConstrainSelectedInstOperands,
     /*  579239 */     // GIR_Coverage, 3818,
     /*  579239 */     GIR_EraseRootFromParent_Done,
     /*  579240 */   // Label 9442: @579240
     /*  579240 */   GIM_Try, /*On fail goto*//*Label 9443*/ GIMT_Encode4(579315), // Rule ID 3819 //
     /*  579245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  579256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  579259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  579262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579291 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11570:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1),
     /*  579294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579313 */     GIR_RootConstrainSelectedInstOperands,
     /*  579314 */     // GIR_Coverage, 3819,
     /*  579314 */     GIR_EraseRootFromParent_Done,
     /*  579315 */   // Label 9443: @579315
     /*  579315 */   GIM_Try, /*On fail goto*//*Label 9444*/ GIMT_Encode4(579390), // Rule ID 3822 //
     /*  579320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579366 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579388 */     GIR_RootConstrainSelectedInstOperands,
     /*  579389 */     // GIR_Coverage, 3822,
     /*  579389 */     GIR_EraseRootFromParent_Done,
     /*  579390 */   // Label 9444: @579390
     /*  579390 */   GIM_Try, /*On fail goto*//*Label 9445*/ GIMT_Encode4(579465), // Rule ID 3823 //
     /*  579395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  579406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  579409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  579412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  579430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579441 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11570:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2),
     /*  579444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579463 */     GIR_RootConstrainSelectedInstOperands,
     /*  579464 */     // GIR_Coverage, 3823,
     /*  579464 */     GIR_EraseRootFromParent_Done,
     /*  579465 */   // Label 9445: @579465
     /*  579465 */   GIM_Try, /*On fail goto*//*Label 9446*/ GIMT_Encode4(579540), // Rule ID 3826 //
     /*  579470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  579473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  579490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  579516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579538 */     GIR_RootConstrainSelectedInstOperands,
     /*  579539 */     // GIR_Coverage, 3826,
     /*  579539 */     GIR_EraseRootFromParent_Done,
     /*  579540 */   // Label 9446: @579540
     /*  579540 */   GIM_Try, /*On fail goto*//*Label 9447*/ GIMT_Encode4(579615), // Rule ID 3827 //
     /*  579545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  579548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd),
     /*  579553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  579556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  579559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  579562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  579565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  579576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  579580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  579584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579591 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11570:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  579591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4),
     /*  579594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  579610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579613 */     GIR_RootConstrainSelectedInstOperands,
     /*  579614 */     // GIR_Coverage, 3827,
     /*  579614 */     GIR_EraseRootFromParent_Done,
     /*  579615 */   // Label 9447: @579615
     /*  579615 */   GIM_Try, /*On fail goto*//*Label 9448*/ GIMT_Encode4(579690), // Rule ID 3830 //
     /*  579620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  579628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  579669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579688 */     GIR_RootConstrainSelectedInstOperands,
     /*  579689 */     // GIR_Coverage, 3830,
     /*  579689 */     GIR_EraseRootFromParent_Done,
     /*  579690 */   // Label 9448: @579690
     /*  579690 */   GIM_Try, /*On fail goto*//*Label 9449*/ GIMT_Encode4(579765), // Rule ID 3831 //
     /*  579695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  579703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  579706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  579709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  579712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  579715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8),
     /*  579744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579763 */     GIR_RootConstrainSelectedInstOperands,
     /*  579764 */     // GIR_Coverage, 3831,
     /*  579764 */     GIR_EraseRootFromParent_Done,
     /*  579765 */   // Label 9449: @579765
     /*  579765 */   GIM_Try, /*On fail goto*//*Label 9450*/ GIMT_Encode4(579840), // Rule ID 3834 //
     /*  579770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  579778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579816 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  579819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579838 */     GIR_RootConstrainSelectedInstOperands,
     /*  579839 */     // GIR_Coverage, 3834,
     /*  579839 */     GIR_EraseRootFromParent_Done,
     /*  579840 */   // Label 9450: @579840
     /*  579840 */   GIM_Try, /*On fail goto*//*Label 9451*/ GIMT_Encode4(579915), // Rule ID 3835 //
     /*  579845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  579853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  579856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  579859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  579862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  579865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  579868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579891 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  579891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  579894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579913 */     GIR_RootConstrainSelectedInstOperands,
     /*  579914 */     // GIR_Coverage, 3835,
     /*  579914 */     GIR_EraseRootFromParent_Done,
     /*  579915 */   // Label 9451: @579915
     /*  579915 */   GIM_Try, /*On fail goto*//*Label 9452*/ GIMT_Encode4(579990), // Rule ID 3838 //
     /*  579920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  579923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  579928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  579931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  579934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  579937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  579940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  579943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  579959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  579966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  579966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  579969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  579971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  579973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  579975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  579977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  579982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  579985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  579988 */     GIR_RootConstrainSelectedInstOperands,
     /*  579989 */     // GIR_Coverage, 3838,
     /*  579989 */     GIR_EraseRootFromParent_Done,
     /*  579990 */   // Label 9452: @579990
     /*  579990 */   GIM_Try, /*On fail goto*//*Label 9453*/ GIMT_Encode4(580065), // Rule ID 3839 //
     /*  579995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  579998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  580006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  580009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  580012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  580015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580041 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580063 */     GIR_RootConstrainSelectedInstOperands,
     /*  580064 */     // GIR_Coverage, 3839,
     /*  580064 */     GIR_EraseRootFromParent_Done,
     /*  580065 */   // Label 9453: @580065
     /*  580065 */   GIM_Try, /*On fail goto*//*Label 9454*/ GIMT_Encode4(580140), // Rule ID 3842 //
     /*  580070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580138 */     GIR_RootConstrainSelectedInstOperands,
     /*  580139 */     // GIR_Coverage, 3842,
     /*  580139 */     GIR_EraseRootFromParent_Done,
     /*  580140 */   // Label 9454: @580140
     /*  580140 */   GIM_Try, /*On fail goto*//*Label 9455*/ GIMT_Encode4(580215), // Rule ID 3843 //
     /*  580145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  580156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  580159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  580162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  580165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580191 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580213 */     GIR_RootConstrainSelectedInstOperands,
     /*  580214 */     // GIR_Coverage, 3843,
     /*  580214 */     GIR_EraseRootFromParent_Done,
     /*  580215 */   // Label 9455: @580215
     /*  580215 */   GIM_Try, /*On fail goto*//*Label 9456*/ GIMT_Encode4(580290), // Rule ID 3846 //
     /*  580220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580288 */     GIR_RootConstrainSelectedInstOperands,
     /*  580289 */     // GIR_Coverage, 3846,
     /*  580289 */     GIR_EraseRootFromParent_Done,
     /*  580290 */   // Label 9456: @580290
     /*  580290 */   GIM_Try, /*On fail goto*//*Label 9457*/ GIMT_Encode4(580365), // Rule ID 3847 //
     /*  580295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  580306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  580309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  580312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  580315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580341 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  580344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580363 */     GIR_RootConstrainSelectedInstOperands,
     /*  580364 */     // GIR_Coverage, 3847,
     /*  580364 */     GIR_EraseRootFromParent_Done,
     /*  580365 */   // Label 9457: @580365
     /*  580365 */   GIM_Try, /*On fail goto*//*Label 9458*/ GIMT_Encode4(580440), // Rule ID 3850 //
     /*  580370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  580416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  580419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580438 */     GIR_RootConstrainSelectedInstOperands,
     /*  580439 */     // GIR_Coverage, 3850,
     /*  580439 */     GIR_EraseRootFromParent_Done,
     /*  580440 */   // Label 9458: @580440
     /*  580440 */   GIM_Try, /*On fail goto*//*Label 9459*/ GIMT_Encode4(580515), // Rule ID 3851 //
     /*  580445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  580456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  580459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  580462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  580465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  580476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580491 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  580491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  580494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  580510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580513 */     GIR_RootConstrainSelectedInstOperands,
     /*  580514 */     // GIR_Coverage, 3851,
     /*  580514 */     GIR_EraseRootFromParent_Done,
     /*  580515 */   // Label 9459: @580515
     /*  580515 */   GIM_Try, /*On fail goto*//*Label 9460*/ GIMT_Encode4(580590), // Rule ID 3854 //
     /*  580520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580588 */     GIR_RootConstrainSelectedInstOperands,
     /*  580589 */     // GIR_Coverage, 3854,
     /*  580589 */     GIR_EraseRootFromParent_Done,
     /*  580590 */   // Label 9460: @580590
     /*  580590 */   GIM_Try, /*On fail goto*//*Label 9461*/ GIMT_Encode4(580665), // Rule ID 3855 //
     /*  580595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  580606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  580609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  580612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  580615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580641 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4),
     /*  580644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580663 */     GIR_RootConstrainSelectedInstOperands,
     /*  580664 */     // GIR_Coverage, 3855,
     /*  580664 */     GIR_EraseRootFromParent_Done,
     /*  580665 */   // Label 9461: @580665
     /*  580665 */   GIM_Try, /*On fail goto*//*Label 9462*/ GIMT_Encode4(580740), // Rule ID 3858 //
     /*  580670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580738 */     GIR_RootConstrainSelectedInstOperands,
     /*  580739 */     // GIR_Coverage, 3858,
     /*  580739 */     GIR_EraseRootFromParent_Done,
     /*  580740 */   // Label 9462: @580740
     /*  580740 */   GIM_Try, /*On fail goto*//*Label 9463*/ GIMT_Encode4(580815), // Rule ID 3859 //
     /*  580745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  580756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  580759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  580762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  580765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580791 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  580794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580813 */     GIR_RootConstrainSelectedInstOperands,
     /*  580814 */     // GIR_Coverage, 3859,
     /*  580814 */     GIR_EraseRootFromParent_Done,
     /*  580815 */   // Label 9463: @580815
     /*  580815 */   GIM_Try, /*On fail goto*//*Label 9464*/ GIMT_Encode4(580890), // Rule ID 3862 //
     /*  580820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  580866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580888 */     GIR_RootConstrainSelectedInstOperands,
     /*  580889 */     // GIR_Coverage, 3862,
     /*  580889 */     GIR_EraseRootFromParent_Done,
     /*  580890 */   // Label 9464: @580890
     /*  580890 */   GIM_Try, /*On fail goto*//*Label 9465*/ GIMT_Encode4(580965), // Rule ID 3863 //
     /*  580895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  580898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  580906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  580909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  580912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  580915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  580918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  580926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  580934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  580941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  580941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  580944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  580946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  580948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  580950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  580952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  580957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  580960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  580963 */     GIR_RootConstrainSelectedInstOperands,
     /*  580964 */     // GIR_Coverage, 3863,
     /*  580964 */     GIR_EraseRootFromParent_Done,
     /*  580965 */   // Label 9465: @580965
     /*  580965 */   GIM_Try, /*On fail goto*//*Label 9466*/ GIMT_Encode4(581040), // Rule ID 3866 //
     /*  580970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  580973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  580978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  580981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  580984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  580987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  580990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  580993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  580997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581038 */     GIR_RootConstrainSelectedInstOperands,
     /*  581039 */     // GIR_Coverage, 3866,
     /*  581039 */     GIR_EraseRootFromParent_Done,
     /*  581040 */   // Label 9466: @581040
     /*  581040 */   GIM_Try, /*On fail goto*//*Label 9467*/ GIMT_Encode4(581115), // Rule ID 3867 //
     /*  581045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  581056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  581059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  581062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  581065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581091 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581113 */     GIR_RootConstrainSelectedInstOperands,
     /*  581114 */     // GIR_Coverage, 3867,
     /*  581114 */     GIR_EraseRootFromParent_Done,
     /*  581115 */   // Label 9467: @581115
     /*  581115 */   GIM_Try, /*On fail goto*//*Label 9468*/ GIMT_Encode4(581190), // Rule ID 3870 //
     /*  581120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  581166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581188 */     GIR_RootConstrainSelectedInstOperands,
     /*  581189 */     // GIR_Coverage, 3870,
     /*  581189 */     GIR_EraseRootFromParent_Done,
     /*  581190 */   // Label 9468: @581190
     /*  581190 */   GIM_Try, /*On fail goto*//*Label 9469*/ GIMT_Encode4(581265), // Rule ID 3871 //
     /*  581195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  581206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  581209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  581212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  581215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581241 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  581241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  581260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581263 */     GIR_RootConstrainSelectedInstOperands,
     /*  581264 */     // GIR_Coverage, 3871,
     /*  581264 */     GIR_EraseRootFromParent_Done,
     /*  581265 */   // Label 9469: @581265
     /*  581265 */   GIM_Try, /*On fail goto*//*Label 9470*/ GIMT_Encode4(581340), // Rule ID 3874 //
     /*  581270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581316 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581338 */     GIR_RootConstrainSelectedInstOperands,
     /*  581339 */     // GIR_Coverage, 3874,
     /*  581339 */     GIR_EraseRootFromParent_Done,
     /*  581340 */   // Label 9470: @581340
     /*  581340 */   GIM_Try, /*On fail goto*//*Label 9471*/ GIMT_Encode4(581415), // Rule ID 3875 //
     /*  581345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  581356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  581359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  581362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  581365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581391 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2),
     /*  581394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581413 */     GIR_RootConstrainSelectedInstOperands,
     /*  581414 */     // GIR_Coverage, 3875,
     /*  581414 */     GIR_EraseRootFromParent_Done,
     /*  581415 */   // Label 9471: @581415
     /*  581415 */   GIM_Try, /*On fail goto*//*Label 9472*/ GIMT_Encode4(581490), // Rule ID 3878 //
     /*  581420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581488 */     GIR_RootConstrainSelectedInstOperands,
     /*  581489 */     // GIR_Coverage, 3878,
     /*  581489 */     GIR_EraseRootFromParent_Done,
     /*  581490 */   // Label 9472: @581490
     /*  581490 */   GIM_Try, /*On fail goto*//*Label 9473*/ GIMT_Encode4(581565), // Rule ID 3879 //
     /*  581495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  581506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  581509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  581512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  581515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581541 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1),
     /*  581544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581563 */     GIR_RootConstrainSelectedInstOperands,
     /*  581564 */     // GIR_Coverage, 3879,
     /*  581564 */     GIR_EraseRootFromParent_Done,
     /*  581565 */   // Label 9473: @581565
     /*  581565 */   GIM_Try, /*On fail goto*//*Label 9474*/ GIMT_Encode4(581640), // Rule ID 3882 //
     /*  581570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581638 */     GIR_RootConstrainSelectedInstOperands,
     /*  581639 */     // GIR_Coverage, 3882,
     /*  581639 */     GIR_EraseRootFromParent_Done,
     /*  581640 */   // Label 9474: @581640
     /*  581640 */   GIM_Try, /*On fail goto*//*Label 9475*/ GIMT_Encode4(581715), // Rule ID 3883 //
     /*  581645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  581656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  581659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  581662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  581665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  581684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581691 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2),
     /*  581694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581713 */     GIR_RootConstrainSelectedInstOperands,
     /*  581714 */     // GIR_Coverage, 3883,
     /*  581714 */     GIR_EraseRootFromParent_Done,
     /*  581715 */   // Label 9475: @581715
     /*  581715 */   GIM_Try, /*On fail goto*//*Label 9476*/ GIMT_Encode4(581790), // Rule ID 3886 //
     /*  581720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  581723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  581766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581788 */     GIR_RootConstrainSelectedInstOperands,
     /*  581789 */     // GIR_Coverage, 3886,
     /*  581789 */     GIR_EraseRootFromParent_Done,
     /*  581790 */   // Label 9476: @581790
     /*  581790 */   GIM_Try, /*On fail goto*//*Label 9477*/ GIMT_Encode4(581865), // Rule ID 3887 //
     /*  581795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  581798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  581806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  581809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  581812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  581815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  581826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  581834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581841 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  581841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4),
     /*  581844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  581860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581863 */     GIR_RootConstrainSelectedInstOperands,
     /*  581864 */     // GIR_Coverage, 3887,
     /*  581864 */     GIR_EraseRootFromParent_Done,
     /*  581865 */   // Label 9477: @581865
     /*  581865 */   GIM_Try, /*On fail goto*//*Label 9478*/ GIMT_Encode4(581940), // Rule ID 3890 //
     /*  581870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  581873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  581890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  581893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  581916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  581919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  581925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  581927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  581932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  581935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  581938 */     GIR_RootConstrainSelectedInstOperands,
     /*  581939 */     // GIR_Coverage, 3890,
     /*  581939 */     GIR_EraseRootFromParent_Done,
     /*  581940 */   // Label 9478: @581940
     /*  581940 */   GIM_Try, /*On fail goto*//*Label 9479*/ GIMT_Encode4(582015), // Rule ID 3891 //
     /*  581945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  581948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  581953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  581956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  581959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  581962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  581965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  581968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  581980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  581984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  581991 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  581991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8),
     /*  581994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  581996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  581998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582013 */     GIR_RootConstrainSelectedInstOperands,
     /*  582014 */     // GIR_Coverage, 3891,
     /*  582014 */     GIR_EraseRootFromParent_Done,
     /*  582015 */   // Label 9479: @582015
     /*  582015 */   GIM_Try, /*On fail goto*//*Label 9480*/ GIMT_Encode4(582090), // Rule ID 3894 //
     /*  582020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582088 */     GIR_RootConstrainSelectedInstOperands,
     /*  582089 */     // GIR_Coverage, 3894,
     /*  582089 */     GIR_EraseRootFromParent_Done,
     /*  582090 */   // Label 9480: @582090
     /*  582090 */   GIM_Try, /*On fail goto*//*Label 9481*/ GIMT_Encode4(582165), // Rule ID 3895 //
     /*  582095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  582106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  582109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  582112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582141 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582163 */     GIR_RootConstrainSelectedInstOperands,
     /*  582164 */     // GIR_Coverage, 3895,
     /*  582164 */     GIR_EraseRootFromParent_Done,
     /*  582165 */   // Label 9481: @582165
     /*  582165 */   GIM_Try, /*On fail goto*//*Label 9482*/ GIMT_Encode4(582240), // Rule ID 3898 //
     /*  582170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582238 */     GIR_RootConstrainSelectedInstOperands,
     /*  582239 */     // GIR_Coverage, 3898,
     /*  582239 */     GIR_EraseRootFromParent_Done,
     /*  582240 */   // Label 9482: @582240
     /*  582240 */   GIM_Try, /*On fail goto*//*Label 9483*/ GIMT_Encode4(582315), // Rule ID 3899 //
     /*  582245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  582256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  582259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  582262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582291 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11598:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582313 */     GIR_RootConstrainSelectedInstOperands,
     /*  582314 */     // GIR_Coverage, 3899,
     /*  582314 */     GIR_EraseRootFromParent_Done,
     /*  582315 */   // Label 9483: @582315
     /*  582315 */   GIM_Try, /*On fail goto*//*Label 9484*/ GIMT_Encode4(582390), // Rule ID 3902 //
     /*  582320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582366 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582388 */     GIR_RootConstrainSelectedInstOperands,
     /*  582389 */     // GIR_Coverage, 3902,
     /*  582389 */     GIR_EraseRootFromParent_Done,
     /*  582390 */   // Label 9484: @582390
     /*  582390 */   GIM_Try, /*On fail goto*//*Label 9485*/ GIMT_Encode4(582465), // Rule ID 3903 //
     /*  582395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  582406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  582409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  582412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  582444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582463 */     GIR_RootConstrainSelectedInstOperands,
     /*  582464 */     // GIR_Coverage, 3903,
     /*  582464 */     GIR_EraseRootFromParent_Done,
     /*  582465 */   // Label 9485: @582465
     /*  582465 */   GIM_Try, /*On fail goto*//*Label 9486*/ GIMT_Encode4(582540), // Rule ID 3906 //
     /*  582470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  582519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582538 */     GIR_RootConstrainSelectedInstOperands,
     /*  582539 */     // GIR_Coverage, 3906,
     /*  582539 */     GIR_EraseRootFromParent_Done,
     /*  582540 */   // Label 9486: @582540
     /*  582540 */   GIM_Try, /*On fail goto*//*Label 9487*/ GIMT_Encode4(582615), // Rule ID 3907 //
     /*  582545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  582556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  582559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  582562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  582580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582591 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  582594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582613 */     GIR_RootConstrainSelectedInstOperands,
     /*  582614 */     // GIR_Coverage, 3907,
     /*  582614 */     GIR_EraseRootFromParent_Done,
     /*  582615 */   // Label 9487: @582615
     /*  582615 */   GIM_Try, /*On fail goto*//*Label 9488*/ GIMT_Encode4(582690), // Rule ID 3910 //
     /*  582620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582666 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  582666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  582669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582688 */     GIR_RootConstrainSelectedInstOperands,
     /*  582689 */     // GIR_Coverage, 3910,
     /*  582689 */     GIR_EraseRootFromParent_Done,
     /*  582690 */   // Label 9488: @582690
     /*  582690 */   GIM_Try, /*On fail goto*//*Label 9489*/ GIMT_Encode4(582765), // Rule ID 3911 //
     /*  582695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  582706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  582709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  582712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  582726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  582730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582741 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  582741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  582744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  582760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582763 */     GIR_RootConstrainSelectedInstOperands,
     /*  582764 */     // GIR_Coverage, 3911,
     /*  582764 */     GIR_EraseRootFromParent_Done,
     /*  582765 */   // Label 9489: @582765
     /*  582765 */   GIM_Try, /*On fail goto*//*Label 9490*/ GIMT_Encode4(582840), // Rule ID 3914 //
     /*  582770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582816 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582838 */     GIR_RootConstrainSelectedInstOperands,
     /*  582839 */     // GIR_Coverage, 3914,
     /*  582839 */     GIR_EraseRootFromParent_Done,
     /*  582840 */   // Label 9490: @582840
     /*  582840 */   GIM_Try, /*On fail goto*//*Label 9491*/ GIMT_Encode4(582915), // Rule ID 3915 //
     /*  582845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  582856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  582859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  582862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  582865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  582868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582891 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  582891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4),
     /*  582894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582913 */     GIR_RootConstrainSelectedInstOperands,
     /*  582914 */     // GIR_Coverage, 3915,
     /*  582914 */     GIR_EraseRootFromParent_Done,
     /*  582915 */   // Label 9491: @582915
     /*  582915 */   GIM_Try, /*On fail goto*//*Label 9492*/ GIMT_Encode4(582990), // Rule ID 3918 //
     /*  582920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  582923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  582928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  582931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  582934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  582937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  582940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  582943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  582955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  582959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  582966 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  582966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  582969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  582971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  582973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  582975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  582977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  582982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  582985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  582988 */     GIR_RootConstrainSelectedInstOperands,
     /*  582989 */     // GIR_Coverage, 3918,
     /*  582989 */     GIR_EraseRootFromParent_Done,
     /*  582990 */   // Label 9492: @582990
     /*  582990 */   GIM_Try, /*On fail goto*//*Label 9493*/ GIMT_Encode4(583065), // Rule ID 3919 //
     /*  582995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  582998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  583006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  583009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  583012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583041 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11598:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583063 */     GIR_RootConstrainSelectedInstOperands,
     /*  583064 */     // GIR_Coverage, 3919,
     /*  583064 */     GIR_EraseRootFromParent_Done,
     /*  583065 */   // Label 9493: @583065
     /*  583065 */   GIM_Try, /*On fail goto*//*Label 9494*/ GIMT_Encode4(583140), // Rule ID 3922 //
     /*  583070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583116 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583138 */     GIR_RootConstrainSelectedInstOperands,
     /*  583139 */     // GIR_Coverage, 3922,
     /*  583139 */     GIR_EraseRootFromParent_Done,
     /*  583140 */   // Label 9494: @583140
     /*  583140 */   GIM_Try, /*On fail goto*//*Label 9495*/ GIMT_Encode4(583215), // Rule ID 3923 //
     /*  583145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  583156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  583159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  583162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583191 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583213 */     GIR_RootConstrainSelectedInstOperands,
     /*  583214 */     // GIR_Coverage, 3923,
     /*  583214 */     GIR_EraseRootFromParent_Done,
     /*  583215 */   // Label 9495: @583215
     /*  583215 */   GIM_Try, /*On fail goto*//*Label 9496*/ GIMT_Encode4(583290), // Rule ID 3926 //
     /*  583220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583266 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583288 */     GIR_RootConstrainSelectedInstOperands,
     /*  583289 */     // GIR_Coverage, 3926,
     /*  583289 */     GIR_EraseRootFromParent_Done,
     /*  583290 */   // Label 9496: @583290
     /*  583290 */   GIM_Try, /*On fail goto*//*Label 9497*/ GIMT_Encode4(583365), // Rule ID 3927 //
     /*  583295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  583306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  583309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  583312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583341 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583363 */     GIR_RootConstrainSelectedInstOperands,
     /*  583364 */     // GIR_Coverage, 3927,
     /*  583364 */     GIR_EraseRootFromParent_Done,
     /*  583365 */   // Label 9497: @583365
     /*  583365 */   GIM_Try, /*On fail goto*//*Label 9498*/ GIMT_Encode4(583440), // Rule ID 3930 //
     /*  583370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  583373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  583416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583438 */     GIR_RootConstrainSelectedInstOperands,
     /*  583439 */     // GIR_Coverage, 3930,
     /*  583439 */     GIR_EraseRootFromParent_Done,
     /*  583440 */   // Label 9498: @583440
     /*  583440 */   GIM_Try, /*On fail goto*//*Label 9499*/ GIMT_Encode4(583515), // Rule ID 3931 //
     /*  583445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  583448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  583456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  583459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  583462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  583491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  583494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  583510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583513 */     GIR_RootConstrainSelectedInstOperands,
     /*  583514 */     // GIR_Coverage, 3931,
     /*  583514 */     GIR_EraseRootFromParent_Done,
     /*  583515 */   // Label 9499: @583515
     /*  583515 */   GIM_Try, /*On fail goto*//*Label 9500*/ GIMT_Encode4(583590), // Rule ID 3934 //
     /*  583520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583566 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583588 */     GIR_RootConstrainSelectedInstOperands,
     /*  583589 */     // GIR_Coverage, 3934,
     /*  583589 */     GIR_EraseRootFromParent_Done,
     /*  583590 */   // Label 9500: @583590
     /*  583590 */   GIM_Try, /*On fail goto*//*Label 9501*/ GIMT_Encode4(583665), // Rule ID 3935 //
     /*  583595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  583606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  583609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  583612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583641 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11598:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2),
     /*  583644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583663 */     GIR_RootConstrainSelectedInstOperands,
     /*  583664 */     // GIR_Coverage, 3935,
     /*  583664 */     GIR_EraseRootFromParent_Done,
     /*  583665 */   // Label 9501: @583665
     /*  583665 */   GIM_Try, /*On fail goto*//*Label 9502*/ GIMT_Encode4(583740), // Rule ID 3938 //
     /*  583670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583716 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583738 */     GIR_RootConstrainSelectedInstOperands,
     /*  583739 */     // GIR_Coverage, 3938,
     /*  583739 */     GIR_EraseRootFromParent_Done,
     /*  583740 */   // Label 9502: @583740
     /*  583740 */   GIM_Try, /*On fail goto*//*Label 9503*/ GIMT_Encode4(583815), // Rule ID 3939 //
     /*  583745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  583756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  583759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  583762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  583780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11598:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1),
     /*  583794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583813 */     GIR_RootConstrainSelectedInstOperands,
     /*  583814 */     // GIR_Coverage, 3939,
     /*  583814 */     GIR_EraseRootFromParent_Done,
     /*  583815 */   // Label 9503: @583815
     /*  583815 */   GIM_Try, /*On fail goto*//*Label 9504*/ GIMT_Encode4(583890), // Rule ID 3942 //
     /*  583820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583866 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  583866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583888 */     GIR_RootConstrainSelectedInstOperands,
     /*  583889 */     // GIR_Coverage, 3942,
     /*  583889 */     GIR_EraseRootFromParent_Done,
     /*  583890 */   // Label 9504: @583890
     /*  583890 */   GIM_Try, /*On fail goto*//*Label 9505*/ GIMT_Encode4(583965), // Rule ID 3943 //
     /*  583895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  583898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  583906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  583909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  583912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  583915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  583918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  583926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  583930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  583934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  583941 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11598:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  583941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2),
     /*  583944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  583946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  583948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  583950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  583952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  583957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  583960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  583963 */     GIR_RootConstrainSelectedInstOperands,
     /*  583964 */     // GIR_Coverage, 3943,
     /*  583964 */     GIR_EraseRootFromParent_Done,
     /*  583965 */   // Label 9505: @583965
     /*  583965 */   GIM_Try, /*On fail goto*//*Label 9506*/ GIMT_Encode4(584040), // Rule ID 3946 //
     /*  583970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  583973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  583978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  583981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  583984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  583987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  583990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  583993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  583997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  584016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584038 */     GIR_RootConstrainSelectedInstOperands,
     /*  584039 */     // GIR_Coverage, 3946,
     /*  584039 */     GIR_EraseRootFromParent_Done,
     /*  584040 */   // Label 9506: @584040
     /*  584040 */   GIM_Try, /*On fail goto*//*Label 9507*/ GIMT_Encode4(584115), // Rule ID 3947 //
     /*  584045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  584048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub),
     /*  584053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  584056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  584059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  584062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  584065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  584084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584091 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11598:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  584091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4),
     /*  584094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  584110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584113 */     GIR_RootConstrainSelectedInstOperands,
     /*  584114 */     // GIR_Coverage, 3947,
     /*  584114 */     GIR_EraseRootFromParent_Done,
     /*  584115 */   // Label 9507: @584115
     /*  584115 */   GIM_Try, /*On fail goto*//*Label 9508*/ GIMT_Encode4(584190), // Rule ID 3952 //
     /*  584120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584188 */     GIR_RootConstrainSelectedInstOperands,
     /*  584189 */     // GIR_Coverage, 3952,
     /*  584189 */     GIR_EraseRootFromParent_Done,
     /*  584190 */   // Label 9508: @584190
     /*  584190 */   GIM_Try, /*On fail goto*//*Label 9509*/ GIMT_Encode4(584265), // Rule ID 3953 //
     /*  584195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  584206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  584209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  584212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  584215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584263 */     GIR_RootConstrainSelectedInstOperands,
     /*  584264 */     // GIR_Coverage, 3953,
     /*  584264 */     GIR_EraseRootFromParent_Done,
     /*  584265 */   // Label 9509: @584265
     /*  584265 */   GIM_Try, /*On fail goto*//*Label 9510*/ GIMT_Encode4(584340), // Rule ID 3962 //
     /*  584270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584338 */     GIR_RootConstrainSelectedInstOperands,
     /*  584339 */     // GIR_Coverage, 3962,
     /*  584339 */     GIR_EraseRootFromParent_Done,
     /*  584340 */   // Label 9510: @584340
     /*  584340 */   GIM_Try, /*On fail goto*//*Label 9511*/ GIMT_Encode4(584415), // Rule ID 3963 //
     /*  584345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  584356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  584359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  584362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  584365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  584394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584413 */     GIR_RootConstrainSelectedInstOperands,
     /*  584414 */     // GIR_Coverage, 3963,
     /*  584414 */     GIR_EraseRootFromParent_Done,
     /*  584415 */   // Label 9511: @584415
     /*  584415 */   GIM_Try, /*On fail goto*//*Label 9512*/ GIMT_Encode4(584490), // Rule ID 3972 //
     /*  584420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  584469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584488 */     GIR_RootConstrainSelectedInstOperands,
     /*  584489 */     // GIR_Coverage, 3972,
     /*  584489 */     GIR_EraseRootFromParent_Done,
     /*  584490 */   // Label 9512: @584490
     /*  584490 */   GIM_Try, /*On fail goto*//*Label 9513*/ GIMT_Encode4(584565), // Rule ID 3973 //
     /*  584495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  584506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  584509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  584512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  584515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  584544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584563 */     GIR_RootConstrainSelectedInstOperands,
     /*  584564 */     // GIR_Coverage, 3973,
     /*  584564 */     GIR_EraseRootFromParent_Done,
     /*  584565 */   // Label 9513: @584565
     /*  584565 */   GIM_Try, /*On fail goto*//*Label 9514*/ GIMT_Encode4(584640), // Rule ID 3982 //
     /*  584570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  584619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584638 */     GIR_RootConstrainSelectedInstOperands,
     /*  584639 */     // GIR_Coverage, 3982,
     /*  584639 */     GIR_EraseRootFromParent_Done,
     /*  584640 */   // Label 9514: @584640
     /*  584640 */   GIM_Try, /*On fail goto*//*Label 9515*/ GIMT_Encode4(584715), // Rule ID 3983 //
     /*  584645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  584656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  584659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  584662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  584665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  584684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584691 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  584694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584713 */     GIR_RootConstrainSelectedInstOperands,
     /*  584714 */     // GIR_Coverage, 3983,
     /*  584714 */     GIR_EraseRootFromParent_Done,
     /*  584715 */   // Label 9515: @584715
     /*  584715 */   GIM_Try, /*On fail goto*//*Label 9516*/ GIMT_Encode4(584790), // Rule ID 3992 //
     /*  584720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  584737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  584766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  584769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584788 */     GIR_RootConstrainSelectedInstOperands,
     /*  584789 */     // GIR_Coverage, 3992,
     /*  584789 */     GIR_EraseRootFromParent_Done,
     /*  584790 */   // Label 9516: @584790
     /*  584790 */   GIM_Try, /*On fail goto*//*Label 9517*/ GIMT_Encode4(584865), // Rule ID 3993 //
     /*  584795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  584806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  584809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  584812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  584815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  584830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  584834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584841 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  584841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  584844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  584860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584863 */     GIR_RootConstrainSelectedInstOperands,
     /*  584864 */     // GIR_Coverage, 3993,
     /*  584864 */     GIR_EraseRootFromParent_Done,
     /*  584865 */   // Label 9517: @584865
     /*  584865 */   GIM_Try, /*On fail goto*//*Label 9518*/ GIMT_Encode4(584940), // Rule ID 4002 //
     /*  584870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  584873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  584893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  584916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  584925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  584927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  584932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  584935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  584938 */     GIR_RootConstrainSelectedInstOperands,
     /*  584939 */     // GIR_Coverage, 4002,
     /*  584939 */     GIR_EraseRootFromParent_Done,
     /*  584940 */   // Label 9518: @584940
     /*  584940 */   GIM_Try, /*On fail goto*//*Label 9519*/ GIMT_Encode4(585015), // Rule ID 4003 //
     /*  584945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  584948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  584953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  584956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  584959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  584962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  584965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  584968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  584984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  584991 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  584991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4),
     /*  584994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  584996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  584998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585013 */     GIR_RootConstrainSelectedInstOperands,
     /*  585014 */     // GIR_Coverage, 4003,
     /*  585014 */     GIR_EraseRootFromParent_Done,
     /*  585015 */   // Label 9519: @585015
     /*  585015 */   GIM_Try, /*On fail goto*//*Label 9520*/ GIMT_Encode4(585090), // Rule ID 4012 //
     /*  585020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585088 */     GIR_RootConstrainSelectedInstOperands,
     /*  585089 */     // GIR_Coverage, 4012,
     /*  585089 */     GIR_EraseRootFromParent_Done,
     /*  585090 */   // Label 9520: @585090
     /*  585090 */   GIM_Try, /*On fail goto*//*Label 9521*/ GIMT_Encode4(585165), // Rule ID 4013 //
     /*  585095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  585106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  585109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  585112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  585115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585163 */     GIR_RootConstrainSelectedInstOperands,
     /*  585164 */     // GIR_Coverage, 4013,
     /*  585164 */     GIR_EraseRootFromParent_Done,
     /*  585165 */   // Label 9521: @585165
     /*  585165 */   GIM_Try, /*On fail goto*//*Label 9522*/ GIMT_Encode4(585240), // Rule ID 4022 //
     /*  585170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585238 */     GIR_RootConstrainSelectedInstOperands,
     /*  585239 */     // GIR_Coverage, 4022,
     /*  585239 */     GIR_EraseRootFromParent_Done,
     /*  585240 */   // Label 9522: @585240
     /*  585240 */   GIM_Try, /*On fail goto*//*Label 9523*/ GIMT_Encode4(585315), // Rule ID 4023 //
     /*  585245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  585256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  585259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  585262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  585265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585313 */     GIR_RootConstrainSelectedInstOperands,
     /*  585314 */     // GIR_Coverage, 4023,
     /*  585314 */     GIR_EraseRootFromParent_Done,
     /*  585315 */   // Label 9523: @585315
     /*  585315 */   GIM_Try, /*On fail goto*//*Label 9524*/ GIMT_Encode4(585390), // Rule ID 4032 //
     /*  585320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585388 */     GIR_RootConstrainSelectedInstOperands,
     /*  585389 */     // GIR_Coverage, 4032,
     /*  585389 */     GIR_EraseRootFromParent_Done,
     /*  585390 */   // Label 9524: @585390
     /*  585390 */   GIM_Try, /*On fail goto*//*Label 9525*/ GIMT_Encode4(585465), // Rule ID 4033 //
     /*  585395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  585406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  585409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  585412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  585415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585463 */     GIR_RootConstrainSelectedInstOperands,
     /*  585464 */     // GIR_Coverage, 4033,
     /*  585464 */     GIR_EraseRootFromParent_Done,
     /*  585465 */   // Label 9525: @585465
     /*  585465 */   GIM_Try, /*On fail goto*//*Label 9526*/ GIMT_Encode4(585540), // Rule ID 4042 //
     /*  585470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  585473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  585487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  585516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585538 */     GIR_RootConstrainSelectedInstOperands,
     /*  585539 */     // GIR_Coverage, 4042,
     /*  585539 */     GIR_EraseRootFromParent_Done,
     /*  585540 */   // Label 9526: @585540
     /*  585540 */   GIM_Try, /*On fail goto*//*Label 9527*/ GIMT_Encode4(585615), // Rule ID 4043 //
     /*  585545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  585548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  585556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  585559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  585562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  585565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  585580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585591 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  585591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  585594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  585610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585613 */     GIR_RootConstrainSelectedInstOperands,
     /*  585614 */     // GIR_Coverage, 4043,
     /*  585614 */     GIR_EraseRootFromParent_Done,
     /*  585615 */   // Label 9527: @585615
     /*  585615 */   GIM_Try, /*On fail goto*//*Label 9528*/ GIMT_Encode4(585690), // Rule ID 4052 //
     /*  585620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  585637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585688 */     GIR_RootConstrainSelectedInstOperands,
     /*  585689 */     // GIR_Coverage, 4052,
     /*  585689 */     GIR_EraseRootFromParent_Done,
     /*  585690 */   // Label 9528: @585690
     /*  585690 */   GIM_Try, /*On fail goto*//*Label 9529*/ GIMT_Encode4(585765), // Rule ID 4053 //
     /*  585695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  585706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  585709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  585712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  585715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585741 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2),
     /*  585744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585763 */     GIR_RootConstrainSelectedInstOperands,
     /*  585764 */     // GIR_Coverage, 4053,
     /*  585764 */     GIR_EraseRootFromParent_Done,
     /*  585765 */   // Label 9529: @585765
     /*  585765 */   GIM_Try, /*On fail goto*//*Label 9530*/ GIMT_Encode4(585840), // Rule ID 4062 //
     /*  585770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  585787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585838 */     GIR_RootConstrainSelectedInstOperands,
     /*  585839 */     // GIR_Coverage, 4062,
     /*  585839 */     GIR_EraseRootFromParent_Done,
     /*  585840 */   // Label 9530: @585840
     /*  585840 */   GIM_Try, /*On fail goto*//*Label 9531*/ GIMT_Encode4(585915), // Rule ID 4063 //
     /*  585845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  585856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  585859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  585862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  585865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  585868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  585884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  585891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1),
     /*  585894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585913 */     GIR_RootConstrainSelectedInstOperands,
     /*  585914 */     // GIR_Coverage, 4063,
     /*  585914 */     GIR_EraseRootFromParent_Done,
     /*  585915 */   // Label 9531: @585915
     /*  585915 */   GIM_Try, /*On fail goto*//*Label 9532*/ GIMT_Encode4(585990), // Rule ID 4072 //
     /*  585920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  585923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  585928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  585931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  585934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  585937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  585940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  585943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  585955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  585959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  585966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  585966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  585969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  585971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  585973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  585975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  585977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  585982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  585985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  585988 */     GIR_RootConstrainSelectedInstOperands,
     /*  585989 */     // GIR_Coverage, 4072,
     /*  585989 */     GIR_EraseRootFromParent_Done,
     /*  585990 */   // Label 9532: @585990
     /*  585990 */   GIM_Try, /*On fail goto*//*Label 9533*/ GIMT_Encode4(586065), // Rule ID 4073 //
     /*  585995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  585998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  586006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  586009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  586012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  586015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586041 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2),
     /*  586044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586063 */     GIR_RootConstrainSelectedInstOperands,
     /*  586064 */     // GIR_Coverage, 4073,
     /*  586064 */     GIR_EraseRootFromParent_Done,
     /*  586065 */   // Label 9533: @586065
     /*  586065 */   GIM_Try, /*On fail goto*//*Label 9534*/ GIMT_Encode4(586140), // Rule ID 4082 //
     /*  586070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  586073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  586116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586138 */     GIR_RootConstrainSelectedInstOperands,
     /*  586139 */     // GIR_Coverage, 4082,
     /*  586139 */     GIR_EraseRootFromParent_Done,
     /*  586140 */   // Label 9534: @586140
     /*  586140 */   GIM_Try, /*On fail goto*//*Label 9535*/ GIMT_Encode4(586215), // Rule ID 4083 //
     /*  586145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  586148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  586156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  586159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  586162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  586165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586191 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  586191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4),
     /*  586194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  586210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586213 */     GIR_RootConstrainSelectedInstOperands,
     /*  586214 */     // GIR_Coverage, 4083,
     /*  586214 */     GIR_EraseRootFromParent_Done,
     /*  586215 */   // Label 9535: @586215
     /*  586215 */   GIM_Try, /*On fail goto*//*Label 9536*/ GIMT_Encode4(586290), // Rule ID 4090 //
     /*  586220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586288 */     GIR_RootConstrainSelectedInstOperands,
     /*  586289 */     // GIR_Coverage, 4090,
     /*  586289 */     GIR_EraseRootFromParent_Done,
     /*  586290 */   // Label 9536: @586290
     /*  586290 */   GIM_Try, /*On fail goto*//*Label 9537*/ GIMT_Encode4(586365), // Rule ID 4091 //
     /*  586295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  586306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  586309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  586312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586341 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8),
     /*  586344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586363 */     GIR_RootConstrainSelectedInstOperands,
     /*  586364 */     // GIR_Coverage, 4091,
     /*  586364 */     GIR_EraseRootFromParent_Done,
     /*  586365 */   // Label 9537: @586365
     /*  586365 */   GIM_Try, /*On fail goto*//*Label 9538*/ GIMT_Encode4(586440), // Rule ID 4094 //
     /*  586370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  586419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586438 */     GIR_RootConstrainSelectedInstOperands,
     /*  586439 */     // GIR_Coverage, 4094,
     /*  586439 */     GIR_EraseRootFromParent_Done,
     /*  586440 */   // Label 9538: @586440
     /*  586440 */   GIM_Try, /*On fail goto*//*Label 9539*/ GIMT_Encode4(586515), // Rule ID 4095 //
     /*  586445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  586456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  586459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  586462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586491 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  586494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586513 */     GIR_RootConstrainSelectedInstOperands,
     /*  586514 */     // GIR_Coverage, 4095,
     /*  586514 */     GIR_EraseRootFromParent_Done,
     /*  586515 */   // Label 9539: @586515
     /*  586515 */   GIM_Try, /*On fail goto*//*Label 9540*/ GIMT_Encode4(586590), // Rule ID 4098 //
     /*  586520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  586537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  586569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586588 */     GIR_RootConstrainSelectedInstOperands,
     /*  586589 */     // GIR_Coverage, 4098,
     /*  586589 */     GIR_EraseRootFromParent_Done,
     /*  586590 */   // Label 9540: @586590
     /*  586590 */   GIM_Try, /*On fail goto*//*Label 9541*/ GIMT_Encode4(586665), // Rule ID 4099 //
     /*  586595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  586606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  586609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  586612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  586630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586641 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11576:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  586644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586663 */     GIR_RootConstrainSelectedInstOperands,
     /*  586664 */     // GIR_Coverage, 4099,
     /*  586664 */     GIR_EraseRootFromParent_Done,
     /*  586665 */   // Label 9541: @586665
     /*  586665 */   GIM_Try, /*On fail goto*//*Label 9542*/ GIMT_Encode4(586740), // Rule ID 4102 //
     /*  586670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  586687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  586719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586738 */     GIR_RootConstrainSelectedInstOperands,
     /*  586739 */     // GIR_Coverage, 4102,
     /*  586739 */     GIR_EraseRootFromParent_Done,
     /*  586740 */   // Label 9542: @586740
     /*  586740 */   GIM_Try, /*On fail goto*//*Label 9543*/ GIMT_Encode4(586815), // Rule ID 4103 //
     /*  586745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  586756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  586759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  586762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  586780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  586794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586813 */     GIR_RootConstrainSelectedInstOperands,
     /*  586814 */     // GIR_Coverage, 4103,
     /*  586814 */     GIR_EraseRootFromParent_Done,
     /*  586815 */   // Label 9543: @586815
     /*  586815 */   GIM_Try, /*On fail goto*//*Label 9544*/ GIMT_Encode4(586890), // Rule ID 4106 //
     /*  586820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  586837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  586866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  586869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586888 */     GIR_RootConstrainSelectedInstOperands,
     /*  586889 */     // GIR_Coverage, 4106,
     /*  586889 */     GIR_EraseRootFromParent_Done,
     /*  586890 */   // Label 9544: @586890
     /*  586890 */   GIM_Try, /*On fail goto*//*Label 9545*/ GIMT_Encode4(586965), // Rule ID 4107 //
     /*  586895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  586898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  586906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  586909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  586912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  586915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  586918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  586930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  586934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  586941 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  586941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  586944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  586946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  586948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  586950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  586952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  586957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  586960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  586963 */     GIR_RootConstrainSelectedInstOperands,
     /*  586964 */     // GIR_Coverage, 4107,
     /*  586964 */     GIR_EraseRootFromParent_Done,
     /*  586965 */   // Label 9545: @586965
     /*  586965 */   GIM_Try, /*On fail goto*//*Label 9546*/ GIMT_Encode4(587040), // Rule ID 4110 //
     /*  586970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  586973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  586978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  586981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  586984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  586987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  586990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  586993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  586997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  587016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587038 */     GIR_RootConstrainSelectedInstOperands,
     /*  587039 */     // GIR_Coverage, 4110,
     /*  587039 */     GIR_EraseRootFromParent_Done,
     /*  587040 */   // Label 9546: @587040
     /*  587040 */   GIM_Try, /*On fail goto*//*Label 9547*/ GIMT_Encode4(587115), // Rule ID 4111 //
     /*  587045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  587056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  587059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  587062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587091 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  587091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  587110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587113 */     GIR_RootConstrainSelectedInstOperands,
     /*  587114 */     // GIR_Coverage, 4111,
     /*  587114 */     GIR_EraseRootFromParent_Done,
     /*  587115 */   // Label 9547: @587115
     /*  587115 */   GIM_Try, /*On fail goto*//*Label 9548*/ GIMT_Encode4(587190), // Rule ID 4114 //
     /*  587120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587188 */     GIR_RootConstrainSelectedInstOperands,
     /*  587189 */     // GIR_Coverage, 4114,
     /*  587189 */     GIR_EraseRootFromParent_Done,
     /*  587190 */   // Label 9548: @587190
     /*  587190 */   GIM_Try, /*On fail goto*//*Label 9549*/ GIMT_Encode4(587265), // Rule ID 4115 //
     /*  587195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  587206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  587209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  587212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587241 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4),
     /*  587244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587263 */     GIR_RootConstrainSelectedInstOperands,
     /*  587264 */     // GIR_Coverage, 4115,
     /*  587264 */     GIR_EraseRootFromParent_Done,
     /*  587265 */   // Label 9549: @587265
     /*  587265 */   GIM_Try, /*On fail goto*//*Label 9550*/ GIMT_Encode4(587340), // Rule ID 4118 //
     /*  587270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587338 */     GIR_RootConstrainSelectedInstOperands,
     /*  587339 */     // GIR_Coverage, 4118,
     /*  587339 */     GIR_EraseRootFromParent_Done,
     /*  587340 */   // Label 9550: @587340
     /*  587340 */   GIM_Try, /*On fail goto*//*Label 9551*/ GIMT_Encode4(587415), // Rule ID 4119 //
     /*  587345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  587356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  587359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  587362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587391 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11576:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587413 */     GIR_RootConstrainSelectedInstOperands,
     /*  587414 */     // GIR_Coverage, 4119,
     /*  587414 */     GIR_EraseRootFromParent_Done,
     /*  587415 */   // Label 9551: @587415
     /*  587415 */   GIM_Try, /*On fail goto*//*Label 9552*/ GIMT_Encode4(587490), // Rule ID 4122 //
     /*  587420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  587437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587488 */     GIR_RootConstrainSelectedInstOperands,
     /*  587489 */     // GIR_Coverage, 4122,
     /*  587489 */     GIR_EraseRootFromParent_Done,
     /*  587490 */   // Label 9552: @587490
     /*  587490 */   GIM_Try, /*On fail goto*//*Label 9553*/ GIMT_Encode4(587565), // Rule ID 4123 //
     /*  587495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  587506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  587509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  587512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  587530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  587544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587563 */     GIR_RootConstrainSelectedInstOperands,
     /*  587564 */     // GIR_Coverage, 4123,
     /*  587564 */     GIR_EraseRootFromParent_Done,
     /*  587565 */   // Label 9553: @587565
     /*  587565 */   GIM_Try, /*On fail goto*//*Label 9554*/ GIMT_Encode4(587640), // Rule ID 4126 //
     /*  587570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  587587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587638 */     GIR_RootConstrainSelectedInstOperands,
     /*  587639 */     // GIR_Coverage, 4126,
     /*  587639 */     GIR_EraseRootFromParent_Done,
     /*  587640 */   // Label 9554: @587640
     /*  587640 */   GIM_Try, /*On fail goto*//*Label 9555*/ GIMT_Encode4(587715), // Rule ID 4127 //
     /*  587645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  587656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  587659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  587662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  587680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  587694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587713 */     GIR_RootConstrainSelectedInstOperands,
     /*  587714 */     // GIR_Coverage, 4127,
     /*  587714 */     GIR_EraseRootFromParent_Done,
     /*  587715 */   // Label 9555: @587715
     /*  587715 */   GIM_Try, /*On fail goto*//*Label 9556*/ GIMT_Encode4(587790), // Rule ID 4130 //
     /*  587720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  587723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  587737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  587766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587788 */     GIR_RootConstrainSelectedInstOperands,
     /*  587789 */     // GIR_Coverage, 4130,
     /*  587789 */     GIR_EraseRootFromParent_Done,
     /*  587790 */   // Label 9556: @587790
     /*  587790 */   GIM_Try, /*On fail goto*//*Label 9557*/ GIMT_Encode4(587865), // Rule ID 4131 //
     /*  587795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  587798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  587806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  587809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  587812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  587830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587841 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  587841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  587844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  587860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587863 */     GIR_RootConstrainSelectedInstOperands,
     /*  587864 */     // GIR_Coverage, 4131,
     /*  587864 */     GIR_EraseRootFromParent_Done,
     /*  587865 */   // Label 9557: @587865
     /*  587865 */   GIM_Try, /*On fail goto*//*Label 9558*/ GIMT_Encode4(587940), // Rule ID 4134 //
     /*  587870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  587873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  587887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  587890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  587893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  587916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  587925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  587927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  587932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  587935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  587938 */     GIR_RootConstrainSelectedInstOperands,
     /*  587939 */     // GIR_Coverage, 4134,
     /*  587939 */     GIR_EraseRootFromParent_Done,
     /*  587940 */   // Label 9558: @587940
     /*  587940 */   GIM_Try, /*On fail goto*//*Label 9559*/ GIMT_Encode4(588015), // Rule ID 4135 //
     /*  587945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  587948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  587953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  587956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  587959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  587962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  587965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  587968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  587980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  587984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  587991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11576:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  587991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2),
     /*  587994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  587996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  587998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588013 */     GIR_RootConstrainSelectedInstOperands,
     /*  588014 */     // GIR_Coverage, 4135,
     /*  588014 */     GIR_EraseRootFromParent_Done,
     /*  588015 */   // Label 9559: @588015
     /*  588015 */   GIM_Try, /*On fail goto*//*Label 9560*/ GIMT_Encode4(588090), // Rule ID 4138 //
     /*  588020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588088 */     GIR_RootConstrainSelectedInstOperands,
     /*  588089 */     // GIR_Coverage, 4138,
     /*  588089 */     GIR_EraseRootFromParent_Done,
     /*  588090 */   // Label 9560: @588090
     /*  588090 */   GIM_Try, /*On fail goto*//*Label 9561*/ GIMT_Encode4(588165), // Rule ID 4139 //
     /*  588095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  588106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  588109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  588112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11576:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1),
     /*  588144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588163 */     GIR_RootConstrainSelectedInstOperands,
     /*  588164 */     // GIR_Coverage, 4139,
     /*  588164 */     GIR_EraseRootFromParent_Done,
     /*  588165 */   // Label 9561: @588165
     /*  588165 */   GIM_Try, /*On fail goto*//*Label 9562*/ GIMT_Encode4(588240), // Rule ID 4142 //
     /*  588170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588238 */     GIR_RootConstrainSelectedInstOperands,
     /*  588239 */     // GIR_Coverage, 4142,
     /*  588239 */     GIR_EraseRootFromParent_Done,
     /*  588240 */   // Label 9562: @588240
     /*  588240 */   GIM_Try, /*On fail goto*//*Label 9563*/ GIMT_Encode4(588315), // Rule ID 4143 //
     /*  588245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  588256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  588259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  588262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  588280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588291 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11576:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2),
     /*  588294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588313 */     GIR_RootConstrainSelectedInstOperands,
     /*  588314 */     // GIR_Coverage, 4143,
     /*  588314 */     GIR_EraseRootFromParent_Done,
     /*  588315 */   // Label 9563: @588315
     /*  588315 */   GIM_Try, /*On fail goto*//*Label 9564*/ GIMT_Encode4(588390), // Rule ID 4146 //
     /*  588320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  588323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  588340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  588366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588388 */     GIR_RootConstrainSelectedInstOperands,
     /*  588389 */     // GIR_Coverage, 4146,
     /*  588389 */     GIR_EraseRootFromParent_Done,
     /*  588390 */   // Label 9564: @588390
     /*  588390 */   GIM_Try, /*On fail goto*//*Label 9565*/ GIMT_Encode4(588465), // Rule ID 4147 //
     /*  588395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  588398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w),
     /*  588403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  588406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  588409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  588412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  588415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  588430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  588434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588441 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11576:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADDU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  588441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4),
     /*  588444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  588460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588463 */     GIR_RootConstrainSelectedInstOperands,
     /*  588464 */     // GIR_Coverage, 4147,
     /*  588464 */     GIR_EraseRootFromParent_Done,
     /*  588465 */   // Label 9565: @588465
     /*  588465 */   GIM_Try, /*On fail goto*//*Label 9566*/ GIMT_Encode4(588540), // Rule ID 4152 //
     /*  588470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  588481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  588484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  588487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  588490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  588519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588538 */     GIR_RootConstrainSelectedInstOperands,
     /*  588539 */     // GIR_Coverage, 4152,
     /*  588539 */     GIR_EraseRootFromParent_Done,
     /*  588540 */   // Label 9566: @588540
     /*  588540 */   GIM_Try, /*On fail goto*//*Label 9567*/ GIMT_Encode4(588615), // Rule ID 4153 //
     /*  588545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  588556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  588559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  588562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  588565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588591 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8),
     /*  588594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588613 */     GIR_RootConstrainSelectedInstOperands,
     /*  588614 */     // GIR_Coverage, 4153,
     /*  588614 */     GIR_EraseRootFromParent_Done,
     /*  588615 */   // Label 9567: @588615
     /*  588615 */   GIM_Try, /*On fail goto*//*Label 9568*/ GIMT_Encode4(588690), // Rule ID 4162 //
     /*  588620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  588669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588688 */     GIR_RootConstrainSelectedInstOperands,
     /*  588689 */     // GIR_Coverage, 4162,
     /*  588689 */     GIR_EraseRootFromParent_Done,
     /*  588690 */   // Label 9568: @588690
     /*  588690 */   GIM_Try, /*On fail goto*//*Label 9569*/ GIMT_Encode4(588765), // Rule ID 4163 //
     /*  588695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  588706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  588709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  588712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  588715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  588744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588763 */     GIR_RootConstrainSelectedInstOperands,
     /*  588764 */     // GIR_Coverage, 4163,
     /*  588764 */     GIR_EraseRootFromParent_Done,
     /*  588765 */   // Label 9569: @588765
     /*  588765 */   GIM_Try, /*On fail goto*//*Label 9570*/ GIMT_Encode4(588840), // Rule ID 4172 //
     /*  588770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  588819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588838 */     GIR_RootConstrainSelectedInstOperands,
     /*  588839 */     // GIR_Coverage, 4172,
     /*  588839 */     GIR_EraseRootFromParent_Done,
     /*  588840 */   // Label 9570: @588840
     /*  588840 */   GIM_Try, /*On fail goto*//*Label 9571*/ GIMT_Encode4(588915), // Rule ID 4173 //
     /*  588845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  588856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  588859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  588862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  588865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  588868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588891 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  588891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  588894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588913 */     GIR_RootConstrainSelectedInstOperands,
     /*  588914 */     // GIR_Coverage, 4173,
     /*  588914 */     GIR_EraseRootFromParent_Done,
     /*  588915 */   // Label 9571: @588915
     /*  588915 */   GIM_Try, /*On fail goto*//*Label 9572*/ GIMT_Encode4(588990), // Rule ID 4182 //
     /*  588920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  588923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  588928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  588931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  588934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  588937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  588940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  588943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  588955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  588959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  588966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  588966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  588969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  588971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  588973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  588975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  588977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  588982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  588985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  588988 */     GIR_RootConstrainSelectedInstOperands,
     /*  588989 */     // GIR_Coverage, 4182,
     /*  588989 */     GIR_EraseRootFromParent_Done,
     /*  588990 */   // Label 9572: @588990
     /*  588990 */   GIM_Try, /*On fail goto*//*Label 9573*/ GIMT_Encode4(589065), // Rule ID 4183 //
     /*  588995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  588998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  589006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  589009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  589012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  589015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589063 */     GIR_RootConstrainSelectedInstOperands,
     /*  589064 */     // GIR_Coverage, 4183,
     /*  589064 */     GIR_EraseRootFromParent_Done,
     /*  589065 */   // Label 9573: @589065
     /*  589065 */   GIM_Try, /*On fail goto*//*Label 9574*/ GIMT_Encode4(589140), // Rule ID 4192 //
     /*  589070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589138 */     GIR_RootConstrainSelectedInstOperands,
     /*  589139 */     // GIR_Coverage, 4192,
     /*  589139 */     GIR_EraseRootFromParent_Done,
     /*  589140 */   // Label 9574: @589140
     /*  589140 */   GIM_Try, /*On fail goto*//*Label 9575*/ GIMT_Encode4(589215), // Rule ID 4193 //
     /*  589145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  589156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  589159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  589162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  589165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589191 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589213 */     GIR_RootConstrainSelectedInstOperands,
     /*  589214 */     // GIR_Coverage, 4193,
     /*  589214 */     GIR_EraseRootFromParent_Done,
     /*  589215 */   // Label 9575: @589215
     /*  589215 */   GIM_Try, /*On fail goto*//*Label 9576*/ GIMT_Encode4(589290), // Rule ID 4202 //
     /*  589220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  589266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589288 */     GIR_RootConstrainSelectedInstOperands,
     /*  589289 */     // GIR_Coverage, 4202,
     /*  589289 */     GIR_EraseRootFromParent_Done,
     /*  589290 */   // Label 9576: @589290
     /*  589290 */   GIM_Try, /*On fail goto*//*Label 9577*/ GIMT_Encode4(589365), // Rule ID 4203 //
     /*  589295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  589306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  589309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  589312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  589315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589341 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  589341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  589344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  589360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589363 */     GIR_RootConstrainSelectedInstOperands,
     /*  589364 */     // GIR_Coverage, 4203,
     /*  589364 */     GIR_EraseRootFromParent_Done,
     /*  589365 */   // Label 9577: @589365
     /*  589365 */   GIM_Try, /*On fail goto*//*Label 9578*/ GIMT_Encode4(589440), // Rule ID 4212 //
     /*  589370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589438 */     GIR_RootConstrainSelectedInstOperands,
     /*  589439 */     // GIR_Coverage, 4212,
     /*  589439 */     GIR_EraseRootFromParent_Done,
     /*  589440 */   // Label 9578: @589440
     /*  589440 */   GIM_Try, /*On fail goto*//*Label 9579*/ GIMT_Encode4(589515), // Rule ID 4213 //
     /*  589445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  589456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  589459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  589462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  589465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4),
     /*  589494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589513 */     GIR_RootConstrainSelectedInstOperands,
     /*  589514 */     // GIR_Coverage, 4213,
     /*  589514 */     GIR_EraseRootFromParent_Done,
     /*  589515 */   // Label 9579: @589515
     /*  589515 */   GIM_Try, /*On fail goto*//*Label 9580*/ GIMT_Encode4(589590), // Rule ID 4222 //
     /*  589520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589588 */     GIR_RootConstrainSelectedInstOperands,
     /*  589589 */     // GIR_Coverage, 4222,
     /*  589589 */     GIR_EraseRootFromParent_Done,
     /*  589590 */   // Label 9580: @589590
     /*  589590 */   GIM_Try, /*On fail goto*//*Label 9581*/ GIMT_Encode4(589665), // Rule ID 4223 //
     /*  589595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  589606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  589609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  589612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  589615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  589644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589663 */     GIR_RootConstrainSelectedInstOperands,
     /*  589664 */     // GIR_Coverage, 4223,
     /*  589664 */     GIR_EraseRootFromParent_Done,
     /*  589665 */   // Label 9581: @589665
     /*  589665 */   GIM_Try, /*On fail goto*//*Label 9582*/ GIMT_Encode4(589740), // Rule ID 4232 //
     /*  589670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589738 */     GIR_RootConstrainSelectedInstOperands,
     /*  589739 */     // GIR_Coverage, 4232,
     /*  589739 */     GIR_EraseRootFromParent_Done,
     /*  589740 */   // Label 9582: @589740
     /*  589740 */   GIM_Try, /*On fail goto*//*Label 9583*/ GIMT_Encode4(589815), // Rule ID 4233 //
     /*  589745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  589756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  589759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  589762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  589765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  589784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  589794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589813 */     GIR_RootConstrainSelectedInstOperands,
     /*  589814 */     // GIR_Coverage, 4233,
     /*  589814 */     GIR_EraseRootFromParent_Done,
     /*  589815 */   // Label 9583: @589815
     /*  589815 */   GIM_Try, /*On fail goto*//*Label 9584*/ GIMT_Encode4(589890), // Rule ID 4242 //
     /*  589820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  589866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589888 */     GIR_RootConstrainSelectedInstOperands,
     /*  589889 */     // GIR_Coverage, 4242,
     /*  589889 */     GIR_EraseRootFromParent_Done,
     /*  589890 */   // Label 9584: @589890
     /*  589890 */   GIM_Try, /*On fail goto*//*Label 9585*/ GIMT_Encode4(589965), // Rule ID 4243 //
     /*  589895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  589898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  589906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  589909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  589912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  589915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  589918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  589930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  589934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  589941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  589941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  589944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  589946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  589948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  589950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  589952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  589957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  589960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  589963 */     GIR_RootConstrainSelectedInstOperands,
     /*  589964 */     // GIR_Coverage, 4243,
     /*  589964 */     GIR_EraseRootFromParent_Done,
     /*  589965 */   // Label 9585: @589965
     /*  589965 */   GIM_Try, /*On fail goto*//*Label 9586*/ GIMT_Encode4(590040), // Rule ID 4252 //
     /*  589970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  589973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  589978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  589981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  589984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  589987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  589990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  589993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  589997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  590016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590038 */     GIR_RootConstrainSelectedInstOperands,
     /*  590039 */     // GIR_Coverage, 4252,
     /*  590039 */     GIR_EraseRootFromParent_Done,
     /*  590040 */   // Label 9586: @590040
     /*  590040 */   GIM_Try, /*On fail goto*//*Label 9587*/ GIMT_Encode4(590115), // Rule ID 4253 //
     /*  590045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  590056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  590059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  590062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  590065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  590091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  590110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590113 */     GIR_RootConstrainSelectedInstOperands,
     /*  590114 */     // GIR_Coverage, 4253,
     /*  590114 */     GIR_EraseRootFromParent_Done,
     /*  590115 */   // Label 9587: @590115
     /*  590115 */   GIM_Try, /*On fail goto*//*Label 9588*/ GIMT_Encode4(590190), // Rule ID 4262 //
     /*  590120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590188 */     GIR_RootConstrainSelectedInstOperands,
     /*  590189 */     // GIR_Coverage, 4262,
     /*  590189 */     GIR_EraseRootFromParent_Done,
     /*  590190 */   // Label 9588: @590190
     /*  590190 */   GIM_Try, /*On fail goto*//*Label 9589*/ GIMT_Encode4(590265), // Rule ID 4263 //
     /*  590195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  590206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  590209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  590212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  590215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590241 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2),
     /*  590244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590263 */     GIR_RootConstrainSelectedInstOperands,
     /*  590264 */     // GIR_Coverage, 4263,
     /*  590264 */     GIR_EraseRootFromParent_Done,
     /*  590265 */   // Label 9589: @590265
     /*  590265 */   GIM_Try, /*On fail goto*//*Label 9590*/ GIMT_Encode4(590340), // Rule ID 4272 //
     /*  590270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590338 */     GIR_RootConstrainSelectedInstOperands,
     /*  590339 */     // GIR_Coverage, 4272,
     /*  590339 */     GIR_EraseRootFromParent_Done,
     /*  590340 */   // Label 9590: @590340
     /*  590340 */   GIM_Try, /*On fail goto*//*Label 9591*/ GIMT_Encode4(590415), // Rule ID 4273 //
     /*  590345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  590356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  590359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  590362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  590365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1),
     /*  590394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590413 */     GIR_RootConstrainSelectedInstOperands,
     /*  590414 */     // GIR_Coverage, 4273,
     /*  590414 */     GIR_EraseRootFromParent_Done,
     /*  590415 */   // Label 9591: @590415
     /*  590415 */   GIM_Try, /*On fail goto*//*Label 9592*/ GIMT_Encode4(590490), // Rule ID 4282 //
     /*  590420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590488 */     GIR_RootConstrainSelectedInstOperands,
     /*  590489 */     // GIR_Coverage, 4282,
     /*  590489 */     GIR_EraseRootFromParent_Done,
     /*  590490 */   // Label 9592: @590490
     /*  590490 */   GIM_Try, /*On fail goto*//*Label 9593*/ GIMT_Encode4(590565), // Rule ID 4283 //
     /*  590495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  590506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  590509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  590512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  590515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  590534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590541 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2),
     /*  590544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590563 */     GIR_RootConstrainSelectedInstOperands,
     /*  590564 */     // GIR_Coverage, 4283,
     /*  590564 */     GIR_EraseRootFromParent_Done,
     /*  590565 */   // Label 9593: @590565
     /*  590565 */   GIM_Try, /*On fail goto*//*Label 9594*/ GIMT_Encode4(590640), // Rule ID 4292 //
     /*  590570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  590573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590616 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  590616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590638 */     GIR_RootConstrainSelectedInstOperands,
     /*  590639 */     // GIR_Coverage, 4292,
     /*  590639 */     GIR_EraseRootFromParent_Done,
     /*  590640 */   // Label 9594: @590640
     /*  590640 */   GIM_Try, /*On fail goto*//*Label 9595*/ GIMT_Encode4(590715), // Rule ID 4293 //
     /*  590645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  590648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  590656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  590659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  590662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  590665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  590680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  590684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590691 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  590691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4),
     /*  590694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  590710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590713 */     GIR_RootConstrainSelectedInstOperands,
     /*  590714 */     // GIR_Coverage, 4293,
     /*  590714 */     GIR_EraseRootFromParent_Done,
     /*  590715 */   // Label 9595: @590715
     /*  590715 */   GIM_Try, /*On fail goto*//*Label 9596*/ GIMT_Encode4(590790), // Rule ID 4300 //
     /*  590720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  590769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590788 */     GIR_RootConstrainSelectedInstOperands,
     /*  590789 */     // GIR_Coverage, 4300,
     /*  590789 */     GIR_EraseRootFromParent_Done,
     /*  590790 */   // Label 9596: @590790
     /*  590790 */   GIM_Try, /*On fail goto*//*Label 9597*/ GIMT_Encode4(590865), // Rule ID 4301 //
     /*  590795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  590806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  590809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  590812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590841 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8),
     /*  590844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590863 */     GIR_RootConstrainSelectedInstOperands,
     /*  590864 */     // GIR_Coverage, 4301,
     /*  590864 */     GIR_EraseRootFromParent_Done,
     /*  590865 */   // Label 9597: @590865
     /*  590865 */   GIM_Try, /*On fail goto*//*Label 9598*/ GIMT_Encode4(590940), // Rule ID 4304 //
     /*  590870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  590873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  590890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  590893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  590916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  590919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  590925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  590927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  590932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  590935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  590938 */     GIR_RootConstrainSelectedInstOperands,
     /*  590939 */     // GIR_Coverage, 4304,
     /*  590939 */     GIR_EraseRootFromParent_Done,
     /*  590940 */   // Label 9598: @590940
     /*  590940 */   GIM_Try, /*On fail goto*//*Label 9599*/ GIMT_Encode4(591015), // Rule ID 4305 //
     /*  590945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  590948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  590953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  590956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  590959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  590962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  590965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  590968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  590980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  590984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  590991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  590991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  590994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  590996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  590998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591013 */     GIR_RootConstrainSelectedInstOperands,
     /*  591014 */     // GIR_Coverage, 4305,
     /*  591014 */     GIR_EraseRootFromParent_Done,
     /*  591015 */   // Label 9599: @591015
     /*  591015 */   GIM_Try, /*On fail goto*//*Label 9600*/ GIMT_Encode4(591090), // Rule ID 4308 //
     /*  591020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591088 */     GIR_RootConstrainSelectedInstOperands,
     /*  591089 */     // GIR_Coverage, 4308,
     /*  591089 */     GIR_EraseRootFromParent_Done,
     /*  591090 */   // Label 9600: @591090
     /*  591090 */   GIM_Try, /*On fail goto*//*Label 9601*/ GIMT_Encode4(591165), // Rule ID 4309 //
     /*  591095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  591106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  591109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  591112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11604:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591163 */     GIR_RootConstrainSelectedInstOperands,
     /*  591164 */     // GIR_Coverage, 4309,
     /*  591164 */     GIR_EraseRootFromParent_Done,
     /*  591165 */   // Label 9601: @591165
     /*  591165 */   GIM_Try, /*On fail goto*//*Label 9602*/ GIMT_Encode4(591240), // Rule ID 4312 //
     /*  591170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591238 */     GIR_RootConstrainSelectedInstOperands,
     /*  591239 */     // GIR_Coverage, 4312,
     /*  591239 */     GIR_EraseRootFromParent_Done,
     /*  591240 */   // Label 9602: @591240
     /*  591240 */   GIM_Try, /*On fail goto*//*Label 9603*/ GIMT_Encode4(591315), // Rule ID 4313 //
     /*  591245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  591256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  591259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  591262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591313 */     GIR_RootConstrainSelectedInstOperands,
     /*  591314 */     // GIR_Coverage, 4313,
     /*  591314 */     GIR_EraseRootFromParent_Done,
     /*  591315 */   // Label 9603: @591315
     /*  591315 */   GIM_Try, /*On fail goto*//*Label 9604*/ GIMT_Encode4(591390), // Rule ID 4316 //
     /*  591320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591388 */     GIR_RootConstrainSelectedInstOperands,
     /*  591389 */     // GIR_Coverage, 4316,
     /*  591389 */     GIR_EraseRootFromParent_Done,
     /*  591390 */   // Label 9604: @591390
     /*  591390 */   GIM_Try, /*On fail goto*//*Label 9605*/ GIMT_Encode4(591465), // Rule ID 4317 //
     /*  591395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  591406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  591409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  591412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  591430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591441 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  591444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591463 */     GIR_RootConstrainSelectedInstOperands,
     /*  591464 */     // GIR_Coverage, 4317,
     /*  591464 */     GIR_EraseRootFromParent_Done,
     /*  591465 */   // Label 9605: @591465
     /*  591465 */   GIM_Try, /*On fail goto*//*Label 9606*/ GIMT_Encode4(591540), // Rule ID 4320 //
     /*  591470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  591516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  591519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591538 */     GIR_RootConstrainSelectedInstOperands,
     /*  591539 */     // GIR_Coverage, 4320,
     /*  591539 */     GIR_EraseRootFromParent_Done,
     /*  591540 */   // Label 9606: @591540
     /*  591540 */   GIM_Try, /*On fail goto*//*Label 9607*/ GIMT_Encode4(591615), // Rule ID 4321 //
     /*  591545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  591556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  591559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  591562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  591580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  591591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  591594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  591610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591613 */     GIR_RootConstrainSelectedInstOperands,
     /*  591614 */     // GIR_Coverage, 4321,
     /*  591614 */     GIR_EraseRootFromParent_Done,
     /*  591615 */   // Label 9607: @591615
     /*  591615 */   GIM_Try, /*On fail goto*//*Label 9608*/ GIMT_Encode4(591690), // Rule ID 4324 //
     /*  591620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591688 */     GIR_RootConstrainSelectedInstOperands,
     /*  591689 */     // GIR_Coverage, 4324,
     /*  591689 */     GIR_EraseRootFromParent_Done,
     /*  591690 */   // Label 9608: @591690
     /*  591690 */   GIM_Try, /*On fail goto*//*Label 9609*/ GIMT_Encode4(591765), // Rule ID 4325 //
     /*  591695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  591706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  591709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  591712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591741 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4),
     /*  591744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591763 */     GIR_RootConstrainSelectedInstOperands,
     /*  591764 */     // GIR_Coverage, 4325,
     /*  591764 */     GIR_EraseRootFromParent_Done,
     /*  591765 */   // Label 9609: @591765
     /*  591765 */   GIM_Try, /*On fail goto*//*Label 9610*/ GIMT_Encode4(591840), // Rule ID 4328 //
     /*  591770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591838 */     GIR_RootConstrainSelectedInstOperands,
     /*  591839 */     // GIR_Coverage, 4328,
     /*  591839 */     GIR_EraseRootFromParent_Done,
     /*  591840 */   // Label 9610: @591840
     /*  591840 */   GIM_Try, /*On fail goto*//*Label 9611*/ GIMT_Encode4(591915), // Rule ID 4329 //
     /*  591845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  591856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  591859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  591862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  591865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  591868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  591880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591891 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11604:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  591891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  591894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591913 */     GIR_RootConstrainSelectedInstOperands,
     /*  591914 */     // GIR_Coverage, 4329,
     /*  591914 */     GIR_EraseRootFromParent_Done,
     /*  591915 */   // Label 9611: @591915
     /*  591915 */   GIM_Try, /*On fail goto*//*Label 9612*/ GIMT_Encode4(591990), // Rule ID 4332 //
     /*  591920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  591923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  591928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  591931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  591934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  591937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  591940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  591943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  591955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  591959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  591966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  591966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  591969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  591971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  591973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  591975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  591977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  591982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  591985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  591988 */     GIR_RootConstrainSelectedInstOperands,
     /*  591989 */     // GIR_Coverage, 4332,
     /*  591989 */     GIR_EraseRootFromParent_Done,
     /*  591990 */   // Label 9612: @591990
     /*  591990 */   GIM_Try, /*On fail goto*//*Label 9613*/ GIMT_Encode4(592065), // Rule ID 4333 //
     /*  591995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  591998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  592006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  592009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  592012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592063 */     GIR_RootConstrainSelectedInstOperands,
     /*  592064 */     // GIR_Coverage, 4333,
     /*  592064 */     GIR_EraseRootFromParent_Done,
     /*  592065 */   // Label 9613: @592065
     /*  592065 */   GIM_Try, /*On fail goto*//*Label 9614*/ GIMT_Encode4(592140), // Rule ID 4336 //
     /*  592070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592138 */     GIR_RootConstrainSelectedInstOperands,
     /*  592139 */     // GIR_Coverage, 4336,
     /*  592139 */     GIR_EraseRootFromParent_Done,
     /*  592140 */   // Label 9614: @592140
     /*  592140 */   GIM_Try, /*On fail goto*//*Label 9615*/ GIMT_Encode4(592215), // Rule ID 4337 //
     /*  592145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  592156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  592159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  592162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592213 */     GIR_RootConstrainSelectedInstOperands,
     /*  592214 */     // GIR_Coverage, 4337,
     /*  592214 */     GIR_EraseRootFromParent_Done,
     /*  592215 */   // Label 9615: @592215
     /*  592215 */   GIM_Try, /*On fail goto*//*Label 9616*/ GIMT_Encode4(592290), // Rule ID 4340 //
     /*  592220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  592266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592288 */     GIR_RootConstrainSelectedInstOperands,
     /*  592289 */     // GIR_Coverage, 4340,
     /*  592289 */     GIR_EraseRootFromParent_Done,
     /*  592290 */   // Label 9616: @592290
     /*  592290 */   GIM_Try, /*On fail goto*//*Label 9617*/ GIMT_Encode4(592365), // Rule ID 4341 //
     /*  592295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  592298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  592306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  592309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  592312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592341 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  592341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  592360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592363 */     GIR_RootConstrainSelectedInstOperands,
     /*  592364 */     // GIR_Coverage, 4341,
     /*  592364 */     GIR_EraseRootFromParent_Done,
     /*  592365 */   // Label 9617: @592365
     /*  592365 */   GIM_Try, /*On fail goto*//*Label 9618*/ GIMT_Encode4(592440), // Rule ID 4344 //
     /*  592370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592438 */     GIR_RootConstrainSelectedInstOperands,
     /*  592439 */     // GIR_Coverage, 4344,
     /*  592439 */     GIR_EraseRootFromParent_Done,
     /*  592440 */   // Label 9618: @592440
     /*  592440 */   GIM_Try, /*On fail goto*//*Label 9619*/ GIMT_Encode4(592515), // Rule ID 4345 //
     /*  592445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  592456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  592459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  592462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592491 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11604:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2),
     /*  592494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592513 */     GIR_RootConstrainSelectedInstOperands,
     /*  592514 */     // GIR_Coverage, 4345,
     /*  592514 */     GIR_EraseRootFromParent_Done,
     /*  592515 */   // Label 9619: @592515
     /*  592515 */   GIM_Try, /*On fail goto*//*Label 9620*/ GIMT_Encode4(592590), // Rule ID 4348 //
     /*  592520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592588 */     GIR_RootConstrainSelectedInstOperands,
     /*  592589 */     // GIR_Coverage, 4348,
     /*  592589 */     GIR_EraseRootFromParent_Done,
     /*  592590 */   // Label 9620: @592590
     /*  592590 */   GIM_Try, /*On fail goto*//*Label 9621*/ GIMT_Encode4(592665), // Rule ID 4349 //
     /*  592595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  592606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  592609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  592612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  592630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11604:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1),
     /*  592644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592663 */     GIR_RootConstrainSelectedInstOperands,
     /*  592664 */     // GIR_Coverage, 4349,
     /*  592664 */     GIR_EraseRootFromParent_Done,
     /*  592665 */   // Label 9621: @592665
     /*  592665 */   GIM_Try, /*On fail goto*//*Label 9622*/ GIMT_Encode4(592740), // Rule ID 4352 //
     /*  592670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592738 */     GIR_RootConstrainSelectedInstOperands,
     /*  592739 */     // GIR_Coverage, 4352,
     /*  592739 */     GIR_EraseRootFromParent_Done,
     /*  592740 */   // Label 9622: @592740
     /*  592740 */   GIM_Try, /*On fail goto*//*Label 9623*/ GIMT_Encode4(592815), // Rule ID 4353 //
     /*  592745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  592756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  592759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  592762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  592780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592791 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11604:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2),
     /*  592794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592813 */     GIR_RootConstrainSelectedInstOperands,
     /*  592814 */     // GIR_Coverage, 4353,
     /*  592814 */     GIR_EraseRootFromParent_Done,
     /*  592815 */   // Label 9623: @592815
     /*  592815 */   GIM_Try, /*On fail goto*//*Label 9624*/ GIMT_Encode4(592890), // Rule ID 4356 //
     /*  592820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  592823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  592840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  592866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592888 */     GIR_RootConstrainSelectedInstOperands,
     /*  592889 */     // GIR_Coverage, 4356,
     /*  592889 */     GIR_EraseRootFromParent_Done,
     /*  592890 */   // Label 9624: @592890
     /*  592890 */   GIM_Try, /*On fail goto*//*Label 9625*/ GIMT_Encode4(592965), // Rule ID 4357 //
     /*  592895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  592898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w),
     /*  592903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  592906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  592909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  592912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  592915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  592918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  592930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  592934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  592941 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11604:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUBU_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  592941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4),
     /*  592944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  592946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  592948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  592950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  592952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  592957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  592960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  592963 */     GIR_RootConstrainSelectedInstOperands,
     /*  592964 */     // GIR_Coverage, 4357,
     /*  592964 */     GIR_EraseRootFromParent_Done,
     /*  592965 */   // Label 9625: @592965
     /*  592965 */   GIM_Try, /*On fail goto*//*Label 9626*/ GIMT_Encode4(593040), // Rule ID 4362 //
     /*  592970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  592973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  592978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  592981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  592984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  592987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  592990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  592993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  592997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593016 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593038 */     GIR_RootConstrainSelectedInstOperands,
     /*  593039 */     // GIR_Coverage, 4362,
     /*  593039 */     GIR_EraseRootFromParent_Done,
     /*  593040 */   // Label 9626: @593040
     /*  593040 */   GIM_Try, /*On fail goto*//*Label 9627*/ GIMT_Encode4(593115), // Rule ID 4363 //
     /*  593045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  593056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  593059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  593062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  593065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593091 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8),
     /*  593094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593113 */     GIR_RootConstrainSelectedInstOperands,
     /*  593114 */     // GIR_Coverage, 4363,
     /*  593114 */     GIR_EraseRootFromParent_Done,
     /*  593115 */   // Label 9627: @593115
     /*  593115 */   GIM_Try, /*On fail goto*//*Label 9628*/ GIMT_Encode4(593190), // Rule ID 4372 //
     /*  593120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593188 */     GIR_RootConstrainSelectedInstOperands,
     /*  593189 */     // GIR_Coverage, 4372,
     /*  593189 */     GIR_EraseRootFromParent_Done,
     /*  593190 */   // Label 9628: @593190
     /*  593190 */   GIM_Try, /*On fail goto*//*Label 9629*/ GIMT_Encode4(593265), // Rule ID 4373 //
     /*  593195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  593206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  593209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  593212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  593215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593241 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593263 */     GIR_RootConstrainSelectedInstOperands,
     /*  593264 */     // GIR_Coverage, 4373,
     /*  593264 */     GIR_EraseRootFromParent_Done,
     /*  593265 */   // Label 9629: @593265
     /*  593265 */   GIM_Try, /*On fail goto*//*Label 9630*/ GIMT_Encode4(593340), // Rule ID 4382 //
     /*  593270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593316 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593338 */     GIR_RootConstrainSelectedInstOperands,
     /*  593339 */     // GIR_Coverage, 4382,
     /*  593339 */     GIR_EraseRootFromParent_Done,
     /*  593340 */   // Label 9630: @593340
     /*  593340 */   GIM_Try, /*On fail goto*//*Label 9631*/ GIMT_Encode4(593415), // Rule ID 4383 //
     /*  593345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  593356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  593359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  593362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  593365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593391 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  593394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593413 */     GIR_RootConstrainSelectedInstOperands,
     /*  593414 */     // GIR_Coverage, 4383,
     /*  593414 */     GIR_EraseRootFromParent_Done,
     /*  593415 */   // Label 9631: @593415
     /*  593415 */   GIM_Try, /*On fail goto*//*Label 9632*/ GIMT_Encode4(593490), // Rule ID 4392 //
     /*  593420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  593469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593488 */     GIR_RootConstrainSelectedInstOperands,
     /*  593489 */     // GIR_Coverage, 4392,
     /*  593489 */     GIR_EraseRootFromParent_Done,
     /*  593490 */   // Label 9632: @593490
     /*  593490 */   GIM_Try, /*On fail goto*//*Label 9633*/ GIMT_Encode4(593565), // Rule ID 4393 //
     /*  593495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  593506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  593509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  593512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  593515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593541 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  593544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593563 */     GIR_RootConstrainSelectedInstOperands,
     /*  593564 */     // GIR_Coverage, 4393,
     /*  593564 */     GIR_EraseRootFromParent_Done,
     /*  593565 */   // Label 9633: @593565
     /*  593565 */   GIM_Try, /*On fail goto*//*Label 9634*/ GIMT_Encode4(593640), // Rule ID 4402 //
     /*  593570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593616 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  593619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593638 */     GIR_RootConstrainSelectedInstOperands,
     /*  593639 */     // GIR_Coverage, 4402,
     /*  593639 */     GIR_EraseRootFromParent_Done,
     /*  593640 */   // Label 9634: @593640
     /*  593640 */   GIM_Try, /*On fail goto*//*Label 9635*/ GIMT_Encode4(593715), // Rule ID 4403 //
     /*  593645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  593656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  593659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  593662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  593665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  593684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593691 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  593694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593713 */     GIR_RootConstrainSelectedInstOperands,
     /*  593714 */     // GIR_Coverage, 4403,
     /*  593714 */     GIR_EraseRootFromParent_Done,
     /*  593715 */   // Label 9635: @593715
     /*  593715 */   GIM_Try, /*On fail goto*//*Label 9636*/ GIMT_Encode4(593790), // Rule ID 4412 //
     /*  593720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593766 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  593766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  593769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593788 */     GIR_RootConstrainSelectedInstOperands,
     /*  593789 */     // GIR_Coverage, 4412,
     /*  593789 */     GIR_EraseRootFromParent_Done,
     /*  593790 */   // Label 9636: @593790
     /*  593790 */   GIM_Try, /*On fail goto*//*Label 9637*/ GIMT_Encode4(593865), // Rule ID 4413 //
     /*  593795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  593806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  593809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  593812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  593815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  593830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  593834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593841 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  593841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  593844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  593860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593863 */     GIR_RootConstrainSelectedInstOperands,
     /*  593864 */     // GIR_Coverage, 4413,
     /*  593864 */     GIR_EraseRootFromParent_Done,
     /*  593865 */   // Label 9637: @593865
     /*  593865 */   GIM_Try, /*On fail goto*//*Label 9638*/ GIMT_Encode4(593940), // Rule ID 4422 //
     /*  593870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  593873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  593893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593916 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  593916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  593925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  593927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  593932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  593935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  593938 */     GIR_RootConstrainSelectedInstOperands,
     /*  593939 */     // GIR_Coverage, 4422,
     /*  593939 */     GIR_EraseRootFromParent_Done,
     /*  593940 */   // Label 9638: @593940
     /*  593940 */   GIM_Try, /*On fail goto*//*Label 9639*/ GIMT_Encode4(594015), // Rule ID 4423 //
     /*  593945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  593948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  593953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  593956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  593959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  593962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  593965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  593968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  593984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  593991 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  593991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4),
     /*  593994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  593996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  593998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594013 */     GIR_RootConstrainSelectedInstOperands,
     /*  594014 */     // GIR_Coverage, 4423,
     /*  594014 */     GIR_EraseRootFromParent_Done,
     /*  594015 */   // Label 9639: @594015
     /*  594015 */   GIM_Try, /*On fail goto*//*Label 9640*/ GIMT_Encode4(594090), // Rule ID 4432 //
     /*  594020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594066 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594088 */     GIR_RootConstrainSelectedInstOperands,
     /*  594089 */     // GIR_Coverage, 4432,
     /*  594089 */     GIR_EraseRootFromParent_Done,
     /*  594090 */   // Label 9640: @594090
     /*  594090 */   GIM_Try, /*On fail goto*//*Label 9641*/ GIMT_Encode4(594165), // Rule ID 4433 //
     /*  594095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  594106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  594109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  594112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  594115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594163 */     GIR_RootConstrainSelectedInstOperands,
     /*  594164 */     // GIR_Coverage, 4433,
     /*  594164 */     GIR_EraseRootFromParent_Done,
     /*  594165 */   // Label 9641: @594165
     /*  594165 */   GIM_Try, /*On fail goto*//*Label 9642*/ GIMT_Encode4(594240), // Rule ID 4442 //
     /*  594170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594238 */     GIR_RootConstrainSelectedInstOperands,
     /*  594239 */     // GIR_Coverage, 4442,
     /*  594239 */     GIR_EraseRootFromParent_Done,
     /*  594240 */   // Label 9642: @594240
     /*  594240 */   GIM_Try, /*On fail goto*//*Label 9643*/ GIMT_Encode4(594315), // Rule ID 4443 //
     /*  594245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  594256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  594259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  594262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  594265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594291 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594313 */     GIR_RootConstrainSelectedInstOperands,
     /*  594314 */     // GIR_Coverage, 4443,
     /*  594314 */     GIR_EraseRootFromParent_Done,
     /*  594315 */   // Label 9643: @594315
     /*  594315 */   GIM_Try, /*On fail goto*//*Label 9644*/ GIMT_Encode4(594390), // Rule ID 4452 //
     /*  594320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594388 */     GIR_RootConstrainSelectedInstOperands,
     /*  594389 */     // GIR_Coverage, 4452,
     /*  594389 */     GIR_EraseRootFromParent_Done,
     /*  594390 */   // Label 9644: @594390
     /*  594390 */   GIM_Try, /*On fail goto*//*Label 9645*/ GIMT_Encode4(594465), // Rule ID 4453 //
     /*  594395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  594406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  594409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  594412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  594415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594463 */     GIR_RootConstrainSelectedInstOperands,
     /*  594464 */     // GIR_Coverage, 4453,
     /*  594464 */     GIR_EraseRootFromParent_Done,
     /*  594465 */   // Label 9645: @594465
     /*  594465 */   GIM_Try, /*On fail goto*//*Label 9646*/ GIMT_Encode4(594540), // Rule ID 4462 //
     /*  594470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  594473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  594516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594538 */     GIR_RootConstrainSelectedInstOperands,
     /*  594539 */     // GIR_Coverage, 4462,
     /*  594539 */     GIR_EraseRootFromParent_Done,
     /*  594540 */   // Label 9646: @594540
     /*  594540 */   GIM_Try, /*On fail goto*//*Label 9647*/ GIMT_Encode4(594615), // Rule ID 4463 //
     /*  594545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  594548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  594556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  594559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  594562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  594565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  594580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594591 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  594591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  594594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  594610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594613 */     GIR_RootConstrainSelectedInstOperands,
     /*  594614 */     // GIR_Coverage, 4463,
     /*  594614 */     GIR_EraseRootFromParent_Done,
     /*  594615 */   // Label 9647: @594615
     /*  594615 */   GIM_Try, /*On fail goto*//*Label 9648*/ GIMT_Encode4(594690), // Rule ID 4472 //
     /*  594620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594666 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594688 */     GIR_RootConstrainSelectedInstOperands,
     /*  594689 */     // GIR_Coverage, 4472,
     /*  594689 */     GIR_EraseRootFromParent_Done,
     /*  594690 */   // Label 9648: @594690
     /*  594690 */   GIM_Try, /*On fail goto*//*Label 9649*/ GIMT_Encode4(594765), // Rule ID 4473 //
     /*  594695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  594706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  594709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  594712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  594715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594741 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2),
     /*  594744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594763 */     GIR_RootConstrainSelectedInstOperands,
     /*  594764 */     // GIR_Coverage, 4473,
     /*  594764 */     GIR_EraseRootFromParent_Done,
     /*  594765 */   // Label 9649: @594765
     /*  594765 */   GIM_Try, /*On fail goto*//*Label 9650*/ GIMT_Encode4(594840), // Rule ID 4482 //
     /*  594770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594838 */     GIR_RootConstrainSelectedInstOperands,
     /*  594839 */     // GIR_Coverage, 4482,
     /*  594839 */     GIR_EraseRootFromParent_Done,
     /*  594840 */   // Label 9650: @594840
     /*  594840 */   GIM_Try, /*On fail goto*//*Label 9651*/ GIMT_Encode4(594915), // Rule ID 4483 //
     /*  594845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  594856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  594859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  594862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  594865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  594868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  594884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  594891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1),
     /*  594894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594913 */     GIR_RootConstrainSelectedInstOperands,
     /*  594914 */     // GIR_Coverage, 4483,
     /*  594914 */     GIR_EraseRootFromParent_Done,
     /*  594915 */   // Label 9651: @594915
     /*  594915 */   GIM_Try, /*On fail goto*//*Label 9652*/ GIMT_Encode4(594990), // Rule ID 4492 //
     /*  594920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  594923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  594928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  594931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  594934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  594937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  594940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  594943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  594955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  594959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  594966 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  594966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  594969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  594971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  594973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  594975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  594977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  594982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  594985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  594988 */     GIR_RootConstrainSelectedInstOperands,
     /*  594989 */     // GIR_Coverage, 4492,
     /*  594989 */     GIR_EraseRootFromParent_Done,
     /*  594990 */   // Label 9652: @594990
     /*  594990 */   GIM_Try, /*On fail goto*//*Label 9653*/ GIMT_Encode4(595065), // Rule ID 4493 //
     /*  594995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  594998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  595006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  595009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  595012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  595015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595041 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2),
     /*  595044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595063 */     GIR_RootConstrainSelectedInstOperands,
     /*  595064 */     // GIR_Coverage, 4493,
     /*  595064 */     GIR_EraseRootFromParent_Done,
     /*  595065 */   // Label 9653: @595065
     /*  595065 */   GIM_Try, /*On fail goto*//*Label 9654*/ GIMT_Encode4(595140), // Rule ID 4502 //
     /*  595070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  595073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  595116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595138 */     GIR_RootConstrainSelectedInstOperands,
     /*  595139 */     // GIR_Coverage, 4502,
     /*  595139 */     GIR_EraseRootFromParent_Done,
     /*  595140 */   // Label 9654: @595140
     /*  595140 */   GIM_Try, /*On fail goto*//*Label 9655*/ GIMT_Encode4(595215), // Rule ID 4503 //
     /*  595145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  595148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  595156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  595159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  595162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  595165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595191 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  595191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4),
     /*  595194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  595210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595213 */     GIR_RootConstrainSelectedInstOperands,
     /*  595214 */     // GIR_Coverage, 4503,
     /*  595214 */     GIR_EraseRootFromParent_Done,
     /*  595215 */   // Label 9655: @595215
     /*  595215 */   GIM_Try, /*On fail goto*//*Label 9656*/ GIMT_Encode4(595290), // Rule ID 4510 //
     /*  595220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595266 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595288 */     GIR_RootConstrainSelectedInstOperands,
     /*  595289 */     // GIR_Coverage, 4510,
     /*  595289 */     GIR_EraseRootFromParent_Done,
     /*  595290 */   // Label 9656: @595290
     /*  595290 */   GIM_Try, /*On fail goto*//*Label 9657*/ GIMT_Encode4(595365), // Rule ID 4511 //
     /*  595295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  595306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  595309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  595312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595341 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8),
     /*  595344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595363 */     GIR_RootConstrainSelectedInstOperands,
     /*  595364 */     // GIR_Coverage, 4511,
     /*  595364 */     GIR_EraseRootFromParent_Done,
     /*  595365 */   // Label 9657: @595365
     /*  595365 */   GIM_Try, /*On fail goto*//*Label 9658*/ GIMT_Encode4(595440), // Rule ID 4514 //
     /*  595370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  595419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595438 */     GIR_RootConstrainSelectedInstOperands,
     /*  595439 */     // GIR_Coverage, 4514,
     /*  595439 */     GIR_EraseRootFromParent_Done,
     /*  595440 */   // Label 9658: @595440
     /*  595440 */   GIM_Try, /*On fail goto*//*Label 9659*/ GIMT_Encode4(595515), // Rule ID 4515 //
     /*  595445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  595456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  595459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  595462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595491 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  595494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595513 */     GIR_RootConstrainSelectedInstOperands,
     /*  595514 */     // GIR_Coverage, 4515,
     /*  595514 */     GIR_EraseRootFromParent_Done,
     /*  595515 */   // Label 9659: @595515
     /*  595515 */   GIM_Try, /*On fail goto*//*Label 9660*/ GIMT_Encode4(595590), // Rule ID 4518 //
     /*  595520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  595569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595588 */     GIR_RootConstrainSelectedInstOperands,
     /*  595589 */     // GIR_Coverage, 4518,
     /*  595589 */     GIR_EraseRootFromParent_Done,
     /*  595590 */   // Label 9660: @595590
     /*  595590 */   GIM_Try, /*On fail goto*//*Label 9661*/ GIMT_Encode4(595665), // Rule ID 4519 //
     /*  595595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  595606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  595609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  595612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  595630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595641 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11572:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  595644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595663 */     GIR_RootConstrainSelectedInstOperands,
     /*  595664 */     // GIR_Coverage, 4519,
     /*  595664 */     GIR_EraseRootFromParent_Done,
     /*  595665 */   // Label 9661: @595665
     /*  595665 */   GIM_Try, /*On fail goto*//*Label 9662*/ GIMT_Encode4(595740), // Rule ID 4522 //
     /*  595670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  595719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595738 */     GIR_RootConstrainSelectedInstOperands,
     /*  595739 */     // GIR_Coverage, 4522,
     /*  595739 */     GIR_EraseRootFromParent_Done,
     /*  595740 */   // Label 9662: @595740
     /*  595740 */   GIM_Try, /*On fail goto*//*Label 9663*/ GIMT_Encode4(595815), // Rule ID 4523 //
     /*  595745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  595756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  595759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  595762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  595780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595791 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  595794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595813 */     GIR_RootConstrainSelectedInstOperands,
     /*  595814 */     // GIR_Coverage, 4523,
     /*  595814 */     GIR_EraseRootFromParent_Done,
     /*  595815 */   // Label 9663: @595815
     /*  595815 */   GIM_Try, /*On fail goto*//*Label 9664*/ GIMT_Encode4(595890), // Rule ID 4526 //
     /*  595820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595866 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  595866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  595869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595888 */     GIR_RootConstrainSelectedInstOperands,
     /*  595889 */     // GIR_Coverage, 4526,
     /*  595889 */     GIR_EraseRootFromParent_Done,
     /*  595890 */   // Label 9664: @595890
     /*  595890 */   GIM_Try, /*On fail goto*//*Label 9665*/ GIMT_Encode4(595965), // Rule ID 4527 //
     /*  595895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  595898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  595906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  595909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  595912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  595915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  595918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  595930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  595934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  595941 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  595941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  595944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  595946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  595948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  595950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  595952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  595957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  595960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  595963 */     GIR_RootConstrainSelectedInstOperands,
     /*  595964 */     // GIR_Coverage, 4527,
     /*  595964 */     GIR_EraseRootFromParent_Done,
     /*  595965 */   // Label 9665: @595965
     /*  595965 */   GIM_Try, /*On fail goto*//*Label 9666*/ GIMT_Encode4(596040), // Rule ID 4530 //
     /*  595970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  595973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  595978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  595981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  595984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  595987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  595990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  595993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  595997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596016 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  596016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596038 */     GIR_RootConstrainSelectedInstOperands,
     /*  596039 */     // GIR_Coverage, 4530,
     /*  596039 */     GIR_EraseRootFromParent_Done,
     /*  596040 */   // Label 9666: @596040
     /*  596040 */   GIM_Try, /*On fail goto*//*Label 9667*/ GIMT_Encode4(596115), // Rule ID 4531 //
     /*  596045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  596056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  596059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  596062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596091 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  596091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  596110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596113 */     GIR_RootConstrainSelectedInstOperands,
     /*  596114 */     // GIR_Coverage, 4531,
     /*  596114 */     GIR_EraseRootFromParent_Done,
     /*  596115 */   // Label 9667: @596115
     /*  596115 */   GIM_Try, /*On fail goto*//*Label 9668*/ GIMT_Encode4(596190), // Rule ID 4534 //
     /*  596120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596166 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596188 */     GIR_RootConstrainSelectedInstOperands,
     /*  596189 */     // GIR_Coverage, 4534,
     /*  596189 */     GIR_EraseRootFromParent_Done,
     /*  596190 */   // Label 9668: @596190
     /*  596190 */   GIM_Try, /*On fail goto*//*Label 9669*/ GIMT_Encode4(596265), // Rule ID 4535 //
     /*  596195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  596206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  596209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  596212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596241 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4),
     /*  596244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596263 */     GIR_RootConstrainSelectedInstOperands,
     /*  596264 */     // GIR_Coverage, 4535,
     /*  596264 */     GIR_EraseRootFromParent_Done,
     /*  596265 */   // Label 9669: @596265
     /*  596265 */   GIM_Try, /*On fail goto*//*Label 9670*/ GIMT_Encode4(596340), // Rule ID 4538 //
     /*  596270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596338 */     GIR_RootConstrainSelectedInstOperands,
     /*  596339 */     // GIR_Coverage, 4538,
     /*  596339 */     GIR_EraseRootFromParent_Done,
     /*  596340 */   // Label 9670: @596340
     /*  596340 */   GIM_Try, /*On fail goto*//*Label 9671*/ GIMT_Encode4(596415), // Rule ID 4539 //
     /*  596345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  596356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  596359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  596362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596391 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11572:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596413 */     GIR_RootConstrainSelectedInstOperands,
     /*  596414 */     // GIR_Coverage, 4539,
     /*  596414 */     GIR_EraseRootFromParent_Done,
     /*  596415 */   // Label 9671: @596415
     /*  596415 */   GIM_Try, /*On fail goto*//*Label 9672*/ GIMT_Encode4(596490), // Rule ID 4542 //
     /*  596420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596488 */     GIR_RootConstrainSelectedInstOperands,
     /*  596489 */     // GIR_Coverage, 4542,
     /*  596489 */     GIR_EraseRootFromParent_Done,
     /*  596490 */   // Label 9672: @596490
     /*  596490 */   GIM_Try, /*On fail goto*//*Label 9673*/ GIMT_Encode4(596565), // Rule ID 4543 //
     /*  596495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  596506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  596509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  596512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  596530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  596544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596563 */     GIR_RootConstrainSelectedInstOperands,
     /*  596564 */     // GIR_Coverage, 4543,
     /*  596564 */     GIR_EraseRootFromParent_Done,
     /*  596565 */   // Label 9673: @596565
     /*  596565 */   GIM_Try, /*On fail goto*//*Label 9674*/ GIMT_Encode4(596640), // Rule ID 4546 //
     /*  596570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596638 */     GIR_RootConstrainSelectedInstOperands,
     /*  596639 */     // GIR_Coverage, 4546,
     /*  596639 */     GIR_EraseRootFromParent_Done,
     /*  596640 */   // Label 9674: @596640
     /*  596640 */   GIM_Try, /*On fail goto*//*Label 9675*/ GIMT_Encode4(596715), // Rule ID 4547 //
     /*  596645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  596656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  596659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  596662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  596680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596691 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  596694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596713 */     GIR_RootConstrainSelectedInstOperands,
     /*  596714 */     // GIR_Coverage, 4547,
     /*  596714 */     GIR_EraseRootFromParent_Done,
     /*  596715 */   // Label 9675: @596715
     /*  596715 */   GIM_Try, /*On fail goto*//*Label 9676*/ GIMT_Encode4(596790), // Rule ID 4550 //
     /*  596720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  596723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  596766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596788 */     GIR_RootConstrainSelectedInstOperands,
     /*  596789 */     // GIR_Coverage, 4550,
     /*  596789 */     GIR_EraseRootFromParent_Done,
     /*  596790 */   // Label 9676: @596790
     /*  596790 */   GIM_Try, /*On fail goto*//*Label 9677*/ GIMT_Encode4(596865), // Rule ID 4551 //
     /*  596795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  596798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  596806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  596809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  596812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  596830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596841 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  596841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  596844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  596860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596863 */     GIR_RootConstrainSelectedInstOperands,
     /*  596864 */     // GIR_Coverage, 4551,
     /*  596864 */     GIR_EraseRootFromParent_Done,
     /*  596865 */   // Label 9677: @596865
     /*  596865 */   GIM_Try, /*On fail goto*//*Label 9678*/ GIMT_Encode4(596940), // Rule ID 4554 //
     /*  596870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  596873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  596890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  596893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  596916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  596925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  596927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  596932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  596935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  596938 */     GIR_RootConstrainSelectedInstOperands,
     /*  596939 */     // GIR_Coverage, 4554,
     /*  596939 */     GIR_EraseRootFromParent_Done,
     /*  596940 */   // Label 9678: @596940
     /*  596940 */   GIM_Try, /*On fail goto*//*Label 9679*/ GIMT_Encode4(597015), // Rule ID 4555 //
     /*  596945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  596948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  596953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  596956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  596959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  596962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  596965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  596968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  596980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  596984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  596991 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11572:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  596991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2),
     /*  596994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  596996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  596998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597013 */     GIR_RootConstrainSelectedInstOperands,
     /*  597014 */     // GIR_Coverage, 4555,
     /*  597014 */     GIR_EraseRootFromParent_Done,
     /*  597015 */   // Label 9679: @597015
     /*  597015 */   GIM_Try, /*On fail goto*//*Label 9680*/ GIMT_Encode4(597090), // Rule ID 4558 //
     /*  597020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597066 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597088 */     GIR_RootConstrainSelectedInstOperands,
     /*  597089 */     // GIR_Coverage, 4558,
     /*  597089 */     GIR_EraseRootFromParent_Done,
     /*  597090 */   // Label 9680: @597090
     /*  597090 */   GIM_Try, /*On fail goto*//*Label 9681*/ GIMT_Encode4(597165), // Rule ID 4559 //
     /*  597095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  597106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  597109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  597112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597141 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11572:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1),
     /*  597144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597163 */     GIR_RootConstrainSelectedInstOperands,
     /*  597164 */     // GIR_Coverage, 4559,
     /*  597164 */     GIR_EraseRootFromParent_Done,
     /*  597165 */   // Label 9681: @597165
     /*  597165 */   GIM_Try, /*On fail goto*//*Label 9682*/ GIMT_Encode4(597240), // Rule ID 4562 //
     /*  597170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597216 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597238 */     GIR_RootConstrainSelectedInstOperands,
     /*  597239 */     // GIR_Coverage, 4562,
     /*  597239 */     GIR_EraseRootFromParent_Done,
     /*  597240 */   // Label 9682: @597240
     /*  597240 */   GIM_Try, /*On fail goto*//*Label 9683*/ GIMT_Encode4(597315), // Rule ID 4563 //
     /*  597245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  597256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  597259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  597262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  597280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597291 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11572:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2),
     /*  597294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597313 */     GIR_RootConstrainSelectedInstOperands,
     /*  597314 */     // GIR_Coverage, 4563,
     /*  597314 */     GIR_EraseRootFromParent_Done,
     /*  597315 */   // Label 9683: @597315
     /*  597315 */   GIM_Try, /*On fail goto*//*Label 9684*/ GIMT_Encode4(597390), // Rule ID 4566 //
     /*  597320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  597323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  597340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  597366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597388 */     GIR_RootConstrainSelectedInstOperands,
     /*  597389 */     // GIR_Coverage, 4566,
     /*  597389 */     GIR_EraseRootFromParent_Done,
     /*  597390 */   // Label 9684: @597390
     /*  597390 */   GIM_Try, /*On fail goto*//*Label 9685*/ GIMT_Encode4(597465), // Rule ID 4567 //
     /*  597395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  597398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w),
     /*  597403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  597406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  597409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  597412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  597415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  597430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  597434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597441 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11572:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWADD_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  597441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4),
     /*  597444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  597460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597463 */     GIR_RootConstrainSelectedInstOperands,
     /*  597464 */     // GIR_Coverage, 4567,
     /*  597464 */     GIR_EraseRootFromParent_Done,
     /*  597465 */   // Label 9685: @597465
     /*  597465 */   GIM_Try, /*On fail goto*//*Label 9686*/ GIMT_Encode4(597540), // Rule ID 4572 //
     /*  597470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597516 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  597519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597538 */     GIR_RootConstrainSelectedInstOperands,
     /*  597539 */     // GIR_Coverage, 4572,
     /*  597539 */     GIR_EraseRootFromParent_Done,
     /*  597540 */   // Label 9686: @597540
     /*  597540 */   GIM_Try, /*On fail goto*//*Label 9687*/ GIMT_Encode4(597615), // Rule ID 4573 //
     /*  597545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  597556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  597559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  597562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  597565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597591 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8),
     /*  597594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597613 */     GIR_RootConstrainSelectedInstOperands,
     /*  597614 */     // GIR_Coverage, 4573,
     /*  597614 */     GIR_EraseRootFromParent_Done,
     /*  597615 */   // Label 9687: @597615
     /*  597615 */   GIM_Try, /*On fail goto*//*Label 9688*/ GIMT_Encode4(597690), // Rule ID 4582 //
     /*  597620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  597669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597688 */     GIR_RootConstrainSelectedInstOperands,
     /*  597689 */     // GIR_Coverage, 4582,
     /*  597689 */     GIR_EraseRootFromParent_Done,
     /*  597690 */   // Label 9688: @597690
     /*  597690 */   GIM_Try, /*On fail goto*//*Label 9689*/ GIMT_Encode4(597765), // Rule ID 4583 //
     /*  597695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  597706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  597709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  597712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  597715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  597744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597763 */     GIR_RootConstrainSelectedInstOperands,
     /*  597764 */     // GIR_Coverage, 4583,
     /*  597764 */     GIR_EraseRootFromParent_Done,
     /*  597765 */   // Label 9689: @597765
     /*  597765 */   GIM_Try, /*On fail goto*//*Label 9690*/ GIMT_Encode4(597840), // Rule ID 4592 //
     /*  597770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  597819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597838 */     GIR_RootConstrainSelectedInstOperands,
     /*  597839 */     // GIR_Coverage, 4592,
     /*  597839 */     GIR_EraseRootFromParent_Done,
     /*  597840 */   // Label 9690: @597840
     /*  597840 */   GIM_Try, /*On fail goto*//*Label 9691*/ GIMT_Encode4(597915), // Rule ID 4593 //
     /*  597845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  597856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  597859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  597862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  597865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  597868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597891 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  597891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  597894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597913 */     GIR_RootConstrainSelectedInstOperands,
     /*  597914 */     // GIR_Coverage, 4593,
     /*  597914 */     GIR_EraseRootFromParent_Done,
     /*  597915 */   // Label 9691: @597915
     /*  597915 */   GIM_Try, /*On fail goto*//*Label 9692*/ GIMT_Encode4(597990), // Rule ID 4602 //
     /*  597920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  597923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  597928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  597931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  597934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  597937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  597940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  597943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  597955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  597959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  597966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  597966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  597969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  597971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  597973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  597975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  597977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  597982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  597985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  597988 */     GIR_RootConstrainSelectedInstOperands,
     /*  597989 */     // GIR_Coverage, 4602,
     /*  597989 */     GIR_EraseRootFromParent_Done,
     /*  597990 */   // Label 9692: @597990
     /*  597990 */   GIM_Try, /*On fail goto*//*Label 9693*/ GIMT_Encode4(598065), // Rule ID 4603 //
     /*  597995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  597998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  598006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  598009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  598012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  598015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598063 */     GIR_RootConstrainSelectedInstOperands,
     /*  598064 */     // GIR_Coverage, 4603,
     /*  598064 */     GIR_EraseRootFromParent_Done,
     /*  598065 */   // Label 9693: @598065
     /*  598065 */   GIM_Try, /*On fail goto*//*Label 9694*/ GIMT_Encode4(598140), // Rule ID 4612 //
     /*  598070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598138 */     GIR_RootConstrainSelectedInstOperands,
     /*  598139 */     // GIR_Coverage, 4612,
     /*  598139 */     GIR_EraseRootFromParent_Done,
     /*  598140 */   // Label 9694: @598140
     /*  598140 */   GIM_Try, /*On fail goto*//*Label 9695*/ GIMT_Encode4(598215), // Rule ID 4613 //
     /*  598145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  598156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  598159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  598162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  598165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598191 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598213 */     GIR_RootConstrainSelectedInstOperands,
     /*  598214 */     // GIR_Coverage, 4613,
     /*  598214 */     GIR_EraseRootFromParent_Done,
     /*  598215 */   // Label 9695: @598215
     /*  598215 */   GIM_Try, /*On fail goto*//*Label 9696*/ GIMT_Encode4(598290), // Rule ID 4622 //
     /*  598220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598266 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  598266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598288 */     GIR_RootConstrainSelectedInstOperands,
     /*  598289 */     // GIR_Coverage, 4622,
     /*  598289 */     GIR_EraseRootFromParent_Done,
     /*  598290 */   // Label 9696: @598290
     /*  598290 */   GIM_Try, /*On fail goto*//*Label 9697*/ GIMT_Encode4(598365), // Rule ID 4623 //
     /*  598295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  598306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  598309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  598312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  598315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598341 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  598341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  598344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  598360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598363 */     GIR_RootConstrainSelectedInstOperands,
     /*  598364 */     // GIR_Coverage, 4623,
     /*  598364 */     GIR_EraseRootFromParent_Done,
     /*  598365 */   // Label 9697: @598365
     /*  598365 */   GIM_Try, /*On fail goto*//*Label 9698*/ GIMT_Encode4(598440), // Rule ID 4632 //
     /*  598370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598438 */     GIR_RootConstrainSelectedInstOperands,
     /*  598439 */     // GIR_Coverage, 4632,
     /*  598439 */     GIR_EraseRootFromParent_Done,
     /*  598440 */   // Label 9698: @598440
     /*  598440 */   GIM_Try, /*On fail goto*//*Label 9699*/ GIMT_Encode4(598515), // Rule ID 4633 //
     /*  598445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  598456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  598459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  598462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  598465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598491 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4),
     /*  598494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598513 */     GIR_RootConstrainSelectedInstOperands,
     /*  598514 */     // GIR_Coverage, 4633,
     /*  598514 */     GIR_EraseRootFromParent_Done,
     /*  598515 */   // Label 9699: @598515
     /*  598515 */   GIM_Try, /*On fail goto*//*Label 9700*/ GIMT_Encode4(598590), // Rule ID 4642 //
     /*  598520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598588 */     GIR_RootConstrainSelectedInstOperands,
     /*  598589 */     // GIR_Coverage, 4642,
     /*  598589 */     GIR_EraseRootFromParent_Done,
     /*  598590 */   // Label 9700: @598590
     /*  598590 */   GIM_Try, /*On fail goto*//*Label 9701*/ GIMT_Encode4(598665), // Rule ID 4643 //
     /*  598595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  598606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  598609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  598612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  598615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598641 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  598644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598663 */     GIR_RootConstrainSelectedInstOperands,
     /*  598664 */     // GIR_Coverage, 4643,
     /*  598664 */     GIR_EraseRootFromParent_Done,
     /*  598665 */   // Label 9701: @598665
     /*  598665 */   GIM_Try, /*On fail goto*//*Label 9702*/ GIMT_Encode4(598740), // Rule ID 4652 //
     /*  598670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598738 */     GIR_RootConstrainSelectedInstOperands,
     /*  598739 */     // GIR_Coverage, 4652,
     /*  598739 */     GIR_EraseRootFromParent_Done,
     /*  598740 */   // Label 9702: @598740
     /*  598740 */   GIM_Try, /*On fail goto*//*Label 9703*/ GIMT_Encode4(598815), // Rule ID 4653 //
     /*  598745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  598756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  598759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  598762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  598765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  598784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598791 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  598794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598813 */     GIR_RootConstrainSelectedInstOperands,
     /*  598814 */     // GIR_Coverage, 4653,
     /*  598814 */     GIR_EraseRootFromParent_Done,
     /*  598815 */   // Label 9703: @598815
     /*  598815 */   GIM_Try, /*On fail goto*//*Label 9704*/ GIMT_Encode4(598890), // Rule ID 4662 //
     /*  598820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598866 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  598866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598888 */     GIR_RootConstrainSelectedInstOperands,
     /*  598889 */     // GIR_Coverage, 4662,
     /*  598889 */     GIR_EraseRootFromParent_Done,
     /*  598890 */   // Label 9704: @598890
     /*  598890 */   GIM_Try, /*On fail goto*//*Label 9705*/ GIMT_Encode4(598965), // Rule ID 4663 //
     /*  598895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  598898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  598906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  598909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  598912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  598915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  598918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  598930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  598934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  598941 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  598941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  598944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  598946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  598948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  598950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  598952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  598957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  598960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  598963 */     GIR_RootConstrainSelectedInstOperands,
     /*  598964 */     // GIR_Coverage, 4663,
     /*  598964 */     GIR_EraseRootFromParent_Done,
     /*  598965 */   // Label 9705: @598965
     /*  598965 */   GIM_Try, /*On fail goto*//*Label 9706*/ GIMT_Encode4(599040), // Rule ID 4672 //
     /*  598970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  598973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  598978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  598981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  598984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  598987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  598990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  598993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  598997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  599016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599038 */     GIR_RootConstrainSelectedInstOperands,
     /*  599039 */     // GIR_Coverage, 4672,
     /*  599039 */     GIR_EraseRootFromParent_Done,
     /*  599040 */   // Label 9706: @599040
     /*  599040 */   GIM_Try, /*On fail goto*//*Label 9707*/ GIMT_Encode4(599115), // Rule ID 4673 //
     /*  599045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  599056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  599059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  599062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  599065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599091 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  599091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  599110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599113 */     GIR_RootConstrainSelectedInstOperands,
     /*  599114 */     // GIR_Coverage, 4673,
     /*  599114 */     GIR_EraseRootFromParent_Done,
     /*  599115 */   // Label 9707: @599115
     /*  599115 */   GIM_Try, /*On fail goto*//*Label 9708*/ GIMT_Encode4(599190), // Rule ID 4682 //
     /*  599120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599166 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599188 */     GIR_RootConstrainSelectedInstOperands,
     /*  599189 */     // GIR_Coverage, 4682,
     /*  599189 */     GIR_EraseRootFromParent_Done,
     /*  599190 */   // Label 9708: @599190
     /*  599190 */   GIM_Try, /*On fail goto*//*Label 9709*/ GIMT_Encode4(599265), // Rule ID 4683 //
     /*  599195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  599206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  599209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  599212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  599215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599241 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2),
     /*  599244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599263 */     GIR_RootConstrainSelectedInstOperands,
     /*  599264 */     // GIR_Coverage, 4683,
     /*  599264 */     GIR_EraseRootFromParent_Done,
     /*  599265 */   // Label 9709: @599265
     /*  599265 */   GIM_Try, /*On fail goto*//*Label 9710*/ GIMT_Encode4(599340), // Rule ID 4692 //
     /*  599270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599338 */     GIR_RootConstrainSelectedInstOperands,
     /*  599339 */     // GIR_Coverage, 4692,
     /*  599339 */     GIR_EraseRootFromParent_Done,
     /*  599340 */   // Label 9710: @599340
     /*  599340 */   GIM_Try, /*On fail goto*//*Label 9711*/ GIMT_Encode4(599415), // Rule ID 4693 //
     /*  599345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  599356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  599359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  599362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  599365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599391 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1),
     /*  599394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599413 */     GIR_RootConstrainSelectedInstOperands,
     /*  599414 */     // GIR_Coverage, 4693,
     /*  599414 */     GIR_EraseRootFromParent_Done,
     /*  599415 */   // Label 9711: @599415
     /*  599415 */   GIM_Try, /*On fail goto*//*Label 9712*/ GIMT_Encode4(599490), // Rule ID 4702 //
     /*  599420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599466 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599488 */     GIR_RootConstrainSelectedInstOperands,
     /*  599489 */     // GIR_Coverage, 4702,
     /*  599489 */     GIR_EraseRootFromParent_Done,
     /*  599490 */   // Label 9712: @599490
     /*  599490 */   GIM_Try, /*On fail goto*//*Label 9713*/ GIMT_Encode4(599565), // Rule ID 4703 //
     /*  599495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  599506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  599509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  599512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  599515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  599534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599541 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2),
     /*  599544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599563 */     GIR_RootConstrainSelectedInstOperands,
     /*  599564 */     // GIR_Coverage, 4703,
     /*  599564 */     GIR_EraseRootFromParent_Done,
     /*  599565 */   // Label 9713: @599565
     /*  599565 */   GIM_Try, /*On fail goto*//*Label 9714*/ GIMT_Encode4(599640), // Rule ID 4712 //
     /*  599570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  599573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599616 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  599616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599638 */     GIR_RootConstrainSelectedInstOperands,
     /*  599639 */     // GIR_Coverage, 4712,
     /*  599639 */     GIR_EraseRootFromParent_Done,
     /*  599640 */   // Label 9714: @599640
     /*  599640 */   GIM_Try, /*On fail goto*//*Label 9715*/ GIMT_Encode4(599715), // Rule ID 4713 //
     /*  599645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  599648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  599656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  599659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  599662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  599665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  599680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  599684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599691 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  599691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4),
     /*  599694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  599710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599713 */     GIR_RootConstrainSelectedInstOperands,
     /*  599714 */     // GIR_Coverage, 4713,
     /*  599714 */     GIR_EraseRootFromParent_Done,
     /*  599715 */   // Label 9715: @599715
     /*  599715 */   GIM_Try, /*On fail goto*//*Label 9716*/ GIMT_Encode4(599790), // Rule ID 4720 //
     /*  599720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  599769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599788 */     GIR_RootConstrainSelectedInstOperands,
     /*  599789 */     // GIR_Coverage, 4720,
     /*  599789 */     GIR_EraseRootFromParent_Done,
     /*  599790 */   // Label 9716: @599790
     /*  599790 */   GIM_Try, /*On fail goto*//*Label 9717*/ GIMT_Encode4(599865), // Rule ID 4721 //
     /*  599795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  599806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  599809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  599812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599841 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8),
     /*  599844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599863 */     GIR_RootConstrainSelectedInstOperands,
     /*  599864 */     // GIR_Coverage, 4721,
     /*  599864 */     GIR_EraseRootFromParent_Done,
     /*  599865 */   // Label 9717: @599865
     /*  599865 */   GIM_Try, /*On fail goto*//*Label 9718*/ GIMT_Encode4(599940), // Rule ID 4724 //
     /*  599870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  599873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  599890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  599893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  599916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  599919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  599925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  599927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  599932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  599935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  599938 */     GIR_RootConstrainSelectedInstOperands,
     /*  599939 */     // GIR_Coverage, 4724,
     /*  599939 */     GIR_EraseRootFromParent_Done,
     /*  599940 */   // Label 9718: @599940
     /*  599940 */   GIM_Try, /*On fail goto*//*Label 9719*/ GIMT_Encode4(600015), // Rule ID 4725 //
     /*  599945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  599948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  599953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  599956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  599959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  599962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  599965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  599968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  599980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  599984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  599991 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  599991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  599994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  599996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  599998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600013 */     GIR_RootConstrainSelectedInstOperands,
     /*  600014 */     // GIR_Coverage, 4725,
     /*  600014 */     GIR_EraseRootFromParent_Done,
     /*  600015 */   // Label 9719: @600015
     /*  600015 */   GIM_Try, /*On fail goto*//*Label 9720*/ GIMT_Encode4(600090), // Rule ID 4728 //
     /*  600020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600066 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600088 */     GIR_RootConstrainSelectedInstOperands,
     /*  600089 */     // GIR_Coverage, 4728,
     /*  600089 */     GIR_EraseRootFromParent_Done,
     /*  600090 */   // Label 9720: @600090
     /*  600090 */   GIM_Try, /*On fail goto*//*Label 9721*/ GIMT_Encode4(600165), // Rule ID 4729 //
     /*  600095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  600106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  600109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  600112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600141 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11600:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600163 */     GIR_RootConstrainSelectedInstOperands,
     /*  600164 */     // GIR_Coverage, 4729,
     /*  600164 */     GIR_EraseRootFromParent_Done,
     /*  600165 */   // Label 9721: @600165
     /*  600165 */   GIM_Try, /*On fail goto*//*Label 9722*/ GIMT_Encode4(600240), // Rule ID 4732 //
     /*  600170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600216 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600238 */     GIR_RootConstrainSelectedInstOperands,
     /*  600239 */     // GIR_Coverage, 4732,
     /*  600239 */     GIR_EraseRootFromParent_Done,
     /*  600240 */   // Label 9722: @600240
     /*  600240 */   GIM_Try, /*On fail goto*//*Label 9723*/ GIMT_Encode4(600315), // Rule ID 4733 //
     /*  600245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  600256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  600259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  600262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600313 */     GIR_RootConstrainSelectedInstOperands,
     /*  600314 */     // GIR_Coverage, 4733,
     /*  600314 */     GIR_EraseRootFromParent_Done,
     /*  600315 */   // Label 9723: @600315
     /*  600315 */   GIM_Try, /*On fail goto*//*Label 9724*/ GIMT_Encode4(600390), // Rule ID 4736 //
     /*  600320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600366 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600388 */     GIR_RootConstrainSelectedInstOperands,
     /*  600389 */     // GIR_Coverage, 4736,
     /*  600389 */     GIR_EraseRootFromParent_Done,
     /*  600390 */   // Label 9724: @600390
     /*  600390 */   GIM_Try, /*On fail goto*//*Label 9725*/ GIMT_Encode4(600465), // Rule ID 4737 //
     /*  600395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  600406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  600409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  600412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  600430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600441 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  600444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600463 */     GIR_RootConstrainSelectedInstOperands,
     /*  600464 */     // GIR_Coverage, 4737,
     /*  600464 */     GIR_EraseRootFromParent_Done,
     /*  600465 */   // Label 9725: @600465
     /*  600465 */   GIM_Try, /*On fail goto*//*Label 9726*/ GIMT_Encode4(600540), // Rule ID 4740 //
     /*  600470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600516 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  600516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  600519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600538 */     GIR_RootConstrainSelectedInstOperands,
     /*  600539 */     // GIR_Coverage, 4740,
     /*  600539 */     GIR_EraseRootFromParent_Done,
     /*  600540 */   // Label 9726: @600540
     /*  600540 */   GIM_Try, /*On fail goto*//*Label 9727*/ GIMT_Encode4(600615), // Rule ID 4741 //
     /*  600545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  600556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  600559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  600562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  600580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  600591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  600594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  600610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600613 */     GIR_RootConstrainSelectedInstOperands,
     /*  600614 */     // GIR_Coverage, 4741,
     /*  600614 */     GIR_EraseRootFromParent_Done,
     /*  600615 */   // Label 9727: @600615
     /*  600615 */   GIM_Try, /*On fail goto*//*Label 9728*/ GIMT_Encode4(600690), // Rule ID 4744 //
     /*  600620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600688 */     GIR_RootConstrainSelectedInstOperands,
     /*  600689 */     // GIR_Coverage, 4744,
     /*  600689 */     GIR_EraseRootFromParent_Done,
     /*  600690 */   // Label 9728: @600690
     /*  600690 */   GIM_Try, /*On fail goto*//*Label 9729*/ GIMT_Encode4(600765), // Rule ID 4745 //
     /*  600695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  600706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  600709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  600712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600741 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4),
     /*  600744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600763 */     GIR_RootConstrainSelectedInstOperands,
     /*  600764 */     // GIR_Coverage, 4745,
     /*  600764 */     GIR_EraseRootFromParent_Done,
     /*  600765 */   // Label 9729: @600765
     /*  600765 */   GIM_Try, /*On fail goto*//*Label 9730*/ GIMT_Encode4(600840), // Rule ID 4748 //
     /*  600770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600816 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600838 */     GIR_RootConstrainSelectedInstOperands,
     /*  600839 */     // GIR_Coverage, 4748,
     /*  600839 */     GIR_EraseRootFromParent_Done,
     /*  600840 */   // Label 9730: @600840
     /*  600840 */   GIM_Try, /*On fail goto*//*Label 9731*/ GIMT_Encode4(600915), // Rule ID 4749 //
     /*  600845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  600856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  600859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  600862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  600865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  600868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  600880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600891 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11600:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  600891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  600894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600913 */     GIR_RootConstrainSelectedInstOperands,
     /*  600914 */     // GIR_Coverage, 4749,
     /*  600914 */     GIR_EraseRootFromParent_Done,
     /*  600915 */   // Label 9731: @600915
     /*  600915 */   GIM_Try, /*On fail goto*//*Label 9732*/ GIMT_Encode4(600990), // Rule ID 4752 //
     /*  600920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  600923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  600928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  600931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  600934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  600937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  600940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  600943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  600955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  600959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  600966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  600966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  600969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  600971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  600973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  600975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  600977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  600982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  600985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  600988 */     GIR_RootConstrainSelectedInstOperands,
     /*  600989 */     // GIR_Coverage, 4752,
     /*  600989 */     GIR_EraseRootFromParent_Done,
     /*  600990 */   // Label 9732: @600990
     /*  600990 */   GIM_Try, /*On fail goto*//*Label 9733*/ GIMT_Encode4(601065), // Rule ID 4753 //
     /*  600995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  600998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  601006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  601009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  601012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601063 */     GIR_RootConstrainSelectedInstOperands,
     /*  601064 */     // GIR_Coverage, 4753,
     /*  601064 */     GIR_EraseRootFromParent_Done,
     /*  601065 */   // Label 9733: @601065
     /*  601065 */   GIM_Try, /*On fail goto*//*Label 9734*/ GIMT_Encode4(601140), // Rule ID 4756 //
     /*  601070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601116 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601138 */     GIR_RootConstrainSelectedInstOperands,
     /*  601139 */     // GIR_Coverage, 4756,
     /*  601139 */     GIR_EraseRootFromParent_Done,
     /*  601140 */   // Label 9734: @601140
     /*  601140 */   GIM_Try, /*On fail goto*//*Label 9735*/ GIMT_Encode4(601215), // Rule ID 4757 //
     /*  601145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  601156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  601159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  601162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601191 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601213 */     GIR_RootConstrainSelectedInstOperands,
     /*  601214 */     // GIR_Coverage, 4757,
     /*  601214 */     GIR_EraseRootFromParent_Done,
     /*  601215 */   // Label 9735: @601215
     /*  601215 */   GIM_Try, /*On fail goto*//*Label 9736*/ GIMT_Encode4(601290), // Rule ID 4760 //
     /*  601220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  601266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601288 */     GIR_RootConstrainSelectedInstOperands,
     /*  601289 */     // GIR_Coverage, 4760,
     /*  601289 */     GIR_EraseRootFromParent_Done,
     /*  601290 */   // Label 9736: @601290
     /*  601290 */   GIM_Try, /*On fail goto*//*Label 9737*/ GIMT_Encode4(601365), // Rule ID 4761 //
     /*  601295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  601298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  601306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  601309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  601312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601341 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  601341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  601360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601363 */     GIR_RootConstrainSelectedInstOperands,
     /*  601364 */     // GIR_Coverage, 4761,
     /*  601364 */     GIR_EraseRootFromParent_Done,
     /*  601365 */   // Label 9737: @601365
     /*  601365 */   GIM_Try, /*On fail goto*//*Label 9738*/ GIMT_Encode4(601440), // Rule ID 4764 //
     /*  601370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601416 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601438 */     GIR_RootConstrainSelectedInstOperands,
     /*  601439 */     // GIR_Coverage, 4764,
     /*  601439 */     GIR_EraseRootFromParent_Done,
     /*  601440 */   // Label 9738: @601440
     /*  601440 */   GIM_Try, /*On fail goto*//*Label 9739*/ GIMT_Encode4(601515), // Rule ID 4765 //
     /*  601445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  601456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  601459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  601462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601491 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11600:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2),
     /*  601494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601513 */     GIR_RootConstrainSelectedInstOperands,
     /*  601514 */     // GIR_Coverage, 4765,
     /*  601514 */     GIR_EraseRootFromParent_Done,
     /*  601515 */   // Label 9739: @601515
     /*  601515 */   GIM_Try, /*On fail goto*//*Label 9740*/ GIMT_Encode4(601590), // Rule ID 4768 //
     /*  601520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601588 */     GIR_RootConstrainSelectedInstOperands,
     /*  601589 */     // GIR_Coverage, 4768,
     /*  601589 */     GIR_EraseRootFromParent_Done,
     /*  601590 */   // Label 9740: @601590
     /*  601590 */   GIM_Try, /*On fail goto*//*Label 9741*/ GIMT_Encode4(601665), // Rule ID 4769 //
     /*  601595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  601606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  601609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  601612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  601630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601641 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11600:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1),
     /*  601644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601663 */     GIR_RootConstrainSelectedInstOperands,
     /*  601664 */     // GIR_Coverage, 4769,
     /*  601664 */     GIR_EraseRootFromParent_Done,
     /*  601665 */   // Label 9741: @601665
     /*  601665 */   GIM_Try, /*On fail goto*//*Label 9742*/ GIMT_Encode4(601740), // Rule ID 4772 //
     /*  601670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601738 */     GIR_RootConstrainSelectedInstOperands,
     /*  601739 */     // GIR_Coverage, 4772,
     /*  601739 */     GIR_EraseRootFromParent_Done,
     /*  601740 */   // Label 9742: @601740
     /*  601740 */   GIM_Try, /*On fail goto*//*Label 9743*/ GIMT_Encode4(601815), // Rule ID 4773 //
     /*  601745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  601756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  601759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  601762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  601780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601791 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11600:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2),
     /*  601794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601813 */     GIR_RootConstrainSelectedInstOperands,
     /*  601814 */     // GIR_Coverage, 4773,
     /*  601814 */     GIR_EraseRootFromParent_Done,
     /*  601815 */   // Label 9743: @601815
     /*  601815 */   GIM_Try, /*On fail goto*//*Label 9744*/ GIMT_Encode4(601890), // Rule ID 4776 //
     /*  601820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  601823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  601840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601866 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  601866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601888 */     GIR_RootConstrainSelectedInstOperands,
     /*  601889 */     // GIR_Coverage, 4776,
     /*  601889 */     GIR_EraseRootFromParent_Done,
     /*  601890 */   // Label 9744: @601890
     /*  601890 */   GIM_Try, /*On fail goto*//*Label 9745*/ GIMT_Encode4(601965), // Rule ID 4777 //
     /*  601895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  601898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w),
     /*  601903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  601906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  601909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  601912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  601915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  601918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  601930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  601934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  601941 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11600:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSUB_WX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  601941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4),
     /*  601944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  601946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  601948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  601950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  601952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  601957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  601960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  601963 */     GIR_RootConstrainSelectedInstOperands,
     /*  601964 */     // GIR_Coverage, 4777,
     /*  601964 */     GIR_EraseRootFromParent_Done,
     /*  601965 */   // Label 9745: @601965
     /*  601965 */   GIM_Try, /*On fail goto*//*Label 9746*/ GIMT_Encode4(602037), // Rule ID 5130 //
     /*  601970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  601973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  601978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  601981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  601984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  601987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  601990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  601993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  601997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602035 */     GIR_RootConstrainSelectedInstOperands,
     /*  602036 */     // GIR_Coverage, 5130,
     /*  602036 */     GIR_EraseRootFromParent_Done,
     /*  602037 */   // Label 9746: @602037
     /*  602037 */   GIM_Try, /*On fail goto*//*Label 9747*/ GIMT_Encode4(602109), // Rule ID 5131 //
     /*  602042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  602056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  602059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602088 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602107 */     GIR_RootConstrainSelectedInstOperands,
     /*  602108 */     // GIR_Coverage, 5131,
     /*  602108 */     GIR_EraseRootFromParent_Done,
     /*  602109 */   // Label 9747: @602109
     /*  602109 */   GIM_Try, /*On fail goto*//*Label 9748*/ GIMT_Encode4(602181), // Rule ID 5132 //
     /*  602114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602179 */     GIR_RootConstrainSelectedInstOperands,
     /*  602180 */     // GIR_Coverage, 5132,
     /*  602180 */     GIR_EraseRootFromParent_Done,
     /*  602181 */   // Label 9748: @602181
     /*  602181 */   GIM_Try, /*On fail goto*//*Label 9749*/ GIMT_Encode4(602253), // Rule ID 5133 //
     /*  602186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  602200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  602203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602251 */     GIR_RootConstrainSelectedInstOperands,
     /*  602252 */     // GIR_Coverage, 5133,
     /*  602252 */     GIR_EraseRootFromParent_Done,
     /*  602253 */   // Label 9749: @602253
     /*  602253 */   GIM_Try, /*On fail goto*//*Label 9750*/ GIMT_Encode4(602325), // Rule ID 5134 //
     /*  602258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602304 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602323 */     GIR_RootConstrainSelectedInstOperands,
     /*  602324 */     // GIR_Coverage, 5134,
     /*  602324 */     GIR_EraseRootFromParent_Done,
     /*  602325 */   // Label 9750: @602325
     /*  602325 */   GIM_Try, /*On fail goto*//*Label 9751*/ GIMT_Encode4(602397), // Rule ID 5135 //
     /*  602330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  602344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  602347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  602376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF4),
     /*  602379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602395 */     GIR_RootConstrainSelectedInstOperands,
     /*  602396 */     // GIR_Coverage, 5135,
     /*  602396 */     GIR_EraseRootFromParent_Done,
     /*  602397 */   // Label 9751: @602397
     /*  602397 */   GIM_Try, /*On fail goto*//*Label 9752*/ GIMT_Encode4(602469), // Rule ID 5136 //
     /*  602402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602448 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602467 */     GIR_RootConstrainSelectedInstOperands,
     /*  602468 */     // GIR_Coverage, 5136,
     /*  602468 */     GIR_EraseRootFromParent_Done,
     /*  602469 */   // Label 9752: @602469
     /*  602469 */   GIM_Try, /*On fail goto*//*Label 9753*/ GIMT_Encode4(602541), // Rule ID 5137 //
     /*  602474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  602488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  602491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  602520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602539 */     GIR_RootConstrainSelectedInstOperands,
     /*  602540 */     // GIR_Coverage, 5137,
     /*  602540 */     GIR_EraseRootFromParent_Done,
     /*  602541 */   // Label 9753: @602541
     /*  602541 */   GIM_Try, /*On fail goto*//*Label 9754*/ GIMT_Encode4(602613), // Rule ID 5138 //
     /*  602546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  602592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602611 */     GIR_RootConstrainSelectedInstOperands,
     /*  602612 */     // GIR_Coverage, 5138,
     /*  602612 */     GIR_EraseRootFromParent_Done,
     /*  602613 */   // Label 9754: @602613
     /*  602613 */   GIM_Try, /*On fail goto*//*Label 9755*/ GIMT_Encode4(602685), // Rule ID 5139 //
     /*  602618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  602629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  602632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  602635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  602638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  602664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_MF2),
     /*  602667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  602683 */     GIR_RootConstrainSelectedInstOperands,
     /*  602684 */     // GIR_Coverage, 5139,
     /*  602684 */     GIR_EraseRootFromParent_Done,
     /*  602685 */   // Label 9755: @602685
     /*  602685 */   GIM_Try, /*On fail goto*//*Label 9756*/ GIMT_Encode4(602757), // Rule ID 5140 //
     /*  602690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  602701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  602704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  602707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  602710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  602736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  602739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602755 */     GIR_RootConstrainSelectedInstOperands,
     /*  602756 */     // GIR_Coverage, 5140,
     /*  602756 */     GIR_EraseRootFromParent_Done,
     /*  602757 */   // Label 9756: @602757
     /*  602757 */   GIM_Try, /*On fail goto*//*Label 9757*/ GIMT_Encode4(602829), // Rule ID 5141 //
     /*  602762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  602773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  602776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  602779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  602782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602808 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  602808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  602811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  602827 */     GIR_RootConstrainSelectedInstOperands,
     /*  602828 */     // GIR_Coverage, 5141,
     /*  602828 */     GIR_EraseRootFromParent_Done,
     /*  602829 */   // Label 9757: @602829
     /*  602829 */   GIM_Try, /*On fail goto*//*Label 9758*/ GIMT_Encode4(602901), // Rule ID 5142 //
     /*  602834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  602857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602880 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  602880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  602883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602899 */     GIR_RootConstrainSelectedInstOperands,
     /*  602900 */     // GIR_Coverage, 5142,
     /*  602900 */     GIR_EraseRootFromParent_Done,
     /*  602901 */   // Label 9758: @602901
     /*  602901 */   GIM_Try, /*On fail goto*//*Label 9759*/ GIMT_Encode4(602973), // Rule ID 5143 //
     /*  602906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  602909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  602917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  602920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  602923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  602926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  602929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  602941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  602945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  602952 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  602952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  602955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  602957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  602959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  602961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  602963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  602968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  602971 */     GIR_RootConstrainSelectedInstOperands,
     /*  602972 */     // GIR_Coverage, 5143,
     /*  602972 */     GIR_EraseRootFromParent_Done,
     /*  602973 */   // Label 9759: @602973
     /*  602973 */   GIM_Try, /*On fail goto*//*Label 9760*/ GIMT_Encode4(603045), // Rule ID 5144 //
     /*  602978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  602981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  602986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  602989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  602992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  602995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  602998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  603024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603043 */     GIR_RootConstrainSelectedInstOperands,
     /*  603044 */     // GIR_Coverage, 5144,
     /*  603044 */     GIR_EraseRootFromParent_Done,
     /*  603045 */   // Label 9760: @603045
     /*  603045 */   GIM_Try, /*On fail goto*//*Label 9761*/ GIMT_Encode4(603117), // Rule ID 5145 //
     /*  603050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  603061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  603064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  603067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  603070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  603096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  603115 */     GIR_RootConstrainSelectedInstOperands,
     /*  603116 */     // GIR_Coverage, 5145,
     /*  603116 */     GIR_EraseRootFromParent_Done,
     /*  603117 */   // Label 9761: @603117
     /*  603117 */   GIM_Try, /*On fail goto*//*Label 9762*/ GIMT_Encode4(603189), // Rule ID 5146 //
     /*  603122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  603125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  603168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603187 */     GIR_RootConstrainSelectedInstOperands,
     /*  603188 */     // GIR_Coverage, 5146,
     /*  603188 */     GIR_EraseRootFromParent_Done,
     /*  603189 */   // Label 9762: @603189
     /*  603189 */   GIM_Try, /*On fail goto*//*Label 9763*/ GIMT_Encode4(603261), // Rule ID 5147 //
     /*  603194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  603197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  603205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  603208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  603211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  603214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  603240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M1),
     /*  603243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  603259 */     GIR_RootConstrainSelectedInstOperands,
     /*  603260 */     // GIR_Coverage, 5147,
     /*  603260 */     GIR_EraseRootFromParent_Done,
     /*  603261 */   // Label 9763: @603261
     /*  603261 */   GIM_Try, /*On fail goto*//*Label 9764*/ GIMT_Encode4(603333), // Rule ID 5148 //
     /*  603266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603312 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603331 */     GIR_RootConstrainSelectedInstOperands,
     /*  603332 */     // GIR_Coverage, 5148,
     /*  603332 */     GIR_EraseRootFromParent_Done,
     /*  603333 */   // Label 9764: @603333
     /*  603333 */   GIM_Try, /*On fail goto*//*Label 9765*/ GIMT_Encode4(603405), // Rule ID 5149 //
     /*  603338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  603352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  603355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603403 */     GIR_RootConstrainSelectedInstOperands,
     /*  603404 */     // GIR_Coverage, 5149,
     /*  603404 */     GIR_EraseRootFromParent_Done,
     /*  603405 */   // Label 9765: @603405
     /*  603405 */   GIM_Try, /*On fail goto*//*Label 9766*/ GIMT_Encode4(603477), // Rule ID 5150 //
     /*  603410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  603421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  603430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603456 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603475 */     GIR_RootConstrainSelectedInstOperands,
     /*  603476 */     // GIR_Coverage, 5150,
     /*  603476 */     GIR_EraseRootFromParent_Done,
     /*  603477 */   // Label 9766: @603477
     /*  603477 */   GIM_Try, /*On fail goto*//*Label 9767*/ GIMT_Encode4(603549), // Rule ID 5151 //
     /*  603482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  603493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  603496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  603499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  603502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603528 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603547 */     GIR_RootConstrainSelectedInstOperands,
     /*  603548 */     // GIR_Coverage, 5151,
     /*  603548 */     GIR_EraseRootFromParent_Done,
     /*  603549 */   // Label 9767: @603549
     /*  603549 */   GIM_Try, /*On fail goto*//*Label 9768*/ GIMT_Encode4(603621), // Rule ID 5152 //
     /*  603554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  603565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  603568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  603571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  603574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603600 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  603600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  603603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603619 */     GIR_RootConstrainSelectedInstOperands,
     /*  603620 */     // GIR_Coverage, 5152,
     /*  603620 */     GIR_EraseRootFromParent_Done,
     /*  603621 */   // Label 9768: @603621
     /*  603621 */   GIM_Try, /*On fail goto*//*Label 9769*/ GIMT_Encode4(603693), // Rule ID 5153 //
     /*  603626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  603637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  603640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  603643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  603646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  603661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603672 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  603672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  603675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  603691 */     GIR_RootConstrainSelectedInstOperands,
     /*  603692 */     // GIR_Coverage, 5153,
     /*  603692 */     GIR_EraseRootFromParent_Done,
     /*  603693 */   // Label 9769: @603693
     /*  603693 */   GIM_Try, /*On fail goto*//*Label 9770*/ GIMT_Encode4(603765), // Rule ID 5154 //
     /*  603698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  603712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  603715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603763 */     GIR_RootConstrainSelectedInstOperands,
     /*  603764 */     // GIR_Coverage, 5154,
     /*  603764 */     GIR_EraseRootFromParent_Done,
     /*  603765 */   // Label 9770: @603765
     /*  603765 */   GIM_Try, /*On fail goto*//*Label 9771*/ GIMT_Encode4(603837), // Rule ID 5155 //
     /*  603770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  603781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  603784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  603787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  603790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  603805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603816 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  603819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603835 */     GIR_RootConstrainSelectedInstOperands,
     /*  603836 */     // GIR_Coverage, 5155,
     /*  603836 */     GIR_EraseRootFromParent_Done,
     /*  603837 */   // Label 9771: @603837
     /*  603837 */   GIM_Try, /*On fail goto*//*Label 9772*/ GIMT_Encode4(603909), // Rule ID 5156 //
     /*  603842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  603856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  603859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  603865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  603888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603907 */     GIR_RootConstrainSelectedInstOperands,
     /*  603908 */     // GIR_Coverage, 5156,
     /*  603908 */     GIR_EraseRootFromParent_Done,
     /*  603909 */   // Label 9772: @603909
     /*  603909 */   GIM_Try, /*On fail goto*//*Label 9773*/ GIMT_Encode4(603981), // Rule ID 5157 //
     /*  603914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  603917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  603925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  603928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  603931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  603934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  603937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  603941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  603949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  603953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  603960 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  603960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  603963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  603965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  603967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  603969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  603971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  603976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  603979 */     GIR_RootConstrainSelectedInstOperands,
     /*  603980 */     // GIR_Coverage, 5157,
     /*  603980 */     GIR_EraseRootFromParent_Done,
     /*  603981 */   // Label 9773: @603981
     /*  603981 */   GIM_Try, /*On fail goto*//*Label 9774*/ GIMT_Encode4(604053), // Rule ID 5158 //
     /*  603986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  603989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  603994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  603997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  604032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604051 */     GIR_RootConstrainSelectedInstOperands,
     /*  604052 */     // GIR_Coverage, 5158,
     /*  604052 */     GIR_EraseRootFromParent_Done,
     /*  604053 */   // Label 9774: @604053
     /*  604053 */   GIM_Try, /*On fail goto*//*Label 9775*/ GIMT_Encode4(604125), // Rule ID 5159 //
     /*  604058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  604069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  604072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  604075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  604078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604104 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  604104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  604123 */     GIR_RootConstrainSelectedInstOperands,
     /*  604124 */     // GIR_Coverage, 5159,
     /*  604124 */     GIR_EraseRootFromParent_Done,
     /*  604125 */   // Label 9775: @604125
     /*  604125 */   GIM_Try, /*On fail goto*//*Label 9776*/ GIMT_Encode4(604197), // Rule ID 5160 //
     /*  604130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604195 */     GIR_RootConstrainSelectedInstOperands,
     /*  604196 */     // GIR_Coverage, 5160,
     /*  604196 */     GIR_EraseRootFromParent_Done,
     /*  604197 */   // Label 9776: @604197
     /*  604197 */   GIM_Try, /*On fail goto*//*Label 9777*/ GIMT_Encode4(604269), // Rule ID 5161 //
     /*  604202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  604216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  604219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604248 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604267 */     GIR_RootConstrainSelectedInstOperands,
     /*  604268 */     // GIR_Coverage, 5161,
     /*  604268 */     GIR_EraseRootFromParent_Done,
     /*  604269 */   // Label 9777: @604269
     /*  604269 */   GIM_Try, /*On fail goto*//*Label 9778*/ GIMT_Encode4(604341), // Rule ID 5162 //
     /*  604274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604339 */     GIR_RootConstrainSelectedInstOperands,
     /*  604340 */     // GIR_Coverage, 5162,
     /*  604340 */     GIR_EraseRootFromParent_Done,
     /*  604341 */   // Label 9778: @604341
     /*  604341 */   GIM_Try, /*On fail goto*//*Label 9779*/ GIMT_Encode4(604413), // Rule ID 5163 //
     /*  604346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  604360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  604363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604411 */     GIR_RootConstrainSelectedInstOperands,
     /*  604412 */     // GIR_Coverage, 5163,
     /*  604412 */     GIR_EraseRootFromParent_Done,
     /*  604413 */   // Label 9779: @604413
     /*  604413 */   GIM_Try, /*On fail goto*//*Label 9780*/ GIMT_Encode4(604485), // Rule ID 5164 //
     /*  604418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  604464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604483 */     GIR_RootConstrainSelectedInstOperands,
     /*  604484 */     // GIR_Coverage, 5164,
     /*  604484 */     GIR_EraseRootFromParent_Done,
     /*  604485 */   // Label 9780: @604485
     /*  604485 */   GIM_Try, /*On fail goto*//*Label 9781*/ GIMT_Encode4(604557), // Rule ID 5165 //
     /*  604490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  604493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  604501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  604504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  604507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  604510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  604536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  604555 */     GIR_RootConstrainSelectedInstOperands,
     /*  604556 */     // GIR_Coverage, 5165,
     /*  604556 */     GIR_EraseRootFromParent_Done,
     /*  604557 */   // Label 9781: @604557
     /*  604557 */   GIM_Try, /*On fail goto*//*Label 9782*/ GIMT_Encode4(604629), // Rule ID 5166 //
     /*  604562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  604565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  604573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  604576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  604579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  604582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604608 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  604608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604627 */     GIR_RootConstrainSelectedInstOperands,
     /*  604628 */     // GIR_Coverage, 5166,
     /*  604628 */     GIR_EraseRootFromParent_Done,
     /*  604629 */   // Label 9782: @604629
     /*  604629 */   GIM_Try, /*On fail goto*//*Label 9783*/ GIMT_Encode4(604701), // Rule ID 5167 //
     /*  604634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  604637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  604645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  604648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  604651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  604654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  604669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604680 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  604680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M2),
     /*  604683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604699 */     GIR_RootConstrainSelectedInstOperands,
     /*  604700 */     // GIR_Coverage, 5167,
     /*  604700 */     GIR_EraseRootFromParent_Done,
     /*  604701 */   // Label 9783: @604701
     /*  604701 */   GIM_Try, /*On fail goto*//*Label 9784*/ GIMT_Encode4(604773), // Rule ID 5168 //
     /*  604706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  604709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  604720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  604723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  604752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604771 */     GIR_RootConstrainSelectedInstOperands,
     /*  604772 */     // GIR_Coverage, 5168,
     /*  604772 */     GIR_EraseRootFromParent_Done,
     /*  604773 */   // Label 9784: @604773
     /*  604773 */   GIM_Try, /*On fail goto*//*Label 9785*/ GIMT_Encode4(604845), // Rule ID 5169 //
     /*  604778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  604781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  604789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  604792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  604795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  604798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  604813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  604824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M4),
     /*  604827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604843 */     GIR_RootConstrainSelectedInstOperands,
     /*  604844 */     // GIR_Coverage, 5169,
     /*  604844 */     GIR_EraseRootFromParent_Done,
     /*  604845 */   // Label 9785: @604845
     /*  604845 */   GIM_Try, /*On fail goto*//*Label 9786*/ GIMT_Encode4(604917), // Rule ID 5170 //
     /*  604850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  604853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  604864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  604867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  604873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  604896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604915 */     GIR_RootConstrainSelectedInstOperands,
     /*  604916 */     // GIR_Coverage, 5170,
     /*  604916 */     GIR_EraseRootFromParent_Done,
     /*  604917 */   // Label 9786: @604917
     /*  604917 */   GIM_Try, /*On fail goto*//*Label 9787*/ GIMT_Encode4(604989), // Rule ID 5171 //
     /*  604922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  604925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  604930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  604933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  604936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  604939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  604942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  604945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  604949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  604957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  604961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  604968 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  604968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VVM_M8),
     /*  604971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  604973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  604975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  604977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  604979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  604984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  604987 */     GIR_RootConstrainSelectedInstOperands,
     /*  604988 */     // GIR_Coverage, 5171,
     /*  604988 */     GIR_EraseRootFromParent_Done,
     /*  604989 */   // Label 9787: @604989
     /*  604989 */   GIM_Try, /*On fail goto*//*Label 9788*/ GIMT_Encode4(605061), // Rule ID 5172 //
     /*  604994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  604997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605059 */     GIR_RootConstrainSelectedInstOperands,
     /*  605060 */     // GIR_Coverage, 5172,
     /*  605060 */     GIR_EraseRootFromParent_Done,
     /*  605061 */   // Label 9788: @605061
     /*  605061 */   GIM_Try, /*On fail goto*//*Label 9789*/ GIMT_Encode4(605133), // Rule ID 5173 //
     /*  605066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  605080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF8),
     /*  605115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605131 */     GIR_RootConstrainSelectedInstOperands,
     /*  605132 */     // GIR_Coverage, 5173,
     /*  605132 */     GIR_EraseRootFromParent_Done,
     /*  605133 */   // Label 9789: @605133
     /*  605133 */   GIM_Try, /*On fail goto*//*Label 9790*/ GIMT_Encode4(605205), // Rule ID 5174 //
     /*  605138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605203 */     GIR_RootConstrainSelectedInstOperands,
     /*  605204 */     // GIR_Coverage, 5174,
     /*  605204 */     GIR_EraseRootFromParent_Done,
     /*  605205 */   // Label 9790: @605205
     /*  605205 */   GIM_Try, /*On fail goto*//*Label 9791*/ GIMT_Encode4(605277), // Rule ID 5175 //
     /*  605210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  605224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605256 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605275 */     GIR_RootConstrainSelectedInstOperands,
     /*  605276 */     // GIR_Coverage, 5175,
     /*  605276 */     GIR_EraseRootFromParent_Done,
     /*  605277 */   // Label 9791: @605277
     /*  605277 */   GIM_Try, /*On fail goto*//*Label 9792*/ GIMT_Encode4(605349), // Rule ID 5176 //
     /*  605282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605347 */     GIR_RootConstrainSelectedInstOperands,
     /*  605348 */     // GIR_Coverage, 5176,
     /*  605348 */     GIR_EraseRootFromParent_Done,
     /*  605349 */   // Label 9792: @605349
     /*  605349 */   GIM_Try, /*On fail goto*//*Label 9793*/ GIMT_Encode4(605421), // Rule ID 5177 //
     /*  605354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  605365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  605368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  605374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605419 */     GIR_RootConstrainSelectedInstOperands,
     /*  605420 */     // GIR_Coverage, 5177,
     /*  605420 */     GIR_EraseRootFromParent_Done,
     /*  605421 */   // Label 9793: @605421
     /*  605421 */   GIM_Try, /*On fail goto*//*Label 9794*/ GIMT_Encode4(605493), // Rule ID 5178 //
     /*  605426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605491 */     GIR_RootConstrainSelectedInstOperands,
     /*  605492 */     // GIR_Coverage, 5178,
     /*  605492 */     GIR_EraseRootFromParent_Done,
     /*  605493 */   // Label 9794: @605493
     /*  605493 */   GIM_Try, /*On fail goto*//*Label 9795*/ GIMT_Encode4(605565), // Rule ID 5179 //
     /*  605498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  605512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605544 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  605544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF4),
     /*  605547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605563 */     GIR_RootConstrainSelectedInstOperands,
     /*  605564 */     // GIR_Coverage, 5179,
     /*  605564 */     GIR_EraseRootFromParent_Done,
     /*  605565 */   // Label 9795: @605565
     /*  605565 */   GIM_Try, /*On fail goto*//*Label 9796*/ GIMT_Encode4(605637), // Rule ID 5180 //
     /*  605570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  605584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  605616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605635 */     GIR_RootConstrainSelectedInstOperands,
     /*  605636 */     // GIR_Coverage, 5180,
     /*  605636 */     GIR_EraseRootFromParent_Done,
     /*  605637 */   // Label 9796: @605637
     /*  605637 */   GIM_Try, /*On fail goto*//*Label 9797*/ GIMT_Encode4(605709), // Rule ID 5181 //
     /*  605642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  605653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  605656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  605662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  605688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  605707 */     GIR_RootConstrainSelectedInstOperands,
     /*  605708 */     // GIR_Coverage, 5181,
     /*  605708 */     GIR_EraseRootFromParent_Done,
     /*  605709 */   // Label 9797: @605709
     /*  605709 */   GIM_Try, /*On fail goto*//*Label 9798*/ GIMT_Encode4(605781), // Rule ID 5182 //
     /*  605714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  605760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605779 */     GIR_RootConstrainSelectedInstOperands,
     /*  605780 */     // GIR_Coverage, 5182,
     /*  605780 */     GIR_EraseRootFromParent_Done,
     /*  605781 */   // Label 9798: @605781
     /*  605781 */   GIM_Try, /*On fail goto*//*Label 9799*/ GIMT_Encode4(605853), // Rule ID 5183 //
     /*  605786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  605797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  605800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  605806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  605832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_MF2),
     /*  605835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  605851 */     GIR_RootConstrainSelectedInstOperands,
     /*  605852 */     // GIR_Coverage, 5183,
     /*  605852 */     GIR_EraseRootFromParent_Done,
     /*  605853 */   // Label 9799: @605853
     /*  605853 */   GIM_Try, /*On fail goto*//*Label 9800*/ GIMT_Encode4(605925), // Rule ID 5184 //
     /*  605858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  605861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  605872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  605875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  605881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605904 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  605904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  605907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605923 */     GIR_RootConstrainSelectedInstOperands,
     /*  605924 */     // GIR_Coverage, 5184,
     /*  605924 */     GIR_EraseRootFromParent_Done,
     /*  605925 */   // Label 9800: @605925
     /*  605925 */   GIM_Try, /*On fail goto*//*Label 9801*/ GIMT_Encode4(605997), // Rule ID 5185 //
     /*  605930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  605933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  605938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  605941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  605944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  605947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  605950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  605953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  605961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  605965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  605969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  605976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  605976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  605979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  605981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  605983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  605985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  605987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  605992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  605995 */     GIR_RootConstrainSelectedInstOperands,
     /*  605996 */     // GIR_Coverage, 5185,
     /*  605996 */     GIR_EraseRootFromParent_Done,
     /*  605997 */   // Label 9801: @605997
     /*  605997 */   GIM_Try, /*On fail goto*//*Label 9802*/ GIMT_Encode4(606069), // Rule ID 5186 //
     /*  606002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606048 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606067 */     GIR_RootConstrainSelectedInstOperands,
     /*  606068 */     // GIR_Coverage, 5186,
     /*  606068 */     GIR_EraseRootFromParent_Done,
     /*  606069 */   // Label 9802: @606069
     /*  606069 */   GIM_Try, /*On fail goto*//*Label 9803*/ GIMT_Encode4(606141), // Rule ID 5187 //
     /*  606074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  606085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  606088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  606094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606120 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606139 */     GIR_RootConstrainSelectedInstOperands,
     /*  606140 */     // GIR_Coverage, 5187,
     /*  606140 */     GIR_EraseRootFromParent_Done,
     /*  606141 */   // Label 9803: @606141
     /*  606141 */   GIM_Try, /*On fail goto*//*Label 9804*/ GIMT_Encode4(606213), // Rule ID 5188 //
     /*  606146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  606192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606211 */     GIR_RootConstrainSelectedInstOperands,
     /*  606212 */     // GIR_Coverage, 5188,
     /*  606212 */     GIR_EraseRootFromParent_Done,
     /*  606213 */   // Label 9804: @606213
     /*  606213 */   GIM_Try, /*On fail goto*//*Label 9805*/ GIMT_Encode4(606285), // Rule ID 5189 //
     /*  606218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  606229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  606232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  606238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606264 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  606264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  606283 */     GIR_RootConstrainSelectedInstOperands,
     /*  606284 */     // GIR_Coverage, 5189,
     /*  606284 */     GIR_EraseRootFromParent_Done,
     /*  606285 */   // Label 9805: @606285
     /*  606285 */   GIM_Try, /*On fail goto*//*Label 9806*/ GIMT_Encode4(606357), // Rule ID 5190 //
     /*  606290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  606293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606336 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  606336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606355 */     GIR_RootConstrainSelectedInstOperands,
     /*  606356 */     // GIR_Coverage, 5190,
     /*  606356 */     GIR_EraseRootFromParent_Done,
     /*  606357 */   // Label 9806: @606357
     /*  606357 */   GIM_Try, /*On fail goto*//*Label 9807*/ GIMT_Encode4(606429), // Rule ID 5191 //
     /*  606362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  606365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  606373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  606376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  606382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606408 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11340:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  606408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M1),
     /*  606411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  606427 */     GIR_RootConstrainSelectedInstOperands,
     /*  606428 */     // GIR_Coverage, 5191,
     /*  606428 */     GIR_EraseRootFromParent_Done,
     /*  606429 */   // Label 9807: @606429
     /*  606429 */   GIM_Try, /*On fail goto*//*Label 9808*/ GIMT_Encode4(606501), // Rule ID 5192 //
     /*  606434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  606445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  606454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  606483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606499 */     GIR_RootConstrainSelectedInstOperands,
     /*  606500 */     // GIR_Coverage, 5192,
     /*  606500 */     GIR_EraseRootFromParent_Done,
     /*  606501 */   // Label 9808: @606501
     /*  606501 */   GIM_Try, /*On fail goto*//*Label 9809*/ GIMT_Encode4(606573), // Rule ID 5193 //
     /*  606506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  606517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  606520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  606526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606552 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  606555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606571 */     GIR_RootConstrainSelectedInstOperands,
     /*  606572 */     // GIR_Coverage, 5193,
     /*  606572 */     GIR_EraseRootFromParent_Done,
     /*  606573 */   // Label 9809: @606573
     /*  606573 */   GIM_Try, /*On fail goto*//*Label 9810*/ GIMT_Encode4(606645), // Rule ID 5194 //
     /*  606578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  606589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  606592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  606598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606624 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  606627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606643 */     GIR_RootConstrainSelectedInstOperands,
     /*  606644 */     // GIR_Coverage, 5194,
     /*  606644 */     GIR_EraseRootFromParent_Done,
     /*  606645 */   // Label 9810: @606645
     /*  606645 */   GIM_Try, /*On fail goto*//*Label 9811*/ GIMT_Encode4(606717), // Rule ID 5195 //
     /*  606650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  606661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  606664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  606670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  606681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  606699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606715 */     GIR_RootConstrainSelectedInstOperands,
     /*  606716 */     // GIR_Coverage, 5195,
     /*  606716 */     GIR_EraseRootFromParent_Done,
     /*  606717 */   // Label 9811: @606717
     /*  606717 */   GIM_Try, /*On fail goto*//*Label 9812*/ GIMT_Encode4(606789), // Rule ID 5196 //
     /*  606722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  606733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  606736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  606742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606768 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  606768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  606771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606787 */     GIR_RootConstrainSelectedInstOperands,
     /*  606788 */     // GIR_Coverage, 5196,
     /*  606788 */     GIR_EraseRootFromParent_Done,
     /*  606789 */   // Label 9812: @606789
     /*  606789 */   GIM_Try, /*On fail goto*//*Label 9813*/ GIMT_Encode4(606861), // Rule ID 5197 //
     /*  606794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  606805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  606808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  606814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  606825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606840 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  606840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  606843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  606859 */     GIR_RootConstrainSelectedInstOperands,
     /*  606860 */     // GIR_Coverage, 5197,
     /*  606860 */     GIR_EraseRootFromParent_Done,
     /*  606861 */   // Label 9813: @606861
     /*  606861 */   GIM_Try, /*On fail goto*//*Label 9814*/ GIMT_Encode4(606933), // Rule ID 5198 //
     /*  606866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  606869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  606880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  606883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  606889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  606912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  606915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  606928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  606931 */     GIR_RootConstrainSelectedInstOperands,
     /*  606932 */     // GIR_Coverage, 5198,
     /*  606932 */     GIR_EraseRootFromParent_Done,
     /*  606933 */   // Label 9814: @606933
     /*  606933 */   GIM_Try, /*On fail goto*//*Label 9815*/ GIMT_Encode4(607005), // Rule ID 5199 //
     /*  606938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  606941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  606946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  606949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  606952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  606955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  606958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  606961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  606965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  606969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  606973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  606977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  606984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  606984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  606987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  606989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  606991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  606993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  606995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607003 */     GIR_RootConstrainSelectedInstOperands,
     /*  607004 */     // GIR_Coverage, 5199,
     /*  607004 */     GIR_EraseRootFromParent_Done,
     /*  607005 */   // Label 9815: @607005
     /*  607005 */   GIM_Try, /*On fail goto*//*Label 9816*/ GIMT_Encode4(607077), // Rule ID 5200 //
     /*  607010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607056 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607075 */     GIR_RootConstrainSelectedInstOperands,
     /*  607076 */     // GIR_Coverage, 5200,
     /*  607076 */     GIR_EraseRootFromParent_Done,
     /*  607077 */   // Label 9816: @607077
     /*  607077 */   GIM_Try, /*On fail goto*//*Label 9817*/ GIMT_Encode4(607149), // Rule ID 5201 //
     /*  607082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  607096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607147 */     GIR_RootConstrainSelectedInstOperands,
     /*  607148 */     // GIR_Coverage, 5201,
     /*  607148 */     GIR_EraseRootFromParent_Done,
     /*  607149 */   // Label 9817: @607149
     /*  607149 */   GIM_Try, /*On fail goto*//*Label 9818*/ GIMT_Encode4(607221), // Rule ID 5202 //
     /*  607154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607200 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  607200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607219 */     GIR_RootConstrainSelectedInstOperands,
     /*  607220 */     // GIR_Coverage, 5202,
     /*  607220 */     GIR_EraseRootFromParent_Done,
     /*  607221 */   // Label 9818: @607221
     /*  607221 */   GIM_Try, /*On fail goto*//*Label 9819*/ GIMT_Encode4(607293), // Rule ID 5203 //
     /*  607226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  607237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  607240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  607246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  607272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  607291 */     GIR_RootConstrainSelectedInstOperands,
     /*  607292 */     // GIR_Coverage, 5203,
     /*  607292 */     GIR_EraseRootFromParent_Done,
     /*  607293 */   // Label 9819: @607293
     /*  607293 */   GIM_Try, /*On fail goto*//*Label 9820*/ GIMT_Encode4(607365), // Rule ID 5204 //
     /*  607298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607363 */     GIR_RootConstrainSelectedInstOperands,
     /*  607364 */     // GIR_Coverage, 5204,
     /*  607364 */     GIR_EraseRootFromParent_Done,
     /*  607365 */   // Label 9820: @607365
     /*  607365 */   GIM_Try, /*On fail goto*//*Label 9821*/ GIMT_Encode4(607437), // Rule ID 5205 //
     /*  607370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  607384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607435 */     GIR_RootConstrainSelectedInstOperands,
     /*  607436 */     // GIR_Coverage, 5205,
     /*  607436 */     GIR_EraseRootFromParent_Done,
     /*  607437 */   // Label 9821: @607437
     /*  607437 */   GIM_Try, /*On fail goto*//*Label 9822*/ GIMT_Encode4(607509), // Rule ID 5206 //
     /*  607442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607488 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607507 */     GIR_RootConstrainSelectedInstOperands,
     /*  607508 */     // GIR_Coverage, 5206,
     /*  607508 */     GIR_EraseRootFromParent_Done,
     /*  607509 */   // Label 9822: @607509
     /*  607509 */   GIM_Try, /*On fail goto*//*Label 9823*/ GIMT_Encode4(607581), // Rule ID 5207 //
     /*  607514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  607525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  607528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  607534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607579 */     GIR_RootConstrainSelectedInstOperands,
     /*  607580 */     // GIR_Coverage, 5207,
     /*  607580 */     GIR_EraseRootFromParent_Done,
     /*  607581 */   // Label 9823: @607581
     /*  607581 */   GIM_Try, /*On fail goto*//*Label 9824*/ GIMT_Encode4(607653), // Rule ID 5208 //
     /*  607586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  607589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  607600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607632 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  607632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607651 */     GIR_RootConstrainSelectedInstOperands,
     /*  607652 */     // GIR_Coverage, 5208,
     /*  607652 */     GIR_EraseRootFromParent_Done,
     /*  607653 */   // Label 9824: @607653
     /*  607653 */   GIM_Try, /*On fail goto*//*Label 9825*/ GIMT_Encode4(607725), // Rule ID 5209 //
     /*  607658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  607661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  607669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  607672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  607678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  607689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  607704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  607707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  607723 */     GIR_RootConstrainSelectedInstOperands,
     /*  607724 */     // GIR_Coverage, 5209,
     /*  607724 */     GIR_EraseRootFromParent_Done,
     /*  607725 */   // Label 9825: @607725
     /*  607725 */   GIM_Try, /*On fail goto*//*Label 9826*/ GIMT_Encode4(607797), // Rule ID 5210 //
     /*  607730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  607744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607776 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607795 */     GIR_RootConstrainSelectedInstOperands,
     /*  607796 */     // GIR_Coverage, 5210,
     /*  607796 */     GIR_EraseRootFromParent_Done,
     /*  607797 */   // Label 9826: @607797
     /*  607797 */   GIM_Try, /*On fail goto*//*Label 9827*/ GIMT_Encode4(607869), // Rule ID 5211 //
     /*  607802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  607813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  607816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  607822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  607833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11340:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M2),
     /*  607851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607867 */     GIR_RootConstrainSelectedInstOperands,
     /*  607868 */     // GIR_Coverage, 5211,
     /*  607868 */     GIR_EraseRootFromParent_Done,
     /*  607869 */   // Label 9827: @607869
     /*  607869 */   GIM_Try, /*On fail goto*//*Label 9828*/ GIMT_Encode4(607941), // Rule ID 5212 //
     /*  607874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  607877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  607888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  607891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  607897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  607920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  607929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  607931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  607936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  607939 */     GIR_RootConstrainSelectedInstOperands,
     /*  607940 */     // GIR_Coverage, 5212,
     /*  607940 */     GIR_EraseRootFromParent_Done,
     /*  607941 */   // Label 9828: @607941
     /*  607941 */   GIM_Try, /*On fail goto*//*Label 9829*/ GIMT_Encode4(608013), // Rule ID 5213 //
     /*  607946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  607949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  607954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  607957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  607960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  607963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  607966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  607969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  607973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  607977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  607981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  607985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  607992 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11340:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  607992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M4),
     /*  607995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  607997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  607999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608011 */     GIR_RootConstrainSelectedInstOperands,
     /*  608012 */     // GIR_Coverage, 5213,
     /*  608012 */     GIR_EraseRootFromParent_Done,
     /*  608013 */   // Label 9829: @608013
     /*  608013 */   GIM_Try, /*On fail goto*//*Label 9830*/ GIMT_Encode4(608085), // Rule ID 5214 //
     /*  608018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  608021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  608035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  608064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608083 */     GIR_RootConstrainSelectedInstOperands,
     /*  608084 */     // GIR_Coverage, 5214,
     /*  608084 */     GIR_EraseRootFromParent_Done,
     /*  608085 */   // Label 9830: @608085
     /*  608085 */   GIM_Try, /*On fail goto*//*Label 9831*/ GIMT_Encode4(608157), // Rule ID 5215 //
     /*  608090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  608093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadc_carry_in),
     /*  608098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  608101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  608104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  608107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  608110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  608121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  608125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608136 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11340:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMADC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  608136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADC_VXM_M8),
     /*  608139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  608155 */     GIR_RootConstrainSelectedInstOperands,
     /*  608156 */     // GIR_Coverage, 5215,
     /*  608156 */     GIR_EraseRootFromParent_Done,
     /*  608157 */   // Label 9831: @608157
     /*  608157 */   GIM_Try, /*On fail goto*//*Label 9832*/ GIMT_Encode4(608229), // Rule ID 5478 //
     /*  608162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608227 */     GIR_RootConstrainSelectedInstOperands,
     /*  608228 */     // GIR_Coverage, 5478,
     /*  608228 */     GIR_EraseRootFromParent_Done,
     /*  608229 */   // Label 9832: @608229
     /*  608229 */   GIM_Try, /*On fail goto*//*Label 9833*/ GIMT_Encode4(608301), // Rule ID 5479 //
     /*  608234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  608248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  608251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608280 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF8),
     /*  608283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608299 */     GIR_RootConstrainSelectedInstOperands,
     /*  608300 */     // GIR_Coverage, 5479,
     /*  608300 */     GIR_EraseRootFromParent_Done,
     /*  608301 */   // Label 9833: @608301
     /*  608301 */   GIM_Try, /*On fail goto*//*Label 9834*/ GIMT_Encode4(608373), // Rule ID 5480 //
     /*  608306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608371 */     GIR_RootConstrainSelectedInstOperands,
     /*  608372 */     // GIR_Coverage, 5480,
     /*  608372 */     GIR_EraseRootFromParent_Done,
     /*  608373 */   // Label 9834: @608373
     /*  608373 */   GIM_Try, /*On fail goto*//*Label 9835*/ GIMT_Encode4(608445), // Rule ID 5481 //
     /*  608378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  608392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  608395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608443 */     GIR_RootConstrainSelectedInstOperands,
     /*  608444 */     // GIR_Coverage, 5481,
     /*  608444 */     GIR_EraseRootFromParent_Done,
     /*  608445 */   // Label 9835: @608445
     /*  608445 */   GIM_Try, /*On fail goto*//*Label 9836*/ GIMT_Encode4(608517), // Rule ID 5482 //
     /*  608450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  608464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  608467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  608496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  608499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608515 */     GIR_RootConstrainSelectedInstOperands,
     /*  608516 */     // GIR_Coverage, 5482,
     /*  608516 */     GIR_EraseRootFromParent_Done,
     /*  608517 */   // Label 9836: @608517
     /*  608517 */   GIM_Try, /*On fail goto*//*Label 9837*/ GIMT_Encode4(608589), // Rule ID 5483 //
     /*  608522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  608533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  608536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  608539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  608542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  608568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  608571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  608587 */     GIR_RootConstrainSelectedInstOperands,
     /*  608588 */     // GIR_Coverage, 5483,
     /*  608588 */     GIR_EraseRootFromParent_Done,
     /*  608589 */   // Label 9837: @608589
     /*  608589 */   GIM_Try, /*On fail goto*//*Label 9838*/ GIMT_Encode4(608661), // Rule ID 5484 //
     /*  608594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  608608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  608611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608640 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608659 */     GIR_RootConstrainSelectedInstOperands,
     /*  608660 */     // GIR_Coverage, 5484,
     /*  608660 */     GIR_EraseRootFromParent_Done,
     /*  608661 */   // Label 9838: @608661
     /*  608661 */   GIM_Try, /*On fail goto*//*Label 9839*/ GIMT_Encode4(608733), // Rule ID 5485 //
     /*  608666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  608680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  608683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF4),
     /*  608715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608731 */     GIR_RootConstrainSelectedInstOperands,
     /*  608732 */     // GIR_Coverage, 5485,
     /*  608732 */     GIR_EraseRootFromParent_Done,
     /*  608733 */   // Label 9839: @608733
     /*  608733 */   GIM_Try, /*On fail goto*//*Label 9840*/ GIMT_Encode4(608805), // Rule ID 5486 //
     /*  608738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  608752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  608755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608784 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  608784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  608787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608803 */     GIR_RootConstrainSelectedInstOperands,
     /*  608804 */     // GIR_Coverage, 5486,
     /*  608804 */     GIR_EraseRootFromParent_Done,
     /*  608805 */   // Label 9840: @608805
     /*  608805 */   GIM_Try, /*On fail goto*//*Label 9841*/ GIMT_Encode4(608877), // Rule ID 5487 //
     /*  608810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  608821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  608824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  608827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  608830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  608856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  608859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  608875 */     GIR_RootConstrainSelectedInstOperands,
     /*  608876 */     // GIR_Coverage, 5487,
     /*  608876 */     GIR_EraseRootFromParent_Done,
     /*  608877 */   // Label 9841: @608877
     /*  608877 */   GIM_Try, /*On fail goto*//*Label 9842*/ GIMT_Encode4(608949), // Rule ID 5488 //
     /*  608882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  608885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  608896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  608899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  608905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  608928 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  608928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  608931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  608933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  608935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  608937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  608939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  608944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  608947 */     GIR_RootConstrainSelectedInstOperands,
     /*  608948 */     // GIR_Coverage, 5488,
     /*  608948 */     GIR_EraseRootFromParent_Done,
     /*  608949 */   // Label 9842: @608949
     /*  608949 */   GIM_Try, /*On fail goto*//*Label 9843*/ GIMT_Encode4(609021), // Rule ID 5489 //
     /*  608954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  608957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  608962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  608965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  608968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  608971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  608974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  608977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  608989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  608993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609000 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_MF2),
     /*  609003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609019 */     GIR_RootConstrainSelectedInstOperands,
     /*  609020 */     // GIR_Coverage, 5489,
     /*  609020 */     GIR_EraseRootFromParent_Done,
     /*  609021 */   // Label 9843: @609021
     /*  609021 */   GIM_Try, /*On fail goto*//*Label 9844*/ GIMT_Encode4(609093), // Rule ID 5490 //
     /*  609026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609091 */     GIR_RootConstrainSelectedInstOperands,
     /*  609092 */     // GIR_Coverage, 5490,
     /*  609092 */     GIR_EraseRootFromParent_Done,
     /*  609093 */   // Label 9844: @609093
     /*  609093 */   GIM_Try, /*On fail goto*//*Label 9845*/ GIMT_Encode4(609165), // Rule ID 5491 //
     /*  609098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  609109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  609112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  609115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  609118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609163 */     GIR_RootConstrainSelectedInstOperands,
     /*  609164 */     // GIR_Coverage, 5491,
     /*  609164 */     GIR_EraseRootFromParent_Done,
     /*  609165 */   // Label 9845: @609165
     /*  609165 */   GIM_Try, /*On fail goto*//*Label 9846*/ GIMT_Encode4(609237), // Rule ID 5492 //
     /*  609170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  609216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609235 */     GIR_RootConstrainSelectedInstOperands,
     /*  609236 */     // GIR_Coverage, 5492,
     /*  609236 */     GIR_EraseRootFromParent_Done,
     /*  609237 */   // Label 9846: @609237
     /*  609237 */   GIM_Try, /*On fail goto*//*Label 9847*/ GIMT_Encode4(609309), // Rule ID 5493 //
     /*  609242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  609253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  609256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  609259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  609262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609288 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  609288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  609307 */     GIR_RootConstrainSelectedInstOperands,
     /*  609308 */     // GIR_Coverage, 5493,
     /*  609308 */     GIR_EraseRootFromParent_Done,
     /*  609309 */   // Label 9847: @609309
     /*  609309 */   GIM_Try, /*On fail goto*//*Label 9848*/ GIMT_Encode4(609381), // Rule ID 5494 //
     /*  609314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  609360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609379 */     GIR_RootConstrainSelectedInstOperands,
     /*  609380 */     // GIR_Coverage, 5494,
     /*  609380 */     GIR_EraseRootFromParent_Done,
     /*  609381 */   // Label 9848: @609381
     /*  609381 */   GIM_Try, /*On fail goto*//*Label 9849*/ GIMT_Encode4(609453), // Rule ID 5495 //
     /*  609386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  609397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  609400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  609403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  609406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  609432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  609451 */     GIR_RootConstrainSelectedInstOperands,
     /*  609452 */     // GIR_Coverage, 5495,
     /*  609452 */     GIR_EraseRootFromParent_Done,
     /*  609453 */   // Label 9849: @609453
     /*  609453 */   GIM_Try, /*On fail goto*//*Label 9850*/ GIMT_Encode4(609525), // Rule ID 5496 //
     /*  609458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  609461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  609472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  609475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  609504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609523 */     GIR_RootConstrainSelectedInstOperands,
     /*  609524 */     // GIR_Coverage, 5496,
     /*  609524 */     GIR_EraseRootFromParent_Done,
     /*  609525 */   // Label 9850: @609525
     /*  609525 */   GIM_Try, /*On fail goto*//*Label 9851*/ GIMT_Encode4(609597), // Rule ID 5497 //
     /*  609530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  609533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  609541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  609544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  609547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  609550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609576 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  609576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M1),
     /*  609579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  609595 */     GIR_RootConstrainSelectedInstOperands,
     /*  609596 */     // GIR_Coverage, 5497,
     /*  609596 */     GIR_EraseRootFromParent_Done,
     /*  609597 */   // Label 9851: @609597
     /*  609597 */   GIM_Try, /*On fail goto*//*Label 9852*/ GIMT_Encode4(609669), // Rule ID 5498 //
     /*  609602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  609613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  609616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  609619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  609622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  609651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609667 */     GIR_RootConstrainSelectedInstOperands,
     /*  609668 */     // GIR_Coverage, 5498,
     /*  609668 */     GIR_EraseRootFromParent_Done,
     /*  609669 */   // Label 9852: @609669
     /*  609669 */   GIM_Try, /*On fail goto*//*Label 9853*/ GIMT_Encode4(609741), // Rule ID 5499 //
     /*  609674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  609685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  609688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  609691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  609694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  609709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609720 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  609723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609739 */     GIR_RootConstrainSelectedInstOperands,
     /*  609740 */     // GIR_Coverage, 5499,
     /*  609740 */     GIR_EraseRootFromParent_Done,
     /*  609741 */   // Label 9853: @609741
     /*  609741 */   GIM_Try, /*On fail goto*//*Label 9854*/ GIMT_Encode4(609813), // Rule ID 5500 //
     /*  609746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  609757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  609760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  609763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  609766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  609795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609811 */     GIR_RootConstrainSelectedInstOperands,
     /*  609812 */     // GIR_Coverage, 5500,
     /*  609812 */     GIR_EraseRootFromParent_Done,
     /*  609813 */   // Label 9854: @609813
     /*  609813 */   GIM_Try, /*On fail goto*//*Label 9855*/ GIMT_Encode4(609885), // Rule ID 5501 //
     /*  609818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  609829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  609832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  609835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  609838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  609853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609864 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  609864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  609867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609883 */     GIR_RootConstrainSelectedInstOperands,
     /*  609884 */     // GIR_Coverage, 5501,
     /*  609884 */     GIR_EraseRootFromParent_Done,
     /*  609885 */   // Label 9855: @609885
     /*  609885 */   GIM_Try, /*On fail goto*//*Label 9856*/ GIMT_Encode4(609957), // Rule ID 5502 //
     /*  609890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  609893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  609901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  609904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  609907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  609910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  609913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  609929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  609936 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  609936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  609939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  609941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  609943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  609945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  609947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  609952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  609955 */     GIR_RootConstrainSelectedInstOperands,
     /*  609956 */     // GIR_Coverage, 5502,
     /*  609956 */     GIR_EraseRootFromParent_Done,
     /*  609957 */   // Label 9856: @609957
     /*  609957 */   GIM_Try, /*On fail goto*//*Label 9857*/ GIMT_Encode4(610029), // Rule ID 5503 //
     /*  609962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  609965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  609970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  609973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  609976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  609979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  609982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  609985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  609989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  609997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610008 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  610008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  610027 */     GIR_RootConstrainSelectedInstOperands,
     /*  610028 */     // GIR_Coverage, 5503,
     /*  610028 */     GIR_EraseRootFromParent_Done,
     /*  610029 */   // Label 9857: @610029
     /*  610029 */   GIM_Try, /*On fail goto*//*Label 9858*/ GIMT_Encode4(610101), // Rule ID 5504 //
     /*  610034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610080 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610099 */     GIR_RootConstrainSelectedInstOperands,
     /*  610100 */     // GIR_Coverage, 5504,
     /*  610100 */     GIR_EraseRootFromParent_Done,
     /*  610101 */   // Label 9858: @610101
     /*  610101 */   GIM_Try, /*On fail goto*//*Label 9859*/ GIMT_Encode4(610173), // Rule ID 5505 //
     /*  610106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  610120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  610123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610171 */     GIR_RootConstrainSelectedInstOperands,
     /*  610172 */     // GIR_Coverage, 5505,
     /*  610172 */     GIR_EraseRootFromParent_Done,
     /*  610173 */   // Label 9859: @610173
     /*  610173 */   GIM_Try, /*On fail goto*//*Label 9860*/ GIMT_Encode4(610245), // Rule ID 5506 //
     /*  610178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610224 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610243 */     GIR_RootConstrainSelectedInstOperands,
     /*  610244 */     // GIR_Coverage, 5506,
     /*  610244 */     GIR_EraseRootFromParent_Done,
     /*  610245 */   // Label 9860: @610245
     /*  610245 */   GIM_Try, /*On fail goto*//*Label 9861*/ GIMT_Encode4(610317), // Rule ID 5507 //
     /*  610250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  610264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  610267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610296 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610315 */     GIR_RootConstrainSelectedInstOperands,
     /*  610316 */     // GIR_Coverage, 5507,
     /*  610316 */     GIR_EraseRootFromParent_Done,
     /*  610317 */   // Label 9861: @610317
     /*  610317 */   GIM_Try, /*On fail goto*//*Label 9862*/ GIMT_Encode4(610389), // Rule ID 5508 //
     /*  610322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610368 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  610368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610387 */     GIR_RootConstrainSelectedInstOperands,
     /*  610388 */     // GIR_Coverage, 5508,
     /*  610388 */     GIR_EraseRootFromParent_Done,
     /*  610389 */   // Label 9862: @610389
     /*  610389 */   GIM_Try, /*On fail goto*//*Label 9863*/ GIMT_Encode4(610461), // Rule ID 5509 //
     /*  610394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  610405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  610408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  610411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  610414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610440 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  610440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  610459 */     GIR_RootConstrainSelectedInstOperands,
     /*  610460 */     // GIR_Coverage, 5509,
     /*  610460 */     GIR_EraseRootFromParent_Done,
     /*  610461 */   // Label 9863: @610461
     /*  610461 */   GIM_Try, /*On fail goto*//*Label 9864*/ GIMT_Encode4(610533), // Rule ID 5510 //
     /*  610466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  610480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  610483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610531 */     GIR_RootConstrainSelectedInstOperands,
     /*  610532 */     // GIR_Coverage, 5510,
     /*  610532 */     GIR_EraseRootFromParent_Done,
     /*  610533 */   // Label 9864: @610533
     /*  610533 */   GIM_Try, /*On fail goto*//*Label 9865*/ GIMT_Encode4(610605), // Rule ID 5511 //
     /*  610538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  610549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  610552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  610555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  610558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610584 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610603 */     GIR_RootConstrainSelectedInstOperands,
     /*  610604 */     // GIR_Coverage, 5511,
     /*  610604 */     GIR_EraseRootFromParent_Done,
     /*  610605 */   // Label 9865: @610605
     /*  610605 */   GIM_Try, /*On fail goto*//*Label 9866*/ GIMT_Encode4(610677), // Rule ID 5512 //
     /*  610610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  610624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  610627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610656 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610675 */     GIR_RootConstrainSelectedInstOperands,
     /*  610676 */     // GIR_Coverage, 5512,
     /*  610676 */     GIR_EraseRootFromParent_Done,
     /*  610677 */   // Label 9866: @610677
     /*  610677 */   GIM_Try, /*On fail goto*//*Label 9867*/ GIMT_Encode4(610749), // Rule ID 5513 //
     /*  610682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  610693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  610696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  610699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  610702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  610717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610728 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  610731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610747 */     GIR_RootConstrainSelectedInstOperands,
     /*  610748 */     // GIR_Coverage, 5513,
     /*  610748 */     GIR_EraseRootFromParent_Done,
     /*  610749 */   // Label 9867: @610749
     /*  610749 */   GIM_Try, /*On fail goto*//*Label 9868*/ GIMT_Encode4(610821), // Rule ID 5514 //
     /*  610754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  610757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  610768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  610771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  610800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610819 */     GIR_RootConstrainSelectedInstOperands,
     /*  610820 */     // GIR_Coverage, 5514,
     /*  610820 */     GIR_EraseRootFromParent_Done,
     /*  610821 */   // Label 9868: @610821
     /*  610821 */   GIM_Try, /*On fail goto*//*Label 9869*/ GIMT_Encode4(610893), // Rule ID 5515 //
     /*  610826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  610829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  610837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  610840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  610843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  610846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  610861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  610872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  610875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  610891 */     GIR_RootConstrainSelectedInstOperands,
     /*  610892 */     // GIR_Coverage, 5515,
     /*  610892 */     GIR_EraseRootFromParent_Done,
     /*  610893 */   // Label 9869: @610893
     /*  610893 */   GIM_Try, /*On fail goto*//*Label 9870*/ GIMT_Encode4(610965), // Rule ID 5516 //
     /*  610898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  610901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  610912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  610915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  610921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  610933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  610937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  610944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  610944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  610947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  610949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  610951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  610953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  610955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  610960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  610963 */     GIR_RootConstrainSelectedInstOperands,
     /*  610964 */     // GIR_Coverage, 5516,
     /*  610964 */     GIR_EraseRootFromParent_Done,
     /*  610965 */   // Label 9870: @610965
     /*  610965 */   GIM_Try, /*On fail goto*//*Label 9871*/ GIMT_Encode4(611037), // Rule ID 5517 //
     /*  610970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  610973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  610978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  610981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  610984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  610987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  610990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  610993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  610997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  611005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M2),
     /*  611019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611035 */     GIR_RootConstrainSelectedInstOperands,
     /*  611036 */     // GIR_Coverage, 5517,
     /*  611036 */     GIR_EraseRootFromParent_Done,
     /*  611037 */   // Label 9871: @611037
     /*  611037 */   GIM_Try, /*On fail goto*//*Label 9872*/ GIMT_Encode4(611109), // Rule ID 5518 //
     /*  611042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611107 */     GIR_RootConstrainSelectedInstOperands,
     /*  611108 */     // GIR_Coverage, 5518,
     /*  611108 */     GIR_EraseRootFromParent_Done,
     /*  611109 */   // Label 9872: @611109
     /*  611109 */   GIM_Try, /*On fail goto*//*Label 9873*/ GIMT_Encode4(611181), // Rule ID 5519 //
     /*  611114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  611128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  611131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  611149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M4),
     /*  611163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611179 */     GIR_RootConstrainSelectedInstOperands,
     /*  611180 */     // GIR_Coverage, 5519,
     /*  611180 */     GIR_EraseRootFromParent_Done,
     /*  611181 */   // Label 9873: @611181
     /*  611181 */   GIM_Try, /*On fail goto*//*Label 9874*/ GIMT_Encode4(611253), // Rule ID 5520 //
     /*  611186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  611189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611232 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  611232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611251 */     GIR_RootConstrainSelectedInstOperands,
     /*  611252 */     // GIR_Coverage, 5520,
     /*  611252 */     GIR_EraseRootFromParent_Done,
     /*  611253 */   // Label 9874: @611253
     /*  611253 */   GIM_Try, /*On fail goto*//*Label 9875*/ GIMT_Encode4(611325), // Rule ID 5521 //
     /*  611258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  611261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  611269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  611272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  611275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  611278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  611293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VVM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  611304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VVM_M8),
     /*  611307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  611323 */     GIR_RootConstrainSelectedInstOperands,
     /*  611324 */     // GIR_Coverage, 5521,
     /*  611324 */     GIR_EraseRootFromParent_Done,
     /*  611325 */   // Label 9875: @611325
     /*  611325 */   GIM_Try, /*On fail goto*//*Label 9876*/ GIMT_Encode4(611397), // Rule ID 5522 //
     /*  611330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611395 */     GIR_RootConstrainSelectedInstOperands,
     /*  611396 */     // GIR_Coverage, 5522,
     /*  611396 */     GIR_EraseRootFromParent_Done,
     /*  611397 */   // Label 9876: @611397
     /*  611397 */   GIM_Try, /*On fail goto*//*Label 9877*/ GIMT_Encode4(611469), // Rule ID 5523 //
     /*  611402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  611416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF8),
     /*  611451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611467 */     GIR_RootConstrainSelectedInstOperands,
     /*  611468 */     // GIR_Coverage, 5523,
     /*  611468 */     GIR_EraseRootFromParent_Done,
     /*  611469 */   // Label 9877: @611469
     /*  611469 */   GIM_Try, /*On fail goto*//*Label 9878*/ GIMT_Encode4(611541), // Rule ID 5524 //
     /*  611474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  611488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  611523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611539 */     GIR_RootConstrainSelectedInstOperands,
     /*  611540 */     // GIR_Coverage, 5524,
     /*  611540 */     GIR_EraseRootFromParent_Done,
     /*  611541 */   // Label 9878: @611541
     /*  611541 */   GIM_Try, /*On fail goto*//*Label 9879*/ GIMT_Encode4(611613), // Rule ID 5525 //
     /*  611546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  611560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611592 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  611595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611611 */     GIR_RootConstrainSelectedInstOperands,
     /*  611612 */     // GIR_Coverage, 5525,
     /*  611612 */     GIR_EraseRootFromParent_Done,
     /*  611613 */   // Label 9879: @611613
     /*  611613 */   GIM_Try, /*On fail goto*//*Label 9880*/ GIMT_Encode4(611685), // Rule ID 5526 //
     /*  611618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  611632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611664 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  611664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  611667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611683 */     GIR_RootConstrainSelectedInstOperands,
     /*  611684 */     // GIR_Coverage, 5526,
     /*  611684 */     GIR_EraseRootFromParent_Done,
     /*  611685 */   // Label 9880: @611685
     /*  611685 */   GIM_Try, /*On fail goto*//*Label 9881*/ GIMT_Encode4(611757), // Rule ID 5527 //
     /*  611690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  611701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  611704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  611710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  611736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  611739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  611755 */     GIR_RootConstrainSelectedInstOperands,
     /*  611756 */     // GIR_Coverage, 5527,
     /*  611756 */     GIR_EraseRootFromParent_Done,
     /*  611757 */   // Label 9881: @611757
     /*  611757 */   GIM_Try, /*On fail goto*//*Label 9882*/ GIMT_Encode4(611829), // Rule ID 5528 //
     /*  611762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  611776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  611811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611827 */     GIR_RootConstrainSelectedInstOperands,
     /*  611828 */     // GIR_Coverage, 5528,
     /*  611828 */     GIR_EraseRootFromParent_Done,
     /*  611829 */   // Label 9882: @611829
     /*  611829 */   GIM_Try, /*On fail goto*//*Label 9883*/ GIMT_Encode4(611901), // Rule ID 5529 //
     /*  611834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  611845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  611848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  611854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  611857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611880 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  611880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF4),
     /*  611883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611899 */     GIR_RootConstrainSelectedInstOperands,
     /*  611900 */     // GIR_Coverage, 5529,
     /*  611900 */     GIR_EraseRootFromParent_Done,
     /*  611901 */   // Label 9883: @611901
     /*  611901 */   GIM_Try, /*On fail goto*//*Label 9884*/ GIMT_Encode4(611973), // Rule ID 5530 //
     /*  611906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  611909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  611920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  611923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  611929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  611937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  611941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  611945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  611952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  611952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  611955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  611957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  611959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  611961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  611963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  611968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  611971 */     GIR_RootConstrainSelectedInstOperands,
     /*  611972 */     // GIR_Coverage, 5530,
     /*  611972 */     GIR_EraseRootFromParent_Done,
     /*  611973 */   // Label 9884: @611973
     /*  611973 */   GIM_Try, /*On fail goto*//*Label 9885*/ GIMT_Encode4(612045), // Rule ID 5531 //
     /*  611978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  611981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  611986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  611989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  611992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  611995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  611998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612043 */     GIR_RootConstrainSelectedInstOperands,
     /*  612044 */     // GIR_Coverage, 5531,
     /*  612044 */     GIR_EraseRootFromParent_Done,
     /*  612045 */   // Label 9885: @612045
     /*  612045 */   GIM_Try, /*On fail goto*//*Label 9886*/ GIMT_Encode4(612117), // Rule ID 5532 //
     /*  612050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612096 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  612096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612115 */     GIR_RootConstrainSelectedInstOperands,
     /*  612116 */     // GIR_Coverage, 5532,
     /*  612116 */     GIR_EraseRootFromParent_Done,
     /*  612117 */   // Label 9886: @612117
     /*  612117 */   GIM_Try, /*On fail goto*//*Label 9887*/ GIMT_Encode4(612189), // Rule ID 5533 //
     /*  612122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  612136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_MF2),
     /*  612171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612187 */     GIR_RootConstrainSelectedInstOperands,
     /*  612188 */     // GIR_Coverage, 5533,
     /*  612188 */     GIR_EraseRootFromParent_Done,
     /*  612189 */   // Label 9887: @612189
     /*  612189 */   GIM_Try, /*On fail goto*//*Label 9888*/ GIMT_Encode4(612261), // Rule ID 5534 //
     /*  612194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612259 */     GIR_RootConstrainSelectedInstOperands,
     /*  612260 */     // GIR_Coverage, 5534,
     /*  612260 */     GIR_EraseRootFromParent_Done,
     /*  612261 */   // Label 9888: @612261
     /*  612261 */   GIM_Try, /*On fail goto*//*Label 9889*/ GIMT_Encode4(612333), // Rule ID 5535 //
     /*  612266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  612277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  612280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  612286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612331 */     GIR_RootConstrainSelectedInstOperands,
     /*  612332 */     // GIR_Coverage, 5535,
     /*  612332 */     GIR_EraseRootFromParent_Done,
     /*  612333 */   // Label 9889: @612333
     /*  612333 */   GIM_Try, /*On fail goto*//*Label 9890*/ GIMT_Encode4(612405), // Rule ID 5536 //
     /*  612338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  612384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612403 */     GIR_RootConstrainSelectedInstOperands,
     /*  612404 */     // GIR_Coverage, 5536,
     /*  612404 */     GIR_EraseRootFromParent_Done,
     /*  612405 */   // Label 9890: @612405
     /*  612405 */   GIM_Try, /*On fail goto*//*Label 9891*/ GIMT_Encode4(612477), // Rule ID 5537 //
     /*  612410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  612421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  612424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  612430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  612456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  612475 */     GIR_RootConstrainSelectedInstOperands,
     /*  612476 */     // GIR_Coverage, 5537,
     /*  612476 */     GIR_EraseRootFromParent_Done,
     /*  612477 */   // Label 9891: @612477
     /*  612477 */   GIM_Try, /*On fail goto*//*Label 9892*/ GIMT_Encode4(612549), // Rule ID 5538 //
     /*  612482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  612496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  612528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612547 */     GIR_RootConstrainSelectedInstOperands,
     /*  612548 */     // GIR_Coverage, 5538,
     /*  612548 */     GIR_EraseRootFromParent_Done,
     /*  612549 */   // Label 9892: @612549
     /*  612549 */   GIM_Try, /*On fail goto*//*Label 9893*/ GIMT_Encode4(612621), // Rule ID 5539 //
     /*  612554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  612565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  612568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  612574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612600 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  612600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  612619 */     GIR_RootConstrainSelectedInstOperands,
     /*  612620 */     // GIR_Coverage, 5539,
     /*  612620 */     GIR_EraseRootFromParent_Done,
     /*  612621 */   // Label 9893: @612621
     /*  612621 */   GIM_Try, /*On fail goto*//*Label 9894*/ GIMT_Encode4(612693), // Rule ID 5540 //
     /*  612626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  612629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  612640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  612672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612691 */     GIR_RootConstrainSelectedInstOperands,
     /*  612692 */     // GIR_Coverage, 5540,
     /*  612692 */     GIR_EraseRootFromParent_Done,
     /*  612693 */   // Label 9894: @612693
     /*  612693 */   GIM_Try, /*On fail goto*//*Label 9895*/ GIMT_Encode4(612765), // Rule ID 5541 //
     /*  612698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  612701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  612709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  612712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  612718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11372:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  612744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M1),
     /*  612747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  612763 */     GIR_RootConstrainSelectedInstOperands,
     /*  612764 */     // GIR_Coverage, 5541,
     /*  612764 */     GIR_EraseRootFromParent_Done,
     /*  612765 */   // Label 9895: @612765
     /*  612765 */   GIM_Try, /*On fail goto*//*Label 9896*/ GIMT_Encode4(612837), // Rule ID 5542 //
     /*  612770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  612781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  612784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  612790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612816 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  612819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612835 */     GIR_RootConstrainSelectedInstOperands,
     /*  612836 */     // GIR_Coverage, 5542,
     /*  612836 */     GIR_EraseRootFromParent_Done,
     /*  612837 */   // Label 9896: @612837
     /*  612837 */   GIM_Try, /*On fail goto*//*Label 9897*/ GIMT_Encode4(612909), // Rule ID 5543 //
     /*  612842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  612853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  612856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  612859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  612862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  612865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  612873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  612888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  612891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612907 */     GIR_RootConstrainSelectedInstOperands,
     /*  612908 */     // GIR_Coverage, 5543,
     /*  612908 */     GIR_EraseRootFromParent_Done,
     /*  612909 */   // Label 9897: @612909
     /*  612909 */   GIM_Try, /*On fail goto*//*Label 9898*/ GIMT_Encode4(612981), // Rule ID 5544 //
     /*  612914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  612917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  612925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  612928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  612931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  612934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  612937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  612941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  612945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  612949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  612953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  612960 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  612960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  612963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  612965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  612967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  612969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  612971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  612976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  612979 */     GIR_RootConstrainSelectedInstOperands,
     /*  612980 */     // GIR_Coverage, 5544,
     /*  612980 */     GIR_EraseRootFromParent_Done,
     /*  612981 */   // Label 9898: @612981
     /*  612981 */   GIM_Try, /*On fail goto*//*Label 9899*/ GIMT_Encode4(613053), // Rule ID 5545 //
     /*  612986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  612989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  612994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  612997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  613000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613051 */     GIR_RootConstrainSelectedInstOperands,
     /*  613052 */     // GIR_Coverage, 5545,
     /*  613052 */     GIR_EraseRootFromParent_Done,
     /*  613053 */   // Label 9899: @613053
     /*  613053 */   GIM_Try, /*On fail goto*//*Label 9900*/ GIMT_Encode4(613125), // Rule ID 5546 //
     /*  613058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613104 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  613104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613123 */     GIR_RootConstrainSelectedInstOperands,
     /*  613124 */     // GIR_Coverage, 5546,
     /*  613124 */     GIR_EraseRootFromParent_Done,
     /*  613125 */   // Label 9900: @613125
     /*  613125 */   GIM_Try, /*On fail goto*//*Label 9901*/ GIMT_Encode4(613197), // Rule ID 5547 //
     /*  613130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  613141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  613144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  613150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613176 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  613176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  613195 */     GIR_RootConstrainSelectedInstOperands,
     /*  613196 */     // GIR_Coverage, 5547,
     /*  613196 */     GIR_EraseRootFromParent_Done,
     /*  613197 */   // Label 9901: @613197
     /*  613197 */   GIM_Try, /*On fail goto*//*Label 9902*/ GIMT_Encode4(613269), // Rule ID 5548 //
     /*  613202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613248 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613267 */     GIR_RootConstrainSelectedInstOperands,
     /*  613268 */     // GIR_Coverage, 5548,
     /*  613268 */     GIR_EraseRootFromParent_Done,
     /*  613269 */   // Label 9902: @613269
     /*  613269 */   GIM_Try, /*On fail goto*//*Label 9903*/ GIMT_Encode4(613341), // Rule ID 5549 //
     /*  613274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  613288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613339 */     GIR_RootConstrainSelectedInstOperands,
     /*  613340 */     // GIR_Coverage, 5549,
     /*  613340 */     GIR_EraseRootFromParent_Done,
     /*  613341 */   // Label 9903: @613341
     /*  613341 */   GIM_Try, /*On fail goto*//*Label 9904*/ GIMT_Encode4(613413), // Rule ID 5550 //
     /*  613346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613392 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613411 */     GIR_RootConstrainSelectedInstOperands,
     /*  613412 */     // GIR_Coverage, 5550,
     /*  613412 */     GIR_EraseRootFromParent_Done,
     /*  613413 */   // Label 9904: @613413
     /*  613413 */   GIM_Try, /*On fail goto*//*Label 9905*/ GIMT_Encode4(613485), // Rule ID 5551 //
     /*  613418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  613432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613464 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613483 */     GIR_RootConstrainSelectedInstOperands,
     /*  613484 */     // GIR_Coverage, 5551,
     /*  613484 */     GIR_EraseRootFromParent_Done,
     /*  613485 */   // Label 9905: @613485
     /*  613485 */   GIM_Try, /*On fail goto*//*Label 9906*/ GIMT_Encode4(613557), // Rule ID 5552 //
     /*  613490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  613504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613536 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  613536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613555 */     GIR_RootConstrainSelectedInstOperands,
     /*  613556 */     // GIR_Coverage, 5552,
     /*  613556 */     GIR_EraseRootFromParent_Done,
     /*  613557 */   // Label 9906: @613557
     /*  613557 */   GIM_Try, /*On fail goto*//*Label 9907*/ GIMT_Encode4(613629), // Rule ID 5553 //
     /*  613562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  613573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  613576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  613582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613608 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  613608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  613627 */     GIR_RootConstrainSelectedInstOperands,
     /*  613628 */     // GIR_Coverage, 5553,
     /*  613628 */     GIR_EraseRootFromParent_Done,
     /*  613629 */   // Label 9907: @613629
     /*  613629 */   GIM_Try, /*On fail goto*//*Label 9908*/ GIMT_Encode4(613701), // Rule ID 5554 //
     /*  613634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  613648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613680 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613699 */     GIR_RootConstrainSelectedInstOperands,
     /*  613700 */     // GIR_Coverage, 5554,
     /*  613700 */     GIR_EraseRootFromParent_Done,
     /*  613701 */   // Label 9908: @613701
     /*  613701 */   GIM_Try, /*On fail goto*//*Label 9909*/ GIMT_Encode4(613773), // Rule ID 5555 //
     /*  613706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  613717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  613720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  613726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  613737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  613755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613771 */     GIR_RootConstrainSelectedInstOperands,
     /*  613772 */     // GIR_Coverage, 5555,
     /*  613772 */     GIR_EraseRootFromParent_Done,
     /*  613773 */   // Label 9909: @613773
     /*  613773 */   GIM_Try, /*On fail goto*//*Label 9910*/ GIMT_Encode4(613845), // Rule ID 5556 //
     /*  613778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  613792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613843 */     GIR_RootConstrainSelectedInstOperands,
     /*  613844 */     // GIR_Coverage, 5556,
     /*  613844 */     GIR_EraseRootFromParent_Done,
     /*  613845 */   // Label 9910: @613845
     /*  613845 */   GIM_Try, /*On fail goto*//*Label 9911*/ GIMT_Encode4(613917), // Rule ID 5557 //
     /*  613850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  613861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  613864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  613867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  613870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  613873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  613881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613896 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  613896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  613899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613915 */     GIR_RootConstrainSelectedInstOperands,
     /*  613916 */     // GIR_Coverage, 5557,
     /*  613916 */     GIR_EraseRootFromParent_Done,
     /*  613917 */   // Label 9911: @613917
     /*  613917 */   GIM_Try, /*On fail goto*//*Label 9912*/ GIMT_Encode4(613989), // Rule ID 5558 //
     /*  613922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  613925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  613930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  613933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  613936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  613939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  613942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  613945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  613949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  613953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  613957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  613961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  613968 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  613968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  613971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  613973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  613975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  613977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  613979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  613984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  613987 */     GIR_RootConstrainSelectedInstOperands,
     /*  613988 */     // GIR_Coverage, 5558,
     /*  613988 */     GIR_EraseRootFromParent_Done,
     /*  613989 */   // Label 9912: @613989
     /*  613989 */   GIM_Try, /*On fail goto*//*Label 9913*/ GIMT_Encode4(614061), // Rule ID 5559 //
     /*  613994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  613997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  614005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  614008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  614014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  614040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  614059 */     GIR_RootConstrainSelectedInstOperands,
     /*  614060 */     // GIR_Coverage, 5559,
     /*  614060 */     GIR_EraseRootFromParent_Done,
     /*  614061 */   // Label 9913: @614061
     /*  614061 */   GIM_Try, /*On fail goto*//*Label 9914*/ GIMT_Encode4(614133), // Rule ID 5560 //
     /*  614066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614112 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614131 */     GIR_RootConstrainSelectedInstOperands,
     /*  614132 */     // GIR_Coverage, 5560,
     /*  614132 */     GIR_EraseRootFromParent_Done,
     /*  614133 */   // Label 9914: @614133
     /*  614133 */   GIM_Try, /*On fail goto*//*Label 9915*/ GIMT_Encode4(614205), // Rule ID 5561 //
     /*  614138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  614149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  614152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  614158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  614169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11372:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M2),
     /*  614187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614203 */     GIR_RootConstrainSelectedInstOperands,
     /*  614204 */     // GIR_Coverage, 5561,
     /*  614204 */     GIR_EraseRootFromParent_Done,
     /*  614205 */   // Label 9915: @614205
     /*  614205 */   GIM_Try, /*On fail goto*//*Label 9916*/ GIMT_Encode4(614277), // Rule ID 5562 //
     /*  614210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614275 */     GIR_RootConstrainSelectedInstOperands,
     /*  614276 */     // GIR_Coverage, 5562,
     /*  614276 */     GIR_EraseRootFromParent_Done,
     /*  614277 */   // Label 9916: @614277
     /*  614277 */   GIM_Try, /*On fail goto*//*Label 9917*/ GIMT_Encode4(614349), // Rule ID 5563 //
     /*  614282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  614293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  614296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  614302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  614313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11372:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M4),
     /*  614331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614347 */     GIR_RootConstrainSelectedInstOperands,
     /*  614348 */     // GIR_Coverage, 5563,
     /*  614348 */     GIR_EraseRootFromParent_Done,
     /*  614349 */   // Label 9917: @614349
     /*  614349 */   GIM_Try, /*On fail goto*//*Label 9918*/ GIMT_Encode4(614421), // Rule ID 5564 //
     /*  614354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  614357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  614371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  614400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614419 */     GIR_RootConstrainSelectedInstOperands,
     /*  614420 */     // GIR_Coverage, 5564,
     /*  614420 */     GIR_EraseRootFromParent_Done,
     /*  614421 */   // Label 9918: @614421
     /*  614421 */   GIM_Try, /*On fail goto*//*Label 9919*/ GIMT_Encode4(614493), // Rule ID 5565 //
     /*  614426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  614429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbc_borrow_in),
     /*  614434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  614437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  614440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  614443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  614446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  614457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  614461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  614465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11372:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBC_VXM_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  614472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBC_VXM_M8),
     /*  614475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  614479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  614481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  614483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  614491 */     GIR_RootConstrainSelectedInstOperands,
     /*  614492 */     // GIR_Coverage, 5565,
     /*  614492 */     GIR_EraseRootFromParent_Done,
     /*  614493 */   // Label 9919: @614493
     /*  614493 */   GIM_Try, /*On fail goto*//*Label 9920*/ GIMT_Encode4(614568), // Rule ID 5654 //
     /*  614498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  614509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  614512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  614515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  614518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  614547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614566 */     GIR_RootConstrainSelectedInstOperands,
     /*  614567 */     // GIR_Coverage, 5654,
     /*  614567 */     GIR_EraseRootFromParent_Done,
     /*  614568 */   // Label 9920: @614568
     /*  614568 */   GIM_Try, /*On fail goto*//*Label 9921*/ GIMT_Encode4(614643), // Rule ID 5655 //
     /*  614573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  614584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  614587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  614590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  614593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8),
     /*  614622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614641 */     GIR_RootConstrainSelectedInstOperands,
     /*  614642 */     // GIR_Coverage, 5655,
     /*  614642 */     GIR_EraseRootFromParent_Done,
     /*  614643 */   // Label 9921: @614643
     /*  614643 */   GIM_Try, /*On fail goto*//*Label 9922*/ GIMT_Encode4(614718), // Rule ID 5658 //
     /*  614648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  614659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  614662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  614665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  614668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  614697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614716 */     GIR_RootConstrainSelectedInstOperands,
     /*  614717 */     // GIR_Coverage, 5658,
     /*  614717 */     GIR_EraseRootFromParent_Done,
     /*  614718 */   // Label 9922: @614718
     /*  614718 */   GIM_Try, /*On fail goto*//*Label 9923*/ GIMT_Encode4(614793), // Rule ID 5659 //
     /*  614723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  614734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  614737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  614740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  614743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  614772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614791 */     GIR_RootConstrainSelectedInstOperands,
     /*  614792 */     // GIR_Coverage, 5659,
     /*  614792 */     GIR_EraseRootFromParent_Done,
     /*  614793 */   // Label 9923: @614793
     /*  614793 */   GIM_Try, /*On fail goto*//*Label 9924*/ GIMT_Encode4(614868), // Rule ID 5662 //
     /*  614798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  614809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  614812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  614815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  614818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  614844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  614847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614866 */     GIR_RootConstrainSelectedInstOperands,
     /*  614867 */     // GIR_Coverage, 5662,
     /*  614867 */     GIR_EraseRootFromParent_Done,
     /*  614868 */   // Label 9924: @614868
     /*  614868 */   GIM_Try, /*On fail goto*//*Label 9925*/ GIMT_Encode4(614943), // Rule ID 5663 //
     /*  614873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  614876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  614884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  614887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  614890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  614893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  614896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  614919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  614922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  614926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  614928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  614930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  614935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  614938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  614941 */     GIR_RootConstrainSelectedInstOperands,
     /*  614942 */     // GIR_Coverage, 5663,
     /*  614942 */     GIR_EraseRootFromParent_Done,
     /*  614943 */   // Label 9925: @614943
     /*  614943 */   GIM_Try, /*On fail goto*//*Label 9926*/ GIMT_Encode4(615018), // Rule ID 5666 //
     /*  614948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  614951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  614956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  614959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  614962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  614965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  614968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  614971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  614987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  614994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  614994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  614997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  614999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615016 */     GIR_RootConstrainSelectedInstOperands,
     /*  615017 */     // GIR_Coverage, 5666,
     /*  615017 */     GIR_EraseRootFromParent_Done,
     /*  615018 */   // Label 9926: @615018
     /*  615018 */   GIM_Try, /*On fail goto*//*Label 9927*/ GIMT_Encode4(615093), // Rule ID 5667 //
     /*  615023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  615034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  615037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  615040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  615043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4),
     /*  615072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615091 */     GIR_RootConstrainSelectedInstOperands,
     /*  615092 */     // GIR_Coverage, 5667,
     /*  615092 */     GIR_EraseRootFromParent_Done,
     /*  615093 */   // Label 9927: @615093
     /*  615093 */   GIM_Try, /*On fail goto*//*Label 9928*/ GIMT_Encode4(615168), // Rule ID 5670 //
     /*  615098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615166 */     GIR_RootConstrainSelectedInstOperands,
     /*  615167 */     // GIR_Coverage, 5670,
     /*  615167 */     GIR_EraseRootFromParent_Done,
     /*  615168 */   // Label 9928: @615168
     /*  615168 */   GIM_Try, /*On fail goto*//*Label 9929*/ GIMT_Encode4(615243), // Rule ID 5671 //
     /*  615173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  615184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  615187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  615190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  615193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615241 */     GIR_RootConstrainSelectedInstOperands,
     /*  615242 */     // GIR_Coverage, 5671,
     /*  615242 */     GIR_EraseRootFromParent_Done,
     /*  615243 */   // Label 9929: @615243
     /*  615243 */   GIM_Try, /*On fail goto*//*Label 9930*/ GIMT_Encode4(615318), // Rule ID 5674 //
     /*  615248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615316 */     GIR_RootConstrainSelectedInstOperands,
     /*  615317 */     // GIR_Coverage, 5674,
     /*  615317 */     GIR_EraseRootFromParent_Done,
     /*  615318 */   // Label 9930: @615318
     /*  615318 */   GIM_Try, /*On fail goto*//*Label 9931*/ GIMT_Encode4(615393), // Rule ID 5675 //
     /*  615323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  615334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  615337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  615340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  615343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2),
     /*  615372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615391 */     GIR_RootConstrainSelectedInstOperands,
     /*  615392 */     // GIR_Coverage, 5675,
     /*  615392 */     GIR_EraseRootFromParent_Done,
     /*  615393 */   // Label 9931: @615393
     /*  615393 */   GIM_Try, /*On fail goto*//*Label 9932*/ GIMT_Encode4(615468), // Rule ID 5678 //
     /*  615398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  615409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  615412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  615415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  615418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  615444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615466 */     GIR_RootConstrainSelectedInstOperands,
     /*  615467 */     // GIR_Coverage, 5678,
     /*  615467 */     GIR_EraseRootFromParent_Done,
     /*  615468 */   // Label 9932: @615468
     /*  615468 */   GIM_Try, /*On fail goto*//*Label 9933*/ GIMT_Encode4(615543), // Rule ID 5679 //
     /*  615473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  615484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  615487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  615490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  615493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  615519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  615538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615541 */     GIR_RootConstrainSelectedInstOperands,
     /*  615542 */     // GIR_Coverage, 5679,
     /*  615542 */     GIR_EraseRootFromParent_Done,
     /*  615543 */   // Label 9933: @615543
     /*  615543 */   GIM_Try, /*On fail goto*//*Label 9934*/ GIMT_Encode4(615618), // Rule ID 5682 //
     /*  615548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  615559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  615562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  615565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  615568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  615594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615616 */     GIR_RootConstrainSelectedInstOperands,
     /*  615617 */     // GIR_Coverage, 5682,
     /*  615617 */     GIR_EraseRootFromParent_Done,
     /*  615618 */   // Label 9934: @615618
     /*  615618 */   GIM_Try, /*On fail goto*//*Label 9935*/ GIMT_Encode4(615693), // Rule ID 5683 //
     /*  615623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  615634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  615637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  615640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  615643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  615669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  615688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615691 */     GIR_RootConstrainSelectedInstOperands,
     /*  615692 */     // GIR_Coverage, 5683,
     /*  615692 */     GIR_EraseRootFromParent_Done,
     /*  615693 */   // Label 9935: @615693
     /*  615693 */   GIM_Try, /*On fail goto*//*Label 9936*/ GIMT_Encode4(615768), // Rule ID 5686 //
     /*  615698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  615701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  615709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  615712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  615715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  615718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  615744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615766 */     GIR_RootConstrainSelectedInstOperands,
     /*  615767 */     // GIR_Coverage, 5686,
     /*  615767 */     GIR_EraseRootFromParent_Done,
     /*  615768 */   // Label 9936: @615768
     /*  615768 */   GIM_Try, /*On fail goto*//*Label 9937*/ GIMT_Encode4(615843), // Rule ID 5687 //
     /*  615773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  615776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  615784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  615787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  615790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  615793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  615819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  615838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615841 */     GIR_RootConstrainSelectedInstOperands,
     /*  615842 */     // GIR_Coverage, 5687,
     /*  615842 */     GIR_EraseRootFromParent_Done,
     /*  615843 */   // Label 9937: @615843
     /*  615843 */   GIM_Try, /*On fail goto*//*Label 9938*/ GIMT_Encode4(615918), // Rule ID 5690 //
     /*  615848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  615851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  615859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  615862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  615865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  615868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  615871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  615894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615916 */     GIR_RootConstrainSelectedInstOperands,
     /*  615917 */     // GIR_Coverage, 5690,
     /*  615917 */     GIR_EraseRootFromParent_Done,
     /*  615918 */   // Label 9938: @615918
     /*  615918 */   GIM_Try, /*On fail goto*//*Label 9939*/ GIMT_Encode4(615993), // Rule ID 5691 //
     /*  615923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  615926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  615931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  615934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  615937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  615940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  615943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  615946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  615962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  615969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  615969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1),
     /*  615972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  615974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  615976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  615978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  615980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  615985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  615988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  615991 */     GIR_RootConstrainSelectedInstOperands,
     /*  615992 */     // GIR_Coverage, 5691,
     /*  615992 */     GIR_EraseRootFromParent_Done,
     /*  615993 */   // Label 9939: @615993
     /*  615993 */   GIM_Try, /*On fail goto*//*Label 9940*/ GIMT_Encode4(616068), // Rule ID 5694 //
     /*  615998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616066 */     GIR_RootConstrainSelectedInstOperands,
     /*  616067 */     // GIR_Coverage, 5694,
     /*  616067 */     GIR_EraseRootFromParent_Done,
     /*  616068 */   // Label 9940: @616068
     /*  616068 */   GIM_Try, /*On fail goto*//*Label 9941*/ GIMT_Encode4(616143), // Rule ID 5695 //
     /*  616073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  616084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  616087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  616090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  616093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616141 */     GIR_RootConstrainSelectedInstOperands,
     /*  616142 */     // GIR_Coverage, 5695,
     /*  616142 */     GIR_EraseRootFromParent_Done,
     /*  616143 */   // Label 9941: @616143
     /*  616143 */   GIM_Try, /*On fail goto*//*Label 9942*/ GIMT_Encode4(616218), // Rule ID 5698 //
     /*  616148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616216 */     GIR_RootConstrainSelectedInstOperands,
     /*  616217 */     // GIR_Coverage, 5698,
     /*  616217 */     GIR_EraseRootFromParent_Done,
     /*  616218 */   // Label 9942: @616218
     /*  616218 */   GIM_Try, /*On fail goto*//*Label 9943*/ GIMT_Encode4(616293), // Rule ID 5699 //
     /*  616223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  616234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  616237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  616240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  616243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616291 */     GIR_RootConstrainSelectedInstOperands,
     /*  616292 */     // GIR_Coverage, 5699,
     /*  616292 */     GIR_EraseRootFromParent_Done,
     /*  616293 */   // Label 9943: @616293
     /*  616293 */   GIM_Try, /*On fail goto*//*Label 9944*/ GIMT_Encode4(616368), // Rule ID 5702 //
     /*  616298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  616344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616366 */     GIR_RootConstrainSelectedInstOperands,
     /*  616367 */     // GIR_Coverage, 5702,
     /*  616367 */     GIR_EraseRootFromParent_Done,
     /*  616368 */   // Label 9944: @616368
     /*  616368 */   GIM_Try, /*On fail goto*//*Label 9945*/ GIMT_Encode4(616443), // Rule ID 5703 //
     /*  616373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  616384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  616387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  616390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  616393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  616419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  616438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616441 */     GIR_RootConstrainSelectedInstOperands,
     /*  616442 */     // GIR_Coverage, 5703,
     /*  616442 */     GIR_EraseRootFromParent_Done,
     /*  616443 */   // Label 9945: @616443
     /*  616443 */   GIM_Try, /*On fail goto*//*Label 9946*/ GIMT_Encode4(616518), // Rule ID 5706 //
     /*  616448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  616459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  616462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  616465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  616468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616516 */     GIR_RootConstrainSelectedInstOperands,
     /*  616517 */     // GIR_Coverage, 5706,
     /*  616517 */     GIR_EraseRootFromParent_Done,
     /*  616518 */   // Label 9946: @616518
     /*  616518 */   GIM_Try, /*On fail goto*//*Label 9947*/ GIMT_Encode4(616593), // Rule ID 5707 //
     /*  616523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  616534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  616537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  616540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  616543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616591 */     GIR_RootConstrainSelectedInstOperands,
     /*  616592 */     // GIR_Coverage, 5707,
     /*  616592 */     GIR_EraseRootFromParent_Done,
     /*  616593 */   // Label 9947: @616593
     /*  616593 */   GIM_Try, /*On fail goto*//*Label 9948*/ GIMT_Encode4(616668), // Rule ID 5710 //
     /*  616598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  616609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  616612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  616615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  616618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616666 */     GIR_RootConstrainSelectedInstOperands,
     /*  616667 */     // GIR_Coverage, 5710,
     /*  616667 */     GIR_EraseRootFromParent_Done,
     /*  616668 */   // Label 9948: @616668
     /*  616668 */   GIM_Try, /*On fail goto*//*Label 9949*/ GIMT_Encode4(616743), // Rule ID 5711 //
     /*  616673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  616684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  616687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  616690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  616693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  616712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  616722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616741 */     GIR_RootConstrainSelectedInstOperands,
     /*  616742 */     // GIR_Coverage, 5711,
     /*  616742 */     GIR_EraseRootFromParent_Done,
     /*  616743 */   // Label 9949: @616743
     /*  616743 */   GIM_Try, /*On fail goto*//*Label 9950*/ GIMT_Encode4(616818), // Rule ID 5714 //
     /*  616748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  616759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  616762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  616765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  616768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  616794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616816 */     GIR_RootConstrainSelectedInstOperands,
     /*  616817 */     // GIR_Coverage, 5714,
     /*  616817 */     GIR_EraseRootFromParent_Done,
     /*  616818 */   // Label 9950: @616818
     /*  616818 */   GIM_Try, /*On fail goto*//*Label 9951*/ GIMT_Encode4(616893), // Rule ID 5715 //
     /*  616823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  616834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  616837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  616840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  616843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  616862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  616869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  616872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  616888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616891 */     GIR_RootConstrainSelectedInstOperands,
     /*  616892 */     // GIR_Coverage, 5715,
     /*  616892 */     GIR_EraseRootFromParent_Done,
     /*  616893 */   // Label 9951: @616893
     /*  616893 */   GIM_Try, /*On fail goto*//*Label 9952*/ GIMT_Encode4(616968), // Rule ID 5718 //
     /*  616898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  616901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  616909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  616912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  616915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  616918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  616921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  616937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  616944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  616944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  616947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  616949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  616951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  616953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  616955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  616960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  616963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  616966 */     GIR_RootConstrainSelectedInstOperands,
     /*  616967 */     // GIR_Coverage, 5718,
     /*  616967 */     GIR_EraseRootFromParent_Done,
     /*  616968 */   // Label 9952: @616968
     /*  616968 */   GIM_Try, /*On fail goto*//*Label 9953*/ GIMT_Encode4(617043), // Rule ID 5719 //
     /*  616973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  616976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  616981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  616984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  616987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  616990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  616993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  616996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617041 */     GIR_RootConstrainSelectedInstOperands,
     /*  617042 */     // GIR_Coverage, 5719,
     /*  617042 */     GIR_EraseRootFromParent_Done,
     /*  617043 */   // Label 9953: @617043
     /*  617043 */   GIM_Try, /*On fail goto*//*Label 9954*/ GIMT_Encode4(617118), // Rule ID 5722 //
     /*  617048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617116 */     GIR_RootConstrainSelectedInstOperands,
     /*  617117 */     // GIR_Coverage, 5722,
     /*  617117 */     GIR_EraseRootFromParent_Done,
     /*  617118 */   // Label 9954: @617118
     /*  617118 */   GIM_Try, /*On fail goto*//*Label 9955*/ GIMT_Encode4(617193), // Rule ID 5723 //
     /*  617123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  617134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  617137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  617140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  617143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617191 */     GIR_RootConstrainSelectedInstOperands,
     /*  617192 */     // GIR_Coverage, 5723,
     /*  617192 */     GIR_EraseRootFromParent_Done,
     /*  617193 */   // Label 9955: @617193
     /*  617193 */   GIM_Try, /*On fail goto*//*Label 9956*/ GIMT_Encode4(617268), // Rule ID 5726 //
     /*  617198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  617244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617266 */     GIR_RootConstrainSelectedInstOperands,
     /*  617267 */     // GIR_Coverage, 5726,
     /*  617267 */     GIR_EraseRootFromParent_Done,
     /*  617268 */   // Label 9956: @617268
     /*  617268 */   GIM_Try, /*On fail goto*//*Label 9957*/ GIMT_Encode4(617343), // Rule ID 5727 //
     /*  617273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  617284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  617287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  617290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  617293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  617319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  617338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617341 */     GIR_RootConstrainSelectedInstOperands,
     /*  617342 */     // GIR_Coverage, 5727,
     /*  617342 */     GIR_EraseRootFromParent_Done,
     /*  617343 */   // Label 9957: @617343
     /*  617343 */   GIM_Try, /*On fail goto*//*Label 9958*/ GIMT_Encode4(617418), // Rule ID 5730 //
     /*  617348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  617351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  617394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617416 */     GIR_RootConstrainSelectedInstOperands,
     /*  617417 */     // GIR_Coverage, 5730,
     /*  617417 */     GIR_EraseRootFromParent_Done,
     /*  617418 */   // Label 9958: @617418
     /*  617418 */   GIM_Try, /*On fail goto*//*Label 9959*/ GIMT_Encode4(617493), // Rule ID 5731 //
     /*  617423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  617434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  617437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  617440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  617443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  617462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  617469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2),
     /*  617472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617491 */     GIR_RootConstrainSelectedInstOperands,
     /*  617492 */     // GIR_Coverage, 5731,
     /*  617492 */     GIR_EraseRootFromParent_Done,
     /*  617493 */   // Label 9959: @617493
     /*  617493 */   GIM_Try, /*On fail goto*//*Label 9960*/ GIMT_Encode4(617568), // Rule ID 5734 //
     /*  617498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  617501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  617509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  617512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  617515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  617518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  617544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617566 */     GIR_RootConstrainSelectedInstOperands,
     /*  617567 */     // GIR_Coverage, 5734,
     /*  617567 */     GIR_EraseRootFromParent_Done,
     /*  617568 */   // Label 9960: @617568
     /*  617568 */   GIM_Try, /*On fail goto*//*Label 9961*/ GIMT_Encode4(617643), // Rule ID 5735 //
     /*  617573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  617584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  617587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  617590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  617593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  617612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  617619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4),
     /*  617622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617641 */     GIR_RootConstrainSelectedInstOperands,
     /*  617642 */     // GIR_Coverage, 5735,
     /*  617642 */     GIR_EraseRootFromParent_Done,
     /*  617643 */   // Label 9961: @617643
     /*  617643 */   GIM_Try, /*On fail goto*//*Label 9962*/ GIMT_Encode4(617718), // Rule ID 5738 //
     /*  617648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  617651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  617659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  617662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  617665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  617668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  617694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617716 */     GIR_RootConstrainSelectedInstOperands,
     /*  617717 */     // GIR_Coverage, 5738,
     /*  617717 */     GIR_EraseRootFromParent_Done,
     /*  617718 */   // Label 9962: @617718
     /*  617718 */   GIM_Try, /*On fail goto*//*Label 9963*/ GIMT_Encode4(617793), // Rule ID 5739 //
     /*  617723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  617726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  617734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  617737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  617740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  617743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  617762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  617769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8),
     /*  617772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  617788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617791 */     GIR_RootConstrainSelectedInstOperands,
     /*  617792 */     // GIR_Coverage, 5739,
     /*  617792 */     GIR_EraseRootFromParent_Done,
     /*  617793 */   // Label 9963: @617793
     /*  617793 */   GIM_Try, /*On fail goto*//*Label 9964*/ GIMT_Encode4(617868), // Rule ID 5742 //
     /*  617798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  617809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  617812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  617815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  617847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617866 */     GIR_RootConstrainSelectedInstOperands,
     /*  617867 */     // GIR_Coverage, 5742,
     /*  617867 */     GIR_EraseRootFromParent_Done,
     /*  617868 */   // Label 9964: @617868
     /*  617868 */   GIM_Try, /*On fail goto*//*Label 9965*/ GIMT_Encode4(617943), // Rule ID 5743 //
     /*  617873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  617876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  617884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  617887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  617890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  617893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  617896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  617919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8),
     /*  617922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  617926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  617928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  617930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  617935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  617938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  617941 */     GIR_RootConstrainSelectedInstOperands,
     /*  617942 */     // GIR_Coverage, 5743,
     /*  617942 */     GIR_EraseRootFromParent_Done,
     /*  617943 */   // Label 9965: @617943
     /*  617943 */   GIM_Try, /*On fail goto*//*Label 9966*/ GIMT_Encode4(618018), // Rule ID 5746 //
     /*  617948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  617951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  617956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  617959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  617962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  617965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  617968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  617971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  617983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  617987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  617994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  617994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  617997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  617999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618016 */     GIR_RootConstrainSelectedInstOperands,
     /*  618017 */     // GIR_Coverage, 5746,
     /*  618017 */     GIR_EraseRootFromParent_Done,
     /*  618018 */   // Label 9966: @618018
     /*  618018 */   GIM_Try, /*On fail goto*//*Label 9967*/ GIMT_Encode4(618093), // Rule ID 5747 //
     /*  618023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  618034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  618037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  618040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618091 */     GIR_RootConstrainSelectedInstOperands,
     /*  618092 */     // GIR_Coverage, 5747,
     /*  618092 */     GIR_EraseRootFromParent_Done,
     /*  618093 */   // Label 9967: @618093
     /*  618093 */   GIM_Try, /*On fail goto*//*Label 9968*/ GIMT_Encode4(618168), // Rule ID 5750 //
     /*  618098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618166 */     GIR_RootConstrainSelectedInstOperands,
     /*  618167 */     // GIR_Coverage, 5750,
     /*  618167 */     GIR_EraseRootFromParent_Done,
     /*  618168 */   // Label 9968: @618168
     /*  618168 */   GIM_Try, /*On fail goto*//*Label 9969*/ GIMT_Encode4(618243), // Rule ID 5751 //
     /*  618173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  618184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  618187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  618190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618241 */     GIR_RootConstrainSelectedInstOperands,
     /*  618242 */     // GIR_Coverage, 5751,
     /*  618242 */     GIR_EraseRootFromParent_Done,
     /*  618243 */   // Label 9969: @618243
     /*  618243 */   GIM_Try, /*On fail goto*//*Label 9970*/ GIMT_Encode4(618318), // Rule ID 5754 //
     /*  618248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618316 */     GIR_RootConstrainSelectedInstOperands,
     /*  618317 */     // GIR_Coverage, 5754,
     /*  618317 */     GIR_EraseRootFromParent_Done,
     /*  618318 */   // Label 9970: @618318
     /*  618318 */   GIM_Try, /*On fail goto*//*Label 9971*/ GIMT_Encode4(618393), // Rule ID 5755 //
     /*  618323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  618334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  618337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  618340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  618369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4),
     /*  618372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618391 */     GIR_RootConstrainSelectedInstOperands,
     /*  618392 */     // GIR_Coverage, 5755,
     /*  618392 */     GIR_EraseRootFromParent_Done,
     /*  618393 */   // Label 9971: @618393
     /*  618393 */   GIM_Try, /*On fail goto*//*Label 9972*/ GIMT_Encode4(618468), // Rule ID 5758 //
     /*  618398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  618409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  618412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  618415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618466 */     GIR_RootConstrainSelectedInstOperands,
     /*  618467 */     // GIR_Coverage, 5758,
     /*  618467 */     GIR_EraseRootFromParent_Done,
     /*  618468 */   // Label 9972: @618468
     /*  618468 */   GIM_Try, /*On fail goto*//*Label 9973*/ GIMT_Encode4(618543), // Rule ID 5759 //
     /*  618473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  618484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  618487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  618490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  618519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618541 */     GIR_RootConstrainSelectedInstOperands,
     /*  618542 */     // GIR_Coverage, 5759,
     /*  618542 */     GIR_EraseRootFromParent_Done,
     /*  618543 */   // Label 9973: @618543
     /*  618543 */   GIM_Try, /*On fail goto*//*Label 9974*/ GIMT_Encode4(618618), // Rule ID 5762 //
     /*  618548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  618559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  618562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  618565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  618594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618616 */     GIR_RootConstrainSelectedInstOperands,
     /*  618617 */     // GIR_Coverage, 5762,
     /*  618617 */     GIR_EraseRootFromParent_Done,
     /*  618618 */   // Label 9974: @618618
     /*  618618 */   GIM_Try, /*On fail goto*//*Label 9975*/ GIMT_Encode4(618693), // Rule ID 5763 //
     /*  618623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  618634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  618637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  618640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  618669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2),
     /*  618672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  618688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618691 */     GIR_RootConstrainSelectedInstOperands,
     /*  618692 */     // GIR_Coverage, 5763,
     /*  618692 */     GIR_EraseRootFromParent_Done,
     /*  618693 */   // Label 9975: @618693
     /*  618693 */   GIM_Try, /*On fail goto*//*Label 9976*/ GIMT_Encode4(618768), // Rule ID 5766 //
     /*  618698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  618709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  618712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  618715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  618744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  618747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618766 */     GIR_RootConstrainSelectedInstOperands,
     /*  618767 */     // GIR_Coverage, 5766,
     /*  618767 */     GIR_EraseRootFromParent_Done,
     /*  618768 */   // Label 9976: @618768
     /*  618768 */   GIM_Try, /*On fail goto*//*Label 9977*/ GIMT_Encode4(618843), // Rule ID 5767 //
     /*  618773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  618784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  618787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  618790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11087:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  618819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  618822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  618838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618841 */     GIR_RootConstrainSelectedInstOperands,
     /*  618842 */     // GIR_Coverage, 5767,
     /*  618842 */     GIR_EraseRootFromParent_Done,
     /*  618843 */   // Label 9977: @618843
     /*  618843 */   GIM_Try, /*On fail goto*//*Label 9978*/ GIMT_Encode4(618918), // Rule ID 5770 //
     /*  618848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  618851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  618859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  618862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  618865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  618868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  618871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  618894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  618897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618916 */     GIR_RootConstrainSelectedInstOperands,
     /*  618917 */     // GIR_Coverage, 5770,
     /*  618917 */     GIR_EraseRootFromParent_Done,
     /*  618918 */   // Label 9978: @618918
     /*  618918 */   GIM_Try, /*On fail goto*//*Label 9979*/ GIMT_Encode4(618993), // Rule ID 5771 //
     /*  618923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  618926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  618931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  618934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  618937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  618940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  618943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  618946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  618958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  618962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  618969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11087:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  618969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  618972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  618974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  618976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  618978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  618980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  618985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  618988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  618991 */     GIR_RootConstrainSelectedInstOperands,
     /*  618992 */     // GIR_Coverage, 5771,
     /*  618992 */     GIR_EraseRootFromParent_Done,
     /*  618993 */   // Label 9979: @618993
     /*  618993 */   GIM_Try, /*On fail goto*//*Label 9980*/ GIMT_Encode4(619068), // Rule ID 5774 //
     /*  618998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  619044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619066 */     GIR_RootConstrainSelectedInstOperands,
     /*  619067 */     // GIR_Coverage, 5774,
     /*  619067 */     GIR_EraseRootFromParent_Done,
     /*  619068 */   // Label 9980: @619068
     /*  619068 */   GIM_Try, /*On fail goto*//*Label 9981*/ GIMT_Encode4(619143), // Rule ID 5775 //
     /*  619073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  619084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  619087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  619090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11087:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  619119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  619138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619141 */     GIR_RootConstrainSelectedInstOperands,
     /*  619142 */     // GIR_Coverage, 5775,
     /*  619142 */     GIR_EraseRootFromParent_Done,
     /*  619143 */   // Label 9981: @619143
     /*  619143 */   GIM_Try, /*On fail goto*//*Label 9982*/ GIMT_Encode4(619218), // Rule ID 5778 //
     /*  619148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  619151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  619194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619216 */     GIR_RootConstrainSelectedInstOperands,
     /*  619217 */     // GIR_Coverage, 5778,
     /*  619217 */     GIR_EraseRootFromParent_Done,
     /*  619218 */   // Label 9982: @619218
     /*  619218 */   GIM_Try, /*On fail goto*//*Label 9983*/ GIMT_Encode4(619293), // Rule ID 5779 //
     /*  619223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  619226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  619234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  619237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  619240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  619258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619269 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11087:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  619269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1),
     /*  619272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  619288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619291 */     GIR_RootConstrainSelectedInstOperands,
     /*  619292 */     // GIR_Coverage, 5779,
     /*  619292 */     GIR_EraseRootFromParent_Done,
     /*  619293 */   // Label 9983: @619293
     /*  619293 */   GIM_Try, /*On fail goto*//*Label 9984*/ GIMT_Encode4(619368), // Rule ID 5782 //
     /*  619298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619366 */     GIR_RootConstrainSelectedInstOperands,
     /*  619367 */     // GIR_Coverage, 5782,
     /*  619367 */     GIR_EraseRootFromParent_Done,
     /*  619368 */   // Label 9984: @619368
     /*  619368 */   GIM_Try, /*On fail goto*//*Label 9985*/ GIMT_Encode4(619443), // Rule ID 5783 //
     /*  619373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  619384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  619387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  619390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619419 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619441 */     GIR_RootConstrainSelectedInstOperands,
     /*  619442 */     // GIR_Coverage, 5783,
     /*  619442 */     GIR_EraseRootFromParent_Done,
     /*  619443 */   // Label 9985: @619443
     /*  619443 */   GIM_Try, /*On fail goto*//*Label 9986*/ GIMT_Encode4(619518), // Rule ID 5786 //
     /*  619448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  619459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  619462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  619465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  619497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619516 */     GIR_RootConstrainSelectedInstOperands,
     /*  619517 */     // GIR_Coverage, 5786,
     /*  619517 */     GIR_EraseRootFromParent_Done,
     /*  619518 */   // Label 9986: @619518
     /*  619518 */   GIM_Try, /*On fail goto*//*Label 9987*/ GIMT_Encode4(619593), // Rule ID 5787 //
     /*  619523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  619534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  619537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  619540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  619572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619591 */     GIR_RootConstrainSelectedInstOperands,
     /*  619592 */     // GIR_Coverage, 5787,
     /*  619592 */     GIR_EraseRootFromParent_Done,
     /*  619593 */   // Label 9987: @619593
     /*  619593 */   GIM_Try, /*On fail goto*//*Label 9988*/ GIMT_Encode4(619668), // Rule ID 5790 //
     /*  619598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  619609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  619612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  619615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  619644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  619647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619666 */     GIR_RootConstrainSelectedInstOperands,
     /*  619667 */     // GIR_Coverage, 5790,
     /*  619667 */     GIR_EraseRootFromParent_Done,
     /*  619668 */   // Label 9988: @619668
     /*  619668 */   GIM_Try, /*On fail goto*//*Label 9989*/ GIMT_Encode4(619743), // Rule ID 5791 //
     /*  619673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  619684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  619687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  619690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  619708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  619719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  619722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  619738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619741 */     GIR_RootConstrainSelectedInstOperands,
     /*  619742 */     // GIR_Coverage, 5791,
     /*  619742 */     GIR_EraseRootFromParent_Done,
     /*  619743 */   // Label 9989: @619743
     /*  619743 */   GIM_Try, /*On fail goto*//*Label 9990*/ GIMT_Encode4(619818), // Rule ID 5794 //
     /*  619748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  619759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  619762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  619765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619816 */     GIR_RootConstrainSelectedInstOperands,
     /*  619817 */     // GIR_Coverage, 5794,
     /*  619817 */     GIR_EraseRootFromParent_Done,
     /*  619818 */   // Label 9990: @619818
     /*  619818 */   GIM_Try, /*On fail goto*//*Label 9991*/ GIMT_Encode4(619893), // Rule ID 5795 //
     /*  619823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  619834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  619837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  619840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  619858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  619869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  619872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619891 */     GIR_RootConstrainSelectedInstOperands,
     /*  619892 */     // GIR_Coverage, 5795,
     /*  619892 */     GIR_EraseRootFromParent_Done,
     /*  619893 */   // Label 9991: @619893
     /*  619893 */   GIM_Try, /*On fail goto*//*Label 9992*/ GIMT_Encode4(619968), // Rule ID 5798 //
     /*  619898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  619901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  619909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  619912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  619915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  619918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  619921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  619933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  619937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  619944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  619944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  619947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  619949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  619951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  619953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  619955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  619960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  619963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  619966 */     GIR_RootConstrainSelectedInstOperands,
     /*  619967 */     // GIR_Coverage, 5798,
     /*  619967 */     GIR_EraseRootFromParent_Done,
     /*  619968 */   // Label 9992: @619968
     /*  619968 */   GIM_Try, /*On fail goto*//*Label 9993*/ GIMT_Encode4(620043), // Rule ID 5799 //
     /*  619973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  619976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  619981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  619984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  619987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  619990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  619993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  619996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620041 */     GIR_RootConstrainSelectedInstOperands,
     /*  620042 */     // GIR_Coverage, 5799,
     /*  620042 */     GIR_EraseRootFromParent_Done,
     /*  620043 */   // Label 9993: @620043
     /*  620043 */   GIM_Try, /*On fail goto*//*Label 9994*/ GIMT_Encode4(620118), // Rule ID 5802 //
     /*  620048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  620094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620116 */     GIR_RootConstrainSelectedInstOperands,
     /*  620117 */     // GIR_Coverage, 5802,
     /*  620117 */     GIR_EraseRootFromParent_Done,
     /*  620118 */   // Label 9994: @620118
     /*  620118 */   GIM_Try, /*On fail goto*//*Label 9995*/ GIMT_Encode4(620193), // Rule ID 5803 //
     /*  620123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  620134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  620137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  620140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  620169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  620188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620191 */     GIR_RootConstrainSelectedInstOperands,
     /*  620192 */     // GIR_Coverage, 5803,
     /*  620192 */     GIR_EraseRootFromParent_Done,
     /*  620193 */   // Label 9995: @620193
     /*  620193 */   GIM_Try, /*On fail goto*//*Label 9996*/ GIMT_Encode4(620268), // Rule ID 5806 //
     /*  620198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620266 */     GIR_RootConstrainSelectedInstOperands,
     /*  620267 */     // GIR_Coverage, 5806,
     /*  620267 */     GIR_EraseRootFromParent_Done,
     /*  620268 */   // Label 9996: @620268
     /*  620268 */   GIM_Try, /*On fail goto*//*Label 9997*/ GIMT_Encode4(620343), // Rule ID 5807 //
     /*  620273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  620284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  620287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  620290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620341 */     GIR_RootConstrainSelectedInstOperands,
     /*  620342 */     // GIR_Coverage, 5807,
     /*  620342 */     GIR_EraseRootFromParent_Done,
     /*  620343 */   // Label 9997: @620343
     /*  620343 */   GIM_Try, /*On fail goto*//*Label 9998*/ GIMT_Encode4(620418), // Rule ID 5810 //
     /*  620348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620416 */     GIR_RootConstrainSelectedInstOperands,
     /*  620417 */     // GIR_Coverage, 5810,
     /*  620417 */     GIR_EraseRootFromParent_Done,
     /*  620418 */   // Label 9998: @620418
     /*  620418 */   GIM_Try, /*On fail goto*//*Label 9999*/ GIMT_Encode4(620493), // Rule ID 5811 //
     /*  620423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  620434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  620437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  620440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620491 */     GIR_RootConstrainSelectedInstOperands,
     /*  620492 */     // GIR_Coverage, 5811,
     /*  620492 */     GIR_EraseRootFromParent_Done,
     /*  620493 */   // Label 9999: @620493
     /*  620493 */   GIM_Try, /*On fail goto*//*Label 10000*/ GIMT_Encode4(620568), // Rule ID 5814 //
     /*  620498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  620501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  620509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  620512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  620515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  620544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620566 */     GIR_RootConstrainSelectedInstOperands,
     /*  620567 */     // GIR_Coverage, 5814,
     /*  620567 */     GIR_EraseRootFromParent_Done,
     /*  620568 */   // Label 10000: @620568
     /*  620568 */   GIM_Try, /*On fail goto*//*Label 10001*/ GIMT_Encode4(620643), // Rule ID 5815 //
     /*  620573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  620576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  620584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  620587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  620590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  620619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  620638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620641 */     GIR_RootConstrainSelectedInstOperands,
     /*  620642 */     // GIR_Coverage, 5815,
     /*  620642 */     GIR_EraseRootFromParent_Done,
     /*  620643 */   // Label 10001: @620643
     /*  620643 */   GIM_Try, /*On fail goto*//*Label 10002*/ GIMT_Encode4(620718), // Rule ID 5818 //
     /*  620648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  620659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  620662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  620665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620716 */     GIR_RootConstrainSelectedInstOperands,
     /*  620717 */     // GIR_Coverage, 5818,
     /*  620717 */     GIR_EraseRootFromParent_Done,
     /*  620718 */   // Label 10002: @620718
     /*  620718 */   GIM_Try, /*On fail goto*//*Label 10003*/ GIMT_Encode4(620793), // Rule ID 5819 //
     /*  620723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  620734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  620737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  620740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  620758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11087:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2),
     /*  620772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620791 */     GIR_RootConstrainSelectedInstOperands,
     /*  620792 */     // GIR_Coverage, 5819,
     /*  620792 */     GIR_EraseRootFromParent_Done,
     /*  620793 */   // Label 10003: @620793
     /*  620793 */   GIM_Try, /*On fail goto*//*Label 10004*/ GIMT_Encode4(620868), // Rule ID 5822 //
     /*  620798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  620809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  620812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  620815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620866 */     GIR_RootConstrainSelectedInstOperands,
     /*  620867 */     // GIR_Coverage, 5822,
     /*  620867 */     GIR_EraseRootFromParent_Done,
     /*  620868 */   // Label 10004: @620868
     /*  620868 */   GIM_Try, /*On fail goto*//*Label 10005*/ GIMT_Encode4(620943), // Rule ID 5823 //
     /*  620873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  620876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  620884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  620887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  620890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  620893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  620896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  620908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11087:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  620919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4),
     /*  620922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  620926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  620928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  620930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  620935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  620938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  620941 */     GIR_RootConstrainSelectedInstOperands,
     /*  620942 */     // GIR_Coverage, 5823,
     /*  620942 */     GIR_EraseRootFromParent_Done,
     /*  620943 */   // Label 10005: @620943
     /*  620943 */   GIM_Try, /*On fail goto*//*Label 10006*/ GIMT_Encode4(621018), // Rule ID 5826 //
     /*  620948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  620951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  620956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  620959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  620962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  620965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  620968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  620971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  620983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  620987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  620994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  620994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  620997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  620999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621016 */     GIR_RootConstrainSelectedInstOperands,
     /*  621017 */     // GIR_Coverage, 5826,
     /*  621017 */     GIR_EraseRootFromParent_Done,
     /*  621018 */   // Label 10006: @621018
     /*  621018 */   GIM_Try, /*On fail goto*//*Label 10007*/ GIMT_Encode4(621093), // Rule ID 5827 //
     /*  621023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  621026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand),
     /*  621031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  621034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  621037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  621040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  621043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  621058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  621062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11087:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAND_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  621069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8),
     /*  621072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  621088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621091 */     GIR_RootConstrainSelectedInstOperands,
     /*  621092 */     // GIR_Coverage, 5827,
     /*  621092 */     GIR_EraseRootFromParent_Done,
     /*  621093 */   // Label 10007: @621093
     /*  621093 */   GIM_Try, /*On fail goto*//*Label 10008*/ GIMT_Encode4(621168), // Rule ID 5918 //
     /*  621098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621166 */     GIR_RootConstrainSelectedInstOperands,
     /*  621167 */     // GIR_Coverage, 5918,
     /*  621167 */     GIR_EraseRootFromParent_Done,
     /*  621168 */   // Label 10008: @621168
     /*  621168 */   GIM_Try, /*On fail goto*//*Label 10009*/ GIMT_Encode4(621243), // Rule ID 5919 //
     /*  621173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  621184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  621187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  621190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  621193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8),
     /*  621222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621241 */     GIR_RootConstrainSelectedInstOperands,
     /*  621242 */     // GIR_Coverage, 5919,
     /*  621242 */     GIR_EraseRootFromParent_Done,
     /*  621243 */   // Label 10009: @621243
     /*  621243 */   GIM_Try, /*On fail goto*//*Label 10010*/ GIMT_Encode4(621318), // Rule ID 5922 //
     /*  621248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621316 */     GIR_RootConstrainSelectedInstOperands,
     /*  621317 */     // GIR_Coverage, 5922,
     /*  621317 */     GIR_EraseRootFromParent_Done,
     /*  621318 */   // Label 10010: @621318
     /*  621318 */   GIM_Try, /*On fail goto*//*Label 10011*/ GIMT_Encode4(621393), // Rule ID 5923 //
     /*  621323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  621334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  621337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  621340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  621343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621369 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621391 */     GIR_RootConstrainSelectedInstOperands,
     /*  621392 */     // GIR_Coverage, 5923,
     /*  621392 */     GIR_EraseRootFromParent_Done,
     /*  621393 */   // Label 10011: @621393
     /*  621393 */   GIM_Try, /*On fail goto*//*Label 10012*/ GIMT_Encode4(621468), // Rule ID 5926 //
     /*  621398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  621409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  621412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  621415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  621418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  621444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621466 */     GIR_RootConstrainSelectedInstOperands,
     /*  621467 */     // GIR_Coverage, 5926,
     /*  621467 */     GIR_EraseRootFromParent_Done,
     /*  621468 */   // Label 10012: @621468
     /*  621468 */   GIM_Try, /*On fail goto*//*Label 10013*/ GIMT_Encode4(621543), // Rule ID 5927 //
     /*  621473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  621484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  621487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  621490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  621493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  621519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  621538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621541 */     GIR_RootConstrainSelectedInstOperands,
     /*  621542 */     // GIR_Coverage, 5927,
     /*  621542 */     GIR_EraseRootFromParent_Done,
     /*  621543 */   // Label 10013: @621543
     /*  621543 */   GIM_Try, /*On fail goto*//*Label 10014*/ GIMT_Encode4(621618), // Rule ID 5930 //
     /*  621548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  621559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  621562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  621565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  621568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621616 */     GIR_RootConstrainSelectedInstOperands,
     /*  621617 */     // GIR_Coverage, 5930,
     /*  621617 */     GIR_EraseRootFromParent_Done,
     /*  621618 */   // Label 10014: @621618
     /*  621618 */   GIM_Try, /*On fail goto*//*Label 10015*/ GIMT_Encode4(621693), // Rule ID 5931 //
     /*  621623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  621634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  621637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  621640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  621643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4),
     /*  621672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621691 */     GIR_RootConstrainSelectedInstOperands,
     /*  621692 */     // GIR_Coverage, 5931,
     /*  621692 */     GIR_EraseRootFromParent_Done,
     /*  621693 */   // Label 10015: @621693
     /*  621693 */   GIM_Try, /*On fail goto*//*Label 10016*/ GIMT_Encode4(621768), // Rule ID 5934 //
     /*  621698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  621709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  621712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  621715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  621718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  621744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621766 */     GIR_RootConstrainSelectedInstOperands,
     /*  621767 */     // GIR_Coverage, 5934,
     /*  621767 */     GIR_EraseRootFromParent_Done,
     /*  621768 */   // Label 10016: @621768
     /*  621768 */   GIM_Try, /*On fail goto*//*Label 10017*/ GIMT_Encode4(621843), // Rule ID 5935 //
     /*  621773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  621784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  621787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  621790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  621793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  621819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  621838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621841 */     GIR_RootConstrainSelectedInstOperands,
     /*  621842 */     // GIR_Coverage, 5935,
     /*  621842 */     GIR_EraseRootFromParent_Done,
     /*  621843 */   // Label 10017: @621843
     /*  621843 */   GIM_Try, /*On fail goto*//*Label 10018*/ GIMT_Encode4(621918), // Rule ID 5938 //
     /*  621848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  621851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  621859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  621862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  621865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  621868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  621871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  621894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621916 */     GIR_RootConstrainSelectedInstOperands,
     /*  621917 */     // GIR_Coverage, 5938,
     /*  621917 */     GIR_EraseRootFromParent_Done,
     /*  621918 */   // Label 10018: @621918
     /*  621918 */   GIM_Try, /*On fail goto*//*Label 10019*/ GIMT_Encode4(621993), // Rule ID 5939 //
     /*  621923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  621926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  621931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  621934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  621937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  621940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  621943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  621946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  621962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  621969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  621969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2),
     /*  621972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  621974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  621976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  621978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  621980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  621985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  621988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  621991 */     GIR_RootConstrainSelectedInstOperands,
     /*  621992 */     // GIR_Coverage, 5939,
     /*  621992 */     GIR_EraseRootFromParent_Done,
     /*  621993 */   // Label 10019: @621993
     /*  621993 */   GIM_Try, /*On fail goto*//*Label 10020*/ GIMT_Encode4(622068), // Rule ID 5942 //
     /*  621998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622066 */     GIR_RootConstrainSelectedInstOperands,
     /*  622067 */     // GIR_Coverage, 5942,
     /*  622067 */     GIR_EraseRootFromParent_Done,
     /*  622068 */   // Label 10020: @622068
     /*  622068 */   GIM_Try, /*On fail goto*//*Label 10021*/ GIMT_Encode4(622143), // Rule ID 5943 //
     /*  622073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  622084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  622087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  622090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  622093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622141 */     GIR_RootConstrainSelectedInstOperands,
     /*  622142 */     // GIR_Coverage, 5943,
     /*  622142 */     GIR_EraseRootFromParent_Done,
     /*  622143 */   // Label 10021: @622143
     /*  622143 */   GIM_Try, /*On fail goto*//*Label 10022*/ GIMT_Encode4(622218), // Rule ID 5946 //
     /*  622148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  622194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622216 */     GIR_RootConstrainSelectedInstOperands,
     /*  622217 */     // GIR_Coverage, 5946,
     /*  622217 */     GIR_EraseRootFromParent_Done,
     /*  622218 */   // Label 10022: @622218
     /*  622218 */   GIM_Try, /*On fail goto*//*Label 10023*/ GIMT_Encode4(622293), // Rule ID 5947 //
     /*  622223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  622234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  622237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  622240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  622243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  622269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  622288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622291 */     GIR_RootConstrainSelectedInstOperands,
     /*  622292 */     // GIR_Coverage, 5947,
     /*  622292 */     GIR_EraseRootFromParent_Done,
     /*  622293 */   // Label 10023: @622293
     /*  622293 */   GIM_Try, /*On fail goto*//*Label 10024*/ GIMT_Encode4(622368), // Rule ID 5950 //
     /*  622298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  622344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622366 */     GIR_RootConstrainSelectedInstOperands,
     /*  622367 */     // GIR_Coverage, 5950,
     /*  622367 */     GIR_EraseRootFromParent_Done,
     /*  622368 */   // Label 10024: @622368
     /*  622368 */   GIM_Try, /*On fail goto*//*Label 10025*/ GIMT_Encode4(622443), // Rule ID 5951 //
     /*  622373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  622384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  622387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  622390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  622393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  622419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  622438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622441 */     GIR_RootConstrainSelectedInstOperands,
     /*  622442 */     // GIR_Coverage, 5951,
     /*  622442 */     GIR_EraseRootFromParent_Done,
     /*  622443 */   // Label 10025: @622443
     /*  622443 */   GIM_Try, /*On fail goto*//*Label 10026*/ GIMT_Encode4(622518), // Rule ID 5954 //
     /*  622448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  622451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  622459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  622462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  622465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  622468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  622494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622516 */     GIR_RootConstrainSelectedInstOperands,
     /*  622517 */     // GIR_Coverage, 5954,
     /*  622517 */     GIR_EraseRootFromParent_Done,
     /*  622518 */   // Label 10026: @622518
     /*  622518 */   GIM_Try, /*On fail goto*//*Label 10027*/ GIMT_Encode4(622593), // Rule ID 5955 //
     /*  622523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  622526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  622534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  622537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  622540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  622543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  622562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  622569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1),
     /*  622572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  622588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622591 */     GIR_RootConstrainSelectedInstOperands,
     /*  622592 */     // GIR_Coverage, 5955,
     /*  622592 */     GIR_EraseRootFromParent_Done,
     /*  622593 */   // Label 10027: @622593
     /*  622593 */   GIM_Try, /*On fail goto*//*Label 10028*/ GIMT_Encode4(622668), // Rule ID 5958 //
     /*  622598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  622609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  622612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  622615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  622618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  622647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622666 */     GIR_RootConstrainSelectedInstOperands,
     /*  622667 */     // GIR_Coverage, 5958,
     /*  622667 */     GIR_EraseRootFromParent_Done,
     /*  622668 */   // Label 10028: @622668
     /*  622668 */   GIM_Try, /*On fail goto*//*Label 10029*/ GIMT_Encode4(622743), // Rule ID 5959 //
     /*  622673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  622684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  622687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  622690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  622693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  622712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622719 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  622722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622741 */     GIR_RootConstrainSelectedInstOperands,
     /*  622742 */     // GIR_Coverage, 5959,
     /*  622742 */     GIR_EraseRootFromParent_Done,
     /*  622743 */   // Label 10029: @622743
     /*  622743 */   GIM_Try, /*On fail goto*//*Label 10030*/ GIMT_Encode4(622818), // Rule ID 5962 //
     /*  622748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  622759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  622762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  622765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  622768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  622797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622816 */     GIR_RootConstrainSelectedInstOperands,
     /*  622817 */     // GIR_Coverage, 5962,
     /*  622817 */     GIR_EraseRootFromParent_Done,
     /*  622818 */   // Label 10030: @622818
     /*  622818 */   GIM_Try, /*On fail goto*//*Label 10031*/ GIMT_Encode4(622893), // Rule ID 5963 //
     /*  622823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  622834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  622837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  622840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  622843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  622862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  622869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  622872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622891 */     GIR_RootConstrainSelectedInstOperands,
     /*  622892 */     // GIR_Coverage, 5963,
     /*  622892 */     GIR_EraseRootFromParent_Done,
     /*  622893 */   // Label 10031: @622893
     /*  622893 */   GIM_Try, /*On fail goto*//*Label 10032*/ GIMT_Encode4(622968), // Rule ID 5966 //
     /*  622898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  622901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  622909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  622912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  622915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  622918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  622921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  622937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  622944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  622944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  622947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  622949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  622951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  622953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  622955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  622960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  622963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  622966 */     GIR_RootConstrainSelectedInstOperands,
     /*  622967 */     // GIR_Coverage, 5966,
     /*  622967 */     GIR_EraseRootFromParent_Done,
     /*  622968 */   // Label 10032: @622968
     /*  622968 */   GIM_Try, /*On fail goto*//*Label 10033*/ GIMT_Encode4(623043), // Rule ID 5967 //
     /*  622973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  622976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  622981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  622984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  622987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  622990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  622993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  622996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623019 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  623019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  623038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623041 */     GIR_RootConstrainSelectedInstOperands,
     /*  623042 */     // GIR_Coverage, 5967,
     /*  623042 */     GIR_EraseRootFromParent_Done,
     /*  623043 */   // Label 10033: @623043
     /*  623043 */   GIM_Try, /*On fail goto*//*Label 10034*/ GIMT_Encode4(623118), // Rule ID 5970 //
     /*  623048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623116 */     GIR_RootConstrainSelectedInstOperands,
     /*  623117 */     // GIR_Coverage, 5970,
     /*  623117 */     GIR_EraseRootFromParent_Done,
     /*  623118 */   // Label 10034: @623118
     /*  623118 */   GIM_Try, /*On fail goto*//*Label 10035*/ GIMT_Encode4(623193), // Rule ID 5971 //
     /*  623123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  623134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  623137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  623140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  623143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623191 */     GIR_RootConstrainSelectedInstOperands,
     /*  623192 */     // GIR_Coverage, 5971,
     /*  623192 */     GIR_EraseRootFromParent_Done,
     /*  623193 */   // Label 10035: @623193
     /*  623193 */   GIM_Try, /*On fail goto*//*Label 10036*/ GIMT_Encode4(623268), // Rule ID 5974 //
     /*  623198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623266 */     GIR_RootConstrainSelectedInstOperands,
     /*  623267 */     // GIR_Coverage, 5974,
     /*  623267 */     GIR_EraseRootFromParent_Done,
     /*  623268 */   // Label 10036: @623268
     /*  623268 */   GIM_Try, /*On fail goto*//*Label 10037*/ GIMT_Encode4(623343), // Rule ID 5975 //
     /*  623273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  623284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  623287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  623290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  623293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623319 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623341 */     GIR_RootConstrainSelectedInstOperands,
     /*  623342 */     // GIR_Coverage, 5975,
     /*  623342 */     GIR_EraseRootFromParent_Done,
     /*  623343 */   // Label 10037: @623343
     /*  623343 */   GIM_Try, /*On fail goto*//*Label 10038*/ GIMT_Encode4(623418), // Rule ID 5978 //
     /*  623348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  623394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623416 */     GIR_RootConstrainSelectedInstOperands,
     /*  623417 */     // GIR_Coverage, 5978,
     /*  623417 */     GIR_EraseRootFromParent_Done,
     /*  623418 */   // Label 10038: @623418
     /*  623418 */   GIM_Try, /*On fail goto*//*Label 10039*/ GIMT_Encode4(623493), // Rule ID 5979 //
     /*  623423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  623434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  623437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  623440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  623443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623469 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  623469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  623488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623491 */     GIR_RootConstrainSelectedInstOperands,
     /*  623492 */     // GIR_Coverage, 5979,
     /*  623492 */     GIR_EraseRootFromParent_Done,
     /*  623493 */   // Label 10039: @623493
     /*  623493 */   GIM_Try, /*On fail goto*//*Label 10040*/ GIMT_Encode4(623568), // Rule ID 5982 //
     /*  623498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  623509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  623512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  623515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  623518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623566 */     GIR_RootConstrainSelectedInstOperands,
     /*  623567 */     // GIR_Coverage, 5982,
     /*  623567 */     GIR_EraseRootFromParent_Done,
     /*  623568 */   // Label 10040: @623568
     /*  623568 */   GIM_Try, /*On fail goto*//*Label 10041*/ GIMT_Encode4(623643), // Rule ID 5983 //
     /*  623573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  623584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  623587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  623590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  623593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623641 */     GIR_RootConstrainSelectedInstOperands,
     /*  623642 */     // GIR_Coverage, 5983,
     /*  623642 */     GIR_EraseRootFromParent_Done,
     /*  623643 */   // Label 10041: @623643
     /*  623643 */   GIM_Try, /*On fail goto*//*Label 10042*/ GIMT_Encode4(623718), // Rule ID 5986 //
     /*  623648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  623659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  623662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  623665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  623668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623716 */     GIR_RootConstrainSelectedInstOperands,
     /*  623717 */     // GIR_Coverage, 5986,
     /*  623717 */     GIR_EraseRootFromParent_Done,
     /*  623718 */   // Label 10042: @623718
     /*  623718 */   GIM_Try, /*On fail goto*//*Label 10043*/ GIMT_Encode4(623793), // Rule ID 5987 //
     /*  623723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  623734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  623737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  623740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  623743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  623762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  623772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623791 */     GIR_RootConstrainSelectedInstOperands,
     /*  623792 */     // GIR_Coverage, 5987,
     /*  623792 */     GIR_EraseRootFromParent_Done,
     /*  623793 */   // Label 10043: @623793
     /*  623793 */   GIM_Try, /*On fail goto*//*Label 10044*/ GIMT_Encode4(623868), // Rule ID 5990 //
     /*  623798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  623801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  623809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  623812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  623815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  623818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  623844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623866 */     GIR_RootConstrainSelectedInstOperands,
     /*  623867 */     // GIR_Coverage, 5990,
     /*  623867 */     GIR_EraseRootFromParent_Done,
     /*  623868 */   // Label 10044: @623868
     /*  623868 */   GIM_Try, /*On fail goto*//*Label 10045*/ GIMT_Encode4(623943), // Rule ID 5991 //
     /*  623873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  623876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  623884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  623887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  623890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  623893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  623896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  623912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  623919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  623922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  623926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  623928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  623930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  623935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  623938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  623941 */     GIR_RootConstrainSelectedInstOperands,
     /*  623942 */     // GIR_Coverage, 5991,
     /*  623942 */     GIR_EraseRootFromParent_Done,
     /*  623943 */   // Label 10045: @623943
     /*  623943 */   GIM_Try, /*On fail goto*//*Label 10046*/ GIMT_Encode4(624018), // Rule ID 5994 //
     /*  623948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  623951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  623956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  623959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  623962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  623965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  623968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  623971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  623987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  623994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  623994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  623997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  623999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624016 */     GIR_RootConstrainSelectedInstOperands,
     /*  624017 */     // GIR_Coverage, 5994,
     /*  624017 */     GIR_EraseRootFromParent_Done,
     /*  624018 */   // Label 10046: @624018
     /*  624018 */   GIM_Try, /*On fail goto*//*Label 10047*/ GIMT_Encode4(624093), // Rule ID 5995 //
     /*  624023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  624034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  624037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  624040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  624043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  624062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2),
     /*  624072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624091 */     GIR_RootConstrainSelectedInstOperands,
     /*  624092 */     // GIR_Coverage, 5995,
     /*  624092 */     GIR_EraseRootFromParent_Done,
     /*  624093 */   // Label 10047: @624093
     /*  624093 */   GIM_Try, /*On fail goto*//*Label 10048*/ GIMT_Encode4(624168), // Rule ID 5998 //
     /*  624098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624166 */     GIR_RootConstrainSelectedInstOperands,
     /*  624167 */     // GIR_Coverage, 5998,
     /*  624167 */     GIR_EraseRootFromParent_Done,
     /*  624168 */   // Label 10048: @624168
     /*  624168 */   GIM_Try, /*On fail goto*//*Label 10049*/ GIMT_Encode4(624243), // Rule ID 5999 //
     /*  624173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  624184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  624187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  624190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  624193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  624212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624219 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4),
     /*  624222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624241 */     GIR_RootConstrainSelectedInstOperands,
     /*  624242 */     // GIR_Coverage, 5999,
     /*  624242 */     GIR_EraseRootFromParent_Done,
     /*  624243 */   // Label 10049: @624243
     /*  624243 */   GIM_Try, /*On fail goto*//*Label 10050*/ GIMT_Encode4(624318), // Rule ID 6002 //
     /*  624248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  624251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  624294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624316 */     GIR_RootConstrainSelectedInstOperands,
     /*  624317 */     // GIR_Coverage, 6002,
     /*  624317 */     GIR_EraseRootFromParent_Done,
     /*  624318 */   // Label 10050: @624318
     /*  624318 */   GIM_Try, /*On fail goto*//*Label 10051*/ GIMT_Encode4(624393), // Rule ID 6003 //
     /*  624323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  624326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  624334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  624337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  624340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  624343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  624362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  624369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8),
     /*  624372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  624388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624391 */     GIR_RootConstrainSelectedInstOperands,
     /*  624392 */     // GIR_Coverage, 6003,
     /*  624392 */     GIR_EraseRootFromParent_Done,
     /*  624393 */   // Label 10051: @624393
     /*  624393 */   GIM_Try, /*On fail goto*//*Label 10052*/ GIMT_Encode4(624468), // Rule ID 6006 //
     /*  624398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  624409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  624412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  624415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  624444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  624447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624466 */     GIR_RootConstrainSelectedInstOperands,
     /*  624467 */     // GIR_Coverage, 6006,
     /*  624467 */     GIR_EraseRootFromParent_Done,
     /*  624468 */   // Label 10052: @624468
     /*  624468 */   GIM_Try, /*On fail goto*//*Label 10053*/ GIMT_Encode4(624543), // Rule ID 6007 //
     /*  624473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  624484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  624487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  624490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8),
     /*  624522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624541 */     GIR_RootConstrainSelectedInstOperands,
     /*  624542 */     // GIR_Coverage, 6007,
     /*  624542 */     GIR_EraseRootFromParent_Done,
     /*  624543 */   // Label 10053: @624543
     /*  624543 */   GIM_Try, /*On fail goto*//*Label 10054*/ GIMT_Encode4(624618), // Rule ID 6010 //
     /*  624548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  624559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  624562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  624565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  624594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  624597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624616 */     GIR_RootConstrainSelectedInstOperands,
     /*  624617 */     // GIR_Coverage, 6010,
     /*  624617 */     GIR_EraseRootFromParent_Done,
     /*  624618 */   // Label 10054: @624618
     /*  624618 */   GIM_Try, /*On fail goto*//*Label 10055*/ GIMT_Encode4(624693), // Rule ID 6011 //
     /*  624623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  624634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  624637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  624640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  624672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624691 */     GIR_RootConstrainSelectedInstOperands,
     /*  624692 */     // GIR_Coverage, 6011,
     /*  624692 */     GIR_EraseRootFromParent_Done,
     /*  624693 */   // Label 10055: @624693
     /*  624693 */   GIM_Try, /*On fail goto*//*Label 10056*/ GIMT_Encode4(624768), // Rule ID 6014 //
     /*  624698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  624709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  624712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  624715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624744 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  624744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  624747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624766 */     GIR_RootConstrainSelectedInstOperands,
     /*  624767 */     // GIR_Coverage, 6014,
     /*  624767 */     GIR_EraseRootFromParent_Done,
     /*  624768 */   // Label 10056: @624768
     /*  624768 */   GIM_Try, /*On fail goto*//*Label 10057*/ GIMT_Encode4(624843), // Rule ID 6015 //
     /*  624773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  624784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  624787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  624790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624819 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  624819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  624822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  624838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624841 */     GIR_RootConstrainSelectedInstOperands,
     /*  624842 */     // GIR_Coverage, 6015,
     /*  624842 */     GIR_EraseRootFromParent_Done,
     /*  624843 */   // Label 10057: @624843
     /*  624843 */   GIM_Try, /*On fail goto*//*Label 10058*/ GIMT_Encode4(624918), // Rule ID 6018 //
     /*  624848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  624851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  624859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  624862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  624865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  624868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  624871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624894 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  624894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  624897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624916 */     GIR_RootConstrainSelectedInstOperands,
     /*  624917 */     // GIR_Coverage, 6018,
     /*  624917 */     GIR_EraseRootFromParent_Done,
     /*  624918 */   // Label 10058: @624918
     /*  624918 */   GIM_Try, /*On fail goto*//*Label 10059*/ GIMT_Encode4(624993), // Rule ID 6019 //
     /*  624923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  624926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  624931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  624934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  624937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  624940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  624943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  624946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  624958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  624962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  624969 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  624969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4),
     /*  624972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  624974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  624976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  624978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  624980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  624985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  624988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  624991 */     GIR_RootConstrainSelectedInstOperands,
     /*  624992 */     // GIR_Coverage, 6019,
     /*  624992 */     GIR_EraseRootFromParent_Done,
     /*  624993 */   // Label 10059: @624993
     /*  624993 */   GIM_Try, /*On fail goto*//*Label 10060*/ GIMT_Encode4(625068), // Rule ID 6022 //
     /*  624998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625066 */     GIR_RootConstrainSelectedInstOperands,
     /*  625067 */     // GIR_Coverage, 6022,
     /*  625067 */     GIR_EraseRootFromParent_Done,
     /*  625068 */   // Label 10060: @625068
     /*  625068 */   GIM_Try, /*On fail goto*//*Label 10061*/ GIMT_Encode4(625143), // Rule ID 6023 //
     /*  625073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  625084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  625087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  625090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625141 */     GIR_RootConstrainSelectedInstOperands,
     /*  625142 */     // GIR_Coverage, 6023,
     /*  625142 */     GIR_EraseRootFromParent_Done,
     /*  625143 */   // Label 10061: @625143
     /*  625143 */   GIM_Try, /*On fail goto*//*Label 10062*/ GIMT_Encode4(625218), // Rule ID 6026 //
     /*  625148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  625194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625216 */     GIR_RootConstrainSelectedInstOperands,
     /*  625217 */     // GIR_Coverage, 6026,
     /*  625217 */     GIR_EraseRootFromParent_Done,
     /*  625218 */   // Label 10062: @625218
     /*  625218 */   GIM_Try, /*On fail goto*//*Label 10063*/ GIMT_Encode4(625293), // Rule ID 6027 //
     /*  625223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  625234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  625237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  625240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625269 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  625269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2),
     /*  625272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625291 */     GIR_RootConstrainSelectedInstOperands,
     /*  625292 */     // GIR_Coverage, 6027,
     /*  625292 */     GIR_EraseRootFromParent_Done,
     /*  625293 */   // Label 10063: @625293
     /*  625293 */   GIM_Try, /*On fail goto*//*Label 10064*/ GIMT_Encode4(625368), // Rule ID 6030 //
     /*  625298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625366 */     GIR_RootConstrainSelectedInstOperands,
     /*  625367 */     // GIR_Coverage, 6030,
     /*  625367 */     GIR_EraseRootFromParent_Done,
     /*  625368 */   // Label 10064: @625368
     /*  625368 */   GIM_Try, /*On fail goto*//*Label 10065*/ GIMT_Encode4(625443), // Rule ID 6031 //
     /*  625373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  625384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  625387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  625390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11426:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  625419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625441 */     GIR_RootConstrainSelectedInstOperands,
     /*  625442 */     // GIR_Coverage, 6031,
     /*  625442 */     GIR_EraseRootFromParent_Done,
     /*  625443 */   // Label 10065: @625443
     /*  625443 */   GIM_Try, /*On fail goto*//*Label 10066*/ GIMT_Encode4(625518), // Rule ID 6034 //
     /*  625448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  625459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  625462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  625465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  625494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625516 */     GIR_RootConstrainSelectedInstOperands,
     /*  625517 */     // GIR_Coverage, 6034,
     /*  625517 */     GIR_EraseRootFromParent_Done,
     /*  625518 */   // Label 10066: @625518
     /*  625518 */   GIM_Try, /*On fail goto*//*Label 10067*/ GIMT_Encode4(625593), // Rule ID 6035 //
     /*  625523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  625534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  625537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  625540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11426:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  625569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  625588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625591 */     GIR_RootConstrainSelectedInstOperands,
     /*  625592 */     // GIR_Coverage, 6035,
     /*  625592 */     GIR_EraseRootFromParent_Done,
     /*  625593 */   // Label 10067: @625593
     /*  625593 */   GIM_Try, /*On fail goto*//*Label 10068*/ GIMT_Encode4(625668), // Rule ID 6038 //
     /*  625598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  625609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  625612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  625615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  625644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625666 */     GIR_RootConstrainSelectedInstOperands,
     /*  625667 */     // GIR_Coverage, 6038,
     /*  625667 */     GIR_EraseRootFromParent_Done,
     /*  625668 */   // Label 10068: @625668
     /*  625668 */   GIM_Try, /*On fail goto*//*Label 10069*/ GIMT_Encode4(625743), // Rule ID 6039 //
     /*  625673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  625684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  625687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  625690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11426:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  625719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  625738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625741 */     GIR_RootConstrainSelectedInstOperands,
     /*  625742 */     // GIR_Coverage, 6039,
     /*  625742 */     GIR_EraseRootFromParent_Done,
     /*  625743 */   // Label 10069: @625743
     /*  625743 */   GIM_Try, /*On fail goto*//*Label 10070*/ GIMT_Encode4(625818), // Rule ID 6042 //
     /*  625748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  625751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  625759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  625762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  625765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  625794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625816 */     GIR_RootConstrainSelectedInstOperands,
     /*  625817 */     // GIR_Coverage, 6042,
     /*  625817 */     GIR_EraseRootFromParent_Done,
     /*  625818 */   // Label 10070: @625818
     /*  625818 */   GIM_Try, /*On fail goto*//*Label 10071*/ GIMT_Encode4(625893), // Rule ID 6043 //
     /*  625823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  625826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  625834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  625837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  625840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  625858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11426:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  625869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1),
     /*  625872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  625888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625891 */     GIR_RootConstrainSelectedInstOperands,
     /*  625892 */     // GIR_Coverage, 6043,
     /*  625892 */     GIR_EraseRootFromParent_Done,
     /*  625893 */   // Label 10071: @625893
     /*  625893 */   GIM_Try, /*On fail goto*//*Label 10072*/ GIMT_Encode4(625968), // Rule ID 6046 //
     /*  625898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  625901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  625909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  625912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  625915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  625918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  625921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  625933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  625937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  625944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  625944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  625947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  625949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  625951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  625953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  625955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  625960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  625963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  625966 */     GIR_RootConstrainSelectedInstOperands,
     /*  625967 */     // GIR_Coverage, 6046,
     /*  625967 */     GIR_EraseRootFromParent_Done,
     /*  625968 */   // Label 10072: @625968
     /*  625968 */   GIM_Try, /*On fail goto*//*Label 10073*/ GIMT_Encode4(626043), // Rule ID 6047 //
     /*  625973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  625976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  625981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  625984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  625987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  625990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  625993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  625996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626041 */     GIR_RootConstrainSelectedInstOperands,
     /*  626042 */     // GIR_Coverage, 6047,
     /*  626042 */     GIR_EraseRootFromParent_Done,
     /*  626043 */   // Label 10073: @626043
     /*  626043 */   GIM_Try, /*On fail goto*//*Label 10074*/ GIMT_Encode4(626118), // Rule ID 6050 //
     /*  626048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626116 */     GIR_RootConstrainSelectedInstOperands,
     /*  626117 */     // GIR_Coverage, 6050,
     /*  626117 */     GIR_EraseRootFromParent_Done,
     /*  626118 */   // Label 10074: @626118
     /*  626118 */   GIM_Try, /*On fail goto*//*Label 10075*/ GIMT_Encode4(626193), // Rule ID 6051 //
     /*  626123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  626134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  626137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  626140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626169 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626191 */     GIR_RootConstrainSelectedInstOperands,
     /*  626192 */     // GIR_Coverage, 6051,
     /*  626192 */     GIR_EraseRootFromParent_Done,
     /*  626193 */   // Label 10075: @626193
     /*  626193 */   GIM_Try, /*On fail goto*//*Label 10076*/ GIMT_Encode4(626268), // Rule ID 6054 //
     /*  626198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626244 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  626244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626266 */     GIR_RootConstrainSelectedInstOperands,
     /*  626267 */     // GIR_Coverage, 6054,
     /*  626267 */     GIR_EraseRootFromParent_Done,
     /*  626268 */   // Label 10076: @626268
     /*  626268 */   GIM_Try, /*On fail goto*//*Label 10077*/ GIMT_Encode4(626343), // Rule ID 6055 //
     /*  626273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  626284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  626287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  626290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626319 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  626319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  626338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626341 */     GIR_RootConstrainSelectedInstOperands,
     /*  626342 */     // GIR_Coverage, 6055,
     /*  626342 */     GIR_EraseRootFromParent_Done,
     /*  626343 */   // Label 10077: @626343
     /*  626343 */   GIM_Try, /*On fail goto*//*Label 10078*/ GIMT_Encode4(626418), // Rule ID 6058 //
     /*  626348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626416 */     GIR_RootConstrainSelectedInstOperands,
     /*  626417 */     // GIR_Coverage, 6058,
     /*  626417 */     GIR_EraseRootFromParent_Done,
     /*  626418 */   // Label 10078: @626418
     /*  626418 */   GIM_Try, /*On fail goto*//*Label 10079*/ GIMT_Encode4(626493), // Rule ID 6059 //
     /*  626423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  626434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  626437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  626440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626491 */     GIR_RootConstrainSelectedInstOperands,
     /*  626492 */     // GIR_Coverage, 6059,
     /*  626492 */     GIR_EraseRootFromParent_Done,
     /*  626493 */   // Label 10079: @626493
     /*  626493 */   GIM_Try, /*On fail goto*//*Label 10080*/ GIMT_Encode4(626568), // Rule ID 6062 //
     /*  626498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  626509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  626512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  626515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626566 */     GIR_RootConstrainSelectedInstOperands,
     /*  626567 */     // GIR_Coverage, 6062,
     /*  626567 */     GIR_EraseRootFromParent_Done,
     /*  626568 */   // Label 10080: @626568
     /*  626568 */   GIM_Try, /*On fail goto*//*Label 10081*/ GIMT_Encode4(626643), // Rule ID 6063 //
     /*  626573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  626584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  626587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  626590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626641 */     GIR_RootConstrainSelectedInstOperands,
     /*  626642 */     // GIR_Coverage, 6063,
     /*  626642 */     GIR_EraseRootFromParent_Done,
     /*  626643 */   // Label 10081: @626643
     /*  626643 */   GIM_Try, /*On fail goto*//*Label 10082*/ GIMT_Encode4(626718), // Rule ID 6066 //
     /*  626648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  626659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  626662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  626665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  626694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626716 */     GIR_RootConstrainSelectedInstOperands,
     /*  626717 */     // GIR_Coverage, 6066,
     /*  626717 */     GIR_EraseRootFromParent_Done,
     /*  626718 */   // Label 10082: @626718
     /*  626718 */   GIM_Try, /*On fail goto*//*Label 10083*/ GIMT_Encode4(626793), // Rule ID 6067 //
     /*  626723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  626734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  626737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  626740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  626758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626769 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  626769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  626772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  626788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626791 */     GIR_RootConstrainSelectedInstOperands,
     /*  626792 */     // GIR_Coverage, 6067,
     /*  626792 */     GIR_EraseRootFromParent_Done,
     /*  626793 */   // Label 10083: @626793
     /*  626793 */   GIM_Try, /*On fail goto*//*Label 10084*/ GIMT_Encode4(626868), // Rule ID 6070 //
     /*  626798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  626809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  626812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  626815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626866 */     GIR_RootConstrainSelectedInstOperands,
     /*  626867 */     // GIR_Coverage, 6070,
     /*  626867 */     GIR_EraseRootFromParent_Done,
     /*  626868 */   // Label 10084: @626868
     /*  626868 */   GIM_Try, /*On fail goto*//*Label 10085*/ GIMT_Encode4(626943), // Rule ID 6071 //
     /*  626873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  626876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  626884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  626887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  626890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  626893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  626896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  626908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  626919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  626922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  626926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  626928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  626930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  626935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  626938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  626941 */     GIR_RootConstrainSelectedInstOperands,
     /*  626942 */     // GIR_Coverage, 6071,
     /*  626942 */     GIR_EraseRootFromParent_Done,
     /*  626943 */   // Label 10085: @626943
     /*  626943 */   GIM_Try, /*On fail goto*//*Label 10086*/ GIMT_Encode4(627018), // Rule ID 6074 //
     /*  626948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  626951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  626956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  626959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  626962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  626965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  626968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  626971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  626983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  626987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  626994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  626994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  626997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  626999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627016 */     GIR_RootConstrainSelectedInstOperands,
     /*  627017 */     // GIR_Coverage, 6074,
     /*  627017 */     GIR_EraseRootFromParent_Done,
     /*  627018 */   // Label 10086: @627018
     /*  627018 */   GIM_Try, /*On fail goto*//*Label 10087*/ GIMT_Encode4(627093), // Rule ID 6075 //
     /*  627023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  627034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  627037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  627040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627091 */     GIR_RootConstrainSelectedInstOperands,
     /*  627092 */     // GIR_Coverage, 6075,
     /*  627092 */     GIR_EraseRootFromParent_Done,
     /*  627093 */   // Label 10087: @627093
     /*  627093 */   GIM_Try, /*On fail goto*//*Label 10088*/ GIMT_Encode4(627168), // Rule ID 6078 //
     /*  627098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  627144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627166 */     GIR_RootConstrainSelectedInstOperands,
     /*  627167 */     // GIR_Coverage, 6078,
     /*  627167 */     GIR_EraseRootFromParent_Done,
     /*  627168 */   // Label 10088: @627168
     /*  627168 */   GIM_Try, /*On fail goto*//*Label 10089*/ GIMT_Encode4(627243), // Rule ID 6079 //
     /*  627173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  627184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  627187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  627190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627219 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  627219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  627238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627241 */     GIR_RootConstrainSelectedInstOperands,
     /*  627242 */     // GIR_Coverage, 6079,
     /*  627242 */     GIR_EraseRootFromParent_Done,
     /*  627243 */   // Label 10089: @627243
     /*  627243 */   GIM_Try, /*On fail goto*//*Label 10090*/ GIMT_Encode4(627318), // Rule ID 6082 //
     /*  627248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627316 */     GIR_RootConstrainSelectedInstOperands,
     /*  627317 */     // GIR_Coverage, 6082,
     /*  627317 */     GIR_EraseRootFromParent_Done,
     /*  627318 */   // Label 10090: @627318
     /*  627318 */   GIM_Try, /*On fail goto*//*Label 10091*/ GIMT_Encode4(627393), // Rule ID 6083 //
     /*  627323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  627334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  627337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  627340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  627358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11426:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  627369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2),
     /*  627372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627391 */     GIR_RootConstrainSelectedInstOperands,
     /*  627392 */     // GIR_Coverage, 6083,
     /*  627392 */     GIR_EraseRootFromParent_Done,
     /*  627393 */   // Label 10091: @627393
     /*  627393 */   GIM_Try, /*On fail goto*//*Label 10092*/ GIMT_Encode4(627468), // Rule ID 6086 //
     /*  627398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  627409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  627412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  627415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627466 */     GIR_RootConstrainSelectedInstOperands,
     /*  627467 */     // GIR_Coverage, 6086,
     /*  627467 */     GIR_EraseRootFromParent_Done,
     /*  627468 */   // Label 10092: @627468
     /*  627468 */   GIM_Try, /*On fail goto*//*Label 10093*/ GIMT_Encode4(627543), // Rule ID 6087 //
     /*  627473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  627484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  627487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  627490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  627508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11426:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  627519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4),
     /*  627522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627541 */     GIR_RootConstrainSelectedInstOperands,
     /*  627542 */     // GIR_Coverage, 6087,
     /*  627542 */     GIR_EraseRootFromParent_Done,
     /*  627543 */   // Label 10093: @627543
     /*  627543 */   GIM_Try, /*On fail goto*//*Label 10094*/ GIMT_Encode4(627618), // Rule ID 6090 //
     /*  627548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  627551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  627559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  627562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  627565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  627568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  627594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627616 */     GIR_RootConstrainSelectedInstOperands,
     /*  627617 */     // GIR_Coverage, 6090,
     /*  627617 */     GIR_EraseRootFromParent_Done,
     /*  627618 */   // Label 10094: @627618
     /*  627618 */   GIM_Try, /*On fail goto*//*Label 10095*/ GIMT_Encode4(627693), // Rule ID 6091 //
     /*  627623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  627626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor),
     /*  627631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  627634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  627637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  627640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  627643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  627658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  627662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627669 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11426:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  627669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8),
     /*  627672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  627688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627691 */     GIR_RootConstrainSelectedInstOperands,
     /*  627692 */     // GIR_Coverage, 6091,
     /*  627692 */     GIR_EraseRootFromParent_Done,
     /*  627693 */   // Label 10095: @627693
     /*  627693 */   GIM_Try, /*On fail goto*//*Label 10096*/ GIMT_Encode4(627768), // Rule ID 6182 //
     /*  627698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  627706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  627709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  627712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  627715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  627718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  627747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627766 */     GIR_RootConstrainSelectedInstOperands,
     /*  627767 */     // GIR_Coverage, 6182,
     /*  627767 */     GIR_EraseRootFromParent_Done,
     /*  627768 */   // Label 10096: @627768
     /*  627768 */   GIM_Try, /*On fail goto*//*Label 10097*/ GIMT_Encode4(627843), // Rule ID 6183 //
     /*  627773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  627781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  627784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  627787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  627790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  627793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8),
     /*  627822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627841 */     GIR_RootConstrainSelectedInstOperands,
     /*  627842 */     // GIR_Coverage, 6183,
     /*  627842 */     GIR_EraseRootFromParent_Done,
     /*  627843 */   // Label 10097: @627843
     /*  627843 */   GIM_Try, /*On fail goto*//*Label 10098*/ GIMT_Encode4(627918), // Rule ID 6186 //
     /*  627848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  627851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  627856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  627859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  627862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  627865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  627868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  627871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  627894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  627897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627916 */     GIR_RootConstrainSelectedInstOperands,
     /*  627917 */     // GIR_Coverage, 6186,
     /*  627917 */     GIR_EraseRootFromParent_Done,
     /*  627918 */   // Label 10098: @627918
     /*  627918 */   GIM_Try, /*On fail goto*//*Label 10099*/ GIMT_Encode4(627993), // Rule ID 6187 //
     /*  627923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  627926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  627931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  627934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  627937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  627940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  627943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  627946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  627962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  627969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  627969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  627972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  627974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  627976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  627978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  627980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  627985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  627988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  627991 */     GIR_RootConstrainSelectedInstOperands,
     /*  627992 */     // GIR_Coverage, 6187,
     /*  627992 */     GIR_EraseRootFromParent_Done,
     /*  627993 */   // Label 10099: @627993
     /*  627993 */   GIM_Try, /*On fail goto*//*Label 10100*/ GIMT_Encode4(628068), // Rule ID 6190 //
     /*  627998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628066 */     GIR_RootConstrainSelectedInstOperands,
     /*  628067 */     // GIR_Coverage, 6190,
     /*  628067 */     GIR_EraseRootFromParent_Done,
     /*  628068 */   // Label 10100: @628068
     /*  628068 */   GIM_Try, /*On fail goto*//*Label 10101*/ GIMT_Encode4(628143), // Rule ID 6191 //
     /*  628073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  628084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  628087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  628090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  628093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628119 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628141 */     GIR_RootConstrainSelectedInstOperands,
     /*  628142 */     // GIR_Coverage, 6191,
     /*  628142 */     GIR_EraseRootFromParent_Done,
     /*  628143 */   // Label 10101: @628143
     /*  628143 */   GIM_Try, /*On fail goto*//*Label 10102*/ GIMT_Encode4(628218), // Rule ID 6194 //
     /*  628148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628216 */     GIR_RootConstrainSelectedInstOperands,
     /*  628217 */     // GIR_Coverage, 6194,
     /*  628217 */     GIR_EraseRootFromParent_Done,
     /*  628218 */   // Label 10102: @628218
     /*  628218 */   GIM_Try, /*On fail goto*//*Label 10103*/ GIMT_Encode4(628293), // Rule ID 6195 //
     /*  628223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  628234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  628237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  628240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  628243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4),
     /*  628272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628291 */     GIR_RootConstrainSelectedInstOperands,
     /*  628292 */     // GIR_Coverage, 6195,
     /*  628292 */     GIR_EraseRootFromParent_Done,
     /*  628293 */   // Label 10103: @628293
     /*  628293 */   GIM_Try, /*On fail goto*//*Label 10104*/ GIMT_Encode4(628368), // Rule ID 6198 //
     /*  628298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628366 */     GIR_RootConstrainSelectedInstOperands,
     /*  628367 */     // GIR_Coverage, 6198,
     /*  628367 */     GIR_EraseRootFromParent_Done,
     /*  628368 */   // Label 10104: @628368
     /*  628368 */   GIM_Try, /*On fail goto*//*Label 10105*/ GIMT_Encode4(628443), // Rule ID 6199 //
     /*  628373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  628384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  628387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  628390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  628393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628419 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628441 */     GIR_RootConstrainSelectedInstOperands,
     /*  628442 */     // GIR_Coverage, 6199,
     /*  628442 */     GIR_EraseRootFromParent_Done,
     /*  628443 */   // Label 10105: @628443
     /*  628443 */   GIM_Try, /*On fail goto*//*Label 10106*/ GIMT_Encode4(628518), // Rule ID 6202 //
     /*  628448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  628459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  628462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  628465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  628468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628516 */     GIR_RootConstrainSelectedInstOperands,
     /*  628517 */     // GIR_Coverage, 6202,
     /*  628517 */     GIR_EraseRootFromParent_Done,
     /*  628518 */   // Label 10106: @628518
     /*  628518 */   GIM_Try, /*On fail goto*//*Label 10107*/ GIMT_Encode4(628593), // Rule ID 6203 //
     /*  628523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  628534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  628537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  628540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  628543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  628569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2),
     /*  628572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628591 */     GIR_RootConstrainSelectedInstOperands,
     /*  628592 */     // GIR_Coverage, 6203,
     /*  628592 */     GIR_EraseRootFromParent_Done,
     /*  628593 */   // Label 10107: @628593
     /*  628593 */   GIM_Try, /*On fail goto*//*Label 10108*/ GIMT_Encode4(628668), // Rule ID 6206 //
     /*  628598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  628609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  628612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  628615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  628618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  628644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  628647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628666 */     GIR_RootConstrainSelectedInstOperands,
     /*  628667 */     // GIR_Coverage, 6206,
     /*  628667 */     GIR_EraseRootFromParent_Done,
     /*  628668 */   // Label 10108: @628668
     /*  628668 */   GIM_Try, /*On fail goto*//*Label 10109*/ GIMT_Encode4(628743), // Rule ID 6207 //
     /*  628673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  628684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  628687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  628690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  628693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628719 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  628719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  628722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  628738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628741 */     GIR_RootConstrainSelectedInstOperands,
     /*  628742 */     // GIR_Coverage, 6207,
     /*  628742 */     GIR_EraseRootFromParent_Done,
     /*  628743 */   // Label 10109: @628743
     /*  628743 */   GIM_Try, /*On fail goto*//*Label 10110*/ GIMT_Encode4(628818), // Rule ID 6210 //
     /*  628748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  628759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  628762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  628765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  628768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  628794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  628797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628816 */     GIR_RootConstrainSelectedInstOperands,
     /*  628817 */     // GIR_Coverage, 6210,
     /*  628817 */     GIR_EraseRootFromParent_Done,
     /*  628818 */   // Label 10110: @628818
     /*  628818 */   GIM_Try, /*On fail goto*//*Label 10111*/ GIMT_Encode4(628893), // Rule ID 6211 //
     /*  628823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  628834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  628837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  628840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  628843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628869 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  628869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  628872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  628888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628891 */     GIR_RootConstrainSelectedInstOperands,
     /*  628892 */     // GIR_Coverage, 6211,
     /*  628892 */     GIR_EraseRootFromParent_Done,
     /*  628893 */   // Label 10111: @628893
     /*  628893 */   GIM_Try, /*On fail goto*//*Label 10112*/ GIMT_Encode4(628968), // Rule ID 6214 //
     /*  628898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  628901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  628909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  628912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  628915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  628918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  628921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  628937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  628944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  628944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  628947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  628949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  628951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  628953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  628955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  628960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  628963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  628966 */     GIR_RootConstrainSelectedInstOperands,
     /*  628967 */     // GIR_Coverage, 6214,
     /*  628967 */     GIR_EraseRootFromParent_Done,
     /*  628968 */   // Label 10112: @628968
     /*  628968 */   GIM_Try, /*On fail goto*//*Label 10113*/ GIMT_Encode4(629043), // Rule ID 6215 //
     /*  628973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  628976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  628981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  628984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  628987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  628990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  628993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  628996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  629019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  629038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629041 */     GIR_RootConstrainSelectedInstOperands,
     /*  629042 */     // GIR_Coverage, 6215,
     /*  629042 */     GIR_EraseRootFromParent_Done,
     /*  629043 */   // Label 10113: @629043
     /*  629043 */   GIM_Try, /*On fail goto*//*Label 10114*/ GIMT_Encode4(629118), // Rule ID 6218 //
     /*  629048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  629051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  629094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629116 */     GIR_RootConstrainSelectedInstOperands,
     /*  629117 */     // GIR_Coverage, 6218,
     /*  629117 */     GIR_EraseRootFromParent_Done,
     /*  629118 */   // Label 10114: @629118
     /*  629118 */   GIM_Try, /*On fail goto*//*Label 10115*/ GIMT_Encode4(629193), // Rule ID 6219 //
     /*  629123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  629126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  629134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  629137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  629140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  629143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  629162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  629169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1),
     /*  629172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  629188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629191 */     GIR_RootConstrainSelectedInstOperands,
     /*  629192 */     // GIR_Coverage, 6219,
     /*  629192 */     GIR_EraseRootFromParent_Done,
     /*  629193 */   // Label 10115: @629193
     /*  629193 */   GIM_Try, /*On fail goto*//*Label 10116*/ GIMT_Encode4(629268), // Rule ID 6222 //
     /*  629198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629266 */     GIR_RootConstrainSelectedInstOperands,
     /*  629267 */     // GIR_Coverage, 6222,
     /*  629267 */     GIR_EraseRootFromParent_Done,
     /*  629268 */   // Label 10116: @629268
     /*  629268 */   GIM_Try, /*On fail goto*//*Label 10117*/ GIMT_Encode4(629343), // Rule ID 6223 //
     /*  629273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  629284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  629287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  629290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  629293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629341 */     GIR_RootConstrainSelectedInstOperands,
     /*  629342 */     // GIR_Coverage, 6223,
     /*  629342 */     GIR_EraseRootFromParent_Done,
     /*  629343 */   // Label 10117: @629343
     /*  629343 */   GIM_Try, /*On fail goto*//*Label 10118*/ GIMT_Encode4(629418), // Rule ID 6226 //
     /*  629348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629416 */     GIR_RootConstrainSelectedInstOperands,
     /*  629417 */     // GIR_Coverage, 6226,
     /*  629417 */     GIR_EraseRootFromParent_Done,
     /*  629418 */   // Label 10118: @629418
     /*  629418 */   GIM_Try, /*On fail goto*//*Label 10119*/ GIMT_Encode4(629493), // Rule ID 6227 //
     /*  629423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  629434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  629437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  629440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  629443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629491 */     GIR_RootConstrainSelectedInstOperands,
     /*  629492 */     // GIR_Coverage, 6227,
     /*  629492 */     GIR_EraseRootFromParent_Done,
     /*  629493 */   // Label 10119: @629493
     /*  629493 */   GIM_Try, /*On fail goto*//*Label 10120*/ GIMT_Encode4(629568), // Rule ID 6230 //
     /*  629498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  629509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  629512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  629515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  629518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  629544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  629547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629566 */     GIR_RootConstrainSelectedInstOperands,
     /*  629567 */     // GIR_Coverage, 6230,
     /*  629567 */     GIR_EraseRootFromParent_Done,
     /*  629568 */   // Label 10120: @629568
     /*  629568 */   GIM_Try, /*On fail goto*//*Label 10121*/ GIMT_Encode4(629643), // Rule ID 6231 //
     /*  629573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  629584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  629587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  629590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  629593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629619 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  629619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  629622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  629638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629641 */     GIR_RootConstrainSelectedInstOperands,
     /*  629642 */     // GIR_Coverage, 6231,
     /*  629642 */     GIR_EraseRootFromParent_Done,
     /*  629643 */   // Label 10121: @629643
     /*  629643 */   GIM_Try, /*On fail goto*//*Label 10122*/ GIMT_Encode4(629718), // Rule ID 6234 //
     /*  629648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  629659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  629662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  629665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  629668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629716 */     GIR_RootConstrainSelectedInstOperands,
     /*  629717 */     // GIR_Coverage, 6234,
     /*  629717 */     GIR_EraseRootFromParent_Done,
     /*  629718 */   // Label 10122: @629718
     /*  629718 */   GIM_Try, /*On fail goto*//*Label 10123*/ GIMT_Encode4(629793), // Rule ID 6235 //
     /*  629723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  629734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  629737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  629740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  629743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  629762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  629772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629791 */     GIR_RootConstrainSelectedInstOperands,
     /*  629792 */     // GIR_Coverage, 6235,
     /*  629792 */     GIR_EraseRootFromParent_Done,
     /*  629793 */   // Label 10123: @629793
     /*  629793 */   GIM_Try, /*On fail goto*//*Label 10124*/ GIMT_Encode4(629868), // Rule ID 6238 //
     /*  629798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  629809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  629812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  629815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  629818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629866 */     GIR_RootConstrainSelectedInstOperands,
     /*  629867 */     // GIR_Coverage, 6238,
     /*  629867 */     GIR_EraseRootFromParent_Done,
     /*  629868 */   // Label 10124: @629868
     /*  629868 */   GIM_Try, /*On fail goto*//*Label 10125*/ GIMT_Encode4(629943), // Rule ID 6239 //
     /*  629873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  629876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  629884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  629887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  629890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  629893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  629896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  629912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  629919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  629922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  629926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  629928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  629930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  629935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  629938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  629941 */     GIR_RootConstrainSelectedInstOperands,
     /*  629942 */     // GIR_Coverage, 6239,
     /*  629942 */     GIR_EraseRootFromParent_Done,
     /*  629943 */   // Label 10125: @629943
     /*  629943 */   GIM_Try, /*On fail goto*//*Label 10126*/ GIMT_Encode4(630018), // Rule ID 6242 //
     /*  629948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  629951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  629956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  629959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  629962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  629965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  629968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  629971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  629987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  629994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  629994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  629997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  629999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630016 */     GIR_RootConstrainSelectedInstOperands,
     /*  630017 */     // GIR_Coverage, 6242,
     /*  630017 */     GIR_EraseRootFromParent_Done,
     /*  630018 */   // Label 10126: @630018
     /*  630018 */   GIM_Try, /*On fail goto*//*Label 10127*/ GIMT_Encode4(630093), // Rule ID 6243 //
     /*  630023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  630034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  630037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  630040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  630043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630069 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  630069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  630088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630091 */     GIR_RootConstrainSelectedInstOperands,
     /*  630092 */     // GIR_Coverage, 6243,
     /*  630092 */     GIR_EraseRootFromParent_Done,
     /*  630093 */   // Label 10127: @630093
     /*  630093 */   GIM_Try, /*On fail goto*//*Label 10128*/ GIMT_Encode4(630168), // Rule ID 6246 //
     /*  630098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630166 */     GIR_RootConstrainSelectedInstOperands,
     /*  630167 */     // GIR_Coverage, 6246,
     /*  630167 */     GIR_EraseRootFromParent_Done,
     /*  630168 */   // Label 10128: @630168
     /*  630168 */   GIM_Try, /*On fail goto*//*Label 10129*/ GIMT_Encode4(630243), // Rule ID 6247 //
     /*  630173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  630184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  630187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  630190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  630193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630241 */     GIR_RootConstrainSelectedInstOperands,
     /*  630242 */     // GIR_Coverage, 6247,
     /*  630242 */     GIR_EraseRootFromParent_Done,
     /*  630243 */   // Label 10129: @630243
     /*  630243 */   GIM_Try, /*On fail goto*//*Label 10130*/ GIMT_Encode4(630318), // Rule ID 6250 //
     /*  630248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630316 */     GIR_RootConstrainSelectedInstOperands,
     /*  630317 */     // GIR_Coverage, 6250,
     /*  630317 */     GIR_EraseRootFromParent_Done,
     /*  630318 */   // Label 10130: @630318
     /*  630318 */   GIM_Try, /*On fail goto*//*Label 10131*/ GIMT_Encode4(630393), // Rule ID 6251 //
     /*  630323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  630334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  630337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  630340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  630343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630391 */     GIR_RootConstrainSelectedInstOperands,
     /*  630392 */     // GIR_Coverage, 6251,
     /*  630392 */     GIR_EraseRootFromParent_Done,
     /*  630393 */   // Label 10131: @630393
     /*  630393 */   GIM_Try, /*On fail goto*//*Label 10132*/ GIMT_Encode4(630468), // Rule ID 6254 //
     /*  630398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  630401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  630409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  630412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  630415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  630418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  630444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630466 */     GIR_RootConstrainSelectedInstOperands,
     /*  630467 */     // GIR_Coverage, 6254,
     /*  630467 */     GIR_EraseRootFromParent_Done,
     /*  630468 */   // Label 10132: @630468
     /*  630468 */   GIM_Try, /*On fail goto*//*Label 10133*/ GIMT_Encode4(630543), // Rule ID 6255 //
     /*  630473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  630476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  630484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  630487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  630490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  630493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  630519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  630538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630541 */     GIR_RootConstrainSelectedInstOperands,
     /*  630542 */     // GIR_Coverage, 6255,
     /*  630542 */     GIR_EraseRootFromParent_Done,
     /*  630543 */   // Label 10133: @630543
     /*  630543 */   GIM_Try, /*On fail goto*//*Label 10134*/ GIMT_Encode4(630618), // Rule ID 6258 //
     /*  630548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  630559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  630562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  630565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  630568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630616 */     GIR_RootConstrainSelectedInstOperands,
     /*  630617 */     // GIR_Coverage, 6258,
     /*  630617 */     GIR_EraseRootFromParent_Done,
     /*  630618 */   // Label 10134: @630618
     /*  630618 */   GIM_Try, /*On fail goto*//*Label 10135*/ GIMT_Encode4(630693), // Rule ID 6259 //
     /*  630623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  630634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  630637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  630640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  630643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  630662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2),
     /*  630672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630691 */     GIR_RootConstrainSelectedInstOperands,
     /*  630692 */     // GIR_Coverage, 6259,
     /*  630692 */     GIR_EraseRootFromParent_Done,
     /*  630693 */   // Label 10135: @630693
     /*  630693 */   GIM_Try, /*On fail goto*//*Label 10136*/ GIMT_Encode4(630768), // Rule ID 6262 //
     /*  630698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  630709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  630712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  630715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  630718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630766 */     GIR_RootConstrainSelectedInstOperands,
     /*  630767 */     // GIR_Coverage, 6262,
     /*  630767 */     GIR_EraseRootFromParent_Done,
     /*  630768 */   // Label 10136: @630768
     /*  630768 */   GIM_Try, /*On fail goto*//*Label 10137*/ GIMT_Encode4(630843), // Rule ID 6263 //
     /*  630773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  630784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  630787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  630790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  630793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  630812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630819 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4),
     /*  630822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630841 */     GIR_RootConstrainSelectedInstOperands,
     /*  630842 */     // GIR_Coverage, 6263,
     /*  630842 */     GIR_EraseRootFromParent_Done,
     /*  630843 */   // Label 10137: @630843
     /*  630843 */   GIM_Try, /*On fail goto*//*Label 10138*/ GIMT_Encode4(630918), // Rule ID 6266 //
     /*  630848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  630851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  630859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  630862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  630865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  630868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  630871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  630894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630916 */     GIR_RootConstrainSelectedInstOperands,
     /*  630917 */     // GIR_Coverage, 6266,
     /*  630917 */     GIR_EraseRootFromParent_Done,
     /*  630918 */   // Label 10138: @630918
     /*  630918 */   GIM_Try, /*On fail goto*//*Label 10139*/ GIMT_Encode4(630993), // Rule ID 6267 //
     /*  630923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  630926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  630931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  630934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  630937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  630940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  630943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  630946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  630962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  630969 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  630969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8),
     /*  630972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  630974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  630976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  630978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  630980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  630985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  630988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  630991 */     GIR_RootConstrainSelectedInstOperands,
     /*  630992 */     // GIR_Coverage, 6267,
     /*  630992 */     GIR_EraseRootFromParent_Done,
     /*  630993 */   // Label 10139: @630993
     /*  630993 */   GIM_Try, /*On fail goto*//*Label 10140*/ GIMT_Encode4(631068), // Rule ID 6270 //
     /*  630998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631066 */     GIR_RootConstrainSelectedInstOperands,
     /*  631067 */     // GIR_Coverage, 6270,
     /*  631067 */     GIR_EraseRootFromParent_Done,
     /*  631068 */   // Label 10140: @631068
     /*  631068 */   GIM_Try, /*On fail goto*//*Label 10141*/ GIMT_Encode4(631143), // Rule ID 6271 //
     /*  631073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  631084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  631087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  631090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631119 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8),
     /*  631122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631141 */     GIR_RootConstrainSelectedInstOperands,
     /*  631142 */     // GIR_Coverage, 6271,
     /*  631142 */     GIR_EraseRootFromParent_Done,
     /*  631143 */   // Label 10141: @631143
     /*  631143 */   GIM_Try, /*On fail goto*//*Label 10142*/ GIMT_Encode4(631218), // Rule ID 6274 //
     /*  631148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631194 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631216 */     GIR_RootConstrainSelectedInstOperands,
     /*  631217 */     // GIR_Coverage, 6274,
     /*  631217 */     GIR_EraseRootFromParent_Done,
     /*  631218 */   // Label 10142: @631218
     /*  631218 */   GIM_Try, /*On fail goto*//*Label 10143*/ GIMT_Encode4(631293), // Rule ID 6275 //
     /*  631223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  631234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  631237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  631240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631269 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631291 */     GIR_RootConstrainSelectedInstOperands,
     /*  631292 */     // GIR_Coverage, 6275,
     /*  631292 */     GIR_EraseRootFromParent_Done,
     /*  631293 */   // Label 10143: @631293
     /*  631293 */   GIM_Try, /*On fail goto*//*Label 10144*/ GIMT_Encode4(631368), // Rule ID 6278 //
     /*  631298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631366 */     GIR_RootConstrainSelectedInstOperands,
     /*  631367 */     // GIR_Coverage, 6278,
     /*  631367 */     GIR_EraseRootFromParent_Done,
     /*  631368 */   // Label 10144: @631368
     /*  631368 */   GIM_Try, /*On fail goto*//*Label 10145*/ GIMT_Encode4(631443), // Rule ID 6279 //
     /*  631373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  631384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  631387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  631390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  631419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631441 */     GIR_RootConstrainSelectedInstOperands,
     /*  631442 */     // GIR_Coverage, 6279,
     /*  631442 */     GIR_EraseRootFromParent_Done,
     /*  631443 */   // Label 10145: @631443
     /*  631443 */   GIM_Try, /*On fail goto*//*Label 10146*/ GIMT_Encode4(631518), // Rule ID 6282 //
     /*  631448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  631459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  631462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  631465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  631494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631516 */     GIR_RootConstrainSelectedInstOperands,
     /*  631517 */     // GIR_Coverage, 6282,
     /*  631517 */     GIR_EraseRootFromParent_Done,
     /*  631518 */   // Label 10146: @631518
     /*  631518 */   GIM_Try, /*On fail goto*//*Label 10147*/ GIMT_Encode4(631593), // Rule ID 6283 //
     /*  631523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  631534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  631537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  631540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4),
     /*  631572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631591 */     GIR_RootConstrainSelectedInstOperands,
     /*  631592 */     // GIR_Coverage, 6283,
     /*  631592 */     GIR_EraseRootFromParent_Done,
     /*  631593 */   // Label 10147: @631593
     /*  631593 */   GIM_Try, /*On fail goto*//*Label 10148*/ GIMT_Encode4(631668), // Rule ID 6286 //
     /*  631598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  631609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  631612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  631615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631644 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  631644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631666 */     GIR_RootConstrainSelectedInstOperands,
     /*  631667 */     // GIR_Coverage, 6286,
     /*  631667 */     GIR_EraseRootFromParent_Done,
     /*  631668 */   // Label 10148: @631668
     /*  631668 */   GIM_Try, /*On fail goto*//*Label 10149*/ GIMT_Encode4(631743), // Rule ID 6287 //
     /*  631673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  631684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  631687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  631690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631719 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  631719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  631738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631741 */     GIR_RootConstrainSelectedInstOperands,
     /*  631742 */     // GIR_Coverage, 6287,
     /*  631742 */     GIR_EraseRootFromParent_Done,
     /*  631743 */   // Label 10149: @631743
     /*  631743 */   GIM_Try, /*On fail goto*//*Label 10150*/ GIMT_Encode4(631818), // Rule ID 6290 //
     /*  631748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  631759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  631762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  631765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  631794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631816 */     GIR_RootConstrainSelectedInstOperands,
     /*  631817 */     // GIR_Coverage, 6290,
     /*  631817 */     GIR_EraseRootFromParent_Done,
     /*  631818 */   // Label 10150: @631818
     /*  631818 */   GIM_Try, /*On fail goto*//*Label 10151*/ GIMT_Encode4(631893), // Rule ID 6291 //
     /*  631823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  631834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  631837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  631840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  631869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2),
     /*  631872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  631888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631891 */     GIR_RootConstrainSelectedInstOperands,
     /*  631892 */     // GIR_Coverage, 6291,
     /*  631892 */     GIR_EraseRootFromParent_Done,
     /*  631893 */   // Label 10151: @631893
     /*  631893 */   GIM_Try, /*On fail goto*//*Label 10152*/ GIMT_Encode4(631968), // Rule ID 6294 //
     /*  631898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  631901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  631909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  631912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  631915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  631918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  631921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  631933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  631937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  631944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  631944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  631947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  631949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  631951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  631953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  631955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  631960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  631963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  631966 */     GIR_RootConstrainSelectedInstOperands,
     /*  631967 */     // GIR_Coverage, 6294,
     /*  631967 */     GIR_EraseRootFromParent_Done,
     /*  631968 */   // Label 10152: @631968
     /*  631968 */   GIM_Try, /*On fail goto*//*Label 10153*/ GIMT_Encode4(632043), // Rule ID 6295 //
     /*  631973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  631976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  631981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  631984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  631987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  631990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  631993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  631996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11606:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632041 */     GIR_RootConstrainSelectedInstOperands,
     /*  632042 */     // GIR_Coverage, 6295,
     /*  632042 */     GIR_EraseRootFromParent_Done,
     /*  632043 */   // Label 10153: @632043
     /*  632043 */   GIM_Try, /*On fail goto*//*Label 10154*/ GIMT_Encode4(632118), // Rule ID 6298 //
     /*  632048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632116 */     GIR_RootConstrainSelectedInstOperands,
     /*  632117 */     // GIR_Coverage, 6298,
     /*  632117 */     GIR_EraseRootFromParent_Done,
     /*  632118 */   // Label 10154: @632118
     /*  632118 */   GIM_Try, /*On fail goto*//*Label 10155*/ GIMT_Encode4(632193), // Rule ID 6299 //
     /*  632123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  632134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  632137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  632140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632169 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11606:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  632169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  632188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632191 */     GIR_RootConstrainSelectedInstOperands,
     /*  632192 */     // GIR_Coverage, 6299,
     /*  632192 */     GIR_EraseRootFromParent_Done,
     /*  632193 */   // Label 10155: @632193
     /*  632193 */   GIM_Try, /*On fail goto*//*Label 10156*/ GIMT_Encode4(632268), // Rule ID 6302 //
     /*  632198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  632244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632266 */     GIR_RootConstrainSelectedInstOperands,
     /*  632267 */     // GIR_Coverage, 6302,
     /*  632267 */     GIR_EraseRootFromParent_Done,
     /*  632268 */   // Label 10156: @632268
     /*  632268 */   GIM_Try, /*On fail goto*//*Label 10157*/ GIMT_Encode4(632343), // Rule ID 6303 //
     /*  632273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  632284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  632287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  632290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632319 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11606:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  632319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  632338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632341 */     GIR_RootConstrainSelectedInstOperands,
     /*  632342 */     // GIR_Coverage, 6303,
     /*  632342 */     GIR_EraseRootFromParent_Done,
     /*  632343 */   // Label 10157: @632343
     /*  632343 */   GIM_Try, /*On fail goto*//*Label 10158*/ GIMT_Encode4(632418), // Rule ID 6306 //
     /*  632348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  632351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  632394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632416 */     GIR_RootConstrainSelectedInstOperands,
     /*  632417 */     // GIR_Coverage, 6306,
     /*  632417 */     GIR_EraseRootFromParent_Done,
     /*  632418 */   // Label 10158: @632418
     /*  632418 */   GIM_Try, /*On fail goto*//*Label 10159*/ GIMT_Encode4(632493), // Rule ID 6307 //
     /*  632423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  632426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  632434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  632437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  632440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  632458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632469 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11606:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  632469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1),
     /*  632472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  632488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632491 */     GIR_RootConstrainSelectedInstOperands,
     /*  632492 */     // GIR_Coverage, 6307,
     /*  632492 */     GIR_EraseRootFromParent_Done,
     /*  632493 */   // Label 10159: @632493
     /*  632493 */   GIM_Try, /*On fail goto*//*Label 10160*/ GIMT_Encode4(632568), // Rule ID 6310 //
     /*  632498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  632509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  632512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  632515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  632547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632566 */     GIR_RootConstrainSelectedInstOperands,
     /*  632567 */     // GIR_Coverage, 6310,
     /*  632567 */     GIR_EraseRootFromParent_Done,
     /*  632568 */   // Label 10160: @632568
     /*  632568 */   GIM_Try, /*On fail goto*//*Label 10161*/ GIMT_Encode4(632643), // Rule ID 6311 //
     /*  632573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  632584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  632587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  632590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632619 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  632622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632641 */     GIR_RootConstrainSelectedInstOperands,
     /*  632642 */     // GIR_Coverage, 6311,
     /*  632642 */     GIR_EraseRootFromParent_Done,
     /*  632643 */   // Label 10161: @632643
     /*  632643 */   GIM_Try, /*On fail goto*//*Label 10162*/ GIMT_Encode4(632718), // Rule ID 6314 //
     /*  632648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  632659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  632662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  632665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  632697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632716 */     GIR_RootConstrainSelectedInstOperands,
     /*  632717 */     // GIR_Coverage, 6314,
     /*  632717 */     GIR_EraseRootFromParent_Done,
     /*  632718 */   // Label 10162: @632718
     /*  632718 */   GIM_Try, /*On fail goto*//*Label 10163*/ GIMT_Encode4(632793), // Rule ID 6315 //
     /*  632723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  632734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  632737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  632740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  632758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632769 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  632772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632791 */     GIR_RootConstrainSelectedInstOperands,
     /*  632792 */     // GIR_Coverage, 6315,
     /*  632792 */     GIR_EraseRootFromParent_Done,
     /*  632793 */   // Label 10163: @632793
     /*  632793 */   GIM_Try, /*On fail goto*//*Label 10164*/ GIMT_Encode4(632868), // Rule ID 6318 //
     /*  632798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  632809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  632812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  632815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  632844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  632847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632866 */     GIR_RootConstrainSelectedInstOperands,
     /*  632867 */     // GIR_Coverage, 6318,
     /*  632867 */     GIR_EraseRootFromParent_Done,
     /*  632868 */   // Label 10164: @632868
     /*  632868 */   GIM_Try, /*On fail goto*//*Label 10165*/ GIMT_Encode4(632943), // Rule ID 6319 //
     /*  632873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  632876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  632884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  632887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  632890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  632893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  632896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  632908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632919 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  632919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  632922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  632926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  632928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  632930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  632935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  632938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  632941 */     GIR_RootConstrainSelectedInstOperands,
     /*  632942 */     // GIR_Coverage, 6319,
     /*  632942 */     GIR_EraseRootFromParent_Done,
     /*  632943 */   // Label 10165: @632943
     /*  632943 */   GIM_Try, /*On fail goto*//*Label 10166*/ GIMT_Encode4(633018), // Rule ID 6322 //
     /*  632948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  632951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  632956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  632959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  632962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  632965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  632968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  632971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  632983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  632987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  632994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  632994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  632997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  632999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633016 */     GIR_RootConstrainSelectedInstOperands,
     /*  633017 */     // GIR_Coverage, 6322,
     /*  633017 */     GIR_EraseRootFromParent_Done,
     /*  633018 */   // Label 10166: @633018
     /*  633018 */   GIM_Try, /*On fail goto*//*Label 10167*/ GIMT_Encode4(633093), // Rule ID 6323 //
     /*  633023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  633034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  633037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  633040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633091 */     GIR_RootConstrainSelectedInstOperands,
     /*  633092 */     // GIR_Coverage, 6323,
     /*  633092 */     GIR_EraseRootFromParent_Done,
     /*  633093 */   // Label 10167: @633093
     /*  633093 */   GIM_Try, /*On fail goto*//*Label 10168*/ GIMT_Encode4(633168), // Rule ID 6326 //
     /*  633098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633166 */     GIR_RootConstrainSelectedInstOperands,
     /*  633167 */     // GIR_Coverage, 6326,
     /*  633167 */     GIR_EraseRootFromParent_Done,
     /*  633168 */   // Label 10168: @633168
     /*  633168 */   GIM_Try, /*On fail goto*//*Label 10169*/ GIMT_Encode4(633243), // Rule ID 6327 //
     /*  633173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  633184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  633187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  633190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633241 */     GIR_RootConstrainSelectedInstOperands,
     /*  633242 */     // GIR_Coverage, 6327,
     /*  633242 */     GIR_EraseRootFromParent_Done,
     /*  633243 */   // Label 10169: @633243
     /*  633243 */   GIM_Try, /*On fail goto*//*Label 10170*/ GIMT_Encode4(633318), // Rule ID 6330 //
     /*  633248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  633294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633316 */     GIR_RootConstrainSelectedInstOperands,
     /*  633317 */     // GIR_Coverage, 6330,
     /*  633317 */     GIR_EraseRootFromParent_Done,
     /*  633318 */   // Label 10170: @633318
     /*  633318 */   GIM_Try, /*On fail goto*//*Label 10171*/ GIMT_Encode4(633393), // Rule ID 6331 //
     /*  633323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  633334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  633337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  633340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633369 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  633369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  633388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633391 */     GIR_RootConstrainSelectedInstOperands,
     /*  633392 */     // GIR_Coverage, 6331,
     /*  633392 */     GIR_EraseRootFromParent_Done,
     /*  633393 */   // Label 10171: @633393
     /*  633393 */   GIM_Try, /*On fail goto*//*Label 10172*/ GIMT_Encode4(633468), // Rule ID 6334 //
     /*  633398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  633409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  633412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  633415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633466 */     GIR_RootConstrainSelectedInstOperands,
     /*  633467 */     // GIR_Coverage, 6334,
     /*  633467 */     GIR_EraseRootFromParent_Done,
     /*  633468 */   // Label 10172: @633468
     /*  633468 */   GIM_Try, /*On fail goto*//*Label 10173*/ GIMT_Encode4(633543), // Rule ID 6335 //
     /*  633473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  633484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  633487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  633490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633541 */     GIR_RootConstrainSelectedInstOperands,
     /*  633542 */     // GIR_Coverage, 6335,
     /*  633542 */     GIR_EraseRootFromParent_Done,
     /*  633543 */   // Label 10173: @633543
     /*  633543 */   GIM_Try, /*On fail goto*//*Label 10174*/ GIMT_Encode4(633618), // Rule ID 6338 //
     /*  633548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  633559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  633562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  633565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633616 */     GIR_RootConstrainSelectedInstOperands,
     /*  633617 */     // GIR_Coverage, 6338,
     /*  633617 */     GIR_EraseRootFromParent_Done,
     /*  633618 */   // Label 10174: @633618
     /*  633618 */   GIM_Try, /*On fail goto*//*Label 10175*/ GIMT_Encode4(633693), // Rule ID 6339 //
     /*  633623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  633634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  633637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  633640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  633658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  633672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633691 */     GIR_RootConstrainSelectedInstOperands,
     /*  633692 */     // GIR_Coverage, 6339,
     /*  633692 */     GIR_EraseRootFromParent_Done,
     /*  633693 */   // Label 10175: @633693
     /*  633693 */   GIM_Try, /*On fail goto*//*Label 10176*/ GIMT_Encode4(633768), // Rule ID 6342 //
     /*  633698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  633701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  633709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  633712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  633715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  633744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633766 */     GIR_RootConstrainSelectedInstOperands,
     /*  633767 */     // GIR_Coverage, 6342,
     /*  633767 */     GIR_EraseRootFromParent_Done,
     /*  633768 */   // Label 10176: @633768
     /*  633768 */   GIM_Try, /*On fail goto*//*Label 10177*/ GIMT_Encode4(633843), // Rule ID 6343 //
     /*  633773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  633776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  633784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  633787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  633790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  633808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  633819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  633822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  633838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633841 */     GIR_RootConstrainSelectedInstOperands,
     /*  633842 */     // GIR_Coverage, 6343,
     /*  633842 */     GIR_EraseRootFromParent_Done,
     /*  633843 */   // Label 10177: @633843
     /*  633843 */   GIM_Try, /*On fail goto*//*Label 10178*/ GIMT_Encode4(633918), // Rule ID 6346 //
     /*  633848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  633851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  633859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  633862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  633865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  633868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  633871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  633894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633916 */     GIR_RootConstrainSelectedInstOperands,
     /*  633917 */     // GIR_Coverage, 6346,
     /*  633917 */     GIR_EraseRootFromParent_Done,
     /*  633918 */   // Label 10178: @633918
     /*  633918 */   GIM_Try, /*On fail goto*//*Label 10179*/ GIMT_Encode4(633993), // Rule ID 6347 //
     /*  633923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  633926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  633931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  633934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  633937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  633940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  633943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  633946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  633958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  633962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  633969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11606:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  633969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2),
     /*  633972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  633974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  633976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  633978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  633980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  633985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  633988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  633991 */     GIR_RootConstrainSelectedInstOperands,
     /*  633992 */     // GIR_Coverage, 6347,
     /*  633992 */     GIR_EraseRootFromParent_Done,
     /*  633993 */   // Label 10179: @633993
     /*  633993 */   GIM_Try, /*On fail goto*//*Label 10180*/ GIMT_Encode4(634068), // Rule ID 6350 //
     /*  633998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634066 */     GIR_RootConstrainSelectedInstOperands,
     /*  634067 */     // GIR_Coverage, 6350,
     /*  634067 */     GIR_EraseRootFromParent_Done,
     /*  634068 */   // Label 10180: @634068
     /*  634068 */   GIM_Try, /*On fail goto*//*Label 10181*/ GIMT_Encode4(634143), // Rule ID 6351 //
     /*  634073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  634084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  634087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  634090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  634108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11606:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4),
     /*  634122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634141 */     GIR_RootConstrainSelectedInstOperands,
     /*  634142 */     // GIR_Coverage, 6351,
     /*  634142 */     GIR_EraseRootFromParent_Done,
     /*  634143 */   // Label 10181: @634143
     /*  634143 */   GIM_Try, /*On fail goto*//*Label 10182*/ GIMT_Encode4(634218), // Rule ID 6354 //
     /*  634148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  634151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  634168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  634194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634216 */     GIR_RootConstrainSelectedInstOperands,
     /*  634217 */     // GIR_Coverage, 6354,
     /*  634217 */     GIR_EraseRootFromParent_Done,
     /*  634218 */   // Label 10182: @634218
     /*  634218 */   GIM_Try, /*On fail goto*//*Label 10183*/ GIMT_Encode4(634293), // Rule ID 6355 //
     /*  634223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  634226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor),
     /*  634231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  634234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  634237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  634240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  634243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  634258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  634262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11606:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVXOR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  634269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8),
     /*  634272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  634288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634291 */     GIR_RootConstrainSelectedInstOperands,
     /*  634292 */     // GIR_Coverage, 6355,
     /*  634292 */     GIR_EraseRootFromParent_Done,
     /*  634293 */   // Label 10183: @634293
     /*  634293 */   GIM_Try, /*On fail goto*//*Label 10184*/ GIMT_Encode4(634368), // Rule ID 6446 //
     /*  634298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634344 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  634344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634366 */     GIR_RootConstrainSelectedInstOperands,
     /*  634367 */     // GIR_Coverage, 6446,
     /*  634367 */     GIR_EraseRootFromParent_Done,
     /*  634368 */   // Label 10184: @634368
     /*  634368 */   GIM_Try, /*On fail goto*//*Label 10185*/ GIMT_Encode4(634443), // Rule ID 6447 //
     /*  634373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  634384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  634387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  634390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  634393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634419 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  634419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /*  634422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634441 */     GIR_RootConstrainSelectedInstOperands,
     /*  634442 */     // GIR_Coverage, 6447,
     /*  634442 */     GIR_EraseRootFromParent_Done,
     /*  634443 */   // Label 10185: @634443
     /*  634443 */   GIM_Try, /*On fail goto*//*Label 10186*/ GIMT_Encode4(634518), // Rule ID 6450 //
     /*  634448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  634459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  634462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  634465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  634468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  634494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  634497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634516 */     GIR_RootConstrainSelectedInstOperands,
     /*  634517 */     // GIR_Coverage, 6450,
     /*  634517 */     GIR_EraseRootFromParent_Done,
     /*  634518 */   // Label 10186: @634518
     /*  634518 */   GIM_Try, /*On fail goto*//*Label 10187*/ GIMT_Encode4(634593), // Rule ID 6451 //
     /*  634523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  634534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  634537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  634540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  634543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634569 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  634569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  634572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634591 */     GIR_RootConstrainSelectedInstOperands,
     /*  634592 */     // GIR_Coverage, 6451,
     /*  634592 */     GIR_EraseRootFromParent_Done,
     /*  634593 */   // Label 10187: @634593
     /*  634593 */   GIM_Try, /*On fail goto*//*Label 10188*/ GIMT_Encode4(634668), // Rule ID 6454 //
     /*  634598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  634609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  634612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  634615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  634618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634644 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  634644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  634647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634666 */     GIR_RootConstrainSelectedInstOperands,
     /*  634667 */     // GIR_Coverage, 6454,
     /*  634667 */     GIR_EraseRootFromParent_Done,
     /*  634668 */   // Label 10188: @634668
     /*  634668 */   GIM_Try, /*On fail goto*//*Label 10189*/ GIMT_Encode4(634743), // Rule ID 6455 //
     /*  634673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  634684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  634687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  634690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  634693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634719 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  634719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  634722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  634738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634741 */     GIR_RootConstrainSelectedInstOperands,
     /*  634742 */     // GIR_Coverage, 6455,
     /*  634742 */     GIR_EraseRootFromParent_Done,
     /*  634743 */   // Label 10189: @634743
     /*  634743 */   GIM_Try, /*On fail goto*//*Label 10190*/ GIMT_Encode4(634818), // Rule ID 6458 //
     /*  634748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  634759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  634762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  634765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  634768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  634797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634816 */     GIR_RootConstrainSelectedInstOperands,
     /*  634817 */     // GIR_Coverage, 6458,
     /*  634817 */     GIR_EraseRootFromParent_Done,
     /*  634818 */   // Label 10190: @634818
     /*  634818 */   GIM_Try, /*On fail goto*//*Label 10191*/ GIMT_Encode4(634893), // Rule ID 6459 //
     /*  634823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  634834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  634837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  634840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  634843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  634869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /*  634872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634891 */     GIR_RootConstrainSelectedInstOperands,
     /*  634892 */     // GIR_Coverage, 6459,
     /*  634892 */     GIR_EraseRootFromParent_Done,
     /*  634893 */   // Label 10191: @634893
     /*  634893 */   GIM_Try, /*On fail goto*//*Label 10192*/ GIMT_Encode4(634968), // Rule ID 6462 //
     /*  634898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  634901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  634909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  634912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  634915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  634918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  634921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  634937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  634944 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  634944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  634947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  634949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  634951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  634953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  634955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  634960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  634963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  634966 */     GIR_RootConstrainSelectedInstOperands,
     /*  634967 */     // GIR_Coverage, 6462,
     /*  634967 */     GIR_EraseRootFromParent_Done,
     /*  634968 */   // Label 10192: @634968
     /*  634968 */   GIM_Try, /*On fail goto*//*Label 10193*/ GIMT_Encode4(635043), // Rule ID 6463 //
     /*  634973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  634976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  634981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  634984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  634987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  634990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  634993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  634996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635041 */     GIR_RootConstrainSelectedInstOperands,
     /*  635042 */     // GIR_Coverage, 6463,
     /*  635042 */     GIR_EraseRootFromParent_Done,
     /*  635043 */   // Label 10193: @635043
     /*  635043 */   GIM_Try, /*On fail goto*//*Label 10194*/ GIMT_Encode4(635118), // Rule ID 6466 //
     /*  635048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  635094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635116 */     GIR_RootConstrainSelectedInstOperands,
     /*  635117 */     // GIR_Coverage, 6466,
     /*  635117 */     GIR_EraseRootFromParent_Done,
     /*  635118 */   // Label 10194: @635118
     /*  635118 */   GIM_Try, /*On fail goto*//*Label 10195*/ GIMT_Encode4(635193), // Rule ID 6467 //
     /*  635123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  635134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  635137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  635140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  635143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  635169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /*  635172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635191 */     GIR_RootConstrainSelectedInstOperands,
     /*  635192 */     // GIR_Coverage, 6467,
     /*  635192 */     GIR_EraseRootFromParent_Done,
     /*  635193 */   // Label 10195: @635193
     /*  635193 */   GIM_Try, /*On fail goto*//*Label 10196*/ GIMT_Encode4(635268), // Rule ID 6470 //
     /*  635198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635266 */     GIR_RootConstrainSelectedInstOperands,
     /*  635267 */     // GIR_Coverage, 6470,
     /*  635267 */     GIR_EraseRootFromParent_Done,
     /*  635268 */   // Label 10196: @635268
     /*  635268 */   GIM_Try, /*On fail goto*//*Label 10197*/ GIMT_Encode4(635343), // Rule ID 6471 //
     /*  635273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  635284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  635287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  635290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  635293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635319 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635341 */     GIR_RootConstrainSelectedInstOperands,
     /*  635342 */     // GIR_Coverage, 6471,
     /*  635342 */     GIR_EraseRootFromParent_Done,
     /*  635343 */   // Label 10197: @635343
     /*  635343 */   GIM_Try, /*On fail goto*//*Label 10198*/ GIMT_Encode4(635418), // Rule ID 6474 //
     /*  635348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  635394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635416 */     GIR_RootConstrainSelectedInstOperands,
     /*  635417 */     // GIR_Coverage, 6474,
     /*  635417 */     GIR_EraseRootFromParent_Done,
     /*  635418 */   // Label 10198: @635418
     /*  635418 */   GIM_Try, /*On fail goto*//*Label 10199*/ GIMT_Encode4(635493), // Rule ID 6475 //
     /*  635423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  635434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  635437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  635440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  635443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  635469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  635488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635491 */     GIR_RootConstrainSelectedInstOperands,
     /*  635492 */     // GIR_Coverage, 6475,
     /*  635492 */     GIR_EraseRootFromParent_Done,
     /*  635493 */   // Label 10199: @635493
     /*  635493 */   GIM_Try, /*On fail goto*//*Label 10200*/ GIMT_Encode4(635568), // Rule ID 6478 //
     /*  635498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  635509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  635512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  635515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  635518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  635544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635566 */     GIR_RootConstrainSelectedInstOperands,
     /*  635567 */     // GIR_Coverage, 6478,
     /*  635567 */     GIR_EraseRootFromParent_Done,
     /*  635568 */   // Label 10200: @635568
     /*  635568 */   GIM_Try, /*On fail goto*//*Label 10201*/ GIMT_Encode4(635643), // Rule ID 6479 //
     /*  635573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  635584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  635587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  635590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  635593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  635619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  635638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635641 */     GIR_RootConstrainSelectedInstOperands,
     /*  635642 */     // GIR_Coverage, 6479,
     /*  635642 */     GIR_EraseRootFromParent_Done,
     /*  635643 */   // Label 10201: @635643
     /*  635643 */   GIM_Try, /*On fail goto*//*Label 10202*/ GIMT_Encode4(635718), // Rule ID 6482 //
     /*  635648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  635651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  635659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  635662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  635665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  635668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  635694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635716 */     GIR_RootConstrainSelectedInstOperands,
     /*  635717 */     // GIR_Coverage, 6482,
     /*  635717 */     GIR_EraseRootFromParent_Done,
     /*  635718 */   // Label 10202: @635718
     /*  635718 */   GIM_Try, /*On fail goto*//*Label 10203*/ GIMT_Encode4(635793), // Rule ID 6483 //
     /*  635723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  635726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  635734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  635737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  635740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  635743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  635762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635769 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  635769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /*  635772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  635788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635791 */     GIR_RootConstrainSelectedInstOperands,
     /*  635792 */     // GIR_Coverage, 6483,
     /*  635792 */     GIR_EraseRootFromParent_Done,
     /*  635793 */   // Label 10203: @635793
     /*  635793 */   GIM_Try, /*On fail goto*//*Label 10204*/ GIMT_Encode4(635868), // Rule ID 6486 //
     /*  635798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  635809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  635812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  635815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  635818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  635847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635866 */     GIR_RootConstrainSelectedInstOperands,
     /*  635867 */     // GIR_Coverage, 6486,
     /*  635867 */     GIR_EraseRootFromParent_Done,
     /*  635868 */   // Label 10204: @635868
     /*  635868 */   GIM_Try, /*On fail goto*//*Label 10205*/ GIMT_Encode4(635943), // Rule ID 6487 //
     /*  635873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  635876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  635884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  635887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  635890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  635893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  635896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  635912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  635919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  635922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  635926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  635928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  635930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  635935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  635938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  635941 */     GIR_RootConstrainSelectedInstOperands,
     /*  635942 */     // GIR_Coverage, 6487,
     /*  635942 */     GIR_EraseRootFromParent_Done,
     /*  635943 */   // Label 10205: @635943
     /*  635943 */   GIM_Try, /*On fail goto*//*Label 10206*/ GIMT_Encode4(636018), // Rule ID 6490 //
     /*  635948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  635951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  635956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  635959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  635962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  635965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  635968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  635971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  635987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  635994 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  635994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  635997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  635999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636016 */     GIR_RootConstrainSelectedInstOperands,
     /*  636017 */     // GIR_Coverage, 6490,
     /*  636017 */     GIR_EraseRootFromParent_Done,
     /*  636018 */   // Label 10206: @636018
     /*  636018 */   GIM_Try, /*On fail goto*//*Label 10207*/ GIMT_Encode4(636093), // Rule ID 6491 //
     /*  636023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  636034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  636037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  636040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  636043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636069 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636091 */     GIR_RootConstrainSelectedInstOperands,
     /*  636092 */     // GIR_Coverage, 6491,
     /*  636092 */     GIR_EraseRootFromParent_Done,
     /*  636093 */   // Label 10207: @636093
     /*  636093 */   GIM_Try, /*On fail goto*//*Label 10208*/ GIMT_Encode4(636168), // Rule ID 6494 //
     /*  636098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  636144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636166 */     GIR_RootConstrainSelectedInstOperands,
     /*  636167 */     // GIR_Coverage, 6494,
     /*  636167 */     GIR_EraseRootFromParent_Done,
     /*  636168 */   // Label 10208: @636168
     /*  636168 */   GIM_Try, /*On fail goto*//*Label 10209*/ GIMT_Encode4(636243), // Rule ID 6495 //
     /*  636173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  636184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  636187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  636190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  636193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636219 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  636219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  636238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636241 */     GIR_RootConstrainSelectedInstOperands,
     /*  636242 */     // GIR_Coverage, 6495,
     /*  636242 */     GIR_EraseRootFromParent_Done,
     /*  636243 */   // Label 10209: @636243
     /*  636243 */   GIM_Try, /*On fail goto*//*Label 10210*/ GIMT_Encode4(636318), // Rule ID 6498 //
     /*  636248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636316 */     GIR_RootConstrainSelectedInstOperands,
     /*  636317 */     // GIR_Coverage, 6498,
     /*  636317 */     GIR_EraseRootFromParent_Done,
     /*  636318 */   // Label 10210: @636318
     /*  636318 */   GIM_Try, /*On fail goto*//*Label 10211*/ GIMT_Encode4(636393), // Rule ID 6499 //
     /*  636323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  636334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  636337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  636340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  636343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636391 */     GIR_RootConstrainSelectedInstOperands,
     /*  636392 */     // GIR_Coverage, 6499,
     /*  636392 */     GIR_EraseRootFromParent_Done,
     /*  636393 */   // Label 10211: @636393
     /*  636393 */   GIM_Try, /*On fail goto*//*Label 10212*/ GIMT_Encode4(636468), // Rule ID 6502 //
     /*  636398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  636409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  636412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  636415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  636418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636466 */     GIR_RootConstrainSelectedInstOperands,
     /*  636467 */     // GIR_Coverage, 6502,
     /*  636467 */     GIR_EraseRootFromParent_Done,
     /*  636468 */   // Label 10212: @636468
     /*  636468 */   GIM_Try, /*On fail goto*//*Label 10213*/ GIMT_Encode4(636543), // Rule ID 6503 //
     /*  636473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  636484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  636487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  636490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  636493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636519 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636541 */     GIR_RootConstrainSelectedInstOperands,
     /*  636542 */     // GIR_Coverage, 6503,
     /*  636542 */     GIR_EraseRootFromParent_Done,
     /*  636543 */   // Label 10213: @636543
     /*  636543 */   GIM_Try, /*On fail goto*//*Label 10214*/ GIMT_Encode4(636618), // Rule ID 6506 //
     /*  636548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  636559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  636562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  636565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  636568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  636594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636616 */     GIR_RootConstrainSelectedInstOperands,
     /*  636617 */     // GIR_Coverage, 6506,
     /*  636617 */     GIR_EraseRootFromParent_Done,
     /*  636618 */   // Label 10214: @636618
     /*  636618 */   GIM_Try, /*On fail goto*//*Label 10215*/ GIMT_Encode4(636693), // Rule ID 6507 //
     /*  636623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  636634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  636637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  636640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  636643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  636662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  636669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  636672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  636688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636691 */     GIR_RootConstrainSelectedInstOperands,
     /*  636692 */     // GIR_Coverage, 6507,
     /*  636692 */     GIR_EraseRootFromParent_Done,
     /*  636693 */   // Label 10215: @636693
     /*  636693 */   GIM_Try, /*On fail goto*//*Label 10216*/ GIMT_Encode4(636768), // Rule ID 6510 //
     /*  636698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  636709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  636712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  636715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  636718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636766 */     GIR_RootConstrainSelectedInstOperands,
     /*  636767 */     // GIR_Coverage, 6510,
     /*  636767 */     GIR_EraseRootFromParent_Done,
     /*  636768 */   // Label 10216: @636768
     /*  636768 */   GIM_Try, /*On fail goto*//*Label 10217*/ GIMT_Encode4(636843), // Rule ID 6511 //
     /*  636773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  636784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  636787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  636790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  636793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  636812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  636822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636841 */     GIR_RootConstrainSelectedInstOperands,
     /*  636842 */     // GIR_Coverage, 6511,
     /*  636842 */     GIR_EraseRootFromParent_Done,
     /*  636843 */   // Label 10217: @636843
     /*  636843 */   GIM_Try, /*On fail goto*//*Label 10218*/ GIMT_Encode4(636918), // Rule ID 6514 //
     /*  636848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  636851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  636859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  636862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  636865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  636868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  636871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  636894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636916 */     GIR_RootConstrainSelectedInstOperands,
     /*  636917 */     // GIR_Coverage, 6514,
     /*  636917 */     GIR_EraseRootFromParent_Done,
     /*  636918 */   // Label 10218: @636918
     /*  636918 */   GIM_Try, /*On fail goto*//*Label 10219*/ GIMT_Encode4(636993), // Rule ID 6515 //
     /*  636923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  636926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  636931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  636934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  636937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  636940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  636943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  636946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  636962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  636969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  636969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  636972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  636974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  636976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  636978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  636980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  636985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  636988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  636991 */     GIR_RootConstrainSelectedInstOperands,
     /*  636992 */     // GIR_Coverage, 6515,
     /*  636992 */     GIR_EraseRootFromParent_Done,
     /*  636993 */   // Label 10219: @636993
     /*  636993 */   GIM_Try, /*On fail goto*//*Label 10220*/ GIMT_Encode4(637068), // Rule ID 6518 //
     /*  636998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  637044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637066 */     GIR_RootConstrainSelectedInstOperands,
     /*  637067 */     // GIR_Coverage, 6518,
     /*  637067 */     GIR_EraseRootFromParent_Done,
     /*  637068 */   // Label 10220: @637068
     /*  637068 */   GIM_Try, /*On fail goto*//*Label 10221*/ GIMT_Encode4(637143), // Rule ID 6519 //
     /*  637073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  637084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  637087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  637090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  637093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637119 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  637119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  637138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637141 */     GIR_RootConstrainSelectedInstOperands,
     /*  637142 */     // GIR_Coverage, 6519,
     /*  637142 */     GIR_EraseRootFromParent_Done,
     /*  637143 */   // Label 10221: @637143
     /*  637143 */   GIM_Try, /*On fail goto*//*Label 10222*/ GIMT_Encode4(637218), // Rule ID 6522 //
     /*  637148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637194 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637216 */     GIR_RootConstrainSelectedInstOperands,
     /*  637217 */     // GIR_Coverage, 6522,
     /*  637217 */     GIR_EraseRootFromParent_Done,
     /*  637218 */   // Label 10222: @637218
     /*  637218 */   GIM_Try, /*On fail goto*//*Label 10223*/ GIMT_Encode4(637293), // Rule ID 6523 //
     /*  637223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  637234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  637237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  637240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  637243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  637262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /*  637272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637291 */     GIR_RootConstrainSelectedInstOperands,
     /*  637292 */     // GIR_Coverage, 6523,
     /*  637292 */     GIR_EraseRootFromParent_Done,
     /*  637293 */   // Label 10223: @637293
     /*  637293 */   GIM_Try, /*On fail goto*//*Label 10224*/ GIMT_Encode4(637368), // Rule ID 6526 //
     /*  637298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637366 */     GIR_RootConstrainSelectedInstOperands,
     /*  637367 */     // GIR_Coverage, 6526,
     /*  637367 */     GIR_EraseRootFromParent_Done,
     /*  637368 */   // Label 10224: @637368
     /*  637368 */   GIM_Try, /*On fail goto*//*Label 10225*/ GIMT_Encode4(637443), // Rule ID 6527 //
     /*  637373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  637384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  637387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  637390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  637393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  637412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637419 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /*  637422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637441 */     GIR_RootConstrainSelectedInstOperands,
     /*  637442 */     // GIR_Coverage, 6527,
     /*  637442 */     GIR_EraseRootFromParent_Done,
     /*  637443 */   // Label 10225: @637443
     /*  637443 */   GIM_Try, /*On fail goto*//*Label 10226*/ GIMT_Encode4(637518), // Rule ID 6530 //
     /*  637448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  637451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  637459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  637462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  637465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  637468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  637494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637516 */     GIR_RootConstrainSelectedInstOperands,
     /*  637517 */     // GIR_Coverage, 6530,
     /*  637517 */     GIR_EraseRootFromParent_Done,
     /*  637518 */   // Label 10226: @637518
     /*  637518 */   GIM_Try, /*On fail goto*//*Label 10227*/ GIMT_Encode4(637593), // Rule ID 6531 //
     /*  637523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  637526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  637534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  637537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  637540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  637543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  637562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  637569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /*  637572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  637588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637591 */     GIR_RootConstrainSelectedInstOperands,
     /*  637592 */     // GIR_Coverage, 6531,
     /*  637592 */     GIR_EraseRootFromParent_Done,
     /*  637593 */   // Label 10227: @637593
     /*  637593 */   GIM_Try, /*On fail goto*//*Label 10228*/ GIMT_Encode4(637668), // Rule ID 6534 //
     /*  637598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  637609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  637612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  637615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  637647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637666 */     GIR_RootConstrainSelectedInstOperands,
     /*  637667 */     // GIR_Coverage, 6534,
     /*  637667 */     GIR_EraseRootFromParent_Done,
     /*  637668 */   // Label 10228: @637668
     /*  637668 */   GIM_Try, /*On fail goto*//*Label 10229*/ GIMT_Encode4(637743), // Rule ID 6535 //
     /*  637673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  637684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  637687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  637690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8),
     /*  637722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637741 */     GIR_RootConstrainSelectedInstOperands,
     /*  637742 */     // GIR_Coverage, 6535,
     /*  637742 */     GIR_EraseRootFromParent_Done,
     /*  637743 */   // Label 10229: @637743
     /*  637743 */   GIM_Try, /*On fail goto*//*Label 10230*/ GIMT_Encode4(637818), // Rule ID 6538 //
     /*  637748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  637759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  637762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  637765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  637797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637816 */     GIR_RootConstrainSelectedInstOperands,
     /*  637817 */     // GIR_Coverage, 6538,
     /*  637817 */     GIR_EraseRootFromParent_Done,
     /*  637818 */   // Label 10230: @637818
     /*  637818 */   GIM_Try, /*On fail goto*//*Label 10231*/ GIMT_Encode4(637893), // Rule ID 6539 //
     /*  637823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  637834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  637837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  637840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637869 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  637869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  637872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637891 */     GIR_RootConstrainSelectedInstOperands,
     /*  637892 */     // GIR_Coverage, 6539,
     /*  637892 */     GIR_EraseRootFromParent_Done,
     /*  637893 */   // Label 10231: @637893
     /*  637893 */   GIM_Try, /*On fail goto*//*Label 10232*/ GIMT_Encode4(637968), // Rule ID 6542 //
     /*  637898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  637901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  637909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  637912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  637915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  637918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  637921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  637933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  637937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  637944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  637944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  637947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  637949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  637951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  637953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  637955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  637960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  637963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  637966 */     GIR_RootConstrainSelectedInstOperands,
     /*  637967 */     // GIR_Coverage, 6542,
     /*  637967 */     GIR_EraseRootFromParent_Done,
     /*  637968 */   // Label 10232: @637968
     /*  637968 */   GIM_Try, /*On fail goto*//*Label 10233*/ GIMT_Encode4(638043), // Rule ID 6543 //
     /*  637973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  637976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  637981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  637984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  637987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  637990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  637993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  637996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638041 */     GIR_RootConstrainSelectedInstOperands,
     /*  638042 */     // GIR_Coverage, 6543,
     /*  638042 */     GIR_EraseRootFromParent_Done,
     /*  638043 */   // Label 10233: @638043
     /*  638043 */   GIM_Try, /*On fail goto*//*Label 10234*/ GIMT_Encode4(638118), // Rule ID 6546 //
     /*  638048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638116 */     GIR_RootConstrainSelectedInstOperands,
     /*  638117 */     // GIR_Coverage, 6546,
     /*  638117 */     GIR_EraseRootFromParent_Done,
     /*  638118 */   // Label 10234: @638118
     /*  638118 */   GIM_Try, /*On fail goto*//*Label 10235*/ GIMT_Encode4(638193), // Rule ID 6547 //
     /*  638123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  638134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  638137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  638140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4),
     /*  638172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638191 */     GIR_RootConstrainSelectedInstOperands,
     /*  638192 */     // GIR_Coverage, 6547,
     /*  638192 */     GIR_EraseRootFromParent_Done,
     /*  638193 */   // Label 10235: @638193
     /*  638193 */   GIM_Try, /*On fail goto*//*Label 10236*/ GIMT_Encode4(638268), // Rule ID 6550 //
     /*  638198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638266 */     GIR_RootConstrainSelectedInstOperands,
     /*  638267 */     // GIR_Coverage, 6550,
     /*  638267 */     GIR_EraseRootFromParent_Done,
     /*  638268 */   // Label 10236: @638268
     /*  638268 */   GIM_Try, /*On fail goto*//*Label 10237*/ GIMT_Encode4(638343), // Rule ID 6551 //
     /*  638273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  638284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  638287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  638290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638341 */     GIR_RootConstrainSelectedInstOperands,
     /*  638342 */     // GIR_Coverage, 6551,
     /*  638342 */     GIR_EraseRootFromParent_Done,
     /*  638343 */   // Label 10237: @638343
     /*  638343 */   GIM_Try, /*On fail goto*//*Label 10238*/ GIMT_Encode4(638418), // Rule ID 6554 //
     /*  638348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638416 */     GIR_RootConstrainSelectedInstOperands,
     /*  638417 */     // GIR_Coverage, 6554,
     /*  638417 */     GIR_EraseRootFromParent_Done,
     /*  638418 */   // Label 10238: @638418
     /*  638418 */   GIM_Try, /*On fail goto*//*Label 10239*/ GIMT_Encode4(638493), // Rule ID 6555 //
     /*  638423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  638434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  638437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  638440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638469 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2),
     /*  638472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638491 */     GIR_RootConstrainSelectedInstOperands,
     /*  638492 */     // GIR_Coverage, 6555,
     /*  638492 */     GIR_EraseRootFromParent_Done,
     /*  638493 */   // Label 10239: @638493
     /*  638493 */   GIM_Try, /*On fail goto*//*Label 10240*/ GIMT_Encode4(638568), // Rule ID 6558 //
     /*  638498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  638509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  638512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  638515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  638544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638566 */     GIR_RootConstrainSelectedInstOperands,
     /*  638567 */     // GIR_Coverage, 6558,
     /*  638567 */     GIR_EraseRootFromParent_Done,
     /*  638568 */   // Label 10240: @638568
     /*  638568 */   GIM_Try, /*On fail goto*//*Label 10241*/ GIMT_Encode4(638643), // Rule ID 6559 //
     /*  638573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  638584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  638587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  638590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11484:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  638619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  638638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638641 */     GIR_RootConstrainSelectedInstOperands,
     /*  638642 */     // GIR_Coverage, 6559,
     /*  638642 */     GIR_EraseRootFromParent_Done,
     /*  638643 */   // Label 10241: @638643
     /*  638643 */   GIM_Try, /*On fail goto*//*Label 10242*/ GIMT_Encode4(638718), // Rule ID 6562 //
     /*  638648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  638659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  638662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  638665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  638694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638716 */     GIR_RootConstrainSelectedInstOperands,
     /*  638717 */     // GIR_Coverage, 6562,
     /*  638717 */     GIR_EraseRootFromParent_Done,
     /*  638718 */   // Label 10242: @638718
     /*  638718 */   GIM_Try, /*On fail goto*//*Label 10243*/ GIMT_Encode4(638793), // Rule ID 6563 //
     /*  638723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  638734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  638737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  638740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638769 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11484:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  638769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  638788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638791 */     GIR_RootConstrainSelectedInstOperands,
     /*  638792 */     // GIR_Coverage, 6563,
     /*  638792 */     GIR_EraseRootFromParent_Done,
     /*  638793 */   // Label 10243: @638793
     /*  638793 */   GIM_Try, /*On fail goto*//*Label 10244*/ GIMT_Encode4(638868), // Rule ID 6566 //
     /*  638798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  638801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  638809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  638812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  638815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  638844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638866 */     GIR_RootConstrainSelectedInstOperands,
     /*  638867 */     // GIR_Coverage, 6566,
     /*  638867 */     GIR_EraseRootFromParent_Done,
     /*  638868 */   // Label 10244: @638868
     /*  638868 */   GIM_Try, /*On fail goto*//*Label 10245*/ GIMT_Encode4(638943), // Rule ID 6567 //
     /*  638873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  638876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  638884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  638887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  638890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  638893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  638896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11484:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  638919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  638926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  638928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  638930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  638935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  638938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  638941 */     GIR_RootConstrainSelectedInstOperands,
     /*  638942 */     // GIR_Coverage, 6567,
     /*  638942 */     GIR_EraseRootFromParent_Done,
     /*  638943 */   // Label 10245: @638943
     /*  638943 */   GIM_Try, /*On fail goto*//*Label 10246*/ GIMT_Encode4(639018), // Rule ID 6570 //
     /*  638948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  638951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  638956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  638959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  638962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  638965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  638968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  638971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  638983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  638987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  638994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  638994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  638997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  638999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639016 */     GIR_RootConstrainSelectedInstOperands,
     /*  639017 */     // GIR_Coverage, 6570,
     /*  639017 */     GIR_EraseRootFromParent_Done,
     /*  639018 */   // Label 10246: @639018
     /*  639018 */   GIM_Try, /*On fail goto*//*Label 10247*/ GIMT_Encode4(639093), // Rule ID 6571 //
     /*  639023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  639026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  639034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  639037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  639040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  639058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639069 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11484:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  639069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1),
     /*  639072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  639088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639091 */     GIR_RootConstrainSelectedInstOperands,
     /*  639092 */     // GIR_Coverage, 6571,
     /*  639092 */     GIR_EraseRootFromParent_Done,
     /*  639093 */   // Label 10247: @639093
     /*  639093 */   GIM_Try, /*On fail goto*//*Label 10248*/ GIMT_Encode4(639168), // Rule ID 6574 //
     /*  639098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639166 */     GIR_RootConstrainSelectedInstOperands,
     /*  639167 */     // GIR_Coverage, 6574,
     /*  639167 */     GIR_EraseRootFromParent_Done,
     /*  639168 */   // Label 10248: @639168
     /*  639168 */   GIM_Try, /*On fail goto*//*Label 10249*/ GIMT_Encode4(639243), // Rule ID 6575 //
     /*  639173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  639184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  639187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  639190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639241 */     GIR_RootConstrainSelectedInstOperands,
     /*  639242 */     // GIR_Coverage, 6575,
     /*  639242 */     GIR_EraseRootFromParent_Done,
     /*  639243 */   // Label 10249: @639243
     /*  639243 */   GIM_Try, /*On fail goto*//*Label 10250*/ GIMT_Encode4(639318), // Rule ID 6578 //
     /*  639248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639316 */     GIR_RootConstrainSelectedInstOperands,
     /*  639317 */     // GIR_Coverage, 6578,
     /*  639317 */     GIR_EraseRootFromParent_Done,
     /*  639318 */   // Label 10250: @639318
     /*  639318 */   GIM_Try, /*On fail goto*//*Label 10251*/ GIMT_Encode4(639393), // Rule ID 6579 //
     /*  639323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  639334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  639337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  639340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639369 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639391 */     GIR_RootConstrainSelectedInstOperands,
     /*  639392 */     // GIR_Coverage, 6579,
     /*  639392 */     GIR_EraseRootFromParent_Done,
     /*  639393 */   // Label 10251: @639393
     /*  639393 */   GIM_Try, /*On fail goto*//*Label 10252*/ GIMT_Encode4(639468), // Rule ID 6582 //
     /*  639398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  639409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  639412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  639415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  639444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639466 */     GIR_RootConstrainSelectedInstOperands,
     /*  639467 */     // GIR_Coverage, 6582,
     /*  639467 */     GIR_EraseRootFromParent_Done,
     /*  639468 */   // Label 10252: @639468
     /*  639468 */   GIM_Try, /*On fail goto*//*Label 10253*/ GIMT_Encode4(639543), // Rule ID 6583 //
     /*  639473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  639484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  639487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  639490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639519 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  639519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  639538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639541 */     GIR_RootConstrainSelectedInstOperands,
     /*  639542 */     // GIR_Coverage, 6583,
     /*  639542 */     GIR_EraseRootFromParent_Done,
     /*  639543 */   // Label 10253: @639543
     /*  639543 */   GIM_Try, /*On fail goto*//*Label 10254*/ GIMT_Encode4(639618), // Rule ID 6586 //
     /*  639548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  639559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  639562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  639565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639616 */     GIR_RootConstrainSelectedInstOperands,
     /*  639617 */     // GIR_Coverage, 6586,
     /*  639617 */     GIR_EraseRootFromParent_Done,
     /*  639618 */   // Label 10254: @639618
     /*  639618 */   GIM_Try, /*On fail goto*//*Label 10255*/ GIMT_Encode4(639693), // Rule ID 6587 //
     /*  639623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  639634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  639637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  639640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  639658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  639672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639691 */     GIR_RootConstrainSelectedInstOperands,
     /*  639692 */     // GIR_Coverage, 6587,
     /*  639692 */     GIR_EraseRootFromParent_Done,
     /*  639693 */   // Label 10255: @639693
     /*  639693 */   GIM_Try, /*On fail goto*//*Label 10256*/ GIMT_Encode4(639768), // Rule ID 6590 //
     /*  639698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  639709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  639712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  639715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639766 */     GIR_RootConstrainSelectedInstOperands,
     /*  639767 */     // GIR_Coverage, 6590,
     /*  639767 */     GIR_EraseRootFromParent_Done,
     /*  639768 */   // Label 10256: @639768
     /*  639768 */   GIM_Try, /*On fail goto*//*Label 10257*/ GIMT_Encode4(639843), // Rule ID 6591 //
     /*  639773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  639784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  639787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  639790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  639808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639819 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  639822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639841 */     GIR_RootConstrainSelectedInstOperands,
     /*  639842 */     // GIR_Coverage, 6591,
     /*  639842 */     GIR_EraseRootFromParent_Done,
     /*  639843 */   // Label 10257: @639843
     /*  639843 */   GIM_Try, /*On fail goto*//*Label 10258*/ GIMT_Encode4(639918), // Rule ID 6594 //
     /*  639848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  639851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  639859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  639862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  639865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  639868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  639871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  639894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639916 */     GIR_RootConstrainSelectedInstOperands,
     /*  639917 */     // GIR_Coverage, 6594,
     /*  639917 */     GIR_EraseRootFromParent_Done,
     /*  639918 */   // Label 10258: @639918
     /*  639918 */   GIM_Try, /*On fail goto*//*Label 10259*/ GIMT_Encode4(639993), // Rule ID 6595 //
     /*  639923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  639926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  639931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  639934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  639937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  639940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  639943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  639946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  639958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  639962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  639969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  639969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  639972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  639974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  639976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  639978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  639980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  639985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  639988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  639991 */     GIR_RootConstrainSelectedInstOperands,
     /*  639992 */     // GIR_Coverage, 6595,
     /*  639992 */     GIR_EraseRootFromParent_Done,
     /*  639993 */   // Label 10259: @639993
     /*  639993 */   GIM_Try, /*On fail goto*//*Label 10260*/ GIMT_Encode4(640068), // Rule ID 6598 //
     /*  639998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640066 */     GIR_RootConstrainSelectedInstOperands,
     /*  640067 */     // GIR_Coverage, 6598,
     /*  640067 */     GIR_EraseRootFromParent_Done,
     /*  640068 */   // Label 10260: @640068
     /*  640068 */   GIM_Try, /*On fail goto*//*Label 10261*/ GIMT_Encode4(640143), // Rule ID 6599 //
     /*  640073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  640084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  640087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  640090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640141 */     GIR_RootConstrainSelectedInstOperands,
     /*  640142 */     // GIR_Coverage, 6599,
     /*  640142 */     GIR_EraseRootFromParent_Done,
     /*  640143 */   // Label 10261: @640143
     /*  640143 */   GIM_Try, /*On fail goto*//*Label 10262*/ GIMT_Encode4(640218), // Rule ID 6602 //
     /*  640148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640216 */     GIR_RootConstrainSelectedInstOperands,
     /*  640217 */     // GIR_Coverage, 6602,
     /*  640217 */     GIR_EraseRootFromParent_Done,
     /*  640218 */   // Label 10262: @640218
     /*  640218 */   GIM_Try, /*On fail goto*//*Label 10263*/ GIMT_Encode4(640293), // Rule ID 6603 //
     /*  640223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  640234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  640237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  640240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640269 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640291 */     GIR_RootConstrainSelectedInstOperands,
     /*  640292 */     // GIR_Coverage, 6603,
     /*  640292 */     GIR_EraseRootFromParent_Done,
     /*  640293 */   // Label 10263: @640293
     /*  640293 */   GIM_Try, /*On fail goto*//*Label 10264*/ GIMT_Encode4(640368), // Rule ID 6606 //
     /*  640298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  640344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640366 */     GIR_RootConstrainSelectedInstOperands,
     /*  640367 */     // GIR_Coverage, 6606,
     /*  640367 */     GIR_EraseRootFromParent_Done,
     /*  640368 */   // Label 10264: @640368
     /*  640368 */   GIM_Try, /*On fail goto*//*Label 10265*/ GIMT_Encode4(640443), // Rule ID 6607 //
     /*  640373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  640384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  640387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  640390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  640419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  640438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640441 */     GIR_RootConstrainSelectedInstOperands,
     /*  640442 */     // GIR_Coverage, 6607,
     /*  640442 */     GIR_EraseRootFromParent_Done,
     /*  640443 */   // Label 10265: @640443
     /*  640443 */   GIM_Try, /*On fail goto*//*Label 10266*/ GIMT_Encode4(640518), // Rule ID 6610 //
     /*  640448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  640459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  640462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  640465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  640494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640516 */     GIR_RootConstrainSelectedInstOperands,
     /*  640517 */     // GIR_Coverage, 6610,
     /*  640517 */     GIR_EraseRootFromParent_Done,
     /*  640518 */   // Label 10266: @640518
     /*  640518 */   GIM_Try, /*On fail goto*//*Label 10267*/ GIMT_Encode4(640593), // Rule ID 6611 //
     /*  640523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  640534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  640537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  640540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  640558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11484:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2),
     /*  640572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640591 */     GIR_RootConstrainSelectedInstOperands,
     /*  640592 */     // GIR_Coverage, 6611,
     /*  640592 */     GIR_EraseRootFromParent_Done,
     /*  640593 */   // Label 10267: @640593
     /*  640593 */   GIM_Try, /*On fail goto*//*Label 10268*/ GIMT_Encode4(640668), // Rule ID 6614 //
     /*  640598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  640609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  640612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  640615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  640644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640666 */     GIR_RootConstrainSelectedInstOperands,
     /*  640667 */     // GIR_Coverage, 6614,
     /*  640667 */     GIR_EraseRootFromParent_Done,
     /*  640668 */   // Label 10268: @640668
     /*  640668 */   GIM_Try, /*On fail goto*//*Label 10269*/ GIMT_Encode4(640743), // Rule ID 6615 //
     /*  640673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  640684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  640687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  640690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  640708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11484:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4),
     /*  640722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640741 */     GIR_RootConstrainSelectedInstOperands,
     /*  640742 */     // GIR_Coverage, 6615,
     /*  640742 */     GIR_EraseRootFromParent_Done,
     /*  640743 */   // Label 10269: @640743
     /*  640743 */   GIM_Try, /*On fail goto*//*Label 10270*/ GIMT_Encode4(640818), // Rule ID 6618 //
     /*  640748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  640751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  640759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  640762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  640765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  640768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  640794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640816 */     GIR_RootConstrainSelectedInstOperands,
     /*  640817 */     // GIR_Coverage, 6618,
     /*  640817 */     GIR_EraseRootFromParent_Done,
     /*  640818 */   // Label 10270: @640818
     /*  640818 */   GIM_Try, /*On fail goto*//*Label 10271*/ GIMT_Encode4(640893), // Rule ID 6619 //
     /*  640823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  640826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll),
     /*  640831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  640834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  640837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  640840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  640843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  640858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  640862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11484:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  640869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8),
     /*  640872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  640888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640891 */     GIR_RootConstrainSelectedInstOperands,
     /*  640892 */     // GIR_Coverage, 6619,
     /*  640892 */     GIR_EraseRootFromParent_Done,
     /*  640893 */   // Label 10271: @640893
     /*  640893 */   GIM_Try, /*On fail goto*//*Label 10272*/ GIMT_Encode4(640968), // Rule ID 6710 //
     /*  640898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  640901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  640906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  640909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  640912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  640915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  640918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  640921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  640937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  640944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  640944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  640947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  640949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  640951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  640953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  640955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  640960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  640963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  640966 */     GIR_RootConstrainSelectedInstOperands,
     /*  640967 */     // GIR_Coverage, 6710,
     /*  640967 */     GIR_EraseRootFromParent_Done,
     /*  640968 */   // Label 10272: @640968
     /*  640968 */   GIM_Try, /*On fail goto*//*Label 10273*/ GIMT_Encode4(641043), // Rule ID 6711 //
     /*  640973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  640976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  640981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  640984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  640987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  640990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  640993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  640996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /*  641022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641041 */     GIR_RootConstrainSelectedInstOperands,
     /*  641042 */     // GIR_Coverage, 6711,
     /*  641042 */     GIR_EraseRootFromParent_Done,
     /*  641043 */   // Label 10273: @641043
     /*  641043 */   GIM_Try, /*On fail goto*//*Label 10274*/ GIMT_Encode4(641118), // Rule ID 6714 //
     /*  641048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641116 */     GIR_RootConstrainSelectedInstOperands,
     /*  641117 */     // GIR_Coverage, 6714,
     /*  641117 */     GIR_EraseRootFromParent_Done,
     /*  641118 */   // Label 10274: @641118
     /*  641118 */   GIM_Try, /*On fail goto*//*Label 10275*/ GIMT_Encode4(641193), // Rule ID 6715 //
     /*  641123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  641134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  641137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  641140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  641143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641169 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641191 */     GIR_RootConstrainSelectedInstOperands,
     /*  641192 */     // GIR_Coverage, 6715,
     /*  641192 */     GIR_EraseRootFromParent_Done,
     /*  641193 */   // Label 10275: @641193
     /*  641193 */   GIM_Try, /*On fail goto*//*Label 10276*/ GIMT_Encode4(641268), // Rule ID 6718 //
     /*  641198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641266 */     GIR_RootConstrainSelectedInstOperands,
     /*  641267 */     // GIR_Coverage, 6718,
     /*  641267 */     GIR_EraseRootFromParent_Done,
     /*  641268 */   // Label 10276: @641268
     /*  641268 */   GIM_Try, /*On fail goto*//*Label 10277*/ GIMT_Encode4(641343), // Rule ID 6719 //
     /*  641273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  641284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  641287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  641290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  641293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641319 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641341 */     GIR_RootConstrainSelectedInstOperands,
     /*  641342 */     // GIR_Coverage, 6719,
     /*  641342 */     GIR_EraseRootFromParent_Done,
     /*  641343 */   // Label 10277: @641343
     /*  641343 */   GIM_Try, /*On fail goto*//*Label 10278*/ GIMT_Encode4(641418), // Rule ID 6722 //
     /*  641348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  641394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641416 */     GIR_RootConstrainSelectedInstOperands,
     /*  641417 */     // GIR_Coverage, 6722,
     /*  641417 */     GIR_EraseRootFromParent_Done,
     /*  641418 */   // Label 10278: @641418
     /*  641418 */   GIM_Try, /*On fail goto*//*Label 10279*/ GIMT_Encode4(641493), // Rule ID 6723 //
     /*  641423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  641434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  641437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  641440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  641443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /*  641472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641491 */     GIR_RootConstrainSelectedInstOperands,
     /*  641492 */     // GIR_Coverage, 6723,
     /*  641492 */     GIR_EraseRootFromParent_Done,
     /*  641493 */   // Label 10279: @641493
     /*  641493 */   GIM_Try, /*On fail goto*//*Label 10280*/ GIMT_Encode4(641568), // Rule ID 6726 //
     /*  641498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  641509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  641512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  641515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  641518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  641544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641566 */     GIR_RootConstrainSelectedInstOperands,
     /*  641567 */     // GIR_Coverage, 6726,
     /*  641567 */     GIR_EraseRootFromParent_Done,
     /*  641568 */   // Label 10280: @641568
     /*  641568 */   GIM_Try, /*On fail goto*//*Label 10281*/ GIMT_Encode4(641643), // Rule ID 6727 //
     /*  641573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  641584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  641587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  641590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  641593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  641619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  641638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641641 */     GIR_RootConstrainSelectedInstOperands,
     /*  641642 */     // GIR_Coverage, 6727,
     /*  641642 */     GIR_EraseRootFromParent_Done,
     /*  641643 */   // Label 10281: @641643
     /*  641643 */   GIM_Try, /*On fail goto*//*Label 10282*/ GIMT_Encode4(641718), // Rule ID 6730 //
     /*  641648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  641659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  641662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  641665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  641668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  641694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641716 */     GIR_RootConstrainSelectedInstOperands,
     /*  641717 */     // GIR_Coverage, 6730,
     /*  641717 */     GIR_EraseRootFromParent_Done,
     /*  641718 */   // Label 10282: @641718
     /*  641718 */   GIM_Try, /*On fail goto*//*Label 10283*/ GIMT_Encode4(641793), // Rule ID 6731 //
     /*  641723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  641734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  641737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  641740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  641743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  641769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /*  641772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  641788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641791 */     GIR_RootConstrainSelectedInstOperands,
     /*  641792 */     // GIR_Coverage, 6731,
     /*  641792 */     GIR_EraseRootFromParent_Done,
     /*  641793 */   // Label 10283: @641793
     /*  641793 */   GIM_Try, /*On fail goto*//*Label 10284*/ GIMT_Encode4(641868), // Rule ID 6734 //
     /*  641798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  641809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  641812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  641815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  641818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  641844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  641847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641866 */     GIR_RootConstrainSelectedInstOperands,
     /*  641867 */     // GIR_Coverage, 6734,
     /*  641867 */     GIR_EraseRootFromParent_Done,
     /*  641868 */   // Label 10284: @641868
     /*  641868 */   GIM_Try, /*On fail goto*//*Label 10285*/ GIMT_Encode4(641943), // Rule ID 6735 //
     /*  641873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  641876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  641884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  641887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  641890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  641893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  641896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  641919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  641922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  641926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  641928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  641930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  641935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  641938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  641941 */     GIR_RootConstrainSelectedInstOperands,
     /*  641942 */     // GIR_Coverage, 6735,
     /*  641942 */     GIR_EraseRootFromParent_Done,
     /*  641943 */   // Label 10285: @641943
     /*  641943 */   GIM_Try, /*On fail goto*//*Label 10286*/ GIMT_Encode4(642018), // Rule ID 6738 //
     /*  641948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  641951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  641956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  641959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  641962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  641965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  641968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  641971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  641987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  641994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  641994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  641997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  641999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642016 */     GIR_RootConstrainSelectedInstOperands,
     /*  642017 */     // GIR_Coverage, 6738,
     /*  642017 */     GIR_EraseRootFromParent_Done,
     /*  642018 */   // Label 10286: @642018
     /*  642018 */   GIM_Try, /*On fail goto*//*Label 10287*/ GIMT_Encode4(642093), // Rule ID 6739 //
     /*  642023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  642034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  642037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  642040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  642043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642069 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642091 */     GIR_RootConstrainSelectedInstOperands,
     /*  642092 */     // GIR_Coverage, 6739,
     /*  642092 */     GIR_EraseRootFromParent_Done,
     /*  642093 */   // Label 10287: @642093
     /*  642093 */   GIM_Try, /*On fail goto*//*Label 10288*/ GIMT_Encode4(642168), // Rule ID 6742 //
     /*  642098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  642144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642166 */     GIR_RootConstrainSelectedInstOperands,
     /*  642167 */     // GIR_Coverage, 6742,
     /*  642167 */     GIR_EraseRootFromParent_Done,
     /*  642168 */   // Label 10288: @642168
     /*  642168 */   GIM_Try, /*On fail goto*//*Label 10289*/ GIMT_Encode4(642243), // Rule ID 6743 //
     /*  642173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  642184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  642187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  642190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  642193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  642219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  642238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642241 */     GIR_RootConstrainSelectedInstOperands,
     /*  642242 */     // GIR_Coverage, 6743,
     /*  642242 */     GIR_EraseRootFromParent_Done,
     /*  642243 */   // Label 10289: @642243
     /*  642243 */   GIM_Try, /*On fail goto*//*Label 10290*/ GIMT_Encode4(642318), // Rule ID 6746 //
     /*  642248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  642251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  642294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642316 */     GIR_RootConstrainSelectedInstOperands,
     /*  642317 */     // GIR_Coverage, 6746,
     /*  642317 */     GIR_EraseRootFromParent_Done,
     /*  642318 */   // Label 10290: @642318
     /*  642318 */   GIM_Try, /*On fail goto*//*Label 10291*/ GIMT_Encode4(642393), // Rule ID 6747 //
     /*  642323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  642326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  642334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  642337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  642340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  642343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  642362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642369 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  642369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /*  642372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  642388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642391 */     GIR_RootConstrainSelectedInstOperands,
     /*  642392 */     // GIR_Coverage, 6747,
     /*  642392 */     GIR_EraseRootFromParent_Done,
     /*  642393 */   // Label 10291: @642393
     /*  642393 */   GIM_Try, /*On fail goto*//*Label 10292*/ GIMT_Encode4(642468), // Rule ID 6750 //
     /*  642398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  642409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  642412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  642415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  642418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642444 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642466 */     GIR_RootConstrainSelectedInstOperands,
     /*  642467 */     // GIR_Coverage, 6750,
     /*  642467 */     GIR_EraseRootFromParent_Done,
     /*  642468 */   // Label 10292: @642468
     /*  642468 */   GIM_Try, /*On fail goto*//*Label 10293*/ GIMT_Encode4(642543), // Rule ID 6751 //
     /*  642473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  642484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  642487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  642490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  642493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642541 */     GIR_RootConstrainSelectedInstOperands,
     /*  642542 */     // GIR_Coverage, 6751,
     /*  642542 */     GIR_EraseRootFromParent_Done,
     /*  642543 */   // Label 10293: @642543
     /*  642543 */   GIM_Try, /*On fail goto*//*Label 10294*/ GIMT_Encode4(642618), // Rule ID 6754 //
     /*  642548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  642559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  642562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  642565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  642568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  642597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642616 */     GIR_RootConstrainSelectedInstOperands,
     /*  642617 */     // GIR_Coverage, 6754,
     /*  642617 */     GIR_EraseRootFromParent_Done,
     /*  642618 */   // Label 10294: @642618
     /*  642618 */   GIM_Try, /*On fail goto*//*Label 10295*/ GIMT_Encode4(642693), // Rule ID 6755 //
     /*  642623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  642634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  642637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  642640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  642643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  642662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642669 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  642672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642691 */     GIR_RootConstrainSelectedInstOperands,
     /*  642692 */     // GIR_Coverage, 6755,
     /*  642692 */     GIR_EraseRootFromParent_Done,
     /*  642693 */   // Label 10295: @642693
     /*  642693 */   GIM_Try, /*On fail goto*//*Label 10296*/ GIMT_Encode4(642768), // Rule ID 6758 //
     /*  642698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  642709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  642712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  642715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  642718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  642744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  642747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642766 */     GIR_RootConstrainSelectedInstOperands,
     /*  642767 */     // GIR_Coverage, 6758,
     /*  642767 */     GIR_EraseRootFromParent_Done,
     /*  642768 */   // Label 10296: @642768
     /*  642768 */   GIM_Try, /*On fail goto*//*Label 10297*/ GIMT_Encode4(642843), // Rule ID 6759 //
     /*  642773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  642784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  642787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  642790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  642793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  642812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  642819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  642822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  642838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642841 */     GIR_RootConstrainSelectedInstOperands,
     /*  642842 */     // GIR_Coverage, 6759,
     /*  642842 */     GIR_EraseRootFromParent_Done,
     /*  642843 */   // Label 10297: @642843
     /*  642843 */   GIM_Try, /*On fail goto*//*Label 10298*/ GIMT_Encode4(642918), // Rule ID 6762 //
     /*  642848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  642851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  642859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  642862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  642865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  642868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  642871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  642894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642916 */     GIR_RootConstrainSelectedInstOperands,
     /*  642917 */     // GIR_Coverage, 6762,
     /*  642917 */     GIR_EraseRootFromParent_Done,
     /*  642918 */   // Label 10298: @642918
     /*  642918 */   GIM_Try, /*On fail goto*//*Label 10299*/ GIMT_Encode4(642993), // Rule ID 6763 //
     /*  642923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  642926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  642931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  642934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  642937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  642940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  642943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  642946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  642962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  642969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  642969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  642972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  642974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  642976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  642978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  642980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  642985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  642988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  642991 */     GIR_RootConstrainSelectedInstOperands,
     /*  642992 */     // GIR_Coverage, 6763,
     /*  642992 */     GIR_EraseRootFromParent_Done,
     /*  642993 */   // Label 10299: @642993
     /*  642993 */   GIM_Try, /*On fail goto*//*Label 10300*/ GIMT_Encode4(643068), // Rule ID 6766 //
     /*  642998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643066 */     GIR_RootConstrainSelectedInstOperands,
     /*  643067 */     // GIR_Coverage, 6766,
     /*  643067 */     GIR_EraseRootFromParent_Done,
     /*  643068 */   // Label 10300: @643068
     /*  643068 */   GIM_Try, /*On fail goto*//*Label 10301*/ GIMT_Encode4(643143), // Rule ID 6767 //
     /*  643073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  643084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  643087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  643090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  643093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643141 */     GIR_RootConstrainSelectedInstOperands,
     /*  643142 */     // GIR_Coverage, 6767,
     /*  643142 */     GIR_EraseRootFromParent_Done,
     /*  643143 */   // Label 10301: @643143
     /*  643143 */   GIM_Try, /*On fail goto*//*Label 10302*/ GIMT_Encode4(643218), // Rule ID 6770 //
     /*  643148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  643194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643216 */     GIR_RootConstrainSelectedInstOperands,
     /*  643217 */     // GIR_Coverage, 6770,
     /*  643217 */     GIR_EraseRootFromParent_Done,
     /*  643218 */   // Label 10302: @643218
     /*  643218 */   GIM_Try, /*On fail goto*//*Label 10303*/ GIMT_Encode4(643293), // Rule ID 6771 //
     /*  643223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  643234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  643237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  643240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  643243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  643269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  643288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643291 */     GIR_RootConstrainSelectedInstOperands,
     /*  643292 */     // GIR_Coverage, 6771,
     /*  643292 */     GIR_EraseRootFromParent_Done,
     /*  643293 */   // Label 10303: @643293
     /*  643293 */   GIM_Try, /*On fail goto*//*Label 10304*/ GIMT_Encode4(643368), // Rule ID 6774 //
     /*  643298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643366 */     GIR_RootConstrainSelectedInstOperands,
     /*  643367 */     // GIR_Coverage, 6774,
     /*  643367 */     GIR_EraseRootFromParent_Done,
     /*  643368 */   // Label 10304: @643368
     /*  643368 */   GIM_Try, /*On fail goto*//*Label 10305*/ GIMT_Encode4(643443), // Rule ID 6775 //
     /*  643373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  643384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  643387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  643390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  643393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643441 */     GIR_RootConstrainSelectedInstOperands,
     /*  643442 */     // GIR_Coverage, 6775,
     /*  643442 */     GIR_EraseRootFromParent_Done,
     /*  643443 */   // Label 10305: @643443
     /*  643443 */   GIM_Try, /*On fail goto*//*Label 10306*/ GIMT_Encode4(643518), // Rule ID 6778 //
     /*  643448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  643459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  643462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  643465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  643468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643516 */     GIR_RootConstrainSelectedInstOperands,
     /*  643517 */     // GIR_Coverage, 6778,
     /*  643517 */     GIR_EraseRootFromParent_Done,
     /*  643518 */   // Label 10306: @643518
     /*  643518 */   GIM_Try, /*On fail goto*//*Label 10307*/ GIMT_Encode4(643593), // Rule ID 6779 //
     /*  643523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  643534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  643537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  643540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  643543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643591 */     GIR_RootConstrainSelectedInstOperands,
     /*  643592 */     // GIR_Coverage, 6779,
     /*  643592 */     GIR_EraseRootFromParent_Done,
     /*  643593 */   // Label 10307: @643593
     /*  643593 */   GIM_Try, /*On fail goto*//*Label 10308*/ GIMT_Encode4(643668), // Rule ID 6782 //
     /*  643598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  643601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  643609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  643612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  643615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  643618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643644 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  643644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643666 */     GIR_RootConstrainSelectedInstOperands,
     /*  643667 */     // GIR_Coverage, 6782,
     /*  643667 */     GIR_EraseRootFromParent_Done,
     /*  643668 */   // Label 10308: @643668
     /*  643668 */   GIM_Try, /*On fail goto*//*Label 10309*/ GIMT_Encode4(643743), // Rule ID 6783 //
     /*  643673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  643676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  643684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  643687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  643690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  643693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  643712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  643719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  643722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  643738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643741 */     GIR_RootConstrainSelectedInstOperands,
     /*  643742 */     // GIR_Coverage, 6783,
     /*  643742 */     GIR_EraseRootFromParent_Done,
     /*  643743 */   // Label 10309: @643743
     /*  643743 */   GIM_Try, /*On fail goto*//*Label 10310*/ GIMT_Encode4(643818), // Rule ID 6786 //
     /*  643748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  643759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  643762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  643765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  643768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643816 */     GIR_RootConstrainSelectedInstOperands,
     /*  643817 */     // GIR_Coverage, 6786,
     /*  643817 */     GIR_EraseRootFromParent_Done,
     /*  643818 */   // Label 10310: @643818
     /*  643818 */   GIM_Try, /*On fail goto*//*Label 10311*/ GIMT_Encode4(643893), // Rule ID 6787 //
     /*  643823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  643834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  643837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  643840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  643843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  643862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  643869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /*  643872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643891 */     GIR_RootConstrainSelectedInstOperands,
     /*  643892 */     // GIR_Coverage, 6787,
     /*  643892 */     GIR_EraseRootFromParent_Done,
     /*  643893 */   // Label 10311: @643893
     /*  643893 */   GIM_Try, /*On fail goto*//*Label 10312*/ GIMT_Encode4(643968), // Rule ID 6790 //
     /*  643898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  643901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  643909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  643912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  643915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  643918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  643921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  643937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  643944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  643944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  643947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  643949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  643951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  643953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  643955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  643960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  643963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  643966 */     GIR_RootConstrainSelectedInstOperands,
     /*  643967 */     // GIR_Coverage, 6790,
     /*  643967 */     GIR_EraseRootFromParent_Done,
     /*  643968 */   // Label 10312: @643968
     /*  643968 */   GIM_Try, /*On fail goto*//*Label 10313*/ GIMT_Encode4(644043), // Rule ID 6791 //
     /*  643973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  643976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  643981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  643984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  643987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  643990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  643993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  643996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  644012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /*  644022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644041 */     GIR_RootConstrainSelectedInstOperands,
     /*  644042 */     // GIR_Coverage, 6791,
     /*  644042 */     GIR_EraseRootFromParent_Done,
     /*  644043 */   // Label 10313: @644043
     /*  644043 */   GIM_Try, /*On fail goto*//*Label 10314*/ GIMT_Encode4(644118), // Rule ID 6794 //
     /*  644048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  644051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  644094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644116 */     GIR_RootConstrainSelectedInstOperands,
     /*  644117 */     // GIR_Coverage, 6794,
     /*  644117 */     GIR_EraseRootFromParent_Done,
     /*  644118 */   // Label 10314: @644118
     /*  644118 */   GIM_Try, /*On fail goto*//*Label 10315*/ GIMT_Encode4(644193), // Rule ID 6795 //
     /*  644123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  644126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  644134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  644137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  644140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  644143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  644162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  644169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /*  644172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  644188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644191 */     GIR_RootConstrainSelectedInstOperands,
     /*  644192 */     // GIR_Coverage, 6795,
     /*  644192 */     GIR_EraseRootFromParent_Done,
     /*  644193 */   // Label 10315: @644193
     /*  644193 */   GIM_Try, /*On fail goto*//*Label 10316*/ GIMT_Encode4(644268), // Rule ID 6798 //
     /*  644198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644266 */     GIR_RootConstrainSelectedInstOperands,
     /*  644267 */     // GIR_Coverage, 6798,
     /*  644267 */     GIR_EraseRootFromParent_Done,
     /*  644268 */   // Label 10316: @644268
     /*  644268 */   GIM_Try, /*On fail goto*//*Label 10317*/ GIMT_Encode4(644343), // Rule ID 6799 //
     /*  644273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  644284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  644287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  644290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8),
     /*  644322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644341 */     GIR_RootConstrainSelectedInstOperands,
     /*  644342 */     // GIR_Coverage, 6799,
     /*  644342 */     GIR_EraseRootFromParent_Done,
     /*  644343 */   // Label 10317: @644343
     /*  644343 */   GIM_Try, /*On fail goto*//*Label 10318*/ GIMT_Encode4(644418), // Rule ID 6802 //
     /*  644348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644416 */     GIR_RootConstrainSelectedInstOperands,
     /*  644417 */     // GIR_Coverage, 6802,
     /*  644417 */     GIR_EraseRootFromParent_Done,
     /*  644418 */   // Label 10318: @644418
     /*  644418 */   GIM_Try, /*On fail goto*//*Label 10319*/ GIMT_Encode4(644493), // Rule ID 6803 //
     /*  644423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  644434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  644437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  644440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644491 */     GIR_RootConstrainSelectedInstOperands,
     /*  644492 */     // GIR_Coverage, 6803,
     /*  644492 */     GIR_EraseRootFromParent_Done,
     /*  644493 */   // Label 10319: @644493
     /*  644493 */   GIM_Try, /*On fail goto*//*Label 10320*/ GIMT_Encode4(644568), // Rule ID 6806 //
     /*  644498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  644509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  644512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  644515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  644544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  644547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644566 */     GIR_RootConstrainSelectedInstOperands,
     /*  644567 */     // GIR_Coverage, 6806,
     /*  644567 */     GIR_EraseRootFromParent_Done,
     /*  644568 */   // Label 10320: @644568
     /*  644568 */   GIM_Try, /*On fail goto*//*Label 10321*/ GIMT_Encode4(644643), // Rule ID 6807 //
     /*  644573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  644584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  644587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  644590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  644619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  644622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  644638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644641 */     GIR_RootConstrainSelectedInstOperands,
     /*  644642 */     // GIR_Coverage, 6807,
     /*  644642 */     GIR_EraseRootFromParent_Done,
     /*  644643 */   // Label 10321: @644643
     /*  644643 */   GIM_Try, /*On fail goto*//*Label 10322*/ GIMT_Encode4(644718), // Rule ID 6810 //
     /*  644648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  644659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  644662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  644665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644716 */     GIR_RootConstrainSelectedInstOperands,
     /*  644717 */     // GIR_Coverage, 6810,
     /*  644717 */     GIR_EraseRootFromParent_Done,
     /*  644718 */   // Label 10322: @644718
     /*  644718 */   GIM_Try, /*On fail goto*//*Label 10323*/ GIMT_Encode4(644793), // Rule ID 6811 //
     /*  644723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  644734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  644737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  644740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4),
     /*  644772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644791 */     GIR_RootConstrainSelectedInstOperands,
     /*  644792 */     // GIR_Coverage, 6811,
     /*  644792 */     GIR_EraseRootFromParent_Done,
     /*  644793 */   // Label 10323: @644793
     /*  644793 */   GIM_Try, /*On fail goto*//*Label 10324*/ GIMT_Encode4(644868), // Rule ID 6814 //
     /*  644798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  644809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  644812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  644815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  644844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  644847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644866 */     GIR_RootConstrainSelectedInstOperands,
     /*  644867 */     // GIR_Coverage, 6814,
     /*  644867 */     GIR_EraseRootFromParent_Done,
     /*  644868 */   // Label 10324: @644868
     /*  644868 */   GIM_Try, /*On fail goto*//*Label 10325*/ GIMT_Encode4(644943), // Rule ID 6815 //
     /*  644873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  644876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  644884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  644887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  644890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  644893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  644896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  644919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  644922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  644926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  644928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  644930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  644935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  644938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  644941 */     GIR_RootConstrainSelectedInstOperands,
     /*  644942 */     // GIR_Coverage, 6815,
     /*  644942 */     GIR_EraseRootFromParent_Done,
     /*  644943 */   // Label 10325: @644943
     /*  644943 */   GIM_Try, /*On fail goto*//*Label 10326*/ GIMT_Encode4(645018), // Rule ID 6818 //
     /*  644948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  644951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  644956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  644959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  644962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  644965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  644968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  644971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  644983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  644987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  644994 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  644994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  644997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  644999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645016 */     GIR_RootConstrainSelectedInstOperands,
     /*  645017 */     // GIR_Coverage, 6818,
     /*  645017 */     GIR_EraseRootFromParent_Done,
     /*  645018 */   // Label 10326: @645018
     /*  645018 */   GIM_Try, /*On fail goto*//*Label 10327*/ GIMT_Encode4(645093), // Rule ID 6819 //
     /*  645023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  645034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  645037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  645040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  645069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2),
     /*  645072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645091 */     GIR_RootConstrainSelectedInstOperands,
     /*  645092 */     // GIR_Coverage, 6819,
     /*  645092 */     GIR_EraseRootFromParent_Done,
     /*  645093 */   // Label 10327: @645093
     /*  645093 */   GIM_Try, /*On fail goto*//*Label 10328*/ GIMT_Encode4(645168), // Rule ID 6822 //
     /*  645098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645166 */     GIR_RootConstrainSelectedInstOperands,
     /*  645167 */     // GIR_Coverage, 6822,
     /*  645167 */     GIR_EraseRootFromParent_Done,
     /*  645168 */   // Label 10328: @645168
     /*  645168 */   GIM_Try, /*On fail goto*//*Label 10329*/ GIMT_Encode4(645243), // Rule ID 6823 //
     /*  645173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  645184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  645187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  645190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11512:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645241 */     GIR_RootConstrainSelectedInstOperands,
     /*  645242 */     // GIR_Coverage, 6823,
     /*  645242 */     GIR_EraseRootFromParent_Done,
     /*  645243 */   // Label 10329: @645243
     /*  645243 */   GIM_Try, /*On fail goto*//*Label 10330*/ GIMT_Encode4(645318), // Rule ID 6826 //
     /*  645248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  645294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645316 */     GIR_RootConstrainSelectedInstOperands,
     /*  645317 */     // GIR_Coverage, 6826,
     /*  645317 */     GIR_EraseRootFromParent_Done,
     /*  645318 */   // Label 10330: @645318
     /*  645318 */   GIM_Try, /*On fail goto*//*Label 10331*/ GIMT_Encode4(645393), // Rule ID 6827 //
     /*  645323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  645334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  645337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  645340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11512:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  645369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  645388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645391 */     GIR_RootConstrainSelectedInstOperands,
     /*  645392 */     // GIR_Coverage, 6827,
     /*  645392 */     GIR_EraseRootFromParent_Done,
     /*  645393 */   // Label 10331: @645393
     /*  645393 */   GIM_Try, /*On fail goto*//*Label 10332*/ GIMT_Encode4(645468), // Rule ID 6830 //
     /*  645398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  645409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  645412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  645415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  645444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645466 */     GIR_RootConstrainSelectedInstOperands,
     /*  645467 */     // GIR_Coverage, 6830,
     /*  645467 */     GIR_EraseRootFromParent_Done,
     /*  645468 */   // Label 10332: @645468
     /*  645468 */   GIM_Try, /*On fail goto*//*Label 10333*/ GIMT_Encode4(645543), // Rule ID 6831 //
     /*  645473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  645484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  645487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  645490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11512:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  645519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  645538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645541 */     GIR_RootConstrainSelectedInstOperands,
     /*  645542 */     // GIR_Coverage, 6831,
     /*  645542 */     GIR_EraseRootFromParent_Done,
     /*  645543 */   // Label 10333: @645543
     /*  645543 */   GIM_Try, /*On fail goto*//*Label 10334*/ GIMT_Encode4(645618), // Rule ID 6834 //
     /*  645548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  645551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  645559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  645562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  645565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  645594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645616 */     GIR_RootConstrainSelectedInstOperands,
     /*  645617 */     // GIR_Coverage, 6834,
     /*  645617 */     GIR_EraseRootFromParent_Done,
     /*  645618 */   // Label 10334: @645618
     /*  645618 */   GIM_Try, /*On fail goto*//*Label 10335*/ GIMT_Encode4(645693), // Rule ID 6835 //
     /*  645623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  645626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  645634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  645637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  645640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  645658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645669 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11512:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  645669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1),
     /*  645672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  645688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645691 */     GIR_RootConstrainSelectedInstOperands,
     /*  645692 */     // GIR_Coverage, 6835,
     /*  645692 */     GIR_EraseRootFromParent_Done,
     /*  645693 */   // Label 10335: @645693
     /*  645693 */   GIM_Try, /*On fail goto*//*Label 10336*/ GIMT_Encode4(645768), // Rule ID 6838 //
     /*  645698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  645709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  645712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  645715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  645747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645766 */     GIR_RootConstrainSelectedInstOperands,
     /*  645767 */     // GIR_Coverage, 6838,
     /*  645767 */     GIR_EraseRootFromParent_Done,
     /*  645768 */   // Label 10336: @645768
     /*  645768 */   GIM_Try, /*On fail goto*//*Label 10337*/ GIMT_Encode4(645843), // Rule ID 6839 //
     /*  645773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  645784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  645787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  645790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  645808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  645822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645841 */     GIR_RootConstrainSelectedInstOperands,
     /*  645842 */     // GIR_Coverage, 6839,
     /*  645842 */     GIR_EraseRootFromParent_Done,
     /*  645843 */   // Label 10337: @645843
     /*  645843 */   GIM_Try, /*On fail goto*//*Label 10338*/ GIMT_Encode4(645918), // Rule ID 6842 //
     /*  645848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  645851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  645859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  645862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  645865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  645868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  645871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  645894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  645897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645916 */     GIR_RootConstrainSelectedInstOperands,
     /*  645917 */     // GIR_Coverage, 6842,
     /*  645917 */     GIR_EraseRootFromParent_Done,
     /*  645918 */   // Label 10338: @645918
     /*  645918 */   GIM_Try, /*On fail goto*//*Label 10339*/ GIMT_Encode4(645993), // Rule ID 6843 //
     /*  645923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  645926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  645931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  645934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  645937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  645940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  645943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  645946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  645958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  645962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  645969 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  645969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  645972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  645974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  645976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  645978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  645980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  645985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  645988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  645991 */     GIR_RootConstrainSelectedInstOperands,
     /*  645992 */     // GIR_Coverage, 6843,
     /*  645992 */     GIR_EraseRootFromParent_Done,
     /*  645993 */   // Label 10339: @645993
     /*  645993 */   GIM_Try, /*On fail goto*//*Label 10340*/ GIMT_Encode4(646068), // Rule ID 6846 //
     /*  645998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  646044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646066 */     GIR_RootConstrainSelectedInstOperands,
     /*  646067 */     // GIR_Coverage, 6846,
     /*  646067 */     GIR_EraseRootFromParent_Done,
     /*  646068 */   // Label 10340: @646068
     /*  646068 */   GIM_Try, /*On fail goto*//*Label 10341*/ GIMT_Encode4(646143), // Rule ID 6847 //
     /*  646073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  646084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  646087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  646090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646119 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  646119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  646138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646141 */     GIR_RootConstrainSelectedInstOperands,
     /*  646142 */     // GIR_Coverage, 6847,
     /*  646142 */     GIR_EraseRootFromParent_Done,
     /*  646143 */   // Label 10341: @646143
     /*  646143 */   GIM_Try, /*On fail goto*//*Label 10342*/ GIMT_Encode4(646218), // Rule ID 6850 //
     /*  646148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646216 */     GIR_RootConstrainSelectedInstOperands,
     /*  646217 */     // GIR_Coverage, 6850,
     /*  646217 */     GIR_EraseRootFromParent_Done,
     /*  646218 */   // Label 10342: @646218
     /*  646218 */   GIM_Try, /*On fail goto*//*Label 10343*/ GIMT_Encode4(646293), // Rule ID 6851 //
     /*  646223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  646234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  646237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  646240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646291 */     GIR_RootConstrainSelectedInstOperands,
     /*  646292 */     // GIR_Coverage, 6851,
     /*  646292 */     GIR_EraseRootFromParent_Done,
     /*  646293 */   // Label 10343: @646293
     /*  646293 */   GIM_Try, /*On fail goto*//*Label 10344*/ GIMT_Encode4(646368), // Rule ID 6854 //
     /*  646298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646366 */     GIR_RootConstrainSelectedInstOperands,
     /*  646367 */     // GIR_Coverage, 6854,
     /*  646367 */     GIR_EraseRootFromParent_Done,
     /*  646368 */   // Label 10344: @646368
     /*  646368 */   GIM_Try, /*On fail goto*//*Label 10345*/ GIMT_Encode4(646443), // Rule ID 6855 //
     /*  646373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  646384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  646387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  646390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646441 */     GIR_RootConstrainSelectedInstOperands,
     /*  646442 */     // GIR_Coverage, 6855,
     /*  646442 */     GIR_EraseRootFromParent_Done,
     /*  646443 */   // Label 10345: @646443
     /*  646443 */   GIM_Try, /*On fail goto*//*Label 10346*/ GIMT_Encode4(646518), // Rule ID 6858 //
     /*  646448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  646459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  646462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  646465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  646494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646516 */     GIR_RootConstrainSelectedInstOperands,
     /*  646517 */     // GIR_Coverage, 6858,
     /*  646517 */     GIR_EraseRootFromParent_Done,
     /*  646518 */   // Label 10346: @646518
     /*  646518 */   GIM_Try, /*On fail goto*//*Label 10347*/ GIMT_Encode4(646593), // Rule ID 6859 //
     /*  646523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  646534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  646537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  646540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646569 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  646569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  646588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646591 */     GIR_RootConstrainSelectedInstOperands,
     /*  646592 */     // GIR_Coverage, 6859,
     /*  646592 */     GIR_EraseRootFromParent_Done,
     /*  646593 */   // Label 10347: @646593
     /*  646593 */   GIM_Try, /*On fail goto*//*Label 10348*/ GIMT_Encode4(646668), // Rule ID 6862 //
     /*  646598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  646609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  646612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  646615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646666 */     GIR_RootConstrainSelectedInstOperands,
     /*  646667 */     // GIR_Coverage, 6862,
     /*  646667 */     GIR_EraseRootFromParent_Done,
     /*  646668 */   // Label 10348: @646668
     /*  646668 */   GIM_Try, /*On fail goto*//*Label 10349*/ GIMT_Encode4(646743), // Rule ID 6863 //
     /*  646673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  646684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  646687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  646690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  646708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  646722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646741 */     GIR_RootConstrainSelectedInstOperands,
     /*  646742 */     // GIR_Coverage, 6863,
     /*  646742 */     GIR_EraseRootFromParent_Done,
     /*  646743 */   // Label 10349: @646743
     /*  646743 */   GIM_Try, /*On fail goto*//*Label 10350*/ GIMT_Encode4(646818), // Rule ID 6866 //
     /*  646748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  646759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  646762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  646765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646816 */     GIR_RootConstrainSelectedInstOperands,
     /*  646817 */     // GIR_Coverage, 6866,
     /*  646817 */     GIR_EraseRootFromParent_Done,
     /*  646818 */   // Label 10350: @646818
     /*  646818 */   GIM_Try, /*On fail goto*//*Label 10351*/ GIMT_Encode4(646893), // Rule ID 6867 //
     /*  646823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  646834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  646837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  646840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  646858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646869 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  646869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  646872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646891 */     GIR_RootConstrainSelectedInstOperands,
     /*  646892 */     // GIR_Coverage, 6867,
     /*  646892 */     GIR_EraseRootFromParent_Done,
     /*  646893 */   // Label 10351: @646893
     /*  646893 */   GIM_Try, /*On fail goto*//*Label 10352*/ GIMT_Encode4(646968), // Rule ID 6870 //
     /*  646898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  646901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  646909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  646912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  646915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  646918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  646921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  646933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  646937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  646944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  646944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  646947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  646949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  646951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  646953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  646955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  646960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  646963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  646966 */     GIR_RootConstrainSelectedInstOperands,
     /*  646967 */     // GIR_Coverage, 6870,
     /*  646967 */     GIR_EraseRootFromParent_Done,
     /*  646968 */   // Label 10352: @646968
     /*  646968 */   GIM_Try, /*On fail goto*//*Label 10353*/ GIMT_Encode4(647043), // Rule ID 6871 //
     /*  646973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  646976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  646981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  646984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  646987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  646990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  646993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  646996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647019 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  647019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  647038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647041 */     GIR_RootConstrainSelectedInstOperands,
     /*  647042 */     // GIR_Coverage, 6871,
     /*  647042 */     GIR_EraseRootFromParent_Done,
     /*  647043 */   // Label 10353: @647043
     /*  647043 */   GIM_Try, /*On fail goto*//*Label 10354*/ GIMT_Encode4(647118), // Rule ID 6874 //
     /*  647048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647116 */     GIR_RootConstrainSelectedInstOperands,
     /*  647117 */     // GIR_Coverage, 6874,
     /*  647117 */     GIR_EraseRootFromParent_Done,
     /*  647118 */   // Label 10354: @647118
     /*  647118 */   GIM_Try, /*On fail goto*//*Label 10355*/ GIMT_Encode4(647193), // Rule ID 6875 //
     /*  647123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  647134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  647137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  647140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  647158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11512:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2),
     /*  647172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647191 */     GIR_RootConstrainSelectedInstOperands,
     /*  647192 */     // GIR_Coverage, 6875,
     /*  647192 */     GIR_EraseRootFromParent_Done,
     /*  647193 */   // Label 10355: @647193
     /*  647193 */   GIM_Try, /*On fail goto*//*Label 10356*/ GIMT_Encode4(647268), // Rule ID 6878 //
     /*  647198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647266 */     GIR_RootConstrainSelectedInstOperands,
     /*  647267 */     // GIR_Coverage, 6878,
     /*  647267 */     GIR_EraseRootFromParent_Done,
     /*  647268 */   // Label 10356: @647268
     /*  647268 */   GIM_Try, /*On fail goto*//*Label 10357*/ GIMT_Encode4(647343), // Rule ID 6879 //
     /*  647273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  647284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  647287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  647290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  647308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11512:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4),
     /*  647322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647341 */     GIR_RootConstrainSelectedInstOperands,
     /*  647342 */     // GIR_Coverage, 6879,
     /*  647342 */     GIR_EraseRootFromParent_Done,
     /*  647343 */   // Label 10357: @647343
     /*  647343 */   GIM_Try, /*On fail goto*//*Label 10358*/ GIMT_Encode4(647418), // Rule ID 6882 //
     /*  647348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  647351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  647368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  647394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647416 */     GIR_RootConstrainSelectedInstOperands,
     /*  647417 */     // GIR_Coverage, 6882,
     /*  647417 */     GIR_EraseRootFromParent_Done,
     /*  647418 */   // Label 10358: @647418
     /*  647418 */   GIM_Try, /*On fail goto*//*Label 10359*/ GIMT_Encode4(647493), // Rule ID 6883 //
     /*  647423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  647426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl),
     /*  647431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  647434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  647437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  647440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  647443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  647458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  647462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11512:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  647469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8),
     /*  647472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  647488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647491 */     GIR_RootConstrainSelectedInstOperands,
     /*  647492 */     // GIR_Coverage, 6883,
     /*  647492 */     GIR_EraseRootFromParent_Done,
     /*  647493 */   // Label 10359: @647493
     /*  647493 */   GIM_Try, /*On fail goto*//*Label 10360*/ GIMT_Encode4(647568), // Rule ID 6974 //
     /*  647498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  647509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  647512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  647515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  647518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  647547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647566 */     GIR_RootConstrainSelectedInstOperands,
     /*  647567 */     // GIR_Coverage, 6974,
     /*  647567 */     GIR_EraseRootFromParent_Done,
     /*  647568 */   // Label 10360: @647568
     /*  647568 */   GIM_Try, /*On fail goto*//*Label 10361*/ GIMT_Encode4(647643), // Rule ID 6975 //
     /*  647573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  647584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  647587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  647590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  647593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /*  647622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647641 */     GIR_RootConstrainSelectedInstOperands,
     /*  647642 */     // GIR_Coverage, 6975,
     /*  647642 */     GIR_EraseRootFromParent_Done,
     /*  647643 */   // Label 10361: @647643
     /*  647643 */   GIM_Try, /*On fail goto*//*Label 10362*/ GIMT_Encode4(647718), // Rule ID 6978 //
     /*  647648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  647659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  647662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  647665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  647668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  647697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647716 */     GIR_RootConstrainSelectedInstOperands,
     /*  647717 */     // GIR_Coverage, 6978,
     /*  647717 */     GIR_EraseRootFromParent_Done,
     /*  647718 */   // Label 10362: @647718
     /*  647718 */   GIM_Try, /*On fail goto*//*Label 10363*/ GIMT_Encode4(647793), // Rule ID 6979 //
     /*  647723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  647734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  647737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  647740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  647743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  647772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647791 */     GIR_RootConstrainSelectedInstOperands,
     /*  647792 */     // GIR_Coverage, 6979,
     /*  647792 */     GIR_EraseRootFromParent_Done,
     /*  647793 */   // Label 10363: @647793
     /*  647793 */   GIM_Try, /*On fail goto*//*Label 10364*/ GIMT_Encode4(647868), // Rule ID 6982 //
     /*  647798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  647809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  647812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  647815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  647818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  647844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  647847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647866 */     GIR_RootConstrainSelectedInstOperands,
     /*  647867 */     // GIR_Coverage, 6982,
     /*  647867 */     GIR_EraseRootFromParent_Done,
     /*  647868 */   // Label 10364: @647868
     /*  647868 */   GIM_Try, /*On fail goto*//*Label 10365*/ GIMT_Encode4(647943), // Rule ID 6983 //
     /*  647873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  647876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  647884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  647887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  647890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  647893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  647896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  647919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  647922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  647926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  647928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  647930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  647935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  647938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  647941 */     GIR_RootConstrainSelectedInstOperands,
     /*  647942 */     // GIR_Coverage, 6983,
     /*  647942 */     GIR_EraseRootFromParent_Done,
     /*  647943 */   // Label 10365: @647943
     /*  647943 */   GIM_Try, /*On fail goto*//*Label 10366*/ GIMT_Encode4(648018), // Rule ID 6986 //
     /*  647948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  647951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  647956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  647959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  647962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  647965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  647968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  647971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  647987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  647994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  647994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  647997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  647999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648016 */     GIR_RootConstrainSelectedInstOperands,
     /*  648017 */     // GIR_Coverage, 6986,
     /*  648017 */     GIR_EraseRootFromParent_Done,
     /*  648018 */   // Label 10366: @648018
     /*  648018 */   GIM_Try, /*On fail goto*//*Label 10367*/ GIMT_Encode4(648093), // Rule ID 6987 //
     /*  648023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  648034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  648037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  648040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  648043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /*  648072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648091 */     GIR_RootConstrainSelectedInstOperands,
     /*  648092 */     // GIR_Coverage, 6987,
     /*  648092 */     GIR_EraseRootFromParent_Done,
     /*  648093 */   // Label 10367: @648093
     /*  648093 */   GIM_Try, /*On fail goto*//*Label 10368*/ GIMT_Encode4(648168), // Rule ID 6990 //
     /*  648098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648166 */     GIR_RootConstrainSelectedInstOperands,
     /*  648167 */     // GIR_Coverage, 6990,
     /*  648167 */     GIR_EraseRootFromParent_Done,
     /*  648168 */   // Label 10368: @648168
     /*  648168 */   GIM_Try, /*On fail goto*//*Label 10369*/ GIMT_Encode4(648243), // Rule ID 6991 //
     /*  648173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  648184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  648187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  648190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  648193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648241 */     GIR_RootConstrainSelectedInstOperands,
     /*  648242 */     // GIR_Coverage, 6991,
     /*  648242 */     GIR_EraseRootFromParent_Done,
     /*  648243 */   // Label 10369: @648243
     /*  648243 */   GIM_Try, /*On fail goto*//*Label 10370*/ GIMT_Encode4(648318), // Rule ID 6994 //
     /*  648248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  648294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648316 */     GIR_RootConstrainSelectedInstOperands,
     /*  648317 */     // GIR_Coverage, 6994,
     /*  648317 */     GIR_EraseRootFromParent_Done,
     /*  648318 */   // Label 10370: @648318
     /*  648318 */   GIM_Try, /*On fail goto*//*Label 10371*/ GIMT_Encode4(648393), // Rule ID 6995 //
     /*  648323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  648334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  648337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  648340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  648343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /*  648372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648391 */     GIR_RootConstrainSelectedInstOperands,
     /*  648392 */     // GIR_Coverage, 6995,
     /*  648392 */     GIR_EraseRootFromParent_Done,
     /*  648393 */   // Label 10371: @648393
     /*  648393 */   GIM_Try, /*On fail goto*//*Label 10372*/ GIMT_Encode4(648468), // Rule ID 6998 //
     /*  648398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  648409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  648412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  648444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648466 */     GIR_RootConstrainSelectedInstOperands,
     /*  648467 */     // GIR_Coverage, 6998,
     /*  648467 */     GIR_EraseRootFromParent_Done,
     /*  648468 */   // Label 10372: @648468
     /*  648468 */   GIM_Try, /*On fail goto*//*Label 10373*/ GIMT_Encode4(648543), // Rule ID 6999 //
     /*  648473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  648484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  648487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  648490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  648493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  648519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  648538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648541 */     GIR_RootConstrainSelectedInstOperands,
     /*  648542 */     // GIR_Coverage, 6999,
     /*  648542 */     GIR_EraseRootFromParent_Done,
     /*  648543 */   // Label 10373: @648543
     /*  648543 */   GIM_Try, /*On fail goto*//*Label 10374*/ GIMT_Encode4(648618), // Rule ID 7002 //
     /*  648548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  648559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  648562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  648565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  648568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  648594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648616 */     GIR_RootConstrainSelectedInstOperands,
     /*  648617 */     // GIR_Coverage, 7002,
     /*  648617 */     GIR_EraseRootFromParent_Done,
     /*  648618 */   // Label 10374: @648618
     /*  648618 */   GIM_Try, /*On fail goto*//*Label 10375*/ GIMT_Encode4(648693), // Rule ID 7003 //
     /*  648623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  648634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  648637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  648640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  648643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  648669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  648688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648691 */     GIR_RootConstrainSelectedInstOperands,
     /*  648692 */     // GIR_Coverage, 7003,
     /*  648692 */     GIR_EraseRootFromParent_Done,
     /*  648693 */   // Label 10375: @648693
     /*  648693 */   GIM_Try, /*On fail goto*//*Label 10376*/ GIMT_Encode4(648768), // Rule ID 7006 //
     /*  648698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  648701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  648709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  648712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  648715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  648718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  648744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648766 */     GIR_RootConstrainSelectedInstOperands,
     /*  648767 */     // GIR_Coverage, 7006,
     /*  648767 */     GIR_EraseRootFromParent_Done,
     /*  648768 */   // Label 10376: @648768
     /*  648768 */   GIM_Try, /*On fail goto*//*Label 10377*/ GIMT_Encode4(648843), // Rule ID 7007 //
     /*  648773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  648776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  648784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  648787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  648790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  648793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  648819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  648838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648841 */     GIR_RootConstrainSelectedInstOperands,
     /*  648842 */     // GIR_Coverage, 7007,
     /*  648842 */     GIR_EraseRootFromParent_Done,
     /*  648843 */   // Label 10377: @648843
     /*  648843 */   GIM_Try, /*On fail goto*//*Label 10378*/ GIMT_Encode4(648918), // Rule ID 7010 //
     /*  648848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  648851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  648859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  648862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  648865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  648868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  648871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  648894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648916 */     GIR_RootConstrainSelectedInstOperands,
     /*  648917 */     // GIR_Coverage, 7010,
     /*  648917 */     GIR_EraseRootFromParent_Done,
     /*  648918 */   // Label 10378: @648918
     /*  648918 */   GIM_Try, /*On fail goto*//*Label 10379*/ GIMT_Encode4(648993), // Rule ID 7011 //
     /*  648923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  648926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  648931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  648934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  648937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  648940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  648943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  648946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  648962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  648969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  648969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /*  648972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  648974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  648976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  648978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  648980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  648985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  648988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  648991 */     GIR_RootConstrainSelectedInstOperands,
     /*  648992 */     // GIR_Coverage, 7011,
     /*  648992 */     GIR_EraseRootFromParent_Done,
     /*  648993 */   // Label 10379: @648993
     /*  648993 */   GIM_Try, /*On fail goto*//*Label 10380*/ GIMT_Encode4(649068), // Rule ID 7014 //
     /*  648998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649066 */     GIR_RootConstrainSelectedInstOperands,
     /*  649067 */     // GIR_Coverage, 7014,
     /*  649067 */     GIR_EraseRootFromParent_Done,
     /*  649068 */   // Label 10380: @649068
     /*  649068 */   GIM_Try, /*On fail goto*//*Label 10381*/ GIMT_Encode4(649143), // Rule ID 7015 //
     /*  649073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  649084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  649087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  649090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  649093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649141 */     GIR_RootConstrainSelectedInstOperands,
     /*  649142 */     // GIR_Coverage, 7015,
     /*  649142 */     GIR_EraseRootFromParent_Done,
     /*  649143 */   // Label 10381: @649143
     /*  649143 */   GIM_Try, /*On fail goto*//*Label 10382*/ GIMT_Encode4(649218), // Rule ID 7018 //
     /*  649148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649216 */     GIR_RootConstrainSelectedInstOperands,
     /*  649217 */     // GIR_Coverage, 7018,
     /*  649217 */     GIR_EraseRootFromParent_Done,
     /*  649218 */   // Label 10382: @649218
     /*  649218 */   GIM_Try, /*On fail goto*//*Label 10383*/ GIMT_Encode4(649293), // Rule ID 7019 //
     /*  649223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  649234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  649237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  649240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  649243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649291 */     GIR_RootConstrainSelectedInstOperands,
     /*  649292 */     // GIR_Coverage, 7019,
     /*  649292 */     GIR_EraseRootFromParent_Done,
     /*  649293 */   // Label 10383: @649293
     /*  649293 */   GIM_Try, /*On fail goto*//*Label 10384*/ GIMT_Encode4(649368), // Rule ID 7022 //
     /*  649298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  649344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649366 */     GIR_RootConstrainSelectedInstOperands,
     /*  649367 */     // GIR_Coverage, 7022,
     /*  649367 */     GIR_EraseRootFromParent_Done,
     /*  649368 */   // Label 10384: @649368
     /*  649368 */   GIM_Try, /*On fail goto*//*Label 10385*/ GIMT_Encode4(649443), // Rule ID 7023 //
     /*  649373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  649384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  649387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  649390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  649393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  649419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  649438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649441 */     GIR_RootConstrainSelectedInstOperands,
     /*  649442 */     // GIR_Coverage, 7023,
     /*  649442 */     GIR_EraseRootFromParent_Done,
     /*  649443 */   // Label 10385: @649443
     /*  649443 */   GIM_Try, /*On fail goto*//*Label 10386*/ GIMT_Encode4(649518), // Rule ID 7026 //
     /*  649448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  649459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  649462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649516 */     GIR_RootConstrainSelectedInstOperands,
     /*  649517 */     // GIR_Coverage, 7026,
     /*  649517 */     GIR_EraseRootFromParent_Done,
     /*  649518 */   // Label 10386: @649518
     /*  649518 */   GIM_Try, /*On fail goto*//*Label 10387*/ GIMT_Encode4(649593), // Rule ID 7027 //
     /*  649523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  649534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  649537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  649540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  649543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649591 */     GIR_RootConstrainSelectedInstOperands,
     /*  649592 */     // GIR_Coverage, 7027,
     /*  649592 */     GIR_EraseRootFromParent_Done,
     /*  649593 */   // Label 10387: @649593
     /*  649593 */   GIM_Try, /*On fail goto*//*Label 10388*/ GIMT_Encode4(649668), // Rule ID 7030 //
     /*  649598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  649609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  649612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  649615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  649618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649666 */     GIR_RootConstrainSelectedInstOperands,
     /*  649667 */     // GIR_Coverage, 7030,
     /*  649667 */     GIR_EraseRootFromParent_Done,
     /*  649668 */   // Label 10388: @649668
     /*  649668 */   GIM_Try, /*On fail goto*//*Label 10389*/ GIMT_Encode4(649743), // Rule ID 7031 //
     /*  649673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  649684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  649687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  649690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  649693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  649712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  649722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649741 */     GIR_RootConstrainSelectedInstOperands,
     /*  649742 */     // GIR_Coverage, 7031,
     /*  649742 */     GIR_EraseRootFromParent_Done,
     /*  649743 */   // Label 10389: @649743
     /*  649743 */   GIM_Try, /*On fail goto*//*Label 10390*/ GIMT_Encode4(649818), // Rule ID 7034 //
     /*  649748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  649759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  649762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  649765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  649768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  649794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649816 */     GIR_RootConstrainSelectedInstOperands,
     /*  649817 */     // GIR_Coverage, 7034,
     /*  649817 */     GIR_EraseRootFromParent_Done,
     /*  649818 */   // Label 10390: @649818
     /*  649818 */   GIM_Try, /*On fail goto*//*Label 10391*/ GIMT_Encode4(649893), // Rule ID 7035 //
     /*  649823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  649834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  649837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  649840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  649843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  649862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  649869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  649872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  649888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649891 */     GIR_RootConstrainSelectedInstOperands,
     /*  649892 */     // GIR_Coverage, 7035,
     /*  649892 */     GIR_EraseRootFromParent_Done,
     /*  649893 */   // Label 10391: @649893
     /*  649893 */   GIM_Try, /*On fail goto*//*Label 10392*/ GIMT_Encode4(649968), // Rule ID 7038 //
     /*  649898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  649901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  649909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  649912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  649915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  649918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  649921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  649937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  649944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  649944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  649947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  649949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  649951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  649953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  649955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  649960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  649963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  649966 */     GIR_RootConstrainSelectedInstOperands,
     /*  649967 */     // GIR_Coverage, 7038,
     /*  649967 */     GIR_EraseRootFromParent_Done,
     /*  649968 */   // Label 10392: @649968
     /*  649968 */   GIM_Try, /*On fail goto*//*Label 10393*/ GIMT_Encode4(650043), // Rule ID 7039 //
     /*  649973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  649976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  649981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  649984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  649987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  649990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  649993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  649996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650041 */     GIR_RootConstrainSelectedInstOperands,
     /*  650042 */     // GIR_Coverage, 7039,
     /*  650042 */     GIR_EraseRootFromParent_Done,
     /*  650043 */   // Label 10393: @650043
     /*  650043 */   GIM_Try, /*On fail goto*//*Label 10394*/ GIMT_Encode4(650118), // Rule ID 7042 //
     /*  650048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650116 */     GIR_RootConstrainSelectedInstOperands,
     /*  650117 */     // GIR_Coverage, 7042,
     /*  650117 */     GIR_EraseRootFromParent_Done,
     /*  650118 */   // Label 10394: @650118
     /*  650118 */   GIM_Try, /*On fail goto*//*Label 10395*/ GIMT_Encode4(650193), // Rule ID 7043 //
     /*  650123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  650134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  650137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  650140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  650143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650191 */     GIR_RootConstrainSelectedInstOperands,
     /*  650192 */     // GIR_Coverage, 7043,
     /*  650192 */     GIR_EraseRootFromParent_Done,
     /*  650193 */   // Label 10395: @650193
     /*  650193 */   GIM_Try, /*On fail goto*//*Label 10396*/ GIMT_Encode4(650268), // Rule ID 7046 //
     /*  650198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  650244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650266 */     GIR_RootConstrainSelectedInstOperands,
     /*  650267 */     // GIR_Coverage, 7046,
     /*  650267 */     GIR_EraseRootFromParent_Done,
     /*  650268 */   // Label 10396: @650268
     /*  650268 */   GIM_Try, /*On fail goto*//*Label 10397*/ GIMT_Encode4(650343), // Rule ID 7047 //
     /*  650273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  650284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  650287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  650290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  650293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  650319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  650338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650341 */     GIR_RootConstrainSelectedInstOperands,
     /*  650342 */     // GIR_Coverage, 7047,
     /*  650342 */     GIR_EraseRootFromParent_Done,
     /*  650343 */   // Label 10397: @650343
     /*  650343 */   GIM_Try, /*On fail goto*//*Label 10398*/ GIMT_Encode4(650418), // Rule ID 7050 //
     /*  650348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  650351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  650394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650416 */     GIR_RootConstrainSelectedInstOperands,
     /*  650417 */     // GIR_Coverage, 7050,
     /*  650417 */     GIR_EraseRootFromParent_Done,
     /*  650418 */   // Label 10398: @650418
     /*  650418 */   GIM_Try, /*On fail goto*//*Label 10399*/ GIMT_Encode4(650493), // Rule ID 7051 //
     /*  650423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  650426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  650434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  650437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  650440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  650443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  650462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /*  650472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650491 */     GIR_RootConstrainSelectedInstOperands,
     /*  650492 */     // GIR_Coverage, 7051,
     /*  650492 */     GIR_EraseRootFromParent_Done,
     /*  650493 */   // Label 10399: @650493
     /*  650493 */   GIM_Try, /*On fail goto*//*Label 10400*/ GIMT_Encode4(650568), // Rule ID 7054 //
     /*  650498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  650501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  650509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  650512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  650515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  650518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  650544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650566 */     GIR_RootConstrainSelectedInstOperands,
     /*  650567 */     // GIR_Coverage, 7054,
     /*  650567 */     GIR_EraseRootFromParent_Done,
     /*  650568 */   // Label 10400: @650568
     /*  650568 */   GIM_Try, /*On fail goto*//*Label 10401*/ GIMT_Encode4(650643), // Rule ID 7055 //
     /*  650573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  650576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  650584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  650587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  650590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  650593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  650612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /*  650622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650641 */     GIR_RootConstrainSelectedInstOperands,
     /*  650642 */     // GIR_Coverage, 7055,
     /*  650642 */     GIR_EraseRootFromParent_Done,
     /*  650643 */   // Label 10401: @650643
     /*  650643 */   GIM_Try, /*On fail goto*//*Label 10402*/ GIMT_Encode4(650718), // Rule ID 7058 //
     /*  650648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  650651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  650659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  650662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  650665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  650668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  650694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650716 */     GIR_RootConstrainSelectedInstOperands,
     /*  650717 */     // GIR_Coverage, 7058,
     /*  650717 */     GIR_EraseRootFromParent_Done,
     /*  650718 */   // Label 10402: @650718
     /*  650718 */   GIM_Try, /*On fail goto*//*Label 10403*/ GIMT_Encode4(650793), // Rule ID 7059 //
     /*  650723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  650726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  650734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  650737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  650740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  650743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  650762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  650769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /*  650772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  650788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650791 */     GIR_RootConstrainSelectedInstOperands,
     /*  650792 */     // GIR_Coverage, 7059,
     /*  650792 */     GIR_EraseRootFromParent_Done,
     /*  650793 */   // Label 10403: @650793
     /*  650793 */   GIM_Try, /*On fail goto*//*Label 10404*/ GIMT_Encode4(650868), // Rule ID 7062 //
     /*  650798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  650809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  650812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  650815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  650847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650866 */     GIR_RootConstrainSelectedInstOperands,
     /*  650867 */     // GIR_Coverage, 7062,
     /*  650867 */     GIR_EraseRootFromParent_Done,
     /*  650868 */   // Label 10404: @650868
     /*  650868 */   GIM_Try, /*On fail goto*//*Label 10405*/ GIMT_Encode4(650943), // Rule ID 7063 //
     /*  650873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  650876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  650884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  650887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  650890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  650893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  650896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  650919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8),
     /*  650922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  650926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  650928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  650930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  650935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  650938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  650941 */     GIR_RootConstrainSelectedInstOperands,
     /*  650942 */     // GIR_Coverage, 7063,
     /*  650942 */     GIR_EraseRootFromParent_Done,
     /*  650943 */   // Label 10405: @650943
     /*  650943 */   GIM_Try, /*On fail goto*//*Label 10406*/ GIMT_Encode4(651018), // Rule ID 7066 //
     /*  650948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  650951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  650956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  650959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  650962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  650965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  650968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  650971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  650983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  650987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  650994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  650994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  650997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  650999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651016 */     GIR_RootConstrainSelectedInstOperands,
     /*  651017 */     // GIR_Coverage, 7066,
     /*  651017 */     GIR_EraseRootFromParent_Done,
     /*  651018 */   // Label 10406: @651018
     /*  651018 */   GIM_Try, /*On fail goto*//*Label 10407*/ GIMT_Encode4(651093), // Rule ID 7067 //
     /*  651023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  651034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  651037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  651040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651091 */     GIR_RootConstrainSelectedInstOperands,
     /*  651092 */     // GIR_Coverage, 7067,
     /*  651092 */     GIR_EraseRootFromParent_Done,
     /*  651093 */   // Label 10407: @651093
     /*  651093 */   GIM_Try, /*On fail goto*//*Label 10408*/ GIMT_Encode4(651168), // Rule ID 7070 //
     /*  651098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651166 */     GIR_RootConstrainSelectedInstOperands,
     /*  651167 */     // GIR_Coverage, 7070,
     /*  651167 */     GIR_EraseRootFromParent_Done,
     /*  651168 */   // Label 10408: @651168
     /*  651168 */   GIM_Try, /*On fail goto*//*Label 10409*/ GIMT_Encode4(651243), // Rule ID 7071 //
     /*  651173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  651184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  651187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  651190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651241 */     GIR_RootConstrainSelectedInstOperands,
     /*  651242 */     // GIR_Coverage, 7071,
     /*  651242 */     GIR_EraseRootFromParent_Done,
     /*  651243 */   // Label 10409: @651243
     /*  651243 */   GIM_Try, /*On fail goto*//*Label 10410*/ GIMT_Encode4(651318), // Rule ID 7074 //
     /*  651248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651316 */     GIR_RootConstrainSelectedInstOperands,
     /*  651317 */     // GIR_Coverage, 7074,
     /*  651317 */     GIR_EraseRootFromParent_Done,
     /*  651318 */   // Label 10410: @651318
     /*  651318 */   GIM_Try, /*On fail goto*//*Label 10411*/ GIMT_Encode4(651393), // Rule ID 7075 //
     /*  651323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  651334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  651337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  651340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4),
     /*  651372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651391 */     GIR_RootConstrainSelectedInstOperands,
     /*  651392 */     // GIR_Coverage, 7075,
     /*  651392 */     GIR_EraseRootFromParent_Done,
     /*  651393 */   // Label 10411: @651393
     /*  651393 */   GIM_Try, /*On fail goto*//*Label 10412*/ GIMT_Encode4(651468), // Rule ID 7078 //
     /*  651398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  651409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  651412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651466 */     GIR_RootConstrainSelectedInstOperands,
     /*  651467 */     // GIR_Coverage, 7078,
     /*  651467 */     GIR_EraseRootFromParent_Done,
     /*  651468 */   // Label 10412: @651468
     /*  651468 */   GIM_Try, /*On fail goto*//*Label 10413*/ GIMT_Encode4(651543), // Rule ID 7079 //
     /*  651473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  651484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  651487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  651490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651541 */     GIR_RootConstrainSelectedInstOperands,
     /*  651542 */     // GIR_Coverage, 7079,
     /*  651542 */     GIR_EraseRootFromParent_Done,
     /*  651543 */   // Label 10413: @651543
     /*  651543 */   GIM_Try, /*On fail goto*//*Label 10414*/ GIMT_Encode4(651618), // Rule ID 7082 //
     /*  651548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  651559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  651562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  651565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  651594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651616 */     GIR_RootConstrainSelectedInstOperands,
     /*  651617 */     // GIR_Coverage, 7082,
     /*  651617 */     GIR_EraseRootFromParent_Done,
     /*  651618 */   // Label 10414: @651618
     /*  651618 */   GIM_Try, /*On fail goto*//*Label 10415*/ GIMT_Encode4(651693), // Rule ID 7083 //
     /*  651623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  651634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  651637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  651640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  651669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2),
     /*  651672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  651688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651691 */     GIR_RootConstrainSelectedInstOperands,
     /*  651692 */     // GIR_Coverage, 7083,
     /*  651692 */     GIR_EraseRootFromParent_Done,
     /*  651693 */   // Label 10415: @651693
     /*  651693 */   GIM_Try, /*On fail goto*//*Label 10416*/ GIMT_Encode4(651768), // Rule ID 7086 //
     /*  651698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  651709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  651712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  651715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  651744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  651747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651766 */     GIR_RootConstrainSelectedInstOperands,
     /*  651767 */     // GIR_Coverage, 7086,
     /*  651767 */     GIR_EraseRootFromParent_Done,
     /*  651768 */   // Label 10416: @651768
     /*  651768 */   GIM_Try, /*On fail goto*//*Label 10417*/ GIMT_Encode4(651843), // Rule ID 7087 //
     /*  651773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  651784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  651787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  651790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11510:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  651819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  651822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  651838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651841 */     GIR_RootConstrainSelectedInstOperands,
     /*  651842 */     // GIR_Coverage, 7087,
     /*  651842 */     GIR_EraseRootFromParent_Done,
     /*  651843 */   // Label 10417: @651843
     /*  651843 */   GIM_Try, /*On fail goto*//*Label 10418*/ GIMT_Encode4(651918), // Rule ID 7090 //
     /*  651848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  651851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  651859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  651862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  651865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  651868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  651871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  651894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  651897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651916 */     GIR_RootConstrainSelectedInstOperands,
     /*  651917 */     // GIR_Coverage, 7090,
     /*  651917 */     GIR_EraseRootFromParent_Done,
     /*  651918 */   // Label 10418: @651918
     /*  651918 */   GIM_Try, /*On fail goto*//*Label 10419*/ GIMT_Encode4(651993), // Rule ID 7091 //
     /*  651923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  651926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  651931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  651934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  651937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  651940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  651943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  651946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  651958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  651962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  651969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11510:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  651969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  651972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  651974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  651976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  651978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  651980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  651985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  651988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  651991 */     GIR_RootConstrainSelectedInstOperands,
     /*  651992 */     // GIR_Coverage, 7091,
     /*  651992 */     GIR_EraseRootFromParent_Done,
     /*  651993 */   // Label 10419: @651993
     /*  651993 */   GIM_Try, /*On fail goto*//*Label 10420*/ GIMT_Encode4(652068), // Rule ID 7094 //
     /*  651998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  652044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652066 */     GIR_RootConstrainSelectedInstOperands,
     /*  652067 */     // GIR_Coverage, 7094,
     /*  652067 */     GIR_EraseRootFromParent_Done,
     /*  652068 */   // Label 10420: @652068
     /*  652068 */   GIM_Try, /*On fail goto*//*Label 10421*/ GIMT_Encode4(652143), // Rule ID 7095 //
     /*  652073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  652084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  652087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  652090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11510:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  652119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  652138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652141 */     GIR_RootConstrainSelectedInstOperands,
     /*  652142 */     // GIR_Coverage, 7095,
     /*  652142 */     GIR_EraseRootFromParent_Done,
     /*  652143 */   // Label 10421: @652143
     /*  652143 */   GIM_Try, /*On fail goto*//*Label 10422*/ GIMT_Encode4(652218), // Rule ID 7098 //
     /*  652148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  652151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  652194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652216 */     GIR_RootConstrainSelectedInstOperands,
     /*  652217 */     // GIR_Coverage, 7098,
     /*  652217 */     GIR_EraseRootFromParent_Done,
     /*  652218 */   // Label 10422: @652218
     /*  652218 */   GIM_Try, /*On fail goto*//*Label 10423*/ GIMT_Encode4(652293), // Rule ID 7099 //
     /*  652223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  652226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  652234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  652237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  652240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  652258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652269 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11510:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  652269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1),
     /*  652272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  652288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652291 */     GIR_RootConstrainSelectedInstOperands,
     /*  652292 */     // GIR_Coverage, 7099,
     /*  652292 */     GIR_EraseRootFromParent_Done,
     /*  652293 */   // Label 10423: @652293
     /*  652293 */   GIM_Try, /*On fail goto*//*Label 10424*/ GIMT_Encode4(652368), // Rule ID 7102 //
     /*  652298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652366 */     GIR_RootConstrainSelectedInstOperands,
     /*  652367 */     // GIR_Coverage, 7102,
     /*  652367 */     GIR_EraseRootFromParent_Done,
     /*  652368 */   // Label 10424: @652368
     /*  652368 */   GIM_Try, /*On fail goto*//*Label 10425*/ GIMT_Encode4(652443), // Rule ID 7103 //
     /*  652373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  652384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  652387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  652390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652419 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652441 */     GIR_RootConstrainSelectedInstOperands,
     /*  652442 */     // GIR_Coverage, 7103,
     /*  652442 */     GIR_EraseRootFromParent_Done,
     /*  652443 */   // Label 10425: @652443
     /*  652443 */   GIM_Try, /*On fail goto*//*Label 10426*/ GIMT_Encode4(652518), // Rule ID 7106 //
     /*  652448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  652459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  652462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  652465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  652497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652516 */     GIR_RootConstrainSelectedInstOperands,
     /*  652517 */     // GIR_Coverage, 7106,
     /*  652517 */     GIR_EraseRootFromParent_Done,
     /*  652518 */   // Label 10426: @652518
     /*  652518 */   GIM_Try, /*On fail goto*//*Label 10427*/ GIMT_Encode4(652593), // Rule ID 7107 //
     /*  652523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  652534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  652537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  652540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  652572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652591 */     GIR_RootConstrainSelectedInstOperands,
     /*  652592 */     // GIR_Coverage, 7107,
     /*  652592 */     GIR_EraseRootFromParent_Done,
     /*  652593 */   // Label 10427: @652593
     /*  652593 */   GIM_Try, /*On fail goto*//*Label 10428*/ GIMT_Encode4(652668), // Rule ID 7110 //
     /*  652598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  652609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  652612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  652615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  652644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  652647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652666 */     GIR_RootConstrainSelectedInstOperands,
     /*  652667 */     // GIR_Coverage, 7110,
     /*  652667 */     GIR_EraseRootFromParent_Done,
     /*  652668 */   // Label 10428: @652668
     /*  652668 */   GIM_Try, /*On fail goto*//*Label 10429*/ GIMT_Encode4(652743), // Rule ID 7111 //
     /*  652673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  652684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  652687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  652690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  652708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  652719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  652722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  652738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652741 */     GIR_RootConstrainSelectedInstOperands,
     /*  652742 */     // GIR_Coverage, 7111,
     /*  652742 */     GIR_EraseRootFromParent_Done,
     /*  652743 */   // Label 10429: @652743
     /*  652743 */   GIM_Try, /*On fail goto*//*Label 10430*/ GIMT_Encode4(652818), // Rule ID 7114 //
     /*  652748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  652759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  652762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  652765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652816 */     GIR_RootConstrainSelectedInstOperands,
     /*  652817 */     // GIR_Coverage, 7114,
     /*  652817 */     GIR_EraseRootFromParent_Done,
     /*  652818 */   // Label 10430: @652818
     /*  652818 */   GIM_Try, /*On fail goto*//*Label 10431*/ GIMT_Encode4(652893), // Rule ID 7115 //
     /*  652823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  652834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  652837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  652840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  652858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  652869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  652872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652891 */     GIR_RootConstrainSelectedInstOperands,
     /*  652892 */     // GIR_Coverage, 7115,
     /*  652892 */     GIR_EraseRootFromParent_Done,
     /*  652893 */   // Label 10431: @652893
     /*  652893 */   GIM_Try, /*On fail goto*//*Label 10432*/ GIMT_Encode4(652968), // Rule ID 7118 //
     /*  652898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  652901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  652909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  652912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  652915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  652918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  652921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  652933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  652937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  652944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  652944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  652947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  652949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  652951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  652953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  652955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  652960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  652963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  652966 */     GIR_RootConstrainSelectedInstOperands,
     /*  652967 */     // GIR_Coverage, 7118,
     /*  652967 */     GIR_EraseRootFromParent_Done,
     /*  652968 */   // Label 10432: @652968
     /*  652968 */   GIM_Try, /*On fail goto*//*Label 10433*/ GIMT_Encode4(653043), // Rule ID 7119 //
     /*  652973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  652976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  652981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  652984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  652987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  652990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  652993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  652996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653041 */     GIR_RootConstrainSelectedInstOperands,
     /*  653042 */     // GIR_Coverage, 7119,
     /*  653042 */     GIR_EraseRootFromParent_Done,
     /*  653043 */   // Label 10433: @653043
     /*  653043 */   GIM_Try, /*On fail goto*//*Label 10434*/ GIMT_Encode4(653118), // Rule ID 7122 //
     /*  653048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  653094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653116 */     GIR_RootConstrainSelectedInstOperands,
     /*  653117 */     // GIR_Coverage, 7122,
     /*  653117 */     GIR_EraseRootFromParent_Done,
     /*  653118 */   // Label 10434: @653118
     /*  653118 */   GIM_Try, /*On fail goto*//*Label 10435*/ GIMT_Encode4(653193), // Rule ID 7123 //
     /*  653123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  653134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  653137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  653140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  653169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  653188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653191 */     GIR_RootConstrainSelectedInstOperands,
     /*  653192 */     // GIR_Coverage, 7123,
     /*  653192 */     GIR_EraseRootFromParent_Done,
     /*  653193 */   // Label 10435: @653193
     /*  653193 */   GIM_Try, /*On fail goto*//*Label 10436*/ GIMT_Encode4(653268), // Rule ID 7126 //
     /*  653198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653266 */     GIR_RootConstrainSelectedInstOperands,
     /*  653267 */     // GIR_Coverage, 7126,
     /*  653267 */     GIR_EraseRootFromParent_Done,
     /*  653268 */   // Label 10436: @653268
     /*  653268 */   GIM_Try, /*On fail goto*//*Label 10437*/ GIMT_Encode4(653343), // Rule ID 7127 //
     /*  653273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  653284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  653287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  653290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653341 */     GIR_RootConstrainSelectedInstOperands,
     /*  653342 */     // GIR_Coverage, 7127,
     /*  653342 */     GIR_EraseRootFromParent_Done,
     /*  653343 */   // Label 10437: @653343
     /*  653343 */   GIM_Try, /*On fail goto*//*Label 10438*/ GIMT_Encode4(653418), // Rule ID 7130 //
     /*  653348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653416 */     GIR_RootConstrainSelectedInstOperands,
     /*  653417 */     // GIR_Coverage, 7130,
     /*  653417 */     GIR_EraseRootFromParent_Done,
     /*  653418 */   // Label 10438: @653418
     /*  653418 */   GIM_Try, /*On fail goto*//*Label 10439*/ GIMT_Encode4(653493), // Rule ID 7131 //
     /*  653423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  653434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  653437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  653440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653491 */     GIR_RootConstrainSelectedInstOperands,
     /*  653492 */     // GIR_Coverage, 7131,
     /*  653492 */     GIR_EraseRootFromParent_Done,
     /*  653493 */   // Label 10439: @653493
     /*  653493 */   GIM_Try, /*On fail goto*//*Label 10440*/ GIMT_Encode4(653568), // Rule ID 7134 //
     /*  653498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  653501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  653509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  653512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  653515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  653544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653566 */     GIR_RootConstrainSelectedInstOperands,
     /*  653567 */     // GIR_Coverage, 7134,
     /*  653567 */     GIR_EraseRootFromParent_Done,
     /*  653568 */   // Label 10440: @653568
     /*  653568 */   GIM_Try, /*On fail goto*//*Label 10441*/ GIMT_Encode4(653643), // Rule ID 7135 //
     /*  653573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  653576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  653584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  653587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  653590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  653619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  653638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653641 */     GIR_RootConstrainSelectedInstOperands,
     /*  653642 */     // GIR_Coverage, 7135,
     /*  653642 */     GIR_EraseRootFromParent_Done,
     /*  653643 */   // Label 10441: @653643
     /*  653643 */   GIM_Try, /*On fail goto*//*Label 10442*/ GIMT_Encode4(653718), // Rule ID 7138 //
     /*  653648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  653659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  653662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  653665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653716 */     GIR_RootConstrainSelectedInstOperands,
     /*  653717 */     // GIR_Coverage, 7138,
     /*  653717 */     GIR_EraseRootFromParent_Done,
     /*  653718 */   // Label 10442: @653718
     /*  653718 */   GIM_Try, /*On fail goto*//*Label 10443*/ GIMT_Encode4(653793), // Rule ID 7139 //
     /*  653723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  653734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  653737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  653740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  653758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11510:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2),
     /*  653772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653791 */     GIR_RootConstrainSelectedInstOperands,
     /*  653792 */     // GIR_Coverage, 7139,
     /*  653792 */     GIR_EraseRootFromParent_Done,
     /*  653793 */   // Label 10443: @653793
     /*  653793 */   GIM_Try, /*On fail goto*//*Label 10444*/ GIMT_Encode4(653868), // Rule ID 7142 //
     /*  653798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  653809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  653812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  653815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653866 */     GIR_RootConstrainSelectedInstOperands,
     /*  653867 */     // GIR_Coverage, 7142,
     /*  653867 */     GIR_EraseRootFromParent_Done,
     /*  653868 */   // Label 10444: @653868
     /*  653868 */   GIM_Try, /*On fail goto*//*Label 10445*/ GIMT_Encode4(653943), // Rule ID 7143 //
     /*  653873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  653876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  653884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  653887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  653890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  653893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  653896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  653908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11510:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  653919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4),
     /*  653922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  653926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  653928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  653930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  653935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  653938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  653941 */     GIR_RootConstrainSelectedInstOperands,
     /*  653942 */     // GIR_Coverage, 7143,
     /*  653942 */     GIR_EraseRootFromParent_Done,
     /*  653943 */   // Label 10445: @653943
     /*  653943 */   GIM_Try, /*On fail goto*//*Label 10446*/ GIMT_Encode4(654018), // Rule ID 7146 //
     /*  653948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  653951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  653956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  653959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  653962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  653965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  653968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  653971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  653983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  653987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  653994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  653994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  653997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  653999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654016 */     GIR_RootConstrainSelectedInstOperands,
     /*  654017 */     // GIR_Coverage, 7146,
     /*  654017 */     GIR_EraseRootFromParent_Done,
     /*  654018 */   // Label 10446: @654018
     /*  654018 */   GIM_Try, /*On fail goto*//*Label 10447*/ GIMT_Encode4(654093), // Rule ID 7147 //
     /*  654023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  654026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra),
     /*  654031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  654034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  654037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  654040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  654043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  654062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11510:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  654069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8),
     /*  654072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  654088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654091 */     GIR_RootConstrainSelectedInstOperands,
     /*  654092 */     // GIR_Coverage, 7147,
     /*  654092 */     GIR_EraseRootFromParent_Done,
     /*  654093 */   // Label 10447: @654093
     /*  654093 */   GIM_Try, /*On fail goto*//*Label 10448*/ GIMT_Encode4(654168), // Rule ID 7326 //
     /*  654098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654166 */     GIR_RootConstrainSelectedInstOperands,
     /*  654167 */     // GIR_Coverage, 7326,
     /*  654167 */     GIR_EraseRootFromParent_Done,
     /*  654168 */   // Label 10448: @654168
     /*  654168 */   GIM_Try, /*On fail goto*//*Label 10449*/ GIMT_Encode4(654243), // Rule ID 7327 //
     /*  654173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  654184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  654187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  654190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  654193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8),
     /*  654222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654241 */     GIR_RootConstrainSelectedInstOperands,
     /*  654242 */     // GIR_Coverage, 7327,
     /*  654242 */     GIR_EraseRootFromParent_Done,
     /*  654243 */   // Label 10449: @654243
     /*  654243 */   GIM_Try, /*On fail goto*//*Label 10450*/ GIMT_Encode4(654318), // Rule ID 7330 //
     /*  654248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654316 */     GIR_RootConstrainSelectedInstOperands,
     /*  654317 */     // GIR_Coverage, 7330,
     /*  654317 */     GIR_EraseRootFromParent_Done,
     /*  654318 */   // Label 10450: @654318
     /*  654318 */   GIM_Try, /*On fail goto*//*Label 10451*/ GIMT_Encode4(654393), // Rule ID 7331 //
     /*  654323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  654334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  654337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  654340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  654343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654369 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  654372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654391 */     GIR_RootConstrainSelectedInstOperands,
     /*  654392 */     // GIR_Coverage, 7331,
     /*  654392 */     GIR_EraseRootFromParent_Done,
     /*  654393 */   // Label 10451: @654393
     /*  654393 */   GIM_Try, /*On fail goto*//*Label 10452*/ GIMT_Encode4(654468), // Rule ID 7334 //
     /*  654398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  654409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  654412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  654418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  654447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654466 */     GIR_RootConstrainSelectedInstOperands,
     /*  654467 */     // GIR_Coverage, 7334,
     /*  654467 */     GIR_EraseRootFromParent_Done,
     /*  654468 */   // Label 10452: @654468
     /*  654468 */   GIM_Try, /*On fail goto*//*Label 10453*/ GIMT_Encode4(654543), // Rule ID 7335 //
     /*  654473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  654484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  654487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  654490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  654493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  654522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654541 */     GIR_RootConstrainSelectedInstOperands,
     /*  654542 */     // GIR_Coverage, 7335,
     /*  654542 */     GIR_EraseRootFromParent_Done,
     /*  654543 */   // Label 10453: @654543
     /*  654543 */   GIM_Try, /*On fail goto*//*Label 10454*/ GIMT_Encode4(654618), // Rule ID 7338 //
     /*  654548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  654559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  654562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  654565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  654568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654594 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  654597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654616 */     GIR_RootConstrainSelectedInstOperands,
     /*  654617 */     // GIR_Coverage, 7338,
     /*  654617 */     GIR_EraseRootFromParent_Done,
     /*  654618 */   // Label 10454: @654618
     /*  654618 */   GIM_Try, /*On fail goto*//*Label 10455*/ GIMT_Encode4(654693), // Rule ID 7339 //
     /*  654623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  654634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  654637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  654640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  654643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  654662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654669 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  654672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654691 */     GIR_RootConstrainSelectedInstOperands,
     /*  654692 */     // GIR_Coverage, 7339,
     /*  654692 */     GIR_EraseRootFromParent_Done,
     /*  654693 */   // Label 10455: @654693
     /*  654693 */   GIM_Try, /*On fail goto*//*Label 10456*/ GIMT_Encode4(654768), // Rule ID 7342 //
     /*  654698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  654709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  654712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  654718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  654747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654766 */     GIR_RootConstrainSelectedInstOperands,
     /*  654767 */     // GIR_Coverage, 7342,
     /*  654767 */     GIR_EraseRootFromParent_Done,
     /*  654768 */   // Label 10456: @654768
     /*  654768 */   GIM_Try, /*On fail goto*//*Label 10457*/ GIMT_Encode4(654843), // Rule ID 7343 //
     /*  654773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  654784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  654787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  654790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  654793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  654812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  654822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654841 */     GIR_RootConstrainSelectedInstOperands,
     /*  654842 */     // GIR_Coverage, 7343,
     /*  654842 */     GIR_EraseRootFromParent_Done,
     /*  654843 */   // Label 10457: @654843
     /*  654843 */   GIM_Try, /*On fail goto*//*Label 10458*/ GIMT_Encode4(654918), // Rule ID 7346 //
     /*  654848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  654851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  654859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  654862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  654868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  654871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  654894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  654897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654916 */     GIR_RootConstrainSelectedInstOperands,
     /*  654917 */     // GIR_Coverage, 7346,
     /*  654917 */     GIR_EraseRootFromParent_Done,
     /*  654918 */   // Label 10458: @654918
     /*  654918 */   GIM_Try, /*On fail goto*//*Label 10459*/ GIMT_Encode4(654993), // Rule ID 7347 //
     /*  654923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  654926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  654931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  654934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  654937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  654940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  654943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  654946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  654958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  654962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  654969 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  654969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  654972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  654974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  654976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  654978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  654980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  654985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  654988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  654991 */     GIR_RootConstrainSelectedInstOperands,
     /*  654992 */     // GIR_Coverage, 7347,
     /*  654992 */     GIR_EraseRootFromParent_Done,
     /*  654993 */   // Label 10459: @654993
     /*  654993 */   GIM_Try, /*On fail goto*//*Label 10460*/ GIMT_Encode4(655068), // Rule ID 7350 //
     /*  654998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655066 */     GIR_RootConstrainSelectedInstOperands,
     /*  655067 */     // GIR_Coverage, 7350,
     /*  655067 */     GIR_EraseRootFromParent_Done,
     /*  655068 */   // Label 10460: @655068
     /*  655068 */   GIM_Try, /*On fail goto*//*Label 10461*/ GIMT_Encode4(655143), // Rule ID 7351 //
     /*  655073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  655084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  655087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  655090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  655093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655119 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4),
     /*  655122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655141 */     GIR_RootConstrainSelectedInstOperands,
     /*  655142 */     // GIR_Coverage, 7351,
     /*  655142 */     GIR_EraseRootFromParent_Done,
     /*  655143 */   // Label 10461: @655143
     /*  655143 */   GIM_Try, /*On fail goto*//*Label 10462*/ GIMT_Encode4(655218), // Rule ID 7354 //
     /*  655148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655216 */     GIR_RootConstrainSelectedInstOperands,
     /*  655217 */     // GIR_Coverage, 7354,
     /*  655217 */     GIR_EraseRootFromParent_Done,
     /*  655218 */   // Label 10462: @655218
     /*  655218 */   GIM_Try, /*On fail goto*//*Label 10463*/ GIMT_Encode4(655293), // Rule ID 7355 //
     /*  655223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  655234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  655237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  655240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  655243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655269 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655291 */     GIR_RootConstrainSelectedInstOperands,
     /*  655292 */     // GIR_Coverage, 7355,
     /*  655292 */     GIR_EraseRootFromParent_Done,
     /*  655293 */   // Label 10463: @655293
     /*  655293 */   GIM_Try, /*On fail goto*//*Label 10464*/ GIMT_Encode4(655368), // Rule ID 7358 //
     /*  655298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655366 */     GIR_RootConstrainSelectedInstOperands,
     /*  655367 */     // GIR_Coverage, 7358,
     /*  655367 */     GIR_EraseRootFromParent_Done,
     /*  655368 */   // Label 10464: @655368
     /*  655368 */   GIM_Try, /*On fail goto*//*Label 10465*/ GIMT_Encode4(655443), // Rule ID 7359 //
     /*  655373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  655384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  655387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  655390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  655393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655419 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655441 */     GIR_RootConstrainSelectedInstOperands,
     /*  655442 */     // GIR_Coverage, 7359,
     /*  655442 */     GIR_EraseRootFromParent_Done,
     /*  655443 */   // Label 10465: @655443
     /*  655443 */   GIM_Try, /*On fail goto*//*Label 10466*/ GIMT_Encode4(655518), // Rule ID 7362 //
     /*  655448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  655468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655516 */     GIR_RootConstrainSelectedInstOperands,
     /*  655517 */     // GIR_Coverage, 7362,
     /*  655517 */     GIR_EraseRootFromParent_Done,
     /*  655518 */   // Label 10466: @655518
     /*  655518 */   GIM_Try, /*On fail goto*//*Label 10467*/ GIMT_Encode4(655593), // Rule ID 7363 //
     /*  655523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  655534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  655537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  655540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  655543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  655572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655591 */     GIR_RootConstrainSelectedInstOperands,
     /*  655592 */     // GIR_Coverage, 7363,
     /*  655592 */     GIR_EraseRootFromParent_Done,
     /*  655593 */   // Label 10467: @655593
     /*  655593 */   GIM_Try, /*On fail goto*//*Label 10468*/ GIMT_Encode4(655668), // Rule ID 7366 //
     /*  655598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  655601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  655609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  655612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  655615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  655618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  655644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655666 */     GIR_RootConstrainSelectedInstOperands,
     /*  655667 */     // GIR_Coverage, 7366,
     /*  655667 */     GIR_EraseRootFromParent_Done,
     /*  655668 */   // Label 10468: @655668
     /*  655668 */   GIM_Try, /*On fail goto*//*Label 10469*/ GIMT_Encode4(655743), // Rule ID 7367 //
     /*  655673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  655676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  655684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  655687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  655690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  655693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  655708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  655712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  655719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  655722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  655738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655741 */     GIR_RootConstrainSelectedInstOperands,
     /*  655742 */     // GIR_Coverage, 7367,
     /*  655742 */     GIR_EraseRootFromParent_Done,
     /*  655743 */   // Label 10469: @655743
     /*  655743 */   GIM_Try, /*On fail goto*//*Label 10470*/ GIMT_Encode4(655818), // Rule ID 7370 //
     /*  655748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  655751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  655765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  655768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  655794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655816 */     GIR_RootConstrainSelectedInstOperands,
     /*  655817 */     // GIR_Coverage, 7370,
     /*  655817 */     GIR_EraseRootFromParent_Done,
     /*  655818 */   // Label 10470: @655818
     /*  655818 */   GIM_Try, /*On fail goto*//*Label 10471*/ GIMT_Encode4(655893), // Rule ID 7371 //
     /*  655823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  655826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  655834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  655837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  655840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  655843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  655869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2),
     /*  655872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655891 */     GIR_RootConstrainSelectedInstOperands,
     /*  655892 */     // GIR_Coverage, 7371,
     /*  655892 */     GIR_EraseRootFromParent_Done,
     /*  655893 */   // Label 10471: @655893
     /*  655893 */   GIM_Try, /*On fail goto*//*Label 10472*/ GIMT_Encode4(655968), // Rule ID 7374 //
     /*  655898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  655901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  655909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  655912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  655915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  655918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  655921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  655933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  655937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  655944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  655944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  655947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  655949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  655951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  655953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  655955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  655960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  655963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  655966 */     GIR_RootConstrainSelectedInstOperands,
     /*  655967 */     // GIR_Coverage, 7374,
     /*  655967 */     GIR_EraseRootFromParent_Done,
     /*  655968 */   // Label 10472: @655968
     /*  655968 */   GIM_Try, /*On fail goto*//*Label 10473*/ GIMT_Encode4(656043), // Rule ID 7375 //
     /*  655973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  655976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  655981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  655984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  655987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  655990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  655993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  655996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1),
     /*  656022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656041 */     GIR_RootConstrainSelectedInstOperands,
     /*  656042 */     // GIR_Coverage, 7375,
     /*  656042 */     GIR_EraseRootFromParent_Done,
     /*  656043 */   // Label 10473: @656043
     /*  656043 */   GIM_Try, /*On fail goto*//*Label 10474*/ GIMT_Encode4(656118), // Rule ID 7378 //
     /*  656048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656116 */     GIR_RootConstrainSelectedInstOperands,
     /*  656117 */     // GIR_Coverage, 7378,
     /*  656117 */     GIR_EraseRootFromParent_Done,
     /*  656118 */   // Label 10474: @656118
     /*  656118 */   GIM_Try, /*On fail goto*//*Label 10475*/ GIMT_Encode4(656193), // Rule ID 7379 //
     /*  656123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  656134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  656137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  656140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  656143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2),
     /*  656172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656191 */     GIR_RootConstrainSelectedInstOperands,
     /*  656192 */     // GIR_Coverage, 7379,
     /*  656192 */     GIR_EraseRootFromParent_Done,
     /*  656193 */   // Label 10475: @656193
     /*  656193 */   GIM_Try, /*On fail goto*//*Label 10476*/ GIMT_Encode4(656268), // Rule ID 7382 //
     /*  656198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  656201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  656244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656266 */     GIR_RootConstrainSelectedInstOperands,
     /*  656267 */     // GIR_Coverage, 7382,
     /*  656267 */     GIR_EraseRootFromParent_Done,
     /*  656268 */   // Label 10476: @656268
     /*  656268 */   GIM_Try, /*On fail goto*//*Label 10477*/ GIMT_Encode4(656343), // Rule ID 7383 //
     /*  656273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  656276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  656284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  656287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  656290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  656293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  656308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656319 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  656319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4),
     /*  656322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  656338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656341 */     GIR_RootConstrainSelectedInstOperands,
     /*  656342 */     // GIR_Coverage, 7383,
     /*  656342 */     GIR_EraseRootFromParent_Done,
     /*  656343 */   // Label 10477: @656343
     /*  656343 */   GIM_Try, /*On fail goto*//*Label 10478*/ GIMT_Encode4(656418), // Rule ID 7386 //
     /*  656348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656416 */     GIR_RootConstrainSelectedInstOperands,
     /*  656417 */     // GIR_Coverage, 7386,
     /*  656417 */     GIR_EraseRootFromParent_Done,
     /*  656418 */   // Label 10478: @656418
     /*  656418 */   GIM_Try, /*On fail goto*//*Label 10479*/ GIMT_Encode4(656493), // Rule ID 7387 //
     /*  656423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  656434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  656437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  656440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656469 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8),
     /*  656472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656491 */     GIR_RootConstrainSelectedInstOperands,
     /*  656492 */     // GIR_Coverage, 7387,
     /*  656492 */     GIR_EraseRootFromParent_Done,
     /*  656493 */   // Label 10479: @656493
     /*  656493 */   GIM_Try, /*On fail goto*//*Label 10480*/ GIMT_Encode4(656568), // Rule ID 7390 //
     /*  656498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  656509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  656512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  656515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  656547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656566 */     GIR_RootConstrainSelectedInstOperands,
     /*  656567 */     // GIR_Coverage, 7390,
     /*  656567 */     GIR_EraseRootFromParent_Done,
     /*  656568 */   // Label 10480: @656568
     /*  656568 */   GIM_Try, /*On fail goto*//*Label 10481*/ GIMT_Encode4(656643), // Rule ID 7391 //
     /*  656573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  656584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  656587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  656590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656619 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  656622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656641 */     GIR_RootConstrainSelectedInstOperands,
     /*  656642 */     // GIR_Coverage, 7391,
     /*  656642 */     GIR_EraseRootFromParent_Done,
     /*  656643 */   // Label 10481: @656643
     /*  656643 */   GIM_Try, /*On fail goto*//*Label 10482*/ GIMT_Encode4(656718), // Rule ID 7394 //
     /*  656648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  656659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  656662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656694 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  656697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656716 */     GIR_RootConstrainSelectedInstOperands,
     /*  656717 */     // GIR_Coverage, 7394,
     /*  656717 */     GIR_EraseRootFromParent_Done,
     /*  656718 */   // Label 10482: @656718
     /*  656718 */   GIM_Try, /*On fail goto*//*Label 10483*/ GIMT_Encode4(656793), // Rule ID 7395 //
     /*  656723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  656734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  656737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  656740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656769 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  656772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656791 */     GIR_RootConstrainSelectedInstOperands,
     /*  656792 */     // GIR_Coverage, 7395,
     /*  656792 */     GIR_EraseRootFromParent_Done,
     /*  656793 */   // Label 10483: @656793
     /*  656793 */   GIM_Try, /*On fail goto*//*Label 10484*/ GIMT_Encode4(656868), // Rule ID 7398 //
     /*  656798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  656815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  656847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656866 */     GIR_RootConstrainSelectedInstOperands,
     /*  656867 */     // GIR_Coverage, 7398,
     /*  656867 */     GIR_EraseRootFromParent_Done,
     /*  656868 */   // Label 10484: @656868
     /*  656868 */   GIM_Try, /*On fail goto*//*Label 10485*/ GIMT_Encode4(656943), // Rule ID 7399 //
     /*  656873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  656876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  656884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  656887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  656890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  656893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  656896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  656904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11424:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  656919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  656922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  656926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  656928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  656930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  656935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  656938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  656941 */     GIR_RootConstrainSelectedInstOperands,
     /*  656942 */     // GIR_Coverage, 7399,
     /*  656942 */     GIR_EraseRootFromParent_Done,
     /*  656943 */   // Label 10485: @656943
     /*  656943 */   GIM_Try, /*On fail goto*//*Label 10486*/ GIMT_Encode4(657018), // Rule ID 7402 //
     /*  656948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  656951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  656956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  656959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  656962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  656965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  656968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  656971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  656979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  656983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  656987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  656994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  656994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  656997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  656999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657016 */     GIR_RootConstrainSelectedInstOperands,
     /*  657017 */     // GIR_Coverage, 7402,
     /*  657017 */     GIR_EraseRootFromParent_Done,
     /*  657018 */   // Label 10486: @657018
     /*  657018 */   GIM_Try, /*On fail goto*//*Label 10487*/ GIMT_Encode4(657093), // Rule ID 7403 //
     /*  657023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  657034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  657037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  657040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657091 */     GIR_RootConstrainSelectedInstOperands,
     /*  657092 */     // GIR_Coverage, 7403,
     /*  657092 */     GIR_EraseRootFromParent_Done,
     /*  657093 */   // Label 10487: @657093
     /*  657093 */   GIM_Try, /*On fail goto*//*Label 10488*/ GIMT_Encode4(657168), // Rule ID 7406 //
     /*  657098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657144 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  657144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657166 */     GIR_RootConstrainSelectedInstOperands,
     /*  657167 */     // GIR_Coverage, 7406,
     /*  657167 */     GIR_EraseRootFromParent_Done,
     /*  657168 */   // Label 10488: @657168
     /*  657168 */   GIM_Try, /*On fail goto*//*Label 10489*/ GIMT_Encode4(657243), // Rule ID 7407 //
     /*  657173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  657184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  657187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  657190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657219 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  657219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  657238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657241 */     GIR_RootConstrainSelectedInstOperands,
     /*  657242 */     // GIR_Coverage, 7407,
     /*  657242 */     GIR_EraseRootFromParent_Done,
     /*  657243 */   // Label 10489: @657243
     /*  657243 */   GIM_Try, /*On fail goto*//*Label 10490*/ GIMT_Encode4(657318), // Rule ID 7410 //
     /*  657248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657316 */     GIR_RootConstrainSelectedInstOperands,
     /*  657317 */     // GIR_Coverage, 7410,
     /*  657317 */     GIR_EraseRootFromParent_Done,
     /*  657318 */   // Label 10490: @657318
     /*  657318 */   GIM_Try, /*On fail goto*//*Label 10491*/ GIMT_Encode4(657393), // Rule ID 7411 //
     /*  657323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  657334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  657337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  657340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4),
     /*  657372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657391 */     GIR_RootConstrainSelectedInstOperands,
     /*  657392 */     // GIR_Coverage, 7411,
     /*  657392 */     GIR_EraseRootFromParent_Done,
     /*  657393 */   // Label 10491: @657393
     /*  657393 */   GIM_Try, /*On fail goto*//*Label 10492*/ GIMT_Encode4(657468), // Rule ID 7414 //
     /*  657398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657466 */     GIR_RootConstrainSelectedInstOperands,
     /*  657467 */     // GIR_Coverage, 7414,
     /*  657467 */     GIR_EraseRootFromParent_Done,
     /*  657468 */   // Label 10492: @657468
     /*  657468 */   GIM_Try, /*On fail goto*//*Label 10493*/ GIMT_Encode4(657543), // Rule ID 7415 //
     /*  657473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  657484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  657487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  657490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  657522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657541 */     GIR_RootConstrainSelectedInstOperands,
     /*  657542 */     // GIR_Coverage, 7415,
     /*  657542 */     GIR_EraseRootFromParent_Done,
     /*  657543 */   // Label 10493: @657543
     /*  657543 */   GIM_Try, /*On fail goto*//*Label 10494*/ GIMT_Encode4(657618), // Rule ID 7418 //
     /*  657548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  657559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  657562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657616 */     GIR_RootConstrainSelectedInstOperands,
     /*  657617 */     // GIR_Coverage, 7418,
     /*  657617 */     GIR_EraseRootFromParent_Done,
     /*  657618 */   // Label 10494: @657618
     /*  657618 */   GIM_Try, /*On fail goto*//*Label 10495*/ GIMT_Encode4(657693), // Rule ID 7419 //
     /*  657623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  657634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  657637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  657640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  657654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11424:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  657672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657691 */     GIR_RootConstrainSelectedInstOperands,
     /*  657692 */     // GIR_Coverage, 7419,
     /*  657692 */     GIR_EraseRootFromParent_Done,
     /*  657693 */   // Label 10495: @657693
     /*  657693 */   GIM_Try, /*On fail goto*//*Label 10496*/ GIMT_Encode4(657768), // Rule ID 7422 //
     /*  657698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657766 */     GIR_RootConstrainSelectedInstOperands,
     /*  657767 */     // GIR_Coverage, 7422,
     /*  657767 */     GIR_EraseRootFromParent_Done,
     /*  657768 */   // Label 10496: @657768
     /*  657768 */   GIM_Try, /*On fail goto*//*Label 10497*/ GIMT_Encode4(657843), // Rule ID 7423 //
     /*  657773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  657784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  657787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  657790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  657804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  657822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657841 */     GIR_RootConstrainSelectedInstOperands,
     /*  657842 */     // GIR_Coverage, 7423,
     /*  657842 */     GIR_EraseRootFromParent_Done,
     /*  657843 */   // Label 10497: @657843
     /*  657843 */   GIM_Try, /*On fail goto*//*Label 10498*/ GIMT_Encode4(657918), // Rule ID 7426 //
     /*  657848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  657851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  657868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  657871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  657894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657916 */     GIR_RootConstrainSelectedInstOperands,
     /*  657917 */     // GIR_Coverage, 7426,
     /*  657917 */     GIR_EraseRootFromParent_Done,
     /*  657918 */   // Label 10498: @657918
     /*  657918 */   GIM_Try, /*On fail goto*//*Label 10499*/ GIMT_Encode4(657993), // Rule ID 7427 //
     /*  657923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  657926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  657931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  657934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  657937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  657940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  657943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  657946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  657954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  657958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  657962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  657969 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  657969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  657972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  657974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  657976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  657978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  657980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  657985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  657988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  657991 */     GIR_RootConstrainSelectedInstOperands,
     /*  657992 */     // GIR_Coverage, 7427,
     /*  657992 */     GIR_EraseRootFromParent_Done,
     /*  657993 */   // Label 10499: @657993
     /*  657993 */   GIM_Try, /*On fail goto*//*Label 10500*/ GIMT_Encode4(658068), // Rule ID 7430 //
     /*  657998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658044 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658066 */     GIR_RootConstrainSelectedInstOperands,
     /*  658067 */     // GIR_Coverage, 7430,
     /*  658067 */     GIR_EraseRootFromParent_Done,
     /*  658068 */   // Label 10500: @658068
     /*  658068 */   GIM_Try, /*On fail goto*//*Label 10501*/ GIMT_Encode4(658143), // Rule ID 7431 //
     /*  658073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  658084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  658087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  658090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658119 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2),
     /*  658122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658141 */     GIR_RootConstrainSelectedInstOperands,
     /*  658142 */     // GIR_Coverage, 7431,
     /*  658142 */     GIR_EraseRootFromParent_Done,
     /*  658143 */   // Label 10501: @658143
     /*  658143 */   GIM_Try, /*On fail goto*//*Label 10502*/ GIMT_Encode4(658218), // Rule ID 7434 //
     /*  658148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658216 */     GIR_RootConstrainSelectedInstOperands,
     /*  658217 */     // GIR_Coverage, 7434,
     /*  658217 */     GIR_EraseRootFromParent_Done,
     /*  658218 */   // Label 10502: @658218
     /*  658218 */   GIM_Try, /*On fail goto*//*Label 10503*/ GIMT_Encode4(658293), // Rule ID 7435 //
     /*  658223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  658234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  658237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  658240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658269 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11424:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1),
     /*  658272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658291 */     GIR_RootConstrainSelectedInstOperands,
     /*  658292 */     // GIR_Coverage, 7435,
     /*  658292 */     GIR_EraseRootFromParent_Done,
     /*  658293 */   // Label 10503: @658293
     /*  658293 */   GIM_Try, /*On fail goto*//*Label 10504*/ GIMT_Encode4(658368), // Rule ID 7438 //
     /*  658298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658366 */     GIR_RootConstrainSelectedInstOperands,
     /*  658367 */     // GIR_Coverage, 7438,
     /*  658367 */     GIR_EraseRootFromParent_Done,
     /*  658368 */   // Label 10504: @658368
     /*  658368 */   GIM_Try, /*On fail goto*//*Label 10505*/ GIMT_Encode4(658443), // Rule ID 7439 //
     /*  658373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  658384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  658387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  658390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  658404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11424:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2),
     /*  658422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658441 */     GIR_RootConstrainSelectedInstOperands,
     /*  658442 */     // GIR_Coverage, 7439,
     /*  658442 */     GIR_EraseRootFromParent_Done,
     /*  658443 */   // Label 10505: @658443
     /*  658443 */   GIM_Try, /*On fail goto*//*Label 10506*/ GIMT_Encode4(658518), // Rule ID 7442 //
     /*  658448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  658451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  658468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  658494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658516 */     GIR_RootConstrainSelectedInstOperands,
     /*  658517 */     // GIR_Coverage, 7442,
     /*  658517 */     GIR_EraseRootFromParent_Done,
     /*  658518 */   // Label 10506: @658518
     /*  658518 */   GIM_Try, /*On fail goto*//*Label 10507*/ GIMT_Encode4(658593), // Rule ID 7443 //
     /*  658523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  658526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl),
     /*  658531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  658534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  658537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  658540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  658543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  658554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  658558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  658562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11424:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRL_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  658569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4),
     /*  658572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  658588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658591 */     GIR_RootConstrainSelectedInstOperands,
     /*  658592 */     // GIR_Coverage, 7443,
     /*  658592 */     GIR_EraseRootFromParent_Done,
     /*  658593 */   // Label 10507: @658593
     /*  658593 */   GIM_Try, /*On fail goto*//*Label 10508*/ GIMT_Encode4(658668), // Rule ID 7506 //
     /*  658598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  658647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658666 */     GIR_RootConstrainSelectedInstOperands,
     /*  658667 */     // GIR_Coverage, 7506,
     /*  658667 */     GIR_EraseRootFromParent_Done,
     /*  658668 */   // Label 10508: @658668
     /*  658668 */   GIM_Try, /*On fail goto*//*Label 10509*/ GIMT_Encode4(658743), // Rule ID 7507 //
     /*  658673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  658684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  658687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  658690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  658693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8),
     /*  658722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658741 */     GIR_RootConstrainSelectedInstOperands,
     /*  658742 */     // GIR_Coverage, 7507,
     /*  658742 */     GIR_EraseRootFromParent_Done,
     /*  658743 */   // Label 10509: @658743
     /*  658743 */   GIM_Try, /*On fail goto*//*Label 10510*/ GIMT_Encode4(658818), // Rule ID 7510 //
     /*  658748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  658797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658816 */     GIR_RootConstrainSelectedInstOperands,
     /*  658817 */     // GIR_Coverage, 7510,
     /*  658817 */     GIR_EraseRootFromParent_Done,
     /*  658818 */   // Label 10510: @658818
     /*  658818 */   GIM_Try, /*On fail goto*//*Label 10511*/ GIMT_Encode4(658893), // Rule ID 7511 //
     /*  658823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  658834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  658837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  658840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  658843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658869 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  658869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  658872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658891 */     GIR_RootConstrainSelectedInstOperands,
     /*  658892 */     // GIR_Coverage, 7511,
     /*  658892 */     GIR_EraseRootFromParent_Done,
     /*  658893 */   // Label 10511: @658893
     /*  658893 */   GIM_Try, /*On fail goto*//*Label 10512*/ GIMT_Encode4(658968), // Rule ID 7514 //
     /*  658898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  658901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  658921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  658937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  658944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  658944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  658947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  658949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  658951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  658953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  658955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  658960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  658963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  658966 */     GIR_RootConstrainSelectedInstOperands,
     /*  658967 */     // GIR_Coverage, 7514,
     /*  658967 */     GIR_EraseRootFromParent_Done,
     /*  658968 */   // Label 10512: @658968
     /*  658968 */   GIM_Try, /*On fail goto*//*Label 10513*/ GIMT_Encode4(659043), // Rule ID 7515 //
     /*  658973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  658976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  658981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  658984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  658987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  658990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  658993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  658996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659041 */     GIR_RootConstrainSelectedInstOperands,
     /*  659042 */     // GIR_Coverage, 7515,
     /*  659042 */     GIR_EraseRootFromParent_Done,
     /*  659043 */   // Label 10513: @659043
     /*  659043 */   GIM_Try, /*On fail goto*//*Label 10514*/ GIMT_Encode4(659118), // Rule ID 7518 //
     /*  659048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659094 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659116 */     GIR_RootConstrainSelectedInstOperands,
     /*  659117 */     // GIR_Coverage, 7518,
     /*  659117 */     GIR_EraseRootFromParent_Done,
     /*  659118 */   // Label 10514: @659118
     /*  659118 */   GIM_Try, /*On fail goto*//*Label 10515*/ GIMT_Encode4(659193), // Rule ID 7519 //
     /*  659123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  659134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  659137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  659140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  659143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659169 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659191 */     GIR_RootConstrainSelectedInstOperands,
     /*  659192 */     // GIR_Coverage, 7519,
     /*  659192 */     GIR_EraseRootFromParent_Done,
     /*  659193 */   // Label 10515: @659193
     /*  659193 */   GIM_Try, /*On fail goto*//*Label 10516*/ GIMT_Encode4(659268), // Rule ID 7522 //
     /*  659198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659266 */     GIR_RootConstrainSelectedInstOperands,
     /*  659267 */     // GIR_Coverage, 7522,
     /*  659267 */     GIR_EraseRootFromParent_Done,
     /*  659268 */   // Label 10516: @659268
     /*  659268 */   GIM_Try, /*On fail goto*//*Label 10517*/ GIMT_Encode4(659343), // Rule ID 7523 //
     /*  659273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  659284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  659287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  659290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  659293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659341 */     GIR_RootConstrainSelectedInstOperands,
     /*  659342 */     // GIR_Coverage, 7523,
     /*  659342 */     GIR_EraseRootFromParent_Done,
     /*  659343 */   // Label 10517: @659343
     /*  659343 */   GIM_Try, /*On fail goto*//*Label 10518*/ GIMT_Encode4(659418), // Rule ID 7526 //
     /*  659348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  659394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659416 */     GIR_RootConstrainSelectedInstOperands,
     /*  659417 */     // GIR_Coverage, 7526,
     /*  659417 */     GIR_EraseRootFromParent_Done,
     /*  659418 */   // Label 10518: @659418
     /*  659418 */   GIM_Try, /*On fail goto*//*Label 10519*/ GIMT_Encode4(659493), // Rule ID 7527 //
     /*  659423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  659434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  659437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  659440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  659443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  659458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  659469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  659472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  659488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659491 */     GIR_RootConstrainSelectedInstOperands,
     /*  659492 */     // GIR_Coverage, 7527,
     /*  659492 */     GIR_EraseRootFromParent_Done,
     /*  659493 */   // Label 10519: @659493
     /*  659493 */   GIM_Try, /*On fail goto*//*Label 10520*/ GIMT_Encode4(659568), // Rule ID 7530 //
     /*  659498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659566 */     GIR_RootConstrainSelectedInstOperands,
     /*  659567 */     // GIR_Coverage, 7530,
     /*  659567 */     GIR_EraseRootFromParent_Done,
     /*  659568 */   // Label 10520: @659568
     /*  659568 */   GIM_Try, /*On fail goto*//*Label 10521*/ GIMT_Encode4(659643), // Rule ID 7531 //
     /*  659573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  659584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  659587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  659590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  659593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659619 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4),
     /*  659622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659641 */     GIR_RootConstrainSelectedInstOperands,
     /*  659642 */     // GIR_Coverage, 7531,
     /*  659642 */     GIR_EraseRootFromParent_Done,
     /*  659643 */   // Label 10521: @659643
     /*  659643 */   GIM_Try, /*On fail goto*//*Label 10522*/ GIMT_Encode4(659718), // Rule ID 7534 //
     /*  659648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659716 */     GIR_RootConstrainSelectedInstOperands,
     /*  659717 */     // GIR_Coverage, 7534,
     /*  659717 */     GIR_EraseRootFromParent_Done,
     /*  659718 */   // Label 10522: @659718
     /*  659718 */   GIM_Try, /*On fail goto*//*Label 10523*/ GIMT_Encode4(659793), // Rule ID 7535 //
     /*  659723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  659734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  659737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  659740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  659743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659769 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  659772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659791 */     GIR_RootConstrainSelectedInstOperands,
     /*  659792 */     // GIR_Coverage, 7535,
     /*  659792 */     GIR_EraseRootFromParent_Done,
     /*  659793 */   // Label 10523: @659793
     /*  659793 */   GIM_Try, /*On fail goto*//*Label 10524*/ GIMT_Encode4(659868), // Rule ID 7538 //
     /*  659798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659844 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659866 */     GIR_RootConstrainSelectedInstOperands,
     /*  659867 */     // GIR_Coverage, 7538,
     /*  659867 */     GIR_EraseRootFromParent_Done,
     /*  659868 */   // Label 10524: @659868
     /*  659868 */   GIM_Try, /*On fail goto*//*Label 10525*/ GIMT_Encode4(659943), // Rule ID 7539 //
     /*  659873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  659876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  659884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  659887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  659890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  659893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  659896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  659912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  659919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  659922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  659926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  659928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  659930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  659935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  659938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  659941 */     GIR_RootConstrainSelectedInstOperands,
     /*  659942 */     // GIR_Coverage, 7539,
     /*  659942 */     GIR_EraseRootFromParent_Done,
     /*  659943 */   // Label 10525: @659943
     /*  659943 */   GIM_Try, /*On fail goto*//*Label 10526*/ GIMT_Encode4(660018), // Rule ID 7542 //
     /*  659948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  659951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  659956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  659959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  659962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  659965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  659968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  659971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  659983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  659987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  659994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  659994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  659997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  659999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660016 */     GIR_RootConstrainSelectedInstOperands,
     /*  660017 */     // GIR_Coverage, 7542,
     /*  660017 */     GIR_EraseRootFromParent_Done,
     /*  660018 */   // Label 10526: @660018
     /*  660018 */   GIM_Try, /*On fail goto*//*Label 10527*/ GIMT_Encode4(660093), // Rule ID 7543 //
     /*  660023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  660034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  660037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  660040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  660043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660091 */     GIR_RootConstrainSelectedInstOperands,
     /*  660092 */     // GIR_Coverage, 7543,
     /*  660092 */     GIR_EraseRootFromParent_Done,
     /*  660093 */   // Label 10527: @660093
     /*  660093 */   GIM_Try, /*On fail goto*//*Label 10528*/ GIMT_Encode4(660168), // Rule ID 7546 //
     /*  660098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  660144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660166 */     GIR_RootConstrainSelectedInstOperands,
     /*  660167 */     // GIR_Coverage, 7546,
     /*  660167 */     GIR_EraseRootFromParent_Done,
     /*  660168 */   // Label 10528: @660168
     /*  660168 */   GIM_Try, /*On fail goto*//*Label 10529*/ GIMT_Encode4(660243), // Rule ID 7547 //
     /*  660173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  660184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  660187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  660190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  660193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  660219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  660238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660241 */     GIR_RootConstrainSelectedInstOperands,
     /*  660242 */     // GIR_Coverage, 7547,
     /*  660242 */     GIR_EraseRootFromParent_Done,
     /*  660243 */   // Label 10529: @660243
     /*  660243 */   GIM_Try, /*On fail goto*//*Label 10530*/ GIMT_Encode4(660318), // Rule ID 7550 //
     /*  660248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660316 */     GIR_RootConstrainSelectedInstOperands,
     /*  660317 */     // GIR_Coverage, 7550,
     /*  660317 */     GIR_EraseRootFromParent_Done,
     /*  660318 */   // Label 10530: @660318
     /*  660318 */   GIM_Try, /*On fail goto*//*Label 10531*/ GIMT_Encode4(660393), // Rule ID 7551 //
     /*  660323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  660334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  660337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  660340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  660343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2),
     /*  660372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660391 */     GIR_RootConstrainSelectedInstOperands,
     /*  660392 */     // GIR_Coverage, 7551,
     /*  660392 */     GIR_EraseRootFromParent_Done,
     /*  660393 */   // Label 10531: @660393
     /*  660393 */   GIM_Try, /*On fail goto*//*Label 10532*/ GIMT_Encode4(660468), // Rule ID 7554 //
     /*  660398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660466 */     GIR_RootConstrainSelectedInstOperands,
     /*  660467 */     // GIR_Coverage, 7554,
     /*  660467 */     GIR_EraseRootFromParent_Done,
     /*  660468 */   // Label 10532: @660468
     /*  660468 */   GIM_Try, /*On fail goto*//*Label 10533*/ GIMT_Encode4(660543), // Rule ID 7555 //
     /*  660473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  660484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  660487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  660490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  660493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1),
     /*  660522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660541 */     GIR_RootConstrainSelectedInstOperands,
     /*  660542 */     // GIR_Coverage, 7555,
     /*  660542 */     GIR_EraseRootFromParent_Done,
     /*  660543 */   // Label 10533: @660543
     /*  660543 */   GIM_Try, /*On fail goto*//*Label 10534*/ GIMT_Encode4(660618), // Rule ID 7558 //
     /*  660548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660616 */     GIR_RootConstrainSelectedInstOperands,
     /*  660617 */     // GIR_Coverage, 7558,
     /*  660617 */     GIR_EraseRootFromParent_Done,
     /*  660618 */   // Label 10534: @660618
     /*  660618 */   GIM_Try, /*On fail goto*//*Label 10535*/ GIMT_Encode4(660693), // Rule ID 7559 //
     /*  660623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  660634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  660637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  660640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  660643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  660662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2),
     /*  660672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660691 */     GIR_RootConstrainSelectedInstOperands,
     /*  660692 */     // GIR_Coverage, 7559,
     /*  660692 */     GIR_EraseRootFromParent_Done,
     /*  660693 */   // Label 10535: @660693
     /*  660693 */   GIM_Try, /*On fail goto*//*Label 10536*/ GIMT_Encode4(660768), // Rule ID 7562 //
     /*  660698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  660701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660744 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  660744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660766 */     GIR_RootConstrainSelectedInstOperands,
     /*  660767 */     // GIR_Coverage, 7562,
     /*  660767 */     GIR_EraseRootFromParent_Done,
     /*  660768 */   // Label 10536: @660768
     /*  660768 */   GIM_Try, /*On fail goto*//*Label 10537*/ GIMT_Encode4(660843), // Rule ID 7563 //
     /*  660773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  660776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  660784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  660787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  660790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  660793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  660808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  660812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660819 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  660819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4),
     /*  660822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  660838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660841 */     GIR_RootConstrainSelectedInstOperands,
     /*  660842 */     // GIR_Coverage, 7563,
     /*  660842 */     GIR_EraseRootFromParent_Done,
     /*  660843 */   // Label 10537: @660843
     /*  660843 */   GIM_Try, /*On fail goto*//*Label 10538*/ GIMT_Encode4(660918), // Rule ID 7566 //
     /*  660848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  660851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  660868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  660871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660894 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  660894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  660897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660916 */     GIR_RootConstrainSelectedInstOperands,
     /*  660917 */     // GIR_Coverage, 7566,
     /*  660917 */     GIR_EraseRootFromParent_Done,
     /*  660918 */   // Label 10538: @660918
     /*  660918 */   GIM_Try, /*On fail goto*//*Label 10539*/ GIMT_Encode4(660993), // Rule ID 7567 //
     /*  660923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  660926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  660931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  660934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  660937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  660940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  660943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  660946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  660958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  660962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  660969 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  660969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8),
     /*  660972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  660974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  660976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  660978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  660980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  660985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  660988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  660991 */     GIR_RootConstrainSelectedInstOperands,
     /*  660992 */     // GIR_Coverage, 7567,
     /*  660992 */     GIR_EraseRootFromParent_Done,
     /*  660993 */   // Label 10539: @660993
     /*  660993 */   GIM_Try, /*On fail goto*//*Label 10540*/ GIMT_Encode4(661068), // Rule ID 7570 //
     /*  660998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661066 */     GIR_RootConstrainSelectedInstOperands,
     /*  661067 */     // GIR_Coverage, 7570,
     /*  661067 */     GIR_EraseRootFromParent_Done,
     /*  661068 */   // Label 10540: @661068
     /*  661068 */   GIM_Try, /*On fail goto*//*Label 10541*/ GIMT_Encode4(661143), // Rule ID 7571 //
     /*  661073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  661084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  661087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  661090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661119 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661141 */     GIR_RootConstrainSelectedInstOperands,
     /*  661142 */     // GIR_Coverage, 7571,
     /*  661142 */     GIR_EraseRootFromParent_Done,
     /*  661143 */   // Label 10541: @661143
     /*  661143 */   GIM_Try, /*On fail goto*//*Label 10542*/ GIMT_Encode4(661218), // Rule ID 7574 //
     /*  661148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661194 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661216 */     GIR_RootConstrainSelectedInstOperands,
     /*  661217 */     // GIR_Coverage, 7574,
     /*  661217 */     GIR_EraseRootFromParent_Done,
     /*  661218 */   // Label 10542: @661218
     /*  661218 */   GIM_Try, /*On fail goto*//*Label 10543*/ GIMT_Encode4(661293), // Rule ID 7575 //
     /*  661223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  661234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  661237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  661240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661269 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661291 */     GIR_RootConstrainSelectedInstOperands,
     /*  661292 */     // GIR_Coverage, 7575,
     /*  661292 */     GIR_EraseRootFromParent_Done,
     /*  661293 */   // Label 10543: @661293
     /*  661293 */   GIM_Try, /*On fail goto*//*Label 10544*/ GIMT_Encode4(661368), // Rule ID 7578 //
     /*  661298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661366 */     GIR_RootConstrainSelectedInstOperands,
     /*  661367 */     // GIR_Coverage, 7578,
     /*  661367 */     GIR_EraseRootFromParent_Done,
     /*  661368 */   // Label 10544: @661368
     /*  661368 */   GIM_Try, /*On fail goto*//*Label 10545*/ GIMT_Encode4(661443), // Rule ID 7579 //
     /*  661373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  661384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  661387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  661390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11422:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  661422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661441 */     GIR_RootConstrainSelectedInstOperands,
     /*  661442 */     // GIR_Coverage, 7579,
     /*  661442 */     GIR_EraseRootFromParent_Done,
     /*  661443 */   // Label 10545: @661443
     /*  661443 */   GIM_Try, /*On fail goto*//*Label 10546*/ GIMT_Encode4(661518), // Rule ID 7582 //
     /*  661448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  661497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661516 */     GIR_RootConstrainSelectedInstOperands,
     /*  661517 */     // GIR_Coverage, 7582,
     /*  661517 */     GIR_EraseRootFromParent_Done,
     /*  661518 */   // Label 10546: @661518
     /*  661518 */   GIM_Try, /*On fail goto*//*Label 10547*/ GIMT_Encode4(661593), // Rule ID 7583 //
     /*  661523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  661534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  661537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  661540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  661554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661569 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  661572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661591 */     GIR_RootConstrainSelectedInstOperands,
     /*  661592 */     // GIR_Coverage, 7583,
     /*  661592 */     GIR_EraseRootFromParent_Done,
     /*  661593 */   // Label 10547: @661593
     /*  661593 */   GIM_Try, /*On fail goto*//*Label 10548*/ GIMT_Encode4(661668), // Rule ID 7586 //
     /*  661598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  661644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  661647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661666 */     GIR_RootConstrainSelectedInstOperands,
     /*  661667 */     // GIR_Coverage, 7586,
     /*  661667 */     GIR_EraseRootFromParent_Done,
     /*  661668 */   // Label 10548: @661668
     /*  661668 */   GIM_Try, /*On fail goto*//*Label 10549*/ GIMT_Encode4(661743), // Rule ID 7587 //
     /*  661673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  661684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  661687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  661690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  661704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  661708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661719 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  661719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  661722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  661738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661741 */     GIR_RootConstrainSelectedInstOperands,
     /*  661742 */     // GIR_Coverage, 7587,
     /*  661742 */     GIR_EraseRootFromParent_Done,
     /*  661743 */   // Label 10549: @661743
     /*  661743 */   GIM_Try, /*On fail goto*//*Label 10550*/ GIMT_Encode4(661818), // Rule ID 7590 //
     /*  661748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661816 */     GIR_RootConstrainSelectedInstOperands,
     /*  661817 */     // GIR_Coverage, 7590,
     /*  661817 */     GIR_EraseRootFromParent_Done,
     /*  661818 */   // Label 10550: @661818
     /*  661818 */   GIM_Try, /*On fail goto*//*Label 10551*/ GIMT_Encode4(661893), // Rule ID 7591 //
     /*  661823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  661834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  661837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  661840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  661869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4),
     /*  661872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661891 */     GIR_RootConstrainSelectedInstOperands,
     /*  661892 */     // GIR_Coverage, 7591,
     /*  661892 */     GIR_EraseRootFromParent_Done,
     /*  661893 */   // Label 10551: @661893
     /*  661893 */   GIM_Try, /*On fail goto*//*Label 10552*/ GIMT_Encode4(661968), // Rule ID 7594 //
     /*  661898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  661901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  661918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  661921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  661933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  661937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  661944 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  661944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  661947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  661949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  661951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  661953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  661955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  661960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  661963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  661966 */     GIR_RootConstrainSelectedInstOperands,
     /*  661967 */     // GIR_Coverage, 7594,
     /*  661967 */     GIR_EraseRootFromParent_Done,
     /*  661968 */   // Label 10552: @661968
     /*  661968 */   GIM_Try, /*On fail goto*//*Label 10553*/ GIMT_Encode4(662043), // Rule ID 7595 //
     /*  661973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  661976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  661981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  661984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  661987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  661990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  661993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  661996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662041 */     GIR_RootConstrainSelectedInstOperands,
     /*  662042 */     // GIR_Coverage, 7595,
     /*  662042 */     GIR_EraseRootFromParent_Done,
     /*  662043 */   // Label 10553: @662043
     /*  662043 */   GIM_Try, /*On fail goto*//*Label 10554*/ GIMT_Encode4(662118), // Rule ID 7598 //
     /*  662048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662116 */     GIR_RootConstrainSelectedInstOperands,
     /*  662117 */     // GIR_Coverage, 7598,
     /*  662117 */     GIR_EraseRootFromParent_Done,
     /*  662118 */   // Label 10554: @662118
     /*  662118 */   GIM_Try, /*On fail goto*//*Label 10555*/ GIMT_Encode4(662193), // Rule ID 7599 //
     /*  662123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  662134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  662137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  662140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662169 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11422:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662191 */     GIR_RootConstrainSelectedInstOperands,
     /*  662192 */     // GIR_Coverage, 7599,
     /*  662192 */     GIR_EraseRootFromParent_Done,
     /*  662193 */   // Label 10555: @662193
     /*  662193 */   GIM_Try, /*On fail goto*//*Label 10556*/ GIMT_Encode4(662268), // Rule ID 7602 //
     /*  662198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662266 */     GIR_RootConstrainSelectedInstOperands,
     /*  662267 */     // GIR_Coverage, 7602,
     /*  662267 */     GIR_EraseRootFromParent_Done,
     /*  662268 */   // Label 10556: @662268
     /*  662268 */   GIM_Try, /*On fail goto*//*Label 10557*/ GIMT_Encode4(662343), // Rule ID 7603 //
     /*  662273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  662284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  662287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  662290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662319 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662341 */     GIR_RootConstrainSelectedInstOperands,
     /*  662342 */     // GIR_Coverage, 7603,
     /*  662342 */     GIR_EraseRootFromParent_Done,
     /*  662343 */   // Label 10557: @662343
     /*  662343 */   GIM_Try, /*On fail goto*//*Label 10558*/ GIMT_Encode4(662418), // Rule ID 7606 //
     /*  662348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  662351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  662394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662416 */     GIR_RootConstrainSelectedInstOperands,
     /*  662417 */     // GIR_Coverage, 7606,
     /*  662417 */     GIR_EraseRootFromParent_Done,
     /*  662418 */   // Label 10558: @662418
     /*  662418 */   GIM_Try, /*On fail goto*//*Label 10559*/ GIMT_Encode4(662493), // Rule ID 7607 //
     /*  662423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  662426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  662434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  662437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  662440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662469 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  662469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  662488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662491 */     GIR_RootConstrainSelectedInstOperands,
     /*  662492 */     // GIR_Coverage, 7607,
     /*  662492 */     GIR_EraseRootFromParent_Done,
     /*  662493 */   // Label 10559: @662493
     /*  662493 */   GIM_Try, /*On fail goto*//*Label 10560*/ GIMT_Encode4(662568), // Rule ID 7610 //
     /*  662498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662566 */     GIR_RootConstrainSelectedInstOperands,
     /*  662567 */     // GIR_Coverage, 7610,
     /*  662567 */     GIR_EraseRootFromParent_Done,
     /*  662568 */   // Label 10560: @662568
     /*  662568 */   GIM_Try, /*On fail goto*//*Label 10561*/ GIMT_Encode4(662643), // Rule ID 7611 //
     /*  662573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  662584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  662587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  662590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662619 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2),
     /*  662622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662641 */     GIR_RootConstrainSelectedInstOperands,
     /*  662642 */     // GIR_Coverage, 7611,
     /*  662642 */     GIR_EraseRootFromParent_Done,
     /*  662643 */   // Label 10561: @662643
     /*  662643 */   GIM_Try, /*On fail goto*//*Label 10562*/ GIMT_Encode4(662718), // Rule ID 7614 //
     /*  662648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662694 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662716 */     GIR_RootConstrainSelectedInstOperands,
     /*  662717 */     // GIR_Coverage, 7614,
     /*  662717 */     GIR_EraseRootFromParent_Done,
     /*  662718 */   // Label 10562: @662718
     /*  662718 */   GIM_Try, /*On fail goto*//*Label 10563*/ GIMT_Encode4(662793), // Rule ID 7615 //
     /*  662723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  662734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  662737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  662740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  662754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662769 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11422:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1),
     /*  662772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662791 */     GIR_RootConstrainSelectedInstOperands,
     /*  662792 */     // GIR_Coverage, 7615,
     /*  662792 */     GIR_EraseRootFromParent_Done,
     /*  662793 */   // Label 10563: @662793
     /*  662793 */   GIM_Try, /*On fail goto*//*Label 10564*/ GIMT_Encode4(662868), // Rule ID 7618 //
     /*  662798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662866 */     GIR_RootConstrainSelectedInstOperands,
     /*  662867 */     // GIR_Coverage, 7618,
     /*  662867 */     GIR_EraseRootFromParent_Done,
     /*  662868 */   // Label 10564: @662868
     /*  662868 */   GIM_Try, /*On fail goto*//*Label 10565*/ GIMT_Encode4(662943), // Rule ID 7619 //
     /*  662873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  662876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  662884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  662887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  662890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  662893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  662896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  662904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11422:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  662919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2),
     /*  662922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  662926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  662928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  662930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  662935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  662938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  662941 */     GIR_RootConstrainSelectedInstOperands,
     /*  662942 */     // GIR_Coverage, 7619,
     /*  662942 */     GIR_EraseRootFromParent_Done,
     /*  662943 */   // Label 10565: @662943
     /*  662943 */   GIM_Try, /*On fail goto*//*Label 10566*/ GIMT_Encode4(663018), // Rule ID 7622 //
     /*  662948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  662951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  662956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  662959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  662962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  662965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  662968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  662971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  662979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  662983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  662987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  662994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  662994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  662997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  662999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663016 */     GIR_RootConstrainSelectedInstOperands,
     /*  663017 */     // GIR_Coverage, 7622,
     /*  663017 */     GIR_EraseRootFromParent_Done,
     /*  663018 */   // Label 10566: @663018
     /*  663018 */   GIM_Try, /*On fail goto*//*Label 10567*/ GIMT_Encode4(663093), // Rule ID 7623 //
     /*  663023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  663026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra),
     /*  663031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  663034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  663037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  663040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  663043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  663054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  663058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  663062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11422:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNSRA_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4),
     /*  663072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663091 */     GIR_RootConstrainSelectedInstOperands,
     /*  663092 */     // GIR_Coverage, 7623,
     /*  663092 */     GIR_EraseRootFromParent_Done,
     /*  663093 */   // Label 10567: @663093
     /*  663093 */   GIM_Try, /*On fail goto*//*Label 10568*/ GIMT_Encode4(663168), // Rule ID 10138 //
     /*  663098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663166 */     GIR_RootConstrainSelectedInstOperands,
     /*  663167 */     // GIR_Coverage, 10138,
     /*  663167 */     GIR_EraseRootFromParent_Done,
     /*  663168 */   // Label 10568: @663168
     /*  663168 */   GIM_Try, /*On fail goto*//*Label 10569*/ GIMT_Encode4(663243), // Rule ID 10139 //
     /*  663173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  663184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  663187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  663190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  663193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /*  663222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663241 */     GIR_RootConstrainSelectedInstOperands,
     /*  663242 */     // GIR_Coverage, 10139,
     /*  663242 */     GIR_EraseRootFromParent_Done,
     /*  663243 */   // Label 10569: @663243
     /*  663243 */   GIM_Try, /*On fail goto*//*Label 10570*/ GIMT_Encode4(663318), // Rule ID 10142 //
     /*  663248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663316 */     GIR_RootConstrainSelectedInstOperands,
     /*  663317 */     // GIR_Coverage, 10142,
     /*  663317 */     GIR_EraseRootFromParent_Done,
     /*  663318 */   // Label 10570: @663318
     /*  663318 */   GIM_Try, /*On fail goto*//*Label 10571*/ GIMT_Encode4(663393), // Rule ID 10143 //
     /*  663323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  663334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  663337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  663340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  663343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663369 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663391 */     GIR_RootConstrainSelectedInstOperands,
     /*  663392 */     // GIR_Coverage, 10143,
     /*  663392 */     GIR_EraseRootFromParent_Done,
     /*  663393 */   // Label 10571: @663393
     /*  663393 */   GIM_Try, /*On fail goto*//*Label 10572*/ GIMT_Encode4(663468), // Rule ID 10146 //
     /*  663398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  663415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  663444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663466 */     GIR_RootConstrainSelectedInstOperands,
     /*  663467 */     // GIR_Coverage, 10146,
     /*  663467 */     GIR_EraseRootFromParent_Done,
     /*  663468 */   // Label 10572: @663468
     /*  663468 */   GIM_Try, /*On fail goto*//*Label 10573*/ GIMT_Encode4(663543), // Rule ID 10147 //
     /*  663473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  663484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  663487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  663490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  663493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  663519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  663538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663541 */     GIR_RootConstrainSelectedInstOperands,
     /*  663542 */     // GIR_Coverage, 10147,
     /*  663542 */     GIR_EraseRootFromParent_Done,
     /*  663543 */   // Label 10573: @663543
     /*  663543 */   GIM_Try, /*On fail goto*//*Label 10574*/ GIMT_Encode4(663618), // Rule ID 10150 //
     /*  663548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  663565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663616 */     GIR_RootConstrainSelectedInstOperands,
     /*  663617 */     // GIR_Coverage, 10150,
     /*  663617 */     GIR_EraseRootFromParent_Done,
     /*  663618 */   // Label 10574: @663618
     /*  663618 */   GIM_Try, /*On fail goto*//*Label 10575*/ GIMT_Encode4(663693), // Rule ID 10151 //
     /*  663623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  663634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  663637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  663640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  663643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /*  663672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663691 */     GIR_RootConstrainSelectedInstOperands,
     /*  663692 */     // GIR_Coverage, 10151,
     /*  663692 */     GIR_EraseRootFromParent_Done,
     /*  663693 */   // Label 10575: @663693
     /*  663693 */   GIM_Try, /*On fail goto*//*Label 10576*/ GIMT_Encode4(663768), // Rule ID 10154 //
     /*  663698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  663709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  663712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  663718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  663744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663766 */     GIR_RootConstrainSelectedInstOperands,
     /*  663767 */     // GIR_Coverage, 10154,
     /*  663767 */     GIR_EraseRootFromParent_Done,
     /*  663768 */   // Label 10576: @663768
     /*  663768 */   GIM_Try, /*On fail goto*//*Label 10577*/ GIMT_Encode4(663843), // Rule ID 10155 //
     /*  663773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  663784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  663787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  663790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  663793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  663819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  663838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663841 */     GIR_RootConstrainSelectedInstOperands,
     /*  663842 */     // GIR_Coverage, 10155,
     /*  663842 */     GIR_EraseRootFromParent_Done,
     /*  663843 */   // Label 10577: @663843
     /*  663843 */   GIM_Try, /*On fail goto*//*Label 10578*/ GIMT_Encode4(663918), // Rule ID 10158 //
     /*  663848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  663851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  663868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  663871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  663894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663916 */     GIR_RootConstrainSelectedInstOperands,
     /*  663917 */     // GIR_Coverage, 10158,
     /*  663917 */     GIR_EraseRootFromParent_Done,
     /*  663918 */   // Label 10578: @663918
     /*  663918 */   GIM_Try, /*On fail goto*//*Label 10579*/ GIMT_Encode4(663993), // Rule ID 10159 //
     /*  663923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  663926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  663931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  663934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  663937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  663940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  663943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  663946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  663962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  663969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  663969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /*  663972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  663974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  663976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  663978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  663980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  663985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  663988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  663991 */     GIR_RootConstrainSelectedInstOperands,
     /*  663992 */     // GIR_Coverage, 10159,
     /*  663992 */     GIR_EraseRootFromParent_Done,
     /*  663993 */   // Label 10579: @663993
     /*  663993 */   GIM_Try, /*On fail goto*//*Label 10580*/ GIMT_Encode4(664068), // Rule ID 10162 //
     /*  663998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664066 */     GIR_RootConstrainSelectedInstOperands,
     /*  664067 */     // GIR_Coverage, 10162,
     /*  664067 */     GIR_EraseRootFromParent_Done,
     /*  664068 */   // Label 10580: @664068
     /*  664068 */   GIM_Try, /*On fail goto*//*Label 10581*/ GIMT_Encode4(664143), // Rule ID 10163 //
     /*  664073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  664084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  664087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  664090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  664093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664141 */     GIR_RootConstrainSelectedInstOperands,
     /*  664142 */     // GIR_Coverage, 10163,
     /*  664142 */     GIR_EraseRootFromParent_Done,
     /*  664143 */   // Label 10581: @664143
     /*  664143 */   GIM_Try, /*On fail goto*//*Label 10582*/ GIMT_Encode4(664218), // Rule ID 10166 //
     /*  664148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  664194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664216 */     GIR_RootConstrainSelectedInstOperands,
     /*  664217 */     // GIR_Coverage, 10166,
     /*  664217 */     GIR_EraseRootFromParent_Done,
     /*  664218 */   // Label 10582: @664218
     /*  664218 */   GIM_Try, /*On fail goto*//*Label 10583*/ GIMT_Encode4(664293), // Rule ID 10167 //
     /*  664223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  664234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  664237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  664240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  664243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  664269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  664288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664291 */     GIR_RootConstrainSelectedInstOperands,
     /*  664292 */     // GIR_Coverage, 10167,
     /*  664292 */     GIR_EraseRootFromParent_Done,
     /*  664293 */   // Label 10583: @664293
     /*  664293 */   GIM_Try, /*On fail goto*//*Label 10584*/ GIMT_Encode4(664368), // Rule ID 10170 //
     /*  664298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  664344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664366 */     GIR_RootConstrainSelectedInstOperands,
     /*  664367 */     // GIR_Coverage, 10170,
     /*  664367 */     GIR_EraseRootFromParent_Done,
     /*  664368 */   // Label 10584: @664368
     /*  664368 */   GIM_Try, /*On fail goto*//*Label 10585*/ GIMT_Encode4(664443), // Rule ID 10171 //
     /*  664373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  664384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  664387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  664390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  664393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  664419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  664438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664441 */     GIR_RootConstrainSelectedInstOperands,
     /*  664442 */     // GIR_Coverage, 10171,
     /*  664442 */     GIR_EraseRootFromParent_Done,
     /*  664443 */   // Label 10585: @664443
     /*  664443 */   GIM_Try, /*On fail goto*//*Label 10586*/ GIMT_Encode4(664518), // Rule ID 10174 //
     /*  664448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  664451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  664459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  664462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  664468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  664494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  664513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664516 */     GIR_RootConstrainSelectedInstOperands,
     /*  664517 */     // GIR_Coverage, 10174,
     /*  664517 */     GIR_EraseRootFromParent_Done,
     /*  664518 */   // Label 10586: @664518
     /*  664518 */   GIM_Try, /*On fail goto*//*Label 10587*/ GIMT_Encode4(664593), // Rule ID 10175 //
     /*  664523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  664526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  664534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  664537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  664540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  664543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  664562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  664569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /*  664572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  664588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664591 */     GIR_RootConstrainSelectedInstOperands,
     /*  664592 */     // GIR_Coverage, 10175,
     /*  664592 */     GIR_EraseRootFromParent_Done,
     /*  664593 */   // Label 10587: @664593
     /*  664593 */   GIM_Try, /*On fail goto*//*Label 10588*/ GIMT_Encode4(664668), // Rule ID 10178 //
     /*  664598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  664609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  664612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  664615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  664618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  664647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664666 */     GIR_RootConstrainSelectedInstOperands,
     /*  664667 */     // GIR_Coverage, 10178,
     /*  664667 */     GIR_EraseRootFromParent_Done,
     /*  664668 */   // Label 10588: @664668
     /*  664668 */   GIM_Try, /*On fail goto*//*Label 10589*/ GIMT_Encode4(664743), // Rule ID 10179 //
     /*  664673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  664684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  664687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  664690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  664693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  664712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664719 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  664722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664741 */     GIR_RootConstrainSelectedInstOperands,
     /*  664742 */     // GIR_Coverage, 10179,
     /*  664742 */     GIR_EraseRootFromParent_Done,
     /*  664743 */   // Label 10589: @664743
     /*  664743 */   GIM_Try, /*On fail goto*//*Label 10590*/ GIMT_Encode4(664818), // Rule ID 10182 //
     /*  664748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  664759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  664762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  664765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  664768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  664797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664816 */     GIR_RootConstrainSelectedInstOperands,
     /*  664817 */     // GIR_Coverage, 10182,
     /*  664817 */     GIR_EraseRootFromParent_Done,
     /*  664818 */   // Label 10590: @664818
     /*  664818 */   GIM_Try, /*On fail goto*//*Label 10591*/ GIMT_Encode4(664893), // Rule ID 10183 //
     /*  664823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  664834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  664837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  664840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  664843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  664862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  664869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  664872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664891 */     GIR_RootConstrainSelectedInstOperands,
     /*  664892 */     // GIR_Coverage, 10183,
     /*  664892 */     GIR_EraseRootFromParent_Done,
     /*  664893 */   // Label 10591: @664893
     /*  664893 */   GIM_Try, /*On fail goto*//*Label 10592*/ GIMT_Encode4(664968), // Rule ID 10186 //
     /*  664898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  664901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  664909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  664912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  664915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  664918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  664921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  664937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  664944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  664944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  664947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  664949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  664951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  664953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  664955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  664960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  664963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  664966 */     GIR_RootConstrainSelectedInstOperands,
     /*  664967 */     // GIR_Coverage, 10186,
     /*  664967 */     GIR_EraseRootFromParent_Done,
     /*  664968 */   // Label 10592: @664968
     /*  664968 */   GIM_Try, /*On fail goto*//*Label 10593*/ GIMT_Encode4(665043), // Rule ID 10187 //
     /*  664973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  664976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  664981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  664984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  664987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  664990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  664993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  664996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665019 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  665019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  665038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665041 */     GIR_RootConstrainSelectedInstOperands,
     /*  665042 */     // GIR_Coverage, 10187,
     /*  665042 */     GIR_EraseRootFromParent_Done,
     /*  665043 */   // Label 10593: @665043
     /*  665043 */   GIM_Try, /*On fail goto*//*Label 10594*/ GIMT_Encode4(665118), // Rule ID 10190 //
     /*  665048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665116 */     GIR_RootConstrainSelectedInstOperands,
     /*  665117 */     // GIR_Coverage, 10190,
     /*  665117 */     GIR_EraseRootFromParent_Done,
     /*  665118 */   // Label 10594: @665118
     /*  665118 */   GIM_Try, /*On fail goto*//*Label 10595*/ GIMT_Encode4(665193), // Rule ID 10191 //
     /*  665123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  665134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  665137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  665140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  665143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665191 */     GIR_RootConstrainSelectedInstOperands,
     /*  665192 */     // GIR_Coverage, 10191,
     /*  665192 */     GIR_EraseRootFromParent_Done,
     /*  665193 */   // Label 10595: @665193
     /*  665193 */   GIM_Try, /*On fail goto*//*Label 10596*/ GIMT_Encode4(665268), // Rule ID 10194 //
     /*  665198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665266 */     GIR_RootConstrainSelectedInstOperands,
     /*  665267 */     // GIR_Coverage, 10194,
     /*  665267 */     GIR_EraseRootFromParent_Done,
     /*  665268 */   // Label 10596: @665268
     /*  665268 */   GIM_Try, /*On fail goto*//*Label 10597*/ GIMT_Encode4(665343), // Rule ID 10195 //
     /*  665273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  665284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  665287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  665290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  665293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665319 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665341 */     GIR_RootConstrainSelectedInstOperands,
     /*  665342 */     // GIR_Coverage, 10195,
     /*  665342 */     GIR_EraseRootFromParent_Done,
     /*  665343 */   // Label 10597: @665343
     /*  665343 */   GIM_Try, /*On fail goto*//*Label 10598*/ GIMT_Encode4(665418), // Rule ID 10198 //
     /*  665348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  665394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665416 */     GIR_RootConstrainSelectedInstOperands,
     /*  665417 */     // GIR_Coverage, 10198,
     /*  665417 */     GIR_EraseRootFromParent_Done,
     /*  665418 */   // Label 10598: @665418
     /*  665418 */   GIM_Try, /*On fail goto*//*Label 10599*/ GIMT_Encode4(665493), // Rule ID 10199 //
     /*  665423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  665434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  665437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  665440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  665443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665469 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  665469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  665488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665491 */     GIR_RootConstrainSelectedInstOperands,
     /*  665492 */     // GIR_Coverage, 10199,
     /*  665492 */     GIR_EraseRootFromParent_Done,
     /*  665493 */   // Label 10599: @665493
     /*  665493 */   GIM_Try, /*On fail goto*//*Label 10600*/ GIMT_Encode4(665568), // Rule ID 10202 //
     /*  665498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  665509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  665512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  665515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  665518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665566 */     GIR_RootConstrainSelectedInstOperands,
     /*  665567 */     // GIR_Coverage, 10202,
     /*  665567 */     GIR_EraseRootFromParent_Done,
     /*  665568 */   // Label 10600: @665568
     /*  665568 */   GIM_Try, /*On fail goto*//*Label 10601*/ GIMT_Encode4(665643), // Rule ID 10203 //
     /*  665573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  665584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  665587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  665590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  665593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665641 */     GIR_RootConstrainSelectedInstOperands,
     /*  665642 */     // GIR_Coverage, 10203,
     /*  665642 */     GIR_EraseRootFromParent_Done,
     /*  665643 */   // Label 10601: @665643
     /*  665643 */   GIM_Try, /*On fail goto*//*Label 10602*/ GIMT_Encode4(665718), // Rule ID 10206 //
     /*  665648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  665665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665716 */     GIR_RootConstrainSelectedInstOperands,
     /*  665717 */     // GIR_Coverage, 10206,
     /*  665717 */     GIR_EraseRootFromParent_Done,
     /*  665718 */   // Label 10602: @665718
     /*  665718 */   GIM_Try, /*On fail goto*//*Label 10603*/ GIMT_Encode4(665793), // Rule ID 10207 //
     /*  665723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  665734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  665737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  665740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  665743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  665762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  665772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665791 */     GIR_RootConstrainSelectedInstOperands,
     /*  665792 */     // GIR_Coverage, 10207,
     /*  665792 */     GIR_EraseRootFromParent_Done,
     /*  665793 */   // Label 10603: @665793
     /*  665793 */   GIM_Try, /*On fail goto*//*Label 10604*/ GIMT_Encode4(665868), // Rule ID 10210 //
     /*  665798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  665801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  665809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  665812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  665815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  665818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  665844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665866 */     GIR_RootConstrainSelectedInstOperands,
     /*  665867 */     // GIR_Coverage, 10210,
     /*  665867 */     GIR_EraseRootFromParent_Done,
     /*  665868 */   // Label 10604: @665868
     /*  665868 */   GIM_Try, /*On fail goto*//*Label 10605*/ GIMT_Encode4(665943), // Rule ID 10211 //
     /*  665873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  665876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  665884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  665887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  665890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  665893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  665896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  665912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  665919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  665922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  665926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  665928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  665930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  665935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  665938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  665941 */     GIR_RootConstrainSelectedInstOperands,
     /*  665942 */     // GIR_Coverage, 10211,
     /*  665942 */     GIR_EraseRootFromParent_Done,
     /*  665943 */   // Label 10605: @665943
     /*  665943 */   GIM_Try, /*On fail goto*//*Label 10606*/ GIMT_Encode4(666018), // Rule ID 10214 //
     /*  665948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  665951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  665956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  665959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  665962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  665965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  665968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  665971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  665987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  665994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  665994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  665997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  665999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666016 */     GIR_RootConstrainSelectedInstOperands,
     /*  666017 */     // GIR_Coverage, 10214,
     /*  666017 */     GIR_EraseRootFromParent_Done,
     /*  666018 */   // Label 10606: @666018
     /*  666018 */   GIM_Try, /*On fail goto*//*Label 10607*/ GIMT_Encode4(666093), // Rule ID 10215 //
     /*  666023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  666034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  666037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  666040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  666043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  666062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /*  666072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666091 */     GIR_RootConstrainSelectedInstOperands,
     /*  666092 */     // GIR_Coverage, 10215,
     /*  666092 */     GIR_EraseRootFromParent_Done,
     /*  666093 */   // Label 10607: @666093
     /*  666093 */   GIM_Try, /*On fail goto*//*Label 10608*/ GIMT_Encode4(666168), // Rule ID 10218 //
     /*  666098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666166 */     GIR_RootConstrainSelectedInstOperands,
     /*  666167 */     // GIR_Coverage, 10218,
     /*  666167 */     GIR_EraseRootFromParent_Done,
     /*  666168 */   // Label 10608: @666168
     /*  666168 */   GIM_Try, /*On fail goto*//*Label 10609*/ GIMT_Encode4(666243), // Rule ID 10219 //
     /*  666173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  666184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  666187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  666190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  666193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  666212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666219 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /*  666222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666241 */     GIR_RootConstrainSelectedInstOperands,
     /*  666242 */     // GIR_Coverage, 10219,
     /*  666242 */     GIR_EraseRootFromParent_Done,
     /*  666243 */   // Label 10609: @666243
     /*  666243 */   GIM_Try, /*On fail goto*//*Label 10610*/ GIMT_Encode4(666318), // Rule ID 10222 //
     /*  666248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  666251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  666294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666316 */     GIR_RootConstrainSelectedInstOperands,
     /*  666317 */     // GIR_Coverage, 10222,
     /*  666317 */     GIR_EraseRootFromParent_Done,
     /*  666318 */   // Label 10610: @666318
     /*  666318 */   GIM_Try, /*On fail goto*//*Label 10611*/ GIMT_Encode4(666393), // Rule ID 10223 //
     /*  666323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  666326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  666334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  666337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  666340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  666343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  666362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  666369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /*  666372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  666388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666391 */     GIR_RootConstrainSelectedInstOperands,
     /*  666392 */     // GIR_Coverage, 10223,
     /*  666392 */     GIR_EraseRootFromParent_Done,
     /*  666393 */   // Label 10611: @666393
     /*  666393 */   GIM_Try, /*On fail goto*//*Label 10612*/ GIMT_Encode4(666468), // Rule ID 10226 //
     /*  666398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  666409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  666412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  666415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  666447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666466 */     GIR_RootConstrainSelectedInstOperands,
     /*  666467 */     // GIR_Coverage, 10226,
     /*  666467 */     GIR_EraseRootFromParent_Done,
     /*  666468 */   // Label 10612: @666468
     /*  666468 */   GIM_Try, /*On fail goto*//*Label 10613*/ GIMT_Encode4(666543), // Rule ID 10227 //
     /*  666473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  666484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  666487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  666490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8),
     /*  666522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666541 */     GIR_RootConstrainSelectedInstOperands,
     /*  666542 */     // GIR_Coverage, 10227,
     /*  666542 */     GIR_EraseRootFromParent_Done,
     /*  666543 */   // Label 10613: @666543
     /*  666543 */   GIM_Try, /*On fail goto*//*Label 10614*/ GIMT_Encode4(666618), // Rule ID 10230 //
     /*  666548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  666559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  666562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  666565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  666597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666616 */     GIR_RootConstrainSelectedInstOperands,
     /*  666617 */     // GIR_Coverage, 10230,
     /*  666617 */     GIR_EraseRootFromParent_Done,
     /*  666618 */   // Label 10614: @666618
     /*  666618 */   GIM_Try, /*On fail goto*//*Label 10615*/ GIMT_Encode4(666693), // Rule ID 10231 //
     /*  666623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  666634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  666637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  666640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  666672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666691 */     GIR_RootConstrainSelectedInstOperands,
     /*  666692 */     // GIR_Coverage, 10231,
     /*  666692 */     GIR_EraseRootFromParent_Done,
     /*  666693 */   // Label 10615: @666693
     /*  666693 */   GIM_Try, /*On fail goto*//*Label 10616*/ GIMT_Encode4(666768), // Rule ID 10234 //
     /*  666698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  666709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  666712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  666715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666744 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  666744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  666747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666766 */     GIR_RootConstrainSelectedInstOperands,
     /*  666767 */     // GIR_Coverage, 10234,
     /*  666767 */     GIR_EraseRootFromParent_Done,
     /*  666768 */   // Label 10616: @666768
     /*  666768 */   GIM_Try, /*On fail goto*//*Label 10617*/ GIMT_Encode4(666843), // Rule ID 10235 //
     /*  666773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  666784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  666787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  666790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666819 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  666819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  666822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  666838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666841 */     GIR_RootConstrainSelectedInstOperands,
     /*  666842 */     // GIR_Coverage, 10235,
     /*  666842 */     GIR_EraseRootFromParent_Done,
     /*  666843 */   // Label 10617: @666843
     /*  666843 */   GIM_Try, /*On fail goto*//*Label 10618*/ GIMT_Encode4(666918), // Rule ID 10238 //
     /*  666848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  666851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  666865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  666868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  666871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666894 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  666894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  666897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666916 */     GIR_RootConstrainSelectedInstOperands,
     /*  666917 */     // GIR_Coverage, 10238,
     /*  666917 */     GIR_EraseRootFromParent_Done,
     /*  666918 */   // Label 10618: @666918
     /*  666918 */   GIM_Try, /*On fail goto*//*Label 10619*/ GIMT_Encode4(666993), // Rule ID 10239 //
     /*  666923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  666926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  666931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  666934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  666937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  666940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  666943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  666946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  666958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  666962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  666969 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  666969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4),
     /*  666972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  666974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  666976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  666978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  666980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  666985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  666988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  666991 */     GIR_RootConstrainSelectedInstOperands,
     /*  666992 */     // GIR_Coverage, 10239,
     /*  666992 */     GIR_EraseRootFromParent_Done,
     /*  666993 */   // Label 10619: @666993
     /*  666993 */   GIM_Try, /*On fail goto*//*Label 10620*/ GIMT_Encode4(667068), // Rule ID 10242 //
     /*  666998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667066 */     GIR_RootConstrainSelectedInstOperands,
     /*  667067 */     // GIR_Coverage, 10242,
     /*  667067 */     GIR_EraseRootFromParent_Done,
     /*  667068 */   // Label 10620: @667068
     /*  667068 */   GIM_Try, /*On fail goto*//*Label 10621*/ GIMT_Encode4(667143), // Rule ID 10243 //
     /*  667073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  667084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  667087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  667090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667141 */     GIR_RootConstrainSelectedInstOperands,
     /*  667142 */     // GIR_Coverage, 10243,
     /*  667142 */     GIR_EraseRootFromParent_Done,
     /*  667143 */   // Label 10621: @667143
     /*  667143 */   GIM_Try, /*On fail goto*//*Label 10622*/ GIMT_Encode4(667218), // Rule ID 10246 //
     /*  667148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667216 */     GIR_RootConstrainSelectedInstOperands,
     /*  667217 */     // GIR_Coverage, 10246,
     /*  667217 */     GIR_EraseRootFromParent_Done,
     /*  667218 */   // Label 10622: @667218
     /*  667218 */   GIM_Try, /*On fail goto*//*Label 10623*/ GIMT_Encode4(667293), // Rule ID 10247 //
     /*  667223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  667234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  667237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  667240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667269 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2),
     /*  667272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667291 */     GIR_RootConstrainSelectedInstOperands,
     /*  667292 */     // GIR_Coverage, 10247,
     /*  667292 */     GIR_EraseRootFromParent_Done,
     /*  667293 */   // Label 10623: @667293
     /*  667293 */   GIM_Try, /*On fail goto*//*Label 10624*/ GIMT_Encode4(667368), // Rule ID 10250 //
     /*  667298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667366 */     GIR_RootConstrainSelectedInstOperands,
     /*  667367 */     // GIR_Coverage, 10250,
     /*  667367 */     GIR_EraseRootFromParent_Done,
     /*  667368 */   // Label 10624: @667368
     /*  667368 */   GIM_Try, /*On fail goto*//*Label 10625*/ GIMT_Encode4(667443), // Rule ID 10251 //
     /*  667373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  667384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  667387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  667390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11365:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  667419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667441 */     GIR_RootConstrainSelectedInstOperands,
     /*  667442 */     // GIR_Coverage, 10251,
     /*  667442 */     GIR_EraseRootFromParent_Done,
     /*  667443 */   // Label 10625: @667443
     /*  667443 */   GIM_Try, /*On fail goto*//*Label 10626*/ GIMT_Encode4(667518), // Rule ID 10254 //
     /*  667448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  667459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  667462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  667465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  667494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667516 */     GIR_RootConstrainSelectedInstOperands,
     /*  667517 */     // GIR_Coverage, 10254,
     /*  667517 */     GIR_EraseRootFromParent_Done,
     /*  667518 */   // Label 10626: @667518
     /*  667518 */   GIM_Try, /*On fail goto*//*Label 10627*/ GIMT_Encode4(667593), // Rule ID 10255 //
     /*  667523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  667534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  667537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  667540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11365:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  667569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  667588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667591 */     GIR_RootConstrainSelectedInstOperands,
     /*  667592 */     // GIR_Coverage, 10255,
     /*  667592 */     GIR_EraseRootFromParent_Done,
     /*  667593 */   // Label 10627: @667593
     /*  667593 */   GIM_Try, /*On fail goto*//*Label 10628*/ GIMT_Encode4(667668), // Rule ID 10258 //
     /*  667598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  667615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  667644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667666 */     GIR_RootConstrainSelectedInstOperands,
     /*  667667 */     // GIR_Coverage, 10258,
     /*  667667 */     GIR_EraseRootFromParent_Done,
     /*  667668 */   // Label 10628: @667668
     /*  667668 */   GIM_Try, /*On fail goto*//*Label 10629*/ GIMT_Encode4(667743), // Rule ID 10259 //
     /*  667673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  667684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  667687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  667690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11365:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  667719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  667738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667741 */     GIR_RootConstrainSelectedInstOperands,
     /*  667742 */     // GIR_Coverage, 10259,
     /*  667742 */     GIR_EraseRootFromParent_Done,
     /*  667743 */   // Label 10629: @667743
     /*  667743 */   GIM_Try, /*On fail goto*//*Label 10630*/ GIMT_Encode4(667818), // Rule ID 10262 //
     /*  667748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  667751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  667759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  667762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  667765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  667794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667816 */     GIR_RootConstrainSelectedInstOperands,
     /*  667817 */     // GIR_Coverage, 10262,
     /*  667817 */     GIR_EraseRootFromParent_Done,
     /*  667818 */   // Label 10630: @667818
     /*  667818 */   GIM_Try, /*On fail goto*//*Label 10631*/ GIMT_Encode4(667893), // Rule ID 10263 //
     /*  667823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  667826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  667834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  667837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  667840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  667858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11365:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  667869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1),
     /*  667872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  667888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667891 */     GIR_RootConstrainSelectedInstOperands,
     /*  667892 */     // GIR_Coverage, 10263,
     /*  667892 */     GIR_EraseRootFromParent_Done,
     /*  667893 */   // Label 10631: @667893
     /*  667893 */   GIM_Try, /*On fail goto*//*Label 10632*/ GIMT_Encode4(667968), // Rule ID 10266 //
     /*  667898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  667901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  667909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  667912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  667915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  667918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  667921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  667933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  667937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  667944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  667944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  667947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  667949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  667951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  667953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  667955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  667960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  667963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  667966 */     GIR_RootConstrainSelectedInstOperands,
     /*  667967 */     // GIR_Coverage, 10266,
     /*  667967 */     GIR_EraseRootFromParent_Done,
     /*  667968 */   // Label 10632: @667968
     /*  667968 */   GIM_Try, /*On fail goto*//*Label 10633*/ GIMT_Encode4(668043), // Rule ID 10267 //
     /*  667973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  667976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  667981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  667984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  667987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  667990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  667993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  667996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668041 */     GIR_RootConstrainSelectedInstOperands,
     /*  668042 */     // GIR_Coverage, 10267,
     /*  668042 */     GIR_EraseRootFromParent_Done,
     /*  668043 */   // Label 10633: @668043
     /*  668043 */   GIM_Try, /*On fail goto*//*Label 10634*/ GIMT_Encode4(668118), // Rule ID 10270 //
     /*  668048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668116 */     GIR_RootConstrainSelectedInstOperands,
     /*  668117 */     // GIR_Coverage, 10270,
     /*  668117 */     GIR_EraseRootFromParent_Done,
     /*  668118 */   // Label 10634: @668118
     /*  668118 */   GIM_Try, /*On fail goto*//*Label 10635*/ GIMT_Encode4(668193), // Rule ID 10271 //
     /*  668123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  668134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  668137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  668140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668169 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668191 */     GIR_RootConstrainSelectedInstOperands,
     /*  668192 */     // GIR_Coverage, 10271,
     /*  668192 */     GIR_EraseRootFromParent_Done,
     /*  668193 */   // Label 10635: @668193
     /*  668193 */   GIM_Try, /*On fail goto*//*Label 10636*/ GIMT_Encode4(668268), // Rule ID 10274 //
     /*  668198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668244 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  668244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668266 */     GIR_RootConstrainSelectedInstOperands,
     /*  668267 */     // GIR_Coverage, 10274,
     /*  668267 */     GIR_EraseRootFromParent_Done,
     /*  668268 */   // Label 10636: @668268
     /*  668268 */   GIM_Try, /*On fail goto*//*Label 10637*/ GIMT_Encode4(668343), // Rule ID 10275 //
     /*  668273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  668284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  668287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  668290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668319 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  668319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  668338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668341 */     GIR_RootConstrainSelectedInstOperands,
     /*  668342 */     // GIR_Coverage, 10275,
     /*  668342 */     GIR_EraseRootFromParent_Done,
     /*  668343 */   // Label 10637: @668343
     /*  668343 */   GIM_Try, /*On fail goto*//*Label 10638*/ GIMT_Encode4(668418), // Rule ID 10278 //
     /*  668348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668416 */     GIR_RootConstrainSelectedInstOperands,
     /*  668417 */     // GIR_Coverage, 10278,
     /*  668417 */     GIR_EraseRootFromParent_Done,
     /*  668418 */   // Label 10638: @668418
     /*  668418 */   GIM_Try, /*On fail goto*//*Label 10639*/ GIMT_Encode4(668493), // Rule ID 10279 //
     /*  668423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  668434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  668437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  668440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668491 */     GIR_RootConstrainSelectedInstOperands,
     /*  668492 */     // GIR_Coverage, 10279,
     /*  668492 */     GIR_EraseRootFromParent_Done,
     /*  668493 */   // Label 10639: @668493
     /*  668493 */   GIM_Try, /*On fail goto*//*Label 10640*/ GIMT_Encode4(668568), // Rule ID 10282 //
     /*  668498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  668509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  668512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  668515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668566 */     GIR_RootConstrainSelectedInstOperands,
     /*  668567 */     // GIR_Coverage, 10282,
     /*  668567 */     GIR_EraseRootFromParent_Done,
     /*  668568 */   // Label 10640: @668568
     /*  668568 */   GIM_Try, /*On fail goto*//*Label 10641*/ GIMT_Encode4(668643), // Rule ID 10283 //
     /*  668573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  668584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  668587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  668590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668641 */     GIR_RootConstrainSelectedInstOperands,
     /*  668642 */     // GIR_Coverage, 10283,
     /*  668642 */     GIR_EraseRootFromParent_Done,
     /*  668643 */   // Label 10641: @668643
     /*  668643 */   GIM_Try, /*On fail goto*//*Label 10642*/ GIMT_Encode4(668718), // Rule ID 10286 //
     /*  668648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  668659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  668662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  668665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  668694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668716 */     GIR_RootConstrainSelectedInstOperands,
     /*  668717 */     // GIR_Coverage, 10286,
     /*  668717 */     GIR_EraseRootFromParent_Done,
     /*  668718 */   // Label 10642: @668718
     /*  668718 */   GIM_Try, /*On fail goto*//*Label 10643*/ GIMT_Encode4(668793), // Rule ID 10287 //
     /*  668723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  668734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  668737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  668740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  668758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668769 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  668769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  668772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  668788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668791 */     GIR_RootConstrainSelectedInstOperands,
     /*  668792 */     // GIR_Coverage, 10287,
     /*  668792 */     GIR_EraseRootFromParent_Done,
     /*  668793 */   // Label 10643: @668793
     /*  668793 */   GIM_Try, /*On fail goto*//*Label 10644*/ GIMT_Encode4(668868), // Rule ID 10290 //
     /*  668798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  668809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  668812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  668815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668866 */     GIR_RootConstrainSelectedInstOperands,
     /*  668867 */     // GIR_Coverage, 10290,
     /*  668867 */     GIR_EraseRootFromParent_Done,
     /*  668868 */   // Label 10644: @668868
     /*  668868 */   GIM_Try, /*On fail goto*//*Label 10645*/ GIMT_Encode4(668943), // Rule ID 10291 //
     /*  668873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  668876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  668884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  668887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  668890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  668893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  668896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  668908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  668919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  668922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  668926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  668928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  668930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  668935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  668938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  668941 */     GIR_RootConstrainSelectedInstOperands,
     /*  668942 */     // GIR_Coverage, 10291,
     /*  668942 */     GIR_EraseRootFromParent_Done,
     /*  668943 */   // Label 10645: @668943
     /*  668943 */   GIM_Try, /*On fail goto*//*Label 10646*/ GIMT_Encode4(669018), // Rule ID 10294 //
     /*  668948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  668951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  668956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  668959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  668962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  668965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  668968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  668971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  668983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  668987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  668994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  668994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  668997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  668999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669016 */     GIR_RootConstrainSelectedInstOperands,
     /*  669017 */     // GIR_Coverage, 10294,
     /*  669017 */     GIR_EraseRootFromParent_Done,
     /*  669018 */   // Label 10646: @669018
     /*  669018 */   GIM_Try, /*On fail goto*//*Label 10647*/ GIMT_Encode4(669093), // Rule ID 10295 //
     /*  669023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  669034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  669037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  669040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669091 */     GIR_RootConstrainSelectedInstOperands,
     /*  669092 */     // GIR_Coverage, 10295,
     /*  669092 */     GIR_EraseRootFromParent_Done,
     /*  669093 */   // Label 10647: @669093
     /*  669093 */   GIM_Try, /*On fail goto*//*Label 10648*/ GIMT_Encode4(669168), // Rule ID 10298 //
     /*  669098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  669144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669166 */     GIR_RootConstrainSelectedInstOperands,
     /*  669167 */     // GIR_Coverage, 10298,
     /*  669167 */     GIR_EraseRootFromParent_Done,
     /*  669168 */   // Label 10648: @669168
     /*  669168 */   GIM_Try, /*On fail goto*//*Label 10649*/ GIMT_Encode4(669243), // Rule ID 10299 //
     /*  669173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  669184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  669187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  669190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669219 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  669219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  669238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669241 */     GIR_RootConstrainSelectedInstOperands,
     /*  669242 */     // GIR_Coverage, 10299,
     /*  669242 */     GIR_EraseRootFromParent_Done,
     /*  669243 */   // Label 10649: @669243
     /*  669243 */   GIM_Try, /*On fail goto*//*Label 10650*/ GIMT_Encode4(669318), // Rule ID 10302 //
     /*  669248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669316 */     GIR_RootConstrainSelectedInstOperands,
     /*  669317 */     // GIR_Coverage, 10302,
     /*  669317 */     GIR_EraseRootFromParent_Done,
     /*  669318 */   // Label 10650: @669318
     /*  669318 */   GIM_Try, /*On fail goto*//*Label 10651*/ GIMT_Encode4(669393), // Rule ID 10303 //
     /*  669323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  669334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  669337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  669340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  669358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11365:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  669369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2),
     /*  669372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669391 */     GIR_RootConstrainSelectedInstOperands,
     /*  669392 */     // GIR_Coverage, 10303,
     /*  669392 */     GIR_EraseRootFromParent_Done,
     /*  669393 */   // Label 10651: @669393
     /*  669393 */   GIM_Try, /*On fail goto*//*Label 10652*/ GIMT_Encode4(669468), // Rule ID 10306 //
     /*  669398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  669409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  669412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  669415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669466 */     GIR_RootConstrainSelectedInstOperands,
     /*  669467 */     // GIR_Coverage, 10306,
     /*  669467 */     GIR_EraseRootFromParent_Done,
     /*  669468 */   // Label 10652: @669468
     /*  669468 */   GIM_Try, /*On fail goto*//*Label 10653*/ GIMT_Encode4(669543), // Rule ID 10307 //
     /*  669473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  669484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  669487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  669490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  669508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11365:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  669519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4),
     /*  669522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669541 */     GIR_RootConstrainSelectedInstOperands,
     /*  669542 */     // GIR_Coverage, 10307,
     /*  669542 */     GIR_EraseRootFromParent_Done,
     /*  669543 */   // Label 10653: @669543
     /*  669543 */   GIM_Try, /*On fail goto*//*Label 10654*/ GIMT_Encode4(669618), // Rule ID 10310 //
     /*  669548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  669551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  669559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  669562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  669565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  669568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  669594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669616 */     GIR_RootConstrainSelectedInstOperands,
     /*  669617 */     // GIR_Coverage, 10310,
     /*  669617 */     GIR_EraseRootFromParent_Done,
     /*  669618 */   // Label 10654: @669618
     /*  669618 */   GIM_Try, /*On fail goto*//*Label 10655*/ GIMT_Encode4(669693), // Rule ID 10311 //
     /*  669623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  669626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu),
     /*  669631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  669634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  669637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  669640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  669643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  669658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  669662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669669 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11365:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMINU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  669669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8),
     /*  669672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  669688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669691 */     GIR_RootConstrainSelectedInstOperands,
     /*  669692 */     // GIR_Coverage, 10311,
     /*  669692 */     GIR_EraseRootFromParent_Done,
     /*  669693 */   // Label 10655: @669693
     /*  669693 */   GIM_Try, /*On fail goto*//*Label 10656*/ GIMT_Encode4(669768), // Rule ID 10314 //
     /*  669698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  669706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  669709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  669712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  669715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  669718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  669747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669766 */     GIR_RootConstrainSelectedInstOperands,
     /*  669767 */     // GIR_Coverage, 10314,
     /*  669767 */     GIR_EraseRootFromParent_Done,
     /*  669768 */   // Label 10656: @669768
     /*  669768 */   GIM_Try, /*On fail goto*//*Label 10657*/ GIMT_Encode4(669843), // Rule ID 10315 //
     /*  669773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  669781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  669784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  669787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  669790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  669793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /*  669822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669841 */     GIR_RootConstrainSelectedInstOperands,
     /*  669842 */     // GIR_Coverage, 10315,
     /*  669842 */     GIR_EraseRootFromParent_Done,
     /*  669843 */   // Label 10657: @669843
     /*  669843 */   GIM_Try, /*On fail goto*//*Label 10658*/ GIMT_Encode4(669918), // Rule ID 10318 //
     /*  669848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  669851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  669856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  669859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  669862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  669865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  669868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  669871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  669894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  669897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669916 */     GIR_RootConstrainSelectedInstOperands,
     /*  669917 */     // GIR_Coverage, 10318,
     /*  669917 */     GIR_EraseRootFromParent_Done,
     /*  669918 */   // Label 10658: @669918
     /*  669918 */   GIM_Try, /*On fail goto*//*Label 10659*/ GIMT_Encode4(669993), // Rule ID 10319 //
     /*  669923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  669926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  669931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  669934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  669937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  669940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  669943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  669946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  669962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  669969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  669969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  669972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  669974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  669976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  669978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  669980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  669985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  669988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  669991 */     GIR_RootConstrainSelectedInstOperands,
     /*  669992 */     // GIR_Coverage, 10319,
     /*  669992 */     GIR_EraseRootFromParent_Done,
     /*  669993 */   // Label 10659: @669993
     /*  669993 */   GIM_Try, /*On fail goto*//*Label 10660*/ GIMT_Encode4(670068), // Rule ID 10322 //
     /*  669998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670066 */     GIR_RootConstrainSelectedInstOperands,
     /*  670067 */     // GIR_Coverage, 10322,
     /*  670067 */     GIR_EraseRootFromParent_Done,
     /*  670068 */   // Label 10660: @670068
     /*  670068 */   GIM_Try, /*On fail goto*//*Label 10661*/ GIMT_Encode4(670143), // Rule ID 10323 //
     /*  670073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  670084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  670087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  670090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  670093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670119 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670141 */     GIR_RootConstrainSelectedInstOperands,
     /*  670142 */     // GIR_Coverage, 10323,
     /*  670142 */     GIR_EraseRootFromParent_Done,
     /*  670143 */   // Label 10661: @670143
     /*  670143 */   GIM_Try, /*On fail goto*//*Label 10662*/ GIMT_Encode4(670218), // Rule ID 10326 //
     /*  670148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670216 */     GIR_RootConstrainSelectedInstOperands,
     /*  670217 */     // GIR_Coverage, 10326,
     /*  670217 */     GIR_EraseRootFromParent_Done,
     /*  670218 */   // Label 10662: @670218
     /*  670218 */   GIM_Try, /*On fail goto*//*Label 10663*/ GIMT_Encode4(670293), // Rule ID 10327 //
     /*  670223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  670234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  670237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  670240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  670243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /*  670272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670291 */     GIR_RootConstrainSelectedInstOperands,
     /*  670292 */     // GIR_Coverage, 10327,
     /*  670292 */     GIR_EraseRootFromParent_Done,
     /*  670293 */   // Label 10663: @670293
     /*  670293 */   GIM_Try, /*On fail goto*//*Label 10664*/ GIMT_Encode4(670368), // Rule ID 10330 //
     /*  670298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670366 */     GIR_RootConstrainSelectedInstOperands,
     /*  670367 */     // GIR_Coverage, 10330,
     /*  670367 */     GIR_EraseRootFromParent_Done,
     /*  670368 */   // Label 10664: @670368
     /*  670368 */   GIM_Try, /*On fail goto*//*Label 10665*/ GIMT_Encode4(670443), // Rule ID 10331 //
     /*  670373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  670384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  670387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  670390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  670393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670419 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670441 */     GIR_RootConstrainSelectedInstOperands,
     /*  670442 */     // GIR_Coverage, 10331,
     /*  670442 */     GIR_EraseRootFromParent_Done,
     /*  670443 */   // Label 10665: @670443
     /*  670443 */   GIM_Try, /*On fail goto*//*Label 10666*/ GIMT_Encode4(670518), // Rule ID 10334 //
     /*  670448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  670459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  670462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  670465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  670468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670516 */     GIR_RootConstrainSelectedInstOperands,
     /*  670517 */     // GIR_Coverage, 10334,
     /*  670517 */     GIR_EraseRootFromParent_Done,
     /*  670518 */   // Label 10666: @670518
     /*  670518 */   GIM_Try, /*On fail goto*//*Label 10667*/ GIMT_Encode4(670593), // Rule ID 10335 //
     /*  670523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  670534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  670537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  670540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  670543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  670569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /*  670572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670591 */     GIR_RootConstrainSelectedInstOperands,
     /*  670592 */     // GIR_Coverage, 10335,
     /*  670592 */     GIR_EraseRootFromParent_Done,
     /*  670593 */   // Label 10667: @670593
     /*  670593 */   GIM_Try, /*On fail goto*//*Label 10668*/ GIMT_Encode4(670668), // Rule ID 10338 //
     /*  670598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  670609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  670612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  670615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  670618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  670644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  670647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670666 */     GIR_RootConstrainSelectedInstOperands,
     /*  670667 */     // GIR_Coverage, 10338,
     /*  670667 */     GIR_EraseRootFromParent_Done,
     /*  670668 */   // Label 10668: @670668
     /*  670668 */   GIM_Try, /*On fail goto*//*Label 10669*/ GIMT_Encode4(670743), // Rule ID 10339 //
     /*  670673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  670684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  670687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  670690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  670693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670719 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  670719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  670722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  670738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670741 */     GIR_RootConstrainSelectedInstOperands,
     /*  670742 */     // GIR_Coverage, 10339,
     /*  670742 */     GIR_EraseRootFromParent_Done,
     /*  670743 */   // Label 10669: @670743
     /*  670743 */   GIM_Try, /*On fail goto*//*Label 10670*/ GIMT_Encode4(670818), // Rule ID 10342 //
     /*  670748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  670759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  670762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  670765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  670768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  670794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  670797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670816 */     GIR_RootConstrainSelectedInstOperands,
     /*  670817 */     // GIR_Coverage, 10342,
     /*  670817 */     GIR_EraseRootFromParent_Done,
     /*  670818 */   // Label 10670: @670818
     /*  670818 */   GIM_Try, /*On fail goto*//*Label 10671*/ GIMT_Encode4(670893), // Rule ID 10343 //
     /*  670823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  670834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  670837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  670840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  670843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670869 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  670869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  670872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  670888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670891 */     GIR_RootConstrainSelectedInstOperands,
     /*  670892 */     // GIR_Coverage, 10343,
     /*  670892 */     GIR_EraseRootFromParent_Done,
     /*  670893 */   // Label 10671: @670893
     /*  670893 */   GIM_Try, /*On fail goto*//*Label 10672*/ GIMT_Encode4(670968), // Rule ID 10346 //
     /*  670898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  670901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  670909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  670912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  670915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  670918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  670921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  670937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  670944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  670944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  670947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  670949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  670951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  670953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  670955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  670960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  670963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  670966 */     GIR_RootConstrainSelectedInstOperands,
     /*  670967 */     // GIR_Coverage, 10346,
     /*  670967 */     GIR_EraseRootFromParent_Done,
     /*  670968 */   // Label 10672: @670968
     /*  670968 */   GIM_Try, /*On fail goto*//*Label 10673*/ GIMT_Encode4(671043), // Rule ID 10347 //
     /*  670973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  670976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  670981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  670984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  670987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  670990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  670993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  670996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  671019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  671038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671041 */     GIR_RootConstrainSelectedInstOperands,
     /*  671042 */     // GIR_Coverage, 10347,
     /*  671042 */     GIR_EraseRootFromParent_Done,
     /*  671043 */   // Label 10673: @671043
     /*  671043 */   GIM_Try, /*On fail goto*//*Label 10674*/ GIMT_Encode4(671118), // Rule ID 10350 //
     /*  671048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  671051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  671094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671116 */     GIR_RootConstrainSelectedInstOperands,
     /*  671117 */     // GIR_Coverage, 10350,
     /*  671117 */     GIR_EraseRootFromParent_Done,
     /*  671118 */   // Label 10674: @671118
     /*  671118 */   GIM_Try, /*On fail goto*//*Label 10675*/ GIMT_Encode4(671193), // Rule ID 10351 //
     /*  671123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  671126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  671134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  671137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  671140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  671143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  671162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  671169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /*  671172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  671188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671191 */     GIR_RootConstrainSelectedInstOperands,
     /*  671192 */     // GIR_Coverage, 10351,
     /*  671192 */     GIR_EraseRootFromParent_Done,
     /*  671193 */   // Label 10675: @671193
     /*  671193 */   GIM_Try, /*On fail goto*//*Label 10676*/ GIMT_Encode4(671268), // Rule ID 10354 //
     /*  671198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671266 */     GIR_RootConstrainSelectedInstOperands,
     /*  671267 */     // GIR_Coverage, 10354,
     /*  671267 */     GIR_EraseRootFromParent_Done,
     /*  671268 */   // Label 10676: @671268
     /*  671268 */   GIM_Try, /*On fail goto*//*Label 10677*/ GIMT_Encode4(671343), // Rule ID 10355 //
     /*  671273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  671284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  671287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  671290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  671293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671341 */     GIR_RootConstrainSelectedInstOperands,
     /*  671342 */     // GIR_Coverage, 10355,
     /*  671342 */     GIR_EraseRootFromParent_Done,
     /*  671343 */   // Label 10677: @671343
     /*  671343 */   GIM_Try, /*On fail goto*//*Label 10678*/ GIMT_Encode4(671418), // Rule ID 10358 //
     /*  671348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671416 */     GIR_RootConstrainSelectedInstOperands,
     /*  671417 */     // GIR_Coverage, 10358,
     /*  671417 */     GIR_EraseRootFromParent_Done,
     /*  671418 */   // Label 10678: @671418
     /*  671418 */   GIM_Try, /*On fail goto*//*Label 10679*/ GIMT_Encode4(671493), // Rule ID 10359 //
     /*  671423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  671434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  671437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  671440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  671443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671491 */     GIR_RootConstrainSelectedInstOperands,
     /*  671492 */     // GIR_Coverage, 10359,
     /*  671492 */     GIR_EraseRootFromParent_Done,
     /*  671493 */   // Label 10679: @671493
     /*  671493 */   GIM_Try, /*On fail goto*//*Label 10680*/ GIMT_Encode4(671568), // Rule ID 10362 //
     /*  671498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  671509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  671512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  671515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  671518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  671544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  671547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671566 */     GIR_RootConstrainSelectedInstOperands,
     /*  671567 */     // GIR_Coverage, 10362,
     /*  671567 */     GIR_EraseRootFromParent_Done,
     /*  671568 */   // Label 10680: @671568
     /*  671568 */   GIM_Try, /*On fail goto*//*Label 10681*/ GIMT_Encode4(671643), // Rule ID 10363 //
     /*  671573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  671584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  671587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  671590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  671593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671619 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  671619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  671622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  671638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671641 */     GIR_RootConstrainSelectedInstOperands,
     /*  671642 */     // GIR_Coverage, 10363,
     /*  671642 */     GIR_EraseRootFromParent_Done,
     /*  671643 */   // Label 10681: @671643
     /*  671643 */   GIM_Try, /*On fail goto*//*Label 10682*/ GIMT_Encode4(671718), // Rule ID 10366 //
     /*  671648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  671659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  671662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  671665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  671668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671716 */     GIR_RootConstrainSelectedInstOperands,
     /*  671717 */     // GIR_Coverage, 10366,
     /*  671717 */     GIR_EraseRootFromParent_Done,
     /*  671718 */   // Label 10682: @671718
     /*  671718 */   GIM_Try, /*On fail goto*//*Label 10683*/ GIMT_Encode4(671793), // Rule ID 10367 //
     /*  671723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  671734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  671737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  671740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  671743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  671762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  671772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671791 */     GIR_RootConstrainSelectedInstOperands,
     /*  671792 */     // GIR_Coverage, 10367,
     /*  671792 */     GIR_EraseRootFromParent_Done,
     /*  671793 */   // Label 10683: @671793
     /*  671793 */   GIM_Try, /*On fail goto*//*Label 10684*/ GIMT_Encode4(671868), // Rule ID 10370 //
     /*  671798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  671809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  671812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  671815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  671818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671866 */     GIR_RootConstrainSelectedInstOperands,
     /*  671867 */     // GIR_Coverage, 10370,
     /*  671867 */     GIR_EraseRootFromParent_Done,
     /*  671868 */   // Label 10684: @671868
     /*  671868 */   GIM_Try, /*On fail goto*//*Label 10685*/ GIMT_Encode4(671943), // Rule ID 10371 //
     /*  671873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  671876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  671884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  671887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  671890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  671893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  671896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  671912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  671919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  671922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  671926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  671928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  671930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  671935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  671938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  671941 */     GIR_RootConstrainSelectedInstOperands,
     /*  671942 */     // GIR_Coverage, 10371,
     /*  671942 */     GIR_EraseRootFromParent_Done,
     /*  671943 */   // Label 10685: @671943
     /*  671943 */   GIM_Try, /*On fail goto*//*Label 10686*/ GIMT_Encode4(672018), // Rule ID 10374 //
     /*  671948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  671951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  671956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  671959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  671962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  671965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  671968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  671971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  671987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  671994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  671994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  671997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  671999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672016 */     GIR_RootConstrainSelectedInstOperands,
     /*  672017 */     // GIR_Coverage, 10374,
     /*  672017 */     GIR_EraseRootFromParent_Done,
     /*  672018 */   // Label 10686: @672018
     /*  672018 */   GIM_Try, /*On fail goto*//*Label 10687*/ GIMT_Encode4(672093), // Rule ID 10375 //
     /*  672023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  672034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  672037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  672040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  672043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672069 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  672069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  672088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672091 */     GIR_RootConstrainSelectedInstOperands,
     /*  672092 */     // GIR_Coverage, 10375,
     /*  672092 */     GIR_EraseRootFromParent_Done,
     /*  672093 */   // Label 10687: @672093
     /*  672093 */   GIM_Try, /*On fail goto*//*Label 10688*/ GIMT_Encode4(672168), // Rule ID 10378 //
     /*  672098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672166 */     GIR_RootConstrainSelectedInstOperands,
     /*  672167 */     // GIR_Coverage, 10378,
     /*  672167 */     GIR_EraseRootFromParent_Done,
     /*  672168 */   // Label 10688: @672168
     /*  672168 */   GIM_Try, /*On fail goto*//*Label 10689*/ GIMT_Encode4(672243), // Rule ID 10379 //
     /*  672173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  672184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  672187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  672190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  672193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672241 */     GIR_RootConstrainSelectedInstOperands,
     /*  672242 */     // GIR_Coverage, 10379,
     /*  672242 */     GIR_EraseRootFromParent_Done,
     /*  672243 */   // Label 10689: @672243
     /*  672243 */   GIM_Try, /*On fail goto*//*Label 10690*/ GIMT_Encode4(672318), // Rule ID 10382 //
     /*  672248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672316 */     GIR_RootConstrainSelectedInstOperands,
     /*  672317 */     // GIR_Coverage, 10382,
     /*  672317 */     GIR_EraseRootFromParent_Done,
     /*  672318 */   // Label 10690: @672318
     /*  672318 */   GIM_Try, /*On fail goto*//*Label 10691*/ GIMT_Encode4(672393), // Rule ID 10383 //
     /*  672323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  672334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  672337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  672340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  672343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672391 */     GIR_RootConstrainSelectedInstOperands,
     /*  672392 */     // GIR_Coverage, 10383,
     /*  672392 */     GIR_EraseRootFromParent_Done,
     /*  672393 */   // Label 10691: @672393
     /*  672393 */   GIM_Try, /*On fail goto*//*Label 10692*/ GIMT_Encode4(672468), // Rule ID 10386 //
     /*  672398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  672401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  672409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  672412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  672415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  672418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  672444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672466 */     GIR_RootConstrainSelectedInstOperands,
     /*  672467 */     // GIR_Coverage, 10386,
     /*  672467 */     GIR_EraseRootFromParent_Done,
     /*  672468 */   // Label 10692: @672468
     /*  672468 */   GIM_Try, /*On fail goto*//*Label 10693*/ GIMT_Encode4(672543), // Rule ID 10387 //
     /*  672473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  672476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  672484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  672487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  672490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  672493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  672519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  672538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672541 */     GIR_RootConstrainSelectedInstOperands,
     /*  672542 */     // GIR_Coverage, 10387,
     /*  672542 */     GIR_EraseRootFromParent_Done,
     /*  672543 */   // Label 10693: @672543
     /*  672543 */   GIM_Try, /*On fail goto*//*Label 10694*/ GIMT_Encode4(672618), // Rule ID 10390 //
     /*  672548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  672559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  672562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  672565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  672568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672616 */     GIR_RootConstrainSelectedInstOperands,
     /*  672617 */     // GIR_Coverage, 10390,
     /*  672617 */     GIR_EraseRootFromParent_Done,
     /*  672618 */   // Label 10694: @672618
     /*  672618 */   GIM_Try, /*On fail goto*//*Label 10695*/ GIMT_Encode4(672693), // Rule ID 10391 //
     /*  672623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  672634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  672637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  672640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  672643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  672662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /*  672672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672691 */     GIR_RootConstrainSelectedInstOperands,
     /*  672692 */     // GIR_Coverage, 10391,
     /*  672692 */     GIR_EraseRootFromParent_Done,
     /*  672693 */   // Label 10695: @672693
     /*  672693 */   GIM_Try, /*On fail goto*//*Label 10696*/ GIMT_Encode4(672768), // Rule ID 10394 //
     /*  672698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  672709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  672712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  672715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  672718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672766 */     GIR_RootConstrainSelectedInstOperands,
     /*  672767 */     // GIR_Coverage, 10394,
     /*  672767 */     GIR_EraseRootFromParent_Done,
     /*  672768 */   // Label 10696: @672768
     /*  672768 */   GIM_Try, /*On fail goto*//*Label 10697*/ GIMT_Encode4(672843), // Rule ID 10395 //
     /*  672773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  672784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  672787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  672790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  672793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  672812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672819 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /*  672822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672841 */     GIR_RootConstrainSelectedInstOperands,
     /*  672842 */     // GIR_Coverage, 10395,
     /*  672842 */     GIR_EraseRootFromParent_Done,
     /*  672843 */   // Label 10697: @672843
     /*  672843 */   GIM_Try, /*On fail goto*//*Label 10698*/ GIMT_Encode4(672918), // Rule ID 10398 //
     /*  672848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  672851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  672859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  672862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  672865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  672868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  672871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  672894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672916 */     GIR_RootConstrainSelectedInstOperands,
     /*  672917 */     // GIR_Coverage, 10398,
     /*  672917 */     GIR_EraseRootFromParent_Done,
     /*  672918 */   // Label 10698: @672918
     /*  672918 */   GIM_Try, /*On fail goto*//*Label 10699*/ GIMT_Encode4(672993), // Rule ID 10399 //
     /*  672923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  672926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  672931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  672934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  672937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  672940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  672943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  672946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  672962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  672969 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  672969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /*  672972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  672974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  672976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  672978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  672980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  672985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  672988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  672991 */     GIR_RootConstrainSelectedInstOperands,
     /*  672992 */     // GIR_Coverage, 10399,
     /*  672992 */     GIR_EraseRootFromParent_Done,
     /*  672993 */   // Label 10699: @672993
     /*  672993 */   GIM_Try, /*On fail goto*//*Label 10700*/ GIMT_Encode4(673068), // Rule ID 10402 //
     /*  672998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673066 */     GIR_RootConstrainSelectedInstOperands,
     /*  673067 */     // GIR_Coverage, 10402,
     /*  673067 */     GIR_EraseRootFromParent_Done,
     /*  673068 */   // Label 10700: @673068
     /*  673068 */   GIM_Try, /*On fail goto*//*Label 10701*/ GIMT_Encode4(673143), // Rule ID 10403 //
     /*  673073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  673084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  673087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  673090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673119 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8),
     /*  673122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673141 */     GIR_RootConstrainSelectedInstOperands,
     /*  673142 */     // GIR_Coverage, 10403,
     /*  673142 */     GIR_EraseRootFromParent_Done,
     /*  673143 */   // Label 10701: @673143
     /*  673143 */   GIM_Try, /*On fail goto*//*Label 10702*/ GIMT_Encode4(673218), // Rule ID 10406 //
     /*  673148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673194 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673216 */     GIR_RootConstrainSelectedInstOperands,
     /*  673217 */     // GIR_Coverage, 10406,
     /*  673217 */     GIR_EraseRootFromParent_Done,
     /*  673218 */   // Label 10702: @673218
     /*  673218 */   GIM_Try, /*On fail goto*//*Label 10703*/ GIMT_Encode4(673293), // Rule ID 10407 //
     /*  673223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  673234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  673237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  673240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673269 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673291 */     GIR_RootConstrainSelectedInstOperands,
     /*  673292 */     // GIR_Coverage, 10407,
     /*  673292 */     GIR_EraseRootFromParent_Done,
     /*  673293 */   // Label 10703: @673293
     /*  673293 */   GIM_Try, /*On fail goto*//*Label 10704*/ GIMT_Encode4(673368), // Rule ID 10410 //
     /*  673298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673366 */     GIR_RootConstrainSelectedInstOperands,
     /*  673367 */     // GIR_Coverage, 10410,
     /*  673367 */     GIR_EraseRootFromParent_Done,
     /*  673368 */   // Label 10704: @673368
     /*  673368 */   GIM_Try, /*On fail goto*//*Label 10705*/ GIMT_Encode4(673443), // Rule ID 10411 //
     /*  673373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  673384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  673387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  673390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  673419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673441 */     GIR_RootConstrainSelectedInstOperands,
     /*  673442 */     // GIR_Coverage, 10411,
     /*  673442 */     GIR_EraseRootFromParent_Done,
     /*  673443 */   // Label 10705: @673443
     /*  673443 */   GIM_Try, /*On fail goto*//*Label 10706*/ GIMT_Encode4(673518), // Rule ID 10414 //
     /*  673448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  673459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  673462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  673465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  673494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673516 */     GIR_RootConstrainSelectedInstOperands,
     /*  673517 */     // GIR_Coverage, 10414,
     /*  673517 */     GIR_EraseRootFromParent_Done,
     /*  673518 */   // Label 10706: @673518
     /*  673518 */   GIM_Try, /*On fail goto*//*Label 10707*/ GIMT_Encode4(673593), // Rule ID 10415 //
     /*  673523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  673534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  673537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  673540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4),
     /*  673572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673591 */     GIR_RootConstrainSelectedInstOperands,
     /*  673592 */     // GIR_Coverage, 10415,
     /*  673592 */     GIR_EraseRootFromParent_Done,
     /*  673593 */   // Label 10707: @673593
     /*  673593 */   GIM_Try, /*On fail goto*//*Label 10708*/ GIMT_Encode4(673668), // Rule ID 10418 //
     /*  673598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  673609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  673612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  673615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673644 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  673644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673666 */     GIR_RootConstrainSelectedInstOperands,
     /*  673667 */     // GIR_Coverage, 10418,
     /*  673667 */     GIR_EraseRootFromParent_Done,
     /*  673668 */   // Label 10708: @673668
     /*  673668 */   GIM_Try, /*On fail goto*//*Label 10709*/ GIMT_Encode4(673743), // Rule ID 10419 //
     /*  673673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  673684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  673687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  673690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673719 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  673719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  673738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673741 */     GIR_RootConstrainSelectedInstOperands,
     /*  673742 */     // GIR_Coverage, 10419,
     /*  673742 */     GIR_EraseRootFromParent_Done,
     /*  673743 */   // Label 10709: @673743
     /*  673743 */   GIM_Try, /*On fail goto*//*Label 10710*/ GIMT_Encode4(673818), // Rule ID 10422 //
     /*  673748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  673759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  673762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  673765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  673794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673816 */     GIR_RootConstrainSelectedInstOperands,
     /*  673817 */     // GIR_Coverage, 10422,
     /*  673817 */     GIR_EraseRootFromParent_Done,
     /*  673818 */   // Label 10710: @673818
     /*  673818 */   GIM_Try, /*On fail goto*//*Label 10711*/ GIMT_Encode4(673893), // Rule ID 10423 //
     /*  673823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  673834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  673837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  673840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  673869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2),
     /*  673872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  673888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673891 */     GIR_RootConstrainSelectedInstOperands,
     /*  673892 */     // GIR_Coverage, 10423,
     /*  673892 */     GIR_EraseRootFromParent_Done,
     /*  673893 */   // Label 10711: @673893
     /*  673893 */   GIM_Try, /*On fail goto*//*Label 10712*/ GIMT_Encode4(673968), // Rule ID 10426 //
     /*  673898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  673901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  673909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  673912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  673915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  673918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  673921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  673933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  673937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  673944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  673944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  673947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  673949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  673951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  673953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  673955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  673960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  673963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  673966 */     GIR_RootConstrainSelectedInstOperands,
     /*  673967 */     // GIR_Coverage, 10426,
     /*  673967 */     GIR_EraseRootFromParent_Done,
     /*  673968 */   // Label 10712: @673968
     /*  673968 */   GIM_Try, /*On fail goto*//*Label 10713*/ GIMT_Encode4(674043), // Rule ID 10427 //
     /*  673973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  673976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  673981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  673984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  673987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  673990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  673993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  673996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11363:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674041 */     GIR_RootConstrainSelectedInstOperands,
     /*  674042 */     // GIR_Coverage, 10427,
     /*  674042 */     GIR_EraseRootFromParent_Done,
     /*  674043 */   // Label 10713: @674043
     /*  674043 */   GIM_Try, /*On fail goto*//*Label 10714*/ GIMT_Encode4(674118), // Rule ID 10430 //
     /*  674048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674116 */     GIR_RootConstrainSelectedInstOperands,
     /*  674117 */     // GIR_Coverage, 10430,
     /*  674117 */     GIR_EraseRootFromParent_Done,
     /*  674118 */   // Label 10714: @674118
     /*  674118 */   GIM_Try, /*On fail goto*//*Label 10715*/ GIMT_Encode4(674193), // Rule ID 10431 //
     /*  674123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  674134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  674137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  674140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674169 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11363:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  674169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  674188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674191 */     GIR_RootConstrainSelectedInstOperands,
     /*  674192 */     // GIR_Coverage, 10431,
     /*  674192 */     GIR_EraseRootFromParent_Done,
     /*  674193 */   // Label 10715: @674193
     /*  674193 */   GIM_Try, /*On fail goto*//*Label 10716*/ GIMT_Encode4(674268), // Rule ID 10434 //
     /*  674198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  674244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674266 */     GIR_RootConstrainSelectedInstOperands,
     /*  674267 */     // GIR_Coverage, 10434,
     /*  674267 */     GIR_EraseRootFromParent_Done,
     /*  674268 */   // Label 10716: @674268
     /*  674268 */   GIM_Try, /*On fail goto*//*Label 10717*/ GIMT_Encode4(674343), // Rule ID 10435 //
     /*  674273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  674284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  674287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  674290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674319 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11363:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  674319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  674338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674341 */     GIR_RootConstrainSelectedInstOperands,
     /*  674342 */     // GIR_Coverage, 10435,
     /*  674342 */     GIR_EraseRootFromParent_Done,
     /*  674343 */   // Label 10717: @674343
     /*  674343 */   GIM_Try, /*On fail goto*//*Label 10718*/ GIMT_Encode4(674418), // Rule ID 10438 //
     /*  674348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  674351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  674394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674416 */     GIR_RootConstrainSelectedInstOperands,
     /*  674417 */     // GIR_Coverage, 10438,
     /*  674417 */     GIR_EraseRootFromParent_Done,
     /*  674418 */   // Label 10718: @674418
     /*  674418 */   GIM_Try, /*On fail goto*//*Label 10719*/ GIMT_Encode4(674493), // Rule ID 10439 //
     /*  674423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  674426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  674434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  674437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  674440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  674458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674469 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11363:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  674469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1),
     /*  674472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  674488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674491 */     GIR_RootConstrainSelectedInstOperands,
     /*  674492 */     // GIR_Coverage, 10439,
     /*  674492 */     GIR_EraseRootFromParent_Done,
     /*  674493 */   // Label 10719: @674493
     /*  674493 */   GIM_Try, /*On fail goto*//*Label 10720*/ GIMT_Encode4(674568), // Rule ID 10442 //
     /*  674498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  674509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  674512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  674515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  674547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674566 */     GIR_RootConstrainSelectedInstOperands,
     /*  674567 */     // GIR_Coverage, 10442,
     /*  674567 */     GIR_EraseRootFromParent_Done,
     /*  674568 */   // Label 10720: @674568
     /*  674568 */   GIM_Try, /*On fail goto*//*Label 10721*/ GIMT_Encode4(674643), // Rule ID 10443 //
     /*  674573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  674584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  674587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  674590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674619 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  674622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674641 */     GIR_RootConstrainSelectedInstOperands,
     /*  674642 */     // GIR_Coverage, 10443,
     /*  674642 */     GIR_EraseRootFromParent_Done,
     /*  674643 */   // Label 10721: @674643
     /*  674643 */   GIM_Try, /*On fail goto*//*Label 10722*/ GIMT_Encode4(674718), // Rule ID 10446 //
     /*  674648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  674659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  674662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  674665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  674697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674716 */     GIR_RootConstrainSelectedInstOperands,
     /*  674717 */     // GIR_Coverage, 10446,
     /*  674717 */     GIR_EraseRootFromParent_Done,
     /*  674718 */   // Label 10722: @674718
     /*  674718 */   GIM_Try, /*On fail goto*//*Label 10723*/ GIMT_Encode4(674793), // Rule ID 10447 //
     /*  674723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  674734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  674737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  674740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  674758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674769 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  674772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674791 */     GIR_RootConstrainSelectedInstOperands,
     /*  674792 */     // GIR_Coverage, 10447,
     /*  674792 */     GIR_EraseRootFromParent_Done,
     /*  674793 */   // Label 10723: @674793
     /*  674793 */   GIM_Try, /*On fail goto*//*Label 10724*/ GIMT_Encode4(674868), // Rule ID 10450 //
     /*  674798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  674809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  674812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  674815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  674844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  674847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674866 */     GIR_RootConstrainSelectedInstOperands,
     /*  674867 */     // GIR_Coverage, 10450,
     /*  674867 */     GIR_EraseRootFromParent_Done,
     /*  674868 */   // Label 10724: @674868
     /*  674868 */   GIM_Try, /*On fail goto*//*Label 10725*/ GIMT_Encode4(674943), // Rule ID 10451 //
     /*  674873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  674876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  674884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  674887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  674890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  674893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  674896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  674908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674919 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  674919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  674922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  674926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  674928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  674930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  674935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  674938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  674941 */     GIR_RootConstrainSelectedInstOperands,
     /*  674942 */     // GIR_Coverage, 10451,
     /*  674942 */     GIR_EraseRootFromParent_Done,
     /*  674943 */   // Label 10725: @674943
     /*  674943 */   GIM_Try, /*On fail goto*//*Label 10726*/ GIMT_Encode4(675018), // Rule ID 10454 //
     /*  674948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  674951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  674956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  674959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  674962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  674965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  674968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  674971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  674983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  674987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  674994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  674994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  674997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  674999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675016 */     GIR_RootConstrainSelectedInstOperands,
     /*  675017 */     // GIR_Coverage, 10454,
     /*  675017 */     GIR_EraseRootFromParent_Done,
     /*  675018 */   // Label 10726: @675018
     /*  675018 */   GIM_Try, /*On fail goto*//*Label 10727*/ GIMT_Encode4(675093), // Rule ID 10455 //
     /*  675023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  675034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  675037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  675040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675091 */     GIR_RootConstrainSelectedInstOperands,
     /*  675092 */     // GIR_Coverage, 10455,
     /*  675092 */     GIR_EraseRootFromParent_Done,
     /*  675093 */   // Label 10727: @675093
     /*  675093 */   GIM_Try, /*On fail goto*//*Label 10728*/ GIMT_Encode4(675168), // Rule ID 10458 //
     /*  675098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675166 */     GIR_RootConstrainSelectedInstOperands,
     /*  675167 */     // GIR_Coverage, 10458,
     /*  675167 */     GIR_EraseRootFromParent_Done,
     /*  675168 */   // Label 10728: @675168
     /*  675168 */   GIM_Try, /*On fail goto*//*Label 10729*/ GIMT_Encode4(675243), // Rule ID 10459 //
     /*  675173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  675184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  675187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  675190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675241 */     GIR_RootConstrainSelectedInstOperands,
     /*  675242 */     // GIR_Coverage, 10459,
     /*  675242 */     GIR_EraseRootFromParent_Done,
     /*  675243 */   // Label 10729: @675243
     /*  675243 */   GIM_Try, /*On fail goto*//*Label 10730*/ GIMT_Encode4(675318), // Rule ID 10462 //
     /*  675248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  675294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675316 */     GIR_RootConstrainSelectedInstOperands,
     /*  675317 */     // GIR_Coverage, 10462,
     /*  675317 */     GIR_EraseRootFromParent_Done,
     /*  675318 */   // Label 10730: @675318
     /*  675318 */   GIM_Try, /*On fail goto*//*Label 10731*/ GIMT_Encode4(675393), // Rule ID 10463 //
     /*  675323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  675334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  675337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  675340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675369 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  675369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  675388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675391 */     GIR_RootConstrainSelectedInstOperands,
     /*  675392 */     // GIR_Coverage, 10463,
     /*  675392 */     GIR_EraseRootFromParent_Done,
     /*  675393 */   // Label 10731: @675393
     /*  675393 */   GIM_Try, /*On fail goto*//*Label 10732*/ GIMT_Encode4(675468), // Rule ID 10466 //
     /*  675398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  675409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  675412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  675415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675466 */     GIR_RootConstrainSelectedInstOperands,
     /*  675467 */     // GIR_Coverage, 10466,
     /*  675467 */     GIR_EraseRootFromParent_Done,
     /*  675468 */   // Label 10732: @675468
     /*  675468 */   GIM_Try, /*On fail goto*//*Label 10733*/ GIMT_Encode4(675543), // Rule ID 10467 //
     /*  675473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  675484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  675487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  675490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675541 */     GIR_RootConstrainSelectedInstOperands,
     /*  675542 */     // GIR_Coverage, 10467,
     /*  675542 */     GIR_EraseRootFromParent_Done,
     /*  675543 */   // Label 10733: @675543
     /*  675543 */   GIM_Try, /*On fail goto*//*Label 10734*/ GIMT_Encode4(675618), // Rule ID 10470 //
     /*  675548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  675559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  675562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  675565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675616 */     GIR_RootConstrainSelectedInstOperands,
     /*  675617 */     // GIR_Coverage, 10470,
     /*  675617 */     GIR_EraseRootFromParent_Done,
     /*  675618 */   // Label 10734: @675618
     /*  675618 */   GIM_Try, /*On fail goto*//*Label 10735*/ GIMT_Encode4(675693), // Rule ID 10471 //
     /*  675623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  675634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  675637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  675640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  675658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  675672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675691 */     GIR_RootConstrainSelectedInstOperands,
     /*  675692 */     // GIR_Coverage, 10471,
     /*  675692 */     GIR_EraseRootFromParent_Done,
     /*  675693 */   // Label 10735: @675693
     /*  675693 */   GIM_Try, /*On fail goto*//*Label 10736*/ GIMT_Encode4(675768), // Rule ID 10474 //
     /*  675698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  675701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  675709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  675712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  675715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  675744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675766 */     GIR_RootConstrainSelectedInstOperands,
     /*  675767 */     // GIR_Coverage, 10474,
     /*  675767 */     GIR_EraseRootFromParent_Done,
     /*  675768 */   // Label 10736: @675768
     /*  675768 */   GIM_Try, /*On fail goto*//*Label 10737*/ GIMT_Encode4(675843), // Rule ID 10475 //
     /*  675773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  675776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  675784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  675787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  675790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  675808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  675819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  675822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  675838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675841 */     GIR_RootConstrainSelectedInstOperands,
     /*  675842 */     // GIR_Coverage, 10475,
     /*  675842 */     GIR_EraseRootFromParent_Done,
     /*  675843 */   // Label 10737: @675843
     /*  675843 */   GIM_Try, /*On fail goto*//*Label 10738*/ GIMT_Encode4(675918), // Rule ID 10478 //
     /*  675848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  675851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  675859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  675862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  675865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  675868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  675871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  675894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675916 */     GIR_RootConstrainSelectedInstOperands,
     /*  675917 */     // GIR_Coverage, 10478,
     /*  675917 */     GIR_EraseRootFromParent_Done,
     /*  675918 */   // Label 10738: @675918
     /*  675918 */   GIM_Try, /*On fail goto*//*Label 10739*/ GIMT_Encode4(675993), // Rule ID 10479 //
     /*  675923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  675926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  675931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  675934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  675937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  675940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  675943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  675946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  675958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  675962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  675969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11363:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  675969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2),
     /*  675972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  675974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  675976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  675978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  675980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  675985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  675988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  675991 */     GIR_RootConstrainSelectedInstOperands,
     /*  675992 */     // GIR_Coverage, 10479,
     /*  675992 */     GIR_EraseRootFromParent_Done,
     /*  675993 */   // Label 10739: @675993
     /*  675993 */   GIM_Try, /*On fail goto*//*Label 10740*/ GIMT_Encode4(676068), // Rule ID 10482 //
     /*  675998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676066 */     GIR_RootConstrainSelectedInstOperands,
     /*  676067 */     // GIR_Coverage, 10482,
     /*  676067 */     GIR_EraseRootFromParent_Done,
     /*  676068 */   // Label 10740: @676068
     /*  676068 */   GIM_Try, /*On fail goto*//*Label 10741*/ GIMT_Encode4(676143), // Rule ID 10483 //
     /*  676073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  676084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  676087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  676090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  676108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11363:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4),
     /*  676122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676141 */     GIR_RootConstrainSelectedInstOperands,
     /*  676142 */     // GIR_Coverage, 10483,
     /*  676142 */     GIR_EraseRootFromParent_Done,
     /*  676143 */   // Label 10741: @676143
     /*  676143 */   GIM_Try, /*On fail goto*//*Label 10742*/ GIMT_Encode4(676218), // Rule ID 10486 //
     /*  676148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  676151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  676168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  676194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676216 */     GIR_RootConstrainSelectedInstOperands,
     /*  676217 */     // GIR_Coverage, 10486,
     /*  676217 */     GIR_EraseRootFromParent_Done,
     /*  676218 */   // Label 10742: @676218
     /*  676218 */   GIM_Try, /*On fail goto*//*Label 10743*/ GIMT_Encode4(676293), // Rule ID 10487 //
     /*  676223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  676226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin),
     /*  676231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  676234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  676237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  676240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  676243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  676258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  676262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11363:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMIN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  676269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8),
     /*  676272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  676288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676291 */     GIR_RootConstrainSelectedInstOperands,
     /*  676292 */     // GIR_Coverage, 10487,
     /*  676292 */     GIR_EraseRootFromParent_Done,
     /*  676293 */   // Label 10743: @676293
     /*  676293 */   GIM_Try, /*On fail goto*//*Label 10744*/ GIMT_Encode4(676368), // Rule ID 10490 //
     /*  676298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676344 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676366 */     GIR_RootConstrainSelectedInstOperands,
     /*  676367 */     // GIR_Coverage, 10490,
     /*  676367 */     GIR_EraseRootFromParent_Done,
     /*  676368 */   // Label 10744: @676368
     /*  676368 */   GIM_Try, /*On fail goto*//*Label 10745*/ GIMT_Encode4(676443), // Rule ID 10491 //
     /*  676373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  676384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  676387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  676390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  676393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676419 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /*  676422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676441 */     GIR_RootConstrainSelectedInstOperands,
     /*  676442 */     // GIR_Coverage, 10491,
     /*  676442 */     GIR_EraseRootFromParent_Done,
     /*  676443 */   // Label 10745: @676443
     /*  676443 */   GIM_Try, /*On fail goto*//*Label 10746*/ GIMT_Encode4(676518), // Rule ID 10494 //
     /*  676448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  676459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  676462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  676465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  676468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  676497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676516 */     GIR_RootConstrainSelectedInstOperands,
     /*  676517 */     // GIR_Coverage, 10494,
     /*  676517 */     GIR_EraseRootFromParent_Done,
     /*  676518 */   // Label 10746: @676518
     /*  676518 */   GIM_Try, /*On fail goto*//*Label 10747*/ GIMT_Encode4(676593), // Rule ID 10495 //
     /*  676523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  676534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  676537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  676540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  676543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676569 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  676572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676591 */     GIR_RootConstrainSelectedInstOperands,
     /*  676592 */     // GIR_Coverage, 10495,
     /*  676592 */     GIR_EraseRootFromParent_Done,
     /*  676593 */   // Label 10747: @676593
     /*  676593 */   GIM_Try, /*On fail goto*//*Label 10748*/ GIMT_Encode4(676668), // Rule ID 10498 //
     /*  676598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  676609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  676612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  676615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  676618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676644 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  676644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  676647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676666 */     GIR_RootConstrainSelectedInstOperands,
     /*  676667 */     // GIR_Coverage, 10498,
     /*  676667 */     GIR_EraseRootFromParent_Done,
     /*  676668 */   // Label 10748: @676668
     /*  676668 */   GIM_Try, /*On fail goto*//*Label 10749*/ GIMT_Encode4(676743), // Rule ID 10499 //
     /*  676673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  676684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  676687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  676690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  676693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676719 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  676719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  676722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  676738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676741 */     GIR_RootConstrainSelectedInstOperands,
     /*  676742 */     // GIR_Coverage, 10499,
     /*  676742 */     GIR_EraseRootFromParent_Done,
     /*  676743 */   // Label 10749: @676743
     /*  676743 */   GIM_Try, /*On fail goto*//*Label 10750*/ GIMT_Encode4(676818), // Rule ID 10502 //
     /*  676748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  676759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  676762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  676765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  676768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  676797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676816 */     GIR_RootConstrainSelectedInstOperands,
     /*  676817 */     // GIR_Coverage, 10502,
     /*  676817 */     GIR_EraseRootFromParent_Done,
     /*  676818 */   // Label 10750: @676818
     /*  676818 */   GIM_Try, /*On fail goto*//*Label 10751*/ GIMT_Encode4(676893), // Rule ID 10503 //
     /*  676823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  676834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  676837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  676840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  676843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  676869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /*  676872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676891 */     GIR_RootConstrainSelectedInstOperands,
     /*  676892 */     // GIR_Coverage, 10503,
     /*  676892 */     GIR_EraseRootFromParent_Done,
     /*  676893 */   // Label 10751: @676893
     /*  676893 */   GIM_Try, /*On fail goto*//*Label 10752*/ GIMT_Encode4(676968), // Rule ID 10506 //
     /*  676898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  676901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  676909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  676912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  676915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  676918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  676921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  676937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  676944 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  676944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  676947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  676949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  676951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  676953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  676955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  676960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  676963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  676966 */     GIR_RootConstrainSelectedInstOperands,
     /*  676967 */     // GIR_Coverage, 10506,
     /*  676967 */     GIR_EraseRootFromParent_Done,
     /*  676968 */   // Label 10752: @676968
     /*  676968 */   GIM_Try, /*On fail goto*//*Label 10753*/ GIMT_Encode4(677043), // Rule ID 10507 //
     /*  676973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  676976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  676981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  676984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  676987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  676990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  676993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  676996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677019 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677041 */     GIR_RootConstrainSelectedInstOperands,
     /*  677042 */     // GIR_Coverage, 10507,
     /*  677042 */     GIR_EraseRootFromParent_Done,
     /*  677043 */   // Label 10753: @677043
     /*  677043 */   GIM_Try, /*On fail goto*//*Label 10754*/ GIMT_Encode4(677118), // Rule ID 10510 //
     /*  677048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677094 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  677094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677116 */     GIR_RootConstrainSelectedInstOperands,
     /*  677117 */     // GIR_Coverage, 10510,
     /*  677117 */     GIR_EraseRootFromParent_Done,
     /*  677118 */   // Label 10754: @677118
     /*  677118 */   GIM_Try, /*On fail goto*//*Label 10755*/ GIMT_Encode4(677193), // Rule ID 10511 //
     /*  677123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  677134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  677137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  677140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  677143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677169 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  677169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /*  677172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677191 */     GIR_RootConstrainSelectedInstOperands,
     /*  677192 */     // GIR_Coverage, 10511,
     /*  677192 */     GIR_EraseRootFromParent_Done,
     /*  677193 */   // Label 10755: @677193
     /*  677193 */   GIM_Try, /*On fail goto*//*Label 10756*/ GIMT_Encode4(677268), // Rule ID 10514 //
     /*  677198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677244 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677266 */     GIR_RootConstrainSelectedInstOperands,
     /*  677267 */     // GIR_Coverage, 10514,
     /*  677267 */     GIR_EraseRootFromParent_Done,
     /*  677268 */   // Label 10756: @677268
     /*  677268 */   GIM_Try, /*On fail goto*//*Label 10757*/ GIMT_Encode4(677343), // Rule ID 10515 //
     /*  677273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  677284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  677287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  677290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  677293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677319 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677341 */     GIR_RootConstrainSelectedInstOperands,
     /*  677342 */     // GIR_Coverage, 10515,
     /*  677342 */     GIR_EraseRootFromParent_Done,
     /*  677343 */   // Label 10757: @677343
     /*  677343 */   GIM_Try, /*On fail goto*//*Label 10758*/ GIMT_Encode4(677418), // Rule ID 10518 //
     /*  677348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  677394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677416 */     GIR_RootConstrainSelectedInstOperands,
     /*  677417 */     // GIR_Coverage, 10518,
     /*  677417 */     GIR_EraseRootFromParent_Done,
     /*  677418 */   // Label 10758: @677418
     /*  677418 */   GIM_Try, /*On fail goto*//*Label 10759*/ GIMT_Encode4(677493), // Rule ID 10519 //
     /*  677423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  677434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  677437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  677440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  677443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  677469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  677488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677491 */     GIR_RootConstrainSelectedInstOperands,
     /*  677492 */     // GIR_Coverage, 10519,
     /*  677492 */     GIR_EraseRootFromParent_Done,
     /*  677493 */   // Label 10759: @677493
     /*  677493 */   GIM_Try, /*On fail goto*//*Label 10760*/ GIMT_Encode4(677568), // Rule ID 10522 //
     /*  677498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  677509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  677512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  677515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  677518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  677544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677566 */     GIR_RootConstrainSelectedInstOperands,
     /*  677567 */     // GIR_Coverage, 10522,
     /*  677567 */     GIR_EraseRootFromParent_Done,
     /*  677568 */   // Label 10760: @677568
     /*  677568 */   GIM_Try, /*On fail goto*//*Label 10761*/ GIMT_Encode4(677643), // Rule ID 10523 //
     /*  677573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  677584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  677587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  677590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  677593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  677619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  677638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677641 */     GIR_RootConstrainSelectedInstOperands,
     /*  677642 */     // GIR_Coverage, 10523,
     /*  677642 */     GIR_EraseRootFromParent_Done,
     /*  677643 */   // Label 10761: @677643
     /*  677643 */   GIM_Try, /*On fail goto*//*Label 10762*/ GIMT_Encode4(677718), // Rule ID 10526 //
     /*  677648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  677651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  677659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  677662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  677665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  677668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677694 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  677694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677716 */     GIR_RootConstrainSelectedInstOperands,
     /*  677717 */     // GIR_Coverage, 10526,
     /*  677717 */     GIR_EraseRootFromParent_Done,
     /*  677718 */   // Label 10762: @677718
     /*  677718 */   GIM_Try, /*On fail goto*//*Label 10763*/ GIMT_Encode4(677793), // Rule ID 10527 //
     /*  677723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  677726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  677734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  677737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  677740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  677743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  677762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677769 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  677769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /*  677772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  677788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677791 */     GIR_RootConstrainSelectedInstOperands,
     /*  677792 */     // GIR_Coverage, 10527,
     /*  677792 */     GIR_EraseRootFromParent_Done,
     /*  677793 */   // Label 10763: @677793
     /*  677793 */   GIM_Try, /*On fail goto*//*Label 10764*/ GIMT_Encode4(677868), // Rule ID 10530 //
     /*  677798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  677809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  677812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  677815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  677818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  677847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677866 */     GIR_RootConstrainSelectedInstOperands,
     /*  677867 */     // GIR_Coverage, 10530,
     /*  677867 */     GIR_EraseRootFromParent_Done,
     /*  677868 */   // Label 10764: @677868
     /*  677868 */   GIM_Try, /*On fail goto*//*Label 10765*/ GIMT_Encode4(677943), // Rule ID 10531 //
     /*  677873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  677876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  677884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  677887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  677890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  677893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  677896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  677912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677919 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  677919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  677922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  677926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  677928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  677930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  677935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  677938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  677941 */     GIR_RootConstrainSelectedInstOperands,
     /*  677942 */     // GIR_Coverage, 10531,
     /*  677942 */     GIR_EraseRootFromParent_Done,
     /*  677943 */   // Label 10765: @677943
     /*  677943 */   GIM_Try, /*On fail goto*//*Label 10766*/ GIMT_Encode4(678018), // Rule ID 10534 //
     /*  677948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  677951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  677956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  677959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  677962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  677965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  677968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  677971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  677987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  677994 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  677994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  677997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  677999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678016 */     GIR_RootConstrainSelectedInstOperands,
     /*  678017 */     // GIR_Coverage, 10534,
     /*  678017 */     GIR_EraseRootFromParent_Done,
     /*  678018 */   // Label 10766: @678018
     /*  678018 */   GIM_Try, /*On fail goto*//*Label 10767*/ GIMT_Encode4(678093), // Rule ID 10535 //
     /*  678023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  678034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  678037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  678040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  678043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678069 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678091 */     GIR_RootConstrainSelectedInstOperands,
     /*  678092 */     // GIR_Coverage, 10535,
     /*  678092 */     GIR_EraseRootFromParent_Done,
     /*  678093 */   // Label 10767: @678093
     /*  678093 */   GIM_Try, /*On fail goto*//*Label 10768*/ GIMT_Encode4(678168), // Rule ID 10538 //
     /*  678098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  678144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678166 */     GIR_RootConstrainSelectedInstOperands,
     /*  678167 */     // GIR_Coverage, 10538,
     /*  678167 */     GIR_EraseRootFromParent_Done,
     /*  678168 */   // Label 10768: @678168
     /*  678168 */   GIM_Try, /*On fail goto*//*Label 10769*/ GIMT_Encode4(678243), // Rule ID 10539 //
     /*  678173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  678184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  678187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  678190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  678193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678219 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  678219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  678238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678241 */     GIR_RootConstrainSelectedInstOperands,
     /*  678242 */     // GIR_Coverage, 10539,
     /*  678242 */     GIR_EraseRootFromParent_Done,
     /*  678243 */   // Label 10769: @678243
     /*  678243 */   GIM_Try, /*On fail goto*//*Label 10770*/ GIMT_Encode4(678318), // Rule ID 10542 //
     /*  678248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678316 */     GIR_RootConstrainSelectedInstOperands,
     /*  678317 */     // GIR_Coverage, 10542,
     /*  678317 */     GIR_EraseRootFromParent_Done,
     /*  678318 */   // Label 10770: @678318
     /*  678318 */   GIM_Try, /*On fail goto*//*Label 10771*/ GIMT_Encode4(678393), // Rule ID 10543 //
     /*  678323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  678334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  678337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  678340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  678343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678391 */     GIR_RootConstrainSelectedInstOperands,
     /*  678392 */     // GIR_Coverage, 10543,
     /*  678392 */     GIR_EraseRootFromParent_Done,
     /*  678393 */   // Label 10771: @678393
     /*  678393 */   GIM_Try, /*On fail goto*//*Label 10772*/ GIMT_Encode4(678468), // Rule ID 10546 //
     /*  678398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  678409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  678412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  678415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  678418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678466 */     GIR_RootConstrainSelectedInstOperands,
     /*  678467 */     // GIR_Coverage, 10546,
     /*  678467 */     GIR_EraseRootFromParent_Done,
     /*  678468 */   // Label 10772: @678468
     /*  678468 */   GIM_Try, /*On fail goto*//*Label 10773*/ GIMT_Encode4(678543), // Rule ID 10547 //
     /*  678473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  678484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  678487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  678490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  678493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678519 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678541 */     GIR_RootConstrainSelectedInstOperands,
     /*  678542 */     // GIR_Coverage, 10547,
     /*  678542 */     GIR_EraseRootFromParent_Done,
     /*  678543 */   // Label 10773: @678543
     /*  678543 */   GIM_Try, /*On fail goto*//*Label 10774*/ GIMT_Encode4(678618), // Rule ID 10550 //
     /*  678548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  678559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  678562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  678565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  678568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  678594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678616 */     GIR_RootConstrainSelectedInstOperands,
     /*  678617 */     // GIR_Coverage, 10550,
     /*  678617 */     GIR_EraseRootFromParent_Done,
     /*  678618 */   // Label 10774: @678618
     /*  678618 */   GIM_Try, /*On fail goto*//*Label 10775*/ GIMT_Encode4(678693), // Rule ID 10551 //
     /*  678623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  678634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  678637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  678640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  678643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  678662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  678669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  678672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  678688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678691 */     GIR_RootConstrainSelectedInstOperands,
     /*  678692 */     // GIR_Coverage, 10551,
     /*  678692 */     GIR_EraseRootFromParent_Done,
     /*  678693 */   // Label 10775: @678693
     /*  678693 */   GIM_Try, /*On fail goto*//*Label 10776*/ GIMT_Encode4(678768), // Rule ID 10554 //
     /*  678698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  678709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  678712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  678715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  678718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678744 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678766 */     GIR_RootConstrainSelectedInstOperands,
     /*  678767 */     // GIR_Coverage, 10554,
     /*  678767 */     GIR_EraseRootFromParent_Done,
     /*  678768 */   // Label 10776: @678768
     /*  678768 */   GIM_Try, /*On fail goto*//*Label 10777*/ GIMT_Encode4(678843), // Rule ID 10555 //
     /*  678773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  678784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  678787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  678790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  678793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  678812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  678822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678841 */     GIR_RootConstrainSelectedInstOperands,
     /*  678842 */     // GIR_Coverage, 10555,
     /*  678842 */     GIR_EraseRootFromParent_Done,
     /*  678843 */   // Label 10777: @678843
     /*  678843 */   GIM_Try, /*On fail goto*//*Label 10778*/ GIMT_Encode4(678918), // Rule ID 10558 //
     /*  678848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  678851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  678859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  678862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  678865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  678868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  678871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  678894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678916 */     GIR_RootConstrainSelectedInstOperands,
     /*  678917 */     // GIR_Coverage, 10558,
     /*  678917 */     GIR_EraseRootFromParent_Done,
     /*  678918 */   // Label 10778: @678918
     /*  678918 */   GIM_Try, /*On fail goto*//*Label 10779*/ GIMT_Encode4(678993), // Rule ID 10559 //
     /*  678923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  678926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  678931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  678934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  678937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  678940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  678943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  678946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  678962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  678969 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  678969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  678972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  678974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  678976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  678978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  678980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  678985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  678988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  678991 */     GIR_RootConstrainSelectedInstOperands,
     /*  678992 */     // GIR_Coverage, 10559,
     /*  678992 */     GIR_EraseRootFromParent_Done,
     /*  678993 */   // Label 10779: @678993
     /*  678993 */   GIM_Try, /*On fail goto*//*Label 10780*/ GIMT_Encode4(679068), // Rule ID 10562 //
     /*  678998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  679044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679066 */     GIR_RootConstrainSelectedInstOperands,
     /*  679067 */     // GIR_Coverage, 10562,
     /*  679067 */     GIR_EraseRootFromParent_Done,
     /*  679068 */   // Label 10780: @679068
     /*  679068 */   GIM_Try, /*On fail goto*//*Label 10781*/ GIMT_Encode4(679143), // Rule ID 10563 //
     /*  679073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  679084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  679087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  679090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  679093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679119 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  679119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  679138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679141 */     GIR_RootConstrainSelectedInstOperands,
     /*  679142 */     // GIR_Coverage, 10563,
     /*  679142 */     GIR_EraseRootFromParent_Done,
     /*  679143 */   // Label 10781: @679143
     /*  679143 */   GIM_Try, /*On fail goto*//*Label 10782*/ GIMT_Encode4(679218), // Rule ID 10566 //
     /*  679148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679194 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679216 */     GIR_RootConstrainSelectedInstOperands,
     /*  679217 */     // GIR_Coverage, 10566,
     /*  679217 */     GIR_EraseRootFromParent_Done,
     /*  679218 */   // Label 10782: @679218
     /*  679218 */   GIM_Try, /*On fail goto*//*Label 10783*/ GIMT_Encode4(679293), // Rule ID 10567 //
     /*  679223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  679234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  679237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  679240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  679243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  679262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679269 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /*  679272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679291 */     GIR_RootConstrainSelectedInstOperands,
     /*  679292 */     // GIR_Coverage, 10567,
     /*  679292 */     GIR_EraseRootFromParent_Done,
     /*  679293 */   // Label 10783: @679293
     /*  679293 */   GIM_Try, /*On fail goto*//*Label 10784*/ GIMT_Encode4(679368), // Rule ID 10570 //
     /*  679298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679344 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679366 */     GIR_RootConstrainSelectedInstOperands,
     /*  679367 */     // GIR_Coverage, 10570,
     /*  679367 */     GIR_EraseRootFromParent_Done,
     /*  679368 */   // Label 10784: @679368
     /*  679368 */   GIM_Try, /*On fail goto*//*Label 10785*/ GIMT_Encode4(679443), // Rule ID 10571 //
     /*  679373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  679384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  679387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  679390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  679393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  679412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679419 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /*  679422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679441 */     GIR_RootConstrainSelectedInstOperands,
     /*  679442 */     // GIR_Coverage, 10571,
     /*  679442 */     GIR_EraseRootFromParent_Done,
     /*  679443 */   // Label 10785: @679443
     /*  679443 */   GIM_Try, /*On fail goto*//*Label 10786*/ GIMT_Encode4(679518), // Rule ID 10574 //
     /*  679448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  679451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  679459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  679462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  679465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  679468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  679494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679516 */     GIR_RootConstrainSelectedInstOperands,
     /*  679517 */     // GIR_Coverage, 10574,
     /*  679517 */     GIR_EraseRootFromParent_Done,
     /*  679518 */   // Label 10786: @679518
     /*  679518 */   GIM_Try, /*On fail goto*//*Label 10787*/ GIMT_Encode4(679593), // Rule ID 10575 //
     /*  679523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  679526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  679534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  679537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  679540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  679543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  679562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679569 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  679569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /*  679572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  679588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679591 */     GIR_RootConstrainSelectedInstOperands,
     /*  679592 */     // GIR_Coverage, 10575,
     /*  679592 */     GIR_EraseRootFromParent_Done,
     /*  679593 */   // Label 10787: @679593
     /*  679593 */   GIM_Try, /*On fail goto*//*Label 10788*/ GIMT_Encode4(679668), // Rule ID 10578 //
     /*  679598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  679609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  679612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  679615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  679647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679666 */     GIR_RootConstrainSelectedInstOperands,
     /*  679667 */     // GIR_Coverage, 10578,
     /*  679667 */     GIR_EraseRootFromParent_Done,
     /*  679668 */   // Label 10788: @679668
     /*  679668 */   GIM_Try, /*On fail goto*//*Label 10789*/ GIMT_Encode4(679743), // Rule ID 10579 //
     /*  679673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  679684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  679687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  679690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8),
     /*  679722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679741 */     GIR_RootConstrainSelectedInstOperands,
     /*  679742 */     // GIR_Coverage, 10579,
     /*  679742 */     GIR_EraseRootFromParent_Done,
     /*  679743 */   // Label 10789: @679743
     /*  679743 */   GIM_Try, /*On fail goto*//*Label 10790*/ GIMT_Encode4(679818), // Rule ID 10582 //
     /*  679748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  679759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  679762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  679765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  679797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679816 */     GIR_RootConstrainSelectedInstOperands,
     /*  679817 */     // GIR_Coverage, 10582,
     /*  679817 */     GIR_EraseRootFromParent_Done,
     /*  679818 */   // Label 10790: @679818
     /*  679818 */   GIM_Try, /*On fail goto*//*Label 10791*/ GIMT_Encode4(679893), // Rule ID 10583 //
     /*  679823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  679834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  679837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  679840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679869 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  679869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  679872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679891 */     GIR_RootConstrainSelectedInstOperands,
     /*  679892 */     // GIR_Coverage, 10583,
     /*  679892 */     GIR_EraseRootFromParent_Done,
     /*  679893 */   // Label 10791: @679893
     /*  679893 */   GIM_Try, /*On fail goto*//*Label 10792*/ GIMT_Encode4(679968), // Rule ID 10586 //
     /*  679898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  679901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  679909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  679912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  679915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  679918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  679921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  679933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  679937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  679944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  679944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  679947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  679949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  679951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  679953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  679955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  679960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  679963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  679966 */     GIR_RootConstrainSelectedInstOperands,
     /*  679967 */     // GIR_Coverage, 10586,
     /*  679967 */     GIR_EraseRootFromParent_Done,
     /*  679968 */   // Label 10792: @679968
     /*  679968 */   GIM_Try, /*On fail goto*//*Label 10793*/ GIMT_Encode4(680043), // Rule ID 10587 //
     /*  679973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  679976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  679981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  679984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  679987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  679990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  679993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  679996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680041 */     GIR_RootConstrainSelectedInstOperands,
     /*  680042 */     // GIR_Coverage, 10587,
     /*  680042 */     GIR_EraseRootFromParent_Done,
     /*  680043 */   // Label 10793: @680043
     /*  680043 */   GIM_Try, /*On fail goto*//*Label 10794*/ GIMT_Encode4(680118), // Rule ID 10590 //
     /*  680048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680116 */     GIR_RootConstrainSelectedInstOperands,
     /*  680117 */     // GIR_Coverage, 10590,
     /*  680117 */     GIR_EraseRootFromParent_Done,
     /*  680118 */   // Label 10794: @680118
     /*  680118 */   GIM_Try, /*On fail goto*//*Label 10795*/ GIMT_Encode4(680193), // Rule ID 10591 //
     /*  680123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  680134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  680137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  680140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4),
     /*  680172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680191 */     GIR_RootConstrainSelectedInstOperands,
     /*  680192 */     // GIR_Coverage, 10591,
     /*  680192 */     GIR_EraseRootFromParent_Done,
     /*  680193 */   // Label 10795: @680193
     /*  680193 */   GIM_Try, /*On fail goto*//*Label 10796*/ GIMT_Encode4(680268), // Rule ID 10594 //
     /*  680198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680266 */     GIR_RootConstrainSelectedInstOperands,
     /*  680267 */     // GIR_Coverage, 10594,
     /*  680267 */     GIR_EraseRootFromParent_Done,
     /*  680268 */   // Label 10796: @680268
     /*  680268 */   GIM_Try, /*On fail goto*//*Label 10797*/ GIMT_Encode4(680343), // Rule ID 10595 //
     /*  680273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  680284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  680287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  680290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680341 */     GIR_RootConstrainSelectedInstOperands,
     /*  680342 */     // GIR_Coverage, 10595,
     /*  680342 */     GIR_EraseRootFromParent_Done,
     /*  680343 */   // Label 10797: @680343
     /*  680343 */   GIM_Try, /*On fail goto*//*Label 10798*/ GIMT_Encode4(680418), // Rule ID 10598 //
     /*  680348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680416 */     GIR_RootConstrainSelectedInstOperands,
     /*  680417 */     // GIR_Coverage, 10598,
     /*  680417 */     GIR_EraseRootFromParent_Done,
     /*  680418 */   // Label 10798: @680418
     /*  680418 */   GIM_Try, /*On fail goto*//*Label 10799*/ GIMT_Encode4(680493), // Rule ID 10599 //
     /*  680423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  680434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  680437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  680440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680469 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2),
     /*  680472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680491 */     GIR_RootConstrainSelectedInstOperands,
     /*  680492 */     // GIR_Coverage, 10599,
     /*  680492 */     GIR_EraseRootFromParent_Done,
     /*  680493 */   // Label 10799: @680493
     /*  680493 */   GIM_Try, /*On fail goto*//*Label 10800*/ GIMT_Encode4(680568), // Rule ID 10602 //
     /*  680498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  680509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  680512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  680515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  680544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680566 */     GIR_RootConstrainSelectedInstOperands,
     /*  680567 */     // GIR_Coverage, 10602,
     /*  680567 */     GIR_EraseRootFromParent_Done,
     /*  680568 */   // Label 10800: @680568
     /*  680568 */   GIM_Try, /*On fail goto*//*Label 10801*/ GIMT_Encode4(680643), // Rule ID 10603 //
     /*  680573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  680584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  680587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  680590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11347:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  680619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  680638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680641 */     GIR_RootConstrainSelectedInstOperands,
     /*  680642 */     // GIR_Coverage, 10603,
     /*  680642 */     GIR_EraseRootFromParent_Done,
     /*  680643 */   // Label 10801: @680643
     /*  680643 */   GIM_Try, /*On fail goto*//*Label 10802*/ GIMT_Encode4(680718), // Rule ID 10606 //
     /*  680648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  680659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  680662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  680665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  680694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680716 */     GIR_RootConstrainSelectedInstOperands,
     /*  680717 */     // GIR_Coverage, 10606,
     /*  680717 */     GIR_EraseRootFromParent_Done,
     /*  680718 */   // Label 10802: @680718
     /*  680718 */   GIM_Try, /*On fail goto*//*Label 10803*/ GIMT_Encode4(680793), // Rule ID 10607 //
     /*  680723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  680734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  680737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  680740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680769 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11347:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  680769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  680788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680791 */     GIR_RootConstrainSelectedInstOperands,
     /*  680792 */     // GIR_Coverage, 10607,
     /*  680792 */     GIR_EraseRootFromParent_Done,
     /*  680793 */   // Label 10803: @680793
     /*  680793 */   GIM_Try, /*On fail goto*//*Label 10804*/ GIMT_Encode4(680868), // Rule ID 10610 //
     /*  680798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  680801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  680809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  680812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  680815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  680844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680866 */     GIR_RootConstrainSelectedInstOperands,
     /*  680867 */     // GIR_Coverage, 10610,
     /*  680867 */     GIR_EraseRootFromParent_Done,
     /*  680868 */   // Label 10804: @680868
     /*  680868 */   GIM_Try, /*On fail goto*//*Label 10805*/ GIMT_Encode4(680943), // Rule ID 10611 //
     /*  680873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  680876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  680884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  680887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  680890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  680893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  680896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11347:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  680919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  680926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  680928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  680930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  680935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  680938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  680941 */     GIR_RootConstrainSelectedInstOperands,
     /*  680942 */     // GIR_Coverage, 10611,
     /*  680942 */     GIR_EraseRootFromParent_Done,
     /*  680943 */   // Label 10805: @680943
     /*  680943 */   GIM_Try, /*On fail goto*//*Label 10806*/ GIMT_Encode4(681018), // Rule ID 10614 //
     /*  680948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  680951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  680956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  680959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  680962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  680965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  680968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  680971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  680983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  680987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  680994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  680994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  680997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  680999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681016 */     GIR_RootConstrainSelectedInstOperands,
     /*  681017 */     // GIR_Coverage, 10614,
     /*  681017 */     GIR_EraseRootFromParent_Done,
     /*  681018 */   // Label 10806: @681018
     /*  681018 */   GIM_Try, /*On fail goto*//*Label 10807*/ GIMT_Encode4(681093), // Rule ID 10615 //
     /*  681023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  681026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  681034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  681037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  681040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  681058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681069 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11347:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  681069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1),
     /*  681072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  681088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681091 */     GIR_RootConstrainSelectedInstOperands,
     /*  681092 */     // GIR_Coverage, 10615,
     /*  681092 */     GIR_EraseRootFromParent_Done,
     /*  681093 */   // Label 10807: @681093
     /*  681093 */   GIM_Try, /*On fail goto*//*Label 10808*/ GIMT_Encode4(681168), // Rule ID 10618 //
     /*  681098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681166 */     GIR_RootConstrainSelectedInstOperands,
     /*  681167 */     // GIR_Coverage, 10618,
     /*  681167 */     GIR_EraseRootFromParent_Done,
     /*  681168 */   // Label 10808: @681168
     /*  681168 */   GIM_Try, /*On fail goto*//*Label 10809*/ GIMT_Encode4(681243), // Rule ID 10619 //
     /*  681173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  681184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  681187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  681190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681219 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681241 */     GIR_RootConstrainSelectedInstOperands,
     /*  681242 */     // GIR_Coverage, 10619,
     /*  681242 */     GIR_EraseRootFromParent_Done,
     /*  681243 */   // Label 10809: @681243
     /*  681243 */   GIM_Try, /*On fail goto*//*Label 10810*/ GIMT_Encode4(681318), // Rule ID 10622 //
     /*  681248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681316 */     GIR_RootConstrainSelectedInstOperands,
     /*  681317 */     // GIR_Coverage, 10622,
     /*  681317 */     GIR_EraseRootFromParent_Done,
     /*  681318 */   // Label 10810: @681318
     /*  681318 */   GIM_Try, /*On fail goto*//*Label 10811*/ GIMT_Encode4(681393), // Rule ID 10623 //
     /*  681323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  681334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  681337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  681340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681369 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681391 */     GIR_RootConstrainSelectedInstOperands,
     /*  681392 */     // GIR_Coverage, 10623,
     /*  681392 */     GIR_EraseRootFromParent_Done,
     /*  681393 */   // Label 10811: @681393
     /*  681393 */   GIM_Try, /*On fail goto*//*Label 10812*/ GIMT_Encode4(681468), // Rule ID 10626 //
     /*  681398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  681444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681466 */     GIR_RootConstrainSelectedInstOperands,
     /*  681467 */     // GIR_Coverage, 10626,
     /*  681467 */     GIR_EraseRootFromParent_Done,
     /*  681468 */   // Label 10812: @681468
     /*  681468 */   GIM_Try, /*On fail goto*//*Label 10813*/ GIMT_Encode4(681543), // Rule ID 10627 //
     /*  681473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  681484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  681487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  681490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681519 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  681519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  681538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681541 */     GIR_RootConstrainSelectedInstOperands,
     /*  681542 */     // GIR_Coverage, 10627,
     /*  681542 */     GIR_EraseRootFromParent_Done,
     /*  681543 */   // Label 10813: @681543
     /*  681543 */   GIM_Try, /*On fail goto*//*Label 10814*/ GIMT_Encode4(681618), // Rule ID 10630 //
     /*  681548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  681559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  681562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  681565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681594 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681616 */     GIR_RootConstrainSelectedInstOperands,
     /*  681617 */     // GIR_Coverage, 10630,
     /*  681617 */     GIR_EraseRootFromParent_Done,
     /*  681618 */   // Label 10814: @681618
     /*  681618 */   GIM_Try, /*On fail goto*//*Label 10815*/ GIMT_Encode4(681693), // Rule ID 10631 //
     /*  681623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  681634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  681637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  681640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  681658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681669 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  681672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681691 */     GIR_RootConstrainSelectedInstOperands,
     /*  681692 */     // GIR_Coverage, 10631,
     /*  681692 */     GIR_EraseRootFromParent_Done,
     /*  681693 */   // Label 10815: @681693
     /*  681693 */   GIM_Try, /*On fail goto*//*Label 10816*/ GIMT_Encode4(681768), // Rule ID 10634 //
     /*  681698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  681709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  681712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  681715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681766 */     GIR_RootConstrainSelectedInstOperands,
     /*  681767 */     // GIR_Coverage, 10634,
     /*  681767 */     GIR_EraseRootFromParent_Done,
     /*  681768 */   // Label 10816: @681768
     /*  681768 */   GIM_Try, /*On fail goto*//*Label 10817*/ GIMT_Encode4(681843), // Rule ID 10635 //
     /*  681773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  681784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  681787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  681790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  681808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681819 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  681822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681841 */     GIR_RootConstrainSelectedInstOperands,
     /*  681842 */     // GIR_Coverage, 10635,
     /*  681842 */     GIR_EraseRootFromParent_Done,
     /*  681843 */   // Label 10817: @681843
     /*  681843 */   GIM_Try, /*On fail goto*//*Label 10818*/ GIMT_Encode4(681918), // Rule ID 10638 //
     /*  681848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  681851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  681859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  681862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  681865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  681868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  681871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681894 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  681894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681916 */     GIR_RootConstrainSelectedInstOperands,
     /*  681917 */     // GIR_Coverage, 10638,
     /*  681917 */     GIR_EraseRootFromParent_Done,
     /*  681918 */   // Label 10818: @681918
     /*  681918 */   GIM_Try, /*On fail goto*//*Label 10819*/ GIMT_Encode4(681993), // Rule ID 10639 //
     /*  681923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  681926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  681931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  681934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  681937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  681940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  681943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  681946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  681958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  681962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  681969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  681969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  681972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  681974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  681976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  681978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  681980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  681985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  681988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  681991 */     GIR_RootConstrainSelectedInstOperands,
     /*  681992 */     // GIR_Coverage, 10639,
     /*  681992 */     GIR_EraseRootFromParent_Done,
     /*  681993 */   // Label 10819: @681993
     /*  681993 */   GIM_Try, /*On fail goto*//*Label 10820*/ GIMT_Encode4(682068), // Rule ID 10642 //
     /*  681998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682066 */     GIR_RootConstrainSelectedInstOperands,
     /*  682067 */     // GIR_Coverage, 10642,
     /*  682067 */     GIR_EraseRootFromParent_Done,
     /*  682068 */   // Label 10820: @682068
     /*  682068 */   GIM_Try, /*On fail goto*//*Label 10821*/ GIMT_Encode4(682143), // Rule ID 10643 //
     /*  682073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  682084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  682087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  682090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682141 */     GIR_RootConstrainSelectedInstOperands,
     /*  682142 */     // GIR_Coverage, 10643,
     /*  682142 */     GIR_EraseRootFromParent_Done,
     /*  682143 */   // Label 10821: @682143
     /*  682143 */   GIM_Try, /*On fail goto*//*Label 10822*/ GIMT_Encode4(682218), // Rule ID 10646 //
     /*  682148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682216 */     GIR_RootConstrainSelectedInstOperands,
     /*  682217 */     // GIR_Coverage, 10646,
     /*  682217 */     GIR_EraseRootFromParent_Done,
     /*  682218 */   // Label 10822: @682218
     /*  682218 */   GIM_Try, /*On fail goto*//*Label 10823*/ GIMT_Encode4(682293), // Rule ID 10647 //
     /*  682223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  682234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  682237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  682240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682269 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682291 */     GIR_RootConstrainSelectedInstOperands,
     /*  682292 */     // GIR_Coverage, 10647,
     /*  682292 */     GIR_EraseRootFromParent_Done,
     /*  682293 */   // Label 10823: @682293
     /*  682293 */   GIM_Try, /*On fail goto*//*Label 10824*/ GIMT_Encode4(682368), // Rule ID 10650 //
     /*  682298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  682344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682366 */     GIR_RootConstrainSelectedInstOperands,
     /*  682367 */     // GIR_Coverage, 10650,
     /*  682367 */     GIR_EraseRootFromParent_Done,
     /*  682368 */   // Label 10824: @682368
     /*  682368 */   GIM_Try, /*On fail goto*//*Label 10825*/ GIMT_Encode4(682443), // Rule ID 10651 //
     /*  682373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  682384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  682387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  682390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  682419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  682438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682441 */     GIR_RootConstrainSelectedInstOperands,
     /*  682442 */     // GIR_Coverage, 10651,
     /*  682442 */     GIR_EraseRootFromParent_Done,
     /*  682443 */   // Label 10825: @682443
     /*  682443 */   GIM_Try, /*On fail goto*//*Label 10826*/ GIMT_Encode4(682518), // Rule ID 10654 //
     /*  682448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682516 */     GIR_RootConstrainSelectedInstOperands,
     /*  682517 */     // GIR_Coverage, 10654,
     /*  682517 */     GIR_EraseRootFromParent_Done,
     /*  682518 */   // Label 10826: @682518
     /*  682518 */   GIM_Try, /*On fail goto*//*Label 10827*/ GIMT_Encode4(682593), // Rule ID 10655 //
     /*  682523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  682534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  682537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  682540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  682558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11347:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2),
     /*  682572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682591 */     GIR_RootConstrainSelectedInstOperands,
     /*  682592 */     // GIR_Coverage, 10655,
     /*  682592 */     GIR_EraseRootFromParent_Done,
     /*  682593 */   // Label 10827: @682593
     /*  682593 */   GIM_Try, /*On fail goto*//*Label 10828*/ GIMT_Encode4(682668), // Rule ID 10658 //
     /*  682598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  682609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  682612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  682615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682666 */     GIR_RootConstrainSelectedInstOperands,
     /*  682667 */     // GIR_Coverage, 10658,
     /*  682667 */     GIR_EraseRootFromParent_Done,
     /*  682668 */   // Label 10828: @682668
     /*  682668 */   GIM_Try, /*On fail goto*//*Label 10829*/ GIMT_Encode4(682743), // Rule ID 10659 //
     /*  682673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  682684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  682687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  682690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  682708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11347:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4),
     /*  682722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682741 */     GIR_RootConstrainSelectedInstOperands,
     /*  682742 */     // GIR_Coverage, 10659,
     /*  682742 */     GIR_EraseRootFromParent_Done,
     /*  682743 */   // Label 10829: @682743
     /*  682743 */   GIM_Try, /*On fail goto*//*Label 10830*/ GIMT_Encode4(682818), // Rule ID 10662 //
     /*  682748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  682751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  682759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  682762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  682765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  682768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  682794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682816 */     GIR_RootConstrainSelectedInstOperands,
     /*  682817 */     // GIR_Coverage, 10662,
     /*  682817 */     GIR_EraseRootFromParent_Done,
     /*  682818 */   // Label 10830: @682818
     /*  682818 */   GIM_Try, /*On fail goto*//*Label 10831*/ GIMT_Encode4(682893), // Rule ID 10663 //
     /*  682823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  682826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu),
     /*  682831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  682834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  682837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  682840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  682843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  682858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  682862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11347:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAXU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  682869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8),
     /*  682872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  682888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682891 */     GIR_RootConstrainSelectedInstOperands,
     /*  682892 */     // GIR_Coverage, 10663,
     /*  682892 */     GIR_EraseRootFromParent_Done,
     /*  682893 */   // Label 10831: @682893
     /*  682893 */   GIM_Try, /*On fail goto*//*Label 10832*/ GIMT_Encode4(682968), // Rule ID 10666 //
     /*  682898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  682901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  682906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  682909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  682912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  682915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  682918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  682921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  682937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  682944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  682944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  682947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  682949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  682951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  682953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  682955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  682960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  682963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  682966 */     GIR_RootConstrainSelectedInstOperands,
     /*  682967 */     // GIR_Coverage, 10666,
     /*  682967 */     GIR_EraseRootFromParent_Done,
     /*  682968 */   // Label 10832: @682968
     /*  682968 */   GIM_Try, /*On fail goto*//*Label 10833*/ GIMT_Encode4(683043), // Rule ID 10667 //
     /*  682973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  682976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  682981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  682984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  682987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  682990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  682993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  682996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /*  683022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683041 */     GIR_RootConstrainSelectedInstOperands,
     /*  683042 */     // GIR_Coverage, 10667,
     /*  683042 */     GIR_EraseRootFromParent_Done,
     /*  683043 */   // Label 10833: @683043
     /*  683043 */   GIM_Try, /*On fail goto*//*Label 10834*/ GIMT_Encode4(683118), // Rule ID 10670 //
     /*  683048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683116 */     GIR_RootConstrainSelectedInstOperands,
     /*  683117 */     // GIR_Coverage, 10670,
     /*  683117 */     GIR_EraseRootFromParent_Done,
     /*  683118 */   // Label 10834: @683118
     /*  683118 */   GIM_Try, /*On fail goto*//*Label 10835*/ GIMT_Encode4(683193), // Rule ID 10671 //
     /*  683123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  683134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  683137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  683140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  683143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683169 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683191 */     GIR_RootConstrainSelectedInstOperands,
     /*  683192 */     // GIR_Coverage, 10671,
     /*  683192 */     GIR_EraseRootFromParent_Done,
     /*  683193 */   // Label 10835: @683193
     /*  683193 */   GIM_Try, /*On fail goto*//*Label 10836*/ GIMT_Encode4(683268), // Rule ID 10674 //
     /*  683198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683266 */     GIR_RootConstrainSelectedInstOperands,
     /*  683267 */     // GIR_Coverage, 10674,
     /*  683267 */     GIR_EraseRootFromParent_Done,
     /*  683268 */   // Label 10836: @683268
     /*  683268 */   GIM_Try, /*On fail goto*//*Label 10837*/ GIMT_Encode4(683343), // Rule ID 10675 //
     /*  683273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  683284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  683287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  683290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  683293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683319 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683341 */     GIR_RootConstrainSelectedInstOperands,
     /*  683342 */     // GIR_Coverage, 10675,
     /*  683342 */     GIR_EraseRootFromParent_Done,
     /*  683343 */   // Label 10837: @683343
     /*  683343 */   GIM_Try, /*On fail goto*//*Label 10838*/ GIMT_Encode4(683418), // Rule ID 10678 //
     /*  683348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683416 */     GIR_RootConstrainSelectedInstOperands,
     /*  683417 */     // GIR_Coverage, 10678,
     /*  683417 */     GIR_EraseRootFromParent_Done,
     /*  683418 */   // Label 10838: @683418
     /*  683418 */   GIM_Try, /*On fail goto*//*Label 10839*/ GIMT_Encode4(683493), // Rule ID 10679 //
     /*  683423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  683434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  683437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  683440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  683443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /*  683472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683491 */     GIR_RootConstrainSelectedInstOperands,
     /*  683492 */     // GIR_Coverage, 10679,
     /*  683492 */     GIR_EraseRootFromParent_Done,
     /*  683493 */   // Label 10839: @683493
     /*  683493 */   GIM_Try, /*On fail goto*//*Label 10840*/ GIMT_Encode4(683568), // Rule ID 10682 //
     /*  683498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  683509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  683512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  683515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  683518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683566 */     GIR_RootConstrainSelectedInstOperands,
     /*  683567 */     // GIR_Coverage, 10682,
     /*  683567 */     GIR_EraseRootFromParent_Done,
     /*  683568 */   // Label 10840: @683568
     /*  683568 */   GIM_Try, /*On fail goto*//*Label 10841*/ GIMT_Encode4(683643), // Rule ID 10683 //
     /*  683573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  683584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  683587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  683590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  683593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  683619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  683638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683641 */     GIR_RootConstrainSelectedInstOperands,
     /*  683642 */     // GIR_Coverage, 10683,
     /*  683642 */     GIR_EraseRootFromParent_Done,
     /*  683643 */   // Label 10841: @683643
     /*  683643 */   GIM_Try, /*On fail goto*//*Label 10842*/ GIMT_Encode4(683718), // Rule ID 10686 //
     /*  683648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  683659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  683662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  683665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  683668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  683694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683716 */     GIR_RootConstrainSelectedInstOperands,
     /*  683717 */     // GIR_Coverage, 10686,
     /*  683717 */     GIR_EraseRootFromParent_Done,
     /*  683718 */   // Label 10842: @683718
     /*  683718 */   GIM_Try, /*On fail goto*//*Label 10843*/ GIMT_Encode4(683793), // Rule ID 10687 //
     /*  683723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  683734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  683737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  683740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  683743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  683769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /*  683772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  683788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683791 */     GIR_RootConstrainSelectedInstOperands,
     /*  683792 */     // GIR_Coverage, 10687,
     /*  683792 */     GIR_EraseRootFromParent_Done,
     /*  683793 */   // Label 10843: @683793
     /*  683793 */   GIM_Try, /*On fail goto*//*Label 10844*/ GIMT_Encode4(683868), // Rule ID 10690 //
     /*  683798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  683809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  683812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  683815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  683818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  683844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  683847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683866 */     GIR_RootConstrainSelectedInstOperands,
     /*  683867 */     // GIR_Coverage, 10690,
     /*  683867 */     GIR_EraseRootFromParent_Done,
     /*  683868 */   // Label 10844: @683868
     /*  683868 */   GIM_Try, /*On fail goto*//*Label 10845*/ GIMT_Encode4(683943), // Rule ID 10691 //
     /*  683873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  683876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  683884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  683887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  683890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  683893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  683896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  683919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  683922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  683926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  683928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  683930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  683935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  683938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  683941 */     GIR_RootConstrainSelectedInstOperands,
     /*  683942 */     // GIR_Coverage, 10691,
     /*  683942 */     GIR_EraseRootFromParent_Done,
     /*  683943 */   // Label 10845: @683943
     /*  683943 */   GIM_Try, /*On fail goto*//*Label 10846*/ GIMT_Encode4(684018), // Rule ID 10694 //
     /*  683948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  683951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  683956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  683959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  683962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  683965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  683968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  683971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  683987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  683994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  683994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  683997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  683999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684016 */     GIR_RootConstrainSelectedInstOperands,
     /*  684017 */     // GIR_Coverage, 10694,
     /*  684017 */     GIR_EraseRootFromParent_Done,
     /*  684018 */   // Label 10846: @684018
     /*  684018 */   GIM_Try, /*On fail goto*//*Label 10847*/ GIMT_Encode4(684093), // Rule ID 10695 //
     /*  684023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  684034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  684037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  684040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  684043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684069 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684091 */     GIR_RootConstrainSelectedInstOperands,
     /*  684092 */     // GIR_Coverage, 10695,
     /*  684092 */     GIR_EraseRootFromParent_Done,
     /*  684093 */   // Label 10847: @684093
     /*  684093 */   GIM_Try, /*On fail goto*//*Label 10848*/ GIMT_Encode4(684168), // Rule ID 10698 //
     /*  684098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  684144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684166 */     GIR_RootConstrainSelectedInstOperands,
     /*  684167 */     // GIR_Coverage, 10698,
     /*  684167 */     GIR_EraseRootFromParent_Done,
     /*  684168 */   // Label 10848: @684168
     /*  684168 */   GIM_Try, /*On fail goto*//*Label 10849*/ GIMT_Encode4(684243), // Rule ID 10699 //
     /*  684173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  684184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  684187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  684190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  684193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  684219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  684238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684241 */     GIR_RootConstrainSelectedInstOperands,
     /*  684242 */     // GIR_Coverage, 10699,
     /*  684242 */     GIR_EraseRootFromParent_Done,
     /*  684243 */   // Label 10849: @684243
     /*  684243 */   GIM_Try, /*On fail goto*//*Label 10850*/ GIMT_Encode4(684318), // Rule ID 10702 //
     /*  684248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  684251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  684294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684316 */     GIR_RootConstrainSelectedInstOperands,
     /*  684317 */     // GIR_Coverage, 10702,
     /*  684317 */     GIR_EraseRootFromParent_Done,
     /*  684318 */   // Label 10850: @684318
     /*  684318 */   GIM_Try, /*On fail goto*//*Label 10851*/ GIMT_Encode4(684393), // Rule ID 10703 //
     /*  684323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  684326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  684334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  684337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  684340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  684343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  684362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684369 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  684369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /*  684372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  684388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684391 */     GIR_RootConstrainSelectedInstOperands,
     /*  684392 */     // GIR_Coverage, 10703,
     /*  684392 */     GIR_EraseRootFromParent_Done,
     /*  684393 */   // Label 10851: @684393
     /*  684393 */   GIM_Try, /*On fail goto*//*Label 10852*/ GIMT_Encode4(684468), // Rule ID 10706 //
     /*  684398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684444 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684466 */     GIR_RootConstrainSelectedInstOperands,
     /*  684467 */     // GIR_Coverage, 10706,
     /*  684467 */     GIR_EraseRootFromParent_Done,
     /*  684468 */   // Label 10852: @684468
     /*  684468 */   GIM_Try, /*On fail goto*//*Label 10853*/ GIMT_Encode4(684543), // Rule ID 10707 //
     /*  684473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  684484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  684487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  684490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  684493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684541 */     GIR_RootConstrainSelectedInstOperands,
     /*  684542 */     // GIR_Coverage, 10707,
     /*  684542 */     GIR_EraseRootFromParent_Done,
     /*  684543 */   // Label 10853: @684543
     /*  684543 */   GIM_Try, /*On fail goto*//*Label 10854*/ GIMT_Encode4(684618), // Rule ID 10710 //
     /*  684548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  684559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  684562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  684565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  684568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  684597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684616 */     GIR_RootConstrainSelectedInstOperands,
     /*  684617 */     // GIR_Coverage, 10710,
     /*  684617 */     GIR_EraseRootFromParent_Done,
     /*  684618 */   // Label 10854: @684618
     /*  684618 */   GIM_Try, /*On fail goto*//*Label 10855*/ GIMT_Encode4(684693), // Rule ID 10711 //
     /*  684623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  684634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  684637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  684640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  684643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  684662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684669 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  684672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684691 */     GIR_RootConstrainSelectedInstOperands,
     /*  684692 */     // GIR_Coverage, 10711,
     /*  684692 */     GIR_EraseRootFromParent_Done,
     /*  684693 */   // Label 10855: @684693
     /*  684693 */   GIM_Try, /*On fail goto*//*Label 10856*/ GIMT_Encode4(684768), // Rule ID 10714 //
     /*  684698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  684709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  684712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  684715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  684718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  684744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  684747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684766 */     GIR_RootConstrainSelectedInstOperands,
     /*  684767 */     // GIR_Coverage, 10714,
     /*  684767 */     GIR_EraseRootFromParent_Done,
     /*  684768 */   // Label 10856: @684768
     /*  684768 */   GIM_Try, /*On fail goto*//*Label 10857*/ GIMT_Encode4(684843), // Rule ID 10715 //
     /*  684773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  684784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  684787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  684790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  684793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  684812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  684819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  684822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  684838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684841 */     GIR_RootConstrainSelectedInstOperands,
     /*  684842 */     // GIR_Coverage, 10715,
     /*  684842 */     GIR_EraseRootFromParent_Done,
     /*  684843 */   // Label 10857: @684843
     /*  684843 */   GIM_Try, /*On fail goto*//*Label 10858*/ GIMT_Encode4(684918), // Rule ID 10718 //
     /*  684848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  684851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  684859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  684862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  684865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  684868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  684871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  684894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684916 */     GIR_RootConstrainSelectedInstOperands,
     /*  684917 */     // GIR_Coverage, 10718,
     /*  684917 */     GIR_EraseRootFromParent_Done,
     /*  684918 */   // Label 10858: @684918
     /*  684918 */   GIM_Try, /*On fail goto*//*Label 10859*/ GIMT_Encode4(684993), // Rule ID 10719 //
     /*  684923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  684926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  684931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  684934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  684937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  684940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  684943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  684946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  684962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  684969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  684969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  684972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  684974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  684976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  684978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  684980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  684985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  684988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  684991 */     GIR_RootConstrainSelectedInstOperands,
     /*  684992 */     // GIR_Coverage, 10719,
     /*  684992 */     GIR_EraseRootFromParent_Done,
     /*  684993 */   // Label 10859: @684993
     /*  684993 */   GIM_Try, /*On fail goto*//*Label 10860*/ GIMT_Encode4(685068), // Rule ID 10722 //
     /*  684998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685066 */     GIR_RootConstrainSelectedInstOperands,
     /*  685067 */     // GIR_Coverage, 10722,
     /*  685067 */     GIR_EraseRootFromParent_Done,
     /*  685068 */   // Label 10860: @685068
     /*  685068 */   GIM_Try, /*On fail goto*//*Label 10861*/ GIMT_Encode4(685143), // Rule ID 10723 //
     /*  685073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  685084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  685087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  685090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  685093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685141 */     GIR_RootConstrainSelectedInstOperands,
     /*  685142 */     // GIR_Coverage, 10723,
     /*  685142 */     GIR_EraseRootFromParent_Done,
     /*  685143 */   // Label 10861: @685143
     /*  685143 */   GIM_Try, /*On fail goto*//*Label 10862*/ GIMT_Encode4(685218), // Rule ID 10726 //
     /*  685148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  685194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685216 */     GIR_RootConstrainSelectedInstOperands,
     /*  685217 */     // GIR_Coverage, 10726,
     /*  685217 */     GIR_EraseRootFromParent_Done,
     /*  685218 */   // Label 10862: @685218
     /*  685218 */   GIM_Try, /*On fail goto*//*Label 10863*/ GIMT_Encode4(685293), // Rule ID 10727 //
     /*  685223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  685234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  685237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  685240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  685243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  685269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  685288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685291 */     GIR_RootConstrainSelectedInstOperands,
     /*  685292 */     // GIR_Coverage, 10727,
     /*  685292 */     GIR_EraseRootFromParent_Done,
     /*  685293 */   // Label 10863: @685293
     /*  685293 */   GIM_Try, /*On fail goto*//*Label 10864*/ GIMT_Encode4(685368), // Rule ID 10730 //
     /*  685298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685366 */     GIR_RootConstrainSelectedInstOperands,
     /*  685367 */     // GIR_Coverage, 10730,
     /*  685367 */     GIR_EraseRootFromParent_Done,
     /*  685368 */   // Label 10864: @685368
     /*  685368 */   GIM_Try, /*On fail goto*//*Label 10865*/ GIMT_Encode4(685443), // Rule ID 10731 //
     /*  685373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  685384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  685387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  685390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  685393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685441 */     GIR_RootConstrainSelectedInstOperands,
     /*  685442 */     // GIR_Coverage, 10731,
     /*  685442 */     GIR_EraseRootFromParent_Done,
     /*  685443 */   // Label 10865: @685443
     /*  685443 */   GIM_Try, /*On fail goto*//*Label 10866*/ GIMT_Encode4(685518), // Rule ID 10734 //
     /*  685448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685516 */     GIR_RootConstrainSelectedInstOperands,
     /*  685517 */     // GIR_Coverage, 10734,
     /*  685517 */     GIR_EraseRootFromParent_Done,
     /*  685518 */   // Label 10866: @685518
     /*  685518 */   GIM_Try, /*On fail goto*//*Label 10867*/ GIMT_Encode4(685593), // Rule ID 10735 //
     /*  685523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  685534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  685537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  685540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  685543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685591 */     GIR_RootConstrainSelectedInstOperands,
     /*  685592 */     // GIR_Coverage, 10735,
     /*  685592 */     GIR_EraseRootFromParent_Done,
     /*  685593 */   // Label 10867: @685593
     /*  685593 */   GIM_Try, /*On fail goto*//*Label 10868*/ GIMT_Encode4(685668), // Rule ID 10738 //
     /*  685598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  685601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  685609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  685612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  685615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  685618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685644 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  685644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685666 */     GIR_RootConstrainSelectedInstOperands,
     /*  685667 */     // GIR_Coverage, 10738,
     /*  685667 */     GIR_EraseRootFromParent_Done,
     /*  685668 */   // Label 10868: @685668
     /*  685668 */   GIM_Try, /*On fail goto*//*Label 10869*/ GIMT_Encode4(685743), // Rule ID 10739 //
     /*  685673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  685676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  685684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  685687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  685690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  685693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  685712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  685719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  685722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  685738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685741 */     GIR_RootConstrainSelectedInstOperands,
     /*  685742 */     // GIR_Coverage, 10739,
     /*  685742 */     GIR_EraseRootFromParent_Done,
     /*  685743 */   // Label 10869: @685743
     /*  685743 */   GIM_Try, /*On fail goto*//*Label 10870*/ GIMT_Encode4(685818), // Rule ID 10742 //
     /*  685748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  685759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  685762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  685765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  685768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685816 */     GIR_RootConstrainSelectedInstOperands,
     /*  685817 */     // GIR_Coverage, 10742,
     /*  685817 */     GIR_EraseRootFromParent_Done,
     /*  685818 */   // Label 10870: @685818
     /*  685818 */   GIM_Try, /*On fail goto*//*Label 10871*/ GIMT_Encode4(685893), // Rule ID 10743 //
     /*  685823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  685834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  685837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  685840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  685843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  685862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  685869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /*  685872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685891 */     GIR_RootConstrainSelectedInstOperands,
     /*  685892 */     // GIR_Coverage, 10743,
     /*  685892 */     GIR_EraseRootFromParent_Done,
     /*  685893 */   // Label 10871: @685893
     /*  685893 */   GIM_Try, /*On fail goto*//*Label 10872*/ GIMT_Encode4(685968), // Rule ID 10746 //
     /*  685898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  685901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  685909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  685912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  685915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  685918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  685921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  685937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  685944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  685944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  685947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  685949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  685951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  685953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  685955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  685960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  685963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  685966 */     GIR_RootConstrainSelectedInstOperands,
     /*  685967 */     // GIR_Coverage, 10746,
     /*  685967 */     GIR_EraseRootFromParent_Done,
     /*  685968 */   // Label 10872: @685968
     /*  685968 */   GIM_Try, /*On fail goto*//*Label 10873*/ GIMT_Encode4(686043), // Rule ID 10747 //
     /*  685973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  685976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  685981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  685984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  685987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  685990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  685993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  685996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  686012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /*  686022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686041 */     GIR_RootConstrainSelectedInstOperands,
     /*  686042 */     // GIR_Coverage, 10747,
     /*  686042 */     GIR_EraseRootFromParent_Done,
     /*  686043 */   // Label 10873: @686043
     /*  686043 */   GIM_Try, /*On fail goto*//*Label 10874*/ GIMT_Encode4(686118), // Rule ID 10750 //
     /*  686048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  686051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  686094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686116 */     GIR_RootConstrainSelectedInstOperands,
     /*  686117 */     // GIR_Coverage, 10750,
     /*  686117 */     GIR_EraseRootFromParent_Done,
     /*  686118 */   // Label 10874: @686118
     /*  686118 */   GIM_Try, /*On fail goto*//*Label 10875*/ GIMT_Encode4(686193), // Rule ID 10751 //
     /*  686123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  686126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  686134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  686137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  686140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  686143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  686162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  686169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /*  686172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  686188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686191 */     GIR_RootConstrainSelectedInstOperands,
     /*  686192 */     // GIR_Coverage, 10751,
     /*  686192 */     GIR_EraseRootFromParent_Done,
     /*  686193 */   // Label 10875: @686193
     /*  686193 */   GIM_Try, /*On fail goto*//*Label 10876*/ GIMT_Encode4(686268), // Rule ID 10754 //
     /*  686198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686266 */     GIR_RootConstrainSelectedInstOperands,
     /*  686267 */     // GIR_Coverage, 10754,
     /*  686267 */     GIR_EraseRootFromParent_Done,
     /*  686268 */   // Label 10876: @686268
     /*  686268 */   GIM_Try, /*On fail goto*//*Label 10877*/ GIMT_Encode4(686343), // Rule ID 10755 //
     /*  686273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  686284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  686287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  686290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8),
     /*  686322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686341 */     GIR_RootConstrainSelectedInstOperands,
     /*  686342 */     // GIR_Coverage, 10755,
     /*  686342 */     GIR_EraseRootFromParent_Done,
     /*  686343 */   // Label 10877: @686343
     /*  686343 */   GIM_Try, /*On fail goto*//*Label 10878*/ GIMT_Encode4(686418), // Rule ID 10758 //
     /*  686348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686416 */     GIR_RootConstrainSelectedInstOperands,
     /*  686417 */     // GIR_Coverage, 10758,
     /*  686417 */     GIR_EraseRootFromParent_Done,
     /*  686418 */   // Label 10878: @686418
     /*  686418 */   GIM_Try, /*On fail goto*//*Label 10879*/ GIMT_Encode4(686493), // Rule ID 10759 //
     /*  686423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  686434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  686437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  686440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686491 */     GIR_RootConstrainSelectedInstOperands,
     /*  686492 */     // GIR_Coverage, 10759,
     /*  686492 */     GIR_EraseRootFromParent_Done,
     /*  686493 */   // Label 10879: @686493
     /*  686493 */   GIM_Try, /*On fail goto*//*Label 10880*/ GIMT_Encode4(686568), // Rule ID 10762 //
     /*  686498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  686509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  686512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  686515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  686544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  686547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686566 */     GIR_RootConstrainSelectedInstOperands,
     /*  686567 */     // GIR_Coverage, 10762,
     /*  686567 */     GIR_EraseRootFromParent_Done,
     /*  686568 */   // Label 10880: @686568
     /*  686568 */   GIM_Try, /*On fail goto*//*Label 10881*/ GIMT_Encode4(686643), // Rule ID 10763 //
     /*  686573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  686584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  686587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  686590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  686619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  686622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  686638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686641 */     GIR_RootConstrainSelectedInstOperands,
     /*  686642 */     // GIR_Coverage, 10763,
     /*  686642 */     GIR_EraseRootFromParent_Done,
     /*  686643 */   // Label 10881: @686643
     /*  686643 */   GIM_Try, /*On fail goto*//*Label 10882*/ GIMT_Encode4(686718), // Rule ID 10766 //
     /*  686648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  686659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  686662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  686665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686716 */     GIR_RootConstrainSelectedInstOperands,
     /*  686717 */     // GIR_Coverage, 10766,
     /*  686717 */     GIR_EraseRootFromParent_Done,
     /*  686718 */   // Label 10882: @686718
     /*  686718 */   GIM_Try, /*On fail goto*//*Label 10883*/ GIMT_Encode4(686793), // Rule ID 10767 //
     /*  686723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  686734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  686737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  686740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4),
     /*  686772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686791 */     GIR_RootConstrainSelectedInstOperands,
     /*  686792 */     // GIR_Coverage, 10767,
     /*  686792 */     GIR_EraseRootFromParent_Done,
     /*  686793 */   // Label 10883: @686793
     /*  686793 */   GIM_Try, /*On fail goto*//*Label 10884*/ GIMT_Encode4(686868), // Rule ID 10770 //
     /*  686798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  686809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  686812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  686815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  686844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  686847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686866 */     GIR_RootConstrainSelectedInstOperands,
     /*  686867 */     // GIR_Coverage, 10770,
     /*  686867 */     GIR_EraseRootFromParent_Done,
     /*  686868 */   // Label 10884: @686868
     /*  686868 */   GIM_Try, /*On fail goto*//*Label 10885*/ GIMT_Encode4(686943), // Rule ID 10771 //
     /*  686873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  686876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  686884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  686887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  686890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  686893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  686896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  686919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  686922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  686926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  686928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  686930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  686935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  686938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  686941 */     GIR_RootConstrainSelectedInstOperands,
     /*  686942 */     // GIR_Coverage, 10771,
     /*  686942 */     GIR_EraseRootFromParent_Done,
     /*  686943 */   // Label 10885: @686943
     /*  686943 */   GIM_Try, /*On fail goto*//*Label 10886*/ GIMT_Encode4(687018), // Rule ID 10774 //
     /*  686948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  686951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  686956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  686959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  686962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  686965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  686968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  686971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  686983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  686987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  686994 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  686994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  686997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  686999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687016 */     GIR_RootConstrainSelectedInstOperands,
     /*  687017 */     // GIR_Coverage, 10774,
     /*  687017 */     GIR_EraseRootFromParent_Done,
     /*  687018 */   // Label 10886: @687018
     /*  687018 */   GIM_Try, /*On fail goto*//*Label 10887*/ GIMT_Encode4(687093), // Rule ID 10775 //
     /*  687023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  687034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  687037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  687040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  687069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2),
     /*  687072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687091 */     GIR_RootConstrainSelectedInstOperands,
     /*  687092 */     // GIR_Coverage, 10775,
     /*  687092 */     GIR_EraseRootFromParent_Done,
     /*  687093 */   // Label 10887: @687093
     /*  687093 */   GIM_Try, /*On fail goto*//*Label 10888*/ GIMT_Encode4(687168), // Rule ID 10778 //
     /*  687098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687166 */     GIR_RootConstrainSelectedInstOperands,
     /*  687167 */     // GIR_Coverage, 10778,
     /*  687167 */     GIR_EraseRootFromParent_Done,
     /*  687168 */   // Label 10888: @687168
     /*  687168 */   GIM_Try, /*On fail goto*//*Label 10889*/ GIMT_Encode4(687243), // Rule ID 10779 //
     /*  687173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  687184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  687187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  687190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11345:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687241 */     GIR_RootConstrainSelectedInstOperands,
     /*  687242 */     // GIR_Coverage, 10779,
     /*  687242 */     GIR_EraseRootFromParent_Done,
     /*  687243 */   // Label 10889: @687243
     /*  687243 */   GIM_Try, /*On fail goto*//*Label 10890*/ GIMT_Encode4(687318), // Rule ID 10782 //
     /*  687248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  687294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687316 */     GIR_RootConstrainSelectedInstOperands,
     /*  687317 */     // GIR_Coverage, 10782,
     /*  687317 */     GIR_EraseRootFromParent_Done,
     /*  687318 */   // Label 10890: @687318
     /*  687318 */   GIM_Try, /*On fail goto*//*Label 10891*/ GIMT_Encode4(687393), // Rule ID 10783 //
     /*  687323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  687334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  687337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  687340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11345:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  687369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  687388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687391 */     GIR_RootConstrainSelectedInstOperands,
     /*  687392 */     // GIR_Coverage, 10783,
     /*  687392 */     GIR_EraseRootFromParent_Done,
     /*  687393 */   // Label 10891: @687393
     /*  687393 */   GIM_Try, /*On fail goto*//*Label 10892*/ GIMT_Encode4(687468), // Rule ID 10786 //
     /*  687398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  687444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687466 */     GIR_RootConstrainSelectedInstOperands,
     /*  687467 */     // GIR_Coverage, 10786,
     /*  687467 */     GIR_EraseRootFromParent_Done,
     /*  687468 */   // Label 10892: @687468
     /*  687468 */   GIM_Try, /*On fail goto*//*Label 10893*/ GIMT_Encode4(687543), // Rule ID 10787 //
     /*  687473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  687484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  687487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  687490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11345:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  687519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  687538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687541 */     GIR_RootConstrainSelectedInstOperands,
     /*  687542 */     // GIR_Coverage, 10787,
     /*  687542 */     GIR_EraseRootFromParent_Done,
     /*  687543 */   // Label 10893: @687543
     /*  687543 */   GIM_Try, /*On fail goto*//*Label 10894*/ GIMT_Encode4(687618), // Rule ID 10790 //
     /*  687548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  687551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  687559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  687562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  687565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  687594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687616 */     GIR_RootConstrainSelectedInstOperands,
     /*  687617 */     // GIR_Coverage, 10790,
     /*  687617 */     GIR_EraseRootFromParent_Done,
     /*  687618 */   // Label 10894: @687618
     /*  687618 */   GIM_Try, /*On fail goto*//*Label 10895*/ GIMT_Encode4(687693), // Rule ID 10791 //
     /*  687623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  687626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  687634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  687637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  687640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  687658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687669 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11345:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  687669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1),
     /*  687672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  687688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687691 */     GIR_RootConstrainSelectedInstOperands,
     /*  687692 */     // GIR_Coverage, 10791,
     /*  687692 */     GIR_EraseRootFromParent_Done,
     /*  687693 */   // Label 10895: @687693
     /*  687693 */   GIM_Try, /*On fail goto*//*Label 10896*/ GIMT_Encode4(687768), // Rule ID 10794 //
     /*  687698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  687709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  687712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  687715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  687747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687766 */     GIR_RootConstrainSelectedInstOperands,
     /*  687767 */     // GIR_Coverage, 10794,
     /*  687767 */     GIR_EraseRootFromParent_Done,
     /*  687768 */   // Label 10896: @687768
     /*  687768 */   GIM_Try, /*On fail goto*//*Label 10897*/ GIMT_Encode4(687843), // Rule ID 10795 //
     /*  687773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  687784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  687787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  687790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  687808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  687822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687841 */     GIR_RootConstrainSelectedInstOperands,
     /*  687842 */     // GIR_Coverage, 10795,
     /*  687842 */     GIR_EraseRootFromParent_Done,
     /*  687843 */   // Label 10897: @687843
     /*  687843 */   GIM_Try, /*On fail goto*//*Label 10898*/ GIMT_Encode4(687918), // Rule ID 10798 //
     /*  687848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  687851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  687859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  687862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  687865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  687868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  687871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  687894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  687897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687916 */     GIR_RootConstrainSelectedInstOperands,
     /*  687917 */     // GIR_Coverage, 10798,
     /*  687917 */     GIR_EraseRootFromParent_Done,
     /*  687918 */   // Label 10898: @687918
     /*  687918 */   GIM_Try, /*On fail goto*//*Label 10899*/ GIMT_Encode4(687993), // Rule ID 10799 //
     /*  687923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  687926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  687931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  687934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  687937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  687940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  687943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  687946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  687958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  687962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  687969 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  687969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  687972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  687974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  687976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  687978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  687980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  687985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  687988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  687991 */     GIR_RootConstrainSelectedInstOperands,
     /*  687992 */     // GIR_Coverage, 10799,
     /*  687992 */     GIR_EraseRootFromParent_Done,
     /*  687993 */   // Label 10899: @687993
     /*  687993 */   GIM_Try, /*On fail goto*//*Label 10900*/ GIMT_Encode4(688068), // Rule ID 10802 //
     /*  687998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  688044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688066 */     GIR_RootConstrainSelectedInstOperands,
     /*  688067 */     // GIR_Coverage, 10802,
     /*  688067 */     GIR_EraseRootFromParent_Done,
     /*  688068 */   // Label 10900: @688068
     /*  688068 */   GIM_Try, /*On fail goto*//*Label 10901*/ GIMT_Encode4(688143), // Rule ID 10803 //
     /*  688073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  688084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  688087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  688090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688119 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  688119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  688138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688141 */     GIR_RootConstrainSelectedInstOperands,
     /*  688142 */     // GIR_Coverage, 10803,
     /*  688142 */     GIR_EraseRootFromParent_Done,
     /*  688143 */   // Label 10901: @688143
     /*  688143 */   GIM_Try, /*On fail goto*//*Label 10902*/ GIMT_Encode4(688218), // Rule ID 10806 //
     /*  688148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688216 */     GIR_RootConstrainSelectedInstOperands,
     /*  688217 */     // GIR_Coverage, 10806,
     /*  688217 */     GIR_EraseRootFromParent_Done,
     /*  688218 */   // Label 10902: @688218
     /*  688218 */   GIM_Try, /*On fail goto*//*Label 10903*/ GIMT_Encode4(688293), // Rule ID 10807 //
     /*  688223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  688234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  688237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  688240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688291 */     GIR_RootConstrainSelectedInstOperands,
     /*  688292 */     // GIR_Coverage, 10807,
     /*  688292 */     GIR_EraseRootFromParent_Done,
     /*  688293 */   // Label 10903: @688293
     /*  688293 */   GIM_Try, /*On fail goto*//*Label 10904*/ GIMT_Encode4(688368), // Rule ID 10810 //
     /*  688298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688366 */     GIR_RootConstrainSelectedInstOperands,
     /*  688367 */     // GIR_Coverage, 10810,
     /*  688367 */     GIR_EraseRootFromParent_Done,
     /*  688368 */   // Label 10904: @688368
     /*  688368 */   GIM_Try, /*On fail goto*//*Label 10905*/ GIMT_Encode4(688443), // Rule ID 10811 //
     /*  688373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  688384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  688387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  688390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688441 */     GIR_RootConstrainSelectedInstOperands,
     /*  688442 */     // GIR_Coverage, 10811,
     /*  688442 */     GIR_EraseRootFromParent_Done,
     /*  688443 */   // Label 10905: @688443
     /*  688443 */   GIM_Try, /*On fail goto*//*Label 10906*/ GIMT_Encode4(688518), // Rule ID 10814 //
     /*  688448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  688494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688516 */     GIR_RootConstrainSelectedInstOperands,
     /*  688517 */     // GIR_Coverage, 10814,
     /*  688517 */     GIR_EraseRootFromParent_Done,
     /*  688518 */   // Label 10906: @688518
     /*  688518 */   GIM_Try, /*On fail goto*//*Label 10907*/ GIMT_Encode4(688593), // Rule ID 10815 //
     /*  688523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  688534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  688537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  688540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688569 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  688569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  688588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688591 */     GIR_RootConstrainSelectedInstOperands,
     /*  688592 */     // GIR_Coverage, 10815,
     /*  688592 */     GIR_EraseRootFromParent_Done,
     /*  688593 */   // Label 10907: @688593
     /*  688593 */   GIM_Try, /*On fail goto*//*Label 10908*/ GIMT_Encode4(688668), // Rule ID 10818 //
     /*  688598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  688609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  688612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  688615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688666 */     GIR_RootConstrainSelectedInstOperands,
     /*  688667 */     // GIR_Coverage, 10818,
     /*  688667 */     GIR_EraseRootFromParent_Done,
     /*  688668 */   // Label 10908: @688668
     /*  688668 */   GIM_Try, /*On fail goto*//*Label 10909*/ GIMT_Encode4(688743), // Rule ID 10819 //
     /*  688673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  688684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  688687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  688690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  688708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  688722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688741 */     GIR_RootConstrainSelectedInstOperands,
     /*  688742 */     // GIR_Coverage, 10819,
     /*  688742 */     GIR_EraseRootFromParent_Done,
     /*  688743 */   // Label 10909: @688743
     /*  688743 */   GIM_Try, /*On fail goto*//*Label 10910*/ GIMT_Encode4(688818), // Rule ID 10822 //
     /*  688748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  688759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  688762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  688765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688816 */     GIR_RootConstrainSelectedInstOperands,
     /*  688817 */     // GIR_Coverage, 10822,
     /*  688817 */     GIR_EraseRootFromParent_Done,
     /*  688818 */   // Label 10910: @688818
     /*  688818 */   GIM_Try, /*On fail goto*//*Label 10911*/ GIMT_Encode4(688893), // Rule ID 10823 //
     /*  688823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  688834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  688837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  688840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  688858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688869 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  688869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  688872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688891 */     GIR_RootConstrainSelectedInstOperands,
     /*  688892 */     // GIR_Coverage, 10823,
     /*  688892 */     GIR_EraseRootFromParent_Done,
     /*  688893 */   // Label 10911: @688893
     /*  688893 */   GIM_Try, /*On fail goto*//*Label 10912*/ GIMT_Encode4(688968), // Rule ID 10826 //
     /*  688898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  688901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  688909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  688912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  688915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  688918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  688921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  688933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  688937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  688944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  688944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  688947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  688949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  688951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  688953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  688955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  688960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  688963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  688966 */     GIR_RootConstrainSelectedInstOperands,
     /*  688967 */     // GIR_Coverage, 10826,
     /*  688967 */     GIR_EraseRootFromParent_Done,
     /*  688968 */   // Label 10912: @688968
     /*  688968 */   GIM_Try, /*On fail goto*//*Label 10913*/ GIMT_Encode4(689043), // Rule ID 10827 //
     /*  688973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  688976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  688981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  688984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  688987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  688990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  688993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  688996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689019 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  689019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  689038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689041 */     GIR_RootConstrainSelectedInstOperands,
     /*  689042 */     // GIR_Coverage, 10827,
     /*  689042 */     GIR_EraseRootFromParent_Done,
     /*  689043 */   // Label 10913: @689043
     /*  689043 */   GIM_Try, /*On fail goto*//*Label 10914*/ GIMT_Encode4(689118), // Rule ID 10830 //
     /*  689048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689116 */     GIR_RootConstrainSelectedInstOperands,
     /*  689117 */     // GIR_Coverage, 10830,
     /*  689117 */     GIR_EraseRootFromParent_Done,
     /*  689118 */   // Label 10914: @689118
     /*  689118 */   GIM_Try, /*On fail goto*//*Label 10915*/ GIMT_Encode4(689193), // Rule ID 10831 //
     /*  689123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  689134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  689137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  689140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  689158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11345:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2),
     /*  689172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689191 */     GIR_RootConstrainSelectedInstOperands,
     /*  689192 */     // GIR_Coverage, 10831,
     /*  689192 */     GIR_EraseRootFromParent_Done,
     /*  689193 */   // Label 10915: @689193
     /*  689193 */   GIM_Try, /*On fail goto*//*Label 10916*/ GIMT_Encode4(689268), // Rule ID 10834 //
     /*  689198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689266 */     GIR_RootConstrainSelectedInstOperands,
     /*  689267 */     // GIR_Coverage, 10834,
     /*  689267 */     GIR_EraseRootFromParent_Done,
     /*  689268 */   // Label 10916: @689268
     /*  689268 */   GIM_Try, /*On fail goto*//*Label 10917*/ GIMT_Encode4(689343), // Rule ID 10835 //
     /*  689273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  689284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  689287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  689290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  689308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11345:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4),
     /*  689322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689341 */     GIR_RootConstrainSelectedInstOperands,
     /*  689342 */     // GIR_Coverage, 10835,
     /*  689342 */     GIR_EraseRootFromParent_Done,
     /*  689343 */   // Label 10917: @689343
     /*  689343 */   GIM_Try, /*On fail goto*//*Label 10918*/ GIMT_Encode4(689418), // Rule ID 10838 //
     /*  689348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  689351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  689368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  689394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689416 */     GIR_RootConstrainSelectedInstOperands,
     /*  689417 */     // GIR_Coverage, 10838,
     /*  689417 */     GIR_EraseRootFromParent_Done,
     /*  689418 */   // Label 10918: @689418
     /*  689418 */   GIM_Try, /*On fail goto*//*Label 10919*/ GIMT_Encode4(689493), // Rule ID 10839 //
     /*  689423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  689426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax),
     /*  689431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  689434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  689437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  689440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  689443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  689458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  689462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11345:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMAX_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  689469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8),
     /*  689472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  689488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689491 */     GIR_RootConstrainSelectedInstOperands,
     /*  689492 */     // GIR_Coverage, 10839,
     /*  689492 */     GIR_EraseRootFromParent_Done,
     /*  689493 */   // Label 10919: @689493
     /*  689493 */   GIM_Try, /*On fail goto*//*Label 10920*/ GIMT_Encode4(689568), // Rule ID 10842 //
     /*  689498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  689509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  689512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  689515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  689518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  689547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689566 */     GIR_RootConstrainSelectedInstOperands,
     /*  689567 */     // GIR_Coverage, 10842,
     /*  689567 */     GIR_EraseRootFromParent_Done,
     /*  689568 */   // Label 10920: @689568
     /*  689568 */   GIM_Try, /*On fail goto*//*Label 10921*/ GIMT_Encode4(689643), // Rule ID 10843 //
     /*  689573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  689584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  689587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  689590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  689593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8),
     /*  689622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689641 */     GIR_RootConstrainSelectedInstOperands,
     /*  689642 */     // GIR_Coverage, 10843,
     /*  689642 */     GIR_EraseRootFromParent_Done,
     /*  689643 */   // Label 10921: @689643
     /*  689643 */   GIM_Try, /*On fail goto*//*Label 10922*/ GIMT_Encode4(689718), // Rule ID 10846 //
     /*  689648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  689659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  689662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  689665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  689668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  689697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689716 */     GIR_RootConstrainSelectedInstOperands,
     /*  689717 */     // GIR_Coverage, 10846,
     /*  689717 */     GIR_EraseRootFromParent_Done,
     /*  689718 */   // Label 10922: @689718
     /*  689718 */   GIM_Try, /*On fail goto*//*Label 10923*/ GIMT_Encode4(689793), // Rule ID 10847 //
     /*  689723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  689734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  689737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  689740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  689743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  689772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689791 */     GIR_RootConstrainSelectedInstOperands,
     /*  689792 */     // GIR_Coverage, 10847,
     /*  689792 */     GIR_EraseRootFromParent_Done,
     /*  689793 */   // Label 10923: @689793
     /*  689793 */   GIM_Try, /*On fail goto*//*Label 10924*/ GIMT_Encode4(689868), // Rule ID 10850 //
     /*  689798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  689809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  689812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  689815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  689818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  689844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  689847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689866 */     GIR_RootConstrainSelectedInstOperands,
     /*  689867 */     // GIR_Coverage, 10850,
     /*  689867 */     GIR_EraseRootFromParent_Done,
     /*  689868 */   // Label 10924: @689868
     /*  689868 */   GIM_Try, /*On fail goto*//*Label 10925*/ GIMT_Encode4(689943), // Rule ID 10851 //
     /*  689873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  689876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  689884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  689887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  689890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  689893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  689896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  689919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  689922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  689926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  689928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  689930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  689935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  689938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  689941 */     GIR_RootConstrainSelectedInstOperands,
     /*  689942 */     // GIR_Coverage, 10851,
     /*  689942 */     GIR_EraseRootFromParent_Done,
     /*  689943 */   // Label 10925: @689943
     /*  689943 */   GIM_Try, /*On fail goto*//*Label 10926*/ GIMT_Encode4(690018), // Rule ID 10854 //
     /*  689948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  689951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  689956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  689959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  689962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  689965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  689968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  689971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  689987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  689994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  689994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  689997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  689999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690016 */     GIR_RootConstrainSelectedInstOperands,
     /*  690017 */     // GIR_Coverage, 10854,
     /*  690017 */     GIR_EraseRootFromParent_Done,
     /*  690018 */   // Label 10926: @690018
     /*  690018 */   GIM_Try, /*On fail goto*//*Label 10927*/ GIMT_Encode4(690093), // Rule ID 10855 //
     /*  690023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  690034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  690037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  690040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  690043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4),
     /*  690072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690091 */     GIR_RootConstrainSelectedInstOperands,
     /*  690092 */     // GIR_Coverage, 10855,
     /*  690092 */     GIR_EraseRootFromParent_Done,
     /*  690093 */   // Label 10927: @690093
     /*  690093 */   GIM_Try, /*On fail goto*//*Label 10928*/ GIMT_Encode4(690168), // Rule ID 10858 //
     /*  690098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690166 */     GIR_RootConstrainSelectedInstOperands,
     /*  690167 */     // GIR_Coverage, 10858,
     /*  690167 */     GIR_EraseRootFromParent_Done,
     /*  690168 */   // Label 10928: @690168
     /*  690168 */   GIM_Try, /*On fail goto*//*Label 10929*/ GIMT_Encode4(690243), // Rule ID 10859 //
     /*  690173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  690184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  690187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  690190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  690193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690241 */     GIR_RootConstrainSelectedInstOperands,
     /*  690242 */     // GIR_Coverage, 10859,
     /*  690242 */     GIR_EraseRootFromParent_Done,
     /*  690243 */   // Label 10929: @690243
     /*  690243 */   GIM_Try, /*On fail goto*//*Label 10930*/ GIMT_Encode4(690318), // Rule ID 10862 //
     /*  690248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690316 */     GIR_RootConstrainSelectedInstOperands,
     /*  690317 */     // GIR_Coverage, 10862,
     /*  690317 */     GIR_EraseRootFromParent_Done,
     /*  690318 */   // Label 10930: @690318
     /*  690318 */   GIM_Try, /*On fail goto*//*Label 10931*/ GIMT_Encode4(690393), // Rule ID 10863 //
     /*  690323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  690334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  690337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  690340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  690343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2),
     /*  690372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690391 */     GIR_RootConstrainSelectedInstOperands,
     /*  690392 */     // GIR_Coverage, 10863,
     /*  690392 */     GIR_EraseRootFromParent_Done,
     /*  690393 */   // Label 10931: @690393
     /*  690393 */   GIM_Try, /*On fail goto*//*Label 10932*/ GIMT_Encode4(690468), // Rule ID 10866 //
     /*  690398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  690409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  690412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  690415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  690418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  690444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690466 */     GIR_RootConstrainSelectedInstOperands,
     /*  690467 */     // GIR_Coverage, 10866,
     /*  690467 */     GIR_EraseRootFromParent_Done,
     /*  690468 */   // Label 10932: @690468
     /*  690468 */   GIM_Try, /*On fail goto*//*Label 10933*/ GIMT_Encode4(690543), // Rule ID 10867 //
     /*  690473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  690484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  690487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  690490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  690493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  690519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  690538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690541 */     GIR_RootConstrainSelectedInstOperands,
     /*  690542 */     // GIR_Coverage, 10867,
     /*  690542 */     GIR_EraseRootFromParent_Done,
     /*  690543 */   // Label 10933: @690543
     /*  690543 */   GIM_Try, /*On fail goto*//*Label 10934*/ GIMT_Encode4(690618), // Rule ID 10870 //
     /*  690548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  690559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  690562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  690565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  690568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  690594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690616 */     GIR_RootConstrainSelectedInstOperands,
     /*  690617 */     // GIR_Coverage, 10870,
     /*  690617 */     GIR_EraseRootFromParent_Done,
     /*  690618 */   // Label 10934: @690618
     /*  690618 */   GIM_Try, /*On fail goto*//*Label 10935*/ GIMT_Encode4(690693), // Rule ID 10871 //
     /*  690623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  690634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  690637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  690640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  690643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  690669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  690688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690691 */     GIR_RootConstrainSelectedInstOperands,
     /*  690692 */     // GIR_Coverage, 10871,
     /*  690692 */     GIR_EraseRootFromParent_Done,
     /*  690693 */   // Label 10935: @690693
     /*  690693 */   GIM_Try, /*On fail goto*//*Label 10936*/ GIMT_Encode4(690768), // Rule ID 10874 //
     /*  690698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  690701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  690709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  690712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  690715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  690718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  690744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690766 */     GIR_RootConstrainSelectedInstOperands,
     /*  690767 */     // GIR_Coverage, 10874,
     /*  690767 */     GIR_EraseRootFromParent_Done,
     /*  690768 */   // Label 10936: @690768
     /*  690768 */   GIM_Try, /*On fail goto*//*Label 10937*/ GIMT_Encode4(690843), // Rule ID 10875 //
     /*  690773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  690776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  690784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  690787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  690790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  690793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  690819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  690838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690841 */     GIR_RootConstrainSelectedInstOperands,
     /*  690842 */     // GIR_Coverage, 10875,
     /*  690842 */     GIR_EraseRootFromParent_Done,
     /*  690843 */   // Label 10937: @690843
     /*  690843 */   GIM_Try, /*On fail goto*//*Label 10938*/ GIMT_Encode4(690918), // Rule ID 10878 //
     /*  690848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  690851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  690859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  690862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  690865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  690868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  690871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  690894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690916 */     GIR_RootConstrainSelectedInstOperands,
     /*  690917 */     // GIR_Coverage, 10878,
     /*  690917 */     GIR_EraseRootFromParent_Done,
     /*  690918 */   // Label 10938: @690918
     /*  690918 */   GIM_Try, /*On fail goto*//*Label 10939*/ GIMT_Encode4(690993), // Rule ID 10879 //
     /*  690923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  690926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  690931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  690934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  690937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  690940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  690943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  690946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  690962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  690969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  690969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1),
     /*  690972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  690974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  690976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  690978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  690980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  690985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  690988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  690991 */     GIR_RootConstrainSelectedInstOperands,
     /*  690992 */     // GIR_Coverage, 10879,
     /*  690992 */     GIR_EraseRootFromParent_Done,
     /*  690993 */   // Label 10939: @690993
     /*  690993 */   GIM_Try, /*On fail goto*//*Label 10940*/ GIMT_Encode4(691068), // Rule ID 10882 //
     /*  690998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691066 */     GIR_RootConstrainSelectedInstOperands,
     /*  691067 */     // GIR_Coverage, 10882,
     /*  691067 */     GIR_EraseRootFromParent_Done,
     /*  691068 */   // Label 10940: @691068
     /*  691068 */   GIM_Try, /*On fail goto*//*Label 10941*/ GIMT_Encode4(691143), // Rule ID 10883 //
     /*  691073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  691084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  691087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  691090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  691093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691141 */     GIR_RootConstrainSelectedInstOperands,
     /*  691142 */     // GIR_Coverage, 10883,
     /*  691142 */     GIR_EraseRootFromParent_Done,
     /*  691143 */   // Label 10941: @691143
     /*  691143 */   GIM_Try, /*On fail goto*//*Label 10942*/ GIMT_Encode4(691218), // Rule ID 10886 //
     /*  691148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691216 */     GIR_RootConstrainSelectedInstOperands,
     /*  691217 */     // GIR_Coverage, 10886,
     /*  691217 */     GIR_EraseRootFromParent_Done,
     /*  691218 */   // Label 10942: @691218
     /*  691218 */   GIM_Try, /*On fail goto*//*Label 10943*/ GIMT_Encode4(691293), // Rule ID 10887 //
     /*  691223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  691234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  691237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  691240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  691243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691291 */     GIR_RootConstrainSelectedInstOperands,
     /*  691292 */     // GIR_Coverage, 10887,
     /*  691292 */     GIR_EraseRootFromParent_Done,
     /*  691293 */   // Label 10943: @691293
     /*  691293 */   GIM_Try, /*On fail goto*//*Label 10944*/ GIMT_Encode4(691368), // Rule ID 10890 //
     /*  691298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  691344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691366 */     GIR_RootConstrainSelectedInstOperands,
     /*  691367 */     // GIR_Coverage, 10890,
     /*  691367 */     GIR_EraseRootFromParent_Done,
     /*  691368 */   // Label 10944: @691368
     /*  691368 */   GIM_Try, /*On fail goto*//*Label 10945*/ GIMT_Encode4(691443), // Rule ID 10891 //
     /*  691373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  691384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  691387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  691390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  691393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  691419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  691438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691441 */     GIR_RootConstrainSelectedInstOperands,
     /*  691442 */     // GIR_Coverage, 10891,
     /*  691442 */     GIR_EraseRootFromParent_Done,
     /*  691443 */   // Label 10945: @691443
     /*  691443 */   GIM_Try, /*On fail goto*//*Label 10946*/ GIMT_Encode4(691518), // Rule ID 10894 //
     /*  691448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  691459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  691462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  691465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  691468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691516 */     GIR_RootConstrainSelectedInstOperands,
     /*  691517 */     // GIR_Coverage, 10894,
     /*  691517 */     GIR_EraseRootFromParent_Done,
     /*  691518 */   // Label 10946: @691518
     /*  691518 */   GIM_Try, /*On fail goto*//*Label 10947*/ GIMT_Encode4(691593), // Rule ID 10895 //
     /*  691523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  691534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  691537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  691540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  691543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691591 */     GIR_RootConstrainSelectedInstOperands,
     /*  691592 */     // GIR_Coverage, 10895,
     /*  691592 */     GIR_EraseRootFromParent_Done,
     /*  691593 */   // Label 10947: @691593
     /*  691593 */   GIM_Try, /*On fail goto*//*Label 10948*/ GIMT_Encode4(691668), // Rule ID 10898 //
     /*  691598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  691609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  691612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  691615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  691618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691666 */     GIR_RootConstrainSelectedInstOperands,
     /*  691667 */     // GIR_Coverage, 10898,
     /*  691667 */     GIR_EraseRootFromParent_Done,
     /*  691668 */   // Label 10948: @691668
     /*  691668 */   GIM_Try, /*On fail goto*//*Label 10949*/ GIMT_Encode4(691743), // Rule ID 10899 //
     /*  691673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  691684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  691687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  691690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  691693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  691712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  691722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691741 */     GIR_RootConstrainSelectedInstOperands,
     /*  691742 */     // GIR_Coverage, 10899,
     /*  691742 */     GIR_EraseRootFromParent_Done,
     /*  691743 */   // Label 10949: @691743
     /*  691743 */   GIM_Try, /*On fail goto*//*Label 10950*/ GIMT_Encode4(691818), // Rule ID 10902 //
     /*  691748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  691759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  691762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  691765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  691768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  691794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691816 */     GIR_RootConstrainSelectedInstOperands,
     /*  691817 */     // GIR_Coverage, 10902,
     /*  691817 */     GIR_EraseRootFromParent_Done,
     /*  691818 */   // Label 10950: @691818
     /*  691818 */   GIM_Try, /*On fail goto*//*Label 10951*/ GIMT_Encode4(691893), // Rule ID 10903 //
     /*  691823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  691834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  691837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  691840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  691843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  691862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  691869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  691872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  691888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691891 */     GIR_RootConstrainSelectedInstOperands,
     /*  691892 */     // GIR_Coverage, 10903,
     /*  691892 */     GIR_EraseRootFromParent_Done,
     /*  691893 */   // Label 10951: @691893
     /*  691893 */   GIM_Try, /*On fail goto*//*Label 10952*/ GIMT_Encode4(691968), // Rule ID 10906 //
     /*  691898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  691901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  691909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  691912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  691915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  691918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  691921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  691937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  691944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  691944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  691947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  691949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  691951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  691953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  691955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  691960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  691963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  691966 */     GIR_RootConstrainSelectedInstOperands,
     /*  691967 */     // GIR_Coverage, 10906,
     /*  691967 */     GIR_EraseRootFromParent_Done,
     /*  691968 */   // Label 10952: @691968
     /*  691968 */   GIM_Try, /*On fail goto*//*Label 10953*/ GIMT_Encode4(692043), // Rule ID 10907 //
     /*  691973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  691976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  691981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  691984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  691987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  691990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  691993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  691996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692041 */     GIR_RootConstrainSelectedInstOperands,
     /*  692042 */     // GIR_Coverage, 10907,
     /*  692042 */     GIR_EraseRootFromParent_Done,
     /*  692043 */   // Label 10953: @692043
     /*  692043 */   GIM_Try, /*On fail goto*//*Label 10954*/ GIMT_Encode4(692118), // Rule ID 10910 //
     /*  692048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692116 */     GIR_RootConstrainSelectedInstOperands,
     /*  692117 */     // GIR_Coverage, 10910,
     /*  692117 */     GIR_EraseRootFromParent_Done,
     /*  692118 */   // Label 10954: @692118
     /*  692118 */   GIM_Try, /*On fail goto*//*Label 10955*/ GIMT_Encode4(692193), // Rule ID 10911 //
     /*  692123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  692134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  692137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  692140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  692143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692191 */     GIR_RootConstrainSelectedInstOperands,
     /*  692192 */     // GIR_Coverage, 10911,
     /*  692192 */     GIR_EraseRootFromParent_Done,
     /*  692193 */   // Label 10955: @692193
     /*  692193 */   GIM_Try, /*On fail goto*//*Label 10956*/ GIMT_Encode4(692268), // Rule ID 10914 //
     /*  692198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  692244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692266 */     GIR_RootConstrainSelectedInstOperands,
     /*  692267 */     // GIR_Coverage, 10914,
     /*  692267 */     GIR_EraseRootFromParent_Done,
     /*  692268 */   // Label 10956: @692268
     /*  692268 */   GIM_Try, /*On fail goto*//*Label 10957*/ GIMT_Encode4(692343), // Rule ID 10915 //
     /*  692273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  692284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  692287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  692290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  692293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  692319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  692338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692341 */     GIR_RootConstrainSelectedInstOperands,
     /*  692342 */     // GIR_Coverage, 10915,
     /*  692342 */     GIR_EraseRootFromParent_Done,
     /*  692343 */   // Label 10957: @692343
     /*  692343 */   GIM_Try, /*On fail goto*//*Label 10958*/ GIMT_Encode4(692418), // Rule ID 10918 //
     /*  692348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  692351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692416 */     GIR_RootConstrainSelectedInstOperands,
     /*  692417 */     // GIR_Coverage, 10918,
     /*  692417 */     GIR_EraseRootFromParent_Done,
     /*  692418 */   // Label 10958: @692418
     /*  692418 */   GIM_Try, /*On fail goto*//*Label 10959*/ GIMT_Encode4(692493), // Rule ID 10919 //
     /*  692423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  692426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  692434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  692437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  692440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  692443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  692462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2),
     /*  692472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692491 */     GIR_RootConstrainSelectedInstOperands,
     /*  692492 */     // GIR_Coverage, 10919,
     /*  692492 */     GIR_EraseRootFromParent_Done,
     /*  692493 */   // Label 10959: @692493
     /*  692493 */   GIM_Try, /*On fail goto*//*Label 10960*/ GIMT_Encode4(692568), // Rule ID 10922 //
     /*  692498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  692501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  692509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  692512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  692515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  692518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692566 */     GIR_RootConstrainSelectedInstOperands,
     /*  692567 */     // GIR_Coverage, 10922,
     /*  692567 */     GIR_EraseRootFromParent_Done,
     /*  692568 */   // Label 10960: @692568
     /*  692568 */   GIM_Try, /*On fail goto*//*Label 10961*/ GIMT_Encode4(692643), // Rule ID 10923 //
     /*  692573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  692576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  692584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  692587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  692590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  692593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  692612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4),
     /*  692622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692641 */     GIR_RootConstrainSelectedInstOperands,
     /*  692642 */     // GIR_Coverage, 10923,
     /*  692642 */     GIR_EraseRootFromParent_Done,
     /*  692643 */   // Label 10961: @692643
     /*  692643 */   GIM_Try, /*On fail goto*//*Label 10962*/ GIMT_Encode4(692718), // Rule ID 10926 //
     /*  692648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  692651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  692659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  692662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  692665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  692668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  692694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692716 */     GIR_RootConstrainSelectedInstOperands,
     /*  692717 */     // GIR_Coverage, 10926,
     /*  692717 */     GIR_EraseRootFromParent_Done,
     /*  692718 */   // Label 10962: @692718
     /*  692718 */   GIM_Try, /*On fail goto*//*Label 10963*/ GIMT_Encode4(692793), // Rule ID 10927 //
     /*  692723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  692726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  692734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  692737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  692740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  692743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  692762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  692769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8),
     /*  692772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  692788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692791 */     GIR_RootConstrainSelectedInstOperands,
     /*  692792 */     // GIR_Coverage, 10927,
     /*  692792 */     GIR_EraseRootFromParent_Done,
     /*  692793 */   // Label 10963: @692793
     /*  692793 */   GIM_Try, /*On fail goto*//*Label 10964*/ GIMT_Encode4(692868), // Rule ID 10930 //
     /*  692798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  692809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  692812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  692815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  692847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692866 */     GIR_RootConstrainSelectedInstOperands,
     /*  692867 */     // GIR_Coverage, 10930,
     /*  692867 */     GIR_EraseRootFromParent_Done,
     /*  692868 */   // Label 10964: @692868
     /*  692868 */   GIM_Try, /*On fail goto*//*Label 10965*/ GIMT_Encode4(692943), // Rule ID 10931 //
     /*  692873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  692876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  692884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  692887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  692890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  692893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  692896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  692919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8),
     /*  692922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  692926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  692928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  692930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  692935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  692938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  692941 */     GIR_RootConstrainSelectedInstOperands,
     /*  692942 */     // GIR_Coverage, 10931,
     /*  692942 */     GIR_EraseRootFromParent_Done,
     /*  692943 */   // Label 10965: @692943
     /*  692943 */   GIM_Try, /*On fail goto*//*Label 10966*/ GIMT_Encode4(693018), // Rule ID 10934 //
     /*  692948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  692951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  692956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  692959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  692962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  692965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  692968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  692971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  692983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  692987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  692994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  692994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  692997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  692999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693016 */     GIR_RootConstrainSelectedInstOperands,
     /*  693017 */     // GIR_Coverage, 10934,
     /*  693017 */     GIR_EraseRootFromParent_Done,
     /*  693018 */   // Label 10966: @693018
     /*  693018 */   GIM_Try, /*On fail goto*//*Label 10967*/ GIMT_Encode4(693093), // Rule ID 10935 //
     /*  693023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  693034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  693037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  693040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693091 */     GIR_RootConstrainSelectedInstOperands,
     /*  693092 */     // GIR_Coverage, 10935,
     /*  693092 */     GIR_EraseRootFromParent_Done,
     /*  693093 */   // Label 10967: @693093
     /*  693093 */   GIM_Try, /*On fail goto*//*Label 10968*/ GIMT_Encode4(693168), // Rule ID 10938 //
     /*  693098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693166 */     GIR_RootConstrainSelectedInstOperands,
     /*  693167 */     // GIR_Coverage, 10938,
     /*  693167 */     GIR_EraseRootFromParent_Done,
     /*  693168 */   // Label 10968: @693168
     /*  693168 */   GIM_Try, /*On fail goto*//*Label 10969*/ GIMT_Encode4(693243), // Rule ID 10939 //
     /*  693173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  693184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  693187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  693190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693241 */     GIR_RootConstrainSelectedInstOperands,
     /*  693242 */     // GIR_Coverage, 10939,
     /*  693242 */     GIR_EraseRootFromParent_Done,
     /*  693243 */   // Label 10969: @693243
     /*  693243 */   GIM_Try, /*On fail goto*//*Label 10970*/ GIMT_Encode4(693318), // Rule ID 10942 //
     /*  693248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693316 */     GIR_RootConstrainSelectedInstOperands,
     /*  693317 */     // GIR_Coverage, 10942,
     /*  693317 */     GIR_EraseRootFromParent_Done,
     /*  693318 */   // Label 10970: @693318
     /*  693318 */   GIM_Try, /*On fail goto*//*Label 10971*/ GIMT_Encode4(693393), // Rule ID 10943 //
     /*  693323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  693334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  693337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  693340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4),
     /*  693372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693391 */     GIR_RootConstrainSelectedInstOperands,
     /*  693392 */     // GIR_Coverage, 10943,
     /*  693392 */     GIR_EraseRootFromParent_Done,
     /*  693393 */   // Label 10971: @693393
     /*  693393 */   GIM_Try, /*On fail goto*//*Label 10972*/ GIMT_Encode4(693468), // Rule ID 10946 //
     /*  693398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  693409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  693412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  693415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693466 */     GIR_RootConstrainSelectedInstOperands,
     /*  693467 */     // GIR_Coverage, 10946,
     /*  693467 */     GIR_EraseRootFromParent_Done,
     /*  693468 */   // Label 10972: @693468
     /*  693468 */   GIM_Try, /*On fail goto*//*Label 10973*/ GIMT_Encode4(693543), // Rule ID 10947 //
     /*  693473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  693484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  693487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  693490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693541 */     GIR_RootConstrainSelectedInstOperands,
     /*  693542 */     // GIR_Coverage, 10947,
     /*  693542 */     GIR_EraseRootFromParent_Done,
     /*  693543 */   // Label 10973: @693543
     /*  693543 */   GIM_Try, /*On fail goto*//*Label 10974*/ GIMT_Encode4(693618), // Rule ID 10950 //
     /*  693548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  693559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  693562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  693565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  693594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693616 */     GIR_RootConstrainSelectedInstOperands,
     /*  693617 */     // GIR_Coverage, 10950,
     /*  693617 */     GIR_EraseRootFromParent_Done,
     /*  693618 */   // Label 10974: @693618
     /*  693618 */   GIM_Try, /*On fail goto*//*Label 10975*/ GIMT_Encode4(693693), // Rule ID 10951 //
     /*  693623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  693634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  693637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  693640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  693669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2),
     /*  693672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  693688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693691 */     GIR_RootConstrainSelectedInstOperands,
     /*  693692 */     // GIR_Coverage, 10951,
     /*  693692 */     GIR_EraseRootFromParent_Done,
     /*  693693 */   // Label 10975: @693693
     /*  693693 */   GIM_Try, /*On fail goto*//*Label 10976*/ GIMT_Encode4(693768), // Rule ID 10954 //
     /*  693698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  693709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  693712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  693715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  693744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  693747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693766 */     GIR_RootConstrainSelectedInstOperands,
     /*  693767 */     // GIR_Coverage, 10954,
     /*  693767 */     GIR_EraseRootFromParent_Done,
     /*  693768 */   // Label 10976: @693768
     /*  693768 */   GIM_Try, /*On fail goto*//*Label 10977*/ GIMT_Encode4(693843), // Rule ID 10955 //
     /*  693773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  693784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  693787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  693790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11400:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  693819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  693822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  693838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693841 */     GIR_RootConstrainSelectedInstOperands,
     /*  693842 */     // GIR_Coverage, 10955,
     /*  693842 */     GIR_EraseRootFromParent_Done,
     /*  693843 */   // Label 10977: @693843
     /*  693843 */   GIM_Try, /*On fail goto*//*Label 10978*/ GIMT_Encode4(693918), // Rule ID 10958 //
     /*  693848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  693851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  693859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  693862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  693865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  693868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  693871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  693894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  693897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693916 */     GIR_RootConstrainSelectedInstOperands,
     /*  693917 */     // GIR_Coverage, 10958,
     /*  693917 */     GIR_EraseRootFromParent_Done,
     /*  693918 */   // Label 10978: @693918
     /*  693918 */   GIM_Try, /*On fail goto*//*Label 10979*/ GIMT_Encode4(693993), // Rule ID 10959 //
     /*  693923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  693926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  693931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  693934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  693937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  693940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  693943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  693946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  693958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  693962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  693969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11400:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  693969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  693972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  693974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  693976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  693978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  693980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  693985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  693988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  693991 */     GIR_RootConstrainSelectedInstOperands,
     /*  693992 */     // GIR_Coverage, 10959,
     /*  693992 */     GIR_EraseRootFromParent_Done,
     /*  693993 */   // Label 10979: @693993
     /*  693993 */   GIM_Try, /*On fail goto*//*Label 10980*/ GIMT_Encode4(694068), // Rule ID 10962 //
     /*  693998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  694044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694066 */     GIR_RootConstrainSelectedInstOperands,
     /*  694067 */     // GIR_Coverage, 10962,
     /*  694067 */     GIR_EraseRootFromParent_Done,
     /*  694068 */   // Label 10980: @694068
     /*  694068 */   GIM_Try, /*On fail goto*//*Label 10981*/ GIMT_Encode4(694143), // Rule ID 10963 //
     /*  694073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  694084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  694087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  694090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11400:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  694119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  694138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694141 */     GIR_RootConstrainSelectedInstOperands,
     /*  694142 */     // GIR_Coverage, 10963,
     /*  694142 */     GIR_EraseRootFromParent_Done,
     /*  694143 */   // Label 10981: @694143
     /*  694143 */   GIM_Try, /*On fail goto*//*Label 10982*/ GIMT_Encode4(694218), // Rule ID 10966 //
     /*  694148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  694151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  694194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694216 */     GIR_RootConstrainSelectedInstOperands,
     /*  694217 */     // GIR_Coverage, 10966,
     /*  694217 */     GIR_EraseRootFromParent_Done,
     /*  694218 */   // Label 10982: @694218
     /*  694218 */   GIM_Try, /*On fail goto*//*Label 10983*/ GIMT_Encode4(694293), // Rule ID 10967 //
     /*  694223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  694226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  694234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  694237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  694240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  694258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694269 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11400:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  694269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1),
     /*  694272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  694288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694291 */     GIR_RootConstrainSelectedInstOperands,
     /*  694292 */     // GIR_Coverage, 10967,
     /*  694292 */     GIR_EraseRootFromParent_Done,
     /*  694293 */   // Label 10983: @694293
     /*  694293 */   GIM_Try, /*On fail goto*//*Label 10984*/ GIMT_Encode4(694368), // Rule ID 10970 //
     /*  694298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694366 */     GIR_RootConstrainSelectedInstOperands,
     /*  694367 */     // GIR_Coverage, 10970,
     /*  694367 */     GIR_EraseRootFromParent_Done,
     /*  694368 */   // Label 10984: @694368
     /*  694368 */   GIM_Try, /*On fail goto*//*Label 10985*/ GIMT_Encode4(694443), // Rule ID 10971 //
     /*  694373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  694384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  694387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  694390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694419 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694441 */     GIR_RootConstrainSelectedInstOperands,
     /*  694442 */     // GIR_Coverage, 10971,
     /*  694442 */     GIR_EraseRootFromParent_Done,
     /*  694443 */   // Label 10985: @694443
     /*  694443 */   GIM_Try, /*On fail goto*//*Label 10986*/ GIMT_Encode4(694518), // Rule ID 10974 //
     /*  694448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  694459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  694462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  694465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  694497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694516 */     GIR_RootConstrainSelectedInstOperands,
     /*  694517 */     // GIR_Coverage, 10974,
     /*  694517 */     GIR_EraseRootFromParent_Done,
     /*  694518 */   // Label 10986: @694518
     /*  694518 */   GIM_Try, /*On fail goto*//*Label 10987*/ GIMT_Encode4(694593), // Rule ID 10975 //
     /*  694523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  694534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  694537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  694540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  694572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694591 */     GIR_RootConstrainSelectedInstOperands,
     /*  694592 */     // GIR_Coverage, 10975,
     /*  694592 */     GIR_EraseRootFromParent_Done,
     /*  694593 */   // Label 10987: @694593
     /*  694593 */   GIM_Try, /*On fail goto*//*Label 10988*/ GIMT_Encode4(694668), // Rule ID 10978 //
     /*  694598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  694609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  694612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  694615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  694644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  694647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694666 */     GIR_RootConstrainSelectedInstOperands,
     /*  694667 */     // GIR_Coverage, 10978,
     /*  694667 */     GIR_EraseRootFromParent_Done,
     /*  694668 */   // Label 10988: @694668
     /*  694668 */   GIM_Try, /*On fail goto*//*Label 10989*/ GIMT_Encode4(694743), // Rule ID 10979 //
     /*  694673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  694684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  694687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  694690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  694708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  694719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  694722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  694738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694741 */     GIR_RootConstrainSelectedInstOperands,
     /*  694742 */     // GIR_Coverage, 10979,
     /*  694742 */     GIR_EraseRootFromParent_Done,
     /*  694743 */   // Label 10989: @694743
     /*  694743 */   GIM_Try, /*On fail goto*//*Label 10990*/ GIMT_Encode4(694818), // Rule ID 10982 //
     /*  694748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  694759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  694762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  694765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694816 */     GIR_RootConstrainSelectedInstOperands,
     /*  694817 */     // GIR_Coverage, 10982,
     /*  694817 */     GIR_EraseRootFromParent_Done,
     /*  694818 */   // Label 10990: @694818
     /*  694818 */   GIM_Try, /*On fail goto*//*Label 10991*/ GIMT_Encode4(694893), // Rule ID 10983 //
     /*  694823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  694834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  694837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  694840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  694858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  694869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  694872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694891 */     GIR_RootConstrainSelectedInstOperands,
     /*  694892 */     // GIR_Coverage, 10983,
     /*  694892 */     GIR_EraseRootFromParent_Done,
     /*  694893 */   // Label 10991: @694893
     /*  694893 */   GIM_Try, /*On fail goto*//*Label 10992*/ GIMT_Encode4(694968), // Rule ID 10986 //
     /*  694898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  694901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  694909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  694912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  694915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  694918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  694921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  694933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  694937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  694944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  694944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  694947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  694949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  694951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  694953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  694955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  694960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  694963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  694966 */     GIR_RootConstrainSelectedInstOperands,
     /*  694967 */     // GIR_Coverage, 10986,
     /*  694967 */     GIR_EraseRootFromParent_Done,
     /*  694968 */   // Label 10992: @694968
     /*  694968 */   GIM_Try, /*On fail goto*//*Label 10993*/ GIMT_Encode4(695043), // Rule ID 10987 //
     /*  694973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  694976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  694981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  694984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  694987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  694990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  694993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  694996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695041 */     GIR_RootConstrainSelectedInstOperands,
     /*  695042 */     // GIR_Coverage, 10987,
     /*  695042 */     GIR_EraseRootFromParent_Done,
     /*  695043 */   // Label 10993: @695043
     /*  695043 */   GIM_Try, /*On fail goto*//*Label 10994*/ GIMT_Encode4(695118), // Rule ID 10990 //
     /*  695048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  695094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695116 */     GIR_RootConstrainSelectedInstOperands,
     /*  695117 */     // GIR_Coverage, 10990,
     /*  695117 */     GIR_EraseRootFromParent_Done,
     /*  695118 */   // Label 10994: @695118
     /*  695118 */   GIM_Try, /*On fail goto*//*Label 10995*/ GIMT_Encode4(695193), // Rule ID 10991 //
     /*  695123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  695134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  695137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  695140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  695169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  695188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695191 */     GIR_RootConstrainSelectedInstOperands,
     /*  695192 */     // GIR_Coverage, 10991,
     /*  695192 */     GIR_EraseRootFromParent_Done,
     /*  695193 */   // Label 10995: @695193
     /*  695193 */   GIM_Try, /*On fail goto*//*Label 10996*/ GIMT_Encode4(695268), // Rule ID 10994 //
     /*  695198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695266 */     GIR_RootConstrainSelectedInstOperands,
     /*  695267 */     // GIR_Coverage, 10994,
     /*  695267 */     GIR_EraseRootFromParent_Done,
     /*  695268 */   // Label 10996: @695268
     /*  695268 */   GIM_Try, /*On fail goto*//*Label 10997*/ GIMT_Encode4(695343), // Rule ID 10995 //
     /*  695273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  695284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  695287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  695290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695341 */     GIR_RootConstrainSelectedInstOperands,
     /*  695342 */     // GIR_Coverage, 10995,
     /*  695342 */     GIR_EraseRootFromParent_Done,
     /*  695343 */   // Label 10997: @695343
     /*  695343 */   GIM_Try, /*On fail goto*//*Label 10998*/ GIMT_Encode4(695418), // Rule ID 10998 //
     /*  695348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695416 */     GIR_RootConstrainSelectedInstOperands,
     /*  695417 */     // GIR_Coverage, 10998,
     /*  695417 */     GIR_EraseRootFromParent_Done,
     /*  695418 */   // Label 10998: @695418
     /*  695418 */   GIM_Try, /*On fail goto*//*Label 10999*/ GIMT_Encode4(695493), // Rule ID 10999 //
     /*  695423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  695434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  695437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  695440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695491 */     GIR_RootConstrainSelectedInstOperands,
     /*  695492 */     // GIR_Coverage, 10999,
     /*  695492 */     GIR_EraseRootFromParent_Done,
     /*  695493 */   // Label 10999: @695493
     /*  695493 */   GIM_Try, /*On fail goto*//*Label 11000*/ GIMT_Encode4(695568), // Rule ID 11002 //
     /*  695498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  695501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  695509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  695512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  695515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  695544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695566 */     GIR_RootConstrainSelectedInstOperands,
     /*  695567 */     // GIR_Coverage, 11002,
     /*  695567 */     GIR_EraseRootFromParent_Done,
     /*  695568 */   // Label 11000: @695568
     /*  695568 */   GIM_Try, /*On fail goto*//*Label 11001*/ GIMT_Encode4(695643), // Rule ID 11003 //
     /*  695573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  695576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  695584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  695587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  695590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  695619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  695638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695641 */     GIR_RootConstrainSelectedInstOperands,
     /*  695642 */     // GIR_Coverage, 11003,
     /*  695642 */     GIR_EraseRootFromParent_Done,
     /*  695643 */   // Label 11001: @695643
     /*  695643 */   GIM_Try, /*On fail goto*//*Label 11002*/ GIMT_Encode4(695718), // Rule ID 11006 //
     /*  695648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  695659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  695662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  695665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695716 */     GIR_RootConstrainSelectedInstOperands,
     /*  695717 */     // GIR_Coverage, 11006,
     /*  695717 */     GIR_EraseRootFromParent_Done,
     /*  695718 */   // Label 11002: @695718
     /*  695718 */   GIM_Try, /*On fail goto*//*Label 11003*/ GIMT_Encode4(695793), // Rule ID 11007 //
     /*  695723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  695734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  695737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  695740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  695758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11400:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2),
     /*  695772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695791 */     GIR_RootConstrainSelectedInstOperands,
     /*  695792 */     // GIR_Coverage, 11007,
     /*  695792 */     GIR_EraseRootFromParent_Done,
     /*  695793 */   // Label 11003: @695793
     /*  695793 */   GIM_Try, /*On fail goto*//*Label 11004*/ GIMT_Encode4(695868), // Rule ID 11010 //
     /*  695798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  695809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  695812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  695815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695866 */     GIR_RootConstrainSelectedInstOperands,
     /*  695867 */     // GIR_Coverage, 11010,
     /*  695867 */     GIR_EraseRootFromParent_Done,
     /*  695868 */   // Label 11004: @695868
     /*  695868 */   GIM_Try, /*On fail goto*//*Label 11005*/ GIMT_Encode4(695943), // Rule ID 11011 //
     /*  695873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  695876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  695884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  695887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  695890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  695893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  695896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  695908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11400:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  695919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4),
     /*  695922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  695926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  695928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  695930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  695935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  695938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  695941 */     GIR_RootConstrainSelectedInstOperands,
     /*  695942 */     // GIR_Coverage, 11011,
     /*  695942 */     GIR_EraseRootFromParent_Done,
     /*  695943 */   // Label 11005: @695943
     /*  695943 */   GIM_Try, /*On fail goto*//*Label 11006*/ GIMT_Encode4(696018), // Rule ID 11014 //
     /*  695948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  695951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  695956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  695959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  695962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  695965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  695968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  695971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  695983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  695987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  695994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  695994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  695997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  695999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696016 */     GIR_RootConstrainSelectedInstOperands,
     /*  696017 */     // GIR_Coverage, 11014,
     /*  696017 */     GIR_EraseRootFromParent_Done,
     /*  696018 */   // Label 11006: @696018
     /*  696018 */   GIM_Try, /*On fail goto*//*Label 11007*/ GIMT_Encode4(696093), // Rule ID 11015 //
     /*  696023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  696026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul),
     /*  696031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  696034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  696037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  696040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  696043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  696058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  696062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11400:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  696069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8),
     /*  696072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  696088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696091 */     GIR_RootConstrainSelectedInstOperands,
     /*  696092 */     // GIR_Coverage, 11015,
     /*  696092 */     GIR_EraseRootFromParent_Done,
     /*  696093 */   // Label 11007: @696093
     /*  696093 */   GIM_Try, /*On fail goto*//*Label 11008*/ GIMT_Encode4(696168), // Rule ID 11018 //
     /*  696098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696166 */     GIR_RootConstrainSelectedInstOperands,
     /*  696167 */     // GIR_Coverage, 11018,
     /*  696167 */     GIR_EraseRootFromParent_Done,
     /*  696168 */   // Label 11008: @696168
     /*  696168 */   GIM_Try, /*On fail goto*//*Label 11009*/ GIMT_Encode4(696243), // Rule ID 11019 //
     /*  696173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  696184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  696187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  696190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  696193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /*  696222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696241 */     GIR_RootConstrainSelectedInstOperands,
     /*  696242 */     // GIR_Coverage, 11019,
     /*  696242 */     GIR_EraseRootFromParent_Done,
     /*  696243 */   // Label 11009: @696243
     /*  696243 */   GIM_Try, /*On fail goto*//*Label 11010*/ GIMT_Encode4(696318), // Rule ID 11022 //
     /*  696248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696316 */     GIR_RootConstrainSelectedInstOperands,
     /*  696317 */     // GIR_Coverage, 11022,
     /*  696317 */     GIR_EraseRootFromParent_Done,
     /*  696318 */   // Label 11010: @696318
     /*  696318 */   GIM_Try, /*On fail goto*//*Label 11011*/ GIMT_Encode4(696393), // Rule ID 11023 //
     /*  696323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  696334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  696337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  696340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  696343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696369 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696391 */     GIR_RootConstrainSelectedInstOperands,
     /*  696392 */     // GIR_Coverage, 11023,
     /*  696392 */     GIR_EraseRootFromParent_Done,
     /*  696393 */   // Label 11011: @696393
     /*  696393 */   GIM_Try, /*On fail goto*//*Label 11012*/ GIMT_Encode4(696468), // Rule ID 11026 //
     /*  696398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  696409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  696412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  696415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  696418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  696444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696466 */     GIR_RootConstrainSelectedInstOperands,
     /*  696467 */     // GIR_Coverage, 11026,
     /*  696467 */     GIR_EraseRootFromParent_Done,
     /*  696468 */   // Label 11012: @696468
     /*  696468 */   GIM_Try, /*On fail goto*//*Label 11013*/ GIMT_Encode4(696543), // Rule ID 11027 //
     /*  696473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  696484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  696487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  696490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  696493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  696519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  696538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696541 */     GIR_RootConstrainSelectedInstOperands,
     /*  696542 */     // GIR_Coverage, 11027,
     /*  696542 */     GIR_EraseRootFromParent_Done,
     /*  696543 */   // Label 11013: @696543
     /*  696543 */   GIM_Try, /*On fail goto*//*Label 11014*/ GIMT_Encode4(696618), // Rule ID 11030 //
     /*  696548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  696559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  696562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  696565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  696568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696616 */     GIR_RootConstrainSelectedInstOperands,
     /*  696617 */     // GIR_Coverage, 11030,
     /*  696617 */     GIR_EraseRootFromParent_Done,
     /*  696618 */   // Label 11014: @696618
     /*  696618 */   GIM_Try, /*On fail goto*//*Label 11015*/ GIMT_Encode4(696693), // Rule ID 11031 //
     /*  696623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  696634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  696637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  696640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  696643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /*  696672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696691 */     GIR_RootConstrainSelectedInstOperands,
     /*  696692 */     // GIR_Coverage, 11031,
     /*  696692 */     GIR_EraseRootFromParent_Done,
     /*  696693 */   // Label 11015: @696693
     /*  696693 */   GIM_Try, /*On fail goto*//*Label 11016*/ GIMT_Encode4(696768), // Rule ID 11034 //
     /*  696698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  696709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  696712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  696715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  696718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  696744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696766 */     GIR_RootConstrainSelectedInstOperands,
     /*  696767 */     // GIR_Coverage, 11034,
     /*  696767 */     GIR_EraseRootFromParent_Done,
     /*  696768 */   // Label 11016: @696768
     /*  696768 */   GIM_Try, /*On fail goto*//*Label 11017*/ GIMT_Encode4(696843), // Rule ID 11035 //
     /*  696773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  696784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  696787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  696790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  696793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  696819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  696838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696841 */     GIR_RootConstrainSelectedInstOperands,
     /*  696842 */     // GIR_Coverage, 11035,
     /*  696842 */     GIR_EraseRootFromParent_Done,
     /*  696843 */   // Label 11017: @696843
     /*  696843 */   GIM_Try, /*On fail goto*//*Label 11018*/ GIMT_Encode4(696918), // Rule ID 11038 //
     /*  696848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  696851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  696859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  696862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  696865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  696868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  696871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  696894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696916 */     GIR_RootConstrainSelectedInstOperands,
     /*  696917 */     // GIR_Coverage, 11038,
     /*  696917 */     GIR_EraseRootFromParent_Done,
     /*  696918 */   // Label 11018: @696918
     /*  696918 */   GIM_Try, /*On fail goto*//*Label 11019*/ GIMT_Encode4(696993), // Rule ID 11039 //
     /*  696923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  696926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  696931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  696934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  696937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  696940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  696943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  696946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  696962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  696969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  696969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /*  696972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  696974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  696976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  696978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  696980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  696985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  696988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  696991 */     GIR_RootConstrainSelectedInstOperands,
     /*  696992 */     // GIR_Coverage, 11039,
     /*  696992 */     GIR_EraseRootFromParent_Done,
     /*  696993 */   // Label 11019: @696993
     /*  696993 */   GIM_Try, /*On fail goto*//*Label 11020*/ GIMT_Encode4(697068), // Rule ID 11042 //
     /*  696998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697066 */     GIR_RootConstrainSelectedInstOperands,
     /*  697067 */     // GIR_Coverage, 11042,
     /*  697067 */     GIR_EraseRootFromParent_Done,
     /*  697068 */   // Label 11020: @697068
     /*  697068 */   GIM_Try, /*On fail goto*//*Label 11021*/ GIMT_Encode4(697143), // Rule ID 11043 //
     /*  697073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  697084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  697087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  697090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  697093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697141 */     GIR_RootConstrainSelectedInstOperands,
     /*  697142 */     // GIR_Coverage, 11043,
     /*  697142 */     GIR_EraseRootFromParent_Done,
     /*  697143 */   // Label 11021: @697143
     /*  697143 */   GIM_Try, /*On fail goto*//*Label 11022*/ GIMT_Encode4(697218), // Rule ID 11046 //
     /*  697148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697216 */     GIR_RootConstrainSelectedInstOperands,
     /*  697217 */     // GIR_Coverage, 11046,
     /*  697217 */     GIR_EraseRootFromParent_Done,
     /*  697218 */   // Label 11022: @697218
     /*  697218 */   GIM_Try, /*On fail goto*//*Label 11023*/ GIMT_Encode4(697293), // Rule ID 11047 //
     /*  697223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  697234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  697237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  697240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  697243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  697269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697291 */     GIR_RootConstrainSelectedInstOperands,
     /*  697292 */     // GIR_Coverage, 11047,
     /*  697292 */     GIR_EraseRootFromParent_Done,
     /*  697293 */   // Label 11023: @697293
     /*  697293 */   GIM_Try, /*On fail goto*//*Label 11024*/ GIMT_Encode4(697368), // Rule ID 11050 //
     /*  697298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  697344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697366 */     GIR_RootConstrainSelectedInstOperands,
     /*  697367 */     // GIR_Coverage, 11050,
     /*  697367 */     GIR_EraseRootFromParent_Done,
     /*  697368 */   // Label 11024: @697368
     /*  697368 */   GIM_Try, /*On fail goto*//*Label 11025*/ GIMT_Encode4(697443), // Rule ID 11051 //
     /*  697373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  697384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  697387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  697390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  697393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  697412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  697419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  697422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  697438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697441 */     GIR_RootConstrainSelectedInstOperands,
     /*  697442 */     // GIR_Coverage, 11051,
     /*  697442 */     GIR_EraseRootFromParent_Done,
     /*  697443 */   // Label 11025: @697443
     /*  697443 */   GIM_Try, /*On fail goto*//*Label 11026*/ GIMT_Encode4(697518), // Rule ID 11054 //
     /*  697448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  697459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  697462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  697465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  697468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697494 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  697497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697516 */     GIR_RootConstrainSelectedInstOperands,
     /*  697517 */     // GIR_Coverage, 11054,
     /*  697517 */     GIR_EraseRootFromParent_Done,
     /*  697518 */   // Label 11026: @697518
     /*  697518 */   GIM_Try, /*On fail goto*//*Label 11027*/ GIMT_Encode4(697593), // Rule ID 11055 //
     /*  697523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  697534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  697537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  697540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  697543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697569 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  697572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697591 */     GIR_RootConstrainSelectedInstOperands,
     /*  697592 */     // GIR_Coverage, 11055,
     /*  697592 */     GIR_EraseRootFromParent_Done,
     /*  697593 */   // Label 11027: @697593
     /*  697593 */   GIM_Try, /*On fail goto*//*Label 11028*/ GIMT_Encode4(697668), // Rule ID 11058 //
     /*  697598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  697609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  697612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  697615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  697618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  697647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697666 */     GIR_RootConstrainSelectedInstOperands,
     /*  697667 */     // GIR_Coverage, 11058,
     /*  697667 */     GIR_EraseRootFromParent_Done,
     /*  697668 */   // Label 11028: @697668
     /*  697668 */   GIM_Try, /*On fail goto*//*Label 11029*/ GIMT_Encode4(697743), // Rule ID 11059 //
     /*  697673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  697684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  697687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  697690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  697693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  697712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697719 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  697722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697741 */     GIR_RootConstrainSelectedInstOperands,
     /*  697742 */     // GIR_Coverage, 11059,
     /*  697742 */     GIR_EraseRootFromParent_Done,
     /*  697743 */   // Label 11029: @697743
     /*  697743 */   GIM_Try, /*On fail goto*//*Label 11030*/ GIMT_Encode4(697818), // Rule ID 11062 //
     /*  697748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  697759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  697762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  697765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  697768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697794 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  697794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  697797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697816 */     GIR_RootConstrainSelectedInstOperands,
     /*  697817 */     // GIR_Coverage, 11062,
     /*  697817 */     GIR_EraseRootFromParent_Done,
     /*  697818 */   // Label 11030: @697818
     /*  697818 */   GIM_Try, /*On fail goto*//*Label 11031*/ GIMT_Encode4(697893), // Rule ID 11063 //
     /*  697823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  697834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  697837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  697840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  697843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  697862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697869 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  697869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  697872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  697888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697891 */     GIR_RootConstrainSelectedInstOperands,
     /*  697892 */     // GIR_Coverage, 11063,
     /*  697892 */     GIR_EraseRootFromParent_Done,
     /*  697893 */   // Label 11031: @697893
     /*  697893 */   GIM_Try, /*On fail goto*//*Label 11032*/ GIMT_Encode4(697968), // Rule ID 11066 //
     /*  697898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  697901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  697909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  697912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  697915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  697918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  697921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  697937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  697944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  697944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  697947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  697949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  697951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  697953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  697955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  697960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  697963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  697966 */     GIR_RootConstrainSelectedInstOperands,
     /*  697967 */     // GIR_Coverage, 11066,
     /*  697967 */     GIR_EraseRootFromParent_Done,
     /*  697968 */   // Label 11032: @697968
     /*  697968 */   GIM_Try, /*On fail goto*//*Label 11033*/ GIMT_Encode4(698043), // Rule ID 11067 //
     /*  697973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  697976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  697981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  697984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  697987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  697990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  697993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  697996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698041 */     GIR_RootConstrainSelectedInstOperands,
     /*  698042 */     // GIR_Coverage, 11067,
     /*  698042 */     GIR_EraseRootFromParent_Done,
     /*  698043 */   // Label 11033: @698043
     /*  698043 */   GIM_Try, /*On fail goto*//*Label 11034*/ GIMT_Encode4(698118), // Rule ID 11070 //
     /*  698048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698094 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698116 */     GIR_RootConstrainSelectedInstOperands,
     /*  698117 */     // GIR_Coverage, 11070,
     /*  698117 */     GIR_EraseRootFromParent_Done,
     /*  698118 */   // Label 11034: @698118
     /*  698118 */   GIM_Try, /*On fail goto*//*Label 11035*/ GIMT_Encode4(698193), // Rule ID 11071 //
     /*  698123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  698134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  698137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  698140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  698143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698169 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698191 */     GIR_RootConstrainSelectedInstOperands,
     /*  698192 */     // GIR_Coverage, 11071,
     /*  698192 */     GIR_EraseRootFromParent_Done,
     /*  698193 */   // Label 11035: @698193
     /*  698193 */   GIM_Try, /*On fail goto*//*Label 11036*/ GIMT_Encode4(698268), // Rule ID 11074 //
     /*  698198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  698244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698266 */     GIR_RootConstrainSelectedInstOperands,
     /*  698267 */     // GIR_Coverage, 11074,
     /*  698267 */     GIR_EraseRootFromParent_Done,
     /*  698268 */   // Label 11036: @698268
     /*  698268 */   GIM_Try, /*On fail goto*//*Label 11037*/ GIMT_Encode4(698343), // Rule ID 11075 //
     /*  698273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  698284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  698287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  698290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  698293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698319 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  698319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  698338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698341 */     GIR_RootConstrainSelectedInstOperands,
     /*  698342 */     // GIR_Coverage, 11075,
     /*  698342 */     GIR_EraseRootFromParent_Done,
     /*  698343 */   // Label 11037: @698343
     /*  698343 */   GIM_Try, /*On fail goto*//*Label 11038*/ GIMT_Encode4(698418), // Rule ID 11078 //
     /*  698348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698394 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698416 */     GIR_RootConstrainSelectedInstOperands,
     /*  698417 */     // GIR_Coverage, 11078,
     /*  698417 */     GIR_EraseRootFromParent_Done,
     /*  698418 */   // Label 11038: @698418
     /*  698418 */   GIM_Try, /*On fail goto*//*Label 11039*/ GIMT_Encode4(698493), // Rule ID 11079 //
     /*  698423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  698434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  698437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  698440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  698443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  698462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  698472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698491 */     GIR_RootConstrainSelectedInstOperands,
     /*  698492 */     // GIR_Coverage, 11079,
     /*  698492 */     GIR_EraseRootFromParent_Done,
     /*  698493 */   // Label 11039: @698493
     /*  698493 */   GIM_Try, /*On fail goto*//*Label 11040*/ GIMT_Encode4(698568), // Rule ID 11082 //
     /*  698498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  698509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  698512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  698515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  698518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698566 */     GIR_RootConstrainSelectedInstOperands,
     /*  698567 */     // GIR_Coverage, 11082,
     /*  698567 */     GIR_EraseRootFromParent_Done,
     /*  698568 */   // Label 11040: @698568
     /*  698568 */   GIM_Try, /*On fail goto*//*Label 11041*/ GIMT_Encode4(698643), // Rule ID 11083 //
     /*  698573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  698584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  698587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  698590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  698593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  698612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  698622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698641 */     GIR_RootConstrainSelectedInstOperands,
     /*  698642 */     // GIR_Coverage, 11083,
     /*  698642 */     GIR_EraseRootFromParent_Done,
     /*  698643 */   // Label 11041: @698643
     /*  698643 */   GIM_Try, /*On fail goto*//*Label 11042*/ GIMT_Encode4(698718), // Rule ID 11086 //
     /*  698648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  698659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  698662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  698665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  698668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  698694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698716 */     GIR_RootConstrainSelectedInstOperands,
     /*  698717 */     // GIR_Coverage, 11086,
     /*  698717 */     GIR_EraseRootFromParent_Done,
     /*  698718 */   // Label 11042: @698718
     /*  698718 */   GIM_Try, /*On fail goto*//*Label 11043*/ GIMT_Encode4(698793), // Rule ID 11087 //
     /*  698723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  698734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  698737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  698740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  698743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  698762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698769 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  698769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  698772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  698788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698791 */     GIR_RootConstrainSelectedInstOperands,
     /*  698792 */     // GIR_Coverage, 11087,
     /*  698792 */     GIR_EraseRootFromParent_Done,
     /*  698793 */   // Label 11043: @698793
     /*  698793 */   GIM_Try, /*On fail goto*//*Label 11044*/ GIMT_Encode4(698868), // Rule ID 11090 //
     /*  698798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  698809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  698812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  698815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  698847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698866 */     GIR_RootConstrainSelectedInstOperands,
     /*  698867 */     // GIR_Coverage, 11090,
     /*  698867 */     GIR_EraseRootFromParent_Done,
     /*  698868 */   // Label 11044: @698868
     /*  698868 */   GIM_Try, /*On fail goto*//*Label 11045*/ GIMT_Encode4(698943), // Rule ID 11091 //
     /*  698873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  698876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  698884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  698887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  698890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  698893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  698896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  698919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8),
     /*  698922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  698926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  698928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  698930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  698935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  698938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  698941 */     GIR_RootConstrainSelectedInstOperands,
     /*  698942 */     // GIR_Coverage, 11091,
     /*  698942 */     GIR_EraseRootFromParent_Done,
     /*  698943 */   // Label 11045: @698943
     /*  698943 */   GIM_Try, /*On fail goto*//*Label 11046*/ GIMT_Encode4(699018), // Rule ID 11094 //
     /*  698948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  698951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  698956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  698959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  698962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  698965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  698968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  698971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  698983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  698987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  698994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  698994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  698997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  698999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699016 */     GIR_RootConstrainSelectedInstOperands,
     /*  699017 */     // GIR_Coverage, 11094,
     /*  699017 */     GIR_EraseRootFromParent_Done,
     /*  699018 */   // Label 11046: @699018
     /*  699018 */   GIM_Try, /*On fail goto*//*Label 11047*/ GIMT_Encode4(699093), // Rule ID 11095 //
     /*  699023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  699034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  699037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  699040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699091 */     GIR_RootConstrainSelectedInstOperands,
     /*  699092 */     // GIR_Coverage, 11095,
     /*  699092 */     GIR_EraseRootFromParent_Done,
     /*  699093 */   // Label 11047: @699093
     /*  699093 */   GIM_Try, /*On fail goto*//*Label 11048*/ GIMT_Encode4(699168), // Rule ID 11098 //
     /*  699098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699166 */     GIR_RootConstrainSelectedInstOperands,
     /*  699167 */     // GIR_Coverage, 11098,
     /*  699167 */     GIR_EraseRootFromParent_Done,
     /*  699168 */   // Label 11048: @699168
     /*  699168 */   GIM_Try, /*On fail goto*//*Label 11049*/ GIMT_Encode4(699243), // Rule ID 11099 //
     /*  699173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  699184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  699187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  699190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699241 */     GIR_RootConstrainSelectedInstOperands,
     /*  699242 */     // GIR_Coverage, 11099,
     /*  699242 */     GIR_EraseRootFromParent_Done,
     /*  699243 */   // Label 11049: @699243
     /*  699243 */   GIM_Try, /*On fail goto*//*Label 11050*/ GIMT_Encode4(699318), // Rule ID 11102 //
     /*  699248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699316 */     GIR_RootConstrainSelectedInstOperands,
     /*  699317 */     // GIR_Coverage, 11102,
     /*  699317 */     GIR_EraseRootFromParent_Done,
     /*  699318 */   // Label 11050: @699318
     /*  699318 */   GIM_Try, /*On fail goto*//*Label 11051*/ GIMT_Encode4(699393), // Rule ID 11103 //
     /*  699323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  699334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  699337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  699340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4),
     /*  699372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699391 */     GIR_RootConstrainSelectedInstOperands,
     /*  699392 */     // GIR_Coverage, 11103,
     /*  699392 */     GIR_EraseRootFromParent_Done,
     /*  699393 */   // Label 11051: @699393
     /*  699393 */   GIM_Try, /*On fail goto*//*Label 11052*/ GIMT_Encode4(699468), // Rule ID 11106 //
     /*  699398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  699409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  699412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  699415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699466 */     GIR_RootConstrainSelectedInstOperands,
     /*  699467 */     // GIR_Coverage, 11106,
     /*  699467 */     GIR_EraseRootFromParent_Done,
     /*  699468 */   // Label 11052: @699468
     /*  699468 */   GIM_Try, /*On fail goto*//*Label 11053*/ GIMT_Encode4(699543), // Rule ID 11107 //
     /*  699473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  699484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  699487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  699490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699541 */     GIR_RootConstrainSelectedInstOperands,
     /*  699542 */     // GIR_Coverage, 11107,
     /*  699542 */     GIR_EraseRootFromParent_Done,
     /*  699543 */   // Label 11053: @699543
     /*  699543 */   GIM_Try, /*On fail goto*//*Label 11054*/ GIMT_Encode4(699618), // Rule ID 11110 //
     /*  699548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  699559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  699562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  699565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  699594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699616 */     GIR_RootConstrainSelectedInstOperands,
     /*  699617 */     // GIR_Coverage, 11110,
     /*  699617 */     GIR_EraseRootFromParent_Done,
     /*  699618 */   // Label 11054: @699618
     /*  699618 */   GIM_Try, /*On fail goto*//*Label 11055*/ GIMT_Encode4(699693), // Rule ID 11111 //
     /*  699623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  699634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  699637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  699640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  699669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2),
     /*  699672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  699688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699691 */     GIR_RootConstrainSelectedInstOperands,
     /*  699692 */     // GIR_Coverage, 11111,
     /*  699692 */     GIR_EraseRootFromParent_Done,
     /*  699693 */   // Label 11055: @699693
     /*  699693 */   GIM_Try, /*On fail goto*//*Label 11056*/ GIMT_Encode4(699768), // Rule ID 11114 //
     /*  699698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  699709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  699712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  699715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  699744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  699747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699766 */     GIR_RootConstrainSelectedInstOperands,
     /*  699767 */     // GIR_Coverage, 11114,
     /*  699767 */     GIR_EraseRootFromParent_Done,
     /*  699768 */   // Label 11056: @699768
     /*  699768 */   GIM_Try, /*On fail goto*//*Label 11057*/ GIMT_Encode4(699843), // Rule ID 11115 //
     /*  699773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  699784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  699787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  699790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11402:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  699819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  699822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  699838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699841 */     GIR_RootConstrainSelectedInstOperands,
     /*  699842 */     // GIR_Coverage, 11115,
     /*  699842 */     GIR_EraseRootFromParent_Done,
     /*  699843 */   // Label 11057: @699843
     /*  699843 */   GIM_Try, /*On fail goto*//*Label 11058*/ GIMT_Encode4(699918), // Rule ID 11118 //
     /*  699848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  699851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  699859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  699862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  699865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  699868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  699871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  699894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  699897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699916 */     GIR_RootConstrainSelectedInstOperands,
     /*  699917 */     // GIR_Coverage, 11118,
     /*  699917 */     GIR_EraseRootFromParent_Done,
     /*  699918 */   // Label 11058: @699918
     /*  699918 */   GIM_Try, /*On fail goto*//*Label 11059*/ GIMT_Encode4(699993), // Rule ID 11119 //
     /*  699923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  699926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  699931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  699934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  699937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  699940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  699943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  699946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  699958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  699962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  699969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11402:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  699969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  699972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  699974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  699976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  699978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  699980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  699985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  699988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  699991 */     GIR_RootConstrainSelectedInstOperands,
     /*  699992 */     // GIR_Coverage, 11119,
     /*  699992 */     GIR_EraseRootFromParent_Done,
     /*  699993 */   // Label 11059: @699993
     /*  699993 */   GIM_Try, /*On fail goto*//*Label 11060*/ GIMT_Encode4(700068), // Rule ID 11122 //
     /*  699998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  700044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700066 */     GIR_RootConstrainSelectedInstOperands,
     /*  700067 */     // GIR_Coverage, 11122,
     /*  700067 */     GIR_EraseRootFromParent_Done,
     /*  700068 */   // Label 11060: @700068
     /*  700068 */   GIM_Try, /*On fail goto*//*Label 11061*/ GIMT_Encode4(700143), // Rule ID 11123 //
     /*  700073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  700084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  700087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  700090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  700108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11402:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  700119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  700122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  700138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700141 */     GIR_RootConstrainSelectedInstOperands,
     /*  700142 */     // GIR_Coverage, 11123,
     /*  700142 */     GIR_EraseRootFromParent_Done,
     /*  700143 */   // Label 11061: @700143
     /*  700143 */   GIM_Try, /*On fail goto*//*Label 11062*/ GIMT_Encode4(700218), // Rule ID 11126 //
     /*  700148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700194 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700216 */     GIR_RootConstrainSelectedInstOperands,
     /*  700217 */     // GIR_Coverage, 11126,
     /*  700217 */     GIR_EraseRootFromParent_Done,
     /*  700218 */   // Label 11062: @700218
     /*  700218 */   GIM_Try, /*On fail goto*//*Label 11063*/ GIMT_Encode4(700293), // Rule ID 11127 //
     /*  700223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  700234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  700237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  700240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700269 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700291 */     GIR_RootConstrainSelectedInstOperands,
     /*  700292 */     // GIR_Coverage, 11127,
     /*  700292 */     GIR_EraseRootFromParent_Done,
     /*  700293 */   // Label 11063: @700293
     /*  700293 */   GIM_Try, /*On fail goto*//*Label 11064*/ GIMT_Encode4(700368), // Rule ID 11130 //
     /*  700298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700366 */     GIR_RootConstrainSelectedInstOperands,
     /*  700367 */     // GIR_Coverage, 11130,
     /*  700367 */     GIR_EraseRootFromParent_Done,
     /*  700368 */   // Label 11064: @700368
     /*  700368 */   GIM_Try, /*On fail goto*//*Label 11065*/ GIMT_Encode4(700443), // Rule ID 11131 //
     /*  700373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  700384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  700387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  700390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700419 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700441 */     GIR_RootConstrainSelectedInstOperands,
     /*  700442 */     // GIR_Coverage, 11131,
     /*  700442 */     GIR_EraseRootFromParent_Done,
     /*  700443 */   // Label 11065: @700443
     /*  700443 */   GIM_Try, /*On fail goto*//*Label 11066*/ GIMT_Encode4(700518), // Rule ID 11134 //
     /*  700448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  700459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  700462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  700465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700494 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  700494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  700497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700516 */     GIR_RootConstrainSelectedInstOperands,
     /*  700517 */     // GIR_Coverage, 11134,
     /*  700517 */     GIR_EraseRootFromParent_Done,
     /*  700518 */   // Label 11066: @700518
     /*  700518 */   GIM_Try, /*On fail goto*//*Label 11067*/ GIMT_Encode4(700593), // Rule ID 11135 //
     /*  700523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  700534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  700537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  700540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700569 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  700569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  700572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  700588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700591 */     GIR_RootConstrainSelectedInstOperands,
     /*  700592 */     // GIR_Coverage, 11135,
     /*  700592 */     GIR_EraseRootFromParent_Done,
     /*  700593 */   // Label 11067: @700593
     /*  700593 */   GIM_Try, /*On fail goto*//*Label 11068*/ GIMT_Encode4(700668), // Rule ID 11138 //
     /*  700598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  700609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  700612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  700615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700666 */     GIR_RootConstrainSelectedInstOperands,
     /*  700667 */     // GIR_Coverage, 11138,
     /*  700667 */     GIR_EraseRootFromParent_Done,
     /*  700668 */   // Label 11068: @700668
     /*  700668 */   GIM_Try, /*On fail goto*//*Label 11069*/ GIMT_Encode4(700743), // Rule ID 11139 //
     /*  700673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  700684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  700687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  700690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  700708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700719 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  700722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700741 */     GIR_RootConstrainSelectedInstOperands,
     /*  700742 */     // GIR_Coverage, 11139,
     /*  700742 */     GIR_EraseRootFromParent_Done,
     /*  700743 */   // Label 11069: @700743
     /*  700743 */   GIM_Try, /*On fail goto*//*Label 11070*/ GIMT_Encode4(700818), // Rule ID 11142 //
     /*  700748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  700759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  700762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  700765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700816 */     GIR_RootConstrainSelectedInstOperands,
     /*  700817 */     // GIR_Coverage, 11142,
     /*  700817 */     GIR_EraseRootFromParent_Done,
     /*  700818 */   // Label 11070: @700818
     /*  700818 */   GIM_Try, /*On fail goto*//*Label 11071*/ GIMT_Encode4(700893), // Rule ID 11143 //
     /*  700823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  700834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  700837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  700840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  700858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700869 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  700869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  700872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700891 */     GIR_RootConstrainSelectedInstOperands,
     /*  700892 */     // GIR_Coverage, 11143,
     /*  700892 */     GIR_EraseRootFromParent_Done,
     /*  700893 */   // Label 11071: @700893
     /*  700893 */   GIM_Try, /*On fail goto*//*Label 11072*/ GIMT_Encode4(700968), // Rule ID 11146 //
     /*  700898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  700901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  700909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  700912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  700915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  700918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  700921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  700933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  700937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  700944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  700944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  700947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  700949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  700951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  700953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  700955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  700960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  700963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  700966 */     GIR_RootConstrainSelectedInstOperands,
     /*  700967 */     // GIR_Coverage, 11146,
     /*  700967 */     GIR_EraseRootFromParent_Done,
     /*  700968 */   // Label 11072: @700968
     /*  700968 */   GIM_Try, /*On fail goto*//*Label 11073*/ GIMT_Encode4(701043), // Rule ID 11147 //
     /*  700973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  700976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  700981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  700984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  700987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  700990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  700993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  700996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701019 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  701019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  701038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701041 */     GIR_RootConstrainSelectedInstOperands,
     /*  701042 */     // GIR_Coverage, 11147,
     /*  701042 */     GIR_EraseRootFromParent_Done,
     /*  701043 */   // Label 11073: @701043
     /*  701043 */   GIM_Try, /*On fail goto*//*Label 11074*/ GIMT_Encode4(701118), // Rule ID 11150 //
     /*  701048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701116 */     GIR_RootConstrainSelectedInstOperands,
     /*  701117 */     // GIR_Coverage, 11150,
     /*  701117 */     GIR_EraseRootFromParent_Done,
     /*  701118 */   // Label 11074: @701118
     /*  701118 */   GIM_Try, /*On fail goto*//*Label 11075*/ GIMT_Encode4(701193), // Rule ID 11151 //
     /*  701123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  701134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  701137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  701140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  701158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  701172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701191 */     GIR_RootConstrainSelectedInstOperands,
     /*  701192 */     // GIR_Coverage, 11151,
     /*  701192 */     GIR_EraseRootFromParent_Done,
     /*  701193 */   // Label 11075: @701193
     /*  701193 */   GIM_Try, /*On fail goto*//*Label 11076*/ GIMT_Encode4(701268), // Rule ID 11154 //
     /*  701198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701266 */     GIR_RootConstrainSelectedInstOperands,
     /*  701267 */     // GIR_Coverage, 11154,
     /*  701267 */     GIR_EraseRootFromParent_Done,
     /*  701268 */   // Label 11076: @701268
     /*  701268 */   GIM_Try, /*On fail goto*//*Label 11077*/ GIMT_Encode4(701343), // Rule ID 11155 //
     /*  701273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  701284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  701287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  701290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  701308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701319 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  701322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701341 */     GIR_RootConstrainSelectedInstOperands,
     /*  701342 */     // GIR_Coverage, 11155,
     /*  701342 */     GIR_EraseRootFromParent_Done,
     /*  701343 */   // Label 11077: @701343
     /*  701343 */   GIM_Try, /*On fail goto*//*Label 11078*/ GIMT_Encode4(701418), // Rule ID 11158 //
     /*  701348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  701368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701394 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  701394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701416 */     GIR_RootConstrainSelectedInstOperands,
     /*  701417 */     // GIR_Coverage, 11158,
     /*  701417 */     GIR_EraseRootFromParent_Done,
     /*  701418 */   // Label 11078: @701418
     /*  701418 */   GIM_Try, /*On fail goto*//*Label 11079*/ GIMT_Encode4(701493), // Rule ID 11159 //
     /*  701423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  701431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  701434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  701437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  701440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  701443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  701458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  701462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701469 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  701469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  701472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  701488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701491 */     GIR_RootConstrainSelectedInstOperands,
     /*  701492 */     // GIR_Coverage, 11159,
     /*  701492 */     GIR_EraseRootFromParent_Done,
     /*  701493 */   // Label 11079: @701493
     /*  701493 */   GIM_Try, /*On fail goto*//*Label 11080*/ GIMT_Encode4(701568), // Rule ID 11162 //
     /*  701498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  701509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  701512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  701515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  701518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  701547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701566 */     GIR_RootConstrainSelectedInstOperands,
     /*  701567 */     // GIR_Coverage, 11162,
     /*  701567 */     GIR_EraseRootFromParent_Done,
     /*  701568 */   // Label 11080: @701568
     /*  701568 */   GIM_Try, /*On fail goto*//*Label 11081*/ GIMT_Encode4(701643), // Rule ID 11163 //
     /*  701573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  701584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  701587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  701590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  701593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /*  701622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701641 */     GIR_RootConstrainSelectedInstOperands,
     /*  701642 */     // GIR_Coverage, 11163,
     /*  701642 */     GIR_EraseRootFromParent_Done,
     /*  701643 */   // Label 11081: @701643
     /*  701643 */   GIM_Try, /*On fail goto*//*Label 11082*/ GIMT_Encode4(701718), // Rule ID 11166 //
     /*  701648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  701659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  701662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  701665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  701668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  701697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701716 */     GIR_RootConstrainSelectedInstOperands,
     /*  701717 */     // GIR_Coverage, 11166,
     /*  701717 */     GIR_EraseRootFromParent_Done,
     /*  701718 */   // Label 11082: @701718
     /*  701718 */   GIM_Try, /*On fail goto*//*Label 11083*/ GIMT_Encode4(701793), // Rule ID 11167 //
     /*  701723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  701734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  701737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  701740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  701743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  701772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701791 */     GIR_RootConstrainSelectedInstOperands,
     /*  701792 */     // GIR_Coverage, 11167,
     /*  701792 */     GIR_EraseRootFromParent_Done,
     /*  701793 */   // Label 11083: @701793
     /*  701793 */   GIM_Try, /*On fail goto*//*Label 11084*/ GIMT_Encode4(701868), // Rule ID 11170 //
     /*  701798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  701809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  701812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  701815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  701818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  701844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  701847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701866 */     GIR_RootConstrainSelectedInstOperands,
     /*  701867 */     // GIR_Coverage, 11170,
     /*  701867 */     GIR_EraseRootFromParent_Done,
     /*  701868 */   // Label 11084: @701868
     /*  701868 */   GIM_Try, /*On fail goto*//*Label 11085*/ GIMT_Encode4(701943), // Rule ID 11171 //
     /*  701873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  701876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  701884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  701887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  701890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  701893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  701896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  701919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  701922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  701926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  701928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  701930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  701935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  701938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  701941 */     GIR_RootConstrainSelectedInstOperands,
     /*  701942 */     // GIR_Coverage, 11171,
     /*  701942 */     GIR_EraseRootFromParent_Done,
     /*  701943 */   // Label 11085: @701943
     /*  701943 */   GIM_Try, /*On fail goto*//*Label 11086*/ GIMT_Encode4(702018), // Rule ID 11174 //
     /*  701948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  701951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  701956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  701959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  701962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  701965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  701968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  701971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  701987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  701994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  701994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  701997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  701999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702016 */     GIR_RootConstrainSelectedInstOperands,
     /*  702017 */     // GIR_Coverage, 11174,
     /*  702017 */     GIR_EraseRootFromParent_Done,
     /*  702018 */   // Label 11086: @702018
     /*  702018 */   GIM_Try, /*On fail goto*//*Label 11087*/ GIMT_Encode4(702093), // Rule ID 11175 //
     /*  702023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  702034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  702037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  702040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  702043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /*  702072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702091 */     GIR_RootConstrainSelectedInstOperands,
     /*  702092 */     // GIR_Coverage, 11175,
     /*  702092 */     GIR_EraseRootFromParent_Done,
     /*  702093 */   // Label 11087: @702093
     /*  702093 */   GIM_Try, /*On fail goto*//*Label 11088*/ GIMT_Encode4(702168), // Rule ID 11178 //
     /*  702098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702166 */     GIR_RootConstrainSelectedInstOperands,
     /*  702167 */     // GIR_Coverage, 11178,
     /*  702167 */     GIR_EraseRootFromParent_Done,
     /*  702168 */   // Label 11088: @702168
     /*  702168 */   GIM_Try, /*On fail goto*//*Label 11089*/ GIMT_Encode4(702243), // Rule ID 11179 //
     /*  702173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  702184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  702187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  702190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  702193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702241 */     GIR_RootConstrainSelectedInstOperands,
     /*  702242 */     // GIR_Coverage, 11179,
     /*  702242 */     GIR_EraseRootFromParent_Done,
     /*  702243 */   // Label 11089: @702243
     /*  702243 */   GIM_Try, /*On fail goto*//*Label 11090*/ GIMT_Encode4(702318), // Rule ID 11182 //
     /*  702248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702316 */     GIR_RootConstrainSelectedInstOperands,
     /*  702317 */     // GIR_Coverage, 11182,
     /*  702317 */     GIR_EraseRootFromParent_Done,
     /*  702318 */   // Label 11090: @702318
     /*  702318 */   GIM_Try, /*On fail goto*//*Label 11091*/ GIMT_Encode4(702393), // Rule ID 11183 //
     /*  702323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  702334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  702337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  702340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  702343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /*  702372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702391 */     GIR_RootConstrainSelectedInstOperands,
     /*  702392 */     // GIR_Coverage, 11183,
     /*  702392 */     GIR_EraseRootFromParent_Done,
     /*  702393 */   // Label 11091: @702393
     /*  702393 */   GIM_Try, /*On fail goto*//*Label 11092*/ GIMT_Encode4(702468), // Rule ID 11186 //
     /*  702398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  702409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  702412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  702415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  702418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702466 */     GIR_RootConstrainSelectedInstOperands,
     /*  702467 */     // GIR_Coverage, 11186,
     /*  702467 */     GIR_EraseRootFromParent_Done,
     /*  702468 */   // Label 11092: @702468
     /*  702468 */   GIM_Try, /*On fail goto*//*Label 11093*/ GIMT_Encode4(702543), // Rule ID 11187 //
     /*  702473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  702484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  702487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  702490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  702493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702541 */     GIR_RootConstrainSelectedInstOperands,
     /*  702542 */     // GIR_Coverage, 11187,
     /*  702542 */     GIR_EraseRootFromParent_Done,
     /*  702543 */   // Label 11093: @702543
     /*  702543 */   GIM_Try, /*On fail goto*//*Label 11094*/ GIMT_Encode4(702618), // Rule ID 11190 //
     /*  702548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  702559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  702562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  702565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  702568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  702594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702616 */     GIR_RootConstrainSelectedInstOperands,
     /*  702617 */     // GIR_Coverage, 11190,
     /*  702617 */     GIR_EraseRootFromParent_Done,
     /*  702618 */   // Label 11094: @702618
     /*  702618 */   GIM_Try, /*On fail goto*//*Label 11095*/ GIMT_Encode4(702693), // Rule ID 11191 //
     /*  702623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  702634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  702637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  702640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  702643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  702669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  702688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702691 */     GIR_RootConstrainSelectedInstOperands,
     /*  702692 */     // GIR_Coverage, 11191,
     /*  702692 */     GIR_EraseRootFromParent_Done,
     /*  702693 */   // Label 11095: @702693
     /*  702693 */   GIM_Try, /*On fail goto*//*Label 11096*/ GIMT_Encode4(702768), // Rule ID 11194 //
     /*  702698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  702709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  702712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  702715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  702718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  702744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702766 */     GIR_RootConstrainSelectedInstOperands,
     /*  702767 */     // GIR_Coverage, 11194,
     /*  702767 */     GIR_EraseRootFromParent_Done,
     /*  702768 */   // Label 11096: @702768
     /*  702768 */   GIM_Try, /*On fail goto*//*Label 11097*/ GIMT_Encode4(702843), // Rule ID 11195 //
     /*  702773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  702784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  702787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  702790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  702793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  702812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  702819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  702822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  702838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702841 */     GIR_RootConstrainSelectedInstOperands,
     /*  702842 */     // GIR_Coverage, 11195,
     /*  702842 */     GIR_EraseRootFromParent_Done,
     /*  702843 */   // Label 11097: @702843
     /*  702843 */   GIM_Try, /*On fail goto*//*Label 11098*/ GIMT_Encode4(702918), // Rule ID 11198 //
     /*  702848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  702851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  702859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  702862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  702865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  702868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  702871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702894 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  702894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  702897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702916 */     GIR_RootConstrainSelectedInstOperands,
     /*  702917 */     // GIR_Coverage, 11198,
     /*  702917 */     GIR_EraseRootFromParent_Done,
     /*  702918 */   // Label 11098: @702918
     /*  702918 */   GIM_Try, /*On fail goto*//*Label 11099*/ GIMT_Encode4(702993), // Rule ID 11199 //
     /*  702923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  702926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  702931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  702934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  702937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  702940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  702943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  702946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  702962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  702969 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  702969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  702972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  702974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  702976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  702978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  702980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  702985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  702988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  702991 */     GIR_RootConstrainSelectedInstOperands,
     /*  702992 */     // GIR_Coverage, 11199,
     /*  702992 */     GIR_EraseRootFromParent_Done,
     /*  702993 */   // Label 11099: @702993
     /*  702993 */   GIM_Try, /*On fail goto*//*Label 11100*/ GIMT_Encode4(703068), // Rule ID 11202 //
     /*  702998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703066 */     GIR_RootConstrainSelectedInstOperands,
     /*  703067 */     // GIR_Coverage, 11202,
     /*  703067 */     GIR_EraseRootFromParent_Done,
     /*  703068 */   // Label 11100: @703068
     /*  703068 */   GIM_Try, /*On fail goto*//*Label 11101*/ GIMT_Encode4(703143), // Rule ID 11203 //
     /*  703073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  703084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  703087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  703090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  703093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703119 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703141 */     GIR_RootConstrainSelectedInstOperands,
     /*  703142 */     // GIR_Coverage, 11203,
     /*  703142 */     GIR_EraseRootFromParent_Done,
     /*  703143 */   // Label 11101: @703143
     /*  703143 */   GIM_Try, /*On fail goto*//*Label 11102*/ GIMT_Encode4(703218), // Rule ID 11206 //
     /*  703148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703194 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  703194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703216 */     GIR_RootConstrainSelectedInstOperands,
     /*  703217 */     // GIR_Coverage, 11206,
     /*  703217 */     GIR_EraseRootFromParent_Done,
     /*  703218 */   // Label 11102: @703218
     /*  703218 */   GIM_Try, /*On fail goto*//*Label 11103*/ GIMT_Encode4(703293), // Rule ID 11207 //
     /*  703223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  703234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  703237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  703240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  703243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703269 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  703269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  703288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703291 */     GIR_RootConstrainSelectedInstOperands,
     /*  703292 */     // GIR_Coverage, 11207,
     /*  703292 */     GIR_EraseRootFromParent_Done,
     /*  703293 */   // Label 11103: @703293
     /*  703293 */   GIM_Try, /*On fail goto*//*Label 11104*/ GIMT_Encode4(703368), // Rule ID 11210 //
     /*  703298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703366 */     GIR_RootConstrainSelectedInstOperands,
     /*  703367 */     // GIR_Coverage, 11210,
     /*  703367 */     GIR_EraseRootFromParent_Done,
     /*  703368 */   // Label 11104: @703368
     /*  703368 */   GIM_Try, /*On fail goto*//*Label 11105*/ GIMT_Encode4(703443), // Rule ID 11211 //
     /*  703373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  703384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  703387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  703390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  703393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703441 */     GIR_RootConstrainSelectedInstOperands,
     /*  703442 */     // GIR_Coverage, 11211,
     /*  703442 */     GIR_EraseRootFromParent_Done,
     /*  703443 */   // Label 11105: @703443
     /*  703443 */   GIM_Try, /*On fail goto*//*Label 11106*/ GIMT_Encode4(703518), // Rule ID 11214 //
     /*  703448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  703459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  703462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  703465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  703468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703494 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703516 */     GIR_RootConstrainSelectedInstOperands,
     /*  703517 */     // GIR_Coverage, 11214,
     /*  703517 */     GIR_EraseRootFromParent_Done,
     /*  703518 */   // Label 11106: @703518
     /*  703518 */   GIM_Try, /*On fail goto*//*Label 11107*/ GIMT_Encode4(703593), // Rule ID 11215 //
     /*  703523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  703534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  703537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  703540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  703543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703569 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703591 */     GIR_RootConstrainSelectedInstOperands,
     /*  703592 */     // GIR_Coverage, 11215,
     /*  703592 */     GIR_EraseRootFromParent_Done,
     /*  703593 */   // Label 11107: @703593
     /*  703593 */   GIM_Try, /*On fail goto*//*Label 11108*/ GIMT_Encode4(703668), // Rule ID 11218 //
     /*  703598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  703609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  703612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  703615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  703618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703644 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  703644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703666 */     GIR_RootConstrainSelectedInstOperands,
     /*  703667 */     // GIR_Coverage, 11218,
     /*  703667 */     GIR_EraseRootFromParent_Done,
     /*  703668 */   // Label 11108: @703668
     /*  703668 */   GIM_Try, /*On fail goto*//*Label 11109*/ GIMT_Encode4(703743), // Rule ID 11219 //
     /*  703673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  703684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  703687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  703690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  703693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  703712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703719 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  703719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  703722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  703738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703741 */     GIR_RootConstrainSelectedInstOperands,
     /*  703742 */     // GIR_Coverage, 11219,
     /*  703742 */     GIR_EraseRootFromParent_Done,
     /*  703743 */   // Label 11109: @703743
     /*  703743 */   GIM_Try, /*On fail goto*//*Label 11110*/ GIMT_Encode4(703818), // Rule ID 11222 //
     /*  703748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  703759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  703762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  703765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  703768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703816 */     GIR_RootConstrainSelectedInstOperands,
     /*  703817 */     // GIR_Coverage, 11222,
     /*  703817 */     GIR_EraseRootFromParent_Done,
     /*  703818 */   // Label 11110: @703818
     /*  703818 */   GIM_Try, /*On fail goto*//*Label 11111*/ GIMT_Encode4(703893), // Rule ID 11223 //
     /*  703823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  703834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  703837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  703840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  703843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  703862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  703869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  703872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703891 */     GIR_RootConstrainSelectedInstOperands,
     /*  703892 */     // GIR_Coverage, 11223,
     /*  703892 */     GIR_EraseRootFromParent_Done,
     /*  703893 */   // Label 11111: @703893
     /*  703893 */   GIM_Try, /*On fail goto*//*Label 11112*/ GIMT_Encode4(703968), // Rule ID 11226 //
     /*  703898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  703901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  703909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  703912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  703915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  703918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  703921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  703937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  703944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  703944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  703947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  703949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  703951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  703953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  703955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  703960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  703963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  703966 */     GIR_RootConstrainSelectedInstOperands,
     /*  703967 */     // GIR_Coverage, 11226,
     /*  703967 */     GIR_EraseRootFromParent_Done,
     /*  703968 */   // Label 11112: @703968
     /*  703968 */   GIM_Try, /*On fail goto*//*Label 11113*/ GIMT_Encode4(704043), // Rule ID 11227 //
     /*  703973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  703976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  703981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  703984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  703987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  703990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  703993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  703996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  704012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  704022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704041 */     GIR_RootConstrainSelectedInstOperands,
     /*  704042 */     // GIR_Coverage, 11227,
     /*  704042 */     GIR_EraseRootFromParent_Done,
     /*  704043 */   // Label 11113: @704043
     /*  704043 */   GIM_Try, /*On fail goto*//*Label 11114*/ GIMT_Encode4(704118), // Rule ID 11230 //
     /*  704048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704116 */     GIR_RootConstrainSelectedInstOperands,
     /*  704117 */     // GIR_Coverage, 11230,
     /*  704117 */     GIR_EraseRootFromParent_Done,
     /*  704118 */   // Label 11114: @704118
     /*  704118 */   GIM_Try, /*On fail goto*//*Label 11115*/ GIMT_Encode4(704193), // Rule ID 11231 //
     /*  704123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  704134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  704137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  704140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  704143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  704162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  704169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  704172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  704188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704191 */     GIR_RootConstrainSelectedInstOperands,
     /*  704192 */     // GIR_Coverage, 11231,
     /*  704192 */     GIR_EraseRootFromParent_Done,
     /*  704193 */   // Label 11115: @704193
     /*  704193 */   GIM_Try, /*On fail goto*//*Label 11116*/ GIMT_Encode4(704268), // Rule ID 11234 //
     /*  704198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704266 */     GIR_RootConstrainSelectedInstOperands,
     /*  704267 */     // GIR_Coverage, 11234,
     /*  704267 */     GIR_EraseRootFromParent_Done,
     /*  704268 */   // Label 11116: @704268
     /*  704268 */   GIM_Try, /*On fail goto*//*Label 11117*/ GIMT_Encode4(704343), // Rule ID 11235 //
     /*  704273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  704284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  704287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  704290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8),
     /*  704322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704341 */     GIR_RootConstrainSelectedInstOperands,
     /*  704342 */     // GIR_Coverage, 11235,
     /*  704342 */     GIR_EraseRootFromParent_Done,
     /*  704343 */   // Label 11117: @704343
     /*  704343 */   GIM_Try, /*On fail goto*//*Label 11118*/ GIMT_Encode4(704418), // Rule ID 11238 //
     /*  704348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704416 */     GIR_RootConstrainSelectedInstOperands,
     /*  704417 */     // GIR_Coverage, 11238,
     /*  704417 */     GIR_EraseRootFromParent_Done,
     /*  704418 */   // Label 11118: @704418
     /*  704418 */   GIM_Try, /*On fail goto*//*Label 11119*/ GIMT_Encode4(704493), // Rule ID 11239 //
     /*  704423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  704434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  704437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  704440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704491 */     GIR_RootConstrainSelectedInstOperands,
     /*  704492 */     // GIR_Coverage, 11239,
     /*  704492 */     GIR_EraseRootFromParent_Done,
     /*  704493 */   // Label 11119: @704493
     /*  704493 */   GIM_Try, /*On fail goto*//*Label 11120*/ GIMT_Encode4(704568), // Rule ID 11242 //
     /*  704498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  704509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  704512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  704515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  704544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  704547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704566 */     GIR_RootConstrainSelectedInstOperands,
     /*  704567 */     // GIR_Coverage, 11242,
     /*  704567 */     GIR_EraseRootFromParent_Done,
     /*  704568 */   // Label 11120: @704568
     /*  704568 */   GIM_Try, /*On fail goto*//*Label 11121*/ GIMT_Encode4(704643), // Rule ID 11243 //
     /*  704573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  704584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  704587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  704590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  704619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  704622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  704638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704641 */     GIR_RootConstrainSelectedInstOperands,
     /*  704642 */     // GIR_Coverage, 11243,
     /*  704642 */     GIR_EraseRootFromParent_Done,
     /*  704643 */   // Label 11121: @704643
     /*  704643 */   GIM_Try, /*On fail goto*//*Label 11122*/ GIMT_Encode4(704718), // Rule ID 11246 //
     /*  704648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  704659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  704662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  704665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704716 */     GIR_RootConstrainSelectedInstOperands,
     /*  704717 */     // GIR_Coverage, 11246,
     /*  704717 */     GIR_EraseRootFromParent_Done,
     /*  704718 */   // Label 11122: @704718
     /*  704718 */   GIM_Try, /*On fail goto*//*Label 11123*/ GIMT_Encode4(704793), // Rule ID 11247 //
     /*  704723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  704734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  704737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  704740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4),
     /*  704772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704791 */     GIR_RootConstrainSelectedInstOperands,
     /*  704792 */     // GIR_Coverage, 11247,
     /*  704792 */     GIR_EraseRootFromParent_Done,
     /*  704793 */   // Label 11123: @704793
     /*  704793 */   GIM_Try, /*On fail goto*//*Label 11124*/ GIMT_Encode4(704868), // Rule ID 11250 //
     /*  704798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  704809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  704812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  704815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  704844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  704847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704866 */     GIR_RootConstrainSelectedInstOperands,
     /*  704867 */     // GIR_Coverage, 11250,
     /*  704867 */     GIR_EraseRootFromParent_Done,
     /*  704868 */   // Label 11124: @704868
     /*  704868 */   GIM_Try, /*On fail goto*//*Label 11125*/ GIMT_Encode4(704943), // Rule ID 11251 //
     /*  704873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  704876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  704884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  704887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  704890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  704893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  704896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  704919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  704922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  704926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  704928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  704930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  704935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  704938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  704941 */     GIR_RootConstrainSelectedInstOperands,
     /*  704942 */     // GIR_Coverage, 11251,
     /*  704942 */     GIR_EraseRootFromParent_Done,
     /*  704943 */   // Label 11125: @704943
     /*  704943 */   GIM_Try, /*On fail goto*//*Label 11126*/ GIMT_Encode4(705018), // Rule ID 11254 //
     /*  704948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  704951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  704956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  704959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  704962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  704965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  704968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  704971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  704983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  704987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  704994 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  704994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  704997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  704999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705016 */     GIR_RootConstrainSelectedInstOperands,
     /*  705017 */     // GIR_Coverage, 11254,
     /*  705017 */     GIR_EraseRootFromParent_Done,
     /*  705018 */   // Label 11126: @705018
     /*  705018 */   GIM_Try, /*On fail goto*//*Label 11127*/ GIMT_Encode4(705093), // Rule ID 11255 //
     /*  705023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  705034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  705037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  705040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2),
     /*  705072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705091 */     GIR_RootConstrainSelectedInstOperands,
     /*  705092 */     // GIR_Coverage, 11255,
     /*  705092 */     GIR_EraseRootFromParent_Done,
     /*  705093 */   // Label 11127: @705093
     /*  705093 */   GIM_Try, /*On fail goto*//*Label 11128*/ GIMT_Encode4(705168), // Rule ID 11258 //
     /*  705098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705166 */     GIR_RootConstrainSelectedInstOperands,
     /*  705167 */     // GIR_Coverage, 11258,
     /*  705167 */     GIR_EraseRootFromParent_Done,
     /*  705168 */   // Label 11128: @705168
     /*  705168 */   GIM_Try, /*On fail goto*//*Label 11129*/ GIMT_Encode4(705243), // Rule ID 11259 //
     /*  705173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  705184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  705187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  705190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11406:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705241 */     GIR_RootConstrainSelectedInstOperands,
     /*  705242 */     // GIR_Coverage, 11259,
     /*  705242 */     GIR_EraseRootFromParent_Done,
     /*  705243 */   // Label 11129: @705243
     /*  705243 */   GIM_Try, /*On fail goto*//*Label 11130*/ GIMT_Encode4(705318), // Rule ID 11262 //
     /*  705248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  705294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705316 */     GIR_RootConstrainSelectedInstOperands,
     /*  705317 */     // GIR_Coverage, 11262,
     /*  705317 */     GIR_EraseRootFromParent_Done,
     /*  705318 */   // Label 11130: @705318
     /*  705318 */   GIM_Try, /*On fail goto*//*Label 11131*/ GIMT_Encode4(705393), // Rule ID 11263 //
     /*  705323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  705334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  705337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  705340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11406:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  705369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  705388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705391 */     GIR_RootConstrainSelectedInstOperands,
     /*  705392 */     // GIR_Coverage, 11263,
     /*  705392 */     GIR_EraseRootFromParent_Done,
     /*  705393 */   // Label 11131: @705393
     /*  705393 */   GIM_Try, /*On fail goto*//*Label 11132*/ GIMT_Encode4(705468), // Rule ID 11266 //
     /*  705398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  705444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705466 */     GIR_RootConstrainSelectedInstOperands,
     /*  705467 */     // GIR_Coverage, 11266,
     /*  705467 */     GIR_EraseRootFromParent_Done,
     /*  705468 */   // Label 11132: @705468
     /*  705468 */   GIM_Try, /*On fail goto*//*Label 11133*/ GIMT_Encode4(705543), // Rule ID 11267 //
     /*  705473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  705484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  705487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  705490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  705508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11406:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  705519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  705522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  705538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705541 */     GIR_RootConstrainSelectedInstOperands,
     /*  705542 */     // GIR_Coverage, 11267,
     /*  705542 */     GIR_EraseRootFromParent_Done,
     /*  705543 */   // Label 11133: @705543
     /*  705543 */   GIM_Try, /*On fail goto*//*Label 11134*/ GIMT_Encode4(705618), // Rule ID 11270 //
     /*  705548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  705559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  705562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  705565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705594 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  705597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705616 */     GIR_RootConstrainSelectedInstOperands,
     /*  705617 */     // GIR_Coverage, 11270,
     /*  705617 */     GIR_EraseRootFromParent_Done,
     /*  705618 */   // Label 11134: @705618
     /*  705618 */   GIM_Try, /*On fail goto*//*Label 11135*/ GIMT_Encode4(705693), // Rule ID 11271 //
     /*  705623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  705634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  705637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  705640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  705658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705669 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  705672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705691 */     GIR_RootConstrainSelectedInstOperands,
     /*  705692 */     // GIR_Coverage, 11271,
     /*  705692 */     GIR_EraseRootFromParent_Done,
     /*  705693 */   // Label 11135: @705693
     /*  705693 */   GIM_Try, /*On fail goto*//*Label 11136*/ GIMT_Encode4(705768), // Rule ID 11274 //
     /*  705698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  705709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  705712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  705715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  705747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705766 */     GIR_RootConstrainSelectedInstOperands,
     /*  705767 */     // GIR_Coverage, 11274,
     /*  705767 */     GIR_EraseRootFromParent_Done,
     /*  705768 */   // Label 11136: @705768
     /*  705768 */   GIM_Try, /*On fail goto*//*Label 11137*/ GIMT_Encode4(705843), // Rule ID 11275 //
     /*  705773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  705784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  705787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  705790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  705808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705819 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  705822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705841 */     GIR_RootConstrainSelectedInstOperands,
     /*  705842 */     // GIR_Coverage, 11275,
     /*  705842 */     GIR_EraseRootFromParent_Done,
     /*  705843 */   // Label 11137: @705843
     /*  705843 */   GIM_Try, /*On fail goto*//*Label 11138*/ GIMT_Encode4(705918), // Rule ID 11278 //
     /*  705848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  705851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  705859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  705862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  705865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  705868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  705871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  705894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  705897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705916 */     GIR_RootConstrainSelectedInstOperands,
     /*  705917 */     // GIR_Coverage, 11278,
     /*  705917 */     GIR_EraseRootFromParent_Done,
     /*  705918 */   // Label 11138: @705918
     /*  705918 */   GIM_Try, /*On fail goto*//*Label 11139*/ GIMT_Encode4(705993), // Rule ID 11279 //
     /*  705923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  705926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  705931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  705934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  705937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  705940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  705943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  705946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  705958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  705962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  705969 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  705969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  705972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  705974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  705976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  705978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  705980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  705985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  705988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  705991 */     GIR_RootConstrainSelectedInstOperands,
     /*  705992 */     // GIR_Coverage, 11279,
     /*  705992 */     GIR_EraseRootFromParent_Done,
     /*  705993 */   // Label 11139: @705993
     /*  705993 */   GIM_Try, /*On fail goto*//*Label 11140*/ GIMT_Encode4(706068), // Rule ID 11282 //
     /*  705998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706066 */     GIR_RootConstrainSelectedInstOperands,
     /*  706067 */     // GIR_Coverage, 11282,
     /*  706067 */     GIR_EraseRootFromParent_Done,
     /*  706068 */   // Label 11140: @706068
     /*  706068 */   GIM_Try, /*On fail goto*//*Label 11141*/ GIMT_Encode4(706143), // Rule ID 11283 //
     /*  706073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  706084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  706087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  706090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706141 */     GIR_RootConstrainSelectedInstOperands,
     /*  706142 */     // GIR_Coverage, 11283,
     /*  706142 */     GIR_EraseRootFromParent_Done,
     /*  706143 */   // Label 11141: @706143
     /*  706143 */   GIM_Try, /*On fail goto*//*Label 11142*/ GIMT_Encode4(706218), // Rule ID 11286 //
     /*  706148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706216 */     GIR_RootConstrainSelectedInstOperands,
     /*  706217 */     // GIR_Coverage, 11286,
     /*  706217 */     GIR_EraseRootFromParent_Done,
     /*  706218 */   // Label 11142: @706218
     /*  706218 */   GIM_Try, /*On fail goto*//*Label 11143*/ GIMT_Encode4(706293), // Rule ID 11287 //
     /*  706223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  706234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  706237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  706240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706291 */     GIR_RootConstrainSelectedInstOperands,
     /*  706292 */     // GIR_Coverage, 11287,
     /*  706292 */     GIR_EraseRootFromParent_Done,
     /*  706293 */   // Label 11143: @706293
     /*  706293 */   GIM_Try, /*On fail goto*//*Label 11144*/ GIMT_Encode4(706368), // Rule ID 11290 //
     /*  706298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  706344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706366 */     GIR_RootConstrainSelectedInstOperands,
     /*  706367 */     // GIR_Coverage, 11290,
     /*  706367 */     GIR_EraseRootFromParent_Done,
     /*  706368 */   // Label 11144: @706368
     /*  706368 */   GIM_Try, /*On fail goto*//*Label 11145*/ GIMT_Encode4(706443), // Rule ID 11291 //
     /*  706373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  706384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  706387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  706390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  706419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  706438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706441 */     GIR_RootConstrainSelectedInstOperands,
     /*  706442 */     // GIR_Coverage, 11291,
     /*  706442 */     GIR_EraseRootFromParent_Done,
     /*  706443 */   // Label 11145: @706443
     /*  706443 */   GIM_Try, /*On fail goto*//*Label 11146*/ GIMT_Encode4(706518), // Rule ID 11294 //
     /*  706448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706494 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706516 */     GIR_RootConstrainSelectedInstOperands,
     /*  706517 */     // GIR_Coverage, 11294,
     /*  706517 */     GIR_EraseRootFromParent_Done,
     /*  706518 */   // Label 11146: @706518
     /*  706518 */   GIM_Try, /*On fail goto*//*Label 11147*/ GIMT_Encode4(706593), // Rule ID 11295 //
     /*  706523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  706534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  706537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  706540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  706558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706569 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  706572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706591 */     GIR_RootConstrainSelectedInstOperands,
     /*  706592 */     // GIR_Coverage, 11295,
     /*  706592 */     GIR_EraseRootFromParent_Done,
     /*  706593 */   // Label 11147: @706593
     /*  706593 */   GIM_Try, /*On fail goto*//*Label 11148*/ GIMT_Encode4(706668), // Rule ID 11298 //
     /*  706598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  706609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  706612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  706615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706644 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706666 */     GIR_RootConstrainSelectedInstOperands,
     /*  706667 */     // GIR_Coverage, 11298,
     /*  706667 */     GIR_EraseRootFromParent_Done,
     /*  706668 */   // Label 11148: @706668
     /*  706668 */   GIM_Try, /*On fail goto*//*Label 11149*/ GIMT_Encode4(706743), // Rule ID 11299 //
     /*  706673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  706684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  706687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  706690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  706708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  706722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706741 */     GIR_RootConstrainSelectedInstOperands,
     /*  706742 */     // GIR_Coverage, 11299,
     /*  706742 */     GIR_EraseRootFromParent_Done,
     /*  706743 */   // Label 11149: @706743
     /*  706743 */   GIM_Try, /*On fail goto*//*Label 11150*/ GIMT_Encode4(706818), // Rule ID 11302 //
     /*  706748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  706759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  706762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  706765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  706768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706794 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  706794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706816 */     GIR_RootConstrainSelectedInstOperands,
     /*  706817 */     // GIR_Coverage, 11302,
     /*  706817 */     GIR_EraseRootFromParent_Done,
     /*  706818 */   // Label 11150: @706818
     /*  706818 */   GIM_Try, /*On fail goto*//*Label 11151*/ GIMT_Encode4(706893), // Rule ID 11303 //
     /*  706823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  706831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  706834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  706837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  706840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  706843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  706858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  706862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706869 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  706869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  706872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  706888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706891 */     GIR_RootConstrainSelectedInstOperands,
     /*  706892 */     // GIR_Coverage, 11303,
     /*  706892 */     GIR_EraseRootFromParent_Done,
     /*  706893 */   // Label 11151: @706893
     /*  706893 */   GIM_Try, /*On fail goto*//*Label 11152*/ GIMT_Encode4(706968), // Rule ID 11306 //
     /*  706898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  706901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  706906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  706909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  706912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  706915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  706918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  706921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  706937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  706944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  706944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  706947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  706949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  706951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  706953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  706955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  706960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  706963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  706966 */     GIR_RootConstrainSelectedInstOperands,
     /*  706967 */     // GIR_Coverage, 11306,
     /*  706967 */     GIR_EraseRootFromParent_Done,
     /*  706968 */   // Label 11152: @706968
     /*  706968 */   GIM_Try, /*On fail goto*//*Label 11153*/ GIMT_Encode4(707043), // Rule ID 11307 //
     /*  706973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  706976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  706981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  706984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  706987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  706990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  706993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  706996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8),
     /*  707022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707041 */     GIR_RootConstrainSelectedInstOperands,
     /*  707042 */     // GIR_Coverage, 11307,
     /*  707042 */     GIR_EraseRootFromParent_Done,
     /*  707043 */   // Label 11153: @707043
     /*  707043 */   GIM_Try, /*On fail goto*//*Label 11154*/ GIMT_Encode4(707118), // Rule ID 11310 //
     /*  707048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707116 */     GIR_RootConstrainSelectedInstOperands,
     /*  707117 */     // GIR_Coverage, 11310,
     /*  707117 */     GIR_EraseRootFromParent_Done,
     /*  707118 */   // Label 11154: @707118
     /*  707118 */   GIM_Try, /*On fail goto*//*Label 11155*/ GIMT_Encode4(707193), // Rule ID 11311 //
     /*  707123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  707134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  707137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  707140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  707143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707169 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707191 */     GIR_RootConstrainSelectedInstOperands,
     /*  707192 */     // GIR_Coverage, 11311,
     /*  707192 */     GIR_EraseRootFromParent_Done,
     /*  707193 */   // Label 11155: @707193
     /*  707193 */   GIM_Try, /*On fail goto*//*Label 11156*/ GIMT_Encode4(707268), // Rule ID 11314 //
     /*  707198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707266 */     GIR_RootConstrainSelectedInstOperands,
     /*  707267 */     // GIR_Coverage, 11314,
     /*  707267 */     GIR_EraseRootFromParent_Done,
     /*  707268 */   // Label 11156: @707268
     /*  707268 */   GIM_Try, /*On fail goto*//*Label 11157*/ GIMT_Encode4(707343), // Rule ID 11315 //
     /*  707273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  707284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  707287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  707290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  707293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707319 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707341 */     GIR_RootConstrainSelectedInstOperands,
     /*  707342 */     // GIR_Coverage, 11315,
     /*  707342 */     GIR_EraseRootFromParent_Done,
     /*  707343 */   // Label 11157: @707343
     /*  707343 */   GIM_Try, /*On fail goto*//*Label 11158*/ GIMT_Encode4(707418), // Rule ID 11318 //
     /*  707348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707416 */     GIR_RootConstrainSelectedInstOperands,
     /*  707417 */     // GIR_Coverage, 11318,
     /*  707417 */     GIR_EraseRootFromParent_Done,
     /*  707418 */   // Label 11158: @707418
     /*  707418 */   GIM_Try, /*On fail goto*//*Label 11159*/ GIMT_Encode4(707493), // Rule ID 11319 //
     /*  707423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  707434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  707437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  707440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  707443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4),
     /*  707472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707491 */     GIR_RootConstrainSelectedInstOperands,
     /*  707492 */     // GIR_Coverage, 11319,
     /*  707492 */     GIR_EraseRootFromParent_Done,
     /*  707493 */   // Label 11159: @707493
     /*  707493 */   GIM_Try, /*On fail goto*//*Label 11160*/ GIMT_Encode4(707568), // Rule ID 11322 //
     /*  707498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  707509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  707512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  707515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  707518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707566 */     GIR_RootConstrainSelectedInstOperands,
     /*  707567 */     // GIR_Coverage, 11322,
     /*  707567 */     GIR_EraseRootFromParent_Done,
     /*  707568 */   // Label 11160: @707568
     /*  707568 */   GIM_Try, /*On fail goto*//*Label 11161*/ GIMT_Encode4(707643), // Rule ID 11323 //
     /*  707573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  707584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  707587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  707590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  707593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  707619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  707638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707641 */     GIR_RootConstrainSelectedInstOperands,
     /*  707642 */     // GIR_Coverage, 11323,
     /*  707642 */     GIR_EraseRootFromParent_Done,
     /*  707643 */   // Label 11161: @707643
     /*  707643 */   GIM_Try, /*On fail goto*//*Label 11162*/ GIMT_Encode4(707718), // Rule ID 11326 //
     /*  707648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  707659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  707662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  707665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  707668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  707694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707716 */     GIR_RootConstrainSelectedInstOperands,
     /*  707717 */     // GIR_Coverage, 11326,
     /*  707717 */     GIR_EraseRootFromParent_Done,
     /*  707718 */   // Label 11162: @707718
     /*  707718 */   GIM_Try, /*On fail goto*//*Label 11163*/ GIMT_Encode4(707793), // Rule ID 11327 //
     /*  707723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  707734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  707737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  707740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  707743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  707769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2),
     /*  707772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  707788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707791 */     GIR_RootConstrainSelectedInstOperands,
     /*  707792 */     // GIR_Coverage, 11327,
     /*  707792 */     GIR_EraseRootFromParent_Done,
     /*  707793 */   // Label 11163: @707793
     /*  707793 */   GIM_Try, /*On fail goto*//*Label 11164*/ GIMT_Encode4(707868), // Rule ID 11330 //
     /*  707798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  707809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  707812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  707815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  707818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  707844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  707847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707866 */     GIR_RootConstrainSelectedInstOperands,
     /*  707867 */     // GIR_Coverage, 11330,
     /*  707867 */     GIR_EraseRootFromParent_Done,
     /*  707868 */   // Label 11164: @707868
     /*  707868 */   GIM_Try, /*On fail goto*//*Label 11165*/ GIMT_Encode4(707943), // Rule ID 11331 //
     /*  707873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  707876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  707884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  707887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  707890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  707893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  707896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  707919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  707922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  707926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  707928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  707930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  707935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  707938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  707941 */     GIR_RootConstrainSelectedInstOperands,
     /*  707942 */     // GIR_Coverage, 11331,
     /*  707942 */     GIR_EraseRootFromParent_Done,
     /*  707943 */   // Label 11165: @707943
     /*  707943 */   GIM_Try, /*On fail goto*//*Label 11166*/ GIMT_Encode4(708018), // Rule ID 11334 //
     /*  707948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  707951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  707956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  707959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  707962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  707965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  707968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  707971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  707987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  707994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  707994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  707997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  707999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708016 */     GIR_RootConstrainSelectedInstOperands,
     /*  708017 */     // GIR_Coverage, 11334,
     /*  708017 */     GIR_EraseRootFromParent_Done,
     /*  708018 */   // Label 11166: @708018
     /*  708018 */   GIM_Try, /*On fail goto*//*Label 11167*/ GIMT_Encode4(708093), // Rule ID 11335 //
     /*  708023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  708034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  708037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  708040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  708043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708069 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708091 */     GIR_RootConstrainSelectedInstOperands,
     /*  708092 */     // GIR_Coverage, 11335,
     /*  708092 */     GIR_EraseRootFromParent_Done,
     /*  708093 */   // Label 11167: @708093
     /*  708093 */   GIM_Try, /*On fail goto*//*Label 11168*/ GIMT_Encode4(708168), // Rule ID 11338 //
     /*  708098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  708144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708166 */     GIR_RootConstrainSelectedInstOperands,
     /*  708167 */     // GIR_Coverage, 11338,
     /*  708167 */     GIR_EraseRootFromParent_Done,
     /*  708168 */   // Label 11168: @708168
     /*  708168 */   GIM_Try, /*On fail goto*//*Label 11169*/ GIMT_Encode4(708243), // Rule ID 11339 //
     /*  708173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  708184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  708187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  708190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  708193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  708212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  708219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  708222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  708238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708241 */     GIR_RootConstrainSelectedInstOperands,
     /*  708242 */     // GIR_Coverage, 11339,
     /*  708242 */     GIR_EraseRootFromParent_Done,
     /*  708243 */   // Label 11169: @708243
     /*  708243 */   GIM_Try, /*On fail goto*//*Label 11170*/ GIMT_Encode4(708318), // Rule ID 11342 //
     /*  708248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708294 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708316 */     GIR_RootConstrainSelectedInstOperands,
     /*  708317 */     // GIR_Coverage, 11342,
     /*  708317 */     GIR_EraseRootFromParent_Done,
     /*  708318 */   // Label 11170: @708318
     /*  708318 */   GIM_Try, /*On fail goto*//*Label 11171*/ GIMT_Encode4(708393), // Rule ID 11343 //
     /*  708323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  708334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  708337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  708340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  708343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708369 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708391 */     GIR_RootConstrainSelectedInstOperands,
     /*  708392 */     // GIR_Coverage, 11343,
     /*  708392 */     GIR_EraseRootFromParent_Done,
     /*  708393 */   // Label 11171: @708393
     /*  708393 */   GIM_Try, /*On fail goto*//*Label 11172*/ GIMT_Encode4(708468), // Rule ID 11346 //
     /*  708398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  708409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  708412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  708415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  708418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708466 */     GIR_RootConstrainSelectedInstOperands,
     /*  708467 */     // GIR_Coverage, 11346,
     /*  708467 */     GIR_EraseRootFromParent_Done,
     /*  708468 */   // Label 11172: @708468
     /*  708468 */   GIM_Try, /*On fail goto*//*Label 11173*/ GIMT_Encode4(708543), // Rule ID 11347 //
     /*  708473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  708484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  708487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  708490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  708493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708519 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708541 */     GIR_RootConstrainSelectedInstOperands,
     /*  708542 */     // GIR_Coverage, 11347,
     /*  708542 */     GIR_EraseRootFromParent_Done,
     /*  708543 */   // Label 11173: @708543
     /*  708543 */   GIM_Try, /*On fail goto*//*Label 11174*/ GIMT_Encode4(708618), // Rule ID 11350 //
     /*  708548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  708559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  708562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  708565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  708568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708594 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  708594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  708597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708616 */     GIR_RootConstrainSelectedInstOperands,
     /*  708617 */     // GIR_Coverage, 11350,
     /*  708617 */     GIR_EraseRootFromParent_Done,
     /*  708618 */   // Label 11174: @708618
     /*  708618 */   GIM_Try, /*On fail goto*//*Label 11175*/ GIMT_Encode4(708693), // Rule ID 11351 //
     /*  708623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  708634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  708637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  708640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  708643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  708662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708669 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  708669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  708672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  708688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708691 */     GIR_RootConstrainSelectedInstOperands,
     /*  708692 */     // GIR_Coverage, 11351,
     /*  708692 */     GIR_EraseRootFromParent_Done,
     /*  708693 */   // Label 11175: @708693
     /*  708693 */   GIM_Try, /*On fail goto*//*Label 11176*/ GIMT_Encode4(708768), // Rule ID 11354 //
     /*  708698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  708709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  708712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  708715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  708718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708766 */     GIR_RootConstrainSelectedInstOperands,
     /*  708767 */     // GIR_Coverage, 11354,
     /*  708767 */     GIR_EraseRootFromParent_Done,
     /*  708768 */   // Label 11176: @708768
     /*  708768 */   GIM_Try, /*On fail goto*//*Label 11177*/ GIMT_Encode4(708843), // Rule ID 11355 //
     /*  708773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  708784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  708787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  708790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  708793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  708812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  708822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708841 */     GIR_RootConstrainSelectedInstOperands,
     /*  708842 */     // GIR_Coverage, 11355,
     /*  708842 */     GIR_EraseRootFromParent_Done,
     /*  708843 */   // Label 11177: @708843
     /*  708843 */   GIM_Try, /*On fail goto*//*Label 11178*/ GIMT_Encode4(708918), // Rule ID 11358 //
     /*  708848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  708851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  708859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  708862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  708865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  708868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  708871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708894 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  708894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708916 */     GIR_RootConstrainSelectedInstOperands,
     /*  708917 */     // GIR_Coverage, 11358,
     /*  708917 */     GIR_EraseRootFromParent_Done,
     /*  708918 */   // Label 11178: @708918
     /*  708918 */   GIM_Try, /*On fail goto*//*Label 11179*/ GIMT_Encode4(708993), // Rule ID 11359 //
     /*  708923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  708926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  708931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  708934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  708937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  708940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  708943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  708946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  708962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  708969 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  708969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  708972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  708974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  708976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  708978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  708980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  708985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  708988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  708991 */     GIR_RootConstrainSelectedInstOperands,
     /*  708992 */     // GIR_Coverage, 11359,
     /*  708992 */     GIR_EraseRootFromParent_Done,
     /*  708993 */   // Label 11179: @708993
     /*  708993 */   GIM_Try, /*On fail goto*//*Label 11180*/ GIMT_Encode4(709068), // Rule ID 11362 //
     /*  708998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  709044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709066 */     GIR_RootConstrainSelectedInstOperands,
     /*  709067 */     // GIR_Coverage, 11362,
     /*  709067 */     GIR_EraseRootFromParent_Done,
     /*  709068 */   // Label 11180: @709068
     /*  709068 */   GIM_Try, /*On fail goto*//*Label 11181*/ GIMT_Encode4(709143), // Rule ID 11363 //
     /*  709073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  709084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  709087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  709090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  709093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709119 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  709119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  709138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709141 */     GIR_RootConstrainSelectedInstOperands,
     /*  709142 */     // GIR_Coverage, 11363,
     /*  709142 */     GIR_EraseRootFromParent_Done,
     /*  709143 */   // Label 11181: @709143
     /*  709143 */   GIM_Try, /*On fail goto*//*Label 11182*/ GIMT_Encode4(709218), // Rule ID 11366 //
     /*  709148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709216 */     GIR_RootConstrainSelectedInstOperands,
     /*  709217 */     // GIR_Coverage, 11366,
     /*  709217 */     GIR_EraseRootFromParent_Done,
     /*  709218 */   // Label 11182: @709218
     /*  709218 */   GIM_Try, /*On fail goto*//*Label 11183*/ GIMT_Encode4(709293), // Rule ID 11367 //
     /*  709223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  709234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  709237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  709240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  709243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  709262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  709272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709291 */     GIR_RootConstrainSelectedInstOperands,
     /*  709292 */     // GIR_Coverage, 11367,
     /*  709292 */     GIR_EraseRootFromParent_Done,
     /*  709293 */   // Label 11183: @709293
     /*  709293 */   GIM_Try, /*On fail goto*//*Label 11184*/ GIMT_Encode4(709368), // Rule ID 11370 //
     /*  709298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709366 */     GIR_RootConstrainSelectedInstOperands,
     /*  709367 */     // GIR_Coverage, 11370,
     /*  709367 */     GIR_EraseRootFromParent_Done,
     /*  709368 */   // Label 11184: @709368
     /*  709368 */   GIM_Try, /*On fail goto*//*Label 11185*/ GIMT_Encode4(709443), // Rule ID 11371 //
     /*  709373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  709384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  709387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  709390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  709393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  709412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709419 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  709422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709441 */     GIR_RootConstrainSelectedInstOperands,
     /*  709442 */     // GIR_Coverage, 11371,
     /*  709442 */     GIR_EraseRootFromParent_Done,
     /*  709443 */   // Label 11185: @709443
     /*  709443 */   GIM_Try, /*On fail goto*//*Label 11186*/ GIMT_Encode4(709518), // Rule ID 11374 //
     /*  709448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  709494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709516 */     GIR_RootConstrainSelectedInstOperands,
     /*  709517 */     // GIR_Coverage, 11374,
     /*  709517 */     GIR_EraseRootFromParent_Done,
     /*  709518 */   // Label 11186: @709518
     /*  709518 */   GIM_Try, /*On fail goto*//*Label 11187*/ GIMT_Encode4(709593), // Rule ID 11375 //
     /*  709523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  709534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  709537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  709540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  709543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  709562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709569 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  709569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  709572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  709588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709591 */     GIR_RootConstrainSelectedInstOperands,
     /*  709592 */     // GIR_Coverage, 11375,
     /*  709592 */     GIR_EraseRootFromParent_Done,
     /*  709593 */   // Label 11187: @709593
     /*  709593 */   GIM_Try, /*On fail goto*//*Label 11188*/ GIMT_Encode4(709668), // Rule ID 11378 //
     /*  709598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  709609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  709612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  709615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709644 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  709647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709666 */     GIR_RootConstrainSelectedInstOperands,
     /*  709667 */     // GIR_Coverage, 11378,
     /*  709667 */     GIR_EraseRootFromParent_Done,
     /*  709668 */   // Label 11188: @709668
     /*  709668 */   GIM_Try, /*On fail goto*//*Label 11189*/ GIMT_Encode4(709743), // Rule ID 11379 //
     /*  709673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  709684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  709687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  709690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709719 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8),
     /*  709722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709741 */     GIR_RootConstrainSelectedInstOperands,
     /*  709742 */     // GIR_Coverage, 11379,
     /*  709742 */     GIR_EraseRootFromParent_Done,
     /*  709743 */   // Label 11189: @709743
     /*  709743 */   GIM_Try, /*On fail goto*//*Label 11190*/ GIMT_Encode4(709818), // Rule ID 11382 //
     /*  709748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  709759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  709762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  709765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709794 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  709797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709816 */     GIR_RootConstrainSelectedInstOperands,
     /*  709817 */     // GIR_Coverage, 11382,
     /*  709817 */     GIR_EraseRootFromParent_Done,
     /*  709818 */   // Label 11190: @709818
     /*  709818 */   GIM_Try, /*On fail goto*//*Label 11191*/ GIMT_Encode4(709893), // Rule ID 11383 //
     /*  709823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  709834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  709837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  709840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709869 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  709869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  709872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709891 */     GIR_RootConstrainSelectedInstOperands,
     /*  709892 */     // GIR_Coverage, 11383,
     /*  709892 */     GIR_EraseRootFromParent_Done,
     /*  709893 */   // Label 11191: @709893
     /*  709893 */   GIM_Try, /*On fail goto*//*Label 11192*/ GIMT_Encode4(709968), // Rule ID 11386 //
     /*  709898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  709901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  709909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  709912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  709915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  709918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  709921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  709933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  709937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  709944 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  709944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  709947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  709949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  709951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  709953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  709955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  709960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  709963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  709966 */     GIR_RootConstrainSelectedInstOperands,
     /*  709967 */     // GIR_Coverage, 11386,
     /*  709967 */     GIR_EraseRootFromParent_Done,
     /*  709968 */   // Label 11192: @709968
     /*  709968 */   GIM_Try, /*On fail goto*//*Label 11193*/ GIMT_Encode4(710043), // Rule ID 11387 //
     /*  709973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  709976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  709981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  709984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  709987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  709990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  709993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  709996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710019 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710041 */     GIR_RootConstrainSelectedInstOperands,
     /*  710042 */     // GIR_Coverage, 11387,
     /*  710042 */     GIR_EraseRootFromParent_Done,
     /*  710043 */   // Label 11193: @710043
     /*  710043 */   GIM_Try, /*On fail goto*//*Label 11194*/ GIMT_Encode4(710118), // Rule ID 11390 //
     /*  710048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710116 */     GIR_RootConstrainSelectedInstOperands,
     /*  710117 */     // GIR_Coverage, 11390,
     /*  710117 */     GIR_EraseRootFromParent_Done,
     /*  710118 */   // Label 11194: @710118
     /*  710118 */   GIM_Try, /*On fail goto*//*Label 11195*/ GIMT_Encode4(710193), // Rule ID 11391 //
     /*  710123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  710134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  710137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  710140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4),
     /*  710172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710191 */     GIR_RootConstrainSelectedInstOperands,
     /*  710192 */     // GIR_Coverage, 11391,
     /*  710192 */     GIR_EraseRootFromParent_Done,
     /*  710193 */   // Label 11195: @710193
     /*  710193 */   GIM_Try, /*On fail goto*//*Label 11196*/ GIMT_Encode4(710268), // Rule ID 11394 //
     /*  710198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710266 */     GIR_RootConstrainSelectedInstOperands,
     /*  710267 */     // GIR_Coverage, 11394,
     /*  710267 */     GIR_EraseRootFromParent_Done,
     /*  710268 */   // Label 11196: @710268
     /*  710268 */   GIM_Try, /*On fail goto*//*Label 11197*/ GIMT_Encode4(710343), // Rule ID 11395 //
     /*  710273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  710284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  710287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  710290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710341 */     GIR_RootConstrainSelectedInstOperands,
     /*  710342 */     // GIR_Coverage, 11395,
     /*  710342 */     GIR_EraseRootFromParent_Done,
     /*  710343 */   // Label 11197: @710343
     /*  710343 */   GIM_Try, /*On fail goto*//*Label 11198*/ GIMT_Encode4(710418), // Rule ID 11398 //
     /*  710348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710416 */     GIR_RootConstrainSelectedInstOperands,
     /*  710417 */     // GIR_Coverage, 11398,
     /*  710417 */     GIR_EraseRootFromParent_Done,
     /*  710418 */   // Label 11198: @710418
     /*  710418 */   GIM_Try, /*On fail goto*//*Label 11199*/ GIMT_Encode4(710493), // Rule ID 11399 //
     /*  710423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  710434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  710437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  710440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710469 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2),
     /*  710472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710491 */     GIR_RootConstrainSelectedInstOperands,
     /*  710492 */     // GIR_Coverage, 11399,
     /*  710492 */     GIR_EraseRootFromParent_Done,
     /*  710493 */   // Label 11199: @710493
     /*  710493 */   GIM_Try, /*On fail goto*//*Label 11200*/ GIMT_Encode4(710568), // Rule ID 11402 //
     /*  710498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  710509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  710512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  710515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710566 */     GIR_RootConstrainSelectedInstOperands,
     /*  710567 */     // GIR_Coverage, 11402,
     /*  710567 */     GIR_EraseRootFromParent_Done,
     /*  710568 */   // Label 11200: @710568
     /*  710568 */   GIM_Try, /*On fail goto*//*Label 11201*/ GIMT_Encode4(710643), // Rule ID 11403 //
     /*  710573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  710584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  710587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  710590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11404:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  710619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  710638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710641 */     GIR_RootConstrainSelectedInstOperands,
     /*  710642 */     // GIR_Coverage, 11403,
     /*  710642 */     GIR_EraseRootFromParent_Done,
     /*  710643 */   // Label 11201: @710643
     /*  710643 */   GIM_Try, /*On fail goto*//*Label 11202*/ GIMT_Encode4(710718), // Rule ID 11406 //
     /*  710648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  710659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  710662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  710665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  710694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710716 */     GIR_RootConstrainSelectedInstOperands,
     /*  710717 */     // GIR_Coverage, 11406,
     /*  710717 */     GIR_EraseRootFromParent_Done,
     /*  710718 */   // Label 11202: @710718
     /*  710718 */   GIM_Try, /*On fail goto*//*Label 11203*/ GIMT_Encode4(710793), // Rule ID 11407 //
     /*  710723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  710734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  710737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  710740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710769 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11404:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  710769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  710788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710791 */     GIR_RootConstrainSelectedInstOperands,
     /*  710792 */     // GIR_Coverage, 11407,
     /*  710792 */     GIR_EraseRootFromParent_Done,
     /*  710793 */   // Label 11203: @710793
     /*  710793 */   GIM_Try, /*On fail goto*//*Label 11204*/ GIMT_Encode4(710868), // Rule ID 11410 //
     /*  710798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  710809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  710812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  710815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  710844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710866 */     GIR_RootConstrainSelectedInstOperands,
     /*  710867 */     // GIR_Coverage, 11410,
     /*  710867 */     GIR_EraseRootFromParent_Done,
     /*  710868 */   // Label 11204: @710868
     /*  710868 */   GIM_Try, /*On fail goto*//*Label 11205*/ GIMT_Encode4(710943), // Rule ID 11411 //
     /*  710873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  710876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  710884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  710887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  710890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  710893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  710896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  710908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710919 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11404:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  710919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  710922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  710926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  710928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  710930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  710935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  710938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  710941 */     GIR_RootConstrainSelectedInstOperands,
     /*  710942 */     // GIR_Coverage, 11411,
     /*  710942 */     GIR_EraseRootFromParent_Done,
     /*  710943 */   // Label 11205: @710943
     /*  710943 */   GIM_Try, /*On fail goto*//*Label 11206*/ GIMT_Encode4(711018), // Rule ID 11414 //
     /*  710948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  710951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  710956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  710959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  710962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  710965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  710968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  710971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  710983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  710987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  710994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  710994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  710997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  710999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711016 */     GIR_RootConstrainSelectedInstOperands,
     /*  711017 */     // GIR_Coverage, 11414,
     /*  711017 */     GIR_EraseRootFromParent_Done,
     /*  711018 */   // Label 11206: @711018
     /*  711018 */   GIM_Try, /*On fail goto*//*Label 11207*/ GIMT_Encode4(711093), // Rule ID 11415 //
     /*  711023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  711034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  711037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  711040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711069 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711091 */     GIR_RootConstrainSelectedInstOperands,
     /*  711092 */     // GIR_Coverage, 11415,
     /*  711092 */     GIR_EraseRootFromParent_Done,
     /*  711093 */   // Label 11207: @711093
     /*  711093 */   GIM_Try, /*On fail goto*//*Label 11208*/ GIMT_Encode4(711168), // Rule ID 11418 //
     /*  711098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711144 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711166 */     GIR_RootConstrainSelectedInstOperands,
     /*  711167 */     // GIR_Coverage, 11418,
     /*  711167 */     GIR_EraseRootFromParent_Done,
     /*  711168 */   // Label 11208: @711168
     /*  711168 */   GIM_Try, /*On fail goto*//*Label 11209*/ GIMT_Encode4(711243), // Rule ID 11419 //
     /*  711173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  711184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  711187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  711190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711219 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711241 */     GIR_RootConstrainSelectedInstOperands,
     /*  711242 */     // GIR_Coverage, 11419,
     /*  711242 */     GIR_EraseRootFromParent_Done,
     /*  711243 */   // Label 11209: @711243
     /*  711243 */   GIM_Try, /*On fail goto*//*Label 11210*/ GIMT_Encode4(711318), // Rule ID 11422 //
     /*  711248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711294 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  711294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711316 */     GIR_RootConstrainSelectedInstOperands,
     /*  711317 */     // GIR_Coverage, 11422,
     /*  711317 */     GIR_EraseRootFromParent_Done,
     /*  711318 */   // Label 11210: @711318
     /*  711318 */   GIM_Try, /*On fail goto*//*Label 11211*/ GIMT_Encode4(711393), // Rule ID 11423 //
     /*  711323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  711334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  711337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  711340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711369 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  711369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  711388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711391 */     GIR_RootConstrainSelectedInstOperands,
     /*  711392 */     // GIR_Coverage, 11423,
     /*  711392 */     GIR_EraseRootFromParent_Done,
     /*  711393 */   // Label 11211: @711393
     /*  711393 */   GIM_Try, /*On fail goto*//*Label 11212*/ GIMT_Encode4(711468), // Rule ID 11426 //
     /*  711398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  711409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  711412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  711415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711444 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711466 */     GIR_RootConstrainSelectedInstOperands,
     /*  711467 */     // GIR_Coverage, 11426,
     /*  711467 */     GIR_EraseRootFromParent_Done,
     /*  711468 */   // Label 11212: @711468
     /*  711468 */   GIM_Try, /*On fail goto*//*Label 11213*/ GIMT_Encode4(711543), // Rule ID 11427 //
     /*  711473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  711484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  711487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  711490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711519 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711541 */     GIR_RootConstrainSelectedInstOperands,
     /*  711542 */     // GIR_Coverage, 11427,
     /*  711542 */     GIR_EraseRootFromParent_Done,
     /*  711543 */   // Label 11213: @711543
     /*  711543 */   GIM_Try, /*On fail goto*//*Label 11214*/ GIMT_Encode4(711618), // Rule ID 11430 //
     /*  711548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  711559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  711562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  711565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711594 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711616 */     GIR_RootConstrainSelectedInstOperands,
     /*  711617 */     // GIR_Coverage, 11430,
     /*  711617 */     GIR_EraseRootFromParent_Done,
     /*  711618 */   // Label 11214: @711618
     /*  711618 */   GIM_Try, /*On fail goto*//*Label 11215*/ GIMT_Encode4(711693), // Rule ID 11431 //
     /*  711623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  711634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  711637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  711640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  711658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711669 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  711672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711691 */     GIR_RootConstrainSelectedInstOperands,
     /*  711692 */     // GIR_Coverage, 11431,
     /*  711692 */     GIR_EraseRootFromParent_Done,
     /*  711693 */   // Label 11215: @711693
     /*  711693 */   GIM_Try, /*On fail goto*//*Label 11216*/ GIMT_Encode4(711768), // Rule ID 11434 //
     /*  711698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  711709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  711712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  711715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  711744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711766 */     GIR_RootConstrainSelectedInstOperands,
     /*  711767 */     // GIR_Coverage, 11434,
     /*  711767 */     GIR_EraseRootFromParent_Done,
     /*  711768 */   // Label 11216: @711768
     /*  711768 */   GIM_Try, /*On fail goto*//*Label 11217*/ GIMT_Encode4(711843), // Rule ID 11435 //
     /*  711773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  711784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  711787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  711790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  711808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711819 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  711819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  711822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  711838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711841 */     GIR_RootConstrainSelectedInstOperands,
     /*  711842 */     // GIR_Coverage, 11435,
     /*  711842 */     GIR_EraseRootFromParent_Done,
     /*  711843 */   // Label 11217: @711843
     /*  711843 */   GIM_Try, /*On fail goto*//*Label 11218*/ GIMT_Encode4(711918), // Rule ID 11438 //
     /*  711848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  711851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  711859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  711862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  711865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  711868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  711871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  711894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711916 */     GIR_RootConstrainSelectedInstOperands,
     /*  711917 */     // GIR_Coverage, 11438,
     /*  711917 */     GIR_EraseRootFromParent_Done,
     /*  711918 */   // Label 11218: @711918
     /*  711918 */   GIM_Try, /*On fail goto*//*Label 11219*/ GIMT_Encode4(711993), // Rule ID 11439 //
     /*  711923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  711926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  711931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  711934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  711937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  711940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  711943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  711946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  711958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  711962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  711969 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  711969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  711972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  711974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  711976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  711978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  711980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  711985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  711988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  711991 */     GIR_RootConstrainSelectedInstOperands,
     /*  711992 */     // GIR_Coverage, 11439,
     /*  711992 */     GIR_EraseRootFromParent_Done,
     /*  711993 */   // Label 11219: @711993
     /*  711993 */   GIM_Try, /*On fail goto*//*Label 11220*/ GIMT_Encode4(712068), // Rule ID 11442 //
     /*  711998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712044 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712066 */     GIR_RootConstrainSelectedInstOperands,
     /*  712067 */     // GIR_Coverage, 11442,
     /*  712067 */     GIR_EraseRootFromParent_Done,
     /*  712068 */   // Label 11220: @712068
     /*  712068 */   GIM_Try, /*On fail goto*//*Label 11221*/ GIMT_Encode4(712143), // Rule ID 11443 //
     /*  712073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  712084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  712087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  712090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712119 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  712122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712141 */     GIR_RootConstrainSelectedInstOperands,
     /*  712142 */     // GIR_Coverage, 11443,
     /*  712142 */     GIR_EraseRootFromParent_Done,
     /*  712143 */   // Label 11221: @712143
     /*  712143 */   GIM_Try, /*On fail goto*//*Label 11222*/ GIMT_Encode4(712218), // Rule ID 11446 //
     /*  712148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  712151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  712194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712216 */     GIR_RootConstrainSelectedInstOperands,
     /*  712217 */     // GIR_Coverage, 11446,
     /*  712217 */     GIR_EraseRootFromParent_Done,
     /*  712218 */   // Label 11222: @712218
     /*  712218 */   GIM_Try, /*On fail goto*//*Label 11223*/ GIMT_Encode4(712293), // Rule ID 11447 //
     /*  712223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  712226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  712231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  712234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  712237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  712240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712269 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  712269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  712272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  712288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712291 */     GIR_RootConstrainSelectedInstOperands,
     /*  712292 */     // GIR_Coverage, 11447,
     /*  712292 */     GIR_EraseRootFromParent_Done,
     /*  712293 */   // Label 11223: @712293
     /*  712293 */   GIM_Try, /*On fail goto*//*Label 11224*/ GIMT_Encode4(712368), // Rule ID 11450 //
     /*  712298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712366 */     GIR_RootConstrainSelectedInstOperands,
     /*  712367 */     // GIR_Coverage, 11450,
     /*  712367 */     GIR_EraseRootFromParent_Done,
     /*  712368 */   // Label 11224: @712368
     /*  712368 */   GIM_Try, /*On fail goto*//*Label 11225*/ GIMT_Encode4(712443), // Rule ID 11451 //
     /*  712373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  712393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712419 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /*  712422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712441 */     GIR_RootConstrainSelectedInstOperands,
     /*  712442 */     // GIR_Coverage, 11451,
     /*  712442 */     GIR_EraseRootFromParent_Done,
     /*  712443 */   // Label 11225: @712443
     /*  712443 */   GIM_Try, /*On fail goto*//*Label 11226*/ GIMT_Encode4(712518), // Rule ID 11454 //
     /*  712448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  712459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  712462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  712465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  712468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  712497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712516 */     GIR_RootConstrainSelectedInstOperands,
     /*  712517 */     // GIR_Coverage, 11454,
     /*  712517 */     GIR_EraseRootFromParent_Done,
     /*  712518 */   // Label 11226: @712518
     /*  712518 */   GIM_Try, /*On fail goto*//*Label 11227*/ GIMT_Encode4(712593), // Rule ID 11455 //
     /*  712523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  712534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  712537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  712540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  712543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  712562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /*  712572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712591 */     GIR_RootConstrainSelectedInstOperands,
     /*  712592 */     // GIR_Coverage, 11455,
     /*  712592 */     GIR_EraseRootFromParent_Done,
     /*  712593 */   // Label 11227: @712593
     /*  712593 */   GIM_Try, /*On fail goto*//*Label 11228*/ GIMT_Encode4(712668), // Rule ID 11458 //
     /*  712598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  712609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  712612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  712615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  712618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  712647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712666 */     GIR_RootConstrainSelectedInstOperands,
     /*  712667 */     // GIR_Coverage, 11458,
     /*  712667 */     GIR_EraseRootFromParent_Done,
     /*  712668 */   // Label 11228: @712668
     /*  712668 */   GIM_Try, /*On fail goto*//*Label 11229*/ GIMT_Encode4(712743), // Rule ID 11459 //
     /*  712673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  712684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  712687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  712690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  712693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  712712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /*  712722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712741 */     GIR_RootConstrainSelectedInstOperands,
     /*  712742 */     // GIR_Coverage, 11459,
     /*  712742 */     GIR_EraseRootFromParent_Done,
     /*  712743 */   // Label 11229: @712743
     /*  712743 */   GIM_Try, /*On fail goto*//*Label 11230*/ GIMT_Encode4(712818), // Rule ID 11462 //
     /*  712748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  712759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  712762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  712765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  712768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  712797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712816 */     GIR_RootConstrainSelectedInstOperands,
     /*  712817 */     // GIR_Coverage, 11462,
     /*  712817 */     GIR_EraseRootFromParent_Done,
     /*  712818 */   // Label 11230: @712818
     /*  712818 */   GIM_Try, /*On fail goto*//*Label 11231*/ GIMT_Encode4(712893), // Rule ID 11463 //
     /*  712823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  712834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  712837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  712840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  712843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  712862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  712869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /*  712872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712891 */     GIR_RootConstrainSelectedInstOperands,
     /*  712892 */     // GIR_Coverage, 11463,
     /*  712892 */     GIR_EraseRootFromParent_Done,
     /*  712893 */   // Label 11231: @712893
     /*  712893 */   GIM_Try, /*On fail goto*//*Label 11232*/ GIMT_Encode4(712968), // Rule ID 11466 //
     /*  712898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  712901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  712918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  712921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  712933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  712937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  712944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  712944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  712947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  712949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  712951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  712953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  712955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  712960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  712963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  712966 */     GIR_RootConstrainSelectedInstOperands,
     /*  712967 */     // GIR_Coverage, 11466,
     /*  712967 */     GIR_EraseRootFromParent_Done,
     /*  712968 */   // Label 11232: @712968
     /*  712968 */   GIM_Try, /*On fail goto*//*Label 11233*/ GIMT_Encode4(713043), // Rule ID 11467 //
     /*  712973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  712976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  712981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  712984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  712987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  712990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  712993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  712996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713019 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11402:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1),
     /*  713022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713041 */     GIR_RootConstrainSelectedInstOperands,
     /*  713042 */     // GIR_Coverage, 11467,
     /*  713042 */     GIR_EraseRootFromParent_Done,
     /*  713043 */   // Label 11233: @713043
     /*  713043 */   GIM_Try, /*On fail goto*//*Label 11234*/ GIMT_Encode4(713118), // Rule ID 11470 //
     /*  713048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713116 */     GIR_RootConstrainSelectedInstOperands,
     /*  713117 */     // GIR_Coverage, 11470,
     /*  713117 */     GIR_EraseRootFromParent_Done,
     /*  713118 */   // Label 11234: @713118
     /*  713118 */   GIM_Try, /*On fail goto*//*Label 11235*/ GIMT_Encode4(713193), // Rule ID 11471 //
     /*  713123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11402:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2),
     /*  713172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713191 */     GIR_RootConstrainSelectedInstOperands,
     /*  713192 */     // GIR_Coverage, 11471,
     /*  713192 */     GIR_EraseRootFromParent_Done,
     /*  713193 */   // Label 11235: @713193
     /*  713193 */   GIM_Try, /*On fail goto*//*Label 11236*/ GIMT_Encode4(713268), // Rule ID 11474 //
     /*  713198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713266 */     GIR_RootConstrainSelectedInstOperands,
     /*  713267 */     // GIR_Coverage, 11474,
     /*  713267 */     GIR_EraseRootFromParent_Done,
     /*  713268 */   // Label 11236: @713268
     /*  713268 */   GIM_Try, /*On fail goto*//*Label 11237*/ GIMT_Encode4(713343), // Rule ID 11475 //
     /*  713273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11402:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4),
     /*  713322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713341 */     GIR_RootConstrainSelectedInstOperands,
     /*  713342 */     // GIR_Coverage, 11475,
     /*  713342 */     GIR_EraseRootFromParent_Done,
     /*  713343 */   // Label 11237: @713343
     /*  713343 */   GIM_Try, /*On fail goto*//*Label 11238*/ GIMT_Encode4(713418), // Rule ID 11478 //
     /*  713348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  713368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713416 */     GIR_RootConstrainSelectedInstOperands,
     /*  713417 */     // GIR_Coverage, 11478,
     /*  713417 */     GIR_EraseRootFromParent_Done,
     /*  713418 */   // Label 11238: @713418
     /*  713418 */   GIM_Try, /*On fail goto*//*Label 11239*/ GIMT_Encode4(713493), // Rule ID 11479 //
     /*  713423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh),
     /*  713431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  713443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  713462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11402:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8),
     /*  713472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713491 */     GIR_RootConstrainSelectedInstOperands,
     /*  713492 */     // GIR_Coverage, 11479,
     /*  713492 */     GIR_EraseRootFromParent_Done,
     /*  713493 */   // Label 11239: @713493
     /*  713493 */   GIM_Try, /*On fail goto*//*Label 11240*/ GIMT_Encode4(713568), // Rule ID 11482 //
     /*  713498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  713547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713566 */     GIR_RootConstrainSelectedInstOperands,
     /*  713567 */     // GIR_Coverage, 11482,
     /*  713567 */     GIR_EraseRootFromParent_Done,
     /*  713568 */   // Label 11240: @713568
     /*  713568 */   GIM_Try, /*On fail goto*//*Label 11241*/ GIMT_Encode4(713643), // Rule ID 11483 //
     /*  713573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  713584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  713587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  713590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  713593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  713612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713619 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /*  713622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713641 */     GIR_RootConstrainSelectedInstOperands,
     /*  713642 */     // GIR_Coverage, 11483,
     /*  713642 */     GIR_EraseRootFromParent_Done,
     /*  713643 */   // Label 11241: @713643
     /*  713643 */   GIM_Try, /*On fail goto*//*Label 11242*/ GIMT_Encode4(713718), // Rule ID 11486 //
     /*  713648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  713697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713716 */     GIR_RootConstrainSelectedInstOperands,
     /*  713717 */     // GIR_Coverage, 11486,
     /*  713717 */     GIR_EraseRootFromParent_Done,
     /*  713718 */   // Label 11242: @713718
     /*  713718 */   GIM_Try, /*On fail goto*//*Label 11243*/ GIMT_Encode4(713793), // Rule ID 11487 //
     /*  713723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  713734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  713737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  713740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  713743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  713762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /*  713772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713791 */     GIR_RootConstrainSelectedInstOperands,
     /*  713792 */     // GIR_Coverage, 11487,
     /*  713792 */     GIR_EraseRootFromParent_Done,
     /*  713793 */   // Label 11243: @713793
     /*  713793 */   GIM_Try, /*On fail goto*//*Label 11244*/ GIMT_Encode4(713868), // Rule ID 11490 //
     /*  713798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  713847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713866 */     GIR_RootConstrainSelectedInstOperands,
     /*  713867 */     // GIR_Coverage, 11490,
     /*  713867 */     GIR_EraseRootFromParent_Done,
     /*  713868 */   // Label 11244: @713868
     /*  713868 */   GIM_Try, /*On fail goto*//*Label 11245*/ GIMT_Encode4(713943), // Rule ID 11491 //
     /*  713873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  713876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  713884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  713887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  713890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  713893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  713896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  713912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  713919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /*  713922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  713926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  713928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  713930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  713935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  713938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  713941 */     GIR_RootConstrainSelectedInstOperands,
     /*  713942 */     // GIR_Coverage, 11491,
     /*  713942 */     GIR_EraseRootFromParent_Done,
     /*  713943 */   // Label 11245: @713943
     /*  713943 */   GIM_Try, /*On fail goto*//*Label 11246*/ GIMT_Encode4(714018), // Rule ID 11494 //
     /*  713948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  713951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  713956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  713959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  713962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  713965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  713968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  713971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  713987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  713994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  713994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  713997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  713999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714016 */     GIR_RootConstrainSelectedInstOperands,
     /*  714017 */     // GIR_Coverage, 11494,
     /*  714017 */     GIR_EraseRootFromParent_Done,
     /*  714018 */   // Label 11246: @714018
     /*  714018 */   GIM_Try, /*On fail goto*//*Label 11247*/ GIMT_Encode4(714093), // Rule ID 11495 //
     /*  714023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  714043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /*  714072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714091 */     GIR_RootConstrainSelectedInstOperands,
     /*  714092 */     // GIR_Coverage, 11495,
     /*  714092 */     GIR_EraseRootFromParent_Done,
     /*  714093 */   // Label 11247: @714093
     /*  714093 */   GIM_Try, /*On fail goto*//*Label 11248*/ GIMT_Encode4(714168), // Rule ID 11498 //
     /*  714098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714166 */     GIR_RootConstrainSelectedInstOperands,
     /*  714167 */     // GIR_Coverage, 11498,
     /*  714167 */     GIR_EraseRootFromParent_Done,
     /*  714168 */   // Label 11248: @714168
     /*  714168 */   GIM_Try, /*On fail goto*//*Label 11249*/ GIMT_Encode4(714243), // Rule ID 11499 //
     /*  714173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714219 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11406:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1),
     /*  714222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714241 */     GIR_RootConstrainSelectedInstOperands,
     /*  714242 */     // GIR_Coverage, 11499,
     /*  714242 */     GIR_EraseRootFromParent_Done,
     /*  714243 */   // Label 11249: @714243
     /*  714243 */   GIM_Try, /*On fail goto*//*Label 11250*/ GIMT_Encode4(714318), // Rule ID 11502 //
     /*  714248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714316 */     GIR_RootConstrainSelectedInstOperands,
     /*  714317 */     // GIR_Coverage, 11502,
     /*  714317 */     GIR_EraseRootFromParent_Done,
     /*  714318 */   // Label 11250: @714318
     /*  714318 */   GIM_Try, /*On fail goto*//*Label 11251*/ GIMT_Encode4(714393), // Rule ID 11503 //
     /*  714323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11406:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2),
     /*  714372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714391 */     GIR_RootConstrainSelectedInstOperands,
     /*  714392 */     // GIR_Coverage, 11503,
     /*  714392 */     GIR_EraseRootFromParent_Done,
     /*  714393 */   // Label 11251: @714393
     /*  714393 */   GIM_Try, /*On fail goto*//*Label 11252*/ GIMT_Encode4(714468), // Rule ID 11506 //
     /*  714398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  714447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714466 */     GIR_RootConstrainSelectedInstOperands,
     /*  714467 */     // GIR_Coverage, 11506,
     /*  714467 */     GIR_EraseRootFromParent_Done,
     /*  714468 */   // Label 11252: @714468
     /*  714468 */   GIM_Try, /*On fail goto*//*Label 11253*/ GIMT_Encode4(714543), // Rule ID 11507 //
     /*  714473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  714484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  714487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  714490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  714508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11406:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4),
     /*  714522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714541 */     GIR_RootConstrainSelectedInstOperands,
     /*  714542 */     // GIR_Coverage, 11507,
     /*  714542 */     GIR_EraseRootFromParent_Done,
     /*  714543 */   // Label 11253: @714543
     /*  714543 */   GIM_Try, /*On fail goto*//*Label 11254*/ GIMT_Encode4(714618), // Rule ID 11510 //
     /*  714548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  714568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  714597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714616 */     GIR_RootConstrainSelectedInstOperands,
     /*  714617 */     // GIR_Coverage, 11510,
     /*  714617 */     GIR_EraseRootFromParent_Done,
     /*  714618 */   // Label 11254: @714618
     /*  714618 */   GIM_Try, /*On fail goto*//*Label 11255*/ GIMT_Encode4(714693), // Rule ID 11511 //
     /*  714623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu),
     /*  714631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  714634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  714637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  714640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  714643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  714658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  714662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714669 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11406:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8),
     /*  714672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714691 */     GIR_RootConstrainSelectedInstOperands,
     /*  714692 */     // GIR_Coverage, 11511,
     /*  714692 */     GIR_EraseRootFromParent_Done,
     /*  714693 */   // Label 11255: @714693
     /*  714693 */   GIM_Try, /*On fail goto*//*Label 11256*/ GIMT_Encode4(714768), // Rule ID 11514 //
     /*  714698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  714747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714766 */     GIR_RootConstrainSelectedInstOperands,
     /*  714767 */     // GIR_Coverage, 11514,
     /*  714767 */     GIR_EraseRootFromParent_Done,
     /*  714768 */   // Label 11256: @714768
     /*  714768 */   GIM_Try, /*On fail goto*//*Label 11257*/ GIMT_Encode4(714843), // Rule ID 11515 //
     /*  714773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  714784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  714787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  714790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  714793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  714812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714819 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1),
     /*  714822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714841 */     GIR_RootConstrainSelectedInstOperands,
     /*  714842 */     // GIR_Coverage, 11515,
     /*  714842 */     GIR_EraseRootFromParent_Done,
     /*  714843 */   // Label 11257: @714843
     /*  714843 */   GIM_Try, /*On fail goto*//*Label 11258*/ GIMT_Encode4(714918), // Rule ID 11518 //
     /*  714848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  714851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  714871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  714894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  714897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714916 */     GIR_RootConstrainSelectedInstOperands,
     /*  714917 */     // GIR_Coverage, 11518,
     /*  714917 */     GIR_EraseRootFromParent_Done,
     /*  714918 */   // Label 11258: @714918
     /*  714918 */   GIM_Try, /*On fail goto*//*Label 11259*/ GIMT_Encode4(714993), // Rule ID 11519 //
     /*  714923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  714926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  714931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  714934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  714937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  714940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  714943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  714946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  714962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  714969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  714969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2),
     /*  714972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  714974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  714976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  714978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  714980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  714985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  714988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  714991 */     GIR_RootConstrainSelectedInstOperands,
     /*  714992 */     // GIR_Coverage, 11519,
     /*  714992 */     GIR_EraseRootFromParent_Done,
     /*  714993 */   // Label 11259: @714993
     /*  714993 */   GIM_Try, /*On fail goto*//*Label 11260*/ GIMT_Encode4(715068), // Rule ID 11522 //
     /*  714998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715066 */     GIR_RootConstrainSelectedInstOperands,
     /*  715067 */     // GIR_Coverage, 11522,
     /*  715067 */     GIR_EraseRootFromParent_Done,
     /*  715068 */   // Label 11260: @715068
     /*  715068 */   GIM_Try, /*On fail goto*//*Label 11261*/ GIMT_Encode4(715143), // Rule ID 11523 //
     /*  715073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  715093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4),
     /*  715122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715141 */     GIR_RootConstrainSelectedInstOperands,
     /*  715142 */     // GIR_Coverage, 11523,
     /*  715142 */     GIR_EraseRootFromParent_Done,
     /*  715143 */   // Label 11261: @715143
     /*  715143 */   GIM_Try, /*On fail goto*//*Label 11262*/ GIMT_Encode4(715218), // Rule ID 11526 //
     /*  715148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715216 */     GIR_RootConstrainSelectedInstOperands,
     /*  715217 */     // GIR_Coverage, 11526,
     /*  715217 */     GIR_EraseRootFromParent_Done,
     /*  715218 */   // Label 11262: @715218
     /*  715218 */   GIM_Try, /*On fail goto*//*Label 11263*/ GIMT_Encode4(715293), // Rule ID 11527 //
     /*  715223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  715243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8),
     /*  715272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715291 */     GIR_RootConstrainSelectedInstOperands,
     /*  715292 */     // GIR_Coverage, 11527,
     /*  715292 */     GIR_EraseRootFromParent_Done,
     /*  715293 */   // Label 11263: @715293
     /*  715293 */   GIM_Try, /*On fail goto*//*Label 11264*/ GIMT_Encode4(715368), // Rule ID 11530 //
     /*  715298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715344 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715366 */     GIR_RootConstrainSelectedInstOperands,
     /*  715367 */     // GIR_Coverage, 11530,
     /*  715367 */     GIR_EraseRootFromParent_Done,
     /*  715368 */   // Label 11264: @715368
     /*  715368 */   GIM_Try, /*On fail goto*//*Label 11265*/ GIMT_Encode4(715443), // Rule ID 11531 //
     /*  715373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  715384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  715387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  715390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715419 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11404:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1),
     /*  715422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715441 */     GIR_RootConstrainSelectedInstOperands,
     /*  715442 */     // GIR_Coverage, 11531,
     /*  715442 */     GIR_EraseRootFromParent_Done,
     /*  715443 */   // Label 11265: @715443
     /*  715443 */   GIM_Try, /*On fail goto*//*Label 11266*/ GIMT_Encode4(715518), // Rule ID 11534 //
     /*  715448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715516 */     GIR_RootConstrainSelectedInstOperands,
     /*  715517 */     // GIR_Coverage, 11534,
     /*  715517 */     GIR_EraseRootFromParent_Done,
     /*  715518 */   // Label 11266: @715518
     /*  715518 */   GIM_Try, /*On fail goto*//*Label 11267*/ GIMT_Encode4(715593), // Rule ID 11535 //
     /*  715523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  715534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  715537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  715540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  715558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715569 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11404:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2),
     /*  715572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715591 */     GIR_RootConstrainSelectedInstOperands,
     /*  715592 */     // GIR_Coverage, 11535,
     /*  715592 */     GIR_EraseRootFromParent_Done,
     /*  715593 */   // Label 11267: @715593
     /*  715593 */   GIM_Try, /*On fail goto*//*Label 11268*/ GIMT_Encode4(715668), // Rule ID 11538 //
     /*  715598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715666 */     GIR_RootConstrainSelectedInstOperands,
     /*  715667 */     // GIR_Coverage, 11538,
     /*  715667 */     GIR_EraseRootFromParent_Done,
     /*  715668 */   // Label 11268: @715668
     /*  715668 */   GIM_Try, /*On fail goto*//*Label 11269*/ GIMT_Encode4(715743), // Rule ID 11539 //
     /*  715673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  715684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  715687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  715690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  715708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715719 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11404:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4),
     /*  715722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715741 */     GIR_RootConstrainSelectedInstOperands,
     /*  715742 */     // GIR_Coverage, 11539,
     /*  715742 */     GIR_EraseRootFromParent_Done,
     /*  715743 */   // Label 11269: @715743
     /*  715743 */   GIM_Try, /*On fail goto*//*Label 11270*/ GIMT_Encode4(715818), // Rule ID 11542 //
     /*  715748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /*  715751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  715768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  715794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715816 */     GIR_RootConstrainSelectedInstOperands,
     /*  715817 */     // GIR_Coverage, 11542,
     /*  715817 */     GIR_EraseRootFromParent_Done,
     /*  715818 */   // Label 11270: @715818
     /*  715818 */   GIM_Try, /*On fail goto*//*Label 11271*/ GIMT_Encode4(715893), // Rule ID 11543 //
     /*  715823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /*  715826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu),
     /*  715831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  715834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  715837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  715840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  715843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  715858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  715862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715869 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11404:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMULHSU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  715869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8),
     /*  715872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  715888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715891 */     GIR_RootConstrainSelectedInstOperands,
     /*  715892 */     // GIR_Coverage, 11543,
     /*  715892 */     GIR_EraseRootFromParent_Done,
     /*  715893 */   // Label 11271: @715893
     /*  715893 */   GIM_Try, /*On fail goto*//*Label 11272*/ GIMT_Encode4(715968), // Rule ID 11546 //
     /*  715898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  715901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  715906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  715909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  715912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  715915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  715918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  715921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  715937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  715944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  715944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  715947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  715949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  715951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  715953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  715955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  715960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  715963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  715966 */     GIR_RootConstrainSelectedInstOperands,
     /*  715967 */     // GIR_Coverage, 11546,
     /*  715967 */     GIR_EraseRootFromParent_Done,
     /*  715968 */   // Label 11272: @715968
     /*  715968 */   GIM_Try, /*On fail goto*//*Label 11273*/ GIMT_Encode4(716043), // Rule ID 11547 //
     /*  715973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  715976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  715981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  715984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  715987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  715990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  715993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  715996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716019 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8),
     /*  716022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716041 */     GIR_RootConstrainSelectedInstOperands,
     /*  716042 */     // GIR_Coverage, 11547,
     /*  716042 */     GIR_EraseRootFromParent_Done,
     /*  716043 */   // Label 11273: @716043
     /*  716043 */   GIM_Try, /*On fail goto*//*Label 11274*/ GIMT_Encode4(716118), // Rule ID 11550 //
     /*  716048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716116 */     GIR_RootConstrainSelectedInstOperands,
     /*  716117 */     // GIR_Coverage, 11550,
     /*  716117 */     GIR_EraseRootFromParent_Done,
     /*  716118 */   // Label 11274: @716118
     /*  716118 */   GIM_Try, /*On fail goto*//*Label 11275*/ GIMT_Encode4(716193), // Rule ID 11551 //
     /*  716123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  716134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  716137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  716140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  716143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716169 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8),
     /*  716172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716191 */     GIR_RootConstrainSelectedInstOperands,
     /*  716192 */     // GIR_Coverage, 11551,
     /*  716192 */     GIR_EraseRootFromParent_Done,
     /*  716193 */   // Label 11275: @716193
     /*  716193 */   GIM_Try, /*On fail goto*//*Label 11276*/ GIMT_Encode4(716268), // Rule ID 11554 //
     /*  716198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716244 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716266 */     GIR_RootConstrainSelectedInstOperands,
     /*  716267 */     // GIR_Coverage, 11554,
     /*  716267 */     GIR_EraseRootFromParent_Done,
     /*  716268 */   // Label 11276: @716268
     /*  716268 */   GIM_Try, /*On fail goto*//*Label 11277*/ GIMT_Encode4(716343), // Rule ID 11555 //
     /*  716273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  716284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  716287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  716290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  716293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716319 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8),
     /*  716322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716341 */     GIR_RootConstrainSelectedInstOperands,
     /*  716342 */     // GIR_Coverage, 11555,
     /*  716342 */     GIR_EraseRootFromParent_Done,
     /*  716343 */   // Label 11277: @716343
     /*  716343 */   GIM_Try, /*On fail goto*//*Label 11278*/ GIMT_Encode4(716418), // Rule ID 11558 //
     /*  716348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716416 */     GIR_RootConstrainSelectedInstOperands,
     /*  716417 */     // GIR_Coverage, 11558,
     /*  716417 */     GIR_EraseRootFromParent_Done,
     /*  716418 */   // Label 11278: @716418
     /*  716418 */   GIM_Try, /*On fail goto*//*Label 11279*/ GIMT_Encode4(716493), // Rule ID 11559 //
     /*  716423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  716434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  716437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  716440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  716443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716469 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16),
     /*  716472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716491 */     GIR_RootConstrainSelectedInstOperands,
     /*  716492 */     // GIR_Coverage, 11559,
     /*  716492 */     GIR_EraseRootFromParent_Done,
     /*  716493 */   // Label 11279: @716493
     /*  716493 */   GIM_Try, /*On fail goto*//*Label 11280*/ GIMT_Encode4(716568), // Rule ID 11562 //
     /*  716498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  716509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  716512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  716515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  716518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716544 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  716547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716566 */     GIR_RootConstrainSelectedInstOperands,
     /*  716567 */     // GIR_Coverage, 11562,
     /*  716567 */     GIR_EraseRootFromParent_Done,
     /*  716568 */   // Label 11280: @716568
     /*  716568 */   GIM_Try, /*On fail goto*//*Label 11281*/ GIMT_Encode4(716643), // Rule ID 11563 //
     /*  716573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  716584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  716587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  716590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  716593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716619 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  716619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16),
     /*  716622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  716638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716641 */     GIR_RootConstrainSelectedInstOperands,
     /*  716642 */     // GIR_Coverage, 11563,
     /*  716642 */     GIR_EraseRootFromParent_Done,
     /*  716643 */   // Label 11281: @716643
     /*  716643 */   GIM_Try, /*On fail goto*//*Label 11282*/ GIMT_Encode4(716718), // Rule ID 11566 //
     /*  716648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  716659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  716662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  716665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  716668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716694 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  716694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  716697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716716 */     GIR_RootConstrainSelectedInstOperands,
     /*  716717 */     // GIR_Coverage, 11566,
     /*  716717 */     GIR_EraseRootFromParent_Done,
     /*  716718 */   // Label 11282: @716718
     /*  716718 */   GIM_Try, /*On fail goto*//*Label 11283*/ GIMT_Encode4(716793), // Rule ID 11567 //
     /*  716723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  716734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  716737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  716740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  716743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716769 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  716769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32),
     /*  716772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  716788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716791 */     GIR_RootConstrainSelectedInstOperands,
     /*  716792 */     // GIR_Coverage, 11567,
     /*  716792 */     GIR_EraseRootFromParent_Done,
     /*  716793 */   // Label 11283: @716793
     /*  716793 */   GIM_Try, /*On fail goto*//*Label 11284*/ GIMT_Encode4(716868), // Rule ID 11570 //
     /*  716798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  716815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  716844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  716847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716866 */     GIR_RootConstrainSelectedInstOperands,
     /*  716867 */     // GIR_Coverage, 11570,
     /*  716867 */     GIR_EraseRootFromParent_Done,
     /*  716868 */   // Label 11284: @716868
     /*  716868 */   GIM_Try, /*On fail goto*//*Label 11285*/ GIMT_Encode4(716943), // Rule ID 11571 //
     /*  716873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  716876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  716884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  716887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  716890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  716893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  716896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716919 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  716919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8),
     /*  716922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  716926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  716928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  716930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  716935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  716938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  716941 */     GIR_RootConstrainSelectedInstOperands,
     /*  716942 */     // GIR_Coverage, 11571,
     /*  716942 */     GIR_EraseRootFromParent_Done,
     /*  716943 */   // Label 11285: @716943
     /*  716943 */   GIM_Try, /*On fail goto*//*Label 11286*/ GIMT_Encode4(717018), // Rule ID 11574 //
     /*  716948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  716951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  716956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  716959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  716962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  716965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  716968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  716971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  716987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  716994 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  716994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  716997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  716999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717016 */     GIR_RootConstrainSelectedInstOperands,
     /*  717017 */     // GIR_Coverage, 11574,
     /*  717017 */     GIR_EraseRootFromParent_Done,
     /*  717018 */   // Label 11286: @717018
     /*  717018 */   GIM_Try, /*On fail goto*//*Label 11287*/ GIMT_Encode4(717093), // Rule ID 11575 //
     /*  717023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  717034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  717037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  717040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  717043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717069 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16),
     /*  717072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717091 */     GIR_RootConstrainSelectedInstOperands,
     /*  717092 */     // GIR_Coverage, 11575,
     /*  717092 */     GIR_EraseRootFromParent_Done,
     /*  717093 */   // Label 11287: @717093
     /*  717093 */   GIM_Try, /*On fail goto*//*Label 11288*/ GIMT_Encode4(717168), // Rule ID 11578 //
     /*  717098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  717144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717166 */     GIR_RootConstrainSelectedInstOperands,
     /*  717167 */     // GIR_Coverage, 11578,
     /*  717167 */     GIR_EraseRootFromParent_Done,
     /*  717168 */   // Label 11288: @717168
     /*  717168 */   GIM_Try, /*On fail goto*//*Label 11289*/ GIMT_Encode4(717243), // Rule ID 11579 //
     /*  717173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  717184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  717187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  717190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  717193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  717219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32),
     /*  717222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  717238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717241 */     GIR_RootConstrainSelectedInstOperands,
     /*  717242 */     // GIR_Coverage, 11579,
     /*  717242 */     GIR_EraseRootFromParent_Done,
     /*  717243 */   // Label 11289: @717243
     /*  717243 */   GIM_Try, /*On fail goto*//*Label 11290*/ GIMT_Encode4(717318), // Rule ID 11582 //
     /*  717248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  717251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717294 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  717294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717316 */     GIR_RootConstrainSelectedInstOperands,
     /*  717317 */     // GIR_Coverage, 11582,
     /*  717317 */     GIR_EraseRootFromParent_Done,
     /*  717318 */   // Label 11290: @717318
     /*  717318 */   GIM_Try, /*On fail goto*//*Label 11291*/ GIMT_Encode4(717393), // Rule ID 11583 //
     /*  717323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  717326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  717334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  717337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  717340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  717343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  717362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717369 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  717369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64),
     /*  717372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  717388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717391 */     GIR_RootConstrainSelectedInstOperands,
     /*  717392 */     // GIR_Coverage, 11583,
     /*  717392 */     GIR_EraseRootFromParent_Done,
     /*  717393 */   // Label 11291: @717393
     /*  717393 */   GIM_Try, /*On fail goto*//*Label 11292*/ GIMT_Encode4(717468), // Rule ID 11586 //
     /*  717398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  717409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  717412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  717415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  717418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717444 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  717447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717466 */     GIR_RootConstrainSelectedInstOperands,
     /*  717467 */     // GIR_Coverage, 11586,
     /*  717467 */     GIR_EraseRootFromParent_Done,
     /*  717468 */   // Label 11292: @717468
     /*  717468 */   GIM_Try, /*On fail goto*//*Label 11293*/ GIMT_Encode4(717543), // Rule ID 11587 //
     /*  717473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  717484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  717487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  717490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  717493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717519 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8),
     /*  717522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717541 */     GIR_RootConstrainSelectedInstOperands,
     /*  717542 */     // GIR_Coverage, 11587,
     /*  717542 */     GIR_EraseRootFromParent_Done,
     /*  717543 */   // Label 11293: @717543
     /*  717543 */   GIM_Try, /*On fail goto*//*Label 11294*/ GIMT_Encode4(717618), // Rule ID 11590 //
     /*  717548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  717559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  717562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  717565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  717568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717594 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  717597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717616 */     GIR_RootConstrainSelectedInstOperands,
     /*  717617 */     // GIR_Coverage, 11590,
     /*  717617 */     GIR_EraseRootFromParent_Done,
     /*  717618 */   // Label 11294: @717618
     /*  717618 */   GIM_Try, /*On fail goto*//*Label 11295*/ GIMT_Encode4(717693), // Rule ID 11591 //
     /*  717623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  717634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  717637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  717640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  717643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  717662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717669 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8),
     /*  717672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717691 */     GIR_RootConstrainSelectedInstOperands,
     /*  717692 */     // GIR_Coverage, 11591,
     /*  717692 */     GIR_EraseRootFromParent_Done,
     /*  717693 */   // Label 11295: @717693
     /*  717693 */   GIM_Try, /*On fail goto*//*Label 11296*/ GIMT_Encode4(717768), // Rule ID 11594 //
     /*  717698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  717709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  717712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  717715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  717718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717744 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  717744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  717747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717766 */     GIR_RootConstrainSelectedInstOperands,
     /*  717767 */     // GIR_Coverage, 11594,
     /*  717767 */     GIR_EraseRootFromParent_Done,
     /*  717768 */   // Label 11296: @717768
     /*  717768 */   GIM_Try, /*On fail goto*//*Label 11297*/ GIMT_Encode4(717843), // Rule ID 11595 //
     /*  717773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  717784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  717787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  717790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  717793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  717812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717819 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  717819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8),
     /*  717822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  717838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717841 */     GIR_RootConstrainSelectedInstOperands,
     /*  717842 */     // GIR_Coverage, 11595,
     /*  717842 */     GIR_EraseRootFromParent_Done,
     /*  717843 */   // Label 11297: @717843
     /*  717843 */   GIM_Try, /*On fail goto*//*Label 11298*/ GIMT_Encode4(717918), // Rule ID 11598 //
     /*  717848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  717851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  717859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  717862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  717865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  717868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  717871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  717894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  717897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717916 */     GIR_RootConstrainSelectedInstOperands,
     /*  717917 */     // GIR_Coverage, 11598,
     /*  717917 */     GIR_EraseRootFromParent_Done,
     /*  717918 */   // Label 11298: @717918
     /*  717918 */   GIM_Try, /*On fail goto*//*Label 11299*/ GIMT_Encode4(717993), // Rule ID 11599 //
     /*  717923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  717926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  717931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  717934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  717937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  717940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  717943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  717946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  717962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  717969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  717969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16),
     /*  717972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  717974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  717976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  717978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  717980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  717985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  717988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  717991 */     GIR_RootConstrainSelectedInstOperands,
     /*  717992 */     // GIR_Coverage, 11599,
     /*  717992 */     GIR_EraseRootFromParent_Done,
     /*  717993 */   // Label 11299: @717993
     /*  717993 */   GIM_Try, /*On fail goto*//*Label 11300*/ GIMT_Encode4(718068), // Rule ID 11602 //
     /*  717998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718066 */     GIR_RootConstrainSelectedInstOperands,
     /*  718067 */     // GIR_Coverage, 11602,
     /*  718067 */     GIR_EraseRootFromParent_Done,
     /*  718068 */   // Label 11300: @718068
     /*  718068 */   GIM_Try, /*On fail goto*//*Label 11301*/ GIMT_Encode4(718143), // Rule ID 11603 //
     /*  718073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  718084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  718087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  718090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  718093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718119 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16),
     /*  718122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718141 */     GIR_RootConstrainSelectedInstOperands,
     /*  718142 */     // GIR_Coverage, 11603,
     /*  718142 */     GIR_EraseRootFromParent_Done,
     /*  718143 */   // Label 11301: @718143
     /*  718143 */   GIM_Try, /*On fail goto*//*Label 11302*/ GIMT_Encode4(718218), // Rule ID 11606 //
     /*  718148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  718194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718216 */     GIR_RootConstrainSelectedInstOperands,
     /*  718217 */     // GIR_Coverage, 11606,
     /*  718217 */     GIR_EraseRootFromParent_Done,
     /*  718218 */   // Label 11302: @718218
     /*  718218 */   GIM_Try, /*On fail goto*//*Label 11303*/ GIMT_Encode4(718293), // Rule ID 11607 //
     /*  718223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  718234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  718237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  718240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  718243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  718269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16),
     /*  718272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  718288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718291 */     GIR_RootConstrainSelectedInstOperands,
     /*  718292 */     // GIR_Coverage, 11607,
     /*  718292 */     GIR_EraseRootFromParent_Done,
     /*  718293 */   // Label 11303: @718293
     /*  718293 */   GIM_Try, /*On fail goto*//*Label 11304*/ GIMT_Encode4(718368), // Rule ID 11610 //
     /*  718298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718366 */     GIR_RootConstrainSelectedInstOperands,
     /*  718367 */     // GIR_Coverage, 11610,
     /*  718367 */     GIR_EraseRootFromParent_Done,
     /*  718368 */   // Label 11304: @718368
     /*  718368 */   GIM_Try, /*On fail goto*//*Label 11305*/ GIMT_Encode4(718443), // Rule ID 11611 //
     /*  718373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  718384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  718387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  718390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  718393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32),
     /*  718422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718441 */     GIR_RootConstrainSelectedInstOperands,
     /*  718442 */     // GIR_Coverage, 11611,
     /*  718442 */     GIR_EraseRootFromParent_Done,
     /*  718443 */   // Label 11305: @718443
     /*  718443 */   GIM_Try, /*On fail goto*//*Label 11306*/ GIMT_Encode4(718518), // Rule ID 11614 //
     /*  718448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  718459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  718462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  718465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  718468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  718497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718516 */     GIR_RootConstrainSelectedInstOperands,
     /*  718517 */     // GIR_Coverage, 11614,
     /*  718517 */     GIR_EraseRootFromParent_Done,
     /*  718518 */   // Label 11306: @718518
     /*  718518 */   GIM_Try, /*On fail goto*//*Label 11307*/ GIMT_Encode4(718593), // Rule ID 11615 //
     /*  718523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  718534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  718537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  718540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  718543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718569 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32),
     /*  718572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718591 */     GIR_RootConstrainSelectedInstOperands,
     /*  718592 */     // GIR_Coverage, 11615,
     /*  718592 */     GIR_EraseRootFromParent_Done,
     /*  718593 */   // Label 11307: @718593
     /*  718593 */   GIM_Try, /*On fail goto*//*Label 11308*/ GIMT_Encode4(718668), // Rule ID 11618 //
     /*  718598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  718601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  718609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  718612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  718615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  718618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718644 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  718644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  718647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718666 */     GIR_RootConstrainSelectedInstOperands,
     /*  718667 */     // GIR_Coverage, 11618,
     /*  718667 */     GIR_EraseRootFromParent_Done,
     /*  718668 */   // Label 11308: @718668
     /*  718668 */   GIM_Try, /*On fail goto*//*Label 11309*/ GIMT_Encode4(718743), // Rule ID 11619 //
     /*  718673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  718676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  718684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  718687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  718690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  718693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  718712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718719 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  718719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32),
     /*  718722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  718738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718741 */     GIR_RootConstrainSelectedInstOperands,
     /*  718742 */     // GIR_Coverage, 11619,
     /*  718742 */     GIR_EraseRootFromParent_Done,
     /*  718743 */   // Label 11309: @718743
     /*  718743 */   GIM_Try, /*On fail goto*//*Label 11310*/ GIMT_Encode4(718818), // Rule ID 11622 //
     /*  718748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718794 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  718797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718816 */     GIR_RootConstrainSelectedInstOperands,
     /*  718817 */     // GIR_Coverage, 11622,
     /*  718817 */     GIR_EraseRootFromParent_Done,
     /*  718818 */   // Label 11310: @718818
     /*  718818 */   GIM_Try, /*On fail goto*//*Label 11311*/ GIMT_Encode4(718893), // Rule ID 11623 //
     /*  718823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  718834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  718837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  718840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  718843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  718862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718869 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  718869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64),
     /*  718872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718891 */     GIR_RootConstrainSelectedInstOperands,
     /*  718892 */     // GIR_Coverage, 11623,
     /*  718892 */     GIR_EraseRootFromParent_Done,
     /*  718893 */   // Label 11311: @718893
     /*  718893 */   GIM_Try, /*On fail goto*//*Label 11312*/ GIMT_Encode4(718968), // Rule ID 11626 //
     /*  718898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  718901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  718921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  718937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  718944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  718944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  718947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  718949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  718951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  718953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  718955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  718960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  718963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  718966 */     GIR_RootConstrainSelectedInstOperands,
     /*  718967 */     // GIR_Coverage, 11626,
     /*  718967 */     GIR_EraseRootFromParent_Done,
     /*  718968 */   // Label 11312: @718968
     /*  718968 */   GIM_Try, /*On fail goto*//*Label 11313*/ GIMT_Encode4(719043), // Rule ID 11627 //
     /*  718973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  718976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  718981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  718984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  718987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  718990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  718993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  718996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  719012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719019 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64),
     /*  719022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719041 */     GIR_RootConstrainSelectedInstOperands,
     /*  719042 */     // GIR_Coverage, 11627,
     /*  719042 */     GIR_EraseRootFromParent_Done,
     /*  719043 */   // Label 11313: @719043
     /*  719043 */   GIM_Try, /*On fail goto*//*Label 11314*/ GIMT_Encode4(719118), // Rule ID 11630 //
     /*  719048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  719051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719094 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  719094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719116 */     GIR_RootConstrainSelectedInstOperands,
     /*  719117 */     // GIR_Coverage, 11630,
     /*  719117 */     GIR_EraseRootFromParent_Done,
     /*  719118 */   // Label 11314: @719118
     /*  719118 */   GIM_Try, /*On fail goto*//*Label 11315*/ GIMT_Encode4(719193), // Rule ID 11631 //
     /*  719123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  719126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  719134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  719137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  719140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  719143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  719162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719169 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  719169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64),
     /*  719172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  719188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719191 */     GIR_RootConstrainSelectedInstOperands,
     /*  719192 */     // GIR_Coverage, 11631,
     /*  719192 */     GIR_EraseRootFromParent_Done,
     /*  719193 */   // Label 11315: @719193
     /*  719193 */   GIM_Try, /*On fail goto*//*Label 11316*/ GIMT_Encode4(719268), // Rule ID 11634 //
     /*  719198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719266 */     GIR_RootConstrainSelectedInstOperands,
     /*  719267 */     // GIR_Coverage, 11634,
     /*  719267 */     GIR_EraseRootFromParent_Done,
     /*  719268 */   // Label 11316: @719268
     /*  719268 */   GIM_Try, /*On fail goto*//*Label 11317*/ GIMT_Encode4(719343), // Rule ID 11635 //
     /*  719273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  719284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  719287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  719290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719319 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8),
     /*  719322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719341 */     GIR_RootConstrainSelectedInstOperands,
     /*  719342 */     // GIR_Coverage, 11635,
     /*  719342 */     GIR_EraseRootFromParent_Done,
     /*  719343 */   // Label 11317: @719343
     /*  719343 */   GIM_Try, /*On fail goto*//*Label 11318*/ GIMT_Encode4(719418), // Rule ID 11638 //
     /*  719348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719394 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719416 */     GIR_RootConstrainSelectedInstOperands,
     /*  719417 */     // GIR_Coverage, 11638,
     /*  719417 */     GIR_EraseRootFromParent_Done,
     /*  719418 */   // Label 11318: @719418
     /*  719418 */   GIM_Try, /*On fail goto*//*Label 11319*/ GIMT_Encode4(719493), // Rule ID 11639 //
     /*  719423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  719434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  719437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  719440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719469 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8),
     /*  719472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719491 */     GIR_RootConstrainSelectedInstOperands,
     /*  719492 */     // GIR_Coverage, 11639,
     /*  719492 */     GIR_EraseRootFromParent_Done,
     /*  719493 */   // Label 11319: @719493
     /*  719493 */   GIM_Try, /*On fail goto*//*Label 11320*/ GIMT_Encode4(719568), // Rule ID 11642 //
     /*  719498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  719509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  719512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  719515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719544 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  719544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  719547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719566 */     GIR_RootConstrainSelectedInstOperands,
     /*  719567 */     // GIR_Coverage, 11642,
     /*  719567 */     GIR_EraseRootFromParent_Done,
     /*  719568 */   // Label 11320: @719568
     /*  719568 */   GIM_Try, /*On fail goto*//*Label 11321*/ GIMT_Encode4(719643), // Rule ID 11643 //
     /*  719573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  719584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  719587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  719590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719619 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  719619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8),
     /*  719622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  719638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719641 */     GIR_RootConstrainSelectedInstOperands,
     /*  719642 */     // GIR_Coverage, 11643,
     /*  719642 */     GIR_EraseRootFromParent_Done,
     /*  719643 */   // Label 11321: @719643
     /*  719643 */   GIM_Try, /*On fail goto*//*Label 11322*/ GIMT_Encode4(719718), // Rule ID 11646 //
     /*  719648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  719659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  719662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  719665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  719697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719716 */     GIR_RootConstrainSelectedInstOperands,
     /*  719717 */     // GIR_Coverage, 11646,
     /*  719717 */     GIR_EraseRootFromParent_Done,
     /*  719718 */   // Label 11322: @719718
     /*  719718 */   GIM_Try, /*On fail goto*//*Label 11323*/ GIMT_Encode4(719793), // Rule ID 11647 //
     /*  719723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  719734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  719737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  719740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16),
     /*  719772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719791 */     GIR_RootConstrainSelectedInstOperands,
     /*  719792 */     // GIR_Coverage, 11647,
     /*  719792 */     GIR_EraseRootFromParent_Done,
     /*  719793 */   // Label 11323: @719793
     /*  719793 */   GIM_Try, /*On fail goto*//*Label 11324*/ GIMT_Encode4(719868), // Rule ID 11650 //
     /*  719798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  719809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  719812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  719815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719844 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  719844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  719847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719866 */     GIR_RootConstrainSelectedInstOperands,
     /*  719867 */     // GIR_Coverage, 11650,
     /*  719867 */     GIR_EraseRootFromParent_Done,
     /*  719868 */   // Label 11324: @719868
     /*  719868 */   GIM_Try, /*On fail goto*//*Label 11325*/ GIMT_Encode4(719943), // Rule ID 11651 //
     /*  719873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  719876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  719884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  719887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  719890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  719893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  719896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719919 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  719919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16),
     /*  719922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  719926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  719928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  719930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  719935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  719938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  719941 */     GIR_RootConstrainSelectedInstOperands,
     /*  719942 */     // GIR_Coverage, 11651,
     /*  719942 */     GIR_EraseRootFromParent_Done,
     /*  719943 */   // Label 11325: @719943
     /*  719943 */   GIM_Try, /*On fail goto*//*Label 11326*/ GIMT_Encode4(720018), // Rule ID 11654 //
     /*  719948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  719951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  719956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  719959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  719962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  719965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  719968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  719971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  719983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  719987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  719994 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  719994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  719997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  719999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720016 */     GIR_RootConstrainSelectedInstOperands,
     /*  720017 */     // GIR_Coverage, 11654,
     /*  720017 */     GIR_EraseRootFromParent_Done,
     /*  720018 */   // Label 11326: @720018
     /*  720018 */   GIM_Try, /*On fail goto*//*Label 11327*/ GIMT_Encode4(720093), // Rule ID 11655 //
     /*  720023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  720034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  720037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  720040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32),
     /*  720072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720091 */     GIR_RootConstrainSelectedInstOperands,
     /*  720092 */     // GIR_Coverage, 11655,
     /*  720092 */     GIR_EraseRootFromParent_Done,
     /*  720093 */   // Label 11327: @720093
     /*  720093 */   GIM_Try, /*On fail goto*//*Label 11328*/ GIMT_Encode4(720168), // Rule ID 11658 //
     /*  720098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720166 */     GIR_RootConstrainSelectedInstOperands,
     /*  720167 */     // GIR_Coverage, 11658,
     /*  720167 */     GIR_EraseRootFromParent_Done,
     /*  720168 */   // Label 11328: @720168
     /*  720168 */   GIM_Try, /*On fail goto*//*Label 11329*/ GIMT_Encode4(720243), // Rule ID 11659 //
     /*  720173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  720184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  720187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  720190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11114:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8),
     /*  720222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720241 */     GIR_RootConstrainSelectedInstOperands,
     /*  720242 */     // GIR_Coverage, 11659,
     /*  720242 */     GIR_EraseRootFromParent_Done,
     /*  720243 */   // Label 11329: @720243
     /*  720243 */   GIM_Try, /*On fail goto*//*Label 11330*/ GIMT_Encode4(720318), // Rule ID 11662 //
     /*  720248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720294 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  720294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720316 */     GIR_RootConstrainSelectedInstOperands,
     /*  720317 */     // GIR_Coverage, 11662,
     /*  720317 */     GIR_EraseRootFromParent_Done,
     /*  720318 */   // Label 11330: @720318
     /*  720318 */   GIM_Try, /*On fail goto*//*Label 11331*/ GIMT_Encode4(720393), // Rule ID 11663 //
     /*  720323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  720334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  720337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  720340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720369 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11114:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  720369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16),
     /*  720372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  720388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720391 */     GIR_RootConstrainSelectedInstOperands,
     /*  720392 */     // GIR_Coverage, 11663,
     /*  720392 */     GIR_EraseRootFromParent_Done,
     /*  720393 */   // Label 11331: @720393
     /*  720393 */   GIM_Try, /*On fail goto*//*Label 11332*/ GIMT_Encode4(720468), // Rule ID 11666 //
     /*  720398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  720415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  720444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  720447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720466 */     GIR_RootConstrainSelectedInstOperands,
     /*  720467 */     // GIR_Coverage, 11666,
     /*  720467 */     GIR_EraseRootFromParent_Done,
     /*  720468 */   // Label 11332: @720468
     /*  720468 */   GIM_Try, /*On fail goto*//*Label 11333*/ GIMT_Encode4(720543), // Rule ID 11667 //
     /*  720473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  720484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  720487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  720490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11114:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  720519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32),
     /*  720522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  720538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720541 */     GIR_RootConstrainSelectedInstOperands,
     /*  720542 */     // GIR_Coverage, 11667,
     /*  720542 */     GIR_EraseRootFromParent_Done,
     /*  720543 */   // Label 11333: @720543
     /*  720543 */   GIM_Try, /*On fail goto*//*Label 11334*/ GIMT_Encode4(720618), // Rule ID 11670 //
     /*  720548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  720551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  720559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  720562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  720565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  720594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  720597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720616 */     GIR_RootConstrainSelectedInstOperands,
     /*  720617 */     // GIR_Coverage, 11670,
     /*  720617 */     GIR_EraseRootFromParent_Done,
     /*  720618 */   // Label 11334: @720618
     /*  720618 */   GIM_Try, /*On fail goto*//*Label 11335*/ GIMT_Encode4(720693), // Rule ID 11671 //
     /*  720623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  720626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  720634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  720637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  720640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  720658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720669 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11114:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  720669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64),
     /*  720672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  720688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720691 */     GIR_RootConstrainSelectedInstOperands,
     /*  720692 */     // GIR_Coverage, 11671,
     /*  720692 */     GIR_EraseRootFromParent_Done,
     /*  720693 */   // Label 11335: @720693
     /*  720693 */   GIM_Try, /*On fail goto*//*Label 11336*/ GIMT_Encode4(720768), // Rule ID 11674 //
     /*  720698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  720709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  720712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  720715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720744 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  720747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720766 */     GIR_RootConstrainSelectedInstOperands,
     /*  720767 */     // GIR_Coverage, 11674,
     /*  720767 */     GIR_EraseRootFromParent_Done,
     /*  720768 */   // Label 11336: @720768
     /*  720768 */   GIM_Try, /*On fail goto*//*Label 11337*/ GIMT_Encode4(720843), // Rule ID 11675 //
     /*  720773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  720784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  720787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  720790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  720808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720819 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8),
     /*  720822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720841 */     GIR_RootConstrainSelectedInstOperands,
     /*  720842 */     // GIR_Coverage, 11675,
     /*  720842 */     GIR_EraseRootFromParent_Done,
     /*  720843 */   // Label 11337: @720843
     /*  720843 */   GIM_Try, /*On fail goto*//*Label 11338*/ GIMT_Encode4(720918), // Rule ID 11678 //
     /*  720848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  720851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  720859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  720862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  720865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  720868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  720871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720894 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  720894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  720897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720916 */     GIR_RootConstrainSelectedInstOperands,
     /*  720917 */     // GIR_Coverage, 11678,
     /*  720917 */     GIR_EraseRootFromParent_Done,
     /*  720918 */   // Label 11338: @720918
     /*  720918 */   GIM_Try, /*On fail goto*//*Label 11339*/ GIMT_Encode4(720993), // Rule ID 11679 //
     /*  720923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  720926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  720931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  720934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  720937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  720940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  720943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  720946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  720958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  720962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  720969 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  720969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8),
     /*  720972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  720974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  720976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  720978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  720980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  720985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  720988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  720991 */     GIR_RootConstrainSelectedInstOperands,
     /*  720992 */     // GIR_Coverage, 11679,
     /*  720992 */     GIR_EraseRootFromParent_Done,
     /*  720993 */   // Label 11339: @720993
     /*  720993 */   GIM_Try, /*On fail goto*//*Label 11340*/ GIMT_Encode4(721068), // Rule ID 11682 //
     /*  720998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721044 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  721044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721066 */     GIR_RootConstrainSelectedInstOperands,
     /*  721067 */     // GIR_Coverage, 11682,
     /*  721067 */     GIR_EraseRootFromParent_Done,
     /*  721068 */   // Label 11340: @721068
     /*  721068 */   GIM_Try, /*On fail goto*//*Label 11341*/ GIMT_Encode4(721143), // Rule ID 11683 //
     /*  721073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  721084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  721087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  721090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721119 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  721119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8),
     /*  721122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  721138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721141 */     GIR_RootConstrainSelectedInstOperands,
     /*  721142 */     // GIR_Coverage, 11683,
     /*  721142 */     GIR_EraseRootFromParent_Done,
     /*  721143 */   // Label 11341: @721143
     /*  721143 */   GIM_Try, /*On fail goto*//*Label 11342*/ GIMT_Encode4(721218), // Rule ID 11686 //
     /*  721148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721194 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721216 */     GIR_RootConstrainSelectedInstOperands,
     /*  721217 */     // GIR_Coverage, 11686,
     /*  721217 */     GIR_EraseRootFromParent_Done,
     /*  721218 */   // Label 11342: @721218
     /*  721218 */   GIM_Try, /*On fail goto*//*Label 11343*/ GIMT_Encode4(721293), // Rule ID 11687 //
     /*  721223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  721234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  721237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  721240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721269 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16),
     /*  721272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721291 */     GIR_RootConstrainSelectedInstOperands,
     /*  721292 */     // GIR_Coverage, 11687,
     /*  721292 */     GIR_EraseRootFromParent_Done,
     /*  721293 */   // Label 11343: @721293
     /*  721293 */   GIM_Try, /*On fail goto*//*Label 11344*/ GIMT_Encode4(721368), // Rule ID 11690 //
     /*  721298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721366 */     GIR_RootConstrainSelectedInstOperands,
     /*  721367 */     // GIR_Coverage, 11690,
     /*  721367 */     GIR_EraseRootFromParent_Done,
     /*  721368 */   // Label 11344: @721368
     /*  721368 */   GIM_Try, /*On fail goto*//*Label 11345*/ GIMT_Encode4(721443), // Rule ID 11691 //
     /*  721373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  721384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  721387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  721390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721419 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16),
     /*  721422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721441 */     GIR_RootConstrainSelectedInstOperands,
     /*  721442 */     // GIR_Coverage, 11691,
     /*  721442 */     GIR_EraseRootFromParent_Done,
     /*  721443 */   // Label 11345: @721443
     /*  721443 */   GIM_Try, /*On fail goto*//*Label 11346*/ GIMT_Encode4(721518), // Rule ID 11694 //
     /*  721448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  721459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  721462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  721465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  721494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  721497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721516 */     GIR_RootConstrainSelectedInstOperands,
     /*  721517 */     // GIR_Coverage, 11694,
     /*  721517 */     GIR_EraseRootFromParent_Done,
     /*  721518 */   // Label 11346: @721518
     /*  721518 */   GIM_Try, /*On fail goto*//*Label 11347*/ GIMT_Encode4(721593), // Rule ID 11695 //
     /*  721523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  721534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  721537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  721540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721569 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  721569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16),
     /*  721572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  721588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721591 */     GIR_RootConstrainSelectedInstOperands,
     /*  721592 */     // GIR_Coverage, 11695,
     /*  721592 */     GIR_EraseRootFromParent_Done,
     /*  721593 */   // Label 11347: @721593
     /*  721593 */   GIM_Try, /*On fail goto*//*Label 11348*/ GIMT_Encode4(721668), // Rule ID 11698 //
     /*  721598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  721609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  721612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  721615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  721647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721666 */     GIR_RootConstrainSelectedInstOperands,
     /*  721667 */     // GIR_Coverage, 11698,
     /*  721667 */     GIR_EraseRootFromParent_Done,
     /*  721668 */   // Label 11348: @721668
     /*  721668 */   GIM_Try, /*On fail goto*//*Label 11349*/ GIMT_Encode4(721743), // Rule ID 11699 //
     /*  721673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  721684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  721687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  721690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  721708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721719 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32),
     /*  721722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721741 */     GIR_RootConstrainSelectedInstOperands,
     /*  721742 */     // GIR_Coverage, 11699,
     /*  721742 */     GIR_EraseRootFromParent_Done,
     /*  721743 */   // Label 11349: @721743
     /*  721743 */   GIM_Try, /*On fail goto*//*Label 11350*/ GIMT_Encode4(721818), // Rule ID 11702 //
     /*  721748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  721759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  721762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  721765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  721797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721816 */     GIR_RootConstrainSelectedInstOperands,
     /*  721817 */     // GIR_Coverage, 11702,
     /*  721817 */     GIR_EraseRootFromParent_Done,
     /*  721818 */   // Label 11350: @721818
     /*  721818 */   GIM_Try, /*On fail goto*//*Label 11351*/ GIMT_Encode4(721893), // Rule ID 11703 //
     /*  721823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  721834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  721837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  721840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  721858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721869 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  721869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32),
     /*  721872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721891 */     GIR_RootConstrainSelectedInstOperands,
     /*  721892 */     // GIR_Coverage, 11703,
     /*  721892 */     GIR_EraseRootFromParent_Done,
     /*  721893 */   // Label 11351: @721893
     /*  721893 */   GIM_Try, /*On fail goto*//*Label 11352*/ GIMT_Encode4(721968), // Rule ID 11706 //
     /*  721898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  721901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  721909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  721912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  721915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  721918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  721921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  721933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  721937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  721944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  721944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  721947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  721949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  721951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  721953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  721955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  721960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  721963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  721966 */     GIR_RootConstrainSelectedInstOperands,
     /*  721967 */     // GIR_Coverage, 11706,
     /*  721967 */     GIR_EraseRootFromParent_Done,
     /*  721968 */   // Label 11352: @721968
     /*  721968 */   GIM_Try, /*On fail goto*//*Label 11353*/ GIMT_Encode4(722043), // Rule ID 11707 //
     /*  721973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  721976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  721981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  721984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  721987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  721990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  721993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  721996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722019 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  722019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32),
     /*  722022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  722038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722041 */     GIR_RootConstrainSelectedInstOperands,
     /*  722042 */     // GIR_Coverage, 11707,
     /*  722042 */     GIR_EraseRootFromParent_Done,
     /*  722043 */   // Label 11353: @722043
     /*  722043 */   GIM_Try, /*On fail goto*//*Label 11354*/ GIMT_Encode4(722118), // Rule ID 11710 //
     /*  722048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722116 */     GIR_RootConstrainSelectedInstOperands,
     /*  722117 */     // GIR_Coverage, 11710,
     /*  722117 */     GIR_EraseRootFromParent_Done,
     /*  722118 */   // Label 11354: @722118
     /*  722118 */   GIM_Try, /*On fail goto*//*Label 11355*/ GIMT_Encode4(722193), // Rule ID 11711 //
     /*  722123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  722134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  722137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  722140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  722158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722169 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11114:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64),
     /*  722172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722191 */     GIR_RootConstrainSelectedInstOperands,
     /*  722192 */     // GIR_Coverage, 11711,
     /*  722192 */     GIR_EraseRootFromParent_Done,
     /*  722193 */   // Label 11355: @722193
     /*  722193 */   GIM_Try, /*On fail goto*//*Label 11356*/ GIMT_Encode4(722268), // Rule ID 11714 //
     /*  722198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722266 */     GIR_RootConstrainSelectedInstOperands,
     /*  722267 */     // GIR_Coverage, 11714,
     /*  722267 */     GIR_EraseRootFromParent_Done,
     /*  722268 */   // Label 11356: @722268
     /*  722268 */   GIM_Try, /*On fail goto*//*Label 11357*/ GIMT_Encode4(722343), // Rule ID 11715 //
     /*  722273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  722284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  722287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  722290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  722308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722319 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11114:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64),
     /*  722322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722341 */     GIR_RootConstrainSelectedInstOperands,
     /*  722342 */     // GIR_Coverage, 11715,
     /*  722342 */     GIR_EraseRootFromParent_Done,
     /*  722343 */   // Label 11357: @722343
     /*  722343 */   GIM_Try, /*On fail goto*//*Label 11358*/ GIMT_Encode4(722418), // Rule ID 11718 //
     /*  722348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  722351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  722368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722394 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  722394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722416 */     GIR_RootConstrainSelectedInstOperands,
     /*  722417 */     // GIR_Coverage, 11718,
     /*  722417 */     GIR_EraseRootFromParent_Done,
     /*  722418 */   // Label 11358: @722418
     /*  722418 */   GIM_Try, /*On fail goto*//*Label 11359*/ GIMT_Encode4(722493), // Rule ID 11719 //
     /*  722423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  722426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu),
     /*  722431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  722434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  722437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  722440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  722443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  722458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  722462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722469 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11114:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIVU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  722469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64),
     /*  722472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  722488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722491 */     GIR_RootConstrainSelectedInstOperands,
     /*  722492 */     // GIR_Coverage, 11719,
     /*  722492 */     GIR_EraseRootFromParent_Done,
     /*  722493 */   // Label 11359: @722493
     /*  722493 */   GIM_Try, /*On fail goto*//*Label 11360*/ GIMT_Encode4(722568), // Rule ID 11722 //
     /*  722498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  722509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  722512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  722515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  722518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  722547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722566 */     GIR_RootConstrainSelectedInstOperands,
     /*  722567 */     // GIR_Coverage, 11722,
     /*  722567 */     GIR_EraseRootFromParent_Done,
     /*  722568 */   // Label 11360: @722568
     /*  722568 */   GIM_Try, /*On fail goto*//*Label 11361*/ GIMT_Encode4(722643), // Rule ID 11723 //
     /*  722573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  722584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  722587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  722590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  722593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722619 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8),
     /*  722622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722641 */     GIR_RootConstrainSelectedInstOperands,
     /*  722642 */     // GIR_Coverage, 11723,
     /*  722642 */     GIR_EraseRootFromParent_Done,
     /*  722643 */   // Label 11361: @722643
     /*  722643 */   GIM_Try, /*On fail goto*//*Label 11362*/ GIMT_Encode4(722718), // Rule ID 11726 //
     /*  722648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  722659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  722662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  722665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  722668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  722697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722716 */     GIR_RootConstrainSelectedInstOperands,
     /*  722717 */     // GIR_Coverage, 11726,
     /*  722717 */     GIR_EraseRootFromParent_Done,
     /*  722718 */   // Label 11362: @722718
     /*  722718 */   GIM_Try, /*On fail goto*//*Label 11363*/ GIMT_Encode4(722793), // Rule ID 11727 //
     /*  722723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  722734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  722737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  722740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  722743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722769 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8),
     /*  722772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722791 */     GIR_RootConstrainSelectedInstOperands,
     /*  722792 */     // GIR_Coverage, 11727,
     /*  722792 */     GIR_EraseRootFromParent_Done,
     /*  722793 */   // Label 11363: @722793
     /*  722793 */   GIM_Try, /*On fail goto*//*Label 11364*/ GIMT_Encode4(722868), // Rule ID 11730 //
     /*  722798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  722809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  722812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  722815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  722818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722844 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  722844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  722847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722866 */     GIR_RootConstrainSelectedInstOperands,
     /*  722867 */     // GIR_Coverage, 11730,
     /*  722867 */     GIR_EraseRootFromParent_Done,
     /*  722868 */   // Label 11364: @722868
     /*  722868 */   GIM_Try, /*On fail goto*//*Label 11365*/ GIMT_Encode4(722943), // Rule ID 11731 //
     /*  722873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  722876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  722884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  722887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  722890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  722893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  722896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722919 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  722919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8),
     /*  722922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  722926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  722928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  722930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  722935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  722938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  722941 */     GIR_RootConstrainSelectedInstOperands,
     /*  722942 */     // GIR_Coverage, 11731,
     /*  722942 */     GIR_EraseRootFromParent_Done,
     /*  722943 */   // Label 11365: @722943
     /*  722943 */   GIM_Try, /*On fail goto*//*Label 11366*/ GIMT_Encode4(723018), // Rule ID 11734 //
     /*  722948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  722951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  722956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  722959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  722962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  722965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  722968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  722971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  722987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  722994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  722994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  722997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  722999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723016 */     GIR_RootConstrainSelectedInstOperands,
     /*  723017 */     // GIR_Coverage, 11734,
     /*  723017 */     GIR_EraseRootFromParent_Done,
     /*  723018 */   // Label 11366: @723018
     /*  723018 */   GIM_Try, /*On fail goto*//*Label 11367*/ GIMT_Encode4(723093), // Rule ID 11735 //
     /*  723023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  723034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  723037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  723040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  723043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16),
     /*  723072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723091 */     GIR_RootConstrainSelectedInstOperands,
     /*  723092 */     // GIR_Coverage, 11735,
     /*  723092 */     GIR_EraseRootFromParent_Done,
     /*  723093 */   // Label 11367: @723093
     /*  723093 */   GIM_Try, /*On fail goto*//*Label 11368*/ GIMT_Encode4(723168), // Rule ID 11738 //
     /*  723098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723166 */     GIR_RootConstrainSelectedInstOperands,
     /*  723167 */     // GIR_Coverage, 11738,
     /*  723167 */     GIR_EraseRootFromParent_Done,
     /*  723168 */   // Label 11368: @723168
     /*  723168 */   GIM_Try, /*On fail goto*//*Label 11369*/ GIMT_Encode4(723243), // Rule ID 11739 //
     /*  723173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  723184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  723187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  723190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  723193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723219 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16),
     /*  723222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723241 */     GIR_RootConstrainSelectedInstOperands,
     /*  723242 */     // GIR_Coverage, 11739,
     /*  723242 */     GIR_EraseRootFromParent_Done,
     /*  723243 */   // Label 11369: @723243
     /*  723243 */   GIM_Try, /*On fail goto*//*Label 11370*/ GIMT_Encode4(723318), // Rule ID 11742 //
     /*  723248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  723294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723316 */     GIR_RootConstrainSelectedInstOperands,
     /*  723317 */     // GIR_Coverage, 11742,
     /*  723317 */     GIR_EraseRootFromParent_Done,
     /*  723318 */   // Label 11370: @723318
     /*  723318 */   GIM_Try, /*On fail goto*//*Label 11371*/ GIMT_Encode4(723393), // Rule ID 11743 //
     /*  723323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  723334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  723337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  723340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  723343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723369 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32),
     /*  723372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723391 */     GIR_RootConstrainSelectedInstOperands,
     /*  723392 */     // GIR_Coverage, 11743,
     /*  723392 */     GIR_EraseRootFromParent_Done,
     /*  723393 */   // Label 11371: @723393
     /*  723393 */   GIM_Try, /*On fail goto*//*Label 11372*/ GIMT_Encode4(723468), // Rule ID 11746 //
     /*  723398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  723415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723444 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  723444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  723447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723466 */     GIR_RootConstrainSelectedInstOperands,
     /*  723467 */     // GIR_Coverage, 11746,
     /*  723467 */     GIR_EraseRootFromParent_Done,
     /*  723468 */   // Label 11372: @723468
     /*  723468 */   GIM_Try, /*On fail goto*//*Label 11373*/ GIMT_Encode4(723543), // Rule ID 11747 //
     /*  723473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  723484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  723487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  723490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  723493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723519 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  723519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8),
     /*  723522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  723538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723541 */     GIR_RootConstrainSelectedInstOperands,
     /*  723542 */     // GIR_Coverage, 11747,
     /*  723542 */     GIR_EraseRootFromParent_Done,
     /*  723543 */   // Label 11373: @723543
     /*  723543 */   GIM_Try, /*On fail goto*//*Label 11374*/ GIMT_Encode4(723618), // Rule ID 11750 //
     /*  723548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  723565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  723594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  723597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723616 */     GIR_RootConstrainSelectedInstOperands,
     /*  723617 */     // GIR_Coverage, 11750,
     /*  723617 */     GIR_EraseRootFromParent_Done,
     /*  723618 */   // Label 11374: @723618
     /*  723618 */   GIM_Try, /*On fail goto*//*Label 11375*/ GIMT_Encode4(723693), // Rule ID 11751 //
     /*  723623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  723634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  723637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  723640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  723643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723669 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  723669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16),
     /*  723672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  723688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723691 */     GIR_RootConstrainSelectedInstOperands,
     /*  723692 */     // GIR_Coverage, 11751,
     /*  723692 */     GIR_EraseRootFromParent_Done,
     /*  723693 */   // Label 11375: @723693
     /*  723693 */   GIM_Try, /*On fail goto*//*Label 11376*/ GIMT_Encode4(723768), // Rule ID 11754 //
     /*  723698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  723701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  723709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  723712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  723715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  723718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  723744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  723747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723766 */     GIR_RootConstrainSelectedInstOperands,
     /*  723767 */     // GIR_Coverage, 11754,
     /*  723767 */     GIR_EraseRootFromParent_Done,
     /*  723768 */   // Label 11376: @723768
     /*  723768 */   GIM_Try, /*On fail goto*//*Label 11377*/ GIMT_Encode4(723843), // Rule ID 11755 //
     /*  723773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  723776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  723784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  723787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  723790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  723793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  723819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32),
     /*  723822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  723838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723841 */     GIR_RootConstrainSelectedInstOperands,
     /*  723842 */     // GIR_Coverage, 11755,
     /*  723842 */     GIR_EraseRootFromParent_Done,
     /*  723843 */   // Label 11377: @723843
     /*  723843 */   GIM_Try, /*On fail goto*//*Label 11378*/ GIMT_Encode4(723918), // Rule ID 11758 //
     /*  723848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  723851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  723859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  723862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  723865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  723868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  723871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723894 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  723894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  723897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723916 */     GIR_RootConstrainSelectedInstOperands,
     /*  723917 */     // GIR_Coverage, 11758,
     /*  723917 */     GIR_EraseRootFromParent_Done,
     /*  723918 */   // Label 11378: @723918
     /*  723918 */   GIM_Try, /*On fail goto*//*Label 11379*/ GIMT_Encode4(723993), // Rule ID 11759 //
     /*  723923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  723926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  723931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  723934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  723937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  723940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  723943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  723946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  723962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  723969 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  723969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64),
     /*  723972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  723974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  723976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  723978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  723980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  723985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  723988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  723991 */     GIR_RootConstrainSelectedInstOperands,
     /*  723992 */     // GIR_Coverage, 11759,
     /*  723992 */     GIR_EraseRootFromParent_Done,
     /*  723993 */   // Label 11379: @723993
     /*  723993 */   GIM_Try, /*On fail goto*//*Label 11380*/ GIMT_Encode4(724068), // Rule ID 11762 //
     /*  723998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724066 */     GIR_RootConstrainSelectedInstOperands,
     /*  724067 */     // GIR_Coverage, 11762,
     /*  724067 */     GIR_EraseRootFromParent_Done,
     /*  724068 */   // Label 11380: @724068
     /*  724068 */   GIM_Try, /*On fail goto*//*Label 11381*/ GIMT_Encode4(724143), // Rule ID 11763 //
     /*  724073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  724084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  724087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  724090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  724093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8),
     /*  724122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724141 */     GIR_RootConstrainSelectedInstOperands,
     /*  724142 */     // GIR_Coverage, 11763,
     /*  724142 */     GIR_EraseRootFromParent_Done,
     /*  724143 */   // Label 11381: @724143
     /*  724143 */   GIM_Try, /*On fail goto*//*Label 11382*/ GIMT_Encode4(724218), // Rule ID 11766 //
     /*  724148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724194 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724216 */     GIR_RootConstrainSelectedInstOperands,
     /*  724217 */     // GIR_Coverage, 11766,
     /*  724217 */     GIR_EraseRootFromParent_Done,
     /*  724218 */   // Label 11382: @724218
     /*  724218 */   GIM_Try, /*On fail goto*//*Label 11383*/ GIMT_Encode4(724293), // Rule ID 11767 //
     /*  724223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  724234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  724237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  724240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  724243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724269 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8),
     /*  724272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724291 */     GIR_RootConstrainSelectedInstOperands,
     /*  724292 */     // GIR_Coverage, 11767,
     /*  724292 */     GIR_EraseRootFromParent_Done,
     /*  724293 */   // Label 11383: @724293
     /*  724293 */   GIM_Try, /*On fail goto*//*Label 11384*/ GIMT_Encode4(724368), // Rule ID 11770 //
     /*  724298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724344 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  724344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724366 */     GIR_RootConstrainSelectedInstOperands,
     /*  724367 */     // GIR_Coverage, 11770,
     /*  724367 */     GIR_EraseRootFromParent_Done,
     /*  724368 */   // Label 11384: @724368
     /*  724368 */   GIM_Try, /*On fail goto*//*Label 11385*/ GIMT_Encode4(724443), // Rule ID 11771 //
     /*  724373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  724384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  724387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  724390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  724393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  724419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8),
     /*  724422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  724438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724441 */     GIR_RootConstrainSelectedInstOperands,
     /*  724442 */     // GIR_Coverage, 11771,
     /*  724442 */     GIR_EraseRootFromParent_Done,
     /*  724443 */   // Label 11385: @724443
     /*  724443 */   GIM_Try, /*On fail goto*//*Label 11386*/ GIMT_Encode4(724518), // Rule ID 11774 //
     /*  724448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  724459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  724462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  724465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  724468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  724497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724516 */     GIR_RootConstrainSelectedInstOperands,
     /*  724517 */     // GIR_Coverage, 11774,
     /*  724517 */     GIR_EraseRootFromParent_Done,
     /*  724518 */   // Label 11386: @724518
     /*  724518 */   GIM_Try, /*On fail goto*//*Label 11387*/ GIMT_Encode4(724593), // Rule ID 11775 //
     /*  724523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  724534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  724537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  724540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  724543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16),
     /*  724572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724591 */     GIR_RootConstrainSelectedInstOperands,
     /*  724592 */     // GIR_Coverage, 11775,
     /*  724592 */     GIR_EraseRootFromParent_Done,
     /*  724593 */   // Label 11387: @724593
     /*  724593 */   GIM_Try, /*On fail goto*//*Label 11388*/ GIMT_Encode4(724668), // Rule ID 11778 //
     /*  724598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  724609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  724612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  724615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  724618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724644 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  724647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724666 */     GIR_RootConstrainSelectedInstOperands,
     /*  724667 */     // GIR_Coverage, 11778,
     /*  724667 */     GIR_EraseRootFromParent_Done,
     /*  724668 */   // Label 11388: @724668
     /*  724668 */   GIM_Try, /*On fail goto*//*Label 11389*/ GIMT_Encode4(724743), // Rule ID 11779 //
     /*  724673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  724684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  724687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  724690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  724693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  724712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724719 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16),
     /*  724722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724741 */     GIR_RootConstrainSelectedInstOperands,
     /*  724742 */     // GIR_Coverage, 11779,
     /*  724742 */     GIR_EraseRootFromParent_Done,
     /*  724743 */   // Label 11389: @724743
     /*  724743 */   GIM_Try, /*On fail goto*//*Label 11390*/ GIMT_Encode4(724818), // Rule ID 11782 //
     /*  724748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  724759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  724762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  724765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  724768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724794 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  724794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  724797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724816 */     GIR_RootConstrainSelectedInstOperands,
     /*  724817 */     // GIR_Coverage, 11782,
     /*  724817 */     GIR_EraseRootFromParent_Done,
     /*  724818 */   // Label 11390: @724818
     /*  724818 */   GIM_Try, /*On fail goto*//*Label 11391*/ GIMT_Encode4(724893), // Rule ID 11783 //
     /*  724823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  724834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  724837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  724840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  724843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  724862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724869 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  724869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16),
     /*  724872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  724888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724891 */     GIR_RootConstrainSelectedInstOperands,
     /*  724892 */     // GIR_Coverage, 11783,
     /*  724892 */     GIR_EraseRootFromParent_Done,
     /*  724893 */   // Label 11391: @724893
     /*  724893 */   GIM_Try, /*On fail goto*//*Label 11392*/ GIMT_Encode4(724968), // Rule ID 11786 //
     /*  724898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  724901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  724909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  724912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  724915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  724918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  724921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  724937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  724944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  724944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  724947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  724949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  724951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  724953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  724955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  724960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  724963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  724966 */     GIR_RootConstrainSelectedInstOperands,
     /*  724967 */     // GIR_Coverage, 11786,
     /*  724967 */     GIR_EraseRootFromParent_Done,
     /*  724968 */   // Label 11392: @724968
     /*  724968 */   GIM_Try, /*On fail goto*//*Label 11393*/ GIMT_Encode4(725043), // Rule ID 11787 //
     /*  724973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  724976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  724981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  724984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  724987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  724990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  724993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  724996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725019 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32),
     /*  725022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725041 */     GIR_RootConstrainSelectedInstOperands,
     /*  725042 */     // GIR_Coverage, 11787,
     /*  725042 */     GIR_EraseRootFromParent_Done,
     /*  725043 */   // Label 11393: @725043
     /*  725043 */   GIM_Try, /*On fail goto*//*Label 11394*/ GIMT_Encode4(725118), // Rule ID 11790 //
     /*  725048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725116 */     GIR_RootConstrainSelectedInstOperands,
     /*  725117 */     // GIR_Coverage, 11790,
     /*  725117 */     GIR_EraseRootFromParent_Done,
     /*  725118 */   // Label 11394: @725118
     /*  725118 */   GIM_Try, /*On fail goto*//*Label 11395*/ GIMT_Encode4(725193), // Rule ID 11791 //
     /*  725123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  725134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  725137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  725140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  725143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32),
     /*  725172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725191 */     GIR_RootConstrainSelectedInstOperands,
     /*  725192 */     // GIR_Coverage, 11791,
     /*  725192 */     GIR_EraseRootFromParent_Done,
     /*  725193 */   // Label 11395: @725193
     /*  725193 */   GIM_Try, /*On fail goto*//*Label 11396*/ GIMT_Encode4(725268), // Rule ID 11794 //
     /*  725198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  725244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725266 */     GIR_RootConstrainSelectedInstOperands,
     /*  725267 */     // GIR_Coverage, 11794,
     /*  725267 */     GIR_EraseRootFromParent_Done,
     /*  725268 */   // Label 11396: @725268
     /*  725268 */   GIM_Try, /*On fail goto*//*Label 11397*/ GIMT_Encode4(725343), // Rule ID 11795 //
     /*  725273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  725284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  725287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  725290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  725293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725319 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  725319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32),
     /*  725322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  725338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725341 */     GIR_RootConstrainSelectedInstOperands,
     /*  725342 */     // GIR_Coverage, 11795,
     /*  725342 */     GIR_EraseRootFromParent_Done,
     /*  725343 */   // Label 11397: @725343
     /*  725343 */   GIM_Try, /*On fail goto*//*Label 11398*/ GIMT_Encode4(725418), // Rule ID 11798 //
     /*  725348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  725351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  725394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725416 */     GIR_RootConstrainSelectedInstOperands,
     /*  725417 */     // GIR_Coverage, 11798,
     /*  725417 */     GIR_EraseRootFromParent_Done,
     /*  725418 */   // Label 11398: @725418
     /*  725418 */   GIM_Try, /*On fail goto*//*Label 11399*/ GIMT_Encode4(725493), // Rule ID 11799 //
     /*  725423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  725426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  725434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  725437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  725440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  725443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  725462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64),
     /*  725472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725491 */     GIR_RootConstrainSelectedInstOperands,
     /*  725492 */     // GIR_Coverage, 11799,
     /*  725492 */     GIR_EraseRootFromParent_Done,
     /*  725493 */   // Label 11399: @725493
     /*  725493 */   GIM_Try, /*On fail goto*//*Label 11400*/ GIMT_Encode4(725568), // Rule ID 11802 //
     /*  725498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  725501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  725509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  725512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  725515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  725518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  725544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  725547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725566 */     GIR_RootConstrainSelectedInstOperands,
     /*  725567 */     // GIR_Coverage, 11802,
     /*  725567 */     GIR_EraseRootFromParent_Done,
     /*  725568 */   // Label 11400: @725568
     /*  725568 */   GIM_Try, /*On fail goto*//*Label 11401*/ GIMT_Encode4(725643), // Rule ID 11803 //
     /*  725573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  725576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  725584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  725587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  725590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  725593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  725612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64),
     /*  725622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725641 */     GIR_RootConstrainSelectedInstOperands,
     /*  725642 */     // GIR_Coverage, 11803,
     /*  725642 */     GIR_EraseRootFromParent_Done,
     /*  725643 */   // Label 11401: @725643
     /*  725643 */   GIM_Try, /*On fail goto*//*Label 11402*/ GIMT_Encode4(725718), // Rule ID 11806 //
     /*  725648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  725651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  725659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  725662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  725665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  725668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  725694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  725697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725716 */     GIR_RootConstrainSelectedInstOperands,
     /*  725717 */     // GIR_Coverage, 11806,
     /*  725717 */     GIR_EraseRootFromParent_Done,
     /*  725718 */   // Label 11402: @725718
     /*  725718 */   GIM_Try, /*On fail goto*//*Label 11403*/ GIMT_Encode4(725793), // Rule ID 11807 //
     /*  725723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  725726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  725734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  725737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  725740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  725743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  725762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  725769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64),
     /*  725772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  725788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725791 */     GIR_RootConstrainSelectedInstOperands,
     /*  725792 */     // GIR_Coverage, 11807,
     /*  725792 */     GIR_EraseRootFromParent_Done,
     /*  725793 */   // Label 11403: @725793
     /*  725793 */   GIM_Try, /*On fail goto*//*Label 11404*/ GIMT_Encode4(725868), // Rule ID 11810 //
     /*  725798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  725809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  725812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  725815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  725847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725866 */     GIR_RootConstrainSelectedInstOperands,
     /*  725867 */     // GIR_Coverage, 11810,
     /*  725867 */     GIR_EraseRootFromParent_Done,
     /*  725868 */   // Label 11404: @725868
     /*  725868 */   GIM_Try, /*On fail goto*//*Label 11405*/ GIMT_Encode4(725943), // Rule ID 11811 //
     /*  725873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  725876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  725884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  725887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  725890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  725893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  725896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725919 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  725919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8),
     /*  725922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  725926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  725928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  725930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  725935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  725938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  725941 */     GIR_RootConstrainSelectedInstOperands,
     /*  725942 */     // GIR_Coverage, 11811,
     /*  725942 */     GIR_EraseRootFromParent_Done,
     /*  725943 */   // Label 11405: @725943
     /*  725943 */   GIM_Try, /*On fail goto*//*Label 11406*/ GIMT_Encode4(726018), // Rule ID 11814 //
     /*  725948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  725951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  725956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  725959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  725962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  725965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  725968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  725971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  725983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  725987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  725994 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  725994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  725997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  725999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726016 */     GIR_RootConstrainSelectedInstOperands,
     /*  726017 */     // GIR_Coverage, 11814,
     /*  726017 */     GIR_EraseRootFromParent_Done,
     /*  726018 */   // Label 11406: @726018
     /*  726018 */   GIM_Try, /*On fail goto*//*Label 11407*/ GIMT_Encode4(726093), // Rule ID 11815 //
     /*  726023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  726034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  726037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  726040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726069 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8),
     /*  726072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726091 */     GIR_RootConstrainSelectedInstOperands,
     /*  726092 */     // GIR_Coverage, 11815,
     /*  726092 */     GIR_EraseRootFromParent_Done,
     /*  726093 */   // Label 11407: @726093
     /*  726093 */   GIM_Try, /*On fail goto*//*Label 11408*/ GIMT_Encode4(726168), // Rule ID 11818 //
     /*  726098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726144 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726166 */     GIR_RootConstrainSelectedInstOperands,
     /*  726167 */     // GIR_Coverage, 11818,
     /*  726167 */     GIR_EraseRootFromParent_Done,
     /*  726168 */   // Label 11408: @726168
     /*  726168 */   GIM_Try, /*On fail goto*//*Label 11409*/ GIMT_Encode4(726243), // Rule ID 11819 //
     /*  726173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  726184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  726187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  726190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726219 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8),
     /*  726222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726241 */     GIR_RootConstrainSelectedInstOperands,
     /*  726242 */     // GIR_Coverage, 11819,
     /*  726242 */     GIR_EraseRootFromParent_Done,
     /*  726243 */   // Label 11409: @726243
     /*  726243 */   GIM_Try, /*On fail goto*//*Label 11410*/ GIMT_Encode4(726318), // Rule ID 11822 //
     /*  726248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726294 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726316 */     GIR_RootConstrainSelectedInstOperands,
     /*  726317 */     // GIR_Coverage, 11822,
     /*  726317 */     GIR_EraseRootFromParent_Done,
     /*  726318 */   // Label 11410: @726318
     /*  726318 */   GIM_Try, /*On fail goto*//*Label 11411*/ GIMT_Encode4(726393), // Rule ID 11823 //
     /*  726323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  726334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  726337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  726340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726369 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16),
     /*  726372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726391 */     GIR_RootConstrainSelectedInstOperands,
     /*  726392 */     // GIR_Coverage, 11823,
     /*  726392 */     GIR_EraseRootFromParent_Done,
     /*  726393 */   // Label 11411: @726393
     /*  726393 */   GIM_Try, /*On fail goto*//*Label 11412*/ GIMT_Encode4(726468), // Rule ID 11826 //
     /*  726398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  726409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  726412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  726415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  726447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726466 */     GIR_RootConstrainSelectedInstOperands,
     /*  726467 */     // GIR_Coverage, 11826,
     /*  726467 */     GIR_EraseRootFromParent_Done,
     /*  726468 */   // Label 11412: @726468
     /*  726468 */   GIM_Try, /*On fail goto*//*Label 11413*/ GIMT_Encode4(726543), // Rule ID 11827 //
     /*  726473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  726484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  726487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  726490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726519 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16),
     /*  726522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726541 */     GIR_RootConstrainSelectedInstOperands,
     /*  726542 */     // GIR_Coverage, 11827,
     /*  726542 */     GIR_EraseRootFromParent_Done,
     /*  726543 */   // Label 11413: @726543
     /*  726543 */   GIM_Try, /*On fail goto*//*Label 11414*/ GIMT_Encode4(726618), // Rule ID 11830 //
     /*  726548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  726559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  726562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  726565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726594 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  726594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  726597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726616 */     GIR_RootConstrainSelectedInstOperands,
     /*  726617 */     // GIR_Coverage, 11830,
     /*  726617 */     GIR_EraseRootFromParent_Done,
     /*  726618 */   // Label 11414: @726618
     /*  726618 */   GIM_Try, /*On fail goto*//*Label 11415*/ GIMT_Encode4(726693), // Rule ID 11831 //
     /*  726623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  726634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  726637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  726640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  726669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32),
     /*  726672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  726688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726691 */     GIR_RootConstrainSelectedInstOperands,
     /*  726692 */     // GIR_Coverage, 11831,
     /*  726692 */     GIR_EraseRootFromParent_Done,
     /*  726693 */   // Label 11415: @726693
     /*  726693 */   GIM_Try, /*On fail goto*//*Label 11416*/ GIMT_Encode4(726768), // Rule ID 11834 //
     /*  726698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  726715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726744 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  726744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  726747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726766 */     GIR_RootConstrainSelectedInstOperands,
     /*  726767 */     // GIR_Coverage, 11834,
     /*  726767 */     GIR_EraseRootFromParent_Done,
     /*  726768 */   // Label 11416: @726768
     /*  726768 */   GIM_Try, /*On fail goto*//*Label 11417*/ GIMT_Encode4(726843), // Rule ID 11835 //
     /*  726773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  726784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  726787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  726790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726819 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11112:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  726819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8),
     /*  726822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  726838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726841 */     GIR_RootConstrainSelectedInstOperands,
     /*  726842 */     // GIR_Coverage, 11835,
     /*  726842 */     GIR_EraseRootFromParent_Done,
     /*  726843 */   // Label 11417: @726843
     /*  726843 */   GIM_Try, /*On fail goto*//*Label 11418*/ GIMT_Encode4(726918), // Rule ID 11838 //
     /*  726848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  726851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  726859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  726862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  726865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  726868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  726871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  726894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  726897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726916 */     GIR_RootConstrainSelectedInstOperands,
     /*  726917 */     // GIR_Coverage, 11838,
     /*  726917 */     GIR_EraseRootFromParent_Done,
     /*  726918 */   // Label 11418: @726918
     /*  726918 */   GIM_Try, /*On fail goto*//*Label 11419*/ GIMT_Encode4(726993), // Rule ID 11839 //
     /*  726923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  726926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  726931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  726934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  726937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  726940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  726943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  726946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  726958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  726962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  726969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11112:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  726969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16),
     /*  726972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  726974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  726976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  726978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  726980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  726985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  726988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  726991 */     GIR_RootConstrainSelectedInstOperands,
     /*  726992 */     // GIR_Coverage, 11839,
     /*  726992 */     GIR_EraseRootFromParent_Done,
     /*  726993 */   // Label 11419: @726993
     /*  726993 */   GIM_Try, /*On fail goto*//*Label 11420*/ GIMT_Encode4(727068), // Rule ID 11842 //
     /*  726998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727044 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  727044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727066 */     GIR_RootConstrainSelectedInstOperands,
     /*  727067 */     // GIR_Coverage, 11842,
     /*  727067 */     GIR_EraseRootFromParent_Done,
     /*  727068 */   // Label 11420: @727068
     /*  727068 */   GIM_Try, /*On fail goto*//*Label 11421*/ GIMT_Encode4(727143), // Rule ID 11843 //
     /*  727073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  727084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  727087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  727090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727119 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11112:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  727119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32),
     /*  727122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  727138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727141 */     GIR_RootConstrainSelectedInstOperands,
     /*  727142 */     // GIR_Coverage, 11843,
     /*  727142 */     GIR_EraseRootFromParent_Done,
     /*  727143 */   // Label 11421: @727143
     /*  727143 */   GIM_Try, /*On fail goto*//*Label 11422*/ GIMT_Encode4(727218), // Rule ID 11846 //
     /*  727148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  727151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  727194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727216 */     GIR_RootConstrainSelectedInstOperands,
     /*  727217 */     // GIR_Coverage, 11846,
     /*  727217 */     GIR_EraseRootFromParent_Done,
     /*  727218 */   // Label 11422: @727218
     /*  727218 */   GIM_Try, /*On fail goto*//*Label 11423*/ GIMT_Encode4(727293), // Rule ID 11847 //
     /*  727223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  727226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  727234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  727237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  727240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  727258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727269 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11112:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  727269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64),
     /*  727272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  727288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727291 */     GIR_RootConstrainSelectedInstOperands,
     /*  727292 */     // GIR_Coverage, 11847,
     /*  727292 */     GIR_EraseRootFromParent_Done,
     /*  727293 */   // Label 11423: @727293
     /*  727293 */   GIM_Try, /*On fail goto*//*Label 11424*/ GIMT_Encode4(727368), // Rule ID 11850 //
     /*  727298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727366 */     GIR_RootConstrainSelectedInstOperands,
     /*  727367 */     // GIR_Coverage, 11850,
     /*  727367 */     GIR_EraseRootFromParent_Done,
     /*  727368 */   // Label 11424: @727368
     /*  727368 */   GIM_Try, /*On fail goto*//*Label 11425*/ GIMT_Encode4(727443), // Rule ID 11851 //
     /*  727373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  727384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  727387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  727390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727419 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8),
     /*  727422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727441 */     GIR_RootConstrainSelectedInstOperands,
     /*  727442 */     // GIR_Coverage, 11851,
     /*  727442 */     GIR_EraseRootFromParent_Done,
     /*  727443 */   // Label 11425: @727443
     /*  727443 */   GIM_Try, /*On fail goto*//*Label 11426*/ GIMT_Encode4(727518), // Rule ID 11854 //
     /*  727448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  727459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  727462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  727465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  727497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727516 */     GIR_RootConstrainSelectedInstOperands,
     /*  727517 */     // GIR_Coverage, 11854,
     /*  727517 */     GIR_EraseRootFromParent_Done,
     /*  727518 */   // Label 11426: @727518
     /*  727518 */   GIM_Try, /*On fail goto*//*Label 11427*/ GIMT_Encode4(727593), // Rule ID 11855 //
     /*  727523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  727534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  727537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  727540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727569 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8),
     /*  727572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727591 */     GIR_RootConstrainSelectedInstOperands,
     /*  727592 */     // GIR_Coverage, 11855,
     /*  727592 */     GIR_EraseRootFromParent_Done,
     /*  727593 */   // Label 11427: @727593
     /*  727593 */   GIM_Try, /*On fail goto*//*Label 11428*/ GIMT_Encode4(727668), // Rule ID 11858 //
     /*  727598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  727609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  727612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  727615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727644 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  727644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  727647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727666 */     GIR_RootConstrainSelectedInstOperands,
     /*  727667 */     // GIR_Coverage, 11858,
     /*  727667 */     GIR_EraseRootFromParent_Done,
     /*  727668 */   // Label 11428: @727668
     /*  727668 */   GIM_Try, /*On fail goto*//*Label 11429*/ GIMT_Encode4(727743), // Rule ID 11859 //
     /*  727673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  727684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  727687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  727690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  727708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  727719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8),
     /*  727722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  727738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727741 */     GIR_RootConstrainSelectedInstOperands,
     /*  727742 */     // GIR_Coverage, 11859,
     /*  727742 */     GIR_EraseRootFromParent_Done,
     /*  727743 */   // Label 11429: @727743
     /*  727743 */   GIM_Try, /*On fail goto*//*Label 11430*/ GIMT_Encode4(727818), // Rule ID 11862 //
     /*  727748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  727759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  727762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  727765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  727797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727816 */     GIR_RootConstrainSelectedInstOperands,
     /*  727817 */     // GIR_Coverage, 11862,
     /*  727817 */     GIR_EraseRootFromParent_Done,
     /*  727818 */   // Label 11430: @727818
     /*  727818 */   GIM_Try, /*On fail goto*//*Label 11431*/ GIMT_Encode4(727893), // Rule ID 11863 //
     /*  727823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  727834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  727837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  727840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  727858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  727869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16),
     /*  727872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727891 */     GIR_RootConstrainSelectedInstOperands,
     /*  727892 */     // GIR_Coverage, 11863,
     /*  727892 */     GIR_EraseRootFromParent_Done,
     /*  727893 */   // Label 11431: @727893
     /*  727893 */   GIM_Try, /*On fail goto*//*Label 11432*/ GIMT_Encode4(727968), // Rule ID 11866 //
     /*  727898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  727901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  727909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  727912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  727915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  727918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  727921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  727933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  727937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  727944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  727944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  727947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  727949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  727951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  727953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  727955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  727960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  727963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  727966 */     GIR_RootConstrainSelectedInstOperands,
     /*  727967 */     // GIR_Coverage, 11866,
     /*  727967 */     GIR_EraseRootFromParent_Done,
     /*  727968 */   // Label 11432: @727968
     /*  727968 */   GIM_Try, /*On fail goto*//*Label 11433*/ GIMT_Encode4(728043), // Rule ID 11867 //
     /*  727973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  727976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  727981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  727984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  727987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  727990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  727993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  727996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16),
     /*  728022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728041 */     GIR_RootConstrainSelectedInstOperands,
     /*  728042 */     // GIR_Coverage, 11867,
     /*  728042 */     GIR_EraseRootFromParent_Done,
     /*  728043 */   // Label 11433: @728043
     /*  728043 */   GIM_Try, /*On fail goto*//*Label 11434*/ GIMT_Encode4(728118), // Rule ID 11870 //
     /*  728048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  728094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728116 */     GIR_RootConstrainSelectedInstOperands,
     /*  728117 */     // GIR_Coverage, 11870,
     /*  728117 */     GIR_EraseRootFromParent_Done,
     /*  728118 */   // Label 11434: @728118
     /*  728118 */   GIM_Try, /*On fail goto*//*Label 11435*/ GIMT_Encode4(728193), // Rule ID 11871 //
     /*  728123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  728134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  728137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  728140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  728169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16),
     /*  728172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  728188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728191 */     GIR_RootConstrainSelectedInstOperands,
     /*  728192 */     // GIR_Coverage, 11871,
     /*  728192 */     GIR_EraseRootFromParent_Done,
     /*  728193 */   // Label 11435: @728193
     /*  728193 */   GIM_Try, /*On fail goto*//*Label 11436*/ GIMT_Encode4(728268), // Rule ID 11874 //
     /*  728198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728266 */     GIR_RootConstrainSelectedInstOperands,
     /*  728267 */     // GIR_Coverage, 11874,
     /*  728267 */     GIR_EraseRootFromParent_Done,
     /*  728268 */   // Label 11436: @728268
     /*  728268 */   GIM_Try, /*On fail goto*//*Label 11437*/ GIMT_Encode4(728343), // Rule ID 11875 //
     /*  728273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  728284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  728287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  728290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32),
     /*  728322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728341 */     GIR_RootConstrainSelectedInstOperands,
     /*  728342 */     // GIR_Coverage, 11875,
     /*  728342 */     GIR_EraseRootFromParent_Done,
     /*  728343 */   // Label 11437: @728343
     /*  728343 */   GIM_Try, /*On fail goto*//*Label 11438*/ GIMT_Encode4(728418), // Rule ID 11878 //
     /*  728348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728394 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728416 */     GIR_RootConstrainSelectedInstOperands,
     /*  728417 */     // GIR_Coverage, 11878,
     /*  728417 */     GIR_EraseRootFromParent_Done,
     /*  728418 */   // Label 11438: @728418
     /*  728418 */   GIM_Try, /*On fail goto*//*Label 11439*/ GIMT_Encode4(728493), // Rule ID 11879 //
     /*  728423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  728434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  728437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  728440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728469 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32),
     /*  728472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728491 */     GIR_RootConstrainSelectedInstOperands,
     /*  728492 */     // GIR_Coverage, 11879,
     /*  728492 */     GIR_EraseRootFromParent_Done,
     /*  728493 */   // Label 11439: @728493
     /*  728493 */   GIM_Try, /*On fail goto*//*Label 11440*/ GIMT_Encode4(728568), // Rule ID 11882 //
     /*  728498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  728501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  728509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  728512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  728515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  728544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  728547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728566 */     GIR_RootConstrainSelectedInstOperands,
     /*  728567 */     // GIR_Coverage, 11882,
     /*  728567 */     GIR_EraseRootFromParent_Done,
     /*  728568 */   // Label 11440: @728568
     /*  728568 */   GIM_Try, /*On fail goto*//*Label 11441*/ GIMT_Encode4(728643), // Rule ID 11883 //
     /*  728573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  728576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  728584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  728587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  728590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728619 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  728619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32),
     /*  728622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  728638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728641 */     GIR_RootConstrainSelectedInstOperands,
     /*  728642 */     // GIR_Coverage, 11883,
     /*  728642 */     GIR_EraseRootFromParent_Done,
     /*  728643 */   // Label 11441: @728643
     /*  728643 */   GIM_Try, /*On fail goto*//*Label 11442*/ GIMT_Encode4(728718), // Rule ID 11886 //
     /*  728648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  728659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  728662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  728665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728694 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  728697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728716 */     GIR_RootConstrainSelectedInstOperands,
     /*  728717 */     // GIR_Coverage, 11886,
     /*  728717 */     GIR_EraseRootFromParent_Done,
     /*  728718 */   // Label 11442: @728718
     /*  728718 */   GIM_Try, /*On fail goto*//*Label 11443*/ GIMT_Encode4(728793), // Rule ID 11887 //
     /*  728723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  728734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  728737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  728740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  728758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11112:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64),
     /*  728772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728791 */     GIR_RootConstrainSelectedInstOperands,
     /*  728792 */     // GIR_Coverage, 11887,
     /*  728792 */     GIR_EraseRootFromParent_Done,
     /*  728793 */   // Label 11443: @728793
     /*  728793 */   GIM_Try, /*On fail goto*//*Label 11444*/ GIMT_Encode4(728868), // Rule ID 11890 //
     /*  728798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  728809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  728812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  728815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  728847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728866 */     GIR_RootConstrainSelectedInstOperands,
     /*  728867 */     // GIR_Coverage, 11890,
     /*  728867 */     GIR_EraseRootFromParent_Done,
     /*  728868 */   // Label 11444: @728868
     /*  728868 */   GIM_Try, /*On fail goto*//*Label 11445*/ GIMT_Encode4(728943), // Rule ID 11891 //
     /*  728873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  728876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  728884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  728887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  728890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  728893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  728896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  728908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11112:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  728919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64),
     /*  728922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  728926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  728928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  728930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  728935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  728938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  728941 */     GIR_RootConstrainSelectedInstOperands,
     /*  728942 */     // GIR_Coverage, 11891,
     /*  728942 */     GIR_EraseRootFromParent_Done,
     /*  728943 */   // Label 11445: @728943
     /*  728943 */   GIM_Try, /*On fail goto*//*Label 11446*/ GIMT_Encode4(729018), // Rule ID 11894 //
     /*  728948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  728951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  728956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  728959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  728962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  728965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  728968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  728971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  728983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  728987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  728994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  728994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  728997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  728999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729016 */     GIR_RootConstrainSelectedInstOperands,
     /*  729017 */     // GIR_Coverage, 11894,
     /*  729017 */     GIR_EraseRootFromParent_Done,
     /*  729018 */   // Label 11446: @729018
     /*  729018 */   GIM_Try, /*On fail goto*//*Label 11447*/ GIMT_Encode4(729093), // Rule ID 11895 //
     /*  729023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  729026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv),
     /*  729031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  729034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  729037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  729040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  729043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  729058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  729062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729069 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11112:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVDIV_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  729069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64),
     /*  729072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  729088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729091 */     GIR_RootConstrainSelectedInstOperands,
     /*  729092 */     // GIR_Coverage, 11895,
     /*  729092 */     GIR_EraseRootFromParent_Done,
     /*  729093 */   // Label 11447: @729093
     /*  729093 */   GIM_Try, /*On fail goto*//*Label 11448*/ GIMT_Encode4(729168), // Rule ID 11898 //
     /*  729098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729166 */     GIR_RootConstrainSelectedInstOperands,
     /*  729167 */     // GIR_Coverage, 11898,
     /*  729167 */     GIR_EraseRootFromParent_Done,
     /*  729168 */   // Label 11448: @729168
     /*  729168 */   GIM_Try, /*On fail goto*//*Label 11449*/ GIMT_Encode4(729243), // Rule ID 11899 //
     /*  729173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  729184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  729187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  729190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  729193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8),
     /*  729222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729241 */     GIR_RootConstrainSelectedInstOperands,
     /*  729242 */     // GIR_Coverage, 11899,
     /*  729242 */     GIR_EraseRootFromParent_Done,
     /*  729243 */   // Label 11449: @729243
     /*  729243 */   GIM_Try, /*On fail goto*//*Label 11450*/ GIMT_Encode4(729318), // Rule ID 11902 //
     /*  729248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729294 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729316 */     GIR_RootConstrainSelectedInstOperands,
     /*  729317 */     // GIR_Coverage, 11902,
     /*  729317 */     GIR_EraseRootFromParent_Done,
     /*  729318 */   // Label 11450: @729318
     /*  729318 */   GIM_Try, /*On fail goto*//*Label 11451*/ GIMT_Encode4(729393), // Rule ID 11903 //
     /*  729323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  729334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  729337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  729340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  729343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729369 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8),
     /*  729372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729391 */     GIR_RootConstrainSelectedInstOperands,
     /*  729392 */     // GIR_Coverage, 11903,
     /*  729392 */     GIR_EraseRootFromParent_Done,
     /*  729393 */   // Label 11451: @729393
     /*  729393 */   GIM_Try, /*On fail goto*//*Label 11452*/ GIMT_Encode4(729468), // Rule ID 11906 //
     /*  729398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  729409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  729412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  729415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  729418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729444 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  729444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  729447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729466 */     GIR_RootConstrainSelectedInstOperands,
     /*  729467 */     // GIR_Coverage, 11906,
     /*  729467 */     GIR_EraseRootFromParent_Done,
     /*  729468 */   // Label 11452: @729468
     /*  729468 */   GIM_Try, /*On fail goto*//*Label 11453*/ GIMT_Encode4(729543), // Rule ID 11907 //
     /*  729473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  729484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  729487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  729490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  729493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729519 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  729519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8),
     /*  729522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  729538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729541 */     GIR_RootConstrainSelectedInstOperands,
     /*  729542 */     // GIR_Coverage, 11907,
     /*  729542 */     GIR_EraseRootFromParent_Done,
     /*  729543 */   // Label 11453: @729543
     /*  729543 */   GIM_Try, /*On fail goto*//*Label 11454*/ GIMT_Encode4(729618), // Rule ID 11910 //
     /*  729548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  729559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  729562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  729565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  729568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  729597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729616 */     GIR_RootConstrainSelectedInstOperands,
     /*  729617 */     // GIR_Coverage, 11910,
     /*  729617 */     GIR_EraseRootFromParent_Done,
     /*  729618 */   // Label 11454: @729618
     /*  729618 */   GIM_Try, /*On fail goto*//*Label 11455*/ GIMT_Encode4(729693), // Rule ID 11911 //
     /*  729623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  729634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  729637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  729640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  729643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16),
     /*  729672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729691 */     GIR_RootConstrainSelectedInstOperands,
     /*  729692 */     // GIR_Coverage, 11911,
     /*  729692 */     GIR_EraseRootFromParent_Done,
     /*  729693 */   // Label 11455: @729693
     /*  729693 */   GIM_Try, /*On fail goto*//*Label 11456*/ GIMT_Encode4(729768), // Rule ID 11914 //
     /*  729698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  729709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  729712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  729715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  729718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  729744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  729747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729766 */     GIR_RootConstrainSelectedInstOperands,
     /*  729767 */     // GIR_Coverage, 11914,
     /*  729767 */     GIR_EraseRootFromParent_Done,
     /*  729768 */   // Label 11456: @729768
     /*  729768 */   GIM_Try, /*On fail goto*//*Label 11457*/ GIMT_Encode4(729843), // Rule ID 11915 //
     /*  729773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  729784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  729787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  729790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  729793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  729819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16),
     /*  729822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  729838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729841 */     GIR_RootConstrainSelectedInstOperands,
     /*  729842 */     // GIR_Coverage, 11915,
     /*  729842 */     GIR_EraseRootFromParent_Done,
     /*  729843 */   // Label 11457: @729843
     /*  729843 */   GIM_Try, /*On fail goto*//*Label 11458*/ GIMT_Encode4(729918), // Rule ID 11918 //
     /*  729848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  729851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  729859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  729862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  729865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  729868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  729871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  729894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  729897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729916 */     GIR_RootConstrainSelectedInstOperands,
     /*  729917 */     // GIR_Coverage, 11918,
     /*  729917 */     GIR_EraseRootFromParent_Done,
     /*  729918 */   // Label 11458: @729918
     /*  729918 */   GIM_Try, /*On fail goto*//*Label 11459*/ GIMT_Encode4(729993), // Rule ID 11919 //
     /*  729923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  729926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  729931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  729934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  729937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  729940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  729943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  729946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  729962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  729969 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  729969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32),
     /*  729972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  729974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  729976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  729978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  729980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  729985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  729988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  729991 */     GIR_RootConstrainSelectedInstOperands,
     /*  729992 */     // GIR_Coverage, 11919,
     /*  729992 */     GIR_EraseRootFromParent_Done,
     /*  729993 */   // Label 11459: @729993
     /*  729993 */   GIM_Try, /*On fail goto*//*Label 11460*/ GIMT_Encode4(730068), // Rule ID 11922 //
     /*  729998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730044 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730066 */     GIR_RootConstrainSelectedInstOperands,
     /*  730067 */     // GIR_Coverage, 11922,
     /*  730067 */     GIR_EraseRootFromParent_Done,
     /*  730068 */   // Label 11460: @730068
     /*  730068 */   GIM_Try, /*On fail goto*//*Label 11461*/ GIMT_Encode4(730143), // Rule ID 11923 //
     /*  730073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  730084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  730087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  730090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  730093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730119 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8),
     /*  730122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730141 */     GIR_RootConstrainSelectedInstOperands,
     /*  730142 */     // GIR_Coverage, 11923,
     /*  730142 */     GIR_EraseRootFromParent_Done,
     /*  730143 */   // Label 11461: @730143
     /*  730143 */   GIM_Try, /*On fail goto*//*Label 11462*/ GIMT_Encode4(730218), // Rule ID 11926 //
     /*  730148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  730194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730216 */     GIR_RootConstrainSelectedInstOperands,
     /*  730217 */     // GIR_Coverage, 11926,
     /*  730217 */     GIR_EraseRootFromParent_Done,
     /*  730218 */   // Label 11462: @730218
     /*  730218 */   GIM_Try, /*On fail goto*//*Label 11463*/ GIMT_Encode4(730293), // Rule ID 11927 //
     /*  730223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  730234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  730237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  730240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  730243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  730269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16),
     /*  730272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  730288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730291 */     GIR_RootConstrainSelectedInstOperands,
     /*  730292 */     // GIR_Coverage, 11927,
     /*  730292 */     GIR_EraseRootFromParent_Done,
     /*  730293 */   // Label 11463: @730293
     /*  730293 */   GIM_Try, /*On fail goto*//*Label 11464*/ GIMT_Encode4(730368), // Rule ID 11930 //
     /*  730298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  730344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730366 */     GIR_RootConstrainSelectedInstOperands,
     /*  730367 */     // GIR_Coverage, 11930,
     /*  730367 */     GIR_EraseRootFromParent_Done,
     /*  730368 */   // Label 11464: @730368
     /*  730368 */   GIM_Try, /*On fail goto*//*Label 11465*/ GIMT_Encode4(730443), // Rule ID 11931 //
     /*  730373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  730384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  730387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  730390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  730393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730419 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  730419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32),
     /*  730422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  730438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730441 */     GIR_RootConstrainSelectedInstOperands,
     /*  730442 */     // GIR_Coverage, 11931,
     /*  730442 */     GIR_EraseRootFromParent_Done,
     /*  730443 */   // Label 11465: @730443
     /*  730443 */   GIM_Try, /*On fail goto*//*Label 11466*/ GIMT_Encode4(730518), // Rule ID 11934 //
     /*  730448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  730451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  730459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  730462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  730465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  730468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  730494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  730497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730516 */     GIR_RootConstrainSelectedInstOperands,
     /*  730517 */     // GIR_Coverage, 11934,
     /*  730517 */     GIR_EraseRootFromParent_Done,
     /*  730518 */   // Label 11466: @730518
     /*  730518 */   GIM_Try, /*On fail goto*//*Label 11467*/ GIMT_Encode4(730593), // Rule ID 11935 //
     /*  730523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  730526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  730534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  730537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  730540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  730543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  730562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  730569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64),
     /*  730572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  730588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730591 */     GIR_RootConstrainSelectedInstOperands,
     /*  730592 */     // GIR_Coverage, 11935,
     /*  730592 */     GIR_EraseRootFromParent_Done,
     /*  730593 */   // Label 11467: @730593
     /*  730593 */   GIM_Try, /*On fail goto*//*Label 11468*/ GIMT_Encode4(730668), // Rule ID 11938 //
     /*  730598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  730609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  730612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  730615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  730618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  730647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730666 */     GIR_RootConstrainSelectedInstOperands,
     /*  730667 */     // GIR_Coverage, 11938,
     /*  730667 */     GIR_EraseRootFromParent_Done,
     /*  730668 */   // Label 11468: @730668
     /*  730668 */   GIM_Try, /*On fail goto*//*Label 11469*/ GIMT_Encode4(730743), // Rule ID 11939 //
     /*  730673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  730684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  730687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  730690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  730693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  730712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730719 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8),
     /*  730722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730741 */     GIR_RootConstrainSelectedInstOperands,
     /*  730742 */     // GIR_Coverage, 11939,
     /*  730742 */     GIR_EraseRootFromParent_Done,
     /*  730743 */   // Label 11469: @730743
     /*  730743 */   GIM_Try, /*On fail goto*//*Label 11470*/ GIMT_Encode4(730818), // Rule ID 11942 //
     /*  730748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  730759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  730762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  730765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  730768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  730797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730816 */     GIR_RootConstrainSelectedInstOperands,
     /*  730817 */     // GIR_Coverage, 11942,
     /*  730817 */     GIR_EraseRootFromParent_Done,
     /*  730818 */   // Label 11470: @730818
     /*  730818 */   GIM_Try, /*On fail goto*//*Label 11471*/ GIMT_Encode4(730893), // Rule ID 11943 //
     /*  730823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  730834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  730837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  730840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  730843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  730862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730869 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  730869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8),
     /*  730872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730891 */     GIR_RootConstrainSelectedInstOperands,
     /*  730892 */     // GIR_Coverage, 11943,
     /*  730892 */     GIR_EraseRootFromParent_Done,
     /*  730893 */   // Label 11471: @730893
     /*  730893 */   GIM_Try, /*On fail goto*//*Label 11472*/ GIMT_Encode4(730968), // Rule ID 11946 //
     /*  730898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  730901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  730909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  730912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  730915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  730918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  730921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  730937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  730944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  730944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  730947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  730949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  730951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  730953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  730955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  730960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  730963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  730966 */     GIR_RootConstrainSelectedInstOperands,
     /*  730967 */     // GIR_Coverage, 11946,
     /*  730967 */     GIR_EraseRootFromParent_Done,
     /*  730968 */   // Label 11472: @730968
     /*  730968 */   GIM_Try, /*On fail goto*//*Label 11473*/ GIMT_Encode4(731043), // Rule ID 11947 //
     /*  730973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  730976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  730981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  730984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  730987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  730990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  730993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  730996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731019 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  731019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8),
     /*  731022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  731038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731041 */     GIR_RootConstrainSelectedInstOperands,
     /*  731042 */     // GIR_Coverage, 11947,
     /*  731042 */     GIR_EraseRootFromParent_Done,
     /*  731043 */   // Label 11473: @731043
     /*  731043 */   GIM_Try, /*On fail goto*//*Label 11474*/ GIMT_Encode4(731118), // Rule ID 11950 //
     /*  731048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731094 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731116 */     GIR_RootConstrainSelectedInstOperands,
     /*  731117 */     // GIR_Coverage, 11950,
     /*  731117 */     GIR_EraseRootFromParent_Done,
     /*  731118 */   // Label 11474: @731118
     /*  731118 */   GIM_Try, /*On fail goto*//*Label 11475*/ GIMT_Encode4(731193), // Rule ID 11951 //
     /*  731123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  731134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  731137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  731140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  731143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731169 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16),
     /*  731172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731191 */     GIR_RootConstrainSelectedInstOperands,
     /*  731192 */     // GIR_Coverage, 11951,
     /*  731192 */     GIR_EraseRootFromParent_Done,
     /*  731193 */   // Label 11475: @731193
     /*  731193 */   GIM_Try, /*On fail goto*//*Label 11476*/ GIMT_Encode4(731268), // Rule ID 11954 //
     /*  731198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731266 */     GIR_RootConstrainSelectedInstOperands,
     /*  731267 */     // GIR_Coverage, 11954,
     /*  731267 */     GIR_EraseRootFromParent_Done,
     /*  731268 */   // Label 11476: @731268
     /*  731268 */   GIM_Try, /*On fail goto*//*Label 11477*/ GIMT_Encode4(731343), // Rule ID 11955 //
     /*  731273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  731284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  731287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  731290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  731293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731319 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16),
     /*  731322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731341 */     GIR_RootConstrainSelectedInstOperands,
     /*  731342 */     // GIR_Coverage, 11955,
     /*  731342 */     GIR_EraseRootFromParent_Done,
     /*  731343 */   // Label 11477: @731343
     /*  731343 */   GIM_Try, /*On fail goto*//*Label 11478*/ GIMT_Encode4(731418), // Rule ID 11958 //
     /*  731348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  731394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731416 */     GIR_RootConstrainSelectedInstOperands,
     /*  731417 */     // GIR_Coverage, 11958,
     /*  731417 */     GIR_EraseRootFromParent_Done,
     /*  731418 */   // Label 11478: @731418
     /*  731418 */   GIM_Try, /*On fail goto*//*Label 11479*/ GIMT_Encode4(731493), // Rule ID 11959 //
     /*  731423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  731434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  731437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  731440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  731443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731469 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  731469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16),
     /*  731472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  731488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731491 */     GIR_RootConstrainSelectedInstOperands,
     /*  731492 */     // GIR_Coverage, 11959,
     /*  731492 */     GIR_EraseRootFromParent_Done,
     /*  731493 */   // Label 11479: @731493
     /*  731493 */   GIM_Try, /*On fail goto*//*Label 11480*/ GIMT_Encode4(731568), // Rule ID 11962 //
     /*  731498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  731509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  731512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  731515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  731518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  731547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731566 */     GIR_RootConstrainSelectedInstOperands,
     /*  731567 */     // GIR_Coverage, 11962,
     /*  731567 */     GIR_EraseRootFromParent_Done,
     /*  731568 */   // Label 11480: @731568
     /*  731568 */   GIM_Try, /*On fail goto*//*Label 11481*/ GIMT_Encode4(731643), // Rule ID 11963 //
     /*  731573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  731584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  731587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  731590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  731593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32),
     /*  731622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731641 */     GIR_RootConstrainSelectedInstOperands,
     /*  731642 */     // GIR_Coverage, 11963,
     /*  731642 */     GIR_EraseRootFromParent_Done,
     /*  731643 */   // Label 11481: @731643
     /*  731643 */   GIM_Try, /*On fail goto*//*Label 11482*/ GIMT_Encode4(731718), // Rule ID 11966 //
     /*  731648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  731659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  731662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  731665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  731668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  731697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731716 */     GIR_RootConstrainSelectedInstOperands,
     /*  731717 */     // GIR_Coverage, 11966,
     /*  731717 */     GIR_EraseRootFromParent_Done,
     /*  731718 */   // Label 11482: @731718
     /*  731718 */   GIM_Try, /*On fail goto*//*Label 11483*/ GIMT_Encode4(731793), // Rule ID 11967 //
     /*  731723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  731734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  731737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  731740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  731743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  731762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32),
     /*  731772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731791 */     GIR_RootConstrainSelectedInstOperands,
     /*  731792 */     // GIR_Coverage, 11967,
     /*  731792 */     GIR_EraseRootFromParent_Done,
     /*  731793 */   // Label 11483: @731793
     /*  731793 */   GIM_Try, /*On fail goto*//*Label 11484*/ GIMT_Encode4(731868), // Rule ID 11970 //
     /*  731798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  731801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  731809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  731812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  731815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  731818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  731844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  731847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731866 */     GIR_RootConstrainSelectedInstOperands,
     /*  731867 */     // GIR_Coverage, 11970,
     /*  731867 */     GIR_EraseRootFromParent_Done,
     /*  731868 */   // Label 11484: @731868
     /*  731868 */   GIM_Try, /*On fail goto*//*Label 11485*/ GIMT_Encode4(731943), // Rule ID 11971 //
     /*  731873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  731876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  731884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  731887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  731890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  731893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  731896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  731912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  731919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32),
     /*  731922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  731926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  731928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  731930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  731935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  731938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  731941 */     GIR_RootConstrainSelectedInstOperands,
     /*  731942 */     // GIR_Coverage, 11971,
     /*  731942 */     GIR_EraseRootFromParent_Done,
     /*  731943 */   // Label 11485: @731943
     /*  731943 */   GIM_Try, /*On fail goto*//*Label 11486*/ GIMT_Encode4(732018), // Rule ID 11974 //
     /*  731948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  731951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  731956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  731959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  731962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  731965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  731968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  731971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  731987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  731994 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  731994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  731997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  731999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732016 */     GIR_RootConstrainSelectedInstOperands,
     /*  732017 */     // GIR_Coverage, 11974,
     /*  732017 */     GIR_EraseRootFromParent_Done,
     /*  732018 */   // Label 11486: @732018
     /*  732018 */   GIM_Try, /*On fail goto*//*Label 11487*/ GIMT_Encode4(732093), // Rule ID 11975 //
     /*  732023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  732034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  732037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  732040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  732043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  732062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732069 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64),
     /*  732072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732091 */     GIR_RootConstrainSelectedInstOperands,
     /*  732092 */     // GIR_Coverage, 11975,
     /*  732092 */     GIR_EraseRootFromParent_Done,
     /*  732093 */   // Label 11487: @732093
     /*  732093 */   GIM_Try, /*On fail goto*//*Label 11488*/ GIMT_Encode4(732168), // Rule ID 11978 //
     /*  732098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732144 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732166 */     GIR_RootConstrainSelectedInstOperands,
     /*  732167 */     // GIR_Coverage, 11978,
     /*  732167 */     GIR_EraseRootFromParent_Done,
     /*  732168 */   // Label 11488: @732168
     /*  732168 */   GIM_Try, /*On fail goto*//*Label 11489*/ GIMT_Encode4(732243), // Rule ID 11979 //
     /*  732173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  732184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  732187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  732190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  732193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  732212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732219 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64),
     /*  732222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732241 */     GIR_RootConstrainSelectedInstOperands,
     /*  732242 */     // GIR_Coverage, 11979,
     /*  732242 */     GIR_EraseRootFromParent_Done,
     /*  732243 */   // Label 11489: @732243
     /*  732243 */   GIM_Try, /*On fail goto*//*Label 11490*/ GIMT_Encode4(732318), // Rule ID 11982 //
     /*  732248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  732251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  732294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732316 */     GIR_RootConstrainSelectedInstOperands,
     /*  732317 */     // GIR_Coverage, 11982,
     /*  732317 */     GIR_EraseRootFromParent_Done,
     /*  732318 */   // Label 11490: @732318
     /*  732318 */   GIM_Try, /*On fail goto*//*Label 11491*/ GIMT_Encode4(732393), // Rule ID 11983 //
     /*  732323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  732326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  732334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  732337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  732340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  732343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  732362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732369 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  732369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64),
     /*  732372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  732388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732391 */     GIR_RootConstrainSelectedInstOperands,
     /*  732392 */     // GIR_Coverage, 11983,
     /*  732392 */     GIR_EraseRootFromParent_Done,
     /*  732393 */   // Label 11491: @732393
     /*  732393 */   GIM_Try, /*On fail goto*//*Label 11492*/ GIMT_Encode4(732468), // Rule ID 11986 //
     /*  732398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  732409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  732412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  732415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  732447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732466 */     GIR_RootConstrainSelectedInstOperands,
     /*  732467 */     // GIR_Coverage, 11986,
     /*  732467 */     GIR_EraseRootFromParent_Done,
     /*  732468 */   // Label 11492: @732468
     /*  732468 */   GIM_Try, /*On fail goto*//*Label 11493*/ GIMT_Encode4(732543), // Rule ID 11987 //
     /*  732473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  732484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  732487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  732490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8),
     /*  732522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732541 */     GIR_RootConstrainSelectedInstOperands,
     /*  732542 */     // GIR_Coverage, 11987,
     /*  732542 */     GIR_EraseRootFromParent_Done,
     /*  732543 */   // Label 11493: @732543
     /*  732543 */   GIM_Try, /*On fail goto*//*Label 11494*/ GIMT_Encode4(732618), // Rule ID 11990 //
     /*  732548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  732559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  732562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  732565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732594 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  732597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732616 */     GIR_RootConstrainSelectedInstOperands,
     /*  732617 */     // GIR_Coverage, 11990,
     /*  732617 */     GIR_EraseRootFromParent_Done,
     /*  732618 */   // Label 11494: @732618
     /*  732618 */   GIM_Try, /*On fail goto*//*Label 11495*/ GIMT_Encode4(732693), // Rule ID 11991 //
     /*  732623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  732634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  732637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  732640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732669 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8),
     /*  732672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732691 */     GIR_RootConstrainSelectedInstOperands,
     /*  732692 */     // GIR_Coverage, 11991,
     /*  732692 */     GIR_EraseRootFromParent_Done,
     /*  732693 */   // Label 11495: @732693
     /*  732693 */   GIM_Try, /*On fail goto*//*Label 11496*/ GIMT_Encode4(732768), // Rule ID 11994 //
     /*  732698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  732709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  732712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  732715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732744 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  732744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  732747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732766 */     GIR_RootConstrainSelectedInstOperands,
     /*  732767 */     // GIR_Coverage, 11994,
     /*  732767 */     GIR_EraseRootFromParent_Done,
     /*  732768 */   // Label 11496: @732768
     /*  732768 */   GIM_Try, /*On fail goto*//*Label 11497*/ GIMT_Encode4(732843), // Rule ID 11995 //
     /*  732773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  732784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  732787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  732790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732819 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  732819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8),
     /*  732822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  732838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732841 */     GIR_RootConstrainSelectedInstOperands,
     /*  732842 */     // GIR_Coverage, 11995,
     /*  732842 */     GIR_EraseRootFromParent_Done,
     /*  732843 */   // Label 11497: @732843
     /*  732843 */   GIM_Try, /*On fail goto*//*Label 11498*/ GIMT_Encode4(732918), // Rule ID 11998 //
     /*  732848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  732851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  732859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  732862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  732865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  732868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  732871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732894 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  732894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  732897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732916 */     GIR_RootConstrainSelectedInstOperands,
     /*  732917 */     // GIR_Coverage, 11998,
     /*  732917 */     GIR_EraseRootFromParent_Done,
     /*  732918 */   // Label 11498: @732918
     /*  732918 */   GIM_Try, /*On fail goto*//*Label 11499*/ GIMT_Encode4(732993), // Rule ID 11999 //
     /*  732923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  732926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  732931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  732934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  732937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  732940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  732943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  732946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  732958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  732962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  732969 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  732969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16),
     /*  732972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  732974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  732976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  732978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  732980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  732985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  732988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  732991 */     GIR_RootConstrainSelectedInstOperands,
     /*  732992 */     // GIR_Coverage, 11999,
     /*  732992 */     GIR_EraseRootFromParent_Done,
     /*  732993 */   // Label 11499: @732993
     /*  732993 */   GIM_Try, /*On fail goto*//*Label 11500*/ GIMT_Encode4(733068), // Rule ID 12002 //
     /*  732998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733066 */     GIR_RootConstrainSelectedInstOperands,
     /*  733067 */     // GIR_Coverage, 12002,
     /*  733067 */     GIR_EraseRootFromParent_Done,
     /*  733068 */   // Label 11500: @733068
     /*  733068 */   GIM_Try, /*On fail goto*//*Label 11501*/ GIMT_Encode4(733143), // Rule ID 12003 //
     /*  733073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  733084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  733087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  733090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733119 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16),
     /*  733122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733141 */     GIR_RootConstrainSelectedInstOperands,
     /*  733142 */     // GIR_Coverage, 12003,
     /*  733142 */     GIR_EraseRootFromParent_Done,
     /*  733143 */   // Label 11501: @733143
     /*  733143 */   GIM_Try, /*On fail goto*//*Label 11502*/ GIMT_Encode4(733218), // Rule ID 12006 //
     /*  733148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733194 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  733194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733216 */     GIR_RootConstrainSelectedInstOperands,
     /*  733217 */     // GIR_Coverage, 12006,
     /*  733217 */     GIR_EraseRootFromParent_Done,
     /*  733218 */   // Label 11502: @733218
     /*  733218 */   GIM_Try, /*On fail goto*//*Label 11503*/ GIMT_Encode4(733293), // Rule ID 12007 //
     /*  733223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  733234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  733237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  733240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733269 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  733269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32),
     /*  733272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733291 */     GIR_RootConstrainSelectedInstOperands,
     /*  733292 */     // GIR_Coverage, 12007,
     /*  733292 */     GIR_EraseRootFromParent_Done,
     /*  733293 */   // Label 11503: @733293
     /*  733293 */   GIM_Try, /*On fail goto*//*Label 11504*/ GIMT_Encode4(733368), // Rule ID 12010 //
     /*  733298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733366 */     GIR_RootConstrainSelectedInstOperands,
     /*  733367 */     // GIR_Coverage, 12010,
     /*  733367 */     GIR_EraseRootFromParent_Done,
     /*  733368 */   // Label 11504: @733368
     /*  733368 */   GIM_Try, /*On fail goto*//*Label 11505*/ GIMT_Encode4(733443), // Rule ID 12011 //
     /*  733373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  733384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  733387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  733390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733419 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11446:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  733419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8),
     /*  733422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733441 */     GIR_RootConstrainSelectedInstOperands,
     /*  733442 */     // GIR_Coverage, 12011,
     /*  733442 */     GIR_EraseRootFromParent_Done,
     /*  733443 */   // Label 11505: @733443
     /*  733443 */   GIM_Try, /*On fail goto*//*Label 11506*/ GIMT_Encode4(733518), // Rule ID 12014 //
     /*  733448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  733465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733494 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  733494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  733497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733516 */     GIR_RootConstrainSelectedInstOperands,
     /*  733517 */     // GIR_Coverage, 12014,
     /*  733517 */     GIR_EraseRootFromParent_Done,
     /*  733518 */   // Label 11506: @733518
     /*  733518 */   GIM_Try, /*On fail goto*//*Label 11507*/ GIMT_Encode4(733593), // Rule ID 12015 //
     /*  733523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  733534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  733537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  733540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733569 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11446:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  733569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16),
     /*  733572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  733588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733591 */     GIR_RootConstrainSelectedInstOperands,
     /*  733592 */     // GIR_Coverage, 12015,
     /*  733592 */     GIR_EraseRootFromParent_Done,
     /*  733593 */   // Label 11507: @733593
     /*  733593 */   GIM_Try, /*On fail goto*//*Label 11508*/ GIMT_Encode4(733668), // Rule ID 12018 //
     /*  733598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  733609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  733612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  733615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  733644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  733647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733666 */     GIR_RootConstrainSelectedInstOperands,
     /*  733667 */     // GIR_Coverage, 12018,
     /*  733667 */     GIR_EraseRootFromParent_Done,
     /*  733668 */   // Label 11508: @733668
     /*  733668 */   GIM_Try, /*On fail goto*//*Label 11509*/ GIMT_Encode4(733743), // Rule ID 12019 //
     /*  733673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  733684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  733687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  733690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11446:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  733719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32),
     /*  733722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  733738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733741 */     GIR_RootConstrainSelectedInstOperands,
     /*  733742 */     // GIR_Coverage, 12019,
     /*  733742 */     GIR_EraseRootFromParent_Done,
     /*  733743 */   // Label 11509: @733743
     /*  733743 */   GIM_Try, /*On fail goto*//*Label 11510*/ GIMT_Encode4(733818), // Rule ID 12022 //
     /*  733748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  733751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  733759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  733762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  733765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733794 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  733794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  733797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733816 */     GIR_RootConstrainSelectedInstOperands,
     /*  733817 */     // GIR_Coverage, 12022,
     /*  733817 */     GIR_EraseRootFromParent_Done,
     /*  733818 */   // Label 11510: @733818
     /*  733818 */   GIM_Try, /*On fail goto*//*Label 11511*/ GIMT_Encode4(733893), // Rule ID 12023 //
     /*  733823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  733826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  733834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  733837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  733840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  733858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11446:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  733869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64),
     /*  733872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  733888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733891 */     GIR_RootConstrainSelectedInstOperands,
     /*  733892 */     // GIR_Coverage, 12023,
     /*  733892 */     GIR_EraseRootFromParent_Done,
     /*  733893 */   // Label 11511: @733893
     /*  733893 */   GIM_Try, /*On fail goto*//*Label 11512*/ GIMT_Encode4(733968), // Rule ID 12026 //
     /*  733898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  733901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  733909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  733912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  733915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  733918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  733921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  733933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  733937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  733944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  733944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  733947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  733949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  733951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  733953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  733955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  733960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  733963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  733966 */     GIR_RootConstrainSelectedInstOperands,
     /*  733967 */     // GIR_Coverage, 12026,
     /*  733967 */     GIR_EraseRootFromParent_Done,
     /*  733968 */   // Label 11512: @733968
     /*  733968 */   GIM_Try, /*On fail goto*//*Label 11513*/ GIMT_Encode4(734043), // Rule ID 12027 //
     /*  733973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  733976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  733981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  733984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  733987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  733990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  733993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  733996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734019 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8),
     /*  734022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734041 */     GIR_RootConstrainSelectedInstOperands,
     /*  734042 */     // GIR_Coverage, 12027,
     /*  734042 */     GIR_EraseRootFromParent_Done,
     /*  734043 */   // Label 11513: @734043
     /*  734043 */   GIM_Try, /*On fail goto*//*Label 11514*/ GIMT_Encode4(734118), // Rule ID 12030 //
     /*  734048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734116 */     GIR_RootConstrainSelectedInstOperands,
     /*  734117 */     // GIR_Coverage, 12030,
     /*  734117 */     GIR_EraseRootFromParent_Done,
     /*  734118 */   // Label 11514: @734118
     /*  734118 */   GIM_Try, /*On fail goto*//*Label 11515*/ GIMT_Encode4(734193), // Rule ID 12031 //
     /*  734123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  734134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  734137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  734140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734169 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8),
     /*  734172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734191 */     GIR_RootConstrainSelectedInstOperands,
     /*  734192 */     // GIR_Coverage, 12031,
     /*  734192 */     GIR_EraseRootFromParent_Done,
     /*  734193 */   // Label 11515: @734193
     /*  734193 */   GIM_Try, /*On fail goto*//*Label 11516*/ GIMT_Encode4(734268), // Rule ID 12034 //
     /*  734198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734244 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  734244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734266 */     GIR_RootConstrainSelectedInstOperands,
     /*  734267 */     // GIR_Coverage, 12034,
     /*  734267 */     GIR_EraseRootFromParent_Done,
     /*  734268 */   // Label 11516: @734268
     /*  734268 */   GIM_Try, /*On fail goto*//*Label 11517*/ GIMT_Encode4(734343), // Rule ID 12035 //
     /*  734273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  734284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  734287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  734290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734319 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  734319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8),
     /*  734322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  734338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734341 */     GIR_RootConstrainSelectedInstOperands,
     /*  734342 */     // GIR_Coverage, 12035,
     /*  734342 */     GIR_EraseRootFromParent_Done,
     /*  734343 */   // Label 11517: @734343
     /*  734343 */   GIM_Try, /*On fail goto*//*Label 11518*/ GIMT_Encode4(734418), // Rule ID 12038 //
     /*  734348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734394 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734416 */     GIR_RootConstrainSelectedInstOperands,
     /*  734417 */     // GIR_Coverage, 12038,
     /*  734417 */     GIR_EraseRootFromParent_Done,
     /*  734418 */   // Label 11518: @734418
     /*  734418 */   GIM_Try, /*On fail goto*//*Label 11519*/ GIMT_Encode4(734493), // Rule ID 12039 //
     /*  734423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  734434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  734437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  734440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16),
     /*  734472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734491 */     GIR_RootConstrainSelectedInstOperands,
     /*  734492 */     // GIR_Coverage, 12039,
     /*  734492 */     GIR_EraseRootFromParent_Done,
     /*  734493 */   // Label 11519: @734493
     /*  734493 */   GIM_Try, /*On fail goto*//*Label 11520*/ GIMT_Encode4(734568), // Rule ID 12042 //
     /*  734498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  734509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  734512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  734515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  734547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734566 */     GIR_RootConstrainSelectedInstOperands,
     /*  734567 */     // GIR_Coverage, 12042,
     /*  734567 */     GIR_EraseRootFromParent_Done,
     /*  734568 */   // Label 11520: @734568
     /*  734568 */   GIM_Try, /*On fail goto*//*Label 11521*/ GIMT_Encode4(734643), // Rule ID 12043 //
     /*  734573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  734584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  734587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  734590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734619 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16),
     /*  734622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734641 */     GIR_RootConstrainSelectedInstOperands,
     /*  734642 */     // GIR_Coverage, 12043,
     /*  734642 */     GIR_EraseRootFromParent_Done,
     /*  734643 */   // Label 11521: @734643
     /*  734643 */   GIM_Try, /*On fail goto*//*Label 11522*/ GIMT_Encode4(734718), // Rule ID 12046 //
     /*  734648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  734659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  734662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  734665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  734694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  734697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734716 */     GIR_RootConstrainSelectedInstOperands,
     /*  734717 */     // GIR_Coverage, 12046,
     /*  734717 */     GIR_EraseRootFromParent_Done,
     /*  734718 */   // Label 11522: @734718
     /*  734718 */   GIM_Try, /*On fail goto*//*Label 11523*/ GIMT_Encode4(734793), // Rule ID 12047 //
     /*  734723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  734734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  734737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  734740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  734758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734769 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  734769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16),
     /*  734772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  734788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734791 */     GIR_RootConstrainSelectedInstOperands,
     /*  734792 */     // GIR_Coverage, 12047,
     /*  734792 */     GIR_EraseRootFromParent_Done,
     /*  734793 */   // Label 11523: @734793
     /*  734793 */   GIM_Try, /*On fail goto*//*Label 11524*/ GIMT_Encode4(734868), // Rule ID 12050 //
     /*  734798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  734809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  734812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  734815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  734847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734866 */     GIR_RootConstrainSelectedInstOperands,
     /*  734867 */     // GIR_Coverage, 12050,
     /*  734867 */     GIR_EraseRootFromParent_Done,
     /*  734868 */   // Label 11524: @734868
     /*  734868 */   GIM_Try, /*On fail goto*//*Label 11525*/ GIMT_Encode4(734943), // Rule ID 12051 //
     /*  734873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  734876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  734884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  734887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  734890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  734893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  734896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  734908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734919 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  734919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32),
     /*  734922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  734926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  734928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  734930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  734935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  734938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  734941 */     GIR_RootConstrainSelectedInstOperands,
     /*  734942 */     // GIR_Coverage, 12051,
     /*  734942 */     GIR_EraseRootFromParent_Done,
     /*  734943 */   // Label 11525: @734943
     /*  734943 */   GIM_Try, /*On fail goto*//*Label 11526*/ GIMT_Encode4(735018), // Rule ID 12054 //
     /*  734948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  734951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  734956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  734959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  734962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  734965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  734968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  734971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  734983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  734987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  734994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  734994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  734997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  734999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735016 */     GIR_RootConstrainSelectedInstOperands,
     /*  735017 */     // GIR_Coverage, 12054,
     /*  735017 */     GIR_EraseRootFromParent_Done,
     /*  735018 */   // Label 11526: @735018
     /*  735018 */   GIM_Try, /*On fail goto*//*Label 11527*/ GIMT_Encode4(735093), // Rule ID 12055 //
     /*  735023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  735034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  735037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  735040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32),
     /*  735072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735091 */     GIR_RootConstrainSelectedInstOperands,
     /*  735092 */     // GIR_Coverage, 12055,
     /*  735092 */     GIR_EraseRootFromParent_Done,
     /*  735093 */   // Label 11527: @735093
     /*  735093 */   GIM_Try, /*On fail goto*//*Label 11528*/ GIMT_Encode4(735168), // Rule ID 12058 //
     /*  735098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  735144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735166 */     GIR_RootConstrainSelectedInstOperands,
     /*  735167 */     // GIR_Coverage, 12058,
     /*  735167 */     GIR_EraseRootFromParent_Done,
     /*  735168 */   // Label 11528: @735168
     /*  735168 */   GIM_Try, /*On fail goto*//*Label 11529*/ GIMT_Encode4(735243), // Rule ID 12059 //
     /*  735173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  735184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  735187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  735190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735219 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  735219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32),
     /*  735222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  735238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735241 */     GIR_RootConstrainSelectedInstOperands,
     /*  735242 */     // GIR_Coverage, 12059,
     /*  735242 */     GIR_EraseRootFromParent_Done,
     /*  735243 */   // Label 11529: @735243
     /*  735243 */   GIM_Try, /*On fail goto*//*Label 11530*/ GIMT_Encode4(735318), // Rule ID 12062 //
     /*  735248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735294 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735316 */     GIR_RootConstrainSelectedInstOperands,
     /*  735317 */     // GIR_Coverage, 12062,
     /*  735317 */     GIR_EraseRootFromParent_Done,
     /*  735318 */   // Label 11530: @735318
     /*  735318 */   GIM_Try, /*On fail goto*//*Label 11531*/ GIMT_Encode4(735393), // Rule ID 12063 //
     /*  735323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  735334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  735337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  735340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  735358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735369 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11446:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  735369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64),
     /*  735372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735391 */     GIR_RootConstrainSelectedInstOperands,
     /*  735392 */     // GIR_Coverage, 12063,
     /*  735392 */     GIR_EraseRootFromParent_Done,
     /*  735393 */   // Label 11531: @735393
     /*  735393 */   GIM_Try, /*On fail goto*//*Label 11532*/ GIMT_Encode4(735468), // Rule ID 12066 //
     /*  735398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  735409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  735412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  735415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735444 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  735447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735466 */     GIR_RootConstrainSelectedInstOperands,
     /*  735467 */     // GIR_Coverage, 12066,
     /*  735467 */     GIR_EraseRootFromParent_Done,
     /*  735468 */   // Label 11532: @735468
     /*  735468 */   GIM_Try, /*On fail goto*//*Label 11533*/ GIMT_Encode4(735543), // Rule ID 12067 //
     /*  735473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  735484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  735487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  735490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  735508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735519 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11446:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  735519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64),
     /*  735522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735541 */     GIR_RootConstrainSelectedInstOperands,
     /*  735542 */     // GIR_Coverage, 12067,
     /*  735542 */     GIR_EraseRootFromParent_Done,
     /*  735543 */   // Label 11533: @735543
     /*  735543 */   GIM_Try, /*On fail goto*//*Label 11534*/ GIMT_Encode4(735618), // Rule ID 12070 //
     /*  735548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  735551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  735559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  735562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  735565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  735568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  735594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  735597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735616 */     GIR_RootConstrainSelectedInstOperands,
     /*  735617 */     // GIR_Coverage, 12070,
     /*  735617 */     GIR_EraseRootFromParent_Done,
     /*  735618 */   // Label 11534: @735618
     /*  735618 */   GIM_Try, /*On fail goto*//*Label 11535*/ GIMT_Encode4(735693), // Rule ID 12071 //
     /*  735623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  735626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu),
     /*  735631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  735634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  735637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  735640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  735643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  735658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  735662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735669 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11446:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREMU_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  735669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64),
     /*  735672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  735688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735691 */     GIR_RootConstrainSelectedInstOperands,
     /*  735692 */     // GIR_Coverage, 12071,
     /*  735692 */     GIR_EraseRootFromParent_Done,
     /*  735693 */   // Label 11535: @735693
     /*  735693 */   GIM_Try, /*On fail goto*//*Label 11536*/ GIMT_Encode4(735768), // Rule ID 12074 //
     /*  735698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  735706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  735709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  735712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  735715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  735718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  735747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735766 */     GIR_RootConstrainSelectedInstOperands,
     /*  735767 */     // GIR_Coverage, 12074,
     /*  735767 */     GIR_EraseRootFromParent_Done,
     /*  735768 */   // Label 11536: @735768
     /*  735768 */   GIM_Try, /*On fail goto*//*Label 11537*/ GIMT_Encode4(735843), // Rule ID 12075 //
     /*  735773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  735781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  735784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  735787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  735790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  735793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735819 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8),
     /*  735822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735841 */     GIR_RootConstrainSelectedInstOperands,
     /*  735842 */     // GIR_Coverage, 12075,
     /*  735842 */     GIR_EraseRootFromParent_Done,
     /*  735843 */   // Label 11537: @735843
     /*  735843 */   GIM_Try, /*On fail goto*//*Label 11538*/ GIMT_Encode4(735918), // Rule ID 12078 //
     /*  735848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  735851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  735856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  735859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  735862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  735865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  735868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  735871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  735894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  735897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735916 */     GIR_RootConstrainSelectedInstOperands,
     /*  735917 */     // GIR_Coverage, 12078,
     /*  735917 */     GIR_EraseRootFromParent_Done,
     /*  735918 */   // Label 11538: @735918
     /*  735918 */   GIM_Try, /*On fail goto*//*Label 11539*/ GIMT_Encode4(735993), // Rule ID 12079 //
     /*  735923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  735926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  735931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  735934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  735937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  735940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  735943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  735946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  735962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  735969 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  735969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8),
     /*  735972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  735974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  735976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  735978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  735980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  735985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  735988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  735991 */     GIR_RootConstrainSelectedInstOperands,
     /*  735992 */     // GIR_Coverage, 12079,
     /*  735992 */     GIR_EraseRootFromParent_Done,
     /*  735993 */   // Label 11539: @735993
     /*  735993 */   GIM_Try, /*On fail goto*//*Label 11540*/ GIMT_Encode4(736068), // Rule ID 12082 //
     /*  735998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736066 */     GIR_RootConstrainSelectedInstOperands,
     /*  736067 */     // GIR_Coverage, 12082,
     /*  736067 */     GIR_EraseRootFromParent_Done,
     /*  736068 */   // Label 11540: @736068
     /*  736068 */   GIM_Try, /*On fail goto*//*Label 11541*/ GIMT_Encode4(736143), // Rule ID 12083 //
     /*  736073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  736084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  736087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  736090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  736093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736119 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8),
     /*  736122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736141 */     GIR_RootConstrainSelectedInstOperands,
     /*  736142 */     // GIR_Coverage, 12083,
     /*  736142 */     GIR_EraseRootFromParent_Done,
     /*  736143 */   // Label 11541: @736143
     /*  736143 */   GIM_Try, /*On fail goto*//*Label 11542*/ GIMT_Encode4(736218), // Rule ID 12086 //
     /*  736148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736216 */     GIR_RootConstrainSelectedInstOperands,
     /*  736217 */     // GIR_Coverage, 12086,
     /*  736217 */     GIR_EraseRootFromParent_Done,
     /*  736218 */   // Label 11542: @736218
     /*  736218 */   GIM_Try, /*On fail goto*//*Label 11543*/ GIMT_Encode4(736293), // Rule ID 12087 //
     /*  736223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  736234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  736237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  736240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  736243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736269 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16),
     /*  736272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736291 */     GIR_RootConstrainSelectedInstOperands,
     /*  736292 */     // GIR_Coverage, 12087,
     /*  736292 */     GIR_EraseRootFromParent_Done,
     /*  736293 */   // Label 11543: @736293
     /*  736293 */   GIM_Try, /*On fail goto*//*Label 11544*/ GIMT_Encode4(736368), // Rule ID 12090 //
     /*  736298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736366 */     GIR_RootConstrainSelectedInstOperands,
     /*  736367 */     // GIR_Coverage, 12090,
     /*  736367 */     GIR_EraseRootFromParent_Done,
     /*  736368 */   // Label 11544: @736368
     /*  736368 */   GIM_Try, /*On fail goto*//*Label 11545*/ GIMT_Encode4(736443), // Rule ID 12091 //
     /*  736373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  736384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  736387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  736390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  736393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736419 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16),
     /*  736422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736441 */     GIR_RootConstrainSelectedInstOperands,
     /*  736442 */     // GIR_Coverage, 12091,
     /*  736442 */     GIR_EraseRootFromParent_Done,
     /*  736443 */   // Label 11545: @736443
     /*  736443 */   GIM_Try, /*On fail goto*//*Label 11546*/ GIMT_Encode4(736518), // Rule ID 12094 //
     /*  736448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  736459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  736462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  736465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  736468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  736497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736516 */     GIR_RootConstrainSelectedInstOperands,
     /*  736517 */     // GIR_Coverage, 12094,
     /*  736517 */     GIR_EraseRootFromParent_Done,
     /*  736518 */   // Label 11546: @736518
     /*  736518 */   GIM_Try, /*On fail goto*//*Label 11547*/ GIMT_Encode4(736593), // Rule ID 12095 //
     /*  736523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  736534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  736537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  736540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  736543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  736569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32),
     /*  736572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736591 */     GIR_RootConstrainSelectedInstOperands,
     /*  736592 */     // GIR_Coverage, 12095,
     /*  736592 */     GIR_EraseRootFromParent_Done,
     /*  736593 */   // Label 11547: @736593
     /*  736593 */   GIM_Try, /*On fail goto*//*Label 11548*/ GIMT_Encode4(736668), // Rule ID 12098 //
     /*  736598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  736615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  736644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  736647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736666 */     GIR_RootConstrainSelectedInstOperands,
     /*  736667 */     // GIR_Coverage, 12098,
     /*  736667 */     GIR_EraseRootFromParent_Done,
     /*  736668 */   // Label 11548: @736668
     /*  736668 */   GIM_Try, /*On fail goto*//*Label 11549*/ GIMT_Encode4(736743), // Rule ID 12099 //
     /*  736673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  736684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  736687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  736690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  736693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736719 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  736719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8),
     /*  736722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  736738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736741 */     GIR_RootConstrainSelectedInstOperands,
     /*  736742 */     // GIR_Coverage, 12099,
     /*  736742 */     GIR_EraseRootFromParent_Done,
     /*  736743 */   // Label 11549: @736743
     /*  736743 */   GIM_Try, /*On fail goto*//*Label 11550*/ GIMT_Encode4(736818), // Rule ID 12102 //
     /*  736748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  736759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  736762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  736765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  736768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736794 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  736794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  736797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736816 */     GIR_RootConstrainSelectedInstOperands,
     /*  736817 */     // GIR_Coverage, 12102,
     /*  736817 */     GIR_EraseRootFromParent_Done,
     /*  736818 */   // Label 11550: @736818
     /*  736818 */   GIM_Try, /*On fail goto*//*Label 11551*/ GIMT_Encode4(736893), // Rule ID 12103 //
     /*  736823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  736834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  736837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  736840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  736843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736869 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  736869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16),
     /*  736872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  736888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736891 */     GIR_RootConstrainSelectedInstOperands,
     /*  736892 */     // GIR_Coverage, 12103,
     /*  736892 */     GIR_EraseRootFromParent_Done,
     /*  736893 */   // Label 11551: @736893
     /*  736893 */   GIM_Try, /*On fail goto*//*Label 11552*/ GIMT_Encode4(736968), // Rule ID 12106 //
     /*  736898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  736901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  736909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  736912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  736915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  736918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  736921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  736937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  736944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  736944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  736947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  736949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  736951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  736953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  736955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  736960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  736963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  736966 */     GIR_RootConstrainSelectedInstOperands,
     /*  736967 */     // GIR_Coverage, 12106,
     /*  736967 */     GIR_EraseRootFromParent_Done,
     /*  736968 */   // Label 11552: @736968
     /*  736968 */   GIM_Try, /*On fail goto*//*Label 11553*/ GIMT_Encode4(737043), // Rule ID 12107 //
     /*  736973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  736976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  736981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  736984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  736987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  736990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  736993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  736996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737019 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  737019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32),
     /*  737022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  737038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737041 */     GIR_RootConstrainSelectedInstOperands,
     /*  737042 */     // GIR_Coverage, 12107,
     /*  737042 */     GIR_EraseRootFromParent_Done,
     /*  737043 */   // Label 11553: @737043
     /*  737043 */   GIM_Try, /*On fail goto*//*Label 11554*/ GIMT_Encode4(737118), // Rule ID 12110 //
     /*  737048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  737051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  737094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737116 */     GIR_RootConstrainSelectedInstOperands,
     /*  737117 */     // GIR_Coverage, 12110,
     /*  737117 */     GIR_EraseRootFromParent_Done,
     /*  737118 */   // Label 11554: @737118
     /*  737118 */   GIM_Try, /*On fail goto*//*Label 11555*/ GIMT_Encode4(737193), // Rule ID 12111 //
     /*  737123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  737126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  737134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  737137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  737140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  737143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  737162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737169 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  737169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64),
     /*  737172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  737188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737191 */     GIR_RootConstrainSelectedInstOperands,
     /*  737192 */     // GIR_Coverage, 12111,
     /*  737192 */     GIR_EraseRootFromParent_Done,
     /*  737193 */   // Label 11555: @737193
     /*  737193 */   GIM_Try, /*On fail goto*//*Label 11556*/ GIMT_Encode4(737268), // Rule ID 12114 //
     /*  737198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737266 */     GIR_RootConstrainSelectedInstOperands,
     /*  737267 */     // GIR_Coverage, 12114,
     /*  737267 */     GIR_EraseRootFromParent_Done,
     /*  737268 */   // Label 11556: @737268
     /*  737268 */   GIM_Try, /*On fail goto*//*Label 11557*/ GIMT_Encode4(737343), // Rule ID 12115 //
     /*  737273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  737284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  737287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  737290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  737293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737319 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8),
     /*  737322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737341 */     GIR_RootConstrainSelectedInstOperands,
     /*  737342 */     // GIR_Coverage, 12115,
     /*  737342 */     GIR_EraseRootFromParent_Done,
     /*  737343 */   // Label 11557: @737343
     /*  737343 */   GIM_Try, /*On fail goto*//*Label 11558*/ GIMT_Encode4(737418), // Rule ID 12118 //
     /*  737348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737416 */     GIR_RootConstrainSelectedInstOperands,
     /*  737417 */     // GIR_Coverage, 12118,
     /*  737417 */     GIR_EraseRootFromParent_Done,
     /*  737418 */   // Label 11558: @737418
     /*  737418 */   GIM_Try, /*On fail goto*//*Label 11559*/ GIMT_Encode4(737493), // Rule ID 12119 //
     /*  737423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  737434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  737437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  737440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  737443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737469 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8),
     /*  737472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737491 */     GIR_RootConstrainSelectedInstOperands,
     /*  737492 */     // GIR_Coverage, 12119,
     /*  737492 */     GIR_EraseRootFromParent_Done,
     /*  737493 */   // Label 11559: @737493
     /*  737493 */   GIM_Try, /*On fail goto*//*Label 11560*/ GIMT_Encode4(737568), // Rule ID 12122 //
     /*  737498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  737509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  737512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  737515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  737518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737544 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  737544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  737547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737566 */     GIR_RootConstrainSelectedInstOperands,
     /*  737567 */     // GIR_Coverage, 12122,
     /*  737567 */     GIR_EraseRootFromParent_Done,
     /*  737568 */   // Label 11560: @737568
     /*  737568 */   GIM_Try, /*On fail goto*//*Label 11561*/ GIMT_Encode4(737643), // Rule ID 12123 //
     /*  737573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  737584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  737587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  737590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  737593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737619 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  737619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8),
     /*  737622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  737638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737641 */     GIR_RootConstrainSelectedInstOperands,
     /*  737642 */     // GIR_Coverage, 12123,
     /*  737642 */     GIR_EraseRootFromParent_Done,
     /*  737643 */   // Label 11561: @737643
     /*  737643 */   GIM_Try, /*On fail goto*//*Label 11562*/ GIMT_Encode4(737718), // Rule ID 12126 //
     /*  737648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  737659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  737662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  737665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  737668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  737697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737716 */     GIR_RootConstrainSelectedInstOperands,
     /*  737717 */     // GIR_Coverage, 12126,
     /*  737717 */     GIR_EraseRootFromParent_Done,
     /*  737718 */   // Label 11562: @737718
     /*  737718 */   GIM_Try, /*On fail goto*//*Label 11563*/ GIMT_Encode4(737793), // Rule ID 12127 //
     /*  737723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  737734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  737737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  737740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  737743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  737762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16),
     /*  737772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737791 */     GIR_RootConstrainSelectedInstOperands,
     /*  737792 */     // GIR_Coverage, 12127,
     /*  737792 */     GIR_EraseRootFromParent_Done,
     /*  737793 */   // Label 11563: @737793
     /*  737793 */   GIM_Try, /*On fail goto*//*Label 11564*/ GIMT_Encode4(737868), // Rule ID 12130 //
     /*  737798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  737809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  737812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  737815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  737818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  737847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737866 */     GIR_RootConstrainSelectedInstOperands,
     /*  737867 */     // GIR_Coverage, 12130,
     /*  737867 */     GIR_EraseRootFromParent_Done,
     /*  737868 */   // Label 11564: @737868
     /*  737868 */   GIM_Try, /*On fail goto*//*Label 11565*/ GIMT_Encode4(737943), // Rule ID 12131 //
     /*  737873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  737876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  737884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  737887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  737890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  737893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  737896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  737912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737919 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  737919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16),
     /*  737922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  737926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  737928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  737930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  737935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  737938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  737941 */     GIR_RootConstrainSelectedInstOperands,
     /*  737942 */     // GIR_Coverage, 12131,
     /*  737942 */     GIR_EraseRootFromParent_Done,
     /*  737943 */   // Label 11565: @737943
     /*  737943 */   GIM_Try, /*On fail goto*//*Label 11566*/ GIMT_Encode4(738018), // Rule ID 12134 //
     /*  737948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  737951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  737956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  737959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  737962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  737965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  737968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  737971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  737987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  737994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  737994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  737997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  737999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738016 */     GIR_RootConstrainSelectedInstOperands,
     /*  738017 */     // GIR_Coverage, 12134,
     /*  738017 */     GIR_EraseRootFromParent_Done,
     /*  738018 */   // Label 11566: @738018
     /*  738018 */   GIM_Try, /*On fail goto*//*Label 11567*/ GIMT_Encode4(738093), // Rule ID 12135 //
     /*  738023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  738034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  738037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  738040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  738043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738069 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  738069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16),
     /*  738072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  738088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738091 */     GIR_RootConstrainSelectedInstOperands,
     /*  738092 */     // GIR_Coverage, 12135,
     /*  738092 */     GIR_EraseRootFromParent_Done,
     /*  738093 */   // Label 11567: @738093
     /*  738093 */   GIM_Try, /*On fail goto*//*Label 11568*/ GIMT_Encode4(738168), // Rule ID 12138 //
     /*  738098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738166 */     GIR_RootConstrainSelectedInstOperands,
     /*  738167 */     // GIR_Coverage, 12138,
     /*  738167 */     GIR_EraseRootFromParent_Done,
     /*  738168 */   // Label 11568: @738168
     /*  738168 */   GIM_Try, /*On fail goto*//*Label 11569*/ GIMT_Encode4(738243), // Rule ID 12139 //
     /*  738173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  738184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  738187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  738190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  738193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738219 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32),
     /*  738222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738241 */     GIR_RootConstrainSelectedInstOperands,
     /*  738242 */     // GIR_Coverage, 12139,
     /*  738242 */     GIR_EraseRootFromParent_Done,
     /*  738243 */   // Label 11569: @738243
     /*  738243 */   GIM_Try, /*On fail goto*//*Label 11570*/ GIMT_Encode4(738318), // Rule ID 12142 //
     /*  738248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738294 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738316 */     GIR_RootConstrainSelectedInstOperands,
     /*  738317 */     // GIR_Coverage, 12142,
     /*  738317 */     GIR_EraseRootFromParent_Done,
     /*  738318 */   // Label 11570: @738318
     /*  738318 */   GIM_Try, /*On fail goto*//*Label 11571*/ GIMT_Encode4(738393), // Rule ID 12143 //
     /*  738323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  738334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  738337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  738340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  738343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32),
     /*  738372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738391 */     GIR_RootConstrainSelectedInstOperands,
     /*  738392 */     // GIR_Coverage, 12143,
     /*  738392 */     GIR_EraseRootFromParent_Done,
     /*  738393 */   // Label 11571: @738393
     /*  738393 */   GIM_Try, /*On fail goto*//*Label 11572*/ GIMT_Encode4(738468), // Rule ID 12146 //
     /*  738398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  738401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  738409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  738412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  738415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  738418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738444 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  738444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  738447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738466 */     GIR_RootConstrainSelectedInstOperands,
     /*  738467 */     // GIR_Coverage, 12146,
     /*  738467 */     GIR_EraseRootFromParent_Done,
     /*  738468 */   // Label 11572: @738468
     /*  738468 */   GIM_Try, /*On fail goto*//*Label 11573*/ GIMT_Encode4(738543), // Rule ID 12147 //
     /*  738473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  738476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  738484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  738487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  738490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  738493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738519 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  738519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32),
     /*  738522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  738538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738541 */     GIR_RootConstrainSelectedInstOperands,
     /*  738542 */     // GIR_Coverage, 12147,
     /*  738542 */     GIR_EraseRootFromParent_Done,
     /*  738543 */   // Label 11573: @738543
     /*  738543 */   GIM_Try, /*On fail goto*//*Label 11574*/ GIMT_Encode4(738618), // Rule ID 12150 //
     /*  738548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  738559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  738562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  738565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  738568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  738597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738616 */     GIR_RootConstrainSelectedInstOperands,
     /*  738617 */     // GIR_Coverage, 12150,
     /*  738617 */     GIR_EraseRootFromParent_Done,
     /*  738618 */   // Label 11574: @738618
     /*  738618 */   GIM_Try, /*On fail goto*//*Label 11575*/ GIMT_Encode4(738693), // Rule ID 12151 //
     /*  738623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  738634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  738637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  738640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  738643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  738662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64),
     /*  738672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738691 */     GIR_RootConstrainSelectedInstOperands,
     /*  738692 */     // GIR_Coverage, 12151,
     /*  738692 */     GIR_EraseRootFromParent_Done,
     /*  738693 */   // Label 11575: @738693
     /*  738693 */   GIM_Try, /*On fail goto*//*Label 11576*/ GIMT_Encode4(738768), // Rule ID 12154 //
     /*  738698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  738709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  738712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  738715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  738718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  738747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738766 */     GIR_RootConstrainSelectedInstOperands,
     /*  738767 */     // GIR_Coverage, 12154,
     /*  738767 */     GIR_EraseRootFromParent_Done,
     /*  738768 */   // Label 11576: @738768
     /*  738768 */   GIM_Try, /*On fail goto*//*Label 11577*/ GIMT_Encode4(738843), // Rule ID 12155 //
     /*  738773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  738784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  738787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  738790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  738793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  738812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738819 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64),
     /*  738822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738841 */     GIR_RootConstrainSelectedInstOperands,
     /*  738842 */     // GIR_Coverage, 12155,
     /*  738842 */     GIR_EraseRootFromParent_Done,
     /*  738843 */   // Label 11577: @738843
     /*  738843 */   GIM_Try, /*On fail goto*//*Label 11578*/ GIMT_Encode4(738918), // Rule ID 12158 //
     /*  738848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  738851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  738859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  738862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  738865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  738868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  738871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  738894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  738897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738916 */     GIR_RootConstrainSelectedInstOperands,
     /*  738917 */     // GIR_Coverage, 12158,
     /*  738917 */     GIR_EraseRootFromParent_Done,
     /*  738918 */   // Label 11578: @738918
     /*  738918 */   GIM_Try, /*On fail goto*//*Label 11579*/ GIMT_Encode4(738993), // Rule ID 12159 //
     /*  738923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  738926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  738931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  738934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  738937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  738940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  738943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  738946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  738962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  738969 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  738969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64),
     /*  738972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  738974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  738976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  738978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  738980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  738985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  738988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  738991 */     GIR_RootConstrainSelectedInstOperands,
     /*  738992 */     // GIR_Coverage, 12159,
     /*  738992 */     GIR_EraseRootFromParent_Done,
     /*  738993 */   // Label 11579: @738993
     /*  738993 */   GIM_Try, /*On fail goto*//*Label 11580*/ GIMT_Encode4(739068), // Rule ID 12162 //
     /*  738998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739044 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739066 */     GIR_RootConstrainSelectedInstOperands,
     /*  739067 */     // GIR_Coverage, 12162,
     /*  739067 */     GIR_EraseRootFromParent_Done,
     /*  739068 */   // Label 11580: @739068
     /*  739068 */   GIM_Try, /*On fail goto*//*Label 11581*/ GIMT_Encode4(739143), // Rule ID 12163 //
     /*  739073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  739084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  739087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  739090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739119 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8),
     /*  739122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739141 */     GIR_RootConstrainSelectedInstOperands,
     /*  739142 */     // GIR_Coverage, 12163,
     /*  739142 */     GIR_EraseRootFromParent_Done,
     /*  739143 */   // Label 11581: @739143
     /*  739143 */   GIM_Try, /*On fail goto*//*Label 11582*/ GIMT_Encode4(739218), // Rule ID 12166 //
     /*  739148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739194 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739216 */     GIR_RootConstrainSelectedInstOperands,
     /*  739217 */     // GIR_Coverage, 12166,
     /*  739217 */     GIR_EraseRootFromParent_Done,
     /*  739218 */   // Label 11582: @739218
     /*  739218 */   GIM_Try, /*On fail goto*//*Label 11583*/ GIMT_Encode4(739293), // Rule ID 12167 //
     /*  739223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  739234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  739237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  739240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739269 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8),
     /*  739272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739291 */     GIR_RootConstrainSelectedInstOperands,
     /*  739292 */     // GIR_Coverage, 12167,
     /*  739292 */     GIR_EraseRootFromParent_Done,
     /*  739293 */   // Label 11583: @739293
     /*  739293 */   GIM_Try, /*On fail goto*//*Label 11584*/ GIMT_Encode4(739368), // Rule ID 12170 //
     /*  739298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739366 */     GIR_RootConstrainSelectedInstOperands,
     /*  739367 */     // GIR_Coverage, 12170,
     /*  739367 */     GIR_EraseRootFromParent_Done,
     /*  739368 */   // Label 11584: @739368
     /*  739368 */   GIM_Try, /*On fail goto*//*Label 11585*/ GIMT_Encode4(739443), // Rule ID 12171 //
     /*  739373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  739384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  739387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  739390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739419 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  739419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8),
     /*  739422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739441 */     GIR_RootConstrainSelectedInstOperands,
     /*  739442 */     // GIR_Coverage, 12171,
     /*  739442 */     GIR_EraseRootFromParent_Done,
     /*  739443 */   // Label 11585: @739443
     /*  739443 */   GIM_Try, /*On fail goto*//*Label 11586*/ GIMT_Encode4(739518), // Rule ID 12174 //
     /*  739448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  739459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  739462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  739465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  739497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739516 */     GIR_RootConstrainSelectedInstOperands,
     /*  739517 */     // GIR_Coverage, 12174,
     /*  739517 */     GIR_EraseRootFromParent_Done,
     /*  739518 */   // Label 11586: @739518
     /*  739518 */   GIM_Try, /*On fail goto*//*Label 11587*/ GIMT_Encode4(739593), // Rule ID 12175 //
     /*  739523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  739534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  739537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  739540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739569 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16),
     /*  739572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739591 */     GIR_RootConstrainSelectedInstOperands,
     /*  739592 */     // GIR_Coverage, 12175,
     /*  739592 */     GIR_EraseRootFromParent_Done,
     /*  739593 */   // Label 11587: @739593
     /*  739593 */   GIM_Try, /*On fail goto*//*Label 11588*/ GIMT_Encode4(739668), // Rule ID 12178 //
     /*  739598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  739609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  739612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  739615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739644 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  739644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  739647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739666 */     GIR_RootConstrainSelectedInstOperands,
     /*  739667 */     // GIR_Coverage, 12178,
     /*  739667 */     GIR_EraseRootFromParent_Done,
     /*  739668 */   // Label 11588: @739668
     /*  739668 */   GIM_Try, /*On fail goto*//*Label 11589*/ GIMT_Encode4(739743), // Rule ID 12179 //
     /*  739673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  739684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  739687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  739690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739719 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  739719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16),
     /*  739722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  739738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739741 */     GIR_RootConstrainSelectedInstOperands,
     /*  739742 */     // GIR_Coverage, 12179,
     /*  739742 */     GIR_EraseRootFromParent_Done,
     /*  739743 */   // Label 11589: @739743
     /*  739743 */   GIM_Try, /*On fail goto*//*Label 11590*/ GIMT_Encode4(739818), // Rule ID 12182 //
     /*  739748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  739759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  739762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  739765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  739794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  739797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739816 */     GIR_RootConstrainSelectedInstOperands,
     /*  739817 */     // GIR_Coverage, 12182,
     /*  739817 */     GIR_EraseRootFromParent_Done,
     /*  739818 */   // Label 11590: @739818
     /*  739818 */   GIM_Try, /*On fail goto*//*Label 11591*/ GIMT_Encode4(739893), // Rule ID 12183 //
     /*  739823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  739834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  739837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  739840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739869 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  739869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32),
     /*  739872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  739888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739891 */     GIR_RootConstrainSelectedInstOperands,
     /*  739892 */     // GIR_Coverage, 12183,
     /*  739892 */     GIR_EraseRootFromParent_Done,
     /*  739893 */   // Label 11591: @739893
     /*  739893 */   GIM_Try, /*On fail goto*//*Label 11592*/ GIMT_Encode4(739968), // Rule ID 12186 //
     /*  739898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  739901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  739909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  739912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  739915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  739918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  739921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  739933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  739937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  739944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  739944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  739947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  739949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  739951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  739953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  739955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  739960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  739963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  739966 */     GIR_RootConstrainSelectedInstOperands,
     /*  739967 */     // GIR_Coverage, 12186,
     /*  739967 */     GIR_EraseRootFromParent_Done,
     /*  739968 */   // Label 11592: @739968
     /*  739968 */   GIM_Try, /*On fail goto*//*Label 11593*/ GIMT_Encode4(740043), // Rule ID 12187 //
     /*  739973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  739976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  739981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  739984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  739987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  739990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  739993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  739996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740019 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11444:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8),
     /*  740022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740041 */     GIR_RootConstrainSelectedInstOperands,
     /*  740042 */     // GIR_Coverage, 12187,
     /*  740042 */     GIR_EraseRootFromParent_Done,
     /*  740043 */   // Label 11593: @740043
     /*  740043 */   GIM_Try, /*On fail goto*//*Label 11594*/ GIMT_Encode4(740118), // Rule ID 12190 //
     /*  740048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740116 */     GIR_RootConstrainSelectedInstOperands,
     /*  740117 */     // GIR_Coverage, 12190,
     /*  740117 */     GIR_EraseRootFromParent_Done,
     /*  740118 */   // Label 11594: @740118
     /*  740118 */   GIM_Try, /*On fail goto*//*Label 11595*/ GIMT_Encode4(740193), // Rule ID 12191 //
     /*  740123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  740134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  740137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  740140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740169 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11444:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  740169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16),
     /*  740172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  740188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740191 */     GIR_RootConstrainSelectedInstOperands,
     /*  740192 */     // GIR_Coverage, 12191,
     /*  740192 */     GIR_EraseRootFromParent_Done,
     /*  740193 */   // Label 11595: @740193
     /*  740193 */   GIM_Try, /*On fail goto*//*Label 11596*/ GIMT_Encode4(740268), // Rule ID 12194 //
     /*  740198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  740244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740266 */     GIR_RootConstrainSelectedInstOperands,
     /*  740267 */     // GIR_Coverage, 12194,
     /*  740267 */     GIR_EraseRootFromParent_Done,
     /*  740268 */   // Label 11596: @740268
     /*  740268 */   GIM_Try, /*On fail goto*//*Label 11597*/ GIMT_Encode4(740343), // Rule ID 12195 //
     /*  740273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  740284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  740287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  740290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740319 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11444:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  740319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32),
     /*  740322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  740338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740341 */     GIR_RootConstrainSelectedInstOperands,
     /*  740342 */     // GIR_Coverage, 12195,
     /*  740342 */     GIR_EraseRootFromParent_Done,
     /*  740343 */   // Label 11597: @740343
     /*  740343 */   GIM_Try, /*On fail goto*//*Label 11598*/ GIMT_Encode4(740418), // Rule ID 12198 //
     /*  740348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  740351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740394 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  740394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740416 */     GIR_RootConstrainSelectedInstOperands,
     /*  740417 */     // GIR_Coverage, 12198,
     /*  740417 */     GIR_EraseRootFromParent_Done,
     /*  740418 */   // Label 11598: @740418
     /*  740418 */   GIM_Try, /*On fail goto*//*Label 11599*/ GIMT_Encode4(740493), // Rule ID 12199 //
     /*  740423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  740426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  740434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  740437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  740440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  740458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740469 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11444:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  740469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64),
     /*  740472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  740488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740491 */     GIR_RootConstrainSelectedInstOperands,
     /*  740492 */     // GIR_Coverage, 12199,
     /*  740492 */     GIR_EraseRootFromParent_Done,
     /*  740493 */   // Label 11599: @740493
     /*  740493 */   GIM_Try, /*On fail goto*//*Label 11600*/ GIMT_Encode4(740568), // Rule ID 12202 //
     /*  740498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  740509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  740512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  740515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  740547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740566 */     GIR_RootConstrainSelectedInstOperands,
     /*  740567 */     // GIR_Coverage, 12202,
     /*  740567 */     GIR_EraseRootFromParent_Done,
     /*  740568 */   // Label 11600: @740568
     /*  740568 */   GIM_Try, /*On fail goto*//*Label 11601*/ GIMT_Encode4(740643), // Rule ID 12203 //
     /*  740573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  740584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  740587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  740590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740619 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8),
     /*  740622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740641 */     GIR_RootConstrainSelectedInstOperands,
     /*  740642 */     // GIR_Coverage, 12203,
     /*  740642 */     GIR_EraseRootFromParent_Done,
     /*  740643 */   // Label 11601: @740643
     /*  740643 */   GIM_Try, /*On fail goto*//*Label 11602*/ GIMT_Encode4(740718), // Rule ID 12206 //
     /*  740648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  740659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  740662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  740665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740694 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  740697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740716 */     GIR_RootConstrainSelectedInstOperands,
     /*  740717 */     // GIR_Coverage, 12206,
     /*  740717 */     GIR_EraseRootFromParent_Done,
     /*  740718 */   // Label 11602: @740718
     /*  740718 */   GIM_Try, /*On fail goto*//*Label 11603*/ GIMT_Encode4(740793), // Rule ID 12207 //
     /*  740723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  740734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  740737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  740740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  740758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740769 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8),
     /*  740772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740791 */     GIR_RootConstrainSelectedInstOperands,
     /*  740792 */     // GIR_Coverage, 12207,
     /*  740792 */     GIR_EraseRootFromParent_Done,
     /*  740793 */   // Label 11603: @740793
     /*  740793 */   GIM_Try, /*On fail goto*//*Label 11604*/ GIMT_Encode4(740868), // Rule ID 12210 //
     /*  740798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  740809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  740812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  740815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740844 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  740844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  740847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740866 */     GIR_RootConstrainSelectedInstOperands,
     /*  740867 */     // GIR_Coverage, 12210,
     /*  740867 */     GIR_EraseRootFromParent_Done,
     /*  740868 */   // Label 11604: @740868
     /*  740868 */   GIM_Try, /*On fail goto*//*Label 11605*/ GIMT_Encode4(740943), // Rule ID 12211 //
     /*  740873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  740876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  740884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  740887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  740890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  740893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  740896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  740908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740919 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  740919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8),
     /*  740922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  740926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  740928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  740930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  740935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  740938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  740941 */     GIR_RootConstrainSelectedInstOperands,
     /*  740942 */     // GIR_Coverage, 12211,
     /*  740942 */     GIR_EraseRootFromParent_Done,
     /*  740943 */   // Label 11605: @740943
     /*  740943 */   GIM_Try, /*On fail goto*//*Label 11606*/ GIMT_Encode4(741018), // Rule ID 12214 //
     /*  740948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  740951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  740956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  740959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  740962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  740965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  740968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  740971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  740983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  740987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  740994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  740994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  740997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  740999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741016 */     GIR_RootConstrainSelectedInstOperands,
     /*  741017 */     // GIR_Coverage, 12214,
     /*  741017 */     GIR_EraseRootFromParent_Done,
     /*  741018 */   // Label 11606: @741018
     /*  741018 */   GIM_Try, /*On fail goto*//*Label 11607*/ GIMT_Encode4(741093), // Rule ID 12215 //
     /*  741023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  741034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  741037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  741040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16),
     /*  741072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741091 */     GIR_RootConstrainSelectedInstOperands,
     /*  741092 */     // GIR_Coverage, 12215,
     /*  741092 */     GIR_EraseRootFromParent_Done,
     /*  741093 */   // Label 11607: @741093
     /*  741093 */   GIM_Try, /*On fail goto*//*Label 11608*/ GIMT_Encode4(741168), // Rule ID 12218 //
     /*  741098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741144 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741166 */     GIR_RootConstrainSelectedInstOperands,
     /*  741167 */     // GIR_Coverage, 12218,
     /*  741167 */     GIR_EraseRootFromParent_Done,
     /*  741168 */   // Label 11608: @741168
     /*  741168 */   GIM_Try, /*On fail goto*//*Label 11609*/ GIMT_Encode4(741243), // Rule ID 12219 //
     /*  741173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  741184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  741187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  741190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16),
     /*  741222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741241 */     GIR_RootConstrainSelectedInstOperands,
     /*  741242 */     // GIR_Coverage, 12219,
     /*  741242 */     GIR_EraseRootFromParent_Done,
     /*  741243 */   // Label 11609: @741243
     /*  741243 */   GIM_Try, /*On fail goto*//*Label 11610*/ GIMT_Encode4(741318), // Rule ID 12222 //
     /*  741248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741294 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  741294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741316 */     GIR_RootConstrainSelectedInstOperands,
     /*  741317 */     // GIR_Coverage, 12222,
     /*  741317 */     GIR_EraseRootFromParent_Done,
     /*  741318 */   // Label 11610: @741318
     /*  741318 */   GIM_Try, /*On fail goto*//*Label 11611*/ GIMT_Encode4(741393), // Rule ID 12223 //
     /*  741323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  741334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  741337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  741340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741369 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  741369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16),
     /*  741372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  741388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741391 */     GIR_RootConstrainSelectedInstOperands,
     /*  741392 */     // GIR_Coverage, 12223,
     /*  741392 */     GIR_EraseRootFromParent_Done,
     /*  741393 */   // Label 11611: @741393
     /*  741393 */   GIM_Try, /*On fail goto*//*Label 11612*/ GIMT_Encode4(741468), // Rule ID 12226 //
     /*  741398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  741409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  741412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  741415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741444 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  741447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741466 */     GIR_RootConstrainSelectedInstOperands,
     /*  741467 */     // GIR_Coverage, 12226,
     /*  741467 */     GIR_EraseRootFromParent_Done,
     /*  741468 */   // Label 11612: @741468
     /*  741468 */   GIM_Try, /*On fail goto*//*Label 11613*/ GIMT_Encode4(741543), // Rule ID 12227 //
     /*  741473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  741484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  741487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  741490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32),
     /*  741522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741541 */     GIR_RootConstrainSelectedInstOperands,
     /*  741542 */     // GIR_Coverage, 12227,
     /*  741542 */     GIR_EraseRootFromParent_Done,
     /*  741543 */   // Label 11613: @741543
     /*  741543 */   GIM_Try, /*On fail goto*//*Label 11614*/ GIMT_Encode4(741618), // Rule ID 12230 //
     /*  741548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  741559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  741562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  741565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  741597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741616 */     GIR_RootConstrainSelectedInstOperands,
     /*  741617 */     // GIR_Coverage, 12230,
     /*  741617 */     GIR_EraseRootFromParent_Done,
     /*  741618 */   // Label 11614: @741618
     /*  741618 */   GIM_Try, /*On fail goto*//*Label 11615*/ GIMT_Encode4(741693), // Rule ID 12231 //
     /*  741623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  741634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  741637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  741640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  741658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32),
     /*  741672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741691 */     GIR_RootConstrainSelectedInstOperands,
     /*  741692 */     // GIR_Coverage, 12231,
     /*  741692 */     GIR_EraseRootFromParent_Done,
     /*  741693 */   // Label 11615: @741693
     /*  741693 */   GIM_Try, /*On fail goto*//*Label 11616*/ GIMT_Encode4(741768), // Rule ID 12234 //
     /*  741698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  741701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  741709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  741712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  741715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  741744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  741747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741766 */     GIR_RootConstrainSelectedInstOperands,
     /*  741767 */     // GIR_Coverage, 12234,
     /*  741767 */     GIR_EraseRootFromParent_Done,
     /*  741768 */   // Label 11616: @741768
     /*  741768 */   GIM_Try, /*On fail goto*//*Label 11617*/ GIMT_Encode4(741843), // Rule ID 12235 //
     /*  741773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  741776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  741784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  741787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  741790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  741808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  741819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32),
     /*  741822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  741838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741841 */     GIR_RootConstrainSelectedInstOperands,
     /*  741842 */     // GIR_Coverage, 12235,
     /*  741842 */     GIR_EraseRootFromParent_Done,
     /*  741843 */   // Label 11617: @741843
     /*  741843 */   GIM_Try, /*On fail goto*//*Label 11618*/ GIMT_Encode4(741918), // Rule ID 12238 //
     /*  741848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  741851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  741859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  741862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  741865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  741868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  741871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  741894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  741897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741916 */     GIR_RootConstrainSelectedInstOperands,
     /*  741917 */     // GIR_Coverage, 12238,
     /*  741917 */     GIR_EraseRootFromParent_Done,
     /*  741918 */   // Label 11618: @741918
     /*  741918 */   GIM_Try, /*On fail goto*//*Label 11619*/ GIMT_Encode4(741993), // Rule ID 12239 //
     /*  741923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  741926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  741931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  741934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  741937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  741940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  741943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  741946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  741958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  741962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  741969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11444:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  741969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64),
     /*  741972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  741974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  741976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  741978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  741980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  741985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  741988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  741991 */     GIR_RootConstrainSelectedInstOperands,
     /*  741992 */     // GIR_Coverage, 12239,
     /*  741992 */     GIR_EraseRootFromParent_Done,
     /*  741993 */   // Label 11619: @741993
     /*  741993 */   GIM_Try, /*On fail goto*//*Label 11620*/ GIMT_Encode4(742068), // Rule ID 12242 //
     /*  741998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742066 */     GIR_RootConstrainSelectedInstOperands,
     /*  742067 */     // GIR_Coverage, 12242,
     /*  742067 */     GIR_EraseRootFromParent_Done,
     /*  742068 */   // Label 11620: @742068
     /*  742068 */   GIM_Try, /*On fail goto*//*Label 11621*/ GIMT_Encode4(742143), // Rule ID 12243 //
     /*  742073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  742084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  742087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  742090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11444:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64),
     /*  742122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742141 */     GIR_RootConstrainSelectedInstOperands,
     /*  742142 */     // GIR_Coverage, 12243,
     /*  742142 */     GIR_EraseRootFromParent_Done,
     /*  742143 */   // Label 11621: @742143
     /*  742143 */   GIM_Try, /*On fail goto*//*Label 11622*/ GIMT_Encode4(742218), // Rule ID 12246 //
     /*  742148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  742151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  742168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  742194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742216 */     GIR_RootConstrainSelectedInstOperands,
     /*  742217 */     // GIR_Coverage, 12246,
     /*  742217 */     GIR_EraseRootFromParent_Done,
     /*  742218 */   // Label 11622: @742218
     /*  742218 */   GIM_Try, /*On fail goto*//*Label 11623*/ GIMT_Encode4(742293), // Rule ID 12247 //
     /*  742223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  742226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem),
     /*  742231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  742234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  742237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  742240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  742243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  742258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  742262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11444:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREM_VX_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  742269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64),
     /*  742272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  742288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742291 */     GIR_RootConstrainSelectedInstOperands,
     /*  742292 */     // GIR_Coverage, 12247,
     /*  742292 */     GIR_EraseRootFromParent_Done,
     /*  742293 */   // Label 11623: @742293
     /*  742293 */   GIM_Try, /*On fail goto*//*Label 11624*/ GIMT_Encode4(742368), // Rule ID 12250 //
     /*  742298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742366 */     GIR_RootConstrainSelectedInstOperands,
     /*  742367 */     // GIR_Coverage, 12250,
     /*  742367 */     GIR_EraseRootFromParent_Done,
     /*  742368 */   // Label 11624: @742368
     /*  742368 */   GIM_Try, /*On fail goto*//*Label 11625*/ GIMT_Encode4(742443), // Rule ID 12251 //
     /*  742373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  742384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  742387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  742390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  742393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8),
     /*  742422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742441 */     GIR_RootConstrainSelectedInstOperands,
     /*  742442 */     // GIR_Coverage, 12251,
     /*  742442 */     GIR_EraseRootFromParent_Done,
     /*  742443 */   // Label 11625: @742443
     /*  742443 */   GIM_Try, /*On fail goto*//*Label 11626*/ GIMT_Encode4(742518), // Rule ID 12254 //
     /*  742448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  742459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  742462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  742465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  742468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  742497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742516 */     GIR_RootConstrainSelectedInstOperands,
     /*  742517 */     // GIR_Coverage, 12254,
     /*  742517 */     GIR_EraseRootFromParent_Done,
     /*  742518 */   // Label 11626: @742518
     /*  742518 */   GIM_Try, /*On fail goto*//*Label 11627*/ GIMT_Encode4(742593), // Rule ID 12255 //
     /*  742523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  742534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  742537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  742540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  742543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  742572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742591 */     GIR_RootConstrainSelectedInstOperands,
     /*  742592 */     // GIR_Coverage, 12255,
     /*  742592 */     GIR_EraseRootFromParent_Done,
     /*  742593 */   // Label 11627: @742593
     /*  742593 */   GIM_Try, /*On fail goto*//*Label 11628*/ GIMT_Encode4(742668), // Rule ID 12258 //
     /*  742598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  742615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  742618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  742647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742666 */     GIR_RootConstrainSelectedInstOperands,
     /*  742667 */     // GIR_Coverage, 12258,
     /*  742667 */     GIR_EraseRootFromParent_Done,
     /*  742668 */   // Label 11628: @742668
     /*  742668 */   GIM_Try, /*On fail goto*//*Label 11629*/ GIMT_Encode4(742743), // Rule ID 12259 //
     /*  742673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  742684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  742687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  742690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  742693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  742722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742741 */     GIR_RootConstrainSelectedInstOperands,
     /*  742742 */     // GIR_Coverage, 12259,
     /*  742742 */     GIR_EraseRootFromParent_Done,
     /*  742743 */   // Label 11629: @742743
     /*  742743 */   GIM_Try, /*On fail goto*//*Label 11630*/ GIMT_Encode4(742818), // Rule ID 12262 //
     /*  742748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  742765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  742768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  742797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742816 */     GIR_RootConstrainSelectedInstOperands,
     /*  742817 */     // GIR_Coverage, 12262,
     /*  742817 */     GIR_EraseRootFromParent_Done,
     /*  742818 */   // Label 11630: @742818
     /*  742818 */   GIM_Try, /*On fail goto*//*Label 11631*/ GIMT_Encode4(742893), // Rule ID 12263 //
     /*  742823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  742834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  742837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  742840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  742843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  742862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  742869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  742872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742891 */     GIR_RootConstrainSelectedInstOperands,
     /*  742892 */     // GIR_Coverage, 12263,
     /*  742892 */     GIR_EraseRootFromParent_Done,
     /*  742893 */   // Label 11631: @742893
     /*  742893 */   GIM_Try, /*On fail goto*//*Label 11632*/ GIMT_Encode4(742968), // Rule ID 12266 //
     /*  742898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  742901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  742915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  742918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  742921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  742929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  742937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  742944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  742944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  742947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  742949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  742951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  742953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  742955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  742960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  742963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  742966 */     GIR_RootConstrainSelectedInstOperands,
     /*  742967 */     // GIR_Coverage, 12266,
     /*  742967 */     GIR_EraseRootFromParent_Done,
     /*  742968 */   // Label 11632: @742968
     /*  742968 */   GIM_Try, /*On fail goto*//*Label 11633*/ GIMT_Encode4(743043), // Rule ID 12267 //
     /*  742973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  742976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  742981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  742984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  742987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  742990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  742993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  742996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743041 */     GIR_RootConstrainSelectedInstOperands,
     /*  743042 */     // GIR_Coverage, 12267,
     /*  743042 */     GIR_EraseRootFromParent_Done,
     /*  743043 */   // Label 11633: @743043
     /*  743043 */   GIM_Try, /*On fail goto*//*Label 11634*/ GIMT_Encode4(743118), // Rule ID 12270 //
     /*  743048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  743094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743116 */     GIR_RootConstrainSelectedInstOperands,
     /*  743117 */     // GIR_Coverage, 12270,
     /*  743117 */     GIR_EraseRootFromParent_Done,
     /*  743118 */   // Label 11634: @743118
     /*  743118 */   GIM_Try, /*On fail goto*//*Label 11635*/ GIMT_Encode4(743193), // Rule ID 12271 //
     /*  743123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  743134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  743137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  743140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  743143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  743169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  743188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743191 */     GIR_RootConstrainSelectedInstOperands,
     /*  743192 */     // GIR_Coverage, 12271,
     /*  743192 */     GIR_EraseRootFromParent_Done,
     /*  743193 */   // Label 11635: @743193
     /*  743193 */   GIM_Try, /*On fail goto*//*Label 11636*/ GIMT_Encode4(743268), // Rule ID 12274 //
     /*  743198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743266 */     GIR_RootConstrainSelectedInstOperands,
     /*  743267 */     // GIR_Coverage, 12274,
     /*  743267 */     GIR_EraseRootFromParent_Done,
     /*  743268 */   // Label 11636: @743268
     /*  743268 */   GIM_Try, /*On fail goto*//*Label 11637*/ GIMT_Encode4(743343), // Rule ID 12275 //
     /*  743273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  743284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  743287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  743290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  743293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4),
     /*  743322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743341 */     GIR_RootConstrainSelectedInstOperands,
     /*  743342 */     // GIR_Coverage, 12275,
     /*  743342 */     GIR_EraseRootFromParent_Done,
     /*  743343 */   // Label 11637: @743343
     /*  743343 */   GIM_Try, /*On fail goto*//*Label 11638*/ GIMT_Encode4(743418), // Rule ID 12278 //
     /*  743348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743416 */     GIR_RootConstrainSelectedInstOperands,
     /*  743417 */     // GIR_Coverage, 12278,
     /*  743417 */     GIR_EraseRootFromParent_Done,
     /*  743418 */   // Label 11638: @743418
     /*  743418 */   GIM_Try, /*On fail goto*//*Label 11639*/ GIMT_Encode4(743493), // Rule ID 12279 //
     /*  743423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  743434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  743437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  743440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  743443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743469 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743491 */     GIR_RootConstrainSelectedInstOperands,
     /*  743492 */     // GIR_Coverage, 12279,
     /*  743492 */     GIR_EraseRootFromParent_Done,
     /*  743493 */   // Label 11639: @743493
     /*  743493 */   GIM_Try, /*On fail goto*//*Label 11640*/ GIMT_Encode4(743568), // Rule ID 12282 //
     /*  743498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  743509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  743512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  743515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743566 */     GIR_RootConstrainSelectedInstOperands,
     /*  743567 */     // GIR_Coverage, 12282,
     /*  743567 */     GIR_EraseRootFromParent_Done,
     /*  743568 */   // Label 11640: @743568
     /*  743568 */   GIM_Try, /*On fail goto*//*Label 11641*/ GIMT_Encode4(743643), // Rule ID 12283 //
     /*  743573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  743584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  743587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  743590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  743593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  743622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743641 */     GIR_RootConstrainSelectedInstOperands,
     /*  743642 */     // GIR_Coverage, 12283,
     /*  743642 */     GIR_EraseRootFromParent_Done,
     /*  743643 */   // Label 11641: @743643
     /*  743643 */   GIM_Try, /*On fail goto*//*Label 11642*/ GIMT_Encode4(743718), // Rule ID 12286 //
     /*  743648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  743659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  743662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  743665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  743668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743716 */     GIR_RootConstrainSelectedInstOperands,
     /*  743717 */     // GIR_Coverage, 12286,
     /*  743717 */     GIR_EraseRootFromParent_Done,
     /*  743718 */   // Label 11642: @743718
     /*  743718 */   GIM_Try, /*On fail goto*//*Label 11643*/ GIMT_Encode4(743793), // Rule ID 12287 //
     /*  743723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  743734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  743737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  743740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  743743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  743762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  743772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743791 */     GIR_RootConstrainSelectedInstOperands,
     /*  743792 */     // GIR_Coverage, 12287,
     /*  743792 */     GIR_EraseRootFromParent_Done,
     /*  743793 */   // Label 11643: @743793
     /*  743793 */   GIM_Try, /*On fail goto*//*Label 11644*/ GIMT_Encode4(743868), // Rule ID 12290 //
     /*  743798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  743801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  743809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  743812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  743815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  743818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  743844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743866 */     GIR_RootConstrainSelectedInstOperands,
     /*  743867 */     // GIR_Coverage, 12290,
     /*  743867 */     GIR_EraseRootFromParent_Done,
     /*  743868 */   // Label 11644: @743868
     /*  743868 */   GIM_Try, /*On fail goto*//*Label 11645*/ GIMT_Encode4(743943), // Rule ID 12291 //
     /*  743873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  743876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  743884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  743887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  743890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  743893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  743896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  743904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  743912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  743919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  743922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  743926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  743928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  743930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  743935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  743938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  743941 */     GIR_RootConstrainSelectedInstOperands,
     /*  743942 */     // GIR_Coverage, 12291,
     /*  743942 */     GIR_EraseRootFromParent_Done,
     /*  743943 */   // Label 11645: @743943
     /*  743943 */   GIM_Try, /*On fail goto*//*Label 11646*/ GIMT_Encode4(744018), // Rule ID 12294 //
     /*  743948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  743951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  743956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  743959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  743962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  743965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  743968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  743971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  743987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  743994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  743994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  743997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  743999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744016 */     GIR_RootConstrainSelectedInstOperands,
     /*  744017 */     // GIR_Coverage, 12294,
     /*  744017 */     GIR_EraseRootFromParent_Done,
     /*  744018 */   // Label 11646: @744018
     /*  744018 */   GIM_Try, /*On fail goto*//*Label 11647*/ GIMT_Encode4(744093), // Rule ID 12295 //
     /*  744023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  744034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  744037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  744040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  744043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744069 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2),
     /*  744072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744091 */     GIR_RootConstrainSelectedInstOperands,
     /*  744092 */     // GIR_Coverage, 12295,
     /*  744092 */     GIR_EraseRootFromParent_Done,
     /*  744093 */   // Label 11647: @744093
     /*  744093 */   GIM_Try, /*On fail goto*//*Label 11648*/ GIMT_Encode4(744168), // Rule ID 12298 //
     /*  744098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744166 */     GIR_RootConstrainSelectedInstOperands,
     /*  744167 */     // GIR_Coverage, 12298,
     /*  744167 */     GIR_EraseRootFromParent_Done,
     /*  744168 */   // Label 11648: @744168
     /*  744168 */   GIM_Try, /*On fail goto*//*Label 11649*/ GIMT_Encode4(744243), // Rule ID 12299 //
     /*  744173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  744184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  744187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  744190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  744193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1),
     /*  744222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744241 */     GIR_RootConstrainSelectedInstOperands,
     /*  744242 */     // GIR_Coverage, 12299,
     /*  744242 */     GIR_EraseRootFromParent_Done,
     /*  744243 */   // Label 11649: @744243
     /*  744243 */   GIM_Try, /*On fail goto*//*Label 11650*/ GIMT_Encode4(744318), // Rule ID 12302 //
     /*  744248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744316 */     GIR_RootConstrainSelectedInstOperands,
     /*  744317 */     // GIR_Coverage, 12302,
     /*  744317 */     GIR_EraseRootFromParent_Done,
     /*  744318 */   // Label 11650: @744318
     /*  744318 */   GIM_Try, /*On fail goto*//*Label 11651*/ GIMT_Encode4(744393), // Rule ID 12303 //
     /*  744323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  744334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  744337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  744340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  744343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  744362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744369 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2),
     /*  744372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744391 */     GIR_RootConstrainSelectedInstOperands,
     /*  744392 */     // GIR_Coverage, 12303,
     /*  744392 */     GIR_EraseRootFromParent_Done,
     /*  744393 */   // Label 11651: @744393
     /*  744393 */   GIM_Try, /*On fail goto*//*Label 11652*/ GIMT_Encode4(744468), // Rule ID 12306 //
     /*  744398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  744401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  744409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  744412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  744415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  744418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744444 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  744444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744466 */     GIR_RootConstrainSelectedInstOperands,
     /*  744467 */     // GIR_Coverage, 12306,
     /*  744467 */     GIR_EraseRootFromParent_Done,
     /*  744468 */   // Label 11652: @744468
     /*  744468 */   GIM_Try, /*On fail goto*//*Label 11653*/ GIMT_Encode4(744543), // Rule ID 12307 //
     /*  744473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  744476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  744484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  744487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  744490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  744493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  744504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  744512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744519 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  744519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4),
     /*  744522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  744538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744541 */     GIR_RootConstrainSelectedInstOperands,
     /*  744542 */     // GIR_Coverage, 12307,
     /*  744542 */     GIR_EraseRootFromParent_Done,
     /*  744543 */   // Label 11653: @744543
     /*  744543 */   GIM_Try, /*On fail goto*//*Label 11654*/ GIMT_Encode4(744618), // Rule ID 12310 //
     /*  744548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  744559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  744562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  744565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  744597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744616 */     GIR_RootConstrainSelectedInstOperands,
     /*  744617 */     // GIR_Coverage, 12310,
     /*  744617 */     GIR_EraseRootFromParent_Done,
     /*  744618 */   // Label 11654: @744618
     /*  744618 */   GIM_Try, /*On fail goto*//*Label 11655*/ GIMT_Encode4(744693), // Rule ID 12311 //
     /*  744623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  744634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  744637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  744640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8),
     /*  744672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744691 */     GIR_RootConstrainSelectedInstOperands,
     /*  744692 */     // GIR_Coverage, 12311,
     /*  744692 */     GIR_EraseRootFromParent_Done,
     /*  744693 */   // Label 11655: @744693
     /*  744693 */   GIM_Try, /*On fail goto*//*Label 11656*/ GIMT_Encode4(744768), // Rule ID 12314 //
     /*  744698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  744709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  744712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  744715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  744747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744766 */     GIR_RootConstrainSelectedInstOperands,
     /*  744767 */     // GIR_Coverage, 12314,
     /*  744767 */     GIR_EraseRootFromParent_Done,
     /*  744768 */   // Label 11656: @744768
     /*  744768 */   GIM_Try, /*On fail goto*//*Label 11657*/ GIMT_Encode4(744843), // Rule ID 12315 //
     /*  744773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  744784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  744787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  744790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  744822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744841 */     GIR_RootConstrainSelectedInstOperands,
     /*  744842 */     // GIR_Coverage, 12315,
     /*  744842 */     GIR_EraseRootFromParent_Done,
     /*  744843 */   // Label 11657: @744843
     /*  744843 */   GIM_Try, /*On fail goto*//*Label 11658*/ GIMT_Encode4(744918), // Rule ID 12318 //
     /*  744848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  744851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  744865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  744868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  744871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  744894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  744897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744916 */     GIR_RootConstrainSelectedInstOperands,
     /*  744917 */     // GIR_Coverage, 12318,
     /*  744917 */     GIR_EraseRootFromParent_Done,
     /*  744918 */   // Label 11658: @744918
     /*  744918 */   GIM_Try, /*On fail goto*//*Label 11659*/ GIMT_Encode4(744993), // Rule ID 12319 //
     /*  744923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  744926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  744931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  744934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  744937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  744940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  744943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  744946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  744958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  744962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  744969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11586:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  744969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  744972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  744974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  744976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  744978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  744980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  744985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  744988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  744991 */     GIR_RootConstrainSelectedInstOperands,
     /*  744992 */     // GIR_Coverage, 12319,
     /*  744992 */     GIR_EraseRootFromParent_Done,
     /*  744993 */   // Label 11659: @744993
     /*  744993 */   GIM_Try, /*On fail goto*//*Label 11660*/ GIMT_Encode4(745068), // Rule ID 12322 //
     /*  744998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745066 */     GIR_RootConstrainSelectedInstOperands,
     /*  745067 */     // GIR_Coverage, 12322,
     /*  745067 */     GIR_EraseRootFromParent_Done,
     /*  745068 */   // Label 11660: @745068
     /*  745068 */   GIM_Try, /*On fail goto*//*Label 11661*/ GIMT_Encode4(745143), // Rule ID 12323 //
     /*  745073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  745084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  745087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  745090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745141 */     GIR_RootConstrainSelectedInstOperands,
     /*  745142 */     // GIR_Coverage, 12323,
     /*  745142 */     GIR_EraseRootFromParent_Done,
     /*  745143 */   // Label 11661: @745143
     /*  745143 */   GIM_Try, /*On fail goto*//*Label 11662*/ GIMT_Encode4(745218), // Rule ID 12326 //
     /*  745148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745216 */     GIR_RootConstrainSelectedInstOperands,
     /*  745217 */     // GIR_Coverage, 12326,
     /*  745217 */     GIR_EraseRootFromParent_Done,
     /*  745218 */   // Label 11662: @745218
     /*  745218 */   GIM_Try, /*On fail goto*//*Label 11663*/ GIMT_Encode4(745293), // Rule ID 12327 //
     /*  745223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  745234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  745237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  745240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745291 */     GIR_RootConstrainSelectedInstOperands,
     /*  745292 */     // GIR_Coverage, 12327,
     /*  745292 */     GIR_EraseRootFromParent_Done,
     /*  745293 */   // Label 11663: @745293
     /*  745293 */   GIM_Try, /*On fail goto*//*Label 11664*/ GIMT_Encode4(745368), // Rule ID 12330 //
     /*  745298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  745344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745366 */     GIR_RootConstrainSelectedInstOperands,
     /*  745367 */     // GIR_Coverage, 12330,
     /*  745367 */     GIR_EraseRootFromParent_Done,
     /*  745368 */   // Label 11664: @745368
     /*  745368 */   GIM_Try, /*On fail goto*//*Label 11665*/ GIMT_Encode4(745443), // Rule ID 12331 //
     /*  745373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  745384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  745387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  745390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  745404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  745419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  745422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  745438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745441 */     GIR_RootConstrainSelectedInstOperands,
     /*  745442 */     // GIR_Coverage, 12331,
     /*  745442 */     GIR_EraseRootFromParent_Done,
     /*  745443 */   // Label 11665: @745443
     /*  745443 */   GIM_Try, /*On fail goto*//*Label 11666*/ GIMT_Encode4(745518), // Rule ID 12334 //
     /*  745448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  745459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  745462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745516 */     GIR_RootConstrainSelectedInstOperands,
     /*  745517 */     // GIR_Coverage, 12334,
     /*  745517 */     GIR_EraseRootFromParent_Done,
     /*  745518 */   // Label 11666: @745518
     /*  745518 */   GIM_Try, /*On fail goto*//*Label 11667*/ GIMT_Encode4(745593), // Rule ID 12335 //
     /*  745523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  745534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  745537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  745540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4),
     /*  745572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745591 */     GIR_RootConstrainSelectedInstOperands,
     /*  745592 */     // GIR_Coverage, 12335,
     /*  745592 */     GIR_EraseRootFromParent_Done,
     /*  745593 */   // Label 11667: @745593
     /*  745593 */   GIM_Try, /*On fail goto*//*Label 11668*/ GIMT_Encode4(745668), // Rule ID 12338 //
     /*  745598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  745615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745666 */     GIR_RootConstrainSelectedInstOperands,
     /*  745667 */     // GIR_Coverage, 12338,
     /*  745667 */     GIR_EraseRootFromParent_Done,
     /*  745668 */   // Label 11668: @745668
     /*  745668 */   GIM_Try, /*On fail goto*//*Label 11669*/ GIMT_Encode4(745743), // Rule ID 12339 //
     /*  745673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  745684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  745687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  745690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11586:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  745722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745741 */     GIR_RootConstrainSelectedInstOperands,
     /*  745742 */     // GIR_Coverage, 12339,
     /*  745742 */     GIR_EraseRootFromParent_Done,
     /*  745743 */   // Label 11669: @745743
     /*  745743 */   GIM_Try, /*On fail goto*//*Label 11670*/ GIMT_Encode4(745818), // Rule ID 12342 //
     /*  745748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  745765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745816 */     GIR_RootConstrainSelectedInstOperands,
     /*  745817 */     // GIR_Coverage, 12342,
     /*  745817 */     GIR_EraseRootFromParent_Done,
     /*  745818 */   // Label 11670: @745818
     /*  745818 */   GIM_Try, /*On fail goto*//*Label 11671*/ GIMT_Encode4(745893), // Rule ID 12343 //
     /*  745823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  745834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  745837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  745840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  745858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  745869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  745872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745891 */     GIR_RootConstrainSelectedInstOperands,
     /*  745892 */     // GIR_Coverage, 12343,
     /*  745892 */     GIR_EraseRootFromParent_Done,
     /*  745893 */   // Label 11671: @745893
     /*  745893 */   GIM_Try, /*On fail goto*//*Label 11672*/ GIMT_Encode4(745968), // Rule ID 12346 //
     /*  745898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  745901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  745918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  745921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  745929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  745933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  745937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  745944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  745944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  745947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  745949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  745951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  745953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  745955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  745960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  745963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  745966 */     GIR_RootConstrainSelectedInstOperands,
     /*  745967 */     // GIR_Coverage, 12346,
     /*  745967 */     GIR_EraseRootFromParent_Done,
     /*  745968 */   // Label 11672: @745968
     /*  745968 */   GIM_Try, /*On fail goto*//*Label 11673*/ GIMT_Encode4(746043), // Rule ID 12347 //
     /*  745973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  745976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  745981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  745984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  745987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  745990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  745993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  745996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746041 */     GIR_RootConstrainSelectedInstOperands,
     /*  746042 */     // GIR_Coverage, 12347,
     /*  746042 */     GIR_EraseRootFromParent_Done,
     /*  746043 */   // Label 11673: @746043
     /*  746043 */   GIM_Try, /*On fail goto*//*Label 11674*/ GIMT_Encode4(746118), // Rule ID 12350 //
     /*  746048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  746094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746116 */     GIR_RootConstrainSelectedInstOperands,
     /*  746117 */     // GIR_Coverage, 12350,
     /*  746117 */     GIR_EraseRootFromParent_Done,
     /*  746118 */   // Label 11674: @746118
     /*  746118 */   GIM_Try, /*On fail goto*//*Label 11675*/ GIMT_Encode4(746193), // Rule ID 12351 //
     /*  746123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  746134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  746137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  746140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  746169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  746188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746191 */     GIR_RootConstrainSelectedInstOperands,
     /*  746192 */     // GIR_Coverage, 12351,
     /*  746192 */     GIR_EraseRootFromParent_Done,
     /*  746193 */   // Label 11675: @746193
     /*  746193 */   GIM_Try, /*On fail goto*//*Label 11676*/ GIMT_Encode4(746268), // Rule ID 12354 //
     /*  746198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746266 */     GIR_RootConstrainSelectedInstOperands,
     /*  746267 */     // GIR_Coverage, 12354,
     /*  746267 */     GIR_EraseRootFromParent_Done,
     /*  746268 */   // Label 11676: @746268
     /*  746268 */   GIM_Try, /*On fail goto*//*Label 11677*/ GIMT_Encode4(746343), // Rule ID 12355 //
     /*  746273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  746284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  746287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  746290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746319 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11586:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2),
     /*  746322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746341 */     GIR_RootConstrainSelectedInstOperands,
     /*  746342 */     // GIR_Coverage, 12355,
     /*  746342 */     GIR_EraseRootFromParent_Done,
     /*  746343 */   // Label 11677: @746343
     /*  746343 */   GIM_Try, /*On fail goto*//*Label 11678*/ GIMT_Encode4(746418), // Rule ID 12358 //
     /*  746348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746416 */     GIR_RootConstrainSelectedInstOperands,
     /*  746417 */     // GIR_Coverage, 12358,
     /*  746417 */     GIR_EraseRootFromParent_Done,
     /*  746418 */   // Label 11678: @746418
     /*  746418 */   GIM_Try, /*On fail goto*//*Label 11679*/ GIMT_Encode4(746493), // Rule ID 12359 //
     /*  746423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  746434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  746437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  746440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11586:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1),
     /*  746472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746491 */     GIR_RootConstrainSelectedInstOperands,
     /*  746492 */     // GIR_Coverage, 12359,
     /*  746492 */     GIR_EraseRootFromParent_Done,
     /*  746493 */   // Label 11679: @746493
     /*  746493 */   GIM_Try, /*On fail goto*//*Label 11680*/ GIMT_Encode4(746568), // Rule ID 12362 //
     /*  746498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  746515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746566 */     GIR_RootConstrainSelectedInstOperands,
     /*  746567 */     // GIR_Coverage, 12362,
     /*  746567 */     GIR_EraseRootFromParent_Done,
     /*  746568 */   // Label 11680: @746568
     /*  746568 */   GIM_Try, /*On fail goto*//*Label 11681*/ GIMT_Encode4(746643), // Rule ID 12363 //
     /*  746573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  746584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  746587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  746590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  746608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11586:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2),
     /*  746622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746641 */     GIR_RootConstrainSelectedInstOperands,
     /*  746642 */     // GIR_Coverage, 12363,
     /*  746642 */     GIR_EraseRootFromParent_Done,
     /*  746643 */   // Label 11681: @746643
     /*  746643 */   GIM_Try, /*On fail goto*//*Label 11682*/ GIMT_Encode4(746718), // Rule ID 12366 //
     /*  746648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  746651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  746665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  746668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  746694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746716 */     GIR_RootConstrainSelectedInstOperands,
     /*  746717 */     // GIR_Coverage, 12366,
     /*  746717 */     GIR_EraseRootFromParent_Done,
     /*  746718 */   // Label 11682: @746718
     /*  746718 */   GIM_Try, /*On fail goto*//*Label 11683*/ GIMT_Encode4(746793), // Rule ID 12367 //
     /*  746723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  746726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul),
     /*  746731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  746734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  746737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  746740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  746743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  746754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  746758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  746762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11586:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMUL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  746769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4),
     /*  746772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  746788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746791 */     GIR_RootConstrainSelectedInstOperands,
     /*  746792 */     // GIR_Coverage, 12367,
     /*  746792 */     GIR_EraseRootFromParent_Done,
     /*  746793 */   // Label 11683: @746793
     /*  746793 */   GIM_Try, /*On fail goto*//*Label 11684*/ GIMT_Encode4(746868), // Rule ID 12370 //
     /*  746798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  746806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746844 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  746847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746866 */     GIR_RootConstrainSelectedInstOperands,
     /*  746867 */     // GIR_Coverage, 12370,
     /*  746867 */     GIR_EraseRootFromParent_Done,
     /*  746868 */   // Label 11684: @746868
     /*  746868 */   GIM_Try, /*On fail goto*//*Label 11685*/ GIMT_Encode4(746943), // Rule ID 12371 //
     /*  746873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  746876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  746881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  746884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  746887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  746890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  746893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  746896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746919 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  746919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8),
     /*  746922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  746926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  746928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  746930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  746935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  746938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  746941 */     GIR_RootConstrainSelectedInstOperands,
     /*  746942 */     // GIR_Coverage, 12371,
     /*  746942 */     GIR_EraseRootFromParent_Done,
     /*  746943 */   // Label 11685: @746943
     /*  746943 */   GIM_Try, /*On fail goto*//*Label 11686*/ GIMT_Encode4(747018), // Rule ID 12374 //
     /*  746948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  746951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  746956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  746959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  746962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  746965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  746968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  746971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  746987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  746994 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  746994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  746997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  746999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747016 */     GIR_RootConstrainSelectedInstOperands,
     /*  747017 */     // GIR_Coverage, 12374,
     /*  747017 */     GIR_EraseRootFromParent_Done,
     /*  747018 */   // Label 11686: @747018
     /*  747018 */   GIM_Try, /*On fail goto*//*Label 11687*/ GIMT_Encode4(747093), // Rule ID 12375 //
     /*  747023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  747034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  747037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  747040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  747043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747069 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747091 */     GIR_RootConstrainSelectedInstOperands,
     /*  747092 */     // GIR_Coverage, 12375,
     /*  747092 */     GIR_EraseRootFromParent_Done,
     /*  747093 */   // Label 11687: @747093
     /*  747093 */   GIM_Try, /*On fail goto*//*Label 11688*/ GIMT_Encode4(747168), // Rule ID 12378 //
     /*  747098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747166 */     GIR_RootConstrainSelectedInstOperands,
     /*  747167 */     // GIR_Coverage, 12378,
     /*  747167 */     GIR_EraseRootFromParent_Done,
     /*  747168 */   // Label 11688: @747168
     /*  747168 */   GIM_Try, /*On fail goto*//*Label 11689*/ GIMT_Encode4(747243), // Rule ID 12379 //
     /*  747173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  747184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  747187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  747190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  747193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747219 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747241 */     GIR_RootConstrainSelectedInstOperands,
     /*  747242 */     // GIR_Coverage, 12379,
     /*  747242 */     GIR_EraseRootFromParent_Done,
     /*  747243 */   // Label 11689: @747243
     /*  747243 */   GIM_Try, /*On fail goto*//*Label 11690*/ GIMT_Encode4(747318), // Rule ID 12382 //
     /*  747248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747316 */     GIR_RootConstrainSelectedInstOperands,
     /*  747317 */     // GIR_Coverage, 12382,
     /*  747317 */     GIR_EraseRootFromParent_Done,
     /*  747318 */   // Label 11690: @747318
     /*  747318 */   GIM_Try, /*On fail goto*//*Label 11691*/ GIMT_Encode4(747393), // Rule ID 12383 //
     /*  747323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  747334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  747337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  747340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  747343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  747372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747391 */     GIR_RootConstrainSelectedInstOperands,
     /*  747392 */     // GIR_Coverage, 12383,
     /*  747392 */     GIR_EraseRootFromParent_Done,
     /*  747393 */   // Label 11691: @747393
     /*  747393 */   GIM_Try, /*On fail goto*//*Label 11692*/ GIMT_Encode4(747468), // Rule ID 12386 //
     /*  747398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747444 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  747447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747466 */     GIR_RootConstrainSelectedInstOperands,
     /*  747467 */     // GIR_Coverage, 12386,
     /*  747467 */     GIR_EraseRootFromParent_Done,
     /*  747468 */   // Label 11692: @747468
     /*  747468 */   GIM_Try, /*On fail goto*//*Label 11693*/ GIMT_Encode4(747543), // Rule ID 12387 //
     /*  747473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  747484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  747487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  747490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  747493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  747512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747519 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  747522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747541 */     GIR_RootConstrainSelectedInstOperands,
     /*  747542 */     // GIR_Coverage, 12387,
     /*  747542 */     GIR_EraseRootFromParent_Done,
     /*  747543 */   // Label 11693: @747543
     /*  747543 */   GIM_Try, /*On fail goto*//*Label 11694*/ GIMT_Encode4(747618), // Rule ID 12390 //
     /*  747548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  747594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  747597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747616 */     GIR_RootConstrainSelectedInstOperands,
     /*  747617 */     // GIR_Coverage, 12390,
     /*  747617 */     GIR_EraseRootFromParent_Done,
     /*  747618 */   // Label 11694: @747618
     /*  747618 */   GIM_Try, /*On fail goto*//*Label 11695*/ GIMT_Encode4(747693), // Rule ID 12391 //
     /*  747623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  747634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  747637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  747640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  747643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  747654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  747662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747669 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  747669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  747672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  747688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747691 */     GIR_RootConstrainSelectedInstOperands,
     /*  747692 */     // GIR_Coverage, 12391,
     /*  747692 */     GIR_EraseRootFromParent_Done,
     /*  747693 */   // Label 11695: @747693
     /*  747693 */   GIM_Try, /*On fail goto*//*Label 11696*/ GIMT_Encode4(747768), // Rule ID 12394 //
     /*  747698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747766 */     GIR_RootConstrainSelectedInstOperands,
     /*  747767 */     // GIR_Coverage, 12394,
     /*  747767 */     GIR_EraseRootFromParent_Done,
     /*  747768 */   // Label 11696: @747768
     /*  747768 */   GIM_Try, /*On fail goto*//*Label 11697*/ GIMT_Encode4(747843), // Rule ID 12395 //
     /*  747773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  747784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  747787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  747790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  747793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747819 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4),
     /*  747822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747841 */     GIR_RootConstrainSelectedInstOperands,
     /*  747842 */     // GIR_Coverage, 12395,
     /*  747842 */     GIR_EraseRootFromParent_Done,
     /*  747843 */   // Label 11697: @747843
     /*  747843 */   GIM_Try, /*On fail goto*//*Label 11698*/ GIMT_Encode4(747918), // Rule ID 12398 //
     /*  747848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  747851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  747871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  747894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747916 */     GIR_RootConstrainSelectedInstOperands,
     /*  747917 */     // GIR_Coverage, 12398,
     /*  747917 */     GIR_EraseRootFromParent_Done,
     /*  747918 */   // Label 11698: @747918
     /*  747918 */   GIM_Try, /*On fail goto*//*Label 11699*/ GIMT_Encode4(747993), // Rule ID 12399 //
     /*  747923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  747926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  747931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  747934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  747937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  747940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  747943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  747946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  747962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  747969 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  747969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  747972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  747974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  747976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  747978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  747980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  747985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  747988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  747991 */     GIR_RootConstrainSelectedInstOperands,
     /*  747992 */     // GIR_Coverage, 12399,
     /*  747992 */     GIR_EraseRootFromParent_Done,
     /*  747993 */   // Label 11699: @747993
     /*  747993 */   GIM_Try, /*On fail goto*//*Label 11700*/ GIMT_Encode4(748068), // Rule ID 12402 //
     /*  747998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748066 */     GIR_RootConstrainSelectedInstOperands,
     /*  748067 */     // GIR_Coverage, 12402,
     /*  748067 */     GIR_EraseRootFromParent_Done,
     /*  748068 */   // Label 11700: @748068
     /*  748068 */   GIM_Try, /*On fail goto*//*Label 11701*/ GIMT_Encode4(748143), // Rule ID 12403 //
     /*  748073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  748084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  748087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  748090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  748093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748141 */     GIR_RootConstrainSelectedInstOperands,
     /*  748142 */     // GIR_Coverage, 12403,
     /*  748142 */     GIR_EraseRootFromParent_Done,
     /*  748143 */   // Label 11701: @748143
     /*  748143 */   GIM_Try, /*On fail goto*//*Label 11702*/ GIMT_Encode4(748218), // Rule ID 12406 //
     /*  748148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748194 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748216 */     GIR_RootConstrainSelectedInstOperands,
     /*  748217 */     // GIR_Coverage, 12406,
     /*  748217 */     GIR_EraseRootFromParent_Done,
     /*  748218 */   // Label 11702: @748218
     /*  748218 */   GIM_Try, /*On fail goto*//*Label 11703*/ GIMT_Encode4(748293), // Rule ID 12407 //
     /*  748223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  748234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  748237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  748240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  748243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748269 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748291 */     GIR_RootConstrainSelectedInstOperands,
     /*  748292 */     // GIR_Coverage, 12407,
     /*  748292 */     GIR_EraseRootFromParent_Done,
     /*  748293 */   // Label 11703: @748293
     /*  748293 */   GIM_Try, /*On fail goto*//*Label 11704*/ GIMT_Encode4(748368), // Rule ID 12410 //
     /*  748298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  748301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  748344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748366 */     GIR_RootConstrainSelectedInstOperands,
     /*  748367 */     // GIR_Coverage, 12410,
     /*  748367 */     GIR_EraseRootFromParent_Done,
     /*  748368 */   // Label 11704: @748368
     /*  748368 */   GIM_Try, /*On fail goto*//*Label 11705*/ GIMT_Encode4(748443), // Rule ID 12411 //
     /*  748373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  748376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  748384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  748387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  748390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  748393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  748419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  748438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748441 */     GIR_RootConstrainSelectedInstOperands,
     /*  748442 */     // GIR_Coverage, 12411,
     /*  748442 */     GIR_EraseRootFromParent_Done,
     /*  748443 */   // Label 11705: @748443
     /*  748443 */   GIM_Try, /*On fail goto*//*Label 11706*/ GIMT_Encode4(748518), // Rule ID 12414 //
     /*  748448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748494 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748516 */     GIR_RootConstrainSelectedInstOperands,
     /*  748517 */     // GIR_Coverage, 12414,
     /*  748517 */     GIR_EraseRootFromParent_Done,
     /*  748518 */   // Label 11706: @748518
     /*  748518 */   GIM_Try, /*On fail goto*//*Label 11707*/ GIMT_Encode4(748593), // Rule ID 12415 //
     /*  748523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  748534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  748537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  748540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  748543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748569 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2),
     /*  748572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748591 */     GIR_RootConstrainSelectedInstOperands,
     /*  748592 */     // GIR_Coverage, 12415,
     /*  748592 */     GIR_EraseRootFromParent_Done,
     /*  748593 */   // Label 11707: @748593
     /*  748593 */   GIM_Try, /*On fail goto*//*Label 11708*/ GIMT_Encode4(748668), // Rule ID 12418 //
     /*  748598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748644 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748666 */     GIR_RootConstrainSelectedInstOperands,
     /*  748667 */     // GIR_Coverage, 12418,
     /*  748667 */     GIR_EraseRootFromParent_Done,
     /*  748668 */   // Label 11708: @748668
     /*  748668 */   GIM_Try, /*On fail goto*//*Label 11709*/ GIMT_Encode4(748743), // Rule ID 12419 //
     /*  748673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  748684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  748687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  748690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  748693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  748712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1),
     /*  748722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748741 */     GIR_RootConstrainSelectedInstOperands,
     /*  748742 */     // GIR_Coverage, 12419,
     /*  748742 */     GIR_EraseRootFromParent_Done,
     /*  748743 */   // Label 11709: @748743
     /*  748743 */   GIM_Try, /*On fail goto*//*Label 11710*/ GIMT_Encode4(748818), // Rule ID 12422 //
     /*  748748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748816 */     GIR_RootConstrainSelectedInstOperands,
     /*  748817 */     // GIR_Coverage, 12422,
     /*  748817 */     GIR_EraseRootFromParent_Done,
     /*  748818 */   // Label 11710: @748818
     /*  748818 */   GIM_Try, /*On fail goto*//*Label 11711*/ GIMT_Encode4(748893), // Rule ID 12423 //
     /*  748823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  748834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  748837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  748840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  748843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  748862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748869 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  748869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2),
     /*  748872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748891 */     GIR_RootConstrainSelectedInstOperands,
     /*  748892 */     // GIR_Coverage, 12423,
     /*  748892 */     GIR_EraseRootFromParent_Done,
     /*  748893 */   // Label 11711: @748893
     /*  748893 */   GIM_Try, /*On fail goto*//*Label 11712*/ GIMT_Encode4(748968), // Rule ID 12426 //
     /*  748898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  748901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  748921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  748929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  748937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  748944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  748944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  748947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  748949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  748951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  748953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  748955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  748960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  748963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  748966 */     GIR_RootConstrainSelectedInstOperands,
     /*  748967 */     // GIR_Coverage, 12426,
     /*  748967 */     GIR_EraseRootFromParent_Done,
     /*  748968 */   // Label 11712: @748968
     /*  748968 */   GIM_Try, /*On fail goto*//*Label 11713*/ GIMT_Encode4(749043), // Rule ID 12427 //
     /*  748973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  748976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  748981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  748984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  748987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  748990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  748993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  748996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  749019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4),
     /*  749022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  749038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749041 */     GIR_RootConstrainSelectedInstOperands,
     /*  749042 */     // GIR_Coverage, 12427,
     /*  749042 */     GIR_EraseRootFromParent_Done,
     /*  749043 */   // Label 11713: @749043
     /*  749043 */   GIM_Try, /*On fail goto*//*Label 11714*/ GIMT_Encode4(749118), // Rule ID 12430 //
     /*  749048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749116 */     GIR_RootConstrainSelectedInstOperands,
     /*  749117 */     // GIR_Coverage, 12430,
     /*  749117 */     GIR_EraseRootFromParent_Done,
     /*  749118 */   // Label 11714: @749118
     /*  749118 */   GIM_Try, /*On fail goto*//*Label 11715*/ GIMT_Encode4(749193), // Rule ID 12431 //
     /*  749123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  749134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  749137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  749140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749169 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8),
     /*  749172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749191 */     GIR_RootConstrainSelectedInstOperands,
     /*  749192 */     // GIR_Coverage, 12431,
     /*  749192 */     GIR_EraseRootFromParent_Done,
     /*  749193 */   // Label 11715: @749193
     /*  749193 */   GIM_Try, /*On fail goto*//*Label 11716*/ GIMT_Encode4(749268), // Rule ID 12434 //
     /*  749198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749244 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749266 */     GIR_RootConstrainSelectedInstOperands,
     /*  749267 */     // GIR_Coverage, 12434,
     /*  749267 */     GIR_EraseRootFromParent_Done,
     /*  749268 */   // Label 11716: @749268
     /*  749268 */   GIM_Try, /*On fail goto*//*Label 11717*/ GIMT_Encode4(749343), // Rule ID 12435 //
     /*  749273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  749284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  749287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  749290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749319 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749341 */     GIR_RootConstrainSelectedInstOperands,
     /*  749342 */     // GIR_Coverage, 12435,
     /*  749342 */     GIR_EraseRootFromParent_Done,
     /*  749343 */   // Label 11717: @749343
     /*  749343 */   GIM_Try, /*On fail goto*//*Label 11718*/ GIMT_Encode4(749418), // Rule ID 12438 //
     /*  749348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749416 */     GIR_RootConstrainSelectedInstOperands,
     /*  749417 */     // GIR_Coverage, 12438,
     /*  749417 */     GIR_EraseRootFromParent_Done,
     /*  749418 */   // Label 11718: @749418
     /*  749418 */   GIM_Try, /*On fail goto*//*Label 11719*/ GIMT_Encode4(749493), // Rule ID 12439 //
     /*  749423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  749434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  749437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  749440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11590:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  749472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749491 */     GIR_RootConstrainSelectedInstOperands,
     /*  749492 */     // GIR_Coverage, 12439,
     /*  749492 */     GIR_EraseRootFromParent_Done,
     /*  749493 */   // Label 11719: @749493
     /*  749493 */   GIM_Try, /*On fail goto*//*Label 11720*/ GIMT_Encode4(749568), // Rule ID 12442 //
     /*  749498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  749547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749566 */     GIR_RootConstrainSelectedInstOperands,
     /*  749567 */     // GIR_Coverage, 12442,
     /*  749567 */     GIR_EraseRootFromParent_Done,
     /*  749568 */   // Label 11720: @749568
     /*  749568 */   GIM_Try, /*On fail goto*//*Label 11721*/ GIMT_Encode4(749643), // Rule ID 12443 //
     /*  749573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  749584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  749587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  749590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  749622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749641 */     GIR_RootConstrainSelectedInstOperands,
     /*  749642 */     // GIR_Coverage, 12443,
     /*  749642 */     GIR_EraseRootFromParent_Done,
     /*  749643 */   // Label 11721: @749643
     /*  749643 */   GIM_Try, /*On fail goto*//*Label 11722*/ GIMT_Encode4(749718), // Rule ID 12446 //
     /*  749648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  749697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749716 */     GIR_RootConstrainSelectedInstOperands,
     /*  749717 */     // GIR_Coverage, 12446,
     /*  749717 */     GIR_EraseRootFromParent_Done,
     /*  749718 */   // Label 11722: @749718
     /*  749718 */   GIM_Try, /*On fail goto*//*Label 11723*/ GIMT_Encode4(749793), // Rule ID 12447 //
     /*  749723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  749734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  749737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  749740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  749758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749769 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  749772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749791 */     GIR_RootConstrainSelectedInstOperands,
     /*  749792 */     // GIR_Coverage, 12447,
     /*  749792 */     GIR_EraseRootFromParent_Done,
     /*  749793 */   // Label 11723: @749793
     /*  749793 */   GIM_Try, /*On fail goto*//*Label 11724*/ GIMT_Encode4(749868), // Rule ID 12450 //
     /*  749798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749844 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  749844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  749847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749866 */     GIR_RootConstrainSelectedInstOperands,
     /*  749867 */     // GIR_Coverage, 12450,
     /*  749867 */     GIR_EraseRootFromParent_Done,
     /*  749868 */   // Label 11724: @749868
     /*  749868 */   GIM_Try, /*On fail goto*//*Label 11725*/ GIMT_Encode4(749943), // Rule ID 12451 //
     /*  749873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  749876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  749884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  749887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  749890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  749893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  749896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  749904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  749908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749919 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  749919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  749922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  749926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  749928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  749930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  749935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  749938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  749941 */     GIR_RootConstrainSelectedInstOperands,
     /*  749942 */     // GIR_Coverage, 12451,
     /*  749942 */     GIR_EraseRootFromParent_Done,
     /*  749943 */   // Label 11725: @749943
     /*  749943 */   GIM_Try, /*On fail goto*//*Label 11726*/ GIMT_Encode4(750018), // Rule ID 12454 //
     /*  749948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  749951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  749956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  749959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  749962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  749965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  749968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  749971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  749983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  749987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  749994 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  749994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  749997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  749999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750016 */     GIR_RootConstrainSelectedInstOperands,
     /*  750017 */     // GIR_Coverage, 12454,
     /*  750017 */     GIR_EraseRootFromParent_Done,
     /*  750018 */   // Label 11726: @750018
     /*  750018 */   GIM_Try, /*On fail goto*//*Label 11727*/ GIMT_Encode4(750093), // Rule ID 12455 //
     /*  750023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  750034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  750037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  750040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750069 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4),
     /*  750072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750091 */     GIR_RootConstrainSelectedInstOperands,
     /*  750092 */     // GIR_Coverage, 12455,
     /*  750092 */     GIR_EraseRootFromParent_Done,
     /*  750093 */   // Label 11727: @750093
     /*  750093 */   GIM_Try, /*On fail goto*//*Label 11728*/ GIMT_Encode4(750168), // Rule ID 12458 //
     /*  750098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750166 */     GIR_RootConstrainSelectedInstOperands,
     /*  750167 */     // GIR_Coverage, 12458,
     /*  750167 */     GIR_EraseRootFromParent_Done,
     /*  750168 */   // Label 11728: @750168
     /*  750168 */   GIM_Try, /*On fail goto*//*Label 11729*/ GIMT_Encode4(750243), // Rule ID 12459 //
     /*  750173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  750184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  750187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  750190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750219 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11590:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750241 */     GIR_RootConstrainSelectedInstOperands,
     /*  750242 */     // GIR_Coverage, 12459,
     /*  750242 */     GIR_EraseRootFromParent_Done,
     /*  750243 */   // Label 11729: @750243
     /*  750243 */   GIM_Try, /*On fail goto*//*Label 11730*/ GIMT_Encode4(750318), // Rule ID 12462 //
     /*  750248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750316 */     GIR_RootConstrainSelectedInstOperands,
     /*  750317 */     // GIR_Coverage, 12462,
     /*  750317 */     GIR_EraseRootFromParent_Done,
     /*  750318 */   // Label 11730: @750318
     /*  750318 */   GIM_Try, /*On fail goto*//*Label 11731*/ GIMT_Encode4(750393), // Rule ID 12463 //
     /*  750323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  750334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  750337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  750340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750391 */     GIR_RootConstrainSelectedInstOperands,
     /*  750392 */     // GIR_Coverage, 12463,
     /*  750392 */     GIR_EraseRootFromParent_Done,
     /*  750393 */   // Label 11731: @750393
     /*  750393 */   GIM_Try, /*On fail goto*//*Label 11732*/ GIMT_Encode4(750468), // Rule ID 12466 //
     /*  750398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750466 */     GIR_RootConstrainSelectedInstOperands,
     /*  750467 */     // GIR_Coverage, 12466,
     /*  750467 */     GIR_EraseRootFromParent_Done,
     /*  750468 */   // Label 11732: @750468
     /*  750468 */   GIM_Try, /*On fail goto*//*Label 11733*/ GIMT_Encode4(750543), // Rule ID 12467 //
     /*  750473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  750484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  750487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  750490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750519 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  750522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750541 */     GIR_RootConstrainSelectedInstOperands,
     /*  750542 */     // GIR_Coverage, 12467,
     /*  750542 */     GIR_EraseRootFromParent_Done,
     /*  750543 */   // Label 11733: @750543
     /*  750543 */   GIM_Try, /*On fail goto*//*Label 11734*/ GIMT_Encode4(750618), // Rule ID 12470 //
     /*  750548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  750551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  750594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750616 */     GIR_RootConstrainSelectedInstOperands,
     /*  750617 */     // GIR_Coverage, 12470,
     /*  750617 */     GIR_EraseRootFromParent_Done,
     /*  750618 */   // Label 11734: @750618
     /*  750618 */   GIM_Try, /*On fail goto*//*Label 11735*/ GIMT_Encode4(750693), // Rule ID 12471 //
     /*  750623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  750626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  750634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  750637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  750640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  750654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  750658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750669 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  750669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  750672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  750688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750691 */     GIR_RootConstrainSelectedInstOperands,
     /*  750692 */     // GIR_Coverage, 12471,
     /*  750692 */     GIR_EraseRootFromParent_Done,
     /*  750693 */   // Label 11735: @750693
     /*  750693 */   GIM_Try, /*On fail goto*//*Label 11736*/ GIMT_Encode4(750768), // Rule ID 12474 //
     /*  750698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750766 */     GIR_RootConstrainSelectedInstOperands,
     /*  750767 */     // GIR_Coverage, 12474,
     /*  750767 */     GIR_EraseRootFromParent_Done,
     /*  750768 */   // Label 11736: @750768
     /*  750768 */   GIM_Try, /*On fail goto*//*Label 11737*/ GIMT_Encode4(750843), // Rule ID 12475 //
     /*  750773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  750784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  750787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  750790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750819 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11590:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2),
     /*  750822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750841 */     GIR_RootConstrainSelectedInstOperands,
     /*  750842 */     // GIR_Coverage, 12475,
     /*  750842 */     GIR_EraseRootFromParent_Done,
     /*  750843 */   // Label 11737: @750843
     /*  750843 */   GIM_Try, /*On fail goto*//*Label 11738*/ GIMT_Encode4(750918), // Rule ID 12478 //
     /*  750848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  750851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  750868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  750871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  750894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750916 */     GIR_RootConstrainSelectedInstOperands,
     /*  750917 */     // GIR_Coverage, 12478,
     /*  750917 */     GIR_EraseRootFromParent_Done,
     /*  750918 */   // Label 11738: @750918
     /*  750918 */   GIM_Try, /*On fail goto*//*Label 11739*/ GIMT_Encode4(750993), // Rule ID 12479 //
     /*  750923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  750926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  750931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  750934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  750937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  750940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  750943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  750946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  750954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  750958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  750962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  750969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11590:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  750969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1),
     /*  750972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  750974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  750976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  750978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  750980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  750985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  750988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  750991 */     GIR_RootConstrainSelectedInstOperands,
     /*  750992 */     // GIR_Coverage, 12479,
     /*  750992 */     GIR_EraseRootFromParent_Done,
     /*  750993 */   // Label 11739: @750993
     /*  750993 */   GIM_Try, /*On fail goto*//*Label 11740*/ GIMT_Encode4(751068), // Rule ID 12482 //
     /*  750998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751066 */     GIR_RootConstrainSelectedInstOperands,
     /*  751067 */     // GIR_Coverage, 12482,
     /*  751067 */     GIR_EraseRootFromParent_Done,
     /*  751068 */   // Label 11740: @751068
     /*  751068 */   GIM_Try, /*On fail goto*//*Label 11741*/ GIMT_Encode4(751143), // Rule ID 12483 //
     /*  751073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  751084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  751087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  751090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751119 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11590:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2),
     /*  751122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751141 */     GIR_RootConstrainSelectedInstOperands,
     /*  751142 */     // GIR_Coverage, 12483,
     /*  751142 */     GIR_EraseRootFromParent_Done,
     /*  751143 */   // Label 11741: @751143
     /*  751143 */   GIM_Try, /*On fail goto*//*Label 11742*/ GIMT_Encode4(751218), // Rule ID 12486 //
     /*  751148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  751151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  751168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751194 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  751194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751216 */     GIR_RootConstrainSelectedInstOperands,
     /*  751217 */     // GIR_Coverage, 12486,
     /*  751217 */     GIR_EraseRootFromParent_Done,
     /*  751218 */   // Label 11742: @751218
     /*  751218 */   GIM_Try, /*On fail goto*//*Label 11743*/ GIMT_Encode4(751293), // Rule ID 12487 //
     /*  751223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  751226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu),
     /*  751231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  751234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  751237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  751240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  751243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  751254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  751262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11590:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  751269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4),
     /*  751272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  751288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751291 */     GIR_RootConstrainSelectedInstOperands,
     /*  751292 */     // GIR_Coverage, 12487,
     /*  751292 */     GIR_EraseRootFromParent_Done,
     /*  751293 */   // Label 11743: @751293
     /*  751293 */   GIM_Try, /*On fail goto*//*Label 11744*/ GIMT_Encode4(751368), // Rule ID 12490 //
     /*  751298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751344 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751366 */     GIR_RootConstrainSelectedInstOperands,
     /*  751367 */     // GIR_Coverage, 12490,
     /*  751367 */     GIR_EraseRootFromParent_Done,
     /*  751368 */   // Label 11744: @751368
     /*  751368 */   GIM_Try, /*On fail goto*//*Label 11745*/ GIMT_Encode4(751443), // Rule ID 12491 //
     /*  751373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  751384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  751387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  751390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  751393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751419 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8),
     /*  751422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751441 */     GIR_RootConstrainSelectedInstOperands,
     /*  751442 */     // GIR_Coverage, 12491,
     /*  751442 */     GIR_EraseRootFromParent_Done,
     /*  751443 */   // Label 11745: @751443
     /*  751443 */   GIM_Try, /*On fail goto*//*Label 11746*/ GIMT_Encode4(751518), // Rule ID 12494 //
     /*  751448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751494 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  751497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751516 */     GIR_RootConstrainSelectedInstOperands,
     /*  751517 */     // GIR_Coverage, 12494,
     /*  751517 */     GIR_EraseRootFromParent_Done,
     /*  751518 */   // Label 11746: @751518
     /*  751518 */   GIM_Try, /*On fail goto*//*Label 11747*/ GIMT_Encode4(751593), // Rule ID 12495 //
     /*  751523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  751534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  751537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  751540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  751543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751569 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  751572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751591 */     GIR_RootConstrainSelectedInstOperands,
     /*  751592 */     // GIR_Coverage, 12495,
     /*  751592 */     GIR_EraseRootFromParent_Done,
     /*  751593 */   // Label 11747: @751593
     /*  751593 */   GIM_Try, /*On fail goto*//*Label 11748*/ GIMT_Encode4(751668), // Rule ID 12498 //
     /*  751598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  751647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751666 */     GIR_RootConstrainSelectedInstOperands,
     /*  751667 */     // GIR_Coverage, 12498,
     /*  751667 */     GIR_EraseRootFromParent_Done,
     /*  751668 */   // Label 11748: @751668
     /*  751668 */   GIM_Try, /*On fail goto*//*Label 11749*/ GIMT_Encode4(751743), // Rule ID 12499 //
     /*  751673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  751684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  751687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  751690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  751693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  751722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751741 */     GIR_RootConstrainSelectedInstOperands,
     /*  751742 */     // GIR_Coverage, 12499,
     /*  751742 */     GIR_EraseRootFromParent_Done,
     /*  751743 */   // Label 11749: @751743
     /*  751743 */   GIM_Try, /*On fail goto*//*Label 11750*/ GIMT_Encode4(751818), // Rule ID 12502 //
     /*  751748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  751797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751816 */     GIR_RootConstrainSelectedInstOperands,
     /*  751817 */     // GIR_Coverage, 12502,
     /*  751817 */     GIR_EraseRootFromParent_Done,
     /*  751818 */   // Label 11750: @751818
     /*  751818 */   GIM_Try, /*On fail goto*//*Label 11751*/ GIMT_Encode4(751893), // Rule ID 12503 //
     /*  751823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  751834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  751837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  751840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  751843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  751862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751869 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  751869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  751872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751891 */     GIR_RootConstrainSelectedInstOperands,
     /*  751892 */     // GIR_Coverage, 12503,
     /*  751892 */     GIR_EraseRootFromParent_Done,
     /*  751893 */   // Label 11751: @751893
     /*  751893 */   GIM_Try, /*On fail goto*//*Label 11752*/ GIMT_Encode4(751968), // Rule ID 12506 //
     /*  751898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  751901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  751921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  751929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  751937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  751944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  751944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  751947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  751949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  751951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  751953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  751955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  751960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  751963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  751966 */     GIR_RootConstrainSelectedInstOperands,
     /*  751967 */     // GIR_Coverage, 12506,
     /*  751967 */     GIR_EraseRootFromParent_Done,
     /*  751968 */   // Label 11752: @751968
     /*  751968 */   GIM_Try, /*On fail goto*//*Label 11753*/ GIMT_Encode4(752043), // Rule ID 12507 //
     /*  751973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  751976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  751981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  751984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  751987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  751990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  751993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  751996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752019 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752041 */     GIR_RootConstrainSelectedInstOperands,
     /*  752042 */     // GIR_Coverage, 12507,
     /*  752042 */     GIR_EraseRootFromParent_Done,
     /*  752043 */   // Label 11753: @752043
     /*  752043 */   GIM_Try, /*On fail goto*//*Label 11754*/ GIMT_Encode4(752118), // Rule ID 12510 //
     /*  752048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752094 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  752094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752116 */     GIR_RootConstrainSelectedInstOperands,
     /*  752117 */     // GIR_Coverage, 12510,
     /*  752117 */     GIR_EraseRootFromParent_Done,
     /*  752118 */   // Label 11754: @752118
     /*  752118 */   GIM_Try, /*On fail goto*//*Label 11755*/ GIMT_Encode4(752193), // Rule ID 12511 //
     /*  752123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  752134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  752137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  752140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  752143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752169 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  752169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  752188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752191 */     GIR_RootConstrainSelectedInstOperands,
     /*  752192 */     // GIR_Coverage, 12511,
     /*  752192 */     GIR_EraseRootFromParent_Done,
     /*  752193 */   // Label 11755: @752193
     /*  752193 */   GIM_Try, /*On fail goto*//*Label 11756*/ GIMT_Encode4(752268), // Rule ID 12514 //
     /*  752198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752266 */     GIR_RootConstrainSelectedInstOperands,
     /*  752267 */     // GIR_Coverage, 12514,
     /*  752267 */     GIR_EraseRootFromParent_Done,
     /*  752268 */   // Label 11756: @752268
     /*  752268 */   GIM_Try, /*On fail goto*//*Label 11757*/ GIMT_Encode4(752343), // Rule ID 12515 //
     /*  752273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  752284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  752287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  752290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  752293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752319 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4),
     /*  752322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752341 */     GIR_RootConstrainSelectedInstOperands,
     /*  752342 */     // GIR_Coverage, 12515,
     /*  752342 */     GIR_EraseRootFromParent_Done,
     /*  752343 */   // Label 11757: @752343
     /*  752343 */   GIM_Try, /*On fail goto*//*Label 11758*/ GIMT_Encode4(752418), // Rule ID 12518 //
     /*  752348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752394 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752416 */     GIR_RootConstrainSelectedInstOperands,
     /*  752417 */     // GIR_Coverage, 12518,
     /*  752417 */     GIR_EraseRootFromParent_Done,
     /*  752418 */   // Label 11758: @752418
     /*  752418 */   GIM_Try, /*On fail goto*//*Label 11759*/ GIMT_Encode4(752493), // Rule ID 12519 //
     /*  752423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  752434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  752437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  752440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  752443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752469 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752491 */     GIR_RootConstrainSelectedInstOperands,
     /*  752492 */     // GIR_Coverage, 12519,
     /*  752492 */     GIR_EraseRootFromParent_Done,
     /*  752493 */   // Label 11759: @752493
     /*  752493 */   GIM_Try, /*On fail goto*//*Label 11760*/ GIMT_Encode4(752568), // Rule ID 12522 //
     /*  752498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752566 */     GIR_RootConstrainSelectedInstOperands,
     /*  752567 */     // GIR_Coverage, 12522,
     /*  752567 */     GIR_EraseRootFromParent_Done,
     /*  752568 */   // Label 11760: @752568
     /*  752568 */   GIM_Try, /*On fail goto*//*Label 11761*/ GIMT_Encode4(752643), // Rule ID 12523 //
     /*  752573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  752584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  752587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  752590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  752593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752619 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  752622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752641 */     GIR_RootConstrainSelectedInstOperands,
     /*  752642 */     // GIR_Coverage, 12523,
     /*  752642 */     GIR_EraseRootFromParent_Done,
     /*  752643 */   // Label 11761: @752643
     /*  752643 */   GIM_Try, /*On fail goto*//*Label 11762*/ GIMT_Encode4(752718), // Rule ID 12526 //
     /*  752648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752716 */     GIR_RootConstrainSelectedInstOperands,
     /*  752717 */     // GIR_Coverage, 12526,
     /*  752717 */     GIR_EraseRootFromParent_Done,
     /*  752718 */   // Label 11762: @752718
     /*  752718 */   GIM_Try, /*On fail goto*//*Label 11763*/ GIMT_Encode4(752793), // Rule ID 12527 //
     /*  752723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  752734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  752737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  752740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  752743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  752762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752769 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  752772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752791 */     GIR_RootConstrainSelectedInstOperands,
     /*  752792 */     // GIR_Coverage, 12527,
     /*  752792 */     GIR_EraseRootFromParent_Done,
     /*  752793 */   // Label 11763: @752793
     /*  752793 */   GIM_Try, /*On fail goto*//*Label 11764*/ GIMT_Encode4(752868), // Rule ID 12530 //
     /*  752798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  752801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752844 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  752844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752866 */     GIR_RootConstrainSelectedInstOperands,
     /*  752867 */     // GIR_Coverage, 12530,
     /*  752867 */     GIR_EraseRootFromParent_Done,
     /*  752868 */   // Label 11764: @752868
     /*  752868 */   GIM_Try, /*On fail goto*//*Label 11765*/ GIMT_Encode4(752943), // Rule ID 12531 //
     /*  752873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  752876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  752884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  752887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  752890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  752893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  752896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  752904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  752912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752919 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  752919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  752922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  752926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  752928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  752930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  752935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  752938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  752941 */     GIR_RootConstrainSelectedInstOperands,
     /*  752942 */     // GIR_Coverage, 12531,
     /*  752942 */     GIR_EraseRootFromParent_Done,
     /*  752943 */   // Label 11765: @752943
     /*  752943 */   GIM_Try, /*On fail goto*//*Label 11766*/ GIMT_Encode4(753018), // Rule ID 12534 //
     /*  752948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  752951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  752956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  752959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  752962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  752965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  752968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  752971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  752987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  752994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  752994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  752997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  752999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753016 */     GIR_RootConstrainSelectedInstOperands,
     /*  753017 */     // GIR_Coverage, 12534,
     /*  753017 */     GIR_EraseRootFromParent_Done,
     /*  753018 */   // Label 11766: @753018
     /*  753018 */   GIM_Try, /*On fail goto*//*Label 11767*/ GIMT_Encode4(753093), // Rule ID 12535 //
     /*  753023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  753034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  753037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  753040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  753043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753069 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2),
     /*  753072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753091 */     GIR_RootConstrainSelectedInstOperands,
     /*  753092 */     // GIR_Coverage, 12535,
     /*  753092 */     GIR_EraseRootFromParent_Done,
     /*  753093 */   // Label 11767: @753093
     /*  753093 */   GIM_Try, /*On fail goto*//*Label 11768*/ GIMT_Encode4(753168), // Rule ID 12538 //
     /*  753098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753166 */     GIR_RootConstrainSelectedInstOperands,
     /*  753167 */     // GIR_Coverage, 12538,
     /*  753167 */     GIR_EraseRootFromParent_Done,
     /*  753168 */   // Label 11768: @753168
     /*  753168 */   GIM_Try, /*On fail goto*//*Label 11769*/ GIMT_Encode4(753243), // Rule ID 12539 //
     /*  753173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  753184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  753187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  753190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  753193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753219 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1),
     /*  753222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753241 */     GIR_RootConstrainSelectedInstOperands,
     /*  753242 */     // GIR_Coverage, 12539,
     /*  753242 */     GIR_EraseRootFromParent_Done,
     /*  753243 */   // Label 11769: @753243
     /*  753243 */   GIM_Try, /*On fail goto*//*Label 11770*/ GIMT_Encode4(753318), // Rule ID 12542 //
     /*  753248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753294 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753316 */     GIR_RootConstrainSelectedInstOperands,
     /*  753317 */     // GIR_Coverage, 12542,
     /*  753317 */     GIR_EraseRootFromParent_Done,
     /*  753318 */   // Label 11770: @753318
     /*  753318 */   GIM_Try, /*On fail goto*//*Label 11771*/ GIMT_Encode4(753393), // Rule ID 12543 //
     /*  753323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  753334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  753337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  753340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  753343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  753362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753369 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2),
     /*  753372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753391 */     GIR_RootConstrainSelectedInstOperands,
     /*  753392 */     // GIR_Coverage, 12543,
     /*  753392 */     GIR_EraseRootFromParent_Done,
     /*  753393 */   // Label 11771: @753393
     /*  753393 */   GIM_Try, /*On fail goto*//*Label 11772*/ GIMT_Encode4(753468), // Rule ID 12546 //
     /*  753398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  753401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753444 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  753444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753466 */     GIR_RootConstrainSelectedInstOperands,
     /*  753467 */     // GIR_Coverage, 12546,
     /*  753467 */     GIR_EraseRootFromParent_Done,
     /*  753468 */   // Label 11772: @753468
     /*  753468 */   GIM_Try, /*On fail goto*//*Label 11773*/ GIMT_Encode4(753543), // Rule ID 12547 //
     /*  753473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  753476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  753484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  753487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  753490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  753493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  753504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  753512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753519 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  753519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4),
     /*  753522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  753538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753541 */     GIR_RootConstrainSelectedInstOperands,
     /*  753542 */     // GIR_Coverage, 12547,
     /*  753542 */     GIR_EraseRootFromParent_Done,
     /*  753543 */   // Label 11773: @753543
     /*  753543 */   GIM_Try, /*On fail goto*//*Label 11774*/ GIMT_Encode4(753618), // Rule ID 12550 //
     /*  753548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  753597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753616 */     GIR_RootConstrainSelectedInstOperands,
     /*  753617 */     // GIR_Coverage, 12550,
     /*  753617 */     GIR_EraseRootFromParent_Done,
     /*  753618 */   // Label 11774: @753618
     /*  753618 */   GIM_Try, /*On fail goto*//*Label 11775*/ GIMT_Encode4(753693), // Rule ID 12551 //
     /*  753623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  753634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  753637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  753640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753669 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8),
     /*  753672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753691 */     GIR_RootConstrainSelectedInstOperands,
     /*  753692 */     // GIR_Coverage, 12551,
     /*  753692 */     GIR_EraseRootFromParent_Done,
     /*  753693 */   // Label 11775: @753693
     /*  753693 */   GIM_Try, /*On fail goto*//*Label 11776*/ GIMT_Encode4(753768), // Rule ID 12554 //
     /*  753698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  753747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753766 */     GIR_RootConstrainSelectedInstOperands,
     /*  753767 */     // GIR_Coverage, 12554,
     /*  753767 */     GIR_EraseRootFromParent_Done,
     /*  753768 */   // Label 11776: @753768
     /*  753768 */   GIM_Try, /*On fail goto*//*Label 11777*/ GIMT_Encode4(753843), // Rule ID 12555 //
     /*  753773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  753784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  753787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  753790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753819 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  753822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753841 */     GIR_RootConstrainSelectedInstOperands,
     /*  753842 */     // GIR_Coverage, 12555,
     /*  753842 */     GIR_EraseRootFromParent_Done,
     /*  753843 */   // Label 11777: @753843
     /*  753843 */   GIM_Try, /*On fail goto*//*Label 11778*/ GIMT_Encode4(753918), // Rule ID 12558 //
     /*  753848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  753851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  753868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  753871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753894 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  753894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  753897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753916 */     GIR_RootConstrainSelectedInstOperands,
     /*  753917 */     // GIR_Coverage, 12558,
     /*  753917 */     GIR_EraseRootFromParent_Done,
     /*  753918 */   // Label 11778: @753918
     /*  753918 */   GIM_Try, /*On fail goto*//*Label 11779*/ GIMT_Encode4(753993), // Rule ID 12559 //
     /*  753923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  753926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  753931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  753934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  753937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  753940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  753943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  753946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  753958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  753962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  753969 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11588:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  753969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  753972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  753974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  753976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  753978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  753980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  753985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  753988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  753991 */     GIR_RootConstrainSelectedInstOperands,
     /*  753992 */     // GIR_Coverage, 12559,
     /*  753992 */     GIR_EraseRootFromParent_Done,
     /*  753993 */   // Label 11779: @753993
     /*  753993 */   GIM_Try, /*On fail goto*//*Label 11780*/ GIMT_Encode4(754068), // Rule ID 12562 //
     /*  753998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754066 */     GIR_RootConstrainSelectedInstOperands,
     /*  754067 */     // GIR_Coverage, 12562,
     /*  754067 */     GIR_EraseRootFromParent_Done,
     /*  754068 */   // Label 11780: @754068
     /*  754068 */   GIM_Try, /*On fail goto*//*Label 11781*/ GIMT_Encode4(754143), // Rule ID 12563 //
     /*  754073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  754084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  754087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  754090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754141 */     GIR_RootConstrainSelectedInstOperands,
     /*  754142 */     // GIR_Coverage, 12563,
     /*  754142 */     GIR_EraseRootFromParent_Done,
     /*  754143 */   // Label 11781: @754143
     /*  754143 */   GIM_Try, /*On fail goto*//*Label 11782*/ GIMT_Encode4(754218), // Rule ID 12566 //
     /*  754148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754194 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754216 */     GIR_RootConstrainSelectedInstOperands,
     /*  754217 */     // GIR_Coverage, 12566,
     /*  754217 */     GIR_EraseRootFromParent_Done,
     /*  754218 */   // Label 11782: @754218
     /*  754218 */   GIM_Try, /*On fail goto*//*Label 11783*/ GIMT_Encode4(754293), // Rule ID 12567 //
     /*  754223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  754234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  754237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  754240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754291 */     GIR_RootConstrainSelectedInstOperands,
     /*  754292 */     // GIR_Coverage, 12567,
     /*  754292 */     GIR_EraseRootFromParent_Done,
     /*  754293 */   // Label 11783: @754293
     /*  754293 */   GIM_Try, /*On fail goto*//*Label 11784*/ GIMT_Encode4(754368), // Rule ID 12570 //
     /*  754298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  754344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754366 */     GIR_RootConstrainSelectedInstOperands,
     /*  754367 */     // GIR_Coverage, 12570,
     /*  754367 */     GIR_EraseRootFromParent_Done,
     /*  754368 */   // Label 11784: @754368
     /*  754368 */   GIM_Try, /*On fail goto*//*Label 11785*/ GIMT_Encode4(754443), // Rule ID 12571 //
     /*  754373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  754384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  754387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  754390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  754404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754419 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  754419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  754422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  754438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754441 */     GIR_RootConstrainSelectedInstOperands,
     /*  754442 */     // GIR_Coverage, 12571,
     /*  754442 */     GIR_EraseRootFromParent_Done,
     /*  754443 */   // Label 11785: @754443
     /*  754443 */   GIM_Try, /*On fail goto*//*Label 11786*/ GIMT_Encode4(754518), // Rule ID 12574 //
     /*  754448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754516 */     GIR_RootConstrainSelectedInstOperands,
     /*  754517 */     // GIR_Coverage, 12574,
     /*  754517 */     GIR_EraseRootFromParent_Done,
     /*  754518 */   // Label 11786: @754518
     /*  754518 */   GIM_Try, /*On fail goto*//*Label 11787*/ GIMT_Encode4(754593), // Rule ID 12575 //
     /*  754523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  754534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  754537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  754540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754569 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4),
     /*  754572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754591 */     GIR_RootConstrainSelectedInstOperands,
     /*  754592 */     // GIR_Coverage, 12575,
     /*  754592 */     GIR_EraseRootFromParent_Done,
     /*  754593 */   // Label 11787: @754593
     /*  754593 */   GIM_Try, /*On fail goto*//*Label 11788*/ GIMT_Encode4(754668), // Rule ID 12578 //
     /*  754598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754666 */     GIR_RootConstrainSelectedInstOperands,
     /*  754667 */     // GIR_Coverage, 12578,
     /*  754667 */     GIR_EraseRootFromParent_Done,
     /*  754668 */   // Label 11788: @754668
     /*  754668 */   GIM_Try, /*On fail goto*//*Label 11789*/ GIMT_Encode4(754743), // Rule ID 12579 //
     /*  754673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  754684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  754687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  754690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11588:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  754722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754741 */     GIR_RootConstrainSelectedInstOperands,
     /*  754742 */     // GIR_Coverage, 12579,
     /*  754742 */     GIR_EraseRootFromParent_Done,
     /*  754743 */   // Label 11789: @754743
     /*  754743 */   GIM_Try, /*On fail goto*//*Label 11790*/ GIMT_Encode4(754818), // Rule ID 12582 //
     /*  754748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754816 */     GIR_RootConstrainSelectedInstOperands,
     /*  754817 */     // GIR_Coverage, 12582,
     /*  754817 */     GIR_EraseRootFromParent_Done,
     /*  754818 */   // Label 11790: @754818
     /*  754818 */   GIM_Try, /*On fail goto*//*Label 11791*/ GIMT_Encode4(754893), // Rule ID 12583 //
     /*  754823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  754834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  754837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  754840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  754858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754869 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  754869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  754872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754891 */     GIR_RootConstrainSelectedInstOperands,
     /*  754892 */     // GIR_Coverage, 12583,
     /*  754892 */     GIR_EraseRootFromParent_Done,
     /*  754893 */   // Label 11791: @754893
     /*  754893 */   GIM_Try, /*On fail goto*//*Label 11792*/ GIMT_Encode4(754968), // Rule ID 12586 //
     /*  754898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  754901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  754918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  754921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  754929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  754933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  754937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  754944 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  754944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  754947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  754949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  754951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  754953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  754955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  754960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  754963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  754966 */     GIR_RootConstrainSelectedInstOperands,
     /*  754967 */     // GIR_Coverage, 12586,
     /*  754967 */     GIR_EraseRootFromParent_Done,
     /*  754968 */   // Label 11792: @754968
     /*  754968 */   GIM_Try, /*On fail goto*//*Label 11793*/ GIMT_Encode4(755043), // Rule ID 12587 //
     /*  754973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  754976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  754981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  754984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  754987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  754990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  754993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  754996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755019 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755041 */     GIR_RootConstrainSelectedInstOperands,
     /*  755042 */     // GIR_Coverage, 12587,
     /*  755042 */     GIR_EraseRootFromParent_Done,
     /*  755043 */   // Label 11793: @755043
     /*  755043 */   GIM_Try, /*On fail goto*//*Label 11794*/ GIMT_Encode4(755118), // Rule ID 12590 //
     /*  755048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  755094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755116 */     GIR_RootConstrainSelectedInstOperands,
     /*  755117 */     // GIR_Coverage, 12590,
     /*  755117 */     GIR_EraseRootFromParent_Done,
     /*  755118 */   // Label 11794: @755118
     /*  755118 */   GIM_Try, /*On fail goto*//*Label 11795*/ GIMT_Encode4(755193), // Rule ID 12591 //
     /*  755123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  755134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  755137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  755140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755169 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  755169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  755188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755191 */     GIR_RootConstrainSelectedInstOperands,
     /*  755192 */     // GIR_Coverage, 12591,
     /*  755192 */     GIR_EraseRootFromParent_Done,
     /*  755193 */   // Label 11795: @755193
     /*  755193 */   GIM_Try, /*On fail goto*//*Label 11796*/ GIMT_Encode4(755268), // Rule ID 12594 //
     /*  755198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755244 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755266 */     GIR_RootConstrainSelectedInstOperands,
     /*  755267 */     // GIR_Coverage, 12594,
     /*  755267 */     GIR_EraseRootFromParent_Done,
     /*  755268 */   // Label 11796: @755268
     /*  755268 */   GIM_Try, /*On fail goto*//*Label 11797*/ GIMT_Encode4(755343), // Rule ID 12595 //
     /*  755273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  755284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  755287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  755290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755319 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11588:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2),
     /*  755322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755341 */     GIR_RootConstrainSelectedInstOperands,
     /*  755342 */     // GIR_Coverage, 12595,
     /*  755342 */     GIR_EraseRootFromParent_Done,
     /*  755343 */   // Label 11797: @755343
     /*  755343 */   GIM_Try, /*On fail goto*//*Label 11798*/ GIMT_Encode4(755418), // Rule ID 12598 //
     /*  755348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755394 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755416 */     GIR_RootConstrainSelectedInstOperands,
     /*  755417 */     // GIR_Coverage, 12598,
     /*  755417 */     GIR_EraseRootFromParent_Done,
     /*  755418 */   // Label 11798: @755418
     /*  755418 */   GIM_Try, /*On fail goto*//*Label 11799*/ GIMT_Encode4(755493), // Rule ID 12599 //
     /*  755423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  755434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  755437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  755440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755469 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11588:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1),
     /*  755472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755491 */     GIR_RootConstrainSelectedInstOperands,
     /*  755492 */     // GIR_Coverage, 12599,
     /*  755492 */     GIR_EraseRootFromParent_Done,
     /*  755493 */   // Label 11799: @755493
     /*  755493 */   GIM_Try, /*On fail goto*//*Label 11800*/ GIMT_Encode4(755568), // Rule ID 12602 //
     /*  755498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755544 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755566 */     GIR_RootConstrainSelectedInstOperands,
     /*  755567 */     // GIR_Coverage, 12602,
     /*  755567 */     GIR_EraseRootFromParent_Done,
     /*  755568 */   // Label 11800: @755568
     /*  755568 */   GIM_Try, /*On fail goto*//*Label 11801*/ GIMT_Encode4(755643), // Rule ID 12603 //
     /*  755573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  755584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  755587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  755590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  755608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755619 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11588:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2),
     /*  755622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755641 */     GIR_RootConstrainSelectedInstOperands,
     /*  755642 */     // GIR_Coverage, 12603,
     /*  755642 */     GIR_EraseRootFromParent_Done,
     /*  755643 */   // Label 11801: @755643
     /*  755643 */   GIM_Try, /*On fail goto*//*Label 11802*/ GIMT_Encode4(755718), // Rule ID 12606 //
     /*  755648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  755651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  755668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  755694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755716 */     GIR_RootConstrainSelectedInstOperands,
     /*  755717 */     // GIR_Coverage, 12606,
     /*  755717 */     GIR_EraseRootFromParent_Done,
     /*  755718 */   // Label 11802: @755718
     /*  755718 */   GIM_Try, /*On fail goto*//*Label 11803*/ GIMT_Encode4(755793), // Rule ID 12607 //
     /*  755723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  755726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu),
     /*  755731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  755734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  755737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  755740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  755743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  755754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  755758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  755762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755769 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11588:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWMULSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  755769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4),
     /*  755772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  755788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755791 */     GIR_RootConstrainSelectedInstOperands,
     /*  755792 */     // GIR_Coverage, 12607,
     /*  755792 */     GIR_EraseRootFromParent_Done,
     /*  755793 */   // Label 11803: @755793
     /*  755793 */   GIM_Try, /*On fail goto*//*Label 11804*/ GIMT_Encode4(755871), // Rule ID 13936 //
     /*  755798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  755806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  755809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  755812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  755844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  755847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755866 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  755869 */     GIR_RootConstrainSelectedInstOperands,
     /*  755870 */     // GIR_Coverage, 13936,
     /*  755870 */     GIR_EraseRootFromParent_Done,
     /*  755871 */   // Label 11804: @755871
     /*  755871 */   GIM_Try, /*On fail goto*//*Label 11805*/ GIMT_Encode4(755949), // Rule ID 13937 //
     /*  755876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  755879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  755884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  755887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  755890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  755893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  755896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  755899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  755922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  755922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /*  755925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  755927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  755929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  755931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  755933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  755938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  755941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  755944 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  755947 */     GIR_RootConstrainSelectedInstOperands,
     /*  755948 */     // GIR_Coverage, 13937,
     /*  755948 */     GIR_EraseRootFromParent_Done,
     /*  755949 */   // Label 11805: @755949
     /*  755949 */   GIM_Try, /*On fail goto*//*Label 11806*/ GIMT_Encode4(756027), // Rule ID 13940 //
     /*  755954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  755957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  755962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  755965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  755968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  755971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  755974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  755977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  755993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756000 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756022 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756025 */     GIR_RootConstrainSelectedInstOperands,
     /*  756026 */     // GIR_Coverage, 13940,
     /*  756026 */     GIR_EraseRootFromParent_Done,
     /*  756027 */   // Label 11806: @756027
     /*  756027 */   GIM_Try, /*On fail goto*//*Label 11807*/ GIMT_Encode4(756105), // Rule ID 13941 //
     /*  756032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  756043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  756046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  756049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  756052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756078 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756100 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756103 */     GIR_RootConstrainSelectedInstOperands,
     /*  756104 */     // GIR_Coverage, 13941,
     /*  756104 */     GIR_EraseRootFromParent_Done,
     /*  756105 */   // Label 11807: @756105
     /*  756105 */   GIM_Try, /*On fail goto*//*Label 11808*/ GIMT_Encode4(756183), // Rule ID 13944 //
     /*  756110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756181 */     GIR_RootConstrainSelectedInstOperands,
     /*  756182 */     // GIR_Coverage, 13944,
     /*  756182 */     GIR_EraseRootFromParent_Done,
     /*  756183 */   // Label 11808: @756183
     /*  756183 */   GIM_Try, /*On fail goto*//*Label 11809*/ GIMT_Encode4(756261), // Rule ID 13945 //
     /*  756188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  756199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  756202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  756205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  756208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756259 */     GIR_RootConstrainSelectedInstOperands,
     /*  756260 */     // GIR_Coverage, 13945,
     /*  756260 */     GIR_EraseRootFromParent_Done,
     /*  756261 */   // Label 11809: @756261
     /*  756261 */   GIM_Try, /*On fail goto*//*Label 11810*/ GIMT_Encode4(756339), // Rule ID 13948 //
     /*  756266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756312 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756337 */     GIR_RootConstrainSelectedInstOperands,
     /*  756338 */     // GIR_Coverage, 13948,
     /*  756338 */     GIR_EraseRootFromParent_Done,
     /*  756339 */   // Label 11810: @756339
     /*  756339 */   GIM_Try, /*On fail goto*//*Label 11811*/ GIMT_Encode4(756417), // Rule ID 13949 //
     /*  756344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  756355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  756358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  756361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  756364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /*  756393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756415 */     GIR_RootConstrainSelectedInstOperands,
     /*  756416 */     // GIR_Coverage, 13949,
     /*  756416 */     GIR_EraseRootFromParent_Done,
     /*  756417 */   // Label 11811: @756417
     /*  756417 */   GIM_Try, /*On fail goto*//*Label 11812*/ GIMT_Encode4(756495), // Rule ID 13952 //
     /*  756422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  756433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  756436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756468 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756493 */     GIR_RootConstrainSelectedInstOperands,
     /*  756494 */     // GIR_Coverage, 13952,
     /*  756494 */     GIR_EraseRootFromParent_Done,
     /*  756495 */   // Label 11812: @756495
     /*  756495 */   GIM_Try, /*On fail goto*//*Label 11813*/ GIMT_Encode4(756573), // Rule ID 13953 //
     /*  756500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  756511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  756514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  756517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  756520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756546 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  756546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756571 */     GIR_RootConstrainSelectedInstOperands,
     /*  756572 */     // GIR_Coverage, 13953,
     /*  756572 */     GIR_EraseRootFromParent_Done,
     /*  756573 */   // Label 11813: @756573
     /*  756573 */   GIM_Try, /*On fail goto*//*Label 11814*/ GIMT_Encode4(756651), // Rule ID 13956 //
     /*  756578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  756598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756624 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  756624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756649 */     GIR_RootConstrainSelectedInstOperands,
     /*  756650 */     // GIR_Coverage, 13956,
     /*  756650 */     GIR_EraseRootFromParent_Done,
     /*  756651 */   // Label 11814: @756651
     /*  756651 */   GIM_Try, /*On fail goto*//*Label 11815*/ GIMT_Encode4(756729), // Rule ID 13957 //
     /*  756656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  756667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  756670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  756673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  756676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  756702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /*  756705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  756721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756727 */     GIR_RootConstrainSelectedInstOperands,
     /*  756728 */     // GIR_Coverage, 13957,
     /*  756728 */     GIR_EraseRootFromParent_Done,
     /*  756729 */   // Label 11815: @756729
     /*  756729 */   GIM_Try, /*On fail goto*//*Label 11816*/ GIMT_Encode4(756807), // Rule ID 13960 //
     /*  756734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  756745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  756748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  756780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  756783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756805 */     GIR_RootConstrainSelectedInstOperands,
     /*  756806 */     // GIR_Coverage, 13960,
     /*  756806 */     GIR_EraseRootFromParent_Done,
     /*  756807 */   // Label 11816: @756807
     /*  756807 */   GIM_Try, /*On fail goto*//*Label 11817*/ GIMT_Encode4(756885), // Rule ID 13961 //
     /*  756812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  756823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  756826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  756829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  756832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756858 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  756858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  756861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  756877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756883 */     GIR_RootConstrainSelectedInstOperands,
     /*  756884 */     // GIR_Coverage, 13961,
     /*  756884 */     GIR_EraseRootFromParent_Done,
     /*  756885 */   // Label 11817: @756885
     /*  756885 */   GIM_Try, /*On fail goto*//*Label 11818*/ GIMT_Encode4(756963), // Rule ID 13964 //
     /*  756890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  756893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  756901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  756904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  756913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  756936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  756936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  756939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  756941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  756943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  756945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  756947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  756952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  756955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  756958 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  756961 */     GIR_RootConstrainSelectedInstOperands,
     /*  756962 */     // GIR_Coverage, 13964,
     /*  756962 */     GIR_EraseRootFromParent_Done,
     /*  756963 */   // Label 11818: @756963
     /*  756963 */   GIM_Try, /*On fail goto*//*Label 11819*/ GIMT_Encode4(757041), // Rule ID 13965 //
     /*  756968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  756971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  756976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  756979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  756982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  756985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  756988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  756991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  756999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757039 */     GIR_RootConstrainSelectedInstOperands,
     /*  757040 */     // GIR_Coverage, 13965,
     /*  757040 */     GIR_EraseRootFromParent_Done,
     /*  757041 */   // Label 11819: @757041
     /*  757041 */   GIM_Try, /*On fail goto*//*Label 11820*/ GIMT_Encode4(757119), // Rule ID 13968 //
     /*  757046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  757092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757117 */     GIR_RootConstrainSelectedInstOperands,
     /*  757118 */     // GIR_Coverage, 13968,
     /*  757118 */     GIR_EraseRootFromParent_Done,
     /*  757119 */   // Label 11820: @757119
     /*  757119 */   GIM_Try, /*On fail goto*//*Label 11821*/ GIMT_Encode4(757197), // Rule ID 13969 //
     /*  757124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  757135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  757138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  757141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  757144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  757170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  757189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757195 */     GIR_RootConstrainSelectedInstOperands,
     /*  757196 */     // GIR_Coverage, 13969,
     /*  757196 */     GIR_EraseRootFromParent_Done,
     /*  757197 */   // Label 11821: @757197
     /*  757197 */   GIM_Try, /*On fail goto*//*Label 11822*/ GIMT_Encode4(757275), // Rule ID 13972 //
     /*  757202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  757205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757248 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  757248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757273 */     GIR_RootConstrainSelectedInstOperands,
     /*  757274 */     // GIR_Coverage, 13972,
     /*  757274 */     GIR_EraseRootFromParent_Done,
     /*  757275 */   // Label 11822: @757275
     /*  757275 */   GIM_Try, /*On fail goto*//*Label 11823*/ GIMT_Encode4(757353), // Rule ID 13973 //
     /*  757280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  757283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  757291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  757294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  757297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  757300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  757319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757326 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  757326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /*  757329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  757345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757348 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757351 */     GIR_RootConstrainSelectedInstOperands,
     /*  757352 */     // GIR_Coverage, 13973,
     /*  757352 */     GIR_EraseRootFromParent_Done,
     /*  757353 */   // Label 11823: @757353
     /*  757353 */   GIM_Try, /*On fail goto*//*Label 11824*/ GIMT_Encode4(757431), // Rule ID 13976 //
     /*  757358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757404 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757429 */     GIR_RootConstrainSelectedInstOperands,
     /*  757430 */     // GIR_Coverage, 13976,
     /*  757430 */     GIR_EraseRootFromParent_Done,
     /*  757431 */   // Label 11824: @757431
     /*  757431 */   GIM_Try, /*On fail goto*//*Label 11825*/ GIMT_Encode4(757509), // Rule ID 13977 //
     /*  757436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  757447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  757450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  757453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  757456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757507 */     GIR_RootConstrainSelectedInstOperands,
     /*  757508 */     // GIR_Coverage, 13977,
     /*  757508 */     GIR_EraseRootFromParent_Done,
     /*  757509 */   // Label 11825: @757509
     /*  757509 */   GIM_Try, /*On fail goto*//*Label 11826*/ GIMT_Encode4(757587), // Rule ID 13980 //
     /*  757514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  757525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  757528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  757531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  757534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757560 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  757563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757582 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757585 */     GIR_RootConstrainSelectedInstOperands,
     /*  757586 */     // GIR_Coverage, 13980,
     /*  757586 */     GIR_EraseRootFromParent_Done,
     /*  757587 */   // Label 11826: @757587
     /*  757587 */   GIM_Try, /*On fail goto*//*Label 11827*/ GIMT_Encode4(757665), // Rule ID 13981 //
     /*  757592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  757603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  757606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  757609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  757612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  757631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757638 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  757641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757660 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757663 */     GIR_RootConstrainSelectedInstOperands,
     /*  757664 */     // GIR_Coverage, 13981,
     /*  757664 */     GIR_EraseRootFromParent_Done,
     /*  757665 */   // Label 11827: @757665
     /*  757665 */   GIM_Try, /*On fail goto*//*Label 11828*/ GIMT_Encode4(757743), // Rule ID 13984 //
     /*  757670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  757681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  757684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  757687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  757690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757716 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  757716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  757719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757738 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757741 */     GIR_RootConstrainSelectedInstOperands,
     /*  757742 */     // GIR_Coverage, 13984,
     /*  757742 */     GIR_EraseRootFromParent_Done,
     /*  757743 */   // Label 11828: @757743
     /*  757743 */   GIM_Try, /*On fail goto*//*Label 11829*/ GIMT_Encode4(757821), // Rule ID 13985 //
     /*  757748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  757759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  757762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  757765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  757768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  757787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757794 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  757794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  757797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  757813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757819 */     GIR_RootConstrainSelectedInstOperands,
     /*  757820 */     // GIR_Coverage, 13985,
     /*  757820 */     GIR_EraseRootFromParent_Done,
     /*  757821 */   // Label 11829: @757821
     /*  757821 */   GIM_Try, /*On fail goto*//*Label 11830*/ GIMT_Encode4(757899), // Rule ID 13988 //
     /*  757826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  757837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  757840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  757849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  757872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757897 */     GIR_RootConstrainSelectedInstOperands,
     /*  757898 */     // GIR_Coverage, 13988,
     /*  757898 */     GIR_EraseRootFromParent_Done,
     /*  757899 */   // Label 11830: @757899
     /*  757899 */   GIM_Try, /*On fail goto*//*Label 11831*/ GIMT_Encode4(757977), // Rule ID 13989 //
     /*  757904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  757907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  757915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  757918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  757921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  757924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  757927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  757943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  757950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  757950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  757953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  757955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  757957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  757959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  757961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  757966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  757969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  757972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  757975 */     GIR_RootConstrainSelectedInstOperands,
     /*  757976 */     // GIR_Coverage, 13989,
     /*  757976 */     GIR_EraseRootFromParent_Done,
     /*  757977 */   // Label 11831: @757977
     /*  757977 */   GIM_Try, /*On fail goto*//*Label 11832*/ GIMT_Encode4(758055), // Rule ID 13992 //
     /*  757982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  757985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  757990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  757993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  757996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  757999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758053 */     GIR_RootConstrainSelectedInstOperands,
     /*  758054 */     // GIR_Coverage, 13992,
     /*  758054 */     GIR_EraseRootFromParent_Done,
     /*  758055 */   // Label 11832: @758055
     /*  758055 */   GIM_Try, /*On fail goto*//*Label 11833*/ GIMT_Encode4(758133), // Rule ID 13993 //
     /*  758060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  758071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  758074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  758077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  758080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758128 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758131 */     GIR_RootConstrainSelectedInstOperands,
     /*  758132 */     // GIR_Coverage, 13993,
     /*  758132 */     GIR_EraseRootFromParent_Done,
     /*  758133 */   // Label 11833: @758133
     /*  758133 */   GIM_Try, /*On fail goto*//*Label 11834*/ GIMT_Encode4(758211), // Rule ID 13996 //
     /*  758138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  758184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758206 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758209 */     GIR_RootConstrainSelectedInstOperands,
     /*  758210 */     // GIR_Coverage, 13996,
     /*  758210 */     GIR_EraseRootFromParent_Done,
     /*  758211 */   // Label 11834: @758211
     /*  758211 */   GIM_Try, /*On fail goto*//*Label 11835*/ GIMT_Encode4(758289), // Rule ID 13997 //
     /*  758216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  758227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  758230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  758233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  758236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  758262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  758281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758287 */     GIR_RootConstrainSelectedInstOperands,
     /*  758288 */     // GIR_Coverage, 13997,
     /*  758288 */     GIR_EraseRootFromParent_Done,
     /*  758289 */   // Label 11835: @758289
     /*  758289 */   GIM_Try, /*On fail goto*//*Label 11836*/ GIMT_Encode4(758367), // Rule ID 14000 //
     /*  758294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758365 */     GIR_RootConstrainSelectedInstOperands,
     /*  758366 */     // GIR_Coverage, 14000,
     /*  758366 */     GIR_EraseRootFromParent_Done,
     /*  758367 */   // Label 11836: @758367
     /*  758367 */   GIM_Try, /*On fail goto*//*Label 11837*/ GIMT_Encode4(758445), // Rule ID 14001 //
     /*  758372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  758383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  758386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  758389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  758392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758418 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758440 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758443 */     GIR_RootConstrainSelectedInstOperands,
     /*  758444 */     // GIR_Coverage, 14001,
     /*  758444 */     GIR_EraseRootFromParent_Done,
     /*  758445 */   // Label 11837: @758445
     /*  758445 */   GIM_Try, /*On fail goto*//*Label 11838*/ GIMT_Encode4(758523), // Rule ID 14004 //
     /*  758450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  758461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  758464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  758467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  758470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758496 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758518 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758521 */     GIR_RootConstrainSelectedInstOperands,
     /*  758522 */     // GIR_Coverage, 14004,
     /*  758522 */     GIR_EraseRootFromParent_Done,
     /*  758523 */   // Label 11838: @758523
     /*  758523 */   GIM_Try, /*On fail goto*//*Label 11839*/ GIMT_Encode4(758601), // Rule ID 14005 //
     /*  758528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  758539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  758542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  758545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  758548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758574 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758599 */     GIR_RootConstrainSelectedInstOperands,
     /*  758600 */     // GIR_Coverage, 14005,
     /*  758600 */     GIR_EraseRootFromParent_Done,
     /*  758601 */   // Label 11839: @758601
     /*  758601 */   GIM_Try, /*On fail goto*//*Label 11840*/ GIMT_Encode4(758679), // Rule ID 14008 //
     /*  758606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  758609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  758617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  758620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  758623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  758626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758652 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  758652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758677 */     GIR_RootConstrainSelectedInstOperands,
     /*  758678 */     // GIR_Coverage, 14008,
     /*  758678 */     GIR_EraseRootFromParent_Done,
     /*  758679 */   // Label 11840: @758679
     /*  758679 */   GIM_Try, /*On fail goto*//*Label 11841*/ GIMT_Encode4(758757), // Rule ID 14009 //
     /*  758684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  758687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  758695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  758698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  758701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  758704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  758723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  758730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  758733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  758749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758755 */     GIR_RootConstrainSelectedInstOperands,
     /*  758756 */     // GIR_Coverage, 14009,
     /*  758756 */     GIR_EraseRootFromParent_Done,
     /*  758757 */   // Label 11841: @758757
     /*  758757 */   GIM_Try, /*On fail goto*//*Label 11842*/ GIMT_Encode4(758835), // Rule ID 14012 //
     /*  758762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  758765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  758773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  758776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  758779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  758782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  758808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758833 */     GIR_RootConstrainSelectedInstOperands,
     /*  758834 */     // GIR_Coverage, 14012,
     /*  758834 */     GIR_EraseRootFromParent_Done,
     /*  758835 */   // Label 11842: @758835
     /*  758835 */   GIM_Try, /*On fail goto*//*Label 11843*/ GIMT_Encode4(758913), // Rule ID 14013 //
     /*  758840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  758843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  758851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  758854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  758857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  758860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  758863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  758879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  758886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /*  758889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758908 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758911 */     GIR_RootConstrainSelectedInstOperands,
     /*  758912 */     // GIR_Coverage, 14013,
     /*  758912 */     GIR_EraseRootFromParent_Done,
     /*  758913 */   // Label 11843: @758913
     /*  758913 */   GIM_Try, /*On fail goto*//*Label 11844*/ GIMT_Encode4(758991), // Rule ID 14016 //
     /*  758918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  758921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  758926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  758929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  758932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  758935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  758938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  758941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  758957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  758964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  758964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  758967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  758969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  758971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  758973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  758975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  758980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  758983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  758986 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  758989 */     GIR_RootConstrainSelectedInstOperands,
     /*  758990 */     // GIR_Coverage, 14016,
     /*  758990 */     GIR_EraseRootFromParent_Done,
     /*  758991 */   // Label 11844: @758991
     /*  758991 */   GIM_Try, /*On fail goto*//*Label 11845*/ GIMT_Encode4(759069), // Rule ID 14017 //
     /*  758996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  758999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  759007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  759010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  759013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  759016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  759035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759042 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /*  759045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759064 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759067 */     GIR_RootConstrainSelectedInstOperands,
     /*  759068 */     // GIR_Coverage, 14017,
     /*  759068 */     GIR_EraseRootFromParent_Done,
     /*  759069 */   // Label 11845: @759069
     /*  759069 */   GIM_Try, /*On fail goto*//*Label 11846*/ GIMT_Encode4(759147), // Rule ID 14020 //
     /*  759074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  759077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  759120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759145 */     GIR_RootConstrainSelectedInstOperands,
     /*  759146 */     // GIR_Coverage, 14020,
     /*  759146 */     GIR_EraseRootFromParent_Done,
     /*  759147 */   // Label 11846: @759147
     /*  759147 */   GIM_Try, /*On fail goto*//*Label 11847*/ GIMT_Encode4(759225), // Rule ID 14021 //
     /*  759152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  759155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  759163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  759166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  759169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  759172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  759191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759198 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  759198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /*  759201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  759217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759223 */     GIR_RootConstrainSelectedInstOperands,
     /*  759224 */     // GIR_Coverage, 14021,
     /*  759224 */     GIR_EraseRootFromParent_Done,
     /*  759225 */   // Label 11847: @759225
     /*  759225 */   GIM_Try, /*On fail goto*//*Label 11848*/ GIMT_Encode4(759303), // Rule ID 14024 //
     /*  759230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759276 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759301 */     GIR_RootConstrainSelectedInstOperands,
     /*  759302 */     // GIR_Coverage, 14024,
     /*  759302 */     GIR_EraseRootFromParent_Done,
     /*  759303 */   // Label 11848: @759303
     /*  759303 */   GIM_Try, /*On fail goto*//*Label 11849*/ GIMT_Encode4(759381), // Rule ID 14025 //
     /*  759308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  759319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  759322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  759325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  759354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8),
     /*  759357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759379 */     GIR_RootConstrainSelectedInstOperands,
     /*  759380 */     // GIR_Coverage, 14025,
     /*  759380 */     GIR_EraseRootFromParent_Done,
     /*  759381 */   // Label 11849: @759381
     /*  759381 */   GIM_Try, /*On fail goto*//*Label 11850*/ GIMT_Encode4(759459), // Rule ID 14028 //
     /*  759386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  759403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759432 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759457 */     GIR_RootConstrainSelectedInstOperands,
     /*  759458 */     // GIR_Coverage, 14028,
     /*  759458 */     GIR_EraseRootFromParent_Done,
     /*  759459 */   // Label 11850: @759459
     /*  759459 */   GIM_Try, /*On fail goto*//*Label 11851*/ GIMT_Encode4(759537), // Rule ID 14029 //
     /*  759464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  759475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  759478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  759481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759510 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  759510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759535 */     GIR_RootConstrainSelectedInstOperands,
     /*  759536 */     // GIR_Coverage, 14029,
     /*  759536 */     GIR_EraseRootFromParent_Done,
     /*  759537 */   // Label 11851: @759537
     /*  759537 */   GIM_Try, /*On fail goto*//*Label 11852*/ GIMT_Encode4(759615), // Rule ID 14032 //
     /*  759542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  759553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  759556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  759559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759588 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  759588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  759591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759613 */     GIR_RootConstrainSelectedInstOperands,
     /*  759614 */     // GIR_Coverage, 14032,
     /*  759614 */     GIR_EraseRootFromParent_Done,
     /*  759615 */   // Label 11852: @759615
     /*  759615 */   GIM_Try, /*On fail goto*//*Label 11853*/ GIMT_Encode4(759693), // Rule ID 14033 //
     /*  759620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  759631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  759634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  759637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759666 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  759666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  759669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  759685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759691 */     GIR_RootConstrainSelectedInstOperands,
     /*  759692 */     // GIR_Coverage, 14033,
     /*  759692 */     GIR_EraseRootFromParent_Done,
     /*  759693 */   // Label 11853: @759693
     /*  759693 */   GIM_Try, /*On fail goto*//*Label 11854*/ GIMT_Encode4(759771), // Rule ID 14036 //
     /*  759698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  759709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  759712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  759715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759766 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759769 */     GIR_RootConstrainSelectedInstOperands,
     /*  759770 */     // GIR_Coverage, 14036,
     /*  759770 */     GIR_EraseRootFromParent_Done,
     /*  759771 */   // Label 11854: @759771
     /*  759771 */   GIM_Try, /*On fail goto*//*Label 11855*/ GIMT_Encode4(759849), // Rule ID 14037 //
     /*  759776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  759787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  759790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  759793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759822 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4),
     /*  759825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759847 */     GIR_RootConstrainSelectedInstOperands,
     /*  759848 */     // GIR_Coverage, 14037,
     /*  759848 */     GIR_EraseRootFromParent_Done,
     /*  759849 */   // Label 11855: @759849
     /*  759849 */   GIM_Try, /*On fail goto*//*Label 11856*/ GIMT_Encode4(759927), // Rule ID 14040 //
     /*  759854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  759857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  759865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  759868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  759871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  759874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  759877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759900 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  759900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  759903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  759922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  759925 */     GIR_RootConstrainSelectedInstOperands,
     /*  759926 */     // GIR_Coverage, 14040,
     /*  759926 */     GIR_EraseRootFromParent_Done,
     /*  759927 */   // Label 11856: @759927
     /*  759927 */   GIM_Try, /*On fail goto*//*Label 11857*/ GIMT_Encode4(760005), // Rule ID 14041 //
     /*  759932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  759935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  759940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  759943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  759946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  759949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  759952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  759955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  759967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  759971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  759978 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  759978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  759981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  759983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  759985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  759987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  759989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  759994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  759997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760003 */     GIR_RootConstrainSelectedInstOperands,
     /*  760004 */     // GIR_Coverage, 14041,
     /*  760004 */     GIR_EraseRootFromParent_Done,
     /*  760005 */   // Label 11857: @760005
     /*  760005 */   GIM_Try, /*On fail goto*//*Label 11858*/ GIMT_Encode4(760083), // Rule ID 14044 //
     /*  760010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760081 */     GIR_RootConstrainSelectedInstOperands,
     /*  760082 */     // GIR_Coverage, 14044,
     /*  760082 */     GIR_EraseRootFromParent_Done,
     /*  760083 */   // Label 11858: @760083
     /*  760083 */   GIM_Try, /*On fail goto*//*Label 11859*/ GIMT_Encode4(760161), // Rule ID 14045 //
     /*  760088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  760099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  760102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  760105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2),
     /*  760137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760159 */     GIR_RootConstrainSelectedInstOperands,
     /*  760160 */     // GIR_Coverage, 14045,
     /*  760160 */     GIR_EraseRootFromParent_Done,
     /*  760161 */   // Label 11859: @760161
     /*  760161 */   GIM_Try, /*On fail goto*//*Label 11860*/ GIMT_Encode4(760239), // Rule ID 14048 //
     /*  760166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760237 */     GIR_RootConstrainSelectedInstOperands,
     /*  760238 */     // GIR_Coverage, 14048,
     /*  760238 */     GIR_EraseRootFromParent_Done,
     /*  760239 */   // Label 11860: @760239
     /*  760239 */   GIM_Try, /*On fail goto*//*Label 11861*/ GIMT_Encode4(760317), // Rule ID 14049 //
     /*  760244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  760255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  760258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  760261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760290 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11464:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760315 */     GIR_RootConstrainSelectedInstOperands,
     /*  760316 */     // GIR_Coverage, 14049,
     /*  760316 */     GIR_EraseRootFromParent_Done,
     /*  760317 */   // Label 11861: @760317
     /*  760317 */   GIM_Try, /*On fail goto*//*Label 11862*/ GIMT_Encode4(760395), // Rule ID 14052 //
     /*  760322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  760368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760393 */     GIR_RootConstrainSelectedInstOperands,
     /*  760394 */     // GIR_Coverage, 14052,
     /*  760394 */     GIR_EraseRootFromParent_Done,
     /*  760395 */   // Label 11862: @760395
     /*  760395 */   GIM_Try, /*On fail goto*//*Label 11863*/ GIMT_Encode4(760473), // Rule ID 14053 //
     /*  760400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  760411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  760414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  760417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11464:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  760446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  760465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760468 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760471 */     GIR_RootConstrainSelectedInstOperands,
     /*  760472 */     // GIR_Coverage, 14053,
     /*  760472 */     GIR_EraseRootFromParent_Done,
     /*  760473 */   // Label 11863: @760473
     /*  760473 */   GIM_Try, /*On fail goto*//*Label 11864*/ GIMT_Encode4(760551), // Rule ID 14056 //
     /*  760478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  760489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  760492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  760495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  760524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760546 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760549 */     GIR_RootConstrainSelectedInstOperands,
     /*  760550 */     // GIR_Coverage, 14056,
     /*  760550 */     GIR_EraseRootFromParent_Done,
     /*  760551 */   // Label 11864: @760551
     /*  760551 */   GIM_Try, /*On fail goto*//*Label 11865*/ GIMT_Encode4(760629), // Rule ID 14057 //
     /*  760556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  760567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  760570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  760573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11464:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  760602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  760621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760624 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760627 */     GIR_RootConstrainSelectedInstOperands,
     /*  760628 */     // GIR_Coverage, 14057,
     /*  760628 */     GIR_EraseRootFromParent_Done,
     /*  760629 */   // Label 11865: @760629
     /*  760629 */   GIM_Try, /*On fail goto*//*Label 11866*/ GIMT_Encode4(760707), // Rule ID 14060 //
     /*  760634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  760637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  760645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  760648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  760651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760680 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  760680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760705 */     GIR_RootConstrainSelectedInstOperands,
     /*  760706 */     // GIR_Coverage, 14060,
     /*  760706 */     GIR_EraseRootFromParent_Done,
     /*  760707 */   // Label 11866: @760707
     /*  760707 */   GIM_Try, /*On fail goto*//*Label 11867*/ GIMT_Encode4(760785), // Rule ID 14061 //
     /*  760712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  760715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  760723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  760726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  760729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  760747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11464:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  760758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1),
     /*  760761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  760777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760783 */     GIR_RootConstrainSelectedInstOperands,
     /*  760784 */     // GIR_Coverage, 14061,
     /*  760784 */     GIR_EraseRootFromParent_Done,
     /*  760785 */   // Label 11867: @760785
     /*  760785 */   GIM_Try, /*On fail goto*//*Label 11868*/ GIMT_Encode4(760863), // Rule ID 14064 //
     /*  760790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  760801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  760804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  760807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  760839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760861 */     GIR_RootConstrainSelectedInstOperands,
     /*  760862 */     // GIR_Coverage, 14064,
     /*  760862 */     GIR_EraseRootFromParent_Done,
     /*  760863 */   // Label 11868: @760863
     /*  760863 */   GIM_Try, /*On fail goto*//*Label 11869*/ GIMT_Encode4(760941), // Rule ID 14065 //
     /*  760868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  760871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  760879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  760882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  760885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  760888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  760891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  760903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  760914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  760917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  760923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  760925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  760930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  760933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  760936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  760939 */     GIR_RootConstrainSelectedInstOperands,
     /*  760940 */     // GIR_Coverage, 14065,
     /*  760940 */     GIR_EraseRootFromParent_Done,
     /*  760941 */   // Label 11869: @760941
     /*  760941 */   GIM_Try, /*On fail goto*//*Label 11870*/ GIMT_Encode4(761019), // Rule ID 14068 //
     /*  760946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  760949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  760954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  760957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  760960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  760963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  760966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  760969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  760981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  760985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  760992 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  760992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  760995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  760997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  760999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761017 */     GIR_RootConstrainSelectedInstOperands,
     /*  761018 */     // GIR_Coverage, 14068,
     /*  761018 */     GIR_EraseRootFromParent_Done,
     /*  761019 */   // Label 11870: @761019
     /*  761019 */   GIM_Try, /*On fail goto*//*Label 11871*/ GIMT_Encode4(761097), // Rule ID 14069 //
     /*  761024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  761035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  761038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  761041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761070 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761092 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761095 */     GIR_RootConstrainSelectedInstOperands,
     /*  761096 */     // GIR_Coverage, 14069,
     /*  761096 */     GIR_EraseRootFromParent_Done,
     /*  761097 */   // Label 11871: @761097
     /*  761097 */   GIM_Try, /*On fail goto*//*Label 11872*/ GIMT_Encode4(761175), // Rule ID 14072 //
     /*  761102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761148 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  761148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761170 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761173 */     GIR_RootConstrainSelectedInstOperands,
     /*  761174 */     // GIR_Coverage, 14072,
     /*  761174 */     GIR_EraseRootFromParent_Done,
     /*  761175 */   // Label 11872: @761175
     /*  761175 */   GIM_Try, /*On fail goto*//*Label 11873*/ GIMT_Encode4(761253), // Rule ID 14073 //
     /*  761180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  761191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  761194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  761197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761226 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  761226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  761245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761251 */     GIR_RootConstrainSelectedInstOperands,
     /*  761252 */     // GIR_Coverage, 14073,
     /*  761252 */     GIR_EraseRootFromParent_Done,
     /*  761253 */   // Label 11873: @761253
     /*  761253 */   GIM_Try, /*On fail goto*//*Label 11874*/ GIMT_Encode4(761331), // Rule ID 14076 //
     /*  761258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761329 */     GIR_RootConstrainSelectedInstOperands,
     /*  761330 */     // GIR_Coverage, 14076,
     /*  761330 */     GIR_EraseRootFromParent_Done,
     /*  761331 */   // Label 11874: @761331
     /*  761331 */   GIM_Try, /*On fail goto*//*Label 11875*/ GIMT_Encode4(761409), // Rule ID 14077 //
     /*  761336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  761347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  761350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  761353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761407 */     GIR_RootConstrainSelectedInstOperands,
     /*  761408 */     // GIR_Coverage, 14077,
     /*  761408 */     GIR_EraseRootFromParent_Done,
     /*  761409 */   // Label 11875: @761409
     /*  761409 */   GIM_Try, /*On fail goto*//*Label 11876*/ GIMT_Encode4(761487), // Rule ID 14080 //
     /*  761414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  761425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  761428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  761431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761485 */     GIR_RootConstrainSelectedInstOperands,
     /*  761486 */     // GIR_Coverage, 14080,
     /*  761486 */     GIR_EraseRootFromParent_Done,
     /*  761487 */   // Label 11876: @761487
     /*  761487 */   GIM_Try, /*On fail goto*//*Label 11877*/ GIMT_Encode4(761565), // Rule ID 14081 //
     /*  761492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  761503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  761506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  761509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761538 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761563 */     GIR_RootConstrainSelectedInstOperands,
     /*  761564 */     // GIR_Coverage, 14081,
     /*  761564 */     GIR_EraseRootFromParent_Done,
     /*  761565 */   // Label 11877: @761565
     /*  761565 */   GIM_Try, /*On fail goto*//*Label 11878*/ GIMT_Encode4(761643), // Rule ID 14084 //
     /*  761570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  761581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  761584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  761587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761616 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  761616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761641 */     GIR_RootConstrainSelectedInstOperands,
     /*  761642 */     // GIR_Coverage, 14084,
     /*  761642 */     GIR_EraseRootFromParent_Done,
     /*  761643 */   // Label 11878: @761643
     /*  761643 */   GIM_Try, /*On fail goto*//*Label 11879*/ GIMT_Encode4(761721), // Rule ID 14085 //
     /*  761648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  761659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  761662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  761665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  761683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  761694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  761697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  761713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761719 */     GIR_RootConstrainSelectedInstOperands,
     /*  761720 */     // GIR_Coverage, 14085,
     /*  761720 */     GIR_EraseRootFromParent_Done,
     /*  761721 */   // Label 11879: @761721
     /*  761721 */   GIM_Try, /*On fail goto*//*Label 11880*/ GIMT_Encode4(761799), // Rule ID 14088 //
     /*  761726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  761737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  761740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  761743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761772 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761797 */     GIR_RootConstrainSelectedInstOperands,
     /*  761798 */     // GIR_Coverage, 14088,
     /*  761798 */     GIR_EraseRootFromParent_Done,
     /*  761799 */   // Label 11880: @761799
     /*  761799 */   GIM_Try, /*On fail goto*//*Label 11881*/ GIMT_Encode4(761877), // Rule ID 14089 //
     /*  761804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  761815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  761818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  761821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  761839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  761850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  761853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761875 */     GIR_RootConstrainSelectedInstOperands,
     /*  761876 */     // GIR_Coverage, 14089,
     /*  761876 */     GIR_EraseRootFromParent_Done,
     /*  761877 */   // Label 11881: @761877
     /*  761877 */   GIM_Try, /*On fail goto*//*Label 11882*/ GIMT_Encode4(761955), // Rule ID 14092 //
     /*  761882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  761885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  761893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  761896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  761899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  761902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  761905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  761928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  761928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  761931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  761933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  761935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  761937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  761939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  761944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  761947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  761950 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  761953 */     GIR_RootConstrainSelectedInstOperands,
     /*  761954 */     // GIR_Coverage, 14092,
     /*  761954 */     GIR_EraseRootFromParent_Done,
     /*  761955 */   // Label 11882: @761955
     /*  761955 */   GIM_Try, /*On fail goto*//*Label 11883*/ GIMT_Encode4(762033), // Rule ID 14093 //
     /*  761960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  761963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  761968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  761971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  761974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  761977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  761980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  761983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  761995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  761999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762006 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762028 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762031 */     GIR_RootConstrainSelectedInstOperands,
     /*  762032 */     // GIR_Coverage, 14093,
     /*  762032 */     GIR_EraseRootFromParent_Done,
     /*  762033 */   // Label 11883: @762033
     /*  762033 */   GIM_Try, /*On fail goto*//*Label 11884*/ GIMT_Encode4(762111), // Rule ID 14096 //
     /*  762038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  762084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762106 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762109 */     GIR_RootConstrainSelectedInstOperands,
     /*  762110 */     // GIR_Coverage, 14096,
     /*  762110 */     GIR_EraseRootFromParent_Done,
     /*  762111 */   // Label 11884: @762111
     /*  762111 */   GIM_Try, /*On fail goto*//*Label 11885*/ GIMT_Encode4(762189), // Rule ID 14097 //
     /*  762116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  762127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  762130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  762133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762162 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  762162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  762181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762187 */     GIR_RootConstrainSelectedInstOperands,
     /*  762188 */     // GIR_Coverage, 14097,
     /*  762188 */     GIR_EraseRootFromParent_Done,
     /*  762189 */   // Label 11885: @762189
     /*  762189 */   GIM_Try, /*On fail goto*//*Label 11886*/ GIMT_Encode4(762267), // Rule ID 14100 //
     /*  762194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762262 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762265 */     GIR_RootConstrainSelectedInstOperands,
     /*  762266 */     // GIR_Coverage, 14100,
     /*  762266 */     GIR_EraseRootFromParent_Done,
     /*  762267 */   // Label 11886: @762267
     /*  762267 */   GIM_Try, /*On fail goto*//*Label 11887*/ GIMT_Encode4(762345), // Rule ID 14101 //
     /*  762272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  762283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  762286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  762289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  762307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11464:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2),
     /*  762321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762340 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762343 */     GIR_RootConstrainSelectedInstOperands,
     /*  762344 */     // GIR_Coverage, 14101,
     /*  762344 */     GIR_EraseRootFromParent_Done,
     /*  762345 */   // Label 11887: @762345
     /*  762345 */   GIM_Try, /*On fail goto*//*Label 11888*/ GIMT_Encode4(762423), // Rule ID 14104 //
     /*  762350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762396 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762421 */     GIR_RootConstrainSelectedInstOperands,
     /*  762422 */     // GIR_Coverage, 14104,
     /*  762422 */     GIR_EraseRootFromParent_Done,
     /*  762423 */   // Label 11888: @762423
     /*  762423 */   GIM_Try, /*On fail goto*//*Label 11889*/ GIMT_Encode4(762501), // Rule ID 14105 //
     /*  762428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  762439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  762442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  762445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  762463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11464:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4),
     /*  762477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762499 */     GIR_RootConstrainSelectedInstOperands,
     /*  762500 */     // GIR_Coverage, 14105,
     /*  762500 */     GIR_EraseRootFromParent_Done,
     /*  762501 */   // Label 11889: @762501
     /*  762501 */   GIM_Try, /*On fail goto*//*Label 11890*/ GIMT_Encode4(762579), // Rule ID 14108 //
     /*  762506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  762509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  762517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  762520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  762523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  762526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762552 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  762552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762577 */     GIR_RootConstrainSelectedInstOperands,
     /*  762578 */     // GIR_Coverage, 14108,
     /*  762578 */     GIR_EraseRootFromParent_Done,
     /*  762579 */   // Label 11890: @762579
     /*  762579 */   GIM_Try, /*On fail goto*//*Label 11891*/ GIMT_Encode4(762657), // Rule ID 14109 //
     /*  762584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  762587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu),
     /*  762592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  762595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  762598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  762601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  762604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  762619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  762623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762630 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11464:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  762630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8),
     /*  762633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  762649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762655 */     GIR_RootConstrainSelectedInstOperands,
     /*  762656 */     // GIR_Coverage, 14109,
     /*  762656 */     GIR_EraseRootFromParent_Done,
     /*  762657 */   // Label 11891: @762657
     /*  762657 */   GIM_Try, /*On fail goto*//*Label 11892*/ GIMT_Encode4(762735), // Rule ID 14200 //
     /*  762662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  762670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  762673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  762676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  762679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  762682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  762711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762733 */     GIR_RootConstrainSelectedInstOperands,
     /*  762734 */     // GIR_Coverage, 14200,
     /*  762734 */     GIR_EraseRootFromParent_Done,
     /*  762735 */   // Label 11892: @762735
     /*  762735 */   GIM_Try, /*On fail goto*//*Label 11893*/ GIMT_Encode4(762813), // Rule ID 14201 //
     /*  762740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  762748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  762751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  762754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  762757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  762760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762786 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /*  762789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762808 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762811 */     GIR_RootConstrainSelectedInstOperands,
     /*  762812 */     // GIR_Coverage, 14201,
     /*  762812 */     GIR_EraseRootFromParent_Done,
     /*  762813 */   // Label 11893: @762813
     /*  762813 */   GIM_Try, /*On fail goto*//*Label 11894*/ GIMT_Encode4(762891), // Rule ID 14204 //
     /*  762818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  762826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  762829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  762832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  762835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  762838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762864 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  762864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  762867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762886 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762889 */     GIR_RootConstrainSelectedInstOperands,
     /*  762890 */     // GIR_Coverage, 14204,
     /*  762890 */     GIR_EraseRootFromParent_Done,
     /*  762891 */   // Label 11894: @762891
     /*  762891 */   GIM_Try, /*On fail goto*//*Label 11895*/ GIMT_Encode4(762969), // Rule ID 14205 //
     /*  762896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  762899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  762904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  762907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  762910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  762913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  762916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  762919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  762935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  762942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  762942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  762945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  762947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  762949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  762951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  762953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  762958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  762961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  762964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  762967 */     GIR_RootConstrainSelectedInstOperands,
     /*  762968 */     // GIR_Coverage, 14205,
     /*  762968 */     GIR_EraseRootFromParent_Done,
     /*  762969 */   // Label 11895: @762969
     /*  762969 */   GIM_Try, /*On fail goto*//*Label 11896*/ GIMT_Encode4(763047), // Rule ID 14208 //
     /*  762974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  762977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  762982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  762985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  762988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  762991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  762994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  762997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763045 */     GIR_RootConstrainSelectedInstOperands,
     /*  763046 */     // GIR_Coverage, 14208,
     /*  763046 */     GIR_EraseRootFromParent_Done,
     /*  763047 */   // Label 11896: @763047
     /*  763047 */   GIM_Try, /*On fail goto*//*Label 11897*/ GIMT_Encode4(763125), // Rule ID 14209 //
     /*  763052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  763063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  763066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  763069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  763072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763098 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763123 */     GIR_RootConstrainSelectedInstOperands,
     /*  763124 */     // GIR_Coverage, 14209,
     /*  763124 */     GIR_EraseRootFromParent_Done,
     /*  763125 */   // Label 11897: @763125
     /*  763125 */   GIM_Try, /*On fail goto*//*Label 11898*/ GIMT_Encode4(763203), // Rule ID 14212 //
     /*  763130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763201 */     GIR_RootConstrainSelectedInstOperands,
     /*  763202 */     // GIR_Coverage, 14212,
     /*  763202 */     GIR_EraseRootFromParent_Done,
     /*  763203 */   // Label 11898: @763203
     /*  763203 */   GIM_Try, /*On fail goto*//*Label 11899*/ GIMT_Encode4(763281), // Rule ID 14213 //
     /*  763208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  763219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  763222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  763225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  763228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763254 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /*  763257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763279 */     GIR_RootConstrainSelectedInstOperands,
     /*  763280 */     // GIR_Coverage, 14213,
     /*  763280 */     GIR_EraseRootFromParent_Done,
     /*  763281 */   // Label 11899: @763281
     /*  763281 */   GIM_Try, /*On fail goto*//*Label 11900*/ GIMT_Encode4(763359), // Rule ID 14216 //
     /*  763286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763332 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763357 */     GIR_RootConstrainSelectedInstOperands,
     /*  763358 */     // GIR_Coverage, 14216,
     /*  763358 */     GIR_EraseRootFromParent_Done,
     /*  763359 */   // Label 11900: @763359
     /*  763359 */   GIM_Try, /*On fail goto*//*Label 11901*/ GIMT_Encode4(763437), // Rule ID 14217 //
     /*  763364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  763375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  763378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  763381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  763384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763410 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763435 */     GIR_RootConstrainSelectedInstOperands,
     /*  763436 */     // GIR_Coverage, 14217,
     /*  763436 */     GIR_EraseRootFromParent_Done,
     /*  763437 */   // Label 11901: @763437
     /*  763437 */   GIM_Try, /*On fail goto*//*Label 11902*/ GIMT_Encode4(763515), // Rule ID 14220 //
     /*  763442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  763453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  763456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  763459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  763462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763488 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763513 */     GIR_RootConstrainSelectedInstOperands,
     /*  763514 */     // GIR_Coverage, 14220,
     /*  763514 */     GIR_EraseRootFromParent_Done,
     /*  763515 */   // Label 11902: @763515
     /*  763515 */   GIM_Try, /*On fail goto*//*Label 11903*/ GIMT_Encode4(763593), // Rule ID 14221 //
     /*  763520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  763531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  763534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  763537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  763540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  763566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /*  763569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763591 */     GIR_RootConstrainSelectedInstOperands,
     /*  763592 */     // GIR_Coverage, 14221,
     /*  763592 */     GIR_EraseRootFromParent_Done,
     /*  763593 */   // Label 11903: @763593
     /*  763593 */   GIM_Try, /*On fail goto*//*Label 11904*/ GIMT_Encode4(763671), // Rule ID 14224 //
     /*  763598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  763609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  763612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  763615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  763618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  763644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  763647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763669 */     GIR_RootConstrainSelectedInstOperands,
     /*  763670 */     // GIR_Coverage, 14224,
     /*  763670 */     GIR_EraseRootFromParent_Done,
     /*  763671 */   // Label 11904: @763671
     /*  763671 */   GIM_Try, /*On fail goto*//*Label 11905*/ GIMT_Encode4(763749), // Rule ID 14225 //
     /*  763676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  763687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  763690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  763693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  763696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763722 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  763722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  763725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  763741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763744 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763747 */     GIR_RootConstrainSelectedInstOperands,
     /*  763748 */     // GIR_Coverage, 14225,
     /*  763748 */     GIR_EraseRootFromParent_Done,
     /*  763749 */   // Label 11905: @763749
     /*  763749 */   GIM_Try, /*On fail goto*//*Label 11906*/ GIMT_Encode4(763827), // Rule ID 14228 //
     /*  763754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  763765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  763768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  763771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  763774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  763800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  763803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763822 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763825 */     GIR_RootConstrainSelectedInstOperands,
     /*  763826 */     // GIR_Coverage, 14228,
     /*  763826 */     GIR_EraseRootFromParent_Done,
     /*  763827 */   // Label 11906: @763827
     /*  763827 */   GIM_Try, /*On fail goto*//*Label 11907*/ GIMT_Encode4(763905), // Rule ID 14229 //
     /*  763832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  763843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  763846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  763849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  763852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  763855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763878 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  763878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  763881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  763897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763903 */     GIR_RootConstrainSelectedInstOperands,
     /*  763904 */     // GIR_Coverage, 14229,
     /*  763904 */     GIR_EraseRootFromParent_Done,
     /*  763905 */   // Label 11907: @763905
     /*  763905 */   GIM_Try, /*On fail goto*//*Label 11908*/ GIMT_Encode4(763983), // Rule ID 14232 //
     /*  763910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  763913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  763921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  763924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  763927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  763930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  763933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  763949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  763956 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  763956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  763959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  763961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  763963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  763965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  763967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  763972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  763975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  763978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  763981 */     GIR_RootConstrainSelectedInstOperands,
     /*  763982 */     // GIR_Coverage, 14232,
     /*  763982 */     GIR_EraseRootFromParent_Done,
     /*  763983 */   // Label 11908: @763983
     /*  763983 */   GIM_Try, /*On fail goto*//*Label 11909*/ GIMT_Encode4(764061), // Rule ID 14233 //
     /*  763988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  763991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  763996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  763999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  764002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  764005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  764008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764034 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  764034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  764053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764059 */     GIR_RootConstrainSelectedInstOperands,
     /*  764060 */     // GIR_Coverage, 14233,
     /*  764060 */     GIR_EraseRootFromParent_Done,
     /*  764061 */   // Label 11909: @764061
     /*  764061 */   GIM_Try, /*On fail goto*//*Label 11910*/ GIMT_Encode4(764139), // Rule ID 14236 //
     /*  764066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  764069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  764112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764137 */     GIR_RootConstrainSelectedInstOperands,
     /*  764138 */     // GIR_Coverage, 14236,
     /*  764138 */     GIR_EraseRootFromParent_Done,
     /*  764139 */   // Label 11910: @764139
     /*  764139 */   GIM_Try, /*On fail goto*//*Label 11911*/ GIMT_Encode4(764217), // Rule ID 14237 //
     /*  764144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  764147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  764155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  764158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  764161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  764164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  764183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764190 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  764190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /*  764193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  764209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764215 */     GIR_RootConstrainSelectedInstOperands,
     /*  764216 */     // GIR_Coverage, 14237,
     /*  764216 */     GIR_EraseRootFromParent_Done,
     /*  764217 */   // Label 11911: @764217
     /*  764217 */   GIM_Try, /*On fail goto*//*Label 11912*/ GIMT_Encode4(764295), // Rule ID 14240 //
     /*  764222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764293 */     GIR_RootConstrainSelectedInstOperands,
     /*  764294 */     // GIR_Coverage, 14240,
     /*  764294 */     GIR_EraseRootFromParent_Done,
     /*  764295 */   // Label 11912: @764295
     /*  764295 */   GIM_Try, /*On fail goto*//*Label 11913*/ GIMT_Encode4(764373), // Rule ID 14241 //
     /*  764300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  764311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  764314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  764317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  764320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764371 */     GIR_RootConstrainSelectedInstOperands,
     /*  764372 */     // GIR_Coverage, 14241,
     /*  764372 */     GIR_EraseRootFromParent_Done,
     /*  764373 */   // Label 11913: @764373
     /*  764373 */   GIM_Try, /*On fail goto*//*Label 11914*/ GIMT_Encode4(764451), // Rule ID 14244 //
     /*  764378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764424 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764449 */     GIR_RootConstrainSelectedInstOperands,
     /*  764450 */     // GIR_Coverage, 14244,
     /*  764450 */     GIR_EraseRootFromParent_Done,
     /*  764451 */   // Label 11914: @764451
     /*  764451 */   GIM_Try, /*On fail goto*//*Label 11915*/ GIMT_Encode4(764529), // Rule ID 14245 //
     /*  764456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  764467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  764470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  764473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  764476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764527 */     GIR_RootConstrainSelectedInstOperands,
     /*  764528 */     // GIR_Coverage, 14245,
     /*  764528 */     GIR_EraseRootFromParent_Done,
     /*  764529 */   // Label 11915: @764529
     /*  764529 */   GIM_Try, /*On fail goto*//*Label 11916*/ GIMT_Encode4(764607), // Rule ID 14248 //
     /*  764534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  764545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  764548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  764551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  764554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764580 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  764580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  764583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764605 */     GIR_RootConstrainSelectedInstOperands,
     /*  764606 */     // GIR_Coverage, 14248,
     /*  764606 */     GIR_EraseRootFromParent_Done,
     /*  764607 */   // Label 11916: @764607
     /*  764607 */   GIM_Try, /*On fail goto*//*Label 11917*/ GIMT_Encode4(764685), // Rule ID 14249 //
     /*  764612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  764623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  764626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  764629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  764632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  764651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764658 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  764658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  764661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  764677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764683 */     GIR_RootConstrainSelectedInstOperands,
     /*  764684 */     // GIR_Coverage, 14249,
     /*  764684 */     GIR_EraseRootFromParent_Done,
     /*  764685 */   // Label 11917: @764685
     /*  764685 */   GIM_Try, /*On fail goto*//*Label 11918*/ GIMT_Encode4(764763), // Rule ID 14252 //
     /*  764690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  764701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  764704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  764707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  764710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764761 */     GIR_RootConstrainSelectedInstOperands,
     /*  764762 */     // GIR_Coverage, 14252,
     /*  764762 */     GIR_EraseRootFromParent_Done,
     /*  764763 */   // Label 11918: @764763
     /*  764763 */   GIM_Try, /*On fail goto*//*Label 11919*/ GIMT_Encode4(764841), // Rule ID 14253 //
     /*  764768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  764779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  764782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  764785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  764788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  764807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  764817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764839 */     GIR_RootConstrainSelectedInstOperands,
     /*  764840 */     // GIR_Coverage, 14253,
     /*  764840 */     GIR_EraseRootFromParent_Done,
     /*  764841 */   // Label 11919: @764841
     /*  764841 */   GIM_Try, /*On fail goto*//*Label 11920*/ GIMT_Encode4(764919), // Rule ID 14256 //
     /*  764846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  764849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  764857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  764860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  764863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  764866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  764869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  764892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764917 */     GIR_RootConstrainSelectedInstOperands,
     /*  764918 */     // GIR_Coverage, 14256,
     /*  764918 */     GIR_EraseRootFromParent_Done,
     /*  764919 */   // Label 11920: @764919
     /*  764919 */   GIM_Try, /*On fail goto*//*Label 11921*/ GIMT_Encode4(764997), // Rule ID 14257 //
     /*  764924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  764927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  764932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  764935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  764938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  764941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  764944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  764947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  764963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  764970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  764970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  764973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  764975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  764977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  764979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  764981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  764986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  764989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  764992 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  764995 */     GIR_RootConstrainSelectedInstOperands,
     /*  764996 */     // GIR_Coverage, 14257,
     /*  764996 */     GIR_EraseRootFromParent_Done,
     /*  764997 */   // Label 11921: @764997
     /*  764997 */   GIM_Try, /*On fail goto*//*Label 11922*/ GIMT_Encode4(765075), // Rule ID 14260 //
     /*  765002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765048 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  765048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765070 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765073 */     GIR_RootConstrainSelectedInstOperands,
     /*  765074 */     // GIR_Coverage, 14260,
     /*  765074 */     GIR_EraseRootFromParent_Done,
     /*  765075 */   // Label 11922: @765075
     /*  765075 */   GIM_Try, /*On fail goto*//*Label 11923*/ GIMT_Encode4(765153), // Rule ID 14261 //
     /*  765080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  765091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  765094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  765097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  765100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  765126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  765145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765148 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765151 */     GIR_RootConstrainSelectedInstOperands,
     /*  765152 */     // GIR_Coverage, 14261,
     /*  765152 */     GIR_EraseRootFromParent_Done,
     /*  765153 */   // Label 11923: @765153
     /*  765153 */   GIM_Try, /*On fail goto*//*Label 11924*/ GIMT_Encode4(765231), // Rule ID 14264 //
     /*  765158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765226 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765229 */     GIR_RootConstrainSelectedInstOperands,
     /*  765230 */     // GIR_Coverage, 14264,
     /*  765230 */     GIR_EraseRootFromParent_Done,
     /*  765231 */   // Label 11924: @765231
     /*  765231 */   GIM_Try, /*On fail goto*//*Label 11925*/ GIMT_Encode4(765309), // Rule ID 14265 //
     /*  765236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  765247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  765250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  765253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  765256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765282 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765307 */     GIR_RootConstrainSelectedInstOperands,
     /*  765308 */     // GIR_Coverage, 14265,
     /*  765308 */     GIR_EraseRootFromParent_Done,
     /*  765309 */   // Label 11925: @765309
     /*  765309 */   GIM_Try, /*On fail goto*//*Label 11926*/ GIMT_Encode4(765387), // Rule ID 14268 //
     /*  765314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765385 */     GIR_RootConstrainSelectedInstOperands,
     /*  765386 */     // GIR_Coverage, 14268,
     /*  765386 */     GIR_EraseRootFromParent_Done,
     /*  765387 */   // Label 11926: @765387
     /*  765387 */   GIM_Try, /*On fail goto*//*Label 11927*/ GIMT_Encode4(765465), // Rule ID 14269 //
     /*  765392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  765403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  765406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  765409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  765412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765438 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765463 */     GIR_RootConstrainSelectedInstOperands,
     /*  765464 */     // GIR_Coverage, 14269,
     /*  765464 */     GIR_EraseRootFromParent_Done,
     /*  765465 */   // Label 11927: @765465
     /*  765465 */   GIM_Try, /*On fail goto*//*Label 11928*/ GIMT_Encode4(765543), // Rule ID 14272 //
     /*  765470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  765473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  765481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  765484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  765487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  765490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  765516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765541 */     GIR_RootConstrainSelectedInstOperands,
     /*  765542 */     // GIR_Coverage, 14272,
     /*  765542 */     GIR_EraseRootFromParent_Done,
     /*  765543 */   // Label 11928: @765543
     /*  765543 */   GIM_Try, /*On fail goto*//*Label 11929*/ GIMT_Encode4(765621), // Rule ID 14273 //
     /*  765548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  765551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  765559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  765562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  765565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  765568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765594 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  765594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  765613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765619 */     GIR_RootConstrainSelectedInstOperands,
     /*  765620 */     // GIR_Coverage, 14273,
     /*  765620 */     GIR_EraseRootFromParent_Done,
     /*  765621 */   // Label 11929: @765621
     /*  765621 */   GIM_Try, /*On fail goto*//*Label 11930*/ GIMT_Encode4(765699), // Rule ID 14276 //
     /*  765626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  765637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  765640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  765643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  765646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765697 */     GIR_RootConstrainSelectedInstOperands,
     /*  765698 */     // GIR_Coverage, 14276,
     /*  765698 */     GIR_EraseRootFromParent_Done,
     /*  765699 */   // Label 11930: @765699
     /*  765699 */   GIM_Try, /*On fail goto*//*Label 11931*/ GIMT_Encode4(765777), // Rule ID 14277 //
     /*  765704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  765715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  765718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  765721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  765724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  765743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765750 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /*  765753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765772 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765775 */     GIR_RootConstrainSelectedInstOperands,
     /*  765776 */     // GIR_Coverage, 14277,
     /*  765776 */     GIR_EraseRootFromParent_Done,
     /*  765777 */   // Label 11931: @765777
     /*  765777 */   GIM_Try, /*On fail goto*//*Label 11932*/ GIMT_Encode4(765855), // Rule ID 14280 //
     /*  765782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  765793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  765796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  765799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  765802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765828 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765850 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765853 */     GIR_RootConstrainSelectedInstOperands,
     /*  765854 */     // GIR_Coverage, 14280,
     /*  765854 */     GIR_EraseRootFromParent_Done,
     /*  765855 */   // Label 11932: @765855
     /*  765855 */   GIM_Try, /*On fail goto*//*Label 11933*/ GIMT_Encode4(765933), // Rule ID 14281 //
     /*  765860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  765863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  765871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  765874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  765877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  765880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  765883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  765899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  765906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /*  765909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  765922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  765925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  765928 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  765931 */     GIR_RootConstrainSelectedInstOperands,
     /*  765932 */     // GIR_Coverage, 14281,
     /*  765932 */     GIR_EraseRootFromParent_Done,
     /*  765933 */   // Label 11933: @765933
     /*  765933 */   GIM_Try, /*On fail goto*//*Label 11934*/ GIMT_Encode4(766011), // Rule ID 14284 //
     /*  765938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  765941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  765946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  765949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  765952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  765955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  765958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  765961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  765977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  765984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  765984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  765987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  765989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  765991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  765993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  765995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766009 */     GIR_RootConstrainSelectedInstOperands,
     /*  766010 */     // GIR_Coverage, 14284,
     /*  766010 */     GIR_EraseRootFromParent_Done,
     /*  766011 */   // Label 11934: @766011
     /*  766011 */   GIM_Try, /*On fail goto*//*Label 11935*/ GIMT_Encode4(766089), // Rule ID 14285 //
     /*  766016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  766019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  766027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  766030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  766033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  766036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  766055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766062 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  766062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /*  766065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  766081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766087 */     GIR_RootConstrainSelectedInstOperands,
     /*  766088 */     // GIR_Coverage, 14285,
     /*  766088 */     GIR_EraseRootFromParent_Done,
     /*  766089 */   // Label 11935: @766089
     /*  766089 */   GIM_Try, /*On fail goto*//*Label 11936*/ GIMT_Encode4(766167), // Rule ID 14288 //
     /*  766094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766165 */     GIR_RootConstrainSelectedInstOperands,
     /*  766166 */     // GIR_Coverage, 14288,
     /*  766166 */     GIR_EraseRootFromParent_Done,
     /*  766167 */   // Label 11936: @766167
     /*  766167 */   GIM_Try, /*On fail goto*//*Label 11937*/ GIMT_Encode4(766245), // Rule ID 14289 //
     /*  766172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  766183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  766186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  766189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766218 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8),
     /*  766221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766243 */     GIR_RootConstrainSelectedInstOperands,
     /*  766244 */     // GIR_Coverage, 14289,
     /*  766244 */     GIR_EraseRootFromParent_Done,
     /*  766245 */   // Label 11937: @766245
     /*  766245 */   GIM_Try, /*On fail goto*//*Label 11938*/ GIMT_Encode4(766323), // Rule ID 14292 //
     /*  766250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766296 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766321 */     GIR_RootConstrainSelectedInstOperands,
     /*  766322 */     // GIR_Coverage, 14292,
     /*  766322 */     GIR_EraseRootFromParent_Done,
     /*  766323 */   // Label 11938: @766323
     /*  766323 */   GIM_Try, /*On fail goto*//*Label 11939*/ GIMT_Encode4(766401), // Rule ID 14293 //
     /*  766328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  766339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  766342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  766345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766374 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766399 */     GIR_RootConstrainSelectedInstOperands,
     /*  766400 */     // GIR_Coverage, 14293,
     /*  766400 */     GIR_EraseRootFromParent_Done,
     /*  766401 */   // Label 11939: @766401
     /*  766401 */   GIM_Try, /*On fail goto*//*Label 11940*/ GIMT_Encode4(766479), // Rule ID 14296 //
     /*  766406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  766417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  766420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  766423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  766452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766474 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766477 */     GIR_RootConstrainSelectedInstOperands,
     /*  766478 */     // GIR_Coverage, 14296,
     /*  766478 */     GIR_EraseRootFromParent_Done,
     /*  766479 */   // Label 11940: @766479
     /*  766479 */   GIM_Try, /*On fail goto*//*Label 11941*/ GIMT_Encode4(766557), // Rule ID 14297 //
     /*  766484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  766495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  766498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  766501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  766530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  766549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766555 */     GIR_RootConstrainSelectedInstOperands,
     /*  766556 */     // GIR_Coverage, 14297,
     /*  766556 */     GIR_EraseRootFromParent_Done,
     /*  766557 */   // Label 11941: @766557
     /*  766557 */   GIM_Try, /*On fail goto*//*Label 11942*/ GIMT_Encode4(766635), // Rule ID 14300 //
     /*  766562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  766573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  766576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  766579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766630 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766633 */     GIR_RootConstrainSelectedInstOperands,
     /*  766634 */     // GIR_Coverage, 14300,
     /*  766634 */     GIR_EraseRootFromParent_Done,
     /*  766635 */   // Label 11942: @766635
     /*  766635 */   GIM_Try, /*On fail goto*//*Label 11943*/ GIMT_Encode4(766713), // Rule ID 14301 //
     /*  766640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  766651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  766654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  766657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4),
     /*  766689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766708 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766711 */     GIR_RootConstrainSelectedInstOperands,
     /*  766712 */     // GIR_Coverage, 14301,
     /*  766712 */     GIR_EraseRootFromParent_Done,
     /*  766713 */   // Label 11943: @766713
     /*  766713 */   GIM_Try, /*On fail goto*//*Label 11944*/ GIMT_Encode4(766791), // Rule ID 14304 //
     /*  766718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  766729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  766732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  766735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  766764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766789 */     GIR_RootConstrainSelectedInstOperands,
     /*  766790 */     // GIR_Coverage, 14304,
     /*  766790 */     GIR_EraseRootFromParent_Done,
     /*  766791 */   // Label 11944: @766791
     /*  766791 */   GIM_Try, /*On fail goto*//*Label 11945*/ GIMT_Encode4(766869), // Rule ID 14305 //
     /*  766796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  766807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  766810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  766813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  766842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  766861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766867 */     GIR_RootConstrainSelectedInstOperands,
     /*  766868 */     // GIR_Coverage, 14305,
     /*  766868 */     GIR_EraseRootFromParent_Done,
     /*  766869 */   // Label 11945: @766869
     /*  766869 */   GIM_Try, /*On fail goto*//*Label 11946*/ GIMT_Encode4(766947), // Rule ID 14308 //
     /*  766874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  766877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  766885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  766888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  766891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  766894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  766897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  766920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  766923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  766925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  766927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  766929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  766931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  766936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  766939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  766942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  766945 */     GIR_RootConstrainSelectedInstOperands,
     /*  766946 */     // GIR_Coverage, 14308,
     /*  766946 */     GIR_EraseRootFromParent_Done,
     /*  766947 */   // Label 11946: @766947
     /*  766947 */   GIM_Try, /*On fail goto*//*Label 11947*/ GIMT_Encode4(767025), // Rule ID 14309 //
     /*  766952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  766955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  766960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  766963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  766966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  766969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  766972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  766975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  766987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  766991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  766998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  766998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2),
     /*  767001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767023 */     GIR_RootConstrainSelectedInstOperands,
     /*  767024 */     // GIR_Coverage, 14309,
     /*  767024 */     GIR_EraseRootFromParent_Done,
     /*  767025 */   // Label 11947: @767025
     /*  767025 */   GIM_Try, /*On fail goto*//*Label 11948*/ GIMT_Encode4(767103), // Rule ID 14312 //
     /*  767030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767076 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767101 */     GIR_RootConstrainSelectedInstOperands,
     /*  767102 */     // GIR_Coverage, 14312,
     /*  767102 */     GIR_EraseRootFromParent_Done,
     /*  767103 */   // Label 11948: @767103
     /*  767103 */   GIM_Try, /*On fail goto*//*Label 11949*/ GIMT_Encode4(767181), // Rule ID 14313 //
     /*  767108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  767119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  767122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  767125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767154 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11462:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767179 */     GIR_RootConstrainSelectedInstOperands,
     /*  767180 */     // GIR_Coverage, 14313,
     /*  767180 */     GIR_EraseRootFromParent_Done,
     /*  767181 */   // Label 11949: @767181
     /*  767181 */   GIM_Try, /*On fail goto*//*Label 11950*/ GIMT_Encode4(767259), // Rule ID 14316 //
     /*  767186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  767232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767257 */     GIR_RootConstrainSelectedInstOperands,
     /*  767258 */     // GIR_Coverage, 14316,
     /*  767258 */     GIR_EraseRootFromParent_Done,
     /*  767259 */   // Label 11950: @767259
     /*  767259 */   GIM_Try, /*On fail goto*//*Label 11951*/ GIMT_Encode4(767337), // Rule ID 14317 //
     /*  767264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  767275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  767278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  767281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11462:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  767310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  767329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767332 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767335 */     GIR_RootConstrainSelectedInstOperands,
     /*  767336 */     // GIR_Coverage, 14317,
     /*  767336 */     GIR_EraseRootFromParent_Done,
     /*  767337 */   // Label 11951: @767337
     /*  767337 */   GIM_Try, /*On fail goto*//*Label 11952*/ GIMT_Encode4(767415), // Rule ID 14320 //
     /*  767342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  767388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767413 */     GIR_RootConstrainSelectedInstOperands,
     /*  767414 */     // GIR_Coverage, 14320,
     /*  767414 */     GIR_EraseRootFromParent_Done,
     /*  767415 */   // Label 11952: @767415
     /*  767415 */   GIM_Try, /*On fail goto*//*Label 11953*/ GIMT_Encode4(767493), // Rule ID 14321 //
     /*  767420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  767431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  767434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  767437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11462:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  767466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  767485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767488 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767491 */     GIR_RootConstrainSelectedInstOperands,
     /*  767492 */     // GIR_Coverage, 14321,
     /*  767492 */     GIR_EraseRootFromParent_Done,
     /*  767493 */   // Label 11953: @767493
     /*  767493 */   GIM_Try, /*On fail goto*//*Label 11954*/ GIMT_Encode4(767571), // Rule ID 14324 //
     /*  767498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  767501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  767509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  767512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  767515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  767544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767566 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767569 */     GIR_RootConstrainSelectedInstOperands,
     /*  767570 */     // GIR_Coverage, 14324,
     /*  767570 */     GIR_EraseRootFromParent_Done,
     /*  767571 */   // Label 11954: @767571
     /*  767571 */   GIM_Try, /*On fail goto*//*Label 11955*/ GIMT_Encode4(767649), // Rule ID 14325 //
     /*  767576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  767579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  767587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  767590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  767593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  767611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767622 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11462:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  767622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1),
     /*  767625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  767641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767647 */     GIR_RootConstrainSelectedInstOperands,
     /*  767648 */     // GIR_Coverage, 14325,
     /*  767648 */     GIR_EraseRootFromParent_Done,
     /*  767649 */   // Label 11955: @767649
     /*  767649 */   GIM_Try, /*On fail goto*//*Label 11956*/ GIMT_Encode4(767727), // Rule ID 14328 //
     /*  767654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  767665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  767668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  767671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767700 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  767703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767725 */     GIR_RootConstrainSelectedInstOperands,
     /*  767726 */     // GIR_Coverage, 14328,
     /*  767726 */     GIR_EraseRootFromParent_Done,
     /*  767727 */   // Label 11956: @767727
     /*  767727 */   GIM_Try, /*On fail goto*//*Label 11957*/ GIMT_Encode4(767805), // Rule ID 14329 //
     /*  767732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  767743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  767746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  767749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  767767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  767781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767803 */     GIR_RootConstrainSelectedInstOperands,
     /*  767804 */     // GIR_Coverage, 14329,
     /*  767804 */     GIR_EraseRootFromParent_Done,
     /*  767805 */   // Label 11957: @767805
     /*  767805 */   GIM_Try, /*On fail goto*//*Label 11958*/ GIMT_Encode4(767883), // Rule ID 14332 //
     /*  767810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  767821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  767824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  767827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767856 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  767856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  767859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767881 */     GIR_RootConstrainSelectedInstOperands,
     /*  767882 */     // GIR_Coverage, 14332,
     /*  767882 */     GIR_EraseRootFromParent_Done,
     /*  767883 */   // Label 11958: @767883
     /*  767883 */   GIM_Try, /*On fail goto*//*Label 11959*/ GIMT_Encode4(767961), // Rule ID 14333 //
     /*  767888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  767891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  767899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  767902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  767905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  767908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  767911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  767923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  767927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  767934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  767934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  767937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  767939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  767941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  767943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  767945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  767950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  767953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  767956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  767959 */     GIR_RootConstrainSelectedInstOperands,
     /*  767960 */     // GIR_Coverage, 14333,
     /*  767960 */     GIR_EraseRootFromParent_Done,
     /*  767961 */   // Label 11959: @767961
     /*  767961 */   GIM_Try, /*On fail goto*//*Label 11960*/ GIMT_Encode4(768039), // Rule ID 14336 //
     /*  767966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  767969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  767974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  767977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  767980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  767983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  767986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  767989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  767997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  768012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768037 */     GIR_RootConstrainSelectedInstOperands,
     /*  768038 */     // GIR_Coverage, 14336,
     /*  768038 */     GIR_EraseRootFromParent_Done,
     /*  768039 */   // Label 11960: @768039
     /*  768039 */   GIM_Try, /*On fail goto*//*Label 11961*/ GIMT_Encode4(768117), // Rule ID 14337 //
     /*  768044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  768055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  768058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  768061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768090 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  768090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  768109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768112 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768115 */     GIR_RootConstrainSelectedInstOperands,
     /*  768116 */     // GIR_Coverage, 14337,
     /*  768116 */     GIR_EraseRootFromParent_Done,
     /*  768117 */   // Label 11961: @768117
     /*  768117 */   GIM_Try, /*On fail goto*//*Label 11962*/ GIMT_Encode4(768195), // Rule ID 14340 //
     /*  768122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768193 */     GIR_RootConstrainSelectedInstOperands,
     /*  768194 */     // GIR_Coverage, 14340,
     /*  768194 */     GIR_EraseRootFromParent_Done,
     /*  768195 */   // Label 11962: @768195
     /*  768195 */   GIM_Try, /*On fail goto*//*Label 11963*/ GIMT_Encode4(768273), // Rule ID 14341 //
     /*  768200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  768211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  768214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  768217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768268 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768271 */     GIR_RootConstrainSelectedInstOperands,
     /*  768272 */     // GIR_Coverage, 14341,
     /*  768272 */     GIR_EraseRootFromParent_Done,
     /*  768273 */   // Label 11963: @768273
     /*  768273 */   GIM_Try, /*On fail goto*//*Label 11964*/ GIMT_Encode4(768351), // Rule ID 14344 //
     /*  768278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768324 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768349 */     GIR_RootConstrainSelectedInstOperands,
     /*  768350 */     // GIR_Coverage, 14344,
     /*  768350 */     GIR_EraseRootFromParent_Done,
     /*  768351 */   // Label 11964: @768351
     /*  768351 */   GIM_Try, /*On fail goto*//*Label 11965*/ GIMT_Encode4(768429), // Rule ID 14345 //
     /*  768356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  768367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  768370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  768373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768402 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768424 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768427 */     GIR_RootConstrainSelectedInstOperands,
     /*  768428 */     // GIR_Coverage, 14345,
     /*  768428 */     GIR_EraseRootFromParent_Done,
     /*  768429 */   // Label 11965: @768429
     /*  768429 */   GIM_Try, /*On fail goto*//*Label 11966*/ GIMT_Encode4(768507), // Rule ID 14348 //
     /*  768434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  768445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  768448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  768451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  768480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768505 */     GIR_RootConstrainSelectedInstOperands,
     /*  768506 */     // GIR_Coverage, 14348,
     /*  768506 */     GIR_EraseRootFromParent_Done,
     /*  768507 */   // Label 11966: @768507
     /*  768507 */   GIM_Try, /*On fail goto*//*Label 11967*/ GIMT_Encode4(768585), // Rule ID 14349 //
     /*  768512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  768523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  768526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  768529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  768558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  768577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768583 */     GIR_RootConstrainSelectedInstOperands,
     /*  768584 */     // GIR_Coverage, 14349,
     /*  768584 */     GIR_EraseRootFromParent_Done,
     /*  768585 */   // Label 11967: @768585
     /*  768585 */   GIM_Try, /*On fail goto*//*Label 11968*/ GIMT_Encode4(768663), // Rule ID 14352 //
     /*  768590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  768601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  768604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  768607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768661 */     GIR_RootConstrainSelectedInstOperands,
     /*  768662 */     // GIR_Coverage, 14352,
     /*  768662 */     GIR_EraseRootFromParent_Done,
     /*  768663 */   // Label 11968: @768663
     /*  768663 */   GIM_Try, /*On fail goto*//*Label 11969*/ GIMT_Encode4(768741), // Rule ID 14353 //
     /*  768668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  768679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  768682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  768685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  768703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768714 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  768717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768736 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768739 */     GIR_RootConstrainSelectedInstOperands,
     /*  768740 */     // GIR_Coverage, 14353,
     /*  768740 */     GIR_EraseRootFromParent_Done,
     /*  768741 */   // Label 11969: @768741
     /*  768741 */   GIM_Try, /*On fail goto*//*Label 11970*/ GIMT_Encode4(768819), // Rule ID 14356 //
     /*  768746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  768757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  768760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  768763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768792 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768814 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768817 */     GIR_RootConstrainSelectedInstOperands,
     /*  768818 */     // GIR_Coverage, 14356,
     /*  768818 */     GIR_EraseRootFromParent_Done,
     /*  768819 */   // Label 11970: @768819
     /*  768819 */   GIM_Try, /*On fail goto*//*Label 11971*/ GIMT_Encode4(768897), // Rule ID 14357 //
     /*  768824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  768835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  768838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  768841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  768844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  768847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  768859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768870 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  768870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  768873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768895 */     GIR_RootConstrainSelectedInstOperands,
     /*  768896 */     // GIR_Coverage, 14357,
     /*  768896 */     GIR_EraseRootFromParent_Done,
     /*  768897 */   // Label 11971: @768897
     /*  768897 */   GIM_Try, /*On fail goto*//*Label 11972*/ GIMT_Encode4(768975), // Rule ID 14360 //
     /*  768902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  768905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  768913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  768916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  768919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  768922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  768925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  768937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  768941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  768948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  768948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  768951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  768953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  768955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  768957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  768959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  768964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  768967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  768970 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  768973 */     GIR_RootConstrainSelectedInstOperands,
     /*  768974 */     // GIR_Coverage, 14360,
     /*  768974 */     GIR_EraseRootFromParent_Done,
     /*  768975 */   // Label 11972: @768975
     /*  768975 */   GIM_Try, /*On fail goto*//*Label 11973*/ GIMT_Encode4(769053), // Rule ID 14361 //
     /*  768980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  768983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  768988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  768991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  768994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  768997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  769026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  769045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769048 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769051 */     GIR_RootConstrainSelectedInstOperands,
     /*  769052 */     // GIR_Coverage, 14361,
     /*  769052 */     GIR_EraseRootFromParent_Done,
     /*  769053 */   // Label 11973: @769053
     /*  769053 */   GIM_Try, /*On fail goto*//*Label 11974*/ GIMT_Encode4(769131), // Rule ID 14364 //
     /*  769058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769129 */     GIR_RootConstrainSelectedInstOperands,
     /*  769130 */     // GIR_Coverage, 14364,
     /*  769130 */     GIR_EraseRootFromParent_Done,
     /*  769131 */   // Label 11974: @769131
     /*  769131 */   GIM_Try, /*On fail goto*//*Label 11975*/ GIMT_Encode4(769209), // Rule ID 14365 //
     /*  769136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  769147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  769150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  769153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  769171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769182 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11462:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2),
     /*  769185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769207 */     GIR_RootConstrainSelectedInstOperands,
     /*  769208 */     // GIR_Coverage, 14365,
     /*  769208 */     GIR_EraseRootFromParent_Done,
     /*  769209 */   // Label 11975: @769209
     /*  769209 */   GIM_Try, /*On fail goto*//*Label 11976*/ GIMT_Encode4(769287), // Rule ID 14368 //
     /*  769214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769285 */     GIR_RootConstrainSelectedInstOperands,
     /*  769286 */     // GIR_Coverage, 14368,
     /*  769286 */     GIR_EraseRootFromParent_Done,
     /*  769287 */   // Label 11976: @769287
     /*  769287 */   GIM_Try, /*On fail goto*//*Label 11977*/ GIMT_Encode4(769365), // Rule ID 14369 //
     /*  769292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  769303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  769306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  769309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  769327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11462:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4),
     /*  769341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769363 */     GIR_RootConstrainSelectedInstOperands,
     /*  769364 */     // GIR_Coverage, 14369,
     /*  769364 */     GIR_EraseRootFromParent_Done,
     /*  769365 */   // Label 11977: @769365
     /*  769365 */   GIM_Try, /*On fail goto*//*Label 11978*/ GIMT_Encode4(769443), // Rule ID 14372 //
     /*  769370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  769373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  769390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  769416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769441 */     GIR_RootConstrainSelectedInstOperands,
     /*  769442 */     // GIR_Coverage, 14372,
     /*  769442 */     GIR_EraseRootFromParent_Done,
     /*  769443 */   // Label 11978: @769443
     /*  769443 */   GIM_Try, /*On fail goto*//*Label 11979*/ GIMT_Encode4(769521), // Rule ID 14373 //
     /*  769448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  769451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd),
     /*  769456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  769459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  769462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  769465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  769468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  769483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  769487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769494 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11462:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  769494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8),
     /*  769497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  769513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769519 */     GIR_RootConstrainSelectedInstOperands,
     /*  769520 */     // GIR_Coverage, 14373,
     /*  769520 */     GIR_EraseRootFromParent_Done,
     /*  769521 */   // Label 11979: @769521
     /*  769521 */   GIM_Try, /*On fail goto*//*Label 11980*/ GIMT_Encode4(769599), // Rule ID 14464 //
     /*  769526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  769537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  769540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  769543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  769546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769572 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  769572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  769575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769597 */     GIR_RootConstrainSelectedInstOperands,
     /*  769598 */     // GIR_Coverage, 14464,
     /*  769598 */     GIR_EraseRootFromParent_Done,
     /*  769599 */   // Label 11980: @769599
     /*  769599 */   GIM_Try, /*On fail goto*//*Label 11981*/ GIMT_Encode4(769677), // Rule ID 14465 //
     /*  769604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  769615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  769618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  769621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  769624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /*  769653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769675 */     GIR_RootConstrainSelectedInstOperands,
     /*  769676 */     // GIR_Coverage, 14465,
     /*  769676 */     GIR_EraseRootFromParent_Done,
     /*  769677 */   // Label 11981: @769677
     /*  769677 */   GIM_Try, /*On fail goto*//*Label 11982*/ GIMT_Encode4(769755), // Rule ID 14468 //
     /*  769682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  769693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  769696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  769699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  769702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769728 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  769728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  769731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769750 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769753 */     GIR_RootConstrainSelectedInstOperands,
     /*  769754 */     // GIR_Coverage, 14468,
     /*  769754 */     GIR_EraseRootFromParent_Done,
     /*  769755 */   // Label 11982: @769755
     /*  769755 */   GIM_Try, /*On fail goto*//*Label 11983*/ GIMT_Encode4(769833), // Rule ID 14469 //
     /*  769760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  769771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  769774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  769777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  769780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769806 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  769809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769831 */     GIR_RootConstrainSelectedInstOperands,
     /*  769832 */     // GIR_Coverage, 14469,
     /*  769832 */     GIR_EraseRootFromParent_Done,
     /*  769833 */   // Label 11983: @769833
     /*  769833 */   GIM_Try, /*On fail goto*//*Label 11984*/ GIMT_Encode4(769911), // Rule ID 14472 //
     /*  769838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  769849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  769852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  769855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  769858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  769861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  769884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  769887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769906 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769909 */     GIR_RootConstrainSelectedInstOperands,
     /*  769910 */     // GIR_Coverage, 14472,
     /*  769910 */     GIR_EraseRootFromParent_Done,
     /*  769911 */   // Label 11984: @769911
     /*  769911 */   GIM_Try, /*On fail goto*//*Label 11985*/ GIMT_Encode4(769989), // Rule ID 14473 //
     /*  769916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  769919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  769924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  769927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  769930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  769933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  769936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  769939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  769955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  769962 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  769962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  769965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  769967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  769969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  769971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  769973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  769978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  769981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  769984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  769987 */     GIR_RootConstrainSelectedInstOperands,
     /*  769988 */     // GIR_Coverage, 14473,
     /*  769988 */     GIR_EraseRootFromParent_Done,
     /*  769989 */   // Label 11985: @769989
     /*  769989 */   GIM_Try, /*On fail goto*//*Label 11986*/ GIMT_Encode4(770067), // Rule ID 14476 //
     /*  769994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  769997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770065 */     GIR_RootConstrainSelectedInstOperands,
     /*  770066 */     // GIR_Coverage, 14476,
     /*  770066 */     GIR_EraseRootFromParent_Done,
     /*  770067 */   // Label 11986: @770067
     /*  770067 */   GIM_Try, /*On fail goto*//*Label 11987*/ GIMT_Encode4(770145), // Rule ID 14477 //
     /*  770072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  770083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  770086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  770089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  770092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /*  770121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770143 */     GIR_RootConstrainSelectedInstOperands,
     /*  770144 */     // GIR_Coverage, 14477,
     /*  770144 */     GIR_EraseRootFromParent_Done,
     /*  770145 */   // Label 11987: @770145
     /*  770145 */   GIM_Try, /*On fail goto*//*Label 11988*/ GIMT_Encode4(770223), // Rule ID 14480 //
     /*  770150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770221 */     GIR_RootConstrainSelectedInstOperands,
     /*  770222 */     // GIR_Coverage, 14480,
     /*  770222 */     GIR_EraseRootFromParent_Done,
     /*  770223 */   // Label 11988: @770223
     /*  770223 */   GIM_Try, /*On fail goto*//*Label 11989*/ GIMT_Encode4(770301), // Rule ID 14481 //
     /*  770228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  770239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  770242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  770245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  770248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770274 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770296 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770299 */     GIR_RootConstrainSelectedInstOperands,
     /*  770300 */     // GIR_Coverage, 14481,
     /*  770300 */     GIR_EraseRootFromParent_Done,
     /*  770301 */   // Label 11989: @770301
     /*  770301 */   GIM_Try, /*On fail goto*//*Label 11990*/ GIMT_Encode4(770379), // Rule ID 14484 //
     /*  770306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  770352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770377 */     GIR_RootConstrainSelectedInstOperands,
     /*  770378 */     // GIR_Coverage, 14484,
     /*  770378 */     GIR_EraseRootFromParent_Done,
     /*  770379 */   // Label 11990: @770379
     /*  770379 */   GIM_Try, /*On fail goto*//*Label 11991*/ GIMT_Encode4(770457), // Rule ID 14485 //
     /*  770384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  770395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  770398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  770401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  770404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /*  770433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770455 */     GIR_RootConstrainSelectedInstOperands,
     /*  770456 */     // GIR_Coverage, 14485,
     /*  770456 */     GIR_EraseRootFromParent_Done,
     /*  770457 */   // Label 11991: @770457
     /*  770457 */   GIM_Try, /*On fail goto*//*Label 11992*/ GIMT_Encode4(770535), // Rule ID 14488 //
     /*  770462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  770473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  770476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  770479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  770482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770508 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  770508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770530 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770533 */     GIR_RootConstrainSelectedInstOperands,
     /*  770534 */     // GIR_Coverage, 14488,
     /*  770534 */     GIR_EraseRootFromParent_Done,
     /*  770535 */   // Label 11992: @770535
     /*  770535 */   GIM_Try, /*On fail goto*//*Label 11993*/ GIMT_Encode4(770613), // Rule ID 14489 //
     /*  770540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  770551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  770554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  770557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  770560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770586 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  770586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  770605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770608 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770611 */     GIR_RootConstrainSelectedInstOperands,
     /*  770612 */     // GIR_Coverage, 14489,
     /*  770612 */     GIR_EraseRootFromParent_Done,
     /*  770613 */   // Label 11993: @770613
     /*  770613 */   GIM_Try, /*On fail goto*//*Label 11994*/ GIMT_Encode4(770691), // Rule ID 14492 //
     /*  770618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  770629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  770632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  770635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  770638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  770664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770686 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770689 */     GIR_RootConstrainSelectedInstOperands,
     /*  770690 */     // GIR_Coverage, 14492,
     /*  770690 */     GIR_EraseRootFromParent_Done,
     /*  770691 */   // Label 11994: @770691
     /*  770691 */   GIM_Try, /*On fail goto*//*Label 11995*/ GIMT_Encode4(770769), // Rule ID 14493 //
     /*  770696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  770707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  770710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  770713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  770716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770742 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  770742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  770761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770767 */     GIR_RootConstrainSelectedInstOperands,
     /*  770768 */     // GIR_Coverage, 14493,
     /*  770768 */     GIR_EraseRootFromParent_Done,
     /*  770769 */   // Label 11995: @770769
     /*  770769 */   GIM_Try, /*On fail goto*//*Label 11996*/ GIMT_Encode4(770847), // Rule ID 14496 //
     /*  770774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  770777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  770785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  770788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  770791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  770794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  770820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770845 */     GIR_RootConstrainSelectedInstOperands,
     /*  770846 */     // GIR_Coverage, 14496,
     /*  770846 */     GIR_EraseRootFromParent_Done,
     /*  770847 */   // Label 11996: @770847
     /*  770847 */   GIM_Try, /*On fail goto*//*Label 11997*/ GIMT_Encode4(770925), // Rule ID 14497 //
     /*  770852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  770855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  770863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  770866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  770869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  770872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  770875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  770898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  770917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  770923 */     GIR_RootConstrainSelectedInstOperands,
     /*  770924 */     // GIR_Coverage, 14497,
     /*  770924 */     GIR_EraseRootFromParent_Done,
     /*  770925 */   // Label 11997: @770925
     /*  770925 */   GIM_Try, /*On fail goto*//*Label 11998*/ GIMT_Encode4(771003), // Rule ID 14500 //
     /*  770930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  770933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  770938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  770941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  770944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  770947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  770950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  770953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  770969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  770976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  770976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  770979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  770981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  770983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  770985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  770987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  770992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  770995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  770998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771001 */     GIR_RootConstrainSelectedInstOperands,
     /*  771002 */     // GIR_Coverage, 14500,
     /*  771002 */     GIR_EraseRootFromParent_Done,
     /*  771003 */   // Label 11998: @771003
     /*  771003 */   GIM_Try, /*On fail goto*//*Label 11999*/ GIMT_Encode4(771081), // Rule ID 14501 //
     /*  771008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  771011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  771019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  771022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  771025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  771028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  771047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  771054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /*  771057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  771073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771076 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771079 */     GIR_RootConstrainSelectedInstOperands,
     /*  771080 */     // GIR_Coverage, 14501,
     /*  771080 */     GIR_EraseRootFromParent_Done,
     /*  771081 */   // Label 11999: @771081
     /*  771081 */   GIM_Try, /*On fail goto*//*Label 12000*/ GIMT_Encode4(771159), // Rule ID 14504 //
     /*  771086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771157 */     GIR_RootConstrainSelectedInstOperands,
     /*  771158 */     // GIR_Coverage, 14504,
     /*  771158 */     GIR_EraseRootFromParent_Done,
     /*  771159 */   // Label 12000: @771159
     /*  771159 */   GIM_Try, /*On fail goto*//*Label 12001*/ GIMT_Encode4(771237), // Rule ID 14505 //
     /*  771164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  771175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  771178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  771181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  771184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771235 */     GIR_RootConstrainSelectedInstOperands,
     /*  771236 */     // GIR_Coverage, 14505,
     /*  771236 */     GIR_EraseRootFromParent_Done,
     /*  771237 */   // Label 12001: @771237
     /*  771237 */   GIM_Try, /*On fail goto*//*Label 12002*/ GIMT_Encode4(771315), // Rule ID 14508 //
     /*  771242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771288 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771310 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771313 */     GIR_RootConstrainSelectedInstOperands,
     /*  771314 */     // GIR_Coverage, 14508,
     /*  771314 */     GIR_EraseRootFromParent_Done,
     /*  771315 */   // Label 12002: @771315
     /*  771315 */   GIM_Try, /*On fail goto*//*Label 12003*/ GIMT_Encode4(771393), // Rule ID 14509 //
     /*  771320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  771331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  771334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  771337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  771340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771366 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771388 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771391 */     GIR_RootConstrainSelectedInstOperands,
     /*  771392 */     // GIR_Coverage, 14509,
     /*  771392 */     GIR_EraseRootFromParent_Done,
     /*  771393 */   // Label 12003: @771393
     /*  771393 */   GIM_Try, /*On fail goto*//*Label 12004*/ GIMT_Encode4(771471), // Rule ID 14512 //
     /*  771398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  771409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  771412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  771415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  771418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  771444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771466 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771469 */     GIR_RootConstrainSelectedInstOperands,
     /*  771470 */     // GIR_Coverage, 14512,
     /*  771470 */     GIR_EraseRootFromParent_Done,
     /*  771471 */   // Label 12004: @771471
     /*  771471 */   GIM_Try, /*On fail goto*//*Label 12005*/ GIMT_Encode4(771549), // Rule ID 14513 //
     /*  771476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  771487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  771490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  771493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  771496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771522 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  771522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  771541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771547 */     GIR_RootConstrainSelectedInstOperands,
     /*  771548 */     // GIR_Coverage, 14513,
     /*  771548 */     GIR_EraseRootFromParent_Done,
     /*  771549 */   // Label 12005: @771549
     /*  771549 */   GIM_Try, /*On fail goto*//*Label 12006*/ GIMT_Encode4(771627), // Rule ID 14516 //
     /*  771554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  771565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  771568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  771571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771625 */     GIR_RootConstrainSelectedInstOperands,
     /*  771626 */     // GIR_Coverage, 14516,
     /*  771626 */     GIR_EraseRootFromParent_Done,
     /*  771627 */   // Label 12006: @771627
     /*  771627 */   GIM_Try, /*On fail goto*//*Label 12007*/ GIMT_Encode4(771705), // Rule ID 14517 //
     /*  771632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  771643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  771646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  771649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  771652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  771671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  771681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771703 */     GIR_RootConstrainSelectedInstOperands,
     /*  771704 */     // GIR_Coverage, 14517,
     /*  771704 */     GIR_EraseRootFromParent_Done,
     /*  771705 */   // Label 12007: @771705
     /*  771705 */   GIM_Try, /*On fail goto*//*Label 12008*/ GIMT_Encode4(771783), // Rule ID 14520 //
     /*  771710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  771721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  771724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  771727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  771730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771781 */     GIR_RootConstrainSelectedInstOperands,
     /*  771782 */     // GIR_Coverage, 14520,
     /*  771782 */     GIR_EraseRootFromParent_Done,
     /*  771783 */   // Label 12008: @771783
     /*  771783 */   GIM_Try, /*On fail goto*//*Label 12009*/ GIMT_Encode4(771861), // Rule ID 14521 //
     /*  771788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  771799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  771802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  771805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  771808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  771827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771834 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  771837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771859 */     GIR_RootConstrainSelectedInstOperands,
     /*  771860 */     // GIR_Coverage, 14521,
     /*  771860 */     GIR_EraseRootFromParent_Done,
     /*  771861 */   // Label 12009: @771861
     /*  771861 */   GIM_Try, /*On fail goto*//*Label 12010*/ GIMT_Encode4(771939), // Rule ID 14524 //
     /*  771866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  771869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  771877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  771880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  771883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  771886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  771889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771912 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  771912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  771923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  771928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  771931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  771934 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  771937 */     GIR_RootConstrainSelectedInstOperands,
     /*  771938 */     // GIR_Coverage, 14524,
     /*  771938 */     GIR_EraseRootFromParent_Done,
     /*  771939 */   // Label 12010: @771939
     /*  771939 */   GIM_Try, /*On fail goto*//*Label 12011*/ GIMT_Encode4(772017), // Rule ID 14525 //
     /*  771944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  771947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  771952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  771955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  771958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  771961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  771964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  771967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  771983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  771990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  771990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  771993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  771995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  771997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  771999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  772009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772015 */     GIR_RootConstrainSelectedInstOperands,
     /*  772016 */     // GIR_Coverage, 14525,
     /*  772016 */     GIR_EraseRootFromParent_Done,
     /*  772017 */   // Label 12011: @772017
     /*  772017 */   GIM_Try, /*On fail goto*//*Label 12012*/ GIMT_Encode4(772095), // Rule ID 14528 //
     /*  772022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772093 */     GIR_RootConstrainSelectedInstOperands,
     /*  772094 */     // GIR_Coverage, 14528,
     /*  772094 */     GIR_EraseRootFromParent_Done,
     /*  772095 */   // Label 12012: @772095
     /*  772095 */   GIM_Try, /*On fail goto*//*Label 12013*/ GIMT_Encode4(772173), // Rule ID 14529 //
     /*  772100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  772111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  772114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  772117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  772120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772171 */     GIR_RootConstrainSelectedInstOperands,
     /*  772172 */     // GIR_Coverage, 14529,
     /*  772172 */     GIR_EraseRootFromParent_Done,
     /*  772173 */   // Label 12013: @772173
     /*  772173 */   GIM_Try, /*On fail goto*//*Label 12014*/ GIMT_Encode4(772251), // Rule ID 14532 //
     /*  772178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772249 */     GIR_RootConstrainSelectedInstOperands,
     /*  772250 */     // GIR_Coverage, 14532,
     /*  772250 */     GIR_EraseRootFromParent_Done,
     /*  772251 */   // Label 12014: @772251
     /*  772251 */   GIM_Try, /*On fail goto*//*Label 12015*/ GIMT_Encode4(772329), // Rule ID 14533 //
     /*  772256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  772267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  772270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  772273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  772276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772327 */     GIR_RootConstrainSelectedInstOperands,
     /*  772328 */     // GIR_Coverage, 14533,
     /*  772328 */     GIR_EraseRootFromParent_Done,
     /*  772329 */   // Label 12015: @772329
     /*  772329 */   GIM_Try, /*On fail goto*//*Label 12016*/ GIMT_Encode4(772407), // Rule ID 14536 //
     /*  772334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772380 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  772380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772405 */     GIR_RootConstrainSelectedInstOperands,
     /*  772406 */     // GIR_Coverage, 14536,
     /*  772406 */     GIR_EraseRootFromParent_Done,
     /*  772407 */   // Label 12016: @772407
     /*  772407 */   GIM_Try, /*On fail goto*//*Label 12017*/ GIMT_Encode4(772485), // Rule ID 14537 //
     /*  772412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  772415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  772423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  772426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  772429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  772432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  772458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  772477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772483 */     GIR_RootConstrainSelectedInstOperands,
     /*  772484 */     // GIR_Coverage, 14537,
     /*  772484 */     GIR_EraseRootFromParent_Done,
     /*  772485 */   // Label 12017: @772485
     /*  772485 */   GIM_Try, /*On fail goto*//*Label 12018*/ GIMT_Encode4(772563), // Rule ID 14540 //
     /*  772490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  772493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  772501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  772504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  772507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  772510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772558 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772561 */     GIR_RootConstrainSelectedInstOperands,
     /*  772562 */     // GIR_Coverage, 14540,
     /*  772562 */     GIR_EraseRootFromParent_Done,
     /*  772563 */   // Label 12018: @772563
     /*  772563 */   GIM_Try, /*On fail goto*//*Label 12019*/ GIMT_Encode4(772641), // Rule ID 14541 //
     /*  772568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  772571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  772579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  772582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  772585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  772588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  772607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772614 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /*  772617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772639 */     GIR_RootConstrainSelectedInstOperands,
     /*  772640 */     // GIR_Coverage, 14541,
     /*  772640 */     GIR_EraseRootFromParent_Done,
     /*  772641 */   // Label 12019: @772641
     /*  772641 */   GIM_Try, /*On fail goto*//*Label 12020*/ GIMT_Encode4(772719), // Rule ID 14544 //
     /*  772646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  772649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  772657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  772660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  772663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  772666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772692 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772717 */     GIR_RootConstrainSelectedInstOperands,
     /*  772718 */     // GIR_Coverage, 14544,
     /*  772718 */     GIR_EraseRootFromParent_Done,
     /*  772719 */   // Label 12020: @772719
     /*  772719 */   GIM_Try, /*On fail goto*//*Label 12021*/ GIMT_Encode4(772797), // Rule ID 14545 //
     /*  772724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  772727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  772735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  772738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  772741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  772744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  772763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /*  772773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772792 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772795 */     GIR_RootConstrainSelectedInstOperands,
     /*  772796 */     // GIR_Coverage, 14545,
     /*  772796 */     GIR_EraseRootFromParent_Done,
     /*  772797 */   // Label 12021: @772797
     /*  772797 */   GIM_Try, /*On fail goto*//*Label 12022*/ GIMT_Encode4(772875), // Rule ID 14548 //
     /*  772802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  772805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  772813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  772816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  772819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  772822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772848 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  772848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772870 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772873 */     GIR_RootConstrainSelectedInstOperands,
     /*  772874 */     // GIR_Coverage, 14548,
     /*  772874 */     GIR_EraseRootFromParent_Done,
     /*  772875 */   // Label 12022: @772875
     /*  772875 */   GIM_Try, /*On fail goto*//*Label 12023*/ GIMT_Encode4(772953), // Rule ID 14549 //
     /*  772880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  772883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  772891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  772894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  772897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  772900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  772903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  772919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  772926 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  772926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /*  772929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  772931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  772933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  772935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  772937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  772942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  772945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  772948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  772951 */     GIR_RootConstrainSelectedInstOperands,
     /*  772952 */     // GIR_Coverage, 14549,
     /*  772952 */     GIR_EraseRootFromParent_Done,
     /*  772953 */   // Label 12023: @772953
     /*  772953 */   GIM_Try, /*On fail goto*//*Label 12024*/ GIMT_Encode4(773031), // Rule ID 14552 //
     /*  772958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  772961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  772966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  772969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  772972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  772975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  772978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  772981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  772993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  772997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773004 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773026 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773029 */     GIR_RootConstrainSelectedInstOperands,
     /*  773030 */     // GIR_Coverage, 14552,
     /*  773030 */     GIR_EraseRootFromParent_Done,
     /*  773031 */   // Label 12024: @773031
     /*  773031 */   GIM_Try, /*On fail goto*//*Label 12025*/ GIMT_Encode4(773109), // Rule ID 14553 //
     /*  773036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  773047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  773050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  773053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773082 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8),
     /*  773085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773107 */     GIR_RootConstrainSelectedInstOperands,
     /*  773108 */     // GIR_Coverage, 14553,
     /*  773108 */     GIR_EraseRootFromParent_Done,
     /*  773109 */   // Label 12025: @773109
     /*  773109 */   GIM_Try, /*On fail goto*//*Label 12026*/ GIMT_Encode4(773187), // Rule ID 14556 //
     /*  773114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773185 */     GIR_RootConstrainSelectedInstOperands,
     /*  773186 */     // GIR_Coverage, 14556,
     /*  773186 */     GIR_EraseRootFromParent_Done,
     /*  773187 */   // Label 12026: @773187
     /*  773187 */   GIM_Try, /*On fail goto*//*Label 12027*/ GIMT_Encode4(773265), // Rule ID 14557 //
     /*  773192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  773203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  773206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  773209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773238 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773263 */     GIR_RootConstrainSelectedInstOperands,
     /*  773264 */     // GIR_Coverage, 14557,
     /*  773264 */     GIR_EraseRootFromParent_Done,
     /*  773265 */   // Label 12027: @773265
     /*  773265 */   GIM_Try, /*On fail goto*//*Label 12028*/ GIMT_Encode4(773343), // Rule ID 14560 //
     /*  773270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773316 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773341 */     GIR_RootConstrainSelectedInstOperands,
     /*  773342 */     // GIR_Coverage, 14560,
     /*  773342 */     GIR_EraseRootFromParent_Done,
     /*  773343 */   // Label 12028: @773343
     /*  773343 */   GIM_Try, /*On fail goto*//*Label 12029*/ GIMT_Encode4(773421), // Rule ID 14561 //
     /*  773348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  773359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  773362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  773365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773394 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  773394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773416 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773419 */     GIR_RootConstrainSelectedInstOperands,
     /*  773420 */     // GIR_Coverage, 14561,
     /*  773420 */     GIR_EraseRootFromParent_Done,
     /*  773421 */   // Label 12029: @773421
     /*  773421 */   GIM_Try, /*On fail goto*//*Label 12030*/ GIMT_Encode4(773499), // Rule ID 14564 //
     /*  773426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  773437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  773440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  773443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773472 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  773472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  773491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773494 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773497 */     GIR_RootConstrainSelectedInstOperands,
     /*  773498 */     // GIR_Coverage, 14564,
     /*  773498 */     GIR_EraseRootFromParent_Done,
     /*  773499 */   // Label 12030: @773499
     /*  773499 */   GIM_Try, /*On fail goto*//*Label 12031*/ GIMT_Encode4(773577), // Rule ID 14565 //
     /*  773504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  773515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  773518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  773521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  773550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4),
     /*  773553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  773569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773572 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773575 */     GIR_RootConstrainSelectedInstOperands,
     /*  773576 */     // GIR_Coverage, 14565,
     /*  773576 */     GIR_EraseRootFromParent_Done,
     /*  773577 */   // Label 12031: @773577
     /*  773577 */   GIM_Try, /*On fail goto*//*Label 12032*/ GIMT_Encode4(773655), // Rule ID 14568 //
     /*  773582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  773593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  773596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  773599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  773628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  773647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773653 */     GIR_RootConstrainSelectedInstOperands,
     /*  773654 */     // GIR_Coverage, 14568,
     /*  773654 */     GIR_EraseRootFromParent_Done,
     /*  773655 */   // Label 12032: @773655
     /*  773655 */   GIM_Try, /*On fail goto*//*Label 12033*/ GIMT_Encode4(773733), // Rule ID 14569 //
     /*  773660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  773671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  773674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  773677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  773706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  773725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773728 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773731 */     GIR_RootConstrainSelectedInstOperands,
     /*  773732 */     // GIR_Coverage, 14569,
     /*  773732 */     GIR_EraseRootFromParent_Done,
     /*  773733 */   // Label 12033: @773733
     /*  773733 */   GIM_Try, /*On fail goto*//*Label 12034*/ GIMT_Encode4(773811), // Rule ID 14572 //
     /*  773738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  773749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  773752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  773755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  773784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773806 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773809 */     GIR_RootConstrainSelectedInstOperands,
     /*  773810 */     // GIR_Coverage, 14572,
     /*  773810 */     GIR_EraseRootFromParent_Done,
     /*  773811 */   // Label 12034: @773811
     /*  773811 */   GIM_Try, /*On fail goto*//*Label 12035*/ GIMT_Encode4(773889), // Rule ID 14573 //
     /*  773816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  773827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  773830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  773833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773862 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  773862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2),
     /*  773865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  773881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773887 */     GIR_RootConstrainSelectedInstOperands,
     /*  773888 */     // GIR_Coverage, 14573,
     /*  773888 */     GIR_EraseRootFromParent_Done,
     /*  773889 */   // Label 12035: @773889
     /*  773889 */   GIM_Try, /*On fail goto*//*Label 12036*/ GIMT_Encode4(773967), // Rule ID 14576 //
     /*  773894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  773897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  773905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  773908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  773911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  773914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  773917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  773933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  773940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  773940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  773943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  773945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  773947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  773949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  773951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  773956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  773959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  773962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  773965 */     GIR_RootConstrainSelectedInstOperands,
     /*  773966 */     // GIR_Coverage, 14576,
     /*  773966 */     GIR_EraseRootFromParent_Done,
     /*  773967 */   // Label 12036: @773967
     /*  773967 */   GIM_Try, /*On fail goto*//*Label 12037*/ GIMT_Encode4(774045), // Rule ID 14577 //
     /*  773972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  773975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  773980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  773983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  773986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  773989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  773992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  773995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  773999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774018 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11550:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774043 */     GIR_RootConstrainSelectedInstOperands,
     /*  774044 */     // GIR_Coverage, 14577,
     /*  774044 */     GIR_EraseRootFromParent_Done,
     /*  774045 */   // Label 12037: @774045
     /*  774045 */   GIM_Try, /*On fail goto*//*Label 12038*/ GIMT_Encode4(774123), // Rule ID 14580 //
     /*  774050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  774096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774118 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774121 */     GIR_RootConstrainSelectedInstOperands,
     /*  774122 */     // GIR_Coverage, 14580,
     /*  774122 */     GIR_EraseRootFromParent_Done,
     /*  774123 */   // Label 12038: @774123
     /*  774123 */   GIM_Try, /*On fail goto*//*Label 12039*/ GIMT_Encode4(774201), // Rule ID 14581 //
     /*  774128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  774139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  774142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  774145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774174 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11550:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  774174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  774193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774199 */     GIR_RootConstrainSelectedInstOperands,
     /*  774200 */     // GIR_Coverage, 14581,
     /*  774200 */     GIR_EraseRootFromParent_Done,
     /*  774201 */   // Label 12039: @774201
     /*  774201 */   GIM_Try, /*On fail goto*//*Label 12040*/ GIMT_Encode4(774279), // Rule ID 14584 //
     /*  774206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774252 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  774252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774274 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774277 */     GIR_RootConstrainSelectedInstOperands,
     /*  774278 */     // GIR_Coverage, 14584,
     /*  774278 */     GIR_EraseRootFromParent_Done,
     /*  774279 */   // Label 12040: @774279
     /*  774279 */   GIM_Try, /*On fail goto*//*Label 12041*/ GIMT_Encode4(774357), // Rule ID 14585 //
     /*  774284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  774295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  774298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  774301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11550:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  774330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  774349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774355 */     GIR_RootConstrainSelectedInstOperands,
     /*  774356 */     // GIR_Coverage, 14585,
     /*  774356 */     GIR_EraseRootFromParent_Done,
     /*  774357 */   // Label 12041: @774357
     /*  774357 */   GIM_Try, /*On fail goto*//*Label 12042*/ GIMT_Encode4(774435), // Rule ID 14588 //
     /*  774362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  774365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  774408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774433 */     GIR_RootConstrainSelectedInstOperands,
     /*  774434 */     // GIR_Coverage, 14588,
     /*  774434 */     GIR_EraseRootFromParent_Done,
     /*  774435 */   // Label 12042: @774435
     /*  774435 */   GIM_Try, /*On fail goto*//*Label 12043*/ GIMT_Encode4(774513), // Rule ID 14589 //
     /*  774440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  774443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  774451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  774454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  774457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  774475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11550:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  774486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1),
     /*  774489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  774505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774511 */     GIR_RootConstrainSelectedInstOperands,
     /*  774512 */     // GIR_Coverage, 14589,
     /*  774512 */     GIR_EraseRootFromParent_Done,
     /*  774513 */   // Label 12043: @774513
     /*  774513 */   GIM_Try, /*On fail goto*//*Label 12044*/ GIMT_Encode4(774591), // Rule ID 14592 //
     /*  774518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  774529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  774532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  774535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774564 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  774567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774589 */     GIR_RootConstrainSelectedInstOperands,
     /*  774590 */     // GIR_Coverage, 14592,
     /*  774590 */     GIR_EraseRootFromParent_Done,
     /*  774591 */   // Label 12044: @774591
     /*  774591 */   GIM_Try, /*On fail goto*//*Label 12045*/ GIMT_Encode4(774669), // Rule ID 14593 //
     /*  774596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  774607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  774610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  774613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  774631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  774645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774667 */     GIR_RootConstrainSelectedInstOperands,
     /*  774668 */     // GIR_Coverage, 14593,
     /*  774668 */     GIR_EraseRootFromParent_Done,
     /*  774669 */   // Label 12045: @774669
     /*  774669 */   GIM_Try, /*On fail goto*//*Label 12046*/ GIMT_Encode4(774747), // Rule ID 14596 //
     /*  774674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  774685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  774688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  774691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774720 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  774723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774745 */     GIR_RootConstrainSelectedInstOperands,
     /*  774746 */     // GIR_Coverage, 14596,
     /*  774746 */     GIR_EraseRootFromParent_Done,
     /*  774747 */   // Label 12046: @774747
     /*  774747 */   GIM_Try, /*On fail goto*//*Label 12047*/ GIMT_Encode4(774825), // Rule ID 14597 //
     /*  774752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  774763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  774766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  774769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  774787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774798 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  774801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774823 */     GIR_RootConstrainSelectedInstOperands,
     /*  774824 */     // GIR_Coverage, 14597,
     /*  774824 */     GIR_EraseRootFromParent_Done,
     /*  774825 */   // Label 12047: @774825
     /*  774825 */   GIM_Try, /*On fail goto*//*Label 12048*/ GIMT_Encode4(774903), // Rule ID 14600 //
     /*  774830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  774841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  774844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  774847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  774850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  774853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  774876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  774879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774898 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774901 */     GIR_RootConstrainSelectedInstOperands,
     /*  774902 */     // GIR_Coverage, 14600,
     /*  774902 */     GIR_EraseRootFromParent_Done,
     /*  774903 */   // Label 12048: @774903
     /*  774903 */   GIM_Try, /*On fail goto*//*Label 12049*/ GIMT_Encode4(774981), // Rule ID 14601 //
     /*  774908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  774911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  774919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  774922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  774925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  774928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  774931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  774943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  774947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  774954 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  774954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  774957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  774959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  774961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  774963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  774965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  774970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  774973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  774976 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  774979 */     GIR_RootConstrainSelectedInstOperands,
     /*  774980 */     // GIR_Coverage, 14601,
     /*  774980 */     GIR_EraseRootFromParent_Done,
     /*  774981 */   // Label 12049: @774981
     /*  774981 */   GIM_Try, /*On fail goto*//*Label 12050*/ GIMT_Encode4(775059), // Rule ID 14604 //
     /*  774986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  774989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  774994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  774997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775057 */     GIR_RootConstrainSelectedInstOperands,
     /*  775058 */     // GIR_Coverage, 14604,
     /*  775058 */     GIR_EraseRootFromParent_Done,
     /*  775059 */   // Label 12050: @775059
     /*  775059 */   GIM_Try, /*On fail goto*//*Label 12051*/ GIMT_Encode4(775137), // Rule ID 14605 //
     /*  775064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  775075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  775078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  775081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775132 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775135 */     GIR_RootConstrainSelectedInstOperands,
     /*  775136 */     // GIR_Coverage, 14605,
     /*  775136 */     GIR_EraseRootFromParent_Done,
     /*  775137 */   // Label 12051: @775137
     /*  775137 */   GIM_Try, /*On fail goto*//*Label 12052*/ GIMT_Encode4(775215), // Rule ID 14608 //
     /*  775142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775188 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775213 */     GIR_RootConstrainSelectedInstOperands,
     /*  775214 */     // GIR_Coverage, 14608,
     /*  775214 */     GIR_EraseRootFromParent_Done,
     /*  775215 */   // Label 12052: @775215
     /*  775215 */   GIM_Try, /*On fail goto*//*Label 12053*/ GIMT_Encode4(775293), // Rule ID 14609 //
     /*  775220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  775231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  775234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  775237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775266 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775291 */     GIR_RootConstrainSelectedInstOperands,
     /*  775292 */     // GIR_Coverage, 14609,
     /*  775292 */     GIR_EraseRootFromParent_Done,
     /*  775293 */   // Label 12053: @775293
     /*  775293 */   GIM_Try, /*On fail goto*//*Label 12054*/ GIMT_Encode4(775371), // Rule ID 14612 //
     /*  775298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775344 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  775344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775369 */     GIR_RootConstrainSelectedInstOperands,
     /*  775370 */     // GIR_Coverage, 14612,
     /*  775370 */     GIR_EraseRootFromParent_Done,
     /*  775371 */   // Label 12054: @775371
     /*  775371 */   GIM_Try, /*On fail goto*//*Label 12055*/ GIMT_Encode4(775449), // Rule ID 14613 //
     /*  775376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  775387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  775390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  775393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  775422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  775441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775447 */     GIR_RootConstrainSelectedInstOperands,
     /*  775448 */     // GIR_Coverage, 14613,
     /*  775448 */     GIR_EraseRootFromParent_Done,
     /*  775449 */   // Label 12055: @775449
     /*  775449 */   GIM_Try, /*On fail goto*//*Label 12056*/ GIMT_Encode4(775527), // Rule ID 14616 //
     /*  775454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  775465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  775468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  775471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775525 */     GIR_RootConstrainSelectedInstOperands,
     /*  775526 */     // GIR_Coverage, 14616,
     /*  775526 */     GIR_EraseRootFromParent_Done,
     /*  775527 */   // Label 12056: @775527
     /*  775527 */   GIM_Try, /*On fail goto*//*Label 12057*/ GIMT_Encode4(775605), // Rule ID 14617 //
     /*  775532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  775543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  775546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  775549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775603 */     GIR_RootConstrainSelectedInstOperands,
     /*  775604 */     // GIR_Coverage, 14617,
     /*  775604 */     GIR_EraseRootFromParent_Done,
     /*  775605 */   // Label 12057: @775605
     /*  775605 */   GIM_Try, /*On fail goto*//*Label 12058*/ GIMT_Encode4(775683), // Rule ID 14620 //
     /*  775610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  775621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  775624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  775627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775681 */     GIR_RootConstrainSelectedInstOperands,
     /*  775682 */     // GIR_Coverage, 14620,
     /*  775682 */     GIR_EraseRootFromParent_Done,
     /*  775683 */   // Label 12058: @775683
     /*  775683 */   GIM_Try, /*On fail goto*//*Label 12059*/ GIMT_Encode4(775761), // Rule ID 14621 //
     /*  775688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  775699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  775702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  775705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  775723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  775737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775756 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775759 */     GIR_RootConstrainSelectedInstOperands,
     /*  775760 */     // GIR_Coverage, 14621,
     /*  775760 */     GIR_EraseRootFromParent_Done,
     /*  775761 */   // Label 12059: @775761
     /*  775761 */   GIM_Try, /*On fail goto*//*Label 12060*/ GIMT_Encode4(775839), // Rule ID 14624 //
     /*  775766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  775769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  775777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  775780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  775783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775812 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  775812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775834 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775837 */     GIR_RootConstrainSelectedInstOperands,
     /*  775838 */     // GIR_Coverage, 14624,
     /*  775838 */     GIR_EraseRootFromParent_Done,
     /*  775839 */   // Label 12060: @775839
     /*  775839 */   GIM_Try, /*On fail goto*//*Label 12061*/ GIMT_Encode4(775917), // Rule ID 14625 //
     /*  775844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  775847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  775855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  775858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  775861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  775864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  775867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  775879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  775890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  775893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  775909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775912 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775915 */     GIR_RootConstrainSelectedInstOperands,
     /*  775916 */     // GIR_Coverage, 14625,
     /*  775916 */     GIR_EraseRootFromParent_Done,
     /*  775917 */   // Label 12061: @775917
     /*  775917 */   GIM_Try, /*On fail goto*//*Label 12062*/ GIMT_Encode4(775995), // Rule ID 14628 //
     /*  775922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  775925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  775930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  775933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  775936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  775939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  775942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  775945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  775957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  775961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  775968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  775968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  775971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  775973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  775975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  775977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  775979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  775984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  775987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  775990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  775993 */     GIR_RootConstrainSelectedInstOperands,
     /*  775994 */     // GIR_Coverage, 14628,
     /*  775994 */     GIR_EraseRootFromParent_Done,
     /*  775995 */   // Label 12062: @775995
     /*  775995 */   GIM_Try, /*On fail goto*//*Label 12063*/ GIMT_Encode4(776073), // Rule ID 14629 //
     /*  776000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  776011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  776014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  776017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  776035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776046 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11550:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2),
     /*  776049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776068 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776071 */     GIR_RootConstrainSelectedInstOperands,
     /*  776072 */     // GIR_Coverage, 14629,
     /*  776072 */     GIR_EraseRootFromParent_Done,
     /*  776073 */   // Label 12063: @776073
     /*  776073 */   GIM_Try, /*On fail goto*//*Label 12064*/ GIMT_Encode4(776151), // Rule ID 14632 //
     /*  776078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776124 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776149 */     GIR_RootConstrainSelectedInstOperands,
     /*  776150 */     // GIR_Coverage, 14632,
     /*  776150 */     GIR_EraseRootFromParent_Done,
     /*  776151 */   // Label 12064: @776151
     /*  776151 */   GIM_Try, /*On fail goto*//*Label 12065*/ GIMT_Encode4(776229), // Rule ID 14633 //
     /*  776156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  776167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  776170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  776173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  776191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11550:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4),
     /*  776205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776227 */     GIR_RootConstrainSelectedInstOperands,
     /*  776228 */     // GIR_Coverage, 14633,
     /*  776228 */     GIR_EraseRootFromParent_Done,
     /*  776229 */   // Label 12065: @776229
     /*  776229 */   GIM_Try, /*On fail goto*//*Label 12066*/ GIMT_Encode4(776307), // Rule ID 14636 //
     /*  776234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  776237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  776254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776280 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  776280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776305 */     GIR_RootConstrainSelectedInstOperands,
     /*  776306 */     // GIR_Coverage, 14636,
     /*  776306 */     GIR_EraseRootFromParent_Done,
     /*  776307 */   // Label 12066: @776307
     /*  776307 */   GIM_Try, /*On fail goto*//*Label 12067*/ GIMT_Encode4(776385), // Rule ID 14637 //
     /*  776312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  776315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu),
     /*  776320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  776323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  776326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  776329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  776332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  776347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  776351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776358 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11550:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  776358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8),
     /*  776361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  776377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776383 */     GIR_RootConstrainSelectedInstOperands,
     /*  776384 */     // GIR_Coverage, 14637,
     /*  776384 */     GIR_EraseRootFromParent_Done,
     /*  776385 */   // Label 12067: @776385
     /*  776385 */   GIM_Try, /*On fail goto*//*Label 12068*/ GIMT_Encode4(776463), // Rule ID 14640 //
     /*  776390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  776404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  776407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  776410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  776436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  776439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776461 */     GIR_RootConstrainSelectedInstOperands,
     /*  776462 */     // GIR_Coverage, 14640,
     /*  776462 */     GIR_EraseRootFromParent_Done,
     /*  776463 */   // Label 12068: @776463
     /*  776463 */   GIM_Try, /*On fail goto*//*Label 12069*/ GIMT_Encode4(776541), // Rule ID 14641 //
     /*  776468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  776479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  776482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  776485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  776488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776514 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  776514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /*  776517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776539 */     GIR_RootConstrainSelectedInstOperands,
     /*  776540 */     // GIR_Coverage, 14641,
     /*  776540 */     GIR_EraseRootFromParent_Done,
     /*  776541 */   // Label 12069: @776541
     /*  776541 */   GIM_Try, /*On fail goto*//*Label 12070*/ GIMT_Encode4(776619), // Rule ID 14644 //
     /*  776546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  776557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  776560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  776563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  776566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  776592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  776595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776617 */     GIR_RootConstrainSelectedInstOperands,
     /*  776618 */     // GIR_Coverage, 14644,
     /*  776618 */     GIR_EraseRootFromParent_Done,
     /*  776619 */   // Label 12070: @776619
     /*  776619 */   GIM_Try, /*On fail goto*//*Label 12071*/ GIMT_Encode4(776697), // Rule ID 14645 //
     /*  776624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  776635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  776638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  776641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  776644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776670 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  776670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  776673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776692 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776695 */     GIR_RootConstrainSelectedInstOperands,
     /*  776696 */     // GIR_Coverage, 14645,
     /*  776696 */     GIR_EraseRootFromParent_Done,
     /*  776697 */   // Label 12071: @776697
     /*  776697 */   GIM_Try, /*On fail goto*//*Label 12072*/ GIMT_Encode4(776775), // Rule ID 14648 //
     /*  776702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  776713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  776716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  776719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  776722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776748 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  776748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  776751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776773 */     GIR_RootConstrainSelectedInstOperands,
     /*  776774 */     // GIR_Coverage, 14648,
     /*  776774 */     GIR_EraseRootFromParent_Done,
     /*  776775 */   // Label 12072: @776775
     /*  776775 */   GIM_Try, /*On fail goto*//*Label 12073*/ GIMT_Encode4(776853), // Rule ID 14649 //
     /*  776780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  776791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  776794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  776797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  776800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776826 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  776826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  776829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  776845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776851 */     GIR_RootConstrainSelectedInstOperands,
     /*  776852 */     // GIR_Coverage, 14649,
     /*  776852 */     GIR_EraseRootFromParent_Done,
     /*  776853 */   // Label 12073: @776853
     /*  776853 */   GIM_Try, /*On fail goto*//*Label 12074*/ GIMT_Encode4(776931), // Rule ID 14652 //
     /*  776858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  776861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  776869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  776872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  776875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  776881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776904 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  776904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  776907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  776923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  776926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  776929 */     GIR_RootConstrainSelectedInstOperands,
     /*  776930 */     // GIR_Coverage, 14652,
     /*  776930 */     GIR_EraseRootFromParent_Done,
     /*  776931 */   // Label 12074: @776931
     /*  776931 */   GIM_Try, /*On fail goto*//*Label 12075*/ GIMT_Encode4(777009), // Rule ID 14653 //
     /*  776936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  776939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  776944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  776947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  776950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  776953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  776956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  776959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  776975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  776982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  776982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /*  776985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  776987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  776989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  776991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  776993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  776998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777007 */     GIR_RootConstrainSelectedInstOperands,
     /*  777008 */     // GIR_Coverage, 14653,
     /*  777008 */     GIR_EraseRootFromParent_Done,
     /*  777009 */   // Label 12075: @777009
     /*  777009 */   GIM_Try, /*On fail goto*//*Label 12076*/ GIMT_Encode4(777087), // Rule ID 14656 //
     /*  777014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777060 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777085 */     GIR_RootConstrainSelectedInstOperands,
     /*  777086 */     // GIR_Coverage, 14656,
     /*  777086 */     GIR_EraseRootFromParent_Done,
     /*  777087 */   // Label 12076: @777087
     /*  777087 */   GIM_Try, /*On fail goto*//*Label 12077*/ GIMT_Encode4(777165), // Rule ID 14657 //
     /*  777092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  777103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  777106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  777109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  777112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777163 */     GIR_RootConstrainSelectedInstOperands,
     /*  777164 */     // GIR_Coverage, 14657,
     /*  777164 */     GIR_EraseRootFromParent_Done,
     /*  777165 */   // Label 12077: @777165
     /*  777165 */   GIM_Try, /*On fail goto*//*Label 12078*/ GIMT_Encode4(777243), // Rule ID 14660 //
     /*  777170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777238 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777241 */     GIR_RootConstrainSelectedInstOperands,
     /*  777242 */     // GIR_Coverage, 14660,
     /*  777242 */     GIR_EraseRootFromParent_Done,
     /*  777243 */   // Label 12078: @777243
     /*  777243 */   GIM_Try, /*On fail goto*//*Label 12079*/ GIMT_Encode4(777321), // Rule ID 14661 //
     /*  777248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  777259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  777262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  777265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  777268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /*  777297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777316 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777319 */     GIR_RootConstrainSelectedInstOperands,
     /*  777320 */     // GIR_Coverage, 14661,
     /*  777320 */     GIR_EraseRootFromParent_Done,
     /*  777321 */   // Label 12079: @777321
     /*  777321 */   GIM_Try, /*On fail goto*//*Label 12080*/ GIMT_Encode4(777399), // Rule ID 14664 //
     /*  777326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777372 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777397 */     GIR_RootConstrainSelectedInstOperands,
     /*  777398 */     // GIR_Coverage, 14664,
     /*  777398 */     GIR_EraseRootFromParent_Done,
     /*  777399 */   // Label 12080: @777399
     /*  777399 */   GIM_Try, /*On fail goto*//*Label 12081*/ GIMT_Encode4(777477), // Rule ID 14665 //
     /*  777404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  777415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  777418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  777421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  777424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  777450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  777469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777472 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777475 */     GIR_RootConstrainSelectedInstOperands,
     /*  777476 */     // GIR_Coverage, 14665,
     /*  777476 */     GIR_EraseRootFromParent_Done,
     /*  777477 */   // Label 12081: @777477
     /*  777477 */   GIM_Try, /*On fail goto*//*Label 12082*/ GIMT_Encode4(777555), // Rule ID 14668 //
     /*  777482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  777493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  777496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  777499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  777502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  777528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777553 */     GIR_RootConstrainSelectedInstOperands,
     /*  777554 */     // GIR_Coverage, 14668,
     /*  777554 */     GIR_EraseRootFromParent_Done,
     /*  777555 */   // Label 12082: @777555
     /*  777555 */   GIM_Try, /*On fail goto*//*Label 12083*/ GIMT_Encode4(777633), // Rule ID 14669 //
     /*  777560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  777571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  777574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  777577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  777580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  777606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  777625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777628 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777631 */     GIR_RootConstrainSelectedInstOperands,
     /*  777632 */     // GIR_Coverage, 14669,
     /*  777632 */     GIR_EraseRootFromParent_Done,
     /*  777633 */   // Label 12083: @777633
     /*  777633 */   GIM_Try, /*On fail goto*//*Label 12084*/ GIMT_Encode4(777711), // Rule ID 14672 //
     /*  777638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  777649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  777652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  777655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  777658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  777684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777709 */     GIR_RootConstrainSelectedInstOperands,
     /*  777710 */     // GIR_Coverage, 14672,
     /*  777710 */     GIR_EraseRootFromParent_Done,
     /*  777711 */   // Label 12084: @777711
     /*  777711 */   GIM_Try, /*On fail goto*//*Label 12085*/ GIMT_Encode4(777789), // Rule ID 14673 //
     /*  777716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  777719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  777727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  777730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  777733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  777736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777762 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  777762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  777781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777787 */     GIR_RootConstrainSelectedInstOperands,
     /*  777788 */     // GIR_Coverage, 14673,
     /*  777788 */     GIR_EraseRootFromParent_Done,
     /*  777789 */   // Label 12085: @777789
     /*  777789 */   GIM_Try, /*On fail goto*//*Label 12086*/ GIMT_Encode4(777867), // Rule ID 14676 //
     /*  777794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  777797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  777805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  777808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  777811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  777814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777840 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  777840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777865 */     GIR_RootConstrainSelectedInstOperands,
     /*  777866 */     // GIR_Coverage, 14676,
     /*  777866 */     GIR_EraseRootFromParent_Done,
     /*  777867 */   // Label 12086: @777867
     /*  777867 */   GIM_Try, /*On fail goto*//*Label 12087*/ GIMT_Encode4(777945), // Rule ID 14677 //
     /*  777872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  777875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  777883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  777886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  777889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  777892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  777895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  777911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  777918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /*  777921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  777923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  777925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  777927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  777929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  777934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  777937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  777940 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  777943 */     GIR_RootConstrainSelectedInstOperands,
     /*  777944 */     // GIR_Coverage, 14677,
     /*  777944 */     GIR_EraseRootFromParent_Done,
     /*  777945 */   // Label 12087: @777945
     /*  777945 */   GIM_Try, /*On fail goto*//*Label 12088*/ GIMT_Encode4(778023), // Rule ID 14680 //
     /*  777950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  777953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  777958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  777961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  777964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  777967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  777970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  777973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  777989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  777996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  777996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  777999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778018 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778021 */     GIR_RootConstrainSelectedInstOperands,
     /*  778022 */     // GIR_Coverage, 14680,
     /*  778022 */     GIR_EraseRootFromParent_Done,
     /*  778023 */   // Label 12088: @778023
     /*  778023 */   GIM_Try, /*On fail goto*//*Label 12089*/ GIMT_Encode4(778101), // Rule ID 14681 //
     /*  778028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  778039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  778042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  778045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  778048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778096 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778099 */     GIR_RootConstrainSelectedInstOperands,
     /*  778100 */     // GIR_Coverage, 14681,
     /*  778100 */     GIR_EraseRootFromParent_Done,
     /*  778101 */   // Label 12089: @778101
     /*  778101 */   GIM_Try, /*On fail goto*//*Label 12090*/ GIMT_Encode4(778179), // Rule ID 14684 //
     /*  778106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778152 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778177 */     GIR_RootConstrainSelectedInstOperands,
     /*  778178 */     // GIR_Coverage, 14684,
     /*  778178 */     GIR_EraseRootFromParent_Done,
     /*  778179 */   // Label 12090: @778179
     /*  778179 */   GIM_Try, /*On fail goto*//*Label 12091*/ GIMT_Encode4(778257), // Rule ID 14685 //
     /*  778184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  778195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  778198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  778201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  778204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778230 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778252 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778255 */     GIR_RootConstrainSelectedInstOperands,
     /*  778256 */     // GIR_Coverage, 14685,
     /*  778256 */     GIR_EraseRootFromParent_Done,
     /*  778257 */   // Label 12091: @778257
     /*  778257 */   GIM_Try, /*On fail goto*//*Label 12092*/ GIMT_Encode4(778335), // Rule ID 14688 //
     /*  778262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  778308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778333 */     GIR_RootConstrainSelectedInstOperands,
     /*  778334 */     // GIR_Coverage, 14688,
     /*  778334 */     GIR_EraseRootFromParent_Done,
     /*  778335 */   // Label 12092: @778335
     /*  778335 */   GIM_Try, /*On fail goto*//*Label 12093*/ GIMT_Encode4(778413), // Rule ID 14689 //
     /*  778340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  778351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  778354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  778357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  778360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778386 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  778386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  778405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778411 */     GIR_RootConstrainSelectedInstOperands,
     /*  778412 */     // GIR_Coverage, 14689,
     /*  778412 */     GIR_EraseRootFromParent_Done,
     /*  778413 */   // Label 12093: @778413
     /*  778413 */   GIM_Try, /*On fail goto*//*Label 12094*/ GIMT_Encode4(778491), // Rule ID 14692 //
     /*  778418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  778429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  778432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  778435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778489 */     GIR_RootConstrainSelectedInstOperands,
     /*  778490 */     // GIR_Coverage, 14692,
     /*  778490 */     GIR_EraseRootFromParent_Done,
     /*  778491 */   // Label 12094: @778491
     /*  778491 */   GIM_Try, /*On fail goto*//*Label 12095*/ GIMT_Encode4(778569), // Rule ID 14693 //
     /*  778496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  778507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  778510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  778513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  778516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778542 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778567 */     GIR_RootConstrainSelectedInstOperands,
     /*  778568 */     // GIR_Coverage, 14693,
     /*  778568 */     GIR_EraseRootFromParent_Done,
     /*  778569 */   // Label 12095: @778569
     /*  778569 */   GIM_Try, /*On fail goto*//*Label 12096*/ GIMT_Encode4(778647), // Rule ID 14696 //
     /*  778574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  778585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  778588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  778591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  778594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778620 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778645 */     GIR_RootConstrainSelectedInstOperands,
     /*  778646 */     // GIR_Coverage, 14696,
     /*  778646 */     GIR_EraseRootFromParent_Done,
     /*  778647 */   // Label 12096: @778647
     /*  778647 */   GIM_Try, /*On fail goto*//*Label 12097*/ GIMT_Encode4(778725), // Rule ID 14697 //
     /*  778652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  778663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  778666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  778669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  778672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  778691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778698 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  778701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778723 */     GIR_RootConstrainSelectedInstOperands,
     /*  778724 */     // GIR_Coverage, 14697,
     /*  778724 */     GIR_EraseRootFromParent_Done,
     /*  778725 */   // Label 12097: @778725
     /*  778725 */   GIM_Try, /*On fail goto*//*Label 12098*/ GIMT_Encode4(778803), // Rule ID 14700 //
     /*  778730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  778741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  778744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  778747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  778750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778776 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  778776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778798 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778801 */     GIR_RootConstrainSelectedInstOperands,
     /*  778802 */     // GIR_Coverage, 14700,
     /*  778802 */     GIR_EraseRootFromParent_Done,
     /*  778803 */   // Label 12098: @778803
     /*  778803 */   GIM_Try, /*On fail goto*//*Label 12099*/ GIMT_Encode4(778881), // Rule ID 14701 //
     /*  778808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  778819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  778822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  778825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  778828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  778847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  778854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  778857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  778873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778879 */     GIR_RootConstrainSelectedInstOperands,
     /*  778880 */     // GIR_Coverage, 14701,
     /*  778880 */     GIR_EraseRootFromParent_Done,
     /*  778881 */   // Label 12099: @778881
     /*  778881 */   GIM_Try, /*On fail goto*//*Label 12100*/ GIMT_Encode4(778959), // Rule ID 14704 //
     /*  778886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  778889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  778897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  778900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  778903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  778906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  778909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  778932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  778932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  778935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  778937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  778939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  778941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  778943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  778948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  778951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  778954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  778957 */     GIR_RootConstrainSelectedInstOperands,
     /*  778958 */     // GIR_Coverage, 14704,
     /*  778958 */     GIR_EraseRootFromParent_Done,
     /*  778959 */   // Label 12100: @778959
     /*  778959 */   GIM_Try, /*On fail goto*//*Label 12101*/ GIMT_Encode4(779037), // Rule ID 14705 //
     /*  778964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  778967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  778972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  778975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  778978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  778981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  778984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  778987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  778999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779032 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779035 */     GIR_RootConstrainSelectedInstOperands,
     /*  779036 */     // GIR_Coverage, 14705,
     /*  779036 */     GIR_EraseRootFromParent_Done,
     /*  779037 */   // Label 12101: @779037
     /*  779037 */   GIM_Try, /*On fail goto*//*Label 12102*/ GIMT_Encode4(779115), // Rule ID 14708 //
     /*  779042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779113 */     GIR_RootConstrainSelectedInstOperands,
     /*  779114 */     // GIR_Coverage, 14708,
     /*  779114 */     GIR_EraseRootFromParent_Done,
     /*  779115 */   // Label 12102: @779115
     /*  779115 */   GIM_Try, /*On fail goto*//*Label 12103*/ GIMT_Encode4(779193), // Rule ID 14709 //
     /*  779120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  779131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  779134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  779137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  779140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779191 */     GIR_RootConstrainSelectedInstOperands,
     /*  779192 */     // GIR_Coverage, 14709,
     /*  779192 */     GIR_EraseRootFromParent_Done,
     /*  779193 */   // Label 12103: @779193
     /*  779193 */   GIM_Try, /*On fail goto*//*Label 12104*/ GIMT_Encode4(779271), // Rule ID 14712 //
     /*  779198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779244 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  779244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779269 */     GIR_RootConstrainSelectedInstOperands,
     /*  779270 */     // GIR_Coverage, 14712,
     /*  779270 */     GIR_EraseRootFromParent_Done,
     /*  779271 */   // Label 12104: @779271
     /*  779271 */   GIM_Try, /*On fail goto*//*Label 12105*/ GIMT_Encode4(779349), // Rule ID 14713 //
     /*  779276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  779287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  779290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  779293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  779296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  779322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  779341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779347 */     GIR_RootConstrainSelectedInstOperands,
     /*  779348 */     // GIR_Coverage, 14713,
     /*  779348 */     GIR_EraseRootFromParent_Done,
     /*  779349 */   // Label 12105: @779349
     /*  779349 */   GIM_Try, /*On fail goto*//*Label 12106*/ GIMT_Encode4(779427), // Rule ID 14716 //
     /*  779354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  779400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779425 */     GIR_RootConstrainSelectedInstOperands,
     /*  779426 */     // GIR_Coverage, 14716,
     /*  779426 */     GIR_EraseRootFromParent_Done,
     /*  779427 */   // Label 12106: @779427
     /*  779427 */   GIM_Try, /*On fail goto*//*Label 12107*/ GIMT_Encode4(779505), // Rule ID 14717 //
     /*  779432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  779443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  779446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  779449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  779452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  779471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779478 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  779478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /*  779481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779503 */     GIR_RootConstrainSelectedInstOperands,
     /*  779504 */     // GIR_Coverage, 14717,
     /*  779504 */     GIR_EraseRootFromParent_Done,
     /*  779505 */   // Label 12107: @779505
     /*  779505 */   GIM_Try, /*On fail goto*//*Label 12108*/ GIMT_Encode4(779583), // Rule ID 14720 //
     /*  779510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  779521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  779524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  779527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  779530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  779556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779578 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779581 */     GIR_RootConstrainSelectedInstOperands,
     /*  779582 */     // GIR_Coverage, 14720,
     /*  779582 */     GIR_EraseRootFromParent_Done,
     /*  779583 */   // Label 12108: @779583
     /*  779583 */   GIM_Try, /*On fail goto*//*Label 12109*/ GIMT_Encode4(779661), // Rule ID 14721 //
     /*  779588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  779599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  779602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  779605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  779608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  779627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  779634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /*  779637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779656 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779659 */     GIR_RootConstrainSelectedInstOperands,
     /*  779660 */     // GIR_Coverage, 14721,
     /*  779660 */     GIR_EraseRootFromParent_Done,
     /*  779661 */   // Label 12109: @779661
     /*  779661 */   GIM_Try, /*On fail goto*//*Label 12110*/ GIMT_Encode4(779739), // Rule ID 14724 //
     /*  779666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  779669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  779677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  779680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  779683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  779686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779712 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  779712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779737 */     GIR_RootConstrainSelectedInstOperands,
     /*  779738 */     // GIR_Coverage, 14724,
     /*  779738 */     GIR_EraseRootFromParent_Done,
     /*  779739 */   // Label 12110: @779739
     /*  779739 */   GIM_Try, /*On fail goto*//*Label 12111*/ GIMT_Encode4(779817), // Rule ID 14725 //
     /*  779744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  779747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  779755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  779758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  779761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  779764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  779783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779790 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  779790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /*  779793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  779809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779812 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779815 */     GIR_RootConstrainSelectedInstOperands,
     /*  779816 */     // GIR_Coverage, 14725,
     /*  779816 */     GIR_EraseRootFromParent_Done,
     /*  779817 */   // Label 12111: @779817
     /*  779817 */   GIM_Try, /*On fail goto*//*Label 12112*/ GIMT_Encode4(779895), // Rule ID 14728 //
     /*  779822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  779833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  779836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  779839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  779845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  779868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  779871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779890 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779893 */     GIR_RootConstrainSelectedInstOperands,
     /*  779894 */     // GIR_Coverage, 14728,
     /*  779894 */     GIR_EraseRootFromParent_Done,
     /*  779895 */   // Label 12112: @779895
     /*  779895 */   GIM_Try, /*On fail goto*//*Label 12113*/ GIMT_Encode4(779973), // Rule ID 14729 //
     /*  779900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  779903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  779911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  779914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  779917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  779920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  779923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  779935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  779939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  779946 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  779946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8),
     /*  779949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  779951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  779953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  779955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  779957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  779962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  779965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  779968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  779971 */     GIR_RootConstrainSelectedInstOperands,
     /*  779972 */     // GIR_Coverage, 14729,
     /*  779972 */     GIR_EraseRootFromParent_Done,
     /*  779973 */   // Label 12113: @779973
     /*  779973 */   GIM_Try, /*On fail goto*//*Label 12114*/ GIMT_Encode4(780051), // Rule ID 14732 //
     /*  779978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  779981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  779986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  779989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  779992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  779995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  779998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780049 */     GIR_RootConstrainSelectedInstOperands,
     /*  780050 */     // GIR_Coverage, 14732,
     /*  780050 */     GIR_EraseRootFromParent_Done,
     /*  780051 */   // Label 12114: @780051
     /*  780051 */   GIM_Try, /*On fail goto*//*Label 12115*/ GIMT_Encode4(780129), // Rule ID 14733 //
     /*  780056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  780067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  780070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  780073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780102 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780127 */     GIR_RootConstrainSelectedInstOperands,
     /*  780128 */     // GIR_Coverage, 14733,
     /*  780128 */     GIR_EraseRootFromParent_Done,
     /*  780129 */   // Label 12115: @780129
     /*  780129 */   GIM_Try, /*On fail goto*//*Label 12116*/ GIMT_Encode4(780207), // Rule ID 14736 //
     /*  780134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780205 */     GIR_RootConstrainSelectedInstOperands,
     /*  780206 */     // GIR_Coverage, 14736,
     /*  780206 */     GIR_EraseRootFromParent_Done,
     /*  780207 */   // Label 12116: @780207
     /*  780207 */   GIM_Try, /*On fail goto*//*Label 12117*/ GIMT_Encode4(780285), // Rule ID 14737 //
     /*  780212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  780223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  780226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  780229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780280 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780283 */     GIR_RootConstrainSelectedInstOperands,
     /*  780284 */     // GIR_Coverage, 14737,
     /*  780284 */     GIR_EraseRootFromParent_Done,
     /*  780285 */   // Label 12117: @780285
     /*  780285 */   GIM_Try, /*On fail goto*//*Label 12118*/ GIMT_Encode4(780363), // Rule ID 14740 //
     /*  780290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780336 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  780336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780358 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780361 */     GIR_RootConstrainSelectedInstOperands,
     /*  780362 */     // GIR_Coverage, 14740,
     /*  780362 */     GIR_EraseRootFromParent_Done,
     /*  780363 */   // Label 12118: @780363
     /*  780363 */   GIM_Try, /*On fail goto*//*Label 12119*/ GIMT_Encode4(780441), // Rule ID 14741 //
     /*  780368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  780379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  780382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  780385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  780414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4),
     /*  780417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780439 */     GIR_RootConstrainSelectedInstOperands,
     /*  780440 */     // GIR_Coverage, 14741,
     /*  780440 */     GIR_EraseRootFromParent_Done,
     /*  780441 */   // Label 12119: @780441
     /*  780441 */   GIM_Try, /*On fail goto*//*Label 12120*/ GIMT_Encode4(780519), // Rule ID 14744 //
     /*  780446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  780457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  780460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  780463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  780492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780514 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780517 */     GIR_RootConstrainSelectedInstOperands,
     /*  780518 */     // GIR_Coverage, 14744,
     /*  780518 */     GIR_EraseRootFromParent_Done,
     /*  780519 */   // Label 12120: @780519
     /*  780519 */   GIM_Try, /*On fail goto*//*Label 12121*/ GIMT_Encode4(780597), // Rule ID 14745 //
     /*  780524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  780535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  780538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  780541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780570 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  780570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780592 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780595 */     GIR_RootConstrainSelectedInstOperands,
     /*  780596 */     // GIR_Coverage, 14745,
     /*  780596 */     GIR_EraseRootFromParent_Done,
     /*  780597 */   // Label 12121: @780597
     /*  780597 */   GIM_Try, /*On fail goto*//*Label 12122*/ GIMT_Encode4(780675), // Rule ID 14748 //
     /*  780602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  780613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  780616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  780619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780648 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  780648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780673 */     GIR_RootConstrainSelectedInstOperands,
     /*  780674 */     // GIR_Coverage, 14748,
     /*  780674 */     GIR_EraseRootFromParent_Done,
     /*  780675 */   // Label 12122: @780675
     /*  780675 */   GIM_Try, /*On fail goto*//*Label 12123*/ GIMT_Encode4(780753), // Rule ID 14749 //
     /*  780680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  780691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  780694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  780697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  780726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2),
     /*  780729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  780745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780751 */     GIR_RootConstrainSelectedInstOperands,
     /*  780752 */     // GIR_Coverage, 14749,
     /*  780752 */     GIR_EraseRootFromParent_Done,
     /*  780753 */   // Label 12123: @780753
     /*  780753 */   GIM_Try, /*On fail goto*//*Label 12124*/ GIMT_Encode4(780831), // Rule ID 14752 //
     /*  780758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  780769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  780772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  780775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780804 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  780804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  780807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780829 */     GIR_RootConstrainSelectedInstOperands,
     /*  780830 */     // GIR_Coverage, 14752,
     /*  780830 */     GIR_EraseRootFromParent_Done,
     /*  780831 */   // Label 12124: @780831
     /*  780831 */   GIM_Try, /*On fail goto*//*Label 12125*/ GIMT_Encode4(780909), // Rule ID 14753 //
     /*  780836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  780847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  780850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  780853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  780856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  780859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780882 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11548:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  780882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  780885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  780901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780907 */     GIR_RootConstrainSelectedInstOperands,
     /*  780908 */     // GIR_Coverage, 14753,
     /*  780908 */     GIR_EraseRootFromParent_Done,
     /*  780909 */   // Label 12125: @780909
     /*  780909 */   GIM_Try, /*On fail goto*//*Label 12126*/ GIMT_Encode4(780987), // Rule ID 14756 //
     /*  780914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  780917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  780922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  780925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  780928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  780931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  780934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  780937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  780949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  780953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  780960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  780960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  780963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  780965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  780967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  780969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  780971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  780976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  780979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  780982 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  780985 */     GIR_RootConstrainSelectedInstOperands,
     /*  780986 */     // GIR_Coverage, 14756,
     /*  780986 */     GIR_EraseRootFromParent_Done,
     /*  780987 */   // Label 12126: @780987
     /*  780987 */   GIM_Try, /*On fail goto*//*Label 12127*/ GIMT_Encode4(781065), // Rule ID 14757 //
     /*  780992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  780995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  781003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  781006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  781009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11548:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781060 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781063 */     GIR_RootConstrainSelectedInstOperands,
     /*  781064 */     // GIR_Coverage, 14757,
     /*  781064 */     GIR_EraseRootFromParent_Done,
     /*  781065 */   // Label 12127: @781065
     /*  781065 */   GIM_Try, /*On fail goto*//*Label 12128*/ GIMT_Encode4(781143), // Rule ID 14760 //
     /*  781070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781116 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  781116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781138 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781141 */     GIR_RootConstrainSelectedInstOperands,
     /*  781142 */     // GIR_Coverage, 14760,
     /*  781142 */     GIR_EraseRootFromParent_Done,
     /*  781143 */   // Label 12128: @781143
     /*  781143 */   GIM_Try, /*On fail goto*//*Label 12129*/ GIMT_Encode4(781221), // Rule ID 14761 //
     /*  781148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  781159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  781162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  781165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11548:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  781194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  781213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781219 */     GIR_RootConstrainSelectedInstOperands,
     /*  781220 */     // GIR_Coverage, 14761,
     /*  781220 */     GIR_EraseRootFromParent_Done,
     /*  781221 */   // Label 12129: @781221
     /*  781221 */   GIM_Try, /*On fail goto*//*Label 12130*/ GIMT_Encode4(781299), // Rule ID 14764 //
     /*  781226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  781229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  781272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781294 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781297 */     GIR_RootConstrainSelectedInstOperands,
     /*  781298 */     // GIR_Coverage, 14764,
     /*  781298 */     GIR_EraseRootFromParent_Done,
     /*  781299 */   // Label 12130: @781299
     /*  781299 */   GIM_Try, /*On fail goto*//*Label 12131*/ GIMT_Encode4(781377), // Rule ID 14765 //
     /*  781304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  781307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  781315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  781318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  781321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  781339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781350 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11548:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  781350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1),
     /*  781353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  781369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781375 */     GIR_RootConstrainSelectedInstOperands,
     /*  781376 */     // GIR_Coverage, 14765,
     /*  781376 */     GIR_EraseRootFromParent_Done,
     /*  781377 */   // Label 12131: @781377
     /*  781377 */   GIM_Try, /*On fail goto*//*Label 12132*/ GIMT_Encode4(781455), // Rule ID 14768 //
     /*  781382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781453 */     GIR_RootConstrainSelectedInstOperands,
     /*  781454 */     // GIR_Coverage, 14768,
     /*  781454 */     GIR_EraseRootFromParent_Done,
     /*  781455 */   // Label 12132: @781455
     /*  781455 */   GIM_Try, /*On fail goto*//*Label 12133*/ GIMT_Encode4(781533), // Rule ID 14769 //
     /*  781460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  781471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  781474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  781477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781531 */     GIR_RootConstrainSelectedInstOperands,
     /*  781532 */     // GIR_Coverage, 14769,
     /*  781532 */     GIR_EraseRootFromParent_Done,
     /*  781533 */   // Label 12133: @781533
     /*  781533 */   GIM_Try, /*On fail goto*//*Label 12134*/ GIMT_Encode4(781611), // Rule ID 14772 //
     /*  781538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  781549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  781552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  781555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  781587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781609 */     GIR_RootConstrainSelectedInstOperands,
     /*  781610 */     // GIR_Coverage, 14772,
     /*  781610 */     GIR_EraseRootFromParent_Done,
     /*  781611 */   // Label 12134: @781611
     /*  781611 */   GIM_Try, /*On fail goto*//*Label 12135*/ GIMT_Encode4(781689), // Rule ID 14773 //
     /*  781616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  781627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  781630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  781633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  781651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781662 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  781665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781687 */     GIR_RootConstrainSelectedInstOperands,
     /*  781688 */     // GIR_Coverage, 14773,
     /*  781688 */     GIR_EraseRootFromParent_Done,
     /*  781689 */   // Label 12135: @781689
     /*  781689 */   GIM_Try, /*On fail goto*//*Label 12136*/ GIMT_Encode4(781767), // Rule ID 14776 //
     /*  781694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  781705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  781708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  781711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  781740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  781743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781765 */     GIR_RootConstrainSelectedInstOperands,
     /*  781766 */     // GIR_Coverage, 14776,
     /*  781766 */     GIR_EraseRootFromParent_Done,
     /*  781767 */   // Label 12136: @781767
     /*  781767 */   GIM_Try, /*On fail goto*//*Label 12137*/ GIMT_Encode4(781845), // Rule ID 14777 //
     /*  781772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  781783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  781786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  781789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  781807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781818 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  781818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  781821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  781837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781843 */     GIR_RootConstrainSelectedInstOperands,
     /*  781844 */     // GIR_Coverage, 14777,
     /*  781844 */     GIR_EraseRootFromParent_Done,
     /*  781845 */   // Label 12137: @781845
     /*  781845 */   GIM_Try, /*On fail goto*//*Label 12138*/ GIMT_Encode4(781923), // Rule ID 14780 //
     /*  781850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  781853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  781861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  781864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  781867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  781870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  781873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781896 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  781896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781918 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781921 */     GIR_RootConstrainSelectedInstOperands,
     /*  781922 */     // GIR_Coverage, 14780,
     /*  781922 */     GIR_EraseRootFromParent_Done,
     /*  781923 */   // Label 12138: @781923
     /*  781923 */   GIM_Try, /*On fail goto*//*Label 12139*/ GIMT_Encode4(782001), // Rule ID 14781 //
     /*  781928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  781931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  781936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  781939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  781942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  781945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  781948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  781951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  781963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  781967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  781974 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  781974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  781977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  781979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  781981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  781983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  781985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  781990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  781993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  781996 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  781999 */     GIR_RootConstrainSelectedInstOperands,
     /*  782000 */     // GIR_Coverage, 14781,
     /*  782000 */     GIR_EraseRootFromParent_Done,
     /*  782001 */   // Label 12139: @782001
     /*  782001 */   GIM_Try, /*On fail goto*//*Label 12140*/ GIMT_Encode4(782079), // Rule ID 14784 //
     /*  782006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782052 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782074 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782077 */     GIR_RootConstrainSelectedInstOperands,
     /*  782078 */     // GIR_Coverage, 14784,
     /*  782078 */     GIR_EraseRootFromParent_Done,
     /*  782079 */   // Label 12140: @782079
     /*  782079 */   GIM_Try, /*On fail goto*//*Label 12141*/ GIMT_Encode4(782157), // Rule ID 14785 //
     /*  782084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  782095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  782098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  782101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782155 */     GIR_RootConstrainSelectedInstOperands,
     /*  782156 */     // GIR_Coverage, 14785,
     /*  782156 */     GIR_EraseRootFromParent_Done,
     /*  782157 */   // Label 12141: @782157
     /*  782157 */   GIM_Try, /*On fail goto*//*Label 12142*/ GIMT_Encode4(782235), // Rule ID 14788 //
     /*  782162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782208 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  782208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782233 */     GIR_RootConstrainSelectedInstOperands,
     /*  782234 */     // GIR_Coverage, 14788,
     /*  782234 */     GIR_EraseRootFromParent_Done,
     /*  782235 */   // Label 12142: @782235
     /*  782235 */   GIM_Try, /*On fail goto*//*Label 12143*/ GIMT_Encode4(782313), // Rule ID 14789 //
     /*  782240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  782251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  782254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  782257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  782286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  782305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782311 */     GIR_RootConstrainSelectedInstOperands,
     /*  782312 */     // GIR_Coverage, 14789,
     /*  782312 */     GIR_EraseRootFromParent_Done,
     /*  782313 */   // Label 12143: @782313
     /*  782313 */   GIM_Try, /*On fail goto*//*Label 12144*/ GIMT_Encode4(782391), // Rule ID 14792 //
     /*  782318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782364 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782389 */     GIR_RootConstrainSelectedInstOperands,
     /*  782390 */     // GIR_Coverage, 14792,
     /*  782390 */     GIR_EraseRootFromParent_Done,
     /*  782391 */   // Label 12144: @782391
     /*  782391 */   GIM_Try, /*On fail goto*//*Label 12145*/ GIMT_Encode4(782469), // Rule ID 14793 //
     /*  782396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  782407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  782410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  782413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782467 */     GIR_RootConstrainSelectedInstOperands,
     /*  782468 */     // GIR_Coverage, 14793,
     /*  782468 */     GIR_EraseRootFromParent_Done,
     /*  782469 */   // Label 12145: @782469
     /*  782469 */   GIM_Try, /*On fail goto*//*Label 12146*/ GIMT_Encode4(782547), // Rule ID 14796 //
     /*  782474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  782485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  782488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  782491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782542 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782545 */     GIR_RootConstrainSelectedInstOperands,
     /*  782546 */     // GIR_Coverage, 14796,
     /*  782546 */     GIR_EraseRootFromParent_Done,
     /*  782547 */   // Label 12146: @782547
     /*  782547 */   GIM_Try, /*On fail goto*//*Label 12147*/ GIMT_Encode4(782625), // Rule ID 14797 //
     /*  782552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  782563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  782566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  782569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782598 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782623 */     GIR_RootConstrainSelectedInstOperands,
     /*  782624 */     // GIR_Coverage, 14797,
     /*  782624 */     GIR_EraseRootFromParent_Done,
     /*  782625 */   // Label 12147: @782625
     /*  782625 */   GIM_Try, /*On fail goto*//*Label 12148*/ GIMT_Encode4(782703), // Rule ID 14800 //
     /*  782630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  782633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  782641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  782644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  782647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  782676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782701 */     GIR_RootConstrainSelectedInstOperands,
     /*  782702 */     // GIR_Coverage, 14800,
     /*  782702 */     GIR_EraseRootFromParent_Done,
     /*  782703 */   // Label 12148: @782703
     /*  782703 */   GIM_Try, /*On fail goto*//*Label 12149*/ GIMT_Encode4(782781), // Rule ID 14801 //
     /*  782708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  782711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  782719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  782722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  782725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  782743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782754 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  782754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  782757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  782773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782776 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782779 */     GIR_RootConstrainSelectedInstOperands,
     /*  782780 */     // GIR_Coverage, 14801,
     /*  782780 */     GIR_EraseRootFromParent_Done,
     /*  782781 */   // Label 12149: @782781
     /*  782781 */   GIM_Try, /*On fail goto*//*Label 12150*/ GIMT_Encode4(782859), // Rule ID 14804 //
     /*  782786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  782797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  782800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  782803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782857 */     GIR_RootConstrainSelectedInstOperands,
     /*  782858 */     // GIR_Coverage, 14804,
     /*  782858 */     GIR_EraseRootFromParent_Done,
     /*  782859 */   // Label 12150: @782859
     /*  782859 */   GIM_Try, /*On fail goto*//*Label 12151*/ GIMT_Encode4(782937), // Rule ID 14805 //
     /*  782864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  782867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  782875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  782878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  782881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  782884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  782887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  782899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11548:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  782910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2),
     /*  782913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  782926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  782929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  782932 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  782935 */     GIR_RootConstrainSelectedInstOperands,
     /*  782936 */     // GIR_Coverage, 14805,
     /*  782936 */     GIR_EraseRootFromParent_Done,
     /*  782937 */   // Label 12151: @782937
     /*  782937 */   GIM_Try, /*On fail goto*//*Label 12152*/ GIMT_Encode4(783015), // Rule ID 14808 //
     /*  782942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  782945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  782950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  782953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  782956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  782959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  782962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  782965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  782977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  782981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  782988 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  782988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  782991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  782993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  782995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  782997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  782999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783013 */     GIR_RootConstrainSelectedInstOperands,
     /*  783014 */     // GIR_Coverage, 14808,
     /*  783014 */     GIR_EraseRootFromParent_Done,
     /*  783015 */   // Label 12152: @783015
     /*  783015 */   GIM_Try, /*On fail goto*//*Label 12153*/ GIMT_Encode4(783093), // Rule ID 14809 //
     /*  783020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  783031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  783034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  783037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  783055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11548:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4),
     /*  783069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783091 */     GIR_RootConstrainSelectedInstOperands,
     /*  783092 */     // GIR_Coverage, 14809,
     /*  783092 */     GIR_EraseRootFromParent_Done,
     /*  783093 */   // Label 12153: @783093
     /*  783093 */   GIM_Try, /*On fail goto*//*Label 12154*/ GIMT_Encode4(783171), // Rule ID 14812 //
     /*  783098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  783101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  783118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783144 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  783144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783169 */     GIR_RootConstrainSelectedInstOperands,
     /*  783170 */     // GIR_Coverage, 14812,
     /*  783170 */     GIR_EraseRootFromParent_Done,
     /*  783171 */   // Label 12154: @783171
     /*  783171 */   GIM_Try, /*On fail goto*//*Label 12155*/ GIMT_Encode4(783249), // Rule ID 14813 //
     /*  783176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  783179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub),
     /*  783184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  783187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  783190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  783193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  783196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  783211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  783215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783222 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11548:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  783222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8),
     /*  783225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  783241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  783247 */     GIR_RootConstrainSelectedInstOperands,
     /*  783248 */     // GIR_Coverage, 14813,
     /*  783248 */     GIR_EraseRootFromParent_Done,
     /*  783249 */   // Label 12155: @783249
     /*  783249 */   GIM_Try, /*On fail goto*//*Label 12156*/ GIMT_Encode4(783324), // Rule ID 19054 //
     /*  783254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783322 */     GIR_RootConstrainSelectedInstOperands,
     /*  783323 */     // GIR_Coverage, 19054,
     /*  783323 */     GIR_EraseRootFromParent_Done,
     /*  783324 */   // Label 12156: @783324
     /*  783324 */   GIM_Try, /*On fail goto*//*Label 12157*/ GIMT_Encode4(783399), // Rule ID 19055 //
     /*  783329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  783340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  783343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  783346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  783349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783375 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /*  783378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783397 */     GIR_RootConstrainSelectedInstOperands,
     /*  783398 */     // GIR_Coverage, 19055,
     /*  783398 */     GIR_EraseRootFromParent_Done,
     /*  783399 */   // Label 12157: @783399
     /*  783399 */   GIM_Try, /*On fail goto*//*Label 12158*/ GIMT_Encode4(783474), // Rule ID 19058 //
     /*  783404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  783424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  783453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783472 */     GIR_RootConstrainSelectedInstOperands,
     /*  783473 */     // GIR_Coverage, 19058,
     /*  783473 */     GIR_EraseRootFromParent_Done,
     /*  783474 */   // Label 12158: @783474
     /*  783474 */   GIM_Try, /*On fail goto*//*Label 12159*/ GIMT_Encode4(783549), // Rule ID 19059 //
     /*  783479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  783490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  783493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  783496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  783499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /*  783528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783547 */     GIR_RootConstrainSelectedInstOperands,
     /*  783548 */     // GIR_Coverage, 19059,
     /*  783548 */     GIR_EraseRootFromParent_Done,
     /*  783549 */   // Label 12159: @783549
     /*  783549 */   GIM_Try, /*On fail goto*//*Label 12160*/ GIMT_Encode4(783624), // Rule ID 19062 //
     /*  783554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  783557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  783565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  783568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  783571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  783574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  783603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783622 */     GIR_RootConstrainSelectedInstOperands,
     /*  783623 */     // GIR_Coverage, 19062,
     /*  783623 */     GIR_EraseRootFromParent_Done,
     /*  783624 */   // Label 12160: @783624
     /*  783624 */   GIM_Try, /*On fail goto*//*Label 12161*/ GIMT_Encode4(783699), // Rule ID 19063 //
     /*  783629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  783632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  783640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  783643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  783646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  783649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /*  783678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783697 */     GIR_RootConstrainSelectedInstOperands,
     /*  783698 */     // GIR_Coverage, 19063,
     /*  783698 */     GIR_EraseRootFromParent_Done,
     /*  783699 */   // Label 12161: @783699
     /*  783699 */   GIM_Try, /*On fail goto*//*Label 12162*/ GIMT_Encode4(783774), // Rule ID 19066 //
     /*  783704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  783707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  783715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  783718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  783721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  783724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  783750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  783753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783772 */     GIR_RootConstrainSelectedInstOperands,
     /*  783773 */     // GIR_Coverage, 19066,
     /*  783773 */     GIR_EraseRootFromParent_Done,
     /*  783774 */   // Label 12162: @783774
     /*  783774 */   GIM_Try, /*On fail goto*//*Label 12163*/ GIMT_Encode4(783849), // Rule ID 19067 //
     /*  783779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  783782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  783790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  783793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  783796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  783799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783825 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  783825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /*  783828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  783844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783847 */     GIR_RootConstrainSelectedInstOperands,
     /*  783848 */     // GIR_Coverage, 19067,
     /*  783848 */     GIR_EraseRootFromParent_Done,
     /*  783849 */   // Label 12163: @783849
     /*  783849 */   GIM_Try, /*On fail goto*//*Label 12164*/ GIMT_Encode4(783924), // Rule ID 19070 //
     /*  783854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  783857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  783865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  783868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  783871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  783874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  783877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  783900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  783903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783922 */     GIR_RootConstrainSelectedInstOperands,
     /*  783923 */     // GIR_Coverage, 19070,
     /*  783923 */     GIR_EraseRootFromParent_Done,
     /*  783924 */   // Label 12164: @783924
     /*  783924 */   GIM_Try, /*On fail goto*//*Label 12165*/ GIMT_Encode4(783999), // Rule ID 19071 //
     /*  783929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  783932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  783937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  783940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  783943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  783946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  783949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  783952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  783968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  783975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  783975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /*  783978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  783980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  783982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  783984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  783986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  783991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  783994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  783997 */     GIR_RootConstrainSelectedInstOperands,
     /*  783998 */     // GIR_Coverage, 19071,
     /*  783998 */     GIR_EraseRootFromParent_Done,
     /*  783999 */   // Label 12165: @783999
     /*  783999 */   GIM_Try, /*On fail goto*//*Label 12166*/ GIMT_Encode4(784074), // Rule ID 19074 //
     /*  784004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  784007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  784050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784072 */     GIR_RootConstrainSelectedInstOperands,
     /*  784073 */     // GIR_Coverage, 19074,
     /*  784073 */     GIR_EraseRootFromParent_Done,
     /*  784074 */   // Label 12166: @784074
     /*  784074 */   GIM_Try, /*On fail goto*//*Label 12167*/ GIMT_Encode4(784149), // Rule ID 19075 //
     /*  784079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  784082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  784090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  784093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  784096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  784099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  784118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784125 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  784125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /*  784128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  784144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784147 */     GIR_RootConstrainSelectedInstOperands,
     /*  784148 */     // GIR_Coverage, 19075,
     /*  784148 */     GIR_EraseRootFromParent_Done,
     /*  784149 */   // Label 12167: @784149
     /*  784149 */   GIM_Try, /*On fail goto*//*Label 12168*/ GIMT_Encode4(784224), // Rule ID 19078 //
     /*  784154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784222 */     GIR_RootConstrainSelectedInstOperands,
     /*  784223 */     // GIR_Coverage, 19078,
     /*  784223 */     GIR_EraseRootFromParent_Done,
     /*  784224 */   // Label 12168: @784224
     /*  784224 */   GIM_Try, /*On fail goto*//*Label 12169*/ GIMT_Encode4(784299), // Rule ID 19079 //
     /*  784229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  784240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  784243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  784246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  784249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /*  784278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784297 */     GIR_RootConstrainSelectedInstOperands,
     /*  784298 */     // GIR_Coverage, 19079,
     /*  784298 */     GIR_EraseRootFromParent_Done,
     /*  784299 */   // Label 12169: @784299
     /*  784299 */   GIM_Try, /*On fail goto*//*Label 12170*/ GIMT_Encode4(784374), // Rule ID 19082 //
     /*  784304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784372 */     GIR_RootConstrainSelectedInstOperands,
     /*  784373 */     // GIR_Coverage, 19082,
     /*  784373 */     GIR_EraseRootFromParent_Done,
     /*  784374 */   // Label 12170: @784374
     /*  784374 */   GIM_Try, /*On fail goto*//*Label 12171*/ GIMT_Encode4(784449), // Rule ID 19083 //
     /*  784379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  784390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  784393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  784396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  784399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /*  784428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784447 */     GIR_RootConstrainSelectedInstOperands,
     /*  784448 */     // GIR_Coverage, 19083,
     /*  784448 */     GIR_EraseRootFromParent_Done,
     /*  784449 */   // Label 12171: @784449
     /*  784449 */   GIM_Try, /*On fail goto*//*Label 12172*/ GIMT_Encode4(784524), // Rule ID 19086 //
     /*  784454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  784457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  784471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  784474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784500 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  784500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  784503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784522 */     GIR_RootConstrainSelectedInstOperands,
     /*  784523 */     // GIR_Coverage, 19086,
     /*  784523 */     GIR_EraseRootFromParent_Done,
     /*  784524 */   // Label 12172: @784524
     /*  784524 */   GIM_Try, /*On fail goto*//*Label 12173*/ GIMT_Encode4(784599), // Rule ID 19087 //
     /*  784529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  784532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  784540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  784543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  784546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  784549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784575 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  784575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /*  784578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  784594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784597 */     GIR_RootConstrainSelectedInstOperands,
     /*  784598 */     // GIR_Coverage, 19087,
     /*  784598 */     GIR_EraseRootFromParent_Done,
     /*  784599 */   // Label 12173: @784599
     /*  784599 */   GIM_Try, /*On fail goto*//*Label 12174*/ GIMT_Encode4(784674), // Rule ID 19090 //
     /*  784604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  784615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  784618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  784621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  784624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  784653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784672 */     GIR_RootConstrainSelectedInstOperands,
     /*  784673 */     // GIR_Coverage, 19090,
     /*  784673 */     GIR_EraseRootFromParent_Done,
     /*  784674 */   // Label 12174: @784674
     /*  784674 */   GIM_Try, /*On fail goto*//*Label 12175*/ GIMT_Encode4(784749), // Rule ID 19091 //
     /*  784679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  784690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  784693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  784696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  784699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  784718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /*  784728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784747 */     GIR_RootConstrainSelectedInstOperands,
     /*  784748 */     // GIR_Coverage, 19091,
     /*  784748 */     GIR_EraseRootFromParent_Done,
     /*  784749 */   // Label 12175: @784749
     /*  784749 */   GIM_Try, /*On fail goto*//*Label 12176*/ GIMT_Encode4(784824), // Rule ID 19094 //
     /*  784754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  784765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  784768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  784771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  784774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784800 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  784803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784822 */     GIR_RootConstrainSelectedInstOperands,
     /*  784823 */     // GIR_Coverage, 19094,
     /*  784823 */     GIR_EraseRootFromParent_Done,
     /*  784824 */   // Label 12176: @784824
     /*  784824 */   GIM_Try, /*On fail goto*//*Label 12177*/ GIMT_Encode4(784899), // Rule ID 19095 //
     /*  784829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  784840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  784843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  784846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  784849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  784852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  784868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784875 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  784875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /*  784878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784897 */     GIR_RootConstrainSelectedInstOperands,
     /*  784898 */     // GIR_Coverage, 19095,
     /*  784898 */     GIR_EraseRootFromParent_Done,
     /*  784899 */   // Label 12177: @784899
     /*  784899 */   GIM_Try, /*On fail goto*//*Label 12178*/ GIMT_Encode4(784974), // Rule ID 19098 //
     /*  784904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  784907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  784915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  784918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  784921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  784924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  784927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  784943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  784950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  784950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  784953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  784955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  784957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  784959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  784961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  784966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  784969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  784972 */     GIR_RootConstrainSelectedInstOperands,
     /*  784973 */     // GIR_Coverage, 19098,
     /*  784973 */     GIR_EraseRootFromParent_Done,
     /*  784974 */   // Label 12178: @784974
     /*  784974 */   GIM_Try, /*On fail goto*//*Label 12179*/ GIMT_Encode4(785049), // Rule ID 19099 //
     /*  784979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  784982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  784987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  784990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  784993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  784996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  784999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785025 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /*  785028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785047 */     GIR_RootConstrainSelectedInstOperands,
     /*  785048 */     // GIR_Coverage, 19099,
     /*  785048 */     GIR_EraseRootFromParent_Done,
     /*  785049 */   // Label 12179: @785049
     /*  785049 */   GIM_Try, /*On fail goto*//*Label 12180*/ GIMT_Encode4(785124), // Rule ID 19102 //
     /*  785054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785122 */     GIR_RootConstrainSelectedInstOperands,
     /*  785123 */     // GIR_Coverage, 19102,
     /*  785123 */     GIR_EraseRootFromParent_Done,
     /*  785124 */   // Label 12180: @785124
     /*  785124 */   GIM_Try, /*On fail goto*//*Label 12181*/ GIMT_Encode4(785199), // Rule ID 19103 //
     /*  785129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  785140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  785143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  785146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  785149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  785168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /*  785178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785197 */     GIR_RootConstrainSelectedInstOperands,
     /*  785198 */     // GIR_Coverage, 19103,
     /*  785198 */     GIR_EraseRootFromParent_Done,
     /*  785199 */   // Label 12181: @785199
     /*  785199 */   GIM_Try, /*On fail goto*//*Label 12182*/ GIMT_Encode4(785274), // Rule ID 19106 //
     /*  785204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785272 */     GIR_RootConstrainSelectedInstOperands,
     /*  785273 */     // GIR_Coverage, 19106,
     /*  785273 */     GIR_EraseRootFromParent_Done,
     /*  785274 */   // Label 12182: @785274
     /*  785274 */   GIM_Try, /*On fail goto*//*Label 12183*/ GIMT_Encode4(785349), // Rule ID 19107 //
     /*  785279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  785290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  785293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  785296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  785299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  785318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /*  785328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785347 */     GIR_RootConstrainSelectedInstOperands,
     /*  785348 */     // GIR_Coverage, 19107,
     /*  785348 */     GIR_EraseRootFromParent_Done,
     /*  785349 */   // Label 12183: @785349
     /*  785349 */   GIM_Try, /*On fail goto*//*Label 12184*/ GIMT_Encode4(785424), // Rule ID 19110 //
     /*  785354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  785357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785400 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  785400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785422 */     GIR_RootConstrainSelectedInstOperands,
     /*  785423 */     // GIR_Coverage, 19110,
     /*  785423 */     GIR_EraseRootFromParent_Done,
     /*  785424 */   // Label 12184: @785424
     /*  785424 */   GIM_Try, /*On fail goto*//*Label 12185*/ GIMT_Encode4(785499), // Rule ID 19111 //
     /*  785429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  785432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  785440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  785443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  785446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  785449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  785468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785475 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  785475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /*  785478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  785494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785497 */     GIR_RootConstrainSelectedInstOperands,
     /*  785498 */     // GIR_Coverage, 19111,
     /*  785498 */     GIR_EraseRootFromParent_Done,
     /*  785499 */   // Label 12185: @785499
     /*  785499 */   GIM_Try, /*On fail goto*//*Label 12186*/ GIMT_Encode4(785574), // Rule ID 19114 //
     /*  785504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  785515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  785518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  785521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  785524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  785543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785550 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  785553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785572 */     GIR_RootConstrainSelectedInstOperands,
     /*  785573 */     // GIR_Coverage, 19114,
     /*  785573 */     GIR_EraseRootFromParent_Done,
     /*  785574 */   // Label 12186: @785574
     /*  785574 */   GIM_Try, /*On fail goto*//*Label 12187*/ GIMT_Encode4(785649), // Rule ID 19115 //
     /*  785579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  785590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  785593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  785596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  785599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  785618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785625 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16),
     /*  785628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785647 */     GIR_RootConstrainSelectedInstOperands,
     /*  785648 */     // GIR_Coverage, 19115,
     /*  785648 */     GIR_EraseRootFromParent_Done,
     /*  785649 */   // Label 12187: @785649
     /*  785649 */   GIM_Try, /*On fail goto*//*Label 12188*/ GIMT_Encode4(785724), // Rule ID 19118 //
     /*  785654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  785665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  785668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  785671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  785674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  785693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  785700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  785703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785722 */     GIR_RootConstrainSelectedInstOperands,
     /*  785723 */     // GIR_Coverage, 19118,
     /*  785723 */     GIR_EraseRootFromParent_Done,
     /*  785724 */   // Label 12188: @785724
     /*  785724 */   GIM_Try, /*On fail goto*//*Label 12189*/ GIMT_Encode4(785799), // Rule ID 19119 //
     /*  785729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  785732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  785740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  785743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  785746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  785749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  785768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785775 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  785775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16),
     /*  785778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  785794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785797 */     GIR_RootConstrainSelectedInstOperands,
     /*  785798 */     // GIR_Coverage, 19119,
     /*  785798 */     GIR_EraseRootFromParent_Done,
     /*  785799 */   // Label 12189: @785799
     /*  785799 */   GIM_Try, /*On fail goto*//*Label 12190*/ GIMT_Encode4(785874), // Rule ID 19122 //
     /*  785804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  785807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  785815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  785818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  785843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  785850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  785853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785872 */     GIR_RootConstrainSelectedInstOperands,
     /*  785873 */     // GIR_Coverage, 19122,
     /*  785873 */     GIR_EraseRootFromParent_Done,
     /*  785874 */   // Label 12190: @785874
     /*  785874 */   GIM_Try, /*On fail goto*//*Label 12191*/ GIMT_Encode4(785949), // Rule ID 19123 //
     /*  785879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  785882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  785890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  785893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  785896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  785899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  785902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  785918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  785925 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  785925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32),
     /*  785928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  785930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  785932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  785934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  785936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  785941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  785944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  785947 */     GIR_RootConstrainSelectedInstOperands,
     /*  785948 */     // GIR_Coverage, 19123,
     /*  785948 */     GIR_EraseRootFromParent_Done,
     /*  785949 */   // Label 12191: @785949
     /*  785949 */   GIM_Try, /*On fail goto*//*Label 12192*/ GIMT_Encode4(786024), // Rule ID 19126 //
     /*  785954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  785957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  785962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  785965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  785968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  785971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  785974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  785977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  785989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  785993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786022 */     GIR_RootConstrainSelectedInstOperands,
     /*  786023 */     // GIR_Coverage, 19126,
     /*  786023 */     GIR_EraseRootFromParent_Done,
     /*  786024 */   // Label 12192: @786024
     /*  786024 */   GIM_Try, /*On fail goto*//*Label 12193*/ GIMT_Encode4(786099), // Rule ID 19127 //
     /*  786029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  786040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  786043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  786046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786075 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11143:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16),
     /*  786078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786097 */     GIR_RootConstrainSelectedInstOperands,
     /*  786098 */     // GIR_Coverage, 19127,
     /*  786098 */     GIR_EraseRootFromParent_Done,
     /*  786099 */   // Label 12193: @786099
     /*  786099 */   GIM_Try, /*On fail goto*//*Label 12194*/ GIMT_Encode4(786174), // Rule ID 19130 //
     /*  786104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786172 */     GIR_RootConstrainSelectedInstOperands,
     /*  786173 */     // GIR_Coverage, 19130,
     /*  786173 */     GIR_EraseRootFromParent_Done,
     /*  786174 */   // Label 12194: @786174
     /*  786174 */   GIM_Try, /*On fail goto*//*Label 12195*/ GIMT_Encode4(786249), // Rule ID 19131 //
     /*  786179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  786190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  786193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  786196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786225 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11143:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32),
     /*  786228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786247 */     GIR_RootConstrainSelectedInstOperands,
     /*  786248 */     // GIR_Coverage, 19131,
     /*  786248 */     GIR_EraseRootFromParent_Done,
     /*  786249 */   // Label 12195: @786249
     /*  786249 */   GIM_Try, /*On fail goto*//*Label 12196*/ GIMT_Encode4(786324), // Rule ID 19134 //
     /*  786254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  786257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  786300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786322 */     GIR_RootConstrainSelectedInstOperands,
     /*  786323 */     // GIR_Coverage, 19134,
     /*  786323 */     GIR_EraseRootFromParent_Done,
     /*  786324 */   // Label 12196: @786324
     /*  786324 */   GIM_Try, /*On fail goto*//*Label 12197*/ GIMT_Encode4(786399), // Rule ID 19135 //
     /*  786329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  786332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  786340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  786343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  786346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  786349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  786364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  786368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11143:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  786375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64),
     /*  786378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  786394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786397 */     GIR_RootConstrainSelectedInstOperands,
     /*  786398 */     // GIR_Coverage, 19135,
     /*  786398 */     GIR_EraseRootFromParent_Done,
     /*  786399 */   // Label 12197: @786399
     /*  786399 */   GIM_Try, /*On fail goto*//*Label 12198*/ GIMT_Encode4(786474), // Rule ID 19138 //
     /*  786404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  786453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786472 */     GIR_RootConstrainSelectedInstOperands,
     /*  786473 */     // GIR_Coverage, 19138,
     /*  786473 */     GIR_EraseRootFromParent_Done,
     /*  786474 */   // Label 12198: @786474
     /*  786474 */   GIM_Try, /*On fail goto*//*Label 12199*/ GIMT_Encode4(786549), // Rule ID 19139 //
     /*  786479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  786490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  786493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  786496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16),
     /*  786528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786547 */     GIR_RootConstrainSelectedInstOperands,
     /*  786548 */     // GIR_Coverage, 19139,
     /*  786548 */     GIR_EraseRootFromParent_Done,
     /*  786549 */   // Label 12199: @786549
     /*  786549 */   GIM_Try, /*On fail goto*//*Label 12200*/ GIMT_Encode4(786624), // Rule ID 19142 //
     /*  786554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786600 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  786603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786622 */     GIR_RootConstrainSelectedInstOperands,
     /*  786623 */     // GIR_Coverage, 19142,
     /*  786623 */     GIR_EraseRootFromParent_Done,
     /*  786624 */   // Label 12200: @786624
     /*  786624 */   GIM_Try, /*On fail goto*//*Label 12201*/ GIMT_Encode4(786699), // Rule ID 19143 //
     /*  786629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  786640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  786643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  786646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  786664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786675 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16),
     /*  786678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786697 */     GIR_RootConstrainSelectedInstOperands,
     /*  786698 */     // GIR_Coverage, 19143,
     /*  786698 */     GIR_EraseRootFromParent_Done,
     /*  786699 */   // Label 12201: @786699
     /*  786699 */   GIM_Try, /*On fail goto*//*Label 12202*/ GIMT_Encode4(786774), // Rule ID 19146 //
     /*  786704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  786707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  786750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  786753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786772 */     GIR_RootConstrainSelectedInstOperands,
     /*  786773 */     // GIR_Coverage, 19146,
     /*  786773 */     GIR_EraseRootFromParent_Done,
     /*  786774 */   // Label 12202: @786774
     /*  786774 */   GIM_Try, /*On fail goto*//*Label 12203*/ GIMT_Encode4(786849), // Rule ID 19147 //
     /*  786779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  786782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  786790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  786793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  786796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  786799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  786814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  786818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  786825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16),
     /*  786828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  786844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786847 */     GIR_RootConstrainSelectedInstOperands,
     /*  786848 */     // GIR_Coverage, 19147,
     /*  786848 */     GIR_EraseRootFromParent_Done,
     /*  786849 */   // Label 12203: @786849
     /*  786849 */   GIM_Try, /*On fail goto*//*Label 12204*/ GIMT_Encode4(786924), // Rule ID 19150 //
     /*  786854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  786857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  786877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  786900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  786903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786922 */     GIR_RootConstrainSelectedInstOperands,
     /*  786923 */     // GIR_Coverage, 19150,
     /*  786923 */     GIR_EraseRootFromParent_Done,
     /*  786924 */   // Label 12204: @786924
     /*  786924 */   GIM_Try, /*On fail goto*//*Label 12205*/ GIMT_Encode4(786999), // Rule ID 19151 //
     /*  786929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  786932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  786937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  786940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  786943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  786946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  786949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  786952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  786964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  786968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  786975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  786975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32),
     /*  786978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  786980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  786982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  786984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  786986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  786991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  786994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  786997 */     GIR_RootConstrainSelectedInstOperands,
     /*  786998 */     // GIR_Coverage, 19151,
     /*  786998 */     GIR_EraseRootFromParent_Done,
     /*  786999 */   // Label 12205: @786999
     /*  786999 */   GIM_Try, /*On fail goto*//*Label 12206*/ GIMT_Encode4(787074), // Rule ID 19154 //
     /*  787004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787072 */     GIR_RootConstrainSelectedInstOperands,
     /*  787073 */     // GIR_Coverage, 19154,
     /*  787073 */     GIR_EraseRootFromParent_Done,
     /*  787074 */   // Label 12206: @787074
     /*  787074 */   GIM_Try, /*On fail goto*//*Label 12207*/ GIMT_Encode4(787149), // Rule ID 19155 //
     /*  787079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  787090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  787093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  787096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32),
     /*  787128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787147 */     GIR_RootConstrainSelectedInstOperands,
     /*  787148 */     // GIR_Coverage, 19155,
     /*  787148 */     GIR_EraseRootFromParent_Done,
     /*  787149 */   // Label 12207: @787149
     /*  787149 */   GIM_Try, /*On fail goto*//*Label 12208*/ GIMT_Encode4(787224), // Rule ID 19158 //
     /*  787154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  787157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787200 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  787200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787222 */     GIR_RootConstrainSelectedInstOperands,
     /*  787223 */     // GIR_Coverage, 19158,
     /*  787223 */     GIR_EraseRootFromParent_Done,
     /*  787224 */   // Label 12208: @787224
     /*  787224 */   GIM_Try, /*On fail goto*//*Label 12209*/ GIMT_Encode4(787299), // Rule ID 19159 //
     /*  787229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  787232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  787240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  787243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  787246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  787249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  787268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787275 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  787275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32),
     /*  787278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  787294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787297 */     GIR_RootConstrainSelectedInstOperands,
     /*  787298 */     // GIR_Coverage, 19159,
     /*  787298 */     GIR_EraseRootFromParent_Done,
     /*  787299 */   // Label 12209: @787299
     /*  787299 */   GIM_Try, /*On fail goto*//*Label 12210*/ GIMT_Encode4(787374), // Rule ID 19162 //
     /*  787304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787372 */     GIR_RootConstrainSelectedInstOperands,
     /*  787373 */     // GIR_Coverage, 19162,
     /*  787373 */     GIR_EraseRootFromParent_Done,
     /*  787374 */   // Label 12210: @787374
     /*  787374 */   GIM_Try, /*On fail goto*//*Label 12211*/ GIMT_Encode4(787449), // Rule ID 19163 //
     /*  787379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  787390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  787393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  787396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  787414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11143:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64),
     /*  787428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787447 */     GIR_RootConstrainSelectedInstOperands,
     /*  787448 */     // GIR_Coverage, 19163,
     /*  787448 */     GIR_EraseRootFromParent_Done,
     /*  787449 */   // Label 12211: @787449
     /*  787449 */   GIM_Try, /*On fail goto*//*Label 12212*/ GIMT_Encode4(787524), // Rule ID 19166 //
     /*  787454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  787503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787522 */     GIR_RootConstrainSelectedInstOperands,
     /*  787523 */     // GIR_Coverage, 19166,
     /*  787523 */     GIR_EraseRootFromParent_Done,
     /*  787524 */   // Label 12212: @787524
     /*  787524 */   GIM_Try, /*On fail goto*//*Label 12213*/ GIMT_Encode4(787599), // Rule ID 19167 //
     /*  787529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  787540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  787543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  787546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  787564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11143:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64),
     /*  787578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787597 */     GIR_RootConstrainSelectedInstOperands,
     /*  787598 */     // GIR_Coverage, 19167,
     /*  787598 */     GIR_EraseRootFromParent_Done,
     /*  787599 */   // Label 12213: @787599
     /*  787599 */   GIM_Try, /*On fail goto*//*Label 12214*/ GIMT_Encode4(787674), // Rule ID 19170 //
     /*  787604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  787607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  787650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  787653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787672 */     GIR_RootConstrainSelectedInstOperands,
     /*  787673 */     // GIR_Coverage, 19170,
     /*  787673 */     GIR_EraseRootFromParent_Done,
     /*  787674 */   // Label 12214: @787674
     /*  787674 */   GIM_Try, /*On fail goto*//*Label 12215*/ GIMT_Encode4(787749), // Rule ID 19171 //
     /*  787679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  787682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin),
     /*  787687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  787690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  787693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  787696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  787699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  787714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  787718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787725 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11143:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMIN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  787725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64),
     /*  787728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  787744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787747 */     GIR_RootConstrainSelectedInstOperands,
     /*  787748 */     // GIR_Coverage, 19171,
     /*  787748 */     GIR_EraseRootFromParent_Done,
     /*  787749 */   // Label 12215: @787749
     /*  787749 */   GIM_Try, /*On fail goto*//*Label 12216*/ GIMT_Encode4(787824), // Rule ID 19174 //
     /*  787754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  787762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  787803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787822 */     GIR_RootConstrainSelectedInstOperands,
     /*  787823 */     // GIR_Coverage, 19174,
     /*  787823 */     GIR_EraseRootFromParent_Done,
     /*  787824 */   // Label 12216: @787824
     /*  787824 */   GIM_Try, /*On fail goto*//*Label 12217*/ GIMT_Encode4(787899), // Rule ID 19175 //
     /*  787829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  787837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  787840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  787843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  787846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  787849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  787852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787875 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  787875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /*  787878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787897 */     GIR_RootConstrainSelectedInstOperands,
     /*  787898 */     // GIR_Coverage, 19175,
     /*  787898 */     GIR_EraseRootFromParent_Done,
     /*  787899 */   // Label 12217: @787899
     /*  787899 */   GIM_Try, /*On fail goto*//*Label 12218*/ GIMT_Encode4(787974), // Rule ID 19178 //
     /*  787904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  787907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  787912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  787927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  787943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  787950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  787950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  787953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  787955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  787957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  787959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  787961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  787966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  787969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  787972 */     GIR_RootConstrainSelectedInstOperands,
     /*  787973 */     // GIR_Coverage, 19178,
     /*  787973 */     GIR_EraseRootFromParent_Done,
     /*  787974 */   // Label 12218: @787974
     /*  787974 */   GIM_Try, /*On fail goto*//*Label 12219*/ GIMT_Encode4(788049), // Rule ID 19179 //
     /*  787979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  787982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  787987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  787990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  787993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  787996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  787999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788025 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /*  788028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788047 */     GIR_RootConstrainSelectedInstOperands,
     /*  788048 */     // GIR_Coverage, 19179,
     /*  788048 */     GIR_EraseRootFromParent_Done,
     /*  788049 */   // Label 12219: @788049
     /*  788049 */   GIM_Try, /*On fail goto*//*Label 12220*/ GIMT_Encode4(788124), // Rule ID 19182 //
     /*  788054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788100 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788122 */     GIR_RootConstrainSelectedInstOperands,
     /*  788123 */     // GIR_Coverage, 19182,
     /*  788123 */     GIR_EraseRootFromParent_Done,
     /*  788124 */   // Label 12220: @788124
     /*  788124 */   GIM_Try, /*On fail goto*//*Label 12221*/ GIMT_Encode4(788199), // Rule ID 19183 //
     /*  788129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  788140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  788143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  788146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  788149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788175 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /*  788178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788197 */     GIR_RootConstrainSelectedInstOperands,
     /*  788198 */     // GIR_Coverage, 19183,
     /*  788198 */     GIR_EraseRootFromParent_Done,
     /*  788199 */   // Label 12221: @788199
     /*  788199 */   GIM_Try, /*On fail goto*//*Label 12222*/ GIMT_Encode4(788274), // Rule ID 19186 //
     /*  788204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788272 */     GIR_RootConstrainSelectedInstOperands,
     /*  788273 */     // GIR_Coverage, 19186,
     /*  788273 */     GIR_EraseRootFromParent_Done,
     /*  788274 */   // Label 12222: @788274
     /*  788274 */   GIM_Try, /*On fail goto*//*Label 12223*/ GIMT_Encode4(788349), // Rule ID 19187 //
     /*  788279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  788290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  788293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  788296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  788299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788325 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /*  788328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788347 */     GIR_RootConstrainSelectedInstOperands,
     /*  788348 */     // GIR_Coverage, 19187,
     /*  788348 */     GIR_EraseRootFromParent_Done,
     /*  788349 */   // Label 12223: @788349
     /*  788349 */   GIM_Try, /*On fail goto*//*Label 12224*/ GIMT_Encode4(788424), // Rule ID 19190 //
     /*  788354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  788357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  788400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788422 */     GIR_RootConstrainSelectedInstOperands,
     /*  788423 */     // GIR_Coverage, 19190,
     /*  788423 */     GIR_EraseRootFromParent_Done,
     /*  788424 */   // Label 12224: @788424
     /*  788424 */   GIM_Try, /*On fail goto*//*Label 12225*/ GIMT_Encode4(788499), // Rule ID 19191 //
     /*  788429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  788432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  788440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  788443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  788446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  788449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788475 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  788475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /*  788478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  788494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788497 */     GIR_RootConstrainSelectedInstOperands,
     /*  788498 */     // GIR_Coverage, 19191,
     /*  788498 */     GIR_EraseRootFromParent_Done,
     /*  788499 */   // Label 12225: @788499
     /*  788499 */   GIM_Try, /*On fail goto*//*Label 12226*/ GIMT_Encode4(788574), // Rule ID 19194 //
     /*  788504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  788507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  788550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  788553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788572 */     GIR_RootConstrainSelectedInstOperands,
     /*  788573 */     // GIR_Coverage, 19194,
     /*  788573 */     GIR_EraseRootFromParent_Done,
     /*  788574 */   // Label 12226: @788574
     /*  788574 */   GIM_Try, /*On fail goto*//*Label 12227*/ GIMT_Encode4(788649), // Rule ID 19195 //
     /*  788579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  788582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  788590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  788593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  788596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  788599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  788618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788625 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  788625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /*  788628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  788644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788647 */     GIR_RootConstrainSelectedInstOperands,
     /*  788648 */     // GIR_Coverage, 19195,
     /*  788648 */     GIR_EraseRootFromParent_Done,
     /*  788649 */   // Label 12227: @788649
     /*  788649 */   GIM_Try, /*On fail goto*//*Label 12228*/ GIMT_Encode4(788724), // Rule ID 19198 //
     /*  788654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  788703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788722 */     GIR_RootConstrainSelectedInstOperands,
     /*  788723 */     // GIR_Coverage, 19198,
     /*  788723 */     GIR_EraseRootFromParent_Done,
     /*  788724 */   // Label 12228: @788724
     /*  788724 */   GIM_Try, /*On fail goto*//*Label 12229*/ GIMT_Encode4(788799), // Rule ID 19199 //
     /*  788729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  788740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  788743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  788746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  788749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  788768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788775 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /*  788778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788797 */     GIR_RootConstrainSelectedInstOperands,
     /*  788798 */     // GIR_Coverage, 19199,
     /*  788798 */     GIR_EraseRootFromParent_Done,
     /*  788799 */   // Label 12229: @788799
     /*  788799 */   GIM_Try, /*On fail goto*//*Label 12230*/ GIMT_Encode4(788874), // Rule ID 19202 //
     /*  788804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788850 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  788850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  788853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788872 */     GIR_RootConstrainSelectedInstOperands,
     /*  788873 */     // GIR_Coverage, 19202,
     /*  788873 */     GIR_EraseRootFromParent_Done,
     /*  788874 */   // Label 12230: @788874
     /*  788874 */   GIM_Try, /*On fail goto*//*Label 12231*/ GIMT_Encode4(788949), // Rule ID 19203 //
     /*  788879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  788882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  788890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  788893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  788896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  788899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  788902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  788918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  788925 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  788925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /*  788928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  788930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  788932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  788934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  788936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  788941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  788944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  788947 */     GIR_RootConstrainSelectedInstOperands,
     /*  788948 */     // GIR_Coverage, 19203,
     /*  788948 */     GIR_EraseRootFromParent_Done,
     /*  788949 */   // Label 12231: @788949
     /*  788949 */   GIM_Try, /*On fail goto*//*Label 12232*/ GIMT_Encode4(789024), // Rule ID 19206 //
     /*  788954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  788957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  788962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  788965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  788968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  788971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  788974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  788977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  788993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789000 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  789000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789022 */     GIR_RootConstrainSelectedInstOperands,
     /*  789023 */     // GIR_Coverage, 19206,
     /*  789023 */     GIR_EraseRootFromParent_Done,
     /*  789024 */   // Label 12232: @789024
     /*  789024 */   GIM_Try, /*On fail goto*//*Label 12233*/ GIMT_Encode4(789099), // Rule ID 19207 //
     /*  789029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  789032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  789040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  789043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  789046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  789049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789075 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  789075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /*  789078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  789094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789097 */     GIR_RootConstrainSelectedInstOperands,
     /*  789098 */     // GIR_Coverage, 19207,
     /*  789098 */     GIR_EraseRootFromParent_Done,
     /*  789099 */   // Label 12233: @789099
     /*  789099 */   GIM_Try, /*On fail goto*//*Label 12234*/ GIMT_Encode4(789174), // Rule ID 19210 //
     /*  789104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789172 */     GIR_RootConstrainSelectedInstOperands,
     /*  789173 */     // GIR_Coverage, 19210,
     /*  789173 */     GIR_EraseRootFromParent_Done,
     /*  789174 */   // Label 12234: @789174
     /*  789174 */   GIM_Try, /*On fail goto*//*Label 12235*/ GIMT_Encode4(789249), // Rule ID 19211 //
     /*  789179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  789190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  789193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  789196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  789199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /*  789228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789247 */     GIR_RootConstrainSelectedInstOperands,
     /*  789248 */     // GIR_Coverage, 19211,
     /*  789248 */     GIR_EraseRootFromParent_Done,
     /*  789249 */   // Label 12235: @789249
     /*  789249 */   GIM_Try, /*On fail goto*//*Label 12236*/ GIMT_Encode4(789324), // Rule ID 19214 //
     /*  789254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789300 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789322 */     GIR_RootConstrainSelectedInstOperands,
     /*  789323 */     // GIR_Coverage, 19214,
     /*  789323 */     GIR_EraseRootFromParent_Done,
     /*  789324 */   // Label 12236: @789324
     /*  789324 */   GIM_Try, /*On fail goto*//*Label 12237*/ GIMT_Encode4(789399), // Rule ID 19215 //
     /*  789329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  789340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  789343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  789346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  789349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789375 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /*  789378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789397 */     GIR_RootConstrainSelectedInstOperands,
     /*  789398 */     // GIR_Coverage, 19215,
     /*  789398 */     GIR_EraseRootFromParent_Done,
     /*  789399 */   // Label 12237: @789399
     /*  789399 */   GIM_Try, /*On fail goto*//*Label 12238*/ GIMT_Encode4(789474), // Rule ID 19218 //
     /*  789404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  789407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789450 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  789450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  789453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789472 */     GIR_RootConstrainSelectedInstOperands,
     /*  789473 */     // GIR_Coverage, 19218,
     /*  789473 */     GIR_EraseRootFromParent_Done,
     /*  789474 */   // Label 12238: @789474
     /*  789474 */   GIM_Try, /*On fail goto*//*Label 12239*/ GIMT_Encode4(789549), // Rule ID 19219 //
     /*  789479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  789482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  789490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  789493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  789496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  789499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  789525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /*  789528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  789544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789547 */     GIR_RootConstrainSelectedInstOperands,
     /*  789548 */     // GIR_Coverage, 19219,
     /*  789548 */     GIR_EraseRootFromParent_Done,
     /*  789549 */   // Label 12239: @789549
     /*  789549 */   GIM_Try, /*On fail goto*//*Label 12240*/ GIMT_Encode4(789624), // Rule ID 19222 //
     /*  789554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  789603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789622 */     GIR_RootConstrainSelectedInstOperands,
     /*  789623 */     // GIR_Coverage, 19222,
     /*  789623 */     GIR_EraseRootFromParent_Done,
     /*  789624 */   // Label 12240: @789624
     /*  789624 */   GIM_Try, /*On fail goto*//*Label 12241*/ GIMT_Encode4(789699), // Rule ID 19223 //
     /*  789629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  789640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  789643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  789646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  789649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  789668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789675 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /*  789678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789697 */     GIR_RootConstrainSelectedInstOperands,
     /*  789698 */     // GIR_Coverage, 19223,
     /*  789698 */     GIR_EraseRootFromParent_Done,
     /*  789699 */   // Label 12241: @789699
     /*  789699 */   GIM_Try, /*On fail goto*//*Label 12242*/ GIMT_Encode4(789774), // Rule ID 19226 //
     /*  789704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  789753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789772 */     GIR_RootConstrainSelectedInstOperands,
     /*  789773 */     // GIR_Coverage, 19226,
     /*  789773 */     GIR_EraseRootFromParent_Done,
     /*  789774 */   // Label 12242: @789774
     /*  789774 */   GIM_Try, /*On fail goto*//*Label 12243*/ GIMT_Encode4(789849), // Rule ID 19227 //
     /*  789779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  789790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  789793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  789796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  789799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  789818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789825 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /*  789828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789847 */     GIR_RootConstrainSelectedInstOperands,
     /*  789848 */     // GIR_Coverage, 19227,
     /*  789848 */     GIR_EraseRootFromParent_Done,
     /*  789849 */   // Label 12243: @789849
     /*  789849 */   GIM_Try, /*On fail goto*//*Label 12244*/ GIMT_Encode4(789924), // Rule ID 19230 //
     /*  789854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  789857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  789877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  789900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  789903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789922 */     GIR_RootConstrainSelectedInstOperands,
     /*  789923 */     // GIR_Coverage, 19230,
     /*  789923 */     GIR_EraseRootFromParent_Done,
     /*  789924 */   // Label 12244: @789924
     /*  789924 */   GIM_Try, /*On fail goto*//*Label 12245*/ GIMT_Encode4(789999), // Rule ID 19231 //
     /*  789929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  789932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  789937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  789940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  789943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  789946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  789949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  789952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  789968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  789975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  789975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /*  789978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  789980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  789982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  789984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  789986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  789991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  789994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  789997 */     GIR_RootConstrainSelectedInstOperands,
     /*  789998 */     // GIR_Coverage, 19231,
     /*  789998 */     GIR_EraseRootFromParent_Done,
     /*  789999 */   // Label 12245: @789999
     /*  789999 */   GIM_Try, /*On fail goto*//*Label 12246*/ GIMT_Encode4(790074), // Rule ID 19234 //
     /*  790004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790072 */     GIR_RootConstrainSelectedInstOperands,
     /*  790073 */     // GIR_Coverage, 19234,
     /*  790073 */     GIR_EraseRootFromParent_Done,
     /*  790074 */   // Label 12246: @790074
     /*  790074 */   GIM_Try, /*On fail goto*//*Label 12247*/ GIMT_Encode4(790149), // Rule ID 19235 //
     /*  790079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  790090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  790093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  790096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790125 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16),
     /*  790128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790147 */     GIR_RootConstrainSelectedInstOperands,
     /*  790148 */     // GIR_Coverage, 19235,
     /*  790148 */     GIR_EraseRootFromParent_Done,
     /*  790149 */   // Label 12247: @790149
     /*  790149 */   GIM_Try, /*On fail goto*//*Label 12248*/ GIMT_Encode4(790224), // Rule ID 19238 //
     /*  790154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790200 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790222 */     GIR_RootConstrainSelectedInstOperands,
     /*  790223 */     // GIR_Coverage, 19238,
     /*  790223 */     GIR_EraseRootFromParent_Done,
     /*  790224 */   // Label 12248: @790224
     /*  790224 */   GIM_Try, /*On fail goto*//*Label 12249*/ GIMT_Encode4(790299), // Rule ID 19239 //
     /*  790229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  790240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  790243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  790246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790275 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16),
     /*  790278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790297 */     GIR_RootConstrainSelectedInstOperands,
     /*  790298 */     // GIR_Coverage, 19239,
     /*  790298 */     GIR_EraseRootFromParent_Done,
     /*  790299 */   // Label 12249: @790299
     /*  790299 */   GIM_Try, /*On fail goto*//*Label 12250*/ GIMT_Encode4(790374), // Rule ID 19242 //
     /*  790304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790372 */     GIR_RootConstrainSelectedInstOperands,
     /*  790373 */     // GIR_Coverage, 19242,
     /*  790373 */     GIR_EraseRootFromParent_Done,
     /*  790374 */   // Label 12250: @790374
     /*  790374 */   GIM_Try, /*On fail goto*//*Label 12251*/ GIMT_Encode4(790449), // Rule ID 19243 //
     /*  790379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  790390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  790393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  790396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790425 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32),
     /*  790428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790447 */     GIR_RootConstrainSelectedInstOperands,
     /*  790448 */     // GIR_Coverage, 19243,
     /*  790448 */     GIR_EraseRootFromParent_Done,
     /*  790449 */   // Label 12251: @790449
     /*  790449 */   GIM_Try, /*On fail goto*//*Label 12252*/ GIMT_Encode4(790524), // Rule ID 19246 //
     /*  790454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790500 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  790503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790522 */     GIR_RootConstrainSelectedInstOperands,
     /*  790523 */     // GIR_Coverage, 19246,
     /*  790523 */     GIR_EraseRootFromParent_Done,
     /*  790524 */   // Label 12252: @790524
     /*  790524 */   GIM_Try, /*On fail goto*//*Label 12253*/ GIMT_Encode4(790599), // Rule ID 19247 //
     /*  790529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  790540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  790543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  790546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790575 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11140:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  790575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16),
     /*  790578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790597 */     GIR_RootConstrainSelectedInstOperands,
     /*  790598 */     // GIR_Coverage, 19247,
     /*  790598 */     GIR_EraseRootFromParent_Done,
     /*  790599 */   // Label 12253: @790599
     /*  790599 */   GIM_Try, /*On fail goto*//*Label 12254*/ GIMT_Encode4(790674), // Rule ID 19250 //
     /*  790604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  790607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  790650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  790653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790672 */     GIR_RootConstrainSelectedInstOperands,
     /*  790673 */     // GIR_Coverage, 19250,
     /*  790673 */     GIR_EraseRootFromParent_Done,
     /*  790674 */   // Label 12254: @790674
     /*  790674 */   GIM_Try, /*On fail goto*//*Label 12255*/ GIMT_Encode4(790749), // Rule ID 19251 //
     /*  790679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  790682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  790690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  790693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  790696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  790699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  790718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790725 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11140:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  790725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32),
     /*  790728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  790744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790747 */     GIR_RootConstrainSelectedInstOperands,
     /*  790748 */     // GIR_Coverage, 19251,
     /*  790748 */     GIR_EraseRootFromParent_Done,
     /*  790749 */   // Label 12255: @790749
     /*  790749 */   GIM_Try, /*On fail goto*//*Label 12256*/ GIMT_Encode4(790824), // Rule ID 19254 //
     /*  790754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  790757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  790800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  790803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790822 */     GIR_RootConstrainSelectedInstOperands,
     /*  790823 */     // GIR_Coverage, 19254,
     /*  790823 */     GIR_EraseRootFromParent_Done,
     /*  790824 */   // Label 12256: @790824
     /*  790824 */   GIM_Try, /*On fail goto*//*Label 12257*/ GIMT_Encode4(790899), // Rule ID 19255 //
     /*  790829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  790832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  790840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  790843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  790846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  790849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  790852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  790864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  790868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790875 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11140:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  790875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64),
     /*  790878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  790894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790897 */     GIR_RootConstrainSelectedInstOperands,
     /*  790898 */     // GIR_Coverage, 19255,
     /*  790898 */     GIR_EraseRootFromParent_Done,
     /*  790899 */   // Label 12257: @790899
     /*  790899 */   GIM_Try, /*On fail goto*//*Label 12258*/ GIMT_Encode4(790974), // Rule ID 19258 //
     /*  790904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  790907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  790927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  790939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  790943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  790950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  790950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  790953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  790955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  790957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  790959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  790961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  790966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  790969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  790972 */     GIR_RootConstrainSelectedInstOperands,
     /*  790973 */     // GIR_Coverage, 19258,
     /*  790973 */     GIR_EraseRootFromParent_Done,
     /*  790974 */   // Label 12258: @790974
     /*  790974 */   GIM_Try, /*On fail goto*//*Label 12259*/ GIMT_Encode4(791049), // Rule ID 19259 //
     /*  790979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  790982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  790987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  790990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  790993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  790996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  790999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791025 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16),
     /*  791028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791047 */     GIR_RootConstrainSelectedInstOperands,
     /*  791048 */     // GIR_Coverage, 19259,
     /*  791048 */     GIR_EraseRootFromParent_Done,
     /*  791049 */   // Label 12259: @791049
     /*  791049 */   GIM_Try, /*On fail goto*//*Label 12260*/ GIMT_Encode4(791124), // Rule ID 19262 //
     /*  791054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791100 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791122 */     GIR_RootConstrainSelectedInstOperands,
     /*  791123 */     // GIR_Coverage, 19262,
     /*  791123 */     GIR_EraseRootFromParent_Done,
     /*  791124 */   // Label 12260: @791124
     /*  791124 */   GIM_Try, /*On fail goto*//*Label 12261*/ GIMT_Encode4(791199), // Rule ID 19263 //
     /*  791129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  791140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  791143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  791146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791175 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16),
     /*  791178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791197 */     GIR_RootConstrainSelectedInstOperands,
     /*  791198 */     // GIR_Coverage, 19263,
     /*  791198 */     GIR_EraseRootFromParent_Done,
     /*  791199 */   // Label 12261: @791199
     /*  791199 */   GIM_Try, /*On fail goto*//*Label 12262*/ GIMT_Encode4(791274), // Rule ID 19266 //
     /*  791204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  791207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  791250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791272 */     GIR_RootConstrainSelectedInstOperands,
     /*  791273 */     // GIR_Coverage, 19266,
     /*  791273 */     GIR_EraseRootFromParent_Done,
     /*  791274 */   // Label 12262: @791274
     /*  791274 */   GIM_Try, /*On fail goto*//*Label 12263*/ GIMT_Encode4(791349), // Rule ID 19267 //
     /*  791279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  791282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  791290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  791293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  791296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  791299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  791318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791325 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  791325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16),
     /*  791328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  791344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791347 */     GIR_RootConstrainSelectedInstOperands,
     /*  791348 */     // GIR_Coverage, 19267,
     /*  791348 */     GIR_EraseRootFromParent_Done,
     /*  791349 */   // Label 12263: @791349
     /*  791349 */   GIM_Try, /*On fail goto*//*Label 12264*/ GIMT_Encode4(791424), // Rule ID 19270 //
     /*  791354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791400 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791422 */     GIR_RootConstrainSelectedInstOperands,
     /*  791423 */     // GIR_Coverage, 19270,
     /*  791423 */     GIR_EraseRootFromParent_Done,
     /*  791424 */   // Label 12264: @791424
     /*  791424 */   GIM_Try, /*On fail goto*//*Label 12265*/ GIMT_Encode4(791499), // Rule ID 19271 //
     /*  791429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  791440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  791443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  791446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791475 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32),
     /*  791478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791497 */     GIR_RootConstrainSelectedInstOperands,
     /*  791498 */     // GIR_Coverage, 19271,
     /*  791498 */     GIR_EraseRootFromParent_Done,
     /*  791499 */   // Label 12265: @791499
     /*  791499 */   GIM_Try, /*On fail goto*//*Label 12266*/ GIMT_Encode4(791574), // Rule ID 19274 //
     /*  791504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791550 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  791553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791572 */     GIR_RootConstrainSelectedInstOperands,
     /*  791573 */     // GIR_Coverage, 19274,
     /*  791573 */     GIR_EraseRootFromParent_Done,
     /*  791574 */   // Label 12266: @791574
     /*  791574 */   GIM_Try, /*On fail goto*//*Label 12267*/ GIMT_Encode4(791649), // Rule ID 19275 //
     /*  791579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  791590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  791593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  791596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791625 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32),
     /*  791628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791647 */     GIR_RootConstrainSelectedInstOperands,
     /*  791648 */     // GIR_Coverage, 19275,
     /*  791648 */     GIR_EraseRootFromParent_Done,
     /*  791649 */   // Label 12267: @791649
     /*  791649 */   GIM_Try, /*On fail goto*//*Label 12268*/ GIMT_Encode4(791724), // Rule ID 19278 //
     /*  791654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  791657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  791700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  791703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791722 */     GIR_RootConstrainSelectedInstOperands,
     /*  791723 */     // GIR_Coverage, 19278,
     /*  791723 */     GIR_EraseRootFromParent_Done,
     /*  791724 */   // Label 12268: @791724
     /*  791724 */   GIM_Try, /*On fail goto*//*Label 12269*/ GIMT_Encode4(791799), // Rule ID 19279 //
     /*  791729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  791732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  791740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  791743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  791746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  791749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  791764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  791768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791775 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  791775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32),
     /*  791778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  791794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791797 */     GIR_RootConstrainSelectedInstOperands,
     /*  791798 */     // GIR_Coverage, 19279,
     /*  791798 */     GIR_EraseRootFromParent_Done,
     /*  791799 */   // Label 12269: @791799
     /*  791799 */   GIM_Try, /*On fail goto*//*Label 12270*/ GIMT_Encode4(791874), // Rule ID 19282 //
     /*  791804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791850 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  791850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  791853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791872 */     GIR_RootConstrainSelectedInstOperands,
     /*  791873 */     // GIR_Coverage, 19282,
     /*  791873 */     GIR_EraseRootFromParent_Done,
     /*  791874 */   // Label 12270: @791874
     /*  791874 */   GIM_Try, /*On fail goto*//*Label 12271*/ GIMT_Encode4(791949), // Rule ID 19283 //
     /*  791879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  791882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  791890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  791893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  791896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  791902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  791914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  791925 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11140:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  791925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64),
     /*  791928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  791930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  791932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  791934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  791936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  791941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  791944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  791947 */     GIR_RootConstrainSelectedInstOperands,
     /*  791948 */     // GIR_Coverage, 19283,
     /*  791948 */     GIR_EraseRootFromParent_Done,
     /*  791949 */   // Label 12271: @791949
     /*  791949 */   GIM_Try, /*On fail goto*//*Label 12272*/ GIMT_Encode4(792024), // Rule ID 19286 //
     /*  791954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  791957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  791962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  791965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  791968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  791971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  791974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  791977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  791989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  791993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792000 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792022 */     GIR_RootConstrainSelectedInstOperands,
     /*  792023 */     // GIR_Coverage, 19286,
     /*  792023 */     GIR_EraseRootFromParent_Done,
     /*  792024 */   // Label 12272: @792024
     /*  792024 */   GIM_Try, /*On fail goto*//*Label 12273*/ GIMT_Encode4(792099), // Rule ID 19287 //
     /*  792029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  792040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  792043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  792046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  792064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792075 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11140:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64),
     /*  792078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792097 */     GIR_RootConstrainSelectedInstOperands,
     /*  792098 */     // GIR_Coverage, 19287,
     /*  792098 */     GIR_EraseRootFromParent_Done,
     /*  792099 */   // Label 12273: @792099
     /*  792099 */   GIM_Try, /*On fail goto*//*Label 12274*/ GIMT_Encode4(792174), // Rule ID 19290 //
     /*  792104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  792107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  792150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792172 */     GIR_RootConstrainSelectedInstOperands,
     /*  792173 */     // GIR_Coverage, 19290,
     /*  792173 */     GIR_EraseRootFromParent_Done,
     /*  792174 */   // Label 12274: @792174
     /*  792174 */   GIM_Try, /*On fail goto*//*Label 12275*/ GIMT_Encode4(792249), // Rule ID 19291 //
     /*  792179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  792182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax),
     /*  792187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  792190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  792193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  792196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  792199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  792214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  792218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792225 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11140:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMAX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  792225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64),
     /*  792228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  792244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792247 */     GIR_RootConstrainSelectedInstOperands,
     /*  792248 */     // GIR_Coverage, 19291,
     /*  792248 */     GIR_EraseRootFromParent_Done,
     /*  792249 */   // Label 12275: @792249
     /*  792249 */   GIM_Try, /*On fail goto*//*Label 12276*/ GIMT_Encode4(792324), // Rule ID 19294 //
     /*  792254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792322 */     GIR_RootConstrainSelectedInstOperands,
     /*  792323 */     // GIR_Coverage, 19294,
     /*  792323 */     GIR_EraseRootFromParent_Done,
     /*  792324 */   // Label 12276: @792324
     /*  792324 */   GIM_Try, /*On fail goto*//*Label 12277*/ GIMT_Encode4(792399), // Rule ID 19295 //
     /*  792329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  792340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  792343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  792346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  792349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792375 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /*  792378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792397 */     GIR_RootConstrainSelectedInstOperands,
     /*  792398 */     // GIR_Coverage, 19295,
     /*  792398 */     GIR_EraseRootFromParent_Done,
     /*  792399 */   // Label 12277: @792399
     /*  792399 */   GIM_Try, /*On fail goto*//*Label 12278*/ GIMT_Encode4(792474), // Rule ID 19298 //
     /*  792404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  792453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792472 */     GIR_RootConstrainSelectedInstOperands,
     /*  792473 */     // GIR_Coverage, 19298,
     /*  792473 */     GIR_EraseRootFromParent_Done,
     /*  792474 */   // Label 12278: @792474
     /*  792474 */   GIM_Try, /*On fail goto*//*Label 12279*/ GIMT_Encode4(792549), // Rule ID 19299 //
     /*  792479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  792490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  792493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  792496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  792499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /*  792528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792547 */     GIR_RootConstrainSelectedInstOperands,
     /*  792548 */     // GIR_Coverage, 19299,
     /*  792548 */     GIR_EraseRootFromParent_Done,
     /*  792549 */   // Label 12279: @792549
     /*  792549 */   GIM_Try, /*On fail goto*//*Label 12280*/ GIMT_Encode4(792624), // Rule ID 19302 //
     /*  792554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  792603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792622 */     GIR_RootConstrainSelectedInstOperands,
     /*  792623 */     // GIR_Coverage, 19302,
     /*  792623 */     GIR_EraseRootFromParent_Done,
     /*  792624 */   // Label 12280: @792624
     /*  792624 */   GIM_Try, /*On fail goto*//*Label 12281*/ GIMT_Encode4(792699), // Rule ID 19303 //
     /*  792629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  792640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  792643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  792646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  792649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /*  792678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792697 */     GIR_RootConstrainSelectedInstOperands,
     /*  792698 */     // GIR_Coverage, 19303,
     /*  792698 */     GIR_EraseRootFromParent_Done,
     /*  792699 */   // Label 12281: @792699
     /*  792699 */   GIM_Try, /*On fail goto*//*Label 12282*/ GIMT_Encode4(792774), // Rule ID 19306 //
     /*  792704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  792707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  792750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  792753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792772 */     GIR_RootConstrainSelectedInstOperands,
     /*  792773 */     // GIR_Coverage, 19306,
     /*  792773 */     GIR_EraseRootFromParent_Done,
     /*  792774 */   // Label 12282: @792774
     /*  792774 */   GIM_Try, /*On fail goto*//*Label 12283*/ GIMT_Encode4(792849), // Rule ID 19307 //
     /*  792779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  792782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  792790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  792793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  792796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  792799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792825 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  792825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /*  792828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  792844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792847 */     GIR_RootConstrainSelectedInstOperands,
     /*  792848 */     // GIR_Coverage, 19307,
     /*  792848 */     GIR_EraseRootFromParent_Done,
     /*  792849 */   // Label 12283: @792849
     /*  792849 */   GIM_Try, /*On fail goto*//*Label 12284*/ GIMT_Encode4(792924), // Rule ID 19310 //
     /*  792854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  792857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  792877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  792900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  792903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792922 */     GIR_RootConstrainSelectedInstOperands,
     /*  792923 */     // GIR_Coverage, 19310,
     /*  792923 */     GIR_EraseRootFromParent_Done,
     /*  792924 */   // Label 12284: @792924
     /*  792924 */   GIM_Try, /*On fail goto*//*Label 12285*/ GIMT_Encode4(792999), // Rule ID 19311 //
     /*  792929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  792932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  792937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  792940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  792943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  792946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  792949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  792952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  792968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  792975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  792975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /*  792978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  792980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  792982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  792984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  792986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  792991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  792994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  792997 */     GIR_RootConstrainSelectedInstOperands,
     /*  792998 */     // GIR_Coverage, 19311,
     /*  792998 */     GIR_EraseRootFromParent_Done,
     /*  792999 */   // Label 12285: @792999
     /*  792999 */   GIM_Try, /*On fail goto*//*Label 12286*/ GIMT_Encode4(793074), // Rule ID 19314 //
     /*  793004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  793007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  793050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793072 */     GIR_RootConstrainSelectedInstOperands,
     /*  793073 */     // GIR_Coverage, 19314,
     /*  793073 */     GIR_EraseRootFromParent_Done,
     /*  793074 */   // Label 12286: @793074
     /*  793074 */   GIM_Try, /*On fail goto*//*Label 12287*/ GIMT_Encode4(793149), // Rule ID 19315 //
     /*  793079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  793082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  793090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  793093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  793096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  793099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  793118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793125 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  793125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /*  793128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  793144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793147 */     GIR_RootConstrainSelectedInstOperands,
     /*  793148 */     // GIR_Coverage, 19315,
     /*  793148 */     GIR_EraseRootFromParent_Done,
     /*  793149 */   // Label 12287: @793149
     /*  793149 */   GIM_Try, /*On fail goto*//*Label 12288*/ GIMT_Encode4(793224), // Rule ID 19318 //
     /*  793154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793222 */     GIR_RootConstrainSelectedInstOperands,
     /*  793223 */     // GIR_Coverage, 19318,
     /*  793223 */     GIR_EraseRootFromParent_Done,
     /*  793224 */   // Label 12288: @793224
     /*  793224 */   GIM_Try, /*On fail goto*//*Label 12289*/ GIMT_Encode4(793299), // Rule ID 19319 //
     /*  793229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  793240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  793243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  793246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  793249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /*  793278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793297 */     GIR_RootConstrainSelectedInstOperands,
     /*  793298 */     // GIR_Coverage, 19319,
     /*  793298 */     GIR_EraseRootFromParent_Done,
     /*  793299 */   // Label 12289: @793299
     /*  793299 */   GIM_Try, /*On fail goto*//*Label 12290*/ GIMT_Encode4(793374), // Rule ID 19322 //
     /*  793304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793372 */     GIR_RootConstrainSelectedInstOperands,
     /*  793373 */     // GIR_Coverage, 19322,
     /*  793373 */     GIR_EraseRootFromParent_Done,
     /*  793374 */   // Label 12290: @793374
     /*  793374 */   GIM_Try, /*On fail goto*//*Label 12291*/ GIMT_Encode4(793449), // Rule ID 19323 //
     /*  793379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  793390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  793393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  793396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  793399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /*  793428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793447 */     GIR_RootConstrainSelectedInstOperands,
     /*  793448 */     // GIR_Coverage, 19323,
     /*  793448 */     GIR_EraseRootFromParent_Done,
     /*  793449 */   // Label 12291: @793449
     /*  793449 */   GIM_Try, /*On fail goto*//*Label 12292*/ GIMT_Encode4(793524), // Rule ID 19326 //
     /*  793454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  793457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793500 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  793500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  793503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793522 */     GIR_RootConstrainSelectedInstOperands,
     /*  793523 */     // GIR_Coverage, 19326,
     /*  793523 */     GIR_EraseRootFromParent_Done,
     /*  793524 */   // Label 12292: @793524
     /*  793524 */   GIM_Try, /*On fail goto*//*Label 12293*/ GIMT_Encode4(793599), // Rule ID 19327 //
     /*  793529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  793532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  793540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  793543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  793546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  793549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793575 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  793575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /*  793578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  793594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793597 */     GIR_RootConstrainSelectedInstOperands,
     /*  793598 */     // GIR_Coverage, 19327,
     /*  793598 */     GIR_EraseRootFromParent_Done,
     /*  793599 */   // Label 12293: @793599
     /*  793599 */   GIM_Try, /*On fail goto*//*Label 12294*/ GIMT_Encode4(793674), // Rule ID 19330 //
     /*  793604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  793653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793672 */     GIR_RootConstrainSelectedInstOperands,
     /*  793673 */     // GIR_Coverage, 19330,
     /*  793673 */     GIR_EraseRootFromParent_Done,
     /*  793674 */   // Label 12294: @793674
     /*  793674 */   GIM_Try, /*On fail goto*//*Label 12295*/ GIMT_Encode4(793749), // Rule ID 19331 //
     /*  793679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  793690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  793693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  793696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  793699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  793718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /*  793728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793747 */     GIR_RootConstrainSelectedInstOperands,
     /*  793748 */     // GIR_Coverage, 19331,
     /*  793748 */     GIR_EraseRootFromParent_Done,
     /*  793749 */   // Label 12295: @793749
     /*  793749 */   GIM_Try, /*On fail goto*//*Label 12296*/ GIMT_Encode4(793824), // Rule ID 19334 //
     /*  793754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793800 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  793803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793822 */     GIR_RootConstrainSelectedInstOperands,
     /*  793823 */     // GIR_Coverage, 19334,
     /*  793823 */     GIR_EraseRootFromParent_Done,
     /*  793824 */   // Label 12296: @793824
     /*  793824 */   GIM_Try, /*On fail goto*//*Label 12297*/ GIMT_Encode4(793899), // Rule ID 19335 //
     /*  793829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  793840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  793843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  793846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  793849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  793852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  793868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793875 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  793875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /*  793878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793897 */     GIR_RootConstrainSelectedInstOperands,
     /*  793898 */     // GIR_Coverage, 19335,
     /*  793898 */     GIR_EraseRootFromParent_Done,
     /*  793899 */   // Label 12297: @793899
     /*  793899 */   GIM_Try, /*On fail goto*//*Label 12298*/ GIMT_Encode4(793974), // Rule ID 19338 //
     /*  793904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  793907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  793927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  793943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  793950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  793950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  793953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  793955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  793957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  793959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  793961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  793966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  793969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  793972 */     GIR_RootConstrainSelectedInstOperands,
     /*  793973 */     // GIR_Coverage, 19338,
     /*  793973 */     GIR_EraseRootFromParent_Done,
     /*  793974 */   // Label 12298: @793974
     /*  793974 */   GIM_Try, /*On fail goto*//*Label 12299*/ GIMT_Encode4(794049), // Rule ID 19339 //
     /*  793979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  793982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  793987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  793990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  793993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  793996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  793999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794025 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /*  794028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794047 */     GIR_RootConstrainSelectedInstOperands,
     /*  794048 */     // GIR_Coverage, 19339,
     /*  794048 */     GIR_EraseRootFromParent_Done,
     /*  794049 */   // Label 12299: @794049
     /*  794049 */   GIM_Try, /*On fail goto*//*Label 12300*/ GIMT_Encode4(794124), // Rule ID 19342 //
     /*  794054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794122 */     GIR_RootConstrainSelectedInstOperands,
     /*  794123 */     // GIR_Coverage, 19342,
     /*  794123 */     GIR_EraseRootFromParent_Done,
     /*  794124 */   // Label 12300: @794124
     /*  794124 */   GIM_Try, /*On fail goto*//*Label 12301*/ GIMT_Encode4(794199), // Rule ID 19343 //
     /*  794129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  794140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  794143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  794146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  794149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  794168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /*  794178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794197 */     GIR_RootConstrainSelectedInstOperands,
     /*  794198 */     // GIR_Coverage, 19343,
     /*  794198 */     GIR_EraseRootFromParent_Done,
     /*  794199 */   // Label 12301: @794199
     /*  794199 */   GIM_Try, /*On fail goto*//*Label 12302*/ GIMT_Encode4(794274), // Rule ID 19346 //
     /*  794204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794272 */     GIR_RootConstrainSelectedInstOperands,
     /*  794273 */     // GIR_Coverage, 19346,
     /*  794273 */     GIR_EraseRootFromParent_Done,
     /*  794274 */   // Label 12302: @794274
     /*  794274 */   GIM_Try, /*On fail goto*//*Label 12303*/ GIMT_Encode4(794349), // Rule ID 19347 //
     /*  794279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  794290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  794293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  794296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  794299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  794318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /*  794328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794347 */     GIR_RootConstrainSelectedInstOperands,
     /*  794348 */     // GIR_Coverage, 19347,
     /*  794348 */     GIR_EraseRootFromParent_Done,
     /*  794349 */   // Label 12303: @794349
     /*  794349 */   GIM_Try, /*On fail goto*//*Label 12304*/ GIMT_Encode4(794424), // Rule ID 19350 //
     /*  794354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  794357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794400 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  794400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794422 */     GIR_RootConstrainSelectedInstOperands,
     /*  794423 */     // GIR_Coverage, 19350,
     /*  794423 */     GIR_EraseRootFromParent_Done,
     /*  794424 */   // Label 12304: @794424
     /*  794424 */   GIM_Try, /*On fail goto*//*Label 12305*/ GIMT_Encode4(794499), // Rule ID 19351 //
     /*  794429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  794432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  794440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  794443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  794446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  794449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  794468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794475 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  794475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /*  794478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  794494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794497 */     GIR_RootConstrainSelectedInstOperands,
     /*  794498 */     // GIR_Coverage, 19351,
     /*  794498 */     GIR_EraseRootFromParent_Done,
     /*  794499 */   // Label 12305: @794499
     /*  794499 */   GIM_Try, /*On fail goto*//*Label 12306*/ GIMT_Encode4(794574), // Rule ID 19354 //
     /*  794504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794550 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  794553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794572 */     GIR_RootConstrainSelectedInstOperands,
     /*  794573 */     // GIR_Coverage, 19354,
     /*  794573 */     GIR_EraseRootFromParent_Done,
     /*  794574 */   // Label 12306: @794574
     /*  794574 */   GIM_Try, /*On fail goto*//*Label 12307*/ GIMT_Encode4(794649), // Rule ID 19355 //
     /*  794579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  794590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  794593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  794596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794625 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16),
     /*  794628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794647 */     GIR_RootConstrainSelectedInstOperands,
     /*  794648 */     // GIR_Coverage, 19355,
     /*  794648 */     GIR_EraseRootFromParent_Done,
     /*  794649 */   // Label 12307: @794649
     /*  794649 */   GIM_Try, /*On fail goto*//*Label 12308*/ GIMT_Encode4(794724), // Rule ID 19358 //
     /*  794654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  794700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  794703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794722 */     GIR_RootConstrainSelectedInstOperands,
     /*  794723 */     // GIR_Coverage, 19358,
     /*  794723 */     GIR_EraseRootFromParent_Done,
     /*  794724 */   // Label 12308: @794724
     /*  794724 */   GIM_Try, /*On fail goto*//*Label 12309*/ GIMT_Encode4(794799), // Rule ID 19359 //
     /*  794729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  794732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  794740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  794743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  794746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794775 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  794775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16),
     /*  794778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  794794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794797 */     GIR_RootConstrainSelectedInstOperands,
     /*  794798 */     // GIR_Coverage, 19359,
     /*  794798 */     GIR_EraseRootFromParent_Done,
     /*  794799 */   // Label 12309: @794799
     /*  794799 */   GIM_Try, /*On fail goto*//*Label 12310*/ GIMT_Encode4(794874), // Rule ID 19362 //
     /*  794804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  794807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  794850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  794853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794872 */     GIR_RootConstrainSelectedInstOperands,
     /*  794873 */     // GIR_Coverage, 19362,
     /*  794873 */     GIR_EraseRootFromParent_Done,
     /*  794874 */   // Label 12310: @794874
     /*  794874 */   GIM_Try, /*On fail goto*//*Label 12311*/ GIMT_Encode4(794949), // Rule ID 19363 //
     /*  794879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  794882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  794890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  794893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  794896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  794899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  794902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  794918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  794925 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  794925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32),
     /*  794928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  794930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  794932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  794934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  794936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  794941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  794944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  794947 */     GIR_RootConstrainSelectedInstOperands,
     /*  794948 */     // GIR_Coverage, 19363,
     /*  794948 */     GIR_EraseRootFromParent_Done,
     /*  794949 */   // Label 12311: @794949
     /*  794949 */   GIM_Try, /*On fail goto*//*Label 12312*/ GIMT_Encode4(795024), // Rule ID 19366 //
     /*  794954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  794957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  794962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  794965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  794968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  794971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  794974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  794977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  794989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  794993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795022 */     GIR_RootConstrainSelectedInstOperands,
     /*  795023 */     // GIR_Coverage, 19366,
     /*  795023 */     GIR_EraseRootFromParent_Done,
     /*  795024 */   // Label 12312: @795024
     /*  795024 */   GIM_Try, /*On fail goto*//*Label 12313*/ GIMT_Encode4(795099), // Rule ID 19367 //
     /*  795029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  795040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  795043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  795046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795075 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11196:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16),
     /*  795078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795097 */     GIR_RootConstrainSelectedInstOperands,
     /*  795098 */     // GIR_Coverage, 19367,
     /*  795098 */     GIR_EraseRootFromParent_Done,
     /*  795099 */   // Label 12313: @795099
     /*  795099 */   GIM_Try, /*On fail goto*//*Label 12314*/ GIMT_Encode4(795174), // Rule ID 19370 //
     /*  795104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795172 */     GIR_RootConstrainSelectedInstOperands,
     /*  795173 */     // GIR_Coverage, 19370,
     /*  795173 */     GIR_EraseRootFromParent_Done,
     /*  795174 */   // Label 12314: @795174
     /*  795174 */   GIM_Try, /*On fail goto*//*Label 12315*/ GIMT_Encode4(795249), // Rule ID 19371 //
     /*  795179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  795190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  795193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  795196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795225 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11196:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32),
     /*  795228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795247 */     GIR_RootConstrainSelectedInstOperands,
     /*  795248 */     // GIR_Coverage, 19371,
     /*  795248 */     GIR_EraseRootFromParent_Done,
     /*  795249 */   // Label 12315: @795249
     /*  795249 */   GIM_Try, /*On fail goto*//*Label 12316*/ GIMT_Encode4(795324), // Rule ID 19374 //
     /*  795254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  795257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  795300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795322 */     GIR_RootConstrainSelectedInstOperands,
     /*  795323 */     // GIR_Coverage, 19374,
     /*  795323 */     GIR_EraseRootFromParent_Done,
     /*  795324 */   // Label 12316: @795324
     /*  795324 */   GIM_Try, /*On fail goto*//*Label 12317*/ GIMT_Encode4(795399), // Rule ID 19375 //
     /*  795329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  795332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  795340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  795343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  795346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  795349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  795364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  795368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11196:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  795375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64),
     /*  795378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  795394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795397 */     GIR_RootConstrainSelectedInstOperands,
     /*  795398 */     // GIR_Coverage, 19375,
     /*  795398 */     GIR_EraseRootFromParent_Done,
     /*  795399 */   // Label 12317: @795399
     /*  795399 */   GIM_Try, /*On fail goto*//*Label 12318*/ GIMT_Encode4(795474), // Rule ID 19378 //
     /*  795404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  795453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795472 */     GIR_RootConstrainSelectedInstOperands,
     /*  795473 */     // GIR_Coverage, 19378,
     /*  795473 */     GIR_EraseRootFromParent_Done,
     /*  795474 */   // Label 12318: @795474
     /*  795474 */   GIM_Try, /*On fail goto*//*Label 12319*/ GIMT_Encode4(795549), // Rule ID 19379 //
     /*  795479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  795490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  795493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  795496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16),
     /*  795528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795547 */     GIR_RootConstrainSelectedInstOperands,
     /*  795548 */     // GIR_Coverage, 19379,
     /*  795548 */     GIR_EraseRootFromParent_Done,
     /*  795549 */   // Label 12319: @795549
     /*  795549 */   GIM_Try, /*On fail goto*//*Label 12320*/ GIMT_Encode4(795624), // Rule ID 19382 //
     /*  795554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795600 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  795603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795622 */     GIR_RootConstrainSelectedInstOperands,
     /*  795623 */     // GIR_Coverage, 19382,
     /*  795623 */     GIR_EraseRootFromParent_Done,
     /*  795624 */   // Label 12320: @795624
     /*  795624 */   GIM_Try, /*On fail goto*//*Label 12321*/ GIMT_Encode4(795699), // Rule ID 19383 //
     /*  795629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  795640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  795643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  795646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  795664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795675 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16),
     /*  795678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795697 */     GIR_RootConstrainSelectedInstOperands,
     /*  795698 */     // GIR_Coverage, 19383,
     /*  795698 */     GIR_EraseRootFromParent_Done,
     /*  795699 */   // Label 12321: @795699
     /*  795699 */   GIM_Try, /*On fail goto*//*Label 12322*/ GIMT_Encode4(795774), // Rule ID 19386 //
     /*  795704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  795707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  795750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  795753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795772 */     GIR_RootConstrainSelectedInstOperands,
     /*  795773 */     // GIR_Coverage, 19386,
     /*  795773 */     GIR_EraseRootFromParent_Done,
     /*  795774 */   // Label 12322: @795774
     /*  795774 */   GIM_Try, /*On fail goto*//*Label 12323*/ GIMT_Encode4(795849), // Rule ID 19387 //
     /*  795779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  795782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  795790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  795793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  795796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  795799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  795814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  795818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  795825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16),
     /*  795828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  795844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795847 */     GIR_RootConstrainSelectedInstOperands,
     /*  795848 */     // GIR_Coverage, 19387,
     /*  795848 */     GIR_EraseRootFromParent_Done,
     /*  795849 */   // Label 12323: @795849
     /*  795849 */   GIM_Try, /*On fail goto*//*Label 12324*/ GIMT_Encode4(795924), // Rule ID 19390 //
     /*  795854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  795857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  795877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  795900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  795903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795922 */     GIR_RootConstrainSelectedInstOperands,
     /*  795923 */     // GIR_Coverage, 19390,
     /*  795923 */     GIR_EraseRootFromParent_Done,
     /*  795924 */   // Label 12324: @795924
     /*  795924 */   GIM_Try, /*On fail goto*//*Label 12325*/ GIMT_Encode4(795999), // Rule ID 19391 //
     /*  795929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  795932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  795937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  795940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  795943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  795946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  795949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  795952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  795964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  795968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  795975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  795975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32),
     /*  795978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  795980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  795982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  795984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  795986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  795991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  795994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  795997 */     GIR_RootConstrainSelectedInstOperands,
     /*  795998 */     // GIR_Coverage, 19391,
     /*  795998 */     GIR_EraseRootFromParent_Done,
     /*  795999 */   // Label 12325: @795999
     /*  795999 */   GIM_Try, /*On fail goto*//*Label 12326*/ GIMT_Encode4(796074), // Rule ID 19394 //
     /*  796004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796072 */     GIR_RootConstrainSelectedInstOperands,
     /*  796073 */     // GIR_Coverage, 19394,
     /*  796073 */     GIR_EraseRootFromParent_Done,
     /*  796074 */   // Label 12326: @796074
     /*  796074 */   GIM_Try, /*On fail goto*//*Label 12327*/ GIMT_Encode4(796149), // Rule ID 19395 //
     /*  796079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  796090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  796093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  796096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32),
     /*  796128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796147 */     GIR_RootConstrainSelectedInstOperands,
     /*  796148 */     // GIR_Coverage, 19395,
     /*  796148 */     GIR_EraseRootFromParent_Done,
     /*  796149 */   // Label 12327: @796149
     /*  796149 */   GIM_Try, /*On fail goto*//*Label 12328*/ GIMT_Encode4(796224), // Rule ID 19398 //
     /*  796154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  796157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796200 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  796200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796222 */     GIR_RootConstrainSelectedInstOperands,
     /*  796223 */     // GIR_Coverage, 19398,
     /*  796223 */     GIR_EraseRootFromParent_Done,
     /*  796224 */   // Label 12328: @796224
     /*  796224 */   GIM_Try, /*On fail goto*//*Label 12329*/ GIMT_Encode4(796299), // Rule ID 19399 //
     /*  796229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  796232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  796240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  796243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  796246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  796249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  796268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796275 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  796275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32),
     /*  796278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  796294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796297 */     GIR_RootConstrainSelectedInstOperands,
     /*  796298 */     // GIR_Coverage, 19399,
     /*  796298 */     GIR_EraseRootFromParent_Done,
     /*  796299 */   // Label 12329: @796299
     /*  796299 */   GIM_Try, /*On fail goto*//*Label 12330*/ GIMT_Encode4(796374), // Rule ID 19402 //
     /*  796304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796372 */     GIR_RootConstrainSelectedInstOperands,
     /*  796373 */     // GIR_Coverage, 19402,
     /*  796373 */     GIR_EraseRootFromParent_Done,
     /*  796374 */   // Label 12330: @796374
     /*  796374 */   GIM_Try, /*On fail goto*//*Label 12331*/ GIMT_Encode4(796449), // Rule ID 19403 //
     /*  796379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  796390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  796393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  796396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  796414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11196:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64),
     /*  796428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796447 */     GIR_RootConstrainSelectedInstOperands,
     /*  796448 */     // GIR_Coverage, 19403,
     /*  796448 */     GIR_EraseRootFromParent_Done,
     /*  796449 */   // Label 12331: @796449
     /*  796449 */   GIM_Try, /*On fail goto*//*Label 12332*/ GIMT_Encode4(796524), // Rule ID 19406 //
     /*  796454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  796503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796522 */     GIR_RootConstrainSelectedInstOperands,
     /*  796523 */     // GIR_Coverage, 19406,
     /*  796523 */     GIR_EraseRootFromParent_Done,
     /*  796524 */   // Label 12332: @796524
     /*  796524 */   GIM_Try, /*On fail goto*//*Label 12333*/ GIMT_Encode4(796599), // Rule ID 19407 //
     /*  796529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  796540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  796543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  796546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  796564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11196:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64),
     /*  796578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796597 */     GIR_RootConstrainSelectedInstOperands,
     /*  796598 */     // GIR_Coverage, 19407,
     /*  796598 */     GIR_EraseRootFromParent_Done,
     /*  796599 */   // Label 12333: @796599
     /*  796599 */   GIM_Try, /*On fail goto*//*Label 12334*/ GIMT_Encode4(796674), // Rule ID 19410 //
     /*  796604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  796607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  796650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  796653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796672 */     GIR_RootConstrainSelectedInstOperands,
     /*  796673 */     // GIR_Coverage, 19410,
     /*  796673 */     GIR_EraseRootFromParent_Done,
     /*  796674 */   // Label 12334: @796674
     /*  796674 */   GIM_Try, /*On fail goto*//*Label 12335*/ GIMT_Encode4(796749), // Rule ID 19411 //
     /*  796679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  796682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj),
     /*  796687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  796690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  796693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  796696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  796699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  796714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  796718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796725 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11196:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJ_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  796725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64),
     /*  796728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  796744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796747 */     GIR_RootConstrainSelectedInstOperands,
     /*  796748 */     // GIR_Coverage, 19411,
     /*  796748 */     GIR_EraseRootFromParent_Done,
     /*  796749 */   // Label 12335: @796749
     /*  796749 */   GIM_Try, /*On fail goto*//*Label 12336*/ GIMT_Encode4(796824), // Rule ID 19414 //
     /*  796754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  796762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  796803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796822 */     GIR_RootConstrainSelectedInstOperands,
     /*  796823 */     // GIR_Coverage, 19414,
     /*  796823 */     GIR_EraseRootFromParent_Done,
     /*  796824 */   // Label 12336: @796824
     /*  796824 */   GIM_Try, /*On fail goto*//*Label 12337*/ GIMT_Encode4(796899), // Rule ID 19415 //
     /*  796829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  796837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  796840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  796843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  796846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  796849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  796852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796875 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  796875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /*  796878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796897 */     GIR_RootConstrainSelectedInstOperands,
     /*  796898 */     // GIR_Coverage, 19415,
     /*  796898 */     GIR_EraseRootFromParent_Done,
     /*  796899 */   // Label 12337: @796899
     /*  796899 */   GIM_Try, /*On fail goto*//*Label 12338*/ GIMT_Encode4(796974), // Rule ID 19418 //
     /*  796904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  796907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  796912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  796927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  796943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  796950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  796950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  796953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  796955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  796957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  796959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  796961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  796966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  796969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  796972 */     GIR_RootConstrainSelectedInstOperands,
     /*  796973 */     // GIR_Coverage, 19418,
     /*  796973 */     GIR_EraseRootFromParent_Done,
     /*  796974 */   // Label 12338: @796974
     /*  796974 */   GIM_Try, /*On fail goto*//*Label 12339*/ GIMT_Encode4(797049), // Rule ID 19419 //
     /*  796979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  796982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  796987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  796990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  796993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  796996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  796999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797025 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /*  797028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797047 */     GIR_RootConstrainSelectedInstOperands,
     /*  797048 */     // GIR_Coverage, 19419,
     /*  797048 */     GIR_EraseRootFromParent_Done,
     /*  797049 */   // Label 12339: @797049
     /*  797049 */   GIM_Try, /*On fail goto*//*Label 12340*/ GIMT_Encode4(797124), // Rule ID 19422 //
     /*  797054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797100 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797122 */     GIR_RootConstrainSelectedInstOperands,
     /*  797123 */     // GIR_Coverage, 19422,
     /*  797123 */     GIR_EraseRootFromParent_Done,
     /*  797124 */   // Label 12340: @797124
     /*  797124 */   GIM_Try, /*On fail goto*//*Label 12341*/ GIMT_Encode4(797199), // Rule ID 19423 //
     /*  797129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  797140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  797143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  797146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  797149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797175 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /*  797178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797197 */     GIR_RootConstrainSelectedInstOperands,
     /*  797198 */     // GIR_Coverage, 19423,
     /*  797198 */     GIR_EraseRootFromParent_Done,
     /*  797199 */   // Label 12341: @797199
     /*  797199 */   GIM_Try, /*On fail goto*//*Label 12342*/ GIMT_Encode4(797274), // Rule ID 19426 //
     /*  797204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797272 */     GIR_RootConstrainSelectedInstOperands,
     /*  797273 */     // GIR_Coverage, 19426,
     /*  797273 */     GIR_EraseRootFromParent_Done,
     /*  797274 */   // Label 12342: @797274
     /*  797274 */   GIM_Try, /*On fail goto*//*Label 12343*/ GIMT_Encode4(797349), // Rule ID 19427 //
     /*  797279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  797290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  797293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  797296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  797299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797325 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /*  797328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797347 */     GIR_RootConstrainSelectedInstOperands,
     /*  797348 */     // GIR_Coverage, 19427,
     /*  797348 */     GIR_EraseRootFromParent_Done,
     /*  797349 */   // Label 12343: @797349
     /*  797349 */   GIM_Try, /*On fail goto*//*Label 12344*/ GIMT_Encode4(797424), // Rule ID 19430 //
     /*  797354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  797357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  797400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797422 */     GIR_RootConstrainSelectedInstOperands,
     /*  797423 */     // GIR_Coverage, 19430,
     /*  797423 */     GIR_EraseRootFromParent_Done,
     /*  797424 */   // Label 12344: @797424
     /*  797424 */   GIM_Try, /*On fail goto*//*Label 12345*/ GIMT_Encode4(797499), // Rule ID 19431 //
     /*  797429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  797432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  797440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  797443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  797446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  797449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797475 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  797475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /*  797478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  797494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797497 */     GIR_RootConstrainSelectedInstOperands,
     /*  797498 */     // GIR_Coverage, 19431,
     /*  797498 */     GIR_EraseRootFromParent_Done,
     /*  797499 */   // Label 12345: @797499
     /*  797499 */   GIM_Try, /*On fail goto*//*Label 12346*/ GIMT_Encode4(797574), // Rule ID 19434 //
     /*  797504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  797507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  797550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  797553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797572 */     GIR_RootConstrainSelectedInstOperands,
     /*  797573 */     // GIR_Coverage, 19434,
     /*  797573 */     GIR_EraseRootFromParent_Done,
     /*  797574 */   // Label 12346: @797574
     /*  797574 */   GIM_Try, /*On fail goto*//*Label 12347*/ GIMT_Encode4(797649), // Rule ID 19435 //
     /*  797579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  797582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  797590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  797593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  797596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  797599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  797618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797625 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  797625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /*  797628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  797644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797647 */     GIR_RootConstrainSelectedInstOperands,
     /*  797648 */     // GIR_Coverage, 19435,
     /*  797648 */     GIR_EraseRootFromParent_Done,
     /*  797649 */   // Label 12347: @797649
     /*  797649 */   GIM_Try, /*On fail goto*//*Label 12348*/ GIMT_Encode4(797724), // Rule ID 19438 //
     /*  797654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  797703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797722 */     GIR_RootConstrainSelectedInstOperands,
     /*  797723 */     // GIR_Coverage, 19438,
     /*  797723 */     GIR_EraseRootFromParent_Done,
     /*  797724 */   // Label 12348: @797724
     /*  797724 */   GIM_Try, /*On fail goto*//*Label 12349*/ GIMT_Encode4(797799), // Rule ID 19439 //
     /*  797729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  797740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  797743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  797746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  797749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  797768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797775 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /*  797778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797797 */     GIR_RootConstrainSelectedInstOperands,
     /*  797798 */     // GIR_Coverage, 19439,
     /*  797798 */     GIR_EraseRootFromParent_Done,
     /*  797799 */   // Label 12349: @797799
     /*  797799 */   GIM_Try, /*On fail goto*//*Label 12350*/ GIMT_Encode4(797874), // Rule ID 19442 //
     /*  797804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797850 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  797850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  797853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797872 */     GIR_RootConstrainSelectedInstOperands,
     /*  797873 */     // GIR_Coverage, 19442,
     /*  797873 */     GIR_EraseRootFromParent_Done,
     /*  797874 */   // Label 12350: @797874
     /*  797874 */   GIM_Try, /*On fail goto*//*Label 12351*/ GIMT_Encode4(797949), // Rule ID 19443 //
     /*  797879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  797882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  797890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  797893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  797896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  797899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  797902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  797918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  797925 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  797925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /*  797928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  797930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  797932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  797934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  797936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  797941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  797944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  797947 */     GIR_RootConstrainSelectedInstOperands,
     /*  797948 */     // GIR_Coverage, 19443,
     /*  797948 */     GIR_EraseRootFromParent_Done,
     /*  797949 */   // Label 12351: @797949
     /*  797949 */   GIM_Try, /*On fail goto*//*Label 12352*/ GIMT_Encode4(798024), // Rule ID 19446 //
     /*  797954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  797957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  797962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  797965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  797968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  797971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  797974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  797977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  797993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798000 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  798000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798022 */     GIR_RootConstrainSelectedInstOperands,
     /*  798023 */     // GIR_Coverage, 19446,
     /*  798023 */     GIR_EraseRootFromParent_Done,
     /*  798024 */   // Label 12352: @798024
     /*  798024 */   GIM_Try, /*On fail goto*//*Label 12353*/ GIMT_Encode4(798099), // Rule ID 19447 //
     /*  798029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  798032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  798040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  798043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  798046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  798049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798075 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  798075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /*  798078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  798094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798097 */     GIR_RootConstrainSelectedInstOperands,
     /*  798098 */     // GIR_Coverage, 19447,
     /*  798098 */     GIR_EraseRootFromParent_Done,
     /*  798099 */   // Label 12353: @798099
     /*  798099 */   GIM_Try, /*On fail goto*//*Label 12354*/ GIMT_Encode4(798174), // Rule ID 19450 //
     /*  798104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798172 */     GIR_RootConstrainSelectedInstOperands,
     /*  798173 */     // GIR_Coverage, 19450,
     /*  798173 */     GIR_EraseRootFromParent_Done,
     /*  798174 */   // Label 12354: @798174
     /*  798174 */   GIM_Try, /*On fail goto*//*Label 12355*/ GIMT_Encode4(798249), // Rule ID 19451 //
     /*  798179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  798190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  798193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  798196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  798199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /*  798228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798247 */     GIR_RootConstrainSelectedInstOperands,
     /*  798248 */     // GIR_Coverage, 19451,
     /*  798248 */     GIR_EraseRootFromParent_Done,
     /*  798249 */   // Label 12355: @798249
     /*  798249 */   GIM_Try, /*On fail goto*//*Label 12356*/ GIMT_Encode4(798324), // Rule ID 19454 //
     /*  798254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798300 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798322 */     GIR_RootConstrainSelectedInstOperands,
     /*  798323 */     // GIR_Coverage, 19454,
     /*  798323 */     GIR_EraseRootFromParent_Done,
     /*  798324 */   // Label 12356: @798324
     /*  798324 */   GIM_Try, /*On fail goto*//*Label 12357*/ GIMT_Encode4(798399), // Rule ID 19455 //
     /*  798329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  798340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  798343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  798346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  798349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798375 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /*  798378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798397 */     GIR_RootConstrainSelectedInstOperands,
     /*  798398 */     // GIR_Coverage, 19455,
     /*  798398 */     GIR_EraseRootFromParent_Done,
     /*  798399 */   // Label 12357: @798399
     /*  798399 */   GIM_Try, /*On fail goto*//*Label 12358*/ GIMT_Encode4(798474), // Rule ID 19458 //
     /*  798404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  798407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798450 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  798450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  798453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798472 */     GIR_RootConstrainSelectedInstOperands,
     /*  798473 */     // GIR_Coverage, 19458,
     /*  798473 */     GIR_EraseRootFromParent_Done,
     /*  798474 */   // Label 12358: @798474
     /*  798474 */   GIM_Try, /*On fail goto*//*Label 12359*/ GIMT_Encode4(798549), // Rule ID 19459 //
     /*  798479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  798482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  798490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  798493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  798496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  798499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  798525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /*  798528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  798544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798547 */     GIR_RootConstrainSelectedInstOperands,
     /*  798548 */     // GIR_Coverage, 19459,
     /*  798548 */     GIR_EraseRootFromParent_Done,
     /*  798549 */   // Label 12359: @798549
     /*  798549 */   GIM_Try, /*On fail goto*//*Label 12360*/ GIMT_Encode4(798624), // Rule ID 19462 //
     /*  798554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  798603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798622 */     GIR_RootConstrainSelectedInstOperands,
     /*  798623 */     // GIR_Coverage, 19462,
     /*  798623 */     GIR_EraseRootFromParent_Done,
     /*  798624 */   // Label 12360: @798624
     /*  798624 */   GIM_Try, /*On fail goto*//*Label 12361*/ GIMT_Encode4(798699), // Rule ID 19463 //
     /*  798629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  798640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  798643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  798646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  798649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  798668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798675 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /*  798678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798697 */     GIR_RootConstrainSelectedInstOperands,
     /*  798698 */     // GIR_Coverage, 19463,
     /*  798698 */     GIR_EraseRootFromParent_Done,
     /*  798699 */   // Label 12361: @798699
     /*  798699 */   GIM_Try, /*On fail goto*//*Label 12362*/ GIMT_Encode4(798774), // Rule ID 19466 //
     /*  798704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  798753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798772 */     GIR_RootConstrainSelectedInstOperands,
     /*  798773 */     // GIR_Coverage, 19466,
     /*  798773 */     GIR_EraseRootFromParent_Done,
     /*  798774 */   // Label 12362: @798774
     /*  798774 */   GIM_Try, /*On fail goto*//*Label 12363*/ GIMT_Encode4(798849), // Rule ID 19467 //
     /*  798779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  798790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  798793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  798796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  798799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  798818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798825 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /*  798828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798847 */     GIR_RootConstrainSelectedInstOperands,
     /*  798848 */     // GIR_Coverage, 19467,
     /*  798848 */     GIR_EraseRootFromParent_Done,
     /*  798849 */   // Label 12363: @798849
     /*  798849 */   GIM_Try, /*On fail goto*//*Label 12364*/ GIMT_Encode4(798924), // Rule ID 19470 //
     /*  798854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  798857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  798877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  798900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  798903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798922 */     GIR_RootConstrainSelectedInstOperands,
     /*  798923 */     // GIR_Coverage, 19470,
     /*  798923 */     GIR_EraseRootFromParent_Done,
     /*  798924 */   // Label 12364: @798924
     /*  798924 */   GIM_Try, /*On fail goto*//*Label 12365*/ GIMT_Encode4(798999), // Rule ID 19471 //
     /*  798929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  798932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  798937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  798940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  798943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  798946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  798949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  798952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  798968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  798975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  798975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /*  798978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  798980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  798982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  798984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  798986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  798991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  798994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  798997 */     GIR_RootConstrainSelectedInstOperands,
     /*  798998 */     // GIR_Coverage, 19471,
     /*  798998 */     GIR_EraseRootFromParent_Done,
     /*  798999 */   // Label 12365: @798999
     /*  798999 */   GIM_Try, /*On fail goto*//*Label 12366*/ GIMT_Encode4(799074), // Rule ID 19474 //
     /*  799004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799050 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799072 */     GIR_RootConstrainSelectedInstOperands,
     /*  799073 */     // GIR_Coverage, 19474,
     /*  799073 */     GIR_EraseRootFromParent_Done,
     /*  799074 */   // Label 12366: @799074
     /*  799074 */   GIM_Try, /*On fail goto*//*Label 12367*/ GIMT_Encode4(799149), // Rule ID 19475 //
     /*  799079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  799090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  799093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  799096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799125 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16),
     /*  799128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799147 */     GIR_RootConstrainSelectedInstOperands,
     /*  799148 */     // GIR_Coverage, 19475,
     /*  799148 */     GIR_EraseRootFromParent_Done,
     /*  799149 */   // Label 12367: @799149
     /*  799149 */   GIM_Try, /*On fail goto*//*Label 12368*/ GIMT_Encode4(799224), // Rule ID 19478 //
     /*  799154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799200 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799222 */     GIR_RootConstrainSelectedInstOperands,
     /*  799223 */     // GIR_Coverage, 19478,
     /*  799223 */     GIR_EraseRootFromParent_Done,
     /*  799224 */   // Label 12368: @799224
     /*  799224 */   GIM_Try, /*On fail goto*//*Label 12369*/ GIMT_Encode4(799299), // Rule ID 19479 //
     /*  799229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  799240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  799243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  799246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799275 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16),
     /*  799278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799297 */     GIR_RootConstrainSelectedInstOperands,
     /*  799298 */     // GIR_Coverage, 19479,
     /*  799298 */     GIR_EraseRootFromParent_Done,
     /*  799299 */   // Label 12369: @799299
     /*  799299 */   GIM_Try, /*On fail goto*//*Label 12370*/ GIMT_Encode4(799374), // Rule ID 19482 //
     /*  799304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799372 */     GIR_RootConstrainSelectedInstOperands,
     /*  799373 */     // GIR_Coverage, 19482,
     /*  799373 */     GIR_EraseRootFromParent_Done,
     /*  799374 */   // Label 12370: @799374
     /*  799374 */   GIM_Try, /*On fail goto*//*Label 12371*/ GIMT_Encode4(799449), // Rule ID 19483 //
     /*  799379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  799390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  799393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  799396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799425 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32),
     /*  799428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799447 */     GIR_RootConstrainSelectedInstOperands,
     /*  799448 */     // GIR_Coverage, 19483,
     /*  799448 */     GIR_EraseRootFromParent_Done,
     /*  799449 */   // Label 12371: @799449
     /*  799449 */   GIM_Try, /*On fail goto*//*Label 12372*/ GIMT_Encode4(799524), // Rule ID 19486 //
     /*  799454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799500 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  799503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799522 */     GIR_RootConstrainSelectedInstOperands,
     /*  799523 */     // GIR_Coverage, 19486,
     /*  799523 */     GIR_EraseRootFromParent_Done,
     /*  799524 */   // Label 12372: @799524
     /*  799524 */   GIM_Try, /*On fail goto*//*Label 12373*/ GIMT_Encode4(799599), // Rule ID 19487 //
     /*  799529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  799540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  799543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  799546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799575 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11198:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  799575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16),
     /*  799578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799597 */     GIR_RootConstrainSelectedInstOperands,
     /*  799598 */     // GIR_Coverage, 19487,
     /*  799598 */     GIR_EraseRootFromParent_Done,
     /*  799599 */   // Label 12373: @799599
     /*  799599 */   GIM_Try, /*On fail goto*//*Label 12374*/ GIMT_Encode4(799674), // Rule ID 19490 //
     /*  799604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  799607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799650 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  799650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  799653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799672 */     GIR_RootConstrainSelectedInstOperands,
     /*  799673 */     // GIR_Coverage, 19490,
     /*  799673 */     GIR_EraseRootFromParent_Done,
     /*  799674 */   // Label 12374: @799674
     /*  799674 */   GIM_Try, /*On fail goto*//*Label 12375*/ GIMT_Encode4(799749), // Rule ID 19491 //
     /*  799679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  799682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  799690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  799693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  799696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  799699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  799718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799725 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11198:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  799725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32),
     /*  799728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  799744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799747 */     GIR_RootConstrainSelectedInstOperands,
     /*  799748 */     // GIR_Coverage, 19491,
     /*  799748 */     GIR_EraseRootFromParent_Done,
     /*  799749 */   // Label 12375: @799749
     /*  799749 */   GIM_Try, /*On fail goto*//*Label 12376*/ GIMT_Encode4(799824), // Rule ID 19494 //
     /*  799754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  799757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  799800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  799803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799822 */     GIR_RootConstrainSelectedInstOperands,
     /*  799823 */     // GIR_Coverage, 19494,
     /*  799823 */     GIR_EraseRootFromParent_Done,
     /*  799824 */   // Label 12376: @799824
     /*  799824 */   GIM_Try, /*On fail goto*//*Label 12377*/ GIMT_Encode4(799899), // Rule ID 19495 //
     /*  799829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  799832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  799840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  799843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  799846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  799849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  799852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  799864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  799868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799875 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11198:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  799875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64),
     /*  799878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  799894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799897 */     GIR_RootConstrainSelectedInstOperands,
     /*  799898 */     // GIR_Coverage, 19495,
     /*  799898 */     GIR_EraseRootFromParent_Done,
     /*  799899 */   // Label 12377: @799899
     /*  799899 */   GIM_Try, /*On fail goto*//*Label 12378*/ GIMT_Encode4(799974), // Rule ID 19498 //
     /*  799904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  799907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  799927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  799939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  799943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  799950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  799950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  799953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  799955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  799957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  799959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  799961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  799966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  799969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  799972 */     GIR_RootConstrainSelectedInstOperands,
     /*  799973 */     // GIR_Coverage, 19498,
     /*  799973 */     GIR_EraseRootFromParent_Done,
     /*  799974 */   // Label 12378: @799974
     /*  799974 */   GIM_Try, /*On fail goto*//*Label 12379*/ GIMT_Encode4(800049), // Rule ID 19499 //
     /*  799979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  799982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  799987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  799990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  799993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  799996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  799999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800025 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16),
     /*  800028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800047 */     GIR_RootConstrainSelectedInstOperands,
     /*  800048 */     // GIR_Coverage, 19499,
     /*  800048 */     GIR_EraseRootFromParent_Done,
     /*  800049 */   // Label 12379: @800049
     /*  800049 */   GIM_Try, /*On fail goto*//*Label 12380*/ GIMT_Encode4(800124), // Rule ID 19502 //
     /*  800054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800100 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800122 */     GIR_RootConstrainSelectedInstOperands,
     /*  800123 */     // GIR_Coverage, 19502,
     /*  800123 */     GIR_EraseRootFromParent_Done,
     /*  800124 */   // Label 12380: @800124
     /*  800124 */   GIM_Try, /*On fail goto*//*Label 12381*/ GIMT_Encode4(800199), // Rule ID 19503 //
     /*  800129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  800140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  800143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  800146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800175 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16),
     /*  800178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800197 */     GIR_RootConstrainSelectedInstOperands,
     /*  800198 */     // GIR_Coverage, 19503,
     /*  800198 */     GIR_EraseRootFromParent_Done,
     /*  800199 */   // Label 12381: @800199
     /*  800199 */   GIM_Try, /*On fail goto*//*Label 12382*/ GIMT_Encode4(800274), // Rule ID 19506 //
     /*  800204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  800207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  800250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800272 */     GIR_RootConstrainSelectedInstOperands,
     /*  800273 */     // GIR_Coverage, 19506,
     /*  800273 */     GIR_EraseRootFromParent_Done,
     /*  800274 */   // Label 12382: @800274
     /*  800274 */   GIM_Try, /*On fail goto*//*Label 12383*/ GIMT_Encode4(800349), // Rule ID 19507 //
     /*  800279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  800282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  800290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  800293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  800296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  800299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  800318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800325 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  800325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16),
     /*  800328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  800344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800347 */     GIR_RootConstrainSelectedInstOperands,
     /*  800348 */     // GIR_Coverage, 19507,
     /*  800348 */     GIR_EraseRootFromParent_Done,
     /*  800349 */   // Label 12383: @800349
     /*  800349 */   GIM_Try, /*On fail goto*//*Label 12384*/ GIMT_Encode4(800424), // Rule ID 19510 //
     /*  800354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800400 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800422 */     GIR_RootConstrainSelectedInstOperands,
     /*  800423 */     // GIR_Coverage, 19510,
     /*  800423 */     GIR_EraseRootFromParent_Done,
     /*  800424 */   // Label 12384: @800424
     /*  800424 */   GIM_Try, /*On fail goto*//*Label 12385*/ GIMT_Encode4(800499), // Rule ID 19511 //
     /*  800429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  800440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  800443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  800446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800475 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32),
     /*  800478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800497 */     GIR_RootConstrainSelectedInstOperands,
     /*  800498 */     // GIR_Coverage, 19511,
     /*  800498 */     GIR_EraseRootFromParent_Done,
     /*  800499 */   // Label 12385: @800499
     /*  800499 */   GIM_Try, /*On fail goto*//*Label 12386*/ GIMT_Encode4(800574), // Rule ID 19514 //
     /*  800504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800550 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  800553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800572 */     GIR_RootConstrainSelectedInstOperands,
     /*  800573 */     // GIR_Coverage, 19514,
     /*  800573 */     GIR_EraseRootFromParent_Done,
     /*  800574 */   // Label 12386: @800574
     /*  800574 */   GIM_Try, /*On fail goto*//*Label 12387*/ GIMT_Encode4(800649), // Rule ID 19515 //
     /*  800579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  800590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  800593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  800596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800625 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32),
     /*  800628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800647 */     GIR_RootConstrainSelectedInstOperands,
     /*  800648 */     // GIR_Coverage, 19515,
     /*  800648 */     GIR_EraseRootFromParent_Done,
     /*  800649 */   // Label 12387: @800649
     /*  800649 */   GIM_Try, /*On fail goto*//*Label 12388*/ GIMT_Encode4(800724), // Rule ID 19518 //
     /*  800654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  800657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800700 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  800700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  800703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800722 */     GIR_RootConstrainSelectedInstOperands,
     /*  800723 */     // GIR_Coverage, 19518,
     /*  800723 */     GIR_EraseRootFromParent_Done,
     /*  800724 */   // Label 12388: @800724
     /*  800724 */   GIM_Try, /*On fail goto*//*Label 12389*/ GIMT_Encode4(800799), // Rule ID 19519 //
     /*  800729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  800732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  800740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  800743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  800746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  800749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  800764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  800768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800775 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  800775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32),
     /*  800778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  800794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800797 */     GIR_RootConstrainSelectedInstOperands,
     /*  800798 */     // GIR_Coverage, 19519,
     /*  800798 */     GIR_EraseRootFromParent_Done,
     /*  800799 */   // Label 12389: @800799
     /*  800799 */   GIM_Try, /*On fail goto*//*Label 12390*/ GIMT_Encode4(800874), // Rule ID 19522 //
     /*  800804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800850 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  800850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  800853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800872 */     GIR_RootConstrainSelectedInstOperands,
     /*  800873 */     // GIR_Coverage, 19522,
     /*  800873 */     GIR_EraseRootFromParent_Done,
     /*  800874 */   // Label 12390: @800874
     /*  800874 */   GIM_Try, /*On fail goto*//*Label 12391*/ GIMT_Encode4(800949), // Rule ID 19523 //
     /*  800879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  800882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  800890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  800893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  800896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  800902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  800914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  800925 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11198:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  800925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64),
     /*  800928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  800930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  800932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  800934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  800936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  800941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  800944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  800947 */     GIR_RootConstrainSelectedInstOperands,
     /*  800948 */     // GIR_Coverage, 19523,
     /*  800948 */     GIR_EraseRootFromParent_Done,
     /*  800949 */   // Label 12391: @800949
     /*  800949 */   GIM_Try, /*On fail goto*//*Label 12392*/ GIMT_Encode4(801024), // Rule ID 19526 //
     /*  800954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  800957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  800962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  800965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  800968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  800971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  800974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  800977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  800989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  800993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801000 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801022 */     GIR_RootConstrainSelectedInstOperands,
     /*  801023 */     // GIR_Coverage, 19526,
     /*  801023 */     GIR_EraseRootFromParent_Done,
     /*  801024 */   // Label 12392: @801024
     /*  801024 */   GIM_Try, /*On fail goto*//*Label 12393*/ GIMT_Encode4(801099), // Rule ID 19527 //
     /*  801029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  801040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  801043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  801046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  801064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801075 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11198:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64),
     /*  801078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801097 */     GIR_RootConstrainSelectedInstOperands,
     /*  801098 */     // GIR_Coverage, 19527,
     /*  801098 */     GIR_EraseRootFromParent_Done,
     /*  801099 */   // Label 12393: @801099
     /*  801099 */   GIM_Try, /*On fail goto*//*Label 12394*/ GIMT_Encode4(801174), // Rule ID 19530 //
     /*  801104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  801107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801150 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  801150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801172 */     GIR_RootConstrainSelectedInstOperands,
     /*  801173 */     // GIR_Coverage, 19530,
     /*  801173 */     GIR_EraseRootFromParent_Done,
     /*  801174 */   // Label 12394: @801174
     /*  801174 */   GIM_Try, /*On fail goto*//*Label 12395*/ GIMT_Encode4(801249), // Rule ID 19531 //
     /*  801179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  801182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn),
     /*  801187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  801190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  801193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  801196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  801199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  801214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  801218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801225 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11198:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJN_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  801225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64),
     /*  801228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  801244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801247 */     GIR_RootConstrainSelectedInstOperands,
     /*  801248 */     // GIR_Coverage, 19531,
     /*  801248 */     GIR_EraseRootFromParent_Done,
     /*  801249 */   // Label 12395: @801249
     /*  801249 */   GIM_Try, /*On fail goto*//*Label 12396*/ GIMT_Encode4(801324), // Rule ID 19534 //
     /*  801254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801322 */     GIR_RootConstrainSelectedInstOperands,
     /*  801323 */     // GIR_Coverage, 19534,
     /*  801323 */     GIR_EraseRootFromParent_Done,
     /*  801324 */   // Label 12396: @801324
     /*  801324 */   GIM_Try, /*On fail goto*//*Label 12397*/ GIMT_Encode4(801399), // Rule ID 19535 //
     /*  801329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  801340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  801343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  801346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  801349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801375 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /*  801378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801397 */     GIR_RootConstrainSelectedInstOperands,
     /*  801398 */     // GIR_Coverage, 19535,
     /*  801398 */     GIR_EraseRootFromParent_Done,
     /*  801399 */   // Label 12397: @801399
     /*  801399 */   GIM_Try, /*On fail goto*//*Label 12398*/ GIMT_Encode4(801474), // Rule ID 19538 //
     /*  801404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  801453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801472 */     GIR_RootConstrainSelectedInstOperands,
     /*  801473 */     // GIR_Coverage, 19538,
     /*  801473 */     GIR_EraseRootFromParent_Done,
     /*  801474 */   // Label 12398: @801474
     /*  801474 */   GIM_Try, /*On fail goto*//*Label 12399*/ GIMT_Encode4(801549), // Rule ID 19539 //
     /*  801479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  801490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  801493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  801496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  801499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /*  801528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801547 */     GIR_RootConstrainSelectedInstOperands,
     /*  801548 */     // GIR_Coverage, 19539,
     /*  801548 */     GIR_EraseRootFromParent_Done,
     /*  801549 */   // Label 12399: @801549
     /*  801549 */   GIM_Try, /*On fail goto*//*Label 12400*/ GIMT_Encode4(801624), // Rule ID 19542 //
     /*  801554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  801603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801622 */     GIR_RootConstrainSelectedInstOperands,
     /*  801623 */     // GIR_Coverage, 19542,
     /*  801623 */     GIR_EraseRootFromParent_Done,
     /*  801624 */   // Label 12400: @801624
     /*  801624 */   GIM_Try, /*On fail goto*//*Label 12401*/ GIMT_Encode4(801699), // Rule ID 19543 //
     /*  801629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  801640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  801643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  801646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  801649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /*  801678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801697 */     GIR_RootConstrainSelectedInstOperands,
     /*  801698 */     // GIR_Coverage, 19543,
     /*  801698 */     GIR_EraseRootFromParent_Done,
     /*  801699 */   // Label 12401: @801699
     /*  801699 */   GIM_Try, /*On fail goto*//*Label 12402*/ GIMT_Encode4(801774), // Rule ID 19546 //
     /*  801704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  801707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  801750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  801753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801772 */     GIR_RootConstrainSelectedInstOperands,
     /*  801773 */     // GIR_Coverage, 19546,
     /*  801773 */     GIR_EraseRootFromParent_Done,
     /*  801774 */   // Label 12402: @801774
     /*  801774 */   GIM_Try, /*On fail goto*//*Label 12403*/ GIMT_Encode4(801849), // Rule ID 19547 //
     /*  801779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  801782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  801790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  801793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  801796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  801799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801825 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  801825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /*  801828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  801844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801847 */     GIR_RootConstrainSelectedInstOperands,
     /*  801848 */     // GIR_Coverage, 19547,
     /*  801848 */     GIR_EraseRootFromParent_Done,
     /*  801849 */   // Label 12403: @801849
     /*  801849 */   GIM_Try, /*On fail goto*//*Label 12404*/ GIMT_Encode4(801924), // Rule ID 19550 //
     /*  801854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  801857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  801877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  801900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  801903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801922 */     GIR_RootConstrainSelectedInstOperands,
     /*  801923 */     // GIR_Coverage, 19550,
     /*  801923 */     GIR_EraseRootFromParent_Done,
     /*  801924 */   // Label 12404: @801924
     /*  801924 */   GIM_Try, /*On fail goto*//*Label 12405*/ GIMT_Encode4(801999), // Rule ID 19551 //
     /*  801929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  801932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  801937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  801940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  801943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  801946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  801949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  801952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  801968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  801975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  801975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /*  801978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  801980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  801982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  801984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  801986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  801991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  801994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  801997 */     GIR_RootConstrainSelectedInstOperands,
     /*  801998 */     // GIR_Coverage, 19551,
     /*  801998 */     GIR_EraseRootFromParent_Done,
     /*  801999 */   // Label 12405: @801999
     /*  801999 */   GIM_Try, /*On fail goto*//*Label 12406*/ GIMT_Encode4(802074), // Rule ID 19554 //
     /*  802004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  802007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  802050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802072 */     GIR_RootConstrainSelectedInstOperands,
     /*  802073 */     // GIR_Coverage, 19554,
     /*  802073 */     GIR_EraseRootFromParent_Done,
     /*  802074 */   // Label 12406: @802074
     /*  802074 */   GIM_Try, /*On fail goto*//*Label 12407*/ GIMT_Encode4(802149), // Rule ID 19555 //
     /*  802079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  802082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  802090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  802093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  802096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  802099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  802118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802125 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  802125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /*  802128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  802144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802147 */     GIR_RootConstrainSelectedInstOperands,
     /*  802148 */     // GIR_Coverage, 19555,
     /*  802148 */     GIR_EraseRootFromParent_Done,
     /*  802149 */   // Label 12407: @802149
     /*  802149 */   GIM_Try, /*On fail goto*//*Label 12408*/ GIMT_Encode4(802224), // Rule ID 19558 //
     /*  802154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802222 */     GIR_RootConstrainSelectedInstOperands,
     /*  802223 */     // GIR_Coverage, 19558,
     /*  802223 */     GIR_EraseRootFromParent_Done,
     /*  802224 */   // Label 12408: @802224
     /*  802224 */   GIM_Try, /*On fail goto*//*Label 12409*/ GIMT_Encode4(802299), // Rule ID 19559 //
     /*  802229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  802240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  802243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  802246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  802249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /*  802278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802297 */     GIR_RootConstrainSelectedInstOperands,
     /*  802298 */     // GIR_Coverage, 19559,
     /*  802298 */     GIR_EraseRootFromParent_Done,
     /*  802299 */   // Label 12409: @802299
     /*  802299 */   GIM_Try, /*On fail goto*//*Label 12410*/ GIMT_Encode4(802374), // Rule ID 19562 //
     /*  802304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802372 */     GIR_RootConstrainSelectedInstOperands,
     /*  802373 */     // GIR_Coverage, 19562,
     /*  802373 */     GIR_EraseRootFromParent_Done,
     /*  802374 */   // Label 12410: @802374
     /*  802374 */   GIM_Try, /*On fail goto*//*Label 12411*/ GIMT_Encode4(802449), // Rule ID 19563 //
     /*  802379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  802390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  802393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  802396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  802399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /*  802428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802447 */     GIR_RootConstrainSelectedInstOperands,
     /*  802448 */     // GIR_Coverage, 19563,
     /*  802448 */     GIR_EraseRootFromParent_Done,
     /*  802449 */   // Label 12411: @802449
     /*  802449 */   GIM_Try, /*On fail goto*//*Label 12412*/ GIMT_Encode4(802524), // Rule ID 19566 //
     /*  802454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  802457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802500 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  802500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  802503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802522 */     GIR_RootConstrainSelectedInstOperands,
     /*  802523 */     // GIR_Coverage, 19566,
     /*  802523 */     GIR_EraseRootFromParent_Done,
     /*  802524 */   // Label 12412: @802524
     /*  802524 */   GIM_Try, /*On fail goto*//*Label 12413*/ GIMT_Encode4(802599), // Rule ID 19567 //
     /*  802529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  802532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  802540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  802543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  802546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  802549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802575 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  802575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /*  802578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  802594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802597 */     GIR_RootConstrainSelectedInstOperands,
     /*  802598 */     // GIR_Coverage, 19567,
     /*  802598 */     GIR_EraseRootFromParent_Done,
     /*  802599 */   // Label 12413: @802599
     /*  802599 */   GIM_Try, /*On fail goto*//*Label 12414*/ GIMT_Encode4(802674), // Rule ID 19570 //
     /*  802604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  802653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802672 */     GIR_RootConstrainSelectedInstOperands,
     /*  802673 */     // GIR_Coverage, 19570,
     /*  802673 */     GIR_EraseRootFromParent_Done,
     /*  802674 */   // Label 12414: @802674
     /*  802674 */   GIM_Try, /*On fail goto*//*Label 12415*/ GIMT_Encode4(802749), // Rule ID 19571 //
     /*  802679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  802690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  802693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  802696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  802699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  802718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /*  802728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802747 */     GIR_RootConstrainSelectedInstOperands,
     /*  802748 */     // GIR_Coverage, 19571,
     /*  802748 */     GIR_EraseRootFromParent_Done,
     /*  802749 */   // Label 12415: @802749
     /*  802749 */   GIM_Try, /*On fail goto*//*Label 12416*/ GIMT_Encode4(802824), // Rule ID 19574 //
     /*  802754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802800 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  802803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802822 */     GIR_RootConstrainSelectedInstOperands,
     /*  802823 */     // GIR_Coverage, 19574,
     /*  802823 */     GIR_EraseRootFromParent_Done,
     /*  802824 */   // Label 12416: @802824
     /*  802824 */   GIM_Try, /*On fail goto*//*Label 12417*/ GIMT_Encode4(802899), // Rule ID 19575 //
     /*  802829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  802840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  802843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  802846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  802849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  802852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  802868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802875 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  802875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /*  802878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802897 */     GIR_RootConstrainSelectedInstOperands,
     /*  802898 */     // GIR_Coverage, 19575,
     /*  802898 */     GIR_EraseRootFromParent_Done,
     /*  802899 */   // Label 12417: @802899
     /*  802899 */   GIM_Try, /*On fail goto*//*Label 12418*/ GIMT_Encode4(802974), // Rule ID 19578 //
     /*  802904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  802907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  802927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  802943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  802950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  802950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  802953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  802955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  802957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  802959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  802961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  802966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  802969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  802972 */     GIR_RootConstrainSelectedInstOperands,
     /*  802973 */     // GIR_Coverage, 19578,
     /*  802973 */     GIR_EraseRootFromParent_Done,
     /*  802974 */   // Label 12418: @802974
     /*  802974 */   GIM_Try, /*On fail goto*//*Label 12419*/ GIMT_Encode4(803049), // Rule ID 19579 //
     /*  802979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  802982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  802987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  802990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  802993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  802996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  802999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803025 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /*  803028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803047 */     GIR_RootConstrainSelectedInstOperands,
     /*  803048 */     // GIR_Coverage, 19579,
     /*  803048 */     GIR_EraseRootFromParent_Done,
     /*  803049 */   // Label 12419: @803049
     /*  803049 */   GIM_Try, /*On fail goto*//*Label 12420*/ GIMT_Encode4(803124), // Rule ID 19582 //
     /*  803054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803122 */     GIR_RootConstrainSelectedInstOperands,
     /*  803123 */     // GIR_Coverage, 19582,
     /*  803123 */     GIR_EraseRootFromParent_Done,
     /*  803124 */   // Label 12420: @803124
     /*  803124 */   GIM_Try, /*On fail goto*//*Label 12421*/ GIMT_Encode4(803199), // Rule ID 19583 //
     /*  803129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  803140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  803143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  803146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  803149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  803168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /*  803178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803197 */     GIR_RootConstrainSelectedInstOperands,
     /*  803198 */     // GIR_Coverage, 19583,
     /*  803198 */     GIR_EraseRootFromParent_Done,
     /*  803199 */   // Label 12421: @803199
     /*  803199 */   GIM_Try, /*On fail goto*//*Label 12422*/ GIMT_Encode4(803274), // Rule ID 19586 //
     /*  803204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803272 */     GIR_RootConstrainSelectedInstOperands,
     /*  803273 */     // GIR_Coverage, 19586,
     /*  803273 */     GIR_EraseRootFromParent_Done,
     /*  803274 */   // Label 12422: @803274
     /*  803274 */   GIM_Try, /*On fail goto*//*Label 12423*/ GIMT_Encode4(803349), // Rule ID 19587 //
     /*  803279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  803290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  803293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  803296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  803299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  803318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /*  803328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803347 */     GIR_RootConstrainSelectedInstOperands,
     /*  803348 */     // GIR_Coverage, 19587,
     /*  803348 */     GIR_EraseRootFromParent_Done,
     /*  803349 */   // Label 12423: @803349
     /*  803349 */   GIM_Try, /*On fail goto*//*Label 12424*/ GIMT_Encode4(803424), // Rule ID 19590 //
     /*  803354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  803357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803400 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  803400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803422 */     GIR_RootConstrainSelectedInstOperands,
     /*  803423 */     // GIR_Coverage, 19590,
     /*  803423 */     GIR_EraseRootFromParent_Done,
     /*  803424 */   // Label 12424: @803424
     /*  803424 */   GIM_Try, /*On fail goto*//*Label 12425*/ GIMT_Encode4(803499), // Rule ID 19591 //
     /*  803429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  803432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  803440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  803443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  803446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  803449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  803468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803475 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  803475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /*  803478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  803494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803497 */     GIR_RootConstrainSelectedInstOperands,
     /*  803498 */     // GIR_Coverage, 19591,
     /*  803498 */     GIR_EraseRootFromParent_Done,
     /*  803499 */   // Label 12425: @803499
     /*  803499 */   GIM_Try, /*On fail goto*//*Label 12426*/ GIMT_Encode4(803574), // Rule ID 19594 //
     /*  803504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803550 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  803553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803572 */     GIR_RootConstrainSelectedInstOperands,
     /*  803573 */     // GIR_Coverage, 19594,
     /*  803573 */     GIR_EraseRootFromParent_Done,
     /*  803574 */   // Label 12426: @803574
     /*  803574 */   GIM_Try, /*On fail goto*//*Label 12427*/ GIMT_Encode4(803649), // Rule ID 19595 //
     /*  803579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  803590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  803593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  803596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803625 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16),
     /*  803628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803647 */     GIR_RootConstrainSelectedInstOperands,
     /*  803648 */     // GIR_Coverage, 19595,
     /*  803648 */     GIR_EraseRootFromParent_Done,
     /*  803649 */   // Label 12427: @803649
     /*  803649 */   GIM_Try, /*On fail goto*//*Label 12428*/ GIMT_Encode4(803724), // Rule ID 19598 //
     /*  803654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  803700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  803703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803722 */     GIR_RootConstrainSelectedInstOperands,
     /*  803723 */     // GIR_Coverage, 19598,
     /*  803723 */     GIR_EraseRootFromParent_Done,
     /*  803724 */   // Label 12428: @803724
     /*  803724 */   GIM_Try, /*On fail goto*//*Label 12429*/ GIMT_Encode4(803799), // Rule ID 19599 //
     /*  803729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  803732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  803740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  803743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  803746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803775 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  803775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16),
     /*  803778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  803794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803797 */     GIR_RootConstrainSelectedInstOperands,
     /*  803798 */     // GIR_Coverage, 19599,
     /*  803798 */     GIR_EraseRootFromParent_Done,
     /*  803799 */   // Label 12429: @803799
     /*  803799 */   GIM_Try, /*On fail goto*//*Label 12430*/ GIMT_Encode4(803874), // Rule ID 19602 //
     /*  803804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  803807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  803850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  803853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803872 */     GIR_RootConstrainSelectedInstOperands,
     /*  803873 */     // GIR_Coverage, 19602,
     /*  803873 */     GIR_EraseRootFromParent_Done,
     /*  803874 */   // Label 12430: @803874
     /*  803874 */   GIM_Try, /*On fail goto*//*Label 12431*/ GIMT_Encode4(803949), // Rule ID 19603 //
     /*  803879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  803882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  803890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  803893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  803896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  803899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  803902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  803918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  803925 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  803925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32),
     /*  803928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  803930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  803932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  803934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  803936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  803941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  803944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  803947 */     GIR_RootConstrainSelectedInstOperands,
     /*  803948 */     // GIR_Coverage, 19603,
     /*  803948 */     GIR_EraseRootFromParent_Done,
     /*  803949 */   // Label 12431: @803949
     /*  803949 */   GIM_Try, /*On fail goto*//*Label 12432*/ GIMT_Encode4(804024), // Rule ID 19606 //
     /*  803954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  803957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  803962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  803965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  803968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  803971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  803974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  803977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  803989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  803993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804022 */     GIR_RootConstrainSelectedInstOperands,
     /*  804023 */     // GIR_Coverage, 19606,
     /*  804023 */     GIR_EraseRootFromParent_Done,
     /*  804024 */   // Label 12432: @804024
     /*  804024 */   GIM_Try, /*On fail goto*//*Label 12433*/ GIMT_Encode4(804099), // Rule ID 19607 //
     /*  804029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  804040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  804043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  804046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804075 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11200:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16),
     /*  804078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804097 */     GIR_RootConstrainSelectedInstOperands,
     /*  804098 */     // GIR_Coverage, 19607,
     /*  804098 */     GIR_EraseRootFromParent_Done,
     /*  804099 */   // Label 12433: @804099
     /*  804099 */   GIM_Try, /*On fail goto*//*Label 12434*/ GIMT_Encode4(804174), // Rule ID 19610 //
     /*  804104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804172 */     GIR_RootConstrainSelectedInstOperands,
     /*  804173 */     // GIR_Coverage, 19610,
     /*  804173 */     GIR_EraseRootFromParent_Done,
     /*  804174 */   // Label 12434: @804174
     /*  804174 */   GIM_Try, /*On fail goto*//*Label 12435*/ GIMT_Encode4(804249), // Rule ID 19611 //
     /*  804179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  804190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  804193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  804196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804225 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11200:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32),
     /*  804228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804247 */     GIR_RootConstrainSelectedInstOperands,
     /*  804248 */     // GIR_Coverage, 19611,
     /*  804248 */     GIR_EraseRootFromParent_Done,
     /*  804249 */   // Label 12435: @804249
     /*  804249 */   GIM_Try, /*On fail goto*//*Label 12436*/ GIMT_Encode4(804324), // Rule ID 19614 //
     /*  804254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  804257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  804300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804322 */     GIR_RootConstrainSelectedInstOperands,
     /*  804323 */     // GIR_Coverage, 19614,
     /*  804323 */     GIR_EraseRootFromParent_Done,
     /*  804324 */   // Label 12436: @804324
     /*  804324 */   GIM_Try, /*On fail goto*//*Label 12437*/ GIMT_Encode4(804399), // Rule ID 19615 //
     /*  804329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  804332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  804340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  804343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  804346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  804349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  804364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  804368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11200:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  804375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64),
     /*  804378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  804394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804397 */     GIR_RootConstrainSelectedInstOperands,
     /*  804398 */     // GIR_Coverage, 19615,
     /*  804398 */     GIR_EraseRootFromParent_Done,
     /*  804399 */   // Label 12437: @804399
     /*  804399 */   GIM_Try, /*On fail goto*//*Label 12438*/ GIMT_Encode4(804474), // Rule ID 19618 //
     /*  804404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  804453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804472 */     GIR_RootConstrainSelectedInstOperands,
     /*  804473 */     // GIR_Coverage, 19618,
     /*  804473 */     GIR_EraseRootFromParent_Done,
     /*  804474 */   // Label 12438: @804474
     /*  804474 */   GIM_Try, /*On fail goto*//*Label 12439*/ GIMT_Encode4(804549), // Rule ID 19619 //
     /*  804479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  804490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  804493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  804496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16),
     /*  804528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804547 */     GIR_RootConstrainSelectedInstOperands,
     /*  804548 */     // GIR_Coverage, 19619,
     /*  804548 */     GIR_EraseRootFromParent_Done,
     /*  804549 */   // Label 12439: @804549
     /*  804549 */   GIM_Try, /*On fail goto*//*Label 12440*/ GIMT_Encode4(804624), // Rule ID 19622 //
     /*  804554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804600 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  804603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804622 */     GIR_RootConstrainSelectedInstOperands,
     /*  804623 */     // GIR_Coverage, 19622,
     /*  804623 */     GIR_EraseRootFromParent_Done,
     /*  804624 */   // Label 12440: @804624
     /*  804624 */   GIM_Try, /*On fail goto*//*Label 12441*/ GIMT_Encode4(804699), // Rule ID 19623 //
     /*  804629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  804640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  804643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  804646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  804664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804675 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16),
     /*  804678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804697 */     GIR_RootConstrainSelectedInstOperands,
     /*  804698 */     // GIR_Coverage, 19623,
     /*  804698 */     GIR_EraseRootFromParent_Done,
     /*  804699 */   // Label 12441: @804699
     /*  804699 */   GIM_Try, /*On fail goto*//*Label 12442*/ GIMT_Encode4(804774), // Rule ID 19626 //
     /*  804704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  804707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  804750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  804753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804772 */     GIR_RootConstrainSelectedInstOperands,
     /*  804773 */     // GIR_Coverage, 19626,
     /*  804773 */     GIR_EraseRootFromParent_Done,
     /*  804774 */   // Label 12442: @804774
     /*  804774 */   GIM_Try, /*On fail goto*//*Label 12443*/ GIMT_Encode4(804849), // Rule ID 19627 //
     /*  804779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  804782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  804790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  804793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  804796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  804799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  804814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  804818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  804825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16),
     /*  804828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  804844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804847 */     GIR_RootConstrainSelectedInstOperands,
     /*  804848 */     // GIR_Coverage, 19627,
     /*  804848 */     GIR_EraseRootFromParent_Done,
     /*  804849 */   // Label 12443: @804849
     /*  804849 */   GIM_Try, /*On fail goto*//*Label 12444*/ GIMT_Encode4(804924), // Rule ID 19630 //
     /*  804854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  804857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  804877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  804900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  804903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804922 */     GIR_RootConstrainSelectedInstOperands,
     /*  804923 */     // GIR_Coverage, 19630,
     /*  804923 */     GIR_EraseRootFromParent_Done,
     /*  804924 */   // Label 12444: @804924
     /*  804924 */   GIM_Try, /*On fail goto*//*Label 12445*/ GIMT_Encode4(804999), // Rule ID 19631 //
     /*  804929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  804932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  804937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  804940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  804943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  804946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  804949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  804952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  804964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  804968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  804975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  804975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32),
     /*  804978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  804980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  804982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  804984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  804986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  804991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  804994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  804997 */     GIR_RootConstrainSelectedInstOperands,
     /*  804998 */     // GIR_Coverage, 19631,
     /*  804998 */     GIR_EraseRootFromParent_Done,
     /*  804999 */   // Label 12445: @804999
     /*  804999 */   GIM_Try, /*On fail goto*//*Label 12446*/ GIMT_Encode4(805074), // Rule ID 19634 //
     /*  805004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805072 */     GIR_RootConstrainSelectedInstOperands,
     /*  805073 */     // GIR_Coverage, 19634,
     /*  805073 */     GIR_EraseRootFromParent_Done,
     /*  805074 */   // Label 12446: @805074
     /*  805074 */   GIM_Try, /*On fail goto*//*Label 12447*/ GIMT_Encode4(805149), // Rule ID 19635 //
     /*  805079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  805090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  805093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  805096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32),
     /*  805128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805147 */     GIR_RootConstrainSelectedInstOperands,
     /*  805148 */     // GIR_Coverage, 19635,
     /*  805148 */     GIR_EraseRootFromParent_Done,
     /*  805149 */   // Label 12447: @805149
     /*  805149 */   GIM_Try, /*On fail goto*//*Label 12448*/ GIMT_Encode4(805224), // Rule ID 19638 //
     /*  805154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  805157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805200 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  805200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805222 */     GIR_RootConstrainSelectedInstOperands,
     /*  805223 */     // GIR_Coverage, 19638,
     /*  805223 */     GIR_EraseRootFromParent_Done,
     /*  805224 */   // Label 12448: @805224
     /*  805224 */   GIM_Try, /*On fail goto*//*Label 12449*/ GIMT_Encode4(805299), // Rule ID 19639 //
     /*  805229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  805232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  805240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  805243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  805246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  805249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  805268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805275 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  805275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32),
     /*  805278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  805294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805297 */     GIR_RootConstrainSelectedInstOperands,
     /*  805298 */     // GIR_Coverage, 19639,
     /*  805298 */     GIR_EraseRootFromParent_Done,
     /*  805299 */   // Label 12449: @805299
     /*  805299 */   GIM_Try, /*On fail goto*//*Label 12450*/ GIMT_Encode4(805374), // Rule ID 19642 //
     /*  805304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805372 */     GIR_RootConstrainSelectedInstOperands,
     /*  805373 */     // GIR_Coverage, 19642,
     /*  805373 */     GIR_EraseRootFromParent_Done,
     /*  805374 */   // Label 12450: @805374
     /*  805374 */   GIM_Try, /*On fail goto*//*Label 12451*/ GIMT_Encode4(805449), // Rule ID 19643 //
     /*  805379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  805390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  805393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  805396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  805414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11200:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64),
     /*  805428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805447 */     GIR_RootConstrainSelectedInstOperands,
     /*  805448 */     // GIR_Coverage, 19643,
     /*  805448 */     GIR_EraseRootFromParent_Done,
     /*  805449 */   // Label 12451: @805449
     /*  805449 */   GIM_Try, /*On fail goto*//*Label 12452*/ GIMT_Encode4(805524), // Rule ID 19646 //
     /*  805454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  805503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805522 */     GIR_RootConstrainSelectedInstOperands,
     /*  805523 */     // GIR_Coverage, 19646,
     /*  805523 */     GIR_EraseRootFromParent_Done,
     /*  805524 */   // Label 12452: @805524
     /*  805524 */   GIM_Try, /*On fail goto*//*Label 12453*/ GIMT_Encode4(805599), // Rule ID 19647 //
     /*  805529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  805540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  805543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  805546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  805564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11200:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64),
     /*  805578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805597 */     GIR_RootConstrainSelectedInstOperands,
     /*  805598 */     // GIR_Coverage, 19647,
     /*  805598 */     GIR_EraseRootFromParent_Done,
     /*  805599 */   // Label 12453: @805599
     /*  805599 */   GIM_Try, /*On fail goto*//*Label 12454*/ GIMT_Encode4(805674), // Rule ID 19650 //
     /*  805604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  805607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  805650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  805653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805672 */     GIR_RootConstrainSelectedInstOperands,
     /*  805673 */     // GIR_Coverage, 19650,
     /*  805673 */     GIR_EraseRootFromParent_Done,
     /*  805674 */   // Label 12454: @805674
     /*  805674 */   GIM_Try, /*On fail goto*//*Label 12455*/ GIMT_Encode4(805749), // Rule ID 19651 //
     /*  805679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  805682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx),
     /*  805687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  805690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  805693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  805696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  805699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  805714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  805718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805725 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11200:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSGNJX_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  805725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64),
     /*  805728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  805732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  805744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805747 */     GIR_RootConstrainSelectedInstOperands,
     /*  805748 */     // GIR_Coverage, 19651,
     /*  805748 */     GIR_EraseRootFromParent_Done,
     /*  805749 */   // Label 12455: @805749
     /*  805749 */   GIM_Try, /*On fail goto*//*Label 12456*/ GIMT_Encode4(805824), // Rule ID 21868 //
     /*  805754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  805757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  805762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  805765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  805768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  805771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  805774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  805800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  805803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  805807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805822 */     GIR_RootConstrainSelectedInstOperands,
     /*  805823 */     // GIR_Coverage, 21868,
     /*  805823 */     GIR_EraseRootFromParent_Done,
     /*  805824 */   // Label 12456: @805824
     /*  805824 */   GIM_Try, /*On fail goto*//*Label 12457*/ GIMT_Encode4(805899), // Rule ID 21869 //
     /*  805829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  805832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  805837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  805840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  805843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  805846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  805849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  805852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805875 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  805875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8),
     /*  805878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  805882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805897 */     GIR_RootConstrainSelectedInstOperands,
     /*  805898 */     // GIR_Coverage, 21869,
     /*  805898 */     GIR_EraseRootFromParent_Done,
     /*  805899 */   // Label 12457: @805899
     /*  805899 */   GIM_Try, /*On fail goto*//*Label 12458*/ GIMT_Encode4(805974), // Rule ID 21872 //
     /*  805904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  805907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  805912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  805915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  805918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  805921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  805924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  805927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  805943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  805950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  805950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  805953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  805955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  805957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  805959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  805961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  805966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  805969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  805972 */     GIR_RootConstrainSelectedInstOperands,
     /*  805973 */     // GIR_Coverage, 21872,
     /*  805973 */     GIR_EraseRootFromParent_Done,
     /*  805974 */   // Label 12458: @805974
     /*  805974 */   GIM_Try, /*On fail goto*//*Label 12459*/ GIMT_Encode4(806049), // Rule ID 21873 //
     /*  805979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  805982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  805987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  805990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  805993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  805996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  805999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8),
     /*  806028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806047 */     GIR_RootConstrainSelectedInstOperands,
     /*  806048 */     // GIR_Coverage, 21873,
     /*  806048 */     GIR_EraseRootFromParent_Done,
     /*  806049 */   // Label 12459: @806049
     /*  806049 */   GIM_Try, /*On fail goto*//*Label 12460*/ GIMT_Encode4(806124), // Rule ID 21876 //
     /*  806054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806122 */     GIR_RootConstrainSelectedInstOperands,
     /*  806123 */     // GIR_Coverage, 21876,
     /*  806123 */     GIR_EraseRootFromParent_Done,
     /*  806124 */   // Label 12460: @806124
     /*  806124 */   GIM_Try, /*On fail goto*//*Label 12461*/ GIMT_Encode4(806199), // Rule ID 21877 //
     /*  806129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  806146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16),
     /*  806178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806197 */     GIR_RootConstrainSelectedInstOperands,
     /*  806198 */     // GIR_Coverage, 21877,
     /*  806198 */     GIR_EraseRootFromParent_Done,
     /*  806199 */   // Label 12461: @806199
     /*  806199 */   GIM_Try, /*On fail goto*//*Label 12462*/ GIMT_Encode4(806274), // Rule ID 21880 //
     /*  806204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806272 */     GIR_RootConstrainSelectedInstOperands,
     /*  806273 */     // GIR_Coverage, 21880,
     /*  806273 */     GIR_EraseRootFromParent_Done,
     /*  806274 */   // Label 12462: @806274
     /*  806274 */   GIM_Try, /*On fail goto*//*Label 12463*/ GIMT_Encode4(806349), // Rule ID 21881 //
     /*  806279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  806296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806325 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16),
     /*  806328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806347 */     GIR_RootConstrainSelectedInstOperands,
     /*  806348 */     // GIR_Coverage, 21881,
     /*  806348 */     GIR_EraseRootFromParent_Done,
     /*  806349 */   // Label 12463: @806349
     /*  806349 */   GIM_Try, /*On fail goto*//*Label 12464*/ GIMT_Encode4(806424), // Rule ID 21884 //
     /*  806354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806422 */     GIR_RootConstrainSelectedInstOperands,
     /*  806423 */     // GIR_Coverage, 21884,
     /*  806423 */     GIR_EraseRootFromParent_Done,
     /*  806424 */   // Label 12464: @806424
     /*  806424 */   GIM_Try, /*On fail goto*//*Label 12465*/ GIMT_Encode4(806499), // Rule ID 21885 //
     /*  806429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  806446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32),
     /*  806478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806497 */     GIR_RootConstrainSelectedInstOperands,
     /*  806498 */     // GIR_Coverage, 21885,
     /*  806498 */     GIR_EraseRootFromParent_Done,
     /*  806499 */   // Label 12465: @806499
     /*  806499 */   GIM_Try, /*On fail goto*//*Label 12466*/ GIMT_Encode4(806574), // Rule ID 21888 //
     /*  806504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  806521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  806550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  806553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806572 */     GIR_RootConstrainSelectedInstOperands,
     /*  806573 */     // GIR_Coverage, 21888,
     /*  806573 */     GIR_EraseRootFromParent_Done,
     /*  806574 */   // Label 12466: @806574
     /*  806574 */   GIM_Try, /*On fail goto*//*Label 12467*/ GIMT_Encode4(806649), // Rule ID 21889 //
     /*  806579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  806590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  806593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  806596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  806599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  806625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8),
     /*  806628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  806644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806647 */     GIR_RootConstrainSelectedInstOperands,
     /*  806648 */     // GIR_Coverage, 21889,
     /*  806648 */     GIR_EraseRootFromParent_Done,
     /*  806649 */   // Label 12467: @806649
     /*  806649 */   GIM_Try, /*On fail goto*//*Label 12468*/ GIMT_Encode4(806724), // Rule ID 21892 //
     /*  806654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  806700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  806703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806722 */     GIR_RootConstrainSelectedInstOperands,
     /*  806723 */     // GIR_Coverage, 21892,
     /*  806723 */     GIR_EraseRootFromParent_Done,
     /*  806724 */   // Label 12468: @806724
     /*  806724 */   GIM_Try, /*On fail goto*//*Label 12469*/ GIMT_Encode4(806799), // Rule ID 21893 //
     /*  806729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  806740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  806743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  806746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  806749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  806775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16),
     /*  806778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  806794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806797 */     GIR_RootConstrainSelectedInstOperands,
     /*  806798 */     // GIR_Coverage, 21893,
     /*  806798 */     GIR_EraseRootFromParent_Done,
     /*  806799 */   // Label 12469: @806799
     /*  806799 */   GIM_Try, /*On fail goto*//*Label 12470*/ GIMT_Encode4(806874), // Rule ID 21896 //
     /*  806804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  806807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  806850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  806853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806872 */     GIR_RootConstrainSelectedInstOperands,
     /*  806873 */     // GIR_Coverage, 21896,
     /*  806873 */     GIR_EraseRootFromParent_Done,
     /*  806874 */   // Label 12470: @806874
     /*  806874 */   GIM_Try, /*On fail goto*//*Label 12471*/ GIMT_Encode4(806949), // Rule ID 21897 //
     /*  806879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  806882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  806890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  806893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  806896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  806899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  806902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  806925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  806925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32),
     /*  806928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  806930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  806932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  806934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  806936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  806941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  806944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  806947 */     GIR_RootConstrainSelectedInstOperands,
     /*  806948 */     // GIR_Coverage, 21897,
     /*  806948 */     GIR_EraseRootFromParent_Done,
     /*  806949 */   // Label 12471: @806949
     /*  806949 */   GIM_Try, /*On fail goto*//*Label 12472*/ GIMT_Encode4(807024), // Rule ID 21900 //
     /*  806954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  806957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  806962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  806965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  806968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  806971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  806974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  806977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  806993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  807000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807022 */     GIR_RootConstrainSelectedInstOperands,
     /*  807023 */     // GIR_Coverage, 21900,
     /*  807023 */     GIR_EraseRootFromParent_Done,
     /*  807024 */   // Label 12472: @807024
     /*  807024 */   GIM_Try, /*On fail goto*//*Label 12473*/ GIMT_Encode4(807099), // Rule ID 21901 //
     /*  807029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  807032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  807040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  807043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  807046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  807049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  807075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64),
     /*  807078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  807094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807097 */     GIR_RootConstrainSelectedInstOperands,
     /*  807098 */     // GIR_Coverage, 21901,
     /*  807098 */     GIR_EraseRootFromParent_Done,
     /*  807099 */   // Label 12473: @807099
     /*  807099 */   GIM_Try, /*On fail goto*//*Label 12474*/ GIMT_Encode4(807174), // Rule ID 21904 //
     /*  807104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807172 */     GIR_RootConstrainSelectedInstOperands,
     /*  807173 */     // GIR_Coverage, 21904,
     /*  807173 */     GIR_EraseRootFromParent_Done,
     /*  807174 */   // Label 12474: @807174
     /*  807174 */   GIM_Try, /*On fail goto*//*Label 12475*/ GIMT_Encode4(807249), // Rule ID 21905 //
     /*  807179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  807196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8),
     /*  807228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807247 */     GIR_RootConstrainSelectedInstOperands,
     /*  807248 */     // GIR_Coverage, 21905,
     /*  807248 */     GIR_EraseRootFromParent_Done,
     /*  807249 */   // Label 12475: @807249
     /*  807249 */   GIM_Try, /*On fail goto*//*Label 12476*/ GIMT_Encode4(807324), // Rule ID 21908 //
     /*  807254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807322 */     GIR_RootConstrainSelectedInstOperands,
     /*  807323 */     // GIR_Coverage, 21908,
     /*  807323 */     GIR_EraseRootFromParent_Done,
     /*  807324 */   // Label 12476: @807324
     /*  807324 */   GIM_Try, /*On fail goto*//*Label 12477*/ GIMT_Encode4(807399), // Rule ID 21909 //
     /*  807329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  807346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807375 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8),
     /*  807378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807397 */     GIR_RootConstrainSelectedInstOperands,
     /*  807398 */     // GIR_Coverage, 21909,
     /*  807398 */     GIR_EraseRootFromParent_Done,
     /*  807399 */   // Label 12477: @807399
     /*  807399 */   GIM_Try, /*On fail goto*//*Label 12478*/ GIMT_Encode4(807474), // Rule ID 21912 //
     /*  807404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  807421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  807450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  807453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807472 */     GIR_RootConstrainSelectedInstOperands,
     /*  807473 */     // GIR_Coverage, 21912,
     /*  807473 */     GIR_EraseRootFromParent_Done,
     /*  807474 */   // Label 12478: @807474
     /*  807474 */   GIM_Try, /*On fail goto*//*Label 12479*/ GIMT_Encode4(807549), // Rule ID 21913 //
     /*  807479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  807490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  807493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  807496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  807499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807525 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11440:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  807525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8),
     /*  807528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  807544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807547 */     GIR_RootConstrainSelectedInstOperands,
     /*  807548 */     // GIR_Coverage, 21913,
     /*  807548 */     GIR_EraseRootFromParent_Done,
     /*  807549 */   // Label 12479: @807549
     /*  807549 */   GIM_Try, /*On fail goto*//*Label 12480*/ GIMT_Encode4(807624), // Rule ID 21916 //
     /*  807554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  807571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  807603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807622 */     GIR_RootConstrainSelectedInstOperands,
     /*  807623 */     // GIR_Coverage, 21916,
     /*  807623 */     GIR_EraseRootFromParent_Done,
     /*  807624 */   // Label 12480: @807624
     /*  807624 */   GIM_Try, /*On fail goto*//*Label 12481*/ GIMT_Encode4(807699), // Rule ID 21917 //
     /*  807629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  807646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  807664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16),
     /*  807678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807697 */     GIR_RootConstrainSelectedInstOperands,
     /*  807698 */     // GIR_Coverage, 21917,
     /*  807698 */     GIR_EraseRootFromParent_Done,
     /*  807699 */   // Label 12481: @807699
     /*  807699 */   GIM_Try, /*On fail goto*//*Label 12482*/ GIMT_Encode4(807774), // Rule ID 21920 //
     /*  807704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  807721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  807753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807772 */     GIR_RootConstrainSelectedInstOperands,
     /*  807773 */     // GIR_Coverage, 21920,
     /*  807773 */     GIR_EraseRootFromParent_Done,
     /*  807774 */   // Label 12482: @807774
     /*  807774 */   GIM_Try, /*On fail goto*//*Label 12483*/ GIMT_Encode4(807849), // Rule ID 21921 //
     /*  807779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  807796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  807814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16),
     /*  807828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807847 */     GIR_RootConstrainSelectedInstOperands,
     /*  807848 */     // GIR_Coverage, 21921,
     /*  807848 */     GIR_EraseRootFromParent_Done,
     /*  807849 */   // Label 12483: @807849
     /*  807849 */   GIM_Try, /*On fail goto*//*Label 12484*/ GIMT_Encode4(807924), // Rule ID 21924 //
     /*  807854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  807857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  807871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  807877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  807900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  807903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807922 */     GIR_RootConstrainSelectedInstOperands,
     /*  807923 */     // GIR_Coverage, 21924,
     /*  807923 */     GIR_EraseRootFromParent_Done,
     /*  807924 */   // Label 12484: @807924
     /*  807924 */   GIM_Try, /*On fail goto*//*Label 12485*/ GIMT_Encode4(807999), // Rule ID 21925 //
     /*  807929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  807932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  807937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  807940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  807943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  807946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  807949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  807952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  807964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  807968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  807975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11440:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  807975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16),
     /*  807978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  807980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  807982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  807984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  807986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  807991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  807994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  807997 */     GIR_RootConstrainSelectedInstOperands,
     /*  807998 */     // GIR_Coverage, 21925,
     /*  807998 */     GIR_EraseRootFromParent_Done,
     /*  807999 */   // Label 12485: @807999
     /*  807999 */   GIM_Try, /*On fail goto*//*Label 12486*/ GIMT_Encode4(808074), // Rule ID 21928 //
     /*  808004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808072 */     GIR_RootConstrainSelectedInstOperands,
     /*  808073 */     // GIR_Coverage, 21928,
     /*  808073 */     GIR_EraseRootFromParent_Done,
     /*  808074 */   // Label 12486: @808074
     /*  808074 */   GIM_Try, /*On fail goto*//*Label 12487*/ GIMT_Encode4(808149), // Rule ID 21929 //
     /*  808079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  808096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808125 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32),
     /*  808128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808147 */     GIR_RootConstrainSelectedInstOperands,
     /*  808148 */     // GIR_Coverage, 21929,
     /*  808148 */     GIR_EraseRootFromParent_Done,
     /*  808149 */   // Label 12487: @808149
     /*  808149 */   GIM_Try, /*On fail goto*//*Label 12488*/ GIMT_Encode4(808224), // Rule ID 21932 //
     /*  808154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808222 */     GIR_RootConstrainSelectedInstOperands,
     /*  808223 */     // GIR_Coverage, 21932,
     /*  808223 */     GIR_EraseRootFromParent_Done,
     /*  808224 */   // Label 12488: @808224
     /*  808224 */   GIM_Try, /*On fail goto*//*Label 12489*/ GIMT_Encode4(808299), // Rule ID 21933 //
     /*  808229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  808246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32),
     /*  808278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808297 */     GIR_RootConstrainSelectedInstOperands,
     /*  808298 */     // GIR_Coverage, 21933,
     /*  808298 */     GIR_EraseRootFromParent_Done,
     /*  808299 */   // Label 12489: @808299
     /*  808299 */   GIM_Try, /*On fail goto*//*Label 12490*/ GIMT_Encode4(808374), // Rule ID 21936 //
     /*  808304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  808350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808372 */     GIR_RootConstrainSelectedInstOperands,
     /*  808373 */     // GIR_Coverage, 21936,
     /*  808373 */     GIR_EraseRootFromParent_Done,
     /*  808374 */   // Label 12490: @808374
     /*  808374 */   GIM_Try, /*On fail goto*//*Label 12491*/ GIMT_Encode4(808449), // Rule ID 21937 //
     /*  808379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  808390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  808393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  808396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  808399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11440:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  808425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32),
     /*  808428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  808444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808447 */     GIR_RootConstrainSelectedInstOperands,
     /*  808448 */     // GIR_Coverage, 21937,
     /*  808448 */     GIR_EraseRootFromParent_Done,
     /*  808449 */   // Label 12491: @808449
     /*  808449 */   GIM_Try, /*On fail goto*//*Label 12492*/ GIMT_Encode4(808524), // Rule ID 21940 //
     /*  808454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  808457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  808471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  808503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808522 */     GIR_RootConstrainSelectedInstOperands,
     /*  808523 */     // GIR_Coverage, 21940,
     /*  808523 */     GIR_EraseRootFromParent_Done,
     /*  808524 */   // Label 12492: @808524
     /*  808524 */   GIM_Try, /*On fail goto*//*Label 12493*/ GIMT_Encode4(808599), // Rule ID 21941 //
     /*  808529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  808532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  808546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  808564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808575 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64),
     /*  808578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808597 */     GIR_RootConstrainSelectedInstOperands,
     /*  808598 */     // GIR_Coverage, 21941,
     /*  808598 */     GIR_EraseRootFromParent_Done,
     /*  808599 */   // Label 12493: @808599
     /*  808599 */   GIM_Try, /*On fail goto*//*Label 12494*/ GIMT_Encode4(808674), // Rule ID 21944 //
     /*  808604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  808607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  808621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808650 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  808653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808672 */     GIR_RootConstrainSelectedInstOperands,
     /*  808673 */     // GIR_Coverage, 21944,
     /*  808673 */     GIR_EraseRootFromParent_Done,
     /*  808674 */   // Label 12494: @808674
     /*  808674 */   GIM_Try, /*On fail goto*//*Label 12495*/ GIMT_Encode4(808749), // Rule ID 21945 //
     /*  808679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  808682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  808696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  808714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808725 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64),
     /*  808728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808747 */     GIR_RootConstrainSelectedInstOperands,
     /*  808748 */     // GIR_Coverage, 21945,
     /*  808748 */     GIR_EraseRootFromParent_Done,
     /*  808749 */   // Label 12495: @808749
     /*  808749 */   GIM_Try, /*On fail goto*//*Label 12496*/ GIMT_Encode4(808824), // Rule ID 21948 //
     /*  808754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  808757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  808771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  808800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  808803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808822 */     GIR_RootConstrainSelectedInstOperands,
     /*  808823 */     // GIR_Coverage, 21948,
     /*  808823 */     GIR_EraseRootFromParent_Done,
     /*  808824 */   // Label 12496: @808824
     /*  808824 */   GIM_Try, /*On fail goto*//*Label 12497*/ GIMT_Encode4(808899), // Rule ID 21949 //
     /*  808829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  808832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum),
     /*  808837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  808840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  808843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  808846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  808849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  808852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  808864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11440:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  808875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64),
     /*  808878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  808894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808897 */     GIR_RootConstrainSelectedInstOperands,
     /*  808898 */     // GIR_Coverage, 21949,
     /*  808898 */     GIR_EraseRootFromParent_Done,
     /*  808899 */   // Label 12497: @808899
     /*  808899 */   GIM_Try, /*On fail goto*//*Label 12498*/ GIMT_Encode4(808974), // Rule ID 21952 //
     /*  808904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  808907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  808912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  808921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  808927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  808943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  808950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  808950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  808953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  808955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  808957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  808959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  808961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  808966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  808969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  808972 */     GIR_RootConstrainSelectedInstOperands,
     /*  808973 */     // GIR_Coverage, 21952,
     /*  808973 */     GIR_EraseRootFromParent_Done,
     /*  808974 */   // Label 12498: @808974
     /*  808974 */   GIM_Try, /*On fail goto*//*Label 12499*/ GIMT_Encode4(809049), // Rule ID 21953 //
     /*  808979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  808982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  808987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  808990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  808993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  808996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  808999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8),
     /*  809028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809047 */     GIR_RootConstrainSelectedInstOperands,
     /*  809048 */     // GIR_Coverage, 21953,
     /*  809048 */     GIR_EraseRootFromParent_Done,
     /*  809049 */   // Label 12499: @809049
     /*  809049 */   GIM_Try, /*On fail goto*//*Label 12500*/ GIMT_Encode4(809124), // Rule ID 21956 //
     /*  809054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809122 */     GIR_RootConstrainSelectedInstOperands,
     /*  809123 */     // GIR_Coverage, 21956,
     /*  809123 */     GIR_EraseRootFromParent_Done,
     /*  809124 */   // Label 12500: @809124
     /*  809124 */   GIM_Try, /*On fail goto*//*Label 12501*/ GIMT_Encode4(809199), // Rule ID 21957 //
     /*  809129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  809146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809175 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8),
     /*  809178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809197 */     GIR_RootConstrainSelectedInstOperands,
     /*  809198 */     // GIR_Coverage, 21957,
     /*  809198 */     GIR_EraseRootFromParent_Done,
     /*  809199 */   // Label 12501: @809199
     /*  809199 */   GIM_Try, /*On fail goto*//*Label 12502*/ GIMT_Encode4(809274), // Rule ID 21960 //
     /*  809204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809272 */     GIR_RootConstrainSelectedInstOperands,
     /*  809273 */     // GIR_Coverage, 21960,
     /*  809273 */     GIR_EraseRootFromParent_Done,
     /*  809274 */   // Label 12502: @809274
     /*  809274 */   GIM_Try, /*On fail goto*//*Label 12503*/ GIMT_Encode4(809349), // Rule ID 21961 //
     /*  809279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  809296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8),
     /*  809328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809347 */     GIR_RootConstrainSelectedInstOperands,
     /*  809348 */     // GIR_Coverage, 21961,
     /*  809348 */     GIR_EraseRootFromParent_Done,
     /*  809349 */   // Label 12503: @809349
     /*  809349 */   GIM_Try, /*On fail goto*//*Label 12504*/ GIMT_Encode4(809424), // Rule ID 21964 //
     /*  809354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809422 */     GIR_RootConstrainSelectedInstOperands,
     /*  809423 */     // GIR_Coverage, 21964,
     /*  809423 */     GIR_EraseRootFromParent_Done,
     /*  809424 */   // Label 12504: @809424
     /*  809424 */   GIM_Try, /*On fail goto*//*Label 12505*/ GIMT_Encode4(809499), // Rule ID 21965 //
     /*  809429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  809446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16),
     /*  809478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809497 */     GIR_RootConstrainSelectedInstOperands,
     /*  809498 */     // GIR_Coverage, 21965,
     /*  809498 */     GIR_EraseRootFromParent_Done,
     /*  809499 */   // Label 12505: @809499
     /*  809499 */   GIM_Try, /*On fail goto*//*Label 12506*/ GIMT_Encode4(809574), // Rule ID 21968 //
     /*  809504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  809521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  809550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  809553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809572 */     GIR_RootConstrainSelectedInstOperands,
     /*  809573 */     // GIR_Coverage, 21968,
     /*  809573 */     GIR_EraseRootFromParent_Done,
     /*  809574 */   // Label 12506: @809574
     /*  809574 */   GIM_Try, /*On fail goto*//*Label 12507*/ GIMT_Encode4(809649), // Rule ID 21969 //
     /*  809579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  809596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809625 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  809625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16),
     /*  809628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  809644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809647 */     GIR_RootConstrainSelectedInstOperands,
     /*  809648 */     // GIR_Coverage, 21969,
     /*  809648 */     GIR_EraseRootFromParent_Done,
     /*  809649 */   // Label 12507: @809649
     /*  809649 */   GIM_Try, /*On fail goto*//*Label 12508*/ GIMT_Encode4(809724), // Rule ID 21972 //
     /*  809654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  809671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  809700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  809703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809722 */     GIR_RootConstrainSelectedInstOperands,
     /*  809723 */     // GIR_Coverage, 21972,
     /*  809723 */     GIR_EraseRootFromParent_Done,
     /*  809724 */   // Label 12508: @809724
     /*  809724 */   GIM_Try, /*On fail goto*//*Label 12509*/ GIMT_Encode4(809799), // Rule ID 21973 //
     /*  809729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  809740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  809743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  809746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  809749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  809775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32),
     /*  809778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  809794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809797 */     GIR_RootConstrainSelectedInstOperands,
     /*  809798 */     // GIR_Coverage, 21973,
     /*  809798 */     GIR_EraseRootFromParent_Done,
     /*  809799 */   // Label 12509: @809799
     /*  809799 */   GIM_Try, /*On fail goto*//*Label 12510*/ GIMT_Encode4(809874), // Rule ID 21976 //
     /*  809804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  809821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  809850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  809853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809872 */     GIR_RootConstrainSelectedInstOperands,
     /*  809873 */     // GIR_Coverage, 21976,
     /*  809873 */     GIR_EraseRootFromParent_Done,
     /*  809874 */   // Label 12510: @809874
     /*  809874 */   GIM_Try, /*On fail goto*//*Label 12511*/ GIMT_Encode4(809949), // Rule ID 21977 //
     /*  809879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  809882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  809890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  809893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  809896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  809899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  809902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  809925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  809925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8),
     /*  809928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  809930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  809932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  809934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  809936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  809941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  809944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  809947 */     GIR_RootConstrainSelectedInstOperands,
     /*  809948 */     // GIR_Coverage, 21977,
     /*  809948 */     GIR_EraseRootFromParent_Done,
     /*  809949 */   // Label 12511: @809949
     /*  809949 */   GIM_Try, /*On fail goto*//*Label 12512*/ GIMT_Encode4(810024), // Rule ID 21980 //
     /*  809954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  809957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  809962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  809965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  809968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  809971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  809974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  809977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  809993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810022 */     GIR_RootConstrainSelectedInstOperands,
     /*  810023 */     // GIR_Coverage, 21980,
     /*  810023 */     GIR_EraseRootFromParent_Done,
     /*  810024 */   // Label 12512: @810024
     /*  810024 */   GIM_Try, /*On fail goto*//*Label 12513*/ GIMT_Encode4(810099), // Rule ID 21981 //
     /*  810029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  810046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16),
     /*  810078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810097 */     GIR_RootConstrainSelectedInstOperands,
     /*  810098 */     // GIR_Coverage, 21981,
     /*  810098 */     GIR_EraseRootFromParent_Done,
     /*  810099 */   // Label 12513: @810099
     /*  810099 */   GIM_Try, /*On fail goto*//*Label 12514*/ GIMT_Encode4(810174), // Rule ID 21984 //
     /*  810104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  810150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810172 */     GIR_RootConstrainSelectedInstOperands,
     /*  810173 */     // GIR_Coverage, 21984,
     /*  810173 */     GIR_EraseRootFromParent_Done,
     /*  810174 */   // Label 12514: @810174
     /*  810174 */   GIM_Try, /*On fail goto*//*Label 12515*/ GIMT_Encode4(810249), // Rule ID 21985 //
     /*  810179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  810190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  810193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  810196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  810199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  810225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32),
     /*  810228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  810244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810247 */     GIR_RootConstrainSelectedInstOperands,
     /*  810248 */     // GIR_Coverage, 21985,
     /*  810248 */     GIR_EraseRootFromParent_Done,
     /*  810249 */   // Label 12515: @810249
     /*  810249 */   GIM_Try, /*On fail goto*//*Label 12516*/ GIMT_Encode4(810324), // Rule ID 21988 //
     /*  810254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  810257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  810300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810322 */     GIR_RootConstrainSelectedInstOperands,
     /*  810323 */     // GIR_Coverage, 21988,
     /*  810323 */     GIR_EraseRootFromParent_Done,
     /*  810324 */   // Label 12516: @810324
     /*  810324 */   GIM_Try, /*On fail goto*//*Label 12517*/ GIMT_Encode4(810399), // Rule ID 21989 //
     /*  810329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  810332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  810340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  810343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  810346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  810349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  810375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64),
     /*  810378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  810394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810397 */     GIR_RootConstrainSelectedInstOperands,
     /*  810398 */     // GIR_Coverage, 21989,
     /*  810398 */     GIR_EraseRootFromParent_Done,
     /*  810399 */   // Label 12517: @810399
     /*  810399 */   GIM_Try, /*On fail goto*//*Label 12518*/ GIMT_Encode4(810474), // Rule ID 21992 //
     /*  810404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  810421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  810453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810472 */     GIR_RootConstrainSelectedInstOperands,
     /*  810473 */     // GIR_Coverage, 21992,
     /*  810473 */     GIR_EraseRootFromParent_Done,
     /*  810474 */   // Label 12518: @810474
     /*  810474 */   GIM_Try, /*On fail goto*//*Label 12519*/ GIMT_Encode4(810549), // Rule ID 21993 //
     /*  810479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  810496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810525 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8),
     /*  810528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810547 */     GIR_RootConstrainSelectedInstOperands,
     /*  810548 */     // GIR_Coverage, 21993,
     /*  810548 */     GIR_EraseRootFromParent_Done,
     /*  810549 */   // Label 12519: @810549
     /*  810549 */   GIM_Try, /*On fail goto*//*Label 12520*/ GIMT_Encode4(810624), // Rule ID 21996 //
     /*  810554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  810571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  810603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810622 */     GIR_RootConstrainSelectedInstOperands,
     /*  810623 */     // GIR_Coverage, 21996,
     /*  810623 */     GIR_EraseRootFromParent_Done,
     /*  810624 */   // Label 12520: @810624
     /*  810624 */   GIM_Try, /*On fail goto*//*Label 12521*/ GIMT_Encode4(810699), // Rule ID 21997 //
     /*  810629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  810646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  810664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8),
     /*  810678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810697 */     GIR_RootConstrainSelectedInstOperands,
     /*  810698 */     // GIR_Coverage, 21997,
     /*  810698 */     GIR_EraseRootFromParent_Done,
     /*  810699 */   // Label 12521: @810699
     /*  810699 */   GIM_Try, /*On fail goto*//*Label 12522*/ GIMT_Encode4(810774), // Rule ID 22000 //
     /*  810704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  810721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  810750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  810753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810772 */     GIR_RootConstrainSelectedInstOperands,
     /*  810773 */     // GIR_Coverage, 22000,
     /*  810773 */     GIR_EraseRootFromParent_Done,
     /*  810774 */   // Label 12522: @810774
     /*  810774 */   GIM_Try, /*On fail goto*//*Label 12523*/ GIMT_Encode4(810849), // Rule ID 22001 //
     /*  810779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  810790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  810793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  810796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  810799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  810814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11428:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  810825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8),
     /*  810828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  810844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810847 */     GIR_RootConstrainSelectedInstOperands,
     /*  810848 */     // GIR_Coverage, 22001,
     /*  810848 */     GIR_EraseRootFromParent_Done,
     /*  810849 */   // Label 12523: @810849
     /*  810849 */   GIM_Try, /*On fail goto*//*Label 12524*/ GIMT_Encode4(810924), // Rule ID 22004 //
     /*  810854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  810857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  810871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  810877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  810900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  810903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810922 */     GIR_RootConstrainSelectedInstOperands,
     /*  810923 */     // GIR_Coverage, 22004,
     /*  810923 */     GIR_EraseRootFromParent_Done,
     /*  810924 */   // Label 12524: @810924
     /*  810924 */   GIM_Try, /*On fail goto*//*Label 12525*/ GIMT_Encode4(810999), // Rule ID 22005 //
     /*  810929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  810932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  810937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  810940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  810943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  810946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  810949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  810952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  810964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  810968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  810975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  810975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16),
     /*  810978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  810980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  810982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  810984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  810986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  810991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  810994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  810997 */     GIR_RootConstrainSelectedInstOperands,
     /*  810998 */     // GIR_Coverage, 22005,
     /*  810998 */     GIR_EraseRootFromParent_Done,
     /*  810999 */   // Label 12525: @810999
     /*  810999 */   GIM_Try, /*On fail goto*//*Label 12526*/ GIMT_Encode4(811074), // Rule ID 22008 //
     /*  811004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811072 */     GIR_RootConstrainSelectedInstOperands,
     /*  811073 */     // GIR_Coverage, 22008,
     /*  811073 */     GIR_EraseRootFromParent_Done,
     /*  811074 */   // Label 12526: @811074
     /*  811074 */   GIM_Try, /*On fail goto*//*Label 12527*/ GIMT_Encode4(811149), // Rule ID 22009 //
     /*  811079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  811096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811125 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16),
     /*  811128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811147 */     GIR_RootConstrainSelectedInstOperands,
     /*  811148 */     // GIR_Coverage, 22009,
     /*  811148 */     GIR_EraseRootFromParent_Done,
     /*  811149 */   // Label 12527: @811149
     /*  811149 */   GIM_Try, /*On fail goto*//*Label 12528*/ GIMT_Encode4(811224), // Rule ID 22012 //
     /*  811154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  811200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811222 */     GIR_RootConstrainSelectedInstOperands,
     /*  811223 */     // GIR_Coverage, 22012,
     /*  811223 */     GIR_EraseRootFromParent_Done,
     /*  811224 */   // Label 12528: @811224
     /*  811224 */   GIM_Try, /*On fail goto*//*Label 12529*/ GIMT_Encode4(811299), // Rule ID 22013 //
     /*  811229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  811240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  811243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  811246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  811249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11428:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  811275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16),
     /*  811278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  811294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811297 */     GIR_RootConstrainSelectedInstOperands,
     /*  811298 */     // GIR_Coverage, 22013,
     /*  811298 */     GIR_EraseRootFromParent_Done,
     /*  811299 */   // Label 12529: @811299
     /*  811299 */   GIM_Try, /*On fail goto*//*Label 12530*/ GIMT_Encode4(811374), // Rule ID 22016 //
     /*  811304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811372 */     GIR_RootConstrainSelectedInstOperands,
     /*  811373 */     // GIR_Coverage, 22016,
     /*  811373 */     GIR_EraseRootFromParent_Done,
     /*  811374 */   // Label 12530: @811374
     /*  811374 */   GIM_Try, /*On fail goto*//*Label 12531*/ GIMT_Encode4(811449), // Rule ID 22017 //
     /*  811379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  811396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32),
     /*  811428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811447 */     GIR_RootConstrainSelectedInstOperands,
     /*  811448 */     // GIR_Coverage, 22017,
     /*  811448 */     GIR_EraseRootFromParent_Done,
     /*  811449 */   // Label 12531: @811449
     /*  811449 */   GIM_Try, /*On fail goto*//*Label 12532*/ GIMT_Encode4(811524), // Rule ID 22020 //
     /*  811454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  811471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  811503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811522 */     GIR_RootConstrainSelectedInstOperands,
     /*  811523 */     // GIR_Coverage, 22020,
     /*  811523 */     GIR_EraseRootFromParent_Done,
     /*  811524 */   // Label 12532: @811524
     /*  811524 */   GIM_Try, /*On fail goto*//*Label 12533*/ GIMT_Encode4(811599), // Rule ID 22021 //
     /*  811529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  811546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32),
     /*  811578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811597 */     GIR_RootConstrainSelectedInstOperands,
     /*  811598 */     // GIR_Coverage, 22021,
     /*  811598 */     GIR_EraseRootFromParent_Done,
     /*  811599 */   // Label 12533: @811599
     /*  811599 */   GIM_Try, /*On fail goto*//*Label 12534*/ GIMT_Encode4(811674), // Rule ID 22024 //
     /*  811604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  811607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  811621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  811650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  811653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811672 */     GIR_RootConstrainSelectedInstOperands,
     /*  811673 */     // GIR_Coverage, 22024,
     /*  811673 */     GIR_EraseRootFromParent_Done,
     /*  811674 */   // Label 12534: @811674
     /*  811674 */   GIM_Try, /*On fail goto*//*Label 12535*/ GIMT_Encode4(811749), // Rule ID 22025 //
     /*  811679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  811682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  811690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  811693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  811696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  811699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  811714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811725 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11428:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  811725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32),
     /*  811728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  811744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811747 */     GIR_RootConstrainSelectedInstOperands,
     /*  811748 */     // GIR_Coverage, 22025,
     /*  811748 */     GIR_EraseRootFromParent_Done,
     /*  811749 */   // Label 12535: @811749
     /*  811749 */   GIM_Try, /*On fail goto*//*Label 12536*/ GIMT_Encode4(811824), // Rule ID 22028 //
     /*  811754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  811771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  811803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811822 */     GIR_RootConstrainSelectedInstOperands,
     /*  811823 */     // GIR_Coverage, 22028,
     /*  811823 */     GIR_EraseRootFromParent_Done,
     /*  811824 */   // Label 12536: @811824
     /*  811824 */   GIM_Try, /*On fail goto*//*Label 12537*/ GIMT_Encode4(811899), // Rule ID 22029 //
     /*  811829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  811846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  811852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  811864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  811875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64),
     /*  811878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811897 */     GIR_RootConstrainSelectedInstOperands,
     /*  811898 */     // GIR_Coverage, 22029,
     /*  811898 */     GIR_EraseRootFromParent_Done,
     /*  811899 */   // Label 12537: @811899
     /*  811899 */   GIM_Try, /*On fail goto*//*Label 12538*/ GIMT_Encode4(811974), // Rule ID 22032 //
     /*  811904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  811907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  811921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  811927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  811939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  811943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  811950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  811950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  811953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  811955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  811957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  811959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  811961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  811966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  811969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  811972 */     GIR_RootConstrainSelectedInstOperands,
     /*  811973 */     // GIR_Coverage, 22032,
     /*  811973 */     GIR_EraseRootFromParent_Done,
     /*  811974 */   // Label 12538: @811974
     /*  811974 */   GIM_Try, /*On fail goto*//*Label 12539*/ GIMT_Encode4(812049), // Rule ID 22033 //
     /*  811979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  811982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  811987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  811990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  811993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  811996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  811999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  812014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64),
     /*  812028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812047 */     GIR_RootConstrainSelectedInstOperands,
     /*  812048 */     // GIR_Coverage, 22033,
     /*  812048 */     GIR_EraseRootFromParent_Done,
     /*  812049 */   // Label 12539: @812049
     /*  812049 */   GIM_Try, /*On fail goto*//*Label 12540*/ GIMT_Encode4(812124), // Rule ID 22036 //
     /*  812054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  812057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  812100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812122 */     GIR_RootConstrainSelectedInstOperands,
     /*  812123 */     // GIR_Coverage, 22036,
     /*  812123 */     GIR_EraseRootFromParent_Done,
     /*  812124 */   // Label 12540: @812124
     /*  812124 */   GIM_Try, /*On fail goto*//*Label 12541*/ GIMT_Encode4(812199), // Rule ID 22037 //
     /*  812129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  812132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand),
     /*  812137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  812140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  812143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  812146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  812149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  812164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11428:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  812175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64),
     /*  812178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  812194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812197 */     GIR_RootConstrainSelectedInstOperands,
     /*  812198 */     // GIR_Coverage, 22037,
     /*  812198 */     GIR_EraseRootFromParent_Done,
     /*  812199 */   // Label 12541: @812199
     /*  812199 */   GIM_Try, /*On fail goto*//*Label 12542*/ GIMT_Encode4(812274), // Rule ID 22040 //
     /*  812204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812272 */     GIR_RootConstrainSelectedInstOperands,
     /*  812273 */     // GIR_Coverage, 22040,
     /*  812273 */     GIR_EraseRootFromParent_Done,
     /*  812274 */   // Label 12542: @812274
     /*  812274 */   GIM_Try, /*On fail goto*//*Label 12543*/ GIMT_Encode4(812349), // Rule ID 22041 //
     /*  812279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  812296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8),
     /*  812328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812347 */     GIR_RootConstrainSelectedInstOperands,
     /*  812348 */     // GIR_Coverage, 22041,
     /*  812348 */     GIR_EraseRootFromParent_Done,
     /*  812349 */   // Label 12543: @812349
     /*  812349 */   GIM_Try, /*On fail goto*//*Label 12544*/ GIMT_Encode4(812424), // Rule ID 22044 //
     /*  812354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812422 */     GIR_RootConstrainSelectedInstOperands,
     /*  812423 */     // GIR_Coverage, 22044,
     /*  812423 */     GIR_EraseRootFromParent_Done,
     /*  812424 */   // Label 12544: @812424
     /*  812424 */   GIM_Try, /*On fail goto*//*Label 12545*/ GIMT_Encode4(812499), // Rule ID 22045 //
     /*  812429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  812446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812475 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8),
     /*  812478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812497 */     GIR_RootConstrainSelectedInstOperands,
     /*  812498 */     // GIR_Coverage, 22045,
     /*  812498 */     GIR_EraseRootFromParent_Done,
     /*  812499 */   // Label 12545: @812499
     /*  812499 */   GIM_Try, /*On fail goto*//*Label 12546*/ GIMT_Encode4(812574), // Rule ID 22048 //
     /*  812504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  812521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  812550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  812553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812572 */     GIR_RootConstrainSelectedInstOperands,
     /*  812573 */     // GIR_Coverage, 22048,
     /*  812573 */     GIR_EraseRootFromParent_Done,
     /*  812574 */   // Label 12546: @812574
     /*  812574 */   GIM_Try, /*On fail goto*//*Label 12547*/ GIMT_Encode4(812649), // Rule ID 22049 //
     /*  812579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  812590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  812593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  812596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  812599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  812625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8),
     /*  812628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  812644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812647 */     GIR_RootConstrainSelectedInstOperands,
     /*  812648 */     // GIR_Coverage, 22049,
     /*  812648 */     GIR_EraseRootFromParent_Done,
     /*  812649 */   // Label 12547: @812649
     /*  812649 */   GIM_Try, /*On fail goto*//*Label 12548*/ GIMT_Encode4(812724), // Rule ID 22052 //
     /*  812654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  812671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  812703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812722 */     GIR_RootConstrainSelectedInstOperands,
     /*  812723 */     // GIR_Coverage, 22052,
     /*  812723 */     GIR_EraseRootFromParent_Done,
     /*  812724 */   // Label 12548: @812724
     /*  812724 */   GIM_Try, /*On fail goto*//*Label 12549*/ GIMT_Encode4(812799), // Rule ID 22053 //
     /*  812729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  812746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16),
     /*  812778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812797 */     GIR_RootConstrainSelectedInstOperands,
     /*  812798 */     // GIR_Coverage, 22053,
     /*  812798 */     GIR_EraseRootFromParent_Done,
     /*  812799 */   // Label 12549: @812799
     /*  812799 */   GIM_Try, /*On fail goto*//*Label 12550*/ GIMT_Encode4(812874), // Rule ID 22056 //
     /*  812804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  812821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  812850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  812853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812872 */     GIR_RootConstrainSelectedInstOperands,
     /*  812873 */     // GIR_Coverage, 22056,
     /*  812873 */     GIR_EraseRootFromParent_Done,
     /*  812874 */   // Label 12550: @812874
     /*  812874 */   GIM_Try, /*On fail goto*//*Label 12551*/ GIMT_Encode4(812949), // Rule ID 22057 //
     /*  812879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  812882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  812890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  812893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  812896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  812899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  812902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  812925 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  812925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16),
     /*  812928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  812930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  812932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  812934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  812936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  812941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  812944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  812947 */     GIR_RootConstrainSelectedInstOperands,
     /*  812948 */     // GIR_Coverage, 22057,
     /*  812948 */     GIR_EraseRootFromParent_Done,
     /*  812949 */   // Label 12551: @812949
     /*  812949 */   GIM_Try, /*On fail goto*//*Label 12552*/ GIMT_Encode4(813024), // Rule ID 22060 //
     /*  812954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  812957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  812962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  812965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  812968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  812971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  812974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  812977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  812993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813022 */     GIR_RootConstrainSelectedInstOperands,
     /*  813023 */     // GIR_Coverage, 22060,
     /*  813023 */     GIR_EraseRootFromParent_Done,
     /*  813024 */   // Label 12552: @813024
     /*  813024 */   GIM_Try, /*On fail goto*//*Label 12553*/ GIMT_Encode4(813099), // Rule ID 22061 //
     /*  813029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  813046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  813075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32),
     /*  813078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813097 */     GIR_RootConstrainSelectedInstOperands,
     /*  813098 */     // GIR_Coverage, 22061,
     /*  813098 */     GIR_EraseRootFromParent_Done,
     /*  813099 */   // Label 12553: @813099
     /*  813099 */   GIM_Try, /*On fail goto*//*Label 12554*/ GIMT_Encode4(813174), // Rule ID 22064 //
     /*  813104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813172 */     GIR_RootConstrainSelectedInstOperands,
     /*  813173 */     // GIR_Coverage, 22064,
     /*  813173 */     GIR_EraseRootFromParent_Done,
     /*  813174 */   // Label 12554: @813174
     /*  813174 */   GIM_Try, /*On fail goto*//*Label 12555*/ GIMT_Encode4(813249), // Rule ID 22065 //
     /*  813179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  813196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8),
     /*  813228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813247 */     GIR_RootConstrainSelectedInstOperands,
     /*  813248 */     // GIR_Coverage, 22065,
     /*  813248 */     GIR_EraseRootFromParent_Done,
     /*  813249 */   // Label 12555: @813249
     /*  813249 */   GIM_Try, /*On fail goto*//*Label 12556*/ GIMT_Encode4(813324), // Rule ID 22068 //
     /*  813254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  813300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813322 */     GIR_RootConstrainSelectedInstOperands,
     /*  813323 */     // GIR_Coverage, 22068,
     /*  813323 */     GIR_EraseRootFromParent_Done,
     /*  813324 */   // Label 12556: @813324
     /*  813324 */   GIM_Try, /*On fail goto*//*Label 12557*/ GIMT_Encode4(813399), // Rule ID 22069 //
     /*  813329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  813340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  813343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  813346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  813349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  813375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16),
     /*  813378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  813394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813397 */     GIR_RootConstrainSelectedInstOperands,
     /*  813398 */     // GIR_Coverage, 22069,
     /*  813398 */     GIR_EraseRootFromParent_Done,
     /*  813399 */   // Label 12557: @813399
     /*  813399 */   GIM_Try, /*On fail goto*//*Label 12558*/ GIMT_Encode4(813474), // Rule ID 22072 //
     /*  813404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  813450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  813453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813472 */     GIR_RootConstrainSelectedInstOperands,
     /*  813473 */     // GIR_Coverage, 22072,
     /*  813473 */     GIR_EraseRootFromParent_Done,
     /*  813474 */   // Label 12558: @813474
     /*  813474 */   GIM_Try, /*On fail goto*//*Label 12559*/ GIMT_Encode4(813549), // Rule ID 22073 //
     /*  813479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  813490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  813493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  813496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  813499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  813525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32),
     /*  813528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  813544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813547 */     GIR_RootConstrainSelectedInstOperands,
     /*  813548 */     // GIR_Coverage, 22073,
     /*  813548 */     GIR_EraseRootFromParent_Done,
     /*  813549 */   // Label 12559: @813549
     /*  813549 */   GIM_Try, /*On fail goto*//*Label 12560*/ GIMT_Encode4(813624), // Rule ID 22076 //
     /*  813554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  813557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  813571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  813600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  813603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813622 */     GIR_RootConstrainSelectedInstOperands,
     /*  813623 */     // GIR_Coverage, 22076,
     /*  813623 */     GIR_EraseRootFromParent_Done,
     /*  813624 */   // Label 12560: @813624
     /*  813624 */   GIM_Try, /*On fail goto*//*Label 12561*/ GIMT_Encode4(813699), // Rule ID 22077 //
     /*  813629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  813632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  813640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  813643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  813646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  813649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  813675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64),
     /*  813678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  813694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813697 */     GIR_RootConstrainSelectedInstOperands,
     /*  813698 */     // GIR_Coverage, 22077,
     /*  813698 */     GIR_EraseRootFromParent_Done,
     /*  813699 */   // Label 12561: @813699
     /*  813699 */   GIM_Try, /*On fail goto*//*Label 12562*/ GIMT_Encode4(813774), // Rule ID 22080 //
     /*  813704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  813721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  813753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813772 */     GIR_RootConstrainSelectedInstOperands,
     /*  813773 */     // GIR_Coverage, 22080,
     /*  813773 */     GIR_EraseRootFromParent_Done,
     /*  813774 */   // Label 12562: @813774
     /*  813774 */   GIM_Try, /*On fail goto*//*Label 12563*/ GIMT_Encode4(813849), // Rule ID 22081 //
     /*  813779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  813796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  813814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8),
     /*  813828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813847 */     GIR_RootConstrainSelectedInstOperands,
     /*  813848 */     // GIR_Coverage, 22081,
     /*  813848 */     GIR_EraseRootFromParent_Done,
     /*  813849 */   // Label 12563: @813849
     /*  813849 */   GIM_Try, /*On fail goto*//*Label 12564*/ GIMT_Encode4(813924), // Rule ID 22084 //
     /*  813854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  813857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  813871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  813877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  813900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  813903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813922 */     GIR_RootConstrainSelectedInstOperands,
     /*  813923 */     // GIR_Coverage, 22084,
     /*  813923 */     GIR_EraseRootFromParent_Done,
     /*  813924 */   // Label 12564: @813924
     /*  813924 */   GIM_Try, /*On fail goto*//*Label 12565*/ GIMT_Encode4(813999), // Rule ID 22085 //
     /*  813929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  813932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  813937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  813940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  813943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  813946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  813949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  813952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  813964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  813968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  813975 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  813975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8),
     /*  813978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  813980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  813982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  813984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  813986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  813991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  813994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  813997 */     GIR_RootConstrainSelectedInstOperands,
     /*  813998 */     // GIR_Coverage, 22085,
     /*  813998 */     GIR_EraseRootFromParent_Done,
     /*  813999 */   // Label 12565: @813999
     /*  813999 */   GIM_Try, /*On fail goto*//*Label 12566*/ GIMT_Encode4(814074), // Rule ID 22088 //
     /*  814004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  814050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814072 */     GIR_RootConstrainSelectedInstOperands,
     /*  814073 */     // GIR_Coverage, 22088,
     /*  814073 */     GIR_EraseRootFromParent_Done,
     /*  814074 */   // Label 12566: @814074
     /*  814074 */   GIM_Try, /*On fail goto*//*Label 12567*/ GIMT_Encode4(814149), // Rule ID 22089 //
     /*  814079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  814090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  814093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  814096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  814099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11438:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  814125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8),
     /*  814128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  814144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814147 */     GIR_RootConstrainSelectedInstOperands,
     /*  814148 */     // GIR_Coverage, 22089,
     /*  814148 */     GIR_EraseRootFromParent_Done,
     /*  814149 */   // Label 12567: @814149
     /*  814149 */   GIM_Try, /*On fail goto*//*Label 12568*/ GIMT_Encode4(814224), // Rule ID 22092 //
     /*  814154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814222 */     GIR_RootConstrainSelectedInstOperands,
     /*  814223 */     // GIR_Coverage, 22092,
     /*  814223 */     GIR_EraseRootFromParent_Done,
     /*  814224 */   // Label 12568: @814224
     /*  814224 */   GIM_Try, /*On fail goto*//*Label 12569*/ GIMT_Encode4(814299), // Rule ID 22093 //
     /*  814229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  814246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16),
     /*  814278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814297 */     GIR_RootConstrainSelectedInstOperands,
     /*  814298 */     // GIR_Coverage, 22093,
     /*  814298 */     GIR_EraseRootFromParent_Done,
     /*  814299 */   // Label 12569: @814299
     /*  814299 */   GIM_Try, /*On fail goto*//*Label 12570*/ GIMT_Encode4(814374), // Rule ID 22096 //
     /*  814304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814372 */     GIR_RootConstrainSelectedInstOperands,
     /*  814373 */     // GIR_Coverage, 22096,
     /*  814373 */     GIR_EraseRootFromParent_Done,
     /*  814374 */   // Label 12570: @814374
     /*  814374 */   GIM_Try, /*On fail goto*//*Label 12571*/ GIMT_Encode4(814449), // Rule ID 22097 //
     /*  814379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  814396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16),
     /*  814428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814447 */     GIR_RootConstrainSelectedInstOperands,
     /*  814448 */     // GIR_Coverage, 22097,
     /*  814448 */     GIR_EraseRootFromParent_Done,
     /*  814449 */   // Label 12571: @814449
     /*  814449 */   GIM_Try, /*On fail goto*//*Label 12572*/ GIMT_Encode4(814524), // Rule ID 22100 //
     /*  814454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  814500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  814503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814522 */     GIR_RootConstrainSelectedInstOperands,
     /*  814523 */     // GIR_Coverage, 22100,
     /*  814523 */     GIR_EraseRootFromParent_Done,
     /*  814524 */   // Label 12572: @814524
     /*  814524 */   GIM_Try, /*On fail goto*//*Label 12573*/ GIMT_Encode4(814599), // Rule ID 22101 //
     /*  814529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  814540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  814543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  814546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  814549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11438:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  814575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16),
     /*  814578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  814594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814597 */     GIR_RootConstrainSelectedInstOperands,
     /*  814598 */     // GIR_Coverage, 22101,
     /*  814598 */     GIR_EraseRootFromParent_Done,
     /*  814599 */   // Label 12573: @814599
     /*  814599 */   GIM_Try, /*On fail goto*//*Label 12574*/ GIMT_Encode4(814674), // Rule ID 22104 //
     /*  814604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  814621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  814653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814672 */     GIR_RootConstrainSelectedInstOperands,
     /*  814673 */     // GIR_Coverage, 22104,
     /*  814673 */     GIR_EraseRootFromParent_Done,
     /*  814674 */   // Label 12574: @814674
     /*  814674 */   GIM_Try, /*On fail goto*//*Label 12575*/ GIMT_Encode4(814749), // Rule ID 22105 //
     /*  814679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  814696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  814714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814725 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32),
     /*  814728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814747 */     GIR_RootConstrainSelectedInstOperands,
     /*  814748 */     // GIR_Coverage, 22105,
     /*  814748 */     GIR_EraseRootFromParent_Done,
     /*  814749 */   // Label 12575: @814749
     /*  814749 */   GIM_Try, /*On fail goto*//*Label 12576*/ GIMT_Encode4(814824), // Rule ID 22108 //
     /*  814754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  814771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  814803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814822 */     GIR_RootConstrainSelectedInstOperands,
     /*  814823 */     // GIR_Coverage, 22108,
     /*  814823 */     GIR_EraseRootFromParent_Done,
     /*  814824 */   // Label 12576: @814824
     /*  814824 */   GIM_Try, /*On fail goto*//*Label 12577*/ GIMT_Encode4(814899), // Rule ID 22109 //
     /*  814829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  814846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  814852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  814864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814875 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  814875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32),
     /*  814878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814897 */     GIR_RootConstrainSelectedInstOperands,
     /*  814898 */     // GIR_Coverage, 22109,
     /*  814898 */     GIR_EraseRootFromParent_Done,
     /*  814899 */   // Label 12577: @814899
     /*  814899 */   GIM_Try, /*On fail goto*//*Label 12578*/ GIMT_Encode4(814974), // Rule ID 22112 //
     /*  814904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  814907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  814921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  814927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  814939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  814943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  814950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  814950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  814953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  814955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  814957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  814959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  814961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  814966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  814969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  814972 */     GIR_RootConstrainSelectedInstOperands,
     /*  814973 */     // GIR_Coverage, 22112,
     /*  814973 */     GIR_EraseRootFromParent_Done,
     /*  814974 */   // Label 12578: @814974
     /*  814974 */   GIM_Try, /*On fail goto*//*Label 12579*/ GIMT_Encode4(815049), // Rule ID 22113 //
     /*  814979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  814982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  814987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  814990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  814993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  814996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  814999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11438:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  815025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32),
     /*  815028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  815044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815047 */     GIR_RootConstrainSelectedInstOperands,
     /*  815048 */     // GIR_Coverage, 22113,
     /*  815048 */     GIR_EraseRootFromParent_Done,
     /*  815049 */   // Label 12579: @815049
     /*  815049 */   GIM_Try, /*On fail goto*//*Label 12580*/ GIMT_Encode4(815124), // Rule ID 22116 //
     /*  815054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815122 */     GIR_RootConstrainSelectedInstOperands,
     /*  815123 */     // GIR_Coverage, 22116,
     /*  815123 */     GIR_EraseRootFromParent_Done,
     /*  815124 */   // Label 12580: @815124
     /*  815124 */   GIM_Try, /*On fail goto*//*Label 12581*/ GIMT_Encode4(815199), // Rule ID 22117 //
     /*  815129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  815146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  815164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64),
     /*  815178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815197 */     GIR_RootConstrainSelectedInstOperands,
     /*  815198 */     // GIR_Coverage, 22117,
     /*  815198 */     GIR_EraseRootFromParent_Done,
     /*  815199 */   // Label 12581: @815199
     /*  815199 */   GIM_Try, /*On fail goto*//*Label 12582*/ GIMT_Encode4(815274), // Rule ID 22120 //
     /*  815204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815272 */     GIR_RootConstrainSelectedInstOperands,
     /*  815273 */     // GIR_Coverage, 22120,
     /*  815273 */     GIR_EraseRootFromParent_Done,
     /*  815274 */   // Label 12582: @815274
     /*  815274 */   GIM_Try, /*On fail goto*//*Label 12583*/ GIMT_Encode4(815349), // Rule ID 22121 //
     /*  815279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  815296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  815314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815325 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64),
     /*  815328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815347 */     GIR_RootConstrainSelectedInstOperands,
     /*  815348 */     // GIR_Coverage, 22121,
     /*  815348 */     GIR_EraseRootFromParent_Done,
     /*  815349 */   // Label 12583: @815349
     /*  815349 */   GIM_Try, /*On fail goto*//*Label 12584*/ GIMT_Encode4(815424), // Rule ID 22124 //
     /*  815354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  815357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  815400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815422 */     GIR_RootConstrainSelectedInstOperands,
     /*  815423 */     // GIR_Coverage, 22124,
     /*  815423 */     GIR_EraseRootFromParent_Done,
     /*  815424 */   // Label 12584: @815424
     /*  815424 */   GIM_Try, /*On fail goto*//*Label 12585*/ GIMT_Encode4(815499), // Rule ID 22125 //
     /*  815429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  815432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor),
     /*  815437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  815440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  815443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  815446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  815449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  815464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11438:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  815475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64),
     /*  815478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  815494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815497 */     GIR_RootConstrainSelectedInstOperands,
     /*  815498 */     // GIR_Coverage, 22125,
     /*  815498 */     GIR_EraseRootFromParent_Done,
     /*  815499 */   // Label 12585: @815499
     /*  815499 */   GIM_Try, /*On fail goto*//*Label 12586*/ GIMT_Encode4(815574), // Rule ID 22128 //
     /*  815504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  815521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  815553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815572 */     GIR_RootConstrainSelectedInstOperands,
     /*  815573 */     // GIR_Coverage, 22128,
     /*  815573 */     GIR_EraseRootFromParent_Done,
     /*  815574 */   // Label 12586: @815574
     /*  815574 */   GIM_Try, /*On fail goto*//*Label 12587*/ GIMT_Encode4(815649), // Rule ID 22129 //
     /*  815579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  815596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8),
     /*  815628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815647 */     GIR_RootConstrainSelectedInstOperands,
     /*  815648 */     // GIR_Coverage, 22129,
     /*  815648 */     GIR_EraseRootFromParent_Done,
     /*  815649 */   // Label 12587: @815649
     /*  815649 */   GIM_Try, /*On fail goto*//*Label 12588*/ GIMT_Encode4(815724), // Rule ID 22132 //
     /*  815654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  815671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  815703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815722 */     GIR_RootConstrainSelectedInstOperands,
     /*  815723 */     // GIR_Coverage, 22132,
     /*  815723 */     GIR_EraseRootFromParent_Done,
     /*  815724 */   // Label 12588: @815724
     /*  815724 */   GIM_Try, /*On fail goto*//*Label 12589*/ GIMT_Encode4(815799), // Rule ID 22133 //
     /*  815729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  815746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815775 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8),
     /*  815778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815797 */     GIR_RootConstrainSelectedInstOperands,
     /*  815798 */     // GIR_Coverage, 22133,
     /*  815798 */     GIR_EraseRootFromParent_Done,
     /*  815799 */   // Label 12589: @815799
     /*  815799 */   GIM_Try, /*On fail goto*//*Label 12590*/ GIMT_Encode4(815874), // Rule ID 22136 //
     /*  815804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  815821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  815850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  815853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815872 */     GIR_RootConstrainSelectedInstOperands,
     /*  815873 */     // GIR_Coverage, 22136,
     /*  815873 */     GIR_EraseRootFromParent_Done,
     /*  815874 */   // Label 12590: @815874
     /*  815874 */   GIM_Try, /*On fail goto*//*Label 12591*/ GIMT_Encode4(815949), // Rule ID 22137 //
     /*  815879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  815882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  815890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  815893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  815896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  815899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  815902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  815925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  815925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8),
     /*  815928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  815930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  815932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  815934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  815936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  815941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  815944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  815947 */     GIR_RootConstrainSelectedInstOperands,
     /*  815948 */     // GIR_Coverage, 22137,
     /*  815948 */     GIR_EraseRootFromParent_Done,
     /*  815949 */   // Label 12591: @815949
     /*  815949 */   GIM_Try, /*On fail goto*//*Label 12592*/ GIMT_Encode4(816024), // Rule ID 22140 //
     /*  815954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  815957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  815962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  815965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  815968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  815971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  815974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  815977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  815993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816022 */     GIR_RootConstrainSelectedInstOperands,
     /*  816023 */     // GIR_Coverage, 22140,
     /*  816023 */     GIR_EraseRootFromParent_Done,
     /*  816024 */   // Label 12592: @816024
     /*  816024 */   GIM_Try, /*On fail goto*//*Label 12593*/ GIMT_Encode4(816099), // Rule ID 22141 //
     /*  816029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  816046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16),
     /*  816078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816097 */     GIR_RootConstrainSelectedInstOperands,
     /*  816098 */     // GIR_Coverage, 22141,
     /*  816098 */     GIR_EraseRootFromParent_Done,
     /*  816099 */   // Label 12593: @816099
     /*  816099 */   GIM_Try, /*On fail goto*//*Label 12594*/ GIMT_Encode4(816174), // Rule ID 22144 //
     /*  816104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816150 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816172 */     GIR_RootConstrainSelectedInstOperands,
     /*  816173 */     // GIR_Coverage, 22144,
     /*  816173 */     GIR_EraseRootFromParent_Done,
     /*  816174 */   // Label 12594: @816174
     /*  816174 */   GIM_Try, /*On fail goto*//*Label 12595*/ GIMT_Encode4(816249), // Rule ID 22145 //
     /*  816179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  816196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816225 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16),
     /*  816228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816247 */     GIR_RootConstrainSelectedInstOperands,
     /*  816248 */     // GIR_Coverage, 22145,
     /*  816248 */     GIR_EraseRootFromParent_Done,
     /*  816249 */   // Label 12595: @816249
     /*  816249 */   GIM_Try, /*On fail goto*//*Label 12596*/ GIMT_Encode4(816324), // Rule ID 22148 //
     /*  816254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816322 */     GIR_RootConstrainSelectedInstOperands,
     /*  816323 */     // GIR_Coverage, 22148,
     /*  816323 */     GIR_EraseRootFromParent_Done,
     /*  816324 */   // Label 12596: @816324
     /*  816324 */   GIM_Try, /*On fail goto*//*Label 12597*/ GIMT_Encode4(816399), // Rule ID 22149 //
     /*  816329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  816346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816375 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32),
     /*  816378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816397 */     GIR_RootConstrainSelectedInstOperands,
     /*  816398 */     // GIR_Coverage, 22149,
     /*  816398 */     GIR_EraseRootFromParent_Done,
     /*  816399 */   // Label 12597: @816399
     /*  816399 */   GIM_Try, /*On fail goto*//*Label 12598*/ GIMT_Encode4(816474), // Rule ID 22152 //
     /*  816404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  816421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  816450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  816453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816472 */     GIR_RootConstrainSelectedInstOperands,
     /*  816473 */     // GIR_Coverage, 22152,
     /*  816473 */     GIR_EraseRootFromParent_Done,
     /*  816474 */   // Label 12598: @816474
     /*  816474 */   GIM_Try, /*On fail goto*//*Label 12599*/ GIMT_Encode4(816549), // Rule ID 22153 //
     /*  816479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  816490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  816493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  816496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  816499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816525 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  816525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8),
     /*  816528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  816544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816547 */     GIR_RootConstrainSelectedInstOperands,
     /*  816548 */     // GIR_Coverage, 22153,
     /*  816548 */     GIR_EraseRootFromParent_Done,
     /*  816549 */   // Label 12599: @816549
     /*  816549 */   GIM_Try, /*On fail goto*//*Label 12600*/ GIMT_Encode4(816624), // Rule ID 22156 //
     /*  816554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  816571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  816600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  816603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816622 */     GIR_RootConstrainSelectedInstOperands,
     /*  816623 */     // GIR_Coverage, 22156,
     /*  816623 */     GIR_EraseRootFromParent_Done,
     /*  816624 */   // Label 12600: @816624
     /*  816624 */   GIM_Try, /*On fail goto*//*Label 12601*/ GIMT_Encode4(816699), // Rule ID 22157 //
     /*  816629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  816640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  816643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  816646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  816649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  816675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16),
     /*  816678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  816694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816697 */     GIR_RootConstrainSelectedInstOperands,
     /*  816698 */     // GIR_Coverage, 22157,
     /*  816698 */     GIR_EraseRootFromParent_Done,
     /*  816699 */   // Label 12601: @816699
     /*  816699 */   GIM_Try, /*On fail goto*//*Label 12602*/ GIMT_Encode4(816774), // Rule ID 22160 //
     /*  816704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  816707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  816721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  816750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  816753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816772 */     GIR_RootConstrainSelectedInstOperands,
     /*  816773 */     // GIR_Coverage, 22160,
     /*  816773 */     GIR_EraseRootFromParent_Done,
     /*  816774 */   // Label 12602: @816774
     /*  816774 */   GIM_Try, /*On fail goto*//*Label 12603*/ GIMT_Encode4(816849), // Rule ID 22161 //
     /*  816779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  816782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  816790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  816793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  816796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  816799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816825 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  816825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32),
     /*  816828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  816844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816847 */     GIR_RootConstrainSelectedInstOperands,
     /*  816848 */     // GIR_Coverage, 22161,
     /*  816848 */     GIR_EraseRootFromParent_Done,
     /*  816849 */   // Label 12603: @816849
     /*  816849 */   GIM_Try, /*On fail goto*//*Label 12604*/ GIMT_Encode4(816924), // Rule ID 22164 //
     /*  816854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  816857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  816871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  816877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  816900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  816903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816922 */     GIR_RootConstrainSelectedInstOperands,
     /*  816923 */     // GIR_Coverage, 22164,
     /*  816923 */     GIR_EraseRootFromParent_Done,
     /*  816924 */   // Label 12604: @816924
     /*  816924 */   GIM_Try, /*On fail goto*//*Label 12605*/ GIMT_Encode4(816999), // Rule ID 22165 //
     /*  816929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  816932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  816937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  816940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  816943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  816946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  816949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  816952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  816968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  816975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  816975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64),
     /*  816978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  816980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  816982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  816984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  816986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  816991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  816994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  816997 */     GIR_RootConstrainSelectedInstOperands,
     /*  816998 */     // GIR_Coverage, 22165,
     /*  816998 */     GIR_EraseRootFromParent_Done,
     /*  816999 */   // Label 12605: @816999
     /*  816999 */   GIM_Try, /*On fail goto*//*Label 12606*/ GIMT_Encode4(817074), // Rule ID 22168 //
     /*  817004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817072 */     GIR_RootConstrainSelectedInstOperands,
     /*  817073 */     // GIR_Coverage, 22168,
     /*  817073 */     GIR_EraseRootFromParent_Done,
     /*  817074 */   // Label 12606: @817074
     /*  817074 */   GIM_Try, /*On fail goto*//*Label 12607*/ GIMT_Encode4(817149), // Rule ID 22169 //
     /*  817079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  817096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8),
     /*  817128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817147 */     GIR_RootConstrainSelectedInstOperands,
     /*  817148 */     // GIR_Coverage, 22169,
     /*  817148 */     GIR_EraseRootFromParent_Done,
     /*  817149 */   // Label 12607: @817149
     /*  817149 */   GIM_Try, /*On fail goto*//*Label 12608*/ GIMT_Encode4(817224), // Rule ID 22172 //
     /*  817154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817222 */     GIR_RootConstrainSelectedInstOperands,
     /*  817223 */     // GIR_Coverage, 22172,
     /*  817223 */     GIR_EraseRootFromParent_Done,
     /*  817224 */   // Label 12608: @817224
     /*  817224 */   GIM_Try, /*On fail goto*//*Label 12609*/ GIMT_Encode4(817299), // Rule ID 22173 //
     /*  817229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  817246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817275 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8),
     /*  817278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817297 */     GIR_RootConstrainSelectedInstOperands,
     /*  817298 */     // GIR_Coverage, 22173,
     /*  817298 */     GIR_EraseRootFromParent_Done,
     /*  817299 */   // Label 12609: @817299
     /*  817299 */   GIM_Try, /*On fail goto*//*Label 12610*/ GIMT_Encode4(817374), // Rule ID 22176 //
     /*  817304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  817350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817372 */     GIR_RootConstrainSelectedInstOperands,
     /*  817373 */     // GIR_Coverage, 22176,
     /*  817373 */     GIR_EraseRootFromParent_Done,
     /*  817374 */   // Label 12610: @817374
     /*  817374 */   GIM_Try, /*On fail goto*//*Label 12611*/ GIMT_Encode4(817449), // Rule ID 22177 //
     /*  817379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  817390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  817393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  817396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  817399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817425 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11442:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  817425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8),
     /*  817428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  817444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817447 */     GIR_RootConstrainSelectedInstOperands,
     /*  817448 */     // GIR_Coverage, 22177,
     /*  817448 */     GIR_EraseRootFromParent_Done,
     /*  817449 */   // Label 12611: @817449
     /*  817449 */   GIM_Try, /*On fail goto*//*Label 12612*/ GIMT_Encode4(817524), // Rule ID 22180 //
     /*  817454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  817471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  817503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817522 */     GIR_RootConstrainSelectedInstOperands,
     /*  817523 */     // GIR_Coverage, 22180,
     /*  817523 */     GIR_EraseRootFromParent_Done,
     /*  817524 */   // Label 12612: @817524
     /*  817524 */   GIM_Try, /*On fail goto*//*Label 12613*/ GIMT_Encode4(817599), // Rule ID 22181 //
     /*  817529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  817546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16),
     /*  817578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817597 */     GIR_RootConstrainSelectedInstOperands,
     /*  817598 */     // GIR_Coverage, 22181,
     /*  817598 */     GIR_EraseRootFromParent_Done,
     /*  817599 */   // Label 12613: @817599
     /*  817599 */   GIM_Try, /*On fail goto*//*Label 12614*/ GIMT_Encode4(817674), // Rule ID 22184 //
     /*  817604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  817621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  817653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817672 */     GIR_RootConstrainSelectedInstOperands,
     /*  817673 */     // GIR_Coverage, 22184,
     /*  817673 */     GIR_EraseRootFromParent_Done,
     /*  817674 */   // Label 12614: @817674
     /*  817674 */   GIM_Try, /*On fail goto*//*Label 12615*/ GIMT_Encode4(817749), // Rule ID 22185 //
     /*  817679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  817696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  817714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817725 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16),
     /*  817728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817747 */     GIR_RootConstrainSelectedInstOperands,
     /*  817748 */     // GIR_Coverage, 22185,
     /*  817748 */     GIR_EraseRootFromParent_Done,
     /*  817749 */   // Label 12615: @817749
     /*  817749 */   GIM_Try, /*On fail goto*//*Label 12616*/ GIMT_Encode4(817824), // Rule ID 22188 //
     /*  817754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  817771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  817800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  817803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817822 */     GIR_RootConstrainSelectedInstOperands,
     /*  817823 */     // GIR_Coverage, 22188,
     /*  817823 */     GIR_EraseRootFromParent_Done,
     /*  817824 */   // Label 12616: @817824
     /*  817824 */   GIM_Try, /*On fail goto*//*Label 12617*/ GIMT_Encode4(817899), // Rule ID 22189 //
     /*  817829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  817840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  817843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  817846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  817849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  817852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  817864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11442:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  817875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16),
     /*  817878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  817894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817897 */     GIR_RootConstrainSelectedInstOperands,
     /*  817898 */     // GIR_Coverage, 22189,
     /*  817898 */     GIR_EraseRootFromParent_Done,
     /*  817899 */   // Label 12617: @817899
     /*  817899 */   GIM_Try, /*On fail goto*//*Label 12618*/ GIMT_Encode4(817974), // Rule ID 22192 //
     /*  817904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  817907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  817921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  817927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  817939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  817943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  817950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  817950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  817953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  817955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  817957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  817959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  817961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  817966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  817969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  817972 */     GIR_RootConstrainSelectedInstOperands,
     /*  817973 */     // GIR_Coverage, 22192,
     /*  817973 */     GIR_EraseRootFromParent_Done,
     /*  817974 */   // Label 12618: @817974
     /*  817974 */   GIM_Try, /*On fail goto*//*Label 12619*/ GIMT_Encode4(818049), // Rule ID 22193 //
     /*  817979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  817982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  817987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  817990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  817993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  817996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  817999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32),
     /*  818028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818047 */     GIR_RootConstrainSelectedInstOperands,
     /*  818048 */     // GIR_Coverage, 22193,
     /*  818048 */     GIR_EraseRootFromParent_Done,
     /*  818049 */   // Label 12619: @818049
     /*  818049 */   GIM_Try, /*On fail goto*//*Label 12620*/ GIMT_Encode4(818124), // Rule ID 22196 //
     /*  818054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818122 */     GIR_RootConstrainSelectedInstOperands,
     /*  818123 */     // GIR_Coverage, 22196,
     /*  818123 */     GIR_EraseRootFromParent_Done,
     /*  818124 */   // Label 12620: @818124
     /*  818124 */   GIM_Try, /*On fail goto*//*Label 12621*/ GIMT_Encode4(818199), // Rule ID 22197 //
     /*  818129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  818146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818175 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32),
     /*  818178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818197 */     GIR_RootConstrainSelectedInstOperands,
     /*  818198 */     // GIR_Coverage, 22197,
     /*  818198 */     GIR_EraseRootFromParent_Done,
     /*  818199 */   // Label 12621: @818199
     /*  818199 */   GIM_Try, /*On fail goto*//*Label 12622*/ GIMT_Encode4(818274), // Rule ID 22200 //
     /*  818204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  818250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818272 */     GIR_RootConstrainSelectedInstOperands,
     /*  818273 */     // GIR_Coverage, 22200,
     /*  818273 */     GIR_EraseRootFromParent_Done,
     /*  818274 */   // Label 12622: @818274
     /*  818274 */   GIM_Try, /*On fail goto*//*Label 12623*/ GIMT_Encode4(818349), // Rule ID 22201 //
     /*  818279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  818290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  818293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  818296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  818299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818325 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11442:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  818325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32),
     /*  818328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  818344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818347 */     GIR_RootConstrainSelectedInstOperands,
     /*  818348 */     // GIR_Coverage, 22201,
     /*  818348 */     GIR_EraseRootFromParent_Done,
     /*  818349 */   // Label 12623: @818349
     /*  818349 */   GIM_Try, /*On fail goto*//*Label 12624*/ GIMT_Encode4(818424), // Rule ID 22204 //
     /*  818354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  818357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  818400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818422 */     GIR_RootConstrainSelectedInstOperands,
     /*  818423 */     // GIR_Coverage, 22204,
     /*  818423 */     GIR_EraseRootFromParent_Done,
     /*  818424 */   // Label 12624: @818424
     /*  818424 */   GIM_Try, /*On fail goto*//*Label 12625*/ GIMT_Encode4(818499), // Rule ID 22205 //
     /*  818429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  818432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  818446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  818464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64),
     /*  818478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818497 */     GIR_RootConstrainSelectedInstOperands,
     /*  818498 */     // GIR_Coverage, 22205,
     /*  818498 */     GIR_EraseRootFromParent_Done,
     /*  818499 */   // Label 12625: @818499
     /*  818499 */   GIM_Try, /*On fail goto*//*Label 12626*/ GIMT_Encode4(818574), // Rule ID 22208 //
     /*  818504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  818507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  818521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818550 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  818550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  818553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818572 */     GIR_RootConstrainSelectedInstOperands,
     /*  818573 */     // GIR_Coverage, 22208,
     /*  818573 */     GIR_EraseRootFromParent_Done,
     /*  818574 */   // Label 12626: @818574
     /*  818574 */   GIM_Try, /*On fail goto*//*Label 12627*/ GIMT_Encode4(818649), // Rule ID 22209 //
     /*  818579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  818582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  818596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  818614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818625 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64),
     /*  818628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818647 */     GIR_RootConstrainSelectedInstOperands,
     /*  818648 */     // GIR_Coverage, 22209,
     /*  818648 */     GIR_EraseRootFromParent_Done,
     /*  818649 */   // Label 12627: @818649
     /*  818649 */   GIM_Try, /*On fail goto*//*Label 12628*/ GIMT_Encode4(818724), // Rule ID 22212 //
     /*  818654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  818657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  818671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  818700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  818703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818722 */     GIR_RootConstrainSelectedInstOperands,
     /*  818723 */     // GIR_Coverage, 22212,
     /*  818723 */     GIR_EraseRootFromParent_Done,
     /*  818724 */   // Label 12628: @818724
     /*  818724 */   GIM_Try, /*On fail goto*//*Label 12629*/ GIMT_Encode4(818799), // Rule ID 22213 //
     /*  818729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  818732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor),
     /*  818737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  818740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  818743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  818746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  818749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  818764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11442:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  818775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64),
     /*  818778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  818794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818797 */     GIR_RootConstrainSelectedInstOperands,
     /*  818798 */     // GIR_Coverage, 22213,
     /*  818798 */     GIR_EraseRootFromParent_Done,
     /*  818799 */   // Label 12629: @818799
     /*  818799 */   GIM_Try, /*On fail goto*//*Label 12630*/ GIMT_Encode4(818874), // Rule ID 22216 //
     /*  818804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  818812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  818821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  818850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  818853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818872 */     GIR_RootConstrainSelectedInstOperands,
     /*  818873 */     // GIR_Coverage, 22216,
     /*  818873 */     GIR_EraseRootFromParent_Done,
     /*  818874 */   // Label 12630: @818874
     /*  818874 */   GIM_Try, /*On fail goto*//*Label 12631*/ GIMT_Encode4(818949), // Rule ID 22217 //
     /*  818879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  818882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  818887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  818896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  818902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  818925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  818925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8),
     /*  818928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  818930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  818932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  818934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  818936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  818941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  818944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  818947 */     GIR_RootConstrainSelectedInstOperands,
     /*  818948 */     // GIR_Coverage, 22217,
     /*  818948 */     GIR_EraseRootFromParent_Done,
     /*  818949 */   // Label 12631: @818949
     /*  818949 */   GIM_Try, /*On fail goto*//*Label 12632*/ GIMT_Encode4(819024), // Rule ID 22220 //
     /*  818954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  818957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  818962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  818965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  818968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  818971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  818974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  818977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  818993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819022 */     GIR_RootConstrainSelectedInstOperands,
     /*  819023 */     // GIR_Coverage, 22220,
     /*  819023 */     GIR_EraseRootFromParent_Done,
     /*  819024 */   // Label 12632: @819024
     /*  819024 */   GIM_Try, /*On fail goto*//*Label 12633*/ GIMT_Encode4(819099), // Rule ID 22221 //
     /*  819029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  819046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819075 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8),
     /*  819078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819097 */     GIR_RootConstrainSelectedInstOperands,
     /*  819098 */     // GIR_Coverage, 22221,
     /*  819098 */     GIR_EraseRootFromParent_Done,
     /*  819099 */   // Label 12633: @819099
     /*  819099 */   GIM_Try, /*On fail goto*//*Label 12634*/ GIMT_Encode4(819174), // Rule ID 22224 //
     /*  819104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819172 */     GIR_RootConstrainSelectedInstOperands,
     /*  819173 */     // GIR_Coverage, 22224,
     /*  819173 */     GIR_EraseRootFromParent_Done,
     /*  819174 */   // Label 12634: @819174
     /*  819174 */   GIM_Try, /*On fail goto*//*Label 12635*/ GIMT_Encode4(819249), // Rule ID 22225 //
     /*  819179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  819196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8),
     /*  819228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819247 */     GIR_RootConstrainSelectedInstOperands,
     /*  819248 */     // GIR_Coverage, 22225,
     /*  819248 */     GIR_EraseRootFromParent_Done,
     /*  819249 */   // Label 12635: @819249
     /*  819249 */   GIM_Try, /*On fail goto*//*Label 12636*/ GIMT_Encode4(819324), // Rule ID 22228 //
     /*  819254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819322 */     GIR_RootConstrainSelectedInstOperands,
     /*  819323 */     // GIR_Coverage, 22228,
     /*  819323 */     GIR_EraseRootFromParent_Done,
     /*  819324 */   // Label 12636: @819324
     /*  819324 */   GIM_Try, /*On fail goto*//*Label 12637*/ GIMT_Encode4(819399), // Rule ID 22229 //
     /*  819329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  819346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  819375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16),
     /*  819378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819397 */     GIR_RootConstrainSelectedInstOperands,
     /*  819398 */     // GIR_Coverage, 22229,
     /*  819398 */     GIR_EraseRootFromParent_Done,
     /*  819399 */   // Label 12637: @819399
     /*  819399 */   GIM_Try, /*On fail goto*//*Label 12638*/ GIMT_Encode4(819474), // Rule ID 22232 //
     /*  819404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  819421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819450 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  819453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819472 */     GIR_RootConstrainSelectedInstOperands,
     /*  819473 */     // GIR_Coverage, 22232,
     /*  819473 */     GIR_EraseRootFromParent_Done,
     /*  819474 */   // Label 12638: @819474
     /*  819474 */   GIM_Try, /*On fail goto*//*Label 12639*/ GIMT_Encode4(819549), // Rule ID 22233 //
     /*  819479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  819496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  819525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16),
     /*  819528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819547 */     GIR_RootConstrainSelectedInstOperands,
     /*  819548 */     // GIR_Coverage, 22233,
     /*  819548 */     GIR_EraseRootFromParent_Done,
     /*  819549 */   // Label 12639: @819549
     /*  819549 */   GIM_Try, /*On fail goto*//*Label 12640*/ GIMT_Encode4(819624), // Rule ID 22236 //
     /*  819554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  819571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  819600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  819603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819622 */     GIR_RootConstrainSelectedInstOperands,
     /*  819623 */     // GIR_Coverage, 22236,
     /*  819623 */     GIR_EraseRootFromParent_Done,
     /*  819624 */   // Label 12640: @819624
     /*  819624 */   GIM_Try, /*On fail goto*//*Label 12641*/ GIMT_Encode4(819699), // Rule ID 22237 //
     /*  819629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  819640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  819643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  819646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  819649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  819675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32),
     /*  819678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  819694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819697 */     GIR_RootConstrainSelectedInstOperands,
     /*  819698 */     // GIR_Coverage, 22237,
     /*  819698 */     GIR_EraseRootFromParent_Done,
     /*  819699 */   // Label 12641: @819699
     /*  819699 */   GIM_Try, /*On fail goto*//*Label 12642*/ GIMT_Encode4(819774), // Rule ID 22240 //
     /*  819704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  819721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  819750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  819753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819772 */     GIR_RootConstrainSelectedInstOperands,
     /*  819773 */     // GIR_Coverage, 22240,
     /*  819773 */     GIR_EraseRootFromParent_Done,
     /*  819774 */   // Label 12642: @819774
     /*  819774 */   GIM_Try, /*On fail goto*//*Label 12643*/ GIMT_Encode4(819849), // Rule ID 22241 //
     /*  819779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  819790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  819793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  819796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  819799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  819825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8),
     /*  819828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  819844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819847 */     GIR_RootConstrainSelectedInstOperands,
     /*  819848 */     // GIR_Coverage, 22241,
     /*  819848 */     GIR_EraseRootFromParent_Done,
     /*  819849 */   // Label 12643: @819849
     /*  819849 */   GIM_Try, /*On fail goto*//*Label 12644*/ GIMT_Encode4(819924), // Rule ID 22244 //
     /*  819854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  819857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  819871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  819877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  819900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  819903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819922 */     GIR_RootConstrainSelectedInstOperands,
     /*  819923 */     // GIR_Coverage, 22244,
     /*  819923 */     GIR_EraseRootFromParent_Done,
     /*  819924 */   // Label 12644: @819924
     /*  819924 */   GIM_Try, /*On fail goto*//*Label 12645*/ GIMT_Encode4(819999), // Rule ID 22245 //
     /*  819929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  819932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  819937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  819940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  819943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  819946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  819949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  819952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  819968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  819975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  819975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16),
     /*  819978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  819980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  819982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  819984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  819986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  819991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  819994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  819997 */     GIR_RootConstrainSelectedInstOperands,
     /*  819998 */     // GIR_Coverage, 22245,
     /*  819998 */     GIR_EraseRootFromParent_Done,
     /*  819999 */   // Label 12645: @819999
     /*  819999 */   GIM_Try, /*On fail goto*//*Label 12646*/ GIMT_Encode4(820074), // Rule ID 22248 //
     /*  820004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820050 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  820050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820072 */     GIR_RootConstrainSelectedInstOperands,
     /*  820073 */     // GIR_Coverage, 22248,
     /*  820073 */     GIR_EraseRootFromParent_Done,
     /*  820074 */   // Label 12646: @820074
     /*  820074 */   GIM_Try, /*On fail goto*//*Label 12647*/ GIMT_Encode4(820149), // Rule ID 22249 //
     /*  820079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  820090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  820093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  820096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  820099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820125 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  820125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32),
     /*  820128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  820144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820147 */     GIR_RootConstrainSelectedInstOperands,
     /*  820148 */     // GIR_Coverage, 22249,
     /*  820148 */     GIR_EraseRootFromParent_Done,
     /*  820149 */   // Label 12647: @820149
     /*  820149 */   GIM_Try, /*On fail goto*//*Label 12648*/ GIMT_Encode4(820224), // Rule ID 22252 //
     /*  820154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  820157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820200 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  820200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820222 */     GIR_RootConstrainSelectedInstOperands,
     /*  820223 */     // GIR_Coverage, 22252,
     /*  820223 */     GIR_EraseRootFromParent_Done,
     /*  820224 */   // Label 12648: @820224
     /*  820224 */   GIM_Try, /*On fail goto*//*Label 12649*/ GIMT_Encode4(820299), // Rule ID 22253 //
     /*  820229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  820232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  820240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  820243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  820246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  820249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820275 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  820275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64),
     /*  820278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  820294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820297 */     GIR_RootConstrainSelectedInstOperands,
     /*  820298 */     // GIR_Coverage, 22253,
     /*  820298 */     GIR_EraseRootFromParent_Done,
     /*  820299 */   // Label 12649: @820299
     /*  820299 */   GIM_Try, /*On fail goto*//*Label 12650*/ GIMT_Encode4(820374), // Rule ID 22256 //
     /*  820304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820372 */     GIR_RootConstrainSelectedInstOperands,
     /*  820373 */     // GIR_Coverage, 22256,
     /*  820373 */     GIR_EraseRootFromParent_Done,
     /*  820374 */   // Label 12650: @820374
     /*  820374 */   GIM_Try, /*On fail goto*//*Label 12651*/ GIMT_Encode4(820449), // Rule ID 22257 //
     /*  820379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  820396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820425 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8),
     /*  820428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820447 */     GIR_RootConstrainSelectedInstOperands,
     /*  820448 */     // GIR_Coverage, 22257,
     /*  820448 */     GIR_EraseRootFromParent_Done,
     /*  820449 */   // Label 12651: @820449
     /*  820449 */   GIM_Try, /*On fail goto*//*Label 12652*/ GIMT_Encode4(820524), // Rule ID 22260 //
     /*  820454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  820471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  820489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820500 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  820503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820522 */     GIR_RootConstrainSelectedInstOperands,
     /*  820523 */     // GIR_Coverage, 22260,
     /*  820523 */     GIR_EraseRootFromParent_Done,
     /*  820524 */   // Label 12652: @820524
     /*  820524 */   GIM_Try, /*On fail goto*//*Label 12653*/ GIMT_Encode4(820599), // Rule ID 22261 //
     /*  820529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  820546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  820564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820575 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8),
     /*  820578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820597 */     GIR_RootConstrainSelectedInstOperands,
     /*  820598 */     // GIR_Coverage, 22261,
     /*  820598 */     GIR_EraseRootFromParent_Done,
     /*  820599 */   // Label 12653: @820599
     /*  820599 */   GIM_Try, /*On fail goto*//*Label 12654*/ GIMT_Encode4(820674), // Rule ID 22264 //
     /*  820604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  820621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  820639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  820650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  820653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820672 */     GIR_RootConstrainSelectedInstOperands,
     /*  820673 */     // GIR_Coverage, 22264,
     /*  820673 */     GIR_EraseRootFromParent_Done,
     /*  820674 */   // Label 12654: @820674
     /*  820674 */   GIM_Try, /*On fail goto*//*Label 12655*/ GIMT_Encode4(820749), // Rule ID 22265 //
     /*  820679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  820690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  820693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  820696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  820699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  820714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820725 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11436:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  820725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8),
     /*  820728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  820744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820747 */     GIR_RootConstrainSelectedInstOperands,
     /*  820748 */     // GIR_Coverage, 22265,
     /*  820748 */     GIR_EraseRootFromParent_Done,
     /*  820749 */   // Label 12655: @820749
     /*  820749 */   GIM_Try, /*On fail goto*//*Label 12656*/ GIMT_Encode4(820824), // Rule ID 22268 //
     /*  820754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  820771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  820803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820822 */     GIR_RootConstrainSelectedInstOperands,
     /*  820823 */     // GIR_Coverage, 22268,
     /*  820823 */     GIR_EraseRootFromParent_Done,
     /*  820824 */   // Label 12656: @820824
     /*  820824 */   GIM_Try, /*On fail goto*//*Label 12657*/ GIMT_Encode4(820899), // Rule ID 22269 //
     /*  820829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  820846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  820852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  820864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  820875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16),
     /*  820878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820897 */     GIR_RootConstrainSelectedInstOperands,
     /*  820898 */     // GIR_Coverage, 22269,
     /*  820898 */     GIR_EraseRootFromParent_Done,
     /*  820899 */   // Label 12657: @820899
     /*  820899 */   GIM_Try, /*On fail goto*//*Label 12658*/ GIMT_Encode4(820974), // Rule ID 22272 //
     /*  820904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  820907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  820921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  820927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  820939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  820943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  820950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  820950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  820953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  820955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  820957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  820959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  820961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  820966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  820969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  820972 */     GIR_RootConstrainSelectedInstOperands,
     /*  820973 */     // GIR_Coverage, 22272,
     /*  820973 */     GIR_EraseRootFromParent_Done,
     /*  820974 */   // Label 12658: @820974
     /*  820974 */   GIM_Try, /*On fail goto*//*Label 12659*/ GIMT_Encode4(821049), // Rule ID 22273 //
     /*  820979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  820982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  820987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  820990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  820993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  820996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  820999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821025 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16),
     /*  821028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821047 */     GIR_RootConstrainSelectedInstOperands,
     /*  821048 */     // GIR_Coverage, 22273,
     /*  821048 */     GIR_EraseRootFromParent_Done,
     /*  821049 */   // Label 12659: @821049
     /*  821049 */   GIM_Try, /*On fail goto*//*Label 12660*/ GIMT_Encode4(821124), // Rule ID 22276 //
     /*  821054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  821100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821122 */     GIR_RootConstrainSelectedInstOperands,
     /*  821123 */     // GIR_Coverage, 22276,
     /*  821123 */     GIR_EraseRootFromParent_Done,
     /*  821124 */   // Label 12660: @821124
     /*  821124 */   GIM_Try, /*On fail goto*//*Label 12661*/ GIMT_Encode4(821199), // Rule ID 22277 //
     /*  821129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  821140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  821143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  821146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  821149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11436:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  821175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16),
     /*  821178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  821194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821197 */     GIR_RootConstrainSelectedInstOperands,
     /*  821198 */     // GIR_Coverage, 22277,
     /*  821198 */     GIR_EraseRootFromParent_Done,
     /*  821199 */   // Label 12661: @821199
     /*  821199 */   GIM_Try, /*On fail goto*//*Label 12662*/ GIMT_Encode4(821274), // Rule ID 22280 //
     /*  821204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821272 */     GIR_RootConstrainSelectedInstOperands,
     /*  821273 */     // GIR_Coverage, 22280,
     /*  821273 */     GIR_EraseRootFromParent_Done,
     /*  821274 */   // Label 12662: @821274
     /*  821274 */   GIM_Try, /*On fail goto*//*Label 12663*/ GIMT_Encode4(821349), // Rule ID 22281 //
     /*  821279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  821296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821325 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32),
     /*  821328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821347 */     GIR_RootConstrainSelectedInstOperands,
     /*  821348 */     // GIR_Coverage, 22281,
     /*  821348 */     GIR_EraseRootFromParent_Done,
     /*  821349 */   // Label 12663: @821349
     /*  821349 */   GIM_Try, /*On fail goto*//*Label 12664*/ GIMT_Encode4(821424), // Rule ID 22284 //
     /*  821354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821422 */     GIR_RootConstrainSelectedInstOperands,
     /*  821423 */     // GIR_Coverage, 22284,
     /*  821423 */     GIR_EraseRootFromParent_Done,
     /*  821424 */   // Label 12664: @821424
     /*  821424 */   GIM_Try, /*On fail goto*//*Label 12665*/ GIMT_Encode4(821499), // Rule ID 22285 //
     /*  821429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  821446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821475 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32),
     /*  821478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821497 */     GIR_RootConstrainSelectedInstOperands,
     /*  821498 */     // GIR_Coverage, 22285,
     /*  821498 */     GIR_EraseRootFromParent_Done,
     /*  821499 */   // Label 12665: @821499
     /*  821499 */   GIM_Try, /*On fail goto*//*Label 12666*/ GIMT_Encode4(821574), // Rule ID 22288 //
     /*  821504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  821507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  821521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  821550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  821553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821572 */     GIR_RootConstrainSelectedInstOperands,
     /*  821573 */     // GIR_Coverage, 22288,
     /*  821573 */     GIR_EraseRootFromParent_Done,
     /*  821574 */   // Label 12666: @821574
     /*  821574 */   GIM_Try, /*On fail goto*//*Label 12667*/ GIMT_Encode4(821649), // Rule ID 22289 //
     /*  821579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  821582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  821590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  821593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  821596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  821599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11436:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  821625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32),
     /*  821628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  821644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821647 */     GIR_RootConstrainSelectedInstOperands,
     /*  821648 */     // GIR_Coverage, 22289,
     /*  821648 */     GIR_EraseRootFromParent_Done,
     /*  821649 */   // Label 12667: @821649
     /*  821649 */   GIM_Try, /*On fail goto*//*Label 12668*/ GIMT_Encode4(821724), // Rule ID 22292 //
     /*  821654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  821671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  821703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821722 */     GIR_RootConstrainSelectedInstOperands,
     /*  821723 */     // GIR_Coverage, 22292,
     /*  821723 */     GIR_EraseRootFromParent_Done,
     /*  821724 */   // Label 12668: @821724
     /*  821724 */   GIM_Try, /*On fail goto*//*Label 12669*/ GIMT_Encode4(821799), // Rule ID 22293 //
     /*  821729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  821746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  821764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64),
     /*  821778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821797 */     GIR_RootConstrainSelectedInstOperands,
     /*  821798 */     // GIR_Coverage, 22293,
     /*  821798 */     GIR_EraseRootFromParent_Done,
     /*  821799 */   // Label 12669: @821799
     /*  821799 */   GIM_Try, /*On fail goto*//*Label 12670*/ GIMT_Encode4(821874), // Rule ID 22296 //
     /*  821804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  821821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821850 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  821850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  821853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821872 */     GIR_RootConstrainSelectedInstOperands,
     /*  821873 */     // GIR_Coverage, 22296,
     /*  821873 */     GIR_EraseRootFromParent_Done,
     /*  821874 */   // Label 12670: @821874
     /*  821874 */   GIM_Try, /*On fail goto*//*Label 12671*/ GIMT_Encode4(821949), // Rule ID 22297 //
     /*  821879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  821882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  821896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  821902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  821914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  821925 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  821925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64),
     /*  821928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  821930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  821932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  821934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  821936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  821941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  821944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  821947 */     GIR_RootConstrainSelectedInstOperands,
     /*  821948 */     // GIR_Coverage, 22297,
     /*  821948 */     GIR_EraseRootFromParent_Done,
     /*  821949 */   // Label 12671: @821949
     /*  821949 */   GIM_Try, /*On fail goto*//*Label 12672*/ GIMT_Encode4(822024), // Rule ID 22300 //
     /*  821954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  821957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  821962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  821965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  821968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  821971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  821974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  821977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  821989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  821993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  822000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822022 */     GIR_RootConstrainSelectedInstOperands,
     /*  822023 */     // GIR_Coverage, 22300,
     /*  822023 */     GIR_EraseRootFromParent_Done,
     /*  822024 */   // Label 12672: @822024
     /*  822024 */   GIM_Try, /*On fail goto*//*Label 12673*/ GIMT_Encode4(822099), // Rule ID 22301 //
     /*  822029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  822032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu),
     /*  822037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  822040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  822043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  822046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  822049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  822064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11436:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  822075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64),
     /*  822078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  822094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822097 */     GIR_RootConstrainSelectedInstOperands,
     /*  822098 */     // GIR_Coverage, 22301,
     /*  822098 */     GIR_EraseRootFromParent_Done,
     /*  822099 */   // Label 12673: @822099
     /*  822099 */   GIM_Try, /*On fail goto*//*Label 12674*/ GIMT_Encode4(822174), // Rule ID 22304 //
     /*  822104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822172 */     GIR_RootConstrainSelectedInstOperands,
     /*  822173 */     // GIR_Coverage, 22304,
     /*  822173 */     GIR_EraseRootFromParent_Done,
     /*  822174 */   // Label 12674: @822174
     /*  822174 */   GIM_Try, /*On fail goto*//*Label 12675*/ GIMT_Encode4(822249), // Rule ID 22305 //
     /*  822179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  822196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8),
     /*  822228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822247 */     GIR_RootConstrainSelectedInstOperands,
     /*  822248 */     // GIR_Coverage, 22305,
     /*  822248 */     GIR_EraseRootFromParent_Done,
     /*  822249 */   // Label 12675: @822249
     /*  822249 */   GIM_Try, /*On fail goto*//*Label 12676*/ GIMT_Encode4(822324), // Rule ID 22308 //
     /*  822254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822322 */     GIR_RootConstrainSelectedInstOperands,
     /*  822323 */     // GIR_Coverage, 22308,
     /*  822323 */     GIR_EraseRootFromParent_Done,
     /*  822324 */   // Label 12676: @822324
     /*  822324 */   GIM_Try, /*On fail goto*//*Label 12677*/ GIMT_Encode4(822399), // Rule ID 22309 //
     /*  822329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  822346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822375 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8),
     /*  822378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822397 */     GIR_RootConstrainSelectedInstOperands,
     /*  822398 */     // GIR_Coverage, 22309,
     /*  822398 */     GIR_EraseRootFromParent_Done,
     /*  822399 */   // Label 12677: @822399
     /*  822399 */   GIM_Try, /*On fail goto*//*Label 12678*/ GIMT_Encode4(822474), // Rule ID 22312 //
     /*  822404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  822421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  822450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  822453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822472 */     GIR_RootConstrainSelectedInstOperands,
     /*  822473 */     // GIR_Coverage, 22312,
     /*  822473 */     GIR_EraseRootFromParent_Done,
     /*  822474 */   // Label 12678: @822474
     /*  822474 */   GIM_Try, /*On fail goto*//*Label 12679*/ GIMT_Encode4(822549), // Rule ID 22313 //
     /*  822479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  822490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  822493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  822496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  822499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822525 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  822525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8),
     /*  822528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  822544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822547 */     GIR_RootConstrainSelectedInstOperands,
     /*  822548 */     // GIR_Coverage, 22313,
     /*  822548 */     GIR_EraseRootFromParent_Done,
     /*  822549 */   // Label 12679: @822549
     /*  822549 */   GIM_Try, /*On fail goto*//*Label 12680*/ GIMT_Encode4(822624), // Rule ID 22316 //
     /*  822554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  822571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  822603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822622 */     GIR_RootConstrainSelectedInstOperands,
     /*  822623 */     // GIR_Coverage, 22316,
     /*  822623 */     GIR_EraseRootFromParent_Done,
     /*  822624 */   // Label 12680: @822624
     /*  822624 */   GIM_Try, /*On fail goto*//*Label 12681*/ GIMT_Encode4(822699), // Rule ID 22317 //
     /*  822629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  822646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16),
     /*  822678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822697 */     GIR_RootConstrainSelectedInstOperands,
     /*  822698 */     // GIR_Coverage, 22317,
     /*  822698 */     GIR_EraseRootFromParent_Done,
     /*  822699 */   // Label 12681: @822699
     /*  822699 */   GIM_Try, /*On fail goto*//*Label 12682*/ GIMT_Encode4(822774), // Rule ID 22320 //
     /*  822704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  822721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  822750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  822753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822772 */     GIR_RootConstrainSelectedInstOperands,
     /*  822773 */     // GIR_Coverage, 22320,
     /*  822773 */     GIR_EraseRootFromParent_Done,
     /*  822774 */   // Label 12682: @822774
     /*  822774 */   GIM_Try, /*On fail goto*//*Label 12683*/ GIMT_Encode4(822849), // Rule ID 22321 //
     /*  822779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  822790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  822793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  822796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  822799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  822825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16),
     /*  822828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  822844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822847 */     GIR_RootConstrainSelectedInstOperands,
     /*  822848 */     // GIR_Coverage, 22321,
     /*  822848 */     GIR_EraseRootFromParent_Done,
     /*  822849 */   // Label 12683: @822849
     /*  822849 */   GIM_Try, /*On fail goto*//*Label 12684*/ GIMT_Encode4(822924), // Rule ID 22324 //
     /*  822854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  822857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  822871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  822877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  822900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  822903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822922 */     GIR_RootConstrainSelectedInstOperands,
     /*  822923 */     // GIR_Coverage, 22324,
     /*  822923 */     GIR_EraseRootFromParent_Done,
     /*  822924 */   // Label 12684: @822924
     /*  822924 */   GIM_Try, /*On fail goto*//*Label 12685*/ GIMT_Encode4(822999), // Rule ID 22325 //
     /*  822929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  822932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  822937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  822940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  822943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  822946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  822949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  822952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  822968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  822975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  822975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32),
     /*  822978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  822980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  822982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  822984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  822986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  822991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  822994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  822997 */     GIR_RootConstrainSelectedInstOperands,
     /*  822998 */     // GIR_Coverage, 22325,
     /*  822998 */     GIR_EraseRootFromParent_Done,
     /*  822999 */   // Label 12685: @822999
     /*  822999 */   GIM_Try, /*On fail goto*//*Label 12686*/ GIMT_Encode4(823074), // Rule ID 22328 //
     /*  823004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823072 */     GIR_RootConstrainSelectedInstOperands,
     /*  823073 */     // GIR_Coverage, 22328,
     /*  823073 */     GIR_EraseRootFromParent_Done,
     /*  823074 */   // Label 12686: @823074
     /*  823074 */   GIM_Try, /*On fail goto*//*Label 12687*/ GIMT_Encode4(823149), // Rule ID 22329 //
     /*  823079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  823096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8),
     /*  823128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823147 */     GIR_RootConstrainSelectedInstOperands,
     /*  823148 */     // GIR_Coverage, 22329,
     /*  823148 */     GIR_EraseRootFromParent_Done,
     /*  823149 */   // Label 12687: @823149
     /*  823149 */   GIM_Try, /*On fail goto*//*Label 12688*/ GIMT_Encode4(823224), // Rule ID 22332 //
     /*  823154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  823200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823222 */     GIR_RootConstrainSelectedInstOperands,
     /*  823223 */     // GIR_Coverage, 22332,
     /*  823223 */     GIR_EraseRootFromParent_Done,
     /*  823224 */   // Label 12688: @823224
     /*  823224 */   GIM_Try, /*On fail goto*//*Label 12689*/ GIMT_Encode4(823299), // Rule ID 22333 //
     /*  823229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  823240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  823243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  823246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  823249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  823275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16),
     /*  823278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  823294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823297 */     GIR_RootConstrainSelectedInstOperands,
     /*  823298 */     // GIR_Coverage, 22333,
     /*  823298 */     GIR_EraseRootFromParent_Done,
     /*  823299 */   // Label 12689: @823299
     /*  823299 */   GIM_Try, /*On fail goto*//*Label 12690*/ GIMT_Encode4(823374), // Rule ID 22336 //
     /*  823304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  823350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823372 */     GIR_RootConstrainSelectedInstOperands,
     /*  823373 */     // GIR_Coverage, 22336,
     /*  823373 */     GIR_EraseRootFromParent_Done,
     /*  823374 */   // Label 12690: @823374
     /*  823374 */   GIM_Try, /*On fail goto*//*Label 12691*/ GIMT_Encode4(823449), // Rule ID 22337 //
     /*  823379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  823390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  823393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  823396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  823399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  823425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32),
     /*  823428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  823444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823447 */     GIR_RootConstrainSelectedInstOperands,
     /*  823448 */     // GIR_Coverage, 22337,
     /*  823448 */     GIR_EraseRootFromParent_Done,
     /*  823449 */   // Label 12691: @823449
     /*  823449 */   GIM_Try, /*On fail goto*//*Label 12692*/ GIMT_Encode4(823524), // Rule ID 22340 //
     /*  823454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  823457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  823471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  823500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  823503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823522 */     GIR_RootConstrainSelectedInstOperands,
     /*  823523 */     // GIR_Coverage, 22340,
     /*  823523 */     GIR_EraseRootFromParent_Done,
     /*  823524 */   // Label 12692: @823524
     /*  823524 */   GIM_Try, /*On fail goto*//*Label 12693*/ GIMT_Encode4(823599), // Rule ID 22341 //
     /*  823529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  823532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  823540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  823543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  823546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  823549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823575 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  823575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64),
     /*  823578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  823594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823597 */     GIR_RootConstrainSelectedInstOperands,
     /*  823598 */     // GIR_Coverage, 22341,
     /*  823598 */     GIR_EraseRootFromParent_Done,
     /*  823599 */   // Label 12693: @823599
     /*  823599 */   GIM_Try, /*On fail goto*//*Label 12694*/ GIMT_Encode4(823674), // Rule ID 22344 //
     /*  823604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  823621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  823639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  823653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823672 */     GIR_RootConstrainSelectedInstOperands,
     /*  823673 */     // GIR_Coverage, 22344,
     /*  823673 */     GIR_EraseRootFromParent_Done,
     /*  823674 */   // Label 12694: @823674
     /*  823674 */   GIM_Try, /*On fail goto*//*Label 12695*/ GIMT_Encode4(823749), // Rule ID 22345 //
     /*  823679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  823696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  823714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823725 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8),
     /*  823728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823747 */     GIR_RootConstrainSelectedInstOperands,
     /*  823748 */     // GIR_Coverage, 22345,
     /*  823748 */     GIR_EraseRootFromParent_Done,
     /*  823749 */   // Label 12695: @823749
     /*  823749 */   GIM_Try, /*On fail goto*//*Label 12696*/ GIMT_Encode4(823824), // Rule ID 22348 //
     /*  823754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  823771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823800 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  823803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823822 */     GIR_RootConstrainSelectedInstOperands,
     /*  823823 */     // GIR_Coverage, 22348,
     /*  823823 */     GIR_EraseRootFromParent_Done,
     /*  823824 */   // Label 12696: @823824
     /*  823824 */   GIM_Try, /*On fail goto*//*Label 12697*/ GIMT_Encode4(823899), // Rule ID 22349 //
     /*  823829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  823846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  823852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  823864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823875 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  823875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8),
     /*  823878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823897 */     GIR_RootConstrainSelectedInstOperands,
     /*  823898 */     // GIR_Coverage, 22349,
     /*  823898 */     GIR_EraseRootFromParent_Done,
     /*  823899 */   // Label 12697: @823899
     /*  823899 */   GIM_Try, /*On fail goto*//*Label 12698*/ GIMT_Encode4(823974), // Rule ID 22352 //
     /*  823904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  823907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  823921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  823927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  823939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  823943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  823950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  823950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  823953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  823955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  823957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  823959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  823961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  823966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  823969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  823972 */     GIR_RootConstrainSelectedInstOperands,
     /*  823973 */     // GIR_Coverage, 22352,
     /*  823973 */     GIR_EraseRootFromParent_Done,
     /*  823974 */   // Label 12698: @823974
     /*  823974 */   GIM_Try, /*On fail goto*//*Label 12699*/ GIMT_Encode4(824049), // Rule ID 22353 //
     /*  823979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  823982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  823987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  823990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  823993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  823996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  823999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11434:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  824025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8),
     /*  824028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  824044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824047 */     GIR_RootConstrainSelectedInstOperands,
     /*  824048 */     // GIR_Coverage, 22353,
     /*  824048 */     GIR_EraseRootFromParent_Done,
     /*  824049 */   // Label 12699: @824049
     /*  824049 */   GIM_Try, /*On fail goto*//*Label 12700*/ GIMT_Encode4(824124), // Rule ID 22356 //
     /*  824054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824122 */     GIR_RootConstrainSelectedInstOperands,
     /*  824123 */     // GIR_Coverage, 22356,
     /*  824123 */     GIR_EraseRootFromParent_Done,
     /*  824124 */   // Label 12700: @824124
     /*  824124 */   GIM_Try, /*On fail goto*//*Label 12701*/ GIMT_Encode4(824199), // Rule ID 22357 //
     /*  824129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  824146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16),
     /*  824178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824197 */     GIR_RootConstrainSelectedInstOperands,
     /*  824198 */     // GIR_Coverage, 22357,
     /*  824198 */     GIR_EraseRootFromParent_Done,
     /*  824199 */   // Label 12701: @824199
     /*  824199 */   GIM_Try, /*On fail goto*//*Label 12702*/ GIMT_Encode4(824274), // Rule ID 22360 //
     /*  824204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824272 */     GIR_RootConstrainSelectedInstOperands,
     /*  824273 */     // GIR_Coverage, 22360,
     /*  824273 */     GIR_EraseRootFromParent_Done,
     /*  824274 */   // Label 12702: @824274
     /*  824274 */   GIM_Try, /*On fail goto*//*Label 12703*/ GIMT_Encode4(824349), // Rule ID 22361 //
     /*  824279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  824296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824325 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16),
     /*  824328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824347 */     GIR_RootConstrainSelectedInstOperands,
     /*  824348 */     // GIR_Coverage, 22361,
     /*  824348 */     GIR_EraseRootFromParent_Done,
     /*  824349 */   // Label 12703: @824349
     /*  824349 */   GIM_Try, /*On fail goto*//*Label 12704*/ GIMT_Encode4(824424), // Rule ID 22364 //
     /*  824354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  824400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824422 */     GIR_RootConstrainSelectedInstOperands,
     /*  824423 */     // GIR_Coverage, 22364,
     /*  824423 */     GIR_EraseRootFromParent_Done,
     /*  824424 */   // Label 12704: @824424
     /*  824424 */   GIM_Try, /*On fail goto*//*Label 12705*/ GIMT_Encode4(824499), // Rule ID 22365 //
     /*  824429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  824440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  824443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  824446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  824449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11434:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  824475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16),
     /*  824478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  824494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824497 */     GIR_RootConstrainSelectedInstOperands,
     /*  824498 */     // GIR_Coverage, 22365,
     /*  824498 */     GIR_EraseRootFromParent_Done,
     /*  824499 */   // Label 12705: @824499
     /*  824499 */   GIM_Try, /*On fail goto*//*Label 12706*/ GIMT_Encode4(824574), // Rule ID 22368 //
     /*  824504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  824521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  824553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824572 */     GIR_RootConstrainSelectedInstOperands,
     /*  824573 */     // GIR_Coverage, 22368,
     /*  824573 */     GIR_EraseRootFromParent_Done,
     /*  824574 */   // Label 12706: @824574
     /*  824574 */   GIM_Try, /*On fail goto*//*Label 12707*/ GIMT_Encode4(824649), // Rule ID 22369 //
     /*  824579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  824596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32),
     /*  824628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824647 */     GIR_RootConstrainSelectedInstOperands,
     /*  824648 */     // GIR_Coverage, 22369,
     /*  824648 */     GIR_EraseRootFromParent_Done,
     /*  824649 */   // Label 12707: @824649
     /*  824649 */   GIM_Try, /*On fail goto*//*Label 12708*/ GIMT_Encode4(824724), // Rule ID 22372 //
     /*  824654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  824671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  824703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824722 */     GIR_RootConstrainSelectedInstOperands,
     /*  824723 */     // GIR_Coverage, 22372,
     /*  824723 */     GIR_EraseRootFromParent_Done,
     /*  824724 */   // Label 12708: @824724
     /*  824724 */   GIM_Try, /*On fail goto*//*Label 12709*/ GIMT_Encode4(824799), // Rule ID 22373 //
     /*  824729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  824746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  824764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32),
     /*  824778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824797 */     GIR_RootConstrainSelectedInstOperands,
     /*  824798 */     // GIR_Coverage, 22373,
     /*  824798 */     GIR_EraseRootFromParent_Done,
     /*  824799 */   // Label 12709: @824799
     /*  824799 */   GIM_Try, /*On fail goto*//*Label 12710*/ GIMT_Encode4(824874), // Rule ID 22376 //
     /*  824804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  824807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  824821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  824850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  824853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824872 */     GIR_RootConstrainSelectedInstOperands,
     /*  824873 */     // GIR_Coverage, 22376,
     /*  824873 */     GIR_EraseRootFromParent_Done,
     /*  824874 */   // Label 12710: @824874
     /*  824874 */   GIM_Try, /*On fail goto*//*Label 12711*/ GIMT_Encode4(824949), // Rule ID 22377 //
     /*  824879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  824882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  824890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  824893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  824896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  824899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  824902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  824914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  824925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11434:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  824925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32),
     /*  824928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  824930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  824932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  824934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  824936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  824941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  824944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  824947 */     GIR_RootConstrainSelectedInstOperands,
     /*  824948 */     // GIR_Coverage, 22377,
     /*  824948 */     GIR_EraseRootFromParent_Done,
     /*  824949 */   // Label 12711: @824949
     /*  824949 */   GIM_Try, /*On fail goto*//*Label 12712*/ GIMT_Encode4(825024), // Rule ID 22380 //
     /*  824954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  824957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  824962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  824965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  824968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  824971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  824974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  824977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  824989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  824993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825022 */     GIR_RootConstrainSelectedInstOperands,
     /*  825023 */     // GIR_Coverage, 22380,
     /*  825023 */     GIR_EraseRootFromParent_Done,
     /*  825024 */   // Label 12712: @825024
     /*  825024 */   GIM_Try, /*On fail goto*//*Label 12713*/ GIMT_Encode4(825099), // Rule ID 22381 //
     /*  825029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  825046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  825064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64),
     /*  825078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825097 */     GIR_RootConstrainSelectedInstOperands,
     /*  825098 */     // GIR_Coverage, 22381,
     /*  825098 */     GIR_EraseRootFromParent_Done,
     /*  825099 */   // Label 12713: @825099
     /*  825099 */   GIM_Try, /*On fail goto*//*Label 12714*/ GIMT_Encode4(825174), // Rule ID 22384 //
     /*  825104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825172 */     GIR_RootConstrainSelectedInstOperands,
     /*  825173 */     // GIR_Coverage, 22384,
     /*  825173 */     GIR_EraseRootFromParent_Done,
     /*  825174 */   // Label 12714: @825174
     /*  825174 */   GIM_Try, /*On fail goto*//*Label 12715*/ GIMT_Encode4(825249), // Rule ID 22385 //
     /*  825179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  825196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  825214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825225 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64),
     /*  825228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825247 */     GIR_RootConstrainSelectedInstOperands,
     /*  825248 */     // GIR_Coverage, 22385,
     /*  825248 */     GIR_EraseRootFromParent_Done,
     /*  825249 */   // Label 12715: @825249
     /*  825249 */   GIM_Try, /*On fail goto*//*Label 12716*/ GIMT_Encode4(825324), // Rule ID 22388 //
     /*  825254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  825257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  825300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825322 */     GIR_RootConstrainSelectedInstOperands,
     /*  825323 */     // GIR_Coverage, 22388,
     /*  825323 */     GIR_EraseRootFromParent_Done,
     /*  825324 */   // Label 12716: @825324
     /*  825324 */   GIM_Try, /*On fail goto*//*Label 12717*/ GIMT_Encode4(825399), // Rule ID 22389 //
     /*  825329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  825332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin),
     /*  825337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  825340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  825343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  825346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  825349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  825364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11434:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  825375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64),
     /*  825378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  825394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825397 */     GIR_RootConstrainSelectedInstOperands,
     /*  825398 */     // GIR_Coverage, 22389,
     /*  825398 */     GIR_EraseRootFromParent_Done,
     /*  825399 */   // Label 12717: @825399
     /*  825399 */   GIM_Try, /*On fail goto*//*Label 12718*/ GIMT_Encode4(825474), // Rule ID 22392 //
     /*  825404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  825421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825450 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  825453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825472 */     GIR_RootConstrainSelectedInstOperands,
     /*  825473 */     // GIR_Coverage, 22392,
     /*  825473 */     GIR_EraseRootFromParent_Done,
     /*  825474 */   // Label 12718: @825474
     /*  825474 */   GIM_Try, /*On fail goto*//*Label 12719*/ GIMT_Encode4(825549), // Rule ID 22393 //
     /*  825479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  825496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825525 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8),
     /*  825528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825547 */     GIR_RootConstrainSelectedInstOperands,
     /*  825548 */     // GIR_Coverage, 22393,
     /*  825548 */     GIR_EraseRootFromParent_Done,
     /*  825549 */   // Label 12719: @825549
     /*  825549 */   GIM_Try, /*On fail goto*//*Label 12720*/ GIMT_Encode4(825624), // Rule ID 22396 //
     /*  825554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  825571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  825603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825622 */     GIR_RootConstrainSelectedInstOperands,
     /*  825623 */     // GIR_Coverage, 22396,
     /*  825623 */     GIR_EraseRootFromParent_Done,
     /*  825624 */   // Label 12720: @825624
     /*  825624 */   GIM_Try, /*On fail goto*//*Label 12721*/ GIMT_Encode4(825699), // Rule ID 22397 //
     /*  825629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  825646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825675 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8),
     /*  825678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825697 */     GIR_RootConstrainSelectedInstOperands,
     /*  825698 */     // GIR_Coverage, 22397,
     /*  825698 */     GIR_EraseRootFromParent_Done,
     /*  825699 */   // Label 12721: @825699
     /*  825699 */   GIM_Try, /*On fail goto*//*Label 12722*/ GIMT_Encode4(825774), // Rule ID 22400 //
     /*  825704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  825721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  825750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  825753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825772 */     GIR_RootConstrainSelectedInstOperands,
     /*  825773 */     // GIR_Coverage, 22400,
     /*  825773 */     GIR_EraseRootFromParent_Done,
     /*  825774 */   // Label 12722: @825774
     /*  825774 */   GIM_Try, /*On fail goto*//*Label 12723*/ GIMT_Encode4(825849), // Rule ID 22401 //
     /*  825779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  825790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  825793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  825796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  825799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  825825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8),
     /*  825828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  825844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825847 */     GIR_RootConstrainSelectedInstOperands,
     /*  825848 */     // GIR_Coverage, 22401,
     /*  825848 */     GIR_EraseRootFromParent_Done,
     /*  825849 */   // Label 12723: @825849
     /*  825849 */   GIM_Try, /*On fail goto*//*Label 12724*/ GIMT_Encode4(825924), // Rule ID 22404 //
     /*  825854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  825857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  825871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  825877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  825900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  825903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825922 */     GIR_RootConstrainSelectedInstOperands,
     /*  825923 */     // GIR_Coverage, 22404,
     /*  825923 */     GIR_EraseRootFromParent_Done,
     /*  825924 */   // Label 12724: @825924
     /*  825924 */   GIM_Try, /*On fail goto*//*Label 12725*/ GIMT_Encode4(825999), // Rule ID 22405 //
     /*  825929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  825932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  825937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  825940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  825943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  825946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  825949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  825952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  825968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  825975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  825975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16),
     /*  825978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  825980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  825982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  825984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  825986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  825991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  825994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  825997 */     GIR_RootConstrainSelectedInstOperands,
     /*  825998 */     // GIR_Coverage, 22405,
     /*  825998 */     GIR_EraseRootFromParent_Done,
     /*  825999 */   // Label 12725: @825999
     /*  825999 */   GIM_Try, /*On fail goto*//*Label 12726*/ GIMT_Encode4(826074), // Rule ID 22408 //
     /*  826004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826072 */     GIR_RootConstrainSelectedInstOperands,
     /*  826073 */     // GIR_Coverage, 22408,
     /*  826073 */     GIR_EraseRootFromParent_Done,
     /*  826074 */   // Label 12726: @826074
     /*  826074 */   GIM_Try, /*On fail goto*//*Label 12727*/ GIMT_Encode4(826149), // Rule ID 22409 //
     /*  826079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  826096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826125 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16),
     /*  826128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826147 */     GIR_RootConstrainSelectedInstOperands,
     /*  826148 */     // GIR_Coverage, 22409,
     /*  826148 */     GIR_EraseRootFromParent_Done,
     /*  826149 */   // Label 12727: @826149
     /*  826149 */   GIM_Try, /*On fail goto*//*Label 12728*/ GIMT_Encode4(826224), // Rule ID 22412 //
     /*  826154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  826200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826222 */     GIR_RootConstrainSelectedInstOperands,
     /*  826223 */     // GIR_Coverage, 22412,
     /*  826223 */     GIR_EraseRootFromParent_Done,
     /*  826224 */   // Label 12728: @826224
     /*  826224 */   GIM_Try, /*On fail goto*//*Label 12729*/ GIMT_Encode4(826299), // Rule ID 22413 //
     /*  826229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  826246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  826275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32),
     /*  826278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826297 */     GIR_RootConstrainSelectedInstOperands,
     /*  826298 */     // GIR_Coverage, 22413,
     /*  826298 */     GIR_EraseRootFromParent_Done,
     /*  826299 */   // Label 12729: @826299
     /*  826299 */   GIM_Try, /*On fail goto*//*Label 12730*/ GIMT_Encode4(826374), // Rule ID 22416 //
     /*  826304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826372 */     GIR_RootConstrainSelectedInstOperands,
     /*  826373 */     // GIR_Coverage, 22416,
     /*  826373 */     GIR_EraseRootFromParent_Done,
     /*  826374 */   // Label 12730: @826374
     /*  826374 */   GIM_Try, /*On fail goto*//*Label 12731*/ GIMT_Encode4(826449), // Rule ID 22417 //
     /*  826379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  826396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826425 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  826425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8),
     /*  826428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826447 */     GIR_RootConstrainSelectedInstOperands,
     /*  826448 */     // GIR_Coverage, 22417,
     /*  826448 */     GIR_EraseRootFromParent_Done,
     /*  826449 */   // Label 12731: @826449
     /*  826449 */   GIM_Try, /*On fail goto*//*Label 12732*/ GIMT_Encode4(826524), // Rule ID 22420 //
     /*  826454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  826471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  826500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  826503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826522 */     GIR_RootConstrainSelectedInstOperands,
     /*  826523 */     // GIR_Coverage, 22420,
     /*  826523 */     GIR_EraseRootFromParent_Done,
     /*  826524 */   // Label 12732: @826524
     /*  826524 */   GIM_Try, /*On fail goto*//*Label 12733*/ GIMT_Encode4(826599), // Rule ID 22421 //
     /*  826529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  826540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  826543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  826546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  826549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826575 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  826575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16),
     /*  826578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  826594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826597 */     GIR_RootConstrainSelectedInstOperands,
     /*  826598 */     // GIR_Coverage, 22421,
     /*  826598 */     GIR_EraseRootFromParent_Done,
     /*  826599 */   // Label 12733: @826599
     /*  826599 */   GIM_Try, /*On fail goto*//*Label 12734*/ GIMT_Encode4(826674), // Rule ID 22424 //
     /*  826604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  826621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  826650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  826653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826672 */     GIR_RootConstrainSelectedInstOperands,
     /*  826673 */     // GIR_Coverage, 22424,
     /*  826673 */     GIR_EraseRootFromParent_Done,
     /*  826674 */   // Label 12734: @826674
     /*  826674 */   GIM_Try, /*On fail goto*//*Label 12735*/ GIMT_Encode4(826749), // Rule ID 22425 //
     /*  826679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  826690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  826693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  826696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  826699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826725 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  826725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32),
     /*  826728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  826744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826747 */     GIR_RootConstrainSelectedInstOperands,
     /*  826748 */     // GIR_Coverage, 22425,
     /*  826748 */     GIR_EraseRootFromParent_Done,
     /*  826749 */   // Label 12735: @826749
     /*  826749 */   GIM_Try, /*On fail goto*//*Label 12736*/ GIMT_Encode4(826824), // Rule ID 22428 //
     /*  826754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  826757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  826771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  826800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  826803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826822 */     GIR_RootConstrainSelectedInstOperands,
     /*  826823 */     // GIR_Coverage, 22428,
     /*  826823 */     GIR_EraseRootFromParent_Done,
     /*  826824 */   // Label 12736: @826824
     /*  826824 */   GIM_Try, /*On fail goto*//*Label 12737*/ GIMT_Encode4(826899), // Rule ID 22429 //
     /*  826829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  826832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  826840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  826843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  826846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  826849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  826852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  826875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64),
     /*  826878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  826894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826897 */     GIR_RootConstrainSelectedInstOperands,
     /*  826898 */     // GIR_Coverage, 22429,
     /*  826898 */     GIR_EraseRootFromParent_Done,
     /*  826899 */   // Label 12737: @826899
     /*  826899 */   GIM_Try, /*On fail goto*//*Label 12738*/ GIMT_Encode4(826974), // Rule ID 22432 //
     /*  826904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  826907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  826921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  826927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  826939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  826943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  826950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  826950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  826953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  826955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  826957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  826959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  826961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  826966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  826969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  826972 */     GIR_RootConstrainSelectedInstOperands,
     /*  826973 */     // GIR_Coverage, 22432,
     /*  826973 */     GIR_EraseRootFromParent_Done,
     /*  826974 */   // Label 12738: @826974
     /*  826974 */   GIM_Try, /*On fail goto*//*Label 12739*/ GIMT_Encode4(827049), // Rule ID 22433 //
     /*  826979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  826982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  826987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  826990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  826993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  826996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  826999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8),
     /*  827028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827047 */     GIR_RootConstrainSelectedInstOperands,
     /*  827048 */     // GIR_Coverage, 22433,
     /*  827048 */     GIR_EraseRootFromParent_Done,
     /*  827049 */   // Label 12739: @827049
     /*  827049 */   GIM_Try, /*On fail goto*//*Label 12740*/ GIMT_Encode4(827124), // Rule ID 22436 //
     /*  827054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827122 */     GIR_RootConstrainSelectedInstOperands,
     /*  827123 */     // GIR_Coverage, 22436,
     /*  827123 */     GIR_EraseRootFromParent_Done,
     /*  827124 */   // Label 12740: @827124
     /*  827124 */   GIM_Try, /*On fail goto*//*Label 12741*/ GIMT_Encode4(827199), // Rule ID 22437 //
     /*  827129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  827146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827175 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8),
     /*  827178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827197 */     GIR_RootConstrainSelectedInstOperands,
     /*  827198 */     // GIR_Coverage, 22437,
     /*  827198 */     GIR_EraseRootFromParent_Done,
     /*  827199 */   // Label 12741: @827199
     /*  827199 */   GIM_Try, /*On fail goto*//*Label 12742*/ GIMT_Encode4(827274), // Rule ID 22440 //
     /*  827204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  827250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827272 */     GIR_RootConstrainSelectedInstOperands,
     /*  827273 */     // GIR_Coverage, 22440,
     /*  827273 */     GIR_EraseRootFromParent_Done,
     /*  827274 */   // Label 12742: @827274
     /*  827274 */   GIM_Try, /*On fail goto*//*Label 12743*/ GIMT_Encode4(827349), // Rule ID 22441 //
     /*  827279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  827290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  827293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  827296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  827299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11432:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  827325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8),
     /*  827328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  827344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827347 */     GIR_RootConstrainSelectedInstOperands,
     /*  827348 */     // GIR_Coverage, 22441,
     /*  827348 */     GIR_EraseRootFromParent_Done,
     /*  827349 */   // Label 12743: @827349
     /*  827349 */   GIM_Try, /*On fail goto*//*Label 12744*/ GIMT_Encode4(827424), // Rule ID 22444 //
     /*  827354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827422 */     GIR_RootConstrainSelectedInstOperands,
     /*  827423 */     // GIR_Coverage, 22444,
     /*  827423 */     GIR_EraseRootFromParent_Done,
     /*  827424 */   // Label 12744: @827424
     /*  827424 */   GIM_Try, /*On fail goto*//*Label 12745*/ GIMT_Encode4(827499), // Rule ID 22445 //
     /*  827429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  827446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16),
     /*  827478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827497 */     GIR_RootConstrainSelectedInstOperands,
     /*  827498 */     // GIR_Coverage, 22445,
     /*  827498 */     GIR_EraseRootFromParent_Done,
     /*  827499 */   // Label 12745: @827499
     /*  827499 */   GIM_Try, /*On fail goto*//*Label 12746*/ GIMT_Encode4(827574), // Rule ID 22448 //
     /*  827504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  827521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  827553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827572 */     GIR_RootConstrainSelectedInstOperands,
     /*  827573 */     // GIR_Coverage, 22448,
     /*  827573 */     GIR_EraseRootFromParent_Done,
     /*  827574 */   // Label 12746: @827574
     /*  827574 */   GIM_Try, /*On fail goto*//*Label 12747*/ GIMT_Encode4(827649), // Rule ID 22449 //
     /*  827579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  827596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827625 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16),
     /*  827628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827647 */     GIR_RootConstrainSelectedInstOperands,
     /*  827648 */     // GIR_Coverage, 22449,
     /*  827648 */     GIR_EraseRootFromParent_Done,
     /*  827649 */   // Label 12747: @827649
     /*  827649 */   GIM_Try, /*On fail goto*//*Label 12748*/ GIMT_Encode4(827724), // Rule ID 22452 //
     /*  827654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  827671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  827700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  827703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827722 */     GIR_RootConstrainSelectedInstOperands,
     /*  827723 */     // GIR_Coverage, 22452,
     /*  827723 */     GIR_EraseRootFromParent_Done,
     /*  827724 */   // Label 12748: @827724
     /*  827724 */   GIM_Try, /*On fail goto*//*Label 12749*/ GIMT_Encode4(827799), // Rule ID 22453 //
     /*  827729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  827740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  827743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  827746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  827749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  827764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11432:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  827775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16),
     /*  827778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  827794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827797 */     GIR_RootConstrainSelectedInstOperands,
     /*  827798 */     // GIR_Coverage, 22453,
     /*  827798 */     GIR_EraseRootFromParent_Done,
     /*  827799 */   // Label 12749: @827799
     /*  827799 */   GIM_Try, /*On fail goto*//*Label 12750*/ GIMT_Encode4(827874), // Rule ID 22456 //
     /*  827804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  827821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  827850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  827853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827872 */     GIR_RootConstrainSelectedInstOperands,
     /*  827873 */     // GIR_Coverage, 22456,
     /*  827873 */     GIR_EraseRootFromParent_Done,
     /*  827874 */   // Label 12750: @827874
     /*  827874 */   GIM_Try, /*On fail goto*//*Label 12751*/ GIMT_Encode4(827949), // Rule ID 22457 //
     /*  827879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  827882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  827896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  827902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  827914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  827925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  827925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32),
     /*  827928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  827930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  827932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  827934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  827936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  827941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  827944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  827947 */     GIR_RootConstrainSelectedInstOperands,
     /*  827948 */     // GIR_Coverage, 22457,
     /*  827948 */     GIR_EraseRootFromParent_Done,
     /*  827949 */   // Label 12751: @827949
     /*  827949 */   GIM_Try, /*On fail goto*//*Label 12752*/ GIMT_Encode4(828024), // Rule ID 22460 //
     /*  827954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  827957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  827962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  827965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  827968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  827971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  827974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  827977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  827989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  827993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828022 */     GIR_RootConstrainSelectedInstOperands,
     /*  828023 */     // GIR_Coverage, 22460,
     /*  828023 */     GIR_EraseRootFromParent_Done,
     /*  828024 */   // Label 12752: @828024
     /*  828024 */   GIM_Try, /*On fail goto*//*Label 12753*/ GIMT_Encode4(828099), // Rule ID 22461 //
     /*  828029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  828046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32),
     /*  828078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828097 */     GIR_RootConstrainSelectedInstOperands,
     /*  828098 */     // GIR_Coverage, 22461,
     /*  828098 */     GIR_EraseRootFromParent_Done,
     /*  828099 */   // Label 12753: @828099
     /*  828099 */   GIM_Try, /*On fail goto*//*Label 12754*/ GIMT_Encode4(828174), // Rule ID 22464 //
     /*  828104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  828150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828172 */     GIR_RootConstrainSelectedInstOperands,
     /*  828173 */     // GIR_Coverage, 22464,
     /*  828173 */     GIR_EraseRootFromParent_Done,
     /*  828174 */   // Label 12754: @828174
     /*  828174 */   GIM_Try, /*On fail goto*//*Label 12755*/ GIMT_Encode4(828249), // Rule ID 22465 //
     /*  828179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  828190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  828193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  828196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  828199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11432:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  828225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32),
     /*  828228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  828244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828247 */     GIR_RootConstrainSelectedInstOperands,
     /*  828248 */     // GIR_Coverage, 22465,
     /*  828248 */     GIR_EraseRootFromParent_Done,
     /*  828249 */   // Label 12755: @828249
     /*  828249 */   GIM_Try, /*On fail goto*//*Label 12756*/ GIMT_Encode4(828324), // Rule ID 22468 //
     /*  828254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828322 */     GIR_RootConstrainSelectedInstOperands,
     /*  828323 */     // GIR_Coverage, 22468,
     /*  828323 */     GIR_EraseRootFromParent_Done,
     /*  828324 */   // Label 12756: @828324
     /*  828324 */   GIM_Try, /*On fail goto*//*Label 12757*/ GIMT_Encode4(828399), // Rule ID 22469 //
     /*  828329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  828346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  828364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  828375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64),
     /*  828378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828397 */     GIR_RootConstrainSelectedInstOperands,
     /*  828398 */     // GIR_Coverage, 22469,
     /*  828398 */     GIR_EraseRootFromParent_Done,
     /*  828399 */   // Label 12757: @828399
     /*  828399 */   GIM_Try, /*On fail goto*//*Label 12758*/ GIMT_Encode4(828474), // Rule ID 22472 //
     /*  828404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  828421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  828453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828472 */     GIR_RootConstrainSelectedInstOperands,
     /*  828473 */     // GIR_Coverage, 22472,
     /*  828473 */     GIR_EraseRootFromParent_Done,
     /*  828474 */   // Label 12758: @828474
     /*  828474 */   GIM_Try, /*On fail goto*//*Label 12759*/ GIMT_Encode4(828549), // Rule ID 22473 //
     /*  828479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  828496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  828514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  828525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64),
     /*  828528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828547 */     GIR_RootConstrainSelectedInstOperands,
     /*  828548 */     // GIR_Coverage, 22473,
     /*  828548 */     GIR_EraseRootFromParent_Done,
     /*  828549 */   // Label 12759: @828549
     /*  828549 */   GIM_Try, /*On fail goto*//*Label 12760*/ GIMT_Encode4(828624), // Rule ID 22476 //
     /*  828554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  828557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  828571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  828600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  828603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828622 */     GIR_RootConstrainSelectedInstOperands,
     /*  828623 */     // GIR_Coverage, 22476,
     /*  828623 */     GIR_EraseRootFromParent_Done,
     /*  828624 */   // Label 12760: @828624
     /*  828624 */   GIM_Try, /*On fail goto*//*Label 12761*/ GIMT_Encode4(828699), // Rule ID 22477 //
     /*  828629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  828632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu),
     /*  828637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  828640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  828643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  828646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  828649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  828664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11432:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  828675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64),
     /*  828678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  828694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828697 */     GIR_RootConstrainSelectedInstOperands,
     /*  828698 */     // GIR_Coverage, 22477,
     /*  828698 */     GIR_EraseRootFromParent_Done,
     /*  828699 */   // Label 12761: @828699
     /*  828699 */   GIM_Try, /*On fail goto*//*Label 12762*/ GIMT_Encode4(828774), // Rule ID 22480 //
     /*  828704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  828712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  828721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828750 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  828753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828772 */     GIR_RootConstrainSelectedInstOperands,
     /*  828773 */     // GIR_Coverage, 22480,
     /*  828773 */     GIR_EraseRootFromParent_Done,
     /*  828774 */   // Label 12762: @828774
     /*  828774 */   GIM_Try, /*On fail goto*//*Label 12763*/ GIMT_Encode4(828849), // Rule ID 22481 //
     /*  828779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  828787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  828796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828825 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8),
     /*  828828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828847 */     GIR_RootConstrainSelectedInstOperands,
     /*  828848 */     // GIR_Coverage, 22481,
     /*  828848 */     GIR_EraseRootFromParent_Done,
     /*  828849 */   // Label 12763: @828849
     /*  828849 */   GIM_Try, /*On fail goto*//*Label 12764*/ GIMT_Encode4(828924), // Rule ID 22484 //
     /*  828854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  828857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  828862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  828871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  828877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  828900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  828903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828922 */     GIR_RootConstrainSelectedInstOperands,
     /*  828923 */     // GIR_Coverage, 22484,
     /*  828923 */     GIR_EraseRootFromParent_Done,
     /*  828924 */   // Label 12764: @828924
     /*  828924 */   GIM_Try, /*On fail goto*//*Label 12765*/ GIMT_Encode4(828999), // Rule ID 22485 //
     /*  828929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  828932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  828937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  828940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  828943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  828946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  828949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  828952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  828968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  828975 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  828975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8),
     /*  828978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  828980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  828982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  828984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  828986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  828991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  828994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  828997 */     GIR_RootConstrainSelectedInstOperands,
     /*  828998 */     // GIR_Coverage, 22485,
     /*  828998 */     GIR_EraseRootFromParent_Done,
     /*  828999 */   // Label 12765: @828999
     /*  828999 */   GIM_Try, /*On fail goto*//*Label 12766*/ GIMT_Encode4(829074), // Rule ID 22488 //
     /*  829004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829050 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829072 */     GIR_RootConstrainSelectedInstOperands,
     /*  829073 */     // GIR_Coverage, 22488,
     /*  829073 */     GIR_EraseRootFromParent_Done,
     /*  829074 */   // Label 12766: @829074
     /*  829074 */   GIM_Try, /*On fail goto*//*Label 12767*/ GIMT_Encode4(829149), // Rule ID 22489 //
     /*  829079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  829096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8),
     /*  829128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829147 */     GIR_RootConstrainSelectedInstOperands,
     /*  829148 */     // GIR_Coverage, 22489,
     /*  829148 */     GIR_EraseRootFromParent_Done,
     /*  829149 */   // Label 12767: @829149
     /*  829149 */   GIM_Try, /*On fail goto*//*Label 12768*/ GIMT_Encode4(829224), // Rule ID 22492 //
     /*  829154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829222 */     GIR_RootConstrainSelectedInstOperands,
     /*  829223 */     // GIR_Coverage, 22492,
     /*  829223 */     GIR_EraseRootFromParent_Done,
     /*  829224 */   // Label 12768: @829224
     /*  829224 */   GIM_Try, /*On fail goto*//*Label 12769*/ GIMT_Encode4(829299), // Rule ID 22493 //
     /*  829229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  829246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16),
     /*  829278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829297 */     GIR_RootConstrainSelectedInstOperands,
     /*  829298 */     // GIR_Coverage, 22493,
     /*  829298 */     GIR_EraseRootFromParent_Done,
     /*  829299 */   // Label 12769: @829299
     /*  829299 */   GIM_Try, /*On fail goto*//*Label 12770*/ GIMT_Encode4(829374), // Rule ID 22496 //
     /*  829304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829372 */     GIR_RootConstrainSelectedInstOperands,
     /*  829373 */     // GIR_Coverage, 22496,
     /*  829373 */     GIR_EraseRootFromParent_Done,
     /*  829374 */   // Label 12770: @829374
     /*  829374 */   GIM_Try, /*On fail goto*//*Label 12771*/ GIMT_Encode4(829449), // Rule ID 22497 //
     /*  829379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  829396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16),
     /*  829428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829447 */     GIR_RootConstrainSelectedInstOperands,
     /*  829448 */     // GIR_Coverage, 22497,
     /*  829448 */     GIR_EraseRootFromParent_Done,
     /*  829449 */   // Label 12771: @829449
     /*  829449 */   GIM_Try, /*On fail goto*//*Label 12772*/ GIMT_Encode4(829524), // Rule ID 22500 //
     /*  829454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  829471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  829503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829522 */     GIR_RootConstrainSelectedInstOperands,
     /*  829523 */     // GIR_Coverage, 22500,
     /*  829523 */     GIR_EraseRootFromParent_Done,
     /*  829524 */   // Label 12772: @829524
     /*  829524 */   GIM_Try, /*On fail goto*//*Label 12773*/ GIMT_Encode4(829599), // Rule ID 22501 //
     /*  829529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  829546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  829575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32),
     /*  829578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829597 */     GIR_RootConstrainSelectedInstOperands,
     /*  829598 */     // GIR_Coverage, 22501,
     /*  829598 */     GIR_EraseRootFromParent_Done,
     /*  829599 */   // Label 12773: @829599
     /*  829599 */   GIM_Try, /*On fail goto*//*Label 12774*/ GIMT_Encode4(829674), // Rule ID 22504 //
     /*  829604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  829621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  829650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  829653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829672 */     GIR_RootConstrainSelectedInstOperands,
     /*  829673 */     // GIR_Coverage, 22504,
     /*  829673 */     GIR_EraseRootFromParent_Done,
     /*  829674 */   // Label 12774: @829674
     /*  829674 */   GIM_Try, /*On fail goto*//*Label 12775*/ GIMT_Encode4(829749), // Rule ID 22505 //
     /*  829679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  829690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  829693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  829696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  829699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829725 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  829725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8),
     /*  829728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  829744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829747 */     GIR_RootConstrainSelectedInstOperands,
     /*  829748 */     // GIR_Coverage, 22505,
     /*  829748 */     GIR_EraseRootFromParent_Done,
     /*  829749 */   // Label 12775: @829749
     /*  829749 */   GIM_Try, /*On fail goto*//*Label 12776*/ GIMT_Encode4(829824), // Rule ID 22508 //
     /*  829754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  829771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  829800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  829803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829822 */     GIR_RootConstrainSelectedInstOperands,
     /*  829823 */     // GIR_Coverage, 22508,
     /*  829823 */     GIR_EraseRootFromParent_Done,
     /*  829824 */   // Label 12776: @829824
     /*  829824 */   GIM_Try, /*On fail goto*//*Label 12777*/ GIMT_Encode4(829899), // Rule ID 22509 //
     /*  829829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  829840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  829843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  829846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  829849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  829852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829875 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  829875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16),
     /*  829878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  829894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829897 */     GIR_RootConstrainSelectedInstOperands,
     /*  829898 */     // GIR_Coverage, 22509,
     /*  829898 */     GIR_EraseRootFromParent_Done,
     /*  829899 */   // Label 12777: @829899
     /*  829899 */   GIM_Try, /*On fail goto*//*Label 12778*/ GIMT_Encode4(829974), // Rule ID 22512 //
     /*  829904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  829907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  829921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  829927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  829943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  829950 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  829950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  829953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  829955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  829957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  829959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  829961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  829966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  829969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  829972 */     GIR_RootConstrainSelectedInstOperands,
     /*  829973 */     // GIR_Coverage, 22512,
     /*  829973 */     GIR_EraseRootFromParent_Done,
     /*  829974 */   // Label 12778: @829974
     /*  829974 */   GIM_Try, /*On fail goto*//*Label 12779*/ GIMT_Encode4(830049), // Rule ID 22513 //
     /*  829979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  829982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  829987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  829990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  829993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  829996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  829999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830025 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  830025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32),
     /*  830028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  830044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830047 */     GIR_RootConstrainSelectedInstOperands,
     /*  830048 */     // GIR_Coverage, 22513,
     /*  830048 */     GIR_EraseRootFromParent_Done,
     /*  830049 */   // Label 12779: @830049
     /*  830049 */   GIM_Try, /*On fail goto*//*Label 12780*/ GIMT_Encode4(830124), // Rule ID 22516 //
     /*  830054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  830057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830100 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  830100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830122 */     GIR_RootConstrainSelectedInstOperands,
     /*  830123 */     // GIR_Coverage, 22516,
     /*  830123 */     GIR_EraseRootFromParent_Done,
     /*  830124 */   // Label 12780: @830124
     /*  830124 */   GIM_Try, /*On fail goto*//*Label 12781*/ GIMT_Encode4(830199), // Rule ID 22517 //
     /*  830129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  830132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  830140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  830143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  830146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  830149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  830175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64),
     /*  830178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  830194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830197 */     GIR_RootConstrainSelectedInstOperands,
     /*  830198 */     // GIR_Coverage, 22517,
     /*  830198 */     GIR_EraseRootFromParent_Done,
     /*  830199 */   // Label 12781: @830199
     /*  830199 */   GIM_Try, /*On fail goto*//*Label 12782*/ GIMT_Encode4(830274), // Rule ID 22520 //
     /*  830204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830272 */     GIR_RootConstrainSelectedInstOperands,
     /*  830273 */     // GIR_Coverage, 22520,
     /*  830273 */     GIR_EraseRootFromParent_Done,
     /*  830274 */   // Label 12782: @830274
     /*  830274 */   GIM_Try, /*On fail goto*//*Label 12783*/ GIMT_Encode4(830349), // Rule ID 22521 //
     /*  830279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  830296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8),
     /*  830328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830347 */     GIR_RootConstrainSelectedInstOperands,
     /*  830348 */     // GIR_Coverage, 22521,
     /*  830348 */     GIR_EraseRootFromParent_Done,
     /*  830349 */   // Label 12783: @830349
     /*  830349 */   GIM_Try, /*On fail goto*//*Label 12784*/ GIMT_Encode4(830424), // Rule ID 22524 //
     /*  830354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830422 */     GIR_RootConstrainSelectedInstOperands,
     /*  830423 */     // GIR_Coverage, 22524,
     /*  830423 */     GIR_EraseRootFromParent_Done,
     /*  830424 */   // Label 12784: @830424
     /*  830424 */   GIM_Try, /*On fail goto*//*Label 12785*/ GIMT_Encode4(830499), // Rule ID 22525 //
     /*  830429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  830446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830475 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8),
     /*  830478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830497 */     GIR_RootConstrainSelectedInstOperands,
     /*  830498 */     // GIR_Coverage, 22525,
     /*  830498 */     GIR_EraseRootFromParent_Done,
     /*  830499 */   // Label 12785: @830499
     /*  830499 */   GIM_Try, /*On fail goto*//*Label 12786*/ GIMT_Encode4(830574), // Rule ID 22528 //
     /*  830504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  830521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  830539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  830550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  830553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830572 */     GIR_RootConstrainSelectedInstOperands,
     /*  830573 */     // GIR_Coverage, 22528,
     /*  830573 */     GIR_EraseRootFromParent_Done,
     /*  830574 */   // Label 12786: @830574
     /*  830574 */   GIM_Try, /*On fail goto*//*Label 12787*/ GIMT_Encode4(830649), // Rule ID 22529 //
     /*  830579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  830590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  830593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  830596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  830599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  830614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11430:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  830625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8),
     /*  830628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  830644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830647 */     GIR_RootConstrainSelectedInstOperands,
     /*  830648 */     // GIR_Coverage, 22529,
     /*  830648 */     GIR_EraseRootFromParent_Done,
     /*  830649 */   // Label 12787: @830649
     /*  830649 */   GIM_Try, /*On fail goto*//*Label 12788*/ GIMT_Encode4(830724), // Rule ID 22532 //
     /*  830654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  830671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  830703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830722 */     GIR_RootConstrainSelectedInstOperands,
     /*  830723 */     // GIR_Coverage, 22532,
     /*  830723 */     GIR_EraseRootFromParent_Done,
     /*  830724 */   // Label 12788: @830724
     /*  830724 */   GIM_Try, /*On fail goto*//*Label 12789*/ GIMT_Encode4(830799), // Rule ID 22533 //
     /*  830729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  830746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  830764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16),
     /*  830778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830797 */     GIR_RootConstrainSelectedInstOperands,
     /*  830798 */     // GIR_Coverage, 22533,
     /*  830798 */     GIR_EraseRootFromParent_Done,
     /*  830799 */   // Label 12789: @830799
     /*  830799 */   GIM_Try, /*On fail goto*//*Label 12790*/ GIMT_Encode4(830874), // Rule ID 22536 //
     /*  830804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  830821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  830850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  830853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830872 */     GIR_RootConstrainSelectedInstOperands,
     /*  830873 */     // GIR_Coverage, 22536,
     /*  830873 */     GIR_EraseRootFromParent_Done,
     /*  830874 */   // Label 12790: @830874
     /*  830874 */   GIM_Try, /*On fail goto*//*Label 12791*/ GIMT_Encode4(830949), // Rule ID 22537 //
     /*  830879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  830882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  830896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  830902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  830914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  830925 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  830925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16),
     /*  830928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  830930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  830932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  830934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  830936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  830941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  830944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  830947 */     GIR_RootConstrainSelectedInstOperands,
     /*  830948 */     // GIR_Coverage, 22537,
     /*  830948 */     GIR_EraseRootFromParent_Done,
     /*  830949 */   // Label 12791: @830949
     /*  830949 */   GIM_Try, /*On fail goto*//*Label 12792*/ GIMT_Encode4(831024), // Rule ID 22540 //
     /*  830954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  830957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  830962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  830965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  830968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  830971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  830974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  830977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  830989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  830993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  831000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831022 */     GIR_RootConstrainSelectedInstOperands,
     /*  831023 */     // GIR_Coverage, 22540,
     /*  831023 */     GIR_EraseRootFromParent_Done,
     /*  831024 */   // Label 12792: @831024
     /*  831024 */   GIM_Try, /*On fail goto*//*Label 12793*/ GIMT_Encode4(831099), // Rule ID 22541 //
     /*  831029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  831040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  831043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  831046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  831049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11430:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  831075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16),
     /*  831078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  831094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831097 */     GIR_RootConstrainSelectedInstOperands,
     /*  831098 */     // GIR_Coverage, 22541,
     /*  831098 */     GIR_EraseRootFromParent_Done,
     /*  831099 */   // Label 12793: @831099
     /*  831099 */   GIM_Try, /*On fail goto*//*Label 12794*/ GIMT_Encode4(831174), // Rule ID 22544 //
     /*  831104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831172 */     GIR_RootConstrainSelectedInstOperands,
     /*  831173 */     // GIR_Coverage, 22544,
     /*  831173 */     GIR_EraseRootFromParent_Done,
     /*  831174 */   // Label 12794: @831174
     /*  831174 */   GIM_Try, /*On fail goto*//*Label 12795*/ GIMT_Encode4(831249), // Rule ID 22545 //
     /*  831179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  831196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32),
     /*  831228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831247 */     GIR_RootConstrainSelectedInstOperands,
     /*  831248 */     // GIR_Coverage, 22545,
     /*  831248 */     GIR_EraseRootFromParent_Done,
     /*  831249 */   // Label 12795: @831249
     /*  831249 */   GIM_Try, /*On fail goto*//*Label 12796*/ GIMT_Encode4(831324), // Rule ID 22548 //
     /*  831254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831322 */     GIR_RootConstrainSelectedInstOperands,
     /*  831323 */     // GIR_Coverage, 22548,
     /*  831323 */     GIR_EraseRootFromParent_Done,
     /*  831324 */   // Label 12796: @831324
     /*  831324 */   GIM_Try, /*On fail goto*//*Label 12797*/ GIMT_Encode4(831399), // Rule ID 22549 //
     /*  831329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  831346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831375 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32),
     /*  831378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831397 */     GIR_RootConstrainSelectedInstOperands,
     /*  831398 */     // GIR_Coverage, 22549,
     /*  831398 */     GIR_EraseRootFromParent_Done,
     /*  831399 */   // Label 12797: @831399
     /*  831399 */   GIM_Try, /*On fail goto*//*Label 12798*/ GIMT_Encode4(831474), // Rule ID 22552 //
     /*  831404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  831407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  831450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  831453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831472 */     GIR_RootConstrainSelectedInstOperands,
     /*  831473 */     // GIR_Coverage, 22552,
     /*  831473 */     GIR_EraseRootFromParent_Done,
     /*  831474 */   // Label 12798: @831474
     /*  831474 */   GIM_Try, /*On fail goto*//*Label 12799*/ GIMT_Encode4(831549), // Rule ID 22553 //
     /*  831479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  831482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  831490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  831493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  831496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  831499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11430:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  831525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32),
     /*  831528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  831544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831547 */     GIR_RootConstrainSelectedInstOperands,
     /*  831548 */     // GIR_Coverage, 22553,
     /*  831548 */     GIR_EraseRootFromParent_Done,
     /*  831549 */   // Label 12799: @831549
     /*  831549 */   GIM_Try, /*On fail goto*//*Label 12800*/ GIMT_Encode4(831624), // Rule ID 22556 //
     /*  831554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  831571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  831603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831622 */     GIR_RootConstrainSelectedInstOperands,
     /*  831623 */     // GIR_Coverage, 22556,
     /*  831623 */     GIR_EraseRootFromParent_Done,
     /*  831624 */   // Label 12800: @831624
     /*  831624 */   GIM_Try, /*On fail goto*//*Label 12801*/ GIMT_Encode4(831699), // Rule ID 22557 //
     /*  831629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  831646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  831664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64),
     /*  831678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831697 */     GIR_RootConstrainSelectedInstOperands,
     /*  831698 */     // GIR_Coverage, 22557,
     /*  831698 */     GIR_EraseRootFromParent_Done,
     /*  831699 */   // Label 12801: @831699
     /*  831699 */   GIM_Try, /*On fail goto*//*Label 12802*/ GIMT_Encode4(831774), // Rule ID 22560 //
     /*  831704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  831721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  831753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831772 */     GIR_RootConstrainSelectedInstOperands,
     /*  831773 */     // GIR_Coverage, 22560,
     /*  831773 */     GIR_EraseRootFromParent_Done,
     /*  831774 */   // Label 12802: @831774
     /*  831774 */   GIM_Try, /*On fail goto*//*Label 12803*/ GIMT_Encode4(831849), // Rule ID 22561 //
     /*  831779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  831796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  831814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831825 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64),
     /*  831828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831847 */     GIR_RootConstrainSelectedInstOperands,
     /*  831848 */     // GIR_Coverage, 22561,
     /*  831848 */     GIR_EraseRootFromParent_Done,
     /*  831849 */   // Label 12803: @831849
     /*  831849 */   GIM_Try, /*On fail goto*//*Label 12804*/ GIMT_Encode4(831924), // Rule ID 22564 //
     /*  831854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  831857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  831871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  831877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  831900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  831903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831922 */     GIR_RootConstrainSelectedInstOperands,
     /*  831923 */     // GIR_Coverage, 22564,
     /*  831923 */     GIR_EraseRootFromParent_Done,
     /*  831924 */   // Label 12804: @831924
     /*  831924 */   GIM_Try, /*On fail goto*//*Label 12805*/ GIMT_Encode4(831999), // Rule ID 22565 //
     /*  831929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  831932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax),
     /*  831937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  831940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  831943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  831946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  831949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  831952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  831964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  831968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  831975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11430:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  831975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64),
     /*  831978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  831980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  831982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  831984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  831986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  831991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  831994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  831997 */     GIR_RootConstrainSelectedInstOperands,
     /*  831998 */     // GIR_Coverage, 22565,
     /*  831998 */     GIR_EraseRootFromParent_Done,
     /*  831999 */   // Label 12805: @831999
     /*  831999 */   GIM_Try, /*On fail goto*//*Label 12806*/ GIMT_Encode4(832074), // Rule ID 22568 //
     /*  832004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832072 */     GIR_RootConstrainSelectedInstOperands,
     /*  832073 */     // GIR_Coverage, 22568,
     /*  832073 */     GIR_EraseRootFromParent_Done,
     /*  832074 */   // Label 12806: @832074
     /*  832074 */   GIM_Try, /*On fail goto*//*Label 12807*/ GIMT_Encode4(832149), // Rule ID 22569 //
     /*  832079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  832096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832125 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8),
     /*  832128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832147 */     GIR_RootConstrainSelectedInstOperands,
     /*  832148 */     // GIR_Coverage, 22569,
     /*  832148 */     GIR_EraseRootFromParent_Done,
     /*  832149 */   // Label 12807: @832149
     /*  832149 */   GIM_Try, /*On fail goto*//*Label 12808*/ GIMT_Encode4(832224), // Rule ID 22572 //
     /*  832154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832222 */     GIR_RootConstrainSelectedInstOperands,
     /*  832223 */     // GIR_Coverage, 22572,
     /*  832223 */     GIR_EraseRootFromParent_Done,
     /*  832224 */   // Label 12808: @832224
     /*  832224 */   GIM_Try, /*On fail goto*//*Label 12809*/ GIMT_Encode4(832299), // Rule ID 22573 //
     /*  832229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  832246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8),
     /*  832278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832297 */     GIR_RootConstrainSelectedInstOperands,
     /*  832298 */     // GIR_Coverage, 22573,
     /*  832298 */     GIR_EraseRootFromParent_Done,
     /*  832299 */   // Label 12809: @832299
     /*  832299 */   GIM_Try, /*On fail goto*//*Label 12810*/ GIMT_Encode4(832374), // Rule ID 22576 //
     /*  832304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832350 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832372 */     GIR_RootConstrainSelectedInstOperands,
     /*  832373 */     // GIR_Coverage, 22576,
     /*  832373 */     GIR_EraseRootFromParent_Done,
     /*  832374 */   // Label 12810: @832374
     /*  832374 */   GIM_Try, /*On fail goto*//*Label 12811*/ GIMT_Encode4(832449), // Rule ID 22577 //
     /*  832379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  832396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  832425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8),
     /*  832428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832447 */     GIR_RootConstrainSelectedInstOperands,
     /*  832448 */     // GIR_Coverage, 22577,
     /*  832448 */     GIR_EraseRootFromParent_Done,
     /*  832449 */   // Label 12811: @832449
     /*  832449 */   GIM_Try, /*On fail goto*//*Label 12812*/ GIMT_Encode4(832524), // Rule ID 22580 //
     /*  832454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  832471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  832500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  832503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832522 */     GIR_RootConstrainSelectedInstOperands,
     /*  832523 */     // GIR_Coverage, 22580,
     /*  832523 */     GIR_EraseRootFromParent_Done,
     /*  832524 */   // Label 12812: @832524
     /*  832524 */   GIM_Try, /*On fail goto*//*Label 12813*/ GIMT_Encode4(832599), // Rule ID 22581 //
     /*  832529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  832546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16),
     /*  832578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832597 */     GIR_RootConstrainSelectedInstOperands,
     /*  832598 */     // GIR_Coverage, 22581,
     /*  832598 */     GIR_EraseRootFromParent_Done,
     /*  832599 */   // Label 12813: @832599
     /*  832599 */   GIM_Try, /*On fail goto*//*Label 12814*/ GIMT_Encode4(832674), // Rule ID 22584 //
     /*  832604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  832621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  832650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  832653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832672 */     GIR_RootConstrainSelectedInstOperands,
     /*  832673 */     // GIR_Coverage, 22584,
     /*  832673 */     GIR_EraseRootFromParent_Done,
     /*  832674 */   // Label 12814: @832674
     /*  832674 */   GIM_Try, /*On fail goto*//*Label 12815*/ GIMT_Encode4(832749), // Rule ID 22585 //
     /*  832679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  832690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  832693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  832696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  832699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832725 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  832725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16),
     /*  832728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  832744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832747 */     GIR_RootConstrainSelectedInstOperands,
     /*  832748 */     // GIR_Coverage, 22585,
     /*  832748 */     GIR_EraseRootFromParent_Done,
     /*  832749 */   // Label 12815: @832749
     /*  832749 */   GIM_Try, /*On fail goto*//*Label 12816*/ GIMT_Encode4(832824), // Rule ID 22588 //
     /*  832754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  832771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  832800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  832803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832822 */     GIR_RootConstrainSelectedInstOperands,
     /*  832823 */     // GIR_Coverage, 22588,
     /*  832823 */     GIR_EraseRootFromParent_Done,
     /*  832824 */   // Label 12816: @832824
     /*  832824 */   GIM_Try, /*On fail goto*//*Label 12817*/ GIMT_Encode4(832899), // Rule ID 22589 //
     /*  832829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  832840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  832843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  832846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  832849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  832852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832875 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  832875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32),
     /*  832878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  832894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832897 */     GIR_RootConstrainSelectedInstOperands,
     /*  832898 */     // GIR_Coverage, 22589,
     /*  832898 */     GIR_EraseRootFromParent_Done,
     /*  832899 */   // Label 12817: @832899
     /*  832899 */   GIM_Try, /*On fail goto*//*Label 12818*/ GIMT_Encode4(832974), // Rule ID 22592 //
     /*  832904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  832907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  832921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  832927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  832943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  832950 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  832950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  832953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  832955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  832957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  832959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  832961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  832966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  832969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  832972 */     GIR_RootConstrainSelectedInstOperands,
     /*  832973 */     // GIR_Coverage, 22592,
     /*  832973 */     GIR_EraseRootFromParent_Done,
     /*  832974 */   // Label 12818: @832974
     /*  832974 */   GIM_Try, /*On fail goto*//*Label 12819*/ GIMT_Encode4(833049), // Rule ID 22593 //
     /*  832979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  832982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  832987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  832990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  832993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  832996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  832999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833025 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8),
     /*  833028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833047 */     GIR_RootConstrainSelectedInstOperands,
     /*  833048 */     // GIR_Coverage, 22593,
     /*  833048 */     GIR_EraseRootFromParent_Done,
     /*  833049 */   // Label 12819: @833049
     /*  833049 */   GIM_Try, /*On fail goto*//*Label 12820*/ GIMT_Encode4(833124), // Rule ID 22596 //
     /*  833054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833100 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833122 */     GIR_RootConstrainSelectedInstOperands,
     /*  833123 */     // GIR_Coverage, 22596,
     /*  833123 */     GIR_EraseRootFromParent_Done,
     /*  833124 */   // Label 12820: @833124
     /*  833124 */   GIM_Try, /*On fail goto*//*Label 12821*/ GIMT_Encode4(833199), // Rule ID 22597 //
     /*  833129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  833146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833175 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16),
     /*  833178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833197 */     GIR_RootConstrainSelectedInstOperands,
     /*  833198 */     // GIR_Coverage, 22597,
     /*  833198 */     GIR_EraseRootFromParent_Done,
     /*  833199 */   // Label 12821: @833199
     /*  833199 */   GIM_Try, /*On fail goto*//*Label 12822*/ GIMT_Encode4(833274), // Rule ID 22600 //
     /*  833204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833250 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  833250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833272 */     GIR_RootConstrainSelectedInstOperands,
     /*  833273 */     // GIR_Coverage, 22600,
     /*  833273 */     GIR_EraseRootFromParent_Done,
     /*  833274 */   // Label 12822: @833274
     /*  833274 */   GIM_Try, /*On fail goto*//*Label 12823*/ GIMT_Encode4(833349), // Rule ID 22601 //
     /*  833279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  833290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  833293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  833296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  833299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833325 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  833325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32),
     /*  833328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  833344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833347 */     GIR_RootConstrainSelectedInstOperands,
     /*  833348 */     // GIR_Coverage, 22601,
     /*  833348 */     GIR_EraseRootFromParent_Done,
     /*  833349 */   // Label 12823: @833349
     /*  833349 */   GIM_Try, /*On fail goto*//*Label 12824*/ GIMT_Encode4(833424), // Rule ID 22604 //
     /*  833354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833422 */     GIR_RootConstrainSelectedInstOperands,
     /*  833423 */     // GIR_Coverage, 22604,
     /*  833423 */     GIR_EraseRootFromParent_Done,
     /*  833424 */   // Label 12824: @833424
     /*  833424 */   GIM_Try, /*On fail goto*//*Label 12825*/ GIMT_Encode4(833499), // Rule ID 22605 //
     /*  833429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  833446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8),
     /*  833478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833497 */     GIR_RootConstrainSelectedInstOperands,
     /*  833498 */     // GIR_Coverage, 22605,
     /*  833498 */     GIR_EraseRootFromParent_Done,
     /*  833499 */   // Label 12825: @833499
     /*  833499 */   GIM_Try, /*On fail goto*//*Label 12826*/ GIMT_Encode4(833574), // Rule ID 22608 //
     /*  833504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  833521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  833539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833550 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  833553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833572 */     GIR_RootConstrainSelectedInstOperands,
     /*  833573 */     // GIR_Coverage, 22608,
     /*  833573 */     GIR_EraseRootFromParent_Done,
     /*  833574 */   // Label 12826: @833574
     /*  833574 */   GIM_Try, /*On fail goto*//*Label 12827*/ GIMT_Encode4(833649), // Rule ID 22609 //
     /*  833579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  833596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  833614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833625 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8),
     /*  833628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833647 */     GIR_RootConstrainSelectedInstOperands,
     /*  833648 */     // GIR_Coverage, 22609,
     /*  833648 */     GIR_EraseRootFromParent_Done,
     /*  833649 */   // Label 12827: @833649
     /*  833649 */   GIM_Try, /*On fail goto*//*Label 12828*/ GIMT_Encode4(833724), // Rule ID 22612 //
     /*  833654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  833671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  833689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  833700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  833703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833722 */     GIR_RootConstrainSelectedInstOperands,
     /*  833723 */     // GIR_Coverage, 22612,
     /*  833723 */     GIR_EraseRootFromParent_Done,
     /*  833724 */   // Label 12828: @833724
     /*  833724 */   GIM_Try, /*On fail goto*//*Label 12829*/ GIMT_Encode4(833799), // Rule ID 22613 //
     /*  833729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  833740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  833743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  833746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  833749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  833764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11594:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  833775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8),
     /*  833778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  833794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833797 */     GIR_RootConstrainSelectedInstOperands,
     /*  833798 */     // GIR_Coverage, 22613,
     /*  833798 */     GIR_EraseRootFromParent_Done,
     /*  833799 */   // Label 12829: @833799
     /*  833799 */   GIM_Try, /*On fail goto*//*Label 12830*/ GIMT_Encode4(833874), // Rule ID 22616 //
     /*  833804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  833821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  833850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  833853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833872 */     GIR_RootConstrainSelectedInstOperands,
     /*  833873 */     // GIR_Coverage, 22616,
     /*  833873 */     GIR_EraseRootFromParent_Done,
     /*  833874 */   // Label 12830: @833874
     /*  833874 */   GIM_Try, /*On fail goto*//*Label 12831*/ GIMT_Encode4(833949), // Rule ID 22617 //
     /*  833879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  833882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  833896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  833902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  833914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  833925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  833925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16),
     /*  833928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  833930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  833932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  833934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  833936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  833941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  833944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  833947 */     GIR_RootConstrainSelectedInstOperands,
     /*  833948 */     // GIR_Coverage, 22617,
     /*  833948 */     GIR_EraseRootFromParent_Done,
     /*  833949 */   // Label 12831: @833949
     /*  833949 */   GIM_Try, /*On fail goto*//*Label 12832*/ GIMT_Encode4(834024), // Rule ID 22620 //
     /*  833954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  833957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  833962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  833965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  833968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  833971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  833974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  833977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  833989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  833993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834022 */     GIR_RootConstrainSelectedInstOperands,
     /*  834023 */     // GIR_Coverage, 22620,
     /*  834023 */     GIR_EraseRootFromParent_Done,
     /*  834024 */   // Label 12832: @834024
     /*  834024 */   GIM_Try, /*On fail goto*//*Label 12833*/ GIMT_Encode4(834099), // Rule ID 22621 //
     /*  834029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  834046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834075 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16),
     /*  834078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834097 */     GIR_RootConstrainSelectedInstOperands,
     /*  834098 */     // GIR_Coverage, 22621,
     /*  834098 */     GIR_EraseRootFromParent_Done,
     /*  834099 */   // Label 12833: @834099
     /*  834099 */   GIM_Try, /*On fail goto*//*Label 12834*/ GIMT_Encode4(834174), // Rule ID 22624 //
     /*  834104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  834150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834172 */     GIR_RootConstrainSelectedInstOperands,
     /*  834173 */     // GIR_Coverage, 22624,
     /*  834173 */     GIR_EraseRootFromParent_Done,
     /*  834174 */   // Label 12834: @834174
     /*  834174 */   GIM_Try, /*On fail goto*//*Label 12835*/ GIMT_Encode4(834249), // Rule ID 22625 //
     /*  834179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  834190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  834193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  834196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  834199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11594:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  834225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16),
     /*  834228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  834244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834247 */     GIR_RootConstrainSelectedInstOperands,
     /*  834248 */     // GIR_Coverage, 22625,
     /*  834248 */     GIR_EraseRootFromParent_Done,
     /*  834249 */   // Label 12835: @834249
     /*  834249 */   GIM_Try, /*On fail goto*//*Label 12836*/ GIMT_Encode4(834324), // Rule ID 22628 //
     /*  834254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834322 */     GIR_RootConstrainSelectedInstOperands,
     /*  834323 */     // GIR_Coverage, 22628,
     /*  834323 */     GIR_EraseRootFromParent_Done,
     /*  834324 */   // Label 12836: @834324
     /*  834324 */   GIM_Try, /*On fail goto*//*Label 12837*/ GIMT_Encode4(834399), // Rule ID 22629 //
     /*  834329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  834346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  834364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32),
     /*  834378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834397 */     GIR_RootConstrainSelectedInstOperands,
     /*  834398 */     // GIR_Coverage, 22629,
     /*  834398 */     GIR_EraseRootFromParent_Done,
     /*  834399 */   // Label 12837: @834399
     /*  834399 */   GIM_Try, /*On fail goto*//*Label 12838*/ GIMT_Encode4(834474), // Rule ID 22632 //
     /*  834404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  834421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834450 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  834453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834472 */     GIR_RootConstrainSelectedInstOperands,
     /*  834473 */     // GIR_Coverage, 22632,
     /*  834473 */     GIR_EraseRootFromParent_Done,
     /*  834474 */   // Label 12838: @834474
     /*  834474 */   GIM_Try, /*On fail goto*//*Label 12839*/ GIMT_Encode4(834549), // Rule ID 22633 //
     /*  834479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  834496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  834514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834525 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32),
     /*  834528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834547 */     GIR_RootConstrainSelectedInstOperands,
     /*  834548 */     // GIR_Coverage, 22633,
     /*  834548 */     GIR_EraseRootFromParent_Done,
     /*  834549 */   // Label 12839: @834549
     /*  834549 */   GIM_Try, /*On fail goto*//*Label 12840*/ GIMT_Encode4(834624), // Rule ID 22636 //
     /*  834554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  834571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  834600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  834603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834622 */     GIR_RootConstrainSelectedInstOperands,
     /*  834623 */     // GIR_Coverage, 22636,
     /*  834623 */     GIR_EraseRootFromParent_Done,
     /*  834624 */   // Label 12840: @834624
     /*  834624 */   GIM_Try, /*On fail goto*//*Label 12841*/ GIMT_Encode4(834699), // Rule ID 22637 //
     /*  834629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu),
     /*  834637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  834640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  834643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  834646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  834649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  834664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11594:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  834675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32),
     /*  834678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  834694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834697 */     GIR_RootConstrainSelectedInstOperands,
     /*  834698 */     // GIR_Coverage, 22637,
     /*  834698 */     GIR_EraseRootFromParent_Done,
     /*  834699 */   // Label 12841: @834699
     /*  834699 */   GIM_Try, /*On fail goto*//*Label 12842*/ GIMT_Encode4(834774), // Rule ID 22640 //
     /*  834704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  834712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  834721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  834753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834772 */     GIR_RootConstrainSelectedInstOperands,
     /*  834773 */     // GIR_Coverage, 22640,
     /*  834773 */     GIR_EraseRootFromParent_Done,
     /*  834774 */   // Label 12842: @834774
     /*  834774 */   GIM_Try, /*On fail goto*//*Label 12843*/ GIMT_Encode4(834849), // Rule ID 22641 //
     /*  834779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  834787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  834796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834825 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8),
     /*  834828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834847 */     GIR_RootConstrainSelectedInstOperands,
     /*  834848 */     // GIR_Coverage, 22641,
     /*  834848 */     GIR_EraseRootFromParent_Done,
     /*  834849 */   // Label 12843: @834849
     /*  834849 */   GIM_Try, /*On fail goto*//*Label 12844*/ GIMT_Encode4(834924), // Rule ID 22644 //
     /*  834854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  834857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  834862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  834871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  834877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834900 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  834900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  834903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834922 */     GIR_RootConstrainSelectedInstOperands,
     /*  834923 */     // GIR_Coverage, 22644,
     /*  834923 */     GIR_EraseRootFromParent_Done,
     /*  834924 */   // Label 12844: @834924
     /*  834924 */   GIM_Try, /*On fail goto*//*Label 12845*/ GIMT_Encode4(834999), // Rule ID 22645 //
     /*  834929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  834932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  834937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  834940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  834943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  834946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  834949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  834952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  834968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  834975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  834975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8),
     /*  834978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  834980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  834982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  834984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  834986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  834991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  834994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  834997 */     GIR_RootConstrainSelectedInstOperands,
     /*  834998 */     // GIR_Coverage, 22645,
     /*  834998 */     GIR_EraseRootFromParent_Done,
     /*  834999 */   // Label 12845: @834999
     /*  834999 */   GIM_Try, /*On fail goto*//*Label 12846*/ GIMT_Encode4(835074), // Rule ID 22648 //
     /*  835004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835072 */     GIR_RootConstrainSelectedInstOperands,
     /*  835073 */     // GIR_Coverage, 22648,
     /*  835073 */     GIR_EraseRootFromParent_Done,
     /*  835074 */   // Label 12846: @835074
     /*  835074 */   GIM_Try, /*On fail goto*//*Label 12847*/ GIMT_Encode4(835149), // Rule ID 22649 //
     /*  835079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  835096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835125 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8),
     /*  835128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835147 */     GIR_RootConstrainSelectedInstOperands,
     /*  835148 */     // GIR_Coverage, 22649,
     /*  835148 */     GIR_EraseRootFromParent_Done,
     /*  835149 */   // Label 12847: @835149
     /*  835149 */   GIM_Try, /*On fail goto*//*Label 12848*/ GIMT_Encode4(835224), // Rule ID 22652 //
     /*  835154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835200 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835222 */     GIR_RootConstrainSelectedInstOperands,
     /*  835223 */     // GIR_Coverage, 22652,
     /*  835223 */     GIR_EraseRootFromParent_Done,
     /*  835224 */   // Label 12848: @835224
     /*  835224 */   GIM_Try, /*On fail goto*//*Label 12849*/ GIMT_Encode4(835299), // Rule ID 22653 //
     /*  835229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  835246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835275 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16),
     /*  835278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835297 */     GIR_RootConstrainSelectedInstOperands,
     /*  835298 */     // GIR_Coverage, 22653,
     /*  835298 */     GIR_EraseRootFromParent_Done,
     /*  835299 */   // Label 12849: @835299
     /*  835299 */   GIM_Try, /*On fail goto*//*Label 12850*/ GIMT_Encode4(835374), // Rule ID 22656 //
     /*  835304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835350 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835372 */     GIR_RootConstrainSelectedInstOperands,
     /*  835373 */     // GIR_Coverage, 22656,
     /*  835373 */     GIR_EraseRootFromParent_Done,
     /*  835374 */   // Label 12850: @835374
     /*  835374 */   GIM_Try, /*On fail goto*//*Label 12851*/ GIMT_Encode4(835449), // Rule ID 22657 //
     /*  835379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  835396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16),
     /*  835428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835447 */     GIR_RootConstrainSelectedInstOperands,
     /*  835448 */     // GIR_Coverage, 22657,
     /*  835448 */     GIR_EraseRootFromParent_Done,
     /*  835449 */   // Label 12851: @835449
     /*  835449 */   GIM_Try, /*On fail goto*//*Label 12852*/ GIMT_Encode4(835524), // Rule ID 22660 //
     /*  835454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  835471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  835503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835522 */     GIR_RootConstrainSelectedInstOperands,
     /*  835523 */     // GIR_Coverage, 22660,
     /*  835523 */     GIR_EraseRootFromParent_Done,
     /*  835524 */   // Label 12852: @835524
     /*  835524 */   GIM_Try, /*On fail goto*//*Label 12853*/ GIMT_Encode4(835599), // Rule ID 22661 //
     /*  835529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  835546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835575 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  835575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32),
     /*  835578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835597 */     GIR_RootConstrainSelectedInstOperands,
     /*  835598 */     // GIR_Coverage, 22661,
     /*  835598 */     GIR_EraseRootFromParent_Done,
     /*  835599 */   // Label 12853: @835599
     /*  835599 */   GIM_Try, /*On fail goto*//*Label 12854*/ GIMT_Encode4(835674), // Rule ID 22664 //
     /*  835604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  835621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  835650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  835653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835672 */     GIR_RootConstrainSelectedInstOperands,
     /*  835673 */     // GIR_Coverage, 22664,
     /*  835673 */     GIR_EraseRootFromParent_Done,
     /*  835674 */   // Label 12854: @835674
     /*  835674 */   GIM_Try, /*On fail goto*//*Label 12855*/ GIMT_Encode4(835749), // Rule ID 22665 //
     /*  835679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  835690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  835693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  835696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  835699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835725 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  835725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8),
     /*  835728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  835744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835747 */     GIR_RootConstrainSelectedInstOperands,
     /*  835748 */     // GIR_Coverage, 22665,
     /*  835748 */     GIR_EraseRootFromParent_Done,
     /*  835749 */   // Label 12855: @835749
     /*  835749 */   GIM_Try, /*On fail goto*//*Label 12856*/ GIMT_Encode4(835824), // Rule ID 22668 //
     /*  835754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  835771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  835800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  835803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835822 */     GIR_RootConstrainSelectedInstOperands,
     /*  835823 */     // GIR_Coverage, 22668,
     /*  835823 */     GIR_EraseRootFromParent_Done,
     /*  835824 */   // Label 12856: @835824
     /*  835824 */   GIM_Try, /*On fail goto*//*Label 12857*/ GIMT_Encode4(835899), // Rule ID 22669 //
     /*  835829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  835840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  835843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  835846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  835849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  835852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835875 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  835875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16),
     /*  835878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  835894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835897 */     GIR_RootConstrainSelectedInstOperands,
     /*  835898 */     // GIR_Coverage, 22669,
     /*  835898 */     GIR_EraseRootFromParent_Done,
     /*  835899 */   // Label 12857: @835899
     /*  835899 */   GIM_Try, /*On fail goto*//*Label 12858*/ GIMT_Encode4(835974), // Rule ID 22672 //
     /*  835904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  835907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  835921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  835927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  835943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  835950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  835950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  835953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  835955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  835957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  835959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  835961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  835966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  835969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  835972 */     GIR_RootConstrainSelectedInstOperands,
     /*  835973 */     // GIR_Coverage, 22672,
     /*  835973 */     GIR_EraseRootFromParent_Done,
     /*  835974 */   // Label 12858: @835974
     /*  835974 */   GIM_Try, /*On fail goto*//*Label 12859*/ GIMT_Encode4(836049), // Rule ID 22673 //
     /*  835979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  835982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  835987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  835990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  835993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  835996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  835999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836025 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  836025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32),
     /*  836028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  836044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836047 */     GIR_RootConstrainSelectedInstOperands,
     /*  836048 */     // GIR_Coverage, 22673,
     /*  836048 */     GIR_EraseRootFromParent_Done,
     /*  836049 */   // Label 12859: @836049
     /*  836049 */   GIM_Try, /*On fail goto*//*Label 12860*/ GIMT_Encode4(836124), // Rule ID 22676 //
     /*  836054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836122 */     GIR_RootConstrainSelectedInstOperands,
     /*  836123 */     // GIR_Coverage, 22676,
     /*  836123 */     GIR_EraseRootFromParent_Done,
     /*  836124 */   // Label 12860: @836124
     /*  836124 */   GIM_Try, /*On fail goto*//*Label 12861*/ GIMT_Encode4(836199), // Rule ID 22677 //
     /*  836129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  836146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8),
     /*  836178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836197 */     GIR_RootConstrainSelectedInstOperands,
     /*  836198 */     // GIR_Coverage, 22677,
     /*  836198 */     GIR_EraseRootFromParent_Done,
     /*  836199 */   // Label 12861: @836199
     /*  836199 */   GIM_Try, /*On fail goto*//*Label 12862*/ GIMT_Encode4(836274), // Rule ID 22680 //
     /*  836204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836272 */     GIR_RootConstrainSelectedInstOperands,
     /*  836273 */     // GIR_Coverage, 22680,
     /*  836273 */     GIR_EraseRootFromParent_Done,
     /*  836274 */   // Label 12862: @836274
     /*  836274 */   GIM_Try, /*On fail goto*//*Label 12863*/ GIMT_Encode4(836349), // Rule ID 22681 //
     /*  836279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  836296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836325 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8),
     /*  836328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836347 */     GIR_RootConstrainSelectedInstOperands,
     /*  836348 */     // GIR_Coverage, 22681,
     /*  836348 */     GIR_EraseRootFromParent_Done,
     /*  836349 */   // Label 12863: @836349
     /*  836349 */   GIM_Try, /*On fail goto*//*Label 12864*/ GIMT_Encode4(836424), // Rule ID 22684 //
     /*  836354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  836400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836422 */     GIR_RootConstrainSelectedInstOperands,
     /*  836423 */     // GIR_Coverage, 22684,
     /*  836423 */     GIR_EraseRootFromParent_Done,
     /*  836424 */   // Label 12864: @836424
     /*  836424 */   GIM_Try, /*On fail goto*//*Label 12865*/ GIMT_Encode4(836499), // Rule ID 22685 //
     /*  836429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  836440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  836443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  836446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  836449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11592:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  836475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8),
     /*  836478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  836494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836497 */     GIR_RootConstrainSelectedInstOperands,
     /*  836498 */     // GIR_Coverage, 22685,
     /*  836498 */     GIR_EraseRootFromParent_Done,
     /*  836499 */   // Label 12865: @836499
     /*  836499 */   GIM_Try, /*On fail goto*//*Label 12866*/ GIMT_Encode4(836574), // Rule ID 22688 //
     /*  836504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  836521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  836553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836572 */     GIR_RootConstrainSelectedInstOperands,
     /*  836573 */     // GIR_Coverage, 22688,
     /*  836573 */     GIR_EraseRootFromParent_Done,
     /*  836574 */   // Label 12866: @836574
     /*  836574 */   GIM_Try, /*On fail goto*//*Label 12867*/ GIMT_Encode4(836649), // Rule ID 22689 //
     /*  836579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  836596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16),
     /*  836628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836647 */     GIR_RootConstrainSelectedInstOperands,
     /*  836648 */     // GIR_Coverage, 22689,
     /*  836648 */     GIR_EraseRootFromParent_Done,
     /*  836649 */   // Label 12867: @836649
     /*  836649 */   GIM_Try, /*On fail goto*//*Label 12868*/ GIMT_Encode4(836724), // Rule ID 22692 //
     /*  836654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  836671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  836703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836722 */     GIR_RootConstrainSelectedInstOperands,
     /*  836723 */     // GIR_Coverage, 22692,
     /*  836723 */     GIR_EraseRootFromParent_Done,
     /*  836724 */   // Label 12868: @836724
     /*  836724 */   GIM_Try, /*On fail goto*//*Label 12869*/ GIMT_Encode4(836799), // Rule ID 22693 //
     /*  836729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  836746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  836764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836775 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16),
     /*  836778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836797 */     GIR_RootConstrainSelectedInstOperands,
     /*  836798 */     // GIR_Coverage, 22693,
     /*  836798 */     GIR_EraseRootFromParent_Done,
     /*  836799 */   // Label 12869: @836799
     /*  836799 */   GIM_Try, /*On fail goto*//*Label 12870*/ GIMT_Encode4(836874), // Rule ID 22696 //
     /*  836804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  836821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  836850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  836853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836872 */     GIR_RootConstrainSelectedInstOperands,
     /*  836873 */     // GIR_Coverage, 22696,
     /*  836873 */     GIR_EraseRootFromParent_Done,
     /*  836874 */   // Label 12870: @836874
     /*  836874 */   GIM_Try, /*On fail goto*//*Label 12871*/ GIMT_Encode4(836949), // Rule ID 22697 //
     /*  836879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  836882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  836890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  836893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  836896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  836899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  836902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  836914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  836925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11592:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  836925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16),
     /*  836928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  836930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  836932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  836934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  836936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  836941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  836944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  836947 */     GIR_RootConstrainSelectedInstOperands,
     /*  836948 */     // GIR_Coverage, 22697,
     /*  836948 */     GIR_EraseRootFromParent_Done,
     /*  836949 */   // Label 12871: @836949
     /*  836949 */   GIM_Try, /*On fail goto*//*Label 12872*/ GIMT_Encode4(837024), // Rule ID 22700 //
     /*  836954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  836957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  836962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  836965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  836968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  836971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  836974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  836977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  836989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  836993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837022 */     GIR_RootConstrainSelectedInstOperands,
     /*  837023 */     // GIR_Coverage, 22700,
     /*  837023 */     GIR_EraseRootFromParent_Done,
     /*  837024 */   // Label 12872: @837024
     /*  837024 */   GIM_Try, /*On fail goto*//*Label 12873*/ GIMT_Encode4(837099), // Rule ID 22701 //
     /*  837029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  837046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  837064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32),
     /*  837078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837097 */     GIR_RootConstrainSelectedInstOperands,
     /*  837098 */     // GIR_Coverage, 22701,
     /*  837098 */     GIR_EraseRootFromParent_Done,
     /*  837099 */   // Label 12873: @837099
     /*  837099 */   GIM_Try, /*On fail goto*//*Label 12874*/ GIMT_Encode4(837174), // Rule ID 22704 //
     /*  837104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837172 */     GIR_RootConstrainSelectedInstOperands,
     /*  837173 */     // GIR_Coverage, 22704,
     /*  837173 */     GIR_EraseRootFromParent_Done,
     /*  837174 */   // Label 12874: @837174
     /*  837174 */   GIM_Try, /*On fail goto*//*Label 12875*/ GIMT_Encode4(837249), // Rule ID 22705 //
     /*  837179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  837196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  837214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837225 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32),
     /*  837228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837247 */     GIR_RootConstrainSelectedInstOperands,
     /*  837248 */     // GIR_Coverage, 22705,
     /*  837248 */     GIR_EraseRootFromParent_Done,
     /*  837249 */   // Label 12875: @837249
     /*  837249 */   GIM_Try, /*On fail goto*//*Label 12876*/ GIMT_Encode4(837324), // Rule ID 22708 //
     /*  837254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  837257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837322 */     GIR_RootConstrainSelectedInstOperands,
     /*  837323 */     // GIR_Coverage, 22708,
     /*  837323 */     GIR_EraseRootFromParent_Done,
     /*  837324 */   // Label 12876: @837324
     /*  837324 */   GIM_Try, /*On fail goto*//*Label 12877*/ GIMT_Encode4(837399), // Rule ID 22709 //
     /*  837329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  837332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum),
     /*  837337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  837340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  837343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  837346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  837349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  837364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11592:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32),
     /*  837378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837397 */     GIR_RootConstrainSelectedInstOperands,
     /*  837398 */     // GIR_Coverage, 22709,
     /*  837398 */     GIR_EraseRootFromParent_Done,
     /*  837399 */   // Label 12877: @837399
     /*  837399 */   GIM_Try, /*On fail goto*//*Label 12878*/ GIMT_Encode4(837474), // Rule ID 22828 //
     /*  837404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  837407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  837453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837472 */     GIR_RootConstrainSelectedInstOperands,
     /*  837473 */     // GIR_Coverage, 22828,
     /*  837473 */     GIR_EraseRootFromParent_Done,
     /*  837474 */   // Label 12878: @837474
     /*  837474 */   GIM_Try, /*On fail goto*//*Label 12879*/ GIMT_Encode4(837549), // Rule ID 22829 //
     /*  837479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  837482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  837496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837525 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16),
     /*  837528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837547 */     GIR_RootConstrainSelectedInstOperands,
     /*  837548 */     // GIR_Coverage, 22829,
     /*  837548 */     GIR_EraseRootFromParent_Done,
     /*  837549 */   // Label 12879: @837549
     /*  837549 */   GIM_Try, /*On fail goto*//*Label 12880*/ GIMT_Encode4(837624), // Rule ID 22832 //
     /*  837554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  837557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837600 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  837603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837622 */     GIR_RootConstrainSelectedInstOperands,
     /*  837623 */     // GIR_Coverage, 22832,
     /*  837623 */     GIR_EraseRootFromParent_Done,
     /*  837624 */   // Label 12880: @837624
     /*  837624 */   GIM_Try, /*On fail goto*//*Label 12881*/ GIMT_Encode4(837699), // Rule ID 22833 //
     /*  837629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  837632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  837646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837675 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16),
     /*  837678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837697 */     GIR_RootConstrainSelectedInstOperands,
     /*  837698 */     // GIR_Coverage, 22833,
     /*  837698 */     GIR_EraseRootFromParent_Done,
     /*  837699 */   // Label 12881: @837699
     /*  837699 */   GIM_Try, /*On fail goto*//*Label 12882*/ GIMT_Encode4(837774), // Rule ID 22836 //
     /*  837704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  837707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837750 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  837750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  837753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837772 */     GIR_RootConstrainSelectedInstOperands,
     /*  837773 */     // GIR_Coverage, 22836,
     /*  837773 */     GIR_EraseRootFromParent_Done,
     /*  837774 */   // Label 12882: @837774
     /*  837774 */   GIM_Try, /*On fail goto*//*Label 12883*/ GIMT_Encode4(837849), // Rule ID 22837 //
     /*  837779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  837782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  837790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  837793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  837796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  837799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837825 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  837825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32),
     /*  837828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  837844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837847 */     GIR_RootConstrainSelectedInstOperands,
     /*  837848 */     // GIR_Coverage, 22837,
     /*  837848 */     GIR_EraseRootFromParent_Done,
     /*  837849 */   // Label 12883: @837849
     /*  837849 */   GIM_Try, /*On fail goto*//*Label 12884*/ GIMT_Encode4(837924), // Rule ID 22840 //
     /*  837854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  837857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  837877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837900 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  837900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  837903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837922 */     GIR_RootConstrainSelectedInstOperands,
     /*  837923 */     // GIR_Coverage, 22840,
     /*  837923 */     GIR_EraseRootFromParent_Done,
     /*  837924 */   // Label 12884: @837924
     /*  837924 */   GIM_Try, /*On fail goto*//*Label 12885*/ GIMT_Encode4(837999), // Rule ID 22841 //
     /*  837929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  837932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  837937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  837940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  837943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  837946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  837949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  837952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  837968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  837975 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  837975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16),
     /*  837978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  837980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  837982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  837984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  837986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  837991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  837994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  837997 */     GIR_RootConstrainSelectedInstOperands,
     /*  837998 */     // GIR_Coverage, 22841,
     /*  837998 */     GIR_EraseRootFromParent_Done,
     /*  837999 */   // Label 12885: @837999
     /*  837999 */   GIM_Try, /*On fail goto*//*Label 12886*/ GIMT_Encode4(838074), // Rule ID 22844 //
     /*  838004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838072 */     GIR_RootConstrainSelectedInstOperands,
     /*  838073 */     // GIR_Coverage, 22844,
     /*  838073 */     GIR_EraseRootFromParent_Done,
     /*  838074 */   // Label 12886: @838074
     /*  838074 */   GIM_Try, /*On fail goto*//*Label 12887*/ GIMT_Encode4(838149), // Rule ID 22845 //
     /*  838079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  838096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838125 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32),
     /*  838128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838147 */     GIR_RootConstrainSelectedInstOperands,
     /*  838148 */     // GIR_Coverage, 22845,
     /*  838148 */     GIR_EraseRootFromParent_Done,
     /*  838149 */   // Label 12887: @838149
     /*  838149 */   GIM_Try, /*On fail goto*//*Label 12888*/ GIMT_Encode4(838224), // Rule ID 22848 //
     /*  838154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  838157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  838200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838222 */     GIR_RootConstrainSelectedInstOperands,
     /*  838223 */     // GIR_Coverage, 22848,
     /*  838223 */     GIR_EraseRootFromParent_Done,
     /*  838224 */   // Label 12888: @838224
     /*  838224 */   GIM_Try, /*On fail goto*//*Label 12889*/ GIMT_Encode4(838299), // Rule ID 22849 //
     /*  838229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  838232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  838240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  838243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  838246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  838249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838275 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  838275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64),
     /*  838278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  838294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838297 */     GIR_RootConstrainSelectedInstOperands,
     /*  838298 */     // GIR_Coverage, 22849,
     /*  838298 */     GIR_EraseRootFromParent_Done,
     /*  838299 */   // Label 12889: @838299
     /*  838299 */   GIM_Try, /*On fail goto*//*Label 12890*/ GIMT_Encode4(838374), // Rule ID 22852 //
     /*  838304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838350 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838372 */     GIR_RootConstrainSelectedInstOperands,
     /*  838373 */     // GIR_Coverage, 22852,
     /*  838373 */     GIR_EraseRootFromParent_Done,
     /*  838374 */   // Label 12890: @838374
     /*  838374 */   GIM_Try, /*On fail goto*//*Label 12891*/ GIMT_Encode4(838449), // Rule ID 22853 //
     /*  838379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  838396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838425 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16),
     /*  838428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838447 */     GIR_RootConstrainSelectedInstOperands,
     /*  838448 */     // GIR_Coverage, 22853,
     /*  838448 */     GIR_EraseRootFromParent_Done,
     /*  838449 */   // Label 12891: @838449
     /*  838449 */   GIM_Try, /*On fail goto*//*Label 12892*/ GIMT_Encode4(838524), // Rule ID 22856 //
     /*  838454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838500 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  838503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838522 */     GIR_RootConstrainSelectedInstOperands,
     /*  838523 */     // GIR_Coverage, 22856,
     /*  838523 */     GIR_EraseRootFromParent_Done,
     /*  838524 */   // Label 12892: @838524
     /*  838524 */   GIM_Try, /*On fail goto*//*Label 12893*/ GIMT_Encode4(838599), // Rule ID 22857 //
     /*  838529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  838546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838575 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16),
     /*  838578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838597 */     GIR_RootConstrainSelectedInstOperands,
     /*  838598 */     // GIR_Coverage, 22857,
     /*  838598 */     GIR_EraseRootFromParent_Done,
     /*  838599 */   // Label 12893: @838599
     /*  838599 */   GIM_Try, /*On fail goto*//*Label 12894*/ GIMT_Encode4(838674), // Rule ID 22860 //
     /*  838604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  838607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  838650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  838653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838672 */     GIR_RootConstrainSelectedInstOperands,
     /*  838673 */     // GIR_Coverage, 22860,
     /*  838673 */     GIR_EraseRootFromParent_Done,
     /*  838674 */   // Label 12894: @838674
     /*  838674 */   GIM_Try, /*On fail goto*//*Label 12895*/ GIMT_Encode4(838749), // Rule ID 22861 //
     /*  838679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  838682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  838690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  838693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  838696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  838699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  838714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838725 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11186:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  838725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16),
     /*  838728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  838744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838747 */     GIR_RootConstrainSelectedInstOperands,
     /*  838748 */     // GIR_Coverage, 22861,
     /*  838748 */     GIR_EraseRootFromParent_Done,
     /*  838749 */   // Label 12895: @838749
     /*  838749 */   GIM_Try, /*On fail goto*//*Label 12896*/ GIMT_Encode4(838824), // Rule ID 22864 //
     /*  838754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838800 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  838803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838822 */     GIR_RootConstrainSelectedInstOperands,
     /*  838823 */     // GIR_Coverage, 22864,
     /*  838823 */     GIR_EraseRootFromParent_Done,
     /*  838824 */   // Label 12896: @838824
     /*  838824 */   GIM_Try, /*On fail goto*//*Label 12897*/ GIMT_Encode4(838899), // Rule ID 22865 //
     /*  838829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  838846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  838852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  838864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838875 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  838875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32),
     /*  838878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838897 */     GIR_RootConstrainSelectedInstOperands,
     /*  838898 */     // GIR_Coverage, 22865,
     /*  838898 */     GIR_EraseRootFromParent_Done,
     /*  838899 */   // Label 12897: @838899
     /*  838899 */   GIM_Try, /*On fail goto*//*Label 12898*/ GIMT_Encode4(838974), // Rule ID 22868 //
     /*  838904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  838907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  838927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  838939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  838943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  838950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  838950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  838953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  838955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  838957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  838959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  838961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  838966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  838969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  838972 */     GIR_RootConstrainSelectedInstOperands,
     /*  838973 */     // GIR_Coverage, 22868,
     /*  838973 */     GIR_EraseRootFromParent_Done,
     /*  838974 */   // Label 12898: @838974
     /*  838974 */   GIM_Try, /*On fail goto*//*Label 12899*/ GIMT_Encode4(839049), // Rule ID 22869 //
     /*  838979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  838982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  838987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  838990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  838993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  838996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  838999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839025 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32),
     /*  839028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839047 */     GIR_RootConstrainSelectedInstOperands,
     /*  839048 */     // GIR_Coverage, 22869,
     /*  839048 */     GIR_EraseRootFromParent_Done,
     /*  839049 */   // Label 12899: @839049
     /*  839049 */   GIM_Try, /*On fail goto*//*Label 12900*/ GIMT_Encode4(839124), // Rule ID 22872 //
     /*  839054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839100 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  839100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839122 */     GIR_RootConstrainSelectedInstOperands,
     /*  839123 */     // GIR_Coverage, 22872,
     /*  839123 */     GIR_EraseRootFromParent_Done,
     /*  839124 */   // Label 12900: @839124
     /*  839124 */   GIM_Try, /*On fail goto*//*Label 12901*/ GIMT_Encode4(839199), // Rule ID 22873 //
     /*  839129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  839132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  839146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839175 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11186:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  839175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32),
     /*  839178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  839194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839197 */     GIR_RootConstrainSelectedInstOperands,
     /*  839198 */     // GIR_Coverage, 22873,
     /*  839198 */     GIR_EraseRootFromParent_Done,
     /*  839199 */   // Label 12901: @839199
     /*  839199 */   GIM_Try, /*On fail goto*//*Label 12902*/ GIMT_Encode4(839274), // Rule ID 22876 //
     /*  839204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839250 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839272 */     GIR_RootConstrainSelectedInstOperands,
     /*  839273 */     // GIR_Coverage, 22876,
     /*  839273 */     GIR_EraseRootFromParent_Done,
     /*  839274 */   // Label 12902: @839274
     /*  839274 */   GIM_Try, /*On fail goto*//*Label 12903*/ GIMT_Encode4(839349), // Rule ID 22877 //
     /*  839279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  839296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  839314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839325 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64),
     /*  839328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839347 */     GIR_RootConstrainSelectedInstOperands,
     /*  839348 */     // GIR_Coverage, 22877,
     /*  839348 */     GIR_EraseRootFromParent_Done,
     /*  839349 */   // Label 12903: @839349
     /*  839349 */   GIM_Try, /*On fail goto*//*Label 12904*/ GIMT_Encode4(839424), // Rule ID 22880 //
     /*  839354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839400 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839422 */     GIR_RootConstrainSelectedInstOperands,
     /*  839423 */     // GIR_Coverage, 22880,
     /*  839423 */     GIR_EraseRootFromParent_Done,
     /*  839424 */   // Label 12904: @839424
     /*  839424 */   GIM_Try, /*On fail goto*//*Label 12905*/ GIMT_Encode4(839499), // Rule ID 22881 //
     /*  839429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  839446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  839464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839475 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64),
     /*  839478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839497 */     GIR_RootConstrainSelectedInstOperands,
     /*  839498 */     // GIR_Coverage, 22881,
     /*  839498 */     GIR_EraseRootFromParent_Done,
     /*  839499 */   // Label 12905: @839499
     /*  839499 */   GIM_Try, /*On fail goto*//*Label 12906*/ GIMT_Encode4(839574), // Rule ID 22884 //
     /*  839504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  839507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  839521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  839550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  839553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839572 */     GIR_RootConstrainSelectedInstOperands,
     /*  839573 */     // GIR_Coverage, 22884,
     /*  839573 */     GIR_EraseRootFromParent_Done,
     /*  839574 */   // Label 12906: @839574
     /*  839574 */   GIM_Try, /*On fail goto*//*Label 12907*/ GIMT_Encode4(839649), // Rule ID 22885 //
     /*  839579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  839582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin),
     /*  839587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  839590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  839593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  839596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  839599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  839614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839625 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11186:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  839625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64),
     /*  839628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  839644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839647 */     GIR_RootConstrainSelectedInstOperands,
     /*  839648 */     // GIR_Coverage, 22885,
     /*  839648 */     GIR_EraseRootFromParent_Done,
     /*  839649 */   // Label 12907: @839649
     /*  839649 */   GIM_Try, /*On fail goto*//*Label 12908*/ GIMT_Encode4(839724), // Rule ID 22888 //
     /*  839654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  839662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  839703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839722 */     GIR_RootConstrainSelectedInstOperands,
     /*  839723 */     // GIR_Coverage, 22888,
     /*  839723 */     GIR_EraseRootFromParent_Done,
     /*  839724 */   // Label 12908: @839724
     /*  839724 */   GIM_Try, /*On fail goto*//*Label 12909*/ GIMT_Encode4(839799), // Rule ID 22889 //
     /*  839729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  839737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  839746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839775 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16),
     /*  839778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839797 */     GIR_RootConstrainSelectedInstOperands,
     /*  839798 */     // GIR_Coverage, 22889,
     /*  839798 */     GIR_EraseRootFromParent_Done,
     /*  839799 */   // Label 12909: @839799
     /*  839799 */   GIM_Try, /*On fail goto*//*Label 12910*/ GIMT_Encode4(839874), // Rule ID 22892 //
     /*  839804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  839807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  839812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839850 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  839850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  839853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839872 */     GIR_RootConstrainSelectedInstOperands,
     /*  839873 */     // GIR_Coverage, 22892,
     /*  839873 */     GIR_EraseRootFromParent_Done,
     /*  839874 */   // Label 12910: @839874
     /*  839874 */   GIM_Try, /*On fail goto*//*Label 12911*/ GIMT_Encode4(839949), // Rule ID 22893 //
     /*  839879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  839882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  839887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  839890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  839893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  839896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  839899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  839902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  839925 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  839925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16),
     /*  839928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  839930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  839932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  839934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  839936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  839941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  839944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  839947 */     GIR_RootConstrainSelectedInstOperands,
     /*  839948 */     // GIR_Coverage, 22893,
     /*  839948 */     GIR_EraseRootFromParent_Done,
     /*  839949 */   // Label 12911: @839949
     /*  839949 */   GIM_Try, /*On fail goto*//*Label 12912*/ GIMT_Encode4(840024), // Rule ID 22896 //
     /*  839954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  839957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  839962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  839965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  839968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  839971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  839974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  839977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  839993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840000 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840022 */     GIR_RootConstrainSelectedInstOperands,
     /*  840023 */     // GIR_Coverage, 22896,
     /*  840023 */     GIR_EraseRootFromParent_Done,
     /*  840024 */   // Label 12912: @840024
     /*  840024 */   GIM_Try, /*On fail goto*//*Label 12913*/ GIMT_Encode4(840099), // Rule ID 22897 //
     /*  840029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  840046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840075 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32),
     /*  840078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840097 */     GIR_RootConstrainSelectedInstOperands,
     /*  840098 */     // GIR_Coverage, 22897,
     /*  840098 */     GIR_EraseRootFromParent_Done,
     /*  840099 */   // Label 12913: @840099
     /*  840099 */   GIM_Try, /*On fail goto*//*Label 12914*/ GIMT_Encode4(840174), // Rule ID 22900 //
     /*  840104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840150 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840172 */     GIR_RootConstrainSelectedInstOperands,
     /*  840173 */     // GIR_Coverage, 22900,
     /*  840173 */     GIR_EraseRootFromParent_Done,
     /*  840174 */   // Label 12914: @840174
     /*  840174 */   GIM_Try, /*On fail goto*//*Label 12915*/ GIMT_Encode4(840249), // Rule ID 22901 //
     /*  840179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  840196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840225 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16),
     /*  840228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840247 */     GIR_RootConstrainSelectedInstOperands,
     /*  840248 */     // GIR_Coverage, 22901,
     /*  840248 */     GIR_EraseRootFromParent_Done,
     /*  840249 */   // Label 12915: @840249
     /*  840249 */   GIM_Try, /*On fail goto*//*Label 12916*/ GIMT_Encode4(840324), // Rule ID 22904 //
     /*  840254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  840257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  840300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840322 */     GIR_RootConstrainSelectedInstOperands,
     /*  840323 */     // GIR_Coverage, 22904,
     /*  840323 */     GIR_EraseRootFromParent_Done,
     /*  840324 */   // Label 12916: @840324
     /*  840324 */   GIM_Try, /*On fail goto*//*Label 12917*/ GIMT_Encode4(840399), // Rule ID 22905 //
     /*  840329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  840332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  840340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  840343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  840346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  840349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840375 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  840375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32),
     /*  840378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  840394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840397 */     GIR_RootConstrainSelectedInstOperands,
     /*  840398 */     // GIR_Coverage, 22905,
     /*  840398 */     GIR_EraseRootFromParent_Done,
     /*  840399 */   // Label 12917: @840399
     /*  840399 */   GIM_Try, /*On fail goto*//*Label 12918*/ GIMT_Encode4(840474), // Rule ID 22908 //
     /*  840404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  840407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  840421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  840450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  840453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840472 */     GIR_RootConstrainSelectedInstOperands,
     /*  840473 */     // GIR_Coverage, 22908,
     /*  840473 */     GIR_EraseRootFromParent_Done,
     /*  840474 */   // Label 12918: @840474
     /*  840474 */   GIM_Try, /*On fail goto*//*Label 12919*/ GIMT_Encode4(840549), // Rule ID 22909 //
     /*  840479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  840482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  840490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  840493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  840496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  840499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840525 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  840525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64),
     /*  840528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  840544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840547 */     GIR_RootConstrainSelectedInstOperands,
     /*  840548 */     // GIR_Coverage, 22909,
     /*  840548 */     GIR_EraseRootFromParent_Done,
     /*  840549 */   // Label 12919: @840549
     /*  840549 */   GIM_Try, /*On fail goto*//*Label 12920*/ GIMT_Encode4(840624), // Rule ID 22912 //
     /*  840554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840600 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  840603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840622 */     GIR_RootConstrainSelectedInstOperands,
     /*  840623 */     // GIR_Coverage, 22912,
     /*  840623 */     GIR_EraseRootFromParent_Done,
     /*  840624 */   // Label 12920: @840624
     /*  840624 */   GIM_Try, /*On fail goto*//*Label 12921*/ GIMT_Encode4(840699), // Rule ID 22913 //
     /*  840629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  840646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  840664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840675 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16),
     /*  840678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840697 */     GIR_RootConstrainSelectedInstOperands,
     /*  840698 */     // GIR_Coverage, 22913,
     /*  840698 */     GIR_EraseRootFromParent_Done,
     /*  840699 */   // Label 12921: @840699
     /*  840699 */   GIM_Try, /*On fail goto*//*Label 12922*/ GIMT_Encode4(840774), // Rule ID 22916 //
     /*  840704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  840721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  840753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840772 */     GIR_RootConstrainSelectedInstOperands,
     /*  840773 */     // GIR_Coverage, 22916,
     /*  840773 */     GIR_EraseRootFromParent_Done,
     /*  840774 */   // Label 12922: @840774
     /*  840774 */   GIM_Try, /*On fail goto*//*Label 12923*/ GIMT_Encode4(840849), // Rule ID 22917 //
     /*  840779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  840796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  840814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840825 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16),
     /*  840828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840847 */     GIR_RootConstrainSelectedInstOperands,
     /*  840848 */     // GIR_Coverage, 22917,
     /*  840848 */     GIR_EraseRootFromParent_Done,
     /*  840849 */   // Label 12923: @840849
     /*  840849 */   GIM_Try, /*On fail goto*//*Label 12924*/ GIMT_Encode4(840924), // Rule ID 22920 //
     /*  840854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  840857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  840871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  840877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840900 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  840900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  840903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840922 */     GIR_RootConstrainSelectedInstOperands,
     /*  840923 */     // GIR_Coverage, 22920,
     /*  840923 */     GIR_EraseRootFromParent_Done,
     /*  840924 */   // Label 12924: @840924
     /*  840924 */   GIM_Try, /*On fail goto*//*Label 12925*/ GIMT_Encode4(840999), // Rule ID 22921 //
     /*  840929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  840932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  840937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  840940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  840943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  840946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  840949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  840952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  840964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  840968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  840975 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11184:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  840975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16),
     /*  840978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  840980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  840982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  840984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  840986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  840991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  840994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  840997 */     GIR_RootConstrainSelectedInstOperands,
     /*  840998 */     // GIR_Coverage, 22921,
     /*  840998 */     GIR_EraseRootFromParent_Done,
     /*  840999 */   // Label 12925: @840999
     /*  840999 */   GIM_Try, /*On fail goto*//*Label 12926*/ GIMT_Encode4(841074), // Rule ID 22924 //
     /*  841004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841050 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841072 */     GIR_RootConstrainSelectedInstOperands,
     /*  841073 */     // GIR_Coverage, 22924,
     /*  841073 */     GIR_EraseRootFromParent_Done,
     /*  841074 */   // Label 12926: @841074
     /*  841074 */   GIM_Try, /*On fail goto*//*Label 12927*/ GIMT_Encode4(841149), // Rule ID 22925 //
     /*  841079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  841096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841125 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32),
     /*  841128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841147 */     GIR_RootConstrainSelectedInstOperands,
     /*  841148 */     // GIR_Coverage, 22925,
     /*  841148 */     GIR_EraseRootFromParent_Done,
     /*  841149 */   // Label 12927: @841149
     /*  841149 */   GIM_Try, /*On fail goto*//*Label 12928*/ GIMT_Encode4(841224), // Rule ID 22928 //
     /*  841154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841200 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841222 */     GIR_RootConstrainSelectedInstOperands,
     /*  841223 */     // GIR_Coverage, 22928,
     /*  841223 */     GIR_EraseRootFromParent_Done,
     /*  841224 */   // Label 12928: @841224
     /*  841224 */   GIM_Try, /*On fail goto*//*Label 12929*/ GIMT_Encode4(841299), // Rule ID 22929 //
     /*  841229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  841246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841275 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32),
     /*  841278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841297 */     GIR_RootConstrainSelectedInstOperands,
     /*  841298 */     // GIR_Coverage, 22929,
     /*  841298 */     GIR_EraseRootFromParent_Done,
     /*  841299 */   // Label 12929: @841299
     /*  841299 */   GIM_Try, /*On fail goto*//*Label 12930*/ GIMT_Encode4(841374), // Rule ID 22932 //
     /*  841304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  841307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841350 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  841350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841372 */     GIR_RootConstrainSelectedInstOperands,
     /*  841373 */     // GIR_Coverage, 22932,
     /*  841373 */     GIR_EraseRootFromParent_Done,
     /*  841374 */   // Label 12930: @841374
     /*  841374 */   GIM_Try, /*On fail goto*//*Label 12931*/ GIMT_Encode4(841449), // Rule ID 22933 //
     /*  841379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  841382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  841390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  841393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  841396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  841399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841425 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11184:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  841425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32),
     /*  841428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  841444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841447 */     GIR_RootConstrainSelectedInstOperands,
     /*  841448 */     // GIR_Coverage, 22933,
     /*  841448 */     GIR_EraseRootFromParent_Done,
     /*  841449 */   // Label 12931: @841449
     /*  841449 */   GIM_Try, /*On fail goto*//*Label 12932*/ GIMT_Encode4(841524), // Rule ID 22936 //
     /*  841454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  841471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841500 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  841500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  841503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841522 */     GIR_RootConstrainSelectedInstOperands,
     /*  841523 */     // GIR_Coverage, 22936,
     /*  841523 */     GIR_EraseRootFromParent_Done,
     /*  841524 */   // Label 12932: @841524
     /*  841524 */   GIM_Try, /*On fail goto*//*Label 12933*/ GIMT_Encode4(841599), // Rule ID 22937 //
     /*  841529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  841546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  841564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841575 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64),
     /*  841578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841597 */     GIR_RootConstrainSelectedInstOperands,
     /*  841598 */     // GIR_Coverage, 22937,
     /*  841598 */     GIR_EraseRootFromParent_Done,
     /*  841599 */   // Label 12933: @841599
     /*  841599 */   GIM_Try, /*On fail goto*//*Label 12934*/ GIMT_Encode4(841674), // Rule ID 22940 //
     /*  841604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  841621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  841650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  841653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841672 */     GIR_RootConstrainSelectedInstOperands,
     /*  841673 */     // GIR_Coverage, 22940,
     /*  841673 */     GIR_EraseRootFromParent_Done,
     /*  841674 */   // Label 12934: @841674
     /*  841674 */   GIM_Try, /*On fail goto*//*Label 12935*/ GIMT_Encode4(841749), // Rule ID 22941 //
     /*  841679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  841696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  841714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841725 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64),
     /*  841728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841747 */     GIR_RootConstrainSelectedInstOperands,
     /*  841748 */     // GIR_Coverage, 22941,
     /*  841748 */     GIR_EraseRootFromParent_Done,
     /*  841749 */   // Label 12935: @841749
     /*  841749 */   GIM_Try, /*On fail goto*//*Label 12936*/ GIMT_Encode4(841824), // Rule ID 22944 //
     /*  841754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  841757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  841771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841800 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  841800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  841803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841822 */     GIR_RootConstrainSelectedInstOperands,
     /*  841823 */     // GIR_Coverage, 22944,
     /*  841823 */     GIR_EraseRootFromParent_Done,
     /*  841824 */   // Label 12936: @841824
     /*  841824 */   GIM_Try, /*On fail goto*//*Label 12937*/ GIMT_Encode4(841899), // Rule ID 22945 //
     /*  841829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  841832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax),
     /*  841837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  841840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  841843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  841846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  841849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  841852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  841864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841875 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11184:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  841875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64),
     /*  841878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  841882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  841884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  841886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  841894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841897 */     GIR_RootConstrainSelectedInstOperands,
     /*  841898 */     // GIR_Coverage, 22945,
     /*  841898 */     GIR_EraseRootFromParent_Done,
     /*  841899 */   // Label 12937: @841899
     /*  841899 */   GIM_Try, /*On fail goto*//*Label 12938*/ GIMT_Encode4(841974), // Rule ID 23226 //
     /*  841904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  841907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  841912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  841915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  841918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  841921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  841924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  841927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  841931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  841939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  841943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  841950 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  841950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  841953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  841955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  841957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  841959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  841961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  841966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  841969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  841972 */     GIR_RootConstrainSelectedInstOperands,
     /*  841973 */     // GIR_Coverage, 23226,
     /*  841973 */     GIR_EraseRootFromParent_Done,
     /*  841974 */   // Label 12938: @841974
     /*  841974 */   GIM_Try, /*On fail goto*//*Label 12939*/ GIMT_Encode4(842049), // Rule ID 23227 //
     /*  841979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  841982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  841987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  841990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  841993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  841996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  841999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842025 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B32_MASK),
     /*  842028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842034 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842047 */     GIR_RootConstrainSelectedInstOperands,
     /*  842048 */     // GIR_Coverage, 23227,
     /*  842048 */     GIR_EraseRootFromParent_Done,
     /*  842049 */   // Label 12939: @842049
     /*  842049 */   GIM_Try, /*On fail goto*//*Label 12940*/ GIMT_Encode4(842124), // Rule ID 23230 //
     /*  842054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842122 */     GIR_RootConstrainSelectedInstOperands,
     /*  842123 */     // GIR_Coverage, 23230,
     /*  842123 */     GIR_EraseRootFromParent_Done,
     /*  842124 */   // Label 12940: @842124
     /*  842124 */   GIM_Try, /*On fail goto*//*Label 12941*/ GIMT_Encode4(842199), // Rule ID 23231 //
     /*  842129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  842140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  842143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  842146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  842149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842175 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B16_MASK),
     /*  842178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842197 */     GIR_RootConstrainSelectedInstOperands,
     /*  842198 */     // GIR_Coverage, 23231,
     /*  842198 */     GIR_EraseRootFromParent_Done,
     /*  842199 */   // Label 12941: @842199
     /*  842199 */   GIM_Try, /*On fail goto*//*Label 12942*/ GIMT_Encode4(842274), // Rule ID 23234 //
     /*  842204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842272 */     GIR_RootConstrainSelectedInstOperands,
     /*  842273 */     // GIR_Coverage, 23234,
     /*  842273 */     GIR_EraseRootFromParent_Done,
     /*  842274 */   // Label 12942: @842274
     /*  842274 */   GIM_Try, /*On fail goto*//*Label 12943*/ GIMT_Encode4(842349), // Rule ID 23235 //
     /*  842279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  842290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  842293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  842296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  842299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B8_MASK),
     /*  842328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842347 */     GIR_RootConstrainSelectedInstOperands,
     /*  842348 */     // GIR_Coverage, 23235,
     /*  842348 */     GIR_EraseRootFromParent_Done,
     /*  842349 */   // Label 12943: @842349
     /*  842349 */   GIM_Try, /*On fail goto*//*Label 12944*/ GIMT_Encode4(842424), // Rule ID 23238 //
     /*  842354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842400 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842422 */     GIR_RootConstrainSelectedInstOperands,
     /*  842423 */     // GIR_Coverage, 23238,
     /*  842423 */     GIR_EraseRootFromParent_Done,
     /*  842424 */   // Label 12944: @842424
     /*  842424 */   GIM_Try, /*On fail goto*//*Label 12945*/ GIMT_Encode4(842499), // Rule ID 23239 //
     /*  842429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  842440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  842443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  842446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  842449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842475 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B4_MASK),
     /*  842478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842497 */     GIR_RootConstrainSelectedInstOperands,
     /*  842498 */     // GIR_Coverage, 23239,
     /*  842498 */     GIR_EraseRootFromParent_Done,
     /*  842499 */   // Label 12945: @842499
     /*  842499 */   GIM_Try, /*On fail goto*//*Label 12946*/ GIMT_Encode4(842574), // Rule ID 23242 //
     /*  842504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  842515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  842518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  842521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  842524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842550 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  842553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842572 */     GIR_RootConstrainSelectedInstOperands,
     /*  842573 */     // GIR_Coverage, 23242,
     /*  842573 */     GIR_EraseRootFromParent_Done,
     /*  842574 */   // Label 12946: @842574
     /*  842574 */   GIM_Try, /*On fail goto*//*Label 12947*/ GIMT_Encode4(842649), // Rule ID 23243 //
     /*  842579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  842590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  842593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  842596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  842599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842625 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B2_MASK),
     /*  842628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842647 */     GIR_RootConstrainSelectedInstOperands,
     /*  842648 */     // GIR_Coverage, 23243,
     /*  842648 */     GIR_EraseRootFromParent_Done,
     /*  842649 */   // Label 12947: @842649
     /*  842649 */   GIM_Try, /*On fail goto*//*Label 12948*/ GIMT_Encode4(842724), // Rule ID 23246 //
     /*  842654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  842665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  842668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  842671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  842674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842700 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  842703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842722 */     GIR_RootConstrainSelectedInstOperands,
     /*  842723 */     // GIR_Coverage, 23246,
     /*  842723 */     GIR_EraseRootFromParent_Done,
     /*  842724 */   // Label 12948: @842724
     /*  842724 */   GIM_Try, /*On fail goto*//*Label 12949*/ GIMT_Encode4(842799), // Rule ID 23247 //
     /*  842729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsbf_mask),
     /*  842737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  842740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  842743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  842746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  842749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842775 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11374:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSBF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSBF_M_B1_MASK),
     /*  842778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842797 */     GIR_RootConstrainSelectedInstOperands,
     /*  842798 */     // GIR_Coverage, 23247,
     /*  842798 */     GIR_EraseRootFromParent_Done,
     /*  842799 */   // Label 12949: @842799
     /*  842799 */   GIM_Try, /*On fail goto*//*Label 12950*/ GIMT_Encode4(842874), // Rule ID 23250 //
     /*  842804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  842812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  842815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  842818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  842821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  842824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  842850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  842853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842872 */     GIR_RootConstrainSelectedInstOperands,
     /*  842873 */     // GIR_Coverage, 23250,
     /*  842873 */     GIR_EraseRootFromParent_Done,
     /*  842874 */   // Label 12950: @842874
     /*  842874 */   GIM_Try, /*On fail goto*//*Label 12951*/ GIMT_Encode4(842949), // Rule ID 23251 //
     /*  842879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  842882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  842887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  842890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  842893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  842896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  842899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  842902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  842925 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  842925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B64_MASK),
     /*  842928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  842930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  842932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  842934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  842936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  842941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  842944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  842947 */     GIR_RootConstrainSelectedInstOperands,
     /*  842948 */     // GIR_Coverage, 23251,
     /*  842948 */     GIR_EraseRootFromParent_Done,
     /*  842949 */   // Label 12951: @842949
     /*  842949 */   GIM_Try, /*On fail goto*//*Label 12952*/ GIMT_Encode4(843024), // Rule ID 23254 //
     /*  842954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  842957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  842962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  842965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  842968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  842971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  842974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  842977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  842981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  842989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  842993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843022 */     GIR_RootConstrainSelectedInstOperands,
     /*  843023 */     // GIR_Coverage, 23254,
     /*  843023 */     GIR_EraseRootFromParent_Done,
     /*  843024 */   // Label 12952: @843024
     /*  843024 */   GIM_Try, /*On fail goto*//*Label 12953*/ GIMT_Encode4(843099), // Rule ID 23255 //
     /*  843029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  843040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  843043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  843046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  843049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843075 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B32_MASK),
     /*  843078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843097 */     GIR_RootConstrainSelectedInstOperands,
     /*  843098 */     // GIR_Coverage, 23255,
     /*  843098 */     GIR_EraseRootFromParent_Done,
     /*  843099 */   // Label 12953: @843099
     /*  843099 */   GIM_Try, /*On fail goto*//*Label 12954*/ GIMT_Encode4(843174), // Rule ID 23258 //
     /*  843104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843150 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843172 */     GIR_RootConstrainSelectedInstOperands,
     /*  843173 */     // GIR_Coverage, 23258,
     /*  843173 */     GIR_EraseRootFromParent_Done,
     /*  843174 */   // Label 12954: @843174
     /*  843174 */   GIM_Try, /*On fail goto*//*Label 12955*/ GIMT_Encode4(843249), // Rule ID 23259 //
     /*  843179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  843190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  843193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  843196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  843199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843225 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B16_MASK),
     /*  843228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843247 */     GIR_RootConstrainSelectedInstOperands,
     /*  843248 */     // GIR_Coverage, 23259,
     /*  843248 */     GIR_EraseRootFromParent_Done,
     /*  843249 */   // Label 12955: @843249
     /*  843249 */   GIM_Try, /*On fail goto*//*Label 12956*/ GIMT_Encode4(843324), // Rule ID 23262 //
     /*  843254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843300 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843322 */     GIR_RootConstrainSelectedInstOperands,
     /*  843323 */     // GIR_Coverage, 23262,
     /*  843323 */     GIR_EraseRootFromParent_Done,
     /*  843324 */   // Label 12956: @843324
     /*  843324 */   GIM_Try, /*On fail goto*//*Label 12957*/ GIMT_Encode4(843399), // Rule ID 23263 //
     /*  843329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  843340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  843343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  843346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  843349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B8_MASK),
     /*  843378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843397 */     GIR_RootConstrainSelectedInstOperands,
     /*  843398 */     // GIR_Coverage, 23263,
     /*  843398 */     GIR_EraseRootFromParent_Done,
     /*  843399 */   // Label 12957: @843399
     /*  843399 */   GIM_Try, /*On fail goto*//*Label 12958*/ GIMT_Encode4(843474), // Rule ID 23266 //
     /*  843404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843450 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  843453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843472 */     GIR_RootConstrainSelectedInstOperands,
     /*  843473 */     // GIR_Coverage, 23266,
     /*  843473 */     GIR_EraseRootFromParent_Done,
     /*  843474 */   // Label 12958: @843474
     /*  843474 */   GIM_Try, /*On fail goto*//*Label 12959*/ GIMT_Encode4(843549), // Rule ID 23267 //
     /*  843479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  843490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  843493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  843496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  843499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843525 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B4_MASK),
     /*  843528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843534 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843547 */     GIR_RootConstrainSelectedInstOperands,
     /*  843548 */     // GIR_Coverage, 23267,
     /*  843548 */     GIR_EraseRootFromParent_Done,
     /*  843549 */   // Label 12959: @843549
     /*  843549 */   GIM_Try, /*On fail goto*//*Label 12960*/ GIMT_Encode4(843624), // Rule ID 23270 //
     /*  843554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843600 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  843603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843622 */     GIR_RootConstrainSelectedInstOperands,
     /*  843623 */     // GIR_Coverage, 23270,
     /*  843623 */     GIR_EraseRootFromParent_Done,
     /*  843624 */   // Label 12960: @843624
     /*  843624 */   GIM_Try, /*On fail goto*//*Label 12961*/ GIMT_Encode4(843699), // Rule ID 23271 //
     /*  843629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  843640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  843643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  843646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  843649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843675 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B2_MASK),
     /*  843678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843684 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843697 */     GIR_RootConstrainSelectedInstOperands,
     /*  843698 */     // GIR_Coverage, 23271,
     /*  843698 */     GIR_EraseRootFromParent_Done,
     /*  843699 */   // Label 12961: @843699
     /*  843699 */   GIM_Try, /*On fail goto*//*Label 12962*/ GIMT_Encode4(843774), // Rule ID 23274 //
     /*  843704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843750 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  843753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843772 */     GIR_RootConstrainSelectedInstOperands,
     /*  843773 */     // GIR_Coverage, 23274,
     /*  843773 */     GIR_EraseRootFromParent_Done,
     /*  843774 */   // Label 12962: @843774
     /*  843774 */   GIM_Try, /*On fail goto*//*Label 12963*/ GIMT_Encode4(843849), // Rule ID 23275 //
     /*  843779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsif_mask),
     /*  843787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  843790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  843793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  843796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  843799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843825 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11387:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSIF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSIF_M_B1_MASK),
     /*  843828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843847 */     GIR_RootConstrainSelectedInstOperands,
     /*  843848 */     // GIR_Coverage, 23275,
     /*  843848 */     GIR_EraseRootFromParent_Done,
     /*  843849 */   // Label 12963: @843849
     /*  843849 */   GIM_Try, /*On fail goto*//*Label 12964*/ GIMT_Encode4(843924), // Rule ID 23278 //
     /*  843854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  843857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  843862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  843877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  843900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  843903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843922 */     GIR_RootConstrainSelectedInstOperands,
     /*  843923 */     // GIR_Coverage, 23278,
     /*  843923 */     GIR_EraseRootFromParent_Done,
     /*  843924 */   // Label 12964: @843924
     /*  843924 */   GIM_Try, /*On fail goto*//*Label 12965*/ GIMT_Encode4(843999), // Rule ID 23279 //
     /*  843929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  843932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  843937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  843940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  843943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  843946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  843949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  843952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  843956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  843964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  843968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  843975 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B64_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  843975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B64_MASK),
     /*  843978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  843980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  843982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  843984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  843986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  843991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  843994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  843997 */     GIR_RootConstrainSelectedInstOperands,
     /*  843998 */     // GIR_Coverage, 23279,
     /*  843998 */     GIR_EraseRootFromParent_Done,
     /*  843999 */   // Label 12965: @843999
     /*  843999 */   GIM_Try, /*On fail goto*//*Label 12966*/ GIMT_Encode4(844074), // Rule ID 23282 //
     /*  844004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844050 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844072 */     GIR_RootConstrainSelectedInstOperands,
     /*  844073 */     // GIR_Coverage, 23282,
     /*  844073 */     GIR_EraseRootFromParent_Done,
     /*  844074 */   // Label 12966: @844074
     /*  844074 */   GIM_Try, /*On fail goto*//*Label 12967*/ GIMT_Encode4(844149), // Rule ID 23283 //
     /*  844079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  844090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  844093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /*  844096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  844099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B32_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B32_MASK),
     /*  844128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844134 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844147 */     GIR_RootConstrainSelectedInstOperands,
     /*  844148 */     // GIR_Coverage, 23283,
     /*  844148 */     GIR_EraseRootFromParent_Done,
     /*  844149 */   // Label 12967: @844149
     /*  844149 */   GIM_Try, /*On fail goto*//*Label 12968*/ GIMT_Encode4(844224), // Rule ID 23286 //
     /*  844154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844222 */     GIR_RootConstrainSelectedInstOperands,
     /*  844223 */     // GIR_Coverage, 23286,
     /*  844223 */     GIR_EraseRootFromParent_Done,
     /*  844224 */   // Label 12968: @844224
     /*  844224 */   GIM_Try, /*On fail goto*//*Label 12969*/ GIMT_Encode4(844299), // Rule ID 23287 //
     /*  844229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  844240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  844243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /*  844246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  844249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B16_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B16_MASK),
     /*  844278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844297 */     GIR_RootConstrainSelectedInstOperands,
     /*  844298 */     // GIR_Coverage, 23287,
     /*  844298 */     GIR_EraseRootFromParent_Done,
     /*  844299 */   // Label 12969: @844299
     /*  844299 */   GIM_Try, /*On fail goto*//*Label 12970*/ GIMT_Encode4(844374), // Rule ID 23290 //
     /*  844304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844350 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844372 */     GIR_RootConstrainSelectedInstOperands,
     /*  844373 */     // GIR_Coverage, 23290,
     /*  844373 */     GIR_EraseRootFromParent_Done,
     /*  844374 */   // Label 12970: @844374
     /*  844374 */   GIM_Try, /*On fail goto*//*Label 12971*/ GIMT_Encode4(844449), // Rule ID 23291 //
     /*  844379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  844390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  844393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /*  844396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  844399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844425 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B8_MASK),
     /*  844428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844447 */     GIR_RootConstrainSelectedInstOperands,
     /*  844448 */     // GIR_Coverage, 23291,
     /*  844448 */     GIR_EraseRootFromParent_Done,
     /*  844449 */   // Label 12971: @844449
     /*  844449 */   GIM_Try, /*On fail goto*//*Label 12972*/ GIMT_Encode4(844524), // Rule ID 23294 //
     /*  844454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  844503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844522 */     GIR_RootConstrainSelectedInstOperands,
     /*  844523 */     // GIR_Coverage, 23294,
     /*  844523 */     GIR_EraseRootFromParent_Done,
     /*  844524 */   // Label 12972: @844524
     /*  844524 */   GIM_Try, /*On fail goto*//*Label 12973*/ GIMT_Encode4(844599), // Rule ID 23295 //
     /*  844529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  844540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  844543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /*  844546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  844549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844575 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B4_MASK),
     /*  844578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844597 */     GIR_RootConstrainSelectedInstOperands,
     /*  844598 */     // GIR_Coverage, 23295,
     /*  844598 */     GIR_EraseRootFromParent_Done,
     /*  844599 */   // Label 12973: @844599
     /*  844599 */   GIM_Try, /*On fail goto*//*Label 12974*/ GIMT_Encode4(844674), // Rule ID 23298 //
     /*  844604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844650 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  844653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844672 */     GIR_RootConstrainSelectedInstOperands,
     /*  844673 */     // GIR_Coverage, 23298,
     /*  844673 */     GIR_EraseRootFromParent_Done,
     /*  844674 */   // Label 12974: @844674
     /*  844674 */   GIM_Try, /*On fail goto*//*Label 12975*/ GIMT_Encode4(844749), // Rule ID 23299 //
     /*  844679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  844690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  844693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /*  844696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  844699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844725 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B2_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B2_MASK),
     /*  844728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844747 */     GIR_RootConstrainSelectedInstOperands,
     /*  844748 */     // GIR_Coverage, 23299,
     /*  844748 */     GIR_EraseRootFromParent_Done,
     /*  844749 */   // Label 12975: @844749
     /*  844749 */   GIM_Try, /*On fail goto*//*Label 12976*/ GIMT_Encode4(844824), // Rule ID 23302 //
     /*  844754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /*  844757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844800 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 0:{ *:[i64] }, 1:{ *:[i64] })
     /*  844800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  844803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844822 */     GIR_RootConstrainSelectedInstOperands,
     /*  844823 */     // GIR_Coverage, 23302,
     /*  844823 */     GIR_EraseRootFromParent_Done,
     /*  844824 */   // Label 12976: @844824
     /*  844824 */   GIM_Try, /*On fail goto*//*Label 12977*/ GIMT_Encode4(844899), // Rule ID 23303 //
     /*  844829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /*  844832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsof_mask),
     /*  844837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  844840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  844843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /*  844846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  844849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  844852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  844856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  844868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844875 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11399:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSOF_M_B1_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 0:{ *:[i32] }, 1:{ *:[i32] })
     /*  844875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSOF_M_B1_MASK),
     /*  844878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  844884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  844886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  844897 */     GIR_RootConstrainSelectedInstOperands,
     /*  844898 */     // GIR_Coverage, 23303,
     /*  844898 */     GIR_EraseRootFromParent_Done,
     /*  844899 */   // Label 12977: @844899
     /*  844899 */   GIM_Try, /*On fail goto*//*Label 12978*/ GIMT_Encode4(844974), // Rule ID 23844 //
     /*  844904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  844907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  844912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  844915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  844918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  844921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  844924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  844927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  844939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  844943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  844950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  844950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  844953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  844955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  844957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  844959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  844961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  844966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  844969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  844972 */     GIR_RootConstrainSelectedInstOperands,
     /*  844973 */     // GIR_Coverage, 23844,
     /*  844973 */     GIR_EraseRootFromParent_Done,
     /*  844974 */   // Label 12978: @844974
     /*  844974 */   GIM_Try, /*On fail goto*//*Label 12979*/ GIMT_Encode4(845049), // Rule ID 23845 //
     /*  844979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  844982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  844987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  844990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  844993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  844996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  844999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845025 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8),
     /*  845028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845047 */     GIR_RootConstrainSelectedInstOperands,
     /*  845048 */     // GIR_Coverage, 23845,
     /*  845048 */     GIR_EraseRootFromParent_Done,
     /*  845049 */   // Label 12979: @845049
     /*  845049 */   GIM_Try, /*On fail goto*//*Label 12980*/ GIMT_Encode4(845124), // Rule ID 23848 //
     /*  845054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845100 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845122 */     GIR_RootConstrainSelectedInstOperands,
     /*  845123 */     // GIR_Coverage, 23848,
     /*  845123 */     GIR_EraseRootFromParent_Done,
     /*  845124 */   // Label 12980: @845124
     /*  845124 */   GIM_Try, /*On fail goto*//*Label 12981*/ GIMT_Encode4(845199), // Rule ID 23849 //
     /*  845129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  845140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  845143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  845146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845175 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845197 */     GIR_RootConstrainSelectedInstOperands,
     /*  845198 */     // GIR_Coverage, 23849,
     /*  845198 */     GIR_EraseRootFromParent_Done,
     /*  845199 */   // Label 12981: @845199
     /*  845199 */   GIM_Try, /*On fail goto*//*Label 12982*/ GIMT_Encode4(845274), // Rule ID 23852 //
     /*  845204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845250 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845272 */     GIR_RootConstrainSelectedInstOperands,
     /*  845273 */     // GIR_Coverage, 23852,
     /*  845273 */     GIR_EraseRootFromParent_Done,
     /*  845274 */   // Label 12982: @845274
     /*  845274 */   GIM_Try, /*On fail goto*//*Label 12983*/ GIMT_Encode4(845349), // Rule ID 23853 //
     /*  845279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  845290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  845293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  845296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845325 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845347 */     GIR_RootConstrainSelectedInstOperands,
     /*  845348 */     // GIR_Coverage, 23853,
     /*  845348 */     GIR_EraseRootFromParent_Done,
     /*  845349 */   // Label 12983: @845349
     /*  845349 */   GIM_Try, /*On fail goto*//*Label 12984*/ GIMT_Encode4(845424), // Rule ID 23856 //
     /*  845354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845400 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845422 */     GIR_RootConstrainSelectedInstOperands,
     /*  845423 */     // GIR_Coverage, 23856,
     /*  845423 */     GIR_EraseRootFromParent_Done,
     /*  845424 */   // Label 12984: @845424
     /*  845424 */   GIM_Try, /*On fail goto*//*Label 12985*/ GIMT_Encode4(845499), // Rule ID 23857 //
     /*  845429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  845440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  845443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  845446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845475 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4),
     /*  845478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845497 */     GIR_RootConstrainSelectedInstOperands,
     /*  845498 */     // GIR_Coverage, 23857,
     /*  845498 */     GIR_EraseRootFromParent_Done,
     /*  845499 */   // Label 12985: @845499
     /*  845499 */   GIM_Try, /*On fail goto*//*Label 12986*/ GIMT_Encode4(845574), // Rule ID 23860 //
     /*  845504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  845515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  845518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  845521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845550 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  845550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845572 */     GIR_RootConstrainSelectedInstOperands,
     /*  845573 */     // GIR_Coverage, 23860,
     /*  845573 */     GIR_EraseRootFromParent_Done,
     /*  845574 */   // Label 12986: @845574
     /*  845574 */   GIM_Try, /*On fail goto*//*Label 12987*/ GIMT_Encode4(845649), // Rule ID 23861 //
     /*  845579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  845590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  845593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  845596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845625 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  845625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  845644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845647 */     GIR_RootConstrainSelectedInstOperands,
     /*  845648 */     // GIR_Coverage, 23861,
     /*  845648 */     GIR_EraseRootFromParent_Done,
     /*  845649 */   // Label 12987: @845649
     /*  845649 */   GIM_Try, /*On fail goto*//*Label 12988*/ GIMT_Encode4(845724), // Rule ID 23864 //
     /*  845654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  845665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  845668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  845671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  845700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845722 */     GIR_RootConstrainSelectedInstOperands,
     /*  845723 */     // GIR_Coverage, 23864,
     /*  845723 */     GIR_EraseRootFromParent_Done,
     /*  845724 */   // Label 12988: @845724
     /*  845724 */   GIM_Try, /*On fail goto*//*Label 12989*/ GIMT_Encode4(845799), // Rule ID 23865 //
     /*  845729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  845740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  845743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  845746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845775 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  845775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2),
     /*  845778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  845794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845797 */     GIR_RootConstrainSelectedInstOperands,
     /*  845798 */     // GIR_Coverage, 23865,
     /*  845798 */     GIR_EraseRootFromParent_Done,
     /*  845799 */   // Label 12989: @845799
     /*  845799 */   GIM_Try, /*On fail goto*//*Label 12990*/ GIMT_Encode4(845874), // Rule ID 23868 //
     /*  845804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  845815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  845818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  845821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  845850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  845853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845872 */     GIR_RootConstrainSelectedInstOperands,
     /*  845873 */     // GIR_Coverage, 23868,
     /*  845873 */     GIR_EraseRootFromParent_Done,
     /*  845874 */   // Label 12990: @845874
     /*  845874 */   GIM_Try, /*On fail goto*//*Label 12991*/ GIMT_Encode4(845949), // Rule ID 23869 //
     /*  845879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  845882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  845890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  845893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  845896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  845899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  845902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  845925 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11478:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  845925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  845928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  845930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  845932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  845934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  845936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  845941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  845944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  845947 */     GIR_RootConstrainSelectedInstOperands,
     /*  845948 */     // GIR_Coverage, 23869,
     /*  845948 */     GIR_EraseRootFromParent_Done,
     /*  845949 */   // Label 12991: @845949
     /*  845949 */   GIM_Try, /*On fail goto*//*Label 12992*/ GIMT_Encode4(846024), // Rule ID 23872 //
     /*  845954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  845957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  845962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  845965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  845968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  845971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  845974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  845977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  845989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  845993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846000 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846022 */     GIR_RootConstrainSelectedInstOperands,
     /*  846023 */     // GIR_Coverage, 23872,
     /*  846023 */     GIR_EraseRootFromParent_Done,
     /*  846024 */   // Label 12992: @846024
     /*  846024 */   GIM_Try, /*On fail goto*//*Label 12993*/ GIMT_Encode4(846099), // Rule ID 23873 //
     /*  846029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  846040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  846043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  846046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846075 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11478:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846097 */     GIR_RootConstrainSelectedInstOperands,
     /*  846098 */     // GIR_Coverage, 23873,
     /*  846098 */     GIR_EraseRootFromParent_Done,
     /*  846099 */   // Label 12993: @846099
     /*  846099 */   GIM_Try, /*On fail goto*//*Label 12994*/ GIMT_Encode4(846174), // Rule ID 23876 //
     /*  846104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846150 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  846150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846172 */     GIR_RootConstrainSelectedInstOperands,
     /*  846173 */     // GIR_Coverage, 23876,
     /*  846173 */     GIR_EraseRootFromParent_Done,
     /*  846174 */   // Label 12994: @846174
     /*  846174 */   GIM_Try, /*On fail goto*//*Label 12995*/ GIMT_Encode4(846249), // Rule ID 23877 //
     /*  846179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  846190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  846193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  846196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846225 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11478:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  846225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  846244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846247 */     GIR_RootConstrainSelectedInstOperands,
     /*  846248 */     // GIR_Coverage, 23877,
     /*  846248 */     GIR_EraseRootFromParent_Done,
     /*  846249 */   // Label 12995: @846249
     /*  846249 */   GIM_Try, /*On fail goto*//*Label 12996*/ GIMT_Encode4(846324), // Rule ID 23880 //
     /*  846254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  846257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846300 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  846300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846322 */     GIR_RootConstrainSelectedInstOperands,
     /*  846323 */     // GIR_Coverage, 23880,
     /*  846323 */     GIR_EraseRootFromParent_Done,
     /*  846324 */   // Label 12996: @846324
     /*  846324 */   GIM_Try, /*On fail goto*//*Label 12997*/ GIMT_Encode4(846399), // Rule ID 23881 //
     /*  846329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  846332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  846340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  846343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  846346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  846364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846375 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11478:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  846375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1),
     /*  846378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  846394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846397 */     GIR_RootConstrainSelectedInstOperands,
     /*  846398 */     // GIR_Coverage, 23881,
     /*  846398 */     GIR_EraseRootFromParent_Done,
     /*  846399 */   // Label 12997: @846399
     /*  846399 */   GIM_Try, /*On fail goto*//*Label 12998*/ GIMT_Encode4(846474), // Rule ID 23884 //
     /*  846404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  846415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  846418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  846421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846450 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846472 */     GIR_RootConstrainSelectedInstOperands,
     /*  846473 */     // GIR_Coverage, 23884,
     /*  846473 */     GIR_EraseRootFromParent_Done,
     /*  846474 */   // Label 12998: @846474
     /*  846474 */   GIM_Try, /*On fail goto*//*Label 12999*/ GIMT_Encode4(846549), // Rule ID 23885 //
     /*  846479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  846490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  846493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  846496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846525 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846547 */     GIR_RootConstrainSelectedInstOperands,
     /*  846548 */     // GIR_Coverage, 23885,
     /*  846548 */     GIR_EraseRootFromParent_Done,
     /*  846549 */   // Label 12999: @846549
     /*  846549 */   GIM_Try, /*On fail goto*//*Label 13000*/ GIMT_Encode4(846624), // Rule ID 23888 //
     /*  846554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  846565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  846568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  846571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  846603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846622 */     GIR_RootConstrainSelectedInstOperands,
     /*  846623 */     // GIR_Coverage, 23888,
     /*  846623 */     GIR_EraseRootFromParent_Done,
     /*  846624 */   // Label 13000: @846624
     /*  846624 */   GIM_Try, /*On fail goto*//*Label 13001*/ GIMT_Encode4(846699), // Rule ID 23889 //
     /*  846629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  846640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  846643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  846646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  846664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846675 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  846678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846697 */     GIR_RootConstrainSelectedInstOperands,
     /*  846698 */     // GIR_Coverage, 23889,
     /*  846698 */     GIR_EraseRootFromParent_Done,
     /*  846699 */   // Label 13001: @846699
     /*  846699 */   GIM_Try, /*On fail goto*//*Label 13002*/ GIMT_Encode4(846774), // Rule ID 23892 //
     /*  846704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  846715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  846718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  846721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846750 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  846750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  846753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846772 */     GIR_RootConstrainSelectedInstOperands,
     /*  846773 */     // GIR_Coverage, 23892,
     /*  846773 */     GIR_EraseRootFromParent_Done,
     /*  846774 */   // Label 13002: @846774
     /*  846774 */   GIM_Try, /*On fail goto*//*Label 13003*/ GIMT_Encode4(846849), // Rule ID 23893 //
     /*  846779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  846790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  846793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  846796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  846814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846825 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  846825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  846828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  846844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846847 */     GIR_RootConstrainSelectedInstOperands,
     /*  846848 */     // GIR_Coverage, 23893,
     /*  846848 */     GIR_EraseRootFromParent_Done,
     /*  846849 */   // Label 13003: @846849
     /*  846849 */   GIM_Try, /*On fail goto*//*Label 13004*/ GIMT_Encode4(846924), // Rule ID 23896 //
     /*  846854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  846857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  846865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  846868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  846871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  846874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  846877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  846900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846922 */     GIR_RootConstrainSelectedInstOperands,
     /*  846923 */     // GIR_Coverage, 23896,
     /*  846923 */     GIR_EraseRootFromParent_Done,
     /*  846924 */   // Label 13004: @846924
     /*  846924 */   GIM_Try, /*On fail goto*//*Label 13005*/ GIMT_Encode4(846999), // Rule ID 23897 //
     /*  846929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  846932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  846937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  846940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  846943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  846946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  846949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  846952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  846964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  846968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  846975 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  846975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  846978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  846980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  846982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  846984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  846986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  846991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  846994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  846997 */     GIR_RootConstrainSelectedInstOperands,
     /*  846998 */     // GIR_Coverage, 23897,
     /*  846998 */     GIR_EraseRootFromParent_Done,
     /*  846999 */   // Label 13005: @846999
     /*  846999 */   GIM_Try, /*On fail goto*//*Label 13006*/ GIMT_Encode4(847074), // Rule ID 23900 //
     /*  847004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847072 */     GIR_RootConstrainSelectedInstOperands,
     /*  847073 */     // GIR_Coverage, 23900,
     /*  847073 */     GIR_EraseRootFromParent_Done,
     /*  847074 */   // Label 13006: @847074
     /*  847074 */   GIM_Try, /*On fail goto*//*Label 13007*/ GIMT_Encode4(847149), // Rule ID 23901 //
     /*  847079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  847090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  847093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  847096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847125 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847147 */     GIR_RootConstrainSelectedInstOperands,
     /*  847148 */     // GIR_Coverage, 23901,
     /*  847148 */     GIR_EraseRootFromParent_Done,
     /*  847149 */   // Label 13007: @847149
     /*  847149 */   GIM_Try, /*On fail goto*//*Label 13008*/ GIMT_Encode4(847224), // Rule ID 23904 //
     /*  847154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  847200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847222 */     GIR_RootConstrainSelectedInstOperands,
     /*  847223 */     // GIR_Coverage, 23904,
     /*  847223 */     GIR_EraseRootFromParent_Done,
     /*  847224 */   // Label 13008: @847224
     /*  847224 */   GIM_Try, /*On fail goto*//*Label 13009*/ GIMT_Encode4(847299), // Rule ID 23905 //
     /*  847229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  847240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  847243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  847246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847275 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  847275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  847294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847297 */     GIR_RootConstrainSelectedInstOperands,
     /*  847298 */     // GIR_Coverage, 23905,
     /*  847298 */     GIR_EraseRootFromParent_Done,
     /*  847299 */   // Label 13009: @847299
     /*  847299 */   GIM_Try, /*On fail goto*//*Label 13010*/ GIMT_Encode4(847374), // Rule ID 23908 //
     /*  847304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847372 */     GIR_RootConstrainSelectedInstOperands,
     /*  847373 */     // GIR_Coverage, 23908,
     /*  847373 */     GIR_EraseRootFromParent_Done,
     /*  847374 */   // Label 13010: @847374
     /*  847374 */   GIM_Try, /*On fail goto*//*Label 13011*/ GIMT_Encode4(847449), // Rule ID 23909 //
     /*  847379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  847390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  847393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  847396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847447 */     GIR_RootConstrainSelectedInstOperands,
     /*  847448 */     // GIR_Coverage, 23909,
     /*  847448 */     GIR_EraseRootFromParent_Done,
     /*  847449 */   // Label 13011: @847449
     /*  847449 */   GIM_Try, /*On fail goto*//*Label 13012*/ GIMT_Encode4(847524), // Rule ID 23912 //
     /*  847454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  847465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  847468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  847471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847522 */     GIR_RootConstrainSelectedInstOperands,
     /*  847523 */     // GIR_Coverage, 23912,
     /*  847523 */     GIR_EraseRootFromParent_Done,
     /*  847524 */   // Label 13012: @847524
     /*  847524 */   GIM_Try, /*On fail goto*//*Label 13013*/ GIMT_Encode4(847599), // Rule ID 23913 //
     /*  847529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  847540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  847543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  847546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847575 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847597 */     GIR_RootConstrainSelectedInstOperands,
     /*  847598 */     // GIR_Coverage, 23913,
     /*  847598 */     GIR_EraseRootFromParent_Done,
     /*  847599 */   // Label 13013: @847599
     /*  847599 */   GIM_Try, /*On fail goto*//*Label 13014*/ GIMT_Encode4(847674), // Rule ID 23916 //
     /*  847604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  847607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  847615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  847618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  847621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847650 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  847650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847672 */     GIR_RootConstrainSelectedInstOperands,
     /*  847673 */     // GIR_Coverage, 23916,
     /*  847673 */     GIR_EraseRootFromParent_Done,
     /*  847674 */   // Label 13014: @847674
     /*  847674 */   GIM_Try, /*On fail goto*//*Label 13015*/ GIMT_Encode4(847749), // Rule ID 23917 //
     /*  847679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  847682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  847690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  847693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  847696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  847714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847725 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  847725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  847728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  847744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847747 */     GIR_RootConstrainSelectedInstOperands,
     /*  847748 */     // GIR_Coverage, 23917,
     /*  847748 */     GIR_EraseRootFromParent_Done,
     /*  847749 */   // Label 13015: @847749
     /*  847749 */   GIM_Try, /*On fail goto*//*Label 13016*/ GIMT_Encode4(847824), // Rule ID 23920 //
     /*  847754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  847757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  847765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  847768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  847771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  847800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847822 */     GIR_RootConstrainSelectedInstOperands,
     /*  847823 */     // GIR_Coverage, 23920,
     /*  847823 */     GIR_EraseRootFromParent_Done,
     /*  847824 */   // Label 13016: @847824
     /*  847824 */   GIM_Try, /*On fail goto*//*Label 13017*/ GIMT_Encode4(847899), // Rule ID 23921 //
     /*  847829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  847832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  847840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  847843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  847846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  847852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  847864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847875 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11478:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  847875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2),
     /*  847878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847897 */     GIR_RootConstrainSelectedInstOperands,
     /*  847898 */     // GIR_Coverage, 23921,
     /*  847898 */     GIR_EraseRootFromParent_Done,
     /*  847899 */   // Label 13017: @847899
     /*  847899 */   GIM_Try, /*On fail goto*//*Label 13018*/ GIMT_Encode4(847974), // Rule ID 23924 //
     /*  847904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  847907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  847915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  847918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  847921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  847924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  847927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  847939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  847943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  847950 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  847950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  847953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  847955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  847957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  847959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  847961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  847966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  847969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  847972 */     GIR_RootConstrainSelectedInstOperands,
     /*  847973 */     // GIR_Coverage, 23924,
     /*  847973 */     GIR_EraseRootFromParent_Done,
     /*  847974 */   // Label 13018: @847974
     /*  847974 */   GIM_Try, /*On fail goto*//*Label 13019*/ GIMT_Encode4(848049), // Rule ID 23925 //
     /*  847979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  847982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  847987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  847990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  847993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  847996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  847999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  848014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848025 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11478:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4),
     /*  848028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848047 */     GIR_RootConstrainSelectedInstOperands,
     /*  848048 */     // GIR_Coverage, 23925,
     /*  848048 */     GIR_EraseRootFromParent_Done,
     /*  848049 */   // Label 13019: @848049
     /*  848049 */   GIM_Try, /*On fail goto*//*Label 13020*/ GIMT_Encode4(848124), // Rule ID 23928 //
     /*  848054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  848057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848100 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  848100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848122 */     GIR_RootConstrainSelectedInstOperands,
     /*  848123 */     // GIR_Coverage, 23928,
     /*  848123 */     GIR_EraseRootFromParent_Done,
     /*  848124 */   // Label 13020: @848124
     /*  848124 */   GIM_Try, /*On fail goto*//*Label 13021*/ GIMT_Encode4(848199), // Rule ID 23929 //
     /*  848129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  848132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up),
     /*  848137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  848140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  848143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  848146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  848164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848175 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11478:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1UP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  848175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8),
     /*  848178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  848194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848197 */     GIR_RootConstrainSelectedInstOperands,
     /*  848198 */     // GIR_Coverage, 23929,
     /*  848198 */     GIR_EraseRootFromParent_Done,
     /*  848199 */   // Label 13021: @848199
     /*  848199 */   GIM_Try, /*On fail goto*//*Label 13022*/ GIMT_Encode4(848274), // Rule ID 23932 //
     /*  848204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848272 */     GIR_RootConstrainSelectedInstOperands,
     /*  848273 */     // GIR_Coverage, 23932,
     /*  848273 */     GIR_EraseRootFromParent_Done,
     /*  848274 */   // Label 13022: @848274
     /*  848274 */   GIM_Try, /*On fail goto*//*Label 13023*/ GIMT_Encode4(848349), // Rule ID 23933 //
     /*  848279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  848290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  848293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  848296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848325 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8),
     /*  848328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848347 */     GIR_RootConstrainSelectedInstOperands,
     /*  848348 */     // GIR_Coverage, 23933,
     /*  848348 */     GIR_EraseRootFromParent_Done,
     /*  848349 */   // Label 13023: @848349
     /*  848349 */   GIM_Try, /*On fail goto*//*Label 13024*/ GIMT_Encode4(848424), // Rule ID 23936 //
     /*  848354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848400 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848422 */     GIR_RootConstrainSelectedInstOperands,
     /*  848423 */     // GIR_Coverage, 23936,
     /*  848423 */     GIR_EraseRootFromParent_Done,
     /*  848424 */   // Label 13024: @848424
     /*  848424 */   GIM_Try, /*On fail goto*//*Label 13025*/ GIMT_Encode4(848499), // Rule ID 23937 //
     /*  848429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  848440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  848443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  848446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848475 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848497 */     GIR_RootConstrainSelectedInstOperands,
     /*  848498 */     // GIR_Coverage, 23937,
     /*  848498 */     GIR_EraseRootFromParent_Done,
     /*  848499 */   // Label 13025: @848499
     /*  848499 */   GIM_Try, /*On fail goto*//*Label 13026*/ GIMT_Encode4(848574), // Rule ID 23940 //
     /*  848504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  848515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  848518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  848521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  848550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  848553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848572 */     GIR_RootConstrainSelectedInstOperands,
     /*  848573 */     // GIR_Coverage, 23940,
     /*  848573 */     GIR_EraseRootFromParent_Done,
     /*  848574 */   // Label 13026: @848574
     /*  848574 */   GIM_Try, /*On fail goto*//*Label 13027*/ GIMT_Encode4(848649), // Rule ID 23941 //
     /*  848579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  848590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  848593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  848596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848625 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  848625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  848628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  848644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848647 */     GIR_RootConstrainSelectedInstOperands,
     /*  848648 */     // GIR_Coverage, 23941,
     /*  848648 */     GIR_EraseRootFromParent_Done,
     /*  848649 */   // Label 13027: @848649
     /*  848649 */   GIM_Try, /*On fail goto*//*Label 13028*/ GIMT_Encode4(848724), // Rule ID 23944 //
     /*  848654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  848665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  848668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  848671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848700 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848722 */     GIR_RootConstrainSelectedInstOperands,
     /*  848723 */     // GIR_Coverage, 23944,
     /*  848723 */     GIR_EraseRootFromParent_Done,
     /*  848724 */   // Label 13028: @848724
     /*  848724 */   GIM_Try, /*On fail goto*//*Label 13029*/ GIMT_Encode4(848799), // Rule ID 23945 //
     /*  848729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  848740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  848743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  848746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848775 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4),
     /*  848778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848797 */     GIR_RootConstrainSelectedInstOperands,
     /*  848798 */     // GIR_Coverage, 23945,
     /*  848798 */     GIR_EraseRootFromParent_Done,
     /*  848799 */   // Label 13029: @848799
     /*  848799 */   GIM_Try, /*On fail goto*//*Label 13030*/ GIMT_Encode4(848874), // Rule ID 23948 //
     /*  848804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  848815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  848818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  848821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  848850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  848853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848872 */     GIR_RootConstrainSelectedInstOperands,
     /*  848873 */     // GIR_Coverage, 23948,
     /*  848873 */     GIR_EraseRootFromParent_Done,
     /*  848874 */   // Label 13030: @848874
     /*  848874 */   GIM_Try, /*On fail goto*//*Label 13031*/ GIMT_Encode4(848949), // Rule ID 23949 //
     /*  848879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  848882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  848890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  848893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  848896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  848899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  848902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  848925 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  848925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  848928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  848930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  848932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  848934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  848936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  848941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  848944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  848947 */     GIR_RootConstrainSelectedInstOperands,
     /*  848948 */     // GIR_Coverage, 23949,
     /*  848948 */     GIR_EraseRootFromParent_Done,
     /*  848949 */   // Label 13031: @848949
     /*  848949 */   GIM_Try, /*On fail goto*//*Label 13032*/ GIMT_Encode4(849024), // Rule ID 23952 //
     /*  848954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  848957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  848962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  848965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  848968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  848971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  848974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  848977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  848989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  848993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849022 */     GIR_RootConstrainSelectedInstOperands,
     /*  849023 */     // GIR_Coverage, 23952,
     /*  849023 */     GIR_EraseRootFromParent_Done,
     /*  849024 */   // Label 13032: @849024
     /*  849024 */   GIM_Try, /*On fail goto*//*Label 13033*/ GIMT_Encode4(849099), // Rule ID 23953 //
     /*  849029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  849040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  849043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  849046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849075 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  849075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2),
     /*  849078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849097 */     GIR_RootConstrainSelectedInstOperands,
     /*  849098 */     // GIR_Coverage, 23953,
     /*  849098 */     GIR_EraseRootFromParent_Done,
     /*  849099 */   // Label 13033: @849099
     /*  849099 */   GIM_Try, /*On fail goto*//*Label 13034*/ GIMT_Encode4(849174), // Rule ID 23956 //
     /*  849104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849150 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849172 */     GIR_RootConstrainSelectedInstOperands,
     /*  849173 */     // GIR_Coverage, 23956,
     /*  849173 */     GIR_EraseRootFromParent_Done,
     /*  849174 */   // Label 13034: @849174
     /*  849174 */   GIM_Try, /*On fail goto*//*Label 13035*/ GIMT_Encode4(849249), // Rule ID 23957 //
     /*  849179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  849190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  849193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  849196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849225 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11476:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849247 */     GIR_RootConstrainSelectedInstOperands,
     /*  849248 */     // GIR_Coverage, 23957,
     /*  849248 */     GIR_EraseRootFromParent_Done,
     /*  849249 */   // Label 13035: @849249
     /*  849249 */   GIM_Try, /*On fail goto*//*Label 13036*/ GIMT_Encode4(849324), // Rule ID 23960 //
     /*  849254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  849300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849322 */     GIR_RootConstrainSelectedInstOperands,
     /*  849323 */     // GIR_Coverage, 23960,
     /*  849323 */     GIR_EraseRootFromParent_Done,
     /*  849324 */   // Label 13036: @849324
     /*  849324 */   GIM_Try, /*On fail goto*//*Label 13037*/ GIMT_Encode4(849399), // Rule ID 23961 //
     /*  849329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  849340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  849343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  849346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849375 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11476:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  849375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  849394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849397 */     GIR_RootConstrainSelectedInstOperands,
     /*  849398 */     // GIR_Coverage, 23961,
     /*  849398 */     GIR_EraseRootFromParent_Done,
     /*  849399 */   // Label 13037: @849399
     /*  849399 */   GIM_Try, /*On fail goto*//*Label 13038*/ GIMT_Encode4(849474), // Rule ID 23964 //
     /*  849404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  849415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  849418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  849421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849450 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  849450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849472 */     GIR_RootConstrainSelectedInstOperands,
     /*  849473 */     // GIR_Coverage, 23964,
     /*  849473 */     GIR_EraseRootFromParent_Done,
     /*  849474 */   // Label 13038: @849474
     /*  849474 */   GIM_Try, /*On fail goto*//*Label 13039*/ GIMT_Encode4(849549), // Rule ID 23965 //
     /*  849479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  849490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  849493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  849496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11476:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  849525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  849544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849547 */     GIR_RootConstrainSelectedInstOperands,
     /*  849548 */     // GIR_Coverage, 23965,
     /*  849548 */     GIR_EraseRootFromParent_Done,
     /*  849549 */   // Label 13039: @849549
     /*  849549 */   GIM_Try, /*On fail goto*//*Label 13040*/ GIMT_Encode4(849624), // Rule ID 23968 //
     /*  849554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  849557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  849565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  849568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  849571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  849600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849622 */     GIR_RootConstrainSelectedInstOperands,
     /*  849623 */     // GIR_Coverage, 23968,
     /*  849623 */     GIR_EraseRootFromParent_Done,
     /*  849624 */   // Label 13040: @849624
     /*  849624 */   GIM_Try, /*On fail goto*//*Label 13041*/ GIMT_Encode4(849699), // Rule ID 23969 //
     /*  849629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  849632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  849640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  849643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  849646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  849664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849675 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11476:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  849675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1),
     /*  849678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  849694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849697 */     GIR_RootConstrainSelectedInstOperands,
     /*  849698 */     // GIR_Coverage, 23969,
     /*  849698 */     GIR_EraseRootFromParent_Done,
     /*  849699 */   // Label 13041: @849699
     /*  849699 */   GIM_Try, /*On fail goto*//*Label 13042*/ GIMT_Encode4(849774), // Rule ID 23972 //
     /*  849704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  849715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  849718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  849721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849750 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  849753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849772 */     GIR_RootConstrainSelectedInstOperands,
     /*  849773 */     // GIR_Coverage, 23972,
     /*  849773 */     GIR_EraseRootFromParent_Done,
     /*  849774 */   // Label 13042: @849774
     /*  849774 */   GIM_Try, /*On fail goto*//*Label 13043*/ GIMT_Encode4(849849), // Rule ID 23973 //
     /*  849779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  849790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  849793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  849796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  849814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849825 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  849828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849847 */     GIR_RootConstrainSelectedInstOperands,
     /*  849848 */     // GIR_Coverage, 23973,
     /*  849848 */     GIR_EraseRootFromParent_Done,
     /*  849849 */   // Label 13043: @849849
     /*  849849 */   GIM_Try, /*On fail goto*//*Label 13044*/ GIMT_Encode4(849924), // Rule ID 23976 //
     /*  849854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  849857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  849865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  849868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  849871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  849874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  849877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849900 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  849900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  849903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849922 */     GIR_RootConstrainSelectedInstOperands,
     /*  849923 */     // GIR_Coverage, 23976,
     /*  849923 */     GIR_EraseRootFromParent_Done,
     /*  849924 */   // Label 13044: @849924
     /*  849924 */   GIM_Try, /*On fail goto*//*Label 13045*/ GIMT_Encode4(849999), // Rule ID 23977 //
     /*  849929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  849932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  849937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  849940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  849943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  849946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  849949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  849952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  849964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  849968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  849975 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  849975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  849978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  849980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  849982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  849984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  849986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  849991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  849994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  849997 */     GIR_RootConstrainSelectedInstOperands,
     /*  849998 */     // GIR_Coverage, 23977,
     /*  849998 */     GIR_EraseRootFromParent_Done,
     /*  849999 */   // Label 13045: @849999
     /*  849999 */   GIM_Try, /*On fail goto*//*Label 13046*/ GIMT_Encode4(850074), // Rule ID 23980 //
     /*  850004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850050 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  850050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850072 */     GIR_RootConstrainSelectedInstOperands,
     /*  850073 */     // GIR_Coverage, 23980,
     /*  850073 */     GIR_EraseRootFromParent_Done,
     /*  850074 */   // Label 13046: @850074
     /*  850074 */   GIM_Try, /*On fail goto*//*Label 13047*/ GIMT_Encode4(850149), // Rule ID 23981 //
     /*  850079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  850090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  850093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  850096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850125 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  850125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  850144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850147 */     GIR_RootConstrainSelectedInstOperands,
     /*  850148 */     // GIR_Coverage, 23981,
     /*  850148 */     GIR_EraseRootFromParent_Done,
     /*  850149 */   // Label 13047: @850149
     /*  850149 */   GIM_Try, /*On fail goto*//*Label 13048*/ GIMT_Encode4(850224), // Rule ID 23984 //
     /*  850154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850222 */     GIR_RootConstrainSelectedInstOperands,
     /*  850223 */     // GIR_Coverage, 23984,
     /*  850223 */     GIR_EraseRootFromParent_Done,
     /*  850224 */   // Label 13048: @850224
     /*  850224 */   GIM_Try, /*On fail goto*//*Label 13049*/ GIMT_Encode4(850299), // Rule ID 23985 //
     /*  850229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  850240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  850243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  850246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850275 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850297 */     GIR_RootConstrainSelectedInstOperands,
     /*  850298 */     // GIR_Coverage, 23985,
     /*  850298 */     GIR_EraseRootFromParent_Done,
     /*  850299 */   // Label 13049: @850299
     /*  850299 */   GIM_Try, /*On fail goto*//*Label 13050*/ GIMT_Encode4(850374), // Rule ID 23988 //
     /*  850304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850350 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850372 */     GIR_RootConstrainSelectedInstOperands,
     /*  850373 */     // GIR_Coverage, 23988,
     /*  850373 */     GIR_EraseRootFromParent_Done,
     /*  850374 */   // Label 13050: @850374
     /*  850374 */   GIM_Try, /*On fail goto*//*Label 13051*/ GIMT_Encode4(850449), // Rule ID 23989 //
     /*  850379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  850390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  850393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  850396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850425 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850447 */     GIR_RootConstrainSelectedInstOperands,
     /*  850448 */     // GIR_Coverage, 23989,
     /*  850448 */     GIR_EraseRootFromParent_Done,
     /*  850449 */   // Label 13051: @850449
     /*  850449 */   GIM_Try, /*On fail goto*//*Label 13052*/ GIMT_Encode4(850524), // Rule ID 23992 //
     /*  850454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  850465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  850468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  850471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  850500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850522 */     GIR_RootConstrainSelectedInstOperands,
     /*  850523 */     // GIR_Coverage, 23992,
     /*  850523 */     GIR_EraseRootFromParent_Done,
     /*  850524 */   // Label 13052: @850524
     /*  850524 */   GIM_Try, /*On fail goto*//*Label 13053*/ GIMT_Encode4(850599), // Rule ID 23993 //
     /*  850529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  850540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  850543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  850546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850575 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  850575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  850594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850597 */     GIR_RootConstrainSelectedInstOperands,
     /*  850598 */     // GIR_Coverage, 23993,
     /*  850598 */     GIR_EraseRootFromParent_Done,
     /*  850599 */   // Label 13053: @850599
     /*  850599 */   GIM_Try, /*On fail goto*//*Label 13054*/ GIMT_Encode4(850674), // Rule ID 23996 //
     /*  850604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  850615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  850618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  850621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850672 */     GIR_RootConstrainSelectedInstOperands,
     /*  850673 */     // GIR_Coverage, 23996,
     /*  850673 */     GIR_EraseRootFromParent_Done,
     /*  850674 */   // Label 13054: @850674
     /*  850674 */   GIM_Try, /*On fail goto*//*Label 13055*/ GIMT_Encode4(850749), // Rule ID 23997 //
     /*  850679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  850690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  850693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  850696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  850714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850725 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  850728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850747 */     GIR_RootConstrainSelectedInstOperands,
     /*  850748 */     // GIR_Coverage, 23997,
     /*  850748 */     GIR_EraseRootFromParent_Done,
     /*  850749 */   // Label 13055: @850749
     /*  850749 */   GIM_Try, /*On fail goto*//*Label 13056*/ GIMT_Encode4(850824), // Rule ID 24000 //
     /*  850754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  850765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  850768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  850771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850822 */     GIR_RootConstrainSelectedInstOperands,
     /*  850823 */     // GIR_Coverage, 24000,
     /*  850823 */     GIR_EraseRootFromParent_Done,
     /*  850824 */   // Label 13056: @850824
     /*  850824 */   GIM_Try, /*On fail goto*//*Label 13057*/ GIMT_Encode4(850899), // Rule ID 24001 //
     /*  850829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  850840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  850843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  850846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  850852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  850864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850875 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  850875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  850878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850897 */     GIR_RootConstrainSelectedInstOperands,
     /*  850898 */     // GIR_Coverage, 24001,
     /*  850898 */     GIR_EraseRootFromParent_Done,
     /*  850899 */   // Label 13057: @850899
     /*  850899 */   GIM_Try, /*On fail goto*//*Label 13058*/ GIMT_Encode4(850974), // Rule ID 24004 //
     /*  850904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  850907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  850915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  850918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  850921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  850924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  850927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  850939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  850943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  850950 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  850950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  850953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  850955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  850957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  850959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  850961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  850966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  850969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  850972 */     GIR_RootConstrainSelectedInstOperands,
     /*  850973 */     // GIR_Coverage, 24004,
     /*  850973 */     GIR_EraseRootFromParent_Done,
     /*  850974 */   // Label 13058: @850974
     /*  850974 */   GIM_Try, /*On fail goto*//*Label 13059*/ GIMT_Encode4(851049), // Rule ID 24005 //
     /*  850979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  850982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  850987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  850990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  850993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  850996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  850999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851047 */     GIR_RootConstrainSelectedInstOperands,
     /*  851048 */     // GIR_Coverage, 24005,
     /*  851048 */     GIR_EraseRootFromParent_Done,
     /*  851049 */   // Label 13059: @851049
     /*  851049 */   GIM_Try, /*On fail goto*//*Label 13060*/ GIMT_Encode4(851124), // Rule ID 24008 //
     /*  851054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851100 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851122 */     GIR_RootConstrainSelectedInstOperands,
     /*  851123 */     // GIR_Coverage, 24008,
     /*  851123 */     GIR_EraseRootFromParent_Done,
     /*  851124 */   // Label 13060: @851124
     /*  851124 */   GIM_Try, /*On fail goto*//*Label 13061*/ GIMT_Encode4(851199), // Rule ID 24009 //
     /*  851129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  851140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  851143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  851146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  851164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851175 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11476:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2),
     /*  851178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851197 */     GIR_RootConstrainSelectedInstOperands,
     /*  851198 */     // GIR_Coverage, 24009,
     /*  851198 */     GIR_EraseRootFromParent_Done,
     /*  851199 */   // Label 13061: @851199
     /*  851199 */   GIM_Try, /*On fail goto*//*Label 13062*/ GIMT_Encode4(851274), // Rule ID 24012 //
     /*  851204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851250 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851272 */     GIR_RootConstrainSelectedInstOperands,
     /*  851273 */     // GIR_Coverage, 24012,
     /*  851273 */     GIR_EraseRootFromParent_Done,
     /*  851274 */   // Label 13062: @851274
     /*  851274 */   GIM_Try, /*On fail goto*//*Label 13063*/ GIMT_Encode4(851349), // Rule ID 24013 //
     /*  851279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  851290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  851293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  851296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  851314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851325 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11476:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4),
     /*  851328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851347 */     GIR_RootConstrainSelectedInstOperands,
     /*  851348 */     // GIR_Coverage, 24013,
     /*  851348 */     GIR_EraseRootFromParent_Done,
     /*  851349 */   // Label 13063: @851349
     /*  851349 */   GIM_Try, /*On fail goto*//*Label 13064*/ GIMT_Encode4(851424), // Rule ID 24016 //
     /*  851354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  851357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  851374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  851400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851422 */     GIR_RootConstrainSelectedInstOperands,
     /*  851423 */     // GIR_Coverage, 24016,
     /*  851423 */     GIR_EraseRootFromParent_Done,
     /*  851424 */   // Label 13064: @851424
     /*  851424 */   GIM_Try, /*On fail goto*//*Label 13065*/ GIMT_Encode4(851499), // Rule ID 24017 //
     /*  851429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  851432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down),
     /*  851437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  851440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  851443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  851446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  851464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  851468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851475 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11476:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSLIDE1DOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  851475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8),
     /*  851478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  851494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851497 */     GIR_RootConstrainSelectedInstOperands,
     /*  851498 */     // GIR_Coverage, 24017,
     /*  851498 */     GIR_EraseRootFromParent_Done,
     /*  851499 */   // Label 13065: @851499
     /*  851499 */   GIM_Try, /*On fail goto*//*Label 13066*/ GIMT_Encode4(851574), // Rule ID 24260 //
     /*  851504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  851507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  851515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  851518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  851521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  851524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851550 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  851553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851572 */     GIR_RootConstrainSelectedInstOperands,
     /*  851573 */     // GIR_Coverage, 24260,
     /*  851573 */     GIR_EraseRootFromParent_Done,
     /*  851574 */   // Label 13066: @851574
     /*  851574 */   GIM_Try, /*On fail goto*//*Label 13067*/ GIMT_Encode4(851649), // Rule ID 24261 //
     /*  851579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  851582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  851590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  851593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  851596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  851599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851625 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4),
     /*  851628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851647 */     GIR_RootConstrainSelectedInstOperands,
     /*  851648 */     // GIR_Coverage, 24261,
     /*  851648 */     GIR_EraseRootFromParent_Done,
     /*  851649 */   // Label 13067: @851649
     /*  851649 */   GIM_Try, /*On fail goto*//*Label 13068*/ GIMT_Encode4(851724), // Rule ID 24264 //
     /*  851654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  851657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  851665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  851668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  851671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  851674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  851700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  851703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851722 */     GIR_RootConstrainSelectedInstOperands,
     /*  851723 */     // GIR_Coverage, 24264,
     /*  851723 */     GIR_EraseRootFromParent_Done,
     /*  851724 */   // Label 13068: @851724
     /*  851724 */   GIM_Try, /*On fail goto*//*Label 13069*/ GIMT_Encode4(851799), // Rule ID 24265 //
     /*  851729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  851732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  851740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  851743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  851746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  851749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851775 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  851775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2),
     /*  851778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  851794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851797 */     GIR_RootConstrainSelectedInstOperands,
     /*  851798 */     // GIR_Coverage, 24265,
     /*  851798 */     GIR_EraseRootFromParent_Done,
     /*  851799 */   // Label 13069: @851799
     /*  851799 */   GIM_Try, /*On fail goto*//*Label 13070*/ GIMT_Encode4(851874), // Rule ID 24268 //
     /*  851804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  851807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  851818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  851843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851850 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  851850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  851853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851872 */     GIR_RootConstrainSelectedInstOperands,
     /*  851873 */     // GIR_Coverage, 24268,
     /*  851873 */     GIR_EraseRootFromParent_Done,
     /*  851874 */   // Label 13070: @851874
     /*  851874 */   GIM_Try, /*On fail goto*//*Label 13071*/ GIMT_Encode4(851949), // Rule ID 24269 //
     /*  851879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  851882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  851890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  851893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  851896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  851899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  851902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  851918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  851925 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  851925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2),
     /*  851928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  851930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  851932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  851934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  851936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  851941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  851944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  851947 */     GIR_RootConstrainSelectedInstOperands,
     /*  851948 */     // GIR_Coverage, 24269,
     /*  851948 */     GIR_EraseRootFromParent_Done,
     /*  851949 */   // Label 13071: @851949
     /*  851949 */   GIM_Try, /*On fail goto*//*Label 13072*/ GIMT_Encode4(852024), // Rule ID 24272 //
     /*  851954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  851957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  851962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  851965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  851968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  851971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  851974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  851977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  851989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  851993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852022 */     GIR_RootConstrainSelectedInstOperands,
     /*  852023 */     // GIR_Coverage, 24272,
     /*  852023 */     GIR_EraseRootFromParent_Done,
     /*  852024 */   // Label 13072: @852024
     /*  852024 */   GIM_Try, /*On fail goto*//*Label 13073*/ GIMT_Encode4(852099), // Rule ID 24273 //
     /*  852029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  852040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  852043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  852046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852075 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11204:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1),
     /*  852078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852097 */     GIR_RootConstrainSelectedInstOperands,
     /*  852098 */     // GIR_Coverage, 24273,
     /*  852098 */     GIR_EraseRootFromParent_Done,
     /*  852099 */   // Label 13073: @852099
     /*  852099 */   GIM_Try, /*On fail goto*//*Label 13074*/ GIMT_Encode4(852174), // Rule ID 24276 //
     /*  852104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852150 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852172 */     GIR_RootConstrainSelectedInstOperands,
     /*  852173 */     // GIR_Coverage, 24276,
     /*  852173 */     GIR_EraseRootFromParent_Done,
     /*  852174 */   // Label 13074: @852174
     /*  852174 */   GIM_Try, /*On fail goto*//*Label 13075*/ GIMT_Encode4(852249), // Rule ID 24277 //
     /*  852179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  852190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  852193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  852196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852225 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11204:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1),
     /*  852228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852247 */     GIR_RootConstrainSelectedInstOperands,
     /*  852248 */     // GIR_Coverage, 24277,
     /*  852248 */     GIR_EraseRootFromParent_Done,
     /*  852249 */   // Label 13075: @852249
     /*  852249 */   GIM_Try, /*On fail goto*//*Label 13076*/ GIMT_Encode4(852324), // Rule ID 24280 //
     /*  852254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  852257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852300 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  852300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852322 */     GIR_RootConstrainSelectedInstOperands,
     /*  852323 */     // GIR_Coverage, 24280,
     /*  852323 */     GIR_EraseRootFromParent_Done,
     /*  852324 */   // Label 13076: @852324
     /*  852324 */   GIM_Try, /*On fail goto*//*Label 13077*/ GIMT_Encode4(852399), // Rule ID 24281 //
     /*  852329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  852332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  852340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  852343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  852346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  852349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  852364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  852368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852375 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11204:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  852375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1),
     /*  852378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  852394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852397 */     GIR_RootConstrainSelectedInstOperands,
     /*  852398 */     // GIR_Coverage, 24281,
     /*  852398 */     GIR_EraseRootFromParent_Done,
     /*  852399 */   // Label 13077: @852399
     /*  852399 */   GIM_Try, /*On fail goto*//*Label 13078*/ GIMT_Encode4(852474), // Rule ID 24284 //
     /*  852404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  852415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  852418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  852421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  852453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852472 */     GIR_RootConstrainSelectedInstOperands,
     /*  852473 */     // GIR_Coverage, 24284,
     /*  852473 */     GIR_EraseRootFromParent_Done,
     /*  852474 */   // Label 13078: @852474
     /*  852474 */   GIM_Try, /*On fail goto*//*Label 13079*/ GIMT_Encode4(852549), // Rule ID 24285 //
     /*  852479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  852490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  852493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  852496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852525 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2),
     /*  852528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852547 */     GIR_RootConstrainSelectedInstOperands,
     /*  852548 */     // GIR_Coverage, 24285,
     /*  852548 */     GIR_EraseRootFromParent_Done,
     /*  852549 */   // Label 13079: @852549
     /*  852549 */   GIM_Try, /*On fail goto*//*Label 13080*/ GIMT_Encode4(852624), // Rule ID 24288 //
     /*  852554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  852565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  852568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  852571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852600 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  852603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852622 */     GIR_RootConstrainSelectedInstOperands,
     /*  852623 */     // GIR_Coverage, 24288,
     /*  852623 */     GIR_EraseRootFromParent_Done,
     /*  852624 */   // Label 13080: @852624
     /*  852624 */   GIM_Try, /*On fail goto*//*Label 13081*/ GIMT_Encode4(852699), // Rule ID 24289 //
     /*  852629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  852640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  852643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  852646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  852664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852675 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4),
     /*  852678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852697 */     GIR_RootConstrainSelectedInstOperands,
     /*  852698 */     // GIR_Coverage, 24289,
     /*  852698 */     GIR_EraseRootFromParent_Done,
     /*  852699 */   // Label 13081: @852699
     /*  852699 */   GIM_Try, /*On fail goto*//*Label 13082*/ GIMT_Encode4(852774), // Rule ID 24292 //
     /*  852704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  852707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  852715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  852718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  852721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852750 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  852750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  852753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852772 */     GIR_RootConstrainSelectedInstOperands,
     /*  852773 */     // GIR_Coverage, 24292,
     /*  852773 */     GIR_EraseRootFromParent_Done,
     /*  852774 */   // Label 13082: @852774
     /*  852774 */   GIM_Try, /*On fail goto*//*Label 13083*/ GIMT_Encode4(852849), // Rule ID 24293 //
     /*  852779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  852782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  852790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  852793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  852796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  852799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  852814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  852818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852825 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  852825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8),
     /*  852828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  852844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852847 */     GIR_RootConstrainSelectedInstOperands,
     /*  852848 */     // GIR_Coverage, 24293,
     /*  852848 */     GIR_EraseRootFromParent_Done,
     /*  852849 */   // Label 13083: @852849
     /*  852849 */   GIM_Try, /*On fail goto*//*Label 13084*/ GIMT_Encode4(852924), // Rule ID 24296 //
     /*  852854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  852857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  852865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  852868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  852871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  852877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852900 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  852900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  852903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852922 */     GIR_RootConstrainSelectedInstOperands,
     /*  852923 */     // GIR_Coverage, 24296,
     /*  852923 */     GIR_EraseRootFromParent_Done,
     /*  852924 */   // Label 13084: @852924
     /*  852924 */   GIM_Try, /*On fail goto*//*Label 13085*/ GIMT_Encode4(852999), // Rule ID 24297 //
     /*  852929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  852932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  852937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  852940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  852943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  852946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  852949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  852952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  852964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  852968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  852975 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  852975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2),
     /*  852978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  852980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  852982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  852984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  852986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  852991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  852994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  852997 */     GIR_RootConstrainSelectedInstOperands,
     /*  852998 */     // GIR_Coverage, 24297,
     /*  852998 */     GIR_EraseRootFromParent_Done,
     /*  852999 */   // Label 13085: @852999
     /*  852999 */   GIM_Try, /*On fail goto*//*Label 13086*/ GIMT_Encode4(853074), // Rule ID 24300 //
     /*  853004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853050 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853072 */     GIR_RootConstrainSelectedInstOperands,
     /*  853073 */     // GIR_Coverage, 24300,
     /*  853073 */     GIR_EraseRootFromParent_Done,
     /*  853074 */   // Label 13086: @853074
     /*  853074 */   GIM_Try, /*On fail goto*//*Label 13087*/ GIMT_Encode4(853149), // Rule ID 24301 //
     /*  853079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  853090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  853093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  853096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853125 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4),
     /*  853128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853147 */     GIR_RootConstrainSelectedInstOperands,
     /*  853148 */     // GIR_Coverage, 24301,
     /*  853148 */     GIR_EraseRootFromParent_Done,
     /*  853149 */   // Label 13087: @853149
     /*  853149 */   GIM_Try, /*On fail goto*//*Label 13088*/ GIMT_Encode4(853224), // Rule ID 24304 //
     /*  853154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  853157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853200 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  853200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853222 */     GIR_RootConstrainSelectedInstOperands,
     /*  853223 */     // GIR_Coverage, 24304,
     /*  853223 */     GIR_EraseRootFromParent_Done,
     /*  853224 */   // Label 13088: @853224
     /*  853224 */   GIM_Try, /*On fail goto*//*Label 13089*/ GIMT_Encode4(853299), // Rule ID 24305 //
     /*  853229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  853232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  853240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  853243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  853246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  853249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  853268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853275 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  853275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8),
     /*  853278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  853294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853297 */     GIR_RootConstrainSelectedInstOperands,
     /*  853298 */     // GIR_Coverage, 24305,
     /*  853298 */     GIR_EraseRootFromParent_Done,
     /*  853299 */   // Label 13089: @853299
     /*  853299 */   GIM_Try, /*On fail goto*//*Label 13090*/ GIMT_Encode4(853374), // Rule ID 24308 //
     /*  853304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853350 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853372 */     GIR_RootConstrainSelectedInstOperands,
     /*  853373 */     // GIR_Coverage, 24308,
     /*  853373 */     GIR_EraseRootFromParent_Done,
     /*  853374 */   // Label 13090: @853374
     /*  853374 */   GIM_Try, /*On fail goto*//*Label 13091*/ GIMT_Encode4(853449), // Rule ID 24309 //
     /*  853379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  853390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  853393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  853396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  853414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11204:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2),
     /*  853428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853447 */     GIR_RootConstrainSelectedInstOperands,
     /*  853448 */     // GIR_Coverage, 24309,
     /*  853448 */     GIR_EraseRootFromParent_Done,
     /*  853449 */   // Label 13091: @853449
     /*  853449 */   GIM_Try, /*On fail goto*//*Label 13092*/ GIMT_Encode4(853524), // Rule ID 24312 //
     /*  853454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  853465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  853468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  853471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853500 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  853503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853522 */     GIR_RootConstrainSelectedInstOperands,
     /*  853523 */     // GIR_Coverage, 24312,
     /*  853523 */     GIR_EraseRootFromParent_Done,
     /*  853524 */   // Label 13092: @853524
     /*  853524 */   GIM_Try, /*On fail goto*//*Label 13093*/ GIMT_Encode4(853599), // Rule ID 24313 //
     /*  853529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  853540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  853543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  853546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  853564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853575 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11204:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4),
     /*  853578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853597 */     GIR_RootConstrainSelectedInstOperands,
     /*  853598 */     // GIR_Coverage, 24313,
     /*  853598 */     GIR_EraseRootFromParent_Done,
     /*  853599 */   // Label 13093: @853599
     /*  853599 */   GIM_Try, /*On fail goto*//*Label 13094*/ GIMT_Encode4(853674), // Rule ID 24316 //
     /*  853604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  853607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  853615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  853618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  853621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853650 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  853650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  853653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853672 */     GIR_RootConstrainSelectedInstOperands,
     /*  853673 */     // GIR_Coverage, 24316,
     /*  853673 */     GIR_EraseRootFromParent_Done,
     /*  853674 */   // Label 13094: @853674
     /*  853674 */   GIM_Try, /*On fail goto*//*Label 13095*/ GIMT_Encode4(853749), // Rule ID 24317 //
     /*  853679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  853682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up),
     /*  853687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  853690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  853693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  853696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  853699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  853714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  853718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853725 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11204:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1UP_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  853725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8),
     /*  853728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  853744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853747 */     GIR_RootConstrainSelectedInstOperands,
     /*  853748 */     // GIR_Coverage, 24317,
     /*  853748 */     GIR_EraseRootFromParent_Done,
     /*  853749 */   // Label 13095: @853749
     /*  853749 */   GIM_Try, /*On fail goto*//*Label 13096*/ GIMT_Encode4(853824), // Rule ID 24320 //
     /*  853754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  853762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  853803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853822 */     GIR_RootConstrainSelectedInstOperands,
     /*  853823 */     // GIR_Coverage, 24320,
     /*  853823 */     GIR_EraseRootFromParent_Done,
     /*  853824 */   // Label 13096: @853824
     /*  853824 */   GIM_Try, /*On fail goto*//*Label 13097*/ GIMT_Encode4(853899), // Rule ID 24321 //
     /*  853829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  853837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  853840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  853843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  853846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  853852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853875 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  853875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4),
     /*  853878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853897 */     GIR_RootConstrainSelectedInstOperands,
     /*  853898 */     // GIR_Coverage, 24321,
     /*  853898 */     GIR_EraseRootFromParent_Done,
     /*  853899 */   // Label 13097: @853899
     /*  853899 */   GIM_Try, /*On fail goto*//*Label 13098*/ GIMT_Encode4(853974), // Rule ID 24324 //
     /*  853904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  853907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  853912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  853927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  853939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  853943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  853950 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  853950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  853953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  853955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  853957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  853959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  853961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  853966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  853969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  853972 */     GIR_RootConstrainSelectedInstOperands,
     /*  853973 */     // GIR_Coverage, 24324,
     /*  853973 */     GIR_EraseRootFromParent_Done,
     /*  853974 */   // Label 13098: @853974
     /*  853974 */   GIM_Try, /*On fail goto*//*Label 13099*/ GIMT_Encode4(854049), // Rule ID 24325 //
     /*  853979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  853982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  853987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  853990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  853993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  853996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  853999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854025 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2),
     /*  854028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854047 */     GIR_RootConstrainSelectedInstOperands,
     /*  854048 */     // GIR_Coverage, 24325,
     /*  854048 */     GIR_EraseRootFromParent_Done,
     /*  854049 */   // Label 13099: @854049
     /*  854049 */   GIM_Try, /*On fail goto*//*Label 13100*/ GIMT_Encode4(854124), // Rule ID 24328 //
     /*  854054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854100 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854122 */     GIR_RootConstrainSelectedInstOperands,
     /*  854123 */     // GIR_Coverage, 24328,
     /*  854123 */     GIR_EraseRootFromParent_Done,
     /*  854124 */   // Label 13100: @854124
     /*  854124 */   GIM_Try, /*On fail goto*//*Label 13101*/ GIMT_Encode4(854199), // Rule ID 24329 //
     /*  854129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  854140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  854143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  854146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854175 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2),
     /*  854178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854197 */     GIR_RootConstrainSelectedInstOperands,
     /*  854198 */     // GIR_Coverage, 24329,
     /*  854198 */     GIR_EraseRootFromParent_Done,
     /*  854199 */   // Label 13101: @854199
     /*  854199 */   GIM_Try, /*On fail goto*//*Label 13102*/ GIMT_Encode4(854274), // Rule ID 24332 //
     /*  854204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854250 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854272 */     GIR_RootConstrainSelectedInstOperands,
     /*  854273 */     // GIR_Coverage, 24332,
     /*  854273 */     GIR_EraseRootFromParent_Done,
     /*  854274 */   // Label 13102: @854274
     /*  854274 */   GIM_Try, /*On fail goto*//*Label 13103*/ GIMT_Encode4(854349), // Rule ID 24333 //
     /*  854279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  854290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  854293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  854296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854325 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11202:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1),
     /*  854328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854347 */     GIR_RootConstrainSelectedInstOperands,
     /*  854348 */     // GIR_Coverage, 24333,
     /*  854348 */     GIR_EraseRootFromParent_Done,
     /*  854349 */   // Label 13103: @854349
     /*  854349 */   GIM_Try, /*On fail goto*//*Label 13104*/ GIMT_Encode4(854424), // Rule ID 24336 //
     /*  854354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  854357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854400 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  854400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854422 */     GIR_RootConstrainSelectedInstOperands,
     /*  854423 */     // GIR_Coverage, 24336,
     /*  854423 */     GIR_EraseRootFromParent_Done,
     /*  854424 */   // Label 13104: @854424
     /*  854424 */   GIM_Try, /*On fail goto*//*Label 13105*/ GIMT_Encode4(854499), // Rule ID 24337 //
     /*  854429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  854432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  854440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  854443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  854446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  854449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  854468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854475 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11202:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  854475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1),
     /*  854478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  854494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854497 */     GIR_RootConstrainSelectedInstOperands,
     /*  854498 */     // GIR_Coverage, 24337,
     /*  854498 */     GIR_EraseRootFromParent_Done,
     /*  854499 */   // Label 13105: @854499
     /*  854499 */   GIM_Try, /*On fail goto*//*Label 13106*/ GIMT_Encode4(854574), // Rule ID 24340 //
     /*  854504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  854507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  854515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  854518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  854521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  854550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  854553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854572 */     GIR_RootConstrainSelectedInstOperands,
     /*  854573 */     // GIR_Coverage, 24340,
     /*  854573 */     GIR_EraseRootFromParent_Done,
     /*  854574 */   // Label 13106: @854574
     /*  854574 */   GIM_Try, /*On fail goto*//*Label 13107*/ GIMT_Encode4(854649), // Rule ID 24341 //
     /*  854579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  854582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  854590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  854593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  854596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  854599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  854614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  854618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854625 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11202:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  854625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1),
     /*  854628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  854644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854647 */     GIR_RootConstrainSelectedInstOperands,
     /*  854648 */     // GIR_Coverage, 24341,
     /*  854648 */     GIR_EraseRootFromParent_Done,
     /*  854649 */   // Label 13107: @854649
     /*  854649 */   GIM_Try, /*On fail goto*//*Label 13108*/ GIMT_Encode4(854724), // Rule ID 24344 //
     /*  854654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854700 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  854703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854722 */     GIR_RootConstrainSelectedInstOperands,
     /*  854723 */     // GIR_Coverage, 24344,
     /*  854723 */     GIR_EraseRootFromParent_Done,
     /*  854724 */   // Label 13108: @854724
     /*  854724 */   GIM_Try, /*On fail goto*//*Label 13109*/ GIMT_Encode4(854799), // Rule ID 24345 //
     /*  854729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  854740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  854743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  854746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  854764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854775 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2),
     /*  854778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854797 */     GIR_RootConstrainSelectedInstOperands,
     /*  854798 */     // GIR_Coverage, 24345,
     /*  854798 */     GIR_EraseRootFromParent_Done,
     /*  854799 */   // Label 13109: @854799
     /*  854799 */   GIM_Try, /*On fail goto*//*Label 13110*/ GIMT_Encode4(854874), // Rule ID 24348 //
     /*  854804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854850 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  854850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  854853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854872 */     GIR_RootConstrainSelectedInstOperands,
     /*  854873 */     // GIR_Coverage, 24348,
     /*  854873 */     GIR_EraseRootFromParent_Done,
     /*  854874 */   // Label 13110: @854874
     /*  854874 */   GIM_Try, /*On fail goto*//*Label 13111*/ GIMT_Encode4(854949), // Rule ID 24349 //
     /*  854879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  854882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  854890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  854893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  854896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  854902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  854914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  854925 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  854925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4),
     /*  854928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  854930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  854932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  854934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  854936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  854941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  854944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  854947 */     GIR_RootConstrainSelectedInstOperands,
     /*  854948 */     // GIR_Coverage, 24349,
     /*  854948 */     GIR_EraseRootFromParent_Done,
     /*  854949 */   // Label 13111: @854949
     /*  854949 */   GIM_Try, /*On fail goto*//*Label 13112*/ GIMT_Encode4(855024), // Rule ID 24352 //
     /*  854954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  854957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  854962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  854965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  854968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  854971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  854974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  854977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  854989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  854993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855000 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  855000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855022 */     GIR_RootConstrainSelectedInstOperands,
     /*  855023 */     // GIR_Coverage, 24352,
     /*  855023 */     GIR_EraseRootFromParent_Done,
     /*  855024 */   // Label 13112: @855024
     /*  855024 */   GIM_Try, /*On fail goto*//*Label 13113*/ GIMT_Encode4(855099), // Rule ID 24353 //
     /*  855029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  855032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  855040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  855043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  855046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /*  855049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  855068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855075 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  855075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8),
     /*  855078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  855094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855097 */     GIR_RootConstrainSelectedInstOperands,
     /*  855098 */     // GIR_Coverage, 24353,
     /*  855098 */     GIR_EraseRootFromParent_Done,
     /*  855099 */   // Label 13113: @855099
     /*  855099 */   GIM_Try, /*On fail goto*//*Label 13114*/ GIMT_Encode4(855174), // Rule ID 24356 //
     /*  855104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855150 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855172 */     GIR_RootConstrainSelectedInstOperands,
     /*  855173 */     // GIR_Coverage, 24356,
     /*  855173 */     GIR_EraseRootFromParent_Done,
     /*  855174 */   // Label 13114: @855174
     /*  855174 */   GIM_Try, /*On fail goto*//*Label 13115*/ GIMT_Encode4(855249), // Rule ID 24357 //
     /*  855179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  855190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  855193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  855196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2),
     /*  855228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855247 */     GIR_RootConstrainSelectedInstOperands,
     /*  855248 */     // GIR_Coverage, 24357,
     /*  855248 */     GIR_EraseRootFromParent_Done,
     /*  855249 */   // Label 13115: @855249
     /*  855249 */   GIM_Try, /*On fail goto*//*Label 13116*/ GIMT_Encode4(855324), // Rule ID 24360 //
     /*  855254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855300 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855322 */     GIR_RootConstrainSelectedInstOperands,
     /*  855323 */     // GIR_Coverage, 24360,
     /*  855323 */     GIR_EraseRootFromParent_Done,
     /*  855324 */   // Label 13116: @855324
     /*  855324 */   GIM_Try, /*On fail goto*//*Label 13117*/ GIMT_Encode4(855399), // Rule ID 24361 //
     /*  855329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  855340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  855343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  855346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855375 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4),
     /*  855378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855397 */     GIR_RootConstrainSelectedInstOperands,
     /*  855398 */     // GIR_Coverage, 24361,
     /*  855398 */     GIR_EraseRootFromParent_Done,
     /*  855399 */   // Label 13117: @855399
     /*  855399 */   GIM_Try, /*On fail goto*//*Label 13118*/ GIMT_Encode4(855474), // Rule ID 24364 //
     /*  855404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  855407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855450 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  855450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  855453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855472 */     GIR_RootConstrainSelectedInstOperands,
     /*  855473 */     // GIR_Coverage, 24364,
     /*  855473 */     GIR_EraseRootFromParent_Done,
     /*  855474 */   // Label 13118: @855474
     /*  855474 */   GIM_Try, /*On fail goto*//*Label 13119*/ GIMT_Encode4(855549), // Rule ID 24365 //
     /*  855479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  855482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  855490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  855493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  855496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  855499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  855518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855525 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  855525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8),
     /*  855528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  855544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855547 */     GIR_RootConstrainSelectedInstOperands,
     /*  855548 */     // GIR_Coverage, 24365,
     /*  855548 */     GIR_EraseRootFromParent_Done,
     /*  855549 */   // Label 13119: @855549
     /*  855549 */   GIM_Try, /*On fail goto*//*Label 13120*/ GIMT_Encode4(855624), // Rule ID 24368 //
     /*  855554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  855603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855622 */     GIR_RootConstrainSelectedInstOperands,
     /*  855623 */     // GIR_Coverage, 24368,
     /*  855623 */     GIR_EraseRootFromParent_Done,
     /*  855624 */   // Label 13120: @855624
     /*  855624 */   GIM_Try, /*On fail goto*//*Label 13121*/ GIMT_Encode4(855699), // Rule ID 24369 //
     /*  855629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  855640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  855643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  855646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  855664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855675 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11202:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2),
     /*  855678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855697 */     GIR_RootConstrainSelectedInstOperands,
     /*  855698 */     // GIR_Coverage, 24369,
     /*  855698 */     GIR_EraseRootFromParent_Done,
     /*  855699 */   // Label 13121: @855699
     /*  855699 */   GIM_Try, /*On fail goto*//*Label 13122*/ GIMT_Encode4(855774), // Rule ID 24372 //
     /*  855704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  855753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855772 */     GIR_RootConstrainSelectedInstOperands,
     /*  855773 */     // GIR_Coverage, 24372,
     /*  855773 */     GIR_EraseRootFromParent_Done,
     /*  855774 */   // Label 13122: @855774
     /*  855774 */   GIM_Try, /*On fail goto*//*Label 13123*/ GIMT_Encode4(855849), // Rule ID 24373 //
     /*  855779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  855790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  855793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  855796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  855814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855825 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11202:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4),
     /*  855828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855847 */     GIR_RootConstrainSelectedInstOperands,
     /*  855848 */     // GIR_Coverage, 24373,
     /*  855848 */     GIR_EraseRootFromParent_Done,
     /*  855849 */   // Label 13123: @855849
     /*  855849 */   GIM_Try, /*On fail goto*//*Label 13124*/ GIMT_Encode4(855924), // Rule ID 24376 //
     /*  855854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  855857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  855877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855900 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  855900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  855903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855922 */     GIR_RootConstrainSelectedInstOperands,
     /*  855923 */     // GIR_Coverage, 24376,
     /*  855923 */     GIR_EraseRootFromParent_Done,
     /*  855924 */   // Label 13124: @855924
     /*  855924 */   GIM_Try, /*On fail goto*//*Label 13125*/ GIMT_Encode4(855999), // Rule ID 24377 //
     /*  855929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  855932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down),
     /*  855937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  855940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  855943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  855946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  855949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  855952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  855964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  855968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  855975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11202:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  855975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8),
     /*  855978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  855980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  855982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  855984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  855986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  855991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  855994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  855997 */     GIR_RootConstrainSelectedInstOperands,
     /*  855998 */     // GIR_Coverage, 24377,
     /*  855998 */     GIR_EraseRootFromParent_Done,
     /*  855999 */   // Label 13125: @855999
     /*  855999 */   GIM_Try, /*On fail goto*//*Label 13126*/ GIMT_Encode4(856074), // Rule ID 24380 //
     /*  856004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856050 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856072 */     GIR_RootConstrainSelectedInstOperands,
     /*  856073 */     // GIR_Coverage, 24380,
     /*  856073 */     GIR_EraseRootFromParent_Done,
     /*  856074 */   // Label 13126: @856074
     /*  856074 */   GIM_Try, /*On fail goto*//*Label 13127*/ GIMT_Encode4(856149), // Rule ID 24381 //
     /*  856079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  856090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  856093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  856096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  856099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856125 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF8_E8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8),
     /*  856128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856147 */     GIR_RootConstrainSelectedInstOperands,
     /*  856148 */     // GIR_Coverage, 24381,
     /*  856148 */     GIR_EraseRootFromParent_Done,
     /*  856149 */   // Label 13127: @856149
     /*  856149 */   GIM_Try, /*On fail goto*//*Label 13128*/ GIMT_Encode4(856224), // Rule ID 24384 //
     /*  856154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856222 */     GIR_RootConstrainSelectedInstOperands,
     /*  856223 */     // GIR_Coverage, 24384,
     /*  856223 */     GIR_EraseRootFromParent_Done,
     /*  856224 */   // Label 13128: @856224
     /*  856224 */   GIM_Try, /*On fail goto*//*Label 13129*/ GIMT_Encode4(856299), // Rule ID 24385 //
     /*  856229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  856240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  856243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  856246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  856249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856275 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8),
     /*  856278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856297 */     GIR_RootConstrainSelectedInstOperands,
     /*  856298 */     // GIR_Coverage, 24385,
     /*  856298 */     GIR_EraseRootFromParent_Done,
     /*  856299 */   // Label 13129: @856299
     /*  856299 */   GIM_Try, /*On fail goto*//*Label 13130*/ GIMT_Encode4(856374), // Rule ID 24388 //
     /*  856304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856350 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856372 */     GIR_RootConstrainSelectedInstOperands,
     /*  856373 */     // GIR_Coverage, 24388,
     /*  856373 */     GIR_EraseRootFromParent_Done,
     /*  856374 */   // Label 13130: @856374
     /*  856374 */   GIM_Try, /*On fail goto*//*Label 13131*/ GIMT_Encode4(856449), // Rule ID 24389 //
     /*  856379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  856390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  856393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  856396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  856399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856425 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  856425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8),
     /*  856428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856447 */     GIR_RootConstrainSelectedInstOperands,
     /*  856448 */     // GIR_Coverage, 24389,
     /*  856448 */     GIR_EraseRootFromParent_Done,
     /*  856449 */   // Label 13131: @856449
     /*  856449 */   GIM_Try, /*On fail goto*//*Label 13132*/ GIMT_Encode4(856524), // Rule ID 24392 //
     /*  856454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  856465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  856468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  856471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  856474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856500 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  856503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856522 */     GIR_RootConstrainSelectedInstOperands,
     /*  856523 */     // GIR_Coverage, 24392,
     /*  856523 */     GIR_EraseRootFromParent_Done,
     /*  856524 */   // Label 13132: @856524
     /*  856524 */   GIM_Try, /*On fail goto*//*Label 13133*/ GIMT_Encode4(856599), // Rule ID 24393 //
     /*  856529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  856540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  856543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  856546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  856549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856575 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  856578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856597 */     GIR_RootConstrainSelectedInstOperands,
     /*  856598 */     // GIR_Coverage, 24393,
     /*  856598 */     GIR_EraseRootFromParent_Done,
     /*  856599 */   // Label 13133: @856599
     /*  856599 */   GIM_Try, /*On fail goto*//*Label 13134*/ GIMT_Encode4(856674), // Rule ID 24396 //
     /*  856604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  856624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856650 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  856650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  856653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856672 */     GIR_RootConstrainSelectedInstOperands,
     /*  856673 */     // GIR_Coverage, 24396,
     /*  856673 */     GIR_EraseRootFromParent_Done,
     /*  856674 */   // Label 13134: @856674
     /*  856674 */   GIM_Try, /*On fail goto*//*Label 13135*/ GIMT_Encode4(856749), // Rule ID 24397 //
     /*  856679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  856690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  856693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  856696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  856699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856725 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  856725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  856728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  856744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856747 */     GIR_RootConstrainSelectedInstOperands,
     /*  856748 */     // GIR_Coverage, 24397,
     /*  856748 */     GIR_EraseRootFromParent_Done,
     /*  856749 */   // Label 13135: @856749
     /*  856749 */   GIM_Try, /*On fail goto*//*Label 13136*/ GIMT_Encode4(856824), // Rule ID 24400 //
     /*  856754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  856774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  856800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  856803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856822 */     GIR_RootConstrainSelectedInstOperands,
     /*  856823 */     // GIR_Coverage, 24400,
     /*  856823 */     GIR_EraseRootFromParent_Done,
     /*  856824 */   // Label 13136: @856824
     /*  856824 */   GIM_Try, /*On fail goto*//*Label 13137*/ GIMT_Encode4(856899), // Rule ID 24401 //
     /*  856829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  856840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  856843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  856846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  856849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  856852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856875 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  856875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  856878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  856894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856897 */     GIR_RootConstrainSelectedInstOperands,
     /*  856898 */     // GIR_Coverage, 24401,
     /*  856898 */     GIR_EraseRootFromParent_Done,
     /*  856899 */   // Label 13137: @856899
     /*  856899 */   GIM_Try, /*On fail goto*//*Label 13138*/ GIMT_Encode4(856974), // Rule ID 24404 //
     /*  856904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  856907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  856915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  856918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  856921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  856924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  856927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  856943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  856950 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  856950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  856953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  856955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  856957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  856959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  856961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  856966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  856969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  856972 */     GIR_RootConstrainSelectedInstOperands,
     /*  856973 */     // GIR_Coverage, 24404,
     /*  856973 */     GIR_EraseRootFromParent_Done,
     /*  856974 */   // Label 13138: @856974
     /*  856974 */   GIM_Try, /*On fail goto*//*Label 13139*/ GIMT_Encode4(857049), // Rule ID 24405 //
     /*  856979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  856982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  856987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  856990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  856993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  856996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  856999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857025 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11450:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8),
     /*  857028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857047 */     GIR_RootConstrainSelectedInstOperands,
     /*  857048 */     // GIR_Coverage, 24405,
     /*  857048 */     GIR_EraseRootFromParent_Done,
     /*  857049 */   // Label 13139: @857049
     /*  857049 */   GIM_Try, /*On fail goto*//*Label 13140*/ GIMT_Encode4(857124), // Rule ID 24408 //
     /*  857054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857100 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  857100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857122 */     GIR_RootConstrainSelectedInstOperands,
     /*  857123 */     // GIR_Coverage, 24408,
     /*  857123 */     GIR_EraseRootFromParent_Done,
     /*  857124 */   // Label 13140: @857124
     /*  857124 */   GIM_Try, /*On fail goto*//*Label 13141*/ GIMT_Encode4(857199), // Rule ID 24409 //
     /*  857129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  857140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  857143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  857146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  857149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857175 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  857175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  857178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  857194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857197 */     GIR_RootConstrainSelectedInstOperands,
     /*  857198 */     // GIR_Coverage, 24409,
     /*  857198 */     GIR_EraseRootFromParent_Done,
     /*  857199 */   // Label 13141: @857199
     /*  857199 */   GIM_Try, /*On fail goto*//*Label 13142*/ GIMT_Encode4(857274), // Rule ID 24412 //
     /*  857204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  857250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857272 */     GIR_RootConstrainSelectedInstOperands,
     /*  857273 */     // GIR_Coverage, 24412,
     /*  857273 */     GIR_EraseRootFromParent_Done,
     /*  857274 */   // Label 13142: @857274
     /*  857274 */   GIM_Try, /*On fail goto*//*Label 13143*/ GIMT_Encode4(857349), // Rule ID 24413 //
     /*  857279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  857290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  857293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  857296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  857299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857325 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  857325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  857328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  857344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857347 */     GIR_RootConstrainSelectedInstOperands,
     /*  857348 */     // GIR_Coverage, 24413,
     /*  857348 */     GIR_EraseRootFromParent_Done,
     /*  857349 */   // Label 13143: @857349
     /*  857349 */   GIM_Try, /*On fail goto*//*Label 13144*/ GIMT_Encode4(857424), // Rule ID 24416 //
     /*  857354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  857357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  857400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857422 */     GIR_RootConstrainSelectedInstOperands,
     /*  857423 */     // GIR_Coverage, 24416,
     /*  857423 */     GIR_EraseRootFromParent_Done,
     /*  857424 */   // Label 13144: @857424
     /*  857424 */   GIM_Try, /*On fail goto*//*Label 13145*/ GIMT_Encode4(857499), // Rule ID 24417 //
     /*  857429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  857432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  857440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  857443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  857446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  857449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  857468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  857475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  857478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  857494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857497 */     GIR_RootConstrainSelectedInstOperands,
     /*  857498 */     // GIR_Coverage, 24417,
     /*  857498 */     GIR_EraseRootFromParent_Done,
     /*  857499 */   // Label 13145: @857499
     /*  857499 */   GIM_Try, /*On fail goto*//*Label 13146*/ GIMT_Encode4(857574), // Rule ID 24420 //
     /*  857504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  857515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  857518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  857521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  857524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  857553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857572 */     GIR_RootConstrainSelectedInstOperands,
     /*  857573 */     // GIR_Coverage, 24420,
     /*  857573 */     GIR_EraseRootFromParent_Done,
     /*  857574 */   // Label 13146: @857574
     /*  857574 */   GIM_Try, /*On fail goto*//*Label 13147*/ GIMT_Encode4(857649), // Rule ID 24421 //
     /*  857579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  857590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  857593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  857596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  857599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857625 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8),
     /*  857628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857647 */     GIR_RootConstrainSelectedInstOperands,
     /*  857648 */     // GIR_Coverage, 24421,
     /*  857648 */     GIR_EraseRootFromParent_Done,
     /*  857649 */   // Label 13147: @857649
     /*  857649 */   GIM_Try, /*On fail goto*//*Label 13148*/ GIMT_Encode4(857724), // Rule ID 24424 //
     /*  857654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  857665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  857668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  857671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  857674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857700 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  857703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857722 */     GIR_RootConstrainSelectedInstOperands,
     /*  857723 */     // GIR_Coverage, 24424,
     /*  857723 */     GIR_EraseRootFromParent_Done,
     /*  857724 */   // Label 13148: @857724
     /*  857724 */   GIM_Try, /*On fail goto*//*Label 13149*/ GIMT_Encode4(857799), // Rule ID 24425 //
     /*  857729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  857740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  857743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  857746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  857749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  857768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857775 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8),
     /*  857778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857797 */     GIR_RootConstrainSelectedInstOperands,
     /*  857798 */     // GIR_Coverage, 24425,
     /*  857798 */     GIR_EraseRootFromParent_Done,
     /*  857799 */   // Label 13149: @857799
     /*  857799 */   GIM_Try, /*On fail goto*//*Label 13150*/ GIMT_Encode4(857874), // Rule ID 24428 //
     /*  857804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  857815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  857818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  857821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  857824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857850 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  857850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  857853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857872 */     GIR_RootConstrainSelectedInstOperands,
     /*  857873 */     // GIR_Coverage, 24428,
     /*  857873 */     GIR_EraseRootFromParent_Done,
     /*  857874 */   // Label 13150: @857874
     /*  857874 */   GIM_Try, /*On fail goto*//*Label 13151*/ GIMT_Encode4(857949), // Rule ID 24429 //
     /*  857879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  857882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  857890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  857893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  857896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  857899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  857902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  857918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  857925 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  857925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8),
     /*  857928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  857930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  857932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  857934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  857936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  857941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  857944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  857947 */     GIR_RootConstrainSelectedInstOperands,
     /*  857948 */     // GIR_Coverage, 24429,
     /*  857948 */     GIR_EraseRootFromParent_Done,
     /*  857949 */   // Label 13151: @857949
     /*  857949 */   GIM_Try, /*On fail goto*//*Label 13152*/ GIMT_Encode4(858024), // Rule ID 24432 //
     /*  857954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  857957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  857962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  857965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  857968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  857971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  857974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  857977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  857993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858000 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858022 */     GIR_RootConstrainSelectedInstOperands,
     /*  858023 */     // GIR_Coverage, 24432,
     /*  858023 */     GIR_EraseRootFromParent_Done,
     /*  858024 */   // Label 13152: @858024
     /*  858024 */   GIM_Try, /*On fail goto*//*Label 13153*/ GIMT_Encode4(858099), // Rule ID 24433 //
     /*  858029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  858040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  858043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  858046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  858049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858075 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  858078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858097 */     GIR_RootConstrainSelectedInstOperands,
     /*  858098 */     // GIR_Coverage, 24433,
     /*  858098 */     GIR_EraseRootFromParent_Done,
     /*  858099 */   // Label 13153: @858099
     /*  858099 */   GIM_Try, /*On fail goto*//*Label 13154*/ GIMT_Encode4(858174), // Rule ID 24436 //
     /*  858104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858172 */     GIR_RootConstrainSelectedInstOperands,
     /*  858173 */     // GIR_Coverage, 24436,
     /*  858173 */     GIR_EraseRootFromParent_Done,
     /*  858174 */   // Label 13154: @858174
     /*  858174 */   GIM_Try, /*On fail goto*//*Label 13155*/ GIMT_Encode4(858249), // Rule ID 24437 //
     /*  858179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  858190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  858193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  858196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  858199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858225 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  858228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858247 */     GIR_RootConstrainSelectedInstOperands,
     /*  858248 */     // GIR_Coverage, 24437,
     /*  858248 */     GIR_EraseRootFromParent_Done,
     /*  858249 */   // Label 13155: @858249
     /*  858249 */   GIM_Try, /*On fail goto*//*Label 13156*/ GIMT_Encode4(858324), // Rule ID 24440 //
     /*  858254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858300 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  858300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858322 */     GIR_RootConstrainSelectedInstOperands,
     /*  858323 */     // GIR_Coverage, 24440,
     /*  858323 */     GIR_EraseRootFromParent_Done,
     /*  858324 */   // Label 13156: @858324
     /*  858324 */   GIM_Try, /*On fail goto*//*Label 13157*/ GIMT_Encode4(858399), // Rule ID 24441 //
     /*  858329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  858340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  858343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  858346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  858349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858375 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  858375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  858378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  858394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858397 */     GIR_RootConstrainSelectedInstOperands,
     /*  858398 */     // GIR_Coverage, 24441,
     /*  858398 */     GIR_EraseRootFromParent_Done,
     /*  858399 */   // Label 13157: @858399
     /*  858399 */   GIM_Try, /*On fail goto*//*Label 13158*/ GIMT_Encode4(858474), // Rule ID 24444 //
     /*  858404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  858415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  858418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  858421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  858424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  858453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858472 */     GIR_RootConstrainSelectedInstOperands,
     /*  858473 */     // GIR_Coverage, 24444,
     /*  858473 */     GIR_EraseRootFromParent_Done,
     /*  858474 */   // Label 13158: @858474
     /*  858474 */   GIM_Try, /*On fail goto*//*Label 13159*/ GIMT_Encode4(858549), // Rule ID 24445 //
     /*  858479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  858490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  858493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  858496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  858499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858525 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  858528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858547 */     GIR_RootConstrainSelectedInstOperands,
     /*  858548 */     // GIR_Coverage, 24445,
     /*  858548 */     GIR_EraseRootFromParent_Done,
     /*  858549 */   // Label 13159: @858549
     /*  858549 */   GIM_Try, /*On fail goto*//*Label 13160*/ GIMT_Encode4(858624), // Rule ID 24448 //
     /*  858554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  858565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  858568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  858571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  858574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  858603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858622 */     GIR_RootConstrainSelectedInstOperands,
     /*  858623 */     // GIR_Coverage, 24448,
     /*  858623 */     GIR_EraseRootFromParent_Done,
     /*  858624 */   // Label 13160: @858624
     /*  858624 */   GIM_Try, /*On fail goto*//*Label 13161*/ GIMT_Encode4(858699), // Rule ID 24449 //
     /*  858629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  858640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  858643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  858646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  858649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  858668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858675 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  858678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858697 */     GIR_RootConstrainSelectedInstOperands,
     /*  858698 */     // GIR_Coverage, 24449,
     /*  858698 */     GIR_EraseRootFromParent_Done,
     /*  858699 */   // Label 13161: @858699
     /*  858699 */   GIM_Try, /*On fail goto*//*Label 13162*/ GIMT_Encode4(858774), // Rule ID 24452 //
     /*  858704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  858707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  858715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  858718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  858721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  858724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  858750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  858753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858772 */     GIR_RootConstrainSelectedInstOperands,
     /*  858773 */     // GIR_Coverage, 24452,
     /*  858773 */     GIR_EraseRootFromParent_Done,
     /*  858774 */   // Label 13162: @858774
     /*  858774 */   GIM_Try, /*On fail goto*//*Label 13163*/ GIMT_Encode4(858849), // Rule ID 24453 //
     /*  858779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  858782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  858790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  858793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  858796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  858799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  858818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858825 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  858825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  858828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  858844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858847 */     GIR_RootConstrainSelectedInstOperands,
     /*  858848 */     // GIR_Coverage, 24453,
     /*  858848 */     GIR_EraseRootFromParent_Done,
     /*  858849 */   // Label 13163: @858849
     /*  858849 */   GIM_Try, /*On fail goto*//*Label 13164*/ GIMT_Encode4(858924), // Rule ID 24456 //
     /*  858854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  858857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  858865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  858868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  858871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  858874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  858877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  858900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  858903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858922 */     GIR_RootConstrainSelectedInstOperands,
     /*  858923 */     // GIR_Coverage, 24456,
     /*  858923 */     GIR_EraseRootFromParent_Done,
     /*  858924 */   // Label 13164: @858924
     /*  858924 */   GIM_Try, /*On fail goto*//*Label 13165*/ GIMT_Encode4(858999), // Rule ID 24457 //
     /*  858929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  858932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  858937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  858940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  858943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  858946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  858949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  858952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  858968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  858975 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  858975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  858978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  858980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  858982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  858984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  858986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  858991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  858994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  858997 */     GIR_RootConstrainSelectedInstOperands,
     /*  858998 */     // GIR_Coverage, 24457,
     /*  858998 */     GIR_EraseRootFromParent_Done,
     /*  858999 */   // Label 13165: @858999
     /*  858999 */   GIM_Try, /*On fail goto*//*Label 13166*/ GIMT_Encode4(859074), // Rule ID 24460 //
     /*  859004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859050 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859072 */     GIR_RootConstrainSelectedInstOperands,
     /*  859073 */     // GIR_Coverage, 24460,
     /*  859073 */     GIR_EraseRootFromParent_Done,
     /*  859074 */   // Label 13166: @859074
     /*  859074 */   GIM_Try, /*On fail goto*//*Label 13167*/ GIMT_Encode4(859149), // Rule ID 24461 //
     /*  859079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  859090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  859093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  859096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  859099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  859118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859125 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  859128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859147 */     GIR_RootConstrainSelectedInstOperands,
     /*  859148 */     // GIR_Coverage, 24461,
     /*  859148 */     GIR_EraseRootFromParent_Done,
     /*  859149 */   // Label 13167: @859149
     /*  859149 */   GIM_Try, /*On fail goto*//*Label 13168*/ GIMT_Encode4(859224), // Rule ID 24464 //
     /*  859154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  859157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  859200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859222 */     GIR_RootConstrainSelectedInstOperands,
     /*  859223 */     // GIR_Coverage, 24464,
     /*  859223 */     GIR_EraseRootFromParent_Done,
     /*  859224 */   // Label 13168: @859224
     /*  859224 */   GIM_Try, /*On fail goto*//*Label 13169*/ GIMT_Encode4(859299), // Rule ID 24465 //
     /*  859229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  859232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  859237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  859240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  859243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  859246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  859249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  859268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859275 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  859275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  859278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  859294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859297 */     GIR_RootConstrainSelectedInstOperands,
     /*  859298 */     // GIR_Coverage, 24465,
     /*  859298 */     GIR_EraseRootFromParent_Done,
     /*  859299 */   // Label 13169: @859299
     /*  859299 */   GIM_Try, /*On fail goto*//*Label 13170*/ GIMT_Encode4(859374), // Rule ID 24468 //
     /*  859304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859350 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  859350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859372 */     GIR_RootConstrainSelectedInstOperands,
     /*  859373 */     // GIR_Coverage, 24468,
     /*  859373 */     GIR_EraseRootFromParent_Done,
     /*  859374 */   // Label 13170: @859374
     /*  859374 */   GIM_Try, /*On fail goto*//*Label 13171*/ GIMT_Encode4(859449), // Rule ID 24469 //
     /*  859379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  859390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  859393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  859396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859425 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  859425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8),
     /*  859428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859447 */     GIR_RootConstrainSelectedInstOperands,
     /*  859448 */     // GIR_Coverage, 24469,
     /*  859448 */     GIR_EraseRootFromParent_Done,
     /*  859449 */   // Label 13171: @859449
     /*  859449 */   GIM_Try, /*On fail goto*//*Label 13172*/ GIMT_Encode4(859524), // Rule ID 24472 //
     /*  859454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  859465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  859468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  859471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859500 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  859500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  859503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859522 */     GIR_RootConstrainSelectedInstOperands,
     /*  859523 */     // GIR_Coverage, 24472,
     /*  859523 */     GIR_EraseRootFromParent_Done,
     /*  859524 */   // Label 13172: @859524
     /*  859524 */   GIM_Try, /*On fail goto*//*Label 13173*/ GIMT_Encode4(859599), // Rule ID 24473 //
     /*  859529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  859540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  859543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  859546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859575 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  859575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  859578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859597 */     GIR_RootConstrainSelectedInstOperands,
     /*  859598 */     // GIR_Coverage, 24473,
     /*  859598 */     GIR_EraseRootFromParent_Done,
     /*  859599 */   // Label 13173: @859599
     /*  859599 */   GIM_Try, /*On fail goto*//*Label 13174*/ GIMT_Encode4(859674), // Rule ID 24476 //
     /*  859604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  859615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  859618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  859621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859650 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  859650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  859653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859672 */     GIR_RootConstrainSelectedInstOperands,
     /*  859673 */     // GIR_Coverage, 24476,
     /*  859673 */     GIR_EraseRootFromParent_Done,
     /*  859674 */   // Label 13174: @859674
     /*  859674 */   GIM_Try, /*On fail goto*//*Label 13175*/ GIMT_Encode4(859749), // Rule ID 24477 //
     /*  859679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  859690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  859693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  859696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859725 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  859725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  859728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  859744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859747 */     GIR_RootConstrainSelectedInstOperands,
     /*  859748 */     // GIR_Coverage, 24477,
     /*  859748 */     GIR_EraseRootFromParent_Done,
     /*  859749 */   // Label 13175: @859749
     /*  859749 */   GIM_Try, /*On fail goto*//*Label 13176*/ GIMT_Encode4(859824), // Rule ID 24480 //
     /*  859754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  859765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  859768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  859771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  859803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859822 */     GIR_RootConstrainSelectedInstOperands,
     /*  859823 */     // GIR_Coverage, 24480,
     /*  859823 */     GIR_EraseRootFromParent_Done,
     /*  859824 */   // Label 13176: @859824
     /*  859824 */   GIM_Try, /*On fail goto*//*Label 13177*/ GIMT_Encode4(859899), // Rule ID 24481 //
     /*  859829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  859840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  859843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  859846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  859852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859875 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  859875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  859878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859897 */     GIR_RootConstrainSelectedInstOperands,
     /*  859898 */     // GIR_Coverage, 24481,
     /*  859898 */     GIR_EraseRootFromParent_Done,
     /*  859899 */   // Label 13177: @859899
     /*  859899 */   GIM_Try, /*On fail goto*//*Label 13178*/ GIMT_Encode4(859974), // Rule ID 24484 //
     /*  859904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  859907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  859918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  859924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  859927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  859939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  859943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  859950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  859950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  859953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  859955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  859957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  859959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  859961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  859966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  859969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  859972 */     GIR_RootConstrainSelectedInstOperands,
     /*  859973 */     // GIR_Coverage, 24484,
     /*  859973 */     GIR_EraseRootFromParent_Done,
     /*  859974 */   // Label 13178: @859974
     /*  859974 */   GIM_Try, /*On fail goto*//*Label 13179*/ GIMT_Encode4(860049), // Rule ID 24485 //
     /*  859979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  859982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  859987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  859990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  859993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  859996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  859999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860025 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860047 */     GIR_RootConstrainSelectedInstOperands,
     /*  860048 */     // GIR_Coverage, 24485,
     /*  860048 */     GIR_EraseRootFromParent_Done,
     /*  860049 */   // Label 13179: @860049
     /*  860049 */   GIM_Try, /*On fail goto*//*Label 13180*/ GIMT_Encode4(860124), // Rule ID 24488 //
     /*  860054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860100 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  860100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860122 */     GIR_RootConstrainSelectedInstOperands,
     /*  860123 */     // GIR_Coverage, 24488,
     /*  860123 */     GIR_EraseRootFromParent_Done,
     /*  860124 */   // Label 13180: @860124
     /*  860124 */   GIM_Try, /*On fail goto*//*Label 13181*/ GIMT_Encode4(860199), // Rule ID 24489 //
     /*  860129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  860140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  860143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  860146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860175 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  860175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  860178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860197 */     GIR_RootConstrainSelectedInstOperands,
     /*  860198 */     // GIR_Coverage, 24489,
     /*  860198 */     GIR_EraseRootFromParent_Done,
     /*  860199 */   // Label 13181: @860199
     /*  860199 */   GIM_Try, /*On fail goto*//*Label 13182*/ GIMT_Encode4(860274), // Rule ID 24492 //
     /*  860204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860250 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860272 */     GIR_RootConstrainSelectedInstOperands,
     /*  860273 */     // GIR_Coverage, 24492,
     /*  860273 */     GIR_EraseRootFromParent_Done,
     /*  860274 */   // Label 13182: @860274
     /*  860274 */   GIM_Try, /*On fail goto*//*Label 13183*/ GIMT_Encode4(860349), // Rule ID 24493 //
     /*  860279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  860290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  860293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  860296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860325 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11452:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860347 */     GIR_RootConstrainSelectedInstOperands,
     /*  860348 */     // GIR_Coverage, 24493,
     /*  860348 */     GIR_EraseRootFromParent_Done,
     /*  860349 */   // Label 13183: @860349
     /*  860349 */   GIM_Try, /*On fail goto*//*Label 13184*/ GIMT_Encode4(860424), // Rule ID 24496 //
     /*  860354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  860400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860422 */     GIR_RootConstrainSelectedInstOperands,
     /*  860423 */     // GIR_Coverage, 24496,
     /*  860423 */     GIR_EraseRootFromParent_Done,
     /*  860424 */   // Label 13184: @860424
     /*  860424 */   GIM_Try, /*On fail goto*//*Label 13185*/ GIMT_Encode4(860499), // Rule ID 24497 //
     /*  860429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  860440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  860443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  860446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860475 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  860475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  860494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860497 */     GIR_RootConstrainSelectedInstOperands,
     /*  860498 */     // GIR_Coverage, 24497,
     /*  860498 */     GIR_EraseRootFromParent_Done,
     /*  860499 */   // Label 13185: @860499
     /*  860499 */   GIM_Try, /*On fail goto*//*Label 13186*/ GIMT_Encode4(860574), // Rule ID 24500 //
     /*  860504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  860515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  860518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  860521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860550 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  860550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860572 */     GIR_RootConstrainSelectedInstOperands,
     /*  860573 */     // GIR_Coverage, 24500,
     /*  860573 */     GIR_EraseRootFromParent_Done,
     /*  860574 */   // Label 13186: @860574
     /*  860574 */   GIM_Try, /*On fail goto*//*Label 13187*/ GIMT_Encode4(860649), // Rule ID 24501 //
     /*  860579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  860590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  860593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  860596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860625 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  860625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  860644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860647 */     GIR_RootConstrainSelectedInstOperands,
     /*  860648 */     // GIR_Coverage, 24501,
     /*  860648 */     GIR_EraseRootFromParent_Done,
     /*  860649 */   // Label 13187: @860649
     /*  860649 */   GIM_Try, /*On fail goto*//*Label 13188*/ GIMT_Encode4(860724), // Rule ID 24504 //
     /*  860654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  860657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  860665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  860668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  860671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  860700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860722 */     GIR_RootConstrainSelectedInstOperands,
     /*  860723 */     // GIR_Coverage, 24504,
     /*  860723 */     GIR_EraseRootFromParent_Done,
     /*  860724 */   // Label 13188: @860724
     /*  860724 */   GIM_Try, /*On fail goto*//*Label 13189*/ GIMT_Encode4(860799), // Rule ID 24505 //
     /*  860729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  860732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  860740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  860743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  860746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  860764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860775 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  860775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  860778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  860794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860797 */     GIR_RootConstrainSelectedInstOperands,
     /*  860798 */     // GIR_Coverage, 24505,
     /*  860798 */     GIR_EraseRootFromParent_Done,
     /*  860799 */   // Label 13189: @860799
     /*  860799 */   GIM_Try, /*On fail goto*//*Label 13190*/ GIMT_Encode4(860874), // Rule ID 24508 //
     /*  860804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  860815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  860818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  860821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860850 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  860850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  860853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860872 */     GIR_RootConstrainSelectedInstOperands,
     /*  860873 */     // GIR_Coverage, 24508,
     /*  860873 */     GIR_EraseRootFromParent_Done,
     /*  860874 */   // Label 13190: @860874
     /*  860874 */   GIM_Try, /*On fail goto*//*Label 13191*/ GIMT_Encode4(860949), // Rule ID 24509 //
     /*  860879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  860882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  860890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  860893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  860896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  860899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  860902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  860914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  860925 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  860925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  860928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  860930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  860932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  860934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  860936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  860941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  860944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  860947 */     GIR_RootConstrainSelectedInstOperands,
     /*  860948 */     // GIR_Coverage, 24509,
     /*  860948 */     GIR_EraseRootFromParent_Done,
     /*  860949 */   // Label 13191: @860949
     /*  860949 */   GIM_Try, /*On fail goto*//*Label 13192*/ GIMT_Encode4(861024), // Rule ID 24512 //
     /*  860954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  860957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  860962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  860965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  860968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  860971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  860974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  860977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  860989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  860993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861022 */     GIR_RootConstrainSelectedInstOperands,
     /*  861023 */     // GIR_Coverage, 24512,
     /*  861023 */     GIR_EraseRootFromParent_Done,
     /*  861024 */   // Label 13192: @861024
     /*  861024 */   GIM_Try, /*On fail goto*//*Label 13193*/ GIMT_Encode4(861099), // Rule ID 24513 //
     /*  861029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  861040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  861043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  861046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861075 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861097 */     GIR_RootConstrainSelectedInstOperands,
     /*  861098 */     // GIR_Coverage, 24513,
     /*  861098 */     GIR_EraseRootFromParent_Done,
     /*  861099 */   // Label 13193: @861099
     /*  861099 */   GIM_Try, /*On fail goto*//*Label 13194*/ GIMT_Encode4(861174), // Rule ID 24516 //
     /*  861104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861150 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  861150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861172 */     GIR_RootConstrainSelectedInstOperands,
     /*  861173 */     // GIR_Coverage, 24516,
     /*  861173 */     GIR_EraseRootFromParent_Done,
     /*  861174 */   // Label 13194: @861174
     /*  861174 */   GIM_Try, /*On fail goto*//*Label 13195*/ GIMT_Encode4(861249), // Rule ID 24517 //
     /*  861179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  861190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  861193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  861196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861225 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  861225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  861244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861247 */     GIR_RootConstrainSelectedInstOperands,
     /*  861248 */     // GIR_Coverage, 24517,
     /*  861248 */     GIR_EraseRootFromParent_Done,
     /*  861249 */   // Label 13195: @861249
     /*  861249 */   GIM_Try, /*On fail goto*//*Label 13196*/ GIMT_Encode4(861324), // Rule ID 24520 //
     /*  861254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861300 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861322 */     GIR_RootConstrainSelectedInstOperands,
     /*  861323 */     // GIR_Coverage, 24520,
     /*  861323 */     GIR_EraseRootFromParent_Done,
     /*  861324 */   // Label 13196: @861324
     /*  861324 */   GIM_Try, /*On fail goto*//*Label 13197*/ GIMT_Encode4(861399), // Rule ID 24521 //
     /*  861329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  861340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  861343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  861346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861375 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861397 */     GIR_RootConstrainSelectedInstOperands,
     /*  861398 */     // GIR_Coverage, 24521,
     /*  861398 */     GIR_EraseRootFromParent_Done,
     /*  861399 */   // Label 13197: @861399
     /*  861399 */   GIM_Try, /*On fail goto*//*Label 13198*/ GIMT_Encode4(861474), // Rule ID 24524 //
     /*  861404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  861415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  861418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  861421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861450 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861472 */     GIR_RootConstrainSelectedInstOperands,
     /*  861473 */     // GIR_Coverage, 24524,
     /*  861473 */     GIR_EraseRootFromParent_Done,
     /*  861474 */   // Label 13198: @861474
     /*  861474 */   GIM_Try, /*On fail goto*//*Label 13199*/ GIMT_Encode4(861549), // Rule ID 24525 //
     /*  861479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  861490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  861493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  861496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861525 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861547 */     GIR_RootConstrainSelectedInstOperands,
     /*  861548 */     // GIR_Coverage, 24525,
     /*  861548 */     GIR_EraseRootFromParent_Done,
     /*  861549 */   // Label 13199: @861549
     /*  861549 */   GIM_Try, /*On fail goto*//*Label 13200*/ GIMT_Encode4(861624), // Rule ID 24528 //
     /*  861554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  861565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  861568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  861571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  861600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861622 */     GIR_RootConstrainSelectedInstOperands,
     /*  861623 */     // GIR_Coverage, 24528,
     /*  861623 */     GIR_EraseRootFromParent_Done,
     /*  861624 */   // Label 13200: @861624
     /*  861624 */   GIM_Try, /*On fail goto*//*Label 13201*/ GIMT_Encode4(861699), // Rule ID 24529 //
     /*  861629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  861640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  861643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  861646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  861664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861675 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  861675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  861678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  861694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861697 */     GIR_RootConstrainSelectedInstOperands,
     /*  861698 */     // GIR_Coverage, 24529,
     /*  861698 */     GIR_EraseRootFromParent_Done,
     /*  861699 */   // Label 13201: @861699
     /*  861699 */   GIM_Try, /*On fail goto*//*Label 13202*/ GIMT_Encode4(861774), // Rule ID 24532 //
     /*  861704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  861715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  861718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  861721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861772 */     GIR_RootConstrainSelectedInstOperands,
     /*  861773 */     // GIR_Coverage, 24532,
     /*  861773 */     GIR_EraseRootFromParent_Done,
     /*  861774 */   // Label 13202: @861774
     /*  861774 */   GIM_Try, /*On fail goto*//*Label 13203*/ GIMT_Encode4(861849), // Rule ID 24533 //
     /*  861779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  861790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  861793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  861796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  861814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861825 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  861828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861847 */     GIR_RootConstrainSelectedInstOperands,
     /*  861848 */     // GIR_Coverage, 24533,
     /*  861848 */     GIR_EraseRootFromParent_Done,
     /*  861849 */   // Label 13203: @861849
     /*  861849 */   GIM_Try, /*On fail goto*//*Label 13204*/ GIMT_Encode4(861924), // Rule ID 24536 //
     /*  861854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  861857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  861865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  861868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  861871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  861874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  861877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  861900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861922 */     GIR_RootConstrainSelectedInstOperands,
     /*  861923 */     // GIR_Coverage, 24536,
     /*  861923 */     GIR_EraseRootFromParent_Done,
     /*  861924 */   // Label 13204: @861924
     /*  861924 */   GIM_Try, /*On fail goto*//*Label 13205*/ GIMT_Encode4(861999), // Rule ID 24537 //
     /*  861929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  861932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  861937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  861940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  861943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  861946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  861949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  861952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  861964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  861968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  861975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  861975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  861978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  861980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  861982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  861984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  861986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  861991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  861994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  861997 */     GIR_RootConstrainSelectedInstOperands,
     /*  861998 */     // GIR_Coverage, 24537,
     /*  861998 */     GIR_EraseRootFromParent_Done,
     /*  861999 */   // Label 13205: @861999
     /*  861999 */   GIM_Try, /*On fail goto*//*Label 13206*/ GIMT_Encode4(862074), // Rule ID 24540 //
     /*  862004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  862050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862072 */     GIR_RootConstrainSelectedInstOperands,
     /*  862073 */     // GIR_Coverage, 24540,
     /*  862073 */     GIR_EraseRootFromParent_Done,
     /*  862074 */   // Label 13206: @862074
     /*  862074 */   GIM_Try, /*On fail goto*//*Label 13207*/ GIMT_Encode4(862149), // Rule ID 24541 //
     /*  862079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  862090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  862093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  862096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862125 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  862125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  862144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862147 */     GIR_RootConstrainSelectedInstOperands,
     /*  862148 */     // GIR_Coverage, 24541,
     /*  862148 */     GIR_EraseRootFromParent_Done,
     /*  862149 */   // Label 13207: @862149
     /*  862149 */   GIM_Try, /*On fail goto*//*Label 13208*/ GIMT_Encode4(862224), // Rule ID 24544 //
     /*  862154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862222 */     GIR_RootConstrainSelectedInstOperands,
     /*  862223 */     // GIR_Coverage, 24544,
     /*  862223 */     GIR_EraseRootFromParent_Done,
     /*  862224 */   // Label 13208: @862224
     /*  862224 */   GIM_Try, /*On fail goto*//*Label 13209*/ GIMT_Encode4(862299), // Rule ID 24545 //
     /*  862229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  862240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  862243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  862246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  862264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862275 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  862278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862297 */     GIR_RootConstrainSelectedInstOperands,
     /*  862298 */     // GIR_Coverage, 24545,
     /*  862298 */     GIR_EraseRootFromParent_Done,
     /*  862299 */   // Label 13209: @862299
     /*  862299 */   GIM_Try, /*On fail goto*//*Label 13210*/ GIMT_Encode4(862374), // Rule ID 24548 //
     /*  862304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862372 */     GIR_RootConstrainSelectedInstOperands,
     /*  862373 */     // GIR_Coverage, 24548,
     /*  862373 */     GIR_EraseRootFromParent_Done,
     /*  862374 */   // Label 13210: @862374
     /*  862374 */   GIM_Try, /*On fail goto*//*Label 13211*/ GIMT_Encode4(862449), // Rule ID 24549 //
     /*  862379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  862390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  862393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  862396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  862414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862425 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  862428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862447 */     GIR_RootConstrainSelectedInstOperands,
     /*  862448 */     // GIR_Coverage, 24549,
     /*  862448 */     GIR_EraseRootFromParent_Done,
     /*  862449 */   // Label 13211: @862449
     /*  862449 */   GIM_Try, /*On fail goto*//*Label 13212*/ GIMT_Encode4(862524), // Rule ID 24552 //
     /*  862454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  862457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  862465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  862468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  862471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  862474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862500 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  862500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862522 */     GIR_RootConstrainSelectedInstOperands,
     /*  862523 */     // GIR_Coverage, 24552,
     /*  862523 */     GIR_EraseRootFromParent_Done,
     /*  862524 */   // Label 13212: @862524
     /*  862524 */   GIM_Try, /*On fail goto*//*Label 13213*/ GIMT_Encode4(862599), // Rule ID 24553 //
     /*  862529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  862532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  862537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  862540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  862543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  862546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  862549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  862564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  862568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862575 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  862575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  862578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  862594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862597 */     GIR_RootConstrainSelectedInstOperands,
     /*  862598 */     // GIR_Coverage, 24553,
     /*  862598 */     GIR_EraseRootFromParent_Done,
     /*  862599 */   // Label 13213: @862599
     /*  862599 */   GIM_Try, /*On fail goto*//*Label 13214*/ GIMT_Encode4(862674), // Rule ID 24644 //
     /*  862604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  862615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  862618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  862621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  862624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862650 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  862653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862672 */     GIR_RootConstrainSelectedInstOperands,
     /*  862673 */     // GIR_Coverage, 24644,
     /*  862673 */     GIR_EraseRootFromParent_Done,
     /*  862674 */   // Label 13214: @862674
     /*  862674 */   GIM_Try, /*On fail goto*//*Label 13215*/ GIMT_Encode4(862749), // Rule ID 24645 //
     /*  862679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  862690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  862693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  862696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  862699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862725 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4),
     /*  862728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862747 */     GIR_RootConstrainSelectedInstOperands,
     /*  862748 */     // GIR_Coverage, 24645,
     /*  862748 */     GIR_EraseRootFromParent_Done,
     /*  862749 */   // Label 13215: @862749
     /*  862749 */   GIM_Try, /*On fail goto*//*Label 13216*/ GIMT_Encode4(862824), // Rule ID 24648 //
     /*  862754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  862765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  862768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  862771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  862774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  862803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862822 */     GIR_RootConstrainSelectedInstOperands,
     /*  862823 */     // GIR_Coverage, 24648,
     /*  862823 */     GIR_EraseRootFromParent_Done,
     /*  862824 */   // Label 13216: @862824
     /*  862824 */   GIM_Try, /*On fail goto*//*Label 13217*/ GIMT_Encode4(862899), // Rule ID 24649 //
     /*  862829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  862840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  862843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  862846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  862849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  862852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862875 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  862875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2),
     /*  862878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862897 */     GIR_RootConstrainSelectedInstOperands,
     /*  862898 */     // GIR_Coverage, 24649,
     /*  862898 */     GIR_EraseRootFromParent_Done,
     /*  862899 */   // Label 13217: @862899
     /*  862899 */   GIM_Try, /*On fail goto*//*Label 13218*/ GIMT_Encode4(862974), // Rule ID 24652 //
     /*  862904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  862907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  862915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  862918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  862921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  862924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  862927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  862943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  862950 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  862950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  862953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  862955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  862957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  862959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  862961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  862966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  862969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  862972 */     GIR_RootConstrainSelectedInstOperands,
     /*  862973 */     // GIR_Coverage, 24652,
     /*  862973 */     GIR_EraseRootFromParent_Done,
     /*  862974 */   // Label 13218: @862974
     /*  862974 */   GIM_Try, /*On fail goto*//*Label 13219*/ GIMT_Encode4(863049), // Rule ID 24653 //
     /*  862979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  862982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  862987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  862990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  862993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  862996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  862999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863025 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1),
     /*  863028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863047 */     GIR_RootConstrainSelectedInstOperands,
     /*  863048 */     // GIR_Coverage, 24653,
     /*  863048 */     GIR_EraseRootFromParent_Done,
     /*  863049 */   // Label 13219: @863049
     /*  863049 */   GIM_Try, /*On fail goto*//*Label 13220*/ GIMT_Encode4(863124), // Rule ID 24656 //
     /*  863054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863122 */     GIR_RootConstrainSelectedInstOperands,
     /*  863123 */     // GIR_Coverage, 24656,
     /*  863123 */     GIR_EraseRootFromParent_Done,
     /*  863124 */   // Label 13220: @863124
     /*  863124 */   GIM_Try, /*On fail goto*//*Label 13221*/ GIMT_Encode4(863199), // Rule ID 24657 //
     /*  863129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  863140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  863143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  863146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863175 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  863178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863197 */     GIR_RootConstrainSelectedInstOperands,
     /*  863198 */     // GIR_Coverage, 24657,
     /*  863198 */     GIR_EraseRootFromParent_Done,
     /*  863199 */   // Label 13221: @863199
     /*  863199 */   GIM_Try, /*On fail goto*//*Label 13222*/ GIMT_Encode4(863274), // Rule ID 24660 //
     /*  863204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863250 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863272 */     GIR_RootConstrainSelectedInstOperands,
     /*  863273 */     // GIR_Coverage, 24660,
     /*  863273 */     GIR_EraseRootFromParent_Done,
     /*  863274 */   // Label 13222: @863274
     /*  863274 */   GIM_Try, /*On fail goto*//*Label 13223*/ GIMT_Encode4(863349), // Rule ID 24661 //
     /*  863279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  863290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  863293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  863296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863325 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  863328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863347 */     GIR_RootConstrainSelectedInstOperands,
     /*  863348 */     // GIR_Coverage, 24661,
     /*  863348 */     GIR_EraseRootFromParent_Done,
     /*  863349 */   // Label 13223: @863349
     /*  863349 */   GIM_Try, /*On fail goto*//*Label 13224*/ GIMT_Encode4(863424), // Rule ID 24664 //
     /*  863354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863422 */     GIR_RootConstrainSelectedInstOperands,
     /*  863423 */     // GIR_Coverage, 24664,
     /*  863423 */     GIR_EraseRootFromParent_Done,
     /*  863424 */   // Label 13224: @863424
     /*  863424 */   GIM_Try, /*On fail goto*//*Label 13225*/ GIMT_Encode4(863499), // Rule ID 24665 //
     /*  863429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  863440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  863443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  863446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863475 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  863478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863497 */     GIR_RootConstrainSelectedInstOperands,
     /*  863498 */     // GIR_Coverage, 24665,
     /*  863498 */     GIR_EraseRootFromParent_Done,
     /*  863499 */   // Label 13225: @863499
     /*  863499 */   GIM_Try, /*On fail goto*//*Label 13226*/ GIMT_Encode4(863574), // Rule ID 24668 //
     /*  863504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  863515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  863518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  863521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  863524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863550 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  863550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  863553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863572 */     GIR_RootConstrainSelectedInstOperands,
     /*  863573 */     // GIR_Coverage, 24668,
     /*  863573 */     GIR_EraseRootFromParent_Done,
     /*  863574 */   // Label 13226: @863574
     /*  863574 */   GIM_Try, /*On fail goto*//*Label 13227*/ GIMT_Encode4(863649), // Rule ID 24669 //
     /*  863579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  863590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  863593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  863596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  863599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  863618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863625 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11454:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  863625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2),
     /*  863628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  863644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863647 */     GIR_RootConstrainSelectedInstOperands,
     /*  863648 */     // GIR_Coverage, 24669,
     /*  863648 */     GIR_EraseRootFromParent_Done,
     /*  863649 */   // Label 13227: @863649
     /*  863649 */   GIM_Try, /*On fail goto*//*Label 13228*/ GIMT_Encode4(863724), // Rule ID 24672 //
     /*  863654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  863665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  863668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  863671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  863700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  863703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863722 */     GIR_RootConstrainSelectedInstOperands,
     /*  863723 */     // GIR_Coverage, 24672,
     /*  863723 */     GIR_EraseRootFromParent_Done,
     /*  863724 */   // Label 13228: @863724
     /*  863724 */   GIM_Try, /*On fail goto*//*Label 13229*/ GIMT_Encode4(863799), // Rule ID 24673 //
     /*  863729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  863740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  863743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  863746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  863749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863775 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  863775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  863778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  863794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863797 */     GIR_RootConstrainSelectedInstOperands,
     /*  863798 */     // GIR_Coverage, 24673,
     /*  863798 */     GIR_EraseRootFromParent_Done,
     /*  863799 */   // Label 13229: @863799
     /*  863799 */   GIM_Try, /*On fail goto*//*Label 13230*/ GIMT_Encode4(863874), // Rule ID 24676 //
     /*  863804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  863807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  863815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  863818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  863821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863850 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  863850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  863853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863872 */     GIR_RootConstrainSelectedInstOperands,
     /*  863873 */     // GIR_Coverage, 24676,
     /*  863873 */     GIR_EraseRootFromParent_Done,
     /*  863874 */   // Label 13230: @863874
     /*  863874 */   GIM_Try, /*On fail goto*//*Label 13231*/ GIMT_Encode4(863949), // Rule ID 24677 //
     /*  863879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  863882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  863890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  863893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  863896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  863899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  863902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  863925 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  863925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  863928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  863930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  863932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  863934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  863936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  863941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  863944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  863947 */     GIR_RootConstrainSelectedInstOperands,
     /*  863948 */     // GIR_Coverage, 24677,
     /*  863948 */     GIR_EraseRootFromParent_Done,
     /*  863949 */   // Label 13231: @863949
     /*  863949 */   GIM_Try, /*On fail goto*//*Label 13232*/ GIMT_Encode4(864024), // Rule ID 24680 //
     /*  863954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  863957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  863962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  863965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  863968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  863971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  863974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  863977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  863993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  864000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864022 */     GIR_RootConstrainSelectedInstOperands,
     /*  864023 */     // GIR_Coverage, 24680,
     /*  864023 */     GIR_EraseRootFromParent_Done,
     /*  864024 */   // Label 13232: @864024
     /*  864024 */   GIM_Try, /*On fail goto*//*Label 13233*/ GIMT_Encode4(864099), // Rule ID 24681 //
     /*  864029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  864032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  864040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  864043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  864046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  864049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864075 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  864075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  864078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  864094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864097 */     GIR_RootConstrainSelectedInstOperands,
     /*  864098 */     // GIR_Coverage, 24681,
     /*  864098 */     GIR_EraseRootFromParent_Done,
     /*  864099 */   // Label 13233: @864099
     /*  864099 */   GIM_Try, /*On fail goto*//*Label 13234*/ GIMT_Encode4(864174), // Rule ID 24684 //
     /*  864104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864172 */     GIR_RootConstrainSelectedInstOperands,
     /*  864173 */     // GIR_Coverage, 24684,
     /*  864173 */     GIR_EraseRootFromParent_Done,
     /*  864174 */   // Label 13234: @864174
     /*  864174 */   GIM_Try, /*On fail goto*//*Label 13235*/ GIMT_Encode4(864249), // Rule ID 24685 //
     /*  864179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  864190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  864193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  864196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4),
     /*  864228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864247 */     GIR_RootConstrainSelectedInstOperands,
     /*  864248 */     // GIR_Coverage, 24685,
     /*  864248 */     GIR_EraseRootFromParent_Done,
     /*  864249 */   // Label 13235: @864249
     /*  864249 */   GIM_Try, /*On fail goto*//*Label 13236*/ GIMT_Encode4(864324), // Rule ID 24688 //
     /*  864254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864300 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  864300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864322 */     GIR_RootConstrainSelectedInstOperands,
     /*  864323 */     // GIR_Coverage, 24688,
     /*  864323 */     GIR_EraseRootFromParent_Done,
     /*  864324 */   // Label 13236: @864324
     /*  864324 */   GIM_Try, /*On fail goto*//*Label 13237*/ GIMT_Encode4(864399), // Rule ID 24689 //
     /*  864329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  864340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  864343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  864346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864375 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  864375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8),
     /*  864378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  864394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864397 */     GIR_RootConstrainSelectedInstOperands,
     /*  864398 */     // GIR_Coverage, 24689,
     /*  864398 */     GIR_EraseRootFromParent_Done,
     /*  864399 */   // Label 13237: @864399
     /*  864399 */   GIM_Try, /*On fail goto*//*Label 13238*/ GIMT_Encode4(864474), // Rule ID 24692 //
     /*  864404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  864415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  864418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  864421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  864453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864472 */     GIR_RootConstrainSelectedInstOperands,
     /*  864473 */     // GIR_Coverage, 24692,
     /*  864473 */     GIR_EraseRootFromParent_Done,
     /*  864474 */   // Label 13238: @864474
     /*  864474 */   GIM_Try, /*On fail goto*//*Label 13239*/ GIMT_Encode4(864549), // Rule ID 24693 //
     /*  864479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  864490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  864493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  864496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  864499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864525 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  864528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864547 */     GIR_RootConstrainSelectedInstOperands,
     /*  864548 */     // GIR_Coverage, 24693,
     /*  864548 */     GIR_EraseRootFromParent_Done,
     /*  864549 */   // Label 13239: @864549
     /*  864549 */   GIM_Try, /*On fail goto*//*Label 13240*/ GIMT_Encode4(864624), // Rule ID 24696 //
     /*  864554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  864565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  864568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  864571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864600 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  864603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864622 */     GIR_RootConstrainSelectedInstOperands,
     /*  864623 */     // GIR_Coverage, 24696,
     /*  864623 */     GIR_EraseRootFromParent_Done,
     /*  864624 */   // Label 13240: @864624
     /*  864624 */   GIM_Try, /*On fail goto*//*Label 13241*/ GIMT_Encode4(864699), // Rule ID 24697 //
     /*  864629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  864640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  864643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  864646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  864649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  864668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864675 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  864678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864697 */     GIR_RootConstrainSelectedInstOperands,
     /*  864698 */     // GIR_Coverage, 24697,
     /*  864698 */     GIR_EraseRootFromParent_Done,
     /*  864699 */   // Label 13241: @864699
     /*  864699 */   GIM_Try, /*On fail goto*//*Label 13242*/ GIMT_Encode4(864774), // Rule ID 24700 //
     /*  864704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  864715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  864718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  864721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864750 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  864750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  864753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864772 */     GIR_RootConstrainSelectedInstOperands,
     /*  864773 */     // GIR_Coverage, 24700,
     /*  864773 */     GIR_EraseRootFromParent_Done,
     /*  864774 */   // Label 13242: @864774
     /*  864774 */   GIM_Try, /*On fail goto*//*Label 13243*/ GIMT_Encode4(864849), // Rule ID 24701 //
     /*  864779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  864790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  864793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  864796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  864799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  864818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864825 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  864825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  864828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  864844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864847 */     GIR_RootConstrainSelectedInstOperands,
     /*  864848 */     // GIR_Coverage, 24701,
     /*  864848 */     GIR_EraseRootFromParent_Done,
     /*  864849 */   // Label 13243: @864849
     /*  864849 */   GIM_Try, /*On fail goto*//*Label 13244*/ GIMT_Encode4(864924), // Rule ID 24704 //
     /*  864854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  864857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  864865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  864868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  864871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  864877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  864900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  864903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864922 */     GIR_RootConstrainSelectedInstOperands,
     /*  864923 */     // GIR_Coverage, 24704,
     /*  864923 */     GIR_EraseRootFromParent_Done,
     /*  864924 */   // Label 13244: @864924
     /*  864924 */   GIM_Try, /*On fail goto*//*Label 13245*/ GIMT_Encode4(864999), // Rule ID 24705 //
     /*  864929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  864932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  864937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  864940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  864943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  864946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  864949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  864952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  864964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  864968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  864975 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  864975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  864978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  864980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  864982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  864984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  864986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  864991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  864994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  864997 */     GIR_RootConstrainSelectedInstOperands,
     /*  864998 */     // GIR_Coverage, 24705,
     /*  864998 */     GIR_EraseRootFromParent_Done,
     /*  864999 */   // Label 13245: @864999
     /*  864999 */   GIM_Try, /*On fail goto*//*Label 13246*/ GIMT_Encode4(865074), // Rule ID 24708 //
     /*  865004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865050 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865072 */     GIR_RootConstrainSelectedInstOperands,
     /*  865073 */     // GIR_Coverage, 24708,
     /*  865073 */     GIR_EraseRootFromParent_Done,
     /*  865074 */   // Label 13246: @865074
     /*  865074 */   GIM_Try, /*On fail goto*//*Label 13247*/ GIMT_Encode4(865149), // Rule ID 24709 //
     /*  865079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  865090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  865093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  865096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865125 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  865128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865147 */     GIR_RootConstrainSelectedInstOperands,
     /*  865148 */     // GIR_Coverage, 24709,
     /*  865148 */     GIR_EraseRootFromParent_Done,
     /*  865149 */   // Label 13247: @865149
     /*  865149 */   GIM_Try, /*On fail goto*//*Label 13248*/ GIMT_Encode4(865224), // Rule ID 24712 //
     /*  865154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  865157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865200 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865222 */     GIR_RootConstrainSelectedInstOperands,
     /*  865223 */     // GIR_Coverage, 24712,
     /*  865223 */     GIR_EraseRootFromParent_Done,
     /*  865224 */   // Label 13248: @865224
     /*  865224 */   GIM_Try, /*On fail goto*//*Label 13249*/ GIMT_Encode4(865299), // Rule ID 24713 //
     /*  865229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  865232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  865240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  865243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  865246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  865249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865275 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  865278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865297 */     GIR_RootConstrainSelectedInstOperands,
     /*  865298 */     // GIR_Coverage, 24713,
     /*  865298 */     GIR_EraseRootFromParent_Done,
     /*  865299 */   // Label 13249: @865299
     /*  865299 */   GIM_Try, /*On fail goto*//*Label 13250*/ GIMT_Encode4(865374), // Rule ID 24716 //
     /*  865304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865372 */     GIR_RootConstrainSelectedInstOperands,
     /*  865373 */     // GIR_Coverage, 24716,
     /*  865373 */     GIR_EraseRootFromParent_Done,
     /*  865374 */   // Label 13250: @865374
     /*  865374 */   GIM_Try, /*On fail goto*//*Label 13251*/ GIMT_Encode4(865449), // Rule ID 24717 //
     /*  865379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  865390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  865393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  865396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  865399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865425 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  865428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865447 */     GIR_RootConstrainSelectedInstOperands,
     /*  865448 */     // GIR_Coverage, 24717,
     /*  865448 */     GIR_EraseRootFromParent_Done,
     /*  865449 */   // Label 13251: @865449
     /*  865449 */   GIM_Try, /*On fail goto*//*Label 13252*/ GIMT_Encode4(865524), // Rule ID 24720 //
     /*  865454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  865465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  865468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  865471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865500 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  865503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865522 */     GIR_RootConstrainSelectedInstOperands,
     /*  865523 */     // GIR_Coverage, 24720,
     /*  865523 */     GIR_EraseRootFromParent_Done,
     /*  865524 */   // Label 13252: @865524
     /*  865524 */   GIM_Try, /*On fail goto*//*Label 13253*/ GIMT_Encode4(865599), // Rule ID 24721 //
     /*  865529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  865540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  865543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  865546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  865549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  865564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865575 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  865578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865597 */     GIR_RootConstrainSelectedInstOperands,
     /*  865598 */     // GIR_Coverage, 24721,
     /*  865598 */     GIR_EraseRootFromParent_Done,
     /*  865599 */   // Label 13253: @865599
     /*  865599 */   GIM_Try, /*On fail goto*//*Label 13254*/ GIMT_Encode4(865674), // Rule ID 24724 //
     /*  865604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  865607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  865615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  865618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  865621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865650 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  865650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  865653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865672 */     GIR_RootConstrainSelectedInstOperands,
     /*  865673 */     // GIR_Coverage, 24724,
     /*  865673 */     GIR_EraseRootFromParent_Done,
     /*  865674 */   // Label 13254: @865674
     /*  865674 */   GIM_Try, /*On fail goto*//*Label 13255*/ GIMT_Encode4(865749), // Rule ID 24725 //
     /*  865679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  865682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  865687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  865690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  865693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  865696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  865699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  865714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  865718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865725 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  865725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  865728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  865744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865747 */     GIR_RootConstrainSelectedInstOperands,
     /*  865748 */     // GIR_Coverage, 24725,
     /*  865748 */     GIR_EraseRootFromParent_Done,
     /*  865749 */   // Label 13255: @865749
     /*  865749 */   GIM_Try, /*On fail goto*//*Label 13256*/ GIMT_Encode4(865824), // Rule ID 24728 //
     /*  865754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  865757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  865762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  865765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  865768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  865771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  865774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865800 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  865803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865822 */     GIR_RootConstrainSelectedInstOperands,
     /*  865823 */     // GIR_Coverage, 24728,
     /*  865823 */     GIR_EraseRootFromParent_Done,
     /*  865824 */   // Label 13256: @865824
     /*  865824 */   GIM_Try, /*On fail goto*//*Label 13257*/ GIMT_Encode4(865899), // Rule ID 24729 //
     /*  865829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  865832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  865837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  865840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  865843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  865846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  865849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  865852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865875 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  865875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32),
     /*  865878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865897 */     GIR_RootConstrainSelectedInstOperands,
     /*  865898 */     // GIR_Coverage, 24729,
     /*  865898 */     GIR_EraseRootFromParent_Done,
     /*  865899 */   // Label 13257: @865899
     /*  865899 */   GIM_Try, /*On fail goto*//*Label 13258*/ GIMT_Encode4(865974), // Rule ID 24732 //
     /*  865904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  865907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  865912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  865915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  865918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  865921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  865924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  865927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  865943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  865950 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  865950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  865953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  865955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  865957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  865959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  865961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  865966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  865969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  865972 */     GIR_RootConstrainSelectedInstOperands,
     /*  865973 */     // GIR_Coverage, 24732,
     /*  865973 */     GIR_EraseRootFromParent_Done,
     /*  865974 */   // Label 13258: @865974
     /*  865974 */   GIM_Try, /*On fail goto*//*Label 13259*/ GIMT_Encode4(866049), // Rule ID 24733 //
     /*  865979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  865982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  865987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  865990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  865993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  865996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  865999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866025 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32),
     /*  866028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866047 */     GIR_RootConstrainSelectedInstOperands,
     /*  866048 */     // GIR_Coverage, 24733,
     /*  866048 */     GIR_EraseRootFromParent_Done,
     /*  866049 */   // Label 13259: @866049
     /*  866049 */   GIM_Try, /*On fail goto*//*Label 13260*/ GIMT_Encode4(866124), // Rule ID 24736 //
     /*  866054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  866057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  866065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  866068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  866071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  866074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866100 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  866103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866122 */     GIR_RootConstrainSelectedInstOperands,
     /*  866123 */     // GIR_Coverage, 24736,
     /*  866123 */     GIR_EraseRootFromParent_Done,
     /*  866124 */   // Label 13260: @866124
     /*  866124 */   GIM_Try, /*On fail goto*//*Label 13261*/ GIMT_Encode4(866199), // Rule ID 24737 //
     /*  866129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  866132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  866140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  866143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  866146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  866149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  866168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866175 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64),
     /*  866178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866197 */     GIR_RootConstrainSelectedInstOperands,
     /*  866198 */     // GIR_Coverage, 24737,
     /*  866198 */     GIR_EraseRootFromParent_Done,
     /*  866199 */   // Label 13261: @866199
     /*  866199 */   GIM_Try, /*On fail goto*//*Label 13262*/ GIMT_Encode4(866274), // Rule ID 24740 //
     /*  866204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  866207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  866224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  866253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866272 */     GIR_RootConstrainSelectedInstOperands,
     /*  866273 */     // GIR_Coverage, 24740,
     /*  866273 */     GIR_EraseRootFromParent_Done,
     /*  866274 */   // Label 13262: @866274
     /*  866274 */   GIM_Try, /*On fail goto*//*Label 13263*/ GIMT_Encode4(866349), // Rule ID 24741 //
     /*  866279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  866282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  866290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  866293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  866296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  866299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866325 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32),
     /*  866328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866347 */     GIR_RootConstrainSelectedInstOperands,
     /*  866348 */     // GIR_Coverage, 24741,
     /*  866348 */     GIR_EraseRootFromParent_Done,
     /*  866349 */   // Label 13263: @866349
     /*  866349 */   GIM_Try, /*On fail goto*//*Label 13264*/ GIMT_Encode4(866424), // Rule ID 24744 //
     /*  866354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  866357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  866374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866400 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  866403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866422 */     GIR_RootConstrainSelectedInstOperands,
     /*  866423 */     // GIR_Coverage, 24744,
     /*  866423 */     GIR_EraseRootFromParent_Done,
     /*  866424 */   // Label 13264: @866424
     /*  866424 */   GIM_Try, /*On fail goto*//*Label 13265*/ GIMT_Encode4(866499), // Rule ID 24745 //
     /*  866429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  866432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  866440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  866443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  866446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  866449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866475 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32),
     /*  866478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866497 */     GIR_RootConstrainSelectedInstOperands,
     /*  866498 */     // GIR_Coverage, 24745,
     /*  866498 */     GIR_EraseRootFromParent_Done,
     /*  866499 */   // Label 13265: @866499
     /*  866499 */   GIM_Try, /*On fail goto*//*Label 13266*/ GIMT_Encode4(866574), // Rule ID 24748 //
     /*  866504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  866507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  866524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866550 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  866550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  866553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866572 */     GIR_RootConstrainSelectedInstOperands,
     /*  866573 */     // GIR_Coverage, 24748,
     /*  866573 */     GIR_EraseRootFromParent_Done,
     /*  866574 */   // Label 13266: @866574
     /*  866574 */   GIM_Try, /*On fail goto*//*Label 13267*/ GIMT_Encode4(866649), // Rule ID 24749 //
     /*  866579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  866582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  866590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  866593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  866596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  866599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866625 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  866625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32),
     /*  866628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  866644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866647 */     GIR_RootConstrainSelectedInstOperands,
     /*  866648 */     // GIR_Coverage, 24749,
     /*  866648 */     GIR_EraseRootFromParent_Done,
     /*  866649 */   // Label 13267: @866649
     /*  866649 */   GIM_Try, /*On fail goto*//*Label 13268*/ GIMT_Encode4(866724), // Rule ID 24752 //
     /*  866654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  866657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  866674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866700 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  866703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866722 */     GIR_RootConstrainSelectedInstOperands,
     /*  866723 */     // GIR_Coverage, 24752,
     /*  866723 */     GIR_EraseRootFromParent_Done,
     /*  866724 */   // Label 13268: @866724
     /*  866724 */   GIM_Try, /*On fail goto*//*Label 13269*/ GIMT_Encode4(866799), // Rule ID 24753 //
     /*  866729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  866732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  866740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  866743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  866746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  866749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  866768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866775 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64),
     /*  866778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866797 */     GIR_RootConstrainSelectedInstOperands,
     /*  866798 */     // GIR_Coverage, 24753,
     /*  866798 */     GIR_EraseRootFromParent_Done,
     /*  866799 */   // Label 13269: @866799
     /*  866799 */   GIM_Try, /*On fail goto*//*Label 13270*/ GIMT_Encode4(866874), // Rule ID 24756 //
     /*  866804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  866807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  866824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866850 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  866850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  866853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866872 */     GIR_RootConstrainSelectedInstOperands,
     /*  866873 */     // GIR_Coverage, 24756,
     /*  866873 */     GIR_EraseRootFromParent_Done,
     /*  866874 */   // Label 13270: @866874
     /*  866874 */   GIM_Try, /*On fail goto*//*Label 13271*/ GIMT_Encode4(866949), // Rule ID 24757 //
     /*  866879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  866882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  866890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  866893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  866896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  866899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  866902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  866918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  866925 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  866925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64),
     /*  866928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  866930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  866932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  866934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  866936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  866941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  866944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  866947 */     GIR_RootConstrainSelectedInstOperands,
     /*  866948 */     // GIR_Coverage, 24757,
     /*  866948 */     GIR_EraseRootFromParent_Done,
     /*  866949 */   // Label 13271: @866949
     /*  866949 */   GIM_Try, /*On fail goto*//*Label 13272*/ GIMT_Encode4(867024), // Rule ID 24760 //
     /*  866954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  866957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  866962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  866965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  866968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  866971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  866974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  866977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  866993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867000 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  867003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867022 */     GIR_RootConstrainSelectedInstOperands,
     /*  867023 */     // GIR_Coverage, 24760,
     /*  867023 */     GIR_EraseRootFromParent_Done,
     /*  867024 */   // Label 13272: @867024
     /*  867024 */   GIM_Try, /*On fail goto*//*Label 13273*/ GIMT_Encode4(867099), // Rule ID 24761 //
     /*  867029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  867032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  867037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  867040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  867043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  867046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  867049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867075 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64),
     /*  867078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867097 */     GIR_RootConstrainSelectedInstOperands,
     /*  867098 */     // GIR_Coverage, 24761,
     /*  867098 */     GIR_EraseRootFromParent_Done,
     /*  867099 */   // Label 13273: @867099
     /*  867099 */   GIM_Try, /*On fail goto*//*Label 13274*/ GIMT_Encode4(867174), // Rule ID 24764 //
     /*  867104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867150 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  867153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867172 */     GIR_RootConstrainSelectedInstOperands,
     /*  867173 */     // GIR_Coverage, 24764,
     /*  867173 */     GIR_EraseRootFromParent_Done,
     /*  867174 */   // Label 13274: @867174
     /*  867174 */   GIM_Try, /*On fail goto*//*Label 13275*/ GIMT_Encode4(867249), // Rule ID 24765 //
     /*  867179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  867190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  867193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  867196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867225 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  867228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867247 */     GIR_RootConstrainSelectedInstOperands,
     /*  867248 */     // GIR_Coverage, 24765,
     /*  867248 */     GIR_EraseRootFromParent_Done,
     /*  867249 */   // Label 13275: @867249
     /*  867249 */   GIM_Try, /*On fail goto*//*Label 13276*/ GIMT_Encode4(867324), // Rule ID 24768 //
     /*  867254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867300 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  867303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867322 */     GIR_RootConstrainSelectedInstOperands,
     /*  867323 */     // GIR_Coverage, 24768,
     /*  867323 */     GIR_EraseRootFromParent_Done,
     /*  867324 */   // Label 13276: @867324
     /*  867324 */   GIM_Try, /*On fail goto*//*Label 13277*/ GIMT_Encode4(867399), // Rule ID 24769 //
     /*  867329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  867340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  867343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  867346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867375 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  867378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867397 */     GIR_RootConstrainSelectedInstOperands,
     /*  867398 */     // GIR_Coverage, 24769,
     /*  867398 */     GIR_EraseRootFromParent_Done,
     /*  867399 */   // Label 13277: @867399
     /*  867399 */   GIM_Try, /*On fail goto*//*Label 13278*/ GIMT_Encode4(867474), // Rule ID 24772 //
     /*  867404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  867407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  867450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  867453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867472 */     GIR_RootConstrainSelectedInstOperands,
     /*  867473 */     // GIR_Coverage, 24772,
     /*  867473 */     GIR_EraseRootFromParent_Done,
     /*  867474 */   // Label 13278: @867474
     /*  867474 */   GIM_Try, /*On fail goto*//*Label 13279*/ GIMT_Encode4(867549), // Rule ID 24773 //
     /*  867479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  867482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  867490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  867493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  867496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  867514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867525 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  867525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  867528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  867544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867547 */     GIR_RootConstrainSelectedInstOperands,
     /*  867548 */     // GIR_Coverage, 24773,
     /*  867548 */     GIR_EraseRootFromParent_Done,
     /*  867549 */   // Label 13279: @867549
     /*  867549 */   GIM_Try, /*On fail goto*//*Label 13280*/ GIMT_Encode4(867624), // Rule ID 24776 //
     /*  867554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867600 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  867603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867622 */     GIR_RootConstrainSelectedInstOperands,
     /*  867623 */     // GIR_Coverage, 24776,
     /*  867623 */     GIR_EraseRootFromParent_Done,
     /*  867624 */   // Label 13280: @867624
     /*  867624 */   GIM_Try, /*On fail goto*//*Label 13281*/ GIMT_Encode4(867699), // Rule ID 24777 //
     /*  867629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  867640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  867643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  867646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  867664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867675 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  867678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867697 */     GIR_RootConstrainSelectedInstOperands,
     /*  867698 */     // GIR_Coverage, 24777,
     /*  867698 */     GIR_EraseRootFromParent_Done,
     /*  867699 */   // Label 13281: @867699
     /*  867699 */   GIM_Try, /*On fail goto*//*Label 13282*/ GIMT_Encode4(867774), // Rule ID 24780 //
     /*  867704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867750 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  867753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867772 */     GIR_RootConstrainSelectedInstOperands,
     /*  867773 */     // GIR_Coverage, 24780,
     /*  867773 */     GIR_EraseRootFromParent_Done,
     /*  867774 */   // Label 13282: @867774
     /*  867774 */   GIM_Try, /*On fail goto*//*Label 13283*/ GIMT_Encode4(867849), // Rule ID 24781 //
     /*  867779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  867790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  867793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  867796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  867814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867825 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  867828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867847 */     GIR_RootConstrainSelectedInstOperands,
     /*  867848 */     // GIR_Coverage, 24781,
     /*  867848 */     GIR_EraseRootFromParent_Done,
     /*  867849 */   // Label 13283: @867849
     /*  867849 */   GIM_Try, /*On fail goto*//*Label 13284*/ GIMT_Encode4(867924), // Rule ID 24784 //
     /*  867854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  867857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  867865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  867868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  867871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  867874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  867877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867900 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  867900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  867903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867922 */     GIR_RootConstrainSelectedInstOperands,
     /*  867923 */     // GIR_Coverage, 24784,
     /*  867923 */     GIR_EraseRootFromParent_Done,
     /*  867924 */   // Label 13284: @867924
     /*  867924 */   GIM_Try, /*On fail goto*//*Label 13285*/ GIMT_Encode4(867999), // Rule ID 24785 //
     /*  867929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  867932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  867937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  867940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  867943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  867946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  867949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  867952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  867964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  867968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  867975 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  867975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  867978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  867980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  867982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  867984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  867986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  867991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  867994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  867997 */     GIR_RootConstrainSelectedInstOperands,
     /*  867998 */     // GIR_Coverage, 24785,
     /*  867998 */     GIR_EraseRootFromParent_Done,
     /*  867999 */   // Label 13285: @867999
     /*  867999 */   GIM_Try, /*On fail goto*//*Label 13286*/ GIMT_Encode4(868074), // Rule ID 24788 //
     /*  868004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868050 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  868053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868072 */     GIR_RootConstrainSelectedInstOperands,
     /*  868073 */     // GIR_Coverage, 24788,
     /*  868073 */     GIR_EraseRootFromParent_Done,
     /*  868074 */   // Label 13286: @868074
     /*  868074 */   GIM_Try, /*On fail goto*//*Label 13287*/ GIMT_Encode4(868149), // Rule ID 24789 //
     /*  868079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  868090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  868093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  868096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868125 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  868128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868147 */     GIR_RootConstrainSelectedInstOperands,
     /*  868148 */     // GIR_Coverage, 24789,
     /*  868148 */     GIR_EraseRootFromParent_Done,
     /*  868149 */   // Label 13287: @868149
     /*  868149 */   GIM_Try, /*On fail goto*//*Label 13288*/ GIMT_Encode4(868224), // Rule ID 24792 //
     /*  868154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868200 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  868203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868222 */     GIR_RootConstrainSelectedInstOperands,
     /*  868223 */     // GIR_Coverage, 24792,
     /*  868223 */     GIR_EraseRootFromParent_Done,
     /*  868224 */   // Label 13288: @868224
     /*  868224 */   GIM_Try, /*On fail goto*//*Label 13289*/ GIMT_Encode4(868299), // Rule ID 24793 //
     /*  868229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  868240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  868243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  868246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  868264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868275 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  868278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868297 */     GIR_RootConstrainSelectedInstOperands,
     /*  868298 */     // GIR_Coverage, 24793,
     /*  868298 */     GIR_EraseRootFromParent_Done,
     /*  868299 */   // Label 13289: @868299
     /*  868299 */   GIM_Try, /*On fail goto*//*Label 13290*/ GIMT_Encode4(868374), // Rule ID 24796 //
     /*  868304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  868307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  868324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868350 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  868350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  868353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868372 */     GIR_RootConstrainSelectedInstOperands,
     /*  868373 */     // GIR_Coverage, 24796,
     /*  868373 */     GIR_EraseRootFromParent_Done,
     /*  868374 */   // Label 13290: @868374
     /*  868374 */   GIM_Try, /*On fail goto*//*Label 13291*/ GIMT_Encode4(868449), // Rule ID 24797 //
     /*  868379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  868382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  868387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  868390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  868393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  868396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  868399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  868414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  868418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868425 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  868425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  868428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  868444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868447 */     GIR_RootConstrainSelectedInstOperands,
     /*  868448 */     // GIR_Coverage, 24797,
     /*  868448 */     GIR_EraseRootFromParent_Done,
     /*  868449 */   // Label 13291: @868449
     /*  868449 */   GIM_Try, /*On fail goto*//*Label 13292*/ GIMT_Encode4(868524), // Rule ID 24836 //
     /*  868454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868500 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  868503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868522 */     GIR_RootConstrainSelectedInstOperands,
     /*  868523 */     // GIR_Coverage, 24836,
     /*  868523 */     GIR_EraseRootFromParent_Done,
     /*  868524 */   // Label 13292: @868524
     /*  868524 */   GIM_Try, /*On fail goto*//*Label 13293*/ GIMT_Encode4(868599), // Rule ID 24837 //
     /*  868529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  868540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  868543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  868546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  868549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868575 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16),
     /*  868578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868597 */     GIR_RootConstrainSelectedInstOperands,
     /*  868598 */     // GIR_Coverage, 24837,
     /*  868598 */     GIR_EraseRootFromParent_Done,
     /*  868599 */   // Label 13293: @868599
     /*  868599 */   GIM_Try, /*On fail goto*//*Label 13294*/ GIMT_Encode4(868674), // Rule ID 24840 //
     /*  868604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868650 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  868653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868672 */     GIR_RootConstrainSelectedInstOperands,
     /*  868673 */     // GIR_Coverage, 24840,
     /*  868673 */     GIR_EraseRootFromParent_Done,
     /*  868674 */   // Label 13294: @868674
     /*  868674 */   GIM_Try, /*On fail goto*//*Label 13295*/ GIMT_Encode4(868749), // Rule ID 24841 //
     /*  868679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  868690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  868693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  868696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  868699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868725 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16),
     /*  868728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868747 */     GIR_RootConstrainSelectedInstOperands,
     /*  868748 */     // GIR_Coverage, 24841,
     /*  868748 */     GIR_EraseRootFromParent_Done,
     /*  868749 */   // Label 13295: @868749
     /*  868749 */   GIM_Try, /*On fail goto*//*Label 13296*/ GIMT_Encode4(868824), // Rule ID 24844 //
     /*  868754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  868803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868822 */     GIR_RootConstrainSelectedInstOperands,
     /*  868823 */     // GIR_Coverage, 24844,
     /*  868823 */     GIR_EraseRootFromParent_Done,
     /*  868824 */   // Label 13296: @868824
     /*  868824 */   GIM_Try, /*On fail goto*//*Label 13297*/ GIMT_Encode4(868899), // Rule ID 24845 //
     /*  868829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  868840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  868843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  868846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  868849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  868852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  868868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868875 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11450:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  868875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16),
     /*  868878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868897 */     GIR_RootConstrainSelectedInstOperands,
     /*  868898 */     // GIR_Coverage, 24845,
     /*  868898 */     GIR_EraseRootFromParent_Done,
     /*  868899 */   // Label 13297: @868899
     /*  868899 */   GIM_Try, /*On fail goto*//*Label 13298*/ GIMT_Encode4(868974), // Rule ID 24848 //
     /*  868904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  868907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  868927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  868943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  868950 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  868950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  868953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  868955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  868957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  868959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  868961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  868966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  868969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  868972 */     GIR_RootConstrainSelectedInstOperands,
     /*  868973 */     // GIR_Coverage, 24848,
     /*  868973 */     GIR_EraseRootFromParent_Done,
     /*  868974 */   // Label 13298: @868974
     /*  868974 */   GIM_Try, /*On fail goto*//*Label 13299*/ GIMT_Encode4(869049), // Rule ID 24849 //
     /*  868979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  868982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  868987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  868990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  868993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  868996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  868999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869025 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11450:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16),
     /*  869028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869047 */     GIR_RootConstrainSelectedInstOperands,
     /*  869048 */     // GIR_Coverage, 24849,
     /*  869048 */     GIR_EraseRootFromParent_Done,
     /*  869049 */   // Label 13299: @869049
     /*  869049 */   GIM_Try, /*On fail goto*//*Label 13300*/ GIMT_Encode4(869124), // Rule ID 24852 //
     /*  869054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  869062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869100 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  869103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869122 */     GIR_RootConstrainSelectedInstOperands,
     /*  869123 */     // GIR_Coverage, 24852,
     /*  869123 */     GIR_EraseRootFromParent_Done,
     /*  869124 */   // Label 13300: @869124
     /*  869124 */   GIM_Try, /*On fail goto*//*Label 13301*/ GIMT_Encode4(869199), // Rule ID 24853 //
     /*  869129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  869137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  869149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869175 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11450:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16),
     /*  869178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869197 */     GIR_RootConstrainSelectedInstOperands,
     /*  869198 */     // GIR_Coverage, 24853,
     /*  869198 */     GIR_EraseRootFromParent_Done,
     /*  869199 */   // Label 13301: @869199
     /*  869199 */   GIM_Try, /*On fail goto*//*Label 13302*/ GIMT_Encode4(869274), // Rule ID 24856 //
     /*  869204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  869212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  869253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869272 */     GIR_RootConstrainSelectedInstOperands,
     /*  869273 */     // GIR_Coverage, 24856,
     /*  869273 */     GIR_EraseRootFromParent_Done,
     /*  869274 */   // Label 13302: @869274
     /*  869274 */   GIM_Try, /*On fail goto*//*Label 13303*/ GIMT_Encode4(869349), // Rule ID 24857 //
     /*  869279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv),
     /*  869287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  869290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  869293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  869296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  869299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  869318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869325 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11450:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16),
     /*  869328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869347 */     GIR_RootConstrainSelectedInstOperands,
     /*  869348 */     // GIR_Coverage, 24857,
     /*  869348 */     GIR_EraseRootFromParent_Done,
     /*  869349 */   // Label 13303: @869349
     /*  869349 */   GIM_Try, /*On fail goto*//*Label 13304*/ GIMT_Encode4(869424), // Rule ID 24860 //
     /*  869354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  869365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  869368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869400 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869422 */     GIR_RootConstrainSelectedInstOperands,
     /*  869423 */     // GIR_Coverage, 24860,
     /*  869423 */     GIR_EraseRootFromParent_Done,
     /*  869424 */   // Label 13304: @869424
     /*  869424 */   GIM_Try, /*On fail goto*//*Label 13305*/ GIMT_Encode4(869499), // Rule ID 24861 //
     /*  869429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  869440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  869443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  869446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869475 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4),
     /*  869478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869497 */     GIR_RootConstrainSelectedInstOperands,
     /*  869498 */     // GIR_Coverage, 24861,
     /*  869498 */     GIR_EraseRootFromParent_Done,
     /*  869499 */   // Label 13305: @869499
     /*  869499 */   GIM_Try, /*On fail goto*//*Label 13306*/ GIMT_Encode4(869574), // Rule ID 24864 //
     /*  869504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869550 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869572 */     GIR_RootConstrainSelectedInstOperands,
     /*  869573 */     // GIR_Coverage, 24864,
     /*  869573 */     GIR_EraseRootFromParent_Done,
     /*  869574 */   // Label 13306: @869574
     /*  869574 */   GIM_Try, /*On fail goto*//*Label 13307*/ GIMT_Encode4(869649), // Rule ID 24865 //
     /*  869579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  869590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  869593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  869596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869625 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2),
     /*  869628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869647 */     GIR_RootConstrainSelectedInstOperands,
     /*  869648 */     // GIR_Coverage, 24865,
     /*  869648 */     GIR_EraseRootFromParent_Done,
     /*  869649 */   // Label 13307: @869649
     /*  869649 */   GIM_Try, /*On fail goto*//*Label 13308*/ GIMT_Encode4(869724), // Rule ID 24868 //
     /*  869654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869700 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869722 */     GIR_RootConstrainSelectedInstOperands,
     /*  869723 */     // GIR_Coverage, 24868,
     /*  869723 */     GIR_EraseRootFromParent_Done,
     /*  869724 */   // Label 13308: @869724
     /*  869724 */   GIM_Try, /*On fail goto*//*Label 13309*/ GIMT_Encode4(869799), // Rule ID 24869 //
     /*  869729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  869740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  869743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  869746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  869764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869775 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11452:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1),
     /*  869778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869797 */     GIR_RootConstrainSelectedInstOperands,
     /*  869798 */     // GIR_Coverage, 24869,
     /*  869798 */     GIR_EraseRootFromParent_Done,
     /*  869799 */   // Label 13309: @869799
     /*  869799 */   GIM_Try, /*On fail goto*//*Label 13310*/ GIMT_Encode4(869874), // Rule ID 24872 //
     /*  869804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869850 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  869850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869872 */     GIR_RootConstrainSelectedInstOperands,
     /*  869873 */     // GIR_Coverage, 24872,
     /*  869873 */     GIR_EraseRootFromParent_Done,
     /*  869874 */   // Label 13310: @869874
     /*  869874 */   GIM_Try, /*On fail goto*//*Label 13311*/ GIMT_Encode4(869949), // Rule ID 24873 //
     /*  869879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  869882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  869890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  869893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  869896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  869899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  869902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  869914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  869925 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11452:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  869925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2),
     /*  869928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  869930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  869932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  869934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  869936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  869941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  869944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  869947 */     GIR_RootConstrainSelectedInstOperands,
     /*  869948 */     // GIR_Coverage, 24873,
     /*  869948 */     GIR_EraseRootFromParent_Done,
     /*  869949 */   // Label 13311: @869949
     /*  869949 */   GIM_Try, /*On fail goto*//*Label 13312*/ GIMT_Encode4(870024), // Rule ID 24876 //
     /*  869954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  869957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  869962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  869965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  869968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  869971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  869974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  869977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  869989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  869993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870000 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870022 */     GIR_RootConstrainSelectedInstOperands,
     /*  870023 */     // GIR_Coverage, 24876,
     /*  870023 */     GIR_EraseRootFromParent_Done,
     /*  870024 */   // Label 13312: @870024
     /*  870024 */   GIM_Try, /*On fail goto*//*Label 13313*/ GIMT_Encode4(870099), // Rule ID 24877 //
     /*  870029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  870032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  870040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  870043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  870046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  870064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870075 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11452:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4),
     /*  870078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870097 */     GIR_RootConstrainSelectedInstOperands,
     /*  870098 */     // GIR_Coverage, 24877,
     /*  870098 */     GIR_EraseRootFromParent_Done,
     /*  870099 */   // Label 13313: @870099
     /*  870099 */   GIM_Try, /*On fail goto*//*Label 13314*/ GIMT_Encode4(870174), // Rule ID 24880 //
     /*  870104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  870107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  870124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870150 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870172 */     GIR_RootConstrainSelectedInstOperands,
     /*  870173 */     // GIR_Coverage, 24880,
     /*  870173 */     GIR_EraseRootFromParent_Done,
     /*  870174 */   // Label 13314: @870174
     /*  870174 */   GIM_Try, /*On fail goto*//*Label 13315*/ GIMT_Encode4(870249), // Rule ID 24881 //
     /*  870179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  870182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx),
     /*  870187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  870190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  870193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  870196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  870199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  870214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  870218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870225 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11452:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHER_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8),
     /*  870228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870247 */     GIR_RootConstrainSelectedInstOperands,
     /*  870248 */     // GIR_Coverage, 24881,
     /*  870248 */     GIR_EraseRootFromParent_Done,
     /*  870249 */   // Label 13315: @870249
     /*  870249 */   GIM_Try, /*On fail goto*//*Label 13316*/ GIMT_Encode4(870324), // Rule ID 24908 //
     /*  870254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  870257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870300 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870322 */     GIR_RootConstrainSelectedInstOperands,
     /*  870323 */     // GIR_Coverage, 24908,
     /*  870323 */     GIR_EraseRootFromParent_Done,
     /*  870324 */   // Label 13316: @870324
     /*  870324 */   GIM_Try, /*On fail goto*//*Label 13317*/ GIMT_Encode4(870399), // Rule ID 24909 //
     /*  870329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  870332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  870340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  870343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  870346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870375 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4),
     /*  870378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870397 */     GIR_RootConstrainSelectedInstOperands,
     /*  870398 */     // GIR_Coverage, 24909,
     /*  870398 */     GIR_EraseRootFromParent_Done,
     /*  870399 */   // Label 13317: @870399
     /*  870399 */   GIM_Try, /*On fail goto*//*Label 13318*/ GIMT_Encode4(870474), // Rule ID 24912 //
     /*  870404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  870407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  870415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  870418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  870453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870472 */     GIR_RootConstrainSelectedInstOperands,
     /*  870473 */     // GIR_Coverage, 24912,
     /*  870473 */     GIR_EraseRootFromParent_Done,
     /*  870474 */   // Label 13318: @870474
     /*  870474 */   GIM_Try, /*On fail goto*//*Label 13319*/ GIMT_Encode4(870549), // Rule ID 24913 //
     /*  870479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  870482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  870490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  870493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  870496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870525 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2),
     /*  870528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870547 */     GIR_RootConstrainSelectedInstOperands,
     /*  870548 */     // GIR_Coverage, 24913,
     /*  870548 */     GIR_EraseRootFromParent_Done,
     /*  870549 */   // Label 13319: @870549
     /*  870549 */   GIM_Try, /*On fail goto*//*Label 13320*/ GIMT_Encode4(870624), // Rule ID 24916 //
     /*  870554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  870557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  870603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870622 */     GIR_RootConstrainSelectedInstOperands,
     /*  870623 */     // GIR_Coverage, 24916,
     /*  870623 */     GIR_EraseRootFromParent_Done,
     /*  870624 */   // Label 13320: @870624
     /*  870624 */   GIM_Try, /*On fail goto*//*Label 13321*/ GIMT_Encode4(870699), // Rule ID 24917 //
     /*  870629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  870632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  870640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  870643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  870646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  870649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870675 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4),
     /*  870678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870697 */     GIR_RootConstrainSelectedInstOperands,
     /*  870698 */     // GIR_Coverage, 24917,
     /*  870698 */     GIR_EraseRootFromParent_Done,
     /*  870699 */   // Label 13321: @870699
     /*  870699 */   GIM_Try, /*On fail goto*//*Label 13322*/ GIMT_Encode4(870774), // Rule ID 24920 //
     /*  870704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  870707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  870715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  870718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  870721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  870724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  870750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  870753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870772 */     GIR_RootConstrainSelectedInstOperands,
     /*  870773 */     // GIR_Coverage, 24920,
     /*  870773 */     GIR_EraseRootFromParent_Done,
     /*  870774 */   // Label 13322: @870774
     /*  870774 */   GIM_Try, /*On fail goto*//*Label 13323*/ GIMT_Encode4(870849), // Rule ID 24921 //
     /*  870779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  870782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  870790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  870793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  870796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  870799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870825 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11454:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  870825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1),
     /*  870828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  870844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870847 */     GIR_RootConstrainSelectedInstOperands,
     /*  870848 */     // GIR_Coverage, 24921,
     /*  870848 */     GIR_EraseRootFromParent_Done,
     /*  870849 */   // Label 13323: @870849
     /*  870849 */   GIM_Try, /*On fail goto*//*Label 13324*/ GIMT_Encode4(870924), // Rule ID 24924 //
     /*  870854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  870857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  870877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  870900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  870903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870922 */     GIR_RootConstrainSelectedInstOperands,
     /*  870923 */     // GIR_Coverage, 24924,
     /*  870923 */     GIR_EraseRootFromParent_Done,
     /*  870924 */   // Label 13324: @870924
     /*  870924 */   GIM_Try, /*On fail goto*//*Label 13325*/ GIMT_Encode4(870999), // Rule ID 24925 //
     /*  870929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  870932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  870937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  870940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  870943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  870946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  870949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  870952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  870968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  870975 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11454:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  870975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2),
     /*  870978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  870980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  870982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  870984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  870986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  870991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  870994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  870997 */     GIR_RootConstrainSelectedInstOperands,
     /*  870998 */     // GIR_Coverage, 24925,
     /*  870998 */     GIR_EraseRootFromParent_Done,
     /*  870999 */   // Label 13325: @870999
     /*  870999 */   GIM_Try, /*On fail goto*//*Label 13326*/ GIMT_Encode4(871074), // Rule ID 24928 //
     /*  871004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  871007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871050 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  871050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871072 */     GIR_RootConstrainSelectedInstOperands,
     /*  871073 */     // GIR_Coverage, 24928,
     /*  871073 */     GIR_EraseRootFromParent_Done,
     /*  871074 */   // Label 13326: @871074
     /*  871074 */   GIM_Try, /*On fail goto*//*Label 13327*/ GIMT_Encode4(871149), // Rule ID 24929 //
     /*  871079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  871082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  871090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  871093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  871096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  871099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871125 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11454:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  871125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4),
     /*  871128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  871144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871147 */     GIR_RootConstrainSelectedInstOperands,
     /*  871148 */     // GIR_Coverage, 24929,
     /*  871148 */     GIR_EraseRootFromParent_Done,
     /*  871149 */   // Label 13327: @871149
     /*  871149 */   GIM_Try, /*On fail goto*//*Label 13328*/ GIMT_Encode4(871224), // Rule ID 24932 //
     /*  871154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  871157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871222 */     GIR_RootConstrainSelectedInstOperands,
     /*  871223 */     // GIR_Coverage, 24932,
     /*  871223 */     GIR_EraseRootFromParent_Done,
     /*  871224 */   // Label 13328: @871224
     /*  871224 */   GIM_Try, /*On fail goto*//*Label 13329*/ GIMT_Encode4(871299), // Rule ID 24933 //
     /*  871229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  871232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  871240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  871243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  871246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871275 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2),
     /*  871278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871297 */     GIR_RootConstrainSelectedInstOperands,
     /*  871298 */     // GIR_Coverage, 24933,
     /*  871298 */     GIR_EraseRootFromParent_Done,
     /*  871299 */   // Label 13329: @871299
     /*  871299 */   GIM_Try, /*On fail goto*//*Label 13330*/ GIMT_Encode4(871374), // Rule ID 24936 //
     /*  871304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  871307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871350 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871372 */     GIR_RootConstrainSelectedInstOperands,
     /*  871373 */     // GIR_Coverage, 24936,
     /*  871373 */     GIR_EraseRootFromParent_Done,
     /*  871374 */   // Label 13330: @871374
     /*  871374 */   GIM_Try, /*On fail goto*//*Label 13331*/ GIMT_Encode4(871449), // Rule ID 24937 //
     /*  871379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  871382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  871390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  871393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  871396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871425 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4),
     /*  871428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871447 */     GIR_RootConstrainSelectedInstOperands,
     /*  871448 */     // GIR_Coverage, 24937,
     /*  871448 */     GIR_EraseRootFromParent_Done,
     /*  871449 */   // Label 13331: @871449
     /*  871449 */   GIM_Try, /*On fail goto*//*Label 13332*/ GIMT_Encode4(871524), // Rule ID 24940 //
     /*  871454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  871457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  871465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  871468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  871471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  871474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871500 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  871500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  871503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871522 */     GIR_RootConstrainSelectedInstOperands,
     /*  871523 */     // GIR_Coverage, 24940,
     /*  871523 */     GIR_EraseRootFromParent_Done,
     /*  871524 */   // Label 13332: @871524
     /*  871524 */   GIM_Try, /*On fail goto*//*Label 13333*/ GIMT_Encode4(871599), // Rule ID 24941 //
     /*  871529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  871532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  871540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  871543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  871546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  871549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871575 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  871575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8),
     /*  871578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  871594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871597 */     GIR_RootConstrainSelectedInstOperands,
     /*  871598 */     // GIR_Coverage, 24941,
     /*  871598 */     GIR_EraseRootFromParent_Done,
     /*  871599 */   // Label 13333: @871599
     /*  871599 */   GIM_Try, /*On fail goto*//*Label 13334*/ GIMT_Encode4(871674), // Rule ID 24944 //
     /*  871604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  871607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871650 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  871653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871672 */     GIR_RootConstrainSelectedInstOperands,
     /*  871673 */     // GIR_Coverage, 24944,
     /*  871673 */     GIR_EraseRootFromParent_Done,
     /*  871674 */   // Label 13334: @871674
     /*  871674 */   GIM_Try, /*On fail goto*//*Label 13335*/ GIMT_Encode4(871749), // Rule ID 24945 //
     /*  871679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  871682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  871690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  871693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  871696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  871699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  871718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1),
     /*  871728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871747 */     GIR_RootConstrainSelectedInstOperands,
     /*  871748 */     // GIR_Coverage, 24945,
     /*  871748 */     GIR_EraseRootFromParent_Done,
     /*  871749 */   // Label 13335: @871749
     /*  871749 */   GIM_Try, /*On fail goto*//*Label 13336*/ GIMT_Encode4(871824), // Rule ID 24948 //
     /*  871754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  871757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  871765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  871768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  871771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871800 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  871803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871822 */     GIR_RootConstrainSelectedInstOperands,
     /*  871823 */     // GIR_Coverage, 24948,
     /*  871823 */     GIR_EraseRootFromParent_Done,
     /*  871824 */   // Label 13336: @871824
     /*  871824 */   GIM_Try, /*On fail goto*//*Label 13337*/ GIMT_Encode4(871899), // Rule ID 24949 //
     /*  871829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  871832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  871840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  871843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  871846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  871849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  871852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  871868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871875 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  871875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2),
     /*  871878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871897 */     GIR_RootConstrainSelectedInstOperands,
     /*  871898 */     // GIR_Coverage, 24949,
     /*  871898 */     GIR_EraseRootFromParent_Done,
     /*  871899 */   // Label 13337: @871899
     /*  871899 */   GIM_Try, /*On fail goto*//*Label 13338*/ GIMT_Encode4(871974), // Rule ID 24952 //
     /*  871904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /*  871907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  871915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  871918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  871921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  871927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  871939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  871943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  871950 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  871950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  871953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  871955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  871957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  871959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  871961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  871966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  871969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  871972 */     GIR_RootConstrainSelectedInstOperands,
     /*  871973 */     // GIR_Coverage, 24952,
     /*  871973 */     GIR_EraseRootFromParent_Done,
     /*  871974 */   // Label 13338: @871974
     /*  871974 */   GIM_Try, /*On fail goto*//*Label 13339*/ GIMT_Encode4(872049), // Rule ID 24953 //
     /*  871979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /*  871982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  871987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  871990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  871993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  871996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  871999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872025 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  872025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4),
     /*  872028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  872044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872047 */     GIR_RootConstrainSelectedInstOperands,
     /*  872048 */     // GIR_Coverage, 24953,
     /*  872048 */     GIR_EraseRootFromParent_Done,
     /*  872049 */   // Label 13339: @872049
     /*  872049 */   GIM_Try, /*On fail goto*//*Label 13340*/ GIMT_Encode4(872124), // Rule ID 24956 //
     /*  872054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872122 */     GIR_RootConstrainSelectedInstOperands,
     /*  872123 */     // GIR_Coverage, 24956,
     /*  872123 */     GIR_EraseRootFromParent_Done,
     /*  872124 */   // Label 13340: @872124
     /*  872124 */   GIM_Try, /*On fail goto*//*Label 13341*/ GIMT_Encode4(872199), // Rule ID 24957 //
     /*  872129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  872140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  872143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  872146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  872149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11454:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2),
     /*  872178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872197 */     GIR_RootConstrainSelectedInstOperands,
     /*  872198 */     // GIR_Coverage, 24957,
     /*  872198 */     GIR_EraseRootFromParent_Done,
     /*  872199 */   // Label 13341: @872199
     /*  872199 */   GIM_Try, /*On fail goto*//*Label 13342*/ GIMT_Encode4(872274), // Rule ID 24960 //
     /*  872204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872250 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872272 */     GIR_RootConstrainSelectedInstOperands,
     /*  872273 */     // GIR_Coverage, 24960,
     /*  872273 */     GIR_EraseRootFromParent_Done,
     /*  872274 */   // Label 13342: @872274
     /*  872274 */   GIM_Try, /*On fail goto*//*Label 13343*/ GIMT_Encode4(872349), // Rule ID 24961 //
     /*  872279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  872290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  872293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  872296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  872299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  872314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872325 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11454:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1),
     /*  872328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872347 */     GIR_RootConstrainSelectedInstOperands,
     /*  872348 */     // GIR_Coverage, 24961,
     /*  872348 */     GIR_EraseRootFromParent_Done,
     /*  872349 */   // Label 13343: @872349
     /*  872349 */   GIM_Try, /*On fail goto*//*Label 13344*/ GIMT_Encode4(872424), // Rule ID 24964 //
     /*  872354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /*  872357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872400 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  872400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872422 */     GIR_RootConstrainSelectedInstOperands,
     /*  872423 */     // GIR_Coverage, 24964,
     /*  872423 */     GIR_EraseRootFromParent_Done,
     /*  872424 */   // Label 13344: @872424
     /*  872424 */   GIM_Try, /*On fail goto*//*Label 13345*/ GIMT_Encode4(872499), // Rule ID 24965 //
     /*  872429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /*  872432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv),
     /*  872437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  872440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  872443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  872446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  872449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  872464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  872468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872475 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11454:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  872475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2),
     /*  872478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  872494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  872497 */     GIR_RootConstrainSelectedInstOperands,
     /*  872498 */     // GIR_Coverage, 24965,
     /*  872498 */     GIR_EraseRootFromParent_Done,
     /*  872499 */   // Label 13345: @872499
     /*  872499 */   GIM_Try, /*On fail goto*//*Label 13346*/ GIMT_Encode4(872571), // Rule ID 24968 //
     /*  872504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  872515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  872518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  872521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  872524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872550 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  872550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  872553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  872569 */     GIR_RootConstrainSelectedInstOperands,
     /*  872570 */     // GIR_Coverage, 24968,
     /*  872570 */     GIR_EraseRootFromParent_Done,
     /*  872571 */   // Label 13346: @872571
     /*  872571 */   GIM_Try, /*On fail goto*//*Label 13347*/ GIMT_Encode4(872643), // Rule ID 24969 //
     /*  872576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  872587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  872590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  872593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  872596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E8:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  872622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E8),
     /*  872625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  872641 */     GIR_RootConstrainSelectedInstOperands,
     /*  872642 */     // GIR_Coverage, 24969,
     /*  872642 */     GIR_EraseRootFromParent_Done,
     /*  872643 */   // Label 13347: @872643
     /*  872643 */   GIM_Try, /*On fail goto*//*Label 13348*/ GIMT_Encode4(872715), // Rule ID 24970 //
     /*  872648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  872659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  872662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  872665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  872668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872694 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  872694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  872697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  872713 */     GIR_RootConstrainSelectedInstOperands,
     /*  872714 */     // GIR_Coverage, 24970,
     /*  872714 */     GIR_EraseRootFromParent_Done,
     /*  872715 */   // Label 13348: @872715
     /*  872715 */   GIM_Try, /*On fail goto*//*Label 13349*/ GIMT_Encode4(872787), // Rule ID 24971 //
     /*  872720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  872731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  872734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  872737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  872740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E8:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  872766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E8),
     /*  872769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  872785 */     GIR_RootConstrainSelectedInstOperands,
     /*  872786 */     // GIR_Coverage, 24971,
     /*  872786 */     GIR_EraseRootFromParent_Done,
     /*  872787 */   // Label 13349: @872787
     /*  872787 */   GIM_Try, /*On fail goto*//*Label 13350*/ GIMT_Encode4(872859), // Rule ID 24972 //
     /*  872792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  872812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872838 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  872838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  872841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872857 */     GIR_RootConstrainSelectedInstOperands,
     /*  872858 */     // GIR_Coverage, 24972,
     /*  872858 */     GIR_EraseRootFromParent_Done,
     /*  872859 */   // Label 13350: @872859
     /*  872859 */   GIM_Try, /*On fail goto*//*Label 13351*/ GIMT_Encode4(872931), // Rule ID 24973 //
     /*  872864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  872867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  872875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  872878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  872881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  872884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  872887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  872910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  872913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  872929 */     GIR_RootConstrainSelectedInstOperands,
     /*  872930 */     // GIR_Coverage, 24973,
     /*  872930 */     GIR_EraseRootFromParent_Done,
     /*  872931 */   // Label 13351: @872931
     /*  872931 */   GIM_Try, /*On fail goto*//*Label 13352*/ GIMT_Encode4(873003), // Rule ID 24974 //
     /*  872936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  872939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  872944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  872947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  872950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  872953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  872956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  872959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  872975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  872982 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  872982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  872985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  872987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  872989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  872991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  872993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  872998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873001 */     GIR_RootConstrainSelectedInstOperands,
     /*  873002 */     // GIR_Coverage, 24974,
     /*  873002 */     GIR_EraseRootFromParent_Done,
     /*  873003 */   // Label 13352: @873003
     /*  873003 */   GIM_Try, /*On fail goto*//*Label 13353*/ GIMT_Encode4(873075), // Rule ID 24975 //
     /*  873008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  873019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  873022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  873025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  873057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873073 */     GIR_RootConstrainSelectedInstOperands,
     /*  873074 */     // GIR_Coverage, 24975,
     /*  873074 */     GIR_EraseRootFromParent_Done,
     /*  873075 */   // Label 13353: @873075
     /*  873075 */   GIM_Try, /*On fail goto*//*Label 13354*/ GIMT_Encode4(873147), // Rule ID 24976 //
     /*  873080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873126 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  873126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873145 */     GIR_RootConstrainSelectedInstOperands,
     /*  873146 */     // GIR_Coverage, 24976,
     /*  873146 */     GIR_EraseRootFromParent_Done,
     /*  873147 */   // Label 13354: @873147
     /*  873147 */   GIM_Try, /*On fail goto*//*Label 13355*/ GIMT_Encode4(873219), // Rule ID 24977 //
     /*  873152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  873163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  873166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  873169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873198 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  873198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  873201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873217 */     GIR_RootConstrainSelectedInstOperands,
     /*  873218 */     // GIR_Coverage, 24977,
     /*  873218 */     GIR_EraseRootFromParent_Done,
     /*  873219 */   // Label 13355: @873219
     /*  873219 */   GIM_Try, /*On fail goto*//*Label 13356*/ GIMT_Encode4(873291), // Rule ID 24978 //
     /*  873224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873270 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873289 */     GIR_RootConstrainSelectedInstOperands,
     /*  873290 */     // GIR_Coverage, 24978,
     /*  873290 */     GIR_EraseRootFromParent_Done,
     /*  873291 */   // Label 13356: @873291
     /*  873291 */   GIM_Try, /*On fail goto*//*Label 13357*/ GIMT_Encode4(873363), // Rule ID 24979 //
     /*  873296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  873307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  873310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  873313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  873316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873342 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11105:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E8:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E8),
     /*  873345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873361 */     GIR_RootConstrainSelectedInstOperands,
     /*  873362 */     // GIR_Coverage, 24979,
     /*  873362 */     GIR_EraseRootFromParent_Done,
     /*  873363 */   // Label 13357: @873363
     /*  873363 */   GIM_Try, /*On fail goto*//*Label 13358*/ GIMT_Encode4(873435), // Rule ID 24980 //
     /*  873368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  873414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  873417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873433 */     GIR_RootConstrainSelectedInstOperands,
     /*  873434 */     // GIR_Coverage, 24980,
     /*  873434 */     GIR_EraseRootFromParent_Done,
     /*  873435 */   // Label 13358: @873435
     /*  873435 */   GIM_Try, /*On fail goto*//*Label 13359*/ GIMT_Encode4(873507), // Rule ID 24981 //
     /*  873440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  873451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  873454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  873457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  873460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873486 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  873486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  873489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  873505 */     GIR_RootConstrainSelectedInstOperands,
     /*  873506 */     // GIR_Coverage, 24981,
     /*  873506 */     GIR_EraseRootFromParent_Done,
     /*  873507 */   // Label 13359: @873507
     /*  873507 */   GIM_Try, /*On fail goto*//*Label 13360*/ GIMT_Encode4(873579), // Rule ID 24982 //
     /*  873512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  873523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  873526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  873529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  873558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  873561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873577 */     GIR_RootConstrainSelectedInstOperands,
     /*  873578 */     // GIR_Coverage, 24982,
     /*  873578 */     GIR_EraseRootFromParent_Done,
     /*  873579 */   // Label 13360: @873579
     /*  873579 */   GIM_Try, /*On fail goto*//*Label 13361*/ GIMT_Encode4(873651), // Rule ID 24983 //
     /*  873584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  873595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  873598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  873601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  873604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  873630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  873633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  873649 */     GIR_RootConstrainSelectedInstOperands,
     /*  873650 */     // GIR_Coverage, 24983,
     /*  873650 */     GIR_EraseRootFromParent_Done,
     /*  873651 */   // Label 13361: @873651
     /*  873651 */   GIM_Try, /*On fail goto*//*Label 13362*/ GIMT_Encode4(873723), // Rule ID 24984 //
     /*  873656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  873659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  873667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  873670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  873673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  873702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  873705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873721 */     GIR_RootConstrainSelectedInstOperands,
     /*  873722 */     // GIR_Coverage, 24984,
     /*  873722 */     GIR_EraseRootFromParent_Done,
     /*  873723 */   // Label 13362: @873723
     /*  873723 */   GIM_Try, /*On fail goto*//*Label 13363*/ GIMT_Encode4(873795), // Rule ID 24985 //
     /*  873728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  873731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  873739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  873742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  873745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  873748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  873774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  873777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  873793 */     GIR_RootConstrainSelectedInstOperands,
     /*  873794 */     // GIR_Coverage, 24985,
     /*  873794 */     GIR_EraseRootFromParent_Done,
     /*  873795 */   // Label 13363: @873795
     /*  873795 */   GIM_Try, /*On fail goto*//*Label 13364*/ GIMT_Encode4(873867), // Rule ID 24986 //
     /*  873800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  873811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  873814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  873817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  873820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873846 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  873849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873865 */     GIR_RootConstrainSelectedInstOperands,
     /*  873866 */     // GIR_Coverage, 24986,
     /*  873866 */     GIR_EraseRootFromParent_Done,
     /*  873867 */   // Label 13364: @873867
     /*  873867 */   GIM_Try, /*On fail goto*//*Label 13365*/ GIMT_Encode4(873939), // Rule ID 24987 //
     /*  873872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  873875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  873883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  873886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  873889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  873892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  873895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  873907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E8:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  873918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E8),
     /*  873921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  873929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  873934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  873937 */     GIR_RootConstrainSelectedInstOperands,
     /*  873938 */     // GIR_Coverage, 24987,
     /*  873938 */     GIR_EraseRootFromParent_Done,
     /*  873939 */   // Label 13365: @873939
     /*  873939 */   GIM_Try, /*On fail goto*//*Label 13366*/ GIMT_Encode4(874011), // Rule ID 24988 //
     /*  873944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  873947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  873952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  873955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  873958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  873961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  873964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  873967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  873979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  873983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  873990 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  873990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  873993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  873995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  873997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  873999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874009 */     GIR_RootConstrainSelectedInstOperands,
     /*  874010 */     // GIR_Coverage, 24988,
     /*  874010 */     GIR_EraseRootFromParent_Done,
     /*  874011 */   // Label 13366: @874011
     /*  874011 */   GIM_Try, /*On fail goto*//*Label 13367*/ GIMT_Encode4(874083), // Rule ID 24989 //
     /*  874016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  874027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  874030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  874033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874062 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E8:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E8),
     /*  874065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874081 */     GIR_RootConstrainSelectedInstOperands,
     /*  874082 */     // GIR_Coverage, 24989,
     /*  874082 */     GIR_EraseRootFromParent_Done,
     /*  874083 */   // Label 13367: @874083
     /*  874083 */   GIM_Try, /*On fail goto*//*Label 13368*/ GIMT_Encode4(874155), // Rule ID 24990 //
     /*  874088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874134 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  874134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874153 */     GIR_RootConstrainSelectedInstOperands,
     /*  874154 */     // GIR_Coverage, 24990,
     /*  874154 */     GIR_EraseRootFromParent_Done,
     /*  874155 */   // Label 13368: @874155
     /*  874155 */   GIM_Try, /*On fail goto*//*Label 13369*/ GIMT_Encode4(874227), // Rule ID 24991 //
     /*  874160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  874171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  874174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  874177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /*  874180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874206 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv64i1] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  874206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E8),
     /*  874209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  874225 */     GIR_RootConstrainSelectedInstOperands,
     /*  874226 */     // GIR_Coverage, 24991,
     /*  874226 */     GIR_EraseRootFromParent_Done,
     /*  874227 */   // Label 13369: @874227
     /*  874227 */   GIM_Try, /*On fail goto*//*Label 13370*/ GIMT_Encode4(874299), // Rule ID 24992 //
     /*  874232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874297 */     GIR_RootConstrainSelectedInstOperands,
     /*  874298 */     // GIR_Coverage, 24992,
     /*  874298 */     GIR_EraseRootFromParent_Done,
     /*  874299 */   // Label 13370: @874299
     /*  874299 */   GIM_Try, /*On fail goto*//*Label 13371*/ GIMT_Encode4(874371), // Rule ID 24993 //
     /*  874304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  874315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  874318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  874321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  874353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874369 */     GIR_RootConstrainSelectedInstOperands,
     /*  874370 */     // GIR_Coverage, 24993,
     /*  874370 */     GIR_EraseRootFromParent_Done,
     /*  874371 */   // Label 13371: @874371
     /*  874371 */   GIM_Try, /*On fail goto*//*Label 13372*/ GIMT_Encode4(874443), // Rule ID 24994 //
     /*  874376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  874425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874441 */     GIR_RootConstrainSelectedInstOperands,
     /*  874442 */     // GIR_Coverage, 24994,
     /*  874442 */     GIR_EraseRootFromParent_Done,
     /*  874443 */   // Label 13372: @874443
     /*  874443 */   GIM_Try, /*On fail goto*//*Label 13373*/ GIMT_Encode4(874515), // Rule ID 24995 //
     /*  874448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  874459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  874462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  874465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874494 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  874497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874513 */     GIR_RootConstrainSelectedInstOperands,
     /*  874514 */     // GIR_Coverage, 24995,
     /*  874514 */     GIR_EraseRootFromParent_Done,
     /*  874515 */   // Label 13373: @874515
     /*  874515 */   GIM_Try, /*On fail goto*//*Label 13374*/ GIMT_Encode4(874587), // Rule ID 24996 //
     /*  874520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  874566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  874569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874585 */     GIR_RootConstrainSelectedInstOperands,
     /*  874586 */     // GIR_Coverage, 24996,
     /*  874586 */     GIR_EraseRootFromParent_Done,
     /*  874587 */   // Label 13374: @874587
     /*  874587 */   GIM_Try, /*On fail goto*//*Label 13375*/ GIMT_Encode4(874659), // Rule ID 24997 //
     /*  874592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  874603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  874606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  874609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  874612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  874638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  874641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  874657 */     GIR_RootConstrainSelectedInstOperands,
     /*  874658 */     // GIR_Coverage, 24997,
     /*  874658 */     GIR_EraseRootFromParent_Done,
     /*  874659 */   // Label 13375: @874659
     /*  874659 */   GIM_Try, /*On fail goto*//*Label 13376*/ GIMT_Encode4(874731), // Rule ID 24998 //
     /*  874664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  874675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  874678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  874681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874710 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  874713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874729 */     GIR_RootConstrainSelectedInstOperands,
     /*  874730 */     // GIR_Coverage, 24998,
     /*  874730 */     GIR_EraseRootFromParent_Done,
     /*  874731 */   // Label 13376: @874731
     /*  874731 */   GIM_Try, /*On fail goto*//*Label 13377*/ GIMT_Encode4(874803), // Rule ID 24999 //
     /*  874736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  874747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  874750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  874753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  874756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  874771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874782 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  874785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874801 */     GIR_RootConstrainSelectedInstOperands,
     /*  874802 */     // GIR_Coverage, 24999,
     /*  874802 */     GIR_EraseRootFromParent_Done,
     /*  874803 */   // Label 13377: @874803
     /*  874803 */   GIM_Try, /*On fail goto*//*Label 13378*/ GIMT_Encode4(874875), // Rule ID 25000 //
     /*  874808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  874819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  874822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  874825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874854 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  874857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874873 */     GIR_RootConstrainSelectedInstOperands,
     /*  874874 */     // GIR_Coverage, 25000,
     /*  874874 */     GIR_EraseRootFromParent_Done,
     /*  874875 */   // Label 13378: @874875
     /*  874875 */   GIM_Try, /*On fail goto*//*Label 13379*/ GIMT_Encode4(874947), // Rule ID 25001 //
     /*  874880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  874883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  874891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  874894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  874897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  874900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  874903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  874915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  874926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  874929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  874931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  874933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  874935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  874937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  874942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  874945 */     GIR_RootConstrainSelectedInstOperands,
     /*  874946 */     // GIR_Coverage, 25001,
     /*  874946 */     GIR_EraseRootFromParent_Done,
     /*  874947 */   // Label 13379: @874947
     /*  874947 */   GIM_Try, /*On fail goto*//*Label 13380*/ GIMT_Encode4(875019), // Rule ID 25002 //
     /*  874952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  874955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  874960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  874963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  874966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  874969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  874972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  874975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  874987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  874991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  874998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  874998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875017 */     GIR_RootConstrainSelectedInstOperands,
     /*  875018 */     // GIR_Coverage, 25002,
     /*  875018 */     GIR_EraseRootFromParent_Done,
     /*  875019 */   // Label 13380: @875019
     /*  875019 */   GIM_Try, /*On fail goto*//*Label 13381*/ GIMT_Encode4(875091), // Rule ID 25003 //
     /*  875024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  875027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  875035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  875038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  875041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  875044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875070 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  875073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875089 */     GIR_RootConstrainSelectedInstOperands,
     /*  875090 */     // GIR_Coverage, 25003,
     /*  875090 */     GIR_EraseRootFromParent_Done,
     /*  875091 */   // Label 13381: @875091
     /*  875091 */   GIM_Try, /*On fail goto*//*Label 13382*/ GIMT_Encode4(875163), // Rule ID 25004 //
     /*  875096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875142 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875161 */     GIR_RootConstrainSelectedInstOperands,
     /*  875162 */     // GIR_Coverage, 25004,
     /*  875162 */     GIR_EraseRootFromParent_Done,
     /*  875163 */   // Label 13382: @875163
     /*  875163 */   GIM_Try, /*On fail goto*//*Label 13383*/ GIMT_Encode4(875235), // Rule ID 25005 //
     /*  875168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  875179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  875182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  875185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  875217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875233 */     GIR_RootConstrainSelectedInstOperands,
     /*  875234 */     // GIR_Coverage, 25005,
     /*  875234 */     GIR_EraseRootFromParent_Done,
     /*  875235 */   // Label 13383: @875235
     /*  875235 */   GIM_Try, /*On fail goto*//*Label 13384*/ GIMT_Encode4(875307), // Rule ID 25006 //
     /*  875240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875305 */     GIR_RootConstrainSelectedInstOperands,
     /*  875306 */     // GIR_Coverage, 25006,
     /*  875306 */     GIR_EraseRootFromParent_Done,
     /*  875307 */   // Label 13384: @875307
     /*  875307 */   GIM_Try, /*On fail goto*//*Label 13385*/ GIMT_Encode4(875379), // Rule ID 25007 //
     /*  875312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  875323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  875326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  875329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  875347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875358 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  875361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875377 */     GIR_RootConstrainSelectedInstOperands,
     /*  875378 */     // GIR_Coverage, 25007,
     /*  875378 */     GIR_EraseRootFromParent_Done,
     /*  875379 */   // Label 13385: @875379
     /*  875379 */   GIM_Try, /*On fail goto*//*Label 13386*/ GIMT_Encode4(875451), // Rule ID 25008 //
     /*  875384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  875387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  875433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875449 */     GIR_RootConstrainSelectedInstOperands,
     /*  875450 */     // GIR_Coverage, 25008,
     /*  875450 */     GIR_EraseRootFromParent_Done,
     /*  875451 */   // Label 13386: @875451
     /*  875451 */   GIM_Try, /*On fail goto*//*Label 13387*/ GIMT_Encode4(875523), // Rule ID 25009 //
     /*  875456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  875459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  875467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  875470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  875473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  875476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  875491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  875505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875521 */     GIR_RootConstrainSelectedInstOperands,
     /*  875522 */     // GIR_Coverage, 25009,
     /*  875522 */     GIR_EraseRootFromParent_Done,
     /*  875523 */   // Label 13387: @875523
     /*  875523 */   GIM_Try, /*On fail goto*//*Label 13388*/ GIMT_Encode4(875595), // Rule ID 25010 //
     /*  875528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  875531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  875539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  875542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  875545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  875548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875574 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  875577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875593 */     GIR_RootConstrainSelectedInstOperands,
     /*  875594 */     // GIR_Coverage, 25010,
     /*  875594 */     GIR_EraseRootFromParent_Done,
     /*  875595 */   // Label 13388: @875595
     /*  875595 */   GIM_Try, /*On fail goto*//*Label 13389*/ GIMT_Encode4(875667), // Rule ID 25011 //
     /*  875600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  875603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  875611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  875614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  875617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  875620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E32),
     /*  875649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875665 */     GIR_RootConstrainSelectedInstOperands,
     /*  875666 */     // GIR_Coverage, 25011,
     /*  875666 */     GIR_EraseRootFromParent_Done,
     /*  875667 */   // Label 13389: @875667
     /*  875667 */   GIM_Try, /*On fail goto*//*Label 13390*/ GIMT_Encode4(875739), // Rule ID 25012 //
     /*  875672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  875675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875718 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  875718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  875721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875737 */     GIR_RootConstrainSelectedInstOperands,
     /*  875738 */     // GIR_Coverage, 25012,
     /*  875738 */     GIR_EraseRootFromParent_Done,
     /*  875739 */   // Label 13390: @875739
     /*  875739 */   GIM_Try, /*On fail goto*//*Label 13391*/ GIMT_Encode4(875811), // Rule ID 25013 //
     /*  875744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  875747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  875755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  875758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  875761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  875764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875790 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  875790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E32),
     /*  875793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  875809 */     GIR_RootConstrainSelectedInstOperands,
     /*  875810 */     // GIR_Coverage, 25013,
     /*  875810 */     GIR_EraseRootFromParent_Done,
     /*  875811 */   // Label 13391: @875811
     /*  875811 */   GIM_Try, /*On fail goto*//*Label 13392*/ GIMT_Encode4(875883), // Rule ID 25014 //
     /*  875816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  875819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  875836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875862 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  875862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  875865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875881 */     GIR_RootConstrainSelectedInstOperands,
     /*  875882 */     // GIR_Coverage, 25014,
     /*  875882 */     GIR_EraseRootFromParent_Done,
     /*  875883 */   // Label 13392: @875883
     /*  875883 */   GIM_Try, /*On fail goto*//*Label 13393*/ GIMT_Encode4(875955), // Rule ID 25015 //
     /*  875888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  875891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  875899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  875902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  875905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  875908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  875911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  875934 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  875934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E64),
     /*  875937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  875939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  875941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  875943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  875945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  875950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  875953 */     GIR_RootConstrainSelectedInstOperands,
     /*  875954 */     // GIR_Coverage, 25015,
     /*  875954 */     GIR_EraseRootFromParent_Done,
     /*  875955 */   // Label 13393: @875955
     /*  875955 */   GIM_Try, /*On fail goto*//*Label 13394*/ GIMT_Encode4(876027), // Rule ID 25016 //
     /*  875960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  875963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  875968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  875971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  875974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  875977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  875980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  875983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  875995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  875999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876006 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  876009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876025 */     GIR_RootConstrainSelectedInstOperands,
     /*  876026 */     // GIR_Coverage, 25016,
     /*  876026 */     GIR_EraseRootFromParent_Done,
     /*  876027 */   // Label 13394: @876027
     /*  876027 */   GIM_Try, /*On fail goto*//*Label 13395*/ GIMT_Encode4(876099), // Rule ID 25017 //
     /*  876032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  876035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  876043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  876046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  876049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876078 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E32),
     /*  876081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876097 */     GIR_RootConstrainSelectedInstOperands,
     /*  876098 */     // GIR_Coverage, 25017,
     /*  876098 */     GIR_EraseRootFromParent_Done,
     /*  876099 */   // Label 13395: @876099
     /*  876099 */   GIM_Try, /*On fail goto*//*Label 13396*/ GIMT_Encode4(876171), // Rule ID 25018 //
     /*  876104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  876107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876150 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  876153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876169 */     GIR_RootConstrainSelectedInstOperands,
     /*  876170 */     // GIR_Coverage, 25018,
     /*  876170 */     GIR_EraseRootFromParent_Done,
     /*  876171 */   // Label 13396: @876171
     /*  876171 */   GIM_Try, /*On fail goto*//*Label 13397*/ GIMT_Encode4(876243), // Rule ID 25019 //
     /*  876176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  876179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  876187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  876190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  876193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876222 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E32),
     /*  876225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876241 */     GIR_RootConstrainSelectedInstOperands,
     /*  876242 */     // GIR_Coverage, 25019,
     /*  876242 */     GIR_EraseRootFromParent_Done,
     /*  876243 */   // Label 13397: @876243
     /*  876243 */   GIM_Try, /*On fail goto*//*Label 13398*/ GIMT_Encode4(876315), // Rule ID 25020 //
     /*  876248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  876251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  876268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876294 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  876294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  876297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876313 */     GIR_RootConstrainSelectedInstOperands,
     /*  876314 */     // GIR_Coverage, 25020,
     /*  876314 */     GIR_EraseRootFromParent_Done,
     /*  876315 */   // Label 13398: @876315
     /*  876315 */   GIM_Try, /*On fail goto*//*Label 13399*/ GIMT_Encode4(876387), // Rule ID 25021 //
     /*  876320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  876323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  876331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  876334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  876337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  876340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876366 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  876366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E32),
     /*  876369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  876385 */     GIR_RootConstrainSelectedInstOperands,
     /*  876386 */     // GIR_Coverage, 25021,
     /*  876386 */     GIR_EraseRootFromParent_Done,
     /*  876387 */   // Label 13399: @876387
     /*  876387 */   GIM_Try, /*On fail goto*//*Label 13400*/ GIMT_Encode4(876459), // Rule ID 25022 //
     /*  876392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  876395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876457 */     GIR_RootConstrainSelectedInstOperands,
     /*  876458 */     // GIR_Coverage, 25022,
     /*  876458 */     GIR_EraseRootFromParent_Done,
     /*  876459 */   // Label 13400: @876459
     /*  876459 */   GIM_Try, /*On fail goto*//*Label 13401*/ GIMT_Encode4(876531), // Rule ID 25023 //
     /*  876464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  876467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  876475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  876478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  876481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  876499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876510 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E64),
     /*  876513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876529 */     GIR_RootConstrainSelectedInstOperands,
     /*  876530 */     // GIR_Coverage, 25023,
     /*  876530 */     GIR_EraseRootFromParent_Done,
     /*  876531 */   // Label 13401: @876531
     /*  876531 */   GIM_Try, /*On fail goto*//*Label 13402*/ GIMT_Encode4(876603), // Rule ID 25024 //
     /*  876536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  876539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876582 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876601 */     GIR_RootConstrainSelectedInstOperands,
     /*  876602 */     // GIR_Coverage, 25024,
     /*  876602 */     GIR_EraseRootFromParent_Done,
     /*  876603 */   // Label 13402: @876603
     /*  876603 */   GIM_Try, /*On fail goto*//*Label 13403*/ GIMT_Encode4(876675), // Rule ID 25025 //
     /*  876608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  876611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  876619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  876622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  876625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  876628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  876643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876654 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E64),
     /*  876657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876673 */     GIR_RootConstrainSelectedInstOperands,
     /*  876674 */     // GIR_Coverage, 25025,
     /*  876674 */     GIR_EraseRootFromParent_Done,
     /*  876675 */   // Label 13403: @876675
     /*  876675 */   GIM_Try, /*On fail goto*//*Label 13404*/ GIMT_Encode4(876747), // Rule ID 25026 //
     /*  876680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  876683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876726 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  876726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876745 */     GIR_RootConstrainSelectedInstOperands,
     /*  876746 */     // GIR_Coverage, 25026,
     /*  876746 */     GIR_EraseRootFromParent_Done,
     /*  876747 */   // Label 13404: @876747
     /*  876747 */   GIM_Try, /*On fail goto*//*Label 13405*/ GIMT_Encode4(876819), // Rule ID 25027 //
     /*  876752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  876755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  876763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  876766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  876769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  876772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  876787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876798 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  876798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E64),
     /*  876801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  876817 */     GIR_RootConstrainSelectedInstOperands,
     /*  876818 */     // GIR_Coverage, 25027,
     /*  876818 */     GIR_EraseRootFromParent_Done,
     /*  876819 */   // Label 13405: @876819
     /*  876819 */   GIM_Try, /*On fail goto*//*Label 13406*/ GIMT_Encode4(876891), // Rule ID 25028 //
     /*  876824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  876870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876889 */     GIR_RootConstrainSelectedInstOperands,
     /*  876890 */     // GIR_Coverage, 25028,
     /*  876890 */     GIR_EraseRootFromParent_Done,
     /*  876891 */   // Label 13406: @876891
     /*  876891 */   GIM_Try, /*On fail goto*//*Label 13407*/ GIMT_Encode4(876963), // Rule ID 25029 //
     /*  876896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  876899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  876907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  876910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  876913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  876916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  876919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  876942 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  876942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF4_E16),
     /*  876945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  876947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  876949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  876951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  876953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  876958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  876961 */     GIR_RootConstrainSelectedInstOperands,
     /*  876962 */     // GIR_Coverage, 25029,
     /*  876962 */     GIR_EraseRootFromParent_Done,
     /*  876963 */   // Label 13407: @876963
     /*  876963 */   GIM_Try, /*On fail goto*//*Label 13408*/ GIMT_Encode4(877035), // Rule ID 25030 //
     /*  876968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  876971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  876976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  876979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  876982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  876985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  876988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  876991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  876999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877033 */     GIR_RootConstrainSelectedInstOperands,
     /*  877034 */     // GIR_Coverage, 25030,
     /*  877034 */     GIR_EraseRootFromParent_Done,
     /*  877035 */   // Label 13408: @877035
     /*  877035 */   GIM_Try, /*On fail goto*//*Label 13409*/ GIMT_Encode4(877107), // Rule ID 25031 //
     /*  877040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  877054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  877057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  877060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877086 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_MF2_E16),
     /*  877089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877105 */     GIR_RootConstrainSelectedInstOperands,
     /*  877106 */     // GIR_Coverage, 25031,
     /*  877106 */     GIR_EraseRootFromParent_Done,
     /*  877107 */   // Label 13409: @877107
     /*  877107 */   GIM_Try, /*On fail goto*//*Label 13410*/ GIMT_Encode4(877179), // Rule ID 25032 //
     /*  877112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877158 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877177 */     GIR_RootConstrainSelectedInstOperands,
     /*  877178 */     // GIR_Coverage, 25032,
     /*  877178 */     GIR_EraseRootFromParent_Done,
     /*  877179 */   // Label 13410: @877179
     /*  877179 */   GIM_Try, /*On fail goto*//*Label 13411*/ GIMT_Encode4(877251), // Rule ID 25033 //
     /*  877184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  877195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  877198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  877201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  877204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877230 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11105:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M1_E16),
     /*  877233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877249 */     GIR_RootConstrainSelectedInstOperands,
     /*  877250 */     // GIR_Coverage, 25033,
     /*  877250 */     GIR_EraseRootFromParent_Done,
     /*  877251 */   // Label 13411: @877251
     /*  877251 */   GIM_Try, /*On fail goto*//*Label 13412*/ GIMT_Encode4(877323), // Rule ID 25034 //
     /*  877256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877321 */     GIR_RootConstrainSelectedInstOperands,
     /*  877322 */     // GIR_Coverage, 25034,
     /*  877322 */     GIR_EraseRootFromParent_Done,
     /*  877323 */   // Label 13412: @877323
     /*  877323 */   GIM_Try, /*On fail goto*//*Label 13413*/ GIMT_Encode4(877395), // Rule ID 25035 //
     /*  877328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  877339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  877342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  877345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  877348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  877363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877374 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11105:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv8i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M2_E16),
     /*  877377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877393 */     GIR_RootConstrainSelectedInstOperands,
     /*  877394 */     // GIR_Coverage, 25035,
     /*  877394 */     GIR_EraseRootFromParent_Done,
     /*  877395 */   // Label 13413: @877395
     /*  877395 */   GIM_Try, /*On fail goto*//*Label 13414*/ GIMT_Encode4(877467), // Rule ID 25036 //
     /*  877400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877446 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877465 */     GIR_RootConstrainSelectedInstOperands,
     /*  877466 */     // GIR_Coverage, 25036,
     /*  877466 */     GIR_EraseRootFromParent_Done,
     /*  877467 */   // Label 13414: @877467
     /*  877467 */   GIM_Try, /*On fail goto*//*Label 13415*/ GIMT_Encode4(877539), // Rule ID 25037 //
     /*  877472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  877483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  877486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  877489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  877492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  877507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877518 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11105:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv16i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M4_E16),
     /*  877521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877537 */     GIR_RootConstrainSelectedInstOperands,
     /*  877538 */     // GIR_Coverage, 25037,
     /*  877538 */     GIR_EraseRootFromParent_Done,
     /*  877539 */   // Label 13415: @877539
     /*  877539 */   GIM_Try, /*On fail goto*//*Label 13416*/ GIMT_Encode4(877611), // Rule ID 25038 //
     /*  877544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /*  877547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877590 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  877590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877609 */     GIR_RootConstrainSelectedInstOperands,
     /*  877610 */     // GIR_Coverage, 25038,
     /*  877610 */     GIR_EraseRootFromParent_Done,
     /*  877611 */   // Label 13416: @877611
     /*  877611 */   GIM_Try, /*On fail goto*//*Label 13417*/ GIMT_Encode4(877683), // Rule ID 25039 //
     /*  877616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /*  877619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcompress),
     /*  877624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  877627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  877630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  877633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  877636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  877651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877662 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11105:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCOMPRESS_VM_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv32i1] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  877662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCOMPRESS_VM_M8_E16),
     /*  877665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  877681 */     GIR_RootConstrainSelectedInstOperands,
     /*  877682 */     // GIR_Coverage, 25039,
     /*  877682 */     GIR_EraseRootFromParent_Done,
     /*  877683 */   // Label 13417: @877683
     /*  877683 */   GIM_Try, /*On fail goto*//*Label 13418*/ GIMT_Encode4(877758), // Rule ID 60486 //
     /*  877688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  877691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  877696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  877708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  877734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  877737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  877756 */     GIR_RootConstrainSelectedInstOperands,
     /*  877757 */     // GIR_Coverage, 60486,
     /*  877757 */     GIR_EraseRootFromParent_Done,
     /*  877758 */   // Label 13418: @877758
     /*  877758 */   GIM_Try, /*On fail goto*//*Label 13419*/ GIMT_Encode4(877833), // Rule ID 60487 //
     /*  877763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  877766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  877771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  877774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  877777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  877780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  877783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  877809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_MF2),
     /*  877812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  877828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  877831 */     GIR_RootConstrainSelectedInstOperands,
     /*  877832 */     // GIR_Coverage, 60487,
     /*  877832 */     GIR_EraseRootFromParent_Done,
     /*  877833 */   // Label 13419: @877833
     /*  877833 */   GIM_Try, /*On fail goto*//*Label 13420*/ GIMT_Encode4(877908), // Rule ID 60844 //
     /*  877838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  877841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  877846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  877855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  877858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  877861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877884 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  877884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  877887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  877906 */     GIR_RootConstrainSelectedInstOperands,
     /*  877907 */     // GIR_Coverage, 60844,
     /*  877907 */     GIR_EraseRootFromParent_Done,
     /*  877908 */   // Label 13420: @877908
     /*  877908 */   GIM_Try, /*On fail goto*//*Label 13421*/ GIMT_Encode4(877983), // Rule ID 60845 //
     /*  877913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  877916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  877921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  877924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  877927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  877930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  877933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  877936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  877952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  877959 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  877959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /*  877962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  877964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  877966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  877968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  877970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  877975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  877978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  877981 */     GIR_RootConstrainSelectedInstOperands,
     /*  877982 */     // GIR_Coverage, 60845,
     /*  877982 */     GIR_EraseRootFromParent_Done,
     /*  877983 */   // Label 13421: @877983
     /*  877983 */   GIM_Try, /*On fail goto*//*Label 13422*/ GIMT_Encode4(878058), // Rule ID 60848 //
     /*  877988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  877991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  877996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  877999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878056 */     GIR_RootConstrainSelectedInstOperands,
     /*  878057 */     // GIR_Coverage, 60848,
     /*  878057 */     GIR_EraseRootFromParent_Done,
     /*  878058 */   // Label 13422: @878058
     /*  878058 */   GIM_Try, /*On fail goto*//*Label 13423*/ GIMT_Encode4(878133), // Rule ID 60849 //
     /*  878063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  878074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  878077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  878080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  878083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878109 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878131 */     GIR_RootConstrainSelectedInstOperands,
     /*  878132 */     // GIR_Coverage, 60849,
     /*  878132 */     GIR_EraseRootFromParent_Done,
     /*  878133 */   // Label 13423: @878133
     /*  878133 */   GIM_Try, /*On fail goto*//*Label 13424*/ GIMT_Encode4(878208), // Rule ID 60852 //
     /*  878138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878206 */     GIR_RootConstrainSelectedInstOperands,
     /*  878207 */     // GIR_Coverage, 60852,
     /*  878207 */     GIR_EraseRootFromParent_Done,
     /*  878208 */   // Label 13424: @878208
     /*  878208 */   GIM_Try, /*On fail goto*//*Label 13425*/ GIMT_Encode4(878283), // Rule ID 60853 //
     /*  878213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  878224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  878227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  878230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  878233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878259 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878281 */     GIR_RootConstrainSelectedInstOperands,
     /*  878282 */     // GIR_Coverage, 60853,
     /*  878282 */     GIR_EraseRootFromParent_Done,
     /*  878283 */   // Label 13425: @878283
     /*  878283 */   GIM_Try, /*On fail goto*//*Label 13426*/ GIMT_Encode4(878358), // Rule ID 60856 //
     /*  878288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878356 */     GIR_RootConstrainSelectedInstOperands,
     /*  878357 */     // GIR_Coverage, 60856,
     /*  878357 */     GIR_EraseRootFromParent_Done,
     /*  878358 */   // Label 13426: @878358
     /*  878358 */   GIM_Try, /*On fail goto*//*Label 13427*/ GIMT_Encode4(878433), // Rule ID 60857 //
     /*  878363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  878374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  878377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  878380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  878383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  878412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878431 */     GIR_RootConstrainSelectedInstOperands,
     /*  878432 */     // GIR_Coverage, 60857,
     /*  878432 */     GIR_EraseRootFromParent_Done,
     /*  878433 */   // Label 13427: @878433
     /*  878433 */   GIM_Try, /*On fail goto*//*Label 13428*/ GIMT_Encode4(878508), // Rule ID 60860 //
     /*  878438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  878458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  878487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878506 */     GIR_RootConstrainSelectedInstOperands,
     /*  878507 */     // GIR_Coverage, 60860,
     /*  878507 */     GIR_EraseRootFromParent_Done,
     /*  878508 */   // Label 13428: @878508
     /*  878508 */   GIM_Try, /*On fail goto*//*Label 13429*/ GIMT_Encode4(878583), // Rule ID 60861 //
     /*  878513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  878524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  878527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  878530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  878533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  878552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878559 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  878562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878581 */     GIR_RootConstrainSelectedInstOperands,
     /*  878582 */     // GIR_Coverage, 60861,
     /*  878582 */     GIR_EraseRootFromParent_Done,
     /*  878583 */   // Label 13429: @878583
     /*  878583 */   GIM_Try, /*On fail goto*//*Label 13430*/ GIMT_Encode4(878658), // Rule ID 60864 //
     /*  878588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  878608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  878634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  878637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878656 */     GIR_RootConstrainSelectedInstOperands,
     /*  878657 */     // GIR_Coverage, 60864,
     /*  878657 */     GIR_EraseRootFromParent_Done,
     /*  878658 */   // Label 13430: @878658
     /*  878658 */   GIM_Try, /*On fail goto*//*Label 13431*/ GIMT_Encode4(878733), // Rule ID 60865 //
     /*  878663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  878674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  878677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  878680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  878683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  878694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  878702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  878709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  878712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  878728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878731 */     GIR_RootConstrainSelectedInstOperands,
     /*  878732 */     // GIR_Coverage, 60865,
     /*  878732 */     GIR_EraseRootFromParent_Done,
     /*  878733 */   // Label 13431: @878733
     /*  878733 */   GIM_Try, /*On fail goto*//*Label 13432*/ GIMT_Encode4(878808), // Rule ID 60868 //
     /*  878738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  878755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  878758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  878784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878806 */     GIR_RootConstrainSelectedInstOperands,
     /*  878807 */     // GIR_Coverage, 60868,
     /*  878807 */     GIR_EraseRootFromParent_Done,
     /*  878808 */   // Label 13432: @878808
     /*  878808 */   GIM_Try, /*On fail goto*//*Label 13433*/ GIMT_Encode4(878883), // Rule ID 60869 //
     /*  878813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  878824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  878827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  878830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  878833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  878859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /*  878862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878881 */     GIR_RootConstrainSelectedInstOperands,
     /*  878882 */     // GIR_Coverage, 60869,
     /*  878882 */     GIR_EraseRootFromParent_Done,
     /*  878883 */   // Label 13433: @878883
     /*  878883 */   GIM_Try, /*On fail goto*//*Label 13434*/ GIMT_Encode4(878958), // Rule ID 60872 //
     /*  878888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  878891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  878899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  878902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  878905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  878908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  878911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  878934 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  878934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  878937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  878939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  878941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  878943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  878945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  878950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  878953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  878956 */     GIR_RootConstrainSelectedInstOperands,
     /*  878957 */     // GIR_Coverage, 60872,
     /*  878957 */     GIR_EraseRootFromParent_Done,
     /*  878958 */   // Label 13434: @878958
     /*  878958 */   GIM_Try, /*On fail goto*//*Label 13435*/ GIMT_Encode4(879033), // Rule ID 60873 //
     /*  878963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  878966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  878971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  878974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  878977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  878980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  878983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  878986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  878998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879009 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879031 */     GIR_RootConstrainSelectedInstOperands,
     /*  879032 */     // GIR_Coverage, 60873,
     /*  879032 */     GIR_EraseRootFromParent_Done,
     /*  879033 */   // Label 13435: @879033
     /*  879033 */   GIM_Try, /*On fail goto*//*Label 13436*/ GIMT_Encode4(879108), // Rule ID 60876 //
     /*  879038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879106 */     GIR_RootConstrainSelectedInstOperands,
     /*  879107 */     // GIR_Coverage, 60876,
     /*  879107 */     GIR_EraseRootFromParent_Done,
     /*  879108 */   // Label 13436: @879108
     /*  879108 */   GIM_Try, /*On fail goto*//*Label 13437*/ GIMT_Encode4(879183), // Rule ID 60877 //
     /*  879113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  879124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  879127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  879130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  879133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879181 */     GIR_RootConstrainSelectedInstOperands,
     /*  879182 */     // GIR_Coverage, 60877,
     /*  879182 */     GIR_EraseRootFromParent_Done,
     /*  879183 */   // Label 13437: @879183
     /*  879183 */   GIM_Try, /*On fail goto*//*Label 13438*/ GIMT_Encode4(879258), // Rule ID 60880 //
     /*  879188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879256 */     GIR_RootConstrainSelectedInstOperands,
     /*  879257 */     // GIR_Coverage, 60880,
     /*  879257 */     GIR_EraseRootFromParent_Done,
     /*  879258 */   // Label 13438: @879258
     /*  879258 */   GIM_Try, /*On fail goto*//*Label 13439*/ GIMT_Encode4(879333), // Rule ID 60881 //
     /*  879263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  879274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  879277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  879280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  879283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879331 */     GIR_RootConstrainSelectedInstOperands,
     /*  879332 */     // GIR_Coverage, 60881,
     /*  879332 */     GIR_EraseRootFromParent_Done,
     /*  879333 */   // Label 13439: @879333
     /*  879333 */   GIM_Try, /*On fail goto*//*Label 13440*/ GIMT_Encode4(879408), // Rule ID 60884 //
     /*  879338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  879384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879406 */     GIR_RootConstrainSelectedInstOperands,
     /*  879407 */     // GIR_Coverage, 60884,
     /*  879407 */     GIR_EraseRootFromParent_Done,
     /*  879408 */   // Label 13440: @879408
     /*  879408 */   GIM_Try, /*On fail goto*//*Label 13441*/ GIMT_Encode4(879483), // Rule ID 60885 //
     /*  879413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  879424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  879427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  879430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  879433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  879459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  879478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879481 */     GIR_RootConstrainSelectedInstOperands,
     /*  879482 */     // GIR_Coverage, 60885,
     /*  879482 */     GIR_EraseRootFromParent_Done,
     /*  879483 */   // Label 13441: @879483
     /*  879483 */   GIM_Try, /*On fail goto*//*Label 13442*/ GIMT_Encode4(879558), // Rule ID 60888 //
     /*  879488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  879499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  879502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  879508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879534 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  879534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879556 */     GIR_RootConstrainSelectedInstOperands,
     /*  879557 */     // GIR_Coverage, 60888,
     /*  879557 */     GIR_EraseRootFromParent_Done,
     /*  879558 */   // Label 13442: @879558
     /*  879558 */   GIM_Try, /*On fail goto*//*Label 13443*/ GIMT_Encode4(879633), // Rule ID 60889 //
     /*  879563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  879574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  879577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  879580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  879583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  879609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /*  879612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879631 */     GIR_RootConstrainSelectedInstOperands,
     /*  879632 */     // GIR_Coverage, 60889,
     /*  879632 */     GIR_EraseRootFromParent_Done,
     /*  879633 */   // Label 13443: @879633
     /*  879633 */   GIM_Try, /*On fail goto*//*Label 13444*/ GIMT_Encode4(879708), // Rule ID 60892 //
     /*  879638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  879655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  879658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  879684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879706 */     GIR_RootConstrainSelectedInstOperands,
     /*  879707 */     // GIR_Coverage, 60892,
     /*  879707 */     GIR_EraseRootFromParent_Done,
     /*  879708 */   // Label 13444: @879708
     /*  879708 */   GIM_Try, /*On fail goto*//*Label 13445*/ GIMT_Encode4(879783), // Rule ID 60893 //
     /*  879713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  879724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  879727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  879730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  879733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  879752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  879759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /*  879762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879781 */     GIR_RootConstrainSelectedInstOperands,
     /*  879782 */     // GIR_Coverage, 60893,
     /*  879782 */     GIR_EraseRootFromParent_Done,
     /*  879783 */   // Label 13445: @879783
     /*  879783 */   GIM_Try, /*On fail goto*//*Label 13446*/ GIMT_Encode4(879858), // Rule ID 60896 //
     /*  879788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  879808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  879834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879856 */     GIR_RootConstrainSelectedInstOperands,
     /*  879857 */     // GIR_Coverage, 60896,
     /*  879857 */     GIR_EraseRootFromParent_Done,
     /*  879858 */   // Label 13446: @879858
     /*  879858 */   GIM_Try, /*On fail goto*//*Label 13447*/ GIMT_Encode4(879933), // Rule ID 60897 //
     /*  879863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  879866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  879874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  879877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  879880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  879883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  879886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  879902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  879909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /*  879912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  879925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  879928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  879931 */     GIR_RootConstrainSelectedInstOperands,
     /*  879932 */     // GIR_Coverage, 60897,
     /*  879932 */     GIR_EraseRootFromParent_Done,
     /*  879933 */   // Label 13447: @879933
     /*  879933 */   GIM_Try, /*On fail goto*//*Label 13448*/ GIMT_Encode4(880008), // Rule ID 60900 //
     /*  879938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  879941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  879946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  879949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  879952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  879955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  879958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  879961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  879969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  879977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  879984 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  879984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  879987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  879989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  879991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  879993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  879995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880006 */     GIR_RootConstrainSelectedInstOperands,
     /*  880007 */     // GIR_Coverage, 60900,
     /*  880007 */     GIR_EraseRootFromParent_Done,
     /*  880008 */   // Label 13448: @880008
     /*  880008 */   GIM_Try, /*On fail goto*//*Label 13449*/ GIMT_Encode4(880083), // Rule ID 60901 //
     /*  880013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  880024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  880027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  880030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  880033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  880059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /*  880062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  880078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880081 */     GIR_RootConstrainSelectedInstOperands,
     /*  880082 */     // GIR_Coverage, 60901,
     /*  880082 */     GIR_EraseRootFromParent_Done,
     /*  880083 */   // Label 13449: @880083
     /*  880083 */   GIM_Try, /*On fail goto*//*Label 13450*/ GIMT_Encode4(880158), // Rule ID 60904 //
     /*  880088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880156 */     GIR_RootConstrainSelectedInstOperands,
     /*  880157 */     // GIR_Coverage, 60904,
     /*  880157 */     GIR_EraseRootFromParent_Done,
     /*  880158 */   // Label 13450: @880158
     /*  880158 */   GIM_Try, /*On fail goto*//*Label 13451*/ GIMT_Encode4(880233), // Rule ID 60905 //
     /*  880163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  880174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  880177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  880180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8),
     /*  880212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880231 */     GIR_RootConstrainSelectedInstOperands,
     /*  880232 */     // GIR_Coverage, 60905,
     /*  880232 */     GIR_EraseRootFromParent_Done,
     /*  880233 */   // Label 13451: @880233
     /*  880233 */   GIM_Try, /*On fail goto*//*Label 13452*/ GIMT_Encode4(880308), // Rule ID 60912 //
     /*  880238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880306 */     GIR_RootConstrainSelectedInstOperands,
     /*  880307 */     // GIR_Coverage, 60912,
     /*  880307 */     GIR_EraseRootFromParent_Done,
     /*  880308 */   // Label 13452: @880308
     /*  880308 */   GIM_Try, /*On fail goto*//*Label 13453*/ GIMT_Encode4(880383), // Rule ID 60913 //
     /*  880313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  880324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  880327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  880330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  880362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880381 */     GIR_RootConstrainSelectedInstOperands,
     /*  880382 */     // GIR_Coverage, 60913,
     /*  880382 */     GIR_EraseRootFromParent_Done,
     /*  880383 */   // Label 13453: @880383
     /*  880383 */   GIM_Try, /*On fail goto*//*Label 13454*/ GIMT_Encode4(880458), // Rule ID 60920 //
     /*  880388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  880405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880434 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  880437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880456 */     GIR_RootConstrainSelectedInstOperands,
     /*  880457 */     // GIR_Coverage, 60920,
     /*  880457 */     GIR_EraseRootFromParent_Done,
     /*  880458 */   // Label 13454: @880458
     /*  880458 */   GIM_Try, /*On fail goto*//*Label 13455*/ GIMT_Encode4(880533), // Rule ID 60921 //
     /*  880463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  880474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  880477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  880480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11596:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  880512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880531 */     GIR_RootConstrainSelectedInstOperands,
     /*  880532 */     // GIR_Coverage, 60921,
     /*  880532 */     GIR_EraseRootFromParent_Done,
     /*  880533 */   // Label 13455: @880533
     /*  880533 */   GIM_Try, /*On fail goto*//*Label 13456*/ GIMT_Encode4(880608), // Rule ID 60928 //
     /*  880538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  880549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  880552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  880555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  880587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880606 */     GIR_RootConstrainSelectedInstOperands,
     /*  880607 */     // GIR_Coverage, 60928,
     /*  880607 */     GIR_EraseRootFromParent_Done,
     /*  880608 */   // Label 13456: @880608
     /*  880608 */   GIM_Try, /*On fail goto*//*Label 13457*/ GIMT_Encode4(880683), // Rule ID 60929 //
     /*  880613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  880624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  880627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  880630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  880648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880659 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  880662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880681 */     GIR_RootConstrainSelectedInstOperands,
     /*  880682 */     // GIR_Coverage, 60929,
     /*  880682 */     GIR_EraseRootFromParent_Done,
     /*  880683 */   // Label 13457: @880683
     /*  880683 */   GIM_Try, /*On fail goto*//*Label 13458*/ GIMT_Encode4(880758), // Rule ID 60936 //
     /*  880688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  880699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  880702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  880705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880734 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  880737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880756 */     GIR_RootConstrainSelectedInstOperands,
     /*  880757 */     // GIR_Coverage, 60936,
     /*  880757 */     GIR_EraseRootFromParent_Done,
     /*  880758 */   // Label 13458: @880758
     /*  880758 */   GIM_Try, /*On fail goto*//*Label 13459*/ GIMT_Encode4(880833), // Rule ID 60937 //
     /*  880763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  880774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  880777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  880780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  880798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880809 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  880812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880831 */     GIR_RootConstrainSelectedInstOperands,
     /*  880832 */     // GIR_Coverage, 60937,
     /*  880832 */     GIR_EraseRootFromParent_Done,
     /*  880833 */   // Label 13459: @880833
     /*  880833 */   GIM_Try, /*On fail goto*//*Label 13460*/ GIMT_Encode4(880908), // Rule ID 60944 //
     /*  880838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  880849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  880852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  880855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  880858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  880861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  880884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  880887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880906 */     GIR_RootConstrainSelectedInstOperands,
     /*  880907 */     // GIR_Coverage, 60944,
     /*  880907 */     GIR_EraseRootFromParent_Done,
     /*  880908 */   // Label 13460: @880908
     /*  880908 */   GIM_Try, /*On fail goto*//*Label 13461*/ GIMT_Encode4(880983), // Rule ID 60945 //
     /*  880913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  880916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  880924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  880927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  880930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  880933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  880936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  880944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  880948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  880952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  880959 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  880959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  880962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  880964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  880966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  880968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  880970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  880975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  880978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  880981 */     GIR_RootConstrainSelectedInstOperands,
     /*  880982 */     // GIR_Coverage, 60945,
     /*  880982 */     GIR_EraseRootFromParent_Done,
     /*  880983 */   // Label 13461: @880983
     /*  880983 */   GIM_Try, /*On fail goto*//*Label 13462*/ GIMT_Encode4(881058), // Rule ID 60952 //
     /*  880988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  880991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  880996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  880999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881056 */     GIR_RootConstrainSelectedInstOperands,
     /*  881057 */     // GIR_Coverage, 60952,
     /*  881057 */     GIR_EraseRootFromParent_Done,
     /*  881058 */   // Label 13462: @881058
     /*  881058 */   GIM_Try, /*On fail goto*//*Label 13463*/ GIMT_Encode4(881133), // Rule ID 60953 //
     /*  881063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  881074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  881077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  881080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4),
     /*  881112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881131 */     GIR_RootConstrainSelectedInstOperands,
     /*  881132 */     // GIR_Coverage, 60953,
     /*  881132 */     GIR_EraseRootFromParent_Done,
     /*  881133 */   // Label 13463: @881133
     /*  881133 */   GIM_Try, /*On fail goto*//*Label 13464*/ GIMT_Encode4(881208), // Rule ID 60960 //
     /*  881138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881206 */     GIR_RootConstrainSelectedInstOperands,
     /*  881207 */     // GIR_Coverage, 60960,
     /*  881207 */     GIR_EraseRootFromParent_Done,
     /*  881208 */   // Label 13464: @881208
     /*  881208 */   GIM_Try, /*On fail goto*//*Label 13465*/ GIMT_Encode4(881283), // Rule ID 60961 //
     /*  881213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  881224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  881227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  881230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11596:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881281 */     GIR_RootConstrainSelectedInstOperands,
     /*  881282 */     // GIR_Coverage, 60961,
     /*  881282 */     GIR_EraseRootFromParent_Done,
     /*  881283 */   // Label 13465: @881283
     /*  881283 */   GIM_Try, /*On fail goto*//*Label 13466*/ GIMT_Encode4(881358), // Rule ID 60968 //
     /*  881288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881334 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881356 */     GIR_RootConstrainSelectedInstOperands,
     /*  881357 */     // GIR_Coverage, 60968,
     /*  881357 */     GIR_EraseRootFromParent_Done,
     /*  881358 */   // Label 13466: @881358
     /*  881358 */   GIM_Try, /*On fail goto*//*Label 13467*/ GIMT_Encode4(881433), // Rule ID 60969 //
     /*  881363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  881374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  881377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  881380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881409 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881431 */     GIR_RootConstrainSelectedInstOperands,
     /*  881432 */     // GIR_Coverage, 60969,
     /*  881432 */     GIR_EraseRootFromParent_Done,
     /*  881433 */   // Label 13467: @881433
     /*  881433 */   GIM_Try, /*On fail goto*//*Label 13468*/ GIMT_Encode4(881508), // Rule ID 60976 //
     /*  881438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  881449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  881452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881506 */     GIR_RootConstrainSelectedInstOperands,
     /*  881507 */     // GIR_Coverage, 60976,
     /*  881507 */     GIR_EraseRootFromParent_Done,
     /*  881508 */   // Label 13468: @881508
     /*  881508 */   GIM_Try, /*On fail goto*//*Label 13469*/ GIMT_Encode4(881583), // Rule ID 60977 //
     /*  881513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  881524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  881527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  881530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  881562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881581 */     GIR_RootConstrainSelectedInstOperands,
     /*  881582 */     // GIR_Coverage, 60977,
     /*  881582 */     GIR_EraseRootFromParent_Done,
     /*  881583 */   // Label 13469: @881583
     /*  881583 */   GIM_Try, /*On fail goto*//*Label 13470*/ GIMT_Encode4(881658), // Rule ID 60984 //
     /*  881588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  881599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  881602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881634 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  881634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881656 */     GIR_RootConstrainSelectedInstOperands,
     /*  881657 */     // GIR_Coverage, 60984,
     /*  881657 */     GIR_EraseRootFromParent_Done,
     /*  881658 */   // Label 13470: @881658
     /*  881658 */   GIM_Try, /*On fail goto*//*Label 13471*/ GIMT_Encode4(881733), // Rule ID 60985 //
     /*  881663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  881674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  881677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  881680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  881694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  881698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  881709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  881712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  881728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881731 */     GIR_RootConstrainSelectedInstOperands,
     /*  881732 */     // GIR_Coverage, 60985,
     /*  881732 */     GIR_EraseRootFromParent_Done,
     /*  881733 */   // Label 13471: @881733
     /*  881733 */   GIM_Try, /*On fail goto*//*Label 13472*/ GIMT_Encode4(881808), // Rule ID 60992 //
     /*  881738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  881749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  881752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  881755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  881784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881806 */     GIR_RootConstrainSelectedInstOperands,
     /*  881807 */     // GIR_Coverage, 60992,
     /*  881807 */     GIR_EraseRootFromParent_Done,
     /*  881808 */   // Label 13472: @881808
     /*  881808 */   GIM_Try, /*On fail goto*//*Label 13473*/ GIMT_Encode4(881883), // Rule ID 60993 //
     /*  881813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  881824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  881827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  881830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881859 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11596:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  881859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2),
     /*  881862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881881 */     GIR_RootConstrainSelectedInstOperands,
     /*  881882 */     // GIR_Coverage, 60993,
     /*  881882 */     GIR_EraseRootFromParent_Done,
     /*  881883 */   // Label 13473: @881883
     /*  881883 */   GIM_Try, /*On fail goto*//*Label 13474*/ GIMT_Encode4(881958), // Rule ID 61000 //
     /*  881888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  881891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  881899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  881902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  881905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  881908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  881911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  881927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  881934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  881934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  881937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  881939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  881941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  881943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  881945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  881950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  881953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  881956 */     GIR_RootConstrainSelectedInstOperands,
     /*  881957 */     // GIR_Coverage, 61000,
     /*  881957 */     GIR_EraseRootFromParent_Done,
     /*  881958 */   // Label 13474: @881958
     /*  881958 */   GIM_Try, /*On fail goto*//*Label 13475*/ GIMT_Encode4(882033), // Rule ID 61001 //
     /*  881963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  881966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  881971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  881974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  881977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  881980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  881983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  881986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  881994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  881998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11596:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1),
     /*  882012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882031 */     GIR_RootConstrainSelectedInstOperands,
     /*  882032 */     // GIR_Coverage, 61001,
     /*  882032 */     GIR_EraseRootFromParent_Done,
     /*  882033 */   // Label 13475: @882033
     /*  882033 */   GIM_Try, /*On fail goto*//*Label 13476*/ GIMT_Encode4(882108), // Rule ID 61008 //
     /*  882038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882106 */     GIR_RootConstrainSelectedInstOperands,
     /*  882107 */     // GIR_Coverage, 61008,
     /*  882107 */     GIR_EraseRootFromParent_Done,
     /*  882108 */   // Label 13476: @882108
     /*  882108 */   GIM_Try, /*On fail goto*//*Label 13477*/ GIMT_Encode4(882183), // Rule ID 61009 //
     /*  882113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  882130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11596:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2),
     /*  882162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882181 */     GIR_RootConstrainSelectedInstOperands,
     /*  882182 */     // GIR_Coverage, 61009,
     /*  882182 */     GIR_EraseRootFromParent_Done,
     /*  882183 */   // Label 13477: @882183
     /*  882183 */   GIM_Try, /*On fail goto*//*Label 13478*/ GIMT_Encode4(882258), // Rule ID 61016 //
     /*  882188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /*  882191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  882234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882256 */     GIR_RootConstrainSelectedInstOperands,
     /*  882257 */     // GIR_Coverage, 61016,
     /*  882257 */     GIR_EraseRootFromParent_Done,
     /*  882258 */   // Label 13478: @882258
     /*  882258 */   GIM_Try, /*On fail goto*//*Label 13479*/ GIMT_Encode4(882333), // Rule ID 61017 //
     /*  882263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /*  882266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll),
     /*  882271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  882280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  882283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11596:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWSLL_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  882309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4),
     /*  882312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  882328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882331 */     GIR_RootConstrainSelectedInstOperands,
     /*  882332 */     // GIR_Coverage, 61017,
     /*  882332 */     GIR_EraseRootFromParent_Done,
     /*  882333 */   // Label 13479: @882333
     /*  882333 */   GIM_Try, /*On fail goto*//*Label 13480*/ GIMT_Encode4(882408), // Rule ID 61024 //
     /*  882338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882406 */     GIR_RootConstrainSelectedInstOperands,
     /*  882407 */     // GIR_Coverage, 61024,
     /*  882407 */     GIR_EraseRootFromParent_Done,
     /*  882408 */   // Label 13480: @882408
     /*  882408 */   GIM_Try, /*On fail goto*//*Label 13481*/ GIMT_Encode4(882483), // Rule ID 61025 //
     /*  882413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  882433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882459 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1),
     /*  882462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882481 */     GIR_RootConstrainSelectedInstOperands,
     /*  882482 */     // GIR_Coverage, 61025,
     /*  882482 */     GIR_EraseRootFromParent_Done,
     /*  882483 */   // Label 13481: @882483
     /*  882483 */   GIM_Try, /*On fail goto*//*Label 13482*/ GIMT_Encode4(882558), // Rule ID 61028 //
     /*  882488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  882505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  882508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  882537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882556 */     GIR_RootConstrainSelectedInstOperands,
     /*  882557 */     // GIR_Coverage, 61028,
     /*  882557 */     GIR_EraseRootFromParent_Done,
     /*  882558 */   // Label 13482: @882558
     /*  882558 */   GIM_Try, /*On fail goto*//*Label 13483*/ GIMT_Encode4(882633), // Rule ID 61029 //
     /*  882563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  882574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  882577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  882580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  882583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  882602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2),
     /*  882612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882631 */     GIR_RootConstrainSelectedInstOperands,
     /*  882632 */     // GIR_Coverage, 61029,
     /*  882632 */     GIR_EraseRootFromParent_Done,
     /*  882633 */   // Label 13483: @882633
     /*  882633 */   GIM_Try, /*On fail goto*//*Label 13484*/ GIMT_Encode4(882708), // Rule ID 61032 //
     /*  882638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  882655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  882658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  882687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882706 */     GIR_RootConstrainSelectedInstOperands,
     /*  882707 */     // GIR_Coverage, 61032,
     /*  882707 */     GIR_EraseRootFromParent_Done,
     /*  882708 */   // Label 13484: @882708
     /*  882708 */   GIM_Try, /*On fail goto*//*Label 13485*/ GIMT_Encode4(882783), // Rule ID 61033 //
     /*  882713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  882724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  882727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  882730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  882733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  882752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4),
     /*  882762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882781 */     GIR_RootConstrainSelectedInstOperands,
     /*  882782 */     // GIR_Coverage, 61033,
     /*  882782 */     GIR_EraseRootFromParent_Done,
     /*  882783 */   // Label 13485: @882783
     /*  882783 */   GIM_Try, /*On fail goto*//*Label 13486*/ GIMT_Encode4(882858), // Rule ID 61036 //
     /*  882788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  882805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  882808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882834 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  882837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882856 */     GIR_RootConstrainSelectedInstOperands,
     /*  882857 */     // GIR_Coverage, 61036,
     /*  882857 */     GIR_EraseRootFromParent_Done,
     /*  882858 */   // Label 13486: @882858
     /*  882858 */   GIM_Try, /*On fail goto*//*Label 13487*/ GIMT_Encode4(882933), // Rule ID 61037 //
     /*  882863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  882866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  882874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  882877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  882880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  882883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  882886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  882902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  882909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8),
     /*  882912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  882925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  882928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  882931 */     GIR_RootConstrainSelectedInstOperands,
     /*  882932 */     // GIR_Coverage, 61037,
     /*  882932 */     GIR_EraseRootFromParent_Done,
     /*  882933 */   // Label 13487: @882933
     /*  882933 */   GIM_Try, /*On fail goto*//*Label 13488*/ GIMT_Encode4(883008), // Rule ID 61040 //
     /*  882938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  882941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  882946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  882949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  882952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  882955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  882958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  882961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  882973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  882977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  882984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  882984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  882987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  882989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  882991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  882993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  882995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883006 */     GIR_RootConstrainSelectedInstOperands,
     /*  883007 */     // GIR_Coverage, 61040,
     /*  883007 */     GIR_EraseRootFromParent_Done,
     /*  883008 */   // Label 13488: @883008
     /*  883008 */   GIM_Try, /*On fail goto*//*Label 13489*/ GIMT_Encode4(883083), // Rule ID 61041 //
     /*  883013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883059 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11099:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1),
     /*  883062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883081 */     GIR_RootConstrainSelectedInstOperands,
     /*  883082 */     // GIR_Coverage, 61041,
     /*  883082 */     GIR_EraseRootFromParent_Done,
     /*  883083 */   // Label 13489: @883083
     /*  883083 */   GIM_Try, /*On fail goto*//*Label 13490*/ GIMT_Encode4(883158), // Rule ID 61044 //
     /*  883088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883156 */     GIR_RootConstrainSelectedInstOperands,
     /*  883157 */     // GIR_Coverage, 61044,
     /*  883157 */     GIR_EraseRootFromParent_Done,
     /*  883158 */   // Label 13490: @883158
     /*  883158 */   GIM_Try, /*On fail goto*//*Label 13491*/ GIMT_Encode4(883233), // Rule ID 61045 //
     /*  883163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11099:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2),
     /*  883212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883231 */     GIR_RootConstrainSelectedInstOperands,
     /*  883232 */     // GIR_Coverage, 61045,
     /*  883232 */     GIR_EraseRootFromParent_Done,
     /*  883233 */   // Label 13491: @883233
     /*  883233 */   GIM_Try, /*On fail goto*//*Label 13492*/ GIMT_Encode4(883308), // Rule ID 61048 //
     /*  883238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883306 */     GIR_RootConstrainSelectedInstOperands,
     /*  883307 */     // GIR_Coverage, 61048,
     /*  883307 */     GIR_EraseRootFromParent_Done,
     /*  883308 */   // Label 13492: @883308
     /*  883308 */   GIM_Try, /*On fail goto*//*Label 13493*/ GIMT_Encode4(883383), // Rule ID 61049 //
     /*  883313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11099:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4),
     /*  883362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883381 */     GIR_RootConstrainSelectedInstOperands,
     /*  883382 */     // GIR_Coverage, 61049,
     /*  883382 */     GIR_EraseRootFromParent_Done,
     /*  883383 */   // Label 13493: @883383
     /*  883383 */   GIM_Try, /*On fail goto*//*Label 13494*/ GIMT_Encode4(883458), // Rule ID 61052 //
     /*  883388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  883408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  883437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883456 */     GIR_RootConstrainSelectedInstOperands,
     /*  883457 */     // GIR_Coverage, 61052,
     /*  883457 */     GIR_EraseRootFromParent_Done,
     /*  883458 */   // Label 13494: @883458
     /*  883458 */   GIM_Try, /*On fail goto*//*Label 13495*/ GIMT_Encode4(883533), // Rule ID 61053 //
     /*  883463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul),
     /*  883471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  883477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  883480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  883483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  883498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  883502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11099:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8),
     /*  883512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883531 */     GIR_RootConstrainSelectedInstOperands,
     /*  883532 */     // GIR_Coverage, 61053,
     /*  883532 */     GIR_EraseRootFromParent_Done,
     /*  883533 */   // Label 13495: @883533
     /*  883533 */   GIM_Try, /*On fail goto*//*Label 13496*/ GIMT_Encode4(883608), // Rule ID 61056 //
     /*  883538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  883587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883606 */     GIR_RootConstrainSelectedInstOperands,
     /*  883607 */     // GIR_Coverage, 61056,
     /*  883607 */     GIR_EraseRootFromParent_Done,
     /*  883608 */   // Label 13496: @883608
     /*  883608 */   GIM_Try, /*On fail goto*//*Label 13497*/ GIMT_Encode4(883683), // Rule ID 61057 //
     /*  883613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  883624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  883627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  883630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  883633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  883652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883659 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1),
     /*  883662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883681 */     GIR_RootConstrainSelectedInstOperands,
     /*  883682 */     // GIR_Coverage, 61057,
     /*  883682 */     GIR_EraseRootFromParent_Done,
     /*  883683 */   // Label 13497: @883683
     /*  883683 */   GIM_Try, /*On fail goto*//*Label 13498*/ GIMT_Encode4(883758), // Rule ID 61060 //
     /*  883688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  883737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883756 */     GIR_RootConstrainSelectedInstOperands,
     /*  883757 */     // GIR_Coverage, 61060,
     /*  883757 */     GIR_EraseRootFromParent_Done,
     /*  883758 */   // Label 13498: @883758
     /*  883758 */   GIM_Try, /*On fail goto*//*Label 13499*/ GIMT_Encode4(883833), // Rule ID 61061 //
     /*  883763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  883774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  883777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  883780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  883783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  883802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2),
     /*  883812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883831 */     GIR_RootConstrainSelectedInstOperands,
     /*  883832 */     // GIR_Coverage, 61061,
     /*  883832 */     GIR_EraseRootFromParent_Done,
     /*  883833 */   // Label 13499: @883833
     /*  883833 */   GIM_Try, /*On fail goto*//*Label 13500*/ GIMT_Encode4(883908), // Rule ID 61064 //
     /*  883838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  883861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  883884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  883887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883906 */     GIR_RootConstrainSelectedInstOperands,
     /*  883907 */     // GIR_Coverage, 61064,
     /*  883907 */     GIR_EraseRootFromParent_Done,
     /*  883908 */   // Label 13500: @883908
     /*  883908 */   GIM_Try, /*On fail goto*//*Label 13501*/ GIMT_Encode4(883983), // Rule ID 61065 //
     /*  883913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  883916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  883924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  883927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  883930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  883933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  883936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  883952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  883959 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  883959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4),
     /*  883962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  883964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  883966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  883968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  883970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  883975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  883978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  883981 */     GIR_RootConstrainSelectedInstOperands,
     /*  883982 */     // GIR_Coverage, 61065,
     /*  883982 */     GIR_EraseRootFromParent_Done,
     /*  883983 */   // Label 13501: @883983
     /*  883983 */   GIM_Try, /*On fail goto*//*Label 13502*/ GIMT_Encode4(884058), // Rule ID 61068 //
     /*  883988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  883991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  883996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  883999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884034 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884056 */     GIR_RootConstrainSelectedInstOperands,
     /*  884057 */     // GIR_Coverage, 61068,
     /*  884057 */     GIR_EraseRootFromParent_Done,
     /*  884058 */   // Label 13502: @884058
     /*  884058 */   GIM_Try, /*On fail goto*//*Label 13503*/ GIMT_Encode4(884133), // Rule ID 61069 //
     /*  884063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  884083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884109 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8),
     /*  884112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884131 */     GIR_RootConstrainSelectedInstOperands,
     /*  884132 */     // GIR_Coverage, 61069,
     /*  884132 */     GIR_EraseRootFromParent_Done,
     /*  884133 */   // Label 13503: @884133
     /*  884133 */   GIM_Try, /*On fail goto*//*Label 13504*/ GIMT_Encode4(884208), // Rule ID 61072 //
     /*  884138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884206 */     GIR_RootConstrainSelectedInstOperands,
     /*  884207 */     // GIR_Coverage, 61072,
     /*  884207 */     GIR_EraseRootFromParent_Done,
     /*  884208 */   // Label 13504: @884208
     /*  884208 */   GIM_Try, /*On fail goto*//*Label 13505*/ GIMT_Encode4(884283), // Rule ID 61073 //
     /*  884213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  884224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  884227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  884230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884259 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11101:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1),
     /*  884262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884281 */     GIR_RootConstrainSelectedInstOperands,
     /*  884282 */     // GIR_Coverage, 61073,
     /*  884282 */     GIR_EraseRootFromParent_Done,
     /*  884283 */   // Label 13505: @884283
     /*  884283 */   GIM_Try, /*On fail goto*//*Label 13506*/ GIMT_Encode4(884358), // Rule ID 61076 //
     /*  884288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884356 */     GIR_RootConstrainSelectedInstOperands,
     /*  884357 */     // GIR_Coverage, 61076,
     /*  884357 */     GIR_EraseRootFromParent_Done,
     /*  884358 */   // Label 13506: @884358
     /*  884358 */   GIM_Try, /*On fail goto*//*Label 13507*/ GIMT_Encode4(884433), // Rule ID 61077 //
     /*  884363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  884374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  884377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  884380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  884398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884409 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11101:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2),
     /*  884412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884431 */     GIR_RootConstrainSelectedInstOperands,
     /*  884432 */     // GIR_Coverage, 61077,
     /*  884432 */     GIR_EraseRootFromParent_Done,
     /*  884433 */   // Label 13507: @884433
     /*  884433 */   GIM_Try, /*On fail goto*//*Label 13508*/ GIMT_Encode4(884508), // Rule ID 61080 //
     /*  884438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884484 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  884487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884506 */     GIR_RootConstrainSelectedInstOperands,
     /*  884507 */     // GIR_Coverage, 61080,
     /*  884507 */     GIR_EraseRootFromParent_Done,
     /*  884508 */   // Label 13508: @884508
     /*  884508 */   GIM_Try, /*On fail goto*//*Label 13509*/ GIMT_Encode4(884583), // Rule ID 61081 //
     /*  884513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  884524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  884527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  884530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  884548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884559 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11101:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4),
     /*  884562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884581 */     GIR_RootConstrainSelectedInstOperands,
     /*  884582 */     // GIR_Coverage, 61081,
     /*  884582 */     GIR_EraseRootFromParent_Done,
     /*  884583 */   // Label 13509: @884583
     /*  884583 */   GIM_Try, /*On fail goto*//*Label 13510*/ GIMT_Encode4(884658), // Rule ID 61084 //
     /*  884588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /*  884591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  884608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  884634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  884637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884656 */     GIR_RootConstrainSelectedInstOperands,
     /*  884657 */     // GIR_Coverage, 61084,
     /*  884657 */     GIR_EraseRootFromParent_Done,
     /*  884658 */   // Label 13510: @884658
     /*  884658 */   GIM_Try, /*On fail goto*//*Label 13511*/ GIMT_Encode4(884733), // Rule ID 61085 //
     /*  884663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /*  884666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh),
     /*  884671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  884674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  884677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  884680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  884683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  884698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  884702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884709 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11101:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVCLMULH_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  884709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8),
     /*  884712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  884728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884731 */     GIR_RootConstrainSelectedInstOperands,
     /*  884732 */     // GIR_Coverage, 61085,
     /*  884732 */     GIR_EraseRootFromParent_Done,
     /*  884733 */   // Label 13511: @884733
     /*  884733 */   GIM_Try, /*On fail goto*//*Label 13512*/ GIMT_Encode4(884808), // Rule ID 61088 //
     /*  884738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  884741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  884746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  884749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  884752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  884758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  884787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884806 */     GIR_RootConstrainSelectedInstOperands,
     /*  884807 */     // GIR_Coverage, 61088,
     /*  884807 */     GIR_EraseRootFromParent_Done,
     /*  884808 */   // Label 13512: @884808
     /*  884808 */   GIM_Try, /*On fail goto*//*Label 13513*/ GIMT_Encode4(884883), // Rule ID 61089 //
     /*  884813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  884816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  884821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  884824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  884827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  884830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  884833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884859 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  884859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8),
     /*  884862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884881 */     GIR_RootConstrainSelectedInstOperands,
     /*  884882 */     // GIR_Coverage, 61089,
     /*  884882 */     GIR_EraseRootFromParent_Done,
     /*  884883 */   // Label 13513: @884883
     /*  884883 */   GIM_Try, /*On fail goto*//*Label 13514*/ GIMT_Encode4(884958), // Rule ID 61092 //
     /*  884888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  884891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  884896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  884899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  884902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  884908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  884911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  884934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  884934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  884937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  884939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  884941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  884943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  884945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  884950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  884953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  884956 */     GIR_RootConstrainSelectedInstOperands,
     /*  884957 */     // GIR_Coverage, 61092,
     /*  884957 */     GIR_EraseRootFromParent_Done,
     /*  884958 */   // Label 13514: @884958
     /*  884958 */   GIM_Try, /*On fail goto*//*Label 13515*/ GIMT_Encode4(885033), // Rule ID 61093 //
     /*  884963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  884966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  884971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  884974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  884977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  884980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  884983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  884986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  884998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885009 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885031 */     GIR_RootConstrainSelectedInstOperands,
     /*  885032 */     // GIR_Coverage, 61093,
     /*  885032 */     GIR_EraseRootFromParent_Done,
     /*  885033 */   // Label 13515: @885033
     /*  885033 */   GIM_Try, /*On fail goto*//*Label 13516*/ GIMT_Encode4(885108), // Rule ID 61096 //
     /*  885038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885084 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885106 */     GIR_RootConstrainSelectedInstOperands,
     /*  885107 */     // GIR_Coverage, 61096,
     /*  885107 */     GIR_EraseRootFromParent_Done,
     /*  885108 */   // Label 13516: @885108
     /*  885108 */   GIM_Try, /*On fail goto*//*Label 13517*/ GIMT_Encode4(885183), // Rule ID 61097 //
     /*  885113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  885124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  885127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  885130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  885133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885181 */     GIR_RootConstrainSelectedInstOperands,
     /*  885182 */     // GIR_Coverage, 61097,
     /*  885182 */     GIR_EraseRootFromParent_Done,
     /*  885183 */   // Label 13517: @885183
     /*  885183 */   GIM_Try, /*On fail goto*//*Label 13518*/ GIMT_Encode4(885258), // Rule ID 61100 //
     /*  885188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885234 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885256 */     GIR_RootConstrainSelectedInstOperands,
     /*  885257 */     // GIR_Coverage, 61100,
     /*  885257 */     GIR_EraseRootFromParent_Done,
     /*  885258 */   // Label 13518: @885258
     /*  885258 */   GIM_Try, /*On fail goto*//*Label 13519*/ GIMT_Encode4(885333), // Rule ID 61101 //
     /*  885263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  885274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  885277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  885280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  885283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885309 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4),
     /*  885312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885331 */     GIR_RootConstrainSelectedInstOperands,
     /*  885332 */     // GIR_Coverage, 61101,
     /*  885332 */     GIR_EraseRootFromParent_Done,
     /*  885333 */   // Label 13519: @885333
     /*  885333 */   GIM_Try, /*On fail goto*//*Label 13520*/ GIMT_Encode4(885408), // Rule ID 61104 //
     /*  885338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885406 */     GIR_RootConstrainSelectedInstOperands,
     /*  885407 */     // GIR_Coverage, 61104,
     /*  885407 */     GIR_EraseRootFromParent_Done,
     /*  885408 */   // Label 13520: @885408
     /*  885408 */   GIM_Try, /*On fail goto*//*Label 13521*/ GIMT_Encode4(885483), // Rule ID 61105 //
     /*  885413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  885424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  885427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  885430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  885433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885459 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885481 */     GIR_RootConstrainSelectedInstOperands,
     /*  885482 */     // GIR_Coverage, 61105,
     /*  885482 */     GIR_EraseRootFromParent_Done,
     /*  885483 */   // Label 13521: @885483
     /*  885483 */   GIM_Try, /*On fail goto*//*Label 13522*/ GIMT_Encode4(885558), // Rule ID 61108 //
     /*  885488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  885505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  885508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885534 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  885534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885556 */     GIR_RootConstrainSelectedInstOperands,
     /*  885557 */     // GIR_Coverage, 61108,
     /*  885557 */     GIR_EraseRootFromParent_Done,
     /*  885558 */   // Label 13522: @885558
     /*  885558 */   GIM_Try, /*On fail goto*//*Label 13523*/ GIMT_Encode4(885633), // Rule ID 61109 //
     /*  885563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  885574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  885577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  885580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  885583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885609 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  885609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2),
     /*  885612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  885628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885631 */     GIR_RootConstrainSelectedInstOperands,
     /*  885632 */     // GIR_Coverage, 61109,
     /*  885632 */     GIR_EraseRootFromParent_Done,
     /*  885633 */   // Label 13523: @885633
     /*  885633 */   GIM_Try, /*On fail goto*//*Label 13524*/ GIMT_Encode4(885708), // Rule ID 61112 //
     /*  885638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  885649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  885652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  885655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  885658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  885684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  885687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885706 */     GIR_RootConstrainSelectedInstOperands,
     /*  885707 */     // GIR_Coverage, 61112,
     /*  885707 */     GIR_EraseRootFromParent_Done,
     /*  885708 */   // Label 13524: @885708
     /*  885708 */   GIM_Try, /*On fail goto*//*Label 13525*/ GIMT_Encode4(885783), // Rule ID 61113 //
     /*  885713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  885724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  885727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  885730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  885733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885759 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  885759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  885762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  885778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885781 */     GIR_RootConstrainSelectedInstOperands,
     /*  885782 */     // GIR_Coverage, 61113,
     /*  885782 */     GIR_EraseRootFromParent_Done,
     /*  885783 */   // Label 13525: @885783
     /*  885783 */   GIM_Try, /*On fail goto*//*Label 13526*/ GIMT_Encode4(885858), // Rule ID 61116 //
     /*  885788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  885799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  885802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  885808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885834 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  885834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  885837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885856 */     GIR_RootConstrainSelectedInstOperands,
     /*  885857 */     // GIR_Coverage, 61116,
     /*  885857 */     GIR_EraseRootFromParent_Done,
     /*  885858 */   // Label 13526: @885858
     /*  885858 */   GIM_Try, /*On fail goto*//*Label 13527*/ GIMT_Encode4(885933), // Rule ID 61117 //
     /*  885863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  885866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  885874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  885877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  885880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  885883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  885886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885909 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  885909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  885912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  885925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  885928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  885931 */     GIR_RootConstrainSelectedInstOperands,
     /*  885932 */     // GIR_Coverage, 61117,
     /*  885932 */     GIR_EraseRootFromParent_Done,
     /*  885933 */   // Label 13527: @885933
     /*  885933 */   GIM_Try, /*On fail goto*//*Label 13528*/ GIMT_Encode4(886008), // Rule ID 61120 //
     /*  885938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  885941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  885946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  885949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  885952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  885955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  885958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  885961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  885977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  885984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  885984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  885987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  885989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  885991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  885993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  885995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886006 */     GIR_RootConstrainSelectedInstOperands,
     /*  886007 */     // GIR_Coverage, 61120,
     /*  886007 */     GIR_EraseRootFromParent_Done,
     /*  886008 */   // Label 13528: @886008
     /*  886008 */   GIM_Try, /*On fail goto*//*Label 13529*/ GIMT_Encode4(886083), // Rule ID 61121 //
     /*  886013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  886024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  886027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  886030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  886033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886059 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  886059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  886078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886081 */     GIR_RootConstrainSelectedInstOperands,
     /*  886082 */     // GIR_Coverage, 61121,
     /*  886082 */     GIR_EraseRootFromParent_Done,
     /*  886083 */   // Label 13529: @886083
     /*  886083 */   GIM_Try, /*On fail goto*//*Label 13530*/ GIMT_Encode4(886158), // Rule ID 61124 //
     /*  886088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886134 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  886134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886156 */     GIR_RootConstrainSelectedInstOperands,
     /*  886157 */     // GIR_Coverage, 61124,
     /*  886157 */     GIR_EraseRootFromParent_Done,
     /*  886158 */   // Label 13530: @886158
     /*  886158 */   GIM_Try, /*On fail goto*//*Label 13531*/ GIMT_Encode4(886233), // Rule ID 61125 //
     /*  886163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  886174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  886177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  886180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  886183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  886202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886209 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  886209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1),
     /*  886212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  886228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886231 */     GIR_RootConstrainSelectedInstOperands,
     /*  886232 */     // GIR_Coverage, 61125,
     /*  886232 */     GIR_EraseRootFromParent_Done,
     /*  886233 */   // Label 13531: @886233
     /*  886233 */   GIM_Try, /*On fail goto*//*Label 13532*/ GIMT_Encode4(886308), // Rule ID 61128 //
     /*  886238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886284 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886306 */     GIR_RootConstrainSelectedInstOperands,
     /*  886307 */     // GIR_Coverage, 61128,
     /*  886307 */     GIR_EraseRootFromParent_Done,
     /*  886308 */   // Label 13532: @886308
     /*  886308 */   GIM_Try, /*On fail goto*//*Label 13533*/ GIMT_Encode4(886383), // Rule ID 61129 //
     /*  886313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  886324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  886327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  886330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  886333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886381 */     GIR_RootConstrainSelectedInstOperands,
     /*  886382 */     // GIR_Coverage, 61129,
     /*  886382 */     GIR_EraseRootFromParent_Done,
     /*  886383 */   // Label 13533: @886383
     /*  886383 */   GIM_Try, /*On fail goto*//*Label 13534*/ GIMT_Encode4(886458), // Rule ID 61132 //
     /*  886388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  886405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  886408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886434 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886456 */     GIR_RootConstrainSelectedInstOperands,
     /*  886457 */     // GIR_Coverage, 61132,
     /*  886457 */     GIR_EraseRootFromParent_Done,
     /*  886458 */   // Label 13534: @886458
     /*  886458 */   GIM_Try, /*On fail goto*//*Label 13535*/ GIMT_Encode4(886533), // Rule ID 61133 //
     /*  886463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  886474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  886477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  886480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  886483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886509 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886531 */     GIR_RootConstrainSelectedInstOperands,
     /*  886532 */     // GIR_Coverage, 61133,
     /*  886532 */     GIR_EraseRootFromParent_Done,
     /*  886533 */   // Label 13535: @886533
     /*  886533 */   GIM_Try, /*On fail goto*//*Label 13536*/ GIMT_Encode4(886608), // Rule ID 61136 //
     /*  886538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  886549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  886552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  886555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  886558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886584 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  886584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  886587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886606 */     GIR_RootConstrainSelectedInstOperands,
     /*  886607 */     // GIR_Coverage, 61136,
     /*  886607 */     GIR_EraseRootFromParent_Done,
     /*  886608 */   // Label 13536: @886608
     /*  886608 */   GIM_Try, /*On fail goto*//*Label 13537*/ GIMT_Encode4(886683), // Rule ID 61137 //
     /*  886613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  886624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  886627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  886630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  886633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  886652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886659 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  886659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  886662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  886678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886681 */     GIR_RootConstrainSelectedInstOperands,
     /*  886682 */     // GIR_Coverage, 61137,
     /*  886682 */     GIR_EraseRootFromParent_Done,
     /*  886683 */   // Label 13537: @886683
     /*  886683 */   GIM_Try, /*On fail goto*//*Label 13538*/ GIMT_Encode4(886758), // Rule ID 61140 //
     /*  886688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  886699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  886702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  886705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  886708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886734 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886756 */     GIR_RootConstrainSelectedInstOperands,
     /*  886757 */     // GIR_Coverage, 61140,
     /*  886757 */     GIR_EraseRootFromParent_Done,
     /*  886758 */   // Label 13538: @886758
     /*  886758 */   GIM_Try, /*On fail goto*//*Label 13539*/ GIMT_Encode4(886833), // Rule ID 61141 //
     /*  886763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  886774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  886777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  886780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  886783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  886802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886809 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  886812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886831 */     GIR_RootConstrainSelectedInstOperands,
     /*  886832 */     // GIR_Coverage, 61141,
     /*  886832 */     GIR_EraseRootFromParent_Done,
     /*  886833 */   // Label 13539: @886833
     /*  886833 */   GIM_Try, /*On fail goto*//*Label 13540*/ GIMT_Encode4(886908), // Rule ID 61144 //
     /*  886838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  886849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  886852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  886855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  886858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  886861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  886884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886906 */     GIR_RootConstrainSelectedInstOperands,
     /*  886907 */     // GIR_Coverage, 61144,
     /*  886907 */     GIR_EraseRootFromParent_Done,
     /*  886908 */   // Label 13540: @886908
     /*  886908 */   GIM_Try, /*On fail goto*//*Label 13541*/ GIMT_Encode4(886983), // Rule ID 61145 //
     /*  886913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  886916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  886924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  886927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  886930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  886933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  886936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  886952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  886959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  886959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  886962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  886964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  886966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  886968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  886970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  886975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  886978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  886981 */     GIR_RootConstrainSelectedInstOperands,
     /*  886982 */     // GIR_Coverage, 61145,
     /*  886982 */     GIR_EraseRootFromParent_Done,
     /*  886983 */   // Label 13541: @886983
     /*  886983 */   GIM_Try, /*On fail goto*//*Label 13542*/ GIMT_Encode4(887058), // Rule ID 61148 //
     /*  886988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  886991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  886996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  886999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887034 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  887034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887056 */     GIR_RootConstrainSelectedInstOperands,
     /*  887057 */     // GIR_Coverage, 61148,
     /*  887057 */     GIR_EraseRootFromParent_Done,
     /*  887058 */   // Label 13542: @887058
     /*  887058 */   GIM_Try, /*On fail goto*//*Label 13543*/ GIMT_Encode4(887133), // Rule ID 61149 //
     /*  887063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  887074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  887077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  887080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  887083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887109 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  887109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  887128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887131 */     GIR_RootConstrainSelectedInstOperands,
     /*  887132 */     // GIR_Coverage, 61149,
     /*  887132 */     GIR_EraseRootFromParent_Done,
     /*  887133 */   // Label 13543: @887133
     /*  887133 */   GIM_Try, /*On fail goto*//*Label 13544*/ GIMT_Encode4(887208), // Rule ID 61152 //
     /*  887138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887206 */     GIR_RootConstrainSelectedInstOperands,
     /*  887207 */     // GIR_Coverage, 61152,
     /*  887207 */     GIR_EraseRootFromParent_Done,
     /*  887208 */   // Label 13544: @887208
     /*  887208 */   GIM_Try, /*On fail goto*//*Label 13545*/ GIMT_Encode4(887283), // Rule ID 61153 //
     /*  887213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  887224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  887227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  887230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  887233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887259 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887281 */     GIR_RootConstrainSelectedInstOperands,
     /*  887282 */     // GIR_Coverage, 61153,
     /*  887282 */     GIR_EraseRootFromParent_Done,
     /*  887283 */   // Label 13545: @887283
     /*  887283 */   GIM_Try, /*On fail goto*//*Label 13546*/ GIMT_Encode4(887358), // Rule ID 61156 //
     /*  887288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887356 */     GIR_RootConstrainSelectedInstOperands,
     /*  887357 */     // GIR_Coverage, 61156,
     /*  887357 */     GIR_EraseRootFromParent_Done,
     /*  887358 */   // Label 13546: @887358
     /*  887358 */   GIM_Try, /*On fail goto*//*Label 13547*/ GIMT_Encode4(887433), // Rule ID 61157 //
     /*  887363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  887374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  887377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  887380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  887383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887431 */     GIR_RootConstrainSelectedInstOperands,
     /*  887432 */     // GIR_Coverage, 61157,
     /*  887432 */     GIR_EraseRootFromParent_Done,
     /*  887433 */   // Label 13547: @887433
     /*  887433 */   GIM_Try, /*On fail goto*//*Label 13548*/ GIMT_Encode4(887508), // Rule ID 61160 //
     /*  887438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  887449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  887452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  887455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  887458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887484 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  887484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887506 */     GIR_RootConstrainSelectedInstOperands,
     /*  887507 */     // GIR_Coverage, 61160,
     /*  887507 */     GIR_EraseRootFromParent_Done,
     /*  887508 */   // Label 13548: @887508
     /*  887508 */   GIM_Try, /*On fail goto*//*Label 13549*/ GIMT_Encode4(887583), // Rule ID 61161 //
     /*  887513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  887524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  887527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  887530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  887533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887559 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  887559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  887578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887581 */     GIR_RootConstrainSelectedInstOperands,
     /*  887582 */     // GIR_Coverage, 61161,
     /*  887582 */     GIR_EraseRootFromParent_Done,
     /*  887583 */   // Label 13549: @887583
     /*  887583 */   GIM_Try, /*On fail goto*//*Label 13550*/ GIMT_Encode4(887658), // Rule ID 61164 //
     /*  887588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  887608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887656 */     GIR_RootConstrainSelectedInstOperands,
     /*  887657 */     // GIR_Coverage, 61164,
     /*  887657 */     GIR_EraseRootFromParent_Done,
     /*  887658 */   // Label 13550: @887658
     /*  887658 */   GIM_Try, /*On fail goto*//*Label 13551*/ GIMT_Encode4(887733), // Rule ID 61165 //
     /*  887663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  887674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  887677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  887680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  887683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  887702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887709 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2),
     /*  887712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887731 */     GIR_RootConstrainSelectedInstOperands,
     /*  887732 */     // GIR_Coverage, 61165,
     /*  887732 */     GIR_EraseRootFromParent_Done,
     /*  887733 */   // Label 13551: @887733
     /*  887733 */   GIM_Try, /*On fail goto*//*Label 13552*/ GIMT_Encode4(887808), // Rule ID 61168 //
     /*  887738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887806 */     GIR_RootConstrainSelectedInstOperands,
     /*  887807 */     // GIR_Coverage, 61168,
     /*  887807 */     GIR_EraseRootFromParent_Done,
     /*  887808 */   // Label 13552: @887808
     /*  887808 */   GIM_Try, /*On fail goto*//*Label 13553*/ GIMT_Encode4(887883), // Rule ID 61169 //
     /*  887813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  887824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  887827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  887830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  887833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  887852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  887859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4),
     /*  887862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887881 */     GIR_RootConstrainSelectedInstOperands,
     /*  887882 */     // GIR_Coverage, 61169,
     /*  887882 */     GIR_EraseRootFromParent_Done,
     /*  887883 */   // Label 13553: @887883
     /*  887883 */   GIM_Try, /*On fail goto*//*Label 13554*/ GIMT_Encode4(887958), // Rule ID 61172 //
     /*  887888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  887891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  887911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  887934 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  887934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  887937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  887939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  887941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  887943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  887945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  887950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  887953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  887956 */     GIR_RootConstrainSelectedInstOperands,
     /*  887957 */     // GIR_Coverage, 61172,
     /*  887957 */     GIR_EraseRootFromParent_Done,
     /*  887958 */   // Label 13554: @887958
     /*  887958 */   GIM_Try, /*On fail goto*//*Label 13555*/ GIMT_Encode4(888033), // Rule ID 61173 //
     /*  887963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  887966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  887971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  887974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  887977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  887980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  887983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  887986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  887998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  888002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888009 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  888009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8),
     /*  888012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  888028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888031 */     GIR_RootConstrainSelectedInstOperands,
     /*  888032 */     // GIR_Coverage, 61173,
     /*  888032 */     GIR_EraseRootFromParent_Done,
     /*  888033 */   // Label 13555: @888033
     /*  888033 */   GIM_Try, /*On fail goto*//*Label 13556*/ GIMT_Encode4(888108), // Rule ID 61176 //
     /*  888038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888084 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888106 */     GIR_RootConstrainSelectedInstOperands,
     /*  888107 */     // GIR_Coverage, 61176,
     /*  888107 */     GIR_EraseRootFromParent_Done,
     /*  888108 */   // Label 13556: @888108
     /*  888108 */   GIM_Try, /*On fail goto*//*Label 13557*/ GIMT_Encode4(888183), // Rule ID 61177 //
     /*  888113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  888124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  888127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  888130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888159 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8),
     /*  888162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888181 */     GIR_RootConstrainSelectedInstOperands,
     /*  888182 */     // GIR_Coverage, 61177,
     /*  888182 */     GIR_EraseRootFromParent_Done,
     /*  888183 */   // Label 13557: @888183
     /*  888183 */   GIM_Try, /*On fail goto*//*Label 13558*/ GIMT_Encode4(888258), // Rule ID 61180 //
     /*  888188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888234 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888256 */     GIR_RootConstrainSelectedInstOperands,
     /*  888257 */     // GIR_Coverage, 61180,
     /*  888257 */     GIR_EraseRootFromParent_Done,
     /*  888258 */   // Label 13558: @888258
     /*  888258 */   GIM_Try, /*On fail goto*//*Label 13559*/ GIMT_Encode4(888333), // Rule ID 61181 //
     /*  888263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  888274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  888277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  888280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888309 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888331 */     GIR_RootConstrainSelectedInstOperands,
     /*  888332 */     // GIR_Coverage, 61181,
     /*  888332 */     GIR_EraseRootFromParent_Done,
     /*  888333 */   // Label 13559: @888333
     /*  888333 */   GIM_Try, /*On fail goto*//*Label 13560*/ GIMT_Encode4(888408), // Rule ID 61184 //
     /*  888338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888406 */     GIR_RootConstrainSelectedInstOperands,
     /*  888407 */     // GIR_Coverage, 61184,
     /*  888407 */     GIR_EraseRootFromParent_Done,
     /*  888408 */   // Label 13560: @888408
     /*  888408 */   GIM_Try, /*On fail goto*//*Label 13561*/ GIMT_Encode4(888483), // Rule ID 61185 //
     /*  888413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  888424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  888427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  888430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888459 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  888459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  888478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888481 */     GIR_RootConstrainSelectedInstOperands,
     /*  888482 */     // GIR_Coverage, 61185,
     /*  888482 */     GIR_EraseRootFromParent_Done,
     /*  888483 */   // Label 13561: @888483
     /*  888483 */   GIM_Try, /*On fail goto*//*Label 13562*/ GIMT_Encode4(888558), // Rule ID 61188 //
     /*  888488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  888499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  888502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  888505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888534 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  888534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888556 */     GIR_RootConstrainSelectedInstOperands,
     /*  888557 */     // GIR_Coverage, 61188,
     /*  888557 */     GIR_EraseRootFromParent_Done,
     /*  888558 */   // Label 13562: @888558
     /*  888558 */   GIM_Try, /*On fail goto*//*Label 13563*/ GIMT_Encode4(888633), // Rule ID 61189 //
     /*  888563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  888574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  888577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  888580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888609 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  888609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4),
     /*  888612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888631 */     GIR_RootConstrainSelectedInstOperands,
     /*  888632 */     // GIR_Coverage, 61189,
     /*  888632 */     GIR_EraseRootFromParent_Done,
     /*  888633 */   // Label 13563: @888633
     /*  888633 */   GIM_Try, /*On fail goto*//*Label 13564*/ GIMT_Encode4(888708), // Rule ID 61192 //
     /*  888638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  888649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  888652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  888655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888684 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  888684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888706 */     GIR_RootConstrainSelectedInstOperands,
     /*  888707 */     // GIR_Coverage, 61192,
     /*  888707 */     GIR_EraseRootFromParent_Done,
     /*  888708 */   // Label 13564: @888708
     /*  888708 */   GIM_Try, /*On fail goto*//*Label 13565*/ GIMT_Encode4(888783), // Rule ID 61193 //
     /*  888713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  888724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  888727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  888730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888759 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  888759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  888778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888781 */     GIR_RootConstrainSelectedInstOperands,
     /*  888782 */     // GIR_Coverage, 61193,
     /*  888782 */     GIR_EraseRootFromParent_Done,
     /*  888783 */   // Label 13565: @888783
     /*  888783 */   GIM_Try, /*On fail goto*//*Label 13566*/ GIMT_Encode4(888858), // Rule ID 61196 //
     /*  888788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  888799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  888802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  888805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888834 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  888834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888856 */     GIR_RootConstrainSelectedInstOperands,
     /*  888857 */     // GIR_Coverage, 61196,
     /*  888857 */     GIR_EraseRootFromParent_Done,
     /*  888858 */   // Label 13566: @888858
     /*  888858 */   GIM_Try, /*On fail goto*//*Label 13567*/ GIMT_Encode4(888933), // Rule ID 61197 //
     /*  888863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  888866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  888874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  888877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  888880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  888883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  888886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888909 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  888909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2),
     /*  888912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  888925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  888928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  888931 */     GIR_RootConstrainSelectedInstOperands,
     /*  888932 */     // GIR_Coverage, 61197,
     /*  888932 */     GIR_EraseRootFromParent_Done,
     /*  888933 */   // Label 13567: @888933
     /*  888933 */   GIM_Try, /*On fail goto*//*Label 13568*/ GIMT_Encode4(889008), // Rule ID 61200 //
     /*  888938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  888941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  888946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  888949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  888952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  888955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  888958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  888961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  888973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  888977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  888984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  888984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  888987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  888989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  888991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  888993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  888995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889006 */     GIR_RootConstrainSelectedInstOperands,
     /*  889007 */     // GIR_Coverage, 61200,
     /*  889007 */     GIR_EraseRootFromParent_Done,
     /*  889008 */   // Label 13568: @889008
     /*  889008 */   GIM_Try, /*On fail goto*//*Label 13569*/ GIMT_Encode4(889083), // Rule ID 61201 //
     /*  889013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  889024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  889027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  889030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889059 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11089:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889081 */     GIR_RootConstrainSelectedInstOperands,
     /*  889082 */     // GIR_Coverage, 61201,
     /*  889082 */     GIR_EraseRootFromParent_Done,
     /*  889083 */   // Label 13569: @889083
     /*  889083 */   GIM_Try, /*On fail goto*//*Label 13570*/ GIMT_Encode4(889158), // Rule ID 61204 //
     /*  889088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889134 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  889134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889156 */     GIR_RootConstrainSelectedInstOperands,
     /*  889157 */     // GIR_Coverage, 61204,
     /*  889157 */     GIR_EraseRootFromParent_Done,
     /*  889158 */   // Label 13570: @889158
     /*  889158 */   GIM_Try, /*On fail goto*//*Label 13571*/ GIMT_Encode4(889233), // Rule ID 61205 //
     /*  889163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  889174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  889177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  889180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889209 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11089:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  889209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  889228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889231 */     GIR_RootConstrainSelectedInstOperands,
     /*  889232 */     // GIR_Coverage, 61205,
     /*  889232 */     GIR_EraseRootFromParent_Done,
     /*  889233 */   // Label 13571: @889233
     /*  889233 */   GIM_Try, /*On fail goto*//*Label 13572*/ GIMT_Encode4(889308), // Rule ID 61208 //
     /*  889238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889284 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  889284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889306 */     GIR_RootConstrainSelectedInstOperands,
     /*  889307 */     // GIR_Coverage, 61208,
     /*  889307 */     GIR_EraseRootFromParent_Done,
     /*  889308 */   // Label 13572: @889308
     /*  889308 */   GIM_Try, /*On fail goto*//*Label 13573*/ GIMT_Encode4(889383), // Rule ID 61209 //
     /*  889313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  889324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  889327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  889330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889359 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11089:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  889359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  889378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889381 */     GIR_RootConstrainSelectedInstOperands,
     /*  889382 */     // GIR_Coverage, 61209,
     /*  889382 */     GIR_EraseRootFromParent_Done,
     /*  889383 */   // Label 13573: @889383
     /*  889383 */   GIM_Try, /*On fail goto*//*Label 13574*/ GIMT_Encode4(889458), // Rule ID 61212 //
     /*  889388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  889405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889434 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  889434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889456 */     GIR_RootConstrainSelectedInstOperands,
     /*  889457 */     // GIR_Coverage, 61212,
     /*  889457 */     GIR_EraseRootFromParent_Done,
     /*  889458 */   // Label 13574: @889458
     /*  889458 */   GIM_Try, /*On fail goto*//*Label 13575*/ GIMT_Encode4(889533), // Rule ID 61213 //
     /*  889463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  889474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  889477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  889480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  889498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889509 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11089:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  889509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1),
     /*  889512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  889528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889531 */     GIR_RootConstrainSelectedInstOperands,
     /*  889532 */     // GIR_Coverage, 61213,
     /*  889532 */     GIR_EraseRootFromParent_Done,
     /*  889533 */   // Label 13575: @889533
     /*  889533 */   GIM_Try, /*On fail goto*//*Label 13576*/ GIMT_Encode4(889608), // Rule ID 61216 //
     /*  889538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  889549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  889552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  889555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  889587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889606 */     GIR_RootConstrainSelectedInstOperands,
     /*  889607 */     // GIR_Coverage, 61216,
     /*  889607 */     GIR_EraseRootFromParent_Done,
     /*  889608 */   // Label 13576: @889608
     /*  889608 */   GIM_Try, /*On fail goto*//*Label 13577*/ GIMT_Encode4(889683), // Rule ID 61217 //
     /*  889613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  889624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  889627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  889630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  889648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889659 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  889662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889681 */     GIR_RootConstrainSelectedInstOperands,
     /*  889682 */     // GIR_Coverage, 61217,
     /*  889682 */     GIR_EraseRootFromParent_Done,
     /*  889683 */   // Label 13577: @889683
     /*  889683 */   GIM_Try, /*On fail goto*//*Label 13578*/ GIMT_Encode4(889758), // Rule ID 61220 //
     /*  889688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  889699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  889702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  889705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  889737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889756 */     GIR_RootConstrainSelectedInstOperands,
     /*  889757 */     // GIR_Coverage, 61220,
     /*  889757 */     GIR_EraseRootFromParent_Done,
     /*  889758 */   // Label 13578: @889758
     /*  889758 */   GIM_Try, /*On fail goto*//*Label 13579*/ GIMT_Encode4(889833), // Rule ID 61221 //
     /*  889763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  889774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  889777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  889780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  889798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889809 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  889812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889831 */     GIR_RootConstrainSelectedInstOperands,
     /*  889832 */     // GIR_Coverage, 61221,
     /*  889832 */     GIR_EraseRootFromParent_Done,
     /*  889833 */   // Label 13579: @889833
     /*  889833 */   GIM_Try, /*On fail goto*//*Label 13580*/ GIMT_Encode4(889908), // Rule ID 61224 //
     /*  889838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  889849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  889852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  889855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  889858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  889861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889884 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  889884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  889887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889906 */     GIR_RootConstrainSelectedInstOperands,
     /*  889907 */     // GIR_Coverage, 61224,
     /*  889907 */     GIR_EraseRootFromParent_Done,
     /*  889908 */   // Label 13580: @889908
     /*  889908 */   GIM_Try, /*On fail goto*//*Label 13581*/ GIMT_Encode4(889983), // Rule ID 61225 //
     /*  889913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  889916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  889924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  889927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  889930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  889933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  889936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  889948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  889952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  889959 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  889959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  889962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  889964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  889966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  889968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  889970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  889975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  889978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  889981 */     GIR_RootConstrainSelectedInstOperands,
     /*  889982 */     // GIR_Coverage, 61225,
     /*  889982 */     GIR_EraseRootFromParent_Done,
     /*  889983 */   // Label 13581: @889983
     /*  889983 */   GIM_Try, /*On fail goto*//*Label 13582*/ GIMT_Encode4(890058), // Rule ID 61228 //
     /*  889988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  889991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  889996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  889999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890034 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890056 */     GIR_RootConstrainSelectedInstOperands,
     /*  890057 */     // GIR_Coverage, 61228,
     /*  890057 */     GIR_EraseRootFromParent_Done,
     /*  890058 */   // Label 13582: @890058
     /*  890058 */   GIM_Try, /*On fail goto*//*Label 13583*/ GIMT_Encode4(890133), // Rule ID 61229 //
     /*  890063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  890074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  890077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  890080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890109 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890131 */     GIR_RootConstrainSelectedInstOperands,
     /*  890132 */     // GIR_Coverage, 61229,
     /*  890132 */     GIR_EraseRootFromParent_Done,
     /*  890133 */   // Label 13583: @890133
     /*  890133 */   GIM_Try, /*On fail goto*//*Label 13584*/ GIMT_Encode4(890208), // Rule ID 61232 //
     /*  890138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890206 */     GIR_RootConstrainSelectedInstOperands,
     /*  890207 */     // GIR_Coverage, 61232,
     /*  890207 */     GIR_EraseRootFromParent_Done,
     /*  890208 */   // Label 13584: @890208
     /*  890208 */   GIM_Try, /*On fail goto*//*Label 13585*/ GIMT_Encode4(890283), // Rule ID 61233 //
     /*  890213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  890224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  890227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  890230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890259 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890281 */     GIR_RootConstrainSelectedInstOperands,
     /*  890282 */     // GIR_Coverage, 61233,
     /*  890282 */     GIR_EraseRootFromParent_Done,
     /*  890283 */   // Label 13585: @890283
     /*  890283 */   GIM_Try, /*On fail goto*//*Label 13586*/ GIMT_Encode4(890358), // Rule ID 61236 //
     /*  890288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  890334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890356 */     GIR_RootConstrainSelectedInstOperands,
     /*  890357 */     // GIR_Coverage, 61236,
     /*  890357 */     GIR_EraseRootFromParent_Done,
     /*  890358 */   // Label 13586: @890358
     /*  890358 */   GIM_Try, /*On fail goto*//*Label 13587*/ GIMT_Encode4(890433), // Rule ID 61237 //
     /*  890363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  890374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  890377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  890380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890409 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  890409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  890428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890431 */     GIR_RootConstrainSelectedInstOperands,
     /*  890432 */     // GIR_Coverage, 61237,
     /*  890432 */     GIR_EraseRootFromParent_Done,
     /*  890433 */   // Label 13587: @890433
     /*  890433 */   GIM_Try, /*On fail goto*//*Label 13588*/ GIMT_Encode4(890508), // Rule ID 61240 //
     /*  890438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  890449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  890452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  890455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890506 */     GIR_RootConstrainSelectedInstOperands,
     /*  890507 */     // GIR_Coverage, 61240,
     /*  890507 */     GIR_EraseRootFromParent_Done,
     /*  890508 */   // Label 13588: @890508
     /*  890508 */   GIM_Try, /*On fail goto*//*Label 13589*/ GIMT_Encode4(890583), // Rule ID 61241 //
     /*  890513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  890524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  890527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  890530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890559 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890581 */     GIR_RootConstrainSelectedInstOperands,
     /*  890582 */     // GIR_Coverage, 61241,
     /*  890582 */     GIR_EraseRootFromParent_Done,
     /*  890583 */   // Label 13589: @890583
     /*  890583 */   GIM_Try, /*On fail goto*//*Label 13590*/ GIMT_Encode4(890658), // Rule ID 61244 //
     /*  890588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  890599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  890602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  890605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890634 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890656 */     GIR_RootConstrainSelectedInstOperands,
     /*  890657 */     // GIR_Coverage, 61244,
     /*  890657 */     GIR_EraseRootFromParent_Done,
     /*  890658 */   // Label 13590: @890658
     /*  890658 */   GIM_Try, /*On fail goto*//*Label 13591*/ GIMT_Encode4(890733), // Rule ID 61245 //
     /*  890663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  890674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  890677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  890680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  890698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890709 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  890712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890731 */     GIR_RootConstrainSelectedInstOperands,
     /*  890732 */     // GIR_Coverage, 61245,
     /*  890732 */     GIR_EraseRootFromParent_Done,
     /*  890733 */   // Label 13591: @890733
     /*  890733 */   GIM_Try, /*On fail goto*//*Label 13592*/ GIMT_Encode4(890808), // Rule ID 61248 //
     /*  890738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  890749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  890752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  890755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  890784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890806 */     GIR_RootConstrainSelectedInstOperands,
     /*  890807 */     // GIR_Coverage, 61248,
     /*  890807 */     GIR_EraseRootFromParent_Done,
     /*  890808 */   // Label 13592: @890808
     /*  890808 */   GIM_Try, /*On fail goto*//*Label 13593*/ GIMT_Encode4(890883), // Rule ID 61249 //
     /*  890813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  890824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  890827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  890830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  890848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890859 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  890859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  890862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  890878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890881 */     GIR_RootConstrainSelectedInstOperands,
     /*  890882 */     // GIR_Coverage, 61249,
     /*  890882 */     GIR_EraseRootFromParent_Done,
     /*  890883 */   // Label 13593: @890883
     /*  890883 */   GIM_Try, /*On fail goto*//*Label 13594*/ GIMT_Encode4(890958), // Rule ID 61252 //
     /*  890888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  890891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  890899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  890902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  890905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  890908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  890911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  890927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  890934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  890934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  890937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  890939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  890941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  890943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  890945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  890950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  890953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  890956 */     GIR_RootConstrainSelectedInstOperands,
     /*  890957 */     // GIR_Coverage, 61252,
     /*  890957 */     GIR_EraseRootFromParent_Done,
     /*  890958 */   // Label 13594: @890958
     /*  890958 */   GIM_Try, /*On fail goto*//*Label 13595*/ GIMT_Encode4(891033), // Rule ID 61253 //
     /*  890963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  890966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  890971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  890974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  890977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  890980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  890983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  890986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  890998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891009 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11089:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2),
     /*  891012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891031 */     GIR_RootConstrainSelectedInstOperands,
     /*  891032 */     // GIR_Coverage, 61253,
     /*  891032 */     GIR_EraseRootFromParent_Done,
     /*  891033 */   // Label 13595: @891033
     /*  891033 */   GIM_Try, /*On fail goto*//*Label 13596*/ GIMT_Encode4(891108), // Rule ID 61256 //
     /*  891038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891106 */     GIR_RootConstrainSelectedInstOperands,
     /*  891107 */     // GIR_Coverage, 61256,
     /*  891107 */     GIR_EraseRootFromParent_Done,
     /*  891108 */   // Label 13596: @891108
     /*  891108 */   GIM_Try, /*On fail goto*//*Label 13597*/ GIMT_Encode4(891183), // Rule ID 61257 //
     /*  891113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  891124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  891127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  891130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  891148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11089:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4),
     /*  891162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891181 */     GIR_RootConstrainSelectedInstOperands,
     /*  891182 */     // GIR_Coverage, 61257,
     /*  891182 */     GIR_EraseRootFromParent_Done,
     /*  891183 */   // Label 13597: @891183
     /*  891183 */   GIM_Try, /*On fail goto*//*Label 13598*/ GIMT_Encode4(891258), // Rule ID 61260 //
     /*  891188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  891208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891234 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  891234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891256 */     GIR_RootConstrainSelectedInstOperands,
     /*  891257 */     // GIR_Coverage, 61260,
     /*  891257 */     GIR_EraseRootFromParent_Done,
     /*  891258 */   // Label 13598: @891258
     /*  891258 */   GIM_Try, /*On fail goto*//*Label 13599*/ GIMT_Encode4(891333), // Rule ID 61261 //
     /*  891263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn),
     /*  891271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  891274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  891277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  891280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  891283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  891298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  891302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11089:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVANDN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  891309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8),
     /*  891312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  891328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891331 */     GIR_RootConstrainSelectedInstOperands,
     /*  891332 */     // GIR_Coverage, 61261,
     /*  891332 */     GIR_EraseRootFromParent_Done,
     /*  891333 */   // Label 13599: @891333
     /*  891333 */   GIM_Try, /*On fail goto*//*Label 13600*/ GIMT_Encode4(891408), // Rule ID 61440 //
     /*  891338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891384 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  891384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891406 */     GIR_RootConstrainSelectedInstOperands,
     /*  891407 */     // GIR_Coverage, 61440,
     /*  891407 */     GIR_EraseRootFromParent_Done,
     /*  891408 */   // Label 13600: @891408
     /*  891408 */   GIM_Try, /*On fail goto*//*Label 13601*/ GIMT_Encode4(891483), // Rule ID 61441 //
     /*  891413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  891424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  891427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  891430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  891433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891459 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /*  891462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891481 */     GIR_RootConstrainSelectedInstOperands,
     /*  891482 */     // GIR_Coverage, 61441,
     /*  891482 */     GIR_EraseRootFromParent_Done,
     /*  891483 */   // Label 13601: @891483
     /*  891483 */   GIM_Try, /*On fail goto*//*Label 13602*/ GIMT_Encode4(891558), // Rule ID 61444 //
     /*  891488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  891499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  891502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  891505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  891508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891534 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  891534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  891537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891556 */     GIR_RootConstrainSelectedInstOperands,
     /*  891557 */     // GIR_Coverage, 61444,
     /*  891557 */     GIR_EraseRootFromParent_Done,
     /*  891558 */   // Label 13602: @891558
     /*  891558 */   GIM_Try, /*On fail goto*//*Label 13603*/ GIMT_Encode4(891633), // Rule ID 61445 //
     /*  891563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  891574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  891577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  891580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  891583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891609 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  891612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891631 */     GIR_RootConstrainSelectedInstOperands,
     /*  891632 */     // GIR_Coverage, 61445,
     /*  891632 */     GIR_EraseRootFromParent_Done,
     /*  891633 */   // Label 13603: @891633
     /*  891633 */   GIM_Try, /*On fail goto*//*Label 13604*/ GIMT_Encode4(891708), // Rule ID 61448 //
     /*  891638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  891649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  891652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  891655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  891658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891684 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  891684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  891687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891706 */     GIR_RootConstrainSelectedInstOperands,
     /*  891707 */     // GIR_Coverage, 61448,
     /*  891707 */     GIR_EraseRootFromParent_Done,
     /*  891708 */   // Label 13604: @891708
     /*  891708 */   GIM_Try, /*On fail goto*//*Label 13605*/ GIMT_Encode4(891783), // Rule ID 61449 //
     /*  891713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  891724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  891727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  891730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  891733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  891759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  891762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  891778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891781 */     GIR_RootConstrainSelectedInstOperands,
     /*  891782 */     // GIR_Coverage, 61449,
     /*  891782 */     GIR_EraseRootFromParent_Done,
     /*  891783 */   // Label 13605: @891783
     /*  891783 */   GIM_Try, /*On fail goto*//*Label 13606*/ GIMT_Encode4(891858), // Rule ID 61452 //
     /*  891788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  891799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  891802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  891805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  891808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891834 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  891837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891856 */     GIR_RootConstrainSelectedInstOperands,
     /*  891857 */     // GIR_Coverage, 61452,
     /*  891857 */     GIR_EraseRootFromParent_Done,
     /*  891858 */   // Label 13606: @891858
     /*  891858 */   GIM_Try, /*On fail goto*//*Label 13607*/ GIMT_Encode4(891933), // Rule ID 61453 //
     /*  891863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  891866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  891874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  891877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  891880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  891883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  891886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891909 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  891909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /*  891912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  891925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  891928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  891931 */     GIR_RootConstrainSelectedInstOperands,
     /*  891932 */     // GIR_Coverage, 61453,
     /*  891932 */     GIR_EraseRootFromParent_Done,
     /*  891933 */   // Label 13607: @891933
     /*  891933 */   GIM_Try, /*On fail goto*//*Label 13608*/ GIMT_Encode4(892008), // Rule ID 61456 //
     /*  891938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  891941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  891946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  891949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  891952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  891955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  891958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  891961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  891977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  891984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  891984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  891987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  891989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  891991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  891993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  891995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892006 */     GIR_RootConstrainSelectedInstOperands,
     /*  892007 */     // GIR_Coverage, 61456,
     /*  892007 */     GIR_EraseRootFromParent_Done,
     /*  892008 */   // Label 13608: @892008
     /*  892008 */   GIM_Try, /*On fail goto*//*Label 13609*/ GIMT_Encode4(892083), // Rule ID 61457 //
     /*  892013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  892024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  892027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  892030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  892033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892081 */     GIR_RootConstrainSelectedInstOperands,
     /*  892082 */     // GIR_Coverage, 61457,
     /*  892082 */     GIR_EraseRootFromParent_Done,
     /*  892083 */   // Label 13609: @892083
     /*  892083 */   GIM_Try, /*On fail goto*//*Label 13610*/ GIMT_Encode4(892158), // Rule ID 61460 //
     /*  892088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  892134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892156 */     GIR_RootConstrainSelectedInstOperands,
     /*  892157 */     // GIR_Coverage, 61460,
     /*  892157 */     GIR_EraseRootFromParent_Done,
     /*  892158 */   // Label 13610: @892158
     /*  892158 */   GIM_Try, /*On fail goto*//*Label 13611*/ GIMT_Encode4(892233), // Rule ID 61461 //
     /*  892163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  892174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  892177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  892180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  892183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892209 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  892209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /*  892212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892231 */     GIR_RootConstrainSelectedInstOperands,
     /*  892232 */     // GIR_Coverage, 61461,
     /*  892232 */     GIR_EraseRootFromParent_Done,
     /*  892233 */   // Label 13611: @892233
     /*  892233 */   GIM_Try, /*On fail goto*//*Label 13612*/ GIMT_Encode4(892308), // Rule ID 61464 //
     /*  892238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892306 */     GIR_RootConstrainSelectedInstOperands,
     /*  892307 */     // GIR_Coverage, 61464,
     /*  892307 */     GIR_EraseRootFromParent_Done,
     /*  892308 */   // Label 13612: @892308
     /*  892308 */   GIM_Try, /*On fail goto*//*Label 13613*/ GIMT_Encode4(892383), // Rule ID 61465 //
     /*  892313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  892324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  892327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  892330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  892333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892381 */     GIR_RootConstrainSelectedInstOperands,
     /*  892382 */     // GIR_Coverage, 61465,
     /*  892382 */     GIR_EraseRootFromParent_Done,
     /*  892383 */   // Label 13613: @892383
     /*  892383 */   GIM_Try, /*On fail goto*//*Label 13614*/ GIMT_Encode4(892458), // Rule ID 61468 //
     /*  892388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  892405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  892408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892434 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  892434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892456 */     GIR_RootConstrainSelectedInstOperands,
     /*  892457 */     // GIR_Coverage, 61468,
     /*  892457 */     GIR_EraseRootFromParent_Done,
     /*  892458 */   // Label 13614: @892458
     /*  892458 */   GIM_Try, /*On fail goto*//*Label 13615*/ GIMT_Encode4(892533), // Rule ID 61469 //
     /*  892463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  892474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  892477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  892480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  892483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  892509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  892528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892531 */     GIR_RootConstrainSelectedInstOperands,
     /*  892532 */     // GIR_Coverage, 61469,
     /*  892532 */     GIR_EraseRootFromParent_Done,
     /*  892533 */   // Label 13615: @892533
     /*  892533 */   GIM_Try, /*On fail goto*//*Label 13616*/ GIMT_Encode4(892608), // Rule ID 61472 //
     /*  892538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  892549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  892552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  892555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  892558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  892584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892606 */     GIR_RootConstrainSelectedInstOperands,
     /*  892607 */     // GIR_Coverage, 61472,
     /*  892607 */     GIR_EraseRootFromParent_Done,
     /*  892608 */   // Label 13616: @892608
     /*  892608 */   GIM_Try, /*On fail goto*//*Label 13617*/ GIMT_Encode4(892683), // Rule ID 61473 //
     /*  892613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  892624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  892627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  892630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  892633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  892659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  892678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892681 */     GIR_RootConstrainSelectedInstOperands,
     /*  892682 */     // GIR_Coverage, 61473,
     /*  892682 */     GIR_EraseRootFromParent_Done,
     /*  892683 */   // Label 13617: @892683
     /*  892683 */   GIM_Try, /*On fail goto*//*Label 13618*/ GIMT_Encode4(892758), // Rule ID 61476 //
     /*  892688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  892699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  892702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  892705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  892708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892734 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  892734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892756 */     GIR_RootConstrainSelectedInstOperands,
     /*  892757 */     // GIR_Coverage, 61476,
     /*  892757 */     GIR_EraseRootFromParent_Done,
     /*  892758 */   // Label 13618: @892758
     /*  892758 */   GIM_Try, /*On fail goto*//*Label 13619*/ GIMT_Encode4(892833), // Rule ID 61477 //
     /*  892763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  892774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  892777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  892780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  892783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  892802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892809 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  892809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /*  892812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  892828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892831 */     GIR_RootConstrainSelectedInstOperands,
     /*  892832 */     // GIR_Coverage, 61477,
     /*  892832 */     GIR_EraseRootFromParent_Done,
     /*  892833 */   // Label 13619: @892833
     /*  892833 */   GIM_Try, /*On fail goto*//*Label 13620*/ GIMT_Encode4(892908), // Rule ID 61480 //
     /*  892838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  892849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  892852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  892855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  892858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  892861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  892884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  892887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892906 */     GIR_RootConstrainSelectedInstOperands,
     /*  892907 */     // GIR_Coverage, 61480,
     /*  892907 */     GIR_EraseRootFromParent_Done,
     /*  892908 */   // Label 13620: @892908
     /*  892908 */   GIM_Try, /*On fail goto*//*Label 13621*/ GIMT_Encode4(892983), // Rule ID 61481 //
     /*  892913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  892916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  892924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  892927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  892930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  892933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  892936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  892952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  892959 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  892959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  892962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  892964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  892966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  892968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  892970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  892975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  892978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  892981 */     GIR_RootConstrainSelectedInstOperands,
     /*  892982 */     // GIR_Coverage, 61481,
     /*  892982 */     GIR_EraseRootFromParent_Done,
     /*  892983 */   // Label 13621: @892983
     /*  892983 */   GIM_Try, /*On fail goto*//*Label 13622*/ GIMT_Encode4(893058), // Rule ID 61484 //
     /*  892988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  892991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  892996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  892999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893034 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893056 */     GIR_RootConstrainSelectedInstOperands,
     /*  893057 */     // GIR_Coverage, 61484,
     /*  893057 */     GIR_EraseRootFromParent_Done,
     /*  893058 */   // Label 13622: @893058
     /*  893058 */   GIM_Try, /*On fail goto*//*Label 13623*/ GIMT_Encode4(893133), // Rule ID 61485 //
     /*  893063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  893074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  893077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  893080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  893083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893109 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893131 */     GIR_RootConstrainSelectedInstOperands,
     /*  893132 */     // GIR_Coverage, 61485,
     /*  893132 */     GIR_EraseRootFromParent_Done,
     /*  893133 */   // Label 13623: @893133
     /*  893133 */   GIM_Try, /*On fail goto*//*Label 13624*/ GIMT_Encode4(893208), // Rule ID 61488 //
     /*  893138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893184 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  893184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893206 */     GIR_RootConstrainSelectedInstOperands,
     /*  893207 */     // GIR_Coverage, 61488,
     /*  893207 */     GIR_EraseRootFromParent_Done,
     /*  893208 */   // Label 13624: @893208
     /*  893208 */   GIM_Try, /*On fail goto*//*Label 13625*/ GIMT_Encode4(893283), // Rule ID 61489 //
     /*  893213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  893224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  893227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  893230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  893233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893259 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  893259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  893278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893281 */     GIR_RootConstrainSelectedInstOperands,
     /*  893282 */     // GIR_Coverage, 61489,
     /*  893282 */     GIR_EraseRootFromParent_Done,
     /*  893283 */   // Label 13625: @893283
     /*  893283 */   GIM_Try, /*On fail goto*//*Label 13626*/ GIMT_Encode4(893358), // Rule ID 61492 //
     /*  893288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893356 */     GIR_RootConstrainSelectedInstOperands,
     /*  893357 */     // GIR_Coverage, 61492,
     /*  893357 */     GIR_EraseRootFromParent_Done,
     /*  893358 */   // Label 13626: @893358
     /*  893358 */   GIM_Try, /*On fail goto*//*Label 13627*/ GIMT_Encode4(893433), // Rule ID 61493 //
     /*  893363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  893374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  893377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  893380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  893383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893409 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893431 */     GIR_RootConstrainSelectedInstOperands,
     /*  893432 */     // GIR_Coverage, 61493,
     /*  893432 */     GIR_EraseRootFromParent_Done,
     /*  893433 */   // Label 13627: @893433
     /*  893433 */   GIM_Try, /*On fail goto*//*Label 13628*/ GIMT_Encode4(893508), // Rule ID 61496 //
     /*  893438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  893449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  893452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  893455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  893458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893484 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893506 */     GIR_RootConstrainSelectedInstOperands,
     /*  893507 */     // GIR_Coverage, 61496,
     /*  893507 */     GIR_EraseRootFromParent_Done,
     /*  893508 */   // Label 13628: @893508
     /*  893508 */   GIM_Try, /*On fail goto*//*Label 13629*/ GIMT_Encode4(893583), // Rule ID 61497 //
     /*  893513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  893524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  893527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  893530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  893533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893559 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893581 */     GIR_RootConstrainSelectedInstOperands,
     /*  893582 */     // GIR_Coverage, 61497,
     /*  893582 */     GIR_EraseRootFromParent_Done,
     /*  893583 */   // Label 13629: @893583
     /*  893583 */   GIM_Try, /*On fail goto*//*Label 13630*/ GIMT_Encode4(893658), // Rule ID 61500 //
     /*  893588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  893599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  893602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  893605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  893608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893634 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  893634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893656 */     GIR_RootConstrainSelectedInstOperands,
     /*  893657 */     // GIR_Coverage, 61500,
     /*  893657 */     GIR_EraseRootFromParent_Done,
     /*  893658 */   // Label 13630: @893658
     /*  893658 */   GIM_Try, /*On fail goto*//*Label 13631*/ GIMT_Encode4(893733), // Rule ID 61501 //
     /*  893663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  893674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  893677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  893680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  893683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  893702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893709 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  893709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  893712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  893728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893731 */     GIR_RootConstrainSelectedInstOperands,
     /*  893732 */     // GIR_Coverage, 61501,
     /*  893732 */     GIR_EraseRootFromParent_Done,
     /*  893733 */   // Label 13631: @893733
     /*  893733 */   GIM_Try, /*On fail goto*//*Label 13632*/ GIMT_Encode4(893808), // Rule ID 61504 //
     /*  893738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  893749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  893752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  893755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  893758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893806 */     GIR_RootConstrainSelectedInstOperands,
     /*  893807 */     // GIR_Coverage, 61504,
     /*  893807 */     GIR_EraseRootFromParent_Done,
     /*  893808 */   // Label 13632: @893808
     /*  893808 */   GIM_Try, /*On fail goto*//*Label 13633*/ GIMT_Encode4(893883), // Rule ID 61505 //
     /*  893813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  893824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  893827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  893830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  893833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  893852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893859 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  893859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  893862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893881 */     GIR_RootConstrainSelectedInstOperands,
     /*  893882 */     // GIR_Coverage, 61505,
     /*  893882 */     GIR_EraseRootFromParent_Done,
     /*  893883 */   // Label 13633: @893883
     /*  893883 */   GIM_Try, /*On fail goto*//*Label 13634*/ GIMT_Encode4(893958), // Rule ID 61508 //
     /*  893888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  893891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  893899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  893902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  893905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  893908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  893911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  893934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  893934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  893937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  893939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  893941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  893943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  893945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  893950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  893953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  893956 */     GIR_RootConstrainSelectedInstOperands,
     /*  893957 */     // GIR_Coverage, 61508,
     /*  893957 */     GIR_EraseRootFromParent_Done,
     /*  893958 */   // Label 13634: @893958
     /*  893958 */   GIM_Try, /*On fail goto*//*Label 13635*/ GIMT_Encode4(894033), // Rule ID 61509 //
     /*  893963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  893966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  893971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  893974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  893977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  893980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  893983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  893986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  893998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894009 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894031 */     GIR_RootConstrainSelectedInstOperands,
     /*  894032 */     // GIR_Coverage, 61509,
     /*  894032 */     GIR_EraseRootFromParent_Done,
     /*  894033 */   // Label 13635: @894033
     /*  894033 */   GIM_Try, /*On fail goto*//*Label 13636*/ GIMT_Encode4(894108), // Rule ID 61512 //
     /*  894038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894084 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  894084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894106 */     GIR_RootConstrainSelectedInstOperands,
     /*  894107 */     // GIR_Coverage, 61512,
     /*  894107 */     GIR_EraseRootFromParent_Done,
     /*  894108 */   // Label 13636: @894108
     /*  894108 */   GIM_Try, /*On fail goto*//*Label 13637*/ GIMT_Encode4(894183), // Rule ID 61513 //
     /*  894113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  894124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  894127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  894130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  894133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894159 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  894159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  894178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894181 */     GIR_RootConstrainSelectedInstOperands,
     /*  894182 */     // GIR_Coverage, 61513,
     /*  894182 */     GIR_EraseRootFromParent_Done,
     /*  894183 */   // Label 13637: @894183
     /*  894183 */   GIM_Try, /*On fail goto*//*Label 13638*/ GIMT_Encode4(894258), // Rule ID 61516 //
     /*  894188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894256 */     GIR_RootConstrainSelectedInstOperands,
     /*  894257 */     // GIR_Coverage, 61516,
     /*  894257 */     GIR_EraseRootFromParent_Done,
     /*  894258 */   // Label 13638: @894258
     /*  894258 */   GIM_Try, /*On fail goto*//*Label 13639*/ GIMT_Encode4(894333), // Rule ID 61517 //
     /*  894263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  894274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  894277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  894280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  894283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  894302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894309 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /*  894312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894331 */     GIR_RootConstrainSelectedInstOperands,
     /*  894332 */     // GIR_Coverage, 61517,
     /*  894332 */     GIR_EraseRootFromParent_Done,
     /*  894333 */   // Label 13639: @894333
     /*  894333 */   GIM_Try, /*On fail goto*//*Label 13640*/ GIMT_Encode4(894408), // Rule ID 61520 //
     /*  894338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894384 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894406 */     GIR_RootConstrainSelectedInstOperands,
     /*  894407 */     // GIR_Coverage, 61520,
     /*  894407 */     GIR_EraseRootFromParent_Done,
     /*  894408 */   // Label 13640: @894408
     /*  894408 */   GIM_Try, /*On fail goto*//*Label 13641*/ GIMT_Encode4(894483), // Rule ID 61521 //
     /*  894413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  894424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  894427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  894430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  894433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  894452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894459 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /*  894462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894481 */     GIR_RootConstrainSelectedInstOperands,
     /*  894482 */     // GIR_Coverage, 61521,
     /*  894482 */     GIR_EraseRootFromParent_Done,
     /*  894483 */   // Label 13641: @894483
     /*  894483 */   GIM_Try, /*On fail goto*//*Label 13642*/ GIMT_Encode4(894558), // Rule ID 61524 //
     /*  894488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  894499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  894502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  894505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  894508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  894534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894556 */     GIR_RootConstrainSelectedInstOperands,
     /*  894557 */     // GIR_Coverage, 61524,
     /*  894557 */     GIR_EraseRootFromParent_Done,
     /*  894558 */   // Label 13642: @894558
     /*  894558 */   GIM_Try, /*On fail goto*//*Label 13643*/ GIMT_Encode4(894633), // Rule ID 61525 //
     /*  894563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  894574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  894577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  894580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  894583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  894602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894609 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  894609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /*  894612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  894628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894631 */     GIR_RootConstrainSelectedInstOperands,
     /*  894632 */     // GIR_Coverage, 61525,
     /*  894632 */     GIR_EraseRootFromParent_Done,
     /*  894633 */   // Label 13643: @894633
     /*  894633 */   GIM_Try, /*On fail goto*//*Label 13644*/ GIMT_Encode4(894708), // Rule ID 61528 //
     /*  894638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  894649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  894652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  894655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894684 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  894687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894706 */     GIR_RootConstrainSelectedInstOperands,
     /*  894707 */     // GIR_Coverage, 61528,
     /*  894707 */     GIR_EraseRootFromParent_Done,
     /*  894708 */   // Label 13644: @894708
     /*  894708 */   GIM_Try, /*On fail goto*//*Label 13645*/ GIMT_Encode4(894783), // Rule ID 61529 //
     /*  894713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  894724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  894727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  894730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894759 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8),
     /*  894762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894781 */     GIR_RootConstrainSelectedInstOperands,
     /*  894782 */     // GIR_Coverage, 61529,
     /*  894782 */     GIR_EraseRootFromParent_Done,
     /*  894783 */   // Label 13645: @894783
     /*  894783 */   GIM_Try, /*On fail goto*//*Label 13646*/ GIMT_Encode4(894858), // Rule ID 61532 //
     /*  894788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  894799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  894802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  894805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894834 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  894837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894856 */     GIR_RootConstrainSelectedInstOperands,
     /*  894857 */     // GIR_Coverage, 61532,
     /*  894857 */     GIR_EraseRootFromParent_Done,
     /*  894858 */   // Label 13646: @894858
     /*  894858 */   GIM_Try, /*On fail goto*//*Label 13647*/ GIMT_Encode4(894933), // Rule ID 61533 //
     /*  894863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  894866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  894874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  894877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  894880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  894883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  894886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894909 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  894909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  894912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  894925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  894928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  894931 */     GIR_RootConstrainSelectedInstOperands,
     /*  894932 */     // GIR_Coverage, 61533,
     /*  894932 */     GIR_EraseRootFromParent_Done,
     /*  894933 */   // Label 13647: @894933
     /*  894933 */   GIM_Try, /*On fail goto*//*Label 13648*/ GIMT_Encode4(895008), // Rule ID 61536 //
     /*  894938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  894941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  894946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  894949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  894952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  894955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  894958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  894961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  894973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  894977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  894984 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  894984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  894987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  894989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  894991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  894993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  894995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895006 */     GIR_RootConstrainSelectedInstOperands,
     /*  895007 */     // GIR_Coverage, 61536,
     /*  895007 */     GIR_EraseRootFromParent_Done,
     /*  895008 */   // Label 13648: @895008
     /*  895008 */   GIM_Try, /*On fail goto*//*Label 13649*/ GIMT_Encode4(895083), // Rule ID 61537 //
     /*  895013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  895024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  895027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  895030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895059 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895081 */     GIR_RootConstrainSelectedInstOperands,
     /*  895082 */     // GIR_Coverage, 61537,
     /*  895082 */     GIR_EraseRootFromParent_Done,
     /*  895083 */   // Label 13649: @895083
     /*  895083 */   GIM_Try, /*On fail goto*//*Label 13650*/ GIMT_Encode4(895158), // Rule ID 61540 //
     /*  895088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895134 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895156 */     GIR_RootConstrainSelectedInstOperands,
     /*  895157 */     // GIR_Coverage, 61540,
     /*  895157 */     GIR_EraseRootFromParent_Done,
     /*  895158 */   // Label 13650: @895158
     /*  895158 */   GIM_Try, /*On fail goto*//*Label 13651*/ GIMT_Encode4(895233), // Rule ID 61541 //
     /*  895163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  895174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  895177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  895180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895209 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4),
     /*  895212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895231 */     GIR_RootConstrainSelectedInstOperands,
     /*  895232 */     // GIR_Coverage, 61541,
     /*  895232 */     GIR_EraseRootFromParent_Done,
     /*  895233 */   // Label 13651: @895233
     /*  895233 */   GIM_Try, /*On fail goto*//*Label 13652*/ GIMT_Encode4(895308), // Rule ID 61544 //
     /*  895238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895306 */     GIR_RootConstrainSelectedInstOperands,
     /*  895307 */     // GIR_Coverage, 61544,
     /*  895307 */     GIR_EraseRootFromParent_Done,
     /*  895308 */   // Label 13652: @895308
     /*  895308 */   GIM_Try, /*On fail goto*//*Label 13653*/ GIMT_Encode4(895383), // Rule ID 61545 //
     /*  895313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  895324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  895327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  895330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895359 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895381 */     GIR_RootConstrainSelectedInstOperands,
     /*  895382 */     // GIR_Coverage, 61545,
     /*  895382 */     GIR_EraseRootFromParent_Done,
     /*  895383 */   // Label 13653: @895383
     /*  895383 */   GIM_Try, /*On fail goto*//*Label 13654*/ GIMT_Encode4(895458), // Rule ID 61548 //
     /*  895388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895456 */     GIR_RootConstrainSelectedInstOperands,
     /*  895457 */     // GIR_Coverage, 61548,
     /*  895457 */     GIR_EraseRootFromParent_Done,
     /*  895458 */   // Label 13654: @895458
     /*  895458 */   GIM_Try, /*On fail goto*//*Label 13655*/ GIMT_Encode4(895533), // Rule ID 61549 //
     /*  895463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  895474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  895477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  895480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895509 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2),
     /*  895512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895531 */     GIR_RootConstrainSelectedInstOperands,
     /*  895532 */     // GIR_Coverage, 61549,
     /*  895532 */     GIR_EraseRootFromParent_Done,
     /*  895533 */   // Label 13655: @895533
     /*  895533 */   GIM_Try, /*On fail goto*//*Label 13656*/ GIMT_Encode4(895608), // Rule ID 61552 //
     /*  895538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  895549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  895552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  895555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895584 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  895584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895606 */     GIR_RootConstrainSelectedInstOperands,
     /*  895607 */     // GIR_Coverage, 61552,
     /*  895607 */     GIR_EraseRootFromParent_Done,
     /*  895608 */   // Label 13656: @895608
     /*  895608 */   GIM_Try, /*On fail goto*//*Label 13657*/ GIMT_Encode4(895683), // Rule ID 61553 //
     /*  895613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  895624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  895627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  895630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895659 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11456:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  895659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  895678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895681 */     GIR_RootConstrainSelectedInstOperands,
     /*  895682 */     // GIR_Coverage, 61553,
     /*  895682 */     GIR_EraseRootFromParent_Done,
     /*  895683 */   // Label 13657: @895683
     /*  895683 */   GIM_Try, /*On fail goto*//*Label 13658*/ GIMT_Encode4(895758), // Rule ID 61556 //
     /*  895688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  895699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  895702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  895705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895734 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  895734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895756 */     GIR_RootConstrainSelectedInstOperands,
     /*  895757 */     // GIR_Coverage, 61556,
     /*  895757 */     GIR_EraseRootFromParent_Done,
     /*  895758 */   // Label 13658: @895758
     /*  895758 */   GIM_Try, /*On fail goto*//*Label 13659*/ GIMT_Encode4(895833), // Rule ID 61557 //
     /*  895763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  895774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  895777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  895780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11456:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  895809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  895828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895831 */     GIR_RootConstrainSelectedInstOperands,
     /*  895832 */     // GIR_Coverage, 61557,
     /*  895832 */     GIR_EraseRootFromParent_Done,
     /*  895833 */   // Label 13659: @895833
     /*  895833 */   GIM_Try, /*On fail goto*//*Label 13660*/ GIMT_Encode4(895908), // Rule ID 61560 //
     /*  895838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  895849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  895852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  895855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  895858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  895861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  895884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895906 */     GIR_RootConstrainSelectedInstOperands,
     /*  895907 */     // GIR_Coverage, 61560,
     /*  895907 */     GIR_EraseRootFromParent_Done,
     /*  895908 */   // Label 13660: @895908
     /*  895908 */   GIM_Try, /*On fail goto*//*Label 13661*/ GIMT_Encode4(895983), // Rule ID 61561 //
     /*  895913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  895916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  895924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  895927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  895930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  895933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  895936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  895948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  895952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  895959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11456:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  895959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  895962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  895964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  895966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  895968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  895970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  895975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  895978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  895981 */     GIR_RootConstrainSelectedInstOperands,
     /*  895982 */     // GIR_Coverage, 61561,
     /*  895982 */     GIR_EraseRootFromParent_Done,
     /*  895983 */   // Label 13661: @895983
     /*  895983 */   GIM_Try, /*On fail goto*//*Label 13662*/ GIMT_Encode4(896058), // Rule ID 61564 //
     /*  895988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  895991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  895996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  895999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  896034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896056 */     GIR_RootConstrainSelectedInstOperands,
     /*  896057 */     // GIR_Coverage, 61564,
     /*  896057 */     GIR_EraseRootFromParent_Done,
     /*  896058 */   // Label 13662: @896058
     /*  896058 */   GIM_Try, /*On fail goto*//*Label 13663*/ GIMT_Encode4(896133), // Rule ID 61565 //
     /*  896063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  896074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  896077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  896080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  896098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896109 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11456:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  896109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1),
     /*  896112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  896128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896131 */     GIR_RootConstrainSelectedInstOperands,
     /*  896132 */     // GIR_Coverage, 61565,
     /*  896132 */     GIR_EraseRootFromParent_Done,
     /*  896133 */   // Label 13663: @896133
     /*  896133 */   GIM_Try, /*On fail goto*//*Label 13664*/ GIMT_Encode4(896208), // Rule ID 61568 //
     /*  896138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896206 */     GIR_RootConstrainSelectedInstOperands,
     /*  896207 */     // GIR_Coverage, 61568,
     /*  896207 */     GIR_EraseRootFromParent_Done,
     /*  896208 */   // Label 13664: @896208
     /*  896208 */   GIM_Try, /*On fail goto*//*Label 13665*/ GIMT_Encode4(896283), // Rule ID 61569 //
     /*  896213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  896224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  896227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  896230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896259 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896281 */     GIR_RootConstrainSelectedInstOperands,
     /*  896282 */     // GIR_Coverage, 61569,
     /*  896282 */     GIR_EraseRootFromParent_Done,
     /*  896283 */   // Label 13665: @896283
     /*  896283 */   GIM_Try, /*On fail goto*//*Label 13666*/ GIMT_Encode4(896358), // Rule ID 61572 //
     /*  896288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896356 */     GIR_RootConstrainSelectedInstOperands,
     /*  896357 */     // GIR_Coverage, 61572,
     /*  896357 */     GIR_EraseRootFromParent_Done,
     /*  896358 */   // Label 13666: @896358
     /*  896358 */   GIM_Try, /*On fail goto*//*Label 13667*/ GIMT_Encode4(896433), // Rule ID 61573 //
     /*  896363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  896374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  896377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  896380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896409 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896431 */     GIR_RootConstrainSelectedInstOperands,
     /*  896432 */     // GIR_Coverage, 61573,
     /*  896432 */     GIR_EraseRootFromParent_Done,
     /*  896433 */   // Label 13667: @896433
     /*  896433 */   GIM_Try, /*On fail goto*//*Label 13668*/ GIMT_Encode4(896508), // Rule ID 61576 //
     /*  896438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  896484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  896487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896506 */     GIR_RootConstrainSelectedInstOperands,
     /*  896507 */     // GIR_Coverage, 61576,
     /*  896507 */     GIR_EraseRootFromParent_Done,
     /*  896508 */   // Label 13668: @896508
     /*  896508 */   GIM_Try, /*On fail goto*//*Label 13669*/ GIMT_Encode4(896583), // Rule ID 61577 //
     /*  896513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  896524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  896527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  896530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896559 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  896559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  896562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  896578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896581 */     GIR_RootConstrainSelectedInstOperands,
     /*  896582 */     // GIR_Coverage, 61577,
     /*  896582 */     GIR_EraseRootFromParent_Done,
     /*  896583 */   // Label 13669: @896583
     /*  896583 */   GIM_Try, /*On fail goto*//*Label 13670*/ GIMT_Encode4(896658), // Rule ID 61580 //
     /*  896588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  896599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  896602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  896605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896656 */     GIR_RootConstrainSelectedInstOperands,
     /*  896657 */     // GIR_Coverage, 61580,
     /*  896657 */     GIR_EraseRootFromParent_Done,
     /*  896658 */   // Label 13670: @896658
     /*  896658 */   GIM_Try, /*On fail goto*//*Label 13671*/ GIMT_Encode4(896733), // Rule ID 61581 //
     /*  896663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  896674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  896677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  896680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  896698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896709 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  896712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896731 */     GIR_RootConstrainSelectedInstOperands,
     /*  896732 */     // GIR_Coverage, 61581,
     /*  896732 */     GIR_EraseRootFromParent_Done,
     /*  896733 */   // Label 13671: @896733
     /*  896733 */   GIM_Try, /*On fail goto*//*Label 13672*/ GIMT_Encode4(896808), // Rule ID 61584 //
     /*  896738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  896749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  896752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  896755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896806 */     GIR_RootConstrainSelectedInstOperands,
     /*  896807 */     // GIR_Coverage, 61584,
     /*  896807 */     GIR_EraseRootFromParent_Done,
     /*  896808 */   // Label 13672: @896808
     /*  896808 */   GIM_Try, /*On fail goto*//*Label 13673*/ GIMT_Encode4(896883), // Rule ID 61585 //
     /*  896813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  896824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  896827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  896830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  896848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896859 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  896859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  896862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896881 */     GIR_RootConstrainSelectedInstOperands,
     /*  896882 */     // GIR_Coverage, 61585,
     /*  896882 */     GIR_EraseRootFromParent_Done,
     /*  896883 */   // Label 13673: @896883
     /*  896883 */   GIM_Try, /*On fail goto*//*Label 13674*/ GIMT_Encode4(896958), // Rule ID 61588 //
     /*  896888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  896891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  896899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  896902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  896905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  896908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  896911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  896927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  896934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  896934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  896937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  896939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  896941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  896943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  896945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  896950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  896953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  896956 */     GIR_RootConstrainSelectedInstOperands,
     /*  896957 */     // GIR_Coverage, 61588,
     /*  896957 */     GIR_EraseRootFromParent_Done,
     /*  896958 */   // Label 13674: @896958
     /*  896958 */   GIM_Try, /*On fail goto*//*Label 13675*/ GIMT_Encode4(897033), // Rule ID 61589 //
     /*  896963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  896966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  896971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  896974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  896977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  896980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  896983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  896986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  896998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897009 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  897009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  897028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897031 */     GIR_RootConstrainSelectedInstOperands,
     /*  897032 */     // GIR_Coverage, 61589,
     /*  897032 */     GIR_EraseRootFromParent_Done,
     /*  897033 */   // Label 13675: @897033
     /*  897033 */   GIM_Try, /*On fail goto*//*Label 13676*/ GIMT_Encode4(897108), // Rule ID 61592 //
     /*  897038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897106 */     GIR_RootConstrainSelectedInstOperands,
     /*  897107 */     // GIR_Coverage, 61592,
     /*  897107 */     GIR_EraseRootFromParent_Done,
     /*  897108 */   // Label 13676: @897108
     /*  897108 */   GIM_Try, /*On fail goto*//*Label 13677*/ GIMT_Encode4(897183), // Rule ID 61593 //
     /*  897113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  897124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  897127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  897130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897159 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897181 */     GIR_RootConstrainSelectedInstOperands,
     /*  897182 */     // GIR_Coverage, 61593,
     /*  897182 */     GIR_EraseRootFromParent_Done,
     /*  897183 */   // Label 13677: @897183
     /*  897183 */   GIM_Try, /*On fail goto*//*Label 13678*/ GIMT_Encode4(897258), // Rule ID 61596 //
     /*  897188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897256 */     GIR_RootConstrainSelectedInstOperands,
     /*  897257 */     // GIR_Coverage, 61596,
     /*  897257 */     GIR_EraseRootFromParent_Done,
     /*  897258 */   // Label 13678: @897258
     /*  897258 */   GIM_Try, /*On fail goto*//*Label 13679*/ GIMT_Encode4(897333), // Rule ID 61597 //
     /*  897263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  897274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  897277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  897280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897331 */     GIR_RootConstrainSelectedInstOperands,
     /*  897332 */     // GIR_Coverage, 61597,
     /*  897332 */     GIR_EraseRootFromParent_Done,
     /*  897333 */   // Label 13679: @897333
     /*  897333 */   GIM_Try, /*On fail goto*//*Label 13680*/ GIMT_Encode4(897408), // Rule ID 61600 //
     /*  897338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  897384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897406 */     GIR_RootConstrainSelectedInstOperands,
     /*  897407 */     // GIR_Coverage, 61600,
     /*  897407 */     GIR_EraseRootFromParent_Done,
     /*  897408 */   // Label 13680: @897408
     /*  897408 */   GIM_Try, /*On fail goto*//*Label 13681*/ GIMT_Encode4(897483), // Rule ID 61601 //
     /*  897413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  897424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  897427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  897430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  897459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  897478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897481 */     GIR_RootConstrainSelectedInstOperands,
     /*  897482 */     // GIR_Coverage, 61601,
     /*  897482 */     GIR_EraseRootFromParent_Done,
     /*  897483 */   // Label 13681: @897483
     /*  897483 */   GIM_Try, /*On fail goto*//*Label 13682*/ GIMT_Encode4(897558), // Rule ID 61604 //
     /*  897488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  897499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  897502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  897505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897556 */     GIR_RootConstrainSelectedInstOperands,
     /*  897557 */     // GIR_Coverage, 61604,
     /*  897557 */     GIR_EraseRootFromParent_Done,
     /*  897558 */   // Label 13682: @897558
     /*  897558 */   GIM_Try, /*On fail goto*//*Label 13683*/ GIMT_Encode4(897633), // Rule ID 61605 //
     /*  897563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  897574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  897577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  897580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  897598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897609 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11456:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2),
     /*  897612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897631 */     GIR_RootConstrainSelectedInstOperands,
     /*  897632 */     // GIR_Coverage, 61605,
     /*  897632 */     GIR_EraseRootFromParent_Done,
     /*  897633 */   // Label 13683: @897633
     /*  897633 */   GIM_Try, /*On fail goto*//*Label 13684*/ GIMT_Encode4(897708), // Rule ID 61608 //
     /*  897638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  897649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  897652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  897655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897706 */     GIR_RootConstrainSelectedInstOperands,
     /*  897707 */     // GIR_Coverage, 61608,
     /*  897707 */     GIR_EraseRootFromParent_Done,
     /*  897708 */   // Label 13684: @897708
     /*  897708 */   GIM_Try, /*On fail goto*//*Label 13685*/ GIMT_Encode4(897783), // Rule ID 61609 //
     /*  897713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  897724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  897727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  897730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  897748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897759 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11456:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4),
     /*  897762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897781 */     GIR_RootConstrainSelectedInstOperands,
     /*  897782 */     // GIR_Coverage, 61609,
     /*  897782 */     GIR_EraseRootFromParent_Done,
     /*  897783 */   // Label 13685: @897783
     /*  897783 */   GIM_Try, /*On fail goto*//*Label 13686*/ GIMT_Encode4(897858), // Rule ID 61612 //
     /*  897788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  897799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  897802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  897805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  897808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897834 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  897834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897856 */     GIR_RootConstrainSelectedInstOperands,
     /*  897857 */     // GIR_Coverage, 61612,
     /*  897857 */     GIR_EraseRootFromParent_Done,
     /*  897858 */   // Label 13686: @897858
     /*  897858 */   GIM_Try, /*On fail goto*//*Label 13687*/ GIMT_Encode4(897933), // Rule ID 61613 //
     /*  897863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  897866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol),
     /*  897871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  897874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  897877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  897880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  897883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  897886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  897898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  897902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897909 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11456:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  897909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8),
     /*  897912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  897925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  897928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  897931 */     GIR_RootConstrainSelectedInstOperands,
     /*  897932 */     // GIR_Coverage, 61613,
     /*  897932 */     GIR_EraseRootFromParent_Done,
     /*  897933 */   // Label 13687: @897933
     /*  897933 */   GIM_Try, /*On fail goto*//*Label 13688*/ GIMT_Encode4(898008), // Rule ID 61700 //
     /*  897938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  897941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  897946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  897949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  897952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  897955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  897958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  897961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  897977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  897984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  897984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  897987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  897989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  897991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  897993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  897995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898006 */     GIR_RootConstrainSelectedInstOperands,
     /*  898007 */     // GIR_Coverage, 61700,
     /*  898007 */     GIR_EraseRootFromParent_Done,
     /*  898008 */   // Label 13688: @898008
     /*  898008 */   GIM_Try, /*On fail goto*//*Label 13689*/ GIMT_Encode4(898083), // Rule ID 61701 //
     /*  898013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  898024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  898027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  898030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  898033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898059 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /*  898062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898081 */     GIR_RootConstrainSelectedInstOperands,
     /*  898082 */     // GIR_Coverage, 61701,
     /*  898082 */     GIR_EraseRootFromParent_Done,
     /*  898083 */   // Label 13689: @898083
     /*  898083 */   GIM_Try, /*On fail goto*//*Label 13690*/ GIMT_Encode4(898158), // Rule ID 61704 //
     /*  898088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898134 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898156 */     GIR_RootConstrainSelectedInstOperands,
     /*  898157 */     // GIR_Coverage, 61704,
     /*  898157 */     GIR_EraseRootFromParent_Done,
     /*  898158 */   // Label 13690: @898158
     /*  898158 */   GIM_Try, /*On fail goto*//*Label 13691*/ GIMT_Encode4(898233), // Rule ID 61705 //
     /*  898163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  898174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  898177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  898180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  898183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898209 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898231 */     GIR_RootConstrainSelectedInstOperands,
     /*  898232 */     // GIR_Coverage, 61705,
     /*  898232 */     GIR_EraseRootFromParent_Done,
     /*  898233 */   // Label 13691: @898233
     /*  898233 */   GIM_Try, /*On fail goto*//*Label 13692*/ GIMT_Encode4(898308), // Rule ID 61708 //
     /*  898238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898284 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898306 */     GIR_RootConstrainSelectedInstOperands,
     /*  898307 */     // GIR_Coverage, 61708,
     /*  898307 */     GIR_EraseRootFromParent_Done,
     /*  898308 */   // Label 13692: @898308
     /*  898308 */   GIM_Try, /*On fail goto*//*Label 13693*/ GIMT_Encode4(898383), // Rule ID 61709 //
     /*  898313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  898324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  898327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  898330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  898333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898359 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898381 */     GIR_RootConstrainSelectedInstOperands,
     /*  898382 */     // GIR_Coverage, 61709,
     /*  898382 */     GIR_EraseRootFromParent_Done,
     /*  898383 */   // Label 13693: @898383
     /*  898383 */   GIM_Try, /*On fail goto*//*Label 13694*/ GIMT_Encode4(898458), // Rule ID 61712 //
     /*  898388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  898405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898434 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898456 */     GIR_RootConstrainSelectedInstOperands,
     /*  898457 */     // GIR_Coverage, 61712,
     /*  898457 */     GIR_EraseRootFromParent_Done,
     /*  898458 */   // Label 13694: @898458
     /*  898458 */   GIM_Try, /*On fail goto*//*Label 13695*/ GIMT_Encode4(898533), // Rule ID 61713 //
     /*  898463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  898474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  898477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  898480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  898483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /*  898512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898531 */     GIR_RootConstrainSelectedInstOperands,
     /*  898532 */     // GIR_Coverage, 61713,
     /*  898532 */     GIR_EraseRootFromParent_Done,
     /*  898533 */   // Label 13695: @898533
     /*  898533 */   GIM_Try, /*On fail goto*//*Label 13696*/ GIMT_Encode4(898608), // Rule ID 61716 //
     /*  898538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  898549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  898552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  898555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  898558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898584 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  898584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898606 */     GIR_RootConstrainSelectedInstOperands,
     /*  898607 */     // GIR_Coverage, 61716,
     /*  898607 */     GIR_EraseRootFromParent_Done,
     /*  898608 */   // Label 13696: @898608
     /*  898608 */   GIM_Try, /*On fail goto*//*Label 13697*/ GIMT_Encode4(898683), // Rule ID 61717 //
     /*  898613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  898624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  898627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  898630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  898633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898659 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  898659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  898678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898681 */     GIR_RootConstrainSelectedInstOperands,
     /*  898682 */     // GIR_Coverage, 61717,
     /*  898682 */     GIR_EraseRootFromParent_Done,
     /*  898683 */   // Label 13697: @898683
     /*  898683 */   GIM_Try, /*On fail goto*//*Label 13698*/ GIMT_Encode4(898758), // Rule ID 61720 //
     /*  898688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  898699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  898702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  898705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  898708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898734 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  898734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898756 */     GIR_RootConstrainSelectedInstOperands,
     /*  898757 */     // GIR_Coverage, 61720,
     /*  898757 */     GIR_EraseRootFromParent_Done,
     /*  898758 */   // Label 13698: @898758
     /*  898758 */   GIM_Try, /*On fail goto*//*Label 13699*/ GIMT_Encode4(898833), // Rule ID 61721 //
     /*  898763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  898774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  898777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  898780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  898783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898809 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  898809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /*  898812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  898828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898831 */     GIR_RootConstrainSelectedInstOperands,
     /*  898832 */     // GIR_Coverage, 61721,
     /*  898832 */     GIR_EraseRootFromParent_Done,
     /*  898833 */   // Label 13699: @898833
     /*  898833 */   GIM_Try, /*On fail goto*//*Label 13700*/ GIMT_Encode4(898908), // Rule ID 61724 //
     /*  898838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  898849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  898852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  898855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  898858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  898861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898884 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  898884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  898887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898906 */     GIR_RootConstrainSelectedInstOperands,
     /*  898907 */     // GIR_Coverage, 61724,
     /*  898907 */     GIR_EraseRootFromParent_Done,
     /*  898908 */   // Label 13700: @898908
     /*  898908 */   GIM_Try, /*On fail goto*//*Label 13701*/ GIMT_Encode4(898983), // Rule ID 61725 //
     /*  898913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  898916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  898924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  898927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  898930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  898933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  898936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  898952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  898959 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  898959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  898962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  898964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  898966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  898968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  898970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  898975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  898978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  898981 */     GIR_RootConstrainSelectedInstOperands,
     /*  898982 */     // GIR_Coverage, 61725,
     /*  898982 */     GIR_EraseRootFromParent_Done,
     /*  898983 */   // Label 13701: @898983
     /*  898983 */   GIM_Try, /*On fail goto*//*Label 13702*/ GIMT_Encode4(899058), // Rule ID 61728 //
     /*  898988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  898991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  898996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  898999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899056 */     GIR_RootConstrainSelectedInstOperands,
     /*  899057 */     // GIR_Coverage, 61728,
     /*  899057 */     GIR_EraseRootFromParent_Done,
     /*  899058 */   // Label 13702: @899058
     /*  899058 */   GIM_Try, /*On fail goto*//*Label 13703*/ GIMT_Encode4(899133), // Rule ID 61729 //
     /*  899063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  899074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  899077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  899080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  899083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899109 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  899109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899131 */     GIR_RootConstrainSelectedInstOperands,
     /*  899132 */     // GIR_Coverage, 61729,
     /*  899132 */     GIR_EraseRootFromParent_Done,
     /*  899133 */   // Label 13703: @899133
     /*  899133 */   GIM_Try, /*On fail goto*//*Label 13704*/ GIMT_Encode4(899208), // Rule ID 61732 //
     /*  899138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  899184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899206 */     GIR_RootConstrainSelectedInstOperands,
     /*  899207 */     // GIR_Coverage, 61732,
     /*  899207 */     GIR_EraseRootFromParent_Done,
     /*  899208 */   // Label 13704: @899208
     /*  899208 */   GIM_Try, /*On fail goto*//*Label 13705*/ GIMT_Encode4(899283), // Rule ID 61733 //
     /*  899213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  899224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  899227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  899230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  899233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  899259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  899278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899281 */     GIR_RootConstrainSelectedInstOperands,
     /*  899282 */     // GIR_Coverage, 61733,
     /*  899282 */     GIR_EraseRootFromParent_Done,
     /*  899283 */   // Label 13705: @899283
     /*  899283 */   GIM_Try, /*On fail goto*//*Label 13706*/ GIMT_Encode4(899358), // Rule ID 61736 //
     /*  899288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899334 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  899334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899356 */     GIR_RootConstrainSelectedInstOperands,
     /*  899357 */     // GIR_Coverage, 61736,
     /*  899357 */     GIR_EraseRootFromParent_Done,
     /*  899358 */   // Label 13706: @899358
     /*  899358 */   GIM_Try, /*On fail goto*//*Label 13707*/ GIMT_Encode4(899433), // Rule ID 61737 //
     /*  899363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  899374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  899377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  899380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  899383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  899402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899409 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  899409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /*  899412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  899428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899431 */     GIR_RootConstrainSelectedInstOperands,
     /*  899432 */     // GIR_Coverage, 61737,
     /*  899432 */     GIR_EraseRootFromParent_Done,
     /*  899433 */   // Label 13707: @899433
     /*  899433 */   GIM_Try, /*On fail goto*//*Label 13708*/ GIMT_Encode4(899508), // Rule ID 61740 //
     /*  899438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  899449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  899452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  899455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  899458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  899487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899506 */     GIR_RootConstrainSelectedInstOperands,
     /*  899507 */     // GIR_Coverage, 61740,
     /*  899507 */     GIR_EraseRootFromParent_Done,
     /*  899508 */   // Label 13708: @899508
     /*  899508 */   GIM_Try, /*On fail goto*//*Label 13709*/ GIMT_Encode4(899583), // Rule ID 61741 //
     /*  899513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  899524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  899527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  899530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  899533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  899562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899581 */     GIR_RootConstrainSelectedInstOperands,
     /*  899582 */     // GIR_Coverage, 61741,
     /*  899582 */     GIR_EraseRootFromParent_Done,
     /*  899583 */   // Label 13709: @899583
     /*  899583 */   GIM_Try, /*On fail goto*//*Label 13710*/ GIMT_Encode4(899658), // Rule ID 61744 //
     /*  899588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  899599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  899602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  899605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  899608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899634 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  899637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899656 */     GIR_RootConstrainSelectedInstOperands,
     /*  899657 */     // GIR_Coverage, 61744,
     /*  899657 */     GIR_EraseRootFromParent_Done,
     /*  899658 */   // Label 13710: @899658
     /*  899658 */   GIM_Try, /*On fail goto*//*Label 13711*/ GIMT_Encode4(899733), // Rule ID 61745 //
     /*  899663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  899674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  899677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  899680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  899683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  899702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899709 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  899712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899731 */     GIR_RootConstrainSelectedInstOperands,
     /*  899732 */     // GIR_Coverage, 61745,
     /*  899732 */     GIR_EraseRootFromParent_Done,
     /*  899733 */   // Label 13711: @899733
     /*  899733 */   GIM_Try, /*On fail goto*//*Label 13712*/ GIMT_Encode4(899808), // Rule ID 61748 //
     /*  899738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  899749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  899752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  899755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  899758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899784 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  899784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  899787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899806 */     GIR_RootConstrainSelectedInstOperands,
     /*  899807 */     // GIR_Coverage, 61748,
     /*  899807 */     GIR_EraseRootFromParent_Done,
     /*  899808 */   // Label 13712: @899808
     /*  899808 */   GIM_Try, /*On fail goto*//*Label 13713*/ GIMT_Encode4(899883), // Rule ID 61749 //
     /*  899813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  899824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  899827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  899830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  899833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  899852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899859 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  899859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  899862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  899878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899881 */     GIR_RootConstrainSelectedInstOperands,
     /*  899882 */     // GIR_Coverage, 61749,
     /*  899882 */     GIR_EraseRootFromParent_Done,
     /*  899883 */   // Label 13713: @899883
     /*  899883 */   GIM_Try, /*On fail goto*//*Label 13714*/ GIMT_Encode4(899958), // Rule ID 61752 //
     /*  899888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  899891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  899899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  899902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  899905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  899908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  899911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  899934 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  899934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  899937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  899939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  899941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  899943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  899945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  899950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  899953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  899956 */     GIR_RootConstrainSelectedInstOperands,
     /*  899957 */     // GIR_Coverage, 61752,
     /*  899957 */     GIR_EraseRootFromParent_Done,
     /*  899958 */   // Label 13714: @899958
     /*  899958 */   GIM_Try, /*On fail goto*//*Label 13715*/ GIMT_Encode4(900033), // Rule ID 61753 //
     /*  899963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  899966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  899971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  899974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  899977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  899980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  899983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  899986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  899998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900009 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900031 */     GIR_RootConstrainSelectedInstOperands,
     /*  900032 */     // GIR_Coverage, 61753,
     /*  900032 */     GIR_EraseRootFromParent_Done,
     /*  900033 */   // Label 13715: @900033
     /*  900033 */   GIM_Try, /*On fail goto*//*Label 13716*/ GIMT_Encode4(900108), // Rule ID 61756 //
     /*  900038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900106 */     GIR_RootConstrainSelectedInstOperands,
     /*  900107 */     // GIR_Coverage, 61756,
     /*  900107 */     GIR_EraseRootFromParent_Done,
     /*  900108 */   // Label 13716: @900108
     /*  900108 */   GIM_Try, /*On fail goto*//*Label 13717*/ GIMT_Encode4(900183), // Rule ID 61757 //
     /*  900113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  900124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  900127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  900130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  900133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900159 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900181 */     GIR_RootConstrainSelectedInstOperands,
     /*  900182 */     // GIR_Coverage, 61757,
     /*  900182 */     GIR_EraseRootFromParent_Done,
     /*  900183 */   // Label 13717: @900183
     /*  900183 */   GIM_Try, /*On fail goto*//*Label 13718*/ GIMT_Encode4(900258), // Rule ID 61760 //
     /*  900188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900234 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  900234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900256 */     GIR_RootConstrainSelectedInstOperands,
     /*  900257 */     // GIR_Coverage, 61760,
     /*  900257 */     GIR_EraseRootFromParent_Done,
     /*  900258 */   // Label 13718: @900258
     /*  900258 */   GIM_Try, /*On fail goto*//*Label 13719*/ GIMT_Encode4(900333), // Rule ID 61761 //
     /*  900263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  900274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  900277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  900280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  900283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900309 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  900309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  900328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900331 */     GIR_RootConstrainSelectedInstOperands,
     /*  900332 */     // GIR_Coverage, 61761,
     /*  900332 */     GIR_EraseRootFromParent_Done,
     /*  900333 */   // Label 13719: @900333
     /*  900333 */   GIM_Try, /*On fail goto*//*Label 13720*/ GIMT_Encode4(900408), // Rule ID 61764 //
     /*  900338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900406 */     GIR_RootConstrainSelectedInstOperands,
     /*  900407 */     // GIR_Coverage, 61764,
     /*  900407 */     GIR_EraseRootFromParent_Done,
     /*  900408 */   // Label 13720: @900408
     /*  900408 */   GIM_Try, /*On fail goto*//*Label 13721*/ GIMT_Encode4(900483), // Rule ID 61765 //
     /*  900413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  900424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  900427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  900430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  900433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900459 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900481 */     GIR_RootConstrainSelectedInstOperands,
     /*  900482 */     // GIR_Coverage, 61765,
     /*  900482 */     GIR_EraseRootFromParent_Done,
     /*  900483 */   // Label 13721: @900483
     /*  900483 */   GIM_Try, /*On fail goto*//*Label 13722*/ GIMT_Encode4(900558), // Rule ID 61768 //
     /*  900488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  900499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  900502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  900505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  900508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900556 */     GIR_RootConstrainSelectedInstOperands,
     /*  900557 */     // GIR_Coverage, 61768,
     /*  900557 */     GIR_EraseRootFromParent_Done,
     /*  900558 */   // Label 13722: @900558
     /*  900558 */   GIM_Try, /*On fail goto*//*Label 13723*/ GIMT_Encode4(900633), // Rule ID 61769 //
     /*  900563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  900574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  900577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  900580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  900583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900631 */     GIR_RootConstrainSelectedInstOperands,
     /*  900632 */     // GIR_Coverage, 61769,
     /*  900632 */     GIR_EraseRootFromParent_Done,
     /*  900633 */   // Label 13723: @900633
     /*  900633 */   GIM_Try, /*On fail goto*//*Label 13724*/ GIMT_Encode4(900708), // Rule ID 61772 //
     /*  900638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  900649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  900652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  900655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  900658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900684 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  900684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900706 */     GIR_RootConstrainSelectedInstOperands,
     /*  900707 */     // GIR_Coverage, 61772,
     /*  900707 */     GIR_EraseRootFromParent_Done,
     /*  900708 */   // Label 13724: @900708
     /*  900708 */   GIM_Try, /*On fail goto*//*Label 13725*/ GIMT_Encode4(900783), // Rule ID 61773 //
     /*  900713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  900724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  900727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  900730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  900733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  900752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900759 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  900759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  900762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  900778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900781 */     GIR_RootConstrainSelectedInstOperands,
     /*  900782 */     // GIR_Coverage, 61773,
     /*  900782 */     GIR_EraseRootFromParent_Done,
     /*  900783 */   // Label 13725: @900783
     /*  900783 */   GIM_Try, /*On fail goto*//*Label 13726*/ GIMT_Encode4(900858), // Rule ID 61776 //
     /*  900788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  900799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  900802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  900805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  900808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900834 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900856 */     GIR_RootConstrainSelectedInstOperands,
     /*  900857 */     // GIR_Coverage, 61776,
     /*  900857 */     GIR_EraseRootFromParent_Done,
     /*  900858 */   // Label 13726: @900858
     /*  900858 */   GIM_Try, /*On fail goto*//*Label 13727*/ GIMT_Encode4(900933), // Rule ID 61777 //
     /*  900863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  900866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  900874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  900877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  900880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  900883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  900886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  900902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900909 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  900909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /*  900912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  900925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  900928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  900931 */     GIR_RootConstrainSelectedInstOperands,
     /*  900932 */     // GIR_Coverage, 61777,
     /*  900932 */     GIR_EraseRootFromParent_Done,
     /*  900933 */   // Label 13727: @900933
     /*  900933 */   GIM_Try, /*On fail goto*//*Label 13728*/ GIMT_Encode4(901008), // Rule ID 61780 //
     /*  900938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  900941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  900946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  900949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  900952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  900955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  900958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  900961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  900977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  900984 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  900984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  900987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  900989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  900991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  900993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  900995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901006 */     GIR_RootConstrainSelectedInstOperands,
     /*  901007 */     // GIR_Coverage, 61780,
     /*  901007 */     GIR_EraseRootFromParent_Done,
     /*  901008 */   // Label 13728: @901008
     /*  901008 */   GIM_Try, /*On fail goto*//*Label 13729*/ GIMT_Encode4(901083), // Rule ID 61781 //
     /*  901013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  901024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  901027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  901030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  901033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  901052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901059 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /*  901062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901081 */     GIR_RootConstrainSelectedInstOperands,
     /*  901082 */     // GIR_Coverage, 61781,
     /*  901082 */     GIR_EraseRootFromParent_Done,
     /*  901083 */   // Label 13729: @901083
     /*  901083 */   GIM_Try, /*On fail goto*//*Label 13730*/ GIMT_Encode4(901158), // Rule ID 61784 //
     /*  901088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901134 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  901134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901156 */     GIR_RootConstrainSelectedInstOperands,
     /*  901157 */     // GIR_Coverage, 61784,
     /*  901157 */     GIR_EraseRootFromParent_Done,
     /*  901158 */   // Label 13730: @901158
     /*  901158 */   GIM_Try, /*On fail goto*//*Label 13731*/ GIMT_Encode4(901233), // Rule ID 61785 //
     /*  901163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  901174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  901177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  901180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  901183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  901202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901209 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  901209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /*  901212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  901228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901231 */     GIR_RootConstrainSelectedInstOperands,
     /*  901232 */     // GIR_Coverage, 61785,
     /*  901232 */     GIR_EraseRootFromParent_Done,
     /*  901233 */   // Label 13731: @901233
     /*  901233 */   GIM_Try, /*On fail goto*//*Label 13732*/ GIMT_Encode4(901308), // Rule ID 61788 //
     /*  901238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901284 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901306 */     GIR_RootConstrainSelectedInstOperands,
     /*  901307 */     // GIR_Coverage, 61788,
     /*  901307 */     GIR_EraseRootFromParent_Done,
     /*  901308 */   // Label 13732: @901308
     /*  901308 */   GIM_Try, /*On fail goto*//*Label 13733*/ GIMT_Encode4(901383), // Rule ID 61789 //
     /*  901313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  901324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  901327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  901330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901359 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  901359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8),
     /*  901362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901381 */     GIR_RootConstrainSelectedInstOperands,
     /*  901382 */     // GIR_Coverage, 61789,
     /*  901382 */     GIR_EraseRootFromParent_Done,
     /*  901383 */   // Label 13733: @901383
     /*  901383 */   GIM_Try, /*On fail goto*//*Label 13734*/ GIMT_Encode4(901458), // Rule ID 61792 //
     /*  901388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901456 */     GIR_RootConstrainSelectedInstOperands,
     /*  901457 */     // GIR_Coverage, 61792,
     /*  901457 */     GIR_EraseRootFromParent_Done,
     /*  901458 */   // Label 13734: @901458
     /*  901458 */   GIM_Try, /*On fail goto*//*Label 13735*/ GIMT_Encode4(901533), // Rule ID 61793 //
     /*  901463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  901474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  901477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  901480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901509 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  901509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901531 */     GIR_RootConstrainSelectedInstOperands,
     /*  901532 */     // GIR_Coverage, 61793,
     /*  901532 */     GIR_EraseRootFromParent_Done,
     /*  901533 */   // Label 13735: @901533
     /*  901533 */   GIM_Try, /*On fail goto*//*Label 13736*/ GIMT_Encode4(901608), // Rule ID 61796 //
     /*  901538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  901549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  901552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  901555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901584 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  901584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  901587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901606 */     GIR_RootConstrainSelectedInstOperands,
     /*  901607 */     // GIR_Coverage, 61796,
     /*  901607 */     GIR_EraseRootFromParent_Done,
     /*  901608 */   // Label 13736: @901608
     /*  901608 */   GIM_Try, /*On fail goto*//*Label 13737*/ GIMT_Encode4(901683), // Rule ID 61797 //
     /*  901613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  901624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  901627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  901630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901659 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  901659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  901662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  901678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901681 */     GIR_RootConstrainSelectedInstOperands,
     /*  901682 */     // GIR_Coverage, 61797,
     /*  901682 */     GIR_EraseRootFromParent_Done,
     /*  901683 */   // Label 13737: @901683
     /*  901683 */   GIM_Try, /*On fail goto*//*Label 13738*/ GIMT_Encode4(901758), // Rule ID 61800 //
     /*  901688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901756 */     GIR_RootConstrainSelectedInstOperands,
     /*  901757 */     // GIR_Coverage, 61800,
     /*  901757 */     GIR_EraseRootFromParent_Done,
     /*  901758 */   // Label 13738: @901758
     /*  901758 */   GIM_Try, /*On fail goto*//*Label 13739*/ GIMT_Encode4(901833), // Rule ID 61801 //
     /*  901763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  901774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  901777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  901780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901809 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4),
     /*  901812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901831 */     GIR_RootConstrainSelectedInstOperands,
     /*  901832 */     // GIR_Coverage, 61801,
     /*  901832 */     GIR_EraseRootFromParent_Done,
     /*  901833 */   // Label 13739: @901833
     /*  901833 */   GIM_Try, /*On fail goto*//*Label 13740*/ GIMT_Encode4(901908), // Rule ID 61804 //
     /*  901838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  901849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  901852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  901855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  901858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  901861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901884 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  901884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  901887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901906 */     GIR_RootConstrainSelectedInstOperands,
     /*  901907 */     // GIR_Coverage, 61804,
     /*  901907 */     GIR_EraseRootFromParent_Done,
     /*  901908 */   // Label 13740: @901908
     /*  901908 */   GIM_Try, /*On fail goto*//*Label 13741*/ GIMT_Encode4(901983), // Rule ID 61805 //
     /*  901913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  901916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  901924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  901927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  901930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  901933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  901936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  901948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  901952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  901959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  901959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  901962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  901964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  901966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  901968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  901970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  901975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  901978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  901981 */     GIR_RootConstrainSelectedInstOperands,
     /*  901982 */     // GIR_Coverage, 61805,
     /*  901982 */     GIR_EraseRootFromParent_Done,
     /*  901983 */   // Label 13741: @901983
     /*  901983 */   GIM_Try, /*On fail goto*//*Label 13742*/ GIMT_Encode4(902058), // Rule ID 61808 //
     /*  901988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  901991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  901996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  901999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  902034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902056 */     GIR_RootConstrainSelectedInstOperands,
     /*  902057 */     // GIR_Coverage, 61808,
     /*  902057 */     GIR_EraseRootFromParent_Done,
     /*  902058 */   // Label 13742: @902058
     /*  902058 */   GIM_Try, /*On fail goto*//*Label 13743*/ GIMT_Encode4(902133), // Rule ID 61809 //
     /*  902063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  902074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  902077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  902080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902109 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  902109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2),
     /*  902112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902131 */     GIR_RootConstrainSelectedInstOperands,
     /*  902132 */     // GIR_Coverage, 61809,
     /*  902132 */     GIR_EraseRootFromParent_Done,
     /*  902133 */   // Label 13743: @902133
     /*  902133 */   GIM_Try, /*On fail goto*//*Label 13744*/ GIMT_Encode4(902208), // Rule ID 61812 //
     /*  902138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902184 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902206 */     GIR_RootConstrainSelectedInstOperands,
     /*  902207 */     // GIR_Coverage, 61812,
     /*  902207 */     GIR_EraseRootFromParent_Done,
     /*  902208 */   // Label 13744: @902208
     /*  902208 */   GIM_Try, /*On fail goto*//*Label 13745*/ GIMT_Encode4(902283), // Rule ID 61813 //
     /*  902213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  902224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  902227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  902230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902259 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11458:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902281 */     GIR_RootConstrainSelectedInstOperands,
     /*  902282 */     // GIR_Coverage, 61813,
     /*  902282 */     GIR_EraseRootFromParent_Done,
     /*  902283 */   // Label 13745: @902283
     /*  902283 */   GIM_Try, /*On fail goto*//*Label 13746*/ GIMT_Encode4(902358), // Rule ID 61816 //
     /*  902288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902334 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  902334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902356 */     GIR_RootConstrainSelectedInstOperands,
     /*  902357 */     // GIR_Coverage, 61816,
     /*  902357 */     GIR_EraseRootFromParent_Done,
     /*  902358 */   // Label 13746: @902358
     /*  902358 */   GIM_Try, /*On fail goto*//*Label 13747*/ GIMT_Encode4(902433), // Rule ID 61817 //
     /*  902363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  902374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  902377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  902380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902409 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11458:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  902409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  902428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902431 */     GIR_RootConstrainSelectedInstOperands,
     /*  902432 */     // GIR_Coverage, 61817,
     /*  902432 */     GIR_EraseRootFromParent_Done,
     /*  902433 */   // Label 13747: @902433
     /*  902433 */   GIM_Try, /*On fail goto*//*Label 13748*/ GIMT_Encode4(902508), // Rule ID 61820 //
     /*  902438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  902455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  902484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902506 */     GIR_RootConstrainSelectedInstOperands,
     /*  902507 */     // GIR_Coverage, 61820,
     /*  902507 */     GIR_EraseRootFromParent_Done,
     /*  902508 */   // Label 13748: @902508
     /*  902508 */   GIM_Try, /*On fail goto*//*Label 13749*/ GIMT_Encode4(902583), // Rule ID 61821 //
     /*  902513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  902524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  902527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  902530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11458:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  902559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  902578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902581 */     GIR_RootConstrainSelectedInstOperands,
     /*  902582 */     // GIR_Coverage, 61821,
     /*  902582 */     GIR_EraseRootFromParent_Done,
     /*  902583 */   // Label 13749: @902583
     /*  902583 */   GIM_Try, /*On fail goto*//*Label 13750*/ GIMT_Encode4(902658), // Rule ID 61824 //
     /*  902588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  902599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  902602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  902605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902634 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  902634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902656 */     GIR_RootConstrainSelectedInstOperands,
     /*  902657 */     // GIR_Coverage, 61824,
     /*  902657 */     GIR_EraseRootFromParent_Done,
     /*  902658 */   // Label 13750: @902658
     /*  902658 */   GIM_Try, /*On fail goto*//*Label 13751*/ GIMT_Encode4(902733), // Rule ID 61825 //
     /*  902663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  902674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  902677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  902680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  902698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902709 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11458:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  902709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1),
     /*  902712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  902728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902731 */     GIR_RootConstrainSelectedInstOperands,
     /*  902732 */     // GIR_Coverage, 61825,
     /*  902732 */     GIR_EraseRootFromParent_Done,
     /*  902733 */   // Label 13751: @902733
     /*  902733 */   GIM_Try, /*On fail goto*//*Label 13752*/ GIMT_Encode4(902808), // Rule ID 61828 //
     /*  902738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  902749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  902752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  902755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  902787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902806 */     GIR_RootConstrainSelectedInstOperands,
     /*  902807 */     // GIR_Coverage, 61828,
     /*  902807 */     GIR_EraseRootFromParent_Done,
     /*  902808 */   // Label 13752: @902808
     /*  902808 */   GIM_Try, /*On fail goto*//*Label 13753*/ GIMT_Encode4(902883), // Rule ID 61829 //
     /*  902813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  902824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  902827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  902830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  902848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902859 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  902859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  902862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902881 */     GIR_RootConstrainSelectedInstOperands,
     /*  902882 */     // GIR_Coverage, 61829,
     /*  902882 */     GIR_EraseRootFromParent_Done,
     /*  902883 */   // Label 13753: @902883
     /*  902883 */   GIM_Try, /*On fail goto*//*Label 13754*/ GIMT_Encode4(902958), // Rule ID 61832 //
     /*  902888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  902891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  902899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  902902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  902905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  902908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  902911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  902927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  902934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  902934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  902937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  902939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  902941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  902943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  902945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  902950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  902953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  902956 */     GIR_RootConstrainSelectedInstOperands,
     /*  902957 */     // GIR_Coverage, 61832,
     /*  902957 */     GIR_EraseRootFromParent_Done,
     /*  902958 */   // Label 13754: @902958
     /*  902958 */   GIM_Try, /*On fail goto*//*Label 13755*/ GIMT_Encode4(903033), // Rule ID 61833 //
     /*  902963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  902966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  902971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  902974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  902977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  902980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  902983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  902986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  902998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903009 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903031 */     GIR_RootConstrainSelectedInstOperands,
     /*  903032 */     // GIR_Coverage, 61833,
     /*  903032 */     GIR_EraseRootFromParent_Done,
     /*  903033 */   // Label 13755: @903033
     /*  903033 */   GIM_Try, /*On fail goto*//*Label 13756*/ GIMT_Encode4(903108), // Rule ID 61836 //
     /*  903038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  903084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903106 */     GIR_RootConstrainSelectedInstOperands,
     /*  903107 */     // GIR_Coverage, 61836,
     /*  903107 */     GIR_EraseRootFromParent_Done,
     /*  903108 */   // Label 13756: @903108
     /*  903108 */   GIM_Try, /*On fail goto*//*Label 13757*/ GIMT_Encode4(903183), // Rule ID 61837 //
     /*  903113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  903124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  903127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  903130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903159 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  903159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  903178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903181 */     GIR_RootConstrainSelectedInstOperands,
     /*  903182 */     // GIR_Coverage, 61837,
     /*  903182 */     GIR_EraseRootFromParent_Done,
     /*  903183 */   // Label 13757: @903183
     /*  903183 */   GIM_Try, /*On fail goto*//*Label 13758*/ GIMT_Encode4(903258), // Rule ID 61840 //
     /*  903188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903234 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903256 */     GIR_RootConstrainSelectedInstOperands,
     /*  903257 */     // GIR_Coverage, 61840,
     /*  903257 */     GIR_EraseRootFromParent_Done,
     /*  903258 */   // Label 13758: @903258
     /*  903258 */   GIM_Try, /*On fail goto*//*Label 13759*/ GIMT_Encode4(903333), // Rule ID 61841 //
     /*  903263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  903274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  903277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  903280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903309 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903331 */     GIR_RootConstrainSelectedInstOperands,
     /*  903332 */     // GIR_Coverage, 61841,
     /*  903332 */     GIR_EraseRootFromParent_Done,
     /*  903333 */   // Label 13759: @903333
     /*  903333 */   GIM_Try, /*On fail goto*//*Label 13760*/ GIMT_Encode4(903408), // Rule ID 61844 //
     /*  903338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903406 */     GIR_RootConstrainSelectedInstOperands,
     /*  903407 */     // GIR_Coverage, 61844,
     /*  903407 */     GIR_EraseRootFromParent_Done,
     /*  903408 */   // Label 13760: @903408
     /*  903408 */   GIM_Try, /*On fail goto*//*Label 13761*/ GIMT_Encode4(903483), // Rule ID 61845 //
     /*  903413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  903424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  903427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  903430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903459 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903481 */     GIR_RootConstrainSelectedInstOperands,
     /*  903482 */     // GIR_Coverage, 61845,
     /*  903482 */     GIR_EraseRootFromParent_Done,
     /*  903483 */   // Label 13761: @903483
     /*  903483 */   GIM_Try, /*On fail goto*//*Label 13762*/ GIMT_Encode4(903558), // Rule ID 61848 //
     /*  903488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  903499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  903502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  903505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903534 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  903534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903556 */     GIR_RootConstrainSelectedInstOperands,
     /*  903557 */     // GIR_Coverage, 61848,
     /*  903557 */     GIR_EraseRootFromParent_Done,
     /*  903558 */   // Label 13762: @903558
     /*  903558 */   GIM_Try, /*On fail goto*//*Label 13763*/ GIMT_Encode4(903633), // Rule ID 61849 //
     /*  903563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  903574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  903577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  903580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  903609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  903628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903631 */     GIR_RootConstrainSelectedInstOperands,
     /*  903632 */     // GIR_Coverage, 61849,
     /*  903632 */     GIR_EraseRootFromParent_Done,
     /*  903633 */   // Label 13763: @903633
     /*  903633 */   GIM_Try, /*On fail goto*//*Label 13764*/ GIMT_Encode4(903708), // Rule ID 61852 //
     /*  903638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  903649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  903652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  903655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903684 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903706 */     GIR_RootConstrainSelectedInstOperands,
     /*  903707 */     // GIR_Coverage, 61852,
     /*  903707 */     GIR_EraseRootFromParent_Done,
     /*  903708 */   // Label 13764: @903708
     /*  903708 */   GIM_Try, /*On fail goto*//*Label 13765*/ GIMT_Encode4(903783), // Rule ID 61853 //
     /*  903713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  903724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  903727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  903730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  903748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903759 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  903762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903781 */     GIR_RootConstrainSelectedInstOperands,
     /*  903782 */     // GIR_Coverage, 61853,
     /*  903782 */     GIR_EraseRootFromParent_Done,
     /*  903783 */   // Label 13765: @903783
     /*  903783 */   GIM_Try, /*On fail goto*//*Label 13766*/ GIMT_Encode4(903858), // Rule ID 61856 //
     /*  903788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  903799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  903802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  903805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903856 */     GIR_RootConstrainSelectedInstOperands,
     /*  903857 */     // GIR_Coverage, 61856,
     /*  903857 */     GIR_EraseRootFromParent_Done,
     /*  903858 */   // Label 13766: @903858
     /*  903858 */   GIM_Try, /*On fail goto*//*Label 13767*/ GIMT_Encode4(903933), // Rule ID 61857 //
     /*  903863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  903866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  903874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  903877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  903880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  903883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  903886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  903898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903909 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  903909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  903912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  903925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  903928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  903931 */     GIR_RootConstrainSelectedInstOperands,
     /*  903932 */     // GIR_Coverage, 61857,
     /*  903932 */     GIR_EraseRootFromParent_Done,
     /*  903933 */   // Label 13767: @903933
     /*  903933 */   GIM_Try, /*On fail goto*//*Label 13768*/ GIMT_Encode4(904008), // Rule ID 61860 //
     /*  903938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  903941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  903946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  903949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  903952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  903955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  903958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  903961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  903973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  903977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  903984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  903984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  903987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  903989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  903991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  903993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  903995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904006 */     GIR_RootConstrainSelectedInstOperands,
     /*  904007 */     // GIR_Coverage, 61860,
     /*  904007 */     GIR_EraseRootFromParent_Done,
     /*  904008 */   // Label 13768: @904008
     /*  904008 */   GIM_Try, /*On fail goto*//*Label 13769*/ GIMT_Encode4(904083), // Rule ID 61861 //
     /*  904013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  904027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  904030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904059 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904081 */     GIR_RootConstrainSelectedInstOperands,
     /*  904082 */     // GIR_Coverage, 61861,
     /*  904082 */     GIR_EraseRootFromParent_Done,
     /*  904083 */   // Label 13769: @904083
     /*  904083 */   GIM_Try, /*On fail goto*//*Label 13770*/ GIMT_Encode4(904158), // Rule ID 61864 //
     /*  904088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904134 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904156 */     GIR_RootConstrainSelectedInstOperands,
     /*  904157 */     // GIR_Coverage, 61864,
     /*  904157 */     GIR_EraseRootFromParent_Done,
     /*  904158 */   // Label 13770: @904158
     /*  904158 */   GIM_Try, /*On fail goto*//*Label 13771*/ GIMT_Encode4(904233), // Rule ID 61865 //
     /*  904163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  904174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  904177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  904180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904209 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11458:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2),
     /*  904212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904231 */     GIR_RootConstrainSelectedInstOperands,
     /*  904232 */     // GIR_Coverage, 61865,
     /*  904232 */     GIR_EraseRootFromParent_Done,
     /*  904233 */   // Label 13771: @904233
     /*  904233 */   GIM_Try, /*On fail goto*//*Label 13772*/ GIMT_Encode4(904308), // Rule ID 61868 //
     /*  904238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904284 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904306 */     GIR_RootConstrainSelectedInstOperands,
     /*  904307 */     // GIR_Coverage, 61868,
     /*  904307 */     GIR_EraseRootFromParent_Done,
     /*  904308 */   // Label 13772: @904308
     /*  904308 */   GIM_Try, /*On fail goto*//*Label 13773*/ GIMT_Encode4(904383), // Rule ID 61869 //
     /*  904313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  904324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  904327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  904330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11458:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4),
     /*  904362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904381 */     GIR_RootConstrainSelectedInstOperands,
     /*  904382 */     // GIR_Coverage, 61869,
     /*  904382 */     GIR_EraseRootFromParent_Done,
     /*  904383 */   // Label 13773: @904383
     /*  904383 */   GIM_Try, /*On fail goto*//*Label 13774*/ GIMT_Encode4(904458), // Rule ID 61872 //
     /*  904388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /*  904391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  904405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  904408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  904434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904456 */     GIR_RootConstrainSelectedInstOperands,
     /*  904457 */     // GIR_Coverage, 61872,
     /*  904457 */     GIR_EraseRootFromParent_Done,
     /*  904458 */   // Label 13774: @904458
     /*  904458 */   GIM_Try, /*On fail goto*//*Label 13775*/ GIMT_Encode4(904533), // Rule ID 61873 //
     /*  904463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /*  904466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror),
     /*  904471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  904474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  904477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  904480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  904483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  904498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  904502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904509 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11458:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVROR_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  904509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8),
     /*  904512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  904528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904531 */     GIR_RootConstrainSelectedInstOperands,
     /*  904532 */     // GIR_Coverage, 61873,
     /*  904532 */     GIR_EraseRootFromParent_Done,
     /*  904533 */   // Label 13775: @904533
     /*  904533 */   GIM_Try, /*On fail goto*//*Label 13776*/ GIMT_Encode4(904608), // Rule ID 62316 //
     /*  904538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  904541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  904549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  904552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  904555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  904558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  904587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904606 */     GIR_RootConstrainSelectedInstOperands,
     /*  904607 */     // GIR_Coverage, 62316,
     /*  904607 */     GIR_EraseRootFromParent_Done,
     /*  904608 */   // Label 13776: @904608
     /*  904608 */   GIM_Try, /*On fail goto*//*Label 13777*/ GIMT_Encode4(904683), // Rule ID 62317 //
     /*  904613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  904616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  904624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  904627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  904630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  904633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  904652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904659 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11488:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M1),
     /*  904662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904681 */     GIR_RootConstrainSelectedInstOperands,
     /*  904682 */     // GIR_Coverage, 62317,
     /*  904682 */     GIR_EraseRootFromParent_Done,
     /*  904683 */   // Label 13777: @904683
     /*  904683 */   GIM_Try, /*On fail goto*//*Label 13778*/ GIMT_Encode4(904758), // Rule ID 62318 //
     /*  904688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  904691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  904737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904756 */     GIR_RootConstrainSelectedInstOperands,
     /*  904757 */     // GIR_Coverage, 62318,
     /*  904757 */     GIR_EraseRootFromParent_Done,
     /*  904758 */   // Label 13778: @904758
     /*  904758 */   GIM_Try, /*On fail goto*//*Label 13779*/ GIMT_Encode4(904833), // Rule ID 62319 //
     /*  904763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  904766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  904774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  904777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  904780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  904783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  904802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11488:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M2),
     /*  904812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904831 */     GIR_RootConstrainSelectedInstOperands,
     /*  904832 */     // GIR_Coverage, 62319,
     /*  904832 */     GIR_EraseRootFromParent_Done,
     /*  904833 */   // Label 13779: @904833
     /*  904833 */   GIM_Try, /*On fail goto*//*Label 13780*/ GIMT_Encode4(904908), // Rule ID 62320 //
     /*  904838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  904841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  904861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  904884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  904887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904906 */     GIR_RootConstrainSelectedInstOperands,
     /*  904907 */     // GIR_Coverage, 62320,
     /*  904907 */     GIR_EraseRootFromParent_Done,
     /*  904908 */   // Label 13780: @904908
     /*  904908 */   GIM_Try, /*On fail goto*//*Label 13781*/ GIMT_Encode4(904983), // Rule ID 62321 //
     /*  904913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  904916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  904924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  904927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  904930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  904933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  904936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  904952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  904959 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11488:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  904959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M4),
     /*  904962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  904964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  904966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  904968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  904970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  904975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  904978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  904981 */     GIR_RootConstrainSelectedInstOperands,
     /*  904982 */     // GIR_Coverage, 62321,
     /*  904982 */     GIR_EraseRootFromParent_Done,
     /*  904983 */   // Label 13781: @904983
     /*  904983 */   GIM_Try, /*On fail goto*//*Label 13782*/ GIMT_Encode4(905058), // Rule ID 62322 //
     /*  904988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  904991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  904996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  904999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  905011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  905034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905056 */     GIR_RootConstrainSelectedInstOperands,
     /*  905057 */     // GIR_Coverage, 62322,
     /*  905057 */     GIR_EraseRootFromParent_Done,
     /*  905058 */   // Label 13782: @905058
     /*  905058 */   GIM_Try, /*On fail goto*//*Label 13783*/ GIMT_Encode4(905133), // Rule ID 62323 //
     /*  905063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  905066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3me),
     /*  905071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  905074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  905077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  905080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  905083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  905086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  905102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11488:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSM3ME_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  905109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3ME_VV_M8),
     /*  905112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  905116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  905118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  905120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  905128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  905131 */     GIR_RootConstrainSelectedInstOperands,
     /*  905132 */     // GIR_Coverage, 62323,
     /*  905132 */     GIR_EraseRootFromParent_Done,
     /*  905133 */   // Label 13783: @905133
     /*  905133 */   GIM_Try, /*On fail goto*//*Label 13784*/ GIMT_Encode4(905197), // Rule ID 64491 //
     /*  905138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuN),
     /*  905146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905174 */     // MIs[0] imm5
     /*  905174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905177 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905182 */     // (intrinsic_wo_chain:{ *:[i32] } 10939:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACUN),
     /*  905185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905193 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905195 */     GIR_RootConstrainSelectedInstOperands,
     /*  905196 */     // GIR_Coverage, 64491,
     /*  905196 */     GIR_EraseRootFromParent_Done,
     /*  905197 */   // Label 13784: @905197
     /*  905197 */   GIM_Try, /*On fail goto*//*Label 13785*/ GIMT_Encode4(905261), // Rule ID 64492 //
     /*  905202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuN),
     /*  905210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905238 */     // MIs[0] imm5
     /*  905238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905246 */     // (intrinsic_wo_chain:{ *:[i32] } 10935:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHUN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHUN),
     /*  905249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905257 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905259 */     GIR_RootConstrainSelectedInstOperands,
     /*  905260 */     // GIR_Coverage, 64492,
     /*  905260 */     GIR_EraseRootFromParent_Done,
     /*  905261 */   // Label 13785: @905261
     /*  905261 */   GIM_Try, /*On fail goto*//*Label 13786*/ GIMT_Encode4(905325), // Rule ID 64493 //
     /*  905266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsN),
     /*  905274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905302 */     // MIs[0] imm5
     /*  905302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905310 */     // (intrinsic_wo_chain:{ *:[i32] } 10937:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSN),
     /*  905313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905321 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905323 */     GIR_RootConstrainSelectedInstOperands,
     /*  905324 */     // GIR_Coverage, 64493,
     /*  905324 */     GIR_EraseRootFromParent_Done,
     /*  905325 */   // Label 13786: @905325
     /*  905325 */   GIM_Try, /*On fail goto*//*Label 13787*/ GIMT_Encode4(905389), // Rule ID 64494 //
     /*  905330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsN),
     /*  905338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905366 */     // MIs[0] imm5
     /*  905366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905374 */     // (intrinsic_wo_chain:{ *:[i32] } 10933:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSN),
     /*  905377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905385 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905387 */     GIR_RootConstrainSelectedInstOperands,
     /*  905388 */     // GIR_Coverage, 64494,
     /*  905388 */     GIR_EraseRootFromParent_Done,
     /*  905389 */   // Label 13787: @905389
     /*  905389 */   GIM_Try, /*On fail goto*//*Label 13788*/ GIMT_Encode4(905453), // Rule ID 64495 //
     /*  905394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macuRN),
     /*  905402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905430 */     // MIs[0] imm5
     /*  905430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905438 */     // (intrinsic_wo_chain:{ *:[i32] } 10940:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACURN),
     /*  905441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905449 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905451 */     GIR_RootConstrainSelectedInstOperands,
     /*  905452 */     // GIR_Coverage, 64495,
     /*  905452 */     GIR_EraseRootFromParent_Done,
     /*  905453 */   // Label 13788: @905453
     /*  905453 */   GIM_Try, /*On fail goto*//*Label 13789*/ GIMT_Encode4(905517), // Rule ID 64496 //
     /*  905458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhuRN),
     /*  905466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905494 */     // MIs[0] imm5
     /*  905494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905502 */     // (intrinsic_wo_chain:{ *:[i32] } 10936:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHURN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHURN),
     /*  905505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905513 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905515 */     GIR_RootConstrainSelectedInstOperands,
     /*  905516 */     // GIR_Coverage, 64496,
     /*  905516 */     GIR_EraseRootFromParent_Done,
     /*  905517 */   // Label 13789: @905517
     /*  905517 */   GIM_Try, /*On fail goto*//*Label 13790*/ GIMT_Encode4(905581), // Rule ID 64497 //
     /*  905522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_macsRN),
     /*  905530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905558 */     // MIs[0] imm5
     /*  905558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905566 */     // (intrinsic_wo_chain:{ *:[i32] } 10938:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACSRN),
     /*  905569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905577 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905579 */     GIR_RootConstrainSelectedInstOperands,
     /*  905580 */     // GIR_Coverage, 64497,
     /*  905580 */     GIR_EraseRootFromParent_Done,
     /*  905581 */   // Label 13790: @905581
     /*  905581 */   GIM_Try, /*On fail goto*//*Label 13791*/ GIMT_Encode4(905645), // Rule ID 64498 //
     /*  905586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVmac_HwMode1),
     /*  905589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_cv_mac_machhsRN),
     /*  905594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  905597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  905600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  905603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  905606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  905622 */     // MIs[0] imm5
     /*  905622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_cv_tuimm5),
     /*  905630 */     // (intrinsic_wo_chain:{ *:[i32] } 10934:{ *:[iPTR] }, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rd, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)  =>  (CV_MACHHSRN:{ *:[i32] } GPR:{ *:[i32] }:$rd, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] })<<P:Predicate_cv_tuimm5>>:$imm5)
     /*  905630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_MACHHSRN),
     /*  905633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  905635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rd
     /*  905637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /*  905639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  905641 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm5
     /*  905643 */     GIR_RootConstrainSelectedInstOperands,
     /*  905644 */     // GIR_Coverage, 64498,
     /*  905644 */     GIR_EraseRootFromParent_Done,
     /*  905645 */   // Label 13791: @905645
     /*  905645 */   GIM_Reject,
     /*  905646 */ // Label 6945: @905646
     /*  905646 */ GIM_Try, /*On fail goto*//*Label 13792*/ GIMT_Encode4(1395119),
     /*  905651 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  905654 */   GIM_Try, /*On fail goto*//*Label 13793*/ GIMT_Encode4(905737), // Rule ID 62830 //
     /*  905659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  905662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  905667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  905676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  905679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905683 */     // MIs[0] op1
     /*  905683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  905686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  905691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905699 */     // MIs[0] op4
     /*  905699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  905707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905714 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  905714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  905717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905719 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  905721 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  905723 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  905725 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  905727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905735 */     GIR_RootConstrainSelectedInstOperands,
     /*  905736 */     // GIR_Coverage, 62830,
     /*  905736 */     GIR_EraseRootFromParent_Done,
     /*  905737 */   // Label 13793: @905737
     /*  905737 */   GIM_Try, /*On fail goto*//*Label 13794*/ GIMT_Encode4(905820), // Rule ID 62831 //
     /*  905742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  905745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  905750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  905753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  905756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  905759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  905762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905766 */     // MIs[0] op1
     /*  905766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  905769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  905774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905782 */     // MIs[0] op4
     /*  905782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  905790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905797 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  905797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF8),
     /*  905800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905802 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  905804 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  905806 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  905808 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  905810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905818 */     GIR_RootConstrainSelectedInstOperands,
     /*  905819 */     // GIR_Coverage, 62831,
     /*  905819 */     GIR_EraseRootFromParent_Done,
     /*  905820 */   // Label 13794: @905820
     /*  905820 */   GIM_Try, /*On fail goto*//*Label 13795*/ GIMT_Encode4(905903), // Rule ID 62874 //
     /*  905825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  905828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  905833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  905842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  905845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905849 */     // MIs[0] op1
     /*  905849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  905852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  905857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905865 */     // MIs[0] op4
     /*  905865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  905873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  905880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  905883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905885 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  905887 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  905889 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  905891 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  905893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905901 */     GIR_RootConstrainSelectedInstOperands,
     /*  905902 */     // GIR_Coverage, 62874,
     /*  905902 */     GIR_EraseRootFromParent_Done,
     /*  905903 */   // Label 13795: @905903
     /*  905903 */   GIM_Try, /*On fail goto*//*Label 13796*/ GIMT_Encode4(905986), // Rule ID 62875 //
     /*  905908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  905911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  905916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  905919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  905922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  905925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  905928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905932 */     // MIs[0] op1
     /*  905932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  905935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  905940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  905948 */     // MIs[0] op4
     /*  905948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  905951 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  905956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  905963 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  905963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  905966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  905968 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  905970 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  905972 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  905974 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  905976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  905981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  905984 */     GIR_RootConstrainSelectedInstOperands,
     /*  905985 */     // GIR_Coverage, 62875,
     /*  905985 */     GIR_EraseRootFromParent_Done,
     /*  905986 */   // Label 13796: @905986
     /*  905986 */   GIM_Try, /*On fail goto*//*Label 13797*/ GIMT_Encode4(906069), // Rule ID 62918 //
     /*  905991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  905994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  905999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906015 */     // MIs[0] op1
     /*  906015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906031 */     // MIs[0] op4
     /*  906031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906034 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906046 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906051 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906053 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906055 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906057 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906067 */     GIR_RootConstrainSelectedInstOperands,
     /*  906068 */     // GIR_Coverage, 62918,
     /*  906068 */     GIR_EraseRootFromParent_Done,
     /*  906069 */   // Label 13797: @906069
     /*  906069 */   GIM_Try, /*On fail goto*//*Label 13798*/ GIMT_Encode4(906152), // Rule ID 62919 //
     /*  906074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  906085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  906088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  906091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906098 */     // MIs[0] op1
     /*  906098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906114 */     // MIs[0] op4
     /*  906114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906117 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906129 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906150 */     GIR_RootConstrainSelectedInstOperands,
     /*  906151 */     // GIR_Coverage, 62919,
     /*  906151 */     GIR_EraseRootFromParent_Done,
     /*  906152 */   // Label 13798: @906152
     /*  906152 */   GIM_Try, /*On fail goto*//*Label 13799*/ GIMT_Encode4(906235), // Rule ID 62962 //
     /*  906157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906181 */     // MIs[0] op1
     /*  906181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906197 */     // MIs[0] op4
     /*  906197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906200 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906212 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906217 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906219 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906221 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906223 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906233 */     GIR_RootConstrainSelectedInstOperands,
     /*  906234 */     // GIR_Coverage, 62962,
     /*  906234 */     GIR_EraseRootFromParent_Done,
     /*  906235 */   // Label 13799: @906235
     /*  906235 */   GIM_Try, /*On fail goto*//*Label 13800*/ GIMT_Encode4(906318), // Rule ID 62963 //
     /*  906240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  906251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  906254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  906257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906264 */     // MIs[0] op1
     /*  906264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906280 */     // MIs[0] op4
     /*  906280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906295 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF4),
     /*  906298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906316 */     GIR_RootConstrainSelectedInstOperands,
     /*  906317 */     // GIR_Coverage, 62963,
     /*  906317 */     GIR_EraseRootFromParent_Done,
     /*  906318 */   // Label 13800: @906318
     /*  906318 */   GIM_Try, /*On fail goto*//*Label 13801*/ GIMT_Encode4(906401), // Rule ID 63018 //
     /*  906323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906347 */     // MIs[0] op1
     /*  906347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906363 */     // MIs[0] op4
     /*  906363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906383 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906385 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906387 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906389 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906399 */     GIR_RootConstrainSelectedInstOperands,
     /*  906400 */     // GIR_Coverage, 63018,
     /*  906400 */     GIR_EraseRootFromParent_Done,
     /*  906401 */   // Label 13801: @906401
     /*  906401 */   GIM_Try, /*On fail goto*//*Label 13802*/ GIMT_Encode4(906484), // Rule ID 63019 //
     /*  906406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  906417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  906420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  906423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906430 */     // MIs[0] op1
     /*  906430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906446 */     // MIs[0] op4
     /*  906446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906461 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906466 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906468 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906470 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906472 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906482 */     GIR_RootConstrainSelectedInstOperands,
     /*  906483 */     // GIR_Coverage, 63019,
     /*  906483 */     GIR_EraseRootFromParent_Done,
     /*  906484 */   // Label 13802: @906484
     /*  906484 */   GIM_Try, /*On fail goto*//*Label 13803*/ GIMT_Encode4(906567), // Rule ID 63074 //
     /*  906489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  906506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906513 */     // MIs[0] op1
     /*  906513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906529 */     // MIs[0] op4
     /*  906529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906532 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906544 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  906544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906549 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906551 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906553 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906555 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906565 */     GIR_RootConstrainSelectedInstOperands,
     /*  906566 */     // GIR_Coverage, 63074,
     /*  906566 */     GIR_EraseRootFromParent_Done,
     /*  906567 */   // Label 13803: @906567
     /*  906567 */   GIM_Try, /*On fail goto*//*Label 13804*/ GIMT_Encode4(906650), // Rule ID 63075 //
     /*  906572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  906583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  906586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  906589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906596 */     // MIs[0] op1
     /*  906596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906612 */     // MIs[0] op4
     /*  906612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906627 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  906627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_MF2),
     /*  906630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906632 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906634 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906636 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906638 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  906648 */     GIR_RootConstrainSelectedInstOperands,
     /*  906649 */     // GIR_Coverage, 63075,
     /*  906649 */     GIR_EraseRootFromParent_Done,
     /*  906650 */   // Label 13804: @906650
     /*  906650 */   GIM_Try, /*On fail goto*//*Label 13805*/ GIMT_Encode4(906733), // Rule ID 63130 //
     /*  906655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  906672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906679 */     // MIs[0] op1
     /*  906679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906695 */     // MIs[0] op4
     /*  906695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906698 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906710 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  906710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  906713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906715 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906717 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906719 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906721 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906731 */     GIR_RootConstrainSelectedInstOperands,
     /*  906732 */     // GIR_Coverage, 63130,
     /*  906732 */     GIR_EraseRootFromParent_Done,
     /*  906733 */   // Label 13805: @906733
     /*  906733 */   GIM_Try, /*On fail goto*//*Label 13806*/ GIMT_Encode4(906816), // Rule ID 63131 //
     /*  906738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  906749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  906752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  906755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906762 */     // MIs[0] op1
     /*  906762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906778 */     // MIs[0] op4
     /*  906778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906793 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  906793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  906796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906798 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906800 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906802 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906804 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  906814 */     GIR_RootConstrainSelectedInstOperands,
     /*  906815 */     // GIR_Coverage, 63131,
     /*  906815 */     GIR_EraseRootFromParent_Done,
     /*  906816 */   // Label 13806: @906816
     /*  906816 */   GIM_Try, /*On fail goto*//*Label 13807*/ GIMT_Encode4(906899), // Rule ID 63174 //
     /*  906821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  906838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  906841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906845 */     // MIs[0] op1
     /*  906845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906861 */     // MIs[0] op4
     /*  906861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  906876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  906879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906881 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906883 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906885 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906887 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906897 */     GIR_RootConstrainSelectedInstOperands,
     /*  906898 */     // GIR_Coverage, 63174,
     /*  906898 */     GIR_EraseRootFromParent_Done,
     /*  906899 */   // Label 13807: @906899
     /*  906899 */   GIM_Try, /*On fail goto*//*Label 13808*/ GIMT_Encode4(906982), // Rule ID 63175 //
     /*  906904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  906907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  906915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  906918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  906921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  906924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906928 */     // MIs[0] op1
     /*  906928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  906931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  906936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  906944 */     // MIs[0] op4
     /*  906944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  906947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  906952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  906959 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  906959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  906962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  906964 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  906966 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  906968 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  906970 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  906972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  906977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  906980 */     GIR_RootConstrainSelectedInstOperands,
     /*  906981 */     // GIR_Coverage, 63175,
     /*  906981 */     GIR_EraseRootFromParent_Done,
     /*  906982 */   // Label 13808: @906982
     /*  906982 */   GIM_Try, /*On fail goto*//*Label 13809*/ GIMT_Encode4(907065), // Rule ID 63230 //
     /*  906987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  906990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  906995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  906998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907011 */     // MIs[0] op1
     /*  907011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907027 */     // MIs[0] op4
     /*  907027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907042 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  907042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907047 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907049 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907051 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907053 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907063 */     GIR_RootConstrainSelectedInstOperands,
     /*  907064 */     // GIR_Coverage, 63230,
     /*  907064 */     GIR_EraseRootFromParent_Done,
     /*  907065 */   // Label 13809: @907065
     /*  907065 */   GIM_Try, /*On fail goto*//*Label 13810*/ GIMT_Encode4(907148), // Rule ID 63231 //
     /*  907070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  907081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  907084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  907087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907094 */     // MIs[0] op1
     /*  907094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907110 */     // MIs[0] op4
     /*  907110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907113 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907125 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  907125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907130 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907132 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907134 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907136 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  907146 */     GIR_RootConstrainSelectedInstOperands,
     /*  907147 */     // GIR_Coverage, 63231,
     /*  907147 */     GIR_EraseRootFromParent_Done,
     /*  907148 */   // Label 13810: @907148
     /*  907148 */   GIM_Try, /*On fail goto*//*Label 13811*/ GIMT_Encode4(907231), // Rule ID 63286 //
     /*  907153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907177 */     // MIs[0] op1
     /*  907177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907193 */     // MIs[0] op4
     /*  907193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907196 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  907208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907213 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907215 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907217 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907219 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907229 */     GIR_RootConstrainSelectedInstOperands,
     /*  907230 */     // GIR_Coverage, 63286,
     /*  907230 */     GIR_EraseRootFromParent_Done,
     /*  907231 */   // Label 13811: @907231
     /*  907231 */   GIM_Try, /*On fail goto*//*Label 13812*/ GIMT_Encode4(907314), // Rule ID 63287 //
     /*  907236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  907247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  907250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  907253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907260 */     // MIs[0] op1
     /*  907260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  907276 */     // MIs[0] op4
     /*  907276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907291 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  907291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M1),
     /*  907294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907296 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907298 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907300 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907302 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  907312 */     GIR_RootConstrainSelectedInstOperands,
     /*  907313 */     // GIR_Coverage, 63287,
     /*  907313 */     GIR_EraseRootFromParent_Done,
     /*  907314 */   // Label 13812: @907314
     /*  907314 */   GIM_Try, /*On fail goto*//*Label 13813*/ GIMT_Encode4(907397), // Rule ID 63342 //
     /*  907319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907343 */     // MIs[0] op1
     /*  907343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907359 */     // MIs[0] op4
     /*  907359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907374 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907379 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907381 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907383 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907385 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907395 */     GIR_RootConstrainSelectedInstOperands,
     /*  907396 */     // GIR_Coverage, 63342,
     /*  907396 */     GIR_EraseRootFromParent_Done,
     /*  907397 */   // Label 13813: @907397
     /*  907397 */   GIM_Try, /*On fail goto*//*Label 13814*/ GIMT_Encode4(907480), // Rule ID 63343 //
     /*  907402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  907413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  907416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  907419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907426 */     // MIs[0] op1
     /*  907426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907442 */     // MIs[0] op4
     /*  907442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907468 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907478 */     GIR_RootConstrainSelectedInstOperands,
     /*  907479 */     // GIR_Coverage, 63343,
     /*  907479 */     GIR_EraseRootFromParent_Done,
     /*  907480 */   // Label 13814: @907480
     /*  907480 */   GIM_Try, /*On fail goto*//*Label 13815*/ GIMT_Encode4(907563), // Rule ID 63386 //
     /*  907485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  907502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907509 */     // MIs[0] op1
     /*  907509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907525 */     // MIs[0] op4
     /*  907525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907528 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  907543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907545 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907547 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907549 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907551 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907561 */     GIR_RootConstrainSelectedInstOperands,
     /*  907562 */     // GIR_Coverage, 63386,
     /*  907562 */     GIR_EraseRootFromParent_Done,
     /*  907563 */   // Label 13815: @907563
     /*  907563 */   GIM_Try, /*On fail goto*//*Label 13816*/ GIMT_Encode4(907646), // Rule ID 63387 //
     /*  907568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  907579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  907582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  907585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907592 */     // MIs[0] op1
     /*  907592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  907608 */     // MIs[0] op4
     /*  907608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907623 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  907626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907628 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907630 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907632 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907634 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907644 */     GIR_RootConstrainSelectedInstOperands,
     /*  907645 */     // GIR_Coverage, 63387,
     /*  907645 */     GIR_EraseRootFromParent_Done,
     /*  907646 */   // Label 13816: @907646
     /*  907646 */   GIM_Try, /*On fail goto*//*Label 13817*/ GIMT_Encode4(907729), // Rule ID 63430 //
     /*  907651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  907668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907675 */     // MIs[0] op1
     /*  907675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907691 */     // MIs[0] op4
     /*  907691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907706 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  907706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  907709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907711 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907713 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907715 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907717 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907727 */     GIR_RootConstrainSelectedInstOperands,
     /*  907728 */     // GIR_Coverage, 63430,
     /*  907728 */     GIR_EraseRootFromParent_Done,
     /*  907729 */   // Label 13817: @907729
     /*  907729 */   GIM_Try, /*On fail goto*//*Label 13818*/ GIMT_Encode4(907812), // Rule ID 63431 //
     /*  907734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  907745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  907748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  907751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907758 */     // MIs[0] op1
     /*  907758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  907774 */     // MIs[0] op4
     /*  907774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907789 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  907789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  907792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907800 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  907810 */     GIR_RootConstrainSelectedInstOperands,
     /*  907811 */     // GIR_Coverage, 63431,
     /*  907811 */     GIR_EraseRootFromParent_Done,
     /*  907812 */   // Label 13818: @907812
     /*  907812 */   GIM_Try, /*On fail goto*//*Label 13819*/ GIMT_Encode4(907895), // Rule ID 63474 //
     /*  907817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  907834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  907837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907841 */     // MIs[0] op1
     /*  907841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907857 */     // MIs[0] op4
     /*  907857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907860 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  907872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907877 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907879 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907881 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907883 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907893 */     GIR_RootConstrainSelectedInstOperands,
     /*  907894 */     // GIR_Coverage, 63474,
     /*  907894 */     GIR_EraseRootFromParent_Done,
     /*  907895 */   // Label 13819: @907895
     /*  907895 */   GIM_Try, /*On fail goto*//*Label 13820*/ GIMT_Encode4(907978), // Rule ID 63475 //
     /*  907900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  907903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  907911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  907914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  907917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  907920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907924 */     // MIs[0] op1
     /*  907924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  907927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  907932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  907940 */     // MIs[0] op4
     /*  907940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  907943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  907948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  907955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  907955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  907958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  907960 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  907962 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  907964 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  907966 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  907968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  907973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  907976 */     GIR_RootConstrainSelectedInstOperands,
     /*  907977 */     // GIR_Coverage, 63475,
     /*  907977 */     GIR_EraseRootFromParent_Done,
     /*  907978 */   // Label 13820: @907978
     /*  907978 */   GIM_Try, /*On fail goto*//*Label 13821*/ GIMT_Encode4(908061), // Rule ID 63530 //
     /*  907983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  907986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  907991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  907994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  907997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908007 */     // MIs[0] op1
     /*  908007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908023 */     // MIs[0] op4
     /*  908023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908026 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908038 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908043 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908045 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908047 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908049 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908059 */     GIR_RootConstrainSelectedInstOperands,
     /*  908060 */     // GIR_Coverage, 63530,
     /*  908060 */     GIR_EraseRootFromParent_Done,
     /*  908061 */   // Label 13821: @908061
     /*  908061 */   GIM_Try, /*On fail goto*//*Label 13822*/ GIMT_Encode4(908144), // Rule ID 63531 //
     /*  908066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  908077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  908080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  908083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908090 */     // MIs[0] op1
     /*  908090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908106 */     // MIs[0] op4
     /*  908106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908121 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908126 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908128 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908130 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908132 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908142 */     GIR_RootConstrainSelectedInstOperands,
     /*  908143 */     // GIR_Coverage, 63531,
     /*  908143 */     GIR_EraseRootFromParent_Done,
     /*  908144 */   // Label 13822: @908144
     /*  908144 */   GIM_Try, /*On fail goto*//*Label 13823*/ GIMT_Encode4(908227), // Rule ID 63586 //
     /*  908149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908173 */     // MIs[0] op1
     /*  908173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908176 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908189 */     // MIs[0] op4
     /*  908189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908204 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  908204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908209 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908211 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908213 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908215 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908225 */     GIR_RootConstrainSelectedInstOperands,
     /*  908226 */     // GIR_Coverage, 63586,
     /*  908226 */     GIR_EraseRootFromParent_Done,
     /*  908227 */   // Label 13823: @908227
     /*  908227 */   GIM_Try, /*On fail goto*//*Label 13824*/ GIMT_Encode4(908310), // Rule ID 63587 //
     /*  908232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  908243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  908246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  908249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908256 */     // MIs[0] op1
     /*  908256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908272 */     // MIs[0] op4
     /*  908272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908287 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  908287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908292 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908294 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908296 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908298 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  908308 */     GIR_RootConstrainSelectedInstOperands,
     /*  908309 */     // GIR_Coverage, 63587,
     /*  908309 */     GIR_EraseRootFromParent_Done,
     /*  908310 */   // Label 13824: @908310
     /*  908310 */   GIM_Try, /*On fail goto*//*Label 13825*/ GIMT_Encode4(908393), // Rule ID 63642 //
     /*  908315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908339 */     // MIs[0] op1
     /*  908339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908355 */     // MIs[0] op4
     /*  908355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908358 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908375 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908377 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908379 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908381 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908391 */     GIR_RootConstrainSelectedInstOperands,
     /*  908392 */     // GIR_Coverage, 63642,
     /*  908392 */     GIR_EraseRootFromParent_Done,
     /*  908393 */   // Label 13825: @908393
     /*  908393 */   GIM_Try, /*On fail goto*//*Label 13826*/ GIMT_Encode4(908476), // Rule ID 63643 //
     /*  908398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  908409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  908412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  908415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908422 */     // MIs[0] op1
     /*  908422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908425 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908438 */     // MIs[0] op4
     /*  908438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908453 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908458 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908460 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908462 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908464 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908474 */     GIR_RootConstrainSelectedInstOperands,
     /*  908475 */     // GIR_Coverage, 63643,
     /*  908475 */     GIR_EraseRootFromParent_Done,
     /*  908476 */   // Label 13826: @908476
     /*  908476 */   GIM_Try, /*On fail goto*//*Label 13827*/ GIMT_Encode4(908559), // Rule ID 63698 //
     /*  908481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  908498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908505 */     // MIs[0] op1
     /*  908505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908508 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908521 */     // MIs[0] op4
     /*  908521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908536 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908541 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908543 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908545 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908547 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908557 */     GIR_RootConstrainSelectedInstOperands,
     /*  908558 */     // GIR_Coverage, 63698,
     /*  908558 */     GIR_EraseRootFromParent_Done,
     /*  908559 */   // Label 13827: @908559
     /*  908559 */   GIM_Try, /*On fail goto*//*Label 13828*/ GIMT_Encode4(908642), // Rule ID 63699 //
     /*  908564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  908575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  908578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  908581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908588 */     // MIs[0] op1
     /*  908588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908591 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  908604 */     // MIs[0] op4
     /*  908604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908607 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908619 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  908622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908624 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908626 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908628 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908630 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908640 */     GIR_RootConstrainSelectedInstOperands,
     /*  908641 */     // GIR_Coverage, 63699,
     /*  908641 */     GIR_EraseRootFromParent_Done,
     /*  908642 */   // Label 13828: @908642
     /*  908642 */   GIM_Try, /*On fail goto*//*Label 13829*/ GIMT_Encode4(908725), // Rule ID 63754 //
     /*  908647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  908664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908671 */     // MIs[0] op1
     /*  908671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908687 */     // MIs[0] op4
     /*  908687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908690 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908702 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  908702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908707 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908709 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908711 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908713 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908723 */     GIR_RootConstrainSelectedInstOperands,
     /*  908724 */     // GIR_Coverage, 63754,
     /*  908724 */     GIR_EraseRootFromParent_Done,
     /*  908725 */   // Label 13829: @908725
     /*  908725 */   GIM_Try, /*On fail goto*//*Label 13830*/ GIMT_Encode4(908808), // Rule ID 63755 //
     /*  908730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  908741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  908744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  908747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908754 */     // MIs[0] op1
     /*  908754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  908770 */     // MIs[0] op4
     /*  908770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908773 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908785 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  908785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  908788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908796 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  908806 */     GIR_RootConstrainSelectedInstOperands,
     /*  908807 */     // GIR_Coverage, 63755,
     /*  908807 */     GIR_EraseRootFromParent_Done,
     /*  908808 */   // Label 13830: @908808
     /*  908808 */   GIM_Try, /*On fail goto*//*Label 13831*/ GIMT_Encode4(908891), // Rule ID 63810 //
     /*  908813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  908830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908837 */     // MIs[0] op1
     /*  908837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908853 */     // MIs[0] op4
     /*  908853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  908868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908873 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908875 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908877 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908879 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908889 */     GIR_RootConstrainSelectedInstOperands,
     /*  908890 */     // GIR_Coverage, 63810,
     /*  908890 */     GIR_EraseRootFromParent_Done,
     /*  908891 */   // Label 13831: @908891
     /*  908891 */   GIM_Try, /*On fail goto*//*Label 13832*/ GIMT_Encode4(908974), // Rule ID 63811 //
     /*  908896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  908899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  908907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  908910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  908913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  908916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908920 */     // MIs[0] op1
     /*  908920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  908923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  908928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  908936 */     // MIs[0] op4
     /*  908936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  908939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  908944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  908951 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  908951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M2),
     /*  908954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  908956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  908958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  908960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  908962 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  908964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  908969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  908972 */     GIR_RootConstrainSelectedInstOperands,
     /*  908973 */     // GIR_Coverage, 63811,
     /*  908973 */     GIR_EraseRootFromParent_Done,
     /*  908974 */   // Label 13832: @908974
     /*  908974 */   GIM_Try, /*On fail goto*//*Label 13833*/ GIMT_Encode4(909057), // Rule ID 63866 //
     /*  908979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  908982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  908987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  908990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  908993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  908996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  908999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909003 */     // MIs[0] op1
     /*  909003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909019 */     // MIs[0] op4
     /*  909019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909039 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909041 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909043 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909045 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909055 */     GIR_RootConstrainSelectedInstOperands,
     /*  909056 */     // GIR_Coverage, 63866,
     /*  909056 */     GIR_EraseRootFromParent_Done,
     /*  909057 */   // Label 13833: @909057
     /*  909057 */   GIM_Try, /*On fail goto*//*Label 13834*/ GIMT_Encode4(909140), // Rule ID 63867 //
     /*  909062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  909073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  909076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  909079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909086 */     // MIs[0] op1
     /*  909086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909102 */     // MIs[0] op4
     /*  909102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909117 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M4),
     /*  909120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909122 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909124 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909126 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909128 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909138 */     GIR_RootConstrainSelectedInstOperands,
     /*  909139 */     // GIR_Coverage, 63867,
     /*  909139 */     GIR_EraseRootFromParent_Done,
     /*  909140 */   // Label 13834: @909140
     /*  909140 */   GIM_Try, /*On fail goto*//*Label 13835*/ GIMT_Encode4(909223), // Rule ID 63922 //
     /*  909145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909169 */     // MIs[0] op1
     /*  909169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909185 */     // MIs[0] op4
     /*  909185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909188 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909200 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  909200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909205 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909207 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909209 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909211 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909221 */     GIR_RootConstrainSelectedInstOperands,
     /*  909222 */     // GIR_Coverage, 63922,
     /*  909222 */     GIR_EraseRootFromParent_Done,
     /*  909223 */   // Label 13835: @909223
     /*  909223 */   GIM_Try, /*On fail goto*//*Label 13836*/ GIMT_Encode4(909306), // Rule ID 63923 //
     /*  909228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivv),
     /*  909236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  909239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  909242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  909245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909252 */     // MIs[0] op1
     /*  909252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  909268 */     // MIs[0] op4
     /*  909268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909283 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11002:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  909283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVV_M8),
     /*  909286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909288 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909290 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909292 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909294 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  909304 */     GIR_RootConstrainSelectedInstOperands,
     /*  909305 */     // GIR_Coverage, 63923,
     /*  909305 */     GIR_EraseRootFromParent_Done,
     /*  909306 */   // Label 13836: @909306
     /*  909306 */   GIM_Try, /*On fail goto*//*Label 13837*/ GIMT_Encode4(909389), // Rule ID 63952 //
     /*  909311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909335 */     // MIs[0] op1
     /*  909335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909351 */     // MIs[0] op4
     /*  909351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909366 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  909369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909371 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909373 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909375 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909377 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909387 */     GIR_RootConstrainSelectedInstOperands,
     /*  909388 */     // GIR_Coverage, 63952,
     /*  909388 */     GIR_EraseRootFromParent_Done,
     /*  909389 */   // Label 13837: @909389
     /*  909389 */   GIM_Try, /*On fail goto*//*Label 13838*/ GIMT_Encode4(909472), // Rule ID 63953 //
     /*  909394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  909405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  909408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  909411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909418 */     // MIs[0] op1
     /*  909418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909434 */     // MIs[0] op4
     /*  909434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909449 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF8),
     /*  909452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909454 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909456 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909458 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909460 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909470 */     GIR_RootConstrainSelectedInstOperands,
     /*  909471 */     // GIR_Coverage, 63953,
     /*  909471 */     GIR_EraseRootFromParent_Done,
     /*  909472 */   // Label 13838: @909472
     /*  909472 */   GIM_Try, /*On fail goto*//*Label 13839*/ GIMT_Encode4(909555), // Rule ID 63970 //
     /*  909477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  909488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  909491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  909494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909501 */     // MIs[0] op1
     /*  909501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909517 */     // MIs[0] op4
     /*  909517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909520 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  909535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909537 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909539 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909541 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909543 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909553 */     GIR_RootConstrainSelectedInstOperands,
     /*  909554 */     // GIR_Coverage, 63970,
     /*  909554 */     GIR_EraseRootFromParent_Done,
     /*  909555 */   // Label 13839: @909555
     /*  909555 */   GIM_Try, /*On fail goto*//*Label 13840*/ GIMT_Encode4(909638), // Rule ID 63971 //
     /*  909560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  909571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  909574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  909577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909584 */     // MIs[0] op1
     /*  909584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909600 */     // MIs[0] op4
     /*  909600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909615 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  909618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909620 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909622 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909624 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909626 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909636 */     GIR_RootConstrainSelectedInstOperands,
     /*  909637 */     // GIR_Coverage, 63971,
     /*  909637 */     GIR_EraseRootFromParent_Done,
     /*  909638 */   // Label 13840: @909638
     /*  909638 */   GIM_Try, /*On fail goto*//*Label 13841*/ GIMT_Encode4(909721), // Rule ID 63988 //
     /*  909643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  909654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  909657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  909660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909667 */     // MIs[0] op1
     /*  909667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909670 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909683 */     // MIs[0] op4
     /*  909683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909686 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  909701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909703 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909705 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909707 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909709 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909719 */     GIR_RootConstrainSelectedInstOperands,
     /*  909720 */     // GIR_Coverage, 63988,
     /*  909720 */     GIR_EraseRootFromParent_Done,
     /*  909721 */   // Label 13841: @909721
     /*  909721 */   GIM_Try, /*On fail goto*//*Label 13842*/ GIMT_Encode4(909804), // Rule ID 63989 //
     /*  909726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  909737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  909740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  909743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909750 */     // MIs[0] op1
     /*  909750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909766 */     // MIs[0] op4
     /*  909766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909781 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  909784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909786 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909788 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909790 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909792 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909802 */     GIR_RootConstrainSelectedInstOperands,
     /*  909803 */     // GIR_Coverage, 63989,
     /*  909803 */     GIR_EraseRootFromParent_Done,
     /*  909804 */   // Label 13842: @909804
     /*  909804 */   GIM_Try, /*On fail goto*//*Label 13843*/ GIMT_Encode4(909887), // Rule ID 64006 //
     /*  909809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  909820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  909823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  909826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909833 */     // MIs[0] op1
     /*  909833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909849 */     // MIs[0] op4
     /*  909849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909852 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909864 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  909864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  909867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909869 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909871 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909873 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909875 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909885 */     GIR_RootConstrainSelectedInstOperands,
     /*  909886 */     // GIR_Coverage, 64006,
     /*  909886 */     GIR_EraseRootFromParent_Done,
     /*  909887 */   // Label 13843: @909887
     /*  909887 */   GIM_Try, /*On fail goto*//*Label 13844*/ GIMT_Encode4(909970), // Rule ID 64007 //
     /*  909892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  909895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  909903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  909906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  909909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  909912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909916 */     // MIs[0] op1
     /*  909916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  909919 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  909924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  909928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  909932 */     // MIs[0] op4
     /*  909932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  909935 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  909940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  909947 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  909947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  909950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  909952 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  909954 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  909956 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  909958 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  909960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  909965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  909968 */     GIR_RootConstrainSelectedInstOperands,
     /*  909969 */     // GIR_Coverage, 64007,
     /*  909969 */     GIR_EraseRootFromParent_Done,
     /*  909970 */   // Label 13844: @909970
     /*  909970 */   GIM_Try, /*On fail goto*//*Label 13845*/ GIMT_Encode4(910053), // Rule ID 64024 //
     /*  909975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  909978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  909983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  909986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  909989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  909992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  909995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  909999 */     // MIs[0] op1
     /*  909999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910015 */     // MIs[0] op4
     /*  910015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910035 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910037 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910039 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910041 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910051 */     GIR_RootConstrainSelectedInstOperands,
     /*  910052 */     // GIR_Coverage, 64024,
     /*  910052 */     GIR_EraseRootFromParent_Done,
     /*  910053 */   // Label 13845: @910053
     /*  910053 */   GIM_Try, /*On fail goto*//*Label 13846*/ GIMT_Encode4(910136), // Rule ID 64025 //
     /*  910058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  910069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  910072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  910075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910082 */     // MIs[0] op1
     /*  910082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910098 */     // MIs[0] op4
     /*  910098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910113 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910118 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910120 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910122 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910124 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910134 */     GIR_RootConstrainSelectedInstOperands,
     /*  910135 */     // GIR_Coverage, 64025,
     /*  910135 */     GIR_EraseRootFromParent_Done,
     /*  910136 */   // Label 13846: @910136
     /*  910136 */   GIM_Try, /*On fail goto*//*Label 13847*/ GIMT_Encode4(910219), // Rule ID 64042 //
     /*  910141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910165 */     // MIs[0] op1
     /*  910165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910181 */     // MIs[0] op4
     /*  910181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910196 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  910196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  910199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910201 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910203 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910205 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910207 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910217 */     GIR_RootConstrainSelectedInstOperands,
     /*  910218 */     // GIR_Coverage, 64042,
     /*  910218 */     GIR_EraseRootFromParent_Done,
     /*  910219 */   // Label 13847: @910219
     /*  910219 */   GIM_Try, /*On fail goto*//*Label 13848*/ GIMT_Encode4(910302), // Rule ID 64043 //
     /*  910224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  910235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  910238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  910241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910248 */     // MIs[0] op1
     /*  910248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910264 */     // MIs[0] op4
     /*  910264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910279 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  910279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  910282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910284 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910286 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910288 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910290 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  910300 */     GIR_RootConstrainSelectedInstOperands,
     /*  910301 */     // GIR_Coverage, 64043,
     /*  910301 */     GIR_EraseRootFromParent_Done,
     /*  910302 */   // Label 13848: @910302
     /*  910302 */   GIM_Try, /*On fail goto*//*Label 13849*/ GIMT_Encode4(910385), // Rule ID 64060 //
     /*  910307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910331 */     // MIs[0] op1
     /*  910331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910347 */     // MIs[0] op4
     /*  910347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910350 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910367 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910369 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910371 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910373 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910383 */     GIR_RootConstrainSelectedInstOperands,
     /*  910384 */     // GIR_Coverage, 64060,
     /*  910384 */     GIR_EraseRootFromParent_Done,
     /*  910385 */   // Label 13849: @910385
     /*  910385 */   GIM_Try, /*On fail goto*//*Label 13850*/ GIMT_Encode4(910468), // Rule ID 64061 //
     /*  910390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  910401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  910404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  910407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910414 */     // MIs[0] op1
     /*  910414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910430 */     // MIs[0] op4
     /*  910430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910445 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF4),
     /*  910448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910450 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910452 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910454 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910456 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910466 */     GIR_RootConstrainSelectedInstOperands,
     /*  910467 */     // GIR_Coverage, 64061,
     /*  910467 */     GIR_EraseRootFromParent_Done,
     /*  910468 */   // Label 13850: @910468
     /*  910468 */   GIM_Try, /*On fail goto*//*Label 13851*/ GIMT_Encode4(910551), // Rule ID 64084 //
     /*  910473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  910484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  910487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910497 */     // MIs[0] op1
     /*  910497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910513 */     // MIs[0] op4
     /*  910513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910516 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  910531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910533 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910535 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910537 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910539 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910549 */     GIR_RootConstrainSelectedInstOperands,
     /*  910550 */     // GIR_Coverage, 64084,
     /*  910550 */     GIR_EraseRootFromParent_Done,
     /*  910551 */   // Label 13851: @910551
     /*  910551 */   GIM_Try, /*On fail goto*//*Label 13852*/ GIMT_Encode4(910634), // Rule ID 64085 //
     /*  910556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  910567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  910570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  910573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910580 */     // MIs[0] op1
     /*  910580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910596 */     // MIs[0] op4
     /*  910596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910611 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  910614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910616 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910618 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910620 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910622 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910632 */     GIR_RootConstrainSelectedInstOperands,
     /*  910633 */     // GIR_Coverage, 64085,
     /*  910633 */     GIR_EraseRootFromParent_Done,
     /*  910634 */   // Label 13852: @910634
     /*  910634 */   GIM_Try, /*On fail goto*//*Label 13853*/ GIMT_Encode4(910717), // Rule ID 64108 //
     /*  910639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  910650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  910653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  910656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910663 */     // MIs[0] op1
     /*  910663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910679 */     // MIs[0] op4
     /*  910679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910694 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  910697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910699 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910701 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910703 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910705 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910715 */     GIR_RootConstrainSelectedInstOperands,
     /*  910716 */     // GIR_Coverage, 64108,
     /*  910716 */     GIR_EraseRootFromParent_Done,
     /*  910717 */   // Label 13853: @910717
     /*  910717 */   GIM_Try, /*On fail goto*//*Label 13854*/ GIMT_Encode4(910800), // Rule ID 64109 //
     /*  910722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  910733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  910736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  910739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910746 */     // MIs[0] op1
     /*  910746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  910762 */     // MIs[0] op4
     /*  910762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910777 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  910780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910782 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910784 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910786 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910788 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910798 */     GIR_RootConstrainSelectedInstOperands,
     /*  910799 */     // GIR_Coverage, 64109,
     /*  910799 */     GIR_EraseRootFromParent_Done,
     /*  910800 */   // Label 13854: @910800
     /*  910800 */   GIM_Try, /*On fail goto*//*Label 13855*/ GIMT_Encode4(910883), // Rule ID 64132 //
     /*  910805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  910816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  910819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  910822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910829 */     // MIs[0] op1
     /*  910829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910845 */     // MIs[0] op4
     /*  910845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910848 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910860 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  910860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910865 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910867 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910869 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910871 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910881 */     GIR_RootConstrainSelectedInstOperands,
     /*  910882 */     // GIR_Coverage, 64132,
     /*  910882 */     GIR_EraseRootFromParent_Done,
     /*  910883 */   // Label 13855: @910883
     /*  910883 */   GIM_Try, /*On fail goto*//*Label 13856*/ GIMT_Encode4(910966), // Rule ID 64133 //
     /*  910888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  910891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  910899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  910902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  910905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  910908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910912 */     // MIs[0] op1
     /*  910912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  910920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  910924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  910928 */     // MIs[0] op4
     /*  910928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  910931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  910936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  910943 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  910943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  910946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  910948 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  910950 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  910952 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  910954 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  910956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  910961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  910964 */     GIR_RootConstrainSelectedInstOperands,
     /*  910965 */     // GIR_Coverage, 64133,
     /*  910965 */     GIR_EraseRootFromParent_Done,
     /*  910966 */   // Label 13856: @910966
     /*  910966 */   GIM_Try, /*On fail goto*//*Label 13857*/ GIMT_Encode4(911049), // Rule ID 64156 //
     /*  910971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  910974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  910979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  910982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  910985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  910988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  910991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  910995 */     // MIs[0] op1
     /*  910995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  910998 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911011 */     // MIs[0] op4
     /*  911011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911014 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911026 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  911026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911031 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911033 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911035 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911037 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911047 */     GIR_RootConstrainSelectedInstOperands,
     /*  911048 */     // GIR_Coverage, 64156,
     /*  911048 */     GIR_EraseRootFromParent_Done,
     /*  911049 */   // Label 13857: @911049
     /*  911049 */   GIM_Try, /*On fail goto*//*Label 13858*/ GIMT_Encode4(911132), // Rule ID 64157 //
     /*  911054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  911065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  911068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  911071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911078 */     // MIs[0] op1
     /*  911078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911094 */     // MIs[0] op4
     /*  911094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911109 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  911109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911114 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911116 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911118 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911120 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  911130 */     GIR_RootConstrainSelectedInstOperands,
     /*  911131 */     // GIR_Coverage, 64157,
     /*  911131 */     GIR_EraseRootFromParent_Done,
     /*  911132 */   // Label 13858: @911132
     /*  911132 */   GIM_Try, /*On fail goto*//*Label 13859*/ GIMT_Encode4(911215), // Rule ID 64180 //
     /*  911137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911161 */     // MIs[0] op1
     /*  911161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911177 */     // MIs[0] op4
     /*  911177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911197 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911199 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911201 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911203 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911213 */     GIR_RootConstrainSelectedInstOperands,
     /*  911214 */     // GIR_Coverage, 64180,
     /*  911214 */     GIR_EraseRootFromParent_Done,
     /*  911215 */   // Label 13859: @911215
     /*  911215 */   GIM_Try, /*On fail goto*//*Label 13860*/ GIMT_Encode4(911298), // Rule ID 64181 //
     /*  911220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  911231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  911234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  911237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911244 */     // MIs[0] op1
     /*  911244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911247 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911260 */     // MIs[0] op4
     /*  911260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911263 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911275 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_MF2),
     /*  911278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911280 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911282 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911284 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911286 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911296 */     GIR_RootConstrainSelectedInstOperands,
     /*  911297 */     // GIR_Coverage, 64181,
     /*  911297 */     GIR_EraseRootFromParent_Done,
     /*  911298 */   // Label 13860: @911298
     /*  911298 */   GIM_Try, /*On fail goto*//*Label 13861*/ GIMT_Encode4(911381), // Rule ID 64204 //
     /*  911303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911327 */     // MIs[0] op1
     /*  911327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911343 */     // MIs[0] op4
     /*  911343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911358 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911363 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911365 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911367 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911369 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911379 */     GIR_RootConstrainSelectedInstOperands,
     /*  911380 */     // GIR_Coverage, 64204,
     /*  911380 */     GIR_EraseRootFromParent_Done,
     /*  911381 */   // Label 13861: @911381
     /*  911381 */   GIM_Try, /*On fail goto*//*Label 13862*/ GIMT_Encode4(911464), // Rule ID 64205 //
     /*  911386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  911397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  911400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  911403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911410 */     // MIs[0] op1
     /*  911410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911413 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911426 */     // MIs[0] op4
     /*  911426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911441 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M1),
     /*  911444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911446 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911448 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911450 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911452 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911462 */     GIR_RootConstrainSelectedInstOperands,
     /*  911463 */     // GIR_Coverage, 64205,
     /*  911463 */     GIR_EraseRootFromParent_Done,
     /*  911464 */   // Label 13862: @911464
     /*  911464 */   GIM_Try, /*On fail goto*//*Label 13863*/ GIMT_Encode4(911547), // Rule ID 64228 //
     /*  911469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  911480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  911483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  911486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911493 */     // MIs[0] op1
     /*  911493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911496 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911509 */     // MIs[0] op4
     /*  911509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911512 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911524 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  911527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911529 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911531 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911533 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911535 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911545 */     GIR_RootConstrainSelectedInstOperands,
     /*  911546 */     // GIR_Coverage, 64228,
     /*  911546 */     GIR_EraseRootFromParent_Done,
     /*  911547 */   // Label 13863: @911547
     /*  911547 */   GIM_Try, /*On fail goto*//*Label 13864*/ GIMT_Encode4(911630), // Rule ID 64229 //
     /*  911552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  911563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  911566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  911569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911576 */     // MIs[0] op1
     /*  911576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  911592 */     // MIs[0] op4
     /*  911592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911607 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M2),
     /*  911610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911612 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911614 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911616 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911618 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911628 */     GIR_RootConstrainSelectedInstOperands,
     /*  911629 */     // GIR_Coverage, 64229,
     /*  911629 */     GIR_EraseRootFromParent_Done,
     /*  911630 */   // Label 13864: @911630
     /*  911630 */   GIM_Try, /*On fail goto*//*Label 13865*/ GIMT_Encode4(911713), // Rule ID 64252 //
     /*  911635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  911638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  911646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  911649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  911652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  911655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911659 */     // MIs[0] op1
     /*  911659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911675 */     // MIs[0] op4
     /*  911675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911690 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i64] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  911690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911695 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911697 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911699 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911701 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911711 */     GIR_RootConstrainSelectedInstOperands,
     /*  911712 */     // GIR_Coverage, 64252,
     /*  911712 */     GIR_EraseRootFromParent_Done,
     /*  911713 */   // Label 13865: @911713
     /*  911713 */   GIM_Try, /*On fail goto*//*Label 13866*/ GIMT_Encode4(911796), // Rule ID 64253 //
     /*  911718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  911721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_ivw),
     /*  911726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  911729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  911732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  911735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  911738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911742 */     // MIs[0] op1
     /*  911742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  911745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  911750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  911754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  911758 */     // MIs[0] op4
     /*  911758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  911761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tsimm5),
     /*  911766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11004:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_IVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, (timm:{ *:[i32] })<<P:Predicate_tsimm5>>:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  911773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_IVW_M4),
     /*  911776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  911778 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  911780 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  911782 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  911784 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  911786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911794 */     GIR_RootConstrainSelectedInstOperands,
     /*  911795 */     // GIR_Coverage, 64253,
     /*  911795 */     GIR_EraseRootFromParent_Done,
     /*  911796 */   // Label 13866: @911796
     /*  911796 */   GIM_Try, /*On fail goto*//*Label 13867*/ GIMT_Encode4(911874), // Rule ID 60482 //
     /*  911801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  911804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  911809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  911815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911833 */     // MIs[0] rs2
     /*  911833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  911836 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  911841 */     // MIs[0] policy
     /*  911841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911851 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  911851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  911854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  911856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911872 */     GIR_RootConstrainSelectedInstOperands,
     /*  911873 */     // GIR_Coverage, 60482,
     /*  911873 */     GIR_EraseRootFromParent_Done,
     /*  911874 */   // Label 13867: @911874
     /*  911874 */   GIM_Try, /*On fail goto*//*Label 13868*/ GIMT_Encode4(911952), // Rule ID 60483 //
     /*  911879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  911882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  911887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  911890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  911893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  911896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  911899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911911 */     // MIs[0] rs2
     /*  911911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  911914 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  911919 */     // MIs[0] policy
     /*  911919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  911922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  911929 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  911929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_MF2),
     /*  911932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  911934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  911936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  911938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  911940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  911945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  911948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  911950 */     GIR_RootConstrainSelectedInstOperands,
     /*  911951 */     // GIR_Coverage, 60483,
     /*  911951 */     GIR_EraseRootFromParent_Done,
     /*  911952 */   // Label 13868: @911952
     /*  911952 */   GIM_Try, /*On fail goto*//*Label 13869*/ GIMT_Encode4(912030), // Rule ID 62138 //
     /*  911957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  911960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  911965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  911968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  911971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  911974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  911977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  911989 */     // MIs[0] rs2
     /*  911989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  911992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  911997 */     // MIs[0] policy
     /*  911997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912007 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912028 */     GIR_RootConstrainSelectedInstOperands,
     /*  912029 */     // GIR_Coverage, 62138,
     /*  912029 */     GIR_EraseRootFromParent_Done,
     /*  912030 */   // Label 13869: @912030
     /*  912030 */   GIM_Try, /*On fail goto*//*Label 13870*/ GIMT_Encode4(912108), // Rule ID 62139 //
     /*  912035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912067 */     // MIs[0] rs2
     /*  912067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912070 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912075 */     // MIs[0] policy
     /*  912075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912085 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11085:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M1),
     /*  912088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912106 */     GIR_RootConstrainSelectedInstOperands,
     /*  912107 */     // GIR_Coverage, 62139,
     /*  912107 */     GIR_EraseRootFromParent_Done,
     /*  912108 */   // Label 13870: @912108
     /*  912108 */   GIM_Try, /*On fail goto*//*Label 13871*/ GIMT_Encode4(912186), // Rule ID 62140 //
     /*  912113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912145 */     // MIs[0] rs2
     /*  912145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912153 */     // MIs[0] policy
     /*  912153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912184 */     GIR_RootConstrainSelectedInstOperands,
     /*  912185 */     // GIR_Coverage, 62140,
     /*  912185 */     GIR_EraseRootFromParent_Done,
     /*  912186 */   // Label 13871: @912186
     /*  912186 */   GIM_Try, /*On fail goto*//*Label 13872*/ GIMT_Encode4(912264), // Rule ID 62141 //
     /*  912191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912223 */     // MIs[0] rs2
     /*  912223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912231 */     // MIs[0] policy
     /*  912231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912241 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11085:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M2),
     /*  912244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912262 */     GIR_RootConstrainSelectedInstOperands,
     /*  912263 */     // GIR_Coverage, 62141,
     /*  912263 */     GIR_EraseRootFromParent_Done,
     /*  912264 */   // Label 13872: @912264
     /*  912264 */   GIM_Try, /*On fail goto*//*Label 13873*/ GIMT_Encode4(912342), // Rule ID 62142 //
     /*  912269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912301 */     // MIs[0] rs2
     /*  912301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912309 */     // MIs[0] policy
     /*  912309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912319 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912340 */     GIR_RootConstrainSelectedInstOperands,
     /*  912341 */     // GIR_Coverage, 62142,
     /*  912341 */     GIR_EraseRootFromParent_Done,
     /*  912342 */   // Label 13873: @912342
     /*  912342 */   GIM_Try, /*On fail goto*//*Label 13874*/ GIMT_Encode4(912420), // Rule ID 62143 //
     /*  912347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  912358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  912361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  912364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  912379 */     // MIs[0] rs2
     /*  912379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912387 */     // MIs[0] policy
     /*  912387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912397 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11085:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M4),
     /*  912400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912418 */     GIR_RootConstrainSelectedInstOperands,
     /*  912419 */     // GIR_Coverage, 62143,
     /*  912419 */     GIR_EraseRootFromParent_Done,
     /*  912420 */   // Label 13874: @912420
     /*  912420 */   GIM_Try, /*On fail goto*//*Label 13875*/ GIMT_Encode4(912498), // Rule ID 62144 //
     /*  912425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode0),
     /*  912428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  912439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912457 */     // MIs[0] rs2
     /*  912457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912460 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912465 */     // MIs[0] policy
     /*  912465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912475 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  912478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912496 */     GIR_RootConstrainSelectedInstOperands,
     /*  912497 */     // GIR_Coverage, 62144,
     /*  912497 */     GIR_EraseRootFromParent_Done,
     /*  912498 */   // Label 13875: @912498
     /*  912498 */   GIM_Try, /*On fail goto*//*Label 13876*/ GIMT_Encode4(912576), // Rule ID 62145 //
     /*  912503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkned_HwMode1),
     /*  912506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaeskf2),
     /*  912511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  912514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  912517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  912520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  912535 */     // MIs[0] rs2
     /*  912535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912538 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912543 */     // MIs[0] policy
     /*  912543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912553 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11085:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAESKF2_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAESKF2_VI_M8),
     /*  912556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912574 */     GIR_RootConstrainSelectedInstOperands,
     /*  912575 */     // GIR_Coverage, 62145,
     /*  912575 */     GIR_EraseRootFromParent_Done,
     /*  912576 */   // Label 13876: @912576
     /*  912576 */   GIM_Try, /*On fail goto*//*Label 13877*/ GIMT_Encode4(912654), // Rule ID 62306 //
     /*  912581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  912584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912613 */     // MIs[0] rs2
     /*  912613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912621 */     // MIs[0] policy
     /*  912621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912631 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  912634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912652 */     GIR_RootConstrainSelectedInstOperands,
     /*  912653 */     // GIR_Coverage, 62306,
     /*  912653 */     GIR_EraseRootFromParent_Done,
     /*  912654 */   // Label 13877: @912654
     /*  912654 */   GIM_Try, /*On fail goto*//*Label 13878*/ GIMT_Encode4(912732), // Rule ID 62307 //
     /*  912659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  912662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  912670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  912673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  912676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912691 */     // MIs[0] rs2
     /*  912691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912699 */     // MIs[0] policy
     /*  912699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912709 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_MF2),
     /*  912712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912730 */     GIR_RootConstrainSelectedInstOperands,
     /*  912731 */     // GIR_Coverage, 62307,
     /*  912731 */     GIR_EraseRootFromParent_Done,
     /*  912732 */   // Label 13878: @912732
     /*  912732 */   GIM_Try, /*On fail goto*//*Label 13879*/ GIMT_Encode4(912810), // Rule ID 62308 //
     /*  912737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  912740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912769 */     // MIs[0] rs2
     /*  912769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912777 */     // MIs[0] policy
     /*  912777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  912790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912808 */     GIR_RootConstrainSelectedInstOperands,
     /*  912809 */     // GIR_Coverage, 62308,
     /*  912809 */     GIR_EraseRootFromParent_Done,
     /*  912810 */   // Label 13879: @912810
     /*  912810 */   GIM_Try, /*On fail goto*//*Label 13880*/ GIMT_Encode4(912888), // Rule ID 62309 //
     /*  912815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  912818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  912826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  912829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  912832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  912847 */     // MIs[0] rs2
     /*  912847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912855 */     // MIs[0] policy
     /*  912855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11487:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  912865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M1),
     /*  912868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912886 */     GIR_RootConstrainSelectedInstOperands,
     /*  912887 */     // GIR_Coverage, 62309,
     /*  912887 */     GIR_EraseRootFromParent_Done,
     /*  912888 */   // Label 13880: @912888
     /*  912888 */   GIM_Try, /*On fail goto*//*Label 13881*/ GIMT_Encode4(912966), // Rule ID 62310 //
     /*  912893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  912896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  912913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912925 */     // MIs[0] rs2
     /*  912925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  912928 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  912933 */     // MIs[0] policy
     /*  912933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  912936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  912943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  912943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  912946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  912948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  912950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  912952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  912954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  912959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  912962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  912964 */     GIR_RootConstrainSelectedInstOperands,
     /*  912965 */     // GIR_Coverage, 62310,
     /*  912965 */     GIR_EraseRootFromParent_Done,
     /*  912966 */   // Label 13881: @912966
     /*  912966 */   GIM_Try, /*On fail goto*//*Label 13882*/ GIMT_Encode4(913044), // Rule ID 62311 //
     /*  912971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  912974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  912979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  912982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  912985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  912988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  912991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  912999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  913003 */     // MIs[0] rs2
     /*  913003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913006 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913011 */     // MIs[0] policy
     /*  913011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913021 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11487:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M2),
     /*  913024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913042 */     GIR_RootConstrainSelectedInstOperands,
     /*  913043 */     // GIR_Coverage, 62311,
     /*  913043 */     GIR_EraseRootFromParent_Done,
     /*  913044 */   // Label 13882: @913044
     /*  913044 */   GIM_Try, /*On fail goto*//*Label 13883*/ GIMT_Encode4(913122), // Rule ID 62312 //
     /*  913049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913081 */     // MIs[0] rs2
     /*  913081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913084 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913089 */     // MIs[0] policy
     /*  913089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913099 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913120 */     GIR_RootConstrainSelectedInstOperands,
     /*  913121 */     // GIR_Coverage, 62312,
     /*  913121 */     GIR_EraseRootFromParent_Done,
     /*  913122 */   // Label 13883: @913122
     /*  913122 */   GIM_Try, /*On fail goto*//*Label 13884*/ GIMT_Encode4(913200), // Rule ID 62313 //
     /*  913127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  913138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  913141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  913144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  913159 */     // MIs[0] rs2
     /*  913159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913167 */     // MIs[0] policy
     /*  913167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913177 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11487:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M4),
     /*  913180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913198 */     GIR_RootConstrainSelectedInstOperands,
     /*  913199 */     // GIR_Coverage, 62313,
     /*  913199 */     GIR_EraseRootFromParent_Done,
     /*  913200 */   // Label 13884: @913200
     /*  913200 */   GIM_Try, /*On fail goto*//*Label 13885*/ GIMT_Encode4(913278), // Rule ID 62314 //
     /*  913205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode0),
     /*  913208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913237 */     // MIs[0] rs2
     /*  913237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913245 */     // MIs[0] policy
     /*  913245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913255 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i64] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913276 */     GIR_RootConstrainSelectedInstOperands,
     /*  913277 */     // GIR_Coverage, 62314,
     /*  913277 */     GIR_EraseRootFromParent_Done,
     /*  913278 */   // Label 13885: @913278
     /*  913278 */   GIM_Try, /*On fail goto*//*Label 13886*/ GIMT_Encode4(913356), // Rule ID 62315 //
     /*  913283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvksh_HwMode1),
     /*  913286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsm3c),
     /*  913291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  913294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  913297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  913300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  913315 */     // MIs[0] rs2
     /*  913315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  913318 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tuimm5),
     /*  913323 */     // MIs[0] policy
     /*  913323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913333 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11487:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSM3C_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (timm:{ *:[i32] })<<P:Predicate_tuimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSM3C_VI_M8),
     /*  913336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /*  913338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  913344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  913352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913354 */     GIR_RootConstrainSelectedInstOperands,
     /*  913355 */     // GIR_Coverage, 62315,
     /*  913355 */     GIR_EraseRootFromParent_Done,
     /*  913356 */   // Label 13886: @913356
     /*  913356 */   GIM_Try, /*On fail goto*//*Label 13887*/ GIMT_Encode4(913444), // Rule ID 23580 //
     /*  913361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913408 */     // MIs[1] Operand 1
     /*  913408 */     // No operand predicates
     /*  913408 */     // MIs[0] policy
     /*  913408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  913423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913442 */     GIR_RootConstrainSelectedInstOperands,
     /*  913443 */     // GIR_Coverage, 23580,
     /*  913443 */     GIR_EraseRootFromParent_Done,
     /*  913444 */   // Label 13887: @913444
     /*  913444 */   GIM_Try, /*On fail goto*//*Label 13888*/ GIMT_Encode4(913532), // Rule ID 23581 //
     /*  913449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  913460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  913463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  913466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913496 */     // MIs[1] Operand 1
     /*  913496 */     // No operand predicates
     /*  913496 */     // MIs[0] policy
     /*  913496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913508 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8),
     /*  913511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913530 */     GIR_RootConstrainSelectedInstOperands,
     /*  913531 */     // GIR_Coverage, 23581,
     /*  913531 */     GIR_EraseRootFromParent_Done,
     /*  913532 */   // Label 13888: @913532
     /*  913532 */   GIM_Try, /*On fail goto*//*Label 13889*/ GIMT_Encode4(913620), // Rule ID 23584 //
     /*  913537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  913548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  913551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  913554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913584 */     // MIs[1] Operand 1
     /*  913584 */     // No operand predicates
     /*  913584 */     // MIs[0] policy
     /*  913584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  913599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913618 */     GIR_RootConstrainSelectedInstOperands,
     /*  913619 */     // GIR_Coverage, 23584,
     /*  913619 */     GIR_EraseRootFromParent_Done,
     /*  913620 */   // Label 13889: @913620
     /*  913620 */   GIM_Try, /*On fail goto*//*Label 13890*/ GIMT_Encode4(913708), // Rule ID 23585 //
     /*  913625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  913636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  913639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  913642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913672 */     // MIs[1] Operand 1
     /*  913672 */     // No operand predicates
     /*  913672 */     // MIs[0] policy
     /*  913672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  913687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913706 */     GIR_RootConstrainSelectedInstOperands,
     /*  913707 */     // GIR_Coverage, 23585,
     /*  913707 */     GIR_EraseRootFromParent_Done,
     /*  913708 */   // Label 13890: @913708
     /*  913708 */   GIM_Try, /*On fail goto*//*Label 13891*/ GIMT_Encode4(913796), // Rule ID 23588 //
     /*  913713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  913724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  913727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  913730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913760 */     // MIs[1] Operand 1
     /*  913760 */     // No operand predicates
     /*  913760 */     // MIs[0] policy
     /*  913760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913772 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  913775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913794 */     GIR_RootConstrainSelectedInstOperands,
     /*  913795 */     // GIR_Coverage, 23588,
     /*  913795 */     GIR_EraseRootFromParent_Done,
     /*  913796 */   // Label 13891: @913796
     /*  913796 */   GIM_Try, /*On fail goto*//*Label 13892*/ GIMT_Encode4(913884), // Rule ID 23589 //
     /*  913801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  913812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  913815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  913818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  913824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913848 */     // MIs[1] Operand 1
     /*  913848 */     // No operand predicates
     /*  913848 */     // MIs[0] policy
     /*  913848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  913860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  913863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  913880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913882 */     GIR_RootConstrainSelectedInstOperands,
     /*  913883 */     // GIR_Coverage, 23589,
     /*  913883 */     GIR_EraseRootFromParent_Done,
     /*  913884 */   // Label 13892: @913884
     /*  913884 */   GIM_Try, /*On fail goto*//*Label 13893*/ GIMT_Encode4(913972), // Rule ID 23592 //
     /*  913889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  913892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  913903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  913909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  913912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  913924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  913928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  913932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  913936 */     // MIs[1] Operand 1
     /*  913936 */     // No operand predicates
     /*  913936 */     // MIs[0] policy
     /*  913936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  913939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  913941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  913948 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  913948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  913951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  913953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  913955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  913957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  913960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  913965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  913968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  913970 */     GIR_RootConstrainSelectedInstOperands,
     /*  913971 */     // GIR_Coverage, 23592,
     /*  913971 */     GIR_EraseRootFromParent_Done,
     /*  913972 */   // Label 13893: @913972
     /*  913972 */   GIM_Try, /*On fail goto*//*Label 13894*/ GIMT_Encode4(914060), // Rule ID 23593 //
     /*  913977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  913980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  913985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  913988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  913991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  913994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  913997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914024 */     // MIs[1] Operand 1
     /*  914024 */     // No operand predicates
     /*  914024 */     // MIs[0] policy
     /*  914024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914036 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  914039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914058 */     GIR_RootConstrainSelectedInstOperands,
     /*  914059 */     // GIR_Coverage, 23593,
     /*  914059 */     GIR_EraseRootFromParent_Done,
     /*  914060 */   // Label 13894: @914060
     /*  914060 */   GIM_Try, /*On fail goto*//*Label 13895*/ GIMT_Encode4(914148), // Rule ID 23596 //
     /*  914065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914112 */     // MIs[1] Operand 1
     /*  914112 */     // No operand predicates
     /*  914112 */     // MIs[0] policy
     /*  914112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914124 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914146 */     GIR_RootConstrainSelectedInstOperands,
     /*  914147 */     // GIR_Coverage, 23596,
     /*  914147 */     GIR_EraseRootFromParent_Done,
     /*  914148 */   // Label 13895: @914148
     /*  914148 */   GIM_Try, /*On fail goto*//*Label 13896*/ GIMT_Encode4(914236), // Rule ID 23597 //
     /*  914153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  914164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  914167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  914170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914200 */     // MIs[1] Operand 1
     /*  914200 */     // No operand predicates
     /*  914200 */     // MIs[0] policy
     /*  914200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914234 */     GIR_RootConstrainSelectedInstOperands,
     /*  914235 */     // GIR_Coverage, 23597,
     /*  914235 */     GIR_EraseRootFromParent_Done,
     /*  914236 */   // Label 13896: @914236
     /*  914236 */   GIM_Try, /*On fail goto*//*Label 13897*/ GIMT_Encode4(914324), // Rule ID 23600 //
     /*  914241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914288 */     // MIs[1] Operand 1
     /*  914288 */     // No operand predicates
     /*  914288 */     // MIs[0] policy
     /*  914288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914300 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914322 */     GIR_RootConstrainSelectedInstOperands,
     /*  914323 */     // GIR_Coverage, 23600,
     /*  914323 */     GIR_EraseRootFromParent_Done,
     /*  914324 */   // Label 13897: @914324
     /*  914324 */   GIM_Try, /*On fail goto*//*Label 13898*/ GIMT_Encode4(914412), // Rule ID 23601 //
     /*  914329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  914340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  914343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  914346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914376 */     // MIs[1] Operand 1
     /*  914376 */     // No operand predicates
     /*  914376 */     // MIs[0] policy
     /*  914376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914388 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  914391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914410 */     GIR_RootConstrainSelectedInstOperands,
     /*  914411 */     // GIR_Coverage, 23601,
     /*  914411 */     GIR_EraseRootFromParent_Done,
     /*  914412 */   // Label 13898: @914412
     /*  914412 */   GIM_Try, /*On fail goto*//*Label 13899*/ GIMT_Encode4(914500), // Rule ID 23604 //
     /*  914417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  914434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914464 */     // MIs[1] Operand 1
     /*  914464 */     // No operand predicates
     /*  914464 */     // MIs[0] policy
     /*  914464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914476 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914498 */     GIR_RootConstrainSelectedInstOperands,
     /*  914499 */     // GIR_Coverage, 23604,
     /*  914499 */     GIR_EraseRootFromParent_Done,
     /*  914500 */   // Label 13899: @914500
     /*  914500 */   GIM_Try, /*On fail goto*//*Label 13900*/ GIMT_Encode4(914588), // Rule ID 23605 //
     /*  914505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  914516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  914519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  914522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914552 */     // MIs[1] Operand 1
     /*  914552 */     // No operand predicates
     /*  914552 */     // MIs[0] policy
     /*  914552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914564 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  914584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914586 */     GIR_RootConstrainSelectedInstOperands,
     /*  914587 */     // GIR_Coverage, 23605,
     /*  914587 */     GIR_EraseRootFromParent_Done,
     /*  914588 */   // Label 13900: @914588
     /*  914588 */   GIM_Try, /*On fail goto*//*Label 13901*/ GIMT_Encode4(914676), // Rule ID 23608 //
     /*  914593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  914607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914640 */     // MIs[1] Operand 1
     /*  914640 */     // No operand predicates
     /*  914640 */     // MIs[0] policy
     /*  914640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914674 */     GIR_RootConstrainSelectedInstOperands,
     /*  914675 */     // GIR_Coverage, 23608,
     /*  914675 */     GIR_EraseRootFromParent_Done,
     /*  914676 */   // Label 13901: @914676
     /*  914676 */   GIM_Try, /*On fail goto*//*Label 13902*/ GIMT_Encode4(914764), // Rule ID 23609 //
     /*  914681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  914692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  914695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  914698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914728 */     // MIs[1] Operand 1
     /*  914728 */     // No operand predicates
     /*  914728 */     // MIs[0] policy
     /*  914728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  914760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914762 */     GIR_RootConstrainSelectedInstOperands,
     /*  914763 */     // GIR_Coverage, 23609,
     /*  914763 */     GIR_EraseRootFromParent_Done,
     /*  914764 */   // Label 13902: @914764
     /*  914764 */   GIM_Try, /*On fail goto*//*Label 13903*/ GIMT_Encode4(914852), // Rule ID 23612 //
     /*  914769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  914772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  914783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914816 */     // MIs[1] Operand 1
     /*  914816 */     // No operand predicates
     /*  914816 */     // MIs[0] policy
     /*  914816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914828 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  914828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914850 */     GIR_RootConstrainSelectedInstOperands,
     /*  914851 */     // GIR_Coverage, 23612,
     /*  914851 */     GIR_EraseRootFromParent_Done,
     /*  914852 */   // Label 13903: @914852
     /*  914852 */   GIM_Try, /*On fail goto*//*Label 13904*/ GIMT_Encode4(914940), // Rule ID 23613 //
     /*  914857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  914860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  914868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  914871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  914874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  914877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  914880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914904 */     // MIs[1] Operand 1
     /*  914904 */     // No operand predicates
     /*  914904 */     // MIs[0] policy
     /*  914904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  914916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  914916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  914919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  914921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  914923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  914925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  914928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  914933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  914936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  914938 */     GIR_RootConstrainSelectedInstOperands,
     /*  914939 */     // GIR_Coverage, 23613,
     /*  914939 */     GIR_EraseRootFromParent_Done,
     /*  914940 */   // Label 13904: @914940
     /*  914940 */   GIM_Try, /*On fail goto*//*Label 13905*/ GIMT_Encode4(915028), // Rule ID 23616 //
     /*  914945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  914948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  914953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  914956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  914959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  914962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  914965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  914968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  914980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  914984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  914988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  914992 */     // MIs[1] Operand 1
     /*  914992 */     // No operand predicates
     /*  914992 */     // MIs[0] policy
     /*  914992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  914995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  914997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915026 */     GIR_RootConstrainSelectedInstOperands,
     /*  915027 */     // GIR_Coverage, 23616,
     /*  915027 */     GIR_EraseRootFromParent_Done,
     /*  915028 */   // Label 13905: @915028
     /*  915028 */   GIM_Try, /*On fail goto*//*Label 13906*/ GIMT_Encode4(915116), // Rule ID 23617 //
     /*  915033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  915036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  915044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  915047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  915050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  915068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915080 */     // MIs[1] Operand 1
     /*  915080 */     // No operand predicates
     /*  915080 */     // MIs[0] policy
     /*  915080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  915095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  915112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915114 */     GIR_RootConstrainSelectedInstOperands,
     /*  915115 */     // GIR_Coverage, 23617,
     /*  915115 */     GIR_EraseRootFromParent_Done,
     /*  915116 */   // Label 13906: @915116
     /*  915116 */   GIM_Try, /*On fail goto*//*Label 13907*/ GIMT_Encode4(915204), // Rule ID 23620 //
     /*  915121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915168 */     // MIs[1] Operand 1
     /*  915168 */     // No operand predicates
     /*  915168 */     // MIs[0] policy
     /*  915168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915202 */     GIR_RootConstrainSelectedInstOperands,
     /*  915203 */     // GIR_Coverage, 23620,
     /*  915203 */     GIR_EraseRootFromParent_Done,
     /*  915204 */   // Label 13907: @915204
     /*  915204 */   GIM_Try, /*On fail goto*//*Label 13908*/ GIMT_Encode4(915292), // Rule ID 23621 //
     /*  915209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  915220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  915223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  915226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915256 */     // MIs[1] Operand 1
     /*  915256 */     // No operand predicates
     /*  915256 */     // MIs[0] policy
     /*  915256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915290 */     GIR_RootConstrainSelectedInstOperands,
     /*  915291 */     // GIR_Coverage, 23621,
     /*  915291 */     GIR_EraseRootFromParent_Done,
     /*  915292 */   // Label 13908: @915292
     /*  915292 */   GIM_Try, /*On fail goto*//*Label 13909*/ GIMT_Encode4(915380), // Rule ID 23624 //
     /*  915297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915344 */     // MIs[1] Operand 1
     /*  915344 */     // No operand predicates
     /*  915344 */     // MIs[0] policy
     /*  915344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915356 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915378 */     GIR_RootConstrainSelectedInstOperands,
     /*  915379 */     // GIR_Coverage, 23624,
     /*  915379 */     GIR_EraseRootFromParent_Done,
     /*  915380 */   // Label 13909: @915380
     /*  915380 */   GIM_Try, /*On fail goto*//*Label 13910*/ GIMT_Encode4(915468), // Rule ID 23625 //
     /*  915385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  915396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  915399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  915402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915432 */     // MIs[1] Operand 1
     /*  915432 */     // No operand predicates
     /*  915432 */     // MIs[0] policy
     /*  915432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915444 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915466 */     GIR_RootConstrainSelectedInstOperands,
     /*  915467 */     // GIR_Coverage, 23625,
     /*  915467 */     GIR_EraseRootFromParent_Done,
     /*  915468 */   // Label 13910: @915468
     /*  915468 */   GIM_Try, /*On fail goto*//*Label 13911*/ GIMT_Encode4(915556), // Rule ID 23628 //
     /*  915473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  915484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  915487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  915490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915520 */     // MIs[1] Operand 1
     /*  915520 */     // No operand predicates
     /*  915520 */     // MIs[0] policy
     /*  915520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915532 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  915535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915554 */     GIR_RootConstrainSelectedInstOperands,
     /*  915555 */     // GIR_Coverage, 23628,
     /*  915555 */     GIR_EraseRootFromParent_Done,
     /*  915556 */   // Label 13911: @915556
     /*  915556 */   GIM_Try, /*On fail goto*//*Label 13912*/ GIMT_Encode4(915644), // Rule ID 23629 //
     /*  915561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  915572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  915575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  915578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  915596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915608 */     // MIs[1] Operand 1
     /*  915608 */     // No operand predicates
     /*  915608 */     // MIs[0] policy
     /*  915608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915620 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  915623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  915640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915642 */     GIR_RootConstrainSelectedInstOperands,
     /*  915643 */     // GIR_Coverage, 23629,
     /*  915643 */     GIR_EraseRootFromParent_Done,
     /*  915644 */   // Label 13912: @915644
     /*  915644 */   GIM_Try, /*On fail goto*//*Label 13913*/ GIMT_Encode4(915732), // Rule ID 23632 //
     /*  915649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  915660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  915663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  915666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915696 */     // MIs[1] Operand 1
     /*  915696 */     // No operand predicates
     /*  915696 */     // MIs[0] policy
     /*  915696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915730 */     GIR_RootConstrainSelectedInstOperands,
     /*  915731 */     // GIR_Coverage, 23632,
     /*  915731 */     GIR_EraseRootFromParent_Done,
     /*  915732 */   // Label 13913: @915732
     /*  915732 */   GIM_Try, /*On fail goto*//*Label 13914*/ GIMT_Encode4(915820), // Rule ID 23633 //
     /*  915737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  915748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  915751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  915754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  915772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915784 */     // MIs[1] Operand 1
     /*  915784 */     // No operand predicates
     /*  915784 */     // MIs[0] policy
     /*  915784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  915799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915818 */     GIR_RootConstrainSelectedInstOperands,
     /*  915819 */     // GIR_Coverage, 23633,
     /*  915819 */     GIR_EraseRootFromParent_Done,
     /*  915820 */   // Label 13914: @915820
     /*  915820 */   GIM_Try, /*On fail goto*//*Label 13915*/ GIMT_Encode4(915908), // Rule ID 23636 //
     /*  915825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  915828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  915836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  915839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  915842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  915845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  915848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915872 */     // MIs[1] Operand 1
     /*  915872 */     // No operand predicates
     /*  915872 */     // MIs[0] policy
     /*  915872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  915884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915906 */     GIR_RootConstrainSelectedInstOperands,
     /*  915907 */     // GIR_Coverage, 23636,
     /*  915907 */     GIR_EraseRootFromParent_Done,
     /*  915908 */   // Label 13915: @915908
     /*  915908 */   GIM_Try, /*On fail goto*//*Label 13916*/ GIMT_Encode4(915996), // Rule ID 23637 //
     /*  915913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  915916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  915921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  915924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  915927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  915930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  915933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  915936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  915948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  915952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  915956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  915960 */     // MIs[1] Operand 1
     /*  915960 */     // No operand predicates
     /*  915960 */     // MIs[0] policy
     /*  915960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  915963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  915965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  915972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  915972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  915975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  915977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  915979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  915981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  915984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  915989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  915992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  915994 */     GIR_RootConstrainSelectedInstOperands,
     /*  915995 */     // GIR_Coverage, 23637,
     /*  915995 */     GIR_EraseRootFromParent_Done,
     /*  915996 */   // Label 13916: @915996
     /*  915996 */   GIM_Try, /*On fail goto*//*Label 13917*/ GIMT_Encode4(916084), // Rule ID 23640 //
     /*  916001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916048 */     // MIs[1] Operand 1
     /*  916048 */     // No operand predicates
     /*  916048 */     // MIs[0] policy
     /*  916048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916082 */     GIR_RootConstrainSelectedInstOperands,
     /*  916083 */     // GIR_Coverage, 23640,
     /*  916083 */     GIR_EraseRootFromParent_Done,
     /*  916084 */   // Label 13917: @916084
     /*  916084 */   GIM_Try, /*On fail goto*//*Label 13918*/ GIMT_Encode4(916172), // Rule ID 23641 //
     /*  916089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  916100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  916103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  916106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916136 */     // MIs[1] Operand 1
     /*  916136 */     // No operand predicates
     /*  916136 */     // MIs[0] policy
     /*  916136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916148 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  916168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916170 */     GIR_RootConstrainSelectedInstOperands,
     /*  916171 */     // GIR_Coverage, 23641,
     /*  916171 */     GIR_EraseRootFromParent_Done,
     /*  916172 */   // Label 13918: @916172
     /*  916172 */   GIM_Try, /*On fail goto*//*Label 13919*/ GIMT_Encode4(916260), // Rule ID 23644 //
     /*  916177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916224 */     // MIs[1] Operand 1
     /*  916224 */     // No operand predicates
     /*  916224 */     // MIs[0] policy
     /*  916224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916258 */     GIR_RootConstrainSelectedInstOperands,
     /*  916259 */     // GIR_Coverage, 23644,
     /*  916259 */     GIR_EraseRootFromParent_Done,
     /*  916260 */   // Label 13919: @916260
     /*  916260 */   GIM_Try, /*On fail goto*//*Label 13920*/ GIMT_Encode4(916348), // Rule ID 23645 //
     /*  916265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  916276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  916279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  916282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916312 */     // MIs[1] Operand 1
     /*  916312 */     // No operand predicates
     /*  916312 */     // MIs[0] policy
     /*  916312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916346 */     GIR_RootConstrainSelectedInstOperands,
     /*  916347 */     // GIR_Coverage, 23645,
     /*  916347 */     GIR_EraseRootFromParent_Done,
     /*  916348 */   // Label 13920: @916348
     /*  916348 */   GIM_Try, /*On fail goto*//*Label 13921*/ GIMT_Encode4(916436), // Rule ID 23648 //
     /*  916353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916400 */     // MIs[1] Operand 1
     /*  916400 */     // No operand predicates
     /*  916400 */     // MIs[0] policy
     /*  916400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916434 */     GIR_RootConstrainSelectedInstOperands,
     /*  916435 */     // GIR_Coverage, 23648,
     /*  916435 */     GIR_EraseRootFromParent_Done,
     /*  916436 */   // Label 13921: @916436
     /*  916436 */   GIM_Try, /*On fail goto*//*Label 13922*/ GIMT_Encode4(916524), // Rule ID 23649 //
     /*  916441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  916452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  916455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  916458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916484 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916488 */     // MIs[1] Operand 1
     /*  916488 */     // No operand predicates
     /*  916488 */     // MIs[0] policy
     /*  916488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916500 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916522 */     GIR_RootConstrainSelectedInstOperands,
     /*  916523 */     // GIR_Coverage, 23649,
     /*  916523 */     GIR_EraseRootFromParent_Done,
     /*  916524 */   // Label 13922: @916524
     /*  916524 */   GIM_Try, /*On fail goto*//*Label 13923*/ GIMT_Encode4(916612), // Rule ID 23652 //
     /*  916529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  916532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916576 */     // MIs[1] Operand 1
     /*  916576 */     // No operand predicates
     /*  916576 */     // MIs[0] policy
     /*  916576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916610 */     GIR_RootConstrainSelectedInstOperands,
     /*  916611 */     // GIR_Coverage, 23652,
     /*  916611 */     GIR_EraseRootFromParent_Done,
     /*  916612 */   // Label 13923: @916612
     /*  916612 */   GIM_Try, /*On fail goto*//*Label 13924*/ GIMT_Encode4(916700), // Rule ID 23653 //
     /*  916617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  916620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  916628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  916631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  916634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  916652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916664 */     // MIs[1] Operand 1
     /*  916664 */     // No operand predicates
     /*  916664 */     // MIs[0] policy
     /*  916664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916676 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  916679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  916696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916698 */     GIR_RootConstrainSelectedInstOperands,
     /*  916699 */     // GIR_Coverage, 23653,
     /*  916699 */     GIR_EraseRootFromParent_Done,
     /*  916700 */   // Label 13924: @916700
     /*  916700 */   GIM_Try, /*On fail goto*//*Label 13925*/ GIMT_Encode4(916788), // Rule ID 23656 //
     /*  916705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  916708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  916716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  916719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  916722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916752 */     // MIs[1] Operand 1
     /*  916752 */     // No operand predicates
     /*  916752 */     // MIs[0] policy
     /*  916752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916764 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916786 */     GIR_RootConstrainSelectedInstOperands,
     /*  916787 */     // GIR_Coverage, 23656,
     /*  916787 */     GIR_EraseRootFromParent_Done,
     /*  916788 */   // Label 13925: @916788
     /*  916788 */   GIM_Try, /*On fail goto*//*Label 13926*/ GIMT_Encode4(916876), // Rule ID 23657 //
     /*  916793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  916804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  916807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  916810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  916828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916840 */     // MIs[1] Operand 1
     /*  916840 */     // No operand predicates
     /*  916840 */     // MIs[0] policy
     /*  916840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916852 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  916852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  916855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916874 */     GIR_RootConstrainSelectedInstOperands,
     /*  916875 */     // GIR_Coverage, 23657,
     /*  916875 */     GIR_EraseRootFromParent_Done,
     /*  916876 */   // Label 13926: @916876
     /*  916876 */   GIM_Try, /*On fail goto*//*Label 13927*/ GIMT_Encode4(916964), // Rule ID 23660 //
     /*  916881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  916884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  916892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  916895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  916898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  916901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  916904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  916920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  916924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  916928 */     // MIs[1] Operand 1
     /*  916928 */     // No operand predicates
     /*  916928 */     // MIs[0] policy
     /*  916928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  916931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  916933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  916940 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  916940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  916943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  916945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  916947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  916949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  916952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  916957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  916960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  916962 */     GIR_RootConstrainSelectedInstOperands,
     /*  916963 */     // GIR_Coverage, 23660,
     /*  916963 */     GIR_EraseRootFromParent_Done,
     /*  916964 */   // Label 13927: @916964
     /*  916964 */   GIM_Try, /*On fail goto*//*Label 13928*/ GIMT_Encode4(917052), // Rule ID 23661 //
     /*  916969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  916972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  916977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  916980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  916983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  916986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  916989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  916992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  916996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  917004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917016 */     // MIs[1] Operand 1
     /*  917016 */     // No operand predicates
     /*  917016 */     // MIs[0] policy
     /*  917016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  917031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917050 */     GIR_RootConstrainSelectedInstOperands,
     /*  917051 */     // GIR_Coverage, 23661,
     /*  917051 */     GIR_EraseRootFromParent_Done,
     /*  917052 */   // Label 13928: @917052
     /*  917052 */   GIM_Try, /*On fail goto*//*Label 13929*/ GIMT_Encode4(917140), // Rule ID 23664 //
     /*  917057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  917060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917104 */     // MIs[1] Operand 1
     /*  917104 */     // No operand predicates
     /*  917104 */     // MIs[0] policy
     /*  917104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917107 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917138 */     GIR_RootConstrainSelectedInstOperands,
     /*  917139 */     // GIR_Coverage, 23664,
     /*  917139 */     GIR_EraseRootFromParent_Done,
     /*  917140 */   // Label 13929: @917140
     /*  917140 */   GIM_Try, /*On fail goto*//*Label 13930*/ GIMT_Encode4(917228), // Rule ID 23665 //
     /*  917145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  917148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  917153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  917156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  917159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  917162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  917180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917192 */     // MIs[1] Operand 1
     /*  917192 */     // No operand predicates
     /*  917192 */     // MIs[0] policy
     /*  917192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917204 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  917207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  917224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917226 */     GIR_RootConstrainSelectedInstOperands,
     /*  917227 */     // GIR_Coverage, 23665,
     /*  917227 */     GIR_EraseRootFromParent_Done,
     /*  917228 */   // Label 13930: @917228
     /*  917228 */   GIM_Try, /*On fail goto*//*Label 13931*/ GIMT_Encode4(917316), // Rule ID 23756 //
     /*  917233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917276 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917280 */     // MIs[1] Operand 1
     /*  917280 */     // No operand predicates
     /*  917280 */     // MIs[0] policy
     /*  917280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917292 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917314 */     GIR_RootConstrainSelectedInstOperands,
     /*  917315 */     // GIR_Coverage, 23756,
     /*  917315 */     GIR_EraseRootFromParent_Done,
     /*  917316 */   // Label 13931: @917316
     /*  917316 */   GIM_Try, /*On fail goto*//*Label 13932*/ GIMT_Encode4(917404), // Rule ID 23757 //
     /*  917321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  917332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  917335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  917338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917364 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917368 */     // MIs[1] Operand 1
     /*  917368 */     // No operand predicates
     /*  917368 */     // MIs[0] policy
     /*  917368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8),
     /*  917383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917402 */     GIR_RootConstrainSelectedInstOperands,
     /*  917403 */     // GIR_Coverage, 23757,
     /*  917403 */     GIR_EraseRootFromParent_Done,
     /*  917404 */   // Label 13932: @917404
     /*  917404 */   GIM_Try, /*On fail goto*//*Label 13933*/ GIMT_Encode4(917492), // Rule ID 23760 //
     /*  917409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917456 */     // MIs[1] Operand 1
     /*  917456 */     // No operand predicates
     /*  917456 */     // MIs[0] policy
     /*  917456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917490 */     GIR_RootConstrainSelectedInstOperands,
     /*  917491 */     // GIR_Coverage, 23760,
     /*  917491 */     GIR_EraseRootFromParent_Done,
     /*  917492 */   // Label 13933: @917492
     /*  917492 */   GIM_Try, /*On fail goto*//*Label 13934*/ GIMT_Encode4(917580), // Rule ID 23761 //
     /*  917497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  917508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  917511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  917514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917544 */     // MIs[1] Operand 1
     /*  917544 */     // No operand predicates
     /*  917544 */     // MIs[0] policy
     /*  917544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917556 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917578 */     GIR_RootConstrainSelectedInstOperands,
     /*  917579 */     // GIR_Coverage, 23761,
     /*  917579 */     GIR_EraseRootFromParent_Done,
     /*  917580 */   // Label 13934: @917580
     /*  917580 */   GIM_Try, /*On fail goto*//*Label 13935*/ GIMT_Encode4(917668), // Rule ID 23764 //
     /*  917585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  917596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  917599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  917602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917632 */     // MIs[1] Operand 1
     /*  917632 */     // No operand predicates
     /*  917632 */     // MIs[0] policy
     /*  917632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917644 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  917647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917666 */     GIR_RootConstrainSelectedInstOperands,
     /*  917667 */     // GIR_Coverage, 23764,
     /*  917667 */     GIR_EraseRootFromParent_Done,
     /*  917668 */   // Label 13935: @917668
     /*  917668 */   GIM_Try, /*On fail goto*//*Label 13936*/ GIMT_Encode4(917756), // Rule ID 23765 //
     /*  917673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  917684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  917687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  917690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917720 */     // MIs[1] Operand 1
     /*  917720 */     // No operand predicates
     /*  917720 */     // MIs[0] policy
     /*  917720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917732 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  917735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  917752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917754 */     GIR_RootConstrainSelectedInstOperands,
     /*  917755 */     // GIR_Coverage, 23765,
     /*  917755 */     GIR_EraseRootFromParent_Done,
     /*  917756 */   // Label 13936: @917756
     /*  917756 */   GIM_Try, /*On fail goto*//*Label 13937*/ GIMT_Encode4(917844), // Rule ID 23768 //
     /*  917761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  917772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  917775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  917778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917808 */     // MIs[1] Operand 1
     /*  917808 */     // No operand predicates
     /*  917808 */     // MIs[0] policy
     /*  917808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917820 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917842 */     GIR_RootConstrainSelectedInstOperands,
     /*  917843 */     // GIR_Coverage, 23768,
     /*  917843 */     GIR_EraseRootFromParent_Done,
     /*  917844 */   // Label 13937: @917844
     /*  917844 */   GIM_Try, /*On fail goto*//*Label 13938*/ GIMT_Encode4(917932), // Rule ID 23769 //
     /*  917849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  917852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  917860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  917863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  917866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  917869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  917872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917896 */     // MIs[1] Operand 1
     /*  917896 */     // No operand predicates
     /*  917896 */     // MIs[0] policy
     /*  917896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  917908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  917911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  917913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  917915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  917917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  917920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  917925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  917928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  917930 */     GIR_RootConstrainSelectedInstOperands,
     /*  917931 */     // GIR_Coverage, 23769,
     /*  917931 */     GIR_EraseRootFromParent_Done,
     /*  917932 */   // Label 13938: @917932
     /*  917932 */   GIM_Try, /*On fail goto*//*Label 13939*/ GIMT_Encode4(918020), // Rule ID 23772 //
     /*  917937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  917940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  917945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  917948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  917951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  917954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  917957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  917960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  917972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  917976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  917980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  917984 */     // MIs[1] Operand 1
     /*  917984 */     // No operand predicates
     /*  917984 */     // MIs[0] policy
     /*  917984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  917987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  917989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  917996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  917996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  917999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918018 */     GIR_RootConstrainSelectedInstOperands,
     /*  918019 */     // GIR_Coverage, 23772,
     /*  918019 */     GIR_EraseRootFromParent_Done,
     /*  918020 */   // Label 13939: @918020
     /*  918020 */   GIM_Try, /*On fail goto*//*Label 13940*/ GIMT_Encode4(918108), // Rule ID 23773 //
     /*  918025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  918036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  918039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  918042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918072 */     // MIs[1] Operand 1
     /*  918072 */     // No operand predicates
     /*  918072 */     // MIs[0] policy
     /*  918072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918084 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918106 */     GIR_RootConstrainSelectedInstOperands,
     /*  918107 */     // GIR_Coverage, 23773,
     /*  918107 */     GIR_EraseRootFromParent_Done,
     /*  918108 */   // Label 13940: @918108
     /*  918108 */   GIM_Try, /*On fail goto*//*Label 13941*/ GIMT_Encode4(918196), // Rule ID 23776 //
     /*  918113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918160 */     // MIs[1] Operand 1
     /*  918160 */     // No operand predicates
     /*  918160 */     // MIs[0] policy
     /*  918160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918194 */     GIR_RootConstrainSelectedInstOperands,
     /*  918195 */     // GIR_Coverage, 23776,
     /*  918195 */     GIR_EraseRootFromParent_Done,
     /*  918196 */   // Label 13941: @918196
     /*  918196 */   GIM_Try, /*On fail goto*//*Label 13942*/ GIMT_Encode4(918284), // Rule ID 23777 //
     /*  918201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  918212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  918215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  918218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918248 */     // MIs[1] Operand 1
     /*  918248 */     // No operand predicates
     /*  918248 */     // MIs[0] policy
     /*  918248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  918263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918282 */     GIR_RootConstrainSelectedInstOperands,
     /*  918283 */     // GIR_Coverage, 23777,
     /*  918283 */     GIR_EraseRootFromParent_Done,
     /*  918284 */   // Label 13942: @918284
     /*  918284 */   GIM_Try, /*On fail goto*//*Label 13943*/ GIMT_Encode4(918372), // Rule ID 23780 //
     /*  918289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918336 */     // MIs[1] Operand 1
     /*  918336 */     // No operand predicates
     /*  918336 */     // MIs[0] policy
     /*  918336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918348 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918370 */     GIR_RootConstrainSelectedInstOperands,
     /*  918371 */     // GIR_Coverage, 23780,
     /*  918371 */     GIR_EraseRootFromParent_Done,
     /*  918372 */   // Label 13943: @918372
     /*  918372 */   GIM_Try, /*On fail goto*//*Label 13944*/ GIMT_Encode4(918460), // Rule ID 23781 //
     /*  918377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  918388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  918391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  918394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918424 */     // MIs[1] Operand 1
     /*  918424 */     // No operand predicates
     /*  918424 */     // MIs[0] policy
     /*  918424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  918456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918458 */     GIR_RootConstrainSelectedInstOperands,
     /*  918459 */     // GIR_Coverage, 23781,
     /*  918459 */     GIR_EraseRootFromParent_Done,
     /*  918460 */   // Label 13944: @918460
     /*  918460 */   GIM_Try, /*On fail goto*//*Label 13945*/ GIMT_Encode4(918548), // Rule ID 23784 //
     /*  918465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918512 */     // MIs[1] Operand 1
     /*  918512 */     // No operand predicates
     /*  918512 */     // MIs[0] policy
     /*  918512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918524 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918546 */     GIR_RootConstrainSelectedInstOperands,
     /*  918547 */     // GIR_Coverage, 23784,
     /*  918547 */     GIR_EraseRootFromParent_Done,
     /*  918548 */   // Label 13945: @918548
     /*  918548 */   GIM_Try, /*On fail goto*//*Label 13946*/ GIMT_Encode4(918636), // Rule ID 23785 //
     /*  918553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  918564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  918567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  918570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918600 */     // MIs[1] Operand 1
     /*  918600 */     // No operand predicates
     /*  918600 */     // MIs[0] policy
     /*  918600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918612 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  918632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918634 */     GIR_RootConstrainSelectedInstOperands,
     /*  918635 */     // GIR_Coverage, 23785,
     /*  918635 */     GIR_EraseRootFromParent_Done,
     /*  918636 */   // Label 13946: @918636
     /*  918636 */   GIM_Try, /*On fail goto*//*Label 13947*/ GIMT_Encode4(918724), // Rule ID 23788 //
     /*  918641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  918652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  918655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  918658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918688 */     // MIs[1] Operand 1
     /*  918688 */     // No operand predicates
     /*  918688 */     // MIs[0] policy
     /*  918688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918722 */     GIR_RootConstrainSelectedInstOperands,
     /*  918723 */     // GIR_Coverage, 23788,
     /*  918723 */     GIR_EraseRootFromParent_Done,
     /*  918724 */   // Label 13947: @918724
     /*  918724 */   GIM_Try, /*On fail goto*//*Label 13948*/ GIMT_Encode4(918812), // Rule ID 23789 //
     /*  918729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  918732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  918740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  918743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  918746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918776 */     // MIs[1] Operand 1
     /*  918776 */     // No operand predicates
     /*  918776 */     // MIs[0] policy
     /*  918776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918779 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918788 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  918808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918810 */     GIR_RootConstrainSelectedInstOperands,
     /*  918811 */     // GIR_Coverage, 23789,
     /*  918811 */     GIR_EraseRootFromParent_Done,
     /*  918812 */   // Label 13948: @918812
     /*  918812 */   GIM_Try, /*On fail goto*//*Label 13949*/ GIMT_Encode4(918900), // Rule ID 23792 //
     /*  918817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  918820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  918828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  918831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  918834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  918837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  918840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918864 */     // MIs[1] Operand 1
     /*  918864 */     // No operand predicates
     /*  918864 */     // MIs[0] policy
     /*  918864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918876 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  918876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918898 */     GIR_RootConstrainSelectedInstOperands,
     /*  918899 */     // GIR_Coverage, 23792,
     /*  918899 */     GIR_EraseRootFromParent_Done,
     /*  918900 */   // Label 13949: @918900
     /*  918900 */   GIM_Try, /*On fail goto*//*Label 13950*/ GIMT_Encode4(918988), // Rule ID 23793 //
     /*  918905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  918908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  918913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  918916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  918919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  918922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  918925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  918928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  918940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  918944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  918948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  918952 */     // MIs[1] Operand 1
     /*  918952 */     // No operand predicates
     /*  918952 */     // MIs[0] policy
     /*  918952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  918955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  918957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  918964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  918964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  918967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  918969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  918971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  918973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  918976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  918981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  918984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  918986 */     GIR_RootConstrainSelectedInstOperands,
     /*  918987 */     // GIR_Coverage, 23793,
     /*  918987 */     GIR_EraseRootFromParent_Done,
     /*  918988 */   // Label 13950: @918988
     /*  918988 */   GIM_Try, /*On fail goto*//*Label 13951*/ GIMT_Encode4(919076), // Rule ID 23796 //
     /*  918993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  918996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919040 */     // MIs[1] Operand 1
     /*  919040 */     // No operand predicates
     /*  919040 */     // MIs[0] policy
     /*  919040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919052 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919074 */     GIR_RootConstrainSelectedInstOperands,
     /*  919075 */     // GIR_Coverage, 23796,
     /*  919075 */     GIR_EraseRootFromParent_Done,
     /*  919076 */   // Label 13951: @919076
     /*  919076 */   GIM_Try, /*On fail goto*//*Label 13952*/ GIMT_Encode4(919164), // Rule ID 23797 //
     /*  919081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  919092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  919095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  919098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919128 */     // MIs[1] Operand 1
     /*  919128 */     // No operand predicates
     /*  919128 */     // MIs[0] policy
     /*  919128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919162 */     GIR_RootConstrainSelectedInstOperands,
     /*  919163 */     // GIR_Coverage, 23797,
     /*  919163 */     GIR_EraseRootFromParent_Done,
     /*  919164 */   // Label 13952: @919164
     /*  919164 */   GIM_Try, /*On fail goto*//*Label 13953*/ GIMT_Encode4(919252), // Rule ID 23800 //
     /*  919169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919216 */     // MIs[1] Operand 1
     /*  919216 */     // No operand predicates
     /*  919216 */     // MIs[0] policy
     /*  919216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919250 */     GIR_RootConstrainSelectedInstOperands,
     /*  919251 */     // GIR_Coverage, 23800,
     /*  919251 */     GIR_EraseRootFromParent_Done,
     /*  919252 */   // Label 13953: @919252
     /*  919252 */   GIM_Try, /*On fail goto*//*Label 13954*/ GIMT_Encode4(919340), // Rule ID 23801 //
     /*  919257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  919268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  919271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  919274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919304 */     // MIs[1] Operand 1
     /*  919304 */     // No operand predicates
     /*  919304 */     // MIs[0] policy
     /*  919304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919316 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919338 */     GIR_RootConstrainSelectedInstOperands,
     /*  919339 */     // GIR_Coverage, 23801,
     /*  919339 */     GIR_EraseRootFromParent_Done,
     /*  919340 */   // Label 13954: @919340
     /*  919340 */   GIM_Try, /*On fail goto*//*Label 13955*/ GIMT_Encode4(919428), // Rule ID 23804 //
     /*  919345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919392 */     // MIs[1] Operand 1
     /*  919392 */     // No operand predicates
     /*  919392 */     // MIs[0] policy
     /*  919392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919404 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  919407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919426 */     GIR_RootConstrainSelectedInstOperands,
     /*  919427 */     // GIR_Coverage, 23804,
     /*  919427 */     GIR_EraseRootFromParent_Done,
     /*  919428 */   // Label 13955: @919428
     /*  919428 */   GIM_Try, /*On fail goto*//*Label 13956*/ GIMT_Encode4(919516), // Rule ID 23805 //
     /*  919433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  919444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  919447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  919450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919480 */     // MIs[1] Operand 1
     /*  919480 */     // No operand predicates
     /*  919480 */     // MIs[0] policy
     /*  919480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  919495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  919512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919514 */     GIR_RootConstrainSelectedInstOperands,
     /*  919515 */     // GIR_Coverage, 23805,
     /*  919515 */     GIR_EraseRootFromParent_Done,
     /*  919516 */   // Label 13956: @919516
     /*  919516 */   GIM_Try, /*On fail goto*//*Label 13957*/ GIMT_Encode4(919604), // Rule ID 23808 //
     /*  919521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  919532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  919535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  919538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919568 */     // MIs[1] Operand 1
     /*  919568 */     // No operand predicates
     /*  919568 */     // MIs[0] policy
     /*  919568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919602 */     GIR_RootConstrainSelectedInstOperands,
     /*  919603 */     // GIR_Coverage, 23808,
     /*  919603 */     GIR_EraseRootFromParent_Done,
     /*  919604 */   // Label 13957: @919604
     /*  919604 */   GIM_Try, /*On fail goto*//*Label 13958*/ GIMT_Encode4(919692), // Rule ID 23809 //
     /*  919609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  919620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  919623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  919626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  919644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919656 */     // MIs[1] Operand 1
     /*  919656 */     // No operand predicates
     /*  919656 */     // MIs[0] policy
     /*  919656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919668 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  919671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919677 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919690 */     GIR_RootConstrainSelectedInstOperands,
     /*  919691 */     // GIR_Coverage, 23809,
     /*  919691 */     GIR_EraseRootFromParent_Done,
     /*  919692 */   // Label 13958: @919692
     /*  919692 */   GIM_Try, /*On fail goto*//*Label 13959*/ GIMT_Encode4(919780), // Rule ID 23812 //
     /*  919697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  919708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  919711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  919714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919744 */     // MIs[1] Operand 1
     /*  919744 */     // No operand predicates
     /*  919744 */     // MIs[0] policy
     /*  919744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919778 */     GIR_RootConstrainSelectedInstOperands,
     /*  919779 */     // GIR_Coverage, 23812,
     /*  919779 */     GIR_EraseRootFromParent_Done,
     /*  919780 */   // Label 13959: @919780
     /*  919780 */   GIM_Try, /*On fail goto*//*Label 13960*/ GIMT_Encode4(919868), // Rule ID 23813 //
     /*  919785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  919796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  919799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  919802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  919820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919832 */     // MIs[1] Operand 1
     /*  919832 */     // No operand predicates
     /*  919832 */     // MIs[0] policy
     /*  919832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  919844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  919847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919866 */     GIR_RootConstrainSelectedInstOperands,
     /*  919867 */     // GIR_Coverage, 23813,
     /*  919867 */     GIR_EraseRootFromParent_Done,
     /*  919868 */   // Label 13960: @919868
     /*  919868 */   GIM_Try, /*On fail goto*//*Label 13961*/ GIMT_Encode4(919956), // Rule ID 23816 //
     /*  919873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  919876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  919884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  919887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  919890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  919893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  919896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  919912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  919916 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  919920 */     // MIs[1] Operand 1
     /*  919920 */     // No operand predicates
     /*  919920 */     // MIs[0] policy
     /*  919920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  919923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  919925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  919932 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  919932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  919935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  919937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  919939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  919941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  919944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  919949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  919952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  919954 */     GIR_RootConstrainSelectedInstOperands,
     /*  919955 */     // GIR_Coverage, 23816,
     /*  919955 */     GIR_EraseRootFromParent_Done,
     /*  919956 */   // Label 13961: @919956
     /*  919956 */   GIM_Try, /*On fail goto*//*Label 13962*/ GIMT_Encode4(920044), // Rule ID 23817 //
     /*  919961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  919964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  919969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  919972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  919975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  919978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  919981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  919984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  919996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920008 */     // MIs[1] Operand 1
     /*  920008 */     // No operand predicates
     /*  920008 */     // MIs[0] policy
     /*  920008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  920040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920042 */     GIR_RootConstrainSelectedInstOperands,
     /*  920043 */     // GIR_Coverage, 23817,
     /*  920043 */     GIR_EraseRootFromParent_Done,
     /*  920044 */   // Label 13962: @920044
     /*  920044 */   GIM_Try, /*On fail goto*//*Label 13963*/ GIMT_Encode4(920132), // Rule ID 23820 //
     /*  920049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920096 */     // MIs[1] Operand 1
     /*  920096 */     // No operand predicates
     /*  920096 */     // MIs[0] policy
     /*  920096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920130 */     GIR_RootConstrainSelectedInstOperands,
     /*  920131 */     // GIR_Coverage, 23820,
     /*  920131 */     GIR_EraseRootFromParent_Done,
     /*  920132 */   // Label 13963: @920132
     /*  920132 */   GIM_Try, /*On fail goto*//*Label 13964*/ GIMT_Encode4(920220), // Rule ID 23821 //
     /*  920137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  920148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  920151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  920154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920184 */     // MIs[1] Operand 1
     /*  920184 */     // No operand predicates
     /*  920184 */     // MIs[0] policy
     /*  920184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920218 */     GIR_RootConstrainSelectedInstOperands,
     /*  920219 */     // GIR_Coverage, 23821,
     /*  920219 */     GIR_EraseRootFromParent_Done,
     /*  920220 */   // Label 13964: @920220
     /*  920220 */   GIM_Try, /*On fail goto*//*Label 13965*/ GIMT_Encode4(920308), // Rule ID 23824 //
     /*  920225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920272 */     // MIs[1] Operand 1
     /*  920272 */     // No operand predicates
     /*  920272 */     // MIs[0] policy
     /*  920272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920284 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920306 */     GIR_RootConstrainSelectedInstOperands,
     /*  920307 */     // GIR_Coverage, 23824,
     /*  920307 */     GIR_EraseRootFromParent_Done,
     /*  920308 */   // Label 13965: @920308
     /*  920308 */   GIM_Try, /*On fail goto*//*Label 13966*/ GIMT_Encode4(920396), // Rule ID 23825 //
     /*  920313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  920324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  920327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  920330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920360 */     // MIs[1] Operand 1
     /*  920360 */     // No operand predicates
     /*  920360 */     // MIs[0] policy
     /*  920360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920394 */     GIR_RootConstrainSelectedInstOperands,
     /*  920395 */     // GIR_Coverage, 23825,
     /*  920395 */     GIR_EraseRootFromParent_Done,
     /*  920396 */   // Label 13966: @920396
     /*  920396 */   GIM_Try, /*On fail goto*//*Label 13967*/ GIMT_Encode4(920484), // Rule ID 23828 //
     /*  920401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  920404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920448 */     // MIs[1] Operand 1
     /*  920448 */     // No operand predicates
     /*  920448 */     // MIs[0] policy
     /*  920448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920460 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920482 */     GIR_RootConstrainSelectedInstOperands,
     /*  920483 */     // GIR_Coverage, 23828,
     /*  920483 */     GIR_EraseRootFromParent_Done,
     /*  920484 */   // Label 13967: @920484
     /*  920484 */   GIM_Try, /*On fail goto*//*Label 13968*/ GIMT_Encode4(920572), // Rule ID 23829 //
     /*  920489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  920492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  920500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  920503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  920506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920532 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920536 */     // MIs[1] Operand 1
     /*  920536 */     // No operand predicates
     /*  920536 */     // MIs[0] policy
     /*  920536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920548 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  920568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920570 */     GIR_RootConstrainSelectedInstOperands,
     /*  920571 */     // GIR_Coverage, 23829,
     /*  920571 */     GIR_EraseRootFromParent_Done,
     /*  920572 */   // Label 13968: @920572
     /*  920572 */   GIM_Try, /*On fail goto*//*Label 13969*/ GIMT_Encode4(920660), // Rule ID 23832 //
     /*  920577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  920580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  920588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  920591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  920594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920624 */     // MIs[1] Operand 1
     /*  920624 */     // No operand predicates
     /*  920624 */     // MIs[0] policy
     /*  920624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920636 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920658 */     GIR_RootConstrainSelectedInstOperands,
     /*  920659 */     // GIR_Coverage, 23832,
     /*  920659 */     GIR_EraseRootFromParent_Done,
     /*  920660 */   // Label 13969: @920660
     /*  920660 */   GIM_Try, /*On fail goto*//*Label 13970*/ GIMT_Encode4(920748), // Rule ID 23833 //
     /*  920665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  920668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  920676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  920679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  920682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  920700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920712 */     // MIs[1] Operand 1
     /*  920712 */     // No operand predicates
     /*  920712 */     // MIs[0] policy
     /*  920712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  920727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920746 */     GIR_RootConstrainSelectedInstOperands,
     /*  920747 */     // GIR_Coverage, 23833,
     /*  920747 */     GIR_EraseRootFromParent_Done,
     /*  920748 */   // Label 13970: @920748
     /*  920748 */   GIM_Try, /*On fail goto*//*Label 13971*/ GIMT_Encode4(920836), // Rule ID 23836 //
     /*  920753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  920756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  920764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  920767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  920770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920800 */     // MIs[1] Operand 1
     /*  920800 */     // No operand predicates
     /*  920800 */     // MIs[0] policy
     /*  920800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920812 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920834 */     GIR_RootConstrainSelectedInstOperands,
     /*  920835 */     // GIR_Coverage, 23836,
     /*  920835 */     GIR_EraseRootFromParent_Done,
     /*  920836 */   // Label 13971: @920836
     /*  920836 */   GIM_Try, /*On fail goto*//*Label 13972*/ GIMT_Encode4(920924), // Rule ID 23837 //
     /*  920841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  920844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  920852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  920855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  920858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  920861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  920864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  920876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920888 */     // MIs[1] Operand 1
     /*  920888 */     // No operand predicates
     /*  920888 */     // MIs[0] policy
     /*  920888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920900 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  920900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  920903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  920912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  920917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  920920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  920922 */     GIR_RootConstrainSelectedInstOperands,
     /*  920923 */     // GIR_Coverage, 23837,
     /*  920923 */     GIR_EraseRootFromParent_Done,
     /*  920924 */   // Label 13972: @920924
     /*  920924 */   GIM_Try, /*On fail goto*//*Label 13973*/ GIMT_Encode4(921012), // Rule ID 23840 //
     /*  920929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  920932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  920937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  920940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  920943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  920946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  920949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  920952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  920964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  920968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  920972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  920976 */     // MIs[1] Operand 1
     /*  920976 */     // No operand predicates
     /*  920976 */     // MIs[0] policy
     /*  920976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  920979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  920981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  920988 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  920988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  920991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  920993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  920995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  920997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921010 */     GIR_RootConstrainSelectedInstOperands,
     /*  921011 */     // GIR_Coverage, 23840,
     /*  921011 */     GIR_EraseRootFromParent_Done,
     /*  921012 */   // Label 13973: @921012
     /*  921012 */   GIM_Try, /*On fail goto*//*Label 13974*/ GIMT_Encode4(921100), // Rule ID 23841 //
     /*  921017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  921020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  921025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  921028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  921031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  921034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  921052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921064 */     // MIs[1] Operand 1
     /*  921064 */     // No operand predicates
     /*  921064 */     // MIs[0] policy
     /*  921064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921076 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  921079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  921096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921098 */     GIR_RootConstrainSelectedInstOperands,
     /*  921099 */     // GIR_Coverage, 23841,
     /*  921099 */     GIR_EraseRootFromParent_Done,
     /*  921100 */   // Label 13974: @921100
     /*  921100 */   GIM_Try, /*On fail goto*//*Label 13975*/ GIMT_Encode4(921188), // Rule ID 24080 //
     /*  921105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  921108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921152 */     // MIs[1] Operand 1
     /*  921152 */     // No operand predicates
     /*  921152 */     // MIs[0] policy
     /*  921152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921164 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921186 */     GIR_RootConstrainSelectedInstOperands,
     /*  921187 */     // GIR_Coverage, 24080,
     /*  921187 */     GIR_EraseRootFromParent_Done,
     /*  921188 */   // Label 13975: @921188
     /*  921188 */   GIM_Try, /*On fail goto*//*Label 13976*/ GIMT_Encode4(921276), // Rule ID 24081 //
     /*  921193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  921196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  921204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  921207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  921210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921240 */     // MIs[1] Operand 1
     /*  921240 */     // No operand predicates
     /*  921240 */     // MIs[0] policy
     /*  921240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921252 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4),
     /*  921255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921274 */     GIR_RootConstrainSelectedInstOperands,
     /*  921275 */     // GIR_Coverage, 24081,
     /*  921275 */     GIR_EraseRootFromParent_Done,
     /*  921276 */   // Label 13976: @921276
     /*  921276 */   GIM_Try, /*On fail goto*//*Label 13977*/ GIMT_Encode4(921364), // Rule ID 24084 //
     /*  921281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  921284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921328 */     // MIs[1] Operand 1
     /*  921328 */     // No operand predicates
     /*  921328 */     // MIs[0] policy
     /*  921328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921340 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921362 */     GIR_RootConstrainSelectedInstOperands,
     /*  921363 */     // GIR_Coverage, 24084,
     /*  921363 */     GIR_EraseRootFromParent_Done,
     /*  921364 */   // Label 13977: @921364
     /*  921364 */   GIM_Try, /*On fail goto*//*Label 13978*/ GIMT_Encode4(921452), // Rule ID 24085 //
     /*  921369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  921372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  921380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  921383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  921386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921412 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921416 */     // MIs[1] Operand 1
     /*  921416 */     // No operand predicates
     /*  921416 */     // MIs[0] policy
     /*  921416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921428 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921450 */     GIR_RootConstrainSelectedInstOperands,
     /*  921451 */     // GIR_Coverage, 24085,
     /*  921451 */     GIR_EraseRootFromParent_Done,
     /*  921452 */   // Label 13978: @921452
     /*  921452 */   GIM_Try, /*On fail goto*//*Label 13979*/ GIMT_Encode4(921540), // Rule ID 24088 //
     /*  921457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  921460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  921474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921500 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921504 */     // MIs[1] Operand 1
     /*  921504 */     // No operand predicates
     /*  921504 */     // MIs[0] policy
     /*  921504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921516 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921538 */     GIR_RootConstrainSelectedInstOperands,
     /*  921539 */     // GIR_Coverage, 24088,
     /*  921539 */     GIR_EraseRootFromParent_Done,
     /*  921540 */   // Label 13979: @921540
     /*  921540 */   GIM_Try, /*On fail goto*//*Label 13980*/ GIMT_Encode4(921628), // Rule ID 24089 //
     /*  921545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  921548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  921556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  921559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  921562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921592 */     // MIs[1] Operand 1
     /*  921592 */     // No operand predicates
     /*  921592 */     // MIs[0] policy
     /*  921592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2),
     /*  921607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921626 */     GIR_RootConstrainSelectedInstOperands,
     /*  921627 */     // GIR_Coverage, 24089,
     /*  921627 */     GIR_EraseRootFromParent_Done,
     /*  921628 */   // Label 13980: @921628
     /*  921628 */   GIM_Try, /*On fail goto*//*Label 13981*/ GIMT_Encode4(921716), // Rule ID 24092 //
     /*  921633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  921636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  921644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  921647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  921650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921680 */     // MIs[1] Operand 1
     /*  921680 */     // No operand predicates
     /*  921680 */     // MIs[0] policy
     /*  921680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  921695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921714 */     GIR_RootConstrainSelectedInstOperands,
     /*  921715 */     // GIR_Coverage, 24092,
     /*  921715 */     GIR_EraseRootFromParent_Done,
     /*  921716 */   // Label 13981: @921716
     /*  921716 */   GIM_Try, /*On fail goto*//*Label 13982*/ GIMT_Encode4(921804), // Rule ID 24093 //
     /*  921721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  921724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  921732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  921735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  921738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921768 */     // MIs[1] Operand 1
     /*  921768 */     // No operand predicates
     /*  921768 */     // MIs[0] policy
     /*  921768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921780 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  921783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  921800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921802 */     GIR_RootConstrainSelectedInstOperands,
     /*  921803 */     // GIR_Coverage, 24093,
     /*  921803 */     GIR_EraseRootFromParent_Done,
     /*  921804 */   // Label 13982: @921804
     /*  921804 */   GIM_Try, /*On fail goto*//*Label 13983*/ GIMT_Encode4(921892), // Rule ID 24096 //
     /*  921809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  921812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  921820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  921823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  921826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  921829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  921832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921856 */     // MIs[1] Operand 1
     /*  921856 */     // No operand predicates
     /*  921856 */     // MIs[0] policy
     /*  921856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921868 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  921868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  921871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921890 */     GIR_RootConstrainSelectedInstOperands,
     /*  921891 */     // GIR_Coverage, 24096,
     /*  921891 */     GIR_EraseRootFromParent_Done,
     /*  921892 */   // Label 13983: @921892
     /*  921892 */   GIM_Try, /*On fail goto*//*Label 13984*/ GIMT_Encode4(921980), // Rule ID 24097 //
     /*  921897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  921900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  921908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  921911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  921914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  921917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  921920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  921932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  921936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  921940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  921944 */     // MIs[1] Operand 1
     /*  921944 */     // No operand predicates
     /*  921944 */     // MIs[0] policy
     /*  921944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  921947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  921949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  921956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  921956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  921959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  921961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  921963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  921965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  921968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  921973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  921976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  921978 */     GIR_RootConstrainSelectedInstOperands,
     /*  921979 */     // GIR_Coverage, 24097,
     /*  921979 */     GIR_EraseRootFromParent_Done,
     /*  921980 */   // Label 13984: @921980
     /*  921980 */   GIM_Try, /*On fail goto*//*Label 13985*/ GIMT_Encode4(922068), // Rule ID 24100 //
     /*  921985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  921988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  921993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  921996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  921999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922032 */     // MIs[1] Operand 1
     /*  922032 */     // No operand predicates
     /*  922032 */     // MIs[0] policy
     /*  922032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922044 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922066 */     GIR_RootConstrainSelectedInstOperands,
     /*  922067 */     // GIR_Coverage, 24100,
     /*  922067 */     GIR_EraseRootFromParent_Done,
     /*  922068 */   // Label 13985: @922068
     /*  922068 */   GIM_Try, /*On fail goto*//*Label 13986*/ GIMT_Encode4(922156), // Rule ID 24101 //
     /*  922073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  922076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  922084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  922087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  922090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  922108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922120 */     // MIs[1] Operand 1
     /*  922120 */     // No operand predicates
     /*  922120 */     // MIs[0] policy
     /*  922120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1),
     /*  922135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  922152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922154 */     GIR_RootConstrainSelectedInstOperands,
     /*  922155 */     // GIR_Coverage, 24101,
     /*  922155 */     GIR_EraseRootFromParent_Done,
     /*  922156 */   // Label 13986: @922156
     /*  922156 */   GIM_Try, /*On fail goto*//*Label 13987*/ GIMT_Encode4(922244), // Rule ID 24104 //
     /*  922161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  922164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922204 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922208 */     // MIs[1] Operand 1
     /*  922208 */     // No operand predicates
     /*  922208 */     // MIs[0] policy
     /*  922208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922242 */     GIR_RootConstrainSelectedInstOperands,
     /*  922243 */     // GIR_Coverage, 24104,
     /*  922243 */     GIR_EraseRootFromParent_Done,
     /*  922244 */   // Label 13987: @922244
     /*  922244 */   GIM_Try, /*On fail goto*//*Label 13988*/ GIMT_Encode4(922332), // Rule ID 24105 //
     /*  922249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  922252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  922260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  922263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  922266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922292 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922296 */     // MIs[1] Operand 1
     /*  922296 */     // No operand predicates
     /*  922296 */     // MIs[0] policy
     /*  922296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922308 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922330 */     GIR_RootConstrainSelectedInstOperands,
     /*  922331 */     // GIR_Coverage, 24105,
     /*  922331 */     GIR_EraseRootFromParent_Done,
     /*  922332 */   // Label 13988: @922332
     /*  922332 */   GIM_Try, /*On fail goto*//*Label 13989*/ GIMT_Encode4(922420), // Rule ID 24108 //
     /*  922337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  922340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922380 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922384 */     // MIs[1] Operand 1
     /*  922384 */     // No operand predicates
     /*  922384 */     // MIs[0] policy
     /*  922384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922396 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922418 */     GIR_RootConstrainSelectedInstOperands,
     /*  922419 */     // GIR_Coverage, 24108,
     /*  922419 */     GIR_EraseRootFromParent_Done,
     /*  922420 */   // Label 13989: @922420
     /*  922420 */   GIM_Try, /*On fail goto*//*Label 13990*/ GIMT_Encode4(922508), // Rule ID 24109 //
     /*  922425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  922428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  922436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  922439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  922442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922472 */     // MIs[1] Operand 1
     /*  922472 */     // No operand predicates
     /*  922472 */     // MIs[0] policy
     /*  922472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922484 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922506 */     GIR_RootConstrainSelectedInstOperands,
     /*  922507 */     // GIR_Coverage, 24109,
     /*  922507 */     GIR_EraseRootFromParent_Done,
     /*  922508 */   // Label 13990: @922508
     /*  922508 */   GIM_Try, /*On fail goto*//*Label 13991*/ GIMT_Encode4(922596), // Rule ID 24112 //
     /*  922513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  922516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  922524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  922527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  922530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922560 */     // MIs[1] Operand 1
     /*  922560 */     // No operand predicates
     /*  922560 */     // MIs[0] policy
     /*  922560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922572 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  922575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922594 */     GIR_RootConstrainSelectedInstOperands,
     /*  922595 */     // GIR_Coverage, 24112,
     /*  922595 */     GIR_EraseRootFromParent_Done,
     /*  922596 */   // Label 13991: @922596
     /*  922596 */   GIM_Try, /*On fail goto*//*Label 13992*/ GIMT_Encode4(922684), // Rule ID 24113 //
     /*  922601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  922604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  922612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  922615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  922618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  922636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922648 */     // MIs[1] Operand 1
     /*  922648 */     // No operand predicates
     /*  922648 */     // MIs[0] policy
     /*  922648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  922663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  922680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922682 */     GIR_RootConstrainSelectedInstOperands,
     /*  922683 */     // GIR_Coverage, 24113,
     /*  922683 */     GIR_EraseRootFromParent_Done,
     /*  922684 */   // Label 13992: @922684
     /*  922684 */   GIM_Try, /*On fail goto*//*Label 13993*/ GIMT_Encode4(922772), // Rule ID 24116 //
     /*  922689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  922692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  922700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  922703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  922706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922736 */     // MIs[1] Operand 1
     /*  922736 */     // No operand predicates
     /*  922736 */     // MIs[0] policy
     /*  922736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922770 */     GIR_RootConstrainSelectedInstOperands,
     /*  922771 */     // GIR_Coverage, 24116,
     /*  922771 */     GIR_EraseRootFromParent_Done,
     /*  922772 */   // Label 13993: @922772
     /*  922772 */   GIM_Try, /*On fail goto*//*Label 13994*/ GIMT_Encode4(922860), // Rule ID 24117 //
     /*  922777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  922780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  922788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  922791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  922794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  922812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922824 */     // MIs[1] Operand 1
     /*  922824 */     // No operand predicates
     /*  922824 */     // MIs[0] policy
     /*  922824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922836 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  922836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  922839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922858 */     GIR_RootConstrainSelectedInstOperands,
     /*  922859 */     // GIR_Coverage, 24117,
     /*  922859 */     GIR_EraseRootFromParent_Done,
     /*  922860 */   // Label 13994: @922860
     /*  922860 */   GIM_Try, /*On fail goto*//*Label 13995*/ GIMT_Encode4(922948), // Rule ID 24120 //
     /*  922865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  922868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  922876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  922879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  922882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  922885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  922888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  922912 */     // MIs[1] Operand 1
     /*  922912 */     // No operand predicates
     /*  922912 */     // MIs[0] policy
     /*  922912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  922915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  922917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  922924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  922924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  922927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  922929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  922931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  922933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  922936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  922941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  922944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  922946 */     GIR_RootConstrainSelectedInstOperands,
     /*  922947 */     // GIR_Coverage, 24120,
     /*  922947 */     GIR_EraseRootFromParent_Done,
     /*  922948 */   // Label 13995: @922948
     /*  922948 */   GIM_Try, /*On fail goto*//*Label 13996*/ GIMT_Encode4(923036), // Rule ID 24121 //
     /*  922953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  922956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  922961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  922964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  922967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  922970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  922973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  922976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  922988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  922992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  922996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923000 */     // MIs[1] Operand 1
     /*  923000 */     // No operand predicates
     /*  923000 */     // MIs[0] policy
     /*  923000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923034 */     GIR_RootConstrainSelectedInstOperands,
     /*  923035 */     // GIR_Coverage, 24121,
     /*  923035 */     GIR_EraseRootFromParent_Done,
     /*  923036 */   // Label 13996: @923036
     /*  923036 */   GIM_Try, /*On fail goto*//*Label 13997*/ GIMT_Encode4(923124), // Rule ID 24124 //
     /*  923041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  923044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923088 */     // MIs[1] Operand 1
     /*  923088 */     // No operand predicates
     /*  923088 */     // MIs[0] policy
     /*  923088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923100 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923122 */     GIR_RootConstrainSelectedInstOperands,
     /*  923123 */     // GIR_Coverage, 24124,
     /*  923123 */     GIR_EraseRootFromParent_Done,
     /*  923124 */   // Label 13997: @923124
     /*  923124 */   GIM_Try, /*On fail goto*//*Label 13998*/ GIMT_Encode4(923212), // Rule ID 24125 //
     /*  923129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  923132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  923140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  923143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  923146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923172 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923176 */     // MIs[1] Operand 1
     /*  923176 */     // No operand predicates
     /*  923176 */     // MIs[0] policy
     /*  923176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923188 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  923208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923210 */     GIR_RootConstrainSelectedInstOperands,
     /*  923211 */     // GIR_Coverage, 24125,
     /*  923211 */     GIR_EraseRootFromParent_Done,
     /*  923212 */   // Label 13998: @923212
     /*  923212 */   GIM_Try, /*On fail goto*//*Label 13999*/ GIMT_Encode4(923300), // Rule ID 24128 //
     /*  923217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  923220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923260 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923264 */     // MIs[1] Operand 1
     /*  923264 */     // No operand predicates
     /*  923264 */     // MIs[0] policy
     /*  923264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923276 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923298 */     GIR_RootConstrainSelectedInstOperands,
     /*  923299 */     // GIR_Coverage, 24128,
     /*  923299 */     GIR_EraseRootFromParent_Done,
     /*  923300 */   // Label 13999: @923300
     /*  923300 */   GIM_Try, /*On fail goto*//*Label 14000*/ GIMT_Encode4(923388), // Rule ID 24129 //
     /*  923305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  923308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  923316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  923319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  923322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  923340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923352 */     // MIs[1] Operand 1
     /*  923352 */     // No operand predicates
     /*  923352 */     // MIs[0] policy
     /*  923352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2),
     /*  923367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923386 */     GIR_RootConstrainSelectedInstOperands,
     /*  923387 */     // GIR_Coverage, 24129,
     /*  923387 */     GIR_EraseRootFromParent_Done,
     /*  923388 */   // Label 14000: @923388
     /*  923388 */   GIM_Try, /*On fail goto*//*Label 14001*/ GIMT_Encode4(923476), // Rule ID 24132 //
     /*  923393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  923396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  923410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923440 */     // MIs[1] Operand 1
     /*  923440 */     // No operand predicates
     /*  923440 */     // MIs[0] policy
     /*  923440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923452 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923474 */     GIR_RootConstrainSelectedInstOperands,
     /*  923475 */     // GIR_Coverage, 24132,
     /*  923475 */     GIR_EraseRootFromParent_Done,
     /*  923476 */   // Label 14001: @923476
     /*  923476 */   GIM_Try, /*On fail goto*//*Label 14002*/ GIMT_Encode4(923564), // Rule ID 24133 //
     /*  923481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  923484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  923492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  923495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  923498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  923516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923528 */     // MIs[1] Operand 1
     /*  923528 */     // No operand predicates
     /*  923528 */     // MIs[0] policy
     /*  923528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923540 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4),
     /*  923543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923562 */     GIR_RootConstrainSelectedInstOperands,
     /*  923563 */     // GIR_Coverage, 24133,
     /*  923563 */     GIR_EraseRootFromParent_Done,
     /*  923564 */   // Label 14002: @923564
     /*  923564 */   GIM_Try, /*On fail goto*//*Label 14003*/ GIMT_Encode4(923652), // Rule ID 24136 //
     /*  923569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  923572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  923580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  923583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  923586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923616 */     // MIs[1] Operand 1
     /*  923616 */     // No operand predicates
     /*  923616 */     // MIs[0] policy
     /*  923616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923628 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923650 */     GIR_RootConstrainSelectedInstOperands,
     /*  923651 */     // GIR_Coverage, 24136,
     /*  923651 */     GIR_EraseRootFromParent_Done,
     /*  923652 */   // Label 14003: @923652
     /*  923652 */   GIM_Try, /*On fail goto*//*Label 14004*/ GIMT_Encode4(923740), // Rule ID 24137 //
     /*  923657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  923660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /*  923665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  923668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  923671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  923674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  923692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923704 */     // MIs[1] Operand 1
     /*  923704 */     // No operand predicates
     /*  923704 */     // MIs[0] policy
     /*  923704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923716 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8),
     /*  923719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  923736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923738 */     GIR_RootConstrainSelectedInstOperands,
     /*  923739 */     // GIR_Coverage, 24137,
     /*  923739 */     GIR_EraseRootFromParent_Done,
     /*  923740 */   // Label 14004: @923740
     /*  923740 */   GIM_Try, /*On fail goto*//*Label 14005*/ GIMT_Encode4(923828), // Rule ID 24200 //
     /*  923745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  923748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  923756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  923759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  923762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923792 */     // MIs[1] Operand 1
     /*  923792 */     // No operand predicates
     /*  923792 */     // MIs[0] policy
     /*  923792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923804 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  923807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923826 */     GIR_RootConstrainSelectedInstOperands,
     /*  923827 */     // GIR_Coverage, 24200,
     /*  923827 */     GIR_EraseRootFromParent_Done,
     /*  923828 */   // Label 14005: @923828
     /*  923828 */   GIM_Try, /*On fail goto*//*Label 14006*/ GIMT_Encode4(923916), // Rule ID 24201 //
     /*  923833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  923836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  923844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  923847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  923850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  923853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  923856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923880 */     // MIs[1] Operand 1
     /*  923880 */     // No operand predicates
     /*  923880 */     // MIs[0] policy
     /*  923880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923892 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  923892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4),
     /*  923895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  923912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  923914 */     GIR_RootConstrainSelectedInstOperands,
     /*  923915 */     // GIR_Coverage, 24201,
     /*  923915 */     GIR_EraseRootFromParent_Done,
     /*  923916 */   // Label 14006: @923916
     /*  923916 */   GIM_Try, /*On fail goto*//*Label 14007*/ GIMT_Encode4(924004), // Rule ID 24204 //
     /*  923921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  923924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  923929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  923932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  923935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  923938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  923941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  923944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  923956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  923960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  923964 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  923968 */     // MIs[1] Operand 1
     /*  923968 */     // No operand predicates
     /*  923968 */     // MIs[0] policy
     /*  923968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  923971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  923973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  923980 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  923980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  923983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  923985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  923987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  923989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  923992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  923997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924002 */     GIR_RootConstrainSelectedInstOperands,
     /*  924003 */     // GIR_Coverage, 24204,
     /*  924003 */     GIR_EraseRootFromParent_Done,
     /*  924004 */   // Label 14007: @924004
     /*  924004 */   GIM_Try, /*On fail goto*//*Label 14008*/ GIMT_Encode4(924092), // Rule ID 24205 //
     /*  924009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  924012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  924020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  924023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  924026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924052 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924056 */     // MIs[1] Operand 1
     /*  924056 */     // No operand predicates
     /*  924056 */     // MIs[0] policy
     /*  924056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924068 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924090 */     GIR_RootConstrainSelectedInstOperands,
     /*  924091 */     // GIR_Coverage, 24205,
     /*  924091 */     GIR_EraseRootFromParent_Done,
     /*  924092 */   // Label 14008: @924092
     /*  924092 */   GIM_Try, /*On fail goto*//*Label 14009*/ GIMT_Encode4(924180), // Rule ID 24208 //
     /*  924097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  924100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924140 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924144 */     // MIs[1] Operand 1
     /*  924144 */     // No operand predicates
     /*  924144 */     // MIs[0] policy
     /*  924144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924156 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924178 */     GIR_RootConstrainSelectedInstOperands,
     /*  924179 */     // GIR_Coverage, 24208,
     /*  924179 */     GIR_EraseRootFromParent_Done,
     /*  924180 */   // Label 14009: @924180
     /*  924180 */   GIM_Try, /*On fail goto*//*Label 14010*/ GIMT_Encode4(924268), // Rule ID 24209 //
     /*  924185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  924188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  924196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  924199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  924202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924232 */     // MIs[1] Operand 1
     /*  924232 */     // No operand predicates
     /*  924232 */     // MIs[0] policy
     /*  924232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2),
     /*  924247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924266 */     GIR_RootConstrainSelectedInstOperands,
     /*  924267 */     // GIR_Coverage, 24209,
     /*  924267 */     GIR_EraseRootFromParent_Done,
     /*  924268 */   // Label 14010: @924268
     /*  924268 */   GIM_Try, /*On fail goto*//*Label 14011*/ GIMT_Encode4(924356), // Rule ID 24212 //
     /*  924273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  924276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924320 */     // MIs[1] Operand 1
     /*  924320 */     // No operand predicates
     /*  924320 */     // MIs[0] policy
     /*  924320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924332 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924354 */     GIR_RootConstrainSelectedInstOperands,
     /*  924355 */     // GIR_Coverage, 24212,
     /*  924355 */     GIR_EraseRootFromParent_Done,
     /*  924356 */   // Label 14011: @924356
     /*  924356 */   GIM_Try, /*On fail goto*//*Label 14012*/ GIMT_Encode4(924444), // Rule ID 24213 //
     /*  924361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  924364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  924372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  924375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  924378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924408 */     // MIs[1] Operand 1
     /*  924408 */     // No operand predicates
     /*  924408 */     // MIs[0] policy
     /*  924408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924420 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924442 */     GIR_RootConstrainSelectedInstOperands,
     /*  924443 */     // GIR_Coverage, 24213,
     /*  924443 */     GIR_EraseRootFromParent_Done,
     /*  924444 */   // Label 14012: @924444
     /*  924444 */   GIM_Try, /*On fail goto*//*Label 14013*/ GIMT_Encode4(924532), // Rule ID 24216 //
     /*  924449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  924452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  924460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  924463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  924466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924496 */     // MIs[1] Operand 1
     /*  924496 */     // No operand predicates
     /*  924496 */     // MIs[0] policy
     /*  924496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924508 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924530 */     GIR_RootConstrainSelectedInstOperands,
     /*  924531 */     // GIR_Coverage, 24216,
     /*  924531 */     GIR_EraseRootFromParent_Done,
     /*  924532 */   // Label 14013: @924532
     /*  924532 */   GIM_Try, /*On fail goto*//*Label 14014*/ GIMT_Encode4(924620), // Rule ID 24217 //
     /*  924537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  924540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  924548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  924551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  924554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924584 */     // MIs[1] Operand 1
     /*  924584 */     // No operand predicates
     /*  924584 */     // MIs[0] policy
     /*  924584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924596 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  924616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924618 */     GIR_RootConstrainSelectedInstOperands,
     /*  924619 */     // GIR_Coverage, 24217,
     /*  924619 */     GIR_EraseRootFromParent_Done,
     /*  924620 */   // Label 14014: @924620
     /*  924620 */   GIM_Try, /*On fail goto*//*Label 14015*/ GIMT_Encode4(924708), // Rule ID 24220 //
     /*  924625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  924628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  924636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  924639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  924642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924672 */     // MIs[1] Operand 1
     /*  924672 */     // No operand predicates
     /*  924672 */     // MIs[0] policy
     /*  924672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924684 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924706 */     GIR_RootConstrainSelectedInstOperands,
     /*  924707 */     // GIR_Coverage, 24220,
     /*  924707 */     GIR_EraseRootFromParent_Done,
     /*  924708 */   // Label 14015: @924708
     /*  924708 */   GIM_Try, /*On fail goto*//*Label 14016*/ GIMT_Encode4(924796), // Rule ID 24221 //
     /*  924713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  924716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  924724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  924727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  924730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  924748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924756 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924760 */     // MIs[1] Operand 1
     /*  924760 */     // No operand predicates
     /*  924760 */     // MIs[0] policy
     /*  924760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924772 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1),
     /*  924775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  924792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924794 */     GIR_RootConstrainSelectedInstOperands,
     /*  924795 */     // GIR_Coverage, 24221,
     /*  924795 */     GIR_EraseRootFromParent_Done,
     /*  924796 */   // Label 14016: @924796
     /*  924796 */   GIM_Try, /*On fail goto*//*Label 14017*/ GIMT_Encode4(924884), // Rule ID 24224 //
     /*  924801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  924804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  924812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  924815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  924818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  924824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924844 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924848 */     // MIs[1] Operand 1
     /*  924848 */     // No operand predicates
     /*  924848 */     // MIs[0] policy
     /*  924848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924860 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  924860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924882 */     GIR_RootConstrainSelectedInstOperands,
     /*  924883 */     // GIR_Coverage, 24224,
     /*  924883 */     GIR_EraseRootFromParent_Done,
     /*  924884 */   // Label 14017: @924884
     /*  924884 */   GIM_Try, /*On fail goto*//*Label 14018*/ GIMT_Encode4(924972), // Rule ID 24225 //
     /*  924889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  924892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  924900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  924903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  924906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  924909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  924912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  924924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  924928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  924932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  924936 */     // MIs[1] Operand 1
     /*  924936 */     // No operand predicates
     /*  924936 */     // MIs[0] policy
     /*  924936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  924939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  924941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  924948 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  924948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  924951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  924953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  924955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  924957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  924960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  924965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  924968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  924970 */     GIR_RootConstrainSelectedInstOperands,
     /*  924971 */     // GIR_Coverage, 24225,
     /*  924971 */     GIR_EraseRootFromParent_Done,
     /*  924972 */   // Label 14018: @924972
     /*  924972 */   GIM_Try, /*On fail goto*//*Label 14019*/ GIMT_Encode4(925060), // Rule ID 24228 //
     /*  924977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  924980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  924985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  924988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  924991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  924994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  924997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925020 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925024 */     // MIs[1] Operand 1
     /*  925024 */     // No operand predicates
     /*  925024 */     // MIs[0] policy
     /*  925024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925036 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925058 */     GIR_RootConstrainSelectedInstOperands,
     /*  925059 */     // GIR_Coverage, 24228,
     /*  925059 */     GIR_EraseRootFromParent_Done,
     /*  925060 */   // Label 14019: @925060
     /*  925060 */   GIM_Try, /*On fail goto*//*Label 14020*/ GIMT_Encode4(925148), // Rule ID 24229 //
     /*  925065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  925076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  925079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  925082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925112 */     // MIs[1] Operand 1
     /*  925112 */     // No operand predicates
     /*  925112 */     // MIs[0] policy
     /*  925112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925124 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925146 */     GIR_RootConstrainSelectedInstOperands,
     /*  925147 */     // GIR_Coverage, 24229,
     /*  925147 */     GIR_EraseRootFromParent_Done,
     /*  925148 */   // Label 14020: @925148
     /*  925148 */   GIM_Try, /*On fail goto*//*Label 14021*/ GIMT_Encode4(925236), // Rule ID 24232 //
     /*  925153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  925156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925200 */     // MIs[1] Operand 1
     /*  925200 */     // No operand predicates
     /*  925200 */     // MIs[0] policy
     /*  925200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925212 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925234 */     GIR_RootConstrainSelectedInstOperands,
     /*  925235 */     // GIR_Coverage, 24232,
     /*  925235 */     GIR_EraseRootFromParent_Done,
     /*  925236 */   // Label 14021: @925236
     /*  925236 */   GIM_Try, /*On fail goto*//*Label 14022*/ GIMT_Encode4(925324), // Rule ID 24233 //
     /*  925241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  925244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  925252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  925255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  925258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925288 */     // MIs[1] Operand 1
     /*  925288 */     // No operand predicates
     /*  925288 */     // MIs[0] policy
     /*  925288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925300 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  925320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925322 */     GIR_RootConstrainSelectedInstOperands,
     /*  925323 */     // GIR_Coverage, 24233,
     /*  925323 */     GIR_EraseRootFromParent_Done,
     /*  925324 */   // Label 14022: @925324
     /*  925324 */   GIM_Try, /*On fail goto*//*Label 14023*/ GIMT_Encode4(925412), // Rule ID 24236 //
     /*  925329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925376 */     // MIs[1] Operand 1
     /*  925376 */     // No operand predicates
     /*  925376 */     // MIs[0] policy
     /*  925376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925388 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925410 */     GIR_RootConstrainSelectedInstOperands,
     /*  925411 */     // GIR_Coverage, 24236,
     /*  925411 */     GIR_EraseRootFromParent_Done,
     /*  925412 */   // Label 14023: @925412
     /*  925412 */   GIM_Try, /*On fail goto*//*Label 14024*/ GIMT_Encode4(925500), // Rule ID 24237 //
     /*  925417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  925428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  925431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  925434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925464 */     // MIs[1] Operand 1
     /*  925464 */     // No operand predicates
     /*  925464 */     // MIs[0] policy
     /*  925464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925498 */     GIR_RootConstrainSelectedInstOperands,
     /*  925499 */     // GIR_Coverage, 24237,
     /*  925499 */     GIR_EraseRootFromParent_Done,
     /*  925500 */   // Label 14024: @925500
     /*  925500 */   GIM_Try, /*On fail goto*//*Label 14025*/ GIMT_Encode4(925588), // Rule ID 24240 //
     /*  925505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  925516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  925519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  925522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925552 */     // MIs[1] Operand 1
     /*  925552 */     // No operand predicates
     /*  925552 */     // MIs[0] policy
     /*  925552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925586 */     GIR_RootConstrainSelectedInstOperands,
     /*  925587 */     // GIR_Coverage, 24240,
     /*  925587 */     GIR_EraseRootFromParent_Done,
     /*  925588 */   // Label 14025: @925588
     /*  925588 */   GIM_Try, /*On fail goto*//*Label 14026*/ GIMT_Encode4(925676), // Rule ID 24241 //
     /*  925593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  925604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  925607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  925610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  925628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925636 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925640 */     // MIs[1] Operand 1
     /*  925640 */     // No operand predicates
     /*  925640 */     // MIs[0] policy
     /*  925640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925652 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  925655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925674 */     GIR_RootConstrainSelectedInstOperands,
     /*  925675 */     // GIR_Coverage, 24241,
     /*  925675 */     GIR_EraseRootFromParent_Done,
     /*  925676 */   // Label 14026: @925676
     /*  925676 */   GIM_Try, /*On fail goto*//*Label 14027*/ GIMT_Encode4(925764), // Rule ID 24244 //
     /*  925681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /*  925684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  925692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  925695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  925698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925728 */     // MIs[1] Operand 1
     /*  925728 */     // No operand predicates
     /*  925728 */     // MIs[0] policy
     /*  925728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925740 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925762 */     GIR_RootConstrainSelectedInstOperands,
     /*  925763 */     // GIR_Coverage, 24244,
     /*  925763 */     GIR_EraseRootFromParent_Done,
     /*  925764 */   // Label 14027: @925764
     /*  925764 */   GIM_Try, /*On fail goto*//*Label 14028*/ GIMT_Encode4(925852), // Rule ID 24245 //
     /*  925769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /*  925772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  925780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  925783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  925786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  925804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925816 */     // MIs[1] Operand 1
     /*  925816 */     // No operand predicates
     /*  925816 */     // MIs[0] policy
     /*  925816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925828 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  925828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  925831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  925848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925850 */     GIR_RootConstrainSelectedInstOperands,
     /*  925851 */     // GIR_Coverage, 24245,
     /*  925851 */     GIR_EraseRootFromParent_Done,
     /*  925852 */   // Label 14028: @925852
     /*  925852 */   GIM_Try, /*On fail goto*//*Label 14029*/ GIMT_Encode4(925940), // Rule ID 24248 //
     /*  925857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  925860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  925868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  925871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  925874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  925877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  925880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925904 */     // MIs[1] Operand 1
     /*  925904 */     // No operand predicates
     /*  925904 */     // MIs[0] policy
     /*  925904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  925916 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  925916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  925919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  925921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  925923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  925925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  925928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  925933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  925936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  925938 */     GIR_RootConstrainSelectedInstOperands,
     /*  925939 */     // GIR_Coverage, 24248,
     /*  925939 */     GIR_EraseRootFromParent_Done,
     /*  925940 */   // Label 14029: @925940
     /*  925940 */   GIM_Try, /*On fail goto*//*Label 14030*/ GIMT_Encode4(926028), // Rule ID 24249 //
     /*  925945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  925948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  925953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  925956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  925959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  925962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  925965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  925968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  925980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  925984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  925988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  925992 */     // MIs[1] Operand 1
     /*  925992 */     // No operand predicates
     /*  925992 */     // MIs[0] policy
     /*  925992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  925995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  925997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926004 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2),
     /*  926007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926026 */     GIR_RootConstrainSelectedInstOperands,
     /*  926027 */     // GIR_Coverage, 24249,
     /*  926027 */     GIR_EraseRootFromParent_Done,
     /*  926028 */   // Label 14030: @926028
     /*  926028 */   GIM_Try, /*On fail goto*//*Label 14031*/ GIMT_Encode4(926116), // Rule ID 24252 //
     /*  926033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926080 */     // MIs[1] Operand 1
     /*  926080 */     // No operand predicates
     /*  926080 */     // MIs[0] policy
     /*  926080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926092 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926114 */     GIR_RootConstrainSelectedInstOperands,
     /*  926115 */     // GIR_Coverage, 24252,
     /*  926115 */     GIR_EraseRootFromParent_Done,
     /*  926116 */   // Label 14031: @926116
     /*  926116 */   GIM_Try, /*On fail goto*//*Label 14032*/ GIMT_Encode4(926204), // Rule ID 24253 //
     /*  926121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  926132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  926135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  926138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  926156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926168 */     // MIs[1] Operand 1
     /*  926168 */     // No operand predicates
     /*  926168 */     // MIs[0] policy
     /*  926168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4),
     /*  926183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926202 */     GIR_RootConstrainSelectedInstOperands,
     /*  926203 */     // GIR_Coverage, 24253,
     /*  926203 */     GIR_EraseRootFromParent_Done,
     /*  926204 */   // Label 14032: @926204
     /*  926204 */   GIM_Try, /*On fail goto*//*Label 14033*/ GIMT_Encode4(926292), // Rule ID 24256 //
     /*  926209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /*  926212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  926232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926256 */     // MIs[1] Operand 1
     /*  926256 */     // No operand predicates
     /*  926256 */     // MIs[0] policy
     /*  926256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926268 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  926268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926290 */     GIR_RootConstrainSelectedInstOperands,
     /*  926291 */     // GIR_Coverage, 24256,
     /*  926291 */     GIR_EraseRootFromParent_Done,
     /*  926292 */   // Label 14033: @926292
     /*  926292 */   GIM_Try, /*On fail goto*//*Label 14034*/ GIMT_Encode4(926380), // Rule ID 24257 //
     /*  926297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /*  926300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /*  926305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  926308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  926311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  926314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  926320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  926332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926344 */     // MIs[1] Operand 1
     /*  926344 */     // No operand predicates
     /*  926344 */     // MIs[0] policy
     /*  926344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  926347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926356 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  926356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8),
     /*  926359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  926363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  926376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  926378 */     GIR_RootConstrainSelectedInstOperands,
     /*  926379 */     // GIR_Coverage, 24257,
     /*  926379 */     GIR_EraseRootFromParent_Done,
     /*  926380 */   // Label 14034: @926380
     /*  926380 */   GIM_Try, /*On fail goto*//*Label 14035*/ GIMT_Encode4(926471), // Rule ID 15868 //
     /*  926385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  926396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  926399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  926402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926432 */     // MIs[1] Operand 1
     /*  926432 */     // No operand predicates
     /*  926432 */     // MIs[0] round
     /*  926432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926444 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  926444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  926447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926456 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926469 */     GIR_RootConstrainSelectedInstOperands,
     /*  926470 */     // GIR_Coverage, 15868,
     /*  926470 */     GIR_EraseRootFromParent_Done,
     /*  926471 */   // Label 14035: @926471
     /*  926471 */   GIM_Try, /*On fail goto*//*Label 14036*/ GIMT_Encode4(926562), // Rule ID 15869 //
     /*  926476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  926487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  926490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  926493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  926499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926519 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926523 */     // MIs[1] Operand 1
     /*  926523 */     // No operand predicates
     /*  926523 */     // MIs[0] round
     /*  926523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926535 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  926535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8),
     /*  926538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926560 */     GIR_RootConstrainSelectedInstOperands,
     /*  926561 */     // GIR_Coverage, 15869,
     /*  926561 */     GIR_EraseRootFromParent_Done,
     /*  926562 */   // Label 14036: @926562
     /*  926562 */   GIM_Try, /*On fail goto*//*Label 14037*/ GIMT_Encode4(926653), // Rule ID 15872 //
     /*  926567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  926578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  926581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  926584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926614 */     // MIs[1] Operand 1
     /*  926614 */     // No operand predicates
     /*  926614 */     // MIs[0] round
     /*  926614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926626 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  926626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  926629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926651 */     GIR_RootConstrainSelectedInstOperands,
     /*  926652 */     // GIR_Coverage, 15872,
     /*  926652 */     GIR_EraseRootFromParent_Done,
     /*  926653 */   // Label 14037: @926653
     /*  926653 */   GIM_Try, /*On fail goto*//*Label 14038*/ GIMT_Encode4(926744), // Rule ID 15873 //
     /*  926658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  926669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  926672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  926675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  926681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926705 */     // MIs[1] Operand 1
     /*  926705 */     // No operand predicates
     /*  926705 */     // MIs[0] round
     /*  926705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926717 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  926717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  926720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926742 */     GIR_RootConstrainSelectedInstOperands,
     /*  926743 */     // GIR_Coverage, 15873,
     /*  926743 */     GIR_EraseRootFromParent_Done,
     /*  926744 */   // Label 14038: @926744
     /*  926744 */   GIM_Try, /*On fail goto*//*Label 14039*/ GIMT_Encode4(926835), // Rule ID 15876 //
     /*  926749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  926760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  926763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  926766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926796 */     // MIs[1] Operand 1
     /*  926796 */     // No operand predicates
     /*  926796 */     // MIs[0] round
     /*  926796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926808 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  926808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  926811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926820 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926833 */     GIR_RootConstrainSelectedInstOperands,
     /*  926834 */     // GIR_Coverage, 15876,
     /*  926834 */     GIR_EraseRootFromParent_Done,
     /*  926835 */   // Label 14039: @926835
     /*  926835 */   GIM_Try, /*On fail goto*//*Label 14040*/ GIMT_Encode4(926926), // Rule ID 15877 //
     /*  926840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  926843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  926851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  926854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  926857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  926860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  926863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926887 */     // MIs[1] Operand 1
     /*  926887 */     // No operand predicates
     /*  926887 */     // MIs[0] round
     /*  926887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926899 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  926899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  926902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  926911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  926913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  926918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  926921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  926924 */     GIR_RootConstrainSelectedInstOperands,
     /*  926925 */     // GIR_Coverage, 15877,
     /*  926925 */     GIR_EraseRootFromParent_Done,
     /*  926926 */   // Label 14040: @926926
     /*  926926 */   GIM_Try, /*On fail goto*//*Label 14041*/ GIMT_Encode4(927017), // Rule ID 15880 //
     /*  926931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  926934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  926939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  926942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  926945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  926948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  926951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  926954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  926966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  926970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  926974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  926978 */     // MIs[1] Operand 1
     /*  926978 */     // No operand predicates
     /*  926978 */     // MIs[0] round
     /*  926978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  926981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  926983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  926990 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  926990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  926993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  926995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  926997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  926999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927015 */     GIR_RootConstrainSelectedInstOperands,
     /*  927016 */     // GIR_Coverage, 15880,
     /*  927016 */     GIR_EraseRootFromParent_Done,
     /*  927017 */   // Label 14041: @927017
     /*  927017 */   GIM_Try, /*On fail goto*//*Label 14042*/ GIMT_Encode4(927108), // Rule ID 15881 //
     /*  927022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  927033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  927036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  927039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927069 */     // MIs[1] Operand 1
     /*  927069 */     // No operand predicates
     /*  927069 */     // MIs[0] round
     /*  927069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927081 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4),
     /*  927084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927106 */     GIR_RootConstrainSelectedInstOperands,
     /*  927107 */     // GIR_Coverage, 15881,
     /*  927107 */     GIR_EraseRootFromParent_Done,
     /*  927108 */   // Label 14042: @927108
     /*  927108 */   GIM_Try, /*On fail goto*//*Label 14043*/ GIMT_Encode4(927199), // Rule ID 15884 //
     /*  927113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927156 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927160 */     // MIs[1] Operand 1
     /*  927160 */     // No operand predicates
     /*  927160 */     // MIs[0] round
     /*  927160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927184 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927197 */     GIR_RootConstrainSelectedInstOperands,
     /*  927198 */     // GIR_Coverage, 15884,
     /*  927198 */     GIR_EraseRootFromParent_Done,
     /*  927199 */   // Label 14043: @927199
     /*  927199 */   GIM_Try, /*On fail goto*//*Label 14044*/ GIMT_Encode4(927290), // Rule ID 15885 //
     /*  927204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  927215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  927218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  927221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927251 */     // MIs[1] Operand 1
     /*  927251 */     // No operand predicates
     /*  927251 */     // MIs[0] round
     /*  927251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927263 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927288 */     GIR_RootConstrainSelectedInstOperands,
     /*  927289 */     // GIR_Coverage, 15885,
     /*  927289 */     GIR_EraseRootFromParent_Done,
     /*  927290 */   // Label 14044: @927290
     /*  927290 */   GIM_Try, /*On fail goto*//*Label 14045*/ GIMT_Encode4(927381), // Rule ID 15888 //
     /*  927295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927342 */     // MIs[1] Operand 1
     /*  927342 */     // No operand predicates
     /*  927342 */     // MIs[0] round
     /*  927342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927354 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  927354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927363 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927366 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927379 */     GIR_RootConstrainSelectedInstOperands,
     /*  927380 */     // GIR_Coverage, 15888,
     /*  927380 */     GIR_EraseRootFromParent_Done,
     /*  927381 */   // Label 14045: @927381
     /*  927381 */   GIM_Try, /*On fail goto*//*Label 14046*/ GIMT_Encode4(927472), // Rule ID 15889 //
     /*  927386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  927397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  927400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  927403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927433 */     // MIs[1] Operand 1
     /*  927433 */     // No operand predicates
     /*  927433 */     // MIs[0] round
     /*  927433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927445 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  927445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2),
     /*  927448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927470 */     GIR_RootConstrainSelectedInstOperands,
     /*  927471 */     // GIR_Coverage, 15889,
     /*  927471 */     GIR_EraseRootFromParent_Done,
     /*  927472 */   // Label 14046: @927472
     /*  927472 */   GIM_Try, /*On fail goto*//*Label 14047*/ GIMT_Encode4(927563), // Rule ID 15892 //
     /*  927477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  927488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  927491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  927494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927524 */     // MIs[1] Operand 1
     /*  927524 */     // No operand predicates
     /*  927524 */     // MIs[0] round
     /*  927524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  927536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927548 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927561 */     GIR_RootConstrainSelectedInstOperands,
     /*  927562 */     // GIR_Coverage, 15892,
     /*  927562 */     GIR_EraseRootFromParent_Done,
     /*  927563 */   // Label 14047: @927563
     /*  927563 */   GIM_Try, /*On fail goto*//*Label 14048*/ GIMT_Encode4(927654), // Rule ID 15893 //
     /*  927568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  927579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  927582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  927585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927611 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927615 */     // MIs[1] Operand 1
     /*  927615 */     // No operand predicates
     /*  927615 */     // MIs[0] round
     /*  927615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927627 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  927627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  927649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927652 */     GIR_RootConstrainSelectedInstOperands,
     /*  927653 */     // GIR_Coverage, 15893,
     /*  927653 */     GIR_EraseRootFromParent_Done,
     /*  927654 */   // Label 14048: @927654
     /*  927654 */   GIM_Try, /*On fail goto*//*Label 14049*/ GIMT_Encode4(927745), // Rule ID 15896 //
     /*  927659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  927670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  927673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  927676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927706 */     // MIs[1] Operand 1
     /*  927706 */     // No operand predicates
     /*  927706 */     // MIs[0] round
     /*  927706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927718 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  927718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927730 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927743 */     GIR_RootConstrainSelectedInstOperands,
     /*  927744 */     // GIR_Coverage, 15896,
     /*  927744 */     GIR_EraseRootFromParent_Done,
     /*  927745 */   // Label 14049: @927745
     /*  927745 */   GIM_Try, /*On fail goto*//*Label 14050*/ GIMT_Encode4(927836), // Rule ID 15897 //
     /*  927750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  927761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  927764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  927767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927797 */     // MIs[1] Operand 1
     /*  927797 */     // No operand predicates
     /*  927797 */     // MIs[0] round
     /*  927797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927809 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  927809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  927831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927834 */     GIR_RootConstrainSelectedInstOperands,
     /*  927835 */     // GIR_Coverage, 15897,
     /*  927835 */     GIR_EraseRootFromParent_Done,
     /*  927836 */   // Label 14050: @927836
     /*  927836 */   GIM_Try, /*On fail goto*//*Label 14051*/ GIMT_Encode4(927927), // Rule ID 15900 //
     /*  927841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  927844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  927852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  927855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  927858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  927861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  927864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927888 */     // MIs[1] Operand 1
     /*  927888 */     // No operand predicates
     /*  927888 */     // MIs[0] round
     /*  927888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  927900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  927909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  927912 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  927914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  927919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  927922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  927925 */     GIR_RootConstrainSelectedInstOperands,
     /*  927926 */     // GIR_Coverage, 15900,
     /*  927926 */     GIR_EraseRootFromParent_Done,
     /*  927927 */   // Label 14051: @927927
     /*  927927 */   GIM_Try, /*On fail goto*//*Label 14052*/ GIMT_Encode4(928018), // Rule ID 15901 //
     /*  927932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  927935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  927940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  927943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  927946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  927949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  927952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  927955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  927967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  927971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  927975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  927979 */     // MIs[1] Operand 1
     /*  927979 */     // No operand predicates
     /*  927979 */     // MIs[0] round
     /*  927979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  927982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  927984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  927991 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  927991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  927994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  927996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  927998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  928013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928016 */     GIR_RootConstrainSelectedInstOperands,
     /*  928017 */     // GIR_Coverage, 15901,
     /*  928017 */     GIR_EraseRootFromParent_Done,
     /*  928018 */   // Label 14052: @928018
     /*  928018 */   GIM_Try, /*On fail goto*//*Label 14053*/ GIMT_Encode4(928109), // Rule ID 15904 //
     /*  928023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  928026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928070 */     // MIs[1] Operand 1
     /*  928070 */     // No operand predicates
     /*  928070 */     // MIs[0] round
     /*  928070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928082 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  928082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928094 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928107 */     GIR_RootConstrainSelectedInstOperands,
     /*  928108 */     // GIR_Coverage, 15904,
     /*  928108 */     GIR_EraseRootFromParent_Done,
     /*  928109 */   // Label 14053: @928109
     /*  928109 */   GIM_Try, /*On fail goto*//*Label 14054*/ GIMT_Encode4(928200), // Rule ID 15905 //
     /*  928114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  928117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  928125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  928128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  928131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  928149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928161 */     // MIs[1] Operand 1
     /*  928161 */     // No operand predicates
     /*  928161 */     // MIs[0] round
     /*  928161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928173 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  928173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1),
     /*  928176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  928195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928198 */     GIR_RootConstrainSelectedInstOperands,
     /*  928199 */     // GIR_Coverage, 15905,
     /*  928199 */     GIR_EraseRootFromParent_Done,
     /*  928200 */   // Label 14054: @928200
     /*  928200 */   GIM_Try, /*On fail goto*//*Label 14055*/ GIMT_Encode4(928291), // Rule ID 15908 //
     /*  928205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928252 */     // MIs[1] Operand 1
     /*  928252 */     // No operand predicates
     /*  928252 */     // MIs[0] round
     /*  928252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928264 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928276 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928289 */     GIR_RootConstrainSelectedInstOperands,
     /*  928290 */     // GIR_Coverage, 15908,
     /*  928290 */     GIR_EraseRootFromParent_Done,
     /*  928291 */   // Label 14055: @928291
     /*  928291 */   GIM_Try, /*On fail goto*//*Label 14056*/ GIMT_Encode4(928382), // Rule ID 15909 //
     /*  928296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  928307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  928310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  928313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928343 */     // MIs[1] Operand 1
     /*  928343 */     // No operand predicates
     /*  928343 */     // MIs[0] round
     /*  928343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928355 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928380 */     GIR_RootConstrainSelectedInstOperands,
     /*  928381 */     // GIR_Coverage, 15909,
     /*  928381 */     GIR_EraseRootFromParent_Done,
     /*  928382 */   // Label 14056: @928382
     /*  928382 */   GIM_Try, /*On fail goto*//*Label 14057*/ GIMT_Encode4(928473), // Rule ID 15912 //
     /*  928387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  928404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928434 */     // MIs[1] Operand 1
     /*  928434 */     // No operand predicates
     /*  928434 */     // MIs[0] round
     /*  928434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928446 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  928449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928458 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928471 */     GIR_RootConstrainSelectedInstOperands,
     /*  928472 */     // GIR_Coverage, 15912,
     /*  928472 */     GIR_EraseRootFromParent_Done,
     /*  928473 */   // Label 14057: @928473
     /*  928473 */   GIM_Try, /*On fail goto*//*Label 14058*/ GIMT_Encode4(928564), // Rule ID 15913 //
     /*  928478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  928489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  928492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  928495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928525 */     // MIs[1] Operand 1
     /*  928525 */     // No operand predicates
     /*  928525 */     // MIs[0] round
     /*  928525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928537 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  928540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928562 */     GIR_RootConstrainSelectedInstOperands,
     /*  928563 */     // GIR_Coverage, 15913,
     /*  928563 */     GIR_EraseRootFromParent_Done,
     /*  928564 */   // Label 14058: @928564
     /*  928564 */   GIM_Try, /*On fail goto*//*Label 14059*/ GIMT_Encode4(928655), // Rule ID 15916 //
     /*  928569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  928580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  928583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  928586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928616 */     // MIs[1] Operand 1
     /*  928616 */     // No operand predicates
     /*  928616 */     // MIs[0] round
     /*  928616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928628 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  928628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  928631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928640 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928653 */     GIR_RootConstrainSelectedInstOperands,
     /*  928654 */     // GIR_Coverage, 15916,
     /*  928654 */     GIR_EraseRootFromParent_Done,
     /*  928655 */   // Label 14059: @928655
     /*  928655 */   GIM_Try, /*On fail goto*//*Label 14060*/ GIMT_Encode4(928746), // Rule ID 15917 //
     /*  928660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  928671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  928674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  928677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  928695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928707 */     // MIs[1] Operand 1
     /*  928707 */     // No operand predicates
     /*  928707 */     // MIs[0] round
     /*  928707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928710 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928719 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  928719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  928722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  928741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928744 */     GIR_RootConstrainSelectedInstOperands,
     /*  928745 */     // GIR_Coverage, 15917,
     /*  928745 */     GIR_EraseRootFromParent_Done,
     /*  928746 */   // Label 14060: @928746
     /*  928746 */   GIM_Try, /*On fail goto*//*Label 14061*/ GIMT_Encode4(928837), // Rule ID 15920 //
     /*  928751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  928762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  928765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  928768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928798 */     // MIs[1] Operand 1
     /*  928798 */     // No operand predicates
     /*  928798 */     // MIs[0] round
     /*  928798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928835 */     GIR_RootConstrainSelectedInstOperands,
     /*  928836 */     // GIR_Coverage, 15920,
     /*  928836 */     GIR_EraseRootFromParent_Done,
     /*  928837 */   // Label 14061: @928837
     /*  928837 */   GIM_Try, /*On fail goto*//*Label 14062*/ GIMT_Encode4(928928), // Rule ID 15921 //
     /*  928842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  928845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  928853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  928856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  928859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  928862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  928865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  928877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928889 */     // MIs[1] Operand 1
     /*  928889 */     // No operand predicates
     /*  928889 */     // MIs[0] round
     /*  928889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928901 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  928901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  928904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928906 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  928910 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  928913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  928915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  928920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  928923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  928926 */     GIR_RootConstrainSelectedInstOperands,
     /*  928927 */     // GIR_Coverage, 15921,
     /*  928927 */     GIR_EraseRootFromParent_Done,
     /*  928928 */   // Label 14062: @928928
     /*  928928 */   GIM_Try, /*On fail goto*//*Label 14063*/ GIMT_Encode4(929019), // Rule ID 15924 //
     /*  928933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  928936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  928941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  928944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  928947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  928950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  928953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  928956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  928968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  928972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  928976 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  928980 */     // MIs[1] Operand 1
     /*  928980 */     // No operand predicates
     /*  928980 */     // MIs[0] round
     /*  928980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  928983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  928985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  928992 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  928992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  928995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  928997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  928999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929004 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929017 */     GIR_RootConstrainSelectedInstOperands,
     /*  929018 */     // GIR_Coverage, 15924,
     /*  929018 */     GIR_EraseRootFromParent_Done,
     /*  929019 */   // Label 14063: @929019
     /*  929019 */   GIM_Try, /*On fail goto*//*Label 14064*/ GIMT_Encode4(929110), // Rule ID 15925 //
     /*  929024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  929035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  929038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  929041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929071 */     // MIs[1] Operand 1
     /*  929071 */     // No operand predicates
     /*  929071 */     // MIs[0] round
     /*  929071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929083 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929108 */     GIR_RootConstrainSelectedInstOperands,
     /*  929109 */     // GIR_Coverage, 15925,
     /*  929109 */     GIR_EraseRootFromParent_Done,
     /*  929110 */   // Label 14064: @929110
     /*  929110 */   GIM_Try, /*On fail goto*//*Label 14065*/ GIMT_Encode4(929201), // Rule ID 15928 //
     /*  929115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929162 */     // MIs[1] Operand 1
     /*  929162 */     // No operand predicates
     /*  929162 */     // MIs[0] round
     /*  929162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  929174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929186 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929199 */     GIR_RootConstrainSelectedInstOperands,
     /*  929200 */     // GIR_Coverage, 15928,
     /*  929200 */     GIR_EraseRootFromParent_Done,
     /*  929201 */   // Label 14065: @929201
     /*  929201 */   GIM_Try, /*On fail goto*//*Label 14066*/ GIMT_Encode4(929292), // Rule ID 15929 //
     /*  929206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  929217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  929220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  929223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929253 */     // MIs[1] Operand 1
     /*  929253 */     // No operand predicates
     /*  929253 */     // MIs[0] round
     /*  929253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929265 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  929265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  929287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929290 */     GIR_RootConstrainSelectedInstOperands,
     /*  929291 */     // GIR_Coverage, 15929,
     /*  929291 */     GIR_EraseRootFromParent_Done,
     /*  929292 */   // Label 14066: @929292
     /*  929292 */   GIM_Try, /*On fail goto*//*Label 14067*/ GIMT_Encode4(929383), // Rule ID 15932 //
     /*  929297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929344 */     // MIs[1] Operand 1
     /*  929344 */     // No operand predicates
     /*  929344 */     // MIs[0] round
     /*  929344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  929356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929368 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929381 */     GIR_RootConstrainSelectedInstOperands,
     /*  929382 */     // GIR_Coverage, 15932,
     /*  929382 */     GIR_EraseRootFromParent_Done,
     /*  929383 */   // Label 14067: @929383
     /*  929383 */   GIM_Try, /*On fail goto*//*Label 14068*/ GIMT_Encode4(929474), // Rule ID 15933 //
     /*  929388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  929399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  929402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  929405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929435 */     // MIs[1] Operand 1
     /*  929435 */     // No operand predicates
     /*  929435 */     // MIs[0] round
     /*  929435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  929447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929472 */     GIR_RootConstrainSelectedInstOperands,
     /*  929473 */     // GIR_Coverage, 15933,
     /*  929473 */     GIR_EraseRootFromParent_Done,
     /*  929474 */   // Label 14068: @929474
     /*  929474 */   GIM_Try, /*On fail goto*//*Label 14069*/ GIMT_Encode4(929565), // Rule ID 15936 //
     /*  929479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929526 */     // MIs[1] Operand 1
     /*  929526 */     // No operand predicates
     /*  929526 */     // MIs[0] round
     /*  929526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  929538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929550 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929563 */     GIR_RootConstrainSelectedInstOperands,
     /*  929564 */     // GIR_Coverage, 15936,
     /*  929564 */     GIR_EraseRootFromParent_Done,
     /*  929565 */   // Label 14069: @929565
     /*  929565 */   GIM_Try, /*On fail goto*//*Label 14070*/ GIMT_Encode4(929656), // Rule ID 15937 //
     /*  929570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  929581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  929584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  929587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  929605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929617 */     // MIs[1] Operand 1
     /*  929617 */     // No operand predicates
     /*  929617 */     // MIs[0] round
     /*  929617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929629 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  929629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  929632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929638 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929654 */     GIR_RootConstrainSelectedInstOperands,
     /*  929655 */     // GIR_Coverage, 15937,
     /*  929655 */     GIR_EraseRootFromParent_Done,
     /*  929656 */   // Label 14070: @929656
     /*  929656 */   GIM_Try, /*On fail goto*//*Label 14071*/ GIMT_Encode4(929747), // Rule ID 15940 //
     /*  929661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  929664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  929672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  929675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  929678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929708 */     // MIs[1] Operand 1
     /*  929708 */     // No operand predicates
     /*  929708 */     // MIs[0] round
     /*  929708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929720 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  929720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929745 */     GIR_RootConstrainSelectedInstOperands,
     /*  929746 */     // GIR_Coverage, 15940,
     /*  929746 */     GIR_EraseRootFromParent_Done,
     /*  929747 */   // Label 14071: @929747
     /*  929747 */   GIM_Try, /*On fail goto*//*Label 14072*/ GIMT_Encode4(929838), // Rule ID 15941 //
     /*  929752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  929755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  929763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  929766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  929769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  929787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929799 */     // MIs[1] Operand 1
     /*  929799 */     // No operand predicates
     /*  929799 */     // MIs[0] round
     /*  929799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929811 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  929811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  929814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  929833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929836 */     GIR_RootConstrainSelectedInstOperands,
     /*  929837 */     // GIR_Coverage, 15941,
     /*  929837 */     GIR_EraseRootFromParent_Done,
     /*  929838 */   // Label 14072: @929838
     /*  929838 */   GIM_Try, /*On fail goto*//*Label 14073*/ GIMT_Encode4(929929), // Rule ID 15944 //
     /*  929843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  929846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  929854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  929857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  929860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  929863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  929866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929890 */     // MIs[1] Operand 1
     /*  929890 */     // No operand predicates
     /*  929890 */     // MIs[0] round
     /*  929890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  929902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  929909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  929911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  929914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  929916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  929921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  929924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  929927 */     GIR_RootConstrainSelectedInstOperands,
     /*  929928 */     // GIR_Coverage, 15944,
     /*  929928 */     GIR_EraseRootFromParent_Done,
     /*  929929 */   // Label 14073: @929929
     /*  929929 */   GIM_Try, /*On fail goto*//*Label 14074*/ GIMT_Encode4(930020), // Rule ID 15945 //
     /*  929934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  929937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  929942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  929945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  929948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  929951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  929954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  929957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  929969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  929973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  929977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  929981 */     // MIs[1] Operand 1
     /*  929981 */     // No operand predicates
     /*  929981 */     // MIs[0] round
     /*  929981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  929984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  929986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  929993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  929993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2),
     /*  929996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  929998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930018 */     GIR_RootConstrainSelectedInstOperands,
     /*  930019 */     // GIR_Coverage, 15945,
     /*  930019 */     GIR_EraseRootFromParent_Done,
     /*  930020 */   // Label 14074: @930020
     /*  930020 */   GIM_Try, /*On fail goto*//*Label 14075*/ GIMT_Encode4(930111), // Rule ID 15948 //
     /*  930025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930072 */     // MIs[1] Operand 1
     /*  930072 */     // No operand predicates
     /*  930072 */     // MIs[0] round
     /*  930072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930084 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930109 */     GIR_RootConstrainSelectedInstOperands,
     /*  930110 */     // GIR_Coverage, 15948,
     /*  930110 */     GIR_EraseRootFromParent_Done,
     /*  930111 */   // Label 14075: @930111
     /*  930111 */   GIM_Try, /*On fail goto*//*Label 14076*/ GIMT_Encode4(930202), // Rule ID 15949 //
     /*  930116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  930127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  930130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  930133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  930151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930163 */     // MIs[1] Operand 1
     /*  930163 */     // No operand predicates
     /*  930163 */     // MIs[0] round
     /*  930163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930175 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4),
     /*  930178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930200 */     GIR_RootConstrainSelectedInstOperands,
     /*  930201 */     // GIR_Coverage, 15949,
     /*  930201 */     GIR_EraseRootFromParent_Done,
     /*  930202 */   // Label 14076: @930202
     /*  930202 */   GIM_Try, /*On fail goto*//*Label 14077*/ GIMT_Encode4(930293), // Rule ID 15952 //
     /*  930207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  930210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930254 */     // MIs[1] Operand 1
     /*  930254 */     // No operand predicates
     /*  930254 */     // MIs[0] round
     /*  930254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930266 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  930266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930291 */     GIR_RootConstrainSelectedInstOperands,
     /*  930292 */     // GIR_Coverage, 15952,
     /*  930292 */     GIR_EraseRootFromParent_Done,
     /*  930293 */   // Label 14077: @930293
     /*  930293 */   GIM_Try, /*On fail goto*//*Label 14078*/ GIMT_Encode4(930384), // Rule ID 15953 //
     /*  930298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  930301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /*  930306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  930309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  930312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  930315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  930333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930341 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930345 */     // MIs[1] Operand 1
     /*  930345 */     // No operand predicates
     /*  930345 */     // MIs[0] round
     /*  930345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930357 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  930357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8),
     /*  930360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  930379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930382 */     GIR_RootConstrainSelectedInstOperands,
     /*  930383 */     // GIR_Coverage, 15953,
     /*  930383 */     GIR_EraseRootFromParent_Done,
     /*  930384 */   // Label 14078: @930384
     /*  930384 */   GIM_Try, /*On fail goto*//*Label 14079*/ GIMT_Encode4(930475), // Rule ID 16132 //
     /*  930389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930436 */     // MIs[1] Operand 1
     /*  930436 */     // No operand predicates
     /*  930436 */     // MIs[0] round
     /*  930436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930448 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  930451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930473 */     GIR_RootConstrainSelectedInstOperands,
     /*  930474 */     // GIR_Coverage, 16132,
     /*  930474 */     GIR_EraseRootFromParent_Done,
     /*  930475 */   // Label 14079: @930475
     /*  930475 */   GIM_Try, /*On fail goto*//*Label 14080*/ GIMT_Encode4(930566), // Rule ID 16133 //
     /*  930480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  930491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  930494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  930497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930527 */     // MIs[1] Operand 1
     /*  930527 */     // No operand predicates
     /*  930527 */     // MIs[0] round
     /*  930527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930539 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  930539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8),
     /*  930542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930564 */     GIR_RootConstrainSelectedInstOperands,
     /*  930565 */     // GIR_Coverage, 16133,
     /*  930565 */     GIR_EraseRootFromParent_Done,
     /*  930566 */   // Label 14080: @930566
     /*  930566 */   GIM_Try, /*On fail goto*//*Label 14081*/ GIMT_Encode4(930657), // Rule ID 16136 //
     /*  930571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930618 */     // MIs[1] Operand 1
     /*  930618 */     // No operand predicates
     /*  930618 */     // MIs[0] round
     /*  930618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  930633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930642 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930655 */     GIR_RootConstrainSelectedInstOperands,
     /*  930656 */     // GIR_Coverage, 16136,
     /*  930656 */     GIR_EraseRootFromParent_Done,
     /*  930657 */   // Label 14081: @930657
     /*  930657 */   GIM_Try, /*On fail goto*//*Label 14082*/ GIMT_Encode4(930748), // Rule ID 16137 //
     /*  930662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  930673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  930676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  930679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930709 */     // MIs[1] Operand 1
     /*  930709 */     // No operand predicates
     /*  930709 */     // MIs[0] round
     /*  930709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930721 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  930721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  930724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930746 */     GIR_RootConstrainSelectedInstOperands,
     /*  930747 */     // GIR_Coverage, 16137,
     /*  930747 */     GIR_EraseRootFromParent_Done,
     /*  930748 */   // Label 14082: @930748
     /*  930748 */   GIM_Try, /*On fail goto*//*Label 14083*/ GIMT_Encode4(930839), // Rule ID 16140 //
     /*  930753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  930764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  930767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  930770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930800 */     // MIs[1] Operand 1
     /*  930800 */     // No operand predicates
     /*  930800 */     // MIs[0] round
     /*  930800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930812 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  930812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  930815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930824 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930837 */     GIR_RootConstrainSelectedInstOperands,
     /*  930838 */     // GIR_Coverage, 16140,
     /*  930838 */     GIR_EraseRootFromParent_Done,
     /*  930839 */   // Label 14083: @930839
     /*  930839 */   GIM_Try, /*On fail goto*//*Label 14084*/ GIMT_Encode4(930930), // Rule ID 16141 //
     /*  930844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  930847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  930855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  930858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  930861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  930864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  930867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930891 */     // MIs[1] Operand 1
     /*  930891 */     // No operand predicates
     /*  930891 */     // MIs[0] round
     /*  930891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930903 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  930903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  930906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  930910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  930912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  930915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  930917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  930922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  930925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  930928 */     GIR_RootConstrainSelectedInstOperands,
     /*  930929 */     // GIR_Coverage, 16141,
     /*  930929 */     GIR_EraseRootFromParent_Done,
     /*  930930 */   // Label 14084: @930930
     /*  930930 */   GIM_Try, /*On fail goto*//*Label 14085*/ GIMT_Encode4(931021), // Rule ID 16144 //
     /*  930935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  930938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  930943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  930946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  930949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  930952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  930955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  930958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  930970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  930974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  930978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  930982 */     // MIs[1] Operand 1
     /*  930982 */     // No operand predicates
     /*  930982 */     // MIs[0] round
     /*  930982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  930985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  930987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  930994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  930994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  930997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  930999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931006 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931019 */     GIR_RootConstrainSelectedInstOperands,
     /*  931020 */     // GIR_Coverage, 16144,
     /*  931020 */     GIR_EraseRootFromParent_Done,
     /*  931021 */   // Label 14085: @931021
     /*  931021 */   GIM_Try, /*On fail goto*//*Label 14086*/ GIMT_Encode4(931112), // Rule ID 16145 //
     /*  931026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  931037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  931040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  931043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931073 */     // MIs[1] Operand 1
     /*  931073 */     // No operand predicates
     /*  931073 */     // MIs[0] round
     /*  931073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4),
     /*  931088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931110 */     GIR_RootConstrainSelectedInstOperands,
     /*  931111 */     // GIR_Coverage, 16145,
     /*  931111 */     GIR_EraseRootFromParent_Done,
     /*  931112 */   // Label 14086: @931112
     /*  931112 */   GIM_Try, /*On fail goto*//*Label 14087*/ GIMT_Encode4(931203), // Rule ID 16148 //
     /*  931117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931164 */     // MIs[1] Operand 1
     /*  931164 */     // No operand predicates
     /*  931164 */     // MIs[0] round
     /*  931164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931167 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931188 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931201 */     GIR_RootConstrainSelectedInstOperands,
     /*  931202 */     // GIR_Coverage, 16148,
     /*  931202 */     GIR_EraseRootFromParent_Done,
     /*  931203 */   // Label 14087: @931203
     /*  931203 */   GIM_Try, /*On fail goto*//*Label 14088*/ GIMT_Encode4(931294), // Rule ID 16149 //
     /*  931208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  931219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  931222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  931225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931255 */     // MIs[1] Operand 1
     /*  931255 */     // No operand predicates
     /*  931255 */     // MIs[0] round
     /*  931255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931267 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931292 */     GIR_RootConstrainSelectedInstOperands,
     /*  931293 */     // GIR_Coverage, 16149,
     /*  931293 */     GIR_EraseRootFromParent_Done,
     /*  931294 */   // Label 14088: @931294
     /*  931294 */   GIM_Try, /*On fail goto*//*Label 14089*/ GIMT_Encode4(931385), // Rule ID 16152 //
     /*  931299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931346 */     // MIs[1] Operand 1
     /*  931346 */     // No operand predicates
     /*  931346 */     // MIs[0] round
     /*  931346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931358 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931370 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931383 */     GIR_RootConstrainSelectedInstOperands,
     /*  931384 */     // GIR_Coverage, 16152,
     /*  931384 */     GIR_EraseRootFromParent_Done,
     /*  931385 */   // Label 14089: @931385
     /*  931385 */   GIM_Try, /*On fail goto*//*Label 14090*/ GIMT_Encode4(931476), // Rule ID 16153 //
     /*  931390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  931401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  931404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  931407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931437 */     // MIs[1] Operand 1
     /*  931437 */     // No operand predicates
     /*  931437 */     // MIs[0] round
     /*  931437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931449 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2),
     /*  931452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931474 */     GIR_RootConstrainSelectedInstOperands,
     /*  931475 */     // GIR_Coverage, 16153,
     /*  931475 */     GIR_EraseRootFromParent_Done,
     /*  931476 */   // Label 14090: @931476
     /*  931476 */   GIM_Try, /*On fail goto*//*Label 14091*/ GIMT_Encode4(931567), // Rule ID 16156 //
     /*  931481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931528 */     // MIs[1] Operand 1
     /*  931528 */     // No operand predicates
     /*  931528 */     // MIs[0] round
     /*  931528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  931540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931552 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931565 */     GIR_RootConstrainSelectedInstOperands,
     /*  931566 */     // GIR_Coverage, 16156,
     /*  931566 */     GIR_EraseRootFromParent_Done,
     /*  931567 */   // Label 14091: @931567
     /*  931567 */   GIM_Try, /*On fail goto*//*Label 14092*/ GIMT_Encode4(931658), // Rule ID 16157 //
     /*  931572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  931583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  931586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  931589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931619 */     // MIs[1] Operand 1
     /*  931619 */     // No operand predicates
     /*  931619 */     // MIs[0] round
     /*  931619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931631 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  931631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931640 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  931653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931656 */     GIR_RootConstrainSelectedInstOperands,
     /*  931657 */     // GIR_Coverage, 16157,
     /*  931657 */     GIR_EraseRootFromParent_Done,
     /*  931658 */   // Label 14092: @931658
     /*  931658 */   GIM_Try, /*On fail goto*//*Label 14093*/ GIMT_Encode4(931749), // Rule ID 16160 //
     /*  931663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  931674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  931677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  931680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931706 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931710 */     // MIs[1] Operand 1
     /*  931710 */     // No operand predicates
     /*  931710 */     // MIs[0] round
     /*  931710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931722 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  931722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931734 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931747 */     GIR_RootConstrainSelectedInstOperands,
     /*  931748 */     // GIR_Coverage, 16160,
     /*  931748 */     GIR_EraseRootFromParent_Done,
     /*  931749 */   // Label 14093: @931749
     /*  931749 */   GIM_Try, /*On fail goto*//*Label 14094*/ GIMT_Encode4(931840), // Rule ID 16161 //
     /*  931754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  931765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  931768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  931771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931801 */     // MIs[1] Operand 1
     /*  931801 */     // No operand predicates
     /*  931801 */     // MIs[0] round
     /*  931801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931813 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  931813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  931835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931838 */     GIR_RootConstrainSelectedInstOperands,
     /*  931839 */     // GIR_Coverage, 16161,
     /*  931839 */     GIR_EraseRootFromParent_Done,
     /*  931840 */   // Label 14094: @931840
     /*  931840 */   GIM_Try, /*On fail goto*//*Label 14095*/ GIMT_Encode4(931931), // Rule ID 16164 //
     /*  931845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  931848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  931856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  931859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  931862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  931865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  931868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931892 */     // MIs[1] Operand 1
     /*  931892 */     // No operand predicates
     /*  931892 */     // MIs[0] round
     /*  931892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  931904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  931909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  931911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  931913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  931916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  931918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  931923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  931926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  931929 */     GIR_RootConstrainSelectedInstOperands,
     /*  931930 */     // GIR_Coverage, 16164,
     /*  931930 */     GIR_EraseRootFromParent_Done,
     /*  931931 */   // Label 14095: @931931
     /*  931931 */   GIM_Try, /*On fail goto*//*Label 14096*/ GIMT_Encode4(932022), // Rule ID 16165 //
     /*  931936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  931939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  931944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  931947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  931950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  931953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  931956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  931959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  931971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  931975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  931979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  931983 */     // MIs[1] Operand 1
     /*  931983 */     // No operand predicates
     /*  931983 */     // MIs[0] round
     /*  931983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  931986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  931988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  931995 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  931995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  931998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  932017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932020 */     GIR_RootConstrainSelectedInstOperands,
     /*  932021 */     // GIR_Coverage, 16165,
     /*  932021 */     GIR_EraseRootFromParent_Done,
     /*  932022 */   // Label 14096: @932022
     /*  932022 */   GIM_Try, /*On fail goto*//*Label 14097*/ GIMT_Encode4(932113), // Rule ID 16168 //
     /*  932027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  932030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932074 */     // MIs[1] Operand 1
     /*  932074 */     // No operand predicates
     /*  932074 */     // MIs[0] round
     /*  932074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932086 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  932086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932098 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932111 */     GIR_RootConstrainSelectedInstOperands,
     /*  932112 */     // GIR_Coverage, 16168,
     /*  932112 */     GIR_EraseRootFromParent_Done,
     /*  932113 */   // Label 14097: @932113
     /*  932113 */   GIM_Try, /*On fail goto*//*Label 14098*/ GIMT_Encode4(932204), // Rule ID 16169 //
     /*  932118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  932121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  932129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  932132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  932135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  932153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932161 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932165 */     // MIs[1] Operand 1
     /*  932165 */     // No operand predicates
     /*  932165 */     // MIs[0] round
     /*  932165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  932177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1),
     /*  932180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  932199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932202 */     GIR_RootConstrainSelectedInstOperands,
     /*  932203 */     // GIR_Coverage, 16169,
     /*  932203 */     GIR_EraseRootFromParent_Done,
     /*  932204 */   // Label 14098: @932204
     /*  932204 */   GIM_Try, /*On fail goto*//*Label 14099*/ GIMT_Encode4(932295), // Rule ID 16172 //
     /*  932209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932256 */     // MIs[1] Operand 1
     /*  932256 */     // No operand predicates
     /*  932256 */     // MIs[0] round
     /*  932256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932277 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932280 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932293 */     GIR_RootConstrainSelectedInstOperands,
     /*  932294 */     // GIR_Coverage, 16172,
     /*  932294 */     GIR_EraseRootFromParent_Done,
     /*  932295 */   // Label 14099: @932295
     /*  932295 */   GIM_Try, /*On fail goto*//*Label 14100*/ GIMT_Encode4(932386), // Rule ID 16173 //
     /*  932300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  932311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  932314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  932317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932347 */     // MIs[1] Operand 1
     /*  932347 */     // No operand predicates
     /*  932347 */     // MIs[0] round
     /*  932347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932384 */     GIR_RootConstrainSelectedInstOperands,
     /*  932385 */     // GIR_Coverage, 16173,
     /*  932385 */     GIR_EraseRootFromParent_Done,
     /*  932386 */   // Label 14100: @932386
     /*  932386 */   GIM_Try, /*On fail goto*//*Label 14101*/ GIMT_Encode4(932477), // Rule ID 16176 //
     /*  932391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932438 */     // MIs[1] Operand 1
     /*  932438 */     // No operand predicates
     /*  932438 */     // MIs[0] round
     /*  932438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932450 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  932453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932462 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932475 */     GIR_RootConstrainSelectedInstOperands,
     /*  932476 */     // GIR_Coverage, 16176,
     /*  932476 */     GIR_EraseRootFromParent_Done,
     /*  932477 */   // Label 14101: @932477
     /*  932477 */   GIM_Try, /*On fail goto*//*Label 14102*/ GIMT_Encode4(932568), // Rule ID 16177 //
     /*  932482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  932493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  932496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  932499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932529 */     // MIs[1] Operand 1
     /*  932529 */     // No operand predicates
     /*  932529 */     // MIs[0] round
     /*  932529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932541 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  932544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932566 */     GIR_RootConstrainSelectedInstOperands,
     /*  932567 */     // GIR_Coverage, 16177,
     /*  932567 */     GIR_EraseRootFromParent_Done,
     /*  932568 */   // Label 14102: @932568
     /*  932568 */   GIM_Try, /*On fail goto*//*Label 14103*/ GIMT_Encode4(932659), // Rule ID 16180 //
     /*  932573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932620 */     // MIs[1] Operand 1
     /*  932620 */     // No operand predicates
     /*  932620 */     // MIs[0] round
     /*  932620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932632 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  932632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  932635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932644 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932657 */     GIR_RootConstrainSelectedInstOperands,
     /*  932658 */     // GIR_Coverage, 16180,
     /*  932658 */     GIR_EraseRootFromParent_Done,
     /*  932659 */   // Label 14103: @932659
     /*  932659 */   GIM_Try, /*On fail goto*//*Label 14104*/ GIMT_Encode4(932750), // Rule ID 16181 //
     /*  932664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  932675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  932678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  932681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  932699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932711 */     // MIs[1] Operand 1
     /*  932711 */     // No operand predicates
     /*  932711 */     // MIs[0] round
     /*  932711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932723 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  932723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  932726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  932745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932748 */     GIR_RootConstrainSelectedInstOperands,
     /*  932749 */     // GIR_Coverage, 16181,
     /*  932749 */     GIR_EraseRootFromParent_Done,
     /*  932750 */   // Label 14104: @932750
     /*  932750 */   GIM_Try, /*On fail goto*//*Label 14105*/ GIMT_Encode4(932841), // Rule ID 16184 //
     /*  932755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  932766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  932769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  932772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932802 */     // MIs[1] Operand 1
     /*  932802 */     // No operand predicates
     /*  932802 */     // MIs[0] round
     /*  932802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932826 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932839 */     GIR_RootConstrainSelectedInstOperands,
     /*  932840 */     // GIR_Coverage, 16184,
     /*  932840 */     GIR_EraseRootFromParent_Done,
     /*  932841 */   // Label 14105: @932841
     /*  932841 */   GIM_Try, /*On fail goto*//*Label 14106*/ GIMT_Encode4(932932), // Rule ID 16185 //
     /*  932846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  932849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  932857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  932860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  932863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  932866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  932869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  932881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932893 */     // MIs[1] Operand 1
     /*  932893 */     // No operand predicates
     /*  932893 */     // MIs[0] round
     /*  932893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  932905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  932908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  932910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  932912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  932914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  932917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  932919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  932924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  932927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  932930 */     GIR_RootConstrainSelectedInstOperands,
     /*  932931 */     // GIR_Coverage, 16185,
     /*  932931 */     GIR_EraseRootFromParent_Done,
     /*  932932 */   // Label 14106: @932932
     /*  932932 */   GIM_Try, /*On fail goto*//*Label 14107*/ GIMT_Encode4(933023), // Rule ID 16188 //
     /*  932937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  932940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  932945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  932948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  932951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  932954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  932957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  932960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  932972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  932976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  932980 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  932984 */     // MIs[1] Operand 1
     /*  932984 */     // No operand predicates
     /*  932984 */     // MIs[0] round
     /*  932984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  932987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  932989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  932996 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  932996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  932999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933008 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933021 */     GIR_RootConstrainSelectedInstOperands,
     /*  933022 */     // GIR_Coverage, 16188,
     /*  933022 */     GIR_EraseRootFromParent_Done,
     /*  933023 */   // Label 14107: @933023
     /*  933023 */   GIM_Try, /*On fail goto*//*Label 14108*/ GIMT_Encode4(933114), // Rule ID 16189 //
     /*  933028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  933039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  933042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  933045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933075 */     // MIs[1] Operand 1
     /*  933075 */     // No operand predicates
     /*  933075 */     // MIs[0] round
     /*  933075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933112 */     GIR_RootConstrainSelectedInstOperands,
     /*  933113 */     // GIR_Coverage, 16189,
     /*  933113 */     GIR_EraseRootFromParent_Done,
     /*  933114 */   // Label 14108: @933114
     /*  933114 */   GIM_Try, /*On fail goto*//*Label 14109*/ GIMT_Encode4(933205), // Rule ID 16192 //
     /*  933119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933166 */     // MIs[1] Operand 1
     /*  933166 */     // No operand predicates
     /*  933166 */     // MIs[0] round
     /*  933166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  933178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933203 */     GIR_RootConstrainSelectedInstOperands,
     /*  933204 */     // GIR_Coverage, 16192,
     /*  933204 */     GIR_EraseRootFromParent_Done,
     /*  933205 */   // Label 14109: @933205
     /*  933205 */   GIM_Try, /*On fail goto*//*Label 14110*/ GIMT_Encode4(933296), // Rule ID 16193 //
     /*  933210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  933221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  933224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  933227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933257 */     // MIs[1] Operand 1
     /*  933257 */     // No operand predicates
     /*  933257 */     // MIs[0] round
     /*  933257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933269 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  933269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  933291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933294 */     GIR_RootConstrainSelectedInstOperands,
     /*  933295 */     // GIR_Coverage, 16193,
     /*  933295 */     GIR_EraseRootFromParent_Done,
     /*  933296 */   // Label 14110: @933296
     /*  933296 */   GIM_Try, /*On fail goto*//*Label 14111*/ GIMT_Encode4(933387), // Rule ID 16196 //
     /*  933301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933348 */     // MIs[1] Operand 1
     /*  933348 */     // No operand predicates
     /*  933348 */     // MIs[0] round
     /*  933348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933372 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933385 */     GIR_RootConstrainSelectedInstOperands,
     /*  933386 */     // GIR_Coverage, 16196,
     /*  933386 */     GIR_EraseRootFromParent_Done,
     /*  933387 */   // Label 14111: @933387
     /*  933387 */   GIM_Try, /*On fail goto*//*Label 14112*/ GIMT_Encode4(933478), // Rule ID 16197 //
     /*  933392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  933403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  933406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  933409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933439 */     // MIs[1] Operand 1
     /*  933439 */     // No operand predicates
     /*  933439 */     // MIs[0] round
     /*  933439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933442 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933451 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933476 */     GIR_RootConstrainSelectedInstOperands,
     /*  933477 */     // GIR_Coverage, 16197,
     /*  933477 */     GIR_EraseRootFromParent_Done,
     /*  933478 */   // Label 14112: @933478
     /*  933478 */   GIM_Try, /*On fail goto*//*Label 14113*/ GIMT_Encode4(933569), // Rule ID 16200 //
     /*  933483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933530 */     // MIs[1] Operand 1
     /*  933530 */     // No operand predicates
     /*  933530 */     // MIs[0] round
     /*  933530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933542 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933554 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933567 */     GIR_RootConstrainSelectedInstOperands,
     /*  933568 */     // GIR_Coverage, 16200,
     /*  933568 */     GIR_EraseRootFromParent_Done,
     /*  933569 */   // Label 14113: @933569
     /*  933569 */   GIM_Try, /*On fail goto*//*Label 14114*/ GIMT_Encode4(933660), // Rule ID 16201 //
     /*  933574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  933585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  933588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  933591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  933609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933621 */     // MIs[1] Operand 1
     /*  933621 */     // No operand predicates
     /*  933621 */     // MIs[0] round
     /*  933621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933633 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  933636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933658 */     GIR_RootConstrainSelectedInstOperands,
     /*  933659 */     // GIR_Coverage, 16201,
     /*  933659 */     GIR_EraseRootFromParent_Done,
     /*  933660 */   // Label 14114: @933660
     /*  933660 */   GIM_Try, /*On fail goto*//*Label 14115*/ GIMT_Encode4(933751), // Rule ID 16204 //
     /*  933665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  933668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  933676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  933679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  933682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933712 */     // MIs[1] Operand 1
     /*  933712 */     // No operand predicates
     /*  933712 */     // MIs[0] round
     /*  933712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  933724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933749 */     GIR_RootConstrainSelectedInstOperands,
     /*  933750 */     // GIR_Coverage, 16204,
     /*  933750 */     GIR_EraseRootFromParent_Done,
     /*  933751 */   // Label 14115: @933751
     /*  933751 */   GIM_Try, /*On fail goto*//*Label 14116*/ GIMT_Encode4(933842), // Rule ID 16205 //
     /*  933756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  933759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  933767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  933770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  933773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  933791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933803 */     // MIs[1] Operand 1
     /*  933803 */     // No operand predicates
     /*  933803 */     // MIs[0] round
     /*  933803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933815 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  933815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  933818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  933837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933840 */     GIR_RootConstrainSelectedInstOperands,
     /*  933841 */     // GIR_Coverage, 16205,
     /*  933841 */     GIR_EraseRootFromParent_Done,
     /*  933842 */   // Label 14116: @933842
     /*  933842 */   GIM_Try, /*On fail goto*//*Label 14117*/ GIMT_Encode4(933933), // Rule ID 16208 //
     /*  933847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  933850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  933858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  933861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  933864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  933867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  933870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933890 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933894 */     // MIs[1] Operand 1
     /*  933894 */     // No operand predicates
     /*  933894 */     // MIs[0] round
     /*  933894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933906 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  933906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  933909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  933911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  933913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  933915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  933918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  933920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  933925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  933928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  933931 */     GIR_RootConstrainSelectedInstOperands,
     /*  933932 */     // GIR_Coverage, 16208,
     /*  933932 */     GIR_EraseRootFromParent_Done,
     /*  933933 */   // Label 14117: @933933
     /*  933933 */   GIM_Try, /*On fail goto*//*Label 14118*/ GIMT_Encode4(934024), // Rule ID 16209 //
     /*  933938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  933941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  933946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  933949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  933952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  933955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  933958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  933961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  933973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  933977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  933981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  933985 */     // MIs[1] Operand 1
     /*  933985 */     // No operand predicates
     /*  933985 */     // MIs[0] round
     /*  933985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  933988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  933990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  933997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  933997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2),
     /*  934000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934022 */     GIR_RootConstrainSelectedInstOperands,
     /*  934023 */     // GIR_Coverage, 16209,
     /*  934023 */     GIR_EraseRootFromParent_Done,
     /*  934024 */   // Label 14118: @934024
     /*  934024 */   GIM_Try, /*On fail goto*//*Label 14119*/ GIMT_Encode4(934115), // Rule ID 16212 //
     /*  934029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934076 */     // MIs[1] Operand 1
     /*  934076 */     // No operand predicates
     /*  934076 */     // MIs[0] round
     /*  934076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934088 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934113 */     GIR_RootConstrainSelectedInstOperands,
     /*  934114 */     // GIR_Coverage, 16212,
     /*  934114 */     GIR_EraseRootFromParent_Done,
     /*  934115 */   // Label 14119: @934115
     /*  934115 */   GIM_Try, /*On fail goto*//*Label 14120*/ GIMT_Encode4(934206), // Rule ID 16213 //
     /*  934120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  934131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  934134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  934137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  934155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934167 */     // MIs[1] Operand 1
     /*  934167 */     // No operand predicates
     /*  934167 */     // MIs[0] round
     /*  934167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934179 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4),
     /*  934182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934204 */     GIR_RootConstrainSelectedInstOperands,
     /*  934205 */     // GIR_Coverage, 16213,
     /*  934205 */     GIR_EraseRootFromParent_Done,
     /*  934206 */   // Label 14120: @934206
     /*  934206 */   GIM_Try, /*On fail goto*//*Label 14121*/ GIMT_Encode4(934297), // Rule ID 16216 //
     /*  934211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  934214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934258 */     // MIs[1] Operand 1
     /*  934258 */     // No operand predicates
     /*  934258 */     // MIs[0] round
     /*  934258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /*  934270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934295 */     GIR_RootConstrainSelectedInstOperands,
     /*  934296 */     // GIR_Coverage, 16216,
     /*  934296 */     GIR_EraseRootFromParent_Done,
     /*  934297 */   // Label 14121: @934297
     /*  934297 */   GIM_Try, /*On fail goto*//*Label 14122*/ GIMT_Encode4(934388), // Rule ID 16217 //
     /*  934302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  934305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /*  934310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  934313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  934316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  934319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  934337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934345 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934349 */     // MIs[1] Operand 1
     /*  934349 */     // No operand predicates
     /*  934349 */     // MIs[0] round
     /*  934349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934361 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VI_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /*  934361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8),
     /*  934364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  934383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934386 */     GIR_RootConstrainSelectedInstOperands,
     /*  934387 */     // GIR_Coverage, 16217,
     /*  934387 */     GIR_EraseRootFromParent_Done,
     /*  934388 */   // Label 14122: @934388
     /*  934388 */   GIM_Try, /*On fail goto*//*Label 14123*/ GIMT_Encode4(934482), // Rule ID 16340 //
     /*  934393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  934410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934440 */     // MIs[1] Operand 1
     /*  934440 */     // No operand predicates
     /*  934440 */     // MIs[0] round
     /*  934440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934452 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  934455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934480 */     GIR_RootConstrainSelectedInstOperands,
     /*  934481 */     // GIR_Coverage, 16340,
     /*  934481 */     GIR_EraseRootFromParent_Done,
     /*  934482 */   // Label 14123: @934482
     /*  934482 */   GIM_Try, /*On fail goto*//*Label 14124*/ GIMT_Encode4(934576), // Rule ID 16341 //
     /*  934487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  934498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  934501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  934504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934534 */     // MIs[1] Operand 1
     /*  934534 */     // No operand predicates
     /*  934534 */     // MIs[0] round
     /*  934534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  934546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8),
     /*  934549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934558 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934574 */     GIR_RootConstrainSelectedInstOperands,
     /*  934575 */     // GIR_Coverage, 16341,
     /*  934575 */     GIR_EraseRootFromParent_Done,
     /*  934576 */   // Label 14124: @934576
     /*  934576 */   GIM_Try, /*On fail goto*//*Label 14125*/ GIMT_Encode4(934670), // Rule ID 16344 //
     /*  934581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  934598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934628 */     // MIs[1] Operand 1
     /*  934628 */     // No operand predicates
     /*  934628 */     // MIs[0] round
     /*  934628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934640 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  934643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934652 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934668 */     GIR_RootConstrainSelectedInstOperands,
     /*  934669 */     // GIR_Coverage, 16344,
     /*  934669 */     GIR_EraseRootFromParent_Done,
     /*  934670 */   // Label 14125: @934670
     /*  934670 */   GIM_Try, /*On fail goto*//*Label 14126*/ GIMT_Encode4(934764), // Rule ID 16345 //
     /*  934675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  934686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  934689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  934692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934722 */     // MIs[1] Operand 1
     /*  934722 */     // No operand predicates
     /*  934722 */     // MIs[0] round
     /*  934722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934734 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  934734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  934737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934746 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934759 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934762 */     GIR_RootConstrainSelectedInstOperands,
     /*  934763 */     // GIR_Coverage, 16345,
     /*  934763 */     GIR_EraseRootFromParent_Done,
     /*  934764 */   // Label 14126: @934764
     /*  934764 */   GIM_Try, /*On fail goto*//*Label 14127*/ GIMT_Encode4(934858), // Rule ID 16348 //
     /*  934769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  934780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  934783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  934786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934812 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934816 */     // MIs[1] Operand 1
     /*  934816 */     // No operand predicates
     /*  934816 */     // MIs[0] round
     /*  934816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  934828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  934831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934840 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934856 */     GIR_RootConstrainSelectedInstOperands,
     /*  934857 */     // GIR_Coverage, 16348,
     /*  934857 */     GIR_EraseRootFromParent_Done,
     /*  934858 */   // Label 14127: @934858
     /*  934858 */   GIM_Try, /*On fail goto*//*Label 14128*/ GIMT_Encode4(934952), // Rule ID 16349 //
     /*  934863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  934866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  934874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  934877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  934880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  934883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  934886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  934906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  934910 */     // MIs[1] Operand 1
     /*  934910 */     // No operand predicates
     /*  934910 */     // MIs[0] round
     /*  934910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  934913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  934915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  934922 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  934922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  934925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  934927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  934929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  934931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  934934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  934936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  934941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  934944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  934947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  934950 */     GIR_RootConstrainSelectedInstOperands,
     /*  934951 */     // GIR_Coverage, 16349,
     /*  934951 */     GIR_EraseRootFromParent_Done,
     /*  934952 */   // Label 14128: @934952
     /*  934952 */   GIM_Try, /*On fail goto*//*Label 14129*/ GIMT_Encode4(935046), // Rule ID 16352 //
     /*  934957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  934960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  934965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  934968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  934971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  934974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  934977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  934980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  934988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  934992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  934996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935004 */     // MIs[1] Operand 1
     /*  935004 */     // No operand predicates
     /*  935004 */     // MIs[0] round
     /*  935004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935028 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935044 */     GIR_RootConstrainSelectedInstOperands,
     /*  935045 */     // GIR_Coverage, 16352,
     /*  935045 */     GIR_EraseRootFromParent_Done,
     /*  935046 */   // Label 14129: @935046
     /*  935046 */   GIM_Try, /*On fail goto*//*Label 14130*/ GIMT_Encode4(935140), // Rule ID 16353 //
     /*  935051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  935062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  935065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  935068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935094 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935098 */     // MIs[1] Operand 1
     /*  935098 */     // No operand predicates
     /*  935098 */     // MIs[0] round
     /*  935098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935110 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935122 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935138 */     GIR_RootConstrainSelectedInstOperands,
     /*  935139 */     // GIR_Coverage, 16353,
     /*  935139 */     GIR_EraseRootFromParent_Done,
     /*  935140 */   // Label 14130: @935140
     /*  935140 */   GIM_Try, /*On fail goto*//*Label 14131*/ GIMT_Encode4(935234), // Rule ID 16356 //
     /*  935145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935192 */     // MIs[1] Operand 1
     /*  935192 */     // No operand predicates
     /*  935192 */     // MIs[0] round
     /*  935192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935216 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935232 */     GIR_RootConstrainSelectedInstOperands,
     /*  935233 */     // GIR_Coverage, 16356,
     /*  935233 */     GIR_EraseRootFromParent_Done,
     /*  935234 */   // Label 14131: @935234
     /*  935234 */   GIM_Try, /*On fail goto*//*Label 14132*/ GIMT_Encode4(935328), // Rule ID 16357 //
     /*  935239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  935250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  935253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  935256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935286 */     // MIs[1] Operand 1
     /*  935286 */     // No operand predicates
     /*  935286 */     // MIs[0] round
     /*  935286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  935301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935310 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935326 */     GIR_RootConstrainSelectedInstOperands,
     /*  935327 */     // GIR_Coverage, 16357,
     /*  935327 */     GIR_EraseRootFromParent_Done,
     /*  935328 */   // Label 14132: @935328
     /*  935328 */   GIM_Try, /*On fail goto*//*Label 14133*/ GIMT_Encode4(935422), // Rule ID 16360 //
     /*  935333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935380 */     // MIs[1] Operand 1
     /*  935380 */     // No operand predicates
     /*  935380 */     // MIs[0] round
     /*  935380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  935392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  935395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935404 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935420 */     GIR_RootConstrainSelectedInstOperands,
     /*  935421 */     // GIR_Coverage, 16360,
     /*  935421 */     GIR_EraseRootFromParent_Done,
     /*  935422 */   // Label 14133: @935422
     /*  935422 */   GIM_Try, /*On fail goto*//*Label 14134*/ GIMT_Encode4(935516), // Rule ID 16361 //
     /*  935427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  935438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  935441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  935444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  935458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  935462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935470 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935474 */     // MIs[1] Operand 1
     /*  935474 */     // No operand predicates
     /*  935474 */     // MIs[0] round
     /*  935474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  935486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  935489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935498 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  935508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935514 */     GIR_RootConstrainSelectedInstOperands,
     /*  935515 */     // GIR_Coverage, 16361,
     /*  935515 */     GIR_EraseRootFromParent_Done,
     /*  935516 */   // Label 14134: @935516
     /*  935516 */   GIM_Try, /*On fail goto*//*Label 14135*/ GIMT_Encode4(935610), // Rule ID 16364 //
     /*  935521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935568 */     // MIs[1] Operand 1
     /*  935568 */     // No operand predicates
     /*  935568 */     // MIs[0] round
     /*  935568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935580 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935592 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935608 */     GIR_RootConstrainSelectedInstOperands,
     /*  935609 */     // GIR_Coverage, 16364,
     /*  935609 */     GIR_EraseRootFromParent_Done,
     /*  935610 */   // Label 14135: @935610
     /*  935610 */   GIM_Try, /*On fail goto*//*Label 14136*/ GIMT_Encode4(935704), // Rule ID 16365 //
     /*  935615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  935626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  935629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  935632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935662 */     // MIs[1] Operand 1
     /*  935662 */     // No operand predicates
     /*  935662 */     // MIs[0] round
     /*  935662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4),
     /*  935677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935686 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935699 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935702 */     GIR_RootConstrainSelectedInstOperands,
     /*  935703 */     // GIR_Coverage, 16365,
     /*  935703 */     GIR_EraseRootFromParent_Done,
     /*  935704 */   // Label 14136: @935704
     /*  935704 */   GIM_Try, /*On fail goto*//*Label 14137*/ GIMT_Encode4(935798), // Rule ID 16368 //
     /*  935709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  935726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935752 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935756 */     // MIs[1] Operand 1
     /*  935756 */     // No operand predicates
     /*  935756 */     // MIs[0] round
     /*  935756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935796 */     GIR_RootConstrainSelectedInstOperands,
     /*  935797 */     // GIR_Coverage, 16368,
     /*  935797 */     GIR_EraseRootFromParent_Done,
     /*  935798 */   // Label 14137: @935798
     /*  935798 */   GIM_Try, /*On fail goto*//*Label 14138*/ GIMT_Encode4(935892), // Rule ID 16369 //
     /*  935803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  935814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  935817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  935820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  935823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  935826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935850 */     // MIs[1] Operand 1
     /*  935850 */     // No operand predicates
     /*  935850 */     // MIs[0] round
     /*  935850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  935862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  935865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935874 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935887 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935890 */     GIR_RootConstrainSelectedInstOperands,
     /*  935891 */     // GIR_Coverage, 16369,
     /*  935891 */     GIR_EraseRootFromParent_Done,
     /*  935892 */   // Label 14138: @935892
     /*  935892 */   GIM_Try, /*On fail goto*//*Label 14139*/ GIMT_Encode4(935986), // Rule ID 16372 //
     /*  935897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  935900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  935908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  935911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  935914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  935917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  935920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  935928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  935932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  935936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  935940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  935944 */     // MIs[1] Operand 1
     /*  935944 */     // No operand predicates
     /*  935944 */     // MIs[0] round
     /*  935944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  935947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  935949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  935956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  935956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  935959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  935961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  935963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  935965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  935968 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  935970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  935975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  935978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  935981 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  935984 */     GIR_RootConstrainSelectedInstOperands,
     /*  935985 */     // GIR_Coverage, 16372,
     /*  935985 */     GIR_EraseRootFromParent_Done,
     /*  935986 */   // Label 14139: @935986
     /*  935986 */   GIM_Try, /*On fail goto*//*Label 14140*/ GIMT_Encode4(936080), // Rule ID 16373 //
     /*  935991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  935994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  935999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  936002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  936005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  936008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936038 */     // MIs[1] Operand 1
     /*  936038 */     // No operand predicates
     /*  936038 */     // MIs[0] round
     /*  936038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936062 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936078 */     GIR_RootConstrainSelectedInstOperands,
     /*  936079 */     // GIR_Coverage, 16373,
     /*  936079 */     GIR_EraseRootFromParent_Done,
     /*  936080 */   // Label 14140: @936080
     /*  936080 */   GIM_Try, /*On fail goto*//*Label 14141*/ GIMT_Encode4(936174), // Rule ID 16376 //
     /*  936085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936132 */     // MIs[1] Operand 1
     /*  936132 */     // No operand predicates
     /*  936132 */     // MIs[0] round
     /*  936132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936156 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936169 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936172 */     GIR_RootConstrainSelectedInstOperands,
     /*  936173 */     // GIR_Coverage, 16376,
     /*  936173 */     GIR_EraseRootFromParent_Done,
     /*  936174 */   // Label 14141: @936174
     /*  936174 */   GIM_Try, /*On fail goto*//*Label 14142*/ GIMT_Encode4(936268), // Rule ID 16377 //
     /*  936179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  936190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  936193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  936196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936226 */     // MIs[1] Operand 1
     /*  936226 */     // No operand predicates
     /*  936226 */     // MIs[0] round
     /*  936226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936238 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936266 */     GIR_RootConstrainSelectedInstOperands,
     /*  936267 */     // GIR_Coverage, 16377,
     /*  936267 */     GIR_EraseRootFromParent_Done,
     /*  936268 */   // Label 14142: @936268
     /*  936268 */   GIM_Try, /*On fail goto*//*Label 14143*/ GIMT_Encode4(936362), // Rule ID 16380 //
     /*  936273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  936276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936320 */     // MIs[1] Operand 1
     /*  936320 */     // No operand predicates
     /*  936320 */     // MIs[0] round
     /*  936320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  936332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936344 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936360 */     GIR_RootConstrainSelectedInstOperands,
     /*  936361 */     // GIR_Coverage, 16380,
     /*  936361 */     GIR_EraseRootFromParent_Done,
     /*  936362 */   // Label 14143: @936362
     /*  936362 */   GIM_Try, /*On fail goto*//*Label 14144*/ GIMT_Encode4(936456), // Rule ID 16381 //
     /*  936367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  936370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  936378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  936381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  936384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  936402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936414 */     // MIs[1] Operand 1
     /*  936414 */     // No operand predicates
     /*  936414 */     // MIs[0] round
     /*  936414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936426 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  936426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  936429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936438 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  936448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936454 */     GIR_RootConstrainSelectedInstOperands,
     /*  936455 */     // GIR_Coverage, 16381,
     /*  936455 */     GIR_EraseRootFromParent_Done,
     /*  936456 */   // Label 14144: @936456
     /*  936456 */   GIM_Try, /*On fail goto*//*Label 14145*/ GIMT_Encode4(936550), // Rule ID 16384 //
     /*  936461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  936464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  936472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  936475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936508 */     // MIs[1] Operand 1
     /*  936508 */     // No operand predicates
     /*  936508 */     // MIs[0] round
     /*  936508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  936520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936532 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936548 */     GIR_RootConstrainSelectedInstOperands,
     /*  936549 */     // GIR_Coverage, 16384,
     /*  936549 */     GIR_EraseRootFromParent_Done,
     /*  936550 */   // Label 14145: @936550
     /*  936550 */   GIM_Try, /*On fail goto*//*Label 14146*/ GIMT_Encode4(936644), // Rule ID 16385 //
     /*  936555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  936558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  936566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  936569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  936572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936602 */     // MIs[1] Operand 1
     /*  936602 */     // No operand predicates
     /*  936602 */     // MIs[0] round
     /*  936602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936614 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  936614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2),
     /*  936617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936642 */     GIR_RootConstrainSelectedInstOperands,
     /*  936643 */     // GIR_Coverage, 16385,
     /*  936643 */     GIR_EraseRootFromParent_Done,
     /*  936644 */   // Label 14146: @936644
     /*  936644 */   GIM_Try, /*On fail goto*//*Label 14147*/ GIMT_Encode4(936738), // Rule ID 16388 //
     /*  936649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  936652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  936666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936696 */     // MIs[1] Operand 1
     /*  936696 */     // No operand predicates
     /*  936696 */     // MIs[0] round
     /*  936696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936708 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  936708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936720 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936736 */     GIR_RootConstrainSelectedInstOperands,
     /*  936737 */     // GIR_Coverage, 16388,
     /*  936737 */     GIR_EraseRootFromParent_Done,
     /*  936738 */   // Label 14147: @936738
     /*  936738 */   GIM_Try, /*On fail goto*//*Label 14148*/ GIMT_Encode4(936832), // Rule ID 16389 //
     /*  936743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  936746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  936754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  936757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  936760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  936774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936786 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936790 */     // MIs[1] Operand 1
     /*  936790 */     // No operand predicates
     /*  936790 */     // MIs[0] round
     /*  936790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936802 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  936802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1),
     /*  936805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936814 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936827 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936830 */     GIR_RootConstrainSelectedInstOperands,
     /*  936831 */     // GIR_Coverage, 16389,
     /*  936831 */     GIR_EraseRootFromParent_Done,
     /*  936832 */   // Label 14148: @936832
     /*  936832 */   GIM_Try, /*On fail goto*//*Label 14149*/ GIMT_Encode4(936926), // Rule ID 16392 //
     /*  936837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  936840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  936848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  936851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  936854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  936857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  936860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936884 */     // MIs[1] Operand 1
     /*  936884 */     // No operand predicates
     /*  936884 */     // MIs[0] round
     /*  936884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  936896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  936908 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  936910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  936915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  936918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  936921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  936924 */     GIR_RootConstrainSelectedInstOperands,
     /*  936925 */     // GIR_Coverage, 16392,
     /*  936925 */     GIR_EraseRootFromParent_Done,
     /*  936926 */   // Label 14149: @936926
     /*  936926 */   GIM_Try, /*On fail goto*//*Label 14150*/ GIMT_Encode4(937020), // Rule ID 16393 //
     /*  936931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  936934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  936939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  936942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  936945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  936948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  936951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  936954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  936962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  936966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  936970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  936974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  936978 */     // MIs[1] Operand 1
     /*  936978 */     // No operand predicates
     /*  936978 */     // MIs[0] round
     /*  936978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  936981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  936983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  936990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  936990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2),
     /*  936993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  936995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  936997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  936999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937002 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937018 */     GIR_RootConstrainSelectedInstOperands,
     /*  937019 */     // GIR_Coverage, 16393,
     /*  937019 */     GIR_EraseRootFromParent_Done,
     /*  937020 */   // Label 14150: @937020
     /*  937020 */   GIM_Try, /*On fail goto*//*Label 14151*/ GIMT_Encode4(937114), // Rule ID 16396 //
     /*  937025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  937028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937072 */     // MIs[1] Operand 1
     /*  937072 */     // No operand predicates
     /*  937072 */     // MIs[0] round
     /*  937072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937075 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937084 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  937084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937096 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937112 */     GIR_RootConstrainSelectedInstOperands,
     /*  937113 */     // GIR_Coverage, 16396,
     /*  937113 */     GIR_EraseRootFromParent_Done,
     /*  937114 */   // Label 14151: @937114
     /*  937114 */   GIM_Try, /*On fail goto*//*Label 14152*/ GIMT_Encode4(937208), // Rule ID 16397 //
     /*  937119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  937122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /*  937127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  937130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  937133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  937136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  937150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  937154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937166 */     // MIs[1] Operand 1
     /*  937166 */     // No operand predicates
     /*  937166 */     // MIs[0] round
     /*  937166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937169 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937178 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  937178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4),
     /*  937181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937190 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  937200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937206 */     GIR_RootConstrainSelectedInstOperands,
     /*  937207 */     // GIR_Coverage, 16397,
     /*  937207 */     GIR_EraseRootFromParent_Done,
     /*  937208 */   // Label 14152: @937208
     /*  937208 */   GIM_Try, /*On fail goto*//*Label 14153*/ GIMT_Encode4(937302), // Rule ID 16520 //
     /*  937213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937260 */     // MIs[1] Operand 1
     /*  937260 */     // No operand predicates
     /*  937260 */     // MIs[0] round
     /*  937260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937272 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937284 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937300 */     GIR_RootConstrainSelectedInstOperands,
     /*  937301 */     // GIR_Coverage, 16520,
     /*  937301 */     GIR_EraseRootFromParent_Done,
     /*  937302 */   // Label 14153: @937302
     /*  937302 */   GIM_Try, /*On fail goto*//*Label 14154*/ GIMT_Encode4(937396), // Rule ID 16521 //
     /*  937307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  937318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  937321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  937324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937350 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937354 */     // MIs[1] Operand 1
     /*  937354 */     // No operand predicates
     /*  937354 */     // MIs[0] round
     /*  937354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937366 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8),
     /*  937369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937378 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937394 */     GIR_RootConstrainSelectedInstOperands,
     /*  937395 */     // GIR_Coverage, 16521,
     /*  937395 */     GIR_EraseRootFromParent_Done,
     /*  937396 */   // Label 14154: @937396
     /*  937396 */   GIM_Try, /*On fail goto*//*Label 14155*/ GIMT_Encode4(937490), // Rule ID 16524 //
     /*  937401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  937412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  937415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  937418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937448 */     // MIs[1] Operand 1
     /*  937448 */     // No operand predicates
     /*  937448 */     // MIs[0] round
     /*  937448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937460 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  937463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937472 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937488 */     GIR_RootConstrainSelectedInstOperands,
     /*  937489 */     // GIR_Coverage, 16524,
     /*  937489 */     GIR_EraseRootFromParent_Done,
     /*  937490 */   // Label 14155: @937490
     /*  937490 */   GIM_Try, /*On fail goto*//*Label 14156*/ GIMT_Encode4(937584), // Rule ID 16525 //
     /*  937495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  937506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  937509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  937512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937542 */     // MIs[1] Operand 1
     /*  937542 */     // No operand predicates
     /*  937542 */     // MIs[0] round
     /*  937542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  937557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937582 */     GIR_RootConstrainSelectedInstOperands,
     /*  937583 */     // GIR_Coverage, 16525,
     /*  937583 */     GIR_EraseRootFromParent_Done,
     /*  937584 */   // Label 14156: @937584
     /*  937584 */   GIM_Try, /*On fail goto*//*Label 14157*/ GIMT_Encode4(937678), // Rule ID 16528 //
     /*  937589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  937600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  937603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  937606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937632 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937636 */     // MIs[1] Operand 1
     /*  937636 */     // No operand predicates
     /*  937636 */     // MIs[0] round
     /*  937636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  937651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937660 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937673 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937676 */     GIR_RootConstrainSelectedInstOperands,
     /*  937677 */     // GIR_Coverage, 16528,
     /*  937677 */     GIR_EraseRootFromParent_Done,
     /*  937678 */   // Label 14157: @937678
     /*  937678 */   GIM_Try, /*On fail goto*//*Label 14158*/ GIMT_Encode4(937772), // Rule ID 16529 //
     /*  937683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  937694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  937697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  937700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937730 */     // MIs[1] Operand 1
     /*  937730 */     // No operand predicates
     /*  937730 */     // MIs[0] round
     /*  937730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  937745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937754 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937770 */     GIR_RootConstrainSelectedInstOperands,
     /*  937771 */     // GIR_Coverage, 16529,
     /*  937771 */     GIR_EraseRootFromParent_Done,
     /*  937772 */   // Label 14158: @937772
     /*  937772 */   GIM_Try, /*On fail goto*//*Label 14159*/ GIMT_Encode4(937866), // Rule ID 16532 //
     /*  937777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  937788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  937791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937824 */     // MIs[1] Operand 1
     /*  937824 */     // No operand predicates
     /*  937824 */     // MIs[0] round
     /*  937824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  937836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  937839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937848 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937861 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937864 */     GIR_RootConstrainSelectedInstOperands,
     /*  937865 */     // GIR_Coverage, 16532,
     /*  937865 */     GIR_EraseRootFromParent_Done,
     /*  937866 */   // Label 14159: @937866
     /*  937866 */   GIM_Try, /*On fail goto*//*Label 14160*/ GIMT_Encode4(937960), // Rule ID 16533 //
     /*  937871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  937874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  937882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  937885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  937888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  937891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  937894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  937902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  937910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  937914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  937918 */     // MIs[1] Operand 1
     /*  937918 */     // No operand predicates
     /*  937918 */     // MIs[0] round
     /*  937918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  937921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  937923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  937930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  937930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  937933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  937935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  937937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  937939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  937942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  937944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  937949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  937952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  937955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  937958 */     GIR_RootConstrainSelectedInstOperands,
     /*  937959 */     // GIR_Coverage, 16533,
     /*  937959 */     GIR_EraseRootFromParent_Done,
     /*  937960 */   // Label 14160: @937960
     /*  937960 */   GIM_Try, /*On fail goto*//*Label 14161*/ GIMT_Encode4(938054), // Rule ID 16536 //
     /*  937965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  937968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  937973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  937976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  937979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  937982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  937985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  937988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  937996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938012 */     // MIs[1] Operand 1
     /*  938012 */     // No operand predicates
     /*  938012 */     // MIs[0] round
     /*  938012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938024 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938036 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938049 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938052 */     GIR_RootConstrainSelectedInstOperands,
     /*  938053 */     // GIR_Coverage, 16536,
     /*  938053 */     GIR_EraseRootFromParent_Done,
     /*  938054 */   // Label 14161: @938054
     /*  938054 */   GIM_Try, /*On fail goto*//*Label 14162*/ GIMT_Encode4(938148), // Rule ID 16537 //
     /*  938059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  938070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  938073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  938076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938106 */     // MIs[1] Operand 1
     /*  938106 */     // No operand predicates
     /*  938106 */     // MIs[0] round
     /*  938106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938130 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938146 */     GIR_RootConstrainSelectedInstOperands,
     /*  938147 */     // GIR_Coverage, 16537,
     /*  938147 */     GIR_EraseRootFromParent_Done,
     /*  938148 */   // Label 14162: @938148
     /*  938148 */   GIM_Try, /*On fail goto*//*Label 14163*/ GIMT_Encode4(938242), // Rule ID 16540 //
     /*  938153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938200 */     // MIs[1] Operand 1
     /*  938200 */     // No operand predicates
     /*  938200 */     // MIs[0] round
     /*  938200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938212 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /*  938212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938224 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938237 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938240 */     GIR_RootConstrainSelectedInstOperands,
     /*  938241 */     // GIR_Coverage, 16540,
     /*  938241 */     GIR_EraseRootFromParent_Done,
     /*  938242 */   // Label 14163: @938242
     /*  938242 */   GIM_Try, /*On fail goto*//*Label 14164*/ GIMT_Encode4(938336), // Rule ID 16541 //
     /*  938247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  938258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  938261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  938264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  938282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938294 */     // MIs[1] Operand 1
     /*  938294 */     // No operand predicates
     /*  938294 */     // MIs[0] round
     /*  938294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938306 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /*  938306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  938309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938318 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  938328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938334 */     GIR_RootConstrainSelectedInstOperands,
     /*  938335 */     // GIR_Coverage, 16541,
     /*  938335 */     GIR_EraseRootFromParent_Done,
     /*  938336 */   // Label 14164: @938336
     /*  938336 */   GIM_Try, /*On fail goto*//*Label 14165*/ GIMT_Encode4(938430), // Rule ID 16544 //
     /*  938341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938388 */     // MIs[1] Operand 1
     /*  938388 */     // No operand predicates
     /*  938388 */     // MIs[0] round
     /*  938388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938400 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938428 */     GIR_RootConstrainSelectedInstOperands,
     /*  938429 */     // GIR_Coverage, 16544,
     /*  938429 */     GIR_EraseRootFromParent_Done,
     /*  938430 */   // Label 14165: @938430
     /*  938430 */   GIM_Try, /*On fail goto*//*Label 14166*/ GIMT_Encode4(938524), // Rule ID 16545 //
     /*  938435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  938446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  938449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  938452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938482 */     // MIs[1] Operand 1
     /*  938482 */     // No operand predicates
     /*  938482 */     // MIs[0] round
     /*  938482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  938494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4),
     /*  938497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938506 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938522 */     GIR_RootConstrainSelectedInstOperands,
     /*  938523 */     // GIR_Coverage, 16545,
     /*  938523 */     GIR_EraseRootFromParent_Done,
     /*  938524 */   // Label 14166: @938524
     /*  938524 */   GIM_Try, /*On fail goto*//*Label 14167*/ GIMT_Encode4(938618), // Rule ID 16548 //
     /*  938529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  938540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  938543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  938546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938572 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938576 */     // MIs[1] Operand 1
     /*  938576 */     // No operand predicates
     /*  938576 */     // MIs[0] round
     /*  938576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938588 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938600 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938616 */     GIR_RootConstrainSelectedInstOperands,
     /*  938617 */     // GIR_Coverage, 16548,
     /*  938617 */     GIR_EraseRootFromParent_Done,
     /*  938618 */   // Label 14167: @938618
     /*  938618 */   GIM_Try, /*On fail goto*//*Label 14168*/ GIMT_Encode4(938712), // Rule ID 16549 //
     /*  938623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  938634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  938637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  938640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938670 */     // MIs[1] Operand 1
     /*  938670 */     // No operand predicates
     /*  938670 */     // MIs[0] round
     /*  938670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938682 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  938682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  938685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938694 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938707 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938710 */     GIR_RootConstrainSelectedInstOperands,
     /*  938711 */     // GIR_Coverage, 16549,
     /*  938711 */     GIR_EraseRootFromParent_Done,
     /*  938712 */   // Label 14168: @938712
     /*  938712 */   GIM_Try, /*On fail goto*//*Label 14169*/ GIMT_Encode4(938806), // Rule ID 16552 //
     /*  938717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  938728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  938731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  938734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938764 */     // MIs[1] Operand 1
     /*  938764 */     // No operand predicates
     /*  938764 */     // MIs[0] round
     /*  938764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938776 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938804 */     GIR_RootConstrainSelectedInstOperands,
     /*  938805 */     // GIR_Coverage, 16552,
     /*  938805 */     GIR_EraseRootFromParent_Done,
     /*  938806 */   // Label 14169: @938806
     /*  938806 */   GIM_Try, /*On fail goto*//*Label 14170*/ GIMT_Encode4(938900), // Rule ID 16553 //
     /*  938811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  938814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  938822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  938825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  938828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  938831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  938834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  938842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938858 */     // MIs[1] Operand 1
     /*  938858 */     // No operand predicates
     /*  938858 */     // MIs[0] round
     /*  938858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938870 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  938870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  938873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938882 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938895 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938898 */     GIR_RootConstrainSelectedInstOperands,
     /*  938899 */     // GIR_Coverage, 16553,
     /*  938899 */     GIR_EraseRootFromParent_Done,
     /*  938900 */   // Label 14170: @938900
     /*  938900 */   GIM_Try, /*On fail goto*//*Label 14171*/ GIMT_Encode4(938994), // Rule ID 16556 //
     /*  938905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  938908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  938913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  938916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  938919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  938922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  938925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  938928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  938936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  938940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  938944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  938948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  938952 */     // MIs[1] Operand 1
     /*  938952 */     // No operand predicates
     /*  938952 */     // MIs[0] round
     /*  938952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  938955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  938957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  938964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  938964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  938967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  938969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  938971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  938973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  938976 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  938978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  938983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  938986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  938989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  938992 */     GIR_RootConstrainSelectedInstOperands,
     /*  938993 */     // GIR_Coverage, 16556,
     /*  938993 */     GIR_EraseRootFromParent_Done,
     /*  938994 */   // Label 14171: @938994
     /*  938994 */   GIM_Try, /*On fail goto*//*Label 14172*/ GIMT_Encode4(939088), // Rule ID 16557 //
     /*  938999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  939010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  939013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  939016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939046 */     // MIs[1] Operand 1
     /*  939046 */     // No operand predicates
     /*  939046 */     // MIs[0] round
     /*  939046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939058 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939070 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939086 */     GIR_RootConstrainSelectedInstOperands,
     /*  939087 */     // GIR_Coverage, 16557,
     /*  939087 */     GIR_EraseRootFromParent_Done,
     /*  939088 */   // Label 14172: @939088
     /*  939088 */   GIM_Try, /*On fail goto*//*Label 14173*/ GIMT_Encode4(939182), // Rule ID 16560 //
     /*  939093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  939096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939140 */     // MIs[1] Operand 1
     /*  939140 */     // No operand predicates
     /*  939140 */     // MIs[0] round
     /*  939140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  939152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939164 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939180 */     GIR_RootConstrainSelectedInstOperands,
     /*  939181 */     // GIR_Coverage, 16560,
     /*  939181 */     GIR_EraseRootFromParent_Done,
     /*  939182 */   // Label 14173: @939182
     /*  939182 */   GIM_Try, /*On fail goto*//*Label 14174*/ GIMT_Encode4(939276), // Rule ID 16561 //
     /*  939187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  939190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  939198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  939201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  939204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939230 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939234 */     // MIs[1] Operand 1
     /*  939234 */     // No operand predicates
     /*  939234 */     // MIs[0] round
     /*  939234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939246 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  939246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939258 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  939268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939274 */     GIR_RootConstrainSelectedInstOperands,
     /*  939275 */     // GIR_Coverage, 16561,
     /*  939275 */     GIR_EraseRootFromParent_Done,
     /*  939276 */   // Label 14174: @939276
     /*  939276 */   GIM_Try, /*On fail goto*//*Label 14175*/ GIMT_Encode4(939370), // Rule ID 16564 //
     /*  939281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939328 */     // MIs[1] Operand 1
     /*  939328 */     // No operand predicates
     /*  939328 */     // MIs[0] round
     /*  939328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939340 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939352 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939368 */     GIR_RootConstrainSelectedInstOperands,
     /*  939369 */     // GIR_Coverage, 16564,
     /*  939369 */     GIR_EraseRootFromParent_Done,
     /*  939370 */   // Label 14175: @939370
     /*  939370 */   GIM_Try, /*On fail goto*//*Label 14176*/ GIMT_Encode4(939464), // Rule ID 16565 //
     /*  939375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  939386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  939389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  939392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939422 */     // MIs[1] Operand 1
     /*  939422 */     // No operand predicates
     /*  939422 */     // MIs[0] round
     /*  939422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2),
     /*  939437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939446 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939462 */     GIR_RootConstrainSelectedInstOperands,
     /*  939463 */     // GIR_Coverage, 16565,
     /*  939463 */     GIR_EraseRootFromParent_Done,
     /*  939464 */   // Label 14176: @939464
     /*  939464 */   GIM_Try, /*On fail goto*//*Label 14177*/ GIMT_Encode4(939558), // Rule ID 16568 //
     /*  939469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  939480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  939483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  939486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939516 */     // MIs[1] Operand 1
     /*  939516 */     // No operand predicates
     /*  939516 */     // MIs[0] round
     /*  939516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939528 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939540 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939556 */     GIR_RootConstrainSelectedInstOperands,
     /*  939557 */     // GIR_Coverage, 16568,
     /*  939557 */     GIR_EraseRootFromParent_Done,
     /*  939558 */   // Label 14177: @939558
     /*  939558 */   GIM_Try, /*On fail goto*//*Label 14178*/ GIMT_Encode4(939652), // Rule ID 16569 //
     /*  939563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  939574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  939577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  939580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  939594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939606 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939610 */     // MIs[1] Operand 1
     /*  939610 */     // No operand predicates
     /*  939610 */     // MIs[0] round
     /*  939610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939622 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1),
     /*  939625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939650 */     GIR_RootConstrainSelectedInstOperands,
     /*  939651 */     // GIR_Coverage, 16569,
     /*  939651 */     GIR_EraseRootFromParent_Done,
     /*  939652 */   // Label 14178: @939652
     /*  939652 */   GIM_Try, /*On fail goto*//*Label 14179*/ GIMT_Encode4(939746), // Rule ID 16572 //
     /*  939657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  939668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  939671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  939674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939704 */     // MIs[1] Operand 1
     /*  939704 */     // No operand predicates
     /*  939704 */     // MIs[0] round
     /*  939704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939716 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939744 */     GIR_RootConstrainSelectedInstOperands,
     /*  939745 */     // GIR_Coverage, 16572,
     /*  939745 */     GIR_EraseRootFromParent_Done,
     /*  939746 */   // Label 14179: @939746
     /*  939746 */   GIM_Try, /*On fail goto*//*Label 14180*/ GIMT_Encode4(939840), // Rule ID 16573 //
     /*  939751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  939762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  939765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  939768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  939782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939798 */     // MIs[1] Operand 1
     /*  939798 */     // No operand predicates
     /*  939798 */     // MIs[0] round
     /*  939798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2),
     /*  939813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939822 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939838 */     GIR_RootConstrainSelectedInstOperands,
     /*  939839 */     // GIR_Coverage, 16573,
     /*  939839 */     GIR_EraseRootFromParent_Done,
     /*  939840 */   // Label 14180: @939840
     /*  939840 */   GIM_Try, /*On fail goto*//*Label 14181*/ GIMT_Encode4(939934), // Rule ID 16576 //
     /*  939845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  939848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  939856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  939859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  939862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  939865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  939868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939892 */     // MIs[1] Operand 1
     /*  939892 */     // No operand predicates
     /*  939892 */     // MIs[0] round
     /*  939892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  939904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  939907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  939909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  939911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  939913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  939916 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  939918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  939923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  939926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  939929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  939932 */     GIR_RootConstrainSelectedInstOperands,
     /*  939933 */     // GIR_Coverage, 16576,
     /*  939933 */     GIR_EraseRootFromParent_Done,
     /*  939934 */   // Label 14181: @939934
     /*  939934 */   GIM_Try, /*On fail goto*//*Label 14182*/ GIMT_Encode4(940028), // Rule ID 16577 //
     /*  939939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  939942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /*  939947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  939950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  939953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  939956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  939959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  939962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  939970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  939974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  939978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  939982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /*  939986 */     // MIs[1] Operand 1
     /*  939986 */     // No operand predicates
     /*  939986 */     // MIs[0] round
     /*  939986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  939989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  939991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  939998 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WI_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  939998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4),
     /*  940001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  940005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  940010 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  940023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /*  940026 */     GIR_RootConstrainSelectedInstOperands,
     /*  940027 */     // GIR_Coverage, 16577,
     /*  940027 */     GIR_EraseRootFromParent_Done,
     /*  940028 */   // Label 14182: @940028
     /*  940028 */   GIM_Try, /*On fail goto*//*Label 14183*/ GIMT_Encode4(940112), // Rule ID 2652 //
     /*  940033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940076 */     // MIs[0] round
     /*  940076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940088 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940110 */     GIR_RootConstrainSelectedInstOperands,
     /*  940111 */     // GIR_Coverage, 2652,
     /*  940111 */     GIR_EraseRootFromParent_Done,
     /*  940112 */   // Label 14183: @940112
     /*  940112 */   GIM_Try, /*On fail goto*//*Label 14184*/ GIMT_Encode4(940196), // Rule ID 2653 //
     /*  940117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  940128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  940131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  940134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  940137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940160 */     // MIs[0] round
     /*  940160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940172 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  940175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940194 */     GIR_RootConstrainSelectedInstOperands,
     /*  940195 */     // GIR_Coverage, 2653,
     /*  940195 */     GIR_EraseRootFromParent_Done,
     /*  940196 */   // Label 14184: @940196
     /*  940196 */   GIM_Try, /*On fail goto*//*Label 14185*/ GIMT_Encode4(940280), // Rule ID 17024 //
     /*  940201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940244 */     // MIs[0] round
     /*  940244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940256 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940278 */     GIR_RootConstrainSelectedInstOperands,
     /*  940279 */     // GIR_Coverage, 17024,
     /*  940279 */     GIR_EraseRootFromParent_Done,
     /*  940280 */   // Label 14185: @940280
     /*  940280 */   GIM_Try, /*On fail goto*//*Label 14186*/ GIMT_Encode4(940364), // Rule ID 17025 //
     /*  940285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  940296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  940299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  940302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  940305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940328 */     // MIs[0] round
     /*  940328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940340 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  940343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940362 */     GIR_RootConstrainSelectedInstOperands,
     /*  940363 */     // GIR_Coverage, 17025,
     /*  940363 */     GIR_EraseRootFromParent_Done,
     /*  940364 */   // Label 14186: @940364
     /*  940364 */   GIM_Try, /*On fail goto*//*Label 14187*/ GIMT_Encode4(940448), // Rule ID 17034 //
     /*  940369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940412 */     // MIs[0] round
     /*  940412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  940427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940446 */     GIR_RootConstrainSelectedInstOperands,
     /*  940447 */     // GIR_Coverage, 17034,
     /*  940447 */     GIR_EraseRootFromParent_Done,
     /*  940448 */   // Label 14187: @940448
     /*  940448 */   GIM_Try, /*On fail goto*//*Label 14188*/ GIMT_Encode4(940532), // Rule ID 17035 //
     /*  940453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  940464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  940467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  940470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  940473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940496 */     // MIs[0] round
     /*  940496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940508 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  940511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940530 */     GIR_RootConstrainSelectedInstOperands,
     /*  940531 */     // GIR_Coverage, 17035,
     /*  940531 */     GIR_EraseRootFromParent_Done,
     /*  940532 */   // Label 14188: @940532
     /*  940532 */   GIM_Try, /*On fail goto*//*Label 14189*/ GIMT_Encode4(940616), // Rule ID 17044 //
     /*  940537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  940557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940580 */     // MIs[0] round
     /*  940580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940592 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  940595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940614 */     GIR_RootConstrainSelectedInstOperands,
     /*  940615 */     // GIR_Coverage, 17044,
     /*  940615 */     GIR_EraseRootFromParent_Done,
     /*  940616 */   // Label 14189: @940616
     /*  940616 */   GIM_Try, /*On fail goto*//*Label 14190*/ GIMT_Encode4(940700), // Rule ID 17045 //
     /*  940621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  940632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  940635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  940638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  940641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  940664 */     // MIs[0] round
     /*  940664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940676 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  940679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940698 */     GIR_RootConstrainSelectedInstOperands,
     /*  940699 */     // GIR_Coverage, 17045,
     /*  940699 */     GIR_EraseRootFromParent_Done,
     /*  940700 */   // Label 14190: @940700
     /*  940700 */   GIM_Try, /*On fail goto*//*Label 14191*/ GIMT_Encode4(940784), // Rule ID 17054 //
     /*  940705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  940708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  940716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  940719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  940725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940748 */     // MIs[0] round
     /*  940748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940760 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  940760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  940763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940782 */     GIR_RootConstrainSelectedInstOperands,
     /*  940783 */     // GIR_Coverage, 17054,
     /*  940783 */     GIR_EraseRootFromParent_Done,
     /*  940784 */   // Label 14191: @940784
     /*  940784 */   GIM_Try, /*On fail goto*//*Label 14192*/ GIMT_Encode4(940868), // Rule ID 17055 //
     /*  940789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  940792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  940800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  940803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  940806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  940809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  940828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  940832 */     // MIs[0] round
     /*  940832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940844 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  940844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  940847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  940863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940866 */     GIR_RootConstrainSelectedInstOperands,
     /*  940867 */     // GIR_Coverage, 17055,
     /*  940867 */     GIR_EraseRootFromParent_Done,
     /*  940868 */   // Label 14192: @940868
     /*  940868 */   GIM_Try, /*On fail goto*//*Label 14193*/ GIMT_Encode4(940952), // Rule ID 17064 //
     /*  940873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  940876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  940884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  940887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  940893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  940896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940916 */     // MIs[0] round
     /*  940916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  940919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  940921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  940928 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  940928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  940931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  940933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  940935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  940937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  940939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  940944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  940947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  940950 */     GIR_RootConstrainSelectedInstOperands,
     /*  940951 */     // GIR_Coverage, 17064,
     /*  940951 */     GIR_EraseRootFromParent_Done,
     /*  940952 */   // Label 14193: @940952
     /*  940952 */   GIM_Try, /*On fail goto*//*Label 14194*/ GIMT_Encode4(941036), // Rule ID 17065 //
     /*  940957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  940960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  940965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  940968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  940971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  940974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  940977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  940980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  940988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  940992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  940996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941000 */     // MIs[0] round
     /*  941000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941012 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  941015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941034 */     GIR_RootConstrainSelectedInstOperands,
     /*  941035 */     // GIR_Coverage, 17065,
     /*  941035 */     GIR_EraseRootFromParent_Done,
     /*  941036 */   // Label 14194: @941036
     /*  941036 */   GIM_Try, /*On fail goto*//*Label 14195*/ GIMT_Encode4(941120), // Rule ID 17074 //
     /*  941041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941084 */     // MIs[0] round
     /*  941084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941096 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941118 */     GIR_RootConstrainSelectedInstOperands,
     /*  941119 */     // GIR_Coverage, 17074,
     /*  941119 */     GIR_EraseRootFromParent_Done,
     /*  941120 */   // Label 14195: @941120
     /*  941120 */   GIM_Try, /*On fail goto*//*Label 14196*/ GIMT_Encode4(941204), // Rule ID 17075 //
     /*  941125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  941136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  941139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  941142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  941145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941168 */     // MIs[0] round
     /*  941168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941180 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  941183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941202 */     GIR_RootConstrainSelectedInstOperands,
     /*  941203 */     // GIR_Coverage, 17075,
     /*  941203 */     GIR_EraseRootFromParent_Done,
     /*  941204 */   // Label 14196: @941204
     /*  941204 */   GIM_Try, /*On fail goto*//*Label 14197*/ GIMT_Encode4(941288), // Rule ID 17084 //
     /*  941209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941252 */     // MIs[0] round
     /*  941252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941264 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941286 */     GIR_RootConstrainSelectedInstOperands,
     /*  941287 */     // GIR_Coverage, 17084,
     /*  941287 */     GIR_EraseRootFromParent_Done,
     /*  941288 */   // Label 14197: @941288
     /*  941288 */   GIM_Try, /*On fail goto*//*Label 14198*/ GIMT_Encode4(941372), // Rule ID 17085 //
     /*  941293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  941304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  941307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  941310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  941313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941336 */     // MIs[0] round
     /*  941336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941348 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  941351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941370 */     GIR_RootConstrainSelectedInstOperands,
     /*  941371 */     // GIR_Coverage, 17085,
     /*  941371 */     GIR_EraseRootFromParent_Done,
     /*  941372 */   // Label 14198: @941372
     /*  941372 */   GIM_Try, /*On fail goto*//*Label 14199*/ GIMT_Encode4(941456), // Rule ID 17094 //
     /*  941377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  941380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941420 */     // MIs[0] round
     /*  941420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  941432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  941435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941454 */     GIR_RootConstrainSelectedInstOperands,
     /*  941455 */     // GIR_Coverage, 17094,
     /*  941455 */     GIR_EraseRootFromParent_Done,
     /*  941456 */   // Label 14199: @941456
     /*  941456 */   GIM_Try, /*On fail goto*//*Label 14200*/ GIMT_Encode4(941540), // Rule ID 17095 //
     /*  941461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  941464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  941469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  941472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  941475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  941478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  941481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  941500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  941504 */     // MIs[0] round
     /*  941504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941516 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  941516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  941519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  941535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941538 */     GIR_RootConstrainSelectedInstOperands,
     /*  941539 */     // GIR_Coverage, 17095,
     /*  941539 */     GIR_EraseRootFromParent_Done,
     /*  941540 */   // Label 14200: @941540
     /*  941540 */   GIM_Try, /*On fail goto*//*Label 14201*/ GIMT_Encode4(941624), // Rule ID 17140 //
     /*  941545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941588 */     // MIs[0] round
     /*  941588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941600 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  941603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941622 */     GIR_RootConstrainSelectedInstOperands,
     /*  941623 */     // GIR_Coverage, 17140,
     /*  941623 */     GIR_EraseRootFromParent_Done,
     /*  941624 */   // Label 14201: @941624
     /*  941624 */   GIM_Try, /*On fail goto*//*Label 14202*/ GIMT_Encode4(941708), // Rule ID 17141 //
     /*  941629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  941640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  941643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  941646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  941649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941672 */     // MIs[0] round
     /*  941672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941684 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  941687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941706 */     GIR_RootConstrainSelectedInstOperands,
     /*  941707 */     // GIR_Coverage, 17141,
     /*  941707 */     GIR_EraseRootFromParent_Done,
     /*  941708 */   // Label 14202: @941708
     /*  941708 */   GIM_Try, /*On fail goto*//*Label 14203*/ GIMT_Encode4(941792), // Rule ID 17150 //
     /*  941713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941756 */     // MIs[0] round
     /*  941756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941768 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  941771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941790 */     GIR_RootConstrainSelectedInstOperands,
     /*  941791 */     // GIR_Coverage, 17150,
     /*  941791 */     GIR_EraseRootFromParent_Done,
     /*  941792 */   // Label 14203: @941792
     /*  941792 */   GIM_Try, /*On fail goto*//*Label 14204*/ GIMT_Encode4(941876), // Rule ID 17151 //
     /*  941797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  941808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  941811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  941814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  941817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941840 */     // MIs[0] round
     /*  941840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941852 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  941852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  941855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941874 */     GIR_RootConstrainSelectedInstOperands,
     /*  941875 */     // GIR_Coverage, 17151,
     /*  941875 */     GIR_EraseRootFromParent_Done,
     /*  941876 */   // Label 14204: @941876
     /*  941876 */   GIM_Try, /*On fail goto*//*Label 14205*/ GIMT_Encode4(941960), // Rule ID 17160 //
     /*  941881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  941884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  941904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  941916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  941924 */     // MIs[0] round
     /*  941924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  941927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  941929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  941936 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  941936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  941939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  941941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  941943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  941945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  941947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  941952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  941955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  941958 */     GIR_RootConstrainSelectedInstOperands,
     /*  941959 */     // GIR_Coverage, 17160,
     /*  941959 */     GIR_EraseRootFromParent_Done,
     /*  941960 */   // Label 14205: @941960
     /*  941960 */   GIM_Try, /*On fail goto*//*Label 14206*/ GIMT_Encode4(942044), // Rule ID 17161 //
     /*  941965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  941968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  941973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  941976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  941979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  941982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  941985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  941988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  941992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  941996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942008 */     // MIs[0] round
     /*  942008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  942023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942042 */     GIR_RootConstrainSelectedInstOperands,
     /*  942043 */     // GIR_Coverage, 17161,
     /*  942043 */     GIR_EraseRootFromParent_Done,
     /*  942044 */   // Label 14206: @942044
     /*  942044 */   GIM_Try, /*On fail goto*//*Label 14207*/ GIMT_Encode4(942128), // Rule ID 17170 //
     /*  942049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942092 */     // MIs[0] round
     /*  942092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942104 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942126 */     GIR_RootConstrainSelectedInstOperands,
     /*  942127 */     // GIR_Coverage, 17170,
     /*  942127 */     GIR_EraseRootFromParent_Done,
     /*  942128 */   // Label 14207: @942128
     /*  942128 */   GIM_Try, /*On fail goto*//*Label 14208*/ GIMT_Encode4(942212), // Rule ID 17171 //
     /*  942133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  942144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  942147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  942150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  942153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942176 */     // MIs[0] round
     /*  942176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942188 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  942191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942210 */     GIR_RootConstrainSelectedInstOperands,
     /*  942211 */     // GIR_Coverage, 17171,
     /*  942211 */     GIR_EraseRootFromParent_Done,
     /*  942212 */   // Label 14208: @942212
     /*  942212 */   GIM_Try, /*On fail goto*//*Label 14209*/ GIMT_Encode4(942296), // Rule ID 17180 //
     /*  942217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  942220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942260 */     // MIs[0] round
     /*  942260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942272 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  942272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942294 */     GIR_RootConstrainSelectedInstOperands,
     /*  942295 */     // GIR_Coverage, 17180,
     /*  942295 */     GIR_EraseRootFromParent_Done,
     /*  942296 */   // Label 14209: @942296
     /*  942296 */   GIM_Try, /*On fail goto*//*Label 14210*/ GIMT_Encode4(942380), // Rule ID 17181 //
     /*  942301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  942304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  942312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  942315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  942318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  942321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942344 */     // MIs[0] round
     /*  942344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942356 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  942356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  942359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  942375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942378 */     GIR_RootConstrainSelectedInstOperands,
     /*  942379 */     // GIR_Coverage, 17181,
     /*  942379 */     GIR_EraseRootFromParent_Done,
     /*  942380 */   // Label 14210: @942380
     /*  942380 */   GIM_Try, /*On fail goto*//*Label 14211*/ GIMT_Encode4(942464), // Rule ID 17190 //
     /*  942385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  942396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  942399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  942402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  942405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942428 */     // MIs[0] round
     /*  942428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942440 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  942443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942462 */     GIR_RootConstrainSelectedInstOperands,
     /*  942463 */     // GIR_Coverage, 17190,
     /*  942463 */     GIR_EraseRootFromParent_Done,
     /*  942464 */   // Label 14211: @942464
     /*  942464 */   GIM_Try, /*On fail goto*//*Label 14212*/ GIMT_Encode4(942548), // Rule ID 17191 //
     /*  942469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  942480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  942483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  942486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  942489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942512 */     // MIs[0] round
     /*  942512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942524 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  942527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942546 */     GIR_RootConstrainSelectedInstOperands,
     /*  942547 */     // GIR_Coverage, 17191,
     /*  942547 */     GIR_EraseRootFromParent_Done,
     /*  942548 */   // Label 14212: @942548
     /*  942548 */   GIM_Try, /*On fail goto*//*Label 14213*/ GIMT_Encode4(942632), // Rule ID 17200 //
     /*  942553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942596 */     // MIs[0] round
     /*  942596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942608 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  942611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942630 */     GIR_RootConstrainSelectedInstOperands,
     /*  942631 */     // GIR_Coverage, 17200,
     /*  942631 */     GIR_EraseRootFromParent_Done,
     /*  942632 */   // Label 14213: @942632
     /*  942632 */   GIM_Try, /*On fail goto*//*Label 14214*/ GIMT_Encode4(942716), // Rule ID 17201 //
     /*  942637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  942648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  942651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  942654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  942657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  942680 */     // MIs[0] round
     /*  942680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942692 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  942695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942714 */     GIR_RootConstrainSelectedInstOperands,
     /*  942715 */     // GIR_Coverage, 17201,
     /*  942715 */     GIR_EraseRootFromParent_Done,
     /*  942716 */   // Label 14214: @942716
     /*  942716 */   GIM_Try, /*On fail goto*//*Label 14215*/ GIMT_Encode4(942800), // Rule ID 17210 //
     /*  942721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942764 */     // MIs[0] round
     /*  942764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942776 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  942779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942798 */     GIR_RootConstrainSelectedInstOperands,
     /*  942799 */     // GIR_Coverage, 17210,
     /*  942799 */     GIR_EraseRootFromParent_Done,
     /*  942800 */   // Label 14215: @942800
     /*  942800 */   GIM_Try, /*On fail goto*//*Label 14216*/ GIMT_Encode4(942884), // Rule ID 17211 //
     /*  942805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  942816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  942819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  942822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  942825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  942848 */     // MIs[0] round
     /*  942848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942860 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  942860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  942863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942882 */     GIR_RootConstrainSelectedInstOperands,
     /*  942883 */     // GIR_Coverage, 17211,
     /*  942883 */     GIR_EraseRootFromParent_Done,
     /*  942884 */   // Label 14216: @942884
     /*  942884 */   GIM_Try, /*On fail goto*//*Label 14217*/ GIMT_Encode4(942968), // Rule ID 17220 //
     /*  942889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  942892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  942912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  942920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  942924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  942928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  942932 */     // MIs[0] round
     /*  942932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  942935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  942937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  942944 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  942944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  942947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  942949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  942951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  942953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  942955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  942960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  942963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  942966 */     GIR_RootConstrainSelectedInstOperands,
     /*  942967 */     // GIR_Coverage, 17220,
     /*  942967 */     GIR_EraseRootFromParent_Done,
     /*  942968 */   // Label 14217: @942968
     /*  942968 */   GIM_Try, /*On fail goto*//*Label 14218*/ GIMT_Encode4(943052), // Rule ID 17221 //
     /*  942973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  942976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  942981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  942984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  942987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  942990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  942993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  942996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  943004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  943008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  943012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  943016 */     // MIs[0] round
     /*  943016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  943019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  943021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943028 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, (undef:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  943028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  943031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  943035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  943037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  943039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  943047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  943050 */     GIR_RootConstrainSelectedInstOperands,
     /*  943051 */     // GIR_Coverage, 17221,
     /*  943051 */     GIR_EraseRootFromParent_Done,
     /*  943052 */   // Label 14218: @943052
     /*  943052 */   GIM_Try, /*On fail goto*//*Label 14219*/ GIMT_Encode4(943134), // Rule ID 62806 //
     /*  943057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943084 */     // MIs[0] op1
     /*  943084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943087 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943111 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  943114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943116 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943118 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943120 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943122 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943132 */     GIR_RootConstrainSelectedInstOperands,
     /*  943133 */     // GIR_Coverage, 62806,
     /*  943133 */     GIR_EraseRootFromParent_Done,
     /*  943134 */   // Label 14219: @943134
     /*  943134 */   GIM_Try, /*On fail goto*//*Label 14220*/ GIMT_Encode4(943216), // Rule ID 62807 //
     /*  943139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943166 */     // MIs[0] op1
     /*  943166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF8),
     /*  943196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943198 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943200 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943202 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943204 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943214 */     GIR_RootConstrainSelectedInstOperands,
     /*  943215 */     // GIR_Coverage, 62807,
     /*  943215 */     GIR_EraseRootFromParent_Done,
     /*  943216 */   // Label 14220: @943216
     /*  943216 */   GIM_Try, /*On fail goto*//*Label 14221*/ GIMT_Encode4(943298), // Rule ID 62836 //
     /*  943221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943248 */     // MIs[0] op1
     /*  943248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943275 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  943278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943280 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943282 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943284 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943286 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943296 */     GIR_RootConstrainSelectedInstOperands,
     /*  943297 */     // GIR_Coverage, 62836,
     /*  943297 */     GIR_EraseRootFromParent_Done,
     /*  943298 */   // Label 14221: @943298
     /*  943298 */   GIM_Try, /*On fail goto*//*Label 14222*/ GIMT_Encode4(943380), // Rule ID 62837 //
     /*  943303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  943314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  943317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  943320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  943323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943330 */     // MIs[0] op1
     /*  943330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943333 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943357 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF8:{ *:[nxv1i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i8] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF8),
     /*  943360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943362 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943364 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943366 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943368 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943378 */     GIR_RootConstrainSelectedInstOperands,
     /*  943379 */     // GIR_Coverage, 62837,
     /*  943379 */     GIR_EraseRootFromParent_Done,
     /*  943380 */   // Label 14222: @943380
     /*  943380 */   GIM_Try, /*On fail goto*//*Label 14223*/ GIMT_Encode4(943462), // Rule ID 62868 //
     /*  943385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943412 */     // MIs[0] op1
     /*  943412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943415 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943439 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  943442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943444 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943446 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943448 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943450 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943460 */     GIR_RootConstrainSelectedInstOperands,
     /*  943461 */     // GIR_Coverage, 62868,
     /*  943461 */     GIR_EraseRootFromParent_Done,
     /*  943462 */   // Label 14223: @943462
     /*  943462 */   GIM_Try, /*On fail goto*//*Label 14224*/ GIMT_Encode4(943544), // Rule ID 62869 //
     /*  943467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943494 */     // MIs[0] op1
     /*  943494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943497 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943521 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  943524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943526 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943528 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943530 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943532 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943542 */     GIR_RootConstrainSelectedInstOperands,
     /*  943543 */     // GIR_Coverage, 62869,
     /*  943543 */     GIR_EraseRootFromParent_Done,
     /*  943544 */   // Label 14224: @943544
     /*  943544 */   GIM_Try, /*On fail goto*//*Label 14225*/ GIMT_Encode4(943626), // Rule ID 62880 //
     /*  943549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  943569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943576 */     // MIs[0] op1
     /*  943576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943579 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943603 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  943606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943608 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943610 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943612 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943614 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943624 */     GIR_RootConstrainSelectedInstOperands,
     /*  943625 */     // GIR_Coverage, 62880,
     /*  943625 */     GIR_EraseRootFromParent_Done,
     /*  943626 */   // Label 14225: @943626
     /*  943626 */   GIM_Try, /*On fail goto*//*Label 14226*/ GIMT_Encode4(943708), // Rule ID 62881 //
     /*  943631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  943642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  943645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  943648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  943651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943658 */     // MIs[0] op1
     /*  943658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943685 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv2i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i8] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  943688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943690 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943692 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943694 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943696 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943706 */     GIR_RootConstrainSelectedInstOperands,
     /*  943707 */     // GIR_Coverage, 62881,
     /*  943707 */     GIR_EraseRootFromParent_Done,
     /*  943708 */   // Label 14226: @943708
     /*  943708 */   GIM_Try, /*On fail goto*//*Label 14227*/ GIMT_Encode4(943790), // Rule ID 62912 //
     /*  943713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  943724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  943727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  943730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  943733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943740 */     // MIs[0] op1
     /*  943740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943743 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943767 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  943770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943772 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943774 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943776 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943778 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943788 */     GIR_RootConstrainSelectedInstOperands,
     /*  943789 */     // GIR_Coverage, 62912,
     /*  943789 */     GIR_EraseRootFromParent_Done,
     /*  943790 */   // Label 14227: @943790
     /*  943790 */   GIM_Try, /*On fail goto*//*Label 14228*/ GIMT_Encode4(943872), // Rule ID 62913 //
     /*  943795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  943803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  943806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  943809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  943812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  943815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943822 */     // MIs[0] op1
     /*  943822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943825 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  943842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943849 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  943849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  943852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943854 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943856 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943858 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943860 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943870 */     GIR_RootConstrainSelectedInstOperands,
     /*  943871 */     // GIR_Coverage, 62913,
     /*  943871 */     GIR_EraseRootFromParent_Done,
     /*  943872 */   // Label 14228: @943872
     /*  943872 */   GIM_Try, /*On fail goto*//*Label 14229*/ GIMT_Encode4(943954), // Rule ID 62924 //
     /*  943877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  943880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  943888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  943891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  943894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  943897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  943900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943904 */     // MIs[0] op1
     /*  943904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943907 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  943931 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  943931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  943934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  943936 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  943938 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  943940 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  943942 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  943944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  943949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  943952 */     GIR_RootConstrainSelectedInstOperands,
     /*  943953 */     // GIR_Coverage, 62924,
     /*  943953 */     GIR_EraseRootFromParent_Done,
     /*  943954 */   // Label 14229: @943954
     /*  943954 */   GIM_Try, /*On fail goto*//*Label 14230*/ GIMT_Encode4(944036), // Rule ID 62925 //
     /*  943959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  943962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  943967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  943970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  943973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  943976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  943979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  943982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943986 */     // MIs[0] op1
     /*  943986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  943989 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  943994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  943998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944013 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv4i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i8] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  944013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  944016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944018 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944020 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944022 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944024 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  944034 */     GIR_RootConstrainSelectedInstOperands,
     /*  944035 */     // GIR_Coverage, 62925,
     /*  944035 */     GIR_EraseRootFromParent_Done,
     /*  944036 */   // Label 14230: @944036
     /*  944036 */   GIM_Try, /*On fail goto*//*Label 14231*/ GIMT_Encode4(944118), // Rule ID 62956 //
     /*  944041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944068 */     // MIs[0] op1
     /*  944068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944095 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  944098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944100 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944102 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944104 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944106 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944116 */     GIR_RootConstrainSelectedInstOperands,
     /*  944117 */     // GIR_Coverage, 62956,
     /*  944117 */     GIR_EraseRootFromParent_Done,
     /*  944118 */   // Label 14231: @944118
     /*  944118 */   GIM_Try, /*On fail goto*//*Label 14232*/ GIMT_Encode4(944200), // Rule ID 62957 //
     /*  944123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944150 */     // MIs[0] op1
     /*  944150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944153 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944177 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF4),
     /*  944180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944182 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944184 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944186 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944188 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944198 */     GIR_RootConstrainSelectedInstOperands,
     /*  944199 */     // GIR_Coverage, 62957,
     /*  944199 */     GIR_EraseRootFromParent_Done,
     /*  944200 */   // Label 14232: @944200
     /*  944200 */   GIM_Try, /*On fail goto*//*Label 14233*/ GIMT_Encode4(944282), // Rule ID 62968 //
     /*  944205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944232 */     // MIs[0] op1
     /*  944232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944235 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944259 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944264 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944266 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944268 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944270 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944280 */     GIR_RootConstrainSelectedInstOperands,
     /*  944281 */     // GIR_Coverage, 62968,
     /*  944281 */     GIR_EraseRootFromParent_Done,
     /*  944282 */   // Label 14233: @944282
     /*  944282 */   GIM_Try, /*On fail goto*//*Label 14234*/ GIMT_Encode4(944364), // Rule ID 62969 //
     /*  944287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  944307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944314 */     // MIs[0] op1
     /*  944314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944317 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944341 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF4),
     /*  944344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944346 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944348 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944350 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944352 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944362 */     GIR_RootConstrainSelectedInstOperands,
     /*  944363 */     // GIR_Coverage, 62969,
     /*  944363 */     GIR_EraseRootFromParent_Done,
     /*  944364 */   // Label 14234: @944364
     /*  944364 */   GIM_Try, /*On fail goto*//*Label 14235*/ GIMT_Encode4(944446), // Rule ID 62980 //
     /*  944369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944396 */     // MIs[0] op1
     /*  944396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944423 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  944426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944428 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944430 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944432 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944434 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944444 */     GIR_RootConstrainSelectedInstOperands,
     /*  944445 */     // GIR_Coverage, 62980,
     /*  944445 */     GIR_EraseRootFromParent_Done,
     /*  944446 */   // Label 14235: @944446
     /*  944446 */   GIM_Try, /*On fail goto*//*Label 14236*/ GIMT_Encode4(944528), // Rule ID 62981 //
     /*  944451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  944462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  944465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  944468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944478 */     // MIs[0] op1
     /*  944478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944505 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF4:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF4),
     /*  944508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944510 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944512 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944514 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944516 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944526 */     GIR_RootConstrainSelectedInstOperands,
     /*  944527 */     // GIR_Coverage, 62981,
     /*  944527 */     GIR_EraseRootFromParent_Done,
     /*  944528 */   // Label 14236: @944528
     /*  944528 */   GIM_Try, /*On fail goto*//*Label 14237*/ GIMT_Encode4(944610), // Rule ID 63012 //
     /*  944533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  944553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944560 */     // MIs[0] op1
     /*  944560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944587 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  944590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944592 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944594 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944596 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944598 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944608 */     GIR_RootConstrainSelectedInstOperands,
     /*  944609 */     // GIR_Coverage, 63012,
     /*  944609 */     GIR_EraseRootFromParent_Done,
     /*  944610 */   // Label 14237: @944610
     /*  944610 */   GIM_Try, /*On fail goto*//*Label 14238*/ GIMT_Encode4(944692), // Rule ID 63013 //
     /*  944615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  944623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  944635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944642 */     // MIs[0] op1
     /*  944642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944645 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  944662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944669 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  944672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944674 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944676 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944678 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944680 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944690 */     GIR_RootConstrainSelectedInstOperands,
     /*  944691 */     // GIR_Coverage, 63013,
     /*  944691 */     GIR_EraseRootFromParent_Done,
     /*  944692 */   // Label 14238: @944692
     /*  944692 */   GIM_Try, /*On fail goto*//*Label 14239*/ GIMT_Encode4(944774), // Rule ID 63024 //
     /*  944697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  944717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944724 */     // MIs[0] op1
     /*  944724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  944754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944756 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944758 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944760 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944762 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944772 */     GIR_RootConstrainSelectedInstOperands,
     /*  944773 */     // GIR_Coverage, 63024,
     /*  944773 */     GIR_EraseRootFromParent_Done,
     /*  944774 */   // Label 14239: @944774
     /*  944774 */   GIM_Try, /*On fail goto*//*Label 14240*/ GIMT_Encode4(944856), // Rule ID 63025 //
     /*  944779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  944787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  944799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944806 */     // MIs[0] op1
     /*  944806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944809 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  944814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944833 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  944836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944838 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944840 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944842 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944844 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944854 */     GIR_RootConstrainSelectedInstOperands,
     /*  944855 */     // GIR_Coverage, 63025,
     /*  944855 */     GIR_EraseRootFromParent_Done,
     /*  944856 */   // Label 14240: @944856
     /*  944856 */   GIM_Try, /*On fail goto*//*Label 14241*/ GIMT_Encode4(944938), // Rule ID 63036 //
     /*  944861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  944864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  944884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944888 */     // MIs[0] op1
     /*  944888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944891 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944915 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  944915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  944918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  944920 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  944922 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  944924 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  944926 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  944928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  944933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  944936 */     GIR_RootConstrainSelectedInstOperands,
     /*  944937 */     // GIR_Coverage, 63036,
     /*  944937 */     GIR_EraseRootFromParent_Done,
     /*  944938 */   // Label 14241: @944938
     /*  944938 */   GIM_Try, /*On fail goto*//*Label 14242*/ GIMT_Encode4(945020), // Rule ID 63037 //
     /*  944943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  944946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  944951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  944954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  944957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  944960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  944963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  944966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944970 */     // MIs[0] op1
     /*  944970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  944973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  944978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  944986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  944990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  944997 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_MF2:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  944997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_MF2),
     /*  945000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945002 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945004 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945006 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945008 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945018 */     GIR_RootConstrainSelectedInstOperands,
     /*  945019 */     // GIR_Coverage, 63037,
     /*  945019 */     GIR_EraseRootFromParent_Done,
     /*  945020 */   // Label 14242: @945020
     /*  945020 */   GIM_Try, /*On fail goto*//*Label 14243*/ GIMT_Encode4(945102), // Rule ID 63068 //
     /*  945025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945052 */     // MIs[0] op1
     /*  945052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945079 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945084 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945086 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945088 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945090 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945100 */     GIR_RootConstrainSelectedInstOperands,
     /*  945101 */     // GIR_Coverage, 63068,
     /*  945101 */     GIR_EraseRootFromParent_Done,
     /*  945102 */   // Label 14243: @945102
     /*  945102 */   GIM_Try, /*On fail goto*//*Label 14244*/ GIMT_Encode4(945184), // Rule ID 63069 //
     /*  945107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945134 */     // MIs[0] op1
     /*  945134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945137 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945161 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_MF2),
     /*  945164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945166 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945168 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945170 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945172 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945182 */     GIR_RootConstrainSelectedInstOperands,
     /*  945183 */     // GIR_Coverage, 63069,
     /*  945183 */     GIR_EraseRootFromParent_Done,
     /*  945184 */   // Label 14244: @945184
     /*  945184 */   GIM_Try, /*On fail goto*//*Label 14245*/ GIMT_Encode4(945266), // Rule ID 63080 //
     /*  945189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945216 */     // MIs[0] op1
     /*  945216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945243 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945248 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945250 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945252 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945254 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945264 */     GIR_RootConstrainSelectedInstOperands,
     /*  945265 */     // GIR_Coverage, 63080,
     /*  945265 */     GIR_EraseRootFromParent_Done,
     /*  945266 */   // Label 14245: @945266
     /*  945266 */   GIM_Try, /*On fail goto*//*Label 14246*/ GIMT_Encode4(945348), // Rule ID 63081 //
     /*  945271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  945291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945298 */     // MIs[0] op1
     /*  945298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945325 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_MF2),
     /*  945328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945330 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945332 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945334 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945336 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945346 */     GIR_RootConstrainSelectedInstOperands,
     /*  945347 */     // GIR_Coverage, 63081,
     /*  945347 */     GIR_EraseRootFromParent_Done,
     /*  945348 */   // Label 14246: @945348
     /*  945348 */   GIM_Try, /*On fail goto*//*Label 14247*/ GIMT_Encode4(945430), // Rule ID 63092 //
     /*  945353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945380 */     // MIs[0] op1
     /*  945380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  945400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945407 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  945407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  945410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945412 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945414 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945416 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945418 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945428 */     GIR_RootConstrainSelectedInstOperands,
     /*  945429 */     // GIR_Coverage, 63092,
     /*  945429 */     GIR_EraseRootFromParent_Done,
     /*  945430 */   // Label 14247: @945430
     /*  945430 */   GIM_Try, /*On fail goto*//*Label 14248*/ GIMT_Encode4(945512), // Rule ID 63093 //
     /*  945435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  945443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  945446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  945449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  945452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945462 */     // MIs[0] op1
     /*  945462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945465 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  945470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  945482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945489 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_MF2:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  945489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_MF2),
     /*  945492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945494 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945496 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945498 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945500 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  945510 */     GIR_RootConstrainSelectedInstOperands,
     /*  945511 */     // GIR_Coverage, 63093,
     /*  945511 */     GIR_EraseRootFromParent_Done,
     /*  945512 */   // Label 14248: @945512
     /*  945512 */   GIM_Try, /*On fail goto*//*Label 14249*/ GIMT_Encode4(945594), // Rule ID 63124 //
     /*  945517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  945528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  945531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  945534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945544 */     // MIs[0] op1
     /*  945544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945571 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  945571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  945574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945576 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945578 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945580 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945582 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945592 */     GIR_RootConstrainSelectedInstOperands,
     /*  945593 */     // GIR_Coverage, 63124,
     /*  945593 */     GIR_EraseRootFromParent_Done,
     /*  945594 */   // Label 14249: @945594
     /*  945594 */   GIM_Try, /*On fail goto*//*Label 14250*/ GIMT_Encode4(945676), // Rule ID 63125 //
     /*  945599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  945610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  945613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  945616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945626 */     // MIs[0] op1
     /*  945626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945653 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  945653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  945656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945658 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945660 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945662 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945664 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945674 */     GIR_RootConstrainSelectedInstOperands,
     /*  945675 */     // GIR_Coverage, 63125,
     /*  945675 */     GIR_EraseRootFromParent_Done,
     /*  945676 */   // Label 14250: @945676
     /*  945676 */   GIM_Try, /*On fail goto*//*Label 14251*/ GIMT_Encode4(945758), // Rule ID 63136 //
     /*  945681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  945692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  945695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  945698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  945701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945708 */     // MIs[0] op1
     /*  945708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945711 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945735 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  945735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  945738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945740 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945742 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945744 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945746 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945756 */     GIR_RootConstrainSelectedInstOperands,
     /*  945757 */     // GIR_Coverage, 63136,
     /*  945757 */     GIR_EraseRootFromParent_Done,
     /*  945758 */   // Label 14251: @945758
     /*  945758 */   GIM_Try, /*On fail goto*//*Label 14252*/ GIMT_Encode4(945840), // Rule ID 63137 //
     /*  945763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  945771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  945774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  945777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  945780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  945783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945790 */     // MIs[0] op1
     /*  945790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945817 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv8i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv8i8] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  945817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  945820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945822 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945824 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945826 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945828 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  945838 */     GIR_RootConstrainSelectedInstOperands,
     /*  945839 */     // GIR_Coverage, 63137,
     /*  945839 */     GIR_EraseRootFromParent_Done,
     /*  945840 */   // Label 14252: @945840
     /*  945840 */   GIM_Try, /*On fail goto*//*Label 14253*/ GIMT_Encode4(945922), // Rule ID 63168 //
     /*  945845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  945848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  945856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  945859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  945862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  945865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  945868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945872 */     // MIs[0] op1
     /*  945872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945899 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  945899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  945902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945904 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945906 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945908 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945910 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  945920 */     GIR_RootConstrainSelectedInstOperands,
     /*  945921 */     // GIR_Coverage, 63168,
     /*  945921 */     GIR_EraseRootFromParent_Done,
     /*  945922 */   // Label 14253: @945922
     /*  945922 */   GIM_Try, /*On fail goto*//*Label 14254*/ GIMT_Encode4(946004), // Rule ID 63169 //
     /*  945927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  945930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  945935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  945938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  945941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  945944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  945947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  945950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945954 */     // MIs[0] op1
     /*  945954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  945957 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  945962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  945970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  945974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  945981 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  945981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  945984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  945986 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  945988 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  945990 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  945992 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  945994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  945999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946002 */     GIR_RootConstrainSelectedInstOperands,
     /*  946003 */     // GIR_Coverage, 63169,
     /*  946003 */     GIR_EraseRootFromParent_Done,
     /*  946004 */   // Label 14254: @946004
     /*  946004 */   GIM_Try, /*On fail goto*//*Label 14255*/ GIMT_Encode4(946086), // Rule ID 63180 //
     /*  946009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946036 */     // MIs[0] op1
     /*  946036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946063 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946068 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946070 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946072 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946074 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946084 */     GIR_RootConstrainSelectedInstOperands,
     /*  946085 */     // GIR_Coverage, 63180,
     /*  946085 */     GIR_EraseRootFromParent_Done,
     /*  946086 */   // Label 14255: @946086
     /*  946086 */   GIM_Try, /*On fail goto*//*Label 14256*/ GIMT_Encode4(946168), // Rule ID 63181 //
     /*  946091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  946111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946118 */     // MIs[0] op1
     /*  946118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946145 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946150 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946152 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946154 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946156 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946166 */     GIR_RootConstrainSelectedInstOperands,
     /*  946167 */     // GIR_Coverage, 63181,
     /*  946167 */     GIR_EraseRootFromParent_Done,
     /*  946168 */   // Label 14256: @946168
     /*  946168 */   GIM_Try, /*On fail goto*//*Label 14257*/ GIMT_Encode4(946250), // Rule ID 63192 //
     /*  946173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946200 */     // MIs[0] op1
     /*  946200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  946227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  946230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946232 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946234 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946236 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946238 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946248 */     GIR_RootConstrainSelectedInstOperands,
     /*  946249 */     // GIR_Coverage, 63192,
     /*  946249 */     GIR_EraseRootFromParent_Done,
     /*  946250 */   // Label 14257: @946250
     /*  946250 */   GIM_Try, /*On fail goto*//*Label 14258*/ GIMT_Encode4(946332), // Rule ID 63193 //
     /*  946255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  946266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  946269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  946272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  946275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946282 */     // MIs[0] op1
     /*  946282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  946302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946309 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M1:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  946309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M1),
     /*  946312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946314 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946316 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946318 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946320 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  946330 */     GIR_RootConstrainSelectedInstOperands,
     /*  946331 */     // GIR_Coverage, 63193,
     /*  946331 */     GIR_EraseRootFromParent_Done,
     /*  946332 */   // Label 14258: @946332
     /*  946332 */   GIM_Try, /*On fail goto*//*Label 14259*/ GIMT_Encode4(946414), // Rule ID 63224 //
     /*  946337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946364 */     // MIs[0] op1
     /*  946364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946367 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946391 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946396 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946398 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946400 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946402 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946412 */     GIR_RootConstrainSelectedInstOperands,
     /*  946413 */     // GIR_Coverage, 63224,
     /*  946413 */     GIR_EraseRootFromParent_Done,
     /*  946414 */   // Label 14259: @946414
     /*  946414 */   GIM_Try, /*On fail goto*//*Label 14260*/ GIMT_Encode4(946496), // Rule ID 63225 //
     /*  946419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946446 */     // MIs[0] op1
     /*  946446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946449 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946473 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946478 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946480 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946482 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946484 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946494 */     GIR_RootConstrainSelectedInstOperands,
     /*  946495 */     // GIR_Coverage, 63225,
     /*  946495 */     GIR_EraseRootFromParent_Done,
     /*  946496 */   // Label 14260: @946496
     /*  946496 */   GIM_Try, /*On fail goto*//*Label 14261*/ GIMT_Encode4(946578), // Rule ID 63236 //
     /*  946501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  946521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946528 */     // MIs[0] op1
     /*  946528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946531 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946555 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946560 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946562 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946564 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946566 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946576 */     GIR_RootConstrainSelectedInstOperands,
     /*  946577 */     // GIR_Coverage, 63236,
     /*  946577 */     GIR_EraseRootFromParent_Done,
     /*  946578 */   // Label 14261: @946578
     /*  946578 */   GIM_Try, /*On fail goto*//*Label 14262*/ GIMT_Encode4(946660), // Rule ID 63237 //
     /*  946583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  946591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  946603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946610 */     // MIs[0] op1
     /*  946610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946613 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946637 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  946640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946642 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946644 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946646 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946648 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946658 */     GIR_RootConstrainSelectedInstOperands,
     /*  946659 */     // GIR_Coverage, 63237,
     /*  946659 */     GIR_EraseRootFromParent_Done,
     /*  946660 */   // Label 14262: @946660
     /*  946660 */   GIM_Try, /*On fail goto*//*Label 14263*/ GIMT_Encode4(946742), // Rule ID 63248 //
     /*  946665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946692 */     // MIs[0] op1
     /*  946692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946695 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946719 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  946719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  946722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946724 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946726 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946728 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946730 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946740 */     GIR_RootConstrainSelectedInstOperands,
     /*  946741 */     // GIR_Coverage, 63248,
     /*  946741 */     GIR_EraseRootFromParent_Done,
     /*  946742 */   // Label 14263: @946742
     /*  946742 */   GIM_Try, /*On fail goto*//*Label 14264*/ GIMT_Encode4(946824), // Rule ID 63249 //
     /*  946747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  946755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  946758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  946761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  946764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946774 */     // MIs[0] op1
     /*  946774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946777 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  946782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  946794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946801 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M1:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  946801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M1),
     /*  946804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946806 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946808 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946810 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946812 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  946822 */     GIR_RootConstrainSelectedInstOperands,
     /*  946823 */     // GIR_Coverage, 63249,
     /*  946823 */     GIR_EraseRootFromParent_Done,
     /*  946824 */   // Label 14264: @946824
     /*  946824 */   GIM_Try, /*On fail goto*//*Label 14265*/ GIMT_Encode4(946906), // Rule ID 63280 //
     /*  946829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  946846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  946849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  946852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946856 */     // MIs[0] op1
     /*  946856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946859 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  946883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946888 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946890 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946892 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946894 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  946904 */     GIR_RootConstrainSelectedInstOperands,
     /*  946905 */     // GIR_Coverage, 63280,
     /*  946905 */     GIR_EraseRootFromParent_Done,
     /*  946906 */   // Label 14265: @946906
     /*  946906 */   GIM_Try, /*On fail goto*//*Label 14266*/ GIMT_Encode4(946988), // Rule ID 63281 //
     /*  946911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  946914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  946919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  946922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  946925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  946928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  946931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  946934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946938 */     // MIs[0] op1
     /*  946938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  946941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  946946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  946954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  946958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  946965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  946965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M1),
     /*  946968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  946970 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  946972 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  946974 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  946976 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  946978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  946983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  946986 */     GIR_RootConstrainSelectedInstOperands,
     /*  946987 */     // GIR_Coverage, 63281,
     /*  946987 */     GIR_EraseRootFromParent_Done,
     /*  946988 */   // Label 14266: @946988
     /*  946988 */   GIM_Try, /*On fail goto*//*Label 14267*/ GIMT_Encode4(947070), // Rule ID 63292 //
     /*  946993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  946996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947020 */     // MIs[0] op1
     /*  947020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947023 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947047 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947052 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947054 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947056 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947058 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947068 */     GIR_RootConstrainSelectedInstOperands,
     /*  947069 */     // GIR_Coverage, 63292,
     /*  947069 */     GIR_EraseRootFromParent_Done,
     /*  947070 */   // Label 14267: @947070
     /*  947070 */   GIM_Try, /*On fail goto*//*Label 14268*/ GIMT_Encode4(947152), // Rule ID 63293 //
     /*  947075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s64,
     /*  947095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947102 */     // MIs[0] op1
     /*  947102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947129 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, VR:{ *:[nxv1i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M1),
     /*  947132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947134 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947136 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947138 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947140 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947150 */     GIR_RootConstrainSelectedInstOperands,
     /*  947151 */     // GIR_Coverage, 63293,
     /*  947151 */     GIR_EraseRootFromParent_Done,
     /*  947152 */   // Label 14268: @947152
     /*  947152 */   GIM_Try, /*On fail goto*//*Label 14269*/ GIMT_Encode4(947234), // Rule ID 63304 //
     /*  947157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947184 */     // MIs[0] op1
     /*  947184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  947211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  947214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947216 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947218 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947220 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947222 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947232 */     GIR_RootConstrainSelectedInstOperands,
     /*  947233 */     // GIR_Coverage, 63304,
     /*  947233 */     GIR_EraseRootFromParent_Done,
     /*  947234 */   // Label 14269: @947234
     /*  947234 */   GIM_Try, /*On fail goto*//*Label 14270*/ GIMT_Encode4(947316), // Rule ID 63305 //
     /*  947239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  947247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  947250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  947253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /*  947256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947266 */     // MIs[0] op1
     /*  947266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947269 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  947274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  947282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  947286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947293 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M1:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  947293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M1),
     /*  947296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947298 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947300 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947302 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947304 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  947314 */     GIR_RootConstrainSelectedInstOperands,
     /*  947315 */     // GIR_Coverage, 63305,
     /*  947315 */     GIR_EraseRootFromParent_Done,
     /*  947316 */   // Label 14270: @947316
     /*  947316 */   GIM_Try, /*On fail goto*//*Label 14271*/ GIMT_Encode4(947398), // Rule ID 63336 //
     /*  947321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947348 */     // MIs[0] op1
     /*  947348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947351 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947375 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  947378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947380 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947382 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947384 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947386 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947396 */     GIR_RootConstrainSelectedInstOperands,
     /*  947397 */     // GIR_Coverage, 63336,
     /*  947397 */     GIR_EraseRootFromParent_Done,
     /*  947398 */   // Label 14271: @947398
     /*  947398 */   GIM_Try, /*On fail goto*//*Label 14272*/ GIMT_Encode4(947480), // Rule ID 63337 //
     /*  947403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947430 */     // MIs[0] op1
     /*  947430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947457 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  947460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947462 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947464 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947466 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947468 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947478 */     GIR_RootConstrainSelectedInstOperands,
     /*  947479 */     // GIR_Coverage, 63337,
     /*  947479 */     GIR_EraseRootFromParent_Done,
     /*  947480 */   // Label 14272: @947480
     /*  947480 */   GIM_Try, /*On fail goto*//*Label 14273*/ GIMT_Encode4(947562), // Rule ID 63348 //
     /*  947485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  947505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947512 */     // MIs[0] op1
     /*  947512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947515 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  947542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947544 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947546 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947548 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947550 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947560 */     GIR_RootConstrainSelectedInstOperands,
     /*  947561 */     // GIR_Coverage, 63348,
     /*  947561 */     GIR_EraseRootFromParent_Done,
     /*  947562 */   // Label 14273: @947562
     /*  947562 */   GIM_Try, /*On fail goto*//*Label 14274*/ GIMT_Encode4(947644), // Rule ID 63349 //
     /*  947567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  947578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  947581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  947584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  947587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947594 */     // MIs[0] op1
     /*  947594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  947614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947621 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv16i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv16i8] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  947624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947626 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947628 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947630 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947632 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947642 */     GIR_RootConstrainSelectedInstOperands,
     /*  947643 */     // GIR_Coverage, 63349,
     /*  947643 */     GIR_EraseRootFromParent_Done,
     /*  947644 */   // Label 14274: @947644
     /*  947644 */   GIM_Try, /*On fail goto*//*Label 14275*/ GIMT_Encode4(947726), // Rule ID 63380 //
     /*  947649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  947660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947676 */     // MIs[0] op1
     /*  947676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947703 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  947706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947708 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947710 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947712 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947714 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947724 */     GIR_RootConstrainSelectedInstOperands,
     /*  947725 */     // GIR_Coverage, 63380,
     /*  947725 */     GIR_EraseRootFromParent_Done,
     /*  947726 */   // Label 14275: @947726
     /*  947726 */   GIM_Try, /*On fail goto*//*Label 14276*/ GIMT_Encode4(947808), // Rule ID 63381 //
     /*  947731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  947742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  947751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947758 */     // MIs[0] op1
     /*  947758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  947778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947785 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  947788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947790 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947792 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947794 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947796 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947806 */     GIR_RootConstrainSelectedInstOperands,
     /*  947807 */     // GIR_Coverage, 63381,
     /*  947807 */     GIR_EraseRootFromParent_Done,
     /*  947808 */   // Label 14276: @947808
     /*  947808 */   GIM_Try, /*On fail goto*//*Label 14277*/ GIMT_Encode4(947890), // Rule ID 63392 //
     /*  947813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  947824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  947833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  947836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947840 */     // MIs[0] op1
     /*  947840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947867 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  947867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  947870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947872 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947874 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947876 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947878 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947888 */     GIR_RootConstrainSelectedInstOperands,
     /*  947889 */     // GIR_Coverage, 63392,
     /*  947889 */     GIR_EraseRootFromParent_Done,
     /*  947890 */   // Label 14277: @947890
     /*  947890 */   GIM_Try, /*On fail goto*//*Label 14278*/ GIMT_Encode4(947972), // Rule ID 63393 //
     /*  947895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  947898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  947903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  947906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  947909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  947912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  947915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  947918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947922 */     // MIs[0] op1
     /*  947922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  947925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  947930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  947942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  947949 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv32i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv32i8] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  947949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  947952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  947954 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  947956 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  947958 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  947960 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  947962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  947967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  947970 */     GIR_RootConstrainSelectedInstOperands,
     /*  947971 */     // GIR_Coverage, 63393,
     /*  947971 */     GIR_EraseRootFromParent_Done,
     /*  947972 */   // Label 14278: @947972
     /*  947972 */   GIM_Try, /*On fail goto*//*Label 14279*/ GIMT_Encode4(948054), // Rule ID 63424 //
     /*  947977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  947980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  947985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  947988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  947991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  947994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  947997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948004 */     // MIs[0] op1
     /*  948004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948031 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  948034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948036 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948038 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948040 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948042 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948052 */     GIR_RootConstrainSelectedInstOperands,
     /*  948053 */     // GIR_Coverage, 63424,
     /*  948053 */     GIR_EraseRootFromParent_Done,
     /*  948054 */   // Label 14279: @948054
     /*  948054 */   GIM_Try, /*On fail goto*//*Label 14280*/ GIMT_Encode4(948136), // Rule ID 63425 //
     /*  948059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948086 */     // MIs[0] op1
     /*  948086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948089 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948113 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  948116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948118 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948120 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948122 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948124 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948134 */     GIR_RootConstrainSelectedInstOperands,
     /*  948135 */     // GIR_Coverage, 63425,
     /*  948135 */     GIR_EraseRootFromParent_Done,
     /*  948136 */   // Label 14280: @948136
     /*  948136 */   GIM_Try, /*On fail goto*//*Label 14281*/ GIMT_Encode4(948218), // Rule ID 63436 //
     /*  948141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948168 */     // MIs[0] op1
     /*  948168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948171 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948195 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  948195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  948198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948200 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948202 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948204 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948206 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948216 */     GIR_RootConstrainSelectedInstOperands,
     /*  948217 */     // GIR_Coverage, 63436,
     /*  948217 */     GIR_EraseRootFromParent_Done,
     /*  948218 */   // Label 14281: @948218
     /*  948218 */   GIM_Try, /*On fail goto*//*Label 14282*/ GIMT_Encode4(948300), // Rule ID 63437 //
     /*  948223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  948234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  948237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /*  948240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s8,
     /*  948243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948250 */     // MIs[0] op1
     /*  948250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  948270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948277 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv64i8] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv64i8] }:$op2, VRM8:{ *:[nxv64i8] }:$op3, VRM8:{ *:[nxv64i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  948277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  948280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948282 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948284 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948286 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948288 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  948298 */     GIR_RootConstrainSelectedInstOperands,
     /*  948299 */     // GIR_Coverage, 63437,
     /*  948299 */     GIR_EraseRootFromParent_Done,
     /*  948300 */   // Label 14282: @948300
     /*  948300 */   GIM_Try, /*On fail goto*//*Label 14283*/ GIMT_Encode4(948382), // Rule ID 63468 //
     /*  948305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948332 */     // MIs[0] op1
     /*  948332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948335 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948359 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  948362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948364 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948366 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948368 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948370 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948380 */     GIR_RootConstrainSelectedInstOperands,
     /*  948381 */     // GIR_Coverage, 63468,
     /*  948381 */     GIR_EraseRootFromParent_Done,
     /*  948382 */   // Label 14283: @948382
     /*  948382 */   GIM_Try, /*On fail goto*//*Label 14284*/ GIMT_Encode4(948464), // Rule ID 63469 //
     /*  948387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948414 */     // MIs[0] op1
     /*  948414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948441 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  948444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948446 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948448 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948450 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948452 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948462 */     GIR_RootConstrainSelectedInstOperands,
     /*  948463 */     // GIR_Coverage, 63469,
     /*  948463 */     GIR_EraseRootFromParent_Done,
     /*  948464 */   // Label 14284: @948464
     /*  948464 */   GIM_Try, /*On fail goto*//*Label 14285*/ GIMT_Encode4(948546), // Rule ID 63480 //
     /*  948469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  948489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948496 */     // MIs[0] op1
     /*  948496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948523 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  948526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948528 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948530 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948532 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948534 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948544 */     GIR_RootConstrainSelectedInstOperands,
     /*  948545 */     // GIR_Coverage, 63480,
     /*  948545 */     GIR_EraseRootFromParent_Done,
     /*  948546 */   // Label 14285: @948546
     /*  948546 */   GIM_Try, /*On fail goto*//*Label 14286*/ GIMT_Encode4(948628), // Rule ID 63481 //
     /*  948551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  948571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948578 */     // MIs[0] op1
     /*  948578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948581 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  948608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948610 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948612 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948614 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948616 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948626 */     GIR_RootConstrainSelectedInstOperands,
     /*  948627 */     // GIR_Coverage, 63481,
     /*  948627 */     GIR_EraseRootFromParent_Done,
     /*  948628 */   // Label 14286: @948628
     /*  948628 */   GIM_Try, /*On fail goto*//*Label 14287*/ GIMT_Encode4(948710), // Rule ID 63492 //
     /*  948633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948660 */     // MIs[0] op1
     /*  948660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948687 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  948690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948692 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948694 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948696 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948698 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948708 */     GIR_RootConstrainSelectedInstOperands,
     /*  948709 */     // GIR_Coverage, 63492,
     /*  948709 */     GIR_EraseRootFromParent_Done,
     /*  948710 */   // Label 14287: @948710
     /*  948710 */   GIM_Try, /*On fail goto*//*Label 14288*/ GIMT_Encode4(948792), // Rule ID 63493 //
     /*  948715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  948723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  948726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  948729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  948732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  948735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948742 */     // MIs[0] op1
     /*  948742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  948750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  948758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  948762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948769 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M2:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M2),
     /*  948772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948774 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948776 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948778 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948780 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948790 */     GIR_RootConstrainSelectedInstOperands,
     /*  948791 */     // GIR_Coverage, 63493,
     /*  948791 */     GIR_EraseRootFromParent_Done,
     /*  948792 */   // Label 14288: @948792
     /*  948792 */   GIM_Try, /*On fail goto*//*Label 14289*/ GIMT_Encode4(948874), // Rule ID 63524 //
     /*  948797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  948808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  948811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  948814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  948817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948824 */     // MIs[0] op1
     /*  948824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948851 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  948851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  948854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948856 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948858 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948860 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948862 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948872 */     GIR_RootConstrainSelectedInstOperands,
     /*  948873 */     // GIR_Coverage, 63524,
     /*  948873 */     GIR_EraseRootFromParent_Done,
     /*  948874 */   // Label 14289: @948874
     /*  948874 */   GIM_Try, /*On fail goto*//*Label 14290*/ GIMT_Encode4(948956), // Rule ID 63525 //
     /*  948879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  948882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  948887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  948890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  948893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  948896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  948899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  948902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948906 */     // MIs[0] op1
     /*  948906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948909 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  948926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  948933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  948933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  948936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  948938 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  948940 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  948942 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  948944 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  948946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  948951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  948954 */     GIR_RootConstrainSelectedInstOperands,
     /*  948955 */     // GIR_Coverage, 63525,
     /*  948955 */     GIR_EraseRootFromParent_Done,
     /*  948956 */   // Label 14290: @948956
     /*  948956 */   GIM_Try, /*On fail goto*//*Label 14291*/ GIMT_Encode4(949038), // Rule ID 63536 //
     /*  948961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  948964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  948969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  948972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  948975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  948978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  948981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  948984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  948988 */     // MIs[0] op1
     /*  948988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  948991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  948996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949015 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  949018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949020 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949022 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949024 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949026 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949036 */     GIR_RootConstrainSelectedInstOperands,
     /*  949037 */     // GIR_Coverage, 63536,
     /*  949037 */     GIR_EraseRootFromParent_Done,
     /*  949038 */   // Label 14291: @949038
     /*  949038 */   GIM_Try, /*On fail goto*//*Label 14292*/ GIMT_Encode4(949120), // Rule ID 63537 //
     /*  949043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  949063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949070 */     // MIs[0] op1
     /*  949070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949073 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949097 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  949100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949102 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949104 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949106 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949108 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949118 */     GIR_RootConstrainSelectedInstOperands,
     /*  949119 */     // GIR_Coverage, 63537,
     /*  949119 */     GIR_EraseRootFromParent_Done,
     /*  949120 */   // Label 14292: @949120
     /*  949120 */   GIM_Try, /*On fail goto*//*Label 14293*/ GIMT_Encode4(949202), // Rule ID 63548 //
     /*  949125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949152 */     // MIs[0] op1
     /*  949152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949179 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  949182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949184 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949186 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949188 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949190 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949200 */     GIR_RootConstrainSelectedInstOperands,
     /*  949201 */     // GIR_Coverage, 63548,
     /*  949201 */     GIR_EraseRootFromParent_Done,
     /*  949202 */   // Label 14293: @949202
     /*  949202 */   GIM_Try, /*On fail goto*//*Label 14294*/ GIMT_Encode4(949284), // Rule ID 63549 //
     /*  949207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  949218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  949221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  949224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949234 */     // MIs[0] op1
     /*  949234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949237 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  949250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949261 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M4:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M4),
     /*  949264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949266 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949268 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949270 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949272 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949282 */     GIR_RootConstrainSelectedInstOperands,
     /*  949283 */     // GIR_Coverage, 63549,
     /*  949283 */     GIR_EraseRootFromParent_Done,
     /*  949284 */   // Label 14294: @949284
     /*  949284 */   GIM_Try, /*On fail goto*//*Label 14295*/ GIMT_Encode4(949366), // Rule ID 63580 //
     /*  949289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949316 */     // MIs[0] op1
     /*  949316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949319 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949343 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  949346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949348 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949350 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949352 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949354 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949364 */     GIR_RootConstrainSelectedInstOperands,
     /*  949365 */     // GIR_Coverage, 63580,
     /*  949365 */     GIR_EraseRootFromParent_Done,
     /*  949366 */   // Label 14295: @949366
     /*  949366 */   GIM_Try, /*On fail goto*//*Label 14296*/ GIMT_Encode4(949448), // Rule ID 63581 //
     /*  949371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949398 */     // MIs[0] op1
     /*  949398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949425 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  949428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949430 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949432 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949434 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949436 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949446 */     GIR_RootConstrainSelectedInstOperands,
     /*  949447 */     // GIR_Coverage, 63581,
     /*  949447 */     GIR_EraseRootFromParent_Done,
     /*  949448 */   // Label 14296: @949448
     /*  949448 */   GIM_Try, /*On fail goto*//*Label 14297*/ GIMT_Encode4(949530), // Rule ID 63592 //
     /*  949453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  949473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949480 */     // MIs[0] op1
     /*  949480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949507 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  949510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949512 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949514 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949516 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949518 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949528 */     GIR_RootConstrainSelectedInstOperands,
     /*  949529 */     // GIR_Coverage, 63592,
     /*  949529 */     GIR_EraseRootFromParent_Done,
     /*  949530 */   // Label 14297: @949530
     /*  949530 */   GIM_Try, /*On fail goto*//*Label 14298*/ GIMT_Encode4(949612), // Rule ID 63593 //
     /*  949535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s16,
     /*  949555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949562 */     // MIs[0] op1
     /*  949562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949589 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, VRM8:{ *:[nxv32i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  949592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949594 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949596 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949598 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949600 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949610 */     GIR_RootConstrainSelectedInstOperands,
     /*  949611 */     // GIR_Coverage, 63593,
     /*  949611 */     GIR_EraseRootFromParent_Done,
     /*  949612 */   // Label 14298: @949612
     /*  949612 */   GIM_Try, /*On fail goto*//*Label 14299*/ GIMT_Encode4(949694), // Rule ID 63604 //
     /*  949617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949644 */     // MIs[0] op1
     /*  949644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949647 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949671 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  949671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  949674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949676 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949678 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949680 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949682 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949692 */     GIR_RootConstrainSelectedInstOperands,
     /*  949693 */     // GIR_Coverage, 63604,
     /*  949693 */     GIR_EraseRootFromParent_Done,
     /*  949694 */   // Label 14299: @949694
     /*  949694 */   GIM_Try, /*On fail goto*//*Label 14300*/ GIMT_Encode4(949776), // Rule ID 63605 //
     /*  949699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  949707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  949710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  949713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /*  949716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  949719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949726 */     // MIs[0] op1
     /*  949726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949729 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  949734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  949742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  949746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949753 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VV_M8:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM8:{ *:[nxv32i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  949753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VV_M8),
     /*  949756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949758 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949760 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949762 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949764 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  949774 */     GIR_RootConstrainSelectedInstOperands,
     /*  949775 */     // GIR_Coverage, 63605,
     /*  949775 */     GIR_EraseRootFromParent_Done,
     /*  949776 */   // Label 14300: @949776
     /*  949776 */   GIM_Try, /*On fail goto*//*Label 14301*/ GIMT_Encode4(949858), // Rule ID 63636 //
     /*  949781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  949792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  949795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  949798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  949801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949808 */     // MIs[0] op1
     /*  949808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  949838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949840 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949842 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949844 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949846 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949856 */     GIR_RootConstrainSelectedInstOperands,
     /*  949857 */     // GIR_Coverage, 63636,
     /*  949857 */     GIR_EraseRootFromParent_Done,
     /*  949858 */   // Label 14301: @949858
     /*  949858 */   GIM_Try, /*On fail goto*//*Label 14302*/ GIMT_Encode4(949940), // Rule ID 63637 //
     /*  949863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  949866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  949871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  949874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  949877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  949880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  949883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  949886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949890 */     // MIs[0] op1
     /*  949890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949893 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  949910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949917 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  949917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  949920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  949922 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  949924 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  949926 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  949928 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  949930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  949935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  949938 */     GIR_RootConstrainSelectedInstOperands,
     /*  949939 */     // GIR_Coverage, 63637,
     /*  949939 */     GIR_EraseRootFromParent_Done,
     /*  949940 */   // Label 14302: @949940
     /*  949940 */   GIM_Try, /*On fail goto*//*Label 14303*/ GIMT_Encode4(950022), // Rule ID 63648 //
     /*  949945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  949948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  949953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  949956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  949959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  949962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  949965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  949968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949972 */     // MIs[0] op1
     /*  949972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  949975 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  949980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  949992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  949999 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  949999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  950002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950004 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950006 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950008 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950010 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950020 */     GIR_RootConstrainSelectedInstOperands,
     /*  950021 */     // GIR_Coverage, 63648,
     /*  950021 */     GIR_EraseRootFromParent_Done,
     /*  950022 */   // Label 14303: @950022
     /*  950022 */   GIM_Try, /*On fail goto*//*Label 14304*/ GIMT_Encode4(950104), // Rule ID 63649 //
     /*  950027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  950047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950054 */     // MIs[0] op1
     /*  950054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950057 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950081 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  950084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950086 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950088 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950090 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950092 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950102 */     GIR_RootConstrainSelectedInstOperands,
     /*  950103 */     // GIR_Coverage, 63649,
     /*  950103 */     GIR_EraseRootFromParent_Done,
     /*  950104 */   // Label 14304: @950104
     /*  950104 */   GIM_Try, /*On fail goto*//*Label 14305*/ GIMT_Encode4(950186), // Rule ID 63660 //
     /*  950109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950136 */     // MIs[0] op1
     /*  950136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950163 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  950166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950168 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950170 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950172 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950174 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950184 */     GIR_RootConstrainSelectedInstOperands,
     /*  950185 */     // GIR_Coverage, 63660,
     /*  950185 */     GIR_EraseRootFromParent_Done,
     /*  950186 */   // Label 14305: @950186
     /*  950186 */   GIM_Try, /*On fail goto*//*Label 14306*/ GIMT_Encode4(950268), // Rule ID 63661 //
     /*  950191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  950202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  950205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  950208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950218 */     // MIs[0] op1
     /*  950218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  950234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M2:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M2),
     /*  950248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950250 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950252 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950254 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950256 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950266 */     GIR_RootConstrainSelectedInstOperands,
     /*  950267 */     // GIR_Coverage, 63661,
     /*  950267 */     GIR_EraseRootFromParent_Done,
     /*  950268 */   // Label 14306: @950268
     /*  950268 */   GIM_Try, /*On fail goto*//*Label 14307*/ GIMT_Encode4(950350), // Rule ID 63692 //
     /*  950273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950300 */     // MIs[0] op1
     /*  950300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950327 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  950330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950332 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950334 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950336 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950338 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950348 */     GIR_RootConstrainSelectedInstOperands,
     /*  950349 */     // GIR_Coverage, 63692,
     /*  950349 */     GIR_EraseRootFromParent_Done,
     /*  950350 */   // Label 14307: @950350
     /*  950350 */   GIM_Try, /*On fail goto*//*Label 14308*/ GIMT_Encode4(950432), // Rule ID 63693 //
     /*  950355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950382 */     // MIs[0] op1
     /*  950382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950409 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  950412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950414 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950416 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950418 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950420 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950430 */     GIR_RootConstrainSelectedInstOperands,
     /*  950431 */     // GIR_Coverage, 63693,
     /*  950431 */     GIR_EraseRootFromParent_Done,
     /*  950432 */   // Label 14308: @950432
     /*  950432 */   GIM_Try, /*On fail goto*//*Label 14309*/ GIMT_Encode4(950514), // Rule ID 63704 //
     /*  950437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  950457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950464 */     // MIs[0] op1
     /*  950464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950491 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  950494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950496 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950498 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950500 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950502 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950512 */     GIR_RootConstrainSelectedInstOperands,
     /*  950513 */     // GIR_Coverage, 63704,
     /*  950513 */     GIR_EraseRootFromParent_Done,
     /*  950514 */   // Label 14309: @950514
     /*  950514 */   GIM_Try, /*On fail goto*//*Label 14310*/ GIMT_Encode4(950596), // Rule ID 63705 //
     /*  950519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  950539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950546 */     // MIs[0] op1
     /*  950546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950573 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  950576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950578 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950580 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950582 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950584 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950594 */     GIR_RootConstrainSelectedInstOperands,
     /*  950595 */     // GIR_Coverage, 63705,
     /*  950595 */     GIR_EraseRootFromParent_Done,
     /*  950596 */   // Label 14310: @950596
     /*  950596 */   GIM_Try, /*On fail goto*//*Label 14311*/ GIMT_Encode4(950678), // Rule ID 63716 //
     /*  950601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950628 */     // MIs[0] op1
     /*  950628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950655 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  950658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950660 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950662 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950664 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950666 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950676 */     GIR_RootConstrainSelectedInstOperands,
     /*  950677 */     // GIR_Coverage, 63716,
     /*  950677 */     GIR_EraseRootFromParent_Done,
     /*  950678 */   // Label 14311: @950678
     /*  950678 */   GIM_Try, /*On fail goto*//*Label 14312*/ GIMT_Encode4(950760), // Rule ID 63717 //
     /*  950683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  950691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  950694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  950697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  950700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950710 */     // MIs[0] op1
     /*  950710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  950718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  950726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  950730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950737 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M4:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M4),
     /*  950740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950742 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950744 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950746 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950748 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950758 */     GIR_RootConstrainSelectedInstOperands,
     /*  950759 */     // GIR_Coverage, 63717,
     /*  950759 */     GIR_EraseRootFromParent_Done,
     /*  950760 */   // Label 14312: @950760
     /*  950760 */   GIM_Try, /*On fail goto*//*Label 14313*/ GIMT_Encode4(950842), // Rule ID 63748 //
     /*  950765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  950776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  950779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  950782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  950785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950792 */     // MIs[0] op1
     /*  950792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950795 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950819 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  950822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950824 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950826 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950828 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950830 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950840 */     GIR_RootConstrainSelectedInstOperands,
     /*  950841 */     // GIR_Coverage, 63748,
     /*  950841 */     GIR_EraseRootFromParent_Done,
     /*  950842 */   // Label 14313: @950842
     /*  950842 */   GIM_Try, /*On fail goto*//*Label 14314*/ GIMT_Encode4(950924), // Rule ID 63749 //
     /*  950847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  950850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  950855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  950858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  950861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  950864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  950867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  950870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950874 */     // MIs[0] op1
     /*  950874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  950894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950901 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  950901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  950904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950906 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950908 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950910 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950912 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  950919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  950922 */     GIR_RootConstrainSelectedInstOperands,
     /*  950923 */     // GIR_Coverage, 63749,
     /*  950923 */     GIR_EraseRootFromParent_Done,
     /*  950924 */   // Label 14314: @950924
     /*  950924 */   GIM_Try, /*On fail goto*//*Label 14315*/ GIMT_Encode4(951006), // Rule ID 63760 //
     /*  950929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  950932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  950937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  950940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  950943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  950946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  950949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  950952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950956 */     // MIs[0] op1
     /*  950956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  950959 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  950964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  950976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  950983 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  950983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  950986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  950988 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  950990 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  950992 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  950994 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  950996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951004 */     GIR_RootConstrainSelectedInstOperands,
     /*  951005 */     // GIR_Coverage, 63760,
     /*  951005 */     GIR_EraseRootFromParent_Done,
     /*  951006 */   // Label 14315: @951006
     /*  951006 */   GIM_Try, /*On fail goto*//*Label 14316*/ GIMT_Encode4(951088), // Rule ID 63761 //
     /*  951011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s32,
     /*  951031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951038 */     // MIs[0] op1
     /*  951038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, VRM8:{ *:[nxv16i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  951068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951070 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951072 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951074 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951076 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951086 */     GIR_RootConstrainSelectedInstOperands,
     /*  951087 */     // GIR_Coverage, 63761,
     /*  951087 */     GIR_EraseRootFromParent_Done,
     /*  951088 */   // Label 14316: @951088
     /*  951088 */   GIM_Try, /*On fail goto*//*Label 14317*/ GIMT_Encode4(951170), // Rule ID 63772 //
     /*  951093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951120 */     // MIs[0] op1
     /*  951120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951147 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  951147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  951150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951152 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951154 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951156 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951158 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951168 */     GIR_RootConstrainSelectedInstOperands,
     /*  951169 */     // GIR_Coverage, 63772,
     /*  951169 */     GIR_EraseRootFromParent_Done,
     /*  951170 */   // Label 14317: @951170
     /*  951170 */   GIM_Try, /*On fail goto*//*Label 14318*/ GIMT_Encode4(951252), // Rule ID 63773 //
     /*  951175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  951186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  951189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /*  951192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951202 */     // MIs[0] op1
     /*  951202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  951218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  951222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951229 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VV_M8:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM8:{ *:[nxv16i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  951229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VV_M8),
     /*  951232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951234 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951236 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951238 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951240 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  951250 */     GIR_RootConstrainSelectedInstOperands,
     /*  951251 */     // GIR_Coverage, 63773,
     /*  951251 */     GIR_EraseRootFromParent_Done,
     /*  951252 */   // Label 14318: @951252
     /*  951252 */   GIM_Try, /*On fail goto*//*Label 14319*/ GIMT_Encode4(951334), // Rule ID 63804 //
     /*  951257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951284 */     // MIs[0] op1
     /*  951284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951311 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951316 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951318 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951320 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951322 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951332 */     GIR_RootConstrainSelectedInstOperands,
     /*  951333 */     // GIR_Coverage, 63804,
     /*  951333 */     GIR_EraseRootFromParent_Done,
     /*  951334 */   // Label 14319: @951334
     /*  951334 */   GIM_Try, /*On fail goto*//*Label 14320*/ GIMT_Encode4(951416), // Rule ID 63805 //
     /*  951339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951366 */     // MIs[0] op1
     /*  951366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951369 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M2),
     /*  951396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951398 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951400 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951402 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951404 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951414 */     GIR_RootConstrainSelectedInstOperands,
     /*  951415 */     // GIR_Coverage, 63805,
     /*  951415 */     GIR_EraseRootFromParent_Done,
     /*  951416 */   // Label 14320: @951416
     /*  951416 */   GIM_Try, /*On fail goto*//*Label 14321*/ GIMT_Encode4(951498), // Rule ID 63816 //
     /*  951421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  951441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951448 */     // MIs[0] op1
     /*  951448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951451 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951475 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951480 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951482 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951484 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951486 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951496 */     GIR_RootConstrainSelectedInstOperands,
     /*  951497 */     // GIR_Coverage, 63816,
     /*  951497 */     GIR_EraseRootFromParent_Done,
     /*  951498 */   // Label 14321: @951498
     /*  951498 */   GIM_Try, /*On fail goto*//*Label 14322*/ GIMT_Encode4(951580), // Rule ID 63817 //
     /*  951503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /*  951523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951530 */     // MIs[0] op1
     /*  951530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951533 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951557 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, VRM2:{ *:[nxv2i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M2),
     /*  951560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951562 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951564 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951566 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951568 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951578 */     GIR_RootConstrainSelectedInstOperands,
     /*  951579 */     // GIR_Coverage, 63817,
     /*  951579 */     GIR_EraseRootFromParent_Done,
     /*  951580 */   // Label 14322: @951580
     /*  951580 */   GIM_Try, /*On fail goto*//*Label 14323*/ GIMT_Encode4(951662), // Rule ID 63828 //
     /*  951585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951612 */     // MIs[0] op1
     /*  951612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951639 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  951642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951644 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951646 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951648 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951650 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951660 */     GIR_RootConstrainSelectedInstOperands,
     /*  951661 */     // GIR_Coverage, 63828,
     /*  951661 */     GIR_EraseRootFromParent_Done,
     /*  951662 */   // Label 14323: @951662
     /*  951662 */   GIM_Try, /*On fail goto*//*Label 14324*/ GIMT_Encode4(951744), // Rule ID 63829 //
     /*  951667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  951675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  951678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  951681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /*  951684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951694 */     // MIs[0] op1
     /*  951694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951697 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  951702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  951710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  951714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951721 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M2:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VRM2:{ *:[nxv2i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M2),
     /*  951724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951726 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951728 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951730 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951732 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951742 */     GIR_RootConstrainSelectedInstOperands,
     /*  951743 */     // GIR_Coverage, 63829,
     /*  951743 */     GIR_EraseRootFromParent_Done,
     /*  951744 */   // Label 14324: @951744
     /*  951744 */   GIM_Try, /*On fail goto*//*Label 14325*/ GIMT_Encode4(951826), // Rule ID 63860 //
     /*  951749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  951760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  951763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  951766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  951769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951776 */     // MIs[0] op1
     /*  951776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951803 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  951806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951808 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951810 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951812 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951814 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951824 */     GIR_RootConstrainSelectedInstOperands,
     /*  951825 */     // GIR_Coverage, 63860,
     /*  951825 */     GIR_EraseRootFromParent_Done,
     /*  951826 */   // Label 14325: @951826
     /*  951826 */   GIM_Try, /*On fail goto*//*Label 14326*/ GIMT_Encode4(951908), // Rule ID 63861 //
     /*  951831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  951839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  951842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  951845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  951848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  951851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  951854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951858 */     // MIs[0] op1
     /*  951858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951861 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  951878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951885 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  951885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M4),
     /*  951888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951890 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951892 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951894 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951896 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951906 */     GIR_RootConstrainSelectedInstOperands,
     /*  951907 */     // GIR_Coverage, 63861,
     /*  951907 */     GIR_EraseRootFromParent_Done,
     /*  951908 */   // Label 14326: @951908
     /*  951908 */   GIM_Try, /*On fail goto*//*Label 14327*/ GIMT_Encode4(951990), // Rule ID 63872 //
     /*  951913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  951916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  951921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  951924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  951927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  951930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  951933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  951936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951940 */     // MIs[0] op1
     /*  951940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  951943 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  951948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  951960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  951967 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  951967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  951970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  951972 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  951974 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  951976 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  951978 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  951980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  951985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  951988 */     GIR_RootConstrainSelectedInstOperands,
     /*  951989 */     // GIR_Coverage, 63872,
     /*  951989 */     GIR_EraseRootFromParent_Done,
     /*  951990 */   // Label 14327: @951990
     /*  951990 */   GIM_Try, /*On fail goto*//*Label 14328*/ GIMT_Encode4(952072), // Rule ID 63873 //
     /*  951995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  951998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s64,
     /*  952015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952022 */     // MIs[0] op1
     /*  952022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952049 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, VRM4:{ *:[nxv4i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M4),
     /*  952052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952054 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952056 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952058 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952060 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952070 */     GIR_RootConstrainSelectedInstOperands,
     /*  952071 */     // GIR_Coverage, 63873,
     /*  952071 */     GIR_EraseRootFromParent_Done,
     /*  952072 */   // Label 14328: @952072
     /*  952072 */   GIM_Try, /*On fail goto*//*Label 14329*/ GIMT_Encode4(952154), // Rule ID 63884 //
     /*  952077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952104 */     // MIs[0] op1
     /*  952104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952131 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  952134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952136 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952138 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952140 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952142 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952152 */     GIR_RootConstrainSelectedInstOperands,
     /*  952153 */     // GIR_Coverage, 63884,
     /*  952153 */     GIR_EraseRootFromParent_Done,
     /*  952154 */   // Label 14329: @952154
     /*  952154 */   GIM_Try, /*On fail goto*//*Label 14330*/ GIMT_Encode4(952236), // Rule ID 63885 //
     /*  952159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  952170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  952173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /*  952176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952186 */     // MIs[0] op1
     /*  952186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  952202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952213 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M4:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM4:{ *:[nxv4i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M4),
     /*  952216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952218 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952220 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952222 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952224 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952234 */     GIR_RootConstrainSelectedInstOperands,
     /*  952235 */     // GIR_Coverage, 63885,
     /*  952235 */     GIR_EraseRootFromParent_Done,
     /*  952236 */   // Label 14330: @952236
     /*  952236 */   GIM_Try, /*On fail goto*//*Label 14331*/ GIMT_Encode4(952318), // Rule ID 63916 //
     /*  952241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952268 */     // MIs[0] op1
     /*  952268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952271 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952295 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952300 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952302 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952304 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952306 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952316 */     GIR_RootConstrainSelectedInstOperands,
     /*  952317 */     // GIR_Coverage, 63916,
     /*  952317 */     GIR_EraseRootFromParent_Done,
     /*  952318 */   // Label 14331: @952318
     /*  952318 */   GIM_Try, /*On fail goto*//*Label 14332*/ GIMT_Encode4(952400), // Rule ID 63917 //
     /*  952323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvv),
     /*  952331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952350 */     // MIs[0] op1
     /*  952350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952377 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11016:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVV_M8),
     /*  952380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952382 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952384 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952386 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952388 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952398 */     GIR_RootConstrainSelectedInstOperands,
     /*  952399 */     // GIR_Coverage, 63917,
     /*  952399 */     GIR_EraseRootFromParent_Done,
     /*  952400 */   // Label 14332: @952400
     /*  952400 */   GIM_Try, /*On fail goto*//*Label 14333*/ GIMT_Encode4(952482), // Rule ID 63928 //
     /*  952405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  952425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952432 */     // MIs[0] op1
     /*  952432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952459 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952464 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952466 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952468 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952470 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952480 */     GIR_RootConstrainSelectedInstOperands,
     /*  952481 */     // GIR_Coverage, 63928,
     /*  952481 */     GIR_EraseRootFromParent_Done,
     /*  952482 */   // Label 14333: @952482
     /*  952482 */   GIM_Try, /*On fail goto*//*Label 14334*/ GIMT_Encode4(952564), // Rule ID 63929 //
     /*  952487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvv),
     /*  952495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s64,
     /*  952507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952514 */     // MIs[0] op1
     /*  952514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952541 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11008:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, VRM8:{ *:[nxv8i64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVV_M8),
     /*  952544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952546 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952548 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952550 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952552 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952562 */     GIR_RootConstrainSelectedInstOperands,
     /*  952563 */     // GIR_Coverage, 63929,
     /*  952563 */     GIR_EraseRootFromParent_Done,
     /*  952564 */   // Label 14334: @952564
     /*  952564 */   GIM_Try, /*On fail goto*//*Label 14335*/ GIMT_Encode4(952646), // Rule ID 63940 //
     /*  952569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952596 */     // MIs[0] op1
     /*  952596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952599 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952623 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  952623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  952626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952628 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952630 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952632 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952634 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952644 */     GIR_RootConstrainSelectedInstOperands,
     /*  952645 */     // GIR_Coverage, 63940,
     /*  952645 */     GIR_EraseRootFromParent_Done,
     /*  952646 */   // Label 14335: @952646
     /*  952646 */   GIM_Try, /*On fail goto*//*Label 14336*/ GIMT_Encode4(952728), // Rule ID 63941 //
     /*  952651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvv),
     /*  952659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  952662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  952665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /*  952668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952678 */     // MIs[0] op1
     /*  952678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  952686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  952694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /*  952698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952705 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10994:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR64VV_M8:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM8:{ *:[nxv8i64] }:$op3, FPR64:{ *:[f64] }:$op4, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  952705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR64VV_M8),
     /*  952708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952710 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952712 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952714 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952716 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  952726 */     GIR_RootConstrainSelectedInstOperands,
     /*  952727 */     // GIR_Coverage, 63941,
     /*  952727 */     GIR_EraseRootFromParent_Done,
     /*  952728 */   // Label 14336: @952728
     /*  952728 */   GIM_Try, /*On fail goto*//*Label 14337*/ GIMT_Encode4(952810), // Rule ID 63946 //
     /*  952733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  952741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  952744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  952747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  952750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  952753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952760 */     // MIs[0] op1
     /*  952760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952787 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  952790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952792 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952794 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952796 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952798 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952808 */     GIR_RootConstrainSelectedInstOperands,
     /*  952809 */     // GIR_Coverage, 63946,
     /*  952809 */     GIR_EraseRootFromParent_Done,
     /*  952810 */   // Label 14337: @952810
     /*  952810 */   GIM_Try, /*On fail goto*//*Label 14338*/ GIMT_Encode4(952892), // Rule ID 63947 //
     /*  952815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  952823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  952826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  952829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  952832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  952835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  952838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952842 */     // MIs[0] op1
     /*  952842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  952862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952869 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  952869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF8),
     /*  952872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952874 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952876 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952878 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952880 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952890 */     GIR_RootConstrainSelectedInstOperands,
     /*  952891 */     // GIR_Coverage, 63947,
     /*  952891 */     GIR_EraseRootFromParent_Done,
     /*  952892 */   // Label 14338: @952892
     /*  952892 */   GIM_Try, /*On fail goto*//*Label 14339*/ GIMT_Encode4(952974), // Rule ID 63958 //
     /*  952897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  952900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  952905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  952908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  952911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  952914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  952917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  952920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952924 */     // MIs[0] op1
     /*  952924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  952927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  952932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  952944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  952951 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  952951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  952954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  952956 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  952958 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  952960 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  952962 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  952964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  952969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  952972 */     GIR_RootConstrainSelectedInstOperands,
     /*  952973 */     // GIR_Coverage, 63958,
     /*  952973 */     GIR_EraseRootFromParent_Done,
     /*  952974 */   // Label 14339: @952974
     /*  952974 */   GIM_Try, /*On fail goto*//*Label 14340*/ GIMT_Encode4(953056), // Rule ID 63959 //
     /*  952979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  952982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  952987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  952990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  952993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  952996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s8,
     /*  952999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953006 */     // MIs[0] op1
     /*  953006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953009 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953033 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF8:{ *:[nxv1i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i16] }:$op2, VR:{ *:[nxv1i8] }:$op3, VR:{ *:[nxv1i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF8),
     /*  953036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953038 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953040 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953042 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953044 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953054 */     GIR_RootConstrainSelectedInstOperands,
     /*  953055 */     // GIR_Coverage, 63959,
     /*  953055 */     GIR_EraseRootFromParent_Done,
     /*  953056 */   // Label 14340: @953056
     /*  953056 */   GIM_Try, /*On fail goto*//*Label 14341*/ GIMT_Encode4(953138), // Rule ID 63964 //
     /*  953061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953088 */     // MIs[0] op1
     /*  953088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953115 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  953118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953120 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953122 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953124 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953126 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953136 */     GIR_RootConstrainSelectedInstOperands,
     /*  953137 */     // GIR_Coverage, 63964,
     /*  953137 */     GIR_EraseRootFromParent_Done,
     /*  953138 */   // Label 14341: @953138
     /*  953138 */   GIM_Try, /*On fail goto*//*Label 14342*/ GIMT_Encode4(953220), // Rule ID 63965 //
     /*  953143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953170 */     // MIs[0] op1
     /*  953170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953173 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953197 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  953200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953202 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953204 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953206 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953208 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953218 */     GIR_RootConstrainSelectedInstOperands,
     /*  953219 */     // GIR_Coverage, 63965,
     /*  953219 */     GIR_EraseRootFromParent_Done,
     /*  953220 */   // Label 14342: @953220
     /*  953220 */   GIM_Try, /*On fail goto*//*Label 14343*/ GIMT_Encode4(953302), // Rule ID 63976 //
     /*  953225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953252 */     // MIs[0] op1
     /*  953252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  953282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953284 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953286 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953288 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953290 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953300 */     GIR_RootConstrainSelectedInstOperands,
     /*  953301 */     // GIR_Coverage, 63976,
     /*  953301 */     GIR_EraseRootFromParent_Done,
     /*  953302 */   // Label 14343: @953302
     /*  953302 */   GIM_Try, /*On fail goto*//*Label 14344*/ GIMT_Encode4(953384), // Rule ID 63977 //
     /*  953307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  953318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  953321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /*  953324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s8,
     /*  953327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953334 */     // MIs[0] op1
     /*  953334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953337 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953361 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv2i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i16] }:$op2, VR:{ *:[nxv2i8] }:$op3, VR:{ *:[nxv2i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  953364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953366 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953368 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953370 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953372 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953382 */     GIR_RootConstrainSelectedInstOperands,
     /*  953383 */     // GIR_Coverage, 63977,
     /*  953383 */     GIR_EraseRootFromParent_Done,
     /*  953384 */   // Label 14344: @953384
     /*  953384 */   GIM_Try, /*On fail goto*//*Label 14345*/ GIMT_Encode4(953466), // Rule ID 63982 //
     /*  953389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953416 */     // MIs[0] op1
     /*  953416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953419 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953443 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  953446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953448 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953450 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953452 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953454 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953464 */     GIR_RootConstrainSelectedInstOperands,
     /*  953465 */     // GIR_Coverage, 63982,
     /*  953465 */     GIR_EraseRootFromParent_Done,
     /*  953466 */   // Label 14345: @953466
     /*  953466 */   GIM_Try, /*On fail goto*//*Label 14346*/ GIMT_Encode4(953548), // Rule ID 63983 //
     /*  953471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953498 */     // MIs[0] op1
     /*  953498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  953528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953530 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953532 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953534 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953536 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953546 */     GIR_RootConstrainSelectedInstOperands,
     /*  953547 */     // GIR_Coverage, 63983,
     /*  953547 */     GIR_EraseRootFromParent_Done,
     /*  953548 */   // Label 14346: @953548
     /*  953548 */   GIM_Try, /*On fail goto*//*Label 14347*/ GIMT_Encode4(953630), // Rule ID 63994 //
     /*  953553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  953573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953580 */     // MIs[0] op1
     /*  953580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953583 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953607 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  953610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953612 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953614 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953616 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953618 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953628 */     GIR_RootConstrainSelectedInstOperands,
     /*  953629 */     // GIR_Coverage, 63994,
     /*  953629 */     GIR_EraseRootFromParent_Done,
     /*  953630 */   // Label 14347: @953630
     /*  953630 */   GIM_Try, /*On fail goto*//*Label 14348*/ GIMT_Encode4(953712), // Rule ID 63995 //
     /*  953635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  953646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  953649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /*  953652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s8,
     /*  953655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953662 */     // MIs[0] op1
     /*  953662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953689 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv4i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv4i16] }:$op2, VR:{ *:[nxv4i8] }:$op3, VR:{ *:[nxv4i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  953692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953694 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953696 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953698 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953700 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953710 */     GIR_RootConstrainSelectedInstOperands,
     /*  953711 */     // GIR_Coverage, 63995,
     /*  953711 */     GIR_EraseRootFromParent_Done,
     /*  953712 */   // Label 14348: @953712
     /*  953712 */   GIM_Try, /*On fail goto*//*Label 14349*/ GIMT_Encode4(953794), // Rule ID 64000 //
     /*  953717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  953734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  953737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953744 */     // MIs[0] op1
     /*  953744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953747 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  953774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953776 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953778 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953780 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953782 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953792 */     GIR_RootConstrainSelectedInstOperands,
     /*  953793 */     // GIR_Coverage, 64000,
     /*  953793 */     GIR_EraseRootFromParent_Done,
     /*  953794 */   // Label 14349: @953794
     /*  953794 */   GIM_Try, /*On fail goto*//*Label 14350*/ GIMT_Encode4(953876), // Rule ID 64001 //
     /*  953799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  953807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  953816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  953819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953826 */     // MIs[0] op1
     /*  953826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  953846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  953853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  953856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953858 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953860 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953862 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953864 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953874 */     GIR_RootConstrainSelectedInstOperands,
     /*  953875 */     // GIR_Coverage, 64001,
     /*  953875 */     GIR_EraseRootFromParent_Done,
     /*  953876 */   // Label 14350: @953876
     /*  953876 */   GIM_Try, /*On fail goto*//*Label 14351*/ GIMT_Encode4(953958), // Rule ID 64012 //
     /*  953881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  953884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  953898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  953901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  953904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953908 */     // MIs[0] op1
     /*  953908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  953928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  953935 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  953935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  953938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  953940 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  953942 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  953944 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  953946 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  953948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  953953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  953956 */     GIR_RootConstrainSelectedInstOperands,
     /*  953957 */     // GIR_Coverage, 64012,
     /*  953957 */     GIR_EraseRootFromParent_Done,
     /*  953958 */   // Label 14351: @953958
     /*  953958 */   GIM_Try, /*On fail goto*//*Label 14352*/ GIMT_Encode4(954040), // Rule ID 64013 //
     /*  953963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  953966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  953971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  953974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  953977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /*  953980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s8,
     /*  953983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  953986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  953990 */     // MIs[0] op1
     /*  953990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  953993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  953998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954017 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv8i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv8i16] }:$op2, VR:{ *:[nxv8i8] }:$op3, VR:{ *:[nxv8i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  954020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954022 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954024 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954026 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954028 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954038 */     GIR_RootConstrainSelectedInstOperands,
     /*  954039 */     // GIR_Coverage, 64013,
     /*  954039 */     GIR_EraseRootFromParent_Done,
     /*  954040 */   // Label 14352: @954040
     /*  954040 */   GIM_Try, /*On fail goto*//*Label 14353*/ GIMT_Encode4(954122), // Rule ID 64018 //
     /*  954045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954072 */     // MIs[0] op1
     /*  954072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954075 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954099 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  954102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954104 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954106 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954108 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954110 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954120 */     GIR_RootConstrainSelectedInstOperands,
     /*  954121 */     // GIR_Coverage, 64018,
     /*  954121 */     GIR_EraseRootFromParent_Done,
     /*  954122 */   // Label 14353: @954122
     /*  954122 */   GIM_Try, /*On fail goto*//*Label 14354*/ GIMT_Encode4(954204), // Rule ID 64019 //
     /*  954127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954154 */     // MIs[0] op1
     /*  954154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954157 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954181 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  954184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954186 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954188 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954190 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954192 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954202 */     GIR_RootConstrainSelectedInstOperands,
     /*  954203 */     // GIR_Coverage, 64019,
     /*  954203 */     GIR_EraseRootFromParent_Done,
     /*  954204 */   // Label 14354: @954204
     /*  954204 */   GIM_Try, /*On fail goto*//*Label 14355*/ GIMT_Encode4(954286), // Rule ID 64030 //
     /*  954209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954236 */     // MIs[0] op1
     /*  954236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954263 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  954266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954268 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954270 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954272 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954274 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954284 */     GIR_RootConstrainSelectedInstOperands,
     /*  954285 */     // GIR_Coverage, 64030,
     /*  954285 */     GIR_EraseRootFromParent_Done,
     /*  954286 */   // Label 14355: @954286
     /*  954286 */   GIM_Try, /*On fail goto*//*Label 14356*/ GIMT_Encode4(954368), // Rule ID 64031 //
     /*  954291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  954302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  954305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /*  954308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /*  954311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954318 */     // MIs[0] op1
     /*  954318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  954338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954345 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv16i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv16i16] }:$op2, VRM2:{ *:[nxv16i8] }:$op3, VRM2:{ *:[nxv16i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  954348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954350 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954352 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954354 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954356 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954366 */     GIR_RootConstrainSelectedInstOperands,
     /*  954367 */     // GIR_Coverage, 64031,
     /*  954367 */     GIR_EraseRootFromParent_Done,
     /*  954368 */   // Label 14356: @954368
     /*  954368 */   GIM_Try, /*On fail goto*//*Label 14357*/ GIMT_Encode4(954450), // Rule ID 64036 //
     /*  954373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954400 */     // MIs[0] op1
     /*  954400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954403 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954427 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  954430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954432 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954434 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954436 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954438 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954448 */     GIR_RootConstrainSelectedInstOperands,
     /*  954449 */     // GIR_Coverage, 64036,
     /*  954449 */     GIR_EraseRootFromParent_Done,
     /*  954450 */   // Label 14357: @954450
     /*  954450 */   GIM_Try, /*On fail goto*//*Label 14358*/ GIMT_Encode4(954532), // Rule ID 64037 //
     /*  954455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954482 */     // MIs[0] op1
     /*  954482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954509 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  954512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954514 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954516 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954518 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954520 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954530 */     GIR_RootConstrainSelectedInstOperands,
     /*  954531 */     // GIR_Coverage, 64037,
     /*  954531 */     GIR_EraseRootFromParent_Done,
     /*  954532 */   // Label 14358: @954532
     /*  954532 */   GIM_Try, /*On fail goto*//*Label 14359*/ GIMT_Encode4(954614), // Rule ID 64048 //
     /*  954537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  954557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954564 */     // MIs[0] op1
     /*  954564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954567 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954591 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  954591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  954594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954596 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954598 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954600 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954602 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954612 */     GIR_RootConstrainSelectedInstOperands,
     /*  954613 */     // GIR_Coverage, 64048,
     /*  954613 */     GIR_EraseRootFromParent_Done,
     /*  954614 */   // Label 14359: @954614
     /*  954614 */   GIM_Try, /*On fail goto*//*Label 14360*/ GIMT_Encode4(954696), // Rule ID 64049 //
     /*  954619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  954630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  954633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /*  954636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s8,
     /*  954639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954646 */     // MIs[0] op1
     /*  954646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  954658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  954666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954673 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv32i16] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv32i16] }:$op2, VRM4:{ *:[nxv32i8] }:$op3, VRM4:{ *:[nxv32i8] }:$op4, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  954673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  954676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954678 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954680 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954682 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954684 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  954694 */     GIR_RootConstrainSelectedInstOperands,
     /*  954695 */     // GIR_Coverage, 64049,
     /*  954695 */     GIR_EraseRootFromParent_Done,
     /*  954696 */   // Label 14360: @954696
     /*  954696 */   GIM_Try, /*On fail goto*//*Label 14361*/ GIMT_Encode4(954778), // Rule ID 64054 //
     /*  954701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  954712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  954715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  954718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  954721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954728 */     // MIs[0] op1
     /*  954728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954755 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  954755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  954758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954760 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954762 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954764 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954766 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954776 */     GIR_RootConstrainSelectedInstOperands,
     /*  954777 */     // GIR_Coverage, 64054,
     /*  954777 */     GIR_EraseRootFromParent_Done,
     /*  954778 */   // Label 14361: @954778
     /*  954778 */   GIM_Try, /*On fail goto*//*Label 14362*/ GIMT_Encode4(954860), // Rule ID 64055 //
     /*  954783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  954791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  954794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  954797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  954800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  954803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954810 */     // MIs[0] op1
     /*  954810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954813 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  954830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  954837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF4),
     /*  954840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954842 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954844 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954846 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954848 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954858 */     GIR_RootConstrainSelectedInstOperands,
     /*  954859 */     // GIR_Coverage, 64055,
     /*  954859 */     GIR_EraseRootFromParent_Done,
     /*  954860 */   // Label 14362: @954860
     /*  954860 */   GIM_Try, /*On fail goto*//*Label 14363*/ GIMT_Encode4(954942), // Rule ID 64066 //
     /*  954865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  954868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  954876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  954879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  954882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  954885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  954888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954892 */     // MIs[0] op1
     /*  954892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  954919 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  954919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  954922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  954924 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  954926 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  954928 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  954930 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  954932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  954937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  954940 */     GIR_RootConstrainSelectedInstOperands,
     /*  954941 */     // GIR_Coverage, 64066,
     /*  954941 */     GIR_EraseRootFromParent_Done,
     /*  954942 */   // Label 14363: @954942
     /*  954942 */   GIM_Try, /*On fail goto*//*Label 14364*/ GIMT_Encode4(955024), // Rule ID 64067 //
     /*  954947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  954950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  954955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  954958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  954961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  954964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s16,
     /*  954967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  954970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954974 */     // MIs[0] op1
     /*  954974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  954977 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  954982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  954994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955001 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, VR:{ *:[nxv1i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF4),
     /*  955004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955006 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955008 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955010 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955012 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955022 */     GIR_RootConstrainSelectedInstOperands,
     /*  955023 */     // GIR_Coverage, 64067,
     /*  955023 */     GIR_EraseRootFromParent_Done,
     /*  955024 */   // Label 14364: @955024
     /*  955024 */   GIM_Try, /*On fail goto*//*Label 14365*/ GIMT_Encode4(955106), // Rule ID 64072 //
     /*  955029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955056 */     // MIs[0] op1
     /*  955056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955083 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  955086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955088 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955090 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955092 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955094 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955104 */     GIR_RootConstrainSelectedInstOperands,
     /*  955105 */     // GIR_Coverage, 64072,
     /*  955105 */     GIR_EraseRootFromParent_Done,
     /*  955106 */   // Label 14365: @955106
     /*  955106 */   GIM_Try, /*On fail goto*//*Label 14366*/ GIMT_Encode4(955188), // Rule ID 64073 //
     /*  955111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  955122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  955125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  955128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955138 */     // MIs[0] op1
     /*  955138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955165 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF4:{ *:[nxv1i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i32] }:$op2, VR:{ *:[nxv1i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF4),
     /*  955168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955170 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955172 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955174 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955176 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955186 */     GIR_RootConstrainSelectedInstOperands,
     /*  955187 */     // GIR_Coverage, 64073,
     /*  955187 */     GIR_EraseRootFromParent_Done,
     /*  955188 */   // Label 14366: @955188
     /*  955188 */   GIM_Try, /*On fail goto*//*Label 14367*/ GIMT_Encode4(955270), // Rule ID 64078 //
     /*  955193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955220 */     // MIs[0] op1
     /*  955220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  955250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955252 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955254 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955256 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955258 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955268 */     GIR_RootConstrainSelectedInstOperands,
     /*  955269 */     // GIR_Coverage, 64078,
     /*  955269 */     GIR_EraseRootFromParent_Done,
     /*  955270 */   // Label 14367: @955270
     /*  955270 */   GIM_Try, /*On fail goto*//*Label 14368*/ GIMT_Encode4(955352), // Rule ID 64079 //
     /*  955275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955302 */     // MIs[0] op1
     /*  955302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955305 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955329 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  955332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955334 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955336 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955338 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955340 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955350 */     GIR_RootConstrainSelectedInstOperands,
     /*  955351 */     // GIR_Coverage, 64079,
     /*  955351 */     GIR_EraseRootFromParent_Done,
     /*  955352 */   // Label 14368: @955352
     /*  955352 */   GIM_Try, /*On fail goto*//*Label 14369*/ GIMT_Encode4(955434), // Rule ID 64090 //
     /*  955357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955384 */     // MIs[0] op1
     /*  955384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955411 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  955414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955416 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955418 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955420 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955422 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955432 */     GIR_RootConstrainSelectedInstOperands,
     /*  955433 */     // GIR_Coverage, 64090,
     /*  955433 */     GIR_EraseRootFromParent_Done,
     /*  955434 */   // Label 14369: @955434
     /*  955434 */   GIM_Try, /*On fail goto*//*Label 14370*/ GIMT_Encode4(955516), // Rule ID 64091 //
     /*  955439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /*  955459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955466 */     // MIs[0] op1
     /*  955466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955469 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955493 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, VR:{ *:[nxv2i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  955496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955498 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955500 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955502 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955504 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955514 */     GIR_RootConstrainSelectedInstOperands,
     /*  955515 */     // GIR_Coverage, 64091,
     /*  955515 */     GIR_EraseRootFromParent_Done,
     /*  955516 */   // Label 14370: @955516
     /*  955516 */   GIM_Try, /*On fail goto*//*Label 14371*/ GIMT_Encode4(955598), // Rule ID 64096 //
     /*  955521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955548 */     // MIs[0] op1
     /*  955548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955575 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  955578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955580 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955582 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955584 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955586 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955596 */     GIR_RootConstrainSelectedInstOperands,
     /*  955597 */     // GIR_Coverage, 64096,
     /*  955597 */     GIR_EraseRootFromParent_Done,
     /*  955598 */   // Label 14371: @955598
     /*  955598 */   GIM_Try, /*On fail goto*//*Label 14372*/ GIMT_Encode4(955680), // Rule ID 64097 //
     /*  955603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  955611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  955614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  955617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  955620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  955623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955630 */     // MIs[0] op1
     /*  955630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955633 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  955638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  955650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955657 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_MF2:{ *:[nxv2i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv2i32] }:$op2, VR:{ *:[nxv2i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_MF2),
     /*  955660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955662 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955664 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955666 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955668 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955678 */     GIR_RootConstrainSelectedInstOperands,
     /*  955679 */     // GIR_Coverage, 64097,
     /*  955679 */     GIR_EraseRootFromParent_Done,
     /*  955680 */   // Label 14372: @955680
     /*  955680 */   GIM_Try, /*On fail goto*//*Label 14373*/ GIMT_Encode4(955762), // Rule ID 64102 //
     /*  955685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  955696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  955699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  955702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  955705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955712 */     // MIs[0] op1
     /*  955712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  955742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955744 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955746 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955748 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955750 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955760 */     GIR_RootConstrainSelectedInstOperands,
     /*  955761 */     // GIR_Coverage, 64102,
     /*  955761 */     GIR_EraseRootFromParent_Done,
     /*  955762 */   // Label 14373: @955762
     /*  955762 */   GIM_Try, /*On fail goto*//*Label 14374*/ GIMT_Encode4(955844), // Rule ID 64103 //
     /*  955767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  955775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  955778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  955781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  955784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  955787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955794 */     // MIs[0] op1
     /*  955794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955797 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  955814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955821 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  955824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955826 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955828 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955830 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955832 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955842 */     GIR_RootConstrainSelectedInstOperands,
     /*  955843 */     // GIR_Coverage, 64103,
     /*  955843 */     GIR_EraseRootFromParent_Done,
     /*  955844 */   // Label 14374: @955844
     /*  955844 */   GIM_Try, /*On fail goto*//*Label 14375*/ GIMT_Encode4(955926), // Rule ID 64114 //
     /*  955849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  955852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  955860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  955863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  955866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  955869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  955872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955876 */     // MIs[0] op1
     /*  955876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955879 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955903 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  955903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  955906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955908 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955910 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955912 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955914 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  955921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  955924 */     GIR_RootConstrainSelectedInstOperands,
     /*  955925 */     // GIR_Coverage, 64114,
     /*  955925 */     GIR_EraseRootFromParent_Done,
     /*  955926 */   // Label 14375: @955926
     /*  955926 */   GIM_Try, /*On fail goto*//*Label 14376*/ GIMT_Encode4(956008), // Rule ID 64115 //
     /*  955931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  955934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  955939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  955942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  955945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  955948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /*  955951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  955954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955958 */     // MIs[0] op1
     /*  955958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  955961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  955966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  955970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  955978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  955985 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, VR:{ *:[nxv4i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  955985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  955988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  955990 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  955992 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  955994 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  955996 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  955998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956006 */     GIR_RootConstrainSelectedInstOperands,
     /*  956007 */     // GIR_Coverage, 64115,
     /*  956007 */     GIR_EraseRootFromParent_Done,
     /*  956008 */   // Label 14376: @956008
     /*  956008 */   GIM_Try, /*On fail goto*//*Label 14377*/ GIMT_Encode4(956090), // Rule ID 64120 //
     /*  956013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956040 */     // MIs[0] op1
     /*  956040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  956070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956072 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956074 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956076 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956078 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956088 */     GIR_RootConstrainSelectedInstOperands,
     /*  956089 */     // GIR_Coverage, 64120,
     /*  956089 */     GIR_EraseRootFromParent_Done,
     /*  956090 */   // Label 14377: @956090
     /*  956090 */   GIM_Try, /*On fail goto*//*Label 14378*/ GIMT_Encode4(956172), // Rule ID 64121 //
     /*  956095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  956106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  956109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  956112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956122 */     // MIs[0] op1
     /*  956122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  956138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M1:{ *:[nxv4i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv4i32] }:$op2, VR:{ *:[nxv4i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M1),
     /*  956152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956154 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956156 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956158 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956160 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956170 */     GIR_RootConstrainSelectedInstOperands,
     /*  956171 */     // GIR_Coverage, 64121,
     /*  956171 */     GIR_EraseRootFromParent_Done,
     /*  956172 */   // Label 14378: @956172
     /*  956172 */   GIM_Try, /*On fail goto*//*Label 14379*/ GIMT_Encode4(956254), // Rule ID 64126 //
     /*  956177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956204 */     // MIs[0] op1
     /*  956204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956231 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  956234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956236 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956238 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956240 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956242 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956252 */     GIR_RootConstrainSelectedInstOperands,
     /*  956253 */     // GIR_Coverage, 64126,
     /*  956253 */     GIR_EraseRootFromParent_Done,
     /*  956254 */   // Label 14379: @956254
     /*  956254 */   GIM_Try, /*On fail goto*//*Label 14380*/ GIMT_Encode4(956336), // Rule ID 64127 //
     /*  956259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956286 */     // MIs[0] op1
     /*  956286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  956316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956318 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956320 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956322 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956324 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956334 */     GIR_RootConstrainSelectedInstOperands,
     /*  956335 */     // GIR_Coverage, 64127,
     /*  956335 */     GIR_EraseRootFromParent_Done,
     /*  956336 */   // Label 14380: @956336
     /*  956336 */   GIM_Try, /*On fail goto*//*Label 14381*/ GIMT_Encode4(956418), // Rule ID 64138 //
     /*  956341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956368 */     // MIs[0] op1
     /*  956368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956395 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  956398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956400 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956402 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956404 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956406 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956416 */     GIR_RootConstrainSelectedInstOperands,
     /*  956417 */     // GIR_Coverage, 64138,
     /*  956417 */     GIR_EraseRootFromParent_Done,
     /*  956418 */   // Label 14381: @956418
     /*  956418 */   GIM_Try, /*On fail goto*//*Label 14382*/ GIMT_Encode4(956500), // Rule ID 64139 //
     /*  956423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /*  956443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956450 */     // MIs[0] op1
     /*  956450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956453 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956477 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, VRM2:{ *:[nxv8i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  956480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956482 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956484 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956486 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956488 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956498 */     GIR_RootConstrainSelectedInstOperands,
     /*  956499 */     // GIR_Coverage, 64139,
     /*  956499 */     GIR_EraseRootFromParent_Done,
     /*  956500 */   // Label 14382: @956500
     /*  956500 */   GIM_Try, /*On fail goto*//*Label 14383*/ GIMT_Encode4(956582), // Rule ID 64144 //
     /*  956505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956532 */     // MIs[0] op1
     /*  956532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956559 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  956562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956564 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956566 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956568 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956570 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956580 */     GIR_RootConstrainSelectedInstOperands,
     /*  956581 */     // GIR_Coverage, 64144,
     /*  956581 */     GIR_EraseRootFromParent_Done,
     /*  956582 */   // Label 14383: @956582
     /*  956582 */   GIM_Try, /*On fail goto*//*Label 14384*/ GIMT_Encode4(956664), // Rule ID 64145 //
     /*  956587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  956595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  956598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  956601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  956604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  956607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956614 */     // MIs[0] op1
     /*  956614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956617 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  956622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  956630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  956634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956641 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M2:{ *:[nxv8i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv8i32] }:$op2, VRM2:{ *:[nxv8i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M2),
     /*  956644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956646 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956648 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956650 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956652 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956662 */     GIR_RootConstrainSelectedInstOperands,
     /*  956663 */     // GIR_Coverage, 64145,
     /*  956663 */     GIR_EraseRootFromParent_Done,
     /*  956664 */   // Label 14384: @956664
     /*  956664 */   GIM_Try, /*On fail goto*//*Label 14385*/ GIMT_Encode4(956746), // Rule ID 64150 //
     /*  956669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  956680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  956683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  956686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  956689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956696 */     // MIs[0] op1
     /*  956696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956723 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  956726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956728 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956730 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956732 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956734 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956744 */     GIR_RootConstrainSelectedInstOperands,
     /*  956745 */     // GIR_Coverage, 64150,
     /*  956745 */     GIR_EraseRootFromParent_Done,
     /*  956746 */   // Label 14385: @956746
     /*  956746 */   GIM_Try, /*On fail goto*//*Label 14386*/ GIMT_Encode4(956828), // Rule ID 64151 //
     /*  956751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  956759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  956762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  956765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  956768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  956771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956778 */     // MIs[0] op1
     /*  956778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  956798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956805 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  956808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956810 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956812 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956814 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956816 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956826 */     GIR_RootConstrainSelectedInstOperands,
     /*  956827 */     // GIR_Coverage, 64151,
     /*  956827 */     GIR_EraseRootFromParent_Done,
     /*  956828 */   // Label 14386: @956828
     /*  956828 */   GIM_Try, /*On fail goto*//*Label 14387*/ GIMT_Encode4(956910), // Rule ID 64162 //
     /*  956833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  956836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  956844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  956847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  956850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  956853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  956856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956860 */     // MIs[0] op1
     /*  956860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956887 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  956887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  956890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956892 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956894 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956896 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956898 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956908 */     GIR_RootConstrainSelectedInstOperands,
     /*  956909 */     // GIR_Coverage, 64162,
     /*  956909 */     GIR_EraseRootFromParent_Done,
     /*  956910 */   // Label 14387: @956910
     /*  956910 */   GIM_Try, /*On fail goto*//*Label 14388*/ GIMT_Encode4(956992), // Rule ID 64163 //
     /*  956915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  956918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  956923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  956926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  956929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  956932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s16,
     /*  956935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  956938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956942 */     // MIs[0] op1
     /*  956942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  956945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  956950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  956954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  956962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  956969 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, VRM4:{ *:[nxv16i16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  956969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  956972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  956974 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  956976 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  956978 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  956980 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  956982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  956987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  956990 */     GIR_RootConstrainSelectedInstOperands,
     /*  956991 */     // GIR_Coverage, 64163,
     /*  956991 */     GIR_EraseRootFromParent_Done,
     /*  956992 */   // Label 14388: @956992
     /*  956992 */   GIM_Try, /*On fail goto*//*Label 14389*/ GIMT_Encode4(957074), // Rule ID 64168 //
     /*  956997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957024 */     // MIs[0] op1
     /*  957024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957027 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957051 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  957051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  957054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957056 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957058 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957060 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957062 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957072 */     GIR_RootConstrainSelectedInstOperands,
     /*  957073 */     // GIR_Coverage, 64168,
     /*  957073 */     GIR_EraseRootFromParent_Done,
     /*  957074 */   // Label 14389: @957074
     /*  957074 */   GIM_Try, /*On fail goto*//*Label 14390*/ GIMT_Encode4(957156), // Rule ID 64169 //
     /*  957079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  957090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  957093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  957096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s16,
     /*  957099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957106 */     // MIs[0] op1
     /*  957106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957109 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  957118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  957122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /*  957126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957133 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR16VW_M4:{ *:[nxv16i32] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv16i32] }:$op2, VRM4:{ *:[nxv16i16] }:$op3, FPR16:{ *:[f16] }:$op4, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  957133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR16VW_M4),
     /*  957136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957138 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957140 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957142 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957144 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  957154 */     GIR_RootConstrainSelectedInstOperands,
     /*  957155 */     // GIR_Coverage, 64169,
     /*  957155 */     GIR_EraseRootFromParent_Done,
     /*  957156 */   // Label 14390: @957156
     /*  957156 */   GIM_Try, /*On fail goto*//*Label 14391*/ GIMT_Encode4(957238), // Rule ID 64174 //
     /*  957161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957188 */     // MIs[0] op1
     /*  957188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957191 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957215 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957220 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957222 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957224 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957226 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957236 */     GIR_RootConstrainSelectedInstOperands,
     /*  957237 */     // GIR_Coverage, 64174,
     /*  957237 */     GIR_EraseRootFromParent_Done,
     /*  957238 */   // Label 14391: @957238
     /*  957238 */   GIM_Try, /*On fail goto*//*Label 14392*/ GIMT_Encode4(957320), // Rule ID 64175 //
     /*  957243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957270 */     // MIs[0] op1
     /*  957270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957297 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_MF2),
     /*  957300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957302 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957304 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957306 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957308 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957318 */     GIR_RootConstrainSelectedInstOperands,
     /*  957319 */     // GIR_Coverage, 64175,
     /*  957319 */     GIR_EraseRootFromParent_Done,
     /*  957320 */   // Label 14392: @957320
     /*  957320 */   GIM_Try, /*On fail goto*//*Label 14393*/ GIMT_Encode4(957402), // Rule ID 64186 //
     /*  957325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957352 */     // MIs[0] op1
     /*  957352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957379 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957384 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957386 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957388 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957390 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957400 */     GIR_RootConstrainSelectedInstOperands,
     /*  957401 */     // GIR_Coverage, 64186,
     /*  957401 */     GIR_EraseRootFromParent_Done,
     /*  957402 */   // Label 14393: @957402
     /*  957402 */   GIM_Try, /*On fail goto*//*Label 14394*/ GIMT_Encode4(957484), // Rule ID 64187 //
     /*  957407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s32,
     /*  957427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957434 */     // MIs[0] op1
     /*  957434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957437 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957461 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, VR:{ *:[nxv1i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_MF2),
     /*  957464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957466 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957468 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957470 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957472 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957482 */     GIR_RootConstrainSelectedInstOperands,
     /*  957483 */     // GIR_Coverage, 64187,
     /*  957483 */     GIR_EraseRootFromParent_Done,
     /*  957484 */   // Label 14394: @957484
     /*  957484 */   GIM_Try, /*On fail goto*//*Label 14395*/ GIMT_Encode4(957566), // Rule ID 64192 //
     /*  957489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957516 */     // MIs[0] op1
     /*  957516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957519 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  957536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957543 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  957546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957548 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957550 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957552 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957554 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957564 */     GIR_RootConstrainSelectedInstOperands,
     /*  957565 */     // GIR_Coverage, 64192,
     /*  957565 */     GIR_EraseRootFromParent_Done,
     /*  957566 */   // Label 14395: @957566
     /*  957566 */   GIM_Try, /*On fail goto*//*Label 14396*/ GIMT_Encode4(957648), // Rule ID 64193 //
     /*  957571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  957582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  957585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  957588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957598 */     // MIs[0] op1
     /*  957598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  957606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  957618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957625 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_MF2:{ *:[nxv1i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VR:{ *:[nxv1i64] }:$op2, VR:{ *:[nxv1i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_MF2),
     /*  957628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957630 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957632 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957634 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957636 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957646 */     GIR_RootConstrainSelectedInstOperands,
     /*  957647 */     // GIR_Coverage, 64193,
     /*  957647 */     GIR_EraseRootFromParent_Done,
     /*  957648 */   // Label 14396: @957648
     /*  957648 */   GIM_Try, /*On fail goto*//*Label 14397*/ GIMT_Encode4(957730), // Rule ID 64198 //
     /*  957653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  957670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  957673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957680 */     // MIs[0] op1
     /*  957680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957683 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957707 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  957710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957712 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957714 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957716 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957718 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957728 */     GIR_RootConstrainSelectedInstOperands,
     /*  957729 */     // GIR_Coverage, 64198,
     /*  957729 */     GIR_EraseRootFromParent_Done,
     /*  957730 */   // Label 14397: @957730
     /*  957730 */   GIM_Try, /*On fail goto*//*Label 14398*/ GIMT_Encode4(957812), // Rule ID 64199 //
     /*  957735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  957743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  957752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  957755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957762 */     // MIs[0] op1
     /*  957762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957765 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  957782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M1),
     /*  957792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957794 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957796 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957798 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957800 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957810 */     GIR_RootConstrainSelectedInstOperands,
     /*  957811 */     // GIR_Coverage, 64199,
     /*  957811 */     GIR_EraseRootFromParent_Done,
     /*  957812 */   // Label 14398: @957812
     /*  957812 */   GIM_Try, /*On fail goto*//*Label 14399*/ GIMT_Encode4(957894), // Rule ID 64210 //
     /*  957817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  957834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  957837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  957840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957844 */     // MIs[0] op1
     /*  957844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957847 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  957871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  957874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957876 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957878 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957880 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957882 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957892 */     GIR_RootConstrainSelectedInstOperands,
     /*  957893 */     // GIR_Coverage, 64210,
     /*  957893 */     GIR_EraseRootFromParent_Done,
     /*  957894 */   // Label 14399: @957894
     /*  957894 */   GIM_Try, /*On fail goto*//*Label 14400*/ GIMT_Encode4(957976), // Rule ID 64211 //
     /*  957899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  957902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  957907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  957916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /*  957919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  957922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957926 */     // MIs[0] op1
     /*  957926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  957929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  957934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  957938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  957946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  957953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, VR:{ *:[nxv2i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  957953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M1),
     /*  957956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  957958 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  957960 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  957962 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  957964 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  957966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  957971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  957974 */     GIR_RootConstrainSelectedInstOperands,
     /*  957975 */     // GIR_Coverage, 64211,
     /*  957975 */     GIR_EraseRootFromParent_Done,
     /*  957976 */   // Label 14400: @957976
     /*  957976 */   GIM_Try, /*On fail goto*//*Label 14401*/ GIMT_Encode4(958058), // Rule ID 64216 //
     /*  957981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  957984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  957989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  957992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  957995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  957998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958008 */     // MIs[0] op1
     /*  958008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958011 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958035 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  958038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958040 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958042 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958044 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958046 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958056 */     GIR_RootConstrainSelectedInstOperands,
     /*  958057 */     // GIR_Coverage, 64216,
     /*  958057 */     GIR_EraseRootFromParent_Done,
     /*  958058 */   // Label 14401: @958058
     /*  958058 */   GIM_Try, /*On fail goto*//*Label 14402*/ GIMT_Encode4(958140), // Rule ID 64217 //
     /*  958063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  958074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  958077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  958080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958090 */     // MIs[0] op1
     /*  958090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  958106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M1:{ *:[nxv2i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM2:{ *:[nxv2i64] }:$op2, VR:{ *:[nxv2i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M1),
     /*  958120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958122 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958124 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958126 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958128 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958138 */     GIR_RootConstrainSelectedInstOperands,
     /*  958139 */     // GIR_Coverage, 64217,
     /*  958139 */     GIR_EraseRootFromParent_Done,
     /*  958140 */   // Label 14402: @958140
     /*  958140 */   GIM_Try, /*On fail goto*//*Label 14403*/ GIMT_Encode4(958222), // Rule ID 64222 //
     /*  958145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958172 */     // MIs[0] op1
     /*  958172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958199 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958204 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958206 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958208 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958210 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958220 */     GIR_RootConstrainSelectedInstOperands,
     /*  958221 */     // GIR_Coverage, 64222,
     /*  958221 */     GIR_EraseRootFromParent_Done,
     /*  958222 */   // Label 14403: @958222
     /*  958222 */   GIM_Try, /*On fail goto*//*Label 14404*/ GIMT_Encode4(958304), // Rule ID 64223 //
     /*  958227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958254 */     // MIs[0] op1
     /*  958254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958257 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958281 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M2),
     /*  958284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958286 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958288 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958290 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958292 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958302 */     GIR_RootConstrainSelectedInstOperands,
     /*  958303 */     // GIR_Coverage, 64223,
     /*  958303 */     GIR_EraseRootFromParent_Done,
     /*  958304 */   // Label 14404: @958304
     /*  958304 */   GIM_Try, /*On fail goto*//*Label 14405*/ GIMT_Encode4(958386), // Rule ID 64234 //
     /*  958309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958336 */     // MIs[0] op1
     /*  958336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958339 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958363 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958368 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958370 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958372 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958374 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958384 */     GIR_RootConstrainSelectedInstOperands,
     /*  958385 */     // GIR_Coverage, 64234,
     /*  958385 */     GIR_EraseRootFromParent_Done,
     /*  958386 */   // Label 14405: @958386
     /*  958386 */   GIM_Try, /*On fail goto*//*Label 14406*/ GIMT_Encode4(958468), // Rule ID 64235 //
     /*  958391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /*  958411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958418 */     // MIs[0] op1
     /*  958418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958445 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, VRM2:{ *:[nxv4i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M2),
     /*  958448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958450 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958452 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958454 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958456 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958466 */     GIR_RootConstrainSelectedInstOperands,
     /*  958467 */     // GIR_Coverage, 64235,
     /*  958467 */     GIR_EraseRootFromParent_Done,
     /*  958468 */   // Label 14406: @958468
     /*  958468 */   GIM_Try, /*On fail goto*//*Label 14407*/ GIMT_Encode4(958550), // Rule ID 64240 //
     /*  958473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958500 */     // MIs[0] op1
     /*  958500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958527 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  958530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958532 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958534 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958536 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958538 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958548 */     GIR_RootConstrainSelectedInstOperands,
     /*  958549 */     // GIR_Coverage, 64240,
     /*  958549 */     GIR_EraseRootFromParent_Done,
     /*  958550 */   // Label 14407: @958550
     /*  958550 */   GIM_Try, /*On fail goto*//*Label 14408*/ GIMT_Encode4(958632), // Rule ID 64241 //
     /*  958555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  958566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  958569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  958572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958582 */     // MIs[0] op1
     /*  958582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958585 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  958590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  958598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  958602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958609 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M2:{ *:[nxv4i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM4:{ *:[nxv4i64] }:$op2, VRM2:{ *:[nxv4i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M2),
     /*  958612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958614 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958616 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958618 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958620 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958630 */     GIR_RootConstrainSelectedInstOperands,
     /*  958631 */     // GIR_Coverage, 64241,
     /*  958631 */     GIR_EraseRootFromParent_Done,
     /*  958632 */   // Label 14408: @958632
     /*  958632 */   GIM_Try, /*On fail goto*//*Label 14409*/ GIMT_Encode4(958714), // Rule ID 64246 //
     /*  958637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  958648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  958651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  958654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  958657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958664 */     // MIs[0] op1
     /*  958664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958691 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i64] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958696 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958698 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958700 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958702 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958712 */     GIR_RootConstrainSelectedInstOperands,
     /*  958713 */     // GIR_Coverage, 64246,
     /*  958713 */     GIR_EraseRootFromParent_Done,
     /*  958714 */   // Label 14409: @958714
     /*  958714 */   GIM_Try, /*On fail goto*//*Label 14410*/ GIMT_Encode4(958796), // Rule ID 64247 //
     /*  958719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_xvw),
     /*  958727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  958730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  958733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  958736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958746 */     // MIs[0] op1
     /*  958746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /*  958766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11018:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_XVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, GPR:{ *:[i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_XVW_M4),
     /*  958776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958778 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958780 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958782 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958784 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958794 */     GIR_RootConstrainSelectedInstOperands,
     /*  958795 */     // GIR_Coverage, 64247,
     /*  958795 */     GIR_EraseRootFromParent_Done,
     /*  958796 */   // Label 14410: @958796
     /*  958796 */   GIM_Try, /*On fail goto*//*Label 14411*/ GIMT_Encode4(958878), // Rule ID 64258 //
     /*  958801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  958812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  958815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  958818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  958821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958828 */     // MIs[0] op1
     /*  958828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958831 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958855 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  958855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  958858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958860 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958862 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958864 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958866 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958876 */     GIR_RootConstrainSelectedInstOperands,
     /*  958877 */     // GIR_Coverage, 64258,
     /*  958877 */     GIR_EraseRootFromParent_Done,
     /*  958878 */   // Label 14411: @958878
     /*  958878 */   GIM_Try, /*On fail goto*//*Label 14412*/ GIMT_Encode4(958960), // Rule ID 64259 //
     /*  958883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  958886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_vvw),
     /*  958891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  958894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  958897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  958900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s32,
     /*  958903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  958906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958910 */     // MIs[0] op1
     /*  958910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload2),
     /*  958918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  958930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  958937 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11010:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_VVW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload2>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, VRM4:{ *:[nxv8i32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  958937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_VVW_M4),
     /*  958940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  958942 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  958944 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  958946 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  958948 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  958950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  958955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  958958 */     GIR_RootConstrainSelectedInstOperands,
     /*  958959 */     // GIR_Coverage, 64259,
     /*  958959 */     GIR_EraseRootFromParent_Done,
     /*  958960 */   // Label 14412: @958960
     /*  958960 */   GIM_Try, /*On fail goto*//*Label 14413*/ GIMT_Encode4(959042), // Rule ID 64264 //
     /*  958965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode0),
     /*  958968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  958973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  958976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  958979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  958982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  958985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  958988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  958992 */     // MIs[0] op1
     /*  958992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  958995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959019 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i64] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  959019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  959022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959024 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959026 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959028 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959030 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959040 */     GIR_RootConstrainSelectedInstOperands,
     /*  959041 */     // GIR_Coverage, 64264,
     /*  959041 */     GIR_EraseRootFromParent_Done,
     /*  959042 */   // Label 14413: @959042
     /*  959042 */   GIM_Try, /*On fail goto*//*Label 14414*/ GIMT_Encode4(959124), // Rule ID 64265 //
     /*  959047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvcp_HwMode1),
     /*  959050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vc_v_fvw),
     /*  959055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  959058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  959061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  959064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  959067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959074 */     // MIs[0] op1
     /*  959074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  959077 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_payload1),
     /*  959082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  959086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  959090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /*  959094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959101 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 10996:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVC_V_FPR32VW_M4:{ *:[nxv8i64] } (timm:{ *:[i32] })<<P:Predicate_payload1>>:$op1, VRM8:{ *:[nxv8i64] }:$op2, VRM4:{ *:[nxv8i32] }:$op3, FPR32:{ *:[f32] }:$op4, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  959101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVC_V_FPR32VW_M4),
     /*  959104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959106 */     GIR_RootToRootCopy, /*OpIdx*/2, // op1
     /*  959108 */     GIR_RootToRootCopy, /*OpIdx*/3, // op2
     /*  959110 */     GIR_RootToRootCopy, /*OpIdx*/4, // op3
     /*  959112 */     GIR_RootToRootCopy, /*OpIdx*/5, // op4
     /*  959114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  959122 */     GIR_RootConstrainSelectedInstOperands,
     /*  959123 */     // GIR_Coverage, 64265,
     /*  959123 */     GIR_EraseRootFromParent_Done,
     /*  959124 */   // Label 14414: @959124
     /*  959124 */   GIM_Try, /*On fail goto*//*Label 14415*/ GIMT_Encode4(959216), // Rule ID 5086 //
     /*  959129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959179 */     // MIs[1] Operand 1
     /*  959179 */     // No operand predicates
     /*  959179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959192 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959214 */     GIR_RootConstrainSelectedInstOperands,
     /*  959215 */     // GIR_Coverage, 5086,
     /*  959215 */     GIR_EraseRootFromParent_Done,
     /*  959216 */   // Label 14415: @959216
     /*  959216 */   GIM_Try, /*On fail goto*//*Label 14416*/ GIMT_Encode4(959308), // Rule ID 5087 //
     /*  959221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  959232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  959235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  959238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959267 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959271 */     // MIs[1] Operand 1
     /*  959271 */     // No operand predicates
     /*  959271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959284 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF8),
     /*  959287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959306 */     GIR_RootConstrainSelectedInstOperands,
     /*  959307 */     // GIR_Coverage, 5087,
     /*  959307 */     GIR_EraseRootFromParent_Done,
     /*  959308 */   // Label 14416: @959308
     /*  959308 */   GIM_Try, /*On fail goto*//*Label 14417*/ GIMT_Encode4(959400), // Rule ID 5088 //
     /*  959313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959359 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959363 */     // MIs[1] Operand 1
     /*  959363 */     // No operand predicates
     /*  959363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959376 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959398 */     GIR_RootConstrainSelectedInstOperands,
     /*  959399 */     // GIR_Coverage, 5088,
     /*  959399 */     GIR_EraseRootFromParent_Done,
     /*  959400 */   // Label 14417: @959400
     /*  959400 */   GIM_Try, /*On fail goto*//*Label 14418*/ GIMT_Encode4(959492), // Rule ID 5089 //
     /*  959405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  959416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  959419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  959422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959455 */     // MIs[1] Operand 1
     /*  959455 */     // No operand predicates
     /*  959455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959490 */     GIR_RootConstrainSelectedInstOperands,
     /*  959491 */     // GIR_Coverage, 5089,
     /*  959491 */     GIR_EraseRootFromParent_Done,
     /*  959492 */   // Label 14418: @959492
     /*  959492 */   GIM_Try, /*On fail goto*//*Label 14419*/ GIMT_Encode4(959584), // Rule ID 5090 //
     /*  959497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  959508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  959511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  959514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  959520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959547 */     // MIs[1] Operand 1
     /*  959547 */     // No operand predicates
     /*  959547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959560 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  959560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  959563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959582 */     GIR_RootConstrainSelectedInstOperands,
     /*  959583 */     // GIR_Coverage, 5090,
     /*  959583 */     GIR_EraseRootFromParent_Done,
     /*  959584 */   // Label 14419: @959584
     /*  959584 */   GIM_Try, /*On fail goto*//*Label 14420*/ GIMT_Encode4(959676), // Rule ID 5091 //
     /*  959589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  959600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  959603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  959606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  959612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959639 */     // MIs[1] Operand 1
     /*  959639 */     // No operand predicates
     /*  959639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  959652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  959655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  959674 */     GIR_RootConstrainSelectedInstOperands,
     /*  959675 */     // GIR_Coverage, 5091,
     /*  959675 */     GIR_EraseRootFromParent_Done,
     /*  959676 */   // Label 14420: @959676
     /*  959676 */   GIM_Try, /*On fail goto*//*Label 14421*/ GIMT_Encode4(959768), // Rule ID 5092 //
     /*  959681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  959692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  959695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  959698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959731 */     // MIs[1] Operand 1
     /*  959731 */     // No operand predicates
     /*  959731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959766 */     GIR_RootConstrainSelectedInstOperands,
     /*  959767 */     // GIR_Coverage, 5092,
     /*  959767 */     GIR_EraseRootFromParent_Done,
     /*  959768 */   // Label 14421: @959768
     /*  959768 */   GIM_Try, /*On fail goto*//*Label 14422*/ GIMT_Encode4(959860), // Rule ID 5093 //
     /*  959773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  959784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  959787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  959790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  959796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959819 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959823 */     // MIs[1] Operand 1
     /*  959823 */     // No operand predicates
     /*  959823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959836 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  959836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF4),
     /*  959839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959858 */     GIR_RootConstrainSelectedInstOperands,
     /*  959859 */     // GIR_Coverage, 5093,
     /*  959859 */     GIR_EraseRootFromParent_Done,
     /*  959860 */   // Label 14422: @959860
     /*  959860 */   GIM_Try, /*On fail goto*//*Label 14423*/ GIMT_Encode4(959952), // Rule ID 5094 //
     /*  959865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  959868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  959876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  959879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  959882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  959885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  959891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  959911 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  959915 */     // MIs[1] Operand 1
     /*  959915 */     // No operand predicates
     /*  959915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  959919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  959921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  959928 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  959928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  959931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  959933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  959935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  959937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  959940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  959942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  959947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  959950 */     GIR_RootConstrainSelectedInstOperands,
     /*  959951 */     // GIR_Coverage, 5094,
     /*  959951 */     GIR_EraseRootFromParent_Done,
     /*  959952 */   // Label 14423: @959952
     /*  959952 */   GIM_Try, /*On fail goto*//*Label 14424*/ GIMT_Encode4(960044), // Rule ID 5095 //
     /*  959957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  959960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  959965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  959968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  959971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  959974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  959977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  959980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  959983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  959987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  959995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  959999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960007 */     // MIs[1] Operand 1
     /*  960007 */     // No operand predicates
     /*  960007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960020 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960042 */     GIR_RootConstrainSelectedInstOperands,
     /*  960043 */     // GIR_Coverage, 5095,
     /*  960043 */     GIR_EraseRootFromParent_Done,
     /*  960044 */   // Label 14424: @960044
     /*  960044 */   GIM_Try, /*On fail goto*//*Label 14425*/ GIMT_Encode4(960136), // Rule ID 5096 //
     /*  960049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960099 */     // MIs[1] Operand 1
     /*  960099 */     // No operand predicates
     /*  960099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960112 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  960112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960134 */     GIR_RootConstrainSelectedInstOperands,
     /*  960135 */     // GIR_Coverage, 5096,
     /*  960135 */     GIR_EraseRootFromParent_Done,
     /*  960136 */   // Label 14425: @960136
     /*  960136 */   GIM_Try, /*On fail goto*//*Label 14426*/ GIMT_Encode4(960228), // Rule ID 5097 //
     /*  960141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  960152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  960155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  960158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960191 */     // MIs[1] Operand 1
     /*  960191 */     // No operand predicates
     /*  960191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_MF2),
     /*  960207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960226 */     GIR_RootConstrainSelectedInstOperands,
     /*  960227 */     // GIR_Coverage, 5097,
     /*  960227 */     GIR_EraseRootFromParent_Done,
     /*  960228 */   // Label 14426: @960228
     /*  960228 */   GIM_Try, /*On fail goto*//*Label 14427*/ GIMT_Encode4(960320), // Rule ID 5098 //
     /*  960233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960283 */     // MIs[1] Operand 1
     /*  960283 */     // No operand predicates
     /*  960283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960296 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  960296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960318 */     GIR_RootConstrainSelectedInstOperands,
     /*  960319 */     // GIR_Coverage, 5098,
     /*  960319 */     GIR_EraseRootFromParent_Done,
     /*  960320 */   // Label 14427: @960320
     /*  960320 */   GIM_Try, /*On fail goto*//*Label 14428*/ GIMT_Encode4(960412), // Rule ID 5099 //
     /*  960325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  960336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  960339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  960342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  960348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960371 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960375 */     // MIs[1] Operand 1
     /*  960375 */     // No operand predicates
     /*  960375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  960388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  960410 */     GIR_RootConstrainSelectedInstOperands,
     /*  960411 */     // GIR_Coverage, 5099,
     /*  960411 */     GIR_EraseRootFromParent_Done,
     /*  960412 */   // Label 14428: @960412
     /*  960412 */   GIM_Try, /*On fail goto*//*Label 14429*/ GIMT_Encode4(960504), // Rule ID 5100 //
     /*  960417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960467 */     // MIs[1] Operand 1
     /*  960467 */     // No operand predicates
     /*  960467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  960480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960502 */     GIR_RootConstrainSelectedInstOperands,
     /*  960503 */     // GIR_Coverage, 5100,
     /*  960503 */     GIR_EraseRootFromParent_Done,
     /*  960504 */   // Label 14429: @960504
     /*  960504 */   GIM_Try, /*On fail goto*//*Label 14430*/ GIMT_Encode4(960596), // Rule ID 5101 //
     /*  960509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  960520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  960523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  960526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  960532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960559 */     // MIs[1] Operand 1
     /*  960559 */     // No operand predicates
     /*  960559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  960572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  960594 */     GIR_RootConstrainSelectedInstOperands,
     /*  960595 */     // GIR_Coverage, 5101,
     /*  960595 */     GIR_EraseRootFromParent_Done,
     /*  960596 */   // Label 14430: @960596
     /*  960596 */   GIM_Try, /*On fail goto*//*Label 14431*/ GIMT_Encode4(960688), // Rule ID 5102 //
     /*  960601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  960612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  960615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  960618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960651 */     // MIs[1] Operand 1
     /*  960651 */     // No operand predicates
     /*  960651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  960664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960686 */     GIR_RootConstrainSelectedInstOperands,
     /*  960687 */     // GIR_Coverage, 5102,
     /*  960687 */     GIR_EraseRootFromParent_Done,
     /*  960688 */   // Label 14431: @960688
     /*  960688 */   GIM_Try, /*On fail goto*//*Label 14432*/ GIMT_Encode4(960780), // Rule ID 5103 //
     /*  960693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  960696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  960704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  960707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  960710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  960716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960743 */     // MIs[1] Operand 1
     /*  960743 */     // No operand predicates
     /*  960743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  960756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960765 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  960778 */     GIR_RootConstrainSelectedInstOperands,
     /*  960779 */     // GIR_Coverage, 5103,
     /*  960779 */     GIR_EraseRootFromParent_Done,
     /*  960780 */   // Label 14432: @960780
     /*  960780 */   GIM_Try, /*On fail goto*//*Label 14433*/ GIMT_Encode4(960872), // Rule ID 5104 //
     /*  960785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  960788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  960796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  960799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  960802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960835 */     // MIs[1] Operand 1
     /*  960835 */     // No operand predicates
     /*  960835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960848 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  960848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  960870 */     GIR_RootConstrainSelectedInstOperands,
     /*  960871 */     // GIR_Coverage, 5104,
     /*  960871 */     GIR_EraseRootFromParent_Done,
     /*  960872 */   // Label 14433: @960872
     /*  960872 */   GIM_Try, /*On fail goto*//*Label 14434*/ GIMT_Encode4(960964), // Rule ID 5105 //
     /*  960877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  960880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  960888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  960891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  960894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  960897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  960900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  960903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  960907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  960915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  960919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  960923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  960927 */     // MIs[1] Operand 1
     /*  960927 */     // No operand predicates
     /*  960927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  960931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  960933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  960940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  960940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M1),
     /*  960943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  960945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  960947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  960949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  960952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  960954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  960959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  960962 */     GIR_RootConstrainSelectedInstOperands,
     /*  960963 */     // GIR_Coverage, 5105,
     /*  960963 */     GIR_EraseRootFromParent_Done,
     /*  960964 */   // Label 14434: @960964
     /*  960964 */   GIM_Try, /*On fail goto*//*Label 14435*/ GIMT_Encode4(961056), // Rule ID 5106 //
     /*  960969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  960972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  960977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  960980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  960983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  960986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  960989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  960992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  960995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  960999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961015 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961019 */     // MIs[1] Operand 1
     /*  961019 */     // No operand predicates
     /*  961019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961054 */     GIR_RootConstrainSelectedInstOperands,
     /*  961055 */     // GIR_Coverage, 5106,
     /*  961055 */     GIR_EraseRootFromParent_Done,
     /*  961056 */   // Label 14435: @961056
     /*  961056 */   GIM_Try, /*On fail goto*//*Label 14436*/ GIMT_Encode4(961148), // Rule ID 5107 //
     /*  961061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  961072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  961075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  961078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961111 */     // MIs[1] Operand 1
     /*  961111 */     // No operand predicates
     /*  961111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961146 */     GIR_RootConstrainSelectedInstOperands,
     /*  961147 */     // GIR_Coverage, 5107,
     /*  961147 */     GIR_EraseRootFromParent_Done,
     /*  961148 */   // Label 14436: @961148
     /*  961148 */   GIM_Try, /*On fail goto*//*Label 14437*/ GIMT_Encode4(961240), // Rule ID 5108 //
     /*  961153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961203 */     // MIs[1] Operand 1
     /*  961203 */     // No operand predicates
     /*  961203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961238 */     GIR_RootConstrainSelectedInstOperands,
     /*  961239 */     // GIR_Coverage, 5108,
     /*  961239 */     GIR_EraseRootFromParent_Done,
     /*  961240 */   // Label 14437: @961240
     /*  961240 */   GIM_Try, /*On fail goto*//*Label 14438*/ GIMT_Encode4(961332), // Rule ID 5109 //
     /*  961245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  961256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  961259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  961262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961295 */     // MIs[1] Operand 1
     /*  961295 */     // No operand predicates
     /*  961295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961308 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961330 */     GIR_RootConstrainSelectedInstOperands,
     /*  961331 */     // GIR_Coverage, 5109,
     /*  961331 */     GIR_EraseRootFromParent_Done,
     /*  961332 */   // Label 14438: @961332
     /*  961332 */   GIM_Try, /*On fail goto*//*Label 14439*/ GIMT_Encode4(961424), // Rule ID 5110 //
     /*  961337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961387 */     // MIs[1] Operand 1
     /*  961387 */     // No operand predicates
     /*  961387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961400 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  961400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  961403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961422 */     GIR_RootConstrainSelectedInstOperands,
     /*  961423 */     // GIR_Coverage, 5110,
     /*  961423 */     GIR_EraseRootFromParent_Done,
     /*  961424 */   // Label 14439: @961424
     /*  961424 */   GIM_Try, /*On fail goto*//*Label 14440*/ GIMT_Encode4(961516), // Rule ID 5111 //
     /*  961429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  961440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  961443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  961446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  961452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961479 */     // MIs[1] Operand 1
     /*  961479 */     // No operand predicates
     /*  961479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961492 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  961492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  961495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  961514 */     GIR_RootConstrainSelectedInstOperands,
     /*  961515 */     // GIR_Coverage, 5111,
     /*  961515 */     GIR_EraseRootFromParent_Done,
     /*  961516 */   // Label 14440: @961516
     /*  961516 */   GIM_Try, /*On fail goto*//*Label 14441*/ GIMT_Encode4(961608), // Rule ID 5112 //
     /*  961521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  961532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  961535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  961538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961567 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961571 */     // MIs[1] Operand 1
     /*  961571 */     // No operand predicates
     /*  961571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961606 */     GIR_RootConstrainSelectedInstOperands,
     /*  961607 */     // GIR_Coverage, 5112,
     /*  961607 */     GIR_EraseRootFromParent_Done,
     /*  961608 */   // Label 14441: @961608
     /*  961608 */   GIM_Try, /*On fail goto*//*Label 14442*/ GIMT_Encode4(961700), // Rule ID 5113 //
     /*  961613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  961624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  961627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  961630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  961636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  961643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  961651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961663 */     // MIs[1] Operand 1
     /*  961663 */     // No operand predicates
     /*  961663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  961679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961698 */     GIR_RootConstrainSelectedInstOperands,
     /*  961699 */     // GIR_Coverage, 5113,
     /*  961699 */     GIR_EraseRootFromParent_Done,
     /*  961700 */   // Label 14442: @961700
     /*  961700 */   GIM_Try, /*On fail goto*//*Label 14443*/ GIMT_Encode4(961792), // Rule ID 5114 //
     /*  961705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  961716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  961719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  961722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961755 */     // MIs[1] Operand 1
     /*  961755 */     // No operand predicates
     /*  961755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961768 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961790 */     GIR_RootConstrainSelectedInstOperands,
     /*  961791 */     // GIR_Coverage, 5114,
     /*  961791 */     GIR_EraseRootFromParent_Done,
     /*  961792 */   // Label 14443: @961792
     /*  961792 */   GIM_Try, /*On fail goto*//*Label 14444*/ GIMT_Encode4(961884), // Rule ID 5115 //
     /*  961797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  961808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  961811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  961814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  961817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  961820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  961823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  961827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  961835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961847 */     // MIs[1] Operand 1
     /*  961847 */     // No operand predicates
     /*  961847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961860 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  961860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  961863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961882 */     GIR_RootConstrainSelectedInstOperands,
     /*  961883 */     // GIR_Coverage, 5115,
     /*  961883 */     GIR_EraseRootFromParent_Done,
     /*  961884 */   // Label 14444: @961884
     /*  961884 */   GIM_Try, /*On fail goto*//*Label 14445*/ GIMT_Encode4(961976), // Rule ID 5116 //
     /*  961889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  961892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  961900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  961903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  961906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  961909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  961912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  961915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  961919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  961927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  961931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  961935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  961939 */     // MIs[1] Operand 1
     /*  961939 */     // No operand predicates
     /*  961939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  961943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  961945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  961952 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  961952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  961955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  961957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  961959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  961961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  961964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  961966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  961971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  961974 */     GIR_RootConstrainSelectedInstOperands,
     /*  961975 */     // GIR_Coverage, 5116,
     /*  961975 */     GIR_EraseRootFromParent_Done,
     /*  961976 */   // Label 14445: @961976
     /*  961976 */   GIM_Try, /*On fail goto*//*Label 14446*/ GIMT_Encode4(962068), // Rule ID 5117 //
     /*  961981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  961984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  961989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  961992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  961995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  961998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  962004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962031 */     // MIs[1] Operand 1
     /*  962031 */     // No operand predicates
     /*  962031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962044 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  962044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  962066 */     GIR_RootConstrainSelectedInstOperands,
     /*  962067 */     // GIR_Coverage, 5117,
     /*  962067 */     GIR_EraseRootFromParent_Done,
     /*  962068 */   // Label 14446: @962068
     /*  962068 */   GIM_Try, /*On fail goto*//*Label 14447*/ GIMT_Encode4(962160), // Rule ID 5118 //
     /*  962073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962119 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962123 */     // MIs[1] Operand 1
     /*  962123 */     // No operand predicates
     /*  962123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962158 */     GIR_RootConstrainSelectedInstOperands,
     /*  962159 */     // GIR_Coverage, 5118,
     /*  962159 */     GIR_EraseRootFromParent_Done,
     /*  962160 */   // Label 14447: @962160
     /*  962160 */   GIM_Try, /*On fail goto*//*Label 14448*/ GIMT_Encode4(962252), // Rule ID 5119 //
     /*  962165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  962176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  962179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  962182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962215 */     // MIs[1] Operand 1
     /*  962215 */     // No operand predicates
     /*  962215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962228 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962250 */     GIR_RootConstrainSelectedInstOperands,
     /*  962251 */     // GIR_Coverage, 5119,
     /*  962251 */     GIR_EraseRootFromParent_Done,
     /*  962252 */   // Label 14448: @962252
     /*  962252 */   GIM_Try, /*On fail goto*//*Label 14449*/ GIMT_Encode4(962344), // Rule ID 5120 //
     /*  962257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962307 */     // MIs[1] Operand 1
     /*  962307 */     // No operand predicates
     /*  962307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962342 */     GIR_RootConstrainSelectedInstOperands,
     /*  962343 */     // GIR_Coverage, 5120,
     /*  962343 */     GIR_EraseRootFromParent_Done,
     /*  962344 */   // Label 14449: @962344
     /*  962344 */   GIM_Try, /*On fail goto*//*Label 14450*/ GIMT_Encode4(962436), // Rule ID 5121 //
     /*  962349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  962360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  962363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  962366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  962372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962399 */     // MIs[1] Operand 1
     /*  962399 */     // No operand predicates
     /*  962399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962412 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962434 */     GIR_RootConstrainSelectedInstOperands,
     /*  962435 */     // GIR_Coverage, 5121,
     /*  962435 */     GIR_EraseRootFromParent_Done,
     /*  962436 */   // Label 14450: @962436
     /*  962436 */   GIM_Try, /*On fail goto*//*Label 14451*/ GIMT_Encode4(962528), // Rule ID 5122 //
     /*  962441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  962444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  962452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  962455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  962458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962491 */     // MIs[1] Operand 1
     /*  962491 */     // No operand predicates
     /*  962491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962504 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  962504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962526 */     GIR_RootConstrainSelectedInstOperands,
     /*  962527 */     // GIR_Coverage, 5122,
     /*  962527 */     GIR_EraseRootFromParent_Done,
     /*  962528 */   // Label 14451: @962528
     /*  962528 */   GIM_Try, /*On fail goto*//*Label 14452*/ GIMT_Encode4(962620), // Rule ID 5123 //
     /*  962533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  962536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  962544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  962547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  962550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  962556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  962563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  962571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962583 */     // MIs[1] Operand 1
     /*  962583 */     // No operand predicates
     /*  962583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962596 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  962596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  962599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  962618 */     GIR_RootConstrainSelectedInstOperands,
     /*  962619 */     // GIR_Coverage, 5123,
     /*  962619 */     GIR_EraseRootFromParent_Done,
     /*  962620 */   // Label 14452: @962620
     /*  962620 */   GIM_Try, /*On fail goto*//*Label 14453*/ GIMT_Encode4(962712), // Rule ID 5124 //
     /*  962625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  962628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  962639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  962648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962675 */     // MIs[1] Operand 1
     /*  962675 */     // No operand predicates
     /*  962675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  962688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962710 */     GIR_RootConstrainSelectedInstOperands,
     /*  962711 */     // GIR_Coverage, 5124,
     /*  962711 */     GIR_EraseRootFromParent_Done,
     /*  962712 */   // Label 14453: @962712
     /*  962712 */   GIM_Try, /*On fail goto*//*Label 14454*/ GIMT_Encode4(962804), // Rule ID 5125 //
     /*  962717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  962720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  962728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  962731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  962734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  962740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  962747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  962755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962767 */     // MIs[1] Operand 1
     /*  962767 */     // No operand predicates
     /*  962767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  962780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M2),
     /*  962783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962802 */     GIR_RootConstrainSelectedInstOperands,
     /*  962803 */     // GIR_Coverage, 5125,
     /*  962803 */     GIR_EraseRootFromParent_Done,
     /*  962804 */   // Label 14454: @962804
     /*  962804 */   GIM_Try, /*On fail goto*//*Label 14455*/ GIMT_Encode4(962896), // Rule ID 5126 //
     /*  962809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  962812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  962823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  962829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  962835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962859 */     // MIs[1] Operand 1
     /*  962859 */     // No operand predicates
     /*  962859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962872 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  962872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962894 */     GIR_RootConstrainSelectedInstOperands,
     /*  962895 */     // GIR_Coverage, 5126,
     /*  962895 */     GIR_EraseRootFromParent_Done,
     /*  962896 */   // Label 14455: @962896
     /*  962896 */   GIM_Try, /*On fail goto*//*Label 14456*/ GIMT_Encode4(962988), // Rule ID 5127 //
     /*  962901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  962904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  962909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  962912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  962915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  962918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  962921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  962924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  962927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  962931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  962939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  962943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  962947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  962951 */     // MIs[1] Operand 1
     /*  962951 */     // No operand predicates
     /*  962951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  962955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  962957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  962964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  962964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M4),
     /*  962967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  962969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  962971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  962973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  962976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  962978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  962983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  962986 */     GIR_RootConstrainSelectedInstOperands,
     /*  962987 */     // GIR_Coverage, 5127,
     /*  962987 */     GIR_EraseRootFromParent_Done,
     /*  962988 */   // Label 14456: @962988
     /*  962988 */   GIM_Try, /*On fail goto*//*Label 14457*/ GIMT_Encode4(963080), // Rule ID 5128 //
     /*  962993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  962996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963043 */     // MIs[1] Operand 1
     /*  963043 */     // No operand predicates
     /*  963043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  963056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963078 */     GIR_RootConstrainSelectedInstOperands,
     /*  963079 */     // GIR_Coverage, 5128,
     /*  963079 */     GIR_EraseRootFromParent_Done,
     /*  963080 */   // Label 14457: @963080
     /*  963080 */   GIM_Try, /*On fail goto*//*Label 14458*/ GIMT_Encode4(963172), // Rule ID 5129 //
     /*  963085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  963088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /*  963093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  963096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  963099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  963102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  963108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  963115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  963123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963135 */     // MIs[1] Operand 1
     /*  963135 */     // No operand predicates
     /*  963135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963148 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  963148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VIM_M8),
     /*  963151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  963170 */     GIR_RootConstrainSelectedInstOperands,
     /*  963171 */     // GIR_Coverage, 5129,
     /*  963171 */     GIR_EraseRootFromParent_Done,
     /*  963172 */   // Label 14458: @963172
     /*  963172 */   GIM_Try, /*On fail goto*//*Label 14459*/ GIMT_Encode4(963267), // Rule ID 7860 //
     /*  963177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963227 */     // MIs[1] Operand 1
     /*  963227 */     // No operand predicates
     /*  963227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963240 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963265 */     GIR_RootConstrainSelectedInstOperands,
     /*  963266 */     // GIR_Coverage, 7860,
     /*  963266 */     GIR_EraseRootFromParent_Done,
     /*  963267 */   // Label 14459: @963267
     /*  963267 */   GIM_Try, /*On fail goto*//*Label 14460*/ GIMT_Encode4(963362), // Rule ID 7861 //
     /*  963272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  963289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963322 */     // MIs[1] Operand 1
     /*  963322 */     // No operand predicates
     /*  963322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963335 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  963335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF8_MASK),
     /*  963338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963360 */     GIR_RootConstrainSelectedInstOperands,
     /*  963361 */     // GIR_Coverage, 7861,
     /*  963361 */     GIR_EraseRootFromParent_Done,
     /*  963362 */   // Label 14460: @963362
     /*  963362 */   GIM_Try, /*On fail goto*//*Label 14461*/ GIMT_Encode4(963457), // Rule ID 7864 //
     /*  963367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963417 */     // MIs[1] Operand 1
     /*  963417 */     // No operand predicates
     /*  963417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963430 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963455 */     GIR_RootConstrainSelectedInstOperands,
     /*  963456 */     // GIR_Coverage, 7864,
     /*  963456 */     GIR_EraseRootFromParent_Done,
     /*  963457 */   // Label 14461: @963457
     /*  963457 */   GIM_Try, /*On fail goto*//*Label 14462*/ GIMT_Encode4(963552), // Rule ID 7865 //
     /*  963462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  963479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963512 */     // MIs[1] Operand 1
     /*  963512 */     // No operand predicates
     /*  963512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963525 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  963525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963550 */     GIR_RootConstrainSelectedInstOperands,
     /*  963551 */     // GIR_Coverage, 7865,
     /*  963551 */     GIR_EraseRootFromParent_Done,
     /*  963552 */   // Label 14462: @963552
     /*  963552 */   GIM_Try, /*On fail goto*//*Label 14463*/ GIMT_Encode4(963647), // Rule ID 7868 //
     /*  963557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  963568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  963571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963607 */     // MIs[1] Operand 1
     /*  963607 */     // No operand predicates
     /*  963607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  963620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  963623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963645 */     GIR_RootConstrainSelectedInstOperands,
     /*  963646 */     // GIR_Coverage, 7868,
     /*  963646 */     GIR_EraseRootFromParent_Done,
     /*  963647 */   // Label 14463: @963647
     /*  963647 */   GIM_Try, /*On fail goto*//*Label 14464*/ GIMT_Encode4(963742), // Rule ID 7869 //
     /*  963652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  963663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  963666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  963669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  963675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963702 */     // MIs[1] Operand 1
     /*  963702 */     // No operand predicates
     /*  963702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963715 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  963715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  963718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  963737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963740 */     GIR_RootConstrainSelectedInstOperands,
     /*  963741 */     // GIR_Coverage, 7869,
     /*  963741 */     GIR_EraseRootFromParent_Done,
     /*  963742 */   // Label 14464: @963742
     /*  963742 */   GIM_Try, /*On fail goto*//*Label 14465*/ GIMT_Encode4(963837), // Rule ID 7872 //
     /*  963747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  963764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963797 */     // MIs[1] Operand 1
     /*  963797 */     // No operand predicates
     /*  963797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963810 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  963810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963835 */     GIR_RootConstrainSelectedInstOperands,
     /*  963836 */     // GIR_Coverage, 7872,
     /*  963836 */     GIR_EraseRootFromParent_Done,
     /*  963837 */   // Label 14465: @963837
     /*  963837 */   GIM_Try, /*On fail goto*//*Label 14466*/ GIMT_Encode4(963932), // Rule ID 7873 //
     /*  963842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  963845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  963853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  963856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  963859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  963862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  963865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  963868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963892 */     // MIs[1] Operand 1
     /*  963892 */     // No operand predicates
     /*  963892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  963905 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  963905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF4_MASK),
     /*  963908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  963910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  963912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  963914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  963917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  963919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  963924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  963927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  963930 */     GIR_RootConstrainSelectedInstOperands,
     /*  963931 */     // GIR_Coverage, 7873,
     /*  963931 */     GIR_EraseRootFromParent_Done,
     /*  963932 */   // Label 14466: @963932
     /*  963932 */   GIM_Try, /*On fail goto*//*Label 14467*/ GIMT_Encode4(964027), // Rule ID 7876 //
     /*  963937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  963940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  963945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  963948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  963951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  963954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  963957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  963960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  963963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  963975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  963979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  963983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  963987 */     // MIs[1] Operand 1
     /*  963987 */     // No operand predicates
     /*  963987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  963991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  963993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964025 */     GIR_RootConstrainSelectedInstOperands,
     /*  964026 */     // GIR_Coverage, 7876,
     /*  964026 */     GIR_EraseRootFromParent_Done,
     /*  964027 */   // Label 14467: @964027
     /*  964027 */   GIM_Try, /*On fail goto*//*Label 14468*/ GIMT_Encode4(964122), // Rule ID 7877 //
     /*  964032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  964049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964082 */     // MIs[1] Operand 1
     /*  964082 */     // No operand predicates
     /*  964082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964095 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964120 */     GIR_RootConstrainSelectedInstOperands,
     /*  964121 */     // GIR_Coverage, 7877,
     /*  964121 */     GIR_EraseRootFromParent_Done,
     /*  964122 */   // Label 14468: @964122
     /*  964122 */   GIM_Try, /*On fail goto*//*Label 14469*/ GIMT_Encode4(964217), // Rule ID 7880 //
     /*  964127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964177 */     // MIs[1] Operand 1
     /*  964177 */     // No operand predicates
     /*  964177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964190 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  964190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964215 */     GIR_RootConstrainSelectedInstOperands,
     /*  964216 */     // GIR_Coverage, 7880,
     /*  964216 */     GIR_EraseRootFromParent_Done,
     /*  964217 */   // Label 14469: @964217
     /*  964217 */   GIM_Try, /*On fail goto*//*Label 14470*/ GIMT_Encode4(964312), // Rule ID 7881 //
     /*  964222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  964239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964272 */     // MIs[1] Operand 1
     /*  964272 */     // No operand predicates
     /*  964272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964285 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  964285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_MF2_MASK),
     /*  964288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964310 */     GIR_RootConstrainSelectedInstOperands,
     /*  964311 */     // GIR_Coverage, 7881,
     /*  964311 */     GIR_EraseRootFromParent_Done,
     /*  964312 */   // Label 14470: @964312
     /*  964312 */   GIM_Try, /*On fail goto*//*Label 14471*/ GIMT_Encode4(964407), // Rule ID 7884 //
     /*  964317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964367 */     // MIs[1] Operand 1
     /*  964367 */     // No operand predicates
     /*  964367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  964380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964405 */     GIR_RootConstrainSelectedInstOperands,
     /*  964406 */     // GIR_Coverage, 7884,
     /*  964406 */     GIR_EraseRootFromParent_Done,
     /*  964407 */   // Label 14471: @964407
     /*  964407 */   GIM_Try, /*On fail goto*//*Label 14472*/ GIMT_Encode4(964502), // Rule ID 7885 //
     /*  964412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  964423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  964426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  964429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  964435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964462 */     // MIs[1] Operand 1
     /*  964462 */     // No operand predicates
     /*  964462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  964475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  964497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964500 */     GIR_RootConstrainSelectedInstOperands,
     /*  964501 */     // GIR_Coverage, 7885,
     /*  964501 */     GIR_EraseRootFromParent_Done,
     /*  964502 */   // Label 14472: @964502
     /*  964502 */   GIM_Try, /*On fail goto*//*Label 14473*/ GIMT_Encode4(964597), // Rule ID 7888 //
     /*  964507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964557 */     // MIs[1] Operand 1
     /*  964557 */     // No operand predicates
     /*  964557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964570 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  964570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964595 */     GIR_RootConstrainSelectedInstOperands,
     /*  964596 */     // GIR_Coverage, 7888,
     /*  964596 */     GIR_EraseRootFromParent_Done,
     /*  964597 */   // Label 14473: @964597
     /*  964597 */   GIM_Try, /*On fail goto*//*Label 14474*/ GIMT_Encode4(964692), // Rule ID 7889 //
     /*  964602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  964613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  964616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  964619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  964625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964652 */     // MIs[1] Operand 1
     /*  964652 */     // No operand predicates
     /*  964652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964665 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  964665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  964687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964690 */     GIR_RootConstrainSelectedInstOperands,
     /*  964691 */     // GIR_Coverage, 7889,
     /*  964691 */     GIR_EraseRootFromParent_Done,
     /*  964692 */   // Label 14474: @964692
     /*  964692 */   GIM_Try, /*On fail goto*//*Label 14475*/ GIMT_Encode4(964787), // Rule ID 7892 //
     /*  964697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  964700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964747 */     // MIs[1] Operand 1
     /*  964747 */     // No operand predicates
     /*  964747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964760 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  964760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964785 */     GIR_RootConstrainSelectedInstOperands,
     /*  964786 */     // GIR_Coverage, 7892,
     /*  964786 */     GIR_EraseRootFromParent_Done,
     /*  964787 */   // Label 14475: @964787
     /*  964787 */   GIM_Try, /*On fail goto*//*Label 14476*/ GIMT_Encode4(964882), // Rule ID 7893 //
     /*  964792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  964795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  964803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  964806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  964809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  964812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  964815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  964818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964842 */     // MIs[1] Operand 1
     /*  964842 */     // No operand predicates
     /*  964842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964855 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  964855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  964877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964880 */     GIR_RootConstrainSelectedInstOperands,
     /*  964881 */     // GIR_Coverage, 7893,
     /*  964881 */     GIR_EraseRootFromParent_Done,
     /*  964882 */   // Label 14476: @964882
     /*  964882 */   GIM_Try, /*On fail goto*//*Label 14477*/ GIMT_Encode4(964977), // Rule ID 7896 //
     /*  964887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  964890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  964904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  964907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  964910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  964913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  964925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  964929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  964933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  964937 */     // MIs[1] Operand 1
     /*  964937 */     // No operand predicates
     /*  964937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  964941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  964943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  964950 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  964950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  964953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  964955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  964957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  964959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  964962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  964964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  964969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  964972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  964975 */     GIR_RootConstrainSelectedInstOperands,
     /*  964976 */     // GIR_Coverage, 7896,
     /*  964976 */     GIR_EraseRootFromParent_Done,
     /*  964977 */   // Label 14477: @964977
     /*  964977 */   GIM_Try, /*On fail goto*//*Label 14478*/ GIMT_Encode4(965072), // Rule ID 7897 //
     /*  964982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  964985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  964990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  964993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  964996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  964999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  965005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965032 */     // MIs[1] Operand 1
     /*  965032 */     // No operand predicates
     /*  965032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965045 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  965045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M1_MASK),
     /*  965048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  965067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965070 */     GIR_RootConstrainSelectedInstOperands,
     /*  965071 */     // GIR_Coverage, 7897,
     /*  965071 */     GIR_EraseRootFromParent_Done,
     /*  965072 */   // Label 14478: @965072
     /*  965072 */   GIM_Try, /*On fail goto*//*Label 14479*/ GIMT_Encode4(965167), // Rule ID 7900 //
     /*  965077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965127 */     // MIs[1] Operand 1
     /*  965127 */     // No operand predicates
     /*  965127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965140 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965165 */     GIR_RootConstrainSelectedInstOperands,
     /*  965166 */     // GIR_Coverage, 7900,
     /*  965166 */     GIR_EraseRootFromParent_Done,
     /*  965167 */   // Label 14479: @965167
     /*  965167 */   GIM_Try, /*On fail goto*//*Label 14480*/ GIMT_Encode4(965262), // Rule ID 7901 //
     /*  965172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  965189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965222 */     // MIs[1] Operand 1
     /*  965222 */     // No operand predicates
     /*  965222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965235 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965260 */     GIR_RootConstrainSelectedInstOperands,
     /*  965261 */     // GIR_Coverage, 7901,
     /*  965261 */     GIR_EraseRootFromParent_Done,
     /*  965262 */   // Label 14480: @965262
     /*  965262 */   GIM_Try, /*On fail goto*//*Label 14481*/ GIMT_Encode4(965357), // Rule ID 7904 //
     /*  965267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965317 */     // MIs[1] Operand 1
     /*  965317 */     // No operand predicates
     /*  965317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965330 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965355 */     GIR_RootConstrainSelectedInstOperands,
     /*  965356 */     // GIR_Coverage, 7904,
     /*  965356 */     GIR_EraseRootFromParent_Done,
     /*  965357 */   // Label 14481: @965357
     /*  965357 */   GIM_Try, /*On fail goto*//*Label 14482*/ GIMT_Encode4(965452), // Rule ID 7905 //
     /*  965362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  965373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  965376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  965379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  965385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965412 */     // MIs[1] Operand 1
     /*  965412 */     // No operand predicates
     /*  965412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965425 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965450 */     GIR_RootConstrainSelectedInstOperands,
     /*  965451 */     // GIR_Coverage, 7905,
     /*  965451 */     GIR_EraseRootFromParent_Done,
     /*  965452 */   // Label 14482: @965452
     /*  965452 */   GIM_Try, /*On fail goto*//*Label 14483*/ GIMT_Encode4(965547), // Rule ID 7908 //
     /*  965457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  965468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  965471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965507 */     // MIs[1] Operand 1
     /*  965507 */     // No operand predicates
     /*  965507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965520 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  965520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  965523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965545 */     GIR_RootConstrainSelectedInstOperands,
     /*  965546 */     // GIR_Coverage, 7908,
     /*  965546 */     GIR_EraseRootFromParent_Done,
     /*  965547 */   // Label 14483: @965547
     /*  965547 */   GIM_Try, /*On fail goto*//*Label 14484*/ GIMT_Encode4(965642), // Rule ID 7909 //
     /*  965552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  965563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  965566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  965569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  965575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  965590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965602 */     // MIs[1] Operand 1
     /*  965602 */     // No operand predicates
     /*  965602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965615 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  965615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  965618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  965637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965640 */     GIR_RootConstrainSelectedInstOperands,
     /*  965641 */     // GIR_Coverage, 7909,
     /*  965641 */     GIR_EraseRootFromParent_Done,
     /*  965642 */   // Label 14484: @965642
     /*  965642 */   GIM_Try, /*On fail goto*//*Label 14485*/ GIMT_Encode4(965737), // Rule ID 7912 //
     /*  965647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965697 */     // MIs[1] Operand 1
     /*  965697 */     // No operand predicates
     /*  965697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965710 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965735 */     GIR_RootConstrainSelectedInstOperands,
     /*  965736 */     // GIR_Coverage, 7912,
     /*  965736 */     GIR_EraseRootFromParent_Done,
     /*  965737 */   // Label 14485: @965737
     /*  965737 */   GIM_Try, /*On fail goto*//*Label 14486*/ GIMT_Encode4(965832), // Rule ID 7913 //
     /*  965742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  965753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  965756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  965759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  965765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  965780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965792 */     // MIs[1] Operand 1
     /*  965792 */     // No operand predicates
     /*  965792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965805 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  965808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965830 */     GIR_RootConstrainSelectedInstOperands,
     /*  965831 */     // GIR_Coverage, 7913,
     /*  965831 */     GIR_EraseRootFromParent_Done,
     /*  965832 */   // Label 14486: @965832
     /*  965832 */   GIM_Try, /*On fail goto*//*Label 14487*/ GIMT_Encode4(965927), // Rule ID 7916 //
     /*  965837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  965840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  965854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  965857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  965863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965887 */     // MIs[1] Operand 1
     /*  965887 */     // No operand predicates
     /*  965887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965900 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  965900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  965905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  965907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  965909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  965912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  965914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  965919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  965922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  965925 */     GIR_RootConstrainSelectedInstOperands,
     /*  965926 */     // GIR_Coverage, 7916,
     /*  965926 */     GIR_EraseRootFromParent_Done,
     /*  965927 */   // Label 14487: @965927
     /*  965927 */   GIM_Try, /*On fail goto*//*Label 14488*/ GIMT_Encode4(966022), // Rule ID 7917 //
     /*  965932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  965935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  965940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  965943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  965946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  965949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  965952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  965955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  965958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  965966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  965970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  965974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  965978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  965982 */     // MIs[1] Operand 1
     /*  965982 */     // No operand predicates
     /*  965982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  965986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  965988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  965995 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  965995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  965998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966020 */     GIR_RootConstrainSelectedInstOperands,
     /*  966021 */     // GIR_Coverage, 7917,
     /*  966021 */     GIR_EraseRootFromParent_Done,
     /*  966022 */   // Label 14488: @966022
     /*  966022 */   GIM_Try, /*On fail goto*//*Label 14489*/ GIMT_Encode4(966117), // Rule ID 7920 //
     /*  966027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966077 */     // MIs[1] Operand 1
     /*  966077 */     // No operand predicates
     /*  966077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966090 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  966090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966115 */     GIR_RootConstrainSelectedInstOperands,
     /*  966116 */     // GIR_Coverage, 7920,
     /*  966116 */     GIR_EraseRootFromParent_Done,
     /*  966117 */   // Label 14489: @966117
     /*  966117 */   GIM_Try, /*On fail goto*//*Label 14490*/ GIMT_Encode4(966212), // Rule ID 7921 //
     /*  966122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  966133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  966136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  966139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  966145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966172 */     // MIs[1] Operand 1
     /*  966172 */     // No operand predicates
     /*  966172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966185 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  966185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  966207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966210 */     GIR_RootConstrainSelectedInstOperands,
     /*  966211 */     // GIR_Coverage, 7921,
     /*  966211 */     GIR_EraseRootFromParent_Done,
     /*  966212 */   // Label 14490: @966212
     /*  966212 */   GIM_Try, /*On fail goto*//*Label 14491*/ GIMT_Encode4(966307), // Rule ID 7924 //
     /*  966217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966267 */     // MIs[1] Operand 1
     /*  966267 */     // No operand predicates
     /*  966267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966280 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966305 */     GIR_RootConstrainSelectedInstOperands,
     /*  966306 */     // GIR_Coverage, 7924,
     /*  966306 */     GIR_EraseRootFromParent_Done,
     /*  966307 */   // Label 14491: @966307
     /*  966307 */   GIM_Try, /*On fail goto*//*Label 14492*/ GIMT_Encode4(966402), // Rule ID 7925 //
     /*  966312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  966329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  966335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966362 */     // MIs[1] Operand 1
     /*  966362 */     // No operand predicates
     /*  966362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966375 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  966375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966400 */     GIR_RootConstrainSelectedInstOperands,
     /*  966401 */     // GIR_Coverage, 7925,
     /*  966401 */     GIR_EraseRootFromParent_Done,
     /*  966402 */   // Label 14492: @966402
     /*  966402 */   GIM_Try, /*On fail goto*//*Label 14493*/ GIMT_Encode4(966497), // Rule ID 7928 //
     /*  966407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966457 */     // MIs[1] Operand 1
     /*  966457 */     // No operand predicates
     /*  966457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966470 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966495 */     GIR_RootConstrainSelectedInstOperands,
     /*  966496 */     // GIR_Coverage, 7928,
     /*  966496 */     GIR_EraseRootFromParent_Done,
     /*  966497 */   // Label 14493: @966497
     /*  966497 */   GIM_Try, /*On fail goto*//*Label 14494*/ GIMT_Encode4(966592), // Rule ID 7929 //
     /*  966502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  966513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  966516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  966519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  966525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  966540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966552 */     // MIs[1] Operand 1
     /*  966552 */     // No operand predicates
     /*  966552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966565 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  966565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  966568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966590 */     GIR_RootConstrainSelectedInstOperands,
     /*  966591 */     // GIR_Coverage, 7929,
     /*  966591 */     GIR_EraseRootFromParent_Done,
     /*  966592 */   // Label 14494: @966592
     /*  966592 */   GIM_Try, /*On fail goto*//*Label 14495*/ GIMT_Encode4(966687), // Rule ID 7932 //
     /*  966597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  966600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966647 */     // MIs[1] Operand 1
     /*  966647 */     // No operand predicates
     /*  966647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966660 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  966660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966685 */     GIR_RootConstrainSelectedInstOperands,
     /*  966686 */     // GIR_Coverage, 7932,
     /*  966686 */     GIR_EraseRootFromParent_Done,
     /*  966687 */   // Label 14495: @966687
     /*  966687 */   GIM_Try, /*On fail goto*//*Label 14496*/ GIMT_Encode4(966782), // Rule ID 7933 //
     /*  966692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  966695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  966703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  966706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  966709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  966715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  966730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966742 */     // MIs[1] Operand 1
     /*  966742 */     // No operand predicates
     /*  966742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966755 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  966755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  966758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  966777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966780 */     GIR_RootConstrainSelectedInstOperands,
     /*  966781 */     // GIR_Coverage, 7933,
     /*  966781 */     GIR_EraseRootFromParent_Done,
     /*  966782 */   // Label 14496: @966782
     /*  966782 */   GIM_Try, /*On fail goto*//*Label 14497*/ GIMT_Encode4(966877), // Rule ID 7936 //
     /*  966787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  966790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  966798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  966801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  966804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  966810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  966813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966837 */     // MIs[1] Operand 1
     /*  966837 */     // No operand predicates
     /*  966837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966850 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  966850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  966872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966875 */     GIR_RootConstrainSelectedInstOperands,
     /*  966876 */     // GIR_Coverage, 7936,
     /*  966876 */     GIR_EraseRootFromParent_Done,
     /*  966877 */   // Label 14497: @966877
     /*  966877 */   GIM_Try, /*On fail goto*//*Label 14498*/ GIMT_Encode4(966972), // Rule ID 7937 //
     /*  966882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  966885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  966893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  966896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  966899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  966902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  966905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  966908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  966916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  966920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  966924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  966928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  966932 */     // MIs[1] Operand 1
     /*  966932 */     // No operand predicates
     /*  966932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  966936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  966938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  966945 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  966945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M2_MASK),
     /*  966948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  966950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  966952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  966954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  966957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  966959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  966964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  966967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  966970 */     GIR_RootConstrainSelectedInstOperands,
     /*  966971 */     // GIR_Coverage, 7937,
     /*  966971 */     GIR_EraseRootFromParent_Done,
     /*  966972 */   // Label 14498: @966972
     /*  966972 */   GIM_Try, /*On fail goto*//*Label 14499*/ GIMT_Encode4(967067), // Rule ID 7940 //
     /*  966977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  966980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  966985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  966988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  966991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  966994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  966997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967027 */     // MIs[1] Operand 1
     /*  967027 */     // No operand predicates
     /*  967027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967040 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967065 */     GIR_RootConstrainSelectedInstOperands,
     /*  967066 */     // GIR_Coverage, 7940,
     /*  967066 */     GIR_EraseRootFromParent_Done,
     /*  967067 */   // Label 14499: @967067
     /*  967067 */   GIM_Try, /*On fail goto*//*Label 14500*/ GIMT_Encode4(967162), // Rule ID 7941 //
     /*  967072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  967089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  967110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967122 */     // MIs[1] Operand 1
     /*  967122 */     // No operand predicates
     /*  967122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967135 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M4_MASK),
     /*  967138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967160 */     GIR_RootConstrainSelectedInstOperands,
     /*  967161 */     // GIR_Coverage, 7941,
     /*  967161 */     GIR_EraseRootFromParent_Done,
     /*  967162 */   // Label 14500: @967162
     /*  967162 */   GIM_Try, /*On fail goto*//*Label 14501*/ GIMT_Encode4(967257), // Rule ID 7944 //
     /*  967167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  967170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967217 */     // MIs[1] Operand 1
     /*  967217 */     // No operand predicates
     /*  967217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967230 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  967230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967255 */     GIR_RootConstrainSelectedInstOperands,
     /*  967256 */     // GIR_Coverage, 7944,
     /*  967256 */     GIR_EraseRootFromParent_Done,
     /*  967257 */   // Label 14501: @967257
     /*  967257 */   GIM_Try, /*On fail goto*//*Label 14502*/ GIMT_Encode4(967352), // Rule ID 7945 //
     /*  967262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  967265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /*  967270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  967273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  967276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  967279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  967285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  967300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967312 */     // MIs[1] Operand 1
     /*  967312 */     // No operand predicates
     /*  967312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967325 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  967325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VI_M8_MASK),
     /*  967328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  967347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967350 */     GIR_RootConstrainSelectedInstOperands,
     /*  967351 */     // GIR_Coverage, 7945,
     /*  967351 */     GIR_EraseRootFromParent_Done,
     /*  967352 */   // Label 14502: @967352
     /*  967352 */   GIM_Try, /*On fail goto*//*Label 14503*/ GIMT_Encode4(967447), // Rule ID 8124 //
     /*  967357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967407 */     // MIs[1] Operand 1
     /*  967407 */     // No operand predicates
     /*  967407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  967423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967445 */     GIR_RootConstrainSelectedInstOperands,
     /*  967446 */     // GIR_Coverage, 8124,
     /*  967446 */     GIR_EraseRootFromParent_Done,
     /*  967447 */   // Label 14503: @967447
     /*  967447 */   GIM_Try, /*On fail goto*//*Label 14504*/ GIMT_Encode4(967542), // Rule ID 8125 //
     /*  967452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  967469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967502 */     // MIs[1] Operand 1
     /*  967502 */     // No operand predicates
     /*  967502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967515 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF8_MASK),
     /*  967518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967540 */     GIR_RootConstrainSelectedInstOperands,
     /*  967541 */     // GIR_Coverage, 8125,
     /*  967541 */     GIR_EraseRootFromParent_Done,
     /*  967542 */   // Label 14504: @967542
     /*  967542 */   GIM_Try, /*On fail goto*//*Label 14505*/ GIMT_Encode4(967637), // Rule ID 8128 //
     /*  967547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967597 */     // MIs[1] Operand 1
     /*  967597 */     // No operand predicates
     /*  967597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967610 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  967613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967635 */     GIR_RootConstrainSelectedInstOperands,
     /*  967636 */     // GIR_Coverage, 8128,
     /*  967636 */     GIR_EraseRootFromParent_Done,
     /*  967637 */   // Label 14505: @967637
     /*  967637 */   GIM_Try, /*On fail goto*//*Label 14506*/ GIMT_Encode4(967732), // Rule ID 8129 //
     /*  967642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  967653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  967656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  967659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  967665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967692 */     // MIs[1] Operand 1
     /*  967692 */     // No operand predicates
     /*  967692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967705 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  967708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967730 */     GIR_RootConstrainSelectedInstOperands,
     /*  967731 */     // GIR_Coverage, 8129,
     /*  967731 */     GIR_EraseRootFromParent_Done,
     /*  967732 */   // Label 14506: @967732
     /*  967732 */   GIM_Try, /*On fail goto*//*Label 14507*/ GIMT_Encode4(967827), // Rule ID 8132 //
     /*  967737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967787 */     // MIs[1] Operand 1
     /*  967787 */     // No operand predicates
     /*  967787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967800 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  967800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  967803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967825 */     GIR_RootConstrainSelectedInstOperands,
     /*  967826 */     // GIR_Coverage, 8132,
     /*  967826 */     GIR_EraseRootFromParent_Done,
     /*  967827 */   // Label 14507: @967827
     /*  967827 */   GIM_Try, /*On fail goto*//*Label 14508*/ GIMT_Encode4(967922), // Rule ID 8133 //
     /*  967832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  967835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  967843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  967846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  967849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  967852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  967855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  967858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967882 */     // MIs[1] Operand 1
     /*  967882 */     // No operand predicates
     /*  967882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967895 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  967895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  967898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  967907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  967909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  967914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  967917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  967920 */     GIR_RootConstrainSelectedInstOperands,
     /*  967921 */     // GIR_Coverage, 8133,
     /*  967921 */     GIR_EraseRootFromParent_Done,
     /*  967922 */   // Label 14508: @967922
     /*  967922 */   GIM_Try, /*On fail goto*//*Label 14509*/ GIMT_Encode4(968017), // Rule ID 8136 //
     /*  967927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  967930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  967935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  967938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  967941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  967944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  967947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  967950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  967953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  967965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  967969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  967973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  967977 */     // MIs[1] Operand 1
     /*  967977 */     // No operand predicates
     /*  967977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  967981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  967983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  967990 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  967990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  967993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  967995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  967997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  967999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968015 */     GIR_RootConstrainSelectedInstOperands,
     /*  968016 */     // GIR_Coverage, 8136,
     /*  968016 */     GIR_EraseRootFromParent_Done,
     /*  968017 */   // Label 14509: @968017
     /*  968017 */   GIM_Try, /*On fail goto*//*Label 14510*/ GIMT_Encode4(968112), // Rule ID 8137 //
     /*  968022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  968039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968072 */     // MIs[1] Operand 1
     /*  968072 */     // No operand predicates
     /*  968072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968085 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF4_MASK),
     /*  968088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968110 */     GIR_RootConstrainSelectedInstOperands,
     /*  968111 */     // GIR_Coverage, 8137,
     /*  968111 */     GIR_EraseRootFromParent_Done,
     /*  968112 */   // Label 14510: @968112
     /*  968112 */   GIM_Try, /*On fail goto*//*Label 14511*/ GIMT_Encode4(968207), // Rule ID 8140 //
     /*  968117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968167 */     // MIs[1] Operand 1
     /*  968167 */     // No operand predicates
     /*  968167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968180 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968205 */     GIR_RootConstrainSelectedInstOperands,
     /*  968206 */     // GIR_Coverage, 8140,
     /*  968206 */     GIR_EraseRootFromParent_Done,
     /*  968207 */   // Label 14511: @968207
     /*  968207 */   GIM_Try, /*On fail goto*//*Label 14512*/ GIMT_Encode4(968302), // Rule ID 8141 //
     /*  968212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  968229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968262 */     // MIs[1] Operand 1
     /*  968262 */     // No operand predicates
     /*  968262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968275 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968300 */     GIR_RootConstrainSelectedInstOperands,
     /*  968301 */     // GIR_Coverage, 8141,
     /*  968301 */     GIR_EraseRootFromParent_Done,
     /*  968302 */   // Label 14512: @968302
     /*  968302 */   GIM_Try, /*On fail goto*//*Label 14513*/ GIMT_Encode4(968397), // Rule ID 8144 //
     /*  968307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968357 */     // MIs[1] Operand 1
     /*  968357 */     // No operand predicates
     /*  968357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968370 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968395 */     GIR_RootConstrainSelectedInstOperands,
     /*  968396 */     // GIR_Coverage, 8144,
     /*  968396 */     GIR_EraseRootFromParent_Done,
     /*  968397 */   // Label 14513: @968397
     /*  968397 */   GIM_Try, /*On fail goto*//*Label 14514*/ GIMT_Encode4(968492), // Rule ID 8145 //
     /*  968402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  968413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  968416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  968419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  968425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968452 */     // MIs[1] Operand 1
     /*  968452 */     // No operand predicates
     /*  968452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968465 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  968465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_MF2_MASK),
     /*  968468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968490 */     GIR_RootConstrainSelectedInstOperands,
     /*  968491 */     // GIR_Coverage, 8145,
     /*  968491 */     GIR_EraseRootFromParent_Done,
     /*  968492 */   // Label 14514: @968492
     /*  968492 */   GIM_Try, /*On fail goto*//*Label 14515*/ GIMT_Encode4(968587), // Rule ID 8148 //
     /*  968497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968547 */     // MIs[1] Operand 1
     /*  968547 */     // No operand predicates
     /*  968547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968560 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  968560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  968563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968585 */     GIR_RootConstrainSelectedInstOperands,
     /*  968586 */     // GIR_Coverage, 8148,
     /*  968586 */     GIR_EraseRootFromParent_Done,
     /*  968587 */   // Label 14515: @968587
     /*  968587 */   GIM_Try, /*On fail goto*//*Label 14516*/ GIMT_Encode4(968682), // Rule ID 8149 //
     /*  968592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  968603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  968606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  968609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  968615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968642 */     // MIs[1] Operand 1
     /*  968642 */     // No operand predicates
     /*  968642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968655 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  968655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  968658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  968677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968680 */     GIR_RootConstrainSelectedInstOperands,
     /*  968681 */     // GIR_Coverage, 8149,
     /*  968681 */     GIR_EraseRootFromParent_Done,
     /*  968682 */   // Label 14516: @968682
     /*  968682 */   GIM_Try, /*On fail goto*//*Label 14517*/ GIMT_Encode4(968777), // Rule ID 8152 //
     /*  968687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968737 */     // MIs[1] Operand 1
     /*  968737 */     // No operand predicates
     /*  968737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968750 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  968750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  968753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968775 */     GIR_RootConstrainSelectedInstOperands,
     /*  968776 */     // GIR_Coverage, 8152,
     /*  968776 */     GIR_EraseRootFromParent_Done,
     /*  968777 */   // Label 14517: @968777
     /*  968777 */   GIM_Try, /*On fail goto*//*Label 14518*/ GIMT_Encode4(968872), // Rule ID 8153 //
     /*  968782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  968793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  968796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  968799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  968805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968832 */     // MIs[1] Operand 1
     /*  968832 */     // No operand predicates
     /*  968832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968845 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  968845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  968848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  968867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968870 */     GIR_RootConstrainSelectedInstOperands,
     /*  968871 */     // GIR_Coverage, 8153,
     /*  968871 */     GIR_EraseRootFromParent_Done,
     /*  968872 */   // Label 14518: @968872
     /*  968872 */   GIM_Try, /*On fail goto*//*Label 14519*/ GIMT_Encode4(968967), // Rule ID 8156 //
     /*  968877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  968880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  968894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  968897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  968903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  968915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  968919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  968923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  968927 */     // MIs[1] Operand 1
     /*  968927 */     // No operand predicates
     /*  968927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  968931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  968933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  968940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  968940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  968943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  968945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  968947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  968949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  968952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  968954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  968959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  968962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  968965 */     GIR_RootConstrainSelectedInstOperands,
     /*  968966 */     // GIR_Coverage, 8156,
     /*  968966 */     GIR_EraseRootFromParent_Done,
     /*  968967 */   // Label 14519: @968967
     /*  968967 */   GIM_Try, /*On fail goto*//*Label 14520*/ GIMT_Encode4(969062), // Rule ID 8157 //
     /*  968972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  968975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  968980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  968983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  968986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  968989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  968992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  968995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  968998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969022 */     // MIs[1] Operand 1
     /*  969022 */     // No operand predicates
     /*  969022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969035 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  969035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  969057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969060 */     GIR_RootConstrainSelectedInstOperands,
     /*  969061 */     // GIR_Coverage, 8157,
     /*  969061 */     GIR_EraseRootFromParent_Done,
     /*  969062 */   // Label 14520: @969062
     /*  969062 */   GIM_Try, /*On fail goto*//*Label 14521*/ GIMT_Encode4(969157), // Rule ID 8160 //
     /*  969067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  969070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969117 */     // MIs[1] Operand 1
     /*  969117 */     // No operand predicates
     /*  969117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969130 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  969130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969155 */     GIR_RootConstrainSelectedInstOperands,
     /*  969156 */     // GIR_Coverage, 8160,
     /*  969156 */     GIR_EraseRootFromParent_Done,
     /*  969157 */   // Label 14521: @969157
     /*  969157 */   GIM_Try, /*On fail goto*//*Label 14522*/ GIMT_Encode4(969252), // Rule ID 8161 //
     /*  969162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  969165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  969173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  969176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  969179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  969185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969212 */     // MIs[1] Operand 1
     /*  969212 */     // No operand predicates
     /*  969212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969225 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  969225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M1_MASK),
     /*  969228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  969247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969250 */     GIR_RootConstrainSelectedInstOperands,
     /*  969251 */     // GIR_Coverage, 8161,
     /*  969251 */     GIR_EraseRootFromParent_Done,
     /*  969252 */   // Label 14522: @969252
     /*  969252 */   GIM_Try, /*On fail goto*//*Label 14523*/ GIMT_Encode4(969347), // Rule ID 8164 //
     /*  969257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969307 */     // MIs[1] Operand 1
     /*  969307 */     // No operand predicates
     /*  969307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969345 */     GIR_RootConstrainSelectedInstOperands,
     /*  969346 */     // GIR_Coverage, 8164,
     /*  969346 */     GIR_EraseRootFromParent_Done,
     /*  969347 */   // Label 14523: @969347
     /*  969347 */   GIM_Try, /*On fail goto*//*Label 14524*/ GIMT_Encode4(969442), // Rule ID 8165 //
     /*  969352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  969363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  969366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  969369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  969375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969402 */     // MIs[1] Operand 1
     /*  969402 */     // No operand predicates
     /*  969402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969440 */     GIR_RootConstrainSelectedInstOperands,
     /*  969441 */     // GIR_Coverage, 8165,
     /*  969441 */     GIR_EraseRootFromParent_Done,
     /*  969442 */   // Label 14524: @969442
     /*  969442 */   GIM_Try, /*On fail goto*//*Label 14525*/ GIMT_Encode4(969537), // Rule ID 8168 //
     /*  969447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969497 */     // MIs[1] Operand 1
     /*  969497 */     // No operand predicates
     /*  969497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969510 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  969513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969535 */     GIR_RootConstrainSelectedInstOperands,
     /*  969536 */     // GIR_Coverage, 8168,
     /*  969536 */     GIR_EraseRootFromParent_Done,
     /*  969537 */   // Label 14525: @969537
     /*  969537 */   GIM_Try, /*On fail goto*//*Label 14526*/ GIMT_Encode4(969632), // Rule ID 8169 //
     /*  969542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  969553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  969556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  969559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  969565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  969580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969588 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969592 */     // MIs[1] Operand 1
     /*  969592 */     // No operand predicates
     /*  969592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969605 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  969608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969630 */     GIR_RootConstrainSelectedInstOperands,
     /*  969631 */     // GIR_Coverage, 8169,
     /*  969631 */     GIR_EraseRootFromParent_Done,
     /*  969632 */   // Label 14526: @969632
     /*  969632 */   GIM_Try, /*On fail goto*//*Label 14527*/ GIMT_Encode4(969727), // Rule ID 8172 //
     /*  969637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969687 */     // MIs[1] Operand 1
     /*  969687 */     // No operand predicates
     /*  969687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969700 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  969700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  969703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969725 */     GIR_RootConstrainSelectedInstOperands,
     /*  969726 */     // GIR_Coverage, 8172,
     /*  969726 */     GIR_EraseRootFromParent_Done,
     /*  969727 */   // Label 14527: @969727
     /*  969727 */   GIM_Try, /*On fail goto*//*Label 14528*/ GIMT_Encode4(969822), // Rule ID 8173 //
     /*  969732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  969743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  969746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  969749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  969755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  969770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969782 */     // MIs[1] Operand 1
     /*  969782 */     // No operand predicates
     /*  969782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969795 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  969795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  969798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969804 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  969817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969820 */     GIR_RootConstrainSelectedInstOperands,
     /*  969821 */     // GIR_Coverage, 8173,
     /*  969821 */     GIR_EraseRootFromParent_Done,
     /*  969822 */   // Label 14528: @969822
     /*  969822 */   GIM_Try, /*On fail goto*//*Label 14529*/ GIMT_Encode4(969917), // Rule ID 8176 //
     /*  969827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  969830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  969844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  969847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  969853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969877 */     // MIs[1] Operand 1
     /*  969877 */     // No operand predicates
     /*  969877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969890 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  969890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  969909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  969912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  969915 */     GIR_RootConstrainSelectedInstOperands,
     /*  969916 */     // GIR_Coverage, 8176,
     /*  969916 */     GIR_EraseRootFromParent_Done,
     /*  969917 */   // Label 14529: @969917
     /*  969917 */   GIM_Try, /*On fail goto*//*Label 14530*/ GIMT_Encode4(970012), // Rule ID 8177 //
     /*  969922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  969925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  969930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  969933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  969936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  969939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  969942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  969945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  969948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  969956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  969960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  969964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  969968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  969972 */     // MIs[1] Operand 1
     /*  969972 */     // No operand predicates
     /*  969972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  969976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  969978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  969985 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  969985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  969988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  969990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  969992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  969994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  969997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  969999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970010 */     GIR_RootConstrainSelectedInstOperands,
     /*  970011 */     // GIR_Coverage, 8177,
     /*  970011 */     GIR_EraseRootFromParent_Done,
     /*  970012 */   // Label 14530: @970012
     /*  970012 */   GIM_Try, /*On fail goto*//*Label 14531*/ GIMT_Encode4(970107), // Rule ID 8180 //
     /*  970017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970067 */     // MIs[1] Operand 1
     /*  970067 */     // No operand predicates
     /*  970067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970105 */     GIR_RootConstrainSelectedInstOperands,
     /*  970106 */     // GIR_Coverage, 8180,
     /*  970106 */     GIR_EraseRootFromParent_Done,
     /*  970107 */   // Label 14531: @970107
     /*  970107 */   GIM_Try, /*On fail goto*//*Label 14532*/ GIMT_Encode4(970202), // Rule ID 8181 //
     /*  970112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  970129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970158 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970162 */     // MIs[1] Operand 1
     /*  970162 */     // No operand predicates
     /*  970162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970175 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970200 */     GIR_RootConstrainSelectedInstOperands,
     /*  970201 */     // GIR_Coverage, 8181,
     /*  970201 */     GIR_EraseRootFromParent_Done,
     /*  970202 */   // Label 14532: @970202
     /*  970202 */   GIM_Try, /*On fail goto*//*Label 14533*/ GIMT_Encode4(970297), // Rule ID 8184 //
     /*  970207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970257 */     // MIs[1] Operand 1
     /*  970257 */     // No operand predicates
     /*  970257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970270 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  970270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970295 */     GIR_RootConstrainSelectedInstOperands,
     /*  970296 */     // GIR_Coverage, 8184,
     /*  970296 */     GIR_EraseRootFromParent_Done,
     /*  970297 */   // Label 14533: @970297
     /*  970297 */   GIM_Try, /*On fail goto*//*Label 14534*/ GIMT_Encode4(970392), // Rule ID 8185 //
     /*  970302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  970313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  970316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  970319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  970325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970348 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970352 */     // MIs[1] Operand 1
     /*  970352 */     // No operand predicates
     /*  970352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970365 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  970365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970374 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  970387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970390 */     GIR_RootConstrainSelectedInstOperands,
     /*  970391 */     // GIR_Coverage, 8185,
     /*  970391 */     GIR_EraseRootFromParent_Done,
     /*  970392 */   // Label 14534: @970392
     /*  970392 */   GIM_Try, /*On fail goto*//*Label 14535*/ GIMT_Encode4(970487), // Rule ID 8188 //
     /*  970397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970447 */     // MIs[1] Operand 1
     /*  970447 */     // No operand predicates
     /*  970447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970485 */     GIR_RootConstrainSelectedInstOperands,
     /*  970486 */     // GIR_Coverage, 8188,
     /*  970486 */     GIR_EraseRootFromParent_Done,
     /*  970487 */   // Label 14535: @970487
     /*  970487 */   GIM_Try, /*On fail goto*//*Label 14536*/ GIMT_Encode4(970582), // Rule ID 8189 //
     /*  970492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  970503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  970506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  970509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  970515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  970530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970542 */     // MIs[1] Operand 1
     /*  970542 */     // No operand predicates
     /*  970542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970555 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  970558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970580 */     GIR_RootConstrainSelectedInstOperands,
     /*  970581 */     // GIR_Coverage, 8189,
     /*  970581 */     GIR_EraseRootFromParent_Done,
     /*  970582 */   // Label 14536: @970582
     /*  970582 */   GIM_Try, /*On fail goto*//*Label 14537*/ GIMT_Encode4(970677), // Rule ID 8192 //
     /*  970587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970637 */     // MIs[1] Operand 1
     /*  970637 */     // No operand predicates
     /*  970637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970650 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970675 */     GIR_RootConstrainSelectedInstOperands,
     /*  970676 */     // GIR_Coverage, 8192,
     /*  970676 */     GIR_EraseRootFromParent_Done,
     /*  970677 */   // Label 14537: @970677
     /*  970677 */   GIM_Try, /*On fail goto*//*Label 14538*/ GIMT_Encode4(970772), // Rule ID 8193 //
     /*  970682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  970693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  970696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  970699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  970705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  970720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970732 */     // MIs[1] Operand 1
     /*  970732 */     // No operand predicates
     /*  970732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970745 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  970748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970770 */     GIR_RootConstrainSelectedInstOperands,
     /*  970771 */     // GIR_Coverage, 8193,
     /*  970771 */     GIR_EraseRootFromParent_Done,
     /*  970772 */   // Label 14538: @970772
     /*  970772 */   GIM_Try, /*On fail goto*//*Label 14539*/ GIMT_Encode4(970867), // Rule ID 8196 //
     /*  970777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  970780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  970794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970827 */     // MIs[1] Operand 1
     /*  970827 */     // No operand predicates
     /*  970827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970840 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  970840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970865 */     GIR_RootConstrainSelectedInstOperands,
     /*  970866 */     // GIR_Coverage, 8196,
     /*  970866 */     GIR_EraseRootFromParent_Done,
     /*  970867 */   // Label 14539: @970867
     /*  970867 */   GIM_Try, /*On fail goto*//*Label 14540*/ GIMT_Encode4(970962), // Rule ID 8197 //
     /*  970872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  970875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  970883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  970886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  970889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  970892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  970895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  970898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  970910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  970914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  970918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  970922 */     // MIs[1] Operand 1
     /*  970922 */     // No operand predicates
     /*  970922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  970926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  970928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  970935 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  970935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  970938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  970940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  970942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  970944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  970947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  970949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  970954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  970957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  970960 */     GIR_RootConstrainSelectedInstOperands,
     /*  970961 */     // GIR_Coverage, 8197,
     /*  970961 */     GIR_EraseRootFromParent_Done,
     /*  970962 */   // Label 14540: @970962
     /*  970962 */   GIM_Try, /*On fail goto*//*Label 14541*/ GIMT_Encode4(971057), // Rule ID 8200 //
     /*  970967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  970970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  970975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  970978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  970981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  970984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  970987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  970990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  970993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  970997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971013 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971017 */     // MIs[1] Operand 1
     /*  971017 */     // No operand predicates
     /*  971017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971030 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971055 */     GIR_RootConstrainSelectedInstOperands,
     /*  971056 */     // GIR_Coverage, 8200,
     /*  971056 */     GIR_EraseRootFromParent_Done,
     /*  971057 */   // Label 14541: @971057
     /*  971057 */   GIM_Try, /*On fail goto*//*Label 14542*/ GIMT_Encode4(971152), // Rule ID 8201 //
     /*  971062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  971079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  971100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971112 */     // MIs[1] Operand 1
     /*  971112 */     // No operand predicates
     /*  971112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971125 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M2_MASK),
     /*  971128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971150 */     GIR_RootConstrainSelectedInstOperands,
     /*  971151 */     // GIR_Coverage, 8201,
     /*  971151 */     GIR_EraseRootFromParent_Done,
     /*  971152 */   // Label 14542: @971152
     /*  971152 */   GIM_Try, /*On fail goto*//*Label 14543*/ GIMT_Encode4(971247), // Rule ID 8204 //
     /*  971157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971207 */     // MIs[1] Operand 1
     /*  971207 */     // No operand predicates
     /*  971207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971245 */     GIR_RootConstrainSelectedInstOperands,
     /*  971246 */     // GIR_Coverage, 8204,
     /*  971246 */     GIR_EraseRootFromParent_Done,
     /*  971247 */   // Label 14543: @971247
     /*  971247 */   GIM_Try, /*On fail goto*//*Label 14544*/ GIMT_Encode4(971342), // Rule ID 8205 //
     /*  971252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  971269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  971290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971302 */     // MIs[1] Operand 1
     /*  971302 */     // No operand predicates
     /*  971302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971315 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M4_MASK),
     /*  971318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971340 */     GIR_RootConstrainSelectedInstOperands,
     /*  971341 */     // GIR_Coverage, 8205,
     /*  971341 */     GIR_EraseRootFromParent_Done,
     /*  971342 */   // Label 14544: @971342
     /*  971342 */   GIM_Try, /*On fail goto*//*Label 14545*/ GIMT_Encode4(971437), // Rule ID 8208 //
     /*  971347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  971350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971397 */     // MIs[1] Operand 1
     /*  971397 */     // No operand predicates
     /*  971397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971410 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  971410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971435 */     GIR_RootConstrainSelectedInstOperands,
     /*  971436 */     // GIR_Coverage, 8208,
     /*  971436 */     GIR_EraseRootFromParent_Done,
     /*  971437 */   // Label 14545: @971437
     /*  971437 */   GIM_Try, /*On fail goto*//*Label 14546*/ GIMT_Encode4(971532), // Rule ID 8209 //
     /*  971442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  971445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /*  971450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  971453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  971456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  971459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  971465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  971480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971492 */     // MIs[1] Operand 1
     /*  971492 */     // No operand predicates
     /*  971492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971505 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  971505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VI_M8_MASK),
     /*  971508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  971527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971530 */     GIR_RootConstrainSelectedInstOperands,
     /*  971531 */     // GIR_Coverage, 8209,
     /*  971531 */     GIR_EraseRootFromParent_Done,
     /*  971532 */   // Label 14546: @971532
     /*  971532 */   GIM_Try, /*On fail goto*//*Label 14547*/ GIMT_Encode4(971627), // Rule ID 8740 //
     /*  971537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  971545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971583 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971587 */     // MIs[1] Operand 1
     /*  971587 */     // No operand predicates
     /*  971587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971600 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  971603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971625 */     GIR_RootConstrainSelectedInstOperands,
     /*  971626 */     // GIR_Coverage, 8740,
     /*  971626 */     GIR_EraseRootFromParent_Done,
     /*  971627 */   // Label 14547: @971627
     /*  971627 */   GIM_Try, /*On fail goto*//*Label 14548*/ GIMT_Encode4(971722), // Rule ID 8741 //
     /*  971632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  971640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  971643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  971646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  971649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  971655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971682 */     // MIs[1] Operand 1
     /*  971682 */     // No operand predicates
     /*  971682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971695 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  971695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF8_MASK),
     /*  971698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971720 */     GIR_RootConstrainSelectedInstOperands,
     /*  971721 */     // GIR_Coverage, 8741,
     /*  971721 */     GIR_EraseRootFromParent_Done,
     /*  971722 */   // Label 14548: @971722
     /*  971722 */   GIM_Try, /*On fail goto*//*Label 14549*/ GIMT_Encode4(971817), // Rule ID 8744 //
     /*  971727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  971735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  971744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971777 */     // MIs[1] Operand 1
     /*  971777 */     // No operand predicates
     /*  971777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971781 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971790 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  971793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971815 */     GIR_RootConstrainSelectedInstOperands,
     /*  971816 */     // GIR_Coverage, 8744,
     /*  971816 */     GIR_EraseRootFromParent_Done,
     /*  971817 */   // Label 14549: @971817
     /*  971817 */   GIM_Try, /*On fail goto*//*Label 14550*/ GIMT_Encode4(971912), // Rule ID 8745 //
     /*  971822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  971825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  971830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  971833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  971836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  971839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  971842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  971845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  971848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971872 */     // MIs[1] Operand 1
     /*  971872 */     // No operand predicates
     /*  971872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971885 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  971885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  971888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  971907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  971910 */     GIR_RootConstrainSelectedInstOperands,
     /*  971911 */     // GIR_Coverage, 8745,
     /*  971911 */     GIR_EraseRootFromParent_Done,
     /*  971912 */   // Label 14550: @971912
     /*  971912 */   GIM_Try, /*On fail goto*//*Label 14551*/ GIMT_Encode4(972007), // Rule ID 8748 //
     /*  971917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  971920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  971925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  971928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  971931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  971934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  971937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  971940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  971943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  971955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  971959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  971963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  971967 */     // MIs[1] Operand 1
     /*  971967 */     // No operand predicates
     /*  971967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  971971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  971973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  971980 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  971980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  971983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  971985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  971987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  971989 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  971992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  971994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  971999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972005 */     GIR_RootConstrainSelectedInstOperands,
     /*  972006 */     // GIR_Coverage, 8748,
     /*  972006 */     GIR_EraseRootFromParent_Done,
     /*  972007 */   // Label 14551: @972007
     /*  972007 */   GIM_Try, /*On fail goto*//*Label 14552*/ GIMT_Encode4(972102), // Rule ID 8749 //
     /*  972012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  972029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972062 */     // MIs[1] Operand 1
     /*  972062 */     // No operand predicates
     /*  972062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972075 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972100 */     GIR_RootConstrainSelectedInstOperands,
     /*  972101 */     // GIR_Coverage, 8749,
     /*  972101 */     GIR_EraseRootFromParent_Done,
     /*  972102 */   // Label 14552: @972102
     /*  972102 */   GIM_Try, /*On fail goto*//*Label 14553*/ GIMT_Encode4(972197), // Rule ID 8752 //
     /*  972107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972157 */     // MIs[1] Operand 1
     /*  972157 */     // No operand predicates
     /*  972157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972170 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972195 */     GIR_RootConstrainSelectedInstOperands,
     /*  972196 */     // GIR_Coverage, 8752,
     /*  972196 */     GIR_EraseRootFromParent_Done,
     /*  972197 */   // Label 14553: @972197
     /*  972197 */   GIM_Try, /*On fail goto*//*Label 14554*/ GIMT_Encode4(972292), // Rule ID 8753 //
     /*  972202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  972219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972248 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972252 */     // MIs[1] Operand 1
     /*  972252 */     // No operand predicates
     /*  972252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972265 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF4_MASK),
     /*  972268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972290 */     GIR_RootConstrainSelectedInstOperands,
     /*  972291 */     // GIR_Coverage, 8753,
     /*  972291 */     GIR_EraseRootFromParent_Done,
     /*  972292 */   // Label 14554: @972292
     /*  972292 */   GIM_Try, /*On fail goto*//*Label 14555*/ GIMT_Encode4(972387), // Rule ID 8756 //
     /*  972297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972343 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972347 */     // MIs[1] Operand 1
     /*  972347 */     // No operand predicates
     /*  972347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972385 */     GIR_RootConstrainSelectedInstOperands,
     /*  972386 */     // GIR_Coverage, 8756,
     /*  972386 */     GIR_EraseRootFromParent_Done,
     /*  972387 */   // Label 14555: @972387
     /*  972387 */   GIM_Try, /*On fail goto*//*Label 14556*/ GIMT_Encode4(972482), // Rule ID 8757 //
     /*  972392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  972403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  972406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  972409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  972415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972442 */     // MIs[1] Operand 1
     /*  972442 */     // No operand predicates
     /*  972442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972455 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  972455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972480 */     GIR_RootConstrainSelectedInstOperands,
     /*  972481 */     // GIR_Coverage, 8757,
     /*  972481 */     GIR_EraseRootFromParent_Done,
     /*  972482 */   // Label 14556: @972482
     /*  972482 */   GIM_Try, /*On fail goto*//*Label 14557*/ GIMT_Encode4(972577), // Rule ID 8760 //
     /*  972487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972537 */     // MIs[1] Operand 1
     /*  972537 */     // No operand predicates
     /*  972537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972550 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  972550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972575 */     GIR_RootConstrainSelectedInstOperands,
     /*  972576 */     // GIR_Coverage, 8760,
     /*  972576 */     GIR_EraseRootFromParent_Done,
     /*  972577 */   // Label 14557: @972577
     /*  972577 */   GIM_Try, /*On fail goto*//*Label 14558*/ GIMT_Encode4(972672), // Rule ID 8761 //
     /*  972582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  972593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  972596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  972599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  972605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972632 */     // MIs[1] Operand 1
     /*  972632 */     // No operand predicates
     /*  972632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972636 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972645 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  972645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_MF2_MASK),
     /*  972648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  972667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972670 */     GIR_RootConstrainSelectedInstOperands,
     /*  972671 */     // GIR_Coverage, 8761,
     /*  972671 */     GIR_EraseRootFromParent_Done,
     /*  972672 */   // Label 14558: @972672
     /*  972672 */   GIM_Try, /*On fail goto*//*Label 14559*/ GIMT_Encode4(972767), // Rule ID 8764 //
     /*  972677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972727 */     // MIs[1] Operand 1
     /*  972727 */     // No operand predicates
     /*  972727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  972740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  972743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972765 */     GIR_RootConstrainSelectedInstOperands,
     /*  972766 */     // GIR_Coverage, 8764,
     /*  972766 */     GIR_EraseRootFromParent_Done,
     /*  972767 */   // Label 14559: @972767
     /*  972767 */   GIM_Try, /*On fail goto*//*Label 14560*/ GIMT_Encode4(972862), // Rule ID 8765 //
     /*  972772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  972783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  972786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  972789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  972795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972822 */     // MIs[1] Operand 1
     /*  972822 */     // No operand predicates
     /*  972822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972835 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  972835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  972838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  972857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972860 */     GIR_RootConstrainSelectedInstOperands,
     /*  972861 */     // GIR_Coverage, 8765,
     /*  972861 */     GIR_EraseRootFromParent_Done,
     /*  972862 */   // Label 14560: @972862
     /*  972862 */   GIM_Try, /*On fail goto*//*Label 14561*/ GIMT_Encode4(972957), // Rule ID 8768 //
     /*  972867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  972870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  972884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  972887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  972893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  972909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  972913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  972917 */     // MIs[1] Operand 1
     /*  972917 */     // No operand predicates
     /*  972917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  972921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  972923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  972930 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  972930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  972933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  972935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  972937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  972939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  972942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  972944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  972949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  972952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  972955 */     GIR_RootConstrainSelectedInstOperands,
     /*  972956 */     // GIR_Coverage, 8768,
     /*  972956 */     GIR_EraseRootFromParent_Done,
     /*  972957 */   // Label 14561: @972957
     /*  972957 */   GIM_Try, /*On fail goto*//*Label 14562*/ GIMT_Encode4(973052), // Rule ID 8769 //
     /*  972962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  972965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  972970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  972973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  972976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  972979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  972982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  972985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  972988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  972996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973012 */     // MIs[1] Operand 1
     /*  973012 */     // No operand predicates
     /*  973012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973025 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  973025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  973047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973050 */     GIR_RootConstrainSelectedInstOperands,
     /*  973051 */     // GIR_Coverage, 8769,
     /*  973051 */     GIR_EraseRootFromParent_Done,
     /*  973052 */   // Label 14562: @973052
     /*  973052 */   GIM_Try, /*On fail goto*//*Label 14563*/ GIMT_Encode4(973147), // Rule ID 8772 //
     /*  973057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973103 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973107 */     // MIs[1] Operand 1
     /*  973107 */     // No operand predicates
     /*  973107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  973120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973145 */     GIR_RootConstrainSelectedInstOperands,
     /*  973146 */     // GIR_Coverage, 8772,
     /*  973146 */     GIR_EraseRootFromParent_Done,
     /*  973147 */   // Label 14563: @973147
     /*  973147 */   GIM_Try, /*On fail goto*//*Label 14564*/ GIMT_Encode4(973242), // Rule ID 8773 //
     /*  973152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  973163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  973166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  973169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  973175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973202 */     // MIs[1] Operand 1
     /*  973202 */     // No operand predicates
     /*  973202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973215 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  973215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  973237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973240 */     GIR_RootConstrainSelectedInstOperands,
     /*  973241 */     // GIR_Coverage, 8773,
     /*  973241 */     GIR_EraseRootFromParent_Done,
     /*  973242 */   // Label 14564: @973242
     /*  973242 */   GIM_Try, /*On fail goto*//*Label 14565*/ GIMT_Encode4(973337), // Rule ID 8776 //
     /*  973247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  973250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973297 */     // MIs[1] Operand 1
     /*  973297 */     // No operand predicates
     /*  973297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973310 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  973310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973335 */     GIR_RootConstrainSelectedInstOperands,
     /*  973336 */     // GIR_Coverage, 8776,
     /*  973336 */     GIR_EraseRootFromParent_Done,
     /*  973337 */   // Label 14565: @973337
     /*  973337 */   GIM_Try, /*On fail goto*//*Label 14566*/ GIMT_Encode4(973432), // Rule ID 8777 //
     /*  973342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  973345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  973353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  973356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  973359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  973365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973392 */     // MIs[1] Operand 1
     /*  973392 */     // No operand predicates
     /*  973392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973405 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  973405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M1_MASK),
     /*  973408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  973427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973430 */     GIR_RootConstrainSelectedInstOperands,
     /*  973431 */     // GIR_Coverage, 8777,
     /*  973431 */     GIR_EraseRootFromParent_Done,
     /*  973432 */   // Label 14566: @973432
     /*  973432 */   GIM_Try, /*On fail goto*//*Label 14567*/ GIMT_Encode4(973527), // Rule ID 8780 //
     /*  973437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973487 */     // MIs[1] Operand 1
     /*  973487 */     // No operand predicates
     /*  973487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  973503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973525 */     GIR_RootConstrainSelectedInstOperands,
     /*  973526 */     // GIR_Coverage, 8780,
     /*  973526 */     GIR_EraseRootFromParent_Done,
     /*  973527 */   // Label 14567: @973527
     /*  973527 */   GIM_Try, /*On fail goto*//*Label 14568*/ GIMT_Encode4(973622), // Rule ID 8781 //
     /*  973532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  973543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  973546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  973549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  973555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  973570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973582 */     // MIs[1] Operand 1
     /*  973582 */     // No operand predicates
     /*  973582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973595 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  973598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973620 */     GIR_RootConstrainSelectedInstOperands,
     /*  973621 */     // GIR_Coverage, 8781,
     /*  973621 */     GIR_EraseRootFromParent_Done,
     /*  973622 */   // Label 14568: @973622
     /*  973622 */   GIM_Try, /*On fail goto*//*Label 14569*/ GIMT_Encode4(973717), // Rule ID 8784 //
     /*  973627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973673 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973677 */     // MIs[1] Operand 1
     /*  973677 */     // No operand predicates
     /*  973677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973690 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  973693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973715 */     GIR_RootConstrainSelectedInstOperands,
     /*  973716 */     // GIR_Coverage, 8784,
     /*  973716 */     GIR_EraseRootFromParent_Done,
     /*  973717 */   // Label 14569: @973717
     /*  973717 */   GIM_Try, /*On fail goto*//*Label 14570*/ GIMT_Encode4(973812), // Rule ID 8785 //
     /*  973722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  973733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  973736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  973739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  973745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  973760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973768 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973772 */     // MIs[1] Operand 1
     /*  973772 */     // No operand predicates
     /*  973772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973785 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  973788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973810 */     GIR_RootConstrainSelectedInstOperands,
     /*  973811 */     // GIR_Coverage, 8785,
     /*  973811 */     GIR_EraseRootFromParent_Done,
     /*  973812 */   // Label 14570: @973812
     /*  973812 */   GIM_Try, /*On fail goto*//*Label 14571*/ GIMT_Encode4(973907), // Rule ID 8788 //
     /*  973817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  973820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  973828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  973831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  973834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  973837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  973840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  973843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  973855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973867 */     // MIs[1] Operand 1
     /*  973867 */     // No operand predicates
     /*  973867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973880 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  973880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  973883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  973905 */     GIR_RootConstrainSelectedInstOperands,
     /*  973906 */     // GIR_Coverage, 8788,
     /*  973906 */     GIR_EraseRootFromParent_Done,
     /*  973907 */   // Label 14571: @973907
     /*  973907 */   GIM_Try, /*On fail goto*//*Label 14572*/ GIMT_Encode4(974002), // Rule ID 8789 //
     /*  973912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  973915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  973920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  973923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  973926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  973929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  973932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  973935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  973938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  973946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  973950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  973954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  973958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  973962 */     // MIs[1] Operand 1
     /*  973962 */     // No operand predicates
     /*  973962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  973966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  973968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  973975 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  973975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  973978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  973980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  973982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  973984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  973987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  973989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  973994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  973997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974000 */     GIR_RootConstrainSelectedInstOperands,
     /*  974001 */     // GIR_Coverage, 8789,
     /*  974001 */     GIR_EraseRootFromParent_Done,
     /*  974002 */   // Label 14572: @974002
     /*  974002 */   GIM_Try, /*On fail goto*//*Label 14573*/ GIMT_Encode4(974097), // Rule ID 8792 //
     /*  974007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974057 */     // MIs[1] Operand 1
     /*  974057 */     // No operand predicates
     /*  974057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974070 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974095 */     GIR_RootConstrainSelectedInstOperands,
     /*  974096 */     // GIR_Coverage, 8792,
     /*  974096 */     GIR_EraseRootFromParent_Done,
     /*  974097 */   // Label 14573: @974097
     /*  974097 */   GIM_Try, /*On fail goto*//*Label 14574*/ GIMT_Encode4(974192), // Rule ID 8793 //
     /*  974102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  974119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974152 */     // MIs[1] Operand 1
     /*  974152 */     // No operand predicates
     /*  974152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974165 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974190 */     GIR_RootConstrainSelectedInstOperands,
     /*  974191 */     // GIR_Coverage, 8793,
     /*  974191 */     GIR_EraseRootFromParent_Done,
     /*  974192 */   // Label 14574: @974192
     /*  974192 */   GIM_Try, /*On fail goto*//*Label 14575*/ GIMT_Encode4(974287), // Rule ID 8796 //
     /*  974197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974247 */     // MIs[1] Operand 1
     /*  974247 */     // No operand predicates
     /*  974247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974285 */     GIR_RootConstrainSelectedInstOperands,
     /*  974286 */     // GIR_Coverage, 8796,
     /*  974286 */     GIR_EraseRootFromParent_Done,
     /*  974287 */   // Label 14575: @974287
     /*  974287 */   GIM_Try, /*On fail goto*//*Label 14576*/ GIMT_Encode4(974382), // Rule ID 8797 //
     /*  974292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  974309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974338 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974342 */     // MIs[1] Operand 1
     /*  974342 */     // No operand predicates
     /*  974342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974355 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974380 */     GIR_RootConstrainSelectedInstOperands,
     /*  974381 */     // GIR_Coverage, 8797,
     /*  974381 */     GIR_EraseRootFromParent_Done,
     /*  974382 */   // Label 14576: @974382
     /*  974382 */   GIM_Try, /*On fail goto*//*Label 14577*/ GIMT_Encode4(974477), // Rule ID 8800 //
     /*  974387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974437 */     // MIs[1] Operand 1
     /*  974437 */     // No operand predicates
     /*  974437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974450 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  974450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974475 */     GIR_RootConstrainSelectedInstOperands,
     /*  974476 */     // GIR_Coverage, 8800,
     /*  974476 */     GIR_EraseRootFromParent_Done,
     /*  974477 */   // Label 14577: @974477
     /*  974477 */   GIM_Try, /*On fail goto*//*Label 14578*/ GIMT_Encode4(974572), // Rule ID 8801 //
     /*  974482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  974493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  974496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  974499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  974505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974532 */     // MIs[1] Operand 1
     /*  974532 */     // No operand predicates
     /*  974532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974545 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  974545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  974548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  974567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974570 */     GIR_RootConstrainSelectedInstOperands,
     /*  974571 */     // GIR_Coverage, 8801,
     /*  974571 */     GIR_EraseRootFromParent_Done,
     /*  974572 */   // Label 14578: @974572
     /*  974572 */   GIM_Try, /*On fail goto*//*Label 14579*/ GIMT_Encode4(974667), // Rule ID 8804 //
     /*  974577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974627 */     // MIs[1] Operand 1
     /*  974627 */     // No operand predicates
     /*  974627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974640 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974665 */     GIR_RootConstrainSelectedInstOperands,
     /*  974666 */     // GIR_Coverage, 8804,
     /*  974666 */     GIR_EraseRootFromParent_Done,
     /*  974667 */   // Label 14579: @974667
     /*  974667 */   GIM_Try, /*On fail goto*//*Label 14580*/ GIMT_Encode4(974762), // Rule ID 8805 //
     /*  974672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  974683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  974686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  974689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  974695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  974710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974722 */     // MIs[1] Operand 1
     /*  974722 */     // No operand predicates
     /*  974722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974735 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  974738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974760 */     GIR_RootConstrainSelectedInstOperands,
     /*  974761 */     // GIR_Coverage, 8805,
     /*  974761 */     GIR_EraseRootFromParent_Done,
     /*  974762 */   // Label 14580: @974762
     /*  974762 */   GIM_Try, /*On fail goto*//*Label 14581*/ GIMT_Encode4(974857), // Rule ID 8808 //
     /*  974767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  974784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974817 */     // MIs[1] Operand 1
     /*  974817 */     // No operand predicates
     /*  974817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974830 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  974830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974855 */     GIR_RootConstrainSelectedInstOperands,
     /*  974856 */     // GIR_Coverage, 8808,
     /*  974856 */     GIR_EraseRootFromParent_Done,
     /*  974857 */   // Label 14581: @974857
     /*  974857 */   GIM_Try, /*On fail goto*//*Label 14582*/ GIMT_Encode4(974952), // Rule ID 8809 //
     /*  974862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  974865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  974873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  974876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  974879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  974882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  974885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  974888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  974900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  974908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  974912 */     // MIs[1] Operand 1
     /*  974912 */     // No operand predicates
     /*  974912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  974916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  974918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  974925 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  974925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  974928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  974930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  974932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  974934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  974937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  974939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  974944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  974947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  974950 */     GIR_RootConstrainSelectedInstOperands,
     /*  974951 */     // GIR_Coverage, 8809,
     /*  974951 */     GIR_EraseRootFromParent_Done,
     /*  974952 */   // Label 14582: @974952
     /*  974952 */   GIM_Try, /*On fail goto*//*Label 14583*/ GIMT_Encode4(975047), // Rule ID 8812 //
     /*  974957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  974960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  974965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  974968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  974971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  974974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  974977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  974980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  974983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  974991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  974995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  974999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975007 */     // MIs[1] Operand 1
     /*  975007 */     // No operand predicates
     /*  975007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  975020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975045 */     GIR_RootConstrainSelectedInstOperands,
     /*  975046 */     // GIR_Coverage, 8812,
     /*  975046 */     GIR_EraseRootFromParent_Done,
     /*  975047 */   // Label 14583: @975047
     /*  975047 */   GIM_Try, /*On fail goto*//*Label 14584*/ GIMT_Encode4(975142), // Rule ID 8813 //
     /*  975052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  975063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  975066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  975069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  975075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975102 */     // MIs[1] Operand 1
     /*  975102 */     // No operand predicates
     /*  975102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975115 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  975115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  975137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975140 */     GIR_RootConstrainSelectedInstOperands,
     /*  975141 */     // GIR_Coverage, 8813,
     /*  975141 */     GIR_EraseRootFromParent_Done,
     /*  975142 */   // Label 14584: @975142
     /*  975142 */   GIM_Try, /*On fail goto*//*Label 14585*/ GIMT_Encode4(975237), // Rule ID 8816 //
     /*  975147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975193 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975197 */     // MIs[1] Operand 1
     /*  975197 */     // No operand predicates
     /*  975197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975210 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975235 */     GIR_RootConstrainSelectedInstOperands,
     /*  975236 */     // GIR_Coverage, 8816,
     /*  975236 */     GIR_EraseRootFromParent_Done,
     /*  975237 */   // Label 14585: @975237
     /*  975237 */   GIM_Try, /*On fail goto*//*Label 14586*/ GIMT_Encode4(975332), // Rule ID 8817 //
     /*  975242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  975259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  975280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975288 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975292 */     // MIs[1] Operand 1
     /*  975292 */     // No operand predicates
     /*  975292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975305 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M2_MASK),
     /*  975308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975330 */     GIR_RootConstrainSelectedInstOperands,
     /*  975331 */     // GIR_Coverage, 8817,
     /*  975331 */     GIR_EraseRootFromParent_Done,
     /*  975332 */   // Label 14586: @975332
     /*  975332 */   GIM_Try, /*On fail goto*//*Label 14587*/ GIMT_Encode4(975427), // Rule ID 8820 //
     /*  975337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975387 */     // MIs[1] Operand 1
     /*  975387 */     // No operand predicates
     /*  975387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975400 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975425 */     GIR_RootConstrainSelectedInstOperands,
     /*  975426 */     // GIR_Coverage, 8820,
     /*  975426 */     GIR_EraseRootFromParent_Done,
     /*  975427 */   // Label 14587: @975427
     /*  975427 */   GIM_Try, /*On fail goto*//*Label 14588*/ GIMT_Encode4(975522), // Rule ID 8821 //
     /*  975432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  975443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  975446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  975449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  975455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  975470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975482 */     // MIs[1] Operand 1
     /*  975482 */     // No operand predicates
     /*  975482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975486 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975495 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M4_MASK),
     /*  975498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975520 */     GIR_RootConstrainSelectedInstOperands,
     /*  975521 */     // GIR_Coverage, 8821,
     /*  975521 */     GIR_EraseRootFromParent_Done,
     /*  975522 */   // Label 14588: @975522
     /*  975522 */   GIM_Try, /*On fail goto*//*Label 14589*/ GIMT_Encode4(975617), // Rule ID 8824 //
     /*  975527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  975530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975577 */     // MIs[1] Operand 1
     /*  975577 */     // No operand predicates
     /*  975577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975590 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  975590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975615 */     GIR_RootConstrainSelectedInstOperands,
     /*  975616 */     // GIR_Coverage, 8824,
     /*  975616 */     GIR_EraseRootFromParent_Done,
     /*  975617 */   // Label 14589: @975617
     /*  975617 */   GIM_Try, /*On fail goto*//*Label 14590*/ GIMT_Encode4(975712), // Rule ID 8825 //
     /*  975622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  975625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /*  975630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  975633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  975636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  975639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  975645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  975660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975672 */     // MIs[1] Operand 1
     /*  975672 */     // No operand predicates
     /*  975672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975685 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  975685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VI_M8_MASK),
     /*  975688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  975707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975710 */     GIR_RootConstrainSelectedInstOperands,
     /*  975711 */     // GIR_Coverage, 8825,
     /*  975711 */     GIR_EraseRootFromParent_Done,
     /*  975712 */   // Label 14590: @975712
     /*  975712 */   GIM_Try, /*On fail goto*//*Label 14591*/ GIMT_Encode4(975807), // Rule ID 9004 //
     /*  975717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  975725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  975734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  975740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975767 */     // MIs[1] Operand 1
     /*  975767 */     // No operand predicates
     /*  975767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  975780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  975783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  975802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975805 */     GIR_RootConstrainSelectedInstOperands,
     /*  975806 */     // GIR_Coverage, 9004,
     /*  975806 */     GIR_EraseRootFromParent_Done,
     /*  975807 */   // Label 14591: @975807
     /*  975807 */   GIM_Try, /*On fail goto*//*Label 14592*/ GIMT_Encode4(975902), // Rule ID 9005 //
     /*  975812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  975815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  975820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  975823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  975826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  975829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  975832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  975835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  975838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975862 */     // MIs[1] Operand 1
     /*  975862 */     // No operand predicates
     /*  975862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975875 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  975875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF8_MASK),
     /*  975878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  975897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975900 */     GIR_RootConstrainSelectedInstOperands,
     /*  975901 */     // GIR_Coverage, 9005,
     /*  975901 */     GIR_EraseRootFromParent_Done,
     /*  975902 */   // Label 14592: @975902
     /*  975902 */   GIM_Try, /*On fail goto*//*Label 14593*/ GIMT_Encode4(975997), // Rule ID 9008 //
     /*  975907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  975910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  975915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  975918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  975921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  975924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  975927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  975930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  975933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  975945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  975949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  975953 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  975957 */     // MIs[1] Operand 1
     /*  975957 */     // No operand predicates
     /*  975957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  975961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  975963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  975970 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  975970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  975973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  975975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  975977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  975979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  975982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  975984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  975989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  975992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  975995 */     GIR_RootConstrainSelectedInstOperands,
     /*  975996 */     // GIR_Coverage, 9008,
     /*  975996 */     GIR_EraseRootFromParent_Done,
     /*  975997 */   // Label 14593: @975997
     /*  975997 */   GIM_Try, /*On fail goto*//*Label 14594*/ GIMT_Encode4(976092), // Rule ID 9009 //
     /*  976002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  976019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976052 */     // MIs[1] Operand 1
     /*  976052 */     // No operand predicates
     /*  976052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976065 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976090 */     GIR_RootConstrainSelectedInstOperands,
     /*  976091 */     // GIR_Coverage, 9009,
     /*  976091 */     GIR_EraseRootFromParent_Done,
     /*  976092 */   // Label 14594: @976092
     /*  976092 */   GIM_Try, /*On fail goto*//*Label 14595*/ GIMT_Encode4(976187), // Rule ID 9012 //
     /*  976097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976147 */     // MIs[1] Operand 1
     /*  976147 */     // No operand predicates
     /*  976147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976160 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976185 */     GIR_RootConstrainSelectedInstOperands,
     /*  976186 */     // GIR_Coverage, 9012,
     /*  976186 */     GIR_EraseRootFromParent_Done,
     /*  976187 */   // Label 14595: @976187
     /*  976187 */   GIM_Try, /*On fail goto*//*Label 14596*/ GIMT_Encode4(976282), // Rule ID 9013 //
     /*  976192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  976203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  976206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  976209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  976215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976242 */     // MIs[1] Operand 1
     /*  976242 */     // No operand predicates
     /*  976242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976255 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  976255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976280 */     GIR_RootConstrainSelectedInstOperands,
     /*  976281 */     // GIR_Coverage, 9013,
     /*  976281 */     GIR_EraseRootFromParent_Done,
     /*  976282 */   // Label 14596: @976282
     /*  976282 */   GIM_Try, /*On fail goto*//*Label 14597*/ GIMT_Encode4(976377), // Rule ID 9016 //
     /*  976287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976337 */     // MIs[1] Operand 1
     /*  976337 */     // No operand predicates
     /*  976337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976350 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976375 */     GIR_RootConstrainSelectedInstOperands,
     /*  976376 */     // GIR_Coverage, 9016,
     /*  976376 */     GIR_EraseRootFromParent_Done,
     /*  976377 */   // Label 14597: @976377
     /*  976377 */   GIM_Try, /*On fail goto*//*Label 14598*/ GIMT_Encode4(976472), // Rule ID 9017 //
     /*  976382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  976399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976432 */     // MIs[1] Operand 1
     /*  976432 */     // No operand predicates
     /*  976432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976445 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF4_MASK),
     /*  976448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976470 */     GIR_RootConstrainSelectedInstOperands,
     /*  976471 */     // GIR_Coverage, 9017,
     /*  976471 */     GIR_EraseRootFromParent_Done,
     /*  976472 */   // Label 14598: @976472
     /*  976472 */   GIM_Try, /*On fail goto*//*Label 14599*/ GIMT_Encode4(976567), // Rule ID 9020 //
     /*  976477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976527 */     // MIs[1] Operand 1
     /*  976527 */     // No operand predicates
     /*  976527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  976540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976565 */     GIR_RootConstrainSelectedInstOperands,
     /*  976566 */     // GIR_Coverage, 9020,
     /*  976566 */     GIR_EraseRootFromParent_Done,
     /*  976567 */   // Label 14599: @976567
     /*  976567 */   GIM_Try, /*On fail goto*//*Label 14600*/ GIMT_Encode4(976662), // Rule ID 9021 //
     /*  976572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  976583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  976586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  976589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  976595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976622 */     // MIs[1] Operand 1
     /*  976622 */     // No operand predicates
     /*  976622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976635 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  976635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  976657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976660 */     GIR_RootConstrainSelectedInstOperands,
     /*  976661 */     // GIR_Coverage, 9021,
     /*  976661 */     GIR_EraseRootFromParent_Done,
     /*  976662 */   // Label 14600: @976662
     /*  976662 */   GIM_Try, /*On fail goto*//*Label 14601*/ GIMT_Encode4(976757), // Rule ID 9024 //
     /*  976667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976713 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976717 */     // MIs[1] Operand 1
     /*  976717 */     // No operand predicates
     /*  976717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976730 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  976730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976755 */     GIR_RootConstrainSelectedInstOperands,
     /*  976756 */     // GIR_Coverage, 9024,
     /*  976756 */     GIR_EraseRootFromParent_Done,
     /*  976757 */   // Label 14601: @976757
     /*  976757 */   GIM_Try, /*On fail goto*//*Label 14602*/ GIMT_Encode4(976852), // Rule ID 9025 //
     /*  976762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  976773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  976776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  976779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  976785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976812 */     // MIs[1] Operand 1
     /*  976812 */     // No operand predicates
     /*  976812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976825 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  976825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_MF2_MASK),
     /*  976828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976834 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  976847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976850 */     GIR_RootConstrainSelectedInstOperands,
     /*  976851 */     // GIR_Coverage, 9025,
     /*  976851 */     GIR_EraseRootFromParent_Done,
     /*  976852 */   // Label 14602: @976852
     /*  976852 */   GIM_Try, /*On fail goto*//*Label 14603*/ GIMT_Encode4(976947), // Rule ID 9028 //
     /*  976857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  976860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  976874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  976877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  976883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  976907 */     // MIs[1] Operand 1
     /*  976907 */     // No operand predicates
     /*  976907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  976911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  976913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  976920 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  976920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  976923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  976925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  976927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  976929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  976932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  976934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  976939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  976942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  976945 */     GIR_RootConstrainSelectedInstOperands,
     /*  976946 */     // GIR_Coverage, 9028,
     /*  976946 */     GIR_EraseRootFromParent_Done,
     /*  976947 */   // Label 14603: @976947
     /*  976947 */   GIM_Try, /*On fail goto*//*Label 14604*/ GIMT_Encode4(977042), // Rule ID 9029 //
     /*  976952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  976955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  976960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  976963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  976966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  976969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  976972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  976975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  976978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  976990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  976994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  976998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977002 */     // MIs[1] Operand 1
     /*  977002 */     // No operand predicates
     /*  977002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977015 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977040 */     GIR_RootConstrainSelectedInstOperands,
     /*  977041 */     // GIR_Coverage, 9029,
     /*  977041 */     GIR_EraseRootFromParent_Done,
     /*  977042 */   // Label 14604: @977042
     /*  977042 */   GIM_Try, /*On fail goto*//*Label 14605*/ GIMT_Encode4(977137), // Rule ID 9032 //
     /*  977047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977097 */     // MIs[1] Operand 1
     /*  977097 */     // No operand predicates
     /*  977097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977110 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  977110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977135 */     GIR_RootConstrainSelectedInstOperands,
     /*  977136 */     // GIR_Coverage, 9032,
     /*  977136 */     GIR_EraseRootFromParent_Done,
     /*  977137 */   // Label 14605: @977137
     /*  977137 */   GIM_Try, /*On fail goto*//*Label 14606*/ GIMT_Encode4(977232), // Rule ID 9033 //
     /*  977142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  977153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  977156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  977159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  977165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977192 */     // MIs[1] Operand 1
     /*  977192 */     // No operand predicates
     /*  977192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977205 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  977205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  977227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977230 */     GIR_RootConstrainSelectedInstOperands,
     /*  977231 */     // GIR_Coverage, 9033,
     /*  977231 */     GIR_EraseRootFromParent_Done,
     /*  977232 */   // Label 14606: @977232
     /*  977232 */   GIM_Try, /*On fail goto*//*Label 14607*/ GIMT_Encode4(977327), // Rule ID 9036 //
     /*  977237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977287 */     // MIs[1] Operand 1
     /*  977287 */     // No operand predicates
     /*  977287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  977300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977325 */     GIR_RootConstrainSelectedInstOperands,
     /*  977326 */     // GIR_Coverage, 9036,
     /*  977326 */     GIR_EraseRootFromParent_Done,
     /*  977327 */   // Label 14607: @977327
     /*  977327 */   GIM_Try, /*On fail goto*//*Label 14608*/ GIMT_Encode4(977422), // Rule ID 9037 //
     /*  977332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  977343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  977346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  977349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  977355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977378 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977382 */     // MIs[1] Operand 1
     /*  977382 */     // No operand predicates
     /*  977382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977395 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  977395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  977417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977420 */     GIR_RootConstrainSelectedInstOperands,
     /*  977421 */     // GIR_Coverage, 9037,
     /*  977421 */     GIR_EraseRootFromParent_Done,
     /*  977422 */   // Label 14608: @977422
     /*  977422 */   GIM_Try, /*On fail goto*//*Label 14609*/ GIMT_Encode4(977517), // Rule ID 9040 //
     /*  977427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  977430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977477 */     // MIs[1] Operand 1
     /*  977477 */     // No operand predicates
     /*  977477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977490 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  977490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977499 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977515 */     GIR_RootConstrainSelectedInstOperands,
     /*  977516 */     // GIR_Coverage, 9040,
     /*  977516 */     GIR_EraseRootFromParent_Done,
     /*  977517 */   // Label 14609: @977517
     /*  977517 */   GIM_Try, /*On fail goto*//*Label 14610*/ GIMT_Encode4(977612), // Rule ID 9041 //
     /*  977522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  977525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  977533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  977536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  977539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  977545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977572 */     // MIs[1] Operand 1
     /*  977572 */     // No operand predicates
     /*  977572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977585 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  977585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M1_MASK),
     /*  977588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  977607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977610 */     GIR_RootConstrainSelectedInstOperands,
     /*  977611 */     // GIR_Coverage, 9041,
     /*  977611 */     GIR_EraseRootFromParent_Done,
     /*  977612 */   // Label 14610: @977612
     /*  977612 */   GIM_Try, /*On fail goto*//*Label 14611*/ GIMT_Encode4(977707), // Rule ID 9044 //
     /*  977617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977667 */     // MIs[1] Operand 1
     /*  977667 */     // No operand predicates
     /*  977667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  977683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977705 */     GIR_RootConstrainSelectedInstOperands,
     /*  977706 */     // GIR_Coverage, 9044,
     /*  977706 */     GIR_EraseRootFromParent_Done,
     /*  977707 */   // Label 14611: @977707
     /*  977707 */   GIM_Try, /*On fail goto*//*Label 14612*/ GIMT_Encode4(977802), // Rule ID 9045 //
     /*  977712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  977723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  977726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  977729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  977735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  977750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977762 */     // MIs[1] Operand 1
     /*  977762 */     // No operand predicates
     /*  977762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977775 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  977778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977800 */     GIR_RootConstrainSelectedInstOperands,
     /*  977801 */     // GIR_Coverage, 9045,
     /*  977801 */     GIR_EraseRootFromParent_Done,
     /*  977802 */   // Label 14612: @977802
     /*  977802 */   GIM_Try, /*On fail goto*//*Label 14613*/ GIMT_Encode4(977897), // Rule ID 9048 //
     /*  977807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  977810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  977818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  977821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  977824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  977827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  977830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  977833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  977845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977857 */     // MIs[1] Operand 1
     /*  977857 */     // No operand predicates
     /*  977857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977870 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  977870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  977873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977895 */     GIR_RootConstrainSelectedInstOperands,
     /*  977896 */     // GIR_Coverage, 9048,
     /*  977896 */     GIR_EraseRootFromParent_Done,
     /*  977897 */   // Label 14613: @977897
     /*  977897 */   GIM_Try, /*On fail goto*//*Label 14614*/ GIMT_Encode4(977992), // Rule ID 9049 //
     /*  977902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  977905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  977910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  977913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  977916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  977919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  977922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  977925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  977928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  977936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  977940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  977944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  977948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  977952 */     // MIs[1] Operand 1
     /*  977952 */     // No operand predicates
     /*  977952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  977956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  977958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  977965 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  977965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  977968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  977970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  977972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  977974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  977977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  977979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  977984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  977987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  977990 */     GIR_RootConstrainSelectedInstOperands,
     /*  977991 */     // GIR_Coverage, 9049,
     /*  977991 */     GIR_EraseRootFromParent_Done,
     /*  977992 */   // Label 14614: @977992
     /*  977992 */   GIM_Try, /*On fail goto*//*Label 14615*/ GIMT_Encode4(978087), // Rule ID 9052 //
     /*  977997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978047 */     // MIs[1] Operand 1
     /*  978047 */     // No operand predicates
     /*  978047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978060 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  978060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978085 */     GIR_RootConstrainSelectedInstOperands,
     /*  978086 */     // GIR_Coverage, 9052,
     /*  978086 */     GIR_EraseRootFromParent_Done,
     /*  978087 */   // Label 14615: @978087
     /*  978087 */   GIM_Try, /*On fail goto*//*Label 14616*/ GIMT_Encode4(978182), // Rule ID 9053 //
     /*  978092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  978103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  978106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  978109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  978115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978142 */     // MIs[1] Operand 1
     /*  978142 */     // No operand predicates
     /*  978142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978146 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978155 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  978155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  978177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978180 */     GIR_RootConstrainSelectedInstOperands,
     /*  978181 */     // GIR_Coverage, 9053,
     /*  978181 */     GIR_EraseRootFromParent_Done,
     /*  978182 */   // Label 14616: @978182
     /*  978182 */   GIM_Try, /*On fail goto*//*Label 14617*/ GIMT_Encode4(978277), // Rule ID 9056 //
     /*  978187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978237 */     // MIs[1] Operand 1
     /*  978237 */     // No operand predicates
     /*  978237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978250 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978275 */     GIR_RootConstrainSelectedInstOperands,
     /*  978276 */     // GIR_Coverage, 9056,
     /*  978276 */     GIR_EraseRootFromParent_Done,
     /*  978277 */   // Label 14617: @978277
     /*  978277 */   GIM_Try, /*On fail goto*//*Label 14618*/ GIMT_Encode4(978372), // Rule ID 9057 //
     /*  978282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  978299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978332 */     // MIs[1] Operand 1
     /*  978332 */     // No operand predicates
     /*  978332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978345 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978370 */     GIR_RootConstrainSelectedInstOperands,
     /*  978371 */     // GIR_Coverage, 9057,
     /*  978371 */     GIR_EraseRootFromParent_Done,
     /*  978372 */   // Label 14618: @978372
     /*  978372 */   GIM_Try, /*On fail goto*//*Label 14619*/ GIMT_Encode4(978467), // Rule ID 9060 //
     /*  978377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978427 */     // MIs[1] Operand 1
     /*  978427 */     // No operand predicates
     /*  978427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978465 */     GIR_RootConstrainSelectedInstOperands,
     /*  978466 */     // GIR_Coverage, 9060,
     /*  978466 */     GIR_EraseRootFromParent_Done,
     /*  978467 */   // Label 14619: @978467
     /*  978467 */   GIM_Try, /*On fail goto*//*Label 14620*/ GIMT_Encode4(978562), // Rule ID 9061 //
     /*  978472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  978483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  978486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  978489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  978495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978522 */     // MIs[1] Operand 1
     /*  978522 */     // No operand predicates
     /*  978522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978535 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  978538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978560 */     GIR_RootConstrainSelectedInstOperands,
     /*  978561 */     // GIR_Coverage, 9061,
     /*  978561 */     GIR_EraseRootFromParent_Done,
     /*  978562 */   // Label 14620: @978562
     /*  978562 */   GIM_Try, /*On fail goto*//*Label 14621*/ GIMT_Encode4(978657), // Rule ID 9064 //
     /*  978567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978617 */     // MIs[1] Operand 1
     /*  978617 */     // No operand predicates
     /*  978617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978630 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  978630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978655 */     GIR_RootConstrainSelectedInstOperands,
     /*  978656 */     // GIR_Coverage, 9064,
     /*  978656 */     GIR_EraseRootFromParent_Done,
     /*  978657 */   // Label 14621: @978657
     /*  978657 */   GIM_Try, /*On fail goto*//*Label 14622*/ GIMT_Encode4(978752), // Rule ID 9065 //
     /*  978662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  978673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  978676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  978679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  978685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  978700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978708 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978712 */     // MIs[1] Operand 1
     /*  978712 */     // No operand predicates
     /*  978712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978725 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  978725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  978728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  978747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978750 */     GIR_RootConstrainSelectedInstOperands,
     /*  978751 */     // GIR_Coverage, 9065,
     /*  978751 */     GIR_EraseRootFromParent_Done,
     /*  978752 */   // Label 14622: @978752
     /*  978752 */   GIM_Try, /*On fail goto*//*Label 14623*/ GIMT_Encode4(978847), // Rule ID 9068 //
     /*  978757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  978774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978807 */     // MIs[1] Operand 1
     /*  978807 */     // No operand predicates
     /*  978807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978820 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  978820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978845 */     GIR_RootConstrainSelectedInstOperands,
     /*  978846 */     // GIR_Coverage, 9068,
     /*  978846 */     GIR_EraseRootFromParent_Done,
     /*  978847 */   // Label 14623: @978847
     /*  978847 */   GIM_Try, /*On fail goto*//*Label 14624*/ GIMT_Encode4(978942), // Rule ID 9069 //
     /*  978852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  978855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  978863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  978866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  978869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  978872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  978875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  978878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  978890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978902 */     // MIs[1] Operand 1
     /*  978902 */     // No operand predicates
     /*  978902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  978906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  978908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  978915 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  978915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  978918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  978920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  978922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  978924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  978927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  978929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  978934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  978937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  978940 */     GIR_RootConstrainSelectedInstOperands,
     /*  978941 */     // GIR_Coverage, 9069,
     /*  978941 */     GIR_EraseRootFromParent_Done,
     /*  978942 */   // Label 14624: @978942
     /*  978942 */   GIM_Try, /*On fail goto*//*Label 14625*/ GIMT_Encode4(979037), // Rule ID 9072 //
     /*  978947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  978950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  978955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  978958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  978961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  978964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  978967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  978970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  978973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  978981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  978985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  978989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  978993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  978997 */     // MIs[1] Operand 1
     /*  978997 */     // No operand predicates
     /*  978997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979010 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979035 */     GIR_RootConstrainSelectedInstOperands,
     /*  979036 */     // GIR_Coverage, 9072,
     /*  979036 */     GIR_EraseRootFromParent_Done,
     /*  979037 */   // Label 14625: @979037
     /*  979037 */   GIM_Try, /*On fail goto*//*Label 14626*/ GIMT_Encode4(979132), // Rule ID 9073 //
     /*  979042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  979059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979092 */     // MIs[1] Operand 1
     /*  979092 */     // No operand predicates
     /*  979092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979105 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979130 */     GIR_RootConstrainSelectedInstOperands,
     /*  979131 */     // GIR_Coverage, 9073,
     /*  979131 */     GIR_EraseRootFromParent_Done,
     /*  979132 */   // Label 14626: @979132
     /*  979132 */   GIM_Try, /*On fail goto*//*Label 14627*/ GIMT_Encode4(979227), // Rule ID 9076 //
     /*  979137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979187 */     // MIs[1] Operand 1
     /*  979187 */     // No operand predicates
     /*  979187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  979200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979225 */     GIR_RootConstrainSelectedInstOperands,
     /*  979226 */     // GIR_Coverage, 9076,
     /*  979226 */     GIR_EraseRootFromParent_Done,
     /*  979227 */   // Label 14627: @979227
     /*  979227 */   GIM_Try, /*On fail goto*//*Label 14628*/ GIMT_Encode4(979322), // Rule ID 9077 //
     /*  979232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  979243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  979246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  979249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  979255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979282 */     // MIs[1] Operand 1
     /*  979282 */     // No operand predicates
     /*  979282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979295 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  979295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  979317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979320 */     GIR_RootConstrainSelectedInstOperands,
     /*  979321 */     // GIR_Coverage, 9077,
     /*  979321 */     GIR_EraseRootFromParent_Done,
     /*  979322 */   // Label 14628: @979322
     /*  979322 */   GIM_Try, /*On fail goto*//*Label 14629*/ GIMT_Encode4(979417), // Rule ID 9080 //
     /*  979327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979377 */     // MIs[1] Operand 1
     /*  979377 */     // No operand predicates
     /*  979377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979390 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979415 */     GIR_RootConstrainSelectedInstOperands,
     /*  979416 */     // GIR_Coverage, 9080,
     /*  979416 */     GIR_EraseRootFromParent_Done,
     /*  979417 */   // Label 14629: @979417
     /*  979417 */   GIM_Try, /*On fail goto*//*Label 14630*/ GIMT_Encode4(979512), // Rule ID 9081 //
     /*  979422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  979433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  979436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  979439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  979445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  979460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979468 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979472 */     // MIs[1] Operand 1
     /*  979472 */     // No operand predicates
     /*  979472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979485 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M2_MASK),
     /*  979488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979494 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979510 */     GIR_RootConstrainSelectedInstOperands,
     /*  979511 */     // GIR_Coverage, 9081,
     /*  979511 */     GIR_EraseRootFromParent_Done,
     /*  979512 */   // Label 14630: @979512
     /*  979512 */   GIM_Try, /*On fail goto*//*Label 14631*/ GIMT_Encode4(979607), // Rule ID 9084 //
     /*  979517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979567 */     // MIs[1] Operand 1
     /*  979567 */     // No operand predicates
     /*  979567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979580 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979605 */     GIR_RootConstrainSelectedInstOperands,
     /*  979606 */     // GIR_Coverage, 9084,
     /*  979606 */     GIR_EraseRootFromParent_Done,
     /*  979607 */   // Label 14631: @979607
     /*  979607 */   GIM_Try, /*On fail goto*//*Label 14632*/ GIMT_Encode4(979702), // Rule ID 9085 //
     /*  979612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  979623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  979626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  979629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  979635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  979650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979662 */     // MIs[1] Operand 1
     /*  979662 */     // No operand predicates
     /*  979662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979675 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M4_MASK),
     /*  979678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979700 */     GIR_RootConstrainSelectedInstOperands,
     /*  979701 */     // GIR_Coverage, 9085,
     /*  979701 */     GIR_EraseRootFromParent_Done,
     /*  979702 */   // Label 14632: @979702
     /*  979702 */   GIM_Try, /*On fail goto*//*Label 14633*/ GIMT_Encode4(979797), // Rule ID 9088 //
     /*  979707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  979710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979757 */     // MIs[1] Operand 1
     /*  979757 */     // No operand predicates
     /*  979757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979770 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  979770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979795 */     GIR_RootConstrainSelectedInstOperands,
     /*  979796 */     // GIR_Coverage, 9088,
     /*  979796 */     GIR_EraseRootFromParent_Done,
     /*  979797 */   // Label 14633: @979797
     /*  979797 */   GIM_Try, /*On fail goto*//*Label 14634*/ GIMT_Encode4(979892), // Rule ID 9089 //
     /*  979802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  979805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /*  979810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  979813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  979816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  979819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  979822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  979825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  979828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  979840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979852 */     // MIs[1] Operand 1
     /*  979852 */     // No operand predicates
     /*  979852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979865 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  979865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VI_M8_MASK),
     /*  979868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  979887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979890 */     GIR_RootConstrainSelectedInstOperands,
     /*  979891 */     // GIR_Coverage, 9089,
     /*  979891 */     GIR_EraseRootFromParent_Done,
     /*  979892 */   // Label 14634: @979892
     /*  979892 */   GIM_Try, /*On fail goto*//*Label 14635*/ GIMT_Encode4(979987), // Rule ID 9180 //
     /*  979897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  979900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  979905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  979908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  979911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  979914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  979917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  979920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  979923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  979935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  979939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  979943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  979947 */     // MIs[1] Operand 1
     /*  979947 */     // No operand predicates
     /*  979947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  979951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  979953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  979960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  979960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  979963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  979965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  979967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  979969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  979972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  979974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  979979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  979982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  979985 */     GIR_RootConstrainSelectedInstOperands,
     /*  979986 */     // GIR_Coverage, 9180,
     /*  979986 */     GIR_EraseRootFromParent_Done,
     /*  979987 */   // Label 14635: @979987
     /*  979987 */   GIM_Try, /*On fail goto*//*Label 14636*/ GIMT_Encode4(980082), // Rule ID 9181 //
     /*  979992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  979995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  980009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980038 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980042 */     // MIs[1] Operand 1
     /*  980042 */     // No operand predicates
     /*  980042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980055 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF8_MASK),
     /*  980058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980080 */     GIR_RootConstrainSelectedInstOperands,
     /*  980081 */     // GIR_Coverage, 9181,
     /*  980081 */     GIR_EraseRootFromParent_Done,
     /*  980082 */   // Label 14636: @980082
     /*  980082 */   GIM_Try, /*On fail goto*//*Label 14637*/ GIMT_Encode4(980177), // Rule ID 9184 //
     /*  980087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980137 */     // MIs[1] Operand 1
     /*  980137 */     // No operand predicates
     /*  980137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980150 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980175 */     GIR_RootConstrainSelectedInstOperands,
     /*  980176 */     // GIR_Coverage, 9184,
     /*  980176 */     GIR_EraseRootFromParent_Done,
     /*  980177 */   // Label 14637: @980177
     /*  980177 */   GIM_Try, /*On fail goto*//*Label 14638*/ GIMT_Encode4(980272), // Rule ID 9185 //
     /*  980182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  980199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980232 */     // MIs[1] Operand 1
     /*  980232 */     // No operand predicates
     /*  980232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980245 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980270 */     GIR_RootConstrainSelectedInstOperands,
     /*  980271 */     // GIR_Coverage, 9185,
     /*  980271 */     GIR_EraseRootFromParent_Done,
     /*  980272 */   // Label 14638: @980272
     /*  980272 */   GIM_Try, /*On fail goto*//*Label 14639*/ GIMT_Encode4(980367), // Rule ID 9188 //
     /*  980277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980327 */     // MIs[1] Operand 1
     /*  980327 */     // No operand predicates
     /*  980327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980340 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  980340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980365 */     GIR_RootConstrainSelectedInstOperands,
     /*  980366 */     // GIR_Coverage, 9188,
     /*  980366 */     GIR_EraseRootFromParent_Done,
     /*  980367 */   // Label 14639: @980367
     /*  980367 */   GIM_Try, /*On fail goto*//*Label 14640*/ GIMT_Encode4(980462), // Rule ID 9189 //
     /*  980372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  980383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  980386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  980389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  980395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980422 */     // MIs[1] Operand 1
     /*  980422 */     // No operand predicates
     /*  980422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980435 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  980435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  980457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980460 */     GIR_RootConstrainSelectedInstOperands,
     /*  980461 */     // GIR_Coverage, 9189,
     /*  980461 */     GIR_EraseRootFromParent_Done,
     /*  980462 */   // Label 14640: @980462
     /*  980462 */   GIM_Try, /*On fail goto*//*Label 14641*/ GIMT_Encode4(980557), // Rule ID 9192 //
     /*  980467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980517 */     // MIs[1] Operand 1
     /*  980517 */     // No operand predicates
     /*  980517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980530 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980555 */     GIR_RootConstrainSelectedInstOperands,
     /*  980556 */     // GIR_Coverage, 9192,
     /*  980556 */     GIR_EraseRootFromParent_Done,
     /*  980557 */   // Label 14641: @980557
     /*  980557 */   GIM_Try, /*On fail goto*//*Label 14642*/ GIMT_Encode4(980652), // Rule ID 9193 //
     /*  980562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  980579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980612 */     // MIs[1] Operand 1
     /*  980612 */     // No operand predicates
     /*  980612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980625 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF4_MASK),
     /*  980628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980650 */     GIR_RootConstrainSelectedInstOperands,
     /*  980651 */     // GIR_Coverage, 9193,
     /*  980651 */     GIR_EraseRootFromParent_Done,
     /*  980652 */   // Label 14642: @980652
     /*  980652 */   GIM_Try, /*On fail goto*//*Label 14643*/ GIMT_Encode4(980747), // Rule ID 9196 //
     /*  980657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980703 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980707 */     // MIs[1] Operand 1
     /*  980707 */     // No operand predicates
     /*  980707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980720 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  980720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980745 */     GIR_RootConstrainSelectedInstOperands,
     /*  980746 */     // GIR_Coverage, 9196,
     /*  980746 */     GIR_EraseRootFromParent_Done,
     /*  980747 */   // Label 14643: @980747
     /*  980747 */   GIM_Try, /*On fail goto*//*Label 14644*/ GIMT_Encode4(980842), // Rule ID 9197 //
     /*  980752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  980763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  980766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  980769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  980775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980802 */     // MIs[1] Operand 1
     /*  980802 */     // No operand predicates
     /*  980802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980815 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  980815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  980837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980840 */     GIR_RootConstrainSelectedInstOperands,
     /*  980841 */     // GIR_Coverage, 9197,
     /*  980841 */     GIR_EraseRootFromParent_Done,
     /*  980842 */   // Label 14644: @980842
     /*  980842 */   GIM_Try, /*On fail goto*//*Label 14645*/ GIMT_Encode4(980937), // Rule ID 9200 //
     /*  980847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  980850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  980864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  980867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  980873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980893 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980897 */     // MIs[1] Operand 1
     /*  980897 */     // No operand predicates
     /*  980897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  980910 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  980910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  980913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  980915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  980917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  980919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  980922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  980924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  980929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  980932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  980935 */     GIR_RootConstrainSelectedInstOperands,
     /*  980936 */     // GIR_Coverage, 9200,
     /*  980936 */     GIR_EraseRootFromParent_Done,
     /*  980937 */   // Label 14645: @980937
     /*  980937 */   GIM_Try, /*On fail goto*//*Label 14646*/ GIMT_Encode4(981032), // Rule ID 9201 //
     /*  980942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  980945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  980950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  980953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  980956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  980959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  980962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  980965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  980968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  980980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  980984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  980988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  980992 */     // MIs[1] Operand 1
     /*  980992 */     // No operand predicates
     /*  980992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  980996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  980998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981005 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_MF2_MASK),
     /*  981008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981030 */     GIR_RootConstrainSelectedInstOperands,
     /*  981031 */     // GIR_Coverage, 9201,
     /*  981031 */     GIR_EraseRootFromParent_Done,
     /*  981032 */   // Label 14646: @981032
     /*  981032 */   GIM_Try, /*On fail goto*//*Label 14647*/ GIMT_Encode4(981127), // Rule ID 9204 //
     /*  981037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981087 */     // MIs[1] Operand 1
     /*  981087 */     // No operand predicates
     /*  981087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981091 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981125 */     GIR_RootConstrainSelectedInstOperands,
     /*  981126 */     // GIR_Coverage, 9204,
     /*  981126 */     GIR_EraseRootFromParent_Done,
     /*  981127 */   // Label 14647: @981127
     /*  981127 */   GIM_Try, /*On fail goto*//*Label 14648*/ GIMT_Encode4(981222), // Rule ID 9205 //
     /*  981132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  981143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  981146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  981149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  981155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981182 */     // MIs[1] Operand 1
     /*  981182 */     // No operand predicates
     /*  981182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981195 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981220 */     GIR_RootConstrainSelectedInstOperands,
     /*  981221 */     // GIR_Coverage, 9205,
     /*  981221 */     GIR_EraseRootFromParent_Done,
     /*  981222 */   // Label 14648: @981222
     /*  981222 */   GIM_Try, /*On fail goto*//*Label 14649*/ GIMT_Encode4(981317), // Rule ID 9208 //
     /*  981227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981277 */     // MIs[1] Operand 1
     /*  981277 */     // No operand predicates
     /*  981277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981290 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  981290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981315 */     GIR_RootConstrainSelectedInstOperands,
     /*  981316 */     // GIR_Coverage, 9208,
     /*  981316 */     GIR_EraseRootFromParent_Done,
     /*  981317 */   // Label 14649: @981317
     /*  981317 */   GIM_Try, /*On fail goto*//*Label 14650*/ GIMT_Encode4(981412), // Rule ID 9209 //
     /*  981322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  981333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  981336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  981339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  981345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981372 */     // MIs[1] Operand 1
     /*  981372 */     // No operand predicates
     /*  981372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981385 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  981385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  981407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981410 */     GIR_RootConstrainSelectedInstOperands,
     /*  981411 */     // GIR_Coverage, 9209,
     /*  981411 */     GIR_EraseRootFromParent_Done,
     /*  981412 */   // Label 14650: @981412
     /*  981412 */   GIM_Try, /*On fail goto*//*Label 14651*/ GIMT_Encode4(981507), // Rule ID 9212 //
     /*  981417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981463 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981467 */     // MIs[1] Operand 1
     /*  981467 */     // No operand predicates
     /*  981467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  981480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981505 */     GIR_RootConstrainSelectedInstOperands,
     /*  981506 */     // GIR_Coverage, 9212,
     /*  981506 */     GIR_EraseRootFromParent_Done,
     /*  981507 */   // Label 14651: @981507
     /*  981507 */   GIM_Try, /*On fail goto*//*Label 14652*/ GIMT_Encode4(981602), // Rule ID 9213 //
     /*  981512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  981523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  981526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  981529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  981535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981558 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981562 */     // MIs[1] Operand 1
     /*  981562 */     // No operand predicates
     /*  981562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981575 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  981575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  981597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981600 */     GIR_RootConstrainSelectedInstOperands,
     /*  981601 */     // GIR_Coverage, 9213,
     /*  981601 */     GIR_EraseRootFromParent_Done,
     /*  981602 */   // Label 14652: @981602
     /*  981602 */   GIM_Try, /*On fail goto*//*Label 14653*/ GIMT_Encode4(981697), // Rule ID 9216 //
     /*  981607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  981610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981657 */     // MIs[1] Operand 1
     /*  981657 */     // No operand predicates
     /*  981657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981670 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  981670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981695 */     GIR_RootConstrainSelectedInstOperands,
     /*  981696 */     // GIR_Coverage, 9216,
     /*  981696 */     GIR_EraseRootFromParent_Done,
     /*  981697 */   // Label 14653: @981697
     /*  981697 */   GIM_Try, /*On fail goto*//*Label 14654*/ GIMT_Encode4(981792), // Rule ID 9217 //
     /*  981702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  981705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  981713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  981716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  981719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  981725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981752 */     // MIs[1] Operand 1
     /*  981752 */     // No operand predicates
     /*  981752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981765 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  981765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M1_MASK),
     /*  981768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  981787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981790 */     GIR_RootConstrainSelectedInstOperands,
     /*  981791 */     // GIR_Coverage, 9217,
     /*  981791 */     GIR_EraseRootFromParent_Done,
     /*  981792 */   // Label 14654: @981792
     /*  981792 */   GIM_Try, /*On fail goto*//*Label 14655*/ GIMT_Encode4(981887), // Rule ID 9220 //
     /*  981797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  981808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  981811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  981814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  981817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  981820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  981823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  981835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981847 */     // MIs[1] Operand 1
     /*  981847 */     // No operand predicates
     /*  981847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981851 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981860 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  981860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  981863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981885 */     GIR_RootConstrainSelectedInstOperands,
     /*  981886 */     // GIR_Coverage, 9220,
     /*  981886 */     GIR_EraseRootFromParent_Done,
     /*  981887 */   // Label 14655: @981887
     /*  981887 */   GIM_Try, /*On fail goto*//*Label 14656*/ GIMT_Encode4(981982), // Rule ID 9221 //
     /*  981892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  981895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  981903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  981906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  981909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  981912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  981915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  981918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  981926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  981930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  981934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  981938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  981942 */     // MIs[1] Operand 1
     /*  981942 */     // No operand predicates
     /*  981942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  981946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  981948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  981955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  981955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  981958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  981960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  981962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  981964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  981967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  981969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  981974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  981977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  981980 */     GIR_RootConstrainSelectedInstOperands,
     /*  981981 */     // GIR_Coverage, 9221,
     /*  981981 */     GIR_EraseRootFromParent_Done,
     /*  981982 */   // Label 14656: @981982
     /*  981982 */   GIM_Try, /*On fail goto*//*Label 14657*/ GIMT_Encode4(982077), // Rule ID 9224 //
     /*  981987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  981990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  981995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  981998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982037 */     // MIs[1] Operand 1
     /*  982037 */     // No operand predicates
     /*  982037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982050 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982075 */     GIR_RootConstrainSelectedInstOperands,
     /*  982076 */     // GIR_Coverage, 9224,
     /*  982076 */     GIR_EraseRootFromParent_Done,
     /*  982077 */   // Label 14657: @982077
     /*  982077 */   GIM_Try, /*On fail goto*//*Label 14658*/ GIMT_Encode4(982172), // Rule ID 9225 //
     /*  982082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  982099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982128 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982132 */     // MIs[1] Operand 1
     /*  982132 */     // No operand predicates
     /*  982132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982145 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982170 */     GIR_RootConstrainSelectedInstOperands,
     /*  982171 */     // GIR_Coverage, 9225,
     /*  982171 */     GIR_EraseRootFromParent_Done,
     /*  982172 */   // Label 14658: @982172
     /*  982172 */   GIM_Try, /*On fail goto*//*Label 14659*/ GIMT_Encode4(982267), // Rule ID 9228 //
     /*  982177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982227 */     // MIs[1] Operand 1
     /*  982227 */     // No operand predicates
     /*  982227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982240 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  982240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982265 */     GIR_RootConstrainSelectedInstOperands,
     /*  982266 */     // GIR_Coverage, 9228,
     /*  982266 */     GIR_EraseRootFromParent_Done,
     /*  982267 */   // Label 14659: @982267
     /*  982267 */   GIM_Try, /*On fail goto*//*Label 14660*/ GIMT_Encode4(982362), // Rule ID 9229 //
     /*  982272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  982283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  982286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  982289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  982295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982318 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982322 */     // MIs[1] Operand 1
     /*  982322 */     // No operand predicates
     /*  982322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982335 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  982335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  982357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982360 */     GIR_RootConstrainSelectedInstOperands,
     /*  982361 */     // GIR_Coverage, 9229,
     /*  982361 */     GIR_EraseRootFromParent_Done,
     /*  982362 */   // Label 14660: @982362
     /*  982362 */   GIM_Try, /*On fail goto*//*Label 14661*/ GIMT_Encode4(982457), // Rule ID 9232 //
     /*  982367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982417 */     // MIs[1] Operand 1
     /*  982417 */     // No operand predicates
     /*  982417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982430 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982455 */     GIR_RootConstrainSelectedInstOperands,
     /*  982456 */     // GIR_Coverage, 9232,
     /*  982456 */     GIR_EraseRootFromParent_Done,
     /*  982457 */   // Label 14661: @982457
     /*  982457 */   GIM_Try, /*On fail goto*//*Label 14662*/ GIMT_Encode4(982552), // Rule ID 9233 //
     /*  982462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  982473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  982476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  982479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  982485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982512 */     // MIs[1] Operand 1
     /*  982512 */     // No operand predicates
     /*  982512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982525 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  982528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982550 */     GIR_RootConstrainSelectedInstOperands,
     /*  982551 */     // GIR_Coverage, 9233,
     /*  982551 */     GIR_EraseRootFromParent_Done,
     /*  982552 */   // Label 14662: @982552
     /*  982552 */   GIM_Try, /*On fail goto*//*Label 14663*/ GIMT_Encode4(982647), // Rule ID 9236 //
     /*  982557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982607 */     // MIs[1] Operand 1
     /*  982607 */     // No operand predicates
     /*  982607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982620 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982645 */     GIR_RootConstrainSelectedInstOperands,
     /*  982646 */     // GIR_Coverage, 9236,
     /*  982646 */     GIR_EraseRootFromParent_Done,
     /*  982647 */   // Label 14663: @982647
     /*  982647 */   GIM_Try, /*On fail goto*//*Label 14664*/ GIMT_Encode4(982742), // Rule ID 9237 //
     /*  982652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  982663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  982666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  982669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  982675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  982690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982702 */     // MIs[1] Operand 1
     /*  982702 */     // No operand predicates
     /*  982702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982715 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  982718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982740 */     GIR_RootConstrainSelectedInstOperands,
     /*  982741 */     // GIR_Coverage, 9237,
     /*  982741 */     GIR_EraseRootFromParent_Done,
     /*  982742 */   // Label 14664: @982742
     /*  982742 */   GIM_Try, /*On fail goto*//*Label 14665*/ GIMT_Encode4(982837), // Rule ID 9240 //
     /*  982747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982793 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982797 */     // MIs[1] Operand 1
     /*  982797 */     // No operand predicates
     /*  982797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982810 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  982810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982835 */     GIR_RootConstrainSelectedInstOperands,
     /*  982836 */     // GIR_Coverage, 9240,
     /*  982836 */     GIR_EraseRootFromParent_Done,
     /*  982837 */   // Label 14665: @982837
     /*  982837 */   GIM_Try, /*On fail goto*//*Label 14666*/ GIMT_Encode4(982932), // Rule ID 9241 //
     /*  982842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  982845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  982853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  982856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  982859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  982862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  982865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  982868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  982880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982892 */     // MIs[1] Operand 1
     /*  982892 */     // No operand predicates
     /*  982892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  982905 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  982905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  982908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  982910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  982912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  982914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  982917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  982919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  982924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  982927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  982930 */     GIR_RootConstrainSelectedInstOperands,
     /*  982931 */     // GIR_Coverage, 9241,
     /*  982931 */     GIR_EraseRootFromParent_Done,
     /*  982932 */   // Label 14666: @982932
     /*  982932 */   GIM_Try, /*On fail goto*//*Label 14667*/ GIMT_Encode4(983027), // Rule ID 9244 //
     /*  982937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  982940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  982945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  982948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  982951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  982954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  982957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  982960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  982963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  982971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  982975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  982979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  982983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  982987 */     // MIs[1] Operand 1
     /*  982987 */     // No operand predicates
     /*  982987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  982991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  982993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983025 */     GIR_RootConstrainSelectedInstOperands,
     /*  983026 */     // GIR_Coverage, 9244,
     /*  983026 */     GIR_EraseRootFromParent_Done,
     /*  983027 */   // Label 14667: @983027
     /*  983027 */   GIM_Try, /*On fail goto*//*Label 14668*/ GIMT_Encode4(983122), // Rule ID 9245 //
     /*  983032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  983049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983082 */     // MIs[1] Operand 1
     /*  983082 */     // No operand predicates
     /*  983082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983095 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983104 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983120 */     GIR_RootConstrainSelectedInstOperands,
     /*  983121 */     // GIR_Coverage, 9245,
     /*  983121 */     GIR_EraseRootFromParent_Done,
     /*  983122 */   // Label 14668: @983122
     /*  983122 */   GIM_Try, /*On fail goto*//*Label 14669*/ GIMT_Encode4(983217), // Rule ID 9248 //
     /*  983127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983177 */     // MIs[1] Operand 1
     /*  983177 */     // No operand predicates
     /*  983177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983190 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983215 */     GIR_RootConstrainSelectedInstOperands,
     /*  983216 */     // GIR_Coverage, 9248,
     /*  983216 */     GIR_EraseRootFromParent_Done,
     /*  983217 */   // Label 14669: @983217
     /*  983217 */   GIM_Try, /*On fail goto*//*Label 14670*/ GIMT_Encode4(983312), // Rule ID 9249 //
     /*  983222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  983239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983272 */     // MIs[1] Operand 1
     /*  983272 */     // No operand predicates
     /*  983272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983285 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983310 */     GIR_RootConstrainSelectedInstOperands,
     /*  983311 */     // GIR_Coverage, 9249,
     /*  983311 */     GIR_EraseRootFromParent_Done,
     /*  983312 */   // Label 14670: @983312
     /*  983312 */   GIM_Try, /*On fail goto*//*Label 14671*/ GIMT_Encode4(983407), // Rule ID 9252 //
     /*  983317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  983320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983367 */     // MIs[1] Operand 1
     /*  983367 */     // No operand predicates
     /*  983367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983380 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  983380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983405 */     GIR_RootConstrainSelectedInstOperands,
     /*  983406 */     // GIR_Coverage, 9252,
     /*  983406 */     GIR_EraseRootFromParent_Done,
     /*  983407 */   // Label 14671: @983407
     /*  983407 */   GIM_Try, /*On fail goto*//*Label 14672*/ GIMT_Encode4(983502), // Rule ID 9253 //
     /*  983412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  983415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  983423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  983426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  983429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  983435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983462 */     // MIs[1] Operand 1
     /*  983462 */     // No operand predicates
     /*  983462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983475 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  983475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  983497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983500 */     GIR_RootConstrainSelectedInstOperands,
     /*  983501 */     // GIR_Coverage, 9253,
     /*  983501 */     GIR_EraseRootFromParent_Done,
     /*  983502 */   // Label 14672: @983502
     /*  983502 */   GIM_Try, /*On fail goto*//*Label 14673*/ GIMT_Encode4(983597), // Rule ID 9256 //
     /*  983507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983557 */     // MIs[1] Operand 1
     /*  983557 */     // No operand predicates
     /*  983557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983570 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983595 */     GIR_RootConstrainSelectedInstOperands,
     /*  983596 */     // GIR_Coverage, 9256,
     /*  983596 */     GIR_EraseRootFromParent_Done,
     /*  983597 */   // Label 14673: @983597
     /*  983597 */   GIM_Try, /*On fail goto*//*Label 14674*/ GIMT_Encode4(983692), // Rule ID 9257 //
     /*  983602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  983613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  983616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  983619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  983625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  983640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983652 */     // MIs[1] Operand 1
     /*  983652 */     // No operand predicates
     /*  983652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983665 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  983665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M2_MASK),
     /*  983668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983690 */     GIR_RootConstrainSelectedInstOperands,
     /*  983691 */     // GIR_Coverage, 9257,
     /*  983691 */     GIR_EraseRootFromParent_Done,
     /*  983692 */   // Label 14674: @983692
     /*  983692 */   GIM_Try, /*On fail goto*//*Label 14675*/ GIMT_Encode4(983787), // Rule ID 9260 //
     /*  983697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983747 */     // MIs[1] Operand 1
     /*  983747 */     // No operand predicates
     /*  983747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983760 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983785 */     GIR_RootConstrainSelectedInstOperands,
     /*  983786 */     // GIR_Coverage, 9260,
     /*  983786 */     GIR_EraseRootFromParent_Done,
     /*  983787 */   // Label 14675: @983787
     /*  983787 */   GIM_Try, /*On fail goto*//*Label 14676*/ GIMT_Encode4(983882), // Rule ID 9261 //
     /*  983792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  983803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  983806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  983809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  983812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  983815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  983818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  983830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983842 */     // MIs[1] Operand 1
     /*  983842 */     // No operand predicates
     /*  983842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983855 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  983855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M4_MASK),
     /*  983858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983864 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983880 */     GIR_RootConstrainSelectedInstOperands,
     /*  983881 */     // GIR_Coverage, 9261,
     /*  983881 */     GIR_EraseRootFromParent_Done,
     /*  983882 */   // Label 14676: @983882
     /*  983882 */   GIM_Try, /*On fail goto*//*Label 14677*/ GIMT_Encode4(983977), // Rule ID 9264 //
     /*  983887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  983890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  983904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  983907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  983910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  983913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  983921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  983925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  983929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  983933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  983937 */     // MIs[1] Operand 1
     /*  983937 */     // No operand predicates
     /*  983937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  983941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  983943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  983950 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  983950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  983953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  983955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  983957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  983959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  983962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  983964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  983969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  983972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  983975 */     GIR_RootConstrainSelectedInstOperands,
     /*  983976 */     // GIR_Coverage, 9264,
     /*  983976 */     GIR_EraseRootFromParent_Done,
     /*  983977 */   // Label 14677: @983977
     /*  983977 */   GIM_Try, /*On fail goto*//*Label 14678*/ GIMT_Encode4(984072), // Rule ID 9265 //
     /*  983982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  983985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /*  983990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  983993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  983996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  983999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  984005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  984020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984032 */     // MIs[1] Operand 1
     /*  984032 */     // No operand predicates
     /*  984032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984045 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  984045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VI_M8_MASK),
     /*  984048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  984067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984070 */     GIR_RootConstrainSelectedInstOperands,
     /*  984071 */     // GIR_Coverage, 9265,
     /*  984071 */     GIR_EraseRootFromParent_Done,
     /*  984072 */   // Label 14678: @984072
     /*  984072 */   GIM_Try, /*On fail goto*//*Label 14679*/ GIMT_Encode4(984167), // Rule ID 9356 //
     /*  984077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984127 */     // MIs[1] Operand 1
     /*  984127 */     // No operand predicates
     /*  984127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984140 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984165 */     GIR_RootConstrainSelectedInstOperands,
     /*  984166 */     // GIR_Coverage, 9356,
     /*  984166 */     GIR_EraseRootFromParent_Done,
     /*  984167 */   // Label 14679: @984167
     /*  984167 */   GIM_Try, /*On fail goto*//*Label 14680*/ GIMT_Encode4(984262), // Rule ID 9357 //
     /*  984172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  984189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984222 */     // MIs[1] Operand 1
     /*  984222 */     // No operand predicates
     /*  984222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984235 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF8_MASK),
     /*  984238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984260 */     GIR_RootConstrainSelectedInstOperands,
     /*  984261 */     // GIR_Coverage, 9357,
     /*  984261 */     GIR_EraseRootFromParent_Done,
     /*  984262 */   // Label 14680: @984262
     /*  984262 */   GIM_Try, /*On fail goto*//*Label 14681*/ GIMT_Encode4(984357), // Rule ID 9360 //
     /*  984267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984317 */     // MIs[1] Operand 1
     /*  984317 */     // No operand predicates
     /*  984317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984330 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984355 */     GIR_RootConstrainSelectedInstOperands,
     /*  984356 */     // GIR_Coverage, 9360,
     /*  984356 */     GIR_EraseRootFromParent_Done,
     /*  984357 */   // Label 14681: @984357
     /*  984357 */   GIM_Try, /*On fail goto*//*Label 14682*/ GIMT_Encode4(984452), // Rule ID 9361 //
     /*  984362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  984379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984408 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984412 */     // MIs[1] Operand 1
     /*  984412 */     // No operand predicates
     /*  984412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984425 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984434 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984450 */     GIR_RootConstrainSelectedInstOperands,
     /*  984451 */     // GIR_Coverage, 9361,
     /*  984451 */     GIR_EraseRootFromParent_Done,
     /*  984452 */   // Label 14682: @984452
     /*  984452 */   GIM_Try, /*On fail goto*//*Label 14683*/ GIMT_Encode4(984547), // Rule ID 9364 //
     /*  984457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984507 */     // MIs[1] Operand 1
     /*  984507 */     // No operand predicates
     /*  984507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  984520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  984523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984545 */     GIR_RootConstrainSelectedInstOperands,
     /*  984546 */     // GIR_Coverage, 9364,
     /*  984546 */     GIR_EraseRootFromParent_Done,
     /*  984547 */   // Label 14683: @984547
     /*  984547 */   GIM_Try, /*On fail goto*//*Label 14684*/ GIMT_Encode4(984642), // Rule ID 9365 //
     /*  984552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  984563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  984566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  984569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  984575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984602 */     // MIs[1] Operand 1
     /*  984602 */     // No operand predicates
     /*  984602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984615 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  984615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  984618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  984637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984640 */     GIR_RootConstrainSelectedInstOperands,
     /*  984641 */     // GIR_Coverage, 9365,
     /*  984641 */     GIR_EraseRootFromParent_Done,
     /*  984642 */   // Label 14684: @984642
     /*  984642 */   GIM_Try, /*On fail goto*//*Label 14685*/ GIMT_Encode4(984737), // Rule ID 9368 //
     /*  984647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984697 */     // MIs[1] Operand 1
     /*  984697 */     // No operand predicates
     /*  984697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984710 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  984710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984735 */     GIR_RootConstrainSelectedInstOperands,
     /*  984736 */     // GIR_Coverage, 9368,
     /*  984736 */     GIR_EraseRootFromParent_Done,
     /*  984737 */   // Label 14685: @984737
     /*  984737 */   GIM_Try, /*On fail goto*//*Label 14686*/ GIMT_Encode4(984832), // Rule ID 9369 //
     /*  984742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  984753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  984756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  984759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  984765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984792 */     // MIs[1] Operand 1
     /*  984792 */     // No operand predicates
     /*  984792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984805 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  984805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF4_MASK),
     /*  984808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984830 */     GIR_RootConstrainSelectedInstOperands,
     /*  984831 */     // GIR_Coverage, 9369,
     /*  984831 */     GIR_EraseRootFromParent_Done,
     /*  984832 */   // Label 14686: @984832
     /*  984832 */   GIM_Try, /*On fail goto*//*Label 14687*/ GIMT_Encode4(984927), // Rule ID 9372 //
     /*  984837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  984840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  984854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  984857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  984863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984887 */     // MIs[1] Operand 1
     /*  984887 */     // No operand predicates
     /*  984887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  984900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  984903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  984905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  984907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  984909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  984912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  984914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  984919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  984922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  984925 */     GIR_RootConstrainSelectedInstOperands,
     /*  984926 */     // GIR_Coverage, 9372,
     /*  984926 */     GIR_EraseRootFromParent_Done,
     /*  984927 */   // Label 14687: @984927
     /*  984927 */   GIM_Try, /*On fail goto*//*Label 14688*/ GIMT_Encode4(985022), // Rule ID 9373 //
     /*  984932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  984935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  984940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  984943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  984946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  984949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  984952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  984955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  984958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  984970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  984974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  984978 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  984982 */     // MIs[1] Operand 1
     /*  984982 */     // No operand predicates
     /*  984982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  984986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  984988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  984995 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  984995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  984998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985020 */     GIR_RootConstrainSelectedInstOperands,
     /*  985021 */     // GIR_Coverage, 9373,
     /*  985021 */     GIR_EraseRootFromParent_Done,
     /*  985022 */   // Label 14688: @985022
     /*  985022 */   GIM_Try, /*On fail goto*//*Label 14689*/ GIMT_Encode4(985117), // Rule ID 9376 //
     /*  985027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985073 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985077 */     // MIs[1] Operand 1
     /*  985077 */     // No operand predicates
     /*  985077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985090 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985115 */     GIR_RootConstrainSelectedInstOperands,
     /*  985116 */     // GIR_Coverage, 9376,
     /*  985116 */     GIR_EraseRootFromParent_Done,
     /*  985117 */   // Label 14689: @985117
     /*  985117 */   GIM_Try, /*On fail goto*//*Label 14690*/ GIMT_Encode4(985212), // Rule ID 9377 //
     /*  985122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  985139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985172 */     // MIs[1] Operand 1
     /*  985172 */     // No operand predicates
     /*  985172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985185 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_MF2_MASK),
     /*  985188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985210 */     GIR_RootConstrainSelectedInstOperands,
     /*  985211 */     // GIR_Coverage, 9377,
     /*  985211 */     GIR_EraseRootFromParent_Done,
     /*  985212 */   // Label 14690: @985212
     /*  985212 */   GIM_Try, /*On fail goto*//*Label 14691*/ GIMT_Encode4(985307), // Rule ID 9380 //
     /*  985217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985267 */     // MIs[1] Operand 1
     /*  985267 */     // No operand predicates
     /*  985267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  985280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985305 */     GIR_RootConstrainSelectedInstOperands,
     /*  985306 */     // GIR_Coverage, 9380,
     /*  985306 */     GIR_EraseRootFromParent_Done,
     /*  985307 */   // Label 14691: @985307
     /*  985307 */   GIM_Try, /*On fail goto*//*Label 14692*/ GIMT_Encode4(985402), // Rule ID 9381 //
     /*  985312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  985323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  985326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  985329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  985335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985362 */     // MIs[1] Operand 1
     /*  985362 */     // No operand predicates
     /*  985362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985375 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  985375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  985397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985400 */     GIR_RootConstrainSelectedInstOperands,
     /*  985401 */     // GIR_Coverage, 9381,
     /*  985401 */     GIR_EraseRootFromParent_Done,
     /*  985402 */   // Label 14692: @985402
     /*  985402 */   GIM_Try, /*On fail goto*//*Label 14693*/ GIMT_Encode4(985497), // Rule ID 9384 //
     /*  985407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985457 */     // MIs[1] Operand 1
     /*  985457 */     // No operand predicates
     /*  985457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985470 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  985470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985495 */     GIR_RootConstrainSelectedInstOperands,
     /*  985496 */     // GIR_Coverage, 9384,
     /*  985496 */     GIR_EraseRootFromParent_Done,
     /*  985497 */   // Label 14693: @985497
     /*  985497 */   GIM_Try, /*On fail goto*//*Label 14694*/ GIMT_Encode4(985592), // Rule ID 9385 //
     /*  985502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  985513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  985516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  985519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  985525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985552 */     // MIs[1] Operand 1
     /*  985552 */     // No operand predicates
     /*  985552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985565 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  985565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  985587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985590 */     GIR_RootConstrainSelectedInstOperands,
     /*  985591 */     // GIR_Coverage, 9385,
     /*  985591 */     GIR_EraseRootFromParent_Done,
     /*  985592 */   // Label 14694: @985592
     /*  985592 */   GIM_Try, /*On fail goto*//*Label 14695*/ GIMT_Encode4(985687), // Rule ID 9388 //
     /*  985597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985647 */     // MIs[1] Operand 1
     /*  985647 */     // No operand predicates
     /*  985647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  985660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985685 */     GIR_RootConstrainSelectedInstOperands,
     /*  985686 */     // GIR_Coverage, 9388,
     /*  985686 */     GIR_EraseRootFromParent_Done,
     /*  985687 */   // Label 14695: @985687
     /*  985687 */   GIM_Try, /*On fail goto*//*Label 14696*/ GIMT_Encode4(985782), // Rule ID 9389 //
     /*  985692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  985695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  985703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  985706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  985709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  985715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985742 */     // MIs[1] Operand 1
     /*  985742 */     // No operand predicates
     /*  985742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  985755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  985777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985780 */     GIR_RootConstrainSelectedInstOperands,
     /*  985781 */     // GIR_Coverage, 9389,
     /*  985781 */     GIR_EraseRootFromParent_Done,
     /*  985782 */   // Label 14696: @985782
     /*  985782 */   GIM_Try, /*On fail goto*//*Label 14697*/ GIMT_Encode4(985877), // Rule ID 9392 //
     /*  985787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  985790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  985813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985837 */     // MIs[1] Operand 1
     /*  985837 */     // No operand predicates
     /*  985837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985850 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  985850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985859 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985875 */     GIR_RootConstrainSelectedInstOperands,
     /*  985876 */     // GIR_Coverage, 9392,
     /*  985876 */     GIR_EraseRootFromParent_Done,
     /*  985877 */   // Label 14697: @985877
     /*  985877 */   GIM_Try, /*On fail goto*//*Label 14698*/ GIMT_Encode4(985972), // Rule ID 9393 //
     /*  985882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  985885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /*  985893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  985896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  985899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  985902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  985905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  985908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  985920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  985924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  985928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  985932 */     // MIs[1] Operand 1
     /*  985932 */     // No operand predicates
     /*  985932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  985936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  985938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  985945 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  985945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M1_MASK),
     /*  985948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  985950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  985952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  985954 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  985957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  985959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  985964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  985967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  985970 */     GIR_RootConstrainSelectedInstOperands,
     /*  985971 */     // GIR_Coverage, 9393,
     /*  985971 */     GIR_EraseRootFromParent_Done,
     /*  985972 */   // Label 14698: @985972
     /*  985972 */   GIM_Try, /*On fail goto*//*Label 14699*/ GIMT_Encode4(986067), // Rule ID 9396 //
     /*  985977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  985980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  985985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  985988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  985991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  985994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  985997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986027 */     // MIs[1] Operand 1
     /*  986027 */     // No operand predicates
     /*  986027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986065 */     GIR_RootConstrainSelectedInstOperands,
     /*  986066 */     // GIR_Coverage, 9396,
     /*  986066 */     GIR_EraseRootFromParent_Done,
     /*  986067 */   // Label 14699: @986067
     /*  986067 */   GIM_Try, /*On fail goto*//*Label 14700*/ GIMT_Encode4(986162), // Rule ID 9397 //
     /*  986072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  986089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986122 */     // MIs[1] Operand 1
     /*  986122 */     // No operand predicates
     /*  986122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986135 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986160 */     GIR_RootConstrainSelectedInstOperands,
     /*  986161 */     // GIR_Coverage, 9397,
     /*  986161 */     GIR_EraseRootFromParent_Done,
     /*  986162 */   // Label 14700: @986162
     /*  986162 */   GIM_Try, /*On fail goto*//*Label 14701*/ GIMT_Encode4(986257), // Rule ID 9400 //
     /*  986167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986217 */     // MIs[1] Operand 1
     /*  986217 */     // No operand predicates
     /*  986217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986230 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986255 */     GIR_RootConstrainSelectedInstOperands,
     /*  986256 */     // GIR_Coverage, 9400,
     /*  986256 */     GIR_EraseRootFromParent_Done,
     /*  986257 */   // Label 14701: @986257
     /*  986257 */   GIM_Try, /*On fail goto*//*Label 14702*/ GIMT_Encode4(986352), // Rule ID 9401 //
     /*  986262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  986279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986308 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986312 */     // MIs[1] Operand 1
     /*  986312 */     // No operand predicates
     /*  986312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986325 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986350 */     GIR_RootConstrainSelectedInstOperands,
     /*  986351 */     // GIR_Coverage, 9401,
     /*  986351 */     GIR_EraseRootFromParent_Done,
     /*  986352 */   // Label 14702: @986352
     /*  986352 */   GIM_Try, /*On fail goto*//*Label 14703*/ GIMT_Encode4(986447), // Rule ID 9404 //
     /*  986357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986403 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986407 */     // MIs[1] Operand 1
     /*  986407 */     // No operand predicates
     /*  986407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986420 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /*  986420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  986423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986445 */     GIR_RootConstrainSelectedInstOperands,
     /*  986446 */     // GIR_Coverage, 9404,
     /*  986446 */     GIR_EraseRootFromParent_Done,
     /*  986447 */   // Label 14703: @986447
     /*  986447 */   GIM_Try, /*On fail goto*//*Label 14704*/ GIMT_Encode4(986542), // Rule ID 9405 //
     /*  986452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /*  986463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /*  986466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  986469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  986475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986502 */     // MIs[1] Operand 1
     /*  986502 */     // No operand predicates
     /*  986502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986515 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /*  986515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  986518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986524 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  986537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986540 */     GIR_RootConstrainSelectedInstOperands,
     /*  986541 */     // GIR_Coverage, 9405,
     /*  986541 */     GIR_EraseRootFromParent_Done,
     /*  986542 */   // Label 14704: @986542
     /*  986542 */   GIM_Try, /*On fail goto*//*Label 14705*/ GIMT_Encode4(986637), // Rule ID 9408 //
     /*  986547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986597 */     // MIs[1] Operand 1
     /*  986597 */     // No operand predicates
     /*  986597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986610 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986635 */     GIR_RootConstrainSelectedInstOperands,
     /*  986636 */     // GIR_Coverage, 9408,
     /*  986636 */     GIR_EraseRootFromParent_Done,
     /*  986637 */   // Label 14705: @986637
     /*  986637 */   GIM_Try, /*On fail goto*//*Label 14706*/ GIMT_Encode4(986732), // Rule ID 9409 //
     /*  986642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  986653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  986656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  986659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  986665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  986680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986692 */     // MIs[1] Operand 1
     /*  986692 */     // No operand predicates
     /*  986692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986705 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  986708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986730 */     GIR_RootConstrainSelectedInstOperands,
     /*  986731 */     // GIR_Coverage, 9409,
     /*  986731 */     GIR_EraseRootFromParent_Done,
     /*  986732 */   // Label 14706: @986732
     /*  986732 */   GIM_Try, /*On fail goto*//*Label 14707*/ GIMT_Encode4(986827), // Rule ID 9412 //
     /*  986737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986787 */     // MIs[1] Operand 1
     /*  986787 */     // No operand predicates
     /*  986787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986825 */     GIR_RootConstrainSelectedInstOperands,
     /*  986826 */     // GIR_Coverage, 9412,
     /*  986826 */     GIR_EraseRootFromParent_Done,
     /*  986827 */   // Label 14707: @986827
     /*  986827 */   GIM_Try, /*On fail goto*//*Label 14708*/ GIMT_Encode4(986922), // Rule ID 9413 //
     /*  986832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  986835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  986843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  986846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  986849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  986852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  986855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  986858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  986870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986882 */     // MIs[1] Operand 1
     /*  986882 */     // No operand predicates
     /*  986882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  986895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  986898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  986907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  986909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  986914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  986917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  986920 */     GIR_RootConstrainSelectedInstOperands,
     /*  986921 */     // GIR_Coverage, 9413,
     /*  986921 */     GIR_EraseRootFromParent_Done,
     /*  986922 */   // Label 14708: @986922
     /*  986922 */   GIM_Try, /*On fail goto*//*Label 14709*/ GIMT_Encode4(987017), // Rule ID 9416 //
     /*  986927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  986930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  986935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  986938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  986941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  986944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  986947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  986950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  986953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  986961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  986965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  986969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  986973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  986977 */     // MIs[1] Operand 1
     /*  986977 */     // No operand predicates
     /*  986977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  986981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  986983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  986990 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /*  986990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  986993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  986995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  986997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  986999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987015 */     GIR_RootConstrainSelectedInstOperands,
     /*  987016 */     // GIR_Coverage, 9416,
     /*  987016 */     GIR_EraseRootFromParent_Done,
     /*  987017 */   // Label 14709: @987017
     /*  987017 */   GIM_Try, /*On fail goto*//*Label 14710*/ GIMT_Encode4(987112), // Rule ID 9417 //
     /*  987022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /*  987033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /*  987036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  987039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  987045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987072 */     // MIs[1] Operand 1
     /*  987072 */     // No operand predicates
     /*  987072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987085 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /*  987085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  987107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987110 */     GIR_RootConstrainSelectedInstOperands,
     /*  987111 */     // GIR_Coverage, 9417,
     /*  987111 */     GIR_EraseRootFromParent_Done,
     /*  987112 */   // Label 14710: @987112
     /*  987112 */   GIM_Try, /*On fail goto*//*Label 14711*/ GIMT_Encode4(987207), // Rule ID 9420 //
     /*  987117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987167 */     // MIs[1] Operand 1
     /*  987167 */     // No operand predicates
     /*  987167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987205 */     GIR_RootConstrainSelectedInstOperands,
     /*  987206 */     // GIR_Coverage, 9420,
     /*  987206 */     GIR_EraseRootFromParent_Done,
     /*  987207 */   // Label 14711: @987207
     /*  987207 */   GIM_Try, /*On fail goto*//*Label 14712*/ GIMT_Encode4(987302), // Rule ID 9421 //
     /*  987212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  987229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987258 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987262 */     // MIs[1] Operand 1
     /*  987262 */     // No operand predicates
     /*  987262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987275 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987300 */     GIR_RootConstrainSelectedInstOperands,
     /*  987301 */     // GIR_Coverage, 9421,
     /*  987301 */     GIR_EraseRootFromParent_Done,
     /*  987302 */   // Label 14712: @987302
     /*  987302 */   GIM_Try, /*On fail goto*//*Label 14713*/ GIMT_Encode4(987397), // Rule ID 9424 //
     /*  987307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987357 */     // MIs[1] Operand 1
     /*  987357 */     // No operand predicates
     /*  987357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987370 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987395 */     GIR_RootConstrainSelectedInstOperands,
     /*  987396 */     // GIR_Coverage, 9424,
     /*  987396 */     GIR_EraseRootFromParent_Done,
     /*  987397 */   // Label 14713: @987397
     /*  987397 */   GIM_Try, /*On fail goto*//*Label 14714*/ GIMT_Encode4(987492), // Rule ID 9425 //
     /*  987402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  987413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  987416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  987419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  987425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987452 */     // MIs[1] Operand 1
     /*  987452 */     // No operand predicates
     /*  987452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987465 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987474 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987490 */     GIR_RootConstrainSelectedInstOperands,
     /*  987491 */     // GIR_Coverage, 9425,
     /*  987491 */     GIR_EraseRootFromParent_Done,
     /*  987492 */   // Label 14714: @987492
     /*  987492 */   GIM_Try, /*On fail goto*//*Label 14715*/ GIMT_Encode4(987587), // Rule ID 9428 //
     /*  987497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  987500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987547 */     // MIs[1] Operand 1
     /*  987547 */     // No operand predicates
     /*  987547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /*  987560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987585 */     GIR_RootConstrainSelectedInstOperands,
     /*  987586 */     // GIR_Coverage, 9428,
     /*  987586 */     GIR_EraseRootFromParent_Done,
     /*  987587 */   // Label 14715: @987587
     /*  987587 */   GIM_Try, /*On fail goto*//*Label 14716*/ GIMT_Encode4(987682), // Rule ID 9429 //
     /*  987592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  987595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /*  987603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  987606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  987609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  987615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  987630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987642 */     // MIs[1] Operand 1
     /*  987642 */     // No operand predicates
     /*  987642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987655 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /*  987655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  987658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  987677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987680 */     GIR_RootConstrainSelectedInstOperands,
     /*  987681 */     // GIR_Coverage, 9429,
     /*  987681 */     GIR_EraseRootFromParent_Done,
     /*  987682 */   // Label 14716: @987682
     /*  987682 */   GIM_Try, /*On fail goto*//*Label 14717*/ GIMT_Encode4(987777), // Rule ID 9432 //
     /*  987687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  987690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987737 */     // MIs[1] Operand 1
     /*  987737 */     // No operand predicates
     /*  987737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987750 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  987750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987775 */     GIR_RootConstrainSelectedInstOperands,
     /*  987776 */     // GIR_Coverage, 9432,
     /*  987776 */     GIR_EraseRootFromParent_Done,
     /*  987777 */   // Label 14717: @987777
     /*  987777 */   GIM_Try, /*On fail goto*//*Label 14718*/ GIMT_Encode4(987872), // Rule ID 9433 //
     /*  987782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /*  987793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  987796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  987799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  987805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  987820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987832 */     // MIs[1] Operand 1
     /*  987832 */     // No operand predicates
     /*  987832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987845 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  987845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M2_MASK),
     /*  987848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987870 */     GIR_RootConstrainSelectedInstOperands,
     /*  987871 */     // GIR_Coverage, 9433,
     /*  987871 */     GIR_EraseRootFromParent_Done,
     /*  987872 */   // Label 14718: @987872
     /*  987872 */   GIM_Try, /*On fail goto*//*Label 14719*/ GIMT_Encode4(987967), // Rule ID 9436 //
     /*  987877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  987880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  987894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  987897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  987903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  987911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  987915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  987919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  987923 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  987927 */     // MIs[1] Operand 1
     /*  987927 */     // No operand predicates
     /*  987927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  987931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  987933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  987940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  987940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  987943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  987945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  987947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  987949 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  987952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  987954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  987959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  987962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  987965 */     GIR_RootConstrainSelectedInstOperands,
     /*  987966 */     // GIR_Coverage, 9436,
     /*  987966 */     GIR_EraseRootFromParent_Done,
     /*  987967 */   // Label 14719: @987967
     /*  987967 */   GIM_Try, /*On fail goto*//*Label 14720*/ GIMT_Encode4(988062), // Rule ID 9437 //
     /*  987972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  987975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  987980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /*  987983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  987986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  987989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  987992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  987995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  987998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  988010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988022 */     // MIs[1] Operand 1
     /*  988022 */     // No operand predicates
     /*  988022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M4_MASK),
     /*  988038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988060 */     GIR_RootConstrainSelectedInstOperands,
     /*  988061 */     // GIR_Coverage, 9437,
     /*  988061 */     GIR_EraseRootFromParent_Done,
     /*  988062 */   // Label 14720: @988062
     /*  988062 */   GIM_Try, /*On fail goto*//*Label 14721*/ GIMT_Encode4(988157), // Rule ID 9440 //
     /*  988067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  988070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988117 */     // MIs[1] Operand 1
     /*  988117 */     // No operand predicates
     /*  988117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988130 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /*  988130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988155 */     GIR_RootConstrainSelectedInstOperands,
     /*  988156 */     // GIR_Coverage, 9440,
     /*  988156 */     GIR_EraseRootFromParent_Done,
     /*  988157 */   // Label 14721: @988157
     /*  988157 */   GIM_Try, /*On fail goto*//*Label 14722*/ GIMT_Encode4(988252), // Rule ID 9441 //
     /*  988162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  988165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /*  988170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /*  988173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  988176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  988179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  988185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  988200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988212 */     // MIs[1] Operand 1
     /*  988212 */     // No operand predicates
     /*  988212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988225 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VI_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /*  988225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VI_M8_MASK),
     /*  988228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  988247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  988250 */     GIR_RootConstrainSelectedInstOperands,
     /*  988251 */     // GIR_Coverage, 9441,
     /*  988251 */     GIR_EraseRootFromParent_Done,
     /*  988252 */   // Label 14722: @988252
     /*  988252 */   GIM_Try, /*On fail goto*//*Label 14723*/ GIMT_Encode4(988344), // Rule ID 13818 //
     /*  988257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988307 */     // MIs[1] Operand 1
     /*  988307 */     // No operand predicates
     /*  988307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988320 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  988320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988342 */     GIR_RootConstrainSelectedInstOperands,
     /*  988343 */     // GIR_Coverage, 13818,
     /*  988343 */     GIR_EraseRootFromParent_Done,
     /*  988344 */   // Label 14723: @988344
     /*  988344 */   GIM_Try, /*On fail goto*//*Label 14724*/ GIMT_Encode4(988436), // Rule ID 13819 //
     /*  988349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  988360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  988363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  988366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988399 */     // MIs[1] Operand 1
     /*  988399 */     // No operand predicates
     /*  988399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988412 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  988412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF8),
     /*  988415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988434 */     GIR_RootConstrainSelectedInstOperands,
     /*  988435 */     // GIR_Coverage, 13819,
     /*  988435 */     GIR_EraseRootFromParent_Done,
     /*  988436 */   // Label 14724: @988436
     /*  988436 */   GIM_Try, /*On fail goto*//*Label 14725*/ GIMT_Encode4(988528), // Rule ID 13820 //
     /*  988441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  988452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  988455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988491 */     // MIs[1] Operand 1
     /*  988491 */     // No operand predicates
     /*  988491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988504 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  988504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  988507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988526 */     GIR_RootConstrainSelectedInstOperands,
     /*  988527 */     // GIR_Coverage, 13820,
     /*  988527 */     GIR_EraseRootFromParent_Done,
     /*  988528 */   // Label 14725: @988528
     /*  988528 */   GIM_Try, /*On fail goto*//*Label 14726*/ GIMT_Encode4(988620), // Rule ID 13821 //
     /*  988533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /*  988544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /*  988547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  988550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  988556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988583 */     // MIs[1] Operand 1
     /*  988583 */     // No operand predicates
     /*  988583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988596 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  988596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  988599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988605 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988618 */     GIR_RootConstrainSelectedInstOperands,
     /*  988619 */     // GIR_Coverage, 13821,
     /*  988619 */     GIR_EraseRootFromParent_Done,
     /*  988620 */   // Label 14726: @988620
     /*  988620 */   GIM_Try, /*On fail goto*//*Label 14727*/ GIMT_Encode4(988712), // Rule ID 13822 //
     /*  988625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  988636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  988639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988675 */     // MIs[1] Operand 1
     /*  988675 */     // No operand predicates
     /*  988675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988688 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  988688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  988691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988710 */     GIR_RootConstrainSelectedInstOperands,
     /*  988711 */     // GIR_Coverage, 13822,
     /*  988711 */     GIR_EraseRootFromParent_Done,
     /*  988712 */   // Label 14727: @988712
     /*  988712 */   GIM_Try, /*On fail goto*//*Label 14728*/ GIMT_Encode4(988804), // Rule ID 13823 //
     /*  988717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /*  988728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /*  988731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  988734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  988740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988767 */     // MIs[1] Operand 1
     /*  988767 */     // No operand predicates
     /*  988767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988780 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  988780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  988783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  988802 */     GIR_RootConstrainSelectedInstOperands,
     /*  988803 */     // GIR_Coverage, 13823,
     /*  988803 */     GIR_EraseRootFromParent_Done,
     /*  988804 */   // Label 14728: @988804
     /*  988804 */   GIM_Try, /*On fail goto*//*Label 14729*/ GIMT_Encode4(988896), // Rule ID 13824 //
     /*  988809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  988820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  988823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  988826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  988829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  988835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988859 */     // MIs[1] Operand 1
     /*  988859 */     // No operand predicates
     /*  988859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  988872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  988875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988894 */     GIR_RootConstrainSelectedInstOperands,
     /*  988895 */     // GIR_Coverage, 13824,
     /*  988895 */     GIR_EraseRootFromParent_Done,
     /*  988896 */   // Label 14729: @988896
     /*  988896 */   GIM_Try, /*On fail goto*//*Label 14730*/ GIMT_Encode4(988988), // Rule ID 13825 //
     /*  988901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  988904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  988909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  988912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  988915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  988918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  988921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  988924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  988927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  988931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  988939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  988943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  988947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  988951 */     // MIs[1] Operand 1
     /*  988951 */     // No operand predicates
     /*  988951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  988955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  988957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  988964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  988964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF4),
     /*  988967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  988969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  988971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  988973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  988976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  988978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  988983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  988986 */     GIR_RootConstrainSelectedInstOperands,
     /*  988987 */     // GIR_Coverage, 13825,
     /*  988987 */     GIR_EraseRootFromParent_Done,
     /*  988988 */   // Label 14730: @988988
     /*  988988 */   GIM_Try, /*On fail goto*//*Label 14731*/ GIMT_Encode4(989080), // Rule ID 13826 //
     /*  988993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  988996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989043 */     // MIs[1] Operand 1
     /*  989043 */     // No operand predicates
     /*  989043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989056 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989078 */     GIR_RootConstrainSelectedInstOperands,
     /*  989079 */     // GIR_Coverage, 13826,
     /*  989079 */     GIR_EraseRootFromParent_Done,
     /*  989080 */   // Label 14731: @989080
     /*  989080 */   GIM_Try, /*On fail goto*//*Label 14732*/ GIMT_Encode4(989172), // Rule ID 13827 //
     /*  989085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  989096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  989099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  989102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989135 */     // MIs[1] Operand 1
     /*  989135 */     // No operand predicates
     /*  989135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989170 */     GIR_RootConstrainSelectedInstOperands,
     /*  989171 */     // GIR_Coverage, 13827,
     /*  989171 */     GIR_EraseRootFromParent_Done,
     /*  989172 */   // Label 14732: @989172
     /*  989172 */   GIM_Try, /*On fail goto*//*Label 14733*/ GIMT_Encode4(989264), // Rule ID 13828 //
     /*  989177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989223 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989227 */     // MIs[1] Operand 1
     /*  989227 */     // No operand predicates
     /*  989227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  989240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989262 */     GIR_RootConstrainSelectedInstOperands,
     /*  989263 */     // GIR_Coverage, 13828,
     /*  989263 */     GIR_EraseRootFromParent_Done,
     /*  989264 */   // Label 14733: @989264
     /*  989264 */   GIM_Try, /*On fail goto*//*Label 14734*/ GIMT_Encode4(989356), // Rule ID 13829 //
     /*  989269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  989280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  989283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  989286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989315 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989319 */     // MIs[1] Operand 1
     /*  989319 */     // No operand predicates
     /*  989319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  989332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_MF2),
     /*  989335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989354 */     GIR_RootConstrainSelectedInstOperands,
     /*  989355 */     // GIR_Coverage, 13829,
     /*  989355 */     GIR_EraseRootFromParent_Done,
     /*  989356 */   // Label 14734: @989356
     /*  989356 */   GIM_Try, /*On fail goto*//*Label 14735*/ GIMT_Encode4(989448), // Rule ID 13830 //
     /*  989361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989411 */     // MIs[1] Operand 1
     /*  989411 */     // No operand predicates
     /*  989411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  989424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989446 */     GIR_RootConstrainSelectedInstOperands,
     /*  989447 */     // GIR_Coverage, 13830,
     /*  989447 */     GIR_EraseRootFromParent_Done,
     /*  989448 */   // Label 14735: @989448
     /*  989448 */   GIM_Try, /*On fail goto*//*Label 14736*/ GIMT_Encode4(989540), // Rule ID 13831 //
     /*  989453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /*  989464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /*  989467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  989470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  989476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989503 */     // MIs[1] Operand 1
     /*  989503 */     // No operand predicates
     /*  989503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  989516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  989538 */     GIR_RootConstrainSelectedInstOperands,
     /*  989539 */     // GIR_Coverage, 13831,
     /*  989539 */     GIR_EraseRootFromParent_Done,
     /*  989540 */   // Label 14736: @989540
     /*  989540 */   GIM_Try, /*On fail goto*//*Label 14737*/ GIMT_Encode4(989632), // Rule ID 13832 //
     /*  989545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  989556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  989559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989595 */     // MIs[1] Operand 1
     /*  989595 */     // No operand predicates
     /*  989595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  989608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989630 */     GIR_RootConstrainSelectedInstOperands,
     /*  989631 */     // GIR_Coverage, 13832,
     /*  989631 */     GIR_EraseRootFromParent_Done,
     /*  989632 */   // Label 14737: @989632
     /*  989632 */   GIM_Try, /*On fail goto*//*Label 14738*/ GIMT_Encode4(989724), // Rule ID 13833 //
     /*  989637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  989648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  989651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  989654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  989660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989687 */     // MIs[1] Operand 1
     /*  989687 */     // No operand predicates
     /*  989687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  989700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  989722 */     GIR_RootConstrainSelectedInstOperands,
     /*  989723 */     // GIR_Coverage, 13833,
     /*  989723 */     GIR_EraseRootFromParent_Done,
     /*  989724 */   // Label 14738: @989724
     /*  989724 */   GIM_Try, /*On fail goto*//*Label 14739*/ GIMT_Encode4(989816), // Rule ID 13834 //
     /*  989729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  989732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  989740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  989743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  989746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989775 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989779 */     // MIs[1] Operand 1
     /*  989779 */     // No operand predicates
     /*  989779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989792 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  989792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989814 */     GIR_RootConstrainSelectedInstOperands,
     /*  989815 */     // GIR_Coverage, 13834,
     /*  989815 */     GIR_EraseRootFromParent_Done,
     /*  989816 */   // Label 14739: @989816
     /*  989816 */   GIM_Try, /*On fail goto*//*Label 14740*/ GIMT_Encode4(989908), // Rule ID 13835 //
     /*  989821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  989824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  989832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  989835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  989838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  989841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  989844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  989847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989867 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989871 */     // MIs[1] Operand 1
     /*  989871 */     // No operand predicates
     /*  989871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  989884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  989906 */     GIR_RootConstrainSelectedInstOperands,
     /*  989907 */     // GIR_Coverage, 13835,
     /*  989907 */     GIR_EraseRootFromParent_Done,
     /*  989908 */   // Label 14740: @989908
     /*  989908 */   GIM_Try, /*On fail goto*//*Label 14741*/ GIMT_Encode4(990000), // Rule ID 13836 //
     /*  989913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  989916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  989921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  989924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  989927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  989930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  989933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  989936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  989939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  989943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  989951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  989955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  989959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  989963 */     // MIs[1] Operand 1
     /*  989963 */     // No operand predicates
     /*  989963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  989967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  989969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  989976 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  989976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  989979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  989981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  989983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  989985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  989988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  989990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  989995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  989998 */     GIR_RootConstrainSelectedInstOperands,
     /*  989999 */     // GIR_Coverage, 13836,
     /*  989999 */     GIR_EraseRootFromParent_Done,
     /*  990000 */   // Label 14741: @990000
     /*  990000 */   GIM_Try, /*On fail goto*//*Label 14742*/ GIMT_Encode4(990092), // Rule ID 13837 //
     /*  990005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  990008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  990016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  990019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /*  990022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /*  990028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  990035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  990043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990055 */     // MIs[1] Operand 1
     /*  990055 */     // No operand predicates
     /*  990055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  990068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M1),
     /*  990071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  990090 */     GIR_RootConstrainSelectedInstOperands,
     /*  990091 */     // GIR_Coverage, 13837,
     /*  990091 */     GIR_EraseRootFromParent_Done,
     /*  990092 */   // Label 14742: @990092
     /*  990092 */   GIM_Try, /*On fail goto*//*Label 14743*/ GIMT_Encode4(990184), // Rule ID 13838 //
     /*  990097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990147 */     // MIs[1] Operand 1
     /*  990147 */     // No operand predicates
     /*  990147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990182 */     GIR_RootConstrainSelectedInstOperands,
     /*  990183 */     // GIR_Coverage, 13838,
     /*  990183 */     GIR_EraseRootFromParent_Done,
     /*  990184 */   // Label 14743: @990184
     /*  990184 */   GIM_Try, /*On fail goto*//*Label 14744*/ GIMT_Encode4(990276), // Rule ID 13839 //
     /*  990189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /*  990200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  990203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  990206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990239 */     // MIs[1] Operand 1
     /*  990239 */     // No operand predicates
     /*  990239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990243 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990274 */     GIR_RootConstrainSelectedInstOperands,
     /*  990275 */     // GIR_Coverage, 13839,
     /*  990275 */     GIR_EraseRootFromParent_Done,
     /*  990276 */   // Label 14744: @990276
     /*  990276 */   GIM_Try, /*On fail goto*//*Label 14745*/ GIMT_Encode4(990368), // Rule ID 13840 //
     /*  990281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990331 */     // MIs[1] Operand 1
     /*  990331 */     // No operand predicates
     /*  990331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990366 */     GIR_RootConstrainSelectedInstOperands,
     /*  990367 */     // GIR_Coverage, 13840,
     /*  990367 */     GIR_EraseRootFromParent_Done,
     /*  990368 */   // Label 14745: @990368
     /*  990368 */   GIM_Try, /*On fail goto*//*Label 14746*/ GIMT_Encode4(990460), // Rule ID 13841 //
     /*  990373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /*  990384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /*  990387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  990390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  990396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990423 */     // MIs[1] Operand 1
     /*  990423 */     // No operand predicates
     /*  990423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990436 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990458 */     GIR_RootConstrainSelectedInstOperands,
     /*  990459 */     // GIR_Coverage, 13841,
     /*  990459 */     GIR_EraseRootFromParent_Done,
     /*  990460 */   // Label 14746: @990460
     /*  990460 */   GIM_Try, /*On fail goto*//*Label 14747*/ GIMT_Encode4(990552), // Rule ID 13842 //
     /*  990465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  990476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  990479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  990495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990515 */     // MIs[1] Operand 1
     /*  990515 */     // No operand predicates
     /*  990515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990528 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /*  990528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  990531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990550 */     GIR_RootConstrainSelectedInstOperands,
     /*  990551 */     // GIR_Coverage, 13842,
     /*  990551 */     GIR_EraseRootFromParent_Done,
     /*  990552 */   // Label 14747: @990552
     /*  990552 */   GIM_Try, /*On fail goto*//*Label 14748*/ GIMT_Encode4(990644), // Rule ID 13843 //
     /*  990557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /*  990568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /*  990571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /*  990574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /*  990580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  990587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  990595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990607 */     // MIs[1] Operand 1
     /*  990607 */     // No operand predicates
     /*  990607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990620 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /*  990620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  990623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  990642 */     GIR_RootConstrainSelectedInstOperands,
     /*  990643 */     // GIR_Coverage, 13843,
     /*  990643 */     GIR_EraseRootFromParent_Done,
     /*  990644 */   // Label 14748: @990644
     /*  990644 */   GIM_Try, /*On fail goto*//*Label 14749*/ GIMT_Encode4(990736), // Rule ID 13844 //
     /*  990649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  990660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  990663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990699 */     // MIs[1] Operand 1
     /*  990699 */     // No operand predicates
     /*  990699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990734 */     GIR_RootConstrainSelectedInstOperands,
     /*  990735 */     // GIR_Coverage, 13844,
     /*  990735 */     GIR_EraseRootFromParent_Done,
     /*  990736 */   // Label 14749: @990736
     /*  990736 */   GIM_Try, /*On fail goto*//*Label 14750*/ GIMT_Encode4(990828), // Rule ID 13845 //
     /*  990741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  990752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  990755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  990758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  990764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  990771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  990779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990791 */     // MIs[1] Operand 1
     /*  990791 */     // No operand predicates
     /*  990791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990804 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  990807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990826 */     GIR_RootConstrainSelectedInstOperands,
     /*  990827 */     // GIR_Coverage, 13845,
     /*  990827 */     GIR_EraseRootFromParent_Done,
     /*  990828 */   // Label 14750: @990828
     /*  990828 */   GIM_Try, /*On fail goto*//*Label 14751*/ GIMT_Encode4(990920), // Rule ID 13846 //
     /*  990833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  990836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  990844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  990847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  990850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  990853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  990859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990883 */     // MIs[1] Operand 1
     /*  990883 */     // No operand predicates
     /*  990883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  990896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  990908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  990910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  990915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  990918 */     GIR_RootConstrainSelectedInstOperands,
     /*  990919 */     // GIR_Coverage, 13846,
     /*  990919 */     GIR_EraseRootFromParent_Done,
     /*  990920 */   // Label 14751: @990920
     /*  990920 */   GIM_Try, /*On fail goto*//*Label 14752*/ GIMT_Encode4(991012), // Rule ID 13847 //
     /*  990925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  990928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  990933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  990936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  990939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  990942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  990945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  990948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  990951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  990955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  990963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  990967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  990971 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  990975 */     // MIs[1] Operand 1
     /*  990975 */     // No operand predicates
     /*  990975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  990979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  990981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  990988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  990988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  990991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  990993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  990995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  990997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991010 */     GIR_RootConstrainSelectedInstOperands,
     /*  991011 */     // GIR_Coverage, 13847,
     /*  991011 */     GIR_EraseRootFromParent_Done,
     /*  991012 */   // Label 14752: @991012
     /*  991012 */   GIM_Try, /*On fail goto*//*Label 14753*/ GIMT_Encode4(991104), // Rule ID 13848 //
     /*  991017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991067 */     // MIs[1] Operand 1
     /*  991067 */     // No operand predicates
     /*  991067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /*  991080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991102 */     GIR_RootConstrainSelectedInstOperands,
     /*  991103 */     // GIR_Coverage, 13848,
     /*  991103 */     GIR_EraseRootFromParent_Done,
     /*  991104 */   // Label 14753: @991104
     /*  991104 */   GIM_Try, /*On fail goto*//*Label 14754*/ GIMT_Encode4(991196), // Rule ID 13849 //
     /*  991109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  991120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  991123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /*  991126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /*  991132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991159 */     // MIs[1] Operand 1
     /*  991159 */     // No operand predicates
     /*  991159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991172 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /*  991172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  991194 */     GIR_RootConstrainSelectedInstOperands,
     /*  991195 */     // GIR_Coverage, 13849,
     /*  991195 */     GIR_EraseRootFromParent_Done,
     /*  991196 */   // Label 14754: @991196
     /*  991196 */   GIM_Try, /*On fail goto*//*Label 14755*/ GIMT_Encode4(991288), // Rule ID 13850 //
     /*  991201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991251 */     // MIs[1] Operand 1
     /*  991251 */     // No operand predicates
     /*  991251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991273 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991286 */     GIR_RootConstrainSelectedInstOperands,
     /*  991287 */     // GIR_Coverage, 13850,
     /*  991287 */     GIR_EraseRootFromParent_Done,
     /*  991288 */   // Label 14755: @991288
     /*  991288 */   GIM_Try, /*On fail goto*//*Label 14756*/ GIMT_Encode4(991380), // Rule ID 13851 //
     /*  991293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  991304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  991307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  991310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991343 */     // MIs[1] Operand 1
     /*  991343 */     // No operand predicates
     /*  991343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  991356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991378 */     GIR_RootConstrainSelectedInstOperands,
     /*  991379 */     // GIR_Coverage, 13851,
     /*  991379 */     GIR_EraseRootFromParent_Done,
     /*  991380 */   // Label 14756: @991380
     /*  991380 */   GIM_Try, /*On fail goto*//*Label 14757*/ GIMT_Encode4(991472), // Rule ID 13852 //
     /*  991385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991431 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991435 */     // MIs[1] Operand 1
     /*  991435 */     // No operand predicates
     /*  991435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991470 */     GIR_RootConstrainSelectedInstOperands,
     /*  991471 */     // GIR_Coverage, 13852,
     /*  991471 */     GIR_EraseRootFromParent_Done,
     /*  991472 */   // Label 14757: @991472
     /*  991472 */   GIM_Try, /*On fail goto*//*Label 14758*/ GIMT_Encode4(991564), // Rule ID 13853 //
     /*  991477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  991488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  991491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  991494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  991500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991523 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991527 */     // MIs[1] Operand 1
     /*  991527 */     // No operand predicates
     /*  991527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991540 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  991540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  991543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991562 */     GIR_RootConstrainSelectedInstOperands,
     /*  991563 */     // GIR_Coverage, 13853,
     /*  991563 */     GIR_EraseRootFromParent_Done,
     /*  991564 */   // Label 14758: @991564
     /*  991564 */   GIM_Try, /*On fail goto*//*Label 14759*/ GIMT_Encode4(991656), // Rule ID 13854 //
     /*  991569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  991572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  991580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  991583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991619 */     // MIs[1] Operand 1
     /*  991619 */     // No operand predicates
     /*  991619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /*  991632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991654 */     GIR_RootConstrainSelectedInstOperands,
     /*  991655 */     // GIR_Coverage, 13854,
     /*  991655 */     GIR_EraseRootFromParent_Done,
     /*  991656 */   // Label 14759: @991656
     /*  991656 */   GIM_Try, /*On fail goto*//*Label 14760*/ GIMT_Encode4(991748), // Rule ID 13855 //
     /*  991661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  991664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  991672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  991675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /*  991678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /*  991684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  991691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  991699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991711 */     // MIs[1] Operand 1
     /*  991711 */     // No operand predicates
     /*  991711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /*  991724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  991727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  991746 */     GIR_RootConstrainSelectedInstOperands,
     /*  991747 */     // GIR_Coverage, 13855,
     /*  991747 */     GIR_EraseRootFromParent_Done,
     /*  991748 */   // Label 14760: @991748
     /*  991748 */   GIM_Try, /*On fail goto*//*Label 14761*/ GIMT_Encode4(991840), // Rule ID 13856 //
     /*  991753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  991756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  991764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  991767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  991770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  991776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991803 */     // MIs[1] Operand 1
     /*  991803 */     // No operand predicates
     /*  991803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  991816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991825 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991838 */     GIR_RootConstrainSelectedInstOperands,
     /*  991839 */     // GIR_Coverage, 13856,
     /*  991839 */     GIR_EraseRootFromParent_Done,
     /*  991840 */   // Label 14761: @991840
     /*  991840 */   GIM_Try, /*On fail goto*//*Label 14762*/ GIMT_Encode4(991932), // Rule ID 13857 //
     /*  991845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  991848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  991856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  991859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  991862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  991865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /*  991868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  991871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  991875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  991883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991895 */     // MIs[1] Operand 1
     /*  991895 */     // No operand predicates
     /*  991895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  991908 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  991908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M2),
     /*  991911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  991913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  991915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  991917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  991920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  991922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  991927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  991930 */     GIR_RootConstrainSelectedInstOperands,
     /*  991931 */     // GIR_Coverage, 13857,
     /*  991931 */     GIR_EraseRootFromParent_Done,
     /*  991932 */   // Label 14762: @991932
     /*  991932 */   GIM_Try, /*On fail goto*//*Label 14763*/ GIMT_Encode4(992024), // Rule ID 13858 //
     /*  991937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  991940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  991945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  991948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  991951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  991954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  991957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  991960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  991963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  991967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  991975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  991979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  991983 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  991987 */     // MIs[1] Operand 1
     /*  991987 */     // No operand predicates
     /*  991987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  991991 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  991993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992000 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992009 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992022 */     GIR_RootConstrainSelectedInstOperands,
     /*  992023 */     // GIR_Coverage, 13858,
     /*  992023 */     GIR_EraseRootFromParent_Done,
     /*  992024 */   // Label 14763: @992024
     /*  992024 */   GIM_Try, /*On fail goto*//*Label 14764*/ GIMT_Encode4(992116), // Rule ID 13859 //
     /*  992029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  992040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  992043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /*  992046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /*  992052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  992059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992075 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992079 */     // MIs[1] Operand 1
     /*  992079 */     // No operand predicates
     /*  992079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M4),
     /*  992095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992114 */     GIR_RootConstrainSelectedInstOperands,
     /*  992115 */     // GIR_Coverage, 13859,
     /*  992115 */     GIR_EraseRootFromParent_Done,
     /*  992116 */   // Label 14764: @992116
     /*  992116 */   GIM_Try, /*On fail goto*//*Label 14765*/ GIMT_Encode4(992208), // Rule ID 13860 //
     /*  992121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /*  992124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /*  992141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992171 */     // MIs[1] Operand 1
     /*  992171 */     // No operand predicates
     /*  992171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /*  992184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992206 */     GIR_RootConstrainSelectedInstOperands,
     /*  992207 */     // GIR_Coverage, 13860,
     /*  992207 */     GIR_EraseRootFromParent_Done,
     /*  992208 */   // Label 14765: @992208
     /*  992208 */   GIM_Try, /*On fail goto*//*Label 14766*/ GIMT_Encode4(992300), // Rule ID 13861 //
     /*  992213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /*  992216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /*  992221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  992224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  992227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /*  992230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  992233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /*  992236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  992243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  992255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  992259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /*  992263 */     // MIs[1] Operand 1
     /*  992263 */     // No operand predicates
     /*  992263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  992267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  992269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992276 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VIM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /*  992276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VIM_M8),
     /*  992279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  992285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /*  992288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /*  992290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  992298 */     GIR_RootConstrainSelectedInstOperands,
     /*  992299 */     // GIR_Coverage, 13861,
     /*  992299 */     GIR_EraseRootFromParent_Done,
     /*  992300 */   // Label 14766: @992300
     /*  992300 */   GIM_Try, /*On fail goto*//*Label 14767*/ GIMT_Encode4(992376), // Rule ID 2656 //
     /*  992305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992333 */     // MIs[0] passthru
     /*  992333 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992342 */     // MIs[0] round
     /*  992342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992352 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992374 */     GIR_RootConstrainSelectedInstOperands,
     /*  992375 */     // GIR_Coverage, 2656,
     /*  992375 */     GIR_EraseRootFromParent_Done,
     /*  992376 */   // Label 14767: @992376
     /*  992376 */   GIM_Try, /*On fail goto*//*Label 14768*/ GIMT_Encode4(992452), // Rule ID 2657 //
     /*  992381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  992392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  992395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  992398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992409 */     // MIs[0] passthru
     /*  992409 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992418 */     // MIs[0] round
     /*  992418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992428 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_TIED),
     /*  992431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992450 */     GIR_RootConstrainSelectedInstOperands,
     /*  992451 */     // GIR_Coverage, 2657,
     /*  992451 */     GIR_EraseRootFromParent_Done,
     /*  992452 */   // Label 14768: @992452
     /*  992452 */   GIM_Try, /*On fail goto*//*Label 14769*/ GIMT_Encode4(992528), // Rule ID 17028 //
     /*  992457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  992468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  992471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  992474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992485 */     // MIs[0] passthru
     /*  992485 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992494 */     // MIs[0] round
     /*  992494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992504 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  992507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992526 */     GIR_RootConstrainSelectedInstOperands,
     /*  992527 */     // GIR_Coverage, 17028,
     /*  992527 */     GIR_EraseRootFromParent_Done,
     /*  992528 */   // Label 14769: @992528
     /*  992528 */   GIM_Try, /*On fail goto*//*Label 14770*/ GIMT_Encode4(992604), // Rule ID 17029 //
     /*  992533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  992544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  992547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  992550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992561 */     // MIs[0] passthru
     /*  992561 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992570 */     // MIs[0] round
     /*  992570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992580 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_TIED),
     /*  992583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992602 */     GIR_RootConstrainSelectedInstOperands,
     /*  992603 */     // GIR_Coverage, 17029,
     /*  992603 */     GIR_EraseRootFromParent_Done,
     /*  992604 */   // Label 14770: @992604
     /*  992604 */   GIM_Try, /*On fail goto*//*Label 14771*/ GIMT_Encode4(992680), // Rule ID 17038 //
     /*  992609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  992626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992637 */     // MIs[0] passthru
     /*  992637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992646 */     // MIs[0] round
     /*  992646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992656 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  992659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992678 */     GIR_RootConstrainSelectedInstOperands,
     /*  992679 */     // GIR_Coverage, 17038,
     /*  992679 */     GIR_EraseRootFromParent_Done,
     /*  992680 */   // Label 14771: @992680
     /*  992680 */   GIM_Try, /*On fail goto*//*Label 14772*/ GIMT_Encode4(992756), // Rule ID 17039 //
     /*  992685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  992696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  992699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  992702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992713 */     // MIs[0] passthru
     /*  992713 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  992722 */     // MIs[0] round
     /*  992722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992732 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_TIED),
     /*  992735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992754 */     GIR_RootConstrainSelectedInstOperands,
     /*  992755 */     // GIR_Coverage, 17039,
     /*  992755 */     GIR_EraseRootFromParent_Done,
     /*  992756 */   // Label 14772: @992756
     /*  992756 */   GIM_Try, /*On fail goto*//*Label 14773*/ GIMT_Encode4(992832), // Rule ID 17048 //
     /*  992761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  992778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992789 */     // MIs[0] passthru
     /*  992789 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992798 */     // MIs[0] round
     /*  992798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992808 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  992811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992830 */     GIR_RootConstrainSelectedInstOperands,
     /*  992831 */     // GIR_Coverage, 17048,
     /*  992831 */     GIR_EraseRootFromParent_Done,
     /*  992832 */   // Label 14773: @992832
     /*  992832 */   GIM_Try, /*On fail goto*//*Label 14774*/ GIMT_Encode4(992908), // Rule ID 17049 //
     /*  992837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  992848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  992851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  992854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  992857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992865 */     // MIs[0] passthru
     /*  992865 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  992874 */     // MIs[0] round
     /*  992874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992884 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  992884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_TIED),
     /*  992887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992906 */     GIR_RootConstrainSelectedInstOperands,
     /*  992907 */     // GIR_Coverage, 17049,
     /*  992907 */     GIR_EraseRootFromParent_Done,
     /*  992908 */   // Label 14774: @992908
     /*  992908 */   GIM_Try, /*On fail goto*//*Label 14775*/ GIMT_Encode4(992984), // Rule ID 17058 //
     /*  992913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  992916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  992924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  992927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  992930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  992933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  992941 */     // MIs[0] passthru
     /*  992941 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  992946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  992950 */     // MIs[0] round
     /*  992950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  992953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  992960 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  992960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  992963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  992965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  992967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  992969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  992971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  992976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  992979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  992982 */     GIR_RootConstrainSelectedInstOperands,
     /*  992983 */     // GIR_Coverage, 17058,
     /*  992983 */     GIR_EraseRootFromParent_Done,
     /*  992984 */   // Label 14775: @992984
     /*  992984 */   GIM_Try, /*On fail goto*//*Label 14776*/ GIMT_Encode4(993060), // Rule ID 17059 //
     /*  992989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  992992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  992997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  993000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  993003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  993006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993017 */     // MIs[0] passthru
     /*  993017 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993026 */     // MIs[0] round
     /*  993026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993036 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_TIED),
     /*  993039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993058 */     GIR_RootConstrainSelectedInstOperands,
     /*  993059 */     // GIR_Coverage, 17059,
     /*  993059 */     GIR_EraseRootFromParent_Done,
     /*  993060 */   // Label 14776: @993060
     /*  993060 */   GIM_Try, /*On fail goto*//*Label 14777*/ GIMT_Encode4(993136), // Rule ID 17068 //
     /*  993065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993093 */     // MIs[0] passthru
     /*  993093 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993102 */     // MIs[0] round
     /*  993102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993112 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993134 */     GIR_RootConstrainSelectedInstOperands,
     /*  993135 */     // GIR_Coverage, 17068,
     /*  993135 */     GIR_EraseRootFromParent_Done,
     /*  993136 */   // Label 14777: @993136
     /*  993136 */   GIM_Try, /*On fail goto*//*Label 14778*/ GIMT_Encode4(993212), // Rule ID 17069 //
     /*  993141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  993152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  993155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  993158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993169 */     // MIs[0] passthru
     /*  993169 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993178 */     // MIs[0] round
     /*  993178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_TIED),
     /*  993191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993210 */     GIR_RootConstrainSelectedInstOperands,
     /*  993211 */     // GIR_Coverage, 17069,
     /*  993211 */     GIR_EraseRootFromParent_Done,
     /*  993212 */   // Label 14778: @993212
     /*  993212 */   GIM_Try, /*On fail goto*//*Label 14779*/ GIMT_Encode4(993288), // Rule ID 17078 //
     /*  993217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993245 */     // MIs[0] passthru
     /*  993245 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993254 */     // MIs[0] round
     /*  993254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993286 */     GIR_RootConstrainSelectedInstOperands,
     /*  993287 */     // GIR_Coverage, 17078,
     /*  993287 */     GIR_EraseRootFromParent_Done,
     /*  993288 */   // Label 14779: @993288
     /*  993288 */   GIM_Try, /*On fail goto*//*Label 14780*/ GIMT_Encode4(993364), // Rule ID 17079 //
     /*  993293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  993304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  993307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  993310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993321 */     // MIs[0] passthru
     /*  993321 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993330 */     // MIs[0] round
     /*  993330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993340 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_TIED),
     /*  993343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993362 */     GIR_RootConstrainSelectedInstOperands,
     /*  993363 */     // GIR_Coverage, 17079,
     /*  993363 */     GIR_EraseRootFromParent_Done,
     /*  993364 */   // Label 14780: @993364
     /*  993364 */   GIM_Try, /*On fail goto*//*Label 14781*/ GIMT_Encode4(993440), // Rule ID 17088 //
     /*  993369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993397 */     // MIs[0] passthru
     /*  993397 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993406 */     // MIs[0] round
     /*  993406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993416 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  993419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993438 */     GIR_RootConstrainSelectedInstOperands,
     /*  993439 */     // GIR_Coverage, 17088,
     /*  993439 */     GIR_EraseRootFromParent_Done,
     /*  993440 */   // Label 14781: @993440
     /*  993440 */   GIM_Try, /*On fail goto*//*Label 14782*/ GIMT_Encode4(993516), // Rule ID 17089 //
     /*  993445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  993456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  993459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  993462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993473 */     // MIs[0] passthru
     /*  993473 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  993482 */     // MIs[0] round
     /*  993482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993492 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_TIED),
     /*  993495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993514 */     GIR_RootConstrainSelectedInstOperands,
     /*  993515 */     // GIR_Coverage, 17089,
     /*  993515 */     GIR_EraseRootFromParent_Done,
     /*  993516 */   // Label 14782: @993516
     /*  993516 */   GIM_Try, /*On fail goto*//*Label 14783*/ GIMT_Encode4(993592), // Rule ID 17098 //
     /*  993521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  993524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  993538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993549 */     // MIs[0] passthru
     /*  993549 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993558 */     // MIs[0] round
     /*  993558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993568 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  993568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  993571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993590 */     GIR_RootConstrainSelectedInstOperands,
     /*  993591 */     // GIR_Coverage, 17098,
     /*  993591 */     GIR_EraseRootFromParent_Done,
     /*  993592 */   // Label 14783: @993592
     /*  993592 */   GIM_Try, /*On fail goto*//*Label 14784*/ GIMT_Encode4(993668), // Rule ID 17099 //
     /*  993597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  993600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /*  993605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  993608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  993611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  993614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  993625 */     // MIs[0] passthru
     /*  993625 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  993634 */     // MIs[0] round
     /*  993634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993644 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  993644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_TIED),
     /*  993647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  993663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993666 */     GIR_RootConstrainSelectedInstOperands,
     /*  993667 */     // GIR_Coverage, 17099,
     /*  993667 */     GIR_EraseRootFromParent_Done,
     /*  993668 */   // Label 14784: @993668
     /*  993668 */   GIM_Try, /*On fail goto*//*Label 14785*/ GIMT_Encode4(993744), // Rule ID 17144 //
     /*  993673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  993681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993701 */     // MIs[0] passthru
     /*  993701 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993710 */     // MIs[0] round
     /*  993710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993720 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  993723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993742 */     GIR_RootConstrainSelectedInstOperands,
     /*  993743 */     // GIR_Coverage, 17144,
     /*  993743 */     GIR_EraseRootFromParent_Done,
     /*  993744 */   // Label 14785: @993744
     /*  993744 */   GIM_Try, /*On fail goto*//*Label 14786*/ GIMT_Encode4(993820), // Rule ID 17145 //
     /*  993749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  993757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  993760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  993763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /*  993766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993777 */     // MIs[0] passthru
     /*  993777 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993786 */     // MIs[0] round
     /*  993786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993796 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_TIED),
     /*  993799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993818 */     GIR_RootConstrainSelectedInstOperands,
     /*  993819 */     // GIR_Coverage, 17145,
     /*  993819 */     GIR_EraseRootFromParent_Done,
     /*  993820 */   // Label 14786: @993820
     /*  993820 */   GIM_Try, /*On fail goto*//*Label 14787*/ GIMT_Encode4(993896), // Rule ID 17154 //
     /*  993825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  993833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993853 */     // MIs[0] passthru
     /*  993853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993862 */     // MIs[0] round
     /*  993862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993872 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  993872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  993875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993894 */     GIR_RootConstrainSelectedInstOperands,
     /*  993895 */     // GIR_Coverage, 17154,
     /*  993895 */     GIR_EraseRootFromParent_Done,
     /*  993896 */   // Label 14787: @993896
     /*  993896 */   GIM_Try, /*On fail goto*//*Label 14788*/ GIMT_Encode4(993972), // Rule ID 17155 //
     /*  993901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  993904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  993909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  993912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  993915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /*  993918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  993921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993929 */     // MIs[0] passthru
     /*  993929 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  993934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  993938 */     // MIs[0] round
     /*  993938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  993941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  993948 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  993948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_TIED),
     /*  993951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  993953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  993955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  993957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  993959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  993964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  993967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  993970 */     GIR_RootConstrainSelectedInstOperands,
     /*  993971 */     // GIR_Coverage, 17155,
     /*  993971 */     GIR_EraseRootFromParent_Done,
     /*  993972 */   // Label 14788: @993972
     /*  993972 */   GIM_Try, /*On fail goto*//*Label 14789*/ GIMT_Encode4(994048), // Rule ID 17164 //
     /*  993977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  993980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  993985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  993988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  993991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  993994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  993997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994005 */     // MIs[0] passthru
     /*  994005 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994014 */     // MIs[0] round
     /*  994014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994046 */     GIR_RootConstrainSelectedInstOperands,
     /*  994047 */     // GIR_Coverage, 17164,
     /*  994047 */     GIR_EraseRootFromParent_Done,
     /*  994048 */   // Label 14789: @994048
     /*  994048 */   GIM_Try, /*On fail goto*//*Label 14790*/ GIMT_Encode4(994124), // Rule ID 17165 //
     /*  994053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  994064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  994067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /*  994070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994081 */     // MIs[0] passthru
     /*  994081 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994090 */     // MIs[0] round
     /*  994090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994100 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_TIED),
     /*  994103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994122 */     GIR_RootConstrainSelectedInstOperands,
     /*  994123 */     // GIR_Coverage, 17165,
     /*  994123 */     GIR_EraseRootFromParent_Done,
     /*  994124 */   // Label 14790: @994124
     /*  994124 */   GIM_Try, /*On fail goto*//*Label 14791*/ GIMT_Encode4(994200), // Rule ID 17174 //
     /*  994129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994157 */     // MIs[0] passthru
     /*  994157 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994166 */     // MIs[0] round
     /*  994166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994198 */     GIR_RootConstrainSelectedInstOperands,
     /*  994199 */     // GIR_Coverage, 17174,
     /*  994199 */     GIR_EraseRootFromParent_Done,
     /*  994200 */   // Label 14791: @994200
     /*  994200 */   GIM_Try, /*On fail goto*//*Label 14792*/ GIMT_Encode4(994276), // Rule ID 17175 //
     /*  994205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  994216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  994219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /*  994222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994233 */     // MIs[0] passthru
     /*  994233 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994242 */     // MIs[0] round
     /*  994242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994252 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_TIED),
     /*  994255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994274 */     GIR_RootConstrainSelectedInstOperands,
     /*  994275 */     // GIR_Coverage, 17175,
     /*  994275 */     GIR_EraseRootFromParent_Done,
     /*  994276 */   // Label 14792: @994276
     /*  994276 */   GIM_Try, /*On fail goto*//*Label 14793*/ GIMT_Encode4(994352), // Rule ID 17184 //
     /*  994281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /*  994284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994309 */     // MIs[0] passthru
     /*  994309 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994318 */     // MIs[0] round
     /*  994318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994328 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /*  994328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994350 */     GIR_RootConstrainSelectedInstOperands,
     /*  994351 */     // GIR_Coverage, 17184,
     /*  994351 */     GIR_EraseRootFromParent_Done,
     /*  994352 */   // Label 14793: @994352
     /*  994352 */   GIM_Try, /*On fail goto*//*Label 14794*/ GIMT_Encode4(994428), // Rule ID 17185 //
     /*  994357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /*  994360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  994368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  994371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /*  994374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994385 */     // MIs[0] passthru
     /*  994385 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994394 */     // MIs[0] round
     /*  994394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994404 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /*  994404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_TIED),
     /*  994407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  994423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994426 */     GIR_RootConstrainSelectedInstOperands,
     /*  994427 */     // GIR_Coverage, 17185,
     /*  994427 */     GIR_EraseRootFromParent_Done,
     /*  994428 */   // Label 14794: @994428
     /*  994428 */   GIM_Try, /*On fail goto*//*Label 14795*/ GIMT_Encode4(994504), // Rule ID 17194 //
     /*  994433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994461 */     // MIs[0] passthru
     /*  994461 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994470 */     // MIs[0] round
     /*  994470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994480 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  994483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994502 */     GIR_RootConstrainSelectedInstOperands,
     /*  994503 */     // GIR_Coverage, 17194,
     /*  994503 */     GIR_EraseRootFromParent_Done,
     /*  994504 */   // Label 14795: @994504
     /*  994504 */   GIM_Try, /*On fail goto*//*Label 14796*/ GIMT_Encode4(994580), // Rule ID 17195 //
     /*  994509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  994520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  994523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /*  994526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994537 */     // MIs[0] passthru
     /*  994537 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994546 */     // MIs[0] round
     /*  994546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_TIED),
     /*  994559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994578 */     GIR_RootConstrainSelectedInstOperands,
     /*  994579 */     // GIR_Coverage, 17195,
     /*  994579 */     GIR_EraseRootFromParent_Done,
     /*  994580 */   // Label 14796: @994580
     /*  994580 */   GIM_Try, /*On fail goto*//*Label 14797*/ GIMT_Encode4(994656), // Rule ID 17204 //
     /*  994585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994613 */     // MIs[0] passthru
     /*  994613 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994622 */     // MIs[0] round
     /*  994622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  994635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994654 */     GIR_RootConstrainSelectedInstOperands,
     /*  994655 */     // GIR_Coverage, 17204,
     /*  994655 */     GIR_EraseRootFromParent_Done,
     /*  994656 */   // Label 14797: @994656
     /*  994656 */   GIM_Try, /*On fail goto*//*Label 14798*/ GIMT_Encode4(994732), // Rule ID 17205 //
     /*  994661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  994672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  994675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /*  994678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994689 */     // MIs[0] passthru
     /*  994689 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  994698 */     // MIs[0] round
     /*  994698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994708 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_TIED),
     /*  994711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994730 */     GIR_RootConstrainSelectedInstOperands,
     /*  994731 */     // GIR_Coverage, 17205,
     /*  994731 */     GIR_EraseRootFromParent_Done,
     /*  994732 */   // Label 14798: @994732
     /*  994732 */   GIM_Try, /*On fail goto*//*Label 14799*/ GIMT_Encode4(994808), // Rule ID 17214 //
     /*  994737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994765 */     // MIs[0] passthru
     /*  994765 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994774 */     // MIs[0] round
     /*  994774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  994787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994806 */     GIR_RootConstrainSelectedInstOperands,
     /*  994807 */     // GIR_Coverage, 17214,
     /*  994807 */     GIR_EraseRootFromParent_Done,
     /*  994808 */   // Label 14799: @994808
     /*  994808 */   GIM_Try, /*On fail goto*//*Label 14800*/ GIMT_Encode4(994884), // Rule ID 17215 //
     /*  994813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  994824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  994827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /*  994830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994841 */     // MIs[0] passthru
     /*  994841 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  994850 */     // MIs[0] round
     /*  994850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994860 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  994860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_TIED),
     /*  994863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994882 */     GIR_RootConstrainSelectedInstOperands,
     /*  994883 */     // GIR_Coverage, 17215,
     /*  994883 */     GIR_EraseRootFromParent_Done,
     /*  994884 */   // Label 14800: @994884
     /*  994884 */   GIM_Try, /*On fail goto*//*Label 14801*/ GIMT_Encode4(994960), // Rule ID 17224 //
     /*  994889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /*  994892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /*  994909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994917 */     // MIs[0] passthru
     /*  994917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  994926 */     // MIs[0] round
     /*  994926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  994929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  994936 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /*  994936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  994939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  994941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  994943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  994945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  994947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  994952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  994955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  994958 */     GIR_RootConstrainSelectedInstOperands,
     /*  994959 */     // GIR_Coverage, 17224,
     /*  994959 */     GIR_EraseRootFromParent_Done,
     /*  994960 */   // Label 14801: @994960
     /*  994960 */   GIM_Try, /*On fail goto*//*Label 14802*/ GIMT_Encode4(995036), // Rule ID 17225 //
     /*  994965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /*  994968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /*  994973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  994976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  994979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /*  994982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  994985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  994993 */     // MIs[0] passthru
     /*  994993 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /*  994998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  995002 */     // MIs[0] round
     /*  995002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  995005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995012 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /*  995012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_TIED),
     /*  995015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /*  995023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  995031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  995034 */     GIR_RootConstrainSelectedInstOperands,
     /*  995035 */     // GIR_Coverage, 17225,
     /*  995035 */     GIR_EraseRootFromParent_Done,
     /*  995036 */   // Label 14802: @995036
     /*  995036 */   GIM_Try, /*On fail goto*//*Label 14803*/ GIMT_Encode4(995113), // Rule ID 2586 //
     /*  995041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995080 */     // MIs[0] policy
     /*  995080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995090 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995111 */     GIR_RootConstrainSelectedInstOperands,
     /*  995112 */     // GIR_Coverage, 2586,
     /*  995112 */     GIR_EraseRootFromParent_Done,
     /*  995113 */   // Label 14803: @995113
     /*  995113 */   GIM_Try, /*On fail goto*//*Label 14804*/ GIMT_Encode4(995190), // Rule ID 2587 //
     /*  995118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /*  995126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /*  995135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995157 */     // MIs[0] policy
     /*  995157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995167 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF8_MASK),
     /*  995170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995188 */     GIR_RootConstrainSelectedInstOperands,
     /*  995189 */     // GIR_Coverage, 2587,
     /*  995189 */     GIR_EraseRootFromParent_Done,
     /*  995190 */   // Label 14804: @995190
     /*  995190 */   GIM_Try, /*On fail goto*//*Label 14805*/ GIMT_Encode4(995267), // Rule ID 2590 //
     /*  995195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995234 */     // MIs[0] policy
     /*  995234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995244 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995265 */     GIR_RootConstrainSelectedInstOperands,
     /*  995266 */     // GIR_Coverage, 2590,
     /*  995266 */     GIR_EraseRootFromParent_Done,
     /*  995267 */   // Label 14805: @995267
     /*  995267 */   GIM_Try, /*On fail goto*//*Label 14806*/ GIMT_Encode4(995344), // Rule ID 2591 //
     /*  995272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995311 */     // MIs[0] policy
     /*  995311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995321 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4_MASK),
     /*  995324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995342 */     GIR_RootConstrainSelectedInstOperands,
     /*  995343 */     // GIR_Coverage, 2591,
     /*  995343 */     GIR_EraseRootFromParent_Done,
     /*  995344 */   // Label 14806: @995344
     /*  995344 */   GIM_Try, /*On fail goto*//*Label 14807*/ GIMT_Encode4(995421), // Rule ID 2594 //
     /*  995349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /*  995352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995388 */     // MIs[0] policy
     /*  995388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995398 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995419 */     GIR_RootConstrainSelectedInstOperands,
     /*  995420 */     // GIR_Coverage, 2594,
     /*  995420 */     GIR_EraseRootFromParent_Done,
     /*  995421 */   // Label 14807: @995421
     /*  995421 */   GIM_Try, /*On fail goto*//*Label 14808*/ GIMT_Encode4(995498), // Rule ID 2595 //
     /*  995426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /*  995429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /*  995434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995465 */     // MIs[0] policy
     /*  995465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995475 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF4_E16_MASK),
     /*  995478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995496 */     GIR_RootConstrainSelectedInstOperands,
     /*  995497 */     // GIR_Coverage, 2595,
     /*  995497 */     GIR_EraseRootFromParent_Done,
     /*  995498 */   // Label 14808: @995498
     /*  995498 */   GIM_Try, /*On fail goto*//*Label 14809*/ GIMT_Encode4(995575), // Rule ID 2630 //
     /*  995503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /*  995506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  995511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995542 */     // MIs[0] policy
     /*  995542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995552 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  995555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995573 */     GIR_RootConstrainSelectedInstOperands,
     /*  995574 */     // GIR_Coverage, 2630,
     /*  995574 */     GIR_EraseRootFromParent_Done,
     /*  995575 */   // Label 14809: @995575
     /*  995575 */   GIM_Try, /*On fail goto*//*Label 14810*/ GIMT_Encode4(995652), // Rule ID 2631 //
     /*  995580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /*  995583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /*  995588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  995591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  995594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  995597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  995600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995619 */     // MIs[0] policy
     /*  995619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995629 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF4_MASK),
     /*  995632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995650 */     GIR_RootConstrainSelectedInstOperands,
     /*  995651 */     // GIR_Coverage, 2631,
     /*  995651 */     GIR_EraseRootFromParent_Done,
     /*  995652 */   // Label 14810: @995652
     /*  995652 */   GIM_Try, /*On fail goto*//*Label 14811*/ GIMT_Encode4(995729), // Rule ID 2662 //
     /*  995657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  995665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  995677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995696 */     // MIs[0] policy
     /*  995696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  995709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  995713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995727 */     GIR_RootConstrainSelectedInstOperands,
     /*  995728 */     // GIR_Coverage, 2662,
     /*  995728 */     GIR_EraseRootFromParent_Done,
     /*  995729 */   // Label 14811: @995729
     /*  995729 */   GIM_Try, /*On fail goto*//*Label 14812*/ GIMT_Encode4(995806), // Rule ID 2663 //
     /*  995734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /*  995742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /*  995745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /*  995748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  995751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /*  995754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995773 */     // MIs[0] policy
     /*  995773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995783 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8),
     /*  995786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /*  995790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /*  995792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /*  995794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  995802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995804 */     GIR_RootConstrainSelectedInstOperands,
     /*  995805 */     // GIR_Coverage, 2663,
     /*  995805 */     GIR_EraseRootFromParent_Done,
     /*  995806 */   // Label 14812: @995806
     /*  995806 */   GIM_Try, /*On fail goto*//*Label 14813*/ GIMT_Encode4(995883), // Rule ID 4782 //
     /*  995811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  995822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  995825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  995828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  995831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995850 */     // MIs[0] policy
     /*  995850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  995860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  995863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995881 */     GIR_RootConstrainSelectedInstOperands,
     /*  995882 */     // GIR_Coverage, 4782,
     /*  995882 */     GIR_EraseRootFromParent_Done,
     /*  995883 */   // Label 14813: @995883
     /*  995883 */   GIM_Try, /*On fail goto*//*Label 14814*/ GIMT_Encode4(995960), // Rule ID 4783 //
     /*  995888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  995891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /*  995899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  995902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  995905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  995908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  995911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  995927 */     // MIs[0] policy
     /*  995927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  995930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  995937 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  995937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  995940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  995942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  995944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  995946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  995948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  995953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  995956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  995958 */     GIR_RootConstrainSelectedInstOperands,
     /*  995959 */     // GIR_Coverage, 4783,
     /*  995959 */     GIR_EraseRootFromParent_Done,
     /*  995960 */   // Label 14814: @995960
     /*  995960 */   GIM_Try, /*On fail goto*//*Label 14815*/ GIMT_Encode4(996037), // Rule ID 4786 //
     /*  995965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  995968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  995973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  995976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  995979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  995982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  995985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  995988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  995992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  995996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996004 */     // MIs[0] policy
     /*  996004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996035 */     GIR_RootConstrainSelectedInstOperands,
     /*  996036 */     // GIR_Coverage, 4786,
     /*  996036 */     GIR_EraseRootFromParent_Done,
     /*  996037 */   // Label 14815: @996037
     /*  996037 */   GIM_Try, /*On fail goto*//*Label 14816*/ GIMT_Encode4(996114), // Rule ID 4787 //
     /*  996042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /*  996053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  996056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  996059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996081 */     // MIs[0] policy
     /*  996081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996091 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11609:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996112 */     GIR_RootConstrainSelectedInstOperands,
     /*  996113 */     // GIR_Coverage, 4787,
     /*  996113 */     GIR_EraseRootFromParent_Done,
     /*  996114 */   // Label 14816: @996114
     /*  996114 */   GIM_Try, /*On fail goto*//*Label 14817*/ GIMT_Encode4(996191), // Rule ID 4790 //
     /*  996119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996158 */     // MIs[0] policy
     /*  996158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996168 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996189 */     GIR_RootConstrainSelectedInstOperands,
     /*  996190 */     // GIR_Coverage, 4790,
     /*  996190 */     GIR_EraseRootFromParent_Done,
     /*  996191 */   // Label 14817: @996191
     /*  996191 */   GIM_Try, /*On fail goto*//*Label 14818*/ GIMT_Encode4(996268), // Rule ID 4791 //
     /*  996196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /*  996207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  996210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  996213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  996216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996235 */     // MIs[0] policy
     /*  996235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996245 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996266 */     GIR_RootConstrainSelectedInstOperands,
     /*  996267 */     // GIR_Coverage, 4791,
     /*  996267 */     GIR_EraseRootFromParent_Done,
     /*  996268 */   // Label 14818: @996268
     /*  996268 */   GIM_Try, /*On fail goto*//*Label 14819*/ GIMT_Encode4(996345), // Rule ID 4794 //
     /*  996273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996312 */     // MIs[0] policy
     /*  996312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996343 */     GIR_RootConstrainSelectedInstOperands,
     /*  996344 */     // GIR_Coverage, 4794,
     /*  996344 */     GIR_EraseRootFromParent_Done,
     /*  996345 */   // Label 14819: @996345
     /*  996345 */   GIM_Try, /*On fail goto*//*Label 14820*/ GIMT_Encode4(996422), // Rule ID 4795 //
     /*  996350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /*  996361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /*  996364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  996367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  996370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  996377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996389 */     // MIs[0] policy
     /*  996389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996399 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  996402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996420 */     GIR_RootConstrainSelectedInstOperands,
     /*  996421 */     // GIR_Coverage, 4795,
     /*  996421 */     GIR_EraseRootFromParent_Done,
     /*  996422 */   // Label 14820: @996422
     /*  996422 */   GIM_Try, /*On fail goto*//*Label 14821*/ GIMT_Encode4(996499), // Rule ID 4798 //
     /*  996427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  996438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  996441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  996444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  996447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996466 */     // MIs[0] policy
     /*  996466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996476 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  996479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996497 */     GIR_RootConstrainSelectedInstOperands,
     /*  996498 */     // GIR_Coverage, 4798,
     /*  996498 */     GIR_EraseRootFromParent_Done,
     /*  996499 */   // Label 14821: @996499
     /*  996499 */   GIM_Try, /*On fail goto*//*Label 14822*/ GIMT_Encode4(996576), // Rule ID 4799 //
     /*  996504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /*  996515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /*  996518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /*  996521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /*  996524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  996531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  996535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  996539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996543 */     // MIs[0] policy
     /*  996543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996553 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  996556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /*  996572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996574 */     GIR_RootConstrainSelectedInstOperands,
     /*  996575 */     // GIR_Coverage, 4799,
     /*  996575 */     GIR_EraseRootFromParent_Done,
     /*  996576 */   // Label 14822: @996576
     /*  996576 */   GIM_Try, /*On fail goto*//*Label 14823*/ GIMT_Encode4(996653), // Rule ID 4802 //
     /*  996581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996620 */     // MIs[0] policy
     /*  996620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996630 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996651 */     GIR_RootConstrainSelectedInstOperands,
     /*  996652 */     // GIR_Coverage, 4802,
     /*  996652 */     GIR_EraseRootFromParent_Done,
     /*  996653 */   // Label 14823: @996653
     /*  996653 */   GIM_Try, /*On fail goto*//*Label 14824*/ GIMT_Encode4(996730), // Rule ID 4803 //
     /*  996658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  996669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  996672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  996675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  996678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996697 */     // MIs[0] policy
     /*  996697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996707 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2_MASK),
     /*  996710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996728 */     GIR_RootConstrainSelectedInstOperands,
     /*  996729 */     // GIR_Coverage, 4803,
     /*  996729 */     GIR_EraseRootFromParent_Done,
     /*  996730 */   // Label 14824: @996730
     /*  996730 */   GIM_Try, /*On fail goto*//*Label 14825*/ GIMT_Encode4(996807), // Rule ID 4806 //
     /*  996735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  996752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996774 */     // MIs[0] policy
     /*  996774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996805 */     GIR_RootConstrainSelectedInstOperands,
     /*  996806 */     // GIR_Coverage, 4806,
     /*  996806 */     GIR_EraseRootFromParent_Done,
     /*  996807 */   // Label 14825: @996807
     /*  996807 */   GIM_Try, /*On fail goto*//*Label 14826*/ GIMT_Encode4(996884), // Rule ID 4807 //
     /*  996812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  996823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  996826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  996829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  996832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  996839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996851 */     // MIs[0] policy
     /*  996851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996861 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  996861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  996864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996882 */     GIR_RootConstrainSelectedInstOperands,
     /*  996883 */     // GIR_Coverage, 4807,
     /*  996883 */     GIR_EraseRootFromParent_Done,
     /*  996884 */   // Label 14826: @996884
     /*  996884 */   GIM_Try, /*On fail goto*//*Label 14827*/ GIMT_Encode4(996961), // Rule ID 4810 //
     /*  996889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  996892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  996900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  996903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  996906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  996912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  996924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  996928 */     // MIs[0] policy
     /*  996928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  996931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  996938 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  996938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  996941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  996943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  996945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  996947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  996949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  996954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  996957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  996959 */     GIR_RootConstrainSelectedInstOperands,
     /*  996960 */     // GIR_Coverage, 4810,
     /*  996960 */     GIR_EraseRootFromParent_Done,
     /*  996961 */   // Label 14827: @996961
     /*  996961 */   GIM_Try, /*On fail goto*//*Label 14828*/ GIMT_Encode4(997038), // Rule ID 4811 //
     /*  996966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  996969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  996974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  996977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  996980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  996983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  996986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  996989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  996993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  996997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997005 */     // MIs[0] policy
     /*  997005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997015 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997036 */     GIR_RootConstrainSelectedInstOperands,
     /*  997037 */     // GIR_Coverage, 4811,
     /*  997037 */     GIR_EraseRootFromParent_Done,
     /*  997038 */   // Label 14828: @997038
     /*  997038 */   GIM_Try, /*On fail goto*//*Label 14829*/ GIMT_Encode4(997115), // Rule ID 4814 //
     /*  997043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997082 */     // MIs[0] policy
     /*  997082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997092 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997113 */     GIR_RootConstrainSelectedInstOperands,
     /*  997114 */     // GIR_Coverage, 4814,
     /*  997114 */     GIR_EraseRootFromParent_Done,
     /*  997115 */   // Label 14829: @997115
     /*  997115 */   GIM_Try, /*On fail goto*//*Label 14830*/ GIMT_Encode4(997192), // Rule ID 4815 //
     /*  997120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  997131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  997134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  997137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997159 */     // MIs[0] policy
     /*  997159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997169 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997190 */     GIR_RootConstrainSelectedInstOperands,
     /*  997191 */     // GIR_Coverage, 4815,
     /*  997191 */     GIR_EraseRootFromParent_Done,
     /*  997192 */   // Label 14830: @997192
     /*  997192 */   GIM_Try, /*On fail goto*//*Label 14831*/ GIMT_Encode4(997269), // Rule ID 4818 //
     /*  997197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997236 */     // MIs[0] policy
     /*  997236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997246 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997267 */     GIR_RootConstrainSelectedInstOperands,
     /*  997268 */     // GIR_Coverage, 4818,
     /*  997268 */     GIR_EraseRootFromParent_Done,
     /*  997269 */   // Label 14831: @997269
     /*  997269 */   GIM_Try, /*On fail goto*//*Label 14832*/ GIMT_Encode4(997346), // Rule ID 4819 //
     /*  997274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  997277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  997285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  997288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /*  997291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  997294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997313 */     // MIs[0] policy
     /*  997313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997323 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  997342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997344 */     GIR_RootConstrainSelectedInstOperands,
     /*  997345 */     // GIR_Coverage, 4819,
     /*  997345 */     GIR_EraseRootFromParent_Done,
     /*  997346 */   // Label 14832: @997346
     /*  997346 */   GIM_Try, /*On fail goto*//*Label 14833*/ GIMT_Encode4(997423), // Rule ID 4822 //
     /*  997351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997390 */     // MIs[0] policy
     /*  997390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997421 */     GIR_RootConstrainSelectedInstOperands,
     /*  997422 */     // GIR_Coverage, 4822,
     /*  997422 */     GIR_EraseRootFromParent_Done,
     /*  997423 */   // Label 14833: @997423
     /*  997423 */   GIM_Try, /*On fail goto*//*Label 14834*/ GIMT_Encode4(997500), // Rule ID 4823 //
     /*  997428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  997439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  997442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /*  997445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997467 */     // MIs[0] policy
     /*  997467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997477 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1_MASK),
     /*  997480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997498 */     GIR_RootConstrainSelectedInstOperands,
     /*  997499 */     // GIR_Coverage, 4823,
     /*  997499 */     GIR_EraseRootFromParent_Done,
     /*  997500 */   // Label 14834: @997500
     /*  997500 */   GIM_Try, /*On fail goto*//*Label 14835*/ GIMT_Encode4(997577), // Rule ID 4826 //
     /*  997505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  997522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997544 */     // MIs[0] policy
     /*  997544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997575 */     GIR_RootConstrainSelectedInstOperands,
     /*  997576 */     // GIR_Coverage, 4826,
     /*  997576 */     GIR_EraseRootFromParent_Done,
     /*  997577 */   // Label 14835: @997577
     /*  997577 */   GIM_Try, /*On fail goto*//*Label 14836*/ GIMT_Encode4(997654), // Rule ID 4827 //
     /*  997582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  997593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  997596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /*  997599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  997602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  997609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997621 */     // MIs[0] policy
     /*  997621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2_MASK),
     /*  997634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997640 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997652 */     GIR_RootConstrainSelectedInstOperands,
     /*  997653 */     // GIR_Coverage, 4827,
     /*  997653 */     GIR_EraseRootFromParent_Done,
     /*  997654 */   // Label 14836: @997654
     /*  997654 */   GIM_Try, /*On fail goto*//*Label 14837*/ GIMT_Encode4(997731), // Rule ID 4830 //
     /*  997659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  997676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997698 */     // MIs[0] policy
     /*  997698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997717 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997729 */     GIR_RootConstrainSelectedInstOperands,
     /*  997730 */     // GIR_Coverage, 4830,
     /*  997730 */     GIR_EraseRootFromParent_Done,
     /*  997731 */   // Label 14837: @997731
     /*  997731 */   GIM_Try, /*On fail goto*//*Label 14838*/ GIMT_Encode4(997808), // Rule ID 4831 //
     /*  997736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  997747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  997750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  997753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  997756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  997763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  997771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997775 */     // MIs[0] policy
     /*  997775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997785 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4_MASK),
     /*  997788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997794 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997806 */     GIR_RootConstrainSelectedInstOperands,
     /*  997807 */     // GIR_Coverage, 4831,
     /*  997807 */     GIR_EraseRootFromParent_Done,
     /*  997808 */   // Label 14838: @997808
     /*  997808 */   GIM_Try, /*On fail goto*//*Label 14839*/ GIMT_Encode4(997885), // Rule ID 4834 //
     /*  997813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  997816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  997830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997852 */     // MIs[0] policy
     /*  997852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  997862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997883 */     GIR_RootConstrainSelectedInstOperands,
     /*  997884 */     // GIR_Coverage, 4834,
     /*  997884 */     GIR_EraseRootFromParent_Done,
     /*  997885 */   // Label 14839: @997885
     /*  997885 */   GIM_Try, /*On fail goto*//*Label 14840*/ GIMT_Encode4(997962), // Rule ID 4835 //
     /*  997890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  997893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  997901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  997904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /*  997907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  997910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  997913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  997917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  997921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  997925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  997929 */     // MIs[0] policy
     /*  997929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  997932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  997939 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  997939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8_MASK),
     /*  997942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  997944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  997946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  997948 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  997950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  997955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  997958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  997960 */     GIR_RootConstrainSelectedInstOperands,
     /*  997961 */     // GIR_Coverage, 4835,
     /*  997961 */     GIR_EraseRootFromParent_Done,
     /*  997962 */   // Label 14840: @997962
     /*  997962 */   GIM_Try, /*On fail goto*//*Label 14841*/ GIMT_Encode4(998039), // Rule ID 4838 //
     /*  997967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  997970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  997975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  997978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  997981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  997984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  997987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  997990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  997994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  997998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998006 */     // MIs[0] policy
     /*  998006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998016 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998037 */     GIR_RootConstrainSelectedInstOperands,
     /*  998038 */     // GIR_Coverage, 4838,
     /*  998038 */     GIR_EraseRootFromParent_Done,
     /*  998039 */   // Label 14841: @998039
     /*  998039 */   GIM_Try, /*On fail goto*//*Label 14842*/ GIMT_Encode4(998116), // Rule ID 4839 //
     /*  998044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /*  998055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /*  998058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  998061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998083 */     // MIs[0] policy
     /*  998083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998093 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2_MASK),
     /*  998096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998102 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998114 */     GIR_RootConstrainSelectedInstOperands,
     /*  998115 */     // GIR_Coverage, 4839,
     /*  998115 */     GIR_EraseRootFromParent_Done,
     /*  998116 */   // Label 14842: @998116
     /*  998116 */   GIM_Try, /*On fail goto*//*Label 14843*/ GIMT_Encode4(998193), // Rule ID 4842 //
     /*  998121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998160 */     // MIs[0] policy
     /*  998160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998179 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998191 */     GIR_RootConstrainSelectedInstOperands,
     /*  998192 */     // GIR_Coverage, 4842,
     /*  998192 */     GIR_EraseRootFromParent_Done,
     /*  998193 */   // Label 14843: @998193
     /*  998193 */   GIM_Try, /*On fail goto*//*Label 14844*/ GIMT_Encode4(998270), // Rule ID 4843 //
     /*  998198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /*  998209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  998212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  998215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998237 */     // MIs[0] policy
     /*  998237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998247 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11609:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998256 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998268 */     GIR_RootConstrainSelectedInstOperands,
     /*  998269 */     // GIR_Coverage, 4843,
     /*  998269 */     GIR_EraseRootFromParent_Done,
     /*  998270 */   // Label 14844: @998270
     /*  998270 */   GIM_Try, /*On fail goto*//*Label 14845*/ GIMT_Encode4(998347), // Rule ID 4846 //
     /*  998275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998314 */     // MIs[0] policy
     /*  998314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998324 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998345 */     GIR_RootConstrainSelectedInstOperands,
     /*  998346 */     // GIR_Coverage, 4846,
     /*  998346 */     GIR_EraseRootFromParent_Done,
     /*  998347 */   // Label 14845: @998347
     /*  998347 */   GIM_Try, /*On fail goto*//*Label 14846*/ GIMT_Encode4(998424), // Rule ID 4847 //
     /*  998352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /*  998363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  998366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  998369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  998372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998391 */     // MIs[0] policy
     /*  998391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998401 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998422 */     GIR_RootConstrainSelectedInstOperands,
     /*  998423 */     // GIR_Coverage, 4847,
     /*  998423 */     GIR_EraseRootFromParent_Done,
     /*  998424 */   // Label 14846: @998424
     /*  998424 */   GIM_Try, /*On fail goto*//*Label 14847*/ GIMT_Encode4(998501), // Rule ID 4850 //
     /*  998429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  998446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998468 */     // MIs[0] policy
     /*  998468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998478 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  998481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998487 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998499 */     GIR_RootConstrainSelectedInstOperands,
     /*  998500 */     // GIR_Coverage, 4850,
     /*  998500 */     GIR_EraseRootFromParent_Done,
     /*  998501 */   // Label 14847: @998501
     /*  998501 */   GIM_Try, /*On fail goto*//*Label 14848*/ GIMT_Encode4(998578), // Rule ID 4851 //
     /*  998506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /*  998517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /*  998520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  998523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  998526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  998533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  998537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998545 */     // MIs[0] policy
     /*  998545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998555 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  998558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998564 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998576 */     GIR_RootConstrainSelectedInstOperands,
     /*  998577 */     // GIR_Coverage, 4851,
     /*  998577 */     GIR_EraseRootFromParent_Done,
     /*  998578 */   // Label 14848: @998578
     /*  998578 */   GIM_Try, /*On fail goto*//*Label 14849*/ GIMT_Encode4(998655), // Rule ID 4854 //
     /*  998583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  998586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  998600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998622 */     // MIs[0] policy
     /*  998622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  998635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998653 */     GIR_RootConstrainSelectedInstOperands,
     /*  998654 */     // GIR_Coverage, 4854,
     /*  998654 */     GIR_EraseRootFromParent_Done,
     /*  998655 */   // Label 14849: @998655
     /*  998655 */   GIM_Try, /*On fail goto*//*Label 14850*/ GIMT_Encode4(998732), // Rule ID 4855 //
     /*  998660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /*  998663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /*  998671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /*  998674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  998677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /*  998680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  998687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  998691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998699 */     // MIs[0] policy
     /*  998699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998709 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  998712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /*  998728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998730 */     GIR_RootConstrainSelectedInstOperands,
     /*  998731 */     // GIR_Coverage, 4855,
     /*  998731 */     GIR_EraseRootFromParent_Done,
     /*  998732 */   // Label 14850: @998732
     /*  998732 */   GIM_Try, /*On fail goto*//*Label 14851*/ GIMT_Encode4(998809), // Rule ID 4858 //
     /*  998737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  998754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998776 */     // MIs[0] policy
     /*  998776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998807 */     GIR_RootConstrainSelectedInstOperands,
     /*  998808 */     // GIR_Coverage, 4858,
     /*  998808 */     GIR_EraseRootFromParent_Done,
     /*  998809 */   // Label 14851: @998809
     /*  998809 */   GIM_Try, /*On fail goto*//*Label 14852*/ GIMT_Encode4(998886), // Rule ID 4859 //
     /*  998814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  998825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  998828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /*  998831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  998834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  998841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998853 */     // MIs[0] policy
     /*  998853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  998863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1_MASK),
     /*  998866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998872 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998884 */     GIR_RootConstrainSelectedInstOperands,
     /*  998885 */     // GIR_Coverage, 4859,
     /*  998885 */     GIR_EraseRootFromParent_Done,
     /*  998886 */   // Label 14852: @998886
     /*  998886 */   GIM_Try, /*On fail goto*//*Label 14853*/ GIMT_Encode4(998963), // Rule ID 4862 //
     /*  998891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  998894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  998908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  998914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  998926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  998930 */     // MIs[0] policy
     /*  998930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  998933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  998940 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  998940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  998943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  998945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  998947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  998949 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  998951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  998956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  998959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  998961 */     GIR_RootConstrainSelectedInstOperands,
     /*  998962 */     // GIR_Coverage, 4862,
     /*  998962 */     GIR_EraseRootFromParent_Done,
     /*  998963 */   // Label 14853: @998963
     /*  998963 */   GIM_Try, /*On fail goto*//*Label 14854*/ GIMT_Encode4(999040), // Rule ID 4863 //
     /*  998968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  998971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  998976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  998979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  998982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /*  998985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  998988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  998991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  998995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  998999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999007 */     // MIs[0] policy
     /*  999007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2_MASK),
     /*  999020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999026 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999038 */     GIR_RootConstrainSelectedInstOperands,
     /*  999039 */     // GIR_Coverage, 4863,
     /*  999039 */     GIR_EraseRootFromParent_Done,
     /*  999040 */   // Label 14854: @999040
     /*  999040 */   GIM_Try, /*On fail goto*//*Label 14855*/ GIMT_Encode4(999117), // Rule ID 4866 //
     /*  999045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999084 */     // MIs[0] policy
     /*  999084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999094 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999115 */     GIR_RootConstrainSelectedInstOperands,
     /*  999116 */     // GIR_Coverage, 4866,
     /*  999116 */     GIR_EraseRootFromParent_Done,
     /*  999117 */   // Label 14855: @999117
     /*  999117 */   GIM_Try, /*On fail goto*//*Label 14856*/ GIMT_Encode4(999194), // Rule ID 4867 //
     /*  999122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /*  999139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999161 */     // MIs[0] policy
     /*  999161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999171 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4_MASK),
     /*  999174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999180 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999192 */     GIR_RootConstrainSelectedInstOperands,
     /*  999193 */     // GIR_Coverage, 4867,
     /*  999193 */     GIR_EraseRootFromParent_Done,
     /*  999194 */   // Label 14856: @999194
     /*  999194 */   GIM_Try, /*On fail goto*//*Label 14857*/ GIMT_Encode4(999271), // Rule ID 4870 //
     /*  999199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999238 */     // MIs[0] policy
     /*  999238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999269 */     GIR_RootConstrainSelectedInstOperands,
     /*  999270 */     // GIR_Coverage, 4870,
     /*  999270 */     GIR_EraseRootFromParent_Done,
     /*  999271 */   // Label 14857: @999271
     /*  999271 */   GIM_Try, /*On fail goto*//*Label 14858*/ GIMT_Encode4(999348), // Rule ID 4871 //
     /*  999276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  999293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999315 */     // MIs[0] policy
     /*  999315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999325 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8_MASK),
     /*  999328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999346 */     GIR_RootConstrainSelectedInstOperands,
     /*  999347 */     // GIR_Coverage, 4871,
     /*  999347 */     GIR_EraseRootFromParent_Done,
     /*  999348 */   // Label 14858: @999348
     /*  999348 */   GIM_Try, /*On fail goto*//*Label 14859*/ GIMT_Encode4(999425), // Rule ID 4874 //
     /*  999353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999392 */     // MIs[0] policy
     /*  999392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999402 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  999405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999423 */     GIR_RootConstrainSelectedInstOperands,
     /*  999424 */     // GIR_Coverage, 4874,
     /*  999424 */     GIR_EraseRootFromParent_Done,
     /*  999425 */   // Label 14859: @999425
     /*  999425 */   GIM_Try, /*On fail goto*//*Label 14860*/ GIMT_Encode4(999502), // Rule ID 4875 //
     /*  999430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /*  999441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /*  999444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999469 */     // MIs[0] policy
     /*  999469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999479 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11609:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1_MASK),
     /*  999482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999488 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999500 */     GIR_RootConstrainSelectedInstOperands,
     /*  999501 */     // GIR_Coverage, 4875,
     /*  999501 */     GIR_EraseRootFromParent_Done,
     /*  999502 */   // Label 14860: @999502
     /*  999502 */   GIM_Try, /*On fail goto*//*Label 14861*/ GIMT_Encode4(999579), // Rule ID 4878 //
     /*  999507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999546 */     // MIs[0] policy
     /*  999546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /*  999559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999577 */     GIR_RootConstrainSelectedInstOperands,
     /*  999578 */     // GIR_Coverage, 4878,
     /*  999578 */     GIR_EraseRootFromParent_Done,
     /*  999579 */   // Label 14861: @999579
     /*  999579 */   GIM_Try, /*On fail goto*//*Label 14862*/ GIMT_Encode4(999656), // Rule ID 4879 //
     /*  999584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /*  999595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  999598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /*  999601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /*  999604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /*  999611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /*  999615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999623 */     // MIs[0] policy
     /*  999623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999633 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11609:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2_MASK),
     /*  999636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999642 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999654 */     GIR_RootConstrainSelectedInstOperands,
     /*  999655 */     // GIR_Coverage, 4879,
     /*  999655 */     GIR_EraseRootFromParent_Done,
     /*  999656 */   // Label 14862: @999656
     /*  999656 */   GIM_Try, /*On fail goto*//*Label 14863*/ GIMT_Encode4(999733), // Rule ID 4882 //
     /*  999661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999700 */     // MIs[0] policy
     /*  999700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /*  999713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999719 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999731 */     GIR_RootConstrainSelectedInstOperands,
     /*  999732 */     // GIR_Coverage, 4882,
     /*  999732 */     GIR_EraseRootFromParent_Done,
     /*  999733 */   // Label 14863: @999733
     /*  999733 */   GIM_Try, /*On fail goto*//*Label 14864*/ GIMT_Encode4(999810), // Rule ID 4883 //
     /*  999738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /*  999749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /*  999752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /*  999755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /*  999758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /*  999765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /*  999769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999777 */     // MIs[0] policy
     /*  999777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999787 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11609:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4_MASK),
     /*  999790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999796 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999808 */     GIR_RootConstrainSelectedInstOperands,
     /*  999809 */     // GIR_Coverage, 4883,
     /*  999809 */     GIR_EraseRootFromParent_Done,
     /*  999810 */   // Label 14864: @999810
     /*  999810 */   GIM_Try, /*On fail goto*//*Label 14865*/ GIMT_Encode4(999887), // Rule ID 4886 //
     /*  999815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /*  999818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999854 */     // MIs[0] policy
     /*  999854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999864 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /*  999864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /*  999867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999885 */     GIR_RootConstrainSelectedInstOperands,
     /*  999886 */     // GIR_Coverage, 4886,
     /*  999886 */     GIR_EraseRootFromParent_Done,
     /*  999887 */   // Label 14865: @999887
     /*  999887 */   GIM_Try, /*On fail goto*//*Label 14866*/ GIMT_Encode4(999964), // Rule ID 4887 //
     /*  999892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /*  999895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vzext_mask),
     /*  999900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /*  999903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /*  999906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /*  999909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /*  999912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  999915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /*  999919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /*  999923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /*  999927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /*  999931 */     // MIs[0] policy
     /*  999931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  999934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /*  999941 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11609:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVZEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /*  999941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8_MASK),
     /*  999944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /*  999946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /*  999948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /*  999950 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /*  999952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /*  999957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /*  999960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /*  999962 */     GIR_RootConstrainSelectedInstOperands,
     /*  999963 */     // GIR_Coverage, 4887,
     /*  999963 */     GIR_EraseRootFromParent_Done,
     /*  999964 */   // Label 14866: @999964
     /*  999964 */   GIM_Try, /*On fail goto*//*Label 14867*/ GIMT_Encode4(1000041), // Rule ID 4890 //
     /*  999969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /*  999972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /*  999977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /*  999980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /*  999983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /*  999986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /*  999989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /*  999992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /*  999996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000008 */     // MIs[0] policy
     /* 1000008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000018 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000040 */     // GIR_Coverage, 4890,
     /* 1000040 */     GIR_EraseRootFromParent_Done,
     /* 1000041 */   // Label 14867: @1000041
     /* 1000041 */   GIM_Try, /*On fail goto*//*Label 14868*/ GIMT_Encode4(1000118), // Rule ID 4891 //
     /* 1000046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1000057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1000060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1000063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000085 */     // MIs[0] policy
     /* 1000085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000095 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4_MASK),
     /* 1000098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000117 */     // GIR_Coverage, 4891,
     /* 1000117 */     GIR_EraseRootFromParent_Done,
     /* 1000118 */   // Label 14868: @1000118
     /* 1000118 */   GIM_Try, /*On fail goto*//*Label 14869*/ GIMT_Encode4(1000195), // Rule ID 4894 //
     /* 1000123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000162 */     // MIs[0] policy
     /* 1000162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000194 */     // GIR_Coverage, 4894,
     /* 1000194 */     GIR_EraseRootFromParent_Done,
     /* 1000195 */   // Label 14869: @1000195
     /* 1000195 */   GIM_Try, /*On fail goto*//*Label 14870*/ GIMT_Encode4(1000272), // Rule ID 4895 //
     /* 1000200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1000211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1000214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1000217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1000220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000239 */     // MIs[0] policy
     /* 1000239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000249 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000258 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000271 */     // GIR_Coverage, 4895,
     /* 1000271 */     GIR_EraseRootFromParent_Done,
     /* 1000272 */   // Label 14870: @1000272
     /* 1000272 */   GIM_Try, /*On fail goto*//*Label 14871*/ GIMT_Encode4(1000349), // Rule ID 4898 //
     /* 1000277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000316 */     // MIs[0] policy
     /* 1000316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000326 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000348 */     // GIR_Coverage, 4898,
     /* 1000348 */     GIR_EraseRootFromParent_Done,
     /* 1000349 */   // Label 14871: @1000349
     /* 1000349 */   GIM_Try, /*On fail goto*//*Label 14872*/ GIMT_Encode4(1000426), // Rule ID 4899 //
     /* 1000354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1000365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1000368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1000371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1000374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000393 */     // MIs[0] policy
     /* 1000393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000403 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11472:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1000406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000412 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000425 */     // GIR_Coverage, 4899,
     /* 1000425 */     GIR_EraseRootFromParent_Done,
     /* 1000426 */   // Label 14872: @1000426
     /* 1000426 */   GIM_Try, /*On fail goto*//*Label 14873*/ GIMT_Encode4(1000503), // Rule ID 4902 //
     /* 1000431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000470 */     // MIs[0] policy
     /* 1000470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1000483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000502 */     // GIR_Coverage, 4902,
     /* 1000502 */     GIR_EraseRootFromParent_Done,
     /* 1000503 */   // Label 14873: @1000503
     /* 1000503 */   GIM_Try, /*On fail goto*//*Label 14874*/ GIMT_Encode4(1000580), // Rule ID 4903 //
     /* 1000508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1000519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1000522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1000525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1000528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1000535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000547 */     // MIs[0] policy
     /* 1000547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000557 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1000560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000566 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000579 */     // GIR_Coverage, 4903,
     /* 1000579 */     GIR_EraseRootFromParent_Done,
     /* 1000580 */   // Label 14874: @1000580
     /* 1000580 */   GIM_Try, /*On fail goto*//*Label 14875*/ GIMT_Encode4(1000657), // Rule ID 4906 //
     /* 1000585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000624 */     // MIs[0] policy
     /* 1000624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1000637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000656 */     // GIR_Coverage, 4906,
     /* 1000656 */     GIR_EraseRootFromParent_Done,
     /* 1000657 */   // Label 14875: @1000657
     /* 1000657 */   GIM_Try, /*On fail goto*//*Label 14876*/ GIMT_Encode4(1000734), // Rule ID 4907 //
     /* 1000662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1000673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1000676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1000679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1000682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1000689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1000697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000701 */     // MIs[0] policy
     /* 1000701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000711 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1000714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000720 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000733 */     // GIR_Coverage, 4907,
     /* 1000733 */     GIR_EraseRootFromParent_Done,
     /* 1000734 */   // Label 14876: @1000734
     /* 1000734 */   GIM_Try, /*On fail goto*//*Label 14877*/ GIMT_Encode4(1000811), // Rule ID 4910 //
     /* 1000739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000778 */     // MIs[0] policy
     /* 1000778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000788 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1000791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000810 */     // GIR_Coverage, 4910,
     /* 1000810 */     GIR_EraseRootFromParent_Done,
     /* 1000811 */   // Label 14877: @1000811
     /* 1000811 */   GIM_Try, /*On fail goto*//*Label 14878*/ GIMT_Encode4(1000888), // Rule ID 4911 //
     /* 1000816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1000827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1000830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1000833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1000836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1000843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1000847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1000851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000855 */     // MIs[0] policy
     /* 1000855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000865 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1000865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1000868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000874 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1000884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000887 */     // GIR_Coverage, 4911,
     /* 1000887 */     GIR_EraseRootFromParent_Done,
     /* 1000888 */   // Label 14878: @1000888
     /* 1000888 */   GIM_Try, /*On fail goto*//*Label 14879*/ GIMT_Encode4(1000965), // Rule ID 4914 //
     /* 1000893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1000896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1000904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1000907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1000910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1000916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1000928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1000932 */     // MIs[0] policy
     /* 1000932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1000935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1000942 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1000942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1000945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1000947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1000949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1000951 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1000953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1000958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1000961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1000963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1000964 */     // GIR_Coverage, 4914,
     /* 1000964 */     GIR_EraseRootFromParent_Done,
     /* 1000965 */   // Label 14879: @1000965
     /* 1000965 */   GIM_Try, /*On fail goto*//*Label 14880*/ GIMT_Encode4(1001042), // Rule ID 4915 //
     /* 1000970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1000973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1000978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1000981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1000984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1000987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1000990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1000993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1000997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001009 */     // MIs[0] policy
     /* 1001009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001019 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2_MASK),
     /* 1001022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001028 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001041 */     // GIR_Coverage, 4915,
     /* 1001041 */     GIR_EraseRootFromParent_Done,
     /* 1001042 */   // Label 14880: @1001042
     /* 1001042 */   GIM_Try, /*On fail goto*//*Label 14881*/ GIMT_Encode4(1001119), // Rule ID 4918 //
     /* 1001047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001086 */     // MIs[0] policy
     /* 1001086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001118 */     // GIR_Coverage, 4918,
     /* 1001118 */     GIR_EraseRootFromParent_Done,
     /* 1001119 */   // Label 14881: @1001119
     /* 1001119 */   GIM_Try, /*On fail goto*//*Label 14882*/ GIMT_Encode4(1001196), // Rule ID 4919 //
     /* 1001124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1001135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1001138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1001141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001163 */     // MIs[0] policy
     /* 1001163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001173 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001182 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001195 */     // GIR_Coverage, 4919,
     /* 1001195 */     GIR_EraseRootFromParent_Done,
     /* 1001196 */   // Label 14882: @1001196
     /* 1001196 */   GIM_Try, /*On fail goto*//*Label 14883*/ GIMT_Encode4(1001273), // Rule ID 4922 //
     /* 1001201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001240 */     // MIs[0] policy
     /* 1001240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001250 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001272 */     // GIR_Coverage, 4922,
     /* 1001272 */     GIR_EraseRootFromParent_Done,
     /* 1001273 */   // Label 14883: @1001273
     /* 1001273 */   GIM_Try, /*On fail goto*//*Label 14884*/ GIMT_Encode4(1001350), // Rule ID 4923 //
     /* 1001278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1001289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1001292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1001295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001317 */     // MIs[0] policy
     /* 1001317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001327 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001349 */     // GIR_Coverage, 4923,
     /* 1001349 */     GIR_EraseRootFromParent_Done,
     /* 1001350 */   // Label 14884: @1001350
     /* 1001350 */   GIM_Try, /*On fail goto*//*Label 14885*/ GIMT_Encode4(1001427), // Rule ID 4926 //
     /* 1001355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001394 */     // MIs[0] policy
     /* 1001394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001426 */     // GIR_Coverage, 4926,
     /* 1001426 */     GIR_EraseRootFromParent_Done,
     /* 1001427 */   // Label 14885: @1001427
     /* 1001427 */   GIM_Try, /*On fail goto*//*Label 14886*/ GIMT_Encode4(1001504), // Rule ID 4927 //
     /* 1001432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1001443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1001446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1001449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1001452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001471 */     // MIs[0] policy
     /* 1001471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001481 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1001484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001490 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001503 */     // GIR_Coverage, 4927,
     /* 1001503 */     GIR_EraseRootFromParent_Done,
     /* 1001504 */   // Label 14886: @1001504
     /* 1001504 */   GIM_Try, /*On fail goto*//*Label 14887*/ GIMT_Encode4(1001581), // Rule ID 4930 //
     /* 1001509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1001512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001548 */     // MIs[0] policy
     /* 1001548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001580 */     // GIR_Coverage, 4930,
     /* 1001580 */     GIR_EraseRootFromParent_Done,
     /* 1001581 */   // Label 14887: @1001581
     /* 1001581 */   GIM_Try, /*On fail goto*//*Label 14888*/ GIMT_Encode4(1001658), // Rule ID 4931 //
     /* 1001586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1001589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1001597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1001600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1001603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1001606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1001613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1001617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1001621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001625 */     // MIs[0] policy
     /* 1001625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001635 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1001638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001644 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1001654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001657 */     // GIR_Coverage, 4931,
     /* 1001657 */     GIR_EraseRootFromParent_Done,
     /* 1001658 */   // Label 14888: @1001658
     /* 1001658 */   GIM_Try, /*On fail goto*//*Label 14889*/ GIMT_Encode4(1001735), // Rule ID 4934 //
     /* 1001663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001702 */     // MIs[0] policy
     /* 1001702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001734 */     // GIR_Coverage, 4934,
     /* 1001734 */     GIR_EraseRootFromParent_Done,
     /* 1001735 */   // Label 14889: @1001735
     /* 1001735 */   GIM_Try, /*On fail goto*//*Label 14890*/ GIMT_Encode4(1001812), // Rule ID 4935 //
     /* 1001740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1001751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1001754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1001757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1001760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1001767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001779 */     // MIs[0] policy
     /* 1001779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001789 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1_MASK),
     /* 1001792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001798 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001811 */     // GIR_Coverage, 4935,
     /* 1001811 */     GIR_EraseRootFromParent_Done,
     /* 1001812 */   // Label 14890: @1001812
     /* 1001812 */   GIM_Try, /*On fail goto*//*Label 14891*/ GIMT_Encode4(1001889), // Rule ID 4938 //
     /* 1001817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001856 */     // MIs[0] policy
     /* 1001856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1001866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001888 */     // GIR_Coverage, 4938,
     /* 1001888 */     GIR_EraseRootFromParent_Done,
     /* 1001889 */   // Label 14891: @1001889
     /* 1001889 */   GIM_Try, /*On fail goto*//*Label 14892*/ GIMT_Encode4(1001966), // Rule ID 4939 //
     /* 1001894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1001897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1001905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1001908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1001911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1001914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1001917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1001921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1001925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1001929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1001933 */     // MIs[0] policy
     /* 1001933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1001936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1001943 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1001943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2_MASK),
     /* 1001946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1001948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1001950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1001952 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1001954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1001959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1001962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1001964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1001965 */     // GIR_Coverage, 4939,
     /* 1001965 */     GIR_EraseRootFromParent_Done,
     /* 1001966 */   // Label 14892: @1001966
     /* 1001966 */   GIM_Try, /*On fail goto*//*Label 14893*/ GIMT_Encode4(1002043), // Rule ID 4942 //
     /* 1001971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1001974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1001979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1001982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1001985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1001988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1001991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1001994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1001998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002010 */     // MIs[0] policy
     /* 1002010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002020 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002029 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002042 */     // GIR_Coverage, 4942,
     /* 1002042 */     GIR_EraseRootFromParent_Done,
     /* 1002043 */   // Label 14893: @1002043
     /* 1002043 */   GIM_Try, /*On fail goto*//*Label 14894*/ GIMT_Encode4(1002120), // Rule ID 4943 //
     /* 1002048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1002059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1002062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1002065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002087 */     // MIs[0] policy
     /* 1002087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002097 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4_MASK),
     /* 1002100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002119 */     // GIR_Coverage, 4943,
     /* 1002119 */     GIR_EraseRootFromParent_Done,
     /* 1002120 */   // Label 14894: @1002120
     /* 1002120 */   GIM_Try, /*On fail goto*//*Label 14895*/ GIMT_Encode4(1002197), // Rule ID 4946 //
     /* 1002125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1002128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002164 */     // MIs[0] policy
     /* 1002164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002196 */     // GIR_Coverage, 4946,
     /* 1002196 */     GIR_EraseRootFromParent_Done,
     /* 1002197 */   // Label 14895: @1002197
     /* 1002197 */   GIM_Try, /*On fail goto*//*Label 14896*/ GIMT_Encode4(1002274), // Rule ID 4947 //
     /* 1002202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1002205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1002213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1002216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1002219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002241 */     // MIs[0] policy
     /* 1002241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002251 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF2_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8_MASK),
     /* 1002254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1002270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002273 */     // GIR_Coverage, 4947,
     /* 1002273 */     GIR_EraseRootFromParent_Done,
     /* 1002274 */   // Label 14896: @1002274
     /* 1002274 */   GIM_Try, /*On fail goto*//*Label 14897*/ GIMT_Encode4(1002351), // Rule ID 4950 //
     /* 1002279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002318 */     // MIs[0] policy
     /* 1002318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002350 */     // GIR_Coverage, 4950,
     /* 1002350 */     GIR_EraseRootFromParent_Done,
     /* 1002351 */   // Label 14897: @1002351
     /* 1002351 */   GIM_Try, /*On fail goto*//*Label 14898*/ GIMT_Encode4(1002428), // Rule ID 4951 //
     /* 1002356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1002367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1002370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1002373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1002376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002395 */     // MIs[0] policy
     /* 1002395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002405 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2_MASK),
     /* 1002408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002427 */     // GIR_Coverage, 4951,
     /* 1002427 */     GIR_EraseRootFromParent_Done,
     /* 1002428 */   // Label 14898: @1002428
     /* 1002428 */   GIM_Try, /*On fail goto*//*Label 14899*/ GIMT_Encode4(1002505), // Rule ID 4954 //
     /* 1002433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002472 */     // MIs[0] policy
     /* 1002472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002482 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1002485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002491 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002504 */     // GIR_Coverage, 4954,
     /* 1002504 */     GIR_EraseRootFromParent_Done,
     /* 1002505 */   // Label 14899: @1002505
     /* 1002505 */   GIM_Try, /*On fail goto*//*Label 14900*/ GIMT_Encode4(1002582), // Rule ID 4955 //
     /* 1002510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1002521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1002524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1002527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1002530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1002537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002549 */     // MIs[0] policy
     /* 1002549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11472:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1002562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002568 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002581 */     // GIR_Coverage, 4955,
     /* 1002581 */     GIR_EraseRootFromParent_Done,
     /* 1002582 */   // Label 14900: @1002582
     /* 1002582 */   GIM_Try, /*On fail goto*//*Label 14901*/ GIMT_Encode4(1002659), // Rule ID 4958 //
     /* 1002587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002626 */     // MIs[0] policy
     /* 1002626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1002639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002658 */     // GIR_Coverage, 4958,
     /* 1002658 */     GIR_EraseRootFromParent_Done,
     /* 1002659 */   // Label 14901: @1002659
     /* 1002659 */   GIM_Try, /*On fail goto*//*Label 14902*/ GIMT_Encode4(1002736), // Rule ID 4959 //
     /* 1002664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1002675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1002678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1002681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1002684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1002691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002703 */     // MIs[0] policy
     /* 1002703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1002716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002722 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002735 */     // GIR_Coverage, 4959,
     /* 1002735 */     GIR_EraseRootFromParent_Done,
     /* 1002736 */   // Label 14902: @1002736
     /* 1002736 */   GIM_Try, /*On fail goto*//*Label 14903*/ GIMT_Encode4(1002813), // Rule ID 4962 //
     /* 1002741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002780 */     // MIs[0] policy
     /* 1002780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002790 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1002793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002799 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002812 */     // GIR_Coverage, 4962,
     /* 1002812 */     GIR_EraseRootFromParent_Done,
     /* 1002813 */   // Label 14903: @1002813
     /* 1002813 */   GIM_Try, /*On fail goto*//*Label 14904*/ GIMT_Encode4(1002890), // Rule ID 4963 //
     /* 1002818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1002829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1002832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1002835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1002838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1002845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1002849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1002853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002857 */     // MIs[0] policy
     /* 1002857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002867 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1002867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1002870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002876 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002889 */     // GIR_Coverage, 4963,
     /* 1002889 */     GIR_EraseRootFromParent_Done,
     /* 1002890 */   // Label 14904: @1002890
     /* 1002890 */   GIM_Try, /*On fail goto*//*Label 14905*/ GIMT_Encode4(1002967), // Rule ID 4966 //
     /* 1002895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1002898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1002912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1002918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1002926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1002930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1002934 */     // MIs[0] policy
     /* 1002934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1002937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1002944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1002944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1002947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1002949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1002951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1002953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1002955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1002960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1002963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1002965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1002966 */     // GIR_Coverage, 4966,
     /* 1002966 */     GIR_EraseRootFromParent_Done,
     /* 1002967 */   // Label 14905: @1002967
     /* 1002967 */   GIM_Try, /*On fail goto*//*Label 14906*/ GIMT_Encode4(1003044), // Rule ID 4967 //
     /* 1002972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1002975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1002980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1002983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1002986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1002989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1002992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1002995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1002999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003011 */     // MIs[0] policy
     /* 1003011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003030 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1003040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003043 */     // GIR_Coverage, 4967,
     /* 1003043 */     GIR_EraseRootFromParent_Done,
     /* 1003044 */   // Label 14906: @1003044
     /* 1003044 */   GIM_Try, /*On fail goto*//*Label 14907*/ GIMT_Encode4(1003121), // Rule ID 4970 //
     /* 1003049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003088 */     // MIs[0] policy
     /* 1003088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003098 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003120 */     // GIR_Coverage, 4970,
     /* 1003120 */     GIR_EraseRootFromParent_Done,
     /* 1003121 */   // Label 14907: @1003121
     /* 1003121 */   GIM_Try, /*On fail goto*//*Label 14908*/ GIMT_Encode4(1003198), // Rule ID 4971 //
     /* 1003126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1003143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003165 */     // MIs[0] policy
     /* 1003165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003175 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1_MASK),
     /* 1003178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003184 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003197 */     // GIR_Coverage, 4971,
     /* 1003197 */     GIR_EraseRootFromParent_Done,
     /* 1003198 */   // Label 14908: @1003198
     /* 1003198 */   GIM_Try, /*On fail goto*//*Label 14909*/ GIMT_Encode4(1003275), // Rule ID 4974 //
     /* 1003203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003242 */     // MIs[0] policy
     /* 1003242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003274 */     // GIR_Coverage, 4974,
     /* 1003274 */     GIR_EraseRootFromParent_Done,
     /* 1003275 */   // Label 14909: @1003275
     /* 1003275 */   GIM_Try, /*On fail goto*//*Label 14910*/ GIMT_Encode4(1003352), // Rule ID 4975 //
     /* 1003280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1003297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003319 */     // MIs[0] policy
     /* 1003319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003329 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2_MASK),
     /* 1003332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003351 */     // GIR_Coverage, 4975,
     /* 1003351 */     GIR_EraseRootFromParent_Done,
     /* 1003352 */   // Label 14910: @1003352
     /* 1003352 */   GIM_Try, /*On fail goto*//*Label 14911*/ GIMT_Encode4(1003429), // Rule ID 4978 //
     /* 1003357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003396 */     // MIs[0] policy
     /* 1003396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003406 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003428 */     // GIR_Coverage, 4978,
     /* 1003428 */     GIR_EraseRootFromParent_Done,
     /* 1003429 */   // Label 14911: @1003429
     /* 1003429 */   GIM_Try, /*On fail goto*//*Label 14912*/ GIMT_Encode4(1003506), // Rule ID 4979 //
     /* 1003434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1003451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1003461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1003465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003473 */     // MIs[0] policy
     /* 1003473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003483 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4_MASK),
     /* 1003486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003492 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003505 */     // GIR_Coverage, 4979,
     /* 1003505 */     GIR_EraseRootFromParent_Done,
     /* 1003506 */   // Label 14912: @1003506
     /* 1003506 */   GIM_Try, /*On fail goto*//*Label 14913*/ GIMT_Encode4(1003583), // Rule ID 4982 //
     /* 1003511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003550 */     // MIs[0] policy
     /* 1003550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003582 */     // GIR_Coverage, 4982,
     /* 1003582 */     GIR_EraseRootFromParent_Done,
     /* 1003583 */   // Label 14913: @1003583
     /* 1003583 */   GIM_Try, /*On fail goto*//*Label 14914*/ GIMT_Encode4(1003660), // Rule ID 4983 //
     /* 1003588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1003599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1003602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1003605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1003608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1003615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1003619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003627 */     // MIs[0] policy
     /* 1003627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003637 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF4_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8_MASK),
     /* 1003640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003646 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003659 */     // GIR_Coverage, 4983,
     /* 1003659 */     GIR_EraseRootFromParent_Done,
     /* 1003660 */   // Label 14914: @1003660
     /* 1003660 */   GIM_Try, /*On fail goto*//*Label 14915*/ GIMT_Encode4(1003737), // Rule ID 4986 //
     /* 1003665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003704 */     // MIs[0] policy
     /* 1003704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1003717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003736 */     // GIR_Coverage, 4986,
     /* 1003736 */     GIR_EraseRootFromParent_Done,
     /* 1003737 */   // Label 14915: @1003737
     /* 1003737 */   GIM_Try, /*On fail goto*//*Label 14916*/ GIMT_Encode4(1003814), // Rule ID 4987 //
     /* 1003742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1003753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1003756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1003759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1003762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1003769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003781 */     // MIs[0] policy
     /* 1003781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003791 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11472:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1_MASK),
     /* 1003794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003800 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003813 */     // GIR_Coverage, 4987,
     /* 1003813 */     GIR_EraseRootFromParent_Done,
     /* 1003814 */   // Label 14916: @1003814
     /* 1003814 */   GIM_Try, /*On fail goto*//*Label 14917*/ GIMT_Encode4(1003891), // Rule ID 4990 //
     /* 1003819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003858 */     // MIs[0] policy
     /* 1003858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1003868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1003871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003890 */     // GIR_Coverage, 4990,
     /* 1003890 */     GIR_EraseRootFromParent_Done,
     /* 1003891 */   // Label 14917: @1003891
     /* 1003891 */   GIM_Try, /*On fail goto*//*Label 14918*/ GIMT_Encode4(1003968), // Rule ID 4991 //
     /* 1003896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1003899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1003907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1003910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1003913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1003916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1003919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1003923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1003927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1003931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1003935 */     // MIs[0] policy
     /* 1003935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1003938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1003945 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11472:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1003945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2_MASK),
     /* 1003948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1003950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1003952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1003954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1003956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1003961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1003964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1003966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1003967 */     // GIR_Coverage, 4991,
     /* 1003967 */     GIR_EraseRootFromParent_Done,
     /* 1003968 */   // Label 14918: @1003968
     /* 1003968 */   GIM_Try, /*On fail goto*//*Label 14919*/ GIMT_Encode4(1004045), // Rule ID 4994 //
     /* 1003973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1003976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1003981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1003984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1003987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1003990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1003993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1003996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004012 */     // MIs[0] policy
     /* 1004012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004022 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004031 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004044 */     // GIR_Coverage, 4994,
     /* 1004044 */     GIR_EraseRootFromParent_Done,
     /* 1004045 */   // Label 14919: @1004045
     /* 1004045 */   GIM_Try, /*On fail goto*//*Label 14920*/ GIMT_Encode4(1004122), // Rule ID 4995 //
     /* 1004050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1004061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1004064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1004070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1004077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1004081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004089 */     // MIs[0] policy
     /* 1004089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004099 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11472:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4_MASK),
     /* 1004102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004108 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004121 */     // GIR_Coverage, 4995,
     /* 1004121 */     GIR_EraseRootFromParent_Done,
     /* 1004122 */   // Label 14920: @1004122
     /* 1004122 */   GIM_Try, /*On fail goto*//*Label 14921*/ GIMT_Encode4(1004199), // Rule ID 4998 //
     /* 1004127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1004130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004166 */     // MIs[0] policy
     /* 1004166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004176 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004198 */     // GIR_Coverage, 4998,
     /* 1004198 */     GIR_EraseRootFromParent_Done,
     /* 1004199 */   // Label 14921: @1004199
     /* 1004199 */   GIM_Try, /*On fail goto*//*Label 14922*/ GIMT_Encode4(1004276), // Rule ID 4999 //
     /* 1004204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1004207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsext_mask),
     /* 1004212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1004215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1004218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1004221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1004224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1004231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1004235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1004243 */     // MIs[0] policy
     /* 1004243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004253 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11472:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSEXT_VF8_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8_MASK),
     /* 1004256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1004260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1004262 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1004264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1004272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004275 */     // GIR_Coverage, 4999,
     /* 1004275 */     GIR_EraseRootFromParent_Done,
     /* 1004276 */   // Label 14922: @1004276
     /* 1004276 */   GIM_Try, /*On fail goto*//*Label 14923*/ GIMT_Encode4(1004353), // Rule ID 12610 //
     /* 1004281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004320 */     // MIs[0] policy
     /* 1004320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004352 */     // GIR_Coverage, 12610,
     /* 1004352 */     GIR_EraseRootFromParent_Done,
     /* 1004353 */   // Label 14923: @1004353
     /* 1004353 */   GIM_Try, /*On fail goto*//*Label 14924*/ GIMT_Encode4(1004430), // Rule ID 12611 //
     /* 1004358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1004369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1004372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1004375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1004378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004397 */     // MIs[0] policy
     /* 1004397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004407 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004429 */     // GIR_Coverage, 12611,
     /* 1004429 */     GIR_EraseRootFromParent_Done,
     /* 1004430 */   // Label 14924: @1004430
     /* 1004430 */   GIM_Try, /*On fail goto*//*Label 14925*/ GIMT_Encode4(1004507), // Rule ID 12614 //
     /* 1004435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1004446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1004449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1004455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004474 */     // MIs[0] policy
     /* 1004474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004506 */     // GIR_Coverage, 12614,
     /* 1004506 */     GIR_EraseRootFromParent_Done,
     /* 1004507 */   // Label 14925: @1004507
     /* 1004507 */   GIM_Try, /*On fail goto*//*Label 14926*/ GIMT_Encode4(1004584), // Rule ID 12615 //
     /* 1004512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1004523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1004526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1004529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1004532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004551 */     // MIs[0] policy
     /* 1004551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004561 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1004580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004583 */     // GIR_Coverage, 12615,
     /* 1004583 */     GIR_EraseRootFromParent_Done,
     /* 1004584 */   // Label 14926: @1004584
     /* 1004584 */   GIM_Try, /*On fail goto*//*Label 14927*/ GIMT_Encode4(1004661), // Rule ID 12618 //
     /* 1004589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1004609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004628 */     // MIs[0] policy
     /* 1004628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004638 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004660 */     // GIR_Coverage, 12618,
     /* 1004660 */     GIR_EraseRootFromParent_Done,
     /* 1004661 */   // Label 14927: @1004661
     /* 1004661 */   GIM_Try, /*On fail goto*//*Label 14928*/ GIMT_Encode4(1004738), // Rule ID 12619 //
     /* 1004666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1004677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1004680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1004683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1004686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004705 */     // MIs[0] policy
     /* 1004705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004715 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4),
     /* 1004718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004737 */     // GIR_Coverage, 12619,
     /* 1004737 */     GIR_EraseRootFromParent_Done,
     /* 1004738 */   // Label 14928: @1004738
     /* 1004738 */   GIM_Try, /*On fail goto*//*Label 14929*/ GIMT_Encode4(1004815), // Rule ID 12622 //
     /* 1004743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1004763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004782 */     // MIs[0] policy
     /* 1004782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004814 */     // GIR_Coverage, 12622,
     /* 1004814 */     GIR_EraseRootFromParent_Done,
     /* 1004815 */   // Label 14929: @1004815
     /* 1004815 */   GIM_Try, /*On fail goto*//*Label 14930*/ GIMT_Encode4(1004892), // Rule ID 12623 //
     /* 1004820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1004831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1004834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1004837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1004840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004859 */     // MIs[0] policy
     /* 1004859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004869 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1004869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1004888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004891 */     // GIR_Coverage, 12623,
     /* 1004891 */     GIR_EraseRootFromParent_Done,
     /* 1004892 */   // Label 14930: @1004892
     /* 1004892 */   GIM_Try, /*On fail goto*//*Label 14931*/ GIMT_Encode4(1004969), // Rule ID 12626 //
     /* 1004897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1004900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1004908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1004911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1004914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1004917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1004920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1004936 */     // MIs[0] policy
     /* 1004936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1004939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1004946 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1004946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1004949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1004951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1004953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1004955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1004957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1004962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1004965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1004967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1004968 */     // GIR_Coverage, 12626,
     /* 1004968 */     GIR_EraseRootFromParent_Done,
     /* 1004969 */   // Label 14931: @1004969
     /* 1004969 */   GIM_Try, /*On fail goto*//*Label 14932*/ GIMT_Encode4(1005046), // Rule ID 12627 //
     /* 1004974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1004977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1004982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1004985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1004988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1004991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1004994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1004997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005013 */     // MIs[0] policy
     /* 1005013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005023 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2),
     /* 1005026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005045 */     // GIR_Coverage, 12627,
     /* 1005045 */     GIR_EraseRootFromParent_Done,
     /* 1005046 */   // Label 14932: @1005046
     /* 1005046 */   GIM_Try, /*On fail goto*//*Label 14933*/ GIMT_Encode4(1005123), // Rule ID 12630 //
     /* 1005051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005090 */     // MIs[0] policy
     /* 1005090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005122 */     // GIR_Coverage, 12630,
     /* 1005122 */     GIR_EraseRootFromParent_Done,
     /* 1005123 */   // Label 14933: @1005123
     /* 1005123 */   GIM_Try, /*On fail goto*//*Label 14934*/ GIMT_Encode4(1005200), // Rule ID 12631 //
     /* 1005128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1005139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1005142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1005145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1005148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005167 */     // MIs[0] policy
     /* 1005167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005177 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005199 */     // GIR_Coverage, 12631,
     /* 1005199 */     GIR_EraseRootFromParent_Done,
     /* 1005200 */   // Label 14934: @1005200
     /* 1005200 */   GIM_Try, /*On fail goto*//*Label 14935*/ GIMT_Encode4(1005277), // Rule ID 12634 //
     /* 1005205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005244 */     // MIs[0] policy
     /* 1005244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005254 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005276 */     // GIR_Coverage, 12634,
     /* 1005276 */     GIR_EraseRootFromParent_Done,
     /* 1005277 */   // Label 14935: @1005277
     /* 1005277 */   GIM_Try, /*On fail goto*//*Label 14936*/ GIMT_Encode4(1005354), // Rule ID 12635 //
     /* 1005282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1005293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1005296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1005299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1005302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005321 */     // MIs[0] policy
     /* 1005321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005331 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1005350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005353 */     // GIR_Coverage, 12635,
     /* 1005353 */     GIR_EraseRootFromParent_Done,
     /* 1005354 */   // Label 14936: @1005354
     /* 1005354 */   GIM_Try, /*On fail goto*//*Label 14937*/ GIMT_Encode4(1005431), // Rule ID 12638 //
     /* 1005359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005398 */     // MIs[0] policy
     /* 1005398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005430 */     // GIR_Coverage, 12638,
     /* 1005430 */     GIR_EraseRootFromParent_Done,
     /* 1005431 */   // Label 14937: @1005431
     /* 1005431 */   GIM_Try, /*On fail goto*//*Label 14938*/ GIMT_Encode4(1005508), // Rule ID 12639 //
     /* 1005436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1005447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1005450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1005453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1005456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005475 */     // MIs[0] policy
     /* 1005475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005485 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1005504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005507 */     // GIR_Coverage, 12639,
     /* 1005507 */     GIR_EraseRootFromParent_Done,
     /* 1005508 */   // Label 14938: @1005508
     /* 1005508 */   GIM_Try, /*On fail goto*//*Label 14939*/ GIMT_Encode4(1005585), // Rule ID 12642 //
     /* 1005513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1005516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1005524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1005527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1005530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1005533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005552 */     // MIs[0] policy
     /* 1005552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005584 */     // GIR_Coverage, 12642,
     /* 1005584 */     GIR_EraseRootFromParent_Done,
     /* 1005585 */   // Label 14939: @1005585
     /* 1005585 */   GIM_Try, /*On fail goto*//*Label 14940*/ GIMT_Encode4(1005662), // Rule ID 12643 //
     /* 1005590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1005593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1005601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1005604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1005607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1005610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1005629 */     // MIs[0] policy
     /* 1005629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005639 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1),
     /* 1005642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1005658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005661 */     // GIR_Coverage, 12643,
     /* 1005661 */     GIR_EraseRootFromParent_Done,
     /* 1005662 */   // Label 14940: @1005662
     /* 1005662 */   GIM_Try, /*On fail goto*//*Label 14941*/ GIMT_Encode4(1005739), // Rule ID 12646 //
     /* 1005667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1005678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1005681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1005684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1005687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005706 */     // MIs[0] policy
     /* 1005706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1005719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005738 */     // GIR_Coverage, 12646,
     /* 1005738 */     GIR_EraseRootFromParent_Done,
     /* 1005739 */   // Label 14941: @1005739
     /* 1005739 */   GIM_Try, /*On fail goto*//*Label 14942*/ GIMT_Encode4(1005816), // Rule ID 12647 //
     /* 1005744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1005755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1005758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1005761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1005764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1005783 */     // MIs[0] policy
     /* 1005783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005793 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1005796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005815 */     // GIR_Coverage, 12647,
     /* 1005815 */     GIR_EraseRootFromParent_Done,
     /* 1005816 */   // Label 14942: @1005816
     /* 1005816 */   GIM_Try, /*On fail goto*//*Label 14943*/ GIMT_Encode4(1005893), // Rule ID 12650 //
     /* 1005821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1005832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1005835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1005841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005860 */     // MIs[0] policy
     /* 1005860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1005870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1005873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005892 */     // GIR_Coverage, 12650,
     /* 1005892 */     GIR_EraseRootFromParent_Done,
     /* 1005893 */   // Label 14943: @1005893
     /* 1005893 */   GIM_Try, /*On fail goto*//*Label 14944*/ GIMT_Encode4(1005970), // Rule ID 12651 //
     /* 1005898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1005901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1005909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1005912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1005915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1005918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1005921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1005937 */     // MIs[0] policy
     /* 1005937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1005940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1005947 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1005947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1005950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1005952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1005954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1005956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1005958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1005963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1005966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1005968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1005969 */     // GIR_Coverage, 12651,
     /* 1005969 */     GIR_EraseRootFromParent_Done,
     /* 1005970 */   // Label 14944: @1005970
     /* 1005970 */   GIM_Try, /*On fail goto*//*Label 14945*/ GIMT_Encode4(1006047), // Rule ID 12654 //
     /* 1005975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1005978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1005983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1005986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1005989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1005992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1005995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1005998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006014 */     // MIs[0] policy
     /* 1006014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006046 */     // GIR_Coverage, 12654,
     /* 1006046 */     GIR_EraseRootFromParent_Done,
     /* 1006047 */   // Label 14945: @1006047
     /* 1006047 */   GIM_Try, /*On fail goto*//*Label 14946*/ GIMT_Encode4(1006124), // Rule ID 12655 //
     /* 1006052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1006063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1006066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1006069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1006072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006091 */     // MIs[0] policy
     /* 1006091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006101 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1006120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006123 */     // GIR_Coverage, 12655,
     /* 1006123 */     GIR_EraseRootFromParent_Done,
     /* 1006124 */   // Label 14946: @1006124
     /* 1006124 */   GIM_Try, /*On fail goto*//*Label 14947*/ GIMT_Encode4(1006201), // Rule ID 12658 //
     /* 1006129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006168 */     // MIs[0] policy
     /* 1006168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006178 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006200 */     // GIR_Coverage, 12658,
     /* 1006200 */     GIR_EraseRootFromParent_Done,
     /* 1006201 */   // Label 14947: @1006201
     /* 1006201 */   GIM_Try, /*On fail goto*//*Label 14948*/ GIMT_Encode4(1006278), // Rule ID 12659 //
     /* 1006206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1006217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1006220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1006223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1006226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006245 */     // MIs[0] policy
     /* 1006245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006255 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006277 */     // GIR_Coverage, 12659,
     /* 1006277 */     GIR_EraseRootFromParent_Done,
     /* 1006278 */   // Label 14948: @1006278
     /* 1006278 */   GIM_Try, /*On fail goto*//*Label 14949*/ GIMT_Encode4(1006355), // Rule ID 12662 //
     /* 1006283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006322 */     // MIs[0] policy
     /* 1006322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006354 */     // GIR_Coverage, 12662,
     /* 1006354 */     GIR_EraseRootFromParent_Done,
     /* 1006355 */   // Label 14949: @1006355
     /* 1006355 */   GIM_Try, /*On fail goto*//*Label 14950*/ GIMT_Encode4(1006432), // Rule ID 12663 //
     /* 1006360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1006371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1006374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1006377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1006380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006399 */     // MIs[0] policy
     /* 1006399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006409 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006431 */     // GIR_Coverage, 12663,
     /* 1006431 */     GIR_EraseRootFromParent_Done,
     /* 1006432 */   // Label 14950: @1006432
     /* 1006432 */   GIM_Try, /*On fail goto*//*Label 14951*/ GIMT_Encode4(1006509), // Rule ID 12666 //
     /* 1006437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1006448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1006451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1006454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1006457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006476 */     // MIs[0] policy
     /* 1006476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006486 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006508 */     // GIR_Coverage, 12666,
     /* 1006508 */     GIR_EraseRootFromParent_Done,
     /* 1006509 */   // Label 14951: @1006509
     /* 1006509 */   GIM_Try, /*On fail goto*//*Label 14952*/ GIMT_Encode4(1006586), // Rule ID 12667 //
     /* 1006514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1006525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1006528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1006531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1006534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006553 */     // MIs[0] policy
     /* 1006553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006563 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1006582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006585 */     // GIR_Coverage, 12667,
     /* 1006585 */     GIR_EraseRootFromParent_Done,
     /* 1006586 */   // Label 14952: @1006586
     /* 1006586 */   GIM_Try, /*On fail goto*//*Label 14953*/ GIMT_Encode4(1006663), // Rule ID 12670 //
     /* 1006591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1006602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1006605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1006611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006630 */     // MIs[0] policy
     /* 1006630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006662 */     // GIR_Coverage, 12670,
     /* 1006662 */     GIR_EraseRootFromParent_Done,
     /* 1006663 */   // Label 14953: @1006663
     /* 1006663 */   GIM_Try, /*On fail goto*//*Label 14954*/ GIMT_Encode4(1006740), // Rule ID 12671 //
     /* 1006668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1006679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1006682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1006685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1006688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1006707 */     // MIs[0] policy
     /* 1006707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006717 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1006720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006739 */     // GIR_Coverage, 12671,
     /* 1006739 */     GIR_EraseRootFromParent_Done,
     /* 1006740 */   // Label 14954: @1006740
     /* 1006740 */   GIM_Try, /*On fail goto*//*Label 14955*/ GIMT_Encode4(1006817), // Rule ID 12674 //
     /* 1006745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1006756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1006759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1006765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006784 */     // MIs[0] policy
     /* 1006784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006794 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006816 */     // GIR_Coverage, 12674,
     /* 1006816 */     GIR_EraseRootFromParent_Done,
     /* 1006817 */   // Label 14955: @1006817
     /* 1006817 */   GIM_Try, /*On fail goto*//*Label 14956*/ GIMT_Encode4(1006894), // Rule ID 12675 //
     /* 1006822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1006833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1006836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1006839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1006842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1006861 */     // MIs[0] policy
     /* 1006861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006871 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1006871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1006874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006893 */     // GIR_Coverage, 12675,
     /* 1006893 */     GIR_EraseRootFromParent_Done,
     /* 1006894 */   // Label 14956: @1006894
     /* 1006894 */   GIM_Try, /*On fail goto*//*Label 14957*/ GIMT_Encode4(1006971), // Rule ID 12678 //
     /* 1006899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1006902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1006910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1006913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1006916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1006919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1006922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1006938 */     // MIs[0] policy
     /* 1006938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1006941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1006948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1006948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1006951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1006953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1006955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1006957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1006959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1006964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1006967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1006969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1006970 */     // GIR_Coverage, 12678,
     /* 1006970 */     GIR_EraseRootFromParent_Done,
     /* 1006971 */   // Label 14957: @1006971
     /* 1006971 */   GIM_Try, /*On fail goto*//*Label 14958*/ GIMT_Encode4(1007048), // Rule ID 12679 //
     /* 1006976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1006979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1006984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1006987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1006990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1006993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1006996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1006999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007015 */     // MIs[0] policy
     /* 1007015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007025 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1007044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007047 */     // GIR_Coverage, 12679,
     /* 1007047 */     GIR_EraseRootFromParent_Done,
     /* 1007048 */   // Label 14958: @1007048
     /* 1007048 */   GIM_Try, /*On fail goto*//*Label 14959*/ GIMT_Encode4(1007125), // Rule ID 12682 //
     /* 1007053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007092 */     // MIs[0] policy
     /* 1007092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007124 */     // GIR_Coverage, 12682,
     /* 1007124 */     GIR_EraseRootFromParent_Done,
     /* 1007125 */   // Label 14959: @1007125
     /* 1007125 */   GIM_Try, /*On fail goto*//*Label 14960*/ GIMT_Encode4(1007202), // Rule ID 12683 //
     /* 1007130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1007141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1007144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1007147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1007150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1007169 */     // MIs[0] policy
     /* 1007169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007179 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2),
     /* 1007182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007201 */     // GIR_Coverage, 12683,
     /* 1007201 */     GIR_EraseRootFromParent_Done,
     /* 1007202 */   // Label 14960: @1007202
     /* 1007202 */   GIM_Try, /*On fail goto*//*Label 14961*/ GIMT_Encode4(1007279), // Rule ID 12686 //
     /* 1007207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007246 */     // MIs[0] policy
     /* 1007246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007256 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007278 */     // GIR_Coverage, 12686,
     /* 1007278 */     GIR_EraseRootFromParent_Done,
     /* 1007279 */   // Label 14961: @1007279
     /* 1007279 */   GIM_Try, /*On fail goto*//*Label 14962*/ GIMT_Encode4(1007356), // Rule ID 12687 //
     /* 1007284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1007295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1007298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1007301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1007304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1007323 */     // MIs[0] policy
     /* 1007323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4),
     /* 1007336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007355 */     // GIR_Coverage, 12687,
     /* 1007355 */     GIR_EraseRootFromParent_Done,
     /* 1007356 */   // Label 14962: @1007356
     /* 1007356 */   GIM_Try, /*On fail goto*//*Label 14963*/ GIMT_Encode4(1007433), // Rule ID 12690 //
     /* 1007361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1007364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007400 */     // MIs[0] policy
     /* 1007400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007410 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007432 */     // GIR_Coverage, 12690,
     /* 1007432 */     GIR_EraseRootFromParent_Done,
     /* 1007433 */   // Label 14963: @1007433
     /* 1007433 */   GIM_Try, /*On fail goto*//*Label 14964*/ GIMT_Encode4(1007510), // Rule ID 12691 //
     /* 1007438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1007441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1007449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1007452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1007455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1007458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1007477 */     // MIs[0] policy
     /* 1007477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007487 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8),
     /* 1007490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1007506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007509 */     // GIR_Coverage, 12691,
     /* 1007509 */     GIR_EraseRootFromParent_Done,
     /* 1007510 */   // Label 14964: @1007510
     /* 1007510 */   GIM_Try, /*On fail goto*//*Label 14965*/ GIMT_Encode4(1007587), // Rule ID 12694 //
     /* 1007515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1007526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1007529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1007532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1007535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007554 */     // MIs[0] policy
     /* 1007554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007564 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1007567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007586 */     // GIR_Coverage, 12694,
     /* 1007586 */     GIR_EraseRootFromParent_Done,
     /* 1007587 */   // Label 14965: @1007587
     /* 1007587 */   GIM_Try, /*On fail goto*//*Label 14966*/ GIMT_Encode4(1007664), // Rule ID 12695 //
     /* 1007592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1007603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1007606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1007609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1007612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007631 */     // MIs[0] policy
     /* 1007631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007641 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8),
     /* 1007644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007663 */     // GIR_Coverage, 12695,
     /* 1007663 */     GIR_EraseRootFromParent_Done,
     /* 1007664 */   // Label 14966: @1007664
     /* 1007664 */   GIM_Try, /*On fail goto*//*Label 14967*/ GIMT_Encode4(1007741), // Rule ID 12698 //
     /* 1007669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1007680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1007683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1007686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1007689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007708 */     // MIs[0] policy
     /* 1007708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1007721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007740 */     // GIR_Coverage, 12698,
     /* 1007740 */     GIR_EraseRootFromParent_Done,
     /* 1007741 */   // Label 14967: @1007741
     /* 1007741 */   GIM_Try, /*On fail goto*//*Label 14968*/ GIMT_Encode4(1007818), // Rule ID 12699 //
     /* 1007746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1007757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1007760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1007763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1007766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007785 */     // MIs[0] policy
     /* 1007785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007795 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1007798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007817 */     // GIR_Coverage, 12699,
     /* 1007817 */     GIR_EraseRootFromParent_Done,
     /* 1007818 */   // Label 14968: @1007818
     /* 1007818 */   GIM_Try, /*On fail goto*//*Label 14969*/ GIMT_Encode4(1007895), // Rule ID 12702 //
     /* 1007823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1007834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1007837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1007840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1007843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1007846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007862 */     // MIs[0] policy
     /* 1007862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007872 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1007872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1007875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007894 */     // GIR_Coverage, 12702,
     /* 1007894 */     GIR_EraseRootFromParent_Done,
     /* 1007895 */   // Label 14969: @1007895
     /* 1007895 */   GIM_Try, /*On fail goto*//*Label 14970*/ GIMT_Encode4(1007972), // Rule ID 12703 //
     /* 1007900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1007903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1007911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1007914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1007917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1007920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1007923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1007935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1007939 */     // MIs[0] policy
     /* 1007939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1007942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1007949 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1007949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1007952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1007954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1007956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1007958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1007960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1007965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1007968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1007970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1007971 */     // GIR_Coverage, 12703,
     /* 1007971 */     GIR_EraseRootFromParent_Done,
     /* 1007972 */   // Label 14970: @1007972
     /* 1007972 */   GIM_Try, /*On fail goto*//*Label 14971*/ GIMT_Encode4(1008049), // Rule ID 12706 //
     /* 1007977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1007980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1007985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1007988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1007991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1007994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1007997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008016 */     // MIs[0] policy
     /* 1008016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008026 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008048 */     // GIR_Coverage, 12706,
     /* 1008048 */     GIR_EraseRootFromParent_Done,
     /* 1008049 */   // Label 14971: @1008049
     /* 1008049 */   GIM_Try, /*On fail goto*//*Label 14972*/ GIMT_Encode4(1008126), // Rule ID 12707 //
     /* 1008054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1008065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1008068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1008074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008093 */     // MIs[0] policy
     /* 1008093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008103 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4),
     /* 1008106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008125 */     // GIR_Coverage, 12707,
     /* 1008125 */     GIR_EraseRootFromParent_Done,
     /* 1008126 */   // Label 14972: @1008126
     /* 1008126 */   GIM_Try, /*On fail goto*//*Label 14973*/ GIMT_Encode4(1008203), // Rule ID 12710 //
     /* 1008131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008170 */     // MIs[0] policy
     /* 1008170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008202 */     // GIR_Coverage, 12710,
     /* 1008202 */     GIR_EraseRootFromParent_Done,
     /* 1008203 */   // Label 14973: @1008203
     /* 1008203 */   GIM_Try, /*On fail goto*//*Label 14974*/ GIMT_Encode4(1008280), // Rule ID 12711 //
     /* 1008208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1008219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1008222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1008228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008247 */     // MIs[0] policy
     /* 1008247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008257 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008279 */     // GIR_Coverage, 12711,
     /* 1008279 */     GIR_EraseRootFromParent_Done,
     /* 1008280 */   // Label 14974: @1008280
     /* 1008280 */   GIM_Try, /*On fail goto*//*Label 14975*/ GIMT_Encode4(1008357), // Rule ID 12714 //
     /* 1008285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008324 */     // MIs[0] policy
     /* 1008324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008356 */     // GIR_Coverage, 12714,
     /* 1008356 */     GIR_EraseRootFromParent_Done,
     /* 1008357 */   // Label 14975: @1008357
     /* 1008357 */   GIM_Try, /*On fail goto*//*Label 14976*/ GIMT_Encode4(1008434), // Rule ID 12715 //
     /* 1008362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1008373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1008376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1008382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008401 */     // MIs[0] policy
     /* 1008401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008411 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2),
     /* 1008414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008433 */     // GIR_Coverage, 12715,
     /* 1008433 */     GIR_EraseRootFromParent_Done,
     /* 1008434 */   // Label 14976: @1008434
     /* 1008434 */   GIM_Try, /*On fail goto*//*Label 14977*/ GIMT_Encode4(1008511), // Rule ID 12718 //
     /* 1008439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1008450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1008453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1008459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008478 */     // MIs[0] policy
     /* 1008478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008488 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008510 */     // GIR_Coverage, 12718,
     /* 1008510 */     GIR_EraseRootFromParent_Done,
     /* 1008511 */   // Label 14977: @1008511
     /* 1008511 */   GIM_Try, /*On fail goto*//*Label 14978*/ GIMT_Encode4(1008588), // Rule ID 12719 //
     /* 1008516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1008527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1008530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1008536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008555 */     // MIs[0] policy
     /* 1008555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008565 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11341:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1008584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008587 */     // GIR_Coverage, 12719,
     /* 1008587 */     GIR_EraseRootFromParent_Done,
     /* 1008588 */   // Label 14978: @1008588
     /* 1008588 */   GIM_Try, /*On fail goto*//*Label 14979*/ GIMT_Encode4(1008665), // Rule ID 12722 //
     /* 1008593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1008604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1008607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1008613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008632 */     // MIs[0] policy
     /* 1008632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008642 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008664 */     // GIR_Coverage, 12722,
     /* 1008664 */     GIR_EraseRootFromParent_Done,
     /* 1008665 */   // Label 14979: @1008665
     /* 1008665 */   GIM_Try, /*On fail goto*//*Label 14980*/ GIMT_Encode4(1008742), // Rule ID 12723 //
     /* 1008670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1008681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1008684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1008690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008709 */     // MIs[0] policy
     /* 1008709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008719 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11341:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1008738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008741 */     // GIR_Coverage, 12723,
     /* 1008741 */     GIR_EraseRootFromParent_Done,
     /* 1008742 */   // Label 14980: @1008742
     /* 1008742 */   GIM_Try, /*On fail goto*//*Label 14981*/ GIMT_Encode4(1008819), // Rule ID 12726 //
     /* 1008747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1008750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1008758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1008761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1008767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008786 */     // MIs[0] policy
     /* 1008786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008818 */     // GIR_Coverage, 12726,
     /* 1008818 */     GIR_EraseRootFromParent_Done,
     /* 1008819 */   // Label 14981: @1008819
     /* 1008819 */   GIM_Try, /*On fail goto*//*Label 14982*/ GIMT_Encode4(1008896), // Rule ID 12727 //
     /* 1008824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1008827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1008835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1008838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1008844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1008847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008863 */     // MIs[0] policy
     /* 1008863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008873 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11341:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1008873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1008892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008895 */     // GIR_Coverage, 12727,
     /* 1008895 */     GIR_EraseRootFromParent_Done,
     /* 1008896 */   // Label 14982: @1008896
     /* 1008896 */   GIM_Try, /*On fail goto*//*Label 14983*/ GIMT_Encode4(1008973), // Rule ID 12730 //
     /* 1008901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1008904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1008918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1008921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1008924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1008936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1008940 */     // MIs[0] policy
     /* 1008940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1008943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1008950 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1008950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1008953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1008955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1008957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1008959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1008961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1008966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1008969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1008971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1008972 */     // GIR_Coverage, 12730,
     /* 1008972 */     GIR_EraseRootFromParent_Done,
     /* 1008973 */   // Label 14983: @1008973
     /* 1008973 */   GIM_Try, /*On fail goto*//*Label 14984*/ GIMT_Encode4(1009050), // Rule ID 12731 //
     /* 1008978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1008981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1008986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1008989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1008992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1008995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1008998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1009017 */     // MIs[0] policy
     /* 1009017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009027 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11341:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1),
     /* 1009030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1009046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009049 */     // GIR_Coverage, 12731,
     /* 1009049 */     GIR_EraseRootFromParent_Done,
     /* 1009050 */   // Label 14984: @1009050
     /* 1009050 */   GIM_Try, /*On fail goto*//*Label 14985*/ GIMT_Encode4(1009127), // Rule ID 12734 //
     /* 1009055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009094 */     // MIs[0] policy
     /* 1009094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009126 */     // GIR_Coverage, 12734,
     /* 1009126 */     GIR_EraseRootFromParent_Done,
     /* 1009127 */   // Label 14985: @1009127
     /* 1009127 */   GIM_Try, /*On fail goto*//*Label 14986*/ GIMT_Encode4(1009204), // Rule ID 12735 //
     /* 1009132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1009143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1009146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1009152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009171 */     // MIs[0] policy
     /* 1009171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009181 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009203 */     // GIR_Coverage, 12735,
     /* 1009203 */     GIR_EraseRootFromParent_Done,
     /* 1009204 */   // Label 14986: @1009204
     /* 1009204 */   GIM_Try, /*On fail goto*//*Label 14987*/ GIMT_Encode4(1009281), // Rule ID 12738 //
     /* 1009209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009248 */     // MIs[0] policy
     /* 1009248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009258 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009280 */     // GIR_Coverage, 12738,
     /* 1009280 */     GIR_EraseRootFromParent_Done,
     /* 1009281 */   // Label 14987: @1009281
     /* 1009281 */   GIM_Try, /*On fail goto*//*Label 14988*/ GIMT_Encode4(1009358), // Rule ID 12739 //
     /* 1009286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1009297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1009300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1009306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009325 */     // MIs[0] policy
     /* 1009325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009335 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009357 */     // GIR_Coverage, 12739,
     /* 1009357 */     GIR_EraseRootFromParent_Done,
     /* 1009358 */   // Label 14988: @1009358
     /* 1009358 */   GIM_Try, /*On fail goto*//*Label 14989*/ GIMT_Encode4(1009435), // Rule ID 12742 //
     /* 1009363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009402 */     // MIs[0] policy
     /* 1009402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009412 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009434 */     // GIR_Coverage, 12742,
     /* 1009434 */     GIR_EraseRootFromParent_Done,
     /* 1009435 */   // Label 14989: @1009435
     /* 1009435 */   GIM_Try, /*On fail goto*//*Label 14990*/ GIMT_Encode4(1009512), // Rule ID 12743 //
     /* 1009440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1009451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1009454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1009460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009479 */     // MIs[0] policy
     /* 1009479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009489 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1009508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009511 */     // GIR_Coverage, 12743,
     /* 1009511 */     GIR_EraseRootFromParent_Done,
     /* 1009512 */   // Label 14990: @1009512
     /* 1009512 */   GIM_Try, /*On fail goto*//*Label 14991*/ GIMT_Encode4(1009589), // Rule ID 12746 //
     /* 1009517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1009528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1009531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1009537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009556 */     // MIs[0] policy
     /* 1009556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009588 */     // GIR_Coverage, 12746,
     /* 1009588 */     GIR_EraseRootFromParent_Done,
     /* 1009589 */   // Label 14991: @1009589
     /* 1009589 */   GIM_Try, /*On fail goto*//*Label 14992*/ GIMT_Encode4(1009666), // Rule ID 12747 //
     /* 1009594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1009605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1009608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1009614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1009633 */     // MIs[0] policy
     /* 1009633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009643 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1009646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009665 */     // GIR_Coverage, 12747,
     /* 1009665 */     GIR_EraseRootFromParent_Done,
     /* 1009666 */   // Label 14992: @1009666
     /* 1009666 */   GIM_Try, /*On fail goto*//*Label 14993*/ GIMT_Encode4(1009743), // Rule ID 12750 //
     /* 1009671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1009682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1009685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1009691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009710 */     // MIs[0] policy
     /* 1009710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009742 */     // GIR_Coverage, 12750,
     /* 1009742 */     GIR_EraseRootFromParent_Done,
     /* 1009743 */   // Label 14993: @1009743
     /* 1009743 */   GIM_Try, /*On fail goto*//*Label 14994*/ GIMT_Encode4(1009820), // Rule ID 12751 //
     /* 1009748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1009759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1009762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1009768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1009787 */     // MIs[0] policy
     /* 1009787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009797 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1009800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009819 */     // GIR_Coverage, 12751,
     /* 1009819 */     GIR_EraseRootFromParent_Done,
     /* 1009820 */   // Label 14994: @1009820
     /* 1009820 */   GIM_Try, /*On fail goto*//*Label 14995*/ GIMT_Encode4(1009897), // Rule ID 12754 //
     /* 1009825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1009836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1009839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1009845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1009848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009864 */     // MIs[0] policy
     /* 1009864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1009874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009896 */     // GIR_Coverage, 12754,
     /* 1009896 */     GIR_EraseRootFromParent_Done,
     /* 1009897 */   // Label 14995: @1009897
     /* 1009897 */   GIM_Try, /*On fail goto*//*Label 14996*/ GIMT_Encode4(1009974), // Rule ID 12755 //
     /* 1009902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1009905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1009913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1009916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1009919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1009922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1009925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1009937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1009941 */     // MIs[0] policy
     /* 1009941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1009944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1009951 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1009951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1009954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1009956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1009958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1009960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1009962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1009967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1009970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1009972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1009973 */     // GIR_Coverage, 12755,
     /* 1009973 */     GIR_EraseRootFromParent_Done,
     /* 1009974 */   // Label 14996: @1009974
     /* 1009974 */   GIM_Try, /*On fail goto*//*Label 14997*/ GIMT_Encode4(1010051), // Rule ID 12758 //
     /* 1009979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1009982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1009987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1009990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1009993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1009996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1009999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010018 */     // MIs[0] policy
     /* 1010018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010050 */     // GIR_Coverage, 12758,
     /* 1010050 */     GIR_EraseRootFromParent_Done,
     /* 1010051 */   // Label 14997: @1010051
     /* 1010051 */   GIM_Try, /*On fail goto*//*Label 14998*/ GIMT_Encode4(1010128), // Rule ID 12759 //
     /* 1010056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1010067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1010070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1010076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010095 */     // MIs[0] policy
     /* 1010095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010105 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010127 */     // GIR_Coverage, 12759,
     /* 1010127 */     GIR_EraseRootFromParent_Done,
     /* 1010128 */   // Label 14998: @1010128
     /* 1010128 */   GIM_Try, /*On fail goto*//*Label 14999*/ GIMT_Encode4(1010205), // Rule ID 12762 //
     /* 1010133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010172 */     // MIs[0] policy
     /* 1010172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010182 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010204 */     // GIR_Coverage, 12762,
     /* 1010204 */     GIR_EraseRootFromParent_Done,
     /* 1010205 */   // Label 14999: @1010205
     /* 1010205 */   GIM_Try, /*On fail goto*//*Label 15000*/ GIMT_Encode4(1010282), // Rule ID 12763 //
     /* 1010210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1010221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1010224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1010230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010249 */     // MIs[0] policy
     /* 1010249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010259 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010281 */     // GIR_Coverage, 12763,
     /* 1010281 */     GIR_EraseRootFromParent_Done,
     /* 1010282 */   // Label 15000: @1010282
     /* 1010282 */   GIM_Try, /*On fail goto*//*Label 15001*/ GIMT_Encode4(1010359), // Rule ID 12766 //
     /* 1010287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010326 */     // MIs[0] policy
     /* 1010326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010336 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010358 */     // GIR_Coverage, 12766,
     /* 1010358 */     GIR_EraseRootFromParent_Done,
     /* 1010359 */   // Label 15001: @1010359
     /* 1010359 */   GIM_Try, /*On fail goto*//*Label 15002*/ GIMT_Encode4(1010436), // Rule ID 12767 //
     /* 1010364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1010375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1010378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1010384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010403 */     // MIs[0] policy
     /* 1010403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010413 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1010432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010435 */     // GIR_Coverage, 12767,
     /* 1010435 */     GIR_EraseRootFromParent_Done,
     /* 1010436 */   // Label 15002: @1010436
     /* 1010436 */   GIM_Try, /*On fail goto*//*Label 15003*/ GIMT_Encode4(1010513), // Rule ID 12770 //
     /* 1010441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1010444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1010452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1010455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1010461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010480 */     // MIs[0] policy
     /* 1010480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010490 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010512 */     // GIR_Coverage, 12770,
     /* 1010512 */     GIR_EraseRootFromParent_Done,
     /* 1010513 */   // Label 15003: @1010513
     /* 1010513 */   GIM_Try, /*On fail goto*//*Label 15004*/ GIMT_Encode4(1010590), // Rule ID 12771 //
     /* 1010518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1010521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1010529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1010532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1010538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1010557 */     // MIs[0] policy
     /* 1010557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11341:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2),
     /* 1010570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010589 */     // GIR_Coverage, 12771,
     /* 1010589 */     GIR_EraseRootFromParent_Done,
     /* 1010590 */   // Label 15004: @1010590
     /* 1010590 */   GIM_Try, /*On fail goto*//*Label 15005*/ GIMT_Encode4(1010667), // Rule ID 12774 //
     /* 1010595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1010598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1010606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1010609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1010615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010634 */     // MIs[0] policy
     /* 1010634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010644 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010666 */     // GIR_Coverage, 12774,
     /* 1010666 */     GIR_EraseRootFromParent_Done,
     /* 1010667 */   // Label 15005: @1010667
     /* 1010667 */   GIM_Try, /*On fail goto*//*Label 15006*/ GIMT_Encode4(1010744), // Rule ID 12775 //
     /* 1010672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1010675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1010683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1010686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1010692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1010711 */     // MIs[0] policy
     /* 1010711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010721 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11341:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4),
     /* 1010724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010743 */     // GIR_Coverage, 12775,
     /* 1010743 */     GIR_EraseRootFromParent_Done,
     /* 1010744 */   // Label 15006: @1010744
     /* 1010744 */   GIM_Try, /*On fail goto*//*Label 15007*/ GIMT_Encode4(1010821), // Rule ID 12778 //
     /* 1010749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1010752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1010760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1010763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1010766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1010769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010788 */     // MIs[0] policy
     /* 1010788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010798 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010820 */     // GIR_Coverage, 12778,
     /* 1010820 */     GIR_EraseRootFromParent_Done,
     /* 1010821 */   // Label 15007: @1010821
     /* 1010821 */   GIM_Try, /*On fail goto*//*Label 15008*/ GIMT_Encode4(1010898), // Rule ID 12779 //
     /* 1010826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1010829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd),
     /* 1010834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1010837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1010840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1010843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1010846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1010849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1010861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1010865 */     // MIs[0] policy
     /* 1010865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010875 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11341:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1010875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8),
     /* 1010878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1010894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010897 */     // GIR_Coverage, 12779,
     /* 1010897 */     GIR_EraseRootFromParent_Done,
     /* 1010898 */   // Label 15008: @1010898
     /* 1010898 */   GIM_Try, /*On fail goto*//*Label 15009*/ GIMT_Encode4(1010975), // Rule ID 12782 //
     /* 1010903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1010906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1010911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1010914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1010917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1010920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1010923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1010926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1010942 */     // MIs[0] policy
     /* 1010942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1010945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1010952 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1010952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1010955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1010957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1010959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1010961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1010963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1010968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1010971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1010973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1010974 */     // GIR_Coverage, 12782,
     /* 1010974 */     GIR_EraseRootFromParent_Done,
     /* 1010975 */   // Label 15009: @1010975
     /* 1010975 */   GIM_Try, /*On fail goto*//*Label 15010*/ GIMT_Encode4(1011052), // Rule ID 12783 //
     /* 1010980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1010983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1010988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1010991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1010994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1010997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1011000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011019 */     // MIs[0] policy
     /* 1011019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011029 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8),
     /* 1011032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011051 */     // GIR_Coverage, 12783,
     /* 1011051 */     GIR_EraseRootFromParent_Done,
     /* 1011052 */   // Label 15010: @1011052
     /* 1011052 */   GIM_Try, /*On fail goto*//*Label 15011*/ GIMT_Encode4(1011129), // Rule ID 12786 //
     /* 1011057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011096 */     // MIs[0] policy
     /* 1011096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011106 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011128 */     // GIR_Coverage, 12786,
     /* 1011128 */     GIR_EraseRootFromParent_Done,
     /* 1011129 */   // Label 15011: @1011129
     /* 1011129 */   GIM_Try, /*On fail goto*//*Label 15012*/ GIMT_Encode4(1011206), // Rule ID 12787 //
     /* 1011134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1011145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1011148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1011151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1011154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011173 */     // MIs[0] policy
     /* 1011173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011183 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011205 */     // GIR_Coverage, 12787,
     /* 1011205 */     GIR_EraseRootFromParent_Done,
     /* 1011206 */   // Label 15012: @1011206
     /* 1011206 */   GIM_Try, /*On fail goto*//*Label 15013*/ GIMT_Encode4(1011283), // Rule ID 12790 //
     /* 1011211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011250 */     // MIs[0] policy
     /* 1011250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011260 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011282 */     // GIR_Coverage, 12790,
     /* 1011282 */     GIR_EraseRootFromParent_Done,
     /* 1011283 */   // Label 15013: @1011283
     /* 1011283 */   GIM_Try, /*On fail goto*//*Label 15014*/ GIMT_Encode4(1011360), // Rule ID 12791 //
     /* 1011288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1011299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1011302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1011305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1011308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011327 */     // MIs[0] policy
     /* 1011327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011337 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011359 */     // GIR_Coverage, 12791,
     /* 1011359 */     GIR_EraseRootFromParent_Done,
     /* 1011360 */   // Label 15014: @1011360
     /* 1011360 */   GIM_Try, /*On fail goto*//*Label 15015*/ GIMT_Encode4(1011437), // Rule ID 12794 //
     /* 1011365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011404 */     // MIs[0] policy
     /* 1011404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011436 */     // GIR_Coverage, 12794,
     /* 1011436 */     GIR_EraseRootFromParent_Done,
     /* 1011437 */   // Label 15015: @1011437
     /* 1011437 */   GIM_Try, /*On fail goto*//*Label 15016*/ GIMT_Encode4(1011514), // Rule ID 12795 //
     /* 1011442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1011453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1011456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1011459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1011462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011481 */     // MIs[0] policy
     /* 1011481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011491 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4),
     /* 1011494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011513 */     // GIR_Coverage, 12795,
     /* 1011513 */     GIR_EraseRootFromParent_Done,
     /* 1011514 */   // Label 15016: @1011514
     /* 1011514 */   GIM_Try, /*On fail goto*//*Label 15017*/ GIMT_Encode4(1011591), // Rule ID 12798 //
     /* 1011519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1011530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1011533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1011536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1011539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011558 */     // MIs[0] policy
     /* 1011558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011590 */     // GIR_Coverage, 12798,
     /* 1011590 */     GIR_EraseRootFromParent_Done,
     /* 1011591 */   // Label 15017: @1011591
     /* 1011591 */   GIM_Try, /*On fail goto*//*Label 15018*/ GIMT_Encode4(1011668), // Rule ID 12799 //
     /* 1011596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1011607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1011610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1011613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1011616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011635 */     // MIs[0] policy
     /* 1011635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011645 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1011664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011667 */     // GIR_Coverage, 12799,
     /* 1011667 */     GIR_EraseRootFromParent_Done,
     /* 1011668 */   // Label 15018: @1011668
     /* 1011668 */   GIM_Try, /*On fail goto*//*Label 15019*/ GIMT_Encode4(1011745), // Rule ID 12802 //
     /* 1011673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1011684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1011687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1011690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1011693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011712 */     // MIs[0] policy
     /* 1011712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011744 */     // GIR_Coverage, 12802,
     /* 1011744 */     GIR_EraseRootFromParent_Done,
     /* 1011745 */   // Label 15019: @1011745
     /* 1011745 */   GIM_Try, /*On fail goto*//*Label 15020*/ GIMT_Encode4(1011822), // Rule ID 12803 //
     /* 1011750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1011761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1011764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1011767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1011770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011789 */     // MIs[0] policy
     /* 1011789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011799 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2),
     /* 1011802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1011818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011821 */     // GIR_Coverage, 12803,
     /* 1011821 */     GIR_EraseRootFromParent_Done,
     /* 1011822 */   // Label 15020: @1011822
     /* 1011822 */   GIM_Try, /*On fail goto*//*Label 15021*/ GIMT_Encode4(1011899), // Rule ID 12806 //
     /* 1011827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1011838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1011841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1011844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1011847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1011850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011866 */     // MIs[0] policy
     /* 1011866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011876 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1011876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1011879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011898 */     // GIR_Coverage, 12806,
     /* 1011898 */     GIR_EraseRootFromParent_Done,
     /* 1011899 */   // Label 15021: @1011899
     /* 1011899 */   GIM_Try, /*On fail goto*//*Label 15022*/ GIMT_Encode4(1011976), // Rule ID 12807 //
     /* 1011904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1011907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1011915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1011918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1011921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1011924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1011927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1011943 */     // MIs[0] policy
     /* 1011943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1011946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1011953 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1011953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1011956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1011958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1011960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1011962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1011964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1011969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1011972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1011974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1011975 */     // GIR_Coverage, 12807,
     /* 1011975 */     GIR_EraseRootFromParent_Done,
     /* 1011976 */   // Label 15022: @1011976
     /* 1011976 */   GIM_Try, /*On fail goto*//*Label 15023*/ GIMT_Encode4(1012053), // Rule ID 12810 //
     /* 1011981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1011984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1011989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1011992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1011995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1011998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012020 */     // MIs[0] policy
     /* 1012020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012030 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012052 */     // GIR_Coverage, 12810,
     /* 1012052 */     GIR_EraseRootFromParent_Done,
     /* 1012053 */   // Label 15023: @1012053
     /* 1012053 */   GIM_Try, /*On fail goto*//*Label 15024*/ GIMT_Encode4(1012130), // Rule ID 12811 //
     /* 1012058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1012069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1012072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1012075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1012078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012097 */     // MIs[0] policy
     /* 1012097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012129 */     // GIR_Coverage, 12811,
     /* 1012129 */     GIR_EraseRootFromParent_Done,
     /* 1012130 */   // Label 15024: @1012130
     /* 1012130 */   GIM_Try, /*On fail goto*//*Label 15025*/ GIMT_Encode4(1012207), // Rule ID 12814 //
     /* 1012135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012174 */     // MIs[0] policy
     /* 1012174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012184 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012206 */     // GIR_Coverage, 12814,
     /* 1012206 */     GIR_EraseRootFromParent_Done,
     /* 1012207 */   // Label 15025: @1012207
     /* 1012207 */   GIM_Try, /*On fail goto*//*Label 15026*/ GIMT_Encode4(1012284), // Rule ID 12815 //
     /* 1012212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1012223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1012226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1012229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1012232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012251 */     // MIs[0] policy
     /* 1012251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012261 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1012280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012283 */     // GIR_Coverage, 12815,
     /* 1012283 */     GIR_EraseRootFromParent_Done,
     /* 1012284 */   // Label 15026: @1012284
     /* 1012284 */   GIM_Try, /*On fail goto*//*Label 15027*/ GIMT_Encode4(1012361), // Rule ID 12818 //
     /* 1012289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1012292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012328 */     // MIs[0] policy
     /* 1012328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012360 */     // GIR_Coverage, 12818,
     /* 1012360 */     GIR_EraseRootFromParent_Done,
     /* 1012361 */   // Label 15027: @1012361
     /* 1012361 */   GIM_Try, /*On fail goto*//*Label 15028*/ GIMT_Encode4(1012438), // Rule ID 12819 //
     /* 1012366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1012369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1012377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1012380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1012383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1012386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1012405 */     // MIs[0] policy
     /* 1012405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012415 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1),
     /* 1012418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1012434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012437 */     // GIR_Coverage, 12819,
     /* 1012437 */     GIR_EraseRootFromParent_Done,
     /* 1012438 */   // Label 15028: @1012438
     /* 1012438 */   GIM_Try, /*On fail goto*//*Label 15029*/ GIMT_Encode4(1012515), // Rule ID 12822 //
     /* 1012443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1012454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1012457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1012460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1012463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012482 */     // MIs[0] policy
     /* 1012482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1012495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012514 */     // GIR_Coverage, 12822,
     /* 1012514 */     GIR_EraseRootFromParent_Done,
     /* 1012515 */   // Label 15029: @1012515
     /* 1012515 */   GIM_Try, /*On fail goto*//*Label 15030*/ GIMT_Encode4(1012592), // Rule ID 12823 //
     /* 1012520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1012531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1012534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1012537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1012540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012559 */     // MIs[0] policy
     /* 1012559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012569 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1012572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012574 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012591 */     // GIR_Coverage, 12823,
     /* 1012591 */     GIR_EraseRootFromParent_Done,
     /* 1012592 */   // Label 15030: @1012592
     /* 1012592 */   GIM_Try, /*On fail goto*//*Label 15031*/ GIMT_Encode4(1012669), // Rule ID 12826 //
     /* 1012597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1012608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1012611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1012614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1012617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012636 */     // MIs[0] policy
     /* 1012636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1012649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012668 */     // GIR_Coverage, 12826,
     /* 1012668 */     GIR_EraseRootFromParent_Done,
     /* 1012669 */   // Label 15031: @1012669
     /* 1012669 */   GIM_Try, /*On fail goto*//*Label 15032*/ GIMT_Encode4(1012746), // Rule ID 12827 //
     /* 1012674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1012685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1012688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1012691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1012694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1012713 */     // MIs[0] policy
     /* 1012713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012723 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1012726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012745 */     // GIR_Coverage, 12827,
     /* 1012745 */     GIR_EraseRootFromParent_Done,
     /* 1012746 */   // Label 15032: @1012746
     /* 1012746 */   GIM_Try, /*On fail goto*//*Label 15033*/ GIMT_Encode4(1012823), // Rule ID 12830 //
     /* 1012751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1012762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1012765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1012768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1012771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012790 */     // MIs[0] policy
     /* 1012790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012800 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1012803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012822 */     // GIR_Coverage, 12830,
     /* 1012822 */     GIR_EraseRootFromParent_Done,
     /* 1012823 */   // Label 15033: @1012823
     /* 1012823 */   GIM_Try, /*On fail goto*//*Label 15034*/ GIMT_Encode4(1012900), // Rule ID 12831 //
     /* 1012828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1012839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1012842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1012845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1012848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1012851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1012867 */     // MIs[0] policy
     /* 1012867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012877 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1012877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1012880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1012896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012899 */     // GIR_Coverage, 12831,
     /* 1012899 */     GIR_EraseRootFromParent_Done,
     /* 1012900 */   // Label 15034: @1012900
     /* 1012900 */   GIM_Try, /*On fail goto*//*Label 15035*/ GIMT_Encode4(1012977), // Rule ID 12834 //
     /* 1012905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1012908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1012916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1012919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1012922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1012925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1012928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1012944 */     // MIs[0] policy
     /* 1012944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1012947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1012954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1012954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1012957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1012959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1012961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1012963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1012965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1012970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1012973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1012975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1012976 */     // GIR_Coverage, 12834,
     /* 1012976 */     GIR_EraseRootFromParent_Done,
     /* 1012977 */   // Label 15035: @1012977
     /* 1012977 */   GIM_Try, /*On fail goto*//*Label 15036*/ GIMT_Encode4(1013054), // Rule ID 12835 //
     /* 1012982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1012985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1012990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1012993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1012996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1012999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1013002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013021 */     // MIs[0] policy
     /* 1013021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013031 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013053 */     // GIR_Coverage, 12835,
     /* 1013053 */     GIR_EraseRootFromParent_Done,
     /* 1013054 */   // Label 15036: @1013054
     /* 1013054 */   GIM_Try, /*On fail goto*//*Label 15037*/ GIMT_Encode4(1013131), // Rule ID 12838 //
     /* 1013059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013098 */     // MIs[0] policy
     /* 1013098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013108 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013130 */     // GIR_Coverage, 12838,
     /* 1013130 */     GIR_EraseRootFromParent_Done,
     /* 1013131 */   // Label 15037: @1013131
     /* 1013131 */   GIM_Try, /*On fail goto*//*Label 15038*/ GIMT_Encode4(1013208), // Rule ID 12839 //
     /* 1013136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1013147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1013150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1013153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1013156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013175 */     // MIs[0] policy
     /* 1013175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013185 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013207 */     // GIR_Coverage, 12839,
     /* 1013207 */     GIR_EraseRootFromParent_Done,
     /* 1013208 */   // Label 15038: @1013208
     /* 1013208 */   GIM_Try, /*On fail goto*//*Label 15039*/ GIMT_Encode4(1013285), // Rule ID 12842 //
     /* 1013213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013252 */     // MIs[0] policy
     /* 1013252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013284 */     // GIR_Coverage, 12842,
     /* 1013284 */     GIR_EraseRootFromParent_Done,
     /* 1013285 */   // Label 15039: @1013285
     /* 1013285 */   GIM_Try, /*On fail goto*//*Label 15040*/ GIMT_Encode4(1013362), // Rule ID 12843 //
     /* 1013290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1013301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1013304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1013307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1013310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013329 */     // MIs[0] policy
     /* 1013329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013339 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1013358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013361 */     // GIR_Coverage, 12843,
     /* 1013361 */     GIR_EraseRootFromParent_Done,
     /* 1013362 */   // Label 15040: @1013362
     /* 1013362 */   GIM_Try, /*On fail goto*//*Label 15041*/ GIMT_Encode4(1013439), // Rule ID 12846 //
     /* 1013367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013406 */     // MIs[0] policy
     /* 1013406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013438 */     // GIR_Coverage, 12846,
     /* 1013438 */     GIR_EraseRootFromParent_Done,
     /* 1013439 */   // Label 15041: @1013439
     /* 1013439 */   GIM_Try, /*On fail goto*//*Label 15042*/ GIMT_Encode4(1013516), // Rule ID 12847 //
     /* 1013444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1013455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1013458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1013461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1013464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013483 */     // MIs[0] policy
     /* 1013483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013515 */     // GIR_Coverage, 12847,
     /* 1013515 */     GIR_EraseRootFromParent_Done,
     /* 1013516 */   // Label 15042: @1013516
     /* 1013516 */   GIM_Try, /*On fail goto*//*Label 15043*/ GIMT_Encode4(1013593), // Rule ID 12850 //
     /* 1013521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1013532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1013535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1013538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1013541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013560 */     // MIs[0] policy
     /* 1013560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013570 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013592 */     // GIR_Coverage, 12850,
     /* 1013592 */     GIR_EraseRootFromParent_Done,
     /* 1013593 */   // Label 15043: @1013593
     /* 1013593 */   GIM_Try, /*On fail goto*//*Label 15044*/ GIMT_Encode4(1013670), // Rule ID 12851 //
     /* 1013598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1013609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1013612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1013615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1013618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1013637 */     // MIs[0] policy
     /* 1013637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013647 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1013650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013669 */     // GIR_Coverage, 12851,
     /* 1013669 */     GIR_EraseRootFromParent_Done,
     /* 1013670 */   // Label 15044: @1013670
     /* 1013670 */   GIM_Try, /*On fail goto*//*Label 15045*/ GIMT_Encode4(1013747), // Rule ID 12854 //
     /* 1013675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1013678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1013686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1013689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1013692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1013695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013714 */     // MIs[0] policy
     /* 1013714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013746 */     // GIR_Coverage, 12854,
     /* 1013746 */     GIR_EraseRootFromParent_Done,
     /* 1013747 */   // Label 15045: @1013747
     /* 1013747 */   GIM_Try, /*On fail goto*//*Label 15046*/ GIMT_Encode4(1013824), // Rule ID 12855 //
     /* 1013752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1013755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1013763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1013766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1013769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1013772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1013791 */     // MIs[0] policy
     /* 1013791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013801 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1013804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1013820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013823 */     // GIR_Coverage, 12855,
     /* 1013823 */     GIR_EraseRootFromParent_Done,
     /* 1013824 */   // Label 15046: @1013824
     /* 1013824 */   GIM_Try, /*On fail goto*//*Label 15047*/ GIMT_Encode4(1013901), // Rule ID 12858 //
     /* 1013829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1013840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1013843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1013846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1013849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1013852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013868 */     // MIs[0] policy
     /* 1013868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1013878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013900 */     // GIR_Coverage, 12858,
     /* 1013900 */     GIR_EraseRootFromParent_Done,
     /* 1013901 */   // Label 15047: @1013901
     /* 1013901 */   GIM_Try, /*On fail goto*//*Label 15048*/ GIMT_Encode4(1013978), // Rule ID 12859 //
     /* 1013906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1013909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1013917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1013920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1013923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1013926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1013929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1013945 */     // MIs[0] policy
     /* 1013945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1013948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1013955 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1013955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2),
     /* 1013958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1013960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1013962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1013964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1013966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1013971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1013974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1013976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1013977 */     // GIR_Coverage, 12859,
     /* 1013977 */     GIR_EraseRootFromParent_Done,
     /* 1013978 */   // Label 15048: @1013978
     /* 1013978 */   GIM_Try, /*On fail goto*//*Label 15049*/ GIMT_Encode4(1014055), // Rule ID 12862 //
     /* 1013983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1013986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1013991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1013994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1013997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014022 */     // MIs[0] policy
     /* 1014022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014032 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014054 */     // GIR_Coverage, 12862,
     /* 1014054 */     GIR_EraseRootFromParent_Done,
     /* 1014055 */   // Label 15049: @1014055
     /* 1014055 */   GIM_Try, /*On fail goto*//*Label 15050*/ GIMT_Encode4(1014132), // Rule ID 12863 //
     /* 1014060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1014071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1014074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1014077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1014080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1014099 */     // MIs[0] policy
     /* 1014099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014109 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4),
     /* 1014112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014131 */     // GIR_Coverage, 12863,
     /* 1014131 */     GIR_EraseRootFromParent_Done,
     /* 1014132 */   // Label 15050: @1014132
     /* 1014132 */   GIM_Try, /*On fail goto*//*Label 15051*/ GIMT_Encode4(1014209), // Rule ID 12866 //
     /* 1014137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1014140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014176 */     // MIs[0] policy
     /* 1014176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014186 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014208 */     // GIR_Coverage, 12866,
     /* 1014208 */     GIR_EraseRootFromParent_Done,
     /* 1014209 */   // Label 15051: @1014209
     /* 1014209 */   GIM_Try, /*On fail goto*//*Label 15052*/ GIMT_Encode4(1014286), // Rule ID 12867 //
     /* 1014214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1014217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1014225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1014228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1014231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1014234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1014253 */     // MIs[0] policy
     /* 1014253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014263 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8),
     /* 1014266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1014282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014285 */     // GIR_Coverage, 12867,
     /* 1014285 */     GIR_EraseRootFromParent_Done,
     /* 1014286 */   // Label 15052: @1014286
     /* 1014286 */   GIM_Try, /*On fail goto*//*Label 15053*/ GIMT_Encode4(1014363), // Rule ID 12870 //
     /* 1014291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014330 */     // MIs[0] policy
     /* 1014330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014340 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014362 */     // GIR_Coverage, 12870,
     /* 1014362 */     GIR_EraseRootFromParent_Done,
     /* 1014363 */   // Label 15053: @1014363
     /* 1014363 */   GIM_Try, /*On fail goto*//*Label 15054*/ GIMT_Encode4(1014440), // Rule ID 12871 //
     /* 1014368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1014379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1014382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1014388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014407 */     // MIs[0] policy
     /* 1014407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014417 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8),
     /* 1014420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014439 */     // GIR_Coverage, 12871,
     /* 1014439 */     GIR_EraseRootFromParent_Done,
     /* 1014440 */   // Label 15054: @1014440
     /* 1014440 */   GIM_Try, /*On fail goto*//*Label 15055*/ GIMT_Encode4(1014517), // Rule ID 12874 //
     /* 1014445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1014456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1014459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1014465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014484 */     // MIs[0] policy
     /* 1014484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014494 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1014497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014516 */     // GIR_Coverage, 12874,
     /* 1014516 */     GIR_EraseRootFromParent_Done,
     /* 1014517 */   // Label 15055: @1014517
     /* 1014517 */   GIM_Try, /*On fail goto*//*Label 15056*/ GIMT_Encode4(1014594), // Rule ID 12875 //
     /* 1014522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1014533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1014536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1014542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014561 */     // MIs[0] policy
     /* 1014561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014571 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1014574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014593 */     // GIR_Coverage, 12875,
     /* 1014593 */     GIR_EraseRootFromParent_Done,
     /* 1014594 */   // Label 15056: @1014594
     /* 1014594 */   GIM_Try, /*On fail goto*//*Label 15057*/ GIMT_Encode4(1014671), // Rule ID 12878 //
     /* 1014599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1014610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1014613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1014619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014638 */     // MIs[0] policy
     /* 1014638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014648 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1014651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014670 */     // GIR_Coverage, 12878,
     /* 1014670 */     GIR_EraseRootFromParent_Done,
     /* 1014671 */   // Label 15057: @1014671
     /* 1014671 */   GIM_Try, /*On fail goto*//*Label 15058*/ GIMT_Encode4(1014748), // Rule ID 12879 //
     /* 1014676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1014687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1014690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1014696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014715 */     // MIs[0] policy
     /* 1014715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014725 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1014728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1014744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014747 */     // GIR_Coverage, 12879,
     /* 1014747 */     GIR_EraseRootFromParent_Done,
     /* 1014748 */   // Label 15058: @1014748
     /* 1014748 */   GIM_Try, /*On fail goto*//*Label 15059*/ GIMT_Encode4(1014825), // Rule ID 12882 //
     /* 1014753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1014764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1014767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1014773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014792 */     // MIs[0] policy
     /* 1014792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014802 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1014805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014824 */     // GIR_Coverage, 12882,
     /* 1014824 */     GIR_EraseRootFromParent_Done,
     /* 1014825 */   // Label 15059: @1014825
     /* 1014825 */   GIM_Try, /*On fail goto*//*Label 15060*/ GIMT_Encode4(1014902), // Rule ID 12883 //
     /* 1014830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1014841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1014844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1014847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1014850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1014853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014869 */     // MIs[0] policy
     /* 1014869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014879 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1014879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4),
     /* 1014882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014901 */     // GIR_Coverage, 12883,
     /* 1014901 */     GIR_EraseRootFromParent_Done,
     /* 1014902 */   // Label 15060: @1014902
     /* 1014902 */   GIM_Try, /*On fail goto*//*Label 15061*/ GIMT_Encode4(1014979), // Rule ID 12886 //
     /* 1014907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1014910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1014918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1014921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1014924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1014927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1014930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1014942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1014946 */     // MIs[0] policy
     /* 1014946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1014949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1014956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1014956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1014959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1014961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1014963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1014965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1014967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1014972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1014975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1014977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1014978 */     // GIR_Coverage, 12886,
     /* 1014978 */     GIR_EraseRootFromParent_Done,
     /* 1014979 */   // Label 15061: @1014979
     /* 1014979 */   GIM_Try, /*On fail goto*//*Label 15062*/ GIMT_Encode4(1015056), // Rule ID 12887 //
     /* 1014984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1014987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1014992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1014995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1014998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1015004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015023 */     // MIs[0] policy
     /* 1015023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015033 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015055 */     // GIR_Coverage, 12887,
     /* 1015055 */     GIR_EraseRootFromParent_Done,
     /* 1015056 */   // Label 15062: @1015056
     /* 1015056 */   GIM_Try, /*On fail goto*//*Label 15063*/ GIMT_Encode4(1015133), // Rule ID 12890 //
     /* 1015061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015100 */     // MIs[0] policy
     /* 1015100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015132 */     // GIR_Coverage, 12890,
     /* 1015132 */     GIR_EraseRootFromParent_Done,
     /* 1015133 */   // Label 15063: @1015133
     /* 1015133 */   GIM_Try, /*On fail goto*//*Label 15064*/ GIMT_Encode4(1015210), // Rule ID 12891 //
     /* 1015138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1015149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1015152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1015158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015177 */     // MIs[0] policy
     /* 1015177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015187 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2),
     /* 1015190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015209 */     // GIR_Coverage, 12891,
     /* 1015209 */     GIR_EraseRootFromParent_Done,
     /* 1015210 */   // Label 15064: @1015210
     /* 1015210 */   GIM_Try, /*On fail goto*//*Label 15065*/ GIMT_Encode4(1015287), // Rule ID 12894 //
     /* 1015215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015254 */     // MIs[0] policy
     /* 1015254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015286 */     // GIR_Coverage, 12894,
     /* 1015286 */     GIR_EraseRootFromParent_Done,
     /* 1015287 */   // Label 15065: @1015287
     /* 1015287 */   GIM_Try, /*On fail goto*//*Label 15066*/ GIMT_Encode4(1015364), // Rule ID 12895 //
     /* 1015292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1015303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1015306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1015312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015331 */     // MIs[0] policy
     /* 1015331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015341 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11420:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015363 */     // GIR_Coverage, 12895,
     /* 1015363 */     GIR_EraseRootFromParent_Done,
     /* 1015364 */   // Label 15066: @1015364
     /* 1015364 */   GIM_Try, /*On fail goto*//*Label 15067*/ GIMT_Encode4(1015441), // Rule ID 12898 //
     /* 1015369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015408 */     // MIs[0] policy
     /* 1015408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015440 */     // GIR_Coverage, 12898,
     /* 1015440 */     GIR_EraseRootFromParent_Done,
     /* 1015441 */   // Label 15067: @1015441
     /* 1015441 */   GIM_Try, /*On fail goto*//*Label 15068*/ GIMT_Encode4(1015518), // Rule ID 12899 //
     /* 1015446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1015457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1015460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1015466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015485 */     // MIs[0] policy
     /* 1015485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015495 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11420:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1015514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015517 */     // GIR_Coverage, 12899,
     /* 1015517 */     GIR_EraseRootFromParent_Done,
     /* 1015518 */   // Label 15068: @1015518
     /* 1015518 */   GIM_Try, /*On fail goto*//*Label 15069*/ GIMT_Encode4(1015595), // Rule ID 12902 //
     /* 1015523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1015534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1015537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1015543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015562 */     // MIs[0] policy
     /* 1015562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015572 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015594 */     // GIR_Coverage, 12902,
     /* 1015594 */     GIR_EraseRootFromParent_Done,
     /* 1015595 */   // Label 15069: @1015595
     /* 1015595 */   GIM_Try, /*On fail goto*//*Label 15070*/ GIMT_Encode4(1015672), // Rule ID 12903 //
     /* 1015600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1015611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1015614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1015620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015639 */     // MIs[0] policy
     /* 1015639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015649 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11420:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015654 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1015668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015671 */     // GIR_Coverage, 12903,
     /* 1015671 */     GIR_EraseRootFromParent_Done,
     /* 1015672 */   // Label 15070: @1015672
     /* 1015672 */   GIM_Try, /*On fail goto*//*Label 15071*/ GIMT_Encode4(1015749), // Rule ID 12906 //
     /* 1015677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1015680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1015688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1015691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1015697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015716 */     // MIs[0] policy
     /* 1015716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015748 */     // GIR_Coverage, 12906,
     /* 1015748 */     GIR_EraseRootFromParent_Done,
     /* 1015749 */   // Label 15071: @1015749
     /* 1015749 */   GIM_Try, /*On fail goto*//*Label 15072*/ GIMT_Encode4(1015826), // Rule ID 12907 //
     /* 1015754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1015757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1015765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1015768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1015774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1015793 */     // MIs[0] policy
     /* 1015793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015803 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11420:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1),
     /* 1015806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1015822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015825 */     // GIR_Coverage, 12907,
     /* 1015825 */     GIR_EraseRootFromParent_Done,
     /* 1015826 */   // Label 15072: @1015826
     /* 1015826 */   GIM_Try, /*On fail goto*//*Label 15073*/ GIMT_Encode4(1015903), // Rule ID 12910 //
     /* 1015831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1015842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1015845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1015848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1015851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1015854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015870 */     // MIs[0] policy
     /* 1015870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015880 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1015880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1015883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015902 */     // GIR_Coverage, 12910,
     /* 1015902 */     GIR_EraseRootFromParent_Done,
     /* 1015903 */   // Label 15073: @1015903
     /* 1015903 */   GIM_Try, /*On fail goto*//*Label 15074*/ GIMT_Encode4(1015980), // Rule ID 12911 //
     /* 1015908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1015911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1015919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1015922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1015925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1015928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1015931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1015943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1015947 */     // MIs[0] policy
     /* 1015947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1015950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1015957 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1015957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1015960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1015962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1015964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1015966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1015968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1015973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1015976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1015978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1015979 */     // GIR_Coverage, 12911,
     /* 1015979 */     GIR_EraseRootFromParent_Done,
     /* 1015980 */   // Label 15074: @1015980
     /* 1015980 */   GIM_Try, /*On fail goto*//*Label 15075*/ GIMT_Encode4(1016057), // Rule ID 12914 //
     /* 1015985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1015988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1015993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1015996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1015999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016024 */     // MIs[0] policy
     /* 1016024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016034 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016056 */     // GIR_Coverage, 12914,
     /* 1016056 */     GIR_EraseRootFromParent_Done,
     /* 1016057 */   // Label 15075: @1016057
     /* 1016057 */   GIM_Try, /*On fail goto*//*Label 15076*/ GIMT_Encode4(1016134), // Rule ID 12915 //
     /* 1016062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1016073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1016076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1016082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016101 */     // MIs[0] policy
     /* 1016101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016111 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016133 */     // GIR_Coverage, 12915,
     /* 1016133 */     GIR_EraseRootFromParent_Done,
     /* 1016134 */   // Label 15076: @1016134
     /* 1016134 */   GIM_Try, /*On fail goto*//*Label 15077*/ GIMT_Encode4(1016211), // Rule ID 12918 //
     /* 1016139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016178 */     // MIs[0] policy
     /* 1016178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016188 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016210 */     // GIR_Coverage, 12918,
     /* 1016210 */     GIR_EraseRootFromParent_Done,
     /* 1016211 */   // Label 15077: @1016211
     /* 1016211 */   GIM_Try, /*On fail goto*//*Label 15078*/ GIMT_Encode4(1016288), // Rule ID 12919 //
     /* 1016216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1016227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1016230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1016236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016255 */     // MIs[0] policy
     /* 1016255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016265 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1016284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016287 */     // GIR_Coverage, 12919,
     /* 1016287 */     GIR_EraseRootFromParent_Done,
     /* 1016288 */   // Label 15078: @1016288
     /* 1016288 */   GIM_Try, /*On fail goto*//*Label 15079*/ GIMT_Encode4(1016365), // Rule ID 12922 //
     /* 1016293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016332 */     // MIs[0] policy
     /* 1016332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016342 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016364 */     // GIR_Coverage, 12922,
     /* 1016364 */     GIR_EraseRootFromParent_Done,
     /* 1016365 */   // Label 15079: @1016365
     /* 1016365 */   GIM_Try, /*On fail goto*//*Label 15080*/ GIMT_Encode4(1016442), // Rule ID 12923 //
     /* 1016370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1016381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1016384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1016390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016409 */     // MIs[0] policy
     /* 1016409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016441 */     // GIR_Coverage, 12923,
     /* 1016441 */     GIR_EraseRootFromParent_Done,
     /* 1016442 */   // Label 15080: @1016442
     /* 1016442 */   GIM_Try, /*On fail goto*//*Label 15081*/ GIMT_Encode4(1016519), // Rule ID 12926 //
     /* 1016447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1016458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1016461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1016467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016486 */     // MIs[0] policy
     /* 1016486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016518 */     // GIR_Coverage, 12926,
     /* 1016518 */     GIR_EraseRootFromParent_Done,
     /* 1016519 */   // Label 15081: @1016519
     /* 1016519 */   GIM_Try, /*On fail goto*//*Label 15082*/ GIMT_Encode4(1016596), // Rule ID 12927 //
     /* 1016524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1016535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1016538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1016544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016563 */     // MIs[0] policy
     /* 1016563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016573 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016595 */     // GIR_Coverage, 12927,
     /* 1016595 */     GIR_EraseRootFromParent_Done,
     /* 1016596 */   // Label 15082: @1016596
     /* 1016596 */   GIM_Try, /*On fail goto*//*Label 15083*/ GIMT_Encode4(1016673), // Rule ID 12930 //
     /* 1016601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1016612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1016615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1016621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016640 */     // MIs[0] policy
     /* 1016640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016650 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016672 */     // GIR_Coverage, 12930,
     /* 1016672 */     GIR_EraseRootFromParent_Done,
     /* 1016673 */   // Label 15083: @1016673
     /* 1016673 */   GIM_Try, /*On fail goto*//*Label 15084*/ GIMT_Encode4(1016750), // Rule ID 12931 //
     /* 1016678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1016689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1016692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1016698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1016717 */     // MIs[0] policy
     /* 1016717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016727 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1016730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1016746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016749 */     // GIR_Coverage, 12931,
     /* 1016749 */     GIR_EraseRootFromParent_Done,
     /* 1016750 */   // Label 15084: @1016750
     /* 1016750 */   GIM_Try, /*On fail goto*//*Label 15085*/ GIMT_Encode4(1016827), // Rule ID 12934 //
     /* 1016755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1016766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1016769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1016775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016794 */     // MIs[0] policy
     /* 1016794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016826 */     // GIR_Coverage, 12934,
     /* 1016826 */     GIR_EraseRootFromParent_Done,
     /* 1016827 */   // Label 15085: @1016827
     /* 1016827 */   GIM_Try, /*On fail goto*//*Label 15086*/ GIMT_Encode4(1016904), // Rule ID 12935 //
     /* 1016832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1016843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1016846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1016849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1016852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1016855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1016871 */     // MIs[0] policy
     /* 1016871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016881 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1016881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1016884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016903 */     // GIR_Coverage, 12935,
     /* 1016903 */     GIR_EraseRootFromParent_Done,
     /* 1016904 */   // Label 15086: @1016904
     /* 1016904 */   GIM_Try, /*On fail goto*//*Label 15087*/ GIMT_Encode4(1016981), // Rule ID 12938 //
     /* 1016909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1016912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1016920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1016923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1016926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1016929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1016932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1016944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1016948 */     // MIs[0] policy
     /* 1016948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1016951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1016958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1016958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1016961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1016963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1016965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1016967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1016969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1016974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1016977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1016979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1016980 */     // GIR_Coverage, 12938,
     /* 1016980 */     GIR_EraseRootFromParent_Done,
     /* 1016981 */   // Label 15087: @1016981
     /* 1016981 */   GIM_Try, /*On fail goto*//*Label 15088*/ GIMT_Encode4(1017058), // Rule ID 12939 //
     /* 1016986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1016989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1016994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1016997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1017000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1017006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017025 */     // MIs[0] policy
     /* 1017025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017035 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017057 */     // GIR_Coverage, 12939,
     /* 1017057 */     GIR_EraseRootFromParent_Done,
     /* 1017058 */   // Label 15088: @1017058
     /* 1017058 */   GIM_Try, /*On fail goto*//*Label 15089*/ GIMT_Encode4(1017135), // Rule ID 12942 //
     /* 1017063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017102 */     // MIs[0] policy
     /* 1017102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017134 */     // GIR_Coverage, 12942,
     /* 1017134 */     GIR_EraseRootFromParent_Done,
     /* 1017135 */   // Label 15089: @1017135
     /* 1017135 */   GIM_Try, /*On fail goto*//*Label 15090*/ GIMT_Encode4(1017212), // Rule ID 12943 //
     /* 1017140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1017151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1017154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1017160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017179 */     // MIs[0] policy
     /* 1017179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017189 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017194 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1017208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017211 */     // GIR_Coverage, 12943,
     /* 1017211 */     GIR_EraseRootFromParent_Done,
     /* 1017212 */   // Label 15090: @1017212
     /* 1017212 */   GIM_Try, /*On fail goto*//*Label 15091*/ GIMT_Encode4(1017289), // Rule ID 12946 //
     /* 1017217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017256 */     // MIs[0] policy
     /* 1017256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017288 */     // GIR_Coverage, 12946,
     /* 1017288 */     GIR_EraseRootFromParent_Done,
     /* 1017289 */   // Label 15091: @1017289
     /* 1017289 */   GIM_Try, /*On fail goto*//*Label 15092*/ GIMT_Encode4(1017366), // Rule ID 12947 //
     /* 1017294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1017305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1017308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1017314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1017333 */     // MIs[0] policy
     /* 1017333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017343 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11420:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2),
     /* 1017346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017365 */     // GIR_Coverage, 12947,
     /* 1017365 */     GIR_EraseRootFromParent_Done,
     /* 1017366 */   // Label 15092: @1017366
     /* 1017366 */   GIM_Try, /*On fail goto*//*Label 15093*/ GIMT_Encode4(1017443), // Rule ID 12950 //
     /* 1017371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017410 */     // MIs[0] policy
     /* 1017410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017420 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017442 */     // GIR_Coverage, 12950,
     /* 1017442 */     GIR_EraseRootFromParent_Done,
     /* 1017443 */   // Label 15093: @1017443
     /* 1017443 */   GIM_Try, /*On fail goto*//*Label 15094*/ GIMT_Encode4(1017520), // Rule ID 12951 //
     /* 1017448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1017459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1017462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1017468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1017487 */     // MIs[0] policy
     /* 1017487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017497 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11420:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4),
     /* 1017500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017519 */     // GIR_Coverage, 12951,
     /* 1017519 */     GIR_EraseRootFromParent_Done,
     /* 1017520 */   // Label 15094: @1017520
     /* 1017520 */   GIM_Try, /*On fail goto*//*Label 15095*/ GIMT_Encode4(1017597), // Rule ID 12954 //
     /* 1017525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1017528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1017536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1017539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1017542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1017545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017564 */     // MIs[0] policy
     /* 1017564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017574 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017596 */     // GIR_Coverage, 12954,
     /* 1017596 */     GIR_EraseRootFromParent_Done,
     /* 1017597 */   // Label 15095: @1017597
     /* 1017597 */   GIM_Try, /*On fail goto*//*Label 15096*/ GIMT_Encode4(1017674), // Rule ID 12955 //
     /* 1017602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1017605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub),
     /* 1017610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1017613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1017616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1017619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1017622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1017637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1017641 */     // MIs[0] policy
     /* 1017641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017651 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11420:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8),
     /* 1017654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1017670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017673 */     // GIR_Coverage, 12955,
     /* 1017673 */     GIR_EraseRootFromParent_Done,
     /* 1017674 */   // Label 15096: @1017674
     /* 1017674 */   GIM_Try, /*On fail goto*//*Label 15097*/ GIMT_Encode4(1017751), // Rule ID 12958 //
     /* 1017679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1017687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1017690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1017693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1017696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1017699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017718 */     // MIs[0] policy
     /* 1017718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017728 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1017731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017750 */     // GIR_Coverage, 12958,
     /* 1017750 */     GIR_EraseRootFromParent_Done,
     /* 1017751 */   // Label 15097: @1017751
     /* 1017751 */   GIM_Try, /*On fail goto*//*Label 15098*/ GIMT_Encode4(1017828), // Rule ID 12959 //
     /* 1017756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1017764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1017767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1017770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1017773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1017776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017795 */     // MIs[0] policy
     /* 1017795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017805 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8),
     /* 1017808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017827 */     // GIR_Coverage, 12959,
     /* 1017827 */     GIR_EraseRootFromParent_Done,
     /* 1017828 */   // Label 15098: @1017828
     /* 1017828 */   GIM_Try, /*On fail goto*//*Label 15099*/ GIMT_Encode4(1017905), // Rule ID 12962 //
     /* 1017833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1017841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1017844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1017847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1017850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1017853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1017856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017872 */     // MIs[0] policy
     /* 1017872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017882 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1017882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1017885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017904 */     // GIR_Coverage, 12962,
     /* 1017904 */     GIR_EraseRootFromParent_Done,
     /* 1017905 */   // Label 15099: @1017905
     /* 1017905 */   GIM_Try, /*On fail goto*//*Label 15100*/ GIMT_Encode4(1017982), // Rule ID 12963 //
     /* 1017910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1017913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1017918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1017921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1017924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1017927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1017930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1017933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1017949 */     // MIs[0] policy
     /* 1017949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1017952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1017959 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1017959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1017962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1017964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1017966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1017968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1017970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1017975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1017978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1017980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1017981 */     // GIR_Coverage, 12963,
     /* 1017981 */     GIR_EraseRootFromParent_Done,
     /* 1017982 */   // Label 15100: @1017982
     /* 1017982 */   GIM_Try, /*On fail goto*//*Label 15101*/ GIMT_Encode4(1018059), // Rule ID 12966 //
     /* 1017987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1017990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1017995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1017998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018026 */     // MIs[0] policy
     /* 1018026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018036 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018058 */     // GIR_Coverage, 12966,
     /* 1018058 */     GIR_EraseRootFromParent_Done,
     /* 1018059 */   // Label 15101: @1018059
     /* 1018059 */   GIM_Try, /*On fail goto*//*Label 15102*/ GIMT_Encode4(1018136), // Rule ID 12967 //
     /* 1018064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1018075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1018078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1018081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1018084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018103 */     // MIs[0] policy
     /* 1018103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018113 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018135 */     // GIR_Coverage, 12967,
     /* 1018135 */     GIR_EraseRootFromParent_Done,
     /* 1018136 */   // Label 15102: @1018136
     /* 1018136 */   GIM_Try, /*On fail goto*//*Label 15103*/ GIMT_Encode4(1018213), // Rule ID 12970 //
     /* 1018141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018180 */     // MIs[0] policy
     /* 1018180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018212 */     // GIR_Coverage, 12970,
     /* 1018212 */     GIR_EraseRootFromParent_Done,
     /* 1018213 */   // Label 15103: @1018213
     /* 1018213 */   GIM_Try, /*On fail goto*//*Label 15104*/ GIMT_Encode4(1018290), // Rule ID 12971 //
     /* 1018218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1018229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1018232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1018235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1018238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018257 */     // MIs[0] policy
     /* 1018257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018267 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4),
     /* 1018270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018289 */     // GIR_Coverage, 12971,
     /* 1018289 */     GIR_EraseRootFromParent_Done,
     /* 1018290 */   // Label 15104: @1018290
     /* 1018290 */   GIM_Try, /*On fail goto*//*Label 15105*/ GIMT_Encode4(1018367), // Rule ID 12974 //
     /* 1018295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018334 */     // MIs[0] policy
     /* 1018334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018344 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018366 */     // GIR_Coverage, 12974,
     /* 1018366 */     GIR_EraseRootFromParent_Done,
     /* 1018367 */   // Label 15105: @1018367
     /* 1018367 */   GIM_Try, /*On fail goto*//*Label 15106*/ GIMT_Encode4(1018444), // Rule ID 12975 //
     /* 1018372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1018383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1018386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1018389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1018392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018411 */     // MIs[0] policy
     /* 1018411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018421 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018443 */     // GIR_Coverage, 12975,
     /* 1018443 */     GIR_EraseRootFromParent_Done,
     /* 1018444 */   // Label 15106: @1018444
     /* 1018444 */   GIM_Try, /*On fail goto*//*Label 15107*/ GIMT_Encode4(1018521), // Rule ID 12978 //
     /* 1018449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018488 */     // MIs[0] policy
     /* 1018488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018498 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018520 */     // GIR_Coverage, 12978,
     /* 1018520 */     GIR_EraseRootFromParent_Done,
     /* 1018521 */   // Label 15107: @1018521
     /* 1018521 */   GIM_Try, /*On fail goto*//*Label 15108*/ GIMT_Encode4(1018598), // Rule ID 12979 //
     /* 1018526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1018537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1018540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1018543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1018546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018565 */     // MIs[0] policy
     /* 1018565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018575 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2),
     /* 1018578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018597 */     // GIR_Coverage, 12979,
     /* 1018597 */     GIR_EraseRootFromParent_Done,
     /* 1018598 */   // Label 15108: @1018598
     /* 1018598 */   GIM_Try, /*On fail goto*//*Label 15109*/ GIMT_Encode4(1018675), // Rule ID 12982 //
     /* 1018603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1018614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1018617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1018620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1018623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018642 */     // MIs[0] policy
     /* 1018642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1018655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018674 */     // GIR_Coverage, 12982,
     /* 1018674 */     GIR_EraseRootFromParent_Done,
     /* 1018675 */   // Label 15109: @1018675
     /* 1018675 */   GIM_Try, /*On fail goto*//*Label 15110*/ GIMT_Encode4(1018752), // Rule ID 12983 //
     /* 1018680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1018691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1018694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1018697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1018700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018719 */     // MIs[0] policy
     /* 1018719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018729 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1018732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1018748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018751 */     // GIR_Coverage, 12983,
     /* 1018751 */     GIR_EraseRootFromParent_Done,
     /* 1018752 */   // Label 15110: @1018752
     /* 1018752 */   GIM_Try, /*On fail goto*//*Label 15111*/ GIMT_Encode4(1018829), // Rule ID 12986 //
     /* 1018757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1018768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1018771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1018774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1018777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018796 */     // MIs[0] policy
     /* 1018796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1018809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018828 */     // GIR_Coverage, 12986,
     /* 1018828 */     GIR_EraseRootFromParent_Done,
     /* 1018829 */   // Label 15111: @1018829
     /* 1018829 */   GIM_Try, /*On fail goto*//*Label 15112*/ GIMT_Encode4(1018906), // Rule ID 12987 //
     /* 1018834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1018845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1018848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1018851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1018854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1018857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018873 */     // MIs[0] policy
     /* 1018873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018883 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1018883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1018886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1018902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018905 */     // GIR_Coverage, 12987,
     /* 1018905 */     GIR_EraseRootFromParent_Done,
     /* 1018906 */   // Label 15112: @1018906
     /* 1018906 */   GIM_Try, /*On fail goto*//*Label 15113*/ GIMT_Encode4(1018983), // Rule ID 12990 //
     /* 1018911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1018914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1018922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1018925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1018928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1018931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1018934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1018950 */     // MIs[0] policy
     /* 1018950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1018953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1018960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1018960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1018963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1018965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1018967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1018969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1018971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1018976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1018979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1018981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1018982 */     // GIR_Coverage, 12990,
     /* 1018982 */     GIR_EraseRootFromParent_Done,
     /* 1018983 */   // Label 15113: @1018983
     /* 1018983 */   GIM_Try, /*On fail goto*//*Label 15114*/ GIMT_Encode4(1019060), // Rule ID 12991 //
     /* 1018988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1018991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1018996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1018999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1019002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1019005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1019008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019027 */     // MIs[0] policy
     /* 1019027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019037 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1019056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019059 */     // GIR_Coverage, 12991,
     /* 1019059 */     GIR_EraseRootFromParent_Done,
     /* 1019060 */   // Label 15114: @1019060
     /* 1019060 */   GIM_Try, /*On fail goto*//*Label 15115*/ GIMT_Encode4(1019137), // Rule ID 12994 //
     /* 1019065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1019068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019104 */     // MIs[0] policy
     /* 1019104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019114 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019136 */     // GIR_Coverage, 12994,
     /* 1019136 */     GIR_EraseRootFromParent_Done,
     /* 1019137 */   // Label 15115: @1019137
     /* 1019137 */   GIM_Try, /*On fail goto*//*Label 15116*/ GIMT_Encode4(1019214), // Rule ID 12995 //
     /* 1019142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1019145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1019153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1019156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1019159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1019162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1019181 */     // MIs[0] policy
     /* 1019181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019191 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1),
     /* 1019194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1019210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019213 */     // GIR_Coverage, 12995,
     /* 1019213 */     GIR_EraseRootFromParent_Done,
     /* 1019214 */   // Label 15116: @1019214
     /* 1019214 */   GIM_Try, /*On fail goto*//*Label 15117*/ GIMT_Encode4(1019291), // Rule ID 12998 //
     /* 1019219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019258 */     // MIs[0] policy
     /* 1019258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019268 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019290 */     // GIR_Coverage, 12998,
     /* 1019290 */     GIR_EraseRootFromParent_Done,
     /* 1019291 */   // Label 15117: @1019291
     /* 1019291 */   GIM_Try, /*On fail goto*//*Label 15118*/ GIMT_Encode4(1019368), // Rule ID 12999 //
     /* 1019296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1019307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1019310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1019313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1019316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019335 */     // MIs[0] policy
     /* 1019335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019345 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019367 */     // GIR_Coverage, 12999,
     /* 1019367 */     GIR_EraseRootFromParent_Done,
     /* 1019368 */   // Label 15118: @1019368
     /* 1019368 */   GIM_Try, /*On fail goto*//*Label 15119*/ GIMT_Encode4(1019445), // Rule ID 13002 //
     /* 1019373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019412 */     // MIs[0] policy
     /* 1019412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019422 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019444 */     // GIR_Coverage, 13002,
     /* 1019444 */     GIR_EraseRootFromParent_Done,
     /* 1019445 */   // Label 15119: @1019445
     /* 1019445 */   GIM_Try, /*On fail goto*//*Label 15120*/ GIMT_Encode4(1019522), // Rule ID 13003 //
     /* 1019450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1019461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1019464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1019467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1019470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019489 */     // MIs[0] policy
     /* 1019489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019499 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019521 */     // GIR_Coverage, 13003,
     /* 1019521 */     GIR_EraseRootFromParent_Done,
     /* 1019522 */   // Label 15120: @1019522
     /* 1019522 */   GIM_Try, /*On fail goto*//*Label 15121*/ GIMT_Encode4(1019599), // Rule ID 13006 //
     /* 1019527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1019538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1019541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1019544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1019547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019566 */     // MIs[0] policy
     /* 1019566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1019579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019598 */     // GIR_Coverage, 13006,
     /* 1019598 */     GIR_EraseRootFromParent_Done,
     /* 1019599 */   // Label 15121: @1019599
     /* 1019599 */   GIM_Try, /*On fail goto*//*Label 15122*/ GIMT_Encode4(1019676), // Rule ID 13007 //
     /* 1019604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1019615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1019618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1019621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1019624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1019643 */     // MIs[0] policy
     /* 1019643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019653 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1019656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1019672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019675 */     // GIR_Coverage, 13007,
     /* 1019675 */     GIR_EraseRootFromParent_Done,
     /* 1019676 */   // Label 15122: @1019676
     /* 1019676 */   GIM_Try, /*On fail goto*//*Label 15123*/ GIMT_Encode4(1019753), // Rule ID 13010 //
     /* 1019681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1019692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1019695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1019698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1019701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019720 */     // MIs[0] policy
     /* 1019720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019752 */     // GIR_Coverage, 13010,
     /* 1019752 */     GIR_EraseRootFromParent_Done,
     /* 1019753 */   // Label 15123: @1019753
     /* 1019753 */   GIM_Try, /*On fail goto*//*Label 15124*/ GIMT_Encode4(1019830), // Rule ID 13011 //
     /* 1019758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1019769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1019772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1019775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1019778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1019797 */     // MIs[0] policy
     /* 1019797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019807 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1019810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019829 */     // GIR_Coverage, 13011,
     /* 1019829 */     GIR_EraseRootFromParent_Done,
     /* 1019830 */   // Label 15124: @1019830
     /* 1019830 */   GIM_Try, /*On fail goto*//*Label 15125*/ GIMT_Encode4(1019907), // Rule ID 13014 //
     /* 1019835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1019846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1019849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1019852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1019855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1019858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019874 */     // MIs[0] policy
     /* 1019874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1019884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019906 */     // GIR_Coverage, 13014,
     /* 1019906 */     GIR_EraseRootFromParent_Done,
     /* 1019907 */   // Label 15125: @1019907
     /* 1019907 */   GIM_Try, /*On fail goto*//*Label 15126*/ GIMT_Encode4(1019984), // Rule ID 13015 //
     /* 1019912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1019915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1019923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1019926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1019929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1019932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1019935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1019951 */     // MIs[0] policy
     /* 1019951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1019954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1019961 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1019961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1019964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1019966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1019968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1019970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1019972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1019977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1019980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1019982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1019983 */     // GIR_Coverage, 13015,
     /* 1019983 */     GIR_EraseRootFromParent_Done,
     /* 1019984 */   // Label 15126: @1019984
     /* 1019984 */   GIM_Try, /*On fail goto*//*Label 15127*/ GIMT_Encode4(1020061), // Rule ID 13018 //
     /* 1019989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1019992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1019997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020028 */     // MIs[0] policy
     /* 1020028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020060 */     // GIR_Coverage, 13018,
     /* 1020060 */     GIR_EraseRootFromParent_Done,
     /* 1020061 */   // Label 15127: @1020061
     /* 1020061 */   GIM_Try, /*On fail goto*//*Label 15128*/ GIMT_Encode4(1020138), // Rule ID 13019 //
     /* 1020066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1020077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1020080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1020083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1020086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020105 */     // MIs[0] policy
     /* 1020105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020115 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1020134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020137 */     // GIR_Coverage, 13019,
     /* 1020137 */     GIR_EraseRootFromParent_Done,
     /* 1020138 */   // Label 15128: @1020138
     /* 1020138 */   GIM_Try, /*On fail goto*//*Label 15129*/ GIMT_Encode4(1020215), // Rule ID 13022 //
     /* 1020143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020182 */     // MIs[0] policy
     /* 1020182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020214 */     // GIR_Coverage, 13022,
     /* 1020214 */     GIR_EraseRootFromParent_Done,
     /* 1020215 */   // Label 15129: @1020215
     /* 1020215 */   GIM_Try, /*On fail goto*//*Label 15130*/ GIMT_Encode4(1020292), // Rule ID 13023 //
     /* 1020220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1020231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1020234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1020237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1020240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020259 */     // MIs[0] policy
     /* 1020259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020269 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020291 */     // GIR_Coverage, 13023,
     /* 1020291 */     GIR_EraseRootFromParent_Done,
     /* 1020292 */   // Label 15130: @1020292
     /* 1020292 */   GIM_Try, /*On fail goto*//*Label 15131*/ GIMT_Encode4(1020369), // Rule ID 13026 //
     /* 1020297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020336 */     // MIs[0] policy
     /* 1020336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020346 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020368 */     // GIR_Coverage, 13026,
     /* 1020368 */     GIR_EraseRootFromParent_Done,
     /* 1020369 */   // Label 15131: @1020369
     /* 1020369 */   GIM_Try, /*On fail goto*//*Label 15132*/ GIMT_Encode4(1020446), // Rule ID 13027 //
     /* 1020374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1020385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1020388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1020391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1020394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020413 */     // MIs[0] policy
     /* 1020413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020423 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020445 */     // GIR_Coverage, 13027,
     /* 1020445 */     GIR_EraseRootFromParent_Done,
     /* 1020446 */   // Label 15132: @1020446
     /* 1020446 */   GIM_Try, /*On fail goto*//*Label 15133*/ GIMT_Encode4(1020523), // Rule ID 13030 //
     /* 1020451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1020454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1020468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1020471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020490 */     // MIs[0] policy
     /* 1020490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020522 */     // GIR_Coverage, 13030,
     /* 1020522 */     GIR_EraseRootFromParent_Done,
     /* 1020523 */   // Label 15133: @1020523
     /* 1020523 */   GIM_Try, /*On fail goto*//*Label 15134*/ GIMT_Encode4(1020600), // Rule ID 13031 //
     /* 1020528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1020531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1020539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1020542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1020545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1020548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020567 */     // MIs[0] policy
     /* 1020567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020577 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1020596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020599 */     // GIR_Coverage, 13031,
     /* 1020599 */     GIR_EraseRootFromParent_Done,
     /* 1020600 */   // Label 15134: @1020600
     /* 1020600 */   GIM_Try, /*On fail goto*//*Label 15135*/ GIMT_Encode4(1020677), // Rule ID 13034 //
     /* 1020605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1020616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1020619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1020622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1020625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020644 */     // MIs[0] policy
     /* 1020644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020676 */     // GIR_Coverage, 13034,
     /* 1020676 */     GIR_EraseRootFromParent_Done,
     /* 1020677 */   // Label 15135: @1020677
     /* 1020677 */   GIM_Try, /*On fail goto*//*Label 15136*/ GIMT_Encode4(1020754), // Rule ID 13035 //
     /* 1020682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1020693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1020696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1020699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1020702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1020721 */     // MIs[0] policy
     /* 1020721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020731 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2),
     /* 1020734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020753 */     // GIR_Coverage, 13035,
     /* 1020753 */     GIR_EraseRootFromParent_Done,
     /* 1020754 */   // Label 15136: @1020754
     /* 1020754 */   GIM_Try, /*On fail goto*//*Label 15137*/ GIMT_Encode4(1020831), // Rule ID 13038 //
     /* 1020759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1020770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1020773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1020776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1020779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020798 */     // MIs[0] policy
     /* 1020798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020808 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020830 */     // GIR_Coverage, 13038,
     /* 1020830 */     GIR_EraseRootFromParent_Done,
     /* 1020831 */   // Label 15137: @1020831
     /* 1020831 */   GIM_Try, /*On fail goto*//*Label 15138*/ GIMT_Encode4(1020908), // Rule ID 13039 //
     /* 1020836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1020847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1020850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1020853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1020856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1020859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1020875 */     // MIs[0] policy
     /* 1020875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020885 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1020885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4),
     /* 1020888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020907 */     // GIR_Coverage, 13039,
     /* 1020907 */     GIR_EraseRootFromParent_Done,
     /* 1020908 */   // Label 15138: @1020908
     /* 1020908 */   GIM_Try, /*On fail goto*//*Label 15139*/ GIMT_Encode4(1020985), // Rule ID 13042 //
     /* 1020913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1020916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1020924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1020927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1020930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1020933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1020936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1020952 */     // MIs[0] policy
     /* 1020952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1020955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1020962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1020962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1020965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1020967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1020969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1020971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1020973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1020978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1020981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1020983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1020984 */     // GIR_Coverage, 13042,
     /* 1020984 */     GIR_EraseRootFromParent_Done,
     /* 1020985 */   // Label 15139: @1020985
     /* 1020985 */   GIM_Try, /*On fail goto*//*Label 15140*/ GIMT_Encode4(1021062), // Rule ID 13043 //
     /* 1020990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1020993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1020998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1021001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1021004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1021007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1021010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1021029 */     // MIs[0] policy
     /* 1021029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021039 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8),
     /* 1021042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1021058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021061 */     // GIR_Coverage, 13043,
     /* 1021061 */     GIR_EraseRootFromParent_Done,
     /* 1021062 */   // Label 15140: @1021062
     /* 1021062 */   GIM_Try, /*On fail goto*//*Label 15141*/ GIMT_Encode4(1021139), // Rule ID 13046 //
     /* 1021067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021106 */     // MIs[0] policy
     /* 1021106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021138 */     // GIR_Coverage, 13046,
     /* 1021138 */     GIR_EraseRootFromParent_Done,
     /* 1021139 */   // Label 15141: @1021139
     /* 1021139 */   GIM_Try, /*On fail goto*//*Label 15142*/ GIMT_Encode4(1021216), // Rule ID 13047 //
     /* 1021144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1021155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1021158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1021164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021183 */     // MIs[0] policy
     /* 1021183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021193 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8),
     /* 1021196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021215 */     // GIR_Coverage, 13047,
     /* 1021215 */     GIR_EraseRootFromParent_Done,
     /* 1021216 */   // Label 15142: @1021216
     /* 1021216 */   GIM_Try, /*On fail goto*//*Label 15143*/ GIMT_Encode4(1021293), // Rule ID 13050 //
     /* 1021221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021260 */     // MIs[0] policy
     /* 1021260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021270 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021292 */     // GIR_Coverage, 13050,
     /* 1021292 */     GIR_EraseRootFromParent_Done,
     /* 1021293 */   // Label 15143: @1021293
     /* 1021293 */   GIM_Try, /*On fail goto*//*Label 15144*/ GIMT_Encode4(1021370), // Rule ID 13051 //
     /* 1021298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1021309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1021312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1021318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021337 */     // MIs[0] policy
     /* 1021337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021347 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021369 */     // GIR_Coverage, 13051,
     /* 1021369 */     GIR_EraseRootFromParent_Done,
     /* 1021370 */   // Label 15144: @1021370
     /* 1021370 */   GIM_Try, /*On fail goto*//*Label 15145*/ GIMT_Encode4(1021447), // Rule ID 13054 //
     /* 1021375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021414 */     // MIs[0] policy
     /* 1021414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021446 */     // GIR_Coverage, 13054,
     /* 1021446 */     GIR_EraseRootFromParent_Done,
     /* 1021447 */   // Label 15145: @1021447
     /* 1021447 */   GIM_Try, /*On fail goto*//*Label 15146*/ GIMT_Encode4(1021524), // Rule ID 13055 //
     /* 1021452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1021463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1021466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1021472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021491 */     // MIs[0] policy
     /* 1021491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021501 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1021520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021523 */     // GIR_Coverage, 13055,
     /* 1021523 */     GIR_EraseRootFromParent_Done,
     /* 1021524 */   // Label 15146: @1021524
     /* 1021524 */   GIM_Try, /*On fail goto*//*Label 15147*/ GIMT_Encode4(1021601), // Rule ID 13058 //
     /* 1021529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1021540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1021543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1021549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021568 */     // MIs[0] policy
     /* 1021568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021578 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021600 */     // GIR_Coverage, 13058,
     /* 1021600 */     GIR_EraseRootFromParent_Done,
     /* 1021601 */   // Label 15147: @1021601
     /* 1021601 */   GIM_Try, /*On fail goto*//*Label 15148*/ GIMT_Encode4(1021678), // Rule ID 13059 //
     /* 1021606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1021617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1021620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1021626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021645 */     // MIs[0] policy
     /* 1021645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021655 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4),
     /* 1021658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021677 */     // GIR_Coverage, 13059,
     /* 1021677 */     GIR_EraseRootFromParent_Done,
     /* 1021678 */   // Label 15148: @1021678
     /* 1021678 */   GIM_Try, /*On fail goto*//*Label 15149*/ GIMT_Encode4(1021755), // Rule ID 13062 //
     /* 1021683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1021694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1021697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1021703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021722 */     // MIs[0] policy
     /* 1021722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021732 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021754 */     // GIR_Coverage, 13062,
     /* 1021754 */     GIR_EraseRootFromParent_Done,
     /* 1021755 */   // Label 15149: @1021755
     /* 1021755 */   GIM_Try, /*On fail goto*//*Label 15150*/ GIMT_Encode4(1021832), // Rule ID 13063 //
     /* 1021760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1021771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1021774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1021780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021799 */     // MIs[0] policy
     /* 1021799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021809 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1021828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021831 */     // GIR_Coverage, 13063,
     /* 1021831 */     GIR_EraseRootFromParent_Done,
     /* 1021832 */   // Label 15150: @1021832
     /* 1021832 */   GIM_Try, /*On fail goto*//*Label 15151*/ GIMT_Encode4(1021909), // Rule ID 13066 //
     /* 1021837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1021848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1021851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1021854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1021857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1021860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021876 */     // MIs[0] policy
     /* 1021876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021886 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1021886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021908 */     // GIR_Coverage, 13066,
     /* 1021908 */     GIR_EraseRootFromParent_Done,
     /* 1021909 */   // Label 15151: @1021909
     /* 1021909 */   GIM_Try, /*On fail goto*//*Label 15152*/ GIMT_Encode4(1021986), // Rule ID 13067 //
     /* 1021914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1021917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1021925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1021928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1021931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1021934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1021937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1021949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1021953 */     // MIs[0] policy
     /* 1021953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1021956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1021963 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1021963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2),
     /* 1021966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1021968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1021970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1021972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1021974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1021979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1021982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1021984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1021985 */     // GIR_Coverage, 13067,
     /* 1021985 */     GIR_EraseRootFromParent_Done,
     /* 1021986 */   // Label 15152: @1021986
     /* 1021986 */   GIM_Try, /*On fail goto*//*Label 15153*/ GIMT_Encode4(1022063), // Rule ID 13070 //
     /* 1021991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1021994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1021999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022030 */     // MIs[0] policy
     /* 1022030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022062 */     // GIR_Coverage, 13070,
     /* 1022062 */     GIR_EraseRootFromParent_Done,
     /* 1022063 */   // Label 15153: @1022063
     /* 1022063 */   GIM_Try, /*On fail goto*//*Label 15154*/ GIMT_Encode4(1022140), // Rule ID 13071 //
     /* 1022068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1022079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1022082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1022088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022107 */     // MIs[0] policy
     /* 1022107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022117 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11337:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022139 */     // GIR_Coverage, 13071,
     /* 1022139 */     GIR_EraseRootFromParent_Done,
     /* 1022140 */   // Label 15154: @1022140
     /* 1022140 */   GIM_Try, /*On fail goto*//*Label 15155*/ GIMT_Encode4(1022217), // Rule ID 13074 //
     /* 1022145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022184 */     // MIs[0] policy
     /* 1022184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022194 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022216 */     // GIR_Coverage, 13074,
     /* 1022216 */     GIR_EraseRootFromParent_Done,
     /* 1022217 */   // Label 15155: @1022217
     /* 1022217 */   GIM_Try, /*On fail goto*//*Label 15156*/ GIMT_Encode4(1022294), // Rule ID 13075 //
     /* 1022222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1022233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1022236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1022242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022261 */     // MIs[0] policy
     /* 1022261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022271 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11337:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1022290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022293 */     // GIR_Coverage, 13075,
     /* 1022293 */     GIR_EraseRootFromParent_Done,
     /* 1022294 */   // Label 15156: @1022294
     /* 1022294 */   GIM_Try, /*On fail goto*//*Label 15157*/ GIMT_Encode4(1022371), // Rule ID 13078 //
     /* 1022299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022338 */     // MIs[0] policy
     /* 1022338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022370 */     // GIR_Coverage, 13078,
     /* 1022370 */     GIR_EraseRootFromParent_Done,
     /* 1022371 */   // Label 15157: @1022371
     /* 1022371 */   GIM_Try, /*On fail goto*//*Label 15158*/ GIMT_Encode4(1022448), // Rule ID 13079 //
     /* 1022376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1022387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1022390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1022396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022415 */     // MIs[0] policy
     /* 1022415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022425 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11337:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1022444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022447 */     // GIR_Coverage, 13079,
     /* 1022447 */     GIR_EraseRootFromParent_Done,
     /* 1022448 */   // Label 15158: @1022448
     /* 1022448 */   GIM_Try, /*On fail goto*//*Label 15159*/ GIMT_Encode4(1022525), // Rule ID 13082 //
     /* 1022453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1022456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1022464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1022467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1022473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022492 */     // MIs[0] policy
     /* 1022492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022502 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022524 */     // GIR_Coverage, 13082,
     /* 1022524 */     GIR_EraseRootFromParent_Done,
     /* 1022525 */   // Label 15159: @1022525
     /* 1022525 */   GIM_Try, /*On fail goto*//*Label 15160*/ GIMT_Encode4(1022602), // Rule ID 13083 //
     /* 1022530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1022533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1022541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1022544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1022550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1022569 */     // MIs[0] policy
     /* 1022569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022579 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11337:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1),
     /* 1022582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1022598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022601 */     // GIR_Coverage, 13083,
     /* 1022601 */     GIR_EraseRootFromParent_Done,
     /* 1022602 */   // Label 15160: @1022602
     /* 1022602 */   GIM_Try, /*On fail goto*//*Label 15161*/ GIMT_Encode4(1022679), // Rule ID 13086 //
     /* 1022607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1022618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1022621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022646 */     // MIs[0] policy
     /* 1022646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022656 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1022659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022678 */     // GIR_Coverage, 13086,
     /* 1022678 */     GIR_EraseRootFromParent_Done,
     /* 1022679 */   // Label 15161: @1022679
     /* 1022679 */   GIM_Try, /*On fail goto*//*Label 15162*/ GIMT_Encode4(1022756), // Rule ID 13087 //
     /* 1022684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1022695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1022698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1022704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1022723 */     // MIs[0] policy
     /* 1022723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022733 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1022736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022755 */     // GIR_Coverage, 13087,
     /* 1022755 */     GIR_EraseRootFromParent_Done,
     /* 1022756 */   // Label 15162: @1022756
     /* 1022756 */   GIM_Try, /*On fail goto*//*Label 15163*/ GIMT_Encode4(1022833), // Rule ID 13090 //
     /* 1022761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1022772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1022775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1022781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022800 */     // MIs[0] policy
     /* 1022800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022810 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1022813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022832 */     // GIR_Coverage, 13090,
     /* 1022832 */     GIR_EraseRootFromParent_Done,
     /* 1022833 */   // Label 15163: @1022833
     /* 1022833 */   GIM_Try, /*On fail goto*//*Label 15164*/ GIMT_Encode4(1022910), // Rule ID 13091 //
     /* 1022838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1022849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1022852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1022855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1022858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1022861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1022877 */     // MIs[0] policy
     /* 1022877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022887 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1022887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1022890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022909 */     // GIR_Coverage, 13091,
     /* 1022909 */     GIR_EraseRootFromParent_Done,
     /* 1022910 */   // Label 15164: @1022910
     /* 1022910 */   GIM_Try, /*On fail goto*//*Label 15165*/ GIMT_Encode4(1022987), // Rule ID 13094 //
     /* 1022915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1022918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1022923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1022926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1022929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1022932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1022935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1022938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1022950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1022954 */     // MIs[0] policy
     /* 1022954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1022957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1022964 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1022964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1022967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1022969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1022971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1022973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1022975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1022980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1022983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1022985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1022986 */     // GIR_Coverage, 13094,
     /* 1022986 */     GIR_EraseRootFromParent_Done,
     /* 1022987 */   // Label 15165: @1022987
     /* 1022987 */   GIM_Try, /*On fail goto*//*Label 15166*/ GIMT_Encode4(1023064), // Rule ID 13095 //
     /* 1022992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1022995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1023003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1023006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1023012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023031 */     // MIs[0] policy
     /* 1023031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023041 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1023060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023063 */     // GIR_Coverage, 13095,
     /* 1023063 */     GIR_EraseRootFromParent_Done,
     /* 1023064 */   // Label 15166: @1023064
     /* 1023064 */   GIM_Try, /*On fail goto*//*Label 15167*/ GIMT_Encode4(1023141), // Rule ID 13098 //
     /* 1023069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023108 */     // MIs[0] policy
     /* 1023108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023140 */     // GIR_Coverage, 13098,
     /* 1023140 */     GIR_EraseRootFromParent_Done,
     /* 1023141 */   // Label 15167: @1023141
     /* 1023141 */   GIM_Try, /*On fail goto*//*Label 15168*/ GIMT_Encode4(1023218), // Rule ID 13099 //
     /* 1023146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1023157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1023160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1023166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023185 */     // MIs[0] policy
     /* 1023185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023195 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023217 */     // GIR_Coverage, 13099,
     /* 1023217 */     GIR_EraseRootFromParent_Done,
     /* 1023218 */   // Label 15168: @1023218
     /* 1023218 */   GIM_Try, /*On fail goto*//*Label 15169*/ GIMT_Encode4(1023295), // Rule ID 13102 //
     /* 1023223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023262 */     // MIs[0] policy
     /* 1023262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023294 */     // GIR_Coverage, 13102,
     /* 1023294 */     GIR_EraseRootFromParent_Done,
     /* 1023295 */   // Label 15169: @1023295
     /* 1023295 */   GIM_Try, /*On fail goto*//*Label 15170*/ GIMT_Encode4(1023372), // Rule ID 13103 //
     /* 1023300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1023311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1023314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1023320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023339 */     // MIs[0] policy
     /* 1023339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023349 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023371 */     // GIR_Coverage, 13103,
     /* 1023371 */     GIR_EraseRootFromParent_Done,
     /* 1023372 */   // Label 15170: @1023372
     /* 1023372 */   GIM_Try, /*On fail goto*//*Label 15171*/ GIMT_Encode4(1023449), // Rule ID 13106 //
     /* 1023377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023416 */     // MIs[0] policy
     /* 1023416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023426 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023448 */     // GIR_Coverage, 13106,
     /* 1023448 */     GIR_EraseRootFromParent_Done,
     /* 1023449 */   // Label 15171: @1023449
     /* 1023449 */   GIM_Try, /*On fail goto*//*Label 15172*/ GIMT_Encode4(1023526), // Rule ID 13107 //
     /* 1023454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1023465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1023468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1023474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023493 */     // MIs[0] policy
     /* 1023493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023503 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1023522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023525 */     // GIR_Coverage, 13107,
     /* 1023525 */     GIR_EraseRootFromParent_Done,
     /* 1023526 */   // Label 15172: @1023526
     /* 1023526 */   GIM_Try, /*On fail goto*//*Label 15173*/ GIMT_Encode4(1023603), // Rule ID 13110 //
     /* 1023531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1023542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1023545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1023551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023570 */     // MIs[0] policy
     /* 1023570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023580 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023602 */     // GIR_Coverage, 13110,
     /* 1023602 */     GIR_EraseRootFromParent_Done,
     /* 1023603 */   // Label 15173: @1023603
     /* 1023603 */   GIM_Try, /*On fail goto*//*Label 15174*/ GIMT_Encode4(1023680), // Rule ID 13111 //
     /* 1023608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1023619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1023622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1023628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1023647 */     // MIs[0] policy
     /* 1023647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1023660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023679 */     // GIR_Coverage, 13111,
     /* 1023679 */     GIR_EraseRootFromParent_Done,
     /* 1023680 */   // Label 15174: @1023680
     /* 1023680 */   GIM_Try, /*On fail goto*//*Label 15175*/ GIMT_Encode4(1023757), // Rule ID 13114 //
     /* 1023685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1023696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1023699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1023705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023724 */     // MIs[0] policy
     /* 1023724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023734 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023756 */     // GIR_Coverage, 13114,
     /* 1023756 */     GIR_EraseRootFromParent_Done,
     /* 1023757 */   // Label 15175: @1023757
     /* 1023757 */   GIM_Try, /*On fail goto*//*Label 15176*/ GIMT_Encode4(1023834), // Rule ID 13115 //
     /* 1023762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1023773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1023776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1023782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1023801 */     // MIs[0] policy
     /* 1023801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023811 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1023814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023833 */     // GIR_Coverage, 13115,
     /* 1023833 */     GIR_EraseRootFromParent_Done,
     /* 1023834 */   // Label 15176: @1023834
     /* 1023834 */   GIM_Try, /*On fail goto*//*Label 15177*/ GIMT_Encode4(1023911), // Rule ID 13118 //
     /* 1023839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1023842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1023856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1023859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1023862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023878 */     // MIs[0] policy
     /* 1023878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023888 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1023888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023910 */     // GIR_Coverage, 13118,
     /* 1023910 */     GIR_EraseRootFromParent_Done,
     /* 1023911 */   // Label 15177: @1023911
     /* 1023911 */   GIM_Try, /*On fail goto*//*Label 15178*/ GIMT_Encode4(1023988), // Rule ID 13119 //
     /* 1023916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1023919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1023924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1023927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1023930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1023933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1023936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1023939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1023951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1023955 */     // MIs[0] policy
     /* 1023955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1023958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1023965 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1023965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1023968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1023970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1023972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1023974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1023976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1023981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1023984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1023986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1023987 */     // GIR_Coverage, 13119,
     /* 1023987 */     GIR_EraseRootFromParent_Done,
     /* 1023988 */   // Label 15178: @1023988
     /* 1023988 */   GIM_Try, /*On fail goto*//*Label 15179*/ GIMT_Encode4(1024065), // Rule ID 13122 //
     /* 1023993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1023996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024032 */     // MIs[0] policy
     /* 1024032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024042 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024064 */     // GIR_Coverage, 13122,
     /* 1024064 */     GIR_EraseRootFromParent_Done,
     /* 1024065 */   // Label 15179: @1024065
     /* 1024065 */   GIM_Try, /*On fail goto*//*Label 15180*/ GIMT_Encode4(1024142), // Rule ID 13123 //
     /* 1024070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1024081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1024084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1024090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1024109 */     // MIs[0] policy
     /* 1024109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024119 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11337:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2),
     /* 1024122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024141 */     // GIR_Coverage, 13123,
     /* 1024141 */     GIR_EraseRootFromParent_Done,
     /* 1024142 */   // Label 15180: @1024142
     /* 1024142 */   GIM_Try, /*On fail goto*//*Label 15181*/ GIMT_Encode4(1024219), // Rule ID 13126 //
     /* 1024147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024186 */     // MIs[0] policy
     /* 1024186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024218 */     // GIR_Coverage, 13126,
     /* 1024218 */     GIR_EraseRootFromParent_Done,
     /* 1024219 */   // Label 15181: @1024219
     /* 1024219 */   GIM_Try, /*On fail goto*//*Label 15182*/ GIMT_Encode4(1024296), // Rule ID 13127 //
     /* 1024224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1024235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1024238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1024244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1024263 */     // MIs[0] policy
     /* 1024263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024273 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11337:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4),
     /* 1024276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024295 */     // GIR_Coverage, 13127,
     /* 1024295 */     GIR_EraseRootFromParent_Done,
     /* 1024296 */   // Label 15182: @1024296
     /* 1024296 */   GIM_Try, /*On fail goto*//*Label 15183*/ GIMT_Encode4(1024373), // Rule ID 13130 //
     /* 1024301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1024304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1024318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024340 */     // MIs[0] policy
     /* 1024340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024372 */     // GIR_Coverage, 13130,
     /* 1024372 */     GIR_EraseRootFromParent_Done,
     /* 1024373 */   // Label 15183: @1024373
     /* 1024373 */   GIM_Try, /*On fail goto*//*Label 15184*/ GIMT_Encode4(1024450), // Rule ID 13131 //
     /* 1024378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1024381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc),
     /* 1024386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1024389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1024392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1024395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1024398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1024413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1024417 */     // MIs[0] policy
     /* 1024417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024427 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11337:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8),
     /* 1024430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1024446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024449 */     // GIR_Coverage, 13131,
     /* 1024449 */     GIR_EraseRootFromParent_Done,
     /* 1024450 */   // Label 15184: @1024450
     /* 1024450 */   GIM_Try, /*On fail goto*//*Label 15185*/ GIMT_Encode4(1024527), // Rule ID 13134 //
     /* 1024455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1024466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1024469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1024472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1024475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024494 */     // MIs[0] policy
     /* 1024494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1024507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024526 */     // GIR_Coverage, 13134,
     /* 1024526 */     GIR_EraseRootFromParent_Done,
     /* 1024527 */   // Label 15185: @1024527
     /* 1024527 */   GIM_Try, /*On fail goto*//*Label 15186*/ GIMT_Encode4(1024604), // Rule ID 13135 //
     /* 1024532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1024543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1024546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1024549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1024552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024571 */     // MIs[0] policy
     /* 1024571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024581 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8),
     /* 1024584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024603 */     // GIR_Coverage, 13135,
     /* 1024603 */     GIR_EraseRootFromParent_Done,
     /* 1024604 */   // Label 15186: @1024604
     /* 1024604 */   GIM_Try, /*On fail goto*//*Label 15187*/ GIMT_Encode4(1024681), // Rule ID 13138 //
     /* 1024609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1024620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1024623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1024626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1024629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024648 */     // MIs[0] policy
     /* 1024648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024658 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1024661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024680 */     // GIR_Coverage, 13138,
     /* 1024680 */     GIR_EraseRootFromParent_Done,
     /* 1024681 */   // Label 15187: @1024681
     /* 1024681 */   GIM_Try, /*On fail goto*//*Label 15188*/ GIMT_Encode4(1024758), // Rule ID 13139 //
     /* 1024686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1024697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1024700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1024703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1024706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024725 */     // MIs[0] policy
     /* 1024725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024735 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1024738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024757 */     // GIR_Coverage, 13139,
     /* 1024757 */     GIR_EraseRootFromParent_Done,
     /* 1024758 */   // Label 15188: @1024758
     /* 1024758 */   GIM_Try, /*On fail goto*//*Label 15189*/ GIMT_Encode4(1024835), // Rule ID 13142 //
     /* 1024763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1024774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1024777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1024780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1024783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024802 */     // MIs[0] policy
     /* 1024802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024812 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1024815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024834 */     // GIR_Coverage, 13142,
     /* 1024834 */     GIR_EraseRootFromParent_Done,
     /* 1024835 */   // Label 15189: @1024835
     /* 1024835 */   GIM_Try, /*On fail goto*//*Label 15190*/ GIMT_Encode4(1024912), // Rule ID 13143 //
     /* 1024840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1024851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1024854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1024857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1024860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1024863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024879 */     // MIs[0] policy
     /* 1024879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024889 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1024889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1024892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1024908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024911 */     // GIR_Coverage, 13143,
     /* 1024911 */     GIR_EraseRootFromParent_Done,
     /* 1024912 */   // Label 15190: @1024912
     /* 1024912 */   GIM_Try, /*On fail goto*//*Label 15191*/ GIMT_Encode4(1024989), // Rule ID 13146 //
     /* 1024917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1024920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1024925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1024928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1024931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1024934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1024937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1024940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1024956 */     // MIs[0] policy
     /* 1024956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1024959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1024966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1024966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1024969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1024971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1024973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1024975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1024977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1024982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1024985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1024987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1024988 */     // GIR_Coverage, 13146,
     /* 1024988 */     GIR_EraseRootFromParent_Done,
     /* 1024989 */   // Label 15191: @1024989
     /* 1024989 */   GIM_Try, /*On fail goto*//*Label 15192*/ GIMT_Encode4(1025066), // Rule ID 13147 //
     /* 1024994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1024997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1025005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1025008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1025011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1025014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025033 */     // MIs[0] policy
     /* 1025033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025043 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4),
     /* 1025046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025065 */     // GIR_Coverage, 13147,
     /* 1025065 */     GIR_EraseRootFromParent_Done,
     /* 1025066 */   // Label 15192: @1025066
     /* 1025066 */   GIM_Try, /*On fail goto*//*Label 15193*/ GIMT_Encode4(1025143), // Rule ID 13150 //
     /* 1025071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025110 */     // MIs[0] policy
     /* 1025110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025120 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025142 */     // GIR_Coverage, 13150,
     /* 1025142 */     GIR_EraseRootFromParent_Done,
     /* 1025143 */   // Label 15193: @1025143
     /* 1025143 */   GIM_Try, /*On fail goto*//*Label 15194*/ GIMT_Encode4(1025220), // Rule ID 13151 //
     /* 1025148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1025159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1025162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1025165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1025168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025187 */     // MIs[0] policy
     /* 1025187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025197 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025202 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025219 */     // GIR_Coverage, 13151,
     /* 1025219 */     GIR_EraseRootFromParent_Done,
     /* 1025220 */   // Label 15194: @1025220
     /* 1025220 */   GIM_Try, /*On fail goto*//*Label 15195*/ GIMT_Encode4(1025297), // Rule ID 13154 //
     /* 1025225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025264 */     // MIs[0] policy
     /* 1025264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025274 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025296 */     // GIR_Coverage, 13154,
     /* 1025296 */     GIR_EraseRootFromParent_Done,
     /* 1025297 */   // Label 15195: @1025297
     /* 1025297 */   GIM_Try, /*On fail goto*//*Label 15196*/ GIMT_Encode4(1025374), // Rule ID 13155 //
     /* 1025302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1025313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1025316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1025319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1025322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025341 */     // MIs[0] policy
     /* 1025341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2),
     /* 1025354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025373 */     // GIR_Coverage, 13155,
     /* 1025373 */     GIR_EraseRootFromParent_Done,
     /* 1025374 */   // Label 15196: @1025374
     /* 1025374 */   GIM_Try, /*On fail goto*//*Label 15197*/ GIMT_Encode4(1025451), // Rule ID 13158 //
     /* 1025379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025418 */     // MIs[0] policy
     /* 1025418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025428 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025450 */     // GIR_Coverage, 13158,
     /* 1025450 */     GIR_EraseRootFromParent_Done,
     /* 1025451 */   // Label 15197: @1025451
     /* 1025451 */   GIM_Try, /*On fail goto*//*Label 15198*/ GIMT_Encode4(1025528), // Rule ID 13159 //
     /* 1025456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1025467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1025470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1025473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1025476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025495 */     // MIs[0] policy
     /* 1025495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025505 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1025524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025527 */     // GIR_Coverage, 13159,
     /* 1025527 */     GIR_EraseRootFromParent_Done,
     /* 1025528 */   // Label 15198: @1025528
     /* 1025528 */   GIM_Try, /*On fail goto*//*Label 15199*/ GIMT_Encode4(1025605), // Rule ID 13162 //
     /* 1025533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1025544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1025547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1025550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1025553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025572 */     // MIs[0] policy
     /* 1025572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025582 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025604 */     // GIR_Coverage, 13162,
     /* 1025604 */     GIR_EraseRootFromParent_Done,
     /* 1025605 */   // Label 15199: @1025605
     /* 1025605 */   GIM_Try, /*On fail goto*//*Label 15200*/ GIMT_Encode4(1025682), // Rule ID 13163 //
     /* 1025610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1025621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1025624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1025627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1025630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025649 */     // MIs[0] policy
     /* 1025649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025659 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1025678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025681 */     // GIR_Coverage, 13163,
     /* 1025681 */     GIR_EraseRootFromParent_Done,
     /* 1025682 */   // Label 15200: @1025682
     /* 1025682 */   GIM_Try, /*On fail goto*//*Label 15201*/ GIMT_Encode4(1025759), // Rule ID 13166 //
     /* 1025687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1025698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1025701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1025704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1025707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025726 */     // MIs[0] policy
     /* 1025726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025758 */     // GIR_Coverage, 13166,
     /* 1025758 */     GIR_EraseRootFromParent_Done,
     /* 1025759 */   // Label 15201: @1025759
     /* 1025759 */   GIM_Try, /*On fail goto*//*Label 15202*/ GIMT_Encode4(1025836), // Rule ID 13167 //
     /* 1025764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1025767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1025775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1025778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1025781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1025784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025803 */     // MIs[0] policy
     /* 1025803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025813 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1025832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025835 */     // GIR_Coverage, 13167,
     /* 1025835 */     GIR_EraseRootFromParent_Done,
     /* 1025836 */   // Label 15202: @1025836
     /* 1025836 */   GIM_Try, /*On fail goto*//*Label 15203*/ GIMT_Encode4(1025913), // Rule ID 13170 //
     /* 1025841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1025844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1025852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1025855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1025858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1025861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1025864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025880 */     // MIs[0] policy
     /* 1025880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025890 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1025890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025912 */     // GIR_Coverage, 13170,
     /* 1025912 */     GIR_EraseRootFromParent_Done,
     /* 1025913 */   // Label 15203: @1025913
     /* 1025913 */   GIM_Try, /*On fail goto*//*Label 15204*/ GIMT_Encode4(1025990), // Rule ID 13171 //
     /* 1025918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1025921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1025926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1025929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1025932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1025935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1025938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1025941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1025957 */     // MIs[0] policy
     /* 1025957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1025960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1025967 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1025967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1),
     /* 1025970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1025972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1025974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1025976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1025978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1025983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1025986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1025988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1025989 */     // GIR_Coverage, 13171,
     /* 1025989 */     GIR_EraseRootFromParent_Done,
     /* 1025990 */   // Label 15204: @1025990
     /* 1025990 */   GIM_Try, /*On fail goto*//*Label 15205*/ GIMT_Encode4(1026067), // Rule ID 13174 //
     /* 1025995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1025998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026034 */     // MIs[0] policy
     /* 1026034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026066 */     // GIR_Coverage, 13174,
     /* 1026066 */     GIR_EraseRootFromParent_Done,
     /* 1026067 */   // Label 15205: @1026067
     /* 1026067 */   GIM_Try, /*On fail goto*//*Label 15206*/ GIMT_Encode4(1026144), // Rule ID 13175 //
     /* 1026072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1026083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1026086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1026089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1026092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026111 */     // MIs[0] policy
     /* 1026111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026121 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026143 */     // GIR_Coverage, 13175,
     /* 1026143 */     GIR_EraseRootFromParent_Done,
     /* 1026144 */   // Label 15206: @1026144
     /* 1026144 */   GIM_Try, /*On fail goto*//*Label 15207*/ GIMT_Encode4(1026221), // Rule ID 13178 //
     /* 1026149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026188 */     // MIs[0] policy
     /* 1026188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026198 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026220 */     // GIR_Coverage, 13178,
     /* 1026220 */     GIR_EraseRootFromParent_Done,
     /* 1026221 */   // Label 15207: @1026221
     /* 1026221 */   GIM_Try, /*On fail goto*//*Label 15208*/ GIMT_Encode4(1026298), // Rule ID 13179 //
     /* 1026226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1026237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1026240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1026243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1026246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026265 */     // MIs[0] policy
     /* 1026265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026275 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026297 */     // GIR_Coverage, 13179,
     /* 1026297 */     GIR_EraseRootFromParent_Done,
     /* 1026298 */   // Label 15208: @1026298
     /* 1026298 */   GIM_Try, /*On fail goto*//*Label 15209*/ GIMT_Encode4(1026375), // Rule ID 13182 //
     /* 1026303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026342 */     // MIs[0] policy
     /* 1026342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026352 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026374 */     // GIR_Coverage, 13182,
     /* 1026374 */     GIR_EraseRootFromParent_Done,
     /* 1026375 */   // Label 15209: @1026375
     /* 1026375 */   GIM_Try, /*On fail goto*//*Label 15210*/ GIMT_Encode4(1026452), // Rule ID 13183 //
     /* 1026380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1026391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1026394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1026397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1026400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026419 */     // MIs[0] policy
     /* 1026419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026429 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1026448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026451 */     // GIR_Coverage, 13183,
     /* 1026451 */     GIR_EraseRootFromParent_Done,
     /* 1026452 */   // Label 15210: @1026452
     /* 1026452 */   GIM_Try, /*On fail goto*//*Label 15211*/ GIMT_Encode4(1026529), // Rule ID 13186 //
     /* 1026457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1026468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1026471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1026474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1026477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026496 */     // MIs[0] policy
     /* 1026496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026528 */     // GIR_Coverage, 13186,
     /* 1026528 */     GIR_EraseRootFromParent_Done,
     /* 1026529 */   // Label 15211: @1026529
     /* 1026529 */   GIM_Try, /*On fail goto*//*Label 15212*/ GIMT_Encode4(1026606), // Rule ID 13187 //
     /* 1026534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1026545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1026548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1026551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1026554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026573 */     // MIs[0] policy
     /* 1026573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026583 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026605 */     // GIR_Coverage, 13187,
     /* 1026605 */     GIR_EraseRootFromParent_Done,
     /* 1026606 */   // Label 15212: @1026606
     /* 1026606 */   GIM_Try, /*On fail goto*//*Label 15213*/ GIMT_Encode4(1026683), // Rule ID 13190 //
     /* 1026611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1026622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1026625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1026628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1026631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026650 */     // MIs[0] policy
     /* 1026650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026660 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026682 */     // GIR_Coverage, 13190,
     /* 1026682 */     GIR_EraseRootFromParent_Done,
     /* 1026683 */   // Label 15213: @1026683
     /* 1026683 */   GIM_Try, /*On fail goto*//*Label 15214*/ GIMT_Encode4(1026760), // Rule ID 13191 //
     /* 1026688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1026699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1026702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1026705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1026708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1026727 */     // MIs[0] policy
     /* 1026727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026737 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1026740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026742 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026759 */     // GIR_Coverage, 13191,
     /* 1026759 */     GIR_EraseRootFromParent_Done,
     /* 1026760 */   // Label 15214: @1026760
     /* 1026760 */   GIM_Try, /*On fail goto*//*Label 15215*/ GIMT_Encode4(1026837), // Rule ID 13194 //
     /* 1026765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1026776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1026779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1026782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1026785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026804 */     // MIs[0] policy
     /* 1026804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026814 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026836 */     // GIR_Coverage, 13194,
     /* 1026836 */     GIR_EraseRootFromParent_Done,
     /* 1026837 */   // Label 15215: @1026837
     /* 1026837 */   GIM_Try, /*On fail goto*//*Label 15216*/ GIMT_Encode4(1026914), // Rule ID 13195 //
     /* 1026842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1026853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1026856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1026859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1026862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1026865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1026881 */     // MIs[0] policy
     /* 1026881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026891 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1026891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1026894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1026910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026913 */     // GIR_Coverage, 13195,
     /* 1026913 */     GIR_EraseRootFromParent_Done,
     /* 1026914 */   // Label 15216: @1026914
     /* 1026914 */   GIM_Try, /*On fail goto*//*Label 15217*/ GIMT_Encode4(1026991), // Rule ID 13198 //
     /* 1026919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1026922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1026927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1026930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1026933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1026936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1026939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1026942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1026958 */     // MIs[0] policy
     /* 1026958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1026961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1026968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1026968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1026971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1026973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1026975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1026977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1026979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1026984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1026987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1026989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1026990 */     // GIR_Coverage, 13198,
     /* 1026990 */     GIR_EraseRootFromParent_Done,
     /* 1026991 */   // Label 15217: @1026991
     /* 1026991 */   GIM_Try, /*On fail goto*//*Label 15218*/ GIMT_Encode4(1027068), // Rule ID 13199 //
     /* 1026996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1026999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1027007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1027010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1027013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1027016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027035 */     // MIs[0] policy
     /* 1027035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027045 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027067 */     // GIR_Coverage, 13199,
     /* 1027067 */     GIR_EraseRootFromParent_Done,
     /* 1027068 */   // Label 15218: @1027068
     /* 1027068 */   GIM_Try, /*On fail goto*//*Label 15219*/ GIMT_Encode4(1027145), // Rule ID 13202 //
     /* 1027073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027112 */     // MIs[0] policy
     /* 1027112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027122 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027144 */     // GIR_Coverage, 13202,
     /* 1027144 */     GIR_EraseRootFromParent_Done,
     /* 1027145 */   // Label 15219: @1027145
     /* 1027145 */   GIM_Try, /*On fail goto*//*Label 15220*/ GIMT_Encode4(1027222), // Rule ID 13203 //
     /* 1027150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1027161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1027164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1027167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1027170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027189 */     // MIs[0] policy
     /* 1027189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027199 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027221 */     // GIR_Coverage, 13203,
     /* 1027221 */     GIR_EraseRootFromParent_Done,
     /* 1027222 */   // Label 15220: @1027222
     /* 1027222 */   GIM_Try, /*On fail goto*//*Label 15221*/ GIMT_Encode4(1027299), // Rule ID 13206 //
     /* 1027227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027266 */     // MIs[0] policy
     /* 1027266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027276 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027298 */     // GIR_Coverage, 13206,
     /* 1027298 */     GIR_EraseRootFromParent_Done,
     /* 1027299 */   // Label 15221: @1027299
     /* 1027299 */   GIM_Try, /*On fail goto*//*Label 15222*/ GIMT_Encode4(1027376), // Rule ID 13207 //
     /* 1027304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1027315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1027318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1027321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1027324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027343 */     // MIs[0] policy
     /* 1027343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027353 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1027372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027375 */     // GIR_Coverage, 13207,
     /* 1027375 */     GIR_EraseRootFromParent_Done,
     /* 1027376 */   // Label 15222: @1027376
     /* 1027376 */   GIM_Try, /*On fail goto*//*Label 15223*/ GIMT_Encode4(1027453), // Rule ID 13210 //
     /* 1027381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1027384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027420 */     // MIs[0] policy
     /* 1027420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027452 */     // GIR_Coverage, 13210,
     /* 1027452 */     GIR_EraseRootFromParent_Done,
     /* 1027453 */   // Label 15223: @1027453
     /* 1027453 */   GIM_Try, /*On fail goto*//*Label 15224*/ GIMT_Encode4(1027530), // Rule ID 13211 //
     /* 1027458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1027461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1027469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1027472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1027475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1027478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1027497 */     // MIs[0] policy
     /* 1027497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027507 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2),
     /* 1027510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027529 */     // GIR_Coverage, 13211,
     /* 1027529 */     GIR_EraseRootFromParent_Done,
     /* 1027530 */   // Label 15224: @1027530
     /* 1027530 */   GIM_Try, /*On fail goto*//*Label 15225*/ GIMT_Encode4(1027607), // Rule ID 13214 //
     /* 1027535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1027538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1027546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1027549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1027552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1027555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027574 */     // MIs[0] policy
     /* 1027574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027584 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027606 */     // GIR_Coverage, 13214,
     /* 1027606 */     GIR_EraseRootFromParent_Done,
     /* 1027607 */   // Label 15225: @1027607
     /* 1027607 */   GIM_Try, /*On fail goto*//*Label 15226*/ GIMT_Encode4(1027684), // Rule ID 13215 //
     /* 1027612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1027615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1027623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1027626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1027629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1027632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1027651 */     // MIs[0] policy
     /* 1027651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027661 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4),
     /* 1027664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027683 */     // GIR_Coverage, 13215,
     /* 1027683 */     GIR_EraseRootFromParent_Done,
     /* 1027684 */   // Label 15226: @1027684
     /* 1027684 */   GIM_Try, /*On fail goto*//*Label 15227*/ GIMT_Encode4(1027761), // Rule ID 13218 //
     /* 1027689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1027692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1027700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1027703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1027706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1027709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027728 */     // MIs[0] policy
     /* 1027728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027738 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027760 */     // GIR_Coverage, 13218,
     /* 1027760 */     GIR_EraseRootFromParent_Done,
     /* 1027761 */   // Label 15227: @1027761
     /* 1027761 */   GIM_Try, /*On fail goto*//*Label 15228*/ GIMT_Encode4(1027838), // Rule ID 13219 //
     /* 1027766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1027769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1027777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1027780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1027783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1027786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1027805 */     // MIs[0] policy
     /* 1027805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027815 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8),
     /* 1027818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1027834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027837 */     // GIR_Coverage, 13219,
     /* 1027837 */     GIR_EraseRootFromParent_Done,
     /* 1027838 */   // Label 15228: @1027838
     /* 1027838 */   GIM_Try, /*On fail goto*//*Label 15229*/ GIMT_Encode4(1027915), // Rule ID 13222 //
     /* 1027843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1027846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1027854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1027857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1027860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1027863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1027866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027882 */     // MIs[0] policy
     /* 1027882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1027892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1027895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027914 */     // GIR_Coverage, 13222,
     /* 1027914 */     GIR_EraseRootFromParent_Done,
     /* 1027915 */   // Label 15229: @1027915
     /* 1027915 */   GIM_Try, /*On fail goto*//*Label 15230*/ GIMT_Encode4(1027992), // Rule ID 13223 //
     /* 1027920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1027923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1027928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1027931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1027934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1027937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1027940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1027943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1027955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1027959 */     // MIs[0] policy
     /* 1027959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1027962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1027969 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1027969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8),
     /* 1027972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1027974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1027976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1027978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1027980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1027985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1027988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1027990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1027991 */     // GIR_Coverage, 13223,
     /* 1027991 */     GIR_EraseRootFromParent_Done,
     /* 1027992 */   // Label 15230: @1027992
     /* 1027992 */   GIM_Try, /*On fail goto*//*Label 15231*/ GIMT_Encode4(1028069), // Rule ID 13226 //
     /* 1027997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028036 */     // MIs[0] policy
     /* 1028036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028046 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028068 */     // GIR_Coverage, 13226,
     /* 1028068 */     GIR_EraseRootFromParent_Done,
     /* 1028069 */   // Label 15231: @1028069
     /* 1028069 */   GIM_Try, /*On fail goto*//*Label 15232*/ GIMT_Encode4(1028146), // Rule ID 13227 //
     /* 1028074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1028085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1028088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1028094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028113 */     // MIs[0] policy
     /* 1028113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028123 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028128 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028145 */     // GIR_Coverage, 13227,
     /* 1028145 */     GIR_EraseRootFromParent_Done,
     /* 1028146 */   // Label 15232: @1028146
     /* 1028146 */   GIM_Try, /*On fail goto*//*Label 15233*/ GIMT_Encode4(1028223), // Rule ID 13230 //
     /* 1028151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028190 */     // MIs[0] policy
     /* 1028190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028200 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028222 */     // GIR_Coverage, 13230,
     /* 1028222 */     GIR_EraseRootFromParent_Done,
     /* 1028223 */   // Label 15233: @1028223
     /* 1028223 */   GIM_Try, /*On fail goto*//*Label 15234*/ GIMT_Encode4(1028300), // Rule ID 13231 //
     /* 1028228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1028239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1028242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1028248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028267 */     // MIs[0] policy
     /* 1028267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028277 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028299 */     // GIR_Coverage, 13231,
     /* 1028299 */     GIR_EraseRootFromParent_Done,
     /* 1028300 */   // Label 15234: @1028300
     /* 1028300 */   GIM_Try, /*On fail goto*//*Label 15235*/ GIMT_Encode4(1028377), // Rule ID 13234 //
     /* 1028305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028344 */     // MIs[0] policy
     /* 1028344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028354 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028376 */     // GIR_Coverage, 13234,
     /* 1028376 */     GIR_EraseRootFromParent_Done,
     /* 1028377 */   // Label 15235: @1028377
     /* 1028377 */   GIM_Try, /*On fail goto*//*Label 15236*/ GIMT_Encode4(1028454), // Rule ID 13235 //
     /* 1028382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1028393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1028396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1028402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028421 */     // MIs[0] policy
     /* 1028421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028431 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4),
     /* 1028434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028453 */     // GIR_Coverage, 13235,
     /* 1028453 */     GIR_EraseRootFromParent_Done,
     /* 1028454 */   // Label 15236: @1028454
     /* 1028454 */   GIM_Try, /*On fail goto*//*Label 15237*/ GIMT_Encode4(1028531), // Rule ID 13238 //
     /* 1028459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1028470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1028473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1028479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028498 */     // MIs[0] policy
     /* 1028498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028508 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028530 */     // GIR_Coverage, 13238,
     /* 1028530 */     GIR_EraseRootFromParent_Done,
     /* 1028531 */   // Label 15237: @1028531
     /* 1028531 */   GIM_Try, /*On fail goto*//*Label 15238*/ GIMT_Encode4(1028608), // Rule ID 13239 //
     /* 1028536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1028547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1028550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1028556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028575 */     // MIs[0] policy
     /* 1028575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028585 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028607 */     // GIR_Coverage, 13239,
     /* 1028607 */     GIR_EraseRootFromParent_Done,
     /* 1028608 */   // Label 15238: @1028608
     /* 1028608 */   GIM_Try, /*On fail goto*//*Label 15239*/ GIMT_Encode4(1028685), // Rule ID 13242 //
     /* 1028613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1028624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1028627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1028633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028652 */     // MIs[0] policy
     /* 1028652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028684 */     // GIR_Coverage, 13242,
     /* 1028684 */     GIR_EraseRootFromParent_Done,
     /* 1028685 */   // Label 15239: @1028685
     /* 1028685 */   GIM_Try, /*On fail goto*//*Label 15240*/ GIMT_Encode4(1028762), // Rule ID 13243 //
     /* 1028690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1028701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1028704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1028710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028729 */     // MIs[0] policy
     /* 1028729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028739 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2),
     /* 1028742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1028758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028761 */     // GIR_Coverage, 13243,
     /* 1028761 */     GIR_EraseRootFromParent_Done,
     /* 1028762 */   // Label 15240: @1028762
     /* 1028762 */   GIM_Try, /*On fail goto*//*Label 15241*/ GIMT_Encode4(1028839), // Rule ID 13246 //
     /* 1028767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1028778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1028781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028806 */     // MIs[0] policy
     /* 1028806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028816 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1028819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028838 */     // GIR_Coverage, 13246,
     /* 1028838 */     GIR_EraseRootFromParent_Done,
     /* 1028839 */   // Label 15241: @1028839
     /* 1028839 */   GIM_Try, /*On fail goto*//*Label 15242*/ GIMT_Encode4(1028916), // Rule ID 13247 //
     /* 1028844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1028847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1028855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1028858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1028861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1028864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1028867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028883 */     // MIs[0] policy
     /* 1028883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028893 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11418:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1028893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1028896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1028912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028915 */     // GIR_Coverage, 13247,
     /* 1028915 */     GIR_EraseRootFromParent_Done,
     /* 1028916 */   // Label 15242: @1028916
     /* 1028916 */   GIM_Try, /*On fail goto*//*Label 15243*/ GIMT_Encode4(1028993), // Rule ID 13250 //
     /* 1028921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1028924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1028929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1028932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1028935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1028938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1028941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1028944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1028956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1028960 */     // MIs[0] policy
     /* 1028960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1028963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1028970 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1028970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1028973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1028975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1028977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1028979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1028981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1028986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1028989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1028991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1028992 */     // GIR_Coverage, 13250,
     /* 1028992 */     GIR_EraseRootFromParent_Done,
     /* 1028993 */   // Label 15243: @1028993
     /* 1028993 */   GIM_Try, /*On fail goto*//*Label 15244*/ GIMT_Encode4(1029070), // Rule ID 13251 //
     /* 1028998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1029009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1029012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1029018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029037 */     // MIs[0] policy
     /* 1029037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029047 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11418:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029069 */     // GIR_Coverage, 13251,
     /* 1029069 */     GIR_EraseRootFromParent_Done,
     /* 1029070 */   // Label 15244: @1029070
     /* 1029070 */   GIM_Try, /*On fail goto*//*Label 15245*/ GIMT_Encode4(1029147), // Rule ID 13254 //
     /* 1029075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029114 */     // MIs[0] policy
     /* 1029114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029146 */     // GIR_Coverage, 13254,
     /* 1029146 */     GIR_EraseRootFromParent_Done,
     /* 1029147 */   // Label 15245: @1029147
     /* 1029147 */   GIM_Try, /*On fail goto*//*Label 15246*/ GIMT_Encode4(1029224), // Rule ID 13255 //
     /* 1029152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1029163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1029166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1029172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029191 */     // MIs[0] policy
     /* 1029191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11418:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1029220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029223 */     // GIR_Coverage, 13255,
     /* 1029223 */     GIR_EraseRootFromParent_Done,
     /* 1029224 */   // Label 15246: @1029224
     /* 1029224 */   GIM_Try, /*On fail goto*//*Label 15247*/ GIMT_Encode4(1029301), // Rule ID 13258 //
     /* 1029229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1029232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029268 */     // MIs[0] policy
     /* 1029268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029300 */     // GIR_Coverage, 13258,
     /* 1029300 */     GIR_EraseRootFromParent_Done,
     /* 1029301 */   // Label 15247: @1029301
     /* 1029301 */   GIM_Try, /*On fail goto*//*Label 15248*/ GIMT_Encode4(1029378), // Rule ID 13259 //
     /* 1029306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1029309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1029317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1029320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1029326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1029345 */     // MIs[0] policy
     /* 1029345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029355 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11418:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1),
     /* 1029358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1029374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029377 */     // GIR_Coverage, 13259,
     /* 1029377 */     GIR_EraseRootFromParent_Done,
     /* 1029378 */   // Label 15248: @1029378
     /* 1029378 */   GIM_Try, /*On fail goto*//*Label 15249*/ GIMT_Encode4(1029455), // Rule ID 13262 //
     /* 1029383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029422 */     // MIs[0] policy
     /* 1029422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029454 */     // GIR_Coverage, 13262,
     /* 1029454 */     GIR_EraseRootFromParent_Done,
     /* 1029455 */   // Label 15249: @1029455
     /* 1029455 */   GIM_Try, /*On fail goto*//*Label 15250*/ GIMT_Encode4(1029532), // Rule ID 13263 //
     /* 1029460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1029471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1029474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1029480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029499 */     // MIs[0] policy
     /* 1029499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029509 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029531 */     // GIR_Coverage, 13263,
     /* 1029531 */     GIR_EraseRootFromParent_Done,
     /* 1029532 */   // Label 15250: @1029532
     /* 1029532 */   GIM_Try, /*On fail goto*//*Label 15251*/ GIMT_Encode4(1029609), // Rule ID 13266 //
     /* 1029537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1029548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1029551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1029557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029576 */     // MIs[0] policy
     /* 1029576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1029589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029608 */     // GIR_Coverage, 13266,
     /* 1029608 */     GIR_EraseRootFromParent_Done,
     /* 1029609 */   // Label 15251: @1029609
     /* 1029609 */   GIM_Try, /*On fail goto*//*Label 15252*/ GIMT_Encode4(1029686), // Rule ID 13267 //
     /* 1029614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1029625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1029628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1029634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1029653 */     // MIs[0] policy
     /* 1029653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029663 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1029666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029685 */     // GIR_Coverage, 13267,
     /* 1029685 */     GIR_EraseRootFromParent_Done,
     /* 1029686 */   // Label 15252: @1029686
     /* 1029686 */   GIM_Try, /*On fail goto*//*Label 15253*/ GIMT_Encode4(1029763), // Rule ID 13270 //
     /* 1029691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1029702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1029705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1029711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029730 */     // MIs[0] policy
     /* 1029730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1029743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029762 */     // GIR_Coverage, 13270,
     /* 1029762 */     GIR_EraseRootFromParent_Done,
     /* 1029763 */   // Label 15253: @1029763
     /* 1029763 */   GIM_Try, /*On fail goto*//*Label 15254*/ GIMT_Encode4(1029840), // Rule ID 13271 //
     /* 1029768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1029779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1029782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1029788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1029807 */     // MIs[0] policy
     /* 1029807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029817 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1029820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1029836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029839 */     // GIR_Coverage, 13271,
     /* 1029839 */     GIR_EraseRootFromParent_Done,
     /* 1029840 */   // Label 15254: @1029840
     /* 1029840 */   GIM_Try, /*On fail goto*//*Label 15255*/ GIMT_Encode4(1029917), // Rule ID 13274 //
     /* 1029845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1029848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1029856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1029859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1029862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1029865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1029868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029884 */     // MIs[0] policy
     /* 1029884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029894 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1029894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029916 */     // GIR_Coverage, 13274,
     /* 1029916 */     GIR_EraseRootFromParent_Done,
     /* 1029917 */   // Label 15255: @1029917
     /* 1029917 */   GIM_Try, /*On fail goto*//*Label 15256*/ GIMT_Encode4(1029994), // Rule ID 13275 //
     /* 1029922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1029925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1029930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1029933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1029936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1029939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1029942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1029945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1029957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1029961 */     // MIs[0] policy
     /* 1029961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1029964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1029971 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1029971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1029974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1029976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1029978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1029980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1029982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1029987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1029990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1029992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1029993 */     // GIR_Coverage, 13275,
     /* 1029993 */     GIR_EraseRootFromParent_Done,
     /* 1029994 */   // Label 15256: @1029994
     /* 1029994 */   GIM_Try, /*On fail goto*//*Label 15257*/ GIMT_Encode4(1030071), // Rule ID 13278 //
     /* 1029999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030038 */     // MIs[0] policy
     /* 1030038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030070 */     // GIR_Coverage, 13278,
     /* 1030070 */     GIR_EraseRootFromParent_Done,
     /* 1030071 */   // Label 15257: @1030071
     /* 1030071 */   GIM_Try, /*On fail goto*//*Label 15258*/ GIMT_Encode4(1030148), // Rule ID 13279 //
     /* 1030076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1030087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1030090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1030096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030115 */     // MIs[0] policy
     /* 1030115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030125 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030147 */     // GIR_Coverage, 13279,
     /* 1030147 */     GIR_EraseRootFromParent_Done,
     /* 1030148 */   // Label 15258: @1030148
     /* 1030148 */   GIM_Try, /*On fail goto*//*Label 15259*/ GIMT_Encode4(1030225), // Rule ID 13282 //
     /* 1030153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030192 */     // MIs[0] policy
     /* 1030192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030224 */     // GIR_Coverage, 13282,
     /* 1030224 */     GIR_EraseRootFromParent_Done,
     /* 1030225 */   // Label 15259: @1030225
     /* 1030225 */   GIM_Try, /*On fail goto*//*Label 15260*/ GIMT_Encode4(1030302), // Rule ID 13283 //
     /* 1030230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1030241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1030244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1030250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030269 */     // MIs[0] policy
     /* 1030269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030279 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1030298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030301 */     // GIR_Coverage, 13283,
     /* 1030301 */     GIR_EraseRootFromParent_Done,
     /* 1030302 */   // Label 15260: @1030302
     /* 1030302 */   GIM_Try, /*On fail goto*//*Label 15261*/ GIMT_Encode4(1030379), // Rule ID 13286 //
     /* 1030307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030346 */     // MIs[0] policy
     /* 1030346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030378 */     // GIR_Coverage, 13286,
     /* 1030378 */     GIR_EraseRootFromParent_Done,
     /* 1030379 */   // Label 15261: @1030379
     /* 1030379 */   GIM_Try, /*On fail goto*//*Label 15262*/ GIMT_Encode4(1030456), // Rule ID 13287 //
     /* 1030384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1030395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1030398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1030404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030423 */     // MIs[0] policy
     /* 1030423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030455 */     // GIR_Coverage, 13287,
     /* 1030455 */     GIR_EraseRootFromParent_Done,
     /* 1030456 */   // Label 15262: @1030456
     /* 1030456 */   GIM_Try, /*On fail goto*//*Label 15263*/ GIMT_Encode4(1030533), // Rule ID 13290 //
     /* 1030461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1030472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1030475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1030481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030500 */     // MIs[0] policy
     /* 1030500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030510 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030532 */     // GIR_Coverage, 13290,
     /* 1030532 */     GIR_EraseRootFromParent_Done,
     /* 1030533 */   // Label 15263: @1030533
     /* 1030533 */   GIM_Try, /*On fail goto*//*Label 15264*/ GIMT_Encode4(1030610), // Rule ID 13291 //
     /* 1030538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1030549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1030552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1030558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030577 */     // MIs[0] policy
     /* 1030577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030587 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030609 */     // GIR_Coverage, 13291,
     /* 1030609 */     GIR_EraseRootFromParent_Done,
     /* 1030610 */   // Label 15264: @1030610
     /* 1030610 */   GIM_Try, /*On fail goto*//*Label 15265*/ GIMT_Encode4(1030687), // Rule ID 13294 //
     /* 1030615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1030618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1030626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1030629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1030635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030654 */     // MIs[0] policy
     /* 1030654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030664 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030686 */     // GIR_Coverage, 13294,
     /* 1030686 */     GIR_EraseRootFromParent_Done,
     /* 1030687 */   // Label 15265: @1030687
     /* 1030687 */   GIM_Try, /*On fail goto*//*Label 15266*/ GIMT_Encode4(1030764), // Rule ID 13295 //
     /* 1030692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1030695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1030703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1030706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1030712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1030731 */     // MIs[0] policy
     /* 1030731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030741 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1030744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1030760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030763 */     // GIR_Coverage, 13295,
     /* 1030763 */     GIR_EraseRootFromParent_Done,
     /* 1030764 */   // Label 15266: @1030764
     /* 1030764 */   GIM_Try, /*On fail goto*//*Label 15267*/ GIMT_Encode4(1030841), // Rule ID 13298 //
     /* 1030769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1030780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1030783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1030789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030808 */     // MIs[0] policy
     /* 1030808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030840 */     // GIR_Coverage, 13298,
     /* 1030840 */     GIR_EraseRootFromParent_Done,
     /* 1030841 */   // Label 15267: @1030841
     /* 1030841 */   GIM_Try, /*On fail goto*//*Label 15268*/ GIMT_Encode4(1030918), // Rule ID 13299 //
     /* 1030846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1030849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1030857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1030860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1030863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1030866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1030869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1030885 */     // MIs[0] policy
     /* 1030885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11418:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1030895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2),
     /* 1030898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030917 */     // GIR_Coverage, 13299,
     /* 1030917 */     GIR_EraseRootFromParent_Done,
     /* 1030918 */   // Label 15268: @1030918
     /* 1030918 */   GIM_Try, /*On fail goto*//*Label 15269*/ GIMT_Encode4(1030995), // Rule ID 13302 //
     /* 1030923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1030926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1030931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1030934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1030937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1030940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1030943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1030946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1030958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1030962 */     // MIs[0] policy
     /* 1030962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1030965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1030972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1030972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1030975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1030977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1030979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1030981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1030983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1030988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1030991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1030993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1030994 */     // GIR_Coverage, 13302,
     /* 1030994 */     GIR_EraseRootFromParent_Done,
     /* 1030995 */   // Label 15269: @1030995
     /* 1030995 */   GIM_Try, /*On fail goto*//*Label 15270*/ GIMT_Encode4(1031072), // Rule ID 13303 //
     /* 1031000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1031011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1031014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1031020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031039 */     // MIs[0] policy
     /* 1031039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031049 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11418:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4),
     /* 1031052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031071 */     // GIR_Coverage, 13303,
     /* 1031071 */     GIR_EraseRootFromParent_Done,
     /* 1031072 */   // Label 15270: @1031072
     /* 1031072 */   GIM_Try, /*On fail goto*//*Label 15271*/ GIMT_Encode4(1031149), // Rule ID 13306 //
     /* 1031077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1031080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1031094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031116 */     // MIs[0] policy
     /* 1031116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031126 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031148 */     // GIR_Coverage, 13306,
     /* 1031148 */     GIR_EraseRootFromParent_Done,
     /* 1031149 */   // Label 15271: @1031149
     /* 1031149 */   GIM_Try, /*On fail goto*//*Label 15272*/ GIMT_Encode4(1031226), // Rule ID 13307 //
     /* 1031154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1031157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac),
     /* 1031162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1031165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1031168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1031171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1031174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1031189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1031193 */     // MIs[0] policy
     /* 1031193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031203 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11418:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8),
     /* 1031206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1031222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031225 */     // GIR_Coverage, 13307,
     /* 1031225 */     GIR_EraseRootFromParent_Done,
     /* 1031226 */   // Label 15272: @1031226
     /* 1031226 */   GIM_Try, /*On fail goto*//*Label 15273*/ GIMT_Encode4(1031303), // Rule ID 13310 //
     /* 1031231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031270 */     // MIs[0] policy
     /* 1031270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031280 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031302 */     // GIR_Coverage, 13310,
     /* 1031302 */     GIR_EraseRootFromParent_Done,
     /* 1031303 */   // Label 15273: @1031303
     /* 1031303 */   GIM_Try, /*On fail goto*//*Label 15274*/ GIMT_Encode4(1031380), // Rule ID 13311 //
     /* 1031308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1031319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1031322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1031325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1031328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031347 */     // MIs[0] policy
     /* 1031347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031357 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8),
     /* 1031360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031379 */     // GIR_Coverage, 13311,
     /* 1031379 */     GIR_EraseRootFromParent_Done,
     /* 1031380 */   // Label 15274: @1031380
     /* 1031380 */   GIM_Try, /*On fail goto*//*Label 15275*/ GIMT_Encode4(1031457), // Rule ID 13314 //
     /* 1031385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1031405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031424 */     // MIs[0] policy
     /* 1031424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1031437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031456 */     // GIR_Coverage, 13314,
     /* 1031456 */     GIR_EraseRootFromParent_Done,
     /* 1031457 */   // Label 15275: @1031457
     /* 1031457 */   GIM_Try, /*On fail goto*//*Label 15276*/ GIMT_Encode4(1031534), // Rule ID 13315 //
     /* 1031462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1031473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1031476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1031479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1031482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031501 */     // MIs[0] policy
     /* 1031501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031511 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1031514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031533 */     // GIR_Coverage, 13315,
     /* 1031533 */     GIR_EraseRootFromParent_Done,
     /* 1031534 */   // Label 15276: @1031534
     /* 1031534 */   GIM_Try, /*On fail goto*//*Label 15277*/ GIMT_Encode4(1031611), // Rule ID 13318 //
     /* 1031539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1031550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1031553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1031556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1031559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031578 */     // MIs[0] policy
     /* 1031578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1031591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031610 */     // GIR_Coverage, 13318,
     /* 1031610 */     GIR_EraseRootFromParent_Done,
     /* 1031611 */   // Label 15277: @1031611
     /* 1031611 */   GIM_Try, /*On fail goto*//*Label 15278*/ GIMT_Encode4(1031688), // Rule ID 13319 //
     /* 1031616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1031627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1031630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1031633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1031636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031655 */     // MIs[0] policy
     /* 1031655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031665 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1031668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031687 */     // GIR_Coverage, 13319,
     /* 1031687 */     GIR_EraseRootFromParent_Done,
     /* 1031688 */   // Label 15278: @1031688
     /* 1031688 */   GIM_Try, /*On fail goto*//*Label 15279*/ GIMT_Encode4(1031765), // Rule ID 13322 //
     /* 1031693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1031704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1031707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1031710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1031713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031732 */     // MIs[0] policy
     /* 1031732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1031745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031764 */     // GIR_Coverage, 13322,
     /* 1031764 */     GIR_EraseRootFromParent_Done,
     /* 1031765 */   // Label 15279: @1031765
     /* 1031765 */   GIM_Try, /*On fail goto*//*Label 15280*/ GIMT_Encode4(1031842), // Rule ID 13323 //
     /* 1031770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1031781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1031784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1031787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1031790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1031809 */     // MIs[0] policy
     /* 1031809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031819 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1031822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031841 */     // GIR_Coverage, 13323,
     /* 1031841 */     GIR_EraseRootFromParent_Done,
     /* 1031842 */   // Label 15280: @1031842
     /* 1031842 */   GIM_Try, /*On fail goto*//*Label 15281*/ GIMT_Encode4(1031919), // Rule ID 13326 //
     /* 1031847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1031850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1031864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1031867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1031870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031886 */     // MIs[0] policy
     /* 1031886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031896 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1031896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1031899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031918 */     // GIR_Coverage, 13326,
     /* 1031918 */     GIR_EraseRootFromParent_Done,
     /* 1031919 */   // Label 15281: @1031919
     /* 1031919 */   GIM_Try, /*On fail goto*//*Label 15282*/ GIMT_Encode4(1031996), // Rule ID 13327 //
     /* 1031924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1031927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1031932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1031935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1031938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1031941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1031944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1031947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1031955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1031963 */     // MIs[0] policy
     /* 1031963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1031966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1031973 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1031973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1031976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1031978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1031980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1031982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1031984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1031989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1031992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1031994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1031995 */     // GIR_Coverage, 13327,
     /* 1031995 */     GIR_EraseRootFromParent_Done,
     /* 1031996 */   // Label 15282: @1031996
     /* 1031996 */   GIM_Try, /*On fail goto*//*Label 15283*/ GIMT_Encode4(1032073), // Rule ID 13330 //
     /* 1032001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032040 */     // MIs[0] policy
     /* 1032040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032050 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032072 */     // GIR_Coverage, 13330,
     /* 1032072 */     GIR_EraseRootFromParent_Done,
     /* 1032073 */   // Label 15283: @1032073
     /* 1032073 */   GIM_Try, /*On fail goto*//*Label 15284*/ GIMT_Encode4(1032150), // Rule ID 13331 //
     /* 1032078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1032089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1032092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1032095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1032098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032117 */     // MIs[0] policy
     /* 1032117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032127 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1032146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032149 */     // GIR_Coverage, 13331,
     /* 1032149 */     GIR_EraseRootFromParent_Done,
     /* 1032150 */   // Label 15284: @1032150
     /* 1032150 */   GIM_Try, /*On fail goto*//*Label 15285*/ GIMT_Encode4(1032227), // Rule ID 13334 //
     /* 1032155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032194 */     // MIs[0] policy
     /* 1032194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032226 */     // GIR_Coverage, 13334,
     /* 1032226 */     GIR_EraseRootFromParent_Done,
     /* 1032227 */   // Label 15285: @1032227
     /* 1032227 */   GIM_Try, /*On fail goto*//*Label 15286*/ GIMT_Encode4(1032304), // Rule ID 13335 //
     /* 1032232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1032243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1032246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1032249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1032252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032271 */     // MIs[0] policy
     /* 1032271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4),
     /* 1032284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032303 */     // GIR_Coverage, 13335,
     /* 1032303 */     GIR_EraseRootFromParent_Done,
     /* 1032304 */   // Label 15286: @1032304
     /* 1032304 */   GIM_Try, /*On fail goto*//*Label 15287*/ GIMT_Encode4(1032381), // Rule ID 13338 //
     /* 1032309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032348 */     // MIs[0] policy
     /* 1032348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032380 */     // GIR_Coverage, 13338,
     /* 1032380 */     GIR_EraseRootFromParent_Done,
     /* 1032381 */   // Label 15287: @1032381
     /* 1032381 */   GIM_Try, /*On fail goto*//*Label 15288*/ GIMT_Encode4(1032458), // Rule ID 13339 //
     /* 1032386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1032397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1032400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1032403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1032406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032425 */     // MIs[0] policy
     /* 1032425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032457 */     // GIR_Coverage, 13339,
     /* 1032457 */     GIR_EraseRootFromParent_Done,
     /* 1032458 */   // Label 15288: @1032458
     /* 1032458 */   GIM_Try, /*On fail goto*//*Label 15289*/ GIMT_Encode4(1032535), // Rule ID 13342 //
     /* 1032463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1032480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1032483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032502 */     // MIs[0] policy
     /* 1032502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032512 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032534 */     // GIR_Coverage, 13342,
     /* 1032534 */     GIR_EraseRootFromParent_Done,
     /* 1032535 */   // Label 15289: @1032535
     /* 1032535 */   GIM_Try, /*On fail goto*//*Label 15290*/ GIMT_Encode4(1032612), // Rule ID 13343 //
     /* 1032540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1032551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1032554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1032557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1032560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032579 */     // MIs[0] policy
     /* 1032579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1032592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032611 */     // GIR_Coverage, 13343,
     /* 1032611 */     GIR_EraseRootFromParent_Done,
     /* 1032612 */   // Label 15290: @1032612
     /* 1032612 */   GIM_Try, /*On fail goto*//*Label 15291*/ GIMT_Encode4(1032689), // Rule ID 13346 //
     /* 1032617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1032628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1032631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1032634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1032637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032656 */     // MIs[0] policy
     /* 1032656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032666 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032688 */     // GIR_Coverage, 13346,
     /* 1032688 */     GIR_EraseRootFromParent_Done,
     /* 1032689 */   // Label 15291: @1032689
     /* 1032689 */   GIM_Try, /*On fail goto*//*Label 15292*/ GIMT_Encode4(1032766), // Rule ID 13347 //
     /* 1032694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1032705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1032708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1032711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1032714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1032733 */     // MIs[0] policy
     /* 1032733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032743 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1032746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032765 */     // GIR_Coverage, 13347,
     /* 1032765 */     GIR_EraseRootFromParent_Done,
     /* 1032766 */   // Label 15292: @1032766
     /* 1032766 */   GIM_Try, /*On fail goto*//*Label 15293*/ GIMT_Encode4(1032843), // Rule ID 13350 //
     /* 1032771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1032774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1032782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1032785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1032788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1032791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032810 */     // MIs[0] policy
     /* 1032810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032820 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032842 */     // GIR_Coverage, 13350,
     /* 1032842 */     GIR_EraseRootFromParent_Done,
     /* 1032843 */   // Label 15293: @1032843
     /* 1032843 */   GIM_Try, /*On fail goto*//*Label 15294*/ GIMT_Encode4(1032920), // Rule ID 13351 //
     /* 1032848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1032851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1032859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1032862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1032865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1032868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1032871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1032879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1032887 */     // MIs[0] policy
     /* 1032887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032897 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1032897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1032900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1032916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032919 */     // GIR_Coverage, 13351,
     /* 1032919 */     GIR_EraseRootFromParent_Done,
     /* 1032920 */   // Label 15294: @1032920
     /* 1032920 */   GIM_Try, /*On fail goto*//*Label 15295*/ GIMT_Encode4(1032997), // Rule ID 13354 //
     /* 1032925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1032928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1032933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1032936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1032939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1032942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1032945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1032948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1032964 */     // MIs[0] policy
     /* 1032964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1032967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1032974 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1032974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1032977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1032979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1032981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1032983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1032985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1032990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1032993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1032995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1032996 */     // GIR_Coverage, 13354,
     /* 1032996 */     GIR_EraseRootFromParent_Done,
     /* 1032997 */   // Label 15295: @1032997
     /* 1032997 */   GIM_Try, /*On fail goto*//*Label 15296*/ GIMT_Encode4(1033074), // Rule ID 13355 //
     /* 1033002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1033013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1033016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1033019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1033022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033041 */     // MIs[0] policy
     /* 1033041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033051 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2),
     /* 1033054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033073 */     // GIR_Coverage, 13355,
     /* 1033073 */     GIR_EraseRootFromParent_Done,
     /* 1033074 */   // Label 15296: @1033074
     /* 1033074 */   GIM_Try, /*On fail goto*//*Label 15297*/ GIMT_Encode4(1033151), // Rule ID 13358 //
     /* 1033079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033118 */     // MIs[0] policy
     /* 1033118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033150 */     // GIR_Coverage, 13358,
     /* 1033150 */     GIR_EraseRootFromParent_Done,
     /* 1033151 */   // Label 15297: @1033151
     /* 1033151 */   GIM_Try, /*On fail goto*//*Label 15298*/ GIMT_Encode4(1033228), // Rule ID 13359 //
     /* 1033156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1033167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1033170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1033173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1033176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033195 */     // MIs[0] policy
     /* 1033195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1),
     /* 1033208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033227 */     // GIR_Coverage, 13359,
     /* 1033227 */     GIR_EraseRootFromParent_Done,
     /* 1033228 */   // Label 15298: @1033228
     /* 1033228 */   GIM_Try, /*On fail goto*//*Label 15299*/ GIMT_Encode4(1033305), // Rule ID 13362 //
     /* 1033233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033272 */     // MIs[0] policy
     /* 1033272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033304 */     // GIR_Coverage, 13362,
     /* 1033304 */     GIR_EraseRootFromParent_Done,
     /* 1033305 */   // Label 15299: @1033305
     /* 1033305 */   GIM_Try, /*On fail goto*//*Label 15300*/ GIMT_Encode4(1033382), // Rule ID 13363 //
     /* 1033310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1033321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1033324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1033327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1033330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1033349 */     // MIs[0] policy
     /* 1033349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2),
     /* 1033362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033381 */     // GIR_Coverage, 13363,
     /* 1033381 */     GIR_EraseRootFromParent_Done,
     /* 1033382 */   // Label 15300: @1033382
     /* 1033382 */   GIM_Try, /*On fail goto*//*Label 15301*/ GIMT_Encode4(1033459), // Rule ID 13366 //
     /* 1033387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1033390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1033404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1033407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033426 */     // MIs[0] policy
     /* 1033426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033458 */     // GIR_Coverage, 13366,
     /* 1033458 */     GIR_EraseRootFromParent_Done,
     /* 1033459 */   // Label 15301: @1033459
     /* 1033459 */   GIM_Try, /*On fail goto*//*Label 15302*/ GIMT_Encode4(1033536), // Rule ID 13367 //
     /* 1033464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1033467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1033475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1033478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1033481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1033484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1033495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1033503 */     // MIs[0] policy
     /* 1033503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033513 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4),
     /* 1033516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1033532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033535 */     // GIR_Coverage, 13367,
     /* 1033535 */     GIR_EraseRootFromParent_Done,
     /* 1033536 */   // Label 15302: @1033536
     /* 1033536 */   GIM_Try, /*On fail goto*//*Label 15303*/ GIMT_Encode4(1033613), // Rule ID 13370 //
     /* 1033541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1033552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1033555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1033561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033580 */     // MIs[0] policy
     /* 1033580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033590 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1033593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033612 */     // GIR_Coverage, 13370,
     /* 1033612 */     GIR_EraseRootFromParent_Done,
     /* 1033613 */   // Label 15303: @1033613
     /* 1033613 */   GIM_Try, /*On fail goto*//*Label 15304*/ GIMT_Encode4(1033690), // Rule ID 13371 //
     /* 1033618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1033629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1033632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1033638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033657 */     // MIs[0] policy
     /* 1033657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033667 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8),
     /* 1033670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033689 */     // GIR_Coverage, 13371,
     /* 1033689 */     GIR_EraseRootFromParent_Done,
     /* 1033690 */   // Label 15304: @1033690
     /* 1033690 */   GIM_Try, /*On fail goto*//*Label 15305*/ GIMT_Encode4(1033767), // Rule ID 13374 //
     /* 1033695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1033706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1033709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1033715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033734 */     // MIs[0] policy
     /* 1033734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1033747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033766 */     // GIR_Coverage, 13374,
     /* 1033766 */     GIR_EraseRootFromParent_Done,
     /* 1033767 */   // Label 15305: @1033767
     /* 1033767 */   GIM_Try, /*On fail goto*//*Label 15306*/ GIMT_Encode4(1033844), // Rule ID 13375 //
     /* 1033772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1033783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1033786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1033792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033811 */     // MIs[0] policy
     /* 1033811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033821 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1033824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033843 */     // GIR_Coverage, 13375,
     /* 1033843 */     GIR_EraseRootFromParent_Done,
     /* 1033844 */   // Label 15306: @1033844
     /* 1033844 */   GIM_Try, /*On fail goto*//*Label 15307*/ GIMT_Encode4(1033921), // Rule ID 13378 //
     /* 1033849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1033852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1033866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1033869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1033872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033888 */     // MIs[0] policy
     /* 1033888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1033898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1033901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033920 */     // GIR_Coverage, 13378,
     /* 1033920 */     GIR_EraseRootFromParent_Done,
     /* 1033921 */   // Label 15307: @1033921
     /* 1033921 */   GIM_Try, /*On fail goto*//*Label 15308*/ GIMT_Encode4(1033998), // Rule ID 13379 //
     /* 1033926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1033929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1033934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1033937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1033940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1033943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1033946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1033949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1033961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1033965 */     // MIs[0] policy
     /* 1033965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1033968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1033975 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11582:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1033975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1033978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1033980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1033982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1033984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1033986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1033991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1033994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1033996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1033997 */     // GIR_Coverage, 13379,
     /* 1033997 */     GIR_EraseRootFromParent_Done,
     /* 1033998 */   // Label 15308: @1033998
     /* 1033998 */   GIM_Try, /*On fail goto*//*Label 15309*/ GIMT_Encode4(1034075), // Rule ID 13382 //
     /* 1034003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034042 */     // MIs[0] policy
     /* 1034042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034074 */     // GIR_Coverage, 13382,
     /* 1034074 */     GIR_EraseRootFromParent_Done,
     /* 1034075 */   // Label 15309: @1034075
     /* 1034075 */   GIM_Try, /*On fail goto*//*Label 15310*/ GIMT_Encode4(1034152), // Rule ID 13383 //
     /* 1034080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1034091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1034094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1034100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034119 */     // MIs[0] policy
     /* 1034119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034151 */     // GIR_Coverage, 13383,
     /* 1034151 */     GIR_EraseRootFromParent_Done,
     /* 1034152 */   // Label 15310: @1034152
     /* 1034152 */   GIM_Try, /*On fail goto*//*Label 15311*/ GIMT_Encode4(1034229), // Rule ID 13386 //
     /* 1034157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034196 */     // MIs[0] policy
     /* 1034196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034206 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034228 */     // GIR_Coverage, 13386,
     /* 1034228 */     GIR_EraseRootFromParent_Done,
     /* 1034229 */   // Label 15311: @1034229
     /* 1034229 */   GIM_Try, /*On fail goto*//*Label 15312*/ GIMT_Encode4(1034306), // Rule ID 13387 //
     /* 1034234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1034245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1034248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1034254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034273 */     // MIs[0] policy
     /* 1034273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034283 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034305 */     // GIR_Coverage, 13387,
     /* 1034305 */     GIR_EraseRootFromParent_Done,
     /* 1034306 */   // Label 15312: @1034306
     /* 1034306 */   GIM_Try, /*On fail goto*//*Label 15313*/ GIMT_Encode4(1034383), // Rule ID 13390 //
     /* 1034311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034350 */     // MIs[0] policy
     /* 1034350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034360 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034382 */     // GIR_Coverage, 13390,
     /* 1034382 */     GIR_EraseRootFromParent_Done,
     /* 1034383 */   // Label 15313: @1034383
     /* 1034383 */   GIM_Try, /*On fail goto*//*Label 15314*/ GIMT_Encode4(1034460), // Rule ID 13391 //
     /* 1034388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1034399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1034402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1034408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1034419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034427 */     // MIs[0] policy
     /* 1034427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034437 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1034440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1034456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034459 */     // GIR_Coverage, 13391,
     /* 1034459 */     GIR_EraseRootFromParent_Done,
     /* 1034460 */   // Label 15314: @1034460
     /* 1034460 */   GIM_Try, /*On fail goto*//*Label 15315*/ GIMT_Encode4(1034537), // Rule ID 13394 //
     /* 1034465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1034485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034504 */     // MIs[0] policy
     /* 1034504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034536 */     // GIR_Coverage, 13394,
     /* 1034536 */     GIR_EraseRootFromParent_Done,
     /* 1034537 */   // Label 15315: @1034537
     /* 1034537 */   GIM_Try, /*On fail goto*//*Label 15316*/ GIMT_Encode4(1034614), // Rule ID 13395 //
     /* 1034542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1034553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1034556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1034562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034581 */     // MIs[0] policy
     /* 1034581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034591 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4),
     /* 1034594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034613 */     // GIR_Coverage, 13395,
     /* 1034613 */     GIR_EraseRootFromParent_Done,
     /* 1034614 */   // Label 15316: @1034614
     /* 1034614 */   GIM_Try, /*On fail goto*//*Label 15317*/ GIMT_Encode4(1034691), // Rule ID 13398 //
     /* 1034619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1034630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1034633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1034639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034658 */     // MIs[0] policy
     /* 1034658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034668 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034690 */     // GIR_Coverage, 13398,
     /* 1034690 */     GIR_EraseRootFromParent_Done,
     /* 1034691 */   // Label 15317: @1034691
     /* 1034691 */   GIM_Try, /*On fail goto*//*Label 15318*/ GIMT_Encode4(1034768), // Rule ID 13399 //
     /* 1034696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1034707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1034710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1034716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034735 */     // MIs[0] policy
     /* 1034735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034745 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11582:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1034748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034767 */     // GIR_Coverage, 13399,
     /* 1034767 */     GIR_EraseRootFromParent_Done,
     /* 1034768 */   // Label 15318: @1034768
     /* 1034768 */   GIM_Try, /*On fail goto*//*Label 15319*/ GIMT_Encode4(1034845), // Rule ID 13402 //
     /* 1034773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1034793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034812 */     // MIs[0] policy
     /* 1034812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034844 */     // GIR_Coverage, 13402,
     /* 1034844 */     GIR_EraseRootFromParent_Done,
     /* 1034845 */   // Label 15319: @1034845
     /* 1034845 */   GIM_Try, /*On fail goto*//*Label 15320*/ GIMT_Encode4(1034922), // Rule ID 13403 //
     /* 1034850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1034853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1034861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1034864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1034867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1034870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1034873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1034889 */     // MIs[0] policy
     /* 1034889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034899 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1034899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1034902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034921 */     // GIR_Coverage, 13403,
     /* 1034921 */     GIR_EraseRootFromParent_Done,
     /* 1034922 */   // Label 15320: @1034922
     /* 1034922 */   GIM_Try, /*On fail goto*//*Label 15321*/ GIMT_Encode4(1034999), // Rule ID 13406 //
     /* 1034927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1034930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1034935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1034938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1034941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1034944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1034947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1034950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1034958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1034962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1034966 */     // MIs[0] policy
     /* 1034966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1034969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1034976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1034976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1034979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1034981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1034983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1034985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1034987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1034992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1034995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1034997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1034998 */     // GIR_Coverage, 13406,
     /* 1034998 */     GIR_EraseRootFromParent_Done,
     /* 1034999 */   // Label 15321: @1034999
     /* 1034999 */   GIM_Try, /*On fail goto*//*Label 15322*/ GIMT_Encode4(1035076), // Rule ID 13407 //
     /* 1035004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1035015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1035018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1035024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035043 */     // MIs[0] policy
     /* 1035043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035053 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035075 */     // GIR_Coverage, 13407,
     /* 1035075 */     GIR_EraseRootFromParent_Done,
     /* 1035076 */   // Label 15322: @1035076
     /* 1035076 */   GIM_Try, /*On fail goto*//*Label 15323*/ GIMT_Encode4(1035153), // Rule ID 13410 //
     /* 1035081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035120 */     // MIs[0] policy
     /* 1035120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035152 */     // GIR_Coverage, 13410,
     /* 1035152 */     GIR_EraseRootFromParent_Done,
     /* 1035153 */   // Label 15323: @1035153
     /* 1035153 */   GIM_Try, /*On fail goto*//*Label 15324*/ GIMT_Encode4(1035230), // Rule ID 13411 //
     /* 1035158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1035169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1035172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1035178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035197 */     // MIs[0] policy
     /* 1035197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035207 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1035226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035229 */     // GIR_Coverage, 13411,
     /* 1035229 */     GIR_EraseRootFromParent_Done,
     /* 1035230 */   // Label 15324: @1035230
     /* 1035230 */   GIM_Try, /*On fail goto*//*Label 15325*/ GIMT_Encode4(1035307), // Rule ID 13414 //
     /* 1035235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035274 */     // MIs[0] policy
     /* 1035274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035306 */     // GIR_Coverage, 13414,
     /* 1035306 */     GIR_EraseRootFromParent_Done,
     /* 1035307 */   // Label 15325: @1035307
     /* 1035307 */   GIM_Try, /*On fail goto*//*Label 15326*/ GIMT_Encode4(1035384), // Rule ID 13415 //
     /* 1035312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1035323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1035326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1035332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035351 */     // MIs[0] policy
     /* 1035351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035361 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11582:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2),
     /* 1035364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035383 */     // GIR_Coverage, 13415,
     /* 1035383 */     GIR_EraseRootFromParent_Done,
     /* 1035384 */   // Label 15326: @1035384
     /* 1035384 */   GIM_Try, /*On fail goto*//*Label 15327*/ GIMT_Encode4(1035461), // Rule ID 13418 //
     /* 1035389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1035409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035428 */     // MIs[0] policy
     /* 1035428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035460 */     // GIR_Coverage, 13418,
     /* 1035460 */     GIR_EraseRootFromParent_Done,
     /* 1035461 */   // Label 15327: @1035461
     /* 1035461 */   GIM_Try, /*On fail goto*//*Label 15328*/ GIMT_Encode4(1035538), // Rule ID 13419 //
     /* 1035466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1035477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1035480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1035486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035505 */     // MIs[0] policy
     /* 1035505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035515 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11582:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1),
     /* 1035518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035537 */     // GIR_Coverage, 13419,
     /* 1035537 */     GIR_EraseRootFromParent_Done,
     /* 1035538 */   // Label 15328: @1035538
     /* 1035538 */   GIM_Try, /*On fail goto*//*Label 15329*/ GIMT_Encode4(1035615), // Rule ID 13422 //
     /* 1035543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1035563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035582 */     // MIs[0] policy
     /* 1035582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035592 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035614 */     // GIR_Coverage, 13422,
     /* 1035614 */     GIR_EraseRootFromParent_Done,
     /* 1035615 */   // Label 15329: @1035615
     /* 1035615 */   GIM_Try, /*On fail goto*//*Label 15330*/ GIMT_Encode4(1035692), // Rule ID 13423 //
     /* 1035620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1035631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1035634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1035640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1035659 */     // MIs[0] policy
     /* 1035659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035669 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11582:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2),
     /* 1035672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035691 */     // GIR_Coverage, 13423,
     /* 1035691 */     GIR_EraseRootFromParent_Done,
     /* 1035692 */   // Label 15330: @1035692
     /* 1035692 */   GIM_Try, /*On fail goto*//*Label 15331*/ GIMT_Encode4(1035769), // Rule ID 13426 //
     /* 1035697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1035700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1035714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1035717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035736 */     // MIs[0] policy
     /* 1035736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035746 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035768 */     // GIR_Coverage, 13426,
     /* 1035768 */     GIR_EraseRootFromParent_Done,
     /* 1035769 */   // Label 15331: @1035769
     /* 1035769 */   GIM_Try, /*On fail goto*//*Label 15332*/ GIMT_Encode4(1035846), // Rule ID 13427 //
     /* 1035774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1035777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu),
     /* 1035782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1035785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1035788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1035791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1035794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1035805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1035809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1035813 */     // MIs[0] policy
     /* 1035813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035823 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11582:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4),
     /* 1035826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1035842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035845 */     // GIR_Coverage, 13427,
     /* 1035845 */     GIR_EraseRootFromParent_Done,
     /* 1035846 */   // Label 15332: @1035846
     /* 1035846 */   GIM_Try, /*On fail goto*//*Label 15333*/ GIMT_Encode4(1035923), // Rule ID 13430 //
     /* 1035851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1035854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1035859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1035874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035890 */     // MIs[0] policy
     /* 1035890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035900 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1035900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1035903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035922 */     // GIR_Coverage, 13430,
     /* 1035922 */     GIR_EraseRootFromParent_Done,
     /* 1035923 */   // Label 15333: @1035923
     /* 1035923 */   GIM_Try, /*On fail goto*//*Label 15334*/ GIMT_Encode4(1036000), // Rule ID 13431 //
     /* 1035928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1035931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1035936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1035939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1035942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1035945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1035948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1035951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1035967 */     // MIs[0] policy
     /* 1035967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1035970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1035977 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1035977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8),
     /* 1035980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1035982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1035984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1035986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1035988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1035993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1035996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1035998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1035999 */     // GIR_Coverage, 13431,
     /* 1035999 */     GIR_EraseRootFromParent_Done,
     /* 1036000 */   // Label 15334: @1036000
     /* 1036000 */   GIM_Try, /*On fail goto*//*Label 15335*/ GIMT_Encode4(1036077), // Rule ID 13434 //
     /* 1036005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036044 */     // MIs[0] policy
     /* 1036044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036054 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036076 */     // GIR_Coverage, 13434,
     /* 1036076 */     GIR_EraseRootFromParent_Done,
     /* 1036077 */   // Label 15335: @1036077
     /* 1036077 */   GIM_Try, /*On fail goto*//*Label 15336*/ GIMT_Encode4(1036154), // Rule ID 13435 //
     /* 1036082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1036093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1036096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1036099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1036102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036121 */     // MIs[0] policy
     /* 1036121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036131 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036153 */     // GIR_Coverage, 13435,
     /* 1036153 */     GIR_EraseRootFromParent_Done,
     /* 1036154 */   // Label 15336: @1036154
     /* 1036154 */   GIM_Try, /*On fail goto*//*Label 15337*/ GIMT_Encode4(1036231), // Rule ID 13438 //
     /* 1036159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036198 */     // MIs[0] policy
     /* 1036198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036208 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036230 */     // GIR_Coverage, 13438,
     /* 1036230 */     GIR_EraseRootFromParent_Done,
     /* 1036231 */   // Label 15337: @1036231
     /* 1036231 */   GIM_Try, /*On fail goto*//*Label 15338*/ GIMT_Encode4(1036308), // Rule ID 13439 //
     /* 1036236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1036247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1036250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1036253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1036256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036275 */     // MIs[0] policy
     /* 1036275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036285 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036307 */     // GIR_Coverage, 13439,
     /* 1036307 */     GIR_EraseRootFromParent_Done,
     /* 1036308 */   // Label 15338: @1036308
     /* 1036308 */   GIM_Try, /*On fail goto*//*Label 15339*/ GIMT_Encode4(1036385), // Rule ID 13442 //
     /* 1036313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036352 */     // MIs[0] policy
     /* 1036352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036384 */     // GIR_Coverage, 13442,
     /* 1036384 */     GIR_EraseRootFromParent_Done,
     /* 1036385 */   // Label 15339: @1036385
     /* 1036385 */   GIM_Try, /*On fail goto*//*Label 15340*/ GIMT_Encode4(1036462), // Rule ID 13443 //
     /* 1036390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1036401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1036404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1036407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1036410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036429 */     // MIs[0] policy
     /* 1036429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036439 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1036442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036461 */     // GIR_Coverage, 13443,
     /* 1036461 */     GIR_EraseRootFromParent_Done,
     /* 1036462 */   // Label 15340: @1036462
     /* 1036462 */   GIM_Try, /*On fail goto*//*Label 15341*/ GIMT_Encode4(1036539), // Rule ID 13446 //
     /* 1036467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036506 */     // MIs[0] policy
     /* 1036506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1036519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036538 */     // GIR_Coverage, 13446,
     /* 1036538 */     GIR_EraseRootFromParent_Done,
     /* 1036539 */   // Label 15341: @1036539
     /* 1036539 */   GIM_Try, /*On fail goto*//*Label 15342*/ GIMT_Encode4(1036616), // Rule ID 13447 //
     /* 1036544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1036555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1036558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1036561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1036564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1036583 */     // MIs[0] policy
     /* 1036583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036593 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1036596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036615 */     // GIR_Coverage, 13447,
     /* 1036615 */     GIR_EraseRootFromParent_Done,
     /* 1036616 */   // Label 15342: @1036616
     /* 1036616 */   GIM_Try, /*On fail goto*//*Label 15343*/ GIMT_Encode4(1036693), // Rule ID 13450 //
     /* 1036621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036660 */     // MIs[0] policy
     /* 1036660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036670 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1036673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036692 */     // GIR_Coverage, 13450,
     /* 1036692 */     GIR_EraseRootFromParent_Done,
     /* 1036693 */   // Label 15343: @1036693
     /* 1036693 */   GIM_Try, /*On fail goto*//*Label 15344*/ GIMT_Encode4(1036770), // Rule ID 13451 //
     /* 1036698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1036709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1036712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1036715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1036718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1036729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1036737 */     // MIs[0] policy
     /* 1036737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036747 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1036750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1036766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036769 */     // GIR_Coverage, 13451,
     /* 1036769 */     GIR_EraseRootFromParent_Done,
     /* 1036770 */   // Label 15344: @1036770
     /* 1036770 */   GIM_Try, /*On fail goto*//*Label 15345*/ GIMT_Encode4(1036847), // Rule ID 13454 //
     /* 1036775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036814 */     // MIs[0] policy
     /* 1036814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036846 */     // GIR_Coverage, 13454,
     /* 1036846 */     GIR_EraseRootFromParent_Done,
     /* 1036847 */   // Label 15345: @1036847
     /* 1036847 */   GIM_Try, /*On fail goto*//*Label 15346*/ GIMT_Encode4(1036924), // Rule ID 13455 //
     /* 1036852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1036855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1036863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1036866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1036869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1036872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1036875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036891 */     // MIs[0] policy
     /* 1036891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036901 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1036901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4),
     /* 1036904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1036923 */     // GIR_Coverage, 13455,
     /* 1036923 */     GIR_EraseRootFromParent_Done,
     /* 1036924 */   // Label 15346: @1036924
     /* 1036924 */   GIM_Try, /*On fail goto*//*Label 15347*/ GIMT_Encode4(1037001), // Rule ID 13458 //
     /* 1036929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1036932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1036937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1036940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1036943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1036946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1036949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1036952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1036968 */     // MIs[0] policy
     /* 1036968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1036971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1036978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1036978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1036981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1036983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1036985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1036987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1036989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1036994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1036997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1036999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037000 */     // GIR_Coverage, 13458,
     /* 1037000 */     GIR_EraseRootFromParent_Done,
     /* 1037001 */   // Label 15347: @1037001
     /* 1037001 */   GIM_Try, /*On fail goto*//*Label 15348*/ GIMT_Encode4(1037078), // Rule ID 13459 //
     /* 1037006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1037017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1037020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1037023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1037026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037045 */     // MIs[0] policy
     /* 1037045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037077 */     // GIR_Coverage, 13459,
     /* 1037077 */     GIR_EraseRootFromParent_Done,
     /* 1037078 */   // Label 15348: @1037078
     /* 1037078 */   GIM_Try, /*On fail goto*//*Label 15349*/ GIMT_Encode4(1037155), // Rule ID 13462 //
     /* 1037083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037122 */     // MIs[0] policy
     /* 1037122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037154 */     // GIR_Coverage, 13462,
     /* 1037154 */     GIR_EraseRootFromParent_Done,
     /* 1037155 */   // Label 15349: @1037155
     /* 1037155 */   GIM_Try, /*On fail goto*//*Label 15350*/ GIMT_Encode4(1037232), // Rule ID 13463 //
     /* 1037160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1037171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1037174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1037177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1037180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037199 */     // MIs[0] policy
     /* 1037199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037231 */     // GIR_Coverage, 13463,
     /* 1037231 */     GIR_EraseRootFromParent_Done,
     /* 1037232 */   // Label 15350: @1037232
     /* 1037232 */   GIM_Try, /*On fail goto*//*Label 15351*/ GIMT_Encode4(1037309), // Rule ID 13466 //
     /* 1037237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037276 */     // MIs[0] policy
     /* 1037276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037308 */     // GIR_Coverage, 13466,
     /* 1037308 */     GIR_EraseRootFromParent_Done,
     /* 1037309 */   // Label 15351: @1037309
     /* 1037309 */   GIM_Try, /*On fail goto*//*Label 15352*/ GIMT_Encode4(1037386), // Rule ID 13467 //
     /* 1037314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1037325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1037328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1037331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1037334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037353 */     // MIs[0] policy
     /* 1037353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037363 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037385 */     // GIR_Coverage, 13467,
     /* 1037385 */     GIR_EraseRootFromParent_Done,
     /* 1037386 */   // Label 15352: @1037386
     /* 1037386 */   GIM_Try, /*On fail goto*//*Label 15353*/ GIMT_Encode4(1037463), // Rule ID 13470 //
     /* 1037391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1037394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037430 */     // MIs[0] policy
     /* 1037430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037462 */     // GIR_Coverage, 13470,
     /* 1037462 */     GIR_EraseRootFromParent_Done,
     /* 1037463 */   // Label 15353: @1037463
     /* 1037463 */   GIM_Try, /*On fail goto*//*Label 15354*/ GIMT_Encode4(1037540), // Rule ID 13471 //
     /* 1037468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1037471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1037479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1037482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1037485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1037488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1037499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037507 */     // MIs[0] policy
     /* 1037507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037517 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1037520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1037536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037539 */     // GIR_Coverage, 13471,
     /* 1037539 */     GIR_EraseRootFromParent_Done,
     /* 1037540 */   // Label 15354: @1037540
     /* 1037540 */   GIM_Try, /*On fail goto*//*Label 15355*/ GIMT_Encode4(1037617), // Rule ID 13474 //
     /* 1037545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037584 */     // MIs[0] policy
     /* 1037584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037616 */     // GIR_Coverage, 13474,
     /* 1037616 */     GIR_EraseRootFromParent_Done,
     /* 1037617 */   // Label 15355: @1037617
     /* 1037617 */   GIM_Try, /*On fail goto*//*Label 15356*/ GIMT_Encode4(1037694), // Rule ID 13475 //
     /* 1037622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1037633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1037636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1037639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1037642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037661 */     // MIs[0] policy
     /* 1037661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037671 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2),
     /* 1037674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037693 */     // GIR_Coverage, 13475,
     /* 1037693 */     GIR_EraseRootFromParent_Done,
     /* 1037694 */   // Label 15356: @1037694
     /* 1037694 */   GIM_Try, /*On fail goto*//*Label 15357*/ GIMT_Encode4(1037771), // Rule ID 13478 //
     /* 1037699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037738 */     // MIs[0] policy
     /* 1037738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037748 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037770 */     // GIR_Coverage, 13478,
     /* 1037770 */     GIR_EraseRootFromParent_Done,
     /* 1037771 */   // Label 15357: @1037771
     /* 1037771 */   GIM_Try, /*On fail goto*//*Label 15358*/ GIMT_Encode4(1037848), // Rule ID 13479 //
     /* 1037776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1037787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1037790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1037793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1037796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1037815 */     // MIs[0] policy
     /* 1037815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037825 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1),
     /* 1037828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037847 */     // GIR_Coverage, 13479,
     /* 1037847 */     GIR_EraseRootFromParent_Done,
     /* 1037848 */   // Label 15358: @1037848
     /* 1037848 */   GIM_Try, /*On fail goto*//*Label 15359*/ GIMT_Encode4(1037925), // Rule ID 13482 //
     /* 1037853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1037856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1037876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037892 */     // MIs[0] policy
     /* 1037892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037902 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1037902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1037923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1037924 */     // GIR_Coverage, 13482,
     /* 1037924 */     GIR_EraseRootFromParent_Done,
     /* 1037925 */   // Label 15359: @1037925
     /* 1037925 */   GIM_Try, /*On fail goto*//*Label 15360*/ GIMT_Encode4(1038002), // Rule ID 13483 //
     /* 1037930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1037933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1037938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1037941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1037944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1037947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1037950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1037953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1037961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1037969 */     // MIs[0] policy
     /* 1037969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1037972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1037979 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1037979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2),
     /* 1037982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1037984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1037986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1037988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1037990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1037995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1037998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038001 */     // GIR_Coverage, 13483,
     /* 1038001 */     GIR_EraseRootFromParent_Done,
     /* 1038002 */   // Label 15360: @1038002
     /* 1038002 */   GIM_Try, /*On fail goto*//*Label 15361*/ GIMT_Encode4(1038079), // Rule ID 13486 //
     /* 1038007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1038010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038046 */     // MIs[0] policy
     /* 1038046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038078 */     // GIR_Coverage, 13486,
     /* 1038078 */     GIR_EraseRootFromParent_Done,
     /* 1038079 */   // Label 15361: @1038079
     /* 1038079 */   GIM_Try, /*On fail goto*//*Label 15362*/ GIMT_Encode4(1038156), // Rule ID 13487 //
     /* 1038084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1038087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1038095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1038098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1038101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1038104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038123 */     // MIs[0] policy
     /* 1038123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038133 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4),
     /* 1038136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1038152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038155 */     // GIR_Coverage, 13487,
     /* 1038155 */     GIR_EraseRootFromParent_Done,
     /* 1038156 */   // Label 15362: @1038156
     /* 1038156 */   GIM_Try, /*On fail goto*//*Label 15363*/ GIMT_Encode4(1038233), // Rule ID 13490 //
     /* 1038161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038200 */     // MIs[0] policy
     /* 1038200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038232 */     // GIR_Coverage, 13490,
     /* 1038232 */     GIR_EraseRootFromParent_Done,
     /* 1038233 */   // Label 15363: @1038233
     /* 1038233 */   GIM_Try, /*On fail goto*//*Label 15364*/ GIMT_Encode4(1038310), // Rule ID 13491 //
     /* 1038238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1038249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1038252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1038258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038277 */     // MIs[0] policy
     /* 1038277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038287 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8),
     /* 1038290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038309 */     // GIR_Coverage, 13491,
     /* 1038309 */     GIR_EraseRootFromParent_Done,
     /* 1038310 */   // Label 15364: @1038310
     /* 1038310 */   GIM_Try, /*On fail goto*//*Label 15365*/ GIMT_Encode4(1038387), // Rule ID 13494 //
     /* 1038315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038354 */     // MIs[0] policy
     /* 1038354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038386 */     // GIR_Coverage, 13494,
     /* 1038386 */     GIR_EraseRootFromParent_Done,
     /* 1038387 */   // Label 15365: @1038387
     /* 1038387 */   GIM_Try, /*On fail goto*//*Label 15366*/ GIMT_Encode4(1038464), // Rule ID 13495 //
     /* 1038392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1038403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1038406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1038412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038431 */     // MIs[0] policy
     /* 1038431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038441 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1038444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038463 */     // GIR_Coverage, 13495,
     /* 1038463 */     GIR_EraseRootFromParent_Done,
     /* 1038464 */   // Label 15366: @1038464
     /* 1038464 */   GIM_Try, /*On fail goto*//*Label 15367*/ GIMT_Encode4(1038541), // Rule ID 13498 //
     /* 1038469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038508 */     // MIs[0] policy
     /* 1038508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038518 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1038521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038540 */     // GIR_Coverage, 13498,
     /* 1038540 */     GIR_EraseRootFromParent_Done,
     /* 1038541 */   // Label 15367: @1038541
     /* 1038541 */   GIM_Try, /*On fail goto*//*Label 15368*/ GIMT_Encode4(1038618), // Rule ID 13499 //
     /* 1038546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1038557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1038560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1038566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038585 */     // MIs[0] policy
     /* 1038585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038595 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11578:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1038598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038617 */     // GIR_Coverage, 13499,
     /* 1038617 */     GIR_EraseRootFromParent_Done,
     /* 1038618 */   // Label 15368: @1038618
     /* 1038618 */   GIM_Try, /*On fail goto*//*Label 15369*/ GIMT_Encode4(1038695), // Rule ID 13502 //
     /* 1038623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038662 */     // MIs[0] policy
     /* 1038662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1038675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038694 */     // GIR_Coverage, 13502,
     /* 1038694 */     GIR_EraseRootFromParent_Done,
     /* 1038695 */   // Label 15369: @1038695
     /* 1038695 */   GIM_Try, /*On fail goto*//*Label 15370*/ GIMT_Encode4(1038772), // Rule ID 13503 //
     /* 1038700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1038711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1038714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1038720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1038739 */     // MIs[0] policy
     /* 1038739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038749 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1038752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038771 */     // GIR_Coverage, 13503,
     /* 1038771 */     GIR_EraseRootFromParent_Done,
     /* 1038772 */   // Label 15370: @1038772
     /* 1038772 */   GIM_Try, /*On fail goto*//*Label 15371*/ GIMT_Encode4(1038849), // Rule ID 13506 //
     /* 1038777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038816 */     // MIs[0] policy
     /* 1038816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038826 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1038829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038848 */     // GIR_Coverage, 13506,
     /* 1038848 */     GIR_EraseRootFromParent_Done,
     /* 1038849 */   // Label 15371: @1038849
     /* 1038849 */   GIM_Try, /*On fail goto*//*Label 15372*/ GIMT_Encode4(1038926), // Rule ID 13507 //
     /* 1038854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1038857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1038865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1038868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1038871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1038874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1038877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1038893 */     // MIs[0] policy
     /* 1038893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038903 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1038903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1038906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1038924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1038925 */     // GIR_Coverage, 13507,
     /* 1038925 */     GIR_EraseRootFromParent_Done,
     /* 1038926 */   // Label 15372: @1038926
     /* 1038926 */   GIM_Try, /*On fail goto*//*Label 15373*/ GIMT_Encode4(1039003), // Rule ID 13510 //
     /* 1038931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1038934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1038939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1038942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1038945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1038948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1038951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1038954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1038962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1038966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1038970 */     // MIs[0] policy
     /* 1038970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1038973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1038980 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1038980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1038983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1038985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1038987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1038989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1038991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1038996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1038999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039002 */     // GIR_Coverage, 13510,
     /* 1039002 */     GIR_EraseRootFromParent_Done,
     /* 1039003 */   // Label 15373: @1039003
     /* 1039003 */   GIM_Try, /*On fail goto*//*Label 15374*/ GIMT_Encode4(1039080), // Rule ID 13511 //
     /* 1039008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1039019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1039022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1039028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039047 */     // MIs[0] policy
     /* 1039047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039057 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1039076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039079 */     // GIR_Coverage, 13511,
     /* 1039079 */     GIR_EraseRootFromParent_Done,
     /* 1039080 */   // Label 15374: @1039080
     /* 1039080 */   GIM_Try, /*On fail goto*//*Label 15375*/ GIMT_Encode4(1039157), // Rule ID 13514 //
     /* 1039085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039124 */     // MIs[0] policy
     /* 1039124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039156 */     // GIR_Coverage, 13514,
     /* 1039156 */     GIR_EraseRootFromParent_Done,
     /* 1039157 */   // Label 15375: @1039157
     /* 1039157 */   GIM_Try, /*On fail goto*//*Label 15376*/ GIMT_Encode4(1039234), // Rule ID 13515 //
     /* 1039162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1039173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1039176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1039182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039201 */     // MIs[0] policy
     /* 1039201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039211 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4),
     /* 1039214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039233 */     // GIR_Coverage, 13515,
     /* 1039233 */     GIR_EraseRootFromParent_Done,
     /* 1039234 */   // Label 15376: @1039234
     /* 1039234 */   GIM_Try, /*On fail goto*//*Label 15377*/ GIMT_Encode4(1039311), // Rule ID 13518 //
     /* 1039239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039278 */     // MIs[0] policy
     /* 1039278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039310 */     // GIR_Coverage, 13518,
     /* 1039310 */     GIR_EraseRootFromParent_Done,
     /* 1039311 */   // Label 15377: @1039311
     /* 1039311 */   GIM_Try, /*On fail goto*//*Label 15378*/ GIMT_Encode4(1039388), // Rule ID 13519 //
     /* 1039316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1039327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1039330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1039336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039355 */     // MIs[0] policy
     /* 1039355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039365 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11578:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039387 */     // GIR_Coverage, 13519,
     /* 1039387 */     GIR_EraseRootFromParent_Done,
     /* 1039388 */   // Label 15378: @1039388
     /* 1039388 */   GIM_Try, /*On fail goto*//*Label 15379*/ GIMT_Encode4(1039465), // Rule ID 13522 //
     /* 1039393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039432 */     // MIs[0] policy
     /* 1039432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039442 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039464 */     // GIR_Coverage, 13522,
     /* 1039464 */     GIR_EraseRootFromParent_Done,
     /* 1039465 */   // Label 15379: @1039465
     /* 1039465 */   GIM_Try, /*On fail goto*//*Label 15380*/ GIMT_Encode4(1039542), // Rule ID 13523 //
     /* 1039470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1039481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1039484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1039490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039509 */     // MIs[0] policy
     /* 1039509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1039522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039541 */     // GIR_Coverage, 13523,
     /* 1039541 */     GIR_EraseRootFromParent_Done,
     /* 1039542 */   // Label 15380: @1039542
     /* 1039542 */   GIM_Try, /*On fail goto*//*Label 15381*/ GIMT_Encode4(1039619), // Rule ID 13526 //
     /* 1039547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039586 */     // MIs[0] policy
     /* 1039586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039596 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039618 */     // GIR_Coverage, 13526,
     /* 1039618 */     GIR_EraseRootFromParent_Done,
     /* 1039619 */   // Label 15381: @1039619
     /* 1039619 */   GIM_Try, /*On fail goto*//*Label 15382*/ GIMT_Encode4(1039696), // Rule ID 13527 //
     /* 1039624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1039635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1039638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1039644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1039663 */     // MIs[0] policy
     /* 1039663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039673 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1039676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039695 */     // GIR_Coverage, 13527,
     /* 1039695 */     GIR_EraseRootFromParent_Done,
     /* 1039696 */   // Label 15382: @1039696
     /* 1039696 */   GIM_Try, /*On fail goto*//*Label 15383*/ GIMT_Encode4(1039773), // Rule ID 13530 //
     /* 1039701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1039704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039740 */     // MIs[0] policy
     /* 1039740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039750 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039772 */     // GIR_Coverage, 13530,
     /* 1039772 */     GIR_EraseRootFromParent_Done,
     /* 1039773 */   // Label 15383: @1039773
     /* 1039773 */   GIM_Try, /*On fail goto*//*Label 15384*/ GIMT_Encode4(1039850), // Rule ID 13531 //
     /* 1039778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1039781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1039789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1039792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1039798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1039809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1039817 */     // MIs[0] policy
     /* 1039817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039827 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1039830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1039846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039849 */     // GIR_Coverage, 13531,
     /* 1039849 */     GIR_EraseRootFromParent_Done,
     /* 1039850 */   // Label 15384: @1039850
     /* 1039850 */   GIM_Try, /*On fail goto*//*Label 15385*/ GIMT_Encode4(1039927), // Rule ID 13534 //
     /* 1039855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1039858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1039872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1039878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039894 */     // MIs[0] policy
     /* 1039894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1039904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1039923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1039925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1039926 */     // GIR_Coverage, 13534,
     /* 1039926 */     GIR_EraseRootFromParent_Done,
     /* 1039927 */   // Label 15385: @1039927
     /* 1039927 */   GIM_Try, /*On fail goto*//*Label 15386*/ GIMT_Encode4(1040004), // Rule ID 13535 //
     /* 1039932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1039935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1039940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1039943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1039946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1039949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1039952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1039955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1039967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1039971 */     // MIs[0] policy
     /* 1039971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1039974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1039981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11578:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1039981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2),
     /* 1039984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1039986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1039988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1039990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1039992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1039997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040003 */     // GIR_Coverage, 13535,
     /* 1040003 */     GIR_EraseRootFromParent_Done,
     /* 1040004 */   // Label 15386: @1040004
     /* 1040004 */   GIM_Try, /*On fail goto*//*Label 15387*/ GIMT_Encode4(1040081), // Rule ID 13538 //
     /* 1040009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040048 */     // MIs[0] policy
     /* 1040048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040058 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040080 */     // GIR_Coverage, 13538,
     /* 1040080 */     GIR_EraseRootFromParent_Done,
     /* 1040081 */   // Label 15387: @1040081
     /* 1040081 */   GIM_Try, /*On fail goto*//*Label 15388*/ GIMT_Encode4(1040158), // Rule ID 13539 //
     /* 1040086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1040097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1040100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1040106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040125 */     // MIs[0] policy
     /* 1040125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11578:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1),
     /* 1040138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040157 */     // GIR_Coverage, 13539,
     /* 1040157 */     GIR_EraseRootFromParent_Done,
     /* 1040158 */   // Label 15388: @1040158
     /* 1040158 */   GIM_Try, /*On fail goto*//*Label 15389*/ GIMT_Encode4(1040235), // Rule ID 13542 //
     /* 1040163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040202 */     // MIs[0] policy
     /* 1040202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040212 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040234 */     // GIR_Coverage, 13542,
     /* 1040234 */     GIR_EraseRootFromParent_Done,
     /* 1040235 */   // Label 15389: @1040235
     /* 1040235 */   GIM_Try, /*On fail goto*//*Label 15390*/ GIMT_Encode4(1040312), // Rule ID 13543 //
     /* 1040240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1040251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1040254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1040260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040279 */     // MIs[0] policy
     /* 1040279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040289 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11578:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2),
     /* 1040292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040311 */     // GIR_Coverage, 13543,
     /* 1040311 */     GIR_EraseRootFromParent_Done,
     /* 1040312 */   // Label 15390: @1040312
     /* 1040312 */   GIM_Try, /*On fail goto*//*Label 15391*/ GIMT_Encode4(1040389), // Rule ID 13546 //
     /* 1040317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1040320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1040334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040356 */     // MIs[0] policy
     /* 1040356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040366 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040388 */     // GIR_Coverage, 13546,
     /* 1040388 */     GIR_EraseRootFromParent_Done,
     /* 1040389 */   // Label 15391: @1040389
     /* 1040389 */   GIM_Try, /*On fail goto*//*Label 15392*/ GIMT_Encode4(1040466), // Rule ID 13547 //
     /* 1040394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1040397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc),
     /* 1040402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1040405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1040408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1040411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1040414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1040425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1040429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1040433 */     // MIs[0] policy
     /* 1040433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040443 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11578:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4),
     /* 1040446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1040462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040465 */     // GIR_Coverage, 13547,
     /* 1040465 */     GIR_EraseRootFromParent_Done,
     /* 1040466 */   // Label 15392: @1040466
     /* 1040466 */   GIM_Try, /*On fail goto*//*Label 15393*/ GIMT_Encode4(1040543), // Rule ID 13550 //
     /* 1040471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040510 */     // MIs[0] policy
     /* 1040510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1040523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040542 */     // GIR_Coverage, 13550,
     /* 1040542 */     GIR_EraseRootFromParent_Done,
     /* 1040543 */   // Label 15393: @1040543
     /* 1040543 */   GIM_Try, /*On fail goto*//*Label 15394*/ GIMT_Encode4(1040620), // Rule ID 13551 //
     /* 1040548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1040559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1040562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1040565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1040568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040587 */     // MIs[0] policy
     /* 1040587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040597 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8),
     /* 1040600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040619 */     // GIR_Coverage, 13551,
     /* 1040619 */     GIR_EraseRootFromParent_Done,
     /* 1040620 */   // Label 15394: @1040620
     /* 1040620 */   GIM_Try, /*On fail goto*//*Label 15395*/ GIMT_Encode4(1040697), // Rule ID 13554 //
     /* 1040625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040664 */     // MIs[0] policy
     /* 1040664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040674 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1040677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040696 */     // GIR_Coverage, 13554,
     /* 1040696 */     GIR_EraseRootFromParent_Done,
     /* 1040697 */   // Label 15395: @1040697
     /* 1040697 */   GIM_Try, /*On fail goto*//*Label 15396*/ GIMT_Encode4(1040774), // Rule ID 13555 //
     /* 1040702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1040713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1040716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1040719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1040722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040741 */     // MIs[0] policy
     /* 1040741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040751 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1040754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040773 */     // GIR_Coverage, 13555,
     /* 1040773 */     GIR_EraseRootFromParent_Done,
     /* 1040774 */   // Label 15396: @1040774
     /* 1040774 */   GIM_Try, /*On fail goto*//*Label 15397*/ GIMT_Encode4(1040851), // Rule ID 13558 //
     /* 1040779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040818 */     // MIs[0] policy
     /* 1040818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1040831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040850 */     // GIR_Coverage, 13558,
     /* 1040850 */     GIR_EraseRootFromParent_Done,
     /* 1040851 */   // Label 15397: @1040851
     /* 1040851 */   GIM_Try, /*On fail goto*//*Label 15398*/ GIMT_Encode4(1040928), // Rule ID 13559 //
     /* 1040856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1040859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1040867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1040870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1040873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1040876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1040879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040895 */     // MIs[0] policy
     /* 1040895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040905 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1040905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1040908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1040924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1040926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1040927 */     // GIR_Coverage, 13559,
     /* 1040927 */     GIR_EraseRootFromParent_Done,
     /* 1040928 */   // Label 15398: @1040928
     /* 1040928 */   GIM_Try, /*On fail goto*//*Label 15399*/ GIMT_Encode4(1041005), // Rule ID 13562 //
     /* 1040933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1040936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1040941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1040944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1040947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1040950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1040953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1040956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1040964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1040972 */     // MIs[0] policy
     /* 1040972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1040975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1040982 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1040982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1040985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1040987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1040989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1040991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1040993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1040998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041004 */     // GIR_Coverage, 13562,
     /* 1041004 */     GIR_EraseRootFromParent_Done,
     /* 1041005 */   // Label 15399: @1041005
     /* 1041005 */   GIM_Try, /*On fail goto*//*Label 15400*/ GIMT_Encode4(1041082), // Rule ID 13563 //
     /* 1041010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1041021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1041024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1041027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1041030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041049 */     // MIs[0] policy
     /* 1041049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041059 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041081 */     // GIR_Coverage, 13563,
     /* 1041081 */     GIR_EraseRootFromParent_Done,
     /* 1041082 */   // Label 15400: @1041082
     /* 1041082 */   GIM_Try, /*On fail goto*//*Label 15401*/ GIMT_Encode4(1041159), // Rule ID 13566 //
     /* 1041087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041126 */     // MIs[0] policy
     /* 1041126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041158 */     // GIR_Coverage, 13566,
     /* 1041158 */     GIR_EraseRootFromParent_Done,
     /* 1041159 */   // Label 15401: @1041159
     /* 1041159 */   GIM_Try, /*On fail goto*//*Label 15402*/ GIMT_Encode4(1041236), // Rule ID 13567 //
     /* 1041164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1041175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1041178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1041181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1041184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041203 */     // MIs[0] policy
     /* 1041203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041213 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041235 */     // GIR_Coverage, 13567,
     /* 1041235 */     GIR_EraseRootFromParent_Done,
     /* 1041236 */   // Label 15402: @1041236
     /* 1041236 */   GIM_Try, /*On fail goto*//*Label 15403*/ GIMT_Encode4(1041313), // Rule ID 13570 //
     /* 1041241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041280 */     // MIs[0] policy
     /* 1041280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041290 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041312 */     // GIR_Coverage, 13570,
     /* 1041312 */     GIR_EraseRootFromParent_Done,
     /* 1041313 */   // Label 15403: @1041313
     /* 1041313 */   GIM_Try, /*On fail goto*//*Label 15404*/ GIMT_Encode4(1041390), // Rule ID 13571 //
     /* 1041318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1041329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1041332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1041335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1041338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1041349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041357 */     // MIs[0] policy
     /* 1041357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041367 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1041370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1041386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041389 */     // GIR_Coverage, 13571,
     /* 1041389 */     GIR_EraseRootFromParent_Done,
     /* 1041390 */   // Label 15404: @1041390
     /* 1041390 */   GIM_Try, /*On fail goto*//*Label 15405*/ GIMT_Encode4(1041467), // Rule ID 13574 //
     /* 1041395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041434 */     // MIs[0] policy
     /* 1041434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041444 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041466 */     // GIR_Coverage, 13574,
     /* 1041466 */     GIR_EraseRootFromParent_Done,
     /* 1041467 */   // Label 15405: @1041467
     /* 1041467 */   GIM_Try, /*On fail goto*//*Label 15406*/ GIMT_Encode4(1041544), // Rule ID 13575 //
     /* 1041472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1041483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1041486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1041489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1041492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041511 */     // MIs[0] policy
     /* 1041511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041521 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4),
     /* 1041524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041543 */     // GIR_Coverage, 13575,
     /* 1041543 */     GIR_EraseRootFromParent_Done,
     /* 1041544 */   // Label 15406: @1041544
     /* 1041544 */   GIM_Try, /*On fail goto*//*Label 15407*/ GIMT_Encode4(1041621), // Rule ID 13578 //
     /* 1041549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041588 */     // MIs[0] policy
     /* 1041588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041598 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041620 */     // GIR_Coverage, 13578,
     /* 1041620 */     GIR_EraseRootFromParent_Done,
     /* 1041621 */   // Label 15407: @1041621
     /* 1041621 */   GIM_Try, /*On fail goto*//*Label 15408*/ GIMT_Encode4(1041698), // Rule ID 13579 //
     /* 1041626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1041637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1041640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1041643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1041646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041665 */     // MIs[0] policy
     /* 1041665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1041678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041697 */     // GIR_Coverage, 13579,
     /* 1041697 */     GIR_EraseRootFromParent_Done,
     /* 1041698 */   // Label 15408: @1041698
     /* 1041698 */   GIM_Try, /*On fail goto*//*Label 15409*/ GIMT_Encode4(1041775), // Rule ID 13582 //
     /* 1041703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041742 */     // MIs[0] policy
     /* 1041742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041752 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041774 */     // GIR_Coverage, 13582,
     /* 1041774 */     GIR_EraseRootFromParent_Done,
     /* 1041775 */   // Label 15409: @1041775
     /* 1041775 */   GIM_Try, /*On fail goto*//*Label 15410*/ GIMT_Encode4(1041852), // Rule ID 13583 //
     /* 1041780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1041791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1041794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1041797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1041800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1041819 */     // MIs[0] policy
     /* 1041819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1041832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041851 */     // GIR_Coverage, 13583,
     /* 1041851 */     GIR_EraseRootFromParent_Done,
     /* 1041852 */   // Label 15410: @1041852
     /* 1041852 */   GIM_Try, /*On fail goto*//*Label 15411*/ GIMT_Encode4(1041929), // Rule ID 13586 //
     /* 1041857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1041860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1041880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041896 */     // MIs[0] policy
     /* 1041896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041906 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1041906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1041925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1041927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1041928 */     // GIR_Coverage, 13586,
     /* 1041928 */     GIR_EraseRootFromParent_Done,
     /* 1041929 */   // Label 15411: @1041929
     /* 1041929 */   GIM_Try, /*On fail goto*//*Label 15412*/ GIMT_Encode4(1042006), // Rule ID 13587 //
     /* 1041934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1041937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1041942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1041945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1041948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1041951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1041954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1041957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1041965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1041973 */     // MIs[0] policy
     /* 1041973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1041976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1041983 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1041983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1041986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1041988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1041990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1041992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1041994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1041999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042005 */     // GIR_Coverage, 13587,
     /* 1042005 */     GIR_EraseRootFromParent_Done,
     /* 1042006 */   // Label 15412: @1042006
     /* 1042006 */   GIM_Try, /*On fail goto*//*Label 15413*/ GIMT_Encode4(1042083), // Rule ID 13590 //
     /* 1042011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042050 */     // MIs[0] policy
     /* 1042050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042082 */     // GIR_Coverage, 13590,
     /* 1042082 */     GIR_EraseRootFromParent_Done,
     /* 1042083 */   // Label 15413: @1042083
     /* 1042083 */   GIM_Try, /*On fail goto*//*Label 15414*/ GIMT_Encode4(1042160), // Rule ID 13591 //
     /* 1042088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1042099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1042102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1042105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1042108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042127 */     // MIs[0] policy
     /* 1042127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1042156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042159 */     // GIR_Coverage, 13591,
     /* 1042159 */     GIR_EraseRootFromParent_Done,
     /* 1042160 */   // Label 15414: @1042160
     /* 1042160 */   GIM_Try, /*On fail goto*//*Label 15415*/ GIMT_Encode4(1042237), // Rule ID 13594 //
     /* 1042165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042204 */     // MIs[0] policy
     /* 1042204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042214 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042236 */     // GIR_Coverage, 13594,
     /* 1042236 */     GIR_EraseRootFromParent_Done,
     /* 1042237 */   // Label 15415: @1042237
     /* 1042237 */   GIM_Try, /*On fail goto*//*Label 15416*/ GIMT_Encode4(1042314), // Rule ID 13595 //
     /* 1042242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1042253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1042256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1042259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1042262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042281 */     // MIs[0] policy
     /* 1042281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042291 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2),
     /* 1042294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042313 */     // GIR_Coverage, 13595,
     /* 1042313 */     GIR_EraseRootFromParent_Done,
     /* 1042314 */   // Label 15416: @1042314
     /* 1042314 */   GIM_Try, /*On fail goto*//*Label 15417*/ GIMT_Encode4(1042391), // Rule ID 13598 //
     /* 1042319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042358 */     // MIs[0] policy
     /* 1042358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042368 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042390 */     // GIR_Coverage, 13598,
     /* 1042390 */     GIR_EraseRootFromParent_Done,
     /* 1042391 */   // Label 15417: @1042391
     /* 1042391 */   GIM_Try, /*On fail goto*//*Label 15418*/ GIMT_Encode4(1042468), // Rule ID 13599 //
     /* 1042396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1042407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1042410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1042413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1042416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042435 */     // MIs[0] policy
     /* 1042435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1),
     /* 1042448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042467 */     // GIR_Coverage, 13599,
     /* 1042467 */     GIR_EraseRootFromParent_Done,
     /* 1042468 */   // Label 15418: @1042468
     /* 1042468 */   GIM_Try, /*On fail goto*//*Label 15419*/ GIMT_Encode4(1042545), // Rule ID 13602 //
     /* 1042473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042512 */     // MIs[0] policy
     /* 1042512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042522 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042544 */     // GIR_Coverage, 13602,
     /* 1042544 */     GIR_EraseRootFromParent_Done,
     /* 1042545 */   // Label 15419: @1042545
     /* 1042545 */   GIM_Try, /*On fail goto*//*Label 15420*/ GIMT_Encode4(1042622), // Rule ID 13603 //
     /* 1042550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1042561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1042564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1042567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1042570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1042589 */     // MIs[0] policy
     /* 1042589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042599 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2),
     /* 1042602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042621 */     // GIR_Coverage, 13603,
     /* 1042621 */     GIR_EraseRootFromParent_Done,
     /* 1042622 */   // Label 15420: @1042622
     /* 1042622 */   GIM_Try, /*On fail goto*//*Label 15421*/ GIMT_Encode4(1042699), // Rule ID 13606 //
     /* 1042627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1042630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042666 */     // MIs[0] policy
     /* 1042666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042698 */     // GIR_Coverage, 13606,
     /* 1042698 */     GIR_EraseRootFromParent_Done,
     /* 1042699 */   // Label 15421: @1042699
     /* 1042699 */   GIM_Try, /*On fail goto*//*Label 15422*/ GIMT_Encode4(1042776), // Rule ID 13607 //
     /* 1042704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1042707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1042715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1042718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1042721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1042724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1042735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1042743 */     // MIs[0] policy
     /* 1042743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042753 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4),
     /* 1042756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1042772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042775 */     // GIR_Coverage, 13607,
     /* 1042775 */     GIR_EraseRootFromParent_Done,
     /* 1042776 */   // Label 15422: @1042776
     /* 1042776 */   GIM_Try, /*On fail goto*//*Label 15423*/ GIMT_Encode4(1042853), // Rule ID 13610 //
     /* 1042781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042820 */     // MIs[0] policy
     /* 1042820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042830 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1042833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042852 */     // GIR_Coverage, 13610,
     /* 1042852 */     GIR_EraseRootFromParent_Done,
     /* 1042853 */   // Label 15423: @1042853
     /* 1042853 */   GIM_Try, /*On fail goto*//*Label 15424*/ GIMT_Encode4(1042930), // Rule ID 13611 //
     /* 1042858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1042861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1042869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1042872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1042875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1042878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1042881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042897 */     // MIs[0] policy
     /* 1042897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042907 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1042907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8),
     /* 1042910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1042923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1042926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1042928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1042929 */     // GIR_Coverage, 13611,
     /* 1042929 */     GIR_EraseRootFromParent_Done,
     /* 1042930 */   // Label 15424: @1042930
     /* 1042930 */   GIM_Try, /*On fail goto*//*Label 15425*/ GIMT_Encode4(1043007), // Rule ID 13614 //
     /* 1042935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1042938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1042943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1042946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1042949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1042952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1042955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1042958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1042970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1042974 */     // MIs[0] policy
     /* 1042974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1042977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1042984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1042984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1042987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1042989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1042991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1042993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1042995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043006 */     // GIR_Coverage, 13614,
     /* 1043006 */     GIR_EraseRootFromParent_Done,
     /* 1043007 */   // Label 15425: @1043007
     /* 1043007 */   GIM_Try, /*On fail goto*//*Label 15426*/ GIMT_Encode4(1043084), // Rule ID 13615 //
     /* 1043012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1043023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1043026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1043032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043051 */     // MIs[0] policy
     /* 1043051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043061 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043083 */     // GIR_Coverage, 13615,
     /* 1043083 */     GIR_EraseRootFromParent_Done,
     /* 1043084 */   // Label 15426: @1043084
     /* 1043084 */   GIM_Try, /*On fail goto*//*Label 15427*/ GIMT_Encode4(1043161), // Rule ID 13618 //
     /* 1043089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043128 */     // MIs[0] policy
     /* 1043128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043160 */     // GIR_Coverage, 13618,
     /* 1043160 */     GIR_EraseRootFromParent_Done,
     /* 1043161 */   // Label 15427: @1043161
     /* 1043161 */   GIM_Try, /*On fail goto*//*Label 15428*/ GIMT_Encode4(1043238), // Rule ID 13619 //
     /* 1043166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1043177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1043180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1043186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043205 */     // MIs[0] policy
     /* 1043205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043215 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11580:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043237 */     // GIR_Coverage, 13619,
     /* 1043237 */     GIR_EraseRootFromParent_Done,
     /* 1043238 */   // Label 15428: @1043238
     /* 1043238 */   GIM_Try, /*On fail goto*//*Label 15429*/ GIMT_Encode4(1043315), // Rule ID 13622 //
     /* 1043243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043282 */     // MIs[0] policy
     /* 1043282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043314 */     // GIR_Coverage, 13622,
     /* 1043314 */     GIR_EraseRootFromParent_Done,
     /* 1043315 */   // Label 15429: @1043315
     /* 1043315 */   GIM_Try, /*On fail goto*//*Label 15430*/ GIMT_Encode4(1043392), // Rule ID 13623 //
     /* 1043320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1043331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1043334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1043340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043359 */     // MIs[0] policy
     /* 1043359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1043372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043391 */     // GIR_Coverage, 13623,
     /* 1043391 */     GIR_EraseRootFromParent_Done,
     /* 1043392 */   // Label 15430: @1043392
     /* 1043392 */   GIM_Try, /*On fail goto*//*Label 15431*/ GIMT_Encode4(1043469), // Rule ID 13626 //
     /* 1043397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043436 */     // MIs[0] policy
     /* 1043436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043446 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1043449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043468 */     // GIR_Coverage, 13626,
     /* 1043468 */     GIR_EraseRootFromParent_Done,
     /* 1043469 */   // Label 15431: @1043469
     /* 1043469 */   GIM_Try, /*On fail goto*//*Label 15432*/ GIMT_Encode4(1043546), // Rule ID 13627 //
     /* 1043474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1043485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1043488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1043494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1043513 */     // MIs[0] policy
     /* 1043513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043523 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1043526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043545 */     // GIR_Coverage, 13627,
     /* 1043545 */     GIR_EraseRootFromParent_Done,
     /* 1043546 */   // Label 15432: @1043546
     /* 1043546 */   GIM_Try, /*On fail goto*//*Label 15433*/ GIMT_Encode4(1043623), // Rule ID 13630 //
     /* 1043551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043590 */     // MIs[0] policy
     /* 1043590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1043603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043622 */     // GIR_Coverage, 13630,
     /* 1043622 */     GIR_EraseRootFromParent_Done,
     /* 1043623 */   // Label 15433: @1043623
     /* 1043623 */   GIM_Try, /*On fail goto*//*Label 15434*/ GIMT_Encode4(1043700), // Rule ID 13631 //
     /* 1043628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1043639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1043642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1043648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1043659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1043667 */     // MIs[0] policy
     /* 1043667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043677 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1043680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1043696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043699 */     // GIR_Coverage, 13631,
     /* 1043699 */     GIR_EraseRootFromParent_Done,
     /* 1043700 */   // Label 15434: @1043700
     /* 1043700 */   GIM_Try, /*On fail goto*//*Label 15435*/ GIMT_Encode4(1043777), // Rule ID 13634 //
     /* 1043705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043744 */     // MIs[0] policy
     /* 1043744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043776 */     // GIR_Coverage, 13634,
     /* 1043776 */     GIR_EraseRootFromParent_Done,
     /* 1043777 */   // Label 15435: @1043777
     /* 1043777 */   GIM_Try, /*On fail goto*//*Label 15436*/ GIMT_Encode4(1043854), // Rule ID 13635 //
     /* 1043782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1043793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1043796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1043802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043821 */     // MIs[0] policy
     /* 1043821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043831 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4),
     /* 1043834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043853 */     // GIR_Coverage, 13635,
     /* 1043853 */     GIR_EraseRootFromParent_Done,
     /* 1043854 */   // Label 15436: @1043854
     /* 1043854 */   GIM_Try, /*On fail goto*//*Label 15437*/ GIMT_Encode4(1043931), // Rule ID 13638 //
     /* 1043859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1043862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1043876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1043882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043898 */     // MIs[0] policy
     /* 1043898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1043908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1043924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1043927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1043929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1043930 */     // GIR_Coverage, 13638,
     /* 1043930 */     GIR_EraseRootFromParent_Done,
     /* 1043931 */   // Label 15437: @1043931
     /* 1043931 */   GIM_Try, /*On fail goto*//*Label 15438*/ GIMT_Encode4(1044008), // Rule ID 13639 //
     /* 1043936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1043939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1043944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1043947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1043950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1043953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1043956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1043959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1043971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1043975 */     // MIs[0] policy
     /* 1043975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1043978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1043985 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11580:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1043985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1043988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1043990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1043992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1043994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1043996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044007 */     // GIR_Coverage, 13639,
     /* 1044007 */     GIR_EraseRootFromParent_Done,
     /* 1044008 */   // Label 15438: @1044008
     /* 1044008 */   GIM_Try, /*On fail goto*//*Label 15439*/ GIMT_Encode4(1044085), // Rule ID 13642 //
     /* 1044013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044052 */     // MIs[0] policy
     /* 1044052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044062 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044084 */     // GIR_Coverage, 13642,
     /* 1044084 */     GIR_EraseRootFromParent_Done,
     /* 1044085 */   // Label 15439: @1044085
     /* 1044085 */   GIM_Try, /*On fail goto*//*Label 15440*/ GIMT_Encode4(1044162), // Rule ID 13643 //
     /* 1044090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1044101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1044104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1044110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044129 */     // MIs[0] policy
     /* 1044129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044161 */     // GIR_Coverage, 13643,
     /* 1044161 */     GIR_EraseRootFromParent_Done,
     /* 1044162 */   // Label 15440: @1044162
     /* 1044162 */   GIM_Try, /*On fail goto*//*Label 15441*/ GIMT_Encode4(1044239), // Rule ID 13646 //
     /* 1044167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044206 */     // MIs[0] policy
     /* 1044206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044216 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044238 */     // GIR_Coverage, 13646,
     /* 1044238 */     GIR_EraseRootFromParent_Done,
     /* 1044239 */   // Label 15441: @1044239
     /* 1044239 */   GIM_Try, /*On fail goto*//*Label 15442*/ GIMT_Encode4(1044316), // Rule ID 13647 //
     /* 1044244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1044255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1044258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1044264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044283 */     // MIs[0] policy
     /* 1044283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044293 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044315 */     // GIR_Coverage, 13647,
     /* 1044315 */     GIR_EraseRootFromParent_Done,
     /* 1044316 */   // Label 15442: @1044316
     /* 1044316 */   GIM_Try, /*On fail goto*//*Label 15443*/ GIMT_Encode4(1044393), // Rule ID 13650 //
     /* 1044321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1044324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044360 */     // MIs[0] policy
     /* 1044360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044392 */     // GIR_Coverage, 13650,
     /* 1044392 */     GIR_EraseRootFromParent_Done,
     /* 1044393 */   // Label 15443: @1044393
     /* 1044393 */   GIM_Try, /*On fail goto*//*Label 15444*/ GIMT_Encode4(1044470), // Rule ID 13651 //
     /* 1044398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1044401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1044409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1044412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1044418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044437 */     // MIs[0] policy
     /* 1044437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044447 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1044466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044469 */     // GIR_Coverage, 13651,
     /* 1044469 */     GIR_EraseRootFromParent_Done,
     /* 1044470 */   // Label 15444: @1044470
     /* 1044470 */   GIM_Try, /*On fail goto*//*Label 15445*/ GIMT_Encode4(1044547), // Rule ID 13654 //
     /* 1044475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044514 */     // MIs[0] policy
     /* 1044514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044546 */     // GIR_Coverage, 13654,
     /* 1044546 */     GIR_EraseRootFromParent_Done,
     /* 1044547 */   // Label 15445: @1044547
     /* 1044547 */   GIM_Try, /*On fail goto*//*Label 15446*/ GIMT_Encode4(1044624), // Rule ID 13655 //
     /* 1044552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1044563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1044566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1044572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044591 */     // MIs[0] policy
     /* 1044591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044601 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11580:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2),
     /* 1044604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044623 */     // GIR_Coverage, 13655,
     /* 1044623 */     GIR_EraseRootFromParent_Done,
     /* 1044624 */   // Label 15446: @1044624
     /* 1044624 */   GIM_Try, /*On fail goto*//*Label 15447*/ GIMT_Encode4(1044701), // Rule ID 13658 //
     /* 1044629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044668 */     // MIs[0] policy
     /* 1044668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044700 */     // GIR_Coverage, 13658,
     /* 1044700 */     GIR_EraseRootFromParent_Done,
     /* 1044701 */   // Label 15447: @1044701
     /* 1044701 */   GIM_Try, /*On fail goto*//*Label 15448*/ GIMT_Encode4(1044778), // Rule ID 13659 //
     /* 1044706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1044717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1044720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1044726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1044745 */     // MIs[0] policy
     /* 1044745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11580:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1),
     /* 1044758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044777 */     // GIR_Coverage, 13659,
     /* 1044777 */     GIR_EraseRootFromParent_Done,
     /* 1044778 */   // Label 15448: @1044778
     /* 1044778 */   GIM_Try, /*On fail goto*//*Label 15449*/ GIMT_Encode4(1044855), // Rule ID 13662 //
     /* 1044783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044822 */     // MIs[0] policy
     /* 1044822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044854 */     // GIR_Coverage, 13662,
     /* 1044854 */     GIR_EraseRootFromParent_Done,
     /* 1044855 */   // Label 15449: @1044855
     /* 1044855 */   GIM_Try, /*On fail goto*//*Label 15450*/ GIMT_Encode4(1044932), // Rule ID 13663 //
     /* 1044860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1044863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1044871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1044874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1044877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1044880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1044883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1044899 */     // MIs[0] policy
     /* 1044899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044909 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11580:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1044909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2),
     /* 1044912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1044925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1044928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1044930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1044931 */     // GIR_Coverage, 13663,
     /* 1044931 */     GIR_EraseRootFromParent_Done,
     /* 1044932 */   // Label 15450: @1044932
     /* 1044932 */   GIM_Try, /*On fail goto*//*Label 15451*/ GIMT_Encode4(1045009), // Rule ID 13666 //
     /* 1044937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1044940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1044945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1044948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1044951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1044954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1044957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1044960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1044968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1044972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1044976 */     // MIs[0] policy
     /* 1044976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1044979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1044986 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1044986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1044989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1044991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1044993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1044995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1044997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045008 */     // GIR_Coverage, 13666,
     /* 1045008 */     GIR_EraseRootFromParent_Done,
     /* 1045009 */   // Label 15451: @1045009
     /* 1045009 */   GIM_Try, /*On fail goto*//*Label 15452*/ GIMT_Encode4(1045086), // Rule ID 13667 //
     /* 1045014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1045017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu),
     /* 1045022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1045025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1045028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1045034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045053 */     // MIs[0] policy
     /* 1045053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045063 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11580:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4),
     /* 1045066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1045082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045085 */     // GIR_Coverage, 13667,
     /* 1045085 */     GIR_EraseRootFromParent_Done,
     /* 1045086 */   // Label 15452: @1045086
     /* 1045086 */   GIM_Try, /*On fail goto*//*Label 15453*/ GIMT_Encode4(1045163), // Rule ID 13670 //
     /* 1045091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045130 */     // MIs[0] policy
     /* 1045130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045140 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045162 */     // GIR_Coverage, 13670,
     /* 1045162 */     GIR_EraseRootFromParent_Done,
     /* 1045163 */   // Label 15453: @1045163
     /* 1045163 */   GIM_Try, /*On fail goto*//*Label 15454*/ GIMT_Encode4(1045240), // Rule ID 13671 //
     /* 1045168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1045179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1045182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1045188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045207 */     // MIs[0] policy
     /* 1045207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045217 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8),
     /* 1045220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045239 */     // GIR_Coverage, 13671,
     /* 1045239 */     GIR_EraseRootFromParent_Done,
     /* 1045240 */   // Label 15454: @1045240
     /* 1045240 */   GIM_Try, /*On fail goto*//*Label 15455*/ GIMT_Encode4(1045317), // Rule ID 13674 //
     /* 1045245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045284 */     // MIs[0] policy
     /* 1045284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045294 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045316 */     // GIR_Coverage, 13674,
     /* 1045316 */     GIR_EraseRootFromParent_Done,
     /* 1045317 */   // Label 15455: @1045317
     /* 1045317 */   GIM_Try, /*On fail goto*//*Label 15456*/ GIMT_Encode4(1045394), // Rule ID 13675 //
     /* 1045322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1045333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1045336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1045342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045361 */     // MIs[0] policy
     /* 1045361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045371 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1045374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045393 */     // GIR_Coverage, 13675,
     /* 1045393 */     GIR_EraseRootFromParent_Done,
     /* 1045394 */   // Label 15456: @1045394
     /* 1045394 */   GIM_Try, /*On fail goto*//*Label 15457*/ GIMT_Encode4(1045471), // Rule ID 13678 //
     /* 1045399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045438 */     // MIs[0] policy
     /* 1045438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1045451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045470 */     // GIR_Coverage, 13678,
     /* 1045470 */     GIR_EraseRootFromParent_Done,
     /* 1045471 */   // Label 15457: @1045471
     /* 1045471 */   GIM_Try, /*On fail goto*//*Label 15458*/ GIMT_Encode4(1045548), // Rule ID 13679 //
     /* 1045476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1045487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1045490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1045496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045515 */     // MIs[0] policy
     /* 1045515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045525 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11584:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1045528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045547 */     // GIR_Coverage, 13679,
     /* 1045547 */     GIR_EraseRootFromParent_Done,
     /* 1045548 */   // Label 15458: @1045548
     /* 1045548 */   GIM_Try, /*On fail goto*//*Label 15459*/ GIMT_Encode4(1045625), // Rule ID 13682 //
     /* 1045553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045592 */     // MIs[0] policy
     /* 1045592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045602 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1045605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045624 */     // GIR_Coverage, 13682,
     /* 1045624 */     GIR_EraseRootFromParent_Done,
     /* 1045625 */   // Label 15459: @1045625
     /* 1045625 */   GIM_Try, /*On fail goto*//*Label 15460*/ GIMT_Encode4(1045702), // Rule ID 13683 //
     /* 1045630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1045641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1045644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1045650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1045669 */     // MIs[0] policy
     /* 1045669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1045682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045701 */     // GIR_Coverage, 13683,
     /* 1045701 */     GIR_EraseRootFromParent_Done,
     /* 1045702 */   // Label 15460: @1045702
     /* 1045702 */   GIM_Try, /*On fail goto*//*Label 15461*/ GIMT_Encode4(1045779), // Rule ID 13686 //
     /* 1045707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045746 */     // MIs[0] policy
     /* 1045746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045756 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1045759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045778 */     // GIR_Coverage, 13686,
     /* 1045778 */     GIR_EraseRootFromParent_Done,
     /* 1045779 */   // Label 15461: @1045779
     /* 1045779 */   GIM_Try, /*On fail goto*//*Label 15462*/ GIMT_Encode4(1045856), // Rule ID 13687 //
     /* 1045784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1045795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1045798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1045804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1045823 */     // MIs[0] policy
     /* 1045823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045833 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1045836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045855 */     // GIR_Coverage, 13687,
     /* 1045855 */     GIR_EraseRootFromParent_Done,
     /* 1045856 */   // Label 15462: @1045856
     /* 1045856 */   GIM_Try, /*On fail goto*//*Label 15463*/ GIMT_Encode4(1045933), // Rule ID 13690 //
     /* 1045861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1045864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1045878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1045884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045900 */     // MIs[0] policy
     /* 1045900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1045910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1045913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1045926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1045929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1045931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1045932 */     // GIR_Coverage, 13690,
     /* 1045932 */     GIR_EraseRootFromParent_Done,
     /* 1045933 */   // Label 15463: @1045933
     /* 1045933 */   GIM_Try, /*On fail goto*//*Label 15464*/ GIMT_Encode4(1046010), // Rule ID 13691 //
     /* 1045938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1045941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1045946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1045949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1045952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1045955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1045958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1045961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1045969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1045973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1045977 */     // MIs[0] policy
     /* 1045977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1045980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1045987 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1045987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1045990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1045992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1045994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1045996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1045998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1046006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046009 */     // GIR_Coverage, 13691,
     /* 1046009 */     GIR_EraseRootFromParent_Done,
     /* 1046010 */   // Label 15464: @1046010
     /* 1046010 */   GIM_Try, /*On fail goto*//*Label 15465*/ GIMT_Encode4(1046087), // Rule ID 13694 //
     /* 1046015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046054 */     // MIs[0] policy
     /* 1046054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046064 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046086 */     // GIR_Coverage, 13694,
     /* 1046086 */     GIR_EraseRootFromParent_Done,
     /* 1046087 */   // Label 15465: @1046087
     /* 1046087 */   GIM_Try, /*On fail goto*//*Label 15466*/ GIMT_Encode4(1046164), // Rule ID 13695 //
     /* 1046092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1046103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1046106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1046112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046131 */     // MIs[0] policy
     /* 1046131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4),
     /* 1046144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046163 */     // GIR_Coverage, 13695,
     /* 1046163 */     GIR_EraseRootFromParent_Done,
     /* 1046164 */   // Label 15466: @1046164
     /* 1046164 */   GIM_Try, /*On fail goto*//*Label 15467*/ GIMT_Encode4(1046241), // Rule ID 13698 //
     /* 1046169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046208 */     // MIs[0] policy
     /* 1046208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046240 */     // GIR_Coverage, 13698,
     /* 1046240 */     GIR_EraseRootFromParent_Done,
     /* 1046241 */   // Label 15467: @1046241
     /* 1046241 */   GIM_Try, /*On fail goto*//*Label 15468*/ GIMT_Encode4(1046318), // Rule ID 13699 //
     /* 1046246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1046257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1046260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1046266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046285 */     // MIs[0] policy
     /* 1046285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046295 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11584:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046317 */     // GIR_Coverage, 13699,
     /* 1046317 */     GIR_EraseRootFromParent_Done,
     /* 1046318 */   // Label 15468: @1046318
     /* 1046318 */   GIM_Try, /*On fail goto*//*Label 15469*/ GIMT_Encode4(1046395), // Rule ID 13702 //
     /* 1046323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046362 */     // MIs[0] policy
     /* 1046362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046394 */     // GIR_Coverage, 13702,
     /* 1046394 */     GIR_EraseRootFromParent_Done,
     /* 1046395 */   // Label 15469: @1046395
     /* 1046395 */   GIM_Try, /*On fail goto*//*Label 15470*/ GIMT_Encode4(1046472), // Rule ID 13703 //
     /* 1046400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1046411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1046414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1046420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046439 */     // MIs[0] policy
     /* 1046439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046449 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046471 */     // GIR_Coverage, 13703,
     /* 1046471 */     GIR_EraseRootFromParent_Done,
     /* 1046472 */   // Label 15470: @1046472
     /* 1046472 */   GIM_Try, /*On fail goto*//*Label 15471*/ GIMT_Encode4(1046549), // Rule ID 13706 //
     /* 1046477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046516 */     // MIs[0] policy
     /* 1046516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046548 */     // GIR_Coverage, 13706,
     /* 1046548 */     GIR_EraseRootFromParent_Done,
     /* 1046549 */   // Label 15471: @1046549
     /* 1046549 */   GIM_Try, /*On fail goto*//*Label 15472*/ GIMT_Encode4(1046626), // Rule ID 13707 //
     /* 1046554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1046565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1046568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1046574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046593 */     // MIs[0] policy
     /* 1046593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046603 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1046606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046625 */     // GIR_Coverage, 13707,
     /* 1046625 */     GIR_EraseRootFromParent_Done,
     /* 1046626 */   // Label 15472: @1046626
     /* 1046626 */   GIM_Try, /*On fail goto*//*Label 15473*/ GIMT_Encode4(1046703), // Rule ID 13710 //
     /* 1046631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1046634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046670 */     // MIs[0] policy
     /* 1046670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046680 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046702 */     // GIR_Coverage, 13710,
     /* 1046702 */     GIR_EraseRootFromParent_Done,
     /* 1046703 */   // Label 15473: @1046703
     /* 1046703 */   GIM_Try, /*On fail goto*//*Label 15474*/ GIMT_Encode4(1046780), // Rule ID 13711 //
     /* 1046708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1046711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1046719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1046722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1046728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1046739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1046747 */     // MIs[0] policy
     /* 1046747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046757 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1046760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1046776 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046779 */     // GIR_Coverage, 13711,
     /* 1046779 */     GIR_EraseRootFromParent_Done,
     /* 1046780 */   // Label 15474: @1046780
     /* 1046780 */   GIM_Try, /*On fail goto*//*Label 15475*/ GIMT_Encode4(1046857), // Rule ID 13714 //
     /* 1046785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046824 */     // MIs[0] policy
     /* 1046824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046853 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046856 */     // GIR_Coverage, 13714,
     /* 1046856 */     GIR_EraseRootFromParent_Done,
     /* 1046857 */   // Label 15475: @1046857
     /* 1046857 */   GIM_Try, /*On fail goto*//*Label 15476*/ GIMT_Encode4(1046934), // Rule ID 13715 //
     /* 1046862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1046865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1046873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1046876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1046879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1046882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1046885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046901 */     // MIs[0] policy
     /* 1046901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046911 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11584:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1046911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2),
     /* 1046914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1046927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1046930 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1046932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1046933 */     // GIR_Coverage, 13715,
     /* 1046933 */     GIR_EraseRootFromParent_Done,
     /* 1046934 */   // Label 15476: @1046934
     /* 1046934 */   GIM_Try, /*On fail goto*//*Label 15477*/ GIMT_Encode4(1047011), // Rule ID 13718 //
     /* 1046939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1046942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1046947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1046950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1046953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1046956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1046959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1046962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1046970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1046974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1046978 */     // MIs[0] policy
     /* 1046978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1046981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1046988 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1046988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1046991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1046993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1046995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1046997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1046999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047010 */     // GIR_Coverage, 13718,
     /* 1047010 */     GIR_EraseRootFromParent_Done,
     /* 1047011 */   // Label 15477: @1047011
     /* 1047011 */   GIM_Try, /*On fail goto*//*Label 15478*/ GIMT_Encode4(1047088), // Rule ID 13719 //
     /* 1047016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1047027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1047030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1047036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047055 */     // MIs[0] policy
     /* 1047055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047065 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11584:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1),
     /* 1047068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047084 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047087 */     // GIR_Coverage, 13719,
     /* 1047087 */     GIR_EraseRootFromParent_Done,
     /* 1047088 */   // Label 15478: @1047088
     /* 1047088 */   GIM_Try, /*On fail goto*//*Label 15479*/ GIMT_Encode4(1047165), // Rule ID 13722 //
     /* 1047093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047132 */     // MIs[0] policy
     /* 1047132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047161 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047164 */     // GIR_Coverage, 13722,
     /* 1047164 */     GIR_EraseRootFromParent_Done,
     /* 1047165 */   // Label 15479: @1047165
     /* 1047165 */   GIM_Try, /*On fail goto*//*Label 15480*/ GIMT_Encode4(1047242), // Rule ID 13723 //
     /* 1047170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1047181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1047184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1047190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1047209 */     // MIs[0] policy
     /* 1047209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047219 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11584:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2),
     /* 1047222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047238 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047241 */     // GIR_Coverage, 13723,
     /* 1047241 */     GIR_EraseRootFromParent_Done,
     /* 1047242 */   // Label 15480: @1047242
     /* 1047242 */   GIM_Try, /*On fail goto*//*Label 15481*/ GIMT_Encode4(1047319), // Rule ID 13726 //
     /* 1047247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1047250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1047264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047286 */     // MIs[0] policy
     /* 1047286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047296 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047315 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047318 */     // GIR_Coverage, 13726,
     /* 1047318 */     GIR_EraseRootFromParent_Done,
     /* 1047319 */   // Label 15481: @1047319
     /* 1047319 */   GIM_Try, /*On fail goto*//*Label 15482*/ GIMT_Encode4(1047396), // Rule ID 13727 //
     /* 1047324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1047327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus),
     /* 1047332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1047335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1047338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1047341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1047344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1047355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1047359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1047363 */     // MIs[0] policy
     /* 1047363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047373 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11584:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4),
     /* 1047376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1047380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1047382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1047384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047392 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047395 */     // GIR_Coverage, 13727,
     /* 1047395 */     GIR_EraseRootFromParent_Done,
     /* 1047396 */   // Label 15482: @1047396
     /* 1047396 */   GIM_Try, /*On fail goto*//*Label 15483*/ GIMT_Encode4(1047473), // Rule ID 18940 //
     /* 1047401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1047404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1047418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047440 */     // MIs[0] policy
     /* 1047440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047450 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1047453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047459 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047469 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047472 */     // GIR_Coverage, 18940,
     /* 1047472 */     GIR_EraseRootFromParent_Done,
     /* 1047473 */   // Label 15483: @1047473
     /* 1047473 */   GIM_Try, /*On fail goto*//*Label 15484*/ GIMT_Encode4(1047550), // Rule ID 18941 //
     /* 1047478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1047481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1047489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1047492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1047495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047517 */     // MIs[0] policy
     /* 1047517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047527 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E16_MASK),
     /* 1047530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047536 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047546 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047549 */     // GIR_Coverage, 18941,
     /* 1047549 */     GIR_EraseRootFromParent_Done,
     /* 1047550 */   // Label 15484: @1047550
     /* 1047550 */   GIM_Try, /*On fail goto*//*Label 15485*/ GIMT_Encode4(1047627), // Rule ID 18944 //
     /* 1047555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1047558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1047572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1047575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047594 */     // MIs[0] policy
     /* 1047594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047604 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1047607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047623 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047626 */     // GIR_Coverage, 18944,
     /* 1047626 */     GIR_EraseRootFromParent_Done,
     /* 1047627 */   // Label 15485: @1047627
     /* 1047627 */   GIM_Try, /*On fail goto*//*Label 15486*/ GIMT_Encode4(1047704), // Rule ID 18945 //
     /* 1047632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1047635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1047643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1047646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1047649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1047652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047671 */     // MIs[0] policy
     /* 1047671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047681 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_MF2_E32_MASK),
     /* 1047684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047690 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047700 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047703 */     // GIR_Coverage, 18945,
     /* 1047703 */     GIR_EraseRootFromParent_Done,
     /* 1047704 */   // Label 15486: @1047704
     /* 1047704 */   GIM_Try, /*On fail goto*//*Label 15487*/ GIMT_Encode4(1047781), // Rule ID 18948 //
     /* 1047709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1047712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1047726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1047729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047748 */     // MIs[0] policy
     /* 1047748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1047761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047767 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047777 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047780 */     // GIR_Coverage, 18948,
     /* 1047780 */     GIR_EraseRootFromParent_Done,
     /* 1047781 */   // Label 15487: @1047781
     /* 1047781 */   GIM_Try, /*On fail goto*//*Label 15488*/ GIMT_Encode4(1047858), // Rule ID 18949 //
     /* 1047786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1047789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1047797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1047800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1047803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1047806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047825 */     // MIs[0] policy
     /* 1047825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047835 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11193:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E16_MASK),
     /* 1047838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1047854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047857 */     // GIR_Coverage, 18949,
     /* 1047857 */     GIR_EraseRootFromParent_Done,
     /* 1047858 */   // Label 15488: @1047858
     /* 1047858 */   GIM_Try, /*On fail goto*//*Label 15489*/ GIMT_Encode4(1047935), // Rule ID 18952 //
     /* 1047863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1047866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1047880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1047886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047902 */     // MIs[0] policy
     /* 1047902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1047912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1047915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1047923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1047928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1047931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1047933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1047934 */     // GIR_Coverage, 18952,
     /* 1047934 */     GIR_EraseRootFromParent_Done,
     /* 1047935 */   // Label 15489: @1047935
     /* 1047935 */   GIM_Try, /*On fail goto*//*Label 15490*/ GIMT_Encode4(1048012), // Rule ID 18953 //
     /* 1047940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1047943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1047948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1047951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1047954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1047957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1047960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1047963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1047967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1047975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1047979 */     // MIs[0] policy
     /* 1047979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1047982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1047989 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11193:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1047989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E32_MASK),
     /* 1047992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1047994 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1047996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1047998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048011 */     // GIR_Coverage, 18953,
     /* 1048011 */     GIR_EraseRootFromParent_Done,
     /* 1048012 */   // Label 15490: @1048012
     /* 1048012 */   GIM_Try, /*On fail goto*//*Label 15491*/ GIMT_Encode4(1048089), // Rule ID 18956 //
     /* 1048017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1048020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048056 */     // MIs[0] policy
     /* 1048056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048066 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048088 */     // GIR_Coverage, 18956,
     /* 1048088 */     GIR_EraseRootFromParent_Done,
     /* 1048089 */   // Label 15491: @1048089
     /* 1048089 */   GIM_Try, /*On fail goto*//*Label 15492*/ GIMT_Encode4(1048166), // Rule ID 18957 //
     /* 1048094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1048097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1048105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1048108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1048111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1048114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1048121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1048129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048133 */     // MIs[0] policy
     /* 1048133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048143 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11193:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M1_E64_MASK),
     /* 1048146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048152 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1048162 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048165 */     // GIR_Coverage, 18957,
     /* 1048165 */     GIR_EraseRootFromParent_Done,
     /* 1048166 */   // Label 15492: @1048166
     /* 1048166 */   GIM_Try, /*On fail goto*//*Label 15493*/ GIMT_Encode4(1048243), // Rule ID 18960 //
     /* 1048171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048210 */     // MIs[0] policy
     /* 1048210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048229 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048239 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048242 */     // GIR_Coverage, 18960,
     /* 1048242 */     GIR_EraseRootFromParent_Done,
     /* 1048243 */   // Label 15493: @1048243
     /* 1048243 */   GIM_Try, /*On fail goto*//*Label 15494*/ GIMT_Encode4(1048320), // Rule ID 18961 //
     /* 1048248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1048259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1048262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1048265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048287 */     // MIs[0] policy
     /* 1048287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048297 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E16_MASK),
     /* 1048300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048306 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048316 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048319 */     // GIR_Coverage, 18961,
     /* 1048319 */     GIR_EraseRootFromParent_Done,
     /* 1048320 */   // Label 15494: @1048320
     /* 1048320 */   GIM_Try, /*On fail goto*//*Label 15495*/ GIMT_Encode4(1048397), // Rule ID 18964 //
     /* 1048325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048364 */     // MIs[0] policy
     /* 1048364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048374 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048393 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048396 */     // GIR_Coverage, 18964,
     /* 1048396 */     GIR_EraseRootFromParent_Done,
     /* 1048397 */   // Label 15495: @1048397
     /* 1048397 */   GIM_Try, /*On fail goto*//*Label 15496*/ GIMT_Encode4(1048474), // Rule ID 18965 //
     /* 1048402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1048413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1048416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1048419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048441 */     // MIs[0] policy
     /* 1048441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048451 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E16_MASK),
     /* 1048454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048460 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048470 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048473 */     // GIR_Coverage, 18965,
     /* 1048473 */     GIR_EraseRootFromParent_Done,
     /* 1048474 */   // Label 15496: @1048474
     /* 1048474 */   GIM_Try, /*On fail goto*//*Label 15497*/ GIMT_Encode4(1048551), // Rule ID 18968 //
     /* 1048479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1048482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1048490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1048493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1048496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1048499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1048506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048518 */     // MIs[0] policy
     /* 1048518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048528 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1048531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048547 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048550 */     // GIR_Coverage, 18968,
     /* 1048550 */     GIR_EraseRootFromParent_Done,
     /* 1048551 */   // Label 15497: @1048551
     /* 1048551 */   GIM_Try, /*On fail goto*//*Label 15498*/ GIMT_Encode4(1048628), // Rule ID 18969 //
     /* 1048556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1048559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1048567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1048570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1048573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1048576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1048583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048595 */     // MIs[0] policy
     /* 1048595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048605 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E16_MASK),
     /* 1048608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048614 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1048624 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048627 */     // GIR_Coverage, 18969,
     /* 1048627 */     GIR_EraseRootFromParent_Done,
     /* 1048628 */   // Label 15498: @1048628
     /* 1048628 */   GIM_Try, /*On fail goto*//*Label 15499*/ GIMT_Encode4(1048705), // Rule ID 18972 //
     /* 1048633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1048650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048672 */     // MIs[0] policy
     /* 1048672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048682 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1048685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048701 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048704 */     // GIR_Coverage, 18972,
     /* 1048704 */     GIR_EraseRootFromParent_Done,
     /* 1048705 */   // Label 15499: @1048705
     /* 1048705 */   GIM_Try, /*On fail goto*//*Label 15500*/ GIMT_Encode4(1048782), // Rule ID 18973 //
     /* 1048710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1048721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1048724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1048727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1048730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1048737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1048745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048749 */     // MIs[0] policy
     /* 1048749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048759 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E32_MASK),
     /* 1048762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048768 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048778 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048781 */     // GIR_Coverage, 18973,
     /* 1048781 */     GIR_EraseRootFromParent_Done,
     /* 1048782 */   // Label 15500: @1048782
     /* 1048782 */   GIM_Try, /*On fail goto*//*Label 15501*/ GIMT_Encode4(1048859), // Rule ID 18976 //
     /* 1048787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1048804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048826 */     // MIs[0] policy
     /* 1048826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048836 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1048839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048858 */     // GIR_Coverage, 18976,
     /* 1048858 */     GIR_EraseRootFromParent_Done,
     /* 1048859 */   // Label 15501: @1048859
     /* 1048859 */   GIM_Try, /*On fail goto*//*Label 15502*/ GIMT_Encode4(1048936), // Rule ID 18977 //
     /* 1048864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1048867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1048875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1048878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1048881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1048884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1048887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1048891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1048899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048903 */     // MIs[0] policy
     /* 1048903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048913 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1048913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E32_MASK),
     /* 1048916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1048924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1048929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1048932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1048934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1048935 */     // GIR_Coverage, 18977,
     /* 1048935 */     GIR_EraseRootFromParent_Done,
     /* 1048936 */   // Label 15502: @1048936
     /* 1048936 */   GIM_Try, /*On fail goto*//*Label 15503*/ GIMT_Encode4(1049013), // Rule ID 18980 //
     /* 1048941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1048944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1048949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1048952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1048955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1048958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1048961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1048964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1048968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1048976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1048980 */     // MIs[0] policy
     /* 1048980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1048983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1048990 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1048990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1048993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1048995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1048997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1048999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049012 */     // GIR_Coverage, 18980,
     /* 1049012 */     GIR_EraseRootFromParent_Done,
     /* 1049013 */   // Label 15503: @1049013
     /* 1049013 */   GIM_Try, /*On fail goto*//*Label 15504*/ GIMT_Encode4(1049090), // Rule ID 18981 //
     /* 1049018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1049021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1049029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1049032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1049035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1049038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049057 */     // MIs[0] policy
     /* 1049057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049067 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E32_MASK),
     /* 1049070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049076 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049086 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049089 */     // GIR_Coverage, 18981,
     /* 1049089 */     GIR_EraseRootFromParent_Done,
     /* 1049090 */   // Label 15504: @1049090
     /* 1049090 */   GIM_Try, /*On fail goto*//*Label 15505*/ GIMT_Encode4(1049167), // Rule ID 18984 //
     /* 1049095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049134 */     // MIs[0] policy
     /* 1049134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049144 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049163 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049166 */     // GIR_Coverage, 18984,
     /* 1049166 */     GIR_EraseRootFromParent_Done,
     /* 1049167 */   // Label 15505: @1049167
     /* 1049167 */   GIM_Try, /*On fail goto*//*Label 15506*/ GIMT_Encode4(1049244), // Rule ID 18985 //
     /* 1049172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1049183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1049186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1049189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1049199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1049207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049211 */     // MIs[0] policy
     /* 1049211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049221 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11193:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M2_E64_MASK),
     /* 1049224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049243 */     // GIR_Coverage, 18985,
     /* 1049243 */     GIR_EraseRootFromParent_Done,
     /* 1049244 */   // Label 15506: @1049244
     /* 1049244 */   GIM_Try, /*On fail goto*//*Label 15507*/ GIMT_Encode4(1049321), // Rule ID 18988 //
     /* 1049249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049288 */     // MIs[0] policy
     /* 1049288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049298 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049320 */     // GIR_Coverage, 18988,
     /* 1049320 */     GIR_EraseRootFromParent_Done,
     /* 1049321 */   // Label 15507: @1049321
     /* 1049321 */   GIM_Try, /*On fail goto*//*Label 15508*/ GIMT_Encode4(1049398), // Rule ID 18989 //
     /* 1049326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1049337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1049340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1049343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1049353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1049361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049365 */     // MIs[0] policy
     /* 1049365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049375 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11193:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M4_E64_MASK),
     /* 1049378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049397 */     // GIR_Coverage, 18989,
     /* 1049397 */     GIR_EraseRootFromParent_Done,
     /* 1049398 */   // Label 15508: @1049398
     /* 1049398 */   GIM_Try, /*On fail goto*//*Label 15509*/ GIMT_Encode4(1049475), // Rule ID 18992 //
     /* 1049403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1049406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1049420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049442 */     // MIs[0] policy
     /* 1049442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049452 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1049455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049471 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049474 */     // GIR_Coverage, 18992,
     /* 1049474 */     GIR_EraseRootFromParent_Done,
     /* 1049475 */   // Label 15509: @1049475
     /* 1049475 */   GIM_Try, /*On fail goto*//*Label 15510*/ GIMT_Encode4(1049552), // Rule ID 18993 //
     /* 1049480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1049483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsqrt7_mask),
     /* 1049488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1049491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1049494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1049497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1049500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1049507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1049515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049519 */     // MIs[0] policy
     /* 1049519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049529 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11193:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSQRT7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSQRT7_V_M8_E64_MASK),
     /* 1049532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049538 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1049548 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049551 */     // GIR_Coverage, 18993,
     /* 1049551 */     GIR_EraseRootFromParent_Done,
     /* 1049552 */   // Label 15510: @1049552
     /* 1049552 */   GIM_Try, /*On fail goto*//*Label 15511*/ GIMT_Encode4(1049629), // Rule ID 20376 //
     /* 1049557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1049560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1049574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049596 */     // MIs[0] policy
     /* 1049596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1049609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049625 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049628 */     // GIR_Coverage, 20376,
     /* 1049628 */     GIR_EraseRootFromParent_Done,
     /* 1049629 */   // Label 15511: @1049629
     /* 1049629 */   GIM_Try, /*On fail goto*//*Label 15512*/ GIMT_Encode4(1049706), // Rule ID 20377 //
     /* 1049634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1049637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1049645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1049648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1049651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1049654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049673 */     // MIs[0] policy
     /* 1049673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049683 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1049686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049692 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049702 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049705 */     // GIR_Coverage, 20377,
     /* 1049705 */     GIR_EraseRootFromParent_Done,
     /* 1049706 */   // Label 15512: @1049706
     /* 1049706 */   GIM_Try, /*On fail goto*//*Label 15513*/ GIMT_Encode4(1049783), // Rule ID 20380 //
     /* 1049711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1049714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1049722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1049725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1049728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049750 */     // MIs[0] policy
     /* 1049750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049760 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1049763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049779 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049782 */     // GIR_Coverage, 20380,
     /* 1049782 */     GIR_EraseRootFromParent_Done,
     /* 1049783 */   // Label 15513: @1049783
     /* 1049783 */   GIM_Try, /*On fail goto*//*Label 15514*/ GIMT_Encode4(1049860), // Rule ID 20381 //
     /* 1049788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1049791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1049799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1049802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1049805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1049808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049827 */     // MIs[0] policy
     /* 1049827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049837 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_MF2_MASK),
     /* 1049840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049846 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1049856 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049859 */     // GIR_Coverage, 20381,
     /* 1049859 */     GIR_EraseRootFromParent_Done,
     /* 1049860 */   // Label 15514: @1049860
     /* 1049860 */   GIM_Try, /*On fail goto*//*Label 15515*/ GIMT_Encode4(1049937), // Rule ID 20384 //
     /* 1049865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1049868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1049882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1049888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049904 */     // MIs[0] policy
     /* 1049904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049914 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1049914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1049917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1049923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1049925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1049930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1049933 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1049935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1049936 */     // GIR_Coverage, 20384,
     /* 1049936 */     GIR_EraseRootFromParent_Done,
     /* 1049937 */   // Label 15515: @1049937
     /* 1049937 */   GIM_Try, /*On fail goto*//*Label 15516*/ GIMT_Encode4(1050014), // Rule ID 20385 //
     /* 1049942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1049945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1049950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1049953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1049956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1049959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1049962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1049965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1049969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1049977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1049981 */     // MIs[0] policy
     /* 1049981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1049984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1049991 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11119:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1049991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1049994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1049996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1049998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050013 */     // GIR_Coverage, 20385,
     /* 1050013 */     GIR_EraseRootFromParent_Done,
     /* 1050014 */   // Label 15516: @1050014
     /* 1050014 */   GIM_Try, /*On fail goto*//*Label 15517*/ GIMT_Encode4(1050091), // Rule ID 20388 //
     /* 1050019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050058 */     // MIs[0] policy
     /* 1050058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050068 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050077 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050087 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050090 */     // GIR_Coverage, 20388,
     /* 1050090 */     GIR_EraseRootFromParent_Done,
     /* 1050091 */   // Label 15517: @1050091
     /* 1050091 */   GIM_Try, /*On fail goto*//*Label 15518*/ GIMT_Encode4(1050168), // Rule ID 20389 //
     /* 1050096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1050107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1050110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1050113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1050116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050135 */     // MIs[0] policy
     /* 1050135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050145 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11119:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050154 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050164 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050167 */     // GIR_Coverage, 20389,
     /* 1050167 */     GIR_EraseRootFromParent_Done,
     /* 1050168 */   // Label 15518: @1050168
     /* 1050168 */   GIM_Try, /*On fail goto*//*Label 15519*/ GIMT_Encode4(1050245), // Rule ID 20392 //
     /* 1050173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1050176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050212 */     // MIs[0] policy
     /* 1050212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050222 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050244 */     // GIR_Coverage, 20392,
     /* 1050244 */     GIR_EraseRootFromParent_Done,
     /* 1050245 */   // Label 15519: @1050245
     /* 1050245 */   GIM_Try, /*On fail goto*//*Label 15520*/ GIMT_Encode4(1050322), // Rule ID 20393 //
     /* 1050250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1050253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1050261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1050264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1050267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1050270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1050277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1050285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050289 */     // MIs[0] policy
     /* 1050289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050299 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11119:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M1_MASK),
     /* 1050302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1050318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050321 */     // GIR_Coverage, 20393,
     /* 1050321 */     GIR_EraseRootFromParent_Done,
     /* 1050322 */   // Label 15520: @1050322
     /* 1050322 */   GIM_Try, /*On fail goto*//*Label 15521*/ GIMT_Encode4(1050399), // Rule ID 20396 //
     /* 1050327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050366 */     // MIs[0] policy
     /* 1050366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050395 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050398 */     // GIR_Coverage, 20396,
     /* 1050398 */     GIR_EraseRootFromParent_Done,
     /* 1050399 */   // Label 15521: @1050399
     /* 1050399 */   GIM_Try, /*On fail goto*//*Label 15522*/ GIMT_Encode4(1050476), // Rule ID 20397 //
     /* 1050404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1050415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1050418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1050421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050443 */     // MIs[0] policy
     /* 1050443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050453 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050462 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050472 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050475 */     // GIR_Coverage, 20397,
     /* 1050475 */     GIR_EraseRootFromParent_Done,
     /* 1050476 */   // Label 15522: @1050476
     /* 1050476 */   GIM_Try, /*On fail goto*//*Label 15523*/ GIMT_Encode4(1050553), // Rule ID 20400 //
     /* 1050481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1050498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1050501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050520 */     // MIs[0] policy
     /* 1050520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050530 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1050533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050539 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050549 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050552 */     // GIR_Coverage, 20400,
     /* 1050552 */     GIR_EraseRootFromParent_Done,
     /* 1050553 */   // Label 15523: @1050553
     /* 1050553 */   GIM_Try, /*On fail goto*//*Label 15524*/ GIMT_Encode4(1050630), // Rule ID 20401 //
     /* 1050558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1050569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1050572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1050575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1050578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050597 */     // MIs[0] policy
     /* 1050597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050607 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1050610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050616 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050626 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050629 */     // GIR_Coverage, 20401,
     /* 1050629 */     GIR_EraseRootFromParent_Done,
     /* 1050630 */   // Label 15524: @1050630
     /* 1050630 */   GIM_Try, /*On fail goto*//*Label 15525*/ GIMT_Encode4(1050707), // Rule ID 20404 //
     /* 1050635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1050638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1050652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1050655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050674 */     // MIs[0] policy
     /* 1050674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050684 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1050687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050706 */     // GIR_Coverage, 20404,
     /* 1050706 */     GIR_EraseRootFromParent_Done,
     /* 1050707 */   // Label 15525: @1050707
     /* 1050707 */   GIM_Try, /*On fail goto*//*Label 15526*/ GIMT_Encode4(1050784), // Rule ID 20405 //
     /* 1050712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1050715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1050723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1050726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1050729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1050732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1050739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1050747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050751 */     // MIs[0] policy
     /* 1050751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050761 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1050764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1050780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050783 */     // GIR_Coverage, 20405,
     /* 1050783 */     GIR_EraseRootFromParent_Done,
     /* 1050784 */   // Label 15526: @1050784
     /* 1050784 */   GIM_Try, /*On fail goto*//*Label 15527*/ GIMT_Encode4(1050861), // Rule ID 20408 //
     /* 1050789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1050806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050828 */     // MIs[0] policy
     /* 1050828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050838 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050847 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050857 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050860 */     // GIR_Coverage, 20408,
     /* 1050860 */     GIR_EraseRootFromParent_Done,
     /* 1050861 */   // Label 15527: @1050861
     /* 1050861 */   GIM_Try, /*On fail goto*//*Label 15528*/ GIMT_Encode4(1050938), // Rule ID 20409 //
     /* 1050866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1050869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1050877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1050880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1050883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1050886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1050889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1050893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1050901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050905 */     // MIs[0] policy
     /* 1050905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1050915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1050918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1050924 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1050926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1050931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1050934 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1050936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1050937 */     // GIR_Coverage, 20409,
     /* 1050937 */     GIR_EraseRootFromParent_Done,
     /* 1050938 */   // Label 15528: @1050938
     /* 1050938 */   GIM_Try, /*On fail goto*//*Label 15529*/ GIMT_Encode4(1051015), // Rule ID 20412 //
     /* 1050943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1050946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1050951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1050954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1050957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1050960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1050963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1050966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1050970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1050978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1050982 */     // MIs[0] policy
     /* 1050982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1050985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1050992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1050992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1050995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1050997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1050999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051011 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051014 */     // GIR_Coverage, 20412,
     /* 1051014 */     GIR_EraseRootFromParent_Done,
     /* 1051015 */   // Label 15529: @1051015
     /* 1051015 */   GIM_Try, /*On fail goto*//*Label 15530*/ GIMT_Encode4(1051092), // Rule ID 20413 //
     /* 1051020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1051031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1051034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1051037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051059 */     // MIs[0] policy
     /* 1051059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051078 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051088 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051091 */     // GIR_Coverage, 20413,
     /* 1051091 */     GIR_EraseRootFromParent_Done,
     /* 1051092 */   // Label 15530: @1051092
     /* 1051092 */   GIM_Try, /*On fail goto*//*Label 15531*/ GIMT_Encode4(1051169), // Rule ID 20416 //
     /* 1051097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1051100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051136 */     // MIs[0] policy
     /* 1051136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051146 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051165 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051168 */     // GIR_Coverage, 20416,
     /* 1051168 */     GIR_EraseRootFromParent_Done,
     /* 1051169 */   // Label 15531: @1051169
     /* 1051169 */   GIM_Try, /*On fail goto*//*Label 15532*/ GIMT_Encode4(1051246), // Rule ID 20417 //
     /* 1051174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1051177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1051185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1051188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1051191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1051194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051213 */     // MIs[0] policy
     /* 1051213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051223 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051232 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1051242 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051245 */     // GIR_Coverage, 20417,
     /* 1051245 */     GIR_EraseRootFromParent_Done,
     /* 1051246 */   // Label 15532: @1051246
     /* 1051246 */   GIM_Try, /*On fail goto*//*Label 15533*/ GIMT_Encode4(1051323), // Rule ID 20420 //
     /* 1051251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051290 */     // MIs[0] policy
     /* 1051290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051300 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051322 */     // GIR_Coverage, 20420,
     /* 1051322 */     GIR_EraseRootFromParent_Done,
     /* 1051323 */   // Label 15533: @1051323
     /* 1051323 */   GIM_Try, /*On fail goto*//*Label 15534*/ GIMT_Encode4(1051400), // Rule ID 20421 //
     /* 1051328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1051339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1051342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1051345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1051355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1051363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051367 */     // MIs[0] policy
     /* 1051367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11119:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M2_MASK),
     /* 1051380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051399 */     // GIR_Coverage, 20421,
     /* 1051399 */     GIR_EraseRootFromParent_Done,
     /* 1051400 */   // Label 15534: @1051400
     /* 1051400 */   GIM_Try, /*On fail goto*//*Label 15535*/ GIMT_Encode4(1051477), // Rule ID 20424 //
     /* 1051405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1051422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051444 */     // MIs[0] policy
     /* 1051444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051454 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051473 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051476 */     // GIR_Coverage, 20424,
     /* 1051476 */     GIR_EraseRootFromParent_Done,
     /* 1051477 */   // Label 15535: @1051477
     /* 1051477 */   GIM_Try, /*On fail goto*//*Label 15536*/ GIMT_Encode4(1051554), // Rule ID 20425 //
     /* 1051482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1051493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1051496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1051499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1051502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1051509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1051517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051521 */     // MIs[0] policy
     /* 1051521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051531 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11119:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M4_MASK),
     /* 1051534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051540 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051550 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051553 */     // GIR_Coverage, 20425,
     /* 1051553 */     GIR_EraseRootFromParent_Done,
     /* 1051554 */   // Label 15536: @1051554
     /* 1051554 */   GIM_Try, /*On fail goto*//*Label 15537*/ GIMT_Encode4(1051631), // Rule ID 20428 //
     /* 1051559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1051562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1051576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051598 */     // MIs[0] policy
     /* 1051598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051627 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051630 */     // GIR_Coverage, 20428,
     /* 1051630 */     GIR_EraseRootFromParent_Done,
     /* 1051631 */   // Label 15537: @1051631
     /* 1051631 */   GIM_Try, /*On fail goto*//*Label 15538*/ GIMT_Encode4(1051708), // Rule ID 20429 //
     /* 1051636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1051639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfclass_mask),
     /* 1051644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1051647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1051650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1051653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1051656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1051663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1051671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051675 */     // MIs[0] policy
     /* 1051675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051685 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11119:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCLASS_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCLASS_V_M8_MASK),
     /* 1051688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051694 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1051704 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051707 */     // GIR_Coverage, 20429,
     /* 1051707 */     GIR_EraseRootFromParent_Done,
     /* 1051708 */   // Label 15538: @1051708
     /* 1051708 */   GIM_Try, /*On fail goto*//*Label 15539*/ GIMT_Encode4(1051785), // Rule ID 20754 //
     /* 1051713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1051721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1051724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1051727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1051730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051752 */     // MIs[0] policy
     /* 1051752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051762 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1051765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051781 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051784 */     // GIR_Coverage, 20754,
     /* 1051784 */     GIR_EraseRootFromParent_Done,
     /* 1051785 */   // Label 15539: @1051785
     /* 1051785 */   GIM_Try, /*On fail goto*//*Label 15540*/ GIMT_Encode4(1051862), // Rule ID 20755 //
     /* 1051790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1051798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1051801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1051804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1051807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1051810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051829 */     // MIs[0] policy
     /* 1051829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051839 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1051842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051861 */     // GIR_Coverage, 20755,
     /* 1051861 */     GIR_EraseRootFromParent_Done,
     /* 1051862 */   // Label 15540: @1051862
     /* 1051862 */   GIM_Try, /*On fail goto*//*Label 15541*/ GIMT_Encode4(1051939), // Rule ID 20758 //
     /* 1051867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1051870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1051875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1051890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051906 */     // MIs[0] policy
     /* 1051906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051916 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1051916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1051919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1051923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1051925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1051927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1051932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1051935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1051937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1051938 */     // GIR_Coverage, 20758,
     /* 1051938 */     GIR_EraseRootFromParent_Done,
     /* 1051939 */   // Label 15541: @1051939
     /* 1051939 */   GIM_Try, /*On fail goto*//*Label 15542*/ GIMT_Encode4(1052016), // Rule ID 20759 //
     /* 1051944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1051947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1051952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1051955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1051958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1051961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1051964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1051967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1051971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1051979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1051983 */     // MIs[0] policy
     /* 1051983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1051986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1051993 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1051993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1051996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1051998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052002 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052012 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052015 */     // GIR_Coverage, 20759,
     /* 1052015 */     GIR_EraseRootFromParent_Done,
     /* 1052016 */   // Label 15542: @1052016
     /* 1052016 */   GIM_Try, /*On fail goto*//*Label 15543*/ GIMT_Encode4(1052093), // Rule ID 20762 //
     /* 1052021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052060 */     // MIs[0] policy
     /* 1052060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052070 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052079 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052089 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052092 */     // GIR_Coverage, 20762,
     /* 1052092 */     GIR_EraseRootFromParent_Done,
     /* 1052093 */   // Label 15543: @1052093
     /* 1052093 */   GIM_Try, /*On fail goto*//*Label 15544*/ GIMT_Encode4(1052170), // Rule ID 20763 //
     /* 1052098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1052109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1052112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1052115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052137 */     // MIs[0] policy
     /* 1052137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052147 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1052150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052156 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052166 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052169 */     // GIR_Coverage, 20763,
     /* 1052169 */     GIR_EraseRootFromParent_Done,
     /* 1052170 */   // Label 15544: @1052170
     /* 1052170 */   GIM_Try, /*On fail goto*//*Label 15545*/ GIMT_Encode4(1052247), // Rule ID 20766 //
     /* 1052175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052214 */     // MIs[0] policy
     /* 1052214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052243 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052246 */     // GIR_Coverage, 20766,
     /* 1052246 */     GIR_EraseRootFromParent_Done,
     /* 1052247 */   // Label 15545: @1052247
     /* 1052247 */   GIM_Try, /*On fail goto*//*Label 15546*/ GIMT_Encode4(1052324), // Rule ID 20767 //
     /* 1052252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1052263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1052266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1052269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1052272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052291 */     // MIs[0] policy
     /* 1052291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052301 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11127:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052310 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052320 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052323 */     // GIR_Coverage, 20767,
     /* 1052323 */     GIR_EraseRootFromParent_Done,
     /* 1052324 */   // Label 15546: @1052324
     /* 1052324 */   GIM_Try, /*On fail goto*//*Label 15547*/ GIMT_Encode4(1052401), // Rule ID 20770 //
     /* 1052329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1052332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052368 */     // MIs[0] policy
     /* 1052368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052378 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052397 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052400 */     // GIR_Coverage, 20770,
     /* 1052400 */     GIR_EraseRootFromParent_Done,
     /* 1052401 */   // Label 15547: @1052401
     /* 1052401 */   GIM_Try, /*On fail goto*//*Label 15548*/ GIMT_Encode4(1052478), // Rule ID 20771 //
     /* 1052406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1052409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1052417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1052420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1052423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1052426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052445 */     // MIs[0] policy
     /* 1052445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052455 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11127:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052464 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1052474 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052477 */     // GIR_Coverage, 20771,
     /* 1052477 */     GIR_EraseRootFromParent_Done,
     /* 1052478 */   // Label 15548: @1052478
     /* 1052478 */   GIM_Try, /*On fail goto*//*Label 15549*/ GIMT_Encode4(1052555), // Rule ID 20774 //
     /* 1052483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1052486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052522 */     // MIs[0] policy
     /* 1052522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052532 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052541 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052551 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052554 */     // GIR_Coverage, 20774,
     /* 1052554 */     GIR_EraseRootFromParent_Done,
     /* 1052555 */   // Label 15549: @1052555
     /* 1052555 */   GIM_Try, /*On fail goto*//*Label 15550*/ GIMT_Encode4(1052632), // Rule ID 20775 //
     /* 1052560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1052563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1052571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1052574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1052577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1052580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1052587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1052595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052599 */     // MIs[0] policy
     /* 1052599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052609 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11127:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1052612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052618 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1052628 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052631 */     // GIR_Coverage, 20775,
     /* 1052631 */     GIR_EraseRootFromParent_Done,
     /* 1052632 */   // Label 15550: @1052632
     /* 1052632 */   GIM_Try, /*On fail goto*//*Label 15551*/ GIMT_Encode4(1052709), // Rule ID 20778 //
     /* 1052637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052676 */     // MIs[0] policy
     /* 1052676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1052689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052708 */     // GIR_Coverage, 20778,
     /* 1052708 */     GIR_EraseRootFromParent_Done,
     /* 1052709 */   // Label 15551: @1052709
     /* 1052709 */   GIM_Try, /*On fail goto*//*Label 15552*/ GIMT_Encode4(1052786), // Rule ID 20779 //
     /* 1052714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1052725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1052728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1052731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1052734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1052741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1052749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052753 */     // MIs[0] policy
     /* 1052753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1052766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052785 */     // GIR_Coverage, 20779,
     /* 1052785 */     GIR_EraseRootFromParent_Done,
     /* 1052786 */   // Label 15552: @1052786
     /* 1052786 */   GIM_Try, /*On fail goto*//*Label 15553*/ GIMT_Encode4(1052863), // Rule ID 20782 //
     /* 1052791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052830 */     // MIs[0] policy
     /* 1052830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1052843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052862 */     // GIR_Coverage, 20782,
     /* 1052862 */     GIR_EraseRootFromParent_Done,
     /* 1052863 */   // Label 15553: @1052863
     /* 1052863 */   GIM_Try, /*On fail goto*//*Label 15554*/ GIMT_Encode4(1052940), // Rule ID 20783 //
     /* 1052868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1052871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1052879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1052882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1052885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1052888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1052891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1052895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1052903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052907 */     // MIs[0] policy
     /* 1052907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052917 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1052917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1052920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1052924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1052926 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1052928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1052933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1052936 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1052938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1052939 */     // GIR_Coverage, 20783,
     /* 1052939 */     GIR_EraseRootFromParent_Done,
     /* 1052940 */   // Label 15554: @1052940
     /* 1052940 */   GIM_Try, /*On fail goto*//*Label 15555*/ GIMT_Encode4(1053017), // Rule ID 20786 //
     /* 1052945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1052948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1052953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1052956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1052959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1052962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1052965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1052968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1052972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1052980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1052984 */     // MIs[0] policy
     /* 1052984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1052987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1052994 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1052994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1052997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1052999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053016 */     // GIR_Coverage, 20786,
     /* 1053016 */     GIR_EraseRootFromParent_Done,
     /* 1053017 */   // Label 15555: @1053017
     /* 1053017 */   GIM_Try, /*On fail goto*//*Label 15556*/ GIMT_Encode4(1053094), // Rule ID 20787 //
     /* 1053022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1053025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1053033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1053036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1053039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1053042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053061 */     // MIs[0] policy
     /* 1053061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053071 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053080 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1053090 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053093 */     // GIR_Coverage, 20787,
     /* 1053093 */     GIR_EraseRootFromParent_Done,
     /* 1053094 */   // Label 15556: @1053094
     /* 1053094 */   GIM_Try, /*On fail goto*//*Label 15557*/ GIMT_Encode4(1053171), // Rule ID 20790 //
     /* 1053099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053138 */     // MIs[0] policy
     /* 1053138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053148 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053167 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053170 */     // GIR_Coverage, 20790,
     /* 1053170 */     GIR_EraseRootFromParent_Done,
     /* 1053171 */   // Label 15557: @1053171
     /* 1053171 */   GIM_Try, /*On fail goto*//*Label 15558*/ GIMT_Encode4(1053248), // Rule ID 20791 //
     /* 1053176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1053187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1053190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1053193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053215 */     // MIs[0] policy
     /* 1053215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053225 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053234 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053244 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053247 */     // GIR_Coverage, 20791,
     /* 1053247 */     GIR_EraseRootFromParent_Done,
     /* 1053248 */   // Label 15558: @1053248
     /* 1053248 */   GIM_Try, /*On fail goto*//*Label 15559*/ GIMT_Encode4(1053325), // Rule ID 20794 //
     /* 1053253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053292 */     // MIs[0] policy
     /* 1053292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053302 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053311 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053321 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053324 */     // GIR_Coverage, 20794,
     /* 1053324 */     GIR_EraseRootFromParent_Done,
     /* 1053325 */   // Label 15559: @1053325
     /* 1053325 */   GIM_Try, /*On fail goto*//*Label 15560*/ GIMT_Encode4(1053402), // Rule ID 20795 //
     /* 1053330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1053341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1053344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1053347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053369 */     // MIs[0] policy
     /* 1053369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053388 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053398 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053401 */     // GIR_Coverage, 20795,
     /* 1053401 */     GIR_EraseRootFromParent_Done,
     /* 1053402 */   // Label 15560: @1053402
     /* 1053402 */   GIM_Try, /*On fail goto*//*Label 15561*/ GIMT_Encode4(1053479), // Rule ID 20798 //
     /* 1053407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1053410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053446 */     // MIs[0] policy
     /* 1053446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053456 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053475 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053478 */     // GIR_Coverage, 20798,
     /* 1053478 */     GIR_EraseRootFromParent_Done,
     /* 1053479 */   // Label 15561: @1053479
     /* 1053479 */   GIM_Try, /*On fail goto*//*Label 15562*/ GIMT_Encode4(1053556), // Rule ID 20799 //
     /* 1053484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1053487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1053495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1053498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1053501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1053504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053523 */     // MIs[0] policy
     /* 1053523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053533 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1053552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053555 */     // GIR_Coverage, 20799,
     /* 1053555 */     GIR_EraseRootFromParent_Done,
     /* 1053556 */   // Label 15562: @1053556
     /* 1053556 */   GIM_Try, /*On fail goto*//*Label 15563*/ GIMT_Encode4(1053633), // Rule ID 20802 //
     /* 1053561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053600 */     // MIs[0] policy
     /* 1053600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053629 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053632 */     // GIR_Coverage, 20802,
     /* 1053632 */     GIR_EraseRootFromParent_Done,
     /* 1053633 */   // Label 15563: @1053633
     /* 1053633 */   GIM_Try, /*On fail goto*//*Label 15564*/ GIMT_Encode4(1053710), // Rule ID 20803 //
     /* 1053638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1053649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1053652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1053655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1053658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1053665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1053673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053677 */     // MIs[0] policy
     /* 1053677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11127:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1053690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053696 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053706 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053709 */     // GIR_Coverage, 20803,
     /* 1053709 */     GIR_EraseRootFromParent_Done,
     /* 1053710 */   // Label 15564: @1053710
     /* 1053710 */   GIM_Try, /*On fail goto*//*Label 15565*/ GIMT_Encode4(1053787), // Rule ID 20806 //
     /* 1053715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053754 */     // MIs[0] policy
     /* 1053754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053783 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053786 */     // GIR_Coverage, 20806,
     /* 1053786 */     GIR_EraseRootFromParent_Done,
     /* 1053787 */   // Label 15565: @1053787
     /* 1053787 */   GIM_Try, /*On fail goto*//*Label 15566*/ GIMT_Encode4(1053864), // Rule ID 20807 //
     /* 1053792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1053803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1053806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1053809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1053812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1053819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1053827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053831 */     // MIs[0] policy
     /* 1053831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053841 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11127:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1053844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053863 */     // GIR_Coverage, 20807,
     /* 1053863 */     GIR_EraseRootFromParent_Done,
     /* 1053864 */   // Label 15566: @1053864
     /* 1053864 */   GIM_Try, /*On fail goto*//*Label 15567*/ GIMT_Encode4(1053941), // Rule ID 20810 //
     /* 1053869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1053872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1053892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053908 */     // MIs[0] policy
     /* 1053908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053918 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1053918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1053923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1053925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1053927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1053929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1053934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1053937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1053939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1053940 */     // GIR_Coverage, 20810,
     /* 1053940 */     GIR_EraseRootFromParent_Done,
     /* 1053941 */   // Label 15567: @1053941
     /* 1053941 */   GIM_Try, /*On fail goto*//*Label 15568*/ GIMT_Encode4(1054018), // Rule ID 20811 //
     /* 1053946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1053949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_xu_f_v_mask),
     /* 1053954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1053957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1053960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1053963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1053966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1053969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1053973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1053981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1053985 */     // MIs[0] policy
     /* 1053985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1053988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1053995 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11127:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1053995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1053998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054017 */     // GIR_Coverage, 20811,
     /* 1054017 */     GIR_EraseRootFromParent_Done,
     /* 1054018 */   // Label 15568: @1054018
     /* 1054018 */   GIM_Try, /*On fail goto*//*Label 15569*/ GIMT_Encode4(1054095), // Rule ID 20814 //
     /* 1054023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054062 */     // MIs[0] policy
     /* 1054062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054094 */     // GIR_Coverage, 20814,
     /* 1054094 */     GIR_EraseRootFromParent_Done,
     /* 1054095 */   // Label 15569: @1054095
     /* 1054095 */   GIM_Try, /*On fail goto*//*Label 15570*/ GIMT_Encode4(1054172), // Rule ID 20815 //
     /* 1054100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1054111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1054114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1054117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054139 */     // MIs[0] policy
     /* 1054139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054149 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1054152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054171 */     // GIR_Coverage, 20815,
     /* 1054171 */     GIR_EraseRootFromParent_Done,
     /* 1054172 */   // Label 15570: @1054172
     /* 1054172 */   GIM_Try, /*On fail goto*//*Label 15571*/ GIMT_Encode4(1054249), // Rule ID 20818 //
     /* 1054177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054216 */     // MIs[0] policy
     /* 1054216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054245 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054248 */     // GIR_Coverage, 20818,
     /* 1054248 */     GIR_EraseRootFromParent_Done,
     /* 1054249 */   // Label 15571: @1054249
     /* 1054249 */   GIM_Try, /*On fail goto*//*Label 15572*/ GIMT_Encode4(1054326), // Rule ID 20819 //
     /* 1054254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1054265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1054268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1054271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054293 */     // MIs[0] policy
     /* 1054293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054303 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054312 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054322 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054325 */     // GIR_Coverage, 20819,
     /* 1054325 */     GIR_EraseRootFromParent_Done,
     /* 1054326 */   // Label 15572: @1054326
     /* 1054326 */   GIM_Try, /*On fail goto*//*Label 15573*/ GIMT_Encode4(1054403), // Rule ID 20822 //
     /* 1054331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054370 */     // MIs[0] policy
     /* 1054370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054380 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054389 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054399 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054402 */     // GIR_Coverage, 20822,
     /* 1054402 */     GIR_EraseRootFromParent_Done,
     /* 1054403 */   // Label 15573: @1054403
     /* 1054403 */   GIM_Try, /*On fail goto*//*Label 15574*/ GIMT_Encode4(1054480), // Rule ID 20823 //
     /* 1054408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1054419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1054422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1054425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054447 */     // MIs[0] policy
     /* 1054447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054457 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1054460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054479 */     // GIR_Coverage, 20823,
     /* 1054479 */     GIR_EraseRootFromParent_Done,
     /* 1054480 */   // Label 15574: @1054480
     /* 1054480 */   GIM_Try, /*On fail goto*//*Label 15575*/ GIMT_Encode4(1054557), // Rule ID 20826 //
     /* 1054485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054524 */     // MIs[0] policy
     /* 1054524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054553 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054556 */     // GIR_Coverage, 20826,
     /* 1054556 */     GIR_EraseRootFromParent_Done,
     /* 1054557 */   // Label 15575: @1054557
     /* 1054557 */   GIM_Try, /*On fail goto*//*Label 15576*/ GIMT_Encode4(1054634), // Rule ID 20827 //
     /* 1054562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1054565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1054573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1054576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1054579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1054582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054601 */     // MIs[0] policy
     /* 1054601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054611 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11125:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054620 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1054630 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054633 */     // GIR_Coverage, 20827,
     /* 1054633 */     GIR_EraseRootFromParent_Done,
     /* 1054634 */   // Label 15576: @1054634
     /* 1054634 */   GIM_Try, /*On fail goto*//*Label 15577*/ GIMT_Encode4(1054711), // Rule ID 20830 //
     /* 1054639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1054642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054678 */     // MIs[0] policy
     /* 1054678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054707 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054710 */     // GIR_Coverage, 20830,
     /* 1054710 */     GIR_EraseRootFromParent_Done,
     /* 1054711 */   // Label 15577: @1054711
     /* 1054711 */   GIM_Try, /*On fail goto*//*Label 15578*/ GIMT_Encode4(1054788), // Rule ID 20831 //
     /* 1054716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1054719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1054727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1054730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1054733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1054736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054755 */     // MIs[0] policy
     /* 1054755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054765 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11125:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054774 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1054784 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054787 */     // GIR_Coverage, 20831,
     /* 1054787 */     GIR_EraseRootFromParent_Done,
     /* 1054788 */   // Label 15578: @1054788
     /* 1054788 */   GIM_Try, /*On fail goto*//*Label 15579*/ GIMT_Encode4(1054865), // Rule ID 20834 //
     /* 1054793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1054796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054832 */     // MIs[0] policy
     /* 1054832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054842 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054851 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054861 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054864 */     // GIR_Coverage, 20834,
     /* 1054864 */     GIR_EraseRootFromParent_Done,
     /* 1054865 */   // Label 15579: @1054865
     /* 1054865 */   GIM_Try, /*On fail goto*//*Label 15580*/ GIMT_Encode4(1054942), // Rule ID 20835 //
     /* 1054870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1054873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1054881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1054884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1054887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1054890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1054893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1054897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1054905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054909 */     // MIs[0] policy
     /* 1054909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054919 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11125:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1054919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1054922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1054924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1054926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1054928 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1054930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1054935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1054938 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1054940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1054941 */     // GIR_Coverage, 20835,
     /* 1054941 */     GIR_EraseRootFromParent_Done,
     /* 1054942 */   // Label 15580: @1054942
     /* 1054942 */   GIM_Try, /*On fail goto*//*Label 15581*/ GIMT_Encode4(1055019), // Rule ID 20838 //
     /* 1054947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1054950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1054955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1054958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1054961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1054964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1054967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1054970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1054974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1054982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1054986 */     // MIs[0] policy
     /* 1054986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1054989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1054996 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1054996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1054999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055015 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055018 */     // GIR_Coverage, 20838,
     /* 1055018 */     GIR_EraseRootFromParent_Done,
     /* 1055019 */   // Label 15581: @1055019
     /* 1055019 */   GIM_Try, /*On fail goto*//*Label 15582*/ GIMT_Encode4(1055096), // Rule ID 20839 //
     /* 1055024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1055035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1055038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1055041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055063 */     // MIs[0] policy
     /* 1055063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055082 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055092 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055094 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055095 */     // GIR_Coverage, 20839,
     /* 1055095 */     GIR_EraseRootFromParent_Done,
     /* 1055096 */   // Label 15582: @1055096
     /* 1055096 */   GIM_Try, /*On fail goto*//*Label 15583*/ GIMT_Encode4(1055173), // Rule ID 20842 //
     /* 1055101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055140 */     // MIs[0] policy
     /* 1055140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055172 */     // GIR_Coverage, 20842,
     /* 1055172 */     GIR_EraseRootFromParent_Done,
     /* 1055173 */   // Label 15583: @1055173
     /* 1055173 */   GIM_Try, /*On fail goto*//*Label 15584*/ GIMT_Encode4(1055250), // Rule ID 20843 //
     /* 1055178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1055189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1055192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1055195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055217 */     // MIs[0] policy
     /* 1055217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055227 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055249 */     // GIR_Coverage, 20843,
     /* 1055249 */     GIR_EraseRootFromParent_Done,
     /* 1055250 */   // Label 15584: @1055250
     /* 1055250 */   GIM_Try, /*On fail goto*//*Label 15585*/ GIMT_Encode4(1055327), // Rule ID 20846 //
     /* 1055255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1055258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055294 */     // MIs[0] policy
     /* 1055294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055323 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055326 */     // GIR_Coverage, 20846,
     /* 1055326 */     GIR_EraseRootFromParent_Done,
     /* 1055327 */   // Label 15585: @1055327
     /* 1055327 */   GIM_Try, /*On fail goto*//*Label 15586*/ GIMT_Encode4(1055404), // Rule ID 20847 //
     /* 1055332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1055335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1055343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1055346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1055349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1055352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055371 */     // MIs[0] policy
     /* 1055371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055381 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1055400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055403 */     // GIR_Coverage, 20847,
     /* 1055403 */     GIR_EraseRootFromParent_Done,
     /* 1055404 */   // Label 15586: @1055404
     /* 1055404 */   GIM_Try, /*On fail goto*//*Label 15587*/ GIMT_Encode4(1055481), // Rule ID 20850 //
     /* 1055409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055448 */     // MIs[0] policy
     /* 1055448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055480 */     // GIR_Coverage, 20850,
     /* 1055480 */     GIR_EraseRootFromParent_Done,
     /* 1055481 */   // Label 15587: @1055481
     /* 1055481 */   GIM_Try, /*On fail goto*//*Label 15588*/ GIMT_Encode4(1055558), // Rule ID 20851 //
     /* 1055486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1055497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1055500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1055503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1055506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055525 */     // MIs[0] policy
     /* 1055525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055544 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055554 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055557 */     // GIR_Coverage, 20851,
     /* 1055557 */     GIR_EraseRootFromParent_Done,
     /* 1055558 */   // Label 15588: @1055558
     /* 1055558 */   GIM_Try, /*On fail goto*//*Label 15589*/ GIMT_Encode4(1055635), // Rule ID 20854 //
     /* 1055563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055602 */     // MIs[0] policy
     /* 1055602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055612 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055621 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055631 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055634 */     // GIR_Coverage, 20854,
     /* 1055634 */     GIR_EraseRootFromParent_Done,
     /* 1055635 */   // Label 15589: @1055635
     /* 1055635 */   GIM_Try, /*On fail goto*//*Label 15590*/ GIMT_Encode4(1055712), // Rule ID 20855 //
     /* 1055640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1055651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1055654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1055657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1055660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1055667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1055675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055679 */     // MIs[0] policy
     /* 1055679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055689 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1055692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055698 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055708 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055710 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055711 */     // GIR_Coverage, 20855,
     /* 1055711 */     GIR_EraseRootFromParent_Done,
     /* 1055712 */   // Label 15590: @1055712
     /* 1055712 */   GIM_Try, /*On fail goto*//*Label 15591*/ GIMT_Encode4(1055789), // Rule ID 20858 //
     /* 1055717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1055720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055756 */     // MIs[0] policy
     /* 1055756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055788 */     // GIR_Coverage, 20858,
     /* 1055788 */     GIR_EraseRootFromParent_Done,
     /* 1055789 */   // Label 15591: @1055789
     /* 1055789 */   GIM_Try, /*On fail goto*//*Label 15592*/ GIMT_Encode4(1055866), // Rule ID 20859 //
     /* 1055794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1055797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1055805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1055808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1055811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1055814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1055821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1055829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055833 */     // MIs[0] policy
     /* 1055833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055843 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1055846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055852 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1055862 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055865 */     // GIR_Coverage, 20859,
     /* 1055865 */     GIR_EraseRootFromParent_Done,
     /* 1055866 */   // Label 15592: @1055866
     /* 1055866 */   GIM_Try, /*On fail goto*//*Label 15593*/ GIMT_Encode4(1055943), // Rule ID 20862 //
     /* 1055871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1055874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1055894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055910 */     // MIs[0] policy
     /* 1055910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1055920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1055923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1055925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1055927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1055929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1055931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1055936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1055939 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1055941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1055942 */     // GIR_Coverage, 20862,
     /* 1055942 */     GIR_EraseRootFromParent_Done,
     /* 1055943 */   // Label 15593: @1055943
     /* 1055943 */   GIM_Try, /*On fail goto*//*Label 15594*/ GIMT_Encode4(1056020), // Rule ID 20863 //
     /* 1055948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1055951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1055956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1055959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1055962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1055965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1055968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1055971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1055975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1055983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1055987 */     // MIs[0] policy
     /* 1055987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1055990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1055997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11125:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1055997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1056000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056006 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056016 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056019 */     // GIR_Coverage, 20863,
     /* 1056019 */     GIR_EraseRootFromParent_Done,
     /* 1056020 */   // Label 15594: @1056020
     /* 1056020 */   GIM_Try, /*On fail goto*//*Label 15595*/ GIMT_Encode4(1056097), // Rule ID 20866 //
     /* 1056025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056064 */     // MIs[0] policy
     /* 1056064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056074 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056093 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056096 */     // GIR_Coverage, 20866,
     /* 1056096 */     GIR_EraseRootFromParent_Done,
     /* 1056097 */   // Label 15595: @1056097
     /* 1056097 */   GIM_Try, /*On fail goto*//*Label 15596*/ GIMT_Encode4(1056174), // Rule ID 20867 //
     /* 1056102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1056113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1056116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1056119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056141 */     // MIs[0] policy
     /* 1056141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056151 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11125:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1056154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056160 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056170 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056173 */     // GIR_Coverage, 20867,
     /* 1056173 */     GIR_EraseRootFromParent_Done,
     /* 1056174 */   // Label 15596: @1056174
     /* 1056174 */   GIM_Try, /*On fail goto*//*Label 15597*/ GIMT_Encode4(1056251), // Rule ID 20870 //
     /* 1056179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1056182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056218 */     // MIs[0] policy
     /* 1056218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056228 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056247 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056250 */     // GIR_Coverage, 20870,
     /* 1056250 */     GIR_EraseRootFromParent_Done,
     /* 1056251 */   // Label 15597: @1056251
     /* 1056251 */   GIM_Try, /*On fail goto*//*Label 15598*/ GIMT_Encode4(1056328), // Rule ID 20871 //
     /* 1056256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1056259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_rtz_x_f_v_mask),
     /* 1056264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1056267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1056270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1056273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056295 */     // MIs[0] policy
     /* 1056295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056305 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11125:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1056308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056314 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1056324 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056327 */     // GIR_Coverage, 20871,
     /* 1056327 */     GIR_EraseRootFromParent_Done,
     /* 1056328 */   // Label 15598: @1056328
     /* 1056328 */   GIM_Try, /*On fail goto*//*Label 15599*/ GIMT_Encode4(1056405), // Rule ID 21138 //
     /* 1056333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056372 */     // MIs[0] policy
     /* 1056372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056382 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056391 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056401 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056404 */     // GIR_Coverage, 21138,
     /* 1056404 */     GIR_EraseRootFromParent_Done,
     /* 1056405 */   // Label 15599: @1056405
     /* 1056405 */   GIM_Try, /*On fail goto*//*Label 15600*/ GIMT_Encode4(1056482), // Rule ID 21139 //
     /* 1056410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1056421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1056424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1056427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1056430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056449 */     // MIs[0] policy
     /* 1056449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056459 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1056462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056468 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056478 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056481 */     // GIR_Coverage, 21139,
     /* 1056481 */     GIR_EraseRootFromParent_Done,
     /* 1056482 */   // Label 15600: @1056482
     /* 1056482 */   GIM_Try, /*On fail goto*//*Label 15601*/ GIMT_Encode4(1056559), // Rule ID 21142 //
     /* 1056487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056526 */     // MIs[0] policy
     /* 1056526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056555 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056558 */     // GIR_Coverage, 21142,
     /* 1056558 */     GIR_EraseRootFromParent_Done,
     /* 1056559 */   // Label 15601: @1056559
     /* 1056559 */   GIM_Try, /*On fail goto*//*Label 15602*/ GIMT_Encode4(1056636), // Rule ID 21143 //
     /* 1056564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1056575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1056578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1056581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1056584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1056591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056603 */     // MIs[0] policy
     /* 1056603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056613 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11223:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1056616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056635 */     // GIR_Coverage, 21143,
     /* 1056635 */     GIR_EraseRootFromParent_Done,
     /* 1056636 */   // Label 15602: @1056636
     /* 1056636 */   GIM_Try, /*On fail goto*//*Label 15603*/ GIMT_Encode4(1056713), // Rule ID 21146 //
     /* 1056641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056680 */     // MIs[0] policy
     /* 1056680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056712 */     // GIR_Coverage, 21146,
     /* 1056712 */     GIR_EraseRootFromParent_Done,
     /* 1056713 */   // Label 15603: @1056713
     /* 1056713 */   GIM_Try, /*On fail goto*//*Label 15604*/ GIMT_Encode4(1056790), // Rule ID 21147 //
     /* 1056718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1056729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1056732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1056735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1056738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1056745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1056753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056757 */     // MIs[0] policy
     /* 1056757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1056770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056789 */     // GIR_Coverage, 21147,
     /* 1056789 */     GIR_EraseRootFromParent_Done,
     /* 1056790 */   // Label 15604: @1056790
     /* 1056790 */   GIM_Try, /*On fail goto*//*Label 15605*/ GIMT_Encode4(1056867), // Rule ID 21150 //
     /* 1056795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056834 */     // MIs[0] policy
     /* 1056834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1056847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056866 */     // GIR_Coverage, 21150,
     /* 1056866 */     GIR_EraseRootFromParent_Done,
     /* 1056867 */   // Label 15605: @1056867
     /* 1056867 */   GIM_Try, /*On fail goto*//*Label 15606*/ GIMT_Encode4(1056944), // Rule ID 21151 //
     /* 1056872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1056875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1056883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1056886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1056889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1056892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1056895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1056899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1056907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056911 */     // MIs[0] policy
     /* 1056911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056921 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1056921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1056924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1056926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1056928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1056930 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1056932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1056937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1056940 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1056942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1056943 */     // GIR_Coverage, 21151,
     /* 1056943 */     GIR_EraseRootFromParent_Done,
     /* 1056944 */   // Label 15606: @1056944
     /* 1056944 */   GIM_Try, /*On fail goto*//*Label 15607*/ GIMT_Encode4(1057021), // Rule ID 21154 //
     /* 1056949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1056952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1056957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1056960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1056963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1056966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1056969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1056972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1056976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1056980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1056984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1056988 */     // MIs[0] policy
     /* 1056988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1056991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1056998 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1056998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057017 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057020 */     // GIR_Coverage, 21154,
     /* 1057020 */     GIR_EraseRootFromParent_Done,
     /* 1057021 */   // Label 15607: @1057021
     /* 1057021 */   GIM_Try, /*On fail goto*//*Label 15608*/ GIMT_Encode4(1057098), // Rule ID 21155 //
     /* 1057026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1057037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1057040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1057043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1057046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057065 */     // MIs[0] policy
     /* 1057065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057075 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057084 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057094 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057097 */     // GIR_Coverage, 21155,
     /* 1057097 */     GIR_EraseRootFromParent_Done,
     /* 1057098 */   // Label 15608: @1057098
     /* 1057098 */   GIM_Try, /*On fail goto*//*Label 15609*/ GIMT_Encode4(1057175), // Rule ID 21158 //
     /* 1057103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057142 */     // MIs[0] policy
     /* 1057142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057171 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057174 */     // GIR_Coverage, 21158,
     /* 1057174 */     GIR_EraseRootFromParent_Done,
     /* 1057175 */   // Label 15609: @1057175
     /* 1057175 */   GIM_Try, /*On fail goto*//*Label 15610*/ GIMT_Encode4(1057252), // Rule ID 21159 //
     /* 1057180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1057191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1057194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1057197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057219 */     // MIs[0] policy
     /* 1057219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057229 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11223:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1057232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057238 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057248 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057251 */     // GIR_Coverage, 21159,
     /* 1057251 */     GIR_EraseRootFromParent_Done,
     /* 1057252 */   // Label 15610: @1057252
     /* 1057252 */   GIM_Try, /*On fail goto*//*Label 15611*/ GIMT_Encode4(1057329), // Rule ID 21162 //
     /* 1057257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057296 */     // MIs[0] policy
     /* 1057296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057328 */     // GIR_Coverage, 21162,
     /* 1057328 */     GIR_EraseRootFromParent_Done,
     /* 1057329 */   // Label 15611: @1057329
     /* 1057329 */   GIM_Try, /*On fail goto*//*Label 15612*/ GIMT_Encode4(1057406), // Rule ID 21163 //
     /* 1057334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1057345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1057348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1057351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1057361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057373 */     // MIs[0] policy
     /* 1057373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11223:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1057386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057392 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057402 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057405 */     // GIR_Coverage, 21163,
     /* 1057405 */     GIR_EraseRootFromParent_Done,
     /* 1057406 */   // Label 15612: @1057406
     /* 1057406 */   GIM_Try, /*On fail goto*//*Label 15613*/ GIMT_Encode4(1057483), // Rule ID 21166 //
     /* 1057411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057450 */     // MIs[0] policy
     /* 1057450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057460 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057479 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057482 */     // GIR_Coverage, 21166,
     /* 1057482 */     GIR_EraseRootFromParent_Done,
     /* 1057483 */   // Label 15613: @1057483
     /* 1057483 */   GIM_Try, /*On fail goto*//*Label 15614*/ GIMT_Encode4(1057560), // Rule ID 21167 //
     /* 1057488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1057499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1057502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1057505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1057508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1057515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1057523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057527 */     // MIs[0] policy
     /* 1057527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057537 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11223:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1057540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057542 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057546 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057556 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057558 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057559 */     // GIR_Coverage, 21167,
     /* 1057559 */     GIR_EraseRootFromParent_Done,
     /* 1057560 */   // Label 15614: @1057560
     /* 1057560 */   GIM_Try, /*On fail goto*//*Label 15615*/ GIMT_Encode4(1057637), // Rule ID 21170 //
     /* 1057565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1057568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057604 */     // MIs[0] policy
     /* 1057604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057614 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057623 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057633 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057636 */     // GIR_Coverage, 21170,
     /* 1057636 */     GIR_EraseRootFromParent_Done,
     /* 1057637 */   // Label 15615: @1057637
     /* 1057637 */   GIM_Try, /*On fail goto*//*Label 15616*/ GIMT_Encode4(1057714), // Rule ID 21171 //
     /* 1057642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1057645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_xu_f_v_mask),
     /* 1057650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1057653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1057656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1057659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1057662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1057669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1057673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1057677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057681 */     // MIs[0] policy
     /* 1057681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057691 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11223:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1057694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1057710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057713 */     // GIR_Coverage, 21171,
     /* 1057713 */     GIR_EraseRootFromParent_Done,
     /* 1057714 */   // Label 15616: @1057714
     /* 1057714 */   GIM_Try, /*On fail goto*//*Label 15617*/ GIMT_Encode4(1057791), // Rule ID 21174 //
     /* 1057719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1057727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057758 */     // MIs[0] policy
     /* 1057758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057768 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1057771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057790 */     // GIR_Coverage, 21174,
     /* 1057790 */     GIR_EraseRootFromParent_Done,
     /* 1057791 */   // Label 15617: @1057791
     /* 1057791 */   GIM_Try, /*On fail goto*//*Label 15618*/ GIMT_Encode4(1057868), // Rule ID 21175 //
     /* 1057796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1057804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1057807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1057810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1057813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1057816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057835 */     // MIs[0] policy
     /* 1057835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057845 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1057848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057854 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057864 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057867 */     // GIR_Coverage, 21175,
     /* 1057867 */     GIR_EraseRootFromParent_Done,
     /* 1057868 */   // Label 15618: @1057868
     /* 1057868 */   GIM_Try, /*On fail goto*//*Label 15619*/ GIMT_Encode4(1057945), // Rule ID 21178 //
     /* 1057873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1057876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1057881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1057896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057912 */     // MIs[0] policy
     /* 1057912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1057922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1057925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1057927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1057929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1057931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1057933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1057938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1057941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1057943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1057944 */     // GIR_Coverage, 21178,
     /* 1057944 */     GIR_EraseRootFromParent_Done,
     /* 1057945 */   // Label 15619: @1057945
     /* 1057945 */   GIM_Try, /*On fail goto*//*Label 15620*/ GIMT_Encode4(1058022), // Rule ID 21179 //
     /* 1057950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1057953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1057958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1057961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1057964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1057967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1057970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1057973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1057977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1057985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1057989 */     // MIs[0] policy
     /* 1057989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1057992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1057999 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11221:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1057999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058021 */     // GIR_Coverage, 21179,
     /* 1058021 */     GIR_EraseRootFromParent_Done,
     /* 1058022 */   // Label 15620: @1058022
     /* 1058022 */   GIM_Try, /*On fail goto*//*Label 15621*/ GIMT_Encode4(1058099), // Rule ID 21182 //
     /* 1058027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058066 */     // MIs[0] policy
     /* 1058066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058098 */     // GIR_Coverage, 21182,
     /* 1058098 */     GIR_EraseRootFromParent_Done,
     /* 1058099 */   // Label 15621: @1058099
     /* 1058099 */   GIM_Try, /*On fail goto*//*Label 15622*/ GIMT_Encode4(1058176), // Rule ID 21183 //
     /* 1058104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1058115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1058118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1058121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058143 */     // MIs[0] policy
     /* 1058143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058153 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058175 */     // GIR_Coverage, 21183,
     /* 1058175 */     GIR_EraseRootFromParent_Done,
     /* 1058176 */   // Label 15622: @1058176
     /* 1058176 */   GIM_Try, /*On fail goto*//*Label 15623*/ GIMT_Encode4(1058253), // Rule ID 21186 //
     /* 1058181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058220 */     // MIs[0] policy
     /* 1058220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058252 */     // GIR_Coverage, 21186,
     /* 1058252 */     GIR_EraseRootFromParent_Done,
     /* 1058253 */   // Label 15623: @1058253
     /* 1058253 */   GIM_Try, /*On fail goto*//*Label 15624*/ GIMT_Encode4(1058330), // Rule ID 21187 //
     /* 1058258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1058269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1058272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1058275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058297 */     // MIs[0] policy
     /* 1058297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058307 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058316 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058326 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058329 */     // GIR_Coverage, 21187,
     /* 1058329 */     GIR_EraseRootFromParent_Done,
     /* 1058330 */   // Label 15624: @1058330
     /* 1058330 */   GIM_Try, /*On fail goto*//*Label 15625*/ GIMT_Encode4(1058407), // Rule ID 21190 //
     /* 1058335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1058338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058374 */     // MIs[0] policy
     /* 1058374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058403 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058406 */     // GIR_Coverage, 21190,
     /* 1058406 */     GIR_EraseRootFromParent_Done,
     /* 1058407 */   // Label 15625: @1058407
     /* 1058407 */   GIM_Try, /*On fail goto*//*Label 15626*/ GIMT_Encode4(1058484), // Rule ID 21191 //
     /* 1058412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1058415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1058423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1058426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1058429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1058432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058451 */     // MIs[0] policy
     /* 1058451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058461 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1058464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1058480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058483 */     // GIR_Coverage, 21191,
     /* 1058483 */     GIR_EraseRootFromParent_Done,
     /* 1058484 */   // Label 15626: @1058484
     /* 1058484 */   GIM_Try, /*On fail goto*//*Label 15627*/ GIMT_Encode4(1058561), // Rule ID 21194 //
     /* 1058489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058528 */     // MIs[0] policy
     /* 1058528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058538 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058557 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058560 */     // GIR_Coverage, 21194,
     /* 1058560 */     GIR_EraseRootFromParent_Done,
     /* 1058561 */   // Label 15627: @1058561
     /* 1058561 */   GIM_Try, /*On fail goto*//*Label 15628*/ GIMT_Encode4(1058638), // Rule ID 21195 //
     /* 1058566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1058577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1058580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1058583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1058586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1058593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058605 */     // MIs[0] policy
     /* 1058605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058615 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11221:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1058618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058624 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058634 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058637 */     // GIR_Coverage, 21195,
     /* 1058637 */     GIR_EraseRootFromParent_Done,
     /* 1058638 */   // Label 15628: @1058638
     /* 1058638 */   GIM_Try, /*On fail goto*//*Label 15629*/ GIMT_Encode4(1058715), // Rule ID 21198 //
     /* 1058643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058682 */     // MIs[0] policy
     /* 1058682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058711 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058714 */     // GIR_Coverage, 21198,
     /* 1058714 */     GIR_EraseRootFromParent_Done,
     /* 1058715 */   // Label 15629: @1058715
     /* 1058715 */   GIM_Try, /*On fail goto*//*Label 15630*/ GIMT_Encode4(1058792), // Rule ID 21199 //
     /* 1058720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1058731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1058734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1058737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1058740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1058747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1058755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058759 */     // MIs[0] policy
     /* 1058759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058769 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11221:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1058772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058791 */     // GIR_Coverage, 21199,
     /* 1058791 */     GIR_EraseRootFromParent_Done,
     /* 1058792 */   // Label 15630: @1058792
     /* 1058792 */   GIM_Try, /*On fail goto*//*Label 15631*/ GIMT_Encode4(1058869), // Rule ID 21202 //
     /* 1058797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058836 */     // MIs[0] policy
     /* 1058836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058846 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1058846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058868 */     // GIR_Coverage, 21202,
     /* 1058868 */     GIR_EraseRootFromParent_Done,
     /* 1058869 */   // Label 15631: @1058869
     /* 1058869 */   GIM_Try, /*On fail goto*//*Label 15632*/ GIMT_Encode4(1058946), // Rule ID 21203 //
     /* 1058874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1058877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1058885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1058888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1058891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1058894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1058897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1058901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1058909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058913 */     // MIs[0] policy
     /* 1058913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1058923 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11221:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1058923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1058926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1058928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1058930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1058932 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1058934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1058939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1058942 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1058944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1058945 */     // GIR_Coverage, 21203,
     /* 1058945 */     GIR_EraseRootFromParent_Done,
     /* 1058946 */   // Label 15632: @1058946
     /* 1058946 */   GIM_Try, /*On fail goto*//*Label 15633*/ GIMT_Encode4(1059023), // Rule ID 21206 //
     /* 1058951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1058954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1058959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1058962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1058965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1058968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1058971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1058974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1058978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1058982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1058986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1058990 */     // MIs[0] policy
     /* 1058990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1058993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059000 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059019 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059022 */     // GIR_Coverage, 21206,
     /* 1059022 */     GIR_EraseRootFromParent_Done,
     /* 1059023 */   // Label 15633: @1059023
     /* 1059023 */   GIM_Try, /*On fail goto*//*Label 15634*/ GIMT_Encode4(1059100), // Rule ID 21207 //
     /* 1059028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1059031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_rtz_x_f_v_mask),
     /* 1059036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1059039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1059042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1059045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059067 */     // MIs[0] policy
     /* 1059067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059077 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11221:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1059080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1059096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059099 */     // GIR_Coverage, 21207,
     /* 1059099 */     GIR_EraseRootFromParent_Done,
     /* 1059100 */   // Label 15634: @1059100
     /* 1059100 */   GIM_Try, /*On fail goto*//*Label 15635*/ GIMT_Encode4(1059177), // Rule ID 21210 //
     /* 1059105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059144 */     // MIs[0] policy
     /* 1059144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059154 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059163 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059173 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059176 */     // GIR_Coverage, 21210,
     /* 1059176 */     GIR_EraseRootFromParent_Done,
     /* 1059177 */   // Label 15635: @1059177
     /* 1059177 */   GIM_Try, /*On fail goto*//*Label 15636*/ GIMT_Encode4(1059254), // Rule ID 21211 //
     /* 1059182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1059193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1059196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1059199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1059202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059221 */     // MIs[0] policy
     /* 1059221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059231 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8_MASK),
     /* 1059234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059240 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059250 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059253 */     // GIR_Coverage, 21211,
     /* 1059253 */     GIR_EraseRootFromParent_Done,
     /* 1059254 */   // Label 15636: @1059254
     /* 1059254 */   GIM_Try, /*On fail goto*//*Label 15637*/ GIMT_Encode4(1059331), // Rule ID 21214 //
     /* 1059259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059298 */     // MIs[0] policy
     /* 1059298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059308 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059327 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059330 */     // GIR_Coverage, 21214,
     /* 1059330 */     GIR_EraseRootFromParent_Done,
     /* 1059331 */   // Label 15637: @1059331
     /* 1059331 */   GIM_Try, /*On fail goto*//*Label 15638*/ GIMT_Encode4(1059408), // Rule ID 21215 //
     /* 1059336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1059347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1059350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1059353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1059356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059375 */     // MIs[0] policy
     /* 1059375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059385 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8_MASK),
     /* 1059388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059407 */     // GIR_Coverage, 21215,
     /* 1059407 */     GIR_EraseRootFromParent_Done,
     /* 1059408 */   // Label 15638: @1059408
     /* 1059408 */   GIM_Try, /*On fail goto*//*Label 15639*/ GIMT_Encode4(1059485), // Rule ID 21218 //
     /* 1059413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1059430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059452 */     // MIs[0] policy
     /* 1059452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059462 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1059465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059484 */     // GIR_Coverage, 21218,
     /* 1059484 */     GIR_EraseRootFromParent_Done,
     /* 1059485 */   // Label 15639: @1059485
     /* 1059485 */   GIM_Try, /*On fail goto*//*Label 15640*/ GIMT_Encode4(1059562), // Rule ID 21219 //
     /* 1059490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1059501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1059504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1059507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1059510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1059517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059529 */     // MIs[0] policy
     /* 1059529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059539 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11219:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8_MASK),
     /* 1059542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059561 */     // GIR_Coverage, 21219,
     /* 1059561 */     GIR_EraseRootFromParent_Done,
     /* 1059562 */   // Label 15640: @1059562
     /* 1059562 */   GIM_Try, /*On fail goto*//*Label 15641*/ GIMT_Encode4(1059639), // Rule ID 21222 //
     /* 1059567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1059584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059606 */     // MIs[0] policy
     /* 1059606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059616 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1059619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059635 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059638 */     // GIR_Coverage, 21222,
     /* 1059638 */     GIR_EraseRootFromParent_Done,
     /* 1059639 */   // Label 15641: @1059639
     /* 1059639 */   GIM_Try, /*On fail goto*//*Label 15642*/ GIMT_Encode4(1059716), // Rule ID 21223 //
     /* 1059644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1059655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1059658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1059661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1059664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1059671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1059679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059683 */     // MIs[0] policy
     /* 1059683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059693 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8_MASK),
     /* 1059696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059702 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059712 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059715 */     // GIR_Coverage, 21223,
     /* 1059715 */     GIR_EraseRootFromParent_Done,
     /* 1059716 */   // Label 15642: @1059716
     /* 1059716 */   GIM_Try, /*On fail goto*//*Label 15643*/ GIMT_Encode4(1059793), // Rule ID 21226 //
     /* 1059721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1059738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059760 */     // MIs[0] policy
     /* 1059760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059770 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1059773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059789 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059792 */     // GIR_Coverage, 21226,
     /* 1059792 */     GIR_EraseRootFromParent_Done,
     /* 1059793 */   // Label 15643: @1059793
     /* 1059793 */   GIM_Try, /*On fail goto*//*Label 15644*/ GIMT_Encode4(1059870), // Rule ID 21227 //
     /* 1059798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1059809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1059812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1059815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1059818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1059825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1059833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059837 */     // MIs[0] policy
     /* 1059837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059847 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1059847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8_MASK),
     /* 1059850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059856 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059866 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059869 */     // GIR_Coverage, 21227,
     /* 1059869 */     GIR_EraseRootFromParent_Done,
     /* 1059870 */   // Label 15644: @1059870
     /* 1059870 */   GIM_Try, /*On fail goto*//*Label 15645*/ GIMT_Encode4(1059947), // Rule ID 21230 //
     /* 1059875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1059878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1059892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1059898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059914 */     // MIs[0] policy
     /* 1059914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1059924 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1059924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1059927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1059929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1059931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1059933 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1059935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1059940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1059943 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1059945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1059946 */     // GIR_Coverage, 21230,
     /* 1059946 */     GIR_EraseRootFromParent_Done,
     /* 1059947 */   // Label 15645: @1059947
     /* 1059947 */   GIM_Try, /*On fail goto*//*Label 15646*/ GIMT_Encode4(1060024), // Rule ID 21231 //
     /* 1059952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1059955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1059960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1059963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1059966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1059969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1059972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1059975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1059979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1059983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1059987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1059991 */     // MIs[0] policy
     /* 1059991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1059994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060001 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8_MASK),
     /* 1060004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060010 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1060020 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060023 */     // GIR_Coverage, 21231,
     /* 1060023 */     GIR_EraseRootFromParent_Done,
     /* 1060024 */   // Label 15646: @1060024
     /* 1060024 */   GIM_Try, /*On fail goto*//*Label 15647*/ GIMT_Encode4(1060101), // Rule ID 21234 //
     /* 1060029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060068 */     // MIs[0] policy
     /* 1060068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060078 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060100 */     // GIR_Coverage, 21234,
     /* 1060100 */     GIR_EraseRootFromParent_Done,
     /* 1060101 */   // Label 15647: @1060101
     /* 1060101 */   GIM_Try, /*On fail goto*//*Label 15648*/ GIMT_Encode4(1060178), // Rule ID 21235 //
     /* 1060106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1060117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1060120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1060123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060145 */     // MIs[0] policy
     /* 1060145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060155 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16_MASK),
     /* 1060158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060177 */     // GIR_Coverage, 21235,
     /* 1060177 */     GIR_EraseRootFromParent_Done,
     /* 1060178 */   // Label 15648: @1060178
     /* 1060178 */   GIM_Try, /*On fail goto*//*Label 15649*/ GIMT_Encode4(1060255), // Rule ID 21238 //
     /* 1060183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060222 */     // MIs[0] policy
     /* 1060222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060232 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060251 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060254 */     // GIR_Coverage, 21238,
     /* 1060254 */     GIR_EraseRootFromParent_Done,
     /* 1060255 */   // Label 15649: @1060255
     /* 1060255 */   GIM_Try, /*On fail goto*//*Label 15650*/ GIMT_Encode4(1060332), // Rule ID 21239 //
     /* 1060260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1060271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1060274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1060277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060299 */     // MIs[0] policy
     /* 1060299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060309 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11219:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16_MASK),
     /* 1060312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060318 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060328 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060331 */     // GIR_Coverage, 21239,
     /* 1060331 */     GIR_EraseRootFromParent_Done,
     /* 1060332 */   // Label 15650: @1060332
     /* 1060332 */   GIM_Try, /*On fail goto*//*Label 15651*/ GIMT_Encode4(1060409), // Rule ID 21242 //
     /* 1060337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060376 */     // MIs[0] policy
     /* 1060376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060386 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060405 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060408 */     // GIR_Coverage, 21242,
     /* 1060408 */     GIR_EraseRootFromParent_Done,
     /* 1060409 */   // Label 15651: @1060409
     /* 1060409 */   GIM_Try, /*On fail goto*//*Label 15652*/ GIMT_Encode4(1060486), // Rule ID 21243 //
     /* 1060414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1060425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1060428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1060431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1060434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060453 */     // MIs[0] policy
     /* 1060453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060463 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16_MASK),
     /* 1060466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060472 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060482 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060485 */     // GIR_Coverage, 21243,
     /* 1060485 */     GIR_EraseRootFromParent_Done,
     /* 1060486 */   // Label 15652: @1060486
     /* 1060486 */   GIM_Try, /*On fail goto*//*Label 15653*/ GIMT_Encode4(1060563), // Rule ID 21246 //
     /* 1060491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1060508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060530 */     // MIs[0] policy
     /* 1060530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060540 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1060543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060559 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060562 */     // GIR_Coverage, 21246,
     /* 1060562 */     GIR_EraseRootFromParent_Done,
     /* 1060563 */   // Label 15653: @1060563
     /* 1060563 */   GIM_Try, /*On fail goto*//*Label 15654*/ GIMT_Encode4(1060640), // Rule ID 21247 //
     /* 1060568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1060579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1060582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1060585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1060588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1060595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060607 */     // MIs[0] policy
     /* 1060607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060617 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16_MASK),
     /* 1060620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060626 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060636 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060639 */     // GIR_Coverage, 21247,
     /* 1060639 */     GIR_EraseRootFromParent_Done,
     /* 1060640 */   // Label 15654: @1060640
     /* 1060640 */   GIM_Try, /*On fail goto*//*Label 15655*/ GIMT_Encode4(1060717), // Rule ID 21250 //
     /* 1060645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1060648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1060662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060684 */     // MIs[0] policy
     /* 1060684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060694 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1060697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060716 */     // GIR_Coverage, 21250,
     /* 1060716 */     GIR_EraseRootFromParent_Done,
     /* 1060717 */   // Label 15655: @1060717
     /* 1060717 */   GIM_Try, /*On fail goto*//*Label 15656*/ GIMT_Encode4(1060794), // Rule ID 21251 //
     /* 1060722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1060725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1060733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1060736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1060739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1060742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1060749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1060753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1060757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060761 */     // MIs[0] policy
     /* 1060761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060771 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16_MASK),
     /* 1060774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060780 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1060790 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060793 */     // GIR_Coverage, 21251,
     /* 1060793 */     GIR_EraseRootFromParent_Done,
     /* 1060794 */   // Label 15656: @1060794
     /* 1060794 */   GIM_Try, /*On fail goto*//*Label 15657*/ GIMT_Encode4(1060871), // Rule ID 21254 //
     /* 1060799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1060802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1060810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1060813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1060816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060838 */     // MIs[0] policy
     /* 1060838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060848 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1060848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1060851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060867 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060870 */     // GIR_Coverage, 21254,
     /* 1060870 */     GIR_EraseRootFromParent_Done,
     /* 1060871 */   // Label 15657: @1060871
     /* 1060871 */   GIM_Try, /*On fail goto*//*Label 15658*/ GIMT_Encode4(1060948), // Rule ID 21255 //
     /* 1060876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1060879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1060887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1060890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1060893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1060896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1060899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1060903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060915 */     // MIs[0] policy
     /* 1060915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1060925 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11219:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1060925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32_MASK),
     /* 1060928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1060930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1060932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1060934 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1060936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1060941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1060944 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1060946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1060947 */     // GIR_Coverage, 21255,
     /* 1060947 */     GIR_EraseRootFromParent_Done,
     /* 1060948 */   // Label 15658: @1060948
     /* 1060948 */   GIM_Try, /*On fail goto*//*Label 15659*/ GIMT_Encode4(1061025), // Rule ID 21258 //
     /* 1060953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1060956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1060961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1060964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1060967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1060970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1060973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1060976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1060980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1060984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1060988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1060992 */     // MIs[0] policy
     /* 1060992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1060995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061002 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061011 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061021 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061024 */     // GIR_Coverage, 21258,
     /* 1061024 */     GIR_EraseRootFromParent_Done,
     /* 1061025 */   // Label 15659: @1061025
     /* 1061025 */   GIM_Try, /*On fail goto*//*Label 15660*/ GIMT_Encode4(1061102), // Rule ID 21259 //
     /* 1061030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1061041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1061044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1061047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061069 */     // MIs[0] policy
     /* 1061069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061079 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11219:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32_MASK),
     /* 1061082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061084 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061088 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061098 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061101 */     // GIR_Coverage, 21259,
     /* 1061101 */     GIR_EraseRootFromParent_Done,
     /* 1061102 */   // Label 15660: @1061102
     /* 1061102 */   GIM_Try, /*On fail goto*//*Label 15661*/ GIMT_Encode4(1061179), // Rule ID 21262 //
     /* 1061107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061146 */     // MIs[0] policy
     /* 1061146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061156 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061175 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061178 */     // GIR_Coverage, 21262,
     /* 1061178 */     GIR_EraseRootFromParent_Done,
     /* 1061179 */   // Label 15661: @1061179
     /* 1061179 */   GIM_Try, /*On fail goto*//*Label 15662*/ GIMT_Encode4(1061256), // Rule ID 21263 //
     /* 1061184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1061195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1061198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1061201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1061211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061223 */     // MIs[0] policy
     /* 1061223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061233 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11219:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32_MASK),
     /* 1061236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061242 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061252 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061255 */     // GIR_Coverage, 21263,
     /* 1061255 */     GIR_EraseRootFromParent_Done,
     /* 1061256 */   // Label 15662: @1061256
     /* 1061256 */   GIM_Try, /*On fail goto*//*Label 15663*/ GIMT_Encode4(1061333), // Rule ID 21266 //
     /* 1061261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1061264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061300 */     // MIs[0] policy
     /* 1061300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061310 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061329 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061332 */     // GIR_Coverage, 21266,
     /* 1061332 */     GIR_EraseRootFromParent_Done,
     /* 1061333 */   // Label 15663: @1061333
     /* 1061333 */   GIM_Try, /*On fail goto*//*Label 15664*/ GIMT_Encode4(1061410), // Rule ID 21267 //
     /* 1061338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1061341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_xu_v_mask),
     /* 1061346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1061349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1061352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1061355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1061365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1061369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1061373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061377 */     // MIs[0] policy
     /* 1061377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061387 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11219:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32_MASK),
     /* 1061390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061396 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1061406 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061409 */     // GIR_Coverage, 21267,
     /* 1061409 */     GIR_EraseRootFromParent_Done,
     /* 1061410 */   // Label 15664: @1061410
     /* 1061410 */   GIM_Try, /*On fail goto*//*Label 15665*/ GIMT_Encode4(1061487), // Rule ID 21270 //
     /* 1061415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061454 */     // MIs[0] policy
     /* 1061454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061464 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1061467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061486 */     // GIR_Coverage, 21270,
     /* 1061486 */     GIR_EraseRootFromParent_Done,
     /* 1061487 */   // Label 15665: @1061487
     /* 1061487 */   GIM_Try, /*On fail goto*//*Label 15666*/ GIMT_Encode4(1061564), // Rule ID 21271 //
     /* 1061492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1061503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1061506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1061509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1061512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061531 */     // MIs[0] policy
     /* 1061531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061541 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF8_E8_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8_MASK),
     /* 1061544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061563 */     // GIR_Coverage, 21271,
     /* 1061563 */     GIR_EraseRootFromParent_Done,
     /* 1061564 */   // Label 15666: @1061564
     /* 1061564 */   GIM_Try, /*On fail goto*//*Label 15667*/ GIMT_Encode4(1061641), // Rule ID 21274 //
     /* 1061569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1061580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1061583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1061586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061608 */     // MIs[0] policy
     /* 1061608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061618 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1061621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061640 */     // GIR_Coverage, 21274,
     /* 1061640 */     GIR_EraseRootFromParent_Done,
     /* 1061641 */   // Label 15667: @1061641
     /* 1061641 */   GIM_Try, /*On fail goto*//*Label 15668*/ GIMT_Encode4(1061718), // Rule ID 21275 //
     /* 1061646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1061657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1061660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1061663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1061666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061685 */     // MIs[0] policy
     /* 1061685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061695 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E8_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8_MASK),
     /* 1061698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061704 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061714 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061717 */     // GIR_Coverage, 21275,
     /* 1061717 */     GIR_EraseRootFromParent_Done,
     /* 1061718 */   // Label 15668: @1061718
     /* 1061718 */   GIM_Try, /*On fail goto*//*Label 15669*/ GIMT_Encode4(1061795), // Rule ID 21278 //
     /* 1061723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1061734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1061737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1061740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061762 */     // MIs[0] policy
     /* 1061762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1061775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061791 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061794 */     // GIR_Coverage, 21278,
     /* 1061794 */     GIR_EraseRootFromParent_Done,
     /* 1061795 */   // Label 15669: @1061795
     /* 1061795 */   GIM_Try, /*On fail goto*//*Label 15670*/ GIMT_Encode4(1061872), // Rule ID 21279 //
     /* 1061800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1061811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1061814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1061817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1061820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1061827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061839 */     // MIs[0] policy
     /* 1061839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061849 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11217:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E8_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1061849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8_MASK),
     /* 1061852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061858 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061868 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061871 */     // GIR_Coverage, 21279,
     /* 1061871 */     GIR_EraseRootFromParent_Done,
     /* 1061872 */   // Label 15670: @1061872
     /* 1061872 */   GIM_Try, /*On fail goto*//*Label 15671*/ GIMT_Encode4(1061949), // Rule ID 21282 //
     /* 1061877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1061880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1061888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1061891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1061894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1061900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061916 */     // MIs[0] policy
     /* 1061916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1061926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1061926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1061929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1061931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1061933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1061935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1061937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1061942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1061945 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1061947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1061948 */     // GIR_Coverage, 21282,
     /* 1061948 */     GIR_EraseRootFromParent_Done,
     /* 1061949 */   // Label 15671: @1061949
     /* 1061949 */   GIM_Try, /*On fail goto*//*Label 15672*/ GIMT_Encode4(1062026), // Rule ID 21283 //
     /* 1061954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1061957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1061962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1061965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1061968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1061971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1061974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1061977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1061981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1061985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1061989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1061993 */     // MIs[0] policy
     /* 1061993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1061996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062003 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E8_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8_MASK),
     /* 1062006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062012 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062022 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062025 */     // GIR_Coverage, 21283,
     /* 1062025 */     GIR_EraseRootFromParent_Done,
     /* 1062026 */   // Label 15672: @1062026
     /* 1062026 */   GIM_Try, /*On fail goto*//*Label 15673*/ GIMT_Encode4(1062103), // Rule ID 21286 //
     /* 1062031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062070 */     // MIs[0] policy
     /* 1062070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062080 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062099 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062102 */     // GIR_Coverage, 21286,
     /* 1062102 */     GIR_EraseRootFromParent_Done,
     /* 1062103 */   // Label 15673: @1062103
     /* 1062103 */   GIM_Try, /*On fail goto*//*Label 15674*/ GIMT_Encode4(1062180), // Rule ID 21287 //
     /* 1062108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1062119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1062122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1062125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062147 */     // MIs[0] policy
     /* 1062147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062157 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E8_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8_MASK),
     /* 1062160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062166 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062176 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062179 */     // GIR_Coverage, 21287,
     /* 1062179 */     GIR_EraseRootFromParent_Done,
     /* 1062180 */   // Label 15674: @1062180
     /* 1062180 */   GIM_Try, /*On fail goto*//*Label 15675*/ GIMT_Encode4(1062257), // Rule ID 21290 //
     /* 1062185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1062188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062224 */     // MIs[0] policy
     /* 1062224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062234 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062243 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062253 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062256 */     // GIR_Coverage, 21290,
     /* 1062256 */     GIR_EraseRootFromParent_Done,
     /* 1062257 */   // Label 15675: @1062257
     /* 1062257 */   GIM_Try, /*On fail goto*//*Label 15676*/ GIMT_Encode4(1062334), // Rule ID 21291 //
     /* 1062262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1062265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1062273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1062276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1062279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1062282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062301 */     // MIs[0] policy
     /* 1062301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062311 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8_MASK),
     /* 1062314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062320 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1062330 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062333 */     // GIR_Coverage, 21291,
     /* 1062333 */     GIR_EraseRootFromParent_Done,
     /* 1062334 */   // Label 15676: @1062334
     /* 1062334 */   GIM_Try, /*On fail goto*//*Label 15677*/ GIMT_Encode4(1062411), // Rule ID 21294 //
     /* 1062339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062378 */     // MIs[0] policy
     /* 1062378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062388 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062407 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062410 */     // GIR_Coverage, 21294,
     /* 1062410 */     GIR_EraseRootFromParent_Done,
     /* 1062411 */   // Label 15677: @1062411
     /* 1062411 */   GIM_Try, /*On fail goto*//*Label 15678*/ GIMT_Encode4(1062488), // Rule ID 21295 //
     /* 1062416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1062427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1062430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1062433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1062436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062455 */     // MIs[0] policy
     /* 1062455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062465 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16_MASK),
     /* 1062468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062474 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062484 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062486 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062487 */     // GIR_Coverage, 21295,
     /* 1062487 */     GIR_EraseRootFromParent_Done,
     /* 1062488 */   // Label 15678: @1062488
     /* 1062488 */   GIM_Try, /*On fail goto*//*Label 15679*/ GIMT_Encode4(1062565), // Rule ID 21298 //
     /* 1062493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062532 */     // MIs[0] policy
     /* 1062532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062542 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1062545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062561 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062564 */     // GIR_Coverage, 21298,
     /* 1062564 */     GIR_EraseRootFromParent_Done,
     /* 1062565 */   // Label 15679: @1062565
     /* 1062565 */   GIM_Try, /*On fail goto*//*Label 15680*/ GIMT_Encode4(1062642), // Rule ID 21299 //
     /* 1062570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1062581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1062584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1062587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1062590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1062597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062609 */     // MIs[0] policy
     /* 1062609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11217:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16_MASK),
     /* 1062622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062641 */     // GIR_Coverage, 21299,
     /* 1062641 */     GIR_EraseRootFromParent_Done,
     /* 1062642 */   // Label 15680: @1062642
     /* 1062642 */   GIM_Try, /*On fail goto*//*Label 15681*/ GIMT_Encode4(1062719), // Rule ID 21302 //
     /* 1062647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062686 */     // MIs[0] policy
     /* 1062686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062696 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1062699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062718 */     // GIR_Coverage, 21302,
     /* 1062718 */     GIR_EraseRootFromParent_Done,
     /* 1062719 */   // Label 15681: @1062719
     /* 1062719 */   GIM_Try, /*On fail goto*//*Label 15682*/ GIMT_Encode4(1062796), // Rule ID 21303 //
     /* 1062724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1062735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1062738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1062741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1062744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1062751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1062759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062763 */     // MIs[0] policy
     /* 1062763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062773 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16_MASK),
     /* 1062776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062782 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062792 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062795 */     // GIR_Coverage, 21303,
     /* 1062795 */     GIR_EraseRootFromParent_Done,
     /* 1062796 */   // Label 15682: @1062796
     /* 1062796 */   GIM_Try, /*On fail goto*//*Label 15683*/ GIMT_Encode4(1062873), // Rule ID 21306 //
     /* 1062801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062840 */     // MIs[0] policy
     /* 1062840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062850 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1062850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1062853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062872 */     // GIR_Coverage, 21306,
     /* 1062872 */     GIR_EraseRootFromParent_Done,
     /* 1062873 */   // Label 15683: @1062873
     /* 1062873 */   GIM_Try, /*On fail goto*//*Label 15684*/ GIMT_Encode4(1062950), // Rule ID 21307 //
     /* 1062878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1062881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1062889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1062892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1062895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1062898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1062901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1062905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1062913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062917 */     // MIs[0] policy
     /* 1062917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1062927 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1062927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16_MASK),
     /* 1062930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1062932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1062934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1062936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1062938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1062943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1062946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1062948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1062949 */     // GIR_Coverage, 21307,
     /* 1062949 */     GIR_EraseRootFromParent_Done,
     /* 1062950 */   // Label 15684: @1062950
     /* 1062950 */   GIM_Try, /*On fail goto*//*Label 15685*/ GIMT_Encode4(1063027), // Rule ID 21310 //
     /* 1062955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1062958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1062963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1062966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1062969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1062972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1062975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1062978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1062982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1062986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1062990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1062994 */     // MIs[0] policy
     /* 1062994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1062997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063004 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063013 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063023 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063026 */     // GIR_Coverage, 21310,
     /* 1063026 */     GIR_EraseRootFromParent_Done,
     /* 1063027 */   // Label 15685: @1063027
     /* 1063027 */   GIM_Try, /*On fail goto*//*Label 15686*/ GIMT_Encode4(1063104), // Rule ID 21311 //
     /* 1063032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1063035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1063043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1063046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1063049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1063052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063071 */     // MIs[0] policy
     /* 1063071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063081 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16_MASK),
     /* 1063084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063090 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063100 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063103 */     // GIR_Coverage, 21311,
     /* 1063103 */     GIR_EraseRootFromParent_Done,
     /* 1063104 */   // Label 15686: @1063104
     /* 1063104 */   GIM_Try, /*On fail goto*//*Label 15687*/ GIMT_Encode4(1063181), // Rule ID 21314 //
     /* 1063109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063148 */     // MIs[0] policy
     /* 1063148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063158 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063177 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063180 */     // GIR_Coverage, 21314,
     /* 1063180 */     GIR_EraseRootFromParent_Done,
     /* 1063181 */   // Label 15687: @1063181
     /* 1063181 */   GIM_Try, /*On fail goto*//*Label 15688*/ GIMT_Encode4(1063258), // Rule ID 21315 //
     /* 1063186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1063197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1063200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1063203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063225 */     // MIs[0] policy
     /* 1063225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063235 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11217:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32_MASK),
     /* 1063238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063244 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063254 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063257 */     // GIR_Coverage, 21315,
     /* 1063257 */     GIR_EraseRootFromParent_Done,
     /* 1063258 */   // Label 15688: @1063258
     /* 1063258 */   GIM_Try, /*On fail goto*//*Label 15689*/ GIMT_Encode4(1063335), // Rule ID 21318 //
     /* 1063263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063302 */     // MIs[0] policy
     /* 1063302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063312 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063331 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063334 */     // GIR_Coverage, 21318,
     /* 1063334 */     GIR_EraseRootFromParent_Done,
     /* 1063335 */   // Label 15689: @1063335
     /* 1063335 */   GIM_Try, /*On fail goto*//*Label 15690*/ GIMT_Encode4(1063412), // Rule ID 21319 //
     /* 1063340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1063351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1063354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1063357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1063367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063379 */     // MIs[0] policy
     /* 1063379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063389 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11217:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32_MASK),
     /* 1063392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063411 */     // GIR_Coverage, 21319,
     /* 1063411 */     GIR_EraseRootFromParent_Done,
     /* 1063412 */   // Label 15690: @1063412
     /* 1063412 */   GIM_Try, /*On fail goto*//*Label 15691*/ GIMT_Encode4(1063489), // Rule ID 21322 //
     /* 1063417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063456 */     // MIs[0] policy
     /* 1063456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063466 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1063469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063475 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063485 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063488 */     // GIR_Coverage, 21322,
     /* 1063488 */     GIR_EraseRootFromParent_Done,
     /* 1063489 */   // Label 15691: @1063489
     /* 1063489 */   GIM_Try, /*On fail goto*//*Label 15692*/ GIMT_Encode4(1063566), // Rule ID 21323 //
     /* 1063494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1063505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1063508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1063511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1063514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1063521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1063529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063533 */     // MIs[0] policy
     /* 1063533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063543 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11217:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32_MASK),
     /* 1063546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063552 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063562 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063565 */     // GIR_Coverage, 21323,
     /* 1063565 */     GIR_EraseRootFromParent_Done,
     /* 1063566 */   // Label 15692: @1063566
     /* 1063566 */   GIM_Try, /*On fail goto*//*Label 15693*/ GIMT_Encode4(1063643), // Rule ID 21326 //
     /* 1063571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1063574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063610 */     // MIs[0] policy
     /* 1063610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063620 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1063623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063639 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063642 */     // GIR_Coverage, 21326,
     /* 1063642 */     GIR_EraseRootFromParent_Done,
     /* 1063643 */   // Label 15693: @1063643
     /* 1063643 */   GIM_Try, /*On fail goto*//*Label 15694*/ GIMT_Encode4(1063720), // Rule ID 21327 //
     /* 1063648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1063651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_x_v_mask),
     /* 1063656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1063659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1063662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1063665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1063668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1063675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1063679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1063683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063687 */     // MIs[0] policy
     /* 1063687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063697 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11217:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32_MASK),
     /* 1063700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063706 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1063716 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063719 */     // GIR_Coverage, 21327,
     /* 1063719 */     GIR_EraseRootFromParent_Done,
     /* 1063720 */   // Label 15694: @1063720
     /* 1063720 */   GIM_Try, /*On fail goto*//*Label 15695*/ GIMT_Encode4(1063797), // Rule ID 21330 //
     /* 1063725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1063728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1063733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063764 */     // MIs[0] policy
     /* 1063764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1063777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063793 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063796 */     // GIR_Coverage, 21330,
     /* 1063796 */     GIR_EraseRootFromParent_Done,
     /* 1063797 */   // Label 15695: @1063797
     /* 1063797 */   GIM_Try, /*On fail goto*//*Label 15696*/ GIMT_Encode4(1063874), // Rule ID 21331 //
     /* 1063802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1063805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1063810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1063813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1063816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1063819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1063822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063841 */     // MIs[0] policy
     /* 1063841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063851 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1063851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF4_E16_MASK),
     /* 1063854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063860 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063870 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063873 */     // GIR_Coverage, 21331,
     /* 1063873 */     GIR_EraseRootFromParent_Done,
     /* 1063874 */   // Label 15696: @1063874
     /* 1063874 */   GIM_Try, /*On fail goto*//*Label 15697*/ GIMT_Encode4(1063951), // Rule ID 21334 //
     /* 1063879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1063882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1063887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1063902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063918 */     // MIs[0] policy
     /* 1063918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1063928 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1063928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1063931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1063933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1063935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1063937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1063939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1063944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1063947 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1063949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1063950 */     // GIR_Coverage, 21334,
     /* 1063950 */     GIR_EraseRootFromParent_Done,
     /* 1063951 */   // Label 15697: @1063951
     /* 1063951 */   GIM_Try, /*On fail goto*//*Label 15698*/ GIMT_Encode4(1064028), // Rule ID 21335 //
     /* 1063956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1063959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1063964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1063967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1063970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1063973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1063976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1063979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1063983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1063991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1063995 */     // MIs[0] policy
     /* 1063995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1063998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064005 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11215:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E16_MASK),
     /* 1064008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064027 */     // GIR_Coverage, 21335,
     /* 1064027 */     GIR_EraseRootFromParent_Done,
     /* 1064028 */   // Label 15698: @1064028
     /* 1064028 */   GIM_Try, /*On fail goto*//*Label 15699*/ GIMT_Encode4(1064105), // Rule ID 21338 //
     /* 1064033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1064036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064072 */     // MIs[0] policy
     /* 1064072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064082 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064101 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064104 */     // GIR_Coverage, 21338,
     /* 1064104 */     GIR_EraseRootFromParent_Done,
     /* 1064105 */   // Label 15699: @1064105
     /* 1064105 */   GIM_Try, /*On fail goto*//*Label 15700*/ GIMT_Encode4(1064182), // Rule ID 21339 //
     /* 1064110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1064113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1064121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1064124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1064127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064149 */     // MIs[0] policy
     /* 1064149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064159 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E16_MASK),
     /* 1064162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064181 */     // GIR_Coverage, 21339,
     /* 1064181 */     GIR_EraseRootFromParent_Done,
     /* 1064182 */   // Label 15700: @1064182
     /* 1064182 */   GIM_Try, /*On fail goto*//*Label 15701*/ GIMT_Encode4(1064259), // Rule ID 21342 //
     /* 1064187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1064190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064226 */     // MIs[0] policy
     /* 1064226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064258 */     // GIR_Coverage, 21342,
     /* 1064258 */     GIR_EraseRootFromParent_Done,
     /* 1064259 */   // Label 15701: @1064259
     /* 1064259 */   GIM_Try, /*On fail goto*//*Label 15702*/ GIMT_Encode4(1064336), // Rule ID 21343 //
     /* 1064264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1064267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1064275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1064278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1064281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064303 */     // MIs[0] policy
     /* 1064303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064313 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E16_MASK),
     /* 1064316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064334 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064335 */     // GIR_Coverage, 21343,
     /* 1064335 */     GIR_EraseRootFromParent_Done,
     /* 1064336 */   // Label 15702: @1064336
     /* 1064336 */   GIM_Try, /*On fail goto*//*Label 15703*/ GIMT_Encode4(1064413), // Rule ID 21346 //
     /* 1064341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1064344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064380 */     // MIs[0] policy
     /* 1064380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064390 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064409 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064412 */     // GIR_Coverage, 21346,
     /* 1064412 */     GIR_EraseRootFromParent_Done,
     /* 1064413 */   // Label 15703: @1064413
     /* 1064413 */   GIM_Try, /*On fail goto*//*Label 15704*/ GIMT_Encode4(1064490), // Rule ID 21347 //
     /* 1064418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1064421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1064429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1064432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1064435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1064438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064457 */     // MIs[0] policy
     /* 1064457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064467 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E16_MASK),
     /* 1064470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064476 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1064486 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064489 */     // GIR_Coverage, 21347,
     /* 1064489 */     GIR_EraseRootFromParent_Done,
     /* 1064490 */   // Label 15704: @1064490
     /* 1064490 */   GIM_Try, /*On fail goto*//*Label 15705*/ GIMT_Encode4(1064567), // Rule ID 21350 //
     /* 1064495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1064498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064534 */     // MIs[0] policy
     /* 1064534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064544 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1064547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064566 */     // GIR_Coverage, 21350,
     /* 1064566 */     GIR_EraseRootFromParent_Done,
     /* 1064567 */   // Label 15705: @1064567
     /* 1064567 */   GIM_Try, /*On fail goto*//*Label 15706*/ GIMT_Encode4(1064644), // Rule ID 21351 //
     /* 1064572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1064575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1064583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1064586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1064589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1064592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1064599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064611 */     // MIs[0] policy
     /* 1064611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064621 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11215:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_MF2_E32_MASK),
     /* 1064624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064643 */     // GIR_Coverage, 21351,
     /* 1064643 */     GIR_EraseRootFromParent_Done,
     /* 1064644 */   // Label 15706: @1064644
     /* 1064644 */   GIM_Try, /*On fail goto*//*Label 15707*/ GIMT_Encode4(1064721), // Rule ID 21354 //
     /* 1064649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1064652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064688 */     // MIs[0] policy
     /* 1064688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064698 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1064701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064717 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064720 */     // GIR_Coverage, 21354,
     /* 1064720 */     GIR_EraseRootFromParent_Done,
     /* 1064721 */   // Label 15707: @1064721
     /* 1064721 */   GIM_Try, /*On fail goto*//*Label 15708*/ GIMT_Encode4(1064798), // Rule ID 21355 //
     /* 1064726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1064729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1064737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1064740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1064743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1064746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1064753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1064761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064765 */     // MIs[0] policy
     /* 1064765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064775 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11215:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M1_E32_MASK),
     /* 1064778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064784 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064794 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064797 */     // GIR_Coverage, 21355,
     /* 1064797 */     GIR_EraseRootFromParent_Done,
     /* 1064798 */   // Label 15708: @1064798
     /* 1064798 */   GIM_Try, /*On fail goto*//*Label 15709*/ GIMT_Encode4(1064875), // Rule ID 21358 //
     /* 1064803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1064806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064842 */     // MIs[0] policy
     /* 1064842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064852 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1064852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1064855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064871 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064874 */     // GIR_Coverage, 21358,
     /* 1064874 */     GIR_EraseRootFromParent_Done,
     /* 1064875 */   // Label 15709: @1064875
     /* 1064875 */   GIM_Try, /*On fail goto*//*Label 15710*/ GIMT_Encode4(1064952), // Rule ID 21359 //
     /* 1064880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1064883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1064891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1064894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1064897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1064900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1064903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1064907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1064915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064919 */     // MIs[0] policy
     /* 1064919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1064929 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11215:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1064929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M2_E32_MASK),
     /* 1064932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1064934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1064936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1064938 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1064940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1064945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1064948 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1064950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1064951 */     // GIR_Coverage, 21359,
     /* 1064951 */     GIR_EraseRootFromParent_Done,
     /* 1064952 */   // Label 15710: @1064952
     /* 1064952 */   GIM_Try, /*On fail goto*//*Label 15711*/ GIMT_Encode4(1065029), // Rule ID 21362 //
     /* 1064957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1064960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1064965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1064968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1064971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1064974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1064977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1064980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1064984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1064988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1064992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1064996 */     // MIs[0] policy
     /* 1064996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1064999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065006 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065015 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065025 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065028 */     // GIR_Coverage, 21362,
     /* 1065028 */     GIR_EraseRootFromParent_Done,
     /* 1065029 */   // Label 15711: @1065029
     /* 1065029 */   GIM_Try, /*On fail goto*//*Label 15712*/ GIMT_Encode4(1065106), // Rule ID 21363 //
     /* 1065034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1065037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_f_f_v_mask),
     /* 1065042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1065045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1065048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1065051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1065061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065073 */     // MIs[0] policy
     /* 1065073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065083 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11215:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_F_F_V_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_F_V_M4_E32_MASK),
     /* 1065086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065092 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1065102 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065105 */     // GIR_Coverage, 21363,
     /* 1065105 */     GIR_EraseRootFromParent_Done,
     /* 1065106 */   // Label 15712: @1065106
     /* 1065106 */   GIM_Try, /*On fail goto*//*Label 15713*/ GIMT_Encode4(1065183), // Rule ID 21606 //
     /* 1065111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065150 */     // MIs[0] policy
     /* 1065150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065179 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065182 */     // GIR_Coverage, 21606,
     /* 1065182 */     GIR_EraseRootFromParent_Done,
     /* 1065183 */   // Label 15713: @1065183
     /* 1065183 */   GIM_Try, /*On fail goto*//*Label 15714*/ GIMT_Encode4(1065260), // Rule ID 21607 //
     /* 1065188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1065199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1065202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1065205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1065208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065227 */     // MIs[0] policy
     /* 1065227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065237 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1065240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065246 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065256 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065259 */     // GIR_Coverage, 21607,
     /* 1065259 */     GIR_EraseRootFromParent_Done,
     /* 1065260 */   // Label 15714: @1065260
     /* 1065260 */   GIM_Try, /*On fail goto*//*Label 15715*/ GIMT_Encode4(1065337), // Rule ID 21610 //
     /* 1065265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065304 */     // MIs[0] policy
     /* 1065304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065323 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065333 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065336 */     // GIR_Coverage, 21610,
     /* 1065336 */     GIR_EraseRootFromParent_Done,
     /* 1065337 */   // Label 15715: @1065337
     /* 1065337 */   GIM_Try, /*On fail goto*//*Label 15716*/ GIMT_Encode4(1065414), // Rule ID 21611 //
     /* 1065342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1065353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1065356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1065359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1065362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065381 */     // MIs[0] policy
     /* 1065381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065391 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1065394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065400 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065410 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065413 */     // GIR_Coverage, 21611,
     /* 1065413 */     GIR_EraseRootFromParent_Done,
     /* 1065414 */   // Label 15716: @1065414
     /* 1065414 */   GIM_Try, /*On fail goto*//*Label 15717*/ GIMT_Encode4(1065491), // Rule ID 21614 //
     /* 1065419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065458 */     // MIs[0] policy
     /* 1065458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065468 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1065471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065490 */     // GIR_Coverage, 21614,
     /* 1065490 */     GIR_EraseRootFromParent_Done,
     /* 1065491 */   // Label 15717: @1065491
     /* 1065491 */   GIM_Try, /*On fail goto*//*Label 15718*/ GIMT_Encode4(1065568), // Rule ID 21615 //
     /* 1065496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1065507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1065510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1065513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1065516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065535 */     // MIs[0] policy
     /* 1065535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065545 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1065548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065567 */     // GIR_Coverage, 21615,
     /* 1065567 */     GIR_EraseRootFromParent_Done,
     /* 1065568 */   // Label 15718: @1065568
     /* 1065568 */   GIM_Try, /*On fail goto*//*Label 15719*/ GIMT_Encode4(1065645), // Rule ID 21618 //
     /* 1065573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1065584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1065587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065612 */     // MIs[0] policy
     /* 1065612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065622 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1065625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065644 */     // GIR_Coverage, 21618,
     /* 1065644 */     GIR_EraseRootFromParent_Done,
     /* 1065645 */   // Label 15719: @1065645
     /* 1065645 */   GIM_Try, /*On fail goto*//*Label 15720*/ GIMT_Encode4(1065722), // Rule ID 21619 //
     /* 1065650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1065661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1065664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1065667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1065670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1065677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1065681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065689 */     // MIs[0] policy
     /* 1065689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065699 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11165:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1065702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065708 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065718 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065721 */     // GIR_Coverage, 21619,
     /* 1065721 */     GIR_EraseRootFromParent_Done,
     /* 1065722 */   // Label 15720: @1065722
     /* 1065722 */   GIM_Try, /*On fail goto*//*Label 15721*/ GIMT_Encode4(1065799), // Rule ID 21622 //
     /* 1065727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1065738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1065741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065766 */     // MIs[0] policy
     /* 1065766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1065779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065795 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065798 */     // GIR_Coverage, 21622,
     /* 1065798 */     GIR_EraseRootFromParent_Done,
     /* 1065799 */   // Label 15721: @1065799
     /* 1065799 */   GIM_Try, /*On fail goto*//*Label 15722*/ GIMT_Encode4(1065876), // Rule ID 21623 //
     /* 1065804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1065815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1065818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1065821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1065824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1065831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1065835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065843 */     // MIs[0] policy
     /* 1065843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065853 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1065853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1065856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065862 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065872 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065875 */     // GIR_Coverage, 21623,
     /* 1065875 */     GIR_EraseRootFromParent_Done,
     /* 1065876 */   // Label 15722: @1065876
     /* 1065876 */   GIM_Try, /*On fail goto*//*Label 15723*/ GIMT_Encode4(1065953), // Rule ID 21626 //
     /* 1065881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1065884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1065892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1065895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1065898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1065901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1065904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065920 */     // MIs[0] policy
     /* 1065920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1065923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1065930 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1065930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1065933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1065935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1065937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1065939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1065941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1065946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1065949 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1065951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1065952 */     // GIR_Coverage, 21626,
     /* 1065952 */     GIR_EraseRootFromParent_Done,
     /* 1065953 */   // Label 15723: @1065953
     /* 1065953 */   GIM_Try, /*On fail goto*//*Label 15724*/ GIMT_Encode4(1066030), // Rule ID 21627 //
     /* 1065958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1065961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1065966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1065969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1065972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1065975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1065978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1065981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1065985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1065989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1065993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1065997 */     // MIs[0] policy
     /* 1065997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066007 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066016 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1066026 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066029 */     // GIR_Coverage, 21627,
     /* 1066029 */     GIR_EraseRootFromParent_Done,
     /* 1066030 */   // Label 15724: @1066030
     /* 1066030 */   GIM_Try, /*On fail goto*//*Label 15725*/ GIMT_Encode4(1066107), // Rule ID 21630 //
     /* 1066035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066074 */     // MIs[0] policy
     /* 1066074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066084 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066106 */     // GIR_Coverage, 21630,
     /* 1066106 */     GIR_EraseRootFromParent_Done,
     /* 1066107 */   // Label 15725: @1066107
     /* 1066107 */   GIM_Try, /*On fail goto*//*Label 15726*/ GIMT_Encode4(1066184), // Rule ID 21631 //
     /* 1066112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1066123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1066126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1066129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066151 */     // MIs[0] policy
     /* 1066151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066161 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1066164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066170 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066180 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066183 */     // GIR_Coverage, 21631,
     /* 1066183 */     GIR_EraseRootFromParent_Done,
     /* 1066184 */   // Label 15726: @1066184
     /* 1066184 */   GIM_Try, /*On fail goto*//*Label 15727*/ GIMT_Encode4(1066261), // Rule ID 21634 //
     /* 1066189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066228 */     // MIs[0] policy
     /* 1066228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066238 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066257 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066260 */     // GIR_Coverage, 21634,
     /* 1066260 */     GIR_EraseRootFromParent_Done,
     /* 1066261 */   // Label 15727: @1066261
     /* 1066261 */   GIM_Try, /*On fail goto*//*Label 15728*/ GIMT_Encode4(1066338), // Rule ID 21635 //
     /* 1066266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1066277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1066280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1066283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066305 */     // MIs[0] policy
     /* 1066305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066315 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066324 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066334 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066337 */     // GIR_Coverage, 21635,
     /* 1066337 */     GIR_EraseRootFromParent_Done,
     /* 1066338 */   // Label 15728: @1066338
     /* 1066338 */   GIM_Try, /*On fail goto*//*Label 15729*/ GIMT_Encode4(1066415), // Rule ID 21638 //
     /* 1066343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066382 */     // MIs[0] policy
     /* 1066382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066411 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066414 */     // GIR_Coverage, 21638,
     /* 1066414 */     GIR_EraseRootFromParent_Done,
     /* 1066415 */   // Label 15729: @1066415
     /* 1066415 */   GIM_Try, /*On fail goto*//*Label 15730*/ GIMT_Encode4(1066492), // Rule ID 21639 //
     /* 1066420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1066431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1066434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1066437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1066440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066459 */     // MIs[0] policy
     /* 1066459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066469 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11165:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1066472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066491 */     // GIR_Coverage, 21639,
     /* 1066491 */     GIR_EraseRootFromParent_Done,
     /* 1066492 */   // Label 15730: @1066492
     /* 1066492 */   GIM_Try, /*On fail goto*//*Label 15731*/ GIMT_Encode4(1066569), // Rule ID 21642 //
     /* 1066497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1066514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066536 */     // MIs[0] policy
     /* 1066536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066546 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066568 */     // GIR_Coverage, 21642,
     /* 1066568 */     GIR_EraseRootFromParent_Done,
     /* 1066569 */   // Label 15731: @1066569
     /* 1066569 */   GIM_Try, /*On fail goto*//*Label 15732*/ GIMT_Encode4(1066646), // Rule ID 21643 //
     /* 1066574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1066585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1066588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1066591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1066594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1066601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066613 */     // MIs[0] policy
     /* 1066613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066623 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1066626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066632 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066642 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066645 */     // GIR_Coverage, 21643,
     /* 1066645 */     GIR_EraseRootFromParent_Done,
     /* 1066646 */   // Label 15732: @1066646
     /* 1066646 */   GIM_Try, /*On fail goto*//*Label 15733*/ GIMT_Encode4(1066723), // Rule ID 21646 //
     /* 1066651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1066654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1066668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066690 */     // MIs[0] policy
     /* 1066690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066700 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066719 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066722 */     // GIR_Coverage, 21646,
     /* 1066722 */     GIR_EraseRootFromParent_Done,
     /* 1066723 */   // Label 15733: @1066723
     /* 1066723 */   GIM_Try, /*On fail goto*//*Label 15734*/ GIMT_Encode4(1066800), // Rule ID 21647 //
     /* 1066728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1066731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1066739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1066742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1066745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1066748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1066755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1066759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1066763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066767 */     // MIs[0] policy
     /* 1066767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1066780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066786 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1066796 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066799 */     // GIR_Coverage, 21647,
     /* 1066799 */     GIR_EraseRootFromParent_Done,
     /* 1066800 */   // Label 15734: @1066800
     /* 1066800 */   GIM_Try, /*On fail goto*//*Label 15735*/ GIMT_Encode4(1066877), // Rule ID 21650 //
     /* 1066805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1066808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1066822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066844 */     // MIs[0] policy
     /* 1066844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066854 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1066854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066873 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066876 */     // GIR_Coverage, 21650,
     /* 1066876 */     GIR_EraseRootFromParent_Done,
     /* 1066877 */   // Label 15735: @1066877
     /* 1066877 */   GIM_Try, /*On fail goto*//*Label 15736*/ GIMT_Encode4(1066954), // Rule ID 21651 //
     /* 1066882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1066885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1066893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1066896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1066899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1066902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1066905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066921 */     // MIs[0] policy
     /* 1066921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1066924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1066931 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1066931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1066934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1066936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1066938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1066940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1066942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1066947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1066950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1066952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1066953 */     // GIR_Coverage, 21651,
     /* 1066953 */     GIR_EraseRootFromParent_Done,
     /* 1066954 */   // Label 15736: @1066954
     /* 1066954 */   GIM_Try, /*On fail goto*//*Label 15737*/ GIMT_Encode4(1067031), // Rule ID 21654 //
     /* 1066959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1066962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1066967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1066970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1066973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1066976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1066979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1066982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1066986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1066990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1066994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1066998 */     // MIs[0] policy
     /* 1066998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067008 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067030 */     // GIR_Coverage, 21654,
     /* 1067030 */     GIR_EraseRootFromParent_Done,
     /* 1067031 */   // Label 15737: @1067031
     /* 1067031 */   GIM_Try, /*On fail goto*//*Label 15738*/ GIMT_Encode4(1067108), // Rule ID 21655 //
     /* 1067036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1067047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1067050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1067053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067075 */     // MIs[0] policy
     /* 1067075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067085 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11165:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1067088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067094 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067104 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067107 */     // GIR_Coverage, 21655,
     /* 1067107 */     GIR_EraseRootFromParent_Done,
     /* 1067108 */   // Label 15738: @1067108
     /* 1067108 */   GIM_Try, /*On fail goto*//*Label 15739*/ GIMT_Encode4(1067185), // Rule ID 21658 //
     /* 1067113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067152 */     // MIs[0] policy
     /* 1067152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067181 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067184 */     // GIR_Coverage, 21658,
     /* 1067184 */     GIR_EraseRootFromParent_Done,
     /* 1067185 */   // Label 15739: @1067185
     /* 1067185 */   GIM_Try, /*On fail goto*//*Label 15740*/ GIMT_Encode4(1067262), // Rule ID 21659 //
     /* 1067190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1067201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1067204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1067207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1067217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067229 */     // MIs[0] policy
     /* 1067229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11165:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1067242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067248 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067258 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067261 */     // GIR_Coverage, 21659,
     /* 1067261 */     GIR_EraseRootFromParent_Done,
     /* 1067262 */   // Label 15740: @1067262
     /* 1067262 */   GIM_Try, /*On fail goto*//*Label 15741*/ GIMT_Encode4(1067339), // Rule ID 21662 //
     /* 1067267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1067270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067306 */     // MIs[0] policy
     /* 1067306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067325 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067335 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067338 */     // GIR_Coverage, 21662,
     /* 1067338 */     GIR_EraseRootFromParent_Done,
     /* 1067339 */   // Label 15741: @1067339
     /* 1067339 */   GIM_Try, /*On fail goto*//*Label 15742*/ GIMT_Encode4(1067416), // Rule ID 21663 //
     /* 1067344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1067347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_xu_f_w_mask),
     /* 1067352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1067355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1067358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1067361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1067371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1067375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1067379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067383 */     // MIs[0] policy
     /* 1067383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067393 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11165:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1067396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067402 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1067412 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067415 */     // GIR_Coverage, 21663,
     /* 1067415 */     GIR_EraseRootFromParent_Done,
     /* 1067416 */   // Label 15742: @1067416
     /* 1067416 */   GIM_Try, /*On fail goto*//*Label 15743*/ GIMT_Encode4(1067493), // Rule ID 21666 //
     /* 1067421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1067432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1067435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1067438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067460 */     // MIs[0] policy
     /* 1067460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067470 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1067473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067489 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067492 */     // GIR_Coverage, 21666,
     /* 1067492 */     GIR_EraseRootFromParent_Done,
     /* 1067493 */   // Label 15743: @1067493
     /* 1067493 */   GIM_Try, /*On fail goto*//*Label 15744*/ GIMT_Encode4(1067570), // Rule ID 21667 //
     /* 1067498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1067501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1067509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1067512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1067515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1067518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067537 */     // MIs[0] policy
     /* 1067537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067547 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1067550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067569 */     // GIR_Coverage, 21667,
     /* 1067569 */     GIR_EraseRootFromParent_Done,
     /* 1067570 */   // Label 15744: @1067570
     /* 1067570 */   GIM_Try, /*On fail goto*//*Label 15745*/ GIMT_Encode4(1067647), // Rule ID 21670 //
     /* 1067575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1067586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1067589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1067592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067614 */     // MIs[0] policy
     /* 1067614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1067627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067646 */     // GIR_Coverage, 21670,
     /* 1067646 */     GIR_EraseRootFromParent_Done,
     /* 1067647 */   // Label 15745: @1067647
     /* 1067647 */   GIM_Try, /*On fail goto*//*Label 15746*/ GIMT_Encode4(1067724), // Rule ID 21671 //
     /* 1067652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1067655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1067663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1067666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1067669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1067672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067691 */     // MIs[0] policy
     /* 1067691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067701 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1067704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067710 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067720 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067723 */     // GIR_Coverage, 21671,
     /* 1067723 */     GIR_EraseRootFromParent_Done,
     /* 1067724 */   // Label 15746: @1067724
     /* 1067724 */   GIM_Try, /*On fail goto*//*Label 15747*/ GIMT_Encode4(1067801), // Rule ID 21674 //
     /* 1067729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1067740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1067743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067768 */     // MIs[0] policy
     /* 1067768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067778 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1067781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067787 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067797 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067800 */     // GIR_Coverage, 21674,
     /* 1067800 */     GIR_EraseRootFromParent_Done,
     /* 1067801 */   // Label 15747: @1067801
     /* 1067801 */   GIM_Try, /*On fail goto*//*Label 15748*/ GIMT_Encode4(1067878), // Rule ID 21675 //
     /* 1067806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1067809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1067817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1067820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1067823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1067826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067845 */     // MIs[0] policy
     /* 1067845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067855 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1067855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1067858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067877 */     // GIR_Coverage, 21675,
     /* 1067877 */     GIR_EraseRootFromParent_Done,
     /* 1067878 */   // Label 15748: @1067878
     /* 1067878 */   GIM_Try, /*On fail goto*//*Label 15749*/ GIMT_Encode4(1067955), // Rule ID 21678 //
     /* 1067883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1067886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1067894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1067897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1067906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067922 */     // MIs[0] policy
     /* 1067922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1067925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1067932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1067932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1067935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1067937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1067939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1067941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1067943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1067948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1067951 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1067953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1067954 */     // GIR_Coverage, 21678,
     /* 1067954 */     GIR_EraseRootFromParent_Done,
     /* 1067955 */   // Label 15749: @1067955
     /* 1067955 */   GIM_Try, /*On fail goto*//*Label 15750*/ GIMT_Encode4(1068032), // Rule ID 21679 //
     /* 1067960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1067963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1067968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1067971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1067974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1067977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1067980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1067983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1067987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1067991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1067995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1067999 */     // MIs[0] policy
     /* 1067999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068009 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11163:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068018 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068028 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068031 */     // GIR_Coverage, 21679,
     /* 1068031 */     GIR_EraseRootFromParent_Done,
     /* 1068032 */   // Label 15750: @1068032
     /* 1068032 */   GIM_Try, /*On fail goto*//*Label 15751*/ GIMT_Encode4(1068109), // Rule ID 21682 //
     /* 1068037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068076 */     // MIs[0] policy
     /* 1068076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068086 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068095 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068105 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068108 */     // GIR_Coverage, 21682,
     /* 1068108 */     GIR_EraseRootFromParent_Done,
     /* 1068109 */   // Label 15751: @1068109
     /* 1068109 */   GIM_Try, /*On fail goto*//*Label 15752*/ GIMT_Encode4(1068186), // Rule ID 21683 //
     /* 1068114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1068125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1068128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1068131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068153 */     // MIs[0] policy
     /* 1068153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068163 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068172 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068182 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068185 */     // GIR_Coverage, 21683,
     /* 1068185 */     GIR_EraseRootFromParent_Done,
     /* 1068186 */   // Label 15752: @1068186
     /* 1068186 */   GIM_Try, /*On fail goto*//*Label 15753*/ GIMT_Encode4(1068263), // Rule ID 21686 //
     /* 1068191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1068194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068230 */     // MIs[0] policy
     /* 1068230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068240 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068259 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068262 */     // GIR_Coverage, 21686,
     /* 1068262 */     GIR_EraseRootFromParent_Done,
     /* 1068263 */   // Label 15753: @1068263
     /* 1068263 */   GIM_Try, /*On fail goto*//*Label 15754*/ GIMT_Encode4(1068340), // Rule ID 21687 //
     /* 1068268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1068271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1068279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1068282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1068285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1068288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068307 */     // MIs[0] policy
     /* 1068307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068317 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1068320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1068336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068339 */     // GIR_Coverage, 21687,
     /* 1068339 */     GIR_EraseRootFromParent_Done,
     /* 1068340 */   // Label 15754: @1068340
     /* 1068340 */   GIM_Try, /*On fail goto*//*Label 15755*/ GIMT_Encode4(1068417), // Rule ID 21690 //
     /* 1068345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068384 */     // MIs[0] policy
     /* 1068384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068394 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068413 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068416 */     // GIR_Coverage, 21690,
     /* 1068416 */     GIR_EraseRootFromParent_Done,
     /* 1068417 */   // Label 15755: @1068417
     /* 1068417 */   GIM_Try, /*On fail goto*//*Label 15756*/ GIMT_Encode4(1068494), // Rule ID 21691 //
     /* 1068422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1068433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1068436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1068439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1068442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068461 */     // MIs[0] policy
     /* 1068461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1068474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068480 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068490 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068493 */     // GIR_Coverage, 21691,
     /* 1068493 */     GIR_EraseRootFromParent_Done,
     /* 1068494 */   // Label 15756: @1068494
     /* 1068494 */   GIM_Try, /*On fail goto*//*Label 15757*/ GIMT_Encode4(1068571), // Rule ID 21694 //
     /* 1068499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1068510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1068513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1068516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068538 */     // MIs[0] policy
     /* 1068538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068548 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068557 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068567 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068570 */     // GIR_Coverage, 21694,
     /* 1068570 */     GIR_EraseRootFromParent_Done,
     /* 1068571 */   // Label 15757: @1068571
     /* 1068571 */   GIM_Try, /*On fail goto*//*Label 15758*/ GIMT_Encode4(1068648), // Rule ID 21695 //
     /* 1068576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1068587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1068590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1068593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1068596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068615 */     // MIs[0] policy
     /* 1068615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068625 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1068628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068634 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068644 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068647 */     // GIR_Coverage, 21695,
     /* 1068647 */     GIR_EraseRootFromParent_Done,
     /* 1068648 */   // Label 15758: @1068648
     /* 1068648 */   GIM_Try, /*On fail goto*//*Label 15759*/ GIMT_Encode4(1068725), // Rule ID 21698 //
     /* 1068653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1068664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1068667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1068670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068692 */     // MIs[0] policy
     /* 1068692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068721 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068724 */     // GIR_Coverage, 21698,
     /* 1068724 */     GIR_EraseRootFromParent_Done,
     /* 1068725 */   // Label 15759: @1068725
     /* 1068725 */   GIM_Try, /*On fail goto*//*Label 15760*/ GIMT_Encode4(1068802), // Rule ID 21699 //
     /* 1068730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1068741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1068744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1068747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1068750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1068757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1068761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068769 */     // MIs[0] policy
     /* 1068769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068779 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11163:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1068782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068788 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068798 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068801 */     // GIR_Coverage, 21699,
     /* 1068801 */     GIR_EraseRootFromParent_Done,
     /* 1068802 */   // Label 15760: @1068802
     /* 1068802 */   GIM_Try, /*On fail goto*//*Label 15761*/ GIMT_Encode4(1068879), // Rule ID 21702 //
     /* 1068807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1068818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1068821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068846 */     // MIs[0] policy
     /* 1068846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1068856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068875 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068878 */     // GIR_Coverage, 21702,
     /* 1068878 */     GIR_EraseRootFromParent_Done,
     /* 1068879 */   // Label 15761: @1068879
     /* 1068879 */   GIM_Try, /*On fail goto*//*Label 15762*/ GIMT_Encode4(1068956), // Rule ID 21703 //
     /* 1068884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1068887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1068895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1068898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1068901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1068904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1068907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1068911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1068915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1068923 */     // MIs[0] policy
     /* 1068923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1068926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1068933 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1068933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1068936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1068938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1068940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1068942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1068944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1068949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1068952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1068954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1068955 */     // GIR_Coverage, 21703,
     /* 1068955 */     GIR_EraseRootFromParent_Done,
     /* 1068956 */   // Label 15762: @1068956
     /* 1068956 */   GIM_Try, /*On fail goto*//*Label 15763*/ GIMT_Encode4(1069033), // Rule ID 21706 //
     /* 1068961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1068964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1068969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1068972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1068975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1068978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1068981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1068984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1068988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1068992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1068996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069000 */     // MIs[0] policy
     /* 1069000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069029 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069032 */     // GIR_Coverage, 21706,
     /* 1069032 */     GIR_EraseRootFromParent_Done,
     /* 1069033 */   // Label 15763: @1069033
     /* 1069033 */   GIM_Try, /*On fail goto*//*Label 15764*/ GIMT_Encode4(1069110), // Rule ID 21707 //
     /* 1069038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1069041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1069049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1069052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1069055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1069058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069077 */     // MIs[0] policy
     /* 1069077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069096 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069106 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069109 */     // GIR_Coverage, 21707,
     /* 1069109 */     GIR_EraseRootFromParent_Done,
     /* 1069110 */   // Label 15764: @1069110
     /* 1069110 */   GIM_Try, /*On fail goto*//*Label 15765*/ GIMT_Encode4(1069187), // Rule ID 21710 //
     /* 1069115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069154 */     // MIs[0] policy
     /* 1069154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069164 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069183 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069186 */     // GIR_Coverage, 21710,
     /* 1069186 */     GIR_EraseRootFromParent_Done,
     /* 1069187 */   // Label 15765: @1069187
     /* 1069187 */   GIM_Try, /*On fail goto*//*Label 15766*/ GIMT_Encode4(1069264), // Rule ID 21711 //
     /* 1069192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1069203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1069206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1069209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069231 */     // MIs[0] policy
     /* 1069231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069241 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1069244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069250 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069260 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069263 */     // GIR_Coverage, 21711,
     /* 1069263 */     GIR_EraseRootFromParent_Done,
     /* 1069264 */   // Label 15766: @1069264
     /* 1069264 */   GIM_Try, /*On fail goto*//*Label 15767*/ GIMT_Encode4(1069341), // Rule ID 21714 //
     /* 1069269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069308 */     // MIs[0] policy
     /* 1069308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069327 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069337 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069340 */     // GIR_Coverage, 21714,
     /* 1069340 */     GIR_EraseRootFromParent_Done,
     /* 1069341 */   // Label 15767: @1069341
     /* 1069341 */   GIM_Try, /*On fail goto*//*Label 15768*/ GIMT_Encode4(1069418), // Rule ID 21715 //
     /* 1069346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1069357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1069360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1069363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069385 */     // MIs[0] policy
     /* 1069385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069395 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11163:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1069398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069404 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069414 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069417 */     // GIR_Coverage, 21715,
     /* 1069417 */     GIR_EraseRootFromParent_Done,
     /* 1069418 */   // Label 15768: @1069418
     /* 1069418 */   GIM_Try, /*On fail goto*//*Label 15769*/ GIMT_Encode4(1069495), // Rule ID 21718 //
     /* 1069423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1069434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1069437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1069440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069462 */     // MIs[0] policy
     /* 1069462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069472 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069494 */     // GIR_Coverage, 21718,
     /* 1069494 */     GIR_EraseRootFromParent_Done,
     /* 1069495 */   // Label 15769: @1069495
     /* 1069495 */   GIM_Try, /*On fail goto*//*Label 15770*/ GIMT_Encode4(1069572), // Rule ID 21719 //
     /* 1069500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1069511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1069514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1069517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1069520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1069527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1069531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069539 */     // MIs[0] policy
     /* 1069539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11163:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1069552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069571 */     // GIR_Coverage, 21719,
     /* 1069571 */     GIR_EraseRootFromParent_Done,
     /* 1069572 */   // Label 15770: @1069572
     /* 1069572 */   GIM_Try, /*On fail goto*//*Label 15771*/ GIMT_Encode4(1069649), // Rule ID 21722 //
     /* 1069577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1069580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1069588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1069591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1069594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069616 */     // MIs[0] policy
     /* 1069616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069635 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069645 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069648 */     // GIR_Coverage, 21722,
     /* 1069648 */     GIR_EraseRootFromParent_Done,
     /* 1069649 */   // Label 15771: @1069649
     /* 1069649 */   GIM_Try, /*On fail goto*//*Label 15772*/ GIMT_Encode4(1069726), // Rule ID 21723 //
     /* 1069654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1069657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rtz_x_f_w_mask),
     /* 1069662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1069665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1069668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1069671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1069674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1069681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1069685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1069689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069693 */     // MIs[0] policy
     /* 1069693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069703 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11163:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1069706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069712 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1069722 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069725 */     // GIR_Coverage, 21723,
     /* 1069725 */     GIR_EraseRootFromParent_Done,
     /* 1069726 */   // Label 15772: @1069726
     /* 1069726 */   GIM_Try, /*On fail goto*//*Label 15773*/ GIMT_Encode4(1069803), // Rule ID 21834 //
     /* 1069731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1069734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1069739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069770 */     // MIs[0] policy
     /* 1069770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069780 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1069783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069799 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069802 */     // GIR_Coverage, 21834,
     /* 1069802 */     GIR_EraseRootFromParent_Done,
     /* 1069803 */   // Label 15773: @1069803
     /* 1069803 */   GIM_Try, /*On fail goto*//*Label 15774*/ GIMT_Encode4(1069880), // Rule ID 21835 //
     /* 1069808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1069811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1069816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1069819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1069822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1069825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1069828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069847 */     // MIs[0] policy
     /* 1069847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1069857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF4_E16_MASK),
     /* 1069860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069866 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069876 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069879 */     // GIR_Coverage, 21835,
     /* 1069879 */     GIR_EraseRootFromParent_Done,
     /* 1069880 */   // Label 15774: @1069880
     /* 1069880 */   GIM_Try, /*On fail goto*//*Label 15775*/ GIMT_Encode4(1069957), // Rule ID 21838 //
     /* 1069885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1069888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1069893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1069908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1069924 */     // MIs[0] policy
     /* 1069924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1069927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1069934 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1069934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1069937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1069939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1069941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1069943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1069945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1069950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1069953 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1069955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1069956 */     // GIR_Coverage, 21838,
     /* 1069956 */     GIR_EraseRootFromParent_Done,
     /* 1069957 */   // Label 15775: @1069957
     /* 1069957 */   GIM_Try, /*On fail goto*//*Label 15776*/ GIMT_Encode4(1070034), // Rule ID 21839 //
     /* 1069962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1069965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1069970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1069973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1069976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1069979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1069982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1069985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1069989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1069997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070001 */     // MIs[0] policy
     /* 1070001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070011 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E16_MASK),
     /* 1070014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070020 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070030 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070033 */     // GIR_Coverage, 21839,
     /* 1070033 */     GIR_EraseRootFromParent_Done,
     /* 1070034 */   // Label 15776: @1070034
     /* 1070034 */   GIM_Try, /*On fail goto*//*Label 15777*/ GIMT_Encode4(1070111), // Rule ID 21842 //
     /* 1070039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070078 */     // MIs[0] policy
     /* 1070078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070088 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070107 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070110 */     // GIR_Coverage, 21842,
     /* 1070110 */     GIR_EraseRootFromParent_Done,
     /* 1070111 */   // Label 15777: @1070111
     /* 1070111 */   GIM_Try, /*On fail goto*//*Label 15778*/ GIMT_Encode4(1070188), // Rule ID 21843 //
     /* 1070116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1070127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1070130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1070133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070155 */     // MIs[0] policy
     /* 1070155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070165 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11161:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E16_MASK),
     /* 1070168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070174 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070184 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070187 */     // GIR_Coverage, 21843,
     /* 1070187 */     GIR_EraseRootFromParent_Done,
     /* 1070188 */   // Label 15778: @1070188
     /* 1070188 */   GIM_Try, /*On fail goto*//*Label 15779*/ GIMT_Encode4(1070265), // Rule ID 21846 //
     /* 1070193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070232 */     // MIs[0] policy
     /* 1070232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070242 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070264 */     // GIR_Coverage, 21846,
     /* 1070264 */     GIR_EraseRootFromParent_Done,
     /* 1070265 */   // Label 15779: @1070265
     /* 1070265 */   GIM_Try, /*On fail goto*//*Label 15780*/ GIMT_Encode4(1070342), // Rule ID 21847 //
     /* 1070270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1070281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1070284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1070287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070309 */     // MIs[0] policy
     /* 1070309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070319 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E16_MASK),
     /* 1070322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070341 */     // GIR_Coverage, 21847,
     /* 1070341 */     GIR_EraseRootFromParent_Done,
     /* 1070342 */   // Label 15780: @1070342
     /* 1070342 */   GIM_Try, /*On fail goto*//*Label 15781*/ GIMT_Encode4(1070419), // Rule ID 21850 //
     /* 1070347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1070350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070386 */     // MIs[0] policy
     /* 1070386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070396 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070418 */     // GIR_Coverage, 21850,
     /* 1070418 */     GIR_EraseRootFromParent_Done,
     /* 1070419 */   // Label 15781: @1070419
     /* 1070419 */   GIM_Try, /*On fail goto*//*Label 15782*/ GIMT_Encode4(1070496), // Rule ID 21851 //
     /* 1070424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1070427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1070435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1070438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1070441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1070444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070463 */     // MIs[0] policy
     /* 1070463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070473 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E16_MASK),
     /* 1070476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1070492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070495 */     // GIR_Coverage, 21851,
     /* 1070495 */     GIR_EraseRootFromParent_Done,
     /* 1070496 */   // Label 15782: @1070496
     /* 1070496 */   GIM_Try, /*On fail goto*//*Label 15783*/ GIMT_Encode4(1070573), // Rule ID 21854 //
     /* 1070501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1070504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070540 */     // MIs[0] policy
     /* 1070540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070550 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1070553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070569 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070572 */     // GIR_Coverage, 21854,
     /* 1070572 */     GIR_EraseRootFromParent_Done,
     /* 1070573 */   // Label 15783: @1070573
     /* 1070573 */   GIM_Try, /*On fail goto*//*Label 15784*/ GIMT_Encode4(1070650), // Rule ID 21855 //
     /* 1070578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1070581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1070589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1070592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1070595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1070598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070617 */     // MIs[0] policy
     /* 1070617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070627 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_MF2_E32_MASK),
     /* 1070630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070636 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070646 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070649 */     // GIR_Coverage, 21855,
     /* 1070649 */     GIR_EraseRootFromParent_Done,
     /* 1070650 */   // Label 15784: @1070650
     /* 1070650 */   GIM_Try, /*On fail goto*//*Label 15785*/ GIMT_Encode4(1070727), // Rule ID 21858 //
     /* 1070655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1070658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070694 */     // MIs[0] policy
     /* 1070694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1070707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070723 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070726 */     // GIR_Coverage, 21858,
     /* 1070726 */     GIR_EraseRootFromParent_Done,
     /* 1070727 */   // Label 15785: @1070727
     /* 1070727 */   GIM_Try, /*On fail goto*//*Label 15786*/ GIMT_Encode4(1070804), // Rule ID 21859 //
     /* 1070732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1070735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1070743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1070746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1070749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1070752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1070759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1070763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070771 */     // MIs[0] policy
     /* 1070771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070781 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11161:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M1_E32_MASK),
     /* 1070784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070790 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070800 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070803 */     // GIR_Coverage, 21859,
     /* 1070803 */     GIR_EraseRootFromParent_Done,
     /* 1070804 */   // Label 15786: @1070804
     /* 1070804 */   GIM_Try, /*On fail goto*//*Label 15787*/ GIMT_Encode4(1070881), // Rule ID 21862 //
     /* 1070809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1070812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070848 */     // MIs[0] policy
     /* 1070848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070858 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1070858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1070861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070867 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070877 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070880 */     // GIR_Coverage, 21862,
     /* 1070880 */     GIR_EraseRootFromParent_Done,
     /* 1070881 */   // Label 15787: @1070881
     /* 1070881 */   GIM_Try, /*On fail goto*//*Label 15788*/ GIMT_Encode4(1070958), // Rule ID 21863 //
     /* 1070886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1070889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1070897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1070900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1070903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1070906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1070909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1070913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1070917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1070925 */     // MIs[0] policy
     /* 1070925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1070928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1070935 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11161:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1070935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M2_E32_MASK),
     /* 1070938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1070940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1070942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1070944 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1070946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1070951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1070954 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1070956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1070957 */     // GIR_Coverage, 21863,
     /* 1070957 */     GIR_EraseRootFromParent_Done,
     /* 1070958 */   // Label 15788: @1070958
     /* 1070958 */   GIM_Try, /*On fail goto*//*Label 15789*/ GIMT_Encode4(1071035), // Rule ID 21866 //
     /* 1070963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1070966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1070971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1070974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1070977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1070980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1070983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1070986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1070990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1070994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1070998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071002 */     // MIs[0] policy
     /* 1071002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071012 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071031 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071034 */     // GIR_Coverage, 21866,
     /* 1071034 */     GIR_EraseRootFromParent_Done,
     /* 1071035 */   // Label 15789: @1071035
     /* 1071035 */   GIM_Try, /*On fail goto*//*Label 15790*/ GIMT_Encode4(1071112), // Rule ID 21867 //
     /* 1071040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1071043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_rod_f_f_w_mask),
     /* 1071048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1071051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1071054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1071057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1071067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1071071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1071075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071079 */     // MIs[0] policy
     /* 1071079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071089 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11161:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_ROD_F_F_W_M4_E32_MASK),
     /* 1071092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071098 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071108 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071110 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071111 */     // GIR_Coverage, 21867,
     /* 1071111 */     GIR_EraseRootFromParent_Done,
     /* 1071112 */   // Label 15790: @1071112
     /* 1071112 */   GIM_Try, /*On fail goto*//*Label 15791*/ GIMT_Encode4(1071189), // Rule ID 23306 //
     /* 1071117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071156 */     // MIs[0] policy
     /* 1071156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071166 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071175 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071185 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071188 */     // GIR_Coverage, 23306,
     /* 1071188 */     GIR_EraseRootFromParent_Done,
     /* 1071189 */   // Label 15791: @1071189
     /* 1071189 */   GIM_Try, /*On fail goto*//*Label 15792*/ GIMT_Encode4(1071266), // Rule ID 23307 //
     /* 1071194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1071205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1071208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071233 */     // MIs[0] policy
     /* 1071233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071243 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071252 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071262 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071265 */     // GIR_Coverage, 23307,
     /* 1071265 */     GIR_EraseRootFromParent_Done,
     /* 1071266 */   // Label 15792: @1071266
     /* 1071266 */   GIM_Try, /*On fail goto*//*Label 15793*/ GIMT_Encode4(1071343), // Rule ID 23310 //
     /* 1071271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071310 */     // MIs[0] policy
     /* 1071310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071339 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071342 */     // GIR_Coverage, 23310,
     /* 1071342 */     GIR_EraseRootFromParent_Done,
     /* 1071343 */   // Label 15793: @1071343
     /* 1071343 */   GIM_Try, /*On fail goto*//*Label 15794*/ GIMT_Encode4(1071420), // Rule ID 23311 //
     /* 1071348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1071359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1071362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1071365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1071368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071387 */     // MIs[0] policy
     /* 1071387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071397 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071419 */     // GIR_Coverage, 23311,
     /* 1071419 */     GIR_EraseRootFromParent_Done,
     /* 1071420 */   // Label 15794: @1071420
     /* 1071420 */   GIM_Try, /*On fail goto*//*Label 15795*/ GIMT_Encode4(1071497), // Rule ID 23314 //
     /* 1071425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1071436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1071439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071464 */     // MIs[0] policy
     /* 1071464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071496 */     // GIR_Coverage, 23314,
     /* 1071496 */     GIR_EraseRootFromParent_Done,
     /* 1071497 */   // Label 15795: @1071497
     /* 1071497 */   GIM_Try, /*On fail goto*//*Label 15796*/ GIMT_Encode4(1071574), // Rule ID 23315 //
     /* 1071502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1071513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1071516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071541 */     // MIs[0] policy
     /* 1071541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071551 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF4_MASK),
     /* 1071554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071560 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071570 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071573 */     // GIR_Coverage, 23315,
     /* 1071573 */     GIR_EraseRootFromParent_Done,
     /* 1071574 */   // Label 15796: @1071574
     /* 1071574 */   GIM_Try, /*On fail goto*//*Label 15797*/ GIMT_Encode4(1071651), // Rule ID 23318 //
     /* 1071579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1071590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1071593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071618 */     // MIs[0] policy
     /* 1071618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071628 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071650 */     // GIR_Coverage, 23318,
     /* 1071650 */     GIR_EraseRootFromParent_Done,
     /* 1071651 */   // Label 15797: @1071651
     /* 1071651 */   GIM_Try, /*On fail goto*//*Label 15798*/ GIMT_Encode4(1071728), // Rule ID 23319 //
     /* 1071656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1071667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1071670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1071673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1071676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071695 */     // MIs[0] policy
     /* 1071695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071705 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071714 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1071724 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071727 */     // GIR_Coverage, 23319,
     /* 1071727 */     GIR_EraseRootFromParent_Done,
     /* 1071728 */   // Label 15798: @1071728
     /* 1071728 */   GIM_Try, /*On fail goto*//*Label 15799*/ GIMT_Encode4(1071805), // Rule ID 23322 //
     /* 1071733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071772 */     // MIs[0] policy
     /* 1071772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071801 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071804 */     // GIR_Coverage, 23322,
     /* 1071804 */     GIR_EraseRootFromParent_Done,
     /* 1071805 */   // Label 15799: @1071805
     /* 1071805 */   GIM_Try, /*On fail goto*//*Label 15800*/ GIMT_Encode4(1071882), // Rule ID 23323 //
     /* 1071810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1071821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1071824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1071827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1071830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071849 */     // MIs[0] policy
     /* 1071849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071859 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1071859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_MF2_MASK),
     /* 1071862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071868 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1071878 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071881 */     // GIR_Coverage, 23323,
     /* 1071881 */     GIR_EraseRootFromParent_Done,
     /* 1071882 */   // Label 15800: @1071882
     /* 1071882 */   GIM_Try, /*On fail goto*//*Label 15801*/ GIMT_Encode4(1071959), // Rule ID 23326 //
     /* 1071887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1071890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1071898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1071901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1071904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1071910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1071926 */     // MIs[0] policy
     /* 1071926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1071929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1071936 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1071936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1071939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1071941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1071943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1071945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1071947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1071952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1071955 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1071957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1071958 */     // GIR_Coverage, 23326,
     /* 1071958 */     GIR_EraseRootFromParent_Done,
     /* 1071959 */   // Label 15801: @1071959
     /* 1071959 */   GIM_Try, /*On fail goto*//*Label 15802*/ GIMT_Encode4(1072036), // Rule ID 23327 //
     /* 1071964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1071967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1071972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1071975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1071978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1071981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1071984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1071987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1071991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1071999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072003 */     // MIs[0] policy
     /* 1072003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072013 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11255:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072022 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072032 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072035 */     // GIR_Coverage, 23327,
     /* 1072035 */     GIR_EraseRootFromParent_Done,
     /* 1072036 */   // Label 15802: @1072036
     /* 1072036 */   GIM_Try, /*On fail goto*//*Label 15803*/ GIMT_Encode4(1072113), // Rule ID 23330 //
     /* 1072041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072080 */     // MIs[0] policy
     /* 1072080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072090 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072112 */     // GIR_Coverage, 23330,
     /* 1072112 */     GIR_EraseRootFromParent_Done,
     /* 1072113 */   // Label 15803: @1072113
     /* 1072113 */   GIM_Try, /*On fail goto*//*Label 15804*/ GIMT_Encode4(1072190), // Rule ID 23331 //
     /* 1072118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1072129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1072132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1072135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1072138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072157 */     // MIs[0] policy
     /* 1072157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072167 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11255:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1072186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072189 */     // GIR_Coverage, 23331,
     /* 1072189 */     GIR_EraseRootFromParent_Done,
     /* 1072190 */   // Label 15804: @1072190
     /* 1072190 */   GIM_Try, /*On fail goto*//*Label 15805*/ GIMT_Encode4(1072267), // Rule ID 23334 //
     /* 1072195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072234 */     // MIs[0] policy
     /* 1072234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072263 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072266 */     // GIR_Coverage, 23334,
     /* 1072266 */     GIR_EraseRootFromParent_Done,
     /* 1072267 */   // Label 15805: @1072267
     /* 1072267 */   GIM_Try, /*On fail goto*//*Label 15806*/ GIMT_Encode4(1072344), // Rule ID 23335 //
     /* 1072272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1072283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1072286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1072289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1072292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072311 */     // MIs[0] policy
     /* 1072311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072321 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11255:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072330 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1072340 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072343 */     // GIR_Coverage, 23335,
     /* 1072343 */     GIR_EraseRootFromParent_Done,
     /* 1072344 */   // Label 15806: @1072344
     /* 1072344 */   GIM_Try, /*On fail goto*//*Label 15807*/ GIMT_Encode4(1072421), // Rule ID 23338 //
     /* 1072349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1072352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072388 */     // MIs[0] policy
     /* 1072388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072398 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072407 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072417 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072420 */     // GIR_Coverage, 23338,
     /* 1072420 */     GIR_EraseRootFromParent_Done,
     /* 1072421 */   // Label 15807: @1072421
     /* 1072421 */   GIM_Try, /*On fail goto*//*Label 15808*/ GIMT_Encode4(1072498), // Rule ID 23339 //
     /* 1072426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1072429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1072437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1072440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 1072443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1072446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1072453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072465 */     // MIs[0] policy
     /* 1072465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072475 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11255:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i1] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M1_MASK),
     /* 1072478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072484 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1072494 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072497 */     // GIR_Coverage, 23339,
     /* 1072497 */     GIR_EraseRootFromParent_Done,
     /* 1072498 */   // Label 15808: @1072498
     /* 1072498 */   GIM_Try, /*On fail goto*//*Label 15809*/ GIMT_Encode4(1072575), // Rule ID 23342 //
     /* 1072503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1072520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072542 */     // MIs[0] policy
     /* 1072542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1072555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072571 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072574 */     // GIR_Coverage, 23342,
     /* 1072574 */     GIR_EraseRootFromParent_Done,
     /* 1072575 */   // Label 15809: @1072575
     /* 1072575 */   GIM_Try, /*On fail goto*//*Label 15810*/ GIMT_Encode4(1072652), // Rule ID 23343 //
     /* 1072580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1072591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1072594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1072597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1072600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072619 */     // MIs[0] policy
     /* 1072619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072629 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1072632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072638 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072648 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072651 */     // GIR_Coverage, 23343,
     /* 1072651 */     GIR_EraseRootFromParent_Done,
     /* 1072652 */   // Label 15810: @1072652
     /* 1072652 */   GIM_Try, /*On fail goto*//*Label 15811*/ GIMT_Encode4(1072729), // Rule ID 23346 //
     /* 1072657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1072674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072696 */     // MIs[0] policy
     /* 1072696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1072709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072725 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072728 */     // GIR_Coverage, 23346,
     /* 1072728 */     GIR_EraseRootFromParent_Done,
     /* 1072729 */   // Label 15811: @1072729
     /* 1072729 */   GIM_Try, /*On fail goto*//*Label 15812*/ GIMT_Encode4(1072806), // Rule ID 23347 //
     /* 1072734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1072745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1072748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1072751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1072754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1072761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1072765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072773 */     // MIs[0] policy
     /* 1072773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072783 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1072786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072805 */     // GIR_Coverage, 23347,
     /* 1072805 */     GIR_EraseRootFromParent_Done,
     /* 1072806 */   // Label 15812: @1072806
     /* 1072806 */   GIM_Try, /*On fail goto*//*Label 15813*/ GIMT_Encode4(1072883), // Rule ID 23350 //
     /* 1072811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1072822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1072825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1072828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1072831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1072838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072850 */     // MIs[0] policy
     /* 1072850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072860 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1072860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1072863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072869 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072879 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072882 */     // GIR_Coverage, 23350,
     /* 1072882 */     GIR_EraseRootFromParent_Done,
     /* 1072883 */   // Label 15813: @1072883
     /* 1072883 */   GIM_Try, /*On fail goto*//*Label 15814*/ GIMT_Encode4(1072960), // Rule ID 23351 //
     /* 1072888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1072891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1072899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1072902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s1,
     /* 1072905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1072908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1072911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1072915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1072919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1072923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1072927 */     // MIs[0] policy
     /* 1072927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1072930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1072937 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VR:{ *:[nxv64i1] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1072937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1072940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1072942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1072944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1072946 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1072948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1072953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1072956 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1072958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1072959 */     // GIR_Coverage, 23351,
     /* 1072959 */     GIR_EraseRootFromParent_Done,
     /* 1072960 */   // Label 15814: @1072960
     /* 1072960 */   GIM_Try, /*On fail goto*//*Label 15815*/ GIMT_Encode4(1073037), // Rule ID 23354 //
     /* 1072965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1072968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1072973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1072976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1072979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1072982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1072985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1072988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1072992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1072996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073004 */     // MIs[0] policy
     /* 1073004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073014 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073036 */     // GIR_Coverage, 23354,
     /* 1073036 */     GIR_EraseRootFromParent_Done,
     /* 1073037 */   // Label 15815: @1073037
     /* 1073037 */   GIM_Try, /*On fail goto*//*Label 15816*/ GIMT_Encode4(1073114), // Rule ID 23355 //
     /* 1073042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1073053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1073056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073081 */     // MIs[0] policy
     /* 1073081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073113 */     // GIR_Coverage, 23355,
     /* 1073113 */     GIR_EraseRootFromParent_Done,
     /* 1073114 */   // Label 15816: @1073114
     /* 1073114 */   GIM_Try, /*On fail goto*//*Label 15817*/ GIMT_Encode4(1073191), // Rule ID 23358 //
     /* 1073119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073158 */     // MIs[0] policy
     /* 1073158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073168 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073187 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073190 */     // GIR_Coverage, 23358,
     /* 1073190 */     GIR_EraseRootFromParent_Done,
     /* 1073191 */   // Label 15817: @1073191
     /* 1073191 */   GIM_Try, /*On fail goto*//*Label 15818*/ GIMT_Encode4(1073268), // Rule ID 23359 //
     /* 1073196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1073207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1073210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073235 */     // MIs[0] policy
     /* 1073235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073245 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073254 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073264 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073267 */     // GIR_Coverage, 23359,
     /* 1073267 */     GIR_EraseRootFromParent_Done,
     /* 1073268 */   // Label 15818: @1073268
     /* 1073268 */   GIM_Try, /*On fail goto*//*Label 15819*/ GIMT_Encode4(1073345), // Rule ID 23362 //
     /* 1073273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073312 */     // MIs[0] policy
     /* 1073312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073322 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073344 */     // GIR_Coverage, 23362,
     /* 1073344 */     GIR_EraseRootFromParent_Done,
     /* 1073345 */   // Label 15819: @1073345
     /* 1073345 */   GIM_Try, /*On fail goto*//*Label 15820*/ GIMT_Encode4(1073422), // Rule ID 23363 //
     /* 1073350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1073361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1073364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s1,
     /* 1073367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1073370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073389 */     // MIs[0] policy
     /* 1073389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073399 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VR:{ *:[nxv32i1] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1073418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073421 */     // GIR_Coverage, 23363,
     /* 1073421 */     GIR_EraseRootFromParent_Done,
     /* 1073422 */   // Label 15820: @1073422
     /* 1073422 */   GIM_Try, /*On fail goto*//*Label 15821*/ GIMT_Encode4(1073499), // Rule ID 23366 //
     /* 1073427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073466 */     // MIs[0] policy
     /* 1073466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073476 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073495 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073498 */     // GIR_Coverage, 23366,
     /* 1073498 */     GIR_EraseRootFromParent_Done,
     /* 1073499 */   // Label 15821: @1073499
     /* 1073499 */   GIM_Try, /*On fail goto*//*Label 15822*/ GIMT_Encode4(1073576), // Rule ID 23367 //
     /* 1073504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1073515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1073518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1073521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1073524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073543 */     // MIs[0] policy
     /* 1073543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073553 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073574 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073575 */     // GIR_Coverage, 23367,
     /* 1073575 */     GIR_EraseRootFromParent_Done,
     /* 1073576 */   // Label 15822: @1073576
     /* 1073576 */   GIM_Try, /*On fail goto*//*Label 15823*/ GIMT_Encode4(1073653), // Rule ID 23370 //
     /* 1073581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1073592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1073595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073620 */     // MIs[0] policy
     /* 1073620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073639 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073649 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073652 */     // GIR_Coverage, 23370,
     /* 1073652 */     GIR_EraseRootFromParent_Done,
     /* 1073653 */   // Label 15823: @1073653
     /* 1073653 */   GIM_Try, /*On fail goto*//*Label 15824*/ GIMT_Encode4(1073730), // Rule ID 23371 //
     /* 1073658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1073669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1073672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1073675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1073678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1073685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1073689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073697 */     // MIs[0] policy
     /* 1073697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073707 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1073710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073716 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073726 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073729 */     // GIR_Coverage, 23371,
     /* 1073729 */     GIR_EraseRootFromParent_Done,
     /* 1073730 */   // Label 15824: @1073730
     /* 1073730 */   GIM_Try, /*On fail goto*//*Label 15825*/ GIMT_Encode4(1073807), // Rule ID 23374 //
     /* 1073735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1073738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1073746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1073749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073774 */     // MIs[0] policy
     /* 1073774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073784 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073803 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073806 */     // GIR_Coverage, 23374,
     /* 1073806 */     GIR_EraseRootFromParent_Done,
     /* 1073807 */   // Label 15825: @1073807
     /* 1073807 */   GIM_Try, /*On fail goto*//*Label 15826*/ GIMT_Encode4(1073884), // Rule ID 23375 //
     /* 1073812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1073815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1073823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1073826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 1073829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1073832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1073839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1073843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073851 */     // MIs[0] policy
     /* 1073851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073861 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VR:{ *:[nxv16i1] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1073861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1073864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073870 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1073880 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073883 */     // GIR_Coverage, 23375,
     /* 1073883 */     GIR_EraseRootFromParent_Done,
     /* 1073884 */   // Label 15826: @1073884
     /* 1073884 */   GIM_Try, /*On fail goto*//*Label 15827*/ GIMT_Encode4(1073961), // Rule ID 23378 //
     /* 1073889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1073892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1073900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1073903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1073912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1073924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1073928 */     // MIs[0] policy
     /* 1073928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1073931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1073938 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1073938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1073941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1073943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1073945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1073947 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1073949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1073954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1073957 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1073959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1073960 */     // GIR_Coverage, 23378,
     /* 1073960 */     GIR_EraseRootFromParent_Done,
     /* 1073961 */   // Label 15827: @1073961
     /* 1073961 */   GIM_Try, /*On fail goto*//*Label 15828*/ GIMT_Encode4(1074038), // Rule ID 23379 //
     /* 1073966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1073969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1073974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1073977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1073980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 1073983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1073986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1073989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1073993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1073997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074005 */     // MIs[0] policy
     /* 1074005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11255:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i1] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M2_MASK),
     /* 1074018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074024 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074034 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074037 */     // GIR_Coverage, 23379,
     /* 1074037 */     GIR_EraseRootFromParent_Done,
     /* 1074038 */   // Label 15828: @1074038
     /* 1074038 */   GIM_Try, /*On fail goto*//*Label 15829*/ GIMT_Encode4(1074115), // Rule ID 23382 //
     /* 1074043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074082 */     // MIs[0] policy
     /* 1074082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074111 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074114 */     // GIR_Coverage, 23382,
     /* 1074114 */     GIR_EraseRootFromParent_Done,
     /* 1074115 */   // Label 15829: @1074115
     /* 1074115 */   GIM_Try, /*On fail goto*//*Label 15830*/ GIMT_Encode4(1074192), // Rule ID 23383 //
     /* 1074120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1074131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1074134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 1074137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1074140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1074147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1074151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074159 */     // MIs[0] policy
     /* 1074159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074169 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11255:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VR:{ *:[nxv4i1] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M4_MASK),
     /* 1074172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074178 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074188 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074191 */     // GIR_Coverage, 23383,
     /* 1074191 */     GIR_EraseRootFromParent_Done,
     /* 1074192 */   // Label 15830: @1074192
     /* 1074192 */   GIM_Try, /*On fail goto*//*Label 15831*/ GIMT_Encode4(1074269), // Rule ID 23386 //
     /* 1074197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1074200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074236 */     // MIs[0] policy
     /* 1074236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074268 */     // GIR_Coverage, 23386,
     /* 1074268 */     GIR_EraseRootFromParent_Done,
     /* 1074269 */   // Label 15831: @1074269
     /* 1074269 */   GIM_Try, /*On fail goto*//*Label 15832*/ GIMT_Encode4(1074346), // Rule ID 23387 //
     /* 1074274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1074277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_viota_mask),
     /* 1074282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1074285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1074288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 1074291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1074294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1074301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1074305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1074313 */     // MIs[0] policy
     /* 1074313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074323 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11255:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVIOTA_M_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VR:{ *:[nxv8i1] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVIOTA_M_M8_MASK),
     /* 1074326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1074330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1074332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1074334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1074342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074345 */     // GIR_Coverage, 23387,
     /* 1074345 */     GIR_EraseRootFromParent_Done,
     /* 1074346 */   // Label 15832: @1074346
     /* 1074346 */   GIM_Try, /*On fail goto*//*Label 15833*/ GIMT_Encode4(1074423), // Rule ID 23492 //
     /* 1074351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074390 */     // MIs[0] policy
     /* 1074390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074400 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1074403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074422 */     // GIR_Coverage, 23492,
     /* 1074422 */     GIR_EraseRootFromParent_Done,
     /* 1074423 */   // Label 15833: @1074423
     /* 1074423 */   GIM_Try, /*On fail goto*//*Label 15834*/ GIMT_Encode4(1074500), // Rule ID 23493 //
     /* 1074428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1074439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1074442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1074445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074467 */     // MIs[0] policy
     /* 1074467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074477 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8),
     /* 1074480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074499 */     // GIR_Coverage, 23493,
     /* 1074499 */     GIR_EraseRootFromParent_Done,
     /* 1074500 */   // Label 15834: @1074500
     /* 1074500 */   GIM_Try, /*On fail goto*//*Label 15835*/ GIMT_Encode4(1074577), // Rule ID 23496 //
     /* 1074505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1074516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1074519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1074522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074544 */     // MIs[0] policy
     /* 1074544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1074557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074573 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074576 */     // GIR_Coverage, 23496,
     /* 1074576 */     GIR_EraseRootFromParent_Done,
     /* 1074577 */   // Label 15835: @1074577
     /* 1074577 */   GIM_Try, /*On fail goto*//*Label 15836*/ GIMT_Encode4(1074654), // Rule ID 23497 //
     /* 1074582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1074593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1074596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1074599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074621 */     // MIs[0] policy
     /* 1074621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074631 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1074634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074650 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074653 */     // GIR_Coverage, 23497,
     /* 1074653 */     GIR_EraseRootFromParent_Done,
     /* 1074654 */   // Label 15836: @1074654
     /* 1074654 */   GIM_Try, /*On fail goto*//*Label 15837*/ GIMT_Encode4(1074731), // Rule ID 23500 //
     /* 1074659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1074670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1074673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1074676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074698 */     // MIs[0] policy
     /* 1074698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1074711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074727 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074730 */     // GIR_Coverage, 23500,
     /* 1074730 */     GIR_EraseRootFromParent_Done,
     /* 1074731 */   // Label 15837: @1074731
     /* 1074731 */   GIM_Try, /*On fail goto*//*Label 15838*/ GIMT_Encode4(1074808), // Rule ID 23501 //
     /* 1074736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1074747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1074750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1074753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074775 */     // MIs[0] policy
     /* 1074775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074785 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1074788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1074804 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074807 */     // GIR_Coverage, 23501,
     /* 1074807 */     GIR_EraseRootFromParent_Done,
     /* 1074808 */   // Label 15838: @1074808
     /* 1074808 */   GIM_Try, /*On fail goto*//*Label 15839*/ GIMT_Encode4(1074885), // Rule ID 23504 //
     /* 1074813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1074830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074852 */     // MIs[0] policy
     /* 1074852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1074862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1074865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074884 */     // GIR_Coverage, 23504,
     /* 1074884 */     GIR_EraseRootFromParent_Done,
     /* 1074885 */   // Label 15839: @1074885
     /* 1074885 */   GIM_Try, /*On fail goto*//*Label 15840*/ GIMT_Encode4(1074962), // Rule ID 23505 //
     /* 1074890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1074893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1074901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1074904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1074907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1074910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1074913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1074929 */     // MIs[0] policy
     /* 1074929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1074932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1074939 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1074939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1074942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1074944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1074946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1074948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1074950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1074955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1074958 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1074960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1074961 */     // GIR_Coverage, 23505,
     /* 1074961 */     GIR_EraseRootFromParent_Done,
     /* 1074962 */   // Label 15840: @1074962
     /* 1074962 */   GIM_Try, /*On fail goto*//*Label 15841*/ GIMT_Encode4(1075039), // Rule ID 23508 //
     /* 1074967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1074970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1074975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1074978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1074981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1074984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1074987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1074990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1074998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075006 */     // MIs[0] policy
     /* 1075006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075035 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075038 */     // GIR_Coverage, 23508,
     /* 1075038 */     GIR_EraseRootFromParent_Done,
     /* 1075039 */   // Label 15841: @1075039
     /* 1075039 */   GIM_Try, /*On fail goto*//*Label 15842*/ GIMT_Encode4(1075116), // Rule ID 23509 //
     /* 1075044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1075055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1075058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1075061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075083 */     // MIs[0] policy
     /* 1075083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075093 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075098 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075112 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075115 */     // GIR_Coverage, 23509,
     /* 1075115 */     GIR_EraseRootFromParent_Done,
     /* 1075116 */   // Label 15842: @1075116
     /* 1075116 */   GIM_Try, /*On fail goto*//*Label 15843*/ GIMT_Encode4(1075193), // Rule ID 23512 //
     /* 1075121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075160 */     // MIs[0] policy
     /* 1075160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075170 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075189 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075192 */     // GIR_Coverage, 23512,
     /* 1075192 */     GIR_EraseRootFromParent_Done,
     /* 1075193 */   // Label 15843: @1075193
     /* 1075193 */   GIM_Try, /*On fail goto*//*Label 15844*/ GIMT_Encode4(1075270), // Rule ID 23513 //
     /* 1075198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1075209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1075212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1075215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075237 */     // MIs[0] policy
     /* 1075237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075247 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1075250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075266 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075269 */     // GIR_Coverage, 23513,
     /* 1075269 */     GIR_EraseRootFromParent_Done,
     /* 1075270 */   // Label 15844: @1075270
     /* 1075270 */   GIM_Try, /*On fail goto*//*Label 15845*/ GIMT_Encode4(1075347), // Rule ID 23516 //
     /* 1075275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075314 */     // MIs[0] policy
     /* 1075314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075346 */     // GIR_Coverage, 23516,
     /* 1075346 */     GIR_EraseRootFromParent_Done,
     /* 1075347 */   // Label 15845: @1075347
     /* 1075347 */   GIM_Try, /*On fail goto*//*Label 15846*/ GIMT_Encode4(1075424), // Rule ID 23517 //
     /* 1075352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1075363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1075366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1075369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075391 */     // MIs[0] policy
     /* 1075391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075401 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11482:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075423 */     // GIR_Coverage, 23517,
     /* 1075423 */     GIR_EraseRootFromParent_Done,
     /* 1075424 */   // Label 15846: @1075424
     /* 1075424 */   GIM_Try, /*On fail goto*//*Label 15847*/ GIMT_Encode4(1075501), // Rule ID 23520 //
     /* 1075429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1075440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1075443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1075446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075468 */     // MIs[0] policy
     /* 1075468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075497 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075500 */     // GIR_Coverage, 23520,
     /* 1075500 */     GIR_EraseRootFromParent_Done,
     /* 1075501 */   // Label 15847: @1075501
     /* 1075501 */   GIM_Try, /*On fail goto*//*Label 15848*/ GIMT_Encode4(1075578), // Rule ID 23521 //
     /* 1075506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1075517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1075520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1075523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075545 */     // MIs[0] policy
     /* 1075545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075555 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1075574 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075577 */     // GIR_Coverage, 23521,
     /* 1075577 */     GIR_EraseRootFromParent_Done,
     /* 1075578 */   // Label 15848: @1075578
     /* 1075578 */   GIM_Try, /*On fail goto*//*Label 15849*/ GIMT_Encode4(1075655), // Rule ID 23524 //
     /* 1075583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1075600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075622 */     // MIs[0] policy
     /* 1075622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075651 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075654 */     // GIR_Coverage, 23524,
     /* 1075654 */     GIR_EraseRootFromParent_Done,
     /* 1075655 */   // Label 15849: @1075655
     /* 1075655 */   GIM_Try, /*On fail goto*//*Label 15850*/ GIMT_Encode4(1075732), // Rule ID 23525 //
     /* 1075660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1075671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1075674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1075677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075699 */     // MIs[0] policy
     /* 1075699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075709 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1075728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075731 */     // GIR_Coverage, 23525,
     /* 1075731 */     GIR_EraseRootFromParent_Done,
     /* 1075732 */   // Label 15850: @1075732
     /* 1075732 */   GIM_Try, /*On fail goto*//*Label 15851*/ GIMT_Encode4(1075809), // Rule ID 23528 //
     /* 1075737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1075740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1075748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1075751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1075754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075776 */     // MIs[0] policy
     /* 1075776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075808 */     // GIR_Coverage, 23528,
     /* 1075808 */     GIR_EraseRootFromParent_Done,
     /* 1075809 */   // Label 15851: @1075809
     /* 1075809 */   GIM_Try, /*On fail goto*//*Label 15852*/ GIMT_Encode4(1075886), // Rule ID 23529 //
     /* 1075814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1075817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1075825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1075828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1075831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1075849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075853 */     // MIs[0] policy
     /* 1075853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075863 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1075863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1075866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1075882 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075885 */     // GIR_Coverage, 23529,
     /* 1075885 */     GIR_EraseRootFromParent_Done,
     /* 1075886 */   // Label 15852: @1075886
     /* 1075886 */   GIM_Try, /*On fail goto*//*Label 15853*/ GIMT_Encode4(1075963), // Rule ID 23532 //
     /* 1075891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1075894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1075902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1075905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1075908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1075911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1075914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1075930 */     // MIs[0] policy
     /* 1075930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1075933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1075940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1075940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1075943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1075945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1075947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1075949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1075951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1075956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1075959 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1075961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1075962 */     // GIR_Coverage, 23532,
     /* 1075962 */     GIR_EraseRootFromParent_Done,
     /* 1075963 */   // Label 15853: @1075963
     /* 1075963 */   GIM_Try, /*On fail goto*//*Label 15854*/ GIMT_Encode4(1076040), // Rule ID 23533 //
     /* 1075968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1075971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1075976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1075979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1075982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1075985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1075988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1075991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1075999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076007 */     // MIs[0] policy
     /* 1076007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076017 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076036 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076039 */     // GIR_Coverage, 23533,
     /* 1076039 */     GIR_EraseRootFromParent_Done,
     /* 1076040 */   // Label 15854: @1076040
     /* 1076040 */   GIM_Try, /*On fail goto*//*Label 15855*/ GIMT_Encode4(1076117), // Rule ID 23536 //
     /* 1076045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076084 */     // MIs[0] policy
     /* 1076084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076113 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076116 */     // GIR_Coverage, 23536,
     /* 1076116 */     GIR_EraseRootFromParent_Done,
     /* 1076117 */   // Label 15855: @1076117
     /* 1076117 */   GIM_Try, /*On fail goto*//*Label 15856*/ GIMT_Encode4(1076194), // Rule ID 23537 //
     /* 1076122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1076133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1076136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1076139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076161 */     // MIs[0] policy
     /* 1076161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076171 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076190 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076193 */     // GIR_Coverage, 23537,
     /* 1076193 */     GIR_EraseRootFromParent_Done,
     /* 1076194 */   // Label 15856: @1076194
     /* 1076194 */   GIM_Try, /*On fail goto*//*Label 15857*/ GIMT_Encode4(1076271), // Rule ID 23540 //
     /* 1076199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076238 */     // MIs[0] policy
     /* 1076238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076248 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076267 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076270 */     // GIR_Coverage, 23540,
     /* 1076270 */     GIR_EraseRootFromParent_Done,
     /* 1076271 */   // Label 15857: @1076271
     /* 1076271 */   GIM_Try, /*On fail goto*//*Label 15858*/ GIMT_Encode4(1076348), // Rule ID 23541 //
     /* 1076276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1076287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1076290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1076293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076315 */     // MIs[0] policy
     /* 1076315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076325 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1076344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076347 */     // GIR_Coverage, 23541,
     /* 1076347 */     GIR_EraseRootFromParent_Done,
     /* 1076348 */   // Label 15858: @1076348
     /* 1076348 */   GIM_Try, /*On fail goto*//*Label 15859*/ GIMT_Encode4(1076425), // Rule ID 23544 //
     /* 1076353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076392 */     // MIs[0] policy
     /* 1076392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076424 */     // GIR_Coverage, 23544,
     /* 1076424 */     GIR_EraseRootFromParent_Done,
     /* 1076425 */   // Label 15859: @1076425
     /* 1076425 */   GIM_Try, /*On fail goto*//*Label 15860*/ GIMT_Encode4(1076502), // Rule ID 23545 //
     /* 1076430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1076441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1076444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1076447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076469 */     // MIs[0] policy
     /* 1076469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076498 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076501 */     // GIR_Coverage, 23545,
     /* 1076501 */     GIR_EraseRootFromParent_Done,
     /* 1076502 */   // Label 15860: @1076502
     /* 1076502 */   GIM_Try, /*On fail goto*//*Label 15861*/ GIMT_Encode4(1076579), // Rule ID 23548 //
     /* 1076507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1076518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1076521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1076524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076546 */     // MIs[0] policy
     /* 1076546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076556 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076575 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076578 */     // GIR_Coverage, 23548,
     /* 1076578 */     GIR_EraseRootFromParent_Done,
     /* 1076579 */   // Label 15861: @1076579
     /* 1076579 */   GIM_Try, /*On fail goto*//*Label 15862*/ GIMT_Encode4(1076656), // Rule ID 23549 //
     /* 1076584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1076595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1076598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1076601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076623 */     // MIs[0] policy
     /* 1076623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076633 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1076636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076652 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076655 */     // GIR_Coverage, 23549,
     /* 1076655 */     GIR_EraseRootFromParent_Done,
     /* 1076656 */   // Label 15862: @1076656
     /* 1076656 */   GIM_Try, /*On fail goto*//*Label 15863*/ GIMT_Encode4(1076733), // Rule ID 23552 //
     /* 1076661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1076672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1076675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1076678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076700 */     // MIs[0] policy
     /* 1076700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076710 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076729 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076732 */     // GIR_Coverage, 23552,
     /* 1076732 */     GIR_EraseRootFromParent_Done,
     /* 1076733 */   // Label 15863: @1076733
     /* 1076733 */   GIM_Try, /*On fail goto*//*Label 15864*/ GIMT_Encode4(1076810), // Rule ID 23553 //
     /* 1076738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1076749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1076752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1076755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1076773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076777 */     // MIs[0] policy
     /* 1076777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076787 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1076790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1076806 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076809 */     // GIR_Coverage, 23553,
     /* 1076809 */     GIR_EraseRootFromParent_Done,
     /* 1076810 */   // Label 15864: @1076810
     /* 1076810 */   GIM_Try, /*On fail goto*//*Label 15865*/ GIMT_Encode4(1076887), // Rule ID 23556 //
     /* 1076815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1076826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1076829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1076832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076854 */     // MIs[0] policy
     /* 1076854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076864 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1076864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076883 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076886 */     // GIR_Coverage, 23556,
     /* 1076886 */     GIR_EraseRootFromParent_Done,
     /* 1076887 */   // Label 15865: @1076887
     /* 1076887 */   GIM_Try, /*On fail goto*//*Label 15866*/ GIMT_Encode4(1076964), // Rule ID 23557 //
     /* 1076892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1076895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1076903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1076906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1076909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1076912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1076915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1076927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1076931 */     // MIs[0] policy
     /* 1076931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1076934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1076941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1076941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1076944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1076946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1076948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1076950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1076952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1076957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1076960 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1076962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1076963 */     // GIR_Coverage, 23557,
     /* 1076963 */     GIR_EraseRootFromParent_Done,
     /* 1076964 */   // Label 15866: @1076964
     /* 1076964 */   GIM_Try, /*On fail goto*//*Label 15867*/ GIMT_Encode4(1077041), // Rule ID 23560 //
     /* 1076969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1076972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1076977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1076980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1076983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1076986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1076989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1076992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1076996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077008 */     // MIs[0] policy
     /* 1077008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077018 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077040 */     // GIR_Coverage, 23560,
     /* 1077040 */     GIR_EraseRootFromParent_Done,
     /* 1077041 */   // Label 15867: @1077041
     /* 1077041 */   GIM_Try, /*On fail goto*//*Label 15868*/ GIMT_Encode4(1077118), // Rule ID 23561 //
     /* 1077046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1077057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1077060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1077063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077085 */     // MIs[0] policy
     /* 1077085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077095 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077117 */     // GIR_Coverage, 23561,
     /* 1077117 */     GIR_EraseRootFromParent_Done,
     /* 1077118 */   // Label 15868: @1077118
     /* 1077118 */   GIM_Try, /*On fail goto*//*Label 15869*/ GIMT_Encode4(1077195), // Rule ID 23564 //
     /* 1077123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077162 */     // MIs[0] policy
     /* 1077162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077172 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077191 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077194 */     // GIR_Coverage, 23564,
     /* 1077194 */     GIR_EraseRootFromParent_Done,
     /* 1077195 */   // Label 15869: @1077195
     /* 1077195 */   GIM_Try, /*On fail goto*//*Label 15870*/ GIMT_Encode4(1077272), // Rule ID 23565 //
     /* 1077200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1077211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1077214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1077217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077239 */     // MIs[0] policy
     /* 1077239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077249 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1077268 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077271 */     // GIR_Coverage, 23565,
     /* 1077271 */     GIR_EraseRootFromParent_Done,
     /* 1077272 */   // Label 15870: @1077272
     /* 1077272 */   GIM_Try, /*On fail goto*//*Label 15871*/ GIMT_Encode4(1077349), // Rule ID 23568 //
     /* 1077277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077316 */     // MIs[0] policy
     /* 1077316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077345 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077348 */     // GIR_Coverage, 23568,
     /* 1077348 */     GIR_EraseRootFromParent_Done,
     /* 1077349 */   // Label 15871: @1077349
     /* 1077349 */   GIM_Try, /*On fail goto*//*Label 15872*/ GIMT_Encode4(1077426), // Rule ID 23569 //
     /* 1077354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1077365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1077368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1077371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1077389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077393 */     // MIs[0] policy
     /* 1077393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077403 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1077406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077422 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077425 */     // GIR_Coverage, 23569,
     /* 1077425 */     GIR_EraseRootFromParent_Done,
     /* 1077426 */   // Label 15872: @1077426
     /* 1077426 */   GIM_Try, /*On fail goto*//*Label 15873*/ GIMT_Encode4(1077503), // Rule ID 23572 //
     /* 1077431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1077442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1077445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1077448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077470 */     // MIs[0] policy
     /* 1077470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077480 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077499 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077502 */     // GIR_Coverage, 23572,
     /* 1077502 */     GIR_EraseRootFromParent_Done,
     /* 1077503 */   // Label 15873: @1077503
     /* 1077503 */   GIM_Try, /*On fail goto*//*Label 15874*/ GIMT_Encode4(1077580), // Rule ID 23573 //
     /* 1077508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1077519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1077522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1077525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1077543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077547 */     // MIs[0] policy
     /* 1077547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077557 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1077560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077576 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077579 */     // GIR_Coverage, 23573,
     /* 1077579 */     GIR_EraseRootFromParent_Done,
     /* 1077580 */   // Label 15874: @1077580
     /* 1077580 */   GIM_Try, /*On fail goto*//*Label 15875*/ GIMT_Encode4(1077657), // Rule ID 23576 //
     /* 1077585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1077588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1077596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1077599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1077602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077624 */     // MIs[0] policy
     /* 1077624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077653 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077656 */     // GIR_Coverage, 23576,
     /* 1077656 */     GIR_EraseRootFromParent_Done,
     /* 1077657 */   // Label 15875: @1077657
     /* 1077657 */   GIM_Try, /*On fail goto*//*Label 15876*/ GIMT_Encode4(1077734), // Rule ID 23577 //
     /* 1077662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1077665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1077670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1077673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1077676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1077679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1077697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077701 */     // MIs[0] policy
     /* 1077701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077711 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1077714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1077730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077733 */     // GIR_Coverage, 23577,
     /* 1077733 */     GIR_EraseRootFromParent_Done,
     /* 1077734 */   // Label 15876: @1077734
     /* 1077734 */   GIM_Try, /*On fail goto*//*Label 15877*/ GIMT_Encode4(1077811), // Rule ID 23668 //
     /* 1077739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1077747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1077750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1077753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1077756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077778 */     // MIs[0] policy
     /* 1077778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077788 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1077791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077807 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077810 */     // GIR_Coverage, 23668,
     /* 1077810 */     GIR_EraseRootFromParent_Done,
     /* 1077811 */   // Label 15877: @1077811
     /* 1077811 */   GIM_Try, /*On fail goto*//*Label 15878*/ GIMT_Encode4(1077888), // Rule ID 23669 //
     /* 1077816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1077824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1077827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1077830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1077833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077855 */     // MIs[0] policy
     /* 1077855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077865 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1077865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8),
     /* 1077868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077884 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077887 */     // GIR_Coverage, 23669,
     /* 1077887 */     GIR_EraseRootFromParent_Done,
     /* 1077888 */   // Label 15878: @1077888
     /* 1077888 */   GIM_Try, /*On fail goto*//*Label 15879*/ GIMT_Encode4(1077965), // Rule ID 23672 //
     /* 1077893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1077896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1077901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1077904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1077907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1077910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1077913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1077916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1077932 */     // MIs[0] policy
     /* 1077932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1077935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1077942 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1077942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1077945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1077947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1077949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1077951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1077953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1077958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1077961 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1077963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1077964 */     // GIR_Coverage, 23672,
     /* 1077964 */     GIR_EraseRootFromParent_Done,
     /* 1077965 */   // Label 15879: @1077965
     /* 1077965 */   GIM_Try, /*On fail goto*//*Label 15880*/ GIMT_Encode4(1078042), // Rule ID 23673 //
     /* 1077970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1077973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1077978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1077981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1077984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1077987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1077990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1077993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1077997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078009 */     // MIs[0] policy
     /* 1078009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078019 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078038 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078041 */     // GIR_Coverage, 23673,
     /* 1078041 */     GIR_EraseRootFromParent_Done,
     /* 1078042 */   // Label 15880: @1078042
     /* 1078042 */   GIM_Try, /*On fail goto*//*Label 15881*/ GIMT_Encode4(1078119), // Rule ID 23676 //
     /* 1078047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078086 */     // MIs[0] policy
     /* 1078086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078096 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078115 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078118 */     // GIR_Coverage, 23676,
     /* 1078118 */     GIR_EraseRootFromParent_Done,
     /* 1078119 */   // Label 15881: @1078119
     /* 1078119 */   GIM_Try, /*On fail goto*//*Label 15882*/ GIMT_Encode4(1078196), // Rule ID 23677 //
     /* 1078124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1078135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1078138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1078141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078163 */     // MIs[0] policy
     /* 1078163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078173 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078192 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078195 */     // GIR_Coverage, 23677,
     /* 1078195 */     GIR_EraseRootFromParent_Done,
     /* 1078196 */   // Label 15882: @1078196
     /* 1078196 */   GIM_Try, /*On fail goto*//*Label 15883*/ GIMT_Encode4(1078273), // Rule ID 23680 //
     /* 1078201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078240 */     // MIs[0] policy
     /* 1078240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078250 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078272 */     // GIR_Coverage, 23680,
     /* 1078272 */     GIR_EraseRootFromParent_Done,
     /* 1078273 */   // Label 15883: @1078273
     /* 1078273 */   GIM_Try, /*On fail goto*//*Label 15884*/ GIMT_Encode4(1078350), // Rule ID 23681 //
     /* 1078278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1078289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1078292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1078295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078317 */     // MIs[0] policy
     /* 1078317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078327 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1078330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078349 */     // GIR_Coverage, 23681,
     /* 1078349 */     GIR_EraseRootFromParent_Done,
     /* 1078350 */   // Label 15884: @1078350
     /* 1078350 */   GIM_Try, /*On fail goto*//*Label 15885*/ GIMT_Encode4(1078427), // Rule ID 23684 //
     /* 1078355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078394 */     // MIs[0] policy
     /* 1078394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078404 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078423 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078426 */     // GIR_Coverage, 23684,
     /* 1078426 */     GIR_EraseRootFromParent_Done,
     /* 1078427 */   // Label 15885: @1078427
     /* 1078427 */   GIM_Try, /*On fail goto*//*Label 15886*/ GIMT_Encode4(1078504), // Rule ID 23685 //
     /* 1078432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1078443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1078446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1078449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078471 */     // MIs[0] policy
     /* 1078471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078481 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078500 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078503 */     // GIR_Coverage, 23685,
     /* 1078503 */     GIR_EraseRootFromParent_Done,
     /* 1078504 */   // Label 15886: @1078504
     /* 1078504 */   GIM_Try, /*On fail goto*//*Label 15887*/ GIMT_Encode4(1078581), // Rule ID 23688 //
     /* 1078509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1078520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1078523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1078526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078548 */     // MIs[0] policy
     /* 1078548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078577 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078580 */     // GIR_Coverage, 23688,
     /* 1078580 */     GIR_EraseRootFromParent_Done,
     /* 1078581 */   // Label 15887: @1078581
     /* 1078581 */   GIM_Try, /*On fail goto*//*Label 15888*/ GIMT_Encode4(1078658), // Rule ID 23689 //
     /* 1078586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1078597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1078600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1078603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078625 */     // MIs[0] policy
     /* 1078625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078635 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1078638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1078654 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078657 */     // GIR_Coverage, 23689,
     /* 1078657 */     GIR_EraseRootFromParent_Done,
     /* 1078658 */   // Label 15888: @1078658
     /* 1078658 */   GIM_Try, /*On fail goto*//*Label 15889*/ GIMT_Encode4(1078735), // Rule ID 23692 //
     /* 1078663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1078674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1078677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1078680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078702 */     // MIs[0] policy
     /* 1078702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1078715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078731 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078734 */     // GIR_Coverage, 23692,
     /* 1078734 */     GIR_EraseRootFromParent_Done,
     /* 1078735 */   // Label 15889: @1078735
     /* 1078735 */   GIM_Try, /*On fail goto*//*Label 15890*/ GIMT_Encode4(1078812), // Rule ID 23693 //
     /* 1078740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1078751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1078754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1078757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078779 */     // MIs[0] policy
     /* 1078779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078789 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11480:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1078792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1078808 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078810 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078811 */     // GIR_Coverage, 23693,
     /* 1078811 */     GIR_EraseRootFromParent_Done,
     /* 1078812 */   // Label 15890: @1078812
     /* 1078812 */   GIM_Try, /*On fail goto*//*Label 15891*/ GIMT_Encode4(1078889), // Rule ID 23696 //
     /* 1078817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1078828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1078831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1078834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078856 */     // MIs[0] policy
     /* 1078856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1078866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1078869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078885 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078888 */     // GIR_Coverage, 23696,
     /* 1078888 */     GIR_EraseRootFromParent_Done,
     /* 1078889 */   // Label 15891: @1078889
     /* 1078889 */   GIM_Try, /*On fail goto*//*Label 15892*/ GIMT_Encode4(1078966), // Rule ID 23697 //
     /* 1078894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1078897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1078905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1078908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1078911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1078914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1078917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1078933 */     // MIs[0] policy
     /* 1078933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1078936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1078943 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1078943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1078946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1078948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1078950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1078952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1078954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1078959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1078962 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1078964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1078965 */     // GIR_Coverage, 23697,
     /* 1078965 */     GIR_EraseRootFromParent_Done,
     /* 1078966 */   // Label 15892: @1078966
     /* 1078966 */   GIM_Try, /*On fail goto*//*Label 15893*/ GIMT_Encode4(1079043), // Rule ID 23700 //
     /* 1078971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1078974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1078979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1078982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1078985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1078988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1078991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1078994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1078998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079010 */     // MIs[0] policy
     /* 1079010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079039 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079042 */     // GIR_Coverage, 23700,
     /* 1079042 */     GIR_EraseRootFromParent_Done,
     /* 1079043 */   // Label 15893: @1079043
     /* 1079043 */   GIM_Try, /*On fail goto*//*Label 15894*/ GIMT_Encode4(1079120), // Rule ID 23701 //
     /* 1079048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1079059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1079062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1079065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079087 */     // MIs[0] policy
     /* 1079087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079097 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1079116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079119 */     // GIR_Coverage, 23701,
     /* 1079119 */     GIR_EraseRootFromParent_Done,
     /* 1079120 */   // Label 15894: @1079120
     /* 1079120 */   GIM_Try, /*On fail goto*//*Label 15895*/ GIMT_Encode4(1079197), // Rule ID 23704 //
     /* 1079125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1079128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079164 */     // MIs[0] policy
     /* 1079164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079196 */     // GIR_Coverage, 23704,
     /* 1079196 */     GIR_EraseRootFromParent_Done,
     /* 1079197 */   // Label 15895: @1079197
     /* 1079197 */   GIM_Try, /*On fail goto*//*Label 15896*/ GIMT_Encode4(1079274), // Rule ID 23705 //
     /* 1079202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1079205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1079213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1079216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1079219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1079237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079241 */     // MIs[0] policy
     /* 1079241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079251 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1079254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1079270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079273 */     // GIR_Coverage, 23705,
     /* 1079273 */     GIR_EraseRootFromParent_Done,
     /* 1079274 */   // Label 15896: @1079274
     /* 1079274 */   GIM_Try, /*On fail goto*//*Label 15897*/ GIMT_Encode4(1079351), // Rule ID 23708 //
     /* 1079279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079318 */     // MIs[0] policy
     /* 1079318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079347 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079350 */     // GIR_Coverage, 23708,
     /* 1079350 */     GIR_EraseRootFromParent_Done,
     /* 1079351 */   // Label 15897: @1079351
     /* 1079351 */   GIM_Try, /*On fail goto*//*Label 15898*/ GIMT_Encode4(1079428), // Rule ID 23709 //
     /* 1079356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1079367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1079370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1079373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079395 */     // MIs[0] policy
     /* 1079395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079427 */     // GIR_Coverage, 23709,
     /* 1079427 */     GIR_EraseRootFromParent_Done,
     /* 1079428 */   // Label 15898: @1079428
     /* 1079428 */   GIM_Try, /*On fail goto*//*Label 15899*/ GIMT_Encode4(1079505), // Rule ID 23712 //
     /* 1079433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1079444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1079447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1079450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079472 */     // MIs[0] policy
     /* 1079472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079482 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1079485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079501 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079504 */     // GIR_Coverage, 23712,
     /* 1079504 */     GIR_EraseRootFromParent_Done,
     /* 1079505 */   // Label 15899: @1079505
     /* 1079505 */   GIM_Try, /*On fail goto*//*Label 15900*/ GIMT_Encode4(1079582), // Rule ID 23713 //
     /* 1079510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1079521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1079524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1079527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079549 */     // MIs[0] policy
     /* 1079549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079559 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1079562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079578 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079581 */     // GIR_Coverage, 23713,
     /* 1079581 */     GIR_EraseRootFromParent_Done,
     /* 1079582 */   // Label 15900: @1079582
     /* 1079582 */   GIM_Try, /*On fail goto*//*Label 15901*/ GIMT_Encode4(1079659), // Rule ID 23716 //
     /* 1079587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1079598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1079601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1079604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079626 */     // MIs[0] policy
     /* 1079626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079636 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1079639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079658 */     // GIR_Coverage, 23716,
     /* 1079658 */     GIR_EraseRootFromParent_Done,
     /* 1079659 */   // Label 15901: @1079659
     /* 1079659 */   GIM_Try, /*On fail goto*//*Label 15902*/ GIMT_Encode4(1079736), // Rule ID 23717 //
     /* 1079664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1079675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1079678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1079681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1079699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079703 */     // MIs[0] policy
     /* 1079703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079713 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1079716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1079732 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079735 */     // GIR_Coverage, 23717,
     /* 1079735 */     GIR_EraseRootFromParent_Done,
     /* 1079736 */   // Label 15902: @1079736
     /* 1079736 */   GIM_Try, /*On fail goto*//*Label 15903*/ GIMT_Encode4(1079813), // Rule ID 23720 //
     /* 1079741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1079752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1079755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1079758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079780 */     // MIs[0] policy
     /* 1079780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079809 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079812 */     // GIR_Coverage, 23720,
     /* 1079812 */     GIR_EraseRootFromParent_Done,
     /* 1079813 */   // Label 15903: @1079813
     /* 1079813 */   GIM_Try, /*On fail goto*//*Label 15904*/ GIMT_Encode4(1079890), // Rule ID 23721 //
     /* 1079818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1079829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1079832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1079835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1079853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079857 */     // MIs[0] policy
     /* 1079857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079867 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1079867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1079870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079886 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079889 */     // GIR_Coverage, 23721,
     /* 1079889 */     GIR_EraseRootFromParent_Done,
     /* 1079890 */   // Label 15904: @1079890
     /* 1079890 */   GIM_Try, /*On fail goto*//*Label 15905*/ GIMT_Encode4(1079967), // Rule ID 23724 //
     /* 1079895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1079898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1079906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1079909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1079912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1079915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1079918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1079934 */     // MIs[0] policy
     /* 1079934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1079937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1079944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1079944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1079947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1079949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1079951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1079953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1079955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1079960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1079963 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1079965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1079966 */     // GIR_Coverage, 23724,
     /* 1079966 */     GIR_EraseRootFromParent_Done,
     /* 1079967 */   // Label 15905: @1079967
     /* 1079967 */   GIM_Try, /*On fail goto*//*Label 15906*/ GIMT_Encode4(1080044), // Rule ID 23725 //
     /* 1079972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1079975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1079980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1079983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1079986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1079989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1079992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1079995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1079999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080011 */     // MIs[0] policy
     /* 1080011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080021 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080040 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080043 */     // GIR_Coverage, 23725,
     /* 1080043 */     GIR_EraseRootFromParent_Done,
     /* 1080044 */   // Label 15906: @1080044
     /* 1080044 */   GIM_Try, /*On fail goto*//*Label 15907*/ GIMT_Encode4(1080121), // Rule ID 23728 //
     /* 1080049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080088 */     // MIs[0] policy
     /* 1080088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080098 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080117 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080120 */     // GIR_Coverage, 23728,
     /* 1080120 */     GIR_EraseRootFromParent_Done,
     /* 1080121 */   // Label 15907: @1080121
     /* 1080121 */   GIM_Try, /*On fail goto*//*Label 15908*/ GIMT_Encode4(1080198), // Rule ID 23729 //
     /* 1080126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1080137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1080140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1080143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080165 */     // MIs[0] policy
     /* 1080165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080175 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1080194 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080197 */     // GIR_Coverage, 23729,
     /* 1080197 */     GIR_EraseRootFromParent_Done,
     /* 1080198 */   // Label 15908: @1080198
     /* 1080198 */   GIM_Try, /*On fail goto*//*Label 15909*/ GIMT_Encode4(1080275), // Rule ID 23732 //
     /* 1080203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080242 */     // MIs[0] policy
     /* 1080242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080252 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080274 */     // GIR_Coverage, 23732,
     /* 1080274 */     GIR_EraseRootFromParent_Done,
     /* 1080275 */   // Label 15909: @1080275
     /* 1080275 */   GIM_Try, /*On fail goto*//*Label 15910*/ GIMT_Encode4(1080352), // Rule ID 23733 //
     /* 1080280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1080291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1080294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1080297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080319 */     // MIs[0] policy
     /* 1080319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080350 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080351 */     // GIR_Coverage, 23733,
     /* 1080351 */     GIR_EraseRootFromParent_Done,
     /* 1080352 */   // Label 15910: @1080352
     /* 1080352 */   GIM_Try, /*On fail goto*//*Label 15911*/ GIMT_Encode4(1080429), // Rule ID 23736 //
     /* 1080357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080396 */     // MIs[0] policy
     /* 1080396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080406 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080425 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080428 */     // GIR_Coverage, 23736,
     /* 1080428 */     GIR_EraseRootFromParent_Done,
     /* 1080429 */   // Label 15911: @1080429
     /* 1080429 */   GIM_Try, /*On fail goto*//*Label 15912*/ GIMT_Encode4(1080506), // Rule ID 23737 //
     /* 1080434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1080445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1080448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1080451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080473 */     // MIs[0] policy
     /* 1080473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080483 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080502 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080505 */     // GIR_Coverage, 23737,
     /* 1080505 */     GIR_EraseRootFromParent_Done,
     /* 1080506 */   // Label 15912: @1080506
     /* 1080506 */   GIM_Try, /*On fail goto*//*Label 15913*/ GIMT_Encode4(1080583), // Rule ID 23740 //
     /* 1080511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1080514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1080522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1080525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1080528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080550 */     // MIs[0] policy
     /* 1080550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080579 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080582 */     // GIR_Coverage, 23740,
     /* 1080582 */     GIR_EraseRootFromParent_Done,
     /* 1080583 */   // Label 15913: @1080583
     /* 1080583 */   GIM_Try, /*On fail goto*//*Label 15914*/ GIMT_Encode4(1080660), // Rule ID 23741 //
     /* 1080588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1080591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1080599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1080602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1080605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1080623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080627 */     // MIs[0] policy
     /* 1080627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080637 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1080640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1080656 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080659 */     // GIR_Coverage, 23741,
     /* 1080659 */     GIR_EraseRootFromParent_Done,
     /* 1080660 */   // Label 15914: @1080660
     /* 1080660 */   GIM_Try, /*On fail goto*//*Label 15915*/ GIMT_Encode4(1080737), // Rule ID 23744 //
     /* 1080665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1080676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1080679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1080682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080704 */     // MIs[0] policy
     /* 1080704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080714 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080733 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080736 */     // GIR_Coverage, 23744,
     /* 1080736 */     GIR_EraseRootFromParent_Done,
     /* 1080737 */   // Label 15915: @1080737
     /* 1080737 */   GIM_Try, /*On fail goto*//*Label 15916*/ GIMT_Encode4(1080814), // Rule ID 23745 //
     /* 1080742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1080753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1080756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1080759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1080777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080781 */     // MIs[0] policy
     /* 1080781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080791 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1080794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080810 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080813 */     // GIR_Coverage, 23745,
     /* 1080813 */     GIR_EraseRootFromParent_Done,
     /* 1080814 */   // Label 15916: @1080814
     /* 1080814 */   GIM_Try, /*On fail goto*//*Label 15917*/ GIMT_Encode4(1080891), // Rule ID 23748 //
     /* 1080819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1080830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1080833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1080836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080858 */     // MIs[0] policy
     /* 1080858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080868 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1080868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080890 */     // GIR_Coverage, 23748,
     /* 1080890 */     GIR_EraseRootFromParent_Done,
     /* 1080891 */   // Label 15917: @1080891
     /* 1080891 */   GIM_Try, /*On fail goto*//*Label 15918*/ GIMT_Encode4(1080968), // Rule ID 23749 //
     /* 1080896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1080899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1080907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1080910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1080913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1080916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1080919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1080931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1080935 */     // MIs[0] policy
     /* 1080935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1080938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1080945 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1080945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1080948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1080950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1080952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1080954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1080956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1080961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1080964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1080966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1080967 */     // GIR_Coverage, 23749,
     /* 1080967 */     GIR_EraseRootFromParent_Done,
     /* 1080968 */   // Label 15918: @1080968
     /* 1080968 */   GIM_Try, /*On fail goto*//*Label 15919*/ GIMT_Encode4(1081045), // Rule ID 23752 //
     /* 1080973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1080976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1080981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1080984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1080987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1080990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1080993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1080996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081012 */     // MIs[0] policy
     /* 1081012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081041 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081044 */     // GIR_Coverage, 23752,
     /* 1081044 */     GIR_EraseRootFromParent_Done,
     /* 1081045 */   // Label 15919: @1081045
     /* 1081045 */   GIM_Try, /*On fail goto*//*Label 15920*/ GIMT_Encode4(1081122), // Rule ID 23753 //
     /* 1081050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1081053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1081058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1081061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1081064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1081067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1081085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081089 */     // MIs[0] policy
     /* 1081089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081099 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1081102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081118 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081121 */     // GIR_Coverage, 23753,
     /* 1081121 */     GIR_EraseRootFromParent_Done,
     /* 1081122 */   // Label 15920: @1081122
     /* 1081122 */   GIM_Try, /*On fail goto*//*Label 15921*/ GIMT_Encode4(1081199), // Rule ID 24020 //
     /* 1081127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1081130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081166 */     // MIs[0] policy
     /* 1081166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081176 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081195 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081198 */     // GIR_Coverage, 24020,
     /* 1081198 */     GIR_EraseRootFromParent_Done,
     /* 1081199 */   // Label 15921: @1081199
     /* 1081199 */   GIM_Try, /*On fail goto*//*Label 15922*/ GIMT_Encode4(1081276), // Rule ID 24021 //
     /* 1081204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1081207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1081215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1081218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1081221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081243 */     // MIs[0] policy
     /* 1081243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081253 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4),
     /* 1081256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081272 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081275 */     // GIR_Coverage, 24021,
     /* 1081275 */     GIR_EraseRootFromParent_Done,
     /* 1081276 */   // Label 15922: @1081276
     /* 1081276 */   GIM_Try, /*On fail goto*//*Label 15923*/ GIMT_Encode4(1081353), // Rule ID 24024 //
     /* 1081281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1081284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081320 */     // MIs[0] policy
     /* 1081320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081330 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081349 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081352 */     // GIR_Coverage, 24024,
     /* 1081352 */     GIR_EraseRootFromParent_Done,
     /* 1081353 */   // Label 15923: @1081353
     /* 1081353 */   GIM_Try, /*On fail goto*//*Label 15924*/ GIMT_Encode4(1081430), // Rule ID 24025 //
     /* 1081358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1081361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1081369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1081372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1081375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081397 */     // MIs[0] policy
     /* 1081397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081407 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081426 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081429 */     // GIR_Coverage, 24025,
     /* 1081429 */     GIR_EraseRootFromParent_Done,
     /* 1081430 */   // Label 15924: @1081430
     /* 1081430 */   GIM_Try, /*On fail goto*//*Label 15925*/ GIMT_Encode4(1081507), // Rule ID 24028 //
     /* 1081435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1081438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1081452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081474 */     // MIs[0] policy
     /* 1081474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081484 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081503 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081506 */     // GIR_Coverage, 24028,
     /* 1081506 */     GIR_EraseRootFromParent_Done,
     /* 1081507 */   // Label 15925: @1081507
     /* 1081507 */   GIM_Try, /*On fail goto*//*Label 15926*/ GIMT_Encode4(1081584), // Rule ID 24029 //
     /* 1081512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1081515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1081523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1081526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1081529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081551 */     // MIs[0] policy
     /* 1081551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081561 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2),
     /* 1081564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081580 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081583 */     // GIR_Coverage, 24029,
     /* 1081583 */     GIR_EraseRootFromParent_Done,
     /* 1081584 */   // Label 15926: @1081584
     /* 1081584 */   GIM_Try, /*On fail goto*//*Label 15927*/ GIMT_Encode4(1081661), // Rule ID 24032 //
     /* 1081589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1081592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1081600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1081603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1081606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081628 */     // MIs[0] policy
     /* 1081628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081638 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1081641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081657 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081660 */     // GIR_Coverage, 24032,
     /* 1081660 */     GIR_EraseRootFromParent_Done,
     /* 1081661 */   // Label 15927: @1081661
     /* 1081661 */   GIM_Try, /*On fail goto*//*Label 15928*/ GIMT_Encode4(1081738), // Rule ID 24033 //
     /* 1081666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1081669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1081677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1081680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1081683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081705 */     // MIs[0] policy
     /* 1081705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081715 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11482:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1081718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1081734 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081737 */     // GIR_Coverage, 24033,
     /* 1081737 */     GIR_EraseRootFromParent_Done,
     /* 1081738 */   // Label 15928: @1081738
     /* 1081738 */   GIM_Try, /*On fail goto*//*Label 15929*/ GIMT_Encode4(1081815), // Rule ID 24036 //
     /* 1081743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1081746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1081754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1081757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1081760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081782 */     // MIs[0] policy
     /* 1081782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1081795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081814 */     // GIR_Coverage, 24036,
     /* 1081814 */     GIR_EraseRootFromParent_Done,
     /* 1081815 */   // Label 15929: @1081815
     /* 1081815 */   GIM_Try, /*On fail goto*//*Label 15930*/ GIMT_Encode4(1081892), // Rule ID 24037 //
     /* 1081820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1081823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1081831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1081834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1081837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081859 */     // MIs[0] policy
     /* 1081859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081869 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11482:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1081869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1081872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1081888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081891 */     // GIR_Coverage, 24037,
     /* 1081891 */     GIR_EraseRootFromParent_Done,
     /* 1081892 */   // Label 15930: @1081892
     /* 1081892 */   GIM_Try, /*On fail goto*//*Label 15931*/ GIMT_Encode4(1081969), // Rule ID 24040 //
     /* 1081897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1081900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1081908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1081911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1081914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1081917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1081920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1081932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1081936 */     // MIs[0] policy
     /* 1081936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1081939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1081946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1081946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1081949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1081951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1081953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1081955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1081957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1081962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1081965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1081967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1081968 */     // GIR_Coverage, 24040,
     /* 1081968 */     GIR_EraseRootFromParent_Done,
     /* 1081969 */   // Label 15931: @1081969
     /* 1081969 */   GIM_Try, /*On fail goto*//*Label 15932*/ GIMT_Encode4(1082046), // Rule ID 24041 //
     /* 1081974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1081977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1081982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1081985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1081988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1081991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1081994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1081997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1082009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082013 */     // MIs[0] policy
     /* 1082013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082023 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11482:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1),
     /* 1082026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1082042 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082045 */     // GIR_Coverage, 24041,
     /* 1082045 */     GIR_EraseRootFromParent_Done,
     /* 1082046 */   // Label 15932: @1082046
     /* 1082046 */   GIM_Try, /*On fail goto*//*Label 15933*/ GIMT_Encode4(1082123), // Rule ID 24044 //
     /* 1082051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1082054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082090 */     // MIs[0] policy
     /* 1082090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082100 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082122 */     // GIR_Coverage, 24044,
     /* 1082122 */     GIR_EraseRootFromParent_Done,
     /* 1082123 */   // Label 15933: @1082123
     /* 1082123 */   GIM_Try, /*On fail goto*//*Label 15934*/ GIMT_Encode4(1082200), // Rule ID 24045 //
     /* 1082128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1082131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1082139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1082142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1082145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082167 */     // MIs[0] policy
     /* 1082167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082177 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082199 */     // GIR_Coverage, 24045,
     /* 1082199 */     GIR_EraseRootFromParent_Done,
     /* 1082200 */   // Label 15934: @1082200
     /* 1082200 */   GIM_Try, /*On fail goto*//*Label 15935*/ GIMT_Encode4(1082277), // Rule ID 24048 //
     /* 1082205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1082208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082244 */     // MIs[0] policy
     /* 1082244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082254 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082276 */     // GIR_Coverage, 24048,
     /* 1082276 */     GIR_EraseRootFromParent_Done,
     /* 1082277 */   // Label 15935: @1082277
     /* 1082277 */   GIM_Try, /*On fail goto*//*Label 15936*/ GIMT_Encode4(1082354), // Rule ID 24049 //
     /* 1082282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1082285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1082293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1082296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1082299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082321 */     // MIs[0] policy
     /* 1082321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082331 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082350 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082353 */     // GIR_Coverage, 24049,
     /* 1082353 */     GIR_EraseRootFromParent_Done,
     /* 1082354 */   // Label 15936: @1082354
     /* 1082354 */   GIM_Try, /*On fail goto*//*Label 15937*/ GIMT_Encode4(1082431), // Rule ID 24052 //
     /* 1082359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1082362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082398 */     // MIs[0] policy
     /* 1082398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082408 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082427 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082430 */     // GIR_Coverage, 24052,
     /* 1082430 */     GIR_EraseRootFromParent_Done,
     /* 1082431 */   // Label 15937: @1082431
     /* 1082431 */   GIM_Try, /*On fail goto*//*Label 15938*/ GIMT_Encode4(1082508), // Rule ID 24053 //
     /* 1082436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1082439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1082447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1082450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1082453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082475 */     // MIs[0] policy
     /* 1082475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082485 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1082504 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082507 */     // GIR_Coverage, 24053,
     /* 1082507 */     GIR_EraseRootFromParent_Done,
     /* 1082508 */   // Label 15938: @1082508
     /* 1082508 */   GIM_Try, /*On fail goto*//*Label 15939*/ GIMT_Encode4(1082585), // Rule ID 24056 //
     /* 1082513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1082516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1082524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1082527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1082530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082552 */     // MIs[0] policy
     /* 1082552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082562 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082581 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082584 */     // GIR_Coverage, 24056,
     /* 1082584 */     GIR_EraseRootFromParent_Done,
     /* 1082585 */   // Label 15939: @1082585
     /* 1082585 */   GIM_Try, /*On fail goto*//*Label 15940*/ GIMT_Encode4(1082662), // Rule ID 24057 //
     /* 1082590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1082593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1082601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1082604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1082607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1082625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082629 */     // MIs[0] policy
     /* 1082629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1082642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082658 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082661 */     // GIR_Coverage, 24057,
     /* 1082661 */     GIR_EraseRootFromParent_Done,
     /* 1082662 */   // Label 15940: @1082662
     /* 1082662 */   GIM_Try, /*On fail goto*//*Label 15941*/ GIMT_Encode4(1082739), // Rule ID 24060 //
     /* 1082667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1082670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1082678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1082681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1082684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082706 */     // MIs[0] policy
     /* 1082706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082716 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082735 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082738 */     // GIR_Coverage, 24060,
     /* 1082738 */     GIR_EraseRootFromParent_Done,
     /* 1082739 */   // Label 15941: @1082739
     /* 1082739 */   GIM_Try, /*On fail goto*//*Label 15942*/ GIMT_Encode4(1082816), // Rule ID 24061 //
     /* 1082744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1082747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1082755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1082758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1082761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1082779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082783 */     // MIs[0] policy
     /* 1082783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082793 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1082796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082812 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082815 */     // GIR_Coverage, 24061,
     /* 1082815 */     GIR_EraseRootFromParent_Done,
     /* 1082816 */   // Label 15942: @1082816
     /* 1082816 */   GIM_Try, /*On fail goto*//*Label 15943*/ GIMT_Encode4(1082893), // Rule ID 24064 //
     /* 1082821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1082824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1082832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1082835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1082838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082860 */     // MIs[0] policy
     /* 1082860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082870 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1082870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082889 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082892 */     // GIR_Coverage, 24064,
     /* 1082892 */     GIR_EraseRootFromParent_Done,
     /* 1082893 */   // Label 15943: @1082893
     /* 1082893 */   GIM_Try, /*On fail goto*//*Label 15944*/ GIMT_Encode4(1082970), // Rule ID 24065 //
     /* 1082898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1082901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1082909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1082912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1082915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1082918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1082921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1082933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1082937 */     // MIs[0] policy
     /* 1082937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1082940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1082947 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1082947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1082950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1082952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1082954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1082956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1082958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1082963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1082966 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1082968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1082969 */     // GIR_Coverage, 24065,
     /* 1082969 */     GIR_EraseRootFromParent_Done,
     /* 1082970 */   // Label 15944: @1082970
     /* 1082970 */   GIM_Try, /*On fail goto*//*Label 15945*/ GIMT_Encode4(1083047), // Rule ID 24068 //
     /* 1082975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1082978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1082983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1082986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1082989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1082992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1082995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1082998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083014 */     // MIs[0] policy
     /* 1083014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083043 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083046 */     // GIR_Coverage, 24068,
     /* 1083046 */     GIR_EraseRootFromParent_Done,
     /* 1083047 */   // Label 15945: @1083047
     /* 1083047 */   GIM_Try, /*On fail goto*//*Label 15946*/ GIMT_Encode4(1083124), // Rule ID 24069 //
     /* 1083052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1083063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1083066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1083069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1083087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083091 */     // MIs[0] policy
     /* 1083091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083101 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11482:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2),
     /* 1083104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083123 */     // GIR_Coverage, 24069,
     /* 1083123 */     GIR_EraseRootFromParent_Done,
     /* 1083124 */   // Label 15946: @1083124
     /* 1083124 */   GIM_Try, /*On fail goto*//*Label 15947*/ GIMT_Encode4(1083201), // Rule ID 24072 //
     /* 1083129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1083132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083168 */     // MIs[0] policy
     /* 1083168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083178 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083200 */     // GIR_Coverage, 24072,
     /* 1083200 */     GIR_EraseRootFromParent_Done,
     /* 1083201 */   // Label 15947: @1083201
     /* 1083201 */   GIM_Try, /*On fail goto*//*Label 15948*/ GIMT_Encode4(1083278), // Rule ID 24073 //
     /* 1083206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1083217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1083220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1083223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1083241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083245 */     // MIs[0] policy
     /* 1083245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083255 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11482:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4),
     /* 1083258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083277 */     // GIR_Coverage, 24073,
     /* 1083277 */     GIR_EraseRootFromParent_Done,
     /* 1083278 */   // Label 15948: @1083278
     /* 1083278 */   GIM_Try, /*On fail goto*//*Label 15949*/ GIMT_Encode4(1083355), // Rule ID 24076 //
     /* 1083283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1083286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083322 */     // MIs[0] policy
     /* 1083322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083332 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083351 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083354 */     // GIR_Coverage, 24076,
     /* 1083354 */     GIR_EraseRootFromParent_Done,
     /* 1083355 */   // Label 15949: @1083355
     /* 1083355 */   GIM_Try, /*On fail goto*//*Label 15950*/ GIMT_Encode4(1083432), // Rule ID 24077 //
     /* 1083360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1083363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup),
     /* 1083368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1083371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1083374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1083377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1083395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083399 */     // MIs[0] policy
     /* 1083399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083409 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11482:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8),
     /* 1083412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1083428 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083431 */     // GIR_Coverage, 24077,
     /* 1083431 */     GIR_EraseRootFromParent_Done,
     /* 1083432 */   // Label 15950: @1083432
     /* 1083432 */   GIM_Try, /*On fail goto*//*Label 15951*/ GIMT_Encode4(1083509), // Rule ID 24140 //
     /* 1083437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1083440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1083454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083476 */     // MIs[0] policy
     /* 1083476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083486 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1083489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083505 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083508 */     // GIR_Coverage, 24140,
     /* 1083508 */     GIR_EraseRootFromParent_Done,
     /* 1083509 */   // Label 15951: @1083509
     /* 1083509 */   GIM_Try, /*On fail goto*//*Label 15952*/ GIMT_Encode4(1083586), // Rule ID 24141 //
     /* 1083514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1083517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1083525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1083528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1083531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083553 */     // MIs[0] policy
     /* 1083553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083563 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4),
     /* 1083566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083582 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083585 */     // GIR_Coverage, 24141,
     /* 1083585 */     GIR_EraseRootFromParent_Done,
     /* 1083586 */   // Label 15952: @1083586
     /* 1083586 */   GIM_Try, /*On fail goto*//*Label 15953*/ GIMT_Encode4(1083663), // Rule ID 24144 //
     /* 1083591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1083594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1083602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1083605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1083608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083630 */     // MIs[0] policy
     /* 1083630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083640 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1083643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083662 */     // GIR_Coverage, 24144,
     /* 1083662 */     GIR_EraseRootFromParent_Done,
     /* 1083663 */   // Label 15953: @1083663
     /* 1083663 */   GIM_Try, /*On fail goto*//*Label 15954*/ GIMT_Encode4(1083740), // Rule ID 24145 //
     /* 1083668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1083671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1083679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1083682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1083685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083707 */     // MIs[0] policy
     /* 1083707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083717 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1083720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083738 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083739 */     // GIR_Coverage, 24145,
     /* 1083739 */     GIR_EraseRootFromParent_Done,
     /* 1083740 */   // Label 15954: @1083740
     /* 1083740 */   GIM_Try, /*On fail goto*//*Label 15955*/ GIMT_Encode4(1083817), // Rule ID 24148 //
     /* 1083745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1083748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1083756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1083759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1083762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083784 */     // MIs[0] policy
     /* 1083784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083794 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1083797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083813 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083816 */     // GIR_Coverage, 24148,
     /* 1083816 */     GIR_EraseRootFromParent_Done,
     /* 1083817 */   // Label 15955: @1083817
     /* 1083817 */   GIM_Try, /*On fail goto*//*Label 15956*/ GIMT_Encode4(1083894), // Rule ID 24149 //
     /* 1083822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1083825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1083833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1083836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1083839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083861 */     // MIs[0] policy
     /* 1083861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083871 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1083871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2),
     /* 1083874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1083890 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083893 */     // GIR_Coverage, 24149,
     /* 1083893 */     GIR_EraseRootFromParent_Done,
     /* 1083894 */   // Label 15956: @1083894
     /* 1083894 */   GIM_Try, /*On fail goto*//*Label 15957*/ GIMT_Encode4(1083971), // Rule ID 24152 //
     /* 1083899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1083902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1083919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1083922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1083934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1083938 */     // MIs[0] policy
     /* 1083938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1083941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1083948 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1083948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1083951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1083953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1083955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1083957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1083959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1083964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1083967 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1083969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1083970 */     // GIR_Coverage, 24152,
     /* 1083970 */     GIR_EraseRootFromParent_Done,
     /* 1083971 */   // Label 15957: @1083971
     /* 1083971 */   GIM_Try, /*On fail goto*//*Label 15958*/ GIMT_Encode4(1084048), // Rule ID 24153 //
     /* 1083976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1083979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1083984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1083987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1083990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1083993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1083996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1083999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084015 */     // MIs[0] policy
     /* 1084015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084025 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11480:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084044 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084047 */     // GIR_Coverage, 24153,
     /* 1084047 */     GIR_EraseRootFromParent_Done,
     /* 1084048 */   // Label 15958: @1084048
     /* 1084048 */   GIM_Try, /*On fail goto*//*Label 15959*/ GIMT_Encode4(1084125), // Rule ID 24156 //
     /* 1084053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1084056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084092 */     // MIs[0] policy
     /* 1084092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084124 */     // GIR_Coverage, 24156,
     /* 1084124 */     GIR_EraseRootFromParent_Done,
     /* 1084125 */   // Label 15959: @1084125
     /* 1084125 */   GIM_Try, /*On fail goto*//*Label 15960*/ GIMT_Encode4(1084202), // Rule ID 24157 //
     /* 1084130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1084133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1084141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1084144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1084147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084169 */     // MIs[0] policy
     /* 1084169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084179 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11480:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084201 */     // GIR_Coverage, 24157,
     /* 1084201 */     GIR_EraseRootFromParent_Done,
     /* 1084202 */   // Label 15960: @1084202
     /* 1084202 */   GIM_Try, /*On fail goto*//*Label 15961*/ GIMT_Encode4(1084279), // Rule ID 24160 //
     /* 1084207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1084210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084246 */     // MIs[0] policy
     /* 1084246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084256 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084275 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084278 */     // GIR_Coverage, 24160,
     /* 1084278 */     GIR_EraseRootFromParent_Done,
     /* 1084279 */   // Label 15961: @1084279
     /* 1084279 */   GIM_Try, /*On fail goto*//*Label 15962*/ GIMT_Encode4(1084356), // Rule ID 24161 //
     /* 1084284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1084287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1084295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1084298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1084301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1084319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084323 */     // MIs[0] policy
     /* 1084323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084333 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11480:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1),
     /* 1084336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1084352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084355 */     // GIR_Coverage, 24161,
     /* 1084355 */     GIR_EraseRootFromParent_Done,
     /* 1084356 */   // Label 15962: @1084356
     /* 1084356 */   GIM_Try, /*On fail goto*//*Label 15963*/ GIMT_Encode4(1084433), // Rule ID 24164 //
     /* 1084361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1084364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084400 */     // MIs[0] policy
     /* 1084400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084410 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084429 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084432 */     // GIR_Coverage, 24164,
     /* 1084432 */     GIR_EraseRootFromParent_Done,
     /* 1084433 */   // Label 15963: @1084433
     /* 1084433 */   GIM_Try, /*On fail goto*//*Label 15964*/ GIMT_Encode4(1084510), // Rule ID 24165 //
     /* 1084438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1084441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1084449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1084452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1084455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084477 */     // MIs[0] policy
     /* 1084477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084487 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084506 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084509 */     // GIR_Coverage, 24165,
     /* 1084509 */     GIR_EraseRootFromParent_Done,
     /* 1084510 */   // Label 15964: @1084510
     /* 1084510 */   GIM_Try, /*On fail goto*//*Label 15965*/ GIMT_Encode4(1084587), // Rule ID 24168 //
     /* 1084515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1084518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084554 */     // MIs[0] policy
     /* 1084554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084564 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084586 */     // GIR_Coverage, 24168,
     /* 1084586 */     GIR_EraseRootFromParent_Done,
     /* 1084587 */   // Label 15965: @1084587
     /* 1084587 */   GIM_Try, /*On fail goto*//*Label 15966*/ GIMT_Encode4(1084664), // Rule ID 24169 //
     /* 1084592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1084595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1084603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1084606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1084609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1084627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084631 */     // MIs[0] policy
     /* 1084631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084641 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1084644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084663 */     // GIR_Coverage, 24169,
     /* 1084663 */     GIR_EraseRootFromParent_Done,
     /* 1084664 */   // Label 15966: @1084664
     /* 1084664 */   GIM_Try, /*On fail goto*//*Label 15967*/ GIMT_Encode4(1084741), // Rule ID 24172 //
     /* 1084669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1084672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084708 */     // MIs[0] policy
     /* 1084708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084718 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084737 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084740 */     // GIR_Coverage, 24172,
     /* 1084740 */     GIR_EraseRootFromParent_Done,
     /* 1084741 */   // Label 15967: @1084741
     /* 1084741 */   GIM_Try, /*On fail goto*//*Label 15968*/ GIMT_Encode4(1084818), // Rule ID 24173 //
     /* 1084746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1084749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1084757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1084760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1084763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1084781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084785 */     // MIs[0] policy
     /* 1084785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084795 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1084798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1084814 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084817 */     // GIR_Coverage, 24173,
     /* 1084817 */     GIR_EraseRootFromParent_Done,
     /* 1084818 */   // Label 15968: @1084818
     /* 1084818 */   GIM_Try, /*On fail goto*//*Label 15969*/ GIMT_Encode4(1084895), // Rule ID 24176 //
     /* 1084823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1084826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1084846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084862 */     // MIs[0] policy
     /* 1084862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084872 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1084872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084891 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084894 */     // GIR_Coverage, 24176,
     /* 1084894 */     GIR_EraseRootFromParent_Done,
     /* 1084895 */   // Label 15969: @1084895
     /* 1084895 */   GIM_Try, /*On fail goto*//*Label 15970*/ GIMT_Encode4(1084972), // Rule ID 24177 //
     /* 1084900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1084903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1084911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1084914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1084917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1084920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1084923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1084935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1084939 */     // MIs[0] policy
     /* 1084939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1084942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1084949 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1084949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1084952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1084954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1084956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1084958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1084960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1084965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1084968 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1084970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1084971 */     // GIR_Coverage, 24177,
     /* 1084971 */     GIR_EraseRootFromParent_Done,
     /* 1084972 */   // Label 15970: @1084972
     /* 1084972 */   GIM_Try, /*On fail goto*//*Label 15971*/ GIMT_Encode4(1085049), // Rule ID 24180 //
     /* 1084977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1084980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1084985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1084988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1084991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1084994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1084997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085016 */     // MIs[0] policy
     /* 1085016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085026 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085045 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085048 */     // GIR_Coverage, 24180,
     /* 1085048 */     GIR_EraseRootFromParent_Done,
     /* 1085049 */   // Label 15971: @1085049
     /* 1085049 */   GIM_Try, /*On fail goto*//*Label 15972*/ GIMT_Encode4(1085126), // Rule ID 24181 //
     /* 1085054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1085065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1085068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1085071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085093 */     // MIs[0] policy
     /* 1085093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085103 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085108 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085122 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085125 */     // GIR_Coverage, 24181,
     /* 1085125 */     GIR_EraseRootFromParent_Done,
     /* 1085126 */   // Label 15972: @1085126
     /* 1085126 */   GIM_Try, /*On fail goto*//*Label 15973*/ GIMT_Encode4(1085203), // Rule ID 24184 //
     /* 1085131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1085134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085170 */     // MIs[0] policy
     /* 1085170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085202 */     // GIR_Coverage, 24184,
     /* 1085202 */     GIR_EraseRootFromParent_Done,
     /* 1085203 */   // Label 15973: @1085203
     /* 1085203 */   GIM_Try, /*On fail goto*//*Label 15974*/ GIMT_Encode4(1085280), // Rule ID 24185 //
     /* 1085208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1085211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1085219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1085222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1085225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085247 */     // MIs[0] policy
     /* 1085247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085257 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085279 */     // GIR_Coverage, 24185,
     /* 1085279 */     GIR_EraseRootFromParent_Done,
     /* 1085280 */   // Label 15974: @1085280
     /* 1085280 */   GIM_Try, /*On fail goto*//*Label 15975*/ GIMT_Encode4(1085357), // Rule ID 24188 //
     /* 1085285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1085288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085324 */     // MIs[0] policy
     /* 1085324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085334 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085353 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085356 */     // GIR_Coverage, 24188,
     /* 1085356 */     GIR_EraseRootFromParent_Done,
     /* 1085357 */   // Label 15975: @1085357
     /* 1085357 */   GIM_Try, /*On fail goto*//*Label 15976*/ GIMT_Encode4(1085434), // Rule ID 24189 //
     /* 1085362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1085365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1085373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1085376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1085379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1085397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085401 */     // MIs[0] policy
     /* 1085401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085411 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11480:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2),
     /* 1085414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085430 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085433 */     // GIR_Coverage, 24189,
     /* 1085433 */     GIR_EraseRootFromParent_Done,
     /* 1085434 */   // Label 15976: @1085434
     /* 1085434 */   GIM_Try, /*On fail goto*//*Label 15977*/ GIMT_Encode4(1085511), // Rule ID 24192 //
     /* 1085439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1085442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085478 */     // MIs[0] policy
     /* 1085478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085488 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085507 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085510 */     // GIR_Coverage, 24192,
     /* 1085510 */     GIR_EraseRootFromParent_Done,
     /* 1085511 */   // Label 15977: @1085511
     /* 1085511 */   GIM_Try, /*On fail goto*//*Label 15978*/ GIMT_Encode4(1085588), // Rule ID 24193 //
     /* 1085516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1085519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1085527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1085530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1085533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1085551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085555 */     // MIs[0] policy
     /* 1085555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085565 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11480:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4),
     /* 1085568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085584 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085587 */     // GIR_Coverage, 24193,
     /* 1085587 */     GIR_EraseRootFromParent_Done,
     /* 1085588 */   // Label 15978: @1085588
     /* 1085588 */   GIM_Try, /*On fail goto*//*Label 15979*/ GIMT_Encode4(1085665), // Rule ID 24196 //
     /* 1085593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1085596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1085613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085632 */     // MIs[0] policy
     /* 1085632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085642 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085661 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085664 */     // GIR_Coverage, 24196,
     /* 1085664 */     GIR_EraseRootFromParent_Done,
     /* 1085665 */   // Label 15979: @1085665
     /* 1085665 */   GIM_Try, /*On fail goto*//*Label 15980*/ GIMT_Encode4(1085742), // Rule ID 24197 //
     /* 1085670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1085673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown),
     /* 1085678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1085681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1085684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1085687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1085690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1085705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1085709 */     // MIs[0] policy
     /* 1085709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085719 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11480:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8),
     /* 1085722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1085738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085741 */     // GIR_Coverage, 24197,
     /* 1085741 */     GIR_EraseRootFromParent_Done,
     /* 1085742 */   // Label 15980: @1085742
     /* 1085742 */   GIM_Try, /*On fail goto*//*Label 15981*/ GIMT_Encode4(1085819), // Rule ID 60480 //
     /* 1085747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1085750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1085755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1085767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085786 */     // MIs[0] policy
     /* 1085786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1085799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1085801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085818 */     // GIR_Coverage, 60480,
     /* 1085818 */     GIR_EraseRootFromParent_Done,
     /* 1085819 */   // Label 15981: @1085819
     /* 1085819 */   GIM_Try, /*On fail goto*//*Label 15982*/ GIMT_Encode4(1085896), // Rule ID 60481 //
     /* 1085824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1085827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1085832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1085835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1085838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1085841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1085844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1085847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085863 */     // MIs[0] policy
     /* 1085863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085873 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1085873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_MF2),
     /* 1085876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1085878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1085880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1085882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1085884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1085892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085895 */     // GIR_Coverage, 60481,
     /* 1085895 */     GIR_EraseRootFromParent_Done,
     /* 1085896 */   // Label 15982: @1085896
     /* 1085896 */   GIM_Try, /*On fail goto*//*Label 15983*/ GIMT_Encode4(1085973), // Rule ID 60494 //
     /* 1085901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1085904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1085909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1085912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1085915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1085918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1085921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1085924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1085928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1085936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1085940 */     // MIs[0] policy
     /* 1085940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1085943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1085950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1085950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1085953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1085955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1085957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1085959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1085961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1085966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1085969 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1085971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1085972 */     // GIR_Coverage, 60494,
     /* 1085972 */     GIR_EraseRootFromParent_Done,
     /* 1085973 */   // Label 15983: @1085973
     /* 1085973 */   GIM_Try, /*On fail goto*//*Label 15984*/ GIMT_Encode4(1086050), // Rule ID 60495 //
     /* 1085978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1085981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1085986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1085989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1085992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1085995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1085998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086017 */     // MIs[0] policy
     /* 1086017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086027 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8_MASK),
     /* 1086030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086036 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086046 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086049 */     // GIR_Coverage, 60495,
     /* 1086049 */     GIR_EraseRootFromParent_Done,
     /* 1086050 */   // Label 15984: @1086050
     /* 1086050 */   GIM_Try, /*On fail goto*//*Label 15985*/ GIMT_Encode4(1086127), // Rule ID 60498 //
     /* 1086055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086094 */     // MIs[0] policy
     /* 1086094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086104 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086123 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086126 */     // GIR_Coverage, 60498,
     /* 1086126 */     GIR_EraseRootFromParent_Done,
     /* 1086127 */   // Label 15985: @1086127
     /* 1086127 */   GIM_Try, /*On fail goto*//*Label 15986*/ GIMT_Encode4(1086204), // Rule ID 60499 //
     /* 1086132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1086143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1086146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1086149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086171 */     // MIs[0] policy
     /* 1086171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086181 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086190 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086200 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086202 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086203 */     // GIR_Coverage, 60499,
     /* 1086203 */     GIR_EraseRootFromParent_Done,
     /* 1086204 */   // Label 15986: @1086204
     /* 1086204 */   GIM_Try, /*On fail goto*//*Label 15987*/ GIMT_Encode4(1086281), // Rule ID 60502 //
     /* 1086209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086248 */     // MIs[0] policy
     /* 1086248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086277 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086280 */     // GIR_Coverage, 60502,
     /* 1086280 */     GIR_EraseRootFromParent_Done,
     /* 1086281 */   // Label 15987: @1086281
     /* 1086281 */   GIM_Try, /*On fail goto*//*Label 15988*/ GIMT_Encode4(1086358), // Rule ID 60503 //
     /* 1086286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1086297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1086300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1086303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086325 */     // MIs[0] policy
     /* 1086325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086335 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086344 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086354 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086357 */     // GIR_Coverage, 60503,
     /* 1086357 */     GIR_EraseRootFromParent_Done,
     /* 1086358 */   // Label 15988: @1086358
     /* 1086358 */   GIM_Try, /*On fail goto*//*Label 15989*/ GIMT_Encode4(1086435), // Rule ID 60506 //
     /* 1086363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086402 */     // MIs[0] policy
     /* 1086402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086421 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086431 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086434 */     // GIR_Coverage, 60506,
     /* 1086434 */     GIR_EraseRootFromParent_Done,
     /* 1086435 */   // Label 15989: @1086435
     /* 1086435 */   GIM_Try, /*On fail goto*//*Label 15990*/ GIMT_Encode4(1086512), // Rule ID 60507 //
     /* 1086440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1086451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1086454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1086457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086479 */     // MIs[0] policy
     /* 1086479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086489 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4_MASK),
     /* 1086492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086498 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086508 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086511 */     // GIR_Coverage, 60507,
     /* 1086511 */     GIR_EraseRootFromParent_Done,
     /* 1086512 */   // Label 15990: @1086512
     /* 1086512 */   GIM_Try, /*On fail goto*//*Label 15991*/ GIMT_Encode4(1086589), // Rule ID 60510 //
     /* 1086517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1086528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1086531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1086534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086556 */     // MIs[0] policy
     /* 1086556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086566 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086585 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086588 */     // GIR_Coverage, 60510,
     /* 1086588 */     GIR_EraseRootFromParent_Done,
     /* 1086589 */   // Label 15991: @1086589
     /* 1086589 */   GIM_Try, /*On fail goto*//*Label 15992*/ GIMT_Encode4(1086666), // Rule ID 60511 //
     /* 1086594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1086605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1086608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1086611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1086614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086633 */     // MIs[0] policy
     /* 1086633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086643 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086652 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1086662 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086665 */     // GIR_Coverage, 60511,
     /* 1086665 */     GIR_EraseRootFromParent_Done,
     /* 1086666 */   // Label 15992: @1086666
     /* 1086666 */   GIM_Try, /*On fail goto*//*Label 15993*/ GIMT_Encode4(1086743), // Rule ID 60514 //
     /* 1086671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086710 */     // MIs[0] policy
     /* 1086710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086720 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086739 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086742 */     // GIR_Coverage, 60514,
     /* 1086742 */     GIR_EraseRootFromParent_Done,
     /* 1086743 */   // Label 15993: @1086743
     /* 1086743 */   GIM_Try, /*On fail goto*//*Label 15994*/ GIMT_Encode4(1086820), // Rule ID 60515 //
     /* 1086748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1086759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1086762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1086765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1086768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086787 */     // MIs[0] policy
     /* 1086787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086797 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2_MASK),
     /* 1086800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086806 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1086816 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086819 */     // GIR_Coverage, 60515,
     /* 1086819 */     GIR_EraseRootFromParent_Done,
     /* 1086820 */   // Label 15994: @1086820
     /* 1086820 */   GIM_Try, /*On fail goto*//*Label 15995*/ GIMT_Encode4(1086897), // Rule ID 60518 //
     /* 1086825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1086836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1086839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1086842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1086845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1086848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086864 */     // MIs[0] policy
     /* 1086864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1086874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1086877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086896 */     // GIR_Coverage, 60518,
     /* 1086896 */     GIR_EraseRootFromParent_Done,
     /* 1086897 */   // Label 15995: @1086897
     /* 1086897 */   GIM_Try, /*On fail goto*//*Label 15996*/ GIMT_Encode4(1086974), // Rule ID 60519 //
     /* 1086902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1086905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1086913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1086916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1086919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1086922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1086925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1086929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1086937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1086941 */     // MIs[0] policy
     /* 1086941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1086944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1086951 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11096:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1086951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1086954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1086956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1086958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1086960 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1086962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1086967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1086970 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1086972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1086973 */     // GIR_Coverage, 60519,
     /* 1086973 */     GIR_EraseRootFromParent_Done,
     /* 1086974 */   // Label 15996: @1086974
     /* 1086974 */   GIM_Try, /*On fail goto*//*Label 15997*/ GIMT_Encode4(1087051), // Rule ID 60522 //
     /* 1086979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1086982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1086987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1086990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1086993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1086996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1086999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087018 */     // MIs[0] policy
     /* 1087018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087028 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087050 */     // GIR_Coverage, 60522,
     /* 1087050 */     GIR_EraseRootFromParent_Done,
     /* 1087051 */   // Label 15997: @1087051
     /* 1087051 */   GIM_Try, /*On fail goto*//*Label 15998*/ GIMT_Encode4(1087128), // Rule ID 60523 //
     /* 1087056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1087067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1087070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1087073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1087076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087095 */     // MIs[0] policy
     /* 1087095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087105 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11096:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087127 */     // GIR_Coverage, 60523,
     /* 1087127 */     GIR_EraseRootFromParent_Done,
     /* 1087128 */   // Label 15998: @1087128
     /* 1087128 */   GIM_Try, /*On fail goto*//*Label 15999*/ GIMT_Encode4(1087205), // Rule ID 60526 //
     /* 1087133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087172 */     // MIs[0] policy
     /* 1087172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087182 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087204 */     // GIR_Coverage, 60526,
     /* 1087204 */     GIR_EraseRootFromParent_Done,
     /* 1087205 */   // Label 15999: @1087205
     /* 1087205 */   GIM_Try, /*On fail goto*//*Label 16000*/ GIMT_Encode4(1087282), // Rule ID 60527 //
     /* 1087210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1087221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1087224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1087227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1087230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087249 */     // MIs[0] policy
     /* 1087249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087259 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11096:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087268 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1087278 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087281 */     // GIR_Coverage, 60527,
     /* 1087281 */     GIR_EraseRootFromParent_Done,
     /* 1087282 */   // Label 16000: @1087282
     /* 1087282 */   GIM_Try, /*On fail goto*//*Label 16001*/ GIMT_Encode4(1087359), // Rule ID 60530 //
     /* 1087287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087326 */     // MIs[0] policy
     /* 1087326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087355 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087358 */     // GIR_Coverage, 60530,
     /* 1087358 */     GIR_EraseRootFromParent_Done,
     /* 1087359 */   // Label 16001: @1087359
     /* 1087359 */   GIM_Try, /*On fail goto*//*Label 16002*/ GIMT_Encode4(1087436), // Rule ID 60531 //
     /* 1087364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1087375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1087378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1087381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1087384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1087391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1087399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087403 */     // MIs[0] policy
     /* 1087403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087413 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11096:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1_MASK),
     /* 1087416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1087432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087435 */     // GIR_Coverage, 60531,
     /* 1087435 */     GIR_EraseRootFromParent_Done,
     /* 1087436 */   // Label 16002: @1087436
     /* 1087436 */   GIM_Try, /*On fail goto*//*Label 16003*/ GIMT_Encode4(1087513), // Rule ID 60534 //
     /* 1087441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1087458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1087461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1087468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087480 */     // MIs[0] policy
     /* 1087480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1087493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087509 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087512 */     // GIR_Coverage, 60534,
     /* 1087512 */     GIR_EraseRootFromParent_Done,
     /* 1087513 */   // Label 16003: @1087513
     /* 1087513 */   GIM_Try, /*On fail goto*//*Label 16004*/ GIMT_Encode4(1087590), // Rule ID 60535 //
     /* 1087518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1087529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1087532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1087535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1087538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1087545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087557 */     // MIs[0] policy
     /* 1087557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087567 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1087570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087576 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087586 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087589 */     // GIR_Coverage, 60535,
     /* 1087589 */     GIR_EraseRootFromParent_Done,
     /* 1087590 */   // Label 16004: @1087590
     /* 1087590 */   GIM_Try, /*On fail goto*//*Label 16005*/ GIMT_Encode4(1087667), // Rule ID 60538 //
     /* 1087595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1087606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1087609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1087612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1087615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1087622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087634 */     // MIs[0] policy
     /* 1087634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087644 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1087647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087653 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087663 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087666 */     // GIR_Coverage, 60538,
     /* 1087666 */     GIR_EraseRootFromParent_Done,
     /* 1087667 */   // Label 16005: @1087667
     /* 1087667 */   GIM_Try, /*On fail goto*//*Label 16006*/ GIMT_Encode4(1087744), // Rule ID 60539 //
     /* 1087672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1087683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1087686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1087689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1087692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1087699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1087707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087711 */     // MIs[0] policy
     /* 1087711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087721 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1087724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087730 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087740 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087743 */     // GIR_Coverage, 60539,
     /* 1087743 */     GIR_EraseRootFromParent_Done,
     /* 1087744 */   // Label 16006: @1087744
     /* 1087744 */   GIM_Try, /*On fail goto*//*Label 16007*/ GIMT_Encode4(1087821), // Rule ID 60542 //
     /* 1087749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1087760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1087763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1087766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1087769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1087776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087788 */     // MIs[0] policy
     /* 1087788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087798 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1087801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087817 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087820 */     // GIR_Coverage, 60542,
     /* 1087820 */     GIR_EraseRootFromParent_Done,
     /* 1087821 */   // Label 16007: @1087821
     /* 1087821 */   GIM_Try, /*On fail goto*//*Label 16008*/ GIMT_Encode4(1087898), // Rule ID 60543 //
     /* 1087826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1087837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1087840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1087843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1087846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1087849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1087853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1087861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087865 */     // MIs[0] policy
     /* 1087865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087875 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1087875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1087878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1087894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087897 */     // GIR_Coverage, 60543,
     /* 1087897 */     GIR_EraseRootFromParent_Done,
     /* 1087898 */   // Label 16008: @1087898
     /* 1087898 */   GIM_Try, /*On fail goto*//*Label 16009*/ GIMT_Encode4(1087975), // Rule ID 60546 //
     /* 1087903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1087906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1087914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1087917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1087920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1087923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1087926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1087930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1087938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1087942 */     // MIs[0] policy
     /* 1087942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1087945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1087952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1087952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1087955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1087957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1087959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1087961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1087963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1087968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1087971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1087973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1087974 */     // GIR_Coverage, 60546,
     /* 1087974 */     GIR_EraseRootFromParent_Done,
     /* 1087975 */   // Label 16009: @1087975
     /* 1087975 */   GIM_Try, /*On fail goto*//*Label 16010*/ GIMT_Encode4(1088052), // Rule ID 60547 //
     /* 1087980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1087983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1087988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1087991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1087994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1087997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088019 */     // MIs[0] policy
     /* 1088019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088029 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088050 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088051 */     // GIR_Coverage, 60547,
     /* 1088051 */     GIR_EraseRootFromParent_Done,
     /* 1088052 */   // Label 16010: @1088052
     /* 1088052 */   GIM_Try, /*On fail goto*//*Label 16011*/ GIMT_Encode4(1088129), // Rule ID 60550 //
     /* 1088057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088096 */     // MIs[0] policy
     /* 1088096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088106 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088125 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088128 */     // GIR_Coverage, 60550,
     /* 1088128 */     GIR_EraseRootFromParent_Done,
     /* 1088129 */   // Label 16011: @1088129
     /* 1088129 */   GIM_Try, /*On fail goto*//*Label 16012*/ GIMT_Encode4(1088206), // Rule ID 60551 //
     /* 1088134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1088145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1088148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1088151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088173 */     // MIs[0] policy
     /* 1088173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088183 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088205 */     // GIR_Coverage, 60551,
     /* 1088205 */     GIR_EraseRootFromParent_Done,
     /* 1088206 */   // Label 16012: @1088206
     /* 1088206 */   GIM_Try, /*On fail goto*//*Label 16013*/ GIMT_Encode4(1088283), // Rule ID 60554 //
     /* 1088211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088250 */     // MIs[0] policy
     /* 1088250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088260 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088279 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088282 */     // GIR_Coverage, 60554,
     /* 1088282 */     GIR_EraseRootFromParent_Done,
     /* 1088283 */   // Label 16013: @1088283
     /* 1088283 */   GIM_Try, /*On fail goto*//*Label 16014*/ GIMT_Encode4(1088360), // Rule ID 60555 //
     /* 1088288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1088299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1088302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1088305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1088308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088327 */     // MIs[0] policy
     /* 1088327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088337 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088346 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1088356 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088359 */     // GIR_Coverage, 60555,
     /* 1088359 */     GIR_EraseRootFromParent_Done,
     /* 1088360 */   // Label 16014: @1088360
     /* 1088360 */   GIM_Try, /*On fail goto*//*Label 16015*/ GIMT_Encode4(1088437), // Rule ID 60558 //
     /* 1088365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088404 */     // MIs[0] policy
     /* 1088404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088423 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088433 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088436 */     // GIR_Coverage, 60558,
     /* 1088436 */     GIR_EraseRootFromParent_Done,
     /* 1088437 */   // Label 16015: @1088437
     /* 1088437 */   GIM_Try, /*On fail goto*//*Label 16016*/ GIMT_Encode4(1088514), // Rule ID 60559 //
     /* 1088442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1088453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1088456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1088459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1088462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088481 */     // MIs[0] policy
     /* 1088481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088491 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088500 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088510 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088513 */     // GIR_Coverage, 60559,
     /* 1088513 */     GIR_EraseRootFromParent_Done,
     /* 1088514 */   // Label 16016: @1088514
     /* 1088514 */   GIM_Try, /*On fail goto*//*Label 16017*/ GIMT_Encode4(1088591), // Rule ID 60562 //
     /* 1088519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1088530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1088533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1088536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088558 */     // MIs[0] policy
     /* 1088558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088568 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088587 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088590 */     // GIR_Coverage, 60562,
     /* 1088590 */     GIR_EraseRootFromParent_Done,
     /* 1088591 */   // Label 16017: @1088591
     /* 1088591 */   GIM_Try, /*On fail goto*//*Label 16018*/ GIMT_Encode4(1088668), // Rule ID 60563 //
     /* 1088596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1088607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1088610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1088613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1088616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1088623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1088631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088635 */     // MIs[0] policy
     /* 1088635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088645 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1088648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088654 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088664 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088667 */     // GIR_Coverage, 60563,
     /* 1088667 */     GIR_EraseRootFromParent_Done,
     /* 1088668 */   // Label 16018: @1088668
     /* 1088668 */   GIM_Try, /*On fail goto*//*Label 16019*/ GIMT_Encode4(1088745), // Rule ID 60566 //
     /* 1088673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1088684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1088687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1088690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088712 */     // MIs[0] policy
     /* 1088712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088741 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088744 */     // GIR_Coverage, 60566,
     /* 1088744 */     GIR_EraseRootFromParent_Done,
     /* 1088745 */   // Label 16019: @1088745
     /* 1088745 */   GIM_Try, /*On fail goto*//*Label 16020*/ GIMT_Encode4(1088822), // Rule ID 60567 //
     /* 1088750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1088761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1088764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1088767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1088770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1088777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1088785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088789 */     // MIs[0] policy
     /* 1088789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1088802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088808 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1088818 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088821 */     // GIR_Coverage, 60567,
     /* 1088821 */     GIR_EraseRootFromParent_Done,
     /* 1088822 */   // Label 16020: @1088822
     /* 1088822 */   GIM_Try, /*On fail goto*//*Label 16021*/ GIMT_Encode4(1088899), // Rule ID 60570 //
     /* 1088827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1088838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1088841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1088844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1088850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088866 */     // MIs[0] policy
     /* 1088866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1088876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088885 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088895 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088898 */     // GIR_Coverage, 60570,
     /* 1088898 */     GIR_EraseRootFromParent_Done,
     /* 1088899 */   // Label 16021: @1088899
     /* 1088899 */   GIM_Try, /*On fail goto*//*Label 16022*/ GIMT_Encode4(1088976), // Rule ID 60571 //
     /* 1088904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1088907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1088915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1088918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1088921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1088924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1088927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1088931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1088939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1088943 */     // MIs[0] policy
     /* 1088943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1088946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1088953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11096:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1088953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2_MASK),
     /* 1088956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1088958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1088960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1088962 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1088964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1088969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1088972 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1088974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1088975 */     // GIR_Coverage, 60571,
     /* 1088975 */     GIR_EraseRootFromParent_Done,
     /* 1088976 */   // Label 16022: @1088976
     /* 1088976 */   GIM_Try, /*On fail goto*//*Label 16023*/ GIMT_Encode4(1089053), // Rule ID 60574 //
     /* 1088981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1088984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1088989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1088992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1088995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1088998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089020 */     // MIs[0] policy
     /* 1089020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089052 */     // GIR_Coverage, 60574,
     /* 1089052 */     GIR_EraseRootFromParent_Done,
     /* 1089053 */   // Label 16023: @1089053
     /* 1089053 */   GIM_Try, /*On fail goto*//*Label 16024*/ GIMT_Encode4(1089130), // Rule ID 60575 //
     /* 1089058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1089069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1089072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1089075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1089085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1089093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089097 */     // MIs[0] policy
     /* 1089097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089107 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11096:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4_MASK),
     /* 1089110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089129 */     // GIR_Coverage, 60575,
     /* 1089129 */     GIR_EraseRootFromParent_Done,
     /* 1089130 */   // Label 16024: @1089130
     /* 1089130 */   GIM_Try, /*On fail goto*//*Label 16025*/ GIMT_Encode4(1089207), // Rule ID 60578 //
     /* 1089135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089174 */     // MIs[0] policy
     /* 1089174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089203 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089206 */     // GIR_Coverage, 60578,
     /* 1089206 */     GIR_EraseRootFromParent_Done,
     /* 1089207 */   // Label 16025: @1089207
     /* 1089207 */   GIM_Try, /*On fail goto*//*Label 16026*/ GIMT_Encode4(1089284), // Rule ID 60579 //
     /* 1089212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev_mask),
     /* 1089220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1089223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1089226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1089229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1089232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1089239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1089247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089251 */     // MIs[0] policy
     /* 1089251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089261 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11096:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8_MASK),
     /* 1089264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089266 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089270 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1089280 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089283 */     // GIR_Coverage, 60579,
     /* 1089283 */     GIR_EraseRootFromParent_Done,
     /* 1089284 */   // Label 16026: @1089284
     /* 1089284 */   GIM_Try, /*On fail goto*//*Label 16027*/ GIMT_Encode4(1089361), // Rule ID 60582 //
     /* 1089289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089328 */     // MIs[0] policy
     /* 1089328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089338 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089357 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089360 */     // GIR_Coverage, 60582,
     /* 1089360 */     GIR_EraseRootFromParent_Done,
     /* 1089361 */   // Label 16027: @1089361
     /* 1089361 */   GIM_Try, /*On fail goto*//*Label 16028*/ GIMT_Encode4(1089438), // Rule ID 60583 //
     /* 1089366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1089377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1089380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1089383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089405 */     // MIs[0] policy
     /* 1089405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089415 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8_MASK),
     /* 1089418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089424 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089434 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089437 */     // GIR_Coverage, 60583,
     /* 1089437 */     GIR_EraseRootFromParent_Done,
     /* 1089438 */   // Label 16028: @1089438
     /* 1089438 */   GIM_Try, /*On fail goto*//*Label 16029*/ GIMT_Encode4(1089515), // Rule ID 60586 //
     /* 1089443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1089454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1089457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1089460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089482 */     // MIs[0] policy
     /* 1089482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089492 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1089495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089511 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089514 */     // GIR_Coverage, 60586,
     /* 1089514 */     GIR_EraseRootFromParent_Done,
     /* 1089515 */   // Label 16029: @1089515
     /* 1089515 */   GIM_Try, /*On fail goto*//*Label 16030*/ GIMT_Encode4(1089592), // Rule ID 60587 //
     /* 1089520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1089531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1089534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1089537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089559 */     // MIs[0] policy
     /* 1089559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089569 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1089572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089578 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089588 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089591 */     // GIR_Coverage, 60587,
     /* 1089591 */     GIR_EraseRootFromParent_Done,
     /* 1089592 */   // Label 16030: @1089592
     /* 1089592 */   GIM_Try, /*On fail goto*//*Label 16031*/ GIMT_Encode4(1089669), // Rule ID 60590 //
     /* 1089597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1089608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1089611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1089614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089636 */     // MIs[0] policy
     /* 1089636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089646 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1089649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089668 */     // GIR_Coverage, 60590,
     /* 1089668 */     GIR_EraseRootFromParent_Done,
     /* 1089669 */   // Label 16031: @1089669
     /* 1089669 */   GIM_Try, /*On fail goto*//*Label 16032*/ GIMT_Encode4(1089746), // Rule ID 60591 //
     /* 1089674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1089685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1089688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1089691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1089694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089713 */     // MIs[0] policy
     /* 1089713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089723 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1089726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1089742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089745 */     // GIR_Coverage, 60591,
     /* 1089745 */     GIR_EraseRootFromParent_Done,
     /* 1089746 */   // Label 16032: @1089746
     /* 1089746 */   GIM_Try, /*On fail goto*//*Label 16033*/ GIMT_Encode4(1089823), // Rule ID 60594 //
     /* 1089751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1089762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1089765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1089768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089790 */     // MIs[0] policy
     /* 1089790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089800 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1089803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089822 */     // GIR_Coverage, 60594,
     /* 1089822 */     GIR_EraseRootFromParent_Done,
     /* 1089823 */   // Label 16033: @1089823
     /* 1089823 */   GIM_Try, /*On fail goto*//*Label 16034*/ GIMT_Encode4(1089900), // Rule ID 60595 //
     /* 1089828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1089839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1089842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1089845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1089848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1089851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089867 */     // MIs[0] policy
     /* 1089867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089877 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1089877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4_MASK),
     /* 1089880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089886 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089896 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089899 */     // GIR_Coverage, 60595,
     /* 1089899 */     GIR_EraseRootFromParent_Done,
     /* 1089900 */   // Label 16034: @1089900
     /* 1089900 */   GIM_Try, /*On fail goto*//*Label 16035*/ GIMT_Encode4(1089977), // Rule ID 60598 //
     /* 1089905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1089908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1089916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1089919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1089922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1089925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1089928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1089932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1089940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1089944 */     // MIs[0] policy
     /* 1089944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1089947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1089954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1089954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1089957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1089959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1089961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1089963 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1089965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1089970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1089973 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1089975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1089976 */     // GIR_Coverage, 60598,
     /* 1089976 */     GIR_EraseRootFromParent_Done,
     /* 1089977 */   // Label 16035: @1089977
     /* 1089977 */   GIM_Try, /*On fail goto*//*Label 16036*/ GIMT_Encode4(1090054), // Rule ID 60599 //
     /* 1089982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1089985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1089990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1089993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1089996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1089999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090021 */     // MIs[0] policy
     /* 1090021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090031 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090040 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090050 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090053 */     // GIR_Coverage, 60599,
     /* 1090053 */     GIR_EraseRootFromParent_Done,
     /* 1090054 */   // Label 16036: @1090054
     /* 1090054 */   GIM_Try, /*On fail goto*//*Label 16037*/ GIMT_Encode4(1090131), // Rule ID 60602 //
     /* 1090059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090098 */     // MIs[0] policy
     /* 1090098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090127 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090130 */     // GIR_Coverage, 60602,
     /* 1090130 */     GIR_EraseRootFromParent_Done,
     /* 1090131 */   // Label 16037: @1090131
     /* 1090131 */   GIM_Try, /*On fail goto*//*Label 16038*/ GIMT_Encode4(1090208), // Rule ID 60603 //
     /* 1090136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1090147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1090150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1090153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090175 */     // MIs[0] policy
     /* 1090175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090185 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2_MASK),
     /* 1090188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090194 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090204 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090207 */     // GIR_Coverage, 60603,
     /* 1090207 */     GIR_EraseRootFromParent_Done,
     /* 1090208 */   // Label 16038: @1090208
     /* 1090208 */   GIM_Try, /*On fail goto*//*Label 16039*/ GIMT_Encode4(1090285), // Rule ID 60606 //
     /* 1090213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090252 */     // MIs[0] policy
     /* 1090252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090281 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090284 */     // GIR_Coverage, 60606,
     /* 1090284 */     GIR_EraseRootFromParent_Done,
     /* 1090285 */   // Label 16039: @1090285
     /* 1090285 */   GIM_Try, /*On fail goto*//*Label 16040*/ GIMT_Encode4(1090362), // Rule ID 60607 //
     /* 1090290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1090301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1090304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1090307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1090310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090329 */     // MIs[0] policy
     /* 1090329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090339 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11104:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090348 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090358 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090361 */     // GIR_Coverage, 60607,
     /* 1090361 */     GIR_EraseRootFromParent_Done,
     /* 1090362 */   // Label 16040: @1090362
     /* 1090362 */   GIM_Try, /*On fail goto*//*Label 16041*/ GIMT_Encode4(1090439), // Rule ID 60610 //
     /* 1090367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090406 */     // MIs[0] policy
     /* 1090406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090435 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090438 */     // GIR_Coverage, 60610,
     /* 1090438 */     GIR_EraseRootFromParent_Done,
     /* 1090439 */   // Label 16041: @1090439
     /* 1090439 */   GIM_Try, /*On fail goto*//*Label 16042*/ GIMT_Encode4(1090516), // Rule ID 60611 //
     /* 1090444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1090455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1090458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1090461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1090464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090483 */     // MIs[0] policy
     /* 1090483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11104:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090502 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1090512 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090515 */     // GIR_Coverage, 60611,
     /* 1090515 */     GIR_EraseRootFromParent_Done,
     /* 1090516 */   // Label 16042: @1090516
     /* 1090516 */   GIM_Try, /*On fail goto*//*Label 16043*/ GIMT_Encode4(1090593), // Rule ID 60614 //
     /* 1090521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1090532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1090535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1090538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090560 */     // MIs[0] policy
     /* 1090560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090589 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090592 */     // GIR_Coverage, 60614,
     /* 1090592 */     GIR_EraseRootFromParent_Done,
     /* 1090593 */   // Label 16043: @1090593
     /* 1090593 */   GIM_Try, /*On fail goto*//*Label 16044*/ GIMT_Encode4(1090670), // Rule ID 60615 //
     /* 1090598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1090609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1090612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1090615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1090618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090637 */     // MIs[0] policy
     /* 1090637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090647 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11104:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1090666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090669 */     // GIR_Coverage, 60615,
     /* 1090669 */     GIR_EraseRootFromParent_Done,
     /* 1090670 */   // Label 16044: @1090670
     /* 1090670 */   GIM_Try, /*On fail goto*//*Label 16045*/ GIMT_Encode4(1090747), // Rule ID 60618 //
     /* 1090675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1090686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1090689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1090692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090714 */     // MIs[0] policy
     /* 1090714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090746 */     // GIR_Coverage, 60618,
     /* 1090746 */     GIR_EraseRootFromParent_Done,
     /* 1090747 */   // Label 16045: @1090747
     /* 1090747 */   GIM_Try, /*On fail goto*//*Label 16046*/ GIMT_Encode4(1090824), // Rule ID 60619 //
     /* 1090752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1090763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1090766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1090769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1090772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1090779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1090787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090791 */     // MIs[0] policy
     /* 1090791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090801 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11104:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1_MASK),
     /* 1090804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090810 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1090820 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090823 */     // GIR_Coverage, 60619,
     /* 1090823 */     GIR_EraseRootFromParent_Done,
     /* 1090824 */   // Label 16046: @1090824
     /* 1090824 */   GIM_Try, /*On fail goto*//*Label 16047*/ GIMT_Encode4(1090901), // Rule ID 60622 //
     /* 1090829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1090840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1090843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1090846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1090849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1090852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1090856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090868 */     // MIs[0] policy
     /* 1090868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1090878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1090881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090897 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090900 */     // GIR_Coverage, 60622,
     /* 1090900 */     GIR_EraseRootFromParent_Done,
     /* 1090901 */   // Label 16047: @1090901
     /* 1090901 */   GIM_Try, /*On fail goto*//*Label 16048*/ GIMT_Encode4(1090978), // Rule ID 60623 //
     /* 1090906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1090909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1090917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1090920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1090923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1090926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1090929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1090933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1090941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1090945 */     // MIs[0] policy
     /* 1090945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1090948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1090955 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1090955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1090958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1090960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1090962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1090964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1090966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1090971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1090974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1090976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1090977 */     // GIR_Coverage, 60623,
     /* 1090977 */     GIR_EraseRootFromParent_Done,
     /* 1090978 */   // Label 16048: @1090978
     /* 1090978 */   GIM_Try, /*On fail goto*//*Label 16049*/ GIMT_Encode4(1091055), // Rule ID 60626 //
     /* 1090983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1090986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1090991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1090994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1090997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091022 */     // MIs[0] policy
     /* 1091022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091054 */     // GIR_Coverage, 60626,
     /* 1091054 */     GIR_EraseRootFromParent_Done,
     /* 1091055 */   // Label 16049: @1091055
     /* 1091055 */   GIM_Try, /*On fail goto*//*Label 16050*/ GIMT_Encode4(1091132), // Rule ID 60627 //
     /* 1091060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1091071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1091074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1091077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091099 */     // MIs[0] policy
     /* 1091099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091109 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091118 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091128 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091131 */     // GIR_Coverage, 60627,
     /* 1091131 */     GIR_EraseRootFromParent_Done,
     /* 1091132 */   // Label 16050: @1091132
     /* 1091132 */   GIM_Try, /*On fail goto*//*Label 16051*/ GIMT_Encode4(1091209), // Rule ID 60630 //
     /* 1091137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091176 */     // MIs[0] policy
     /* 1091176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091186 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091208 */     // GIR_Coverage, 60630,
     /* 1091208 */     GIR_EraseRootFromParent_Done,
     /* 1091209 */   // Label 16051: @1091209
     /* 1091209 */   GIM_Try, /*On fail goto*//*Label 16052*/ GIMT_Encode4(1091286), // Rule ID 60631 //
     /* 1091214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1091225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1091228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1091231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1091234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091253 */     // MIs[0] policy
     /* 1091253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091263 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091272 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1091282 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091285 */     // GIR_Coverage, 60631,
     /* 1091285 */     GIR_EraseRootFromParent_Done,
     /* 1091286 */   // Label 16052: @1091286
     /* 1091286 */   GIM_Try, /*On fail goto*//*Label 16053*/ GIMT_Encode4(1091363), // Rule ID 60634 //
     /* 1091291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091330 */     // MIs[0] policy
     /* 1091330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091340 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091359 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091362 */     // GIR_Coverage, 60634,
     /* 1091362 */     GIR_EraseRootFromParent_Done,
     /* 1091363 */   // Label 16053: @1091363
     /* 1091363 */   GIM_Try, /*On fail goto*//*Label 16054*/ GIMT_Encode4(1091440), // Rule ID 60635 //
     /* 1091368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1091379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1091382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1091385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091407 */     // MIs[0] policy
     /* 1091407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091426 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091436 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091439 */     // GIR_Coverage, 60635,
     /* 1091439 */     GIR_EraseRootFromParent_Done,
     /* 1091440 */   // Label 16054: @1091440
     /* 1091440 */   GIM_Try, /*On fail goto*//*Label 16055*/ GIMT_Encode4(1091517), // Rule ID 60638 //
     /* 1091445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1091456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1091459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1091462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091484 */     // MIs[0] policy
     /* 1091484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091494 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091503 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091513 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091516 */     // GIR_Coverage, 60638,
     /* 1091516 */     GIR_EraseRootFromParent_Done,
     /* 1091517 */   // Label 16055: @1091517
     /* 1091517 */   GIM_Try, /*On fail goto*//*Label 16056*/ GIMT_Encode4(1091594), // Rule ID 60639 //
     /* 1091522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1091533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1091536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1091539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1091542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091561 */     // MIs[0] policy
     /* 1091561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091571 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091580 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091590 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091593 */     // GIR_Coverage, 60639,
     /* 1091593 */     GIR_EraseRootFromParent_Done,
     /* 1091594 */   // Label 16056: @1091594
     /* 1091594 */   GIM_Try, /*On fail goto*//*Label 16057*/ GIMT_Encode4(1091671), // Rule ID 60642 //
     /* 1091599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1091610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1091613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1091616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091638 */     // MIs[0] policy
     /* 1091638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091667 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091670 */     // GIR_Coverage, 60642,
     /* 1091670 */     GIR_EraseRootFromParent_Done,
     /* 1091671 */   // Label 16057: @1091671
     /* 1091671 */   GIM_Try, /*On fail goto*//*Label 16058*/ GIMT_Encode4(1091748), // Rule ID 60643 //
     /* 1091676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1091687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1091690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1091693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1091696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1091703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1091711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091715 */     // MIs[0] policy
     /* 1091715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091725 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1091728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091734 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1091744 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091747 */     // GIR_Coverage, 60643,
     /* 1091747 */     GIR_EraseRootFromParent_Done,
     /* 1091748 */   // Label 16058: @1091748
     /* 1091748 */   GIM_Try, /*On fail goto*//*Label 16059*/ GIMT_Encode4(1091825), // Rule ID 60646 //
     /* 1091753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1091764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1091767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1091770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091792 */     // MIs[0] policy
     /* 1091792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091802 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091824 */     // GIR_Coverage, 60646,
     /* 1091824 */     GIR_EraseRootFromParent_Done,
     /* 1091825 */   // Label 16059: @1091825
     /* 1091825 */   GIM_Try, /*On fail goto*//*Label 16060*/ GIMT_Encode4(1091902), // Rule ID 60647 //
     /* 1091830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1091841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1091844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1091847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1091850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1091853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1091857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1091865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091869 */     // MIs[0] policy
     /* 1091869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091879 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1091879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1091882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091901 */     // GIR_Coverage, 60647,
     /* 1091901 */     GIR_EraseRootFromParent_Done,
     /* 1091902 */   // Label 16060: @1091902
     /* 1091902 */   GIM_Try, /*On fail goto*//*Label 16061*/ GIMT_Encode4(1091979), // Rule ID 60650 //
     /* 1091907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1091910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1091918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1091921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1091924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1091927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1091930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1091934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1091942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1091946 */     // MIs[0] policy
     /* 1091946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1091949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1091956 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1091956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1091959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1091961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1091963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1091965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1091967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1091972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1091975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1091977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1091978 */     // GIR_Coverage, 60650,
     /* 1091978 */     GIR_EraseRootFromParent_Done,
     /* 1091979 */   // Label 16061: @1091979
     /* 1091979 */   GIM_Try, /*On fail goto*//*Label 16062*/ GIMT_Encode4(1092056), // Rule ID 60651 //
     /* 1091984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1091987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1091992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1091995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1091998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1092001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092023 */     // MIs[0] policy
     /* 1092023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092033 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092055 */     // GIR_Coverage, 60651,
     /* 1092055 */     GIR_EraseRootFromParent_Done,
     /* 1092056 */   // Label 16062: @1092056
     /* 1092056 */   GIM_Try, /*On fail goto*//*Label 16063*/ GIMT_Encode4(1092133), // Rule ID 60654 //
     /* 1092061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092100 */     // MIs[0] policy
     /* 1092100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092110 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092132 */     // GIR_Coverage, 60654,
     /* 1092132 */     GIR_EraseRootFromParent_Done,
     /* 1092133 */   // Label 16063: @1092133
     /* 1092133 */   GIM_Try, /*On fail goto*//*Label 16064*/ GIMT_Encode4(1092210), // Rule ID 60655 //
     /* 1092138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1092149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1092152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1092155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1092158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092177 */     // MIs[0] policy
     /* 1092177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092187 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092196 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1092206 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092209 */     // GIR_Coverage, 60655,
     /* 1092209 */     GIR_EraseRootFromParent_Done,
     /* 1092210 */   // Label 16064: @1092210
     /* 1092210 */   GIM_Try, /*On fail goto*//*Label 16065*/ GIMT_Encode4(1092287), // Rule ID 60658 //
     /* 1092215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092254 */     // MIs[0] policy
     /* 1092254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092283 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092286 */     // GIR_Coverage, 60658,
     /* 1092286 */     GIR_EraseRootFromParent_Done,
     /* 1092287 */   // Label 16065: @1092287
     /* 1092287 */   GIM_Try, /*On fail goto*//*Label 16066*/ GIMT_Encode4(1092364), // Rule ID 60659 //
     /* 1092292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1092303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1092306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1092309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1092319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1092327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092331 */     // MIs[0] policy
     /* 1092331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092341 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11104:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2_MASK),
     /* 1092344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092362 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092363 */     // GIR_Coverage, 60659,
     /* 1092363 */     GIR_EraseRootFromParent_Done,
     /* 1092364 */   // Label 16066: @1092364
     /* 1092364 */   GIM_Try, /*On fail goto*//*Label 16067*/ GIMT_Encode4(1092441), // Rule ID 60662 //
     /* 1092369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092408 */     // MIs[0] policy
     /* 1092408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092440 */     // GIR_Coverage, 60662,
     /* 1092440 */     GIR_EraseRootFromParent_Done,
     /* 1092441 */   // Label 16067: @1092441
     /* 1092441 */   GIM_Try, /*On fail goto*//*Label 16068*/ GIMT_Encode4(1092518), // Rule ID 60663 //
     /* 1092446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1092457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1092460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1092463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1092466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1092473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1092481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092485 */     // MIs[0] policy
     /* 1092485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092495 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11104:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4_MASK),
     /* 1092498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092517 */     // GIR_Coverage, 60663,
     /* 1092517 */     GIR_EraseRootFromParent_Done,
     /* 1092518 */   // Label 16068: @1092518
     /* 1092518 */   GIM_Try, /*On fail goto*//*Label 16069*/ GIMT_Encode4(1092595), // Rule ID 60666 //
     /* 1092523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1092534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1092537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1092540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092562 */     // MIs[0] policy
     /* 1092562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092591 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092594 */     // GIR_Coverage, 60666,
     /* 1092594 */     GIR_EraseRootFromParent_Done,
     /* 1092595 */   // Label 16069: @1092595
     /* 1092595 */   GIM_Try, /*On fail goto*//*Label 16070*/ GIMT_Encode4(1092672), // Rule ID 60667 //
     /* 1092600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclz_mask),
     /* 1092608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1092611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1092614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1092617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1092620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1092627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1092635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092639 */     // MIs[0] policy
     /* 1092639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092649 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11104:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8_MASK),
     /* 1092652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092658 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1092668 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092671 */     // GIR_Coverage, 60667,
     /* 1092671 */     GIR_EraseRootFromParent_Done,
     /* 1092672 */   // Label 16070: @1092672
     /* 1092672 */   GIM_Try, /*On fail goto*//*Label 16071*/ GIMT_Encode4(1092749), // Rule ID 60670 //
     /* 1092677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1092685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1092688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1092691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1092694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1092697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1092704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092716 */     // MIs[0] policy
     /* 1092716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092726 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1092729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092735 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092745 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092748 */     // GIR_Coverage, 60670,
     /* 1092748 */     GIR_EraseRootFromParent_Done,
     /* 1092749 */   // Label 16071: @1092749
     /* 1092749 */   GIM_Try, /*On fail goto*//*Label 16072*/ GIMT_Encode4(1092826), // Rule ID 60671 //
     /* 1092754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1092762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1092765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1092768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1092771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1092774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1092781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092793 */     // MIs[0] policy
     /* 1092793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092803 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8_MASK),
     /* 1092806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092812 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092822 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092825 */     // GIR_Coverage, 60671,
     /* 1092825 */     GIR_EraseRootFromParent_Done,
     /* 1092826 */   // Label 16072: @1092826
     /* 1092826 */   GIM_Try, /*On fail goto*//*Label 16073*/ GIMT_Encode4(1092903), // Rule ID 60674 //
     /* 1092831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1092839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1092842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1092845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1092848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1092854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1092858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092870 */     // MIs[0] policy
     /* 1092870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1092880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1092883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092899 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092902 */     // GIR_Coverage, 60674,
     /* 1092902 */     GIR_EraseRootFromParent_Done,
     /* 1092903 */   // Label 16073: @1092903
     /* 1092903 */   GIM_Try, /*On fail goto*//*Label 16074*/ GIMT_Encode4(1092980), // Rule ID 60675 //
     /* 1092908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1092911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1092916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1092919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1092922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1092925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1092928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1092931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1092935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1092943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1092947 */     // MIs[0] policy
     /* 1092947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1092950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1092957 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1092957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1092960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1092962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1092964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1092966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1092968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1092973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1092976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1092978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1092979 */     // GIR_Coverage, 60675,
     /* 1092979 */     GIR_EraseRootFromParent_Done,
     /* 1092980 */   // Label 16074: @1092980
     /* 1092980 */   GIM_Try, /*On fail goto*//*Label 16075*/ GIMT_Encode4(1093057), // Rule ID 60678 //
     /* 1092985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1092988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1092993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1092996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1092999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093024 */     // MIs[0] policy
     /* 1093024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093034 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093053 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093056 */     // GIR_Coverage, 60678,
     /* 1093056 */     GIR_EraseRootFromParent_Done,
     /* 1093057 */   // Label 16075: @1093057
     /* 1093057 */   GIM_Try, /*On fail goto*//*Label 16076*/ GIMT_Encode4(1093134), // Rule ID 60679 //
     /* 1093062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1093073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1093076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1093079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093101 */     // MIs[0] policy
     /* 1093101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093111 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093133 */     // GIR_Coverage, 60679,
     /* 1093133 */     GIR_EraseRootFromParent_Done,
     /* 1093134 */   // Label 16076: @1093134
     /* 1093134 */   GIM_Try, /*On fail goto*//*Label 16077*/ GIMT_Encode4(1093211), // Rule ID 60682 //
     /* 1093139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093178 */     // MIs[0] policy
     /* 1093178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093188 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093207 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093210 */     // GIR_Coverage, 60682,
     /* 1093210 */     GIR_EraseRootFromParent_Done,
     /* 1093211 */   // Label 16077: @1093211
     /* 1093211 */   GIM_Try, /*On fail goto*//*Label 16078*/ GIMT_Encode4(1093288), // Rule ID 60683 //
     /* 1093216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1093227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1093230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1093233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093255 */     // MIs[0] policy
     /* 1093255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093265 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4_MASK),
     /* 1093268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093274 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093284 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093287 */     // GIR_Coverage, 60683,
     /* 1093287 */     GIR_EraseRootFromParent_Done,
     /* 1093288 */   // Label 16078: @1093288
     /* 1093288 */   GIM_Try, /*On fail goto*//*Label 16079*/ GIMT_Encode4(1093365), // Rule ID 60686 //
     /* 1093293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093332 */     // MIs[0] policy
     /* 1093332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093342 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093364 */     // GIR_Coverage, 60686,
     /* 1093364 */     GIR_EraseRootFromParent_Done,
     /* 1093365 */   // Label 16079: @1093365
     /* 1093365 */   GIM_Try, /*On fail goto*//*Label 16080*/ GIMT_Encode4(1093442), // Rule ID 60687 //
     /* 1093370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1093381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1093384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1093387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093409 */     // MIs[0] policy
     /* 1093409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093419 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093441 */     // GIR_Coverage, 60687,
     /* 1093441 */     GIR_EraseRootFromParent_Done,
     /* 1093442 */   // Label 16080: @1093442
     /* 1093442 */   GIM_Try, /*On fail goto*//*Label 16081*/ GIMT_Encode4(1093519), // Rule ID 60690 //
     /* 1093447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1093458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1093461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1093464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093486 */     // MIs[0] policy
     /* 1093486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093515 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093518 */     // GIR_Coverage, 60690,
     /* 1093518 */     GIR_EraseRootFromParent_Done,
     /* 1093519 */   // Label 16081: @1093519
     /* 1093519 */   GIM_Try, /*On fail goto*//*Label 16082*/ GIMT_Encode4(1093596), // Rule ID 60691 //
     /* 1093524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1093535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1093538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1093541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1093544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093563 */     // MIs[0] policy
     /* 1093563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093573 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2_MASK),
     /* 1093576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093582 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093592 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093595 */     // GIR_Coverage, 60691,
     /* 1093595 */     GIR_EraseRootFromParent_Done,
     /* 1093596 */   // Label 16082: @1093596
     /* 1093596 */   GIM_Try, /*On fail goto*//*Label 16083*/ GIMT_Encode4(1093673), // Rule ID 60694 //
     /* 1093601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1093612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1093615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1093618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093640 */     // MIs[0] policy
     /* 1093640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093650 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1093653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093669 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093672 */     // GIR_Coverage, 60694,
     /* 1093672 */     GIR_EraseRootFromParent_Done,
     /* 1093673 */   // Label 16083: @1093673
     /* 1093673 */   GIM_Try, /*On fail goto*//*Label 16084*/ GIMT_Encode4(1093750), // Rule ID 60695 //
     /* 1093678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1093689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1093692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1093695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1093698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093717 */     // MIs[0] policy
     /* 1093717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093727 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11111:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1093730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093736 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1093746 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093749 */     // GIR_Coverage, 60695,
     /* 1093749 */     GIR_EraseRootFromParent_Done,
     /* 1093750 */   // Label 16084: @1093750
     /* 1093750 */   GIM_Try, /*On fail goto*//*Label 16085*/ GIMT_Encode4(1093827), // Rule ID 60698 //
     /* 1093755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1093766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1093769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1093772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093794 */     // MIs[0] policy
     /* 1093794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1093807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093823 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093826 */     // GIR_Coverage, 60698,
     /* 1093826 */     GIR_EraseRootFromParent_Done,
     /* 1093827 */   // Label 16085: @1093827
     /* 1093827 */   GIM_Try, /*On fail goto*//*Label 16086*/ GIMT_Encode4(1093904), // Rule ID 60699 //
     /* 1093832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1093843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1093846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1093849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1093852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1093855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093871 */     // MIs[0] policy
     /* 1093871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093881 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11111:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1093881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1093884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093890 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1093900 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093903 */     // GIR_Coverage, 60699,
     /* 1093903 */     GIR_EraseRootFromParent_Done,
     /* 1093904 */   // Label 16086: @1093904
     /* 1093904 */   GIM_Try, /*On fail goto*//*Label 16087*/ GIMT_Encode4(1093981), // Rule ID 60702 //
     /* 1093909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1093912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1093920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1093923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1093926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1093929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1093932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1093936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1093944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1093948 */     // MIs[0] policy
     /* 1093948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1093951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1093958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1093958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1093961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1093963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1093965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1093967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1093969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1093974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1093977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1093979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1093980 */     // GIR_Coverage, 60702,
     /* 1093980 */     GIR_EraseRootFromParent_Done,
     /* 1093981 */   // Label 16087: @1093981
     /* 1093981 */   GIM_Try, /*On fail goto*//*Label 16088*/ GIMT_Encode4(1094058), // Rule ID 60703 //
     /* 1093986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1093989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1093994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1093997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1094000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1094003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1094006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094025 */     // MIs[0] policy
     /* 1094025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094035 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11111:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1094054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094057 */     // GIR_Coverage, 60703,
     /* 1094057 */     GIR_EraseRootFromParent_Done,
     /* 1094058 */   // Label 16088: @1094058
     /* 1094058 */   GIM_Try, /*On fail goto*//*Label 16089*/ GIMT_Encode4(1094135), // Rule ID 60706 //
     /* 1094063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094102 */     // MIs[0] policy
     /* 1094102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094112 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094131 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094134 */     // GIR_Coverage, 60706,
     /* 1094134 */     GIR_EraseRootFromParent_Done,
     /* 1094135 */   // Label 16089: @1094135
     /* 1094135 */   GIM_Try, /*On fail goto*//*Label 16090*/ GIMT_Encode4(1094212), // Rule ID 60707 //
     /* 1094140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1094151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1094154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1094157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1094160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1094167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1094175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094179 */     // MIs[0] policy
     /* 1094179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094189 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11111:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1_MASK),
     /* 1094192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094198 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1094208 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094211 */     // GIR_Coverage, 60707,
     /* 1094211 */     GIR_EraseRootFromParent_Done,
     /* 1094212 */   // Label 16090: @1094212
     /* 1094212 */   GIM_Try, /*On fail goto*//*Label 16091*/ GIMT_Encode4(1094289), // Rule ID 60710 //
     /* 1094217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094256 */     // MIs[0] policy
     /* 1094256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094275 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094285 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094288 */     // GIR_Coverage, 60710,
     /* 1094288 */     GIR_EraseRootFromParent_Done,
     /* 1094289 */   // Label 16091: @1094289
     /* 1094289 */   GIM_Try, /*On fail goto*//*Label 16092*/ GIMT_Encode4(1094366), // Rule ID 60711 //
     /* 1094294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1094305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1094308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1094311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094333 */     // MIs[0] policy
     /* 1094333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094352 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094362 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094365 */     // GIR_Coverage, 60711,
     /* 1094365 */     GIR_EraseRootFromParent_Done,
     /* 1094366 */   // Label 16092: @1094366
     /* 1094366 */   GIM_Try, /*On fail goto*//*Label 16093*/ GIMT_Encode4(1094443), // Rule ID 60714 //
     /* 1094371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094410 */     // MIs[0] policy
     /* 1094410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094439 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094442 */     // GIR_Coverage, 60714,
     /* 1094442 */     GIR_EraseRootFromParent_Done,
     /* 1094443 */   // Label 16093: @1094443
     /* 1094443 */   GIM_Try, /*On fail goto*//*Label 16094*/ GIMT_Encode4(1094520), // Rule ID 60715 //
     /* 1094448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1094459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1094462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1094465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1094468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094487 */     // MIs[0] policy
     /* 1094487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094497 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094506 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094516 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094519 */     // GIR_Coverage, 60715,
     /* 1094519 */     GIR_EraseRootFromParent_Done,
     /* 1094520 */   // Label 16094: @1094520
     /* 1094520 */   GIM_Try, /*On fail goto*//*Label 16095*/ GIMT_Encode4(1094597), // Rule ID 60718 //
     /* 1094525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1094536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1094539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1094542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1094545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1094552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094564 */     // MIs[0] policy
     /* 1094564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094574 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1094577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094596 */     // GIR_Coverage, 60718,
     /* 1094596 */     GIR_EraseRootFromParent_Done,
     /* 1094597 */   // Label 16095: @1094597
     /* 1094597 */   GIM_Try, /*On fail goto*//*Label 16096*/ GIMT_Encode4(1094674), // Rule ID 60719 //
     /* 1094602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1094613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1094616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1094619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1094622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1094629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1094637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094641 */     // MIs[0] policy
     /* 1094641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094651 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1094654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094660 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1094670 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094673 */     // GIR_Coverage, 60719,
     /* 1094673 */     GIR_EraseRootFromParent_Done,
     /* 1094674 */   // Label 16096: @1094674
     /* 1094674 */   GIM_Try, /*On fail goto*//*Label 16097*/ GIMT_Encode4(1094751), // Rule ID 60722 //
     /* 1094679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1094690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1094693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1094696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094718 */     // MIs[0] policy
     /* 1094718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094747 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094750 */     // GIR_Coverage, 60722,
     /* 1094750 */     GIR_EraseRootFromParent_Done,
     /* 1094751 */   // Label 16097: @1094751
     /* 1094751 */   GIM_Try, /*On fail goto*//*Label 16098*/ GIMT_Encode4(1094828), // Rule ID 60723 //
     /* 1094756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1094767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1094770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1094773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1094776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1094783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1094791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094795 */     // MIs[0] policy
     /* 1094795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1094808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094814 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094824 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094826 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094827 */     // GIR_Coverage, 60723,
     /* 1094827 */     GIR_EraseRootFromParent_Done,
     /* 1094828 */   // Label 16098: @1094828
     /* 1094828 */   GIM_Try, /*On fail goto*//*Label 16099*/ GIMT_Encode4(1094905), // Rule ID 60726 //
     /* 1094833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1094844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1094847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1094850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1094856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094872 */     // MIs[0] policy
     /* 1094872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094882 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1094882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094901 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094904 */     // GIR_Coverage, 60726,
     /* 1094904 */     GIR_EraseRootFromParent_Done,
     /* 1094905 */   // Label 16099: @1094905
     /* 1094905 */   GIM_Try, /*On fail goto*//*Label 16100*/ GIMT_Encode4(1094982), // Rule ID 60727 //
     /* 1094910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1094913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1094921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1094924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1094927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1094930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1094933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1094937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1094945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1094949 */     // MIs[0] policy
     /* 1094949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1094952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1094959 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1094959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1094962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1094964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1094966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1094968 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1094970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1094975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1094978 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1094980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1094981 */     // GIR_Coverage, 60727,
     /* 1094981 */     GIR_EraseRootFromParent_Done,
     /* 1094982 */   // Label 16100: @1094982
     /* 1094982 */   GIM_Try, /*On fail goto*//*Label 16101*/ GIMT_Encode4(1095059), // Rule ID 60730 //
     /* 1094987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1094990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1094995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1094998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095026 */     // MIs[0] policy
     /* 1095026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095045 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095055 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095058 */     // GIR_Coverage, 60730,
     /* 1095058 */     GIR_EraseRootFromParent_Done,
     /* 1095059 */   // Label 16101: @1095059
     /* 1095059 */   GIM_Try, /*On fail goto*//*Label 16102*/ GIMT_Encode4(1095136), // Rule ID 60731 //
     /* 1095064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1095075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1095078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1095081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1095084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095103 */     // MIs[0] policy
     /* 1095103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095113 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095122 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1095132 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095135 */     // GIR_Coverage, 60731,
     /* 1095135 */     GIR_EraseRootFromParent_Done,
     /* 1095136 */   // Label 16102: @1095136
     /* 1095136 */   GIM_Try, /*On fail goto*//*Label 16103*/ GIMT_Encode4(1095213), // Rule ID 60734 //
     /* 1095141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095180 */     // MIs[0] policy
     /* 1095180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095209 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095212 */     // GIR_Coverage, 60734,
     /* 1095212 */     GIR_EraseRootFromParent_Done,
     /* 1095213 */   // Label 16103: @1095213
     /* 1095213 */   GIM_Try, /*On fail goto*//*Label 16104*/ GIMT_Encode4(1095290), // Rule ID 60735 //
     /* 1095218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1095229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1095232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1095235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095257 */     // MIs[0] policy
     /* 1095257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095276 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095286 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095289 */     // GIR_Coverage, 60735,
     /* 1095289 */     GIR_EraseRootFromParent_Done,
     /* 1095290 */   // Label 16104: @1095290
     /* 1095290 */   GIM_Try, /*On fail goto*//*Label 16105*/ GIMT_Encode4(1095367), // Rule ID 60738 //
     /* 1095295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095334 */     // MIs[0] policy
     /* 1095334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095363 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095366 */     // GIR_Coverage, 60738,
     /* 1095366 */     GIR_EraseRootFromParent_Done,
     /* 1095367 */   // Label 16105: @1095367
     /* 1095367 */   GIM_Try, /*On fail goto*//*Label 16106*/ GIMT_Encode4(1095444), // Rule ID 60739 //
     /* 1095372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1095383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1095386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1095389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095411 */     // MIs[0] policy
     /* 1095411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095430 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095440 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095443 */     // GIR_Coverage, 60739,
     /* 1095443 */     GIR_EraseRootFromParent_Done,
     /* 1095444 */   // Label 16106: @1095444
     /* 1095444 */   GIM_Try, /*On fail goto*//*Label 16107*/ GIMT_Encode4(1095521), // Rule ID 60742 //
     /* 1095449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1095460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1095463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1095466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095488 */     // MIs[0] policy
     /* 1095488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095498 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095507 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095517 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095520 */     // GIR_Coverage, 60742,
     /* 1095520 */     GIR_EraseRootFromParent_Done,
     /* 1095521 */   // Label 16107: @1095521
     /* 1095521 */   GIM_Try, /*On fail goto*//*Label 16108*/ GIMT_Encode4(1095598), // Rule ID 60743 //
     /* 1095526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1095537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1095540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1095543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1095546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095565 */     // MIs[0] policy
     /* 1095565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095575 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095584 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1095594 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095597 */     // GIR_Coverage, 60743,
     /* 1095597 */     GIR_EraseRootFromParent_Done,
     /* 1095598 */   // Label 16108: @1095598
     /* 1095598 */   GIM_Try, /*On fail goto*//*Label 16109*/ GIMT_Encode4(1095675), // Rule ID 60746 //
     /* 1095603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1095614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1095617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1095620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1095623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095642 */     // MIs[0] policy
     /* 1095642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095652 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095671 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095674 */     // GIR_Coverage, 60746,
     /* 1095674 */     GIR_EraseRootFromParent_Done,
     /* 1095675 */   // Label 16109: @1095675
     /* 1095675 */   GIM_Try, /*On fail goto*//*Label 16110*/ GIMT_Encode4(1095752), // Rule ID 60747 //
     /* 1095680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1095691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1095694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1095697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1095700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1095707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1095715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095719 */     // MIs[0] policy
     /* 1095719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095729 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11111:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2_MASK),
     /* 1095732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095738 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095748 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095751 */     // GIR_Coverage, 60747,
     /* 1095751 */     GIR_EraseRootFromParent_Done,
     /* 1095752 */   // Label 16110: @1095752
     /* 1095752 */   GIM_Try, /*On fail goto*//*Label 16111*/ GIMT_Encode4(1095829), // Rule ID 60750 //
     /* 1095757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1095768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1095771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1095774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095796 */     // MIs[0] policy
     /* 1095796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095806 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095828 */     // GIR_Coverage, 60750,
     /* 1095828 */     GIR_EraseRootFromParent_Done,
     /* 1095829 */   // Label 16111: @1095829
     /* 1095829 */   GIM_Try, /*On fail goto*//*Label 16112*/ GIMT_Encode4(1095906), // Rule ID 60751 //
     /* 1095834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1095845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1095848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1095851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1095854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1095857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1095861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1095869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095873 */     // MIs[0] policy
     /* 1095873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095883 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11111:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1095883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4_MASK),
     /* 1095886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095905 */     // GIR_Coverage, 60751,
     /* 1095905 */     GIR_EraseRootFromParent_Done,
     /* 1095906 */   // Label 16112: @1095906
     /* 1095906 */   GIM_Try, /*On fail goto*//*Label 16113*/ GIMT_Encode4(1095983), // Rule ID 60754 //
     /* 1095911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1095914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1095922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1095925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1095928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1095931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1095934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1095938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1095946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1095950 */     // MIs[0] policy
     /* 1095950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1095953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1095960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1095960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1095963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1095965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1095967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1095969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1095971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1095976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1095979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1095981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1095982 */     // GIR_Coverage, 60754,
     /* 1095982 */     GIR_EraseRootFromParent_Done,
     /* 1095983 */   // Label 16113: @1095983
     /* 1095983 */   GIM_Try, /*On fail goto*//*Label 16114*/ GIMT_Encode4(1096060), // Rule ID 60755 //
     /* 1095988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1095991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vctz_mask),
     /* 1095996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1095999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1096002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1096005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1096008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1096015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1096023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096027 */     // MIs[0] policy
     /* 1096027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11111:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCTZ_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8_MASK),
     /* 1096040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096046 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1096056 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096059 */     // GIR_Coverage, 60755,
     /* 1096059 */     GIR_EraseRootFromParent_Done,
     /* 1096060 */   // Label 16114: @1096060
     /* 1096060 */   GIM_Try, /*On fail goto*//*Label 16115*/ GIMT_Encode4(1096137), // Rule ID 60758 //
     /* 1096065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096104 */     // MIs[0] policy
     /* 1096104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096133 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096136 */     // GIR_Coverage, 60758,
     /* 1096136 */     GIR_EraseRootFromParent_Done,
     /* 1096137 */   // Label 16115: @1096137
     /* 1096137 */   GIM_Try, /*On fail goto*//*Label 16116*/ GIMT_Encode4(1096214), // Rule ID 60759 //
     /* 1096142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1096153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1096156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1096159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096181 */     // MIs[0] policy
     /* 1096181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096191 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8_MASK),
     /* 1096194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096200 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096210 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096213 */     // GIR_Coverage, 60759,
     /* 1096213 */     GIR_EraseRootFromParent_Done,
     /* 1096214 */   // Label 16116: @1096214
     /* 1096214 */   GIM_Try, /*On fail goto*//*Label 16117*/ GIMT_Encode4(1096291), // Rule ID 60762 //
     /* 1096219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096258 */     // MIs[0] policy
     /* 1096258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096277 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096287 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096290 */     // GIR_Coverage, 60762,
     /* 1096290 */     GIR_EraseRootFromParent_Done,
     /* 1096291 */   // Label 16117: @1096291
     /* 1096291 */   GIM_Try, /*On fail goto*//*Label 16118*/ GIMT_Encode4(1096368), // Rule ID 60763 //
     /* 1096296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1096307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1096310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1096313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096335 */     // MIs[0] policy
     /* 1096335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096345 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096354 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096364 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096367 */     // GIR_Coverage, 60763,
     /* 1096367 */     GIR_EraseRootFromParent_Done,
     /* 1096368 */   // Label 16118: @1096368
     /* 1096368 */   GIM_Try, /*On fail goto*//*Label 16119*/ GIMT_Encode4(1096445), // Rule ID 60766 //
     /* 1096373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096412 */     // MIs[0] policy
     /* 1096412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096422 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096441 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096444 */     // GIR_Coverage, 60766,
     /* 1096444 */     GIR_EraseRootFromParent_Done,
     /* 1096445 */   // Label 16119: @1096445
     /* 1096445 */   GIM_Try, /*On fail goto*//*Label 16120*/ GIMT_Encode4(1096522), // Rule ID 60767 //
     /* 1096450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1096461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1096464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1096467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1096470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096489 */     // MIs[0] policy
     /* 1096489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096499 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096508 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1096518 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096521 */     // GIR_Coverage, 60767,
     /* 1096521 */     GIR_EraseRootFromParent_Done,
     /* 1096522 */   // Label 16120: @1096522
     /* 1096522 */   GIM_Try, /*On fail goto*//*Label 16121*/ GIMT_Encode4(1096599), // Rule ID 60770 //
     /* 1096527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1096538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1096541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1096544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096566 */     // MIs[0] policy
     /* 1096566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096576 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096595 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096598 */     // GIR_Coverage, 60770,
     /* 1096598 */     GIR_EraseRootFromParent_Done,
     /* 1096599 */   // Label 16121: @1096599
     /* 1096599 */   GIM_Try, /*On fail goto*//*Label 16122*/ GIMT_Encode4(1096676), // Rule ID 60771 //
     /* 1096604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1096615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1096618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1096621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096643 */     // MIs[0] policy
     /* 1096643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096653 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4_MASK),
     /* 1096656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096662 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096672 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096675 */     // GIR_Coverage, 60771,
     /* 1096675 */     GIR_EraseRootFromParent_Done,
     /* 1096676 */   // Label 16122: @1096676
     /* 1096676 */   GIM_Try, /*On fail goto*//*Label 16123*/ GIMT_Encode4(1096753), // Rule ID 60774 //
     /* 1096681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1096692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1096695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1096698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096720 */     // MIs[0] policy
     /* 1096720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096730 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096752 */     // GIR_Coverage, 60774,
     /* 1096752 */     GIR_EraseRootFromParent_Done,
     /* 1096753 */   // Label 16123: @1096753
     /* 1096753 */   GIM_Try, /*On fail goto*//*Label 16124*/ GIMT_Encode4(1096830), // Rule ID 60775 //
     /* 1096758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1096769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1096772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1096775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1096778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096797 */     // MIs[0] policy
     /* 1096797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096807 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096812 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1096826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096829 */     // GIR_Coverage, 60775,
     /* 1096829 */     GIR_EraseRootFromParent_Done,
     /* 1096830 */   // Label 16124: @1096830
     /* 1096830 */   GIM_Try, /*On fail goto*//*Label 16125*/ GIMT_Encode4(1096907), // Rule ID 60778 //
     /* 1096835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1096846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1096849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1096852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1096858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096874 */     // MIs[0] policy
     /* 1096874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096884 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1096884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096903 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096906 */     // GIR_Coverage, 60778,
     /* 1096906 */     GIR_EraseRootFromParent_Done,
     /* 1096907 */   // Label 16125: @1096907
     /* 1096907 */   GIM_Try, /*On fail goto*//*Label 16126*/ GIMT_Encode4(1096984), // Rule ID 60779 //
     /* 1096912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1096915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1096923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1096926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1096929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1096932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1096935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1096939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1096947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1096951 */     // MIs[0] policy
     /* 1096951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1096954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1096961 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1096961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2_MASK),
     /* 1096964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1096966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1096968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1096970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1096972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1096977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1096980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1096982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1096983 */     // GIR_Coverage, 60779,
     /* 1096983 */     GIR_EraseRootFromParent_Done,
     /* 1096984 */   // Label 16126: @1096984
     /* 1096984 */   GIM_Try, /*On fail goto*//*Label 16127*/ GIMT_Encode4(1097061), // Rule ID 60782 //
     /* 1096989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1096992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1096997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097028 */     // MIs[0] policy
     /* 1097028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097038 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097060 */     // GIR_Coverage, 60782,
     /* 1097060 */     GIR_EraseRootFromParent_Done,
     /* 1097061 */   // Label 16127: @1097061
     /* 1097061 */   GIM_Try, /*On fail goto*//*Label 16128*/ GIMT_Encode4(1097138), // Rule ID 60783 //
     /* 1097066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1097077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1097080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1097083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1097086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097105 */     // MIs[0] policy
     /* 1097105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097115 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11109:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097124 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097134 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097137 */     // GIR_Coverage, 60783,
     /* 1097137 */     GIR_EraseRootFromParent_Done,
     /* 1097138 */   // Label 16128: @1097138
     /* 1097138 */   GIM_Try, /*On fail goto*//*Label 16129*/ GIMT_Encode4(1097215), // Rule ID 60786 //
     /* 1097143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097182 */     // MIs[0] policy
     /* 1097182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097211 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097214 */     // GIR_Coverage, 60786,
     /* 1097214 */     GIR_EraseRootFromParent_Done,
     /* 1097215 */   // Label 16129: @1097215
     /* 1097215 */   GIM_Try, /*On fail goto*//*Label 16130*/ GIMT_Encode4(1097292), // Rule ID 60787 //
     /* 1097220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1097231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1097234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1097237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1097240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097259 */     // MIs[0] policy
     /* 1097259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11109:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1097288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097291 */     // GIR_Coverage, 60787,
     /* 1097291 */     GIR_EraseRootFromParent_Done,
     /* 1097292 */   // Label 16130: @1097292
     /* 1097292 */   GIM_Try, /*On fail goto*//*Label 16131*/ GIMT_Encode4(1097369), // Rule ID 60790 //
     /* 1097297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097336 */     // MIs[0] policy
     /* 1097336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097346 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097365 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097368 */     // GIR_Coverage, 60790,
     /* 1097368 */     GIR_EraseRootFromParent_Done,
     /* 1097369 */   // Label 16131: @1097369
     /* 1097369 */   GIM_Try, /*On fail goto*//*Label 16132*/ GIMT_Encode4(1097446), // Rule ID 60791 //
     /* 1097374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1097385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1097388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1097391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1097394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097413 */     // MIs[0] policy
     /* 1097413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097423 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11109:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097432 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1097442 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097445 */     // GIR_Coverage, 60791,
     /* 1097445 */     GIR_EraseRootFromParent_Done,
     /* 1097446 */   // Label 16132: @1097446
     /* 1097446 */   GIM_Try, /*On fail goto*//*Label 16133*/ GIMT_Encode4(1097523), // Rule ID 60794 //
     /* 1097451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097490 */     // MIs[0] policy
     /* 1097490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097500 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097519 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097522 */     // GIR_Coverage, 60794,
     /* 1097522 */     GIR_EraseRootFromParent_Done,
     /* 1097523 */   // Label 16133: @1097523
     /* 1097523 */   GIM_Try, /*On fail goto*//*Label 16134*/ GIMT_Encode4(1097600), // Rule ID 60795 //
     /* 1097528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1097539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1097542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1097545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1097548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1097555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1097563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097567 */     // MIs[0] policy
     /* 1097567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097577 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11109:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1_MASK),
     /* 1097580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1097596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097599 */     // GIR_Coverage, 60795,
     /* 1097599 */     GIR_EraseRootFromParent_Done,
     /* 1097600 */   // Label 16134: @1097600
     /* 1097600 */   GIM_Try, /*On fail goto*//*Label 16135*/ GIMT_Encode4(1097677), // Rule ID 60798 //
     /* 1097605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1097616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1097619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1097622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1097625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1097632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097644 */     // MIs[0] policy
     /* 1097644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1097657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097673 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097676 */     // GIR_Coverage, 60798,
     /* 1097676 */     GIR_EraseRootFromParent_Done,
     /* 1097677 */   // Label 16135: @1097677
     /* 1097677 */   GIM_Try, /*On fail goto*//*Label 16136*/ GIMT_Encode4(1097754), // Rule ID 60799 //
     /* 1097682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1097693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1097696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1097699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1097702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1097709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1097717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097721 */     // MIs[0] policy
     /* 1097721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097731 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1097734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097740 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097750 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097753 */     // GIR_Coverage, 60799,
     /* 1097753 */     GIR_EraseRootFromParent_Done,
     /* 1097754 */   // Label 16136: @1097754
     /* 1097754 */   GIM_Try, /*On fail goto*//*Label 16137*/ GIMT_Encode4(1097831), // Rule ID 60802 //
     /* 1097759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1097770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1097773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1097776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1097779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1097786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097798 */     // MIs[0] policy
     /* 1097798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1097811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097827 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097830 */     // GIR_Coverage, 60802,
     /* 1097830 */     GIR_EraseRootFromParent_Done,
     /* 1097831 */   // Label 16137: @1097831
     /* 1097831 */   GIM_Try, /*On fail goto*//*Label 16138*/ GIMT_Encode4(1097908), // Rule ID 60803 //
     /* 1097836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1097847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1097850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1097853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1097856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1097859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1097863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1097871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097875 */     // MIs[0] policy
     /* 1097875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097885 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1097885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1097888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097907 */     // GIR_Coverage, 60803,
     /* 1097907 */     GIR_EraseRootFromParent_Done,
     /* 1097908 */   // Label 16138: @1097908
     /* 1097908 */   GIM_Try, /*On fail goto*//*Label 16139*/ GIMT_Encode4(1097985), // Rule ID 60806 //
     /* 1097913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1097916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1097924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1097927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1097930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1097933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1097936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1097940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1097944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1097948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1097952 */     // MIs[0] policy
     /* 1097952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1097955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1097962 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1097962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1097965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1097967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1097969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1097971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1097973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1097978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1097981 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1097983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1097984 */     // GIR_Coverage, 60806,
     /* 1097984 */     GIR_EraseRootFromParent_Done,
     /* 1097985 */   // Label 16139: @1097985
     /* 1097985 */   GIM_Try, /*On fail goto*//*Label 16140*/ GIMT_Encode4(1098062), // Rule ID 60807 //
     /* 1097990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1097993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1097998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1098001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1098004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1098007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1098010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098029 */     // MIs[0] policy
     /* 1098029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098039 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098048 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1098058 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098061 */     // GIR_Coverage, 60807,
     /* 1098061 */     GIR_EraseRootFromParent_Done,
     /* 1098062 */   // Label 16140: @1098062
     /* 1098062 */   GIM_Try, /*On fail goto*//*Label 16141*/ GIMT_Encode4(1098139), // Rule ID 60810 //
     /* 1098067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098106 */     // MIs[0] policy
     /* 1098106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098116 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098135 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098138 */     // GIR_Coverage, 60810,
     /* 1098138 */     GIR_EraseRootFromParent_Done,
     /* 1098139 */   // Label 16141: @1098139
     /* 1098139 */   GIM_Try, /*On fail goto*//*Label 16142*/ GIMT_Encode4(1098216), // Rule ID 60811 //
     /* 1098144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1098155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1098158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1098161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098183 */     // MIs[0] policy
     /* 1098183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098193 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098202 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098212 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098215 */     // GIR_Coverage, 60811,
     /* 1098215 */     GIR_EraseRootFromParent_Done,
     /* 1098216 */   // Label 16142: @1098216
     /* 1098216 */   GIM_Try, /*On fail goto*//*Label 16143*/ GIMT_Encode4(1098293), // Rule ID 60814 //
     /* 1098221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098260 */     // MIs[0] policy
     /* 1098260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098270 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098289 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098292 */     // GIR_Coverage, 60814,
     /* 1098292 */     GIR_EraseRootFromParent_Done,
     /* 1098293 */   // Label 16143: @1098293
     /* 1098293 */   GIM_Try, /*On fail goto*//*Label 16144*/ GIMT_Encode4(1098370), // Rule ID 60815 //
     /* 1098298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1098309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1098312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1098315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098337 */     // MIs[0] policy
     /* 1098337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098347 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098356 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098366 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098369 */     // GIR_Coverage, 60815,
     /* 1098369 */     GIR_EraseRootFromParent_Done,
     /* 1098370 */   // Label 16144: @1098370
     /* 1098370 */   GIM_Try, /*On fail goto*//*Label 16145*/ GIMT_Encode4(1098447), // Rule ID 60818 //
     /* 1098375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098414 */     // MIs[0] policy
     /* 1098414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098446 */     // GIR_Coverage, 60818,
     /* 1098446 */     GIR_EraseRootFromParent_Done,
     /* 1098447 */   // Label 16145: @1098447
     /* 1098447 */   GIM_Try, /*On fail goto*//*Label 16146*/ GIMT_Encode4(1098524), // Rule ID 60819 //
     /* 1098452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1098463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1098466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1098469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1098472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098491 */     // MIs[0] policy
     /* 1098491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098501 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1098520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098523 */     // GIR_Coverage, 60819,
     /* 1098523 */     GIR_EraseRootFromParent_Done,
     /* 1098524 */   // Label 16146: @1098524
     /* 1098524 */   GIM_Try, /*On fail goto*//*Label 16147*/ GIMT_Encode4(1098601), // Rule ID 60822 //
     /* 1098529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1098540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1098543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1098546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098568 */     // MIs[0] policy
     /* 1098568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098600 */     // GIR_Coverage, 60822,
     /* 1098600 */     GIR_EraseRootFromParent_Done,
     /* 1098601 */   // Label 16147: @1098601
     /* 1098601 */   GIM_Try, /*On fail goto*//*Label 16148*/ GIMT_Encode4(1098678), // Rule ID 60823 //
     /* 1098606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1098617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1098620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1098623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1098626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1098633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1098641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098645 */     // MIs[0] policy
     /* 1098645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098655 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1098658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098664 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098674 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098677 */     // GIR_Coverage, 60823,
     /* 1098677 */     GIR_EraseRootFromParent_Done,
     /* 1098678 */   // Label 16148: @1098678
     /* 1098678 */   GIM_Try, /*On fail goto*//*Label 16149*/ GIMT_Encode4(1098755), // Rule ID 60826 //
     /* 1098683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1098694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1098697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1098700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098722 */     // MIs[0] policy
     /* 1098722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098751 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098754 */     // GIR_Coverage, 60826,
     /* 1098754 */     GIR_EraseRootFromParent_Done,
     /* 1098755 */   // Label 16149: @1098755
     /* 1098755 */   GIM_Try, /*On fail goto*//*Label 16150*/ GIMT_Encode4(1098832), // Rule ID 60827 //
     /* 1098760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1098771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1098774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1098777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1098780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1098787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1098795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098799 */     // MIs[0] policy
     /* 1098799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098809 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1098812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098818 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098828 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098831 */     // GIR_Coverage, 60827,
     /* 1098831 */     GIR_EraseRootFromParent_Done,
     /* 1098832 */   // Label 16150: @1098832
     /* 1098832 */   GIM_Try, /*On fail goto*//*Label 16151*/ GIMT_Encode4(1098909), // Rule ID 60830 //
     /* 1098837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1098848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1098851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1098854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1098860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098876 */     // MIs[0] policy
     /* 1098876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098886 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1098886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098905 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098908 */     // GIR_Coverage, 60830,
     /* 1098908 */     GIR_EraseRootFromParent_Done,
     /* 1098909 */   // Label 16151: @1098909
     /* 1098909 */   GIM_Try, /*On fail goto*//*Label 16152*/ GIMT_Encode4(1098986), // Rule ID 60831 //
     /* 1098914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1098917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1098925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1098928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1098931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1098934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1098937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1098941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1098949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1098953 */     // MIs[0] policy
     /* 1098953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1098956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1098963 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1098963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1098966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1098968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1098970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1098972 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1098974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1098979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1098982 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1098984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1098985 */     // GIR_Coverage, 60831,
     /* 1098985 */     GIR_EraseRootFromParent_Done,
     /* 1098986 */   // Label 16152: @1098986
     /* 1098986 */   GIM_Try, /*On fail goto*//*Label 16153*/ GIMT_Encode4(1099063), // Rule ID 60834 //
     /* 1098991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1098994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1098999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099030 */     // MIs[0] policy
     /* 1099030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099059 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099062 */     // GIR_Coverage, 60834,
     /* 1099062 */     GIR_EraseRootFromParent_Done,
     /* 1099063 */   // Label 16153: @1099063
     /* 1099063 */   GIM_Try, /*On fail goto*//*Label 16154*/ GIMT_Encode4(1099140), // Rule ID 60835 //
     /* 1099068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1099079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1099082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1099085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1099095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1099103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099107 */     // MIs[0] policy
     /* 1099107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11109:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2_MASK),
     /* 1099120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099126 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099136 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099139 */     // GIR_Coverage, 60835,
     /* 1099139 */     GIR_EraseRootFromParent_Done,
     /* 1099140 */   // Label 16154: @1099140
     /* 1099140 */   GIM_Try, /*On fail goto*//*Label 16155*/ GIMT_Encode4(1099217), // Rule ID 60838 //
     /* 1099145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099184 */     // MIs[0] policy
     /* 1099184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099194 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099213 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099216 */     // GIR_Coverage, 60838,
     /* 1099216 */     GIR_EraseRootFromParent_Done,
     /* 1099217 */   // Label 16155: @1099217
     /* 1099217 */   GIM_Try, /*On fail goto*//*Label 16156*/ GIMT_Encode4(1099294), // Rule ID 60839 //
     /* 1099222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1099233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1099236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1099239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1099249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1099257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099261 */     // MIs[0] policy
     /* 1099261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099271 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11109:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4_MASK),
     /* 1099274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099280 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099290 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099293 */     // GIR_Coverage, 60839,
     /* 1099293 */     GIR_EraseRootFromParent_Done,
     /* 1099294 */   // Label 16156: @1099294
     /* 1099294 */   GIM_Try, /*On fail goto*//*Label 16157*/ GIMT_Encode4(1099371), // Rule ID 60842 //
     /* 1099299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1099302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099338 */     // MIs[0] policy
     /* 1099338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099357 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099367 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099370 */     // GIR_Coverage, 60842,
     /* 1099370 */     GIR_EraseRootFromParent_Done,
     /* 1099371 */   // Label 16157: @1099371
     /* 1099371 */   GIM_Try, /*On fail goto*//*Label 16158*/ GIMT_Encode4(1099448), // Rule ID 60843 //
     /* 1099376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1099379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vcpopv_mask),
     /* 1099384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1099387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1099390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1099393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1099396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1099403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1099411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099415 */     // MIs[0] policy
     /* 1099415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099425 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11109:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCPOP_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8_MASK),
     /* 1099428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1099444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099447 */     // GIR_Coverage, 60843,
     /* 1099447 */     GIR_EraseRootFromParent_Done,
     /* 1099448 */   // Label 16158: @1099448
     /* 1099448 */   GIM_Try, /*On fail goto*//*Label 16159*/ GIMT_Encode4(1099525), // Rule ID 61266 //
     /* 1099453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1099464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1099467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1099470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1099473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099492 */     // MIs[0] policy
     /* 1099492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099502 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1099505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099524 */     // GIR_Coverage, 61266,
     /* 1099524 */     GIR_EraseRootFromParent_Done,
     /* 1099525 */   // Label 16159: @1099525
     /* 1099525 */   GIM_Try, /*On fail goto*//*Label 16160*/ GIMT_Encode4(1099602), // Rule ID 61267 //
     /* 1099530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1099533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1099541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1099544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1099547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1099550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099569 */     // MIs[0] policy
     /* 1099569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099579 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF8_MASK),
     /* 1099582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099588 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099598 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099601 */     // GIR_Coverage, 61267,
     /* 1099601 */     GIR_EraseRootFromParent_Done,
     /* 1099602 */   // Label 16160: @1099602
     /* 1099602 */   GIM_Try, /*On fail goto*//*Label 16161*/ GIMT_Encode4(1099679), // Rule ID 61270 //
     /* 1099607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1099618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1099621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1099624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099646 */     // MIs[0] policy
     /* 1099646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099656 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1099659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099675 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099678 */     // GIR_Coverage, 61270,
     /* 1099678 */     GIR_EraseRootFromParent_Done,
     /* 1099679 */   // Label 16161: @1099679
     /* 1099679 */   GIM_Try, /*On fail goto*//*Label 16162*/ GIMT_Encode4(1099756), // Rule ID 61271 //
     /* 1099684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1099687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1099695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1099698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1099701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1099704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099723 */     // MIs[0] policy
     /* 1099723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099733 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1099736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099754 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099755 */     // GIR_Coverage, 61271,
     /* 1099755 */     GIR_EraseRootFromParent_Done,
     /* 1099756 */   // Label 16162: @1099756
     /* 1099756 */   GIM_Try, /*On fail goto*//*Label 16163*/ GIMT_Encode4(1099833), // Rule ID 61274 //
     /* 1099761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1099772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1099775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1099778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099800 */     // MIs[0] policy
     /* 1099800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1099813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099832 */     // GIR_Coverage, 61274,
     /* 1099832 */     GIR_EraseRootFromParent_Done,
     /* 1099833 */   // Label 16163: @1099833
     /* 1099833 */   GIM_Try, /*On fail goto*//*Label 16164*/ GIMT_Encode4(1099910), // Rule ID 61275 //
     /* 1099838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1099841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1099849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1099852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1099855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1099858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1099861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099877 */     // MIs[0] policy
     /* 1099877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099887 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1099887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1099890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099896 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1099906 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099909 */     // GIR_Coverage, 61275,
     /* 1099909 */     GIR_EraseRootFromParent_Done,
     /* 1099910 */   // Label 16164: @1099910
     /* 1099910 */   GIM_Try, /*On fail goto*//*Label 16165*/ GIMT_Encode4(1099987), // Rule ID 61278 //
     /* 1099915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1099918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1099923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1099926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1099929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1099932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1099935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1099938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1099942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1099950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1099954 */     // MIs[0] policy
     /* 1099954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1099957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1099964 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1099964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1099967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1099969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1099971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1099973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1099975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1099980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1099983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1099985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1099986 */     // GIR_Coverage, 61278,
     /* 1099986 */     GIR_EraseRootFromParent_Done,
     /* 1099987 */   // Label 16165: @1099987
     /* 1099987 */   GIM_Try, /*On fail goto*//*Label 16166*/ GIMT_Encode4(1100064), // Rule ID 61279 //
     /* 1099992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1099995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1100003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1100006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1100009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100031 */     // MIs[0] policy
     /* 1100031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100041 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF4_MASK),
     /* 1100044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100050 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100060 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100063 */     // GIR_Coverage, 61279,
     /* 1100063 */     GIR_EraseRootFromParent_Done,
     /* 1100064 */   // Label 16166: @1100064
     /* 1100064 */   GIM_Try, /*On fail goto*//*Label 16167*/ GIMT_Encode4(1100141), // Rule ID 61282 //
     /* 1100069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100108 */     // MIs[0] policy
     /* 1100108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100118 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100127 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100137 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100140 */     // GIR_Coverage, 61282,
     /* 1100140 */     GIR_EraseRootFromParent_Done,
     /* 1100141 */   // Label 16167: @1100141
     /* 1100141 */   GIM_Try, /*On fail goto*//*Label 16168*/ GIMT_Encode4(1100218), // Rule ID 61283 //
     /* 1100146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1100157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1100160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1100163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100185 */     // MIs[0] policy
     /* 1100185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100195 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100204 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100214 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100217 */     // GIR_Coverage, 61283,
     /* 1100217 */     GIR_EraseRootFromParent_Done,
     /* 1100218 */   // Label 16168: @1100218
     /* 1100218 */   GIM_Try, /*On fail goto*//*Label 16169*/ GIMT_Encode4(1100295), // Rule ID 61286 //
     /* 1100223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100262 */     // MIs[0] policy
     /* 1100262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100272 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100291 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100294 */     // GIR_Coverage, 61286,
     /* 1100294 */     GIR_EraseRootFromParent_Done,
     /* 1100295 */   // Label 16169: @1100295
     /* 1100295 */   GIM_Try, /*On fail goto*//*Label 16170*/ GIMT_Encode4(1100372), // Rule ID 61287 //
     /* 1100300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1100311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1100314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1100317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100339 */     // MIs[0] policy
     /* 1100339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100349 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_MF2_MASK),
     /* 1100352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100358 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100368 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100371 */     // GIR_Coverage, 61287,
     /* 1100371 */     GIR_EraseRootFromParent_Done,
     /* 1100372 */   // Label 16170: @1100372
     /* 1100372 */   GIM_Try, /*On fail goto*//*Label 16171*/ GIMT_Encode4(1100449), // Rule ID 61290 //
     /* 1100377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100416 */     // MIs[0] policy
     /* 1100416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100445 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100448 */     // GIR_Coverage, 61290,
     /* 1100448 */     GIR_EraseRootFromParent_Done,
     /* 1100449 */   // Label 16171: @1100449
     /* 1100449 */   GIM_Try, /*On fail goto*//*Label 16172*/ GIMT_Encode4(1100526), // Rule ID 61291 //
     /* 1100454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1100465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1100468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1100471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1100474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100493 */     // MIs[0] policy
     /* 1100493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100503 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11098:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100512 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1100522 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100525 */     // GIR_Coverage, 61291,
     /* 1100525 */     GIR_EraseRootFromParent_Done,
     /* 1100526 */   // Label 16172: @1100526
     /* 1100526 */   GIM_Try, /*On fail goto*//*Label 16173*/ GIMT_Encode4(1100603), // Rule ID 61294 //
     /* 1100531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1100542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1100545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1100548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100570 */     // MIs[0] policy
     /* 1100570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100580 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100589 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100599 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100602 */     // GIR_Coverage, 61294,
     /* 1100602 */     GIR_EraseRootFromParent_Done,
     /* 1100603 */   // Label 16173: @1100603
     /* 1100603 */   GIM_Try, /*On fail goto*//*Label 16174*/ GIMT_Encode4(1100680), // Rule ID 61295 //
     /* 1100608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1100619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1100622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1100625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1100628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100647 */     // MIs[0] policy
     /* 1100647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100657 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11098:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100666 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1100676 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100679 */     // GIR_Coverage, 61295,
     /* 1100679 */     GIR_EraseRootFromParent_Done,
     /* 1100680 */   // Label 16174: @1100680
     /* 1100680 */   GIM_Try, /*On fail goto*//*Label 16175*/ GIMT_Encode4(1100757), // Rule ID 61298 //
     /* 1100685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1100696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1100699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1100702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100724 */     // MIs[0] policy
     /* 1100724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100753 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100756 */     // GIR_Coverage, 61298,
     /* 1100756 */     GIR_EraseRootFromParent_Done,
     /* 1100757 */   // Label 16175: @1100757
     /* 1100757 */   GIM_Try, /*On fail goto*//*Label 16176*/ GIMT_Encode4(1100834), // Rule ID 61299 //
     /* 1100762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1100773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1100776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1100779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1100782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100801 */     // MIs[0] policy
     /* 1100801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100811 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11098:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1100830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100833 */     // GIR_Coverage, 61299,
     /* 1100833 */     GIR_EraseRootFromParent_Done,
     /* 1100834 */   // Label 16176: @1100834
     /* 1100834 */   GIM_Try, /*On fail goto*//*Label 16177*/ GIMT_Encode4(1100911), // Rule ID 61302 //
     /* 1100839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1100850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1100853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1100856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1100862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100878 */     // MIs[0] policy
     /* 1100878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1100888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100910 */     // GIR_Coverage, 61302,
     /* 1100910 */     GIR_EraseRootFromParent_Done,
     /* 1100911 */   // Label 16177: @1100911
     /* 1100911 */   GIM_Try, /*On fail goto*//*Label 16178*/ GIMT_Encode4(1100988), // Rule ID 61303 //
     /* 1100916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1100919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1100924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1100927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1100930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1100933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1100936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1100939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1100943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1100951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1100955 */     // MIs[0] policy
     /* 1100955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1100958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1100965 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11098:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1100965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M1_MASK),
     /* 1100968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1100970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1100972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1100974 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1100976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1100981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1100984 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1100986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1100987 */     // GIR_Coverage, 61303,
     /* 1100987 */     GIR_EraseRootFromParent_Done,
     /* 1100988 */   // Label 16178: @1100988
     /* 1100988 */   GIM_Try, /*On fail goto*//*Label 16179*/ GIMT_Encode4(1101065), // Rule ID 61306 //
     /* 1100993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1100996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101032 */     // MIs[0] policy
     /* 1101032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101042 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101061 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101064 */     // GIR_Coverage, 61306,
     /* 1101064 */     GIR_EraseRootFromParent_Done,
     /* 1101065 */   // Label 16179: @1101065
     /* 1101065 */   GIM_Try, /*On fail goto*//*Label 16180*/ GIMT_Encode4(1101142), // Rule ID 61307 //
     /* 1101070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1101081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1101084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1101087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101109 */     // MIs[0] policy
     /* 1101109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101128 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101138 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101141 */     // GIR_Coverage, 61307,
     /* 1101141 */     GIR_EraseRootFromParent_Done,
     /* 1101142 */   // Label 16180: @1101142
     /* 1101142 */   GIM_Try, /*On fail goto*//*Label 16181*/ GIMT_Encode4(1101219), // Rule ID 61310 //
     /* 1101147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101186 */     // MIs[0] policy
     /* 1101186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101196 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101218 */     // GIR_Coverage, 61310,
     /* 1101218 */     GIR_EraseRootFromParent_Done,
     /* 1101219 */   // Label 16181: @1101219
     /* 1101219 */   GIM_Try, /*On fail goto*//*Label 16182*/ GIMT_Encode4(1101296), // Rule ID 61311 //
     /* 1101224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1101235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1101238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1101241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101263 */     // MIs[0] policy
     /* 1101263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101273 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101295 */     // GIR_Coverage, 61311,
     /* 1101295 */     GIR_EraseRootFromParent_Done,
     /* 1101296 */   // Label 16182: @1101296
     /* 1101296 */   GIM_Try, /*On fail goto*//*Label 16183*/ GIMT_Encode4(1101373), // Rule ID 61314 //
     /* 1101301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101340 */     // MIs[0] policy
     /* 1101340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101350 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101372 */     // GIR_Coverage, 61314,
     /* 1101372 */     GIR_EraseRootFromParent_Done,
     /* 1101373 */   // Label 16183: @1101373
     /* 1101373 */   GIM_Try, /*On fail goto*//*Label 16184*/ GIMT_Encode4(1101450), // Rule ID 61315 //
     /* 1101378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1101389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1101392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1101395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1101398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101417 */     // MIs[0] policy
     /* 1101417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101427 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101436 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1101446 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101449 */     // GIR_Coverage, 61315,
     /* 1101449 */     GIR_EraseRootFromParent_Done,
     /* 1101450 */   // Label 16184: @1101450
     /* 1101450 */   GIM_Try, /*On fail goto*//*Label 16185*/ GIMT_Encode4(1101527), // Rule ID 61318 //
     /* 1101455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1101466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1101469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1101472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101494 */     // MIs[0] policy
     /* 1101494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101523 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101526 */     // GIR_Coverage, 61318,
     /* 1101526 */     GIR_EraseRootFromParent_Done,
     /* 1101527 */   // Label 16185: @1101527
     /* 1101527 */   GIM_Try, /*On fail goto*//*Label 16186*/ GIMT_Encode4(1101604), // Rule ID 61319 //
     /* 1101532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1101543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1101546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1101549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1101552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101571 */     // MIs[0] policy
     /* 1101571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101590 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101600 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101603 */     // GIR_Coverage, 61319,
     /* 1101603 */     GIR_EraseRootFromParent_Done,
     /* 1101604 */   // Label 16186: @1101604
     /* 1101604 */   GIM_Try, /*On fail goto*//*Label 16187*/ GIMT_Encode4(1101681), // Rule ID 61322 //
     /* 1101609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1101620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1101623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1101626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101648 */     // MIs[0] policy
     /* 1101648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101667 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101677 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101680 */     // GIR_Coverage, 61322,
     /* 1101680 */     GIR_EraseRootFromParent_Done,
     /* 1101681 */   // Label 16187: @1101681
     /* 1101681 */   GIM_Try, /*On fail goto*//*Label 16188*/ GIMT_Encode4(1101758), // Rule ID 61323 //
     /* 1101686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1101697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1101700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1101703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1101706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1101713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1101721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101725 */     // MIs[0] policy
     /* 1101725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101735 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1101738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101757 */     // GIR_Coverage, 61323,
     /* 1101757 */     GIR_EraseRootFromParent_Done,
     /* 1101758 */   // Label 16188: @1101758
     /* 1101758 */   GIM_Try, /*On fail goto*//*Label 16189*/ GIMT_Encode4(1101835), // Rule ID 61326 //
     /* 1101763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1101774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1101777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1101780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101802 */     // MIs[0] policy
     /* 1101802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101812 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101831 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101834 */     // GIR_Coverage, 61326,
     /* 1101834 */     GIR_EraseRootFromParent_Done,
     /* 1101835 */   // Label 16189: @1101835
     /* 1101835 */   GIM_Try, /*On fail goto*//*Label 16190*/ GIMT_Encode4(1101912), // Rule ID 61327 //
     /* 1101840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1101851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1101854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1101857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1101860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1101863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1101867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1101875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101879 */     // MIs[0] policy
     /* 1101879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101889 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1101889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1101892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1101908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101911 */     // GIR_Coverage, 61327,
     /* 1101911 */     GIR_EraseRootFromParent_Done,
     /* 1101912 */   // Label 16190: @1101912
     /* 1101912 */   GIM_Try, /*On fail goto*//*Label 16191*/ GIMT_Encode4(1101989), // Rule ID 61330 //
     /* 1101917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1101920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1101925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1101928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1101931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1101934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1101937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1101940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1101944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1101952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1101956 */     // MIs[0] policy
     /* 1101956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1101959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1101966 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1101966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1101969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1101971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1101973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1101975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1101977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1101982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1101985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1101987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1101988 */     // GIR_Coverage, 61330,
     /* 1101988 */     GIR_EraseRootFromParent_Done,
     /* 1101989 */   // Label 16191: @1101989
     /* 1101989 */   GIM_Try, /*On fail goto*//*Label 16192*/ GIMT_Encode4(1102066), // Rule ID 61331 //
     /* 1101994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1101997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1102005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1102008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1102011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102033 */     // MIs[0] policy
     /* 1102033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102043 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102052 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102062 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102065 */     // GIR_Coverage, 61331,
     /* 1102065 */     GIR_EraseRootFromParent_Done,
     /* 1102066 */   // Label 16192: @1102066
     /* 1102066 */   GIM_Try, /*On fail goto*//*Label 16193*/ GIMT_Encode4(1102143), // Rule ID 61334 //
     /* 1102071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102110 */     // MIs[0] policy
     /* 1102110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102120 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102139 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102142 */     // GIR_Coverage, 61334,
     /* 1102142 */     GIR_EraseRootFromParent_Done,
     /* 1102143 */   // Label 16193: @1102143
     /* 1102143 */   GIM_Try, /*On fail goto*//*Label 16194*/ GIMT_Encode4(1102220), // Rule ID 61335 //
     /* 1102148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1102159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1102162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1102165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102187 */     // MIs[0] policy
     /* 1102187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102197 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102218 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102219 */     // GIR_Coverage, 61335,
     /* 1102219 */     GIR_EraseRootFromParent_Done,
     /* 1102220 */   // Label 16194: @1102220
     /* 1102220 */   GIM_Try, /*On fail goto*//*Label 16195*/ GIMT_Encode4(1102297), // Rule ID 61338 //
     /* 1102225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102264 */     // MIs[0] policy
     /* 1102264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102293 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102296 */     // GIR_Coverage, 61338,
     /* 1102296 */     GIR_EraseRootFromParent_Done,
     /* 1102297 */   // Label 16195: @1102297
     /* 1102297 */   GIM_Try, /*On fail goto*//*Label 16196*/ GIMT_Encode4(1102374), // Rule ID 61339 //
     /* 1102302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1102313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1102316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1102319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1102322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102341 */     // MIs[0] policy
     /* 1102341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102351 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102360 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1102370 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102373 */     // GIR_Coverage, 61339,
     /* 1102373 */     GIR_EraseRootFromParent_Done,
     /* 1102374 */   // Label 16196: @1102374
     /* 1102374 */   GIM_Try, /*On fail goto*//*Label 16197*/ GIMT_Encode4(1102451), // Rule ID 61342 //
     /* 1102379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102418 */     // MIs[0] policy
     /* 1102418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102428 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102447 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102450 */     // GIR_Coverage, 61342,
     /* 1102450 */     GIR_EraseRootFromParent_Done,
     /* 1102451 */   // Label 16197: @1102451
     /* 1102451 */   GIM_Try, /*On fail goto*//*Label 16198*/ GIMT_Encode4(1102528), // Rule ID 61343 //
     /* 1102456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1102467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1102470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1102473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1102476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1102483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1102491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102495 */     // MIs[0] policy
     /* 1102495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11098:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M2_MASK),
     /* 1102508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102527 */     // GIR_Coverage, 61343,
     /* 1102527 */     GIR_EraseRootFromParent_Done,
     /* 1102528 */   // Label 16198: @1102528
     /* 1102528 */   GIM_Try, /*On fail goto*//*Label 16199*/ GIMT_Encode4(1102605), // Rule ID 61346 //
     /* 1102533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1102544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1102547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1102550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102572 */     // MIs[0] policy
     /* 1102572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102582 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102601 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102604 */     // GIR_Coverage, 61346,
     /* 1102604 */     GIR_EraseRootFromParent_Done,
     /* 1102605 */   // Label 16199: @1102605
     /* 1102605 */   GIM_Try, /*On fail goto*//*Label 16200*/ GIMT_Encode4(1102682), // Rule ID 61347 //
     /* 1102610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1102621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1102624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1102627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1102630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1102637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1102645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102649 */     // MIs[0] policy
     /* 1102649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102659 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11098:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M4_MASK),
     /* 1102662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102668 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102678 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102681 */     // GIR_Coverage, 61347,
     /* 1102681 */     GIR_EraseRootFromParent_Done,
     /* 1102682 */   // Label 16200: @1102682
     /* 1102682 */   GIM_Try, /*On fail goto*//*Label 16201*/ GIMT_Encode4(1102759), // Rule ID 61350 //
     /* 1102687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1102698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1102701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1102704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102726 */     // MIs[0] policy
     /* 1102726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102736 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102755 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102758 */     // GIR_Coverage, 61350,
     /* 1102758 */     GIR_EraseRootFromParent_Done,
     /* 1102759 */   // Label 16201: @1102759
     /* 1102759 */   GIM_Try, /*On fail goto*//*Label 16202*/ GIMT_Encode4(1102836), // Rule ID 61351 //
     /* 1102764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vbrev8_mask),
     /* 1102772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1102775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1102778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1102781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1102784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1102791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1102799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102803 */     // MIs[0] policy
     /* 1102803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102813 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11098:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVBREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV8_V_M8_MASK),
     /* 1102816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1102832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102835 */     // GIR_Coverage, 61351,
     /* 1102835 */     GIR_EraseRootFromParent_Done,
     /* 1102836 */   // Label 16202: @1102836
     /* 1102836 */   GIM_Try, /*On fail goto*//*Label 16203*/ GIMT_Encode4(1102913), // Rule ID 61354 //
     /* 1102841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1102849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1102852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1102855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1102858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1102861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1102864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1102868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102880 */     // MIs[0] policy
     /* 1102880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1102890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1102893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102899 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102909 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102912 */     // GIR_Coverage, 61354,
     /* 1102912 */     GIR_EraseRootFromParent_Done,
     /* 1102913 */   // Label 16203: @1102913
     /* 1102913 */   GIM_Try, /*On fail goto*//*Label 16204*/ GIMT_Encode4(1102990), // Rule ID 61355 //
     /* 1102918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1102921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1102926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1102929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1102932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1102935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1102938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1102941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1102945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1102953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1102957 */     // MIs[0] policy
     /* 1102957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1102960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1102967 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1102967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8_MASK),
     /* 1102970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1102972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1102974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1102976 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1102978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1102983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1102986 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1102988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1102989 */     // GIR_Coverage, 61355,
     /* 1102989 */     GIR_EraseRootFromParent_Done,
     /* 1102990 */   // Label 16204: @1102990
     /* 1102990 */   GIM_Try, /*On fail goto*//*Label 16205*/ GIMT_Encode4(1103067), // Rule ID 61358 //
     /* 1102995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1102998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103034 */     // MIs[0] policy
     /* 1103034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103044 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103063 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103066 */     // GIR_Coverage, 61358,
     /* 1103066 */     GIR_EraseRootFromParent_Done,
     /* 1103067 */   // Label 16205: @1103067
     /* 1103067 */   GIM_Try, /*On fail goto*//*Label 16206*/ GIMT_Encode4(1103144), // Rule ID 61359 //
     /* 1103072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1103083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1103086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1103089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103111 */     // MIs[0] policy
     /* 1103111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103130 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103140 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103143 */     // GIR_Coverage, 61359,
     /* 1103143 */     GIR_EraseRootFromParent_Done,
     /* 1103144 */   // Label 16206: @1103144
     /* 1103144 */   GIM_Try, /*On fail goto*//*Label 16207*/ GIMT_Encode4(1103221), // Rule ID 61362 //
     /* 1103149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103188 */     // MIs[0] policy
     /* 1103188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103198 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103217 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103220 */     // GIR_Coverage, 61362,
     /* 1103220 */     GIR_EraseRootFromParent_Done,
     /* 1103221 */   // Label 16207: @1103221
     /* 1103221 */   GIM_Try, /*On fail goto*//*Label 16208*/ GIMT_Encode4(1103298), // Rule ID 61363 //
     /* 1103226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1103237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1103240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1103243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103265 */     // MIs[0] policy
     /* 1103265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103275 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103284 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103294 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103297 */     // GIR_Coverage, 61363,
     /* 1103297 */     GIR_EraseRootFromParent_Done,
     /* 1103298 */   // Label 16208: @1103298
     /* 1103298 */   GIM_Try, /*On fail goto*//*Label 16209*/ GIMT_Encode4(1103375), // Rule ID 61366 //
     /* 1103303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103342 */     // MIs[0] policy
     /* 1103342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103374 */     // GIR_Coverage, 61366,
     /* 1103374 */     GIR_EraseRootFromParent_Done,
     /* 1103375 */   // Label 16209: @1103375
     /* 1103375 */   GIM_Try, /*On fail goto*//*Label 16210*/ GIMT_Encode4(1103452), // Rule ID 61367 //
     /* 1103380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1103391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1103394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1103397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103419 */     // MIs[0] policy
     /* 1103419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103429 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4_MASK),
     /* 1103432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103451 */     // GIR_Coverage, 61367,
     /* 1103451 */     GIR_EraseRootFromParent_Done,
     /* 1103452 */   // Label 16210: @1103452
     /* 1103452 */   GIM_Try, /*On fail goto*//*Label 16211*/ GIMT_Encode4(1103529), // Rule ID 61370 //
     /* 1103457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1103468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1103471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103496 */     // MIs[0] policy
     /* 1103496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103525 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103528 */     // GIR_Coverage, 61370,
     /* 1103528 */     GIR_EraseRootFromParent_Done,
     /* 1103529 */   // Label 16211: @1103529
     /* 1103529 */   GIM_Try, /*On fail goto*//*Label 16212*/ GIMT_Encode4(1103606), // Rule ID 61371 //
     /* 1103534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1103545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1103548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1103551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1103554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103573 */     // MIs[0] policy
     /* 1103573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103583 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103592 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103602 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103605 */     // GIR_Coverage, 61371,
     /* 1103605 */     GIR_EraseRootFromParent_Done,
     /* 1103606 */   // Label 16212: @1103606
     /* 1103606 */   GIM_Try, /*On fail goto*//*Label 16213*/ GIMT_Encode4(1103683), // Rule ID 61374 //
     /* 1103611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1103622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1103625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1103628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103650 */     // MIs[0] policy
     /* 1103650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103660 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103669 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103679 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103682 */     // GIR_Coverage, 61374,
     /* 1103682 */     GIR_EraseRootFromParent_Done,
     /* 1103683 */   // Label 16213: @1103683
     /* 1103683 */   GIM_Try, /*On fail goto*//*Label 16214*/ GIMT_Encode4(1103760), // Rule ID 61375 //
     /* 1103688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1103699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1103702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1103705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1103708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103727 */     // MIs[0] policy
     /* 1103727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103737 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2_MASK),
     /* 1103740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103746 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1103756 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103759 */     // GIR_Coverage, 61375,
     /* 1103759 */     GIR_EraseRootFromParent_Done,
     /* 1103760 */   // Label 16214: @1103760
     /* 1103760 */   GIM_Try, /*On fail goto*//*Label 16215*/ GIMT_Encode4(1103837), // Rule ID 61378 //
     /* 1103765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1103776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1103779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1103782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103804 */     // MIs[0] policy
     /* 1103804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103814 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1103817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103833 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103836 */     // GIR_Coverage, 61378,
     /* 1103836 */     GIR_EraseRootFromParent_Done,
     /* 1103837 */   // Label 16215: @1103837
     /* 1103837 */   GIM_Try, /*On fail goto*//*Label 16216*/ GIMT_Encode4(1103914), // Rule ID 61379 //
     /* 1103842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1103853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1103856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1103859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1103862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1103865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103881 */     // MIs[0] policy
     /* 1103881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103891 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11449:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1103891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1103894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103900 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1103910 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103913 */     // GIR_Coverage, 61379,
     /* 1103913 */     GIR_EraseRootFromParent_Done,
     /* 1103914 */   // Label 16216: @1103914
     /* 1103914 */   GIM_Try, /*On fail goto*//*Label 16217*/ GIMT_Encode4(1103991), // Rule ID 61382 //
     /* 1103919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1103922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1103927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1103930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1103933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1103936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1103939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1103942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1103946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1103954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1103958 */     // MIs[0] policy
     /* 1103958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1103961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1103968 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1103968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1103971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1103973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1103975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1103977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1103979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1103984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1103987 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1103989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1103990 */     // GIR_Coverage, 61382,
     /* 1103990 */     GIR_EraseRootFromParent_Done,
     /* 1103991 */   // Label 16217: @1103991
     /* 1103991 */   GIM_Try, /*On fail goto*//*Label 16218*/ GIMT_Encode4(1104068), // Rule ID 61383 //
     /* 1103996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1103999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1104007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1104010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1104013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1104016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104035 */     // MIs[0] policy
     /* 1104035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104045 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11449:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104054 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104064 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104066 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104067 */     // GIR_Coverage, 61383,
     /* 1104067 */     GIR_EraseRootFromParent_Done,
     /* 1104068 */   // Label 16218: @1104068
     /* 1104068 */   GIM_Try, /*On fail goto*//*Label 16219*/ GIMT_Encode4(1104145), // Rule ID 61386 //
     /* 1104073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104112 */     // MIs[0] policy
     /* 1104112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104122 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104131 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104141 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104144 */     // GIR_Coverage, 61386,
     /* 1104144 */     GIR_EraseRootFromParent_Done,
     /* 1104145 */   // Label 16219: @1104145
     /* 1104145 */   GIM_Try, /*On fail goto*//*Label 16220*/ GIMT_Encode4(1104222), // Rule ID 61387 //
     /* 1104150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1104161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1104164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1104167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1104170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104189 */     // MIs[0] policy
     /* 1104189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104199 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11449:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104208 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1104218 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104221 */     // GIR_Coverage, 61387,
     /* 1104221 */     GIR_EraseRootFromParent_Done,
     /* 1104222 */   // Label 16220: @1104222
     /* 1104222 */   GIM_Try, /*On fail goto*//*Label 16221*/ GIMT_Encode4(1104299), // Rule ID 61390 //
     /* 1104227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104266 */     // MIs[0] policy
     /* 1104266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104295 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104298 */     // GIR_Coverage, 61390,
     /* 1104298 */     GIR_EraseRootFromParent_Done,
     /* 1104299 */   // Label 16221: @1104299
     /* 1104299 */   GIM_Try, /*On fail goto*//*Label 16222*/ GIMT_Encode4(1104376), // Rule ID 61391 //
     /* 1104304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1104315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1104318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1104321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1104324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1104331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1104339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104343 */     // MIs[0] policy
     /* 1104343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104353 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11449:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1_MASK),
     /* 1104356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104362 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1104372 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104375 */     // GIR_Coverage, 61391,
     /* 1104375 */     GIR_EraseRootFromParent_Done,
     /* 1104376 */   // Label 16222: @1104376
     /* 1104376 */   GIM_Try, /*On fail goto*//*Label 16223*/ GIMT_Encode4(1104453), // Rule ID 61394 //
     /* 1104381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104420 */     // MIs[0] policy
     /* 1104420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104439 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104449 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104452 */     // GIR_Coverage, 61394,
     /* 1104452 */     GIR_EraseRootFromParent_Done,
     /* 1104453 */   // Label 16223: @1104453
     /* 1104453 */   GIM_Try, /*On fail goto*//*Label 16224*/ GIMT_Encode4(1104530), // Rule ID 61395 //
     /* 1104458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1104469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1104472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1104475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1104478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104497 */     // MIs[0] policy
     /* 1104497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104507 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104516 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104526 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104529 */     // GIR_Coverage, 61395,
     /* 1104529 */     GIR_EraseRootFromParent_Done,
     /* 1104530 */   // Label 16224: @1104530
     /* 1104530 */   GIM_Try, /*On fail goto*//*Label 16225*/ GIMT_Encode4(1104607), // Rule ID 61398 //
     /* 1104535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1104546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1104549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1104552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1104555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1104562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104574 */     // MIs[0] policy
     /* 1104574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104584 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1104587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104606 */     // GIR_Coverage, 61398,
     /* 1104606 */     GIR_EraseRootFromParent_Done,
     /* 1104607 */   // Label 16225: @1104607
     /* 1104607 */   GIM_Try, /*On fail goto*//*Label 16226*/ GIMT_Encode4(1104684), // Rule ID 61399 //
     /* 1104612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1104623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1104626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1104629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1104632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1104639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1104647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104651 */     // MIs[0] policy
     /* 1104651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104661 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1104664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104683 */     // GIR_Coverage, 61399,
     /* 1104683 */     GIR_EraseRootFromParent_Done,
     /* 1104684 */   // Label 16226: @1104684
     /* 1104684 */   GIM_Try, /*On fail goto*//*Label 16227*/ GIMT_Encode4(1104761), // Rule ID 61402 //
     /* 1104689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1104700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1104703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1104706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1104709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1104716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104728 */     // MIs[0] policy
     /* 1104728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104738 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1104741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104760 */     // GIR_Coverage, 61402,
     /* 1104760 */     GIR_EraseRootFromParent_Done,
     /* 1104761 */   // Label 16227: @1104761
     /* 1104761 */   GIM_Try, /*On fail goto*//*Label 16228*/ GIMT_Encode4(1104838), // Rule ID 61403 //
     /* 1104766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1104777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1104780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1104783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 1104786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1104793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1104801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104805 */     // MIs[0] policy
     /* 1104805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104815 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1104818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104824 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1104834 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104837 */     // GIR_Coverage, 61403,
     /* 1104837 */     GIR_EraseRootFromParent_Done,
     /* 1104838 */   // Label 16228: @1104838
     /* 1104838 */   GIM_Try, /*On fail goto*//*Label 16229*/ GIMT_Encode4(1104915), // Rule ID 61406 //
     /* 1104843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1104846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1104854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1104857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1104860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1104866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104882 */     // MIs[0] policy
     /* 1104882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1104892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104901 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104911 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104914 */     // GIR_Coverage, 61406,
     /* 1104914 */     GIR_EraseRootFromParent_Done,
     /* 1104915 */   // Label 16229: @1104915
     /* 1104915 */   GIM_Try, /*On fail goto*//*Label 16230*/ GIMT_Encode4(1104992), // Rule ID 61407 //
     /* 1104920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1104923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1104928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1104931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1104934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1104937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1104940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1104943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1104947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1104955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1104959 */     // MIs[0] policy
     /* 1104959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1104962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1104969 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1104969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1104972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1104974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1104976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1104978 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1104980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1104985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1104988 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1104990 */     GIR_RootConstrainSelectedInstOperands,
     /* 1104991 */     // GIR_Coverage, 61407,
     /* 1104991 */     GIR_EraseRootFromParent_Done,
     /* 1104992 */   // Label 16230: @1104992
     /* 1104992 */   GIM_Try, /*On fail goto*//*Label 16231*/ GIMT_Encode4(1105069), // Rule ID 61410 //
     /* 1104997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105036 */     // MIs[0] policy
     /* 1105036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105046 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105065 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105068 */     // GIR_Coverage, 61410,
     /* 1105068 */     GIR_EraseRootFromParent_Done,
     /* 1105069 */   // Label 16231: @1105069
     /* 1105069 */   GIM_Try, /*On fail goto*//*Label 16232*/ GIMT_Encode4(1105146), // Rule ID 61411 //
     /* 1105074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1105085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1105088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1105091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105113 */     // MIs[0] policy
     /* 1105113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105123 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105132 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105142 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105145 */     // GIR_Coverage, 61411,
     /* 1105145 */     GIR_EraseRootFromParent_Done,
     /* 1105146 */   // Label 16232: @1105146
     /* 1105146 */   GIM_Try, /*On fail goto*//*Label 16233*/ GIMT_Encode4(1105223), // Rule ID 61414 //
     /* 1105151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105190 */     // MIs[0] policy
     /* 1105190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105219 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105222 */     // GIR_Coverage, 61414,
     /* 1105222 */     GIR_EraseRootFromParent_Done,
     /* 1105223 */   // Label 16233: @1105223
     /* 1105223 */   GIM_Try, /*On fail goto*//*Label 16234*/ GIMT_Encode4(1105300), // Rule ID 61415 //
     /* 1105228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1105239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1105242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1105245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1105248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105267 */     // MIs[0] policy
     /* 1105267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105277 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105286 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1105296 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105299 */     // GIR_Coverage, 61415,
     /* 1105299 */     GIR_EraseRootFromParent_Done,
     /* 1105300 */   // Label 16234: @1105300
     /* 1105300 */   GIM_Try, /*On fail goto*//*Label 16235*/ GIMT_Encode4(1105377), // Rule ID 61418 //
     /* 1105305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105344 */     // MIs[0] policy
     /* 1105344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105373 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105376 */     // GIR_Coverage, 61418,
     /* 1105376 */     GIR_EraseRootFromParent_Done,
     /* 1105377 */   // Label 16235: @1105377
     /* 1105377 */   GIM_Try, /*On fail goto*//*Label 16236*/ GIMT_Encode4(1105454), // Rule ID 61419 //
     /* 1105382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1105393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1105396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1105399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105421 */     // MIs[0] policy
     /* 1105421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105440 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105450 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105453 */     // GIR_Coverage, 61419,
     /* 1105453 */     GIR_EraseRootFromParent_Done,
     /* 1105454 */   // Label 16236: @1105454
     /* 1105454 */   GIM_Try, /*On fail goto*//*Label 16237*/ GIMT_Encode4(1105531), // Rule ID 61422 //
     /* 1105459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1105470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1105473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105498 */     // MIs[0] policy
     /* 1105498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105508 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105530 */     // GIR_Coverage, 61422,
     /* 1105530 */     GIR_EraseRootFromParent_Done,
     /* 1105531 */   // Label 16237: @1105531
     /* 1105531 */   GIM_Try, /*On fail goto*//*Label 16238*/ GIMT_Encode4(1105608), // Rule ID 61423 //
     /* 1105536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1105547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1105550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1105553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1105556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105575 */     // MIs[0] policy
     /* 1105575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105585 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105594 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105604 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105606 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105607 */     // GIR_Coverage, 61423,
     /* 1105607 */     GIR_EraseRootFromParent_Done,
     /* 1105608 */   // Label 16238: @1105608
     /* 1105608 */   GIM_Try, /*On fail goto*//*Label 16239*/ GIMT_Encode4(1105685), // Rule ID 61426 //
     /* 1105613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1105624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1105627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1105630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105652 */     // MIs[0] policy
     /* 1105652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105671 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105681 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105684 */     // GIR_Coverage, 61426,
     /* 1105684 */     GIR_EraseRootFromParent_Done,
     /* 1105685 */   // Label 16239: @1105685
     /* 1105685 */   GIM_Try, /*On fail goto*//*Label 16240*/ GIMT_Encode4(1105762), // Rule ID 61427 //
     /* 1105690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1105701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1105704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1105707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1105710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1105717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1105725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105729 */     // MIs[0] policy
     /* 1105729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105739 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1105742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1105758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105761 */     // GIR_Coverage, 61427,
     /* 1105761 */     GIR_EraseRootFromParent_Done,
     /* 1105762 */   // Label 16240: @1105762
     /* 1105762 */   GIM_Try, /*On fail goto*//*Label 16241*/ GIMT_Encode4(1105839), // Rule ID 61430 //
     /* 1105767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1105778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1105781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1105784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105806 */     // MIs[0] policy
     /* 1105806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105838 */     // GIR_Coverage, 61430,
     /* 1105838 */     GIR_EraseRootFromParent_Done,
     /* 1105839 */   // Label 16241: @1105839
     /* 1105839 */   GIM_Try, /*On fail goto*//*Label 16242*/ GIMT_Encode4(1105916), // Rule ID 61431 //
     /* 1105844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1105847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1105855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1105858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1105861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1105864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1105867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1105871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1105879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105883 */     // MIs[0] policy
     /* 1105883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105893 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11449:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1105893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2_MASK),
     /* 1105896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105902 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105912 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105915 */     // GIR_Coverage, 61431,
     /* 1105915 */     GIR_EraseRootFromParent_Done,
     /* 1105916 */   // Label 16242: @1105916
     /* 1105916 */   GIM_Try, /*On fail goto*//*Label 16243*/ GIMT_Encode4(1105993), // Rule ID 61434 //
     /* 1105921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1105924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1105929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1105932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1105935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1105938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1105941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1105944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1105948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1105956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1105960 */     // MIs[0] policy
     /* 1105960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1105963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1105970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1105970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1105973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1105975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1105977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1105979 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1105981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1105986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1105989 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1105991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1105992 */     // GIR_Coverage, 61434,
     /* 1105992 */     GIR_EraseRootFromParent_Done,
     /* 1105993 */   // Label 16243: @1105993
     /* 1105993 */   GIM_Try, /*On fail goto*//*Label 16244*/ GIMT_Encode4(1106070), // Rule ID 61435 //
     /* 1105998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1106009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1106012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1106015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1106018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1106025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106037 */     // MIs[0] policy
     /* 1106037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106047 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11449:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4_MASK),
     /* 1106050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106069 */     // GIR_Coverage, 61435,
     /* 1106069 */     GIR_EraseRootFromParent_Done,
     /* 1106070 */   // Label 16244: @1106070
     /* 1106070 */   GIM_Try, /*On fail goto*//*Label 16245*/ GIMT_Encode4(1106147), // Rule ID 61438 //
     /* 1106075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1106078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106114 */     // MIs[0] policy
     /* 1106114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106143 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106146 */     // GIR_Coverage, 61438,
     /* 1106146 */     GIR_EraseRootFromParent_Done,
     /* 1106147 */   // Label 16245: @1106147
     /* 1106147 */   GIM_Try, /*On fail goto*//*Label 16246*/ GIMT_Encode4(1106224), // Rule ID 61439 //
     /* 1106152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1106155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrev8_mask),
     /* 1106160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1106163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1106166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1106169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1106172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1106179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1106191 */     // MIs[0] policy
     /* 1106191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106201 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11449:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREV8_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8_MASK),
     /* 1106204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1106206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1106208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1106210 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1106212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1106220 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106223 */     // GIR_Coverage, 61439,
     /* 1106223 */     GIR_EraseRootFromParent_Done,
     /* 1106224 */   // Label 16246: @1106224
     /* 1106224 */   GIM_Try, /*On fail goto*//*Label 16247*/ GIMT_Encode4(1106301), // Rule ID 61964 //
     /* 1106229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106268 */     // MIs[0] policy
     /* 1106268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106278 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106297 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106300 */     // GIR_Coverage, 61964,
     /* 1106300 */     GIR_EraseRootFromParent_Done,
     /* 1106301 */   // Label 16247: @1106301
     /* 1106301 */   GIM_Try, /*On fail goto*//*Label 16248*/ GIMT_Encode4(1106378), // Rule ID 61965 //
     /* 1106306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1106317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1106320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1106323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1106326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106345 */     // MIs[0] policy
     /* 1106345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106355 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11250:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M1),
     /* 1106358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106374 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106377 */     // GIR_Coverage, 61965,
     /* 1106377 */     GIR_EraseRootFromParent_Done,
     /* 1106378 */   // Label 16248: @1106378
     /* 1106378 */   GIM_Try, /*On fail goto*//*Label 16249*/ GIMT_Encode4(1106455), // Rule ID 61966 //
     /* 1106383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1106403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106422 */     // MIs[0] policy
     /* 1106422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106432 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1106435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106451 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106454 */     // GIR_Coverage, 61966,
     /* 1106454 */     GIR_EraseRootFromParent_Done,
     /* 1106455 */   // Label 16249: @1106455
     /* 1106455 */   GIM_Try, /*On fail goto*//*Label 16250*/ GIMT_Encode4(1106532), // Rule ID 61967 //
     /* 1106460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1106471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1106474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1106477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1106480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1106499 */     // MIs[0] policy
     /* 1106499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11250:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M2),
     /* 1106512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106528 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106531 */     // GIR_Coverage, 61967,
     /* 1106531 */     GIR_EraseRootFromParent_Done,
     /* 1106532 */   // Label 16250: @1106532
     /* 1106532 */   GIM_Try, /*On fail goto*//*Label 16251*/ GIMT_Encode4(1106609), // Rule ID 61968 //
     /* 1106537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1106557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106576 */     // MIs[0] policy
     /* 1106576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106586 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1106589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106605 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106608 */     // GIR_Coverage, 61968,
     /* 1106608 */     GIR_EraseRootFromParent_Done,
     /* 1106609 */   // Label 16251: @1106609
     /* 1106609 */   GIM_Try, /*On fail goto*//*Label 16252*/ GIMT_Encode4(1106686), // Rule ID 61969 //
     /* 1106614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1106625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1106628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1106631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1106634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1106653 */     // MIs[0] policy
     /* 1106653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106663 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11250:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M4),
     /* 1106666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106685 */     // GIR_Coverage, 61969,
     /* 1106685 */     GIR_EraseRootFromParent_Done,
     /* 1106686 */   // Label 16252: @1106686
     /* 1106686 */   GIM_Try, /*On fail goto*//*Label 16253*/ GIMT_Encode4(1106763), // Rule ID 61970 //
     /* 1106691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode0),
     /* 1106694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1106711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106730 */     // MIs[0] policy
     /* 1106730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106740 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1106743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106759 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106762 */     // GIR_Coverage, 61970,
     /* 1106762 */     GIR_EraseRootFromParent_Done,
     /* 1106763 */   // Label 16253: @1106763
     /* 1106763 */   GIM_Try, /*On fail goto*//*Label 16254*/ GIMT_Encode4(1106840), // Rule ID 61971 //
     /* 1106768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkg_HwMode1),
     /* 1106771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vghsh),
     /* 1106776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1106779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1106782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1106785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1106788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1106807 */     // MIs[0] policy
     /* 1106807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106817 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11250:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVGHSH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVGHSH_VV_M8),
     /* 1106820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106836 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106839 */     // GIR_Coverage, 61971,
     /* 1106839 */     GIR_EraseRootFromParent_Done,
     /* 1106840 */   // Label 16254: @1106840
     /* 1106840 */   GIM_Try, /*On fail goto*//*Label 16255*/ GIMT_Encode4(1106917), // Rule ID 62174 //
     /* 1106845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1106848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1106853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1106856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1106859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1106862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1106865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1106868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106884 */     // MIs[0] policy
     /* 1106884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1106894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1106897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106913 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106916 */     // GIR_Coverage, 62174,
     /* 1106916 */     GIR_EraseRootFromParent_Done,
     /* 1106917 */   // Label 16255: @1106917
     /* 1106917 */   GIM_Try, /*On fail goto*//*Label 16256*/ GIMT_Encode4(1106994), // Rule ID 62175 //
     /* 1106922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1106925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1106930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1106933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1106936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1106939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1106942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1106945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1106961 */     // MIs[0] policy
     /* 1106961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1106964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1106971 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1106971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1106974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1106976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1106978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1106980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1106982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1106987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1106990 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1106992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1106993 */     // GIR_Coverage, 62175,
     /* 1106993 */     GIR_EraseRootFromParent_Done,
     /* 1106994 */   // Label 16256: @1106994
     /* 1106994 */   GIM_Try, /*On fail goto*//*Label 16257*/ GIMT_Encode4(1107071), // Rule ID 62176 //
     /* 1106999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107038 */     // MIs[0] policy
     /* 1107038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107048 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107067 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107070 */     // GIR_Coverage, 62176,
     /* 1107070 */     GIR_EraseRootFromParent_Done,
     /* 1107071 */   // Label 16257: @1107071
     /* 1107071 */   GIM_Try, /*On fail goto*//*Label 16258*/ GIMT_Encode4(1107148), // Rule ID 62177 //
     /* 1107076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107115 */     // MIs[0] policy
     /* 1107115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107125 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107130 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107144 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107147 */     // GIR_Coverage, 62177,
     /* 1107147 */     GIR_EraseRootFromParent_Done,
     /* 1107148 */   // Label 16258: @1107148
     /* 1107148 */   GIM_Try, /*On fail goto*//*Label 16259*/ GIMT_Encode4(1107225), // Rule ID 62178 //
     /* 1107153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107192 */     // MIs[0] policy
     /* 1107192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107224 */     // GIR_Coverage, 62178,
     /* 1107224 */     GIR_EraseRootFromParent_Done,
     /* 1107225 */   // Label 16259: @1107225
     /* 1107225 */   GIM_Try, /*On fail goto*//*Label 16260*/ GIMT_Encode4(1107302), // Rule ID 62179 //
     /* 1107230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107269 */     // MIs[0] policy
     /* 1107269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107301 */     // GIR_Coverage, 62179,
     /* 1107301 */     GIR_EraseRootFromParent_Done,
     /* 1107302 */   // Label 16260: @1107302
     /* 1107302 */   GIM_Try, /*On fail goto*//*Label 16261*/ GIMT_Encode4(1107379), // Rule ID 62180 //
     /* 1107307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107346 */     // MIs[0] policy
     /* 1107346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107378 */     // GIR_Coverage, 62180,
     /* 1107378 */     GIR_EraseRootFromParent_Done,
     /* 1107379 */   // Label 16261: @1107379
     /* 1107379 */   GIM_Try, /*On fail goto*//*Label 16262*/ GIMT_Encode4(1107456), // Rule ID 62181 //
     /* 1107384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1107395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1107398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1107401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1107404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1107423 */     // MIs[0] policy
     /* 1107423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107433 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1107436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107455 */     // GIR_Coverage, 62181,
     /* 1107455 */     GIR_EraseRootFromParent_Done,
     /* 1107456 */   // Label 16262: @1107456
     /* 1107456 */   GIM_Try, /*On fail goto*//*Label 16263*/ GIMT_Encode4(1107533), // Rule ID 62182 //
     /* 1107461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107500 */     // MIs[0] policy
     /* 1107500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107510 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1107513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107529 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107532 */     // GIR_Coverage, 62182,
     /* 1107532 */     GIR_EraseRootFromParent_Done,
     /* 1107533 */   // Label 16263: @1107533
     /* 1107533 */   GIM_Try, /*On fail goto*//*Label 16264*/ GIMT_Encode4(1107610), // Rule ID 62183 //
     /* 1107538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1107546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1107549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1107552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1107555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1107558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1107577 */     // MIs[0] policy
     /* 1107577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107587 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1107590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107606 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107609 */     // GIR_Coverage, 62183,
     /* 1107609 */     GIR_EraseRootFromParent_Done,
     /* 1107610 */   // Label 16264: @1107610
     /* 1107610 */   GIM_Try, /*On fail goto*//*Label 16265*/ GIMT_Encode4(1107687), // Rule ID 62184 //
     /* 1107615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1107623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107654 */     // MIs[0] policy
     /* 1107654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107683 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107686 */     // GIR_Coverage, 62184,
     /* 1107686 */     GIR_EraseRootFromParent_Done,
     /* 1107687 */   // Label 16265: @1107687
     /* 1107687 */   GIM_Try, /*On fail goto*//*Label 16266*/ GIMT_Encode4(1107764), // Rule ID 62185 //
     /* 1107692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1107700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1107703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1107706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1107709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1107712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107731 */     // MIs[0] policy
     /* 1107731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107741 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1107744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107760 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107763 */     // GIR_Coverage, 62185,
     /* 1107763 */     GIR_EraseRootFromParent_Done,
     /* 1107764 */   // Label 16266: @1107764
     /* 1107764 */   GIM_Try, /*On fail goto*//*Label 16267*/ GIMT_Encode4(1107841), // Rule ID 62186 //
     /* 1107769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1107777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107808 */     // MIs[0] policy
     /* 1107808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107837 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107840 */     // GIR_Coverage, 62186,
     /* 1107840 */     GIR_EraseRootFromParent_Done,
     /* 1107841 */   // Label 16267: @1107841
     /* 1107841 */   GIM_Try, /*On fail goto*//*Label 16268*/ GIMT_Encode4(1107918), // Rule ID 62187 //
     /* 1107846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1107849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1107854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1107857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1107860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1107863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1107866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1107869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1107885 */     // MIs[0] policy
     /* 1107885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107895 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1107895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1107898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107914 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107917 */     // GIR_Coverage, 62187,
     /* 1107917 */     GIR_EraseRootFromParent_Done,
     /* 1107918 */   // Label 16268: @1107918
     /* 1107918 */   GIM_Try, /*On fail goto*//*Label 16269*/ GIMT_Encode4(1107995), // Rule ID 62188 //
     /* 1107923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1107926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1107931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1107934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1107937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1107940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1107943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1107946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1107962 */     // MIs[0] policy
     /* 1107962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1107965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1107972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1107972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1107975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1107977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1107979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1107981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1107983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1107988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1107991 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1107993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1107994 */     // GIR_Coverage, 62188,
     /* 1107994 */     GIR_EraseRootFromParent_Done,
     /* 1107995 */   // Label 16269: @1107995
     /* 1107995 */   GIM_Try, /*On fail goto*//*Label 16270*/ GIMT_Encode4(1108072), // Rule ID 62189 //
     /* 1108000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108039 */     // MIs[0] policy
     /* 1108039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108049 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1108052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108068 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108071 */     // GIR_Coverage, 62189,
     /* 1108071 */     GIR_EraseRootFromParent_Done,
     /* 1108072 */   // Label 16270: @1108072
     /* 1108072 */   GIM_Try, /*On fail goto*//*Label 16271*/ GIMT_Encode4(1108149), // Rule ID 62190 //
     /* 1108077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108116 */     // MIs[0] policy
     /* 1108116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108145 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108148 */     // GIR_Coverage, 62190,
     /* 1108148 */     GIR_EraseRootFromParent_Done,
     /* 1108149 */   // Label 16271: @1108149
     /* 1108149 */   GIM_Try, /*On fail goto*//*Label 16272*/ GIMT_Encode4(1108226), // Rule ID 62191 //
     /* 1108154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108193 */     // MIs[0] policy
     /* 1108193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108203 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1108206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108222 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108225 */     // GIR_Coverage, 62191,
     /* 1108225 */     GIR_EraseRootFromParent_Done,
     /* 1108226 */   // Label 16272: @1108226
     /* 1108226 */   GIM_Try, /*On fail goto*//*Label 16273*/ GIMT_Encode4(1108303), // Rule ID 62192 //
     /* 1108231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108270 */     // MIs[0] policy
     /* 1108270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108280 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108302 */     // GIR_Coverage, 62192,
     /* 1108302 */     GIR_EraseRootFromParent_Done,
     /* 1108303 */   // Label 16273: @1108303
     /* 1108303 */   GIM_Try, /*On fail goto*//*Label 16274*/ GIMT_Encode4(1108380), // Rule ID 62193 //
     /* 1108308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1108316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1108319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1108322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1108325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1108328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1108347 */     // MIs[0] policy
     /* 1108347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108357 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1108360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108379 */     // GIR_Coverage, 62193,
     /* 1108379 */     GIR_EraseRootFromParent_Done,
     /* 1108380 */   // Label 16274: @1108380
     /* 1108380 */   GIM_Try, /*On fail goto*//*Label 16275*/ GIMT_Encode4(1108457), // Rule ID 62194 //
     /* 1108385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108424 */     // MIs[0] policy
     /* 1108424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108434 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1108437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108453 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108456 */     // GIR_Coverage, 62194,
     /* 1108456 */     GIR_EraseRootFromParent_Done,
     /* 1108457 */   // Label 16275: @1108457
     /* 1108457 */   GIM_Try, /*On fail goto*//*Label 16276*/ GIMT_Encode4(1108534), // Rule ID 62195 //
     /* 1108462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1108473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1108476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1108479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1108482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108501 */     // MIs[0] policy
     /* 1108501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108511 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1108514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108530 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108533 */     // GIR_Coverage, 62195,
     /* 1108533 */     GIR_EraseRootFromParent_Done,
     /* 1108534 */   // Label 16276: @1108534
     /* 1108534 */   GIM_Try, /*On fail goto*//*Label 16277*/ GIMT_Encode4(1108611), // Rule ID 62196 //
     /* 1108539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108578 */     // MIs[0] policy
     /* 1108578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1108591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108610 */     // GIR_Coverage, 62196,
     /* 1108610 */     GIR_EraseRootFromParent_Done,
     /* 1108611 */   // Label 16277: @1108611
     /* 1108611 */   GIM_Try, /*On fail goto*//*Label 16278*/ GIMT_Encode4(1108688), // Rule ID 62197 //
     /* 1108616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1108627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1108630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1108633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1108636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1108655 */     // MIs[0] policy
     /* 1108655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108665 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1108668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108687 */     // GIR_Coverage, 62197,
     /* 1108687 */     GIR_EraseRootFromParent_Done,
     /* 1108688 */   // Label 16278: @1108688
     /* 1108688 */   GIM_Try, /*On fail goto*//*Label 16279*/ GIMT_Encode4(1108765), // Rule ID 62198 //
     /* 1108693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108732 */     // MIs[0] policy
     /* 1108732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108742 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1108745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108764 */     // GIR_Coverage, 62198,
     /* 1108764 */     GIR_EraseRootFromParent_Done,
     /* 1108765 */   // Label 16279: @1108765
     /* 1108765 */   GIM_Try, /*On fail goto*//*Label 16280*/ GIMT_Encode4(1108842), // Rule ID 62199 //
     /* 1108770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1108781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1108784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1108787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1108790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1108809 */     // MIs[0] policy
     /* 1108809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108819 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1108822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108838 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108841 */     // GIR_Coverage, 62199,
     /* 1108841 */     GIR_EraseRootFromParent_Done,
     /* 1108842 */   // Label 16280: @1108842
     /* 1108842 */   GIM_Try, /*On fail goto*//*Label 16281*/ GIMT_Encode4(1108919), // Rule ID 62200 //
     /* 1108847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1108850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1108870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108886 */     // MIs[0] policy
     /* 1108886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1108896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1108899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108915 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108918 */     // GIR_Coverage, 62200,
     /* 1108918 */     GIR_EraseRootFromParent_Done,
     /* 1108919 */   // Label 16281: @1108919
     /* 1108919 */   GIM_Try, /*On fail goto*//*Label 16282*/ GIMT_Encode4(1108996), // Rule ID 62201 //
     /* 1108924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1108927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1108932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1108935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1108938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1108941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1108944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1108947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1108963 */     // MIs[0] policy
     /* 1108963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1108966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1108973 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1108973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1108976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1108978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1108980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1108982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1108984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1108989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1108992 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1108994 */     GIR_RootConstrainSelectedInstOperands,
     /* 1108995 */     // GIR_Coverage, 62201,
     /* 1108995 */     GIR_EraseRootFromParent_Done,
     /* 1108996 */   // Label 16282: @1108996
     /* 1108996 */   GIM_Try, /*On fail goto*//*Label 16283*/ GIMT_Encode4(1109073), // Rule ID 62202 //
     /* 1109001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode0),
     /* 1109004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109040 */     // MIs[0] policy
     /* 1109040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109050 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109069 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109072 */     // GIR_Coverage, 62202,
     /* 1109072 */     GIR_EraseRootFromParent_Done,
     /* 1109073 */   // Label 16283: @1109073
     /* 1109073 */   GIM_Try, /*On fail goto*//*Label 16284*/ GIMT_Encode4(1109150), // Rule ID 62203 //
     /* 1109078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknha_HwMode1),
     /* 1109081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1109086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109117 */     // MIs[0] policy
     /* 1109117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109127 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1109130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109146 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109149 */     // GIR_Coverage, 62203,
     /* 1109149 */     GIR_EraseRootFromParent_Done,
     /* 1109150 */   // Label 16284: @1109150
     /* 1109150 */   GIM_Try, /*On fail goto*//*Label 16285*/ GIMT_Encode4(1109227), // Rule ID 62204 //
     /* 1109155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109194 */     // MIs[0] policy
     /* 1109194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109223 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109226 */     // GIR_Coverage, 62204,
     /* 1109226 */     GIR_EraseRootFromParent_Done,
     /* 1109227 */   // Label 16285: @1109227
     /* 1109227 */   GIM_Try, /*On fail goto*//*Label 16286*/ GIMT_Encode4(1109304), // Rule ID 62205 //
     /* 1109232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1109243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1109246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1109249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1109252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109271 */     // MIs[0] policy
     /* 1109271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109281 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1109284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109300 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109303 */     // GIR_Coverage, 62205,
     /* 1109303 */     GIR_EraseRootFromParent_Done,
     /* 1109304 */   // Label 16286: @1109304
     /* 1109304 */   GIM_Try, /*On fail goto*//*Label 16287*/ GIMT_Encode4(1109381), // Rule ID 62206 //
     /* 1109309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109348 */     // MIs[0] policy
     /* 1109348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109358 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109377 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109380 */     // GIR_Coverage, 62206,
     /* 1109380 */     GIR_EraseRootFromParent_Done,
     /* 1109381 */   // Label 16287: @1109381
     /* 1109381 */   GIM_Try, /*On fail goto*//*Label 16288*/ GIMT_Encode4(1109458), // Rule ID 62207 //
     /* 1109386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1109397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1109400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1109403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1109406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109425 */     // MIs[0] policy
     /* 1109425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109435 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11473:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109454 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109457 */     // GIR_Coverage, 62207,
     /* 1109457 */     GIR_EraseRootFromParent_Done,
     /* 1109458 */   // Label 16288: @1109458
     /* 1109458 */   GIM_Try, /*On fail goto*//*Label 16289*/ GIMT_Encode4(1109535), // Rule ID 62208 //
     /* 1109463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1109480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1109483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109502 */     // MIs[0] policy
     /* 1109502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1109531 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109534 */     // GIR_Coverage, 62208,
     /* 1109534 */     GIR_EraseRootFromParent_Done,
     /* 1109535 */   // Label 16289: @1109535
     /* 1109535 */   GIM_Try, /*On fail goto*//*Label 16290*/ GIMT_Encode4(1109612), // Rule ID 62209 //
     /* 1109540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1109551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1109554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1109557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1109560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1109579 */     // MIs[0] policy
     /* 1109579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109589 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11473:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1109592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1109608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109611 */     // GIR_Coverage, 62209,
     /* 1109611 */     GIR_EraseRootFromParent_Done,
     /* 1109612 */   // Label 16290: @1109612
     /* 1109612 */   GIM_Try, /*On fail goto*//*Label 16291*/ GIMT_Encode4(1109689), // Rule ID 62210 //
     /* 1109617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109656 */     // MIs[0] policy
     /* 1109656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109666 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1109669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109688 */     // GIR_Coverage, 62210,
     /* 1109688 */     GIR_EraseRootFromParent_Done,
     /* 1109689 */   // Label 16291: @1109689
     /* 1109689 */   GIM_Try, /*On fail goto*//*Label 16292*/ GIMT_Encode4(1109766), // Rule ID 62211 //
     /* 1109694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1109705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1109708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1109711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1109714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1109733 */     // MIs[0] policy
     /* 1109733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1109746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109762 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109765 */     // GIR_Coverage, 62211,
     /* 1109765 */     GIR_EraseRootFromParent_Done,
     /* 1109766 */   // Label 16292: @1109766
     /* 1109766 */   GIM_Try, /*On fail goto*//*Label 16293*/ GIMT_Encode4(1109843), // Rule ID 62212 //
     /* 1109771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109810 */     // MIs[0] policy
     /* 1109810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109820 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109839 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109842 */     // GIR_Coverage, 62212,
     /* 1109842 */     GIR_EraseRootFromParent_Done,
     /* 1109843 */   // Label 16293: @1109843
     /* 1109843 */   GIM_Try, /*On fail goto*//*Label 16294*/ GIMT_Encode4(1109920), // Rule ID 62213 //
     /* 1109848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1109851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1109859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1109862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1109865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1109868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1109871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1109887 */     // MIs[0] policy
     /* 1109887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109897 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1109897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1109900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109916 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109919 */     // GIR_Coverage, 62213,
     /* 1109919 */     GIR_EraseRootFromParent_Done,
     /* 1109920 */   // Label 16294: @1109920
     /* 1109920 */   GIM_Try, /*On fail goto*//*Label 16295*/ GIMT_Encode4(1109997), // Rule ID 62214 //
     /* 1109925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1109928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1109933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1109936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1109939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1109942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1109945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1109948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1109964 */     // MIs[0] policy
     /* 1109964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1109967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1109974 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1109974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1109977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1109979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1109981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1109983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1109985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1109990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1109993 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1109995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1109996 */     // GIR_Coverage, 62214,
     /* 1109996 */     GIR_EraseRootFromParent_Done,
     /* 1109997 */   // Label 16295: @1109997
     /* 1109997 */   GIM_Try, /*On fail goto*//*Label 16296*/ GIMT_Encode4(1110074), // Rule ID 62215 //
     /* 1110002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1110013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1110016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1110019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1110022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110041 */     // MIs[0] policy
     /* 1110041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110051 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110073 */     // GIR_Coverage, 62215,
     /* 1110073 */     GIR_EraseRootFromParent_Done,
     /* 1110074 */   // Label 16296: @1110074
     /* 1110074 */   GIM_Try, /*On fail goto*//*Label 16297*/ GIMT_Encode4(1110151), // Rule ID 62216 //
     /* 1110079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110118 */     // MIs[0] policy
     /* 1110118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110150 */     // GIR_Coverage, 62216,
     /* 1110150 */     GIR_EraseRootFromParent_Done,
     /* 1110151 */   // Label 16297: @1110151
     /* 1110151 */   GIM_Try, /*On fail goto*//*Label 16298*/ GIMT_Encode4(1110228), // Rule ID 62217 //
     /* 1110156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1110167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1110170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1110173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1110176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1110195 */     // MIs[0] policy
     /* 1110195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11473:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1110208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110210 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110224 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110227 */     // GIR_Coverage, 62217,
     /* 1110227 */     GIR_EraseRootFromParent_Done,
     /* 1110228 */   // Label 16298: @1110228
     /* 1110228 */   GIM_Try, /*On fail goto*//*Label 16299*/ GIMT_Encode4(1110305), // Rule ID 62218 //
     /* 1110233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110272 */     // MIs[0] policy
     /* 1110272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110301 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110304 */     // GIR_Coverage, 62218,
     /* 1110304 */     GIR_EraseRootFromParent_Done,
     /* 1110305 */   // Label 16299: @1110305
     /* 1110305 */   GIM_Try, /*On fail goto*//*Label 16300*/ GIMT_Encode4(1110382), // Rule ID 62219 //
     /* 1110310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1110321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1110324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1110327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1110330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1110349 */     // MIs[0] policy
     /* 1110349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110359 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11473:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1110362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110378 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110381 */     // GIR_Coverage, 62219,
     /* 1110381 */     GIR_EraseRootFromParent_Done,
     /* 1110382 */   // Label 16300: @1110382
     /* 1110382 */   GIM_Try, /*On fail goto*//*Label 16301*/ GIMT_Encode4(1110459), // Rule ID 62220 //
     /* 1110387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1110407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110426 */     // MIs[0] policy
     /* 1110426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110436 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110455 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110458 */     // GIR_Coverage, 62220,
     /* 1110458 */     GIR_EraseRootFromParent_Done,
     /* 1110459 */   // Label 16301: @1110459
     /* 1110459 */   GIM_Try, /*On fail goto*//*Label 16302*/ GIMT_Encode4(1110536), // Rule ID 62221 //
     /* 1110464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ch),
     /* 1110472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1110475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1110478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1110481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1110484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1110503 */     // MIs[0] policy
     /* 1110503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110513 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11473:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1110516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110532 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110535 */     // GIR_Coverage, 62221,
     /* 1110535 */     GIR_EraseRootFromParent_Done,
     /* 1110536 */   // Label 16302: @1110536
     /* 1110536 */   GIM_Try, /*On fail goto*//*Label 16303*/ GIMT_Encode4(1110613), // Rule ID 62222 //
     /* 1110541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110580 */     // MIs[0] policy
     /* 1110580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110590 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110609 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110612 */     // GIR_Coverage, 62222,
     /* 1110612 */     GIR_EraseRootFromParent_Done,
     /* 1110613 */   // Label 16303: @1110613
     /* 1110613 */   GIM_Try, /*On fail goto*//*Label 16304*/ GIMT_Encode4(1110690), // Rule ID 62223 //
     /* 1110618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1110629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1110632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1110635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1110638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110657 */     // MIs[0] policy
     /* 1110657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_MF2),
     /* 1110670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110689 */     // GIR_Coverage, 62223,
     /* 1110689 */     GIR_EraseRootFromParent_Done,
     /* 1110690 */   // Label 16304: @1110690
     /* 1110690 */   GIM_Try, /*On fail goto*//*Label 16305*/ GIMT_Encode4(1110767), // Rule ID 62224 //
     /* 1110695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110734 */     // MIs[0] policy
     /* 1110734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110766 */     // GIR_Coverage, 62224,
     /* 1110766 */     GIR_EraseRootFromParent_Done,
     /* 1110767 */   // Label 16305: @1110767
     /* 1110767 */   GIM_Try, /*On fail goto*//*Label 16306*/ GIMT_Encode4(1110844), // Rule ID 62225 //
     /* 1110772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1110783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1110786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1110789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1110792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110811 */     // MIs[0] policy
     /* 1110811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110821 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11474:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1110840 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110842 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110843 */     // GIR_Coverage, 62225,
     /* 1110843 */     GIR_EraseRootFromParent_Done,
     /* 1110844 */   // Label 16306: @1110844
     /* 1110844 */   GIM_Try, /*On fail goto*//*Label 16307*/ GIMT_Encode4(1110921), // Rule ID 62226 //
     /* 1110849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1110852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1110872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110888 */     // MIs[0] policy
     /* 1110888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110898 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1110898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110917 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110920 */     // GIR_Coverage, 62226,
     /* 1110920 */     GIR_EraseRootFromParent_Done,
     /* 1110921 */   // Label 16307: @1110921
     /* 1110921 */   GIM_Try, /*On fail goto*//*Label 16308*/ GIMT_Encode4(1110998), // Rule ID 62227 //
     /* 1110926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1110929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1110934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1110937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1110940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1110943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1110946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1110949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1110965 */     // MIs[0] policy
     /* 1110965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1110968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1110975 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11474:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1110975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M1),
     /* 1110978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1110980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1110982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1110984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1110986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1110991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1110994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1110996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1110997 */     // GIR_Coverage, 62227,
     /* 1110997 */     GIR_EraseRootFromParent_Done,
     /* 1110998 */   // Label 16308: @1110998
     /* 1110998 */   GIM_Try, /*On fail goto*//*Label 16309*/ GIMT_Encode4(1111075), // Rule ID 62228 //
     /* 1111003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111042 */     // MIs[0] policy
     /* 1111042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111071 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111074 */     // GIR_Coverage, 62228,
     /* 1111074 */     GIR_EraseRootFromParent_Done,
     /* 1111075 */   // Label 16309: @1111075
     /* 1111075 */   GIM_Try, /*On fail goto*//*Label 16310*/ GIMT_Encode4(1111152), // Rule ID 62229 //
     /* 1111080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1111091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1111094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1111097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1111100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111119 */     // MIs[0] policy
     /* 1111119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111129 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111148 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111151 */     // GIR_Coverage, 62229,
     /* 1111151 */     GIR_EraseRootFromParent_Done,
     /* 1111152 */   // Label 16310: @1111152
     /* 1111152 */   GIM_Try, /*On fail goto*//*Label 16311*/ GIMT_Encode4(1111229), // Rule ID 62230 //
     /* 1111157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111196 */     // MIs[0] policy
     /* 1111196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111206 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111225 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111228 */     // GIR_Coverage, 62230,
     /* 1111228 */     GIR_EraseRootFromParent_Done,
     /* 1111229 */   // Label 16311: @1111229
     /* 1111229 */   GIM_Try, /*On fail goto*//*Label 16312*/ GIMT_Encode4(1111306), // Rule ID 62231 //
     /* 1111234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1111245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1111248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1111251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1111254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111273 */     // MIs[0] policy
     /* 1111273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111283 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111302 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111305 */     // GIR_Coverage, 62231,
     /* 1111305 */     GIR_EraseRootFromParent_Done,
     /* 1111306 */   // Label 16312: @1111306
     /* 1111306 */   GIM_Try, /*On fail goto*//*Label 16313*/ GIMT_Encode4(1111383), // Rule ID 62232 //
     /* 1111311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111350 */     // MIs[0] policy
     /* 1111350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111360 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111379 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111382 */     // GIR_Coverage, 62232,
     /* 1111382 */     GIR_EraseRootFromParent_Done,
     /* 1111383 */   // Label 16313: @1111383
     /* 1111383 */   GIM_Try, /*On fail goto*//*Label 16314*/ GIMT_Encode4(1111460), // Rule ID 62233 //
     /* 1111388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1111399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1111402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1111405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1111408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111427 */     // MIs[0] policy
     /* 1111427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111437 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111456 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111459 */     // GIR_Coverage, 62233,
     /* 1111459 */     GIR_EraseRootFromParent_Done,
     /* 1111460 */   // Label 16314: @1111460
     /* 1111460 */   GIM_Try, /*On fail goto*//*Label 16315*/ GIMT_Encode4(1111537), // Rule ID 62234 //
     /* 1111465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111504 */     // MIs[0] policy
     /* 1111504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111514 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111533 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111536 */     // GIR_Coverage, 62234,
     /* 1111536 */     GIR_EraseRootFromParent_Done,
     /* 1111537 */   // Label 16315: @1111537
     /* 1111537 */   GIM_Try, /*On fail goto*//*Label 16316*/ GIMT_Encode4(1111614), // Rule ID 62235 //
     /* 1111542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1111553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1111556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1111559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1111562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1111581 */     // MIs[0] policy
     /* 1111581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111591 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11474:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M2),
     /* 1111594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111613 */     // GIR_Coverage, 62235,
     /* 1111613 */     GIR_EraseRootFromParent_Done,
     /* 1111614 */   // Label 16316: @1111614
     /* 1111614 */   GIM_Try, /*On fail goto*//*Label 16317*/ GIMT_Encode4(1111691), // Rule ID 62236 //
     /* 1111619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111658 */     // MIs[0] policy
     /* 1111658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111668 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111687 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111690 */     // GIR_Coverage, 62236,
     /* 1111690 */     GIR_EraseRootFromParent_Done,
     /* 1111691 */   // Label 16317: @1111691
     /* 1111691 */   GIM_Try, /*On fail goto*//*Label 16318*/ GIMT_Encode4(1111768), // Rule ID 62237 //
     /* 1111696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1111707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1111710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1111713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1111716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1111735 */     // MIs[0] policy
     /* 1111735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111745 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11474:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M4),
     /* 1111748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111764 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111767 */     // GIR_Coverage, 62237,
     /* 1111767 */     GIR_EraseRootFromParent_Done,
     /* 1111768 */   // Label 16318: @1111768
     /* 1111768 */   GIM_Try, /*On fail goto*//*Label 16319*/ GIMT_Encode4(1111845), // Rule ID 62238 //
     /* 1111773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111812 */     // MIs[0] policy
     /* 1111812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111822 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111841 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111844 */     // GIR_Coverage, 62238,
     /* 1111844 */     GIR_EraseRootFromParent_Done,
     /* 1111845 */   // Label 16319: @1111845
     /* 1111845 */   GIM_Try, /*On fail goto*//*Label 16320*/ GIMT_Encode4(1111922), // Rule ID 62239 //
     /* 1111850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1111853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2cl),
     /* 1111858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1111861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1111864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1111867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1111870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1111873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1111889 */     // MIs[0] policy
     /* 1111889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111899 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11474:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2CH_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1111899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2CH_VV_M8),
     /* 1111902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1111918 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111921 */     // GIR_Coverage, 62239,
     /* 1111921 */     GIR_EraseRootFromParent_Done,
     /* 1111922 */   // Label 16320: @1111922
     /* 1111922 */   GIM_Try, /*On fail goto*//*Label 16321*/ GIMT_Encode4(1111999), // Rule ID 62240 //
     /* 1111927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1111930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1111935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1111938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1111941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1111944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1111947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1111950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1111966 */     // MIs[0] policy
     /* 1111966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1111969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1111976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1111976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1111979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1111981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1111983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1111985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1111987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1111992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1111995 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1111997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1111998 */     // GIR_Coverage, 62240,
     /* 1111998 */     GIR_EraseRootFromParent_Done,
     /* 1111999 */   // Label 16321: @1111999
     /* 1111999 */   GIM_Try, /*On fail goto*//*Label 16322*/ GIMT_Encode4(1112076), // Rule ID 62241 //
     /* 1112004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1112015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1112018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1112021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1112024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112043 */     // MIs[0] policy
     /* 1112043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112053 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_MF2_E32:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_MF2_E32),
     /* 1112056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112072 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112075 */     // GIR_Coverage, 62241,
     /* 1112075 */     GIR_EraseRootFromParent_Done,
     /* 1112076 */   // Label 16322: @1112076
     /* 1112076 */   GIM_Try, /*On fail goto*//*Label 16323*/ GIMT_Encode4(1112153), // Rule ID 62242 //
     /* 1112081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112120 */     // MIs[0] policy
     /* 1112120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112152 */     // GIR_Coverage, 62242,
     /* 1112152 */     GIR_EraseRootFromParent_Done,
     /* 1112153 */   // Label 16323: @1112153
     /* 1112153 */   GIM_Try, /*On fail goto*//*Label 16324*/ GIMT_Encode4(1112230), // Rule ID 62243 //
     /* 1112158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1112169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1112172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1112175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1112178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112197 */     // MIs[0] policy
     /* 1112197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112207 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11475:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E32:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E32),
     /* 1112210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112229 */     // GIR_Coverage, 62243,
     /* 1112229 */     GIR_EraseRootFromParent_Done,
     /* 1112230 */   // Label 16324: @1112230
     /* 1112230 */   GIM_Try, /*On fail goto*//*Label 16325*/ GIMT_Encode4(1112307), // Rule ID 62244 //
     /* 1112235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112274 */     // MIs[0] policy
     /* 1112274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112284 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112303 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112306 */     // GIR_Coverage, 62244,
     /* 1112306 */     GIR_EraseRootFromParent_Done,
     /* 1112307 */   // Label 16325: @1112307
     /* 1112307 */   GIM_Try, /*On fail goto*//*Label 16326*/ GIMT_Encode4(1112384), // Rule ID 62245 //
     /* 1112312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1112323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1112326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1112329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1112332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1112351 */     // MIs[0] policy
     /* 1112351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112361 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11475:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M1_E64:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M1_E64),
     /* 1112364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112380 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112383 */     // GIR_Coverage, 62245,
     /* 1112383 */     GIR_EraseRootFromParent_Done,
     /* 1112384 */   // Label 16326: @1112384
     /* 1112384 */   GIM_Try, /*On fail goto*//*Label 16327*/ GIMT_Encode4(1112461), // Rule ID 62246 //
     /* 1112389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112428 */     // MIs[0] policy
     /* 1112428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1112441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112457 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112460 */     // GIR_Coverage, 62246,
     /* 1112460 */     GIR_EraseRootFromParent_Done,
     /* 1112461 */   // Label 16327: @1112461
     /* 1112461 */   GIM_Try, /*On fail goto*//*Label 16328*/ GIMT_Encode4(1112538), // Rule ID 62247 //
     /* 1112466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1112477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1112480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1112483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1112486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112505 */     // MIs[0] policy
     /* 1112505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112515 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E32:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E32),
     /* 1112518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112534 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112537 */     // GIR_Coverage, 62247,
     /* 1112537 */     GIR_EraseRootFromParent_Done,
     /* 1112538 */   // Label 16328: @1112538
     /* 1112538 */   GIM_Try, /*On fail goto*//*Label 16329*/ GIMT_Encode4(1112615), // Rule ID 62248 //
     /* 1112543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112582 */     // MIs[0] policy
     /* 1112582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112592 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1112595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112611 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112614 */     // GIR_Coverage, 62248,
     /* 1112614 */     GIR_EraseRootFromParent_Done,
     /* 1112615 */   // Label 16329: @1112615
     /* 1112615 */   GIM_Try, /*On fail goto*//*Label 16330*/ GIMT_Encode4(1112692), // Rule ID 62249 //
     /* 1112620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1112631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1112634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1112637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1112640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1112659 */     // MIs[0] policy
     /* 1112659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E32:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E32),
     /* 1112672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112688 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112690 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112691 */     // GIR_Coverage, 62249,
     /* 1112691 */     GIR_EraseRootFromParent_Done,
     /* 1112692 */   // Label 16330: @1112692
     /* 1112692 */   GIM_Try, /*On fail goto*//*Label 16331*/ GIMT_Encode4(1112769), // Rule ID 62250 //
     /* 1112697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112736 */     // MIs[0] policy
     /* 1112736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112746 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1112749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112765 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112768 */     // GIR_Coverage, 62250,
     /* 1112768 */     GIR_EraseRootFromParent_Done,
     /* 1112769 */   // Label 16331: @1112769
     /* 1112769 */   GIM_Try, /*On fail goto*//*Label 16332*/ GIMT_Encode4(1112846), // Rule ID 62251 //
     /* 1112774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1112785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1112788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1112791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1112794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1112813 */     // MIs[0] policy
     /* 1112813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112823 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E32:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E32),
     /* 1112826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1112842 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112845 */     // GIR_Coverage, 62251,
     /* 1112845 */     GIR_EraseRootFromParent_Done,
     /* 1112846 */   // Label 16332: @1112846
     /* 1112846 */   GIM_Try, /*On fail goto*//*Label 16333*/ GIMT_Encode4(1112923), // Rule ID 62252 //
     /* 1112851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1112854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1112874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112890 */     // MIs[0] policy
     /* 1112890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1112900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1112903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112919 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112922 */     // GIR_Coverage, 62252,
     /* 1112922 */     GIR_EraseRootFromParent_Done,
     /* 1112923 */   // Label 16333: @1112923
     /* 1112923 */   GIM_Try, /*On fail goto*//*Label 16334*/ GIMT_Encode4(1113000), // Rule ID 62253 //
     /* 1112928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1112931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1112936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1112939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1112942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1112945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1112948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1112951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1112967 */     // MIs[0] policy
     /* 1112967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1112970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1112977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11475:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M2_E64:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1112977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M2_E64),
     /* 1112980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1112982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1112984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1112986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1112988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1112993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1112996 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1112998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1112999 */     // GIR_Coverage, 62253,
     /* 1112999 */     GIR_EraseRootFromParent_Done,
     /* 1113000 */   // Label 16334: @1113000
     /* 1113000 */   GIM_Try, /*On fail goto*//*Label 16335*/ GIMT_Encode4(1113077), // Rule ID 62254 //
     /* 1113005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113044 */     // MIs[0] policy
     /* 1113044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113073 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113076 */     // GIR_Coverage, 62254,
     /* 1113076 */     GIR_EraseRootFromParent_Done,
     /* 1113077 */   // Label 16335: @1113077
     /* 1113077 */   GIM_Try, /*On fail goto*//*Label 16336*/ GIMT_Encode4(1113154), // Rule ID 62255 //
     /* 1113082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1113093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1113096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1113099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1113102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113121 */     // MIs[0] policy
     /* 1113121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113131 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11475:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M4_E64:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M4_E64),
     /* 1113134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113150 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113153 */     // GIR_Coverage, 62255,
     /* 1113153 */     GIR_EraseRootFromParent_Done,
     /* 1113154 */   // Label 16336: @1113154
     /* 1113154 */   GIM_Try, /*On fail goto*//*Label 16337*/ GIMT_Encode4(1113231), // Rule ID 62256 //
     /* 1113159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode0),
     /* 1113162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113198 */     // MIs[0] policy
     /* 1113198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113227 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113230 */     // GIR_Coverage, 62256,
     /* 1113230 */     GIR_EraseRootFromParent_Done,
     /* 1113231 */   // Label 16337: @1113231
     /* 1113231 */   GIM_Try, /*On fail goto*//*Label 16338*/ GIMT_Encode4(1113308), // Rule ID 62257 //
     /* 1113236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvknhb_HwMode1),
     /* 1113239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsha2ms),
     /* 1113244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1113247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1113250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1113253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1113256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113275 */     // MIs[0] policy
     /* 1113275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113285 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11475:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSHA2MS_VV_M8_E64:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSHA2MS_VV_M8_E64),
     /* 1113288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 1113290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1113304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113307 */     // GIR_Coverage, 62257,
     /* 1113307 */     GIR_EraseRootFromParent_Done,
     /* 1113308 */   // Label 16338: @1113308
     /* 1113308 */   GIM_Try, /*On fail goto*//*Label 16339*/ GIMT_Encode4(1113385), // Rule ID 62577 //
     /* 1113313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113352 */     // MIs[0] policy
     /* 1113352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113362 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1113365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113384 */     // GIR_Coverage, 62577,
     /* 1113384 */     GIR_EraseRootFromParent_Done,
     /* 1113385 */   // Label 16339: @1113385
     /* 1113385 */   GIM_Try, /*On fail goto*//*Label 16340*/ GIMT_Encode4(1113462), // Rule ID 62578 //
     /* 1113390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1113401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1113404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1113407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1113410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113429 */     // MIs[0] policy
     /* 1113429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113439 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2),
     /* 1113442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113461 */     // GIR_Coverage, 62578,
     /* 1113461 */     GIR_EraseRootFromParent_Done,
     /* 1113462 */   // Label 16340: @1113462
     /* 1113462 */   GIM_Try, /*On fail goto*//*Label 16341*/ GIMT_Encode4(1113539), // Rule ID 62581 //
     /* 1113467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1113484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1113487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113506 */     // MIs[0] policy
     /* 1113506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1113519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113538 */     // GIR_Coverage, 62581,
     /* 1113538 */     GIR_EraseRootFromParent_Done,
     /* 1113539 */   // Label 16341: @1113539
     /* 1113539 */   GIM_Try, /*On fail goto*//*Label 16342*/ GIMT_Encode4(1113616), // Rule ID 62582 //
     /* 1113544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1113555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1113558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1113561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1113564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1113583 */     // MIs[0] policy
     /* 1113583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113593 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1),
     /* 1113596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113615 */     // GIR_Coverage, 62582,
     /* 1113615 */     GIR_EraseRootFromParent_Done,
     /* 1113616 */   // Label 16342: @1113616
     /* 1113616 */   GIM_Try, /*On fail goto*//*Label 16343*/ GIMT_Encode4(1113693), // Rule ID 62585 //
     /* 1113621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1113638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1113641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113660 */     // MIs[0] policy
     /* 1113660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113670 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1113673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113689 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113692 */     // GIR_Coverage, 62585,
     /* 1113692 */     GIR_EraseRootFromParent_Done,
     /* 1113693 */   // Label 16343: @1113693
     /* 1113693 */   GIM_Try, /*On fail goto*//*Label 16344*/ GIMT_Encode4(1113770), // Rule ID 62586 //
     /* 1113698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1113709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1113712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1113715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1113718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1113737 */     // MIs[0] policy
     /* 1113737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2),
     /* 1113750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113766 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113769 */     // GIR_Coverage, 62586,
     /* 1113769 */     GIR_EraseRootFromParent_Done,
     /* 1113770 */   // Label 16344: @1113770
     /* 1113770 */   GIM_Try, /*On fail goto*//*Label 16345*/ GIMT_Encode4(1113847), // Rule ID 62589 //
     /* 1113775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1113792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1113795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113814 */     // MIs[0] policy
     /* 1113814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1113827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113843 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113846 */     // GIR_Coverage, 62589,
     /* 1113846 */     GIR_EraseRootFromParent_Done,
     /* 1113847 */   // Label 16345: @1113847
     /* 1113847 */   GIM_Try, /*On fail goto*//*Label 16346*/ GIMT_Encode4(1113924), // Rule ID 62590 //
     /* 1113852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1113855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1113863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1113866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1113869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1113872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1113875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1113891 */     // MIs[0] policy
     /* 1113891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113901 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1113901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4),
     /* 1113904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113920 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1113923 */     // GIR_Coverage, 62590,
     /* 1113923 */     GIR_EraseRootFromParent_Done,
     /* 1113924 */   // Label 16346: @1113924
     /* 1113924 */   GIM_Try, /*On fail goto*//*Label 16347*/ GIMT_Encode4(1114001), // Rule ID 62593 //
     /* 1113929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1113932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1113937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1113940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1113943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1113946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1113949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1113952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1113968 */     // MIs[0] policy
     /* 1113968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1113971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1113978 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1113978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1113981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1113983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1113985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1113987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1113989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1113994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1113997 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1113999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114000 */     // GIR_Coverage, 62593,
     /* 1114000 */     GIR_EraseRootFromParent_Done,
     /* 1114001 */   // Label 16347: @1114001
     /* 1114001 */   GIM_Try, /*On fail goto*//*Label 16348*/ GIMT_Encode4(1114078), // Rule ID 62594 //
     /* 1114006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1114023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114045 */     // MIs[0] policy
     /* 1114045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114055 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8),
     /* 1114058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114074 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114077 */     // GIR_Coverage, 62594,
     /* 1114077 */     GIR_EraseRootFromParent_Done,
     /* 1114078 */   // Label 16348: @1114078
     /* 1114078 */   GIM_Try, /*On fail goto*//*Label 16349*/ GIMT_Encode4(1114155), // Rule ID 62597 //
     /* 1114083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114122 */     // MIs[0] policy
     /* 1114122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114132 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1114135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114151 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114154 */     // GIR_Coverage, 62597,
     /* 1114154 */     GIR_EraseRootFromParent_Done,
     /* 1114155 */   // Label 16349: @1114155
     /* 1114155 */   GIM_Try, /*On fail goto*//*Label 16350*/ GIMT_Encode4(1114232), // Rule ID 62598 //
     /* 1114160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114199 */     // MIs[0] policy
     /* 1114199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114209 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2),
     /* 1114212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114228 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114230 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114231 */     // GIR_Coverage, 62598,
     /* 1114231 */     GIR_EraseRootFromParent_Done,
     /* 1114232 */   // Label 16350: @1114232
     /* 1114232 */   GIM_Try, /*On fail goto*//*Label 16351*/ GIMT_Encode4(1114309), // Rule ID 62601 //
     /* 1114237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114276 */     // MIs[0] policy
     /* 1114276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1114289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114305 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114308 */     // GIR_Coverage, 62601,
     /* 1114308 */     GIR_EraseRootFromParent_Done,
     /* 1114309 */   // Label 16351: @1114309
     /* 1114309 */   GIM_Try, /*On fail goto*//*Label 16352*/ GIMT_Encode4(1114386), // Rule ID 62602 //
     /* 1114314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1114325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1114328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1114334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114353 */     // MIs[0] policy
     /* 1114353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114363 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11058:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1),
     /* 1114366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114382 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114385 */     // GIR_Coverage, 62602,
     /* 1114385 */     GIR_EraseRootFromParent_Done,
     /* 1114386 */   // Label 16352: @1114386
     /* 1114386 */   GIM_Try, /*On fail goto*//*Label 16353*/ GIMT_Encode4(1114463), // Rule ID 62605 //
     /* 1114391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114430 */     // MIs[0] policy
     /* 1114430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1114443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114459 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114462 */     // GIR_Coverage, 62605,
     /* 1114462 */     GIR_EraseRootFromParent_Done,
     /* 1114463 */   // Label 16353: @1114463
     /* 1114463 */   GIM_Try, /*On fail goto*//*Label 16354*/ GIMT_Encode4(1114540), // Rule ID 62606 //
     /* 1114468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1114479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1114482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1114488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1114507 */     // MIs[0] policy
     /* 1114507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11058:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2),
     /* 1114520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114539 */     // GIR_Coverage, 62606,
     /* 1114539 */     GIR_EraseRootFromParent_Done,
     /* 1114540 */   // Label 16354: @1114540
     /* 1114540 */   GIM_Try, /*On fail goto*//*Label 16355*/ GIMT_Encode4(1114617), // Rule ID 62609 //
     /* 1114545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114584 */     // MIs[0] policy
     /* 1114584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114594 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1114597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114616 */     // GIR_Coverage, 62609,
     /* 1114616 */     GIR_EraseRootFromParent_Done,
     /* 1114617 */   // Label 16355: @1114617
     /* 1114617 */   GIM_Try, /*On fail goto*//*Label 16356*/ GIMT_Encode4(1114694), // Rule ID 62610 //
     /* 1114622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1114633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1114636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1114642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1114661 */     // MIs[0] policy
     /* 1114661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114671 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11058:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4),
     /* 1114674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114690 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114693 */     // GIR_Coverage, 62610,
     /* 1114693 */     GIR_EraseRootFromParent_Done,
     /* 1114694 */   // Label 16356: @1114694
     /* 1114694 */   GIM_Try, /*On fail goto*//*Label 16357*/ GIMT_Encode4(1114771), // Rule ID 62613 //
     /* 1114699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1114716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114738 */     // MIs[0] policy
     /* 1114738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1114751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114767 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114770 */     // GIR_Coverage, 62613,
     /* 1114770 */     GIR_EraseRootFromParent_Done,
     /* 1114771 */   // Label 16357: @1114771
     /* 1114771 */   GIM_Try, /*On fail goto*//*Label 16358*/ GIMT_Encode4(1114848), // Rule ID 62614 //
     /* 1114776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa),
     /* 1114784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1114787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1114790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1114793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1114796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1114811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1114815 */     // MIs[0] policy
     /* 1114815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114825 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11058:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8),
     /* 1114828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114847 */     // GIR_Coverage, 62614,
     /* 1114847 */     GIR_EraseRootFromParent_Done,
     /* 1114848 */   // Label 16358: @1114848
     /* 1114848 */   GIM_Try, /*On fail goto*//*Label 16359*/ GIMT_Encode4(1114925), // Rule ID 62617 //
     /* 1114853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1114856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1114861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1114876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114892 */     // MIs[0] policy
     /* 1114892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114902 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1114902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1114905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114921 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1114923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1114924 */     // GIR_Coverage, 62617,
     /* 1114924 */     GIR_EraseRootFromParent_Done,
     /* 1114925 */   // Label 16359: @1114925
     /* 1114925 */   GIM_Try, /*On fail goto*//*Label 16360*/ GIMT_Encode4(1115002), // Rule ID 62618 //
     /* 1114930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1114933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1114938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1114941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1114944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1114947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1114950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1114953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1114969 */     // MIs[0] policy
     /* 1114969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1114972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1114979 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1114979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2),
     /* 1114982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1114984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1114986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1114988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1114990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1114995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1114998 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115001 */     // GIR_Coverage, 62618,
     /* 1115001 */     GIR_EraseRootFromParent_Done,
     /* 1115002 */   // Label 16360: @1115002
     /* 1115002 */   GIM_Try, /*On fail goto*//*Label 16361*/ GIMT_Encode4(1115079), // Rule ID 62621 //
     /* 1115007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115046 */     // MIs[0] policy
     /* 1115046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1115059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115075 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115078 */     // GIR_Coverage, 62621,
     /* 1115078 */     GIR_EraseRootFromParent_Done,
     /* 1115079 */   // Label 16361: @1115079
     /* 1115079 */   GIM_Try, /*On fail goto*//*Label 16362*/ GIMT_Encode4(1115156), // Rule ID 62622 //
     /* 1115084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1115101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115123 */     // MIs[0] policy
     /* 1115123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115133 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1),
     /* 1115136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115152 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115155 */     // GIR_Coverage, 62622,
     /* 1115155 */     GIR_EraseRootFromParent_Done,
     /* 1115156 */   // Label 16362: @1115156
     /* 1115156 */   GIM_Try, /*On fail goto*//*Label 16363*/ GIMT_Encode4(1115233), // Rule ID 62625 //
     /* 1115161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115200 */     // MIs[0] policy
     /* 1115200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1115213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115232 */     // GIR_Coverage, 62625,
     /* 1115232 */     GIR_EraseRootFromParent_Done,
     /* 1115233 */   // Label 16363: @1115233
     /* 1115233 */   GIM_Try, /*On fail goto*//*Label 16364*/ GIMT_Encode4(1115310), // Rule ID 62626 //
     /* 1115238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1115255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115277 */     // MIs[0] policy
     /* 1115277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115287 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2),
     /* 1115290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115306 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115309 */     // GIR_Coverage, 62626,
     /* 1115309 */     GIR_EraseRootFromParent_Done,
     /* 1115310 */   // Label 16364: @1115310
     /* 1115310 */   GIM_Try, /*On fail goto*//*Label 16365*/ GIMT_Encode4(1115387), // Rule ID 62629 //
     /* 1115315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115354 */     // MIs[0] policy
     /* 1115354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1115367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115383 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115386 */     // GIR_Coverage, 62629,
     /* 1115386 */     GIR_EraseRootFromParent_Done,
     /* 1115387 */   // Label 16365: @1115387
     /* 1115387 */   GIM_Try, /*On fail goto*//*Label 16366*/ GIMT_Encode4(1115464), // Rule ID 62630 //
     /* 1115392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1115403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1115406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1115409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1115412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1115431 */     // MIs[0] policy
     /* 1115431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4),
     /* 1115444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115460 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115463 */     // GIR_Coverage, 62630,
     /* 1115463 */     GIR_EraseRootFromParent_Done,
     /* 1115464 */   // Label 16366: @1115464
     /* 1115464 */   GIM_Try, /*On fail goto*//*Label 16367*/ GIMT_Encode4(1115541), // Rule ID 62633 //
     /* 1115469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1115486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115508 */     // MIs[0] policy
     /* 1115508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1115521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115537 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115540 */     // GIR_Coverage, 62633,
     /* 1115540 */     GIR_EraseRootFromParent_Done,
     /* 1115541 */   // Label 16367: @1115541
     /* 1115541 */   GIM_Try, /*On fail goto*//*Label 16368*/ GIMT_Encode4(1115618), // Rule ID 62634 //
     /* 1115546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1115557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1115560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1115563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1115566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1115585 */     // MIs[0] policy
     /* 1115585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115595 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8),
     /* 1115598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115614 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115617 */     // GIR_Coverage, 62634,
     /* 1115617 */     GIR_EraseRootFromParent_Done,
     /* 1115618 */   // Label 16368: @1115618
     /* 1115618 */   GIM_Try, /*On fail goto*//*Label 16369*/ GIMT_Encode4(1115695), // Rule ID 62637 //
     /* 1115623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115662 */     // MIs[0] policy
     /* 1115662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1115675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115691 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115694 */     // GIR_Coverage, 62637,
     /* 1115694 */     GIR_EraseRootFromParent_Done,
     /* 1115695 */   // Label 16369: @1115695
     /* 1115695 */   GIM_Try, /*On fail goto*//*Label 16370*/ GIMT_Encode4(1115772), // Rule ID 62638 //
     /* 1115700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1115711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1115714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1115720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115739 */     // MIs[0] policy
     /* 1115739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2),
     /* 1115752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115754 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115768 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115770 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115771 */     // GIR_Coverage, 62638,
     /* 1115771 */     GIR_EraseRootFromParent_Done,
     /* 1115772 */   // Label 16370: @1115772
     /* 1115772 */   GIM_Try, /*On fail goto*//*Label 16371*/ GIMT_Encode4(1115849), // Rule ID 62641 //
     /* 1115777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115816 */     // MIs[0] policy
     /* 1115816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1115829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115845 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115848 */     // GIR_Coverage, 62641,
     /* 1115848 */     GIR_EraseRootFromParent_Done,
     /* 1115849 */   // Label 16371: @1115849
     /* 1115849 */   GIM_Try, /*On fail goto*//*Label 16372*/ GIMT_Encode4(1115926), // Rule ID 62642 //
     /* 1115854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1115857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1115865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1115868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1115871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1115874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1115877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1115893 */     // MIs[0] policy
     /* 1115893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115903 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11062:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1115903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1),
     /* 1115906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115922 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1115924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1115925 */     // GIR_Coverage, 62642,
     /* 1115925 */     GIR_EraseRootFromParent_Done,
     /* 1115926 */   // Label 16372: @1115926
     /* 1115926 */   GIM_Try, /*On fail goto*//*Label 16373*/ GIMT_Encode4(1116003), // Rule ID 62645 //
     /* 1115931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1115934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1115939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1115942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1115945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1115948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1115951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1115954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1115966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1115970 */     // MIs[0] policy
     /* 1115970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1115973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1115980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1115980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1115983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1115985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1115987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1115989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1115991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1115996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1115999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116002 */     // GIR_Coverage, 62645,
     /* 1116002 */     GIR_EraseRootFromParent_Done,
     /* 1116003 */   // Label 16373: @1116003
     /* 1116003 */   GIM_Try, /*On fail goto*//*Label 16374*/ GIMT_Encode4(1116080), // Rule ID 62646 //
     /* 1116008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116047 */     // MIs[0] policy
     /* 1116047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11062:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2),
     /* 1116060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116078 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116079 */     // GIR_Coverage, 62646,
     /* 1116079 */     GIR_EraseRootFromParent_Done,
     /* 1116080 */   // Label 16374: @1116080
     /* 1116080 */   GIM_Try, /*On fail goto*//*Label 16375*/ GIMT_Encode4(1116157), // Rule ID 62649 //
     /* 1116085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116124 */     // MIs[0] policy
     /* 1116124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116134 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1116137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116156 */     // GIR_Coverage, 62649,
     /* 1116156 */     GIR_EraseRootFromParent_Done,
     /* 1116157 */   // Label 16375: @1116157
     /* 1116157 */   GIM_Try, /*On fail goto*//*Label 16376*/ GIMT_Encode4(1116234), // Rule ID 62650 //
     /* 1116162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116201 */     // MIs[0] policy
     /* 1116201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116211 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11062:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4),
     /* 1116214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116233 */     // GIR_Coverage, 62650,
     /* 1116233 */     GIR_EraseRootFromParent_Done,
     /* 1116234 */   // Label 16376: @1116234
     /* 1116234 */   GIM_Try, /*On fail goto*//*Label 16377*/ GIMT_Encode4(1116311), // Rule ID 62653 //
     /* 1116239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1116256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116278 */     // MIs[0] policy
     /* 1116278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116288 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1116291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116307 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116310 */     // GIR_Coverage, 62653,
     /* 1116310 */     GIR_EraseRootFromParent_Done,
     /* 1116311 */   // Label 16377: @1116311
     /* 1116311 */   GIM_Try, /*On fail goto*//*Label 16378*/ GIMT_Encode4(1116388), // Rule ID 62654 //
     /* 1116316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau),
     /* 1116324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1116327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1116330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1116333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1116336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1116351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1116355 */     // MIs[0] policy
     /* 1116355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116365 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11062:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8),
     /* 1116368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116384 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116387 */     // GIR_Coverage, 62654,
     /* 1116387 */     GIR_EraseRootFromParent_Done,
     /* 1116388 */   // Label 16378: @1116388
     /* 1116388 */   GIM_Try, /*On fail goto*//*Label 16379*/ GIMT_Encode4(1116465), // Rule ID 62657 //
     /* 1116393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1116410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116432 */     // MIs[0] policy
     /* 1116432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116442 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1116445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116461 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116464 */     // GIR_Coverage, 62657,
     /* 1116464 */     GIR_EraseRootFromParent_Done,
     /* 1116465 */   // Label 16379: @1116465
     /* 1116465 */   GIM_Try, /*On fail goto*//*Label 16380*/ GIMT_Encode4(1116542), // Rule ID 62658 //
     /* 1116470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1116481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1116484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1116487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1116490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116509 */     // MIs[0] policy
     /* 1116509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116519 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2),
     /* 1116522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116538 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116541 */     // GIR_Coverage, 62658,
     /* 1116541 */     GIR_EraseRootFromParent_Done,
     /* 1116542 */   // Label 16380: @1116542
     /* 1116542 */   GIM_Try, /*On fail goto*//*Label 16381*/ GIMT_Encode4(1116619), // Rule ID 62661 //
     /* 1116547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1116564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116586 */     // MIs[0] policy
     /* 1116586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1116599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116615 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116618 */     // GIR_Coverage, 62661,
     /* 1116618 */     GIR_EraseRootFromParent_Done,
     /* 1116619 */   // Label 16381: @1116619
     /* 1116619 */   GIM_Try, /*On fail goto*//*Label 16382*/ GIMT_Encode4(1116696), // Rule ID 62662 //
     /* 1116624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1116635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1116638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1116641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1116644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1116663 */     // MIs[0] policy
     /* 1116663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116673 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1),
     /* 1116676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116694 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116695 */     // GIR_Coverage, 62662,
     /* 1116695 */     GIR_EraseRootFromParent_Done,
     /* 1116696 */   // Label 16382: @1116696
     /* 1116696 */   GIM_Try, /*On fail goto*//*Label 16383*/ GIMT_Encode4(1116773), // Rule ID 62665 //
     /* 1116701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116740 */     // MIs[0] policy
     /* 1116740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1116753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116769 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116772 */     // GIR_Coverage, 62665,
     /* 1116772 */     GIR_EraseRootFromParent_Done,
     /* 1116773 */   // Label 16383: @1116773
     /* 1116773 */   GIM_Try, /*On fail goto*//*Label 16384*/ GIMT_Encode4(1116850), // Rule ID 62666 //
     /* 1116778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1116789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1116792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1116795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1116798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1116817 */     // MIs[0] policy
     /* 1116817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2),
     /* 1116830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116846 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116849 */     // GIR_Coverage, 62666,
     /* 1116849 */     GIR_EraseRootFromParent_Done,
     /* 1116850 */   // Label 16384: @1116850
     /* 1116850 */   GIM_Try, /*On fail goto*//*Label 16385*/ GIMT_Encode4(1116927), // Rule ID 62669 //
     /* 1116855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1116858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1116878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116894 */     // MIs[0] policy
     /* 1116894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116904 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1116904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1116907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1116923 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1116925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1116926 */     // GIR_Coverage, 62669,
     /* 1116926 */     GIR_EraseRootFromParent_Done,
     /* 1116927 */   // Label 16385: @1116927
     /* 1116927 */   GIM_Try, /*On fail goto*//*Label 16386*/ GIMT_Encode4(1117004), // Rule ID 62670 //
     /* 1116932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1116935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1116940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1116943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1116946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1116949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1116952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1116955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1116971 */     // MIs[0] policy
     /* 1116971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1116974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1116981 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1116981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4),
     /* 1116984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1116986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1116988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1116990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1116992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1116997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117000 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117003 */     // GIR_Coverage, 62670,
     /* 1117003 */     GIR_EraseRootFromParent_Done,
     /* 1117004 */   // Label 16386: @1117004
     /* 1117004 */   GIM_Try, /*On fail goto*//*Label 16387*/ GIMT_Encode4(1117081), // Rule ID 62673 //
     /* 1117009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117048 */     // MIs[0] policy
     /* 1117048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117058 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1117061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117080 */     // GIR_Coverage, 62673,
     /* 1117080 */     GIR_EraseRootFromParent_Done,
     /* 1117081 */   // Label 16387: @1117081
     /* 1117081 */   GIM_Try, /*On fail goto*//*Label 16388*/ GIMT_Encode4(1117158), // Rule ID 62674 //
     /* 1117086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1117103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117125 */     // MIs[0] policy
     /* 1117125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117135 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8),
     /* 1117138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117157 */     // GIR_Coverage, 62674,
     /* 1117157 */     GIR_EraseRootFromParent_Done,
     /* 1117158 */   // Label 16388: @1117158
     /* 1117158 */   GIM_Try, /*On fail goto*//*Label 16389*/ GIMT_Encode4(1117235), // Rule ID 62677 //
     /* 1117163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117202 */     // MIs[0] policy
     /* 1117202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1117215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117231 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117234 */     // GIR_Coverage, 62677,
     /* 1117234 */     GIR_EraseRootFromParent_Done,
     /* 1117235 */   // Label 16389: @1117235
     /* 1117235 */   GIM_Try, /*On fail goto*//*Label 16390*/ GIMT_Encode4(1117312), // Rule ID 62678 //
     /* 1117240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117279 */     // MIs[0] policy
     /* 1117279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117289 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2),
     /* 1117292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117308 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117311 */     // GIR_Coverage, 62678,
     /* 1117311 */     GIR_EraseRootFromParent_Done,
     /* 1117312 */   // Label 16390: @1117312
     /* 1117312 */   GIM_Try, /*On fail goto*//*Label 16391*/ GIMT_Encode4(1117389), // Rule ID 62681 //
     /* 1117317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117356 */     // MIs[0] policy
     /* 1117356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1117369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117388 */     // GIR_Coverage, 62681,
     /* 1117388 */     GIR_EraseRootFromParent_Done,
     /* 1117389 */   // Label 16391: @1117389
     /* 1117389 */   GIM_Try, /*On fail goto*//*Label 16392*/ GIMT_Encode4(1117466), // Rule ID 62682 //
     /* 1117394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1117405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1117408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1117414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117433 */     // MIs[0] policy
     /* 1117433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117443 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11060:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1),
     /* 1117446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117465 */     // GIR_Coverage, 62682,
     /* 1117465 */     GIR_EraseRootFromParent_Done,
     /* 1117466 */   // Label 16392: @1117466
     /* 1117466 */   GIM_Try, /*On fail goto*//*Label 16393*/ GIMT_Encode4(1117543), // Rule ID 62685 //
     /* 1117471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117510 */     // MIs[0] policy
     /* 1117510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117520 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1117523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117542 */     // GIR_Coverage, 62685,
     /* 1117542 */     GIR_EraseRootFromParent_Done,
     /* 1117543 */   // Label 16393: @1117543
     /* 1117543 */   GIM_Try, /*On fail goto*//*Label 16394*/ GIMT_Encode4(1117620), // Rule ID 62686 //
     /* 1117548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1117559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1117562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1117568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1117587 */     // MIs[0] policy
     /* 1117587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117597 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11060:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2),
     /* 1117600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117619 */     // GIR_Coverage, 62686,
     /* 1117619 */     GIR_EraseRootFromParent_Done,
     /* 1117620 */   // Label 16394: @1117620
     /* 1117620 */   GIM_Try, /*On fail goto*//*Label 16395*/ GIMT_Encode4(1117697), // Rule ID 62689 //
     /* 1117625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117664 */     // MIs[0] policy
     /* 1117664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1117677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117693 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117696 */     // GIR_Coverage, 62689,
     /* 1117696 */     GIR_EraseRootFromParent_Done,
     /* 1117697 */   // Label 16395: @1117697
     /* 1117697 */   GIM_Try, /*On fail goto*//*Label 16396*/ GIMT_Encode4(1117774), // Rule ID 62690 //
     /* 1117702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1117713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1117716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1117722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1117741 */     // MIs[0] policy
     /* 1117741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117751 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11060:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4),
     /* 1117754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117770 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117773 */     // GIR_Coverage, 62690,
     /* 1117773 */     GIR_EraseRootFromParent_Done,
     /* 1117774 */   // Label 16396: @1117774
     /* 1117774 */   GIM_Try, /*On fail goto*//*Label 16397*/ GIMT_Encode4(1117851), // Rule ID 62693 //
     /* 1117779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117818 */     // MIs[0] policy
     /* 1117818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1117831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117847 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117850 */     // GIR_Coverage, 62693,
     /* 1117850 */     GIR_EraseRootFromParent_Done,
     /* 1117851 */   // Label 16397: @1117851
     /* 1117851 */   GIM_Try, /*On fail goto*//*Label 16398*/ GIMT_Encode4(1117928), // Rule ID 62694 //
     /* 1117856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1117859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu),
     /* 1117864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1117867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1117870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1117873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1117876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1117879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1117895 */     // MIs[0] policy
     /* 1117895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117905 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11060:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1117905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8),
     /* 1117908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1117924 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1117926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1117927 */     // GIR_Coverage, 62694,
     /* 1117927 */     GIR_EraseRootFromParent_Done,
     /* 1117928 */   // Label 16398: @1117928
     /* 1117928 */   GIM_Try, /*On fail goto*//*Label 16399*/ GIMT_Encode4(1118005), // Rule ID 62697 //
     /* 1117933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1117936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1117941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1117944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1117947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1117950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1117953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1117956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1117968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1117972 */     // MIs[0] policy
     /* 1117972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1117975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1117982 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1117982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1117985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1117987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1117989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1117991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1117993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1117998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118001 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118004 */     // GIR_Coverage, 62697,
     /* 1118004 */     GIR_EraseRootFromParent_Done,
     /* 1118005 */   // Label 16399: @1118005
     /* 1118005 */   GIM_Try, /*On fail goto*//*Label 16400*/ GIMT_Encode4(1118082), // Rule ID 62698 //
     /* 1118010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1118021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1118024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1118030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118049 */     // MIs[0] policy
     /* 1118049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118059 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11064:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2),
     /* 1118062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118078 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118081 */     // GIR_Coverage, 62698,
     /* 1118081 */     GIR_EraseRootFromParent_Done,
     /* 1118082 */   // Label 16400: @1118082
     /* 1118082 */   GIM_Try, /*On fail goto*//*Label 16401*/ GIMT_Encode4(1118159), // Rule ID 62701 //
     /* 1118087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118126 */     // MIs[0] policy
     /* 1118126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118136 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1118139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118155 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118158 */     // GIR_Coverage, 62701,
     /* 1118158 */     GIR_EraseRootFromParent_Done,
     /* 1118159 */   // Label 16401: @1118159
     /* 1118159 */   GIM_Try, /*On fail goto*//*Label 16402*/ GIMT_Encode4(1118236), // Rule ID 62702 //
     /* 1118164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118203 */     // MIs[0] policy
     /* 1118203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118213 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11064:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1),
     /* 1118216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118235 */     // GIR_Coverage, 62702,
     /* 1118235 */     GIR_EraseRootFromParent_Done,
     /* 1118236 */   // Label 16402: @1118236
     /* 1118236 */   GIM_Try, /*On fail goto*//*Label 16403*/ GIMT_Encode4(1118313), // Rule ID 62705 //
     /* 1118241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118280 */     // MIs[0] policy
     /* 1118280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1118293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118309 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118312 */     // GIR_Coverage, 62705,
     /* 1118312 */     GIR_EraseRootFromParent_Done,
     /* 1118313 */   // Label 16403: @1118313
     /* 1118313 */   GIM_Try, /*On fail goto*//*Label 16404*/ GIMT_Encode4(1118390), // Rule ID 62706 //
     /* 1118318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118357 */     // MIs[0] policy
     /* 1118357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118367 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11064:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2),
     /* 1118370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118386 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118389 */     // GIR_Coverage, 62706,
     /* 1118389 */     GIR_EraseRootFromParent_Done,
     /* 1118390 */   // Label 16404: @1118390
     /* 1118390 */   GIM_Try, /*On fail goto*//*Label 16405*/ GIMT_Encode4(1118467), // Rule ID 62709 //
     /* 1118395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118434 */     // MIs[0] policy
     /* 1118434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118444 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1118447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118466 */     // GIR_Coverage, 62709,
     /* 1118466 */     GIR_EraseRootFromParent_Done,
     /* 1118467 */   // Label 16405: @1118467
     /* 1118467 */   GIM_Try, /*On fail goto*//*Label 16406*/ GIMT_Encode4(1118544), // Rule ID 62710 //
     /* 1118472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1118483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1118486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1118492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1118511 */     // MIs[0] policy
     /* 1118511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118521 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11064:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4),
     /* 1118524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118542 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118543 */     // GIR_Coverage, 62710,
     /* 1118543 */     GIR_EraseRootFromParent_Done,
     /* 1118544 */   // Label 16406: @1118544
     /* 1118544 */   GIM_Try, /*On fail goto*//*Label 16407*/ GIMT_Encode4(1118621), // Rule ID 62713 //
     /* 1118549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1118552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1118566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118588 */     // MIs[0] policy
     /* 1118588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118598 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1118601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118617 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118620 */     // GIR_Coverage, 62713,
     /* 1118620 */     GIR_EraseRootFromParent_Done,
     /* 1118621 */   // Label 16407: @1118621
     /* 1118621 */   GIM_Try, /*On fail goto*//*Label 16408*/ GIMT_Encode4(1118698), // Rule ID 62714 //
     /* 1118626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1118629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus),
     /* 1118634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1118637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1118640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1118643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1118646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1118661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1118665 */     // MIs[0] policy
     /* 1118665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118675 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11064:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8),
     /* 1118678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1118694 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118697 */     // GIR_Coverage, 62714,
     /* 1118697 */     GIR_EraseRootFromParent_Done,
     /* 1118698 */   // Label 16408: @1118698
     /* 1118698 */   GIM_Try, /*On fail goto*//*Label 16409*/ GIMT_Encode4(1118775), // Rule ID 62808 //
     /* 1118703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1118706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1118711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1118720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118742 */     // MIs[0] policy
     /* 1118742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1118755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1118771 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118774 */     // GIR_Coverage, 62808,
     /* 1118774 */     GIR_EraseRootFromParent_Done,
     /* 1118775 */   // Label 16409: @1118775
     /* 1118775 */   GIM_Try, /*On fail goto*//*Label 16410*/ GIMT_Encode4(1118852), // Rule ID 62809 //
     /* 1118780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1118783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1118788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1118791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1118794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1118797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1118800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118819 */     // MIs[0] policy
     /* 1118819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118829 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11036:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M1),
     /* 1118832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1118848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118851 */     // GIR_Coverage, 62809,
     /* 1118851 */     GIR_EraseRootFromParent_Done,
     /* 1118852 */   // Label 16410: @1118852
     /* 1118852 */   GIM_Try, /*On fail goto*//*Label 16411*/ GIMT_Encode4(1118929), // Rule ID 64266 //
     /* 1118857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1118860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1118865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1118874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1118880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118896 */     // MIs[0] policy
     /* 1118896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1118906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1118909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1118925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1118927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1118928 */     // GIR_Coverage, 64266,
     /* 1118928 */     GIR_EraseRootFromParent_Done,
     /* 1118929 */   // Label 16411: @1118929
     /* 1118929 */   GIM_Try, /*On fail goto*//*Label 16412*/ GIMT_Encode4(1119006), // Rule ID 64267 //
     /* 1118934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1118937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1118942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1118945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1118948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1118951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1118954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1118957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1118969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1118973 */     // MIs[0] policy
     /* 1118973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1118976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1118983 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11036:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1118983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M2),
     /* 1118986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1118988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1118990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1118992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1118994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1118999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119002 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119005 */     // GIR_Coverage, 64267,
     /* 1119005 */     GIR_EraseRootFromParent_Done,
     /* 1119006 */   // Label 16412: @1119006
     /* 1119006 */   GIM_Try, /*On fail goto*//*Label 16413*/ GIMT_Encode4(1119083), // Rule ID 64268 //
     /* 1119011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119050 */     // MIs[0] policy
     /* 1119050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119060 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1119063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119079 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119082 */     // GIR_Coverage, 64268,
     /* 1119082 */     GIR_EraseRootFromParent_Done,
     /* 1119083 */   // Label 16413: @1119083
     /* 1119083 */   GIM_Try, /*On fail goto*//*Label 16414*/ GIMT_Encode4(1119160), // Rule ID 64269 //
     /* 1119088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119127 */     // MIs[0] policy
     /* 1119127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119137 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11036:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M4),
     /* 1119140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119156 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119159 */     // GIR_Coverage, 64269,
     /* 1119159 */     GIR_EraseRootFromParent_Done,
     /* 1119160 */   // Label 16414: @1119160
     /* 1119160 */   GIM_Try, /*On fail goto*//*Label 16415*/ GIMT_Encode4(1119237), // Rule ID 64270 //
     /* 1119165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119204 */     // MIs[0] policy
     /* 1119204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119214 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1119217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119233 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119236 */     // GIR_Coverage, 64270,
     /* 1119236 */     GIR_EraseRootFromParent_Done,
     /* 1119237 */   // Label 16415: @1119237
     /* 1119237 */   GIM_Try, /*On fail goto*//*Label 16416*/ GIMT_Encode4(1119314), // Rule ID 64271 //
     /* 1119242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_2x8x2),
     /* 1119250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119281 */     // MIs[0] policy
     /* 1119281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119291 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11036:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_2x8x2_M8),
     /* 1119294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119310 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119313 */     // GIR_Coverage, 64271,
     /* 1119313 */     GIR_EraseRootFromParent_Done,
     /* 1119314 */   // Label 16416: @1119314
     /* 1119314 */   GIM_Try, /*On fail goto*//*Label 16417*/ GIMT_Encode4(1119391), // Rule ID 64272 //
     /* 1119319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119358 */     // MIs[0] policy
     /* 1119358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1119371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119387 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119390 */     // GIR_Coverage, 64272,
     /* 1119390 */     GIR_EraseRootFromParent_Done,
     /* 1119391 */   // Label 16417: @1119391
     /* 1119391 */   GIM_Try, /*On fail goto*//*Label 16418*/ GIMT_Encode4(1119468), // Rule ID 64273 //
     /* 1119396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119435 */     // MIs[0] policy
     /* 1119435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119445 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11032:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M1),
     /* 1119448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119467 */     // GIR_Coverage, 64273,
     /* 1119467 */     GIR_EraseRootFromParent_Done,
     /* 1119468 */   // Label 16418: @1119468
     /* 1119468 */   GIM_Try, /*On fail goto*//*Label 16419*/ GIMT_Encode4(1119545), // Rule ID 64274 //
     /* 1119473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119512 */     // MIs[0] policy
     /* 1119512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11032:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1119525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119544 */     // GIR_Coverage, 64274,
     /* 1119544 */     GIR_EraseRootFromParent_Done,
     /* 1119545 */   // Label 16419: @1119545
     /* 1119545 */   GIM_Try, /*On fail goto*//*Label 16420*/ GIMT_Encode4(1119622), // Rule ID 64275 //
     /* 1119550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1119561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1119564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1119570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1119589 */     // MIs[0] policy
     /* 1119589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11032:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M2),
     /* 1119602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119618 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119621 */     // GIR_Coverage, 64275,
     /* 1119621 */     GIR_EraseRootFromParent_Done,
     /* 1119622 */   // Label 16420: @1119622
     /* 1119622 */   GIM_Try, /*On fail goto*//*Label 16421*/ GIMT_Encode4(1119699), // Rule ID 64276 //
     /* 1119627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119666 */     // MIs[0] policy
     /* 1119666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11032:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1119679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119695 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119698 */     // GIR_Coverage, 64276,
     /* 1119698 */     GIR_EraseRootFromParent_Done,
     /* 1119699 */   // Label 16421: @1119699
     /* 1119699 */   GIM_Try, /*On fail goto*//*Label 16422*/ GIMT_Encode4(1119776), // Rule ID 64277 //
     /* 1119704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1119715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1119718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1119724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1119743 */     // MIs[0] policy
     /* 1119743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119753 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11032:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M4),
     /* 1119756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119775 */     // GIR_Coverage, 64277,
     /* 1119775 */     GIR_EraseRootFromParent_Done,
     /* 1119776 */   // Label 16422: @1119776
     /* 1119776 */   GIM_Try, /*On fail goto*//*Label 16423*/ GIMT_Encode4(1119853), // Rule ID 64278 //
     /* 1119781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119820 */     // MIs[0] policy
     /* 1119820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11032:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1119833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119849 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119852 */     // GIR_Coverage, 64278,
     /* 1119852 */     GIR_EraseRootFromParent_Done,
     /* 1119853 */   // Label 16423: @1119853
     /* 1119853 */   GIM_Try, /*On fail goto*//*Label 16424*/ GIMT_Encode4(1119930), // Rule ID 64279 //
     /* 1119858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1119861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_2x8x2),
     /* 1119866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1119869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1119872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1119878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1119881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1119897 */     // MIs[0] policy
     /* 1119897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119907 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11032:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1119907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_2x8x2_M8),
     /* 1119910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1119923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1119926 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1119928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1119929 */     // GIR_Coverage, 64279,
     /* 1119929 */     GIR_EraseRootFromParent_Done,
     /* 1119930 */   // Label 16424: @1119930
     /* 1119930 */   GIM_Try, /*On fail goto*//*Label 16425*/ GIMT_Encode4(1120007), // Rule ID 64280 //
     /* 1119935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1119938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1119943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1119946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1119949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1119952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1119955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1119958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1119974 */     // MIs[0] policy
     /* 1119974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1119977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1119984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1119984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1119987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1119989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1119991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1119993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1119995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120003 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120006 */     // GIR_Coverage, 64280,
     /* 1120006 */     GIR_EraseRootFromParent_Done,
     /* 1120007 */   // Label 16425: @1120007
     /* 1120007 */   GIM_Try, /*On fail goto*//*Label 16426*/ GIMT_Encode4(1120084), // Rule ID 64281 //
     /* 1120012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120051 */     // MIs[0] policy
     /* 1120051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120061 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11038:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M1),
     /* 1120064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120080 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120082 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120083 */     // GIR_Coverage, 64281,
     /* 1120083 */     GIR_EraseRootFromParent_Done,
     /* 1120084 */   // Label 16426: @1120084
     /* 1120084 */   GIM_Try, /*On fail goto*//*Label 16427*/ GIMT_Encode4(1120161), // Rule ID 64282 //
     /* 1120089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120128 */     // MIs[0] policy
     /* 1120128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1120141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120160 */     // GIR_Coverage, 64282,
     /* 1120160 */     GIR_EraseRootFromParent_Done,
     /* 1120161 */   // Label 16427: @1120161
     /* 1120161 */   GIM_Try, /*On fail goto*//*Label 16428*/ GIMT_Encode4(1120238), // Rule ID 64283 //
     /* 1120166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120205 */     // MIs[0] policy
     /* 1120205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120215 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11038:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M2),
     /* 1120218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120234 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120237 */     // GIR_Coverage, 64283,
     /* 1120237 */     GIR_EraseRootFromParent_Done,
     /* 1120238 */   // Label 16428: @1120238
     /* 1120238 */   GIM_Try, /*On fail goto*//*Label 16429*/ GIMT_Encode4(1120315), // Rule ID 64284 //
     /* 1120243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120282 */     // MIs[0] policy
     /* 1120282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120292 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1120295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120311 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120314 */     // GIR_Coverage, 64284,
     /* 1120314 */     GIR_EraseRootFromParent_Done,
     /* 1120315 */   // Label 16429: @1120315
     /* 1120315 */   GIM_Try, /*On fail goto*//*Label 16430*/ GIMT_Encode4(1120392), // Rule ID 64285 //
     /* 1120320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120359 */     // MIs[0] policy
     /* 1120359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120369 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11038:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M4),
     /* 1120372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120388 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120391 */     // GIR_Coverage, 64285,
     /* 1120391 */     GIR_EraseRootFromParent_Done,
     /* 1120392 */   // Label 16430: @1120392
     /* 1120392 */   GIM_Try, /*On fail goto*//*Label 16431*/ GIMT_Encode4(1120469), // Rule ID 64286 //
     /* 1120397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120436 */     // MIs[0] policy
     /* 1120436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120446 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1120449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120465 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120468 */     // GIR_Coverage, 64286,
     /* 1120468 */     GIR_EraseRootFromParent_Done,
     /* 1120469 */   // Label 16431: @1120469
     /* 1120469 */   GIM_Try, /*On fail goto*//*Label 16432*/ GIMT_Encode4(1120546), // Rule ID 64287 //
     /* 1120474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_2x8x2),
     /* 1120482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1120485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1120488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1120494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1120513 */     // MIs[0] policy
     /* 1120513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120523 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11038:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_2x8x2_M8),
     /* 1120526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120542 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120545 */     // GIR_Coverage, 64287,
     /* 1120545 */     GIR_EraseRootFromParent_Done,
     /* 1120546 */   // Label 16432: @1120546
     /* 1120546 */   GIM_Try, /*On fail goto*//*Label 16433*/ GIMT_Encode4(1120623), // Rule ID 64288 //
     /* 1120551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120590 */     // MIs[0] policy
     /* 1120590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1120603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120619 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120622 */     // GIR_Coverage, 64288,
     /* 1120622 */     GIR_EraseRootFromParent_Done,
     /* 1120623 */   // Label 16433: @1120623
     /* 1120623 */   GIM_Try, /*On fail goto*//*Label 16434*/ GIMT_Encode4(1120700), // Rule ID 64289 //
     /* 1120628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1120639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1120642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1120648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120667 */     // MIs[0] policy
     /* 1120667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120677 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11034:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M1),
     /* 1120680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120696 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120699 */     // GIR_Coverage, 64289,
     /* 1120699 */     GIR_EraseRootFromParent_Done,
     /* 1120700 */   // Label 16434: @1120700
     /* 1120700 */   GIM_Try, /*On fail goto*//*Label 16435*/ GIMT_Encode4(1120777), // Rule ID 64290 //
     /* 1120705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120744 */     // MIs[0] policy
     /* 1120744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120754 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11034:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1120757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120773 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120776 */     // GIR_Coverage, 64290,
     /* 1120776 */     GIR_EraseRootFromParent_Done,
     /* 1120777 */   // Label 16435: @1120777
     /* 1120777 */   GIM_Try, /*On fail goto*//*Label 16436*/ GIMT_Encode4(1120854), // Rule ID 64291 //
     /* 1120782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1120793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1120796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1120802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1120821 */     // MIs[0] policy
     /* 1120821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11034:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M2),
     /* 1120834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120850 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120853 */     // GIR_Coverage, 64291,
     /* 1120853 */     GIR_EraseRootFromParent_Done,
     /* 1120854 */   // Label 16436: @1120854
     /* 1120854 */   GIM_Try, /*On fail goto*//*Label 16437*/ GIMT_Encode4(1120931), // Rule ID 64292 //
     /* 1120859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1120862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1120882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120898 */     // MIs[0] policy
     /* 1120898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11034:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1120908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1120911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1120924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1120927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1120929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1120930 */     // GIR_Coverage, 64292,
     /* 1120930 */     GIR_EraseRootFromParent_Done,
     /* 1120931 */   // Label 16437: @1120931
     /* 1120931 */   GIM_Try, /*On fail goto*//*Label 16438*/ GIMT_Encode4(1121008), // Rule ID 64293 //
     /* 1120936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1120939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1120944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1120947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1120950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1120953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1120956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1120959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1120971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1120975 */     // MIs[0] policy
     /* 1120975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1120978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1120985 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11034:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1120985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M4),
     /* 1120988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1120990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1120992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1120994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1120996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121006 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121007 */     // GIR_Coverage, 64293,
     /* 1121007 */     GIR_EraseRootFromParent_Done,
     /* 1121008 */   // Label 16438: @1121008
     /* 1121008 */   GIM_Try, /*On fail goto*//*Label 16439*/ GIMT_Encode4(1121085), // Rule ID 64294 //
     /* 1121013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode0),
     /* 1121016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121052 */     // MIs[0] policy
     /* 1121052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121062 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11034:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1121065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121084 */     // GIR_Coverage, 64294,
     /* 1121084 */     GIR_EraseRootFromParent_Done,
     /* 1121085 */   // Label 16439: @1121085
     /* 1121085 */   GIM_Try, /*On fail goto*//*Label 16440*/ GIMT_Encode4(1121162), // Rule ID 64295 //
     /* 1121090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccdod_HwMode1),
     /* 1121093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_2x8x2),
     /* 1121098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1121110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121129 */     // MIs[0] policy
     /* 1121129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121139 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11034:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_2x8x2_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_2x8x2_M8),
     /* 1121142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121158 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121161 */     // GIR_Coverage, 64295,
     /* 1121161 */     GIR_EraseRootFromParent_Done,
     /* 1121162 */   // Label 16440: @1121162
     /* 1121162 */   GIM_Try, /*On fail goto*//*Label 16441*/ GIMT_Encode4(1121239), // Rule ID 64296 //
     /* 1121167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121206 */     // MIs[0] policy
     /* 1121206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121216 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1121219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121235 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121238 */     // GIR_Coverage, 64296,
     /* 1121238 */     GIR_EraseRootFromParent_Done,
     /* 1121239 */   // Label 16441: @1121239
     /* 1121239 */   GIM_Try, /*On fail goto*//*Label 16442*/ GIMT_Encode4(1121316), // Rule ID 64297 //
     /* 1121244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121283 */     // MIs[0] policy
     /* 1121283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121293 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11037:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_MF2),
     /* 1121296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121312 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121315 */     // GIR_Coverage, 64297,
     /* 1121315 */     GIR_EraseRootFromParent_Done,
     /* 1121316 */   // Label 16442: @1121316
     /* 1121316 */   GIM_Try, /*On fail goto*//*Label 16443*/ GIMT_Encode4(1121393), // Rule ID 64298 //
     /* 1121321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121360 */     // MIs[0] policy
     /* 1121360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121370 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1121373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121389 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121392 */     // GIR_Coverage, 64298,
     /* 1121392 */     GIR_EraseRootFromParent_Done,
     /* 1121393 */   // Label 16443: @1121393
     /* 1121393 */   GIM_Try, /*On fail goto*//*Label 16444*/ GIMT_Encode4(1121470), // Rule ID 64299 //
     /* 1121398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121437 */     // MIs[0] policy
     /* 1121437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121447 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11037:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M1),
     /* 1121450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121466 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121469 */     // GIR_Coverage, 64299,
     /* 1121469 */     GIR_EraseRootFromParent_Done,
     /* 1121470 */   // Label 16444: @1121470
     /* 1121470 */   GIM_Try, /*On fail goto*//*Label 16445*/ GIMT_Encode4(1121547), // Rule ID 64300 //
     /* 1121475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121514 */     // MIs[0] policy
     /* 1121514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121524 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1121527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121543 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121546 */     // GIR_Coverage, 64300,
     /* 1121546 */     GIR_EraseRootFromParent_Done,
     /* 1121547 */   // Label 16445: @1121547
     /* 1121547 */   GIM_Try, /*On fail goto*//*Label 16446*/ GIMT_Encode4(1121624), // Rule ID 64301 //
     /* 1121552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1121563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1121566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1121572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121591 */     // MIs[0] policy
     /* 1121591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121601 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11037:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M2),
     /* 1121604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121620 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121623 */     // GIR_Coverage, 64301,
     /* 1121623 */     GIR_EraseRootFromParent_Done,
     /* 1121624 */   // Label 16446: @1121624
     /* 1121624 */   GIM_Try, /*On fail goto*//*Label 16447*/ GIMT_Encode4(1121701), // Rule ID 64302 //
     /* 1121629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121668 */     // MIs[0] policy
     /* 1121668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1121681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121697 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121700 */     // GIR_Coverage, 64302,
     /* 1121700 */     GIR_EraseRootFromParent_Done,
     /* 1121701 */   // Label 16447: @1121701
     /* 1121701 */   GIM_Try, /*On fail goto*//*Label 16448*/ GIMT_Encode4(1121778), // Rule ID 64303 //
     /* 1121706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccu_4x8x4),
     /* 1121714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1121717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1121720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1121726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1121737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1121745 */     // MIs[0] policy
     /* 1121745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121755 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11037:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCU_4x8x4_M4),
     /* 1121758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121774 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121777 */     // GIR_Coverage, 64303,
     /* 1121777 */     GIR_EraseRootFromParent_Done,
     /* 1121778 */   // Label 16448: @1121778
     /* 1121778 */   GIM_Try, /*On fail goto*//*Label 16449*/ GIMT_Encode4(1121855), // Rule ID 64304 //
     /* 1121783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1121791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121822 */     // MIs[0] policy
     /* 1121822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121832 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1121835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121851 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121854 */     // GIR_Coverage, 64304,
     /* 1121854 */     GIR_EraseRootFromParent_Done,
     /* 1121855 */   // Label 16449: @1121855
     /* 1121855 */   GIM_Try, /*On fail goto*//*Label 16450*/ GIMT_Encode4(1121932), // Rule ID 64305 //
     /* 1121860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1121863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1121868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1121871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1121874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1121880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1121883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121899 */     // MIs[0] policy
     /* 1121899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121909 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11033:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1121909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_MF2),
     /* 1121912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1121925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1121928 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1121930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1121931 */     // GIR_Coverage, 64305,
     /* 1121931 */     GIR_EraseRootFromParent_Done,
     /* 1121932 */   // Label 16450: @1121932
     /* 1121932 */   GIM_Try, /*On fail goto*//*Label 16451*/ GIMT_Encode4(1122009), // Rule ID 64306 //
     /* 1121937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1121940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1121945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1121948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1121951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1121954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1121957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1121960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1121968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1121976 */     // MIs[0] policy
     /* 1121976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1121979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1121986 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1121986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1121989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1121991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1121993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1121995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1121997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122005 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122008 */     // GIR_Coverage, 64306,
     /* 1122008 */     GIR_EraseRootFromParent_Done,
     /* 1122009 */   // Label 16451: @1122009
     /* 1122009 */   GIM_Try, /*On fail goto*//*Label 16452*/ GIMT_Encode4(1122086), // Rule ID 64307 //
     /* 1122014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122053 */     // MIs[0] policy
     /* 1122053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122063 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11033:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M1),
     /* 1122066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122085 */     // GIR_Coverage, 64307,
     /* 1122085 */     GIR_EraseRootFromParent_Done,
     /* 1122086 */   // Label 16452: @1122086
     /* 1122086 */   GIM_Try, /*On fail goto*//*Label 16453*/ GIMT_Encode4(1122163), // Rule ID 64308 //
     /* 1122091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122130 */     // MIs[0] policy
     /* 1122130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122140 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1122143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122159 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122162 */     // GIR_Coverage, 64308,
     /* 1122162 */     GIR_EraseRootFromParent_Done,
     /* 1122163 */   // Label 16453: @1122163
     /* 1122163 */   GIM_Try, /*On fail goto*//*Label 16454*/ GIMT_Encode4(1122240), // Rule ID 64309 //
     /* 1122168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122207 */     // MIs[0] policy
     /* 1122207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122217 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11033:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M2),
     /* 1122220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122222 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122239 */     // GIR_Coverage, 64309,
     /* 1122239 */     GIR_EraseRootFromParent_Done,
     /* 1122240 */   // Label 16454: @1122240
     /* 1122240 */   GIM_Try, /*On fail goto*//*Label 16455*/ GIMT_Encode4(1122317), // Rule ID 64310 //
     /* 1122245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122284 */     // MIs[0] policy
     /* 1122284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122294 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1122297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122316 */     // GIR_Coverage, 64310,
     /* 1122316 */     GIR_EraseRootFromParent_Done,
     /* 1122317 */   // Label 16455: @1122317
     /* 1122317 */   GIM_Try, /*On fail goto*//*Label 16456*/ GIMT_Encode4(1122394), // Rule ID 64311 //
     /* 1122322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmacc_4x8x4),
     /* 1122330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122361 */     // MIs[0] policy
     /* 1122361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122371 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11033:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACC_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACC_4x8x4_M4),
     /* 1122374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122393 */     // GIR_Coverage, 64311,
     /* 1122393 */     GIR_EraseRootFromParent_Done,
     /* 1122394 */   // Label 16456: @1122394
     /* 1122394 */   GIM_Try, /*On fail goto*//*Label 16457*/ GIMT_Encode4(1122471), // Rule ID 64312 //
     /* 1122399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122438 */     // MIs[0] policy
     /* 1122438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1122451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122467 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122470 */     // GIR_Coverage, 64312,
     /* 1122470 */     GIR_EraseRootFromParent_Done,
     /* 1122471 */   // Label 16457: @1122471
     /* 1122471 */   GIM_Try, /*On fail goto*//*Label 16458*/ GIMT_Encode4(1122548), // Rule ID 64313 //
     /* 1122476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1122487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1122490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1122496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122515 */     // MIs[0] policy
     /* 1122515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122525 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11039:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_MF2),
     /* 1122528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122544 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122547 */     // GIR_Coverage, 64313,
     /* 1122547 */     GIR_EraseRootFromParent_Done,
     /* 1122548 */   // Label 16458: @1122548
     /* 1122548 */   GIM_Try, /*On fail goto*//*Label 16459*/ GIMT_Encode4(1122625), // Rule ID 64314 //
     /* 1122553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122592 */     // MIs[0] policy
     /* 1122592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122602 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1122605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122621 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122624 */     // GIR_Coverage, 64314,
     /* 1122624 */     GIR_EraseRootFromParent_Done,
     /* 1122625 */   // Label 16459: @1122625
     /* 1122625 */   GIM_Try, /*On fail goto*//*Label 16460*/ GIMT_Encode4(1122702), // Rule ID 64315 //
     /* 1122630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1122641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1122644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1122650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122669 */     // MIs[0] policy
     /* 1122669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122679 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11039:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M1),
     /* 1122682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122698 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122701 */     // GIR_Coverage, 64315,
     /* 1122701 */     GIR_EraseRootFromParent_Done,
     /* 1122702 */   // Label 16460: @1122702
     /* 1122702 */   GIM_Try, /*On fail goto*//*Label 16461*/ GIMT_Encode4(1122779), // Rule ID 64316 //
     /* 1122707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122746 */     // MIs[0] policy
     /* 1122746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122756 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1122759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122778 */     // GIR_Coverage, 64316,
     /* 1122778 */     GIR_EraseRootFromParent_Done,
     /* 1122779 */   // Label 16461: @1122779
     /* 1122779 */   GIM_Try, /*On fail goto*//*Label 16462*/ GIMT_Encode4(1122856), // Rule ID 64317 //
     /* 1122784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1122795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1122798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1122804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1122823 */     // MIs[0] policy
     /* 1122823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122833 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11039:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M2),
     /* 1122836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122852 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122855 */     // GIR_Coverage, 64317,
     /* 1122855 */     GIR_EraseRootFromParent_Done,
     /* 1122856 */   // Label 16462: @1122856
     /* 1122856 */   GIM_Try, /*On fail goto*//*Label 16463*/ GIMT_Encode4(1122933), // Rule ID 64318 //
     /* 1122861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1122864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1122884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122900 */     // MIs[0] policy
     /* 1122900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1122910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1122913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1122926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1122929 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1122931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1122932 */     // GIR_Coverage, 64318,
     /* 1122932 */     GIR_EraseRootFromParent_Done,
     /* 1122933 */   // Label 16463: @1122933
     /* 1122933 */   GIM_Try, /*On fail goto*//*Label 16464*/ GIMT_Encode4(1123010), // Rule ID 64319 //
     /* 1122938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1122941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccus_4x8x4),
     /* 1122946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1122949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1122952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1122955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1122958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1122961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1122969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1122973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1122977 */     // MIs[0] policy
     /* 1122977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1122980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1122987 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11039:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCUS_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1122987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCUS_4x8x4_M4),
     /* 1122990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1122992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1122994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1122996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1122998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123006 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123009 */     // GIR_Coverage, 64319,
     /* 1123009 */     GIR_EraseRootFromParent_Done,
     /* 1123010 */   // Label 16464: @1123010
     /* 1123010 */   GIM_Try, /*On fail goto*//*Label 16465*/ GIMT_Encode4(1123087), // Rule ID 64320 //
     /* 1123015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123054 */     // MIs[0] policy
     /* 1123054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123064 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1123067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123083 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123086 */     // GIR_Coverage, 64320,
     /* 1123086 */     GIR_EraseRootFromParent_Done,
     /* 1123087 */   // Label 16465: @1123087
     /* 1123087 */   GIM_Try, /*On fail goto*//*Label 16466*/ GIMT_Encode4(1123164), // Rule ID 64321 //
     /* 1123092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1123103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1123106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1123112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123131 */     // MIs[0] policy
     /* 1123131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123141 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11035:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_MF2:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_MF2),
     /* 1123144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123160 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123163 */     // GIR_Coverage, 64321,
     /* 1123163 */     GIR_EraseRootFromParent_Done,
     /* 1123164 */   // Label 16466: @1123164
     /* 1123164 */   GIM_Try, /*On fail goto*//*Label 16467*/ GIMT_Encode4(1123241), // Rule ID 64322 //
     /* 1123169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123208 */     // MIs[0] policy
     /* 1123208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1123221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123237 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123240 */     // GIR_Coverage, 64322,
     /* 1123240 */     GIR_EraseRootFromParent_Done,
     /* 1123241 */   // Label 16467: @1123241
     /* 1123241 */   GIM_Try, /*On fail goto*//*Label 16468*/ GIMT_Encode4(1123318), // Rule ID 64323 //
     /* 1123246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1123257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1123260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1123266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123285 */     // MIs[0] policy
     /* 1123285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11035:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M1:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M1),
     /* 1123298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123314 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123317 */     // GIR_Coverage, 64323,
     /* 1123317 */     GIR_EraseRootFromParent_Done,
     /* 1123318 */   // Label 16468: @1123318
     /* 1123318 */   GIM_Try, /*On fail goto*//*Label 16469*/ GIMT_Encode4(1123395), // Rule ID 64324 //
     /* 1123323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123362 */     // MIs[0] policy
     /* 1123362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123372 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1123375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123394 */     // GIR_Coverage, 64324,
     /* 1123394 */     GIR_EraseRootFromParent_Done,
     /* 1123395 */   // Label 16469: @1123395
     /* 1123395 */   GIM_Try, /*On fail goto*//*Label 16470*/ GIMT_Encode4(1123472), // Rule ID 64325 //
     /* 1123400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1123411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1123414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1123420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1123439 */     // MIs[0] policy
     /* 1123439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123449 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11035:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M2:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M2),
     /* 1123452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123470 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123471 */     // GIR_Coverage, 64325,
     /* 1123471 */     GIR_EraseRootFromParent_Done,
     /* 1123472 */   // Label 16470: @1123472
     /* 1123472 */   GIM_Try, /*On fail goto*//*Label 16471*/ GIMT_Encode4(1123549), // Rule ID 64326 //
     /* 1123477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode0),
     /* 1123480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 1123500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123516 */     // MIs[0] policy
     /* 1123516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1123526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1123529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123545 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123548 */     // GIR_Coverage, 64326,
     /* 1123548 */     GIR_EraseRootFromParent_Done,
     /* 1123549 */   // Label 16471: @1123549
     /* 1123549 */   GIM_Try, /*On fail goto*//*Label 16472*/ GIMT_Encode4(1123626), // Rule ID 64327 //
     /* 1123554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvqmaccqoq_HwMode1),
     /* 1123557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vqmaccsu_4x8x4),
     /* 1123562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1123565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1123568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1123571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1123574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 1123577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1123585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1123593 */     // MIs[0] policy
     /* 1123593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1123596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123603 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11035:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVQMACCSU_4x8x4_M4:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1123603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVQMACCSU_4x8x4_M4),
     /* 1123606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1123610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 1123624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123625 */     // GIR_Coverage, 64327,
     /* 1123625 */     GIR_EraseRootFromParent_Done,
     /* 1123626 */   // Label 16472: @1123626
     /* 1123626 */   GIM_Try, /*On fail goto*//*Label 16473*/ GIMT_Encode4(1123706), // Rule ID 2614 //
     /* 1123631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1123634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1123639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1123642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1123645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1123648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1123651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123670 */     // MIs[0] round
     /* 1123670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1123683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123705 */     // GIR_Coverage, 2614,
     /* 1123705 */     GIR_EraseRootFromParent_Done,
     /* 1123706 */   // Label 16473: @1123706
     /* 1123706 */   GIM_Try, /*On fail goto*//*Label 16474*/ GIMT_Encode4(1123786), // Rule ID 2615 //
     /* 1123711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1123714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1123719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1123722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1123725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1123728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1123731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123750 */     // MIs[0] round
     /* 1123750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123760 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8),
     /* 1123763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1123781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123785 */     // GIR_Coverage, 2615,
     /* 1123785 */     GIR_EraseRootFromParent_Done,
     /* 1123786 */   // Label 16474: @1123786
     /* 1123786 */   GIM_Try, /*On fail goto*//*Label 16475*/ GIMT_Encode4(1123866), // Rule ID 2654 //
     /* 1123791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1123794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1123799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1123802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1123805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1123808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1123811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123830 */     // MIs[0] round
     /* 1123830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123840 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1123840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1123843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123865 */     // GIR_Coverage, 2654,
     /* 1123865 */     GIR_EraseRootFromParent_Done,
     /* 1123866 */   // Label 16475: @1123866
     /* 1123866 */   GIM_Try, /*On fail goto*//*Label 16476*/ GIMT_Encode4(1123946), // Rule ID 2655 //
     /* 1123871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1123874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1123879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1123882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1123885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1123888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1123891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1123894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123910 */     // MIs[0] round
     /* 1123910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1123920 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1123920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16),
     /* 1123923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1123925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1123927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1123929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1123931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1123933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1123938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1123941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1123944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1123945 */     // GIR_Coverage, 2655,
     /* 1123945 */     GIR_EraseRootFromParent_Done,
     /* 1123946 */   // Label 16476: @1123946
     /* 1123946 */   GIM_Try, /*On fail goto*//*Label 16477*/ GIMT_Encode4(1124026), // Rule ID 2674 //
     /* 1123951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1123954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1123959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1123962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1123965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1123968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1123971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1123974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1123990 */     // MIs[0] round
     /* 1123990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1123993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1124003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124025 */     // GIR_Coverage, 2674,
     /* 1124025 */     GIR_EraseRootFromParent_Done,
     /* 1124026 */   // Label 16477: @1124026
     /* 1124026 */   GIM_Try, /*On fail goto*//*Label 16478*/ GIMT_Encode4(1124106), // Rule ID 2675 //
     /* 1124031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1124034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1124039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1124042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1124045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1124048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1124051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124070 */     // MIs[0] round
     /* 1124070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16),
     /* 1124083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1124087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124105 */     // GIR_Coverage, 2675,
     /* 1124105 */     GIR_EraseRootFromParent_Done,
     /* 1124106 */   // Label 16478: @1124106
     /* 1124106 */   GIM_Try, /*On fail goto*//*Label 16479*/ GIMT_Encode4(1124186), // Rule ID 14816 //
     /* 1124111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1124122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1124125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1124128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1124131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124150 */     // MIs[0] round
     /* 1124150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124160 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1124163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124185 */     // GIR_Coverage, 14816,
     /* 1124185 */     GIR_EraseRootFromParent_Done,
     /* 1124186 */   // Label 16479: @1124186
     /* 1124186 */   GIM_Try, /*On fail goto*//*Label 16480*/ GIMT_Encode4(1124266), // Rule ID 14817 //
     /* 1124191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1124202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1124205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1124208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1124211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124230 */     // MIs[0] round
     /* 1124230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1124243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124265 */     // GIR_Coverage, 14817,
     /* 1124265 */     GIR_EraseRootFromParent_Done,
     /* 1124266 */   // Label 16480: @1124266
     /* 1124266 */   GIM_Try, /*On fail goto*//*Label 16481*/ GIMT_Encode4(1124346), // Rule ID 14820 //
     /* 1124271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1124282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1124285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124310 */     // MIs[0] round
     /* 1124310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124320 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124345 */     // GIR_Coverage, 14820,
     /* 1124345 */     GIR_EraseRootFromParent_Done,
     /* 1124346 */   // Label 16481: @1124346
     /* 1124346 */   GIM_Try, /*On fail goto*//*Label 16482*/ GIMT_Encode4(1124426), // Rule ID 14821 //
     /* 1124351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1124362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1124365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1124368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1124371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124390 */     // MIs[0] round
     /* 1124390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124400 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124425 */     // GIR_Coverage, 14821,
     /* 1124425 */     GIR_EraseRootFromParent_Done,
     /* 1124426 */   // Label 16482: @1124426
     /* 1124426 */   GIM_Try, /*On fail goto*//*Label 16483*/ GIMT_Encode4(1124506), // Rule ID 14824 //
     /* 1124431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1124442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1124445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1124448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1124451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124470 */     // MIs[0] round
     /* 1124470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1124483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124505 */     // GIR_Coverage, 14824,
     /* 1124505 */     GIR_EraseRootFromParent_Done,
     /* 1124506 */   // Label 16483: @1124506
     /* 1124506 */   GIM_Try, /*On fail goto*//*Label 16484*/ GIMT_Encode4(1124586), // Rule ID 14825 //
     /* 1124511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1124522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1124525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1124528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1124531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124550 */     // MIs[0] round
     /* 1124550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4),
     /* 1124563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124585 */     // GIR_Coverage, 14825,
     /* 1124585 */     GIR_EraseRootFromParent_Done,
     /* 1124586 */   // Label 16484: @1124586
     /* 1124586 */   GIM_Try, /*On fail goto*//*Label 16485*/ GIMT_Encode4(1124666), // Rule ID 14828 //
     /* 1124591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1124602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1124605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1124608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1124611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124630 */     // MIs[0] round
     /* 1124630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124640 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124665 */     // GIR_Coverage, 14828,
     /* 1124665 */     GIR_EraseRootFromParent_Done,
     /* 1124666 */   // Label 16485: @1124666
     /* 1124666 */   GIM_Try, /*On fail goto*//*Label 16486*/ GIMT_Encode4(1124746), // Rule ID 14829 //
     /* 1124671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1124682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1124685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1124688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1124691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124710 */     // MIs[0] round
     /* 1124710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1124741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124745 */     // GIR_Coverage, 14829,
     /* 1124745 */     GIR_EraseRootFromParent_Done,
     /* 1124746 */   // Label 16486: @1124746
     /* 1124746 */   GIM_Try, /*On fail goto*//*Label 16487*/ GIMT_Encode4(1124826), // Rule ID 14832 //
     /* 1124751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1124768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1124771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124790 */     // MIs[0] round
     /* 1124790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124825 */     // GIR_Coverage, 14832,
     /* 1124825 */     GIR_EraseRootFromParent_Done,
     /* 1124826 */   // Label 16487: @1124826
     /* 1124826 */   GIM_Try, /*On fail goto*//*Label 16488*/ GIMT_Encode4(1124906), // Rule ID 14833 //
     /* 1124831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1124842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1124845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1124848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1124851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1124854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124870 */     // MIs[0] round
     /* 1124870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1124880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2),
     /* 1124883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1124901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124905 */     // GIR_Coverage, 14833,
     /* 1124905 */     GIR_EraseRootFromParent_Done,
     /* 1124906 */   // Label 16488: @1124906
     /* 1124906 */   GIM_Try, /*On fail goto*//*Label 16489*/ GIMT_Encode4(1124986), // Rule ID 14836 //
     /* 1124911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1124914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1124922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1124925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1124928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1124931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1124934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1124950 */     // MIs[0] round
     /* 1124950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1124953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1124960 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1124960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1124963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1124965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1124967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1124969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1124971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1124973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1124978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1124981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1124984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1124985 */     // GIR_Coverage, 14836,
     /* 1124985 */     GIR_EraseRootFromParent_Done,
     /* 1124986 */   // Label 16489: @1124986
     /* 1124986 */   GIM_Try, /*On fail goto*//*Label 16490*/ GIMT_Encode4(1125066), // Rule ID 14837 //
     /* 1124991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1124994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1124999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1125002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1125005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1125008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1125011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125030 */     // MIs[0] round
     /* 1125030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125065 */     // GIR_Coverage, 14837,
     /* 1125065 */     GIR_EraseRootFromParent_Done,
     /* 1125066 */   // Label 16490: @1125066
     /* 1125066 */   GIM_Try, /*On fail goto*//*Label 16491*/ GIMT_Encode4(1125146), // Rule ID 14840 //
     /* 1125071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1125082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1125085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125110 */     // MIs[0] round
     /* 1125110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125145 */     // GIR_Coverage, 14840,
     /* 1125145 */     GIR_EraseRootFromParent_Done,
     /* 1125146 */   // Label 16491: @1125146
     /* 1125146 */   GIM_Try, /*On fail goto*//*Label 16492*/ GIMT_Encode4(1125226), // Rule ID 14841 //
     /* 1125151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1125162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1125165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1125168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1125171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125190 */     // MIs[0] round
     /* 1125190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1125221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125225 */     // GIR_Coverage, 14841,
     /* 1125225 */     GIR_EraseRootFromParent_Done,
     /* 1125226 */   // Label 16492: @1125226
     /* 1125226 */   GIM_Try, /*On fail goto*//*Label 16493*/ GIMT_Encode4(1125306), // Rule ID 14844 //
     /* 1125231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1125248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1125251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125270 */     // MIs[0] round
     /* 1125270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125305 */     // GIR_Coverage, 14844,
     /* 1125305 */     GIR_EraseRootFromParent_Done,
     /* 1125306 */   // Label 16493: @1125306
     /* 1125306 */   GIM_Try, /*On fail goto*//*Label 16494*/ GIMT_Encode4(1125386), // Rule ID 14845 //
     /* 1125311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1125322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1125325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1125328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1125331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125350 */     // MIs[0] round
     /* 1125350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1125381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125385 */     // GIR_Coverage, 14845,
     /* 1125385 */     GIR_EraseRootFromParent_Done,
     /* 1125386 */   // Label 16494: @1125386
     /* 1125386 */   GIM_Try, /*On fail goto*//*Label 16495*/ GIMT_Encode4(1125466), // Rule ID 14848 //
     /* 1125391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1125394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1125408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1125411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125430 */     // MIs[0] round
     /* 1125430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125465 */     // GIR_Coverage, 14848,
     /* 1125465 */     GIR_EraseRootFromParent_Done,
     /* 1125466 */   // Label 16495: @1125466
     /* 1125466 */   GIM_Try, /*On fail goto*//*Label 16496*/ GIMT_Encode4(1125546), // Rule ID 14849 //
     /* 1125471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1125474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1125482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1125485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1125488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1125491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1125510 */     // MIs[0] round
     /* 1125510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1),
     /* 1125523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1125541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125545 */     // GIR_Coverage, 14849,
     /* 1125545 */     GIR_EraseRootFromParent_Done,
     /* 1125546 */   // Label 16496: @1125546
     /* 1125546 */   GIM_Try, /*On fail goto*//*Label 16497*/ GIMT_Encode4(1125626), // Rule ID 14852 //
     /* 1125551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1125562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1125565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125590 */     // MIs[0] round
     /* 1125590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125600 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1125603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125625 */     // GIR_Coverage, 14852,
     /* 1125625 */     GIR_EraseRootFromParent_Done,
     /* 1125626 */   // Label 16497: @1125626
     /* 1125626 */   GIM_Try, /*On fail goto*//*Label 16498*/ GIMT_Encode4(1125706), // Rule ID 14853 //
     /* 1125631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1125642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1125645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1125648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1125651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1125670 */     // MIs[0] round
     /* 1125670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1125683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125705 */     // GIR_Coverage, 14853,
     /* 1125705 */     GIR_EraseRootFromParent_Done,
     /* 1125706 */   // Label 16498: @1125706
     /* 1125706 */   GIM_Try, /*On fail goto*//*Label 16499*/ GIMT_Encode4(1125786), // Rule ID 14856 //
     /* 1125711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1125722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1125725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125750 */     // MIs[0] round
     /* 1125750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125760 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1125763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125785 */     // GIR_Coverage, 14856,
     /* 1125785 */     GIR_EraseRootFromParent_Done,
     /* 1125786 */   // Label 16499: @1125786
     /* 1125786 */   GIM_Try, /*On fail goto*//*Label 16500*/ GIMT_Encode4(1125866), // Rule ID 14857 //
     /* 1125791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1125802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1125805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1125808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1125811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1125830 */     // MIs[0] round
     /* 1125830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1125840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1125843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125865 */     // GIR_Coverage, 14857,
     /* 1125865 */     GIR_EraseRootFromParent_Done,
     /* 1125866 */   // Label 16500: @1125866
     /* 1125866 */   GIM_Try, /*On fail goto*//*Label 16501*/ GIMT_Encode4(1125946), // Rule ID 14860 //
     /* 1125871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1125874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1125882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1125885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1125894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125910 */     // MIs[0] round
     /* 1125910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1125920 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1125920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1125923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1125925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1125927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1125929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1125931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1125933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1125938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1125941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1125944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1125945 */     // GIR_Coverage, 14860,
     /* 1125945 */     GIR_EraseRootFromParent_Done,
     /* 1125946 */   // Label 16501: @1125946
     /* 1125946 */   GIM_Try, /*On fail goto*//*Label 16502*/ GIMT_Encode4(1126026), // Rule ID 14861 //
     /* 1125951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1125954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1125959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1125962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1125965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1125968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1125971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1125974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1125990 */     // MIs[0] round
     /* 1125990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1125993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1126003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1126021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126025 */     // GIR_Coverage, 14861,
     /* 1126025 */     GIR_EraseRootFromParent_Done,
     /* 1126026 */   // Label 16502: @1126026
     /* 1126026 */   GIM_Try, /*On fail goto*//*Label 16503*/ GIMT_Encode4(1126106), // Rule ID 14864 //
     /* 1126031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1126042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1126045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126070 */     // MIs[0] round
     /* 1126070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1126083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126105 */     // GIR_Coverage, 14864,
     /* 1126105 */     GIR_EraseRootFromParent_Done,
     /* 1126106 */   // Label 16503: @1126106
     /* 1126106 */   GIM_Try, /*On fail goto*//*Label 16504*/ GIMT_Encode4(1126186), // Rule ID 14865 //
     /* 1126111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1126122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1126125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1126128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1126131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126150 */     // MIs[0] round
     /* 1126150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1126163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126185 */     // GIR_Coverage, 14865,
     /* 1126185 */     GIR_EraseRootFromParent_Done,
     /* 1126186 */   // Label 16504: @1126186
     /* 1126186 */   GIM_Try, /*On fail goto*//*Label 16505*/ GIMT_Encode4(1126266), // Rule ID 14868 //
     /* 1126191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1126202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1126205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126230 */     // MIs[0] round
     /* 1126230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126240 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1126243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126265 */     // GIR_Coverage, 14868,
     /* 1126265 */     GIR_EraseRootFromParent_Done,
     /* 1126266 */   // Label 16505: @1126266
     /* 1126266 */   GIM_Try, /*On fail goto*//*Label 16506*/ GIMT_Encode4(1126346), // Rule ID 14869 //
     /* 1126271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1126282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1126285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1126288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1126291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126310 */     // MIs[0] round
     /* 1126310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1126323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126345 */     // GIR_Coverage, 14869,
     /* 1126345 */     GIR_EraseRootFromParent_Done,
     /* 1126346 */   // Label 16506: @1126346
     /* 1126346 */   GIM_Try, /*On fail goto*//*Label 16507*/ GIMT_Encode4(1126426), // Rule ID 14872 //
     /* 1126351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1126362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1126365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126390 */     // MIs[0] round
     /* 1126390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126400 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1126403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126425 */     // GIR_Coverage, 14872,
     /* 1126425 */     GIR_EraseRootFromParent_Done,
     /* 1126426 */   // Label 16507: @1126426
     /* 1126426 */   GIM_Try, /*On fail goto*//*Label 16508*/ GIMT_Encode4(1126506), // Rule ID 14873 //
     /* 1126431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1126442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1126445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1126448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1126451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126470 */     // MIs[0] round
     /* 1126470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1126483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1126501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126505 */     // GIR_Coverage, 14873,
     /* 1126505 */     GIR_EraseRootFromParent_Done,
     /* 1126506 */   // Label 16508: @1126506
     /* 1126506 */   GIM_Try, /*On fail goto*//*Label 16509*/ GIMT_Encode4(1126586), // Rule ID 14876 //
     /* 1126511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1126528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1126531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126550 */     // MIs[0] round
     /* 1126550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1126563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126585 */     // GIR_Coverage, 14876,
     /* 1126585 */     GIR_EraseRootFromParent_Done,
     /* 1126586 */   // Label 16509: @1126586
     /* 1126586 */   GIM_Try, /*On fail goto*//*Label 16510*/ GIMT_Encode4(1126666), // Rule ID 14877 //
     /* 1126591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1126602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1126605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1126608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1126611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1126630 */     // MIs[0] round
     /* 1126630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1126643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126665 */     // GIR_Coverage, 14877,
     /* 1126665 */     GIR_EraseRootFromParent_Done,
     /* 1126666 */   // Label 16510: @1126666
     /* 1126666 */   GIM_Try, /*On fail goto*//*Label 16511*/ GIMT_Encode4(1126746), // Rule ID 14880 //
     /* 1126671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1126688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1126691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126710 */     // MIs[0] round
     /* 1126710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126720 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1126723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126745 */     // GIR_Coverage, 14880,
     /* 1126745 */     GIR_EraseRootFromParent_Done,
     /* 1126746 */   // Label 16511: @1126746
     /* 1126746 */   GIM_Try, /*On fail goto*//*Label 16512*/ GIMT_Encode4(1126826), // Rule ID 14881 //
     /* 1126751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1126762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1126765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1126768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1126771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1126790 */     // MIs[0] round
     /* 1126790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1126803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126825 */     // GIR_Coverage, 14881,
     /* 1126825 */     GIR_EraseRootFromParent_Done,
     /* 1126826 */   // Label 16512: @1126826
     /* 1126826 */   GIM_Try, /*On fail goto*//*Label 16513*/ GIMT_Encode4(1126906), // Rule ID 14884 //
     /* 1126831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1126834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1126848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1126851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1126854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126870 */     // MIs[0] round
     /* 1126870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1126880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1126883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126905 */     // GIR_Coverage, 14884,
     /* 1126905 */     GIR_EraseRootFromParent_Done,
     /* 1126906 */   // Label 16513: @1126906
     /* 1126906 */   GIM_Try, /*On fail goto*//*Label 16514*/ GIMT_Encode4(1126986), // Rule ID 14885 //
     /* 1126911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1126914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1126922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1126925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1126928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1126931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1126934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1126950 */     // MIs[0] round
     /* 1126950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1126953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1126960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1126960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1126963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1126965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1126967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1126969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1126971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1126973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1126978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1126981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1126984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1126985 */     // GIR_Coverage, 14885,
     /* 1126985 */     GIR_EraseRootFromParent_Done,
     /* 1126986 */   // Label 16514: @1126986
     /* 1126986 */   GIM_Try, /*On fail goto*//*Label 16515*/ GIMT_Encode4(1127066), // Rule ID 14888 //
     /* 1126991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1126994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1126999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1127008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1127011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127030 */     // MIs[0] round
     /* 1127030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127040 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1127043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127065 */     // GIR_Coverage, 14888,
     /* 1127065 */     GIR_EraseRootFromParent_Done,
     /* 1127066 */   // Label 16515: @1127066
     /* 1127066 */   GIM_Try, /*On fail goto*//*Label 16516*/ GIMT_Encode4(1127146), // Rule ID 14889 //
     /* 1127071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1127082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1127085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1127088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1127091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1127110 */     // MIs[0] round
     /* 1127110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2),
     /* 1127123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127145 */     // GIR_Coverage, 14889,
     /* 1127145 */     GIR_EraseRootFromParent_Done,
     /* 1127146 */   // Label 16516: @1127146
     /* 1127146 */   GIM_Try, /*On fail goto*//*Label 16517*/ GIMT_Encode4(1127226), // Rule ID 14892 //
     /* 1127151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1127168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1127171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127190 */     // MIs[0] round
     /* 1127190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127200 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1127203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127225 */     // GIR_Coverage, 14892,
     /* 1127225 */     GIR_EraseRootFromParent_Done,
     /* 1127226 */   // Label 16517: @1127226
     /* 1127226 */   GIM_Try, /*On fail goto*//*Label 16518*/ GIMT_Encode4(1127306), // Rule ID 14893 //
     /* 1127231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1127242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1127245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1127248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1127251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1127270 */     // MIs[0] round
     /* 1127270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4),
     /* 1127283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127305 */     // GIR_Coverage, 14893,
     /* 1127305 */     GIR_EraseRootFromParent_Done,
     /* 1127306 */   // Label 16518: @1127306
     /* 1127306 */   GIM_Try, /*On fail goto*//*Label 16519*/ GIMT_Encode4(1127386), // Rule ID 14896 //
     /* 1127311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1127314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1127328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1127331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127350 */     // MIs[0] round
     /* 1127350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127360 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1127363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127385 */     // GIR_Coverage, 14896,
     /* 1127385 */     GIR_EraseRootFromParent_Done,
     /* 1127386 */   // Label 16519: @1127386
     /* 1127386 */   GIM_Try, /*On fail goto*//*Label 16520*/ GIMT_Encode4(1127466), // Rule ID 14897 //
     /* 1127391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1127394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1127402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1127405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1127408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1127411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1127430 */     // MIs[0] round
     /* 1127430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8),
     /* 1127443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1127461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127465 */     // GIR_Coverage, 14897,
     /* 1127465 */     GIR_EraseRootFromParent_Done,
     /* 1127466 */   // Label 16520: @1127466
     /* 1127466 */   GIM_Try, /*On fail goto*//*Label 16521*/ GIMT_Encode4(1127546), // Rule ID 14900 //
     /* 1127471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1127482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1127485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1127488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1127491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127510 */     // MIs[0] round
     /* 1127510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1127523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127545 */     // GIR_Coverage, 14900,
     /* 1127545 */     GIR_EraseRootFromParent_Done,
     /* 1127546 */   // Label 16521: @1127546
     /* 1127546 */   GIM_Try, /*On fail goto*//*Label 16522*/ GIMT_Encode4(1127626), // Rule ID 14901 //
     /* 1127551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1127562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1127565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1127568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127590 */     // MIs[0] round
     /* 1127590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8),
     /* 1127603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127625 */     // GIR_Coverage, 14901,
     /* 1127625 */     GIR_EraseRootFromParent_Done,
     /* 1127626 */   // Label 16522: @1127626
     /* 1127626 */   GIM_Try, /*On fail goto*//*Label 16523*/ GIMT_Encode4(1127706), // Rule ID 14904 //
     /* 1127631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1127642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1127645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1127648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1127651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127670 */     // MIs[0] round
     /* 1127670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127680 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1127683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127705 */     // GIR_Coverage, 14904,
     /* 1127705 */     GIR_EraseRootFromParent_Done,
     /* 1127706 */   // Label 16523: @1127706
     /* 1127706 */   GIM_Try, /*On fail goto*//*Label 16524*/ GIMT_Encode4(1127786), // Rule ID 14905 //
     /* 1127711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1127722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1127725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1127728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127750 */     // MIs[0] round
     /* 1127750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1127763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127785 */     // GIR_Coverage, 14905,
     /* 1127785 */     GIR_EraseRootFromParent_Done,
     /* 1127786 */   // Label 16524: @1127786
     /* 1127786 */   GIM_Try, /*On fail goto*//*Label 16525*/ GIMT_Encode4(1127866), // Rule ID 14908 //
     /* 1127791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1127802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1127805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1127811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127830 */     // MIs[0] round
     /* 1127830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127840 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1127840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1127843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127865 */     // GIR_Coverage, 14908,
     /* 1127865 */     GIR_EraseRootFromParent_Done,
     /* 1127866 */   // Label 16525: @1127866
     /* 1127866 */   GIM_Try, /*On fail goto*//*Label 16526*/ GIMT_Encode4(1127946), // Rule ID 14909 //
     /* 1127871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1127874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1127882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1127885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1127888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1127891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1127894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127910 */     // MIs[0] round
     /* 1127910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1127920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1127920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1127923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1127925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1127927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1127929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1127931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1127933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1127938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1127941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1127944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1127945 */     // GIR_Coverage, 14909,
     /* 1127945 */     GIR_EraseRootFromParent_Done,
     /* 1127946 */   // Label 16526: @1127946
     /* 1127946 */   GIM_Try, /*On fail goto*//*Label 16527*/ GIMT_Encode4(1128026), // Rule ID 14912 //
     /* 1127951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1127954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1127959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1127962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1127965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1127968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1127971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1127974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1127986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1127990 */     // MIs[0] round
     /* 1127990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1127993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1128003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128025 */     // GIR_Coverage, 14912,
     /* 1128025 */     GIR_EraseRootFromParent_Done,
     /* 1128026 */   // Label 16527: @1128026
     /* 1128026 */   GIM_Try, /*On fail goto*//*Label 16528*/ GIMT_Encode4(1128106), // Rule ID 14913 //
     /* 1128031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1128042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1128045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1128048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128070 */     // MIs[0] round
     /* 1128070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4),
     /* 1128083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128105 */     // GIR_Coverage, 14913,
     /* 1128105 */     GIR_EraseRootFromParent_Done,
     /* 1128106 */   // Label 16528: @1128106
     /* 1128106 */   GIM_Try, /*On fail goto*//*Label 16529*/ GIMT_Encode4(1128186), // Rule ID 14916 //
     /* 1128111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1128122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1128125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1128128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128150 */     // MIs[0] round
     /* 1128150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1128163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128185 */     // GIR_Coverage, 14916,
     /* 1128185 */     GIR_EraseRootFromParent_Done,
     /* 1128186 */   // Label 16529: @1128186
     /* 1128186 */   GIM_Try, /*On fail goto*//*Label 16530*/ GIMT_Encode4(1128266), // Rule ID 14917 //
     /* 1128191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1128202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1128205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1128208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128230 */     // MIs[0] round
     /* 1128230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1128243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128265 */     // GIR_Coverage, 14917,
     /* 1128265 */     GIR_EraseRootFromParent_Done,
     /* 1128266 */   // Label 16530: @1128266
     /* 1128266 */   GIM_Try, /*On fail goto*//*Label 16531*/ GIMT_Encode4(1128346), // Rule ID 14920 //
     /* 1128271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128310 */     // MIs[0] round
     /* 1128310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1128323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128345 */     // GIR_Coverage, 14920,
     /* 1128345 */     GIR_EraseRootFromParent_Done,
     /* 1128346 */   // Label 16531: @1128346
     /* 1128346 */   GIM_Try, /*On fail goto*//*Label 16532*/ GIMT_Encode4(1128426), // Rule ID 14921 //
     /* 1128351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1128362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1128365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1128368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128390 */     // MIs[0] round
     /* 1128390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2),
     /* 1128403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128425 */     // GIR_Coverage, 14921,
     /* 1128425 */     GIR_EraseRootFromParent_Done,
     /* 1128426 */   // Label 16532: @1128426
     /* 1128426 */   GIM_Try, /*On fail goto*//*Label 16533*/ GIMT_Encode4(1128506), // Rule ID 14924 //
     /* 1128431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1128442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1128445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1128448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128470 */     // MIs[0] round
     /* 1128470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128480 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128505 */     // GIR_Coverage, 14924,
     /* 1128505 */     GIR_EraseRootFromParent_Done,
     /* 1128506 */   // Label 16533: @1128506
     /* 1128506 */   GIM_Try, /*On fail goto*//*Label 16534*/ GIMT_Encode4(1128586), // Rule ID 14925 //
     /* 1128511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1128522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1128525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1128528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128550 */     // MIs[0] round
     /* 1128550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11071:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1128581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128585 */     // GIR_Coverage, 14925,
     /* 1128585 */     GIR_EraseRootFromParent_Done,
     /* 1128586 */   // Label 16534: @1128586
     /* 1128586 */   GIM_Try, /*On fail goto*//*Label 16535*/ GIMT_Encode4(1128666), // Rule ID 14928 //
     /* 1128591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128630 */     // MIs[0] round
     /* 1128630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128640 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128665 */     // GIR_Coverage, 14928,
     /* 1128665 */     GIR_EraseRootFromParent_Done,
     /* 1128666 */   // Label 16535: @1128666
     /* 1128666 */   GIM_Try, /*On fail goto*//*Label 16536*/ GIMT_Encode4(1128746), // Rule ID 14929 //
     /* 1128671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1128682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1128685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1128688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128710 */     // MIs[0] round
     /* 1128710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11071:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1128741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128745 */     // GIR_Coverage, 14929,
     /* 1128745 */     GIR_EraseRootFromParent_Done,
     /* 1128746 */   // Label 16536: @1128746
     /* 1128746 */   GIM_Try, /*On fail goto*//*Label 16537*/ GIMT_Encode4(1128826), // Rule ID 14932 //
     /* 1128751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1128754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1128768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128790 */     // MIs[0] round
     /* 1128790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128825 */     // GIR_Coverage, 14932,
     /* 1128825 */     GIR_EraseRootFromParent_Done,
     /* 1128826 */   // Label 16537: @1128826
     /* 1128826 */   GIM_Try, /*On fail goto*//*Label 16538*/ GIMT_Encode4(1128906), // Rule ID 14933 //
     /* 1128831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1128834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1128842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1128845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1128848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1128851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1128854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128870 */     // MIs[0] round
     /* 1128870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11071:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1128880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1128901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128905 */     // GIR_Coverage, 14933,
     /* 1128905 */     GIR_EraseRootFromParent_Done,
     /* 1128906 */   // Label 16538: @1128906
     /* 1128906 */   GIM_Try, /*On fail goto*//*Label 16539*/ GIMT_Encode4(1128986), // Rule ID 14936 //
     /* 1128911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1128914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1128922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1128925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1128928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1128931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1128934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1128946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1128950 */     // MIs[0] round
     /* 1128950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1128953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1128960 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1128960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1128963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1128965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1128967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1128969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1128971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1128973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1128978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1128981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1128984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1128985 */     // GIR_Coverage, 14936,
     /* 1128985 */     GIR_EraseRootFromParent_Done,
     /* 1128986 */   // Label 16539: @1128986
     /* 1128986 */   GIM_Try, /*On fail goto*//*Label 16540*/ GIMT_Encode4(1129066), // Rule ID 14937 //
     /* 1128991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1128994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1128999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1129002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1129005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1129008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1129026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129030 */     // MIs[0] round
     /* 1129030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11071:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1),
     /* 1129043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1129061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129065 */     // GIR_Coverage, 14937,
     /* 1129065 */     GIR_EraseRootFromParent_Done,
     /* 1129066 */   // Label 16540: @1129066
     /* 1129066 */   GIM_Try, /*On fail goto*//*Label 16541*/ GIMT_Encode4(1129146), // Rule ID 14940 //
     /* 1129071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1129082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1129085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1129088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129110 */     // MIs[0] round
     /* 1129110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1129123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129145 */     // GIR_Coverage, 14940,
     /* 1129145 */     GIR_EraseRootFromParent_Done,
     /* 1129146 */   // Label 16541: @1129146
     /* 1129146 */   GIM_Try, /*On fail goto*//*Label 16542*/ GIMT_Encode4(1129226), // Rule ID 14941 //
     /* 1129151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1129162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1129165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1129168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129190 */     // MIs[0] round
     /* 1129190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1129203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129225 */     // GIR_Coverage, 14941,
     /* 1129225 */     GIR_EraseRootFromParent_Done,
     /* 1129226 */   // Label 16542: @1129226
     /* 1129226 */   GIM_Try, /*On fail goto*//*Label 16543*/ GIMT_Encode4(1129306), // Rule ID 14944 //
     /* 1129231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1129242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1129245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1129248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129270 */     // MIs[0] round
     /* 1129270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129280 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1129283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129305 */     // GIR_Coverage, 14944,
     /* 1129305 */     GIR_EraseRootFromParent_Done,
     /* 1129306 */   // Label 16543: @1129306
     /* 1129306 */   GIM_Try, /*On fail goto*//*Label 16544*/ GIMT_Encode4(1129386), // Rule ID 14945 //
     /* 1129311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1129322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1129325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1129328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129350 */     // MIs[0] round
     /* 1129350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1129363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129385 */     // GIR_Coverage, 14945,
     /* 1129385 */     GIR_EraseRootFromParent_Done,
     /* 1129386 */   // Label 16544: @1129386
     /* 1129386 */   GIM_Try, /*On fail goto*//*Label 16545*/ GIMT_Encode4(1129466), // Rule ID 14948 //
     /* 1129391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1129402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1129405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1129408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129430 */     // MIs[0] round
     /* 1129430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129440 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1129443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129465 */     // GIR_Coverage, 14948,
     /* 1129465 */     GIR_EraseRootFromParent_Done,
     /* 1129466 */   // Label 16545: @1129466
     /* 1129466 */   GIM_Try, /*On fail goto*//*Label 16546*/ GIMT_Encode4(1129546), // Rule ID 14949 //
     /* 1129471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1129482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1129485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1129488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129510 */     // MIs[0] round
     /* 1129510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1129523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1129541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129545 */     // GIR_Coverage, 14949,
     /* 1129545 */     GIR_EraseRootFromParent_Done,
     /* 1129546 */   // Label 16546: @1129546
     /* 1129546 */   GIM_Try, /*On fail goto*//*Label 16547*/ GIMT_Encode4(1129626), // Rule ID 14952 //
     /* 1129551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1129562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1129565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1129568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129590 */     // MIs[0] round
     /* 1129590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1129603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129625 */     // GIR_Coverage, 14952,
     /* 1129625 */     GIR_EraseRootFromParent_Done,
     /* 1129626 */   // Label 16547: @1129626
     /* 1129626 */   GIM_Try, /*On fail goto*//*Label 16548*/ GIMT_Encode4(1129706), // Rule ID 14953 //
     /* 1129631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1129642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1129645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1129648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1129666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129670 */     // MIs[0] round
     /* 1129670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1129683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129705 */     // GIR_Coverage, 14953,
     /* 1129705 */     GIR_EraseRootFromParent_Done,
     /* 1129706 */   // Label 16548: @1129706
     /* 1129706 */   GIM_Try, /*On fail goto*//*Label 16549*/ GIMT_Encode4(1129786), // Rule ID 14956 //
     /* 1129711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1129722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1129725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1129728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129750 */     // MIs[0] round
     /* 1129750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129760 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1129763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129785 */     // GIR_Coverage, 14956,
     /* 1129785 */     GIR_EraseRootFromParent_Done,
     /* 1129786 */   // Label 16549: @1129786
     /* 1129786 */   GIM_Try, /*On fail goto*//*Label 16550*/ GIMT_Encode4(1129866), // Rule ID 14957 //
     /* 1129791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1129802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1129805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1129808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1129826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129830 */     // MIs[0] round
     /* 1129830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1129840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1129843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129865 */     // GIR_Coverage, 14957,
     /* 1129865 */     GIR_EraseRootFromParent_Done,
     /* 1129866 */   // Label 16550: @1129866
     /* 1129866 */   GIM_Try, /*On fail goto*//*Label 16551*/ GIMT_Encode4(1129946), // Rule ID 14960 //
     /* 1129871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1129874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1129882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1129885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1129888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1129891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1129894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129910 */     // MIs[0] round
     /* 1129910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1129920 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1129920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1129923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1129925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1129927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1129929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1129931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1129933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1129938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1129941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1129944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1129945 */     // GIR_Coverage, 14960,
     /* 1129945 */     GIR_EraseRootFromParent_Done,
     /* 1129946 */   // Label 16551: @1129946
     /* 1129946 */   GIM_Try, /*On fail goto*//*Label 16552*/ GIMT_Encode4(1130026), // Rule ID 14961 //
     /* 1129951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1129954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1129959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1129962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1129965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1129968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1129971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1129974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1129986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1129990 */     // MIs[0] round
     /* 1129990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1129993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1130003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1130021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130025 */     // GIR_Coverage, 14961,
     /* 1130025 */     GIR_EraseRootFromParent_Done,
     /* 1130026 */   // Label 16552: @1130026
     /* 1130026 */   GIM_Try, /*On fail goto*//*Label 16553*/ GIMT_Encode4(1130106), // Rule ID 14964 //
     /* 1130031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1130042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1130045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1130048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130070 */     // MIs[0] round
     /* 1130070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130080 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1130083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130105 */     // GIR_Coverage, 14964,
     /* 1130105 */     GIR_EraseRootFromParent_Done,
     /* 1130106 */   // Label 16553: @1130106
     /* 1130106 */   GIM_Try, /*On fail goto*//*Label 16554*/ GIMT_Encode4(1130186), // Rule ID 14965 //
     /* 1130111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1130122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1130125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1130128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130150 */     // MIs[0] round
     /* 1130150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1130163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130185 */     // GIR_Coverage, 14965,
     /* 1130185 */     GIR_EraseRootFromParent_Done,
     /* 1130186 */   // Label 16554: @1130186
     /* 1130186 */   GIM_Try, /*On fail goto*//*Label 16555*/ GIMT_Encode4(1130266), // Rule ID 14968 //
     /* 1130191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1130202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1130205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1130208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130230 */     // MIs[0] round
     /* 1130230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1130243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130265 */     // GIR_Coverage, 14968,
     /* 1130265 */     GIR_EraseRootFromParent_Done,
     /* 1130266 */   // Label 16555: @1130266
     /* 1130266 */   GIM_Try, /*On fail goto*//*Label 16556*/ GIMT_Encode4(1130346), // Rule ID 14969 //
     /* 1130271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1130282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1130285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1130288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130310 */     // MIs[0] round
     /* 1130310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1130323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130345 */     // GIR_Coverage, 14969,
     /* 1130345 */     GIR_EraseRootFromParent_Done,
     /* 1130346 */   // Label 16556: @1130346
     /* 1130346 */   GIM_Try, /*On fail goto*//*Label 16557*/ GIMT_Encode4(1130426), // Rule ID 14972 //
     /* 1130351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1130362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1130365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1130368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130390 */     // MIs[0] round
     /* 1130390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1130403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130425 */     // GIR_Coverage, 14972,
     /* 1130425 */     GIR_EraseRootFromParent_Done,
     /* 1130426 */   // Label 16557: @1130426
     /* 1130426 */   GIM_Try, /*On fail goto*//*Label 16558*/ GIMT_Encode4(1130506), // Rule ID 14973 //
     /* 1130431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1130434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1130442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1130445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1130448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130470 */     // MIs[0] round
     /* 1130470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1130483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1130501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130505 */     // GIR_Coverage, 14973,
     /* 1130505 */     GIR_EraseRootFromParent_Done,
     /* 1130506 */   // Label 16558: @1130506
     /* 1130506 */   GIM_Try, /*On fail goto*//*Label 16559*/ GIMT_Encode4(1130586), // Rule ID 14976 //
     /* 1130511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1130522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1130525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1130528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130550 */     // MIs[0] round
     /* 1130550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130560 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1130563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130585 */     // GIR_Coverage, 14976,
     /* 1130585 */     GIR_EraseRootFromParent_Done,
     /* 1130586 */   // Label 16559: @1130586
     /* 1130586 */   GIM_Try, /*On fail goto*//*Label 16560*/ GIMT_Encode4(1130666), // Rule ID 14977 //
     /* 1130591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1130602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1130605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1130608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1130626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130630 */     // MIs[0] round
     /* 1130630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130640 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11071:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2),
     /* 1130643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130665 */     // GIR_Coverage, 14977,
     /* 1130665 */     GIR_EraseRootFromParent_Done,
     /* 1130666 */   // Label 16560: @1130666
     /* 1130666 */   GIM_Try, /*On fail goto*//*Label 16561*/ GIMT_Encode4(1130746), // Rule ID 14980 //
     /* 1130671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1130682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1130685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1130688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130710 */     // MIs[0] round
     /* 1130710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130720 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1130723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130745 */     // GIR_Coverage, 14980,
     /* 1130745 */     GIR_EraseRootFromParent_Done,
     /* 1130746 */   // Label 16561: @1130746
     /* 1130746 */   GIM_Try, /*On fail goto*//*Label 16562*/ GIMT_Encode4(1130826), // Rule ID 14981 //
     /* 1130751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1130762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1130765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1130768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1130786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130790 */     // MIs[0] round
     /* 1130790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11071:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4),
     /* 1130803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130825 */     // GIR_Coverage, 14981,
     /* 1130825 */     GIR_EraseRootFromParent_Done,
     /* 1130826 */   // Label 16562: @1130826
     /* 1130826 */   GIM_Try, /*On fail goto*//*Label 16563*/ GIMT_Encode4(1130906), // Rule ID 14984 //
     /* 1130831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1130834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1130842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1130845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1130848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1130851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1130854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130870 */     // MIs[0] round
     /* 1130870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1130880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1130883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130905 */     // GIR_Coverage, 14984,
     /* 1130905 */     GIR_EraseRootFromParent_Done,
     /* 1130906 */   // Label 16563: @1130906
     /* 1130906 */   GIM_Try, /*On fail goto*//*Label 16564*/ GIMT_Encode4(1130986), // Rule ID 14985 //
     /* 1130911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1130914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu),
     /* 1130919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1130922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1130925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1130928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1130931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1130934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1130946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1130950 */     // MIs[0] round
     /* 1130950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1130953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1130960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11071:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADDU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1130960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8),
     /* 1130963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1130965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1130967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1130969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1130971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1130973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1130978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1130981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1130984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1130985 */     // GIR_Coverage, 14985,
     /* 1130985 */     GIR_EraseRootFromParent_Done,
     /* 1130986 */   // Label 16564: @1130986
     /* 1130986 */   GIM_Try, /*On fail goto*//*Label 16565*/ GIMT_Encode4(1131066), // Rule ID 14988 //
     /* 1130991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1130994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1130999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1131002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1131005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1131008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1131011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131030 */     // MIs[0] round
     /* 1131030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131040 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1131043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131065 */     // GIR_Coverage, 14988,
     /* 1131065 */     GIR_EraseRootFromParent_Done,
     /* 1131066 */   // Label 16565: @1131066
     /* 1131066 */   GIM_Try, /*On fail goto*//*Label 16566*/ GIMT_Encode4(1131146), // Rule ID 14989 //
     /* 1131071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1131082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1131085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1131088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1131091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131110 */     // MIs[0] round
     /* 1131110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8),
     /* 1131123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131145 */     // GIR_Coverage, 14989,
     /* 1131145 */     GIR_EraseRootFromParent_Done,
     /* 1131146 */   // Label 16566: @1131146
     /* 1131146 */   GIM_Try, /*On fail goto*//*Label 16567*/ GIMT_Encode4(1131226), // Rule ID 14992 //
     /* 1131151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1131162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1131165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1131168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1131171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131190 */     // MIs[0] round
     /* 1131190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1131203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131225 */     // GIR_Coverage, 14992,
     /* 1131225 */     GIR_EraseRootFromParent_Done,
     /* 1131226 */   // Label 16567: @1131226
     /* 1131226 */   GIM_Try, /*On fail goto*//*Label 16568*/ GIMT_Encode4(1131306), // Rule ID 14993 //
     /* 1131231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1131242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1131245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1131248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1131251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131270 */     // MIs[0] round
     /* 1131270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1131283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131305 */     // GIR_Coverage, 14993,
     /* 1131305 */     GIR_EraseRootFromParent_Done,
     /* 1131306 */   // Label 16568: @1131306
     /* 1131306 */   GIM_Try, /*On fail goto*//*Label 16569*/ GIMT_Encode4(1131386), // Rule ID 14996 //
     /* 1131311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1131322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1131325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1131328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1131331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131350 */     // MIs[0] round
     /* 1131350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131360 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131385 */     // GIR_Coverage, 14996,
     /* 1131385 */     GIR_EraseRootFromParent_Done,
     /* 1131386 */   // Label 16569: @1131386
     /* 1131386 */   GIM_Try, /*On fail goto*//*Label 16570*/ GIMT_Encode4(1131466), // Rule ID 14997 //
     /* 1131391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1131402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1131405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1131408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1131411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131430 */     // MIs[0] round
     /* 1131430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1131461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131465 */     // GIR_Coverage, 14997,
     /* 1131465 */     GIR_EraseRootFromParent_Done,
     /* 1131466 */   // Label 16570: @1131466
     /* 1131466 */   GIM_Try, /*On fail goto*//*Label 16571*/ GIMT_Encode4(1131546), // Rule ID 15000 //
     /* 1131471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1131482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1131485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1131488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1131491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131510 */     // MIs[0] round
     /* 1131510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1131523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131545 */     // GIR_Coverage, 15000,
     /* 1131545 */     GIR_EraseRootFromParent_Done,
     /* 1131546 */   // Label 16571: @1131546
     /* 1131546 */   GIM_Try, /*On fail goto*//*Label 16572*/ GIMT_Encode4(1131626), // Rule ID 15001 //
     /* 1131551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1131562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1131565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1131568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1131571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131590 */     // MIs[0] round
     /* 1131590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131600 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4),
     /* 1131603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131625 */     // GIR_Coverage, 15001,
     /* 1131625 */     GIR_EraseRootFromParent_Done,
     /* 1131626 */   // Label 16572: @1131626
     /* 1131626 */   GIM_Try, /*On fail goto*//*Label 16573*/ GIMT_Encode4(1131706), // Rule ID 15004 //
     /* 1131631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1131642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1131645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1131648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1131651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131670 */     // MIs[0] round
     /* 1131670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131680 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131705 */     // GIR_Coverage, 15004,
     /* 1131705 */     GIR_EraseRootFromParent_Done,
     /* 1131706 */   // Label 16573: @1131706
     /* 1131706 */   GIM_Try, /*On fail goto*//*Label 16574*/ GIMT_Encode4(1131786), // Rule ID 15005 //
     /* 1131711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1131722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1131725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1131728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1131731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131750 */     // MIs[0] round
     /* 1131750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1131781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131785 */     // GIR_Coverage, 15005,
     /* 1131785 */     GIR_EraseRootFromParent_Done,
     /* 1131786 */   // Label 16574: @1131786
     /* 1131786 */   GIM_Try, /*On fail goto*//*Label 16575*/ GIMT_Encode4(1131866), // Rule ID 15008 //
     /* 1131791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1131802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1131805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1131808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1131811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131830 */     // MIs[0] round
     /* 1131830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1131840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131865 */     // GIR_Coverage, 15008,
     /* 1131865 */     GIR_EraseRootFromParent_Done,
     /* 1131866 */   // Label 16575: @1131866
     /* 1131866 */   GIM_Try, /*On fail goto*//*Label 16576*/ GIMT_Encode4(1131946), // Rule ID 15009 //
     /* 1131871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1131874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1131882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1131885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1131888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1131891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1131894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131910 */     // MIs[0] round
     /* 1131910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1131920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1131920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2),
     /* 1131923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1131925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1131927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1131929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1131931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1131933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1131938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1131941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1131944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1131945 */     // GIR_Coverage, 15009,
     /* 1131945 */     GIR_EraseRootFromParent_Done,
     /* 1131946 */   // Label 16576: @1131946
     /* 1131946 */   GIM_Try, /*On fail goto*//*Label 16577*/ GIMT_Encode4(1132026), // Rule ID 15012 //
     /* 1131951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1131954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1131959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1131962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1131965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1131968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1131971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1131974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1131990 */     // MIs[0] round
     /* 1131990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1131993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132025 */     // GIR_Coverage, 15012,
     /* 1132025 */     GIR_EraseRootFromParent_Done,
     /* 1132026 */   // Label 16577: @1132026
     /* 1132026 */   GIM_Try, /*On fail goto*//*Label 16578*/ GIMT_Encode4(1132106), // Rule ID 15013 //
     /* 1132031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1132042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1132045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1132048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1132051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132070 */     // MIs[0] round
     /* 1132070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132080 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132105 */     // GIR_Coverage, 15013,
     /* 1132105 */     GIR_EraseRootFromParent_Done,
     /* 1132106 */   // Label 16578: @1132106
     /* 1132106 */   GIM_Try, /*On fail goto*//*Label 16579*/ GIMT_Encode4(1132186), // Rule ID 15016 //
     /* 1132111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1132122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1132125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1132128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1132131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132150 */     // MIs[0] round
     /* 1132150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132160 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132185 */     // GIR_Coverage, 15016,
     /* 1132185 */     GIR_EraseRootFromParent_Done,
     /* 1132186 */   // Label 16579: @1132186
     /* 1132186 */   GIM_Try, /*On fail goto*//*Label 16580*/ GIMT_Encode4(1132266), // Rule ID 15017 //
     /* 1132191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1132202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1132205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1132208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1132211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132230 */     // MIs[0] round
     /* 1132230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1132261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132265 */     // GIR_Coverage, 15017,
     /* 1132265 */     GIR_EraseRootFromParent_Done,
     /* 1132266 */   // Label 16580: @1132266
     /* 1132266 */   GIM_Try, /*On fail goto*//*Label 16581*/ GIMT_Encode4(1132346), // Rule ID 15020 //
     /* 1132271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1132288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132310 */     // MIs[0] round
     /* 1132310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132345 */     // GIR_Coverage, 15020,
     /* 1132345 */     GIR_EraseRootFromParent_Done,
     /* 1132346 */   // Label 16581: @1132346
     /* 1132346 */   GIM_Try, /*On fail goto*//*Label 16582*/ GIMT_Encode4(1132426), // Rule ID 15021 //
     /* 1132351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1132362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1132365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1132368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1132371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132390 */     // MIs[0] round
     /* 1132390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1132421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132425 */     // GIR_Coverage, 15021,
     /* 1132425 */     GIR_EraseRootFromParent_Done,
     /* 1132426 */   // Label 16582: @1132426
     /* 1132426 */   GIM_Try, /*On fail goto*//*Label 16583*/ GIMT_Encode4(1132506), // Rule ID 15024 //
     /* 1132431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1132434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1132448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132470 */     // MIs[0] round
     /* 1132470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132480 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132505 */     // GIR_Coverage, 15024,
     /* 1132505 */     GIR_EraseRootFromParent_Done,
     /* 1132506 */   // Label 16583: @1132506
     /* 1132506 */   GIM_Try, /*On fail goto*//*Label 16584*/ GIMT_Encode4(1132586), // Rule ID 15025 //
     /* 1132511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1132514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1132522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1132525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1132528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1132531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1132550 */     // MIs[0] round
     /* 1132550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1),
     /* 1132563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1132581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132585 */     // GIR_Coverage, 15025,
     /* 1132585 */     GIR_EraseRootFromParent_Done,
     /* 1132586 */   // Label 16584: @1132586
     /* 1132586 */   GIM_Try, /*On fail goto*//*Label 16585*/ GIMT_Encode4(1132666), // Rule ID 15028 //
     /* 1132591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1132602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1132605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1132608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1132611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132630 */     // MIs[0] round
     /* 1132630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1132643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132665 */     // GIR_Coverage, 15028,
     /* 1132665 */     GIR_EraseRootFromParent_Done,
     /* 1132666 */   // Label 16585: @1132666
     /* 1132666 */   GIM_Try, /*On fail goto*//*Label 16586*/ GIMT_Encode4(1132746), // Rule ID 15029 //
     /* 1132671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1132682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1132685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1132688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1132691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1132710 */     // MIs[0] round
     /* 1132710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1132723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132745 */     // GIR_Coverage, 15029,
     /* 1132745 */     GIR_EraseRootFromParent_Done,
     /* 1132746 */   // Label 16586: @1132746
     /* 1132746 */   GIM_Try, /*On fail goto*//*Label 16587*/ GIMT_Encode4(1132826), // Rule ID 15032 //
     /* 1132751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1132762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1132765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1132768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1132771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132790 */     // MIs[0] round
     /* 1132790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132800 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1132803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132825 */     // GIR_Coverage, 15032,
     /* 1132825 */     GIR_EraseRootFromParent_Done,
     /* 1132826 */   // Label 16587: @1132826
     /* 1132826 */   GIM_Try, /*On fail goto*//*Label 16588*/ GIMT_Encode4(1132906), // Rule ID 15033 //
     /* 1132831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1132842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1132845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1132848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1132851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1132854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1132870 */     // MIs[0] round
     /* 1132870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132880 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1132880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1132883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132905 */     // GIR_Coverage, 15033,
     /* 1132905 */     GIR_EraseRootFromParent_Done,
     /* 1132906 */   // Label 16588: @1132906
     /* 1132906 */   GIM_Try, /*On fail goto*//*Label 16589*/ GIMT_Encode4(1132986), // Rule ID 15036 //
     /* 1132911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1132914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1132922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1132925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1132928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1132931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1132934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1132950 */     // MIs[0] round
     /* 1132950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1132953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1132960 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1132960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1132963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1132965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1132967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1132969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1132971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1132973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1132978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1132981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1132984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1132985 */     // GIR_Coverage, 15036,
     /* 1132985 */     GIR_EraseRootFromParent_Done,
     /* 1132986 */   // Label 16589: @1132986
     /* 1132986 */   GIM_Try, /*On fail goto*//*Label 16590*/ GIMT_Encode4(1133066), // Rule ID 15037 //
     /* 1132991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1132994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1132999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1133002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1133005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1133008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1133011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133030 */     // MIs[0] round
     /* 1133030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1133043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1133061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133065 */     // GIR_Coverage, 15037,
     /* 1133065 */     GIR_EraseRootFromParent_Done,
     /* 1133066 */   // Label 16590: @1133066
     /* 1133066 */   GIM_Try, /*On fail goto*//*Label 16591*/ GIMT_Encode4(1133146), // Rule ID 15040 //
     /* 1133071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1133082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1133085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1133088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1133091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133110 */     // MIs[0] round
     /* 1133110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1133123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133145 */     // GIR_Coverage, 15040,
     /* 1133145 */     GIR_EraseRootFromParent_Done,
     /* 1133146 */   // Label 16591: @1133146
     /* 1133146 */   GIM_Try, /*On fail goto*//*Label 16592*/ GIMT_Encode4(1133226), // Rule ID 15041 //
     /* 1133151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1133162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1133165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1133168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1133171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133190 */     // MIs[0] round
     /* 1133190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1133203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133225 */     // GIR_Coverage, 15041,
     /* 1133225 */     GIR_EraseRootFromParent_Done,
     /* 1133226 */   // Label 16592: @1133226
     /* 1133226 */   GIM_Try, /*On fail goto*//*Label 16593*/ GIMT_Encode4(1133306), // Rule ID 15044 //
     /* 1133231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1133242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1133245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1133248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1133251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133270 */     // MIs[0] round
     /* 1133270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1133283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133305 */     // GIR_Coverage, 15044,
     /* 1133305 */     GIR_EraseRootFromParent_Done,
     /* 1133306 */   // Label 16593: @1133306
     /* 1133306 */   GIM_Try, /*On fail goto*//*Label 16594*/ GIMT_Encode4(1133386), // Rule ID 15045 //
     /* 1133311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1133322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1133325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1133328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1133331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133350 */     // MIs[0] round
     /* 1133350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1133363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133385 */     // GIR_Coverage, 15045,
     /* 1133385 */     GIR_EraseRootFromParent_Done,
     /* 1133386 */   // Label 16594: @1133386
     /* 1133386 */   GIM_Try, /*On fail goto*//*Label 16595*/ GIMT_Encode4(1133466), // Rule ID 15048 //
     /* 1133391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1133402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1133405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1133408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1133411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133430 */     // MIs[0] round
     /* 1133430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133440 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1133443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133465 */     // GIR_Coverage, 15048,
     /* 1133465 */     GIR_EraseRootFromParent_Done,
     /* 1133466 */   // Label 16595: @1133466
     /* 1133466 */   GIM_Try, /*On fail goto*//*Label 16596*/ GIMT_Encode4(1133546), // Rule ID 15049 //
     /* 1133471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1133482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1133485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1133488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1133491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133510 */     // MIs[0] round
     /* 1133510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133520 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1133523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1133541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133545 */     // GIR_Coverage, 15049,
     /* 1133545 */     GIR_EraseRootFromParent_Done,
     /* 1133546 */   // Label 16596: @1133546
     /* 1133546 */   GIM_Try, /*On fail goto*//*Label 16597*/ GIMT_Encode4(1133626), // Rule ID 15052 //
     /* 1133551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1133562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1133565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1133568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1133571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133590 */     // MIs[0] round
     /* 1133590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1133603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133625 */     // GIR_Coverage, 15052,
     /* 1133625 */     GIR_EraseRootFromParent_Done,
     /* 1133626 */   // Label 16597: @1133626
     /* 1133626 */   GIM_Try, /*On fail goto*//*Label 16598*/ GIMT_Encode4(1133706), // Rule ID 15053 //
     /* 1133631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1133642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1133645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1133648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1133651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1133670 */     // MIs[0] round
     /* 1133670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1133683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133705 */     // GIR_Coverage, 15053,
     /* 1133705 */     GIR_EraseRootFromParent_Done,
     /* 1133706 */   // Label 16598: @1133706
     /* 1133706 */   GIM_Try, /*On fail goto*//*Label 16599*/ GIMT_Encode4(1133786), // Rule ID 15056 //
     /* 1133711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1133722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1133725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1133728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1133731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133750 */     // MIs[0] round
     /* 1133750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1133763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133785 */     // GIR_Coverage, 15056,
     /* 1133785 */     GIR_EraseRootFromParent_Done,
     /* 1133786 */   // Label 16599: @1133786
     /* 1133786 */   GIM_Try, /*On fail goto*//*Label 16600*/ GIMT_Encode4(1133866), // Rule ID 15057 //
     /* 1133791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1133802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1133805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1133808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1133811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1133830 */     // MIs[0] round
     /* 1133830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1133840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1133843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133865 */     // GIR_Coverage, 15057,
     /* 1133865 */     GIR_EraseRootFromParent_Done,
     /* 1133866 */   // Label 16600: @1133866
     /* 1133866 */   GIM_Try, /*On fail goto*//*Label 16601*/ GIMT_Encode4(1133946), // Rule ID 15060 //
     /* 1133871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1133874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1133882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1133885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1133888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1133891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1133894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133910 */     // MIs[0] round
     /* 1133910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1133920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1133920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1133923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1133925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1133927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1133929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1133931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1133933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1133938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1133941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1133944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1133945 */     // GIR_Coverage, 15060,
     /* 1133945 */     GIR_EraseRootFromParent_Done,
     /* 1133946 */   // Label 16601: @1133946
     /* 1133946 */   GIM_Try, /*On fail goto*//*Label 16602*/ GIMT_Encode4(1134026), // Rule ID 15061 //
     /* 1133951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1133954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1133959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1133962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1133965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1133968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1133971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1133974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1133990 */     // MIs[0] round
     /* 1133990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1133993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1134003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1134021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134025 */     // GIR_Coverage, 15061,
     /* 1134025 */     GIR_EraseRootFromParent_Done,
     /* 1134026 */   // Label 16602: @1134026
     /* 1134026 */   GIM_Try, /*On fail goto*//*Label 16603*/ GIMT_Encode4(1134106), // Rule ID 15064 //
     /* 1134031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1134042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1134045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1134048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1134051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134070 */     // MIs[0] round
     /* 1134070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1134083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134105 */     // GIR_Coverage, 15064,
     /* 1134105 */     GIR_EraseRootFromParent_Done,
     /* 1134106 */   // Label 16603: @1134106
     /* 1134106 */   GIM_Try, /*On fail goto*//*Label 16604*/ GIMT_Encode4(1134186), // Rule ID 15065 //
     /* 1134111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1134122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1134125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1134128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1134131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1134150 */     // MIs[0] round
     /* 1134150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2),
     /* 1134163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134185 */     // GIR_Coverage, 15065,
     /* 1134185 */     GIR_EraseRootFromParent_Done,
     /* 1134186 */   // Label 16604: @1134186
     /* 1134186 */   GIM_Try, /*On fail goto*//*Label 16605*/ GIMT_Encode4(1134266), // Rule ID 15068 //
     /* 1134191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1134202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1134205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1134208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1134211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134230 */     // MIs[0] round
     /* 1134230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134240 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1134243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134265 */     // GIR_Coverage, 15068,
     /* 1134265 */     GIR_EraseRootFromParent_Done,
     /* 1134266 */   // Label 16605: @1134266
     /* 1134266 */   GIM_Try, /*On fail goto*//*Label 16606*/ GIMT_Encode4(1134346), // Rule ID 15069 //
     /* 1134271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1134282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1134285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1134288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1134291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1134310 */     // MIs[0] round
     /* 1134310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4),
     /* 1134323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134345 */     // GIR_Coverage, 15069,
     /* 1134345 */     GIR_EraseRootFromParent_Done,
     /* 1134346 */   // Label 16606: @1134346
     /* 1134346 */   GIM_Try, /*On fail goto*//*Label 16607*/ GIMT_Encode4(1134426), // Rule ID 15072 //
     /* 1134351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1134354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1134362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1134365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1134368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1134371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134390 */     // MIs[0] round
     /* 1134390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134400 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1134403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134425 */     // GIR_Coverage, 15072,
     /* 1134425 */     GIR_EraseRootFromParent_Done,
     /* 1134426 */   // Label 16607: @1134426
     /* 1134426 */   GIM_Try, /*On fail goto*//*Label 16608*/ GIMT_Encode4(1134506), // Rule ID 15073 //
     /* 1134431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1134434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1134442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1134445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1134448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1134451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1134470 */     // MIs[0] round
     /* 1134470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8),
     /* 1134483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1134501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134505 */     // GIR_Coverage, 15073,
     /* 1134505 */     GIR_EraseRootFromParent_Done,
     /* 1134506 */   // Label 16608: @1134506
     /* 1134506 */   GIM_Try, /*On fail goto*//*Label 16609*/ GIMT_Encode4(1134586), // Rule ID 15076 //
     /* 1134511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1134522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1134525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1134528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134550 */     // MIs[0] round
     /* 1134550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134560 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1134563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134585 */     // GIR_Coverage, 15076,
     /* 1134585 */     GIR_EraseRootFromParent_Done,
     /* 1134586 */   // Label 16609: @1134586
     /* 1134586 */   GIM_Try, /*On fail goto*//*Label 16610*/ GIMT_Encode4(1134666), // Rule ID 15077 //
     /* 1134591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1134602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1134605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1134608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134630 */     // MIs[0] round
     /* 1134630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8),
     /* 1134643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134665 */     // GIR_Coverage, 15077,
     /* 1134665 */     GIR_EraseRootFromParent_Done,
     /* 1134666 */   // Label 16610: @1134666
     /* 1134666 */   GIM_Try, /*On fail goto*//*Label 16611*/ GIMT_Encode4(1134746), // Rule ID 15080 //
     /* 1134671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1134682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1134685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1134688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134710 */     // MIs[0] round
     /* 1134710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134720 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1134723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134745 */     // GIR_Coverage, 15080,
     /* 1134745 */     GIR_EraseRootFromParent_Done,
     /* 1134746 */   // Label 16611: @1134746
     /* 1134746 */   GIM_Try, /*On fail goto*//*Label 16612*/ GIMT_Encode4(1134826), // Rule ID 15081 //
     /* 1134751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1134762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1134765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1134768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134790 */     // MIs[0] round
     /* 1134790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1134803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134825 */     // GIR_Coverage, 15081,
     /* 1134825 */     GIR_EraseRootFromParent_Done,
     /* 1134826 */   // Label 16612: @1134826
     /* 1134826 */   GIM_Try, /*On fail goto*//*Label 16613*/ GIMT_Encode4(1134906), // Rule ID 15084 //
     /* 1134831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1134842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1134845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1134848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1134851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1134854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134870 */     // MIs[0] round
     /* 1134870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134880 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1134880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1134883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134905 */     // GIR_Coverage, 15084,
     /* 1134905 */     GIR_EraseRootFromParent_Done,
     /* 1134906 */   // Label 16613: @1134906
     /* 1134906 */   GIM_Try, /*On fail goto*//*Label 16614*/ GIMT_Encode4(1134986), // Rule ID 15085 //
     /* 1134911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1134914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1134922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1134925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1134928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1134931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1134934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1134946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1134950 */     // MIs[0] round
     /* 1134950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1134953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1134960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1134960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1134963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1134965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1134967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1134969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1134971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1134973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1134978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1134981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1134984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1134985 */     // GIR_Coverage, 15085,
     /* 1134985 */     GIR_EraseRootFromParent_Done,
     /* 1134986 */   // Label 16614: @1134986
     /* 1134986 */   GIM_Try, /*On fail goto*//*Label 16615*/ GIMT_Encode4(1135066), // Rule ID 15088 //
     /* 1134991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1134994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1134999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1135002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1135005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1135008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135030 */     // MIs[0] round
     /* 1135030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1135043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135065 */     // GIR_Coverage, 15088,
     /* 1135065 */     GIR_EraseRootFromParent_Done,
     /* 1135066 */   // Label 16615: @1135066
     /* 1135066 */   GIM_Try, /*On fail goto*//*Label 16616*/ GIMT_Encode4(1135146), // Rule ID 15089 //
     /* 1135071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1135082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1135085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1135088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135110 */     // MIs[0] round
     /* 1135110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4),
     /* 1135123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135145 */     // GIR_Coverage, 15089,
     /* 1135145 */     GIR_EraseRootFromParent_Done,
     /* 1135146 */   // Label 16616: @1135146
     /* 1135146 */   GIM_Try, /*On fail goto*//*Label 16617*/ GIMT_Encode4(1135226), // Rule ID 15092 //
     /* 1135151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1135162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1135165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1135168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135190 */     // MIs[0] round
     /* 1135190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1135203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135225 */     // GIR_Coverage, 15092,
     /* 1135225 */     GIR_EraseRootFromParent_Done,
     /* 1135226 */   // Label 16617: @1135226
     /* 1135226 */   GIM_Try, /*On fail goto*//*Label 16618*/ GIMT_Encode4(1135306), // Rule ID 15093 //
     /* 1135231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1135242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1135245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1135248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135270 */     // MIs[0] round
     /* 1135270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1135283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135305 */     // GIR_Coverage, 15093,
     /* 1135305 */     GIR_EraseRootFromParent_Done,
     /* 1135306 */   // Label 16618: @1135306
     /* 1135306 */   GIM_Try, /*On fail goto*//*Label 16619*/ GIMT_Encode4(1135386), // Rule ID 15096 //
     /* 1135311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1135322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1135325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1135328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135350 */     // MIs[0] round
     /* 1135350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135360 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1135363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135385 */     // GIR_Coverage, 15096,
     /* 1135385 */     GIR_EraseRootFromParent_Done,
     /* 1135386 */   // Label 16619: @1135386
     /* 1135386 */   GIM_Try, /*On fail goto*//*Label 16620*/ GIMT_Encode4(1135466), // Rule ID 15097 //
     /* 1135391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1135402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1135405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1135408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135430 */     // MIs[0] round
     /* 1135430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2),
     /* 1135443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135465 */     // GIR_Coverage, 15097,
     /* 1135465 */     GIR_EraseRootFromParent_Done,
     /* 1135466 */   // Label 16620: @1135466
     /* 1135466 */   GIM_Try, /*On fail goto*//*Label 16621*/ GIMT_Encode4(1135546), // Rule ID 15100 //
     /* 1135471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1135482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1135485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1135488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135510 */     // MIs[0] round
     /* 1135510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135545 */     // GIR_Coverage, 15100,
     /* 1135545 */     GIR_EraseRootFromParent_Done,
     /* 1135546 */   // Label 16621: @1135546
     /* 1135546 */   GIM_Try, /*On fail goto*//*Label 16622*/ GIMT_Encode4(1135626), // Rule ID 15101 //
     /* 1135551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1135562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1135565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1135568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135590 */     // MIs[0] round
     /* 1135590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11093:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1135621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135625 */     // GIR_Coverage, 15101,
     /* 1135625 */     GIR_EraseRootFromParent_Done,
     /* 1135626 */   // Label 16622: @1135626
     /* 1135626 */   GIM_Try, /*On fail goto*//*Label 16623*/ GIMT_Encode4(1135706), // Rule ID 15104 //
     /* 1135631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1135642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1135645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1135648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135670 */     // MIs[0] round
     /* 1135670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135680 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135705 */     // GIR_Coverage, 15104,
     /* 1135705 */     GIR_EraseRootFromParent_Done,
     /* 1135706 */   // Label 16623: @1135706
     /* 1135706 */   GIM_Try, /*On fail goto*//*Label 16624*/ GIMT_Encode4(1135786), // Rule ID 15105 //
     /* 1135711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1135722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1135725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1135728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135750 */     // MIs[0] round
     /* 1135750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135760 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11093:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1135781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135785 */     // GIR_Coverage, 15105,
     /* 1135785 */     GIR_EraseRootFromParent_Done,
     /* 1135786 */   // Label 16624: @1135786
     /* 1135786 */   GIM_Try, /*On fail goto*//*Label 16625*/ GIMT_Encode4(1135866), // Rule ID 15108 //
     /* 1135791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1135794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1135808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135830 */     // MIs[0] round
     /* 1135830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1135840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135865 */     // GIR_Coverage, 15108,
     /* 1135865 */     GIR_EraseRootFromParent_Done,
     /* 1135866 */   // Label 16625: @1135866
     /* 1135866 */   GIM_Try, /*On fail goto*//*Label 16626*/ GIMT_Encode4(1135946), // Rule ID 15109 //
     /* 1135871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1135874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1135882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1135885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1135888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1135891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1135894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135910 */     // MIs[0] round
     /* 1135910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1135920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11093:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1135920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1135923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1135925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1135927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1135929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1135931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1135933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1135938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1135941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1135944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1135945 */     // GIR_Coverage, 15109,
     /* 1135945 */     GIR_EraseRootFromParent_Done,
     /* 1135946 */   // Label 16626: @1135946
     /* 1135946 */   GIM_Try, /*On fail goto*//*Label 16627*/ GIMT_Encode4(1136026), // Rule ID 15112 //
     /* 1135951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1135954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1135959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1135962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1135965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1135968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1135971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1135974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1135986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1135990 */     // MIs[0] round
     /* 1135990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1135993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136000 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1136003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136025 */     // GIR_Coverage, 15112,
     /* 1136025 */     GIR_EraseRootFromParent_Done,
     /* 1136026 */   // Label 16627: @1136026
     /* 1136026 */   GIM_Try, /*On fail goto*//*Label 16628*/ GIMT_Encode4(1136106), // Rule ID 15113 //
     /* 1136031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1136034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1136042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1136045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1136048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1136066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136070 */     // MIs[0] round
     /* 1136070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11093:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1),
     /* 1136083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1136101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136105 */     // GIR_Coverage, 15113,
     /* 1136105 */     GIR_EraseRootFromParent_Done,
     /* 1136106 */   // Label 16628: @1136106
     /* 1136106 */   GIM_Try, /*On fail goto*//*Label 16629*/ GIMT_Encode4(1136186), // Rule ID 15116 //
     /* 1136111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1136122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1136125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1136128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136150 */     // MIs[0] round
     /* 1136150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1136163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136185 */     // GIR_Coverage, 15116,
     /* 1136185 */     GIR_EraseRootFromParent_Done,
     /* 1136186 */   // Label 16629: @1136186
     /* 1136186 */   GIM_Try, /*On fail goto*//*Label 16630*/ GIMT_Encode4(1136266), // Rule ID 15117 //
     /* 1136191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1136202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1136205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1136208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136230 */     // MIs[0] round
     /* 1136230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1136243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136265 */     // GIR_Coverage, 15117,
     /* 1136265 */     GIR_EraseRootFromParent_Done,
     /* 1136266 */   // Label 16630: @1136266
     /* 1136266 */   GIM_Try, /*On fail goto*//*Label 16631*/ GIMT_Encode4(1136346), // Rule ID 15120 //
     /* 1136271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1136282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1136285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1136288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136310 */     // MIs[0] round
     /* 1136310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1136323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136345 */     // GIR_Coverage, 15120,
     /* 1136345 */     GIR_EraseRootFromParent_Done,
     /* 1136346 */   // Label 16631: @1136346
     /* 1136346 */   GIM_Try, /*On fail goto*//*Label 16632*/ GIMT_Encode4(1136426), // Rule ID 15121 //
     /* 1136351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1136362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1136365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1136368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136390 */     // MIs[0] round
     /* 1136390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136400 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1136403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136425 */     // GIR_Coverage, 15121,
     /* 1136425 */     GIR_EraseRootFromParent_Done,
     /* 1136426 */   // Label 16632: @1136426
     /* 1136426 */   GIM_Try, /*On fail goto*//*Label 16633*/ GIMT_Encode4(1136506), // Rule ID 15124 //
     /* 1136431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1136442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1136445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1136448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136470 */     // MIs[0] round
     /* 1136470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136480 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1136483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136505 */     // GIR_Coverage, 15124,
     /* 1136505 */     GIR_EraseRootFromParent_Done,
     /* 1136506 */   // Label 16633: @1136506
     /* 1136506 */   GIM_Try, /*On fail goto*//*Label 16634*/ GIMT_Encode4(1136586), // Rule ID 15125 //
     /* 1136511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1136522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1136525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1136528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136550 */     // MIs[0] round
     /* 1136550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136560 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1136563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1136581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136585 */     // GIR_Coverage, 15125,
     /* 1136585 */     GIR_EraseRootFromParent_Done,
     /* 1136586 */   // Label 16634: @1136586
     /* 1136586 */   GIM_Try, /*On fail goto*//*Label 16635*/ GIMT_Encode4(1136666), // Rule ID 15128 //
     /* 1136591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1136602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1136605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1136608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136630 */     // MIs[0] round
     /* 1136630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1136643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136665 */     // GIR_Coverage, 15128,
     /* 1136665 */     GIR_EraseRootFromParent_Done,
     /* 1136666 */   // Label 16635: @1136666
     /* 1136666 */   GIM_Try, /*On fail goto*//*Label 16636*/ GIMT_Encode4(1136746), // Rule ID 15129 //
     /* 1136671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1136682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1136685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1136688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1136706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136710 */     // MIs[0] round
     /* 1136710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1136723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136745 */     // GIR_Coverage, 15129,
     /* 1136745 */     GIR_EraseRootFromParent_Done,
     /* 1136746 */   // Label 16636: @1136746
     /* 1136746 */   GIM_Try, /*On fail goto*//*Label 16637*/ GIMT_Encode4(1136826), // Rule ID 15132 //
     /* 1136751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1136762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1136765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1136768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136790 */     // MIs[0] round
     /* 1136790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1136803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136825 */     // GIR_Coverage, 15132,
     /* 1136825 */     GIR_EraseRootFromParent_Done,
     /* 1136826 */   // Label 16637: @1136826
     /* 1136826 */   GIM_Try, /*On fail goto*//*Label 16638*/ GIMT_Encode4(1136906), // Rule ID 15133 //
     /* 1136831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1136842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1136845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1136848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1136851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1136854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1136866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136870 */     // MIs[0] round
     /* 1136870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136880 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1136880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1136883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136905 */     // GIR_Coverage, 15133,
     /* 1136905 */     GIR_EraseRootFromParent_Done,
     /* 1136906 */   // Label 16638: @1136906
     /* 1136906 */   GIM_Try, /*On fail goto*//*Label 16639*/ GIMT_Encode4(1136986), // Rule ID 15136 //
     /* 1136911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1136914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1136922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1136925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1136928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1136931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1136934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1136946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1136950 */     // MIs[0] round
     /* 1136950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1136953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1136960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1136960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1136963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1136965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1136967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1136969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1136971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1136973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1136978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1136981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1136984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1136985 */     // GIR_Coverage, 15136,
     /* 1136985 */     GIR_EraseRootFromParent_Done,
     /* 1136986 */   // Label 16639: @1136986
     /* 1136986 */   GIM_Try, /*On fail goto*//*Label 16640*/ GIMT_Encode4(1137066), // Rule ID 15137 //
     /* 1136991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1136994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1136999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1137002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1137005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1137008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137030 */     // MIs[0] round
     /* 1137030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1137043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1137061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137065 */     // GIR_Coverage, 15137,
     /* 1137065 */     GIR_EraseRootFromParent_Done,
     /* 1137066 */   // Label 16640: @1137066
     /* 1137066 */   GIM_Try, /*On fail goto*//*Label 16641*/ GIMT_Encode4(1137146), // Rule ID 15140 //
     /* 1137071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1137082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1137085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1137088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137110 */     // MIs[0] round
     /* 1137110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137120 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1137123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137145 */     // GIR_Coverage, 15140,
     /* 1137145 */     GIR_EraseRootFromParent_Done,
     /* 1137146 */   // Label 16641: @1137146
     /* 1137146 */   GIM_Try, /*On fail goto*//*Label 16642*/ GIMT_Encode4(1137226), // Rule ID 15141 //
     /* 1137151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1137162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1137165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1137168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137190 */     // MIs[0] round
     /* 1137190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1137203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137225 */     // GIR_Coverage, 15141,
     /* 1137225 */     GIR_EraseRootFromParent_Done,
     /* 1137226 */   // Label 16642: @1137226
     /* 1137226 */   GIM_Try, /*On fail goto*//*Label 16643*/ GIMT_Encode4(1137306), // Rule ID 15144 //
     /* 1137231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1137242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1137245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1137248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137270 */     // MIs[0] round
     /* 1137270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1137283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137305 */     // GIR_Coverage, 15144,
     /* 1137305 */     GIR_EraseRootFromParent_Done,
     /* 1137306 */   // Label 16643: @1137306
     /* 1137306 */   GIM_Try, /*On fail goto*//*Label 16644*/ GIMT_Encode4(1137386), // Rule ID 15145 //
     /* 1137311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1137322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1137325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1137328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137350 */     // MIs[0] round
     /* 1137350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1137363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137385 */     // GIR_Coverage, 15145,
     /* 1137385 */     GIR_EraseRootFromParent_Done,
     /* 1137386 */   // Label 16644: @1137386
     /* 1137386 */   GIM_Try, /*On fail goto*//*Label 16645*/ GIMT_Encode4(1137466), // Rule ID 15148 //
     /* 1137391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1137394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1137402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1137405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1137408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137430 */     // MIs[0] round
     /* 1137430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1137443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137465 */     // GIR_Coverage, 15148,
     /* 1137465 */     GIR_EraseRootFromParent_Done,
     /* 1137466 */   // Label 16645: @1137466
     /* 1137466 */   GIM_Try, /*On fail goto*//*Label 16646*/ GIMT_Encode4(1137546), // Rule ID 15149 //
     /* 1137471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1137474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1137482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1137485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1137488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137510 */     // MIs[0] round
     /* 1137510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1137523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1137541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137545 */     // GIR_Coverage, 15149,
     /* 1137545 */     GIR_EraseRootFromParent_Done,
     /* 1137546 */   // Label 16646: @1137546
     /* 1137546 */   GIM_Try, /*On fail goto*//*Label 16647*/ GIMT_Encode4(1137626), // Rule ID 15152 //
     /* 1137551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1137562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1137565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1137568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137590 */     // MIs[0] round
     /* 1137590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137600 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1137603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137625 */     // GIR_Coverage, 15152,
     /* 1137625 */     GIR_EraseRootFromParent_Done,
     /* 1137626 */   // Label 16647: @1137626
     /* 1137626 */   GIM_Try, /*On fail goto*//*Label 16648*/ GIMT_Encode4(1137706), // Rule ID 15153 //
     /* 1137631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1137642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1137645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1137648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1137666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137670 */     // MIs[0] round
     /* 1137670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11093:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2),
     /* 1137683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137705 */     // GIR_Coverage, 15153,
     /* 1137705 */     GIR_EraseRootFromParent_Done,
     /* 1137706 */   // Label 16648: @1137706
     /* 1137706 */   GIM_Try, /*On fail goto*//*Label 16649*/ GIMT_Encode4(1137786), // Rule ID 15156 //
     /* 1137711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1137722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1137725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1137728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137750 */     // MIs[0] round
     /* 1137750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1137763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137785 */     // GIR_Coverage, 15156,
     /* 1137785 */     GIR_EraseRootFromParent_Done,
     /* 1137786 */   // Label 16649: @1137786
     /* 1137786 */   GIM_Try, /*On fail goto*//*Label 16650*/ GIMT_Encode4(1137866), // Rule ID 15157 //
     /* 1137791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1137802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1137805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1137808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1137826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137830 */     // MIs[0] round
     /* 1137830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11093:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1137840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4),
     /* 1137843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137865 */     // GIR_Coverage, 15157,
     /* 1137865 */     GIR_EraseRootFromParent_Done,
     /* 1137866 */   // Label 16650: @1137866
     /* 1137866 */   GIM_Try, /*On fail goto*//*Label 16651*/ GIMT_Encode4(1137946), // Rule ID 15160 //
     /* 1137871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1137874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1137882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1137885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1137888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1137891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1137894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137910 */     // MIs[0] round
     /* 1137910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1137920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1137920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1137923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1137925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1137927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1137929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1137931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1137933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1137938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1137941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1137944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1137945 */     // GIR_Coverage, 15160,
     /* 1137945 */     GIR_EraseRootFromParent_Done,
     /* 1137946 */   // Label 16651: @1137946
     /* 1137946 */   GIM_Try, /*On fail goto*//*Label 16652*/ GIMT_Encode4(1138026), // Rule ID 15161 //
     /* 1137951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1137954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu),
     /* 1137959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1137962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1137965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1137968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1137971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1137974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1137986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1137990 */     // MIs[0] round
     /* 1137990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1137993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138000 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11093:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUBU_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8),
     /* 1138003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1138021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138025 */     // GIR_Coverage, 15161,
     /* 1138025 */     GIR_EraseRootFromParent_Done,
     /* 1138026 */   // Label 16652: @1138026
     /* 1138026 */   GIM_Try, /*On fail goto*//*Label 16653*/ GIMT_Encode4(1138106), // Rule ID 15164 //
     /* 1138031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1138042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1138045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1138051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138070 */     // MIs[0] round
     /* 1138070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1138083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138105 */     // GIR_Coverage, 15164,
     /* 1138105 */     GIR_EraseRootFromParent_Done,
     /* 1138106 */   // Label 16653: @1138106
     /* 1138106 */   GIM_Try, /*On fail goto*//*Label 16654*/ GIMT_Encode4(1138186), // Rule ID 15165 //
     /* 1138111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1138122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1138125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1138128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1138131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138150 */     // MIs[0] round
     /* 1138150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8),
     /* 1138163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138185 */     // GIR_Coverage, 15165,
     /* 1138185 */     GIR_EraseRootFromParent_Done,
     /* 1138186 */   // Label 16654: @1138186
     /* 1138186 */   GIM_Try, /*On fail goto*//*Label 16655*/ GIMT_Encode4(1138266), // Rule ID 15168 //
     /* 1138191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1138202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1138205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1138208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1138211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138230 */     // MIs[0] round
     /* 1138230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1138243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138265 */     // GIR_Coverage, 15168,
     /* 1138265 */     GIR_EraseRootFromParent_Done,
     /* 1138266 */   // Label 16655: @1138266
     /* 1138266 */   GIM_Try, /*On fail goto*//*Label 16656*/ GIMT_Encode4(1138346), // Rule ID 15169 //
     /* 1138271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1138282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1138285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1138288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1138291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138310 */     // MIs[0] round
     /* 1138310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138320 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1138323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138345 */     // GIR_Coverage, 15169,
     /* 1138345 */     GIR_EraseRootFromParent_Done,
     /* 1138346 */   // Label 16656: @1138346
     /* 1138346 */   GIM_Try, /*On fail goto*//*Label 16657*/ GIMT_Encode4(1138426), // Rule ID 15172 //
     /* 1138351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1138362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1138365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1138368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1138371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138390 */     // MIs[0] round
     /* 1138390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138400 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138425 */     // GIR_Coverage, 15172,
     /* 1138425 */     GIR_EraseRootFromParent_Done,
     /* 1138426 */   // Label 16657: @1138426
     /* 1138426 */   GIM_Try, /*On fail goto*//*Label 16658*/ GIMT_Encode4(1138506), // Rule ID 15173 //
     /* 1138431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1138442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1138445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1138448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1138451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138470 */     // MIs[0] round
     /* 1138470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1138501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138505 */     // GIR_Coverage, 15173,
     /* 1138505 */     GIR_EraseRootFromParent_Done,
     /* 1138506 */   // Label 16658: @1138506
     /* 1138506 */   GIM_Try, /*On fail goto*//*Label 16659*/ GIMT_Encode4(1138586), // Rule ID 15176 //
     /* 1138511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1138522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1138525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1138528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1138531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138550 */     // MIs[0] round
     /* 1138550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1138563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138585 */     // GIR_Coverage, 15176,
     /* 1138585 */     GIR_EraseRootFromParent_Done,
     /* 1138586 */   // Label 16659: @1138586
     /* 1138586 */   GIM_Try, /*On fail goto*//*Label 16660*/ GIMT_Encode4(1138666), // Rule ID 15177 //
     /* 1138591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1138602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1138605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1138608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1138611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138630 */     // MIs[0] round
     /* 1138630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138640 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4),
     /* 1138643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138665 */     // GIR_Coverage, 15177,
     /* 1138665 */     GIR_EraseRootFromParent_Done,
     /* 1138666 */   // Label 16660: @1138666
     /* 1138666 */   GIM_Try, /*On fail goto*//*Label 16661*/ GIMT_Encode4(1138746), // Rule ID 15180 //
     /* 1138671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1138682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1138685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1138688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1138691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138710 */     // MIs[0] round
     /* 1138710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138745 */     // GIR_Coverage, 15180,
     /* 1138745 */     GIR_EraseRootFromParent_Done,
     /* 1138746 */   // Label 16661: @1138746
     /* 1138746 */   GIM_Try, /*On fail goto*//*Label 16662*/ GIMT_Encode4(1138826), // Rule ID 15181 //
     /* 1138751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1138762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1138765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1138768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1138771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138790 */     // MIs[0] round
     /* 1138790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138800 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1138821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138825 */     // GIR_Coverage, 15181,
     /* 1138825 */     GIR_EraseRootFromParent_Done,
     /* 1138826 */   // Label 16662: @1138826
     /* 1138826 */   GIM_Try, /*On fail goto*//*Label 16663*/ GIMT_Encode4(1138906), // Rule ID 15184 //
     /* 1138831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1138842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1138845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1138848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1138851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1138854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138870 */     // MIs[0] round
     /* 1138870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138880 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1138880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138905 */     // GIR_Coverage, 15184,
     /* 1138905 */     GIR_EraseRootFromParent_Done,
     /* 1138906 */   // Label 16663: @1138906
     /* 1138906 */   GIM_Try, /*On fail goto*//*Label 16664*/ GIMT_Encode4(1138986), // Rule ID 15185 //
     /* 1138911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1138914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1138922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1138925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1138928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1138931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1138934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1138950 */     // MIs[0] round
     /* 1138950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1138953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1138960 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1138960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2),
     /* 1138963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1138965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1138967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1138969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1138971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1138973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1138978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1138981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1138984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1138985 */     // GIR_Coverage, 15185,
     /* 1138985 */     GIR_EraseRootFromParent_Done,
     /* 1138986 */   // Label 16664: @1138986
     /* 1138986 */   GIM_Try, /*On fail goto*//*Label 16665*/ GIMT_Encode4(1139066), // Rule ID 15188 //
     /* 1138991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1138994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1138999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1139011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139030 */     // MIs[0] round
     /* 1139030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139065 */     // GIR_Coverage, 15188,
     /* 1139065 */     GIR_EraseRootFromParent_Done,
     /* 1139066 */   // Label 16665: @1139066
     /* 1139066 */   GIM_Try, /*On fail goto*//*Label 16666*/ GIMT_Encode4(1139146), // Rule ID 15189 //
     /* 1139071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1139082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1139085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1139088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1139091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139110 */     // MIs[0] round
     /* 1139110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139120 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139145 */     // GIR_Coverage, 15189,
     /* 1139145 */     GIR_EraseRootFromParent_Done,
     /* 1139146 */   // Label 16666: @1139146
     /* 1139146 */   GIM_Try, /*On fail goto*//*Label 16667*/ GIMT_Encode4(1139226), // Rule ID 15192 //
     /* 1139151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1139162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1139165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1139168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1139171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139190 */     // MIs[0] round
     /* 1139190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139225 */     // GIR_Coverage, 15192,
     /* 1139225 */     GIR_EraseRootFromParent_Done,
     /* 1139226 */   // Label 16667: @1139226
     /* 1139226 */   GIM_Try, /*On fail goto*//*Label 16668*/ GIMT_Encode4(1139306), // Rule ID 15193 //
     /* 1139231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1139242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1139245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1139248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1139251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139270 */     // MIs[0] round
     /* 1139270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1139301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139305 */     // GIR_Coverage, 15193,
     /* 1139305 */     GIR_EraseRootFromParent_Done,
     /* 1139306 */   // Label 16668: @1139306
     /* 1139306 */   GIM_Try, /*On fail goto*//*Label 16669*/ GIMT_Encode4(1139386), // Rule ID 15196 //
     /* 1139311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1139322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1139325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1139328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1139331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139350 */     // MIs[0] round
     /* 1139350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139385 */     // GIR_Coverage, 15196,
     /* 1139385 */     GIR_EraseRootFromParent_Done,
     /* 1139386 */   // Label 16669: @1139386
     /* 1139386 */   GIM_Try, /*On fail goto*//*Label 16670*/ GIMT_Encode4(1139466), // Rule ID 15197 //
     /* 1139391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1139402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1139405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1139408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1139411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139430 */     // MIs[0] round
     /* 1139430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1139461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139465 */     // GIR_Coverage, 15197,
     /* 1139465 */     GIR_EraseRootFromParent_Done,
     /* 1139466 */   // Label 16670: @1139466
     /* 1139466 */   GIM_Try, /*On fail goto*//*Label 16671*/ GIMT_Encode4(1139546), // Rule ID 15200 //
     /* 1139471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1139474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1139482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1139485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1139488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1139491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139510 */     // MIs[0] round
     /* 1139510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139545 */     // GIR_Coverage, 15200,
     /* 1139545 */     GIR_EraseRootFromParent_Done,
     /* 1139546 */   // Label 16671: @1139546
     /* 1139546 */   GIM_Try, /*On fail goto*//*Label 16672*/ GIMT_Encode4(1139626), // Rule ID 15201 //
     /* 1139551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1139554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1139562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1139565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1139568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1139571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1139590 */     // MIs[0] round
     /* 1139590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1),
     /* 1139603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1139621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139625 */     // GIR_Coverage, 15201,
     /* 1139625 */     GIR_EraseRootFromParent_Done,
     /* 1139626 */   // Label 16672: @1139626
     /* 1139626 */   GIM_Try, /*On fail goto*//*Label 16673*/ GIMT_Encode4(1139706), // Rule ID 15204 //
     /* 1139631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1139642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1139645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1139648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1139651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139670 */     // MIs[0] round
     /* 1139670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1139683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139705 */     // GIR_Coverage, 15204,
     /* 1139705 */     GIR_EraseRootFromParent_Done,
     /* 1139706 */   // Label 16673: @1139706
     /* 1139706 */   GIM_Try, /*On fail goto*//*Label 16674*/ GIMT_Encode4(1139786), // Rule ID 15205 //
     /* 1139711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1139722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1139725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1139728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1139731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1139750 */     // MIs[0] round
     /* 1139750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1139763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139785 */     // GIR_Coverage, 15205,
     /* 1139785 */     GIR_EraseRootFromParent_Done,
     /* 1139786 */   // Label 16674: @1139786
     /* 1139786 */   GIM_Try, /*On fail goto*//*Label 16675*/ GIMT_Encode4(1139866), // Rule ID 15208 //
     /* 1139791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1139802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1139805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1139808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1139811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139830 */     // MIs[0] round
     /* 1139830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1139840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1139843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139865 */     // GIR_Coverage, 15208,
     /* 1139865 */     GIR_EraseRootFromParent_Done,
     /* 1139866 */   // Label 16675: @1139866
     /* 1139866 */   GIM_Try, /*On fail goto*//*Label 16676*/ GIMT_Encode4(1139946), // Rule ID 15209 //
     /* 1139871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1139874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1139882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1139885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1139888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1139891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1139894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1139910 */     // MIs[0] round
     /* 1139910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1139920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1139920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1139923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1139925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1139927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1139929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1139931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1139933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1139938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1139941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1139944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1139945 */     // GIR_Coverage, 15209,
     /* 1139945 */     GIR_EraseRootFromParent_Done,
     /* 1139946 */   // Label 16676: @1139946
     /* 1139946 */   GIM_Try, /*On fail goto*//*Label 16677*/ GIMT_Encode4(1140026), // Rule ID 15212 //
     /* 1139951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1139954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1139959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1139962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1139965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1139968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1139971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1139974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1139990 */     // MIs[0] round
     /* 1139990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1139993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140000 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1140003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140025 */     // GIR_Coverage, 15212,
     /* 1140025 */     GIR_EraseRootFromParent_Done,
     /* 1140026 */   // Label 16677: @1140026
     /* 1140026 */   GIM_Try, /*On fail goto*//*Label 16678*/ GIMT_Encode4(1140106), // Rule ID 15213 //
     /* 1140031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1140042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1140045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1140048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1140051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140070 */     // MIs[0] round
     /* 1140070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140080 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1140083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1140101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140105 */     // GIR_Coverage, 15213,
     /* 1140105 */     GIR_EraseRootFromParent_Done,
     /* 1140106 */   // Label 16678: @1140106
     /* 1140106 */   GIM_Try, /*On fail goto*//*Label 16679*/ GIMT_Encode4(1140186), // Rule ID 15216 //
     /* 1140111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1140122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1140125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1140128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1140131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140150 */     // MIs[0] round
     /* 1140150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1140163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140185 */     // GIR_Coverage, 15216,
     /* 1140185 */     GIR_EraseRootFromParent_Done,
     /* 1140186 */   // Label 16679: @1140186
     /* 1140186 */   GIM_Try, /*On fail goto*//*Label 16680*/ GIMT_Encode4(1140266), // Rule ID 15217 //
     /* 1140191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1140202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1140205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1140208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1140211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140230 */     // MIs[0] round
     /* 1140230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1140243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140265 */     // GIR_Coverage, 15217,
     /* 1140265 */     GIR_EraseRootFromParent_Done,
     /* 1140266 */   // Label 16680: @1140266
     /* 1140266 */   GIM_Try, /*On fail goto*//*Label 16681*/ GIMT_Encode4(1140346), // Rule ID 15220 //
     /* 1140271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1140282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1140285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1140288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1140291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140310 */     // MIs[0] round
     /* 1140310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1140323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140345 */     // GIR_Coverage, 15220,
     /* 1140345 */     GIR_EraseRootFromParent_Done,
     /* 1140346 */   // Label 16681: @1140346
     /* 1140346 */   GIM_Try, /*On fail goto*//*Label 16682*/ GIMT_Encode4(1140426), // Rule ID 15221 //
     /* 1140351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1140362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1140365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1140368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1140371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140390 */     // MIs[0] round
     /* 1140390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140400 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1140403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140425 */     // GIR_Coverage, 15221,
     /* 1140425 */     GIR_EraseRootFromParent_Done,
     /* 1140426 */   // Label 16682: @1140426
     /* 1140426 */   GIM_Try, /*On fail goto*//*Label 16683*/ GIMT_Encode4(1140506), // Rule ID 15224 //
     /* 1140431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1140442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1140445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1140448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1140451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140470 */     // MIs[0] round
     /* 1140470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1140483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140505 */     // GIR_Coverage, 15224,
     /* 1140505 */     GIR_EraseRootFromParent_Done,
     /* 1140506 */   // Label 16683: @1140506
     /* 1140506 */   GIM_Try, /*On fail goto*//*Label 16684*/ GIMT_Encode4(1140586), // Rule ID 15225 //
     /* 1140511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1140522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1140525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1140528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1140531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140550 */     // MIs[0] round
     /* 1140550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140560 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1140563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1140581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140585 */     // GIR_Coverage, 15225,
     /* 1140585 */     GIR_EraseRootFromParent_Done,
     /* 1140586 */   // Label 16684: @1140586
     /* 1140586 */   GIM_Try, /*On fail goto*//*Label 16685*/ GIMT_Encode4(1140666), // Rule ID 15228 //
     /* 1140591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1140602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1140605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1140608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1140611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140630 */     // MIs[0] round
     /* 1140630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140640 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1140643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140665 */     // GIR_Coverage, 15228,
     /* 1140665 */     GIR_EraseRootFromParent_Done,
     /* 1140666 */   // Label 16685: @1140666
     /* 1140666 */   GIM_Try, /*On fail goto*//*Label 16686*/ GIMT_Encode4(1140746), // Rule ID 15229 //
     /* 1140671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1140682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1140685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1140688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1140691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1140710 */     // MIs[0] round
     /* 1140710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140720 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1140723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140745 */     // GIR_Coverage, 15229,
     /* 1140745 */     GIR_EraseRootFromParent_Done,
     /* 1140746 */   // Label 16686: @1140746
     /* 1140746 */   GIM_Try, /*On fail goto*//*Label 16687*/ GIMT_Encode4(1140826), // Rule ID 15232 //
     /* 1140751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1140762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1140765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1140768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1140771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140790 */     // MIs[0] round
     /* 1140790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140800 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1140803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140825 */     // GIR_Coverage, 15232,
     /* 1140825 */     GIR_EraseRootFromParent_Done,
     /* 1140826 */   // Label 16687: @1140826
     /* 1140826 */   GIM_Try, /*On fail goto*//*Label 16688*/ GIMT_Encode4(1140906), // Rule ID 15233 //
     /* 1140831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1140842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1140845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1140848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1140851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1140854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1140870 */     // MIs[0] round
     /* 1140870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140880 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1140880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1140883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140905 */     // GIR_Coverage, 15233,
     /* 1140905 */     GIR_EraseRootFromParent_Done,
     /* 1140906 */   // Label 16688: @1140906
     /* 1140906 */   GIM_Try, /*On fail goto*//*Label 16689*/ GIMT_Encode4(1140986), // Rule ID 15236 //
     /* 1140911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1140914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1140922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1140925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1140928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1140931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1140934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1140950 */     // MIs[0] round
     /* 1140950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1140953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1140960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1140960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1140963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1140965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1140967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1140969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1140971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1140973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1140978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1140981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1140984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1140985 */     // GIR_Coverage, 15236,
     /* 1140985 */     GIR_EraseRootFromParent_Done,
     /* 1140986 */   // Label 16689: @1140986
     /* 1140986 */   GIM_Try, /*On fail goto*//*Label 16690*/ GIMT_Encode4(1141066), // Rule ID 15237 //
     /* 1140991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1140994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1140999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1141002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1141005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1141008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1141011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141030 */     // MIs[0] round
     /* 1141030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141040 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1141043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1141061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141065 */     // GIR_Coverage, 15237,
     /* 1141065 */     GIR_EraseRootFromParent_Done,
     /* 1141066 */   // Label 16690: @1141066
     /* 1141066 */   GIM_Try, /*On fail goto*//*Label 16691*/ GIMT_Encode4(1141146), // Rule ID 15240 //
     /* 1141071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1141088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1141091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141110 */     // MIs[0] round
     /* 1141110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1141123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141145 */     // GIR_Coverage, 15240,
     /* 1141145 */     GIR_EraseRootFromParent_Done,
     /* 1141146 */   // Label 16691: @1141146
     /* 1141146 */   GIM_Try, /*On fail goto*//*Label 16692*/ GIMT_Encode4(1141226), // Rule ID 15241 //
     /* 1141151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1141162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1141165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1141168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1141171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1141190 */     // MIs[0] round
     /* 1141190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141200 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2),
     /* 1141203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141225 */     // GIR_Coverage, 15241,
     /* 1141225 */     GIR_EraseRootFromParent_Done,
     /* 1141226 */   // Label 16692: @1141226
     /* 1141226 */   GIM_Try, /*On fail goto*//*Label 16693*/ GIMT_Encode4(1141306), // Rule ID 15244 //
     /* 1141231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1141242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1141245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1141248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1141251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141270 */     // MIs[0] round
     /* 1141270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141280 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1141283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141305 */     // GIR_Coverage, 15244,
     /* 1141305 */     GIR_EraseRootFromParent_Done,
     /* 1141306 */   // Label 16693: @1141306
     /* 1141306 */   GIM_Try, /*On fail goto*//*Label 16694*/ GIMT_Encode4(1141386), // Rule ID 15245 //
     /* 1141311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1141322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1141325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1141328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1141331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1141350 */     // MIs[0] round
     /* 1141350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141360 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4),
     /* 1141363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141385 */     // GIR_Coverage, 15245,
     /* 1141385 */     GIR_EraseRootFromParent_Done,
     /* 1141386 */   // Label 16694: @1141386
     /* 1141386 */   GIM_Try, /*On fail goto*//*Label 16695*/ GIMT_Encode4(1141466), // Rule ID 15248 //
     /* 1141391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1141394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1141402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1141405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1141408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1141411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141430 */     // MIs[0] round
     /* 1141430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1141443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141465 */     // GIR_Coverage, 15248,
     /* 1141465 */     GIR_EraseRootFromParent_Done,
     /* 1141466 */   // Label 16695: @1141466
     /* 1141466 */   GIM_Try, /*On fail goto*//*Label 16696*/ GIMT_Encode4(1141546), // Rule ID 15249 //
     /* 1141471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1141474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1141482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1141485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1141488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1141491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1141510 */     // MIs[0] round
     /* 1141510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141520 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8),
     /* 1141523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1141541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141545 */     // GIR_Coverage, 15249,
     /* 1141545 */     GIR_EraseRootFromParent_Done,
     /* 1141546 */   // Label 16696: @1141546
     /* 1141546 */   GIM_Try, /*On fail goto*//*Label 16697*/ GIMT_Encode4(1141626), // Rule ID 15252 //
     /* 1141551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1141562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1141565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1141568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141590 */     // MIs[0] round
     /* 1141590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141625 */     // GIR_Coverage, 15252,
     /* 1141625 */     GIR_EraseRootFromParent_Done,
     /* 1141626 */   // Label 16697: @1141626
     /* 1141626 */   GIM_Try, /*On fail goto*//*Label 16698*/ GIMT_Encode4(1141706), // Rule ID 15253 //
     /* 1141631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1141642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1141645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1141648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141670 */     // MIs[0] round
     /* 1141670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141680 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8),
     /* 1141683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141705 */     // GIR_Coverage, 15253,
     /* 1141705 */     GIR_EraseRootFromParent_Done,
     /* 1141706 */   // Label 16698: @1141706
     /* 1141706 */   GIM_Try, /*On fail goto*//*Label 16699*/ GIMT_Encode4(1141786), // Rule ID 15256 //
     /* 1141711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1141722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1141725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1141728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141750 */     // MIs[0] round
     /* 1141750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141760 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1141763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141785 */     // GIR_Coverage, 15256,
     /* 1141785 */     GIR_EraseRootFromParent_Done,
     /* 1141786 */   // Label 16699: @1141786
     /* 1141786 */   GIM_Try, /*On fail goto*//*Label 16700*/ GIMT_Encode4(1141866), // Rule ID 15257 //
     /* 1141791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1141802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1141805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1141808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141830 */     // MIs[0] round
     /* 1141830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141840 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1141840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1141843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141865 */     // GIR_Coverage, 15257,
     /* 1141865 */     GIR_EraseRootFromParent_Done,
     /* 1141866 */   // Label 16700: @1141866
     /* 1141866 */   GIM_Try, /*On fail goto*//*Label 16701*/ GIMT_Encode4(1141946), // Rule ID 15260 //
     /* 1141871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1141874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1141882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1141885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1141888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1141891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1141894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141910 */     // MIs[0] round
     /* 1141910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1141920 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1141920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1141923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1141925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1141927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1141929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1141931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1141933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1141938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1141941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1141944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1141945 */     // GIR_Coverage, 15260,
     /* 1141945 */     GIR_EraseRootFromParent_Done,
     /* 1141946 */   // Label 16701: @1141946
     /* 1141946 */   GIM_Try, /*On fail goto*//*Label 16702*/ GIMT_Encode4(1142026), // Rule ID 15261 //
     /* 1141951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1141954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1141959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1141962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1141965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1141968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1141971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1141974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1141986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1141990 */     // MIs[0] round
     /* 1141990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1141993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142000 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1142003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142025 */     // GIR_Coverage, 15261,
     /* 1142025 */     GIR_EraseRootFromParent_Done,
     /* 1142026 */   // Label 16702: @1142026
     /* 1142026 */   GIM_Try, /*On fail goto*//*Label 16703*/ GIMT_Encode4(1142106), // Rule ID 15264 //
     /* 1142031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142070 */     // MIs[0] round
     /* 1142070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142080 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1142083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142105 */     // GIR_Coverage, 15264,
     /* 1142105 */     GIR_EraseRootFromParent_Done,
     /* 1142106 */   // Label 16703: @1142106
     /* 1142106 */   GIM_Try, /*On fail goto*//*Label 16704*/ GIMT_Encode4(1142186), // Rule ID 15265 //
     /* 1142111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1142122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1142125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1142128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142150 */     // MIs[0] round
     /* 1142150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142160 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4),
     /* 1142163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142185 */     // GIR_Coverage, 15265,
     /* 1142185 */     GIR_EraseRootFromParent_Done,
     /* 1142186 */   // Label 16704: @1142186
     /* 1142186 */   GIM_Try, /*On fail goto*//*Label 16705*/ GIMT_Encode4(1142266), // Rule ID 15268 //
     /* 1142191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1142202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1142205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1142208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142230 */     // MIs[0] round
     /* 1142230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1142243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142265 */     // GIR_Coverage, 15268,
     /* 1142265 */     GIR_EraseRootFromParent_Done,
     /* 1142266 */   // Label 16705: @1142266
     /* 1142266 */   GIM_Try, /*On fail goto*//*Label 16706*/ GIMT_Encode4(1142346), // Rule ID 15269 //
     /* 1142271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1142282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1142285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1142288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142310 */     // MIs[0] round
     /* 1142310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142320 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1142323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142345 */     // GIR_Coverage, 15269,
     /* 1142345 */     GIR_EraseRootFromParent_Done,
     /* 1142346 */   // Label 16706: @1142346
     /* 1142346 */   GIM_Try, /*On fail goto*//*Label 16707*/ GIMT_Encode4(1142426), // Rule ID 15272 //
     /* 1142351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1142362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1142365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1142368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142390 */     // MIs[0] round
     /* 1142390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1142403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142425 */     // GIR_Coverage, 15272,
     /* 1142425 */     GIR_EraseRootFromParent_Done,
     /* 1142426 */   // Label 16707: @1142426
     /* 1142426 */   GIM_Try, /*On fail goto*//*Label 16708*/ GIMT_Encode4(1142506), // Rule ID 15273 //
     /* 1142431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1142442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1142445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1142448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142470 */     // MIs[0] round
     /* 1142470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2),
     /* 1142483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142505 */     // GIR_Coverage, 15273,
     /* 1142505 */     GIR_EraseRootFromParent_Done,
     /* 1142506 */   // Label 16708: @1142506
     /* 1142506 */   GIM_Try, /*On fail goto*//*Label 16709*/ GIMT_Encode4(1142586), // Rule ID 15276 //
     /* 1142511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1142522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1142525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1142528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142550 */     // MIs[0] round
     /* 1142550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142585 */     // GIR_Coverage, 15276,
     /* 1142585 */     GIR_EraseRootFromParent_Done,
     /* 1142586 */   // Label 16709: @1142586
     /* 1142586 */   GIM_Try, /*On fail goto*//*Label 16710*/ GIMT_Encode4(1142666), // Rule ID 15277 //
     /* 1142591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1142602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1142605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1142608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142630 */     // MIs[0] round
     /* 1142630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11091:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1142661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142665 */     // GIR_Coverage, 15277,
     /* 1142665 */     GIR_EraseRootFromParent_Done,
     /* 1142666 */   // Label 16710: @1142666
     /* 1142666 */   GIM_Try, /*On fail goto*//*Label 16711*/ GIMT_Encode4(1142746), // Rule ID 15280 //
     /* 1142671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1142682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1142685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1142688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142710 */     // MIs[0] round
     /* 1142710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142745 */     // GIR_Coverage, 15280,
     /* 1142745 */     GIR_EraseRootFromParent_Done,
     /* 1142746 */   // Label 16711: @1142746
     /* 1142746 */   GIM_Try, /*On fail goto*//*Label 16712*/ GIMT_Encode4(1142826), // Rule ID 15281 //
     /* 1142751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1142762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1142765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1142768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142790 */     // MIs[0] round
     /* 1142790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11091:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1142821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142825 */     // GIR_Coverage, 15281,
     /* 1142825 */     GIR_EraseRootFromParent_Done,
     /* 1142826 */   // Label 16712: @1142826
     /* 1142826 */   GIM_Try, /*On fail goto*//*Label 16713*/ GIMT_Encode4(1142906), // Rule ID 15284 //
     /* 1142831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1142834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1142842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1142845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1142848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1142851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1142854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142870 */     // MIs[0] round
     /* 1142870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1142880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142905 */     // GIR_Coverage, 15284,
     /* 1142905 */     GIR_EraseRootFromParent_Done,
     /* 1142906 */   // Label 16713: @1142906
     /* 1142906 */   GIM_Try, /*On fail goto*//*Label 16714*/ GIMT_Encode4(1142986), // Rule ID 15285 //
     /* 1142911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1142914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1142922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1142925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1142928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1142931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1142934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1142946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1142950 */     // MIs[0] round
     /* 1142950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1142953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1142960 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11091:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1142960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1142963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1142965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1142967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1142969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1142971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1142973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1142978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1142981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1142984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1142985 */     // GIR_Coverage, 15285,
     /* 1142985 */     GIR_EraseRootFromParent_Done,
     /* 1142986 */   // Label 16714: @1142986
     /* 1142986 */   GIM_Try, /*On fail goto*//*Label 16715*/ GIMT_Encode4(1143066), // Rule ID 15288 //
     /* 1142991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1142994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1142999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143030 */     // MIs[0] round
     /* 1143030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1143043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143065 */     // GIR_Coverage, 15288,
     /* 1143065 */     GIR_EraseRootFromParent_Done,
     /* 1143066 */   // Label 16715: @1143066
     /* 1143066 */   GIM_Try, /*On fail goto*//*Label 16716*/ GIMT_Encode4(1143146), // Rule ID 15289 //
     /* 1143071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1143074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1143082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1143085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1143088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1143106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143110 */     // MIs[0] round
     /* 1143110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11091:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1),
     /* 1143123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1143141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143145 */     // GIR_Coverage, 15289,
     /* 1143145 */     GIR_EraseRootFromParent_Done,
     /* 1143146 */   // Label 16716: @1143146
     /* 1143146 */   GIM_Try, /*On fail goto*//*Label 16717*/ GIMT_Encode4(1143226), // Rule ID 15292 //
     /* 1143151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1143162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1143165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1143168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143190 */     // MIs[0] round
     /* 1143190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143200 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1143203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143225 */     // GIR_Coverage, 15292,
     /* 1143225 */     GIR_EraseRootFromParent_Done,
     /* 1143226 */   // Label 16717: @1143226
     /* 1143226 */   GIM_Try, /*On fail goto*//*Label 16718*/ GIMT_Encode4(1143306), // Rule ID 15293 //
     /* 1143231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1143242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1143245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1143248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143270 */     // MIs[0] round
     /* 1143270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143280 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1143283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143305 */     // GIR_Coverage, 15293,
     /* 1143305 */     GIR_EraseRootFromParent_Done,
     /* 1143306 */   // Label 16718: @1143306
     /* 1143306 */   GIM_Try, /*On fail goto*//*Label 16719*/ GIMT_Encode4(1143386), // Rule ID 15296 //
     /* 1143311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1143322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1143325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1143328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143350 */     // MIs[0] round
     /* 1143350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143360 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1143363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143385 */     // GIR_Coverage, 15296,
     /* 1143385 */     GIR_EraseRootFromParent_Done,
     /* 1143386 */   // Label 16719: @1143386
     /* 1143386 */   GIM_Try, /*On fail goto*//*Label 16720*/ GIMT_Encode4(1143466), // Rule ID 15297 //
     /* 1143391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1143402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1143405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1143408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143430 */     // MIs[0] round
     /* 1143430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143440 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1143443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143465 */     // GIR_Coverage, 15297,
     /* 1143465 */     GIR_EraseRootFromParent_Done,
     /* 1143466 */   // Label 16720: @1143466
     /* 1143466 */   GIM_Try, /*On fail goto*//*Label 16721*/ GIMT_Encode4(1143546), // Rule ID 15300 //
     /* 1143471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1143482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1143485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1143488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143510 */     // MIs[0] round
     /* 1143510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1143523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143545 */     // GIR_Coverage, 15300,
     /* 1143545 */     GIR_EraseRootFromParent_Done,
     /* 1143546 */   // Label 16721: @1143546
     /* 1143546 */   GIM_Try, /*On fail goto*//*Label 16722*/ GIMT_Encode4(1143626), // Rule ID 15301 //
     /* 1143551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1143562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1143565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1143568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143590 */     // MIs[0] round
     /* 1143590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1143603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1143621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143625 */     // GIR_Coverage, 15301,
     /* 1143625 */     GIR_EraseRootFromParent_Done,
     /* 1143626 */   // Label 16722: @1143626
     /* 1143626 */   GIM_Try, /*On fail goto*//*Label 16723*/ GIMT_Encode4(1143706), // Rule ID 15304 //
     /* 1143631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1143642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1143645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1143648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143670 */     // MIs[0] round
     /* 1143670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143680 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1143683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143705 */     // GIR_Coverage, 15304,
     /* 1143705 */     GIR_EraseRootFromParent_Done,
     /* 1143706 */   // Label 16723: @1143706
     /* 1143706 */   GIM_Try, /*On fail goto*//*Label 16724*/ GIMT_Encode4(1143786), // Rule ID 15305 //
     /* 1143711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1143722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1143725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1143728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1143746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143750 */     // MIs[0] round
     /* 1143750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1143763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143785 */     // GIR_Coverage, 15305,
     /* 1143785 */     GIR_EraseRootFromParent_Done,
     /* 1143786 */   // Label 16724: @1143786
     /* 1143786 */   GIM_Try, /*On fail goto*//*Label 16725*/ GIMT_Encode4(1143866), // Rule ID 15308 //
     /* 1143791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1143802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1143805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1143808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143830 */     // MIs[0] round
     /* 1143830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143840 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1143840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1143843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143865 */     // GIR_Coverage, 15308,
     /* 1143865 */     GIR_EraseRootFromParent_Done,
     /* 1143866 */   // Label 16725: @1143866
     /* 1143866 */   GIM_Try, /*On fail goto*//*Label 16726*/ GIMT_Encode4(1143946), // Rule ID 15309 //
     /* 1143871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1143874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1143882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1143885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1143888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1143891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1143894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1143906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143910 */     // MIs[0] round
     /* 1143910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1143920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1143920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1143923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1143925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1143927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1143929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1143931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1143933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1143938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1143941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1143944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1143945 */     // GIR_Coverage, 15309,
     /* 1143945 */     GIR_EraseRootFromParent_Done,
     /* 1143946 */   // Label 16726: @1143946
     /* 1143946 */   GIM_Try, /*On fail goto*//*Label 16727*/ GIMT_Encode4(1144026), // Rule ID 15312 //
     /* 1143951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1143954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1143959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1143962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1143965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1143968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1143971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1143974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1143986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1143990 */     // MIs[0] round
     /* 1143990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1143993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1144003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144025 */     // GIR_Coverage, 15312,
     /* 1144025 */     GIR_EraseRootFromParent_Done,
     /* 1144026 */   // Label 16727: @1144026
     /* 1144026 */   GIM_Try, /*On fail goto*//*Label 16728*/ GIMT_Encode4(1144106), // Rule ID 15313 //
     /* 1144031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1144042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1144045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1144048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144070 */     // MIs[0] round
     /* 1144070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144080 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1144083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1144101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144105 */     // GIR_Coverage, 15313,
     /* 1144105 */     GIR_EraseRootFromParent_Done,
     /* 1144106 */   // Label 16728: @1144106
     /* 1144106 */   GIM_Try, /*On fail goto*//*Label 16729*/ GIMT_Encode4(1144186), // Rule ID 15316 //
     /* 1144111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1144122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1144125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1144128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144150 */     // MIs[0] round
     /* 1144150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144160 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1144163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144185 */     // GIR_Coverage, 15316,
     /* 1144185 */     GIR_EraseRootFromParent_Done,
     /* 1144186 */   // Label 16729: @1144186
     /* 1144186 */   GIM_Try, /*On fail goto*//*Label 16730*/ GIMT_Encode4(1144266), // Rule ID 15317 //
     /* 1144191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1144202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1144205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1144208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144230 */     // MIs[0] round
     /* 1144230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144240 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1144243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144265 */     // GIR_Coverage, 15317,
     /* 1144265 */     GIR_EraseRootFromParent_Done,
     /* 1144266 */   // Label 16730: @1144266
     /* 1144266 */   GIM_Try, /*On fail goto*//*Label 16731*/ GIMT_Encode4(1144346), // Rule ID 15320 //
     /* 1144271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1144282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1144285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1144288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144310 */     // MIs[0] round
     /* 1144310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144320 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1144323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144345 */     // GIR_Coverage, 15320,
     /* 1144345 */     GIR_EraseRootFromParent_Done,
     /* 1144346 */   // Label 16731: @1144346
     /* 1144346 */   GIM_Try, /*On fail goto*//*Label 16732*/ GIMT_Encode4(1144426), // Rule ID 15321 //
     /* 1144351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1144362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1144365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1144368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144390 */     // MIs[0] round
     /* 1144390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144400 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1144403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144425 */     // GIR_Coverage, 15321,
     /* 1144425 */     GIR_EraseRootFromParent_Done,
     /* 1144426 */   // Label 16732: @1144426
     /* 1144426 */   GIM_Try, /*On fail goto*//*Label 16733*/ GIMT_Encode4(1144506), // Rule ID 15324 //
     /* 1144431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1144434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1144442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1144445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1144448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144470 */     // MIs[0] round
     /* 1144470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1144483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144505 */     // GIR_Coverage, 15324,
     /* 1144505 */     GIR_EraseRootFromParent_Done,
     /* 1144506 */   // Label 16733: @1144506
     /* 1144506 */   GIM_Try, /*On fail goto*//*Label 16734*/ GIMT_Encode4(1144586), // Rule ID 15325 //
     /* 1144511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1144514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1144522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1144525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1144528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144550 */     // MIs[0] round
     /* 1144550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144560 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1144563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1144581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144585 */     // GIR_Coverage, 15325,
     /* 1144585 */     GIR_EraseRootFromParent_Done,
     /* 1144586 */   // Label 16734: @1144586
     /* 1144586 */   GIM_Try, /*On fail goto*//*Label 16735*/ GIMT_Encode4(1144666), // Rule ID 15328 //
     /* 1144591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1144602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1144605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1144608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144630 */     // MIs[0] round
     /* 1144630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144640 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1144643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144665 */     // GIR_Coverage, 15328,
     /* 1144665 */     GIR_EraseRootFromParent_Done,
     /* 1144666 */   // Label 16735: @1144666
     /* 1144666 */   GIM_Try, /*On fail goto*//*Label 16736*/ GIMT_Encode4(1144746), // Rule ID 15329 //
     /* 1144671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1144682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1144685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1144688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1144706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144710 */     // MIs[0] round
     /* 1144710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144720 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11091:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2),
     /* 1144723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144745 */     // GIR_Coverage, 15329,
     /* 1144745 */     GIR_EraseRootFromParent_Done,
     /* 1144746 */   // Label 16736: @1144746
     /* 1144746 */   GIM_Try, /*On fail goto*//*Label 16737*/ GIMT_Encode4(1144826), // Rule ID 15332 //
     /* 1144751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1144762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1144765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1144768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144790 */     // MIs[0] round
     /* 1144790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144800 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1144803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144825 */     // GIR_Coverage, 15332,
     /* 1144825 */     GIR_EraseRootFromParent_Done,
     /* 1144826 */   // Label 16737: @1144826
     /* 1144826 */   GIM_Try, /*On fail goto*//*Label 16738*/ GIMT_Encode4(1144906), // Rule ID 15333 //
     /* 1144831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1144842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1144845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1144848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1144851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1144854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1144866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144870 */     // MIs[0] round
     /* 1144870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144880 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11091:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1144880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4),
     /* 1144883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144905 */     // GIR_Coverage, 15333,
     /* 1144905 */     GIR_EraseRootFromParent_Done,
     /* 1144906 */   // Label 16738: @1144906
     /* 1144906 */   GIM_Try, /*On fail goto*//*Label 16739*/ GIMT_Encode4(1144986), // Rule ID 15336 //
     /* 1144911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1144914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1144922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1144925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1144928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1144931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1144934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1144946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1144950 */     // MIs[0] round
     /* 1144950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1144953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1144960 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1144960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1144963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1144965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1144967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1144969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1144971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1144973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1144978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1144981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1144984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1144985 */     // GIR_Coverage, 15336,
     /* 1144985 */     GIR_EraseRootFromParent_Done,
     /* 1144986 */   // Label 16739: @1144986
     /* 1144986 */   GIM_Try, /*On fail goto*//*Label 16740*/ GIMT_Encode4(1145066), // Rule ID 15337 //
     /* 1144991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1144994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub),
     /* 1144999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1145002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1145005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1145008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1145011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1145026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1145030 */     // MIs[0] round
     /* 1145030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145040 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11091:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVASUB_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8),
     /* 1145043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1145061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145065 */     // GIR_Coverage, 15337,
     /* 1145065 */     GIR_EraseRootFromParent_Done,
     /* 1145066 */   // Label 16740: @1145066
     /* 1145066 */   GIM_Try, /*On fail goto*//*Label 16741*/ GIMT_Encode4(1145146), // Rule ID 15340 //
     /* 1145071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1145088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1145091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145110 */     // MIs[0] round
     /* 1145110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1145123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145145 */     // GIR_Coverage, 15340,
     /* 1145145 */     GIR_EraseRootFromParent_Done,
     /* 1145146 */   // Label 16741: @1145146
     /* 1145146 */   GIM_Try, /*On fail goto*//*Label 16742*/ GIMT_Encode4(1145226), // Rule ID 15341 //
     /* 1145151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1145162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1145165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1145168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1145171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145190 */     // MIs[0] round
     /* 1145190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145200 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8),
     /* 1145203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145225 */     // GIR_Coverage, 15341,
     /* 1145225 */     GIR_EraseRootFromParent_Done,
     /* 1145226 */   // Label 16742: @1145226
     /* 1145226 */   GIM_Try, /*On fail goto*//*Label 16743*/ GIMT_Encode4(1145306), // Rule ID 15344 //
     /* 1145231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1145242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1145245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1145248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1145251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145270 */     // MIs[0] round
     /* 1145270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1145283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145305 */     // GIR_Coverage, 15344,
     /* 1145305 */     GIR_EraseRootFromParent_Done,
     /* 1145306 */   // Label 16743: @1145306
     /* 1145306 */   GIM_Try, /*On fail goto*//*Label 16744*/ GIMT_Encode4(1145386), // Rule ID 15345 //
     /* 1145311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1145322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1145325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1145328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1145331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145350 */     // MIs[0] round
     /* 1145350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1145363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145385 */     // GIR_Coverage, 15345,
     /* 1145385 */     GIR_EraseRootFromParent_Done,
     /* 1145386 */   // Label 16744: @1145386
     /* 1145386 */   GIM_Try, /*On fail goto*//*Label 16745*/ GIMT_Encode4(1145466), // Rule ID 15348 //
     /* 1145391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1145402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1145405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1145408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1145411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145430 */     // MIs[0] round
     /* 1145430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1145443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145465 */     // GIR_Coverage, 15348,
     /* 1145465 */     GIR_EraseRootFromParent_Done,
     /* 1145466 */   // Label 16745: @1145466
     /* 1145466 */   GIM_Try, /*On fail goto*//*Label 16746*/ GIMT_Encode4(1145546), // Rule ID 15349 //
     /* 1145471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1145482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1145485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1145488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1145491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145510 */     // MIs[0] round
     /* 1145510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1145523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1145541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145545 */     // GIR_Coverage, 15349,
     /* 1145545 */     GIR_EraseRootFromParent_Done,
     /* 1145546 */   // Label 16746: @1145546
     /* 1145546 */   GIM_Try, /*On fail goto*//*Label 16747*/ GIMT_Encode4(1145626), // Rule ID 15352 //
     /* 1145551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1145562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1145565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1145568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1145571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145590 */     // MIs[0] round
     /* 1145590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145600 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1145603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145625 */     // GIR_Coverage, 15352,
     /* 1145625 */     GIR_EraseRootFromParent_Done,
     /* 1145626 */   // Label 16747: @1145626
     /* 1145626 */   GIM_Try, /*On fail goto*//*Label 16748*/ GIMT_Encode4(1145706), // Rule ID 15353 //
     /* 1145631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1145642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1145645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1145648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1145651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145670 */     // MIs[0] round
     /* 1145670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4),
     /* 1145683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145705 */     // GIR_Coverage, 15353,
     /* 1145705 */     GIR_EraseRootFromParent_Done,
     /* 1145706 */   // Label 16748: @1145706
     /* 1145706 */   GIM_Try, /*On fail goto*//*Label 16749*/ GIMT_Encode4(1145786), // Rule ID 15356 //
     /* 1145711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1145722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1145725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1145728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1145731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145750 */     // MIs[0] round
     /* 1145750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145760 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1145763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145785 */     // GIR_Coverage, 15356,
     /* 1145785 */     GIR_EraseRootFromParent_Done,
     /* 1145786 */   // Label 16749: @1145786
     /* 1145786 */   GIM_Try, /*On fail goto*//*Label 16750*/ GIMT_Encode4(1145866), // Rule ID 15357 //
     /* 1145791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1145802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1145805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1145808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1145811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145830 */     // MIs[0] round
     /* 1145830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145840 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1145840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1145843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1145861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145865 */     // GIR_Coverage, 15357,
     /* 1145865 */     GIR_EraseRootFromParent_Done,
     /* 1145866 */   // Label 16750: @1145866
     /* 1145866 */   GIM_Try, /*On fail goto*//*Label 16751*/ GIMT_Encode4(1145946), // Rule ID 15360 //
     /* 1145871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1145874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1145882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1145885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1145888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1145891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1145894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145910 */     // MIs[0] round
     /* 1145910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1145920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1145920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1145923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1145925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1145927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1145929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1145931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1145933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1145938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1145941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1145944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1145945 */     // GIR_Coverage, 15360,
     /* 1145945 */     GIR_EraseRootFromParent_Done,
     /* 1145946 */   // Label 16751: @1145946
     /* 1145946 */   GIM_Try, /*On fail goto*//*Label 16752*/ GIMT_Encode4(1146026), // Rule ID 15361 //
     /* 1145951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1145954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1145959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1145962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1145965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1145968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1145971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1145974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1145990 */     // MIs[0] round
     /* 1145990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1145993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2),
     /* 1146003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146025 */     // GIR_Coverage, 15361,
     /* 1146025 */     GIR_EraseRootFromParent_Done,
     /* 1146026 */   // Label 16752: @1146026
     /* 1146026 */   GIM_Try, /*On fail goto*//*Label 16753*/ GIMT_Encode4(1146106), // Rule ID 15364 //
     /* 1146031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1146051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146070 */     // MIs[0] round
     /* 1146070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146080 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146105 */     // GIR_Coverage, 15364,
     /* 1146105 */     GIR_EraseRootFromParent_Done,
     /* 1146106 */   // Label 16753: @1146106
     /* 1146106 */   GIM_Try, /*On fail goto*//*Label 16754*/ GIMT_Encode4(1146186), // Rule ID 15365 //
     /* 1146111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1146122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1146125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1146128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1146131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146150 */     // MIs[0] round
     /* 1146150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146160 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146185 */     // GIR_Coverage, 15365,
     /* 1146185 */     GIR_EraseRootFromParent_Done,
     /* 1146186 */   // Label 16754: @1146186
     /* 1146186 */   GIM_Try, /*On fail goto*//*Label 16755*/ GIMT_Encode4(1146266), // Rule ID 15368 //
     /* 1146191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1146202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1146205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1146208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1146211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146230 */     // MIs[0] round
     /* 1146230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146240 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146265 */     // GIR_Coverage, 15368,
     /* 1146265 */     GIR_EraseRootFromParent_Done,
     /* 1146266 */   // Label 16755: @1146266
     /* 1146266 */   GIM_Try, /*On fail goto*//*Label 16756*/ GIMT_Encode4(1146346), // Rule ID 15369 //
     /* 1146271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1146282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1146285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1146288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1146291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146310 */     // MIs[0] round
     /* 1146310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1146341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146345 */     // GIR_Coverage, 15369,
     /* 1146345 */     GIR_EraseRootFromParent_Done,
     /* 1146346 */   // Label 16756: @1146346
     /* 1146346 */   GIM_Try, /*On fail goto*//*Label 16757*/ GIMT_Encode4(1146426), // Rule ID 15372 //
     /* 1146351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1146362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1146365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1146368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1146371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146390 */     // MIs[0] round
     /* 1146390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146400 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146425 */     // GIR_Coverage, 15372,
     /* 1146425 */     GIR_EraseRootFromParent_Done,
     /* 1146426 */   // Label 16757: @1146426
     /* 1146426 */   GIM_Try, /*On fail goto*//*Label 16758*/ GIMT_Encode4(1146506), // Rule ID 15373 //
     /* 1146431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1146442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1146445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1146448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1146451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146470 */     // MIs[0] round
     /* 1146470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1146501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146505 */     // GIR_Coverage, 15373,
     /* 1146505 */     GIR_EraseRootFromParent_Done,
     /* 1146506 */   // Label 16758: @1146506
     /* 1146506 */   GIM_Try, /*On fail goto*//*Label 16759*/ GIMT_Encode4(1146586), // Rule ID 15376 //
     /* 1146511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1146514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1146522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1146525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1146528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1146531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146550 */     // MIs[0] round
     /* 1146550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146560 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146585 */     // GIR_Coverage, 15376,
     /* 1146585 */     GIR_EraseRootFromParent_Done,
     /* 1146586 */   // Label 16759: @1146586
     /* 1146586 */   GIM_Try, /*On fail goto*//*Label 16760*/ GIMT_Encode4(1146666), // Rule ID 15377 //
     /* 1146591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1146594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1146602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1146605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1146608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1146611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1146630 */     // MIs[0] round
     /* 1146630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1),
     /* 1146643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1146661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146665 */     // GIR_Coverage, 15377,
     /* 1146665 */     GIR_EraseRootFromParent_Done,
     /* 1146666 */   // Label 16760: @1146666
     /* 1146666 */   GIM_Try, /*On fail goto*//*Label 16761*/ GIMT_Encode4(1146746), // Rule ID 15380 //
     /* 1146671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1146682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1146685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1146688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1146691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146710 */     // MIs[0] round
     /* 1146710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1146723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146745 */     // GIR_Coverage, 15380,
     /* 1146745 */     GIR_EraseRootFromParent_Done,
     /* 1146746 */   // Label 16761: @1146746
     /* 1146746 */   GIM_Try, /*On fail goto*//*Label 16762*/ GIMT_Encode4(1146826), // Rule ID 15381 //
     /* 1146751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1146762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1146765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1146768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1146771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1146790 */     // MIs[0] round
     /* 1146790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1146803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146825 */     // GIR_Coverage, 15381,
     /* 1146825 */     GIR_EraseRootFromParent_Done,
     /* 1146826 */   // Label 16762: @1146826
     /* 1146826 */   GIM_Try, /*On fail goto*//*Label 16763*/ GIMT_Encode4(1146906), // Rule ID 15384 //
     /* 1146831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1146842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1146845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1146848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1146851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1146854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146870 */     // MIs[0] round
     /* 1146870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146880 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1146880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1146883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146905 */     // GIR_Coverage, 15384,
     /* 1146905 */     GIR_EraseRootFromParent_Done,
     /* 1146906 */   // Label 16763: @1146906
     /* 1146906 */   GIM_Try, /*On fail goto*//*Label 16764*/ GIMT_Encode4(1146986), // Rule ID 15385 //
     /* 1146911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1146914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1146922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1146925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1146928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1146931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1146934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1146950 */     // MIs[0] round
     /* 1146950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1146953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1146960 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1146960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1146963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1146965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1146967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1146969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1146971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1146973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1146978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1146981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1146984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1146985 */     // GIR_Coverage, 15385,
     /* 1146985 */     GIR_EraseRootFromParent_Done,
     /* 1146986 */   // Label 16764: @1146986
     /* 1146986 */   GIM_Try, /*On fail goto*//*Label 16765*/ GIMT_Encode4(1147066), // Rule ID 15388 //
     /* 1146991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1146994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1146999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1147011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147030 */     // MIs[0] round
     /* 1147030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147040 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1147043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147065 */     // GIR_Coverage, 15388,
     /* 1147065 */     GIR_EraseRootFromParent_Done,
     /* 1147066 */   // Label 16765: @1147066
     /* 1147066 */   GIM_Try, /*On fail goto*//*Label 16766*/ GIMT_Encode4(1147146), // Rule ID 15389 //
     /* 1147071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1147082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1147085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1147088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1147091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147110 */     // MIs[0] round
     /* 1147110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147120 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1147123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1147141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147145 */     // GIR_Coverage, 15389,
     /* 1147145 */     GIR_EraseRootFromParent_Done,
     /* 1147146 */   // Label 16766: @1147146
     /* 1147146 */   GIM_Try, /*On fail goto*//*Label 16767*/ GIMT_Encode4(1147226), // Rule ID 15392 //
     /* 1147151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1147162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1147165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1147168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1147171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147190 */     // MIs[0] round
     /* 1147190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147200 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1147203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147225 */     // GIR_Coverage, 15392,
     /* 1147225 */     GIR_EraseRootFromParent_Done,
     /* 1147226 */   // Label 16767: @1147226
     /* 1147226 */   GIM_Try, /*On fail goto*//*Label 16768*/ GIMT_Encode4(1147306), // Rule ID 15393 //
     /* 1147231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1147242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1147245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1147248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1147251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147270 */     // MIs[0] round
     /* 1147270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1147283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147305 */     // GIR_Coverage, 15393,
     /* 1147305 */     GIR_EraseRootFromParent_Done,
     /* 1147306 */   // Label 16768: @1147306
     /* 1147306 */   GIM_Try, /*On fail goto*//*Label 16769*/ GIMT_Encode4(1147386), // Rule ID 15396 //
     /* 1147311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1147322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1147325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1147328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1147331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147350 */     // MIs[0] round
     /* 1147350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147360 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1147363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147385 */     // GIR_Coverage, 15396,
     /* 1147385 */     GIR_EraseRootFromParent_Done,
     /* 1147386 */   // Label 16769: @1147386
     /* 1147386 */   GIM_Try, /*On fail goto*//*Label 16770*/ GIMT_Encode4(1147466), // Rule ID 15397 //
     /* 1147391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1147402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1147405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1147408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1147411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147430 */     // MIs[0] round
     /* 1147430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147440 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1147443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147465 */     // GIR_Coverage, 15397,
     /* 1147465 */     GIR_EraseRootFromParent_Done,
     /* 1147466 */   // Label 16770: @1147466
     /* 1147466 */   GIM_Try, /*On fail goto*//*Label 16771*/ GIMT_Encode4(1147546), // Rule ID 15400 //
     /* 1147471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1147482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1147485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1147488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1147491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147510 */     // MIs[0] round
     /* 1147510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147520 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1147523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147545 */     // GIR_Coverage, 15400,
     /* 1147545 */     GIR_EraseRootFromParent_Done,
     /* 1147546 */   // Label 16771: @1147546
     /* 1147546 */   GIM_Try, /*On fail goto*//*Label 16772*/ GIMT_Encode4(1147626), // Rule ID 15401 //
     /* 1147551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1147562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1147565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1147568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1147571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147590 */     // MIs[0] round
     /* 1147590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147600 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1147603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1147621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147625 */     // GIR_Coverage, 15401,
     /* 1147625 */     GIR_EraseRootFromParent_Done,
     /* 1147626 */   // Label 16772: @1147626
     /* 1147626 */   GIM_Try, /*On fail goto*//*Label 16773*/ GIMT_Encode4(1147706), // Rule ID 15404 //
     /* 1147631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1147642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1147645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1147648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1147651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147670 */     // MIs[0] round
     /* 1147670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147680 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1147683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147705 */     // GIR_Coverage, 15404,
     /* 1147705 */     GIR_EraseRootFromParent_Done,
     /* 1147706 */   // Label 16773: @1147706
     /* 1147706 */   GIM_Try, /*On fail goto*//*Label 16774*/ GIMT_Encode4(1147786), // Rule ID 15405 //
     /* 1147711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1147722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1147725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1147728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1147731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1147750 */     // MIs[0] round
     /* 1147750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1147763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147785 */     // GIR_Coverage, 15405,
     /* 1147785 */     GIR_EraseRootFromParent_Done,
     /* 1147786 */   // Label 16774: @1147786
     /* 1147786 */   GIM_Try, /*On fail goto*//*Label 16775*/ GIMT_Encode4(1147866), // Rule ID 15408 //
     /* 1147791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1147802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1147805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1147808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1147811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147830 */     // MIs[0] round
     /* 1147830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147840 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1147840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1147843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147865 */     // GIR_Coverage, 15408,
     /* 1147865 */     GIR_EraseRootFromParent_Done,
     /* 1147866 */   // Label 16775: @1147866
     /* 1147866 */   GIM_Try, /*On fail goto*//*Label 16776*/ GIMT_Encode4(1147946), // Rule ID 15409 //
     /* 1147871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1147874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1147882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1147885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1147888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1147891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1147894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1147910 */     // MIs[0] round
     /* 1147910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1147920 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1147920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1147923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1147925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1147927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1147929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1147931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1147933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1147938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1147941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1147944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1147945 */     // GIR_Coverage, 15409,
     /* 1147945 */     GIR_EraseRootFromParent_Done,
     /* 1147946 */   // Label 16776: @1147946
     /* 1147946 */   GIM_Try, /*On fail goto*//*Label 16777*/ GIMT_Encode4(1148026), // Rule ID 15412 //
     /* 1147951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1147954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1147959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1147962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1147965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1147968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1147971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1147974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1147990 */     // MIs[0] round
     /* 1147990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1147993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1148003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148025 */     // GIR_Coverage, 15412,
     /* 1148025 */     GIR_EraseRootFromParent_Done,
     /* 1148026 */   // Label 16777: @1148026
     /* 1148026 */   GIM_Try, /*On fail goto*//*Label 16778*/ GIMT_Encode4(1148106), // Rule ID 15413 //
     /* 1148031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1148042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1148045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1148048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1148051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148070 */     // MIs[0] round
     /* 1148070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1148083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1148101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148105 */     // GIR_Coverage, 15413,
     /* 1148105 */     GIR_EraseRootFromParent_Done,
     /* 1148106 */   // Label 16778: @1148106
     /* 1148106 */   GIM_Try, /*On fail goto*//*Label 16779*/ GIMT_Encode4(1148186), // Rule ID 15416 //
     /* 1148111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1148122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1148125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1148128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1148131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148150 */     // MIs[0] round
     /* 1148150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1148163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148185 */     // GIR_Coverage, 15416,
     /* 1148185 */     GIR_EraseRootFromParent_Done,
     /* 1148186 */   // Label 16779: @1148186
     /* 1148186 */   GIM_Try, /*On fail goto*//*Label 16780*/ GIMT_Encode4(1148266), // Rule ID 15417 //
     /* 1148191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1148202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1148205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1148208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1148211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1148230 */     // MIs[0] round
     /* 1148230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2),
     /* 1148243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148265 */     // GIR_Coverage, 15417,
     /* 1148265 */     GIR_EraseRootFromParent_Done,
     /* 1148266 */   // Label 16780: @1148266
     /* 1148266 */   GIM_Try, /*On fail goto*//*Label 16781*/ GIMT_Encode4(1148346), // Rule ID 15420 //
     /* 1148271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1148282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1148285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1148288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1148291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148310 */     // MIs[0] round
     /* 1148310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148320 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1148323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148345 */     // GIR_Coverage, 15420,
     /* 1148345 */     GIR_EraseRootFromParent_Done,
     /* 1148346 */   // Label 16781: @1148346
     /* 1148346 */   GIM_Try, /*On fail goto*//*Label 16782*/ GIMT_Encode4(1148426), // Rule ID 15421 //
     /* 1148351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1148362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1148365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1148368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1148371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1148390 */     // MIs[0] round
     /* 1148390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4),
     /* 1148403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148425 */     // GIR_Coverage, 15421,
     /* 1148425 */     GIR_EraseRootFromParent_Done,
     /* 1148426 */   // Label 16782: @1148426
     /* 1148426 */   GIM_Try, /*On fail goto*//*Label 16783*/ GIMT_Encode4(1148506), // Rule ID 15424 //
     /* 1148431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1148434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1148442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1148445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1148448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1148451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148470 */     // MIs[0] round
     /* 1148470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1148483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148505 */     // GIR_Coverage, 15424,
     /* 1148505 */     GIR_EraseRootFromParent_Done,
     /* 1148506 */   // Label 16783: @1148506
     /* 1148506 */   GIM_Try, /*On fail goto*//*Label 16784*/ GIMT_Encode4(1148586), // Rule ID 15425 //
     /* 1148511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1148514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1148522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1148525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1148528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1148531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1148550 */     // MIs[0] round
     /* 1148550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8),
     /* 1148563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1148581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148585 */     // GIR_Coverage, 15425,
     /* 1148585 */     GIR_EraseRootFromParent_Done,
     /* 1148586 */   // Label 16784: @1148586
     /* 1148586 */   GIM_Try, /*On fail goto*//*Label 16785*/ GIMT_Encode4(1148666), // Rule ID 15428 //
     /* 1148591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1148602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1148605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1148608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148630 */     // MIs[0] round
     /* 1148630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148640 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1148643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148665 */     // GIR_Coverage, 15428,
     /* 1148665 */     GIR_EraseRootFromParent_Done,
     /* 1148666 */   // Label 16785: @1148666
     /* 1148666 */   GIM_Try, /*On fail goto*//*Label 16786*/ GIMT_Encode4(1148746), // Rule ID 15429 //
     /* 1148671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1148682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1148685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1148688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148710 */     // MIs[0] round
     /* 1148710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148720 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8),
     /* 1148723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148745 */     // GIR_Coverage, 15429,
     /* 1148745 */     GIR_EraseRootFromParent_Done,
     /* 1148746 */   // Label 16786: @1148746
     /* 1148746 */   GIM_Try, /*On fail goto*//*Label 16787*/ GIMT_Encode4(1148826), // Rule ID 15432 //
     /* 1148751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1148762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1148765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1148768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148790 */     // MIs[0] round
     /* 1148790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148800 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1148803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148825 */     // GIR_Coverage, 15432,
     /* 1148825 */     GIR_EraseRootFromParent_Done,
     /* 1148826 */   // Label 16787: @1148826
     /* 1148826 */   GIM_Try, /*On fail goto*//*Label 16788*/ GIMT_Encode4(1148906), // Rule ID 15433 //
     /* 1148831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1148842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1148845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1148848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1148851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1148854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148870 */     // MIs[0] round
     /* 1148870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1148880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1148883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148905 */     // GIR_Coverage, 15433,
     /* 1148905 */     GIR_EraseRootFromParent_Done,
     /* 1148906 */   // Label 16788: @1148906
     /* 1148906 */   GIM_Try, /*On fail goto*//*Label 16789*/ GIMT_Encode4(1148986), // Rule ID 15436 //
     /* 1148911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1148914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1148922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1148925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1148928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1148931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1148934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1148946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1148950 */     // MIs[0] round
     /* 1148950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1148953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1148960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1148960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1148963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1148965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1148967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1148969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1148971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1148973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1148978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1148981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1148984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1148985 */     // GIR_Coverage, 15436,
     /* 1148985 */     GIR_EraseRootFromParent_Done,
     /* 1148986 */   // Label 16789: @1148986
     /* 1148986 */   GIM_Try, /*On fail goto*//*Label 16790*/ GIMT_Encode4(1149066), // Rule ID 15437 //
     /* 1148991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1148994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1148999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1149002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1149005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1149008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149030 */     // MIs[0] round
     /* 1149030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149040 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1149043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149065 */     // GIR_Coverage, 15437,
     /* 1149065 */     GIR_EraseRootFromParent_Done,
     /* 1149066 */   // Label 16790: @1149066
     /* 1149066 */   GIM_Try, /*On fail goto*//*Label 16791*/ GIMT_Encode4(1149146), // Rule ID 15440 //
     /* 1149071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1149088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149110 */     // MIs[0] round
     /* 1149110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1149123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149145 */     // GIR_Coverage, 15440,
     /* 1149145 */     GIR_EraseRootFromParent_Done,
     /* 1149146 */   // Label 16791: @1149146
     /* 1149146 */   GIM_Try, /*On fail goto*//*Label 16792*/ GIMT_Encode4(1149226), // Rule ID 15441 //
     /* 1149151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1149162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1149165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1149168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149190 */     // MIs[0] round
     /* 1149190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4),
     /* 1149203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149225 */     // GIR_Coverage, 15441,
     /* 1149225 */     GIR_EraseRootFromParent_Done,
     /* 1149226 */   // Label 16792: @1149226
     /* 1149226 */   GIM_Try, /*On fail goto*//*Label 16793*/ GIMT_Encode4(1149306), // Rule ID 15444 //
     /* 1149231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1149242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1149245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1149248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149270 */     // MIs[0] round
     /* 1149270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149280 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1149283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149305 */     // GIR_Coverage, 15444,
     /* 1149305 */     GIR_EraseRootFromParent_Done,
     /* 1149306 */   // Label 16793: @1149306
     /* 1149306 */   GIM_Try, /*On fail goto*//*Label 16794*/ GIMT_Encode4(1149386), // Rule ID 15445 //
     /* 1149311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1149322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1149325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1149328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149350 */     // MIs[0] round
     /* 1149350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149360 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1149363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149385 */     // GIR_Coverage, 15445,
     /* 1149385 */     GIR_EraseRootFromParent_Done,
     /* 1149386 */   // Label 16794: @1149386
     /* 1149386 */   GIM_Try, /*On fail goto*//*Label 16795*/ GIMT_Encode4(1149466), // Rule ID 15448 //
     /* 1149391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1149402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1149405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1149408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149430 */     // MIs[0] round
     /* 1149430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149440 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1149443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149465 */     // GIR_Coverage, 15448,
     /* 1149465 */     GIR_EraseRootFromParent_Done,
     /* 1149466 */   // Label 16795: @1149466
     /* 1149466 */   GIM_Try, /*On fail goto*//*Label 16796*/ GIMT_Encode4(1149546), // Rule ID 15449 //
     /* 1149471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1149482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1149485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1149488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149510 */     // MIs[0] round
     /* 1149510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149520 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2),
     /* 1149523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149545 */     // GIR_Coverage, 15449,
     /* 1149545 */     GIR_EraseRootFromParent_Done,
     /* 1149546 */   // Label 16796: @1149546
     /* 1149546 */   GIM_Try, /*On fail goto*//*Label 16797*/ GIMT_Encode4(1149626), // Rule ID 15452 //
     /* 1149551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1149562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1149565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1149568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149590 */     // MIs[0] round
     /* 1149590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149600 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1149603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149625 */     // GIR_Coverage, 15452,
     /* 1149625 */     GIR_EraseRootFromParent_Done,
     /* 1149626 */   // Label 16797: @1149626
     /* 1149626 */   GIM_Try, /*On fail goto*//*Label 16798*/ GIMT_Encode4(1149706), // Rule ID 15453 //
     /* 1149631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1149642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1149645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1149648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149670 */     // MIs[0] round
     /* 1149670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11069:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1149683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1149701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149705 */     // GIR_Coverage, 15453,
     /* 1149705 */     GIR_EraseRootFromParent_Done,
     /* 1149706 */   // Label 16798: @1149706
     /* 1149706 */   GIM_Try, /*On fail goto*//*Label 16799*/ GIMT_Encode4(1149786), // Rule ID 15456 //
     /* 1149711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1149722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1149725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1149728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149750 */     // MIs[0] round
     /* 1149750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149760 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1149763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149785 */     // GIR_Coverage, 15456,
     /* 1149785 */     GIR_EraseRootFromParent_Done,
     /* 1149786 */   // Label 16799: @1149786
     /* 1149786 */   GIM_Try, /*On fail goto*//*Label 16800*/ GIMT_Encode4(1149866), // Rule ID 15457 //
     /* 1149791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1149802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1149805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1149808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149830 */     // MIs[0] round
     /* 1149830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11069:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1149840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1149843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1149861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149865 */     // GIR_Coverage, 15457,
     /* 1149865 */     GIR_EraseRootFromParent_Done,
     /* 1149866 */   // Label 16800: @1149866
     /* 1149866 */   GIM_Try, /*On fail goto*//*Label 16801*/ GIMT_Encode4(1149946), // Rule ID 15460 //
     /* 1149871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1149874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1149882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1149885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1149888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1149891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1149894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149910 */     // MIs[0] round
     /* 1149910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1149920 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1149920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1149923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1149925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1149927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1149929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1149931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1149933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1149938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1149941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1149944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1149945 */     // GIR_Coverage, 15460,
     /* 1149945 */     GIR_EraseRootFromParent_Done,
     /* 1149946 */   // Label 16801: @1149946
     /* 1149946 */   GIM_Try, /*On fail goto*//*Label 16802*/ GIMT_Encode4(1150026), // Rule ID 15461 //
     /* 1149951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1149954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1149959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1149962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1149965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1149968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1149971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1149974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1149986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1149990 */     // MIs[0] round
     /* 1149990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1149993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11069:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1150003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1150021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150025 */     // GIR_Coverage, 15461,
     /* 1150025 */     GIR_EraseRootFromParent_Done,
     /* 1150026 */   // Label 16802: @1150026
     /* 1150026 */   GIM_Try, /*On fail goto*//*Label 16803*/ GIMT_Encode4(1150106), // Rule ID 15464 //
     /* 1150031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1150034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150070 */     // MIs[0] round
     /* 1150070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1150083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150105 */     // GIR_Coverage, 15464,
     /* 1150105 */     GIR_EraseRootFromParent_Done,
     /* 1150106 */   // Label 16803: @1150106
     /* 1150106 */   GIM_Try, /*On fail goto*//*Label 16804*/ GIMT_Encode4(1150186), // Rule ID 15465 //
     /* 1150111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1150114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1150122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1150125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1150128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1150146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150150 */     // MIs[0] round
     /* 1150150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150160 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11069:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1),
     /* 1150163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1150181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150185 */     // GIR_Coverage, 15465,
     /* 1150185 */     GIR_EraseRootFromParent_Done,
     /* 1150186 */   // Label 16804: @1150186
     /* 1150186 */   GIM_Try, /*On fail goto*//*Label 16805*/ GIMT_Encode4(1150266), // Rule ID 15468 //
     /* 1150191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1150202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1150205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1150208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150230 */     // MIs[0] round
     /* 1150230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150240 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1150243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150265 */     // GIR_Coverage, 15468,
     /* 1150265 */     GIR_EraseRootFromParent_Done,
     /* 1150266 */   // Label 16805: @1150266
     /* 1150266 */   GIM_Try, /*On fail goto*//*Label 16806*/ GIMT_Encode4(1150346), // Rule ID 15469 //
     /* 1150271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1150282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1150285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1150288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150310 */     // MIs[0] round
     /* 1150310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1150323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150345 */     // GIR_Coverage, 15469,
     /* 1150345 */     GIR_EraseRootFromParent_Done,
     /* 1150346 */   // Label 16806: @1150346
     /* 1150346 */   GIM_Try, /*On fail goto*//*Label 16807*/ GIMT_Encode4(1150426), // Rule ID 15472 //
     /* 1150351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1150362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1150365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1150368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150390 */     // MIs[0] round
     /* 1150390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150400 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1150403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150425 */     // GIR_Coverage, 15472,
     /* 1150425 */     GIR_EraseRootFromParent_Done,
     /* 1150426 */   // Label 16807: @1150426
     /* 1150426 */   GIM_Try, /*On fail goto*//*Label 16808*/ GIMT_Encode4(1150506), // Rule ID 15473 //
     /* 1150431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1150442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1150445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1150448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150470 */     // MIs[0] round
     /* 1150470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150480 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1150483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150505 */     // GIR_Coverage, 15473,
     /* 1150505 */     GIR_EraseRootFromParent_Done,
     /* 1150506 */   // Label 16808: @1150506
     /* 1150506 */   GIM_Try, /*On fail goto*//*Label 16809*/ GIMT_Encode4(1150586), // Rule ID 15476 //
     /* 1150511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1150522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1150525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1150528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150550 */     // MIs[0] round
     /* 1150550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150560 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1150563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150585 */     // GIR_Coverage, 15476,
     /* 1150585 */     GIR_EraseRootFromParent_Done,
     /* 1150586 */   // Label 16809: @1150586
     /* 1150586 */   GIM_Try, /*On fail goto*//*Label 16810*/ GIMT_Encode4(1150666), // Rule ID 15477 //
     /* 1150591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1150602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1150605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1150608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1150626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150630 */     // MIs[0] round
     /* 1150630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150640 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1150643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1150661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150665 */     // GIR_Coverage, 15477,
     /* 1150665 */     GIR_EraseRootFromParent_Done,
     /* 1150666 */   // Label 16810: @1150666
     /* 1150666 */   GIM_Try, /*On fail goto*//*Label 16811*/ GIMT_Encode4(1150746), // Rule ID 15480 //
     /* 1150671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1150682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1150685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1150688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150710 */     // MIs[0] round
     /* 1150710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1150723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150745 */     // GIR_Coverage, 15480,
     /* 1150745 */     GIR_EraseRootFromParent_Done,
     /* 1150746 */   // Label 16811: @1150746
     /* 1150746 */   GIM_Try, /*On fail goto*//*Label 16812*/ GIMT_Encode4(1150826), // Rule ID 15481 //
     /* 1150751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1150762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1150765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1150768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1150786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150790 */     // MIs[0] round
     /* 1150790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150800 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1150803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150825 */     // GIR_Coverage, 15481,
     /* 1150825 */     GIR_EraseRootFromParent_Done,
     /* 1150826 */   // Label 16812: @1150826
     /* 1150826 */   GIM_Try, /*On fail goto*//*Label 16813*/ GIMT_Encode4(1150906), // Rule ID 15484 //
     /* 1150831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1150842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1150845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1150848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1150851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1150854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150870 */     // MIs[0] round
     /* 1150870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150880 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1150880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1150883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150905 */     // GIR_Coverage, 15484,
     /* 1150905 */     GIR_EraseRootFromParent_Done,
     /* 1150906 */   // Label 16813: @1150906
     /* 1150906 */   GIM_Try, /*On fail goto*//*Label 16814*/ GIMT_Encode4(1150986), // Rule ID 15485 //
     /* 1150911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1150914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1150922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1150925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1150928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1150931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1150934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1150946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1150950 */     // MIs[0] round
     /* 1150950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1150953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1150960 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1150960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1150963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1150965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1150967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1150969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1150971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1150973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1150978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1150981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1150984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1150985 */     // GIR_Coverage, 15485,
     /* 1150985 */     GIR_EraseRootFromParent_Done,
     /* 1150986 */   // Label 16814: @1150986
     /* 1150986 */   GIM_Try, /*On fail goto*//*Label 16815*/ GIMT_Encode4(1151066), // Rule ID 15488 //
     /* 1150991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1150994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1150999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151030 */     // MIs[0] round
     /* 1151030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1151043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151065 */     // GIR_Coverage, 15488,
     /* 1151065 */     GIR_EraseRootFromParent_Done,
     /* 1151066 */   // Label 16815: @1151066
     /* 1151066 */   GIM_Try, /*On fail goto*//*Label 16816*/ GIMT_Encode4(1151146), // Rule ID 15489 //
     /* 1151071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1151082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1151085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1151088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151110 */     // MIs[0] round
     /* 1151110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1151123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1151141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151145 */     // GIR_Coverage, 15489,
     /* 1151145 */     GIR_EraseRootFromParent_Done,
     /* 1151146 */   // Label 16816: @1151146
     /* 1151146 */   GIM_Try, /*On fail goto*//*Label 16817*/ GIMT_Encode4(1151226), // Rule ID 15492 //
     /* 1151151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1151162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1151165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1151168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151190 */     // MIs[0] round
     /* 1151190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1151203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151225 */     // GIR_Coverage, 15492,
     /* 1151225 */     GIR_EraseRootFromParent_Done,
     /* 1151226 */   // Label 16817: @1151226
     /* 1151226 */   GIM_Try, /*On fail goto*//*Label 16818*/ GIMT_Encode4(1151306), // Rule ID 15493 //
     /* 1151231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1151242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1151245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1151248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151270 */     // MIs[0] round
     /* 1151270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1151283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151305 */     // GIR_Coverage, 15493,
     /* 1151305 */     GIR_EraseRootFromParent_Done,
     /* 1151306 */   // Label 16818: @1151306
     /* 1151306 */   GIM_Try, /*On fail goto*//*Label 16819*/ GIMT_Encode4(1151386), // Rule ID 15496 //
     /* 1151311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1151322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1151325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1151328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151350 */     // MIs[0] round
     /* 1151350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151360 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1151363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151385 */     // GIR_Coverage, 15496,
     /* 1151385 */     GIR_EraseRootFromParent_Done,
     /* 1151386 */   // Label 16819: @1151386
     /* 1151386 */   GIM_Try, /*On fail goto*//*Label 16820*/ GIMT_Encode4(1151466), // Rule ID 15497 //
     /* 1151391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1151402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1151405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1151408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151430 */     // MIs[0] round
     /* 1151430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1151443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151465 */     // GIR_Coverage, 15497,
     /* 1151465 */     GIR_EraseRootFromParent_Done,
     /* 1151466 */   // Label 16820: @1151466
     /* 1151466 */   GIM_Try, /*On fail goto*//*Label 16821*/ GIMT_Encode4(1151546), // Rule ID 15500 //
     /* 1151471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1151474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1151482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1151485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1151488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151510 */     // MIs[0] round
     /* 1151510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151520 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1151523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151545 */     // GIR_Coverage, 15500,
     /* 1151545 */     GIR_EraseRootFromParent_Done,
     /* 1151546 */   // Label 16821: @1151546
     /* 1151546 */   GIM_Try, /*On fail goto*//*Label 16822*/ GIMT_Encode4(1151626), // Rule ID 15501 //
     /* 1151551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1151554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1151562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1151565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1151568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151590 */     // MIs[0] round
     /* 1151590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1151603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1151621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151625 */     // GIR_Coverage, 15501,
     /* 1151625 */     GIR_EraseRootFromParent_Done,
     /* 1151626 */   // Label 16822: @1151626
     /* 1151626 */   GIM_Try, /*On fail goto*//*Label 16823*/ GIMT_Encode4(1151706), // Rule ID 15504 //
     /* 1151631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1151642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1151645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1151648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151670 */     // MIs[0] round
     /* 1151670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151680 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1151683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151705 */     // GIR_Coverage, 15504,
     /* 1151705 */     GIR_EraseRootFromParent_Done,
     /* 1151706 */   // Label 16823: @1151706
     /* 1151706 */   GIM_Try, /*On fail goto*//*Label 16824*/ GIMT_Encode4(1151786), // Rule ID 15505 //
     /* 1151711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1151722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1151725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1151728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1151746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151750 */     // MIs[0] round
     /* 1151750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11069:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2),
     /* 1151763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151785 */     // GIR_Coverage, 15505,
     /* 1151785 */     GIR_EraseRootFromParent_Done,
     /* 1151786 */   // Label 16824: @1151786
     /* 1151786 */   GIM_Try, /*On fail goto*//*Label 16825*/ GIMT_Encode4(1151866), // Rule ID 15508 //
     /* 1151791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1151802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1151805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1151808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151830 */     // MIs[0] round
     /* 1151830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151840 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1151840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1151843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151865 */     // GIR_Coverage, 15508,
     /* 1151865 */     GIR_EraseRootFromParent_Done,
     /* 1151866 */   // Label 16825: @1151866
     /* 1151866 */   GIM_Try, /*On fail goto*//*Label 16826*/ GIMT_Encode4(1151946), // Rule ID 15509 //
     /* 1151871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1151874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1151882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1151885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1151888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1151891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1151894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1151906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151910 */     // MIs[0] round
     /* 1151910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1151920 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11069:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1151920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4),
     /* 1151923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1151925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1151927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1151929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1151931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1151933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1151938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1151941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1151944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1151945 */     // GIR_Coverage, 15509,
     /* 1151945 */     GIR_EraseRootFromParent_Done,
     /* 1151946 */   // Label 16826: @1151946
     /* 1151946 */   GIM_Try, /*On fail goto*//*Label 16827*/ GIMT_Encode4(1152026), // Rule ID 15512 //
     /* 1151951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1151954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1151959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1151962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1151965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1151968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1151971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1151974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1151986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1151990 */     // MIs[0] round
     /* 1151990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1151993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152000 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1152003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152025 */     // GIR_Coverage, 15512,
     /* 1152025 */     GIR_EraseRootFromParent_Done,
     /* 1152026 */   // Label 16827: @1152026
     /* 1152026 */   GIM_Try, /*On fail goto*//*Label 16828*/ GIMT_Encode4(1152106), // Rule ID 15513 //
     /* 1152031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1152034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd),
     /* 1152039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1152042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1152045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1152048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1152051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1152066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1152070 */     // MIs[0] round
     /* 1152070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11069:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVAADD_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8),
     /* 1152083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1152101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152105 */     // GIR_Coverage, 15513,
     /* 1152105 */     GIR_EraseRootFromParent_Done,
     /* 1152106 */   // Label 16828: @1152106
     /* 1152106 */   GIM_Try, /*On fail goto*//*Label 16829*/ GIMT_Encode4(1152189), // Rule ID 15516 //
     /* 1152111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1152122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1152125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1152128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1152131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152150 */     // MIs[0] round
     /* 1152150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152160 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1152163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152188 */     // GIR_Coverage, 15516,
     /* 1152188 */     GIR_EraseRootFromParent_Done,
     /* 1152189 */   // Label 16829: @1152189
     /* 1152189 */   GIM_Try, /*On fail goto*//*Label 16830*/ GIMT_Encode4(1152272), // Rule ID 15517 //
     /* 1152194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1152205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1152208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1152211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1152214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152233 */     // MIs[0] round
     /* 1152233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152243 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8),
     /* 1152246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152254 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152271 */     // GIR_Coverage, 15517,
     /* 1152271 */     GIR_EraseRootFromParent_Done,
     /* 1152272 */   // Label 16830: @1152272
     /* 1152272 */   GIM_Try, /*On fail goto*//*Label 16831*/ GIMT_Encode4(1152355), // Rule ID 15520 //
     /* 1152277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1152288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1152291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1152294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1152297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152316 */     // MIs[0] round
     /* 1152316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152326 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1152329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152354 */     // GIR_Coverage, 15520,
     /* 1152354 */     GIR_EraseRootFromParent_Done,
     /* 1152355 */   // Label 16831: @1152355
     /* 1152355 */   GIM_Try, /*On fail goto*//*Label 16832*/ GIMT_Encode4(1152438), // Rule ID 15521 //
     /* 1152360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1152371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1152374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1152377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1152380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152399 */     // MIs[0] round
     /* 1152399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1152412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152420 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152437 */     // GIR_Coverage, 15521,
     /* 1152437 */     GIR_EraseRootFromParent_Done,
     /* 1152438 */   // Label 16832: @1152438
     /* 1152438 */   GIM_Try, /*On fail goto*//*Label 16833*/ GIMT_Encode4(1152521), // Rule ID 15524 //
     /* 1152443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1152454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1152457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1152460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1152463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152482 */     // MIs[0] round
     /* 1152482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1152495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152516 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152520 */     // GIR_Coverage, 15524,
     /* 1152520 */     GIR_EraseRootFromParent_Done,
     /* 1152521 */   // Label 16833: @1152521
     /* 1152521 */   GIM_Try, /*On fail goto*//*Label 16834*/ GIMT_Encode4(1152604), // Rule ID 15525 //
     /* 1152526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1152537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1152540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1152543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1152546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152565 */     // MIs[0] round
     /* 1152565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152575 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1152578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152586 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1152596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152602 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152603 */     // GIR_Coverage, 15525,
     /* 1152603 */     GIR_EraseRootFromParent_Done,
     /* 1152604 */   // Label 16834: @1152604
     /* 1152604 */   GIM_Try, /*On fail goto*//*Label 16835*/ GIMT_Encode4(1152687), // Rule ID 15528 //
     /* 1152609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1152620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1152623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1152626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1152629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152648 */     // MIs[0] round
     /* 1152648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152658 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1152661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152686 */     // GIR_Coverage, 15528,
     /* 1152686 */     GIR_EraseRootFromParent_Done,
     /* 1152687 */   // Label 16835: @1152687
     /* 1152687 */   GIM_Try, /*On fail goto*//*Label 16836*/ GIMT_Encode4(1152770), // Rule ID 15529 //
     /* 1152692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1152703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1152706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1152709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1152712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152731 */     // MIs[0] round
     /* 1152731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152741 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4),
     /* 1152744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152752 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152765 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152769 */     // GIR_Coverage, 15529,
     /* 1152769 */     GIR_EraseRootFromParent_Done,
     /* 1152770 */   // Label 16836: @1152770
     /* 1152770 */   GIM_Try, /*On fail goto*//*Label 16837*/ GIMT_Encode4(1152853), // Rule ID 15532 //
     /* 1152775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1152786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1152789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1152792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1152795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152814 */     // MIs[0] round
     /* 1152814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152824 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1152827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152848 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152852 */     // GIR_Coverage, 15532,
     /* 1152852 */     GIR_EraseRootFromParent_Done,
     /* 1152853 */   // Label 16837: @1152853
     /* 1152853 */   GIM_Try, /*On fail goto*//*Label 16838*/ GIMT_Encode4(1152936), // Rule ID 15533 //
     /* 1152858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1152861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1152869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1152872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1152875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1152878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1152881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152897 */     // MIs[0] round
     /* 1152897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152907 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1152907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1152910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1152918 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1152920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1152925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1152928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1152931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1152935 */     // GIR_Coverage, 15533,
     /* 1152935 */     GIR_EraseRootFromParent_Done,
     /* 1152936 */   // Label 16838: @1152936
     /* 1152936 */   GIM_Try, /*On fail goto*//*Label 16839*/ GIMT_Encode4(1153019), // Rule ID 15536 //
     /* 1152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1152944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1152949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1152952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1152955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1152958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1152961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1152964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1152980 */     // MIs[0] round
     /* 1152980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1152983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1152990 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1152990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1152993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1152995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1152997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1152999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153018 */     // GIR_Coverage, 15536,
     /* 1153018 */     GIR_EraseRootFromParent_Done,
     /* 1153019 */   // Label 16839: @1153019
     /* 1153019 */   GIM_Try, /*On fail goto*//*Label 16840*/ GIMT_Encode4(1153102), // Rule ID 15537 //
     /* 1153024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1153035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1153038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1153041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1153044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153063 */     // MIs[0] round
     /* 1153063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153073 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2),
     /* 1153076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153084 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153101 */     // GIR_Coverage, 15537,
     /* 1153101 */     GIR_EraseRootFromParent_Done,
     /* 1153102 */   // Label 16840: @1153102
     /* 1153102 */   GIM_Try, /*On fail goto*//*Label 16841*/ GIMT_Encode4(1153185), // Rule ID 15540 //
     /* 1153107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1153118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1153121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1153124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1153127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153146 */     // MIs[0] round
     /* 1153146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153184 */     // GIR_Coverage, 15540,
     /* 1153184 */     GIR_EraseRootFromParent_Done,
     /* 1153185 */   // Label 16841: @1153185
     /* 1153185 */   GIM_Try, /*On fail goto*//*Label 16842*/ GIMT_Encode4(1153268), // Rule ID 15541 //
     /* 1153190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1153201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1153204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1153207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1153210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153229 */     // MIs[0] round
     /* 1153229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153239 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153250 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153267 */     // GIR_Coverage, 15541,
     /* 1153267 */     GIR_EraseRootFromParent_Done,
     /* 1153268 */   // Label 16842: @1153268
     /* 1153268 */   GIM_Try, /*On fail goto*//*Label 16843*/ GIMT_Encode4(1153351), // Rule ID 15544 //
     /* 1153273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1153284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1153287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1153290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1153293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153312 */     // MIs[0] round
     /* 1153312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153322 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153350 */     // GIR_Coverage, 15544,
     /* 1153350 */     GIR_EraseRootFromParent_Done,
     /* 1153351 */   // Label 16843: @1153351
     /* 1153351 */   GIM_Try, /*On fail goto*//*Label 16844*/ GIMT_Encode4(1153434), // Rule ID 15545 //
     /* 1153356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1153367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1153370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1153373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1153376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153395 */     // MIs[0] round
     /* 1153395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153405 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153416 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1153426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153433 */     // GIR_Coverage, 15545,
     /* 1153433 */     GIR_EraseRootFromParent_Done,
     /* 1153434 */   // Label 16844: @1153434
     /* 1153434 */   GIM_Try, /*On fail goto*//*Label 16845*/ GIMT_Encode4(1153517), // Rule ID 15548 //
     /* 1153439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1153450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1153453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1153456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1153459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153478 */     // MIs[0] round
     /* 1153478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153488 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153516 */     // GIR_Coverage, 15548,
     /* 1153516 */     GIR_EraseRootFromParent_Done,
     /* 1153517 */   // Label 16845: @1153517
     /* 1153517 */   GIM_Try, /*On fail goto*//*Label 16846*/ GIMT_Encode4(1153600), // Rule ID 15549 //
     /* 1153522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1153533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1153536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1153539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1153542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1153561 */     // MIs[0] round
     /* 1153561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153571 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1153574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153582 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1153592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153599 */     // GIR_Coverage, 15549,
     /* 1153599 */     GIR_EraseRootFromParent_Done,
     /* 1153600 */   // Label 16846: @1153600
     /* 1153600 */   GIM_Try, /*On fail goto*//*Label 16847*/ GIMT_Encode4(1153683), // Rule ID 15552 //
     /* 1153605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1153616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1153619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1153622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1153625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153644 */     // MIs[0] round
     /* 1153644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153654 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1153657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153682 */     // GIR_Coverage, 15552,
     /* 1153682 */     GIR_EraseRootFromParent_Done,
     /* 1153683 */   // Label 16847: @1153683
     /* 1153683 */   GIM_Try, /*On fail goto*//*Label 16848*/ GIMT_Encode4(1153766), // Rule ID 15553 //
     /* 1153688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1153699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1153702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1153705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1153708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1153727 */     // MIs[0] round
     /* 1153727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153737 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1153740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153748 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153765 */     // GIR_Coverage, 15553,
     /* 1153765 */     GIR_EraseRootFromParent_Done,
     /* 1153766 */   // Label 16848: @1153766
     /* 1153766 */   GIM_Try, /*On fail goto*//*Label 16849*/ GIMT_Encode4(1153849), // Rule ID 15556 //
     /* 1153771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1153782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1153785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1153788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1153791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153810 */     // MIs[0] round
     /* 1153810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153820 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1153823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153848 */     // GIR_Coverage, 15556,
     /* 1153848 */     GIR_EraseRootFromParent_Done,
     /* 1153849 */   // Label 16849: @1153849
     /* 1153849 */   GIM_Try, /*On fail goto*//*Label 16850*/ GIMT_Encode4(1153932), // Rule ID 15557 //
     /* 1153854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1153857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1153865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1153868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1153871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1153874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1153877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1153893 */     // MIs[0] round
     /* 1153893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153903 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1153903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1153906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153914 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1153921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1153924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1153927 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1153930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1153931 */     // GIR_Coverage, 15557,
     /* 1153931 */     GIR_EraseRootFromParent_Done,
     /* 1153932 */   // Label 16850: @1153932
     /* 1153932 */   GIM_Try, /*On fail goto*//*Label 16851*/ GIMT_Encode4(1154015), // Rule ID 15560 //
     /* 1153937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1153940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1153945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1153948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1153951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1153954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1153957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1153960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1153976 */     // MIs[0] round
     /* 1153976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1153979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1153986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1153986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1153989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1153991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1153993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1153995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1153997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1153999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154014 */     // GIR_Coverage, 15560,
     /* 1154014 */     GIR_EraseRootFromParent_Done,
     /* 1154015 */   // Label 16851: @1154015
     /* 1154015 */   GIM_Try, /*On fail goto*//*Label 16852*/ GIMT_Encode4(1154098), // Rule ID 15561 //
     /* 1154020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1154031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1154034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1154037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1154040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154059 */     // MIs[0] round
     /* 1154059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154069 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1154072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154080 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1154090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154097 */     // GIR_Coverage, 15561,
     /* 1154097 */     GIR_EraseRootFromParent_Done,
     /* 1154098 */   // Label 16852: @1154098
     /* 1154098 */   GIM_Try, /*On fail goto*//*Label 16853*/ GIMT_Encode4(1154181), // Rule ID 15564 //
     /* 1154103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1154114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1154117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1154120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1154123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154142 */     // MIs[0] round
     /* 1154142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1154155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154180 */     // GIR_Coverage, 15564,
     /* 1154180 */     GIR_EraseRootFromParent_Done,
     /* 1154181 */   // Label 16853: @1154181
     /* 1154181 */   GIM_Try, /*On fail goto*//*Label 16854*/ GIMT_Encode4(1154264), // Rule ID 15565 //
     /* 1154186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1154197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1154200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1154203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1154206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154225 */     // MIs[0] round
     /* 1154225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1154238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154246 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154262 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154263 */     // GIR_Coverage, 15565,
     /* 1154263 */     GIR_EraseRootFromParent_Done,
     /* 1154264 */   // Label 16854: @1154264
     /* 1154264 */   GIM_Try, /*On fail goto*//*Label 16855*/ GIMT_Encode4(1154347), // Rule ID 15568 //
     /* 1154269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1154280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1154283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1154286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1154289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154308 */     // MIs[0] round
     /* 1154308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1154321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154342 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154346 */     // GIR_Coverage, 15568,
     /* 1154346 */     GIR_EraseRootFromParent_Done,
     /* 1154347 */   // Label 16855: @1154347
     /* 1154347 */   GIM_Try, /*On fail goto*//*Label 16856*/ GIMT_Encode4(1154430), // Rule ID 15569 //
     /* 1154352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1154363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1154366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1154369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1154372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154391 */     // MIs[0] round
     /* 1154391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154401 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1154404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154412 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154429 */     // GIR_Coverage, 15569,
     /* 1154429 */     GIR_EraseRootFromParent_Done,
     /* 1154430 */   // Label 16856: @1154430
     /* 1154430 */   GIM_Try, /*On fail goto*//*Label 16857*/ GIMT_Encode4(1154513), // Rule ID 15572 //
     /* 1154435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1154446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1154449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1154452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1154455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154474 */     // MIs[0] round
     /* 1154474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154484 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1154487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154508 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154512 */     // GIR_Coverage, 15572,
     /* 1154512 */     GIR_EraseRootFromParent_Done,
     /* 1154513 */   // Label 16857: @1154513
     /* 1154513 */   GIM_Try, /*On fail goto*//*Label 16858*/ GIMT_Encode4(1154596), // Rule ID 15573 //
     /* 1154518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1154529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1154532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1154535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1154538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154557 */     // MIs[0] round
     /* 1154557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154567 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1154570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154578 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1154588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154595 */     // GIR_Coverage, 15573,
     /* 1154595 */     GIR_EraseRootFromParent_Done,
     /* 1154596 */   // Label 16858: @1154596
     /* 1154596 */   GIM_Try, /*On fail goto*//*Label 16859*/ GIMT_Encode4(1154679), // Rule ID 15576 //
     /* 1154601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1154612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1154615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1154618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1154621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154640 */     // MIs[0] round
     /* 1154640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1154653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154678 */     // GIR_Coverage, 15576,
     /* 1154678 */     GIR_EraseRootFromParent_Done,
     /* 1154679 */   // Label 16859: @1154679
     /* 1154679 */   GIM_Try, /*On fail goto*//*Label 16860*/ GIMT_Encode4(1154762), // Rule ID 15577 //
     /* 1154684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1154695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1154698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1154701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1154704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1154723 */     // MIs[0] round
     /* 1154723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154733 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1154736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154744 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154761 */     // GIR_Coverage, 15577,
     /* 1154761 */     GIR_EraseRootFromParent_Done,
     /* 1154762 */   // Label 16860: @1154762
     /* 1154762 */   GIM_Try, /*On fail goto*//*Label 16861*/ GIMT_Encode4(1154845), // Rule ID 15580 //
     /* 1154767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1154778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1154781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1154784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1154787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154806 */     // MIs[0] round
     /* 1154806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1154819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154840 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154844 */     // GIR_Coverage, 15580,
     /* 1154844 */     GIR_EraseRootFromParent_Done,
     /* 1154845 */   // Label 16861: @1154845
     /* 1154845 */   GIM_Try, /*On fail goto*//*Label 16862*/ GIMT_Encode4(1154928), // Rule ID 15581 //
     /* 1154850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1154853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1154861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1154864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1154867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1154870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1154873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1154889 */     // MIs[0] round
     /* 1154889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154899 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1154899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1154902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154910 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1154917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1154920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1154923 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1154926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1154927 */     // GIR_Coverage, 15581,
     /* 1154927 */     GIR_EraseRootFromParent_Done,
     /* 1154928 */   // Label 16862: @1154928
     /* 1154928 */   GIM_Try, /*On fail goto*//*Label 16863*/ GIMT_Encode4(1155011), // Rule ID 15584 //
     /* 1154933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1154936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1154941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1154944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1154947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1154950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1154953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1154956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1154972 */     // MIs[0] round
     /* 1154972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1154975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1154982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1154982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1154985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1154987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1154989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1154991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1154993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1154995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155006 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155010 */     // GIR_Coverage, 15584,
     /* 1155010 */     GIR_EraseRootFromParent_Done,
     /* 1155011 */   // Label 16863: @1155011
     /* 1155011 */   GIM_Try, /*On fail goto*//*Label 16864*/ GIMT_Encode4(1155094), // Rule ID 15585 //
     /* 1155016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1155027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1155030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1155033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1155036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1155055 */     // MIs[0] round
     /* 1155055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1155068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155076 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155093 */     // GIR_Coverage, 15585,
     /* 1155093 */     GIR_EraseRootFromParent_Done,
     /* 1155094 */   // Label 16864: @1155094
     /* 1155094 */   GIM_Try, /*On fail goto*//*Label 16865*/ GIMT_Encode4(1155177), // Rule ID 15588 //
     /* 1155099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1155110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1155113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1155116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155138 */     // MIs[0] round
     /* 1155138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155176 */     // GIR_Coverage, 15588,
     /* 1155176 */     GIR_EraseRootFromParent_Done,
     /* 1155177 */   // Label 16865: @1155177
     /* 1155177 */   GIM_Try, /*On fail goto*//*Label 16866*/ GIMT_Encode4(1155260), // Rule ID 15589 //
     /* 1155182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1155193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1155196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1155199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155221 */     // MIs[0] round
     /* 1155221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155231 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8),
     /* 1155234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155242 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155259 */     // GIR_Coverage, 15589,
     /* 1155259 */     GIR_EraseRootFromParent_Done,
     /* 1155260 */   // Label 16866: @1155260
     /* 1155260 */   GIM_Try, /*On fail goto*//*Label 16867*/ GIMT_Encode4(1155343), // Rule ID 15592 //
     /* 1155265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1155276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1155279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1155282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155304 */     // MIs[0] round
     /* 1155304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1155317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155338 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155342 */     // GIR_Coverage, 15592,
     /* 1155342 */     GIR_EraseRootFromParent_Done,
     /* 1155343 */   // Label 16867: @1155343
     /* 1155343 */   GIM_Try, /*On fail goto*//*Label 16868*/ GIMT_Encode4(1155426), // Rule ID 15593 //
     /* 1155348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1155359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1155362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1155365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155387 */     // MIs[0] round
     /* 1155387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155397 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1155400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155408 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155425 */     // GIR_Coverage, 15593,
     /* 1155425 */     GIR_EraseRootFromParent_Done,
     /* 1155426 */   // Label 16868: @1155426
     /* 1155426 */   GIM_Try, /*On fail goto*//*Label 16869*/ GIMT_Encode4(1155509), // Rule ID 15596 //
     /* 1155431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1155442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1155445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1155448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155470 */     // MIs[0] round
     /* 1155470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155480 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1155483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155504 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155508 */     // GIR_Coverage, 15596,
     /* 1155508 */     GIR_EraseRootFromParent_Done,
     /* 1155509 */   // Label 16869: @1155509
     /* 1155509 */   GIM_Try, /*On fail goto*//*Label 16870*/ GIMT_Encode4(1155592), // Rule ID 15597 //
     /* 1155514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1155525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1155528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1155531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155553 */     // MIs[0] round
     /* 1155553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155563 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1155566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155574 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1155584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155590 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155591 */     // GIR_Coverage, 15597,
     /* 1155591 */     GIR_EraseRootFromParent_Done,
     /* 1155592 */   // Label 16870: @1155592
     /* 1155592 */   GIM_Try, /*On fail goto*//*Label 16871*/ GIMT_Encode4(1155675), // Rule ID 15600 //
     /* 1155597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1155608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1155611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1155614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155636 */     // MIs[0] round
     /* 1155636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155646 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1155649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155674 */     // GIR_Coverage, 15600,
     /* 1155674 */     GIR_EraseRootFromParent_Done,
     /* 1155675 */   // Label 16871: @1155675
     /* 1155675 */   GIM_Try, /*On fail goto*//*Label 16872*/ GIMT_Encode4(1155758), // Rule ID 15601 //
     /* 1155680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1155691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1155694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1155697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155719 */     // MIs[0] round
     /* 1155719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155729 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4),
     /* 1155732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155740 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155757 */     // GIR_Coverage, 15601,
     /* 1155757 */     GIR_EraseRootFromParent_Done,
     /* 1155758 */   // Label 16872: @1155758
     /* 1155758 */   GIM_Try, /*On fail goto*//*Label 16873*/ GIMT_Encode4(1155841), // Rule ID 15604 //
     /* 1155763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1155774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1155777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1155780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155802 */     // MIs[0] round
     /* 1155802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155812 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1155815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155840 */     // GIR_Coverage, 15604,
     /* 1155840 */     GIR_EraseRootFromParent_Done,
     /* 1155841 */   // Label 16873: @1155841
     /* 1155841 */   GIM_Try, /*On fail goto*//*Label 16874*/ GIMT_Encode4(1155924), // Rule ID 15605 //
     /* 1155846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1155849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1155857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1155860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1155863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1155866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1155869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155885 */     // MIs[0] round
     /* 1155885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155895 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1155895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1155898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155900 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155906 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1155916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1155919 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1155922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1155923 */     // GIR_Coverage, 15605,
     /* 1155923 */     GIR_EraseRootFromParent_Done,
     /* 1155924 */   // Label 16874: @1155924
     /* 1155924 */   GIM_Try, /*On fail goto*//*Label 16875*/ GIMT_Encode4(1156007), // Rule ID 15608 //
     /* 1155929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1155932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1155937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1155940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1155943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1155946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1155949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1155952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1155964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1155968 */     // MIs[0] round
     /* 1155968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1155971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1155978 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1155978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1155981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1155983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1155985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1155987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1155989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1155991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1155996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1155999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156006 */     // GIR_Coverage, 15608,
     /* 1156006 */     GIR_EraseRootFromParent_Done,
     /* 1156007 */   // Label 16875: @1156007
     /* 1156007 */   GIM_Try, /*On fail goto*//*Label 16876*/ GIMT_Encode4(1156090), // Rule ID 15609 //
     /* 1156012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1156023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1156026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1156029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156051 */     // MIs[0] round
     /* 1156051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156061 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2),
     /* 1156064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156072 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156089 */     // GIR_Coverage, 15609,
     /* 1156089 */     GIR_EraseRootFromParent_Done,
     /* 1156090 */   // Label 16876: @1156090
     /* 1156090 */   GIM_Try, /*On fail goto*//*Label 16877*/ GIMT_Encode4(1156173), // Rule ID 15612 //
     /* 1156095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1156106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1156109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1156112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156134 */     // MIs[0] round
     /* 1156134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156144 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156168 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156172 */     // GIR_Coverage, 15612,
     /* 1156172 */     GIR_EraseRootFromParent_Done,
     /* 1156173 */   // Label 16877: @1156173
     /* 1156173 */   GIM_Try, /*On fail goto*//*Label 16878*/ GIMT_Encode4(1156256), // Rule ID 15613 //
     /* 1156178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1156189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1156192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1156195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156217 */     // MIs[0] round
     /* 1156217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156227 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11492:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156238 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156255 */     // GIR_Coverage, 15613,
     /* 1156255 */     GIR_EraseRootFromParent_Done,
     /* 1156256 */   // Label 16878: @1156256
     /* 1156256 */   GIM_Try, /*On fail goto*//*Label 16879*/ GIMT_Encode4(1156339), // Rule ID 15616 //
     /* 1156261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1156272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1156275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1156278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156300 */     // MIs[0] round
     /* 1156300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156338 */     // GIR_Coverage, 15616,
     /* 1156338 */     GIR_EraseRootFromParent_Done,
     /* 1156339 */   // Label 16879: @1156339
     /* 1156339 */   GIM_Try, /*On fail goto*//*Label 16880*/ GIMT_Encode4(1156422), // Rule ID 15617 //
     /* 1156344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1156355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1156358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1156361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156383 */     // MIs[0] round
     /* 1156383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156393 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11492:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156404 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1156414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156421 */     // GIR_Coverage, 15617,
     /* 1156421 */     GIR_EraseRootFromParent_Done,
     /* 1156422 */   // Label 16880: @1156422
     /* 1156422 */   GIM_Try, /*On fail goto*//*Label 16881*/ GIMT_Encode4(1156505), // Rule ID 15620 //
     /* 1156427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1156438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1156441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1156444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156466 */     // MIs[0] round
     /* 1156466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156476 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156500 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156504 */     // GIR_Coverage, 15620,
     /* 1156504 */     GIR_EraseRootFromParent_Done,
     /* 1156505 */   // Label 16881: @1156505
     /* 1156505 */   GIM_Try, /*On fail goto*//*Label 16882*/ GIMT_Encode4(1156588), // Rule ID 15621 //
     /* 1156510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1156521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1156524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1156527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1156545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156549 */     // MIs[0] round
     /* 1156549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156559 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11492:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1156562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156570 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1156580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156586 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156587 */     // GIR_Coverage, 15621,
     /* 1156587 */     GIR_EraseRootFromParent_Done,
     /* 1156588 */   // Label 16882: @1156588
     /* 1156588 */   GIM_Try, /*On fail goto*//*Label 16883*/ GIMT_Encode4(1156671), // Rule ID 15624 //
     /* 1156593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1156604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1156607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1156610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156632 */     // MIs[0] round
     /* 1156632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1156645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156666 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156670 */     // GIR_Coverage, 15624,
     /* 1156670 */     GIR_EraseRootFromParent_Done,
     /* 1156671 */   // Label 16883: @1156671
     /* 1156671 */   GIM_Try, /*On fail goto*//*Label 16884*/ GIMT_Encode4(1156754), // Rule ID 15625 //
     /* 1156676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1156687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1156690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1156693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1156711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156715 */     // MIs[0] round
     /* 1156715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156725 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1156728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156736 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156753 */     // GIR_Coverage, 15625,
     /* 1156753 */     GIR_EraseRootFromParent_Done,
     /* 1156754 */   // Label 16884: @1156754
     /* 1156754 */   GIM_Try, /*On fail goto*//*Label 16885*/ GIMT_Encode4(1156837), // Rule ID 15628 //
     /* 1156759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1156770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1156773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1156776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156798 */     // MIs[0] round
     /* 1156798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1156811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156836 */     // GIR_Coverage, 15628,
     /* 1156836 */     GIR_EraseRootFromParent_Done,
     /* 1156837 */   // Label 16885: @1156837
     /* 1156837 */   GIM_Try, /*On fail goto*//*Label 16886*/ GIMT_Encode4(1156920), // Rule ID 15629 //
     /* 1156842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1156845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1156853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1156856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1156859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1156862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1156865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1156877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156881 */     // MIs[0] round
     /* 1156881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156891 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1156891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1156894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156902 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1156918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1156919 */     // GIR_Coverage, 15629,
     /* 1156919 */     GIR_EraseRootFromParent_Done,
     /* 1156920 */   // Label 16886: @1156920
     /* 1156920 */   GIM_Try, /*On fail goto*//*Label 16887*/ GIMT_Encode4(1157003), // Rule ID 15632 //
     /* 1156925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1156928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1156933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1156936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1156939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1156942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1156945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1156948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1156960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1156964 */     // MIs[0] round
     /* 1156964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1156967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1156974 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1156974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1156977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1156979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1156981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1156983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1156985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1156987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1156992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1156995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1156998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157002 */     // GIR_Coverage, 15632,
     /* 1157002 */     GIR_EraseRootFromParent_Done,
     /* 1157003 */   // Label 16887: @1157003
     /* 1157003 */   GIM_Try, /*On fail goto*//*Label 16888*/ GIMT_Encode4(1157086), // Rule ID 15633 //
     /* 1157008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1157019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1157022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1157025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157047 */     // MIs[0] round
     /* 1157047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157057 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1157060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157068 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1157078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157085 */     // GIR_Coverage, 15633,
     /* 1157085 */     GIR_EraseRootFromParent_Done,
     /* 1157086 */   // Label 16888: @1157086
     /* 1157086 */   GIM_Try, /*On fail goto*//*Label 16889*/ GIMT_Encode4(1157169), // Rule ID 15636 //
     /* 1157091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1157102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1157105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1157108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157130 */     // MIs[0] round
     /* 1157130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1157143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157168 */     // GIR_Coverage, 15636,
     /* 1157168 */     GIR_EraseRootFromParent_Done,
     /* 1157169 */   // Label 16889: @1157169
     /* 1157169 */   GIM_Try, /*On fail goto*//*Label 16890*/ GIMT_Encode4(1157252), // Rule ID 15637 //
     /* 1157174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1157185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1157188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1157191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157213 */     // MIs[0] round
     /* 1157213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157223 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1157226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157234 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157251 */     // GIR_Coverage, 15637,
     /* 1157251 */     GIR_EraseRootFromParent_Done,
     /* 1157252 */   // Label 16890: @1157252
     /* 1157252 */   GIM_Try, /*On fail goto*//*Label 16891*/ GIMT_Encode4(1157335), // Rule ID 15640 //
     /* 1157257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1157268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1157271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1157274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157296 */     // MIs[0] round
     /* 1157296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1157309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157334 */     // GIR_Coverage, 15640,
     /* 1157334 */     GIR_EraseRootFromParent_Done,
     /* 1157335 */   // Label 16891: @1157335
     /* 1157335 */   GIM_Try, /*On fail goto*//*Label 16892*/ GIMT_Encode4(1157418), // Rule ID 15641 //
     /* 1157340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1157351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1157354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1157357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157379 */     // MIs[0] round
     /* 1157379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157389 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1157392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157400 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157417 */     // GIR_Coverage, 15641,
     /* 1157417 */     GIR_EraseRootFromParent_Done,
     /* 1157418 */   // Label 16892: @1157418
     /* 1157418 */   GIM_Try, /*On fail goto*//*Label 16893*/ GIMT_Encode4(1157501), // Rule ID 15644 //
     /* 1157423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1157434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1157437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1157440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157462 */     // MIs[0] round
     /* 1157462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1157475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157500 */     // GIR_Coverage, 15644,
     /* 1157500 */     GIR_EraseRootFromParent_Done,
     /* 1157501 */   // Label 16893: @1157501
     /* 1157501 */   GIM_Try, /*On fail goto*//*Label 16894*/ GIMT_Encode4(1157584), // Rule ID 15645 //
     /* 1157506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1157517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1157520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1157523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157545 */     // MIs[0] round
     /* 1157545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157555 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1157558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157566 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1157576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157583 */     // GIR_Coverage, 15645,
     /* 1157583 */     GIR_EraseRootFromParent_Done,
     /* 1157584 */   // Label 16894: @1157584
     /* 1157584 */   GIM_Try, /*On fail goto*//*Label 16895*/ GIMT_Encode4(1157667), // Rule ID 15648 //
     /* 1157589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1157600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1157603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1157606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157628 */     // MIs[0] round
     /* 1157628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1157641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157666 */     // GIR_Coverage, 15648,
     /* 1157666 */     GIR_EraseRootFromParent_Done,
     /* 1157667 */   // Label 16895: @1157667
     /* 1157667 */   GIM_Try, /*On fail goto*//*Label 16896*/ GIMT_Encode4(1157750), // Rule ID 15649 //
     /* 1157672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1157683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1157686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1157689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1157707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157711 */     // MIs[0] round
     /* 1157711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1157724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157732 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157749 */     // GIR_Coverage, 15649,
     /* 1157749 */     GIR_EraseRootFromParent_Done,
     /* 1157750 */   // Label 16896: @1157750
     /* 1157750 */   GIM_Try, /*On fail goto*//*Label 16897*/ GIMT_Encode4(1157833), // Rule ID 15652 //
     /* 1157755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1157766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1157769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1157772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157794 */     // MIs[0] round
     /* 1157794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157804 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1157807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157828 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157832 */     // GIR_Coverage, 15652,
     /* 1157832 */     GIR_EraseRootFromParent_Done,
     /* 1157833 */   // Label 16897: @1157833
     /* 1157833 */   GIM_Try, /*On fail goto*//*Label 16898*/ GIMT_Encode4(1157916), // Rule ID 15653 //
     /* 1157838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1157841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1157849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1157852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1157855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1157858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1157861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1157873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157877 */     // MIs[0] round
     /* 1157877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157887 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1157887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1157890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157898 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157915 */     // GIR_Coverage, 15653,
     /* 1157915 */     GIR_EraseRootFromParent_Done,
     /* 1157916 */   // Label 16898: @1157916
     /* 1157916 */   GIM_Try, /*On fail goto*//*Label 16899*/ GIMT_Encode4(1157999), // Rule ID 15656 //
     /* 1157921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1157924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1157929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1157932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1157935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1157938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1157941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1157944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1157956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1157960 */     // MIs[0] round
     /* 1157960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1157963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1157970 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1157970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1157973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1157975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1157977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1157979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1157981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1157983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1157988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1157991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1157994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1157997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1157998 */     // GIR_Coverage, 15656,
     /* 1157998 */     GIR_EraseRootFromParent_Done,
     /* 1157999 */   // Label 16899: @1157999
     /* 1157999 */   GIM_Try, /*On fail goto*//*Label 16900*/ GIMT_Encode4(1158082), // Rule ID 15657 //
     /* 1158004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1158007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1158015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1158018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1158021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158043 */     // MIs[0] round
     /* 1158043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158053 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1158056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158064 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1158074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158081 */     // GIR_Coverage, 15657,
     /* 1158081 */     GIR_EraseRootFromParent_Done,
     /* 1158082 */   // Label 16900: @1158082
     /* 1158082 */   GIM_Try, /*On fail goto*//*Label 16901*/ GIMT_Encode4(1158165), // Rule ID 15660 //
     /* 1158087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1158107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158126 */     // MIs[0] round
     /* 1158126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158160 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158164 */     // GIR_Coverage, 15660,
     /* 1158164 */     GIR_EraseRootFromParent_Done,
     /* 1158165 */   // Label 16901: @1158165
     /* 1158165 */   GIM_Try, /*On fail goto*//*Label 16902*/ GIMT_Encode4(1158248), // Rule ID 15661 //
     /* 1158170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1158173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1158190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158209 */     // MIs[0] round
     /* 1158209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158219 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1),
     /* 1158222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158230 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158243 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158246 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158247 */     // GIR_Coverage, 15661,
     /* 1158247 */     GIR_EraseRootFromParent_Done,
     /* 1158248 */   // Label 16902: @1158248
     /* 1158248 */   GIM_Try, /*On fail goto*//*Label 16903*/ GIMT_Encode4(1158331), // Rule ID 15664 //
     /* 1158253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1158264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1158267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1158270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1158273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158292 */     // MIs[0] round
     /* 1158292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158326 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158330 */     // GIR_Coverage, 15664,
     /* 1158330 */     GIR_EraseRootFromParent_Done,
     /* 1158331 */   // Label 16903: @1158331
     /* 1158331 */   GIM_Try, /*On fail goto*//*Label 16904*/ GIMT_Encode4(1158414), // Rule ID 15665 //
     /* 1158336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1158339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1158347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1158350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1158353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1158356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158375 */     // MIs[0] round
     /* 1158375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2),
     /* 1158388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158396 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158409 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158413 */     // GIR_Coverage, 15665,
     /* 1158413 */     GIR_EraseRootFromParent_Done,
     /* 1158414 */   // Label 16904: @1158414
     /* 1158414 */   GIM_Try, /*On fail goto*//*Label 16905*/ GIMT_Encode4(1158497), // Rule ID 15668 //
     /* 1158419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1158430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1158433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1158436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1158439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158458 */     // MIs[0] round
     /* 1158458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158492 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158496 */     // GIR_Coverage, 15668,
     /* 1158496 */     GIR_EraseRootFromParent_Done,
     /* 1158497 */   // Label 16905: @1158497
     /* 1158497 */   GIM_Try, /*On fail goto*//*Label 16906*/ GIMT_Encode4(1158580), // Rule ID 15669 //
     /* 1158502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1158505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1158513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1158516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1158519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1158522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1158541 */     // MIs[0] round
     /* 1158541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158551 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4),
     /* 1158554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158562 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158579 */     // GIR_Coverage, 15669,
     /* 1158579 */     GIR_EraseRootFromParent_Done,
     /* 1158580 */   // Label 16906: @1158580
     /* 1158580 */   GIM_Try, /*On fail goto*//*Label 16907*/ GIMT_Encode4(1158663), // Rule ID 15672 //
     /* 1158585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1158596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1158599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1158602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1158605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158624 */     // MIs[0] round
     /* 1158624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158634 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158662 */     // GIR_Coverage, 15672,
     /* 1158662 */     GIR_EraseRootFromParent_Done,
     /* 1158663 */   // Label 16907: @1158663
     /* 1158663 */   GIM_Try, /*On fail goto*//*Label 16908*/ GIMT_Encode4(1158746), // Rule ID 15673 //
     /* 1158668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1158671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1158679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1158682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1158685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1158688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1158707 */     // MIs[0] round
     /* 1158707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158717 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8),
     /* 1158720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158722 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158728 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158745 */     // GIR_Coverage, 15673,
     /* 1158745 */     GIR_EraseRootFromParent_Done,
     /* 1158746 */   // Label 16908: @1158746
     /* 1158746 */   GIM_Try, /*On fail goto*//*Label 16909*/ GIMT_Encode4(1158829), // Rule ID 15676 //
     /* 1158751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158790 */     // MIs[0] round
     /* 1158790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1158803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158824 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158828 */     // GIR_Coverage, 15676,
     /* 1158828 */     GIR_EraseRootFromParent_Done,
     /* 1158829 */   // Label 16909: @1158829
     /* 1158829 */   GIM_Try, /*On fail goto*//*Label 16910*/ GIMT_Encode4(1158912), // Rule ID 15677 //
     /* 1158834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1158837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1158845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1158848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1158851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1158854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1158857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1158869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158873 */     // MIs[0] round
     /* 1158873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158883 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11492:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1158883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1),
     /* 1158886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158894 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158907 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158911 */     // GIR_Coverage, 15677,
     /* 1158911 */     GIR_EraseRootFromParent_Done,
     /* 1158912 */   // Label 16910: @1158912
     /* 1158912 */   GIM_Try, /*On fail goto*//*Label 16911*/ GIMT_Encode4(1158995), // Rule ID 15680 //
     /* 1158917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1158920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1158925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1158928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1158931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1158934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1158937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1158940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1158952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1158956 */     // MIs[0] round
     /* 1158956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1158959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1158966 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1158966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1158969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1158971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1158973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1158975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1158977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1158979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1158984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1158987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1158990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1158993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1158994 */     // GIR_Coverage, 15680,
     /* 1158994 */     GIR_EraseRootFromParent_Done,
     /* 1158995 */   // Label 16911: @1158995
     /* 1158995 */   GIM_Try, /*On fail goto*//*Label 16912*/ GIMT_Encode4(1159078), // Rule ID 15681 //
     /* 1159000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1159003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1159011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1159014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1159017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1159035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159039 */     // MIs[0] round
     /* 1159039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159049 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11492:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2),
     /* 1159052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159060 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159077 */     // GIR_Coverage, 15681,
     /* 1159077 */     GIR_EraseRootFromParent_Done,
     /* 1159078 */   // Label 16912: @1159078
     /* 1159078 */   GIM_Try, /*On fail goto*//*Label 16913*/ GIMT_Encode4(1159161), // Rule ID 15684 //
     /* 1159083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1159086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1159094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1159097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1159100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159122 */     // MIs[0] round
     /* 1159122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159132 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1159135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159160 */     // GIR_Coverage, 15684,
     /* 1159160 */     GIR_EraseRootFromParent_Done,
     /* 1159161 */   // Label 16913: @1159161
     /* 1159161 */   GIM_Try, /*On fail goto*//*Label 16914*/ GIMT_Encode4(1159244), // Rule ID 15685 //
     /* 1159166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1159169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1159177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1159180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1159183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1159201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159205 */     // MIs[0] round
     /* 1159205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159215 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11492:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4),
     /* 1159218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159226 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159243 */     // GIR_Coverage, 15685,
     /* 1159243 */     GIR_EraseRootFromParent_Done,
     /* 1159244 */   // Label 16914: @1159244
     /* 1159244 */   GIM_Try, /*On fail goto*//*Label 16915*/ GIMT_Encode4(1159327), // Rule ID 15688 //
     /* 1159249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1159252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1159260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1159263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1159266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1159269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159288 */     // MIs[0] round
     /* 1159288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159298 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1159301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159326 */     // GIR_Coverage, 15688,
     /* 1159326 */     GIR_EraseRootFromParent_Done,
     /* 1159327 */   // Label 16915: @1159327
     /* 1159327 */   GIM_Try, /*On fail goto*//*Label 16916*/ GIMT_Encode4(1159410), // Rule ID 15689 //
     /* 1159332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1159335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul),
     /* 1159340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1159343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1159346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1159349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1159352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1159367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1159371 */     // MIs[0] round
     /* 1159371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159381 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11492:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSMUL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8),
     /* 1159384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159392 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1159402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1159408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159409 */     // GIR_Coverage, 15689,
     /* 1159409 */     GIR_EraseRootFromParent_Done,
     /* 1159410 */   // Label 16916: @1159410
     /* 1159410 */   GIM_Try, /*On fail goto*//*Label 16917*/ GIMT_Encode4(1159490), // Rule ID 15692 //
     /* 1159415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1159435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159454 */     // MIs[0] round
     /* 1159454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159464 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1159467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159489 */     // GIR_Coverage, 15692,
     /* 1159489 */     GIR_EraseRootFromParent_Done,
     /* 1159490 */   // Label 16917: @1159490
     /* 1159490 */   GIM_Try, /*On fail goto*//*Label 16918*/ GIMT_Encode4(1159570), // Rule ID 15693 //
     /* 1159495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1159506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1159509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1159512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1159515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159534 */     // MIs[0] round
     /* 1159534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8),
     /* 1159547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159569 */     // GIR_Coverage, 15693,
     /* 1159569 */     GIR_EraseRootFromParent_Done,
     /* 1159570 */   // Label 16918: @1159570
     /* 1159570 */   GIM_Try, /*On fail goto*//*Label 16919*/ GIMT_Encode4(1159650), // Rule ID 15696 //
     /* 1159575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1159595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159614 */     // MIs[0] round
     /* 1159614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159624 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1159627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159649 */     // GIR_Coverage, 15696,
     /* 1159649 */     GIR_EraseRootFromParent_Done,
     /* 1159650 */   // Label 16919: @1159650
     /* 1159650 */   GIM_Try, /*On fail goto*//*Label 16920*/ GIMT_Encode4(1159730), // Rule ID 15697 //
     /* 1159655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1159666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1159669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1159672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1159675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159694 */     // MIs[0] round
     /* 1159694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159704 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1159707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159729 */     // GIR_Coverage, 15697,
     /* 1159729 */     GIR_EraseRootFromParent_Done,
     /* 1159730 */   // Label 16920: @1159730
     /* 1159730 */   GIM_Try, /*On fail goto*//*Label 16921*/ GIMT_Encode4(1159810), // Rule ID 15700 //
     /* 1159735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1159746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1159749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1159755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159774 */     // MIs[0] round
     /* 1159774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1159787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159809 */     // GIR_Coverage, 15700,
     /* 1159809 */     GIR_EraseRootFromParent_Done,
     /* 1159810 */   // Label 16921: @1159810
     /* 1159810 */   GIM_Try, /*On fail goto*//*Label 16922*/ GIMT_Encode4(1159890), // Rule ID 15701 //
     /* 1159815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1159826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1159829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1159832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1159835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159854 */     // MIs[0] round
     /* 1159854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1159864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1159867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1159885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159889 */     // GIR_Coverage, 15701,
     /* 1159889 */     GIR_EraseRootFromParent_Done,
     /* 1159890 */   // Label 16922: @1159890
     /* 1159890 */   GIM_Try, /*On fail goto*//*Label 16923*/ GIMT_Encode4(1159970), // Rule ID 15704 //
     /* 1159895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1159898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1159906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1159909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1159912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1159915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1159918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1159934 */     // MIs[0] round
     /* 1159934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1159937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1159944 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1159944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1159947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1159949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1159951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1159953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1159955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1159957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1159962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1159965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1159968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1159969 */     // GIR_Coverage, 15704,
     /* 1159969 */     GIR_EraseRootFromParent_Done,
     /* 1159970 */   // Label 16923: @1159970
     /* 1159970 */   GIM_Try, /*On fail goto*//*Label 16924*/ GIMT_Encode4(1160050), // Rule ID 15705 //
     /* 1159975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1159978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1159983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1159986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1159989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1159992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1159995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1159998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160014 */     // MIs[0] round
     /* 1160014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4),
     /* 1160027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160049 */     // GIR_Coverage, 15705,
     /* 1160049 */     GIR_EraseRootFromParent_Done,
     /* 1160050 */   // Label 16924: @1160050
     /* 1160050 */   GIM_Try, /*On fail goto*//*Label 16925*/ GIMT_Encode4(1160130), // Rule ID 15708 //
     /* 1160055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1160075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160094 */     // MIs[0] round
     /* 1160094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160104 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1160107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160129 */     // GIR_Coverage, 15708,
     /* 1160129 */     GIR_EraseRootFromParent_Done,
     /* 1160130 */   // Label 16925: @1160130
     /* 1160130 */   GIM_Try, /*On fail goto*//*Label 16926*/ GIMT_Encode4(1160210), // Rule ID 15709 //
     /* 1160135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1160146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1160149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1160152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1160155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160174 */     // MIs[0] round
     /* 1160174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160184 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1160187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160209 */     // GIR_Coverage, 15709,
     /* 1160209 */     GIR_EraseRootFromParent_Done,
     /* 1160210 */   // Label 16926: @1160210
     /* 1160210 */   GIM_Try, /*On fail goto*//*Label 16927*/ GIMT_Encode4(1160290), // Rule ID 15712 //
     /* 1160215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1160235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160254 */     // MIs[0] round
     /* 1160254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1160267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160289 */     // GIR_Coverage, 15712,
     /* 1160289 */     GIR_EraseRootFromParent_Done,
     /* 1160290 */   // Label 16927: @1160290
     /* 1160290 */   GIM_Try, /*On fail goto*//*Label 16928*/ GIMT_Encode4(1160370), // Rule ID 15713 //
     /* 1160295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1160306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1160309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1160312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1160315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160334 */     // MIs[0] round
     /* 1160334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2),
     /* 1160347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160369 */     // GIR_Coverage, 15713,
     /* 1160369 */     GIR_EraseRootFromParent_Done,
     /* 1160370 */   // Label 16928: @1160370
     /* 1160370 */   GIM_Try, /*On fail goto*//*Label 16929*/ GIMT_Encode4(1160450), // Rule ID 15716 //
     /* 1160375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1160395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160414 */     // MIs[0] round
     /* 1160414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160449 */     // GIR_Coverage, 15716,
     /* 1160449 */     GIR_EraseRootFromParent_Done,
     /* 1160450 */   // Label 16929: @1160450
     /* 1160450 */   GIM_Try, /*On fail goto*//*Label 16930*/ GIMT_Encode4(1160530), // Rule ID 15717 //
     /* 1160455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1160466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1160469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1160472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1160475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160494 */     // MIs[0] round
     /* 1160494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1160525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160529 */     // GIR_Coverage, 15717,
     /* 1160529 */     GIR_EraseRootFromParent_Done,
     /* 1160530 */   // Label 16930: @1160530
     /* 1160530 */   GIM_Try, /*On fail goto*//*Label 16931*/ GIMT_Encode4(1160610), // Rule ID 15720 //
     /* 1160535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1160555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160574 */     // MIs[0] round
     /* 1160574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160609 */     // GIR_Coverage, 15720,
     /* 1160609 */     GIR_EraseRootFromParent_Done,
     /* 1160610 */   // Label 16931: @1160610
     /* 1160610 */   GIM_Try, /*On fail goto*//*Label 16932*/ GIMT_Encode4(1160690), // Rule ID 15721 //
     /* 1160615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1160626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1160629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1160632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1160635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160654 */     // MIs[0] round
     /* 1160654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1160685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160689 */     // GIR_Coverage, 15721,
     /* 1160689 */     GIR_EraseRootFromParent_Done,
     /* 1160690 */   // Label 16932: @1160690
     /* 1160690 */   GIM_Try, /*On fail goto*//*Label 16933*/ GIMT_Encode4(1160770), // Rule ID 15724 //
     /* 1160695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1160698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1160706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1160709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1160715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160734 */     // MIs[0] round
     /* 1160734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160744 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160769 */     // GIR_Coverage, 15724,
     /* 1160769 */     GIR_EraseRootFromParent_Done,
     /* 1160770 */   // Label 16933: @1160770
     /* 1160770 */   GIM_Try, /*On fail goto*//*Label 16934*/ GIMT_Encode4(1160850), // Rule ID 15725 //
     /* 1160775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1160778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1160786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1160789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1160792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1160795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160814 */     // MIs[0] round
     /* 1160814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1160845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160849 */     // GIR_Coverage, 15725,
     /* 1160849 */     GIR_EraseRootFromParent_Done,
     /* 1160850 */   // Label 16934: @1160850
     /* 1160850 */   GIM_Try, /*On fail goto*//*Label 16935*/ GIMT_Encode4(1160930), // Rule ID 15728 //
     /* 1160855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1160858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1160866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1160869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1160872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1160875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1160878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160894 */     // MIs[0] round
     /* 1160894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1160904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1160922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1160925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1160928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1160929 */     // GIR_Coverage, 15728,
     /* 1160929 */     GIR_EraseRootFromParent_Done,
     /* 1160930 */   // Label 16935: @1160930
     /* 1160930 */   GIM_Try, /*On fail goto*//*Label 16936*/ GIMT_Encode4(1161010), // Rule ID 15729 //
     /* 1160935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1160938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1160943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1160946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1160949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1160952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1160955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1160958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1160974 */     // MIs[0] round
     /* 1160974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1160977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1160984 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1160984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1),
     /* 1160987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1160989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1160991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1160993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1160995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1160997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1161005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161009 */     // GIR_Coverage, 15729,
     /* 1161009 */     GIR_EraseRootFromParent_Done,
     /* 1161010 */   // Label 16936: @1161010
     /* 1161010 */   GIM_Try, /*On fail goto*//*Label 16937*/ GIMT_Encode4(1161090), // Rule ID 15732 //
     /* 1161015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1161035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161054 */     // MIs[0] round
     /* 1161054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1161067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161089 */     // GIR_Coverage, 15732,
     /* 1161089 */     GIR_EraseRootFromParent_Done,
     /* 1161090 */   // Label 16937: @1161090
     /* 1161090 */   GIM_Try, /*On fail goto*//*Label 16938*/ GIMT_Encode4(1161170), // Rule ID 15733 //
     /* 1161095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1161106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1161109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1161112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1161115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161134 */     // MIs[0] round
     /* 1161134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161144 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1161147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161169 */     // GIR_Coverage, 15733,
     /* 1161169 */     GIR_EraseRootFromParent_Done,
     /* 1161170 */   // Label 16938: @1161170
     /* 1161170 */   GIM_Try, /*On fail goto*//*Label 16939*/ GIMT_Encode4(1161250), // Rule ID 15736 //
     /* 1161175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1161195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161214 */     // MIs[0] round
     /* 1161214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161224 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1161227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161249 */     // GIR_Coverage, 15736,
     /* 1161249 */     GIR_EraseRootFromParent_Done,
     /* 1161250 */   // Label 16939: @1161250
     /* 1161250 */   GIM_Try, /*On fail goto*//*Label 16940*/ GIMT_Encode4(1161330), // Rule ID 15737 //
     /* 1161255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1161266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1161269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1161272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1161275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161294 */     // MIs[0] round
     /* 1161294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161304 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1161307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161329 */     // GIR_Coverage, 15737,
     /* 1161329 */     GIR_EraseRootFromParent_Done,
     /* 1161330 */   // Label 16940: @1161330
     /* 1161330 */   GIM_Try, /*On fail goto*//*Label 16941*/ GIMT_Encode4(1161410), // Rule ID 15740 //
     /* 1161335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1161355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161374 */     // MIs[0] round
     /* 1161374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161384 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1161387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161409 */     // GIR_Coverage, 15740,
     /* 1161409 */     GIR_EraseRootFromParent_Done,
     /* 1161410 */   // Label 16941: @1161410
     /* 1161410 */   GIM_Try, /*On fail goto*//*Label 16942*/ GIMT_Encode4(1161490), // Rule ID 15741 //
     /* 1161415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1161426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1161429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1161432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1161435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161454 */     // MIs[0] round
     /* 1161454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161464 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1161467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1161485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161489 */     // GIR_Coverage, 15741,
     /* 1161489 */     GIR_EraseRootFromParent_Done,
     /* 1161490 */   // Label 16942: @1161490
     /* 1161490 */   GIM_Try, /*On fail goto*//*Label 16943*/ GIMT_Encode4(1161570), // Rule ID 15744 //
     /* 1161495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1161515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161534 */     // MIs[0] round
     /* 1161534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1161547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161569 */     // GIR_Coverage, 15744,
     /* 1161569 */     GIR_EraseRootFromParent_Done,
     /* 1161570 */   // Label 16943: @1161570
     /* 1161570 */   GIM_Try, /*On fail goto*//*Label 16944*/ GIMT_Encode4(1161650), // Rule ID 15745 //
     /* 1161575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1161586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1161589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1161592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1161595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1161614 */     // MIs[0] round
     /* 1161614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161624 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1161627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161649 */     // GIR_Coverage, 15745,
     /* 1161649 */     GIR_EraseRootFromParent_Done,
     /* 1161650 */   // Label 16944: @1161650
     /* 1161650 */   GIM_Try, /*On fail goto*//*Label 16945*/ GIMT_Encode4(1161730), // Rule ID 15748 //
     /* 1161655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1161675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161694 */     // MIs[0] round
     /* 1161694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161704 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1161707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161729 */     // GIR_Coverage, 15748,
     /* 1161729 */     GIR_EraseRootFromParent_Done,
     /* 1161730 */   // Label 16945: @1161730
     /* 1161730 */   GIM_Try, /*On fail goto*//*Label 16946*/ GIMT_Encode4(1161810), // Rule ID 15749 //
     /* 1161735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1161746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1161749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1161752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1161755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1161774 */     // MIs[0] round
     /* 1161774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161784 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1161787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161809 */     // GIR_Coverage, 15749,
     /* 1161809 */     GIR_EraseRootFromParent_Done,
     /* 1161810 */   // Label 16946: @1161810
     /* 1161810 */   GIM_Try, /*On fail goto*//*Label 16947*/ GIMT_Encode4(1161890), // Rule ID 15752 //
     /* 1161815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1161826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1161829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1161832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1161835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161854 */     // MIs[0] round
     /* 1161854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161864 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1161864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1161867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161889 */     // GIR_Coverage, 15752,
     /* 1161889 */     GIR_EraseRootFromParent_Done,
     /* 1161890 */   // Label 16947: @1161890
     /* 1161890 */   GIM_Try, /*On fail goto*//*Label 16948*/ GIMT_Encode4(1161970), // Rule ID 15753 //
     /* 1161895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1161898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1161906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1161909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1161912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1161915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1161918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1161934 */     // MIs[0] round
     /* 1161934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1161937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1161944 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1161944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1161947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1161949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1161951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1161953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1161955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1161957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1161962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1161965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1161968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1161969 */     // GIR_Coverage, 15753,
     /* 1161969 */     GIR_EraseRootFromParent_Done,
     /* 1161970 */   // Label 16948: @1161970
     /* 1161970 */   GIM_Try, /*On fail goto*//*Label 16949*/ GIMT_Encode4(1162050), // Rule ID 15756 //
     /* 1161975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1161978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1161983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1161986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1161989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1161992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1161995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1161998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162014 */     // MIs[0] round
     /* 1162014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1162027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162049 */     // GIR_Coverage, 15756,
     /* 1162049 */     GIR_EraseRootFromParent_Done,
     /* 1162050 */   // Label 16949: @1162050
     /* 1162050 */   GIM_Try, /*On fail goto*//*Label 16950*/ GIMT_Encode4(1162130), // Rule ID 15757 //
     /* 1162055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1162066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1162069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1162072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1162075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162094 */     // MIs[0] round
     /* 1162094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162104 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1162107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162129 */     // GIR_Coverage, 15757,
     /* 1162129 */     GIR_EraseRootFromParent_Done,
     /* 1162130 */   // Label 16950: @1162130
     /* 1162130 */   GIM_Try, /*On fail goto*//*Label 16951*/ GIMT_Encode4(1162210), // Rule ID 15760 //
     /* 1162135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1162155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162174 */     // MIs[0] round
     /* 1162174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162184 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1162187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162209 */     // GIR_Coverage, 15760,
     /* 1162209 */     GIR_EraseRootFromParent_Done,
     /* 1162210 */   // Label 16951: @1162210
     /* 1162210 */   GIM_Try, /*On fail goto*//*Label 16952*/ GIMT_Encode4(1162290), // Rule ID 15761 //
     /* 1162215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1162226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1162229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1162232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1162235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162254 */     // MIs[0] round
     /* 1162254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162264 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1162267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162289 */     // GIR_Coverage, 15761,
     /* 1162289 */     GIR_EraseRootFromParent_Done,
     /* 1162290 */   // Label 16952: @1162290
     /* 1162290 */   GIM_Try, /*On fail goto*//*Label 16953*/ GIMT_Encode4(1162370), // Rule ID 15764 //
     /* 1162295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1162315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162334 */     // MIs[0] round
     /* 1162334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1162347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162369 */     // GIR_Coverage, 15764,
     /* 1162369 */     GIR_EraseRootFromParent_Done,
     /* 1162370 */   // Label 16953: @1162370
     /* 1162370 */   GIM_Try, /*On fail goto*//*Label 16954*/ GIMT_Encode4(1162450), // Rule ID 15765 //
     /* 1162375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1162378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1162386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1162389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1162392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1162395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162414 */     // MIs[0] round
     /* 1162414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1162427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1162445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162449 */     // GIR_Coverage, 15765,
     /* 1162449 */     GIR_EraseRootFromParent_Done,
     /* 1162450 */   // Label 16954: @1162450
     /* 1162450 */   GIM_Try, /*On fail goto*//*Label 16955*/ GIMT_Encode4(1162530), // Rule ID 15768 //
     /* 1162455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1162458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162494 */     // MIs[0] round
     /* 1162494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1162507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162529 */     // GIR_Coverage, 15768,
     /* 1162529 */     GIR_EraseRootFromParent_Done,
     /* 1162530 */   // Label 16955: @1162530
     /* 1162530 */   GIM_Try, /*On fail goto*//*Label 16956*/ GIMT_Encode4(1162610), // Rule ID 15769 //
     /* 1162535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1162538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1162546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1162549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1162552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1162555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1162574 */     // MIs[0] round
     /* 1162574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2),
     /* 1162587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162609 */     // GIR_Coverage, 15769,
     /* 1162609 */     GIR_EraseRootFromParent_Done,
     /* 1162610 */   // Label 16956: @1162610
     /* 1162610 */   GIM_Try, /*On fail goto*//*Label 16957*/ GIMT_Encode4(1162690), // Rule ID 15772 //
     /* 1162615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1162618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1162626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1162629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1162632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1162635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162654 */     // MIs[0] round
     /* 1162654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162664 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1162667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162689 */     // GIR_Coverage, 15772,
     /* 1162689 */     GIR_EraseRootFromParent_Done,
     /* 1162690 */   // Label 16957: @1162690
     /* 1162690 */   GIM_Try, /*On fail goto*//*Label 16958*/ GIMT_Encode4(1162770), // Rule ID 15773 //
     /* 1162695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1162698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1162706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1162709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1162712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1162715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1162734 */     // MIs[0] round
     /* 1162734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162744 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4),
     /* 1162747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162769 */     // GIR_Coverage, 15773,
     /* 1162769 */     GIR_EraseRootFromParent_Done,
     /* 1162770 */   // Label 16958: @1162770
     /* 1162770 */   GIM_Try, /*On fail goto*//*Label 16959*/ GIMT_Encode4(1162850), // Rule ID 15776 //
     /* 1162775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1162778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1162786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1162789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1162792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1162795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162814 */     // MIs[0] round
     /* 1162814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162824 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1162827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162849 */     // GIR_Coverage, 15776,
     /* 1162849 */     GIR_EraseRootFromParent_Done,
     /* 1162850 */   // Label 16959: @1162850
     /* 1162850 */   GIM_Try, /*On fail goto*//*Label 16960*/ GIMT_Encode4(1162930), // Rule ID 15777 //
     /* 1162855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1162858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1162866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1162869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1162872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1162875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1162878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1162894 */     // MIs[0] round
     /* 1162894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1162904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8),
     /* 1162907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1162922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1162925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1162928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1162929 */     // GIR_Coverage, 15777,
     /* 1162929 */     GIR_EraseRootFromParent_Done,
     /* 1162930 */   // Label 16960: @1162930
     /* 1162930 */   GIM_Try, /*On fail goto*//*Label 16961*/ GIMT_Encode4(1163010), // Rule ID 15780 //
     /* 1162935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1162938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1162943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1162946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1162949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1162952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1162955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1162958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1162970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1162974 */     // MIs[0] round
     /* 1162974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1162977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1162984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1162984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1162987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1162989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1162991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1162993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1162995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1162997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163009 */     // GIR_Coverage, 15780,
     /* 1163009 */     GIR_EraseRootFromParent_Done,
     /* 1163010 */   // Label 16961: @1163010
     /* 1163010 */   GIM_Try, /*On fail goto*//*Label 16962*/ GIMT_Encode4(1163090), // Rule ID 15781 //
     /* 1163015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1163026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1163029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1163032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163054 */     // MIs[0] round
     /* 1163054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8),
     /* 1163067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163089 */     // GIR_Coverage, 15781,
     /* 1163089 */     GIR_EraseRootFromParent_Done,
     /* 1163090 */   // Label 16962: @1163090
     /* 1163090 */   GIM_Try, /*On fail goto*//*Label 16963*/ GIMT_Encode4(1163170), // Rule ID 15784 //
     /* 1163095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1163106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1163109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163134 */     // MIs[0] round
     /* 1163134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1163147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163169 */     // GIR_Coverage, 15784,
     /* 1163169 */     GIR_EraseRootFromParent_Done,
     /* 1163170 */   // Label 16963: @1163170
     /* 1163170 */   GIM_Try, /*On fail goto*//*Label 16964*/ GIMT_Encode4(1163250), // Rule ID 15785 //
     /* 1163175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1163186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1163189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1163192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163214 */     // MIs[0] round
     /* 1163214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1163227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163249 */     // GIR_Coverage, 15785,
     /* 1163249 */     GIR_EraseRootFromParent_Done,
     /* 1163250 */   // Label 16964: @1163250
     /* 1163250 */   GIM_Try, /*On fail goto*//*Label 16965*/ GIMT_Encode4(1163330), // Rule ID 15788 //
     /* 1163255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1163266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1163269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1163272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163294 */     // MIs[0] round
     /* 1163294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163304 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163329 */     // GIR_Coverage, 15788,
     /* 1163329 */     GIR_EraseRootFromParent_Done,
     /* 1163330 */   // Label 16965: @1163330
     /* 1163330 */   GIM_Try, /*On fail goto*//*Label 16966*/ GIMT_Encode4(1163410), // Rule ID 15789 //
     /* 1163335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1163346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1163349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1163352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163374 */     // MIs[0] round
     /* 1163374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163384 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163409 */     // GIR_Coverage, 15789,
     /* 1163409 */     GIR_EraseRootFromParent_Done,
     /* 1163410 */   // Label 16966: @1163410
     /* 1163410 */   GIM_Try, /*On fail goto*//*Label 16967*/ GIMT_Encode4(1163490), // Rule ID 15792 //
     /* 1163415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1163426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1163429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1163432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163454 */     // MIs[0] round
     /* 1163454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1163467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163489 */     // GIR_Coverage, 15792,
     /* 1163489 */     GIR_EraseRootFromParent_Done,
     /* 1163490 */   // Label 16967: @1163490
     /* 1163490 */   GIM_Try, /*On fail goto*//*Label 16968*/ GIMT_Encode4(1163570), // Rule ID 15793 //
     /* 1163495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1163506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1163509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1163512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163534 */     // MIs[0] round
     /* 1163534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4),
     /* 1163547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163569 */     // GIR_Coverage, 15793,
     /* 1163569 */     GIR_EraseRootFromParent_Done,
     /* 1163570 */   // Label 16968: @1163570
     /* 1163570 */   GIM_Try, /*On fail goto*//*Label 16969*/ GIMT_Encode4(1163650), // Rule ID 15796 //
     /* 1163575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1163586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1163589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1163592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163614 */     // MIs[0] round
     /* 1163614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163624 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163649 */     // GIR_Coverage, 15796,
     /* 1163649 */     GIR_EraseRootFromParent_Done,
     /* 1163650 */   // Label 16969: @1163650
     /* 1163650 */   GIM_Try, /*On fail goto*//*Label 16970*/ GIMT_Encode4(1163730), // Rule ID 15797 //
     /* 1163655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1163666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1163669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1163672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163694 */     // MIs[0] round
     /* 1163694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163704 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1163725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163729 */     // GIR_Coverage, 15797,
     /* 1163729 */     GIR_EraseRootFromParent_Done,
     /* 1163730 */   // Label 16970: @1163730
     /* 1163730 */   GIM_Try, /*On fail goto*//*Label 16971*/ GIMT_Encode4(1163810), // Rule ID 15800 //
     /* 1163735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1163746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1163749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1163752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163774 */     // MIs[0] round
     /* 1163774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163809 */     // GIR_Coverage, 15800,
     /* 1163809 */     GIR_EraseRootFromParent_Done,
     /* 1163810 */   // Label 16971: @1163810
     /* 1163810 */   GIM_Try, /*On fail goto*//*Label 16972*/ GIMT_Encode4(1163890), // Rule ID 15801 //
     /* 1163815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1163826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1163829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1163832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163854 */     // MIs[0] round
     /* 1163854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163864 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1163864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2),
     /* 1163867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1163885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163889 */     // GIR_Coverage, 15801,
     /* 1163889 */     GIR_EraseRootFromParent_Done,
     /* 1163890 */   // Label 16972: @1163890
     /* 1163890 */   GIM_Try, /*On fail goto*//*Label 16973*/ GIMT_Encode4(1163970), // Rule ID 15804 //
     /* 1163895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1163898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1163906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1163909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1163912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1163915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1163918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1163930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1163934 */     // MIs[0] round
     /* 1163934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1163937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1163944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1163944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1163947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1163949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1163951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1163953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1163955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1163957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1163962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1163965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1163968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1163969 */     // GIR_Coverage, 15804,
     /* 1163969 */     GIR_EraseRootFromParent_Done,
     /* 1163970 */   // Label 16973: @1163970
     /* 1163970 */   GIM_Try, /*On fail goto*//*Label 16974*/ GIMT_Encode4(1164050), // Rule ID 15805 //
     /* 1163975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1163978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1163983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1163986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1163989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1163992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1163995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1163998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164014 */     // MIs[0] round
     /* 1164014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164024 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11532:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164049 */     // GIR_Coverage, 15805,
     /* 1164049 */     GIR_EraseRootFromParent_Done,
     /* 1164050 */   // Label 16974: @1164050
     /* 1164050 */   GIM_Try, /*On fail goto*//*Label 16975*/ GIMT_Encode4(1164130), // Rule ID 15808 //
     /* 1164055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164094 */     // MIs[0] round
     /* 1164094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164104 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164129 */     // GIR_Coverage, 15808,
     /* 1164129 */     GIR_EraseRootFromParent_Done,
     /* 1164130 */   // Label 16975: @1164130
     /* 1164130 */   GIM_Try, /*On fail goto*//*Label 16976*/ GIMT_Encode4(1164210), // Rule ID 15809 //
     /* 1164135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1164146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1164149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1164152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164174 */     // MIs[0] round
     /* 1164174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11532:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1164205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164209 */     // GIR_Coverage, 15809,
     /* 1164209 */     GIR_EraseRootFromParent_Done,
     /* 1164210 */   // Label 16976: @1164210
     /* 1164210 */   GIM_Try, /*On fail goto*//*Label 16977*/ GIMT_Encode4(1164290), // Rule ID 15812 //
     /* 1164215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1164226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1164229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1164232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164254 */     // MIs[0] round
     /* 1164254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164289 */     // GIR_Coverage, 15812,
     /* 1164289 */     GIR_EraseRootFromParent_Done,
     /* 1164290 */   // Label 16977: @1164290
     /* 1164290 */   GIM_Try, /*On fail goto*//*Label 16978*/ GIMT_Encode4(1164370), // Rule ID 15813 //
     /* 1164295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1164306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1164309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1164312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164334 */     // MIs[0] round
     /* 1164334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11532:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1164365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164369 */     // GIR_Coverage, 15813,
     /* 1164369 */     GIR_EraseRootFromParent_Done,
     /* 1164370 */   // Label 16978: @1164370
     /* 1164370 */   GIM_Try, /*On fail goto*//*Label 16979*/ GIMT_Encode4(1164450), // Rule ID 15816 //
     /* 1164375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1164378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1164386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1164389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1164392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164414 */     // MIs[0] round
     /* 1164414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164449 */     // GIR_Coverage, 15816,
     /* 1164449 */     GIR_EraseRootFromParent_Done,
     /* 1164450 */   // Label 16979: @1164450
     /* 1164450 */   GIM_Try, /*On fail goto*//*Label 16980*/ GIMT_Encode4(1164530), // Rule ID 15817 //
     /* 1164455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1164458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1164466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1164469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1164472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1164490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164494 */     // MIs[0] round
     /* 1164494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164504 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11532:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1),
     /* 1164507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1164525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164529 */     // GIR_Coverage, 15817,
     /* 1164529 */     GIR_EraseRootFromParent_Done,
     /* 1164530 */   // Label 16980: @1164530
     /* 1164530 */   GIM_Try, /*On fail goto*//*Label 16981*/ GIMT_Encode4(1164610), // Rule ID 15820 //
     /* 1164535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1164546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1164549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1164552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164574 */     // MIs[0] round
     /* 1164574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1164587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164609 */     // GIR_Coverage, 15820,
     /* 1164609 */     GIR_EraseRootFromParent_Done,
     /* 1164610 */   // Label 16981: @1164610
     /* 1164610 */   GIM_Try, /*On fail goto*//*Label 16982*/ GIMT_Encode4(1164690), // Rule ID 15821 //
     /* 1164615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1164626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1164629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1164632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1164650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164654 */     // MIs[0] round
     /* 1164654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164664 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1164667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164689 */     // GIR_Coverage, 15821,
     /* 1164689 */     GIR_EraseRootFromParent_Done,
     /* 1164690 */   // Label 16982: @1164690
     /* 1164690 */   GIM_Try, /*On fail goto*//*Label 16983*/ GIMT_Encode4(1164770), // Rule ID 15824 //
     /* 1164695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1164706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1164709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1164712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164734 */     // MIs[0] round
     /* 1164734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1164747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164769 */     // GIR_Coverage, 15824,
     /* 1164769 */     GIR_EraseRootFromParent_Done,
     /* 1164770 */   // Label 16983: @1164770
     /* 1164770 */   GIM_Try, /*On fail goto*//*Label 16984*/ GIMT_Encode4(1164850), // Rule ID 15825 //
     /* 1164775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1164786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1164789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1164792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1164810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164814 */     // MIs[0] round
     /* 1164814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164824 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1164827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164849 */     // GIR_Coverage, 15825,
     /* 1164849 */     GIR_EraseRootFromParent_Done,
     /* 1164850 */   // Label 16984: @1164850
     /* 1164850 */   GIM_Try, /*On fail goto*//*Label 16985*/ GIMT_Encode4(1164930), // Rule ID 15828 //
     /* 1164855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1164858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1164866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1164869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1164872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1164875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1164878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164894 */     // MIs[0] round
     /* 1164894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164904 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1164904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1164907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1164922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1164925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1164928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1164929 */     // GIR_Coverage, 15828,
     /* 1164929 */     GIR_EraseRootFromParent_Done,
     /* 1164930 */   // Label 16985: @1164930
     /* 1164930 */   GIM_Try, /*On fail goto*//*Label 16986*/ GIMT_Encode4(1165010), // Rule ID 15829 //
     /* 1164935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1164938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1164943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1164946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1164949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1164952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1164955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1164958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1164970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1164974 */     // MIs[0] round
     /* 1164974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1164977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1164984 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1164984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1164987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1164989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1164991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1164993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1164995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1164997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1165005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165009 */     // GIR_Coverage, 15829,
     /* 1165009 */     GIR_EraseRootFromParent_Done,
     /* 1165010 */   // Label 16986: @1165010
     /* 1165010 */   GIM_Try, /*On fail goto*//*Label 16987*/ GIMT_Encode4(1165090), // Rule ID 15832 //
     /* 1165015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165054 */     // MIs[0] round
     /* 1165054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1165067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165089 */     // GIR_Coverage, 15832,
     /* 1165089 */     GIR_EraseRootFromParent_Done,
     /* 1165090 */   // Label 16987: @1165090
     /* 1165090 */   GIM_Try, /*On fail goto*//*Label 16988*/ GIMT_Encode4(1165170), // Rule ID 15833 //
     /* 1165095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1165106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1165109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1165112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165134 */     // MIs[0] round
     /* 1165134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165144 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1165147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165169 */     // GIR_Coverage, 15833,
     /* 1165169 */     GIR_EraseRootFromParent_Done,
     /* 1165170 */   // Label 16988: @1165170
     /* 1165170 */   GIM_Try, /*On fail goto*//*Label 16989*/ GIMT_Encode4(1165250), // Rule ID 15836 //
     /* 1165175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1165186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1165189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165214 */     // MIs[0] round
     /* 1165214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1165227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165249 */     // GIR_Coverage, 15836,
     /* 1165249 */     GIR_EraseRootFromParent_Done,
     /* 1165250 */   // Label 16989: @1165250
     /* 1165250 */   GIM_Try, /*On fail goto*//*Label 16990*/ GIMT_Encode4(1165330), // Rule ID 15837 //
     /* 1165255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1165266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1165269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1165272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165294 */     // MIs[0] round
     /* 1165294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165304 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1165307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165329 */     // GIR_Coverage, 15837,
     /* 1165329 */     GIR_EraseRootFromParent_Done,
     /* 1165330 */   // Label 16990: @1165330
     /* 1165330 */   GIM_Try, /*On fail goto*//*Label 16991*/ GIMT_Encode4(1165410), // Rule ID 15840 //
     /* 1165335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1165346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1165349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1165352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165374 */     // MIs[0] round
     /* 1165374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1165387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165409 */     // GIR_Coverage, 15840,
     /* 1165409 */     GIR_EraseRootFromParent_Done,
     /* 1165410 */   // Label 16991: @1165410
     /* 1165410 */   GIM_Try, /*On fail goto*//*Label 16992*/ GIMT_Encode4(1165490), // Rule ID 15841 //
     /* 1165415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1165426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1165429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1165432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165454 */     // MIs[0] round
     /* 1165454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165464 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1165467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1165485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165489 */     // GIR_Coverage, 15841,
     /* 1165489 */     GIR_EraseRootFromParent_Done,
     /* 1165490 */   // Label 16992: @1165490
     /* 1165490 */   GIM_Try, /*On fail goto*//*Label 16993*/ GIMT_Encode4(1165570), // Rule ID 15844 //
     /* 1165495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1165506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1165509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1165512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165534 */     // MIs[0] round
     /* 1165534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1165547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165569 */     // GIR_Coverage, 15844,
     /* 1165569 */     GIR_EraseRootFromParent_Done,
     /* 1165570 */   // Label 16993: @1165570
     /* 1165570 */   GIM_Try, /*On fail goto*//*Label 16994*/ GIMT_Encode4(1165650), // Rule ID 15845 //
     /* 1165575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1165586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1165589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1165592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1165610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165614 */     // MIs[0] round
     /* 1165614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1165627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165649 */     // GIR_Coverage, 15845,
     /* 1165649 */     GIR_EraseRootFromParent_Done,
     /* 1165650 */   // Label 16994: @1165650
     /* 1165650 */   GIM_Try, /*On fail goto*//*Label 16995*/ GIMT_Encode4(1165730), // Rule ID 15848 //
     /* 1165655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1165666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1165669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1165672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165694 */     // MIs[0] round
     /* 1165694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1165707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165729 */     // GIR_Coverage, 15848,
     /* 1165729 */     GIR_EraseRootFromParent_Done,
     /* 1165730 */   // Label 16995: @1165730
     /* 1165730 */   GIM_Try, /*On fail goto*//*Label 16996*/ GIMT_Encode4(1165810), // Rule ID 15849 //
     /* 1165735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1165746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1165749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1165752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1165770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165774 */     // MIs[0] round
     /* 1165774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1165787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165809 */     // GIR_Coverage, 15849,
     /* 1165809 */     GIR_EraseRootFromParent_Done,
     /* 1165810 */   // Label 16996: @1165810
     /* 1165810 */   GIM_Try, /*On fail goto*//*Label 16997*/ GIMT_Encode4(1165890), // Rule ID 15852 //
     /* 1165815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1165818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1165826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1165829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1165832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165854 */     // MIs[0] round
     /* 1165854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165864 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1165864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1165867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165889 */     // GIR_Coverage, 15852,
     /* 1165889 */     GIR_EraseRootFromParent_Done,
     /* 1165890 */   // Label 16997: @1165890
     /* 1165890 */   GIM_Try, /*On fail goto*//*Label 16998*/ GIMT_Encode4(1165970), // Rule ID 15853 //
     /* 1165895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1165898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1165906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1165909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1165912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1165915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1165918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1165930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1165934 */     // MIs[0] round
     /* 1165934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1165937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1165944 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1165944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1165947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1165949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1165951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1165953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1165955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1165957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1165962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1165965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1165968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1165969 */     // GIR_Coverage, 15853,
     /* 1165969 */     GIR_EraseRootFromParent_Done,
     /* 1165970 */   // Label 16998: @1165970
     /* 1165970 */   GIM_Try, /*On fail goto*//*Label 16999*/ GIMT_Encode4(1166050), // Rule ID 15856 //
     /* 1165975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1165978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1165983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1165986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1165989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1165992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1165995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1165998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166014 */     // MIs[0] round
     /* 1166014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1166027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166049 */     // GIR_Coverage, 15856,
     /* 1166049 */     GIR_EraseRootFromParent_Done,
     /* 1166050 */   // Label 16999: @1166050
     /* 1166050 */   GIM_Try, /*On fail goto*//*Label 17000*/ GIMT_Encode4(1166130), // Rule ID 15857 //
     /* 1166055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1166066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1166069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1166072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1166090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166094 */     // MIs[0] round
     /* 1166094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11532:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2),
     /* 1166107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166129 */     // GIR_Coverage, 15857,
     /* 1166129 */     GIR_EraseRootFromParent_Done,
     /* 1166130 */   // Label 17000: @1166130
     /* 1166130 */   GIM_Try, /*On fail goto*//*Label 17001*/ GIMT_Encode4(1166210), // Rule ID 15860 //
     /* 1166135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1166146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1166149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166174 */     // MIs[0] round
     /* 1166174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1166187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166209 */     // GIR_Coverage, 15860,
     /* 1166209 */     GIR_EraseRootFromParent_Done,
     /* 1166210 */   // Label 17001: @1166210
     /* 1166210 */   GIM_Try, /*On fail goto*//*Label 17002*/ GIMT_Encode4(1166290), // Rule ID 15861 //
     /* 1166215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1166226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1166229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1166232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1166250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166254 */     // MIs[0] round
     /* 1166254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11532:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4),
     /* 1166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166289 */     // GIR_Coverage, 15861,
     /* 1166289 */     GIR_EraseRootFromParent_Done,
     /* 1166290 */   // Label 17002: @1166290
     /* 1166290 */   GIM_Try, /*On fail goto*//*Label 17003*/ GIMT_Encode4(1166370), // Rule ID 15864 //
     /* 1166295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1166298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1166306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1166309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1166312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1166315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166334 */     // MIs[0] round
     /* 1166334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1166347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166369 */     // GIR_Coverage, 15864,
     /* 1166369 */     GIR_EraseRootFromParent_Done,
     /* 1166370 */   // Label 17003: @1166370
     /* 1166370 */   GIM_Try, /*On fail goto*//*Label 17004*/ GIMT_Encode4(1166450), // Rule ID 15865 //
     /* 1166375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1166378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl),
     /* 1166383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1166386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1166389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1166392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1166395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1166410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1166414 */     // MIs[0] round
     /* 1166414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11532:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRL_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8),
     /* 1166427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1166445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166449 */     // GIR_Coverage, 15865,
     /* 1166449 */     GIR_EraseRootFromParent_Done,
     /* 1166450 */   // Label 17004: @1166450
     /* 1166450 */   GIM_Try, /*On fail goto*//*Label 17005*/ GIMT_Encode4(1166530), // Rule ID 15956 //
     /* 1166455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1166466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1166469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1166472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1166475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166494 */     // MIs[0] round
     /* 1166494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166504 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1166507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166529 */     // GIR_Coverage, 15956,
     /* 1166529 */     GIR_EraseRootFromParent_Done,
     /* 1166530 */   // Label 17005: @1166530
     /* 1166530 */   GIM_Try, /*On fail goto*//*Label 17006*/ GIMT_Encode4(1166610), // Rule ID 15957 //
     /* 1166535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1166546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1166549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1166552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1166555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166574 */     // MIs[0] round
     /* 1166574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166584 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8),
     /* 1166587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166609 */     // GIR_Coverage, 15957,
     /* 1166609 */     GIR_EraseRootFromParent_Done,
     /* 1166610 */   // Label 17006: @1166610
     /* 1166610 */   GIM_Try, /*On fail goto*//*Label 17007*/ GIMT_Encode4(1166690), // Rule ID 15960 //
     /* 1166615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1166626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1166629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1166632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1166635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166654 */     // MIs[0] round
     /* 1166654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1166667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166689 */     // GIR_Coverage, 15960,
     /* 1166689 */     GIR_EraseRootFromParent_Done,
     /* 1166690 */   // Label 17007: @1166690
     /* 1166690 */   GIM_Try, /*On fail goto*//*Label 17008*/ GIMT_Encode4(1166770), // Rule ID 15961 //
     /* 1166695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1166706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1166709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1166712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1166715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166734 */     // MIs[0] round
     /* 1166734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166744 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1166747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166769 */     // GIR_Coverage, 15961,
     /* 1166769 */     GIR_EraseRootFromParent_Done,
     /* 1166770 */   // Label 17008: @1166770
     /* 1166770 */   GIM_Try, /*On fail goto*//*Label 17009*/ GIMT_Encode4(1166850), // Rule ID 15964 //
     /* 1166775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1166786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1166789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1166792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1166795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166814 */     // MIs[0] round
     /* 1166814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166824 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1166827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166849 */     // GIR_Coverage, 15964,
     /* 1166849 */     GIR_EraseRootFromParent_Done,
     /* 1166850 */   // Label 17009: @1166850
     /* 1166850 */   GIM_Try, /*On fail goto*//*Label 17010*/ GIMT_Encode4(1166930), // Rule ID 15965 //
     /* 1166855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1166858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1166866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1166869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1166872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1166875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1166878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166894 */     // MIs[0] round
     /* 1166894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1166904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1166907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1166922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1166925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1166928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1166929 */     // GIR_Coverage, 15965,
     /* 1166929 */     GIR_EraseRootFromParent_Done,
     /* 1166930 */   // Label 17010: @1166930
     /* 1166930 */   GIM_Try, /*On fail goto*//*Label 17011*/ GIMT_Encode4(1167010), // Rule ID 15968 //
     /* 1166935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1166938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1166943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1166946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1166949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1166952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1166955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1166958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1166974 */     // MIs[0] round
     /* 1166974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1166977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1166984 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1166989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1166991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1166993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1166995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1166997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167009 */     // GIR_Coverage, 15968,
     /* 1167009 */     GIR_EraseRootFromParent_Done,
     /* 1167010 */   // Label 17011: @1167010
     /* 1167010 */   GIM_Try, /*On fail goto*//*Label 17012*/ GIMT_Encode4(1167090), // Rule ID 15969 //
     /* 1167015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1167026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1167029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1167032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1167035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167054 */     // MIs[0] round
     /* 1167054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4),
     /* 1167067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167089 */     // GIR_Coverage, 15969,
     /* 1167089 */     GIR_EraseRootFromParent_Done,
     /* 1167090 */   // Label 17012: @1167090
     /* 1167090 */   GIM_Try, /*On fail goto*//*Label 17013*/ GIMT_Encode4(1167170), // Rule ID 15972 //
     /* 1167095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1167106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1167109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1167112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1167115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167134 */     // MIs[0] round
     /* 1167134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167144 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1167147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167169 */     // GIR_Coverage, 15972,
     /* 1167169 */     GIR_EraseRootFromParent_Done,
     /* 1167170 */   // Label 17013: @1167170
     /* 1167170 */   GIM_Try, /*On fail goto*//*Label 17014*/ GIMT_Encode4(1167250), // Rule ID 15973 //
     /* 1167175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1167186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1167189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1167192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1167195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167214 */     // MIs[0] round
     /* 1167214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1167227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167249 */     // GIR_Coverage, 15973,
     /* 1167249 */     GIR_EraseRootFromParent_Done,
     /* 1167250 */   // Label 17014: @1167250
     /* 1167250 */   GIM_Try, /*On fail goto*//*Label 17015*/ GIMT_Encode4(1167330), // Rule ID 15976 //
     /* 1167255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1167266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1167269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1167272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1167275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167294 */     // MIs[0] round
     /* 1167294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1167307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167329 */     // GIR_Coverage, 15976,
     /* 1167329 */     GIR_EraseRootFromParent_Done,
     /* 1167330 */   // Label 17015: @1167330
     /* 1167330 */   GIM_Try, /*On fail goto*//*Label 17016*/ GIMT_Encode4(1167410), // Rule ID 15977 //
     /* 1167335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1167346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1167349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1167352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1167355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167374 */     // MIs[0] round
     /* 1167374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2),
     /* 1167387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167409 */     // GIR_Coverage, 15977,
     /* 1167409 */     GIR_EraseRootFromParent_Done,
     /* 1167410 */   // Label 17016: @1167410
     /* 1167410 */   GIM_Try, /*On fail goto*//*Label 17017*/ GIMT_Encode4(1167490), // Rule ID 15980 //
     /* 1167415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1167426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1167429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1167432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1167435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167454 */     // MIs[0] round
     /* 1167454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167489 */     // GIR_Coverage, 15980,
     /* 1167489 */     GIR_EraseRootFromParent_Done,
     /* 1167490 */   // Label 17017: @1167490
     /* 1167490 */   GIM_Try, /*On fail goto*//*Label 17018*/ GIMT_Encode4(1167570), // Rule ID 15981 //
     /* 1167495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1167506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1167509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1167512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1167515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167534 */     // MIs[0] round
     /* 1167534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1167565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167569 */     // GIR_Coverage, 15981,
     /* 1167569 */     GIR_EraseRootFromParent_Done,
     /* 1167570 */   // Label 17018: @1167570
     /* 1167570 */   GIM_Try, /*On fail goto*//*Label 17019*/ GIMT_Encode4(1167650), // Rule ID 15984 //
     /* 1167575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1167586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1167589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1167592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1167595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167614 */     // MIs[0] round
     /* 1167614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167649 */     // GIR_Coverage, 15984,
     /* 1167649 */     GIR_EraseRootFromParent_Done,
     /* 1167650 */   // Label 17019: @1167650
     /* 1167650 */   GIM_Try, /*On fail goto*//*Label 17020*/ GIMT_Encode4(1167730), // Rule ID 15985 //
     /* 1167655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1167666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1167669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1167672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1167675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167694 */     // MIs[0] round
     /* 1167694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1167725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167729 */     // GIR_Coverage, 15985,
     /* 1167729 */     GIR_EraseRootFromParent_Done,
     /* 1167730 */   // Label 17020: @1167730
     /* 1167730 */   GIM_Try, /*On fail goto*//*Label 17021*/ GIMT_Encode4(1167810), // Rule ID 15988 //
     /* 1167735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1167738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1167746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1167749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1167752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1167755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167774 */     // MIs[0] round
     /* 1167774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167809 */     // GIR_Coverage, 15988,
     /* 1167809 */     GIR_EraseRootFromParent_Done,
     /* 1167810 */   // Label 17021: @1167810
     /* 1167810 */   GIM_Try, /*On fail goto*//*Label 17022*/ GIMT_Encode4(1167890), // Rule ID 15989 //
     /* 1167815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1167818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1167826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1167829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1167832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1167835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167854 */     // MIs[0] round
     /* 1167854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1167864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1167885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167889 */     // GIR_Coverage, 15989,
     /* 1167889 */     GIR_EraseRootFromParent_Done,
     /* 1167890 */   // Label 17022: @1167890
     /* 1167890 */   GIM_Try, /*On fail goto*//*Label 17023*/ GIMT_Encode4(1167970), // Rule ID 15992 //
     /* 1167895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1167898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1167906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1167909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1167912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1167915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1167918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1167934 */     // MIs[0] round
     /* 1167934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1167937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1167944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1167944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1167947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1167949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1167951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1167953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1167955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1167957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1167962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1167965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1167968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1167969 */     // GIR_Coverage, 15992,
     /* 1167969 */     GIR_EraseRootFromParent_Done,
     /* 1167970 */   // Label 17023: @1167970
     /* 1167970 */   GIM_Try, /*On fail goto*//*Label 17024*/ GIMT_Encode4(1168050), // Rule ID 15993 //
     /* 1167975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1167978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1167983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1167986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1167989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1167992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1167995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1167998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1168014 */     // MIs[0] round
     /* 1168014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1),
     /* 1168027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1168045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168049 */     // GIR_Coverage, 15993,
     /* 1168049 */     GIR_EraseRootFromParent_Done,
     /* 1168050 */   // Label 17024: @1168050
     /* 1168050 */   GIM_Try, /*On fail goto*//*Label 17025*/ GIMT_Encode4(1168130), // Rule ID 15996 //
     /* 1168055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1168066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1168069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1168075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168094 */     // MIs[0] round
     /* 1168094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168104 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1168107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168129 */     // GIR_Coverage, 15996,
     /* 1168129 */     GIR_EraseRootFromParent_Done,
     /* 1168130 */   // Label 17025: @1168130
     /* 1168130 */   GIM_Try, /*On fail goto*//*Label 17026*/ GIMT_Encode4(1168210), // Rule ID 15997 //
     /* 1168135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1168146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1168149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1168152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1168155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168174 */     // MIs[0] round
     /* 1168174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168184 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1168187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168209 */     // GIR_Coverage, 15997,
     /* 1168209 */     GIR_EraseRootFromParent_Done,
     /* 1168210 */   // Label 17026: @1168210
     /* 1168210 */   GIM_Try, /*On fail goto*//*Label 17027*/ GIMT_Encode4(1168290), // Rule ID 16000 //
     /* 1168215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1168226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1168229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1168232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1168235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168254 */     // MIs[0] round
     /* 1168254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168264 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1168267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168289 */     // GIR_Coverage, 16000,
     /* 1168289 */     GIR_EraseRootFromParent_Done,
     /* 1168290 */   // Label 17027: @1168290
     /* 1168290 */   GIM_Try, /*On fail goto*//*Label 17028*/ GIMT_Encode4(1168370), // Rule ID 16001 //
     /* 1168295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1168306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1168309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1168312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1168315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168334 */     // MIs[0] round
     /* 1168334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168344 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1168347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168369 */     // GIR_Coverage, 16001,
     /* 1168369 */     GIR_EraseRootFromParent_Done,
     /* 1168370 */   // Label 17028: @1168370
     /* 1168370 */   GIM_Try, /*On fail goto*//*Label 17029*/ GIMT_Encode4(1168450), // Rule ID 16004 //
     /* 1168375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1168386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1168389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1168392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1168395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168414 */     // MIs[0] round
     /* 1168414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168424 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1168427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168449 */     // GIR_Coverage, 16004,
     /* 1168449 */     GIR_EraseRootFromParent_Done,
     /* 1168450 */   // Label 17029: @1168450
     /* 1168450 */   GIM_Try, /*On fail goto*//*Label 17030*/ GIMT_Encode4(1168530), // Rule ID 16005 //
     /* 1168455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1168466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1168469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1168472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1168475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168494 */     // MIs[0] round
     /* 1168494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1168507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1168525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168529 */     // GIR_Coverage, 16005,
     /* 1168529 */     GIR_EraseRootFromParent_Done,
     /* 1168530 */   // Label 17030: @1168530
     /* 1168530 */   GIM_Try, /*On fail goto*//*Label 17031*/ GIMT_Encode4(1168610), // Rule ID 16008 //
     /* 1168535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1168546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1168549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1168552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1168555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168574 */     // MIs[0] round
     /* 1168574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1168587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168609 */     // GIR_Coverage, 16008,
     /* 1168609 */     GIR_EraseRootFromParent_Done,
     /* 1168610 */   // Label 17031: @1168610
     /* 1168610 */   GIM_Try, /*On fail goto*//*Label 17032*/ GIMT_Encode4(1168690), // Rule ID 16009 //
     /* 1168615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1168626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1168629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1168632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1168635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1168654 */     // MIs[0] round
     /* 1168654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168664 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1168667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168689 */     // GIR_Coverage, 16009,
     /* 1168689 */     GIR_EraseRootFromParent_Done,
     /* 1168690 */   // Label 17032: @1168690
     /* 1168690 */   GIM_Try, /*On fail goto*//*Label 17033*/ GIMT_Encode4(1168770), // Rule ID 16012 //
     /* 1168695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1168706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1168709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1168712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1168715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168734 */     // MIs[0] round
     /* 1168734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168744 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1168747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168769 */     // GIR_Coverage, 16012,
     /* 1168769 */     GIR_EraseRootFromParent_Done,
     /* 1168770 */   // Label 17033: @1168770
     /* 1168770 */   GIM_Try, /*On fail goto*//*Label 17034*/ GIMT_Encode4(1168850), // Rule ID 16013 //
     /* 1168775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1168786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1168789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1168792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1168795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1168814 */     // MIs[0] round
     /* 1168814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1168827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168849 */     // GIR_Coverage, 16013,
     /* 1168849 */     GIR_EraseRootFromParent_Done,
     /* 1168850 */   // Label 17034: @1168850
     /* 1168850 */   GIM_Try, /*On fail goto*//*Label 17035*/ GIMT_Encode4(1168930), // Rule ID 16016 //
     /* 1168855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1168858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1168866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1168869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1168872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1168875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1168878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168894 */     // MIs[0] round
     /* 1168894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168904 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1168904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1168907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1168922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1168925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1168928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1168929 */     // GIR_Coverage, 16016,
     /* 1168929 */     GIR_EraseRootFromParent_Done,
     /* 1168930 */   // Label 17035: @1168930
     /* 1168930 */   GIM_Try, /*On fail goto*//*Label 17036*/ GIMT_Encode4(1169010), // Rule ID 16017 //
     /* 1168935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1168938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1168943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1168946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1168949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1168952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1168955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1168958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1168974 */     // MIs[0] round
     /* 1168974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1168977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1168984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1168984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1168987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1168989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1168991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1168993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1168995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1168997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1169005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169009 */     // GIR_Coverage, 16017,
     /* 1169009 */     GIR_EraseRootFromParent_Done,
     /* 1169010 */   // Label 17036: @1169010
     /* 1169010 */   GIM_Try, /*On fail goto*//*Label 17037*/ GIMT_Encode4(1169090), // Rule ID 16020 //
     /* 1169015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1169026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1169029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1169035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169054 */     // MIs[0] round
     /* 1169054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1169067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169089 */     // GIR_Coverage, 16020,
     /* 1169089 */     GIR_EraseRootFromParent_Done,
     /* 1169090 */   // Label 17037: @1169090
     /* 1169090 */   GIM_Try, /*On fail goto*//*Label 17038*/ GIMT_Encode4(1169170), // Rule ID 16021 //
     /* 1169095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1169106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1169109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1169112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1169115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169134 */     // MIs[0] round
     /* 1169134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1169147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169169 */     // GIR_Coverage, 16021,
     /* 1169169 */     GIR_EraseRootFromParent_Done,
     /* 1169170 */   // Label 17038: @1169170
     /* 1169170 */   GIM_Try, /*On fail goto*//*Label 17039*/ GIMT_Encode4(1169250), // Rule ID 16024 //
     /* 1169175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1169186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1169189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1169192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1169195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169214 */     // MIs[0] round
     /* 1169214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169224 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1169227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169249 */     // GIR_Coverage, 16024,
     /* 1169249 */     GIR_EraseRootFromParent_Done,
     /* 1169250 */   // Label 17039: @1169250
     /* 1169250 */   GIM_Try, /*On fail goto*//*Label 17040*/ GIMT_Encode4(1169330), // Rule ID 16025 //
     /* 1169255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1169266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1169269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1169272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1169275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169294 */     // MIs[0] round
     /* 1169294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1169307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169329 */     // GIR_Coverage, 16025,
     /* 1169329 */     GIR_EraseRootFromParent_Done,
     /* 1169330 */   // Label 17040: @1169330
     /* 1169330 */   GIM_Try, /*On fail goto*//*Label 17041*/ GIMT_Encode4(1169410), // Rule ID 16028 //
     /* 1169335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1169346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1169349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1169352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1169355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169374 */     // MIs[0] round
     /* 1169374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169384 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1169387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169409 */     // GIR_Coverage, 16028,
     /* 1169409 */     GIR_EraseRootFromParent_Done,
     /* 1169410 */   // Label 17041: @1169410
     /* 1169410 */   GIM_Try, /*On fail goto*//*Label 17042*/ GIMT_Encode4(1169490), // Rule ID 16029 //
     /* 1169415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1169418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1169426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1169429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1169432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1169435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169454 */     // MIs[0] round
     /* 1169454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169464 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1169467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1169485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169489 */     // GIR_Coverage, 16029,
     /* 1169489 */     GIR_EraseRootFromParent_Done,
     /* 1169490 */   // Label 17042: @1169490
     /* 1169490 */   GIM_Try, /*On fail goto*//*Label 17043*/ GIMT_Encode4(1169570), // Rule ID 16032 //
     /* 1169495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1169506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1169509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1169512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1169515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169534 */     // MIs[0] round
     /* 1169534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1169547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169569 */     // GIR_Coverage, 16032,
     /* 1169569 */     GIR_EraseRootFromParent_Done,
     /* 1169570 */   // Label 17043: @1169570
     /* 1169570 */   GIM_Try, /*On fail goto*//*Label 17044*/ GIMT_Encode4(1169650), // Rule ID 16033 //
     /* 1169575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1169586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1169589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1169592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1169595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1169614 */     // MIs[0] round
     /* 1169614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2),
     /* 1169627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169649 */     // GIR_Coverage, 16033,
     /* 1169649 */     GIR_EraseRootFromParent_Done,
     /* 1169650 */   // Label 17044: @1169650
     /* 1169650 */   GIM_Try, /*On fail goto*//*Label 17045*/ GIMT_Encode4(1169730), // Rule ID 16036 //
     /* 1169655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1169666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1169669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1169672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1169675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169694 */     // MIs[0] round
     /* 1169694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169704 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1169707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169729 */     // GIR_Coverage, 16036,
     /* 1169729 */     GIR_EraseRootFromParent_Done,
     /* 1169730 */   // Label 17045: @1169730
     /* 1169730 */   GIM_Try, /*On fail goto*//*Label 17046*/ GIMT_Encode4(1169810), // Rule ID 16037 //
     /* 1169735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1169746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1169749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1169752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1169755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1169774 */     // MIs[0] round
     /* 1169774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4),
     /* 1169787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169809 */     // GIR_Coverage, 16037,
     /* 1169809 */     GIR_EraseRootFromParent_Done,
     /* 1169810 */   // Label 17046: @1169810
     /* 1169810 */   GIM_Try, /*On fail goto*//*Label 17047*/ GIMT_Encode4(1169890), // Rule ID 16040 //
     /* 1169815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1169818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1169826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1169829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1169832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1169835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169854 */     // MIs[0] round
     /* 1169854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169864 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1169864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1169867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169889 */     // GIR_Coverage, 16040,
     /* 1169889 */     GIR_EraseRootFromParent_Done,
     /* 1169890 */   // Label 17047: @1169890
     /* 1169890 */   GIM_Try, /*On fail goto*//*Label 17048*/ GIMT_Encode4(1169970), // Rule ID 16041 //
     /* 1169895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1169898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1169906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1169909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1169912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1169915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1169918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1169934 */     // MIs[0] round
     /* 1169934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1169937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1169944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VV_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1169944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8),
     /* 1169947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1169949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1169951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1169953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1169955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1169957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1169962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1169965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1169968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1169969 */     // GIR_Coverage, 16041,
     /* 1169969 */     GIR_EraseRootFromParent_Done,
     /* 1169970 */   // Label 17048: @1169970
     /* 1169970 */   GIM_Try, /*On fail goto*//*Label 17049*/ GIMT_Encode4(1170050), // Rule ID 16044 //
     /* 1169975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1169978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1169983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1169986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1169989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1169992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1169995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1169998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170014 */     // MIs[0] round
     /* 1170014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1170027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170049 */     // GIR_Coverage, 16044,
     /* 1170049 */     GIR_EraseRootFromParent_Done,
     /* 1170050 */   // Label 17049: @1170050
     /* 1170050 */   GIM_Try, /*On fail goto*//*Label 17050*/ GIMT_Encode4(1170130), // Rule ID 16045 //
     /* 1170055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1170066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1170069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1170072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170094 */     // MIs[0] round
     /* 1170094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170104 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8),
     /* 1170107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170129 */     // GIR_Coverage, 16045,
     /* 1170129 */     GIR_EraseRootFromParent_Done,
     /* 1170130 */   // Label 17050: @1170130
     /* 1170130 */   GIM_Try, /*On fail goto*//*Label 17051*/ GIMT_Encode4(1170210), // Rule ID 16048 //
     /* 1170135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1170146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1170149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1170152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170174 */     // MIs[0] round
     /* 1170174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170184 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1170187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170209 */     // GIR_Coverage, 16048,
     /* 1170209 */     GIR_EraseRootFromParent_Done,
     /* 1170210 */   // Label 17051: @1170210
     /* 1170210 */   GIM_Try, /*On fail goto*//*Label 17052*/ GIMT_Encode4(1170290), // Rule ID 16049 //
     /* 1170215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1170226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1170229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1170232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170254 */     // MIs[0] round
     /* 1170254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1170267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170289 */     // GIR_Coverage, 16049,
     /* 1170289 */     GIR_EraseRootFromParent_Done,
     /* 1170290 */   // Label 17052: @1170290
     /* 1170290 */   GIM_Try, /*On fail goto*//*Label 17053*/ GIMT_Encode4(1170370), // Rule ID 16052 //
     /* 1170295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1170306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1170309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1170312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170334 */     // MIs[0] round
     /* 1170334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170344 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170369 */     // GIR_Coverage, 16052,
     /* 1170369 */     GIR_EraseRootFromParent_Done,
     /* 1170370 */   // Label 17053: @1170370
     /* 1170370 */   GIM_Try, /*On fail goto*//*Label 17054*/ GIMT_Encode4(1170450), // Rule ID 16053 //
     /* 1170375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1170386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1170389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1170392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170414 */     // MIs[0] round
     /* 1170414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1170445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170449 */     // GIR_Coverage, 16053,
     /* 1170449 */     GIR_EraseRootFromParent_Done,
     /* 1170450 */   // Label 17054: @1170450
     /* 1170450 */   GIM_Try, /*On fail goto*//*Label 17055*/ GIMT_Encode4(1170530), // Rule ID 16056 //
     /* 1170455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1170466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1170469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1170472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170494 */     // MIs[0] round
     /* 1170494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170504 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1170507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170529 */     // GIR_Coverage, 16056,
     /* 1170529 */     GIR_EraseRootFromParent_Done,
     /* 1170530 */   // Label 17055: @1170530
     /* 1170530 */   GIM_Try, /*On fail goto*//*Label 17056*/ GIMT_Encode4(1170610), // Rule ID 16057 //
     /* 1170535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1170546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1170549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1170552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170574 */     // MIs[0] round
     /* 1170574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4),
     /* 1170587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170609 */     // GIR_Coverage, 16057,
     /* 1170609 */     GIR_EraseRootFromParent_Done,
     /* 1170610 */   // Label 17056: @1170610
     /* 1170610 */   GIM_Try, /*On fail goto*//*Label 17057*/ GIMT_Encode4(1170690), // Rule ID 16060 //
     /* 1170615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1170626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1170629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1170632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170654 */     // MIs[0] round
     /* 1170654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170664 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170689 */     // GIR_Coverage, 16060,
     /* 1170689 */     GIR_EraseRootFromParent_Done,
     /* 1170690 */   // Label 17057: @1170690
     /* 1170690 */   GIM_Try, /*On fail goto*//*Label 17058*/ GIMT_Encode4(1170770), // Rule ID 16061 //
     /* 1170695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1170706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1170709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1170712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170734 */     // MIs[0] round
     /* 1170734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1170765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170769 */     // GIR_Coverage, 16061,
     /* 1170769 */     GIR_EraseRootFromParent_Done,
     /* 1170770 */   // Label 17058: @1170770
     /* 1170770 */   GIM_Try, /*On fail goto*//*Label 17059*/ GIMT_Encode4(1170850), // Rule ID 16064 //
     /* 1170775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1170786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1170789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1170792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170814 */     // MIs[0] round
     /* 1170814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170849 */     // GIR_Coverage, 16064,
     /* 1170849 */     GIR_EraseRootFromParent_Done,
     /* 1170850 */   // Label 17059: @1170850
     /* 1170850 */   GIM_Try, /*On fail goto*//*Label 17060*/ GIMT_Encode4(1170930), // Rule ID 16065 //
     /* 1170855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1170858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1170866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1170869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1170872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1170875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1170878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170894 */     // MIs[0] round
     /* 1170894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170904 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1170904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2),
     /* 1170907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1170922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1170925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1170928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1170929 */     // GIR_Coverage, 16065,
     /* 1170929 */     GIR_EraseRootFromParent_Done,
     /* 1170930 */   // Label 17060: @1170930
     /* 1170930 */   GIM_Try, /*On fail goto*//*Label 17061*/ GIMT_Encode4(1171010), // Rule ID 16068 //
     /* 1170935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1170938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1170943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1170946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1170949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1170952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1170955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1170958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1170970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1170974 */     // MIs[0] round
     /* 1170974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1170977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1170984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1170984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1170987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1170989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1170991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1170993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1170995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1170997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171009 */     // GIR_Coverage, 16068,
     /* 1171009 */     GIR_EraseRootFromParent_Done,
     /* 1171010 */   // Label 17061: @1171010
     /* 1171010 */   GIM_Try, /*On fail goto*//*Label 17062*/ GIMT_Encode4(1171090), // Rule ID 16069 //
     /* 1171015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1171026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1171029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1171032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171054 */     // MIs[0] round
     /* 1171054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11530:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171089 */     // GIR_Coverage, 16069,
     /* 1171089 */     GIR_EraseRootFromParent_Done,
     /* 1171090 */   // Label 17062: @1171090
     /* 1171090 */   GIM_Try, /*On fail goto*//*Label 17063*/ GIMT_Encode4(1171170), // Rule ID 16072 //
     /* 1171095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1171106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1171109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1171112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171134 */     // MIs[0] round
     /* 1171134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171169 */     // GIR_Coverage, 16072,
     /* 1171169 */     GIR_EraseRootFromParent_Done,
     /* 1171170 */   // Label 17063: @1171170
     /* 1171170 */   GIM_Try, /*On fail goto*//*Label 17064*/ GIMT_Encode4(1171250), // Rule ID 16073 //
     /* 1171175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1171186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1171189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1171192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171214 */     // MIs[0] round
     /* 1171214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11530:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1171245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171249 */     // GIR_Coverage, 16073,
     /* 1171249 */     GIR_EraseRootFromParent_Done,
     /* 1171250 */   // Label 17064: @1171250
     /* 1171250 */   GIM_Try, /*On fail goto*//*Label 17065*/ GIMT_Encode4(1171330), // Rule ID 16076 //
     /* 1171255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1171266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1171269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1171272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171294 */     // MIs[0] round
     /* 1171294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171304 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171329 */     // GIR_Coverage, 16076,
     /* 1171329 */     GIR_EraseRootFromParent_Done,
     /* 1171330 */   // Label 17065: @1171330
     /* 1171330 */   GIM_Try, /*On fail goto*//*Label 17066*/ GIMT_Encode4(1171410), // Rule ID 16077 //
     /* 1171335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1171346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1171349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1171352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171374 */     // MIs[0] round
     /* 1171374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11530:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1171405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171409 */     // GIR_Coverage, 16077,
     /* 1171409 */     GIR_EraseRootFromParent_Done,
     /* 1171410 */   // Label 17066: @1171410
     /* 1171410 */   GIM_Try, /*On fail goto*//*Label 17067*/ GIMT_Encode4(1171490), // Rule ID 16080 //
     /* 1171415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1171418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1171426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1171429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1171432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171454 */     // MIs[0] round
     /* 1171454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171464 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171489 */     // GIR_Coverage, 16080,
     /* 1171489 */     GIR_EraseRootFromParent_Done,
     /* 1171490 */   // Label 17067: @1171490
     /* 1171490 */   GIM_Try, /*On fail goto*//*Label 17068*/ GIMT_Encode4(1171570), // Rule ID 16081 //
     /* 1171495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1171498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1171506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1171509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1171512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1171530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171534 */     // MIs[0] round
     /* 1171534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171544 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11530:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1),
     /* 1171547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1171565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171569 */     // GIR_Coverage, 16081,
     /* 1171569 */     GIR_EraseRootFromParent_Done,
     /* 1171570 */   // Label 17068: @1171570
     /* 1171570 */   GIM_Try, /*On fail goto*//*Label 17069*/ GIMT_Encode4(1171650), // Rule ID 16084 //
     /* 1171575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1171586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1171589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1171592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171614 */     // MIs[0] round
     /* 1171614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1171627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171649 */     // GIR_Coverage, 16084,
     /* 1171649 */     GIR_EraseRootFromParent_Done,
     /* 1171650 */   // Label 17069: @1171650
     /* 1171650 */   GIM_Try, /*On fail goto*//*Label 17070*/ GIMT_Encode4(1171730), // Rule ID 16085 //
     /* 1171655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1171666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1171669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1171672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1171690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171694 */     // MIs[0] round
     /* 1171694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1171707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171729 */     // GIR_Coverage, 16085,
     /* 1171729 */     GIR_EraseRootFromParent_Done,
     /* 1171730 */   // Label 17070: @1171730
     /* 1171730 */   GIM_Try, /*On fail goto*//*Label 17071*/ GIMT_Encode4(1171810), // Rule ID 16088 //
     /* 1171735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1171746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1171749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1171752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171774 */     // MIs[0] round
     /* 1171774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1171787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171809 */     // GIR_Coverage, 16088,
     /* 1171809 */     GIR_EraseRootFromParent_Done,
     /* 1171810 */   // Label 17071: @1171810
     /* 1171810 */   GIM_Try, /*On fail goto*//*Label 17072*/ GIMT_Encode4(1171890), // Rule ID 16089 //
     /* 1171815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1171826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1171829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1171832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1171850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171854 */     // MIs[0] round
     /* 1171854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1171864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1171867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171889 */     // GIR_Coverage, 16089,
     /* 1171889 */     GIR_EraseRootFromParent_Done,
     /* 1171890 */   // Label 17072: @1171890
     /* 1171890 */   GIM_Try, /*On fail goto*//*Label 17073*/ GIMT_Encode4(1171970), // Rule ID 16092 //
     /* 1171895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1171898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1171906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1171909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1171912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1171915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1171918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1171930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1171934 */     // MIs[0] round
     /* 1171934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1171937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1171944 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1171944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1171947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1171949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1171951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1171953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1171955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1171957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1171962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1171965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1171968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1171969 */     // GIR_Coverage, 16092,
     /* 1171969 */     GIR_EraseRootFromParent_Done,
     /* 1171970 */   // Label 17073: @1171970
     /* 1171970 */   GIM_Try, /*On fail goto*//*Label 17074*/ GIMT_Encode4(1172050), // Rule ID 16093 //
     /* 1171975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1171978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1171983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1171986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1171989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1171992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1171995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1171998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172014 */     // MIs[0] round
     /* 1172014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1172027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1172045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172049 */     // GIR_Coverage, 16093,
     /* 1172049 */     GIR_EraseRootFromParent_Done,
     /* 1172050 */   // Label 17074: @1172050
     /* 1172050 */   GIM_Try, /*On fail goto*//*Label 17075*/ GIMT_Encode4(1172130), // Rule ID 16096 //
     /* 1172055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1172066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1172069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172094 */     // MIs[0] round
     /* 1172094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1172107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172129 */     // GIR_Coverage, 16096,
     /* 1172129 */     GIR_EraseRootFromParent_Done,
     /* 1172130 */   // Label 17075: @1172130
     /* 1172130 */   GIM_Try, /*On fail goto*//*Label 17076*/ GIMT_Encode4(1172210), // Rule ID 16097 //
     /* 1172135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1172146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1172149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1172152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172174 */     // MIs[0] round
     /* 1172174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1172187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172209 */     // GIR_Coverage, 16097,
     /* 1172209 */     GIR_EraseRootFromParent_Done,
     /* 1172210 */   // Label 17076: @1172210
     /* 1172210 */   GIM_Try, /*On fail goto*//*Label 17077*/ GIMT_Encode4(1172290), // Rule ID 16100 //
     /* 1172215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1172226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1172229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1172232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172254 */     // MIs[0] round
     /* 1172254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1172267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172289 */     // GIR_Coverage, 16100,
     /* 1172289 */     GIR_EraseRootFromParent_Done,
     /* 1172290 */   // Label 17077: @1172290
     /* 1172290 */   GIM_Try, /*On fail goto*//*Label 17078*/ GIMT_Encode4(1172370), // Rule ID 16101 //
     /* 1172295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1172306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1172309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1172312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172334 */     // MIs[0] round
     /* 1172334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172344 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1172347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172369 */     // GIR_Coverage, 16101,
     /* 1172369 */     GIR_EraseRootFromParent_Done,
     /* 1172370 */   // Label 17078: @1172370
     /* 1172370 */   GIM_Try, /*On fail goto*//*Label 17079*/ GIMT_Encode4(1172450), // Rule ID 16104 //
     /* 1172375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1172386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1172389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1172392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172414 */     // MIs[0] round
     /* 1172414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172424 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1172427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172449 */     // GIR_Coverage, 16104,
     /* 1172449 */     GIR_EraseRootFromParent_Done,
     /* 1172450 */   // Label 17079: @1172450
     /* 1172450 */   GIM_Try, /*On fail goto*//*Label 17080*/ GIMT_Encode4(1172530), // Rule ID 16105 //
     /* 1172455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1172466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1172469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1172472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172494 */     // MIs[0] round
     /* 1172494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1172507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1172525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172529 */     // GIR_Coverage, 16105,
     /* 1172529 */     GIR_EraseRootFromParent_Done,
     /* 1172530 */   // Label 17080: @1172530
     /* 1172530 */   GIM_Try, /*On fail goto*//*Label 17081*/ GIMT_Encode4(1172610), // Rule ID 16108 //
     /* 1172535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1172546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1172549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1172552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172574 */     // MIs[0] round
     /* 1172574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172584 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1172587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172609 */     // GIR_Coverage, 16108,
     /* 1172609 */     GIR_EraseRootFromParent_Done,
     /* 1172610 */   // Label 17081: @1172610
     /* 1172610 */   GIM_Try, /*On fail goto*//*Label 17082*/ GIMT_Encode4(1172690), // Rule ID 16109 //
     /* 1172615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1172626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1172629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1172632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1172650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172654 */     // MIs[0] round
     /* 1172654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1172667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172689 */     // GIR_Coverage, 16109,
     /* 1172689 */     GIR_EraseRootFromParent_Done,
     /* 1172690 */   // Label 17082: @1172690
     /* 1172690 */   GIM_Try, /*On fail goto*//*Label 17083*/ GIMT_Encode4(1172770), // Rule ID 16112 //
     /* 1172695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1172706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1172709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1172712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172734 */     // MIs[0] round
     /* 1172734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172744 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1172747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172769 */     // GIR_Coverage, 16112,
     /* 1172769 */     GIR_EraseRootFromParent_Done,
     /* 1172770 */   // Label 17083: @1172770
     /* 1172770 */   GIM_Try, /*On fail goto*//*Label 17084*/ GIMT_Encode4(1172850), // Rule ID 16113 //
     /* 1172775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1172786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1172789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1172792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1172810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172814 */     // MIs[0] round
     /* 1172814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1172827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172849 */     // GIR_Coverage, 16113,
     /* 1172849 */     GIR_EraseRootFromParent_Done,
     /* 1172850 */   // Label 17084: @1172850
     /* 1172850 */   GIM_Try, /*On fail goto*//*Label 17085*/ GIMT_Encode4(1172930), // Rule ID 16116 //
     /* 1172855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1172858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1172866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1172869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1172872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1172875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1172878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172894 */     // MIs[0] round
     /* 1172894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172904 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1172904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1172907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1172922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1172925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1172928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1172929 */     // GIR_Coverage, 16116,
     /* 1172929 */     GIR_EraseRootFromParent_Done,
     /* 1172930 */   // Label 17085: @1172930
     /* 1172930 */   GIM_Try, /*On fail goto*//*Label 17086*/ GIMT_Encode4(1173010), // Rule ID 16117 //
     /* 1172935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1172938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1172943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1172946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1172949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1172952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1172955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1172958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1172970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1172974 */     // MIs[0] round
     /* 1172974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1172977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1172984 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1172984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1172987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1172989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1172991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1172993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1172995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1172997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1173005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173009 */     // GIR_Coverage, 16117,
     /* 1173009 */     GIR_EraseRootFromParent_Done,
     /* 1173010 */   // Label 17086: @1173010
     /* 1173010 */   GIM_Try, /*On fail goto*//*Label 17087*/ GIMT_Encode4(1173090), // Rule ID 16120 //
     /* 1173015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1173026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1173029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173054 */     // MIs[0] round
     /* 1173054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173064 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1173067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173089 */     // GIR_Coverage, 16120,
     /* 1173089 */     GIR_EraseRootFromParent_Done,
     /* 1173090 */   // Label 17087: @1173090
     /* 1173090 */   GIM_Try, /*On fail goto*//*Label 17088*/ GIMT_Encode4(1173170), // Rule ID 16121 //
     /* 1173095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1173106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1173109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1173112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1173130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173134 */     // MIs[0] round
     /* 1173134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11530:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2),
     /* 1173147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173169 */     // GIR_Coverage, 16121,
     /* 1173169 */     GIR_EraseRootFromParent_Done,
     /* 1173170 */   // Label 17088: @1173170
     /* 1173170 */   GIM_Try, /*On fail goto*//*Label 17089*/ GIMT_Encode4(1173250), // Rule ID 16124 //
     /* 1173175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1173186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1173189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1173192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173214 */     // MIs[0] round
     /* 1173214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173224 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1173227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173249 */     // GIR_Coverage, 16124,
     /* 1173249 */     GIR_EraseRootFromParent_Done,
     /* 1173250 */   // Label 17089: @1173250
     /* 1173250 */   GIM_Try, /*On fail goto*//*Label 17090*/ GIMT_Encode4(1173330), // Rule ID 16125 //
     /* 1173255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1173266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1173269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1173272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1173290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173294 */     // MIs[0] round
     /* 1173294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11530:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4),
     /* 1173307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173329 */     // GIR_Coverage, 16125,
     /* 1173329 */     GIR_EraseRootFromParent_Done,
     /* 1173330 */   // Label 17090: @1173330
     /* 1173330 */   GIM_Try, /*On fail goto*//*Label 17091*/ GIMT_Encode4(1173410), // Rule ID 16128 //
     /* 1173335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1173338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1173346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1173349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1173352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1173355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173374 */     // MIs[0] round
     /* 1173374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173384 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1173387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173409 */     // GIR_Coverage, 16128,
     /* 1173409 */     GIR_EraseRootFromParent_Done,
     /* 1173410 */   // Label 17091: @1173410
     /* 1173410 */   GIM_Try, /*On fail goto*//*Label 17092*/ GIMT_Encode4(1173490), // Rule ID 16129 //
     /* 1173415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1173418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra),
     /* 1173423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1173426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1173429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1173432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1173435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1173450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1173454 */     // MIs[0] round
     /* 1173454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173464 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11530:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSSRA_VX_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8),
     /* 1173467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1173485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173489 */     // GIR_Coverage, 16129,
     /* 1173489 */     GIR_EraseRootFromParent_Done,
     /* 1173490 */   // Label 17092: @1173490
     /* 1173490 */   GIM_Try, /*On fail goto*//*Label 17093*/ GIMT_Encode4(1173573), // Rule ID 16220 //
     /* 1173495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1173506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1173509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1173512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1173515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173534 */     // MIs[0] round
     /* 1173534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173544 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1173547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173568 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173572 */     // GIR_Coverage, 16220,
     /* 1173572 */     GIR_EraseRootFromParent_Done,
     /* 1173573 */   // Label 17093: @1173573
     /* 1173573 */   GIM_Try, /*On fail goto*//*Label 17094*/ GIMT_Encode4(1173656), // Rule ID 16221 //
     /* 1173578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1173589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1173592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1173595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1173598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173617 */     // MIs[0] round
     /* 1173617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173627 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8),
     /* 1173630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173632 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173638 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173655 */     // GIR_Coverage, 16221,
     /* 1173655 */     GIR_EraseRootFromParent_Done,
     /* 1173656 */   // Label 17094: @1173656
     /* 1173656 */   GIM_Try, /*On fail goto*//*Label 17095*/ GIMT_Encode4(1173739), // Rule ID 16224 //
     /* 1173661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1173672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1173675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1173678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1173681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173700 */     // MIs[0] round
     /* 1173700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173710 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1173713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173734 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173738 */     // GIR_Coverage, 16224,
     /* 1173738 */     GIR_EraseRootFromParent_Done,
     /* 1173739 */   // Label 17095: @1173739
     /* 1173739 */   GIM_Try, /*On fail goto*//*Label 17096*/ GIMT_Encode4(1173822), // Rule ID 16225 //
     /* 1173744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1173755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1173758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1173761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1173764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173783 */     // MIs[0] round
     /* 1173783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173793 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1173796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173804 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173821 */     // GIR_Coverage, 16225,
     /* 1173821 */     GIR_EraseRootFromParent_Done,
     /* 1173822 */   // Label 17096: @1173822
     /* 1173822 */   GIM_Try, /*On fail goto*//*Label 17097*/ GIMT_Encode4(1173905), // Rule ID 16228 //
     /* 1173827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1173838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1173841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1173844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1173847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1173850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173866 */     // MIs[0] round
     /* 1173866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173876 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1173876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1173879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173904 */     // GIR_Coverage, 16228,
     /* 1173904 */     GIR_EraseRootFromParent_Done,
     /* 1173905 */   // Label 17097: @1173905
     /* 1173905 */   GIM_Try, /*On fail goto*//*Label 17098*/ GIMT_Encode4(1173988), // Rule ID 16229 //
     /* 1173910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1173913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1173918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1173921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1173924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1173927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1173930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1173933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1173949 */     // MIs[0] round
     /* 1173949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1173952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1173959 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1173959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1173962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1173964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1173966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1173968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1173970 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1173972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1173977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1173980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1173983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1173986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1173987 */     // GIR_Coverage, 16229,
     /* 1173987 */     GIR_EraseRootFromParent_Done,
     /* 1173988 */   // Label 17098: @1173988
     /* 1173988 */   GIM_Try, /*On fail goto*//*Label 17099*/ GIMT_Encode4(1174071), // Rule ID 16232 //
     /* 1173993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1173996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1174004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1174007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1174010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1174013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174032 */     // MIs[0] round
     /* 1174032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1174045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174070 */     // GIR_Coverage, 16232,
     /* 1174070 */     GIR_EraseRootFromParent_Done,
     /* 1174071 */   // Label 17099: @1174071
     /* 1174071 */   GIM_Try, /*On fail goto*//*Label 17100*/ GIMT_Encode4(1174154), // Rule ID 16233 //
     /* 1174076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1174087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1174090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1174093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1174096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174115 */     // MIs[0] round
     /* 1174115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174125 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1174128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174136 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174153 */     // GIR_Coverage, 16233,
     /* 1174153 */     GIR_EraseRootFromParent_Done,
     /* 1174154 */   // Label 17100: @1174154
     /* 1174154 */   GIM_Try, /*On fail goto*//*Label 17101*/ GIMT_Encode4(1174237), // Rule ID 16236 //
     /* 1174159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1174170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1174173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1174176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1174179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174198 */     // MIs[0] round
     /* 1174198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174208 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1174211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174236 */     // GIR_Coverage, 16236,
     /* 1174236 */     GIR_EraseRootFromParent_Done,
     /* 1174237 */   // Label 17101: @1174237
     /* 1174237 */   GIM_Try, /*On fail goto*//*Label 17102*/ GIMT_Encode4(1174320), // Rule ID 16237 //
     /* 1174242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1174253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1174256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1174259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1174262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174281 */     // MIs[0] round
     /* 1174281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1174294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174302 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174318 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174319 */     // GIR_Coverage, 16237,
     /* 1174319 */     GIR_EraseRootFromParent_Done,
     /* 1174320 */   // Label 17102: @1174320
     /* 1174320 */   GIM_Try, /*On fail goto*//*Label 17103*/ GIMT_Encode4(1174403), // Rule ID 16240 //
     /* 1174325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1174336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1174339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1174345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174364 */     // MIs[0] round
     /* 1174364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174374 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1174377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174402 */     // GIR_Coverage, 16240,
     /* 1174402 */     GIR_EraseRootFromParent_Done,
     /* 1174403 */   // Label 17103: @1174403
     /* 1174403 */   GIM_Try, /*On fail goto*//*Label 17104*/ GIMT_Encode4(1174486), // Rule ID 16241 //
     /* 1174408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1174419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1174422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1174425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1174428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1174443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1174447 */     // MIs[0] round
     /* 1174447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174457 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1174460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174468 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1174478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174485 */     // GIR_Coverage, 16241,
     /* 1174485 */     GIR_EraseRootFromParent_Done,
     /* 1174486 */   // Label 17104: @1174486
     /* 1174486 */   GIM_Try, /*On fail goto*//*Label 17105*/ GIMT_Encode4(1174569), // Rule ID 16244 //
     /* 1174491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1174502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1174505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1174508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1174511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174530 */     // MIs[0] round
     /* 1174530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174540 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1174543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174568 */     // GIR_Coverage, 16244,
     /* 1174568 */     GIR_EraseRootFromParent_Done,
     /* 1174569 */   // Label 17105: @1174569
     /* 1174569 */   GIM_Try, /*On fail goto*//*Label 17106*/ GIMT_Encode4(1174652), // Rule ID 16245 //
     /* 1174574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1174585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1174588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1174591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1174594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174613 */     // MIs[0] round
     /* 1174613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174623 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4),
     /* 1174626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174634 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174651 */     // GIR_Coverage, 16245,
     /* 1174651 */     GIR_EraseRootFromParent_Done,
     /* 1174652 */   // Label 17106: @1174652
     /* 1174652 */   GIM_Try, /*On fail goto*//*Label 17107*/ GIMT_Encode4(1174735), // Rule ID 16248 //
     /* 1174657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1174668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1174671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1174674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1174677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174696 */     // MIs[0] round
     /* 1174696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174706 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1174709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174734 */     // GIR_Coverage, 16248,
     /* 1174734 */     GIR_EraseRootFromParent_Done,
     /* 1174735 */   // Label 17107: @1174735
     /* 1174735 */   GIM_Try, /*On fail goto*//*Label 17108*/ GIMT_Encode4(1174818), // Rule ID 16249 //
     /* 1174740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1174751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1174754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1174757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1174760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174779 */     // MIs[0] round
     /* 1174779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174789 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1174792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174800 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174817 */     // GIR_Coverage, 16249,
     /* 1174817 */     GIR_EraseRootFromParent_Done,
     /* 1174818 */   // Label 17108: @1174818
     /* 1174818 */   GIM_Try, /*On fail goto*//*Label 17109*/ GIMT_Encode4(1174901), // Rule ID 16252 //
     /* 1174823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1174834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1174837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1174843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1174846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174862 */     // MIs[0] round
     /* 1174862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1174872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1174875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174900 */     // GIR_Coverage, 16252,
     /* 1174900 */     GIR_EraseRootFromParent_Done,
     /* 1174901 */   // Label 17109: @1174901
     /* 1174901 */   GIM_Try, /*On fail goto*//*Label 17110*/ GIMT_Encode4(1174984), // Rule ID 16253 //
     /* 1174906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1174909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1174917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1174920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1174923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1174926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1174929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1174941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1174945 */     // MIs[0] round
     /* 1174945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1174948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1174955 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1174955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1174958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1174960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1174962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1174964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1174966 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1174968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1174973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1174976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1174979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1174982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1174983 */     // GIR_Coverage, 16253,
     /* 1174983 */     GIR_EraseRootFromParent_Done,
     /* 1174984 */   // Label 17110: @1174984
     /* 1174984 */   GIM_Try, /*On fail goto*//*Label 17111*/ GIMT_Encode4(1175067), // Rule ID 16256 //
     /* 1174989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1174992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1174997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1175000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1175003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1175006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1175009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175028 */     // MIs[0] round
     /* 1175028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1175041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175066 */     // GIR_Coverage, 16256,
     /* 1175066 */     GIR_EraseRootFromParent_Done,
     /* 1175067 */   // Label 17111: @1175067
     /* 1175067 */   GIM_Try, /*On fail goto*//*Label 17112*/ GIMT_Encode4(1175150), // Rule ID 16257 //
     /* 1175072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1175083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1175086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1175089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1175092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175111 */     // MIs[0] round
     /* 1175111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175121 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1175124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175132 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175149 */     // GIR_Coverage, 16257,
     /* 1175149 */     GIR_EraseRootFromParent_Done,
     /* 1175150 */   // Label 17112: @1175150
     /* 1175150 */   GIM_Try, /*On fail goto*//*Label 17113*/ GIMT_Encode4(1175233), // Rule ID 16260 //
     /* 1175155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1175166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1175169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1175172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1175175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175194 */     // MIs[0] round
     /* 1175194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175204 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1175207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175228 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175232 */     // GIR_Coverage, 16260,
     /* 1175232 */     GIR_EraseRootFromParent_Done,
     /* 1175233 */   // Label 17113: @1175233
     /* 1175233 */   GIM_Try, /*On fail goto*//*Label 17114*/ GIMT_Encode4(1175316), // Rule ID 16261 //
     /* 1175238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1175241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1175249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1175252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1175255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1175258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175277 */     // MIs[0] round
     /* 1175277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175287 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1175290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175298 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1175308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175315 */     // GIR_Coverage, 16261,
     /* 1175315 */     GIR_EraseRootFromParent_Done,
     /* 1175316 */   // Label 17114: @1175316
     /* 1175316 */   GIM_Try, /*On fail goto*//*Label 17115*/ GIMT_Encode4(1175399), // Rule ID 16264 //
     /* 1175321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1175324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175360 */     // MIs[0] round
     /* 1175360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175370 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1175373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175398 */     // GIR_Coverage, 16264,
     /* 1175398 */     GIR_EraseRootFromParent_Done,
     /* 1175399 */   // Label 17115: @1175399
     /* 1175399 */   GIM_Try, /*On fail goto*//*Label 17116*/ GIMT_Encode4(1175482), // Rule ID 16265 //
     /* 1175404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1175407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1175415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1175418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1175421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1175424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175443 */     // MIs[0] round
     /* 1175443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175453 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2),
     /* 1175456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175464 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175477 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175481 */     // GIR_Coverage, 16265,
     /* 1175481 */     GIR_EraseRootFromParent_Done,
     /* 1175482 */   // Label 17116: @1175482
     /* 1175482 */   GIM_Try, /*On fail goto*//*Label 17117*/ GIMT_Encode4(1175565), // Rule ID 16268 //
     /* 1175487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1175490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1175504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1175507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175526 */     // MIs[0] round
     /* 1175526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1175539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175564 */     // GIR_Coverage, 16268,
     /* 1175564 */     GIR_EraseRootFromParent_Done,
     /* 1175565 */   // Label 17117: @1175565
     /* 1175565 */   GIM_Try, /*On fail goto*//*Label 17118*/ GIMT_Encode4(1175648), // Rule ID 16269 //
     /* 1175570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1175573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1175581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1175584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1175587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1175590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1175609 */     // MIs[0] round
     /* 1175609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175619 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1),
     /* 1175622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175630 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175647 */     // GIR_Coverage, 16269,
     /* 1175647 */     GIR_EraseRootFromParent_Done,
     /* 1175648 */   // Label 17118: @1175648
     /* 1175648 */   GIM_Try, /*On fail goto*//*Label 17119*/ GIMT_Encode4(1175731), // Rule ID 16272 //
     /* 1175653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1175656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1175664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1175667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1175670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1175673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175692 */     // MIs[0] round
     /* 1175692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1175705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175730 */     // GIR_Coverage, 16272,
     /* 1175730 */     GIR_EraseRootFromParent_Done,
     /* 1175731 */   // Label 17119: @1175731
     /* 1175731 */   GIM_Try, /*On fail goto*//*Label 17120*/ GIMT_Encode4(1175814), // Rule ID 16273 //
     /* 1175736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1175739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1175747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1175750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1175753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1175756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1175775 */     // MIs[0] round
     /* 1175775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175785 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2),
     /* 1175788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175796 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175813 */     // GIR_Coverage, 16273,
     /* 1175813 */     GIR_EraseRootFromParent_Done,
     /* 1175814 */   // Label 17120: @1175814
     /* 1175814 */   GIM_Try, /*On fail goto*//*Label 17121*/ GIMT_Encode4(1175897), // Rule ID 16276 //
     /* 1175819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1175822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1175830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1175833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1175836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1175839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1175842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175858 */     // MIs[0] round
     /* 1175858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175868 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1175868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1175871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175892 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175896 */     // GIR_Coverage, 16276,
     /* 1175896 */     GIR_EraseRootFromParent_Done,
     /* 1175897 */   // Label 17121: @1175897
     /* 1175897 */   GIM_Try, /*On fail goto*//*Label 17122*/ GIMT_Encode4(1175980), // Rule ID 16277 //
     /* 1175902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1175905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1175913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1175916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1175919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1175922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1175925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1175937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1175941 */     // MIs[0] round
     /* 1175941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1175944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1175951 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1175951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4),
     /* 1175954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1175956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1175958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1175960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1175962 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1175964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1175969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1175972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1175975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1175978 */     GIR_RootConstrainSelectedInstOperands,
     /* 1175979 */     // GIR_Coverage, 16277,
     /* 1175979 */     GIR_EraseRootFromParent_Done,
     /* 1175980 */   // Label 17122: @1175980
     /* 1175980 */   GIM_Try, /*On fail goto*//*Label 17123*/ GIMT_Encode4(1176063), // Rule ID 16280 //
     /* 1175985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1175988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1175993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1175996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1175999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1176002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176024 */     // MIs[0] round
     /* 1176024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1176037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176058 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176062 */     // GIR_Coverage, 16280,
     /* 1176062 */     GIR_EraseRootFromParent_Done,
     /* 1176063 */   // Label 17123: @1176063
     /* 1176063 */   GIM_Try, /*On fail goto*//*Label 17124*/ GIMT_Encode4(1176146), // Rule ID 16281 //
     /* 1176068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1176079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1176082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1176085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176107 */     // MIs[0] round
     /* 1176107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176117 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8),
     /* 1176120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176128 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176145 */     // GIR_Coverage, 16281,
     /* 1176145 */     GIR_EraseRootFromParent_Done,
     /* 1176146 */   // Label 17124: @1176146
     /* 1176146 */   GIM_Try, /*On fail goto*//*Label 17125*/ GIMT_Encode4(1176229), // Rule ID 16284 //
     /* 1176151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1176162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1176165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1176168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176190 */     // MIs[0] round
     /* 1176190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1176203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176228 */     // GIR_Coverage, 16284,
     /* 1176228 */     GIR_EraseRootFromParent_Done,
     /* 1176229 */   // Label 17125: @1176229
     /* 1176229 */   GIM_Try, /*On fail goto*//*Label 17126*/ GIMT_Encode4(1176312), // Rule ID 16285 //
     /* 1176234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1176245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1176248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1176251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176273 */     // MIs[0] round
     /* 1176273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176283 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1176286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176294 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176311 */     // GIR_Coverage, 16285,
     /* 1176311 */     GIR_EraseRootFromParent_Done,
     /* 1176312 */   // Label 17126: @1176312
     /* 1176312 */   GIM_Try, /*On fail goto*//*Label 17127*/ GIMT_Encode4(1176395), // Rule ID 16288 //
     /* 1176317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1176328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1176331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176356 */     // MIs[0] round
     /* 1176356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176366 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1176369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176394 */     // GIR_Coverage, 16288,
     /* 1176394 */     GIR_EraseRootFromParent_Done,
     /* 1176395 */   // Label 17127: @1176395
     /* 1176395 */   GIM_Try, /*On fail goto*//*Label 17128*/ GIMT_Encode4(1176478), // Rule ID 16289 //
     /* 1176400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1176411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1176414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1176417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176439 */     // MIs[0] round
     /* 1176439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176449 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1176452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176460 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176477 */     // GIR_Coverage, 16289,
     /* 1176477 */     GIR_EraseRootFromParent_Done,
     /* 1176478 */   // Label 17128: @1176478
     /* 1176478 */   GIM_Try, /*On fail goto*//*Label 17129*/ GIMT_Encode4(1176561), // Rule ID 16292 //
     /* 1176483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176522 */     // MIs[0] round
     /* 1176522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176532 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1176535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176556 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176560 */     // GIR_Coverage, 16292,
     /* 1176560 */     GIR_EraseRootFromParent_Done,
     /* 1176561 */   // Label 17129: @1176561
     /* 1176561 */   GIM_Try, /*On fail goto*//*Label 17130*/ GIMT_Encode4(1176644), // Rule ID 16293 //
     /* 1176566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1176577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1176580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1176583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1176597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176605 */     // MIs[0] round
     /* 1176605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176615 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11416:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1176618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176626 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176639 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176643 */     // GIR_Coverage, 16293,
     /* 1176643 */     GIR_EraseRootFromParent_Done,
     /* 1176644 */   // Label 17130: @1176644
     /* 1176644 */   GIM_Try, /*On fail goto*//*Label 17131*/ GIMT_Encode4(1176727), // Rule ID 16296 //
     /* 1176649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176688 */     // MIs[0] round
     /* 1176688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1176701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176726 */     // GIR_Coverage, 16296,
     /* 1176726 */     GIR_EraseRootFromParent_Done,
     /* 1176727 */   // Label 17131: @1176727
     /* 1176727 */   GIM_Try, /*On fail goto*//*Label 17132*/ GIMT_Encode4(1176810), // Rule ID 16297 //
     /* 1176732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1176743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1176746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1176749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1176763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176771 */     // MIs[0] round
     /* 1176771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1176784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176792 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176809 */     // GIR_Coverage, 16297,
     /* 1176809 */     GIR_EraseRootFromParent_Done,
     /* 1176810 */   // Label 17132: @1176810
     /* 1176810 */   GIM_Try, /*On fail goto*//*Label 17133*/ GIMT_Encode4(1176893), // Rule ID 16300 //
     /* 1176815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1176835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1176838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176854 */     // MIs[0] round
     /* 1176854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1176864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1176867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176892 */     // GIR_Coverage, 16300,
     /* 1176892 */     GIR_EraseRootFromParent_Done,
     /* 1176893 */   // Label 17133: @1176893
     /* 1176893 */   GIM_Try, /*On fail goto*//*Label 17134*/ GIMT_Encode4(1176976), // Rule ID 16301 //
     /* 1176898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1176901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1176909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1176912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1176915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1176918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1176921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1176929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1176933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1176937 */     // MIs[0] round
     /* 1176937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1176940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1176947 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1176947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1176950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1176952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1176954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1176956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1176958 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1176960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1176965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1176968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1176971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1176974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1176975 */     // GIR_Coverage, 16301,
     /* 1176975 */     GIR_EraseRootFromParent_Done,
     /* 1176976 */   // Label 17134: @1176976
     /* 1176976 */   GIM_Try, /*On fail goto*//*Label 17135*/ GIMT_Encode4(1177059), // Rule ID 16304 //
     /* 1176981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1176984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1176989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1176992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1176995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1176998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177020 */     // MIs[0] round
     /* 1177020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1177033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177058 */     // GIR_Coverage, 16304,
     /* 1177058 */     GIR_EraseRootFromParent_Done,
     /* 1177059 */   // Label 17135: @1177059
     /* 1177059 */   GIM_Try, /*On fail goto*//*Label 17136*/ GIMT_Encode4(1177142), // Rule ID 16305 //
     /* 1177064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1177075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1177078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1177081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177103 */     // MIs[0] round
     /* 1177103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177113 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4),
     /* 1177116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177124 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177137 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177141 */     // GIR_Coverage, 16305,
     /* 1177141 */     GIR_EraseRootFromParent_Done,
     /* 1177142 */   // Label 17136: @1177142
     /* 1177142 */   GIM_Try, /*On fail goto*//*Label 17137*/ GIMT_Encode4(1177225), // Rule ID 16308 //
     /* 1177147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1177158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1177161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1177164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177186 */     // MIs[0] round
     /* 1177186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1177199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177220 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177224 */     // GIR_Coverage, 16308,
     /* 1177224 */     GIR_EraseRootFromParent_Done,
     /* 1177225 */   // Label 17137: @1177225
     /* 1177225 */   GIM_Try, /*On fail goto*//*Label 17138*/ GIMT_Encode4(1177308), // Rule ID 16309 //
     /* 1177230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1177241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1177244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1177247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177269 */     // MIs[0] round
     /* 1177269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1177282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177290 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177307 */     // GIR_Coverage, 16309,
     /* 1177307 */     GIR_EraseRootFromParent_Done,
     /* 1177308 */   // Label 17138: @1177308
     /* 1177308 */   GIM_Try, /*On fail goto*//*Label 17139*/ GIMT_Encode4(1177391), // Rule ID 16312 //
     /* 1177313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1177324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1177327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177352 */     // MIs[0] round
     /* 1177352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177362 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1177365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177390 */     // GIR_Coverage, 16312,
     /* 1177390 */     GIR_EraseRootFromParent_Done,
     /* 1177391 */   // Label 17139: @1177391
     /* 1177391 */   GIM_Try, /*On fail goto*//*Label 17140*/ GIMT_Encode4(1177474), // Rule ID 16313 //
     /* 1177396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1177407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1177410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1177413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177435 */     // MIs[0] round
     /* 1177435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177445 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11416:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1177448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177456 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177469 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177473 */     // GIR_Coverage, 16313,
     /* 1177473 */     GIR_EraseRootFromParent_Done,
     /* 1177474 */   // Label 17140: @1177474
     /* 1177474 */   GIM_Try, /*On fail goto*//*Label 17141*/ GIMT_Encode4(1177557), // Rule ID 16316 //
     /* 1177479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177518 */     // MIs[0] round
     /* 1177518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177528 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1177531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177552 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177556 */     // GIR_Coverage, 16316,
     /* 1177556 */     GIR_EraseRootFromParent_Done,
     /* 1177557 */   // Label 17141: @1177557
     /* 1177557 */   GIM_Try, /*On fail goto*//*Label 17142*/ GIMT_Encode4(1177640), // Rule ID 16317 //
     /* 1177562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1177573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1177576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1177579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1177593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177601 */     // MIs[0] round
     /* 1177601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177611 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1177614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177622 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177639 */     // GIR_Coverage, 16317,
     /* 1177639 */     GIR_EraseRootFromParent_Done,
     /* 1177640 */   // Label 17142: @1177640
     /* 1177640 */   GIM_Try, /*On fail goto*//*Label 17143*/ GIMT_Encode4(1177723), // Rule ID 16320 //
     /* 1177645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1177648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177684 */     // MIs[0] round
     /* 1177684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177694 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1177697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177718 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177722 */     // GIR_Coverage, 16320,
     /* 1177722 */     GIR_EraseRootFromParent_Done,
     /* 1177723 */   // Label 17143: @1177723
     /* 1177723 */   GIM_Try, /*On fail goto*//*Label 17144*/ GIMT_Encode4(1177806), // Rule ID 16321 //
     /* 1177728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1177731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1177739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1177742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1177745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1177759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1177763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177767 */     // MIs[0] round
     /* 1177767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177777 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1177780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177788 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1177798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177801 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177805 */     // GIR_Coverage, 16321,
     /* 1177805 */     GIR_EraseRootFromParent_Done,
     /* 1177806 */   // Label 17144: @1177806
     /* 1177806 */   GIM_Try, /*On fail goto*//*Label 17145*/ GIMT_Encode4(1177889), // Rule ID 16324 //
     /* 1177811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1177814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1177822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1177825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1177828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1177834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177850 */     // MIs[0] round
     /* 1177850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177860 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1177860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1177863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177888 */     // GIR_Coverage, 16324,
     /* 1177888 */     GIR_EraseRootFromParent_Done,
     /* 1177889 */   // Label 17145: @1177889
     /* 1177889 */   GIM_Try, /*On fail goto*//*Label 17146*/ GIMT_Encode4(1177972), // Rule ID 16325 //
     /* 1177894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1177897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1177905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1177908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1177911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1177914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1177917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1177929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1177933 */     // MIs[0] round
     /* 1177933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1177936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1177943 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1177943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2),
     /* 1177946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1177948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1177950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1177952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1177954 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1177956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1177961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1177964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1177967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1177970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1177971 */     // GIR_Coverage, 16325,
     /* 1177971 */     GIR_EraseRootFromParent_Done,
     /* 1177972 */   // Label 17146: @1177972
     /* 1177972 */   GIM_Try, /*On fail goto*//*Label 17147*/ GIMT_Encode4(1178055), // Rule ID 16328 //
     /* 1177977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1177980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1177985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1177988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1177991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1177994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1177997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178016 */     // MIs[0] round
     /* 1178016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178026 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1178029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178050 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178054 */     // GIR_Coverage, 16328,
     /* 1178054 */     GIR_EraseRootFromParent_Done,
     /* 1178055 */   // Label 17147: @1178055
     /* 1178055 */   GIM_Try, /*On fail goto*//*Label 17148*/ GIMT_Encode4(1178138), // Rule ID 16329 //
     /* 1178060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1178063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1178071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1178074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1178077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178099 */     // MIs[0] round
     /* 1178099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178109 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11416:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1),
     /* 1178112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178120 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178137 */     // GIR_Coverage, 16329,
     /* 1178137 */     GIR_EraseRootFromParent_Done,
     /* 1178138 */   // Label 17148: @1178138
     /* 1178138 */   GIM_Try, /*On fail goto*//*Label 17149*/ GIMT_Encode4(1178221), // Rule ID 16332 //
     /* 1178143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1178146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1178154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1178157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178182 */     // MIs[0] round
     /* 1178182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1178195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178216 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178220 */     // GIR_Coverage, 16332,
     /* 1178220 */     GIR_EraseRootFromParent_Done,
     /* 1178221 */   // Label 17149: @1178221
     /* 1178221 */   GIM_Try, /*On fail goto*//*Label 17150*/ GIMT_Encode4(1178304), // Rule ID 16333 //
     /* 1178226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1178229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1178237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1178240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1178243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1178257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178265 */     // MIs[0] round
     /* 1178265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11416:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2),
     /* 1178278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178286 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178302 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178303 */     // GIR_Coverage, 16333,
     /* 1178303 */     GIR_EraseRootFromParent_Done,
     /* 1178304 */   // Label 17150: @1178304
     /* 1178304 */   GIM_Try, /*On fail goto*//*Label 17151*/ GIMT_Encode4(1178387), // Rule ID 16336 //
     /* 1178309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1178312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1178320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1178323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1178329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178348 */     // MIs[0] round
     /* 1178348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178358 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1178361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178382 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178386 */     // GIR_Coverage, 16336,
     /* 1178386 */     GIR_EraseRootFromParent_Done,
     /* 1178387 */   // Label 17151: @1178387
     /* 1178387 */   GIM_Try, /*On fail goto*//*Label 17152*/ GIMT_Encode4(1178470), // Rule ID 16337 //
     /* 1178392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1178395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu),
     /* 1178400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1178403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1178406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1178409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1178412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1178423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1178427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1178431 */     // MIs[0] round
     /* 1178431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178441 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11416:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIPU_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4),
     /* 1178444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178452 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1178462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178469 */     // GIR_Coverage, 16337,
     /* 1178469 */     GIR_EraseRootFromParent_Done,
     /* 1178470 */   // Label 17152: @1178470
     /* 1178470 */   GIM_Try, /*On fail goto*//*Label 17153*/ GIMT_Encode4(1178553), // Rule ID 16400 //
     /* 1178475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178514 */     // MIs[0] round
     /* 1178514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1178527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178552 */     // GIR_Coverage, 16400,
     /* 1178552 */     GIR_EraseRootFromParent_Done,
     /* 1178553 */   // Label 17153: @1178553
     /* 1178553 */   GIM_Try, /*On fail goto*//*Label 17154*/ GIMT_Encode4(1178636), // Rule ID 16401 //
     /* 1178558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1178569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1178572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1178575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1178578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178597 */     // MIs[0] round
     /* 1178597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178607 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8),
     /* 1178610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178618 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178634 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178635 */     // GIR_Coverage, 16401,
     /* 1178635 */     GIR_EraseRootFromParent_Done,
     /* 1178636 */   // Label 17154: @1178636
     /* 1178636 */   GIM_Try, /*On fail goto*//*Label 17155*/ GIMT_Encode4(1178719), // Rule ID 16404 //
     /* 1178641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178680 */     // MIs[0] round
     /* 1178680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178690 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1178693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178714 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178718 */     // GIR_Coverage, 16404,
     /* 1178718 */     GIR_EraseRootFromParent_Done,
     /* 1178719 */   // Label 17155: @1178719
     /* 1178719 */   GIM_Try, /*On fail goto*//*Label 17156*/ GIMT_Encode4(1178802), // Rule ID 16405 //
     /* 1178724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1178735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1178738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1178741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1178744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178763 */     // MIs[0] round
     /* 1178763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178773 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1178776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178784 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178801 */     // GIR_Coverage, 16405,
     /* 1178801 */     GIR_EraseRootFromParent_Done,
     /* 1178802 */   // Label 17156: @1178802
     /* 1178802 */   GIM_Try, /*On fail goto*//*Label 17157*/ GIMT_Encode4(1178885), // Rule ID 16408 //
     /* 1178807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178846 */     // MIs[0] round
     /* 1178846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1178856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1178859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178884 */     // GIR_Coverage, 16408,
     /* 1178884 */     GIR_EraseRootFromParent_Done,
     /* 1178885 */   // Label 17157: @1178885
     /* 1178885 */   GIM_Try, /*On fail goto*//*Label 17158*/ GIMT_Encode4(1178968), // Rule ID 16409 //
     /* 1178890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1178893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1178901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1178904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1178907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1178910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1178913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1178929 */     // MIs[0] round
     /* 1178929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1178932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1178939 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1178939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1178942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1178944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1178946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1178948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1178950 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1178952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1178957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1178960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1178963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1178966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1178967 */     // GIR_Coverage, 16409,
     /* 1178967 */     GIR_EraseRootFromParent_Done,
     /* 1178968 */   // Label 17158: @1178968
     /* 1178968 */   GIM_Try, /*On fail goto*//*Label 17159*/ GIMT_Encode4(1179051), // Rule ID 16412 //
     /* 1178973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1178976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1178981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1178984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1178987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1178990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1178993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1178996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179012 */     // MIs[0] round
     /* 1179012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179022 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1179025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179050 */     // GIR_Coverage, 16412,
     /* 1179050 */     GIR_EraseRootFromParent_Done,
     /* 1179051 */   // Label 17159: @1179051
     /* 1179051 */   GIM_Try, /*On fail goto*//*Label 17160*/ GIMT_Encode4(1179134), // Rule ID 16413 //
     /* 1179056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1179067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1179070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1179073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1179076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179095 */     // MIs[0] round
     /* 1179095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179105 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1179108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179116 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179133 */     // GIR_Coverage, 16413,
     /* 1179133 */     GIR_EraseRootFromParent_Done,
     /* 1179134 */   // Label 17160: @1179134
     /* 1179134 */   GIM_Try, /*On fail goto*//*Label 17161*/ GIMT_Encode4(1179217), // Rule ID 16416 //
     /* 1179139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179178 */     // MIs[0] round
     /* 1179178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179188 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1179191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179212 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179216 */     // GIR_Coverage, 16416,
     /* 1179216 */     GIR_EraseRootFromParent_Done,
     /* 1179217 */   // Label 17161: @1179217
     /* 1179217 */   GIM_Try, /*On fail goto*//*Label 17162*/ GIMT_Encode4(1179300), // Rule ID 16417 //
     /* 1179222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1179233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1179236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1179239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1179242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179261 */     // MIs[0] round
     /* 1179261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1179274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179282 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179299 */     // GIR_Coverage, 16417,
     /* 1179299 */     GIR_EraseRootFromParent_Done,
     /* 1179300 */   // Label 17162: @1179300
     /* 1179300 */   GIM_Try, /*On fail goto*//*Label 17163*/ GIMT_Encode4(1179383), // Rule ID 16420 //
     /* 1179305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179344 */     // MIs[0] round
     /* 1179344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179354 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1179357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179382 */     // GIR_Coverage, 16420,
     /* 1179382 */     GIR_EraseRootFromParent_Done,
     /* 1179383 */   // Label 17163: @1179383
     /* 1179383 */   GIM_Try, /*On fail goto*//*Label 17164*/ GIMT_Encode4(1179466), // Rule ID 16421 //
     /* 1179388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1179399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1179402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1179405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1179408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1179423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1179427 */     // MIs[0] round
     /* 1179427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179437 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1179440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179448 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1179458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179461 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179465 */     // GIR_Coverage, 16421,
     /* 1179465 */     GIR_EraseRootFromParent_Done,
     /* 1179466 */   // Label 17164: @1179466
     /* 1179466 */   GIM_Try, /*On fail goto*//*Label 17165*/ GIMT_Encode4(1179549), // Rule ID 16424 //
     /* 1179471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179510 */     // MIs[0] round
     /* 1179510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179520 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1179523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179548 */     // GIR_Coverage, 16424,
     /* 1179548 */     GIR_EraseRootFromParent_Done,
     /* 1179549 */   // Label 17165: @1179549
     /* 1179549 */   GIM_Try, /*On fail goto*//*Label 17166*/ GIMT_Encode4(1179632), // Rule ID 16425 //
     /* 1179554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1179565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1179568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1179571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1179574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179593 */     // MIs[0] round
     /* 1179593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179603 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4),
     /* 1179606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179614 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179631 */     // GIR_Coverage, 16425,
     /* 1179631 */     GIR_EraseRootFromParent_Done,
     /* 1179632 */   // Label 17166: @1179632
     /* 1179632 */   GIM_Try, /*On fail goto*//*Label 17167*/ GIMT_Encode4(1179715), // Rule ID 16428 //
     /* 1179637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179676 */     // MIs[0] round
     /* 1179676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179686 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1179689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179714 */     // GIR_Coverage, 16428,
     /* 1179714 */     GIR_EraseRootFromParent_Done,
     /* 1179715 */   // Label 17167: @1179715
     /* 1179715 */   GIM_Try, /*On fail goto*//*Label 17168*/ GIMT_Encode4(1179798), // Rule ID 16429 //
     /* 1179720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1179731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1179734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1179737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1179740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179759 */     // MIs[0] round
     /* 1179759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179769 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1179772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179780 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179797 */     // GIR_Coverage, 16429,
     /* 1179797 */     GIR_EraseRootFromParent_Done,
     /* 1179798 */   // Label 17168: @1179798
     /* 1179798 */   GIM_Try, /*On fail goto*//*Label 17169*/ GIMT_Encode4(1179881), // Rule ID 16432 //
     /* 1179803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179842 */     // MIs[0] round
     /* 1179842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1179852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1179855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179876 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179880 */     // GIR_Coverage, 16432,
     /* 1179880 */     GIR_EraseRootFromParent_Done,
     /* 1179881 */   // Label 17169: @1179881
     /* 1179881 */   GIM_Try, /*On fail goto*//*Label 17170*/ GIMT_Encode4(1179964), // Rule ID 16433 //
     /* 1179886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1179889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1179897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1179900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1179903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1179906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1179909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1179925 */     // MIs[0] round
     /* 1179925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1179928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1179935 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1179935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1179938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1179940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1179942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1179944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1179946 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1179948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1179953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1179956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1179959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1179962 */     GIR_RootConstrainSelectedInstOperands,
     /* 1179963 */     // GIR_Coverage, 16433,
     /* 1179963 */     GIR_EraseRootFromParent_Done,
     /* 1179964 */   // Label 17170: @1179964
     /* 1179964 */   GIM_Try, /*On fail goto*//*Label 17171*/ GIMT_Encode4(1180047), // Rule ID 16436 //
     /* 1179969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1179972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1179977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1179980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1179983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1179986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1179989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1179992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1179996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180008 */     // MIs[0] round
     /* 1180008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1180021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180046 */     // GIR_Coverage, 16436,
     /* 1180046 */     GIR_EraseRootFromParent_Done,
     /* 1180047 */   // Label 17171: @1180047
     /* 1180047 */   GIM_Try, /*On fail goto*//*Label 17172*/ GIMT_Encode4(1180130), // Rule ID 16437 //
     /* 1180052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1180063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1180066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1180069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1180072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180091 */     // MIs[0] round
     /* 1180091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1180104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180112 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180129 */     // GIR_Coverage, 16437,
     /* 1180129 */     GIR_EraseRootFromParent_Done,
     /* 1180130 */   // Label 17172: @1180130
     /* 1180130 */   GIM_Try, /*On fail goto*//*Label 17173*/ GIMT_Encode4(1180213), // Rule ID 16440 //
     /* 1180135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180174 */     // MIs[0] round
     /* 1180174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1180187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180212 */     // GIR_Coverage, 16440,
     /* 1180212 */     GIR_EraseRootFromParent_Done,
     /* 1180213 */   // Label 17173: @1180213
     /* 1180213 */   GIM_Try, /*On fail goto*//*Label 17174*/ GIMT_Encode4(1180296), // Rule ID 16441 //
     /* 1180218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1180221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1180229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1180232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1180235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1180238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180257 */     // MIs[0] round
     /* 1180257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180267 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1180270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180278 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1180288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180295 */     // GIR_Coverage, 16441,
     /* 1180295 */     GIR_EraseRootFromParent_Done,
     /* 1180296 */   // Label 17174: @1180296
     /* 1180296 */   GIM_Try, /*On fail goto*//*Label 17175*/ GIMT_Encode4(1180379), // Rule ID 16444 //
     /* 1180301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180340 */     // MIs[0] round
     /* 1180340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1180353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180374 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180378 */     // GIR_Coverage, 16444,
     /* 1180378 */     GIR_EraseRootFromParent_Done,
     /* 1180379 */   // Label 17175: @1180379
     /* 1180379 */   GIM_Try, /*On fail goto*//*Label 17176*/ GIMT_Encode4(1180462), // Rule ID 16445 //
     /* 1180384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1180395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1180398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1180401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1180404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180423 */     // MIs[0] round
     /* 1180423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2),
     /* 1180436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180444 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180457 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180461 */     // GIR_Coverage, 16445,
     /* 1180461 */     GIR_EraseRootFromParent_Done,
     /* 1180462 */   // Label 17176: @1180462
     /* 1180462 */   GIM_Try, /*On fail goto*//*Label 17177*/ GIMT_Encode4(1180545), // Rule ID 16448 //
     /* 1180467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180506 */     // MIs[0] round
     /* 1180506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1180519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180540 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180544 */     // GIR_Coverage, 16448,
     /* 1180544 */     GIR_EraseRootFromParent_Done,
     /* 1180545 */   // Label 17177: @1180545
     /* 1180545 */   GIM_Try, /*On fail goto*//*Label 17178*/ GIMT_Encode4(1180628), // Rule ID 16449 //
     /* 1180550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1180561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1180564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1180567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1180570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180589 */     // MIs[0] round
     /* 1180589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180599 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1),
     /* 1180602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180610 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180627 */     // GIR_Coverage, 16449,
     /* 1180627 */     GIR_EraseRootFromParent_Done,
     /* 1180628 */   // Label 17178: @1180628
     /* 1180628 */   GIM_Try, /*On fail goto*//*Label 17179*/ GIMT_Encode4(1180711), // Rule ID 16452 //
     /* 1180633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180672 */     // MIs[0] round
     /* 1180672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180682 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1180685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180710 */     // GIR_Coverage, 16452,
     /* 1180710 */     GIR_EraseRootFromParent_Done,
     /* 1180711 */   // Label 17179: @1180711
     /* 1180711 */   GIM_Try, /*On fail goto*//*Label 17180*/ GIMT_Encode4(1180794), // Rule ID 16453 //
     /* 1180716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1180727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1180730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1180733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1180736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1180755 */     // MIs[0] round
     /* 1180755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2),
     /* 1180768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180776 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180793 */     // GIR_Coverage, 16453,
     /* 1180793 */     GIR_EraseRootFromParent_Done,
     /* 1180794 */   // Label 17180: @1180794
     /* 1180794 */   GIM_Try, /*On fail goto*//*Label 17181*/ GIMT_Encode4(1180877), // Rule ID 16456 //
     /* 1180799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1180802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180838 */     // MIs[0] round
     /* 1180838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1180848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1180851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180872 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180876 */     // GIR_Coverage, 16456,
     /* 1180876 */     GIR_EraseRootFromParent_Done,
     /* 1180877 */   // Label 17181: @1180877
     /* 1180877 */   GIM_Try, /*On fail goto*//*Label 17182*/ GIMT_Encode4(1180960), // Rule ID 16457 //
     /* 1180882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1180885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1180893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1180896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1180899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1180902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1180905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1180917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1180921 */     // MIs[0] round
     /* 1180921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1180924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1180931 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WV_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1180931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4),
     /* 1180934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1180936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1180938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1180940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1180942 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1180944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1180949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1180952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1180955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1180958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1180959 */     // GIR_Coverage, 16457,
     /* 1180959 */     GIR_EraseRootFromParent_Done,
     /* 1180960 */   // Label 17182: @1180960
     /* 1180960 */   GIM_Try, /*On fail goto*//*Label 17183*/ GIMT_Encode4(1181043), // Rule ID 16460 //
     /* 1180965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1180968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1180973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1180976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1180979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1180982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1180985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1180988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1180996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181004 */     // MIs[0] round
     /* 1181004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181014 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1181017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181038 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181042 */     // GIR_Coverage, 16460,
     /* 1181042 */     GIR_EraseRootFromParent_Done,
     /* 1181043 */   // Label 17183: @1181043
     /* 1181043 */   GIM_Try, /*On fail goto*//*Label 17184*/ GIMT_Encode4(1181126), // Rule ID 16461 //
     /* 1181048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1181059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1181062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1181065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181087 */     // MIs[0] round
     /* 1181087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181097 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8),
     /* 1181100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181108 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181121 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181125 */     // GIR_Coverage, 16461,
     /* 1181125 */     GIR_EraseRootFromParent_Done,
     /* 1181126 */   // Label 17184: @1181126
     /* 1181126 */   GIM_Try, /*On fail goto*//*Label 17185*/ GIMT_Encode4(1181209), // Rule ID 16464 //
     /* 1181131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181170 */     // MIs[0] round
     /* 1181170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181180 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1181183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181208 */     // GIR_Coverage, 16464,
     /* 1181208 */     GIR_EraseRootFromParent_Done,
     /* 1181209 */   // Label 17185: @1181209
     /* 1181209 */   GIM_Try, /*On fail goto*//*Label 17186*/ GIMT_Encode4(1181292), // Rule ID 16465 //
     /* 1181214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1181225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1181228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1181231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181253 */     // MIs[0] round
     /* 1181253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181263 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1181266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181274 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181291 */     // GIR_Coverage, 16465,
     /* 1181291 */     GIR_EraseRootFromParent_Done,
     /* 1181292 */   // Label 17186: @1181292
     /* 1181292 */   GIM_Try, /*On fail goto*//*Label 17187*/ GIMT_Encode4(1181375), // Rule ID 16468 //
     /* 1181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181336 */     // MIs[0] round
     /* 1181336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181346 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1181349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181374 */     // GIR_Coverage, 16468,
     /* 1181374 */     GIR_EraseRootFromParent_Done,
     /* 1181375 */   // Label 17187: @1181375
     /* 1181375 */   GIM_Try, /*On fail goto*//*Label 17188*/ GIMT_Encode4(1181458), // Rule ID 16469 //
     /* 1181380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1181391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1181394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1181397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181419 */     // MIs[0] round
     /* 1181419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181429 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1181432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181440 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181453 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181457 */     // GIR_Coverage, 16469,
     /* 1181457 */     GIR_EraseRootFromParent_Done,
     /* 1181458 */   // Label 17188: @1181458
     /* 1181458 */   GIM_Try, /*On fail goto*//*Label 17189*/ GIMT_Encode4(1181541), // Rule ID 16472 //
     /* 1181463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181502 */     // MIs[0] round
     /* 1181502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181512 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1181515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181536 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181540 */     // GIR_Coverage, 16472,
     /* 1181540 */     GIR_EraseRootFromParent_Done,
     /* 1181541 */   // Label 17189: @1181541
     /* 1181541 */   GIM_Try, /*On fail goto*//*Label 17190*/ GIMT_Encode4(1181624), // Rule ID 16473 //
     /* 1181546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1181557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1181560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1181563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181585 */     // MIs[0] round
     /* 1181585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11414:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1181598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181606 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181619 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181623 */     // GIR_Coverage, 16473,
     /* 1181623 */     GIR_EraseRootFromParent_Done,
     /* 1181624 */   // Label 17190: @1181624
     /* 1181624 */   GIM_Try, /*On fail goto*//*Label 17191*/ GIMT_Encode4(1181707), // Rule ID 16476 //
     /* 1181629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181668 */     // MIs[0] round
     /* 1181668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1181681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181702 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181706 */     // GIR_Coverage, 16476,
     /* 1181706 */     GIR_EraseRootFromParent_Done,
     /* 1181707 */   // Label 17191: @1181707
     /* 1181707 */   GIM_Try, /*On fail goto*//*Label 17192*/ GIMT_Encode4(1181790), // Rule ID 16477 //
     /* 1181712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1181723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1181726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1181729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1181743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181751 */     // MIs[0] round
     /* 1181751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1181764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181772 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181789 */     // GIR_Coverage, 16477,
     /* 1181789 */     GIR_EraseRootFromParent_Done,
     /* 1181790 */   // Label 17192: @1181790
     /* 1181790 */   GIM_Try, /*On fail goto*//*Label 17193*/ GIMT_Encode4(1181873), // Rule ID 16480 //
     /* 1181795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181834 */     // MIs[0] round
     /* 1181834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181844 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1181844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1181847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181872 */     // GIR_Coverage, 16480,
     /* 1181872 */     GIR_EraseRootFromParent_Done,
     /* 1181873 */   // Label 17193: @1181873
     /* 1181873 */   GIM_Try, /*On fail goto*//*Label 17194*/ GIMT_Encode4(1181956), // Rule ID 16481 //
     /* 1181878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1181881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1181889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1181892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1181895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1181898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1181901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1181909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1181913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1181917 */     // MIs[0] round
     /* 1181917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1181920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1181927 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1181927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1181930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1181932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1181934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1181936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1181938 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1181940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1181945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1181948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1181951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1181954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1181955 */     // GIR_Coverage, 16481,
     /* 1181955 */     GIR_EraseRootFromParent_Done,
     /* 1181956 */   // Label 17194: @1181956
     /* 1181956 */   GIM_Try, /*On fail goto*//*Label 17195*/ GIMT_Encode4(1182039), // Rule ID 16484 //
     /* 1181961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1181964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1181969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1181972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1181975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1181978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1181981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1181984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1181996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182000 */     // MIs[0] round
     /* 1182000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182010 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1182013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182034 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182038 */     // GIR_Coverage, 16484,
     /* 1182038 */     GIR_EraseRootFromParent_Done,
     /* 1182039 */   // Label 17195: @1182039
     /* 1182039 */   GIM_Try, /*On fail goto*//*Label 17196*/ GIMT_Encode4(1182122), // Rule ID 16485 //
     /* 1182044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1182055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1182058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1182061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182083 */     // MIs[0] round
     /* 1182083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182093 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4),
     /* 1182096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182104 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182121 */     // GIR_Coverage, 16485,
     /* 1182121 */     GIR_EraseRootFromParent_Done,
     /* 1182122 */   // Label 17196: @1182122
     /* 1182122 */   GIM_Try, /*On fail goto*//*Label 17197*/ GIMT_Encode4(1182205), // Rule ID 16488 //
     /* 1182127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182166 */     // MIs[0] round
     /* 1182166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182176 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1182179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182204 */     // GIR_Coverage, 16488,
     /* 1182204 */     GIR_EraseRootFromParent_Done,
     /* 1182205 */   // Label 17197: @1182205
     /* 1182205 */   GIM_Try, /*On fail goto*//*Label 17198*/ GIMT_Encode4(1182288), // Rule ID 16489 //
     /* 1182210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1182221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1182224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1182227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182249 */     // MIs[0] round
     /* 1182249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182259 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1182262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182270 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182287 */     // GIR_Coverage, 16489,
     /* 1182287 */     GIR_EraseRootFromParent_Done,
     /* 1182288 */   // Label 17198: @1182288
     /* 1182288 */   GIM_Try, /*On fail goto*//*Label 17199*/ GIMT_Encode4(1182371), // Rule ID 16492 //
     /* 1182293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182332 */     // MIs[0] round
     /* 1182332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1182345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182370 */     // GIR_Coverage, 16492,
     /* 1182370 */     GIR_EraseRootFromParent_Done,
     /* 1182371 */   // Label 17199: @1182371
     /* 1182371 */   GIM_Try, /*On fail goto*//*Label 17200*/ GIMT_Encode4(1182454), // Rule ID 16493 //
     /* 1182376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1182387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1182390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1182393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182415 */     // MIs[0] round
     /* 1182415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182425 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11414:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1182428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182436 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182453 */     // GIR_Coverage, 16493,
     /* 1182453 */     GIR_EraseRootFromParent_Done,
     /* 1182454 */   // Label 17200: @1182454
     /* 1182454 */   GIM_Try, /*On fail goto*//*Label 17201*/ GIMT_Encode4(1182537), // Rule ID 16496 //
     /* 1182459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182498 */     // MIs[0] round
     /* 1182498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1182511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182536 */     // GIR_Coverage, 16496,
     /* 1182536 */     GIR_EraseRootFromParent_Done,
     /* 1182537 */   // Label 17201: @1182537
     /* 1182537 */   GIM_Try, /*On fail goto*//*Label 17202*/ GIMT_Encode4(1182620), // Rule ID 16497 //
     /* 1182542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1182553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1182556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1182559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182581 */     // MIs[0] round
     /* 1182581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1182594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182602 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182618 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182619 */     // GIR_Coverage, 16497,
     /* 1182619 */     GIR_EraseRootFromParent_Done,
     /* 1182620 */   // Label 17202: @1182620
     /* 1182620 */   GIM_Try, /*On fail goto*//*Label 17203*/ GIMT_Encode4(1182703), // Rule ID 16500 //
     /* 1182625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1182628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182664 */     // MIs[0] round
     /* 1182664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182674 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1182677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182698 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182702 */     // GIR_Coverage, 16500,
     /* 1182702 */     GIR_EraseRootFromParent_Done,
     /* 1182703 */   // Label 17203: @1182703
     /* 1182703 */   GIM_Try, /*On fail goto*//*Label 17204*/ GIMT_Encode4(1182786), // Rule ID 16501 //
     /* 1182708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1182711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1182719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1182722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1182725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1182739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1182743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182747 */     // MIs[0] round
     /* 1182747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182757 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1182760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182768 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1182778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182785 */     // GIR_Coverage, 16501,
     /* 1182785 */     GIR_EraseRootFromParent_Done,
     /* 1182786 */   // Label 17204: @1182786
     /* 1182786 */   GIM_Try, /*On fail goto*//*Label 17205*/ GIMT_Encode4(1182869), // Rule ID 16504 //
     /* 1182791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182830 */     // MIs[0] round
     /* 1182830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1182840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1182843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182868 */     // GIR_Coverage, 16504,
     /* 1182868 */     GIR_EraseRootFromParent_Done,
     /* 1182869 */   // Label 17205: @1182869
     /* 1182869 */   GIM_Try, /*On fail goto*//*Label 17206*/ GIMT_Encode4(1182952), // Rule ID 16505 //
     /* 1182874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1182877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1182885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1182888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1182891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1182894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1182897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182913 */     // MIs[0] round
     /* 1182913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1182923 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1182923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2),
     /* 1182926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1182928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1182930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1182932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1182934 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1182936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1182941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1182944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1182947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1182950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1182951 */     // GIR_Coverage, 16505,
     /* 1182951 */     GIR_EraseRootFromParent_Done,
     /* 1182952 */   // Label 17206: @1182952
     /* 1182952 */   GIM_Try, /*On fail goto*//*Label 17207*/ GIMT_Encode4(1183035), // Rule ID 16508 //
     /* 1182957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1182960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1182965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1182968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1182971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1182974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1182977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1182980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1182988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1182992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1182996 */     // MIs[0] round
     /* 1182996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1182999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183006 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1183009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183034 */     // GIR_Coverage, 16508,
     /* 1183034 */     GIR_EraseRootFromParent_Done,
     /* 1183035 */   // Label 17207: @1183035
     /* 1183035 */   GIM_Try, /*On fail goto*//*Label 17208*/ GIMT_Encode4(1183118), // Rule ID 16509 //
     /* 1183040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1183051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1183054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1183057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183079 */     // MIs[0] round
     /* 1183079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183089 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11414:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1),
     /* 1183092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183100 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183117 */     // GIR_Coverage, 16509,
     /* 1183117 */     GIR_EraseRootFromParent_Done,
     /* 1183118 */   // Label 17208: @1183118
     /* 1183118 */   GIM_Try, /*On fail goto*//*Label 17209*/ GIMT_Encode4(1183201), // Rule ID 16512 //
     /* 1183123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183162 */     // MIs[0] round
     /* 1183162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1183175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183196 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183200 */     // GIR_Coverage, 16512,
     /* 1183200 */     GIR_EraseRootFromParent_Done,
     /* 1183201 */   // Label 17209: @1183201
     /* 1183201 */   GIM_Try, /*On fail goto*//*Label 17210*/ GIMT_Encode4(1183284), // Rule ID 16513 //
     /* 1183206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1183217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1183220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1183223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1183237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183245 */     // MIs[0] round
     /* 1183245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183255 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11414:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2),
     /* 1183258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183266 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183283 */     // GIR_Coverage, 16513,
     /* 1183283 */     GIR_EraseRootFromParent_Done,
     /* 1183284 */   // Label 17210: @1183284
     /* 1183284 */   GIM_Try, /*On fail goto*//*Label 17211*/ GIMT_Encode4(1183367), // Rule ID 16516 //
     /* 1183289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1183292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1183309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183328 */     // MIs[0] round
     /* 1183328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1183341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183366 */     // GIR_Coverage, 16516,
     /* 1183366 */     GIR_EraseRootFromParent_Done,
     /* 1183367 */   // Label 17211: @1183367
     /* 1183367 */   GIM_Try, /*On fail goto*//*Label 17212*/ GIMT_Encode4(1183450), // Rule ID 16517 //
     /* 1183372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1183375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip),
     /* 1183380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1183383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1183386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1183389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1183392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1183403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1183407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1183411 */     // MIs[0] round
     /* 1183411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183421 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11414:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVNCLIP_WX_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4),
     /* 1183424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183432 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183445 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1183448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183449 */     // GIR_Coverage, 16517,
     /* 1183449 */     GIR_EraseRootFromParent_Done,
     /* 1183450 */   // Label 17212: @1183450
     /* 1183450 */   GIM_Try, /*On fail goto*//*Label 17213*/ GIMT_Encode4(1183530), // Rule ID 16580 //
     /* 1183455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1183458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183494 */     // MIs[0] round
     /* 1183494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183504 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1183507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183529 */     // GIR_Coverage, 16580,
     /* 1183529 */     GIR_EraseRootFromParent_Done,
     /* 1183530 */   // Label 17213: @1183530
     /* 1183530 */   GIM_Try, /*On fail goto*//*Label 17214*/ GIMT_Encode4(1183610), // Rule ID 16581 //
     /* 1183535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1183538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1183546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1183549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1183552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1183555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183574 */     // MIs[0] round
     /* 1183574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183584 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 1183587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183609 */     // GIR_Coverage, 16581,
     /* 1183609 */     GIR_EraseRootFromParent_Done,
     /* 1183610 */   // Label 17214: @1183610
     /* 1183610 */   GIM_Try, /*On fail goto*//*Label 17215*/ GIMT_Encode4(1183690), // Rule ID 16584 //
     /* 1183615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1183618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1183626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1183629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1183635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183654 */     // MIs[0] round
     /* 1183654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1183667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183689 */     // GIR_Coverage, 16584,
     /* 1183689 */     GIR_EraseRootFromParent_Done,
     /* 1183690 */   // Label 17215: @1183690
     /* 1183690 */   GIM_Try, /*On fail goto*//*Label 17216*/ GIMT_Encode4(1183770), // Rule ID 16585 //
     /* 1183695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1183698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1183706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1183709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1183712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1183715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183734 */     // MIs[0] round
     /* 1183734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183744 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 1183747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1183765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183769 */     // GIR_Coverage, 16585,
     /* 1183769 */     GIR_EraseRootFromParent_Done,
     /* 1183770 */   // Label 17216: @1183770
     /* 1183770 */   GIM_Try, /*On fail goto*//*Label 17217*/ GIMT_Encode4(1183850), // Rule ID 16588 //
     /* 1183775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1183778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1183795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183814 */     // MIs[0] round
     /* 1183814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1183827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183849 */     // GIR_Coverage, 16588,
     /* 1183849 */     GIR_EraseRootFromParent_Done,
     /* 1183850 */   // Label 17217: @1183850
     /* 1183850 */   GIM_Try, /*On fail goto*//*Label 17218*/ GIMT_Encode4(1183930), // Rule ID 16589 //
     /* 1183855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1183858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1183866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1183869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1183872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1183875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1183878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183894 */     // MIs[0] round
     /* 1183894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183904 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1183904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 1183907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1183922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1183925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1183928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1183929 */     // GIR_Coverage, 16589,
     /* 1183929 */     GIR_EraseRootFromParent_Done,
     /* 1183930 */   // Label 17218: @1183930
     /* 1183930 */   GIM_Try, /*On fail goto*//*Label 17219*/ GIMT_Encode4(1184010), // Rule ID 16592 //
     /* 1183935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1183938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1183943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1183946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1183949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1183952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1183955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1183958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1183974 */     // MIs[0] round
     /* 1183974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1183977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1183984 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1183984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1183987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1183989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1183991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1183993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1183995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1183997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184009 */     // GIR_Coverage, 16592,
     /* 1184009 */     GIR_EraseRootFromParent_Done,
     /* 1184010 */   // Label 17219: @1184010
     /* 1184010 */   GIM_Try, /*On fail goto*//*Label 17220*/ GIMT_Encode4(1184090), // Rule ID 16593 //
     /* 1184015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1184018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1184026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1184029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1184032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1184035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184054 */     // MIs[0] round
     /* 1184054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184064 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 1184067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184089 */     // GIR_Coverage, 16593,
     /* 1184089 */     GIR_EraseRootFromParent_Done,
     /* 1184090 */   // Label 17220: @1184090
     /* 1184090 */   GIM_Try, /*On fail goto*//*Label 17221*/ GIMT_Encode4(1184170), // Rule ID 16596 //
     /* 1184095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1184098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184134 */     // MIs[0] round
     /* 1184134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1184147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184169 */     // GIR_Coverage, 16596,
     /* 1184169 */     GIR_EraseRootFromParent_Done,
     /* 1184170 */   // Label 17221: @1184170
     /* 1184170 */   GIM_Try, /*On fail goto*//*Label 17222*/ GIMT_Encode4(1184250), // Rule ID 16597 //
     /* 1184175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1184178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1184186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1184189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1184192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1184195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184214 */     // MIs[0] round
     /* 1184214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 1184227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184249 */     // GIR_Coverage, 16597,
     /* 1184249 */     GIR_EraseRootFromParent_Done,
     /* 1184250 */   // Label 17222: @1184250
     /* 1184250 */   GIM_Try, /*On fail goto*//*Label 17223*/ GIMT_Encode4(1184330), // Rule ID 16600 //
     /* 1184255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1184258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1184266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1184269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1184275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184294 */     // MIs[0] round
     /* 1184294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184304 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1184307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1184325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184329 */     // GIR_Coverage, 16600,
     /* 1184329 */     GIR_EraseRootFromParent_Done,
     /* 1184330 */   // Label 17223: @1184330
     /* 1184330 */   GIM_Try, /*On fail goto*//*Label 17224*/ GIMT_Encode4(1184410), // Rule ID 16601 //
     /* 1184335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1184338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1184346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1184349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1184352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1184355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1184374 */     // MIs[0] round
     /* 1184374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184384 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 1184387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1184405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184409 */     // GIR_Coverage, 16601,
     /* 1184409 */     GIR_EraseRootFromParent_Done,
     /* 1184410 */   // Label 17224: @1184410
     /* 1184410 */   GIM_Try, /*On fail goto*//*Label 17225*/ GIMT_Encode4(1184490), // Rule ID 16604 //
     /* 1184415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1184418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184454 */     // MIs[0] round
     /* 1184454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184464 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1184467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184489 */     // GIR_Coverage, 16604,
     /* 1184489 */     GIR_EraseRootFromParent_Done,
     /* 1184490 */   // Label 17225: @1184490
     /* 1184490 */   GIM_Try, /*On fail goto*//*Label 17226*/ GIMT_Encode4(1184570), // Rule ID 16605 //
     /* 1184495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1184498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1184506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1184509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1184512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1184515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184534 */     // MIs[0] round
     /* 1184534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184544 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 1184547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184569 */     // GIR_Coverage, 16605,
     /* 1184569 */     GIR_EraseRootFromParent_Done,
     /* 1184570 */   // Label 17226: @1184570
     /* 1184570 */   GIM_Try, /*On fail goto*//*Label 17227*/ GIMT_Encode4(1184650), // Rule ID 16608 //
     /* 1184575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1184578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184614 */     // MIs[0] round
     /* 1184614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184624 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1184627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184649 */     // GIR_Coverage, 16608,
     /* 1184649 */     GIR_EraseRootFromParent_Done,
     /* 1184650 */   // Label 17227: @1184650
     /* 1184650 */   GIM_Try, /*On fail goto*//*Label 17228*/ GIMT_Encode4(1184730), // Rule ID 16609 //
     /* 1184655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1184658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1184666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1184669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1184672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1184675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1184694 */     // MIs[0] round
     /* 1184694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184704 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 1184707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184729 */     // GIR_Coverage, 16609,
     /* 1184729 */     GIR_EraseRootFromParent_Done,
     /* 1184730 */   // Label 17228: @1184730
     /* 1184730 */   GIM_Try, /*On fail goto*//*Label 17229*/ GIMT_Encode4(1184810), // Rule ID 16612 //
     /* 1184735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1184738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1184746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1184749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1184755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184774 */     // MIs[0] round
     /* 1184774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184784 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1184787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184809 */     // GIR_Coverage, 16612,
     /* 1184809 */     GIR_EraseRootFromParent_Done,
     /* 1184810 */   // Label 17229: @1184810
     /* 1184810 */   GIM_Try, /*On fail goto*//*Label 17230*/ GIMT_Encode4(1184890), // Rule ID 16613 //
     /* 1184815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1184818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1184826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1184829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1184832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1184835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1184854 */     // MIs[0] round
     /* 1184854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184864 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1184864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 1184867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1184885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184889 */     // GIR_Coverage, 16613,
     /* 1184889 */     GIR_EraseRootFromParent_Done,
     /* 1184890 */   // Label 17230: @1184890
     /* 1184890 */   GIM_Try, /*On fail goto*//*Label 17231*/ GIMT_Encode4(1184970), // Rule ID 16616 //
     /* 1184895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1184898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1184906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1184909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1184918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1184934 */     // MIs[0] round
     /* 1184934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1184937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1184944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1184944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1184947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1184949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1184951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1184953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1184955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1184957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1184962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1184965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1184968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1184969 */     // GIR_Coverage, 16616,
     /* 1184969 */     GIR_EraseRootFromParent_Done,
     /* 1184970 */   // Label 17231: @1184970
     /* 1184970 */   GIM_Try, /*On fail goto*//*Label 17232*/ GIMT_Encode4(1185050), // Rule ID 16617 //
     /* 1184975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1184978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1184983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1184986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1184989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1184992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1184995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1184998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185014 */     // MIs[0] round
     /* 1185014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185024 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 1185027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185049 */     // GIR_Coverage, 16617,
     /* 1185049 */     GIR_EraseRootFromParent_Done,
     /* 1185050 */   // Label 17232: @1185050
     /* 1185050 */   GIM_Try, /*On fail goto*//*Label 17233*/ GIMT_Encode4(1185130), // Rule ID 16620 //
     /* 1185055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1185058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185094 */     // MIs[0] round
     /* 1185094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185104 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1185107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185129 */     // GIR_Coverage, 16620,
     /* 1185129 */     GIR_EraseRootFromParent_Done,
     /* 1185130 */   // Label 17233: @1185130
     /* 1185130 */   GIM_Try, /*On fail goto*//*Label 17234*/ GIMT_Encode4(1185210), // Rule ID 16621 //
     /* 1185135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1185138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1185146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1185149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1185152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1185155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185174 */     // MIs[0] round
     /* 1185174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185184 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 1185187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185209 */     // GIR_Coverage, 16621,
     /* 1185209 */     GIR_EraseRootFromParent_Done,
     /* 1185210 */   // Label 17234: @1185210
     /* 1185210 */   GIM_Try, /*On fail goto*//*Label 17235*/ GIMT_Encode4(1185290), // Rule ID 16624 //
     /* 1185215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1185218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1185226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1185229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1185235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185254 */     // MIs[0] round
     /* 1185254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185264 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1185267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185289 */     // GIR_Coverage, 16624,
     /* 1185289 */     GIR_EraseRootFromParent_Done,
     /* 1185290 */   // Label 17235: @1185290
     /* 1185290 */   GIM_Try, /*On fail goto*//*Label 17236*/ GIMT_Encode4(1185370), // Rule ID 16625 //
     /* 1185295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1185298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1185306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1185309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1185312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1185315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185334 */     // MIs[0] round
     /* 1185334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185344 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 1185347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1185365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185369 */     // GIR_Coverage, 16625,
     /* 1185369 */     GIR_EraseRootFromParent_Done,
     /* 1185370 */   // Label 17236: @1185370
     /* 1185370 */   GIM_Try, /*On fail goto*//*Label 17237*/ GIMT_Encode4(1185450), // Rule ID 16628 //
     /* 1185375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1185378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1185386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1185389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1185395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185414 */     // MIs[0] round
     /* 1185414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1185427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185449 */     // GIR_Coverage, 16628,
     /* 1185449 */     GIR_EraseRootFromParent_Done,
     /* 1185450 */   // Label 17237: @1185450
     /* 1185450 */   GIM_Try, /*On fail goto*//*Label 17238*/ GIMT_Encode4(1185530), // Rule ID 16629 //
     /* 1185455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1185458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1185466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1185469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1185472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1185475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1185494 */     // MIs[0] round
     /* 1185494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 1185507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185529 */     // GIR_Coverage, 16629,
     /* 1185529 */     GIR_EraseRootFromParent_Done,
     /* 1185530 */   // Label 17238: @1185530
     /* 1185530 */   GIM_Try, /*On fail goto*//*Label 17239*/ GIMT_Encode4(1185610), // Rule ID 16632 //
     /* 1185535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1185538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1185546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1185549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1185555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185574 */     // MIs[0] round
     /* 1185574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185584 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1185587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185609 */     // GIR_Coverage, 16632,
     /* 1185609 */     GIR_EraseRootFromParent_Done,
     /* 1185610 */   // Label 17239: @1185610
     /* 1185610 */   GIM_Try, /*On fail goto*//*Label 17240*/ GIMT_Encode4(1185690), // Rule ID 16633 //
     /* 1185615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1185618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1185626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1185629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1185632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1185635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1185654 */     // MIs[0] round
     /* 1185654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185664 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 1185667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185689 */     // GIR_Coverage, 16633,
     /* 1185689 */     GIR_EraseRootFromParent_Done,
     /* 1185690 */   // Label 17240: @1185690
     /* 1185690 */   GIM_Try, /*On fail goto*//*Label 17241*/ GIMT_Encode4(1185770), // Rule ID 16636 //
     /* 1185695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1185698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1185706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1185709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1185715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185734 */     // MIs[0] round
     /* 1185734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185744 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1185747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185769 */     // GIR_Coverage, 16636,
     /* 1185769 */     GIR_EraseRootFromParent_Done,
     /* 1185770 */   // Label 17241: @1185770
     /* 1185770 */   GIM_Try, /*On fail goto*//*Label 17242*/ GIMT_Encode4(1185850), // Rule ID 16637 //
     /* 1185775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1185778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1185786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1185789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1185792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1185795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1185814 */     // MIs[0] round
     /* 1185814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185824 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 1185827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1185845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185849 */     // GIR_Coverage, 16637,
     /* 1185849 */     GIR_EraseRootFromParent_Done,
     /* 1185850 */   // Label 17242: @1185850
     /* 1185850 */   GIM_Try, /*On fail goto*//*Label 17243*/ GIMT_Encode4(1185930), // Rule ID 16640 //
     /* 1185855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1185858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1185866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1185869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1185875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1185878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1185894 */     // MIs[0] round
     /* 1185894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185904 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1185904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1185907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1185922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1185925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1185928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1185929 */     // GIR_Coverage, 16640,
     /* 1185929 */     GIR_EraseRootFromParent_Done,
     /* 1185930 */   // Label 17243: @1185930
     /* 1185930 */   GIM_Try, /*On fail goto*//*Label 17244*/ GIMT_Encode4(1186010), // Rule ID 16641 //
     /* 1185935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1185938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1185943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1185946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1185949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1185952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1185955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1185958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1185970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1185974 */     // MIs[0] round
     /* 1185974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1185977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1185984 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1185984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16),
     /* 1185987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1185989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1185991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1185993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1185995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1185997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186009 */     // GIR_Coverage, 16641,
     /* 1186009 */     GIR_EraseRootFromParent_Done,
     /* 1186010 */   // Label 17244: @1186010
     /* 1186010 */   GIM_Try, /*On fail goto*//*Label 17245*/ GIMT_Encode4(1186090), // Rule ID 16644 //
     /* 1186015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1186018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186054 */     // MIs[0] round
     /* 1186054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186064 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1186067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186089 */     // GIR_Coverage, 16644,
     /* 1186089 */     GIR_EraseRootFromParent_Done,
     /* 1186090 */   // Label 17245: @1186090
     /* 1186090 */   GIM_Try, /*On fail goto*//*Label 17246*/ GIMT_Encode4(1186170), // Rule ID 16645 //
     /* 1186095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1186098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1186106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1186109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1186112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186134 */     // MIs[0] round
     /* 1186134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186144 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16),
     /* 1186147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186169 */     // GIR_Coverage, 16645,
     /* 1186169 */     GIR_EraseRootFromParent_Done,
     /* 1186170 */   // Label 17246: @1186170
     /* 1186170 */   GIM_Try, /*On fail goto*//*Label 17247*/ GIMT_Encode4(1186250), // Rule ID 16648 //
     /* 1186175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1186178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1186186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1186189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1186214 */     // MIs[0] round
     /* 1186214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186224 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1186227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186249 */     // GIR_Coverage, 16648,
     /* 1186249 */     GIR_EraseRootFromParent_Done,
     /* 1186250 */   // Label 17247: @1186250
     /* 1186250 */   GIM_Try, /*On fail goto*//*Label 17248*/ GIMT_Encode4(1186330), // Rule ID 16649 //
     /* 1186255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1186258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1186266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1186269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1186272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1186294 */     // MIs[0] round
     /* 1186294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32),
     /* 1186307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186329 */     // GIR_Coverage, 16649,
     /* 1186329 */     GIR_EraseRootFromParent_Done,
     /* 1186330 */   // Label 17248: @1186330
     /* 1186330 */   GIM_Try, /*On fail goto*//*Label 17249*/ GIMT_Encode4(1186410), // Rule ID 16652 //
     /* 1186335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1186338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186374 */     // MIs[0] round
     /* 1186374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186384 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1186387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186409 */     // GIR_Coverage, 16652,
     /* 1186409 */     GIR_EraseRootFromParent_Done,
     /* 1186410 */   // Label 17249: @1186410
     /* 1186410 */   GIM_Try, /*On fail goto*//*Label 17250*/ GIMT_Encode4(1186490), // Rule ID 16653 //
     /* 1186415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1186418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1186426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1186429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1186432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186454 */     // MIs[0] round
     /* 1186454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186464 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11116:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16),
     /* 1186467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186489 */     // GIR_Coverage, 16653,
     /* 1186489 */     GIR_EraseRootFromParent_Done,
     /* 1186490 */   // Label 17250: @1186490
     /* 1186490 */   GIM_Try, /*On fail goto*//*Label 17251*/ GIMT_Encode4(1186570), // Rule ID 16656 //
     /* 1186495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1186498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1186506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1186509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1186534 */     // MIs[0] round
     /* 1186534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1186547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186569 */     // GIR_Coverage, 16656,
     /* 1186569 */     GIR_EraseRootFromParent_Done,
     /* 1186570 */   // Label 17251: @1186570
     /* 1186570 */   GIM_Try, /*On fail goto*//*Label 17252*/ GIMT_Encode4(1186650), // Rule ID 16657 //
     /* 1186575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1186578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1186586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1186589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1186592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1186595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1186614 */     // MIs[0] round
     /* 1186614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11116:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32),
     /* 1186627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1186645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186649 */     // GIR_Coverage, 16657,
     /* 1186649 */     GIR_EraseRootFromParent_Done,
     /* 1186650 */   // Label 17252: @1186650
     /* 1186650 */   GIM_Try, /*On fail goto*//*Label 17253*/ GIMT_Encode4(1186730), // Rule ID 16660 //
     /* 1186655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1186658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1186666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1186669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1186672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1186694 */     // MIs[0] round
     /* 1186694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1186707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1186725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186729 */     // GIR_Coverage, 16660,
     /* 1186729 */     GIR_EraseRootFromParent_Done,
     /* 1186730 */   // Label 17253: @1186730
     /* 1186730 */   GIM_Try, /*On fail goto*//*Label 17254*/ GIMT_Encode4(1186810), // Rule ID 16661 //
     /* 1186735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1186738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1186746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1186749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1186752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1186755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1186770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1186774 */     // MIs[0] round
     /* 1186774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11116:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64),
     /* 1186787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1186805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186809 */     // GIR_Coverage, 16661,
     /* 1186809 */     GIR_EraseRootFromParent_Done,
     /* 1186810 */   // Label 17254: @1186810
     /* 1186810 */   GIM_Try, /*On fail goto*//*Label 17255*/ GIMT_Encode4(1186890), // Rule ID 16664 //
     /* 1186815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1186818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186854 */     // MIs[0] round
     /* 1186854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186864 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1186864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1186867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186889 */     // GIR_Coverage, 16664,
     /* 1186889 */     GIR_EraseRootFromParent_Done,
     /* 1186890 */   // Label 17255: @1186890
     /* 1186890 */   GIM_Try, /*On fail goto*//*Label 17256*/ GIMT_Encode4(1186970), // Rule ID 16665 //
     /* 1186895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1186898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1186906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1186909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1186912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1186918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1186930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1186934 */     // MIs[0] round
     /* 1186934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1186937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1186944 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1186944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16),
     /* 1186947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1186949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1186951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1186953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1186955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1186957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1186962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1186965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1186968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1186969 */     // GIR_Coverage, 16665,
     /* 1186969 */     GIR_EraseRootFromParent_Done,
     /* 1186970 */   // Label 17256: @1186970
     /* 1186970 */   GIM_Try, /*On fail goto*//*Label 17257*/ GIMT_Encode4(1187050), // Rule ID 16668 //
     /* 1186975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1186978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1186983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1186986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1186989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1186992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1186995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1186998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1187014 */     // MIs[0] round
     /* 1187014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187024 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1187027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187049 */     // GIR_Coverage, 16668,
     /* 1187049 */     GIR_EraseRootFromParent_Done,
     /* 1187050 */   // Label 17257: @1187050
     /* 1187050 */   GIM_Try, /*On fail goto*//*Label 17258*/ GIMT_Encode4(1187130), // Rule ID 16669 //
     /* 1187055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1187058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1187066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1187069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1187072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1187075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1187094 */     // MIs[0] round
     /* 1187094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187104 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16),
     /* 1187107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187129 */     // GIR_Coverage, 16669,
     /* 1187129 */     GIR_EraseRootFromParent_Done,
     /* 1187130 */   // Label 17258: @1187130
     /* 1187130 */   GIM_Try, /*On fail goto*//*Label 17259*/ GIMT_Encode4(1187210), // Rule ID 16672 //
     /* 1187135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1187138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1187146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1187149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1187155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1187174 */     // MIs[0] round
     /* 1187174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187184 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1187187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187209 */     // GIR_Coverage, 16672,
     /* 1187209 */     GIR_EraseRootFromParent_Done,
     /* 1187210 */   // Label 17259: @1187210
     /* 1187210 */   GIM_Try, /*On fail goto*//*Label 17260*/ GIMT_Encode4(1187290), // Rule ID 16673 //
     /* 1187215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1187218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1187226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1187229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1187232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1187235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1187254 */     // MIs[0] round
     /* 1187254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187264 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16),
     /* 1187267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1187285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187289 */     // GIR_Coverage, 16673,
     /* 1187289 */     GIR_EraseRootFromParent_Done,
     /* 1187290 */   // Label 17260: @1187290
     /* 1187290 */   GIM_Try, /*On fail goto*//*Label 17261*/ GIMT_Encode4(1187370), // Rule ID 16676 //
     /* 1187295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1187298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187334 */     // MIs[0] round
     /* 1187334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1187347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187369 */     // GIR_Coverage, 16676,
     /* 1187369 */     GIR_EraseRootFromParent_Done,
     /* 1187370 */   // Label 17261: @1187370
     /* 1187370 */   GIM_Try, /*On fail goto*//*Label 17262*/ GIMT_Encode4(1187450), // Rule ID 16677 //
     /* 1187375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1187378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1187386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1187389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1187392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187414 */     // MIs[0] round
     /* 1187414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32),
     /* 1187427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187449 */     // GIR_Coverage, 16677,
     /* 1187449 */     GIR_EraseRootFromParent_Done,
     /* 1187450 */   // Label 17262: @1187450
     /* 1187450 */   GIM_Try, /*On fail goto*//*Label 17263*/ GIMT_Encode4(1187530), // Rule ID 16680 //
     /* 1187455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1187458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187494 */     // MIs[0] round
     /* 1187494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187504 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1187507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187529 */     // GIR_Coverage, 16680,
     /* 1187529 */     GIR_EraseRootFromParent_Done,
     /* 1187530 */   // Label 17263: @1187530
     /* 1187530 */   GIM_Try, /*On fail goto*//*Label 17264*/ GIMT_Encode4(1187610), // Rule ID 16681 //
     /* 1187535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1187538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1187546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1187549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1187552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187574 */     // MIs[0] round
     /* 1187574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187584 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32),
     /* 1187587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187609 */     // GIR_Coverage, 16681,
     /* 1187609 */     GIR_EraseRootFromParent_Done,
     /* 1187610 */   // Label 17264: @1187610
     /* 1187610 */   GIM_Try, /*On fail goto*//*Label 17265*/ GIMT_Encode4(1187690), // Rule ID 16684 //
     /* 1187615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1187618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1187626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1187629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187654 */     // MIs[0] round
     /* 1187654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187664 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1187667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187689 */     // GIR_Coverage, 16684,
     /* 1187689 */     GIR_EraseRootFromParent_Done,
     /* 1187690 */   // Label 17265: @1187690
     /* 1187690 */   GIM_Try, /*On fail goto*//*Label 17266*/ GIMT_Encode4(1187770), // Rule ID 16685 //
     /* 1187695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1187698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1187706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1187709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1187712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1187715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1187730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1187734 */     // MIs[0] round
     /* 1187734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32),
     /* 1187747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1187765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187769 */     // GIR_Coverage, 16685,
     /* 1187769 */     GIR_EraseRootFromParent_Done,
     /* 1187770 */   // Label 17266: @1187770
     /* 1187770 */   GIM_Try, /*On fail goto*//*Label 17267*/ GIMT_Encode4(1187850), // Rule ID 16688 //
     /* 1187775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1187778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1187786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1187789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1187814 */     // MIs[0] round
     /* 1187814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1187827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1187845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187849 */     // GIR_Coverage, 16688,
     /* 1187849 */     GIR_EraseRootFromParent_Done,
     /* 1187850 */   // Label 17267: @1187850
     /* 1187850 */   GIM_Try, /*On fail goto*//*Label 17268*/ GIMT_Encode4(1187930), // Rule ID 16689 //
     /* 1187855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1187858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1187866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1187869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1187872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1187878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1187890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1187894 */     // MIs[0] round
     /* 1187894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11116:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1187904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64),
     /* 1187907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1187922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1187925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1187928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1187929 */     // GIR_Coverage, 16689,
     /* 1187929 */     GIR_EraseRootFromParent_Done,
     /* 1187930 */   // Label 17268: @1187930
     /* 1187930 */   GIM_Try, /*On fail goto*//*Label 17269*/ GIMT_Encode4(1188010), // Rule ID 16692 //
     /* 1187935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1187938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1187943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1187946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1187949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1187952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1187955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1187958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1187970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1187974 */     // MIs[0] round
     /* 1187974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1187977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1187984 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1187984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1187987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1187989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1187991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1187993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1187995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1187997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188009 */     // GIR_Coverage, 16692,
     /* 1188009 */     GIR_EraseRootFromParent_Done,
     /* 1188010 */   // Label 17269: @1188010
     /* 1188010 */   GIM_Try, /*On fail goto*//*Label 17270*/ GIMT_Encode4(1188090), // Rule ID 16693 //
     /* 1188015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1188018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1188026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1188029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1188032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1188050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1188054 */     // MIs[0] round
     /* 1188054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188064 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11116:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64),
     /* 1188067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188089 */     // GIR_Coverage, 16693,
     /* 1188089 */     GIR_EraseRootFromParent_Done,
     /* 1188090 */   // Label 17270: @1188090
     /* 1188090 */   GIM_Try, /*On fail goto*//*Label 17271*/ GIMT_Encode4(1188170), // Rule ID 16696 //
     /* 1188095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1188098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1188106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1188109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1188134 */     // MIs[0] round
     /* 1188134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188144 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1188147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188169 */     // GIR_Coverage, 16696,
     /* 1188169 */     GIR_EraseRootFromParent_Done,
     /* 1188170 */   // Label 17271: @1188170
     /* 1188170 */   GIM_Try, /*On fail goto*//*Label 17272*/ GIMT_Encode4(1188250), // Rule ID 16697 //
     /* 1188175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1188178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd),
     /* 1188183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1188186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1188189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1188192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1188195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1188210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1188214 */     // MIs[0] round
     /* 1188214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188224 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11116:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64),
     /* 1188227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1188245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188249 */     // GIR_Coverage, 16697,
     /* 1188249 */     GIR_EraseRootFromParent_Done,
     /* 1188250 */   // Label 17272: @1188250
     /* 1188250 */   GIM_Try, /*On fail goto*//*Label 17273*/ GIMT_Encode4(1188330), // Rule ID 16700 //
     /* 1188255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188294 */     // MIs[0] round
     /* 1188294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188304 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1188307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188329 */     // GIR_Coverage, 16700,
     /* 1188329 */     GIR_EraseRootFromParent_Done,
     /* 1188330 */   // Label 17273: @1188330
     /* 1188330 */   GIM_Try, /*On fail goto*//*Label 17274*/ GIMT_Encode4(1188410), // Rule ID 16701 //
     /* 1188335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1188346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1188349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1188352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1188355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188374 */     // MIs[0] round
     /* 1188374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188384 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 1188387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188409 */     // GIR_Coverage, 16701,
     /* 1188409 */     GIR_EraseRootFromParent_Done,
     /* 1188410 */   // Label 17274: @1188410
     /* 1188410 */   GIM_Try, /*On fail goto*//*Label 17275*/ GIMT_Encode4(1188490), // Rule ID 16704 //
     /* 1188415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188454 */     // MIs[0] round
     /* 1188454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188464 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1188467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188489 */     // GIR_Coverage, 16704,
     /* 1188489 */     GIR_EraseRootFromParent_Done,
     /* 1188490 */   // Label 17275: @1188490
     /* 1188490 */   GIM_Try, /*On fail goto*//*Label 17276*/ GIMT_Encode4(1188570), // Rule ID 16705 //
     /* 1188495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1188506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1188509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1188512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1188515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188534 */     // MIs[0] round
     /* 1188534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188544 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 1188547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188569 */     // GIR_Coverage, 16705,
     /* 1188569 */     GIR_EraseRootFromParent_Done,
     /* 1188570 */   // Label 17276: @1188570
     /* 1188570 */   GIM_Try, /*On fail goto*//*Label 17277*/ GIMT_Encode4(1188650), // Rule ID 16708 //
     /* 1188575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188614 */     // MIs[0] round
     /* 1188614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1188627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188649 */     // GIR_Coverage, 16708,
     /* 1188649 */     GIR_EraseRootFromParent_Done,
     /* 1188650 */   // Label 17277: @1188650
     /* 1188650 */   GIM_Try, /*On fail goto*//*Label 17278*/ GIMT_Encode4(1188730), // Rule ID 16709 //
     /* 1188655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1188666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1188669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1188672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1188675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188694 */     // MIs[0] round
     /* 1188694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 1188707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188729 */     // GIR_Coverage, 16709,
     /* 1188729 */     GIR_EraseRootFromParent_Done,
     /* 1188730 */   // Label 17278: @1188730
     /* 1188730 */   GIM_Try, /*On fail goto*//*Label 17279*/ GIMT_Encode4(1188810), // Rule ID 16712 //
     /* 1188735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1188738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188774 */     // MIs[0] round
     /* 1188774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1188787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188809 */     // GIR_Coverage, 16712,
     /* 1188809 */     GIR_EraseRootFromParent_Done,
     /* 1188810 */   // Label 17279: @1188810
     /* 1188810 */   GIM_Try, /*On fail goto*//*Label 17280*/ GIMT_Encode4(1188890), // Rule ID 16713 //
     /* 1188815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1188818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1188826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1188829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1188832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1188835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188854 */     // MIs[0] round
     /* 1188854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188864 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1188864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 1188867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1188885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188889 */     // GIR_Coverage, 16713,
     /* 1188889 */     GIR_EraseRootFromParent_Done,
     /* 1188890 */   // Label 17280: @1188890
     /* 1188890 */   GIM_Try, /*On fail goto*//*Label 17281*/ GIMT_Encode4(1188970), // Rule ID 16716 //
     /* 1188895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1188898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1188918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1188934 */     // MIs[0] round
     /* 1188934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1188937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1188944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1188944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1188947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1188949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1188951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1188953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1188955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1188957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1188962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1188965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1188968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1188969 */     // GIR_Coverage, 16716,
     /* 1188969 */     GIR_EraseRootFromParent_Done,
     /* 1188970 */   // Label 17281: @1188970
     /* 1188970 */   GIM_Try, /*On fail goto*//*Label 17282*/ GIMT_Encode4(1189050), // Rule ID 16717 //
     /* 1188975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1188978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1188983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1188986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1188989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1188992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1188995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1188998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189014 */     // MIs[0] round
     /* 1189014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 1189027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189049 */     // GIR_Coverage, 16717,
     /* 1189049 */     GIR_EraseRootFromParent_Done,
     /* 1189050 */   // Label 17282: @1189050
     /* 1189050 */   GIM_Try, /*On fail goto*//*Label 17283*/ GIMT_Encode4(1189130), // Rule ID 16720 //
     /* 1189055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1189058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189094 */     // MIs[0] round
     /* 1189094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189104 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1189107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189129 */     // GIR_Coverage, 16720,
     /* 1189129 */     GIR_EraseRootFromParent_Done,
     /* 1189130 */   // Label 17283: @1189130
     /* 1189130 */   GIM_Try, /*On fail goto*//*Label 17284*/ GIMT_Encode4(1189210), // Rule ID 16721 //
     /* 1189135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1189138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1189146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1189149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1189152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1189155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1189174 */     // MIs[0] round
     /* 1189174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189184 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 1189187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1189205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189209 */     // GIR_Coverage, 16721,
     /* 1189209 */     GIR_EraseRootFromParent_Done,
     /* 1189210 */   // Label 17284: @1189210
     /* 1189210 */   GIM_Try, /*On fail goto*//*Label 17285*/ GIMT_Encode4(1189290), // Rule ID 16724 //
     /* 1189215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189254 */     // MIs[0] round
     /* 1189254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189264 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1189267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189289 */     // GIR_Coverage, 16724,
     /* 1189289 */     GIR_EraseRootFromParent_Done,
     /* 1189290 */   // Label 17285: @1189290
     /* 1189290 */   GIM_Try, /*On fail goto*//*Label 17286*/ GIMT_Encode4(1189370), // Rule ID 16725 //
     /* 1189295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1189306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1189309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1189312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1189315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189334 */     // MIs[0] round
     /* 1189334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189344 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 1189347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189369 */     // GIR_Coverage, 16725,
     /* 1189369 */     GIR_EraseRootFromParent_Done,
     /* 1189370 */   // Label 17286: @1189370
     /* 1189370 */   GIM_Try, /*On fail goto*//*Label 17287*/ GIMT_Encode4(1189450), // Rule ID 16728 //
     /* 1189375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189414 */     // MIs[0] round
     /* 1189414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189424 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1189427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189449 */     // GIR_Coverage, 16728,
     /* 1189449 */     GIR_EraseRootFromParent_Done,
     /* 1189450 */   // Label 17287: @1189450
     /* 1189450 */   GIM_Try, /*On fail goto*//*Label 17288*/ GIMT_Encode4(1189530), // Rule ID 16729 //
     /* 1189455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1189466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1189469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1189472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1189475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189494 */     // MIs[0] round
     /* 1189494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189504 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 1189507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189529 */     // GIR_Coverage, 16729,
     /* 1189529 */     GIR_EraseRootFromParent_Done,
     /* 1189530 */   // Label 17288: @1189530
     /* 1189530 */   GIM_Try, /*On fail goto*//*Label 17289*/ GIMT_Encode4(1189610), // Rule ID 16732 //
     /* 1189535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1189538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189574 */     // MIs[0] round
     /* 1189574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189584 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1189587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189609 */     // GIR_Coverage, 16732,
     /* 1189609 */     GIR_EraseRootFromParent_Done,
     /* 1189610 */   // Label 17289: @1189610
     /* 1189610 */   GIM_Try, /*On fail goto*//*Label 17290*/ GIMT_Encode4(1189690), // Rule ID 16733 //
     /* 1189615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1189618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1189626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1189629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1189632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1189635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1189654 */     // MIs[0] round
     /* 1189654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189664 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 1189667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1189685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189689 */     // GIR_Coverage, 16733,
     /* 1189689 */     GIR_EraseRootFromParent_Done,
     /* 1189690 */   // Label 17290: @1189690
     /* 1189690 */   GIM_Try, /*On fail goto*//*Label 17291*/ GIMT_Encode4(1189770), // Rule ID 16736 //
     /* 1189695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189734 */     // MIs[0] round
     /* 1189734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1189747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189769 */     // GIR_Coverage, 16736,
     /* 1189769 */     GIR_EraseRootFromParent_Done,
     /* 1189770 */   // Label 17291: @1189770
     /* 1189770 */   GIM_Try, /*On fail goto*//*Label 17292*/ GIMT_Encode4(1189850), // Rule ID 16737 //
     /* 1189775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1189786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1189789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1189792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1189795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1189814 */     // MIs[0] round
     /* 1189814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 1189827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189849 */     // GIR_Coverage, 16737,
     /* 1189849 */     GIR_EraseRootFromParent_Done,
     /* 1189850 */   // Label 17292: @1189850
     /* 1189850 */   GIM_Try, /*On fail goto*//*Label 17293*/ GIMT_Encode4(1189930), // Rule ID 16740 //
     /* 1189855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1189858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1189878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189894 */     // MIs[0] round
     /* 1189894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189904 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1189904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1189907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1189922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1189925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1189928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1189929 */     // GIR_Coverage, 16740,
     /* 1189929 */     GIR_EraseRootFromParent_Done,
     /* 1189930 */   // Label 17293: @1189930
     /* 1189930 */   GIM_Try, /*On fail goto*//*Label 17294*/ GIMT_Encode4(1190010), // Rule ID 16741 //
     /* 1189935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1189938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1189943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1189946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1189949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1189952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1189955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1189958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1189974 */     // MIs[0] round
     /* 1189974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1189977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1189984 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1189984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 1189987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1189989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1189991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1189993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1189995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1189997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190009 */     // GIR_Coverage, 16741,
     /* 1190009 */     GIR_EraseRootFromParent_Done,
     /* 1190010 */   // Label 17294: @1190010
     /* 1190010 */   GIM_Try, /*On fail goto*//*Label 17295*/ GIMT_Encode4(1190090), // Rule ID 16744 //
     /* 1190015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190054 */     // MIs[0] round
     /* 1190054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190064 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1190067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190089 */     // GIR_Coverage, 16744,
     /* 1190089 */     GIR_EraseRootFromParent_Done,
     /* 1190090 */   // Label 17295: @1190090
     /* 1190090 */   GIM_Try, /*On fail goto*//*Label 17296*/ GIMT_Encode4(1190170), // Rule ID 16745 //
     /* 1190095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1190098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1190106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1190109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1190112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1190115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190134 */     // MIs[0] round
     /* 1190134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190144 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 1190147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1190165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190169 */     // GIR_Coverage, 16745,
     /* 1190169 */     GIR_EraseRootFromParent_Done,
     /* 1190170 */   // Label 17296: @1190170
     /* 1190170 */   GIM_Try, /*On fail goto*//*Label 17297*/ GIMT_Encode4(1190250), // Rule ID 16748 //
     /* 1190175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190214 */     // MIs[0] round
     /* 1190214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190224 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1190227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190249 */     // GIR_Coverage, 16748,
     /* 1190249 */     GIR_EraseRootFromParent_Done,
     /* 1190250 */   // Label 17297: @1190250
     /* 1190250 */   GIM_Try, /*On fail goto*//*Label 17298*/ GIMT_Encode4(1190330), // Rule ID 16749 //
     /* 1190255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1190266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1190269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1190272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1190275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1190294 */     // MIs[0] round
     /* 1190294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190304 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 1190307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190329 */     // GIR_Coverage, 16749,
     /* 1190329 */     GIR_EraseRootFromParent_Done,
     /* 1190330 */   // Label 17298: @1190330
     /* 1190330 */   GIM_Try, /*On fail goto*//*Label 17299*/ GIMT_Encode4(1190410), // Rule ID 16752 //
     /* 1190335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190374 */     // MIs[0] round
     /* 1190374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190384 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1190387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190409 */     // GIR_Coverage, 16752,
     /* 1190409 */     GIR_EraseRootFromParent_Done,
     /* 1190410 */   // Label 17299: @1190410
     /* 1190410 */   GIM_Try, /*On fail goto*//*Label 17300*/ GIMT_Encode4(1190490), // Rule ID 16753 //
     /* 1190415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1190426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1190429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1190432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1190435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1190454 */     // MIs[0] round
     /* 1190454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190464 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 1190467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190489 */     // GIR_Coverage, 16753,
     /* 1190489 */     GIR_EraseRootFromParent_Done,
     /* 1190490 */   // Label 17300: @1190490
     /* 1190490 */   GIM_Try, /*On fail goto*//*Label 17301*/ GIMT_Encode4(1190570), // Rule ID 16756 //
     /* 1190495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1190498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190534 */     // MIs[0] round
     /* 1190534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190544 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1190547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190569 */     // GIR_Coverage, 16756,
     /* 1190569 */     GIR_EraseRootFromParent_Done,
     /* 1190570 */   // Label 17301: @1190570
     /* 1190570 */   GIM_Try, /*On fail goto*//*Label 17302*/ GIMT_Encode4(1190650), // Rule ID 16757 //
     /* 1190575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1190578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1190586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1190589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1190592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1190595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1190614 */     // MIs[0] round
     /* 1190614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190624 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 1190627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1190645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190649 */     // GIR_Coverage, 16757,
     /* 1190649 */     GIR_EraseRootFromParent_Done,
     /* 1190650 */   // Label 17302: @1190650
     /* 1190650 */   GIM_Try, /*On fail goto*//*Label 17303*/ GIMT_Encode4(1190730), // Rule ID 16760 //
     /* 1190655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190694 */     // MIs[0] round
     /* 1190694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190704 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1190707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190729 */     // GIR_Coverage, 16760,
     /* 1190729 */     GIR_EraseRootFromParent_Done,
     /* 1190730 */   // Label 17303: @1190730
     /* 1190730 */   GIM_Try, /*On fail goto*//*Label 17304*/ GIMT_Encode4(1190810), // Rule ID 16761 //
     /* 1190735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1190746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1190749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1190752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190774 */     // MIs[0] round
     /* 1190774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190784 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16),
     /* 1190787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190809 */     // GIR_Coverage, 16761,
     /* 1190809 */     GIR_EraseRootFromParent_Done,
     /* 1190810 */   // Label 17304: @1190810
     /* 1190810 */   GIM_Try, /*On fail goto*//*Label 17305*/ GIMT_Encode4(1190890), // Rule ID 16764 //
     /* 1190815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1190818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190854 */     // MIs[0] round
     /* 1190854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190864 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1190864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1190867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190889 */     // GIR_Coverage, 16764,
     /* 1190889 */     GIR_EraseRootFromParent_Done,
     /* 1190890 */   // Label 17305: @1190890
     /* 1190890 */   GIM_Try, /*On fail goto*//*Label 17306*/ GIMT_Encode4(1190970), // Rule ID 16765 //
     /* 1190895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1190898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1190906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1190909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1190912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1190915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1190918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1190930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1190934 */     // MIs[0] round
     /* 1190934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1190937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1190944 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1190944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16),
     /* 1190947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1190949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1190951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1190953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1190955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1190957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1190962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1190965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1190968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1190969 */     // GIR_Coverage, 16765,
     /* 1190969 */     GIR_EraseRootFromParent_Done,
     /* 1190970 */   // Label 17306: @1190970
     /* 1190970 */   GIM_Try, /*On fail goto*//*Label 17307*/ GIMT_Encode4(1191050), // Rule ID 16768 //
     /* 1190975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1190978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1190983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1190986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1190989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1190992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1190995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1190998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191014 */     // MIs[0] round
     /* 1191014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1191027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191049 */     // GIR_Coverage, 16768,
     /* 1191049 */     GIR_EraseRootFromParent_Done,
     /* 1191050 */   // Label 17307: @1191050
     /* 1191050 */   GIM_Try, /*On fail goto*//*Label 17308*/ GIMT_Encode4(1191130), // Rule ID 16769 //
     /* 1191055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1191066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1191069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1191072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191094 */     // MIs[0] round
     /* 1191094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191104 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32),
     /* 1191107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191129 */     // GIR_Coverage, 16769,
     /* 1191129 */     GIR_EraseRootFromParent_Done,
     /* 1191130 */   // Label 17308: @1191130
     /* 1191130 */   GIM_Try, /*On fail goto*//*Label 17309*/ GIMT_Encode4(1191210), // Rule ID 16772 //
     /* 1191135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191174 */     // MIs[0] round
     /* 1191174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1191187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191209 */     // GIR_Coverage, 16772,
     /* 1191209 */     GIR_EraseRootFromParent_Done,
     /* 1191210 */   // Label 17309: @1191210
     /* 1191210 */   GIM_Try, /*On fail goto*//*Label 17310*/ GIMT_Encode4(1191290), // Rule ID 16773 //
     /* 1191215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1191226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1191229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1191232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191254 */     // MIs[0] round
     /* 1191254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191264 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11208:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16),
     /* 1191267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191289 */     // GIR_Coverage, 16773,
     /* 1191289 */     GIR_EraseRootFromParent_Done,
     /* 1191290 */   // Label 17310: @1191290
     /* 1191290 */   GIM_Try, /*On fail goto*//*Label 17311*/ GIMT_Encode4(1191370), // Rule ID 16776 //
     /* 1191295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1191298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191334 */     // MIs[0] round
     /* 1191334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1191347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191369 */     // GIR_Coverage, 16776,
     /* 1191369 */     GIR_EraseRootFromParent_Done,
     /* 1191370 */   // Label 17311: @1191370
     /* 1191370 */   GIM_Try, /*On fail goto*//*Label 17312*/ GIMT_Encode4(1191450), // Rule ID 16777 //
     /* 1191375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1191378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1191386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1191389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1191392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1191395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1191414 */     // MIs[0] round
     /* 1191414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11208:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32),
     /* 1191427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1191445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191449 */     // GIR_Coverage, 16777,
     /* 1191449 */     GIR_EraseRootFromParent_Done,
     /* 1191450 */   // Label 17312: @1191450
     /* 1191450 */   GIM_Try, /*On fail goto*//*Label 17313*/ GIMT_Encode4(1191530), // Rule ID 16780 //
     /* 1191455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1191458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191494 */     // MIs[0] round
     /* 1191494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191504 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1191507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191529 */     // GIR_Coverage, 16780,
     /* 1191529 */     GIR_EraseRootFromParent_Done,
     /* 1191530 */   // Label 17313: @1191530
     /* 1191530 */   GIM_Try, /*On fail goto*//*Label 17314*/ GIMT_Encode4(1191610), // Rule ID 16781 //
     /* 1191535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1191538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1191546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1191549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1191552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1191555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1191570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1191574 */     // MIs[0] round
     /* 1191574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191584 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11208:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64),
     /* 1191587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1191605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191609 */     // GIR_Coverage, 16781,
     /* 1191609 */     GIR_EraseRootFromParent_Done,
     /* 1191610 */   // Label 17314: @1191610
     /* 1191610 */   GIM_Try, /*On fail goto*//*Label 17315*/ GIMT_Encode4(1191690), // Rule ID 16784 //
     /* 1191615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191654 */     // MIs[0] round
     /* 1191654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191664 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1191667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191689 */     // GIR_Coverage, 16784,
     /* 1191689 */     GIR_EraseRootFromParent_Done,
     /* 1191690 */   // Label 17315: @1191690
     /* 1191690 */   GIM_Try, /*On fail goto*//*Label 17316*/ GIMT_Encode4(1191770), // Rule ID 16785 //
     /* 1191695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1191706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1191709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1191712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1191730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191734 */     // MIs[0] round
     /* 1191734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191744 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16),
     /* 1191747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191769 */     // GIR_Coverage, 16785,
     /* 1191769 */     GIR_EraseRootFromParent_Done,
     /* 1191770 */   // Label 17316: @1191770
     /* 1191770 */   GIM_Try, /*On fail goto*//*Label 17317*/ GIMT_Encode4(1191850), // Rule ID 16788 //
     /* 1191775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191814 */     // MIs[0] round
     /* 1191814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191824 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1191827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191849 */     // GIR_Coverage, 16788,
     /* 1191849 */     GIR_EraseRootFromParent_Done,
     /* 1191850 */   // Label 17317: @1191850
     /* 1191850 */   GIM_Try, /*On fail goto*//*Label 17318*/ GIMT_Encode4(1191930), // Rule ID 16789 //
     /* 1191855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1191858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1191866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1191869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1191872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1191878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1191890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191894 */     // MIs[0] round
     /* 1191894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1191904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16),
     /* 1191907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1191922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1191925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1191928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1191929 */     // GIR_Coverage, 16789,
     /* 1191929 */     GIR_EraseRootFromParent_Done,
     /* 1191930 */   // Label 17318: @1191930
     /* 1191930 */   GIM_Try, /*On fail goto*//*Label 17319*/ GIMT_Encode4(1192010), // Rule ID 16792 //
     /* 1191935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1191938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1191943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1191946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1191949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1191952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1191955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1191958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1191970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1191974 */     // MIs[0] round
     /* 1191974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1191977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1191984 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1191984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1191987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1191989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1191991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1191993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1191995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1191997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192009 */     // GIR_Coverage, 16792,
     /* 1192009 */     GIR_EraseRootFromParent_Done,
     /* 1192010 */   // Label 17319: @1192010
     /* 1192010 */   GIM_Try, /*On fail goto*//*Label 17320*/ GIMT_Encode4(1192090), // Rule ID 16793 //
     /* 1192015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1192018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1192026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1192029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1192032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1192035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1192054 */     // MIs[0] round
     /* 1192054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192064 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16),
     /* 1192067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1192085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192089 */     // GIR_Coverage, 16793,
     /* 1192089 */     GIR_EraseRootFromParent_Done,
     /* 1192090 */   // Label 17320: @1192090
     /* 1192090 */   GIM_Try, /*On fail goto*//*Label 17321*/ GIMT_Encode4(1192170), // Rule ID 16796 //
     /* 1192095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192134 */     // MIs[0] round
     /* 1192134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1192147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192169 */     // GIR_Coverage, 16796,
     /* 1192169 */     GIR_EraseRootFromParent_Done,
     /* 1192170 */   // Label 17321: @1192170
     /* 1192170 */   GIM_Try, /*On fail goto*//*Label 17322*/ GIMT_Encode4(1192250), // Rule ID 16797 //
     /* 1192175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1192186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1192189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1192192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192214 */     // MIs[0] round
     /* 1192214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32),
     /* 1192227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192249 */     // GIR_Coverage, 16797,
     /* 1192249 */     GIR_EraseRootFromParent_Done,
     /* 1192250 */   // Label 17322: @1192250
     /* 1192250 */   GIM_Try, /*On fail goto*//*Label 17323*/ GIMT_Encode4(1192330), // Rule ID 16800 //
     /* 1192255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192294 */     // MIs[0] round
     /* 1192294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192304 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1192307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192329 */     // GIR_Coverage, 16800,
     /* 1192329 */     GIR_EraseRootFromParent_Done,
     /* 1192330 */   // Label 17323: @1192330
     /* 1192330 */   GIM_Try, /*On fail goto*//*Label 17324*/ GIMT_Encode4(1192410), // Rule ID 16801 //
     /* 1192335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1192346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1192349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1192352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192374 */     // MIs[0] round
     /* 1192374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192384 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32),
     /* 1192387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192409 */     // GIR_Coverage, 16801,
     /* 1192409 */     GIR_EraseRootFromParent_Done,
     /* 1192410 */   // Label 17324: @1192410
     /* 1192410 */   GIM_Try, /*On fail goto*//*Label 17325*/ GIMT_Encode4(1192490), // Rule ID 16804 //
     /* 1192415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1192418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192454 */     // MIs[0] round
     /* 1192454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192464 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1192467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192489 */     // GIR_Coverage, 16804,
     /* 1192489 */     GIR_EraseRootFromParent_Done,
     /* 1192490 */   // Label 17325: @1192490
     /* 1192490 */   GIM_Try, /*On fail goto*//*Label 17326*/ GIMT_Encode4(1192570), // Rule ID 16805 //
     /* 1192495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1192498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1192506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1192509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1192512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1192515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1192534 */     // MIs[0] round
     /* 1192534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192544 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32),
     /* 1192547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1192565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192569 */     // GIR_Coverage, 16805,
     /* 1192569 */     GIR_EraseRootFromParent_Done,
     /* 1192570 */   // Label 17326: @1192570
     /* 1192570 */   GIM_Try, /*On fail goto*//*Label 17327*/ GIMT_Encode4(1192650), // Rule ID 16808 //
     /* 1192575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192614 */     // MIs[0] round
     /* 1192614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192624 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1192627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192649 */     // GIR_Coverage, 16808,
     /* 1192649 */     GIR_EraseRootFromParent_Done,
     /* 1192650 */   // Label 17327: @1192650
     /* 1192650 */   GIM_Try, /*On fail goto*//*Label 17328*/ GIMT_Encode4(1192730), // Rule ID 16809 //
     /* 1192655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1192666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1192669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1192672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1192690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192694 */     // MIs[0] round
     /* 1192694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11208:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64),
     /* 1192707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192729 */     // GIR_Coverage, 16809,
     /* 1192729 */     GIR_EraseRootFromParent_Done,
     /* 1192730 */   // Label 17328: @1192730
     /* 1192730 */   GIM_Try, /*On fail goto*//*Label 17329*/ GIMT_Encode4(1192810), // Rule ID 16812 //
     /* 1192735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192774 */     // MIs[0] round
     /* 1192774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192784 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1192787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192809 */     // GIR_Coverage, 16812,
     /* 1192809 */     GIR_EraseRootFromParent_Done,
     /* 1192810 */   // Label 17329: @1192810
     /* 1192810 */   GIM_Try, /*On fail goto*//*Label 17330*/ GIMT_Encode4(1192890), // Rule ID 16813 //
     /* 1192815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1192826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1192829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1192832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1192850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192854 */     // MIs[0] round
     /* 1192854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192864 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11208:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1192864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64),
     /* 1192867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192889 */     // GIR_Coverage, 16813,
     /* 1192889 */     GIR_EraseRootFromParent_Done,
     /* 1192890 */   // Label 17330: @1192890
     /* 1192890 */   GIM_Try, /*On fail goto*//*Label 17331*/ GIMT_Encode4(1192970), // Rule ID 16816 //
     /* 1192895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1192898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1192918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1192930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1192934 */     // MIs[0] round
     /* 1192934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1192937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1192944 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1192944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1192947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1192949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1192951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1192953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1192955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1192957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1192962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1192965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1192968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1192969 */     // GIR_Coverage, 16816,
     /* 1192969 */     GIR_EraseRootFromParent_Done,
     /* 1192970 */   // Label 17331: @1192970
     /* 1192970 */   GIM_Try, /*On fail goto*//*Label 17332*/ GIMT_Encode4(1193050), // Rule ID 16817 //
     /* 1192975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1192978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub),
     /* 1192983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1192986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1192989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1192992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1192995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1192998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1193010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193014 */     // MIs[0] round
     /* 1193014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193024 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11208:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64),
     /* 1193027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193049 */     // GIR_Coverage, 16817,
     /* 1193049 */     GIR_EraseRootFromParent_Done,
     /* 1193050 */   // Label 17332: @1193050
     /* 1193050 */   GIM_Try, /*On fail goto*//*Label 17333*/ GIMT_Encode4(1193130), // Rule ID 16820 //
     /* 1193055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193094 */     // MIs[0] round
     /* 1193094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193104 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1193107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193129 */     // GIR_Coverage, 16820,
     /* 1193129 */     GIR_EraseRootFromParent_Done,
     /* 1193130 */   // Label 17333: @1193130
     /* 1193130 */   GIM_Try, /*On fail goto*//*Label 17334*/ GIMT_Encode4(1193210), // Rule ID 16821 //
     /* 1193135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1193146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1193149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1193152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193174 */     // MIs[0] round
     /* 1193174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193184 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16),
     /* 1193187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193209 */     // GIR_Coverage, 16821,
     /* 1193209 */     GIR_EraseRootFromParent_Done,
     /* 1193210 */   // Label 17334: @1193210
     /* 1193210 */   GIM_Try, /*On fail goto*//*Label 17335*/ GIMT_Encode4(1193290), // Rule ID 16824 //
     /* 1193215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193254 */     // MIs[0] round
     /* 1193254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193264 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1193267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193289 */     // GIR_Coverage, 16824,
     /* 1193289 */     GIR_EraseRootFromParent_Done,
     /* 1193290 */   // Label 17335: @1193290
     /* 1193290 */   GIM_Try, /*On fail goto*//*Label 17336*/ GIMT_Encode4(1193370), // Rule ID 16825 //
     /* 1193295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1193306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1193309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1193312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193334 */     // MIs[0] round
     /* 1193334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193344 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16),
     /* 1193347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193369 */     // GIR_Coverage, 16825,
     /* 1193369 */     GIR_EraseRootFromParent_Done,
     /* 1193370 */   // Label 17336: @1193370
     /* 1193370 */   GIM_Try, /*On fail goto*//*Label 17337*/ GIMT_Encode4(1193450), // Rule ID 16828 //
     /* 1193375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1193414 */     // MIs[0] round
     /* 1193414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1193427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193449 */     // GIR_Coverage, 16828,
     /* 1193449 */     GIR_EraseRootFromParent_Done,
     /* 1193450 */   // Label 17337: @1193450
     /* 1193450 */   GIM_Try, /*On fail goto*//*Label 17338*/ GIMT_Encode4(1193530), // Rule ID 16829 //
     /* 1193455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1193466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1193469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1193472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1193494 */     // MIs[0] round
     /* 1193494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32),
     /* 1193507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193529 */     // GIR_Coverage, 16829,
     /* 1193529 */     GIR_EraseRootFromParent_Done,
     /* 1193530 */   // Label 17338: @1193530
     /* 1193530 */   GIM_Try, /*On fail goto*//*Label 17339*/ GIMT_Encode4(1193610), // Rule ID 16832 //
     /* 1193535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1193538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193574 */     // MIs[0] round
     /* 1193574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193584 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1193587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193609 */     // GIR_Coverage, 16832,
     /* 1193609 */     GIR_EraseRootFromParent_Done,
     /* 1193610 */   // Label 17339: @1193610
     /* 1193610 */   GIM_Try, /*On fail goto*//*Label 17340*/ GIMT_Encode4(1193690), // Rule ID 16833 //
     /* 1193615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1193618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1193626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1193629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1193632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1193635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1193654 */     // MIs[0] round
     /* 1193654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11194:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16),
     /* 1193667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1193685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193689 */     // GIR_Coverage, 16833,
     /* 1193689 */     GIR_EraseRootFromParent_Done,
     /* 1193690 */   // Label 17340: @1193690
     /* 1193690 */   GIM_Try, /*On fail goto*//*Label 17341*/ GIMT_Encode4(1193770), // Rule ID 16836 //
     /* 1193695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1193698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1193734 */     // MIs[0] round
     /* 1193734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193744 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1193747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193769 */     // GIR_Coverage, 16836,
     /* 1193769 */     GIR_EraseRootFromParent_Done,
     /* 1193770 */   // Label 17341: @1193770
     /* 1193770 */   GIM_Try, /*On fail goto*//*Label 17342*/ GIMT_Encode4(1193850), // Rule ID 16837 //
     /* 1193775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1193778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1193786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1193789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1193792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1193795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1193814 */     // MIs[0] round
     /* 1193814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11194:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32),
     /* 1193827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1193845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193849 */     // GIR_Coverage, 16837,
     /* 1193849 */     GIR_EraseRootFromParent_Done,
     /* 1193850 */   // Label 17342: @1193850
     /* 1193850 */   GIM_Try, /*On fail goto*//*Label 17343*/ GIMT_Encode4(1193930), // Rule ID 16840 //
     /* 1193855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1193858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1193878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193894 */     // MIs[0] round
     /* 1193894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1193904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1193907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1193922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1193925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1193928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1193929 */     // GIR_Coverage, 16840,
     /* 1193929 */     GIR_EraseRootFromParent_Done,
     /* 1193930 */   // Label 17343: @1193930
     /* 1193930 */   GIM_Try, /*On fail goto*//*Label 17344*/ GIMT_Encode4(1194010), // Rule ID 16841 //
     /* 1193935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1193938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1193943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1193946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1193949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1193952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1193955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1193958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1193970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1193974 */     // MIs[0] round
     /* 1193974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1193977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1193984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11194:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1193984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64),
     /* 1193987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1193989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1193991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1193993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1193995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1193997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1194005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194009 */     // GIR_Coverage, 16841,
     /* 1194009 */     GIR_EraseRootFromParent_Done,
     /* 1194010 */   // Label 17344: @1194010
     /* 1194010 */   GIM_Try, /*On fail goto*//*Label 17345*/ GIMT_Encode4(1194090), // Rule ID 16844 //
     /* 1194015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194054 */     // MIs[0] round
     /* 1194054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194064 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1194067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194089 */     // GIR_Coverage, 16844,
     /* 1194089 */     GIR_EraseRootFromParent_Done,
     /* 1194090 */   // Label 17345: @1194090
     /* 1194090 */   GIM_Try, /*On fail goto*//*Label 17346*/ GIMT_Encode4(1194170), // Rule ID 16845 //
     /* 1194095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1194106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1194109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1194112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194134 */     // MIs[0] round
     /* 1194134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194144 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16),
     /* 1194147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194169 */     // GIR_Coverage, 16845,
     /* 1194169 */     GIR_EraseRootFromParent_Done,
     /* 1194170 */   // Label 17346: @1194170
     /* 1194170 */   GIM_Try, /*On fail goto*//*Label 17347*/ GIMT_Encode4(1194250), // Rule ID 16848 //
     /* 1194175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194214 */     // MIs[0] round
     /* 1194214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194224 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1194227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194249 */     // GIR_Coverage, 16848,
     /* 1194249 */     GIR_EraseRootFromParent_Done,
     /* 1194250 */   // Label 17347: @1194250
     /* 1194250 */   GIM_Try, /*On fail goto*//*Label 17348*/ GIMT_Encode4(1194330), // Rule ID 16849 //
     /* 1194255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1194266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1194269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1194272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194294 */     // MIs[0] round
     /* 1194294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194304 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16),
     /* 1194307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194329 */     // GIR_Coverage, 16849,
     /* 1194329 */     GIR_EraseRootFromParent_Done,
     /* 1194330 */   // Label 17348: @1194330
     /* 1194330 */   GIM_Try, /*On fail goto*//*Label 17349*/ GIMT_Encode4(1194410), // Rule ID 16852 //
     /* 1194335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1194338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194374 */     // MIs[0] round
     /* 1194374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194384 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1194387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194409 */     // GIR_Coverage, 16852,
     /* 1194409 */     GIR_EraseRootFromParent_Done,
     /* 1194410 */   // Label 17349: @1194410
     /* 1194410 */   GIM_Try, /*On fail goto*//*Label 17350*/ GIMT_Encode4(1194490), // Rule ID 16853 //
     /* 1194415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1194418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1194426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1194429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1194432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1194435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1194454 */     // MIs[0] round
     /* 1194454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194464 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16),
     /* 1194467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1194485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194489 */     // GIR_Coverage, 16853,
     /* 1194489 */     GIR_EraseRootFromParent_Done,
     /* 1194490 */   // Label 17350: @1194490
     /* 1194490 */   GIM_Try, /*On fail goto*//*Label 17351*/ GIMT_Encode4(1194570), // Rule ID 16856 //
     /* 1194495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194534 */     // MIs[0] round
     /* 1194534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1194547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194569 */     // GIR_Coverage, 16856,
     /* 1194569 */     GIR_EraseRootFromParent_Done,
     /* 1194570 */   // Label 17351: @1194570
     /* 1194570 */   GIM_Try, /*On fail goto*//*Label 17352*/ GIMT_Encode4(1194650), // Rule ID 16857 //
     /* 1194575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1194586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1194589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1194592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1194610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194614 */     // MIs[0] round
     /* 1194614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32),
     /* 1194627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194649 */     // GIR_Coverage, 16857,
     /* 1194649 */     GIR_EraseRootFromParent_Done,
     /* 1194650 */   // Label 17352: @1194650
     /* 1194650 */   GIM_Try, /*On fail goto*//*Label 17353*/ GIMT_Encode4(1194730), // Rule ID 16860 //
     /* 1194655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194694 */     // MIs[0] round
     /* 1194694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194704 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1194707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194729 */     // GIR_Coverage, 16860,
     /* 1194729 */     GIR_EraseRootFromParent_Done,
     /* 1194730 */   // Label 17353: @1194730
     /* 1194730 */   GIM_Try, /*On fail goto*//*Label 17354*/ GIMT_Encode4(1194810), // Rule ID 16861 //
     /* 1194735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1194746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1194749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1194752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1194770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194774 */     // MIs[0] round
     /* 1194774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194784 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32),
     /* 1194787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194809 */     // GIR_Coverage, 16861,
     /* 1194809 */     GIR_EraseRootFromParent_Done,
     /* 1194810 */   // Label 17354: @1194810
     /* 1194810 */   GIM_Try, /*On fail goto*//*Label 17355*/ GIMT_Encode4(1194890), // Rule ID 16864 //
     /* 1194815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1194818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194854 */     // MIs[0] round
     /* 1194854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194864 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1194864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1194867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194889 */     // GIR_Coverage, 16864,
     /* 1194889 */     GIR_EraseRootFromParent_Done,
     /* 1194890 */   // Label 17355: @1194890
     /* 1194890 */   GIM_Try, /*On fail goto*//*Label 17356*/ GIMT_Encode4(1194970), // Rule ID 16865 //
     /* 1194895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1194898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1194906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1194909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1194912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1194915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1194918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1194930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1194934 */     // MIs[0] round
     /* 1194934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1194937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1194944 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1194944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32),
     /* 1194947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1194949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1194951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1194953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1194955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1194957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1194962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1194965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1194968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1194969 */     // GIR_Coverage, 16865,
     /* 1194969 */     GIR_EraseRootFromParent_Done,
     /* 1194970 */   // Label 17356: @1194970
     /* 1194970 */   GIM_Try, /*On fail goto*//*Label 17357*/ GIMT_Encode4(1195050), // Rule ID 16868 //
     /* 1194975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1194978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1194983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1194986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1194989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1194992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1194995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1194998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195014 */     // MIs[0] round
     /* 1195014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1195027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195049 */     // GIR_Coverage, 16868,
     /* 1195049 */     GIR_EraseRootFromParent_Done,
     /* 1195050 */   // Label 17357: @1195050
     /* 1195050 */   GIM_Try, /*On fail goto*//*Label 17358*/ GIMT_Encode4(1195130), // Rule ID 16869 //
     /* 1195055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1195063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1195066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1195069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1195072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195094 */     // MIs[0] round
     /* 1195094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195104 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11194:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64),
     /* 1195107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195129 */     // GIR_Coverage, 16869,
     /* 1195129 */     GIR_EraseRootFromParent_Done,
     /* 1195130 */   // Label 17358: @1195130
     /* 1195130 */   GIM_Try, /*On fail goto*//*Label 17359*/ GIMT_Encode4(1195210), // Rule ID 16872 //
     /* 1195135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1195143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195174 */     // MIs[0] round
     /* 1195174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195184 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1195187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195209 */     // GIR_Coverage, 16872,
     /* 1195209 */     GIR_EraseRootFromParent_Done,
     /* 1195210 */   // Label 17359: @1195210
     /* 1195210 */   GIM_Try, /*On fail goto*//*Label 17360*/ GIMT_Encode4(1195290), // Rule ID 16873 //
     /* 1195215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1195223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1195226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1195229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1195232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195254 */     // MIs[0] round
     /* 1195254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195264 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11194:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64),
     /* 1195267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195289 */     // GIR_Coverage, 16873,
     /* 1195289 */     GIR_EraseRootFromParent_Done,
     /* 1195290 */   // Label 17360: @1195290
     /* 1195290 */   GIM_Try, /*On fail goto*//*Label 17361*/ GIMT_Encode4(1195370), // Rule ID 16876 //
     /* 1195295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1195298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1195303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195334 */     // MIs[0] round
     /* 1195334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1195347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195369 */     // GIR_Coverage, 16876,
     /* 1195369 */     GIR_EraseRootFromParent_Done,
     /* 1195370 */   // Label 17361: @1195370
     /* 1195370 */   GIM_Try, /*On fail goto*//*Label 17362*/ GIMT_Encode4(1195450), // Rule ID 16877 //
     /* 1195375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1195378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub),
     /* 1195383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1195386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1195389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1195392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1195395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1195410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1195414 */     // MIs[0] round
     /* 1195414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11194:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64),
     /* 1195427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1195445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195449 */     // GIR_Coverage, 16877,
     /* 1195449 */     GIR_EraseRootFromParent_Done,
     /* 1195450 */   // Label 17362: @1195450
     /* 1195450 */   GIM_Try, /*On fail goto*//*Label 17363*/ GIMT_Encode4(1195530), // Rule ID 16880 //
     /* 1195455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1195458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1195475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195494 */     // MIs[0] round
     /* 1195494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1195507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195529 */     // GIR_Coverage, 16880,
     /* 1195529 */     GIR_EraseRootFromParent_Done,
     /* 1195530 */   // Label 17363: @1195530
     /* 1195530 */   GIM_Try, /*On fail goto*//*Label 17364*/ GIMT_Encode4(1195610), // Rule ID 16881 //
     /* 1195535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1195538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1195546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1195549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1195552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1195555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195574 */     // MIs[0] round
     /* 1195574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16),
     /* 1195587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195609 */     // GIR_Coverage, 16881,
     /* 1195609 */     GIR_EraseRootFromParent_Done,
     /* 1195610 */   // Label 17364: @1195610
     /* 1195610 */   GIM_Try, /*On fail goto*//*Label 17365*/ GIMT_Encode4(1195690), // Rule ID 16884 //
     /* 1195615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1195618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1195635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195654 */     // MIs[0] round
     /* 1195654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195664 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1195667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195689 */     // GIR_Coverage, 16884,
     /* 1195689 */     GIR_EraseRootFromParent_Done,
     /* 1195690 */   // Label 17365: @1195690
     /* 1195690 */   GIM_Try, /*On fail goto*//*Label 17366*/ GIMT_Encode4(1195770), // Rule ID 16885 //
     /* 1195695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1195698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1195706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1195709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1195712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1195715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195734 */     // MIs[0] round
     /* 1195734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195744 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16),
     /* 1195747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195769 */     // GIR_Coverage, 16885,
     /* 1195769 */     GIR_EraseRootFromParent_Done,
     /* 1195770 */   // Label 17366: @1195770
     /* 1195770 */   GIM_Try, /*On fail goto*//*Label 17367*/ GIMT_Encode4(1195850), // Rule ID 16888 //
     /* 1195775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1195778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1195786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1195789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1195795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195814 */     // MIs[0] round
     /* 1195814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1195827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195849 */     // GIR_Coverage, 16888,
     /* 1195849 */     GIR_EraseRootFromParent_Done,
     /* 1195850 */   // Label 17367: @1195850
     /* 1195850 */   GIM_Try, /*On fail goto*//*Label 17368*/ GIMT_Encode4(1195930), // Rule ID 16889 //
     /* 1195855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1195858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1195866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1195869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1195872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1195875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1195878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1195894 */     // MIs[0] round
     /* 1195894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1195904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16),
     /* 1195907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1195922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1195925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1195928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1195929 */     // GIR_Coverage, 16889,
     /* 1195929 */     GIR_EraseRootFromParent_Done,
     /* 1195930 */   // Label 17368: @1195930
     /* 1195930 */   GIM_Try, /*On fail goto*//*Label 17369*/ GIMT_Encode4(1196010), // Rule ID 16892 //
     /* 1195935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1195938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1195943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1195946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1195949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1195952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1195955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1195958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1195966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1195974 */     // MIs[0] round
     /* 1195974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1195977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1195984 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1195984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1195987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1195989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1195991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1195993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1195995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1195997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196009 */     // GIR_Coverage, 16892,
     /* 1196009 */     GIR_EraseRootFromParent_Done,
     /* 1196010 */   // Label 17369: @1196010
     /* 1196010 */   GIM_Try, /*On fail goto*//*Label 17370*/ GIMT_Encode4(1196090), // Rule ID 16893 //
     /* 1196015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1196018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1196026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1196029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1196032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1196035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196054 */     // MIs[0] round
     /* 1196054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196064 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16),
     /* 1196067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196089 */     // GIR_Coverage, 16893,
     /* 1196089 */     GIR_EraseRootFromParent_Done,
     /* 1196090 */   // Label 17370: @1196090
     /* 1196090 */   GIM_Try, /*On fail goto*//*Label 17371*/ GIMT_Encode4(1196170), // Rule ID 16896 //
     /* 1196095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1196098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1196115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196134 */     // MIs[0] round
     /* 1196134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196144 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1196147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196169 */     // GIR_Coverage, 16896,
     /* 1196169 */     GIR_EraseRootFromParent_Done,
     /* 1196170 */   // Label 17371: @1196170
     /* 1196170 */   GIM_Try, /*On fail goto*//*Label 17372*/ GIMT_Encode4(1196250), // Rule ID 16897 //
     /* 1196175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1196178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1196186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1196189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1196192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1196195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196214 */     // MIs[0] round
     /* 1196214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196224 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16),
     /* 1196227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196249 */     // GIR_Coverage, 16897,
     /* 1196249 */     GIR_EraseRootFromParent_Done,
     /* 1196250 */   // Label 17372: @1196250
     /* 1196250 */   GIM_Try, /*On fail goto*//*Label 17373*/ GIMT_Encode4(1196330), // Rule ID 16900 //
     /* 1196255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1196258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1196275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196294 */     // MIs[0] round
     /* 1196294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196304 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1196307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196329 */     // GIR_Coverage, 16900,
     /* 1196329 */     GIR_EraseRootFromParent_Done,
     /* 1196330 */   // Label 17373: @1196330
     /* 1196330 */   GIM_Try, /*On fail goto*//*Label 17374*/ GIMT_Encode4(1196410), // Rule ID 16901 //
     /* 1196335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1196338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1196346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1196349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1196352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1196355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196374 */     // MIs[0] round
     /* 1196374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196384 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32),
     /* 1196387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196409 */     // GIR_Coverage, 16901,
     /* 1196409 */     GIR_EraseRootFromParent_Done,
     /* 1196410 */   // Label 17374: @1196410
     /* 1196410 */   GIM_Try, /*On fail goto*//*Label 17375*/ GIMT_Encode4(1196490), // Rule ID 16904 //
     /* 1196415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1196418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1196426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1196429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1196435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196454 */     // MIs[0] round
     /* 1196454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196464 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1196467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196489 */     // GIR_Coverage, 16904,
     /* 1196489 */     GIR_EraseRootFromParent_Done,
     /* 1196490 */   // Label 17375: @1196490
     /* 1196490 */   GIM_Try, /*On fail goto*//*Label 17376*/ GIMT_Encode4(1196570), // Rule ID 16905 //
     /* 1196495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1196498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1196506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1196509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1196512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1196515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196534 */     // MIs[0] round
     /* 1196534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196544 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32),
     /* 1196547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196569 */     // GIR_Coverage, 16905,
     /* 1196569 */     GIR_EraseRootFromParent_Done,
     /* 1196570 */   // Label 17376: @1196570
     /* 1196570 */   GIM_Try, /*On fail goto*//*Label 17377*/ GIMT_Encode4(1196650), // Rule ID 16908 //
     /* 1196575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1196578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1196586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1196589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1196595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196614 */     // MIs[0] round
     /* 1196614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1196627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196649 */     // GIR_Coverage, 16908,
     /* 1196649 */     GIR_EraseRootFromParent_Done,
     /* 1196650 */   // Label 17377: @1196650
     /* 1196650 */   GIM_Try, /*On fail goto*//*Label 17378*/ GIMT_Encode4(1196730), // Rule ID 16909 //
     /* 1196655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1196658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1196666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1196669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1196672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1196675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1196694 */     // MIs[0] round
     /* 1196694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196704 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32),
     /* 1196707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196729 */     // GIR_Coverage, 16909,
     /* 1196729 */     GIR_EraseRootFromParent_Done,
     /* 1196730 */   // Label 17378: @1196730
     /* 1196730 */   GIM_Try, /*On fail goto*//*Label 17379*/ GIMT_Encode4(1196810), // Rule ID 16912 //
     /* 1196735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1196738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1196746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1196749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1196755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196774 */     // MIs[0] round
     /* 1196774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1196787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196809 */     // GIR_Coverage, 16912,
     /* 1196809 */     GIR_EraseRootFromParent_Done,
     /* 1196810 */   // Label 17379: @1196810
     /* 1196810 */   GIM_Try, /*On fail goto*//*Label 17380*/ GIMT_Encode4(1196890), // Rule ID 16913 //
     /* 1196815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1196818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1196826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1196829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1196832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1196835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1196846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1196854 */     // MIs[0] round
     /* 1196854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196864 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1196864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32),
     /* 1196867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1196885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196889 */     // GIR_Coverage, 16913,
     /* 1196889 */     GIR_EraseRootFromParent_Done,
     /* 1196890 */   // Label 17380: @1196890
     /* 1196890 */   GIM_Try, /*On fail goto*//*Label 17381*/ GIMT_Encode4(1196970), // Rule ID 16916 //
     /* 1196895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1196898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1196912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1196918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1196930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1196934 */     // MIs[0] round
     /* 1196934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1196937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1196944 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1196944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1196947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1196949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1196951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1196953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1196955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1196957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1196962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1196965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1196968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1196969 */     // GIR_Coverage, 16916,
     /* 1196969 */     GIR_EraseRootFromParent_Done,
     /* 1196970 */   // Label 17381: @1196970
     /* 1196970 */   GIM_Try, /*On fail goto*//*Label 17382*/ GIMT_Encode4(1197050), // Rule ID 16917 //
     /* 1196975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1196978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1196983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1196986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1196989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1196992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1196995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1196998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197014 */     // MIs[0] round
     /* 1197014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16),
     /* 1197027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197049 */     // GIR_Coverage, 16917,
     /* 1197049 */     GIR_EraseRootFromParent_Done,
     /* 1197050 */   // Label 17382: @1197050
     /* 1197050 */   GIM_Try, /*On fail goto*//*Label 17383*/ GIMT_Encode4(1197130), // Rule ID 16920 //
     /* 1197055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1197058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1197066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1197069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197094 */     // MIs[0] round
     /* 1197094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1197107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197129 */     // GIR_Coverage, 16920,
     /* 1197129 */     GIR_EraseRootFromParent_Done,
     /* 1197130 */   // Label 17383: @1197130
     /* 1197130 */   GIM_Try, /*On fail goto*//*Label 17384*/ GIMT_Encode4(1197210), // Rule ID 16921 //
     /* 1197135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1197138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1197146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1197149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1197152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197174 */     // MIs[0] round
     /* 1197174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11210:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16),
     /* 1197187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197209 */     // GIR_Coverage, 16921,
     /* 1197209 */     GIR_EraseRootFromParent_Done,
     /* 1197210 */   // Label 17384: @1197210
     /* 1197210 */   GIM_Try, /*On fail goto*//*Label 17385*/ GIMT_Encode4(1197290), // Rule ID 16924 //
     /* 1197215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1197218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197254 */     // MIs[0] round
     /* 1197254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197264 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1197267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197289 */     // GIR_Coverage, 16924,
     /* 1197289 */     GIR_EraseRootFromParent_Done,
     /* 1197290 */   // Label 17385: @1197290
     /* 1197290 */   GIM_Try, /*On fail goto*//*Label 17386*/ GIMT_Encode4(1197370), // Rule ID 16925 //
     /* 1197295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1197298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1197306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1197309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1197312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197334 */     // MIs[0] round
     /* 1197334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197344 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16),
     /* 1197347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197369 */     // GIR_Coverage, 16925,
     /* 1197369 */     GIR_EraseRootFromParent_Done,
     /* 1197370 */   // Label 17386: @1197370
     /* 1197370 */   GIM_Try, /*On fail goto*//*Label 17387*/ GIMT_Encode4(1197450), // Rule ID 16928 //
     /* 1197375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1197378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1197392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197414 */     // MIs[0] round
     /* 1197414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197424 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1197427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197449 */     // GIR_Coverage, 16928,
     /* 1197449 */     GIR_EraseRootFromParent_Done,
     /* 1197450 */   // Label 17387: @1197450
     /* 1197450 */   GIM_Try, /*On fail goto*//*Label 17388*/ GIMT_Encode4(1197530), // Rule ID 16929 //
     /* 1197455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1197458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1197466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1197469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1197472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197494 */     // MIs[0] round
     /* 1197494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197504 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16),
     /* 1197507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197529 */     // GIR_Coverage, 16929,
     /* 1197529 */     GIR_EraseRootFromParent_Done,
     /* 1197530 */   // Label 17388: @1197530
     /* 1197530 */   GIM_Try, /*On fail goto*//*Label 17389*/ GIMT_Encode4(1197610), // Rule ID 16932 //
     /* 1197535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1197538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197574 */     // MIs[0] round
     /* 1197574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197584 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1197587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197609 */     // GIR_Coverage, 16932,
     /* 1197609 */     GIR_EraseRootFromParent_Done,
     /* 1197610 */   // Label 17389: @1197610
     /* 1197610 */   GIM_Try, /*On fail goto*//*Label 17390*/ GIMT_Encode4(1197690), // Rule ID 16933 //
     /* 1197615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1197618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1197626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1197629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1197632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1197635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1197646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1197650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1197654 */     // MIs[0] round
     /* 1197654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197664 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16),
     /* 1197667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1197685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197689 */     // GIR_Coverage, 16933,
     /* 1197689 */     GIR_EraseRootFromParent_Done,
     /* 1197690 */   // Label 17390: @1197690
     /* 1197690 */   GIM_Try, /*On fail goto*//*Label 17391*/ GIMT_Encode4(1197770), // Rule ID 16936 //
     /* 1197695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1197698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1197706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1197709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197734 */     // MIs[0] round
     /* 1197734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1197747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197769 */     // GIR_Coverage, 16936,
     /* 1197769 */     GIR_EraseRootFromParent_Done,
     /* 1197770 */   // Label 17391: @1197770
     /* 1197770 */   GIM_Try, /*On fail goto*//*Label 17392*/ GIMT_Encode4(1197850), // Rule ID 16937 //
     /* 1197775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1197778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1197786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1197789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1197792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197814 */     // MIs[0] round
     /* 1197814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197824 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11210:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32),
     /* 1197827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197849 */     // GIR_Coverage, 16937,
     /* 1197849 */     GIR_EraseRootFromParent_Done,
     /* 1197850 */   // Label 17392: @1197850
     /* 1197850 */   GIM_Try, /*On fail goto*//*Label 17393*/ GIMT_Encode4(1197930), // Rule ID 16940 //
     /* 1197855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1197858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1197878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197894 */     // MIs[0] round
     /* 1197894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1197904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1197907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1197922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1197925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1197928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1197929 */     // GIR_Coverage, 16940,
     /* 1197929 */     GIR_EraseRootFromParent_Done,
     /* 1197930 */   // Label 17393: @1197930
     /* 1197930 */   GIM_Try, /*On fail goto*//*Label 17394*/ GIMT_Encode4(1198010), // Rule ID 16941 //
     /* 1197935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1197938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1197943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1197946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1197949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1197952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1197955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1197958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1197966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1197970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1197974 */     // MIs[0] round
     /* 1197974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1197977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1197984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11210:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1197984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32),
     /* 1197987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1197989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1197991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1197993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1197995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1197997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198009 */     // GIR_Coverage, 16941,
     /* 1198009 */     GIR_EraseRootFromParent_Done,
     /* 1198010 */   // Label 17394: @1198010
     /* 1198010 */   GIM_Try, /*On fail goto*//*Label 17395*/ GIMT_Encode4(1198090), // Rule ID 16944 //
     /* 1198015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1198018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1198023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1198026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1198029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198054 */     // MIs[0] round
     /* 1198054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198064 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1198067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198089 */     // GIR_Coverage, 16944,
     /* 1198089 */     GIR_EraseRootFromParent_Done,
     /* 1198090 */   // Label 17395: @1198090
     /* 1198090 */   GIM_Try, /*On fail goto*//*Label 17396*/ GIMT_Encode4(1198170), // Rule ID 16945 //
     /* 1198095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1198098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1198103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1198106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1198109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1198112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198134 */     // MIs[0] round
     /* 1198134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11210:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32),
     /* 1198147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198169 */     // GIR_Coverage, 16945,
     /* 1198169 */     GIR_EraseRootFromParent_Done,
     /* 1198170 */   // Label 17396: @1198170
     /* 1198170 */   GIM_Try, /*On fail goto*//*Label 17397*/ GIMT_Encode4(1198250), // Rule ID 16948 //
     /* 1198175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1198178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1198183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1198192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198214 */     // MIs[0] round
     /* 1198214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198224 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1198227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198249 */     // GIR_Coverage, 16948,
     /* 1198249 */     GIR_EraseRootFromParent_Done,
     /* 1198250 */   // Label 17397: @1198250
     /* 1198250 */   GIM_Try, /*On fail goto*//*Label 17398*/ GIMT_Encode4(1198330), // Rule ID 16949 //
     /* 1198255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1198258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd),
     /* 1198263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1198266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1198269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1198272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1198275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1198286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1198294 */     // MIs[0] round
     /* 1198294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198304 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11210:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32),
     /* 1198307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1198325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198329 */     // GIR_Coverage, 16949,
     /* 1198329 */     GIR_EraseRootFromParent_Done,
     /* 1198330 */   // Label 17398: @1198330
     /* 1198330 */   GIM_Try, /*On fail goto*//*Label 17399*/ GIMT_Encode4(1198410), // Rule ID 16952 //
     /* 1198335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1198338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1198355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198374 */     // MIs[0] round
     /* 1198374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1198387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198409 */     // GIR_Coverage, 16952,
     /* 1198409 */     GIR_EraseRootFromParent_Done,
     /* 1198410 */   // Label 17399: @1198410
     /* 1198410 */   GIM_Try, /*On fail goto*//*Label 17400*/ GIMT_Encode4(1198490), // Rule ID 16953 //
     /* 1198415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1198418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1198426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1198429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1198432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1198435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198454 */     // MIs[0] round
     /* 1198454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198464 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16),
     /* 1198467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198489 */     // GIR_Coverage, 16953,
     /* 1198489 */     GIR_EraseRootFromParent_Done,
     /* 1198490 */   // Label 17400: @1198490
     /* 1198490 */   GIM_Try, /*On fail goto*//*Label 17401*/ GIMT_Encode4(1198570), // Rule ID 16956 //
     /* 1198495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1198498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1198515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198534 */     // MIs[0] round
     /* 1198534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1198547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198569 */     // GIR_Coverage, 16956,
     /* 1198569 */     GIR_EraseRootFromParent_Done,
     /* 1198570 */   // Label 17401: @1198570
     /* 1198570 */   GIM_Try, /*On fail goto*//*Label 17402*/ GIMT_Encode4(1198650), // Rule ID 16957 //
     /* 1198575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1198578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1198586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1198589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1198592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1198595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198614 */     // MIs[0] round
     /* 1198614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16),
     /* 1198627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198649 */     // GIR_Coverage, 16957,
     /* 1198649 */     GIR_EraseRootFromParent_Done,
     /* 1198650 */   // Label 17402: @1198650
     /* 1198650 */   GIM_Try, /*On fail goto*//*Label 17403*/ GIMT_Encode4(1198730), // Rule ID 16960 //
     /* 1198655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1198658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1198675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198694 */     // MIs[0] round
     /* 1198694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1198707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198729 */     // GIR_Coverage, 16960,
     /* 1198729 */     GIR_EraseRootFromParent_Done,
     /* 1198730 */   // Label 17403: @1198730
     /* 1198730 */   GIM_Try, /*On fail goto*//*Label 17404*/ GIMT_Encode4(1198810), // Rule ID 16961 //
     /* 1198735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1198738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1198746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1198749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1198752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1198755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1198774 */     // MIs[0] round
     /* 1198774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16),
     /* 1198787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198809 */     // GIR_Coverage, 16961,
     /* 1198809 */     GIR_EraseRootFromParent_Done,
     /* 1198810 */   // Label 17404: @1198810
     /* 1198810 */   GIM_Try, /*On fail goto*//*Label 17405*/ GIMT_Encode4(1198890), // Rule ID 16964 //
     /* 1198815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1198818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1198826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1198829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1198835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198854 */     // MIs[0] round
     /* 1198854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198864 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1198864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1198867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198889 */     // GIR_Coverage, 16964,
     /* 1198889 */     GIR_EraseRootFromParent_Done,
     /* 1198890 */   // Label 17405: @1198890
     /* 1198890 */   GIM_Try, /*On fail goto*//*Label 17406*/ GIMT_Encode4(1198970), // Rule ID 16965 //
     /* 1198895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1198898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1198906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1198909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1198912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1198915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1198918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1198926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1198934 */     // MIs[0] round
     /* 1198934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1198937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1198944 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1198944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16),
     /* 1198947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1198949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1198951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1198953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1198955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1198957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1198962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1198965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1198968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1198969 */     // GIR_Coverage, 16965,
     /* 1198969 */     GIR_EraseRootFromParent_Done,
     /* 1198970 */   // Label 17406: @1198970
     /* 1198970 */   GIM_Try, /*On fail goto*//*Label 17407*/ GIMT_Encode4(1199050), // Rule ID 16968 //
     /* 1198975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1198978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1198983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1198986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1198989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1198992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1198995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1198998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199014 */     // MIs[0] round
     /* 1199014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199024 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1199027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199049 */     // GIR_Coverage, 16968,
     /* 1199049 */     GIR_EraseRootFromParent_Done,
     /* 1199050 */   // Label 17407: @1199050
     /* 1199050 */   GIM_Try, /*On fail goto*//*Label 17408*/ GIMT_Encode4(1199130), // Rule ID 16969 //
     /* 1199055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1199058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1199066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1199069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1199072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1199075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199094 */     // MIs[0] round
     /* 1199094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199104 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16),
     /* 1199107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199129 */     // GIR_Coverage, 16969,
     /* 1199129 */     GIR_EraseRootFromParent_Done,
     /* 1199130 */   // Label 17408: @1199130
     /* 1199130 */   GIM_Try, /*On fail goto*//*Label 17409*/ GIMT_Encode4(1199210), // Rule ID 16972 //
     /* 1199135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1199138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1199152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1199155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199174 */     // MIs[0] round
     /* 1199174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199184 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1199187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199209 */     // GIR_Coverage, 16972,
     /* 1199209 */     GIR_EraseRootFromParent_Done,
     /* 1199210 */   // Label 17409: @1199210
     /* 1199210 */   GIM_Try, /*On fail goto*//*Label 17410*/ GIMT_Encode4(1199290), // Rule ID 16973 //
     /* 1199215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1199218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1199226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1199229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1199232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1199235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199254 */     // MIs[0] round
     /* 1199254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199264 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32),
     /* 1199267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199289 */     // GIR_Coverage, 16973,
     /* 1199289 */     GIR_EraseRootFromParent_Done,
     /* 1199290 */   // Label 17410: @1199290
     /* 1199290 */   GIM_Try, /*On fail goto*//*Label 17411*/ GIMT_Encode4(1199370), // Rule ID 16976 //
     /* 1199295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1199298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1199312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1199315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199334 */     // MIs[0] round
     /* 1199334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1199347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199369 */     // GIR_Coverage, 16976,
     /* 1199369 */     GIR_EraseRootFromParent_Done,
     /* 1199370 */   // Label 17411: @1199370
     /* 1199370 */   GIM_Try, /*On fail goto*//*Label 17412*/ GIMT_Encode4(1199450), // Rule ID 16977 //
     /* 1199375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1199378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1199386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1199389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1199392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1199395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199414 */     // MIs[0] round
     /* 1199414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32),
     /* 1199427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199449 */     // GIR_Coverage, 16977,
     /* 1199449 */     GIR_EraseRootFromParent_Done,
     /* 1199450 */   // Label 17412: @1199450
     /* 1199450 */   GIM_Try, /*On fail goto*//*Label 17413*/ GIMT_Encode4(1199530), // Rule ID 16980 //
     /* 1199455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1199458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1199475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199494 */     // MIs[0] round
     /* 1199494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199504 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1199507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199529 */     // GIR_Coverage, 16980,
     /* 1199529 */     GIR_EraseRootFromParent_Done,
     /* 1199530 */   // Label 17413: @1199530
     /* 1199530 */   GIM_Try, /*On fail goto*//*Label 17414*/ GIMT_Encode4(1199610), // Rule ID 16981 //
     /* 1199535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1199538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1199546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1199549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1199552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1199555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1199574 */     // MIs[0] round
     /* 1199574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199584 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32),
     /* 1199587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199609 */     // GIR_Coverage, 16981,
     /* 1199609 */     GIR_EraseRootFromParent_Done,
     /* 1199610 */   // Label 17414: @1199610
     /* 1199610 */   GIM_Try, /*On fail goto*//*Label 17415*/ GIMT_Encode4(1199690), // Rule ID 16984 //
     /* 1199615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1199618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1199635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199654 */     // MIs[0] round
     /* 1199654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1199667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199689 */     // GIR_Coverage, 16984,
     /* 1199689 */     GIR_EraseRootFromParent_Done,
     /* 1199690 */   // Label 17415: @1199690
     /* 1199690 */   GIM_Try, /*On fail goto*//*Label 17416*/ GIMT_Encode4(1199770), // Rule ID 16985 //
     /* 1199695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1199698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1199706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1199709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1199712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1199715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1199726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1199734 */     // MIs[0] round
     /* 1199734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199744 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32),
     /* 1199747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1199765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199769 */     // GIR_Coverage, 16985,
     /* 1199769 */     GIR_EraseRootFromParent_Done,
     /* 1199770 */   // Label 17416: @1199770
     /* 1199770 */   GIM_Try, /*On fail goto*//*Label 17417*/ GIMT_Encode4(1199850), // Rule ID 16988 //
     /* 1199775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1199778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199814 */     // MIs[0] round
     /* 1199814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199824 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1199827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199849 */     // GIR_Coverage, 16988,
     /* 1199849 */     GIR_EraseRootFromParent_Done,
     /* 1199850 */   // Label 17417: @1199850
     /* 1199850 */   GIM_Try, /*On fail goto*//*Label 17418*/ GIMT_Encode4(1199930), // Rule ID 16989 //
     /* 1199855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1199858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1199866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1199869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1199872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1199878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199894 */     // MIs[0] round
     /* 1199894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199904 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1199904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16),
     /* 1199907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1199922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1199925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1199928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1199929 */     // GIR_Coverage, 16989,
     /* 1199929 */     GIR_EraseRootFromParent_Done,
     /* 1199930 */   // Label 17418: @1199930
     /* 1199930 */   GIM_Try, /*On fail goto*//*Label 17419*/ GIMT_Encode4(1200010), // Rule ID 16992 //
     /* 1199935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1199938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1199943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1199946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1199949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1199952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1199955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1199958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1199970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1199974 */     // MIs[0] round
     /* 1199974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1199977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1199984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1199984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1199987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1199989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1199991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1199993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1199995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1199997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200009 */     // GIR_Coverage, 16992,
     /* 1200009 */     GIR_EraseRootFromParent_Done,
     /* 1200010 */   // Label 17419: @1200010
     /* 1200010 */   GIM_Try, /*On fail goto*//*Label 17420*/ GIMT_Encode4(1200090), // Rule ID 16993 //
     /* 1200015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1200026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1200029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1200032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200054 */     // MIs[0] round
     /* 1200054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11246:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16),
     /* 1200067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200089 */     // GIR_Coverage, 16993,
     /* 1200089 */     GIR_EraseRootFromParent_Done,
     /* 1200090 */   // Label 17420: @1200090
     /* 1200090 */   GIM_Try, /*On fail goto*//*Label 17421*/ GIMT_Encode4(1200170), // Rule ID 16996 //
     /* 1200095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200134 */     // MIs[0] round
     /* 1200134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1200147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200169 */     // GIR_Coverage, 16996,
     /* 1200169 */     GIR_EraseRootFromParent_Done,
     /* 1200170 */   // Label 17421: @1200170
     /* 1200170 */   GIM_Try, /*On fail goto*//*Label 17422*/ GIMT_Encode4(1200250), // Rule ID 16997 //
     /* 1200175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1200186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1200189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1200192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200214 */     // MIs[0] round
     /* 1200214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200224 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16),
     /* 1200227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200249 */     // GIR_Coverage, 16997,
     /* 1200249 */     GIR_EraseRootFromParent_Done,
     /* 1200250 */   // Label 17422: @1200250
     /* 1200250 */   GIM_Try, /*On fail goto*//*Label 17423*/ GIMT_Encode4(1200330), // Rule ID 17000 //
     /* 1200255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200294 */     // MIs[0] round
     /* 1200294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200304 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1200307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200329 */     // GIR_Coverage, 17000,
     /* 1200329 */     GIR_EraseRootFromParent_Done,
     /* 1200330 */   // Label 17423: @1200330
     /* 1200330 */   GIM_Try, /*On fail goto*//*Label 17424*/ GIMT_Encode4(1200410), // Rule ID 17001 //
     /* 1200335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1200346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1200349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1200352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200374 */     // MIs[0] round
     /* 1200374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200384 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16),
     /* 1200387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200409 */     // GIR_Coverage, 17001,
     /* 1200409 */     GIR_EraseRootFromParent_Done,
     /* 1200410 */   // Label 17424: @1200410
     /* 1200410 */   GIM_Try, /*On fail goto*//*Label 17425*/ GIMT_Encode4(1200490), // Rule ID 17004 //
     /* 1200415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1200418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200454 */     // MIs[0] round
     /* 1200454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200464 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1200467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200489 */     // GIR_Coverage, 17004,
     /* 1200489 */     GIR_EraseRootFromParent_Done,
     /* 1200490 */   // Label 17425: @1200490
     /* 1200490 */   GIM_Try, /*On fail goto*//*Label 17426*/ GIMT_Encode4(1200570), // Rule ID 17005 //
     /* 1200495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1200498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1200506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1200509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1200512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1200515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1200526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1200534 */     // MIs[0] round
     /* 1200534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200544 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16),
     /* 1200547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1200565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200569 */     // GIR_Coverage, 17005,
     /* 1200569 */     GIR_EraseRootFromParent_Done,
     /* 1200570 */   // Label 17426: @1200570
     /* 1200570 */   GIM_Try, /*On fail goto*//*Label 17427*/ GIMT_Encode4(1200650), // Rule ID 17008 //
     /* 1200575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200614 */     // MIs[0] round
     /* 1200614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200624 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1200627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200649 */     // GIR_Coverage, 17008,
     /* 1200649 */     GIR_EraseRootFromParent_Done,
     /* 1200650 */   // Label 17427: @1200650
     /* 1200650 */   GIM_Try, /*On fail goto*//*Label 17428*/ GIMT_Encode4(1200730), // Rule ID 17009 //
     /* 1200655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1200658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1200666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1200669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1200672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200694 */     // MIs[0] round
     /* 1200694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11246:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32),
     /* 1200707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200729 */     // GIR_Coverage, 17009,
     /* 1200729 */     GIR_EraseRootFromParent_Done,
     /* 1200730 */   // Label 17428: @1200730
     /* 1200730 */   GIM_Try, /*On fail goto*//*Label 17429*/ GIMT_Encode4(1200810), // Rule ID 17012 //
     /* 1200735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1200752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200774 */     // MIs[0] round
     /* 1200774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1200787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200809 */     // GIR_Coverage, 17012,
     /* 1200809 */     GIR_EraseRootFromParent_Done,
     /* 1200810 */   // Label 17429: @1200810
     /* 1200810 */   GIM_Try, /*On fail goto*//*Label 17430*/ GIMT_Encode4(1200890), // Rule ID 17013 //
     /* 1200815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1200818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1200826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1200829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1200832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1200850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200854 */     // MIs[0] round
     /* 1200854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11246:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1200864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32),
     /* 1200867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200889 */     // GIR_Coverage, 17013,
     /* 1200889 */     GIR_EraseRootFromParent_Done,
     /* 1200890 */   // Label 17430: @1200890
     /* 1200890 */   GIM_Try, /*On fail goto*//*Label 17431*/ GIMT_Encode4(1200970), // Rule ID 17016 //
     /* 1200895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1200898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1200912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1200918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1200926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1200930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1200934 */     // MIs[0] round
     /* 1200934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1200937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1200944 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1200944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1200947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1200949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1200951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1200953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1200955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1200957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1200962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1200965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1200968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1200969 */     // GIR_Coverage, 17016,
     /* 1200969 */     GIR_EraseRootFromParent_Done,
     /* 1200970 */   // Label 17431: @1200970
     /* 1200970 */   GIM_Try, /*On fail goto*//*Label 17432*/ GIMT_Encode4(1201050), // Rule ID 17017 //
     /* 1200975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1200978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1200983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1200986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1200989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1200992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1200995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1200998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1201014 */     // MIs[0] round
     /* 1201014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201024 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11246:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32),
     /* 1201027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201049 */     // GIR_Coverage, 17017,
     /* 1201049 */     GIR_EraseRootFromParent_Done,
     /* 1201050 */   // Label 17432: @1201050
     /* 1201050 */   GIM_Try, /*On fail goto*//*Label 17433*/ GIMT_Encode4(1201130), // Rule ID 17020 //
     /* 1201055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1201063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1201094 */     // MIs[0] round
     /* 1201094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1201107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201129 */     // GIR_Coverage, 17020,
     /* 1201129 */     GIR_EraseRootFromParent_Done,
     /* 1201130 */   // Label 17433: @1201130
     /* 1201130 */   GIM_Try, /*On fail goto*//*Label 17434*/ GIMT_Encode4(1201210), // Rule ID 17021 //
     /* 1201135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub),
     /* 1201143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1201146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1201149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1201155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1201174 */     // MIs[0] round
     /* 1201174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11246:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32),
     /* 1201187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201209 */     // GIR_Coverage, 17021,
     /* 1201209 */     GIR_EraseRootFromParent_Done,
     /* 1201210 */   // Label 17434: @1201210
     /* 1201210 */   GIM_Try, /*On fail goto*//*Label 17435*/ GIMT_Encode4(1201290), // Rule ID 17026 //
     /* 1201215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1201235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201254 */     // MIs[0] round
     /* 1201254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1201267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201289 */     // GIR_Coverage, 17026,
     /* 1201289 */     GIR_EraseRootFromParent_Done,
     /* 1201290 */   // Label 17435: @1201290
     /* 1201290 */   GIM_Try, /*On fail goto*//*Label 17436*/ GIMT_Encode4(1201370), // Rule ID 17027 //
     /* 1201295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1201306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1201309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1201312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1201315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201334 */     // MIs[0] round
     /* 1201334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16),
     /* 1201347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201369 */     // GIR_Coverage, 17027,
     /* 1201369 */     GIR_EraseRootFromParent_Done,
     /* 1201370 */   // Label 17436: @1201370
     /* 1201370 */   GIM_Try, /*On fail goto*//*Label 17437*/ GIMT_Encode4(1201450), // Rule ID 17036 //
     /* 1201375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1201395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201414 */     // MIs[0] round
     /* 1201414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201424 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1201427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201449 */     // GIR_Coverage, 17036,
     /* 1201449 */     GIR_EraseRootFromParent_Done,
     /* 1201450 */   // Label 17437: @1201450
     /* 1201450 */   GIM_Try, /*On fail goto*//*Label 17438*/ GIMT_Encode4(1201530), // Rule ID 17037 //
     /* 1201455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1201466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1201469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1201472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1201475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201494 */     // MIs[0] round
     /* 1201494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16),
     /* 1201507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201529 */     // GIR_Coverage, 17037,
     /* 1201529 */     GIR_EraseRootFromParent_Done,
     /* 1201530 */   // Label 17438: @1201530
     /* 1201530 */   GIM_Try, /*On fail goto*//*Label 17439*/ GIMT_Encode4(1201610), // Rule ID 17046 //
     /* 1201535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201574 */     // MIs[0] round
     /* 1201574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201584 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1201587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201609 */     // GIR_Coverage, 17046,
     /* 1201609 */     GIR_EraseRootFromParent_Done,
     /* 1201610 */   // Label 17439: @1201610
     /* 1201610 */   GIM_Try, /*On fail goto*//*Label 17440*/ GIMT_Encode4(1201690), // Rule ID 17047 //
     /* 1201615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1201626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1201629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1201632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1201635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1201654 */     // MIs[0] round
     /* 1201654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201664 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16),
     /* 1201667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201689 */     // GIR_Coverage, 17047,
     /* 1201689 */     GIR_EraseRootFromParent_Done,
     /* 1201690 */   // Label 17440: @1201690
     /* 1201690 */   GIM_Try, /*On fail goto*//*Label 17441*/ GIMT_Encode4(1201770), // Rule ID 17056 //
     /* 1201695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1201698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1201712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201734 */     // MIs[0] round
     /* 1201734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1201747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201769 */     // GIR_Coverage, 17056,
     /* 1201769 */     GIR_EraseRootFromParent_Done,
     /* 1201770 */   // Label 17441: @1201770
     /* 1201770 */   GIM_Try, /*On fail goto*//*Label 17442*/ GIMT_Encode4(1201850), // Rule ID 17057 //
     /* 1201775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1201778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1201786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1201789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1201792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1201795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1201810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1201814 */     // MIs[0] round
     /* 1201814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201824 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16),
     /* 1201827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1201845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201849 */     // GIR_Coverage, 17057,
     /* 1201849 */     GIR_EraseRootFromParent_Done,
     /* 1201850 */   // Label 17442: @1201850
     /* 1201850 */   GIM_Try, /*On fail goto*//*Label 17443*/ GIMT_Encode4(1201930), // Rule ID 17066 //
     /* 1201855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1201858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1201872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1201878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201894 */     // MIs[0] round
     /* 1201894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1201904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1201907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1201922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1201925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1201928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1201929 */     // GIR_Coverage, 17066,
     /* 1201929 */     GIR_EraseRootFromParent_Done,
     /* 1201930 */   // Label 17443: @1201930
     /* 1201930 */   GIM_Try, /*On fail goto*//*Label 17444*/ GIMT_Encode4(1202010), // Rule ID 17067 //
     /* 1201935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1201938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1201943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1201946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1201949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1201952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1201955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1201958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1201974 */     // MIs[0] round
     /* 1201974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1201977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1201984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1201984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32),
     /* 1201987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1201989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1201991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1201993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1201995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1201997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202009 */     // GIR_Coverage, 17067,
     /* 1202009 */     GIR_EraseRootFromParent_Done,
     /* 1202010 */   // Label 17444: @1202010
     /* 1202010 */   GIM_Try, /*On fail goto*//*Label 17445*/ GIMT_Encode4(1202090), // Rule ID 17076 //
     /* 1202015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1202032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1202035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202054 */     // MIs[0] round
     /* 1202054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202064 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1202067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202089 */     // GIR_Coverage, 17076,
     /* 1202089 */     GIR_EraseRootFromParent_Done,
     /* 1202090 */   // Label 17445: @1202090
     /* 1202090 */   GIM_Try, /*On fail goto*//*Label 17446*/ GIMT_Encode4(1202170), // Rule ID 17077 //
     /* 1202095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1202106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1202109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1202112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1202115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202134 */     // MIs[0] round
     /* 1202134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202144 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32),
     /* 1202147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202169 */     // GIR_Coverage, 17077,
     /* 1202169 */     GIR_EraseRootFromParent_Done,
     /* 1202170 */   // Label 17446: @1202170
     /* 1202170 */   GIM_Try, /*On fail goto*//*Label 17447*/ GIMT_Encode4(1202250), // Rule ID 17086 //
     /* 1202175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1202192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1202195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202214 */     // MIs[0] round
     /* 1202214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1202227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202249 */     // GIR_Coverage, 17086,
     /* 1202249 */     GIR_EraseRootFromParent_Done,
     /* 1202250 */   // Label 17447: @1202250
     /* 1202250 */   GIM_Try, /*On fail goto*//*Label 17448*/ GIMT_Encode4(1202330), // Rule ID 17087 //
     /* 1202255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1202266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1202269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1202272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1202275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202294 */     // MIs[0] round
     /* 1202294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202304 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32),
     /* 1202307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202329 */     // GIR_Coverage, 17087,
     /* 1202329 */     GIR_EraseRootFromParent_Done,
     /* 1202330 */   // Label 17448: @1202330
     /* 1202330 */   GIM_Try, /*On fail goto*//*Label 17449*/ GIMT_Encode4(1202410), // Rule ID 17096 //
     /* 1202335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1202338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1202352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1202355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202374 */     // MIs[0] round
     /* 1202374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202384 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1202387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202409 */     // GIR_Coverage, 17096,
     /* 1202409 */     GIR_EraseRootFromParent_Done,
     /* 1202410 */   // Label 17449: @1202410
     /* 1202410 */   GIM_Try, /*On fail goto*//*Label 17450*/ GIMT_Encode4(1202490), // Rule ID 17097 //
     /* 1202415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1202418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1202426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1202429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1202432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1202435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1202450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1202454 */     // MIs[0] round
     /* 1202454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202464 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32),
     /* 1202467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1202485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202489 */     // GIR_Coverage, 17097,
     /* 1202489 */     GIR_EraseRootFromParent_Done,
     /* 1202490 */   // Label 17450: @1202490
     /* 1202490 */   GIM_Try, /*On fail goto*//*Label 17451*/ GIMT_Encode4(1202570), // Rule ID 17104 //
     /* 1202495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202534 */     // MIs[0] round
     /* 1202534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1202547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202569 */     // GIR_Coverage, 17104,
     /* 1202569 */     GIR_EraseRootFromParent_Done,
     /* 1202570 */   // Label 17451: @1202570
     /* 1202570 */   GIM_Try, /*On fail goto*//*Label 17452*/ GIMT_Encode4(1202650), // Rule ID 17105 //
     /* 1202575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1202586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1202589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1202592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202614 */     // MIs[0] round
     /* 1202614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16),
     /* 1202627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202649 */     // GIR_Coverage, 17105,
     /* 1202649 */     GIR_EraseRootFromParent_Done,
     /* 1202650 */   // Label 17452: @1202650
     /* 1202650 */   GIM_Try, /*On fail goto*//*Label 17453*/ GIMT_Encode4(1202730), // Rule ID 17108 //
     /* 1202655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202694 */     // MIs[0] round
     /* 1202694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1202707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202729 */     // GIR_Coverage, 17108,
     /* 1202729 */     GIR_EraseRootFromParent_Done,
     /* 1202730 */   // Label 17453: @1202730
     /* 1202730 */   GIM_Try, /*On fail goto*//*Label 17454*/ GIMT_Encode4(1202810), // Rule ID 17109 //
     /* 1202735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1202746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1202749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1202752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1202770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202774 */     // MIs[0] round
     /* 1202774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11212:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16),
     /* 1202787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202809 */     // GIR_Coverage, 17109,
     /* 1202809 */     GIR_EraseRootFromParent_Done,
     /* 1202810 */   // Label 17454: @1202810
     /* 1202810 */   GIM_Try, /*On fail goto*//*Label 17455*/ GIMT_Encode4(1202890), // Rule ID 17112 //
     /* 1202815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202854 */     // MIs[0] round
     /* 1202854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202864 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1202864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1202867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202889 */     // GIR_Coverage, 17112,
     /* 1202889 */     GIR_EraseRootFromParent_Done,
     /* 1202890 */   // Label 17455: @1202890
     /* 1202890 */   GIM_Try, /*On fail goto*//*Label 17456*/ GIMT_Encode4(1202970), // Rule ID 17113 //
     /* 1202895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1202898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1202906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1202909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1202912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1202918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1202930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1202934 */     // MIs[0] round
     /* 1202934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1202937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1202944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1202944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16),
     /* 1202947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1202949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1202951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1202953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1202955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1202957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1202962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1202965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1202968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1202969 */     // GIR_Coverage, 17113,
     /* 1202969 */     GIR_EraseRootFromParent_Done,
     /* 1202970 */   // Label 17456: @1202970
     /* 1202970 */   GIM_Try, /*On fail goto*//*Label 17457*/ GIMT_Encode4(1203050), // Rule ID 17116 //
     /* 1202975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1202978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1202983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1202986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1202989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1202992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1202995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1202998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1203014 */     // MIs[0] round
     /* 1203014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203024 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1203027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203049 */     // GIR_Coverage, 17116,
     /* 1203049 */     GIR_EraseRootFromParent_Done,
     /* 1203050 */   // Label 17457: @1203050
     /* 1203050 */   GIM_Try, /*On fail goto*//*Label 17458*/ GIMT_Encode4(1203130), // Rule ID 17117 //
     /* 1203055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1203066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1203069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1203072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1203075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1203094 */     // MIs[0] round
     /* 1203094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203104 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16),
     /* 1203107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203129 */     // GIR_Coverage, 17117,
     /* 1203129 */     GIR_EraseRootFromParent_Done,
     /* 1203130 */   // Label 17458: @1203130
     /* 1203130 */   GIM_Try, /*On fail goto*//*Label 17459*/ GIMT_Encode4(1203210), // Rule ID 17120 //
     /* 1203135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1203155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1203174 */     // MIs[0] round
     /* 1203174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203184 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1203187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203209 */     // GIR_Coverage, 17120,
     /* 1203209 */     GIR_EraseRootFromParent_Done,
     /* 1203210 */   // Label 17459: @1203210
     /* 1203210 */   GIM_Try, /*On fail goto*//*Label 17460*/ GIMT_Encode4(1203290), // Rule ID 17121 //
     /* 1203215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1203218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1203226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1203229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1203232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1203235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1203254 */     // MIs[0] round
     /* 1203254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203264 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16),
     /* 1203267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1203285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203289 */     // GIR_Coverage, 17121,
     /* 1203289 */     GIR_EraseRootFromParent_Done,
     /* 1203290 */   // Label 17460: @1203290
     /* 1203290 */   GIM_Try, /*On fail goto*//*Label 17461*/ GIMT_Encode4(1203370), // Rule ID 17124 //
     /* 1203295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1203312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203334 */     // MIs[0] round
     /* 1203334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203344 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1203347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203369 */     // GIR_Coverage, 17124,
     /* 1203369 */     GIR_EraseRootFromParent_Done,
     /* 1203370 */   // Label 17461: @1203370
     /* 1203370 */   GIM_Try, /*On fail goto*//*Label 17462*/ GIMT_Encode4(1203450), // Rule ID 17125 //
     /* 1203375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1203386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1203389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1203392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203414 */     // MIs[0] round
     /* 1203414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11212:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32),
     /* 1203427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203449 */     // GIR_Coverage, 17125,
     /* 1203449 */     GIR_EraseRootFromParent_Done,
     /* 1203450 */   // Label 17462: @1203450
     /* 1203450 */   GIM_Try, /*On fail goto*//*Label 17463*/ GIMT_Encode4(1203530), // Rule ID 17128 //
     /* 1203455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203494 */     // MIs[0] round
     /* 1203494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1203507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203529 */     // GIR_Coverage, 17128,
     /* 1203529 */     GIR_EraseRootFromParent_Done,
     /* 1203530 */   // Label 17463: @1203530
     /* 1203530 */   GIM_Try, /*On fail goto*//*Label 17464*/ GIMT_Encode4(1203610), // Rule ID 17129 //
     /* 1203535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1203546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1203549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1203552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1203570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203574 */     // MIs[0] round
     /* 1203574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11212:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32),
     /* 1203587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203609 */     // GIR_Coverage, 17129,
     /* 1203609 */     GIR_EraseRootFromParent_Done,
     /* 1203610 */   // Label 17464: @1203610
     /* 1203610 */   GIM_Try, /*On fail goto*//*Label 17465*/ GIMT_Encode4(1203690), // Rule ID 17132 //
     /* 1203615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203654 */     // MIs[0] round
     /* 1203654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203664 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1203667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203689 */     // GIR_Coverage, 17132,
     /* 1203689 */     GIR_EraseRootFromParent_Done,
     /* 1203690 */   // Label 17465: @1203690
     /* 1203690 */   GIM_Try, /*On fail goto*//*Label 17466*/ GIMT_Encode4(1203770), // Rule ID 17133 //
     /* 1203695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1203706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1203709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1203712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1203730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203734 */     // MIs[0] round
     /* 1203734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203744 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11212:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32),
     /* 1203747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203769 */     // GIR_Coverage, 17133,
     /* 1203769 */     GIR_EraseRootFromParent_Done,
     /* 1203770 */   // Label 17466: @1203770
     /* 1203770 */   GIM_Try, /*On fail goto*//*Label 17467*/ GIMT_Encode4(1203850), // Rule ID 17136 //
     /* 1203775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1203778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203814 */     // MIs[0] round
     /* 1203814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203824 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1203827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203849 */     // GIR_Coverage, 17136,
     /* 1203849 */     GIR_EraseRootFromParent_Done,
     /* 1203850 */   // Label 17467: @1203850
     /* 1203850 */   GIM_Try, /*On fail goto*//*Label 17468*/ GIMT_Encode4(1203930), // Rule ID 17137 //
     /* 1203855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1203858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w),
     /* 1203863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1203866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1203869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1203872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1203875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1203878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1203890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1203894 */     // MIs[0] round
     /* 1203894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203904 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11212:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWADD_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1203904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32),
     /* 1203907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1203922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1203925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1203928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1203929 */     // GIR_Coverage, 17137,
     /* 1203929 */     GIR_EraseRootFromParent_Done,
     /* 1203930 */   // Label 17468: @1203930
     /* 1203930 */   GIM_Try, /*On fail goto*//*Label 17469*/ GIMT_Encode4(1204010), // Rule ID 17142 //
     /* 1203935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1203938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1203943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1203946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1203949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1203952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1203955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1203958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1203974 */     // MIs[0] round
     /* 1203974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1203977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1203984 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1203984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1203987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1203989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1203991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1203993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1203995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1203997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204009 */     // GIR_Coverage, 17142,
     /* 1204009 */     GIR_EraseRootFromParent_Done,
     /* 1204010 */   // Label 17469: @1204010
     /* 1204010 */   GIM_Try, /*On fail goto*//*Label 17470*/ GIMT_Encode4(1204090), // Rule ID 17143 //
     /* 1204015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1204026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1204029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1204032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1204035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204054 */     // MIs[0] round
     /* 1204054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204064 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16),
     /* 1204067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204089 */     // GIR_Coverage, 17143,
     /* 1204089 */     GIR_EraseRootFromParent_Done,
     /* 1204090 */   // Label 17470: @1204090
     /* 1204090 */   GIM_Try, /*On fail goto*//*Label 17471*/ GIMT_Encode4(1204170), // Rule ID 17152 //
     /* 1204095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204134 */     // MIs[0] round
     /* 1204134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1204147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204169 */     // GIR_Coverage, 17152,
     /* 1204169 */     GIR_EraseRootFromParent_Done,
     /* 1204170 */   // Label 17471: @1204170
     /* 1204170 */   GIM_Try, /*On fail goto*//*Label 17472*/ GIMT_Encode4(1204250), // Rule ID 17153 //
     /* 1204175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1204186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1204189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1204192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1204195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204214 */     // MIs[0] round
     /* 1204214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16),
     /* 1204227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204249 */     // GIR_Coverage, 17153,
     /* 1204249 */     GIR_EraseRootFromParent_Done,
     /* 1204250 */   // Label 17472: @1204250
     /* 1204250 */   GIM_Try, /*On fail goto*//*Label 17473*/ GIMT_Encode4(1204330), // Rule ID 17162 //
     /* 1204255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1204275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204294 */     // MIs[0] round
     /* 1204294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1204307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204329 */     // GIR_Coverage, 17162,
     /* 1204329 */     GIR_EraseRootFromParent_Done,
     /* 1204330 */   // Label 17473: @1204330
     /* 1204330 */   GIM_Try, /*On fail goto*//*Label 17474*/ GIMT_Encode4(1204410), // Rule ID 17163 //
     /* 1204335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1204346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1204349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1204352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1204355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204374 */     // MIs[0] round
     /* 1204374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204384 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16),
     /* 1204387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204409 */     // GIR_Coverage, 17163,
     /* 1204409 */     GIR_EraseRootFromParent_Done,
     /* 1204410 */   // Label 17474: @1204410
     /* 1204410 */   GIM_Try, /*On fail goto*//*Label 17475*/ GIMT_Encode4(1204490), // Rule ID 17172 //
     /* 1204415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204454 */     // MIs[0] round
     /* 1204454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1204467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204489 */     // GIR_Coverage, 17172,
     /* 1204489 */     GIR_EraseRootFromParent_Done,
     /* 1204490 */   // Label 17475: @1204490
     /* 1204490 */   GIM_Try, /*On fail goto*//*Label 17476*/ GIMT_Encode4(1204570), // Rule ID 17173 //
     /* 1204495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1204506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1204509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1204512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1204515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204534 */     // MIs[0] round
     /* 1204534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204544 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16),
     /* 1204547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204569 */     // GIR_Coverage, 17173,
     /* 1204569 */     GIR_EraseRootFromParent_Done,
     /* 1204570 */   // Label 17476: @1204570
     /* 1204570 */   GIM_Try, /*On fail goto*//*Label 17477*/ GIMT_Encode4(1204650), // Rule ID 17182 //
     /* 1204575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1204578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1204592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204614 */     // MIs[0] round
     /* 1204614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1204627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204649 */     // GIR_Coverage, 17182,
     /* 1204649 */     GIR_EraseRootFromParent_Done,
     /* 1204650 */   // Label 17477: @1204650
     /* 1204650 */   GIM_Try, /*On fail goto*//*Label 17478*/ GIMT_Encode4(1204730), // Rule ID 17183 //
     /* 1204655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1204658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1204666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1204669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1204672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1204675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1204690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1204694 */     // MIs[0] round
     /* 1204694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204704 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16),
     /* 1204707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1204725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204729 */     // GIR_Coverage, 17183,
     /* 1204729 */     GIR_EraseRootFromParent_Done,
     /* 1204730 */   // Label 17478: @1204730
     /* 1204730 */   GIM_Try, /*On fail goto*//*Label 17479*/ GIMT_Encode4(1204810), // Rule ID 17192 //
     /* 1204735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1204752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204774 */     // MIs[0] round
     /* 1204774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1204787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204809 */     // GIR_Coverage, 17192,
     /* 1204809 */     GIR_EraseRootFromParent_Done,
     /* 1204810 */   // Label 17479: @1204810
     /* 1204810 */   GIM_Try, /*On fail goto*//*Label 17480*/ GIMT_Encode4(1204890), // Rule ID 17193 //
     /* 1204815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1204826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1204829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1204832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1204835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204854 */     // MIs[0] round
     /* 1204854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1204864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32),
     /* 1204867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204889 */     // GIR_Coverage, 17193,
     /* 1204889 */     GIR_EraseRootFromParent_Done,
     /* 1204890 */   // Label 17480: @1204890
     /* 1204890 */   GIM_Try, /*On fail goto*//*Label 17481*/ GIMT_Encode4(1204970), // Rule ID 17202 //
     /* 1204895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1204898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1204912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1204918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1204930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1204934 */     // MIs[0] round
     /* 1204934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1204937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1204944 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1204944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1204947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1204949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1204951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1204953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1204955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1204957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1204962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1204965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1204968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1204969 */     // GIR_Coverage, 17202,
     /* 1204969 */     GIR_EraseRootFromParent_Done,
     /* 1204970 */   // Label 17481: @1204970
     /* 1204970 */   GIM_Try, /*On fail goto*//*Label 17482*/ GIMT_Encode4(1205050), // Rule ID 17203 //
     /* 1204975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1204978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1204983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1204986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1204989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1204992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1204995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1204998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205014 */     // MIs[0] round
     /* 1205014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205024 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32),
     /* 1205027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205049 */     // GIR_Coverage, 17203,
     /* 1205049 */     GIR_EraseRootFromParent_Done,
     /* 1205050 */   // Label 17482: @1205050
     /* 1205050 */   GIM_Try, /*On fail goto*//*Label 17483*/ GIMT_Encode4(1205130), // Rule ID 17212 //
     /* 1205055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1205072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1205075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205094 */     // MIs[0] round
     /* 1205094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205104 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1205107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205129 */     // GIR_Coverage, 17212,
     /* 1205129 */     GIR_EraseRootFromParent_Done,
     /* 1205130 */   // Label 17483: @1205130
     /* 1205130 */   GIM_Try, /*On fail goto*//*Label 17484*/ GIMT_Encode4(1205210), // Rule ID 17213 //
     /* 1205135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1205146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1205149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1205152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1205155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205174 */     // MIs[0] round
     /* 1205174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205184 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32),
     /* 1205187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205209 */     // GIR_Coverage, 17213,
     /* 1205209 */     GIR_EraseRootFromParent_Done,
     /* 1205210 */   // Label 17484: @1205210
     /* 1205210 */   GIM_Try, /*On fail goto*//*Label 17485*/ GIMT_Encode4(1205290), // Rule ID 17222 //
     /* 1205215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1205218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1205232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1205235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205254 */     // MIs[0] round
     /* 1205254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205264 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1205267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205289 */     // GIR_Coverage, 17222,
     /* 1205289 */     GIR_EraseRootFromParent_Done,
     /* 1205290 */   // Label 17485: @1205290
     /* 1205290 */   GIM_Try, /*On fail goto*//*Label 17486*/ GIMT_Encode4(1205370), // Rule ID 17223 //
     /* 1205295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1205298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1205306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1205309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1205312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1205315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1205330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205334 */     // MIs[0] round
     /* 1205334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32),
     /* 1205347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1205365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205369 */     // GIR_Coverage, 17223,
     /* 1205369 */     GIR_EraseRootFromParent_Done,
     /* 1205370 */   // Label 17486: @1205370
     /* 1205370 */   GIM_Try, /*On fail goto*//*Label 17487*/ GIMT_Encode4(1205450), // Rule ID 17230 //
     /* 1205375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1205386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205414 */     // MIs[0] round
     /* 1205414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205424 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1205427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205449 */     // GIR_Coverage, 17230,
     /* 1205449 */     GIR_EraseRootFromParent_Done,
     /* 1205450 */   // Label 17487: @1205450
     /* 1205450 */   GIM_Try, /*On fail goto*//*Label 17488*/ GIMT_Encode4(1205530), // Rule ID 17231 //
     /* 1205455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1205466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1205469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1205472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205494 */     // MIs[0] round
     /* 1205494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205504 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16),
     /* 1205507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205529 */     // GIR_Coverage, 17231,
     /* 1205529 */     GIR_EraseRootFromParent_Done,
     /* 1205530 */   // Label 17488: @1205530
     /* 1205530 */   GIM_Try, /*On fail goto*//*Label 17489*/ GIMT_Encode4(1205610), // Rule ID 17234 //
     /* 1205535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205574 */     // MIs[0] round
     /* 1205574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1205587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205609 */     // GIR_Coverage, 17234,
     /* 1205609 */     GIR_EraseRootFromParent_Done,
     /* 1205610 */   // Label 17489: @1205610
     /* 1205610 */   GIM_Try, /*On fail goto*//*Label 17490*/ GIMT_Encode4(1205690), // Rule ID 17235 //
     /* 1205615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1205626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1205629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1205632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1205650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205654 */     // MIs[0] round
     /* 1205654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205664 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11248:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16),
     /* 1205667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205689 */     // GIR_Coverage, 17235,
     /* 1205689 */     GIR_EraseRootFromParent_Done,
     /* 1205690 */   // Label 17490: @1205690
     /* 1205690 */   GIM_Try, /*On fail goto*//*Label 17491*/ GIMT_Encode4(1205770), // Rule ID 17238 //
     /* 1205695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205734 */     // MIs[0] round
     /* 1205734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1205747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205769 */     // GIR_Coverage, 17238,
     /* 1205769 */     GIR_EraseRootFromParent_Done,
     /* 1205770 */   // Label 17491: @1205770
     /* 1205770 */   GIM_Try, /*On fail goto*//*Label 17492*/ GIMT_Encode4(1205850), // Rule ID 17239 //
     /* 1205775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1205786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1205789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1205792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1205810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205814 */     // MIs[0] round
     /* 1205814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205824 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16),
     /* 1205827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205849 */     // GIR_Coverage, 17239,
     /* 1205849 */     GIR_EraseRootFromParent_Done,
     /* 1205850 */   // Label 17492: @1205850
     /* 1205850 */   GIM_Try, /*On fail goto*//*Label 17493*/ GIMT_Encode4(1205930), // Rule ID 17242 //
     /* 1205855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1205858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1205878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205894 */     // MIs[0] round
     /* 1205894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205904 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1205904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1205907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1205922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1205925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1205928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1205929 */     // GIR_Coverage, 17242,
     /* 1205929 */     GIR_EraseRootFromParent_Done,
     /* 1205930 */   // Label 17493: @1205930
     /* 1205930 */   GIM_Try, /*On fail goto*//*Label 17494*/ GIMT_Encode4(1206010), // Rule ID 17243 //
     /* 1205935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1205938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1205943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1205946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1205949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1205952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1205955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1205958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1205970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1205974 */     // MIs[0] round
     /* 1205974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1205977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1205984 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1205984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16),
     /* 1205987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1205989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1205991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1205993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1205995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1205997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206009 */     // GIR_Coverage, 17243,
     /* 1206009 */     GIR_EraseRootFromParent_Done,
     /* 1206010 */   // Label 17494: @1206010
     /* 1206010 */   GIM_Try, /*On fail goto*//*Label 17495*/ GIMT_Encode4(1206090), // Rule ID 17246 //
     /* 1206015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1206018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206054 */     // MIs[0] round
     /* 1206054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206064 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1206067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206089 */     // GIR_Coverage, 17246,
     /* 1206089 */     GIR_EraseRootFromParent_Done,
     /* 1206090 */   // Label 17495: @1206090
     /* 1206090 */   GIM_Try, /*On fail goto*//*Label 17496*/ GIMT_Encode4(1206170), // Rule ID 17247 //
     /* 1206095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1206098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1206106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1206109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1206112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1206115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1206134 */     // MIs[0] round
     /* 1206134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206144 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16),
     /* 1206147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206169 */     // GIR_Coverage, 17247,
     /* 1206169 */     GIR_EraseRootFromParent_Done,
     /* 1206170 */   // Label 17496: @1206170
     /* 1206170 */   GIM_Try, /*On fail goto*//*Label 17497*/ GIMT_Encode4(1206250), // Rule ID 17250 //
     /* 1206175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206214 */     // MIs[0] round
     /* 1206214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206224 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1206227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206249 */     // GIR_Coverage, 17250,
     /* 1206249 */     GIR_EraseRootFromParent_Done,
     /* 1206250 */   // Label 17497: @1206250
     /* 1206250 */   GIM_Try, /*On fail goto*//*Label 17498*/ GIMT_Encode4(1206330), // Rule ID 17251 //
     /* 1206255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1206266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1206269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1206272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206294 */     // MIs[0] round
     /* 1206294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206304 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11248:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32),
     /* 1206307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206329 */     // GIR_Coverage, 17251,
     /* 1206329 */     GIR_EraseRootFromParent_Done,
     /* 1206330 */   // Label 17498: @1206330
     /* 1206330 */   GIM_Try, /*On fail goto*//*Label 17499*/ GIMT_Encode4(1206410), // Rule ID 17254 //
     /* 1206335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206374 */     // MIs[0] round
     /* 1206374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1206387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206409 */     // GIR_Coverage, 17254,
     /* 1206409 */     GIR_EraseRootFromParent_Done,
     /* 1206410 */   // Label 17499: @1206410
     /* 1206410 */   GIM_Try, /*On fail goto*//*Label 17500*/ GIMT_Encode4(1206490), // Rule ID 17255 //
     /* 1206415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1206426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1206429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1206432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1206450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206454 */     // MIs[0] round
     /* 1206454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206464 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11248:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32),
     /* 1206467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206489 */     // GIR_Coverage, 17255,
     /* 1206489 */     GIR_EraseRootFromParent_Done,
     /* 1206490 */   // Label 17500: @1206490
     /* 1206490 */   GIM_Try, /*On fail goto*//*Label 17501*/ GIMT_Encode4(1206570), // Rule ID 17258 //
     /* 1206495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206534 */     // MIs[0] round
     /* 1206534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206544 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1206547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206569 */     // GIR_Coverage, 17258,
     /* 1206569 */     GIR_EraseRootFromParent_Done,
     /* 1206570 */   // Label 17501: @1206570
     /* 1206570 */   GIM_Try, /*On fail goto*//*Label 17502*/ GIMT_Encode4(1206650), // Rule ID 17259 //
     /* 1206575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1206586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1206589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1206592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1206610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206614 */     // MIs[0] round
     /* 1206614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11248:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32),
     /* 1206627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206649 */     // GIR_Coverage, 17259,
     /* 1206649 */     GIR_EraseRootFromParent_Done,
     /* 1206650 */   // Label 17502: @1206650
     /* 1206650 */   GIM_Try, /*On fail goto*//*Label 17503*/ GIMT_Encode4(1206730), // Rule ID 17262 //
     /* 1206655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1206658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1206672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206694 */     // MIs[0] round
     /* 1206694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206704 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1206707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206729 */     // GIR_Coverage, 17262,
     /* 1206729 */     GIR_EraseRootFromParent_Done,
     /* 1206730 */   // Label 17503: @1206730
     /* 1206730 */   GIM_Try, /*On fail goto*//*Label 17504*/ GIMT_Encode4(1206810), // Rule ID 17263 //
     /* 1206735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1206738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w),
     /* 1206743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1206746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1206749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1206752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1206755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1206770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1206774 */     // MIs[0] round
     /* 1206774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11248:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWSUB_WFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32),
     /* 1206787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1206805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206809 */     // GIR_Coverage, 17263,
     /* 1206809 */     GIR_EraseRootFromParent_Done,
     /* 1206810 */   // Label 17504: @1206810
     /* 1206810 */   GIM_Try, /*On fail goto*//*Label 17505*/ GIMT_Encode4(1206890), // Rule ID 17266 //
     /* 1206815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1206818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1206823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1206826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1206829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1206832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1206835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206854 */     // MIs[0] round
     /* 1206854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206864 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1206864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1206867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206889 */     // GIR_Coverage, 17266,
     /* 1206889 */     GIR_EraseRootFromParent_Done,
     /* 1206890 */   // Label 17505: @1206890
     /* 1206890 */   GIM_Try, /*On fail goto*//*Label 17506*/ GIMT_Encode4(1206970), // Rule ID 17267 //
     /* 1206895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1206898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1206903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1206906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1206909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1206912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1206915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1206918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1206934 */     // MIs[0] round
     /* 1206934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1206937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1206944 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1206944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 1206947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1206949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1206951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1206953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1206955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1206957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1206962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1206965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1206968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1206969 */     // GIR_Coverage, 17267,
     /* 1206969 */     GIR_EraseRootFromParent_Done,
     /* 1206970 */   // Label 17506: @1206970
     /* 1206970 */   GIM_Try, /*On fail goto*//*Label 17507*/ GIMT_Encode4(1207050), // Rule ID 17270 //
     /* 1206975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1206978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1206983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1206986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1206989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1206992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1206995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1206998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207014 */     // MIs[0] round
     /* 1207014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207024 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1207027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207049 */     // GIR_Coverage, 17270,
     /* 1207049 */     GIR_EraseRootFromParent_Done,
     /* 1207050 */   // Label 17507: @1207050
     /* 1207050 */   GIM_Try, /*On fail goto*//*Label 17508*/ GIMT_Encode4(1207130), // Rule ID 17271 //
     /* 1207055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1207058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1207066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1207069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1207072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1207075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207094 */     // MIs[0] round
     /* 1207094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207104 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 1207107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207129 */     // GIR_Coverage, 17271,
     /* 1207129 */     GIR_EraseRootFromParent_Done,
     /* 1207130 */   // Label 17508: @1207130
     /* 1207130 */   GIM_Try, /*On fail goto*//*Label 17509*/ GIMT_Encode4(1207210), // Rule ID 17274 //
     /* 1207135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1207138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207174 */     // MIs[0] round
     /* 1207174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1207187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207209 */     // GIR_Coverage, 17274,
     /* 1207209 */     GIR_EraseRootFromParent_Done,
     /* 1207210 */   // Label 17509: @1207210
     /* 1207210 */   GIM_Try, /*On fail goto*//*Label 17510*/ GIMT_Encode4(1207290), // Rule ID 17275 //
     /* 1207215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1207218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1207226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1207229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1207232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1207235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207254 */     // MIs[0] round
     /* 1207254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207264 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 1207267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207289 */     // GIR_Coverage, 17275,
     /* 1207289 */     GIR_EraseRootFromParent_Done,
     /* 1207290 */   // Label 17510: @1207290
     /* 1207290 */   GIM_Try, /*On fail goto*//*Label 17511*/ GIMT_Encode4(1207370), // Rule ID 17278 //
     /* 1207295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1207298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1207306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1207309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1207312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1207315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207334 */     // MIs[0] round
     /* 1207334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207344 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1207347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207369 */     // GIR_Coverage, 17278,
     /* 1207369 */     GIR_EraseRootFromParent_Done,
     /* 1207370 */   // Label 17511: @1207370
     /* 1207370 */   GIM_Try, /*On fail goto*//*Label 17512*/ GIMT_Encode4(1207450), // Rule ID 17279 //
     /* 1207375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1207378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1207386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1207389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1207392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1207395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207414 */     // MIs[0] round
     /* 1207414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207424 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 1207427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207449 */     // GIR_Coverage, 17279,
     /* 1207449 */     GIR_EraseRootFromParent_Done,
     /* 1207450 */   // Label 17512: @1207450
     /* 1207450 */   GIM_Try, /*On fail goto*//*Label 17513*/ GIMT_Encode4(1207530), // Rule ID 17282 //
     /* 1207455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1207458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207494 */     // MIs[0] round
     /* 1207494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207504 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1207507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207529 */     // GIR_Coverage, 17282,
     /* 1207529 */     GIR_EraseRootFromParent_Done,
     /* 1207530 */   // Label 17513: @1207530
     /* 1207530 */   GIM_Try, /*On fail goto*//*Label 17514*/ GIMT_Encode4(1207610), // Rule ID 17283 //
     /* 1207535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1207538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1207546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1207549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1207552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1207555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207574 */     // MIs[0] round
     /* 1207574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 1207587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1207605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207609 */     // GIR_Coverage, 17283,
     /* 1207609 */     GIR_EraseRootFromParent_Done,
     /* 1207610 */   // Label 17514: @1207610
     /* 1207610 */   GIM_Try, /*On fail goto*//*Label 17515*/ GIMT_Encode4(1207690), // Rule ID 17286 //
     /* 1207615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1207618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1207635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207654 */     // MIs[0] round
     /* 1207654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207664 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1207667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207689 */     // GIR_Coverage, 17286,
     /* 1207689 */     GIR_EraseRootFromParent_Done,
     /* 1207690 */   // Label 17515: @1207690
     /* 1207690 */   GIM_Try, /*On fail goto*//*Label 17516*/ GIMT_Encode4(1207770), // Rule ID 17287 //
     /* 1207695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1207698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1207706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1207709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1207712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1207715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1207734 */     // MIs[0] round
     /* 1207734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 1207747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1207765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207769 */     // GIR_Coverage, 17287,
     /* 1207769 */     GIR_EraseRootFromParent_Done,
     /* 1207770 */   // Label 17516: @1207770
     /* 1207770 */   GIM_Try, /*On fail goto*//*Label 17517*/ GIMT_Encode4(1207850), // Rule ID 17290 //
     /* 1207775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1207778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1207786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1207789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1207792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1207795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207814 */     // MIs[0] round
     /* 1207814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207824 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1207827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207849 */     // GIR_Coverage, 17290,
     /* 1207849 */     GIR_EraseRootFromParent_Done,
     /* 1207850 */   // Label 17517: @1207850
     /* 1207850 */   GIM_Try, /*On fail goto*//*Label 17518*/ GIMT_Encode4(1207930), // Rule ID 17291 //
     /* 1207855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1207858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1207866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1207869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1207872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1207875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1207878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1207894 */     // MIs[0] round
     /* 1207894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207904 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1207904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 1207907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1207922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1207925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1207928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1207929 */     // GIR_Coverage, 17291,
     /* 1207929 */     GIR_EraseRootFromParent_Done,
     /* 1207930 */   // Label 17518: @1207930
     /* 1207930 */   GIM_Try, /*On fail goto*//*Label 17519*/ GIMT_Encode4(1208010), // Rule ID 17294 //
     /* 1207935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1207938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1207943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1207946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1207949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1207952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1207955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1207958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1207974 */     // MIs[0] round
     /* 1207974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1207977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1207984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1207984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1207987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1207989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1207991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1207993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1207995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1207997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208009 */     // GIR_Coverage, 17294,
     /* 1208009 */     GIR_EraseRootFromParent_Done,
     /* 1208010 */   // Label 17519: @1208010
     /* 1208010 */   GIM_Try, /*On fail goto*//*Label 17520*/ GIMT_Encode4(1208090), // Rule ID 17295 //
     /* 1208015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1208018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1208026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1208029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1208032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1208035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208054 */     // MIs[0] round
     /* 1208054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 1208067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208089 */     // GIR_Coverage, 17295,
     /* 1208089 */     GIR_EraseRootFromParent_Done,
     /* 1208090 */   // Label 17520: @1208090
     /* 1208090 */   GIM_Try, /*On fail goto*//*Label 17521*/ GIMT_Encode4(1208170), // Rule ID 17298 //
     /* 1208095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1208098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1208106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1208109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1208112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1208115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208134 */     // MIs[0] round
     /* 1208134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208144 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1208147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208169 */     // GIR_Coverage, 17298,
     /* 1208169 */     GIR_EraseRootFromParent_Done,
     /* 1208170 */   // Label 17521: @1208170
     /* 1208170 */   GIM_Try, /*On fail goto*//*Label 17522*/ GIMT_Encode4(1208250), // Rule ID 17299 //
     /* 1208175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1208178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1208186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1208189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1208192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1208195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208214 */     // MIs[0] round
     /* 1208214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 1208227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1208245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208249 */     // GIR_Coverage, 17299,
     /* 1208249 */     GIR_EraseRootFromParent_Done,
     /* 1208250 */   // Label 17522: @1208250
     /* 1208250 */   GIM_Try, /*On fail goto*//*Label 17523*/ GIMT_Encode4(1208330), // Rule ID 17302 //
     /* 1208255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1208258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1208275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208294 */     // MIs[0] round
     /* 1208294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208304 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1208307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208329 */     // GIR_Coverage, 17302,
     /* 1208329 */     GIR_EraseRootFromParent_Done,
     /* 1208330 */   // Label 17523: @1208330
     /* 1208330 */   GIM_Try, /*On fail goto*//*Label 17524*/ GIMT_Encode4(1208410), // Rule ID 17303 //
     /* 1208335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1208338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1208346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1208349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1208352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1208355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208374 */     // MIs[0] round
     /* 1208374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208384 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 1208387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208409 */     // GIR_Coverage, 17303,
     /* 1208409 */     GIR_EraseRootFromParent_Done,
     /* 1208410 */   // Label 17524: @1208410
     /* 1208410 */   GIM_Try, /*On fail goto*//*Label 17525*/ GIMT_Encode4(1208490), // Rule ID 17306 //
     /* 1208415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1208418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1208435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208454 */     // MIs[0] round
     /* 1208454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208464 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1208467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208489 */     // GIR_Coverage, 17306,
     /* 1208489 */     GIR_EraseRootFromParent_Done,
     /* 1208490 */   // Label 17525: @1208490
     /* 1208490 */   GIM_Try, /*On fail goto*//*Label 17526*/ GIMT_Encode4(1208570), // Rule ID 17307 //
     /* 1208495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1208498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1208506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1208509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1208512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1208515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208534 */     // MIs[0] round
     /* 1208534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208544 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 1208547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208569 */     // GIR_Coverage, 17307,
     /* 1208569 */     GIR_EraseRootFromParent_Done,
     /* 1208570 */   // Label 17526: @1208570
     /* 1208570 */   GIM_Try, /*On fail goto*//*Label 17527*/ GIMT_Encode4(1208650), // Rule ID 17310 //
     /* 1208575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1208578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1208595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208614 */     // MIs[0] round
     /* 1208614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208624 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1208627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208649 */     // GIR_Coverage, 17310,
     /* 1208649 */     GIR_EraseRootFromParent_Done,
     /* 1208650 */   // Label 17527: @1208650
     /* 1208650 */   GIM_Try, /*On fail goto*//*Label 17528*/ GIMT_Encode4(1208730), // Rule ID 17311 //
     /* 1208655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1208658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1208666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1208669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1208672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1208675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1208694 */     // MIs[0] round
     /* 1208694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208704 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 1208707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1208725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208729 */     // GIR_Coverage, 17311,
     /* 1208729 */     GIR_EraseRootFromParent_Done,
     /* 1208730 */   // Label 17528: @1208730
     /* 1208730 */   GIM_Try, /*On fail goto*//*Label 17529*/ GIMT_Encode4(1208810), // Rule ID 17314 //
     /* 1208735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1208738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1208755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208774 */     // MIs[0] round
     /* 1208774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208784 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1208787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1208805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208809 */     // GIR_Coverage, 17314,
     /* 1208809 */     GIR_EraseRootFromParent_Done,
     /* 1208810 */   // Label 17529: @1208810
     /* 1208810 */   GIM_Try, /*On fail goto*//*Label 17530*/ GIMT_Encode4(1208890), // Rule ID 17315 //
     /* 1208815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1208818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1208826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1208829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1208832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1208835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1208854 */     // MIs[0] round
     /* 1208854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208864 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1208864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 1208867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1208885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208889 */     // GIR_Coverage, 17315,
     /* 1208889 */     GIR_EraseRootFromParent_Done,
     /* 1208890 */   // Label 17530: @1208890
     /* 1208890 */   GIM_Try, /*On fail goto*//*Label 17531*/ GIMT_Encode4(1208970), // Rule ID 17318 //
     /* 1208895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1208898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1208915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1208918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1208934 */     // MIs[0] round
     /* 1208934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1208937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1208944 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1208944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1208947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1208949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1208951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1208953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1208955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1208957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1208962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1208965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1208968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1208969 */     // GIR_Coverage, 17318,
     /* 1208969 */     GIR_EraseRootFromParent_Done,
     /* 1208970 */   // Label 17531: @1208970
     /* 1208970 */   GIM_Try, /*On fail goto*//*Label 17532*/ GIMT_Encode4(1209050), // Rule ID 17319 //
     /* 1208975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1208978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1208983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1208986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1208989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1208992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1208995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1208998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1209014 */     // MIs[0] round
     /* 1209014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209024 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 1209027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1209045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209049 */     // GIR_Coverage, 17319,
     /* 1209049 */     GIR_EraseRootFromParent_Done,
     /* 1209050 */   // Label 17532: @1209050
     /* 1209050 */   GIM_Try, /*On fail goto*//*Label 17533*/ GIMT_Encode4(1209130), // Rule ID 17322 //
     /* 1209055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1209058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1209075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209094 */     // MIs[0] round
     /* 1209094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209104 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1209107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1209125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209129 */     // GIR_Coverage, 17322,
     /* 1209129 */     GIR_EraseRootFromParent_Done,
     /* 1209130 */   // Label 17533: @1209130
     /* 1209130 */   GIM_Try, /*On fail goto*//*Label 17534*/ GIMT_Encode4(1209210), // Rule ID 17323 //
     /* 1209135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1209138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1209146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1209149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1209152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1209155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1209174 */     // MIs[0] round
     /* 1209174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209184 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 1209187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1209205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209209 */     // GIR_Coverage, 17323,
     /* 1209209 */     GIR_EraseRootFromParent_Done,
     /* 1209210 */   // Label 17534: @1209210
     /* 1209210 */   GIM_Try, /*On fail goto*//*Label 17535*/ GIMT_Encode4(1209290), // Rule ID 17326 //
     /* 1209215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1209218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1209226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1209229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1209232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209254 */     // MIs[0] round
     /* 1209254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209264 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1209267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209289 */     // GIR_Coverage, 17326,
     /* 1209289 */     GIR_EraseRootFromParent_Done,
     /* 1209290 */   // Label 17535: @1209290
     /* 1209290 */   GIM_Try, /*On fail goto*//*Label 17536*/ GIMT_Encode4(1209370), // Rule ID 17327 //
     /* 1209295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1209298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1209306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1209309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1209312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209334 */     // MIs[0] round
     /* 1209334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209344 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16),
     /* 1209347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209369 */     // GIR_Coverage, 17327,
     /* 1209369 */     GIR_EraseRootFromParent_Done,
     /* 1209370 */   // Label 17536: @1209370
     /* 1209370 */   GIM_Try, /*On fail goto*//*Label 17537*/ GIMT_Encode4(1209450), // Rule ID 17330 //
     /* 1209375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1209378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1209386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1209389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1209392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209414 */     // MIs[0] round
     /* 1209414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209424 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1209427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209449 */     // GIR_Coverage, 17330,
     /* 1209449 */     GIR_EraseRootFromParent_Done,
     /* 1209450 */   // Label 17537: @1209450
     /* 1209450 */   GIM_Try, /*On fail goto*//*Label 17538*/ GIMT_Encode4(1209530), // Rule ID 17331 //
     /* 1209455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1209458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1209466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1209469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1209472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209494 */     // MIs[0] round
     /* 1209494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209504 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16),
     /* 1209507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209529 */     // GIR_Coverage, 17331,
     /* 1209529 */     GIR_EraseRootFromParent_Done,
     /* 1209530 */   // Label 17538: @1209530
     /* 1209530 */   GIM_Try, /*On fail goto*//*Label 17539*/ GIMT_Encode4(1209610), // Rule ID 17334 //
     /* 1209535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1209538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209574 */     // MIs[0] round
     /* 1209574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209584 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1209587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209609 */     // GIR_Coverage, 17334,
     /* 1209609 */     GIR_EraseRootFromParent_Done,
     /* 1209610 */   // Label 17539: @1209610
     /* 1209610 */   GIM_Try, /*On fail goto*//*Label 17540*/ GIMT_Encode4(1209690), // Rule ID 17335 //
     /* 1209615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1209618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1209626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1209629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1209632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209654 */     // MIs[0] round
     /* 1209654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32),
     /* 1209667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209689 */     // GIR_Coverage, 17335,
     /* 1209689 */     GIR_EraseRootFromParent_Done,
     /* 1209690 */   // Label 17540: @1209690
     /* 1209690 */   GIM_Try, /*On fail goto*//*Label 17541*/ GIMT_Encode4(1209770), // Rule ID 17338 //
     /* 1209695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1209698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1209706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1209709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1209712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209734 */     // MIs[0] round
     /* 1209734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209744 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1209747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209769 */     // GIR_Coverage, 17338,
     /* 1209769 */     GIR_EraseRootFromParent_Done,
     /* 1209770 */   // Label 17541: @1209770
     /* 1209770 */   GIM_Try, /*On fail goto*//*Label 17542*/ GIMT_Encode4(1209850), // Rule ID 17339 //
     /* 1209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1209792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1209795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1209814 */     // MIs[0] round
     /* 1209814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11149:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16),
     /* 1209827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1209845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209849 */     // GIR_Coverage, 17339,
     /* 1209849 */     GIR_EraseRootFromParent_Done,
     /* 1209850 */   // Label 17542: @1209850
     /* 1209850 */   GIM_Try, /*On fail goto*//*Label 17543*/ GIMT_Encode4(1209930), // Rule ID 17342 //
     /* 1209855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1209858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1209878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209894 */     // MIs[0] round
     /* 1209894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1209904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1209907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1209922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1209925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1209928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1209929 */     // GIR_Coverage, 17342,
     /* 1209929 */     GIR_EraseRootFromParent_Done,
     /* 1209930 */   // Label 17543: @1209930
     /* 1209930 */   GIM_Try, /*On fail goto*//*Label 17544*/ GIMT_Encode4(1210010), // Rule ID 17343 //
     /* 1209935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1209938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1209943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1209946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1209949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1209952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1209955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1209958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1209970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1209974 */     // MIs[0] round
     /* 1209974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1209977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1209984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11149:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1209984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32),
     /* 1209987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1209989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1209991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1209993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1209995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1209997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210009 */     // GIR_Coverage, 17343,
     /* 1210009 */     GIR_EraseRootFromParent_Done,
     /* 1210010 */   // Label 17544: @1210010
     /* 1210010 */   GIM_Try, /*On fail goto*//*Label 17545*/ GIMT_Encode4(1210090), // Rule ID 17346 //
     /* 1210015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1210018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1210035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1210054 */     // MIs[0] round
     /* 1210054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1210067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210089 */     // GIR_Coverage, 17346,
     /* 1210089 */     GIR_EraseRootFromParent_Done,
     /* 1210090 */   // Label 17545: @1210090
     /* 1210090 */   GIM_Try, /*On fail goto*//*Label 17546*/ GIMT_Encode4(1210170), // Rule ID 17347 //
     /* 1210095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1210098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1210106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1210109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1210112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1210115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1210130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1210134 */     // MIs[0] round
     /* 1210134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11149:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64),
     /* 1210147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1210165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210169 */     // GIR_Coverage, 17347,
     /* 1210169 */     GIR_EraseRootFromParent_Done,
     /* 1210170 */   // Label 17546: @1210170
     /* 1210170 */   GIM_Try, /*On fail goto*//*Label 17547*/ GIMT_Encode4(1210250), // Rule ID 17350 //
     /* 1210175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1210178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1210186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1210189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1210192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210214 */     // MIs[0] round
     /* 1210214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210224 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1210227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210249 */     // GIR_Coverage, 17350,
     /* 1210249 */     GIR_EraseRootFromParent_Done,
     /* 1210250 */   // Label 17547: @1210250
     /* 1210250 */   GIM_Try, /*On fail goto*//*Label 17548*/ GIMT_Encode4(1210330), // Rule ID 17351 //
     /* 1210255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1210258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1210266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1210269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1210272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210294 */     // MIs[0] round
     /* 1210294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16),
     /* 1210307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210329 */     // GIR_Coverage, 17351,
     /* 1210329 */     GIR_EraseRootFromParent_Done,
     /* 1210330 */   // Label 17548: @1210330
     /* 1210330 */   GIM_Try, /*On fail goto*//*Label 17549*/ GIMT_Encode4(1210410), // Rule ID 17354 //
     /* 1210335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1210338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1210346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1210349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1210352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210374 */     // MIs[0] round
     /* 1210374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210384 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1210387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210409 */     // GIR_Coverage, 17354,
     /* 1210409 */     GIR_EraseRootFromParent_Done,
     /* 1210410 */   // Label 17549: @1210410
     /* 1210410 */   GIM_Try, /*On fail goto*//*Label 17550*/ GIMT_Encode4(1210490), // Rule ID 17355 //
     /* 1210415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1210418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1210426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1210429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1210432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210454 */     // MIs[0] round
     /* 1210454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210464 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16),
     /* 1210467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210489 */     // GIR_Coverage, 17355,
     /* 1210489 */     GIR_EraseRootFromParent_Done,
     /* 1210490 */   // Label 17550: @1210490
     /* 1210490 */   GIM_Try, /*On fail goto*//*Label 17551*/ GIMT_Encode4(1210570), // Rule ID 17358 //
     /* 1210495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1210498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1210506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1210509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1210512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210534 */     // MIs[0] round
     /* 1210534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210544 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1210547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210569 */     // GIR_Coverage, 17358,
     /* 1210569 */     GIR_EraseRootFromParent_Done,
     /* 1210570 */   // Label 17551: @1210570
     /* 1210570 */   GIM_Try, /*On fail goto*//*Label 17552*/ GIMT_Encode4(1210650), // Rule ID 17359 //
     /* 1210575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1210578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1210586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1210589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1210592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1210595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1210610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1210614 */     // MIs[0] round
     /* 1210614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210624 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16),
     /* 1210627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1210645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210649 */     // GIR_Coverage, 17359,
     /* 1210649 */     GIR_EraseRootFromParent_Done,
     /* 1210650 */   // Label 17552: @1210650
     /* 1210650 */   GIM_Try, /*On fail goto*//*Label 17553*/ GIMT_Encode4(1210730), // Rule ID 17362 //
     /* 1210655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1210658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210694 */     // MIs[0] round
     /* 1210694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1210707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210729 */     // GIR_Coverage, 17362,
     /* 1210729 */     GIR_EraseRootFromParent_Done,
     /* 1210730 */   // Label 17553: @1210730
     /* 1210730 */   GIM_Try, /*On fail goto*//*Label 17554*/ GIMT_Encode4(1210810), // Rule ID 17363 //
     /* 1210735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1210738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1210746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1210749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1210752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1210770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210774 */     // MIs[0] round
     /* 1210774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32),
     /* 1210787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210809 */     // GIR_Coverage, 17363,
     /* 1210809 */     GIR_EraseRootFromParent_Done,
     /* 1210810 */   // Label 17554: @1210810
     /* 1210810 */   GIM_Try, /*On fail goto*//*Label 17555*/ GIMT_Encode4(1210890), // Rule ID 17366 //
     /* 1210815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1210818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210854 */     // MIs[0] round
     /* 1210854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210864 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1210864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1210867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210889 */     // GIR_Coverage, 17366,
     /* 1210889 */     GIR_EraseRootFromParent_Done,
     /* 1210890 */   // Label 17555: @1210890
     /* 1210890 */   GIM_Try, /*On fail goto*//*Label 17556*/ GIMT_Encode4(1210970), // Rule ID 17367 //
     /* 1210895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1210898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1210906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1210909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1210912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1210918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1210930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1210934 */     // MIs[0] round
     /* 1210934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1210937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1210944 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1210944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32),
     /* 1210947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1210949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1210951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1210953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1210955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1210957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1210962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1210965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1210968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1210969 */     // GIR_Coverage, 17367,
     /* 1210969 */     GIR_EraseRootFromParent_Done,
     /* 1210970 */   // Label 17556: @1210970
     /* 1210970 */   GIM_Try, /*On fail goto*//*Label 17557*/ GIMT_Encode4(1211050), // Rule ID 17370 //
     /* 1210975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1210978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1210983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1210986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1210989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1210992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1210995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1210998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211014 */     // MIs[0] round
     /* 1211014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211024 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1211027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211049 */     // GIR_Coverage, 17370,
     /* 1211049 */     GIR_EraseRootFromParent_Done,
     /* 1211050 */   // Label 17557: @1211050
     /* 1211050 */   GIM_Try, /*On fail goto*//*Label 17558*/ GIMT_Encode4(1211130), // Rule ID 17371 //
     /* 1211055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1211058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1211066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1211069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1211072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1211075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1211094 */     // MIs[0] round
     /* 1211094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211104 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32),
     /* 1211107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1211125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211129 */     // GIR_Coverage, 17371,
     /* 1211129 */     GIR_EraseRootFromParent_Done,
     /* 1211130 */   // Label 17558: @1211130
     /* 1211130 */   GIM_Try, /*On fail goto*//*Label 17559*/ GIMT_Encode4(1211210), // Rule ID 17374 //
     /* 1211135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1211138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211174 */     // MIs[0] round
     /* 1211174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211184 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1211187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211209 */     // GIR_Coverage, 17374,
     /* 1211209 */     GIR_EraseRootFromParent_Done,
     /* 1211210 */   // Label 17559: @1211210
     /* 1211210 */   GIM_Try, /*On fail goto*//*Label 17560*/ GIMT_Encode4(1211290), // Rule ID 17375 //
     /* 1211215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1211218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1211226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1211229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1211232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1211250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211254 */     // MIs[0] round
     /* 1211254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11149:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64),
     /* 1211267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211289 */     // GIR_Coverage, 17375,
     /* 1211289 */     GIR_EraseRootFromParent_Done,
     /* 1211290 */   // Label 17560: @1211290
     /* 1211290 */   GIM_Try, /*On fail goto*//*Label 17561*/ GIMT_Encode4(1211370), // Rule ID 17378 //
     /* 1211295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1211298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211334 */     // MIs[0] round
     /* 1211334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211344 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1211347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211369 */     // GIR_Coverage, 17378,
     /* 1211369 */     GIR_EraseRootFromParent_Done,
     /* 1211370 */   // Label 17561: @1211370
     /* 1211370 */   GIM_Try, /*On fail goto*//*Label 17562*/ GIMT_Encode4(1211450), // Rule ID 17379 //
     /* 1211375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1211378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1211386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1211389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1211392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1211410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211414 */     // MIs[0] round
     /* 1211414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211424 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11149:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64),
     /* 1211427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211449 */     // GIR_Coverage, 17379,
     /* 1211449 */     GIR_EraseRootFromParent_Done,
     /* 1211450 */   // Label 17562: @1211450
     /* 1211450 */   GIM_Try, /*On fail goto*//*Label 17563*/ GIMT_Encode4(1211530), // Rule ID 17382 //
     /* 1211455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1211458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211494 */     // MIs[0] round
     /* 1211494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211504 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1211507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211529 */     // GIR_Coverage, 17382,
     /* 1211529 */     GIR_EraseRootFromParent_Done,
     /* 1211530 */   // Label 17563: @1211530
     /* 1211530 */   GIM_Try, /*On fail goto*//*Label 17564*/ GIMT_Encode4(1211610), // Rule ID 17383 //
     /* 1211535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1211538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul),
     /* 1211543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1211546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1211549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1211552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1211555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1211570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1211574 */     // MIs[0] round
     /* 1211574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211584 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11149:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMUL_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64),
     /* 1211587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1211605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211609 */     // GIR_Coverage, 17383,
     /* 1211609 */     GIR_EraseRootFromParent_Done,
     /* 1211610 */   // Label 17564: @1211610
     /* 1211610 */   GIM_Try, /*On fail goto*//*Label 17565*/ GIMT_Encode4(1211690), // Rule ID 17386 //
     /* 1211615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1211623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211654 */     // MIs[0] round
     /* 1211654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211664 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1211667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211689 */     // GIR_Coverage, 17386,
     /* 1211689 */     GIR_EraseRootFromParent_Done,
     /* 1211690 */   // Label 17565: @1211690
     /* 1211690 */   GIM_Try, /*On fail goto*//*Label 17566*/ GIMT_Encode4(1211770), // Rule ID 17387 //
     /* 1211695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1211703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1211706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1211709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1211712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1211715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211734 */     // MIs[0] round
     /* 1211734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211744 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 1211747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211769 */     // GIR_Coverage, 17387,
     /* 1211769 */     GIR_EraseRootFromParent_Done,
     /* 1211770 */   // Label 17566: @1211770
     /* 1211770 */   GIM_Try, /*On fail goto*//*Label 17567*/ GIMT_Encode4(1211850), // Rule ID 17390 //
     /* 1211775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1211778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1211783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211814 */     // MIs[0] round
     /* 1211814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211824 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1211827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211849 */     // GIR_Coverage, 17390,
     /* 1211849 */     GIR_EraseRootFromParent_Done,
     /* 1211850 */   // Label 17567: @1211850
     /* 1211850 */   GIM_Try, /*On fail goto*//*Label 17568*/ GIMT_Encode4(1211930), // Rule ID 17391 //
     /* 1211855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1211858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1211863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1211866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1211869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1211872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1211875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1211878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211894 */     // MIs[0] round
     /* 1211894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211904 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1211904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 1211907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1211922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1211925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1211928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1211929 */     // GIR_Coverage, 17391,
     /* 1211929 */     GIR_EraseRootFromParent_Done,
     /* 1211930 */   // Label 17568: @1211930
     /* 1211930 */   GIM_Try, /*On fail goto*//*Label 17569*/ GIMT_Encode4(1212010), // Rule ID 17394 //
     /* 1211935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1211938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1211943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1211946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1211949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1211952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1211955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1211958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1211974 */     // MIs[0] round
     /* 1211974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1211977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1211984 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1211984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1211987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1211989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1211991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1211993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1211995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1211997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212009 */     // GIR_Coverage, 17394,
     /* 1212009 */     GIR_EraseRootFromParent_Done,
     /* 1212010 */   // Label 17569: @1212010
     /* 1212010 */   GIM_Try, /*On fail goto*//*Label 17570*/ GIMT_Encode4(1212090), // Rule ID 17395 //
     /* 1212015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1212026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1212029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1212032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1212035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212054 */     // MIs[0] round
     /* 1212054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212064 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 1212067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212089 */     // GIR_Coverage, 17395,
     /* 1212089 */     GIR_EraseRootFromParent_Done,
     /* 1212090 */   // Label 17570: @1212090
     /* 1212090 */   GIM_Try, /*On fail goto*//*Label 17571*/ GIMT_Encode4(1212170), // Rule ID 17398 //
     /* 1212095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212134 */     // MIs[0] round
     /* 1212134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1212147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212169 */     // GIR_Coverage, 17398,
     /* 1212169 */     GIR_EraseRootFromParent_Done,
     /* 1212170 */   // Label 17571: @1212170
     /* 1212170 */   GIM_Try, /*On fail goto*//*Label 17572*/ GIMT_Encode4(1212250), // Rule ID 17399 //
     /* 1212175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1212186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1212189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1212192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1212195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212214 */     // MIs[0] round
     /* 1212214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 1212227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212249 */     // GIR_Coverage, 17399,
     /* 1212249 */     GIR_EraseRootFromParent_Done,
     /* 1212250 */   // Label 17572: @1212250
     /* 1212250 */   GIM_Try, /*On fail goto*//*Label 17573*/ GIMT_Encode4(1212330), // Rule ID 17402 //
     /* 1212255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1212258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212294 */     // MIs[0] round
     /* 1212294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1212307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212329 */     // GIR_Coverage, 17402,
     /* 1212329 */     GIR_EraseRootFromParent_Done,
     /* 1212330 */   // Label 17573: @1212330
     /* 1212330 */   GIM_Try, /*On fail goto*//*Label 17574*/ GIMT_Encode4(1212410), // Rule ID 17403 //
     /* 1212335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1212338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1212346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1212349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1212352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1212355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212374 */     // MIs[0] round
     /* 1212374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 1212387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1212405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212409 */     // GIR_Coverage, 17403,
     /* 1212409 */     GIR_EraseRootFromParent_Done,
     /* 1212410 */   // Label 17574: @1212410
     /* 1212410 */   GIM_Try, /*On fail goto*//*Label 17575*/ GIMT_Encode4(1212490), // Rule ID 17406 //
     /* 1212415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1212418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212454 */     // MIs[0] round
     /* 1212454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1212467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212489 */     // GIR_Coverage, 17406,
     /* 1212489 */     GIR_EraseRootFromParent_Done,
     /* 1212490 */   // Label 17575: @1212490
     /* 1212490 */   GIM_Try, /*On fail goto*//*Label 17576*/ GIMT_Encode4(1212570), // Rule ID 17407 //
     /* 1212495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1212498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1212506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1212509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1212512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1212515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1212534 */     // MIs[0] round
     /* 1212534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212544 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 1212547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1212565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212569 */     // GIR_Coverage, 17407,
     /* 1212569 */     GIR_EraseRootFromParent_Done,
     /* 1212570 */   // Label 17576: @1212570
     /* 1212570 */   GIM_Try, /*On fail goto*//*Label 17577*/ GIMT_Encode4(1212650), // Rule ID 17410 //
     /* 1212575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212614 */     // MIs[0] round
     /* 1212614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212624 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1212627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212649 */     // GIR_Coverage, 17410,
     /* 1212649 */     GIR_EraseRootFromParent_Done,
     /* 1212650 */   // Label 17577: @1212650
     /* 1212650 */   GIM_Try, /*On fail goto*//*Label 17578*/ GIMT_Encode4(1212730), // Rule ID 17411 //
     /* 1212655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1212666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1212669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1212672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1212675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1212694 */     // MIs[0] round
     /* 1212694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212704 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 1212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212729 */     // GIR_Coverage, 17411,
     /* 1212729 */     GIR_EraseRootFromParent_Done,
     /* 1212730 */   // Label 17578: @1212730
     /* 1212730 */   GIM_Try, /*On fail goto*//*Label 17579*/ GIMT_Encode4(1212810), // Rule ID 17414 //
     /* 1212735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212774 */     // MIs[0] round
     /* 1212774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212784 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1212787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212809 */     // GIR_Coverage, 17414,
     /* 1212809 */     GIR_EraseRootFromParent_Done,
     /* 1212810 */   // Label 17579: @1212810
     /* 1212810 */   GIM_Try, /*On fail goto*//*Label 17580*/ GIMT_Encode4(1212890), // Rule ID 17415 //
     /* 1212815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1212826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1212829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1212832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1212835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1212854 */     // MIs[0] round
     /* 1212854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212864 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 1212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212889 */     // GIR_Coverage, 17415,
     /* 1212889 */     GIR_EraseRootFromParent_Done,
     /* 1212890 */   // Label 17580: @1212890
     /* 1212890 */   GIM_Try, /*On fail goto*//*Label 17581*/ GIMT_Encode4(1212970), // Rule ID 17418 //
     /* 1212895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1212898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1212918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1212934 */     // MIs[0] round
     /* 1212934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1212937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1212944 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1212944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1212947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1212949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1212951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1212953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1212955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1212957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1212962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1212965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1212968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1212969 */     // GIR_Coverage, 17418,
     /* 1212969 */     GIR_EraseRootFromParent_Done,
     /* 1212970 */   // Label 17581: @1212970
     /* 1212970 */   GIM_Try, /*On fail goto*//*Label 17582*/ GIMT_Encode4(1213050), // Rule ID 17419 //
     /* 1212975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1212978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1212983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1212986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1212989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1212992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1212995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1212998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213014 */     // MIs[0] round
     /* 1213014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213024 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 1213027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1213045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213049 */     // GIR_Coverage, 17419,
     /* 1213049 */     GIR_EraseRootFromParent_Done,
     /* 1213050 */   // Label 17582: @1213050
     /* 1213050 */   GIM_Try, /*On fail goto*//*Label 17583*/ GIMT_Encode4(1213130), // Rule ID 17422 //
     /* 1213055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213094 */     // MIs[0] round
     /* 1213094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213104 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1213107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213129 */     // GIR_Coverage, 17422,
     /* 1213129 */     GIR_EraseRootFromParent_Done,
     /* 1213130 */   // Label 17583: @1213130
     /* 1213130 */   GIM_Try, /*On fail goto*//*Label 17584*/ GIMT_Encode4(1213210), // Rule ID 17423 //
     /* 1213135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1213146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1213149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1213152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1213155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213174 */     // MIs[0] round
     /* 1213174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213184 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 1213187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213209 */     // GIR_Coverage, 17423,
     /* 1213209 */     GIR_EraseRootFromParent_Done,
     /* 1213210 */   // Label 17584: @1213210
     /* 1213210 */   GIM_Try, /*On fail goto*//*Label 17585*/ GIMT_Encode4(1213290), // Rule ID 17426 //
     /* 1213215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213254 */     // MIs[0] round
     /* 1213254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213264 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1213267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213289 */     // GIR_Coverage, 17426,
     /* 1213289 */     GIR_EraseRootFromParent_Done,
     /* 1213290 */   // Label 17585: @1213290
     /* 1213290 */   GIM_Try, /*On fail goto*//*Label 17586*/ GIMT_Encode4(1213370), // Rule ID 17427 //
     /* 1213295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1213306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1213309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1213312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1213315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213334 */     // MIs[0] round
     /* 1213334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213344 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 1213347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213369 */     // GIR_Coverage, 17427,
     /* 1213369 */     GIR_EraseRootFromParent_Done,
     /* 1213370 */   // Label 17586: @1213370
     /* 1213370 */   GIM_Try, /*On fail goto*//*Label 17587*/ GIMT_Encode4(1213450), // Rule ID 17430 //
     /* 1213375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1213378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213414 */     // MIs[0] round
     /* 1213414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1213427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213449 */     // GIR_Coverage, 17430,
     /* 1213449 */     GIR_EraseRootFromParent_Done,
     /* 1213450 */   // Label 17587: @1213450
     /* 1213450 */   GIM_Try, /*On fail goto*//*Label 17588*/ GIMT_Encode4(1213530), // Rule ID 17431 //
     /* 1213455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1213458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1213466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1213469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1213472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1213475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213494 */     // MIs[0] round
     /* 1213494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213504 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 1213507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1213525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213529 */     // GIR_Coverage, 17431,
     /* 1213529 */     GIR_EraseRootFromParent_Done,
     /* 1213530 */   // Label 17588: @1213530
     /* 1213530 */   GIM_Try, /*On fail goto*//*Label 17589*/ GIMT_Encode4(1213610), // Rule ID 17434 //
     /* 1213535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213574 */     // MIs[0] round
     /* 1213574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1213587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213609 */     // GIR_Coverage, 17434,
     /* 1213609 */     GIR_EraseRootFromParent_Done,
     /* 1213610 */   // Label 17589: @1213610
     /* 1213610 */   GIM_Try, /*On fail goto*//*Label 17590*/ GIMT_Encode4(1213690), // Rule ID 17435 //
     /* 1213615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1213626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1213629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1213632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1213635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1213654 */     // MIs[0] round
     /* 1213654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 1213667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213689 */     // GIR_Coverage, 17435,
     /* 1213689 */     GIR_EraseRootFromParent_Done,
     /* 1213690 */   // Label 17590: @1213690
     /* 1213690 */   GIM_Try, /*On fail goto*//*Label 17591*/ GIMT_Encode4(1213770), // Rule ID 17438 //
     /* 1213695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213734 */     // MIs[0] round
     /* 1213734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213744 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1213747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213769 */     // GIR_Coverage, 17438,
     /* 1213769 */     GIR_EraseRootFromParent_Done,
     /* 1213770 */   // Label 17591: @1213770
     /* 1213770 */   GIM_Try, /*On fail goto*//*Label 17592*/ GIMT_Encode4(1213850), // Rule ID 17439 //
     /* 1213775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1213786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1213789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1213792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1213795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1213814 */     // MIs[0] round
     /* 1213814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213824 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 1213827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213849 */     // GIR_Coverage, 17439,
     /* 1213849 */     GIR_EraseRootFromParent_Done,
     /* 1213850 */   // Label 17592: @1213850
     /* 1213850 */   GIM_Try, /*On fail goto*//*Label 17593*/ GIMT_Encode4(1213930), // Rule ID 17442 //
     /* 1213855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1213858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1213878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213894 */     // MIs[0] round
     /* 1213894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213904 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1213904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1213907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1213922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1213925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1213928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1213929 */     // GIR_Coverage, 17442,
     /* 1213929 */     GIR_EraseRootFromParent_Done,
     /* 1213930 */   // Label 17593: @1213930
     /* 1213930 */   GIM_Try, /*On fail goto*//*Label 17594*/ GIMT_Encode4(1214010), // Rule ID 17443 //
     /* 1213935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1213938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1213943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1213946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1213949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1213952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1213955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1213958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1213974 */     // MIs[0] round
     /* 1213974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1213977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1213984 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1213984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 1213987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1213989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1213991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1213993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1213995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1213997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214009 */     // GIR_Coverage, 17443,
     /* 1214009 */     GIR_EraseRootFromParent_Done,
     /* 1214010 */   // Label 17594: @1214010
     /* 1214010 */   GIM_Try, /*On fail goto*//*Label 17595*/ GIMT_Encode4(1214090), // Rule ID 17446 //
     /* 1214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214054 */     // MIs[0] round
     /* 1214054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214064 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1214067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214089 */     // GIR_Coverage, 17446,
     /* 1214089 */     GIR_EraseRootFromParent_Done,
     /* 1214090 */   // Label 17595: @1214090
     /* 1214090 */   GIM_Try, /*On fail goto*//*Label 17596*/ GIMT_Encode4(1214170), // Rule ID 17447 //
     /* 1214095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1214106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1214109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1214112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214134 */     // MIs[0] round
     /* 1214134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214144 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16),
     /* 1214147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214169 */     // GIR_Coverage, 17447,
     /* 1214169 */     GIR_EraseRootFromParent_Done,
     /* 1214170 */   // Label 17596: @1214170
     /* 1214170 */   GIM_Try, /*On fail goto*//*Label 17597*/ GIMT_Encode4(1214250), // Rule ID 17450 //
     /* 1214175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214214 */     // MIs[0] round
     /* 1214214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214224 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1214227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214249 */     // GIR_Coverage, 17450,
     /* 1214249 */     GIR_EraseRootFromParent_Done,
     /* 1214250 */   // Label 17597: @1214250
     /* 1214250 */   GIM_Try, /*On fail goto*//*Label 17598*/ GIMT_Encode4(1214330), // Rule ID 17451 //
     /* 1214255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1214266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1214269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1214272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214294 */     // MIs[0] round
     /* 1214294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214304 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16),
     /* 1214307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214329 */     // GIR_Coverage, 17451,
     /* 1214329 */     GIR_EraseRootFromParent_Done,
     /* 1214330 */   // Label 17598: @1214330
     /* 1214330 */   GIM_Try, /*On fail goto*//*Label 17599*/ GIMT_Encode4(1214410), // Rule ID 17454 //
     /* 1214335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214374 */     // MIs[0] round
     /* 1214374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1214387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214409 */     // GIR_Coverage, 17454,
     /* 1214409 */     GIR_EraseRootFromParent_Done,
     /* 1214410 */   // Label 17599: @1214410
     /* 1214410 */   GIM_Try, /*On fail goto*//*Label 17600*/ GIMT_Encode4(1214490), // Rule ID 17455 //
     /* 1214415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1214426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1214429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1214432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214454 */     // MIs[0] round
     /* 1214454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214464 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32),
     /* 1214467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214489 */     // GIR_Coverage, 17455,
     /* 1214489 */     GIR_EraseRootFromParent_Done,
     /* 1214490 */   // Label 17600: @1214490
     /* 1214490 */   GIM_Try, /*On fail goto*//*Label 17601*/ GIMT_Encode4(1214570), // Rule ID 17458 //
     /* 1214495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214534 */     // MIs[0] round
     /* 1214534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214544 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1214547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214569 */     // GIR_Coverage, 17458,
     /* 1214569 */     GIR_EraseRootFromParent_Done,
     /* 1214570 */   // Label 17601: @1214570
     /* 1214570 */   GIM_Try, /*On fail goto*//*Label 17602*/ GIMT_Encode4(1214650), // Rule ID 17459 //
     /* 1214575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1214578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1214586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1214589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1214592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1214614 */     // MIs[0] round
     /* 1214614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214624 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11132:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16),
     /* 1214627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1214645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214649 */     // GIR_Coverage, 17459,
     /* 1214649 */     GIR_EraseRootFromParent_Done,
     /* 1214650 */   // Label 17602: @1214650
     /* 1214650 */   GIM_Try, /*On fail goto*//*Label 17603*/ GIMT_Encode4(1214730), // Rule ID 17462 //
     /* 1214655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1214658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214694 */     // MIs[0] round
     /* 1214694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1214707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214729 */     // GIR_Coverage, 17462,
     /* 1214729 */     GIR_EraseRootFromParent_Done,
     /* 1214730 */   // Label 17603: @1214730
     /* 1214730 */   GIM_Try, /*On fail goto*//*Label 17604*/ GIMT_Encode4(1214810), // Rule ID 17463 //
     /* 1214735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1214738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1214746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1214749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1214752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1214755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1214774 */     // MIs[0] round
     /* 1214774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214784 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11132:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32),
     /* 1214787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1214805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214809 */     // GIR_Coverage, 17463,
     /* 1214809 */     GIR_EraseRootFromParent_Done,
     /* 1214810 */   // Label 17604: @1214810
     /* 1214810 */   GIM_Try, /*On fail goto*//*Label 17605*/ GIMT_Encode4(1214890), // Rule ID 17466 //
     /* 1214815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1214818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214854 */     // MIs[0] round
     /* 1214854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1214864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1214867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214889 */     // GIR_Coverage, 17466,
     /* 1214889 */     GIR_EraseRootFromParent_Done,
     /* 1214890 */   // Label 17605: @1214890
     /* 1214890 */   GIM_Try, /*On fail goto*//*Label 17606*/ GIMT_Encode4(1214970), // Rule ID 17467 //
     /* 1214895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1214898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1214906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1214909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1214912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1214915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1214918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1214930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1214934 */     // MIs[0] round
     /* 1214934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1214937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1214944 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11132:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1214944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64),
     /* 1214947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1214949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1214951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1214953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1214955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1214957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1214962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1214965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1214968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1214969 */     // GIR_Coverage, 17467,
     /* 1214969 */     GIR_EraseRootFromParent_Done,
     /* 1214970 */   // Label 17606: @1214970
     /* 1214970 */   GIM_Try, /*On fail goto*//*Label 17607*/ GIMT_Encode4(1215050), // Rule ID 17470 //
     /* 1214975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1214978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1214983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1214986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1214989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1214992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1214995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1214998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215014 */     // MIs[0] round
     /* 1215014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215024 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1215027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215049 */     // GIR_Coverage, 17470,
     /* 1215049 */     GIR_EraseRootFromParent_Done,
     /* 1215050 */   // Label 17607: @1215050
     /* 1215050 */   GIM_Try, /*On fail goto*//*Label 17608*/ GIMT_Encode4(1215130), // Rule ID 17471 //
     /* 1215055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1215066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1215069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1215072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215094 */     // MIs[0] round
     /* 1215094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215104 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16),
     /* 1215107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215129 */     // GIR_Coverage, 17471,
     /* 1215129 */     GIR_EraseRootFromParent_Done,
     /* 1215130 */   // Label 17608: @1215130
     /* 1215130 */   GIM_Try, /*On fail goto*//*Label 17609*/ GIMT_Encode4(1215210), // Rule ID 17474 //
     /* 1215135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215174 */     // MIs[0] round
     /* 1215174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215184 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1215187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215209 */     // GIR_Coverage, 17474,
     /* 1215209 */     GIR_EraseRootFromParent_Done,
     /* 1215210 */   // Label 17609: @1215210
     /* 1215210 */   GIM_Try, /*On fail goto*//*Label 17610*/ GIMT_Encode4(1215290), // Rule ID 17475 //
     /* 1215215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1215226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1215229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1215232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215254 */     // MIs[0] round
     /* 1215254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215264 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16),
     /* 1215267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215289 */     // GIR_Coverage, 17475,
     /* 1215289 */     GIR_EraseRootFromParent_Done,
     /* 1215290 */   // Label 17610: @1215290
     /* 1215290 */   GIM_Try, /*On fail goto*//*Label 17611*/ GIMT_Encode4(1215370), // Rule ID 17478 //
     /* 1215295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1215298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215334 */     // MIs[0] round
     /* 1215334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215344 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1215347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215369 */     // GIR_Coverage, 17478,
     /* 1215369 */     GIR_EraseRootFromParent_Done,
     /* 1215370 */   // Label 17611: @1215370
     /* 1215370 */   GIM_Try, /*On fail goto*//*Label 17612*/ GIMT_Encode4(1215450), // Rule ID 17479 //
     /* 1215375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1215378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1215386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1215389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1215392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1215395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1215414 */     // MIs[0] round
     /* 1215414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215424 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16),
     /* 1215427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1215445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215449 */     // GIR_Coverage, 17479,
     /* 1215449 */     GIR_EraseRootFromParent_Done,
     /* 1215450 */   // Label 17612: @1215450
     /* 1215450 */   GIM_Try, /*On fail goto*//*Label 17613*/ GIMT_Encode4(1215530), // Rule ID 17482 //
     /* 1215455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215494 */     // MIs[0] round
     /* 1215494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215504 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1215507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215529 */     // GIR_Coverage, 17482,
     /* 1215529 */     GIR_EraseRootFromParent_Done,
     /* 1215530 */   // Label 17613: @1215530
     /* 1215530 */   GIM_Try, /*On fail goto*//*Label 17614*/ GIMT_Encode4(1215610), // Rule ID 17483 //
     /* 1215535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1215546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1215549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1215552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215574 */     // MIs[0] round
     /* 1215574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215584 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32),
     /* 1215587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215609 */     // GIR_Coverage, 17483,
     /* 1215609 */     GIR_EraseRootFromParent_Done,
     /* 1215610 */   // Label 17614: @1215610
     /* 1215610 */   GIM_Try, /*On fail goto*//*Label 17615*/ GIMT_Encode4(1215690), // Rule ID 17486 //
     /* 1215615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215654 */     // MIs[0] round
     /* 1215654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215664 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1215667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215689 */     // GIR_Coverage, 17486,
     /* 1215689 */     GIR_EraseRootFromParent_Done,
     /* 1215690 */   // Label 17615: @1215690
     /* 1215690 */   GIM_Try, /*On fail goto*//*Label 17616*/ GIMT_Encode4(1215770), // Rule ID 17487 //
     /* 1215695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1215706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1215709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1215712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1215730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215734 */     // MIs[0] round
     /* 1215734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215744 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32),
     /* 1215747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215769 */     // GIR_Coverage, 17487,
     /* 1215769 */     GIR_EraseRootFromParent_Done,
     /* 1215770 */   // Label 17616: @1215770
     /* 1215770 */   GIM_Try, /*On fail goto*//*Label 17617*/ GIMT_Encode4(1215850), // Rule ID 17490 //
     /* 1215775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1215778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215814 */     // MIs[0] round
     /* 1215814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215824 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1215827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215849 */     // GIR_Coverage, 17490,
     /* 1215849 */     GIR_EraseRootFromParent_Done,
     /* 1215850 */   // Label 17617: @1215850
     /* 1215850 */   GIM_Try, /*On fail goto*//*Label 17618*/ GIMT_Encode4(1215930), // Rule ID 17491 //
     /* 1215855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1215858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1215866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1215869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1215872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1215875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1215878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1215890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1215894 */     // MIs[0] round
     /* 1215894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215904 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1215904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32),
     /* 1215907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1215922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1215925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1215928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1215929 */     // GIR_Coverage, 17491,
     /* 1215929 */     GIR_EraseRootFromParent_Done,
     /* 1215930 */   // Label 17618: @1215930
     /* 1215930 */   GIM_Try, /*On fail goto*//*Label 17619*/ GIMT_Encode4(1216010), // Rule ID 17494 //
     /* 1215935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1215938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1215943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1215946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1215949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1215952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1215955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1215958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1215970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1215974 */     // MIs[0] round
     /* 1215974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1215977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1215984 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1215984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1215987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1215989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1215991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1215993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1215995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1215997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216009 */     // GIR_Coverage, 17494,
     /* 1216009 */     GIR_EraseRootFromParent_Done,
     /* 1216010 */   // Label 17619: @1216010
     /* 1216010 */   GIM_Try, /*On fail goto*//*Label 17620*/ GIMT_Encode4(1216090), // Rule ID 17495 //
     /* 1216015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1216026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1216029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1216032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1216050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216054 */     // MIs[0] round
     /* 1216054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216064 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11132:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64),
     /* 1216067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216089 */     // GIR_Coverage, 17495,
     /* 1216089 */     GIR_EraseRootFromParent_Done,
     /* 1216090 */   // Label 17620: @1216090
     /* 1216090 */   GIM_Try, /*On fail goto*//*Label 17621*/ GIMT_Encode4(1216170), // Rule ID 17498 //
     /* 1216095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216134 */     // MIs[0] round
     /* 1216134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1216147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216169 */     // GIR_Coverage, 17498,
     /* 1216169 */     GIR_EraseRootFromParent_Done,
     /* 1216170 */   // Label 17621: @1216170
     /* 1216170 */   GIM_Try, /*On fail goto*//*Label 17622*/ GIMT_Encode4(1216250), // Rule ID 17499 //
     /* 1216175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1216186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1216189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1216192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1216210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216214 */     // MIs[0] round
     /* 1216214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216224 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11132:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64),
     /* 1216227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216249 */     // GIR_Coverage, 17499,
     /* 1216249 */     GIR_EraseRootFromParent_Done,
     /* 1216250 */   // Label 17622: @1216250
     /* 1216250 */   GIM_Try, /*On fail goto*//*Label 17623*/ GIMT_Encode4(1216330), // Rule ID 17502 //
     /* 1216255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1216258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216294 */     // MIs[0] round
     /* 1216294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216304 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1216307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216329 */     // GIR_Coverage, 17502,
     /* 1216329 */     GIR_EraseRootFromParent_Done,
     /* 1216330 */   // Label 17623: @1216330
     /* 1216330 */   GIM_Try, /*On fail goto*//*Label 17624*/ GIMT_Encode4(1216410), // Rule ID 17503 //
     /* 1216335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1216338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv),
     /* 1216343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1216346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1216349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1216352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1216355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1216370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1216374 */     // MIs[0] round
     /* 1216374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216384 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11132:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64),
     /* 1216387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1216405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216409 */     // GIR_Coverage, 17503,
     /* 1216409 */     GIR_EraseRootFromParent_Done,
     /* 1216410 */   // Label 17624: @1216410
     /* 1216410 */   GIM_Try, /*On fail goto*//*Label 17625*/ GIMT_Encode4(1216490), // Rule ID 17506 //
     /* 1216415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1216454 */     // MIs[0] round
     /* 1216454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216464 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1216467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216489 */     // GIR_Coverage, 17506,
     /* 1216489 */     GIR_EraseRootFromParent_Done,
     /* 1216490 */   // Label 17625: @1216490
     /* 1216490 */   GIM_Try, /*On fail goto*//*Label 17626*/ GIMT_Encode4(1216570), // Rule ID 17507 //
     /* 1216495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1216506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1216509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1216512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1216534 */     // MIs[0] round
     /* 1216534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216544 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16),
     /* 1216547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216569 */     // GIR_Coverage, 17507,
     /* 1216569 */     GIR_EraseRootFromParent_Done,
     /* 1216570 */   // Label 17626: @1216570
     /* 1216570 */   GIM_Try, /*On fail goto*//*Label 17627*/ GIMT_Encode4(1216650), // Rule ID 17510 //
     /* 1216575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1216614 */     // MIs[0] round
     /* 1216614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216624 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1216627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216649 */     // GIR_Coverage, 17510,
     /* 1216649 */     GIR_EraseRootFromParent_Done,
     /* 1216650 */   // Label 17627: @1216650
     /* 1216650 */   GIM_Try, /*On fail goto*//*Label 17628*/ GIMT_Encode4(1216730), // Rule ID 17511 //
     /* 1216655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1216666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1216669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1216672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1216694 */     // MIs[0] round
     /* 1216694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216704 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16),
     /* 1216707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216729 */     // GIR_Coverage, 17511,
     /* 1216729 */     GIR_EraseRootFromParent_Done,
     /* 1216730 */   // Label 17628: @1216730
     /* 1216730 */   GIM_Try, /*On fail goto*//*Label 17629*/ GIMT_Encode4(1216810), // Rule ID 17514 //
     /* 1216735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1216738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216774 */     // MIs[0] round
     /* 1216774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216784 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1216787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216809 */     // GIR_Coverage, 17514,
     /* 1216809 */     GIR_EraseRootFromParent_Done,
     /* 1216810 */   // Label 17629: @1216810
     /* 1216810 */   GIM_Try, /*On fail goto*//*Label 17630*/ GIMT_Encode4(1216890), // Rule ID 17515 //
     /* 1216815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1216818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1216826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1216829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1216832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1216835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1216854 */     // MIs[0] round
     /* 1216854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1216864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32),
     /* 1216867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1216885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216889 */     // GIR_Coverage, 17515,
     /* 1216889 */     GIR_EraseRootFromParent_Done,
     /* 1216890 */   // Label 17630: @1216890
     /* 1216890 */   GIM_Try, /*On fail goto*//*Label 17631*/ GIMT_Encode4(1216970), // Rule ID 17518 //
     /* 1216895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1216898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1216918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1216930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1216934 */     // MIs[0] round
     /* 1216934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1216937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1216944 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1216944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1216947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1216949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1216951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1216953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1216955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1216957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1216962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1216965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1216968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1216969 */     // GIR_Coverage, 17518,
     /* 1216969 */     GIR_EraseRootFromParent_Done,
     /* 1216970 */   // Label 17631: @1216970
     /* 1216970 */   GIM_Try, /*On fail goto*//*Label 17632*/ GIMT_Encode4(1217050), // Rule ID 17519 //
     /* 1216975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1216978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1216983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1216986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1216989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1216992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1216995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1216998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217014 */     // MIs[0] round
     /* 1217014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217024 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11180:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16),
     /* 1217027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217049 */     // GIR_Coverage, 17519,
     /* 1217049 */     GIR_EraseRootFromParent_Done,
     /* 1217050 */   // Label 17632: @1217050
     /* 1217050 */   GIM_Try, /*On fail goto*//*Label 17633*/ GIMT_Encode4(1217130), // Rule ID 17522 //
     /* 1217055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1217075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1217094 */     // MIs[0] round
     /* 1217094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1217107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217129 */     // GIR_Coverage, 17522,
     /* 1217129 */     GIR_EraseRootFromParent_Done,
     /* 1217130 */   // Label 17633: @1217130
     /* 1217130 */   GIM_Try, /*On fail goto*//*Label 17634*/ GIMT_Encode4(1217210), // Rule ID 17523 //
     /* 1217135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1217146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1217149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1217152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1217155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1217174 */     // MIs[0] round
     /* 1217174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11180:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32),
     /* 1217187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217209 */     // GIR_Coverage, 17523,
     /* 1217209 */     GIR_EraseRootFromParent_Done,
     /* 1217210 */   // Label 17634: @1217210
     /* 1217210 */   GIM_Try, /*On fail goto*//*Label 17635*/ GIMT_Encode4(1217290), // Rule ID 17526 //
     /* 1217215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1217218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1217235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1217254 */     // MIs[0] round
     /* 1217254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217264 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1217267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217289 */     // GIR_Coverage, 17526,
     /* 1217289 */     GIR_EraseRootFromParent_Done,
     /* 1217290 */   // Label 17635: @1217290
     /* 1217290 */   GIM_Try, /*On fail goto*//*Label 17636*/ GIMT_Encode4(1217370), // Rule ID 17527 //
     /* 1217295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1217298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1217306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1217309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1217312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1217315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1217330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1217334 */     // MIs[0] round
     /* 1217334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217344 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11180:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64),
     /* 1217347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1217365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217369 */     // GIR_Coverage, 17527,
     /* 1217369 */     GIR_EraseRootFromParent_Done,
     /* 1217370 */   // Label 17636: @1217370
     /* 1217370 */   GIM_Try, /*On fail goto*//*Label 17637*/ GIMT_Encode4(1217450), // Rule ID 17530 //
     /* 1217375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217414 */     // MIs[0] round
     /* 1217414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217424 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1217427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217449 */     // GIR_Coverage, 17530,
     /* 1217449 */     GIR_EraseRootFromParent_Done,
     /* 1217450 */   // Label 17637: @1217450
     /* 1217450 */   GIM_Try, /*On fail goto*//*Label 17638*/ GIMT_Encode4(1217530), // Rule ID 17531 //
     /* 1217455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1217466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1217469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1217472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217494 */     // MIs[0] round
     /* 1217494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217504 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16),
     /* 1217507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217529 */     // GIR_Coverage, 17531,
     /* 1217529 */     GIR_EraseRootFromParent_Done,
     /* 1217530 */   // Label 17638: @1217530
     /* 1217530 */   GIM_Try, /*On fail goto*//*Label 17639*/ GIMT_Encode4(1217610), // Rule ID 17534 //
     /* 1217535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217574 */     // MIs[0] round
     /* 1217574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217584 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1217587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217609 */     // GIR_Coverage, 17534,
     /* 1217609 */     GIR_EraseRootFromParent_Done,
     /* 1217610 */   // Label 17639: @1217610
     /* 1217610 */   GIM_Try, /*On fail goto*//*Label 17640*/ GIMT_Encode4(1217690), // Rule ID 17535 //
     /* 1217615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1217626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1217629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1217632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1217650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217654 */     // MIs[0] round
     /* 1217654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217664 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16),
     /* 1217667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217689 */     // GIR_Coverage, 17535,
     /* 1217689 */     GIR_EraseRootFromParent_Done,
     /* 1217690 */   // Label 17640: @1217690
     /* 1217690 */   GIM_Try, /*On fail goto*//*Label 17641*/ GIMT_Encode4(1217770), // Rule ID 17538 //
     /* 1217695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1217698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217734 */     // MIs[0] round
     /* 1217734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217744 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1217747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217769 */     // GIR_Coverage, 17538,
     /* 1217769 */     GIR_EraseRootFromParent_Done,
     /* 1217770 */   // Label 17641: @1217770
     /* 1217770 */   GIM_Try, /*On fail goto*//*Label 17642*/ GIMT_Encode4(1217850), // Rule ID 17539 //
     /* 1217775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1217778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1217786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1217789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1217792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1217795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1217810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1217814 */     // MIs[0] round
     /* 1217814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217824 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16),
     /* 1217827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1217845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217849 */     // GIR_Coverage, 17539,
     /* 1217849 */     GIR_EraseRootFromParent_Done,
     /* 1217850 */   // Label 17642: @1217850
     /* 1217850 */   GIM_Try, /*On fail goto*//*Label 17643*/ GIMT_Encode4(1217930), // Rule ID 17542 //
     /* 1217855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1217858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1217875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1217878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1217894 */     // MIs[0] round
     /* 1217894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217904 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1217904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1217907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1217922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1217925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1217928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1217929 */     // GIR_Coverage, 17542,
     /* 1217929 */     GIR_EraseRootFromParent_Done,
     /* 1217930 */   // Label 17643: @1217930
     /* 1217930 */   GIM_Try, /*On fail goto*//*Label 17644*/ GIMT_Encode4(1218010), // Rule ID 17543 //
     /* 1217935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1217938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1217943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1217946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1217949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1217952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1217955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1217958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1217970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1217974 */     // MIs[0] round
     /* 1217974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1217977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1217984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1217984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32),
     /* 1217987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1217989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1217991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1217993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1217995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1217997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218009 */     // GIR_Coverage, 17543,
     /* 1218009 */     GIR_EraseRootFromParent_Done,
     /* 1218010 */   // Label 17644: @1218010
     /* 1218010 */   GIM_Try, /*On fail goto*//*Label 17645*/ GIMT_Encode4(1218090), // Rule ID 17546 //
     /* 1218015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218054 */     // MIs[0] round
     /* 1218054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218064 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1218067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218089 */     // GIR_Coverage, 17546,
     /* 1218089 */     GIR_EraseRootFromParent_Done,
     /* 1218090 */   // Label 17645: @1218090
     /* 1218090 */   GIM_Try, /*On fail goto*//*Label 17646*/ GIMT_Encode4(1218170), // Rule ID 17547 //
     /* 1218095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1218106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1218109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1218112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218134 */     // MIs[0] round
     /* 1218134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218144 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32),
     /* 1218147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218169 */     // GIR_Coverage, 17547,
     /* 1218169 */     GIR_EraseRootFromParent_Done,
     /* 1218170 */   // Label 17646: @1218170
     /* 1218170 */   GIM_Try, /*On fail goto*//*Label 17647*/ GIMT_Encode4(1218250), // Rule ID 17550 //
     /* 1218175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1218178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218214 */     // MIs[0] round
     /* 1218214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218224 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1218227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218249 */     // GIR_Coverage, 17550,
     /* 1218249 */     GIR_EraseRootFromParent_Done,
     /* 1218250 */   // Label 17647: @1218250
     /* 1218250 */   GIM_Try, /*On fail goto*//*Label 17648*/ GIMT_Encode4(1218330), // Rule ID 17551 //
     /* 1218255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1218258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1218266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1218269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1218272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1218275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1218294 */     // MIs[0] round
     /* 1218294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218304 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32),
     /* 1218307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1218325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218329 */     // GIR_Coverage, 17551,
     /* 1218329 */     GIR_EraseRootFromParent_Done,
     /* 1218330 */   // Label 17648: @1218330
     /* 1218330 */   GIM_Try, /*On fail goto*//*Label 17649*/ GIMT_Encode4(1218410), // Rule ID 17554 //
     /* 1218335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218374 */     // MIs[0] round
     /* 1218374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218384 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1218387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218409 */     // GIR_Coverage, 17554,
     /* 1218409 */     GIR_EraseRootFromParent_Done,
     /* 1218410 */   // Label 17649: @1218410
     /* 1218410 */   GIM_Try, /*On fail goto*//*Label 17650*/ GIMT_Encode4(1218490), // Rule ID 17555 //
     /* 1218415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1218426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1218429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1218432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1218450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218454 */     // MIs[0] round
     /* 1218454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218464 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11180:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64),
     /* 1218467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218489 */     // GIR_Coverage, 17555,
     /* 1218489 */     GIR_EraseRootFromParent_Done,
     /* 1218490 */   // Label 17650: @1218490
     /* 1218490 */   GIM_Try, /*On fail goto*//*Label 17651*/ GIMT_Encode4(1218570), // Rule ID 17558 //
     /* 1218495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218534 */     // MIs[0] round
     /* 1218534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218544 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1218547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218569 */     // GIR_Coverage, 17558,
     /* 1218569 */     GIR_EraseRootFromParent_Done,
     /* 1218570 */   // Label 17651: @1218570
     /* 1218570 */   GIM_Try, /*On fail goto*//*Label 17652*/ GIMT_Encode4(1218650), // Rule ID 17559 //
     /* 1218575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1218586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1218589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1218592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1218610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218614 */     // MIs[0] round
     /* 1218614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218624 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11180:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64),
     /* 1218627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218649 */     // GIR_Coverage, 17559,
     /* 1218649 */     GIR_EraseRootFromParent_Done,
     /* 1218650 */   // Label 17652: @1218650
     /* 1218650 */   GIM_Try, /*On fail goto*//*Label 17653*/ GIMT_Encode4(1218730), // Rule ID 17562 //
     /* 1218655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1218658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218694 */     // MIs[0] round
     /* 1218694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218704 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1218707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218729 */     // GIR_Coverage, 17562,
     /* 1218729 */     GIR_EraseRootFromParent_Done,
     /* 1218730 */   // Label 17653: @1218730
     /* 1218730 */   GIM_Try, /*On fail goto*//*Label 17654*/ GIMT_Encode4(1218810), // Rule ID 17563 //
     /* 1218735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1218738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv),
     /* 1218743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1218746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1218749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1218752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1218755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1218770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1218774 */     // MIs[0] round
     /* 1218774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218784 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11180:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFRDIV_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64),
     /* 1218787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1218805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218809 */     // GIR_Coverage, 17563,
     /* 1218809 */     GIR_EraseRootFromParent_Done,
     /* 1218810 */   // Label 17654: @1218810
     /* 1218810 */   GIM_Try, /*On fail goto*//*Label 17655*/ GIMT_Encode4(1218890), // Rule ID 17566 //
     /* 1218815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1218818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1218823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1218835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218854 */     // MIs[0] round
     /* 1218854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1218864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1218867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218889 */     // GIR_Coverage, 17566,
     /* 1218889 */     GIR_EraseRootFromParent_Done,
     /* 1218890 */   // Label 17655: @1218890
     /* 1218890 */   GIM_Try, /*On fail goto*//*Label 17656*/ GIMT_Encode4(1218970), // Rule ID 17567 //
     /* 1218895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1218898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1218903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1218906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1218909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1218912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1218915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1218918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1218934 */     // MIs[0] round
     /* 1218934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1218937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1218944 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1218944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16),
     /* 1218947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1218949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1218951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1218953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1218955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1218957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1218962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1218965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1218968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1218969 */     // GIR_Coverage, 17567,
     /* 1218969 */     GIR_EraseRootFromParent_Done,
     /* 1218970 */   // Label 17656: @1218970
     /* 1218970 */   GIM_Try, /*On fail goto*//*Label 17657*/ GIMT_Encode4(1219050), // Rule ID 17570 //
     /* 1218975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1218978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1218983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1218986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1218989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1218992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1218995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1218998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219014 */     // MIs[0] round
     /* 1219014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1219027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219049 */     // GIR_Coverage, 17570,
     /* 1219049 */     GIR_EraseRootFromParent_Done,
     /* 1219050 */   // Label 17657: @1219050
     /* 1219050 */   GIM_Try, /*On fail goto*//*Label 17658*/ GIMT_Encode4(1219130), // Rule ID 17571 //
     /* 1219055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1219058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1219066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1219069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1219072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1219075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219094 */     // MIs[0] round
     /* 1219094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16),
     /* 1219107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219129 */     // GIR_Coverage, 17571,
     /* 1219129 */     GIR_EraseRootFromParent_Done,
     /* 1219130 */   // Label 17658: @1219130
     /* 1219130 */   GIM_Try, /*On fail goto*//*Label 17659*/ GIMT_Encode4(1219210), // Rule ID 17574 //
     /* 1219135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1219138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1219155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219174 */     // MIs[0] round
     /* 1219174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219184 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1219187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219209 */     // GIR_Coverage, 17574,
     /* 1219209 */     GIR_EraseRootFromParent_Done,
     /* 1219210 */   // Label 17659: @1219210
     /* 1219210 */   GIM_Try, /*On fail goto*//*Label 17660*/ GIMT_Encode4(1219290), // Rule ID 17575 //
     /* 1219215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1219218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1219226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1219229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1219232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1219235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219254 */     // MIs[0] round
     /* 1219254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219264 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16),
     /* 1219267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219289 */     // GIR_Coverage, 17575,
     /* 1219289 */     GIR_EraseRootFromParent_Done,
     /* 1219290 */   // Label 17660: @1219290
     /* 1219290 */   GIM_Try, /*On fail goto*//*Label 17661*/ GIMT_Encode4(1219370), // Rule ID 17578 //
     /* 1219295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1219298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1219306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1219309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1219315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219334 */     // MIs[0] round
     /* 1219334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219344 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1219347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219369 */     // GIR_Coverage, 17578,
     /* 1219369 */     GIR_EraseRootFromParent_Done,
     /* 1219370 */   // Label 17661: @1219370
     /* 1219370 */   GIM_Try, /*On fail goto*//*Label 17662*/ GIMT_Encode4(1219450), // Rule ID 17579 //
     /* 1219375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1219378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1219386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1219389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1219392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1219395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219414 */     // MIs[0] round
     /* 1219414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219424 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16),
     /* 1219427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219449 */     // GIR_Coverage, 17579,
     /* 1219449 */     GIR_EraseRootFromParent_Done,
     /* 1219450 */   // Label 17662: @1219450
     /* 1219450 */   GIM_Try, /*On fail goto*//*Label 17663*/ GIMT_Encode4(1219530), // Rule ID 17582 //
     /* 1219455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1219458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1219466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1219469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1219475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219494 */     // MIs[0] round
     /* 1219494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219504 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1219507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219529 */     // GIR_Coverage, 17582,
     /* 1219529 */     GIR_EraseRootFromParent_Done,
     /* 1219530 */   // Label 17663: @1219530
     /* 1219530 */   GIM_Try, /*On fail goto*//*Label 17664*/ GIMT_Encode4(1219610), // Rule ID 17583 //
     /* 1219535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1219538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1219546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1219549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1219552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1219555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1219566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219574 */     // MIs[0] round
     /* 1219574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219584 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16),
     /* 1219587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1219605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219609 */     // GIR_Coverage, 17583,
     /* 1219609 */     GIR_EraseRootFromParent_Done,
     /* 1219610 */   // Label 17664: @1219610
     /* 1219610 */   GIM_Try, /*On fail goto*//*Label 17665*/ GIMT_Encode4(1219690), // Rule ID 17586 //
     /* 1219615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1219618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1219635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219654 */     // MIs[0] round
     /* 1219654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219664 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1219667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219689 */     // GIR_Coverage, 17586,
     /* 1219689 */     GIR_EraseRootFromParent_Done,
     /* 1219690 */   // Label 17665: @1219690
     /* 1219690 */   GIM_Try, /*On fail goto*//*Label 17666*/ GIMT_Encode4(1219770), // Rule ID 17587 //
     /* 1219695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1219698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1219706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1219709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1219712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1219715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219734 */     // MIs[0] round
     /* 1219734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32),
     /* 1219747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219769 */     // GIR_Coverage, 17587,
     /* 1219769 */     GIR_EraseRootFromParent_Done,
     /* 1219770 */   // Label 17666: @1219770
     /* 1219770 */   GIM_Try, /*On fail goto*//*Label 17667*/ GIMT_Encode4(1219850), // Rule ID 17590 //
     /* 1219775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1219778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1219786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1219789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1219795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219814 */     // MIs[0] round
     /* 1219814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1219827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219849 */     // GIR_Coverage, 17590,
     /* 1219849 */     GIR_EraseRootFromParent_Done,
     /* 1219850 */   // Label 17667: @1219850
     /* 1219850 */   GIM_Try, /*On fail goto*//*Label 17668*/ GIMT_Encode4(1219930), // Rule ID 17591 //
     /* 1219855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1219858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1219866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1219869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1219872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1219875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1219878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1219894 */     // MIs[0] round
     /* 1219894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1219904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32),
     /* 1219907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1219922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1219925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1219928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1219929 */     // GIR_Coverage, 17591,
     /* 1219929 */     GIR_EraseRootFromParent_Done,
     /* 1219930 */   // Label 17668: @1219930
     /* 1219930 */   GIM_Try, /*On fail goto*//*Label 17669*/ GIMT_Encode4(1220010), // Rule ID 17594 //
     /* 1219935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1219938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1219943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1219946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1219949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1219952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1219955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1219958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1219966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1219974 */     // MIs[0] round
     /* 1219974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1219977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1219984 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1219984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1219987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1219989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1219991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1219993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1219995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1219997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220009 */     // GIR_Coverage, 17594,
     /* 1220009 */     GIR_EraseRootFromParent_Done,
     /* 1220010 */   // Label 17669: @1220010
     /* 1220010 */   GIM_Try, /*On fail goto*//*Label 17670*/ GIMT_Encode4(1220090), // Rule ID 17595 //
     /* 1220015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1220018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1220026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1220029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1220032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1220035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220054 */     // MIs[0] round
     /* 1220054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220064 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32),
     /* 1220067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220089 */     // GIR_Coverage, 17595,
     /* 1220089 */     GIR_EraseRootFromParent_Done,
     /* 1220090 */   // Label 17670: @1220090
     /* 1220090 */   GIM_Try, /*On fail goto*//*Label 17671*/ GIMT_Encode4(1220170), // Rule ID 17598 //
     /* 1220095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1220098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1220115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220134 */     // MIs[0] round
     /* 1220134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220144 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1220147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220169 */     // GIR_Coverage, 17598,
     /* 1220169 */     GIR_EraseRootFromParent_Done,
     /* 1220170 */   // Label 17671: @1220170
     /* 1220170 */   GIM_Try, /*On fail goto*//*Label 17672*/ GIMT_Encode4(1220250), // Rule ID 17599 //
     /* 1220175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1220178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1220186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1220189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1220192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1220195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220214 */     // MIs[0] round
     /* 1220214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220224 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32),
     /* 1220227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1220245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220249 */     // GIR_Coverage, 17599,
     /* 1220249 */     GIR_EraseRootFromParent_Done,
     /* 1220250 */   // Label 17672: @1220250
     /* 1220250 */   GIM_Try, /*On fail goto*//*Label 17673*/ GIMT_Encode4(1220330), // Rule ID 17602 //
     /* 1220255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1220258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1220266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1220269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220294 */     // MIs[0] round
     /* 1220294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220304 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1220307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220329 */     // GIR_Coverage, 17602,
     /* 1220329 */     GIR_EraseRootFromParent_Done,
     /* 1220330 */   // Label 17673: @1220330
     /* 1220330 */   GIM_Try, /*On fail goto*//*Label 17674*/ GIMT_Encode4(1220410), // Rule ID 17603 //
     /* 1220335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1220338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1220346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1220349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1220352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220374 */     // MIs[0] round
     /* 1220374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220384 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16),
     /* 1220387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220409 */     // GIR_Coverage, 17603,
     /* 1220409 */     GIR_EraseRootFromParent_Done,
     /* 1220410 */   // Label 17674: @1220410
     /* 1220410 */   GIM_Try, /*On fail goto*//*Label 17675*/ GIMT_Encode4(1220490), // Rule ID 17606 //
     /* 1220415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1220418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1220426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1220429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1220432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220454 */     // MIs[0] round
     /* 1220454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1220467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220489 */     // GIR_Coverage, 17606,
     /* 1220489 */     GIR_EraseRootFromParent_Done,
     /* 1220490 */   // Label 17675: @1220490
     /* 1220490 */   GIM_Try, /*On fail goto*//*Label 17676*/ GIMT_Encode4(1220570), // Rule ID 17607 //
     /* 1220495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1220498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1220506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1220509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1220512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220534 */     // MIs[0] round
     /* 1220534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11236:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16),
     /* 1220547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220569 */     // GIR_Coverage, 17607,
     /* 1220569 */     GIR_EraseRootFromParent_Done,
     /* 1220570 */   // Label 17676: @1220570
     /* 1220570 */   GIM_Try, /*On fail goto*//*Label 17677*/ GIMT_Encode4(1220650), // Rule ID 17610 //
     /* 1220575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1220578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1220592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220614 */     // MIs[0] round
     /* 1220614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1220627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220649 */     // GIR_Coverage, 17610,
     /* 1220649 */     GIR_EraseRootFromParent_Done,
     /* 1220650 */   // Label 17677: @1220650
     /* 1220650 */   GIM_Try, /*On fail goto*//*Label 17678*/ GIMT_Encode4(1220730), // Rule ID 17611 //
     /* 1220655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1220658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1220666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1220669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1220672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1220690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220694 */     // MIs[0] round
     /* 1220694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16),
     /* 1220707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220729 */     // GIR_Coverage, 17611,
     /* 1220729 */     GIR_EraseRootFromParent_Done,
     /* 1220730 */   // Label 17678: @1220730
     /* 1220730 */   GIM_Try, /*On fail goto*//*Label 17679*/ GIMT_Encode4(1220810), // Rule ID 17614 //
     /* 1220735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1220738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220774 */     // MIs[0] round
     /* 1220774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220784 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1220787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220809 */     // GIR_Coverage, 17614,
     /* 1220809 */     GIR_EraseRootFromParent_Done,
     /* 1220810 */   // Label 17679: @1220810
     /* 1220810 */   GIM_Try, /*On fail goto*//*Label 17680*/ GIMT_Encode4(1220890), // Rule ID 17615 //
     /* 1220815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1220818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1220826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1220829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1220832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1220850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220854 */     // MIs[0] round
     /* 1220854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220864 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1220864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16),
     /* 1220867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220889 */     // GIR_Coverage, 17615,
     /* 1220889 */     GIR_EraseRootFromParent_Done,
     /* 1220890 */   // Label 17680: @1220890
     /* 1220890 */   GIM_Try, /*On fail goto*//*Label 17681*/ GIMT_Encode4(1220970), // Rule ID 17618 //
     /* 1220895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1220898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1220918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1220926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1220930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1220934 */     // MIs[0] round
     /* 1220934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1220937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1220944 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1220944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1220947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1220949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1220951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1220953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1220955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1220957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1220962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1220965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1220968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1220969 */     // GIR_Coverage, 17618,
     /* 1220969 */     GIR_EraseRootFromParent_Done,
     /* 1220970 */   // Label 17681: @1220970
     /* 1220970 */   GIM_Try, /*On fail goto*//*Label 17682*/ GIMT_Encode4(1221050), // Rule ID 17619 //
     /* 1220975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1220978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1220983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1220986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1220989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1220992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1220995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1220998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1221014 */     // MIs[0] round
     /* 1221014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221024 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16),
     /* 1221027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221049 */     // GIR_Coverage, 17619,
     /* 1221049 */     GIR_EraseRootFromParent_Done,
     /* 1221050 */   // Label 17682: @1221050
     /* 1221050 */   GIM_Try, /*On fail goto*//*Label 17683*/ GIMT_Encode4(1221130), // Rule ID 17622 //
     /* 1221055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1221058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221094 */     // MIs[0] round
     /* 1221094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221104 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1221107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221129 */     // GIR_Coverage, 17622,
     /* 1221129 */     GIR_EraseRootFromParent_Done,
     /* 1221130 */   // Label 17683: @1221130
     /* 1221130 */   GIM_Try, /*On fail goto*//*Label 17684*/ GIMT_Encode4(1221210), // Rule ID 17623 //
     /* 1221135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1221138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1221146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1221149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221174 */     // MIs[0] round
     /* 1221174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221184 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11236:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32),
     /* 1221187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221209 */     // GIR_Coverage, 17623,
     /* 1221209 */     GIR_EraseRootFromParent_Done,
     /* 1221210 */   // Label 17684: @1221210
     /* 1221210 */   GIM_Try, /*On fail goto*//*Label 17685*/ GIMT_Encode4(1221290), // Rule ID 17626 //
     /* 1221215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1221218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221254 */     // MIs[0] round
     /* 1221254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1221267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221289 */     // GIR_Coverage, 17626,
     /* 1221289 */     GIR_EraseRootFromParent_Done,
     /* 1221290 */   // Label 17685: @1221290
     /* 1221290 */   GIM_Try, /*On fail goto*//*Label 17686*/ GIMT_Encode4(1221370), // Rule ID 17627 //
     /* 1221295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1221298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1221306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1221309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1221312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221334 */     // MIs[0] round
     /* 1221334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11236:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32),
     /* 1221347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221369 */     // GIR_Coverage, 17627,
     /* 1221369 */     GIR_EraseRootFromParent_Done,
     /* 1221370 */   // Label 17686: @1221370
     /* 1221370 */   GIM_Try, /*On fail goto*//*Label 17687*/ GIMT_Encode4(1221450), // Rule ID 17630 //
     /* 1221375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1221378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221414 */     // MIs[0] round
     /* 1221414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221424 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1221427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221449 */     // GIR_Coverage, 17630,
     /* 1221449 */     GIR_EraseRootFromParent_Done,
     /* 1221450 */   // Label 17687: @1221450
     /* 1221450 */   GIM_Try, /*On fail goto*//*Label 17688*/ GIMT_Encode4(1221530), // Rule ID 17631 //
     /* 1221455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1221458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1221466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1221469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1221472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1221490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221494 */     // MIs[0] round
     /* 1221494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221504 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11236:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32),
     /* 1221507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221529 */     // GIR_Coverage, 17631,
     /* 1221529 */     GIR_EraseRootFromParent_Done,
     /* 1221530 */   // Label 17688: @1221530
     /* 1221530 */   GIM_Try, /*On fail goto*//*Label 17689*/ GIMT_Encode4(1221610), // Rule ID 17634 //
     /* 1221535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1221538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221574 */     // MIs[0] round
     /* 1221574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221584 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1221587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221609 */     // GIR_Coverage, 17634,
     /* 1221609 */     GIR_EraseRootFromParent_Done,
     /* 1221610 */   // Label 17689: @1221610
     /* 1221610 */   GIM_Try, /*On fail goto*//*Label 17690*/ GIMT_Encode4(1221690), // Rule ID 17635 //
     /* 1221615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1221618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul),
     /* 1221623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1221626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1221629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1221632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1221635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1221646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1221650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1221654 */     // MIs[0] round
     /* 1221654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221664 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11236:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWMUL_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32),
     /* 1221667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1221671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221689 */     // GIR_Coverage, 17635,
     /* 1221689 */     GIR_EraseRootFromParent_Done,
     /* 1221690 */   // Label 17690: @1221690
     /* 1221690 */   GIM_Try, /*On fail goto*//*Label 17691*/ GIMT_Encode4(1221770), // Rule ID 22712 //
     /* 1221695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1221698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1221703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1221715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221734 */     // MIs[0] round
     /* 1221734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221744 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1221747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1221751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221769 */     // GIR_Coverage, 22712,
     /* 1221769 */     GIR_EraseRootFromParent_Done,
     /* 1221770 */   // Label 17691: @1221770
     /* 1221770 */   GIM_Try, /*On fail goto*//*Label 17692*/ GIMT_Encode4(1221850), // Rule ID 22713 //
     /* 1221775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1221778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1221783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1221786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1221789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1221792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1221795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221814 */     // MIs[0] round
     /* 1221814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16),
     /* 1221827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1221831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1221845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221849 */     // GIR_Coverage, 22713,
     /* 1221849 */     GIR_EraseRootFromParent_Done,
     /* 1221850 */   // Label 17692: @1221850
     /* 1221850 */   GIM_Try, /*On fail goto*//*Label 17693*/ GIMT_Encode4(1221930), // Rule ID 22716 //
     /* 1221855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1221858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1221863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1221875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1221878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221894 */     // MIs[0] round
     /* 1221894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221904 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1221904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1221907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1221911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1221922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1221925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1221928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1221929 */     // GIR_Coverage, 22716,
     /* 1221929 */     GIR_EraseRootFromParent_Done,
     /* 1221930 */   // Label 17693: @1221930
     /* 1221930 */   GIM_Try, /*On fail goto*//*Label 17694*/ GIMT_Encode4(1222010), // Rule ID 22717 //
     /* 1221935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1221938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1221943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1221946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1221949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1221952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1221955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1221958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1221974 */     // MIs[0] round
     /* 1221974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1221977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1221984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1221984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32),
     /* 1221987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1221989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1221991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1221993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1221995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1221997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222009 */     // GIR_Coverage, 22717,
     /* 1222009 */     GIR_EraseRootFromParent_Done,
     /* 1222010 */   // Label 17694: @1222010
     /* 1222010 */   GIM_Try, /*On fail goto*//*Label 17695*/ GIMT_Encode4(1222090), // Rule ID 22720 //
     /* 1222015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222054 */     // MIs[0] round
     /* 1222054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222064 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1222067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222089 */     // GIR_Coverage, 22720,
     /* 1222089 */     GIR_EraseRootFromParent_Done,
     /* 1222090 */   // Label 17695: @1222090
     /* 1222090 */   GIM_Try, /*On fail goto*//*Label 17696*/ GIMT_Encode4(1222170), // Rule ID 22721 //
     /* 1222095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1222112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222134 */     // MIs[0] round
     /* 1222134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16),
     /* 1222147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222169 */     // GIR_Coverage, 22721,
     /* 1222169 */     GIR_EraseRootFromParent_Done,
     /* 1222170 */   // Label 17696: @1222170
     /* 1222170 */   GIM_Try, /*On fail goto*//*Label 17697*/ GIMT_Encode4(1222250), // Rule ID 22724 //
     /* 1222175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1222195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222214 */     // MIs[0] round
     /* 1222214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1222227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222249 */     // GIR_Coverage, 22724,
     /* 1222249 */     GIR_EraseRootFromParent_Done,
     /* 1222250 */   // Label 17697: @1222250
     /* 1222250 */   GIM_Try, /*On fail goto*//*Label 17698*/ GIMT_Encode4(1222330), // Rule ID 22725 //
     /* 1222255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1222258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1222272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1222275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222294 */     // MIs[0] round
     /* 1222294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32),
     /* 1222307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1222325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222329 */     // GIR_Coverage, 22725,
     /* 1222329 */     GIR_EraseRootFromParent_Done,
     /* 1222330 */   // Label 17698: @1222330
     /* 1222330 */   GIM_Try, /*On fail goto*//*Label 17699*/ GIMT_Encode4(1222410), // Rule ID 22728 //
     /* 1222335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1222338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1222355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222374 */     // MIs[0] round
     /* 1222374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222384 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1222387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222409 */     // GIR_Coverage, 22728,
     /* 1222409 */     GIR_EraseRootFromParent_Done,
     /* 1222410 */   // Label 17699: @1222410
     /* 1222410 */   GIM_Try, /*On fail goto*//*Label 17700*/ GIMT_Encode4(1222490), // Rule ID 22729 //
     /* 1222415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1222418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1222426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1222429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1222432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1222435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222454 */     // MIs[0] round
     /* 1222454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64),
     /* 1222467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1222485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222489 */     // GIR_Coverage, 22729,
     /* 1222489 */     GIR_EraseRootFromParent_Done,
     /* 1222490 */   // Label 17700: @1222490
     /* 1222490 */   GIM_Try, /*On fail goto*//*Label 17701*/ GIMT_Encode4(1222570), // Rule ID 22732 //
     /* 1222495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222534 */     // MIs[0] round
     /* 1222534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222544 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1222547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222569 */     // GIR_Coverage, 22732,
     /* 1222569 */     GIR_EraseRootFromParent_Done,
     /* 1222570 */   // Label 17701: @1222570
     /* 1222570 */   GIM_Try, /*On fail goto*//*Label 17702*/ GIMT_Encode4(1222650), // Rule ID 22733 //
     /* 1222575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1222592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1222610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222614 */     // MIs[0] round
     /* 1222614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222624 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16),
     /* 1222627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222649 */     // GIR_Coverage, 22733,
     /* 1222649 */     GIR_EraseRootFromParent_Done,
     /* 1222650 */   // Label 17702: @1222650
     /* 1222650 */   GIM_Try, /*On fail goto*//*Label 17703*/ GIMT_Encode4(1222730), // Rule ID 22736 //
     /* 1222655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222694 */     // MIs[0] round
     /* 1222694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222704 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1222707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222729 */     // GIR_Coverage, 22736,
     /* 1222729 */     GIR_EraseRootFromParent_Done,
     /* 1222730 */   // Label 17703: @1222730
     /* 1222730 */   GIM_Try, /*On fail goto*//*Label 17704*/ GIMT_Encode4(1222810), // Rule ID 22737 //
     /* 1222735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1222752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1222770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222774 */     // MIs[0] round
     /* 1222774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16),
     /* 1222787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222809 */     // GIR_Coverage, 22737,
     /* 1222809 */     GIR_EraseRootFromParent_Done,
     /* 1222810 */   // Label 17704: @1222810
     /* 1222810 */   GIM_Try, /*On fail goto*//*Label 17705*/ GIMT_Encode4(1222890), // Rule ID 22740 //
     /* 1222815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1222818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222854 */     // MIs[0] round
     /* 1222854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222864 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1222864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1222867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222889 */     // GIR_Coverage, 22740,
     /* 1222889 */     GIR_EraseRootFromParent_Done,
     /* 1222890 */   // Label 17705: @1222890
     /* 1222890 */   GIM_Try, /*On fail goto*//*Label 17706*/ GIMT_Encode4(1222970), // Rule ID 22741 //
     /* 1222895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1222898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1222906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1222909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1222912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1222915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1222918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1222930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1222934 */     // MIs[0] round
     /* 1222934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1222937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1222944 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11188:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1222944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16),
     /* 1222947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1222949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1222951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1222953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1222955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1222957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1222962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1222965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1222968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1222969 */     // GIR_Coverage, 22741,
     /* 1222969 */     GIR_EraseRootFromParent_Done,
     /* 1222970 */   // Label 17706: @1222970
     /* 1222970 */   GIM_Try, /*On fail goto*//*Label 17707*/ GIMT_Encode4(1223050), // Rule ID 22744 //
     /* 1222975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1222978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1222983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1222986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1222989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1222992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1222995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1222998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223014 */     // MIs[0] round
     /* 1223014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1223027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223049 */     // GIR_Coverage, 22744,
     /* 1223049 */     GIR_EraseRootFromParent_Done,
     /* 1223050 */   // Label 17707: @1223050
     /* 1223050 */   GIM_Try, /*On fail goto*//*Label 17708*/ GIMT_Encode4(1223130), // Rule ID 22745 //
     /* 1223055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1223072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1223075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223094 */     // MIs[0] round
     /* 1223094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32),
     /* 1223107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223129 */     // GIR_Coverage, 22745,
     /* 1223129 */     GIR_EraseRootFromParent_Done,
     /* 1223130 */   // Label 17708: @1223130
     /* 1223130 */   GIM_Try, /*On fail goto*//*Label 17709*/ GIMT_Encode4(1223210), // Rule ID 22748 //
     /* 1223135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1223155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223174 */     // MIs[0] round
     /* 1223174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1223187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223209 */     // GIR_Coverage, 22748,
     /* 1223209 */     GIR_EraseRootFromParent_Done,
     /* 1223210 */   // Label 17709: @1223210
     /* 1223210 */   GIM_Try, /*On fail goto*//*Label 17710*/ GIMT_Encode4(1223290), // Rule ID 22749 //
     /* 1223215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1223232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1223235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223254 */     // MIs[0] round
     /* 1223254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32),
     /* 1223267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223289 */     // GIR_Coverage, 22749,
     /* 1223289 */     GIR_EraseRootFromParent_Done,
     /* 1223290 */   // Label 17710: @1223290
     /* 1223290 */   GIM_Try, /*On fail goto*//*Label 17711*/ GIMT_Encode4(1223370), // Rule ID 22752 //
     /* 1223295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1223298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1223315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223334 */     // MIs[0] round
     /* 1223334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1223347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223369 */     // GIR_Coverage, 22752,
     /* 1223369 */     GIR_EraseRootFromParent_Done,
     /* 1223370 */   // Label 17711: @1223370
     /* 1223370 */   GIM_Try, /*On fail goto*//*Label 17712*/ GIMT_Encode4(1223450), // Rule ID 22753 //
     /* 1223375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1223378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1223386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1223389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1223392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1223395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223414 */     // MIs[0] round
     /* 1223414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11188:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32),
     /* 1223427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1223445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223449 */     // GIR_Coverage, 22753,
     /* 1223449 */     GIR_EraseRootFromParent_Done,
     /* 1223450 */   // Label 17712: @1223450
     /* 1223450 */   GIM_Try, /*On fail goto*//*Label 17713*/ GIMT_Encode4(1223530), // Rule ID 22756 //
     /* 1223455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223494 */     // MIs[0] round
     /* 1223494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223504 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1223507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223529 */     // GIR_Coverage, 22756,
     /* 1223529 */     GIR_EraseRootFromParent_Done,
     /* 1223530 */   // Label 17713: @1223530
     /* 1223530 */   GIM_Try, /*On fail goto*//*Label 17714*/ GIMT_Encode4(1223610), // Rule ID 22757 //
     /* 1223535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1223552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1223570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223574 */     // MIs[0] round
     /* 1223574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223584 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64),
     /* 1223587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223609 */     // GIR_Coverage, 22757,
     /* 1223609 */     GIR_EraseRootFromParent_Done,
     /* 1223610 */   // Label 17714: @1223610
     /* 1223610 */   GIM_Try, /*On fail goto*//*Label 17715*/ GIMT_Encode4(1223690), // Rule ID 22760 //
     /* 1223615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223654 */     // MIs[0] round
     /* 1223654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223664 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1223667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223689 */     // GIR_Coverage, 22760,
     /* 1223689 */     GIR_EraseRootFromParent_Done,
     /* 1223690 */   // Label 17715: @1223690
     /* 1223690 */   GIM_Try, /*On fail goto*//*Label 17716*/ GIMT_Encode4(1223770), // Rule ID 22761 //
     /* 1223695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1223712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1223730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223734 */     // MIs[0] round
     /* 1223734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64),
     /* 1223747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223769 */     // GIR_Coverage, 22761,
     /* 1223769 */     GIR_EraseRootFromParent_Done,
     /* 1223770 */   // Label 17716: @1223770
     /* 1223770 */   GIM_Try, /*On fail goto*//*Label 17717*/ GIMT_Encode4(1223850), // Rule ID 22764 //
     /* 1223775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1223778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223814 */     // MIs[0] round
     /* 1223814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223824 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1223827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223849 */     // GIR_Coverage, 22764,
     /* 1223849 */     GIR_EraseRootFromParent_Done,
     /* 1223850 */   // Label 17717: @1223850
     /* 1223850 */   GIM_Try, /*On fail goto*//*Label 17718*/ GIMT_Encode4(1223930), // Rule ID 22765 //
     /* 1223855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1223858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum),
     /* 1223863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1223866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1223869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1223872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1223875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1223878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1223890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223894 */     // MIs[0] round
     /* 1223894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11188:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1223904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64),
     /* 1223907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1223922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1223925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1223928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1223929 */     // GIR_Coverage, 22765,
     /* 1223929 */     GIR_EraseRootFromParent_Done,
     /* 1223930 */   // Label 17718: @1223930
     /* 1223930 */   GIM_Try, /*On fail goto*//*Label 17719*/ GIMT_Encode4(1224010), // Rule ID 22768 //
     /* 1223935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1223938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1223943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1223946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1223949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1223952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1223955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1223958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1223974 */     // MIs[0] round
     /* 1223974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1223977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1223984 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1223984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1223987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1223989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1223991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1223993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1223995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1223997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224009 */     // GIR_Coverage, 22768,
     /* 1224009 */     GIR_EraseRootFromParent_Done,
     /* 1224010 */   // Label 17719: @1224010
     /* 1224010 */   GIM_Try, /*On fail goto*//*Label 17720*/ GIMT_Encode4(1224090), // Rule ID 22769 //
     /* 1224015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1224018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1224032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224054 */     // MIs[0] round
     /* 1224054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224064 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16),
     /* 1224067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224089 */     // GIR_Coverage, 22769,
     /* 1224089 */     GIR_EraseRootFromParent_Done,
     /* 1224090 */   // Label 17720: @1224090
     /* 1224090 */   GIM_Try, /*On fail goto*//*Label 17721*/ GIMT_Encode4(1224170), // Rule ID 22772 //
     /* 1224095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1224098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224134 */     // MIs[0] round
     /* 1224134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1224147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224169 */     // GIR_Coverage, 22772,
     /* 1224169 */     GIR_EraseRootFromParent_Done,
     /* 1224170 */   // Label 17721: @1224170
     /* 1224170 */   GIM_Try, /*On fail goto*//*Label 17722*/ GIMT_Encode4(1224250), // Rule ID 22773 //
     /* 1224175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1224178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1224192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224214 */     // MIs[0] round
     /* 1224214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16),
     /* 1224227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224249 */     // GIR_Coverage, 22773,
     /* 1224249 */     GIR_EraseRootFromParent_Done,
     /* 1224250 */   // Label 17722: @1224250
     /* 1224250 */   GIM_Try, /*On fail goto*//*Label 17723*/ GIMT_Encode4(1224330), // Rule ID 22776 //
     /* 1224255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1224258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224294 */     // MIs[0] round
     /* 1224294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1224307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224329 */     // GIR_Coverage, 22776,
     /* 1224329 */     GIR_EraseRootFromParent_Done,
     /* 1224330 */   // Label 17723: @1224330
     /* 1224330 */   GIM_Try, /*On fail goto*//*Label 17724*/ GIMT_Encode4(1224410), // Rule ID 22777 //
     /* 1224335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1224338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1224352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224374 */     // MIs[0] round
     /* 1224374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32),
     /* 1224387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224409 */     // GIR_Coverage, 22777,
     /* 1224409 */     GIR_EraseRootFromParent_Done,
     /* 1224410 */   // Label 17724: @1224410
     /* 1224410 */   GIM_Try, /*On fail goto*//*Label 17725*/ GIMT_Encode4(1224490), // Rule ID 22780 //
     /* 1224415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1224418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224454 */     // MIs[0] round
     /* 1224454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224464 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1224467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224489 */     // GIR_Coverage, 22780,
     /* 1224489 */     GIR_EraseRootFromParent_Done,
     /* 1224490 */   // Label 17725: @1224490
     /* 1224490 */   GIM_Try, /*On fail goto*//*Label 17726*/ GIMT_Encode4(1224570), // Rule ID 22781 //
     /* 1224495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1224498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1224512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224534 */     // MIs[0] round
     /* 1224534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224544 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16),
     /* 1224547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224569 */     // GIR_Coverage, 22781,
     /* 1224569 */     GIR_EraseRootFromParent_Done,
     /* 1224570 */   // Label 17726: @1224570
     /* 1224570 */   GIM_Try, /*On fail goto*//*Label 17727*/ GIMT_Encode4(1224650), // Rule ID 22784 //
     /* 1224575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1224578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224614 */     // MIs[0] round
     /* 1224614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1224627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224649 */     // GIR_Coverage, 22784,
     /* 1224649 */     GIR_EraseRootFromParent_Done,
     /* 1224650 */   // Label 17727: @1224650
     /* 1224650 */   GIM_Try, /*On fail goto*//*Label 17728*/ GIMT_Encode4(1224730), // Rule ID 22785 //
     /* 1224655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1224658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1224666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1224669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1224672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1224675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224694 */     // MIs[0] round
     /* 1224694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32),
     /* 1224707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1224725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224729 */     // GIR_Coverage, 22785,
     /* 1224729 */     GIR_EraseRootFromParent_Done,
     /* 1224730 */   // Label 17728: @1224730
     /* 1224730 */   GIM_Try, /*On fail goto*//*Label 17729*/ GIMT_Encode4(1224810), // Rule ID 22788 //
     /* 1224735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1224738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1224752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1224755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224774 */     // MIs[0] round
     /* 1224774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1224787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224809 */     // GIR_Coverage, 22788,
     /* 1224809 */     GIR_EraseRootFromParent_Done,
     /* 1224810 */   // Label 17729: @1224810
     /* 1224810 */   GIM_Try, /*On fail goto*//*Label 17730*/ GIMT_Encode4(1224890), // Rule ID 22789 //
     /* 1224815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1224818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1224826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1224829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1224832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1224835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224854 */     // MIs[0] round
     /* 1224854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1224864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64),
     /* 1224867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1224885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224889 */     // GIR_Coverage, 22789,
     /* 1224889 */     GIR_EraseRootFromParent_Done,
     /* 1224890 */   // Label 17730: @1224890
     /* 1224890 */   GIM_Try, /*On fail goto*//*Label 17731*/ GIMT_Encode4(1224970), // Rule ID 22792 //
     /* 1224895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1224898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1224918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1224930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1224934 */     // MIs[0] round
     /* 1224934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1224937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1224944 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1224944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1224947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1224949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1224951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1224953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1224955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1224957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1224962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1224965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1224968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1224969 */     // GIR_Coverage, 22792,
     /* 1224969 */     GIR_EraseRootFromParent_Done,
     /* 1224970 */   // Label 17731: @1224970
     /* 1224970 */   GIM_Try, /*On fail goto*//*Label 17732*/ GIMT_Encode4(1225050), // Rule ID 22793 //
     /* 1224975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1224978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1224983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1224986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1224989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1224992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1224995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1224998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225014 */     // MIs[0] round
     /* 1225014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225024 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16),
     /* 1225027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225049 */     // GIR_Coverage, 22793,
     /* 1225049 */     GIR_EraseRootFromParent_Done,
     /* 1225050 */   // Label 17732: @1225050
     /* 1225050 */   GIM_Try, /*On fail goto*//*Label 17733*/ GIMT_Encode4(1225130), // Rule ID 22796 //
     /* 1225055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1225075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225094 */     // MIs[0] round
     /* 1225094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225104 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1225107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225129 */     // GIR_Coverage, 22796,
     /* 1225129 */     GIR_EraseRootFromParent_Done,
     /* 1225130 */   // Label 17733: @1225130
     /* 1225130 */   GIM_Try, /*On fail goto*//*Label 17734*/ GIMT_Encode4(1225210), // Rule ID 22797 //
     /* 1225135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1225152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1225155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225174 */     // MIs[0] round
     /* 1225174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225184 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16),
     /* 1225187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225209 */     // GIR_Coverage, 22797,
     /* 1225209 */     GIR_EraseRootFromParent_Done,
     /* 1225210 */   // Label 17734: @1225210
     /* 1225210 */   GIM_Try, /*On fail goto*//*Label 17735*/ GIMT_Encode4(1225290), // Rule ID 22800 //
     /* 1225215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1225218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1225232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1225235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225254 */     // MIs[0] round
     /* 1225254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225264 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1225267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225289 */     // GIR_Coverage, 22800,
     /* 1225289 */     GIR_EraseRootFromParent_Done,
     /* 1225290 */   // Label 17735: @1225290
     /* 1225290 */   GIM_Try, /*On fail goto*//*Label 17736*/ GIMT_Encode4(1225370), // Rule ID 22801 //
     /* 1225295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1225298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1225306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1225309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1225312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1225315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225334 */     // MIs[0] round
     /* 1225334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225344 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11190:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16),
     /* 1225347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1225365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225369 */     // GIR_Coverage, 22801,
     /* 1225369 */     GIR_EraseRootFromParent_Done,
     /* 1225370 */   // Label 17736: @1225370
     /* 1225370 */   GIM_Try, /*On fail goto*//*Label 17737*/ GIMT_Encode4(1225450), // Rule ID 22804 //
     /* 1225375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225414 */     // MIs[0] round
     /* 1225414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1225427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225449 */     // GIR_Coverage, 22804,
     /* 1225449 */     GIR_EraseRootFromParent_Done,
     /* 1225450 */   // Label 17737: @1225450
     /* 1225450 */   GIM_Try, /*On fail goto*//*Label 17738*/ GIMT_Encode4(1225530), // Rule ID 22805 //
     /* 1225455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1225458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1225472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225494 */     // MIs[0] round
     /* 1225494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225504 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32),
     /* 1225507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225529 */     // GIR_Coverage, 22805,
     /* 1225529 */     GIR_EraseRootFromParent_Done,
     /* 1225530 */   // Label 17738: @1225530
     /* 1225530 */   GIM_Try, /*On fail goto*//*Label 17739*/ GIMT_Encode4(1225610), // Rule ID 22808 //
     /* 1225535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225574 */     // MIs[0] round
     /* 1225574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1225587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225609 */     // GIR_Coverage, 22808,
     /* 1225609 */     GIR_EraseRootFromParent_Done,
     /* 1225610 */   // Label 17739: @1225610
     /* 1225610 */   GIM_Try, /*On fail goto*//*Label 17740*/ GIMT_Encode4(1225690), // Rule ID 22809 //
     /* 1225615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1225618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1225632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1225650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225654 */     // MIs[0] round
     /* 1225654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225664 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32),
     /* 1225667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225689 */     // GIR_Coverage, 22809,
     /* 1225689 */     GIR_EraseRootFromParent_Done,
     /* 1225690 */   // Label 17740: @1225690
     /* 1225690 */   GIM_Try, /*On fail goto*//*Label 17741*/ GIMT_Encode4(1225770), // Rule ID 22812 //
     /* 1225695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1225698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1225712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225734 */     // MIs[0] round
     /* 1225734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225744 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1225747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225769 */     // GIR_Coverage, 22812,
     /* 1225769 */     GIR_EraseRootFromParent_Done,
     /* 1225770 */   // Label 17741: @1225770
     /* 1225770 */   GIM_Try, /*On fail goto*//*Label 17742*/ GIMT_Encode4(1225850), // Rule ID 22813 //
     /* 1225775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1225778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1225786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1225789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1225792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1225795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1225810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225814 */     // MIs[0] round
     /* 1225814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225824 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11190:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32),
     /* 1225827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1225845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225849 */     // GIR_Coverage, 22813,
     /* 1225849 */     GIR_EraseRootFromParent_Done,
     /* 1225850 */   // Label 17742: @1225850
     /* 1225850 */   GIM_Try, /*On fail goto*//*Label 17743*/ GIMT_Encode4(1225930), // Rule ID 22816 //
     /* 1225855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1225858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1225872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1225875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1225878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225894 */     // MIs[0] round
     /* 1225894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1225904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1225907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1225922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1225925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1225928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1225929 */     // GIR_Coverage, 22816,
     /* 1225929 */     GIR_EraseRootFromParent_Done,
     /* 1225930 */   // Label 17743: @1225930
     /* 1225930 */   GIM_Try, /*On fail goto*//*Label 17744*/ GIMT_Encode4(1226010), // Rule ID 22817 //
     /* 1225935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1225938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1225943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1225946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1225949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1225952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1225955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1225958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1225970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1225974 */     // MIs[0] round
     /* 1225974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1225977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1225984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1225984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64),
     /* 1225987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1225989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1225991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1225993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1225995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1225997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226009 */     // GIR_Coverage, 22817,
     /* 1226009 */     GIR_EraseRootFromParent_Done,
     /* 1226010 */   // Label 17744: @1226010
     /* 1226010 */   GIM_Try, /*On fail goto*//*Label 17745*/ GIMT_Encode4(1226090), // Rule ID 22820 //
     /* 1226015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1226018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1226023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1226032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226054 */     // MIs[0] round
     /* 1226054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1226067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226089 */     // GIR_Coverage, 22820,
     /* 1226089 */     GIR_EraseRootFromParent_Done,
     /* 1226090 */   // Label 17745: @1226090
     /* 1226090 */   GIM_Try, /*On fail goto*//*Label 17746*/ GIMT_Encode4(1226170), // Rule ID 22821 //
     /* 1226095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1226098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1226103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1226112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1226130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226134 */     // MIs[0] round
     /* 1226134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226144 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64),
     /* 1226147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226169 */     // GIR_Coverage, 22821,
     /* 1226169 */     GIR_EraseRootFromParent_Done,
     /* 1226170 */   // Label 17746: @1226170
     /* 1226170 */   GIM_Try, /*On fail goto*//*Label 17747*/ GIMT_Encode4(1226250), // Rule ID 22824 //
     /* 1226175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1226178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1226183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1226192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226214 */     // MIs[0] round
     /* 1226214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226224 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1226227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226249 */     // GIR_Coverage, 22824,
     /* 1226249 */     GIR_EraseRootFromParent_Done,
     /* 1226250 */   // Label 17747: @1226250
     /* 1226250 */   GIM_Try, /*On fail goto*//*Label 17748*/ GIMT_Encode4(1226330), // Rule ID 22825 //
     /* 1226255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1226258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum),
     /* 1226263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1226272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1226290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226294 */     // MIs[0] round
     /* 1226294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226304 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11190:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64),
     /* 1226307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1226325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226329 */     // GIR_Coverage, 22825,
     /* 1226329 */     GIR_EraseRootFromParent_Done,
     /* 1226330 */   // Label 17748: @1226330
     /* 1226330 */   GIM_Try, /*On fail goto*//*Label 17749*/ GIMT_Encode4(1226410), // Rule ID 22948 //
     /* 1226335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1226352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226374 */     // MIs[0] round
     /* 1226374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1226387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226409 */     // GIR_Coverage, 22948,
     /* 1226409 */     GIR_EraseRootFromParent_Done,
     /* 1226410 */   // Label 17749: @1226410
     /* 1226410 */   GIM_Try, /*On fail goto*//*Label 17750*/ GIMT_Encode4(1226490), // Rule ID 22949 //
     /* 1226415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1226432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226454 */     // MIs[0] round
     /* 1226454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226464 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16),
     /* 1226467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226489 */     // GIR_Coverage, 22949,
     /* 1226489 */     GIR_EraseRootFromParent_Done,
     /* 1226490 */   // Label 17750: @1226490
     /* 1226490 */   GIM_Try, /*On fail goto*//*Label 17751*/ GIMT_Encode4(1226570), // Rule ID 22952 //
     /* 1226495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226534 */     // MIs[0] round
     /* 1226534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226544 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1226547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226569 */     // GIR_Coverage, 22952,
     /* 1226569 */     GIR_EraseRootFromParent_Done,
     /* 1226570 */   // Label 17751: @1226570
     /* 1226570 */   GIM_Try, /*On fail goto*//*Label 17752*/ GIMT_Encode4(1226650), // Rule ID 22953 //
     /* 1226575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1226592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226614 */     // MIs[0] round
     /* 1226614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16),
     /* 1226627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226649 */     // GIR_Coverage, 22953,
     /* 1226649 */     GIR_EraseRootFromParent_Done,
     /* 1226650 */   // Label 17752: @1226650
     /* 1226650 */   GIM_Try, /*On fail goto*//*Label 17753*/ GIMT_Encode4(1226730), // Rule ID 22956 //
     /* 1226655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226694 */     // MIs[0] round
     /* 1226694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226704 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1226707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226729 */     // GIR_Coverage, 22956,
     /* 1226729 */     GIR_EraseRootFromParent_Done,
     /* 1226730 */   // Label 17753: @1226730
     /* 1226730 */   GIM_Try, /*On fail goto*//*Label 17754*/ GIMT_Encode4(1226810), // Rule ID 22957 //
     /* 1226735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1226738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1226752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226774 */     // MIs[0] round
     /* 1226774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32),
     /* 1226787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1226805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226809 */     // GIR_Coverage, 22957,
     /* 1226809 */     GIR_EraseRootFromParent_Done,
     /* 1226810 */   // Label 17754: @1226810
     /* 1226810 */   GIM_Try, /*On fail goto*//*Label 17755*/ GIMT_Encode4(1226890), // Rule ID 22960 //
     /* 1226815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1226818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226854 */     // MIs[0] round
     /* 1226854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226864 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1226864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1226867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226889 */     // GIR_Coverage, 22960,
     /* 1226889 */     GIR_EraseRootFromParent_Done,
     /* 1226890 */   // Label 17755: @1226890
     /* 1226890 */   GIM_Try, /*On fail goto*//*Label 17756*/ GIMT_Encode4(1226970), // Rule ID 22961 //
     /* 1226895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1226898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1226906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1226909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1226912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1226915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1226918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1226934 */     // MIs[0] round
     /* 1226934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1226937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1226944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1226944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16),
     /* 1226947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1226949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1226951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1226953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1226955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1226957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1226962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1226965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1226968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1226969 */     // GIR_Coverage, 22961,
     /* 1226969 */     GIR_EraseRootFromParent_Done,
     /* 1226970 */   // Label 17756: @1226970
     /* 1226970 */   GIM_Try, /*On fail goto*//*Label 17757*/ GIMT_Encode4(1227050), // Rule ID 22964 //
     /* 1226975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1226978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1226983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1226986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1226989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1226992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1226995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1226998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227014 */     // MIs[0] round
     /* 1227014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227024 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1227027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227049 */     // GIR_Coverage, 22964,
     /* 1227049 */     GIR_EraseRootFromParent_Done,
     /* 1227050 */   // Label 17757: @1227050
     /* 1227050 */   GIM_Try, /*On fail goto*//*Label 17758*/ GIMT_Encode4(1227130), // Rule ID 22965 //
     /* 1227055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1227072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227094 */     // MIs[0] round
     /* 1227094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227104 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32),
     /* 1227107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227129 */     // GIR_Coverage, 22965,
     /* 1227129 */     GIR_EraseRootFromParent_Done,
     /* 1227130 */   // Label 17758: @1227130
     /* 1227130 */   GIM_Try, /*On fail goto*//*Label 17759*/ GIMT_Encode4(1227210), // Rule ID 22968 //
     /* 1227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227174 */     // MIs[0] round
     /* 1227174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1227187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227209 */     // GIR_Coverage, 22968,
     /* 1227209 */     GIR_EraseRootFromParent_Done,
     /* 1227210 */   // Label 17759: @1227210
     /* 1227210 */   GIM_Try, /*On fail goto*//*Label 17760*/ GIMT_Encode4(1227290), // Rule ID 22969 //
     /* 1227215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1227232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227254 */     // MIs[0] round
     /* 1227254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16),
     /* 1227267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227289 */     // GIR_Coverage, 22969,
     /* 1227289 */     GIR_EraseRootFromParent_Done,
     /* 1227290 */   // Label 17760: @1227290
     /* 1227290 */   GIM_Try, /*On fail goto*//*Label 17761*/ GIMT_Encode4(1227370), // Rule ID 22972 //
     /* 1227295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227334 */     // MIs[0] round
     /* 1227334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1227347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227369 */     // GIR_Coverage, 22972,
     /* 1227369 */     GIR_EraseRootFromParent_Done,
     /* 1227370 */   // Label 17761: @1227370
     /* 1227370 */   GIM_Try, /*On fail goto*//*Label 17762*/ GIMT_Encode4(1227450), // Rule ID 22973 //
     /* 1227375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1227392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227414 */     // MIs[0] round
     /* 1227414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16),
     /* 1227427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227449 */     // GIR_Coverage, 22973,
     /* 1227449 */     GIR_EraseRootFromParent_Done,
     /* 1227450 */   // Label 17762: @1227450
     /* 1227450 */   GIM_Try, /*On fail goto*//*Label 17763*/ GIMT_Encode4(1227530), // Rule ID 22976 //
     /* 1227455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1227458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227494 */     // MIs[0] round
     /* 1227494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227504 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1227507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227529 */     // GIR_Coverage, 22976,
     /* 1227529 */     GIR_EraseRootFromParent_Done,
     /* 1227530 */   // Label 17763: @1227530
     /* 1227530 */   GIM_Try, /*On fail goto*//*Label 17764*/ GIMT_Encode4(1227610), // Rule ID 22977 //
     /* 1227535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1227538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1227546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1227549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1227552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1227555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227574 */     // MIs[0] round
     /* 1227574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227584 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11244:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16),
     /* 1227587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1227605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227609 */     // GIR_Coverage, 22977,
     /* 1227609 */     GIR_EraseRootFromParent_Done,
     /* 1227610 */   // Label 17764: @1227610
     /* 1227610 */   GIM_Try, /*On fail goto*//*Label 17765*/ GIMT_Encode4(1227690), // Rule ID 22980 //
     /* 1227615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227654 */     // MIs[0] round
     /* 1227654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227664 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1227667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227689 */     // GIR_Coverage, 22980,
     /* 1227689 */     GIR_EraseRootFromParent_Done,
     /* 1227690 */   // Label 17765: @1227690
     /* 1227690 */   GIM_Try, /*On fail goto*//*Label 17766*/ GIMT_Encode4(1227770), // Rule ID 22981 //
     /* 1227695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1227712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1227730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227734 */     // MIs[0] round
     /* 1227734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32),
     /* 1227747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227769 */     // GIR_Coverage, 22981,
     /* 1227769 */     GIR_EraseRootFromParent_Done,
     /* 1227770 */   // Label 17766: @1227770
     /* 1227770 */   GIM_Try, /*On fail goto*//*Label 17767*/ GIMT_Encode4(1227850), // Rule ID 22984 //
     /* 1227775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227814 */     // MIs[0] round
     /* 1227814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227824 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1227827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227849 */     // GIR_Coverage, 22984,
     /* 1227849 */     GIR_EraseRootFromParent_Done,
     /* 1227850 */   // Label 17767: @1227850
     /* 1227850 */   GIM_Try, /*On fail goto*//*Label 17768*/ GIMT_Encode4(1227930), // Rule ID 22985 //
     /* 1227855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1227858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1227872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1227878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1227890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227894 */     // MIs[0] round
     /* 1227894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227904 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1227904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32),
     /* 1227907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1227922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1227925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1227928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1227929 */     // GIR_Coverage, 22985,
     /* 1227929 */     GIR_EraseRootFromParent_Done,
     /* 1227930 */   // Label 17768: @1227930
     /* 1227930 */   GIM_Try, /*On fail goto*//*Label 17769*/ GIMT_Encode4(1228010), // Rule ID 22988 //
     /* 1227935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1227938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1227943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1227946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1227949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1227952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1227955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1227958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1227970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1227974 */     // MIs[0] round
     /* 1227974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1227977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1227984 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1227984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1227987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1227989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1227991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1227993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1227995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1227997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228009 */     // GIR_Coverage, 22988,
     /* 1228009 */     GIR_EraseRootFromParent_Done,
     /* 1228010 */   // Label 17769: @1228010
     /* 1228010 */   GIM_Try, /*On fail goto*//*Label 17770*/ GIMT_Encode4(1228090), // Rule ID 22989 //
     /* 1228015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum),
     /* 1228023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1228032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1228050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228054 */     // MIs[0] round
     /* 1228054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11244:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32),
     /* 1228067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228089 */     // GIR_Coverage, 22989,
     /* 1228089 */     GIR_EraseRootFromParent_Done,
     /* 1228090 */   // Label 17770: @1228090
     /* 1228090 */   GIM_Try, /*On fail goto*//*Label 17771*/ GIMT_Encode4(1228170), // Rule ID 22992 //
     /* 1228095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228134 */     // MIs[0] round
     /* 1228134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1228147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228169 */     // GIR_Coverage, 22992,
     /* 1228169 */     GIR_EraseRootFromParent_Done,
     /* 1228170 */   // Label 17771: @1228170
     /* 1228170 */   GIM_Try, /*On fail goto*//*Label 17772*/ GIMT_Encode4(1228250), // Rule ID 22993 //
     /* 1228175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1228192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228214 */     // MIs[0] round
     /* 1228214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16),
     /* 1228227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228249 */     // GIR_Coverage, 22993,
     /* 1228249 */     GIR_EraseRootFromParent_Done,
     /* 1228250 */   // Label 17772: @1228250
     /* 1228250 */   GIM_Try, /*On fail goto*//*Label 17773*/ GIMT_Encode4(1228330), // Rule ID 22996 //
     /* 1228255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228294 */     // MIs[0] round
     /* 1228294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228304 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1228307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228329 */     // GIR_Coverage, 22996,
     /* 1228329 */     GIR_EraseRootFromParent_Done,
     /* 1228330 */   // Label 17773: @1228330
     /* 1228330 */   GIM_Try, /*On fail goto*//*Label 17774*/ GIMT_Encode4(1228410), // Rule ID 22997 //
     /* 1228335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1228352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228374 */     // MIs[0] round
     /* 1228374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228384 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16),
     /* 1228387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228409 */     // GIR_Coverage, 22997,
     /* 1228409 */     GIR_EraseRootFromParent_Done,
     /* 1228410 */   // Label 17774: @1228410
     /* 1228410 */   GIM_Try, /*On fail goto*//*Label 17775*/ GIMT_Encode4(1228490), // Rule ID 23000 //
     /* 1228415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228454 */     // MIs[0] round
     /* 1228454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1228467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228489 */     // GIR_Coverage, 23000,
     /* 1228489 */     GIR_EraseRootFromParent_Done,
     /* 1228490 */   // Label 17775: @1228490
     /* 1228490 */   GIM_Try, /*On fail goto*//*Label 17776*/ GIMT_Encode4(1228570), // Rule ID 23001 //
     /* 1228495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1228512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228534 */     // MIs[0] round
     /* 1228534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228544 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32),
     /* 1228547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228569 */     // GIR_Coverage, 23001,
     /* 1228569 */     GIR_EraseRootFromParent_Done,
     /* 1228570 */   // Label 17776: @1228570
     /* 1228570 */   GIM_Try, /*On fail goto*//*Label 17777*/ GIMT_Encode4(1228650), // Rule ID 23004 //
     /* 1228575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228614 */     // MIs[0] round
     /* 1228614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1228627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228649 */     // GIR_Coverage, 23004,
     /* 1228649 */     GIR_EraseRootFromParent_Done,
     /* 1228650 */   // Label 17777: @1228650
     /* 1228650 */   GIM_Try, /*On fail goto*//*Label 17778*/ GIMT_Encode4(1228730), // Rule ID 23005 //
     /* 1228655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1228672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228694 */     // MIs[0] round
     /* 1228694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228704 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16),
     /* 1228707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228729 */     // GIR_Coverage, 23005,
     /* 1228729 */     GIR_EraseRootFromParent_Done,
     /* 1228730 */   // Label 17778: @1228730
     /* 1228730 */   GIM_Try, /*On fail goto*//*Label 17779*/ GIMT_Encode4(1228810), // Rule ID 23008 //
     /* 1228735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1228738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228774 */     // MIs[0] round
     /* 1228774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228784 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1228787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228809 */     // GIR_Coverage, 23008,
     /* 1228809 */     GIR_EraseRootFromParent_Done,
     /* 1228810 */   // Label 17779: @1228810
     /* 1228810 */   GIM_Try, /*On fail goto*//*Label 17780*/ GIMT_Encode4(1228890), // Rule ID 23009 //
     /* 1228815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1228818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1228826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1228829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1228832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1228835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228854 */     // MIs[0] round
     /* 1228854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228864 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1228864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32),
     /* 1228867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1228885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228889 */     // GIR_Coverage, 23009,
     /* 1228889 */     GIR_EraseRootFromParent_Done,
     /* 1228890 */   // Label 17780: @1228890
     /* 1228890 */   GIM_Try, /*On fail goto*//*Label 17781*/ GIMT_Encode4(1228970), // Rule ID 23012 //
     /* 1228895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1228898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1228912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1228918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1228930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1228934 */     // MIs[0] round
     /* 1228934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1228937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1228944 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1228944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1228947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1228949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1228951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1228953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1228955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1228957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1228962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1228965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1228968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1228969 */     // GIR_Coverage, 23012,
     /* 1228969 */     GIR_EraseRootFromParent_Done,
     /* 1228970 */   // Label 17781: @1228970
     /* 1228970 */   GIM_Try, /*On fail goto*//*Label 17782*/ GIMT_Encode4(1229050), // Rule ID 23013 //
     /* 1228975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1228978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1228983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1228986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1228989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1228992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1228995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1228998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229014 */     // MIs[0] round
     /* 1229014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229024 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16),
     /* 1229027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229049 */     // GIR_Coverage, 23013,
     /* 1229049 */     GIR_EraseRootFromParent_Done,
     /* 1229050 */   // Label 17782: @1229050
     /* 1229050 */   GIM_Try, /*On fail goto*//*Label 17783*/ GIMT_Encode4(1229130), // Rule ID 23016 //
     /* 1229055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229094 */     // MIs[0] round
     /* 1229094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229104 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1229107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229129 */     // GIR_Coverage, 23016,
     /* 1229129 */     GIR_EraseRootFromParent_Done,
     /* 1229130 */   // Label 17783: @1229130
     /* 1229130 */   GIM_Try, /*On fail goto*//*Label 17784*/ GIMT_Encode4(1229210), // Rule ID 23017 //
     /* 1229135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1229152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229174 */     // MIs[0] round
     /* 1229174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229184 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16),
     /* 1229187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229209 */     // GIR_Coverage, 23017,
     /* 1229209 */     GIR_EraseRootFromParent_Done,
     /* 1229210 */   // Label 17784: @1229210
     /* 1229210 */   GIM_Try, /*On fail goto*//*Label 17785*/ GIMT_Encode4(1229290), // Rule ID 23020 //
     /* 1229215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1229218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229254 */     // MIs[0] round
     /* 1229254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229264 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1229267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229289 */     // GIR_Coverage, 23020,
     /* 1229289 */     GIR_EraseRootFromParent_Done,
     /* 1229290 */   // Label 17785: @1229290
     /* 1229290 */   GIM_Try, /*On fail goto*//*Label 17786*/ GIMT_Encode4(1229370), // Rule ID 23021 //
     /* 1229295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1229298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1229306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1229309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1229312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1229315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229334 */     // MIs[0] round
     /* 1229334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229344 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11242:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16),
     /* 1229347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1229365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229369 */     // GIR_Coverage, 23021,
     /* 1229369 */     GIR_EraseRootFromParent_Done,
     /* 1229370 */   // Label 17786: @1229370
     /* 1229370 */   GIM_Try, /*On fail goto*//*Label 17787*/ GIMT_Encode4(1229450), // Rule ID 23024 //
     /* 1229375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229414 */     // MIs[0] round
     /* 1229414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229424 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1229427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229449 */     // GIR_Coverage, 23024,
     /* 1229449 */     GIR_EraseRootFromParent_Done,
     /* 1229450 */   // Label 17787: @1229450
     /* 1229450 */   GIM_Try, /*On fail goto*//*Label 17788*/ GIMT_Encode4(1229530), // Rule ID 23025 //
     /* 1229455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1229472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1229490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229494 */     // MIs[0] round
     /* 1229494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229504 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32),
     /* 1229507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229529 */     // GIR_Coverage, 23025,
     /* 1229529 */     GIR_EraseRootFromParent_Done,
     /* 1229530 */   // Label 17788: @1229530
     /* 1229530 */   GIM_Try, /*On fail goto*//*Label 17789*/ GIMT_Encode4(1229610), // Rule ID 23028 //
     /* 1229535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229574 */     // MIs[0] round
     /* 1229574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229584 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1229587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229609 */     // GIR_Coverage, 23028,
     /* 1229609 */     GIR_EraseRootFromParent_Done,
     /* 1229610 */   // Label 17789: @1229610
     /* 1229610 */   GIM_Try, /*On fail goto*//*Label 17790*/ GIMT_Encode4(1229690), // Rule ID 23029 //
     /* 1229615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1229632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1229650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229654 */     // MIs[0] round
     /* 1229654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229664 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32),
     /* 1229667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229689 */     // GIR_Coverage, 23029,
     /* 1229689 */     GIR_EraseRootFromParent_Done,
     /* 1229690 */   // Label 17790: @1229690
     /* 1229690 */   GIM_Try, /*On fail goto*//*Label 17791*/ GIMT_Encode4(1229770), // Rule ID 23032 //
     /* 1229695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1229698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1229712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229734 */     // MIs[0] round
     /* 1229734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229744 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1229747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229769 */     // GIR_Coverage, 23032,
     /* 1229769 */     GIR_EraseRootFromParent_Done,
     /* 1229770 */   // Label 17791: @1229770
     /* 1229770 */   GIM_Try, /*On fail goto*//*Label 17792*/ GIMT_Encode4(1229850), // Rule ID 23033 //
     /* 1229775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1229778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum),
     /* 1229783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1229786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1229789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1229792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1229795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1229810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229814 */     // MIs[0] round
     /* 1229814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229824 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11242:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32),
     /* 1229827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1229831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1229845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229849 */     // GIR_Coverage, 23033,
     /* 1229849 */     GIR_EraseRootFromParent_Done,
     /* 1229850 */   // Label 17792: @1229850
     /* 1229850 */   GIM_Try, /*On fail goto*//*Label 17793*/ GIMT_Encode4(1229930), // Rule ID 64328 //
     /* 1229855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1229858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1229863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1229866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1229869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1229878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229894 */     // MIs[0] round
     /* 1229894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1229904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1229907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1229922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1229925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1229928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1229929 */     // GIR_Coverage, 64328,
     /* 1229929 */     GIR_EraseRootFromParent_Done,
     /* 1229930 */   // Label 17793: @1229930
     /* 1229930 */   GIM_Try, /*On fail goto*//*Label 17794*/ GIMT_Encode4(1230010), // Rule ID 64329 //
     /* 1229935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1229938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1229943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1229946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1229949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1229952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1229955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1229958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1229970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1229974 */     // MIs[0] round
     /* 1229974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1229977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1229984 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1229984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8),
     /* 1229987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1229989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1229991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1229993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1229995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1229997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230009 */     // GIR_Coverage, 64329,
     /* 1230009 */     GIR_EraseRootFromParent_Done,
     /* 1230010 */   // Label 17794: @1230010
     /* 1230010 */   GIM_Try, /*On fail goto*//*Label 17795*/ GIMT_Encode4(1230090), // Rule ID 64332 //
     /* 1230015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1230026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1230029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230054 */     // MIs[0] round
     /* 1230054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1230067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230089 */     // GIR_Coverage, 64332,
     /* 1230089 */     GIR_EraseRootFromParent_Done,
     /* 1230090 */   // Label 17795: @1230090
     /* 1230090 */   GIM_Try, /*On fail goto*//*Label 17796*/ GIMT_Encode4(1230170), // Rule ID 64333 //
     /* 1230095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1230106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1230109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230134 */     // MIs[0] round
     /* 1230134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4),
     /* 1230147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230169 */     // GIR_Coverage, 64333,
     /* 1230169 */     GIR_EraseRootFromParent_Done,
     /* 1230170 */   // Label 17796: @1230170
     /* 1230170 */   GIM_Try, /*On fail goto*//*Label 17797*/ GIMT_Encode4(1230250), // Rule ID 64336 //
     /* 1230175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1230186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1230189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230214 */     // MIs[0] round
     /* 1230214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230224 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1230227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230249 */     // GIR_Coverage, 64336,
     /* 1230249 */     GIR_EraseRootFromParent_Done,
     /* 1230250 */   // Label 17797: @1230250
     /* 1230250 */   GIM_Try, /*On fail goto*//*Label 17798*/ GIMT_Encode4(1230330), // Rule ID 64337 //
     /* 1230255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1230266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1230269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230294 */     // MIs[0] round
     /* 1230294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230304 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2),
     /* 1230307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230329 */     // GIR_Coverage, 64337,
     /* 1230329 */     GIR_EraseRootFromParent_Done,
     /* 1230330 */   // Label 17798: @1230330
     /* 1230330 */   GIM_Try, /*On fail goto*//*Label 17799*/ GIMT_Encode4(1230410), // Rule ID 64340 //
     /* 1230335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1230346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1230349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230374 */     // MIs[0] round
     /* 1230374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1230387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230409 */     // GIR_Coverage, 64340,
     /* 1230409 */     GIR_EraseRootFromParent_Done,
     /* 1230410 */   // Label 17799: @1230410
     /* 1230410 */   GIM_Try, /*On fail goto*//*Label 17800*/ GIMT_Encode4(1230490), // Rule ID 64341 //
     /* 1230415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1230426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1230429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1230432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1230450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230454 */     // MIs[0] round
     /* 1230454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11029:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1),
     /* 1230467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230489 */     // GIR_Coverage, 64341,
     /* 1230489 */     GIR_EraseRootFromParent_Done,
     /* 1230490 */   // Label 17800: @1230490
     /* 1230490 */   GIM_Try, /*On fail goto*//*Label 17801*/ GIMT_Encode4(1230570), // Rule ID 64344 //
     /* 1230495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1230506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1230509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230534 */     // MIs[0] round
     /* 1230534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230544 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1230547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230569 */     // GIR_Coverage, 64344,
     /* 1230569 */     GIR_EraseRootFromParent_Done,
     /* 1230570 */   // Label 17801: @1230570
     /* 1230570 */   GIM_Try, /*On fail goto*//*Label 17802*/ GIMT_Encode4(1230650), // Rule ID 64345 //
     /* 1230575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf),
     /* 1230583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1230586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1230589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1230592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1230606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1230610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230614 */     // MIs[0] round
     /* 1230614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230624 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11029:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_XU_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2),
     /* 1230627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230649 */     // GIR_Coverage, 64345,
     /* 1230649 */     GIR_EraseRootFromParent_Done,
     /* 1230650 */   // Label 17802: @1230650
     /* 1230650 */   GIM_Try, /*On fail goto*//*Label 17803*/ GIMT_Encode4(1230730), // Rule ID 64348 //
     /* 1230655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1230663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1230666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1230669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1230672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230694 */     // MIs[0] round
     /* 1230694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1230707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230729 */     // GIR_Coverage, 64348,
     /* 1230729 */     GIR_EraseRootFromParent_Done,
     /* 1230730 */   // Label 17803: @1230730
     /* 1230730 */   GIM_Try, /*On fail goto*//*Label 17804*/ GIMT_Encode4(1230810), // Rule ID 64349 //
     /* 1230735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1230743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1230746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1230749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1230752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230774 */     // MIs[0] round
     /* 1230774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230784 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8),
     /* 1230787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230809 */     // GIR_Coverage, 64349,
     /* 1230809 */     GIR_EraseRootFromParent_Done,
     /* 1230810 */   // Label 17804: @1230810
     /* 1230810 */   GIM_Try, /*On fail goto*//*Label 17805*/ GIMT_Encode4(1230890), // Rule ID 64352 //
     /* 1230815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1230823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1230826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1230829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230854 */     // MIs[0] round
     /* 1230854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230864 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1230864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1230867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230889 */     // GIR_Coverage, 64352,
     /* 1230889 */     GIR_EraseRootFromParent_Done,
     /* 1230890 */   // Label 17805: @1230890
     /* 1230890 */   GIM_Try, /*On fail goto*//*Label 17806*/ GIMT_Encode4(1230970), // Rule ID 64353 //
     /* 1230895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1230898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1230903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1230906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1230909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1230912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1230918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1230930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1230934 */     // MIs[0] round
     /* 1230934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1230937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1230944 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1230944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4),
     /* 1230947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1230949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1230951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1230953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1230955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1230957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1230962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1230965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1230968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1230969 */     // GIR_Coverage, 64353,
     /* 1230969 */     GIR_EraseRootFromParent_Done,
     /* 1230970 */   // Label 17806: @1230970
     /* 1230970 */   GIM_Try, /*On fail goto*//*Label 17807*/ GIMT_Encode4(1231050), // Rule ID 64356 //
     /* 1230975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1230978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1230983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1230986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1230989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1230992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1230995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1230998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231014 */     // MIs[0] round
     /* 1231014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231024 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1231027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231049 */     // GIR_Coverage, 64356,
     /* 1231049 */     GIR_EraseRootFromParent_Done,
     /* 1231050 */   // Label 17807: @1231050
     /* 1231050 */   GIM_Try, /*On fail goto*//*Label 17808*/ GIMT_Encode4(1231130), // Rule ID 64357 //
     /* 1231055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1231058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1231063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1231066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1231069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1231072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1231075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231094 */     // MIs[0] round
     /* 1231094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231104 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2),
     /* 1231107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231129 */     // GIR_Coverage, 64357,
     /* 1231129 */     GIR_EraseRootFromParent_Done,
     /* 1231130 */   // Label 17808: @1231130
     /* 1231130 */   GIM_Try, /*On fail goto*//*Label 17809*/ GIMT_Encode4(1231210), // Rule ID 64360 //
     /* 1231135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1231138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1231143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1231146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1231149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1231152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1231155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231174 */     // MIs[0] round
     /* 1231174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231184 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1231187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231209 */     // GIR_Coverage, 64360,
     /* 1231209 */     GIR_EraseRootFromParent_Done,
     /* 1231210 */   // Label 17809: @1231210
     /* 1231210 */   GIM_Try, /*On fail goto*//*Label 17810*/ GIMT_Encode4(1231290), // Rule ID 64361 //
     /* 1231215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1231218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1231223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1231226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1231229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1231232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1231235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1231250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231254 */     // MIs[0] round
     /* 1231254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231264 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11027:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1),
     /* 1231267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231289 */     // GIR_Coverage, 64361,
     /* 1231289 */     GIR_EraseRootFromParent_Done,
     /* 1231290 */   // Label 17810: @1231290
     /* 1231290 */   GIM_Try, /*On fail goto*//*Label 17811*/ GIMT_Encode4(1231370), // Rule ID 64364 //
     /* 1231295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 1231298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1231303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1231306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1231309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1231312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1231315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231334 */     // MIs[0] round
     /* 1231334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231344 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1231344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1231347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231369 */     // GIR_Coverage, 64364,
     /* 1231369 */     GIR_EraseRootFromParent_Done,
     /* 1231370 */   // Label 17811: @1231370
     /* 1231370 */   GIM_Try, /*On fail goto*//*Label 17812*/ GIMT_Encode4(1231450), // Rule ID 64365 //
     /* 1231375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 1231378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf),
     /* 1231383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1231386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1231389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1231392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1231395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1231406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1231410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1231414 */     // MIs[0] round
     /* 1231414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1231417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231424 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11027:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFNRCLIP_X_F_QF_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1231424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2),
     /* 1231427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1231437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1231448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231449 */     // GIR_Coverage, 64365,
     /* 1231449 */     GIR_EraseRootFromParent_Done,
     /* 1231450 */   // Label 17812: @1231450
     /* 1231450 */   GIM_Try, /*On fail goto*//*Label 17813*/ GIMT_Encode4(1231534), // Rule ID 2608 //
     /* 1231455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1231458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1231463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1231511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231533 */     // GIR_Coverage, 2608,
     /* 1231533 */     GIR_EraseRootFromParent_Done,
     /* 1231534 */   // Label 17813: @1231534
     /* 1231534 */   GIM_Try, /*On fail goto*//*Label 17814*/ GIMT_Encode4(1231618), // Rule ID 2609 //
     /* 1231539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1231542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1231547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8_MASK),
     /* 1231595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231617 */     // GIR_Coverage, 2609,
     /* 1231617 */     GIR_EraseRootFromParent_Done,
     /* 1231618 */   // Label 17814: @1231618
     /* 1231618 */   GIM_Try, /*On fail goto*//*Label 17815*/ GIMT_Encode4(1231702), // Rule ID 2620 //
     /* 1231623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1231626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1231631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231676 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1231676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1231679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1231685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1231687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231701 */     // GIR_Coverage, 2620,
     /* 1231701 */     GIR_EraseRootFromParent_Done,
     /* 1231702 */   // Label 17815: @1231702
     /* 1231702 */   GIM_Try, /*On fail goto*//*Label 17816*/ GIMT_Encode4(1231786), // Rule ID 2621 //
     /* 1231707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1231710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1231715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1231718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1231721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231760 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1231760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1231763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1231769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1231771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1231784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231785 */     // GIR_Coverage, 2621,
     /* 1231785 */     GIR_EraseRootFromParent_Done,
     /* 1231786 */   // Label 17816: @1231786
     /* 1231786 */   GIM_Try, /*On fail goto*//*Label 17817*/ GIMT_Encode4(1231867), // Rule ID 2622 //
     /* 1231791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1231794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1231799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1231802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1231805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1231821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231844 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1231844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1231847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231866 */     // GIR_Coverage, 2622,
     /* 1231866 */     GIR_EraseRootFromParent_Done,
     /* 1231867 */   // Label 17817: @1231867
     /* 1231867 */   GIM_Try, /*On fail goto*//*Label 17818*/ GIMT_Encode4(1231948), // Rule ID 2623 //
     /* 1231872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1231875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1231880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1231883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1231886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1231892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1231898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1231902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1231925 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1231925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF8),
     /* 1231928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1231930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1231932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1231934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1231936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1231938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1231943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1231946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1231947 */     // GIR_Coverage, 2623,
     /* 1231947 */     GIR_EraseRootFromParent_Done,
     /* 1231948 */   // Label 17818: @1231948
     /* 1231948 */   GIM_Try, /*On fail goto*//*Label 17819*/ GIMT_Encode4(1232032), // Rule ID 2672 //
     /* 1231953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1231956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1231961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1231964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1231967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1231970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1231973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1231976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1231979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1231983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1231995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1231999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232006 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1232006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1232009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232031 */     // GIR_Coverage, 2672,
     /* 1232031 */     GIR_EraseRootFromParent_Done,
     /* 1232032 */   // Label 17819: @1232032
     /* 1232032 */   GIM_Try, /*On fail goto*//*Label 17820*/ GIMT_Encode4(1232116), // Rule ID 2673 //
     /* 1232037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1232045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1232048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1232051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1232054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1232057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1232060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1232090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF8_E8_MASK),
     /* 1232093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1232097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1232114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232115 */     // GIR_Coverage, 2673,
     /* 1232115 */     GIR_EraseRootFromParent_Done,
     /* 1232116 */   // Label 17820: @1232116
     /* 1232116 */   GIM_Try, /*On fail goto*//*Label 17821*/ GIMT_Encode4(1232197), // Rule ID 5000 //
     /* 1232121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1232132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1232135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1232138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1232141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232174 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1232174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1232177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232196 */     // GIR_Coverage, 5000,
     /* 1232196 */     GIR_EraseRootFromParent_Done,
     /* 1232197 */   // Label 17821: @1232197
     /* 1232197 */   GIM_Try, /*On fail goto*//*Label 17822*/ GIMT_Encode4(1232278), // Rule ID 5001 //
     /* 1232202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1232213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1232216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1232219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1232222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232255 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1232255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1232258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232277 */     // GIR_Coverage, 5001,
     /* 1232277 */     GIR_EraseRootFromParent_Done,
     /* 1232278 */   // Label 17822: @1232278
     /* 1232278 */   GIM_Try, /*On fail goto*//*Label 17823*/ GIMT_Encode4(1232359), // Rule ID 5002 //
     /* 1232283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1232294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1232297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1232300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1232303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232336 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1232336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232358 */     // GIR_Coverage, 5002,
     /* 1232358 */     GIR_EraseRootFromParent_Done,
     /* 1232359 */   // Label 17823: @1232359
     /* 1232359 */   GIM_Try, /*On fail goto*//*Label 17824*/ GIMT_Encode4(1232440), // Rule ID 5003 //
     /* 1232364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1232375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1232378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1232381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1232384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1232387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232417 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1232417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1232438 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232439 */     // GIR_Coverage, 5003,
     /* 1232439 */     GIR_EraseRootFromParent_Done,
     /* 1232440 */   // Label 17824: @1232440
     /* 1232440 */   GIM_Try, /*On fail goto*//*Label 17825*/ GIMT_Encode4(1232521), // Rule ID 5004 //
     /* 1232445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1232456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1232459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1232465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1232468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232498 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1232498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1232501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232520 */     // GIR_Coverage, 5004,
     /* 1232520 */     GIR_EraseRootFromParent_Done,
     /* 1232521 */   // Label 17825: @1232521
     /* 1232521 */   GIM_Try, /*On fail goto*//*Label 17826*/ GIMT_Encode4(1232602), // Rule ID 5005 //
     /* 1232526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1232537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1232540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1232543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1232546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1232549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232579 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1232579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF4),
     /* 1232582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232601 */     // GIR_Coverage, 5005,
     /* 1232601 */     GIR_EraseRootFromParent_Done,
     /* 1232602 */   // Label 17826: @1232602
     /* 1232602 */   GIM_Try, /*On fail goto*//*Label 17827*/ GIMT_Encode4(1232683), // Rule ID 5006 //
     /* 1232607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1232618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1232621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1232627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1232660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232682 */     // GIR_Coverage, 5006,
     /* 1232682 */     GIR_EraseRootFromParent_Done,
     /* 1232683 */   // Label 17827: @1232683
     /* 1232683 */   GIM_Try, /*On fail goto*//*Label 17828*/ GIMT_Encode4(1232764), // Rule ID 5007 //
     /* 1232688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1232699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1232702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1232705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1232708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1232711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1232741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1232762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232763 */     // GIR_Coverage, 5007,
     /* 1232763 */     GIR_EraseRootFromParent_Done,
     /* 1232764 */   // Label 17828: @1232764
     /* 1232764 */   GIM_Try, /*On fail goto*//*Label 17829*/ GIMT_Encode4(1232845), // Rule ID 5008 //
     /* 1232769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1232780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1232783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1232789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1232792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232822 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1232822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232844 */     // GIR_Coverage, 5008,
     /* 1232844 */     GIR_EraseRootFromParent_Done,
     /* 1232845 */   // Label 17829: @1232845
     /* 1232845 */   GIM_Try, /*On fail goto*//*Label 17830*/ GIMT_Encode4(1232926), // Rule ID 5009 //
     /* 1232850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1232853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1232861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1232864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1232867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1232870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1232873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1232876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232903 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1232903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_MF2),
     /* 1232906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1232921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1232924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1232925 */     // GIR_Coverage, 5009,
     /* 1232925 */     GIR_EraseRootFromParent_Done,
     /* 1232926 */   // Label 17830: @1232926
     /* 1232926 */   GIM_Try, /*On fail goto*//*Label 17831*/ GIMT_Encode4(1233007), // Rule ID 5010 //
     /* 1232931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1232934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1232939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1232942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1232945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1232948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1232951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1232954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1232957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1232961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1232973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1232977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1232984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1232984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1232987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1232989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1232991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1232993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1232995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1232997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233006 */     // GIR_Coverage, 5010,
     /* 1233006 */     GIR_EraseRootFromParent_Done,
     /* 1233007 */   // Label 17831: @1233007
     /* 1233007 */   GIM_Try, /*On fail goto*//*Label 17832*/ GIMT_Encode4(1233088), // Rule ID 5011 //
     /* 1233012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1233023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1233026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1233029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1233032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1233035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233065 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1233065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233087 */     // GIR_Coverage, 5011,
     /* 1233087 */     GIR_EraseRootFromParent_Done,
     /* 1233088 */   // Label 17832: @1233088
     /* 1233088 */   GIM_Try, /*On fail goto*//*Label 17833*/ GIMT_Encode4(1233169), // Rule ID 5012 //
     /* 1233093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1233096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1233116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233146 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1233146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233168 */     // GIR_Coverage, 5012,
     /* 1233168 */     GIR_EraseRootFromParent_Done,
     /* 1233169 */   // Label 17833: @1233169
     /* 1233169 */   GIM_Try, /*On fail goto*//*Label 17834*/ GIMT_Encode4(1233250), // Rule ID 5013 //
     /* 1233174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1233185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1233188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1233191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1233194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1233197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233227 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1233227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1233248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233249 */     // GIR_Coverage, 5013,
     /* 1233249 */     GIR_EraseRootFromParent_Done,
     /* 1233250 */   // Label 17834: @1233250
     /* 1233250 */   GIM_Try, /*On fail goto*//*Label 17835*/ GIMT_Encode4(1233331), // Rule ID 5014 //
     /* 1233255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1233258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233308 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1233308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233330 */     // GIR_Coverage, 5014,
     /* 1233330 */     GIR_EraseRootFromParent_Done,
     /* 1233331 */   // Label 17835: @1233331
     /* 1233331 */   GIM_Try, /*On fail goto*//*Label 17836*/ GIMT_Encode4(1233412), // Rule ID 5015 //
     /* 1233336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1233347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1233350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1233353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1233356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1233359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233389 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1233389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1233410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233411 */     // GIR_Coverage, 5015,
     /* 1233411 */     GIR_EraseRootFromParent_Done,
     /* 1233412 */   // Label 17836: @1233412
     /* 1233412 */   GIM_Try, /*On fail goto*//*Label 17837*/ GIMT_Encode4(1233493), // Rule ID 5016 //
     /* 1233417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1233420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1233434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1233470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233492 */     // GIR_Coverage, 5016,
     /* 1233492 */     GIR_EraseRootFromParent_Done,
     /* 1233493 */   // Label 17837: @1233493
     /* 1233493 */   GIM_Try, /*On fail goto*//*Label 17838*/ GIMT_Encode4(1233574), // Rule ID 5017 //
     /* 1233498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1233501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1233509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1233512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1233515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1233518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1233521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1233528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1233540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233551 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1233551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M1),
     /* 1233554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1233572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233573 */     // GIR_Coverage, 5017,
     /* 1233573 */     GIR_EraseRootFromParent_Done,
     /* 1233574 */   // Label 17838: @1233574
     /* 1233574 */   GIM_Try, /*On fail goto*//*Label 17839*/ GIMT_Encode4(1233655), // Rule ID 5018 //
     /* 1233579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1233582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1233590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1233593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1233596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1233599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1233602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1233609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233632 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1233632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1233635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233654 */     // GIR_Coverage, 5018,
     /* 1233654 */     GIR_EraseRootFromParent_Done,
     /* 1233655 */   // Label 17839: @1233655
     /* 1233655 */   GIM_Try, /*On fail goto*//*Label 17840*/ GIMT_Encode4(1233736), // Rule ID 5019 //
     /* 1233660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1233671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1233674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1233677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1233680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1233683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1233690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1233702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233713 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1233713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1233716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233735 */     // GIR_Coverage, 5019,
     /* 1233735 */     GIR_EraseRootFromParent_Done,
     /* 1233736 */   // Label 17840: @1233736
     /* 1233736 */   GIM_Try, /*On fail goto*//*Label 17841*/ GIMT_Encode4(1233817), // Rule ID 5020 //
     /* 1233741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1233744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1233752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1233755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1233758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1233761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1233764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1233771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233794 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1233794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1233797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233816 */     // GIR_Coverage, 5020,
     /* 1233816 */     GIR_EraseRootFromParent_Done,
     /* 1233817 */   // Label 17841: @1233817
     /* 1233817 */   GIM_Try, /*On fail goto*//*Label 17842*/ GIMT_Encode4(1233898), // Rule ID 5021 //
     /* 1233822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1233833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1233836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1233839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1233842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1233845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1233848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1233852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1233864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233875 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1233875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1233878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233897 */     // GIR_Coverage, 5021,
     /* 1233897 */     GIR_EraseRootFromParent_Done,
     /* 1233898 */   // Label 17842: @1233898
     /* 1233898 */   GIM_Try, /*On fail goto*//*Label 17843*/ GIMT_Encode4(1233979), // Rule ID 5022 //
     /* 1233903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1233906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1233914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1233917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1233920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1233923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1233926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1233929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1233933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1233945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1233949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1233956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1233956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1233959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1233961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1233963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1233965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1233967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1233969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1233974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1233977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1233978 */     // GIR_Coverage, 5022,
     /* 1233978 */     GIR_EraseRootFromParent_Done,
     /* 1233979 */   // Label 17843: @1233979
     /* 1233979 */   GIM_Try, /*On fail goto*//*Label 17844*/ GIMT_Encode4(1234060), // Rule ID 5023 //
     /* 1233984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1233987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1233992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1233995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1233998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1234001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1234004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1234007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1234014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234037 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1234037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1234040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1234058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234059 */     // GIR_Coverage, 5023,
     /* 1234059 */     GIR_EraseRootFromParent_Done,
     /* 1234060 */   // Label 17844: @1234060
     /* 1234060 */   GIM_Try, /*On fail goto*//*Label 17845*/ GIMT_Encode4(1234141), // Rule ID 5024 //
     /* 1234065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1234076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1234079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1234085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1234095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234118 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1234118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1234121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234140 */     // GIR_Coverage, 5024,
     /* 1234140 */     GIR_EraseRootFromParent_Done,
     /* 1234141 */   // Label 17845: @1234141
     /* 1234141 */   GIM_Try, /*On fail goto*//*Label 17846*/ GIMT_Encode4(1234222), // Rule ID 5025 //
     /* 1234146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1234157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1234160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1234163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1234166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1234176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234199 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1234199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1234202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234221 */     // GIR_Coverage, 5025,
     /* 1234221 */     GIR_EraseRootFromParent_Done,
     /* 1234222 */   // Label 17846: @1234222
     /* 1234222 */   GIM_Try, /*On fail goto*//*Label 17847*/ GIMT_Encode4(1234303), // Rule ID 5026 //
     /* 1234227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1234238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1234241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1234247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1234257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234280 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1234280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1234283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234302 */     // GIR_Coverage, 5026,
     /* 1234302 */     GIR_EraseRootFromParent_Done,
     /* 1234303 */   // Label 17847: @1234303
     /* 1234303 */   GIM_Try, /*On fail goto*//*Label 17848*/ GIMT_Encode4(1234384), // Rule ID 5027 //
     /* 1234308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1234319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1234322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1234325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1234328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1234338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234361 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1234361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1234364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234382 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234383 */     // GIR_Coverage, 5027,
     /* 1234383 */     GIR_EraseRootFromParent_Done,
     /* 1234384 */   // Label 17848: @1234384
     /* 1234384 */   GIM_Try, /*On fail goto*//*Label 17849*/ GIMT_Encode4(1234465), // Rule ID 5028 //
     /* 1234389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1234400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1234403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1234409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1234412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1234419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1234442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1234445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234464 */     // GIR_Coverage, 5028,
     /* 1234464 */     GIR_EraseRootFromParent_Done,
     /* 1234465 */   // Label 17849: @1234465
     /* 1234465 */   GIM_Try, /*On fail goto*//*Label 17850*/ GIMT_Encode4(1234546), // Rule ID 5029 //
     /* 1234470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1234481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1234484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1234487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1234490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1234493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1234500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234523 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1234523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1234526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1234544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234545 */     // GIR_Coverage, 5029,
     /* 1234545 */     GIR_EraseRootFromParent_Done,
     /* 1234546 */   // Label 17850: @1234546
     /* 1234546 */   GIM_Try, /*On fail goto*//*Label 17851*/ GIMT_Encode4(1234627), // Rule ID 5030 //
     /* 1234551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1234562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1234565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1234571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1234574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1234581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1234604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1234607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234626 */     // GIR_Coverage, 5030,
     /* 1234626 */     GIR_EraseRootFromParent_Done,
     /* 1234627 */   // Label 17851: @1234627
     /* 1234627 */   GIM_Try, /*On fail goto*//*Label 17852*/ GIMT_Encode4(1234708), // Rule ID 5031 //
     /* 1234632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1234643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1234646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1234649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1234652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1234655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1234662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1234674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234685 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1234685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1234688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234707 */     // GIR_Coverage, 5031,
     /* 1234707 */     GIR_EraseRootFromParent_Done,
     /* 1234708 */   // Label 17852: @1234708
     /* 1234708 */   GIM_Try, /*On fail goto*//*Label 17853*/ GIMT_Encode4(1234789), // Rule ID 5032 //
     /* 1234713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1234724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1234727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1234733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1234743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1234766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1234769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234788 */     // GIR_Coverage, 5032,
     /* 1234788 */     GIR_EraseRootFromParent_Done,
     /* 1234789 */   // Label 17853: @1234789
     /* 1234789 */   GIM_Try, /*On fail goto*//*Label 17854*/ GIMT_Encode4(1234870), // Rule ID 5033 //
     /* 1234794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1234805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1234808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1234811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1234814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1234817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1234824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1234836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234847 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1234847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1234850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234869 */     // GIR_Coverage, 5033,
     /* 1234869 */     GIR_EraseRootFromParent_Done,
     /* 1234870 */   // Label 17854: @1234870
     /* 1234870 */   GIM_Try, /*On fail goto*//*Label 17855*/ GIMT_Encode4(1234951), // Rule ID 5034 //
     /* 1234875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1234878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1234886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1234889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1234895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1234901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1234905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1234921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1234928 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1234928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1234931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1234933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1234935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1234937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1234939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1234941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1234946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1234949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1234950 */     // GIR_Coverage, 5034,
     /* 1234950 */     GIR_EraseRootFromParent_Done,
     /* 1234951 */   // Label 17855: @1234951
     /* 1234951 */   GIM_Try, /*On fail goto*//*Label 17856*/ GIMT_Encode4(1235032), // Rule ID 5035 //
     /* 1234956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1234959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1234964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1234967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1234970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1234973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1234976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1234979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1234982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1234986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1234998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235009 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1235009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1235012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1235030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235031 */     // GIR_Coverage, 5035,
     /* 1235031 */     GIR_EraseRootFromParent_Done,
     /* 1235032 */   // Label 17856: @1235032
     /* 1235032 */   GIM_Try, /*On fail goto*//*Label 17857*/ GIMT_Encode4(1235113), // Rule ID 5036 //
     /* 1235037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1235040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1235048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1235051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1235054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1235057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1235067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1235090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1235093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235112 */     // GIR_Coverage, 5036,
     /* 1235112 */     GIR_EraseRootFromParent_Done,
     /* 1235113 */   // Label 17857: @1235113
     /* 1235113 */   GIM_Try, /*On fail goto*//*Label 17858*/ GIMT_Encode4(1235194), // Rule ID 5037 //
     /* 1235118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1235121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1235129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1235132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1235135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1235138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1235148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1235160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235171 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1235171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M2),
     /* 1235174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235176 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235193 */     // GIR_Coverage, 5037,
     /* 1235193 */     GIR_EraseRootFromParent_Done,
     /* 1235194 */   // Label 17858: @1235194
     /* 1235194 */   GIM_Try, /*On fail goto*//*Label 17859*/ GIMT_Encode4(1235275), // Rule ID 5038 //
     /* 1235199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1235202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1235210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1235213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1235216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1235219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1235229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1235252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1235255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235274 */     // GIR_Coverage, 5038,
     /* 1235274 */     GIR_EraseRootFromParent_Done,
     /* 1235275 */   // Label 17859: @1235275
     /* 1235275 */   GIM_Try, /*On fail goto*//*Label 17860*/ GIMT_Encode4(1235356), // Rule ID 5039 //
     /* 1235280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1235283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1235291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1235294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1235297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1235300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1235310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1235322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235333 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1235333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M4),
     /* 1235336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235355 */     // GIR_Coverage, 5039,
     /* 1235355 */     GIR_EraseRootFromParent_Done,
     /* 1235356 */   // Label 17860: @1235356
     /* 1235356 */   GIM_Try, /*On fail goto*//*Label 17861*/ GIMT_Encode4(1235437), // Rule ID 5040 //
     /* 1235361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1235364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1235372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1235375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1235378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1235381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1235384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1235391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235414 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1235414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1235417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235436 */     // GIR_Coverage, 5040,
     /* 1235436 */     GIR_EraseRootFromParent_Done,
     /* 1235437 */   // Label 17861: @1235437
     /* 1235437 */   GIM_Try, /*On fail goto*//*Label 17862*/ GIMT_Encode4(1235518), // Rule ID 5041 //
     /* 1235442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1235445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1235453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1235456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1235459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1235462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1235465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1235472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1235484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235495 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1235495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VVM_M8),
     /* 1235498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1235516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235517 */     // GIR_Coverage, 5041,
     /* 1235517 */     GIR_EraseRootFromParent_Done,
     /* 1235518 */   // Label 17862: @1235518
     /* 1235518 */   GIM_Try, /*On fail goto*//*Label 17863*/ GIMT_Encode4(1235599), // Rule ID 5042 //
     /* 1235523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1235526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1235540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235576 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1235576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1235579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235598 */     // GIR_Coverage, 5042,
     /* 1235598 */     GIR_EraseRootFromParent_Done,
     /* 1235599 */   // Label 17863: @1235599
     /* 1235599 */   GIM_Try, /*On fail goto*//*Label 17864*/ GIMT_Encode4(1235680), // Rule ID 5043 //
     /* 1235604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1235607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1235615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1235618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1235621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1235627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235657 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1235657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF8),
     /* 1235660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235679 */     // GIR_Coverage, 5043,
     /* 1235679 */     GIR_EraseRootFromParent_Done,
     /* 1235680 */   // Label 17864: @1235680
     /* 1235680 */   GIM_Try, /*On fail goto*//*Label 17865*/ GIMT_Encode4(1235761), // Rule ID 5044 //
     /* 1235685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1235688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1235702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235738 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1235738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1235741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235760 */     // GIR_Coverage, 5044,
     /* 1235760 */     GIR_EraseRootFromParent_Done,
     /* 1235761 */   // Label 17865: @1235761
     /* 1235761 */   GIM_Try, /*On fail goto*//*Label 17866*/ GIMT_Encode4(1235842), // Rule ID 5045 //
     /* 1235766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1235769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1235777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1235780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1235783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1235789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235819 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1235819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1235822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235841 */     // GIR_Coverage, 5045,
     /* 1235841 */     GIR_EraseRootFromParent_Done,
     /* 1235842 */   // Label 17866: @1235842
     /* 1235842 */   GIM_Try, /*On fail goto*//*Label 17867*/ GIMT_Encode4(1235923), // Rule ID 5046 //
     /* 1235847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1235850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1235864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1235867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1235873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235900 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1235900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1235903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1235921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1235922 */     // GIR_Coverage, 5046,
     /* 1235922 */     GIR_EraseRootFromParent_Done,
     /* 1235923 */   // Label 17867: @1235923
     /* 1235923 */   GIM_Try, /*On fail goto*//*Label 17868*/ GIMT_Encode4(1236004), // Rule ID 5047 //
     /* 1235928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1235931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1235936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1235939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1235942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1235945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1235948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1235951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1235954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1235958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1235966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1235970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1235974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1235981 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1235981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1235984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1235986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1235988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1235990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1235992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1235994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1235999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236003 */     // GIR_Coverage, 5047,
     /* 1236003 */     GIR_EraseRootFromParent_Done,
     /* 1236004 */   // Label 17868: @1236004
     /* 1236004 */   GIM_Try, /*On fail goto*//*Label 17869*/ GIMT_Encode4(1236085), // Rule ID 5048 //
     /* 1236009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1236062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1236065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236084 */     // GIR_Coverage, 5048,
     /* 1236084 */     GIR_EraseRootFromParent_Done,
     /* 1236085 */   // Label 17869: @1236085
     /* 1236085 */   GIM_Try, /*On fail goto*//*Label 17870*/ GIMT_Encode4(1236166), // Rule ID 5049 //
     /* 1236090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1236101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1236104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1236107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1236143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF4),
     /* 1236146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236165 */     // GIR_Coverage, 5049,
     /* 1236165 */     GIR_EraseRootFromParent_Done,
     /* 1236166 */   // Label 17870: @1236166
     /* 1236166 */   GIM_Try, /*On fail goto*//*Label 17871*/ GIMT_Encode4(1236247), // Rule ID 5050 //
     /* 1236171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236224 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1236224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1236227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236246 */     // GIR_Coverage, 5050,
     /* 1236246 */     GIR_EraseRootFromParent_Done,
     /* 1236247 */   // Label 17871: @1236247
     /* 1236247 */   GIM_Try, /*On fail goto*//*Label 17872*/ GIMT_Encode4(1236328), // Rule ID 5051 //
     /* 1236252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1236263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1236266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1236269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236305 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1236305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1236308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236327 */     // GIR_Coverage, 5051,
     /* 1236327 */     GIR_EraseRootFromParent_Done,
     /* 1236328 */   // Label 17872: @1236328
     /* 1236328 */   GIM_Try, /*On fail goto*//*Label 17873*/ GIMT_Encode4(1236409), // Rule ID 5052 //
     /* 1236333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1236344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1236347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1236350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236386 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1236386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1236389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236408 */     // GIR_Coverage, 5052,
     /* 1236408 */     GIR_EraseRootFromParent_Done,
     /* 1236409 */   // Label 17873: @1236409
     /* 1236409 */   GIM_Try, /*On fail goto*//*Label 17874*/ GIMT_Encode4(1236490), // Rule ID 5053 //
     /* 1236414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1236425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1236428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1236431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1236437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236467 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1236467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_MF2),
     /* 1236470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236489 */     // GIR_Coverage, 5053,
     /* 1236489 */     GIR_EraseRootFromParent_Done,
     /* 1236490 */   // Label 17874: @1236490
     /* 1236490 */   GIM_Try, /*On fail goto*//*Label 17875*/ GIMT_Encode4(1236571), // Rule ID 5054 //
     /* 1236495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1236512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1236518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1236548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236570 */     // GIR_Coverage, 5054,
     /* 1236570 */     GIR_EraseRootFromParent_Done,
     /* 1236571 */   // Label 17875: @1236571
     /* 1236571 */   GIM_Try, /*On fail goto*//*Label 17876*/ GIMT_Encode4(1236652), // Rule ID 5055 //
     /* 1236576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1236587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1236590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1236593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1236599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236629 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11073:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1236629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236634 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1236650 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236651 */     // GIR_Coverage, 5055,
     /* 1236651 */     GIR_EraseRootFromParent_Done,
     /* 1236652 */   // Label 17876: @1236652
     /* 1236652 */   GIM_Try, /*On fail goto*//*Label 17877*/ GIMT_Encode4(1236733), // Rule ID 5056 //
     /* 1236657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1236710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236732 */     // GIR_Coverage, 5056,
     /* 1236732 */     GIR_EraseRootFromParent_Done,
     /* 1236733 */   // Label 17877: @1236733
     /* 1236733 */   GIM_Try, /*On fail goto*//*Label 17878*/ GIMT_Encode4(1236814), // Rule ID 5057 //
     /* 1236738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1236749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1236752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1236755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1236761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236791 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11073:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1236791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1236812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236813 */     // GIR_Coverage, 5057,
     /* 1236813 */     GIR_EraseRootFromParent_Done,
     /* 1236814 */   // Label 17878: @1236814
     /* 1236814 */   GIM_Try, /*On fail goto*//*Label 17879*/ GIMT_Encode4(1236895), // Rule ID 5058 //
     /* 1236819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1236822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1236839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1236845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236872 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1236872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236894 */     // GIR_Coverage, 5058,
     /* 1236894 */     GIR_EraseRootFromParent_Done,
     /* 1236895 */   // Label 17879: @1236895
     /* 1236895 */   GIM_Try, /*On fail goto*//*Label 17880*/ GIMT_Encode4(1236976), // Rule ID 5059 //
     /* 1236900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1236903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1236911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1236914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1236917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1236920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1236923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1236926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1236930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1236938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1236942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1236946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1236953 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11073:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1236953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1236956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1236958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1236960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1236962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1236964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1236966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1236971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1236974 */     GIR_RootConstrainSelectedInstOperands,
     /* 1236975 */     // GIR_Coverage, 5059,
     /* 1236975 */     GIR_EraseRootFromParent_Done,
     /* 1236976 */   // Label 17880: @1236976
     /* 1236976 */   GIM_Try, /*On fail goto*//*Label 17881*/ GIMT_Encode4(1237057), // Rule ID 5060 //
     /* 1236981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1236984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1236989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1236992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1236995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1236998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237034 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1237034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1237037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237056 */     // GIR_Coverage, 5060,
     /* 1237056 */     GIR_EraseRootFromParent_Done,
     /* 1237057 */   // Label 17881: @1237057
     /* 1237057 */   GIM_Try, /*On fail goto*//*Label 17882*/ GIMT_Encode4(1237138), // Rule ID 5061 //
     /* 1237062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1237065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1237073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1237076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1237079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1237085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1237092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1237100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237115 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11073:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1237115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M1),
     /* 1237118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1237136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237137 */     // GIR_Coverage, 5061,
     /* 1237137 */     GIR_EraseRootFromParent_Done,
     /* 1237138 */   // Label 17882: @1237138
     /* 1237138 */   GIM_Try, /*On fail goto*//*Label 17883*/ GIMT_Encode4(1237219), // Rule ID 5062 //
     /* 1237143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1237154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1237157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1237160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1237173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237196 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1237196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1237199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237218 */     // GIR_Coverage, 5062,
     /* 1237218 */     GIR_EraseRootFromParent_Done,
     /* 1237219 */   // Label 17883: @1237219
     /* 1237219 */   GIM_Try, /*On fail goto*//*Label 17884*/ GIMT_Encode4(1237300), // Rule ID 5063 //
     /* 1237224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1237235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1237238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1237241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1237254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237277 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1237277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1237280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237299 */     // GIR_Coverage, 5063,
     /* 1237299 */     GIR_EraseRootFromParent_Done,
     /* 1237300 */   // Label 17884: @1237300
     /* 1237300 */   GIM_Try, /*On fail goto*//*Label 17885*/ GIMT_Encode4(1237381), // Rule ID 5064 //
     /* 1237305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1237316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1237319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1237322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1237328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1237335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1237358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1237361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237380 */     // GIR_Coverage, 5064,
     /* 1237380 */     GIR_EraseRootFromParent_Done,
     /* 1237381 */   // Label 17885: @1237381
     /* 1237381 */   GIM_Try, /*On fail goto*//*Label 17886*/ GIMT_Encode4(1237462), // Rule ID 5065 //
     /* 1237386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1237397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1237400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1237403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1237409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1237416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237439 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1237439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1237442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237461 */     // GIR_Coverage, 5065,
     /* 1237461 */     GIR_EraseRootFromParent_Done,
     /* 1237462 */   // Label 17886: @1237462
     /* 1237462 */   GIM_Try, /*On fail goto*//*Label 17887*/ GIMT_Encode4(1237543), // Rule ID 5066 //
     /* 1237467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1237478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1237481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1237484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1237490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1237497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237520 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1237520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1237523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237542 */     // GIR_Coverage, 5066,
     /* 1237542 */     GIR_EraseRootFromParent_Done,
     /* 1237543 */   // Label 17887: @1237543
     /* 1237543 */   GIM_Try, /*On fail goto*//*Label 17888*/ GIMT_Encode4(1237624), // Rule ID 5067 //
     /* 1237548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1237559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1237562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1237565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1237571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1237578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237601 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1237601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1237604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1237622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237623 */     // GIR_Coverage, 5067,
     /* 1237623 */     GIR_EraseRootFromParent_Done,
     /* 1237624 */   // Label 17888: @1237624
     /* 1237624 */   GIM_Try, /*On fail goto*//*Label 17889*/ GIMT_Encode4(1237705), // Rule ID 5068 //
     /* 1237629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1237659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1237682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1237685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237704 */     // GIR_Coverage, 5068,
     /* 1237704 */     GIR_EraseRootFromParent_Done,
     /* 1237705 */   // Label 17889: @1237705
     /* 1237705 */   GIM_Try, /*On fail goto*//*Label 17890*/ GIMT_Encode4(1237786), // Rule ID 5069 //
     /* 1237710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1237721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1237724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1237727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1237733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1237740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1237748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237763 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1237763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1237766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237785 */     // GIR_Coverage, 5069,
     /* 1237785 */     GIR_EraseRootFromParent_Done,
     /* 1237786 */   // Label 17890: @1237786
     /* 1237786 */   GIM_Try, /*On fail goto*//*Label 17891*/ GIMT_Encode4(1237867), // Rule ID 5070 //
     /* 1237791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1237821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1237844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1237847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237866 */     // GIR_Coverage, 5070,
     /* 1237866 */     GIR_EraseRootFromParent_Done,
     /* 1237867 */   // Label 17891: @1237867
     /* 1237867 */   GIM_Try, /*On fail goto*//*Label 17892*/ GIMT_Encode4(1237948), // Rule ID 5071 //
     /* 1237872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1237875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1237883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1237886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1237889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1237892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1237895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1237898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1237902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1237910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1237925 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1237925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1237928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1237930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1237932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1237934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1237936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1237938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1237943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1237946 */     GIR_RootConstrainSelectedInstOperands,
     /* 1237947 */     // GIR_Coverage, 5071,
     /* 1237947 */     GIR_EraseRootFromParent_Done,
     /* 1237948 */   // Label 17892: @1237948
     /* 1237948 */   GIM_Try, /*On fail goto*//*Label 17893*/ GIMT_Encode4(1238029), // Rule ID 5072 //
     /* 1237953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1237956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1237961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1237964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1237967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1237970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1237973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1237976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1237979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1237983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1237991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1237995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1237999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238006 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1238006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1238009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238028 */     // GIR_Coverage, 5072,
     /* 1238028 */     GIR_EraseRootFromParent_Done,
     /* 1238029 */   // Label 17893: @1238029
     /* 1238029 */   GIM_Try, /*On fail goto*//*Label 17894*/ GIMT_Encode4(1238110), // Rule ID 5073 //
     /* 1238034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1238045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1238048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1238051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1238057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238087 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1238087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1238090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1238108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238109 */     // GIR_Coverage, 5073,
     /* 1238109 */     GIR_EraseRootFromParent_Done,
     /* 1238110 */   // Label 17894: @1238110
     /* 1238110 */   GIM_Try, /*On fail goto*//*Label 17895*/ GIMT_Encode4(1238191), // Rule ID 5074 //
     /* 1238115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1238126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1238129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1238132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1238168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1238171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238190 */     // GIR_Coverage, 5074,
     /* 1238190 */     GIR_EraseRootFromParent_Done,
     /* 1238191 */   // Label 17895: @1238191
     /* 1238191 */   GIM_Try, /*On fail goto*//*Label 17896*/ GIMT_Encode4(1238272), // Rule ID 5075 //
     /* 1238196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1238207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1238210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1238213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1238249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1238252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238271 */     // GIR_Coverage, 5075,
     /* 1238271 */     GIR_EraseRootFromParent_Done,
     /* 1238272 */   // Label 17896: @1238272
     /* 1238272 */   GIM_Try, /*On fail goto*//*Label 17897*/ GIMT_Encode4(1238353), // Rule ID 5076 //
     /* 1238277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1238288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1238291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1238330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1238333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238352 */     // GIR_Coverage, 5076,
     /* 1238352 */     GIR_EraseRootFromParent_Done,
     /* 1238353 */   // Label 17897: @1238353
     /* 1238353 */   GIM_Try, /*On fail goto*//*Label 17898*/ GIMT_Encode4(1238434), // Rule ID 5077 //
     /* 1238358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1238369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1238372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1238375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238411 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1238411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1238414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238433 */     // GIR_Coverage, 5077,
     /* 1238433 */     GIR_EraseRootFromParent_Done,
     /* 1238434 */   // Label 17898: @1238434
     /* 1238434 */   GIM_Try, /*On fail goto*//*Label 17899*/ GIMT_Encode4(1238515), // Rule ID 5078 //
     /* 1238439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1238442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1238450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1238453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1238456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1238462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238492 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1238492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1238495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238514 */     // GIR_Coverage, 5078,
     /* 1238514 */     GIR_EraseRootFromParent_Done,
     /* 1238515 */   // Label 17899: @1238515
     /* 1238515 */   GIM_Try, /*On fail goto*//*Label 17900*/ GIMT_Encode4(1238596), // Rule ID 5079 //
     /* 1238520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1238523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1238531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1238534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1238537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1238543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238573 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1238573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1238576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1238594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238595 */     // GIR_Coverage, 5079,
     /* 1238595 */     GIR_EraseRootFromParent_Done,
     /* 1238596 */   // Label 17900: @1238596
     /* 1238596 */   GIM_Try, /*On fail goto*//*Label 17901*/ GIMT_Encode4(1238677), // Rule ID 5080 //
     /* 1238601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1238604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1238612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1238615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1238618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1238654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1238657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238676 */     // GIR_Coverage, 5080,
     /* 1238676 */     GIR_EraseRootFromParent_Done,
     /* 1238677 */   // Label 17901: @1238677
     /* 1238677 */   GIM_Try, /*On fail goto*//*Label 17902*/ GIMT_Encode4(1238758), // Rule ID 5081 //
     /* 1238682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1238685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1238693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1238696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1238699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1238705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1238712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1238720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238735 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11073:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1238735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M2),
     /* 1238738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238757 */     // GIR_Coverage, 5081,
     /* 1238757 */     GIR_EraseRootFromParent_Done,
     /* 1238758 */   // Label 17902: @1238758
     /* 1238758 */   GIM_Try, /*On fail goto*//*Label 17903*/ GIMT_Encode4(1238839), // Rule ID 5082 //
     /* 1238763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1238766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1238774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1238777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1238780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238816 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1238816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1238819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238838 */     // GIR_Coverage, 5082,
     /* 1238838 */     GIR_EraseRootFromParent_Done,
     /* 1238839 */   // Label 17903: @1238839
     /* 1238839 */   GIM_Try, /*On fail goto*//*Label 17904*/ GIMT_Encode4(1238920), // Rule ID 5083 //
     /* 1238844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1238847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1238855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1238858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1238861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1238864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1238867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1238870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1238874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1238882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238897 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11073:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1238897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M4),
     /* 1238900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1238919 */     // GIR_Coverage, 5083,
     /* 1238919 */     GIR_EraseRootFromParent_Done,
     /* 1238920 */   // Label 17904: @1238920
     /* 1238920 */   GIM_Try, /*On fail goto*//*Label 17905*/ GIMT_Encode4(1239001), // Rule ID 5084 //
     /* 1238925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1238928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1238933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1238936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1238939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1238942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1238945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1238948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1238951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1238955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1238963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1238967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1238971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1238978 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1238978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1238981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1238983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1238985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1238987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1238989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1238991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1238996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1238999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239000 */     // GIR_Coverage, 5084,
     /* 1239000 */     GIR_EraseRootFromParent_Done,
     /* 1239001 */   // Label 17905: @1239001
     /* 1239001 */   GIM_Try, /*On fail goto*//*Label 17906*/ GIMT_Encode4(1239082), // Rule ID 5085 //
     /* 1239006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1239009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadc),
     /* 1239014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1239017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1239020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1239023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1239026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1239029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1239036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1239044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1239048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239059 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11073:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVADC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1239059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADC_VXM_M8),
     /* 1239062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1239080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239081 */     // GIR_Coverage, 5085,
     /* 1239081 */     GIR_EraseRootFromParent_Done,
     /* 1239082 */   // Label 17906: @1239082
     /* 1239082 */   GIM_Try, /*On fail goto*//*Label 17907*/ GIMT_Encode4(1239163), // Rule ID 5390 //
     /* 1239087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1239107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1239143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239162 */     // GIR_Coverage, 5390,
     /* 1239162 */     GIR_EraseRootFromParent_Done,
     /* 1239163 */   // Label 17907: @1239163
     /* 1239163 */   GIM_Try, /*On fail goto*//*Label 17908*/ GIMT_Encode4(1239244), // Rule ID 5391 //
     /* 1239168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1239179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1239182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1239185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1239188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239221 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF8),
     /* 1239224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239243 */     // GIR_Coverage, 5391,
     /* 1239243 */     GIR_EraseRootFromParent_Done,
     /* 1239244 */   // Label 17908: @1239244
     /* 1239244 */   GIM_Try, /*On fail goto*//*Label 17909*/ GIMT_Encode4(1239325), // Rule ID 5392 //
     /* 1239249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1239305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239324 */     // GIR_Coverage, 5392,
     /* 1239324 */     GIR_EraseRootFromParent_Done,
     /* 1239325 */   // Label 17909: @1239325
     /* 1239325 */   GIM_Try, /*On fail goto*//*Label 17910*/ GIMT_Encode4(1239406), // Rule ID 5393 //
     /* 1239330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1239341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1239344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1239347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1239350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239383 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1239386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239405 */     // GIR_Coverage, 5393,
     /* 1239405 */     GIR_EraseRootFromParent_Done,
     /* 1239406 */   // Label 17910: @1239406
     /* 1239406 */   GIM_Try, /*On fail goto*//*Label 17911*/ GIMT_Encode4(1239487), // Rule ID 5394 //
     /* 1239411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239464 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1239464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1239467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239486 */     // GIR_Coverage, 5394,
     /* 1239486 */     GIR_EraseRootFromParent_Done,
     /* 1239487 */   // Label 17911: @1239487
     /* 1239487 */   GIM_Try, /*On fail goto*//*Label 17912*/ GIMT_Encode4(1239568), // Rule ID 5395 //
     /* 1239492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1239503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1239506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1239509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1239512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1239515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239545 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1239545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1239548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1239566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239567 */     // GIR_Coverage, 5395,
     /* 1239567 */     GIR_EraseRootFromParent_Done,
     /* 1239568 */   // Label 17912: @1239568
     /* 1239568 */   GIM_Try, /*On fail goto*//*Label 17913*/ GIMT_Encode4(1239649), // Rule ID 5396 //
     /* 1239573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239626 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1239629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239648 */     // GIR_Coverage, 5396,
     /* 1239648 */     GIR_EraseRootFromParent_Done,
     /* 1239649 */   // Label 17913: @1239649
     /* 1239649 */   GIM_Try, /*On fail goto*//*Label 17914*/ GIMT_Encode4(1239730), // Rule ID 5397 //
     /* 1239654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1239665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1239668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1239671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1239674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239707 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF4),
     /* 1239710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239729 */     // GIR_Coverage, 5397,
     /* 1239729 */     GIR_EraseRootFromParent_Done,
     /* 1239730 */   // Label 17914: @1239730
     /* 1239730 */   GIM_Try, /*On fail goto*//*Label 17915*/ GIMT_Encode4(1239811), // Rule ID 5398 //
     /* 1239735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239788 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1239788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1239791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239810 */     // GIR_Coverage, 5398,
     /* 1239810 */     GIR_EraseRootFromParent_Done,
     /* 1239811 */   // Label 17915: @1239811
     /* 1239811 */   GIM_Try, /*On fail goto*//*Label 17916*/ GIMT_Encode4(1239892), // Rule ID 5399 //
     /* 1239816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1239827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1239830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1239833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1239836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1239839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1239842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239869 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1239869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1239872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1239890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239891 */     // GIR_Coverage, 5399,
     /* 1239891 */     GIR_EraseRootFromParent_Done,
     /* 1239892 */   // Label 17916: @1239892
     /* 1239892 */   GIM_Try, /*On fail goto*//*Label 17917*/ GIMT_Encode4(1239973), // Rule ID 5400 //
     /* 1239897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1239900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1239920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1239923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1239927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1239939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1239943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1239950 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1239950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1239953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1239955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1239957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1239959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1239961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1239963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1239968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1239971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1239972 */     // GIR_Coverage, 5400,
     /* 1239972 */     GIR_EraseRootFromParent_Done,
     /* 1239973 */   // Label 17917: @1239973
     /* 1239973 */   GIM_Try, /*On fail goto*//*Label 17918*/ GIMT_Encode4(1240054), // Rule ID 5401 //
     /* 1239978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1239981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1239986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1239989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1239992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1239995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1239998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240031 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1240031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_MF2),
     /* 1240034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240053 */     // GIR_Coverage, 5401,
     /* 1240053 */     GIR_EraseRootFromParent_Done,
     /* 1240054 */   // Label 17918: @1240054
     /* 1240054 */   GIM_Try, /*On fail goto*//*Label 17919*/ GIMT_Encode4(1240135), // Rule ID 5402 //
     /* 1240059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240134 */     // GIR_Coverage, 5402,
     /* 1240134 */     GIR_EraseRootFromParent_Done,
     /* 1240135 */   // Label 17919: @1240135
     /* 1240135 */   GIM_Try, /*On fail goto*//*Label 17920*/ GIMT_Encode4(1240216), // Rule ID 5403 //
     /* 1240140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1240151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1240154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1240157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1240160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1240163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240193 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240214 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240215 */     // GIR_Coverage, 5403,
     /* 1240215 */     GIR_EraseRootFromParent_Done,
     /* 1240216 */   // Label 17920: @1240216
     /* 1240216 */   GIM_Try, /*On fail goto*//*Label 17921*/ GIMT_Encode4(1240297), // Rule ID 5404 //
     /* 1240221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1240274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240296 */     // GIR_Coverage, 5404,
     /* 1240296 */     GIR_EraseRootFromParent_Done,
     /* 1240297 */   // Label 17921: @1240297
     /* 1240297 */   GIM_Try, /*On fail goto*//*Label 17922*/ GIMT_Encode4(1240378), // Rule ID 5405 //
     /* 1240302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1240313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1240316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1240319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1240322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1240325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240355 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1240355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1240376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240377 */     // GIR_Coverage, 5405,
     /* 1240377 */     GIR_EraseRootFromParent_Done,
     /* 1240378 */   // Label 17922: @1240378
     /* 1240378 */   GIM_Try, /*On fail goto*//*Label 17923*/ GIMT_Encode4(1240459), // Rule ID 5406 //
     /* 1240383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240436 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1240436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240458 */     // GIR_Coverage, 5406,
     /* 1240458 */     GIR_EraseRootFromParent_Done,
     /* 1240459 */   // Label 17923: @1240459
     /* 1240459 */   GIM_Try, /*On fail goto*//*Label 17924*/ GIMT_Encode4(1240540), // Rule ID 5407 //
     /* 1240464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1240475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1240478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1240481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1240484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1240487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240517 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1240517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1240538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240539 */     // GIR_Coverage, 5407,
     /* 1240539 */     GIR_EraseRootFromParent_Done,
     /* 1240540 */   // Label 17924: @1240540
     /* 1240540 */   GIM_Try, /*On fail goto*//*Label 17925*/ GIMT_Encode4(1240621), // Rule ID 5408 //
     /* 1240545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1240548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1240598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240620 */     // GIR_Coverage, 5408,
     /* 1240620 */     GIR_EraseRootFromParent_Done,
     /* 1240621 */   // Label 17925: @1240621
     /* 1240621 */   GIM_Try, /*On fail goto*//*Label 17926*/ GIMT_Encode4(1240702), // Rule ID 5409 //
     /* 1240626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1240629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1240637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1240640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1240643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1240646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1240649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1240656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1240668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240679 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1240679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M1),
     /* 1240682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1240700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240701 */     // GIR_Coverage, 5409,
     /* 1240701 */     GIR_EraseRootFromParent_Done,
     /* 1240702 */   // Label 17926: @1240702
     /* 1240702 */   GIM_Try, /*On fail goto*//*Label 17927*/ GIMT_Encode4(1240783), // Rule ID 5410 //
     /* 1240707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1240763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240782 */     // GIR_Coverage, 5410,
     /* 1240782 */     GIR_EraseRootFromParent_Done,
     /* 1240783 */   // Label 17927: @1240783
     /* 1240783 */   GIM_Try, /*On fail goto*//*Label 17928*/ GIMT_Encode4(1240864), // Rule ID 5411 //
     /* 1240788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1240799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1240802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1240805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1240808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1240811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1240818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1240830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240841 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1240841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1240844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240863 */     // GIR_Coverage, 5411,
     /* 1240863 */     GIR_EraseRootFromParent_Done,
     /* 1240864 */   // Label 17928: @1240864
     /* 1240864 */   GIM_Try, /*On fail goto*//*Label 17929*/ GIMT_Encode4(1240945), // Rule ID 5412 //
     /* 1240869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1240872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1240895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1240922 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1240922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1240925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1240927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1240929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1240931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1240933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1240935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1240940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1240943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1240944 */     // GIR_Coverage, 5412,
     /* 1240944 */     GIR_EraseRootFromParent_Done,
     /* 1240945 */   // Label 17929: @1240945
     /* 1240945 */   GIM_Try, /*On fail goto*//*Label 17930*/ GIMT_Encode4(1241026), // Rule ID 5413 //
     /* 1240950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1240953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1240958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1240961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1240964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1240967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1240970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1240973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1240976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1240980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1240992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1240996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241003 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1241006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241025 */     // GIR_Coverage, 5413,
     /* 1241025 */     GIR_EraseRootFromParent_Done,
     /* 1241026 */   // Label 17930: @1241026
     /* 1241026 */   GIM_Try, /*On fail goto*//*Label 17931*/ GIMT_Encode4(1241107), // Rule ID 5414 //
     /* 1241031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1241051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241084 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1241084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1241087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241106 */     // GIR_Coverage, 5414,
     /* 1241106 */     GIR_EraseRootFromParent_Done,
     /* 1241107 */   // Label 17931: @1241107
     /* 1241107 */   GIM_Try, /*On fail goto*//*Label 17932*/ GIMT_Encode4(1241188), // Rule ID 5415 //
     /* 1241112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1241123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1241126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1241129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1241132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1241135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241165 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1241165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1241168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1241186 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241187 */     // GIR_Coverage, 5415,
     /* 1241187 */     GIR_EraseRootFromParent_Done,
     /* 1241188 */   // Label 17932: @1241188
     /* 1241188 */   GIM_Try, /*On fail goto*//*Label 17933*/ GIMT_Encode4(1241269), // Rule ID 5416 //
     /* 1241193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1241249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241268 */     // GIR_Coverage, 5416,
     /* 1241268 */     GIR_EraseRootFromParent_Done,
     /* 1241269 */   // Label 17933: @1241269
     /* 1241269 */   GIM_Try, /*On fail goto*//*Label 17934*/ GIMT_Encode4(1241350), // Rule ID 5417 //
     /* 1241274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1241285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1241288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1241291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1241294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1241330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241349 */     // GIR_Coverage, 5417,
     /* 1241349 */     GIR_EraseRootFromParent_Done,
     /* 1241350 */   // Label 17934: @1241350
     /* 1241350 */   GIM_Try, /*On fail goto*//*Label 17935*/ GIMT_Encode4(1241431), // Rule ID 5418 //
     /* 1241355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241408 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1241411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241430 */     // GIR_Coverage, 5418,
     /* 1241430 */     GIR_EraseRootFromParent_Done,
     /* 1241431 */   // Label 17935: @1241431
     /* 1241431 */   GIM_Try, /*On fail goto*//*Label 17936*/ GIMT_Encode4(1241512), // Rule ID 5419 //
     /* 1241436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1241447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1241450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1241453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1241456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1241459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241489 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1241492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241511 */     // GIR_Coverage, 5419,
     /* 1241511 */     GIR_EraseRootFromParent_Done,
     /* 1241512 */   // Label 17936: @1241512
     /* 1241512 */   GIM_Try, /*On fail goto*//*Label 17937*/ GIMT_Encode4(1241593), // Rule ID 5420 //
     /* 1241517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241570 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1241570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1241573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241592 */     // GIR_Coverage, 5420,
     /* 1241592 */     GIR_EraseRootFromParent_Done,
     /* 1241593 */   // Label 17937: @1241593
     /* 1241593 */   GIM_Try, /*On fail goto*//*Label 17938*/ GIMT_Encode4(1241674), // Rule ID 5421 //
     /* 1241598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1241609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1241612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1241615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1241618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1241621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1241628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1241640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241651 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1241651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1241654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1241672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241673 */     // GIR_Coverage, 5421,
     /* 1241673 */     GIR_EraseRootFromParent_Done,
     /* 1241674 */   // Label 17938: @1241674
     /* 1241674 */   GIM_Try, /*On fail goto*//*Label 17939*/ GIMT_Encode4(1241755), // Rule ID 5422 //
     /* 1241679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1241735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241754 */     // GIR_Coverage, 5422,
     /* 1241754 */     GIR_EraseRootFromParent_Done,
     /* 1241755 */   // Label 17939: @1241755
     /* 1241755 */   GIM_Try, /*On fail goto*//*Label 17940*/ GIMT_Encode4(1241836), // Rule ID 5423 //
     /* 1241760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1241771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1241774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1241777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1241780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1241783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1241790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1241802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241813 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1241816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241835 */     // GIR_Coverage, 5423,
     /* 1241835 */     GIR_EraseRootFromParent_Done,
     /* 1241836 */   // Label 17940: @1241836
     /* 1241836 */   GIM_Try, /*On fail goto*//*Label 17941*/ GIMT_Encode4(1241917), // Rule ID 5424 //
     /* 1241841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1241844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1241867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241894 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1241894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1241897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241916 */     // GIR_Coverage, 5424,
     /* 1241916 */     GIR_EraseRootFromParent_Done,
     /* 1241917 */   // Label 17941: @1241917
     /* 1241917 */   GIM_Try, /*On fail goto*//*Label 17942*/ GIMT_Encode4(1241998), // Rule ID 5425 //
     /* 1241922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1241925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1241930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1241933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1241936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1241939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1241942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1241945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1241948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1241952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1241964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1241968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1241975 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1241975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1241978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1241980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1241982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1241984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1241986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1241988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1241993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1241996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1241997 */     // GIR_Coverage, 5425,
     /* 1241997 */     GIR_EraseRootFromParent_Done,
     /* 1241998 */   // Label 17942: @1241998
     /* 1241998 */   GIM_Try, /*On fail goto*//*Label 17943*/ GIMT_Encode4(1242079), // Rule ID 5426 //
     /* 1242003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1242056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1242059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242078 */     // GIR_Coverage, 5426,
     /* 1242078 */     GIR_EraseRootFromParent_Done,
     /* 1242079 */   // Label 17943: @1242079
     /* 1242079 */   GIM_Try, /*On fail goto*//*Label 17944*/ GIMT_Encode4(1242160), // Rule ID 5427 //
     /* 1242084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1242095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1242098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1242101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1242104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1242107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242137 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1242137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1242140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1242158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242159 */     // GIR_Coverage, 5427,
     /* 1242159 */     GIR_EraseRootFromParent_Done,
     /* 1242160 */   // Label 17944: @1242160
     /* 1242160 */   GIM_Try, /*On fail goto*//*Label 17945*/ GIMT_Encode4(1242241), // Rule ID 5428 //
     /* 1242165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1242221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242240 */     // GIR_Coverage, 5428,
     /* 1242240 */     GIR_EraseRootFromParent_Done,
     /* 1242241 */   // Label 17945: @1242241
     /* 1242241 */   GIM_Try, /*On fail goto*//*Label 17946*/ GIMT_Encode4(1242322), // Rule ID 5429 //
     /* 1242246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1242257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1242260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1242263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1242266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1242276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1242288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242299 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M2),
     /* 1242302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242321 */     // GIR_Coverage, 5429,
     /* 1242321 */     GIR_EraseRootFromParent_Done,
     /* 1242322 */   // Label 17946: @1242322
     /* 1242322 */   GIM_Try, /*On fail goto*//*Label 17947*/ GIMT_Encode4(1242403), // Rule ID 5430 //
     /* 1242327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242380 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1242383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242402 */     // GIR_Coverage, 5430,
     /* 1242402 */     GIR_EraseRootFromParent_Done,
     /* 1242403 */   // Label 17947: @1242403
     /* 1242403 */   GIM_Try, /*On fail goto*//*Label 17948*/ GIMT_Encode4(1242484), // Rule ID 5431 //
     /* 1242408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1242419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1242422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1242425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1242428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1242438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1242450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242461 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M4),
     /* 1242464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242482 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242483 */     // GIR_Coverage, 5431,
     /* 1242483 */     GIR_EraseRootFromParent_Done,
     /* 1242484 */   // Label 17948: @1242484
     /* 1242484 */   GIM_Try, /*On fail goto*//*Label 17949*/ GIMT_Encode4(1242565), // Rule ID 5432 //
     /* 1242489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1242492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242542 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1242542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1242545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242564 */     // GIR_Coverage, 5432,
     /* 1242564 */     GIR_EraseRootFromParent_Done,
     /* 1242565 */   // Label 17949: @1242565
     /* 1242565 */   GIM_Try, /*On fail goto*//*Label 17950*/ GIMT_Encode4(1242646), // Rule ID 5433 //
     /* 1242570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1242573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1242581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1242584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1242587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1242590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1242593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1242600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1242612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242623 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1242623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VVM_M8),
     /* 1242626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1242644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242645 */     // GIR_Coverage, 5433,
     /* 1242645 */     GIR_EraseRootFromParent_Done,
     /* 1242646 */   // Label 17950: @1242646
     /* 1242646 */   GIM_Try, /*On fail goto*//*Label 17951*/ GIMT_Encode4(1242727), // Rule ID 5434 //
     /* 1242651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242704 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1242707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242726 */     // GIR_Coverage, 5434,
     /* 1242726 */     GIR_EraseRootFromParent_Done,
     /* 1242727 */   // Label 17951: @1242727
     /* 1242727 */   GIM_Try, /*On fail goto*//*Label 17952*/ GIMT_Encode4(1242808), // Rule ID 5435 //
     /* 1242732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1242743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1242746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1242749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1242755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242785 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF8),
     /* 1242788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242807 */     // GIR_Coverage, 5435,
     /* 1242807 */     GIR_EraseRootFromParent_Done,
     /* 1242808 */   // Label 17952: @1242808
     /* 1242808 */   GIM_Try, /*On fail goto*//*Label 17953*/ GIMT_Encode4(1242889), // Rule ID 5436 //
     /* 1242813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1242839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1242866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1242869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242888 */     // GIR_Coverage, 5436,
     /* 1242888 */     GIR_EraseRootFromParent_Done,
     /* 1242889 */   // Label 17953: @1242889
     /* 1242889 */   GIM_Try, /*On fail goto*//*Label 17954*/ GIMT_Encode4(1242970), // Rule ID 5437 //
     /* 1242894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1242897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1242905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1242908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1242911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1242914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1242917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1242920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1242924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1242932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1242936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1242940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1242947 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1242947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1242950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1242952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1242954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1242956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1242958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1242960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1242965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1242968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1242969 */     // GIR_Coverage, 5437,
     /* 1242969 */     GIR_EraseRootFromParent_Done,
     /* 1242970 */   // Label 17954: @1242970
     /* 1242970 */   GIM_Try, /*On fail goto*//*Label 17955*/ GIMT_Encode4(1243051), // Rule ID 5438 //
     /* 1242975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1242978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1242983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1242986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1242989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1242992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1242995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1242998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243028 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243050 */     // GIR_Coverage, 5438,
     /* 1243050 */     GIR_EraseRootFromParent_Done,
     /* 1243051 */   // Label 17955: @1243051
     /* 1243051 */   GIM_Try, /*On fail goto*//*Label 17956*/ GIMT_Encode4(1243132), // Rule ID 5439 //
     /* 1243056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1243067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1243070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1243073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243109 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243131 */     // GIR_Coverage, 5439,
     /* 1243131 */     GIR_EraseRootFromParent_Done,
     /* 1243132 */   // Label 17956: @1243132
     /* 1243132 */   GIM_Try, /*On fail goto*//*Label 17957*/ GIMT_Encode4(1243213), // Rule ID 5440 //
     /* 1243137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243190 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1243193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243212 */     // GIR_Coverage, 5440,
     /* 1243212 */     GIR_EraseRootFromParent_Done,
     /* 1243213 */   // Label 17957: @1243213
     /* 1243213 */   GIM_Try, /*On fail goto*//*Label 17958*/ GIMT_Encode4(1243294), // Rule ID 5441 //
     /* 1243218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1243229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1243232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1243235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243271 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF4),
     /* 1243274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243293 */     // GIR_Coverage, 5441,
     /* 1243293 */     GIR_EraseRootFromParent_Done,
     /* 1243294 */   // Label 17958: @1243294
     /* 1243294 */   GIM_Try, /*On fail goto*//*Label 17959*/ GIMT_Encode4(1243375), // Rule ID 5442 //
     /* 1243299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243352 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243374 */     // GIR_Coverage, 5442,
     /* 1243374 */     GIR_EraseRootFromParent_Done,
     /* 1243375 */   // Label 17959: @1243375
     /* 1243375 */   GIM_Try, /*On fail goto*//*Label 17960*/ GIMT_Encode4(1243456), // Rule ID 5443 //
     /* 1243380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1243391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1243394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1243397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243433 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243454 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243455 */     // GIR_Coverage, 5443,
     /* 1243455 */     GIR_EraseRootFromParent_Done,
     /* 1243456 */   // Label 17960: @1243456
     /* 1243456 */   GIM_Try, /*On fail goto*//*Label 17961*/ GIMT_Encode4(1243537), // Rule ID 5444 //
     /* 1243461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243514 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1243514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243536 */     // GIR_Coverage, 5444,
     /* 1243536 */     GIR_EraseRootFromParent_Done,
     /* 1243537 */   // Label 17961: @1243537
     /* 1243537 */   GIM_Try, /*On fail goto*//*Label 17962*/ GIMT_Encode4(1243618), // Rule ID 5445 //
     /* 1243542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1243553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1243556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1243559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1243565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243595 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1243595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_MF2),
     /* 1243598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1243616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243617 */     // GIR_Coverage, 5445,
     /* 1243617 */     GIR_EraseRootFromParent_Done,
     /* 1243618 */   // Label 17962: @1243618
     /* 1243618 */   GIM_Try, /*On fail goto*//*Label 17963*/ GIMT_Encode4(1243699), // Rule ID 5446 //
     /* 1243623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1243676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1243679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243698 */     // GIR_Coverage, 5446,
     /* 1243698 */     GIR_EraseRootFromParent_Done,
     /* 1243699 */   // Label 17963: @1243699
     /* 1243699 */   GIM_Try, /*On fail goto*//*Label 17964*/ GIMT_Encode4(1243780), // Rule ID 5447 //
     /* 1243704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1243715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1243718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1243721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1243727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243757 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11466:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1243757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1243760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1243778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243779 */     // GIR_Coverage, 5447,
     /* 1243779 */     GIR_EraseRootFromParent_Done,
     /* 1243780 */   // Label 17964: @1243780
     /* 1243780 */   GIM_Try, /*On fail goto*//*Label 17965*/ GIMT_Encode4(1243861), // Rule ID 5448 //
     /* 1243785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243838 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1243838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1243841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243860 */     // GIR_Coverage, 5448,
     /* 1243860 */     GIR_EraseRootFromParent_Done,
     /* 1243861 */   // Label 17965: @1243861
     /* 1243861 */   GIM_Try, /*On fail goto*//*Label 17966*/ GIMT_Encode4(1243942), // Rule ID 5449 //
     /* 1243866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1243869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1243877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1243880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1243883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1243886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1243889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1243892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1243919 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11466:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1243919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1243922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1243924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1243926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1243928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1243930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1243932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1243937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1243940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1243941 */     // GIR_Coverage, 5449,
     /* 1243941 */     GIR_EraseRootFromParent_Done,
     /* 1243942 */   // Label 17966: @1243942
     /* 1243942 */   GIM_Try, /*On fail goto*//*Label 17967*/ GIMT_Encode4(1244023), // Rule ID 5450 //
     /* 1243947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1243950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1243955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1243958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1243961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1243964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1243967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1243970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1243973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1243977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1243985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1243989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1243993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244000 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1244000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1244003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244022 */     // GIR_Coverage, 5450,
     /* 1244022 */     GIR_EraseRootFromParent_Done,
     /* 1244023 */   // Label 17967: @1244023
     /* 1244023 */   GIM_Try, /*On fail goto*//*Label 17968*/ GIMT_Encode4(1244104), // Rule ID 5451 //
     /* 1244028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1244039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1244042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1244045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1244051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244081 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11466:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1244081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1244084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1244102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244103 */     // GIR_Coverage, 5451,
     /* 1244103 */     GIR_EraseRootFromParent_Done,
     /* 1244104 */   // Label 17968: @1244104
     /* 1244104 */   GIM_Try, /*On fail goto*//*Label 17969*/ GIMT_Encode4(1244185), // Rule ID 5452 //
     /* 1244109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1244112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1244162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1244165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244184 */     // GIR_Coverage, 5452,
     /* 1244184 */     GIR_EraseRootFromParent_Done,
     /* 1244185 */   // Label 17969: @1244185
     /* 1244185 */   GIM_Try, /*On fail goto*//*Label 17970*/ GIMT_Encode4(1244266), // Rule ID 5453 //
     /* 1244190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1244193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1244201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1244204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1244207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1244213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1244220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1244228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244243 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11466:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1244243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M1),
     /* 1244246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1244264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244265 */     // GIR_Coverage, 5453,
     /* 1244265 */     GIR_EraseRootFromParent_Done,
     /* 1244266 */   // Label 17970: @1244266
     /* 1244266 */   GIM_Try, /*On fail goto*//*Label 17971*/ GIMT_Encode4(1244347), // Rule ID 5454 //
     /* 1244271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1244327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244346 */     // GIR_Coverage, 5454,
     /* 1244346 */     GIR_EraseRootFromParent_Done,
     /* 1244347 */   // Label 17971: @1244347
     /* 1244347 */   GIM_Try, /*On fail goto*//*Label 17972*/ GIMT_Encode4(1244428), // Rule ID 5455 //
     /* 1244352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1244363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1244366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1244369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244405 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1244408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244427 */     // GIR_Coverage, 5455,
     /* 1244427 */     GIR_EraseRootFromParent_Done,
     /* 1244428 */   // Label 17972: @1244428
     /* 1244428 */   GIM_Try, /*On fail goto*//*Label 17973*/ GIMT_Encode4(1244509), // Rule ID 5456 //
     /* 1244433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244486 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1244489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244508 */     // GIR_Coverage, 5456,
     /* 1244508 */     GIR_EraseRootFromParent_Done,
     /* 1244509 */   // Label 17973: @1244509
     /* 1244509 */   GIM_Try, /*On fail goto*//*Label 17974*/ GIMT_Encode4(1244590), // Rule ID 5457 //
     /* 1244514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1244525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1244528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1244531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1244537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244567 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1244570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244589 */     // GIR_Coverage, 5457,
     /* 1244589 */     GIR_EraseRootFromParent_Done,
     /* 1244590 */   // Label 17974: @1244590
     /* 1244590 */   GIM_Try, /*On fail goto*//*Label 17975*/ GIMT_Encode4(1244671), // Rule ID 5458 //
     /* 1244595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244648 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1244648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1244651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244670 */     // GIR_Coverage, 5458,
     /* 1244670 */     GIR_EraseRootFromParent_Done,
     /* 1244671 */   // Label 17975: @1244671
     /* 1244671 */   GIM_Try, /*On fail goto*//*Label 17976*/ GIMT_Encode4(1244752), // Rule ID 5459 //
     /* 1244676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1244687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1244690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1244693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1244699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1244706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1244714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244729 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1244729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1244732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1244750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244751 */     // GIR_Coverage, 5459,
     /* 1244751 */     GIR_EraseRootFromParent_Done,
     /* 1244752 */   // Label 17976: @1244752
     /* 1244752 */   GIM_Try, /*On fail goto*//*Label 17977*/ GIMT_Encode4(1244833), // Rule ID 5460 //
     /* 1244757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244810 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1244813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244832 */     // GIR_Coverage, 5460,
     /* 1244832 */     GIR_EraseRootFromParent_Done,
     /* 1244833 */   // Label 17977: @1244833
     /* 1244833 */   GIM_Try, /*On fail goto*//*Label 17978*/ GIMT_Encode4(1244914), // Rule ID 5461 //
     /* 1244838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1244841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1244849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1244852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1244855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1244858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1244861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1244864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1244868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1244876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244891 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1244891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1244894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244913 */     // GIR_Coverage, 5461,
     /* 1244913 */     GIR_EraseRootFromParent_Done,
     /* 1244914 */   // Label 17978: @1244914
     /* 1244914 */   GIM_Try, /*On fail goto*//*Label 17979*/ GIMT_Encode4(1244995), // Rule ID 5462 //
     /* 1244919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1244922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1244927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1244930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1244933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1244936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1244939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1244942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1244945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1244949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1244957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1244961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1244965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1244972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1244972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1244975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1244977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1244979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1244981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1244983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1244985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1244990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1244993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1244994 */     // GIR_Coverage, 5462,
     /* 1244994 */     GIR_EraseRootFromParent_Done,
     /* 1244995 */   // Label 17979: @1244995
     /* 1244995 */   GIM_Try, /*On fail goto*//*Label 17980*/ GIMT_Encode4(1245076), // Rule ID 5463 //
     /* 1245000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1245011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1245014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1245017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245053 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1245056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245075 */     // GIR_Coverage, 5463,
     /* 1245075 */     GIR_EraseRootFromParent_Done,
     /* 1245076 */   // Label 17980: @1245076
     /* 1245076 */   GIM_Try, /*On fail goto*//*Label 17981*/ GIMT_Encode4(1245157), // Rule ID 5464 //
     /* 1245081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245134 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1245134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1245137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245156 */     // GIR_Coverage, 5464,
     /* 1245156 */     GIR_EraseRootFromParent_Done,
     /* 1245157 */   // Label 17981: @1245157
     /* 1245157 */   GIM_Try, /*On fail goto*//*Label 17982*/ GIMT_Encode4(1245238), // Rule ID 5465 //
     /* 1245162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1245173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1245176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1245179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1245185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245215 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1245215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1245218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1245236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245237 */     // GIR_Coverage, 5465,
     /* 1245237 */     GIR_EraseRootFromParent_Done,
     /* 1245238 */   // Label 17982: @1245238
     /* 1245238 */   GIM_Try, /*On fail goto*//*Label 17983*/ GIMT_Encode4(1245319), // Rule ID 5466 //
     /* 1245243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1245299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245318 */     // GIR_Coverage, 5466,
     /* 1245318 */     GIR_EraseRootFromParent_Done,
     /* 1245319 */   // Label 17983: @1245319
     /* 1245319 */   GIM_Try, /*On fail goto*//*Label 17984*/ GIMT_Encode4(1245400), // Rule ID 5467 //
     /* 1245324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1245335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1245338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1245341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1245380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245399 */     // GIR_Coverage, 5467,
     /* 1245399 */     GIR_EraseRootFromParent_Done,
     /* 1245400 */   // Label 17984: @1245400
     /* 1245400 */   GIM_Try, /*On fail goto*//*Label 17985*/ GIMT_Encode4(1245481), // Rule ID 5468 //
     /* 1245405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245458 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1245461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245480 */     // GIR_Coverage, 5468,
     /* 1245480 */     GIR_EraseRootFromParent_Done,
     /* 1245481 */   // Label 17985: @1245481
     /* 1245481 */   GIM_Try, /*On fail goto*//*Label 17986*/ GIMT_Encode4(1245562), // Rule ID 5469 //
     /* 1245486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1245497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1245500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1245503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1245509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245539 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1245542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245561 */     // GIR_Coverage, 5469,
     /* 1245561 */     GIR_EraseRootFromParent_Done,
     /* 1245562 */   // Label 17986: @1245562
     /* 1245562 */   GIM_Try, /*On fail goto*//*Label 17987*/ GIMT_Encode4(1245643), // Rule ID 5470 //
     /* 1245567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1245570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1245620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1245623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245642 */     // GIR_Coverage, 5470,
     /* 1245642 */     GIR_EraseRootFromParent_Done,
     /* 1245643 */   // Label 17987: @1245643
     /* 1245643 */   GIM_Try, /*On fail goto*//*Label 17988*/ GIMT_Encode4(1245724), // Rule ID 5471 //
     /* 1245648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1245651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1245659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1245662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1245665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1245671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1245678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1245686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245701 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1245701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1245704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1245722 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245723 */     // GIR_Coverage, 5471,
     /* 1245723 */     GIR_EraseRootFromParent_Done,
     /* 1245724 */   // Label 17988: @1245724
     /* 1245724 */   GIM_Try, /*On fail goto*//*Label 17989*/ GIMT_Encode4(1245805), // Rule ID 5472 //
     /* 1245729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245782 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1245785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245804 */     // GIR_Coverage, 5472,
     /* 1245804 */     GIR_EraseRootFromParent_Done,
     /* 1245805 */   // Label 17989: @1245805
     /* 1245805 */   GIM_Try, /*On fail goto*//*Label 17990*/ GIMT_Encode4(1245886), // Rule ID 5473 //
     /* 1245810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1245821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1245824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1245827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1245833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1245840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1245848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245863 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11466:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1245863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M2),
     /* 1245866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245885 */     // GIR_Coverage, 5473,
     /* 1245885 */     GIR_EraseRootFromParent_Done,
     /* 1245886 */   // Label 17990: @1245886
     /* 1245886 */   GIM_Try, /*On fail goto*//*Label 17991*/ GIMT_Encode4(1245967), // Rule ID 5474 //
     /* 1245891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1245894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1245911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1245917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1245921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1245929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1245933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1245937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1245944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1245944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1245947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1245949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1245951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1245953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1245955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1245957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1245962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1245965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1245966 */     // GIR_Coverage, 5474,
     /* 1245966 */     GIR_EraseRootFromParent_Done,
     /* 1245967 */   // Label 17991: @1245967
     /* 1245967 */   GIM_Try, /*On fail goto*//*Label 17992*/ GIMT_Encode4(1246048), // Rule ID 5475 //
     /* 1245972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1245975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1245980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1245983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1245986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1245989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1245992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1245995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1245998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1246002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1246010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246025 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11466:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M4),
     /* 1246028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246047 */     // GIR_Coverage, 5475,
     /* 1246047 */     GIR_EraseRootFromParent_Done,
     /* 1246048 */   // Label 17992: @1246048
     /* 1246048 */   GIM_Try, /*On fail goto*//*Label 17993*/ GIMT_Encode4(1246129), // Rule ID 5476 //
     /* 1246053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1246056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1246073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246106 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1246106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1246109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246128 */     // GIR_Coverage, 5476,
     /* 1246128 */     GIR_EraseRootFromParent_Done,
     /* 1246129 */   // Label 17993: @1246129
     /* 1246129 */   GIM_Try, /*On fail goto*//*Label 17994*/ GIMT_Encode4(1246210), // Rule ID 5477 //
     /* 1246134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1246137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsbc),
     /* 1246142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1246145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1246148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1246151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1246154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1246157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1246164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1246172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1246176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246187 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11466:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVSBC_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1246187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSBC_VXM_M8),
     /* 1246190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1246208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246209 */     // GIR_Coverage, 5477,
     /* 1246209 */     GIR_EraseRootFromParent_Done,
     /* 1246210 */   // Label 17994: @1246210
     /* 1246210 */   GIM_Try, /*On fail goto*//*Label 17995*/ GIMT_Encode4(1246294), // Rule ID 7688 //
     /* 1246215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246268 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1246271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246293 */     // GIR_Coverage, 7688,
     /* 1246293 */     GIR_EraseRootFromParent_Done,
     /* 1246294 */   // Label 17995: @1246294
     /* 1246294 */   GIM_Try, /*On fail goto*//*Label 17996*/ GIMT_Encode4(1246378), // Rule ID 7689 //
     /* 1246299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1246316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1246319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246352 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1246355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246377 */     // GIR_Coverage, 7689,
     /* 1246377 */     GIR_EraseRootFromParent_Done,
     /* 1246378 */   // Label 17996: @1246378
     /* 1246378 */   GIM_Try, /*On fail goto*//*Label 17997*/ GIMT_Encode4(1246462), // Rule ID 7692 //
     /* 1246383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1246394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1246397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246436 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1246439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246461 */     // GIR_Coverage, 7692,
     /* 1246461 */     GIR_EraseRootFromParent_Done,
     /* 1246462 */   // Label 17997: @1246462
     /* 1246462 */   GIM_Try, /*On fail goto*//*Label 17998*/ GIMT_Encode4(1246546), // Rule ID 7693 //
     /* 1246467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1246478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1246481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1246484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1246487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1246490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246520 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1246523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1246541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246545 */     // GIR_Coverage, 7693,
     /* 1246545 */     GIR_EraseRootFromParent_Done,
     /* 1246546 */   // Label 17998: @1246546
     /* 1246546 */   GIM_Try, /*On fail goto*//*Label 17999*/ GIMT_Encode4(1246630), // Rule ID 7696 //
     /* 1246551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1246607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246629 */     // GIR_Coverage, 7696,
     /* 1246629 */     GIR_EraseRootFromParent_Done,
     /* 1246630 */   // Label 17999: @1246630
     /* 1246630 */   GIM_Try, /*On fail goto*//*Label 18000*/ GIMT_Encode4(1246714), // Rule ID 7697 //
     /* 1246635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1246652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1246655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4_MASK),
     /* 1246691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246713 */     // GIR_Coverage, 7697,
     /* 1246713 */     GIR_EraseRootFromParent_Done,
     /* 1246714 */   // Label 18000: @1246714
     /* 1246714 */   GIM_Try, /*On fail goto*//*Label 18001*/ GIMT_Encode4(1246798), // Rule ID 7700 //
     /* 1246719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1246775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246797 */     // GIR_Coverage, 7700,
     /* 1246797 */     GIR_EraseRootFromParent_Done,
     /* 1246798 */   // Label 18001: @1246798
     /* 1246798 */   GIM_Try, /*On fail goto*//*Label 18002*/ GIMT_Encode4(1246882), // Rule ID 7701 //
     /* 1246803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1246814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1246817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1246820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1246823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1246826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1246856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1246859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1246877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246881 */     // GIR_Coverage, 7701,
     /* 1246881 */     GIR_EraseRootFromParent_Done,
     /* 1246882 */   // Label 18002: @1246882
     /* 1246882 */   GIM_Try, /*On fail goto*//*Label 18003*/ GIMT_Encode4(1246966), // Rule ID 7704 //
     /* 1246887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1246890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1246913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1246929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1246933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1246940 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1246940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1246943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1246945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1246947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1246949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1246951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1246953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1246958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1246961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1246964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1246965 */     // GIR_Coverage, 7704,
     /* 1246965 */     GIR_EraseRootFromParent_Done,
     /* 1246966 */   // Label 18003: @1246966
     /* 1246966 */   GIM_Try, /*On fail goto*//*Label 18004*/ GIMT_Encode4(1247050), // Rule ID 7705 //
     /* 1246971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1246974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1246979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1246982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1246985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1246988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1246991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1246994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1246997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247024 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2_MASK),
     /* 1247027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247049 */     // GIR_Coverage, 7705,
     /* 1247049 */     GIR_EraseRootFromParent_Done,
     /* 1247050 */   // Label 18004: @1247050
     /* 1247050 */   GIM_Try, /*On fail goto*//*Label 18005*/ GIMT_Encode4(1247134), // Rule ID 7708 //
     /* 1247055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1247066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1247069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247133 */     // GIR_Coverage, 7708,
     /* 1247133 */     GIR_EraseRootFromParent_Done,
     /* 1247134 */   // Label 18005: @1247134
     /* 1247134 */   GIM_Try, /*On fail goto*//*Label 18006*/ GIMT_Encode4(1247218), // Rule ID 7709 //
     /* 1247139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1247150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1247153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1247156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1247159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1247162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247217 */     // GIR_Coverage, 7709,
     /* 1247217 */     GIR_EraseRootFromParent_Done,
     /* 1247218 */   // Label 18006: @1247218
     /* 1247218 */   GIM_Try, /*On fail goto*//*Label 18007*/ GIMT_Encode4(1247302), // Rule ID 7712 //
     /* 1247223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1247234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1247237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247276 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247301 */     // GIR_Coverage, 7712,
     /* 1247301 */     GIR_EraseRootFromParent_Done,
     /* 1247302 */   // Label 18007: @1247302
     /* 1247302 */   GIM_Try, /*On fail goto*//*Label 18008*/ GIMT_Encode4(1247386), // Rule ID 7713 //
     /* 1247307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1247318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1247321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1247324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1247327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1247330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247360 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1247381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247385 */     // GIR_Coverage, 7713,
     /* 1247385 */     GIR_EraseRootFromParent_Done,
     /* 1247386 */   // Label 18008: @1247386
     /* 1247386 */   GIM_Try, /*On fail goto*//*Label 18009*/ GIMT_Encode4(1247470), // Rule ID 7716 //
     /* 1247391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1247402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1247405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247469 */     // GIR_Coverage, 7716,
     /* 1247469 */     GIR_EraseRootFromParent_Done,
     /* 1247470 */   // Label 18009: @1247470
     /* 1247470 */   GIM_Try, /*On fail goto*//*Label 18010*/ GIMT_Encode4(1247554), // Rule ID 7717 //
     /* 1247475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1247486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1247489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1247492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1247495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1247498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1247549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247553 */     // GIR_Coverage, 7717,
     /* 1247553 */     GIR_EraseRootFromParent_Done,
     /* 1247554 */   // Label 18010: @1247554
     /* 1247554 */   GIM_Try, /*On fail goto*//*Label 18011*/ GIMT_Encode4(1247638), // Rule ID 7720 //
     /* 1247559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1247562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1247570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1247573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247612 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247637 */     // GIR_Coverage, 7720,
     /* 1247637 */     GIR_EraseRootFromParent_Done,
     /* 1247638 */   // Label 18011: @1247638
     /* 1247638 */   GIM_Try, /*On fail goto*//*Label 18012*/ GIMT_Encode4(1247722), // Rule ID 7721 //
     /* 1247643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1247646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1247654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1247657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1247660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1247663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1247666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247696 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1_MASK),
     /* 1247699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1247717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247721 */     // GIR_Coverage, 7721,
     /* 1247721 */     GIR_EraseRootFromParent_Done,
     /* 1247722 */   // Label 18012: @1247722
     /* 1247722 */   GIM_Try, /*On fail goto*//*Label 18013*/ GIMT_Encode4(1247806), // Rule ID 7724 //
     /* 1247727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1247738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1247783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247805 */     // GIR_Coverage, 7724,
     /* 1247805 */     GIR_EraseRootFromParent_Done,
     /* 1247806 */   // Label 18013: @1247806
     /* 1247806 */   GIM_Try, /*On fail goto*//*Label 18014*/ GIMT_Encode4(1247890), // Rule ID 7725 //
     /* 1247811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1247822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1247825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1247828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1247831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1247834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1247837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1247853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1247864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1247867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247889 */     // GIR_Coverage, 7725,
     /* 1247889 */     GIR_EraseRootFromParent_Done,
     /* 1247890 */   // Label 18014: @1247890
     /* 1247890 */   GIM_Try, /*On fail goto*//*Label 18015*/ GIMT_Encode4(1247974), // Rule ID 7728 //
     /* 1247895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1247898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1247906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1247909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1247918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1247921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1247929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1247937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1247941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1247948 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1247948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1247951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1247953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1247955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1247957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1247959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1247961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1247966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1247969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1247972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1247973 */     // GIR_Coverage, 7728,
     /* 1247973 */     GIR_EraseRootFromParent_Done,
     /* 1247974 */   // Label 18015: @1247974
     /* 1247974 */   GIM_Try, /*On fail goto*//*Label 18016*/ GIMT_Encode4(1248058), // Rule ID 7729 //
     /* 1247979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1247982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1247987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1247990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1247993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1247996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1247999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248032 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1248035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248057 */     // GIR_Coverage, 7729,
     /* 1248057 */     GIR_EraseRootFromParent_Done,
     /* 1248058 */   // Label 18016: @1248058
     /* 1248058 */   GIM_Try, /*On fail goto*//*Label 18017*/ GIMT_Encode4(1248142), // Rule ID 7732 //
     /* 1248063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1248074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1248077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248116 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1248119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248141 */     // GIR_Coverage, 7732,
     /* 1248141 */     GIR_EraseRootFromParent_Done,
     /* 1248142 */   // Label 18017: @1248142
     /* 1248142 */   GIM_Try, /*On fail goto*//*Label 18018*/ GIMT_Encode4(1248226), // Rule ID 7733 //
     /* 1248147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1248158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1248161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1248164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1248167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1248170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248200 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1248203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1248221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248225 */     // GIR_Coverage, 7733,
     /* 1248225 */     GIR_EraseRootFromParent_Done,
     /* 1248226 */   // Label 18018: @1248226
     /* 1248226 */   GIM_Try, /*On fail goto*//*Label 18019*/ GIMT_Encode4(1248310), // Rule ID 7736 //
     /* 1248231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1248245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1248287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248309 */     // GIR_Coverage, 7736,
     /* 1248309 */     GIR_EraseRootFromParent_Done,
     /* 1248310 */   // Label 18019: @1248310
     /* 1248310 */   GIM_Try, /*On fail goto*//*Label 18020*/ GIMT_Encode4(1248394), // Rule ID 7737 //
     /* 1248315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1248329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1248332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1248335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1248371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248393 */     // GIR_Coverage, 7737,
     /* 1248393 */     GIR_EraseRootFromParent_Done,
     /* 1248394 */   // Label 18020: @1248394
     /* 1248394 */   GIM_Try, /*On fail goto*//*Label 18021*/ GIMT_Encode4(1248478), // Rule ID 7740 //
     /* 1248399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1248410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1248413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248452 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1248455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248477 */     // GIR_Coverage, 7740,
     /* 1248477 */     GIR_EraseRootFromParent_Done,
     /* 1248478 */   // Label 18021: @1248478
     /* 1248478 */   GIM_Try, /*On fail goto*//*Label 18022*/ GIMT_Encode4(1248562), // Rule ID 7741 //
     /* 1248483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1248494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1248497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1248500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1248503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1248506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1248539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248561 */     // GIR_Coverage, 7741,
     /* 1248561 */     GIR_EraseRootFromParent_Done,
     /* 1248562 */   // Label 18022: @1248562
     /* 1248562 */   GIM_Try, /*On fail goto*//*Label 18023*/ GIMT_Encode4(1248646), // Rule ID 7744 //
     /* 1248567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1248578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1248581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248620 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1248623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248645 */     // GIR_Coverage, 7744,
     /* 1248645 */     GIR_EraseRootFromParent_Done,
     /* 1248646 */   // Label 18023: @1248646
     /* 1248646 */   GIM_Try, /*On fail goto*//*Label 18024*/ GIMT_Encode4(1248730), // Rule ID 7745 //
     /* 1248651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1248662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1248665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1248668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1248671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1248674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1248693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248704 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1248707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1248725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248729 */     // GIR_Coverage, 7745,
     /* 1248729 */     GIR_EraseRootFromParent_Done,
     /* 1248730 */   // Label 18024: @1248730
     /* 1248730 */   GIM_Try, /*On fail goto*//*Label 18025*/ GIMT_Encode4(1248814), // Rule ID 7748 //
     /* 1248735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1248791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248813 */     // GIR_Coverage, 7748,
     /* 1248813 */     GIR_EraseRootFromParent_Done,
     /* 1248814 */   // Label 18025: @1248814
     /* 1248814 */   GIM_Try, /*On fail goto*//*Label 18026*/ GIMT_Encode4(1248898), // Rule ID 7749 //
     /* 1248819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1248830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1248833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1248836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1248839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1248842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1248845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1248861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1248872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1248875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248897 */     // GIR_Coverage, 7749,
     /* 1248897 */     GIR_EraseRootFromParent_Done,
     /* 1248898 */   // Label 18026: @1248898
     /* 1248898 */   GIM_Try, /*On fail goto*//*Label 18027*/ GIMT_Encode4(1248982), // Rule ID 7752 //
     /* 1248903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1248906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1248917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1248920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1248923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1248926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1248929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1248937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1248945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1248949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1248956 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1248956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1248959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1248961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1248963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1248965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1248967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1248969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1248974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1248977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1248980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1248981 */     // GIR_Coverage, 7752,
     /* 1248981 */     GIR_EraseRootFromParent_Done,
     /* 1248982 */   // Label 18027: @1248982
     /* 1248982 */   GIM_Try, /*On fail goto*//*Label 18028*/ GIMT_Encode4(1249066), // Rule ID 7753 //
     /* 1248987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1248990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1248995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1248998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1249001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1249004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1249007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249040 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1249043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249065 */     // GIR_Coverage, 7753,
     /* 1249065 */     GIR_EraseRootFromParent_Done,
     /* 1249066 */   // Label 18028: @1249066
     /* 1249066 */   GIM_Try, /*On fail goto*//*Label 18029*/ GIMT_Encode4(1249150), // Rule ID 7756 //
     /* 1249071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1249082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1249085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1249127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249149 */     // GIR_Coverage, 7756,
     /* 1249149 */     GIR_EraseRootFromParent_Done,
     /* 1249150 */   // Label 18029: @1249150
     /* 1249150 */   GIM_Try, /*On fail goto*//*Label 18030*/ GIMT_Encode4(1249234), // Rule ID 7757 //
     /* 1249155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1249166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1249169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1249172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1249175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1249178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249208 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1249211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1249229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249233 */     // GIR_Coverage, 7757,
     /* 1249233 */     GIR_EraseRootFromParent_Done,
     /* 1249234 */   // Label 18030: @1249234
     /* 1249234 */   GIM_Try, /*On fail goto*//*Label 18031*/ GIMT_Encode4(1249318), // Rule ID 7760 //
     /* 1249239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1249250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1249253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249292 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1249295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249317 */     // GIR_Coverage, 7760,
     /* 1249317 */     GIR_EraseRootFromParent_Done,
     /* 1249318 */   // Label 18031: @1249318
     /* 1249318 */   GIM_Try, /*On fail goto*//*Label 18032*/ GIMT_Encode4(1249402), // Rule ID 7761 //
     /* 1249323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1249334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1249337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1249340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1249343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1249365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249376 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2_MASK),
     /* 1249379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249401 */     // GIR_Coverage, 7761,
     /* 1249401 */     GIR_EraseRootFromParent_Done,
     /* 1249402 */   // Label 18032: @1249402
     /* 1249402 */   GIM_Try, /*On fail goto*//*Label 18033*/ GIMT_Encode4(1249486), // Rule ID 7764 //
     /* 1249407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1249418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1249421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249460 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1249463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249485 */     // GIR_Coverage, 7764,
     /* 1249485 */     GIR_EraseRootFromParent_Done,
     /* 1249486 */   // Label 18033: @1249486
     /* 1249486 */   GIM_Try, /*On fail goto*//*Label 18034*/ GIMT_Encode4(1249570), // Rule ID 7765 //
     /* 1249491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1249502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1249505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1249508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1249511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1249514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1249533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249544 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4_MASK),
     /* 1249547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249569 */     // GIR_Coverage, 7765,
     /* 1249569 */     GIR_EraseRootFromParent_Done,
     /* 1249570 */   // Label 18034: @1249570
     /* 1249570 */   GIM_Try, /*On fail goto*//*Label 18035*/ GIMT_Encode4(1249654), // Rule ID 7768 //
     /* 1249575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1249578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1249586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1249589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249628 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1249631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249653 */     // GIR_Coverage, 7768,
     /* 1249653 */     GIR_EraseRootFromParent_Done,
     /* 1249654 */   // Label 18035: @1249654
     /* 1249654 */   GIM_Try, /*On fail goto*//*Label 18036*/ GIMT_Encode4(1249738), // Rule ID 7769 //
     /* 1249659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1249662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1249670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1249673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1249676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1249679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1249682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1249701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249712 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8_MASK),
     /* 1249715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1249733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249737 */     // GIR_Coverage, 7769,
     /* 1249737 */     GIR_EraseRootFromParent_Done,
     /* 1249738 */   // Label 18036: @1249738
     /* 1249738 */   GIM_Try, /*On fail goto*//*Label 18037*/ GIMT_Encode4(1249822), // Rule ID 7772 //
     /* 1249743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1249754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1249757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249796 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1249799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249821 */     // GIR_Coverage, 7772,
     /* 1249821 */     GIR_EraseRootFromParent_Done,
     /* 1249822 */   // Label 18037: @1249822
     /* 1249822 */   GIM_Try, /*On fail goto*//*Label 18038*/ GIMT_Encode4(1249906), // Rule ID 7773 //
     /* 1249827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1249838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1249841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1249844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1249847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1249850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1249853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249880 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1249880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF8_MASK),
     /* 1249883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249905 */     // GIR_Coverage, 7773,
     /* 1249905 */     GIR_EraseRootFromParent_Done,
     /* 1249906 */   // Label 18038: @1249906
     /* 1249906 */   GIM_Try, /*On fail goto*//*Label 18039*/ GIMT_Encode4(1249990), // Rule ID 7776 //
     /* 1249911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1249914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1249919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1249922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1249925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1249928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1249931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1249934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1249937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1249949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1249953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1249957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1249964 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1249964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1249967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1249969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1249971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1249973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1249975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1249977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1249982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1249985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1249988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1249989 */     // GIR_Coverage, 7776,
     /* 1249989 */     GIR_EraseRootFromParent_Done,
     /* 1249990 */   // Label 18039: @1249990
     /* 1249990 */   GIM_Try, /*On fail goto*//*Label 18040*/ GIMT_Encode4(1250074), // Rule ID 7777 //
     /* 1249995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1249998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1250012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250048 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1250051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250073 */     // GIR_Coverage, 7777,
     /* 1250073 */     GIR_EraseRootFromParent_Done,
     /* 1250074 */   // Label 18040: @1250074
     /* 1250074 */   GIM_Try, /*On fail goto*//*Label 18041*/ GIMT_Encode4(1250158), // Rule ID 7780 //
     /* 1250079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250157 */     // GIR_Coverage, 7780,
     /* 1250157 */     GIR_EraseRootFromParent_Done,
     /* 1250158 */   // Label 18041: @1250158
     /* 1250158 */   GIM_Try, /*On fail goto*//*Label 18042*/ GIMT_Encode4(1250242), // Rule ID 7781 //
     /* 1250163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1250180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250241 */     // GIR_Coverage, 7781,
     /* 1250241 */     GIR_EraseRootFromParent_Done,
     /* 1250242 */   // Label 18042: @1250242
     /* 1250242 */   GIM_Try, /*On fail goto*//*Label 18043*/ GIMT_Encode4(1250326), // Rule ID 7784 //
     /* 1250247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250300 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1250303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250325 */     // GIR_Coverage, 7784,
     /* 1250325 */     GIR_EraseRootFromParent_Done,
     /* 1250326 */   // Label 18043: @1250326
     /* 1250326 */   GIM_Try, /*On fail goto*//*Label 18044*/ GIMT_Encode4(1250410), // Rule ID 7785 //
     /* 1250331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1250348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250384 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF4_MASK),
     /* 1250387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250409 */     // GIR_Coverage, 7785,
     /* 1250409 */     GIR_EraseRootFromParent_Done,
     /* 1250410 */   // Label 18044: @1250410
     /* 1250410 */   GIM_Try, /*On fail goto*//*Label 18045*/ GIMT_Encode4(1250494), // Rule ID 7788 //
     /* 1250415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250468 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250493 */     // GIR_Coverage, 7788,
     /* 1250493 */     GIR_EraseRootFromParent_Done,
     /* 1250494 */   // Label 18045: @1250494
     /* 1250494 */   GIM_Try, /*On fail goto*//*Label 18046*/ GIMT_Encode4(1250578), // Rule ID 7789 //
     /* 1250499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1250510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1250513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1250516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1250522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250577 */     // GIR_Coverage, 7789,
     /* 1250577 */     GIR_EraseRootFromParent_Done,
     /* 1250578 */   // Label 18046: @1250578
     /* 1250578 */   GIM_Try, /*On fail goto*//*Label 18047*/ GIMT_Encode4(1250662), // Rule ID 7792 //
     /* 1250583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250636 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250661 */     // GIR_Coverage, 7792,
     /* 1250661 */     GIR_EraseRootFromParent_Done,
     /* 1250662 */   // Label 18047: @1250662
     /* 1250662 */   GIM_Try, /*On fail goto*//*Label 18048*/ GIMT_Encode4(1250746), // Rule ID 7793 //
     /* 1250667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1250678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1250681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1250684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1250690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250720 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_MF2_MASK),
     /* 1250723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1250741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250745 */     // GIR_Coverage, 7793,
     /* 1250745 */     GIR_EraseRootFromParent_Done,
     /* 1250746 */   // Label 18048: @1250746
     /* 1250746 */   GIM_Try, /*On fail goto*//*Label 18049*/ GIMT_Encode4(1250830), // Rule ID 7796 //
     /* 1250751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1250807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250829 */     // GIR_Coverage, 7796,
     /* 1250829 */     GIR_EraseRootFromParent_Done,
     /* 1250830 */   // Label 18049: @1250830
     /* 1250830 */   GIM_Try, /*On fail goto*//*Label 18050*/ GIMT_Encode4(1250914), // Rule ID 7797 //
     /* 1250835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1250838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1250846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1250849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1250852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1250855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1250858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1250861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1250888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1250891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1250909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250913 */     // GIR_Coverage, 7797,
     /* 1250913 */     GIR_EraseRootFromParent_Done,
     /* 1250914 */   // Label 18050: @1250914
     /* 1250914 */   GIM_Try, /*On fail goto*//*Label 18051*/ GIMT_Encode4(1250998), // Rule ID 7800 //
     /* 1250919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1250922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1250927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1250930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1250933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1250936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1250939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1250942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1250945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1250957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1250961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1250965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1250972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1250972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1250975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1250977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1250979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1250981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1250983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1250985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1250990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1250993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1250996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1250997 */     // GIR_Coverage, 7800,
     /* 1250997 */     GIR_EraseRootFromParent_Done,
     /* 1250998 */   // Label 18051: @1250998
     /* 1250998 */   GIM_Try, /*On fail goto*//*Label 18052*/ GIMT_Encode4(1251082), // Rule ID 7801 //
     /* 1251003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1251014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1251017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1251020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1251026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251056 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1251059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1251077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251081 */     // GIR_Coverage, 7801,
     /* 1251081 */     GIR_EraseRootFromParent_Done,
     /* 1251082 */   // Label 18052: @1251082
     /* 1251082 */   GIM_Try, /*On fail goto*//*Label 18053*/ GIMT_Encode4(1251166), // Rule ID 7804 //
     /* 1251087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1251143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251165 */     // GIR_Coverage, 7804,
     /* 1251165 */     GIR_EraseRootFromParent_Done,
     /* 1251166 */   // Label 18053: @1251166
     /* 1251166 */   GIM_Try, /*On fail goto*//*Label 18054*/ GIMT_Encode4(1251250), // Rule ID 7805 //
     /* 1251171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1251182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1251185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1251188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1251194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1251227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1251245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251249 */     // GIR_Coverage, 7805,
     /* 1251249 */     GIR_EraseRootFromParent_Done,
     /* 1251250 */   // Label 18054: @1251250
     /* 1251250 */   GIM_Try, /*On fail goto*//*Label 18055*/ GIMT_Encode4(1251334), // Rule ID 7808 //
     /* 1251255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1251258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251308 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1251311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251333 */     // GIR_Coverage, 7808,
     /* 1251333 */     GIR_EraseRootFromParent_Done,
     /* 1251334 */   // Label 18055: @1251334
     /* 1251334 */   GIM_Try, /*On fail goto*//*Label 18056*/ GIMT_Encode4(1251418), // Rule ID 7809 //
     /* 1251339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1251342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1251350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1251353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1251356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1251362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M1_MASK),
     /* 1251395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1251413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251417 */     // GIR_Coverage, 7809,
     /* 1251417 */     GIR_EraseRootFromParent_Done,
     /* 1251418 */   // Label 18056: @1251418
     /* 1251418 */   GIM_Try, /*On fail goto*//*Label 18057*/ GIMT_Encode4(1251502), // Rule ID 7812 //
     /* 1251423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1251434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1251437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1251479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251501 */     // GIR_Coverage, 7812,
     /* 1251501 */     GIR_EraseRootFromParent_Done,
     /* 1251502 */   // Label 18057: @1251502
     /* 1251502 */   GIM_Try, /*On fail goto*//*Label 18058*/ GIMT_Encode4(1251586), // Rule ID 7813 //
     /* 1251507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1251518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1251521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1251524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1251530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1251563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251585 */     // GIR_Coverage, 7813,
     /* 1251585 */     GIR_EraseRootFromParent_Done,
     /* 1251586 */   // Label 18058: @1251586
     /* 1251586 */   GIM_Try, /*On fail goto*//*Label 18059*/ GIMT_Encode4(1251670), // Rule ID 7816 //
     /* 1251591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1251602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1251605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251644 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1251647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251669 */     // GIR_Coverage, 7816,
     /* 1251669 */     GIR_EraseRootFromParent_Done,
     /* 1251670 */   // Label 18059: @1251670
     /* 1251670 */   GIM_Try, /*On fail goto*//*Label 18060*/ GIMT_Encode4(1251754), // Rule ID 7817 //
     /* 1251675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1251686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1251689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1251692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1251698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1251713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251728 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1251731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251753 */     // GIR_Coverage, 7817,
     /* 1251753 */     GIR_EraseRootFromParent_Done,
     /* 1251754 */   // Label 18060: @1251754
     /* 1251754 */   GIM_Try, /*On fail goto*//*Label 18061*/ GIMT_Encode4(1251838), // Rule ID 7820 //
     /* 1251759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1251770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1251773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251812 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1251815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251837 */     // GIR_Coverage, 7820,
     /* 1251837 */     GIR_EraseRootFromParent_Done,
     /* 1251838 */   // Label 18061: @1251838
     /* 1251838 */   GIM_Try, /*On fail goto*//*Label 18062*/ GIMT_Encode4(1251922), // Rule ID 7821 //
     /* 1251843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1251846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1251854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1251857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1251860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1251863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1251866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1251869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1251881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251896 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1251896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1251899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1251917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1251920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1251921 */     // GIR_Coverage, 7821,
     /* 1251921 */     GIR_EraseRootFromParent_Done,
     /* 1251922 */   // Label 18062: @1251922
     /* 1251922 */   GIM_Try, /*On fail goto*//*Label 18063*/ GIMT_Encode4(1252006), // Rule ID 7824 //
     /* 1251927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1251930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1251935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1251938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1251941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1251944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1251947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1251950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1251953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1251961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1251965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1251969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1251973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1251980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1251980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1251983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1251985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1251987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1251989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1251991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1251993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1251998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252005 */     // GIR_Coverage, 7824,
     /* 1252005 */     GIR_EraseRootFromParent_Done,
     /* 1252006 */   // Label 18063: @1252006
     /* 1252006 */   GIM_Try, /*On fail goto*//*Label 18064*/ GIMT_Encode4(1252090), // Rule ID 7825 //
     /* 1252011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1252028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1252067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252089 */     // GIR_Coverage, 7825,
     /* 1252089 */     GIR_EraseRootFromParent_Done,
     /* 1252090 */   // Label 18064: @1252090
     /* 1252090 */   GIM_Try, /*On fail goto*//*Label 18065*/ GIMT_Encode4(1252174), // Rule ID 7828 //
     /* 1252095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252148 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1252151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252173 */     // GIR_Coverage, 7828,
     /* 1252173 */     GIR_EraseRootFromParent_Done,
     /* 1252174 */   // Label 18065: @1252174
     /* 1252174 */   GIM_Try, /*On fail goto*//*Label 18066*/ GIMT_Encode4(1252258), // Rule ID 7829 //
     /* 1252179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1252196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252232 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1252235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252257 */     // GIR_Coverage, 7829,
     /* 1252257 */     GIR_EraseRootFromParent_Done,
     /* 1252258 */   // Label 18066: @1252258
     /* 1252258 */   GIM_Try, /*On fail goto*//*Label 18067*/ GIMT_Encode4(1252342), // Rule ID 7832 //
     /* 1252263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252316 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1252319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252341 */     // GIR_Coverage, 7832,
     /* 1252341 */     GIR_EraseRootFromParent_Done,
     /* 1252342 */   // Label 18067: @1252342
     /* 1252342 */   GIM_Try, /*On fail goto*//*Label 18068*/ GIMT_Encode4(1252426), // Rule ID 7833 //
     /* 1252347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1252358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1252361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1252364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1252370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252400 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1252403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1252421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252425 */     // GIR_Coverage, 7833,
     /* 1252425 */     GIR_EraseRootFromParent_Done,
     /* 1252426 */   // Label 18068: @1252426
     /* 1252426 */   GIM_Try, /*On fail goto*//*Label 18069*/ GIMT_Encode4(1252510), // Rule ID 7836 //
     /* 1252431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1252487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252509 */     // GIR_Coverage, 7836,
     /* 1252509 */     GIR_EraseRootFromParent_Done,
     /* 1252510 */   // Label 18069: @1252510
     /* 1252510 */   GIM_Try, /*On fail goto*//*Label 18070*/ GIMT_Encode4(1252594), // Rule ID 7837 //
     /* 1252515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1252526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1252529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1252532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1252538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1252571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252593 */     // GIR_Coverage, 7837,
     /* 1252593 */     GIR_EraseRootFromParent_Done,
     /* 1252594 */   // Label 18070: @1252594
     /* 1252594 */   GIM_Try, /*On fail goto*//*Label 18071*/ GIMT_Encode4(1252678), // Rule ID 7840 //
     /* 1252599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252652 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1252655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252677 */     // GIR_Coverage, 7840,
     /* 1252677 */     GIR_EraseRootFromParent_Done,
     /* 1252678 */   // Label 18071: @1252678
     /* 1252678 */   GIM_Try, /*On fail goto*//*Label 18072*/ GIMT_Encode4(1252762), // Rule ID 7841 //
     /* 1252683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1252694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1252697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1252700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1252706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1252721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252736 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1252739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252761 */     // GIR_Coverage, 7841,
     /* 1252761 */     GIR_EraseRootFromParent_Done,
     /* 1252762 */   // Label 18072: @1252762
     /* 1252762 */   GIM_Try, /*On fail goto*//*Label 18073*/ GIMT_Encode4(1252846), // Rule ID 7844 //
     /* 1252767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1252770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252820 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1252823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252845 */     // GIR_Coverage, 7844,
     /* 1252845 */     GIR_EraseRootFromParent_Done,
     /* 1252846 */   // Label 18073: @1252846
     /* 1252846 */   GIM_Try, /*On fail goto*//*Label 18074*/ GIMT_Encode4(1252930), // Rule ID 7845 //
     /* 1252851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1252854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1252862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1252865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1252868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1252871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1252874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1252877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1252889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252904 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1252904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1252907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1252917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1252922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1252925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1252928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1252929 */     // GIR_Coverage, 7845,
     /* 1252929 */     GIR_EraseRootFromParent_Done,
     /* 1252930 */   // Label 18074: @1252930
     /* 1252930 */   GIM_Try, /*On fail goto*//*Label 18075*/ GIMT_Encode4(1253014), // Rule ID 7848 //
     /* 1252935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1252938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1252943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1252946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1252949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1252952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1252955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1252958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1252961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1252969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1252973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1252977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1252981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1252988 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1252988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1252991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1252993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1252995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1252997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1252999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253013 */     // GIR_Coverage, 7848,
     /* 1253013 */     GIR_EraseRootFromParent_Done,
     /* 1253014 */   // Label 18075: @1253014
     /* 1253014 */   GIM_Try, /*On fail goto*//*Label 18076*/ GIMT_Encode4(1253098), // Rule ID 7849 //
     /* 1253019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1253036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1253057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M2_MASK),
     /* 1253075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253097 */     // GIR_Coverage, 7849,
     /* 1253097 */     GIR_EraseRootFromParent_Done,
     /* 1253098 */   // Label 18076: @1253098
     /* 1253098 */   GIM_Try, /*On fail goto*//*Label 18077*/ GIMT_Encode4(1253182), // Rule ID 7852 //
     /* 1253103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253156 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1253159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253181 */     // GIR_Coverage, 7852,
     /* 1253181 */     GIR_EraseRootFromParent_Done,
     /* 1253182 */   // Label 18077: @1253182
     /* 1253182 */   GIM_Try, /*On fail goto*//*Label 18078*/ GIMT_Encode4(1253266), // Rule ID 7853 //
     /* 1253187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1253204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1253225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253240 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M4_MASK),
     /* 1253243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253265 */     // GIR_Coverage, 7853,
     /* 1253265 */     GIR_EraseRootFromParent_Done,
     /* 1253266 */   // Label 18078: @1253266
     /* 1253266 */   GIM_Try, /*On fail goto*//*Label 18079*/ GIMT_Encode4(1253350), // Rule ID 7856 //
     /* 1253271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1253274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1253291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1253327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253349 */     // GIR_Coverage, 7856,
     /* 1253349 */     GIR_EraseRootFromParent_Done,
     /* 1253350 */   // Label 18079: @1253350
     /* 1253350 */   GIM_Try, /*On fail goto*//*Label 18080*/ GIMT_Encode4(1253434), // Rule ID 7857 //
     /* 1253355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1253358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmseq_mask),
     /* 1253363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1253366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1253369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1253372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1253375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1253378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1253393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1253397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253408 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11376:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSEQ_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VX_M8_MASK),
     /* 1253411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1253429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253433 */     // GIR_Coverage, 7857,
     /* 1253433 */     GIR_EraseRootFromParent_Done,
     /* 1253434 */   // Label 18080: @1253434
     /* 1253434 */   GIM_Try, /*On fail goto*//*Label 18081*/ GIMT_Encode4(1253518), // Rule ID 7948 //
     /* 1253439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1253456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1253459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253492 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1253495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253517 */     // GIR_Coverage, 7948,
     /* 1253517 */     GIR_EraseRootFromParent_Done,
     /* 1253518 */   // Label 18081: @1253518
     /* 1253518 */   GIM_Try, /*On fail goto*//*Label 18082*/ GIMT_Encode4(1253602), // Rule ID 7949 //
     /* 1253523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1253540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1253543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253576 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8_MASK),
     /* 1253579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253601 */     // GIR_Coverage, 7949,
     /* 1253601 */     GIR_EraseRootFromParent_Done,
     /* 1253602 */   // Label 18082: @1253602
     /* 1253602 */   GIM_Try, /*On fail goto*//*Label 18083*/ GIMT_Encode4(1253686), // Rule ID 7952 //
     /* 1253607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253660 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1253663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253685 */     // GIR_Coverage, 7952,
     /* 1253685 */     GIR_EraseRootFromParent_Done,
     /* 1253686 */   // Label 18083: @1253686
     /* 1253686 */   GIM_Try, /*On fail goto*//*Label 18084*/ GIMT_Encode4(1253770), // Rule ID 7953 //
     /* 1253691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1253702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1253705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1253708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1253711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1253714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253744 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1253747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253769 */     // GIR_Coverage, 7953,
     /* 1253769 */     GIR_EraseRootFromParent_Done,
     /* 1253770 */   // Label 18084: @1253770
     /* 1253770 */   GIM_Try, /*On fail goto*//*Label 18085*/ GIMT_Encode4(1253854), // Rule ID 7956 //
     /* 1253775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1253831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253853 */     // GIR_Coverage, 7956,
     /* 1253853 */     GIR_EraseRootFromParent_Done,
     /* 1253854 */   // Label 18085: @1253854
     /* 1253854 */   GIM_Try, /*On fail goto*//*Label 18086*/ GIMT_Encode4(1253938), // Rule ID 7957 //
     /* 1253859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1253862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1253870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1253873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1253876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1253879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1253882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1253885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253912 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1253912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1253915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1253917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1253919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1253921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1253923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1253925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1253930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1253933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1253936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1253937 */     // GIR_Coverage, 7957,
     /* 1253937 */     GIR_EraseRootFromParent_Done,
     /* 1253938 */   // Label 18086: @1253938
     /* 1253938 */   GIM_Try, /*On fail goto*//*Label 18087*/ GIMT_Encode4(1254022), // Rule ID 7960 //
     /* 1253943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1253946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1253951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1253954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1253957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1253960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1253963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1253966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1253969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1253985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1253989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1253996 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1253996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1253999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254021 */     // GIR_Coverage, 7960,
     /* 1254021 */     GIR_EraseRootFromParent_Done,
     /* 1254022 */   // Label 18087: @1254022
     /* 1254022 */   GIM_Try, /*On fail goto*//*Label 18088*/ GIMT_Encode4(1254106), // Rule ID 7961 //
     /* 1254027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1254044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1254047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254080 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4_MASK),
     /* 1254083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254105 */     // GIR_Coverage, 7961,
     /* 1254105 */     GIR_EraseRootFromParent_Done,
     /* 1254106 */   // Label 18088: @1254106
     /* 1254106 */   GIM_Try, /*On fail goto*//*Label 18089*/ GIMT_Encode4(1254190), // Rule ID 7964 //
     /* 1254111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1254128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1254131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1254167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254189 */     // GIR_Coverage, 7964,
     /* 1254189 */     GIR_EraseRootFromParent_Done,
     /* 1254190 */   // Label 18089: @1254190
     /* 1254190 */   GIM_Try, /*On fail goto*//*Label 18090*/ GIMT_Encode4(1254274), // Rule ID 7965 //
     /* 1254195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1254212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1254215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254248 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1254251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254273 */     // GIR_Coverage, 7965,
     /* 1254273 */     GIR_EraseRootFromParent_Done,
     /* 1254274 */   // Label 18090: @1254274
     /* 1254274 */   GIM_Try, /*On fail goto*//*Label 18091*/ GIMT_Encode4(1254358), // Rule ID 7968 //
     /* 1254279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1254296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1254299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254332 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1254335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254357 */     // GIR_Coverage, 7968,
     /* 1254357 */     GIR_EraseRootFromParent_Done,
     /* 1254358 */   // Label 18091: @1254358
     /* 1254358 */   GIM_Try, /*On fail goto*//*Label 18092*/ GIMT_Encode4(1254442), // Rule ID 7969 //
     /* 1254363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1254380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1254383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254416 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2_MASK),
     /* 1254419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254441 */     // GIR_Coverage, 7969,
     /* 1254441 */     GIR_EraseRootFromParent_Done,
     /* 1254442 */   // Label 18092: @1254442
     /* 1254442 */   GIM_Try, /*On fail goto*//*Label 18093*/ GIMT_Encode4(1254526), // Rule ID 7972 //
     /* 1254447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254525 */     // GIR_Coverage, 7972,
     /* 1254525 */     GIR_EraseRootFromParent_Done,
     /* 1254526 */   // Label 18093: @1254526
     /* 1254526 */   GIM_Try, /*On fail goto*//*Label 18094*/ GIMT_Encode4(1254610), // Rule ID 7973 //
     /* 1254531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1254542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1254545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1254548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1254551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1254554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1254605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254609 */     // GIR_Coverage, 7973,
     /* 1254609 */     GIR_EraseRootFromParent_Done,
     /* 1254610 */   // Label 18094: @1254610
     /* 1254610 */   GIM_Try, /*On fail goto*//*Label 18095*/ GIMT_Encode4(1254694), // Rule ID 7976 //
     /* 1254615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254668 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254693 */     // GIR_Coverage, 7976,
     /* 1254693 */     GIR_EraseRootFromParent_Done,
     /* 1254694 */   // Label 18095: @1254694
     /* 1254694 */   GIM_Try, /*On fail goto*//*Label 18096*/ GIMT_Encode4(1254778), // Rule ID 7977 //
     /* 1254699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1254710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1254713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1254716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1254719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1254722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254752 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1254773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254777 */     // GIR_Coverage, 7977,
     /* 1254777 */     GIR_EraseRootFromParent_Done,
     /* 1254778 */   // Label 18096: @1254778
     /* 1254778 */   GIM_Try, /*On fail goto*//*Label 18097*/ GIMT_Encode4(1254862), // Rule ID 7980 //
     /* 1254783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1254786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254836 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1254836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254861 */     // GIR_Coverage, 7980,
     /* 1254861 */     GIR_EraseRootFromParent_Done,
     /* 1254862 */   // Label 18097: @1254862
     /* 1254862 */   GIM_Try, /*On fail goto*//*Label 18098*/ GIMT_Encode4(1254946), // Rule ID 7981 //
     /* 1254867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1254870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1254878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1254881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1254884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1254887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1254890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1254893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1254920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1254920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1254923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1254925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1254927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1254929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1254931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1254933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1254938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1254941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1254944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1254945 */     // GIR_Coverage, 7981,
     /* 1254945 */     GIR_EraseRootFromParent_Done,
     /* 1254946 */   // Label 18098: @1254946
     /* 1254946 */   GIM_Try, /*On fail goto*//*Label 18099*/ GIMT_Encode4(1255030), // Rule ID 7984 //
     /* 1254951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1254954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1254959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1254962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1254965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1254968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1254971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1254974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1254977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1254993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1254997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1255007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255029 */     // GIR_Coverage, 7984,
     /* 1255029 */     GIR_EraseRootFromParent_Done,
     /* 1255030 */   // Label 18099: @1255030
     /* 1255030 */   GIM_Try, /*On fail goto*//*Label 18100*/ GIMT_Encode4(1255114), // Rule ID 7985 //
     /* 1255035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1255038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1255046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1255049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1255052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1255055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1255058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1_MASK),
     /* 1255091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1255109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255113 */     // GIR_Coverage, 7985,
     /* 1255113 */     GIR_EraseRootFromParent_Done,
     /* 1255114 */   // Label 18100: @1255114
     /* 1255114 */   GIM_Try, /*On fail goto*//*Label 18101*/ GIMT_Encode4(1255198), // Rule ID 7988 //
     /* 1255119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1255136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1255139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1255175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255197 */     // GIR_Coverage, 7988,
     /* 1255197 */     GIR_EraseRootFromParent_Done,
     /* 1255198 */   // Label 18101: @1255198
     /* 1255198 */   GIM_Try, /*On fail goto*//*Label 18102*/ GIMT_Encode4(1255282), // Rule ID 7989 //
     /* 1255203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1255220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1255223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1255259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255281 */     // GIR_Coverage, 7989,
     /* 1255281 */     GIR_EraseRootFromParent_Done,
     /* 1255282 */   // Label 18102: @1255282
     /* 1255282 */   GIM_Try, /*On fail goto*//*Label 18103*/ GIMT_Encode4(1255366), // Rule ID 7992 //
     /* 1255287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1255304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1255307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255340 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1255343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255365 */     // GIR_Coverage, 7992,
     /* 1255365 */     GIR_EraseRootFromParent_Done,
     /* 1255366 */   // Label 18103: @1255366
     /* 1255366 */   GIM_Try, /*On fail goto*//*Label 18104*/ GIMT_Encode4(1255450), // Rule ID 7993 //
     /* 1255371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1255388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1255391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255424 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1255427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255449 */     // GIR_Coverage, 7993,
     /* 1255449 */     GIR_EraseRootFromParent_Done,
     /* 1255450 */   // Label 18104: @1255450
     /* 1255450 */   GIM_Try, /*On fail goto*//*Label 18105*/ GIMT_Encode4(1255534), // Rule ID 7996 //
     /* 1255455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255508 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1255511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255533 */     // GIR_Coverage, 7996,
     /* 1255533 */     GIR_EraseRootFromParent_Done,
     /* 1255534 */   // Label 18105: @1255534
     /* 1255534 */   GIM_Try, /*On fail goto*//*Label 18106*/ GIMT_Encode4(1255618), // Rule ID 7997 //
     /* 1255539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1255550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1255553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1255556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1255559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1255562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255592 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1255595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1255613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255617 */     // GIR_Coverage, 7997,
     /* 1255617 */     GIR_EraseRootFromParent_Done,
     /* 1255618 */   // Label 18106: @1255618
     /* 1255618 */   GIM_Try, /*On fail goto*//*Label 18107*/ GIMT_Encode4(1255702), // Rule ID 8000 //
     /* 1255623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1255679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255701 */     // GIR_Coverage, 8000,
     /* 1255701 */     GIR_EraseRootFromParent_Done,
     /* 1255702 */   // Label 18107: @1255702
     /* 1255702 */   GIM_Try, /*On fail goto*//*Label 18108*/ GIMT_Encode4(1255786), // Rule ID 8001 //
     /* 1255707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1255718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1255721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1255724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1255727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1255730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1255749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1255763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255785 */     // GIR_Coverage, 8001,
     /* 1255785 */     GIR_EraseRootFromParent_Done,
     /* 1255786 */   // Label 18108: @1255786
     /* 1255786 */   GIM_Try, /*On fail goto*//*Label 18109*/ GIMT_Encode4(1255870), // Rule ID 8004 //
     /* 1255791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1255844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1255847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255869 */     // GIR_Coverage, 8004,
     /* 1255869 */     GIR_EraseRootFromParent_Done,
     /* 1255870 */   // Label 18109: @1255870
     /* 1255870 */   GIM_Try, /*On fail goto*//*Label 18110*/ GIMT_Encode4(1255954), // Rule ID 8005 //
     /* 1255875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1255878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1255886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1255889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1255892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1255895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1255898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1255901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1255917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1255921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1255928 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1255928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1255931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1255933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1255935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1255937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1255939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1255941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1255946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1255949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1255952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1255953 */     // GIR_Coverage, 8005,
     /* 1255953 */     GIR_EraseRootFromParent_Done,
     /* 1255954 */   // Label 18110: @1255954
     /* 1255954 */   GIM_Try, /*On fail goto*//*Label 18111*/ GIMT_Encode4(1256038), // Rule ID 8008 //
     /* 1255959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1255962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1255967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1255970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1255973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1255976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1255979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1255982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1255985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1255993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1255997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256012 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1256015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256037 */     // GIR_Coverage, 8008,
     /* 1256037 */     GIR_EraseRootFromParent_Done,
     /* 1256038 */   // Label 18111: @1256038
     /* 1256038 */   GIM_Try, /*On fail goto*//*Label 18112*/ GIMT_Encode4(1256122), // Rule ID 8009 //
     /* 1256043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1256054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1256057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1256060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1256063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1256066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1256099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1256117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256121 */     // GIR_Coverage, 8009,
     /* 1256121 */     GIR_EraseRootFromParent_Done,
     /* 1256122 */   // Label 18112: @1256122
     /* 1256122 */   GIM_Try, /*On fail goto*//*Label 18113*/ GIMT_Encode4(1256206), // Rule ID 8012 //
     /* 1256127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1256144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1256147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1256183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256205 */     // GIR_Coverage, 8012,
     /* 1256205 */     GIR_EraseRootFromParent_Done,
     /* 1256206 */   // Label 18113: @1256206
     /* 1256206 */   GIM_Try, /*On fail goto*//*Label 18114*/ GIMT_Encode4(1256290), // Rule ID 8013 //
     /* 1256211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1256228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1256231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1256267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256289 */     // GIR_Coverage, 8013,
     /* 1256289 */     GIR_EraseRootFromParent_Done,
     /* 1256290 */   // Label 18114: @1256290
     /* 1256290 */   GIM_Try, /*On fail goto*//*Label 18115*/ GIMT_Encode4(1256374), // Rule ID 8016 //
     /* 1256295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1256312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1256315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1256351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256373 */     // GIR_Coverage, 8016,
     /* 1256373 */     GIR_EraseRootFromParent_Done,
     /* 1256374 */   // Label 18115: @1256374
     /* 1256374 */   GIM_Try, /*On fail goto*//*Label 18116*/ GIMT_Encode4(1256458), // Rule ID 8017 //
     /* 1256379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1256396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1256399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1256435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256457 */     // GIR_Coverage, 8017,
     /* 1256457 */     GIR_EraseRootFromParent_Done,
     /* 1256458 */   // Label 18116: @1256458
     /* 1256458 */   GIM_Try, /*On fail goto*//*Label 18117*/ GIMT_Encode4(1256542), // Rule ID 8020 //
     /* 1256463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1256466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256516 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1256519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256541 */     // GIR_Coverage, 8020,
     /* 1256541 */     GIR_EraseRootFromParent_Done,
     /* 1256542 */   // Label 18117: @1256542
     /* 1256542 */   GIM_Try, /*On fail goto*//*Label 18118*/ GIMT_Encode4(1256626), // Rule ID 8021 //
     /* 1256547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1256550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1256558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1256561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1256564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1256567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1256570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1256589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1256603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1256621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256625 */     // GIR_Coverage, 8021,
     /* 1256625 */     GIR_EraseRootFromParent_Done,
     /* 1256626 */   // Label 18118: @1256626
     /* 1256626 */   GIM_Try, /*On fail goto*//*Label 18119*/ GIMT_Encode4(1256710), // Rule ID 8024 //
     /* 1256631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1256687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256709 */     // GIR_Coverage, 8024,
     /* 1256709 */     GIR_EraseRootFromParent_Done,
     /* 1256710 */   // Label 18119: @1256710
     /* 1256710 */   GIM_Try, /*On fail goto*//*Label 18120*/ GIMT_Encode4(1256794), // Rule ID 8025 //
     /* 1256715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1256726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1256729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1256732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1256735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1256738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1256757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2_MASK),
     /* 1256771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256793 */     // GIR_Coverage, 8025,
     /* 1256793 */     GIR_EraseRootFromParent_Done,
     /* 1256794 */   // Label 18120: @1256794
     /* 1256794 */   GIM_Try, /*On fail goto*//*Label 18121*/ GIMT_Encode4(1256878), // Rule ID 8028 //
     /* 1256799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1256852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1256855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256877 */     // GIR_Coverage, 8028,
     /* 1256877 */     GIR_EraseRootFromParent_Done,
     /* 1256878 */   // Label 18121: @1256878
     /* 1256878 */   GIM_Try, /*On fail goto*//*Label 18122*/ GIMT_Encode4(1256962), // Rule ID 8029 //
     /* 1256883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1256886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1256894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1256897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1256900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1256903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1256906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1256909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1256925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1256929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1256936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1256936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4_MASK),
     /* 1256939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1256941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1256943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1256945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1256947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1256949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1256954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1256957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1256960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1256961 */     // GIR_Coverage, 8029,
     /* 1256961 */     GIR_EraseRootFromParent_Done,
     /* 1256962 */   // Label 18122: @1256962
     /* 1256962 */   GIM_Try, /*On fail goto*//*Label 18123*/ GIMT_Encode4(1257046), // Rule ID 8032 //
     /* 1256967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1256970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1256975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1256978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1256981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1256984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1256987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1256990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1256993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1256997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1257023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257045 */     // GIR_Coverage, 8032,
     /* 1257045 */     GIR_EraseRootFromParent_Done,
     /* 1257046 */   // Label 18123: @1257046
     /* 1257046 */   GIM_Try, /*On fail goto*//*Label 18124*/ GIMT_Encode4(1257130), // Rule ID 8033 //
     /* 1257051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1257054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1257062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1257065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1257068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1257071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1257074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1257093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8_MASK),
     /* 1257107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1257125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257129 */     // GIR_Coverage, 8033,
     /* 1257129 */     GIR_EraseRootFromParent_Done,
     /* 1257130 */   // Label 18124: @1257130
     /* 1257130 */   GIM_Try, /*On fail goto*//*Label 18125*/ GIMT_Encode4(1257214), // Rule ID 8036 //
     /* 1257135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1257152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1257191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257213 */     // GIR_Coverage, 8036,
     /* 1257213 */     GIR_EraseRootFromParent_Done,
     /* 1257214 */   // Label 18125: @1257214
     /* 1257214 */   GIM_Try, /*On fail goto*//*Label 18126*/ GIMT_Encode4(1257298), // Rule ID 8037 //
     /* 1257219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1257236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF8_MASK),
     /* 1257275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257297 */     // GIR_Coverage, 8037,
     /* 1257297 */     GIR_EraseRootFromParent_Done,
     /* 1257298 */   // Label 18126: @1257298
     /* 1257298 */   GIM_Try, /*On fail goto*//*Label 18127*/ GIMT_Encode4(1257382), // Rule ID 8040 //
     /* 1257303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1257320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1257359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257381 */     // GIR_Coverage, 8040,
     /* 1257381 */     GIR_EraseRootFromParent_Done,
     /* 1257382 */   // Label 18127: @1257382
     /* 1257382 */   GIM_Try, /*On fail goto*//*Label 18128*/ GIMT_Encode4(1257466), // Rule ID 8041 //
     /* 1257387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1257404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1257443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257465 */     // GIR_Coverage, 8041,
     /* 1257465 */     GIR_EraseRootFromParent_Done,
     /* 1257466 */   // Label 18128: @1257466
     /* 1257466 */   GIM_Try, /*On fail goto*//*Label 18129*/ GIMT_Encode4(1257550), // Rule ID 8044 //
     /* 1257471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257524 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1257527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257549 */     // GIR_Coverage, 8044,
     /* 1257549 */     GIR_EraseRootFromParent_Done,
     /* 1257550 */   // Label 18129: @1257550
     /* 1257550 */   GIM_Try, /*On fail goto*//*Label 18130*/ GIMT_Encode4(1257634), // Rule ID 8045 //
     /* 1257555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1257566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1257569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1257572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1257578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257608 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1257611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1257629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257633 */     // GIR_Coverage, 8045,
     /* 1257633 */     GIR_EraseRootFromParent_Done,
     /* 1257634 */   // Label 18130: @1257634
     /* 1257634 */   GIM_Try, /*On fail goto*//*Label 18131*/ GIMT_Encode4(1257718), // Rule ID 8048 //
     /* 1257639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257692 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1257695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257717 */     // GIR_Coverage, 8048,
     /* 1257717 */     GIR_EraseRootFromParent_Done,
     /* 1257718 */   // Label 18131: @1257718
     /* 1257718 */   GIM_Try, /*On fail goto*//*Label 18132*/ GIMT_Encode4(1257802), // Rule ID 8049 //
     /* 1257723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1257740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257776 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF4_MASK),
     /* 1257779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257801 */     // GIR_Coverage, 8049,
     /* 1257801 */     GIR_EraseRootFromParent_Done,
     /* 1257802 */   // Label 18132: @1257802
     /* 1257802 */   GIM_Try, /*On fail goto*//*Label 18133*/ GIMT_Encode4(1257886), // Rule ID 8052 //
     /* 1257807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1257833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1257860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1257863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257885 */     // GIR_Coverage, 8052,
     /* 1257885 */     GIR_EraseRootFromParent_Done,
     /* 1257886 */   // Label 18133: @1257886
     /* 1257886 */   GIM_Try, /*On fail goto*//*Label 18134*/ GIMT_Encode4(1257970), // Rule ID 8053 //
     /* 1257891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1257894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1257902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1257905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1257908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1257911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1257914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1257917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1257929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1257933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1257937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1257944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1257944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1257947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1257949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1257951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1257953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1257955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1257957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1257962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1257965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1257968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1257969 */     // GIR_Coverage, 8053,
     /* 1257969 */     GIR_EraseRootFromParent_Done,
     /* 1257970 */   // Label 18134: @1257970
     /* 1257970 */   GIM_Try, /*On fail goto*//*Label 18135*/ GIMT_Encode4(1258054), // Rule ID 8056 //
     /* 1257975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1257978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1257983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1257986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1257989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1257992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1257995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1257998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1258031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258053 */     // GIR_Coverage, 8056,
     /* 1258053 */     GIR_EraseRootFromParent_Done,
     /* 1258054 */   // Label 18135: @1258054
     /* 1258054 */   GIM_Try, /*On fail goto*//*Label 18136*/ GIMT_Encode4(1258138), // Rule ID 8057 //
     /* 1258059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1258076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_MF2_MASK),
     /* 1258115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258137 */     // GIR_Coverage, 8057,
     /* 1258137 */     GIR_EraseRootFromParent_Done,
     /* 1258138 */   // Label 18136: @1258138
     /* 1258138 */   GIM_Try, /*On fail goto*//*Label 18137*/ GIMT_Encode4(1258222), // Rule ID 8060 //
     /* 1258143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1258160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258221 */     // GIR_Coverage, 8060,
     /* 1258221 */     GIR_EraseRootFromParent_Done,
     /* 1258222 */   // Label 18137: @1258222
     /* 1258222 */   GIM_Try, /*On fail goto*//*Label 18138*/ GIMT_Encode4(1258306), // Rule ID 8061 //
     /* 1258227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1258238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1258241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1258244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1258250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258305 */     // GIR_Coverage, 8061,
     /* 1258305 */     GIR_EraseRootFromParent_Done,
     /* 1258306 */   // Label 18138: @1258306
     /* 1258306 */   GIM_Try, /*On fail goto*//*Label 18139*/ GIMT_Encode4(1258390), // Rule ID 8064 //
     /* 1258311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1258328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258389 */     // GIR_Coverage, 8064,
     /* 1258389 */     GIR_EraseRootFromParent_Done,
     /* 1258390 */   // Label 18139: @1258390
     /* 1258390 */   GIM_Try, /*On fail goto*//*Label 18140*/ GIMT_Encode4(1258474), // Rule ID 8065 //
     /* 1258395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1258406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1258409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1258412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1258418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1258469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258473 */     // GIR_Coverage, 8065,
     /* 1258473 */     GIR_EraseRootFromParent_Done,
     /* 1258474 */   // Label 18140: @1258474
     /* 1258474 */   GIM_Try, /*On fail goto*//*Label 18141*/ GIMT_Encode4(1258558), // Rule ID 8068 //
     /* 1258479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258557 */     // GIR_Coverage, 8068,
     /* 1258557 */     GIR_EraseRootFromParent_Done,
     /* 1258558 */   // Label 18141: @1258558
     /* 1258558 */   GIM_Try, /*On fail goto*//*Label 18142*/ GIMT_Encode4(1258642), // Rule ID 8069 //
     /* 1258563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1258574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1258577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1258580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1258586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1258637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258641 */     // GIR_Coverage, 8069,
     /* 1258641 */     GIR_EraseRootFromParent_Done,
     /* 1258642 */   // Label 18142: @1258642
     /* 1258642 */   GIM_Try, /*On fail goto*//*Label 18143*/ GIMT_Encode4(1258726), // Rule ID 8072 //
     /* 1258647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1258650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258700 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258725 */     // GIR_Coverage, 8072,
     /* 1258725 */     GIR_EraseRootFromParent_Done,
     /* 1258726 */   // Label 18143: @1258726
     /* 1258726 */   GIM_Try, /*On fail goto*//*Label 18144*/ GIMT_Encode4(1258810), // Rule ID 8073 //
     /* 1258731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1258734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1258742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1258745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1258748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1258754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258784 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M1_MASK),
     /* 1258787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1258805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258809 */     // GIR_Coverage, 8073,
     /* 1258809 */     GIR_EraseRootFromParent_Done,
     /* 1258810 */   // Label 18144: @1258810
     /* 1258810 */   GIM_Try, /*On fail goto*//*Label 18145*/ GIMT_Encode4(1258894), // Rule ID 8076 //
     /* 1258815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1258835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1258841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258868 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1258868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1258871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258893 */     // GIR_Coverage, 8076,
     /* 1258893 */     GIR_EraseRootFromParent_Done,
     /* 1258894 */   // Label 18145: @1258894
     /* 1258894 */   GIM_Try, /*On fail goto*//*Label 18146*/ GIMT_Encode4(1258978), // Rule ID 8077 //
     /* 1258899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1258902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1258910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1258913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1258916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1258919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1258922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1258925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1258933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1258937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1258941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1258945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1258952 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1258952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1258955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1258957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1258959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1258961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1258963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1258965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1258970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1258973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1258976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1258977 */     // GIR_Coverage, 8077,
     /* 1258977 */     GIR_EraseRootFromParent_Done,
     /* 1258978 */   // Label 18146: @1258978
     /* 1258978 */   GIM_Try, /*On fail goto*//*Label 18147*/ GIMT_Encode4(1259062), // Rule ID 8080 //
     /* 1258983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1258986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1258991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1258994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1258997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1259000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259036 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1259039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259061 */     // GIR_Coverage, 8080,
     /* 1259061 */     GIR_EraseRootFromParent_Done,
     /* 1259062 */   // Label 18147: @1259062
     /* 1259062 */   GIM_Try, /*On fail goto*//*Label 18148*/ GIMT_Encode4(1259146), // Rule ID 8081 //
     /* 1259067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1259084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259120 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1259123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259145 */     // GIR_Coverage, 8081,
     /* 1259145 */     GIR_EraseRootFromParent_Done,
     /* 1259146 */   // Label 18148: @1259146
     /* 1259146 */   GIM_Try, /*On fail goto*//*Label 18149*/ GIMT_Encode4(1259230), // Rule ID 8084 //
     /* 1259151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1259162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1259165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1259168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1259174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259204 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1259207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259229 */     // GIR_Coverage, 8084,
     /* 1259229 */     GIR_EraseRootFromParent_Done,
     /* 1259230 */   // Label 18149: @1259230
     /* 1259230 */   GIM_Try, /*On fail goto*//*Label 18150*/ GIMT_Encode4(1259314), // Rule ID 8085 //
     /* 1259235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1259246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1259249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1259252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1259258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259288 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1259291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1259309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259313 */     // GIR_Coverage, 8085,
     /* 1259313 */     GIR_EraseRootFromParent_Done,
     /* 1259314 */   // Label 18150: @1259314
     /* 1259314 */   GIM_Try, /*On fail goto*//*Label 18151*/ GIMT_Encode4(1259398), // Rule ID 8088 //
     /* 1259319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1259375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259397 */     // GIR_Coverage, 8088,
     /* 1259397 */     GIR_EraseRootFromParent_Done,
     /* 1259398 */   // Label 18151: @1259398
     /* 1259398 */   GIM_Try, /*On fail goto*//*Label 18152*/ GIMT_Encode4(1259482), // Rule ID 8089 //
     /* 1259403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1259414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1259417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1259420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1259426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1259459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259481 */     // GIR_Coverage, 8089,
     /* 1259481 */     GIR_EraseRootFromParent_Done,
     /* 1259482 */   // Label 18152: @1259482
     /* 1259482 */   GIM_Try, /*On fail goto*//*Label 18153*/ GIMT_Encode4(1259566), // Rule ID 8092 //
     /* 1259487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259540 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1259543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259565 */     // GIR_Coverage, 8092,
     /* 1259565 */     GIR_EraseRootFromParent_Done,
     /* 1259566 */   // Label 18153: @1259566
     /* 1259566 */   GIM_Try, /*On fail goto*//*Label 18154*/ GIMT_Encode4(1259650), // Rule ID 8093 //
     /* 1259571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1259582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1259585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1259588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1259594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1259609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259624 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1259627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259649 */     // GIR_Coverage, 8093,
     /* 1259649 */     GIR_EraseRootFromParent_Done,
     /* 1259650 */   // Label 18154: @1259650
     /* 1259650 */   GIM_Try, /*On fail goto*//*Label 18155*/ GIMT_Encode4(1259734), // Rule ID 8096 //
     /* 1259655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259708 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1259711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259733 */     // GIR_Coverage, 8096,
     /* 1259733 */     GIR_EraseRootFromParent_Done,
     /* 1259734 */   // Label 18155: @1259734
     /* 1259734 */   GIM_Try, /*On fail goto*//*Label 18156*/ GIMT_Encode4(1259818), // Rule ID 8097 //
     /* 1259739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1259750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1259753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1259756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1259762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1259777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259792 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1259795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1259813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259817 */     // GIR_Coverage, 8097,
     /* 1259817 */     GIR_EraseRootFromParent_Done,
     /* 1259818 */   // Label 18156: @1259818
     /* 1259818 */   GIM_Try, /*On fail goto*//*Label 18157*/ GIMT_Encode4(1259902), // Rule ID 8100 //
     /* 1259823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1259843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1259849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259876 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1259876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1259879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259901 */     // GIR_Coverage, 8100,
     /* 1259901 */     GIR_EraseRootFromParent_Done,
     /* 1259902 */   // Label 18157: @1259902
     /* 1259902 */   GIM_Try, /*On fail goto*//*Label 18158*/ GIMT_Encode4(1259986), // Rule ID 8101 //
     /* 1259907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1259910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1259918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1259921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1259924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1259927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1259930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1259933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1259941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1259945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1259949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1259953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1259960 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1259960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1259963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1259965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1259967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1259969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1259971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1259973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1259978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1259981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1259984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1259985 */     // GIR_Coverage, 8101,
     /* 1259985 */     GIR_EraseRootFromParent_Done,
     /* 1259986 */   // Label 18158: @1259986
     /* 1259986 */   GIM_Try, /*On fail goto*//*Label 18159*/ GIMT_Encode4(1260070), // Rule ID 8104 //
     /* 1259991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1259994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1259999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1260008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260044 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1260047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260069 */     // GIR_Coverage, 8104,
     /* 1260069 */     GIR_EraseRootFromParent_Done,
     /* 1260070 */   // Label 18159: @1260070
     /* 1260070 */   GIM_Try, /*On fail goto*//*Label 18160*/ GIMT_Encode4(1260154), // Rule ID 8105 //
     /* 1260075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1260092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260128 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1260131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260153 */     // GIR_Coverage, 8105,
     /* 1260153 */     GIR_EraseRootFromParent_Done,
     /* 1260154 */   // Label 18160: @1260154
     /* 1260154 */   GIM_Try, /*On fail goto*//*Label 18161*/ GIMT_Encode4(1260238), // Rule ID 8108 //
     /* 1260159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1260176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260212 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1260215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260237 */     // GIR_Coverage, 8108,
     /* 1260237 */     GIR_EraseRootFromParent_Done,
     /* 1260238 */   // Label 18161: @1260238
     /* 1260238 */   GIM_Try, /*On fail goto*//*Label 18162*/ GIMT_Encode4(1260322), // Rule ID 8109 //
     /* 1260243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1260254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1260257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1260260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1260266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260296 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1260299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1260317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260321 */     // GIR_Coverage, 8109,
     /* 1260321 */     GIR_EraseRootFromParent_Done,
     /* 1260322 */   // Label 18162: @1260322
     /* 1260322 */   GIM_Try, /*On fail goto*//*Label 18163*/ GIMT_Encode4(1260406), // Rule ID 8112 //
     /* 1260327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1260383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260405 */     // GIR_Coverage, 8112,
     /* 1260405 */     GIR_EraseRootFromParent_Done,
     /* 1260406 */   // Label 18163: @1260406
     /* 1260406 */   GIM_Try, /*On fail goto*//*Label 18164*/ GIMT_Encode4(1260490), // Rule ID 8113 //
     /* 1260411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1260422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1260425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1260428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1260434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1260449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M2_MASK),
     /* 1260467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260489 */     // GIR_Coverage, 8113,
     /* 1260489 */     GIR_EraseRootFromParent_Done,
     /* 1260490 */   // Label 18164: @1260490
     /* 1260490 */   GIM_Try, /*On fail goto*//*Label 18165*/ GIMT_Encode4(1260574), // Rule ID 8116 //
     /* 1260495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1260551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260573 */     // GIR_Coverage, 8116,
     /* 1260573 */     GIR_EraseRootFromParent_Done,
     /* 1260574 */   // Label 18165: @1260574
     /* 1260574 */   GIM_Try, /*On fail goto*//*Label 18166*/ GIMT_Encode4(1260658), // Rule ID 8117 //
     /* 1260579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1260590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1260593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1260596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1260602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1260617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M4_MASK),
     /* 1260635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260657 */     // GIR_Coverage, 8117,
     /* 1260657 */     GIR_EraseRootFromParent_Done,
     /* 1260658 */   // Label 18166: @1260658
     /* 1260658 */   GIM_Try, /*On fail goto*//*Label 18167*/ GIMT_Encode4(1260742), // Rule ID 8120 //
     /* 1260663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1260666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1260683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1260719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260741 */     // GIR_Coverage, 8120,
     /* 1260741 */     GIR_EraseRootFromParent_Done,
     /* 1260742 */   // Label 18167: @1260742
     /* 1260742 */   GIM_Try, /*On fail goto*//*Label 18168*/ GIMT_Encode4(1260826), // Rule ID 8121 //
     /* 1260747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1260750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsne_mask),
     /* 1260755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1260758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1260761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1260764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1260767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1260770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1260785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1260789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11397:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSNE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VX_M8_MASK),
     /* 1260803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1260821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260825 */     // GIR_Coverage, 8121,
     /* 1260825 */     GIR_EraseRootFromParent_Done,
     /* 1260826 */   // Label 18168: @1260826
     /* 1260826 */   GIM_Try, /*On fail goto*//*Label 18169*/ GIMT_Encode4(1260910), // Rule ID 8212 //
     /* 1260831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1260834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1260839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1260857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1260884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1260887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260909 */     // GIR_Coverage, 8212,
     /* 1260909 */     GIR_EraseRootFromParent_Done,
     /* 1260910 */   // Label 18169: @1260910
     /* 1260910 */   GIM_Try, /*On fail goto*//*Label 18170*/ GIMT_Encode4(1260994), // Rule ID 8213 //
     /* 1260915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1260918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1260923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1260926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1260929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1260932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1260935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1260938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1260941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1260957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1260961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1260968 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1260968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8_MASK),
     /* 1260971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1260973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1260975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1260977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1260979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1260981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1260986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1260989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1260992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1260993 */     // GIR_Coverage, 8213,
     /* 1260993 */     GIR_EraseRootFromParent_Done,
     /* 1260994 */   // Label 18170: @1260994
     /* 1260994 */   GIM_Try, /*On fail goto*//*Label 18171*/ GIMT_Encode4(1261078), // Rule ID 8216 //
     /* 1260999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1261016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1261019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261052 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1261055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261077 */     // GIR_Coverage, 8216,
     /* 1261077 */     GIR_EraseRootFromParent_Done,
     /* 1261078 */   // Label 18171: @1261078
     /* 1261078 */   GIM_Try, /*On fail goto*//*Label 18172*/ GIMT_Encode4(1261162), // Rule ID 8217 //
     /* 1261083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1261100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1261103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261136 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1261139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261161 */     // GIR_Coverage, 8217,
     /* 1261161 */     GIR_EraseRootFromParent_Done,
     /* 1261162 */   // Label 18172: @1261162
     /* 1261162 */   GIM_Try, /*On fail goto*//*Label 18173*/ GIMT_Encode4(1261246), // Rule ID 8220 //
     /* 1261167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1261184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1261187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261245 */     // GIR_Coverage, 8220,
     /* 1261245 */     GIR_EraseRootFromParent_Done,
     /* 1261246 */   // Label 18173: @1261246
     /* 1261246 */   GIM_Try, /*On fail goto*//*Label 18174*/ GIMT_Encode4(1261330), // Rule ID 8221 //
     /* 1261251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1261262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1261265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1261268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1261271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1261274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261329 */     // GIR_Coverage, 8221,
     /* 1261329 */     GIR_EraseRootFromParent_Done,
     /* 1261330 */   // Label 18174: @1261330
     /* 1261330 */   GIM_Try, /*On fail goto*//*Label 18175*/ GIMT_Encode4(1261414), // Rule ID 8224 //
     /* 1261335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261388 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1261391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261413 */     // GIR_Coverage, 8224,
     /* 1261413 */     GIR_EraseRootFromParent_Done,
     /* 1261414 */   // Label 18175: @1261414
     /* 1261414 */   GIM_Try, /*On fail goto*//*Label 18176*/ GIMT_Encode4(1261498), // Rule ID 8225 //
     /* 1261419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1261436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1261439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261472 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1261475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261497 */     // GIR_Coverage, 8225,
     /* 1261497 */     GIR_EraseRootFromParent_Done,
     /* 1261498 */   // Label 18176: @1261498
     /* 1261498 */   GIM_Try, /*On fail goto*//*Label 18177*/ GIMT_Encode4(1261582), // Rule ID 8228 //
     /* 1261503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261581 */     // GIR_Coverage, 8228,
     /* 1261581 */     GIR_EraseRootFromParent_Done,
     /* 1261582 */   // Label 18177: @1261582
     /* 1261582 */   GIM_Try, /*On fail goto*//*Label 18178*/ GIMT_Encode4(1261666), // Rule ID 8229 //
     /* 1261587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1261598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1261601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1261604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1261607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1261610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1261661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261665 */     // GIR_Coverage, 8229,
     /* 1261665 */     GIR_EraseRootFromParent_Done,
     /* 1261666 */   // Label 18178: @1261666
     /* 1261666 */   GIM_Try, /*On fail goto*//*Label 18179*/ GIMT_Encode4(1261750), // Rule ID 8232 //
     /* 1261671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261724 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261749 */     // GIR_Coverage, 8232,
     /* 1261749 */     GIR_EraseRootFromParent_Done,
     /* 1261750 */   // Label 18179: @1261750
     /* 1261750 */   GIM_Try, /*On fail goto*//*Label 18180*/ GIMT_Encode4(1261834), // Rule ID 8233 //
     /* 1261755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1261766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1261769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1261772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1261775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1261778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261808 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1261811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1261829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261833 */     // GIR_Coverage, 8233,
     /* 1261833 */     GIR_EraseRootFromParent_Done,
     /* 1261834 */   // Label 18180: @1261834
     /* 1261834 */   GIM_Try, /*On fail goto*//*Label 18181*/ GIMT_Encode4(1261918), // Rule ID 8236 //
     /* 1261839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1261842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1261865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1261892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1261895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1261916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1261917 */     // GIR_Coverage, 8236,
     /* 1261917 */     GIR_EraseRootFromParent_Done,
     /* 1261918 */   // Label 18181: @1261918
     /* 1261918 */   GIM_Try, /*On fail goto*//*Label 18182*/ GIMT_Encode4(1262002), // Rule ID 8237 //
     /* 1261923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1261926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1261931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1261934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1261937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1261940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1261943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1261946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1261949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1261965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1261969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1261976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1261976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1261979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1261981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1261983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1261985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1261987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1261989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1261994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1261997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262001 */     // GIR_Coverage, 8237,
     /* 1262001 */     GIR_EraseRootFromParent_Done,
     /* 1262002 */   // Label 18182: @1262002
     /* 1262002 */   GIM_Try, /*On fail goto*//*Label 18183*/ GIMT_Encode4(1262086), // Rule ID 8240 //
     /* 1262007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1262024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1262027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262085 */     // GIR_Coverage, 8240,
     /* 1262085 */     GIR_EraseRootFromParent_Done,
     /* 1262086 */   // Label 18183: @1262086
     /* 1262086 */   GIM_Try, /*On fail goto*//*Label 18184*/ GIMT_Encode4(1262170), // Rule ID 8241 //
     /* 1262091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1262102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1262105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1262108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1262111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1262114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1262165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262169 */     // GIR_Coverage, 8241,
     /* 1262169 */     GIR_EraseRootFromParent_Done,
     /* 1262170 */   // Label 18184: @1262170
     /* 1262170 */   GIM_Try, /*On fail goto*//*Label 18185*/ GIMT_Encode4(1262254), // Rule ID 8244 //
     /* 1262175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1262192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1262195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262253 */     // GIR_Coverage, 8244,
     /* 1262253 */     GIR_EraseRootFromParent_Done,
     /* 1262254 */   // Label 18185: @1262254
     /* 1262254 */   GIM_Try, /*On fail goto*//*Label 18186*/ GIMT_Encode4(1262338), // Rule ID 8245 //
     /* 1262259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1262270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1262273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1262276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1262279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1262282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1262333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262337 */     // GIR_Coverage, 8245,
     /* 1262337 */     GIR_EraseRootFromParent_Done,
     /* 1262338 */   // Label 18186: @1262338
     /* 1262338 */   GIM_Try, /*On fail goto*//*Label 18187*/ GIMT_Encode4(1262422), // Rule ID 8248 //
     /* 1262343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1262346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262396 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262421 */     // GIR_Coverage, 8248,
     /* 1262421 */     GIR_EraseRootFromParent_Done,
     /* 1262422 */   // Label 18187: @1262422
     /* 1262422 */   GIM_Try, /*On fail goto*//*Label 18188*/ GIMT_Encode4(1262506), // Rule ID 8249 //
     /* 1262427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1262430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1262438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1262441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1262444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1262447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1262450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262480 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1262483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1262501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262505 */     // GIR_Coverage, 8249,
     /* 1262505 */     GIR_EraseRootFromParent_Done,
     /* 1262506 */   // Label 18188: @1262506
     /* 1262506 */   GIM_Try, /*On fail goto*//*Label 18189*/ GIMT_Encode4(1262590), // Rule ID 8252 //
     /* 1262511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262564 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1262567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262589 */     // GIR_Coverage, 8252,
     /* 1262589 */     GIR_EraseRootFromParent_Done,
     /* 1262590 */   // Label 18189: @1262590
     /* 1262590 */   GIM_Try, /*On fail goto*//*Label 18190*/ GIMT_Encode4(1262674), // Rule ID 8253 //
     /* 1262595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1262606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1262609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1262612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1262615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1262618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1262637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262648 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1262651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262673 */     // GIR_Coverage, 8253,
     /* 1262673 */     GIR_EraseRootFromParent_Done,
     /* 1262674 */   // Label 18190: @1262674
     /* 1262674 */   GIM_Try, /*On fail goto*//*Label 18191*/ GIMT_Encode4(1262758), // Rule ID 8256 //
     /* 1262679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262732 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1262735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262757 */     // GIR_Coverage, 8256,
     /* 1262757 */     GIR_EraseRootFromParent_Done,
     /* 1262758 */   // Label 18191: @1262758
     /* 1262758 */   GIM_Try, /*On fail goto*//*Label 18192*/ GIMT_Encode4(1262842), // Rule ID 8257 //
     /* 1262763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1262774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1262777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1262780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1262783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1262786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1262805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262816 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1262819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262841 */     // GIR_Coverage, 8257,
     /* 1262841 */     GIR_EraseRootFromParent_Done,
     /* 1262842 */   // Label 18192: @1262842
     /* 1262842 */   GIM_Try, /*On fail goto*//*Label 18193*/ GIMT_Encode4(1262926), // Rule ID 8260 //
     /* 1262847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1262850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1262873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262900 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1262900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1262903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1262918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1262921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1262924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1262925 */     // GIR_Coverage, 8260,
     /* 1262925 */     GIR_EraseRootFromParent_Done,
     /* 1262926 */   // Label 18193: @1262926
     /* 1262926 */   GIM_Try, /*On fail goto*//*Label 18194*/ GIMT_Encode4(1263010), // Rule ID 8261 //
     /* 1262931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1262934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1262939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1262942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1262945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1262948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1262951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1262954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1262957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1262965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1262973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1262977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1262984 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1262984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1262987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1262989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1262991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1262993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1262995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1262997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1263005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263009 */     // GIR_Coverage, 8261,
     /* 1263009 */     GIR_EraseRootFromParent_Done,
     /* 1263010 */   // Label 18194: @1263010
     /* 1263010 */   GIM_Try, /*On fail goto*//*Label 18195*/ GIMT_Encode4(1263094), // Rule ID 8264 //
     /* 1263015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1263032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1263035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1263071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263093 */     // GIR_Coverage, 8264,
     /* 1263093 */     GIR_EraseRootFromParent_Done,
     /* 1263094 */   // Label 18195: @1263094
     /* 1263094 */   GIM_Try, /*On fail goto*//*Label 18196*/ GIMT_Encode4(1263178), // Rule ID 8265 //
     /* 1263099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1263116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1263119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1263155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263177 */     // GIR_Coverage, 8265,
     /* 1263177 */     GIR_EraseRootFromParent_Done,
     /* 1263178 */   // Label 18196: @1263178
     /* 1263178 */   GIM_Try, /*On fail goto*//*Label 18197*/ GIMT_Encode4(1263262), // Rule ID 8268 //
     /* 1263183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1263200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1263203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1263239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263261 */     // GIR_Coverage, 8268,
     /* 1263261 */     GIR_EraseRootFromParent_Done,
     /* 1263262 */   // Label 18197: @1263262
     /* 1263262 */   GIM_Try, /*On fail goto*//*Label 18198*/ GIMT_Encode4(1263346), // Rule ID 8269 //
     /* 1263267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1263284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1263287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1263323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263345 */     // GIR_Coverage, 8269,
     /* 1263345 */     GIR_EraseRootFromParent_Done,
     /* 1263346 */   // Label 18198: @1263346
     /* 1263346 */   GIM_Try, /*On fail goto*//*Label 18199*/ GIMT_Encode4(1263430), // Rule ID 8272 //
     /* 1263351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263404 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1263407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263429 */     // GIR_Coverage, 8272,
     /* 1263429 */     GIR_EraseRootFromParent_Done,
     /* 1263430 */   // Label 18199: @1263430
     /* 1263430 */   GIM_Try, /*On fail goto*//*Label 18200*/ GIMT_Encode4(1263514), // Rule ID 8273 //
     /* 1263435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1263446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1263449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1263452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1263455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1263458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263488 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1263491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1263509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263513 */     // GIR_Coverage, 8273,
     /* 1263513 */     GIR_EraseRootFromParent_Done,
     /* 1263514 */   // Label 18200: @1263514
     /* 1263514 */   GIM_Try, /*On fail goto*//*Label 18201*/ GIMT_Encode4(1263598), // Rule ID 8276 //
     /* 1263519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263572 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1263575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263597 */     // GIR_Coverage, 8276,
     /* 1263597 */     GIR_EraseRootFromParent_Done,
     /* 1263598 */   // Label 18201: @1263598
     /* 1263598 */   GIM_Try, /*On fail goto*//*Label 18202*/ GIMT_Encode4(1263682), // Rule ID 8277 //
     /* 1263603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1263614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1263617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1263620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1263623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1263626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1263645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1263659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263681 */     // GIR_Coverage, 8277,
     /* 1263681 */     GIR_EraseRootFromParent_Done,
     /* 1263682 */   // Label 18202: @1263682
     /* 1263682 */   GIM_Try, /*On fail goto*//*Label 18203*/ GIMT_Encode4(1263766), // Rule ID 8280 //
     /* 1263687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263740 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1263743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263765 */     // GIR_Coverage, 8280,
     /* 1263765 */     GIR_EraseRootFromParent_Done,
     /* 1263766 */   // Label 18203: @1263766
     /* 1263766 */   GIM_Try, /*On fail goto*//*Label 18204*/ GIMT_Encode4(1263850), // Rule ID 8281 //
     /* 1263771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1263782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1263785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1263788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1263791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1263794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1263813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263824 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1263827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263849 */     // GIR_Coverage, 8281,
     /* 1263849 */     GIR_EraseRootFromParent_Done,
     /* 1263850 */   // Label 18204: @1263850
     /* 1263850 */   GIM_Try, /*On fail goto*//*Label 18205*/ GIMT_Encode4(1263934), // Rule ID 8284 //
     /* 1263855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1263858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1263881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263908 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1263908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1263911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1263917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1263919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1263921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1263926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1263929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1263932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1263933 */     // GIR_Coverage, 8284,
     /* 1263933 */     GIR_EraseRootFromParent_Done,
     /* 1263934 */   // Label 18205: @1263934
     /* 1263934 */   GIM_Try, /*On fail goto*//*Label 18206*/ GIMT_Encode4(1264018), // Rule ID 8285 //
     /* 1263939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1263942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1263947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1263950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1263953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1263956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1263959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1263962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1263965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1263973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1263981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1263985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1263992 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1263992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1263995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1263997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1263999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1264013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264017 */     // GIR_Coverage, 8285,
     /* 1264017 */     GIR_EraseRootFromParent_Done,
     /* 1264018 */   // Label 18206: @1264018
     /* 1264018 */   GIM_Try, /*On fail goto*//*Label 18207*/ GIMT_Encode4(1264102), // Rule ID 8288 //
     /* 1264023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1264040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1264043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1264079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264101 */     // GIR_Coverage, 8288,
     /* 1264101 */     GIR_EraseRootFromParent_Done,
     /* 1264102 */   // Label 18207: @1264102
     /* 1264102 */   GIM_Try, /*On fail goto*//*Label 18208*/ GIMT_Encode4(1264186), // Rule ID 8289 //
     /* 1264107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1264124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1264127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1264149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264160 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1264163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264185 */     // GIR_Coverage, 8289,
     /* 1264185 */     GIR_EraseRootFromParent_Done,
     /* 1264186 */   // Label 18208: @1264186
     /* 1264186 */   GIM_Try, /*On fail goto*//*Label 18209*/ GIMT_Encode4(1264270), // Rule ID 8292 //
     /* 1264191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1264208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1264211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1264247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264269 */     // GIR_Coverage, 8292,
     /* 1264269 */     GIR_EraseRootFromParent_Done,
     /* 1264270 */   // Label 18209: @1264270
     /* 1264270 */   GIM_Try, /*On fail goto*//*Label 18210*/ GIMT_Encode4(1264354), // Rule ID 8293 //
     /* 1264275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1264292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1264295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1264317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1264331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264353 */     // GIR_Coverage, 8293,
     /* 1264353 */     GIR_EraseRootFromParent_Done,
     /* 1264354 */   // Label 18210: @1264354
     /* 1264354 */   GIM_Try, /*On fail goto*//*Label 18211*/ GIMT_Encode4(1264438), // Rule ID 8296 //
     /* 1264359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1264362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1264415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264437 */     // GIR_Coverage, 8296,
     /* 1264437 */     GIR_EraseRootFromParent_Done,
     /* 1264438 */   // Label 18211: @1264438
     /* 1264438 */   GIM_Try, /*On fail goto*//*Label 18212*/ GIMT_Encode4(1264522), // Rule ID 8297 //
     /* 1264443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1264446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1264454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1264457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1264460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1264463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1264466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1264485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264496 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1264499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1264517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264521 */     // GIR_Coverage, 8297,
     /* 1264521 */     GIR_EraseRootFromParent_Done,
     /* 1264522 */   // Label 18212: @1264522
     /* 1264522 */   GIM_Try, /*On fail goto*//*Label 18213*/ GIMT_Encode4(1264606), // Rule ID 8300 //
     /* 1264527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1264583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264605 */     // GIR_Coverage, 8300,
     /* 1264605 */     GIR_EraseRootFromParent_Done,
     /* 1264606 */   // Label 18213: @1264606
     /* 1264606 */   GIM_Try, /*On fail goto*//*Label 18214*/ GIMT_Encode4(1264690), // Rule ID 8301 //
     /* 1264611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1264622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1264625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1264628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1264634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF8_MASK),
     /* 1264667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264689 */     // GIR_Coverage, 8301,
     /* 1264689 */     GIR_EraseRootFromParent_Done,
     /* 1264690 */   // Label 18214: @1264690
     /* 1264690 */   GIM_Try, /*On fail goto*//*Label 18215*/ GIMT_Encode4(1264774), // Rule ID 8304 //
     /* 1264695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264748 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1264751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264773 */     // GIR_Coverage, 8304,
     /* 1264773 */     GIR_EraseRootFromParent_Done,
     /* 1264774 */   // Label 18215: @1264774
     /* 1264774 */   GIM_Try, /*On fail goto*//*Label 18216*/ GIMT_Encode4(1264858), // Rule ID 8305 //
     /* 1264779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1264790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1264793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1264796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1264802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264832 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1264832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1264835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264857 */     // GIR_Coverage, 8305,
     /* 1264857 */     GIR_EraseRootFromParent_Done,
     /* 1264858 */   // Label 18216: @1264858
     /* 1264858 */   GIM_Try, /*On fail goto*//*Label 18217*/ GIMT_Encode4(1264942), // Rule ID 8308 //
     /* 1264863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1264866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1264883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1264889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1264916 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1264916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1264919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1264921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1264923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1264925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1264927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1264929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1264934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1264937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1264940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1264941 */     // GIR_Coverage, 8308,
     /* 1264941 */     GIR_EraseRootFromParent_Done,
     /* 1264942 */   // Label 18217: @1264942
     /* 1264942 */   GIM_Try, /*On fail goto*//*Label 18218*/ GIMT_Encode4(1265026), // Rule ID 8309 //
     /* 1264947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1264950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1264955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1264958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1264961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1264964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1264967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1264970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1264973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1264985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1264989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1264993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265000 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1265003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265025 */     // GIR_Coverage, 8309,
     /* 1265025 */     GIR_EraseRootFromParent_Done,
     /* 1265026 */   // Label 18218: @1265026
     /* 1265026 */   GIM_Try, /*On fail goto*//*Label 18219*/ GIMT_Encode4(1265110), // Rule ID 8312 //
     /* 1265031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1265048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1265087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265109 */     // GIR_Coverage, 8312,
     /* 1265109 */     GIR_EraseRootFromParent_Done,
     /* 1265110 */   // Label 18219: @1265110
     /* 1265110 */   GIM_Try, /*On fail goto*//*Label 18220*/ GIMT_Encode4(1265194), // Rule ID 8313 //
     /* 1265115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1265132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF4_MASK),
     /* 1265171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265193 */     // GIR_Coverage, 8313,
     /* 1265193 */     GIR_EraseRootFromParent_Done,
     /* 1265194 */   // Label 18220: @1265194
     /* 1265194 */   GIM_Try, /*On fail goto*//*Label 18221*/ GIMT_Encode4(1265278), // Rule ID 8316 //
     /* 1265199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1265216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1265255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265277 */     // GIR_Coverage, 8316,
     /* 1265277 */     GIR_EraseRootFromParent_Done,
     /* 1265278 */   // Label 18221: @1265278
     /* 1265278 */   GIM_Try, /*On fail goto*//*Label 18222*/ GIMT_Encode4(1265362), // Rule ID 8317 //
     /* 1265283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1265300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1265339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265361 */     // GIR_Coverage, 8317,
     /* 1265361 */     GIR_EraseRootFromParent_Done,
     /* 1265362 */   // Label 18222: @1265362
     /* 1265362 */   GIM_Try, /*On fail goto*//*Label 18223*/ GIMT_Encode4(1265446), // Rule ID 8320 //
     /* 1265367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265420 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1265423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265445 */     // GIR_Coverage, 8320,
     /* 1265445 */     GIR_EraseRootFromParent_Done,
     /* 1265446 */   // Label 18223: @1265446
     /* 1265446 */   GIM_Try, /*On fail goto*//*Label 18224*/ GIMT_Encode4(1265530), // Rule ID 8321 //
     /* 1265451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1265462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1265465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1265468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1265474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265504 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_MF2_MASK),
     /* 1265507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265529 */     // GIR_Coverage, 8321,
     /* 1265529 */     GIR_EraseRootFromParent_Done,
     /* 1265530 */   // Label 18224: @1265530
     /* 1265530 */   GIM_Try, /*On fail goto*//*Label 18225*/ GIMT_Encode4(1265614), // Rule ID 8324 //
     /* 1265535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1265591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265613 */     // GIR_Coverage, 8324,
     /* 1265613 */     GIR_EraseRootFromParent_Done,
     /* 1265614 */   // Label 18225: @1265614
     /* 1265614 */   GIM_Try, /*On fail goto*//*Label 18226*/ GIMT_Encode4(1265698), // Rule ID 8325 //
     /* 1265619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1265630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1265633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1265636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1265642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1265675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1265693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265697 */     // GIR_Coverage, 8325,
     /* 1265697 */     GIR_EraseRootFromParent_Done,
     /* 1265698 */   // Label 18226: @1265698
     /* 1265698 */   GIM_Try, /*On fail goto*//*Label 18227*/ GIMT_Encode4(1265782), // Rule ID 8328 //
     /* 1265703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1265759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265781 */     // GIR_Coverage, 8328,
     /* 1265781 */     GIR_EraseRootFromParent_Done,
     /* 1265782 */   // Label 18227: @1265782
     /* 1265782 */   GIM_Try, /*On fail goto*//*Label 18228*/ GIMT_Encode4(1265866), // Rule ID 8329 //
     /* 1265787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1265798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1265801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1265804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1265810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1265840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1265843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1265861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265865 */     // GIR_Coverage, 8329,
     /* 1265865 */     GIR_EraseRootFromParent_Done,
     /* 1265866 */   // Label 18228: @1265866
     /* 1265866 */   GIM_Try, /*On fail goto*//*Label 18229*/ GIMT_Encode4(1265950), // Rule ID 8332 //
     /* 1265871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1265874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1265891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1265897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1265917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1265924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1265924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1265927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1265929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1265931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1265933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1265935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1265937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1265942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1265945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1265948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1265949 */     // GIR_Coverage, 8332,
     /* 1265949 */     GIR_EraseRootFromParent_Done,
     /* 1265950 */   // Label 18229: @1265950
     /* 1265950 */   GIM_Try, /*On fail goto*//*Label 18230*/ GIMT_Encode4(1266034), // Rule ID 8333 //
     /* 1265955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1265958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1265963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1265966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1265969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1265972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1265975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1265978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1265981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1265993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1265997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1266011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1266029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266033 */     // GIR_Coverage, 8333,
     /* 1266033 */     GIR_EraseRootFromParent_Done,
     /* 1266034 */   // Label 18230: @1266034
     /* 1266034 */   GIM_Try, /*On fail goto*//*Label 18231*/ GIMT_Encode4(1266118), // Rule ID 8336 //
     /* 1266039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1266042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1266056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266092 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1266095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266117 */     // GIR_Coverage, 8336,
     /* 1266117 */     GIR_EraseRootFromParent_Done,
     /* 1266118 */   // Label 18231: @1266118
     /* 1266118 */   GIM_Try, /*On fail goto*//*Label 18232*/ GIMT_Encode4(1266202), // Rule ID 8337 //
     /* 1266123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1266126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1266134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1266137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1266140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1266146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266176 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M1_MASK),
     /* 1266179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1266197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266201 */     // GIR_Coverage, 8337,
     /* 1266201 */     GIR_EraseRootFromParent_Done,
     /* 1266202 */   // Label 18232: @1266202
     /* 1266202 */   GIM_Try, /*On fail goto*//*Label 18233*/ GIMT_Encode4(1266286), // Rule ID 8340 //
     /* 1266207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1266224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266260 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1266263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266285 */     // GIR_Coverage, 8340,
     /* 1266285 */     GIR_EraseRootFromParent_Done,
     /* 1266286 */   // Label 18233: @1266286
     /* 1266286 */   GIM_Try, /*On fail goto*//*Label 18234*/ GIMT_Encode4(1266370), // Rule ID 8341 //
     /* 1266291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1266308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266344 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1266347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266369 */     // GIR_Coverage, 8341,
     /* 1266369 */     GIR_EraseRootFromParent_Done,
     /* 1266370 */   // Label 18234: @1266370
     /* 1266370 */   GIM_Try, /*On fail goto*//*Label 18235*/ GIMT_Encode4(1266454), // Rule ID 8344 //
     /* 1266375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266428 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1266431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266453 */     // GIR_Coverage, 8344,
     /* 1266453 */     GIR_EraseRootFromParent_Done,
     /* 1266454 */   // Label 18235: @1266454
     /* 1266454 */   GIM_Try, /*On fail goto*//*Label 18236*/ GIMT_Encode4(1266538), // Rule ID 8345 //
     /* 1266459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1266470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1266473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1266476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1266482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266512 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1266515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266537 */     // GIR_Coverage, 8345,
     /* 1266537 */     GIR_EraseRootFromParent_Done,
     /* 1266538 */   // Label 18236: @1266538
     /* 1266538 */   GIM_Try, /*On fail goto*//*Label 18237*/ GIMT_Encode4(1266622), // Rule ID 8348 //
     /* 1266543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266596 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1266599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266621 */     // GIR_Coverage, 8348,
     /* 1266621 */     GIR_EraseRootFromParent_Done,
     /* 1266622 */   // Label 18237: @1266622
     /* 1266622 */   GIM_Try, /*On fail goto*//*Label 18238*/ GIMT_Encode4(1266706), // Rule ID 8349 //
     /* 1266627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1266638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1266641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1266644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1266650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1266665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266680 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1266683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1266701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266705 */     // GIR_Coverage, 8349,
     /* 1266705 */     GIR_EraseRootFromParent_Done,
     /* 1266706 */   // Label 18238: @1266706
     /* 1266706 */   GIM_Try, /*On fail goto*//*Label 18239*/ GIMT_Encode4(1266790), // Rule ID 8352 //
     /* 1266711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1266767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266789 */     // GIR_Coverage, 8352,
     /* 1266789 */     GIR_EraseRootFromParent_Done,
     /* 1266790 */   // Label 18239: @1266790
     /* 1266790 */   GIM_Try, /*On fail goto*//*Label 18240*/ GIMT_Encode4(1266874), // Rule ID 8353 //
     /* 1266795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1266806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1266809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1266812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1266818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1266833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1266848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1266851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266873 */     // GIR_Coverage, 8353,
     /* 1266873 */     GIR_EraseRootFromParent_Done,
     /* 1266874 */   // Label 18240: @1266874
     /* 1266874 */   GIM_Try, /*On fail goto*//*Label 18241*/ GIMT_Encode4(1266958), // Rule ID 8356 //
     /* 1266879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1266882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1266899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1266905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1266917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1266921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1266925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1266932 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1266932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1266935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1266937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1266939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1266941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1266943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1266945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1266950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1266953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1266956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1266957 */     // GIR_Coverage, 8356,
     /* 1266957 */     GIR_EraseRootFromParent_Done,
     /* 1266958 */   // Label 18241: @1266958
     /* 1266958 */   GIM_Try, /*On fail goto*//*Label 18242*/ GIMT_Encode4(1267042), // Rule ID 8357 //
     /* 1266963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1266966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1266971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1266974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1266977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1266980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1266983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1266986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1266989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1266997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267016 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1267019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267041 */     // GIR_Coverage, 8357,
     /* 1267041 */     GIR_EraseRootFromParent_Done,
     /* 1267042 */   // Label 18242: @1267042
     /* 1267042 */   GIM_Try, /*On fail goto*//*Label 18243*/ GIMT_Encode4(1267126), // Rule ID 8360 //
     /* 1267047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1267064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267100 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1267103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267125 */     // GIR_Coverage, 8360,
     /* 1267125 */     GIR_EraseRootFromParent_Done,
     /* 1267126 */   // Label 18243: @1267126
     /* 1267126 */   GIM_Try, /*On fail goto*//*Label 18244*/ GIMT_Encode4(1267210), // Rule ID 8361 //
     /* 1267131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1267142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1267145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1267148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1267154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267184 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1267187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1267205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267209 */     // GIR_Coverage, 8361,
     /* 1267209 */     GIR_EraseRootFromParent_Done,
     /* 1267210 */   // Label 18244: @1267210
     /* 1267210 */   GIM_Try, /*On fail goto*//*Label 18245*/ GIMT_Encode4(1267294), // Rule ID 8364 //
     /* 1267215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1267232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1267271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267293 */     // GIR_Coverage, 8364,
     /* 1267293 */     GIR_EraseRootFromParent_Done,
     /* 1267294 */   // Label 18245: @1267294
     /* 1267294 */   GIM_Try, /*On fail goto*//*Label 18246*/ GIMT_Encode4(1267378), // Rule ID 8365 //
     /* 1267299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1267316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267352 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1267355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267377 */     // GIR_Coverage, 8365,
     /* 1267377 */     GIR_EraseRootFromParent_Done,
     /* 1267378 */   // Label 18246: @1267378
     /* 1267378 */   GIM_Try, /*On fail goto*//*Label 18247*/ GIMT_Encode4(1267462), // Rule ID 8368 //
     /* 1267383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267436 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1267439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267461 */     // GIR_Coverage, 8368,
     /* 1267461 */     GIR_EraseRootFromParent_Done,
     /* 1267462 */   // Label 18247: @1267462
     /* 1267462 */   GIM_Try, /*On fail goto*//*Label 18248*/ GIMT_Encode4(1267546), // Rule ID 8369 //
     /* 1267467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1267478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1267481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1267484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1267490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267520 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1267523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267545 */     // GIR_Coverage, 8369,
     /* 1267545 */     GIR_EraseRootFromParent_Done,
     /* 1267546 */   // Label 18248: @1267546
     /* 1267546 */   GIM_Try, /*On fail goto*//*Label 18249*/ GIMT_Encode4(1267630), // Rule ID 8372 //
     /* 1267551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1267554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1267607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267629 */     // GIR_Coverage, 8372,
     /* 1267629 */     GIR_EraseRootFromParent_Done,
     /* 1267630 */   // Label 18249: @1267630
     /* 1267630 */   GIM_Try, /*On fail goto*//*Label 18250*/ GIMT_Encode4(1267714), // Rule ID 8373 //
     /* 1267635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1267638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1267646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1267649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1267652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1267658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1267673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267688 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1267691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1267709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267713 */     // GIR_Coverage, 8373,
     /* 1267713 */     GIR_EraseRootFromParent_Done,
     /* 1267714 */   // Label 18250: @1267714
     /* 1267714 */   GIM_Try, /*On fail goto*//*Label 18251*/ GIMT_Encode4(1267798), // Rule ID 8376 //
     /* 1267719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267772 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1267775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267797 */     // GIR_Coverage, 8376,
     /* 1267797 */     GIR_EraseRootFromParent_Done,
     /* 1267798 */   // Label 18251: @1267798
     /* 1267798 */   GIM_Try, /*On fail goto*//*Label 18252*/ GIMT_Encode4(1267882), // Rule ID 8377 //
     /* 1267803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1267814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1267817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1267820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1267826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1267841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1267856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M2_MASK),
     /* 1267859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267881 */     // GIR_Coverage, 8377,
     /* 1267881 */     GIR_EraseRootFromParent_Done,
     /* 1267882 */   // Label 18252: @1267882
     /* 1267882 */   GIM_Try, /*On fail goto*//*Label 18253*/ GIMT_Encode4(1267966), // Rule ID 8380 //
     /* 1267887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1267890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1267907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1267913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1267921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1267925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1267929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1267933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1267940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1267940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1267943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1267945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1267947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1267949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1267951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1267953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1267958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1267961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1267964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1267965 */     // GIR_Coverage, 8380,
     /* 1267965 */     GIR_EraseRootFromParent_Done,
     /* 1267966 */   // Label 18253: @1267966
     /* 1267966 */   GIM_Try, /*On fail goto*//*Label 18254*/ GIMT_Encode4(1268050), // Rule ID 8381 //
     /* 1267971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1267974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1267979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1267982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1267985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1267988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1267991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1267994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1267997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1268009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M4_MASK),
     /* 1268027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268049 */     // GIR_Coverage, 8381,
     /* 1268049 */     GIR_EraseRootFromParent_Done,
     /* 1268050 */   // Label 18254: @1268050
     /* 1268050 */   GIM_Try, /*On fail goto*//*Label 18255*/ GIMT_Encode4(1268134), // Rule ID 8384 //
     /* 1268055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1268058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1268072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1268075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268108 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1268111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268133 */     // GIR_Coverage, 8384,
     /* 1268133 */     GIR_EraseRootFromParent_Done,
     /* 1268134 */   // Label 18255: @1268134
     /* 1268134 */   GIM_Try, /*On fail goto*//*Label 18256*/ GIMT_Encode4(1268218), // Rule ID 8385 //
     /* 1268139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1268142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsltu_mask),
     /* 1268147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1268150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1268153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1268156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1268159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1268162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1268177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1268181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268192 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11395:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VX_M8_MASK),
     /* 1268195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1268213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268217 */     // GIR_Coverage, 8385,
     /* 1268217 */     GIR_EraseRootFromParent_Done,
     /* 1268218 */   // Label 18256: @1268218
     /* 1268218 */   GIM_Try, /*On fail goto*//*Label 18257*/ GIMT_Encode4(1268302), // Rule ID 8388 //
     /* 1268223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1268240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1268243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1268279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268301 */     // GIR_Coverage, 8388,
     /* 1268301 */     GIR_EraseRootFromParent_Done,
     /* 1268302 */   // Label 18257: @1268302
     /* 1268302 */   GIM_Try, /*On fail goto*//*Label 18258*/ GIMT_Encode4(1268386), // Rule ID 8389 //
     /* 1268307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1268324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1268327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1268363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268385 */     // GIR_Coverage, 8389,
     /* 1268385 */     GIR_EraseRootFromParent_Done,
     /* 1268386 */   // Label 18258: @1268386
     /* 1268386 */   GIM_Try, /*On fail goto*//*Label 18259*/ GIMT_Encode4(1268470), // Rule ID 8392 //
     /* 1268391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268444 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1268447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268469 */     // GIR_Coverage, 8392,
     /* 1268469 */     GIR_EraseRootFromParent_Done,
     /* 1268470 */   // Label 18259: @1268470
     /* 1268470 */   GIM_Try, /*On fail goto*//*Label 18260*/ GIMT_Encode4(1268554), // Rule ID 8393 //
     /* 1268475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1268492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1268495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268528 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1268531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268553 */     // GIR_Coverage, 8393,
     /* 1268553 */     GIR_EraseRootFromParent_Done,
     /* 1268554 */   // Label 18260: @1268554
     /* 1268554 */   GIM_Try, /*On fail goto*//*Label 18261*/ GIMT_Encode4(1268638), // Rule ID 8396 //
     /* 1268559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1268615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268637 */     // GIR_Coverage, 8396,
     /* 1268637 */     GIR_EraseRootFromParent_Done,
     /* 1268638 */   // Label 18261: @1268638
     /* 1268638 */   GIM_Try, /*On fail goto*//*Label 18262*/ GIMT_Encode4(1268722), // Rule ID 8397 //
     /* 1268643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1268654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1268657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1268660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1268663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1268666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1268699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1268717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268721 */     // GIR_Coverage, 8397,
     /* 1268721 */     GIR_EraseRootFromParent_Done,
     /* 1268722 */   // Label 18262: @1268722
     /* 1268722 */   GIM_Try, /*On fail goto*//*Label 18263*/ GIMT_Encode4(1268806), // Rule ID 8400 //
     /* 1268727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268780 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1268783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268805 */     // GIR_Coverage, 8400,
     /* 1268805 */     GIR_EraseRootFromParent_Done,
     /* 1268806 */   // Label 18263: @1268806
     /* 1268806 */   GIM_Try, /*On fail goto*//*Label 18264*/ GIMT_Encode4(1268890), // Rule ID 8401 //
     /* 1268811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1268822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1268825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1268828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1268831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1268834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1268837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268864 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1268864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1268867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268889 */     // GIR_Coverage, 8401,
     /* 1268889 */     GIR_EraseRootFromParent_Done,
     /* 1268890 */   // Label 18264: @1268890
     /* 1268890 */   GIM_Try, /*On fail goto*//*Label 18265*/ GIMT_Encode4(1268974), // Rule ID 8404 //
     /* 1268895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1268898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1268918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1268921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1268937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1268941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1268948 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1268948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1268951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1268953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1268955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1268957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1268959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1268961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1268966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1268969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1268972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1268973 */     // GIR_Coverage, 8404,
     /* 1268973 */     GIR_EraseRootFromParent_Done,
     /* 1268974 */   // Label 18265: @1268974
     /* 1268974 */   GIM_Try, /*On fail goto*//*Label 18266*/ GIMT_Encode4(1269058), // Rule ID 8405 //
     /* 1268979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1268982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1268987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1268990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1268993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1268996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1268999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1269035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269057 */     // GIR_Coverage, 8405,
     /* 1269057 */     GIR_EraseRootFromParent_Done,
     /* 1269058 */   // Label 18266: @1269058
     /* 1269058 */   GIM_Try, /*On fail goto*//*Label 18267*/ GIMT_Encode4(1269142), // Rule ID 8408 //
     /* 1269063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1269080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1269083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269116 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1269119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269141 */     // GIR_Coverage, 8408,
     /* 1269141 */     GIR_EraseRootFromParent_Done,
     /* 1269142 */   // Label 18267: @1269142
     /* 1269142 */   GIM_Try, /*On fail goto*//*Label 18268*/ GIMT_Encode4(1269226), // Rule ID 8409 //
     /* 1269147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1269164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1269167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269200 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1269203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269225 */     // GIR_Coverage, 8409,
     /* 1269225 */     GIR_EraseRootFromParent_Done,
     /* 1269226 */   // Label 18268: @1269226
     /* 1269226 */   GIM_Try, /*On fail goto*//*Label 18269*/ GIMT_Encode4(1269310), // Rule ID 8412 //
     /* 1269231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269309 */     // GIR_Coverage, 8412,
     /* 1269309 */     GIR_EraseRootFromParent_Done,
     /* 1269310 */   // Label 18269: @1269310
     /* 1269310 */   GIM_Try, /*On fail goto*//*Label 18270*/ GIMT_Encode4(1269394), // Rule ID 8413 //
     /* 1269315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1269326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1269329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1269332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1269335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1269338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269393 */     // GIR_Coverage, 8413,
     /* 1269393 */     GIR_EraseRootFromParent_Done,
     /* 1269394 */   // Label 18270: @1269394
     /* 1269394 */   GIM_Try, /*On fail goto*//*Label 18271*/ GIMT_Encode4(1269478), // Rule ID 8416 //
     /* 1269399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269477 */     // GIR_Coverage, 8416,
     /* 1269477 */     GIR_EraseRootFromParent_Done,
     /* 1269478 */   // Label 18271: @1269478
     /* 1269478 */   GIM_Try, /*On fail goto*//*Label 18272*/ GIMT_Encode4(1269562), // Rule ID 8417 //
     /* 1269483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1269494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1269497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1269500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1269503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1269506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1269557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269561 */     // GIR_Coverage, 8417,
     /* 1269561 */     GIR_EraseRootFromParent_Done,
     /* 1269562 */   // Label 18272: @1269562
     /* 1269562 */   GIM_Try, /*On fail goto*//*Label 18273*/ GIMT_Encode4(1269646), // Rule ID 8420 //
     /* 1269567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269645 */     // GIR_Coverage, 8420,
     /* 1269645 */     GIR_EraseRootFromParent_Done,
     /* 1269646 */   // Label 18273: @1269646
     /* 1269646 */   GIM_Try, /*On fail goto*//*Label 18274*/ GIMT_Encode4(1269730), // Rule ID 8421 //
     /* 1269651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1269662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1269665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1269668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1269671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1269674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1269725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269729 */     // GIR_Coverage, 8421,
     /* 1269729 */     GIR_EraseRootFromParent_Done,
     /* 1269730 */   // Label 18274: @1269730
     /* 1269730 */   GIM_Try, /*On fail goto*//*Label 18275*/ GIMT_Encode4(1269814), // Rule ID 8424 //
     /* 1269735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1269738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269813 */     // GIR_Coverage, 8424,
     /* 1269813 */     GIR_EraseRootFromParent_Done,
     /* 1269814 */   // Label 18275: @1269814
     /* 1269814 */   GIM_Try, /*On fail goto*//*Label 18276*/ GIMT_Encode4(1269898), // Rule ID 8425 //
     /* 1269819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1269822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1269830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1269833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1269836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1269839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1269842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1269845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1269872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1269875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1269893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269897 */     // GIR_Coverage, 8425,
     /* 1269897 */     GIR_EraseRootFromParent_Done,
     /* 1269898 */   // Label 18276: @1269898
     /* 1269898 */   GIM_Try, /*On fail goto*//*Label 18277*/ GIMT_Encode4(1269982), // Rule ID 8428 //
     /* 1269903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1269906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1269917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1269920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1269923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1269926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1269929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1269937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1269945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1269949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1269956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1269956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1269959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1269961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1269963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1269965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1269967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1269969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1269974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1269977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1269980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1269981 */     // GIR_Coverage, 8428,
     /* 1269981 */     GIR_EraseRootFromParent_Done,
     /* 1269982 */   // Label 18277: @1269982
     /* 1269982 */   GIM_Try, /*On fail goto*//*Label 18278*/ GIMT_Encode4(1270066), // Rule ID 8429 //
     /* 1269987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1269990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1269995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1269998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1270004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1270007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1270043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270065 */     // GIR_Coverage, 8429,
     /* 1270065 */     GIR_EraseRootFromParent_Done,
     /* 1270066 */   // Label 18278: @1270066
     /* 1270066 */   GIM_Try, /*On fail goto*//*Label 18279*/ GIMT_Encode4(1270150), // Rule ID 8432 //
     /* 1270071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1270088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1270091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270124 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1270127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270149 */     // GIR_Coverage, 8432,
     /* 1270149 */     GIR_EraseRootFromParent_Done,
     /* 1270150 */   // Label 18279: @1270150
     /* 1270150 */   GIM_Try, /*On fail goto*//*Label 18280*/ GIMT_Encode4(1270234), // Rule ID 8433 //
     /* 1270155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1270172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1270175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270208 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1270211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270233 */     // GIR_Coverage, 8433,
     /* 1270233 */     GIR_EraseRootFromParent_Done,
     /* 1270234 */   // Label 18280: @1270234
     /* 1270234 */   GIM_Try, /*On fail goto*//*Label 18281*/ GIMT_Encode4(1270318), // Rule ID 8436 //
     /* 1270239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1270250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1270253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1270259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270292 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1270295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270317 */     // GIR_Coverage, 8436,
     /* 1270317 */     GIR_EraseRootFromParent_Done,
     /* 1270318 */   // Label 18281: @1270318
     /* 1270318 */   GIM_Try, /*On fail goto*//*Label 18282*/ GIMT_Encode4(1270402), // Rule ID 8437 //
     /* 1270323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1270334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1270337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1270340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1270343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1270346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270376 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1270379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1270397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270401 */     // GIR_Coverage, 8437,
     /* 1270401 */     GIR_EraseRootFromParent_Done,
     /* 1270402 */   // Label 18282: @1270402
     /* 1270402 */   GIM_Try, /*On fail goto*//*Label 18283*/ GIMT_Encode4(1270486), // Rule ID 8440 //
     /* 1270407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1270463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270485 */     // GIR_Coverage, 8440,
     /* 1270485 */     GIR_EraseRootFromParent_Done,
     /* 1270486 */   // Label 18283: @1270486
     /* 1270486 */   GIM_Try, /*On fail goto*//*Label 18284*/ GIMT_Encode4(1270570), // Rule ID 8441 //
     /* 1270491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1270502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1270505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1270508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1270511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1270514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1270547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270569 */     // GIR_Coverage, 8441,
     /* 1270569 */     GIR_EraseRootFromParent_Done,
     /* 1270570 */   // Label 18284: @1270570
     /* 1270570 */   GIM_Try, /*On fail goto*//*Label 18285*/ GIMT_Encode4(1270654), // Rule ID 8444 //
     /* 1270575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270628 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1270631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270653 */     // GIR_Coverage, 8444,
     /* 1270653 */     GIR_EraseRootFromParent_Done,
     /* 1270654 */   // Label 18285: @1270654
     /* 1270654 */   GIM_Try, /*On fail goto*//*Label 18286*/ GIMT_Encode4(1270738), // Rule ID 8445 //
     /* 1270659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1270670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1270673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1270676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1270679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1270682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1270701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270712 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1270715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270737 */     // GIR_Coverage, 8445,
     /* 1270737 */     GIR_EraseRootFromParent_Done,
     /* 1270738 */   // Label 18286: @1270738
     /* 1270738 */   GIM_Try, /*On fail goto*//*Label 18287*/ GIMT_Encode4(1270822), // Rule ID 8448 //
     /* 1270743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270796 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1270799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270821 */     // GIR_Coverage, 8448,
     /* 1270821 */     GIR_EraseRootFromParent_Done,
     /* 1270822 */   // Label 18287: @1270822
     /* 1270822 */   GIM_Try, /*On fail goto*//*Label 18288*/ GIMT_Encode4(1270906), // Rule ID 8449 //
     /* 1270827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1270838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1270841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1270844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1270847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1270850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1270853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1270869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270880 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1270880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1270883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1270901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270905 */     // GIR_Coverage, 8449,
     /* 1270905 */     GIR_EraseRootFromParent_Done,
     /* 1270906 */   // Label 18288: @1270906
     /* 1270906 */   GIM_Try, /*On fail goto*//*Label 18289*/ GIMT_Encode4(1270990), // Rule ID 8452 //
     /* 1270911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1270914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1270919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1270922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1270925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1270928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1270931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1270934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1270937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1270945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1270953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1270957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1270964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1270964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1270967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1270969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1270971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1270973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1270975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1270977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1270982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1270985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1270988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1270989 */     // GIR_Coverage, 8452,
     /* 1270989 */     GIR_EraseRootFromParent_Done,
     /* 1270990 */   // Label 18289: @1270990
     /* 1270990 */   GIM_Try, /*On fail goto*//*Label 18290*/ GIMT_Encode4(1271074), // Rule ID 8453 //
     /* 1270995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1270998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1271012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1271015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271048 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1271051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271073 */     // GIR_Coverage, 8453,
     /* 1271073 */     GIR_EraseRootFromParent_Done,
     /* 1271074 */   // Label 18290: @1271074
     /* 1271074 */   GIM_Try, /*On fail goto*//*Label 18291*/ GIMT_Encode4(1271158), // Rule ID 8456 //
     /* 1271079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1271096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1271099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271132 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1271135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271157 */     // GIR_Coverage, 8456,
     /* 1271157 */     GIR_EraseRootFromParent_Done,
     /* 1271158 */   // Label 18291: @1271158
     /* 1271158 */   GIM_Try, /*On fail goto*//*Label 18292*/ GIMT_Encode4(1271242), // Rule ID 8457 //
     /* 1271163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1271180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1271183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271216 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1271219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271241 */     // GIR_Coverage, 8457,
     /* 1271241 */     GIR_EraseRootFromParent_Done,
     /* 1271242 */   // Label 18292: @1271242
     /* 1271242 */   GIM_Try, /*On fail goto*//*Label 18293*/ GIMT_Encode4(1271326), // Rule ID 8460 //
     /* 1271247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1271267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271300 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1271303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271325 */     // GIR_Coverage, 8460,
     /* 1271325 */     GIR_EraseRootFromParent_Done,
     /* 1271326 */   // Label 18293: @1271326
     /* 1271326 */   GIM_Try, /*On fail goto*//*Label 18294*/ GIMT_Encode4(1271410), // Rule ID 8461 //
     /* 1271331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1271334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1271342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1271345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1271348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1271351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1271354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271384 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1271387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1271405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271409 */     // GIR_Coverage, 8461,
     /* 1271409 */     GIR_EraseRootFromParent_Done,
     /* 1271410 */   // Label 18294: @1271410
     /* 1271410 */   GIM_Try, /*On fail goto*//*Label 18295*/ GIMT_Encode4(1271494), // Rule ID 8464 //
     /* 1271415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271468 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1271471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271493 */     // GIR_Coverage, 8464,
     /* 1271493 */     GIR_EraseRootFromParent_Done,
     /* 1271494 */   // Label 18295: @1271494
     /* 1271494 */   GIM_Try, /*On fail goto*//*Label 18296*/ GIMT_Encode4(1271578), // Rule ID 8465 //
     /* 1271499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1271510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1271513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1271516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1271519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1271522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1271541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271552 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1271555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271577 */     // GIR_Coverage, 8465,
     /* 1271577 */     GIR_EraseRootFromParent_Done,
     /* 1271578 */   // Label 18296: @1271578
     /* 1271578 */   GIM_Try, /*On fail goto*//*Label 18297*/ GIMT_Encode4(1271662), // Rule ID 8468 //
     /* 1271583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271636 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1271639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271661 */     // GIR_Coverage, 8468,
     /* 1271661 */     GIR_EraseRootFromParent_Done,
     /* 1271662 */   // Label 18297: @1271662
     /* 1271662 */   GIM_Try, /*On fail goto*//*Label 18298*/ GIMT_Encode4(1271746), // Rule ID 8469 //
     /* 1271667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1271678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1271681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1271684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1271687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1271690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1271709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271720 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1271723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271745 */     // GIR_Coverage, 8469,
     /* 1271745 */     GIR_EraseRootFromParent_Done,
     /* 1271746 */   // Label 18298: @1271746
     /* 1271746 */   GIM_Try, /*On fail goto*//*Label 18299*/ GIMT_Encode4(1271830), // Rule ID 8472 //
     /* 1271751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1271754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1271807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271829 */     // GIR_Coverage, 8472,
     /* 1271829 */     GIR_EraseRootFromParent_Done,
     /* 1271830 */   // Label 18299: @1271830
     /* 1271830 */   GIM_Try, /*On fail goto*//*Label 18300*/ GIMT_Encode4(1271914), // Rule ID 8473 //
     /* 1271835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1271838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1271846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1271849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1271852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1271855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1271858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1271861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1271877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271888 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1271888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1271891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1271909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271913 */     // GIR_Coverage, 8473,
     /* 1271913 */     GIR_EraseRootFromParent_Done,
     /* 1271914 */   // Label 18300: @1271914
     /* 1271914 */   GIM_Try, /*On fail goto*//*Label 18301*/ GIMT_Encode4(1271998), // Rule ID 8476 //
     /* 1271919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1271922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1271927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1271930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1271933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1271936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1271939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1271942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1271945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1271957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1271961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1271965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1271972 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1271972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1271975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1271977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1271979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1271981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1271983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1271985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1271990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1271993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1271996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1271997 */     // GIR_Coverage, 8476,
     /* 1271997 */     GIR_EraseRootFromParent_Done,
     /* 1271998 */   // Label 18301: @1271998
     /* 1271998 */   GIM_Try, /*On fail goto*//*Label 18302*/ GIMT_Encode4(1272082), // Rule ID 8477 //
     /* 1272003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1272020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272056 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF8_MASK),
     /* 1272059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272081 */     // GIR_Coverage, 8477,
     /* 1272081 */     GIR_EraseRootFromParent_Done,
     /* 1272082 */   // Label 18302: @1272082
     /* 1272082 */   GIM_Try, /*On fail goto*//*Label 18303*/ GIMT_Encode4(1272166), // Rule ID 8480 //
     /* 1272087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1272104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272140 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1272143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272165 */     // GIR_Coverage, 8480,
     /* 1272165 */     GIR_EraseRootFromParent_Done,
     /* 1272166 */   // Label 18303: @1272166
     /* 1272166 */   GIM_Try, /*On fail goto*//*Label 18304*/ GIMT_Encode4(1272250), // Rule ID 8481 //
     /* 1272171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1272188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272224 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1272227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272249 */     // GIR_Coverage, 8481,
     /* 1272249 */     GIR_EraseRootFromParent_Done,
     /* 1272250 */   // Label 18304: @1272250
     /* 1272250 */   GIM_Try, /*On fail goto*//*Label 18305*/ GIMT_Encode4(1272334), // Rule ID 8484 //
     /* 1272255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272308 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272333 */     // GIR_Coverage, 8484,
     /* 1272333 */     GIR_EraseRootFromParent_Done,
     /* 1272334 */   // Label 18305: @1272334
     /* 1272334 */   GIM_Try, /*On fail goto*//*Label 18306*/ GIMT_Encode4(1272418), // Rule ID 8485 //
     /* 1272339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1272350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1272353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1272356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1272362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272392 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1272413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272417 */     // GIR_Coverage, 8485,
     /* 1272417 */     GIR_EraseRootFromParent_Done,
     /* 1272418 */   // Label 18306: @1272418
     /* 1272418 */   GIM_Try, /*On fail goto*//*Label 18307*/ GIMT_Encode4(1272502), // Rule ID 8488 //
     /* 1272423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272476 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1272479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272501 */     // GIR_Coverage, 8488,
     /* 1272501 */     GIR_EraseRootFromParent_Done,
     /* 1272502 */   // Label 18307: @1272502
     /* 1272502 */   GIM_Try, /*On fail goto*//*Label 18308*/ GIMT_Encode4(1272586), // Rule ID 8489 //
     /* 1272507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1272524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272560 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF4_MASK),
     /* 1272563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272585 */     // GIR_Coverage, 8489,
     /* 1272585 */     GIR_EraseRootFromParent_Done,
     /* 1272586 */   // Label 18308: @1272586
     /* 1272586 */   GIM_Try, /*On fail goto*//*Label 18309*/ GIMT_Encode4(1272670), // Rule ID 8492 //
     /* 1272591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272669 */     // GIR_Coverage, 8492,
     /* 1272669 */     GIR_EraseRootFromParent_Done,
     /* 1272670 */   // Label 18309: @1272670
     /* 1272670 */   GIM_Try, /*On fail goto*//*Label 18310*/ GIMT_Encode4(1272754), // Rule ID 8493 //
     /* 1272675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1272686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1272689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1272692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1272698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1272749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272753 */     // GIR_Coverage, 8493,
     /* 1272753 */     GIR_EraseRootFromParent_Done,
     /* 1272754 */   // Label 18310: @1272754
     /* 1272754 */   GIM_Try, /*On fail goto*//*Label 18311*/ GIMT_Encode4(1272838), // Rule ID 8496 //
     /* 1272759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272812 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272837 */     // GIR_Coverage, 8496,
     /* 1272837 */     GIR_EraseRootFromParent_Done,
     /* 1272838 */   // Label 18311: @1272838
     /* 1272838 */   GIM_Try, /*On fail goto*//*Label 18312*/ GIMT_Encode4(1272922), // Rule ID 8497 //
     /* 1272843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1272846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1272854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1272857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1272860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1272863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1272866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1272869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272896 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1272896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_MF2_MASK),
     /* 1272899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1272917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1272920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1272921 */     // GIR_Coverage, 8497,
     /* 1272921 */     GIR_EraseRootFromParent_Done,
     /* 1272922 */   // Label 18312: @1272922
     /* 1272922 */   GIM_Try, /*On fail goto*//*Label 18313*/ GIMT_Encode4(1273006), // Rule ID 8500 //
     /* 1272927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1272930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1272935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1272938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1272941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1272944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1272947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1272950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1272953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1272965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1272969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1272973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1272980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1272980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1272983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1272985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1272987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1272989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1272991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1272993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1272998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273005 */     // GIR_Coverage, 8500,
     /* 1273005 */     GIR_EraseRootFromParent_Done,
     /* 1273006 */   // Label 18313: @1273006
     /* 1273006 */   GIM_Try, /*On fail goto*//*Label 18314*/ GIMT_Encode4(1273090), // Rule ID 8501 //
     /* 1273011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1273022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1273025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1273028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1273034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273089 */     // GIR_Coverage, 8501,
     /* 1273089 */     GIR_EraseRootFromParent_Done,
     /* 1273090 */   // Label 18314: @1273090
     /* 1273090 */   GIM_Try, /*On fail goto*//*Label 18315*/ GIMT_Encode4(1273174), // Rule ID 8504 //
     /* 1273095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1273112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273148 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273173 */     // GIR_Coverage, 8504,
     /* 1273173 */     GIR_EraseRootFromParent_Done,
     /* 1273174 */   // Label 18315: @1273174
     /* 1273174 */   GIM_Try, /*On fail goto*//*Label 18316*/ GIMT_Encode4(1273258), // Rule ID 8505 //
     /* 1273179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1273190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1273193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1273196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1273202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273232 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1273253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273257 */     // GIR_Coverage, 8505,
     /* 1273257 */     GIR_EraseRootFromParent_Done,
     /* 1273258 */   // Label 18316: @1273258
     /* 1273258 */   GIM_Try, /*On fail goto*//*Label 18317*/ GIMT_Encode4(1273342), // Rule ID 8508 //
     /* 1273263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273341 */     // GIR_Coverage, 8508,
     /* 1273341 */     GIR_EraseRootFromParent_Done,
     /* 1273342 */   // Label 18317: @1273342
     /* 1273342 */   GIM_Try, /*On fail goto*//*Label 18318*/ GIMT_Encode4(1273426), // Rule ID 8509 //
     /* 1273347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1273358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1273361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1273364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1273370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1273421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273425 */     // GIR_Coverage, 8509,
     /* 1273425 */     GIR_EraseRootFromParent_Done,
     /* 1273426 */   // Label 18318: @1273426
     /* 1273426 */   GIM_Try, /*On fail goto*//*Label 18319*/ GIMT_Encode4(1273510), // Rule ID 8512 //
     /* 1273431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1273434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273484 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273509 */     // GIR_Coverage, 8512,
     /* 1273509 */     GIR_EraseRootFromParent_Done,
     /* 1273510 */   // Label 18319: @1273510
     /* 1273510 */   GIM_Try, /*On fail goto*//*Label 18320*/ GIMT_Encode4(1273594), // Rule ID 8513 //
     /* 1273515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1273518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1273526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1273529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1273532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1273538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M1_MASK),
     /* 1273571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1273589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273593 */     // GIR_Coverage, 8513,
     /* 1273593 */     GIR_EraseRootFromParent_Done,
     /* 1273594 */   // Label 18320: @1273594
     /* 1273594 */   GIM_Try, /*On fail goto*//*Label 18321*/ GIMT_Encode4(1273678), // Rule ID 8516 //
     /* 1273599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273652 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1273655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273677 */     // GIR_Coverage, 8516,
     /* 1273677 */     GIR_EraseRootFromParent_Done,
     /* 1273678 */   // Label 18321: @1273678
     /* 1273678 */   GIM_Try, /*On fail goto*//*Label 18322*/ GIMT_Encode4(1273762), // Rule ID 8517 //
     /* 1273683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1273694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1273697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1273700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1273706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1273721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1273739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273761 */     // GIR_Coverage, 8517,
     /* 1273761 */     GIR_EraseRootFromParent_Done,
     /* 1273762 */   // Label 18322: @1273762
     /* 1273762 */   GIM_Try, /*On fail goto*//*Label 18323*/ GIMT_Encode4(1273846), // Rule ID 8520 //
     /* 1273767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273820 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1273823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273845 */     // GIR_Coverage, 8520,
     /* 1273845 */     GIR_EraseRootFromParent_Done,
     /* 1273846 */   // Label 18323: @1273846
     /* 1273846 */   GIM_Try, /*On fail goto*//*Label 18324*/ GIMT_Encode4(1273930), // Rule ID 8521 //
     /* 1273851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1273854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1273862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1273865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1273868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1273871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1273874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1273877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1273889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273904 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1273904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1273907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1273917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1273922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1273925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1273928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1273929 */     // GIR_Coverage, 8521,
     /* 1273929 */     GIR_EraseRootFromParent_Done,
     /* 1273930 */   // Label 18324: @1273930
     /* 1273930 */   GIM_Try, /*On fail goto*//*Label 18325*/ GIMT_Encode4(1274014), // Rule ID 8524 //
     /* 1273935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1273938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1273943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1273946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1273949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1273952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1273955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1273958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1273961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1273969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1273973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1273977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1273981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1273988 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1273988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1273991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1273993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1273995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1273997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1273999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274013 */     // GIR_Coverage, 8524,
     /* 1274013 */     GIR_EraseRootFromParent_Done,
     /* 1274014 */   // Label 18325: @1274014
     /* 1274014 */   GIM_Try, /*On fail goto*//*Label 18326*/ GIMT_Encode4(1274098), // Rule ID 8525 //
     /* 1274019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1274030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1274033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1274036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1274042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274072 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1274075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1274093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274097 */     // GIR_Coverage, 8525,
     /* 1274097 */     GIR_EraseRootFromParent_Done,
     /* 1274098 */   // Label 18326: @1274098
     /* 1274098 */   GIM_Try, /*On fail goto*//*Label 18327*/ GIMT_Encode4(1274182), // Rule ID 8528 //
     /* 1274103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1274120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1274159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274181 */     // GIR_Coverage, 8528,
     /* 1274181 */     GIR_EraseRootFromParent_Done,
     /* 1274182 */   // Label 18327: @1274182
     /* 1274182 */   GIM_Try, /*On fail goto*//*Label 18328*/ GIMT_Encode4(1274266), // Rule ID 8529 //
     /* 1274187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1274204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1274243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274265 */     // GIR_Coverage, 8529,
     /* 1274265 */     GIR_EraseRootFromParent_Done,
     /* 1274266 */   // Label 18328: @1274266
     /* 1274266 */   GIM_Try, /*On fail goto*//*Label 18329*/ GIMT_Encode4(1274350), // Rule ID 8532 //
     /* 1274271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1274327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274349 */     // GIR_Coverage, 8532,
     /* 1274349 */     GIR_EraseRootFromParent_Done,
     /* 1274350 */   // Label 18329: @1274350
     /* 1274350 */   GIM_Try, /*On fail goto*//*Label 18330*/ GIMT_Encode4(1274434), // Rule ID 8533 //
     /* 1274355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1274372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1274411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274433 */     // GIR_Coverage, 8533,
     /* 1274433 */     GIR_EraseRootFromParent_Done,
     /* 1274434 */   // Label 18330: @1274434
     /* 1274434 */   GIM_Try, /*On fail goto*//*Label 18331*/ GIMT_Encode4(1274518), // Rule ID 8536 //
     /* 1274439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1274495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274517 */     // GIR_Coverage, 8536,
     /* 1274517 */     GIR_EraseRootFromParent_Done,
     /* 1274518 */   // Label 18331: @1274518
     /* 1274518 */   GIM_Try, /*On fail goto*//*Label 18332*/ GIMT_Encode4(1274602), // Rule ID 8537 //
     /* 1274523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1274534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1274537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1274540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1274546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1274579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1274597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274601 */     // GIR_Coverage, 8537,
     /* 1274601 */     GIR_EraseRootFromParent_Done,
     /* 1274602 */   // Label 18332: @1274602
     /* 1274602 */   GIM_Try, /*On fail goto*//*Label 18333*/ GIMT_Encode4(1274686), // Rule ID 8540 //
     /* 1274607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1274663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274685 */     // GIR_Coverage, 8540,
     /* 1274685 */     GIR_EraseRootFromParent_Done,
     /* 1274686 */   // Label 18333: @1274686
     /* 1274686 */   GIM_Try, /*On fail goto*//*Label 18334*/ GIMT_Encode4(1274770), // Rule ID 8541 //
     /* 1274691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1274702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1274705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1274708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1274714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1274729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1274747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274769 */     // GIR_Coverage, 8541,
     /* 1274769 */     GIR_EraseRootFromParent_Done,
     /* 1274770 */   // Label 18334: @1274770
     /* 1274770 */   GIM_Try, /*On fail goto*//*Label 18335*/ GIMT_Encode4(1274854), // Rule ID 8544 //
     /* 1274775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1274831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274853 */     // GIR_Coverage, 8544,
     /* 1274853 */     GIR_EraseRootFromParent_Done,
     /* 1274854 */   // Label 18335: @1274854
     /* 1274854 */   GIM_Try, /*On fail goto*//*Label 18336*/ GIMT_Encode4(1274938), // Rule ID 8545 //
     /* 1274859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1274862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1274870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1274873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1274876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1274879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1274882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1274885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1274897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1274912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1274915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1274917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1274919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1274921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1274923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1274925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1274930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1274933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1274936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1274937 */     // GIR_Coverage, 8545,
     /* 1274937 */     GIR_EraseRootFromParent_Done,
     /* 1274938 */   // Label 18336: @1274938
     /* 1274938 */   GIM_Try, /*On fail goto*//*Label 18337*/ GIMT_Encode4(1275022), // Rule ID 8548 //
     /* 1274943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1274946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1274951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1274954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1274957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1274960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1274963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1274966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1274969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1274977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1274981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1274985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1274989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1274996 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1274996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1274999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275021 */     // GIR_Coverage, 8548,
     /* 1275021 */     GIR_EraseRootFromParent_Done,
     /* 1275022 */   // Label 18337: @1275022
     /* 1275022 */   GIM_Try, /*On fail goto*//*Label 18338*/ GIMT_Encode4(1275106), // Rule ID 8549 //
     /* 1275027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1275038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1275041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1275044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1275050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1275083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1275101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275105 */     // GIR_Coverage, 8549,
     /* 1275105 */     GIR_EraseRootFromParent_Done,
     /* 1275106 */   // Label 18338: @1275106
     /* 1275106 */   GIM_Try, /*On fail goto*//*Label 18339*/ GIMT_Encode4(1275190), // Rule ID 8552 //
     /* 1275111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1275128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1275167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275189 */     // GIR_Coverage, 8552,
     /* 1275189 */     GIR_EraseRootFromParent_Done,
     /* 1275190 */   // Label 18339: @1275190
     /* 1275190 */   GIM_Try, /*On fail goto*//*Label 18340*/ GIMT_Encode4(1275274), // Rule ID 8553 //
     /* 1275195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1275212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1275233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275248 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M2_MASK),
     /* 1275251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275273 */     // GIR_Coverage, 8553,
     /* 1275273 */     GIR_EraseRootFromParent_Done,
     /* 1275274 */   // Label 18340: @1275274
     /* 1275274 */   GIM_Try, /*On fail goto*//*Label 18341*/ GIMT_Encode4(1275358), // Rule ID 8556 //
     /* 1275279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1275335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275357 */     // GIR_Coverage, 8556,
     /* 1275357 */     GIR_EraseRootFromParent_Done,
     /* 1275358 */   // Label 18341: @1275358
     /* 1275358 */   GIM_Try, /*On fail goto*//*Label 18342*/ GIMT_Encode4(1275442), // Rule ID 8557 //
     /* 1275363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1275380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1275401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M4_MASK),
     /* 1275419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275441 */     // GIR_Coverage, 8557,
     /* 1275441 */     GIR_EraseRootFromParent_Done,
     /* 1275442 */   // Label 18342: @1275442
     /* 1275442 */   GIM_Try, /*On fail goto*//*Label 18343*/ GIMT_Encode4(1275526), // Rule ID 8560 //
     /* 1275447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1275450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1275467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1275503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275525 */     // GIR_Coverage, 8560,
     /* 1275525 */     GIR_EraseRootFromParent_Done,
     /* 1275526 */   // Label 18343: @1275526
     /* 1275526 */   GIM_Try, /*On fail goto*//*Label 18344*/ GIMT_Encode4(1275610), // Rule ID 8561 //
     /* 1275531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1275534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmslt_mask),
     /* 1275539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1275542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1275545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1275548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1275551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1275554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1275569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1275573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11393:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VX_M8_MASK),
     /* 1275587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1275605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275609 */     // GIR_Coverage, 8561,
     /* 1275609 */     GIR_EraseRootFromParent_Done,
     /* 1275610 */   // Label 18344: @1275610
     /* 1275610 */   GIM_Try, /*On fail goto*//*Label 18345*/ GIMT_Encode4(1275694), // Rule ID 8564 //
     /* 1275615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1275623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275668 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1275671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275693 */     // GIR_Coverage, 8564,
     /* 1275693 */     GIR_EraseRootFromParent_Done,
     /* 1275694 */   // Label 18345: @1275694
     /* 1275694 */   GIM_Try, /*On fail goto*//*Label 18346*/ GIMT_Encode4(1275778), // Rule ID 8565 //
     /* 1275699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1275707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1275710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1275713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1275716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1275719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1275722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1275755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275777 */     // GIR_Coverage, 8565,
     /* 1275777 */     GIR_EraseRootFromParent_Done,
     /* 1275778 */   // Label 18346: @1275778
     /* 1275778 */   GIM_Try, /*On fail goto*//*Label 18347*/ GIMT_Encode4(1275862), // Rule ID 8568 //
     /* 1275783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1275791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275836 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1275836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1275839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275861 */     // GIR_Coverage, 8568,
     /* 1275861 */     GIR_EraseRootFromParent_Done,
     /* 1275862 */   // Label 18347: @1275862
     /* 1275862 */   GIM_Try, /*On fail goto*//*Label 18348*/ GIMT_Encode4(1275946), // Rule ID 8569 //
     /* 1275867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1275870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1275875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1275878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1275881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1275884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1275887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1275890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1275893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1275920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1275920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1275923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1275925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1275927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1275929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1275931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1275933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1275938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1275941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1275944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1275945 */     // GIR_Coverage, 8569,
     /* 1275945 */     GIR_EraseRootFromParent_Done,
     /* 1275946 */   // Label 18348: @1275946
     /* 1275946 */   GIM_Try, /*On fail goto*//*Label 18349*/ GIMT_Encode4(1276030), // Rule ID 8572 //
     /* 1275951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1275954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1275959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1275962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1275965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1275968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1275971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1275974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1275977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1275993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1275997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276029 */     // GIR_Coverage, 8572,
     /* 1276029 */     GIR_EraseRootFromParent_Done,
     /* 1276030 */   // Label 18349: @1276030
     /* 1276030 */   GIM_Try, /*On fail goto*//*Label 18350*/ GIMT_Encode4(1276114), // Rule ID 8573 //
     /* 1276035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1276052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1276055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276088 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276113 */     // GIR_Coverage, 8573,
     /* 1276113 */     GIR_EraseRootFromParent_Done,
     /* 1276114 */   // Label 18350: @1276114
     /* 1276114 */   GIM_Try, /*On fail goto*//*Label 18351*/ GIMT_Encode4(1276198), // Rule ID 8576 //
     /* 1276119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1276136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1276139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276172 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1276175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276197 */     // GIR_Coverage, 8576,
     /* 1276197 */     GIR_EraseRootFromParent_Done,
     /* 1276198 */   // Label 18351: @1276198
     /* 1276198 */   GIM_Try, /*On fail goto*//*Label 18352*/ GIMT_Encode4(1276282), // Rule ID 8577 //
     /* 1276203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1276220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1276223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276256 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1276259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276281 */     // GIR_Coverage, 8577,
     /* 1276281 */     GIR_EraseRootFromParent_Done,
     /* 1276282 */   // Label 18352: @1276282
     /* 1276282 */   GIM_Try, /*On fail goto*//*Label 18353*/ GIMT_Encode4(1276366), // Rule ID 8580 //
     /* 1276287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1276307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276365 */     // GIR_Coverage, 8580,
     /* 1276365 */     GIR_EraseRootFromParent_Done,
     /* 1276366 */   // Label 18353: @1276366
     /* 1276366 */   GIM_Try, /*On fail goto*//*Label 18354*/ GIMT_Encode4(1276450), // Rule ID 8581 //
     /* 1276371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1276388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1276391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276449 */     // GIR_Coverage, 8581,
     /* 1276449 */     GIR_EraseRootFromParent_Done,
     /* 1276450 */   // Label 18354: @1276450
     /* 1276450 */   GIM_Try, /*On fail goto*//*Label 18355*/ GIMT_Encode4(1276534), // Rule ID 8584 //
     /* 1276455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276533 */     // GIR_Coverage, 8584,
     /* 1276533 */     GIR_EraseRootFromParent_Done,
     /* 1276534 */   // Label 18355: @1276534
     /* 1276534 */   GIM_Try, /*On fail goto*//*Label 18356*/ GIMT_Encode4(1276618), // Rule ID 8585 //
     /* 1276539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1276550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1276553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1276556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1276559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1276562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1276595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1276613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276617 */     // GIR_Coverage, 8585,
     /* 1276617 */     GIR_EraseRootFromParent_Done,
     /* 1276618 */   // Label 18356: @1276618
     /* 1276618 */   GIM_Try, /*On fail goto*//*Label 18357*/ GIMT_Encode4(1276702), // Rule ID 8588 //
     /* 1276623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1276679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276701 */     // GIR_Coverage, 8588,
     /* 1276701 */     GIR_EraseRootFromParent_Done,
     /* 1276702 */   // Label 18357: @1276702
     /* 1276702 */   GIM_Try, /*On fail goto*//*Label 18358*/ GIMT_Encode4(1276786), // Rule ID 8589 //
     /* 1276707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1276718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1276721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1276724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1276727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1276730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1276763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1276781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276785 */     // GIR_Coverage, 8589,
     /* 1276785 */     GIR_EraseRootFromParent_Done,
     /* 1276786 */   // Label 18358: @1276786
     /* 1276786 */   GIM_Try, /*On fail goto*//*Label 18359*/ GIMT_Encode4(1276870), // Rule ID 8592 //
     /* 1276791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1276844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1276847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276869 */     // GIR_Coverage, 8592,
     /* 1276869 */     GIR_EraseRootFromParent_Done,
     /* 1276870 */   // Label 18359: @1276870
     /* 1276870 */   GIM_Try, /*On fail goto*//*Label 18360*/ GIMT_Encode4(1276954), // Rule ID 8593 //
     /* 1276875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1276878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1276886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1276889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1276892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1276895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1276898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1276901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1276921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1276928 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1276928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1276931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1276933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1276935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1276937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1276939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1276941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1276946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1276949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1276952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1276953 */     // GIR_Coverage, 8593,
     /* 1276953 */     GIR_EraseRootFromParent_Done,
     /* 1276954 */   // Label 18360: @1276954
     /* 1276954 */   GIM_Try, /*On fail goto*//*Label 18361*/ GIMT_Encode4(1277038), // Rule ID 8596 //
     /* 1276959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1276962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1276967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1276970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1276973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1276976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1276979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1276982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1276985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1276997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277012 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1277015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277037 */     // GIR_Coverage, 8596,
     /* 1277037 */     GIR_EraseRootFromParent_Done,
     /* 1277038 */   // Label 18361: @1277038
     /* 1277038 */   GIM_Try, /*On fail goto*//*Label 18362*/ GIMT_Encode4(1277122), // Rule ID 8597 //
     /* 1277043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1277054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1277057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1277060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1277063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1277066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277096 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1277099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1277117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277121 */     // GIR_Coverage, 8597,
     /* 1277121 */     GIR_EraseRootFromParent_Done,
     /* 1277122 */   // Label 18362: @1277122
     /* 1277122 */   GIM_Try, /*On fail goto*//*Label 18363*/ GIMT_Encode4(1277206), // Rule ID 8600 //
     /* 1277127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1277130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1277144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1277147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1277183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1277201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277205 */     // GIR_Coverage, 8600,
     /* 1277205 */     GIR_EraseRootFromParent_Done,
     /* 1277206 */   // Label 18363: @1277206
     /* 1277206 */   GIM_Try, /*On fail goto*//*Label 18364*/ GIMT_Encode4(1277290), // Rule ID 8601 //
     /* 1277211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1277214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1277222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1277225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1277228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1277231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1277234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1277267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1277285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277289 */     // GIR_Coverage, 8601,
     /* 1277289 */     GIR_EraseRootFromParent_Done,
     /* 1277290 */   // Label 18364: @1277290
     /* 1277290 */   GIM_Try, /*On fail goto*//*Label 18365*/ GIMT_Encode4(1277374), // Rule ID 8604 //
     /* 1277295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1277315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277348 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1277351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277373 */     // GIR_Coverage, 8604,
     /* 1277373 */     GIR_EraseRootFromParent_Done,
     /* 1277374 */   // Label 18365: @1277374
     /* 1277374 */   GIM_Try, /*On fail goto*//*Label 18366*/ GIMT_Encode4(1277458), // Rule ID 8605 //
     /* 1277379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1277396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1277399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277432 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1277435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277457 */     // GIR_Coverage, 8605,
     /* 1277457 */     GIR_EraseRootFromParent_Done,
     /* 1277458 */   // Label 18366: @1277458
     /* 1277458 */   GIM_Try, /*On fail goto*//*Label 18367*/ GIMT_Encode4(1277542), // Rule ID 8608 //
     /* 1277463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277516 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1277519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277541 */     // GIR_Coverage, 8608,
     /* 1277541 */     GIR_EraseRootFromParent_Done,
     /* 1277542 */   // Label 18367: @1277542
     /* 1277542 */   GIM_Try, /*On fail goto*//*Label 18368*/ GIMT_Encode4(1277626), // Rule ID 8609 //
     /* 1277547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1277558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1277561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1277564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1277567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1277570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1277589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277600 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1277603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277625 */     // GIR_Coverage, 8609,
     /* 1277625 */     GIR_EraseRootFromParent_Done,
     /* 1277626 */   // Label 18368: @1277626
     /* 1277626 */   GIM_Try, /*On fail goto*//*Label 18369*/ GIMT_Encode4(1277710), // Rule ID 8612 //
     /* 1277631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277684 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1277687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277709 */     // GIR_Coverage, 8612,
     /* 1277709 */     GIR_EraseRootFromParent_Done,
     /* 1277710 */   // Label 18369: @1277710
     /* 1277710 */   GIM_Try, /*On fail goto*//*Label 18370*/ GIMT_Encode4(1277794), // Rule ID 8613 //
     /* 1277715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1277726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1277729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1277732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1277735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1277738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1277757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277768 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1277771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1277789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277793 */     // GIR_Coverage, 8613,
     /* 1277793 */     GIR_EraseRootFromParent_Done,
     /* 1277794 */   // Label 18370: @1277794
     /* 1277794 */   GIM_Try, /*On fail goto*//*Label 18371*/ GIMT_Encode4(1277878), // Rule ID 8616 //
     /* 1277799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277852 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1277852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1277855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277877 */     // GIR_Coverage, 8616,
     /* 1277877 */     GIR_EraseRootFromParent_Done,
     /* 1277878 */   // Label 18371: @1277878
     /* 1277878 */   GIM_Try, /*On fail goto*//*Label 18372*/ GIMT_Encode4(1277962), // Rule ID 8617 //
     /* 1277883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1277886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1277894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1277897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1277900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1277903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1277906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1277909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1277925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1277929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1277936 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1277936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1277939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1277941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1277943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1277945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1277947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1277949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1277954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1277957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1277960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1277961 */     // GIR_Coverage, 8617,
     /* 1277961 */     GIR_EraseRootFromParent_Done,
     /* 1277962 */   // Label 18372: @1277962
     /* 1277962 */   GIM_Try, /*On fail goto*//*Label 18373*/ GIMT_Encode4(1278046), // Rule ID 8620 //
     /* 1277967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1277970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1277975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1277978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1277981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1277984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1277987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1277990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1277993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1277997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278020 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1278023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278045 */     // GIR_Coverage, 8620,
     /* 1278045 */     GIR_EraseRootFromParent_Done,
     /* 1278046 */   // Label 18373: @1278046
     /* 1278046 */   GIM_Try, /*On fail goto*//*Label 18374*/ GIMT_Encode4(1278130), // Rule ID 8621 //
     /* 1278051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1278068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1278071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278104 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1278107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278129 */     // GIR_Coverage, 8621,
     /* 1278129 */     GIR_EraseRootFromParent_Done,
     /* 1278130 */   // Label 18374: @1278130
     /* 1278130 */   GIM_Try, /*On fail goto*//*Label 18375*/ GIMT_Encode4(1278214), // Rule ID 8624 //
     /* 1278135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1278152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1278155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278188 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1278191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278213 */     // GIR_Coverage, 8624,
     /* 1278213 */     GIR_EraseRootFromParent_Done,
     /* 1278214 */   // Label 18375: @1278214
     /* 1278214 */   GIM_Try, /*On fail goto*//*Label 18376*/ GIMT_Encode4(1278298), // Rule ID 8625 //
     /* 1278219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1278230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1278233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1278236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1278239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1278242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278272 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1278275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1278293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278297 */     // GIR_Coverage, 8625,
     /* 1278297 */     GIR_EraseRootFromParent_Done,
     /* 1278298 */   // Label 18376: @1278298
     /* 1278298 */   GIM_Try, /*On fail goto*//*Label 18377*/ GIMT_Encode4(1278382), // Rule ID 8628 //
     /* 1278303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1278323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278356 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1278359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278381 */     // GIR_Coverage, 8628,
     /* 1278381 */     GIR_EraseRootFromParent_Done,
     /* 1278382 */   // Label 18377: @1278382
     /* 1278382 */   GIM_Try, /*On fail goto*//*Label 18378*/ GIMT_Encode4(1278466), // Rule ID 8629 //
     /* 1278387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1278404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1278407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278440 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1278443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278465 */     // GIR_Coverage, 8629,
     /* 1278465 */     GIR_EraseRootFromParent_Done,
     /* 1278466 */   // Label 18378: @1278466
     /* 1278466 */   GIM_Try, /*On fail goto*//*Label 18379*/ GIMT_Encode4(1278550), // Rule ID 8632 //
     /* 1278471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278524 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1278527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278549 */     // GIR_Coverage, 8632,
     /* 1278549 */     GIR_EraseRootFromParent_Done,
     /* 1278550 */   // Label 18379: @1278550
     /* 1278550 */   GIM_Try, /*On fail goto*//*Label 18380*/ GIMT_Encode4(1278634), // Rule ID 8633 //
     /* 1278555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1278566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1278569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1278572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1278575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1278578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1278597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278608 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1278611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278633 */     // GIR_Coverage, 8633,
     /* 1278633 */     GIR_EraseRootFromParent_Done,
     /* 1278634 */   // Label 18380: @1278634
     /* 1278634 */   GIM_Try, /*On fail goto*//*Label 18381*/ GIMT_Encode4(1278718), // Rule ID 8636 //
     /* 1278639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1278642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278692 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1278695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278717 */     // GIR_Coverage, 8636,
     /* 1278717 */     GIR_EraseRootFromParent_Done,
     /* 1278718 */   // Label 18381: @1278718
     /* 1278718 */   GIM_Try, /*On fail goto*//*Label 18382*/ GIMT_Encode4(1278802), // Rule ID 8637 //
     /* 1278723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1278726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1278734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1278737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1278740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1278743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1278746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1278765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278776 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1278779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1278797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278801 */     // GIR_Coverage, 8637,
     /* 1278801 */     GIR_EraseRootFromParent_Done,
     /* 1278802 */   // Label 18382: @1278802
     /* 1278802 */   GIM_Try, /*On fail goto*//*Label 18383*/ GIMT_Encode4(1278886), // Rule ID 8640 //
     /* 1278807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1278833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1278860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1278863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278885 */     // GIR_Coverage, 8640,
     /* 1278885 */     GIR_EraseRootFromParent_Done,
     /* 1278886 */   // Label 18383: @1278886
     /* 1278886 */   GIM_Try, /*On fail goto*//*Label 18384*/ GIMT_Encode4(1278970), // Rule ID 8641 //
     /* 1278891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1278894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1278902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1278905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1278908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1278911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1278914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1278917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1278925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1278933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1278937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1278944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1278944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1278947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1278949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1278951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1278953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1278955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1278957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1278962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1278965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1278968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1278969 */     // GIR_Coverage, 8641,
     /* 1278969 */     GIR_EraseRootFromParent_Done,
     /* 1278970 */   // Label 18384: @1278970
     /* 1278970 */   GIM_Try, /*On fail goto*//*Label 18385*/ GIMT_Encode4(1279054), // Rule ID 8644 //
     /* 1278975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1278978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1278983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1278986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1278989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1278992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1278995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1278998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279028 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1279031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279053 */     // GIR_Coverage, 8644,
     /* 1279053 */     GIR_EraseRootFromParent_Done,
     /* 1279054 */   // Label 18385: @1279054
     /* 1279054 */   GIM_Try, /*On fail goto*//*Label 18386*/ GIMT_Encode4(1279138), // Rule ID 8645 //
     /* 1279059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1279062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1279076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1279079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1279101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279112 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1279115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279137 */     // GIR_Coverage, 8645,
     /* 1279137 */     GIR_EraseRootFromParent_Done,
     /* 1279138 */   // Label 18386: @1279138
     /* 1279138 */   GIM_Try, /*On fail goto*//*Label 18387*/ GIMT_Encode4(1279222), // Rule ID 8648 //
     /* 1279143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1279146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1279160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1279163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1279199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279221 */     // GIR_Coverage, 8648,
     /* 1279221 */     GIR_EraseRootFromParent_Done,
     /* 1279222 */   // Label 18387: @1279222
     /* 1279222 */   GIM_Try, /*On fail goto*//*Label 18388*/ GIMT_Encode4(1279306), // Rule ID 8649 //
     /* 1279227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1279230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1279238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1279241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1279244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1279247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1279250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1279269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1279283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1279301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279305 */     // GIR_Coverage, 8649,
     /* 1279305 */     GIR_EraseRootFromParent_Done,
     /* 1279306 */   // Label 18388: @1279306
     /* 1279306 */   GIM_Try, /*On fail goto*//*Label 18389*/ GIMT_Encode4(1279390), // Rule ID 8652 //
     /* 1279311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279364 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1279367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279389 */     // GIR_Coverage, 8652,
     /* 1279389 */     GIR_EraseRootFromParent_Done,
     /* 1279390 */   // Label 18389: @1279390
     /* 1279390 */   GIM_Try, /*On fail goto*//*Label 18390*/ GIMT_Encode4(1279474), // Rule ID 8653 //
     /* 1279395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1279412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279448 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF8_MASK),
     /* 1279451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279473 */     // GIR_Coverage, 8653,
     /* 1279473 */     GIR_EraseRootFromParent_Done,
     /* 1279474 */   // Label 18390: @1279474
     /* 1279474 */   GIM_Try, /*On fail goto*//*Label 18391*/ GIMT_Encode4(1279558), // Rule ID 8656 //
     /* 1279479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279532 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1279535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279557 */     // GIR_Coverage, 8656,
     /* 1279557 */     GIR_EraseRootFromParent_Done,
     /* 1279558 */   // Label 18391: @1279558
     /* 1279558 */   GIM_Try, /*On fail goto*//*Label 18392*/ GIMT_Encode4(1279642), // Rule ID 8657 //
     /* 1279563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1279580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1279586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279616 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1279619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279641 */     // GIR_Coverage, 8657,
     /* 1279641 */     GIR_EraseRootFromParent_Done,
     /* 1279642 */   // Label 18392: @1279642
     /* 1279642 */   GIM_Try, /*On fail goto*//*Label 18393*/ GIMT_Encode4(1279726), // Rule ID 8660 //
     /* 1279647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1279703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279725 */     // GIR_Coverage, 8660,
     /* 1279725 */     GIR_EraseRootFromParent_Done,
     /* 1279726 */   // Label 18393: @1279726
     /* 1279726 */   GIM_Try, /*On fail goto*//*Label 18394*/ GIMT_Encode4(1279810), // Rule ID 8661 //
     /* 1279731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1279742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1279745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1279748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1279754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1279787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1279805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279809 */     // GIR_Coverage, 8661,
     /* 1279809 */     GIR_EraseRootFromParent_Done,
     /* 1279810 */   // Label 18394: @1279810
     /* 1279810 */   GIM_Try, /*On fail goto*//*Label 18395*/ GIMT_Encode4(1279894), // Rule ID 8664 //
     /* 1279815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1279835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1279841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279868 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1279868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1279871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279893 */     // GIR_Coverage, 8664,
     /* 1279893 */     GIR_EraseRootFromParent_Done,
     /* 1279894 */   // Label 18395: @1279894
     /* 1279894 */   GIM_Try, /*On fail goto*//*Label 18396*/ GIMT_Encode4(1279978), // Rule ID 8665 //
     /* 1279899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1279902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1279910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1279913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1279916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1279919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1279922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1279925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1279937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1279941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1279945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1279952 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1279952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF4_MASK),
     /* 1279955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1279957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1279959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1279961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1279963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1279965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1279970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1279973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1279976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1279977 */     // GIR_Coverage, 8665,
     /* 1279977 */     GIR_EraseRootFromParent_Done,
     /* 1279978 */   // Label 18396: @1279978
     /* 1279978 */   GIM_Try, /*On fail goto*//*Label 18397*/ GIMT_Encode4(1280062), // Rule ID 8668 //
     /* 1279983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1279986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1279991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1279994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1279997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1280000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280036 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1280039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280061 */     // GIR_Coverage, 8668,
     /* 1280061 */     GIR_EraseRootFromParent_Done,
     /* 1280062 */   // Label 18397: @1280062
     /* 1280062 */   GIM_Try, /*On fail goto*//*Label 18398*/ GIMT_Encode4(1280146), // Rule ID 8669 //
     /* 1280067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1280084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280120 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1280123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280145 */     // GIR_Coverage, 8669,
     /* 1280145 */     GIR_EraseRootFromParent_Done,
     /* 1280146 */   // Label 18398: @1280146
     /* 1280146 */   GIM_Try, /*On fail goto*//*Label 18399*/ GIMT_Encode4(1280230), // Rule ID 8672 //
     /* 1280151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1280168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280204 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1280207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280229 */     // GIR_Coverage, 8672,
     /* 1280229 */     GIR_EraseRootFromParent_Done,
     /* 1280230 */   // Label 18399: @1280230
     /* 1280230 */   GIM_Try, /*On fail goto*//*Label 18400*/ GIMT_Encode4(1280314), // Rule ID 8673 //
     /* 1280235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1280252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280288 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_MF2_MASK),
     /* 1280291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280313 */     // GIR_Coverage, 8673,
     /* 1280313 */     GIR_EraseRootFromParent_Done,
     /* 1280314 */   // Label 18400: @1280314
     /* 1280314 */   GIM_Try, /*On fail goto*//*Label 18401*/ GIMT_Encode4(1280398), // Rule ID 8676 //
     /* 1280319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280372 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280397 */     // GIR_Coverage, 8676,
     /* 1280397 */     GIR_EraseRootFromParent_Done,
     /* 1280398 */   // Label 18401: @1280398
     /* 1280398 */   GIM_Try, /*On fail goto*//*Label 18402*/ GIMT_Encode4(1280482), // Rule ID 8677 //
     /* 1280403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1280414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1280417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1280420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1280426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280456 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1280477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280481 */     // GIR_Coverage, 8677,
     /* 1280481 */     GIR_EraseRootFromParent_Done,
     /* 1280482 */   // Label 18402: @1280482
     /* 1280482 */   GIM_Try, /*On fail goto*//*Label 18403*/ GIMT_Encode4(1280566), // Rule ID 8680 //
     /* 1280487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280540 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280565 */     // GIR_Coverage, 8680,
     /* 1280565 */     GIR_EraseRootFromParent_Done,
     /* 1280566 */   // Label 18403: @1280566
     /* 1280566 */   GIM_Try, /*On fail goto*//*Label 18404*/ GIMT_Encode4(1280650), // Rule ID 8681 //
     /* 1280571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1280582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1280585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1280588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1280594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280624 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1280645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280649 */     // GIR_Coverage, 8681,
     /* 1280649 */     GIR_EraseRootFromParent_Done,
     /* 1280650 */   // Label 18404: @1280650
     /* 1280650 */   GIM_Try, /*On fail goto*//*Label 18405*/ GIMT_Encode4(1280734), // Rule ID 8684 //
     /* 1280655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280708 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280733 */     // GIR_Coverage, 8684,
     /* 1280733 */     GIR_EraseRootFromParent_Done,
     /* 1280734 */   // Label 18405: @1280734
     /* 1280734 */   GIM_Try, /*On fail goto*//*Label 18406*/ GIMT_Encode4(1280818), // Rule ID 8685 //
     /* 1280739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1280742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1280750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1280753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1280756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1280762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280792 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1280813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280817 */     // GIR_Coverage, 8685,
     /* 1280817 */     GIR_EraseRootFromParent_Done,
     /* 1280818 */   // Label 18406: @1280818
     /* 1280818 */   GIM_Try, /*On fail goto*//*Label 18407*/ GIMT_Encode4(1280902), // Rule ID 8688 //
     /* 1280823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1280826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1280843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1280849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1280876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280901 */     // GIR_Coverage, 8688,
     /* 1280901 */     GIR_EraseRootFromParent_Done,
     /* 1280902 */   // Label 18407: @1280902
     /* 1280902 */   GIM_Try, /*On fail goto*//*Label 18408*/ GIMT_Encode4(1280986), // Rule ID 8689 //
     /* 1280907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1280910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1280918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1280921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1280924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1280927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1280930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1280933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1280945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1280949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1280953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1280960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1280960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M1_MASK),
     /* 1280963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1280965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1280967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1280969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1280971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1280973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1280978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1280981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1280984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1280985 */     // GIR_Coverage, 8689,
     /* 1280985 */     GIR_EraseRootFromParent_Done,
     /* 1280986 */   // Label 18408: @1280986
     /* 1280986 */   GIM_Try, /*On fail goto*//*Label 18409*/ GIMT_Encode4(1281070), // Rule ID 8692 //
     /* 1280991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1280994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1280999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1281008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1281047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281069 */     // GIR_Coverage, 8692,
     /* 1281069 */     GIR_EraseRootFromParent_Done,
     /* 1281070 */   // Label 18409: @1281070
     /* 1281070 */   GIM_Try, /*On fail goto*//*Label 18410*/ GIMT_Encode4(1281154), // Rule ID 8693 //
     /* 1281075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1281092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281128 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1281131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281153 */     // GIR_Coverage, 8693,
     /* 1281153 */     GIR_EraseRootFromParent_Done,
     /* 1281154 */   // Label 18410: @1281154
     /* 1281154 */   GIM_Try, /*On fail goto*//*Label 18411*/ GIMT_Encode4(1281238), // Rule ID 8696 //
     /* 1281159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1281176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281212 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1281215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281237 */     // GIR_Coverage, 8696,
     /* 1281237 */     GIR_EraseRootFromParent_Done,
     /* 1281238 */   // Label 18411: @1281238
     /* 1281238 */   GIM_Try, /*On fail goto*//*Label 18412*/ GIMT_Encode4(1281322), // Rule ID 8697 //
     /* 1281243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1281260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281296 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1281299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281321 */     // GIR_Coverage, 8697,
     /* 1281321 */     GIR_EraseRootFromParent_Done,
     /* 1281322 */   // Label 18412: @1281322
     /* 1281322 */   GIM_Try, /*On fail goto*//*Label 18413*/ GIMT_Encode4(1281406), // Rule ID 8700 //
     /* 1281327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281380 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1281383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281405 */     // GIR_Coverage, 8700,
     /* 1281405 */     GIR_EraseRootFromParent_Done,
     /* 1281406 */   // Label 18413: @1281406
     /* 1281406 */   GIM_Try, /*On fail goto*//*Label 18414*/ GIMT_Encode4(1281490), // Rule ID 8701 //
     /* 1281411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1281422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1281425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1281428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1281434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281464 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1281467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1281485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281489 */     // GIR_Coverage, 8701,
     /* 1281489 */     GIR_EraseRootFromParent_Done,
     /* 1281490 */   // Label 18414: @1281490
     /* 1281490 */   GIM_Try, /*On fail goto*//*Label 18415*/ GIMT_Encode4(1281574), // Rule ID 8704 //
     /* 1281495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281548 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1281551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281573 */     // GIR_Coverage, 8704,
     /* 1281573 */     GIR_EraseRootFromParent_Done,
     /* 1281574 */   // Label 18415: @1281574
     /* 1281574 */   GIM_Try, /*On fail goto*//*Label 18416*/ GIMT_Encode4(1281658), // Rule ID 8705 //
     /* 1281579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1281590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1281593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1281596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1281602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1281617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281632 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1281635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281657 */     // GIR_Coverage, 8705,
     /* 1281657 */     GIR_EraseRootFromParent_Done,
     /* 1281658 */   // Label 18416: @1281658
     /* 1281658 */   GIM_Try, /*On fail goto*//*Label 18417*/ GIMT_Encode4(1281742), // Rule ID 8708 //
     /* 1281663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281716 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1281719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281741 */     // GIR_Coverage, 8708,
     /* 1281741 */     GIR_EraseRootFromParent_Done,
     /* 1281742 */   // Label 18417: @1281742
     /* 1281742 */   GIM_Try, /*On fail goto*//*Label 18418*/ GIMT_Encode4(1281826), // Rule ID 8709 //
     /* 1281747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1281758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1281761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1281764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1281770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1281785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281800 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1281803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281825 */     // GIR_Coverage, 8709,
     /* 1281825 */     GIR_EraseRootFromParent_Done,
     /* 1281826 */   // Label 18418: @1281826
     /* 1281826 */   GIM_Try, /*On fail goto*//*Label 18419*/ GIMT_Encode4(1281910), // Rule ID 8712 //
     /* 1281831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1281834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1281851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1281857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281884 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1281884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1281887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281909 */     // GIR_Coverage, 8712,
     /* 1281909 */     GIR_EraseRootFromParent_Done,
     /* 1281910 */   // Label 18419: @1281910
     /* 1281910 */   GIM_Try, /*On fail goto*//*Label 18420*/ GIMT_Encode4(1281994), // Rule ID 8713 //
     /* 1281915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1281918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1281923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1281926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1281929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1281932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1281935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1281938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1281941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1281949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1281953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1281957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1281961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1281968 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1281968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1281971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1281973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1281975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1281977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1281979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1281981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1281986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1281989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1281992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1281993 */     // GIR_Coverage, 8713,
     /* 1281993 */     GIR_EraseRootFromParent_Done,
     /* 1281994 */   // Label 18420: @1281994
     /* 1281994 */   GIM_Try, /*On fail goto*//*Label 18421*/ GIMT_Encode4(1282078), // Rule ID 8716 //
     /* 1281999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1282016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282052 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1282055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282077 */     // GIR_Coverage, 8716,
     /* 1282077 */     GIR_EraseRootFromParent_Done,
     /* 1282078 */   // Label 18421: @1282078
     /* 1282078 */   GIM_Try, /*On fail goto*//*Label 18422*/ GIMT_Encode4(1282162), // Rule ID 8717 //
     /* 1282083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1282100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282136 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1282139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282161 */     // GIR_Coverage, 8717,
     /* 1282161 */     GIR_EraseRootFromParent_Done,
     /* 1282162 */   // Label 18422: @1282162
     /* 1282162 */   GIM_Try, /*On fail goto*//*Label 18423*/ GIMT_Encode4(1282246), // Rule ID 8720 //
     /* 1282167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1282184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282220 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1282223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282245 */     // GIR_Coverage, 8720,
     /* 1282245 */     GIR_EraseRootFromParent_Done,
     /* 1282246 */   // Label 18423: @1282246
     /* 1282246 */   GIM_Try, /*On fail goto*//*Label 18424*/ GIMT_Encode4(1282330), // Rule ID 8721 //
     /* 1282251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1282268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1282307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282329 */     // GIR_Coverage, 8721,
     /* 1282329 */     GIR_EraseRootFromParent_Done,
     /* 1282330 */   // Label 18424: @1282330
     /* 1282330 */   GIM_Try, /*On fail goto*//*Label 18425*/ GIMT_Encode4(1282414), // Rule ID 8724 //
     /* 1282335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1282338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282388 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1282391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282413 */     // GIR_Coverage, 8724,
     /* 1282413 */     GIR_EraseRootFromParent_Done,
     /* 1282414 */   // Label 18425: @1282414
     /* 1282414 */   GIM_Try, /*On fail goto*//*Label 18426*/ GIMT_Encode4(1282498), // Rule ID 8725 //
     /* 1282419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1282422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1282430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1282433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1282436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1282442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282472 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1282475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1282493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282497 */     // GIR_Coverage, 8725,
     /* 1282497 */     GIR_EraseRootFromParent_Done,
     /* 1282498 */   // Label 18426: @1282498
     /* 1282498 */   GIM_Try, /*On fail goto*//*Label 18427*/ GIMT_Encode4(1282582), // Rule ID 8728 //
     /* 1282503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282556 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1282559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282581 */     // GIR_Coverage, 8728,
     /* 1282581 */     GIR_EraseRootFromParent_Done,
     /* 1282582 */   // Label 18427: @1282582
     /* 1282582 */   GIM_Try, /*On fail goto*//*Label 18428*/ GIMT_Encode4(1282666), // Rule ID 8729 //
     /* 1282587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1282598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1282601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1282604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1282610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1282625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282640 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M2_MASK),
     /* 1282643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282665 */     // GIR_Coverage, 8729,
     /* 1282665 */     GIR_EraseRootFromParent_Done,
     /* 1282666 */   // Label 18428: @1282666
     /* 1282666 */   GIM_Try, /*On fail goto*//*Label 18429*/ GIMT_Encode4(1282750), // Rule ID 8732 //
     /* 1282671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282724 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1282727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282749 */     // GIR_Coverage, 8732,
     /* 1282749 */     GIR_EraseRootFromParent_Done,
     /* 1282750 */   // Label 18429: @1282750
     /* 1282750 */   GIM_Try, /*On fail goto*//*Label 18430*/ GIMT_Encode4(1282834), // Rule ID 8733 //
     /* 1282755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1282766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1282769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1282772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1282778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1282793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M4_MASK),
     /* 1282811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282833 */     // GIR_Coverage, 8733,
     /* 1282833 */     GIR_EraseRootFromParent_Done,
     /* 1282834 */   // Label 18430: @1282834
     /* 1282834 */   GIM_Try, /*On fail goto*//*Label 18431*/ GIMT_Encode4(1282918), // Rule ID 8736 //
     /* 1282839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1282842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1282859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1282865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282892 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1282892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1282895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1282916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1282917 */     // GIR_Coverage, 8736,
     /* 1282917 */     GIR_EraseRootFromParent_Done,
     /* 1282918 */   // Label 18431: @1282918
     /* 1282918 */   GIM_Try, /*On fail goto*//*Label 18432*/ GIMT_Encode4(1283002), // Rule ID 8737 //
     /* 1282923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1282926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsleu_mask),
     /* 1282931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1282934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1282937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1282940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1282943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1282946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1282949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1282957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1282961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1282965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1282969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1282976 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11391:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1282976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VX_M8_MASK),
     /* 1282979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1282981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1282983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1282985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1282987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1282989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1282994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1282997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283001 */     // GIR_Coverage, 8737,
     /* 1283001 */     GIR_EraseRootFromParent_Done,
     /* 1283002 */   // Label 18432: @1283002
     /* 1283002 */   GIM_Try, /*On fail goto*//*Label 18433*/ GIMT_Encode4(1283086), // Rule ID 8828 //
     /* 1283007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1283024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1283027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283060 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1283063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283085 */     // GIR_Coverage, 8828,
     /* 1283085 */     GIR_EraseRootFromParent_Done,
     /* 1283086 */   // Label 18433: @1283086
     /* 1283086 */   GIM_Try, /*On fail goto*//*Label 18434*/ GIMT_Encode4(1283170), // Rule ID 8829 //
     /* 1283091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1283108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1283111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283144 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1283147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283169 */     // GIR_Coverage, 8829,
     /* 1283169 */     GIR_EraseRootFromParent_Done,
     /* 1283170 */   // Label 18434: @1283170
     /* 1283170 */   GIM_Try, /*On fail goto*//*Label 18435*/ GIMT_Encode4(1283254), // Rule ID 8832 //
     /* 1283175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1283192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1283195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283228 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1283231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283253 */     // GIR_Coverage, 8832,
     /* 1283253 */     GIR_EraseRootFromParent_Done,
     /* 1283254 */   // Label 18435: @1283254
     /* 1283254 */   GIM_Try, /*On fail goto*//*Label 18436*/ GIMT_Encode4(1283338), // Rule ID 8833 //
     /* 1283259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1283276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1283279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283312 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1283315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283337 */     // GIR_Coverage, 8833,
     /* 1283337 */     GIR_EraseRootFromParent_Done,
     /* 1283338 */   // Label 18436: @1283338
     /* 1283338 */   GIM_Try, /*On fail goto*//*Label 18437*/ GIMT_Encode4(1283422), // Rule ID 8836 //
     /* 1283343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283396 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283421 */     // GIR_Coverage, 8836,
     /* 1283421 */     GIR_EraseRootFromParent_Done,
     /* 1283422 */   // Label 18437: @1283422
     /* 1283422 */   GIM_Try, /*On fail goto*//*Label 18438*/ GIMT_Encode4(1283506), // Rule ID 8837 //
     /* 1283427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1283438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1283441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1283444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1283447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1283450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283480 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1283501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283505 */     // GIR_Coverage, 8837,
     /* 1283505 */     GIR_EraseRootFromParent_Done,
     /* 1283506 */   // Label 18438: @1283506
     /* 1283506 */   GIM_Try, /*On fail goto*//*Label 18439*/ GIMT_Encode4(1283590), // Rule ID 8840 //
     /* 1283511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1283567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283589 */     // GIR_Coverage, 8840,
     /* 1283589 */     GIR_EraseRootFromParent_Done,
     /* 1283590 */   // Label 18439: @1283590
     /* 1283590 */   GIM_Try, /*On fail goto*//*Label 18440*/ GIMT_Encode4(1283674), // Rule ID 8841 //
     /* 1283595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1283612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1283615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1283651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283673 */     // GIR_Coverage, 8841,
     /* 1283673 */     GIR_EraseRootFromParent_Done,
     /* 1283674 */   // Label 18440: @1283674
     /* 1283674 */   GIM_Try, /*On fail goto*//*Label 18441*/ GIMT_Encode4(1283758), // Rule ID 8844 //
     /* 1283679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283732 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283757 */     // GIR_Coverage, 8844,
     /* 1283757 */     GIR_EraseRootFromParent_Done,
     /* 1283758 */   // Label 18441: @1283758
     /* 1283758 */   GIM_Try, /*On fail goto*//*Label 18442*/ GIMT_Encode4(1283842), // Rule ID 8845 //
     /* 1283763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1283774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1283777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1283780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1283783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1283786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283816 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1283837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283841 */     // GIR_Coverage, 8845,
     /* 1283841 */     GIR_EraseRootFromParent_Done,
     /* 1283842 */   // Label 18442: @1283842
     /* 1283842 */   GIM_Try, /*On fail goto*//*Label 18443*/ GIMT_Encode4(1283926), // Rule ID 8848 //
     /* 1283847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1283850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1283873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283900 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1283900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1283918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1283921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1283924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1283925 */     // GIR_Coverage, 8848,
     /* 1283925 */     GIR_EraseRootFromParent_Done,
     /* 1283926 */   // Label 18443: @1283926
     /* 1283926 */   GIM_Try, /*On fail goto*//*Label 18444*/ GIMT_Encode4(1284010), // Rule ID 8849 //
     /* 1283931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1283934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1283939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1283942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1283945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1283948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1283951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1283954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1283957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1283973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1283977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1283984 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1283984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1283987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1283989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1283991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1283993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1283995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1283997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284009 */     // GIR_Coverage, 8849,
     /* 1284009 */     GIR_EraseRootFromParent_Done,
     /* 1284010 */   // Label 18444: @1284010
     /* 1284010 */   GIM_Try, /*On fail goto*//*Label 18445*/ GIMT_Encode4(1284094), // Rule ID 8852 //
     /* 1284015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1284032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284068 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284093 */     // GIR_Coverage, 8852,
     /* 1284093 */     GIR_EraseRootFromParent_Done,
     /* 1284094 */   // Label 18445: @1284094
     /* 1284094 */   GIM_Try, /*On fail goto*//*Label 18446*/ GIMT_Encode4(1284178), // Rule ID 8853 //
     /* 1284099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1284110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1284113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1284116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1284119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1284122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284152 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284177 */     // GIR_Coverage, 8853,
     /* 1284177 */     GIR_EraseRootFromParent_Done,
     /* 1284178 */   // Label 18446: @1284178
     /* 1284178 */   GIM_Try, /*On fail goto*//*Label 18447*/ GIMT_Encode4(1284262), // Rule ID 8856 //
     /* 1284183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1284200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1284203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284236 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284261 */     // GIR_Coverage, 8856,
     /* 1284261 */     GIR_EraseRootFromParent_Done,
     /* 1284262 */   // Label 18447: @1284262
     /* 1284262 */   GIM_Try, /*On fail goto*//*Label 18448*/ GIMT_Encode4(1284346), // Rule ID 8857 //
     /* 1284267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1284278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1284281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1284284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1284287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1284290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284320 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1284341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284345 */     // GIR_Coverage, 8857,
     /* 1284345 */     GIR_EraseRootFromParent_Done,
     /* 1284346 */   // Label 18448: @1284346
     /* 1284346 */   GIM_Try, /*On fail goto*//*Label 18449*/ GIMT_Encode4(1284430), // Rule ID 8860 //
     /* 1284351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284404 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284429 */     // GIR_Coverage, 8860,
     /* 1284429 */     GIR_EraseRootFromParent_Done,
     /* 1284430 */   // Label 18449: @1284430
     /* 1284430 */   GIM_Try, /*On fail goto*//*Label 18450*/ GIMT_Encode4(1284514), // Rule ID 8861 //
     /* 1284435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1284446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1284449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1284452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1284455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1284458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284488 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1284509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284513 */     // GIR_Coverage, 8861,
     /* 1284513 */     GIR_EraseRootFromParent_Done,
     /* 1284514 */   // Label 18450: @1284514
     /* 1284514 */   GIM_Try, /*On fail goto*//*Label 18451*/ GIMT_Encode4(1284598), // Rule ID 8864 //
     /* 1284519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1284522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284597 */     // GIR_Coverage, 8864,
     /* 1284597 */     GIR_EraseRootFromParent_Done,
     /* 1284598 */   // Label 18451: @1284598
     /* 1284598 */   GIM_Try, /*On fail goto*//*Label 18452*/ GIMT_Encode4(1284682), // Rule ID 8865 //
     /* 1284603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1284606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1284614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1284617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1284620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1284623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1284626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1284659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1284677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284681 */     // GIR_Coverage, 8865,
     /* 1284681 */     GIR_EraseRootFromParent_Done,
     /* 1284682 */   // Label 18452: @1284682
     /* 1284682 */   GIM_Try, /*On fail goto*//*Label 18453*/ GIMT_Encode4(1284766), // Rule ID 8868 //
     /* 1284687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1284743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284765 */     // GIR_Coverage, 8868,
     /* 1284765 */     GIR_EraseRootFromParent_Done,
     /* 1284766 */   // Label 18453: @1284766
     /* 1284766 */   GIM_Try, /*On fail goto*//*Label 18454*/ GIMT_Encode4(1284850), // Rule ID 8869 //
     /* 1284771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1284782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1284785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1284788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1284791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1284794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1284813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284824 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1284827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284849 */     // GIR_Coverage, 8869,
     /* 1284849 */     GIR_EraseRootFromParent_Done,
     /* 1284850 */   // Label 18454: @1284850
     /* 1284850 */   GIM_Try, /*On fail goto*//*Label 18455*/ GIMT_Encode4(1284934), // Rule ID 8872 //
     /* 1284855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1284858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1284881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284908 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1284908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1284911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1284917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1284919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1284921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1284926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1284929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1284932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1284933 */     // GIR_Coverage, 8872,
     /* 1284933 */     GIR_EraseRootFromParent_Done,
     /* 1284934 */   // Label 18455: @1284934
     /* 1284934 */   GIM_Try, /*On fail goto*//*Label 18456*/ GIMT_Encode4(1285018), // Rule ID 8873 //
     /* 1284939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1284942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1284947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1284950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1284953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1284956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1284959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1284962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1284965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1284973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1284981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1284985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1284992 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1284992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1284995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1284997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1284999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285017 */     // GIR_Coverage, 8873,
     /* 1285017 */     GIR_EraseRootFromParent_Done,
     /* 1285018 */   // Label 18456: @1285018
     /* 1285018 */   GIM_Try, /*On fail goto*//*Label 18457*/ GIMT_Encode4(1285102), // Rule ID 8876 //
     /* 1285023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1285034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1285037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1285040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1285043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1285046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285076 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1285079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285101 */     // GIR_Coverage, 8876,
     /* 1285101 */     GIR_EraseRootFromParent_Done,
     /* 1285102 */   // Label 18457: @1285102
     /* 1285102 */   GIM_Try, /*On fail goto*//*Label 18458*/ GIMT_Encode4(1285186), // Rule ID 8877 //
     /* 1285107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1285118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1285121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1285124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1285127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1285130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285160 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1285163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1285181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285185 */     // GIR_Coverage, 8877,
     /* 1285185 */     GIR_EraseRootFromParent_Done,
     /* 1285186 */   // Label 18458: @1285186
     /* 1285186 */   GIM_Try, /*On fail goto*//*Label 18459*/ GIMT_Encode4(1285270), // Rule ID 8880 //
     /* 1285191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1285208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1285211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285244 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1285247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285269 */     // GIR_Coverage, 8880,
     /* 1285269 */     GIR_EraseRootFromParent_Done,
     /* 1285270 */   // Label 18459: @1285270
     /* 1285270 */   GIM_Try, /*On fail goto*//*Label 18460*/ GIMT_Encode4(1285354), // Rule ID 8881 //
     /* 1285275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1285292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1285295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285328 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1285331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285353 */     // GIR_Coverage, 8881,
     /* 1285353 */     GIR_EraseRootFromParent_Done,
     /* 1285354 */   // Label 18460: @1285354
     /* 1285354 */   GIM_Try, /*On fail goto*//*Label 18461*/ GIMT_Encode4(1285438), // Rule ID 8884 //
     /* 1285359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285412 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1285415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285437 */     // GIR_Coverage, 8884,
     /* 1285437 */     GIR_EraseRootFromParent_Done,
     /* 1285438 */   // Label 18461: @1285438
     /* 1285438 */   GIM_Try, /*On fail goto*//*Label 18462*/ GIMT_Encode4(1285522), // Rule ID 8885 //
     /* 1285443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1285454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1285457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1285460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1285463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1285466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285496 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1285499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285521 */     // GIR_Coverage, 8885,
     /* 1285521 */     GIR_EraseRootFromParent_Done,
     /* 1285522 */   // Label 18462: @1285522
     /* 1285522 */   GIM_Try, /*On fail goto*//*Label 18463*/ GIMT_Encode4(1285606), // Rule ID 8888 //
     /* 1285527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285580 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1285583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285605 */     // GIR_Coverage, 8888,
     /* 1285605 */     GIR_EraseRootFromParent_Done,
     /* 1285606 */   // Label 18463: @1285606
     /* 1285606 */   GIM_Try, /*On fail goto*//*Label 18464*/ GIMT_Encode4(1285690), // Rule ID 8889 //
     /* 1285611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1285622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1285625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1285628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1285631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1285634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1285653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285664 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1285667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1285685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285689 */     // GIR_Coverage, 8889,
     /* 1285689 */     GIR_EraseRootFromParent_Done,
     /* 1285690 */   // Label 18464: @1285690
     /* 1285690 */   GIM_Try, /*On fail goto*//*Label 18465*/ GIMT_Encode4(1285774), // Rule ID 8892 //
     /* 1285695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285748 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1285751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285773 */     // GIR_Coverage, 8892,
     /* 1285773 */     GIR_EraseRootFromParent_Done,
     /* 1285774 */   // Label 18465: @1285774
     /* 1285774 */   GIM_Try, /*On fail goto*//*Label 18466*/ GIMT_Encode4(1285858), // Rule ID 8893 //
     /* 1285779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1285790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1285793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1285796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1285799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1285802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1285821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285832 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1285832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1285835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285857 */     // GIR_Coverage, 8893,
     /* 1285857 */     GIR_EraseRootFromParent_Done,
     /* 1285858 */   // Label 18466: @1285858
     /* 1285858 */   GIM_Try, /*On fail goto*//*Label 18467*/ GIMT_Encode4(1285942), // Rule ID 8896 //
     /* 1285863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1285866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1285889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1285916 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1285916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1285919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1285921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1285923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1285925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1285927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1285929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1285934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1285937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1285940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1285941 */     // GIR_Coverage, 8896,
     /* 1285941 */     GIR_EraseRootFromParent_Done,
     /* 1285942 */   // Label 18467: @1285942
     /* 1285942 */   GIM_Try, /*On fail goto*//*Label 18468*/ GIMT_Encode4(1286026), // Rule ID 8897 //
     /* 1285947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1285950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1285955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1285958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1285961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1285964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1285967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1285970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1285973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1285981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1285989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1285993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286000 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1286003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286025 */     // GIR_Coverage, 8897,
     /* 1286025 */     GIR_EraseRootFromParent_Done,
     /* 1286026 */   // Label 18468: @1286026
     /* 1286026 */   GIM_Try, /*On fail goto*//*Label 18469*/ GIMT_Encode4(1286110), // Rule ID 8900 //
     /* 1286031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1286048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1286051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1286087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286109 */     // GIR_Coverage, 8900,
     /* 1286109 */     GIR_EraseRootFromParent_Done,
     /* 1286110 */   // Label 18469: @1286110
     /* 1286110 */   GIM_Try, /*On fail goto*//*Label 18470*/ GIMT_Encode4(1286194), // Rule ID 8901 //
     /* 1286115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1286126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1286129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1286132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1286135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1286138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286168 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1286171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1286189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286193 */     // GIR_Coverage, 8901,
     /* 1286193 */     GIR_EraseRootFromParent_Done,
     /* 1286194 */   // Label 18470: @1286194
     /* 1286194 */   GIM_Try, /*On fail goto*//*Label 18471*/ GIMT_Encode4(1286278), // Rule ID 8904 //
     /* 1286199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1286216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1286219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286252 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1286255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286277 */     // GIR_Coverage, 8904,
     /* 1286277 */     GIR_EraseRootFromParent_Done,
     /* 1286278 */   // Label 18471: @1286278
     /* 1286278 */   GIM_Try, /*On fail goto*//*Label 18472*/ GIMT_Encode4(1286362), // Rule ID 8905 //
     /* 1286283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1286300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1286303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1286325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286336 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1286339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286361 */     // GIR_Coverage, 8905,
     /* 1286361 */     GIR_EraseRootFromParent_Done,
     /* 1286362 */   // Label 18472: @1286362
     /* 1286362 */   GIM_Try, /*On fail goto*//*Label 18473*/ GIMT_Encode4(1286446), // Rule ID 8908 //
     /* 1286367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286420 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1286423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286445 */     // GIR_Coverage, 8908,
     /* 1286445 */     GIR_EraseRootFromParent_Done,
     /* 1286446 */   // Label 18473: @1286446
     /* 1286446 */   GIM_Try, /*On fail goto*//*Label 18474*/ GIMT_Encode4(1286530), // Rule ID 8909 //
     /* 1286451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1286462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1286465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1286468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1286471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1286474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1286493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1286507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286529 */     // GIR_Coverage, 8909,
     /* 1286529 */     GIR_EraseRootFromParent_Done,
     /* 1286530 */   // Label 18474: @1286530
     /* 1286530 */   GIM_Try, /*On fail goto*//*Label 18475*/ GIMT_Encode4(1286614), // Rule ID 8912 //
     /* 1286535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1286538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286588 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1286591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286613 */     // GIR_Coverage, 8912,
     /* 1286613 */     GIR_EraseRootFromParent_Done,
     /* 1286614 */   // Label 18475: @1286614
     /* 1286614 */   GIM_Try, /*On fail goto*//*Label 18476*/ GIMT_Encode4(1286698), // Rule ID 8913 //
     /* 1286619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1286622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1286630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1286633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1286636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1286639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1286642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1286661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286672 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1286675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1286693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286697 */     // GIR_Coverage, 8913,
     /* 1286697 */     GIR_EraseRootFromParent_Done,
     /* 1286698 */   // Label 18476: @1286698
     /* 1286698 */   GIM_Try, /*On fail goto*//*Label 18477*/ GIMT_Encode4(1286782), // Rule ID 8916 //
     /* 1286703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286756 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1286759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286781 */     // GIR_Coverage, 8916,
     /* 1286781 */     GIR_EraseRootFromParent_Done,
     /* 1286782 */   // Label 18477: @1286782
     /* 1286782 */   GIM_Try, /*On fail goto*//*Label 18478*/ GIMT_Encode4(1286866), // Rule ID 8917 //
     /* 1286787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1286798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1286801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1286804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1286810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286840 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1286840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF8_MASK),
     /* 1286843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286865 */     // GIR_Coverage, 8917,
     /* 1286865 */     GIR_EraseRootFromParent_Done,
     /* 1286866 */   // Label 18478: @1286866
     /* 1286866 */   GIM_Try, /*On fail goto*//*Label 18479*/ GIMT_Encode4(1286950), // Rule ID 8920 //
     /* 1286871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1286874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1286891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1286897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1286917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1286924 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1286924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1286927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1286929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1286931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1286933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1286935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1286937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1286942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1286945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1286948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1286949 */     // GIR_Coverage, 8920,
     /* 1286949 */     GIR_EraseRootFromParent_Done,
     /* 1286950 */   // Label 18479: @1286950
     /* 1286950 */   GIM_Try, /*On fail goto*//*Label 18480*/ GIMT_Encode4(1287034), // Rule ID 8921 //
     /* 1286955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1286958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1286963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1286966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1286969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1286972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1286975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1286978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1286981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1286993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1286997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287008 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1287011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287033 */     // GIR_Coverage, 8921,
     /* 1287033 */     GIR_EraseRootFromParent_Done,
     /* 1287034 */   // Label 18480: @1287034
     /* 1287034 */   GIM_Try, /*On fail goto*//*Label 18481*/ GIMT_Encode4(1287118), // Rule ID 8924 //
     /* 1287039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1287056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287117 */     // GIR_Coverage, 8924,
     /* 1287117 */     GIR_EraseRootFromParent_Done,
     /* 1287118 */   // Label 18481: @1287118
     /* 1287118 */   GIM_Try, /*On fail goto*//*Label 18482*/ GIMT_Encode4(1287202), // Rule ID 8925 //
     /* 1287123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1287140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287201 */     // GIR_Coverage, 8925,
     /* 1287201 */     GIR_EraseRootFromParent_Done,
     /* 1287202 */   // Label 18482: @1287202
     /* 1287202 */   GIM_Try, /*On fail goto*//*Label 18483*/ GIMT_Encode4(1287286), // Rule ID 8928 //
     /* 1287207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1287224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287260 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1287263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287285 */     // GIR_Coverage, 8928,
     /* 1287285 */     GIR_EraseRootFromParent_Done,
     /* 1287286 */   // Label 18483: @1287286
     /* 1287286 */   GIM_Try, /*On fail goto*//*Label 18484*/ GIMT_Encode4(1287370), // Rule ID 8929 //
     /* 1287291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1287308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287344 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF4_MASK),
     /* 1287347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287369 */     // GIR_Coverage, 8929,
     /* 1287369 */     GIR_EraseRootFromParent_Done,
     /* 1287370 */   // Label 18484: @1287370
     /* 1287370 */   GIM_Try, /*On fail goto*//*Label 18485*/ GIMT_Encode4(1287454), // Rule ID 8932 //
     /* 1287375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287428 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287453 */     // GIR_Coverage, 8932,
     /* 1287453 */     GIR_EraseRootFromParent_Done,
     /* 1287454 */   // Label 18485: @1287454
     /* 1287454 */   GIM_Try, /*On fail goto*//*Label 18486*/ GIMT_Encode4(1287538), // Rule ID 8933 //
     /* 1287459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1287470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1287473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1287476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1287482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287512 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287537 */     // GIR_Coverage, 8933,
     /* 1287537 */     GIR_EraseRootFromParent_Done,
     /* 1287538 */   // Label 18486: @1287538
     /* 1287538 */   GIM_Try, /*On fail goto*//*Label 18487*/ GIMT_Encode4(1287622), // Rule ID 8936 //
     /* 1287543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287596 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287621 */     // GIR_Coverage, 8936,
     /* 1287621 */     GIR_EraseRootFromParent_Done,
     /* 1287622 */   // Label 18487: @1287622
     /* 1287622 */   GIM_Try, /*On fail goto*//*Label 18488*/ GIMT_Encode4(1287706), // Rule ID 8937 //
     /* 1287627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1287638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1287641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1287644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1287650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287680 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_MF2_MASK),
     /* 1287683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1287701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287705 */     // GIR_Coverage, 8937,
     /* 1287705 */     GIR_EraseRootFromParent_Done,
     /* 1287706 */   // Label 18488: @1287706
     /* 1287706 */   GIM_Try, /*On fail goto*//*Label 18489*/ GIMT_Encode4(1287790), // Rule ID 8940 //
     /* 1287711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1287767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287789 */     // GIR_Coverage, 8940,
     /* 1287789 */     GIR_EraseRootFromParent_Done,
     /* 1287790 */   // Label 18489: @1287790
     /* 1287790 */   GIM_Try, /*On fail goto*//*Label 18490*/ GIMT_Encode4(1287874), // Rule ID 8941 //
     /* 1287795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1287806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1287809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1287812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1287818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287848 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1287848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1287851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1287869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287873 */     // GIR_Coverage, 8941,
     /* 1287873 */     GIR_EraseRootFromParent_Done,
     /* 1287874 */   // Label 18490: @1287874
     /* 1287874 */   GIM_Try, /*On fail goto*//*Label 18491*/ GIMT_Encode4(1287958), // Rule ID 8944 //
     /* 1287879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1287882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1287899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1287905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1287921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1287925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1287932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1287932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1287935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1287937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1287939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1287941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1287943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1287945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1287950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1287953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1287956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1287957 */     // GIR_Coverage, 8944,
     /* 1287957 */     GIR_EraseRootFromParent_Done,
     /* 1287958 */   // Label 18491: @1287958
     /* 1287958 */   GIM_Try, /*On fail goto*//*Label 18492*/ GIMT_Encode4(1288042), // Rule ID 8945 //
     /* 1287963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1287966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1287971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1287974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1287977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1287980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1287983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1287986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1287989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1287997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1288019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288041 */     // GIR_Coverage, 8945,
     /* 1288041 */     GIR_EraseRootFromParent_Done,
     /* 1288042 */   // Label 18492: @1288042
     /* 1288042 */   GIM_Try, /*On fail goto*//*Label 18493*/ GIMT_Encode4(1288126), // Rule ID 8948 //
     /* 1288047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1288064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288100 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1288103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288125 */     // GIR_Coverage, 8948,
     /* 1288125 */     GIR_EraseRootFromParent_Done,
     /* 1288126 */   // Label 18493: @1288126
     /* 1288126 */   GIM_Try, /*On fail goto*//*Label 18494*/ GIMT_Encode4(1288210), // Rule ID 8949 //
     /* 1288131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1288142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1288145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1288148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1288154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288184 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1288187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1288205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288209 */     // GIR_Coverage, 8949,
     /* 1288209 */     GIR_EraseRootFromParent_Done,
     /* 1288210 */   // Label 18494: @1288210
     /* 1288210 */   GIM_Try, /*On fail goto*//*Label 18495*/ GIMT_Encode4(1288294), // Rule ID 8952 //
     /* 1288215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1288218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1288232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1288271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288293 */     // GIR_Coverage, 8952,
     /* 1288293 */     GIR_EraseRootFromParent_Done,
     /* 1288294 */   // Label 18495: @1288294
     /* 1288294 */   GIM_Try, /*On fail goto*//*Label 18496*/ GIMT_Encode4(1288378), // Rule ID 8953 //
     /* 1288299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1288302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1288310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1288313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1288316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1288322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M1_MASK),
     /* 1288355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1288373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288377 */     // GIR_Coverage, 8953,
     /* 1288377 */     GIR_EraseRootFromParent_Done,
     /* 1288378 */   // Label 18496: @1288378
     /* 1288378 */   GIM_Try, /*On fail goto*//*Label 18497*/ GIMT_Encode4(1288462), // Rule ID 8956 //
     /* 1288383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288436 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1288439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288461 */     // GIR_Coverage, 8956,
     /* 1288461 */     GIR_EraseRootFromParent_Done,
     /* 1288462 */   // Label 18497: @1288462
     /* 1288462 */   GIM_Try, /*On fail goto*//*Label 18498*/ GIMT_Encode4(1288546), // Rule ID 8957 //
     /* 1288467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1288478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1288481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1288484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1288490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288520 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1288523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288545 */     // GIR_Coverage, 8957,
     /* 1288545 */     GIR_EraseRootFromParent_Done,
     /* 1288546 */   // Label 18498: @1288546
     /* 1288546 */   GIM_Try, /*On fail goto*//*Label 18499*/ GIMT_Encode4(1288630), // Rule ID 8960 //
     /* 1288551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288604 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1288607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288629 */     // GIR_Coverage, 8960,
     /* 1288629 */     GIR_EraseRootFromParent_Done,
     /* 1288630 */   // Label 18499: @1288630
     /* 1288630 */   GIM_Try, /*On fail goto*//*Label 18500*/ GIMT_Encode4(1288714), // Rule ID 8961 //
     /* 1288635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1288646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1288649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1288652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1288658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1288673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288688 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1288691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288713 */     // GIR_Coverage, 8961,
     /* 1288713 */     GIR_EraseRootFromParent_Done,
     /* 1288714 */   // Label 18500: @1288714
     /* 1288714 */   GIM_Try, /*On fail goto*//*Label 18501*/ GIMT_Encode4(1288798), // Rule ID 8964 //
     /* 1288719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288772 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1288775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288797 */     // GIR_Coverage, 8964,
     /* 1288797 */     GIR_EraseRootFromParent_Done,
     /* 1288798 */   // Label 18501: @1288798
     /* 1288798 */   GIM_Try, /*On fail goto*//*Label 18502*/ GIMT_Encode4(1288882), // Rule ID 8965 //
     /* 1288803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1288814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1288817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1288820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1288826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1288841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288856 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1288856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1288859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1288877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288881 */     // GIR_Coverage, 8965,
     /* 1288881 */     GIR_EraseRootFromParent_Done,
     /* 1288882 */   // Label 18502: @1288882
     /* 1288882 */   GIM_Try, /*On fail goto*//*Label 18503*/ GIMT_Encode4(1288966), // Rule ID 8968 //
     /* 1288887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1288890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1288907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1288913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1288921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1288925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1288929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1288933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1288940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1288940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1288943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1288945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1288947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1288949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1288951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1288953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1288958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1288961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1288964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1288965 */     // GIR_Coverage, 8968,
     /* 1288965 */     GIR_EraseRootFromParent_Done,
     /* 1288966 */   // Label 18503: @1288966
     /* 1288966 */   GIM_Try, /*On fail goto*//*Label 18504*/ GIMT_Encode4(1289050), // Rule ID 8969 //
     /* 1288971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1288974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1288979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1288982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1288985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1288988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1288991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1288994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1288997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1289027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289049 */     // GIR_Coverage, 8969,
     /* 1289049 */     GIR_EraseRootFromParent_Done,
     /* 1289050 */   // Label 18504: @1289050
     /* 1289050 */   GIM_Try, /*On fail goto*//*Label 18505*/ GIMT_Encode4(1289134), // Rule ID 8972 //
     /* 1289055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1289072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289108 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1289111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289133 */     // GIR_Coverage, 8972,
     /* 1289133 */     GIR_EraseRootFromParent_Done,
     /* 1289134 */   // Label 18505: @1289134
     /* 1289134 */   GIM_Try, /*On fail goto*//*Label 18506*/ GIMT_Encode4(1289218), // Rule ID 8973 //
     /* 1289139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1289156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289192 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1289195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289217 */     // GIR_Coverage, 8973,
     /* 1289217 */     GIR_EraseRootFromParent_Done,
     /* 1289218 */   // Label 18506: @1289218
     /* 1289218 */   GIM_Try, /*On fail goto*//*Label 18507*/ GIMT_Encode4(1289302), // Rule ID 8976 //
     /* 1289223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1289240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289276 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1289279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289301 */     // GIR_Coverage, 8976,
     /* 1289301 */     GIR_EraseRootFromParent_Done,
     /* 1289302 */   // Label 18507: @1289302
     /* 1289302 */   GIM_Try, /*On fail goto*//*Label 18508*/ GIMT_Encode4(1289386), // Rule ID 8977 //
     /* 1289307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1289318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1289321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1289324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1289330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289360 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1289363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1289381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289385 */     // GIR_Coverage, 8977,
     /* 1289385 */     GIR_EraseRootFromParent_Done,
     /* 1289386 */   // Label 18508: @1289386
     /* 1289386 */   GIM_Try, /*On fail goto*//*Label 18509*/ GIMT_Encode4(1289470), // Rule ID 8980 //
     /* 1289391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289444 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1289447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289469 */     // GIR_Coverage, 8980,
     /* 1289469 */     GIR_EraseRootFromParent_Done,
     /* 1289470 */   // Label 18509: @1289470
     /* 1289470 */   GIM_Try, /*On fail goto*//*Label 18510*/ GIMT_Encode4(1289554), // Rule ID 8981 //
     /* 1289475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1289486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1289489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1289492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1289498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289528 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1289531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289553 */     // GIR_Coverage, 8981,
     /* 1289553 */     GIR_EraseRootFromParent_Done,
     /* 1289554 */   // Label 18510: @1289554
     /* 1289554 */   GIM_Try, /*On fail goto*//*Label 18511*/ GIMT_Encode4(1289638), // Rule ID 8984 //
     /* 1289559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289612 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1289615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289637 */     // GIR_Coverage, 8984,
     /* 1289637 */     GIR_EraseRootFromParent_Done,
     /* 1289638 */   // Label 18511: @1289638
     /* 1289638 */   GIM_Try, /*On fail goto*//*Label 18512*/ GIMT_Encode4(1289722), // Rule ID 8985 //
     /* 1289643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1289654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1289657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1289660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1289666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1289681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289696 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1289699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289721 */     // GIR_Coverage, 8985,
     /* 1289721 */     GIR_EraseRootFromParent_Done,
     /* 1289722 */   // Label 18512: @1289722
     /* 1289722 */   GIM_Try, /*On fail goto*//*Label 18513*/ GIMT_Encode4(1289806), // Rule ID 8988 //
     /* 1289727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1289730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289780 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1289783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289805 */     // GIR_Coverage, 8988,
     /* 1289805 */     GIR_EraseRootFromParent_Done,
     /* 1289806 */   // Label 18513: @1289806
     /* 1289806 */   GIM_Try, /*On fail goto*//*Label 18514*/ GIMT_Encode4(1289890), // Rule ID 8989 //
     /* 1289811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1289814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1289822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1289825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1289828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1289834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1289837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1289849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289864 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1289864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1289867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1289885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289889 */     // GIR_Coverage, 8989,
     /* 1289889 */     GIR_EraseRootFromParent_Done,
     /* 1289890 */   // Label 18514: @1289890
     /* 1289890 */   GIM_Try, /*On fail goto*//*Label 18515*/ GIMT_Encode4(1289974), // Rule ID 8992 //
     /* 1289895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1289898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1289915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1289918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1289921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1289929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1289933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1289937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1289941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1289948 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1289948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1289951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1289953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1289955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1289957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1289959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1289961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1289966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1289969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1289972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1289973 */     // GIR_Coverage, 8992,
     /* 1289973 */     GIR_EraseRootFromParent_Done,
     /* 1289974 */   // Label 18515: @1289974
     /* 1289974 */   GIM_Try, /*On fail goto*//*Label 18516*/ GIMT_Encode4(1290058), // Rule ID 8993 //
     /* 1289979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1289982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1289987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1289990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1289993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1289996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1289999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1290017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290032 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M2_MASK),
     /* 1290035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290057 */     // GIR_Coverage, 8993,
     /* 1290057 */     GIR_EraseRootFromParent_Done,
     /* 1290058 */   // Label 18516: @1290058
     /* 1290058 */   GIM_Try, /*On fail goto*//*Label 18517*/ GIMT_Encode4(1290142), // Rule ID 8996 //
     /* 1290063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1290066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1290080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290116 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1290119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290141 */     // GIR_Coverage, 8996,
     /* 1290141 */     GIR_EraseRootFromParent_Done,
     /* 1290142 */   // Label 18517: @1290142
     /* 1290142 */   GIM_Try, /*On fail goto*//*Label 18518*/ GIMT_Encode4(1290226), // Rule ID 8997 //
     /* 1290147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1290164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1290185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290200 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M4_MASK),
     /* 1290203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290225 */     // GIR_Coverage, 8997,
     /* 1290225 */     GIR_EraseRootFromParent_Done,
     /* 1290226 */   // Label 18518: @1290226
     /* 1290226 */   GIM_Try, /*On fail goto*//*Label 18519*/ GIMT_Encode4(1290310), // Rule ID 9000 //
     /* 1290231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1290234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290284 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1290287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290309 */     // GIR_Coverage, 9000,
     /* 1290309 */     GIR_EraseRootFromParent_Done,
     /* 1290310 */   // Label 18519: @1290310
     /* 1290310 */   GIM_Try, /*On fail goto*//*Label 18520*/ GIMT_Encode4(1290394), // Rule ID 9001 //
     /* 1290315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1290318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsle_mask),
     /* 1290323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1290326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1290329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1290332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1290338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1290353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290368 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11389:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VX_M8_MASK),
     /* 1290371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1290389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290393 */     // GIR_Coverage, 9001,
     /* 1290393 */     GIR_EraseRootFromParent_Done,
     /* 1290394 */   // Label 18520: @1290394
     /* 1290394 */   GIM_Try, /*On fail goto*//*Label 18521*/ GIMT_Encode4(1290478), // Rule ID 9092 //
     /* 1290399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290452 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1290455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290477 */     // GIR_Coverage, 9092,
     /* 1290477 */     GIR_EraseRootFromParent_Done,
     /* 1290478 */   // Label 18521: @1290478
     /* 1290478 */   GIM_Try, /*On fail goto*//*Label 18522*/ GIMT_Encode4(1290562), // Rule ID 9093 //
     /* 1290483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1290500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290536 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF8_MASK),
     /* 1290539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290561 */     // GIR_Coverage, 9093,
     /* 1290561 */     GIR_EraseRootFromParent_Done,
     /* 1290562 */   // Label 18522: @1290562
     /* 1290562 */   GIM_Try, /*On fail goto*//*Label 18523*/ GIMT_Encode4(1290646), // Rule ID 9096 //
     /* 1290567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290620 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1290623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290645 */     // GIR_Coverage, 9096,
     /* 1290645 */     GIR_EraseRootFromParent_Done,
     /* 1290646 */   // Label 18523: @1290646
     /* 1290646 */   GIM_Try, /*On fail goto*//*Label 18524*/ GIMT_Encode4(1290730), // Rule ID 9097 //
     /* 1290651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1290662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1290665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1290668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1290674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290704 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1290707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290729 */     // GIR_Coverage, 9097,
     /* 1290729 */     GIR_EraseRootFromParent_Done,
     /* 1290730 */   // Label 18524: @1290730
     /* 1290730 */   GIM_Try, /*On fail goto*//*Label 18525*/ GIMT_Encode4(1290814), // Rule ID 9100 //
     /* 1290735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1290791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290813 */     // GIR_Coverage, 9100,
     /* 1290813 */     GIR_EraseRootFromParent_Done,
     /* 1290814 */   // Label 18525: @1290814
     /* 1290814 */   GIM_Try, /*On fail goto*//*Label 18526*/ GIMT_Encode4(1290898), // Rule ID 9101 //
     /* 1290819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1290830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1290833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1290836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1290839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1290842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1290845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290872 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1290872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1290875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1290893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290897 */     // GIR_Coverage, 9101,
     /* 1290897 */     GIR_EraseRootFromParent_Done,
     /* 1290898 */   // Label 18526: @1290898
     /* 1290898 */   GIM_Try, /*On fail goto*//*Label 18527*/ GIMT_Encode4(1290982), // Rule ID 9104 //
     /* 1290903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1290906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1290917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1290920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1290923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1290926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1290929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1290941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1290945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1290949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1290956 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1290956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1290959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1290961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1290963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1290965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1290967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1290969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1290974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1290977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1290980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1290981 */     // GIR_Coverage, 9104,
     /* 1290981 */     GIR_EraseRootFromParent_Done,
     /* 1290982 */   // Label 18527: @1290982
     /* 1290982 */   GIM_Try, /*On fail goto*//*Label 18528*/ GIMT_Encode4(1291066), // Rule ID 9105 //
     /* 1290987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1290990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1290995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1290998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1291004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291040 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF4_MASK),
     /* 1291043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291065 */     // GIR_Coverage, 9105,
     /* 1291065 */     GIR_EraseRootFromParent_Done,
     /* 1291066 */   // Label 18528: @1291066
     /* 1291066 */   GIM_Try, /*On fail goto*//*Label 18529*/ GIMT_Encode4(1291150), // Rule ID 9108 //
     /* 1291071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1291088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1291127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291149 */     // GIR_Coverage, 9108,
     /* 1291149 */     GIR_EraseRootFromParent_Done,
     /* 1291150 */   // Label 18529: @1291150
     /* 1291150 */   GIM_Try, /*On fail goto*//*Label 18530*/ GIMT_Encode4(1291234), // Rule ID 9109 //
     /* 1291155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1291172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1291211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291233 */     // GIR_Coverage, 9109,
     /* 1291233 */     GIR_EraseRootFromParent_Done,
     /* 1291234 */   // Label 18530: @1291234
     /* 1291234 */   GIM_Try, /*On fail goto*//*Label 18531*/ GIMT_Encode4(1291318), // Rule ID 9112 //
     /* 1291239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291292 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1291295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291317 */     // GIR_Coverage, 9112,
     /* 1291317 */     GIR_EraseRootFromParent_Done,
     /* 1291318 */   // Label 18531: @1291318
     /* 1291318 */   GIM_Try, /*On fail goto*//*Label 18532*/ GIMT_Encode4(1291402), // Rule ID 9113 //
     /* 1291323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1291340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291376 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_MF2_MASK),
     /* 1291379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291401 */     // GIR_Coverage, 9113,
     /* 1291401 */     GIR_EraseRootFromParent_Done,
     /* 1291402 */   // Label 18532: @1291402
     /* 1291402 */   GIM_Try, /*On fail goto*//*Label 18533*/ GIMT_Encode4(1291486), // Rule ID 9116 //
     /* 1291407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291485 */     // GIR_Coverage, 9116,
     /* 1291485 */     GIR_EraseRootFromParent_Done,
     /* 1291486 */   // Label 18533: @1291486
     /* 1291486 */   GIM_Try, /*On fail goto*//*Label 18534*/ GIMT_Encode4(1291570), // Rule ID 9117 //
     /* 1291491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1291502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1291505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1291508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1291514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1291565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291569 */     // GIR_Coverage, 9117,
     /* 1291569 */     GIR_EraseRootFromParent_Done,
     /* 1291570 */   // Label 18534: @1291570
     /* 1291570 */   GIM_Try, /*On fail goto*//*Label 18535*/ GIMT_Encode4(1291654), // Rule ID 9120 //
     /* 1291575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291628 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291653 */     // GIR_Coverage, 9120,
     /* 1291653 */     GIR_EraseRootFromParent_Done,
     /* 1291654 */   // Label 18535: @1291654
     /* 1291654 */   GIM_Try, /*On fail goto*//*Label 18536*/ GIMT_Encode4(1291738), // Rule ID 9121 //
     /* 1291659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1291670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1291673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1291676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1291682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291712 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1291733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291737 */     // GIR_Coverage, 9121,
     /* 1291737 */     GIR_EraseRootFromParent_Done,
     /* 1291738 */   // Label 18536: @1291738
     /* 1291738 */   GIM_Try, /*On fail goto*//*Label 18537*/ GIMT_Encode4(1291822), // Rule ID 9124 //
     /* 1291743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1291746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291821 */     // GIR_Coverage, 9124,
     /* 1291821 */     GIR_EraseRootFromParent_Done,
     /* 1291822 */   // Label 18537: @1291822
     /* 1291822 */   GIM_Try, /*On fail goto*//*Label 18538*/ GIMT_Encode4(1291906), // Rule ID 9125 //
     /* 1291827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1291830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1291838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1291841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1291844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1291847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1291850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1291853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1291880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1291901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291905 */     // GIR_Coverage, 9125,
     /* 1291905 */     GIR_EraseRootFromParent_Done,
     /* 1291906 */   // Label 18538: @1291906
     /* 1291906 */   GIM_Try, /*On fail goto*//*Label 18539*/ GIMT_Encode4(1291990), // Rule ID 9128 //
     /* 1291911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1291914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1291919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1291922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1291925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1291928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1291931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1291934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1291937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1291949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1291953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1291957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1291964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1291964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1291967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1291969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1291971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1291973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1291975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1291977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1291982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1291985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1291988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1291989 */     // GIR_Coverage, 9128,
     /* 1291989 */     GIR_EraseRootFromParent_Done,
     /* 1291990 */   // Label 18539: @1291990
     /* 1291990 */   GIM_Try, /*On fail goto*//*Label 18540*/ GIMT_Encode4(1292074), // Rule ID 9129 //
     /* 1291995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1291998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1292006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1292009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1292012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1292018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M1_MASK),
     /* 1292051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1292069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292073 */     // GIR_Coverage, 9129,
     /* 1292073 */     GIR_EraseRootFromParent_Done,
     /* 1292074 */   // Label 18540: @1292074
     /* 1292074 */   GIM_Try, /*On fail goto*//*Label 18541*/ GIMT_Encode4(1292158), // Rule ID 9132 //
     /* 1292079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1292096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292132 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1292135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292157 */     // GIR_Coverage, 9132,
     /* 1292157 */     GIR_EraseRootFromParent_Done,
     /* 1292158 */   // Label 18541: @1292158
     /* 1292158 */   GIM_Try, /*On fail goto*//*Label 18542*/ GIMT_Encode4(1292242), // Rule ID 9133 //
     /* 1292163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1292180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292216 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1292219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292241 */     // GIR_Coverage, 9133,
     /* 1292241 */     GIR_EraseRootFromParent_Done,
     /* 1292242 */   // Label 18542: @1292242
     /* 1292242 */   GIM_Try, /*On fail goto*//*Label 18543*/ GIMT_Encode4(1292326), // Rule ID 9136 //
     /* 1292247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1292264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292300 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1292303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292325 */     // GIR_Coverage, 9136,
     /* 1292325 */     GIR_EraseRootFromParent_Done,
     /* 1292326 */   // Label 18543: @1292326
     /* 1292326 */   GIM_Try, /*On fail goto*//*Label 18544*/ GIMT_Encode4(1292410), // Rule ID 9137 //
     /* 1292331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1292348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292384 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1292387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292409 */     // GIR_Coverage, 9137,
     /* 1292409 */     GIR_EraseRootFromParent_Done,
     /* 1292410 */   // Label 18544: @1292410
     /* 1292410 */   GIM_Try, /*On fail goto*//*Label 18545*/ GIMT_Encode4(1292494), // Rule ID 9140 //
     /* 1292415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292468 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1292471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292493 */     // GIR_Coverage, 9140,
     /* 1292493 */     GIR_EraseRootFromParent_Done,
     /* 1292494 */   // Label 18545: @1292494
     /* 1292494 */   GIM_Try, /*On fail goto*//*Label 18546*/ GIMT_Encode4(1292578), // Rule ID 9141 //
     /* 1292499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1292510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1292513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1292516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1292522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292552 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1292555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1292573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292577 */     // GIR_Coverage, 9141,
     /* 1292577 */     GIR_EraseRootFromParent_Done,
     /* 1292578 */   // Label 18546: @1292578
     /* 1292578 */   GIM_Try, /*On fail goto*//*Label 18547*/ GIMT_Encode4(1292662), // Rule ID 9144 //
     /* 1292583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1292639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292661 */     // GIR_Coverage, 9144,
     /* 1292661 */     GIR_EraseRootFromParent_Done,
     /* 1292662 */   // Label 18547: @1292662
     /* 1292662 */   GIM_Try, /*On fail goto*//*Label 18548*/ GIMT_Encode4(1292746), // Rule ID 9145 //
     /* 1292667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1292678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1292681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1292684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1292690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1292705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1292723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292745 */     // GIR_Coverage, 9145,
     /* 1292745 */     GIR_EraseRootFromParent_Done,
     /* 1292746 */   // Label 18548: @1292746
     /* 1292746 */   GIM_Try, /*On fail goto*//*Label 18549*/ GIMT_Encode4(1292830), // Rule ID 9148 //
     /* 1292751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1292807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292829 */     // GIR_Coverage, 9148,
     /* 1292829 */     GIR_EraseRootFromParent_Done,
     /* 1292830 */   // Label 18549: @1292830
     /* 1292830 */   GIM_Try, /*On fail goto*//*Label 18550*/ GIMT_Encode4(1292914), // Rule ID 9149 //
     /* 1292835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1292838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1292846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1292849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1292852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1292855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1292858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1292861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1292873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1292888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1292891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292913 */     // GIR_Coverage, 9149,
     /* 1292913 */     GIR_EraseRootFromParent_Done,
     /* 1292914 */   // Label 18550: @1292914
     /* 1292914 */   GIM_Try, /*On fail goto*//*Label 18551*/ GIMT_Encode4(1292998), // Rule ID 9152 //
     /* 1292919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1292922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1292927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1292930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1292933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1292936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1292939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1292942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1292945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1292953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1292957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1292961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1292965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1292972 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1292972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1292975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1292977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1292979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1292981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1292983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1292985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1292990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1292993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1292996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1292997 */     // GIR_Coverage, 9152,
     /* 1292997 */     GIR_EraseRootFromParent_Done,
     /* 1292998 */   // Label 18551: @1292998
     /* 1292998 */   GIM_Try, /*On fail goto*//*Label 18552*/ GIMT_Encode4(1293082), // Rule ID 9153 //
     /* 1293003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1293014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1293017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1293020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1293026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1293059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1293077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293081 */     // GIR_Coverage, 9153,
     /* 1293081 */     GIR_EraseRootFromParent_Done,
     /* 1293082 */   // Label 18552: @1293082
     /* 1293082 */   GIM_Try, /*On fail goto*//*Label 18553*/ GIMT_Encode4(1293166), // Rule ID 9156 //
     /* 1293087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1293104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1293143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293165 */     // GIR_Coverage, 9156,
     /* 1293165 */     GIR_EraseRootFromParent_Done,
     /* 1293166 */   // Label 18553: @1293166
     /* 1293166 */   GIM_Try, /*On fail goto*//*Label 18554*/ GIMT_Encode4(1293250), // Rule ID 9157 //
     /* 1293171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1293188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1293227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293249 */     // GIR_Coverage, 9157,
     /* 1293249 */     GIR_EraseRootFromParent_Done,
     /* 1293250 */   // Label 18554: @1293250
     /* 1293250 */   GIM_Try, /*On fail goto*//*Label 18555*/ GIMT_Encode4(1293334), // Rule ID 9160 //
     /* 1293255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1293272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1293311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293333 */     // GIR_Coverage, 9160,
     /* 1293333 */     GIR_EraseRootFromParent_Done,
     /* 1293334 */   // Label 18555: @1293334
     /* 1293334 */   GIM_Try, /*On fail goto*//*Label 18556*/ GIMT_Encode4(1293418), // Rule ID 9161 //
     /* 1293339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1293356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1293395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293417 */     // GIR_Coverage, 9161,
     /* 1293417 */     GIR_EraseRootFromParent_Done,
     /* 1293418 */   // Label 18556: @1293418
     /* 1293418 */   GIM_Try, /*On fail goto*//*Label 18557*/ GIMT_Encode4(1293502), // Rule ID 9164 //
     /* 1293423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1293426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1293479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293501 */     // GIR_Coverage, 9164,
     /* 1293501 */     GIR_EraseRootFromParent_Done,
     /* 1293502 */   // Label 18557: @1293502
     /* 1293502 */   GIM_Try, /*On fail goto*//*Label 18558*/ GIMT_Encode4(1293586), // Rule ID 9165 //
     /* 1293507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1293510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1293518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1293521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1293524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1293530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1293563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1293581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293585 */     // GIR_Coverage, 9165,
     /* 1293585 */     GIR_EraseRootFromParent_Done,
     /* 1293586 */   // Label 18558: @1293586
     /* 1293586 */   GIM_Try, /*On fail goto*//*Label 18559*/ GIMT_Encode4(1293670), // Rule ID 9168 //
     /* 1293591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1293647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293669 */     // GIR_Coverage, 9168,
     /* 1293669 */     GIR_EraseRootFromParent_Done,
     /* 1293670 */   // Label 18559: @1293670
     /* 1293670 */   GIM_Try, /*On fail goto*//*Label 18560*/ GIMT_Encode4(1293754), // Rule ID 9169 //
     /* 1293675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1293686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1293689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1293692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1293698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1293713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M2_MASK),
     /* 1293731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293753 */     // GIR_Coverage, 9169,
     /* 1293753 */     GIR_EraseRootFromParent_Done,
     /* 1293754 */   // Label 18560: @1293754
     /* 1293754 */   GIM_Try, /*On fail goto*//*Label 18561*/ GIMT_Encode4(1293838), // Rule ID 9172 //
     /* 1293759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1293815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293837 */     // GIR_Coverage, 9172,
     /* 1293837 */     GIR_EraseRootFromParent_Done,
     /* 1293838 */   // Label 18561: @1293838
     /* 1293838 */   GIM_Try, /*On fail goto*//*Label 18562*/ GIMT_Encode4(1293922), // Rule ID 9173 //
     /* 1293843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1293846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1293854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1293857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1293860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1293863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1293866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1293869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1293881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1293896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M4_MASK),
     /* 1293899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1293917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1293920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1293921 */     // GIR_Coverage, 9173,
     /* 1293921 */     GIR_EraseRootFromParent_Done,
     /* 1293922 */   // Label 18562: @1293922
     /* 1293922 */   GIM_Try, /*On fail goto*//*Label 18563*/ GIMT_Encode4(1294006), // Rule ID 9176 //
     /* 1293927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1293930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1293935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1293938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1293941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1293944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1293947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1293950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1293953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1293961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1293965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1293969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1293973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1293980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1293980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1293983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1293985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1293987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1293989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1293991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1293993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1293998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294005 */     // GIR_Coverage, 9176,
     /* 1294005 */     GIR_EraseRootFromParent_Done,
     /* 1294006 */   // Label 18563: @1294006
     /* 1294006 */   GIM_Try, /*On fail goto*//*Label 18564*/ GIMT_Encode4(1294090), // Rule ID 9177 //
     /* 1294011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1294014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1294019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1294022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1294025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1294028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1294034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1294049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGTU_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGTU_VX_M8_MASK),
     /* 1294067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1294085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294089 */     // GIR_Coverage, 9177,
     /* 1294089 */     GIR_EraseRootFromParent_Done,
     /* 1294090 */   // Label 18564: @1294090
     /* 1294090 */   GIM_Try, /*On fail goto*//*Label 18565*/ GIMT_Encode4(1294174), // Rule ID 9268 //
     /* 1294095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1294112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1294151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294173 */     // GIR_Coverage, 9268,
     /* 1294173 */     GIR_EraseRootFromParent_Done,
     /* 1294174 */   // Label 18565: @1294174
     /* 1294174 */   GIM_Try, /*On fail goto*//*Label 18566*/ GIMT_Encode4(1294258), // Rule ID 9269 //
     /* 1294179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1294196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF8_MASK),
     /* 1294235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294257 */     // GIR_Coverage, 9269,
     /* 1294257 */     GIR_EraseRootFromParent_Done,
     /* 1294258 */   // Label 18566: @1294258
     /* 1294258 */   GIM_Try, /*On fail goto*//*Label 18567*/ GIMT_Encode4(1294342), // Rule ID 9272 //
     /* 1294263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1294280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1294319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294341 */     // GIR_Coverage, 9272,
     /* 1294341 */     GIR_EraseRootFromParent_Done,
     /* 1294342 */   // Label 18567: @1294342
     /* 1294342 */   GIM_Try, /*On fail goto*//*Label 18568*/ GIMT_Encode4(1294426), // Rule ID 9273 //
     /* 1294347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1294364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1294403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294425 */     // GIR_Coverage, 9273,
     /* 1294425 */     GIR_EraseRootFromParent_Done,
     /* 1294426 */   // Label 18568: @1294426
     /* 1294426 */   GIM_Try, /*On fail goto*//*Label 18569*/ GIMT_Encode4(1294510), // Rule ID 9276 //
     /* 1294431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1294487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294509 */     // GIR_Coverage, 9276,
     /* 1294509 */     GIR_EraseRootFromParent_Done,
     /* 1294510 */   // Label 18569: @1294510
     /* 1294510 */   GIM_Try, /*On fail goto*//*Label 18570*/ GIMT_Encode4(1294594), // Rule ID 9277 //
     /* 1294515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1294526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1294529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1294532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1294538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294568 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1294571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1294589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294593 */     // GIR_Coverage, 9277,
     /* 1294593 */     GIR_EraseRootFromParent_Done,
     /* 1294594 */   // Label 18570: @1294594
     /* 1294594 */   GIM_Try, /*On fail goto*//*Label 18571*/ GIMT_Encode4(1294678), // Rule ID 9280 //
     /* 1294599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294652 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1294655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294677 */     // GIR_Coverage, 9280,
     /* 1294677 */     GIR_EraseRootFromParent_Done,
     /* 1294678 */   // Label 18571: @1294678
     /* 1294678 */   GIM_Try, /*On fail goto*//*Label 18572*/ GIMT_Encode4(1294762), // Rule ID 9281 //
     /* 1294683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1294700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294736 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF4_MASK),
     /* 1294739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294761 */     // GIR_Coverage, 9281,
     /* 1294761 */     GIR_EraseRootFromParent_Done,
     /* 1294762 */   // Label 18572: @1294762
     /* 1294762 */   GIM_Try, /*On fail goto*//*Label 18573*/ GIMT_Encode4(1294846), // Rule ID 9284 //
     /* 1294767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1294823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294845 */     // GIR_Coverage, 9284,
     /* 1294845 */     GIR_EraseRootFromParent_Done,
     /* 1294846 */   // Label 18573: @1294846
     /* 1294846 */   GIM_Try, /*On fail goto*//*Label 18574*/ GIMT_Encode4(1294930), // Rule ID 9285 //
     /* 1294851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1294854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1294862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1294865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1294868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1294871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1294874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1294877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1294904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1294907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1294917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1294922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1294925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1294928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1294929 */     // GIR_Coverage, 9285,
     /* 1294929 */     GIR_EraseRootFromParent_Done,
     /* 1294930 */   // Label 18574: @1294930
     /* 1294930 */   GIM_Try, /*On fail goto*//*Label 18575*/ GIMT_Encode4(1295014), // Rule ID 9288 //
     /* 1294935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1294938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1294943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1294946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1294949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1294952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1294955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1294958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1294961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1294973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1294977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1294981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1294988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1294988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1294991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1294993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1294995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1294997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1294999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295013 */     // GIR_Coverage, 9288,
     /* 1295013 */     GIR_EraseRootFromParent_Done,
     /* 1295014 */   // Label 18575: @1295014
     /* 1295014 */   GIM_Try, /*On fail goto*//*Label 18576*/ GIMT_Encode4(1295098), // Rule ID 9289 //
     /* 1295019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1295036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295072 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_MF2_MASK),
     /* 1295075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295097 */     // GIR_Coverage, 9289,
     /* 1295097 */     GIR_EraseRootFromParent_Done,
     /* 1295098 */   // Label 18576: @1295098
     /* 1295098 */   GIM_Try, /*On fail goto*//*Label 18577*/ GIMT_Encode4(1295182), // Rule ID 9292 //
     /* 1295103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1295120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295181 */     // GIR_Coverage, 9292,
     /* 1295181 */     GIR_EraseRootFromParent_Done,
     /* 1295182 */   // Label 18577: @1295182
     /* 1295182 */   GIM_Try, /*On fail goto*//*Label 18578*/ GIMT_Encode4(1295266), // Rule ID 9293 //
     /* 1295187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1295198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1295201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1295204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1295210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295265 */     // GIR_Coverage, 9293,
     /* 1295265 */     GIR_EraseRootFromParent_Done,
     /* 1295266 */   // Label 18578: @1295266
     /* 1295266 */   GIM_Try, /*On fail goto*//*Label 18579*/ GIMT_Encode4(1295350), // Rule ID 9296 //
     /* 1295271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1295288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295324 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295349 */     // GIR_Coverage, 9296,
     /* 1295349 */     GIR_EraseRootFromParent_Done,
     /* 1295350 */   // Label 18579: @1295350
     /* 1295350 */   GIM_Try, /*On fail goto*//*Label 18580*/ GIMT_Encode4(1295434), // Rule ID 9297 //
     /* 1295355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1295366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1295369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1295372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1295378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295408 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1295429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295433 */     // GIR_Coverage, 9297,
     /* 1295433 */     GIR_EraseRootFromParent_Done,
     /* 1295434 */   // Label 18580: @1295434
     /* 1295434 */   GIM_Try, /*On fail goto*//*Label 18581*/ GIMT_Encode4(1295518), // Rule ID 9300 //
     /* 1295439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295492 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295517 */     // GIR_Coverage, 9300,
     /* 1295517 */     GIR_EraseRootFromParent_Done,
     /* 1295518 */   // Label 18581: @1295518
     /* 1295518 */   GIM_Try, /*On fail goto*//*Label 18582*/ GIMT_Encode4(1295602), // Rule ID 9301 //
     /* 1295523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1295534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1295537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1295540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1295546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295576 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1295597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295601 */     // GIR_Coverage, 9301,
     /* 1295601 */     GIR_EraseRootFromParent_Done,
     /* 1295602 */   // Label 18582: @1295602
     /* 1295602 */   GIM_Try, /*On fail goto*//*Label 18583*/ GIMT_Encode4(1295686), // Rule ID 9304 //
     /* 1295607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1295610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295660 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295685 */     // GIR_Coverage, 9304,
     /* 1295685 */     GIR_EraseRootFromParent_Done,
     /* 1295686 */   // Label 18583: @1295686
     /* 1295686 */   GIM_Try, /*On fail goto*//*Label 18584*/ GIMT_Encode4(1295770), // Rule ID 9305 //
     /* 1295691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1295694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1295702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1295705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1295708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1295714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295744 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M1_MASK),
     /* 1295747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1295765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295769 */     // GIR_Coverage, 9305,
     /* 1295769 */     GIR_EraseRootFromParent_Done,
     /* 1295770 */   // Label 18584: @1295770
     /* 1295770 */   GIM_Try, /*On fail goto*//*Label 18585*/ GIMT_Encode4(1295854), // Rule ID 9308 //
     /* 1295775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1295831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295853 */     // GIR_Coverage, 9308,
     /* 1295853 */     GIR_EraseRootFromParent_Done,
     /* 1295854 */   // Label 18585: @1295854
     /* 1295854 */   GIM_Try, /*On fail goto*//*Label 18586*/ GIMT_Encode4(1295938), // Rule ID 9309 //
     /* 1295859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1295862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1295870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1295873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1295876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1295879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1295882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1295885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1295897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295912 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1295912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1295915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1295917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1295919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1295921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1295923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1295925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1295930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1295933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1295936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1295937 */     // GIR_Coverage, 9309,
     /* 1295937 */     GIR_EraseRootFromParent_Done,
     /* 1295938 */   // Label 18586: @1295938
     /* 1295938 */   GIM_Try, /*On fail goto*//*Label 18587*/ GIMT_Encode4(1296022), // Rule ID 9312 //
     /* 1295943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1295946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1295951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1295954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1295957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1295960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1295963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1295966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1295969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1295977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1295981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1295985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1295989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1295996 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1295996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1295999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296021 */     // GIR_Coverage, 9312,
     /* 1296021 */     GIR_EraseRootFromParent_Done,
     /* 1296022 */   // Label 18587: @1296022
     /* 1296022 */   GIM_Try, /*On fail goto*//*Label 18588*/ GIMT_Encode4(1296106), // Rule ID 9313 //
     /* 1296027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1296044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296080 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1296083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296105 */     // GIR_Coverage, 9313,
     /* 1296105 */     GIR_EraseRootFromParent_Done,
     /* 1296106 */   // Label 18588: @1296106
     /* 1296106 */   GIM_Try, /*On fail goto*//*Label 18589*/ GIMT_Encode4(1296190), // Rule ID 9316 //
     /* 1296111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1296122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1296125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1296128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1296134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296164 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1296167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296189 */     // GIR_Coverage, 9316,
     /* 1296189 */     GIR_EraseRootFromParent_Done,
     /* 1296190 */   // Label 18589: @1296190
     /* 1296190 */   GIM_Try, /*On fail goto*//*Label 18590*/ GIMT_Encode4(1296274), // Rule ID 9317 //
     /* 1296195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1296206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1296209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1296212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1296218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296248 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1296251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1296269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296273 */     // GIR_Coverage, 9317,
     /* 1296273 */     GIR_EraseRootFromParent_Done,
     /* 1296274 */   // Label 18590: @1296274
     /* 1296274 */   GIM_Try, /*On fail goto*//*Label 18591*/ GIMT_Encode4(1296358), // Rule ID 9320 //
     /* 1296279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1296296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296332 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1296335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296357 */     // GIR_Coverage, 9320,
     /* 1296357 */     GIR_EraseRootFromParent_Done,
     /* 1296358 */   // Label 18591: @1296358
     /* 1296358 */   GIM_Try, /*On fail goto*//*Label 18592*/ GIMT_Encode4(1296442), // Rule ID 9321 //
     /* 1296363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1296380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296416 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1296419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296441 */     // GIR_Coverage, 9321,
     /* 1296441 */     GIR_EraseRootFromParent_Done,
     /* 1296442 */   // Label 18592: @1296442
     /* 1296442 */   GIM_Try, /*On fail goto*//*Label 18593*/ GIMT_Encode4(1296526), // Rule ID 9324 //
     /* 1296447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296500 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1296503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296525 */     // GIR_Coverage, 9324,
     /* 1296525 */     GIR_EraseRootFromParent_Done,
     /* 1296526 */   // Label 18593: @1296526
     /* 1296526 */   GIM_Try, /*On fail goto*//*Label 18594*/ GIMT_Encode4(1296610), // Rule ID 9325 //
     /* 1296531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1296542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1296545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1296548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1296554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1296587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296609 */     // GIR_Coverage, 9325,
     /* 1296609 */     GIR_EraseRootFromParent_Done,
     /* 1296610 */   // Label 18594: @1296610
     /* 1296610 */   GIM_Try, /*On fail goto*//*Label 18595*/ GIMT_Encode4(1296694), // Rule ID 9328 //
     /* 1296615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296668 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1296671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296693 */     // GIR_Coverage, 9328,
     /* 1296693 */     GIR_EraseRootFromParent_Done,
     /* 1296694 */   // Label 18595: @1296694
     /* 1296694 */   GIM_Try, /*On fail goto*//*Label 18596*/ GIMT_Encode4(1296778), // Rule ID 9329 //
     /* 1296699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1296710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1296713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1296716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1296722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1296737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296752 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1296755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1296773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296777 */     // GIR_Coverage, 9329,
     /* 1296777 */     GIR_EraseRootFromParent_Done,
     /* 1296778 */   // Label 18596: @1296778
     /* 1296778 */   GIM_Try, /*On fail goto*//*Label 18597*/ GIMT_Encode4(1296862), // Rule ID 9332 //
     /* 1296783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296836 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1296836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1296839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296861 */     // GIR_Coverage, 9332,
     /* 1296861 */     GIR_EraseRootFromParent_Done,
     /* 1296862 */   // Label 18597: @1296862
     /* 1296862 */   GIM_Try, /*On fail goto*//*Label 18598*/ GIMT_Encode4(1296946), // Rule ID 9333 //
     /* 1296867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1296870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1296878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1296881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1296884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1296887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1296890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1296893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1296905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1296920 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1296920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1296923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1296925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1296927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1296929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1296931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1296933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1296938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1296941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1296944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1296945 */     // GIR_Coverage, 9333,
     /* 1296945 */     GIR_EraseRootFromParent_Done,
     /* 1296946 */   // Label 18598: @1296946
     /* 1296946 */   GIM_Try, /*On fail goto*//*Label 18599*/ GIMT_Encode4(1297030), // Rule ID 9336 //
     /* 1296951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1296954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1296959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1296962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1296965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1296968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1296971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1296974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1296977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1296985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1296989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1296993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1296997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297004 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1297007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297029 */     // GIR_Coverage, 9336,
     /* 1297029 */     GIR_EraseRootFromParent_Done,
     /* 1297030 */   // Label 18599: @1297030
     /* 1297030 */   GIM_Try, /*On fail goto*//*Label 18600*/ GIMT_Encode4(1297114), // Rule ID 9337 //
     /* 1297035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1297052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297088 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1297091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297113 */     // GIR_Coverage, 9337,
     /* 1297113 */     GIR_EraseRootFromParent_Done,
     /* 1297114 */   // Label 18600: @1297114
     /* 1297114 */   GIM_Try, /*On fail goto*//*Label 18601*/ GIMT_Encode4(1297198), // Rule ID 9340 //
     /* 1297119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1297136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297172 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1297175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297197 */     // GIR_Coverage, 9340,
     /* 1297197 */     GIR_EraseRootFromParent_Done,
     /* 1297198 */   // Label 18601: @1297198
     /* 1297198 */   GIM_Try, /*On fail goto*//*Label 18602*/ GIMT_Encode4(1297282), // Rule ID 9341 //
     /* 1297203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1297214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1297217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1297220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1297226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297256 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1297259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1297277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297281 */     // GIR_Coverage, 9341,
     /* 1297281 */     GIR_EraseRootFromParent_Done,
     /* 1297282 */   // Label 18602: @1297282
     /* 1297282 */   GIM_Try, /*On fail goto*//*Label 18603*/ GIMT_Encode4(1297366), // Rule ID 9344 //
     /* 1297287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1297304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1297343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297365 */     // GIR_Coverage, 9344,
     /* 1297365 */     GIR_EraseRootFromParent_Done,
     /* 1297366 */   // Label 18603: @1297366
     /* 1297366 */   GIM_Try, /*On fail goto*//*Label 18604*/ GIMT_Encode4(1297450), // Rule ID 9345 //
     /* 1297371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1297388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1297409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M2_MASK),
     /* 1297427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297449 */     // GIR_Coverage, 9345,
     /* 1297449 */     GIR_EraseRootFromParent_Done,
     /* 1297450 */   // Label 18604: @1297450
     /* 1297450 */   GIM_Try, /*On fail goto*//*Label 18605*/ GIMT_Encode4(1297534), // Rule ID 9348 //
     /* 1297455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297508 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1297511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297533 */     // GIR_Coverage, 9348,
     /* 1297533 */     GIR_EraseRootFromParent_Done,
     /* 1297534 */   // Label 18605: @1297534
     /* 1297534 */   GIM_Try, /*On fail goto*//*Label 18606*/ GIMT_Encode4(1297618), // Rule ID 9349 //
     /* 1297539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1297556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1297577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297592 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M4_MASK),
     /* 1297595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297617 */     // GIR_Coverage, 9349,
     /* 1297617 */     GIR_EraseRootFromParent_Done,
     /* 1297618 */   // Label 18606: @1297618
     /* 1297618 */   GIM_Try, /*On fail goto*//*Label 18607*/ GIMT_Encode4(1297702), // Rule ID 9352 //
     /* 1297623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1297626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1297643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1297679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297701 */     // GIR_Coverage, 9352,
     /* 1297701 */     GIR_EraseRootFromParent_Done,
     /* 1297702 */   // Label 18607: @1297702
     /* 1297702 */   GIM_Try, /*On fail goto*//*Label 18608*/ GIMT_Encode4(1297786), // Rule ID 9353 //
     /* 1297707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1297710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1297715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1297718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1297721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1297724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1297727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1297730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1297745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1297749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSGT_VX_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSGT_VX_M8_MASK),
     /* 1297763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1297769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1297771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1297781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297785 */     // GIR_Coverage, 9353,
     /* 1297785 */     GIR_EraseRootFromParent_Done,
     /* 1297786 */   // Label 18608: @1297786
     /* 1297786 */   GIM_Try, /*On fail goto*//*Label 18609*/ GIMT_Encode4(1297870), // Rule ID 9444 //
     /* 1297791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1297811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297844 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1297844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1297847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1297853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1297855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297869 */     // GIR_Coverage, 9444,
     /* 1297869 */     GIR_EraseRootFromParent_Done,
     /* 1297870 */   // Label 18609: @1297870
     /* 1297870 */   GIM_Try, /*On fail goto*//*Label 18610*/ GIMT_Encode4(1297954), // Rule ID 9445 //
     /* 1297875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1297878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1297886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1297889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1297892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1297895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1297898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1297901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1297921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1297928 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1297928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1297931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1297933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1297935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1297937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1297939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1297941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1297946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1297949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1297952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1297953 */     // GIR_Coverage, 9445,
     /* 1297953 */     GIR_EraseRootFromParent_Done,
     /* 1297954 */   // Label 18610: @1297954
     /* 1297954 */   GIM_Try, /*On fail goto*//*Label 18611*/ GIMT_Encode4(1298038), // Rule ID 9448 //
     /* 1297959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1297962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1297967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1297970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1297973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1297976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1297979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1297982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1297985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1297997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298012 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298037 */     // GIR_Coverage, 9448,
     /* 1298037 */     GIR_EraseRootFromParent_Done,
     /* 1298038 */   // Label 18611: @1298038
     /* 1298038 */   GIM_Try, /*On fail goto*//*Label 18612*/ GIMT_Encode4(1298122), // Rule ID 9449 //
     /* 1298043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1298060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1298063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298096 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298121 */     // GIR_Coverage, 9449,
     /* 1298121 */     GIR_EraseRootFromParent_Done,
     /* 1298122 */   // Label 18612: @1298122
     /* 1298122 */   GIM_Try, /*On fail goto*//*Label 18613*/ GIMT_Encode4(1298206), // Rule ID 9452 //
     /* 1298127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1298147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298180 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1298183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298205 */     // GIR_Coverage, 9452,
     /* 1298205 */     GIR_EraseRootFromParent_Done,
     /* 1298206 */   // Label 18613: @1298206
     /* 1298206 */   GIM_Try, /*On fail goto*//*Label 18614*/ GIMT_Encode4(1298290), // Rule ID 9453 //
     /* 1298211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1298228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1298231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298264 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4_MASK),
     /* 1298267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298289 */     // GIR_Coverage, 9453,
     /* 1298289 */     GIR_EraseRootFromParent_Done,
     /* 1298290 */   // Label 18614: @1298290
     /* 1298290 */   GIM_Try, /*On fail goto*//*Label 18615*/ GIMT_Encode4(1298374), // Rule ID 9456 //
     /* 1298295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1298315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298348 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298373 */     // GIR_Coverage, 9456,
     /* 1298373 */     GIR_EraseRootFromParent_Done,
     /* 1298374 */   // Label 18615: @1298374
     /* 1298374 */   GIM_Try, /*On fail goto*//*Label 18616*/ GIMT_Encode4(1298458), // Rule ID 9457 //
     /* 1298379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1298396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1298399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298432 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298457 */     // GIR_Coverage, 9457,
     /* 1298457 */     GIR_EraseRootFromParent_Done,
     /* 1298458 */   // Label 18616: @1298458
     /* 1298458 */   GIM_Try, /*On fail goto*//*Label 18617*/ GIMT_Encode4(1298542), // Rule ID 9460 //
     /* 1298463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1298483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298516 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298541 */     // GIR_Coverage, 9460,
     /* 1298541 */     GIR_EraseRootFromParent_Done,
     /* 1298542 */   // Label 18617: @1298542
     /* 1298542 */   GIM_Try, /*On fail goto*//*Label 18618*/ GIMT_Encode4(1298626), // Rule ID 9461 //
     /* 1298547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1298558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1298561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1298564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1298567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1298570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298600 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2_MASK),
     /* 1298603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1298621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298625 */     // GIR_Coverage, 9461,
     /* 1298625 */     GIR_EraseRootFromParent_Done,
     /* 1298626 */   // Label 18618: @1298626
     /* 1298626 */   GIM_Try, /*On fail goto*//*Label 18619*/ GIMT_Encode4(1298710), // Rule ID 9464 //
     /* 1298631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1298651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298684 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1298687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298709 */     // GIR_Coverage, 9464,
     /* 1298709 */     GIR_EraseRootFromParent_Done,
     /* 1298710 */   // Label 18619: @1298710
     /* 1298710 */   GIM_Try, /*On fail goto*//*Label 18620*/ GIMT_Encode4(1298794), // Rule ID 9465 //
     /* 1298715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1298726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1298729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1298732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1298735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1298738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298768 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1298771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1298789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298793 */     // GIR_Coverage, 9465,
     /* 1298793 */     GIR_EraseRootFromParent_Done,
     /* 1298794 */   // Label 18620: @1298794
     /* 1298794 */   GIM_Try, /*On fail goto*//*Label 18621*/ GIMT_Encode4(1298878), // Rule ID 9468 //
     /* 1298799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1298852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1298855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298877 */     // GIR_Coverage, 9468,
     /* 1298877 */     GIR_EraseRootFromParent_Done,
     /* 1298878 */   // Label 18621: @1298878
     /* 1298878 */   GIM_Try, /*On fail goto*//*Label 18622*/ GIMT_Encode4(1298962), // Rule ID 9469 //
     /* 1298883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1298886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1298894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1298897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1298900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1298903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1298906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1298909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1298929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1298936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1298936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1298939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1298941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1298943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1298945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1298947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1298949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1298954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1298957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1298960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1298961 */     // GIR_Coverage, 9469,
     /* 1298961 */     GIR_EraseRootFromParent_Done,
     /* 1298962 */   // Label 18622: @1298962
     /* 1298962 */   GIM_Try, /*On fail goto*//*Label 18623*/ GIMT_Encode4(1299046), // Rule ID 9472 //
     /* 1298967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1298970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1298975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1298978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1298981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1298984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1298987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1298990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1298993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1298997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299020 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1299023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299045 */     // GIR_Coverage, 9472,
     /* 1299045 */     GIR_EraseRootFromParent_Done,
     /* 1299046 */   // Label 18623: @1299046
     /* 1299046 */   GIM_Try, /*On fail goto*//*Label 18624*/ GIMT_Encode4(1299130), // Rule ID 9473 //
     /* 1299051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1299062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1299065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1299068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1299071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1299074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299104 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1299107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1299125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299129 */     // GIR_Coverage, 9473,
     /* 1299129 */     GIR_EraseRootFromParent_Done,
     /* 1299130 */   // Label 18624: @1299130
     /* 1299130 */   GIM_Try, /*On fail goto*//*Label 18625*/ GIMT_Encode4(1299214), // Rule ID 9476 //
     /* 1299135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1299138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1299155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1299191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299213 */     // GIR_Coverage, 9476,
     /* 1299213 */     GIR_EraseRootFromParent_Done,
     /* 1299214 */   // Label 18625: @1299214
     /* 1299214 */   GIM_Try, /*On fail goto*//*Label 18626*/ GIMT_Encode4(1299298), // Rule ID 9477 //
     /* 1299219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1299222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1299230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1299233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1299236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1299239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1299242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1_MASK),
     /* 1299275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1299293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299297 */     // GIR_Coverage, 9477,
     /* 1299297 */     GIR_EraseRootFromParent_Done,
     /* 1299298 */   // Label 18626: @1299298
     /* 1299298 */   GIM_Try, /*On fail goto*//*Label 18627*/ GIMT_Encode4(1299382), // Rule ID 9480 //
     /* 1299303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1299323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299356 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1299359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299381 */     // GIR_Coverage, 9480,
     /* 1299381 */     GIR_EraseRootFromParent_Done,
     /* 1299382 */   // Label 18627: @1299382
     /* 1299382 */   GIM_Try, /*On fail goto*//*Label 18628*/ GIMT_Encode4(1299466), // Rule ID 9481 //
     /* 1299387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1299404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1299407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299440 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1299443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299465 */     // GIR_Coverage, 9481,
     /* 1299465 */     GIR_EraseRootFromParent_Done,
     /* 1299466 */   // Label 18628: @1299466
     /* 1299466 */   GIM_Try, /*On fail goto*//*Label 18629*/ GIMT_Encode4(1299550), // Rule ID 9484 //
     /* 1299471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1299491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299524 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1299527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299549 */     // GIR_Coverage, 9484,
     /* 1299549 */     GIR_EraseRootFromParent_Done,
     /* 1299550 */   // Label 18629: @1299550
     /* 1299550 */   GIM_Try, /*On fail goto*//*Label 18630*/ GIMT_Encode4(1299634), // Rule ID 9485 //
     /* 1299555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1299566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1299569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1299572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1299575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1299578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1299597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299608 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1299611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299633 */     // GIR_Coverage, 9485,
     /* 1299633 */     GIR_EraseRootFromParent_Done,
     /* 1299634 */   // Label 18630: @1299634
     /* 1299634 */   GIM_Try, /*On fail goto*//*Label 18631*/ GIMT_Encode4(1299718), // Rule ID 9488 //
     /* 1299639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1299659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299692 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1299695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299717 */     // GIR_Coverage, 9488,
     /* 1299717 */     GIR_EraseRootFromParent_Done,
     /* 1299718 */   // Label 18631: @1299718
     /* 1299718 */   GIM_Try, /*On fail goto*//*Label 18632*/ GIMT_Encode4(1299802), // Rule ID 9489 //
     /* 1299723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1299734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1299737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1299740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1299743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1299746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1299765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299776 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1299779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1299797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299801 */     // GIR_Coverage, 9489,
     /* 1299801 */     GIR_EraseRootFromParent_Done,
     /* 1299802 */   // Label 18632: @1299802
     /* 1299802 */   GIM_Try, /*On fail goto*//*Label 18633*/ GIMT_Encode4(1299886), // Rule ID 9492 //
     /* 1299807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1299827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1299833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299860 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1299860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1299863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299885 */     // GIR_Coverage, 9492,
     /* 1299885 */     GIR_EraseRootFromParent_Done,
     /* 1299886 */   // Label 18633: @1299886
     /* 1299886 */   GIM_Try, /*On fail goto*//*Label 18634*/ GIMT_Encode4(1299970), // Rule ID 9493 //
     /* 1299891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1299894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1299902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1299905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1299908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1299911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1299914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1299917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1299925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1299933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1299937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1299944 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1299944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1299947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1299949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1299951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1299953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1299955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1299957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1299962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1299965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1299968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1299969 */     // GIR_Coverage, 9493,
     /* 1299969 */     GIR_EraseRootFromParent_Done,
     /* 1299970 */   // Label 18634: @1299970
     /* 1299970 */   GIM_Try, /*On fail goto*//*Label 18635*/ GIMT_Encode4(1300054), // Rule ID 9496 //
     /* 1299975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1299978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1299983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1299986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1299989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1299992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1299995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1299998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300028 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1300031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300053 */     // GIR_Coverage, 9496,
     /* 1300053 */     GIR_EraseRootFromParent_Done,
     /* 1300054 */   // Label 18635: @1300054
     /* 1300054 */   GIM_Try, /*On fail goto*//*Label 18636*/ GIMT_Encode4(1300138), // Rule ID 9497 //
     /* 1300059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1300076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1300079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300112 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1300115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300137 */     // GIR_Coverage, 9497,
     /* 1300137 */     GIR_EraseRootFromParent_Done,
     /* 1300138 */   // Label 18636: @1300138
     /* 1300138 */   GIM_Try, /*On fail goto*//*Label 18637*/ GIMT_Encode4(1300222), // Rule ID 9500 //
     /* 1300143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1300163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300196 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1300199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300221 */     // GIR_Coverage, 9500,
     /* 1300221 */     GIR_EraseRootFromParent_Done,
     /* 1300222 */   // Label 18637: @1300222
     /* 1300222 */   GIM_Try, /*On fail goto*//*Label 18638*/ GIMT_Encode4(1300306), // Rule ID 9501 //
     /* 1300227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1300238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1300241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1300244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1300247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1300250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300280 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1300283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1300301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300305 */     // GIR_Coverage, 9501,
     /* 1300305 */     GIR_EraseRootFromParent_Done,
     /* 1300306 */   // Label 18638: @1300306
     /* 1300306 */   GIM_Try, /*On fail goto*//*Label 18639*/ GIMT_Encode4(1300390), // Rule ID 9504 //
     /* 1300311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1300331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300364 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1300367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300389 */     // GIR_Coverage, 9504,
     /* 1300389 */     GIR_EraseRootFromParent_Done,
     /* 1300390 */   // Label 18639: @1300390
     /* 1300390 */   GIM_Try, /*On fail goto*//*Label 18640*/ GIMT_Encode4(1300474), // Rule ID 9505 //
     /* 1300395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1300412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1300415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1300418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300448 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1300451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300473 */     // GIR_Coverage, 9505,
     /* 1300473 */     GIR_EraseRootFromParent_Done,
     /* 1300474 */   // Label 18640: @1300474
     /* 1300474 */   GIM_Try, /*On fail goto*//*Label 18641*/ GIMT_Encode4(1300558), // Rule ID 9508 //
     /* 1300479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1300499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300532 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1300535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300557 */     // GIR_Coverage, 9508,
     /* 1300557 */     GIR_EraseRootFromParent_Done,
     /* 1300558 */   // Label 18641: @1300558
     /* 1300558 */   GIM_Try, /*On fail goto*//*Label 18642*/ GIMT_Encode4(1300642), // Rule ID 9509 //
     /* 1300563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1300574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1300577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1300580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1300583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1300586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1300605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1300619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300641 */     // GIR_Coverage, 9509,
     /* 1300641 */     GIR_EraseRootFromParent_Done,
     /* 1300642 */   // Label 18642: @1300642
     /* 1300642 */   GIM_Try, /*On fail goto*//*Label 18643*/ GIMT_Encode4(1300726), // Rule ID 9512 //
     /* 1300647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1300650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1300667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300700 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1300703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300725 */     // GIR_Coverage, 9512,
     /* 1300725 */     GIR_EraseRootFromParent_Done,
     /* 1300726 */   // Label 18643: @1300726
     /* 1300726 */   GIM_Try, /*On fail goto*//*Label 18644*/ GIMT_Encode4(1300810), // Rule ID 9513 //
     /* 1300731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1300734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1300742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1300745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1300748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1300751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1300754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1300773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300784 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1300787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1300805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300809 */     // GIR_Coverage, 9513,
     /* 1300809 */     GIR_EraseRootFromParent_Done,
     /* 1300810 */   // Label 18644: @1300810
     /* 1300810 */   GIM_Try, /*On fail goto*//*Label 18645*/ GIMT_Encode4(1300894), // Rule ID 9516 //
     /* 1300815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1300835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1300841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300868 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1300868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1300871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300893 */     // GIR_Coverage, 9516,
     /* 1300893 */     GIR_EraseRootFromParent_Done,
     /* 1300894 */   // Label 18645: @1300894
     /* 1300894 */   GIM_Try, /*On fail goto*//*Label 18646*/ GIMT_Encode4(1300978), // Rule ID 9517 //
     /* 1300899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1300902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1300910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1300913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1300916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1300919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1300922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1300925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1300933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1300941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1300945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1300952 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1300952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2_MASK),
     /* 1300955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1300957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1300959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1300961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1300963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1300965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1300970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1300973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1300976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1300977 */     // GIR_Coverage, 9517,
     /* 1300977 */     GIR_EraseRootFromParent_Done,
     /* 1300978 */   // Label 18646: @1300978
     /* 1300978 */   GIM_Try, /*On fail goto*//*Label 18647*/ GIMT_Encode4(1301062), // Rule ID 9520 //
     /* 1300983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1300986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1300991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1300994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1300997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1301000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1301003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301036 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1301039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301061 */     // GIR_Coverage, 9520,
     /* 1301061 */     GIR_EraseRootFromParent_Done,
     /* 1301062 */   // Label 18647: @1301062
     /* 1301062 */   GIM_Try, /*On fail goto*//*Label 18648*/ GIMT_Encode4(1301146), // Rule ID 9521 //
     /* 1301067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1301084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1301087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1301109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301120 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4_MASK),
     /* 1301123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301145 */     // GIR_Coverage, 9521,
     /* 1301145 */     GIR_EraseRootFromParent_Done,
     /* 1301146 */   // Label 18648: @1301146
     /* 1301146 */   GIM_Try, /*On fail goto*//*Label 18649*/ GIMT_Encode4(1301230), // Rule ID 9524 //
     /* 1301151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1301154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1301171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1301207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301229 */     // GIR_Coverage, 9524,
     /* 1301229 */     GIR_EraseRootFromParent_Done,
     /* 1301230 */   // Label 18649: @1301230
     /* 1301230 */   GIM_Try, /*On fail goto*//*Label 18650*/ GIMT_Encode4(1301314), // Rule ID 9525 //
     /* 1301235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1301238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgtu_mask),
     /* 1301243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1301246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1301249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1301252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1301255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1301258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1301277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301288 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11385:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLTU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8_MASK),
     /* 1301291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1301309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301313 */     // GIR_Coverage, 9525,
     /* 1301313 */     GIR_EraseRootFromParent_Done,
     /* 1301314 */   // Label 18650: @1301314
     /* 1301314 */   GIM_Try, /*On fail goto*//*Label 18651*/ GIMT_Encode4(1301398), // Rule ID 9528 //
     /* 1301319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1301339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301372 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1301375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301397 */     // GIR_Coverage, 9528,
     /* 1301397 */     GIR_EraseRootFromParent_Done,
     /* 1301398 */   // Label 18651: @1301398
     /* 1301398 */   GIM_Try, /*On fail goto*//*Label 18652*/ GIMT_Encode4(1301482), // Rule ID 9529 //
     /* 1301403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1301420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1301423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301456 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8_MASK),
     /* 1301459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301481 */     // GIR_Coverage, 9529,
     /* 1301481 */     GIR_EraseRootFromParent_Done,
     /* 1301482 */   // Label 18652: @1301482
     /* 1301482 */   GIM_Try, /*On fail goto*//*Label 18653*/ GIMT_Encode4(1301566), // Rule ID 9532 //
     /* 1301487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1301507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301540 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1301543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301565 */     // GIR_Coverage, 9532,
     /* 1301565 */     GIR_EraseRootFromParent_Done,
     /* 1301566 */   // Label 18653: @1301566
     /* 1301566 */   GIM_Try, /*On fail goto*//*Label 18654*/ GIMT_Encode4(1301650), // Rule ID 9533 //
     /* 1301571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1301582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1301585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1301588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1301591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1301594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301624 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1301627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301649 */     // GIR_Coverage, 9533,
     /* 1301649 */     GIR_EraseRootFromParent_Done,
     /* 1301650 */   // Label 18654: @1301650
     /* 1301650 */   GIM_Try, /*On fail goto*//*Label 18655*/ GIMT_Encode4(1301734), // Rule ID 9536 //
     /* 1301655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1301675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301708 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1301711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301733 */     // GIR_Coverage, 9536,
     /* 1301733 */     GIR_EraseRootFromParent_Done,
     /* 1301734 */   // Label 18655: @1301734
     /* 1301734 */   GIM_Try, /*On fail goto*//*Label 18656*/ GIMT_Encode4(1301818), // Rule ID 9537 //
     /* 1301739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1301750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1301753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1301756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1301759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1301762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301792 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1301795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1301813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301817 */     // GIR_Coverage, 9537,
     /* 1301817 */     GIR_EraseRootFromParent_Done,
     /* 1301818 */   // Label 18656: @1301818
     /* 1301818 */   GIM_Try, /*On fail goto*//*Label 18657*/ GIMT_Encode4(1301902), // Rule ID 9540 //
     /* 1301823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1301843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1301849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301876 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1301876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1301879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301901 */     // GIR_Coverage, 9540,
     /* 1301901 */     GIR_EraseRootFromParent_Done,
     /* 1301902 */   // Label 18657: @1301902
     /* 1301902 */   GIM_Try, /*On fail goto*//*Label 18658*/ GIMT_Encode4(1301986), // Rule ID 9541 //
     /* 1301907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1301910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1301918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1301921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1301924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1301927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1301930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1301933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1301949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1301953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1301960 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1301960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4_MASK),
     /* 1301963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1301965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1301967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1301969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1301971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1301973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1301978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1301981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1301984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1301985 */     // GIR_Coverage, 9541,
     /* 1301985 */     GIR_EraseRootFromParent_Done,
     /* 1301986 */   // Label 18658: @1301986
     /* 1301986 */   GIM_Try, /*On fail goto*//*Label 18659*/ GIMT_Encode4(1302070), // Rule ID 9544 //
     /* 1301991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1301994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1301999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1302008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1302011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1302047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302069 */     // GIR_Coverage, 9544,
     /* 1302069 */     GIR_EraseRootFromParent_Done,
     /* 1302070 */   // Label 18659: @1302070
     /* 1302070 */   GIM_Try, /*On fail goto*//*Label 18660*/ GIMT_Encode4(1302154), // Rule ID 9545 //
     /* 1302075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1302092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1302095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302128 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1302131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302153 */     // GIR_Coverage, 9545,
     /* 1302153 */     GIR_EraseRootFromParent_Done,
     /* 1302154 */   // Label 18660: @1302154
     /* 1302154 */   GIM_Try, /*On fail goto*//*Label 18661*/ GIMT_Encode4(1302238), // Rule ID 9548 //
     /* 1302159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1302179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302212 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1302215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302237 */     // GIR_Coverage, 9548,
     /* 1302237 */     GIR_EraseRootFromParent_Done,
     /* 1302238 */   // Label 18661: @1302238
     /* 1302238 */   GIM_Try, /*On fail goto*//*Label 18662*/ GIMT_Encode4(1302322), // Rule ID 9549 //
     /* 1302243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1302260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1302263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302296 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2_MASK),
     /* 1302299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302321 */     // GIR_Coverage, 9549,
     /* 1302321 */     GIR_EraseRootFromParent_Done,
     /* 1302322 */   // Label 18662: @1302322
     /* 1302322 */   GIM_Try, /*On fail goto*//*Label 18663*/ GIMT_Encode4(1302406), // Rule ID 9552 //
     /* 1302327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1302347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302380 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302405 */     // GIR_Coverage, 9552,
     /* 1302405 */     GIR_EraseRootFromParent_Done,
     /* 1302406 */   // Label 18663: @1302406
     /* 1302406 */   GIM_Try, /*On fail goto*//*Label 18664*/ GIMT_Encode4(1302490), // Rule ID 9553 //
     /* 1302411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1302422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1302425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1302428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1302431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1302434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302464 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1302485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302489 */     // GIR_Coverage, 9553,
     /* 1302489 */     GIR_EraseRootFromParent_Done,
     /* 1302490 */   // Label 18664: @1302490
     /* 1302490 */   GIM_Try, /*On fail goto*//*Label 18665*/ GIMT_Encode4(1302574), // Rule ID 9556 //
     /* 1302495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1302515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302548 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302573 */     // GIR_Coverage, 9556,
     /* 1302573 */     GIR_EraseRootFromParent_Done,
     /* 1302574 */   // Label 18665: @1302574
     /* 1302574 */   GIM_Try, /*On fail goto*//*Label 18666*/ GIMT_Encode4(1302658), // Rule ID 9557 //
     /* 1302579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1302590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1302593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1302596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1302599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1302602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302632 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1302653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302657 */     // GIR_Coverage, 9557,
     /* 1302657 */     GIR_EraseRootFromParent_Done,
     /* 1302658 */   // Label 18666: @1302658
     /* 1302658 */   GIM_Try, /*On fail goto*//*Label 18667*/ GIMT_Encode4(1302742), // Rule ID 9560 //
     /* 1302663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1302666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1302683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302716 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302741 */     // GIR_Coverage, 9560,
     /* 1302741 */     GIR_EraseRootFromParent_Done,
     /* 1302742 */   // Label 18667: @1302742
     /* 1302742 */   GIM_Try, /*On fail goto*//*Label 18668*/ GIMT_Encode4(1302826), // Rule ID 9561 //
     /* 1302747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1302750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1302758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1302761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1302764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1302767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1302770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302800 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1302821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302825 */     // GIR_Coverage, 9561,
     /* 1302825 */     GIR_EraseRootFromParent_Done,
     /* 1302826 */   // Label 18668: @1302826
     /* 1302826 */   GIM_Try, /*On fail goto*//*Label 18669*/ GIMT_Encode4(1302910), // Rule ID 9564 //
     /* 1302831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1302834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1302851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1302857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302884 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1302884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302909 */     // GIR_Coverage, 9564,
     /* 1302909 */     GIR_EraseRootFromParent_Done,
     /* 1302910 */   // Label 18669: @1302910
     /* 1302910 */   GIM_Try, /*On fail goto*//*Label 18670*/ GIMT_Encode4(1302994), // Rule ID 9565 //
     /* 1302915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1302918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1302923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1302926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1302929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1302932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1302935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1302938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1302941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1302957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1302961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1302968 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1302968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1_MASK),
     /* 1302971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1302973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1302975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1302977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1302979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1302981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1302986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1302989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1302992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1302993 */     // GIR_Coverage, 9565,
     /* 1302993 */     GIR_EraseRootFromParent_Done,
     /* 1302994 */   // Label 18670: @1302994
     /* 1302994 */   GIM_Try, /*On fail goto*//*Label 18671*/ GIMT_Encode4(1303078), // Rule ID 9568 //
     /* 1302999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1303016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1303019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303052 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1303055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303077 */     // GIR_Coverage, 9568,
     /* 1303077 */     GIR_EraseRootFromParent_Done,
     /* 1303078 */   // Label 18671: @1303078
     /* 1303078 */   GIM_Try, /*On fail goto*//*Label 18672*/ GIMT_Encode4(1303162), // Rule ID 9569 //
     /* 1303083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1303100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1303103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303136 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1303139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303161 */     // GIR_Coverage, 9569,
     /* 1303161 */     GIR_EraseRootFromParent_Done,
     /* 1303162 */   // Label 18672: @1303162
     /* 1303162 */   GIM_Try, /*On fail goto*//*Label 18673*/ GIMT_Encode4(1303246), // Rule ID 9572 //
     /* 1303167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1303187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303220 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1303223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303245 */     // GIR_Coverage, 9572,
     /* 1303245 */     GIR_EraseRootFromParent_Done,
     /* 1303246 */   // Label 18673: @1303246
     /* 1303246 */   GIM_Try, /*On fail goto*//*Label 18674*/ GIMT_Encode4(1303330), // Rule ID 9573 //
     /* 1303251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1303268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1303271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303304 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1303307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303329 */     // GIR_Coverage, 9573,
     /* 1303329 */     GIR_EraseRootFromParent_Done,
     /* 1303330 */   // Label 18674: @1303330
     /* 1303330 */   GIM_Try, /*On fail goto*//*Label 18675*/ GIMT_Encode4(1303414), // Rule ID 9576 //
     /* 1303335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1303355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303388 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1303391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303413 */     // GIR_Coverage, 9576,
     /* 1303413 */     GIR_EraseRootFromParent_Done,
     /* 1303414 */   // Label 18675: @1303414
     /* 1303414 */   GIM_Try, /*On fail goto*//*Label 18676*/ GIMT_Encode4(1303498), // Rule ID 9577 //
     /* 1303419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1303430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1303433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1303436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1303439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1303442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303472 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1303475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1303493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303497 */     // GIR_Coverage, 9577,
     /* 1303497 */     GIR_EraseRootFromParent_Done,
     /* 1303498 */   // Label 18676: @1303498
     /* 1303498 */   GIM_Try, /*On fail goto*//*Label 18677*/ GIMT_Encode4(1303582), // Rule ID 9580 //
     /* 1303503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1303523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303556 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1303559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303581 */     // GIR_Coverage, 9580,
     /* 1303581 */     GIR_EraseRootFromParent_Done,
     /* 1303582 */   // Label 18677: @1303582
     /* 1303582 */   GIM_Try, /*On fail goto*//*Label 18678*/ GIMT_Encode4(1303666), // Rule ID 9581 //
     /* 1303587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1303598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1303601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1303604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1303607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1303610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1303629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303640 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1303643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303665 */     // GIR_Coverage, 9581,
     /* 1303665 */     GIR_EraseRootFromParent_Done,
     /* 1303666 */   // Label 18678: @1303666
     /* 1303666 */   GIM_Try, /*On fail goto*//*Label 18679*/ GIMT_Encode4(1303750), // Rule ID 9584 //
     /* 1303671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1303691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303724 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1303727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303749 */     // GIR_Coverage, 9584,
     /* 1303749 */     GIR_EraseRootFromParent_Done,
     /* 1303750 */   // Label 18679: @1303750
     /* 1303750 */   GIM_Try, /*On fail goto*//*Label 18680*/ GIMT_Encode4(1303834), // Rule ID 9585 //
     /* 1303755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1303766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1303769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1303772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1303775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1303778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1303797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303808 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1303811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303833 */     // GIR_Coverage, 9585,
     /* 1303833 */     GIR_EraseRootFromParent_Done,
     /* 1303834 */   // Label 18680: @1303834
     /* 1303834 */   GIM_Try, /*On fail goto*//*Label 18681*/ GIMT_Encode4(1303918), // Rule ID 9588 //
     /* 1303839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1303842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1303859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1303865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303892 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1303892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1303895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1303916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1303917 */     // GIR_Coverage, 9588,
     /* 1303917 */     GIR_EraseRootFromParent_Done,
     /* 1303918 */   // Label 18681: @1303918
     /* 1303918 */   GIM_Try, /*On fail goto*//*Label 18682*/ GIMT_Encode4(1304002), // Rule ID 9589 //
     /* 1303923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1303926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1303931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1303934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1303937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1303940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1303943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1303946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1303949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1303957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1303965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1303969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1303976 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1303976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1303979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1303981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1303983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1303985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1303987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1303989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1303994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1303997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304001 */     // GIR_Coverage, 9589,
     /* 1304001 */     GIR_EraseRootFromParent_Done,
     /* 1304002 */   // Label 18682: @1304002
     /* 1304002 */   GIM_Try, /*On fail goto*//*Label 18683*/ GIMT_Encode4(1304086), // Rule ID 9592 //
     /* 1304007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1304027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304060 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1304063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304085 */     // GIR_Coverage, 9592,
     /* 1304085 */     GIR_EraseRootFromParent_Done,
     /* 1304086 */   // Label 18683: @1304086
     /* 1304086 */   GIM_Try, /*On fail goto*//*Label 18684*/ GIMT_Encode4(1304170), // Rule ID 9593 //
     /* 1304091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1304108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1304111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304144 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1304147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304169 */     // GIR_Coverage, 9593,
     /* 1304169 */     GIR_EraseRootFromParent_Done,
     /* 1304170 */   // Label 18684: @1304170
     /* 1304170 */   GIM_Try, /*On fail goto*//*Label 18685*/ GIMT_Encode4(1304254), // Rule ID 9596 //
     /* 1304175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1304195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304228 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1304231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304253 */     // GIR_Coverage, 9596,
     /* 1304253 */     GIR_EraseRootFromParent_Done,
     /* 1304254 */   // Label 18685: @1304254
     /* 1304254 */   GIM_Try, /*On fail goto*//*Label 18686*/ GIMT_Encode4(1304338), // Rule ID 9597 //
     /* 1304259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1304276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1304279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304312 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1304315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304337 */     // GIR_Coverage, 9597,
     /* 1304337 */     GIR_EraseRootFromParent_Done,
     /* 1304338 */   // Label 18686: @1304338
     /* 1304338 */   GIM_Try, /*On fail goto*//*Label 18687*/ GIMT_Encode4(1304422), // Rule ID 9600 //
     /* 1304343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1304346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1304363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304396 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1304399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304421 */     // GIR_Coverage, 9600,
     /* 1304421 */     GIR_EraseRootFromParent_Done,
     /* 1304422 */   // Label 18687: @1304422
     /* 1304422 */   GIM_Try, /*On fail goto*//*Label 18688*/ GIMT_Encode4(1304506), // Rule ID 9601 //
     /* 1304427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1304430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1304438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1304441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1304444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1304447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1304450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304480 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1304483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1304501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304505 */     // GIR_Coverage, 9601,
     /* 1304505 */     GIR_EraseRootFromParent_Done,
     /* 1304506 */   // Label 18688: @1304506
     /* 1304506 */   GIM_Try, /*On fail goto*//*Label 18689*/ GIMT_Encode4(1304590), // Rule ID 9604 //
     /* 1304511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1304531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304564 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1304567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304589 */     // GIR_Coverage, 9604,
     /* 1304589 */     GIR_EraseRootFromParent_Done,
     /* 1304590 */   // Label 18689: @1304590
     /* 1304590 */   GIM_Try, /*On fail goto*//*Label 18690*/ GIMT_Encode4(1304674), // Rule ID 9605 //
     /* 1304595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1304606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1304609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1304612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1304615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1304618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1304637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304648 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2_MASK),
     /* 1304651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304673 */     // GIR_Coverage, 9605,
     /* 1304673 */     GIR_EraseRootFromParent_Done,
     /* 1304674 */   // Label 18690: @1304674
     /* 1304674 */   GIM_Try, /*On fail goto*//*Label 18691*/ GIMT_Encode4(1304758), // Rule ID 9608 //
     /* 1304679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1304699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1304735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304757 */     // GIR_Coverage, 9608,
     /* 1304757 */     GIR_EraseRootFromParent_Done,
     /* 1304758 */   // Label 18691: @1304758
     /* 1304758 */   GIM_Try, /*On fail goto*//*Label 18692*/ GIMT_Encode4(1304842), // Rule ID 9609 //
     /* 1304763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1304774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1304777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1304780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1304783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1304786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1304805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4_MASK),
     /* 1304819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304841 */     // GIR_Coverage, 9609,
     /* 1304841 */     GIR_EraseRootFromParent_Done,
     /* 1304842 */   // Label 18692: @1304842
     /* 1304842 */   GIM_Try, /*On fail goto*//*Label 18693*/ GIMT_Encode4(1304926), // Rule ID 9612 //
     /* 1304847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1304850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1304867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1304873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304900 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1304900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1304903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1304918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1304921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1304924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1304925 */     // GIR_Coverage, 9612,
     /* 1304925 */     GIR_EraseRootFromParent_Done,
     /* 1304926 */   // Label 18693: @1304926
     /* 1304926 */   GIM_Try, /*On fail goto*//*Label 18694*/ GIMT_Encode4(1305010), // Rule ID 9613 //
     /* 1304931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1304934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgt_mask),
     /* 1304939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1304942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1304945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1304948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1304951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1304954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1304957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1304965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1304973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1304977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1304984 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11383:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1304984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8_MASK),
     /* 1304987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1304989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1304991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1304993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1304995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1304997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1305005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305009 */     // GIR_Coverage, 9613,
     /* 1305009 */     GIR_EraseRootFromParent_Done,
     /* 1305010 */   // Label 18694: @1305010
     /* 1305010 */   GIM_Try, /*On fail goto*//*Label 18695*/ GIMT_Encode4(1305094), // Rule ID 9616 //
     /* 1305015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1305032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1305035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305068 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1305071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305093 */     // GIR_Coverage, 9616,
     /* 1305093 */     GIR_EraseRootFromParent_Done,
     /* 1305094 */   // Label 18695: @1305094
     /* 1305094 */   GIM_Try, /*On fail goto*//*Label 18696*/ GIMT_Encode4(1305178), // Rule ID 9617 //
     /* 1305099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1305116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1305119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8_MASK),
     /* 1305155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305177 */     // GIR_Coverage, 9617,
     /* 1305177 */     GIR_EraseRootFromParent_Done,
     /* 1305178 */   // Label 18696: @1305178
     /* 1305178 */   GIM_Try, /*On fail goto*//*Label 18697*/ GIMT_Encode4(1305262), // Rule ID 9620 //
     /* 1305183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1305200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1305203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305236 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1305239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305261 */     // GIR_Coverage, 9620,
     /* 1305261 */     GIR_EraseRootFromParent_Done,
     /* 1305262 */   // Label 18697: @1305262
     /* 1305262 */   GIM_Try, /*On fail goto*//*Label 18698*/ GIMT_Encode4(1305346), // Rule ID 9621 //
     /* 1305267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1305284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1305287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305320 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1305323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305345 */     // GIR_Coverage, 9621,
     /* 1305345 */     GIR_EraseRootFromParent_Done,
     /* 1305346 */   // Label 18698: @1305346
     /* 1305346 */   GIM_Try, /*On fail goto*//*Label 18699*/ GIMT_Encode4(1305430), // Rule ID 9624 //
     /* 1305351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305429 */     // GIR_Coverage, 9624,
     /* 1305429 */     GIR_EraseRootFromParent_Done,
     /* 1305430 */   // Label 18699: @1305430
     /* 1305430 */   GIM_Try, /*On fail goto*//*Label 18700*/ GIMT_Encode4(1305514), // Rule ID 9625 //
     /* 1305435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1305446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1305449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1305452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1305455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1305458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305488 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1305509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305513 */     // GIR_Coverage, 9625,
     /* 1305513 */     GIR_EraseRootFromParent_Done,
     /* 1305514 */   // Label 18700: @1305514
     /* 1305514 */   GIM_Try, /*On fail goto*//*Label 18701*/ GIMT_Encode4(1305598), // Rule ID 9628 //
     /* 1305519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305572 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1305575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305597 */     // GIR_Coverage, 9628,
     /* 1305597 */     GIR_EraseRootFromParent_Done,
     /* 1305598 */   // Label 18701: @1305598
     /* 1305598 */   GIM_Try, /*On fail goto*//*Label 18702*/ GIMT_Encode4(1305682), // Rule ID 9629 //
     /* 1305603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1305620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1305623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305656 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4_MASK),
     /* 1305659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305681 */     // GIR_Coverage, 9629,
     /* 1305681 */     GIR_EraseRootFromParent_Done,
     /* 1305682 */   // Label 18702: @1305682
     /* 1305682 */   GIM_Try, /*On fail goto*//*Label 18703*/ GIMT_Encode4(1305766), // Rule ID 9632 //
     /* 1305687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305740 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305765 */     // GIR_Coverage, 9632,
     /* 1305765 */     GIR_EraseRootFromParent_Done,
     /* 1305766 */   // Label 18703: @1305766
     /* 1305766 */   GIM_Try, /*On fail goto*//*Label 18704*/ GIMT_Encode4(1305850), // Rule ID 9633 //
     /* 1305771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1305782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1305785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1305788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1305791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1305794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305824 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1305845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305849 */     // GIR_Coverage, 9633,
     /* 1305849 */     GIR_EraseRootFromParent_Done,
     /* 1305850 */   // Label 18704: @1305850
     /* 1305850 */   GIM_Try, /*On fail goto*//*Label 18705*/ GIMT_Encode4(1305934), // Rule ID 9636 //
     /* 1305855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1305858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1305881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305908 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1305908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1305917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1305919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1305921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1305926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1305929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1305932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1305933 */     // GIR_Coverage, 9636,
     /* 1305933 */     GIR_EraseRootFromParent_Done,
     /* 1305934 */   // Label 18705: @1305934
     /* 1305934 */   GIM_Try, /*On fail goto*//*Label 18706*/ GIMT_Encode4(1306018), // Rule ID 9637 //
     /* 1305939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1305942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1305947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1305950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1305953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1305956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1305959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1305962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1305965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1305981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1305985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1305992 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1305992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2_MASK),
     /* 1305995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1305997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1305999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306017 */     // GIR_Coverage, 9637,
     /* 1306017 */     GIR_EraseRootFromParent_Done,
     /* 1306018 */   // Label 18706: @1306018
     /* 1306018 */   GIM_Try, /*On fail goto*//*Label 18707*/ GIMT_Encode4(1306102), // Rule ID 9640 //
     /* 1306023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1306040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1306043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306076 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306101 */     // GIR_Coverage, 9640,
     /* 1306101 */     GIR_EraseRootFromParent_Done,
     /* 1306102 */   // Label 18707: @1306102
     /* 1306102 */   GIM_Try, /*On fail goto*//*Label 18708*/ GIMT_Encode4(1306186), // Rule ID 9641 //
     /* 1306107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1306118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1306121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1306124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1306127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1306130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306160 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306185 */     // GIR_Coverage, 9641,
     /* 1306185 */     GIR_EraseRootFromParent_Done,
     /* 1306186 */   // Label 18708: @1306186
     /* 1306186 */   GIM_Try, /*On fail goto*//*Label 18709*/ GIMT_Encode4(1306270), // Rule ID 9644 //
     /* 1306191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1306208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1306211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306269 */     // GIR_Coverage, 9644,
     /* 1306269 */     GIR_EraseRootFromParent_Done,
     /* 1306270 */   // Label 18709: @1306270
     /* 1306270 */   GIM_Try, /*On fail goto*//*Label 18710*/ GIMT_Encode4(1306354), // Rule ID 9645 //
     /* 1306275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1306286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1306289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1306292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1306295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1306298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306328 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1306349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306353 */     // GIR_Coverage, 9645,
     /* 1306353 */     GIR_EraseRootFromParent_Done,
     /* 1306354 */   // Label 18710: @1306354
     /* 1306354 */   GIM_Try, /*On fail goto*//*Label 18711*/ GIMT_Encode4(1306438), // Rule ID 9648 //
     /* 1306359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306412 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306437 */     // GIR_Coverage, 9648,
     /* 1306437 */     GIR_EraseRootFromParent_Done,
     /* 1306438 */   // Label 18711: @1306438
     /* 1306438 */   GIM_Try, /*On fail goto*//*Label 18712*/ GIMT_Encode4(1306522), // Rule ID 9649 //
     /* 1306443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1306454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1306457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1306460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1306463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1306466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1306517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306521 */     // GIR_Coverage, 9649,
     /* 1306521 */     GIR_EraseRootFromParent_Done,
     /* 1306522 */   // Label 18712: @1306522
     /* 1306522 */   GIM_Try, /*On fail goto*//*Label 18713*/ GIMT_Encode4(1306606), // Rule ID 9652 //
     /* 1306527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1306530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306580 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306605 */     // GIR_Coverage, 9652,
     /* 1306605 */     GIR_EraseRootFromParent_Done,
     /* 1306606 */   // Label 18713: @1306606
     /* 1306606 */   GIM_Try, /*On fail goto*//*Label 18714*/ GIMT_Encode4(1306690), // Rule ID 9653 //
     /* 1306611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1306614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1306622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1306625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1306628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1306631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1306634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306664 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1_MASK),
     /* 1306667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1306685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306689 */     // GIR_Coverage, 9653,
     /* 1306689 */     GIR_EraseRootFromParent_Done,
     /* 1306690 */   // Label 18714: @1306690
     /* 1306690 */   GIM_Try, /*On fail goto*//*Label 18715*/ GIMT_Encode4(1306774), // Rule ID 9656 //
     /* 1306695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306748 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1306751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306773 */     // GIR_Coverage, 9656,
     /* 1306773 */     GIR_EraseRootFromParent_Done,
     /* 1306774 */   // Label 18715: @1306774
     /* 1306774 */   GIM_Try, /*On fail goto*//*Label 18716*/ GIMT_Encode4(1306858), // Rule ID 9657 //
     /* 1306779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1306790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1306793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1306796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1306799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1306802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1306821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306832 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1306832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1306835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306857 */     // GIR_Coverage, 9657,
     /* 1306857 */     GIR_EraseRootFromParent_Done,
     /* 1306858 */   // Label 18716: @1306858
     /* 1306858 */   GIM_Try, /*On fail goto*//*Label 18717*/ GIMT_Encode4(1306942), // Rule ID 9660 //
     /* 1306863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1306866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1306889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1306916 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1306916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1306919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1306921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1306923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1306925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1306927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1306929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1306934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1306937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1306940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1306941 */     // GIR_Coverage, 9660,
     /* 1306941 */     GIR_EraseRootFromParent_Done,
     /* 1306942 */   // Label 18717: @1306942
     /* 1306942 */   GIM_Try, /*On fail goto*//*Label 18718*/ GIMT_Encode4(1307026), // Rule ID 9661 //
     /* 1306947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1306950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1306955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1306958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1306961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1306964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1306967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1306970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1306973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1306981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1306989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1306993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307000 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1307003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307025 */     // GIR_Coverage, 9661,
     /* 1307025 */     GIR_EraseRootFromParent_Done,
     /* 1307026 */   // Label 18718: @1307026
     /* 1307026 */   GIM_Try, /*On fail goto*//*Label 18719*/ GIMT_Encode4(1307110), // Rule ID 9664 //
     /* 1307031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1307042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1307045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1307048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1307051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1307054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307084 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1307087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307109 */     // GIR_Coverage, 9664,
     /* 1307109 */     GIR_EraseRootFromParent_Done,
     /* 1307110 */   // Label 18719: @1307110
     /* 1307110 */   GIM_Try, /*On fail goto*//*Label 18720*/ GIMT_Encode4(1307194), // Rule ID 9665 //
     /* 1307115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1307126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1307129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1307132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1307135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1307138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307168 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1307171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1307189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307193 */     // GIR_Coverage, 9665,
     /* 1307193 */     GIR_EraseRootFromParent_Done,
     /* 1307194 */   // Label 18720: @1307194
     /* 1307194 */   GIM_Try, /*On fail goto*//*Label 18721*/ GIMT_Encode4(1307278), // Rule ID 9668 //
     /* 1307199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1307216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1307219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307252 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1307255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307277 */     // GIR_Coverage, 9668,
     /* 1307277 */     GIR_EraseRootFromParent_Done,
     /* 1307278 */   // Label 18721: @1307278
     /* 1307278 */   GIM_Try, /*On fail goto*//*Label 18722*/ GIMT_Encode4(1307362), // Rule ID 9669 //
     /* 1307283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1307300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1307303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307336 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1307339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307361 */     // GIR_Coverage, 9669,
     /* 1307361 */     GIR_EraseRootFromParent_Done,
     /* 1307362 */   // Label 18722: @1307362
     /* 1307362 */   GIM_Try, /*On fail goto*//*Label 18723*/ GIMT_Encode4(1307446), // Rule ID 9672 //
     /* 1307367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307420 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1307423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307445 */     // GIR_Coverage, 9672,
     /* 1307445 */     GIR_EraseRootFromParent_Done,
     /* 1307446 */   // Label 18723: @1307446
     /* 1307446 */   GIM_Try, /*On fail goto*//*Label 18724*/ GIMT_Encode4(1307530), // Rule ID 9673 //
     /* 1307451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1307462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1307465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1307468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1307471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1307474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307504 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1307507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307529 */     // GIR_Coverage, 9673,
     /* 1307529 */     GIR_EraseRootFromParent_Done,
     /* 1307530 */   // Label 18724: @1307530
     /* 1307530 */   GIM_Try, /*On fail goto*//*Label 18725*/ GIMT_Encode4(1307614), // Rule ID 9676 //
     /* 1307535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307588 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1307591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307613 */     // GIR_Coverage, 9676,
     /* 1307613 */     GIR_EraseRootFromParent_Done,
     /* 1307614 */   // Label 18725: @1307614
     /* 1307614 */   GIM_Try, /*On fail goto*//*Label 18726*/ GIMT_Encode4(1307698), // Rule ID 9677 //
     /* 1307619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1307630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1307633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1307636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1307639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1307642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1307661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307672 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1307675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1307693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307697 */     // GIR_Coverage, 9677,
     /* 1307697 */     GIR_EraseRootFromParent_Done,
     /* 1307698 */   // Label 18726: @1307698
     /* 1307698 */   GIM_Try, /*On fail goto*//*Label 18727*/ GIMT_Encode4(1307782), // Rule ID 9680 //
     /* 1307703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307756 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1307759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307781 */     // GIR_Coverage, 9680,
     /* 1307781 */     GIR_EraseRootFromParent_Done,
     /* 1307782 */   // Label 18727: @1307782
     /* 1307782 */   GIM_Try, /*On fail goto*//*Label 18728*/ GIMT_Encode4(1307866), // Rule ID 9681 //
     /* 1307787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1307798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1307801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1307804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1307807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1307810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1307829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307840 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1307840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1307843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307865 */     // GIR_Coverage, 9681,
     /* 1307865 */     GIR_EraseRootFromParent_Done,
     /* 1307866 */   // Label 18728: @1307866
     /* 1307866 */   GIM_Try, /*On fail goto*//*Label 18729*/ GIMT_Encode4(1307950), // Rule ID 9684 //
     /* 1307871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1307874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1307897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1307917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1307924 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1307924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1307927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1307929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1307931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1307933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1307935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1307937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1307942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1307945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1307948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1307949 */     // GIR_Coverage, 9684,
     /* 1307949 */     GIR_EraseRootFromParent_Done,
     /* 1307950 */   // Label 18729: @1307950
     /* 1307950 */   GIM_Try, /*On fail goto*//*Label 18730*/ GIMT_Encode4(1308034), // Rule ID 9685 //
     /* 1307955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1307958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1307963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1307966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1307969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1307972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1307975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1307978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1307981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1307989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1307997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308008 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1308011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308033 */     // GIR_Coverage, 9685,
     /* 1308033 */     GIR_EraseRootFromParent_Done,
     /* 1308034 */   // Label 18730: @1308034
     /* 1308034 */   GIM_Try, /*On fail goto*//*Label 18731*/ GIMT_Encode4(1308118), // Rule ID 9688 //
     /* 1308039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1308056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1308059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308092 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1308095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308117 */     // GIR_Coverage, 9688,
     /* 1308117 */     GIR_EraseRootFromParent_Done,
     /* 1308118 */   // Label 18731: @1308118
     /* 1308118 */   GIM_Try, /*On fail goto*//*Label 18732*/ GIMT_Encode4(1308202), // Rule ID 9689 //
     /* 1308123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1308134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1308137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1308140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1308143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1308146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308176 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1308179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1308197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308201 */     // GIR_Coverage, 9689,
     /* 1308201 */     GIR_EraseRootFromParent_Done,
     /* 1308202 */   // Label 18732: @1308202
     /* 1308202 */   GIM_Try, /*On fail goto*//*Label 18733*/ GIMT_Encode4(1308286), // Rule ID 9692 //
     /* 1308207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1308224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1308227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1308263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308285 */     // GIR_Coverage, 9692,
     /* 1308285 */     GIR_EraseRootFromParent_Done,
     /* 1308286 */   // Label 18733: @1308286
     /* 1308286 */   GIM_Try, /*On fail goto*//*Label 18734*/ GIMT_Encode4(1308370), // Rule ID 9693 //
     /* 1308291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1308308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1308311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1308333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2_MASK),
     /* 1308347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308369 */     // GIR_Coverage, 9693,
     /* 1308369 */     GIR_EraseRootFromParent_Done,
     /* 1308370 */   // Label 18734: @1308370
     /* 1308370 */   GIM_Try, /*On fail goto*//*Label 18735*/ GIMT_Encode4(1308454), // Rule ID 9696 //
     /* 1308375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308428 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1308431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308453 */     // GIR_Coverage, 9696,
     /* 1308453 */     GIR_EraseRootFromParent_Done,
     /* 1308454 */   // Label 18735: @1308454
     /* 1308454 */   GIM_Try, /*On fail goto*//*Label 18736*/ GIMT_Encode4(1308538), // Rule ID 9697 //
     /* 1308459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1308470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1308473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1308476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1308479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1308482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1308501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308512 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4_MASK),
     /* 1308515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308537 */     // GIR_Coverage, 9697,
     /* 1308537 */     GIR_EraseRootFromParent_Done,
     /* 1308538 */   // Label 18736: @1308538
     /* 1308538 */   GIM_Try, /*On fail goto*//*Label 18737*/ GIMT_Encode4(1308622), // Rule ID 9700 //
     /* 1308543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1308546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1308599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308621 */     // GIR_Coverage, 9700,
     /* 1308621 */     GIR_EraseRootFromParent_Done,
     /* 1308622 */   // Label 18737: @1308622
     /* 1308622 */   GIM_Try, /*On fail goto*//*Label 18738*/ GIMT_Encode4(1308706), // Rule ID 9701 //
     /* 1308627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1308630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsgeu_mask),
     /* 1308635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1308638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1308641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1308644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1308647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1308650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1308669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11381:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLEU_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8_MASK),
     /* 1308683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1308701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308705 */     // GIR_Coverage, 9701,
     /* 1308705 */     GIR_EraseRootFromParent_Done,
     /* 1308706 */   // Label 18738: @1308706
     /* 1308706 */   GIM_Try, /*On fail goto*//*Label 18739*/ GIMT_Encode4(1308790), // Rule ID 9704 //
     /* 1308711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1308719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308764 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1308767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308789 */     // GIR_Coverage, 9704,
     /* 1308789 */     GIR_EraseRootFromParent_Done,
     /* 1308790 */   // Label 18739: @1308790
     /* 1308790 */   GIM_Try, /*On fail goto*//*Label 18740*/ GIMT_Encode4(1308874), // Rule ID 9705 //
     /* 1308795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1308803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1308806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1308809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1308812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1308815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1308818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308848 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF8_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1308848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8_MASK),
     /* 1308851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308873 */     // GIR_Coverage, 9705,
     /* 1308873 */     GIR_EraseRootFromParent_Done,
     /* 1308874 */   // Label 18740: @1308874
     /* 1308874 */   GIM_Try, /*On fail goto*//*Label 18741*/ GIMT_Encode4(1308958), // Rule ID 9708 //
     /* 1308879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1308882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1308887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1308905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1308925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1308932 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1308932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1308935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1308937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1308939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1308941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1308943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1308945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1308950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1308956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1308957 */     // GIR_Coverage, 9708,
     /* 1308957 */     GIR_EraseRootFromParent_Done,
     /* 1308958 */   // Label 18741: @1308958
     /* 1308958 */   GIM_Try, /*On fail goto*//*Label 18742*/ GIMT_Encode4(1309042), // Rule ID 9709 //
     /* 1308963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1308966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1308971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1308974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1308977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1308980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1308983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1308986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1308989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1308997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309016 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1309019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309041 */     // GIR_Coverage, 9709,
     /* 1309041 */     GIR_EraseRootFromParent_Done,
     /* 1309042 */   // Label 18742: @1309042
     /* 1309042 */   GIM_Try, /*On fail goto*//*Label 18743*/ GIMT_Encode4(1309126), // Rule ID 9712 //
     /* 1309047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1309064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1309067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309125 */     // GIR_Coverage, 9712,
     /* 1309125 */     GIR_EraseRootFromParent_Done,
     /* 1309126 */   // Label 18743: @1309126
     /* 1309126 */   GIM_Try, /*On fail goto*//*Label 18744*/ GIMT_Encode4(1309210), // Rule ID 9713 //
     /* 1309131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1309148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1309151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309209 */     // GIR_Coverage, 9713,
     /* 1309209 */     GIR_EraseRootFromParent_Done,
     /* 1309210 */   // Label 18744: @1309210
     /* 1309210 */   GIM_Try, /*On fail goto*//*Label 18745*/ GIMT_Encode4(1309294), // Rule ID 9716 //
     /* 1309215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1309232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1309235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1309271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309293 */     // GIR_Coverage, 9716,
     /* 1309293 */     GIR_EraseRootFromParent_Done,
     /* 1309294 */   // Label 18745: @1309294
     /* 1309294 */   GIM_Try, /*On fail goto*//*Label 18746*/ GIMT_Encode4(1309378), // Rule ID 9717 //
     /* 1309299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1309316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1309319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4_MASK),
     /* 1309355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309377 */     // GIR_Coverage, 9717,
     /* 1309377 */     GIR_EraseRootFromParent_Done,
     /* 1309378 */   // Label 18746: @1309378
     /* 1309378 */   GIM_Try, /*On fail goto*//*Label 18747*/ GIMT_Encode4(1309462), // Rule ID 9720 //
     /* 1309383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309461 */     // GIR_Coverage, 9720,
     /* 1309461 */     GIR_EraseRootFromParent_Done,
     /* 1309462 */   // Label 18747: @1309462
     /* 1309462 */   GIM_Try, /*On fail goto*//*Label 18748*/ GIMT_Encode4(1309546), // Rule ID 9721 //
     /* 1309467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1309478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1309481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1309484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1309487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1309490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309545 */     // GIR_Coverage, 9721,
     /* 1309545 */     GIR_EraseRootFromParent_Done,
     /* 1309546 */   // Label 18748: @1309546
     /* 1309546 */   GIM_Try, /*On fail goto*//*Label 18749*/ GIMT_Encode4(1309630), // Rule ID 9724 //
     /* 1309551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309629 */     // GIR_Coverage, 9724,
     /* 1309629 */     GIR_EraseRootFromParent_Done,
     /* 1309630 */   // Label 18749: @1309630
     /* 1309630 */   GIM_Try, /*On fail goto*//*Label 18750*/ GIMT_Encode4(1309714), // Rule ID 9725 //
     /* 1309635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1309646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1309649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1309652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1309655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1309658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2_MASK),
     /* 1309691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1309709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309713 */     // GIR_Coverage, 9725,
     /* 1309713 */     GIR_EraseRootFromParent_Done,
     /* 1309714 */   // Label 18750: @1309714
     /* 1309714 */   GIM_Try, /*On fail goto*//*Label 18751*/ GIMT_Encode4(1309798), // Rule ID 9728 //
     /* 1309719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309772 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1309775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309797 */     // GIR_Coverage, 9728,
     /* 1309797 */     GIR_EraseRootFromParent_Done,
     /* 1309798 */   // Label 18751: @1309798
     /* 1309798 */   GIM_Try, /*On fail goto*//*Label 18752*/ GIMT_Encode4(1309882), // Rule ID 9729 //
     /* 1309803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1309814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1309817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1309820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1309823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1309826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309856 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1309856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1309859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1309877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309881 */     // GIR_Coverage, 9729,
     /* 1309881 */     GIR_EraseRootFromParent_Done,
     /* 1309882 */   // Label 18752: @1309882
     /* 1309882 */   GIM_Try, /*On fail goto*//*Label 18753*/ GIMT_Encode4(1309966), // Rule ID 9732 //
     /* 1309887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1309890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1309913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1309929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1309933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1309940 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1309940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1309943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1309945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1309947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1309949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1309951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1309953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1309958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1309961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1309964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1309965 */     // GIR_Coverage, 9732,
     /* 1309965 */     GIR_EraseRootFromParent_Done,
     /* 1309966 */   // Label 18753: @1309966
     /* 1309966 */   GIM_Try, /*On fail goto*//*Label 18754*/ GIMT_Encode4(1310050), // Rule ID 9733 //
     /* 1309971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1309974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1309979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1309982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1309985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1309988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1309991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1309994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1309997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310024 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1310027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310049 */     // GIR_Coverage, 9733,
     /* 1310049 */     GIR_EraseRootFromParent_Done,
     /* 1310050 */   // Label 18754: @1310050
     /* 1310050 */   GIM_Try, /*On fail goto*//*Label 18755*/ GIMT_Encode4(1310134), // Rule ID 9736 //
     /* 1310055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1310072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1310075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310108 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1310111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310133 */     // GIR_Coverage, 9736,
     /* 1310133 */     GIR_EraseRootFromParent_Done,
     /* 1310134 */   // Label 18755: @1310134
     /* 1310134 */   GIM_Try, /*On fail goto*//*Label 18756*/ GIMT_Encode4(1310218), // Rule ID 9737 //
     /* 1310139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1310150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1310153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1310156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1310159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1310162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310192 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1310195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1310213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310217 */     // GIR_Coverage, 9737,
     /* 1310217 */     GIR_EraseRootFromParent_Done,
     /* 1310218 */   // Label 18756: @1310218
     /* 1310218 */   GIM_Try, /*On fail goto*//*Label 18757*/ GIMT_Encode4(1310302), // Rule ID 9740 //
     /* 1310223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1310226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1310240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1310243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310276 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1310279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310301 */     // GIR_Coverage, 9740,
     /* 1310301 */     GIR_EraseRootFromParent_Done,
     /* 1310302 */   // Label 18757: @1310302
     /* 1310302 */   GIM_Try, /*On fail goto*//*Label 18758*/ GIMT_Encode4(1310386), // Rule ID 9741 //
     /* 1310307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1310310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1310318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1310321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1310324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1310327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1310330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310360 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1_MASK),
     /* 1310363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1310381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310385 */     // GIR_Coverage, 9741,
     /* 1310385 */     GIR_EraseRootFromParent_Done,
     /* 1310386 */   // Label 18758: @1310386
     /* 1310386 */   GIM_Try, /*On fail goto*//*Label 18759*/ GIMT_Encode4(1310470), // Rule ID 9744 //
     /* 1310391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1310447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310469 */     // GIR_Coverage, 9744,
     /* 1310469 */     GIR_EraseRootFromParent_Done,
     /* 1310470 */   // Label 18759: @1310470
     /* 1310470 */   GIM_Try, /*On fail goto*//*Label 18760*/ GIMT_Encode4(1310554), // Rule ID 9745 //
     /* 1310475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1310486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1310489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1310492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1310495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1310498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1310531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310553 */     // GIR_Coverage, 9745,
     /* 1310553 */     GIR_EraseRootFromParent_Done,
     /* 1310554 */   // Label 18760: @1310554
     /* 1310554 */   GIM_Try, /*On fail goto*//*Label 18761*/ GIMT_Encode4(1310638), // Rule ID 9748 //
     /* 1310559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310612 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1310615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310637 */     // GIR_Coverage, 9748,
     /* 1310637 */     GIR_EraseRootFromParent_Done,
     /* 1310638 */   // Label 18761: @1310638
     /* 1310638 */   GIM_Try, /*On fail goto*//*Label 18762*/ GIMT_Encode4(1310722), // Rule ID 9749 //
     /* 1310643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1310654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1310657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1310660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1310663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1310666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1310685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1310699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310721 */     // GIR_Coverage, 9749,
     /* 1310721 */     GIR_EraseRootFromParent_Done,
     /* 1310722 */   // Label 18762: @1310722
     /* 1310722 */   GIM_Try, /*On fail goto*//*Label 18763*/ GIMT_Encode4(1310806), // Rule ID 9752 //
     /* 1310727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310780 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1310783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310805 */     // GIR_Coverage, 9752,
     /* 1310805 */     GIR_EraseRootFromParent_Done,
     /* 1310806 */   // Label 18763: @1310806
     /* 1310806 */   GIM_Try, /*On fail goto*//*Label 18764*/ GIMT_Encode4(1310890), // Rule ID 9753 //
     /* 1310811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s1,
     /* 1310822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s1,
     /* 1310825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1310828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1310831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1310834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1310837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1310853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310864 */     // (intrinsic_wo_chain:{ *:[nxv64i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv64i1] } VR:{ *:[nxv64i1] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 1:{ *:[i32] })
     /* 1310864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1310867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1310885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310889 */     // GIR_Coverage, 9753,
     /* 1310889 */     GIR_EraseRootFromParent_Done,
     /* 1310890 */   // Label 18764: @1310890
     /* 1310890 */   GIM_Try, /*On fail goto*//*Label 18765*/ GIMT_Encode4(1310974), // Rule ID 9756 //
     /* 1310895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1310898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1310918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1310921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1310929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1310937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1310941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1310948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1310948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1310951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1310953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1310955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1310957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1310959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1310961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1310966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1310969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1310972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1310973 */     // GIR_Coverage, 9756,
     /* 1310973 */     GIR_EraseRootFromParent_Done,
     /* 1310974 */   // Label 18765: @1310974
     /* 1310974 */   GIM_Try, /*On fail goto*//*Label 18766*/ GIMT_Encode4(1311058), // Rule ID 9757 //
     /* 1310979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1310982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1310987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1310990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1310993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1310996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1310999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1311035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311057 */     // GIR_Coverage, 9757,
     /* 1311057 */     GIR_EraseRootFromParent_Done,
     /* 1311058 */   // Label 18766: @1311058
     /* 1311058 */   GIM_Try, /*On fail goto*//*Label 18767*/ GIMT_Encode4(1311142), // Rule ID 9760 //
     /* 1311063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1311083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1311119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311141 */     // GIR_Coverage, 9760,
     /* 1311141 */     GIR_EraseRootFromParent_Done,
     /* 1311142 */   // Label 18767: @1311142
     /* 1311142 */   GIM_Try, /*On fail goto*//*Label 18768*/ GIMT_Encode4(1311226), // Rule ID 9761 //
     /* 1311147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1311164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1311167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1311203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311225 */     // GIR_Coverage, 9761,
     /* 1311225 */     GIR_EraseRootFromParent_Done,
     /* 1311226 */   // Label 18768: @1311226
     /* 1311226 */   GIM_Try, /*On fail goto*//*Label 18769*/ GIMT_Encode4(1311310), // Rule ID 9764 //
     /* 1311231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1311248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1311251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311284 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1311287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311309 */     // GIR_Coverage, 9764,
     /* 1311309 */     GIR_EraseRootFromParent_Done,
     /* 1311310 */   // Label 18769: @1311310
     /* 1311310 */   GIM_Try, /*On fail goto*//*Label 18770*/ GIMT_Encode4(1311394), // Rule ID 9765 //
     /* 1311315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1311326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1311329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1311332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1311335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1311338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311368 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1311371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1311389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311393 */     // GIR_Coverage, 9765,
     /* 1311393 */     GIR_EraseRootFromParent_Done,
     /* 1311394 */   // Label 18770: @1311394
     /* 1311394 */   GIM_Try, /*On fail goto*//*Label 18771*/ GIMT_Encode4(1311478), // Rule ID 9768 //
     /* 1311399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1311455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311477 */     // GIR_Coverage, 9768,
     /* 1311477 */     GIR_EraseRootFromParent_Done,
     /* 1311478 */   // Label 18771: @1311478
     /* 1311478 */   GIM_Try, /*On fail goto*//*Label 18772*/ GIMT_Encode4(1311562), // Rule ID 9769 //
     /* 1311483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1311494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1311497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1311500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1311503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1311506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1311539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311561 */     // GIR_Coverage, 9769,
     /* 1311561 */     GIR_EraseRootFromParent_Done,
     /* 1311562 */   // Label 18772: @1311562
     /* 1311562 */   GIM_Try, /*On fail goto*//*Label 18773*/ GIMT_Encode4(1311646), // Rule ID 9772 //
     /* 1311567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1311623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311645 */     // GIR_Coverage, 9772,
     /* 1311645 */     GIR_EraseRootFromParent_Done,
     /* 1311646 */   // Label 18773: @1311646
     /* 1311646 */   GIM_Try, /*On fail goto*//*Label 18774*/ GIMT_Encode4(1311730), // Rule ID 9773 //
     /* 1311651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1311662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1311665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1311668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1311671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1311674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1311693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311704 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1311707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311729 */     // GIR_Coverage, 9773,
     /* 1311729 */     GIR_EraseRootFromParent_Done,
     /* 1311730 */   // Label 18774: @1311730
     /* 1311730 */   GIM_Try, /*On fail goto*//*Label 18775*/ GIMT_Encode4(1311814), // Rule ID 9776 //
     /* 1311735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1311738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311788 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1311791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311813 */     // GIR_Coverage, 9776,
     /* 1311813 */     GIR_EraseRootFromParent_Done,
     /* 1311814 */   // Label 18775: @1311814
     /* 1311814 */   GIM_Try, /*On fail goto*//*Label 18776*/ GIMT_Encode4(1311898), // Rule ID 9777 //
     /* 1311819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1311822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1311830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1311833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1311836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1311839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1311842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1311845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1311861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311872 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1311872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1311875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1311893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311897 */     // GIR_Coverage, 9777,
     /* 1311897 */     GIR_EraseRootFromParent_Done,
     /* 1311898 */   // Label 18776: @1311898
     /* 1311898 */   GIM_Try, /*On fail goto*//*Label 18777*/ GIMT_Encode4(1311982), // Rule ID 9780 //
     /* 1311903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1311906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1311917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1311920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1311923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1311926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1311929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1311937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1311945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1311949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1311956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1311956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1311959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1311961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1311963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1311965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1311967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1311969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1311974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1311977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1311980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1311981 */     // GIR_Coverage, 9780,
     /* 1311981 */     GIR_EraseRootFromParent_Done,
     /* 1311982 */   // Label 18777: @1311982
     /* 1311982 */   GIM_Try, /*On fail goto*//*Label 18778*/ GIMT_Encode4(1312066), // Rule ID 9781 //
     /* 1311987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1311990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1311995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1311998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1312001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1312004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1312007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1312029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2_MASK),
     /* 1312043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312065 */     // GIR_Coverage, 9781,
     /* 1312065 */     GIR_EraseRootFromParent_Done,
     /* 1312066 */   // Label 18778: @1312066
     /* 1312066 */   GIM_Try, /*On fail goto*//*Label 18779*/ GIMT_Encode4(1312150), // Rule ID 9784 //
     /* 1312071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1312074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1312079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1312088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1312091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312124 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1312127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312149 */     // GIR_Coverage, 9784,
     /* 1312149 */     GIR_EraseRootFromParent_Done,
     /* 1312150 */   // Label 18779: @1312150
     /* 1312150 */   GIM_Try, /*On fail goto*//*Label 18780*/ GIMT_Encode4(1312234), // Rule ID 9785 //
     /* 1312155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1312158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1312163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1312166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1312169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1312172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1312175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1312197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312208 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4_MASK),
     /* 1312211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312233 */     // GIR_Coverage, 9785,
     /* 1312233 */     GIR_EraseRootFromParent_Done,
     /* 1312234 */   // Label 18780: @1312234
     /* 1312234 */   GIM_Try, /*On fail goto*//*Label 18781*/ GIMT_Encode4(1312318), // Rule ID 9788 //
     /* 1312239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1312242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1312247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312292 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1312292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1312295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312317 */     // GIR_Coverage, 9788,
     /* 1312317 */     GIR_EraseRootFromParent_Done,
     /* 1312318 */   // Label 18781: @1312318
     /* 1312318 */   GIM_Try, /*On fail goto*//*Label 18782*/ GIMT_Encode4(1312402), // Rule ID 9789 //
     /* 1312323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1312326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmsge_mask),
     /* 1312331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1312334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1312337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1312340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1312343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1312346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1312365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312376 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11379:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1312376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8_MASK),
     /* 1312379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1312385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1312387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1312397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1312400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312401 */     // GIR_Coverage, 9789,
     /* 1312401 */     GIR_EraseRootFromParent_Done,
     /* 1312402 */   // Label 18782: @1312402
     /* 1312402 */   GIM_Try, /*On fail goto*//*Label 18783*/ GIMT_Encode4(1312483), // Rule ID 13730 //
     /* 1312407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1312418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1312421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1312460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1312463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312482 */     // GIR_Coverage, 13730,
     /* 1312482 */     GIR_EraseRootFromParent_Done,
     /* 1312483 */   // Label 18783: @1312483
     /* 1312483 */   GIM_Try, /*On fail goto*//*Label 18784*/ GIMT_Encode4(1312564), // Rule ID 13731 //
     /* 1312488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1312499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1312502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1312505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1312508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312541 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1312541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 1312544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312563 */     // GIR_Coverage, 13731,
     /* 1312563 */     GIR_EraseRootFromParent_Done,
     /* 1312564 */   // Label 18784: @1312564
     /* 1312564 */   GIM_Try, /*On fail goto*//*Label 18785*/ GIMT_Encode4(1312645), // Rule ID 13732 //
     /* 1312569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1312580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1312583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312622 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1312622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1312625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312644 */     // GIR_Coverage, 13732,
     /* 1312644 */     GIR_EraseRootFromParent_Done,
     /* 1312645 */   // Label 18785: @1312645
     /* 1312645 */   GIM_Try, /*On fail goto*//*Label 18786*/ GIMT_Encode4(1312726), // Rule ID 13733 //
     /* 1312650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1312661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1312664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1312667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1312670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1312673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312703 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1312703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1312706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312725 */     // GIR_Coverage, 13733,
     /* 1312725 */     GIR_EraseRootFromParent_Done,
     /* 1312726 */   // Label 18786: @1312726
     /* 1312726 */   GIM_Try, /*On fail goto*//*Label 18787*/ GIMT_Encode4(1312807), // Rule ID 13734 //
     /* 1312731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1312742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1312745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312784 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1312784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1312787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312806 */     // GIR_Coverage, 13734,
     /* 1312806 */     GIR_EraseRootFromParent_Done,
     /* 1312807 */   // Label 18787: @1312807
     /* 1312807 */   GIM_Try, /*On fail goto*//*Label 18788*/ GIMT_Encode4(1312888), // Rule ID 13735 //
     /* 1312812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1312823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1312826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1312829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1312832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1312835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1312838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312865 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1312865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1312868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1312886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312887 */     // GIR_Coverage, 13735,
     /* 1312887 */     GIR_EraseRootFromParent_Done,
     /* 1312888 */   // Label 18788: @1312888
     /* 1312888 */   GIM_Try, /*On fail goto*//*Label 18789*/ GIMT_Encode4(1312969), // Rule ID 13736 //
     /* 1312893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1312896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1312904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1312907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1312919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1312923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1312935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1312939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1312946 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1312946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1312949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1312951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1312953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1312955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1312957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1312959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1312964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1312967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1312968 */     // GIR_Coverage, 13736,
     /* 1312968 */     GIR_EraseRootFromParent_Done,
     /* 1312969 */   // Label 18789: @1312969
     /* 1312969 */   GIM_Try, /*On fail goto*//*Label 18790*/ GIMT_Encode4(1313050), // Rule ID 13737 //
     /* 1312974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1312977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1312982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1312985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1312988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1312991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1312994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1312997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313027 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1313027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1313030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313049 */     // GIR_Coverage, 13737,
     /* 1313049 */     GIR_EraseRootFromParent_Done,
     /* 1313050 */   // Label 18790: @1313050
     /* 1313050 */   GIM_Try, /*On fail goto*//*Label 18791*/ GIMT_Encode4(1313131), // Rule ID 13738 //
     /* 1313055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1313066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1313069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1313075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1313108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1313111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313130 */     // GIR_Coverage, 13738,
     /* 1313130 */     GIR_EraseRootFromParent_Done,
     /* 1313131 */   // Label 18791: @1313131
     /* 1313131 */   GIM_Try, /*On fail goto*//*Label 18792*/ GIMT_Encode4(1313212), // Rule ID 13739 //
     /* 1313136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1313147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1313150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1313153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1313156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313189 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1313189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1313192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313211 */     // GIR_Coverage, 13739,
     /* 1313211 */     GIR_EraseRootFromParent_Done,
     /* 1313212 */   // Label 18792: @1313212
     /* 1313212 */   GIM_Try, /*On fail goto*//*Label 18793*/ GIMT_Encode4(1313293), // Rule ID 13740 //
     /* 1313217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1313228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1313231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1313234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1313237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1313270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1313273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313292 */     // GIR_Coverage, 13740,
     /* 1313292 */     GIR_EraseRootFromParent_Done,
     /* 1313293 */   // Label 18793: @1313293
     /* 1313293 */   GIM_Try, /*On fail goto*//*Label 18794*/ GIMT_Encode4(1313374), // Rule ID 13741 //
     /* 1313298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1313309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1313312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1313315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1313318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1313351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1313354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313373 */     // GIR_Coverage, 13741,
     /* 1313373 */     GIR_EraseRootFromParent_Done,
     /* 1313374 */   // Label 18794: @1313374
     /* 1313374 */   GIM_Try, /*On fail goto*//*Label 18795*/ GIMT_Encode4(1313455), // Rule ID 13742 //
     /* 1313379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1313390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1313393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313432 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1313432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313454 */     // GIR_Coverage, 13742,
     /* 1313454 */     GIR_EraseRootFromParent_Done,
     /* 1313455 */   // Label 18795: @1313455
     /* 1313455 */   GIM_Try, /*On fail goto*//*Label 18796*/ GIMT_Encode4(1313536), // Rule ID 13743 //
     /* 1313460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1313471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1313474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1313477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1313480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1313483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313513 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1313513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1313534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313535 */     // GIR_Coverage, 13743,
     /* 1313535 */     GIR_EraseRootFromParent_Done,
     /* 1313536 */   // Label 18796: @1313536
     /* 1313536 */   GIM_Try, /*On fail goto*//*Label 18797*/ GIMT_Encode4(1313617), // Rule ID 13744 //
     /* 1313541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1313552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1313555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313594 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1313594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313616 */     // GIR_Coverage, 13744,
     /* 1313616 */     GIR_EraseRootFromParent_Done,
     /* 1313617 */   // Label 18797: @1313617
     /* 1313617 */   GIM_Try, /*On fail goto*//*Label 18798*/ GIMT_Encode4(1313698), // Rule ID 13745 //
     /* 1313622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1313633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1313636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1313639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1313642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1313645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313675 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1313675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1313696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313697 */     // GIR_Coverage, 13745,
     /* 1313697 */     GIR_EraseRootFromParent_Done,
     /* 1313698 */   // Label 18798: @1313698
     /* 1313698 */   GIM_Try, /*On fail goto*//*Label 18799*/ GIMT_Encode4(1313779), // Rule ID 13746 //
     /* 1313703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1313706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1313714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1313717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1313756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313778 */     // GIR_Coverage, 13746,
     /* 1313778 */     GIR_EraseRootFromParent_Done,
     /* 1313779 */   // Label 18799: @1313779
     /* 1313779 */   GIM_Try, /*On fail goto*//*Label 18800*/ GIMT_Encode4(1313860), // Rule ID 13747 //
     /* 1313784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1313787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1313795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1313798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1313801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1313804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1313807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313837 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1313837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1313858 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313859 */     // GIR_Coverage, 13747,
     /* 1313859 */     GIR_EraseRootFromParent_Done,
     /* 1313860 */   // Label 18800: @1313860
     /* 1313860 */   GIM_Try, /*On fail goto*//*Label 18801*/ GIMT_Encode4(1313941), // Rule ID 13748 //
     /* 1313865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1313868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1313876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1313879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1313891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313918 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1313918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1313921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1313923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1313925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1313927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1313929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1313931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1313936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1313939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1313940 */     // GIR_Coverage, 13748,
     /* 1313940 */     GIR_EraseRootFromParent_Done,
     /* 1313941 */   // Label 18801: @1313941
     /* 1313941 */   GIM_Try, /*On fail goto*//*Label 18802*/ GIMT_Encode4(1314022), // Rule ID 13749 //
     /* 1313946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1313949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1313954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1313957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1313960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1313963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1313966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1313969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1313972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1313976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1313988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1313992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1313999 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1313999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1314002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1314020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314021 */     // GIR_Coverage, 13749,
     /* 1314021 */     GIR_EraseRootFromParent_Done,
     /* 1314022 */   // Label 18802: @1314022
     /* 1314022 */   GIM_Try, /*On fail goto*//*Label 18803*/ GIMT_Encode4(1314103), // Rule ID 13750 //
     /* 1314027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1314038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1314041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1314044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1314047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1314080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1314083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314102 */     // GIR_Coverage, 13750,
     /* 1314102 */     GIR_EraseRootFromParent_Done,
     /* 1314103 */   // Label 18803: @1314103
     /* 1314103 */   GIM_Try, /*On fail goto*//*Label 18804*/ GIMT_Encode4(1314184), // Rule ID 13751 //
     /* 1314108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1314119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1314122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1314125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1314128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314161 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1314161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1314164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314183 */     // GIR_Coverage, 13751,
     /* 1314183 */     GIR_EraseRootFromParent_Done,
     /* 1314184 */   // Label 18804: @1314184
     /* 1314184 */   GIM_Try, /*On fail goto*//*Label 18805*/ GIMT_Encode4(1314265), // Rule ID 13752 //
     /* 1314189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1314200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1314203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1314206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1314209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314242 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1314242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1314245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314264 */     // GIR_Coverage, 13752,
     /* 1314264 */     GIR_EraseRootFromParent_Done,
     /* 1314265 */   // Label 18805: @1314265
     /* 1314265 */   GIM_Try, /*On fail goto*//*Label 18806*/ GIMT_Encode4(1314346), // Rule ID 13753 //
     /* 1314270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1314281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1314284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1314287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1314290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314323 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1314323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1314326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314345 */     // GIR_Coverage, 13753,
     /* 1314345 */     GIR_EraseRootFromParent_Done,
     /* 1314346 */   // Label 18806: @1314346
     /* 1314346 */   GIM_Try, /*On fail goto*//*Label 18807*/ GIMT_Encode4(1314427), // Rule ID 13754 //
     /* 1314351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1314362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1314365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1314381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314404 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1314404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1314407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314426 */     // GIR_Coverage, 13754,
     /* 1314426 */     GIR_EraseRootFromParent_Done,
     /* 1314427 */   // Label 18807: @1314427
     /* 1314427 */   GIM_Try, /*On fail goto*//*Label 18808*/ GIMT_Encode4(1314508), // Rule ID 13755 //
     /* 1314432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1314443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1314446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1314449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1314452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1314455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1314462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314485 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1314485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1314488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1314506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314507 */     // GIR_Coverage, 13755,
     /* 1314507 */     GIR_EraseRootFromParent_Done,
     /* 1314508 */   // Label 18808: @1314508
     /* 1314508 */   GIM_Try, /*On fail goto*//*Label 18809*/ GIMT_Encode4(1314589), // Rule ID 13756 //
     /* 1314513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1314524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1314527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1314566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1314569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314588 */     // GIR_Coverage, 13756,
     /* 1314588 */     GIR_EraseRootFromParent_Done,
     /* 1314589 */   // Label 18809: @1314589
     /* 1314589 */   GIM_Try, /*On fail goto*//*Label 18810*/ GIMT_Encode4(1314670), // Rule ID 13757 //
     /* 1314594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1314605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1314608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1314611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1314614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1314617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1314624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1314636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314647 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1314647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1314650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314669 */     // GIR_Coverage, 13757,
     /* 1314669 */     GIR_EraseRootFromParent_Done,
     /* 1314670 */   // Label 18810: @1314670
     /* 1314670 */   GIM_Try, /*On fail goto*//*Label 18811*/ GIMT_Encode4(1314751), // Rule ID 13758 //
     /* 1314675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1314686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1314689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1314728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1314731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314750 */     // GIR_Coverage, 13758,
     /* 1314750 */     GIR_EraseRootFromParent_Done,
     /* 1314751 */   // Label 18811: @1314751
     /* 1314751 */   GIM_Try, /*On fail goto*//*Label 18812*/ GIMT_Encode4(1314832), // Rule ID 13759 //
     /* 1314756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1314767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1314770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1314773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1314776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1314779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1314786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1314798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314809 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1314809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1314812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314830 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314831 */     // GIR_Coverage, 13759,
     /* 1314831 */     GIR_EraseRootFromParent_Done,
     /* 1314832 */   // Label 18812: @1314832
     /* 1314832 */   GIM_Try, /*On fail goto*//*Label 18813*/ GIMT_Encode4(1314913), // Rule ID 13760 //
     /* 1314837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1314840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1314848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1314851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1314863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1314867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314890 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1314890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1314893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314912 */     // GIR_Coverage, 13760,
     /* 1314912 */     GIR_EraseRootFromParent_Done,
     /* 1314913 */   // Label 18813: @1314913
     /* 1314913 */   GIM_Try, /*On fail goto*//*Label 18814*/ GIMT_Encode4(1314994), // Rule ID 13761 //
     /* 1314918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1314921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1314926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1314929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1314932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1314935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1314938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1314941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1314944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1314948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1314960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1314964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1314971 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1314971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1314974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1314976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1314978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1314980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1314982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1314984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1314989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1314992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1314993 */     // GIR_Coverage, 13761,
     /* 1314993 */     GIR_EraseRootFromParent_Done,
     /* 1314994 */   // Label 18814: @1314994
     /* 1314994 */   GIM_Try, /*On fail goto*//*Label 18815*/ GIMT_Encode4(1315075), // Rule ID 13762 //
     /* 1314999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1315010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1315013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1315016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1315019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1315052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1315055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315074 */     // GIR_Coverage, 13762,
     /* 1315074 */     GIR_EraseRootFromParent_Done,
     /* 1315075 */   // Label 18815: @1315075
     /* 1315075 */   GIM_Try, /*On fail goto*//*Label 18816*/ GIMT_Encode4(1315156), // Rule ID 13763 //
     /* 1315080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1315091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1315094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1315097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1315100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1315133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1315136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315155 */     // GIR_Coverage, 13763,
     /* 1315155 */     GIR_EraseRootFromParent_Done,
     /* 1315156 */   // Label 18816: @1315156
     /* 1315156 */   GIM_Try, /*On fail goto*//*Label 18817*/ GIMT_Encode4(1315237), // Rule ID 13764 //
     /* 1315161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1315172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1315175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1315181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1315214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1315217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315236 */     // GIR_Coverage, 13764,
     /* 1315236 */     GIR_EraseRootFromParent_Done,
     /* 1315237 */   // Label 18817: @1315237
     /* 1315237 */   GIM_Try, /*On fail goto*//*Label 18818*/ GIMT_Encode4(1315318), // Rule ID 13765 //
     /* 1315242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1315253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1315256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1315259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1315262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315295 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1315295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1315298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315317 */     // GIR_Coverage, 13765,
     /* 1315317 */     GIR_EraseRootFromParent_Done,
     /* 1315318 */   // Label 18818: @1315318
     /* 1315318 */   GIM_Try, /*On fail goto*//*Label 18819*/ GIMT_Encode4(1315399), // Rule ID 13766 //
     /* 1315323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1315334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1315337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1315353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315376 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1315376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1315379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315398 */     // GIR_Coverage, 13766,
     /* 1315398 */     GIR_EraseRootFromParent_Done,
     /* 1315399 */   // Label 18819: @1315399
     /* 1315399 */   GIM_Try, /*On fail goto*//*Label 18820*/ GIMT_Encode4(1315480), // Rule ID 13767 //
     /* 1315404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1315407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1315415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1315418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1315421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1315424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1315427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1315434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315457 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1315457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1315460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1315478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315479 */     // GIR_Coverage, 13767,
     /* 1315479 */     GIR_EraseRootFromParent_Done,
     /* 1315480 */   // Label 18820: @1315480
     /* 1315480 */   GIM_Try, /*On fail goto*//*Label 18821*/ GIMT_Encode4(1315561), // Rule ID 13768 //
     /* 1315485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1315496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1315499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1315538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1315541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315560 */     // GIR_Coverage, 13768,
     /* 1315560 */     GIR_EraseRootFromParent_Done,
     /* 1315561 */   // Label 18821: @1315561
     /* 1315561 */   GIM_Try, /*On fail goto*//*Label 18822*/ GIMT_Encode4(1315642), // Rule ID 13769 //
     /* 1315566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1315577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1315580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1315583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1315586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1315589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1315596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1315608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315619 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1315619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1315622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315641 */     // GIR_Coverage, 13769,
     /* 1315641 */     GIR_EraseRootFromParent_Done,
     /* 1315642 */   // Label 18822: @1315642
     /* 1315642 */   GIM_Try, /*On fail goto*//*Label 18823*/ GIMT_Encode4(1315723), // Rule ID 13770 //
     /* 1315647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1315658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1315661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315700 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1315700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1315703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315722 */     // GIR_Coverage, 13770,
     /* 1315722 */     GIR_EraseRootFromParent_Done,
     /* 1315723 */   // Label 18823: @1315723
     /* 1315723 */   GIM_Try, /*On fail goto*//*Label 18824*/ GIMT_Encode4(1315804), // Rule ID 13771 //
     /* 1315728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1315739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1315742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1315745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1315748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1315751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1315758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1315770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315781 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1315781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1315784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315803 */     // GIR_Coverage, 13771,
     /* 1315803 */     GIR_EraseRootFromParent_Done,
     /* 1315804 */   // Label 18824: @1315804
     /* 1315804 */   GIM_Try, /*On fail goto*//*Label 18825*/ GIMT_Encode4(1315885), // Rule ID 13772 //
     /* 1315809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1315812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1315820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1315823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1315839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1315862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1315865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315884 */     // GIR_Coverage, 13772,
     /* 1315884 */     GIR_EraseRootFromParent_Done,
     /* 1315885 */   // Label 18825: @1315885
     /* 1315885 */   GIM_Try, /*On fail goto*//*Label 18826*/ GIMT_Encode4(1315966), // Rule ID 13773 //
     /* 1315890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1315893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1315901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1315904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1315907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1315910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1315913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1315916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1315920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1315932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1315936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1315943 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1315943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1315946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1315948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1315950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1315952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1315954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1315956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1315961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1315964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1315965 */     // GIR_Coverage, 13773,
     /* 1315965 */     GIR_EraseRootFromParent_Done,
     /* 1315966 */   // Label 18826: @1315966
     /* 1315966 */   GIM_Try, /*On fail goto*//*Label 18827*/ GIMT_Encode4(1316047), // Rule ID 13774 //
     /* 1315971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1315974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1315979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1315982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1315985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1315988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1315991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1315994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1315997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316024 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1316027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316046 */     // GIR_Coverage, 13774,
     /* 1316046 */     GIR_EraseRootFromParent_Done,
     /* 1316047 */   // Label 18827: @1316047
     /* 1316047 */   GIM_Try, /*On fail goto*//*Label 18828*/ GIMT_Encode4(1316128), // Rule ID 13775 //
     /* 1316052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1316063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1316066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1316069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316105 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1316105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF8),
     /* 1316108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316126 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316127 */     // GIR_Coverage, 13775,
     /* 1316127 */     GIR_EraseRootFromParent_Done,
     /* 1316128 */   // Label 18828: @1316128
     /* 1316128 */   GIM_Try, /*On fail goto*//*Label 18829*/ GIMT_Encode4(1316209), // Rule ID 13776 //
     /* 1316133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1316144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1316147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1316150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316186 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1316189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316208 */     // GIR_Coverage, 13776,
     /* 1316208 */     GIR_EraseRootFromParent_Done,
     /* 1316209 */   // Label 18829: @1316209
     /* 1316209 */   GIM_Try, /*On fail goto*//*Label 18830*/ GIMT_Encode4(1316290), // Rule ID 13777 //
     /* 1316214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1316225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1316228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1316231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316267 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1316267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1316270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316289 */     // GIR_Coverage, 13777,
     /* 1316289 */     GIR_EraseRootFromParent_Done,
     /* 1316290 */   // Label 18830: @1316290
     /* 1316290 */   GIM_Try, /*On fail goto*//*Label 18831*/ GIMT_Encode4(1316371), // Rule ID 13778 //
     /* 1316295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1316306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1316309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316348 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316370 */     // GIR_Coverage, 13778,
     /* 1316370 */     GIR_EraseRootFromParent_Done,
     /* 1316371 */   // Label 18831: @1316371
     /* 1316371 */   GIM_Try, /*On fail goto*//*Label 18832*/ GIMT_Encode4(1316452), // Rule ID 13779 //
     /* 1316376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1316387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1316390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1316393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1316399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316429 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1316429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1316450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316451 */     // GIR_Coverage, 13779,
     /* 1316451 */     GIR_EraseRootFromParent_Done,
     /* 1316452 */   // Label 18832: @1316452
     /* 1316452 */   GIM_Try, /*On fail goto*//*Label 18833*/ GIMT_Encode4(1316533), // Rule ID 13780 //
     /* 1316457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1316468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1316471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316510 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1316510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1316513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316532 */     // GIR_Coverage, 13780,
     /* 1316532 */     GIR_EraseRootFromParent_Done,
     /* 1316533 */   // Label 18833: @1316533
     /* 1316533 */   GIM_Try, /*On fail goto*//*Label 18834*/ GIMT_Encode4(1316614), // Rule ID 13781 //
     /* 1316538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1316549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1316552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1316555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316591 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1316591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF4),
     /* 1316594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316613 */     // GIR_Coverage, 13781,
     /* 1316613 */     GIR_EraseRootFromParent_Done,
     /* 1316614 */   // Label 18834: @1316614
     /* 1316614 */   GIM_Try, /*On fail goto*//*Label 18835*/ GIMT_Encode4(1316695), // Rule ID 13782 //
     /* 1316619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1316630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1316633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316672 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1316672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316694 */     // GIR_Coverage, 13782,
     /* 1316694 */     GIR_EraseRootFromParent_Done,
     /* 1316695 */   // Label 18835: @1316695
     /* 1316695 */   GIM_Try, /*On fail goto*//*Label 18836*/ GIMT_Encode4(1316776), // Rule ID 13783 //
     /* 1316700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1316711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1316714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1316717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1316723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316753 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1316753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1316774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316775 */     // GIR_Coverage, 13783,
     /* 1316775 */     GIR_EraseRootFromParent_Done,
     /* 1316776 */   // Label 18836: @1316776
     /* 1316776 */   GIM_Try, /*On fail goto*//*Label 18837*/ GIMT_Encode4(1316857), // Rule ID 13784 //
     /* 1316781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1316792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1316795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316834 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1316834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316856 */     // GIR_Coverage, 13784,
     /* 1316856 */     GIR_EraseRootFromParent_Done,
     /* 1316857 */   // Label 18837: @1316857
     /* 1316857 */   GIM_Try, /*On fail goto*//*Label 18838*/ GIMT_Encode4(1316938), // Rule ID 13785 //
     /* 1316862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1316865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1316873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1316876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1316879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1316882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1316885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1316888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316915 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1316915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_MF2),
     /* 1316918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1316920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1316922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1316924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1316926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1316928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1316933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1316936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1316937 */     // GIR_Coverage, 13785,
     /* 1316937 */     GIR_EraseRootFromParent_Done,
     /* 1316938 */   // Label 18838: @1316938
     /* 1316938 */   GIM_Try, /*On fail goto*//*Label 18839*/ GIMT_Encode4(1317019), // Rule ID 13786 //
     /* 1316943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1316946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1316951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1316954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1316957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1316960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1316963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1316966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1316969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1316973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1316981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1316985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1316989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1316996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1316996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1316999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317018 */     // GIR_Coverage, 13786,
     /* 1317018 */     GIR_EraseRootFromParent_Done,
     /* 1317019 */   // Label 18839: @1317019
     /* 1317019 */   GIM_Try, /*On fail goto*//*Label 18840*/ GIMT_Encode4(1317100), // Rule ID 13787 //
     /* 1317024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1317035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1317038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1317041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1317047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317077 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11350:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317082 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317098 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317099 */     // GIR_Coverage, 13787,
     /* 1317099 */     GIR_EraseRootFromParent_Done,
     /* 1317100 */   // Label 18840: @1317100
     /* 1317100 */   GIM_Try, /*On fail goto*//*Label 18841*/ GIMT_Encode4(1317181), // Rule ID 13788 //
     /* 1317105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317158 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1317158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317180 */     // GIR_Coverage, 13788,
     /* 1317180 */     GIR_EraseRootFromParent_Done,
     /* 1317181 */   // Label 18841: @1317181
     /* 1317181 */   GIM_Try, /*On fail goto*//*Label 18842*/ GIMT_Encode4(1317262), // Rule ID 13789 //
     /* 1317186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1317197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1317200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1317203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1317209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317239 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1317239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1317260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317261 */     // GIR_Coverage, 13789,
     /* 1317261 */     GIR_EraseRootFromParent_Done,
     /* 1317262 */   // Label 18842: @1317262
     /* 1317262 */   GIM_Try, /*On fail goto*//*Label 18843*/ GIMT_Encode4(1317343), // Rule ID 13790 //
     /* 1317267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1317278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1317281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1317320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317342 */     // GIR_Coverage, 13790,
     /* 1317342 */     GIR_EraseRootFromParent_Done,
     /* 1317343 */   // Label 18843: @1317343
     /* 1317343 */   GIM_Try, /*On fail goto*//*Label 18844*/ GIMT_Encode4(1317424), // Rule ID 13791 //
     /* 1317348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1317359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1317362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1317365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1317371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317401 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1317401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1317422 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317423 */     // GIR_Coverage, 13791,
     /* 1317423 */     GIR_EraseRootFromParent_Done,
     /* 1317424 */   // Label 18844: @1317424
     /* 1317424 */   GIM_Try, /*On fail goto*//*Label 18845*/ GIMT_Encode4(1317505), // Rule ID 13792 //
     /* 1317429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1317432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1317440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1317443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1317482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317504 */     // GIR_Coverage, 13792,
     /* 1317504 */     GIR_EraseRootFromParent_Done,
     /* 1317505 */   // Label 18845: @1317505
     /* 1317505 */   GIM_Try, /*On fail goto*//*Label 18846*/ GIMT_Encode4(1317586), // Rule ID 13793 //
     /* 1317510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1317513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1317521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1317524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1317527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1317533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1317540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1317548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317563 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1317563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M1),
     /* 1317566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1317584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317585 */     // GIR_Coverage, 13793,
     /* 1317585 */     GIR_EraseRootFromParent_Done,
     /* 1317586 */   // Label 18846: @1317586
     /* 1317586 */   GIM_Try, /*On fail goto*//*Label 18847*/ GIMT_Encode4(1317667), // Rule ID 13794 //
     /* 1317591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1317602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1317605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1317621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1317644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1317647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317666 */     // GIR_Coverage, 13794,
     /* 1317666 */     GIR_EraseRootFromParent_Done,
     /* 1317667 */   // Label 18847: @1317667
     /* 1317667 */   GIM_Try, /*On fail goto*//*Label 18848*/ GIMT_Encode4(1317748), // Rule ID 13795 //
     /* 1317672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1317683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1317686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1317689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1317695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1317702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1317710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317725 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1317728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317747 */     // GIR_Coverage, 13795,
     /* 1317747 */     GIR_EraseRootFromParent_Done,
     /* 1317748 */   // Label 18848: @1317748
     /* 1317748 */   GIM_Try, /*On fail goto*//*Label 18849*/ GIMT_Encode4(1317829), // Rule ID 13796 //
     /* 1317753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1317764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1317767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317806 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1317806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1317809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317828 */     // GIR_Coverage, 13796,
     /* 1317828 */     GIR_EraseRootFromParent_Done,
     /* 1317829 */   // Label 18849: @1317829
     /* 1317829 */   GIM_Try, /*On fail goto*//*Label 18850*/ GIMT_Encode4(1317910), // Rule ID 13797 //
     /* 1317834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1317845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1317848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1317851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1317854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1317857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1317860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1317864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1317872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317887 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1317887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1317890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317909 */     // GIR_Coverage, 13797,
     /* 1317909 */     GIR_EraseRootFromParent_Done,
     /* 1317910 */   // Label 18850: @1317910
     /* 1317910 */   GIM_Try, /*On fail goto*//*Label 18851*/ GIMT_Encode4(1317991), // Rule ID 13798 //
     /* 1317915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1317918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1317923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1317926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1317929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1317932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1317935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1317938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1317941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1317945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1317953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1317957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1317961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1317968 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] })
     /* 1317968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1317971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1317973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1317975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1317977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1317979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1317981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1317986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1317989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1317990 */     // GIR_Coverage, 13798,
     /* 1317990 */     GIR_EraseRootFromParent_Done,
     /* 1317991 */   // Label 18851: @1317991
     /* 1317991 */   GIM_Try, /*On fail goto*//*Label 18852*/ GIMT_Encode4(1318072), // Rule ID 13799 //
     /* 1317996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1317999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1318007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1318010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1318013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1318019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318049 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] })
     /* 1318049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1318052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1318070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318071 */     // GIR_Coverage, 13799,
     /* 1318071 */     GIR_EraseRootFromParent_Done,
     /* 1318072 */   // Label 18852: @1318072
     /* 1318072 */   GIM_Try, /*On fail goto*//*Label 18853*/ GIMT_Encode4(1318153), // Rule ID 13800 //
     /* 1318077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1318088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1318091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1318130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1318133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318152 */     // GIR_Coverage, 13800,
     /* 1318152 */     GIR_EraseRootFromParent_Done,
     /* 1318153 */   // Label 18853: @1318153
     /* 1318153 */   GIM_Try, /*On fail goto*//*Label 18854*/ GIMT_Encode4(1318234), // Rule ID 13801 //
     /* 1318158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1318169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1318172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1318175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1318211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1318214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318233 */     // GIR_Coverage, 13801,
     /* 1318233 */     GIR_EraseRootFromParent_Done,
     /* 1318234 */   // Label 18854: @1318234
     /* 1318234 */   GIM_Try, /*On fail goto*//*Label 18855*/ GIMT_Encode4(1318315), // Rule ID 13802 //
     /* 1318239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1318250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1318253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318292 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1318292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1318295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318314 */     // GIR_Coverage, 13802,
     /* 1318314 */     GIR_EraseRootFromParent_Done,
     /* 1318315 */   // Label 18855: @1318315
     /* 1318315 */   GIM_Try, /*On fail goto*//*Label 18856*/ GIMT_Encode4(1318396), // Rule ID 13803 //
     /* 1318320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1318331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1318334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1318337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318373 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1318373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1318376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318395 */     // GIR_Coverage, 13803,
     /* 1318395 */     GIR_EraseRootFromParent_Done,
     /* 1318396 */   // Label 18856: @1318396
     /* 1318396 */   GIM_Try, /*On fail goto*//*Label 18857*/ GIMT_Encode4(1318477), // Rule ID 13804 //
     /* 1318401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1318412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1318415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318454 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1318454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1318457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318476 */     // GIR_Coverage, 13804,
     /* 1318476 */     GIR_EraseRootFromParent_Done,
     /* 1318477 */   // Label 18857: @1318477
     /* 1318477 */   GIM_Try, /*On fail goto*//*Label 18858*/ GIMT_Encode4(1318558), // Rule ID 13805 //
     /* 1318482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1318493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1318496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1318499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1318505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318535 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1318535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1318538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1318556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318557 */     // GIR_Coverage, 13805,
     /* 1318557 */     GIR_EraseRootFromParent_Done,
     /* 1318558 */   // Label 18858: @1318558
     /* 1318558 */   GIM_Try, /*On fail goto*//*Label 18859*/ GIMT_Encode4(1318639), // Rule ID 13806 //
     /* 1318563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1318574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1318577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1318616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1318619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318638 */     // GIR_Coverage, 13806,
     /* 1318638 */     GIR_EraseRootFromParent_Done,
     /* 1318639 */   // Label 18859: @1318639
     /* 1318639 */   GIM_Try, /*On fail goto*//*Label 18860*/ GIMT_Encode4(1318720), // Rule ID 13807 //
     /* 1318644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1318655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1318658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1318661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1318667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1318674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1318682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1318697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1318700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318719 */     // GIR_Coverage, 13807,
     /* 1318719 */     GIR_EraseRootFromParent_Done,
     /* 1318720 */   // Label 18860: @1318720
     /* 1318720 */   GIM_Try, /*On fail goto*//*Label 18861*/ GIMT_Encode4(1318801), // Rule ID 13808 //
     /* 1318725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1318736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1318739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318778 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1318778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1318781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318800 */     // GIR_Coverage, 13808,
     /* 1318800 */     GIR_EraseRootFromParent_Done,
     /* 1318801 */   // Label 18861: @1318801
     /* 1318801 */   GIM_Try, /*On fail goto*//*Label 18862*/ GIMT_Encode4(1318882), // Rule ID 13809 //
     /* 1318806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1318817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1318820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1318823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1318829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1318836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1318844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318859 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1318859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1318862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318881 */     // GIR_Coverage, 13809,
     /* 1318881 */     GIR_EraseRootFromParent_Done,
     /* 1318882 */   // Label 18862: @1318882
     /* 1318882 */   GIM_Try, /*On fail goto*//*Label 18863*/ GIMT_Encode4(1318963), // Rule ID 13810 //
     /* 1318887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1318890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1318898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1318901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1318907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1318913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1318925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1318929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1318933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1318940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1318940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1318943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1318945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1318947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1318949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1318951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1318953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1318958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1318961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1318962 */     // GIR_Coverage, 13810,
     /* 1318962 */     GIR_EraseRootFromParent_Done,
     /* 1318963 */   // Label 18863: @1318963
     /* 1318963 */   GIM_Try, /*On fail goto*//*Label 18864*/ GIMT_Encode4(1319044), // Rule ID 13811 //
     /* 1318968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1318971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1318976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1318979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1318982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1318985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1318988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1318991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1318994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1318998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319021 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1319021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1319024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319043 */     // GIR_Coverage, 13811,
     /* 1319043 */     GIR_EraseRootFromParent_Done,
     /* 1319044 */   // Label 18864: @1319044
     /* 1319044 */   GIM_Try, /*On fail goto*//*Label 18865*/ GIMT_Encode4(1319125), // Rule ID 13812 //
     /* 1319049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1319060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1319063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319102 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1319102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1319105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319124 */     // GIR_Coverage, 13812,
     /* 1319124 */     GIR_EraseRootFromParent_Done,
     /* 1319125 */   // Label 18865: @1319125
     /* 1319125 */   GIM_Try, /*On fail goto*//*Label 18866*/ GIMT_Encode4(1319206), // Rule ID 13813 //
     /* 1319130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1319141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1319144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1319147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1319160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1319168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1319183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M2),
     /* 1319186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319205 */     // GIR_Coverage, 13813,
     /* 1319205 */     GIR_EraseRootFromParent_Done,
     /* 1319206 */   // Label 18866: @1319206
     /* 1319206 */   GIM_Try, /*On fail goto*//*Label 18867*/ GIMT_Encode4(1319287), // Rule ID 13814 //
     /* 1319211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1319222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1319225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1319264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1319267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319286 */     // GIR_Coverage, 13814,
     /* 1319286 */     GIR_EraseRootFromParent_Done,
     /* 1319287 */   // Label 18867: @1319287
     /* 1319287 */   GIM_Try, /*On fail goto*//*Label 18868*/ GIMT_Encode4(1319368), // Rule ID 13815 //
     /* 1319292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1319303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1319306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1319309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1319315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1319322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1319330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319345 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1319345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M4),
     /* 1319348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319366 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319367 */     // GIR_Coverage, 13815,
     /* 1319367 */     GIR_EraseRootFromParent_Done,
     /* 1319368 */   // Label 18868: @1319368
     /* 1319368 */   GIM_Try, /*On fail goto*//*Label 18869*/ GIMT_Encode4(1319449), // Rule ID 13816 //
     /* 1319373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1319376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1319384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1319387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1319393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1319426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1319429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319448 */     // GIR_Coverage, 13816,
     /* 1319448 */     GIR_EraseRootFromParent_Done,
     /* 1319449 */   // Label 18869: @1319449
     /* 1319449 */   GIM_Try, /*On fail goto*//*Label 18870*/ GIMT_Encode4(1319530), // Rule ID 13817 //
     /* 1319454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1319457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1319462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1319465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1319468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1319471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1319474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1319477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1319484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1319492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1319496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319507 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VXM_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1319507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VXM_M8),
     /* 1319510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1319528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319529 */     // GIR_Coverage, 13817,
     /* 1319529 */     GIR_EraseRootFromParent_Done,
     /* 1319530 */   // Label 18870: @1319530
     /* 1319530 */   GIM_Try, /*On fail goto*//*Label 18871*/ GIMT_Encode4(1319614), // Rule ID 19656 //
     /* 1319535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1319538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1319591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319613 */     // GIR_Coverage, 19656,
     /* 1319613 */     GIR_EraseRootFromParent_Done,
     /* 1319614 */   // Label 18871: @1319614
     /* 1319614 */   GIM_Try, /*On fail goto*//*Label 18872*/ GIMT_Encode4(1319698), // Rule ID 19657 //
     /* 1319619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1319622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1319636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1319639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4_MASK),
     /* 1319675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319697 */     // GIR_Coverage, 19657,
     /* 1319697 */     GIR_EraseRootFromParent_Done,
     /* 1319698 */   // Label 18872: @1319698
     /* 1319698 */   GIM_Try, /*On fail goto*//*Label 18873*/ GIMT_Encode4(1319782), // Rule ID 19660 //
     /* 1319703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1319706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319756 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1319759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319781 */     // GIR_Coverage, 19660,
     /* 1319781 */     GIR_EraseRootFromParent_Done,
     /* 1319782 */   // Label 18873: @1319782
     /* 1319782 */   GIM_Try, /*On fail goto*//*Label 18874*/ GIMT_Encode4(1319866), // Rule ID 19661 //
     /* 1319787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1319790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1319798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1319801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1319804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1319807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1319810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319840 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1319840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1319843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1319861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319865 */     // GIR_Coverage, 19661,
     /* 1319865 */     GIR_EraseRootFromParent_Done,
     /* 1319866 */   // Label 18874: @1319866
     /* 1319866 */   GIM_Try, /*On fail goto*//*Label 18875*/ GIMT_Encode4(1319950), // Rule ID 19664 //
     /* 1319871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1319874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1319897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1319917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1319924 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1319924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1319927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1319929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1319931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1319933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1319935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1319937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1319942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1319945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1319948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1319949 */     // GIR_Coverage, 19664,
     /* 1319949 */     GIR_EraseRootFromParent_Done,
     /* 1319950 */   // Label 18875: @1319950
     /* 1319950 */   GIM_Try, /*On fail goto*//*Label 18876*/ GIMT_Encode4(1320034), // Rule ID 19665 //
     /* 1319955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1319958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1319963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1319966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1319969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1319972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1319975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1319978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1319981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1319997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320008 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2_MASK),
     /* 1320011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320033 */     // GIR_Coverage, 19665,
     /* 1320033 */     GIR_EraseRootFromParent_Done,
     /* 1320034 */   // Label 18876: @1320034
     /* 1320034 */   GIM_Try, /*On fail goto*//*Label 18877*/ GIMT_Encode4(1320118), // Rule ID 19668 //
     /* 1320039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1320042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1320050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1320053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320092 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320117 */     // GIR_Coverage, 19668,
     /* 1320117 */     GIR_EraseRootFromParent_Done,
     /* 1320118 */   // Label 18877: @1320118
     /* 1320118 */   GIM_Try, /*On fail goto*//*Label 18878*/ GIMT_Encode4(1320202), // Rule ID 19669 //
     /* 1320123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1320126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1320134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1320137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1320140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1320143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1320146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320176 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320201 */     // GIR_Coverage, 19669,
     /* 1320201 */     GIR_EraseRootFromParent_Done,
     /* 1320202 */   // Label 18878: @1320202
     /* 1320202 */   GIM_Try, /*On fail goto*//*Label 18879*/ GIMT_Encode4(1320286), // Rule ID 19672 //
     /* 1320207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1320210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1320218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1320221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320260 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320285 */     // GIR_Coverage, 19672,
     /* 1320285 */     GIR_EraseRootFromParent_Done,
     /* 1320286 */   // Label 18879: @1320286
     /* 1320286 */   GIM_Try, /*On fail goto*//*Label 18880*/ GIMT_Encode4(1320370), // Rule ID 19673 //
     /* 1320291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1320294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1320302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1320305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1320308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1320311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1320314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320344 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1320365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320369 */     // GIR_Coverage, 19673,
     /* 1320369 */     GIR_EraseRootFromParent_Done,
     /* 1320370 */   // Label 18880: @1320370
     /* 1320370 */   GIM_Try, /*On fail goto*//*Label 18881*/ GIMT_Encode4(1320454), // Rule ID 19676 //
     /* 1320375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1320378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1320386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1320389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320428 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320453 */     // GIR_Coverage, 19676,
     /* 1320453 */     GIR_EraseRootFromParent_Done,
     /* 1320454 */   // Label 18881: @1320454
     /* 1320454 */   GIM_Try, /*On fail goto*//*Label 18882*/ GIMT_Encode4(1320538), // Rule ID 19677 //
     /* 1320459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1320462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1320470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1320473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1320476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1320479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1320482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320512 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1_MASK),
     /* 1320515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1320533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320537 */     // GIR_Coverage, 19677,
     /* 1320537 */     GIR_EraseRootFromParent_Done,
     /* 1320538 */   // Label 18882: @1320538
     /* 1320538 */   GIM_Try, /*On fail goto*//*Label 18883*/ GIMT_Encode4(1320622), // Rule ID 19680 //
     /* 1320543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1320546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1320554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1320557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1320560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1320563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320596 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1320599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320621 */     // GIR_Coverage, 19680,
     /* 1320621 */     GIR_EraseRootFromParent_Done,
     /* 1320622 */   // Label 18883: @1320622
     /* 1320622 */   GIM_Try, /*On fail goto*//*Label 18884*/ GIMT_Encode4(1320706), // Rule ID 19681 //
     /* 1320627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1320630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1320638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1320641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1320644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1320647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1320650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1320669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320680 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1320683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320705 */     // GIR_Coverage, 19681,
     /* 1320705 */     GIR_EraseRootFromParent_Done,
     /* 1320706 */   // Label 18884: @1320706
     /* 1320706 */   GIM_Try, /*On fail goto*//*Label 18885*/ GIMT_Encode4(1320790), // Rule ID 19684 //
     /* 1320711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1320714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1320722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1320725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1320728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1320731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1320767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320789 */     // GIR_Coverage, 19684,
     /* 1320789 */     GIR_EraseRootFromParent_Done,
     /* 1320790 */   // Label 18885: @1320790
     /* 1320790 */   GIM_Try, /*On fail goto*//*Label 18886*/ GIMT_Encode4(1320874), // Rule ID 19685 //
     /* 1320795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1320798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1320806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1320809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1320812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1320815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1320818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1320837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320848 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1320848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1320851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320873 */     // GIR_Coverage, 19685,
     /* 1320873 */     GIR_EraseRootFromParent_Done,
     /* 1320874 */   // Label 18886: @1320874
     /* 1320874 */   GIM_Try, /*On fail goto*//*Label 18887*/ GIMT_Encode4(1320958), // Rule ID 19688 //
     /* 1320879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1320882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1320890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1320893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1320896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1320899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1320905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1320921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1320925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1320932 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1320932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1320935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1320937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1320939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1320941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1320943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1320945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1320950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1320953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1320956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1320957 */     // GIR_Coverage, 19688,
     /* 1320957 */     GIR_EraseRootFromParent_Done,
     /* 1320958 */   // Label 18887: @1320958
     /* 1320958 */   GIM_Try, /*On fail goto*//*Label 18888*/ GIMT_Encode4(1321042), // Rule ID 19689 //
     /* 1320963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1320966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1320971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1320974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1320977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1320980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1320983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1320986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1320989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1320997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321016 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1321019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1321037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321041 */     // GIR_Coverage, 19689,
     /* 1321041 */     GIR_EraseRootFromParent_Done,
     /* 1321042 */   // Label 18888: @1321042
     /* 1321042 */   GIM_Try, /*On fail goto*//*Label 18889*/ GIMT_Encode4(1321126), // Rule ID 19692 //
     /* 1321047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1321050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321100 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1321103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321125 */     // GIR_Coverage, 19692,
     /* 1321125 */     GIR_EraseRootFromParent_Done,
     /* 1321126 */   // Label 18889: @1321126
     /* 1321126 */   GIM_Try, /*On fail goto*//*Label 18890*/ GIMT_Encode4(1321210), // Rule ID 19693 //
     /* 1321131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1321134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1321148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1321151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321184 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1321187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321209 */     // GIR_Coverage, 19693,
     /* 1321209 */     GIR_EraseRootFromParent_Done,
     /* 1321210 */   // Label 18890: @1321210
     /* 1321210 */   GIM_Try, /*On fail goto*//*Label 18891*/ GIMT_Encode4(1321294), // Rule ID 19696 //
     /* 1321215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1321218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321268 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1321271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321293 */     // GIR_Coverage, 19696,
     /* 1321293 */     GIR_EraseRootFromParent_Done,
     /* 1321294 */   // Label 18891: @1321294
     /* 1321294 */   GIM_Try, /*On fail goto*//*Label 18892*/ GIMT_Encode4(1321378), // Rule ID 19697 //
     /* 1321299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1321302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1321316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1321319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321352 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1321355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321377 */     // GIR_Coverage, 19697,
     /* 1321377 */     GIR_EraseRootFromParent_Done,
     /* 1321378 */   // Label 18892: @1321378
     /* 1321378 */   GIM_Try, /*On fail goto*//*Label 18893*/ GIMT_Encode4(1321462), // Rule ID 19700 //
     /* 1321383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1321386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1321394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1321397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1321400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1321403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321436 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1321439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321461 */     // GIR_Coverage, 19700,
     /* 1321461 */     GIR_EraseRootFromParent_Done,
     /* 1321462 */   // Label 18893: @1321462
     /* 1321462 */   GIM_Try, /*On fail goto*//*Label 18894*/ GIMT_Encode4(1321546), // Rule ID 19701 //
     /* 1321467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1321470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1321478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1321481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1321484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1321487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1321490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321520 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1321523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1321541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321545 */     // GIR_Coverage, 19701,
     /* 1321545 */     GIR_EraseRootFromParent_Done,
     /* 1321546 */   // Label 18894: @1321546
     /* 1321546 */   GIM_Try, /*On fail goto*//*Label 18895*/ GIMT_Encode4(1321630), // Rule ID 19704 //
     /* 1321551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1321554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1321562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1321565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1321568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1321571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1321574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321604 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1321607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321629 */     // GIR_Coverage, 19704,
     /* 1321629 */     GIR_EraseRootFromParent_Done,
     /* 1321630 */   // Label 18895: @1321630
     /* 1321630 */   GIM_Try, /*On fail goto*//*Label 18896*/ GIMT_Encode4(1321714), // Rule ID 19705 //
     /* 1321635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1321638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1321646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1321649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1321652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1321655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1321658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1321677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321688 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2_MASK),
     /* 1321691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321713 */     // GIR_Coverage, 19705,
     /* 1321713 */     GIR_EraseRootFromParent_Done,
     /* 1321714 */   // Label 18896: @1321714
     /* 1321714 */   GIM_Try, /*On fail goto*//*Label 18897*/ GIMT_Encode4(1321798), // Rule ID 19708 //
     /* 1321719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1321722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1321736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1321739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1321775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321797 */     // GIR_Coverage, 19708,
     /* 1321797 */     GIR_EraseRootFromParent_Done,
     /* 1321798 */   // Label 18897: @1321798
     /* 1321798 */   GIM_Try, /*On fail goto*//*Label 18898*/ GIMT_Encode4(1321882), // Rule ID 19709 //
     /* 1321803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1321806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1321814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1321817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1321820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1321823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1321826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1321845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321856 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1321856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4_MASK),
     /* 1321859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321881 */     // GIR_Coverage, 19709,
     /* 1321881 */     GIR_EraseRootFromParent_Done,
     /* 1321882 */   // Label 18898: @1321882
     /* 1321882 */   GIM_Try, /*On fail goto*//*Label 18899*/ GIMT_Encode4(1321966), // Rule ID 19712 //
     /* 1321887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1321890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1321904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1321907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1321913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1321921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1321929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1321933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1321940 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1321940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1321943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1321945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1321947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1321949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1321951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1321953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1321958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1321961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1321964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1321965 */     // GIR_Coverage, 19712,
     /* 1321965 */     GIR_EraseRootFromParent_Done,
     /* 1321966 */   // Label 18899: @1321966
     /* 1321966 */   GIM_Try, /*On fail goto*//*Label 18900*/ GIMT_Encode4(1322050), // Rule ID 19713 //
     /* 1321971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1321974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1321979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1321982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1321985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1321988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1321991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1321994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1321997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1322013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322024 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8_MASK),
     /* 1322027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322049 */     // GIR_Coverage, 19713,
     /* 1322049 */     GIR_EraseRootFromParent_Done,
     /* 1322050 */   // Label 18900: @1322050
     /* 1322050 */   GIM_Try, /*On fail goto*//*Label 18901*/ GIMT_Encode4(1322134), // Rule ID 19716 //
     /* 1322055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1322058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1322072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1322111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322133 */     // GIR_Coverage, 19716,
     /* 1322133 */     GIR_EraseRootFromParent_Done,
     /* 1322134 */   // Label 18901: @1322134
     /* 1322134 */   GIM_Try, /*On fail goto*//*Label 18902*/ GIMT_Encode4(1322218), // Rule ID 19717 //
     /* 1322139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1322142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1322156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF4_MASK),
     /* 1322195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322217 */     // GIR_Coverage, 19717,
     /* 1322217 */     GIR_EraseRootFromParent_Done,
     /* 1322218 */   // Label 18902: @1322218
     /* 1322218 */   GIM_Try, /*On fail goto*//*Label 18903*/ GIMT_Encode4(1322302), // Rule ID 19720 //
     /* 1322223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1322226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1322240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322276 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1322279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322301 */     // GIR_Coverage, 19720,
     /* 1322301 */     GIR_EraseRootFromParent_Done,
     /* 1322302 */   // Label 18903: @1322302
     /* 1322302 */   GIM_Try, /*On fail goto*//*Label 18904*/ GIMT_Encode4(1322386), // Rule ID 19721 //
     /* 1322307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1322310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1322324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322360 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_MF2_MASK),
     /* 1322363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322385 */     // GIR_Coverage, 19721,
     /* 1322385 */     GIR_EraseRootFromParent_Done,
     /* 1322386 */   // Label 18904: @1322386
     /* 1322386 */   GIM_Try, /*On fail goto*//*Label 18905*/ GIMT_Encode4(1322470), // Rule ID 19724 //
     /* 1322391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1322394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1322408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1322433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322444 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1322447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322469 */     // GIR_Coverage, 19724,
     /* 1322469 */     GIR_EraseRootFromParent_Done,
     /* 1322470 */   // Label 18905: @1322470
     /* 1322470 */   GIM_Try, /*On fail goto*//*Label 18906*/ GIMT_Encode4(1322554), // Rule ID 19725 //
     /* 1322475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1322478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1322492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1322517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322528 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_MF2_MASK),
     /* 1322531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322553 */     // GIR_Coverage, 19725,
     /* 1322553 */     GIR_EraseRootFromParent_Done,
     /* 1322554 */   // Label 18906: @1322554
     /* 1322554 */   GIM_Try, /*On fail goto*//*Label 18907*/ GIMT_Encode4(1322638), // Rule ID 19728 //
     /* 1322559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1322562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1322570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1322573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1322576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322612 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1322615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322637 */     // GIR_Coverage, 19728,
     /* 1322637 */     GIR_EraseRootFromParent_Done,
     /* 1322638 */   // Label 18907: @1322638
     /* 1322638 */   GIM_Try, /*On fail goto*//*Label 18908*/ GIMT_Encode4(1322722), // Rule ID 19729 //
     /* 1322643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1322646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1322654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1322657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1322660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1322663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1322666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1322685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322696 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M1_MASK),
     /* 1322699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1322717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322721 */     // GIR_Coverage, 19729,
     /* 1322721 */     GIR_EraseRootFromParent_Done,
     /* 1322722 */   // Label 18908: @1322722
     /* 1322722 */   GIM_Try, /*On fail goto*//*Label 18909*/ GIMT_Encode4(1322806), // Rule ID 19732 //
     /* 1322727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1322730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1322744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1322769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322780 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1322783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322805 */     // GIR_Coverage, 19732,
     /* 1322805 */     GIR_EraseRootFromParent_Done,
     /* 1322806 */   // Label 18909: @1322806
     /* 1322806 */   GIM_Try, /*On fail goto*//*Label 18910*/ GIMT_Encode4(1322890), // Rule ID 19733 //
     /* 1322811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1322814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1322822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1322825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1322828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1322831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1322834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1322837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1322853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322864 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1322864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M1_MASK),
     /* 1322867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1322885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322889 */     // GIR_Coverage, 19733,
     /* 1322889 */     GIR_EraseRootFromParent_Done,
     /* 1322890 */   // Label 18910: @1322890
     /* 1322890 */   GIM_Try, /*On fail goto*//*Label 18911*/ GIMT_Encode4(1322974), // Rule ID 19736 //
     /* 1322895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1322898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1322912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1322918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1322921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1322933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1322937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1322941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1322948 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1322948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1322951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1322953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1322955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1322957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1322959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1322961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1322966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1322969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1322972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1322973 */     // GIR_Coverage, 19736,
     /* 1322973 */     GIR_EraseRootFromParent_Done,
     /* 1322974 */   // Label 18911: @1322974
     /* 1322974 */   GIM_Try, /*On fail goto*//*Label 18912*/ GIMT_Encode4(1323058), // Rule ID 19737 //
     /* 1322979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1322982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1322987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1322990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1322993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1322996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1322999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1323002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1323021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323032 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M1_MASK),
     /* 1323035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1323053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323057 */     // GIR_Coverage, 19737,
     /* 1323057 */     GIR_EraseRootFromParent_Done,
     /* 1323058 */   // Label 18912: @1323058
     /* 1323058 */   GIM_Try, /*On fail goto*//*Label 18913*/ GIMT_Encode4(1323142), // Rule ID 19740 //
     /* 1323063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1323066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1323074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1323077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1323080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323116 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1323119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323141 */     // GIR_Coverage, 19740,
     /* 1323141 */     GIR_EraseRootFromParent_Done,
     /* 1323142 */   // Label 18913: @1323142
     /* 1323142 */   GIM_Try, /*On fail goto*//*Label 18914*/ GIMT_Encode4(1323226), // Rule ID 19741 //
     /* 1323147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1323150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1323158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1323161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1323164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323200 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M2_MASK),
     /* 1323203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323225 */     // GIR_Coverage, 19741,
     /* 1323225 */     GIR_EraseRootFromParent_Done,
     /* 1323226 */   // Label 18914: @1323226
     /* 1323226 */   GIM_Try, /*On fail goto*//*Label 18915*/ GIMT_Encode4(1323310), // Rule ID 19744 //
     /* 1323231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1323234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1323242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1323245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1323248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1323254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323284 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1323287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323309 */     // GIR_Coverage, 19744,
     /* 1323309 */     GIR_EraseRootFromParent_Done,
     /* 1323310 */   // Label 18915: @1323310
     /* 1323310 */   GIM_Try, /*On fail goto*//*Label 18916*/ GIMT_Encode4(1323394), // Rule ID 19745 //
     /* 1323315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1323318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1323326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1323329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1323332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1323338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323368 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M4_MASK),
     /* 1323371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323393 */     // GIR_Coverage, 19745,
     /* 1323393 */     GIR_EraseRootFromParent_Done,
     /* 1323394 */   // Label 18916: @1323394
     /* 1323394 */   GIM_Try, /*On fail goto*//*Label 18917*/ GIMT_Encode4(1323478), // Rule ID 19748 //
     /* 1323399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1323402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1323410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1323413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1323416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1323422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323452 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1323455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323477 */     // GIR_Coverage, 19748,
     /* 1323477 */     GIR_EraseRootFromParent_Done,
     /* 1323478 */   // Label 18917: @1323478
     /* 1323478 */   GIM_Try, /*On fail goto*//*Label 18918*/ GIMT_Encode4(1323562), // Rule ID 19749 //
     /* 1323483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1323486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1323494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1323497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1323500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1323503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1323506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1323525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323536 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR16_M8_MASK),
     /* 1323539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1323557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323561 */     // GIR_Coverage, 19749,
     /* 1323561 */     GIR_EraseRootFromParent_Done,
     /* 1323562 */   // Label 18918: @1323562
     /* 1323562 */   GIM_Try, /*On fail goto*//*Label 18919*/ GIMT_Encode4(1323646), // Rule ID 19752 //
     /* 1323567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1323570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1323578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1323581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1323584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1323609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1323623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323645 */     // GIR_Coverage, 19752,
     /* 1323645 */     GIR_EraseRootFromParent_Done,
     /* 1323646 */   // Label 18919: @1323646
     /* 1323646 */   GIM_Try, /*On fail goto*//*Label 18920*/ GIMT_Encode4(1323730), // Rule ID 19753 //
     /* 1323651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1323654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1323662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1323665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1323668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1323674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1323689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1323693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323704 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M2_MASK),
     /* 1323707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323729 */     // GIR_Coverage, 19753,
     /* 1323729 */     GIR_EraseRootFromParent_Done,
     /* 1323730 */   // Label 18920: @1323730
     /* 1323730 */   GIM_Try, /*On fail goto*//*Label 18921*/ GIMT_Encode4(1323814), // Rule ID 19756 //
     /* 1323735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1323738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1323746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1323749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1323752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1323777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323788 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1323791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323813 */     // GIR_Coverage, 19756,
     /* 1323813 */     GIR_EraseRootFromParent_Done,
     /* 1323814 */   // Label 18921: @1323814
     /* 1323814 */   GIM_Try, /*On fail goto*//*Label 18922*/ GIMT_Encode4(1323898), // Rule ID 19757 //
     /* 1323819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1323822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1323830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1323833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1323836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1323842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1323845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1323857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1323861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323872 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1323872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M4_MASK),
     /* 1323875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323897 */     // GIR_Coverage, 19757,
     /* 1323897 */     GIR_EraseRootFromParent_Done,
     /* 1323898 */   // Label 18922: @1323898
     /* 1323898 */   GIM_Try, /*On fail goto*//*Label 18923*/ GIMT_Encode4(1323982), // Rule ID 19760 //
     /* 1323903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1323906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1323914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1323917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1323920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1323923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1323926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1323929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1323937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1323941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1323945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1323949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1323956 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1323956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1323959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1323961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1323963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1323965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1323967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1323969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1323974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1323977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1323980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1323981 */     // GIR_Coverage, 19760,
     /* 1323981 */     GIR_EraseRootFromParent_Done,
     /* 1323982 */   // Label 18923: @1323982
     /* 1323982 */   GIM_Try, /*On fail goto*//*Label 18924*/ GIMT_Encode4(1324066), // Rule ID 19761 //
     /* 1323987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1323990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1323995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1323998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1324001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1324004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1324007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1324010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1324029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324040 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR32_M8_MASK),
     /* 1324043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324065 */     // GIR_Coverage, 19761,
     /* 1324065 */     GIR_EraseRootFromParent_Done,
     /* 1324066 */   // Label 18924: @1324066
     /* 1324066 */   GIM_Try, /*On fail goto*//*Label 18925*/ GIMT_Encode4(1324150), // Rule ID 19764 //
     /* 1324071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1324074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1324088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324124 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1324127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324149 */     // GIR_Coverage, 19764,
     /* 1324149 */     GIR_EraseRootFromParent_Done,
     /* 1324150 */   // Label 18925: @1324150
     /* 1324150 */   GIM_Try, /*On fail goto*//*Label 18926*/ GIMT_Encode4(1324234), // Rule ID 19765 //
     /* 1324155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1324158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1324172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1324193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324208 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M2_MASK),
     /* 1324211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324233 */     // GIR_Coverage, 19765,
     /* 1324233 */     GIR_EraseRootFromParent_Done,
     /* 1324234 */   // Label 18926: @1324234
     /* 1324234 */   GIM_Try, /*On fail goto*//*Label 18927*/ GIMT_Encode4(1324318), // Rule ID 19768 //
     /* 1324239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1324242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1324250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1324253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1324256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1324295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324317 */     // GIR_Coverage, 19768,
     /* 1324317 */     GIR_EraseRootFromParent_Done,
     /* 1324318 */   // Label 18927: @1324318
     /* 1324318 */   GIM_Try, /*On fail goto*//*Label 18928*/ GIMT_Encode4(1324402), // Rule ID 19769 //
     /* 1324323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1324326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1324334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1324337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1324340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1324346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1324361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M4_MASK),
     /* 1324379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324401 */     // GIR_Coverage, 19769,
     /* 1324401 */     GIR_EraseRootFromParent_Done,
     /* 1324402 */   // Label 18928: @1324402
     /* 1324402 */   GIM_Try, /*On fail goto*//*Label 18929*/ GIMT_Encode4(1324486), // Rule ID 19772 //
     /* 1324407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1324410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1324418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1324421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1324424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324460 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1324463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324485 */     // GIR_Coverage, 19772,
     /* 1324485 */     GIR_EraseRootFromParent_Done,
     /* 1324486 */   // Label 18929: @1324486
     /* 1324486 */   GIM_Try, /*On fail goto*//*Label 18930*/ GIMT_Encode4(1324570), // Rule ID 19773 //
     /* 1324491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1324494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfeq_mask),
     /* 1324499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1324502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1324505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1324508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1324511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1324514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1324529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1324533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324544 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11352:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFEQ_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VFPR64_M8_MASK),
     /* 1324547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1324565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324569 */     // GIR_Coverage, 19773,
     /* 1324569 */     GIR_EraseRootFromParent_Done,
     /* 1324570 */   // Label 18930: @1324570
     /* 1324570 */   GIM_Try, /*On fail goto*//*Label 18931*/ GIMT_Encode4(1324654), // Rule ID 19776 //
     /* 1324575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1324578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1324583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1324592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1324595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1324631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324653 */     // GIR_Coverage, 19776,
     /* 1324653 */     GIR_EraseRootFromParent_Done,
     /* 1324654 */   // Label 18931: @1324654
     /* 1324654 */   GIM_Try, /*On fail goto*//*Label 18932*/ GIMT_Encode4(1324738), // Rule ID 19777 //
     /* 1324659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1324662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1324667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1324676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1324679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1324715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324737 */     // GIR_Coverage, 19777,
     /* 1324737 */     GIR_EraseRootFromParent_Done,
     /* 1324738 */   // Label 18932: @1324738
     /* 1324738 */   GIM_Try, /*On fail goto*//*Label 18933*/ GIMT_Encode4(1324822), // Rule ID 19780 //
     /* 1324743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1324746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1324751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1324760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1324763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324796 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1324799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324821 */     // GIR_Coverage, 19780,
     /* 1324821 */     GIR_EraseRootFromParent_Done,
     /* 1324822 */   // Label 18933: @1324822
     /* 1324822 */   GIM_Try, /*On fail goto*//*Label 18934*/ GIMT_Encode4(1324906), // Rule ID 19781 //
     /* 1324827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1324830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1324835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1324838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1324841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1324844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1324847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1324850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1324853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324880 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1324880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1324883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1324901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324905 */     // GIR_Coverage, 19781,
     /* 1324905 */     GIR_EraseRootFromParent_Done,
     /* 1324906 */   // Label 18934: @1324906
     /* 1324906 */   GIM_Try, /*On fail goto*//*Label 18935*/ GIMT_Encode4(1324990), // Rule ID 19784 //
     /* 1324911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1324914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1324919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1324922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1324925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1324928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1324931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1324934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1324937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1324953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1324957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1324964 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1324964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1324967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1324969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1324971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1324973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1324975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1324977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1324982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1324985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1324988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1324989 */     // GIR_Coverage, 19784,
     /* 1324989 */     GIR_EraseRootFromParent_Done,
     /* 1324990 */   // Label 18935: @1324990
     /* 1324990 */   GIM_Try, /*On fail goto*//*Label 18936*/ GIMT_Encode4(1325074), // Rule ID 19785 //
     /* 1324995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1324998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1325006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1325009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1325012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1325015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1325018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325048 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1325051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325073 */     // GIR_Coverage, 19785,
     /* 1325073 */     GIR_EraseRootFromParent_Done,
     /* 1325074 */   // Label 18936: @1325074
     /* 1325074 */   GIM_Try, /*On fail goto*//*Label 18937*/ GIMT_Encode4(1325158), // Rule ID 19788 //
     /* 1325079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1325090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1325093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1325096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1325099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325132 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325157 */     // GIR_Coverage, 19788,
     /* 1325157 */     GIR_EraseRootFromParent_Done,
     /* 1325158 */   // Label 18937: @1325158
     /* 1325158 */   GIM_Try, /*On fail goto*//*Label 18938*/ GIMT_Encode4(1325242), // Rule ID 19789 //
     /* 1325163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1325166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1325174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1325177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1325180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1325183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1325186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325216 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325241 */     // GIR_Coverage, 19789,
     /* 1325241 */     GIR_EraseRootFromParent_Done,
     /* 1325242 */   // Label 18938: @1325242
     /* 1325242 */   GIM_Try, /*On fail goto*//*Label 18939*/ GIMT_Encode4(1325326), // Rule ID 19792 //
     /* 1325247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1325250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1325258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1325261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1325264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1325267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325325 */     // GIR_Coverage, 19792,
     /* 1325325 */     GIR_EraseRootFromParent_Done,
     /* 1325326 */   // Label 18939: @1325326
     /* 1325326 */   GIM_Try, /*On fail goto*//*Label 18940*/ GIMT_Encode4(1325410), // Rule ID 19793 //
     /* 1325331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1325334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1325342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1325345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1325348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1325351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1325354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325384 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1325405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325409 */     // GIR_Coverage, 19793,
     /* 1325409 */     GIR_EraseRootFromParent_Done,
     /* 1325410 */   // Label 18940: @1325410
     /* 1325410 */   GIM_Try, /*On fail goto*//*Label 18941*/ GIMT_Encode4(1325494), // Rule ID 19796 //
     /* 1325415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1325418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1325426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1325429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1325432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1325435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1325438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325468 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325493 */     // GIR_Coverage, 19796,
     /* 1325493 */     GIR_EraseRootFromParent_Done,
     /* 1325494 */   // Label 18941: @1325494
     /* 1325494 */   GIM_Try, /*On fail goto*//*Label 18942*/ GIMT_Encode4(1325578), // Rule ID 19797 //
     /* 1325499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1325502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1325510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1325513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1325516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1325519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1325522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325552 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1325555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1325573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325577 */     // GIR_Coverage, 19797,
     /* 1325577 */     GIR_EraseRootFromParent_Done,
     /* 1325578 */   // Label 18942: @1325578
     /* 1325578 */   GIM_Try, /*On fail goto*//*Label 18943*/ GIMT_Encode4(1325662), // Rule ID 19800 //
     /* 1325583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1325594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1325597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1325603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325636 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1325639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325661 */     // GIR_Coverage, 19800,
     /* 1325661 */     GIR_EraseRootFromParent_Done,
     /* 1325662 */   // Label 18943: @1325662
     /* 1325662 */   GIM_Try, /*On fail goto*//*Label 18944*/ GIMT_Encode4(1325746), // Rule ID 19801 //
     /* 1325667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1325670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1325678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1325681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1325684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1325687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1325690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1325709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325720 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1325723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325745 */     // GIR_Coverage, 19801,
     /* 1325745 */     GIR_EraseRootFromParent_Done,
     /* 1325746 */   // Label 18944: @1325746
     /* 1325746 */   GIM_Try, /*On fail goto*//*Label 18945*/ GIMT_Encode4(1325830), // Rule ID 19804 //
     /* 1325751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325804 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1325807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325829 */     // GIR_Coverage, 19804,
     /* 1325829 */     GIR_EraseRootFromParent_Done,
     /* 1325830 */   // Label 18945: @1325830
     /* 1325830 */   GIM_Try, /*On fail goto*//*Label 18946*/ GIMT_Encode4(1325914), // Rule ID 19805 //
     /* 1325835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1325838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1325846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1325849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1325852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1325855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1325858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1325861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1325877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325888 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1325888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1325891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325913 */     // GIR_Coverage, 19805,
     /* 1325913 */     GIR_EraseRootFromParent_Done,
     /* 1325914 */   // Label 18946: @1325914
     /* 1325914 */   GIM_Try, /*On fail goto*//*Label 18947*/ GIMT_Encode4(1325998), // Rule ID 19808 //
     /* 1325919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1325922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1325927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1325930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1325933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1325936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1325939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1325942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1325945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1325953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1325961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1325965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1325972 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1325972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1325975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1325977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1325979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1325981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1325983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1325985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1325990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1325993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1325996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1325997 */     // GIR_Coverage, 19808,
     /* 1325997 */     GIR_EraseRootFromParent_Done,
     /* 1325998 */   // Label 18947: @1325998
     /* 1325998 */   GIM_Try, /*On fail goto*//*Label 18948*/ GIMT_Encode4(1326082), // Rule ID 19809 //
     /* 1326003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1326006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1326014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1326017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1326020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1326023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1326026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326056 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1326059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1326077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326081 */     // GIR_Coverage, 19809,
     /* 1326081 */     GIR_EraseRootFromParent_Done,
     /* 1326082 */   // Label 18948: @1326082
     /* 1326082 */   GIM_Try, /*On fail goto*//*Label 18949*/ GIMT_Encode4(1326166), // Rule ID 19812 //
     /* 1326087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1326104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1326107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326140 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1326143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326165 */     // GIR_Coverage, 19812,
     /* 1326165 */     GIR_EraseRootFromParent_Done,
     /* 1326166 */   // Label 18949: @1326166
     /* 1326166 */   GIM_Try, /*On fail goto*//*Label 18950*/ GIMT_Encode4(1326250), // Rule ID 19813 //
     /* 1326171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1326188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1326191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326224 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1326227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326249 */     // GIR_Coverage, 19813,
     /* 1326249 */     GIR_EraseRootFromParent_Done,
     /* 1326250 */   // Label 18950: @1326250
     /* 1326250 */   GIM_Try, /*On fail goto*//*Label 18951*/ GIMT_Encode4(1326334), // Rule ID 19816 //
     /* 1326255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1326266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1326269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1326272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1326275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326308 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1326311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326333 */     // GIR_Coverage, 19816,
     /* 1326333 */     GIR_EraseRootFromParent_Done,
     /* 1326334 */   // Label 18951: @1326334
     /* 1326334 */   GIM_Try, /*On fail goto*//*Label 18952*/ GIMT_Encode4(1326418), // Rule ID 19817 //
     /* 1326339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1326350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1326353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1326356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1326359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326392 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1326395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326417 */     // GIR_Coverage, 19817,
     /* 1326417 */     GIR_EraseRootFromParent_Done,
     /* 1326418 */   // Label 18952: @1326418
     /* 1326418 */   GIM_Try, /*On fail goto*//*Label 18953*/ GIMT_Encode4(1326502), // Rule ID 19820 //
     /* 1326423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1326426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1326434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1326437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1326443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1326479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326501 */     // GIR_Coverage, 19820,
     /* 1326501 */     GIR_EraseRootFromParent_Done,
     /* 1326502 */   // Label 18953: @1326502
     /* 1326502 */   GIM_Try, /*On fail goto*//*Label 18954*/ GIMT_Encode4(1326586), // Rule ID 19821 //
     /* 1326507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1326510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1326518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1326521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1326524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1326527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1326530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326560 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1326563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1326581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326585 */     // GIR_Coverage, 19821,
     /* 1326585 */     GIR_EraseRootFromParent_Done,
     /* 1326586 */   // Label 18954: @1326586
     /* 1326586 */   GIM_Try, /*On fail goto*//*Label 18955*/ GIMT_Encode4(1326670), // Rule ID 19824 //
     /* 1326591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1326611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326644 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1326647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326669 */     // GIR_Coverage, 19824,
     /* 1326669 */     GIR_EraseRootFromParent_Done,
     /* 1326670 */   // Label 18955: @1326670
     /* 1326670 */   GIM_Try, /*On fail goto*//*Label 18956*/ GIMT_Encode4(1326754), // Rule ID 19825 //
     /* 1326675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1326678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1326686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1326689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1326692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1326695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1326698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1326717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326728 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1326731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326753 */     // GIR_Coverage, 19825,
     /* 1326753 */     GIR_EraseRootFromParent_Done,
     /* 1326754 */   // Label 18956: @1326754
     /* 1326754 */   GIM_Try, /*On fail goto*//*Label 18957*/ GIMT_Encode4(1326838), // Rule ID 19828 //
     /* 1326759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1326815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326837 */     // GIR_Coverage, 19828,
     /* 1326837 */     GIR_EraseRootFromParent_Done,
     /* 1326838 */   // Label 18957: @1326838
     /* 1326838 */   GIM_Try, /*On fail goto*//*Label 18958*/ GIMT_Encode4(1326922), // Rule ID 19829 //
     /* 1326843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1326846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1326854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1326857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1326860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1326863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1326866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1326869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1326885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1326896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1326899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1326917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1326920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1326921 */     // GIR_Coverage, 19829,
     /* 1326921 */     GIR_EraseRootFromParent_Done,
     /* 1326922 */   // Label 18958: @1326922
     /* 1326922 */   GIM_Try, /*On fail goto*//*Label 18959*/ GIMT_Encode4(1327006), // Rule ID 19832 //
     /* 1326927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1326930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1326935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1326938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1326941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1326944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1326947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1326950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1326953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1326961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1326969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1326973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1326980 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1326980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1326983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1326985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1326987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1326989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1326991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1326993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1326998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327005 */     // GIR_Coverage, 19832,
     /* 1327005 */     GIR_EraseRootFromParent_Done,
     /* 1327006 */   // Label 18959: @1327006
     /* 1327006 */   GIM_Try, /*On fail goto*//*Label 18960*/ GIMT_Encode4(1327090), // Rule ID 19833 //
     /* 1327011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1327014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1327022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1327025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1327028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1327031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1327034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1327053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327064 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1327067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1327085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327089 */     // GIR_Coverage, 19833,
     /* 1327089 */     GIR_EraseRootFromParent_Done,
     /* 1327090 */   // Label 18960: @1327090
     /* 1327090 */   GIM_Try, /*On fail goto*//*Label 18961*/ GIMT_Encode4(1327174), // Rule ID 19836 //
     /* 1327095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1327112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1327151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327173 */     // GIR_Coverage, 19836,
     /* 1327173 */     GIR_EraseRootFromParent_Done,
     /* 1327174 */   // Label 18961: @1327174
     /* 1327174 */   GIM_Try, /*On fail goto*//*Label 18962*/ GIMT_Encode4(1327258), // Rule ID 19837 //
     /* 1327179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1327196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF4_MASK),
     /* 1327235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327257 */     // GIR_Coverage, 19837,
     /* 1327257 */     GIR_EraseRootFromParent_Done,
     /* 1327258 */   // Label 18962: @1327258
     /* 1327258 */   GIM_Try, /*On fail goto*//*Label 18963*/ GIMT_Encode4(1327342), // Rule ID 19840 //
     /* 1327263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1327280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327316 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1327319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327341 */     // GIR_Coverage, 19840,
     /* 1327341 */     GIR_EraseRootFromParent_Done,
     /* 1327342 */   // Label 18963: @1327342
     /* 1327342 */   GIM_Try, /*On fail goto*//*Label 18964*/ GIMT_Encode4(1327426), // Rule ID 19841 //
     /* 1327347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1327364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327400 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_MF2_MASK),
     /* 1327403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327425 */     // GIR_Coverage, 19841,
     /* 1327425 */     GIR_EraseRootFromParent_Done,
     /* 1327426 */   // Label 18964: @1327426
     /* 1327426 */   GIM_Try, /*On fail goto*//*Label 18965*/ GIMT_Encode4(1327510), // Rule ID 19844 //
     /* 1327431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327484 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1327487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327509 */     // GIR_Coverage, 19844,
     /* 1327509 */     GIR_EraseRootFromParent_Done,
     /* 1327510 */   // Label 18965: @1327510
     /* 1327510 */   GIM_Try, /*On fail goto*//*Label 18966*/ GIMT_Encode4(1327594), // Rule ID 19845 //
     /* 1327515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1327532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327568 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_MF2_MASK),
     /* 1327571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327593 */     // GIR_Coverage, 19845,
     /* 1327593 */     GIR_EraseRootFromParent_Done,
     /* 1327594 */   // Label 18966: @1327594
     /* 1327594 */   GIM_Try, /*On fail goto*//*Label 18967*/ GIMT_Encode4(1327678), // Rule ID 19848 //
     /* 1327599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1327602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327652 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1327655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327677 */     // GIR_Coverage, 19848,
     /* 1327677 */     GIR_EraseRootFromParent_Done,
     /* 1327678 */   // Label 18967: @1327678
     /* 1327678 */   GIM_Try, /*On fail goto*//*Label 18968*/ GIMT_Encode4(1327762), // Rule ID 19849 //
     /* 1327683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1327686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1327694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1327697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1327700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1327703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1327706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1327725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327736 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M1_MASK),
     /* 1327739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1327757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327761 */     // GIR_Coverage, 19849,
     /* 1327761 */     GIR_EraseRootFromParent_Done,
     /* 1327762 */   // Label 18968: @1327762
     /* 1327762 */   GIM_Try, /*On fail goto*//*Label 18969*/ GIMT_Encode4(1327846), // Rule ID 19852 //
     /* 1327767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1327770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327820 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1327823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327845 */     // GIR_Coverage, 19852,
     /* 1327845 */     GIR_EraseRootFromParent_Done,
     /* 1327846 */   // Label 18969: @1327846
     /* 1327846 */   GIM_Try, /*On fail goto*//*Label 18970*/ GIMT_Encode4(1327930), // Rule ID 19853 //
     /* 1327851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1327854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1327862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1327865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1327868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1327871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1327874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1327877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1327893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1327904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M1_MASK),
     /* 1327907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1327917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1327922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1327925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1327928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1327929 */     // GIR_Coverage, 19853,
     /* 1327929 */     GIR_EraseRootFromParent_Done,
     /* 1327930 */   // Label 18970: @1327930
     /* 1327930 */   GIM_Try, /*On fail goto*//*Label 18971*/ GIMT_Encode4(1328014), // Rule ID 19856 //
     /* 1327935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1327938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1327943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1327946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1327949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1327952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1327955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1327958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1327961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1327973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1327977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1327981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1327988 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1327988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1327991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1327993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1327995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1327997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1327999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328013 */     // GIR_Coverage, 19856,
     /* 1328013 */     GIR_EraseRootFromParent_Done,
     /* 1328014 */   // Label 18971: @1328014
     /* 1328014 */   GIM_Try, /*On fail goto*//*Label 18972*/ GIMT_Encode4(1328098), // Rule ID 19857 //
     /* 1328019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1328022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1328030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1328033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1328036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1328039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1328042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1328061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328072 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M1_MASK),
     /* 1328075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1328093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328097 */     // GIR_Coverage, 19857,
     /* 1328097 */     GIR_EraseRootFromParent_Done,
     /* 1328098 */   // Label 18972: @1328098
     /* 1328098 */   GIM_Try, /*On fail goto*//*Label 18973*/ GIMT_Encode4(1328182), // Rule ID 19860 //
     /* 1328103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1328120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328156 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1328159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328181 */     // GIR_Coverage, 19860,
     /* 1328181 */     GIR_EraseRootFromParent_Done,
     /* 1328182 */   // Label 18973: @1328182
     /* 1328182 */   GIM_Try, /*On fail goto*//*Label 18974*/ GIMT_Encode4(1328266), // Rule ID 19861 //
     /* 1328187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1328204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328240 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M2_MASK),
     /* 1328243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328265 */     // GIR_Coverage, 19861,
     /* 1328265 */     GIR_EraseRootFromParent_Done,
     /* 1328266 */   // Label 18974: @1328266
     /* 1328266 */   GIM_Try, /*On fail goto*//*Label 18975*/ GIMT_Encode4(1328350), // Rule ID 19864 //
     /* 1328271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1328288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328324 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1328327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328349 */     // GIR_Coverage, 19864,
     /* 1328349 */     GIR_EraseRootFromParent_Done,
     /* 1328350 */   // Label 18975: @1328350
     /* 1328350 */   GIM_Try, /*On fail goto*//*Label 18976*/ GIMT_Encode4(1328434), // Rule ID 19865 //
     /* 1328355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1328372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328408 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M4_MASK),
     /* 1328411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328433 */     // GIR_Coverage, 19865,
     /* 1328433 */     GIR_EraseRootFromParent_Done,
     /* 1328434 */   // Label 18976: @1328434
     /* 1328434 */   GIM_Try, /*On fail goto*//*Label 18977*/ GIMT_Encode4(1328518), // Rule ID 19868 //
     /* 1328439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1328442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1328450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1328453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328492 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1328495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328517 */     // GIR_Coverage, 19868,
     /* 1328517 */     GIR_EraseRootFromParent_Done,
     /* 1328518 */   // Label 18977: @1328518
     /* 1328518 */   GIM_Try, /*On fail goto*//*Label 18978*/ GIMT_Encode4(1328602), // Rule ID 19869 //
     /* 1328523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1328526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1328534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1328537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1328540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1328543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1328546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1328565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328576 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR16_M8_MASK),
     /* 1328579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1328597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328601 */     // GIR_Coverage, 19869,
     /* 1328601 */     GIR_EraseRootFromParent_Done,
     /* 1328602 */   // Label 18978: @1328602
     /* 1328602 */   GIM_Try, /*On fail goto*//*Label 18979*/ GIMT_Encode4(1328686), // Rule ID 19872 //
     /* 1328607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328660 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1328663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328685 */     // GIR_Coverage, 19872,
     /* 1328685 */     GIR_EraseRootFromParent_Done,
     /* 1328686 */   // Label 18979: @1328686
     /* 1328686 */   GIM_Try, /*On fail goto*//*Label 18980*/ GIMT_Encode4(1328770), // Rule ID 19873 //
     /* 1328691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1328702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1328705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1328708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1328714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1328729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328744 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M2_MASK),
     /* 1328747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328769 */     // GIR_Coverage, 19873,
     /* 1328769 */     GIR_EraseRootFromParent_Done,
     /* 1328770 */   // Label 18980: @1328770
     /* 1328770 */   GIM_Try, /*On fail goto*//*Label 18981*/ GIMT_Encode4(1328854), // Rule ID 19876 //
     /* 1328775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328828 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1328831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328853 */     // GIR_Coverage, 19876,
     /* 1328853 */     GIR_EraseRootFromParent_Done,
     /* 1328854 */   // Label 18981: @1328854
     /* 1328854 */   GIM_Try, /*On fail goto*//*Label 18982*/ GIMT_Encode4(1328938), // Rule ID 19877 //
     /* 1328859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1328862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1328870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1328873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1328876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1328882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1328885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1328897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328912 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1328912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M4_MASK),
     /* 1328915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1328917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1328919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1328921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1328923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1328925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1328930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1328933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1328936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1328937 */     // GIR_Coverage, 19877,
     /* 1328937 */     GIR_EraseRootFromParent_Done,
     /* 1328938 */   // Label 18982: @1328938
     /* 1328938 */   GIM_Try, /*On fail goto*//*Label 18983*/ GIMT_Encode4(1329022), // Rule ID 19880 //
     /* 1328943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1328946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1328951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1328954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1328957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1328960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1328963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1328966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1328969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1328977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1328981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1328985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1328989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1328996 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1328996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1328999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329021 */     // GIR_Coverage, 19880,
     /* 1329021 */     GIR_EraseRootFromParent_Done,
     /* 1329022 */   // Label 18983: @1329022
     /* 1329022 */   GIM_Try, /*On fail goto*//*Label 18984*/ GIMT_Encode4(1329106), // Rule ID 19881 //
     /* 1329027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1329030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1329038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1329041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1329044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1329047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1329050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1329069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329080 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR32_M8_MASK),
     /* 1329083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1329101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329105 */     // GIR_Coverage, 19881,
     /* 1329105 */     GIR_EraseRootFromParent_Done,
     /* 1329106 */   // Label 18984: @1329106
     /* 1329106 */   GIM_Try, /*On fail goto*//*Label 18985*/ GIMT_Encode4(1329190), // Rule ID 19884 //
     /* 1329111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1329128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329164 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1329167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329189 */     // GIR_Coverage, 19884,
     /* 1329189 */     GIR_EraseRootFromParent_Done,
     /* 1329190 */   // Label 18985: @1329190
     /* 1329190 */   GIM_Try, /*On fail goto*//*Label 18986*/ GIMT_Encode4(1329274), // Rule ID 19885 //
     /* 1329195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1329212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1329233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329248 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M2_MASK),
     /* 1329251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329273 */     // GIR_Coverage, 19885,
     /* 1329273 */     GIR_EraseRootFromParent_Done,
     /* 1329274 */   // Label 18986: @1329274
     /* 1329274 */   GIM_Try, /*On fail goto*//*Label 18987*/ GIMT_Encode4(1329358), // Rule ID 19888 //
     /* 1329279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1329296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329332 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1329335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329357 */     // GIR_Coverage, 19888,
     /* 1329357 */     GIR_EraseRootFromParent_Done,
     /* 1329358 */   // Label 18987: @1329358
     /* 1329358 */   GIM_Try, /*On fail goto*//*Label 18988*/ GIMT_Encode4(1329442), // Rule ID 19889 //
     /* 1329363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1329374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1329377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1329380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1329386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1329401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329416 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M4_MASK),
     /* 1329419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329441 */     // GIR_Coverage, 19889,
     /* 1329441 */     GIR_EraseRootFromParent_Done,
     /* 1329442 */   // Label 18988: @1329442
     /* 1329442 */   GIM_Try, /*On fail goto*//*Label 18989*/ GIMT_Encode4(1329526), // Rule ID 19892 //
     /* 1329447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1329450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329500 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1329503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329525 */     // GIR_Coverage, 19892,
     /* 1329525 */     GIR_EraseRootFromParent_Done,
     /* 1329526 */   // Label 18989: @1329526
     /* 1329526 */   GIM_Try, /*On fail goto*//*Label 18990*/ GIMT_Encode4(1329610), // Rule ID 19893 //
     /* 1329531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1329534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfle_mask),
     /* 1329539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1329542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1329545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1329548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1329551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1329554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1329569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1329573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329584 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11358:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VFPR64_M8_MASK),
     /* 1329587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1329605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329609 */     // GIR_Coverage, 19893,
     /* 1329609 */     GIR_EraseRootFromParent_Done,
     /* 1329610 */   // Label 18990: @1329610
     /* 1329610 */   GIM_Try, /*On fail goto*//*Label 18991*/ GIMT_Encode4(1329694), // Rule ID 19896 //
     /* 1329615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1329623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1329635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329668 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1329671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329693 */     // GIR_Coverage, 19896,
     /* 1329693 */     GIR_EraseRootFromParent_Done,
     /* 1329694 */   // Label 18991: @1329694
     /* 1329694 */   GIM_Try, /*On fail goto*//*Label 18992*/ GIMT_Encode4(1329778), // Rule ID 19897 //
     /* 1329699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1329707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1329716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1329719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329752 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1329755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329777 */     // GIR_Coverage, 19897,
     /* 1329777 */     GIR_EraseRootFromParent_Done,
     /* 1329778 */   // Label 18992: @1329778
     /* 1329778 */   GIM_Try, /*On fail goto*//*Label 18993*/ GIMT_Encode4(1329862), // Rule ID 19900 //
     /* 1329783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1329786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1329791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1329803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329836 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1329836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1329839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329861 */     // GIR_Coverage, 19900,
     /* 1329861 */     GIR_EraseRootFromParent_Done,
     /* 1329862 */   // Label 18993: @1329862
     /* 1329862 */   GIM_Try, /*On fail goto*//*Label 18994*/ GIMT_Encode4(1329946), // Rule ID 19901 //
     /* 1329867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1329870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1329875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1329878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1329881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1329884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1329887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1329890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1329893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1329920 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1329920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1329923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1329925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1329927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1329929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1329931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1329933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1329938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1329941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1329944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1329945 */     // GIR_Coverage, 19901,
     /* 1329945 */     GIR_EraseRootFromParent_Done,
     /* 1329946 */   // Label 18994: @1329946
     /* 1329946 */   GIM_Try, /*On fail goto*//*Label 18995*/ GIMT_Encode4(1330030), // Rule ID 19904 //
     /* 1329951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1329954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1329959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1329962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1329965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1329968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1329971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1329974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1329977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1329993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1329997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330004 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1330007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330029 */     // GIR_Coverage, 19904,
     /* 1330029 */     GIR_EraseRootFromParent_Done,
     /* 1330030 */   // Label 18995: @1330030
     /* 1330030 */   GIM_Try, /*On fail goto*//*Label 18996*/ GIMT_Encode4(1330114), // Rule ID 19905 //
     /* 1330035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1330052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1330055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330088 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1330091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330113 */     // GIR_Coverage, 19905,
     /* 1330113 */     GIR_EraseRootFromParent_Done,
     /* 1330114 */   // Label 18996: @1330114
     /* 1330114 */   GIM_Try, /*On fail goto*//*Label 18997*/ GIMT_Encode4(1330198), // Rule ID 19908 //
     /* 1330119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1330136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1330139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330172 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330197 */     // GIR_Coverage, 19908,
     /* 1330197 */     GIR_EraseRootFromParent_Done,
     /* 1330198 */   // Label 18997: @1330198
     /* 1330198 */   GIM_Try, /*On fail goto*//*Label 18998*/ GIMT_Encode4(1330282), // Rule ID 19909 //
     /* 1330203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1330214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1330217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1330220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1330223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1330226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330256 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330281 */     // GIR_Coverage, 19909,
     /* 1330281 */     GIR_EraseRootFromParent_Done,
     /* 1330282 */   // Label 18998: @1330282
     /* 1330282 */   GIM_Try, /*On fail goto*//*Label 18999*/ GIMT_Encode4(1330366), // Rule ID 19912 //
     /* 1330287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1330290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1330304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1330307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330340 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330365 */     // GIR_Coverage, 19912,
     /* 1330365 */     GIR_EraseRootFromParent_Done,
     /* 1330366 */   // Label 18999: @1330366
     /* 1330366 */   GIM_Try, /*On fail goto*//*Label 19000*/ GIMT_Encode4(1330450), // Rule ID 19913 //
     /* 1330371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1330374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1330382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1330385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1330388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1330391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1330394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330424 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1330445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330449 */     // GIR_Coverage, 19913,
     /* 1330449 */     GIR_EraseRootFromParent_Done,
     /* 1330450 */   // Label 19000: @1330450
     /* 1330450 */   GIM_Try, /*On fail goto*//*Label 19001*/ GIMT_Encode4(1330534), // Rule ID 19916 //
     /* 1330455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1330458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1330475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330508 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330533 */     // GIR_Coverage, 19916,
     /* 1330533 */     GIR_EraseRootFromParent_Done,
     /* 1330534 */   // Label 19001: @1330534
     /* 1330534 */   GIM_Try, /*On fail goto*//*Label 19002*/ GIMT_Encode4(1330618), // Rule ID 19917 //
     /* 1330539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1330542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1330550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1330553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1330556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1330559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1330562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330592 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1330595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1330613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330617 */     // GIR_Coverage, 19917,
     /* 1330617 */     GIR_EraseRootFromParent_Done,
     /* 1330618 */   // Label 19002: @1330618
     /* 1330618 */   GIM_Try, /*On fail goto*//*Label 19003*/ GIMT_Encode4(1330702), // Rule ID 19920 //
     /* 1330623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1330643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330676 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1330679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330701 */     // GIR_Coverage, 19920,
     /* 1330701 */     GIR_EraseRootFromParent_Done,
     /* 1330702 */   // Label 19003: @1330702
     /* 1330702 */   GIM_Try, /*On fail goto*//*Label 19004*/ GIMT_Encode4(1330786), // Rule ID 19921 //
     /* 1330707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1330718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1330721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1330724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1330727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1330730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1330749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330760 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1330763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330785 */     // GIR_Coverage, 19921,
     /* 1330785 */     GIR_EraseRootFromParent_Done,
     /* 1330786 */   // Label 19004: @1330786
     /* 1330786 */   GIM_Try, /*On fail goto*//*Label 19005*/ GIMT_Encode4(1330870), // Rule ID 19924 //
     /* 1330791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1330811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1330844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1330847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330869 */     // GIR_Coverage, 19924,
     /* 1330869 */     GIR_EraseRootFromParent_Done,
     /* 1330870 */   // Label 19005: @1330870
     /* 1330870 */   GIM_Try, /*On fail goto*//*Label 19006*/ GIMT_Encode4(1330954), // Rule ID 19925 //
     /* 1330875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1330878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1330886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1330889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1330892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1330895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1330898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1330901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1330917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1330921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1330928 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1330928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1330931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1330933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1330935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1330937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1330939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1330941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1330946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1330949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1330952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1330953 */     // GIR_Coverage, 19925,
     /* 1330953 */     GIR_EraseRootFromParent_Done,
     /* 1330954 */   // Label 19006: @1330954
     /* 1330954 */   GIM_Try, /*On fail goto*//*Label 19007*/ GIMT_Encode4(1331038), // Rule ID 19928 //
     /* 1330959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1330962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1330967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1330970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1330973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1330976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1330979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1330982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1330985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1330993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1330997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331012 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1331015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331037 */     // GIR_Coverage, 19928,
     /* 1331037 */     GIR_EraseRootFromParent_Done,
     /* 1331038 */   // Label 19007: @1331038
     /* 1331038 */   GIM_Try, /*On fail goto*//*Label 19008*/ GIMT_Encode4(1331122), // Rule ID 19929 //
     /* 1331043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1331046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1331054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1331057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1331060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1331063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1331066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331096 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1331099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1331117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331121 */     // GIR_Coverage, 19929,
     /* 1331121 */     GIR_EraseRootFromParent_Done,
     /* 1331122 */   // Label 19008: @1331122
     /* 1331122 */   GIM_Try, /*On fail goto*//*Label 19009*/ GIMT_Encode4(1331206), // Rule ID 19932 //
     /* 1331127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1331144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1331147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331180 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1331183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331205 */     // GIR_Coverage, 19932,
     /* 1331205 */     GIR_EraseRootFromParent_Done,
     /* 1331206 */   // Label 19009: @1331206
     /* 1331206 */   GIM_Try, /*On fail goto*//*Label 19010*/ GIMT_Encode4(1331290), // Rule ID 19933 //
     /* 1331211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1331228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1331231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331264 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1331267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331289 */     // GIR_Coverage, 19933,
     /* 1331289 */     GIR_EraseRootFromParent_Done,
     /* 1331290 */   // Label 19010: @1331290
     /* 1331290 */   GIM_Try, /*On fail goto*//*Label 19011*/ GIMT_Encode4(1331374), // Rule ID 19936 //
     /* 1331295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1331312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1331315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331348 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1331351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331373 */     // GIR_Coverage, 19936,
     /* 1331373 */     GIR_EraseRootFromParent_Done,
     /* 1331374 */   // Label 19011: @1331374
     /* 1331374 */   GIM_Try, /*On fail goto*//*Label 19012*/ GIMT_Encode4(1331458), // Rule ID 19937 //
     /* 1331379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1331396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1331399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331432 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1331435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331457 */     // GIR_Coverage, 19937,
     /* 1331457 */     GIR_EraseRootFromParent_Done,
     /* 1331458 */   // Label 19012: @1331458
     /* 1331458 */   GIM_Try, /*On fail goto*//*Label 19013*/ GIMT_Encode4(1331542), // Rule ID 19940 //
     /* 1331463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1331466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1331483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331516 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1331519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331541 */     // GIR_Coverage, 19940,
     /* 1331541 */     GIR_EraseRootFromParent_Done,
     /* 1331542 */   // Label 19013: @1331542
     /* 1331542 */   GIM_Try, /*On fail goto*//*Label 19014*/ GIMT_Encode4(1331626), // Rule ID 19941 //
     /* 1331547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1331550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1331558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1331561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1331564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1331567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1331570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1331589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1331603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1331621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331625 */     // GIR_Coverage, 19941,
     /* 1331625 */     GIR_EraseRootFromParent_Done,
     /* 1331626 */   // Label 19014: @1331626
     /* 1331626 */   GIM_Try, /*On fail goto*//*Label 19015*/ GIMT_Encode4(1331710), // Rule ID 19944 //
     /* 1331631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1331651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331684 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1331687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331709 */     // GIR_Coverage, 19944,
     /* 1331709 */     GIR_EraseRootFromParent_Done,
     /* 1331710 */   // Label 19015: @1331710
     /* 1331710 */   GIM_Try, /*On fail goto*//*Label 19016*/ GIMT_Encode4(1331794), // Rule ID 19945 //
     /* 1331715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1331726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1331729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1331732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1331735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1331738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1331757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331768 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1331771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331793 */     // GIR_Coverage, 19945,
     /* 1331793 */     GIR_EraseRootFromParent_Done,
     /* 1331794 */   // Label 19016: @1331794
     /* 1331794 */   GIM_Try, /*On fail goto*//*Label 19017*/ GIMT_Encode4(1331878), // Rule ID 19948 //
     /* 1331799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1331819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331852 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1331852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1331855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331877 */     // GIR_Coverage, 19948,
     /* 1331877 */     GIR_EraseRootFromParent_Done,
     /* 1331878 */   // Label 19017: @1331878
     /* 1331878 */   GIM_Try, /*On fail goto*//*Label 19018*/ GIMT_Encode4(1331962), // Rule ID 19949 //
     /* 1331883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1331886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1331894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1331897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1331900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1331903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1331906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1331909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1331925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1331929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1331936 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1331936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1331939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1331941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1331943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1331945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1331947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1331949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1331954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1331957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1331960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1331961 */     // GIR_Coverage, 19949,
     /* 1331961 */     GIR_EraseRootFromParent_Done,
     /* 1331962 */   // Label 19018: @1331962
     /* 1331962 */   GIM_Try, /*On fail goto*//*Label 19019*/ GIMT_Encode4(1332046), // Rule ID 19952 //
     /* 1331967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1331970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1331975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1331978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1331981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1331984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1331987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1331990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1331993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1331997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332020 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1332023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332045 */     // GIR_Coverage, 19952,
     /* 1332045 */     GIR_EraseRootFromParent_Done,
     /* 1332046 */   // Label 19019: @1332046
     /* 1332046 */   GIM_Try, /*On fail goto*//*Label 19020*/ GIMT_Encode4(1332130), // Rule ID 19953 //
     /* 1332051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1332054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1332062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1332065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1332068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1332071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1332074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1332093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332104 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1332107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1332125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332129 */     // GIR_Coverage, 19953,
     /* 1332129 */     GIR_EraseRootFromParent_Done,
     /* 1332130 */   // Label 19020: @1332130
     /* 1332130 */   GIM_Try, /*On fail goto*//*Label 19021*/ GIMT_Encode4(1332214), // Rule ID 19956 //
     /* 1332135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332188 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1332191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332213 */     // GIR_Coverage, 19956,
     /* 1332213 */     GIR_EraseRootFromParent_Done,
     /* 1332214 */   // Label 19021: @1332214
     /* 1332214 */   GIM_Try, /*On fail goto*//*Label 19022*/ GIMT_Encode4(1332298), // Rule ID 19957 //
     /* 1332219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1332236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332272 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF4_MASK),
     /* 1332275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332297 */     // GIR_Coverage, 19957,
     /* 1332297 */     GIR_EraseRootFromParent_Done,
     /* 1332298 */   // Label 19022: @1332298
     /* 1332298 */   GIM_Try, /*On fail goto*//*Label 19023*/ GIMT_Encode4(1332382), // Rule ID 19960 //
     /* 1332303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332356 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1332359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332381 */     // GIR_Coverage, 19960,
     /* 1332381 */     GIR_EraseRootFromParent_Done,
     /* 1332382 */   // Label 19023: @1332382
     /* 1332382 */   GIM_Try, /*On fail goto*//*Label 19024*/ GIMT_Encode4(1332466), // Rule ID 19961 //
     /* 1332387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1332404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332440 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_MF2_MASK),
     /* 1332443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332465 */     // GIR_Coverage, 19961,
     /* 1332465 */     GIR_EraseRootFromParent_Done,
     /* 1332466 */   // Label 19024: @1332466
     /* 1332466 */   GIM_Try, /*On fail goto*//*Label 19025*/ GIMT_Encode4(1332550), // Rule ID 19964 //
     /* 1332471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332524 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1332527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332549 */     // GIR_Coverage, 19964,
     /* 1332549 */     GIR_EraseRootFromParent_Done,
     /* 1332550 */   // Label 19025: @1332550
     /* 1332550 */   GIM_Try, /*On fail goto*//*Label 19026*/ GIMT_Encode4(1332634), // Rule ID 19965 //
     /* 1332555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1332572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332608 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_MF2_MASK),
     /* 1332611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332633 */     // GIR_Coverage, 19965,
     /* 1332633 */     GIR_EraseRootFromParent_Done,
     /* 1332634 */   // Label 19026: @1332634
     /* 1332634 */   GIM_Try, /*On fail goto*//*Label 19027*/ GIMT_Encode4(1332718), // Rule ID 19968 //
     /* 1332639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1332642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332692 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1332695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332717 */     // GIR_Coverage, 19968,
     /* 1332717 */     GIR_EraseRootFromParent_Done,
     /* 1332718 */   // Label 19027: @1332718
     /* 1332718 */   GIM_Try, /*On fail goto*//*Label 19028*/ GIMT_Encode4(1332802), // Rule ID 19969 //
     /* 1332723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1332726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1332734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1332737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1332740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1332743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1332746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1332765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332776 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M1_MASK),
     /* 1332779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1332797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332801 */     // GIR_Coverage, 19969,
     /* 1332801 */     GIR_EraseRootFromParent_Done,
     /* 1332802 */   // Label 19028: @1332802
     /* 1332802 */   GIM_Try, /*On fail goto*//*Label 19029*/ GIMT_Encode4(1332886), // Rule ID 19972 //
     /* 1332807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1332810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1332833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1332860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1332863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332885 */     // GIR_Coverage, 19972,
     /* 1332885 */     GIR_EraseRootFromParent_Done,
     /* 1332886 */   // Label 19029: @1332886
     /* 1332886 */   GIM_Try, /*On fail goto*//*Label 19030*/ GIMT_Encode4(1332970), // Rule ID 19973 //
     /* 1332891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1332894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1332902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1332905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1332908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1332911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1332914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1332917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1332929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1332933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1332937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1332944 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1332944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M1_MASK),
     /* 1332947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1332949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1332951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1332953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1332955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1332957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1332962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1332965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1332968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1332969 */     // GIR_Coverage, 19973,
     /* 1332969 */     GIR_EraseRootFromParent_Done,
     /* 1332970 */   // Label 19030: @1332970
     /* 1332970 */   GIM_Try, /*On fail goto*//*Label 19031*/ GIMT_Encode4(1333054), // Rule ID 19976 //
     /* 1332975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1332978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1332983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1332986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1332989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1332992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1332995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1332998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333028 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1333031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333053 */     // GIR_Coverage, 19976,
     /* 1333053 */     GIR_EraseRootFromParent_Done,
     /* 1333054 */   // Label 19031: @1333054
     /* 1333054 */   GIM_Try, /*On fail goto*//*Label 19032*/ GIMT_Encode4(1333138), // Rule ID 19977 //
     /* 1333059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1333062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1333070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1333073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1333076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1333079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1333082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1333101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333112 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M1_MASK),
     /* 1333115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1333133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333137 */     // GIR_Coverage, 19977,
     /* 1333137 */     GIR_EraseRootFromParent_Done,
     /* 1333138 */   // Label 19032: @1333138
     /* 1333138 */   GIM_Try, /*On fail goto*//*Label 19033*/ GIMT_Encode4(1333222), // Rule ID 19980 //
     /* 1333143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1333160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333196 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1333199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333221 */     // GIR_Coverage, 19980,
     /* 1333221 */     GIR_EraseRootFromParent_Done,
     /* 1333222 */   // Label 19033: @1333222
     /* 1333222 */   GIM_Try, /*On fail goto*//*Label 19034*/ GIMT_Encode4(1333306), // Rule ID 19981 //
     /* 1333227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1333244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333280 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M2_MASK),
     /* 1333283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333305 */     // GIR_Coverage, 19981,
     /* 1333305 */     GIR_EraseRootFromParent_Done,
     /* 1333306 */   // Label 19034: @1333306
     /* 1333306 */   GIM_Try, /*On fail goto*//*Label 19035*/ GIMT_Encode4(1333390), // Rule ID 19984 //
     /* 1333311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1333328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333364 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1333367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333389 */     // GIR_Coverage, 19984,
     /* 1333389 */     GIR_EraseRootFromParent_Done,
     /* 1333390 */   // Label 19035: @1333390
     /* 1333390 */   GIM_Try, /*On fail goto*//*Label 19036*/ GIMT_Encode4(1333474), // Rule ID 19985 //
     /* 1333395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1333412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1333418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333448 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M4_MASK),
     /* 1333451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333473 */     // GIR_Coverage, 19985,
     /* 1333473 */     GIR_EraseRootFromParent_Done,
     /* 1333474 */   // Label 19036: @1333474
     /* 1333474 */   GIM_Try, /*On fail goto*//*Label 19037*/ GIMT_Encode4(1333558), // Rule ID 19988 //
     /* 1333479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1333482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333532 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1333535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333557 */     // GIR_Coverage, 19988,
     /* 1333557 */     GIR_EraseRootFromParent_Done,
     /* 1333558 */   // Label 19037: @1333558
     /* 1333558 */   GIM_Try, /*On fail goto*//*Label 19038*/ GIMT_Encode4(1333642), // Rule ID 19989 //
     /* 1333563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1333566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1333574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1333577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1333580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1333583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1333586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1333601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1333605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333616 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR16_M8_MASK),
     /* 1333619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1333637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333641 */     // GIR_Coverage, 19989,
     /* 1333641 */     GIR_EraseRootFromParent_Done,
     /* 1333642 */   // Label 19038: @1333642
     /* 1333642 */   GIM_Try, /*On fail goto*//*Label 19039*/ GIMT_Encode4(1333726), // Rule ID 19992 //
     /* 1333647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333700 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1333703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333725 */     // GIR_Coverage, 19992,
     /* 1333725 */     GIR_EraseRootFromParent_Done,
     /* 1333726 */   // Label 19039: @1333726
     /* 1333726 */   GIM_Try, /*On fail goto*//*Label 19040*/ GIMT_Encode4(1333810), // Rule ID 19993 //
     /* 1333731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1333742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1333745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1333748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1333754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1333769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333784 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M2_MASK),
     /* 1333787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333809 */     // GIR_Coverage, 19993,
     /* 1333809 */     GIR_EraseRootFromParent_Done,
     /* 1333810 */   // Label 19040: @1333810
     /* 1333810 */   GIM_Try, /*On fail goto*//*Label 19041*/ GIMT_Encode4(1333894), // Rule ID 19996 //
     /* 1333815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1333841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333868 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1333868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1333871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333893 */     // GIR_Coverage, 19996,
     /* 1333893 */     GIR_EraseRootFromParent_Done,
     /* 1333894 */   // Label 19041: @1333894
     /* 1333894 */   GIM_Try, /*On fail goto*//*Label 19042*/ GIMT_Encode4(1333978), // Rule ID 19997 //
     /* 1333899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1333902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1333910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1333913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1333916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1333919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1333922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1333925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1333933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1333937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1333941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1333945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1333952 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1333952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M4_MASK),
     /* 1333955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1333957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1333959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1333961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1333963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1333965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1333970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1333973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1333976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1333977 */     // GIR_Coverage, 19997,
     /* 1333977 */     GIR_EraseRootFromParent_Done,
     /* 1333978 */   // Label 19042: @1333978
     /* 1333978 */   GIM_Try, /*On fail goto*//*Label 19043*/ GIMT_Encode4(1334062), // Rule ID 20000 //
     /* 1333983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1333986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1333991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1333994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1333997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1334000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334036 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1334039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334061 */     // GIR_Coverage, 20000,
     /* 1334061 */     GIR_EraseRootFromParent_Done,
     /* 1334062 */   // Label 19043: @1334062
     /* 1334062 */   GIM_Try, /*On fail goto*//*Label 19044*/ GIMT_Encode4(1334146), // Rule ID 20001 //
     /* 1334067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1334070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1334078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1334081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1334084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1334087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1334090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1334109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334120 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR32_M8_MASK),
     /* 1334123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1334141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334145 */     // GIR_Coverage, 20001,
     /* 1334145 */     GIR_EraseRootFromParent_Done,
     /* 1334146 */   // Label 19044: @1334146
     /* 1334146 */   GIM_Try, /*On fail goto*//*Label 19045*/ GIMT_Encode4(1334230), // Rule ID 20004 //
     /* 1334151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1334168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1334207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334229 */     // GIR_Coverage, 20004,
     /* 1334229 */     GIR_EraseRootFromParent_Done,
     /* 1334230 */   // Label 19045: @1334230
     /* 1334230 */   GIM_Try, /*On fail goto*//*Label 19046*/ GIMT_Encode4(1334314), // Rule ID 20005 //
     /* 1334235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1334252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1334273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334288 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M2_MASK),
     /* 1334291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334313 */     // GIR_Coverage, 20005,
     /* 1334313 */     GIR_EraseRootFromParent_Done,
     /* 1334314 */   // Label 19046: @1334314
     /* 1334314 */   GIM_Try, /*On fail goto*//*Label 19047*/ GIMT_Encode4(1334398), // Rule ID 20008 //
     /* 1334319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1334336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334372 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1334375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334397 */     // GIR_Coverage, 20008,
     /* 1334397 */     GIR_EraseRootFromParent_Done,
     /* 1334398 */   // Label 19047: @1334398
     /* 1334398 */   GIM_Try, /*On fail goto*//*Label 19048*/ GIMT_Encode4(1334482), // Rule ID 20009 //
     /* 1334403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1334414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1334417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1334420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1334426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1334441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334456 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M4_MASK),
     /* 1334459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334481 */     // GIR_Coverage, 20009,
     /* 1334481 */     GIR_EraseRootFromParent_Done,
     /* 1334482 */   // Label 19048: @1334482
     /* 1334482 */   GIM_Try, /*On fail goto*//*Label 19049*/ GIMT_Encode4(1334566), // Rule ID 20012 //
     /* 1334487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1334490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334540 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1334543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334565 */     // GIR_Coverage, 20012,
     /* 1334565 */     GIR_EraseRootFromParent_Done,
     /* 1334566 */   // Label 19049: @1334566
     /* 1334566 */   GIM_Try, /*On fail goto*//*Label 19050*/ GIMT_Encode4(1334650), // Rule ID 20013 //
     /* 1334571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1334574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmflt_mask),
     /* 1334579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1334582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1334585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1334588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1334591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1334594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1334609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1334613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334624 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11360:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VFPR64_M8_MASK),
     /* 1334627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1334645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334649 */     // GIR_Coverage, 20013,
     /* 1334649 */     GIR_EraseRootFromParent_Done,
     /* 1334650 */   // Label 19050: @1334650
     /* 1334650 */   GIM_Try, /*On fail goto*//*Label 19051*/ GIMT_Encode4(1334734), // Rule ID 20016 //
     /* 1334655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1334663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1334675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334708 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1334711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334733 */     // GIR_Coverage, 20016,
     /* 1334733 */     GIR_EraseRootFromParent_Done,
     /* 1334734 */   // Label 19051: @1334734
     /* 1334734 */   GIM_Try, /*On fail goto*//*Label 19052*/ GIMT_Encode4(1334818), // Rule ID 20017 //
     /* 1334739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1334747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1334750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1334753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1334756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1334759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1334762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334792 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4_MASK),
     /* 1334795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334817 */     // GIR_Coverage, 20017,
     /* 1334817 */     GIR_EraseRootFromParent_Done,
     /* 1334818 */   // Label 19052: @1334818
     /* 1334818 */   GIM_Try, /*On fail goto*//*Label 19053*/ GIMT_Encode4(1334902), // Rule ID 20020 //
     /* 1334823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1334826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1334831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1334843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1334849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334876 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1334876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1334879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334901 */     // GIR_Coverage, 20020,
     /* 1334901 */     GIR_EraseRootFromParent_Done,
     /* 1334902 */   // Label 19053: @1334902
     /* 1334902 */   GIM_Try, /*On fail goto*//*Label 19054*/ GIMT_Encode4(1334986), // Rule ID 20021 //
     /* 1334907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1334910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1334915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1334918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1334921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1334924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1334927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1334930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1334933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1334949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1334953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1334960 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1334960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1334963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1334965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1334967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1334969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1334971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1334973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1334978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1334981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1334984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1334985 */     // GIR_Coverage, 20021,
     /* 1334985 */     GIR_EraseRootFromParent_Done,
     /* 1334986 */   // Label 19054: @1334986
     /* 1334986 */   GIM_Try, /*On fail goto*//*Label 19055*/ GIMT_Encode4(1335070), // Rule ID 20024 //
     /* 1334991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1334994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1334999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1335008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1335011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335044 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1335047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335069 */     // GIR_Coverage, 20024,
     /* 1335069 */     GIR_EraseRootFromParent_Done,
     /* 1335070 */   // Label 19055: @1335070
     /* 1335070 */   GIM_Try, /*On fail goto*//*Label 19056*/ GIMT_Encode4(1335154), // Rule ID 20025 //
     /* 1335075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1335092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1335095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335128 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2_MASK),
     /* 1335131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335153 */     // GIR_Coverage, 20025,
     /* 1335153 */     GIR_EraseRootFromParent_Done,
     /* 1335154 */   // Label 19056: @1335154
     /* 1335154 */   GIM_Try, /*On fail goto*//*Label 19057*/ GIMT_Encode4(1335238), // Rule ID 20028 //
     /* 1335159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1335176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1335179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335212 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335237 */     // GIR_Coverage, 20028,
     /* 1335237 */     GIR_EraseRootFromParent_Done,
     /* 1335238 */   // Label 19057: @1335238
     /* 1335238 */   GIM_Try, /*On fail goto*//*Label 19058*/ GIMT_Encode4(1335322), // Rule ID 20029 //
     /* 1335243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1335254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1335257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1335260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1335263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1335266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335296 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335321 */     // GIR_Coverage, 20029,
     /* 1335321 */     GIR_EraseRootFromParent_Done,
     /* 1335322 */   // Label 19058: @1335322
     /* 1335322 */   GIM_Try, /*On fail goto*//*Label 19059*/ GIMT_Encode4(1335406), // Rule ID 20032 //
     /* 1335327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1335330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1335344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1335347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335380 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335405 */     // GIR_Coverage, 20032,
     /* 1335405 */     GIR_EraseRootFromParent_Done,
     /* 1335406 */   // Label 19059: @1335406
     /* 1335406 */   GIM_Try, /*On fail goto*//*Label 19060*/ GIMT_Encode4(1335490), // Rule ID 20033 //
     /* 1335411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1335414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1335422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1335425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1335428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1335431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1335434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335464 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1335485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335489 */     // GIR_Coverage, 20033,
     /* 1335489 */     GIR_EraseRootFromParent_Done,
     /* 1335490 */   // Label 19060: @1335490
     /* 1335490 */   GIM_Try, /*On fail goto*//*Label 19061*/ GIMT_Encode4(1335574), // Rule ID 20036 //
     /* 1335495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1335498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1335515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335548 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335573 */     // GIR_Coverage, 20036,
     /* 1335573 */     GIR_EraseRootFromParent_Done,
     /* 1335574 */   // Label 19061: @1335574
     /* 1335574 */   GIM_Try, /*On fail goto*//*Label 19062*/ GIMT_Encode4(1335658), // Rule ID 20037 //
     /* 1335579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1335582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1335590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1335593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1335596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1335599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1335602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335632 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1_MASK),
     /* 1335635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1335653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335657 */     // GIR_Coverage, 20037,
     /* 1335657 */     GIR_EraseRootFromParent_Done,
     /* 1335658 */   // Label 19062: @1335658
     /* 1335658 */   GIM_Try, /*On fail goto*//*Label 19063*/ GIMT_Encode4(1335742), // Rule ID 20040 //
     /* 1335663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1335683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335716 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1335719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335741 */     // GIR_Coverage, 20040,
     /* 1335741 */     GIR_EraseRootFromParent_Done,
     /* 1335742 */   // Label 19063: @1335742
     /* 1335742 */   GIM_Try, /*On fail goto*//*Label 19064*/ GIMT_Encode4(1335826), // Rule ID 20041 //
     /* 1335747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1335758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1335761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1335764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1335767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1335770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1335789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335800 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1335803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335825 */     // GIR_Coverage, 20041,
     /* 1335825 */     GIR_EraseRootFromParent_Done,
     /* 1335826 */   // Label 19064: @1335826
     /* 1335826 */   GIM_Try, /*On fail goto*//*Label 19065*/ GIMT_Encode4(1335910), // Rule ID 20044 //
     /* 1335831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1335834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1335851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1335857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335884 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1335884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1335887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335909 */     // GIR_Coverage, 20044,
     /* 1335909 */     GIR_EraseRootFromParent_Done,
     /* 1335910 */   // Label 19065: @1335910
     /* 1335910 */   GIM_Try, /*On fail goto*//*Label 19066*/ GIMT_Encode4(1335994), // Rule ID 20045 //
     /* 1335915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1335918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1335923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1335926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1335929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1335932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1335935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1335938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1335941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1335949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1335957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1335961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1335968 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1335968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1335971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1335973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1335975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1335977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1335979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1335981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1335986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1335989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1335992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1335993 */     // GIR_Coverage, 20045,
     /* 1335993 */     GIR_EraseRootFromParent_Done,
     /* 1335994 */   // Label 19066: @1335994
     /* 1335994 */   GIM_Try, /*On fail goto*//*Label 19067*/ GIMT_Encode4(1336078), // Rule ID 20048 //
     /* 1335999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1336002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1336010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1336013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1336016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1336019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1336022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336052 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1336055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336077 */     // GIR_Coverage, 20048,
     /* 1336077 */     GIR_EraseRootFromParent_Done,
     /* 1336078 */   // Label 19067: @1336078
     /* 1336078 */   GIM_Try, /*On fail goto*//*Label 19068*/ GIMT_Encode4(1336162), // Rule ID 20049 //
     /* 1336083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1336086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1336094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1336097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1336100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1336103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1336106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336136 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1336139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1336157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336161 */     // GIR_Coverage, 20049,
     /* 1336161 */     GIR_EraseRootFromParent_Done,
     /* 1336162 */   // Label 19068: @1336162
     /* 1336162 */   GIM_Try, /*On fail goto*//*Label 19069*/ GIMT_Encode4(1336246), // Rule ID 20052 //
     /* 1336167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1336184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1336187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336220 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1336223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336245 */     // GIR_Coverage, 20052,
     /* 1336245 */     GIR_EraseRootFromParent_Done,
     /* 1336246 */   // Label 19069: @1336246
     /* 1336246 */   GIM_Try, /*On fail goto*//*Label 19070*/ GIMT_Encode4(1336330), // Rule ID 20053 //
     /* 1336251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1336268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1336271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336304 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1336307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336329 */     // GIR_Coverage, 20053,
     /* 1336329 */     GIR_EraseRootFromParent_Done,
     /* 1336330 */   // Label 19070: @1336330
     /* 1336330 */   GIM_Try, /*On fail goto*//*Label 19071*/ GIMT_Encode4(1336414), // Rule ID 20056 //
     /* 1336335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1336352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1336355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336388 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1336391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336413 */     // GIR_Coverage, 20056,
     /* 1336413 */     GIR_EraseRootFromParent_Done,
     /* 1336414 */   // Label 19071: @1336414
     /* 1336414 */   GIM_Try, /*On fail goto*//*Label 19072*/ GIMT_Encode4(1336498), // Rule ID 20057 //
     /* 1336419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1336430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1336433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1336436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1336439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1336442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336472 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1336475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336497 */     // GIR_Coverage, 20057,
     /* 1336497 */     GIR_EraseRootFromParent_Done,
     /* 1336498 */   // Label 19072: @1336498
     /* 1336498 */   GIM_Try, /*On fail goto*//*Label 19073*/ GIMT_Encode4(1336582), // Rule ID 20060 //
     /* 1336503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1336506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1336523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336556 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1336559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336581 */     // GIR_Coverage, 20060,
     /* 1336581 */     GIR_EraseRootFromParent_Done,
     /* 1336582 */   // Label 19073: @1336582
     /* 1336582 */   GIM_Try, /*On fail goto*//*Label 19074*/ GIMT_Encode4(1336666), // Rule ID 20061 //
     /* 1336587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1336590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1336598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1336601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1336604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1336607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1336610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1336629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336640 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1336643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1336661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336665 */     // GIR_Coverage, 20061,
     /* 1336665 */     GIR_EraseRootFromParent_Done,
     /* 1336666 */   // Label 19074: @1336666
     /* 1336666 */   GIM_Try, /*On fail goto*//*Label 19075*/ GIMT_Encode4(1336750), // Rule ID 20064 //
     /* 1336671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1336691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1336727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336749 */     // GIR_Coverage, 20064,
     /* 1336749 */     GIR_EraseRootFromParent_Done,
     /* 1336750 */   // Label 19075: @1336750
     /* 1336750 */   GIM_Try, /*On fail goto*//*Label 19076*/ GIMT_Encode4(1336834), // Rule ID 20065 //
     /* 1336755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1336766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1336769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1336772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1336775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1336778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1336797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336808 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2_MASK),
     /* 1336811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336833 */     // GIR_Coverage, 20065,
     /* 1336833 */     GIR_EraseRootFromParent_Done,
     /* 1336834 */   // Label 19076: @1336834
     /* 1336834 */   GIM_Try, /*On fail goto*//*Label 19077*/ GIMT_Encode4(1336918), // Rule ID 20068 //
     /* 1336839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1336842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1336859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1336865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336892 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1336892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1336895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1336916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1336917 */     // GIR_Coverage, 20068,
     /* 1336917 */     GIR_EraseRootFromParent_Done,
     /* 1336918 */   // Label 19077: @1336918
     /* 1336918 */   GIM_Try, /*On fail goto*//*Label 19078*/ GIMT_Encode4(1337002), // Rule ID 20069 //
     /* 1336923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1336926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1336931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1336934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1336937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1336940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1336943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1336946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1336949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1336957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1336965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1336969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1336976 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1336976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4_MASK),
     /* 1336979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1336981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1336983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1336985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1336987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1336989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1336994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1336997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337001 */     // GIR_Coverage, 20069,
     /* 1337001 */     GIR_EraseRootFromParent_Done,
     /* 1337002 */   // Label 19078: @1337002
     /* 1337002 */   GIM_Try, /*On fail goto*//*Label 19079*/ GIMT_Encode4(1337086), // Rule ID 20072 //
     /* 1337007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1337010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1337024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1337027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337060 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1337063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337085 */     // GIR_Coverage, 20072,
     /* 1337085 */     GIR_EraseRootFromParent_Done,
     /* 1337086 */   // Label 19079: @1337086
     /* 1337086 */   GIM_Try, /*On fail goto*//*Label 19080*/ GIMT_Encode4(1337170), // Rule ID 20073 //
     /* 1337091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1337094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1337102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1337105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1337108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1337111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1337114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1337133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337144 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8_MASK),
     /* 1337147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1337165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337169 */     // GIR_Coverage, 20073,
     /* 1337169 */     GIR_EraseRootFromParent_Done,
     /* 1337170 */   // Label 19080: @1337170
     /* 1337170 */   GIM_Try, /*On fail goto*//*Label 19081*/ GIMT_Encode4(1337254), // Rule ID 20076 //
     /* 1337175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1337192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337228 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1337231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337253 */     // GIR_Coverage, 20076,
     /* 1337253 */     GIR_EraseRootFromParent_Done,
     /* 1337254 */   // Label 19081: @1337254
     /* 1337254 */   GIM_Try, /*On fail goto*//*Label 19082*/ GIMT_Encode4(1337338), // Rule ID 20077 //
     /* 1337259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1337276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337312 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF4_MASK),
     /* 1337315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337337 */     // GIR_Coverage, 20077,
     /* 1337337 */     GIR_EraseRootFromParent_Done,
     /* 1337338 */   // Label 19082: @1337338
     /* 1337338 */   GIM_Try, /*On fail goto*//*Label 19083*/ GIMT_Encode4(1337422), // Rule ID 20080 //
     /* 1337343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1337360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337396 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1337399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337421 */     // GIR_Coverage, 20080,
     /* 1337421 */     GIR_EraseRootFromParent_Done,
     /* 1337422 */   // Label 19083: @1337422
     /* 1337422 */   GIM_Try, /*On fail goto*//*Label 19084*/ GIMT_Encode4(1337506), // Rule ID 20081 //
     /* 1337427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1337444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337480 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_MF2_MASK),
     /* 1337483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337505 */     // GIR_Coverage, 20081,
     /* 1337505 */     GIR_EraseRootFromParent_Done,
     /* 1337506 */   // Label 19084: @1337506
     /* 1337506 */   GIM_Try, /*On fail goto*//*Label 19085*/ GIMT_Encode4(1337590), // Rule ID 20084 //
     /* 1337511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337564 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1337567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337589 */     // GIR_Coverage, 20084,
     /* 1337589 */     GIR_EraseRootFromParent_Done,
     /* 1337590 */   // Label 19085: @1337590
     /* 1337590 */   GIM_Try, /*On fail goto*//*Label 19086*/ GIMT_Encode4(1337674), // Rule ID 20085 //
     /* 1337595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1337606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1337609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1337612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1337618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337648 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_MF2_MASK),
     /* 1337651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337673 */     // GIR_Coverage, 20085,
     /* 1337673 */     GIR_EraseRootFromParent_Done,
     /* 1337674 */   // Label 19086: @1337674
     /* 1337674 */   GIM_Try, /*On fail goto*//*Label 19087*/ GIMT_Encode4(1337758), // Rule ID 20088 //
     /* 1337679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1337682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337732 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1337735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337757 */     // GIR_Coverage, 20088,
     /* 1337757 */     GIR_EraseRootFromParent_Done,
     /* 1337758 */   // Label 19087: @1337758
     /* 1337758 */   GIM_Try, /*On fail goto*//*Label 19088*/ GIMT_Encode4(1337842), // Rule ID 20089 //
     /* 1337763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1337766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1337774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1337777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1337780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1337783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1337786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1337805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M1_MASK),
     /* 1337819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1337837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337841 */     // GIR_Coverage, 20089,
     /* 1337841 */     GIR_EraseRootFromParent_Done,
     /* 1337842 */   // Label 19088: @1337842
     /* 1337842 */   GIM_Try, /*On fail goto*//*Label 19089*/ GIMT_Encode4(1337926), // Rule ID 20092 //
     /* 1337847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1337850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1337873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337900 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1337900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1337903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1337918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1337921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1337924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1337925 */     // GIR_Coverage, 20092,
     /* 1337925 */     GIR_EraseRootFromParent_Done,
     /* 1337926 */   // Label 19089: @1337926
     /* 1337926 */   GIM_Try, /*On fail goto*//*Label 19090*/ GIMT_Encode4(1338010), // Rule ID 20093 //
     /* 1337931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1337934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1337939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1337942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1337945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1337948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1337951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1337954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1337957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1337969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1337973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1337977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1337984 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1337984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M1_MASK),
     /* 1337987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1337989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1337991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1337993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1337995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1337997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338009 */     // GIR_Coverage, 20093,
     /* 1338009 */     GIR_EraseRootFromParent_Done,
     /* 1338010 */   // Label 19090: @1338010
     /* 1338010 */   GIM_Try, /*On fail goto*//*Label 19091*/ GIMT_Encode4(1338094), // Rule ID 20096 //
     /* 1338015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1338018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1338032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338068 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1338071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338093 */     // GIR_Coverage, 20096,
     /* 1338093 */     GIR_EraseRootFromParent_Done,
     /* 1338094 */   // Label 19091: @1338094
     /* 1338094 */   GIM_Try, /*On fail goto*//*Label 19092*/ GIMT_Encode4(1338178), // Rule ID 20097 //
     /* 1338099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1338102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1338110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1338113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1338116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1338119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1338122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1338141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338152 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M1_MASK),
     /* 1338155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1338173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338177 */     // GIR_Coverage, 20097,
     /* 1338177 */     GIR_EraseRootFromParent_Done,
     /* 1338178 */   // Label 19092: @1338178
     /* 1338178 */   GIM_Try, /*On fail goto*//*Label 19093*/ GIMT_Encode4(1338262), // Rule ID 20100 //
     /* 1338183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1338239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338261 */     // GIR_Coverage, 20100,
     /* 1338261 */     GIR_EraseRootFromParent_Done,
     /* 1338262 */   // Label 19093: @1338262
     /* 1338262 */   GIM_Try, /*On fail goto*//*Label 19094*/ GIMT_Encode4(1338346), // Rule ID 20101 //
     /* 1338267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1338284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338320 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M2_MASK),
     /* 1338323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338345 */     // GIR_Coverage, 20101,
     /* 1338345 */     GIR_EraseRootFromParent_Done,
     /* 1338346 */   // Label 19094: @1338346
     /* 1338346 */   GIM_Try, /*On fail goto*//*Label 19095*/ GIMT_Encode4(1338430), // Rule ID 20104 //
     /* 1338351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338404 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1338407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338429 */     // GIR_Coverage, 20104,
     /* 1338429 */     GIR_EraseRootFromParent_Done,
     /* 1338430 */   // Label 19095: @1338430
     /* 1338430 */   GIM_Try, /*On fail goto*//*Label 19096*/ GIMT_Encode4(1338514), // Rule ID 20105 //
     /* 1338435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1338446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1338449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1338452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1338458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M4_MASK),
     /* 1338491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338513 */     // GIR_Coverage, 20105,
     /* 1338513 */     GIR_EraseRootFromParent_Done,
     /* 1338514 */   // Label 19096: @1338514
     /* 1338514 */   GIM_Try, /*On fail goto*//*Label 19097*/ GIMT_Encode4(1338598), // Rule ID 20108 //
     /* 1338519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1338522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338572 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1338575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338597 */     // GIR_Coverage, 20108,
     /* 1338597 */     GIR_EraseRootFromParent_Done,
     /* 1338598 */   // Label 19097: @1338598
     /* 1338598 */   GIM_Try, /*On fail goto*//*Label 19098*/ GIMT_Encode4(1338682), // Rule ID 20109 //
     /* 1338603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1338606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1338614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1338617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1338620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1338623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1338626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1338641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1338645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338656 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR16_M8_MASK),
     /* 1338659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1338677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338681 */     // GIR_Coverage, 20109,
     /* 1338681 */     GIR_EraseRootFromParent_Done,
     /* 1338682 */   // Label 19098: @1338682
     /* 1338682 */   GIM_Try, /*On fail goto*//*Label 19099*/ GIMT_Encode4(1338766), // Rule ID 20112 //
     /* 1338687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338740 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1338743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338765 */     // GIR_Coverage, 20112,
     /* 1338765 */     GIR_EraseRootFromParent_Done,
     /* 1338766 */   // Label 19099: @1338766
     /* 1338766 */   GIM_Try, /*On fail goto*//*Label 19100*/ GIMT_Encode4(1338850), // Rule ID 20113 //
     /* 1338771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1338782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1338785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1338788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1338794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1338809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M2_MASK),
     /* 1338827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338849 */     // GIR_Coverage, 20113,
     /* 1338849 */     GIR_EraseRootFromParent_Done,
     /* 1338850 */   // Label 19100: @1338850
     /* 1338850 */   GIM_Try, /*On fail goto*//*Label 19101*/ GIMT_Encode4(1338934), // Rule ID 20116 //
     /* 1338855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1338858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1338881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338908 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1338908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1338911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1338917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1338919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1338921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1338926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1338929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1338932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1338933 */     // GIR_Coverage, 20116,
     /* 1338933 */     GIR_EraseRootFromParent_Done,
     /* 1338934 */   // Label 19101: @1338934
     /* 1338934 */   GIM_Try, /*On fail goto*//*Label 19102*/ GIMT_Encode4(1339018), // Rule ID 20117 //
     /* 1338939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1338942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1338947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1338950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1338953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1338956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1338959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1338962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1338965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1338973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1338977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1338981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1338985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1338992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1338992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M4_MASK),
     /* 1338995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1338997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1338999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339017 */     // GIR_Coverage, 20117,
     /* 1339017 */     GIR_EraseRootFromParent_Done,
     /* 1339018 */   // Label 19102: @1339018
     /* 1339018 */   GIM_Try, /*On fail goto*//*Label 19103*/ GIMT_Encode4(1339102), // Rule ID 20120 //
     /* 1339023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1339026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339076 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1339079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339101 */     // GIR_Coverage, 20120,
     /* 1339101 */     GIR_EraseRootFromParent_Done,
     /* 1339102 */   // Label 19103: @1339102
     /* 1339102 */   GIM_Try, /*On fail goto*//*Label 19104*/ GIMT_Encode4(1339186), // Rule ID 20121 //
     /* 1339107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1339110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1339118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1339121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1339124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1339127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1339130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1339149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339160 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR32_M8_MASK),
     /* 1339163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1339181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339185 */     // GIR_Coverage, 20121,
     /* 1339185 */     GIR_EraseRootFromParent_Done,
     /* 1339186 */   // Label 19104: @1339186
     /* 1339186 */   GIM_Try, /*On fail goto*//*Label 19105*/ GIMT_Encode4(1339270), // Rule ID 20124 //
     /* 1339191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339244 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1339247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339269 */     // GIR_Coverage, 20124,
     /* 1339269 */     GIR_EraseRootFromParent_Done,
     /* 1339270 */   // Label 19105: @1339270
     /* 1339270 */   GIM_Try, /*On fail goto*//*Label 19106*/ GIMT_Encode4(1339354), // Rule ID 20125 //
     /* 1339275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1339292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1339313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339328 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M2_MASK),
     /* 1339331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339353 */     // GIR_Coverage, 20125,
     /* 1339353 */     GIR_EraseRootFromParent_Done,
     /* 1339354 */   // Label 19106: @1339354
     /* 1339354 */   GIM_Try, /*On fail goto*//*Label 19107*/ GIMT_Encode4(1339438), // Rule ID 20128 //
     /* 1339359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339412 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1339415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339437 */     // GIR_Coverage, 20128,
     /* 1339437 */     GIR_EraseRootFromParent_Done,
     /* 1339438 */   // Label 19107: @1339438
     /* 1339438 */   GIM_Try, /*On fail goto*//*Label 19108*/ GIMT_Encode4(1339522), // Rule ID 20129 //
     /* 1339443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1339454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1339457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1339460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1339466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1339481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339496 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M4_MASK),
     /* 1339499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339521 */     // GIR_Coverage, 20129,
     /* 1339521 */     GIR_EraseRootFromParent_Done,
     /* 1339522 */   // Label 19108: @1339522
     /* 1339522 */   GIM_Try, /*On fail goto*//*Label 19109*/ GIMT_Encode4(1339606), // Rule ID 20132 //
     /* 1339527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1339530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339580 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1339583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339605 */     // GIR_Coverage, 20132,
     /* 1339605 */     GIR_EraseRootFromParent_Done,
     /* 1339606 */   // Label 19109: @1339606
     /* 1339606 */   GIM_Try, /*On fail goto*//*Label 19110*/ GIMT_Encode4(1339690), // Rule ID 20133 //
     /* 1339611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1339614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfne_mask),
     /* 1339619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1339622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1339625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1339628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1339631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1339634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1339649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1339653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339664 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11362:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFNE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VFPR64_M8_MASK),
     /* 1339667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1339685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339689 */     // GIR_Coverage, 20133,
     /* 1339689 */     GIR_EraseRootFromParent_Done,
     /* 1339690 */   // Label 19110: @1339690
     /* 1339690 */   GIM_Try, /*On fail goto*//*Label 19111*/ GIMT_Encode4(1339774), // Rule ID 20136 //
     /* 1339695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1339703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339748 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1339751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339773 */     // GIR_Coverage, 20136,
     /* 1339773 */     GIR_EraseRootFromParent_Done,
     /* 1339774 */   // Label 19111: @1339774
     /* 1339774 */   GIM_Try, /*On fail goto*//*Label 19112*/ GIMT_Encode4(1339858), // Rule ID 20137 //
     /* 1339779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1339787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1339790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1339793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1339796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1339802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339832 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1339832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF4_MASK),
     /* 1339835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339857 */     // GIR_Coverage, 20137,
     /* 1339857 */     GIR_EraseRootFromParent_Done,
     /* 1339858 */   // Label 19112: @1339858
     /* 1339858 */   GIM_Try, /*On fail goto*//*Label 19113*/ GIMT_Encode4(1339942), // Rule ID 20140 //
     /* 1339863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1339866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1339871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1339889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1339916 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1339916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1339919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1339921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1339923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1339925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1339927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1339929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1339934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1339937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1339940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1339941 */     // GIR_Coverage, 20140,
     /* 1339941 */     GIR_EraseRootFromParent_Done,
     /* 1339942 */   // Label 19113: @1339942
     /* 1339942 */   GIM_Try, /*On fail goto*//*Label 19114*/ GIMT_Encode4(1340026), // Rule ID 20141 //
     /* 1339947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1339950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1339955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1339958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1339961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1339964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1339967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1339970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1339973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1339985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1339989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1339993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340000 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_MF2_MASK),
     /* 1340003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340025 */     // GIR_Coverage, 20141,
     /* 1340025 */     GIR_EraseRootFromParent_Done,
     /* 1340026 */   // Label 19114: @1340026
     /* 1340026 */   GIM_Try, /*On fail goto*//*Label 19115*/ GIMT_Encode4(1340110), // Rule ID 20144 //
     /* 1340031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1340048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340084 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1340087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340109 */     // GIR_Coverage, 20144,
     /* 1340109 */     GIR_EraseRootFromParent_Done,
     /* 1340110 */   // Label 19115: @1340110
     /* 1340110 */   GIM_Try, /*On fail goto*//*Label 19116*/ GIMT_Encode4(1340194), // Rule ID 20145 //
     /* 1340115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1340132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340168 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_MF2_MASK),
     /* 1340171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340193 */     // GIR_Coverage, 20145,
     /* 1340193 */     GIR_EraseRootFromParent_Done,
     /* 1340194 */   // Label 19116: @1340194
     /* 1340194 */   GIM_Try, /*On fail goto*//*Label 19117*/ GIMT_Encode4(1340278), // Rule ID 20148 //
     /* 1340199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1340216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340252 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1340255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340277 */     // GIR_Coverage, 20148,
     /* 1340277 */     GIR_EraseRootFromParent_Done,
     /* 1340278 */   // Label 19117: @1340278
     /* 1340278 */   GIM_Try, /*On fail goto*//*Label 19118*/ GIMT_Encode4(1340362), // Rule ID 20149 //
     /* 1340283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1340294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1340297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1340300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1340306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340336 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M1_MASK),
     /* 1340339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340361 */     // GIR_Coverage, 20149,
     /* 1340361 */     GIR_EraseRootFromParent_Done,
     /* 1340362 */   // Label 19118: @1340362
     /* 1340362 */   GIM_Try, /*On fail goto*//*Label 19119*/ GIMT_Encode4(1340446), // Rule ID 20152 //
     /* 1340367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1340370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1340384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340420 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1340423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340445 */     // GIR_Coverage, 20152,
     /* 1340445 */     GIR_EraseRootFromParent_Done,
     /* 1340446 */   // Label 19119: @1340446
     /* 1340446 */   GIM_Try, /*On fail goto*//*Label 19120*/ GIMT_Encode4(1340530), // Rule ID 20153 //
     /* 1340451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1340454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1340462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1340465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1340468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1340471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1340474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1340493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340504 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M1_MASK),
     /* 1340507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1340525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340529 */     // GIR_Coverage, 20153,
     /* 1340529 */     GIR_EraseRootFromParent_Done,
     /* 1340530 */   // Label 19120: @1340530
     /* 1340530 */   GIM_Try, /*On fail goto*//*Label 19121*/ GIMT_Encode4(1340614), // Rule ID 20156 //
     /* 1340535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1340538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340588 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1340591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340613 */     // GIR_Coverage, 20156,
     /* 1340613 */     GIR_EraseRootFromParent_Done,
     /* 1340614 */   // Label 19121: @1340614
     /* 1340614 */   GIM_Try, /*On fail goto*//*Label 19122*/ GIMT_Encode4(1340698), // Rule ID 20157 //
     /* 1340619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1340622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1340630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1340633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1340636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1340639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1340642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1340661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340672 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M1_MASK),
     /* 1340675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1340693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340697 */     // GIR_Coverage, 20157,
     /* 1340697 */     GIR_EraseRootFromParent_Done,
     /* 1340698 */   // Label 19122: @1340698
     /* 1340698 */   GIM_Try, /*On fail goto*//*Label 19123*/ GIMT_Encode4(1340782), // Rule ID 20160 //
     /* 1340703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340756 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1340759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340781 */     // GIR_Coverage, 20160,
     /* 1340781 */     GIR_EraseRootFromParent_Done,
     /* 1340782 */   // Label 19123: @1340782
     /* 1340782 */   GIM_Try, /*On fail goto*//*Label 19124*/ GIMT_Encode4(1340866), // Rule ID 20161 //
     /* 1340787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1340798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1340801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1340804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1340810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1340825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340840 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1340840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M2_MASK),
     /* 1340843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340865 */     // GIR_Coverage, 20161,
     /* 1340865 */     GIR_EraseRootFromParent_Done,
     /* 1340866 */   // Label 19124: @1340866
     /* 1340866 */   GIM_Try, /*On fail goto*//*Label 19125*/ GIMT_Encode4(1340950), // Rule ID 20164 //
     /* 1340871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1340874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1340897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1340917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1340924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1340924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1340927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1340929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1340931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1340933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1340935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1340937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1340942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1340945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1340948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1340949 */     // GIR_Coverage, 20164,
     /* 1340949 */     GIR_EraseRootFromParent_Done,
     /* 1340950 */   // Label 19125: @1340950
     /* 1340950 */   GIM_Try, /*On fail goto*//*Label 19126*/ GIMT_Encode4(1341034), // Rule ID 20165 //
     /* 1340955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1340958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1340963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1340966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1340969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1340972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1340975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1340978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1340981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1340989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1340993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1340997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341008 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M4_MASK),
     /* 1341011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341033 */     // GIR_Coverage, 20165,
     /* 1341033 */     GIR_EraseRootFromParent_Done,
     /* 1341034 */   // Label 19126: @1341034
     /* 1341034 */   GIM_Try, /*On fail goto*//*Label 19127*/ GIMT_Encode4(1341118), // Rule ID 20168 //
     /* 1341039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1341042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1341050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1341053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1341056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1341062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341092 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1341095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341117 */     // GIR_Coverage, 20168,
     /* 1341117 */     GIR_EraseRootFromParent_Done,
     /* 1341118 */   // Label 19127: @1341118
     /* 1341118 */   GIM_Try, /*On fail goto*//*Label 19128*/ GIMT_Encode4(1341202), // Rule ID 20169 //
     /* 1341123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1341126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1341134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1341137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1341140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1341143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1341146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1341165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341176 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR16_M8_MASK),
     /* 1341179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1341197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341201 */     // GIR_Coverage, 20169,
     /* 1341201 */     GIR_EraseRootFromParent_Done,
     /* 1341202 */   // Label 19128: @1341202
     /* 1341202 */   GIM_Try, /*On fail goto*//*Label 19129*/ GIMT_Encode4(1341286), // Rule ID 20172 //
     /* 1341207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1341224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341260 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1341263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341285 */     // GIR_Coverage, 20172,
     /* 1341285 */     GIR_EraseRootFromParent_Done,
     /* 1341286 */   // Label 19129: @1341286
     /* 1341286 */   GIM_Try, /*On fail goto*//*Label 19130*/ GIMT_Encode4(1341370), // Rule ID 20173 //
     /* 1341291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1341308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341344 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M2_MASK),
     /* 1341347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341369 */     // GIR_Coverage, 20173,
     /* 1341369 */     GIR_EraseRootFromParent_Done,
     /* 1341370 */   // Label 19130: @1341370
     /* 1341370 */   GIM_Try, /*On fail goto*//*Label 19131*/ GIMT_Encode4(1341454), // Rule ID 20176 //
     /* 1341375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1341392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341428 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1341431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341453 */     // GIR_Coverage, 20176,
     /* 1341453 */     GIR_EraseRootFromParent_Done,
     /* 1341454 */   // Label 19131: @1341454
     /* 1341454 */   GIM_Try, /*On fail goto*//*Label 19132*/ GIMT_Encode4(1341538), // Rule ID 20177 //
     /* 1341459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1341470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1341473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1341476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1341482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341512 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M4_MASK),
     /* 1341515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341537 */     // GIR_Coverage, 20177,
     /* 1341537 */     GIR_EraseRootFromParent_Done,
     /* 1341538 */   // Label 19132: @1341538
     /* 1341538 */   GIM_Try, /*On fail goto*//*Label 19133*/ GIMT_Encode4(1341622), // Rule ID 20180 //
     /* 1341543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1341546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341596 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1341599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341621 */     // GIR_Coverage, 20180,
     /* 1341621 */     GIR_EraseRootFromParent_Done,
     /* 1341622 */   // Label 19133: @1341622
     /* 1341622 */   GIM_Try, /*On fail goto*//*Label 19134*/ GIMT_Encode4(1341706), // Rule ID 20181 //
     /* 1341627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1341630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1341638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1341641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1341644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1341647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1341650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1341665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1341669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR32_M8_MASK),
     /* 1341683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1341701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341705 */     // GIR_Coverage, 20181,
     /* 1341705 */     GIR_EraseRootFromParent_Done,
     /* 1341706 */   // Label 19134: @1341706
     /* 1341706 */   GIM_Try, /*On fail goto*//*Label 19135*/ GIMT_Encode4(1341790), // Rule ID 20184 //
     /* 1341711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341764 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1341767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341789 */     // GIR_Coverage, 20184,
     /* 1341789 */     GIR_EraseRootFromParent_Done,
     /* 1341790 */   // Label 19135: @1341790
     /* 1341790 */   GIM_Try, /*On fail goto*//*Label 19136*/ GIMT_Encode4(1341874), // Rule ID 20185 //
     /* 1341795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1341806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1341809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1341812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1341818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1341833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341848 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1341848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M2_MASK),
     /* 1341851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341873 */     // GIR_Coverage, 20185,
     /* 1341873 */     GIR_EraseRootFromParent_Done,
     /* 1341874 */   // Label 19136: @1341874
     /* 1341874 */   GIM_Try, /*On fail goto*//*Label 19137*/ GIMT_Encode4(1341958), // Rule ID 20188 //
     /* 1341879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1341882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1341905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1341917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1341921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1341925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1341932 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1341932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1341935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1341937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1341939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1341941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1341943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1341945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1341950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1341953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1341956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1341957 */     // GIR_Coverage, 20188,
     /* 1341957 */     GIR_EraseRootFromParent_Done,
     /* 1341958 */   // Label 19137: @1341958
     /* 1341958 */   GIM_Try, /*On fail goto*//*Label 19138*/ GIMT_Encode4(1342042), // Rule ID 20189 //
     /* 1341963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1341966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1341971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1341974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1341977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1341980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1341983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1341986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1341989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1341997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1342001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1342005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342016 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M4_MASK),
     /* 1342019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342041 */     // GIR_Coverage, 20189,
     /* 1342041 */     GIR_EraseRootFromParent_Done,
     /* 1342042 */   // Label 19138: @1342042
     /* 1342042 */   GIM_Try, /*On fail goto*//*Label 19139*/ GIMT_Encode4(1342126), // Rule ID 20192 //
     /* 1342047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1342050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1342055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1342064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1342089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342100 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1342103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342125 */     // GIR_Coverage, 20192,
     /* 1342125 */     GIR_EraseRootFromParent_Done,
     /* 1342126 */   // Label 19139: @1342126
     /* 1342126 */   GIM_Try, /*On fail goto*//*Label 19140*/ GIMT_Encode4(1342210), // Rule ID 20193 //
     /* 1342131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1342134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1342139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1342142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1342145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1342148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1342151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1342154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1342169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1342173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342184 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGT_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGT_VFPR64_M8_MASK),
     /* 1342187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1342205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342209 */     // GIR_Coverage, 20193,
     /* 1342209 */     GIR_EraseRootFromParent_Done,
     /* 1342210 */   // Label 19140: @1342210
     /* 1342210 */   GIM_Try, /*On fail goto*//*Label 19141*/ GIMT_Encode4(1342294), // Rule ID 20196 //
     /* 1342215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1342232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342268 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1342271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342293 */     // GIR_Coverage, 20196,
     /* 1342293 */     GIR_EraseRootFromParent_Done,
     /* 1342294 */   // Label 19141: @1342294
     /* 1342294 */   GIM_Try, /*On fail goto*//*Label 19142*/ GIMT_Encode4(1342378), // Rule ID 20197 //
     /* 1342299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1342316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342352 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF4_MASK),
     /* 1342355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342377 */     // GIR_Coverage, 20197,
     /* 1342377 */     GIR_EraseRootFromParent_Done,
     /* 1342378 */   // Label 19142: @1342378
     /* 1342378 */   GIM_Try, /*On fail goto*//*Label 19143*/ GIMT_Encode4(1342462), // Rule ID 20200 //
     /* 1342383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1342400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342436 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1342439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342461 */     // GIR_Coverage, 20200,
     /* 1342461 */     GIR_EraseRootFromParent_Done,
     /* 1342462 */   // Label 19143: @1342462
     /* 1342462 */   GIM_Try, /*On fail goto*//*Label 19144*/ GIMT_Encode4(1342546), // Rule ID 20201 //
     /* 1342467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1342484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342520 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_MF2_MASK),
     /* 1342523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342545 */     // GIR_Coverage, 20201,
     /* 1342545 */     GIR_EraseRootFromParent_Done,
     /* 1342546 */   // Label 19144: @1342546
     /* 1342546 */   GIM_Try, /*On fail goto*//*Label 19145*/ GIMT_Encode4(1342630), // Rule ID 20204 //
     /* 1342551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342604 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1342607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342629 */     // GIR_Coverage, 20204,
     /* 1342629 */     GIR_EraseRootFromParent_Done,
     /* 1342630 */   // Label 19145: @1342630
     /* 1342630 */   GIM_Try, /*On fail goto*//*Label 19146*/ GIMT_Encode4(1342714), // Rule ID 20205 //
     /* 1342635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1342646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1342649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1342652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1342658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342688 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_MF2_MASK),
     /* 1342691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342713 */     // GIR_Coverage, 20205,
     /* 1342713 */     GIR_EraseRootFromParent_Done,
     /* 1342714 */   // Label 19146: @1342714
     /* 1342714 */   GIM_Try, /*On fail goto*//*Label 19147*/ GIMT_Encode4(1342798), // Rule ID 20208 //
     /* 1342719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1342722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342772 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1342775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342797 */     // GIR_Coverage, 20208,
     /* 1342797 */     GIR_EraseRootFromParent_Done,
     /* 1342798 */   // Label 19147: @1342798
     /* 1342798 */   GIM_Try, /*On fail goto*//*Label 19148*/ GIMT_Encode4(1342882), // Rule ID 20209 //
     /* 1342803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1342806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1342814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1342817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1342820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1342823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1342826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1342845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342856 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1342856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M1_MASK),
     /* 1342859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1342877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342881 */     // GIR_Coverage, 20209,
     /* 1342881 */     GIR_EraseRootFromParent_Done,
     /* 1342882 */   // Label 19148: @1342882
     /* 1342882 */   GIM_Try, /*On fail goto*//*Label 19149*/ GIMT_Encode4(1342966), // Rule ID 20212 //
     /* 1342887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1342890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1342913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1342925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1342929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1342933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1342940 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1342940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1342943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1342945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1342947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1342949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1342951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1342953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1342958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1342961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1342964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1342965 */     // GIR_Coverage, 20212,
     /* 1342965 */     GIR_EraseRootFromParent_Done,
     /* 1342966 */   // Label 19149: @1342966
     /* 1342966 */   GIM_Try, /*On fail goto*//*Label 19150*/ GIMT_Encode4(1343050), // Rule ID 20213 //
     /* 1342971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1342974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1342979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1342982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1342985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1342988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1342991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1342994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1342997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343024 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M1_MASK),
     /* 1343027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343049 */     // GIR_Coverage, 20213,
     /* 1343049 */     GIR_EraseRootFromParent_Done,
     /* 1343050 */   // Label 19150: @1343050
     /* 1343050 */   GIM_Try, /*On fail goto*//*Label 19151*/ GIMT_Encode4(1343134), // Rule ID 20216 //
     /* 1343055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1343058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1343072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343108 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1343111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343133 */     // GIR_Coverage, 20216,
     /* 1343133 */     GIR_EraseRootFromParent_Done,
     /* 1343134 */   // Label 19151: @1343134
     /* 1343134 */   GIM_Try, /*On fail goto*//*Label 19152*/ GIMT_Encode4(1343218), // Rule ID 20217 //
     /* 1343139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1343142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1343150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1343153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1343156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1343159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1343162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1343181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343192 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M1_MASK),
     /* 1343195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1343213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343217 */     // GIR_Coverage, 20217,
     /* 1343217 */     GIR_EraseRootFromParent_Done,
     /* 1343218 */   // Label 19152: @1343218
     /* 1343218 */   GIM_Try, /*On fail goto*//*Label 19153*/ GIMT_Encode4(1343302), // Rule ID 20220 //
     /* 1343223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1343240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343276 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1343279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343301 */     // GIR_Coverage, 20220,
     /* 1343301 */     GIR_EraseRootFromParent_Done,
     /* 1343302 */   // Label 19153: @1343302
     /* 1343302 */   GIM_Try, /*On fail goto*//*Label 19154*/ GIMT_Encode4(1343386), // Rule ID 20221 //
     /* 1343307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1343324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343360 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M2_MASK),
     /* 1343363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343385 */     // GIR_Coverage, 20221,
     /* 1343385 */     GIR_EraseRootFromParent_Done,
     /* 1343386 */   // Label 19154: @1343386
     /* 1343386 */   GIM_Try, /*On fail goto*//*Label 19155*/ GIMT_Encode4(1343470), // Rule ID 20224 //
     /* 1343391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1343408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343444 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1343447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343469 */     // GIR_Coverage, 20224,
     /* 1343469 */     GIR_EraseRootFromParent_Done,
     /* 1343470 */   // Label 19155: @1343470
     /* 1343470 */   GIM_Try, /*On fail goto*//*Label 19156*/ GIMT_Encode4(1343554), // Rule ID 20225 //
     /* 1343475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1343486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1343489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1343492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1343498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343528 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M4_MASK),
     /* 1343531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343553 */     // GIR_Coverage, 20225,
     /* 1343553 */     GIR_EraseRootFromParent_Done,
     /* 1343554 */   // Label 19156: @1343554
     /* 1343554 */   GIM_Try, /*On fail goto*//*Label 19157*/ GIMT_Encode4(1343638), // Rule ID 20228 //
     /* 1343559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1343562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343612 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1343615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343637 */     // GIR_Coverage, 20228,
     /* 1343637 */     GIR_EraseRootFromParent_Done,
     /* 1343638 */   // Label 19157: @1343638
     /* 1343638 */   GIM_Try, /*On fail goto*//*Label 19158*/ GIMT_Encode4(1343722), // Rule ID 20229 //
     /* 1343643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1343646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1343654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1343657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1343660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1343663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1343666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1343681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1343685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343696 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR16_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR16_M8_MASK),
     /* 1343699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1343717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343721 */     // GIR_Coverage, 20229,
     /* 1343721 */     GIR_EraseRootFromParent_Done,
     /* 1343722 */   // Label 19158: @1343722
     /* 1343722 */   GIM_Try, /*On fail goto*//*Label 19159*/ GIMT_Encode4(1343806), // Rule ID 20232 //
     /* 1343727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343780 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1343783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343805 */     // GIR_Coverage, 20232,
     /* 1343805 */     GIR_EraseRootFromParent_Done,
     /* 1343806 */   // Label 19159: @1343806
     /* 1343806 */   GIM_Try, /*On fail goto*//*Label 19160*/ GIMT_Encode4(1343890), // Rule ID 20233 //
     /* 1343811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1343822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1343825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1343828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1343834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1343837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1343849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343864 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1343864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M2_MASK),
     /* 1343867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343889 */     // GIR_Coverage, 20233,
     /* 1343889 */     GIR_EraseRootFromParent_Done,
     /* 1343890 */   // Label 19160: @1343890
     /* 1343890 */   GIM_Try, /*On fail goto*//*Label 19161*/ GIMT_Encode4(1343974), // Rule ID 20236 //
     /* 1343895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1343898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1343918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1343921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1343929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1343933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1343937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1343941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1343948 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1343948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1343951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1343953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1343955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1343957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1343959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1343961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1343966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1343969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1343972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1343973 */     // GIR_Coverage, 20236,
     /* 1343973 */     GIR_EraseRootFromParent_Done,
     /* 1343974 */   // Label 19161: @1343974
     /* 1343974 */   GIM_Try, /*On fail goto*//*Label 19162*/ GIMT_Encode4(1344058), // Rule ID 20237 //
     /* 1343979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1343982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1343987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1343990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1343993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1343996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1343999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344032 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M4_MASK),
     /* 1344035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344057 */     // GIR_Coverage, 20237,
     /* 1344057 */     GIR_EraseRootFromParent_Done,
     /* 1344058 */   // Label 19162: @1344058
     /* 1344058 */   GIM_Try, /*On fail goto*//*Label 19163*/ GIMT_Encode4(1344142), // Rule ID 20240 //
     /* 1344063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1344066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1344080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344116 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1344119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344141 */     // GIR_Coverage, 20240,
     /* 1344141 */     GIR_EraseRootFromParent_Done,
     /* 1344142 */   // Label 19163: @1344142
     /* 1344142 */   GIM_Try, /*On fail goto*//*Label 19164*/ GIMT_Encode4(1344226), // Rule ID 20241 //
     /* 1344147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1344150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1344158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1344161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1344164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1344167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1344170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1344189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344200 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR32_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR32_M8_MASK),
     /* 1344203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1344221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344225 */     // GIR_Coverage, 20241,
     /* 1344225 */     GIR_EraseRootFromParent_Done,
     /* 1344226 */   // Label 19164: @1344226
     /* 1344226 */   GIM_Try, /*On fail goto*//*Label 19165*/ GIMT_Encode4(1344310), // Rule ID 20244 //
     /* 1344231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1344248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1344287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344309 */     // GIR_Coverage, 20244,
     /* 1344309 */     GIR_EraseRootFromParent_Done,
     /* 1344310 */   // Label 19165: @1344310
     /* 1344310 */   GIM_Try, /*On fail goto*//*Label 19166*/ GIMT_Encode4(1344394), // Rule ID 20245 //
     /* 1344315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1344332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1344353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344368 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M2_MASK),
     /* 1344371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344393 */     // GIR_Coverage, 20245,
     /* 1344393 */     GIR_EraseRootFromParent_Done,
     /* 1344394 */   // Label 19166: @1344394
     /* 1344394 */   GIM_Try, /*On fail goto*//*Label 19167*/ GIMT_Encode4(1344478), // Rule ID 20248 //
     /* 1344399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344452 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1344455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344477 */     // GIR_Coverage, 20248,
     /* 1344477 */     GIR_EraseRootFromParent_Done,
     /* 1344478 */   // Label 19167: @1344478
     /* 1344478 */   GIM_Try, /*On fail goto*//*Label 19168*/ GIMT_Encode4(1344562), // Rule ID 20249 //
     /* 1344483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1344494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1344497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1344500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1344506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1344521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344536 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M4_MASK),
     /* 1344539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344561 */     // GIR_Coverage, 20249,
     /* 1344561 */     GIR_EraseRootFromParent_Done,
     /* 1344562 */   // Label 19168: @1344562
     /* 1344562 */   GIM_Try, /*On fail goto*//*Label 19169*/ GIMT_Encode4(1344646), // Rule ID 20252 //
     /* 1344567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1344570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344620 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1344623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344645 */     // GIR_Coverage, 20252,
     /* 1344645 */     GIR_EraseRootFromParent_Done,
     /* 1344646 */   // Label 19169: @1344646
     /* 1344646 */   GIM_Try, /*On fail goto*//*Label 19170*/ GIMT_Encode4(1344730), // Rule ID 20253 //
     /* 1344651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1344654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1344659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1344662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1344665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1344668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1344671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1344674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1344689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1344693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344704 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFGE_VFPR64_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFGE_VFPR64_M8_MASK),
     /* 1344707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1344713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1344715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1344725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344729 */     // GIR_Coverage, 20253,
     /* 1344729 */     GIR_EraseRootFromParent_Done,
     /* 1344730 */   // Label 19170: @1344730
     /* 1344730 */   GIM_Try, /*On fail goto*//*Label 19171*/ GIMT_Encode4(1344814), // Rule ID 20256 //
     /* 1344735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1344755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344788 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1344791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1344797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1344799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344813 */     // GIR_Coverage, 20256,
     /* 1344813 */     GIR_EraseRootFromParent_Done,
     /* 1344814 */   // Label 19171: @1344814
     /* 1344814 */   GIM_Try, /*On fail goto*//*Label 19172*/ GIMT_Encode4(1344898), // Rule ID 20257 //
     /* 1344819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1344830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1344833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1344836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1344839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1344842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1344845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344872 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1344872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4_MASK),
     /* 1344875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1344881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1344883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344897 */     // GIR_Coverage, 20257,
     /* 1344897 */     GIR_EraseRootFromParent_Done,
     /* 1344898 */   // Label 19172: @1344898
     /* 1344898 */   GIM_Try, /*On fail goto*//*Label 19173*/ GIMT_Encode4(1344982), // Rule ID 20260 //
     /* 1344903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1344906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1344917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1344920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1344923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1344926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1344929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1344945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1344949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1344956 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1344956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1344959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1344961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1344963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1344965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1344967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1344969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1344974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1344977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1344980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1344981 */     // GIR_Coverage, 20260,
     /* 1344981 */     GIR_EraseRootFromParent_Done,
     /* 1344982 */   // Label 19173: @1344982
     /* 1344982 */   GIM_Try, /*On fail goto*//*Label 19174*/ GIMT_Encode4(1345066), // Rule ID 20261 //
     /* 1344987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1344990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1344995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1344998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1345004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1345007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345040 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1345043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345065 */     // GIR_Coverage, 20261,
     /* 1345065 */     GIR_EraseRootFromParent_Done,
     /* 1345066 */   // Label 19174: @1345066
     /* 1345066 */   GIM_Try, /*On fail goto*//*Label 19175*/ GIMT_Encode4(1345150), // Rule ID 20264 //
     /* 1345071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1345091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345124 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1345127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345149 */     // GIR_Coverage, 20264,
     /* 1345149 */     GIR_EraseRootFromParent_Done,
     /* 1345150 */   // Label 19175: @1345150
     /* 1345150 */   GIM_Try, /*On fail goto*//*Label 19176*/ GIMT_Encode4(1345234), // Rule ID 20265 //
     /* 1345155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1345172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1345175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345208 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2_MASK),
     /* 1345211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345233 */     // GIR_Coverage, 20265,
     /* 1345233 */     GIR_EraseRootFromParent_Done,
     /* 1345234 */   // Label 19176: @1345234
     /* 1345234 */   GIM_Try, /*On fail goto*//*Label 19177*/ GIMT_Encode4(1345318), // Rule ID 20268 //
     /* 1345239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1345259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345292 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345317 */     // GIR_Coverage, 20268,
     /* 1345317 */     GIR_EraseRootFromParent_Done,
     /* 1345318 */   // Label 19177: @1345318
     /* 1345318 */   GIM_Try, /*On fail goto*//*Label 19178*/ GIMT_Encode4(1345402), // Rule ID 20269 //
     /* 1345323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1345334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1345337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1345340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1345343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1345346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345376 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345401 */     // GIR_Coverage, 20269,
     /* 1345401 */     GIR_EraseRootFromParent_Done,
     /* 1345402 */   // Label 19178: @1345402
     /* 1345402 */   GIM_Try, /*On fail goto*//*Label 19179*/ GIMT_Encode4(1345486), // Rule ID 20272 //
     /* 1345407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1345410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1345427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345460 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345485 */     // GIR_Coverage, 20272,
     /* 1345485 */     GIR_EraseRootFromParent_Done,
     /* 1345486 */   // Label 19179: @1345486
     /* 1345486 */   GIM_Try, /*On fail goto*//*Label 19180*/ GIMT_Encode4(1345570), // Rule ID 20273 //
     /* 1345491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1345494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1345502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1345505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1345508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1345511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1345514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345544 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1345565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345569 */     // GIR_Coverage, 20273,
     /* 1345569 */     GIR_EraseRootFromParent_Done,
     /* 1345570 */   // Label 19180: @1345570
     /* 1345570 */   GIM_Try, /*On fail goto*//*Label 19181*/ GIMT_Encode4(1345654), // Rule ID 20276 //
     /* 1345575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1345578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1345595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345628 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345653 */     // GIR_Coverage, 20276,
     /* 1345653 */     GIR_EraseRootFromParent_Done,
     /* 1345654 */   // Label 19181: @1345654
     /* 1345654 */   GIM_Try, /*On fail goto*//*Label 19182*/ GIMT_Encode4(1345738), // Rule ID 20277 //
     /* 1345659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1345662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1345670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1345673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1345676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1345679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1345682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345712 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1_MASK),
     /* 1345715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1345733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345737 */     // GIR_Coverage, 20277,
     /* 1345737 */     GIR_EraseRootFromParent_Done,
     /* 1345738 */   // Label 19182: @1345738
     /* 1345738 */   GIM_Try, /*On fail goto*//*Label 19183*/ GIMT_Encode4(1345822), // Rule ID 20280 //
     /* 1345743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1345763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1345799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345821 */     // GIR_Coverage, 20280,
     /* 1345821 */     GIR_EraseRootFromParent_Done,
     /* 1345822 */   // Label 19183: @1345822
     /* 1345822 */   GIM_Try, /*On fail goto*//*Label 19184*/ GIMT_Encode4(1345906), // Rule ID 20281 //
     /* 1345827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1345838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1345841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1345844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1345847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1345850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1345853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1345869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345880 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1345880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1345883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345905 */     // GIR_Coverage, 20281,
     /* 1345905 */     GIR_EraseRootFromParent_Done,
     /* 1345906 */   // Label 19184: @1345906
     /* 1345906 */   GIM_Try, /*On fail goto*//*Label 19185*/ GIMT_Encode4(1345990), // Rule ID 20284 //
     /* 1345911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1345914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1345919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1345922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1345925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1345928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1345931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1345934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1345937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1345945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1345953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1345957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1345964 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1345964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1345967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1345969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1345971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1345973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1345975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1345977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1345982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1345985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1345988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1345989 */     // GIR_Coverage, 20284,
     /* 1345989 */     GIR_EraseRootFromParent_Done,
     /* 1345990 */   // Label 19185: @1345990
     /* 1345990 */   GIM_Try, /*On fail goto*//*Label 19186*/ GIMT_Encode4(1346074), // Rule ID 20285 //
     /* 1345995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1345998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1346012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1346015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346048 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1346051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346073 */     // GIR_Coverage, 20285,
     /* 1346073 */     GIR_EraseRootFromParent_Done,
     /* 1346074 */   // Label 19186: @1346074
     /* 1346074 */   GIM_Try, /*On fail goto*//*Label 19187*/ GIMT_Encode4(1346158), // Rule ID 20288 //
     /* 1346079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1346082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1346090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1346093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1346096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1346099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346132 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1346135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346157 */     // GIR_Coverage, 20288,
     /* 1346157 */     GIR_EraseRootFromParent_Done,
     /* 1346158 */   // Label 19187: @1346158
     /* 1346158 */   GIM_Try, /*On fail goto*//*Label 19188*/ GIMT_Encode4(1346242), // Rule ID 20289 //
     /* 1346163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1346166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1346174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1346177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1346180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1346183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1346186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346216 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1346219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1346237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346241 */     // GIR_Coverage, 20289,
     /* 1346241 */     GIR_EraseRootFromParent_Done,
     /* 1346242 */   // Label 19188: @1346242
     /* 1346242 */   GIM_Try, /*On fail goto*//*Label 19189*/ GIMT_Encode4(1346326), // Rule ID 20292 //
     /* 1346247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1346264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1346267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346300 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1346303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346325 */     // GIR_Coverage, 20292,
     /* 1346325 */     GIR_EraseRootFromParent_Done,
     /* 1346326 */   // Label 19189: @1346326
     /* 1346326 */   GIM_Try, /*On fail goto*//*Label 19190*/ GIMT_Encode4(1346410), // Rule ID 20293 //
     /* 1346331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1346348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1346351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346384 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1346387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346409 */     // GIR_Coverage, 20293,
     /* 1346409 */     GIR_EraseRootFromParent_Done,
     /* 1346410 */   // Label 19190: @1346410
     /* 1346410 */   GIM_Try, /*On fail goto*//*Label 19191*/ GIMT_Encode4(1346494), // Rule ID 20296 //
     /* 1346415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1346435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346468 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1346471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346493 */     // GIR_Coverage, 20296,
     /* 1346493 */     GIR_EraseRootFromParent_Done,
     /* 1346494 */   // Label 19191: @1346494
     /* 1346494 */   GIM_Try, /*On fail goto*//*Label 19192*/ GIMT_Encode4(1346578), // Rule ID 20297 //
     /* 1346499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1346510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1346513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1346516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1346519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1346522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346552 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1346555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346577 */     // GIR_Coverage, 20297,
     /* 1346577 */     GIR_EraseRootFromParent_Done,
     /* 1346578 */   // Label 19192: @1346578
     /* 1346578 */   GIM_Try, /*On fail goto*//*Label 19193*/ GIMT_Encode4(1346662), // Rule ID 20300 //
     /* 1346583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1346586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1346603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346636 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1346639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346661 */     // GIR_Coverage, 20300,
     /* 1346661 */     GIR_EraseRootFromParent_Done,
     /* 1346662 */   // Label 19193: @1346662
     /* 1346662 */   GIM_Try, /*On fail goto*//*Label 19194*/ GIMT_Encode4(1346746), // Rule ID 20301 //
     /* 1346667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1346670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1346678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1346681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1346684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1346687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1346690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1346709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346720 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1346723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1346741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346745 */     // GIR_Coverage, 20301,
     /* 1346745 */     GIR_EraseRootFromParent_Done,
     /* 1346746 */   // Label 19194: @1346746
     /* 1346746 */   GIM_Try, /*On fail goto*//*Label 19195*/ GIMT_Encode4(1346830), // Rule ID 20304 //
     /* 1346751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1346771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346804 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1346807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346829 */     // GIR_Coverage, 20304,
     /* 1346829 */     GIR_EraseRootFromParent_Done,
     /* 1346830 */   // Label 19195: @1346830
     /* 1346830 */   GIM_Try, /*On fail goto*//*Label 19196*/ GIMT_Encode4(1346914), // Rule ID 20305 //
     /* 1346835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1346838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1346846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1346849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1346852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1346855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1346858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1346861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1346877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346888 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1346888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2_MASK),
     /* 1346891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346913 */     // GIR_Coverage, 20305,
     /* 1346913 */     GIR_EraseRootFromParent_Done,
     /* 1346914 */   // Label 19196: @1346914
     /* 1346914 */   GIM_Try, /*On fail goto*//*Label 19197*/ GIMT_Encode4(1346998), // Rule ID 20308 //
     /* 1346919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1346922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1346927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1346930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1346933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1346936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1346939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1346942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1346945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1346953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1346961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1346965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1346972 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1346972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1346975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1346977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1346979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1346981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1346983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1346985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1346990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1346993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1346996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1346997 */     // GIR_Coverage, 20308,
     /* 1346997 */     GIR_EraseRootFromParent_Done,
     /* 1346998 */   // Label 19197: @1346998
     /* 1346998 */   GIM_Try, /*On fail goto*//*Label 19198*/ GIMT_Encode4(1347082), // Rule ID 20309 //
     /* 1347003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1347020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1347023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1347045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347056 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4_MASK),
     /* 1347059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347081 */     // GIR_Coverage, 20309,
     /* 1347081 */     GIR_EraseRootFromParent_Done,
     /* 1347082 */   // Label 19198: @1347082
     /* 1347082 */   GIM_Try, /*On fail goto*//*Label 19199*/ GIMT_Encode4(1347166), // Rule ID 20312 //
     /* 1347087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1347090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1347104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1347107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347140 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1347143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347165 */     // GIR_Coverage, 20312,
     /* 1347165 */     GIR_EraseRootFromParent_Done,
     /* 1347166 */   // Label 19199: @1347166
     /* 1347166 */   GIM_Try, /*On fail goto*//*Label 19200*/ GIMT_Encode4(1347250), // Rule ID 20313 //
     /* 1347171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1347174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfgt_mask),
     /* 1347179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1347182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1347185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1347188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1347191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1347194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1347213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347224 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11356:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLT_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8_MASK),
     /* 1347227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1347245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347249 */     // GIR_Coverage, 20313,
     /* 1347249 */     GIR_EraseRootFromParent_Done,
     /* 1347250 */   // Label 19200: @1347250
     /* 1347250 */   GIM_Try, /*On fail goto*//*Label 19201*/ GIMT_Encode4(1347334), // Rule ID 20316 //
     /* 1347255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1347272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1347275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347308 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1347311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347333 */     // GIR_Coverage, 20316,
     /* 1347333 */     GIR_EraseRootFromParent_Done,
     /* 1347334 */   // Label 19201: @1347334
     /* 1347334 */   GIM_Try, /*On fail goto*//*Label 19202*/ GIMT_Encode4(1347418), // Rule ID 20317 //
     /* 1347339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1347356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1347359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347392 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF4_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4_MASK),
     /* 1347395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347417 */     // GIR_Coverage, 20317,
     /* 1347417 */     GIR_EraseRootFromParent_Done,
     /* 1347418 */   // Label 19202: @1347418
     /* 1347418 */   GIM_Try, /*On fail goto*//*Label 19203*/ GIMT_Encode4(1347502), // Rule ID 20320 //
     /* 1347423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1347443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347476 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1347479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347501 */     // GIR_Coverage, 20320,
     /* 1347501 */     GIR_EraseRootFromParent_Done,
     /* 1347502 */   // Label 19203: @1347502
     /* 1347502 */   GIM_Try, /*On fail goto*//*Label 19204*/ GIMT_Encode4(1347586), // Rule ID 20321 //
     /* 1347507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1347524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1347527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347560 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1347563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347585 */     // GIR_Coverage, 20321,
     /* 1347585 */     GIR_EraseRootFromParent_Done,
     /* 1347586 */   // Label 19204: @1347586
     /* 1347586 */   GIM_Try, /*On fail goto*//*Label 19205*/ GIMT_Encode4(1347670), // Rule ID 20324 //
     /* 1347591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1347611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347644 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1347647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347669 */     // GIR_Coverage, 20324,
     /* 1347669 */     GIR_EraseRootFromParent_Done,
     /* 1347670 */   // Label 19205: @1347670
     /* 1347670 */   GIM_Try, /*On fail goto*//*Label 19206*/ GIMT_Encode4(1347754), // Rule ID 20325 //
     /* 1347675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1347678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1347686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1347689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1347692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1347695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1347698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347728 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_MF2_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2_MASK),
     /* 1347731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1347749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347753 */     // GIR_Coverage, 20325,
     /* 1347753 */     GIR_EraseRootFromParent_Done,
     /* 1347754 */   // Label 19206: @1347754
     /* 1347754 */   GIM_Try, /*On fail goto*//*Label 19207*/ GIMT_Encode4(1347838), // Rule ID 20328 //
     /* 1347759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1347762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1347779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347812 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1347815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347837 */     // GIR_Coverage, 20328,
     /* 1347837 */     GIR_EraseRootFromParent_Done,
     /* 1347838 */   // Label 19207: @1347838
     /* 1347838 */   GIM_Try, /*On fail goto*//*Label 19208*/ GIMT_Encode4(1347922), // Rule ID 20329 //
     /* 1347843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1347846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1347854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1347857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1347860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1347863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1347866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1347869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347896 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1347896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1347899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1347917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1347920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1347921 */     // GIR_Coverage, 20329,
     /* 1347921 */     GIR_EraseRootFromParent_Done,
     /* 1347922 */   // Label 19208: @1347922
     /* 1347922 */   GIM_Try, /*On fail goto*//*Label 19209*/ GIMT_Encode4(1348006), // Rule ID 20332 //
     /* 1347927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1347930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1347935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1347938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1347941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1347944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1347947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1347950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1347953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1347969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1347973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1347980 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1347980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1347983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1347985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1347987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1347989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1347991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1347993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1347998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348005 */     // GIR_Coverage, 20332,
     /* 1348005 */     GIR_EraseRootFromParent_Done,
     /* 1348006 */   // Label 19209: @1348006
     /* 1348006 */   GIM_Try, /*On fail goto*//*Label 19210*/ GIMT_Encode4(1348090), // Rule ID 20333 //
     /* 1348011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1348022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1348025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1348028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1348031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1348034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348064 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1348067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348089 */     // GIR_Coverage, 20333,
     /* 1348089 */     GIR_EraseRootFromParent_Done,
     /* 1348090 */   // Label 19210: @1348090
     /* 1348090 */   GIM_Try, /*On fail goto*//*Label 19211*/ GIMT_Encode4(1348174), // Rule ID 20336 //
     /* 1348095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1348098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1348112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1348115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348148 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1348151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348173 */     // GIR_Coverage, 20336,
     /* 1348173 */     GIR_EraseRootFromParent_Done,
     /* 1348174 */   // Label 19211: @1348174
     /* 1348174 */   GIM_Try, /*On fail goto*//*Label 19212*/ GIMT_Encode4(1348258), // Rule ID 20337 //
     /* 1348179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1348182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 1348190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 1348193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1348196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1348199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1348202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348232 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M1_MASK:{ *:[nxv1i1] } VR:{ *:[nxv1i1] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1_MASK),
     /* 1348235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1348253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348257 */     // GIR_Coverage, 20337,
     /* 1348257 */     GIR_EraseRootFromParent_Done,
     /* 1348258 */   // Label 19212: @1348258
     /* 1348258 */   GIM_Try, /*On fail goto*//*Label 19213*/ GIMT_Encode4(1348342), // Rule ID 20340 //
     /* 1348263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1348280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1348283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348316 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1348319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348341 */     // GIR_Coverage, 20340,
     /* 1348341 */     GIR_EraseRootFromParent_Done,
     /* 1348342 */   // Label 19213: @1348342
     /* 1348342 */   GIM_Try, /*On fail goto*//*Label 19214*/ GIMT_Encode4(1348426), // Rule ID 20341 //
     /* 1348347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1348364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1348367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348400 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1348403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348425 */     // GIR_Coverage, 20341,
     /* 1348425 */     GIR_EraseRootFromParent_Done,
     /* 1348426 */   // Label 19214: @1348426
     /* 1348426 */   GIM_Try, /*On fail goto*//*Label 19215*/ GIMT_Encode4(1348510), // Rule ID 20344 //
     /* 1348431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1348451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348484 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1348487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348509 */     // GIR_Coverage, 20344,
     /* 1348509 */     GIR_EraseRootFromParent_Done,
     /* 1348510 */   // Label 19215: @1348510
     /* 1348510 */   GIM_Try, /*On fail goto*//*Label 19216*/ GIMT_Encode4(1348594), // Rule ID 20345 //
     /* 1348515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1348526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1348529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1348532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1348535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1348538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348568 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1348571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348593 */     // GIR_Coverage, 20345,
     /* 1348593 */     GIR_EraseRootFromParent_Done,
     /* 1348594 */   // Label 19216: @1348594
     /* 1348594 */   GIM_Try, /*On fail goto*//*Label 19217*/ GIMT_Encode4(1348678), // Rule ID 20348 //
     /* 1348599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1348602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1348619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348652 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1348655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348677 */     // GIR_Coverage, 20348,
     /* 1348677 */     GIR_EraseRootFromParent_Done,
     /* 1348678 */   // Label 19217: @1348678
     /* 1348678 */   GIM_Try, /*On fail goto*//*Label 19218*/ GIMT_Encode4(1348762), // Rule ID 20349 //
     /* 1348683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1348686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s1,
     /* 1348694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s1,
     /* 1348697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1348700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1348703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1348706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1348725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348736 */     // (intrinsic_wo_chain:{ *:[nxv32i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv32i1] } VR:{ *:[nxv32i1] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1348739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1348757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348761 */     // GIR_Coverage, 20349,
     /* 1348761 */     GIR_EraseRootFromParent_Done,
     /* 1348762 */   // Label 19218: @1348762
     /* 1348762 */   GIM_Try, /*On fail goto*//*Label 19219*/ GIMT_Encode4(1348846), // Rule ID 20352 //
     /* 1348767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1348787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348820 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1348823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348845 */     // GIR_Coverage, 20352,
     /* 1348845 */     GIR_EraseRootFromParent_Done,
     /* 1348846 */   // Label 19219: @1348846
     /* 1348846 */   GIM_Try, /*On fail goto*//*Label 19220*/ GIMT_Encode4(1348930), // Rule ID 20353 //
     /* 1348851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1348854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1348862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1348865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1348868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1348871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1348874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1348877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1348893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348904 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1348904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1348907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1348917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1348922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1348925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1348928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1348929 */     // GIR_Coverage, 20353,
     /* 1348929 */     GIR_EraseRootFromParent_Done,
     /* 1348930 */   // Label 19220: @1348930
     /* 1348930 */   GIM_Try, /*On fail goto*//*Label 19221*/ GIMT_Encode4(1349014), // Rule ID 20356 //
     /* 1348935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1348938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1348943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1348946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1348949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1348952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1348955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1348958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1348961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1348969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1348977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1348981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1348988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1348988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1348991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1348993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1348995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1348997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1348999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349013 */     // GIR_Coverage, 20356,
     /* 1349013 */     GIR_EraseRootFromParent_Done,
     /* 1349014 */   // Label 19221: @1349014
     /* 1349014 */   GIM_Try, /*On fail goto*//*Label 19222*/ GIMT_Encode4(1349098), // Rule ID 20357 //
     /* 1349019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1349036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1349039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349072 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1349075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349097 */     // GIR_Coverage, 20357,
     /* 1349097 */     GIR_EraseRootFromParent_Done,
     /* 1349098 */   // Label 19222: @1349098
     /* 1349098 */   GIM_Try, /*On fail goto*//*Label 19223*/ GIMT_Encode4(1349182), // Rule ID 20360 //
     /* 1349103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1349106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1349114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1349117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1349120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1349123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1349126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349156 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1349159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349181 */     // GIR_Coverage, 20360,
     /* 1349181 */     GIR_EraseRootFromParent_Done,
     /* 1349182 */   // Label 19223: @1349182
     /* 1349182 */   GIM_Try, /*On fail goto*//*Label 19224*/ GIMT_Encode4(1349266), // Rule ID 20361 //
     /* 1349187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1349190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 1349198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 1349201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1349204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1349207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1349210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349240 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv16i1] } VR:{ *:[nxv16i1] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1349243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1349261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349265 */     // GIR_Coverage, 20361,
     /* 1349265 */     GIR_EraseRootFromParent_Done,
     /* 1349266 */   // Label 19224: @1349266
     /* 1349266 */   GIM_Try, /*On fail goto*//*Label 19225*/ GIMT_Encode4(1349350), // Rule ID 20364 //
     /* 1349271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1349288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1349291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349324 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1349327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349349 */     // GIR_Coverage, 20364,
     /* 1349349 */     GIR_EraseRootFromParent_Done,
     /* 1349350 */   // Label 19225: @1349350
     /* 1349350 */   GIM_Try, /*On fail goto*//*Label 19226*/ GIMT_Encode4(1349434), // Rule ID 20365 //
     /* 1349355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 1349366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 1349369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1349372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1349375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1349378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1349397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349408 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M2_MASK:{ *:[nxv2i1] } VR:{ *:[nxv2i1] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2_MASK),
     /* 1349411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349433 */     // GIR_Coverage, 20365,
     /* 1349433 */     GIR_EraseRootFromParent_Done,
     /* 1349434 */   // Label 19226: @1349434
     /* 1349434 */   GIM_Try, /*On fail goto*//*Label 19227*/ GIMT_Encode4(1349518), // Rule ID 20368 //
     /* 1349439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1349459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349492 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1349495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349517 */     // GIR_Coverage, 20368,
     /* 1349517 */     GIR_EraseRootFromParent_Done,
     /* 1349518 */   // Label 19227: @1349518
     /* 1349518 */   GIM_Try, /*On fail goto*//*Label 19228*/ GIMT_Encode4(1349602), // Rule ID 20369 //
     /* 1349523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 1349534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 1349537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1349540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1349543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1349546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1349565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349576 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M4_MASK:{ *:[nxv4i1] } VR:{ *:[nxv4i1] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4_MASK),
     /* 1349579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349601 */     // GIR_Coverage, 20369,
     /* 1349601 */     GIR_EraseRootFromParent_Done,
     /* 1349602 */   // Label 19228: @1349602
     /* 1349602 */   GIM_Try, /*On fail goto*//*Label 19229*/ GIMT_Encode4(1349686), // Rule ID 20372 //
     /* 1349607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1349610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1349627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349660 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 1349660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1349663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349685 */     // GIR_Coverage, 20372,
     /* 1349685 */     GIR_EraseRootFromParent_Done,
     /* 1349686 */   // Label 19229: @1349686
     /* 1349686 */   GIM_Try, /*On fail goto*//*Label 19230*/ GIMT_Encode4(1349770), // Rule ID 20373 //
     /* 1349691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1349694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmfge_mask),
     /* 1349699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 1349702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 1349705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1349708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1349711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1349714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1349733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349744 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 11354:{ *:[iPTR] }, VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMFLE_VV_M8_MASK:{ *:[nxv8i1] } VR:{ *:[nxv8i1] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 1349744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8_MASK),
     /* 1349747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1349753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1349755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1349765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1349768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349769 */     // GIR_Coverage, 20373,
     /* 1349769 */     GIR_EraseRootFromParent_Done,
     /* 1349770 */   // Label 19230: @1349770
     /* 1349770 */   GIM_Try, /*On fail goto*//*Label 19231*/ GIMT_Encode4(1349851), // Rule ID 20430 //
     /* 1349775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1349778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1349783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1349786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1349789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1349795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349828 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1349828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1349831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349850 */     // GIR_Coverage, 20430,
     /* 1349850 */     GIR_EraseRootFromParent_Done,
     /* 1349851 */   // Label 19231: @1349851
     /* 1349851 */   GIM_Try, /*On fail goto*//*Label 19232*/ GIMT_Encode4(1349932), // Rule ID 20431 //
     /* 1349856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1349859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1349864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1349867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1349870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1349876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1349882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349909 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1349909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 1349912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1349920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1349922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1349927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1349930 */     GIR_RootConstrainSelectedInstOperands,
     /* 1349931 */     // GIR_Coverage, 20431,
     /* 1349931 */     GIR_EraseRootFromParent_Done,
     /* 1349932 */   // Label 19232: @1349932
     /* 1349932 */   GIM_Try, /*On fail goto*//*Label 19233*/ GIMT_Encode4(1350013), // Rule ID 20432 //
     /* 1349937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1349940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1349945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1349948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1349951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1349954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1349957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1349960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1349963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1349967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1349975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1349979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1349983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1349990 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1349990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1349993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1349995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1349997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1349999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350012 */     // GIR_Coverage, 20432,
     /* 1350012 */     GIR_EraseRootFromParent_Done,
     /* 1350013 */   // Label 19233: @1350013
     /* 1350013 */   GIM_Try, /*On fail goto*//*Label 19234*/ GIMT_Encode4(1350094), // Rule ID 20433 //
     /* 1350018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1350029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1350032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1350035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350071 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1350071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF4),
     /* 1350074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350093 */     // GIR_Coverage, 20433,
     /* 1350093 */     GIR_EraseRootFromParent_Done,
     /* 1350094 */   // Label 19234: @1350094
     /* 1350094 */   GIM_Try, /*On fail goto*//*Label 19235*/ GIMT_Encode4(1350175), // Rule ID 20434 //
     /* 1350099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1350102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1350110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1350113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1350119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350152 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1350152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1350155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350174 */     // GIR_Coverage, 20434,
     /* 1350174 */     GIR_EraseRootFromParent_Done,
     /* 1350175 */   // Label 19235: @1350175
     /* 1350175 */   GIM_Try, /*On fail goto*//*Label 19236*/ GIMT_Encode4(1350256), // Rule ID 20435 //
     /* 1350180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1350183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1350191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1350194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1350200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350233 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1350233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1350236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350255 */     // GIR_Coverage, 20435,
     /* 1350255 */     GIR_EraseRootFromParent_Done,
     /* 1350256 */   // Label 19236: @1350256
     /* 1350256 */   GIM_Try, /*On fail goto*//*Label 19237*/ GIMT_Encode4(1350337), // Rule ID 20436 //
     /* 1350261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1350272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1350275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350314 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1350314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1350317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350336 */     // GIR_Coverage, 20436,
     /* 1350336 */     GIR_EraseRootFromParent_Done,
     /* 1350337 */   // Label 19237: @1350337
     /* 1350337 */   GIM_Try, /*On fail goto*//*Label 19238*/ GIMT_Encode4(1350418), // Rule ID 20437 //
     /* 1350342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1350353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1350356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1350359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1350365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350395 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1350395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_MF2),
     /* 1350398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350417 */     // GIR_Coverage, 20437,
     /* 1350417 */     GIR_EraseRootFromParent_Done,
     /* 1350418 */   // Label 19238: @1350418
     /* 1350418 */   GIM_Try, /*On fail goto*//*Label 19239*/ GIMT_Encode4(1350499), // Rule ID 20438 //
     /* 1350423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1350434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1350437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1350443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350476 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1350476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1350479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350498 */     // GIR_Coverage, 20438,
     /* 1350498 */     GIR_EraseRootFromParent_Done,
     /* 1350499 */   // Label 19239: @1350499
     /* 1350499 */   GIM_Try, /*On fail goto*//*Label 19240*/ GIMT_Encode4(1350580), // Rule ID 20439 //
     /* 1350504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1350515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1350518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1350524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350557 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1350557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 1350560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350579 */     // GIR_Coverage, 20439,
     /* 1350579 */     GIR_EraseRootFromParent_Done,
     /* 1350580 */   // Label 19240: @1350580
     /* 1350580 */   GIM_Try, /*On fail goto*//*Label 19241*/ GIMT_Encode4(1350661), // Rule ID 20440 //
     /* 1350585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1350588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1350596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1350599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350638 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1350638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1350641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350660 */     // GIR_Coverage, 20440,
     /* 1350660 */     GIR_EraseRootFromParent_Done,
     /* 1350661 */   // Label 19241: @1350661
     /* 1350661 */   GIM_Try, /*On fail goto*//*Label 19242*/ GIMT_Encode4(1350742), // Rule ID 20441 //
     /* 1350666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1350669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1350677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1350680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1350683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1350686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1350689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1350708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350719 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1350719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_MF2),
     /* 1350722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1350740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350741 */     // GIR_Coverage, 20441,
     /* 1350741 */     GIR_EraseRootFromParent_Done,
     /* 1350742 */   // Label 19242: @1350742
     /* 1350742 */   GIM_Try, /*On fail goto*//*Label 19243*/ GIMT_Encode4(1350823), // Rule ID 20442 //
     /* 1350747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1350750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1350758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1350761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1350767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350800 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1350800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1350803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350822 */     // GIR_Coverage, 20442,
     /* 1350822 */     GIR_EraseRootFromParent_Done,
     /* 1350823 */   // Label 19243: @1350823
     /* 1350823 */   GIM_Try, /*On fail goto*//*Label 19244*/ GIMT_Encode4(1350904), // Rule ID 20443 //
     /* 1350828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1350831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1350836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1350839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1350842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1350848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1350854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350881 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11350:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1350881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1350884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350903 */     // GIR_Coverage, 20443,
     /* 1350903 */     GIR_EraseRootFromParent_Done,
     /* 1350904 */   // Label 19244: @1350904
     /* 1350904 */   GIM_Try, /*On fail goto*//*Label 19245*/ GIMT_Encode4(1350985), // Rule ID 20444 //
     /* 1350909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1350912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1350920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1350923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1350926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1350929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1350932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1350935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1350939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1350947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1350951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1350955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1350962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1350962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1350965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1350967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1350969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1350971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1350973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1350975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1350980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1350983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1350984 */     // GIR_Coverage, 20444,
     /* 1350984 */     GIR_EraseRootFromParent_Done,
     /* 1350985 */   // Label 19245: @1350985
     /* 1350985 */   GIM_Try, /*On fail goto*//*Label 19246*/ GIMT_Encode4(1351066), // Rule ID 20445 //
     /* 1350990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1350993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1350998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1351001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1351004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1351007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1351013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351043 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11142:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1351043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M1),
     /* 1351046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351065 */     // GIR_Coverage, 20445,
     /* 1351065 */     GIR_EraseRootFromParent_Done,
     /* 1351066 */   // Label 19246: @1351066
     /* 1351066 */   GIM_Try, /*On fail goto*//*Label 19247*/ GIMT_Encode4(1351147), // Rule ID 20446 //
     /* 1351071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1351082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1351085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1351088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1351091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1351124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1351127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351146 */     // GIR_Coverage, 20446,
     /* 1351146 */     GIR_EraseRootFromParent_Done,
     /* 1351147 */   // Label 19247: @1351147
     /* 1351147 */   GIM_Try, /*On fail goto*//*Label 19248*/ GIMT_Encode4(1351228), // Rule ID 20447 //
     /* 1351152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1351163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1351166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1351169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1351172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351205 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11350:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1351205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1351208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351227 */     // GIR_Coverage, 20447,
     /* 1351227 */     GIR_EraseRootFromParent_Done,
     /* 1351228 */   // Label 19248: @1351228
     /* 1351228 */   GIM_Try, /*On fail goto*//*Label 19249*/ GIMT_Encode4(1351309), // Rule ID 20448 //
     /* 1351233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1351236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1351244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1351247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1351250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351286 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1351286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1351289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351308 */     // GIR_Coverage, 20448,
     /* 1351308 */     GIR_EraseRootFromParent_Done,
     /* 1351309 */   // Label 19249: @1351309
     /* 1351309 */   GIM_Try, /*On fail goto*//*Label 19250*/ GIMT_Encode4(1351390), // Rule ID 20449 //
     /* 1351314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1351317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1351325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1351328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1351331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1351334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1351337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1351356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351367 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11142:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1351367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M1),
     /* 1351370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1351388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351389 */     // GIR_Coverage, 20449,
     /* 1351389 */     GIR_EraseRootFromParent_Done,
     /* 1351390 */   // Label 19250: @1351390
     /* 1351390 */   GIM_Try, /*On fail goto*//*Label 19251*/ GIMT_Encode4(1351471), // Rule ID 20450 //
     /* 1351395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1351406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1351409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1351412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1351415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351448 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1351448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1351451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351470 */     // GIR_Coverage, 20450,
     /* 1351470 */     GIR_EraseRootFromParent_Done,
     /* 1351471 */   // Label 19251: @1351471
     /* 1351471 */   GIM_Try, /*On fail goto*//*Label 19252*/ GIMT_Encode4(1351552), // Rule ID 20451 //
     /* 1351476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1351487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1351490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1351493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1351496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351529 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11350:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1351529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 1351532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351551 */     // GIR_Coverage, 20451,
     /* 1351551 */     GIR_EraseRootFromParent_Done,
     /* 1351552 */   // Label 19252: @1351552
     /* 1351552 */   GIM_Try, /*On fail goto*//*Label 19253*/ GIMT_Encode4(1351633), // Rule ID 20452 //
     /* 1351557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1351560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1351568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1351571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1351574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351610 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1351610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1351613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351632 */     // GIR_Coverage, 20452,
     /* 1351632 */     GIR_EraseRootFromParent_Done,
     /* 1351633 */   // Label 19253: @1351633
     /* 1351633 */   GIM_Try, /*On fail goto*//*Label 19254*/ GIMT_Encode4(1351714), // Rule ID 20453 //
     /* 1351638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1351641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1351649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1351652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1351655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1351658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1351661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1351668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1351676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1351680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351691 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11142:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1351691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M1),
     /* 1351694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1351712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351713 */     // GIR_Coverage, 20453,
     /* 1351713 */     GIR_EraseRootFromParent_Done,
     /* 1351714 */   // Label 19254: @1351714
     /* 1351714 */   GIM_Try, /*On fail goto*//*Label 19255*/ GIMT_Encode4(1351795), // Rule ID 20454 //
     /* 1351719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1351722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1351739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351772 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1351772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1351775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351794 */     // GIR_Coverage, 20454,
     /* 1351794 */     GIR_EraseRootFromParent_Done,
     /* 1351795 */   // Label 19255: @1351795
     /* 1351795 */   GIM_Try, /*On fail goto*//*Label 19256*/ GIMT_Encode4(1351876), // Rule ID 20455 //
     /* 1351800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1351803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1351808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1351820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351853 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1351853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1351856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351875 */     // GIR_Coverage, 20455,
     /* 1351875 */     GIR_EraseRootFromParent_Done,
     /* 1351876 */   // Label 19256: @1351876
     /* 1351876 */   GIM_Try, /*On fail goto*//*Label 19257*/ GIMT_Encode4(1351957), // Rule ID 20456 //
     /* 1351881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1351884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1351907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1351923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1351927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1351934 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1351934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1351937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1351939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1351941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1351943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1351945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1351947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1351952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1351955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1351956 */     // GIR_Coverage, 20456,
     /* 1351956 */     GIR_EraseRootFromParent_Done,
     /* 1351957 */   // Label 19257: @1351957
     /* 1351957 */   GIM_Try, /*On fail goto*//*Label 19258*/ GIMT_Encode4(1352038), // Rule ID 20457 //
     /* 1351962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1351965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1351970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1351973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1351976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1351979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1351982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1351985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1351988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1351992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1351996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352015 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1352015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M2),
     /* 1352018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352037 */     // GIR_Coverage, 20457,
     /* 1352037 */     GIR_EraseRootFromParent_Done,
     /* 1352038 */   // Label 19258: @1352038
     /* 1352038 */   GIM_Try, /*On fail goto*//*Label 19259*/ GIMT_Encode4(1352119), // Rule ID 20458 //
     /* 1352043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1352046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1352054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1352057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352096 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1352096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1352099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352118 */     // GIR_Coverage, 20458,
     /* 1352118 */     GIR_EraseRootFromParent_Done,
     /* 1352119 */   // Label 19259: @1352119
     /* 1352119 */   GIM_Try, /*On fail goto*//*Label 19260*/ GIMT_Encode4(1352200), // Rule ID 20459 //
     /* 1352124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1352127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1352135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1352138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1352144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352177 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1352177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1352180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352198 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352199 */     // GIR_Coverage, 20459,
     /* 1352199 */     GIR_EraseRootFromParent_Done,
     /* 1352200 */   // Label 19260: @1352200
     /* 1352200 */   GIM_Try, /*On fail goto*//*Label 19261*/ GIMT_Encode4(1352281), // Rule ID 20460 //
     /* 1352205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1352216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1352219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352258 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1352258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1352261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352280 */     // GIR_Coverage, 20460,
     /* 1352280 */     GIR_EraseRootFromParent_Done,
     /* 1352281 */   // Label 19261: @1352281
     /* 1352281 */   GIM_Try, /*On fail goto*//*Label 19262*/ GIMT_Encode4(1352362), // Rule ID 20461 //
     /* 1352286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1352297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1352300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1352303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1352309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1352316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1352324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352339 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1352339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M4),
     /* 1352342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352361 */     // GIR_Coverage, 20461,
     /* 1352361 */     GIR_EraseRootFromParent_Done,
     /* 1352362 */   // Label 19262: @1352362
     /* 1352362 */   GIM_Try, /*On fail goto*//*Label 19263*/ GIMT_Encode4(1352443), // Rule ID 20462 //
     /* 1352367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1352370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1352378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1352381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352420 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1352420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1352423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352442 */     // GIR_Coverage, 20462,
     /* 1352442 */     GIR_EraseRootFromParent_Done,
     /* 1352443 */   // Label 19263: @1352443
     /* 1352443 */   GIM_Try, /*On fail goto*//*Label 19264*/ GIMT_Encode4(1352524), // Rule ID 20463 //
     /* 1352448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1352451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1352459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1352462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1352468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352501 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1352501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1352504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352523 */     // GIR_Coverage, 20463,
     /* 1352523 */     GIR_EraseRootFromParent_Done,
     /* 1352524 */   // Label 19264: @1352524
     /* 1352524 */   GIM_Try, /*On fail goto*//*Label 19265*/ GIMT_Encode4(1352605), // Rule ID 20464 //
     /* 1352529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1352532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1352540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1352543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352582 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] })
     /* 1352582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1352585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352604 */     // GIR_Coverage, 20464,
     /* 1352604 */     GIR_EraseRootFromParent_Done,
     /* 1352605 */   // Label 19265: @1352605
     /* 1352605 */   GIM_Try, /*On fail goto*//*Label 19266*/ GIMT_Encode4(1352686), // Rule ID 20465 //
     /* 1352610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1352613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1352621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1352624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1352627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1352630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1352633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1352640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1352648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1352652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352663 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR16M_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] })
     /* 1352663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR16M_M8),
     /* 1352666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1352684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352685 */     // GIR_Coverage, 20465,
     /* 1352685 */     GIR_EraseRootFromParent_Done,
     /* 1352686 */   // Label 19266: @1352686
     /* 1352686 */   GIM_Try, /*On fail goto*//*Label 19267*/ GIMT_Encode4(1352767), // Rule ID 20466 //
     /* 1352691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1352702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1352705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352744 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1352744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1352747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352766 */     // GIR_Coverage, 20466,
     /* 1352766 */     GIR_EraseRootFromParent_Done,
     /* 1352767 */   // Label 19267: @1352767
     /* 1352767 */   GIM_Try, /*On fail goto*//*Label 19268*/ GIMT_Encode4(1352848), // Rule ID 20467 //
     /* 1352772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1352780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1352783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1352786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1352792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1352825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1352828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352847 */     // GIR_Coverage, 20467,
     /* 1352847 */     GIR_EraseRootFromParent_Done,
     /* 1352848 */   // Label 19268: @1352848
     /* 1352848 */   GIM_Try, /*On fail goto*//*Label 19269*/ GIMT_Encode4(1352929), // Rule ID 20468 //
     /* 1352853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1352856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1352864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1352867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1352879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1352895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352906 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1352906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1352909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1352919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1352924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1352927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1352928 */     // GIR_Coverage, 20468,
     /* 1352928 */     GIR_EraseRootFromParent_Done,
     /* 1352929 */   // Label 19269: @1352929
     /* 1352929 */   GIM_Try, /*On fail goto*//*Label 19270*/ GIMT_Encode4(1353010), // Rule ID 20469 //
     /* 1352934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1352937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1352942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1352945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1352948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1352951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1352954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1352957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1352960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1352964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1352972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1352976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1352980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1352987 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1352987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M2),
     /* 1352990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1352992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1352994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1352996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1352998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353009 */     // GIR_Coverage, 20469,
     /* 1353009 */     GIR_EraseRootFromParent_Done,
     /* 1353010 */   // Label 19270: @1353010
     /* 1353010 */   GIM_Try, /*On fail goto*//*Label 19271*/ GIMT_Encode4(1353091), // Rule ID 20470 //
     /* 1353015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1353026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1353029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1353045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353068 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1353068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1353071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353090 */     // GIR_Coverage, 20470,
     /* 1353090 */     GIR_EraseRootFromParent_Done,
     /* 1353091 */   // Label 19271: @1353091
     /* 1353091 */   GIM_Try, /*On fail goto*//*Label 19272*/ GIMT_Encode4(1353172), // Rule ID 20471 //
     /* 1353096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1353107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1353110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1353116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1353126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353149 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1353149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1353152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353171 */     // GIR_Coverage, 20471,
     /* 1353171 */     GIR_EraseRootFromParent_Done,
     /* 1353172 */   // Label 19272: @1353172
     /* 1353172 */   GIM_Try, /*On fail goto*//*Label 19273*/ GIMT_Encode4(1353253), // Rule ID 20472 //
     /* 1353177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1353188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1353191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1353207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1353230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1353233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353252 */     // GIR_Coverage, 20472,
     /* 1353252 */     GIR_EraseRootFromParent_Done,
     /* 1353253 */   // Label 19273: @1353253
     /* 1353253 */   GIM_Try, /*On fail goto*//*Label 19274*/ GIMT_Encode4(1353334), // Rule ID 20473 //
     /* 1353258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1353269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1353272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1353275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1353281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1353288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1353296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353311 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1353311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M4),
     /* 1353314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353333 */     // GIR_Coverage, 20473,
     /* 1353333 */     GIR_EraseRootFromParent_Done,
     /* 1353334 */   // Label 19274: @1353334
     /* 1353334 */   GIM_Try, /*On fail goto*//*Label 19275*/ GIMT_Encode4(1353415), // Rule ID 20474 //
     /* 1353339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1353350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1353353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1353369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353392 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1353392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1353395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353414 */     // GIR_Coverage, 20474,
     /* 1353414 */     GIR_EraseRootFromParent_Done,
     /* 1353415 */   // Label 19275: @1353415
     /* 1353415 */   GIM_Try, /*On fail goto*//*Label 19276*/ GIMT_Encode4(1353496), // Rule ID 20475 //
     /* 1353420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1353431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1353434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1353440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1353450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353473 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1353473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1353476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353495 */     // GIR_Coverage, 20475,
     /* 1353495 */     GIR_EraseRootFromParent_Done,
     /* 1353496 */   // Label 19276: @1353496
     /* 1353496 */   GIM_Try, /*On fail goto*//*Label 19277*/ GIMT_Encode4(1353577), // Rule ID 20476 //
     /* 1353501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1353504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1353512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1353515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1353531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353554 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] })
     /* 1353554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1353557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353576 */     // GIR_Coverage, 20476,
     /* 1353576 */     GIR_EraseRootFromParent_Done,
     /* 1353577 */   // Label 19277: @1353577
     /* 1353577 */   GIM_Try, /*On fail goto*//*Label 19278*/ GIMT_Encode4(1353658), // Rule ID 20477 //
     /* 1353582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1353585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1353593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1353596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1353599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1353602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1353605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1353612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1353620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1353624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353635 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR32M_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] })
     /* 1353635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR32M_M8),
     /* 1353638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1353656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353657 */     // GIR_Coverage, 20477,
     /* 1353657 */     GIR_EraseRootFromParent_Done,
     /* 1353658 */   // Label 19278: @1353658
     /* 1353658 */   GIM_Try, /*On fail goto*//*Label 19279*/ GIMT_Encode4(1353739), // Rule ID 20478 //
     /* 1353663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1353674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1353677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1353693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353716 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1353716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1353719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353738 */     // GIR_Coverage, 20478,
     /* 1353738 */     GIR_EraseRootFromParent_Done,
     /* 1353739 */   // Label 19279: @1353739
     /* 1353739 */   GIM_Try, /*On fail goto*//*Label 19280*/ GIMT_Encode4(1353820), // Rule ID 20479 //
     /* 1353744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1353755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1353758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1353764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1353774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353797 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11350:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1353797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 1353800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353819 */     // GIR_Coverage, 20479,
     /* 1353819 */     GIR_EraseRootFromParent_Done,
     /* 1353820 */   // Label 19280: @1353820
     /* 1353820 */   GIM_Try, /*On fail goto*//*Label 19281*/ GIMT_Encode4(1353901), // Rule ID 20480 //
     /* 1353825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1353836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1353839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1353851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1353855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1353867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1353878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1353881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353900 */     // GIR_Coverage, 20480,
     /* 1353900 */     GIR_EraseRootFromParent_Done,
     /* 1353901 */   // Label 19281: @1353901
     /* 1353901 */   GIM_Try, /*On fail goto*//*Label 19282*/ GIMT_Encode4(1353982), // Rule ID 20481 //
     /* 1353906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1353909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1353914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1353917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1353920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1353923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1353926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1353929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1353932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1353936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1353944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1353948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1353952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1353959 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11142:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1353959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M2),
     /* 1353962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1353964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1353966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1353968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1353970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1353972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1353977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1353980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1353981 */     // GIR_Coverage, 20481,
     /* 1353981 */     GIR_EraseRootFromParent_Done,
     /* 1353982 */   // Label 19282: @1353982
     /* 1353982 */   GIM_Try, /*On fail goto*//*Label 19283*/ GIMT_Encode4(1354063), // Rule ID 20482 //
     /* 1353987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1353990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1353995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1353998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1354001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1354007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1354017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354040 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1354040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1354043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354062 */     // GIR_Coverage, 20482,
     /* 1354062 */     GIR_EraseRootFromParent_Done,
     /* 1354063 */   // Label 19283: @1354063
     /* 1354063 */   GIM_Try, /*On fail goto*//*Label 19284*/ GIMT_Encode4(1354144), // Rule ID 20483 //
     /* 1354068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1354079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1354082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1354088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1354098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354121 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11350:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1354121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 1354124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354142 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354143 */     // GIR_Coverage, 20483,
     /* 1354143 */     GIR_EraseRootFromParent_Done,
     /* 1354144 */   // Label 19284: @1354144
     /* 1354144 */   GIM_Try, /*On fail goto*//*Label 19285*/ GIMT_Encode4(1354225), // Rule ID 20484 //
     /* 1354149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1354160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1354163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1354179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354202 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1354202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1354205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354224 */     // GIR_Coverage, 20484,
     /* 1354224 */     GIR_EraseRootFromParent_Done,
     /* 1354225 */   // Label 19285: @1354225
     /* 1354225 */   GIM_Try, /*On fail goto*//*Label 19286*/ GIMT_Encode4(1354306), // Rule ID 20485 //
     /* 1354230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1354241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1354244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1354247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1354260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1354268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354283 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11142:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1354283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M4),
     /* 1354286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354305 */     // GIR_Coverage, 20485,
     /* 1354305 */     GIR_EraseRootFromParent_Done,
     /* 1354306 */   // Label 19286: @1354306
     /* 1354306 */   GIM_Try, /*On fail goto*//*Label 19287*/ GIMT_Encode4(1354387), // Rule ID 20486 //
     /* 1354311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1354322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1354325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1354341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354364 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1354364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1354367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354386 */     // GIR_Coverage, 20486,
     /* 1354386 */     GIR_EraseRootFromParent_Done,
     /* 1354387 */   // Label 19287: @1354387
     /* 1354387 */   GIM_Try, /*On fail goto*//*Label 19288*/ GIMT_Encode4(1354468), // Rule ID 20487 //
     /* 1354392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmerge),
     /* 1354400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1354403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1354406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1354412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1354422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354445 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11350:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1354445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 1354448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354466 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354467 */     // GIR_Coverage, 20487,
     /* 1354467 */     GIR_EraseRootFromParent_Done,
     /* 1354468 */   // Label 19288: @1354468
     /* 1354468 */   GIM_Try, /*On fail goto*//*Label 19289*/ GIMT_Encode4(1354549), // Rule ID 20488 //
     /* 1354473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1354476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1354484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1354487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1354503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354526 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] })
     /* 1354526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1354529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354548 */     // GIR_Coverage, 20488,
     /* 1354548 */     GIR_EraseRootFromParent_Done,
     /* 1354549 */   // Label 19289: @1354549
     /* 1354549 */   GIM_Try, /*On fail goto*//*Label 19290*/ GIMT_Encode4(1354630), // Rule ID 20489 //
     /* 1354554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1354557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmerge),
     /* 1354562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1354565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1354568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1354571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1354574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1354577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1354584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1354592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1354596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354607 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11142:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFMERGE_VFPR64M_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] })
     /* 1354607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMERGE_VFPR64M_M8),
     /* 1354610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1354614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1354628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354629 */     // GIR_Coverage, 20489,
     /* 1354629 */     GIR_EraseRootFromParent_Done,
     /* 1354630 */   // Label 19290: @1354630
     /* 1354630 */   GIM_Try, /*On fail goto*//*Label 19291*/ GIMT_Encode4(1354714), // Rule ID 21870 //
     /* 1354635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1354643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1354652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1354655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354688 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1354688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1354691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1354695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1354712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354713 */     // GIR_Coverage, 21870,
     /* 1354713 */     GIR_EraseRootFromParent_Done,
     /* 1354714 */   // Label 19291: @1354714
     /* 1354714 */   GIM_Try, /*On fail goto*//*Label 19292*/ GIMT_Encode4(1354798), // Rule ID 21871 //
     /* 1354719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1354727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1354736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1354739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1354742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354772 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1354772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E8_MASK),
     /* 1354775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1354779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1354796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354797 */     // GIR_Coverage, 21871,
     /* 1354797 */     GIR_EraseRootFromParent_Done,
     /* 1354798 */   // Label 19292: @1354798
     /* 1354798 */   GIM_Try, /*On fail goto*//*Label 19293*/ GIMT_Encode4(1354882), // Rule ID 21874 //
     /* 1354803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1354811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1354820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1354823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354856 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1354856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1354859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1354863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1354880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354881 */     // GIR_Coverage, 21874,
     /* 1354881 */     GIR_EraseRootFromParent_Done,
     /* 1354882 */   // Label 19293: @1354882
     /* 1354882 */   GIM_Try, /*On fail goto*//*Label 19294*/ GIMT_Encode4(1354966), // Rule ID 21875 //
     /* 1354887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1354890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1354895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1354898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1354901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1354904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1354907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1354910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1354913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1354917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1354929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1354933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1354940 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1354940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E8_MASK),
     /* 1354943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1354945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1354947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1354949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1354951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1354953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1354958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1354961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1354964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1354965 */     // GIR_Coverage, 21875,
     /* 1354965 */     GIR_EraseRootFromParent_Done,
     /* 1354966 */   // Label 19294: @1354966
     /* 1354966 */   GIM_Try, /*On fail goto*//*Label 19295*/ GIMT_Encode4(1355050), // Rule ID 21878 //
     /* 1354971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1354974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1354979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1354982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1354985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1354988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1354991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1354994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1354997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355024 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1355027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355049 */     // GIR_Coverage, 21878,
     /* 1355049 */     GIR_EraseRootFromParent_Done,
     /* 1355050 */   // Label 19295: @1355050
     /* 1355050 */   GIM_Try, /*On fail goto*//*Label 19296*/ GIMT_Encode4(1355134), // Rule ID 21879 //
     /* 1355055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1355072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF4_E16_MASK),
     /* 1355111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355133 */     // GIR_Coverage, 21879,
     /* 1355133 */     GIR_EraseRootFromParent_Done,
     /* 1355134 */   // Label 19296: @1355134
     /* 1355134 */   GIM_Try, /*On fail goto*//*Label 19297*/ GIMT_Encode4(1355218), // Rule ID 21882 //
     /* 1355139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1355156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355192 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1355195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355217 */     // GIR_Coverage, 21882,
     /* 1355217 */     GIR_EraseRootFromParent_Done,
     /* 1355218 */   // Label 19297: @1355218
     /* 1355218 */   GIM_Try, /*On fail goto*//*Label 19298*/ GIMT_Encode4(1355302), // Rule ID 21883 //
     /* 1355223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1355240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355276 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E16_MASK),
     /* 1355279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355301 */     // GIR_Coverage, 21883,
     /* 1355301 */     GIR_EraseRootFromParent_Done,
     /* 1355302 */   // Label 19298: @1355302
     /* 1355302 */   GIM_Try, /*On fail goto*//*Label 19299*/ GIMT_Encode4(1355386), // Rule ID 21886 //
     /* 1355307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1355324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355360 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1355363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355385 */     // GIR_Coverage, 21886,
     /* 1355385 */     GIR_EraseRootFromParent_Done,
     /* 1355386 */   // Label 19299: @1355386
     /* 1355386 */   GIM_Try, /*On fail goto*//*Label 19300*/ GIMT_Encode4(1355470), // Rule ID 21887 //
     /* 1355391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1355408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1355414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_MF2_E32_MASK),
     /* 1355447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355469 */     // GIR_Coverage, 21887,
     /* 1355469 */     GIR_EraseRootFromParent_Done,
     /* 1355470 */   // Label 19300: @1355470
     /* 1355470 */   GIM_Try, /*On fail goto*//*Label 19301*/ GIMT_Encode4(1355554), // Rule ID 21890 //
     /* 1355475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1355486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1355489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1355492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1355495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1355531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355553 */     // GIR_Coverage, 21890,
     /* 1355553 */     GIR_EraseRootFromParent_Done,
     /* 1355554 */   // Label 19301: @1355554
     /* 1355554 */   GIM_Try, /*On fail goto*//*Label 19302*/ GIMT_Encode4(1355638), // Rule ID 21891 //
     /* 1355559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1355570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1355573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1355576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1355579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1355582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355612 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E8_MASK),
     /* 1355615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1355633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355637 */     // GIR_Coverage, 21891,
     /* 1355637 */     GIR_EraseRootFromParent_Done,
     /* 1355638 */   // Label 19302: @1355638
     /* 1355638 */   GIM_Try, /*On fail goto*//*Label 19303*/ GIMT_Encode4(1355722), // Rule ID 21894 //
     /* 1355643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1355699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355721 */     // GIR_Coverage, 21894,
     /* 1355721 */     GIR_EraseRootFromParent_Done,
     /* 1355722 */   // Label 19303: @1355722
     /* 1355722 */   GIM_Try, /*On fail goto*//*Label 19304*/ GIMT_Encode4(1355806), // Rule ID 21895 //
     /* 1355727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1355738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1355741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1355744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1355747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1355750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E16_MASK),
     /* 1355783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1355801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355805 */     // GIR_Coverage, 21895,
     /* 1355805 */     GIR_EraseRootFromParent_Done,
     /* 1355806 */   // Label 19304: @1355806
     /* 1355806 */   GIM_Try, /*On fail goto*//*Label 19305*/ GIMT_Encode4(1355890), // Rule ID 21898 //
     /* 1355811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1355814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1355837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355864 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1355864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1355867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355889 */     // GIR_Coverage, 21898,
     /* 1355889 */     GIR_EraseRootFromParent_Done,
     /* 1355890 */   // Label 19305: @1355890
     /* 1355890 */   GIM_Try, /*On fail goto*//*Label 19306*/ GIMT_Encode4(1355974), // Rule ID 21899 //
     /* 1355895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1355898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1355906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1355909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1355912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1355915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1355918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1355921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1355925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1355937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1355941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1355948 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1355948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E32_MASK),
     /* 1355951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1355953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1355955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1355957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1355959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1355961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1355966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1355969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1355972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1355973 */     // GIR_Coverage, 21899,
     /* 1355973 */     GIR_EraseRootFromParent_Done,
     /* 1355974 */   // Label 19306: @1355974
     /* 1355974 */   GIM_Try, /*On fail goto*//*Label 19307*/ GIMT_Encode4(1356058), // Rule ID 21902 //
     /* 1355979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1355982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1355987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1355990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1355993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1355996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1355999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1356035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356057 */     // GIR_Coverage, 21902,
     /* 1356057 */     GIR_EraseRootFromParent_Done,
     /* 1356058 */   // Label 19307: @1356058
     /* 1356058 */   GIM_Try, /*On fail goto*//*Label 19308*/ GIMT_Encode4(1356142), // Rule ID 21903 //
     /* 1356063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1356066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1356074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1356077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1356080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1356083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1356086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356116 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M1_E64_MASK),
     /* 1356119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1356137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356141 */     // GIR_Coverage, 21903,
     /* 1356141 */     GIR_EraseRootFromParent_Done,
     /* 1356142 */   // Label 19308: @1356142
     /* 1356142 */   GIM_Try, /*On fail goto*//*Label 19309*/ GIMT_Encode4(1356226), // Rule ID 21906 //
     /* 1356147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1356164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356200 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1356203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356225 */     // GIR_Coverage, 21906,
     /* 1356225 */     GIR_EraseRootFromParent_Done,
     /* 1356226 */   // Label 19309: @1356226
     /* 1356226 */   GIM_Try, /*On fail goto*//*Label 19310*/ GIMT_Encode4(1356310), // Rule ID 21907 //
     /* 1356231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1356248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356284 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E8_MASK),
     /* 1356287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356309 */     // GIR_Coverage, 21907,
     /* 1356309 */     GIR_EraseRootFromParent_Done,
     /* 1356310 */   // Label 19310: @1356310
     /* 1356310 */   GIM_Try, /*On fail goto*//*Label 19311*/ GIMT_Encode4(1356394), // Rule ID 21910 //
     /* 1356315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1356332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356368 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1356371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356393 */     // GIR_Coverage, 21910,
     /* 1356393 */     GIR_EraseRootFromParent_Done,
     /* 1356394 */   // Label 19311: @1356394
     /* 1356394 */   GIM_Try, /*On fail goto*//*Label 19312*/ GIMT_Encode4(1356478), // Rule ID 21911 //
     /* 1356399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1356416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1356422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E8_MASK),
     /* 1356455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356477 */     // GIR_Coverage, 21911,
     /* 1356477 */     GIR_EraseRootFromParent_Done,
     /* 1356478 */   // Label 19312: @1356478
     /* 1356478 */   GIM_Try, /*On fail goto*//*Label 19313*/ GIMT_Encode4(1356562), // Rule ID 21914 //
     /* 1356483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1356500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1356506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356536 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1356539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356561 */     // GIR_Coverage, 21914,
     /* 1356561 */     GIR_EraseRootFromParent_Done,
     /* 1356562 */   // Label 19313: @1356562
     /* 1356562 */   GIM_Try, /*On fail goto*//*Label 19314*/ GIMT_Encode4(1356646), // Rule ID 21915 //
     /* 1356567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1356578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1356581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1356584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1356587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1356590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1356605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356620 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11441:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E8_MASK),
     /* 1356623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1356641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356645 */     // GIR_Coverage, 21915,
     /* 1356645 */     GIR_EraseRootFromParent_Done,
     /* 1356646 */   // Label 19314: @1356646
     /* 1356646 */   GIM_Try, /*On fail goto*//*Label 19315*/ GIMT_Encode4(1356730), // Rule ID 21918 //
     /* 1356651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1356662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1356665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1356671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1356707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356729 */     // GIR_Coverage, 21918,
     /* 1356729 */     GIR_EraseRootFromParent_Done,
     /* 1356730 */   // Label 19315: @1356730
     /* 1356730 */   GIM_Try, /*On fail goto*//*Label 19316*/ GIMT_Encode4(1356814), // Rule ID 21919 //
     /* 1356735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1356746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1356749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1356752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1356755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1356758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1356773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E16_MASK),
     /* 1356791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356813 */     // GIR_Coverage, 21919,
     /* 1356813 */     GIR_EraseRootFromParent_Done,
     /* 1356814 */   // Label 19316: @1356814
     /* 1356814 */   GIM_Try, /*On fail goto*//*Label 19317*/ GIMT_Encode4(1356898), // Rule ID 21922 //
     /* 1356819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1356830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1356833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1356839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1356845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1356872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1356875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356897 */     // GIR_Coverage, 21922,
     /* 1356897 */     GIR_EraseRootFromParent_Done,
     /* 1356898 */   // Label 19317: @1356898
     /* 1356898 */   GIM_Try, /*On fail goto*//*Label 19318*/ GIMT_Encode4(1356982), // Rule ID 21923 //
     /* 1356903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1356906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1356914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1356917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1356920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1356923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1356926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1356929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1356933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1356941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1356945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1356949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1356956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1356956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E16_MASK),
     /* 1356959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1356961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1356963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1356965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1356967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1356969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1356974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1356977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1356980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1356981 */     // GIR_Coverage, 21923,
     /* 1356981 */     GIR_EraseRootFromParent_Done,
     /* 1356982 */   // Label 19318: @1356982
     /* 1356982 */   GIM_Try, /*On fail goto*//*Label 19319*/ GIMT_Encode4(1357066), // Rule ID 21926 //
     /* 1356987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1356990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1356995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1356998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1357004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1357010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1357043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357065 */     // GIR_Coverage, 21926,
     /* 1357065 */     GIR_EraseRootFromParent_Done,
     /* 1357066 */   // Label 19319: @1357066
     /* 1357066 */   GIM_Try, /*On fail goto*//*Label 19320*/ GIMT_Encode4(1357150), // Rule ID 21927 //
     /* 1357071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1357082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1357085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1357088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1357091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1357094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11441:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E16_MASK),
     /* 1357127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1357145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357149 */     // GIR_Coverage, 21927,
     /* 1357149 */     GIR_EraseRootFromParent_Done,
     /* 1357150 */   // Label 19320: @1357150
     /* 1357150 */   GIM_Try, /*On fail goto*//*Label 19321*/ GIMT_Encode4(1357234), // Rule ID 21930 //
     /* 1357155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357208 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1357211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357233 */     // GIR_Coverage, 21930,
     /* 1357233 */     GIR_EraseRootFromParent_Done,
     /* 1357234 */   // Label 19321: @1357234
     /* 1357234 */   GIM_Try, /*On fail goto*//*Label 19322*/ GIMT_Encode4(1357318), // Rule ID 21931 //
     /* 1357239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1357256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357292 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E32_MASK),
     /* 1357295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357317 */     // GIR_Coverage, 21931,
     /* 1357317 */     GIR_EraseRootFromParent_Done,
     /* 1357318 */   // Label 19322: @1357318
     /* 1357318 */   GIM_Try, /*On fail goto*//*Label 19323*/ GIMT_Encode4(1357402), // Rule ID 21934 //
     /* 1357323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1357379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357401 */     // GIR_Coverage, 21934,
     /* 1357401 */     GIR_EraseRootFromParent_Done,
     /* 1357402 */   // Label 19323: @1357402
     /* 1357402 */   GIM_Try, /*On fail goto*//*Label 19324*/ GIMT_Encode4(1357486), // Rule ID 21935 //
     /* 1357407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1357424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1357430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357460 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E32_MASK),
     /* 1357463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357485 */     // GIR_Coverage, 21935,
     /* 1357485 */     GIR_EraseRootFromParent_Done,
     /* 1357486 */   // Label 19324: @1357486
     /* 1357486 */   GIM_Try, /*On fail goto*//*Label 19325*/ GIMT_Encode4(1357570), // Rule ID 21938 //
     /* 1357491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1357494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357544 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1357547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357569 */     // GIR_Coverage, 21938,
     /* 1357569 */     GIR_EraseRootFromParent_Done,
     /* 1357570 */   // Label 19325: @1357570
     /* 1357570 */   GIM_Try, /*On fail goto*//*Label 19326*/ GIMT_Encode4(1357654), // Rule ID 21939 //
     /* 1357575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1357578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1357586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1357589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1357592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1357595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1357598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1357613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357628 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11441:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E32_MASK),
     /* 1357631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1357649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357653 */     // GIR_Coverage, 21939,
     /* 1357653 */     GIR_EraseRootFromParent_Done,
     /* 1357654 */   // Label 19326: @1357654
     /* 1357654 */   GIM_Try, /*On fail goto*//*Label 19327*/ GIMT_Encode4(1357738), // Rule ID 21942 //
     /* 1357659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1357662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1357670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1357673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1357676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1357679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1357715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357737 */     // GIR_Coverage, 21942,
     /* 1357737 */     GIR_EraseRootFromParent_Done,
     /* 1357738 */   // Label 19327: @1357738
     /* 1357738 */   GIM_Try, /*On fail goto*//*Label 19328*/ GIMT_Encode4(1357822), // Rule ID 21943 //
     /* 1357743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1357746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1357754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1357757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1357760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1357763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1357766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1357781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357796 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M2_E64_MASK),
     /* 1357799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357821 */     // GIR_Coverage, 21943,
     /* 1357821 */     GIR_EraseRootFromParent_Done,
     /* 1357822 */   // Label 19328: @1357822
     /* 1357822 */   GIM_Try, /*On fail goto*//*Label 19329*/ GIMT_Encode4(1357906), // Rule ID 21946 //
     /* 1357827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1357830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1357838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1357841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1357844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1357847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1357853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357880 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1357880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1357883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357905 */     // GIR_Coverage, 21946,
     /* 1357905 */     GIR_EraseRootFromParent_Done,
     /* 1357906 */   // Label 19329: @1357906
     /* 1357906 */   GIM_Try, /*On fail goto*//*Label 19330*/ GIMT_Encode4(1357990), // Rule ID 21947 //
     /* 1357911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1357914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1357919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1357922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1357925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1357928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1357931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1357934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1357937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1357941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1357949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1357953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1357957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1357964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1357964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M4_E64_MASK),
     /* 1357967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1357969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1357971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1357973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1357975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1357977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1357982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1357985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1357988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1357989 */     // GIR_Coverage, 21947,
     /* 1357989 */     GIR_EraseRootFromParent_Done,
     /* 1357990 */   // Label 19330: @1357990
     /* 1357990 */   GIM_Try, /*On fail goto*//*Label 19331*/ GIMT_Encode4(1358074), // Rule ID 21950 //
     /* 1357995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1357998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1358003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358048 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1358051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358073 */     // GIR_Coverage, 21950,
     /* 1358073 */     GIR_EraseRootFromParent_Done,
     /* 1358074 */   // Label 19331: @1358074
     /* 1358074 */   GIM_Try, /*On fail goto*//*Label 19332*/ GIMT_Encode4(1358158), // Rule ID 21951 //
     /* 1358079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1358082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredsum_mask),
     /* 1358087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1358090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1358093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1358096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1358099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1358102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1358117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358132 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11441:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDSUM_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDSUM_VS_M8_E64_MASK),
     /* 1358135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1358153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358157 */     // GIR_Coverage, 21951,
     /* 1358157 */     GIR_EraseRootFromParent_Done,
     /* 1358158 */   // Label 19332: @1358158
     /* 1358158 */   GIM_Try, /*On fail goto*//*Label 19333*/ GIMT_Encode4(1358242), // Rule ID 21954 //
     /* 1358163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1358180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1358219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358241 */     // GIR_Coverage, 21954,
     /* 1358241 */     GIR_EraseRootFromParent_Done,
     /* 1358242 */   // Label 19333: @1358242
     /* 1358242 */   GIM_Try, /*On fail goto*//*Label 19334*/ GIMT_Encode4(1358326), // Rule ID 21955 //
     /* 1358247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1358264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF8_E8_MASK),
     /* 1358303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358325 */     // GIR_Coverage, 21955,
     /* 1358325 */     GIR_EraseRootFromParent_Done,
     /* 1358326 */   // Label 19334: @1358326
     /* 1358326 */   GIM_Try, /*On fail goto*//*Label 19335*/ GIMT_Encode4(1358410), // Rule ID 21958 //
     /* 1358331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1358348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358384 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1358387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358409 */     // GIR_Coverage, 21958,
     /* 1358409 */     GIR_EraseRootFromParent_Done,
     /* 1358410 */   // Label 19335: @1358410
     /* 1358410 */   GIM_Try, /*On fail goto*//*Label 19336*/ GIMT_Encode4(1358494), // Rule ID 21959 //
     /* 1358415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1358432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358468 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E8_MASK),
     /* 1358471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358493 */     // GIR_Coverage, 21959,
     /* 1358493 */     GIR_EraseRootFromParent_Done,
     /* 1358494 */   // Label 19336: @1358494
     /* 1358494 */   GIM_Try, /*On fail goto*//*Label 19337*/ GIMT_Encode4(1358578), // Rule ID 21962 //
     /* 1358499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1358516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358552 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1358555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358577 */     // GIR_Coverage, 21962,
     /* 1358577 */     GIR_EraseRootFromParent_Done,
     /* 1358578 */   // Label 19337: @1358578
     /* 1358578 */   GIM_Try, /*On fail goto*//*Label 19338*/ GIMT_Encode4(1358662), // Rule ID 21963 //
     /* 1358583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1358594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1358597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1358600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1358603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1358606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358636 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E8_MASK),
     /* 1358639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1358657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358661 */     // GIR_Coverage, 21963,
     /* 1358661 */     GIR_EraseRootFromParent_Done,
     /* 1358662 */   // Label 19338: @1358662
     /* 1358662 */   GIM_Try, /*On fail goto*//*Label 19339*/ GIMT_Encode4(1358746), // Rule ID 21966 //
     /* 1358667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1358684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1358723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358745 */     // GIR_Coverage, 21966,
     /* 1358745 */     GIR_EraseRootFromParent_Done,
     /* 1358746 */   // Label 19339: @1358746
     /* 1358746 */   GIM_Try, /*On fail goto*//*Label 19340*/ GIMT_Encode4(1358830), // Rule ID 21967 //
     /* 1358751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1358768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1358774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF4_E16_MASK),
     /* 1358807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358829 */     // GIR_Coverage, 21967,
     /* 1358829 */     GIR_EraseRootFromParent_Done,
     /* 1358830 */   // Label 19340: @1358830
     /* 1358830 */   GIM_Try, /*On fail goto*//*Label 19341*/ GIMT_Encode4(1358914), // Rule ID 21970 //
     /* 1358835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1358838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1358852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1358861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1358888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1358891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358913 */     // GIR_Coverage, 21970,
     /* 1358913 */     GIR_EraseRootFromParent_Done,
     /* 1358914 */   // Label 19341: @1358914
     /* 1358914 */   GIM_Try, /*On fail goto*//*Label 19342*/ GIMT_Encode4(1358998), // Rule ID 21971 //
     /* 1358919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1358922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1358927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1358930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1358933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1358936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1358939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1358942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1358945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1358949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1358961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1358965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1358972 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1358972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E16_MASK),
     /* 1358975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1358977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1358979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1358981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1358983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1358985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1358990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1358993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1358996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1358997 */     // GIR_Coverage, 21971,
     /* 1358997 */     GIR_EraseRootFromParent_Done,
     /* 1358998 */   // Label 19342: @1358998
     /* 1358998 */   GIM_Try, /*On fail goto*//*Label 19343*/ GIMT_Encode4(1359082), // Rule ID 21974 //
     /* 1359003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1359020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359056 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1359059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359081 */     // GIR_Coverage, 21974,
     /* 1359081 */     GIR_EraseRootFromParent_Done,
     /* 1359082 */   // Label 19343: @1359082
     /* 1359082 */   GIM_Try, /*On fail goto*//*Label 19344*/ GIMT_Encode4(1359166), // Rule ID 21975 //
     /* 1359087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1359104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359140 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_MF2_E32_MASK),
     /* 1359143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359165 */     // GIR_Coverage, 21975,
     /* 1359165 */     GIR_EraseRootFromParent_Done,
     /* 1359166 */   // Label 19344: @1359166
     /* 1359166 */   GIM_Try, /*On fail goto*//*Label 19345*/ GIMT_Encode4(1359250), // Rule ID 21978 //
     /* 1359171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1359188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1359227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359249 */     // GIR_Coverage, 21978,
     /* 1359249 */     GIR_EraseRootFromParent_Done,
     /* 1359250 */   // Label 19345: @1359250
     /* 1359250 */   GIM_Try, /*On fail goto*//*Label 19346*/ GIMT_Encode4(1359334), // Rule ID 21979 //
     /* 1359255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1359272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1359278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E8_MASK),
     /* 1359311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359333 */     // GIR_Coverage, 21979,
     /* 1359333 */     GIR_EraseRootFromParent_Done,
     /* 1359334 */   // Label 19346: @1359334
     /* 1359334 */   GIM_Try, /*On fail goto*//*Label 19347*/ GIMT_Encode4(1359418), // Rule ID 21982 //
     /* 1359339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1359356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1359395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359417 */     // GIR_Coverage, 21982,
     /* 1359417 */     GIR_EraseRootFromParent_Done,
     /* 1359418 */   // Label 19347: @1359418
     /* 1359418 */   GIM_Try, /*On fail goto*//*Label 19348*/ GIMT_Encode4(1359502), // Rule ID 21983 //
     /* 1359423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1359434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1359437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1359440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1359443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1359446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359476 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E16_MASK),
     /* 1359479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1359497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359501 */     // GIR_Coverage, 21983,
     /* 1359501 */     GIR_EraseRootFromParent_Done,
     /* 1359502 */   // Label 19348: @1359502
     /* 1359502 */   GIM_Try, /*On fail goto*//*Label 19349*/ GIMT_Encode4(1359586), // Rule ID 21986 //
     /* 1359507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1359524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359560 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1359563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359585 */     // GIR_Coverage, 21986,
     /* 1359585 */     GIR_EraseRootFromParent_Done,
     /* 1359586 */   // Label 19349: @1359586
     /* 1359586 */   GIM_Try, /*On fail goto*//*Label 19350*/ GIMT_Encode4(1359670), // Rule ID 21987 //
     /* 1359591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1359602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1359605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1359608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1359611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1359614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E32_MASK),
     /* 1359647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1359665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359669 */     // GIR_Coverage, 21987,
     /* 1359669 */     GIR_EraseRootFromParent_Done,
     /* 1359670 */   // Label 19350: @1359670
     /* 1359670 */   GIM_Try, /*On fail goto*//*Label 19351*/ GIMT_Encode4(1359754), // Rule ID 21990 //
     /* 1359675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1359678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1359686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1359689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1359692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1359695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359728 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1359731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1359749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359753 */     // GIR_Coverage, 21990,
     /* 1359753 */     GIR_EraseRootFromParent_Done,
     /* 1359754 */   // Label 19351: @1359754
     /* 1359754 */   GIM_Try, /*On fail goto*//*Label 19352*/ GIMT_Encode4(1359838), // Rule ID 21991 //
     /* 1359759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1359762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1359770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1359773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1359776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1359779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1359782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359812 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M1_E64_MASK),
     /* 1359815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1359833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359837 */     // GIR_Coverage, 21991,
     /* 1359837 */     GIR_EraseRootFromParent_Done,
     /* 1359838 */   // Label 19352: @1359838
     /* 1359838 */   GIM_Try, /*On fail goto*//*Label 19353*/ GIMT_Encode4(1359922), // Rule ID 21994 //
     /* 1359843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1359846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1359860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1359869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1359896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1359899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1359917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1359920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1359921 */     // GIR_Coverage, 21994,
     /* 1359921 */     GIR_EraseRootFromParent_Done,
     /* 1359922 */   // Label 19353: @1359922
     /* 1359922 */   GIM_Try, /*On fail goto*//*Label 19354*/ GIMT_Encode4(1360006), // Rule ID 21995 //
     /* 1359927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1359930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1359935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1359938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1359941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1359944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1359947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1359950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1359953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1359957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1359965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1359969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1359973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1359980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1359980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E8_MASK),
     /* 1359983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1359985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1359987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1359989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1359991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1359993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1359998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360005 */     // GIR_Coverage, 21995,
     /* 1360005 */     GIR_EraseRootFromParent_Done,
     /* 1360006 */   // Label 19354: @1360006
     /* 1360006 */   GIM_Try, /*On fail goto*//*Label 19355*/ GIMT_Encode4(1360090), // Rule ID 21998 //
     /* 1360011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1360028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360064 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1360067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360089 */     // GIR_Coverage, 21998,
     /* 1360089 */     GIR_EraseRootFromParent_Done,
     /* 1360090 */   // Label 19355: @1360090
     /* 1360090 */   GIM_Try, /*On fail goto*//*Label 19356*/ GIMT_Encode4(1360174), // Rule ID 21999 //
     /* 1360095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1360112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E8_MASK),
     /* 1360151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360173 */     // GIR_Coverage, 21999,
     /* 1360173 */     GIR_EraseRootFromParent_Done,
     /* 1360174 */   // Label 19356: @1360174
     /* 1360174 */   GIM_Try, /*On fail goto*//*Label 19357*/ GIMT_Encode4(1360258), // Rule ID 22002 //
     /* 1360179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1360196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1360202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1360235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360257 */     // GIR_Coverage, 22002,
     /* 1360257 */     GIR_EraseRootFromParent_Done,
     /* 1360258 */   // Label 19357: @1360258
     /* 1360258 */   GIM_Try, /*On fail goto*//*Label 19358*/ GIMT_Encode4(1360342), // Rule ID 22003 //
     /* 1360263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1360274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1360277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1360280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1360283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1360286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360316 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11429:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E8_MASK),
     /* 1360319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1360337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360341 */     // GIR_Coverage, 22003,
     /* 1360341 */     GIR_EraseRootFromParent_Done,
     /* 1360342 */   // Label 19358: @1360342
     /* 1360342 */   GIM_Try, /*On fail goto*//*Label 19359*/ GIMT_Encode4(1360426), // Rule ID 22006 //
     /* 1360347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1360364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360400 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1360403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360425 */     // GIR_Coverage, 22006,
     /* 1360425 */     GIR_EraseRootFromParent_Done,
     /* 1360426 */   // Label 19359: @1360426
     /* 1360426 */   GIM_Try, /*On fail goto*//*Label 19360*/ GIMT_Encode4(1360510), // Rule ID 22007 //
     /* 1360431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1360448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1360454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360484 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E16_MASK),
     /* 1360487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360509 */     // GIR_Coverage, 22007,
     /* 1360509 */     GIR_EraseRootFromParent_Done,
     /* 1360510 */   // Label 19360: @1360510
     /* 1360510 */   GIM_Try, /*On fail goto*//*Label 19361*/ GIMT_Encode4(1360594), // Rule ID 22010 //
     /* 1360515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1360532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1360571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360593 */     // GIR_Coverage, 22010,
     /* 1360593 */     GIR_EraseRootFromParent_Done,
     /* 1360594 */   // Label 19361: @1360594
     /* 1360594 */   GIM_Try, /*On fail goto*//*Label 19362*/ GIMT_Encode4(1360678), // Rule ID 22011 //
     /* 1360599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1360616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1360622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1360637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E16_MASK),
     /* 1360655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360677 */     // GIR_Coverage, 22011,
     /* 1360677 */     GIR_EraseRootFromParent_Done,
     /* 1360678 */   // Label 19362: @1360678
     /* 1360678 */   GIM_Try, /*On fail goto*//*Label 19363*/ GIMT_Encode4(1360762), // Rule ID 22014 //
     /* 1360683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1360700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360736 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1360739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360761 */     // GIR_Coverage, 22014,
     /* 1360761 */     GIR_EraseRootFromParent_Done,
     /* 1360762 */   // Label 19363: @1360762
     /* 1360762 */   GIM_Try, /*On fail goto*//*Label 19364*/ GIMT_Encode4(1360846), // Rule ID 22015 //
     /* 1360767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1360778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1360781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1360784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1360787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1360790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1360805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360820 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11429:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E16_MASK),
     /* 1360823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1360841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360845 */     // GIR_Coverage, 22015,
     /* 1360845 */     GIR_EraseRootFromParent_Done,
     /* 1360846 */   // Label 19364: @1360846
     /* 1360846 */   GIM_Try, /*On fail goto*//*Label 19365*/ GIMT_Encode4(1360930), // Rule ID 22018 //
     /* 1360851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1360854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1360862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1360865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1360868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1360871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1360877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1360904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1360907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1360917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1360922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1360925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1360928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1360929 */     // GIR_Coverage, 22018,
     /* 1360929 */     GIR_EraseRootFromParent_Done,
     /* 1360930 */   // Label 19365: @1360930
     /* 1360930 */   GIM_Try, /*On fail goto*//*Label 19366*/ GIMT_Encode4(1361014), // Rule ID 22019 //
     /* 1360935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1360938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1360943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1360946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1360949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1360952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1360955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1360958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1360961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1360965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1360973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1360977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1360981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1360988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1360988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E32_MASK),
     /* 1360991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1360993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1360995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1360997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1360999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361013 */     // GIR_Coverage, 22019,
     /* 1361013 */     GIR_EraseRootFromParent_Done,
     /* 1361014 */   // Label 19366: @1361014
     /* 1361014 */   GIM_Try, /*On fail goto*//*Label 19367*/ GIMT_Encode4(1361098), // Rule ID 22022 //
     /* 1361019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1361036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361072 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1361075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361097 */     // GIR_Coverage, 22022,
     /* 1361097 */     GIR_EraseRootFromParent_Done,
     /* 1361098 */   // Label 19367: @1361098
     /* 1361098 */   GIM_Try, /*On fail goto*//*Label 19368*/ GIMT_Encode4(1361182), // Rule ID 22023 //
     /* 1361103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1361120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E32_MASK),
     /* 1361159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361181 */     // GIR_Coverage, 22023,
     /* 1361181 */     GIR_EraseRootFromParent_Done,
     /* 1361182 */   // Label 19368: @1361182
     /* 1361182 */   GIM_Try, /*On fail goto*//*Label 19369*/ GIMT_Encode4(1361266), // Rule ID 22026 //
     /* 1361187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1361204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1361243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361265 */     // GIR_Coverage, 22026,
     /* 1361265 */     GIR_EraseRootFromParent_Done,
     /* 1361266 */   // Label 19369: @1361266
     /* 1361266 */   GIM_Try, /*On fail goto*//*Label 19370*/ GIMT_Encode4(1361350), // Rule ID 22027 //
     /* 1361271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1361282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1361285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1361288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1361291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1361294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11429:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E32_MASK),
     /* 1361327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1361345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361349 */     // GIR_Coverage, 22027,
     /* 1361349 */     GIR_EraseRootFromParent_Done,
     /* 1361350 */   // Label 19370: @1361350
     /* 1361350 */   GIM_Try, /*On fail goto*//*Label 19371*/ GIMT_Encode4(1361434), // Rule ID 22030 //
     /* 1361355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1361358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1361372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361408 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1361411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361433 */     // GIR_Coverage, 22030,
     /* 1361433 */     GIR_EraseRootFromParent_Done,
     /* 1361434 */   // Label 19371: @1361434
     /* 1361434 */   GIM_Try, /*On fail goto*//*Label 19372*/ GIMT_Encode4(1361518), // Rule ID 22031 //
     /* 1361439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1361442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1361456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1361462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1361477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M2_E64_MASK),
     /* 1361495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361517 */     // GIR_Coverage, 22031,
     /* 1361517 */     GIR_EraseRootFromParent_Done,
     /* 1361518 */   // Label 19372: @1361518
     /* 1361518 */   GIM_Try, /*On fail goto*//*Label 19373*/ GIMT_Encode4(1361602), // Rule ID 22034 //
     /* 1361523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1361526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1361579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361601 */     // GIR_Coverage, 22034,
     /* 1361601 */     GIR_EraseRootFromParent_Done,
     /* 1361602 */   // Label 19373: @1361602
     /* 1361602 */   GIM_Try, /*On fail goto*//*Label 19374*/ GIMT_Encode4(1361686), // Rule ID 22035 //
     /* 1361607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1361610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1361624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1361630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1361645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361660 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M4_E64_MASK),
     /* 1361663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361685 */     // GIR_Coverage, 22035,
     /* 1361685 */     GIR_EraseRootFromParent_Done,
     /* 1361686 */   // Label 19374: @1361686
     /* 1361686 */   GIM_Try, /*On fail goto*//*Label 19375*/ GIMT_Encode4(1361770), // Rule ID 22038 //
     /* 1361691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1361694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361744 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1361747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361769 */     // GIR_Coverage, 22038,
     /* 1361769 */     GIR_EraseRootFromParent_Done,
     /* 1361770 */   // Label 19375: @1361770
     /* 1361770 */   GIM_Try, /*On fail goto*//*Label 19376*/ GIMT_Encode4(1361854), // Rule ID 22039 //
     /* 1361775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1361778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredand_mask),
     /* 1361783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1361786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1361789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1361792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1361795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1361798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1361813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361828 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11429:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDAND_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDAND_VS_M8_E64_MASK),
     /* 1361831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1361849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361853 */     // GIR_Coverage, 22039,
     /* 1361853 */     GIR_EraseRootFromParent_Done,
     /* 1361854 */   // Label 19376: @1361854
     /* 1361854 */   GIM_Try, /*On fail goto*//*Label 19377*/ GIMT_Encode4(1361938), // Rule ID 22042 //
     /* 1361859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1361862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1361867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1361876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1361885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361912 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1361912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1361915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1361917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1361919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1361921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1361923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1361925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1361930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1361933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1361936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1361937 */     // GIR_Coverage, 22042,
     /* 1361937 */     GIR_EraseRootFromParent_Done,
     /* 1361938 */   // Label 19377: @1361938
     /* 1361938 */   GIM_Try, /*On fail goto*//*Label 19378*/ GIMT_Encode4(1362022), // Rule ID 22043 //
     /* 1361943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1361946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1361951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1361954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1361957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1361960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1361963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1361966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1361969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1361973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1361985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1361989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1361996 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1361996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF8_E8_MASK),
     /* 1361999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362021 */     // GIR_Coverage, 22043,
     /* 1362021 */     GIR_EraseRootFromParent_Done,
     /* 1362022 */   // Label 19378: @1362022
     /* 1362022 */   GIM_Try, /*On fail goto*//*Label 19379*/ GIMT_Encode4(1362106), // Rule ID 22046 //
     /* 1362027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1362044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362080 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1362083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362105 */     // GIR_Coverage, 22046,
     /* 1362105 */     GIR_EraseRootFromParent_Done,
     /* 1362106 */   // Label 19379: @1362106
     /* 1362106 */   GIM_Try, /*On fail goto*//*Label 19380*/ GIMT_Encode4(1362190), // Rule ID 22047 //
     /* 1362111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1362128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362164 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E8_MASK),
     /* 1362167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362189 */     // GIR_Coverage, 22047,
     /* 1362189 */     GIR_EraseRootFromParent_Done,
     /* 1362190 */   // Label 19380: @1362190
     /* 1362190 */   GIM_Try, /*On fail goto*//*Label 19381*/ GIMT_Encode4(1362274), // Rule ID 22050 //
     /* 1362195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1362212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362248 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1362251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362273 */     // GIR_Coverage, 22050,
     /* 1362273 */     GIR_EraseRootFromParent_Done,
     /* 1362274 */   // Label 19381: @1362274
     /* 1362274 */   GIM_Try, /*On fail goto*//*Label 19382*/ GIMT_Encode4(1362358), // Rule ID 22051 //
     /* 1362279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1362296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1362302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362332 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E8_MASK),
     /* 1362335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362357 */     // GIR_Coverage, 22051,
     /* 1362357 */     GIR_EraseRootFromParent_Done,
     /* 1362358 */   // Label 19382: @1362358
     /* 1362358 */   GIM_Try, /*On fail goto*//*Label 19383*/ GIMT_Encode4(1362442), // Rule ID 22054 //
     /* 1362363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362416 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1362419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362441 */     // GIR_Coverage, 22054,
     /* 1362441 */     GIR_EraseRootFromParent_Done,
     /* 1362442 */   // Label 19383: @1362442
     /* 1362442 */   GIM_Try, /*On fail goto*//*Label 19384*/ GIMT_Encode4(1362526), // Rule ID 22055 //
     /* 1362447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1362464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF4_E16_MASK),
     /* 1362503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362525 */     // GIR_Coverage, 22055,
     /* 1362525 */     GIR_EraseRootFromParent_Done,
     /* 1362526 */   // Label 19384: @1362526
     /* 1362526 */   GIM_Try, /*On fail goto*//*Label 19385*/ GIMT_Encode4(1362610), // Rule ID 22058 //
     /* 1362531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1362587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362609 */     // GIR_Coverage, 22058,
     /* 1362609 */     GIR_EraseRootFromParent_Done,
     /* 1362610 */   // Label 19385: @1362610
     /* 1362610 */   GIM_Try, /*On fail goto*//*Label 19386*/ GIMT_Encode4(1362694), // Rule ID 22059 //
     /* 1362615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1362626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1362629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1362632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1362635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1362638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362668 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E16_MASK),
     /* 1362671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1362689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362693 */     // GIR_Coverage, 22059,
     /* 1362693 */     GIR_EraseRootFromParent_Done,
     /* 1362694 */   // Label 19386: @1362694
     /* 1362694 */   GIM_Try, /*On fail goto*//*Label 19387*/ GIMT_Encode4(1362778), // Rule ID 22062 //
     /* 1362699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1362755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362777 */     // GIR_Coverage, 22062,
     /* 1362777 */     GIR_EraseRootFromParent_Done,
     /* 1362778 */   // Label 19387: @1362778
     /* 1362778 */   GIM_Try, /*On fail goto*//*Label 19388*/ GIMT_Encode4(1362862), // Rule ID 22063 //
     /* 1362783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1362794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1362797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1362800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1362803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1362806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1362836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_MF2_E32_MASK),
     /* 1362839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1362857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362861 */     // GIR_Coverage, 22063,
     /* 1362861 */     GIR_EraseRootFromParent_Done,
     /* 1362862 */   // Label 19388: @1362862
     /* 1362862 */   GIM_Try, /*On fail goto*//*Label 19389*/ GIMT_Encode4(1362946), // Rule ID 22066 //
     /* 1362867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1362870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1362893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1362920 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1362920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1362923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1362925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1362927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1362929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1362931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1362933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1362938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1362941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1362944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1362945 */     // GIR_Coverage, 22066,
     /* 1362945 */     GIR_EraseRootFromParent_Done,
     /* 1362946 */   // Label 19389: @1362946
     /* 1362946 */   GIM_Try, /*On fail goto*//*Label 19390*/ GIMT_Encode4(1363030), // Rule ID 22067 //
     /* 1362951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1362954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1362959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1362962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1362965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1362968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1362971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1362974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1362977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1362981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1362993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1362997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E8_MASK),
     /* 1363007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363029 */     // GIR_Coverage, 22067,
     /* 1363029 */     GIR_EraseRootFromParent_Done,
     /* 1363030 */   // Label 19390: @1363030
     /* 1363030 */   GIM_Try, /*On fail goto*//*Label 19391*/ GIMT_Encode4(1363114), // Rule ID 22070 //
     /* 1363035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1363052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1363091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363113 */     // GIR_Coverage, 22070,
     /* 1363113 */     GIR_EraseRootFromParent_Done,
     /* 1363114 */   // Label 19391: @1363114
     /* 1363114 */   GIM_Try, /*On fail goto*//*Label 19392*/ GIMT_Encode4(1363198), // Rule ID 22071 //
     /* 1363119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1363130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1363133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1363136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1363139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1363142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E16_MASK),
     /* 1363175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1363193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363197 */     // GIR_Coverage, 22071,
     /* 1363197 */     GIR_EraseRootFromParent_Done,
     /* 1363198 */   // Label 19392: @1363198
     /* 1363198 */   GIM_Try, /*On fail goto*//*Label 19393*/ GIMT_Encode4(1363282), // Rule ID 22074 //
     /* 1363203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1363220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363256 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1363259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363281 */     // GIR_Coverage, 22074,
     /* 1363281 */     GIR_EraseRootFromParent_Done,
     /* 1363282 */   // Label 19393: @1363282
     /* 1363282 */   GIM_Try, /*On fail goto*//*Label 19394*/ GIMT_Encode4(1363366), // Rule ID 22075 //
     /* 1363287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1363298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1363301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1363304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1363307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1363310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363340 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E32_MASK),
     /* 1363343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1363361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363365 */     // GIR_Coverage, 22075,
     /* 1363365 */     GIR_EraseRootFromParent_Done,
     /* 1363366 */   // Label 19394: @1363366
     /* 1363366 */   GIM_Try, /*On fail goto*//*Label 19395*/ GIMT_Encode4(1363450), // Rule ID 22078 //
     /* 1363371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1363374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363424 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1363427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363449 */     // GIR_Coverage, 22078,
     /* 1363449 */     GIR_EraseRootFromParent_Done,
     /* 1363450 */   // Label 19395: @1363450
     /* 1363450 */   GIM_Try, /*On fail goto*//*Label 19396*/ GIMT_Encode4(1363534), // Rule ID 22079 //
     /* 1363455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1363458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1363466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1363469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1363472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1363475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1363478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M1_E64_MASK),
     /* 1363511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1363529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363533 */     // GIR_Coverage, 22079,
     /* 1363533 */     GIR_EraseRootFromParent_Done,
     /* 1363534 */   // Label 19396: @1363534
     /* 1363534 */   GIM_Try, /*On fail goto*//*Label 19397*/ GIMT_Encode4(1363618), // Rule ID 22082 //
     /* 1363539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1363595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363617 */     // GIR_Coverage, 22082,
     /* 1363617 */     GIR_EraseRootFromParent_Done,
     /* 1363618 */   // Label 19397: @1363618
     /* 1363618 */   GIM_Try, /*On fail goto*//*Label 19398*/ GIMT_Encode4(1363702), // Rule ID 22083 //
     /* 1363623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1363640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1363646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1363661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363676 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E8_MASK),
     /* 1363679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363701 */     // GIR_Coverage, 22083,
     /* 1363701 */     GIR_EraseRootFromParent_Done,
     /* 1363702 */   // Label 19398: @1363702
     /* 1363702 */   GIM_Try, /*On fail goto*//*Label 19399*/ GIMT_Encode4(1363786), // Rule ID 22086 //
     /* 1363707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1363763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363785 */     // GIR_Coverage, 22086,
     /* 1363785 */     GIR_EraseRootFromParent_Done,
     /* 1363786 */   // Label 19399: @1363786
     /* 1363786 */   GIM_Try, /*On fail goto*//*Label 19400*/ GIMT_Encode4(1363870), // Rule ID 22087 //
     /* 1363791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1363808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1363814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1363829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1363844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E8_MASK),
     /* 1363847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363869 */     // GIR_Coverage, 22087,
     /* 1363869 */     GIR_EraseRootFromParent_Done,
     /* 1363870 */   // Label 19400: @1363870
     /* 1363870 */   GIM_Try, /*On fail goto*//*Label 19401*/ GIMT_Encode4(1363954), // Rule ID 22090 //
     /* 1363875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1363878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1363901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1363921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1363928 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1363928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1363931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1363933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1363935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1363937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1363939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1363941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1363946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1363949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1363952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1363953 */     // GIR_Coverage, 22090,
     /* 1363953 */     GIR_EraseRootFromParent_Done,
     /* 1363954 */   // Label 19401: @1363954
     /* 1363954 */   GIM_Try, /*On fail goto*//*Label 19402*/ GIMT_Encode4(1364038), // Rule ID 22091 //
     /* 1363959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1363962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1363967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1363970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1363973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1363976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1363979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1363982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1363985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1363989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1363993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1363997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364012 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11439:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E8_MASK),
     /* 1364015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1364033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364037 */     // GIR_Coverage, 22091,
     /* 1364037 */     GIR_EraseRootFromParent_Done,
     /* 1364038 */   // Label 19402: @1364038
     /* 1364038 */   GIM_Try, /*On fail goto*//*Label 19403*/ GIMT_Encode4(1364122), // Rule ID 22094 //
     /* 1364043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1364060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1364099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364121 */     // GIR_Coverage, 22094,
     /* 1364121 */     GIR_EraseRootFromParent_Done,
     /* 1364122 */   // Label 19403: @1364122
     /* 1364122 */   GIM_Try, /*On fail goto*//*Label 19404*/ GIMT_Encode4(1364206), // Rule ID 22095 //
     /* 1364127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1364144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E16_MASK),
     /* 1364183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364205 */     // GIR_Coverage, 22095,
     /* 1364205 */     GIR_EraseRootFromParent_Done,
     /* 1364206 */   // Label 19404: @1364206
     /* 1364206 */   GIM_Try, /*On fail goto*//*Label 19405*/ GIMT_Encode4(1364290), // Rule ID 22098 //
     /* 1364211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1364228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364264 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1364267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364289 */     // GIR_Coverage, 22098,
     /* 1364289 */     GIR_EraseRootFromParent_Done,
     /* 1364290 */   // Label 19405: @1364290
     /* 1364290 */   GIM_Try, /*On fail goto*//*Label 19406*/ GIMT_Encode4(1364374), // Rule ID 22099 //
     /* 1364295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1364312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364348 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E16_MASK),
     /* 1364351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364373 */     // GIR_Coverage, 22099,
     /* 1364373 */     GIR_EraseRootFromParent_Done,
     /* 1364374 */   // Label 19406: @1364374
     /* 1364374 */   GIM_Try, /*On fail goto*//*Label 19407*/ GIMT_Encode4(1364458), // Rule ID 22102 //
     /* 1364379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364432 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1364435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364457 */     // GIR_Coverage, 22102,
     /* 1364457 */     GIR_EraseRootFromParent_Done,
     /* 1364458 */   // Label 19407: @1364458
     /* 1364458 */   GIM_Try, /*On fail goto*//*Label 19408*/ GIMT_Encode4(1364542), // Rule ID 22103 //
     /* 1364463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1364474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1364477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1364480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1364483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1364486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11439:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E16_MASK),
     /* 1364519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1364537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364541 */     // GIR_Coverage, 22103,
     /* 1364541 */     GIR_EraseRootFromParent_Done,
     /* 1364542 */   // Label 19408: @1364542
     /* 1364542 */   GIM_Try, /*On fail goto*//*Label 19409*/ GIMT_Encode4(1364626), // Rule ID 22106 //
     /* 1364547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1364603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364625 */     // GIR_Coverage, 22106,
     /* 1364625 */     GIR_EraseRootFromParent_Done,
     /* 1364626 */   // Label 19409: @1364626
     /* 1364626 */   GIM_Try, /*On fail goto*//*Label 19410*/ GIMT_Encode4(1364710), // Rule ID 22107 //
     /* 1364631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1364648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1364654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1364669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E32_MASK),
     /* 1364687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364709 */     // GIR_Coverage, 22107,
     /* 1364709 */     GIR_EraseRootFromParent_Done,
     /* 1364710 */   // Label 19410: @1364710
     /* 1364710 */   GIM_Try, /*On fail goto*//*Label 19411*/ GIMT_Encode4(1364794), // Rule ID 22110 //
     /* 1364715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1364771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364793 */     // GIR_Coverage, 22110,
     /* 1364793 */     GIR_EraseRootFromParent_Done,
     /* 1364794 */   // Label 19411: @1364794
     /* 1364794 */   GIM_Try, /*On fail goto*//*Label 19412*/ GIMT_Encode4(1364878), // Rule ID 22111 //
     /* 1364799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1364816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1364822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1364837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1364852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E32_MASK),
     /* 1364855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364877 */     // GIR_Coverage, 22111,
     /* 1364877 */     GIR_EraseRootFromParent_Done,
     /* 1364878 */   // Label 19412: @1364878
     /* 1364878 */   GIM_Try, /*On fail goto*//*Label 19413*/ GIMT_Encode4(1364962), // Rule ID 22114 //
     /* 1364883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1364886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1364909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1364921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1364925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1364929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1364936 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1364936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1364939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1364941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1364943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1364945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1364947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1364949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1364954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1364957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1364960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1364961 */     // GIR_Coverage, 22114,
     /* 1364961 */     GIR_EraseRootFromParent_Done,
     /* 1364962 */   // Label 19413: @1364962
     /* 1364962 */   GIM_Try, /*On fail goto*//*Label 19414*/ GIMT_Encode4(1365046), // Rule ID 22115 //
     /* 1364967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1364970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1364975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1364978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1364981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1364984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1364987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1364990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1364993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1364997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365020 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11439:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E32_MASK),
     /* 1365023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1365041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365045 */     // GIR_Coverage, 22115,
     /* 1365045 */     GIR_EraseRootFromParent_Done,
     /* 1365046 */   // Label 19414: @1365046
     /* 1365046 */   GIM_Try, /*On fail goto*//*Label 19415*/ GIMT_Encode4(1365130), // Rule ID 22118 //
     /* 1365051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1365068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1365107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365129 */     // GIR_Coverage, 22118,
     /* 1365129 */     GIR_EraseRootFromParent_Done,
     /* 1365130 */   // Label 19415: @1365130
     /* 1365130 */   GIM_Try, /*On fail goto*//*Label 19416*/ GIMT_Encode4(1365214), // Rule ID 22119 //
     /* 1365135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1365152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1365173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365188 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M2_E64_MASK),
     /* 1365191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365213 */     // GIR_Coverage, 22119,
     /* 1365213 */     GIR_EraseRootFromParent_Done,
     /* 1365214 */   // Label 19416: @1365214
     /* 1365214 */   GIM_Try, /*On fail goto*//*Label 19417*/ GIMT_Encode4(1365298), // Rule ID 22122 //
     /* 1365219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1365236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365272 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1365275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365297 */     // GIR_Coverage, 22122,
     /* 1365297 */     GIR_EraseRootFromParent_Done,
     /* 1365298 */   // Label 19417: @1365298
     /* 1365298 */   GIM_Try, /*On fail goto*//*Label 19418*/ GIMT_Encode4(1365382), // Rule ID 22123 //
     /* 1365303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1365320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1365341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365356 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M4_E64_MASK),
     /* 1365359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365381 */     // GIR_Coverage, 22123,
     /* 1365381 */     GIR_EraseRootFromParent_Done,
     /* 1365382 */   // Label 19418: @1365382
     /* 1365382 */   GIM_Try, /*On fail goto*//*Label 19419*/ GIMT_Encode4(1365466), // Rule ID 22126 //
     /* 1365387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1365390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1365443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365465 */     // GIR_Coverage, 22126,
     /* 1365465 */     GIR_EraseRootFromParent_Done,
     /* 1365466 */   // Label 19419: @1365466
     /* 1365466 */   GIM_Try, /*On fail goto*//*Label 19420*/ GIMT_Encode4(1365550), // Rule ID 22127 //
     /* 1365471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1365474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredor_mask),
     /* 1365479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1365482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1365485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1365488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1365491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1365494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1365509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365524 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11439:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDOR_VS_M8_E64_MASK),
     /* 1365527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1365545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365549 */     // GIR_Coverage, 22127,
     /* 1365549 */     GIR_EraseRootFromParent_Done,
     /* 1365550 */   // Label 19420: @1365550
     /* 1365550 */   GIM_Try, /*On fail goto*//*Label 19421*/ GIMT_Encode4(1365634), // Rule ID 22130 //
     /* 1365555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365608 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1365611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365633 */     // GIR_Coverage, 22130,
     /* 1365633 */     GIR_EraseRootFromParent_Done,
     /* 1365634 */   // Label 19421: @1365634
     /* 1365634 */   GIM_Try, /*On fail goto*//*Label 19422*/ GIMT_Encode4(1365718), // Rule ID 22131 //
     /* 1365639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1365656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1365662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365692 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF8_E8_MASK),
     /* 1365695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365717 */     // GIR_Coverage, 22131,
     /* 1365717 */     GIR_EraseRootFromParent_Done,
     /* 1365718 */   // Label 19422: @1365718
     /* 1365718 */   GIM_Try, /*On fail goto*//*Label 19423*/ GIMT_Encode4(1365802), // Rule ID 22134 //
     /* 1365723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1365779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365801 */     // GIR_Coverage, 22134,
     /* 1365801 */     GIR_EraseRootFromParent_Done,
     /* 1365802 */   // Label 19423: @1365802
     /* 1365802 */   GIM_Try, /*On fail goto*//*Label 19424*/ GIMT_Encode4(1365886), // Rule ID 22135 //
     /* 1365807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1365824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1365830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1365833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365860 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1365860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E8_MASK),
     /* 1365863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365885 */     // GIR_Coverage, 22135,
     /* 1365885 */     GIR_EraseRootFromParent_Done,
     /* 1365886 */   // Label 19424: @1365886
     /* 1365886 */   GIM_Try, /*On fail goto*//*Label 19425*/ GIMT_Encode4(1365970), // Rule ID 22138 //
     /* 1365891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1365894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1365917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1365921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1365933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1365937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1365944 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1365944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1365947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1365949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1365951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1365953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1365955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1365957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1365962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1365965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1365968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1365969 */     // GIR_Coverage, 22138,
     /* 1365969 */     GIR_EraseRootFromParent_Done,
     /* 1365970 */   // Label 19425: @1365970
     /* 1365970 */   GIM_Try, /*On fail goto*//*Label 19426*/ GIMT_Encode4(1366054), // Rule ID 22139 //
     /* 1365975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1365978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1365983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1365986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1365989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1365992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1365995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1365998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366028 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E8_MASK),
     /* 1366031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366053 */     // GIR_Coverage, 22139,
     /* 1366053 */     GIR_EraseRootFromParent_Done,
     /* 1366054 */   // Label 19426: @1366054
     /* 1366054 */   GIM_Try, /*On fail goto*//*Label 19427*/ GIMT_Encode4(1366138), // Rule ID 22142 //
     /* 1366059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1366076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1366115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366137 */     // GIR_Coverage, 22142,
     /* 1366137 */     GIR_EraseRootFromParent_Done,
     /* 1366138 */   // Label 19427: @1366138
     /* 1366138 */   GIM_Try, /*On fail goto*//*Label 19428*/ GIMT_Encode4(1366222), // Rule ID 22143 //
     /* 1366143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1366160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF4_E16_MASK),
     /* 1366199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366221 */     // GIR_Coverage, 22143,
     /* 1366221 */     GIR_EraseRootFromParent_Done,
     /* 1366222 */   // Label 19428: @1366222
     /* 1366222 */   GIM_Try, /*On fail goto*//*Label 19429*/ GIMT_Encode4(1366306), // Rule ID 22146 //
     /* 1366227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1366244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1366283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366305 */     // GIR_Coverage, 22146,
     /* 1366305 */     GIR_EraseRootFromParent_Done,
     /* 1366306 */   // Label 19429: @1366306
     /* 1366306 */   GIM_Try, /*On fail goto*//*Label 19430*/ GIMT_Encode4(1366390), // Rule ID 22147 //
     /* 1366311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1366328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E16_MASK),
     /* 1366367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366389 */     // GIR_Coverage, 22147,
     /* 1366389 */     GIR_EraseRootFromParent_Done,
     /* 1366390 */   // Label 19430: @1366390
     /* 1366390 */   GIM_Try, /*On fail goto*//*Label 19431*/ GIMT_Encode4(1366474), // Rule ID 22150 //
     /* 1366395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1366451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366473 */     // GIR_Coverage, 22150,
     /* 1366473 */     GIR_EraseRootFromParent_Done,
     /* 1366474 */   // Label 19431: @1366474
     /* 1366474 */   GIM_Try, /*On fail goto*//*Label 19432*/ GIMT_Encode4(1366558), // Rule ID 22151 //
     /* 1366479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1366496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1366502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_MF2_E32_MASK),
     /* 1366535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366557 */     // GIR_Coverage, 22151,
     /* 1366557 */     GIR_EraseRootFromParent_Done,
     /* 1366558 */   // Label 19432: @1366558
     /* 1366558 */   GIM_Try, /*On fail goto*//*Label 19433*/ GIMT_Encode4(1366642), // Rule ID 22154 //
     /* 1366563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366616 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1366619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366641 */     // GIR_Coverage, 22154,
     /* 1366641 */     GIR_EraseRootFromParent_Done,
     /* 1366642 */   // Label 19433: @1366642
     /* 1366642 */   GIM_Try, /*On fail goto*//*Label 19434*/ GIMT_Encode4(1366726), // Rule ID 22155 //
     /* 1366647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1366658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1366661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1366664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1366667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1366670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366700 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E8_MASK),
     /* 1366703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1366721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366725 */     // GIR_Coverage, 22155,
     /* 1366725 */     GIR_EraseRootFromParent_Done,
     /* 1366726 */   // Label 19434: @1366726
     /* 1366726 */   GIM_Try, /*On fail goto*//*Label 19435*/ GIMT_Encode4(1366810), // Rule ID 22158 //
     /* 1366731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366784 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1366787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366809 */     // GIR_Coverage, 22158,
     /* 1366809 */     GIR_EraseRootFromParent_Done,
     /* 1366810 */   // Label 19435: @1366810
     /* 1366810 */   GIM_Try, /*On fail goto*//*Label 19436*/ GIMT_Encode4(1366894), // Rule ID 22159 //
     /* 1366815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1366826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1366829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1366832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1366835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1366838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1366841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366868 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1366868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E16_MASK),
     /* 1366871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1366889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366893 */     // GIR_Coverage, 22159,
     /* 1366893 */     GIR_EraseRootFromParent_Done,
     /* 1366894 */   // Label 19436: @1366894
     /* 1366894 */   GIM_Try, /*On fail goto*//*Label 19437*/ GIMT_Encode4(1366978), // Rule ID 22162 //
     /* 1366899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1366902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1366916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1366919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1366922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1366925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1366929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1366941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1366945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1366952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1366952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1366955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1366957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1366959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1366961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1366963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1366965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1366970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1366973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1366976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1366977 */     // GIR_Coverage, 22162,
     /* 1366977 */     GIR_EraseRootFromParent_Done,
     /* 1366978 */   // Label 19437: @1366978
     /* 1366978 */   GIM_Try, /*On fail goto*//*Label 19438*/ GIMT_Encode4(1367062), // Rule ID 22163 //
     /* 1366983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1366986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1366991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1366994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1366997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1367000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1367003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1367006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367036 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E32_MASK),
     /* 1367039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1367057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367061 */     // GIR_Coverage, 22163,
     /* 1367061 */     GIR_EraseRootFromParent_Done,
     /* 1367062 */   // Label 19438: @1367062
     /* 1367062 */   GIM_Try, /*On fail goto*//*Label 19439*/ GIMT_Encode4(1367146), // Rule ID 22166 //
     /* 1367067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1367070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1367084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1367123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367145 */     // GIR_Coverage, 22166,
     /* 1367145 */     GIR_EraseRootFromParent_Done,
     /* 1367146 */   // Label 19439: @1367146
     /* 1367146 */   GIM_Try, /*On fail goto*//*Label 19440*/ GIMT_Encode4(1367230), // Rule ID 22167 //
     /* 1367151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1367154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1367162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1367165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1367168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1367171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1367174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367204 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M1_E64_MASK),
     /* 1367207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1367225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367229 */     // GIR_Coverage, 22167,
     /* 1367229 */     GIR_EraseRootFromParent_Done,
     /* 1367230 */   // Label 19440: @1367230
     /* 1367230 */   GIM_Try, /*On fail goto*//*Label 19441*/ GIMT_Encode4(1367314), // Rule ID 22170 //
     /* 1367235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1367252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367288 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1367291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367313 */     // GIR_Coverage, 22170,
     /* 1367313 */     GIR_EraseRootFromParent_Done,
     /* 1367314 */   // Label 19441: @1367314
     /* 1367314 */   GIM_Try, /*On fail goto*//*Label 19442*/ GIMT_Encode4(1367398), // Rule ID 22171 //
     /* 1367319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1367336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367372 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E8_MASK),
     /* 1367375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367397 */     // GIR_Coverage, 22171,
     /* 1367397 */     GIR_EraseRootFromParent_Done,
     /* 1367398 */   // Label 19442: @1367398
     /* 1367398 */   GIM_Try, /*On fail goto*//*Label 19443*/ GIMT_Encode4(1367482), // Rule ID 22174 //
     /* 1367403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367456 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1367459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367481 */     // GIR_Coverage, 22174,
     /* 1367481 */     GIR_EraseRootFromParent_Done,
     /* 1367482 */   // Label 19443: @1367482
     /* 1367482 */   GIM_Try, /*On fail goto*//*Label 19444*/ GIMT_Encode4(1367566), // Rule ID 22175 //
     /* 1367487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1367504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1367510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367540 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E8_MASK),
     /* 1367543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367565 */     // GIR_Coverage, 22175,
     /* 1367565 */     GIR_EraseRootFromParent_Done,
     /* 1367566 */   // Label 19444: @1367566
     /* 1367566 */   GIM_Try, /*On fail goto*//*Label 19445*/ GIMT_Encode4(1367650), // Rule ID 22178 //
     /* 1367571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367624 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1367627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367649 */     // GIR_Coverage, 22178,
     /* 1367649 */     GIR_EraseRootFromParent_Done,
     /* 1367650 */   // Label 19445: @1367650
     /* 1367650 */   GIM_Try, /*On fail goto*//*Label 19446*/ GIMT_Encode4(1367734), // Rule ID 22179 //
     /* 1367655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1367666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1367669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1367672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1367675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1367678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1367693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11443:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E8_MASK),
     /* 1367711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1367729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367733 */     // GIR_Coverage, 22179,
     /* 1367733 */     GIR_EraseRootFromParent_Done,
     /* 1367734 */   // Label 19446: @1367734
     /* 1367734 */   GIM_Try, /*On fail goto*//*Label 19447*/ GIMT_Encode4(1367818), // Rule ID 22182 //
     /* 1367739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1367795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367817 */     // GIR_Coverage, 22182,
     /* 1367817 */     GIR_EraseRootFromParent_Done,
     /* 1367818 */   // Label 19447: @1367818
     /* 1367818 */   GIM_Try, /*On fail goto*//*Label 19448*/ GIMT_Encode4(1367902), // Rule ID 22183 //
     /* 1367823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1367840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1367846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1367849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1367861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1367876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E16_MASK),
     /* 1367879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367901 */     // GIR_Coverage, 22183,
     /* 1367901 */     GIR_EraseRootFromParent_Done,
     /* 1367902 */   // Label 19448: @1367902
     /* 1367902 */   GIM_Try, /*On fail goto*//*Label 19449*/ GIMT_Encode4(1367986), // Rule ID 22186 //
     /* 1367907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1367910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1367918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1367921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1367924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1367927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1367930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1367933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1367937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1367945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1367949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1367953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1367960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1367960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1367963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1367965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1367967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1367969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1367971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1367973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1367978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1367981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1367984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1367985 */     // GIR_Coverage, 22186,
     /* 1367985 */     GIR_EraseRootFromParent_Done,
     /* 1367986 */   // Label 19449: @1367986
     /* 1367986 */   GIM_Try, /*On fail goto*//*Label 19450*/ GIMT_Encode4(1368070), // Rule ID 22187 //
     /* 1367991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1367994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1367999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1368008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E16_MASK),
     /* 1368047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368069 */     // GIR_Coverage, 22187,
     /* 1368069 */     GIR_EraseRootFromParent_Done,
     /* 1368070 */   // Label 19450: @1368070
     /* 1368070 */   GIM_Try, /*On fail goto*//*Label 19451*/ GIMT_Encode4(1368154), // Rule ID 22190 //
     /* 1368075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1368092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1368131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368153 */     // GIR_Coverage, 22190,
     /* 1368153 */     GIR_EraseRootFromParent_Done,
     /* 1368154 */   // Label 19451: @1368154
     /* 1368154 */   GIM_Try, /*On fail goto*//*Label 19452*/ GIMT_Encode4(1368238), // Rule ID 22191 //
     /* 1368159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1368170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1368173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1368176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1368179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1368182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368212 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11443:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E16_MASK),
     /* 1368215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1368233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368237 */     // GIR_Coverage, 22191,
     /* 1368237 */     GIR_EraseRootFromParent_Done,
     /* 1368238 */   // Label 19452: @1368238
     /* 1368238 */   GIM_Try, /*On fail goto*//*Label 19453*/ GIMT_Encode4(1368322), // Rule ID 22194 //
     /* 1368243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1368260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1368299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368321 */     // GIR_Coverage, 22194,
     /* 1368321 */     GIR_EraseRootFromParent_Done,
     /* 1368322 */   // Label 19453: @1368322
     /* 1368322 */   GIM_Try, /*On fail goto*//*Label 19454*/ GIMT_Encode4(1368406), // Rule ID 22195 //
     /* 1368327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1368344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E32_MASK),
     /* 1368383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368405 */     // GIR_Coverage, 22195,
     /* 1368405 */     GIR_EraseRootFromParent_Done,
     /* 1368406 */   // Label 19454: @1368406
     /* 1368406 */   GIM_Try, /*On fail goto*//*Label 19455*/ GIMT_Encode4(1368490), // Rule ID 22198 //
     /* 1368411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1368467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368489 */     // GIR_Coverage, 22198,
     /* 1368489 */     GIR_EraseRootFromParent_Done,
     /* 1368490 */   // Label 19455: @1368490
     /* 1368490 */   GIM_Try, /*On fail goto*//*Label 19456*/ GIMT_Encode4(1368574), // Rule ID 22199 //
     /* 1368495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1368512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1368518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E32_MASK),
     /* 1368551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368573 */     // GIR_Coverage, 22199,
     /* 1368573 */     GIR_EraseRootFromParent_Done,
     /* 1368574 */   // Label 19456: @1368574
     /* 1368574 */   GIM_Try, /*On fail goto*//*Label 19457*/ GIMT_Encode4(1368658), // Rule ID 22202 //
     /* 1368579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1368582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368632 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1368635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368657 */     // GIR_Coverage, 22202,
     /* 1368657 */     GIR_EraseRootFromParent_Done,
     /* 1368658 */   // Label 19457: @1368658
     /* 1368658 */   GIM_Try, /*On fail goto*//*Label 19458*/ GIMT_Encode4(1368742), // Rule ID 22203 //
     /* 1368663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1368666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1368674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1368677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1368680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1368683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1368686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1368701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368716 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11443:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E32_MASK),
     /* 1368719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1368737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368741 */     // GIR_Coverage, 22203,
     /* 1368741 */     GIR_EraseRootFromParent_Done,
     /* 1368742 */   // Label 19458: @1368742
     /* 1368742 */   GIM_Try, /*On fail goto*//*Label 19459*/ GIMT_Encode4(1368826), // Rule ID 22206 //
     /* 1368747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1368803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368825 */     // GIR_Coverage, 22206,
     /* 1368825 */     GIR_EraseRootFromParent_Done,
     /* 1368826 */   // Label 19459: @1368826
     /* 1368826 */   GIM_Try, /*On fail goto*//*Label 19460*/ GIMT_Encode4(1368910), // Rule ID 22207 //
     /* 1368831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1368834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1368848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1368854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1368857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1368869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1368884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M2_E64_MASK),
     /* 1368887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368909 */     // GIR_Coverage, 22207,
     /* 1368909 */     GIR_EraseRootFromParent_Done,
     /* 1368910 */   // Label 19460: @1368910
     /* 1368910 */   GIM_Try, /*On fail goto*//*Label 19461*/ GIMT_Encode4(1368994), // Rule ID 22210 //
     /* 1368915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1368918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1368923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1368926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1368929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1368932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1368935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1368938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1368941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1368945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1368953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1368957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1368961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1368968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1368968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1368971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1368973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1368975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1368977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1368979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1368981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1368986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1368989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1368992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1368993 */     // GIR_Coverage, 22210,
     /* 1368993 */     GIR_EraseRootFromParent_Done,
     /* 1368994 */   // Label 19461: @1368994
     /* 1368994 */   GIM_Try, /*On fail goto*//*Label 19462*/ GIMT_Encode4(1369078), // Rule ID 22211 //
     /* 1368999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1369007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1369016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1369037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M4_E64_MASK),
     /* 1369055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369077 */     // GIR_Coverage, 22211,
     /* 1369077 */     GIR_EraseRootFromParent_Done,
     /* 1369078 */   // Label 19462: @1369078
     /* 1369078 */   GIM_Try, /*On fail goto*//*Label 19463*/ GIMT_Encode4(1369162), // Rule ID 22214 //
     /* 1369083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1369086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1369091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1369100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1369139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369161 */     // GIR_Coverage, 22214,
     /* 1369161 */     GIR_EraseRootFromParent_Done,
     /* 1369162 */   // Label 19463: @1369162
     /* 1369162 */   GIM_Try, /*On fail goto*//*Label 19464*/ GIMT_Encode4(1369246), // Rule ID 22215 //
     /* 1369167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1369170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredxor_mask),
     /* 1369175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1369178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1369181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1369184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1369187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1369190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1369205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369220 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11443:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDXOR_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDXOR_VS_M8_E64_MASK),
     /* 1369223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1369241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369245 */     // GIR_Coverage, 22215,
     /* 1369245 */     GIR_EraseRootFromParent_Done,
     /* 1369246 */   // Label 19464: @1369246
     /* 1369246 */   GIM_Try, /*On fail goto*//*Label 19465*/ GIMT_Encode4(1369330), // Rule ID 22218 //
     /* 1369251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1369268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369304 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1369307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369329 */     // GIR_Coverage, 22218,
     /* 1369329 */     GIR_EraseRootFromParent_Done,
     /* 1369330 */   // Label 19465: @1369330
     /* 1369330 */   GIM_Try, /*On fail goto*//*Label 19466*/ GIMT_Encode4(1369414), // Rule ID 22219 //
     /* 1369335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1369352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF8_E8_MASK),
     /* 1369391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369413 */     // GIR_Coverage, 22219,
     /* 1369413 */     GIR_EraseRootFromParent_Done,
     /* 1369414 */   // Label 19466: @1369414
     /* 1369414 */   GIM_Try, /*On fail goto*//*Label 19467*/ GIMT_Encode4(1369498), // Rule ID 22222 //
     /* 1369419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369472 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1369475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369497 */     // GIR_Coverage, 22222,
     /* 1369497 */     GIR_EraseRootFromParent_Done,
     /* 1369498 */   // Label 19467: @1369498
     /* 1369498 */   GIM_Try, /*On fail goto*//*Label 19468*/ GIMT_Encode4(1369582), // Rule ID 22223 //
     /* 1369503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1369520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E8_MASK),
     /* 1369559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369581 */     // GIR_Coverage, 22223,
     /* 1369581 */     GIR_EraseRootFromParent_Done,
     /* 1369582 */   // Label 19468: @1369582
     /* 1369582 */   GIM_Try, /*On fail goto*//*Label 19469*/ GIMT_Encode4(1369666), // Rule ID 22226 //
     /* 1369587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1369643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369665 */     // GIR_Coverage, 22226,
     /* 1369665 */     GIR_EraseRootFromParent_Done,
     /* 1369666 */   // Label 19469: @1369666
     /* 1369666 */   GIM_Try, /*On fail goto*//*Label 19470*/ GIMT_Encode4(1369750), // Rule ID 22227 //
     /* 1369671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1369682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1369685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1369688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1369691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1369694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369724 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E8_MASK),
     /* 1369727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1369745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369749 */     // GIR_Coverage, 22227,
     /* 1369749 */     GIR_EraseRootFromParent_Done,
     /* 1369750 */   // Label 19470: @1369750
     /* 1369750 */   GIM_Try, /*On fail goto*//*Label 19471*/ GIMT_Encode4(1369834), // Rule ID 22230 //
     /* 1369755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369808 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1369811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369833 */     // GIR_Coverage, 22230,
     /* 1369833 */     GIR_EraseRootFromParent_Done,
     /* 1369834 */   // Label 19471: @1369834
     /* 1369834 */   GIM_Try, /*On fail goto*//*Label 19472*/ GIMT_Encode4(1369918), // Rule ID 22231 //
     /* 1369839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1369842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1369856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1369862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1369865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1369892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF4_E16_MASK),
     /* 1369895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1369916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1369917 */     // GIR_Coverage, 22231,
     /* 1369917 */     GIR_EraseRootFromParent_Done,
     /* 1369918 */   // Label 19472: @1369918
     /* 1369918 */   GIM_Try, /*On fail goto*//*Label 19473*/ GIMT_Encode4(1370002), // Rule ID 22234 //
     /* 1369923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1369926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1369931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1369934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1369937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1369940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1369943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1369946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1369949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1369953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1369965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1369969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1369976 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1369976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1369979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1369981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1369983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1369985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1369987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1369989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1369994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1369997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370001 */     // GIR_Coverage, 22234,
     /* 1370001 */     GIR_EraseRootFromParent_Done,
     /* 1370002 */   // Label 19473: @1370002
     /* 1370002 */   GIM_Try, /*On fail goto*//*Label 19474*/ GIMT_Encode4(1370086), // Rule ID 22235 //
     /* 1370007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1370024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370060 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E16_MASK),
     /* 1370063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370085 */     // GIR_Coverage, 22235,
     /* 1370085 */     GIR_EraseRootFromParent_Done,
     /* 1370086 */   // Label 19474: @1370086
     /* 1370086 */   GIM_Try, /*On fail goto*//*Label 19475*/ GIMT_Encode4(1370170), // Rule ID 22238 //
     /* 1370091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1370108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370144 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1370147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370169 */     // GIR_Coverage, 22238,
     /* 1370169 */     GIR_EraseRootFromParent_Done,
     /* 1370170 */   // Label 19475: @1370170
     /* 1370170 */   GIM_Try, /*On fail goto*//*Label 19476*/ GIMT_Encode4(1370254), // Rule ID 22239 //
     /* 1370175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1370192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_MF2_E32_MASK),
     /* 1370231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370253 */     // GIR_Coverage, 22239,
     /* 1370253 */     GIR_EraseRootFromParent_Done,
     /* 1370254 */   // Label 19476: @1370254
     /* 1370254 */   GIM_Try, /*On fail goto*//*Label 19477*/ GIMT_Encode4(1370338), // Rule ID 22242 //
     /* 1370259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1370276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370312 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1370315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370337 */     // GIR_Coverage, 22242,
     /* 1370337 */     GIR_EraseRootFromParent_Done,
     /* 1370338 */   // Label 19477: @1370338
     /* 1370338 */   GIM_Try, /*On fail goto*//*Label 19478*/ GIMT_Encode4(1370422), // Rule ID 22243 //
     /* 1370343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1370360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1370366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370396 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E8_MASK),
     /* 1370399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1370417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370421 */     // GIR_Coverage, 22243,
     /* 1370421 */     GIR_EraseRootFromParent_Done,
     /* 1370422 */   // Label 19478: @1370422
     /* 1370422 */   GIM_Try, /*On fail goto*//*Label 19479*/ GIMT_Encode4(1370506), // Rule ID 22246 //
     /* 1370427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1370483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370505 */     // GIR_Coverage, 22246,
     /* 1370505 */     GIR_EraseRootFromParent_Done,
     /* 1370506 */   // Label 19479: @1370506
     /* 1370506 */   GIM_Try, /*On fail goto*//*Label 19480*/ GIMT_Encode4(1370590), // Rule ID 22247 //
     /* 1370511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1370522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1370525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1370528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1370531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1370534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370564 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E16_MASK),
     /* 1370567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1370585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370589 */     // GIR_Coverage, 22247,
     /* 1370589 */     GIR_EraseRootFromParent_Done,
     /* 1370590 */   // Label 19480: @1370590
     /* 1370590 */   GIM_Try, /*On fail goto*//*Label 19481*/ GIMT_Encode4(1370674), // Rule ID 22250 //
     /* 1370595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1370651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370673 */     // GIR_Coverage, 22250,
     /* 1370673 */     GIR_EraseRootFromParent_Done,
     /* 1370674 */   // Label 19481: @1370674
     /* 1370674 */   GIM_Try, /*On fail goto*//*Label 19482*/ GIMT_Encode4(1370758), // Rule ID 22251 //
     /* 1370679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1370682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1370690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1370693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1370696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1370699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1370702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E32_MASK),
     /* 1370735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1370753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370757 */     // GIR_Coverage, 22251,
     /* 1370757 */     GIR_EraseRootFromParent_Done,
     /* 1370758 */   // Label 19482: @1370758
     /* 1370758 */   GIM_Try, /*On fail goto*//*Label 19483*/ GIMT_Encode4(1370842), // Rule ID 22254 //
     /* 1370763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1370766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1370819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370841 */     // GIR_Coverage, 22254,
     /* 1370841 */     GIR_EraseRootFromParent_Done,
     /* 1370842 */   // Label 19483: @1370842
     /* 1370842 */   GIM_Try, /*On fail goto*//*Label 19484*/ GIMT_Encode4(1370926), // Rule ID 22255 //
     /* 1370847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1370850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1370858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1370861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1370864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1370867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1370870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1370873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1370900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M1_E64_MASK),
     /* 1370903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1370918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1370921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1370924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1370925 */     // GIR_Coverage, 22255,
     /* 1370925 */     GIR_EraseRootFromParent_Done,
     /* 1370926 */   // Label 19484: @1370926
     /* 1370926 */   GIM_Try, /*On fail goto*//*Label 19485*/ GIMT_Encode4(1371010), // Rule ID 22258 //
     /* 1370931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1370934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1370939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1370942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1370945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1370948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1370951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1370954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1370957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1370961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1370969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1370973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1370977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1370984 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1370984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1370987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1370989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1370991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1370993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1370995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1370997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371009 */     // GIR_Coverage, 22258,
     /* 1371009 */     GIR_EraseRootFromParent_Done,
     /* 1371010 */   // Label 19485: @1371010
     /* 1371010 */   GIM_Try, /*On fail goto*//*Label 19486*/ GIMT_Encode4(1371094), // Rule ID 22259 //
     /* 1371015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1371032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371068 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E8_MASK),
     /* 1371071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371093 */     // GIR_Coverage, 22259,
     /* 1371093 */     GIR_EraseRootFromParent_Done,
     /* 1371094 */   // Label 19486: @1371094
     /* 1371094 */   GIM_Try, /*On fail goto*//*Label 19487*/ GIMT_Encode4(1371178), // Rule ID 22262 //
     /* 1371099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1371116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371152 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1371155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371177 */     // GIR_Coverage, 22262,
     /* 1371177 */     GIR_EraseRootFromParent_Done,
     /* 1371178 */   // Label 19487: @1371178
     /* 1371178 */   GIM_Try, /*On fail goto*//*Label 19488*/ GIMT_Encode4(1371262), // Rule ID 22263 //
     /* 1371183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1371200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E8_MASK),
     /* 1371239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371261 */     // GIR_Coverage, 22263,
     /* 1371261 */     GIR_EraseRootFromParent_Done,
     /* 1371262 */   // Label 19488: @1371262
     /* 1371262 */   GIM_Try, /*On fail goto*//*Label 19489*/ GIMT_Encode4(1371346), // Rule ID 22266 //
     /* 1371267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1371284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1371290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371320 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1371323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371345 */     // GIR_Coverage, 22266,
     /* 1371345 */     GIR_EraseRootFromParent_Done,
     /* 1371346 */   // Label 19489: @1371346
     /* 1371346 */   GIM_Try, /*On fail goto*//*Label 19490*/ GIMT_Encode4(1371430), // Rule ID 22267 //
     /* 1371351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1371362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1371365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1371368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1371371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1371374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371404 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11437:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E8_MASK),
     /* 1371407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1371425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371429 */     // GIR_Coverage, 22267,
     /* 1371429 */     GIR_EraseRootFromParent_Done,
     /* 1371430 */   // Label 19490: @1371430
     /* 1371430 */   GIM_Try, /*On fail goto*//*Label 19491*/ GIMT_Encode4(1371514), // Rule ID 22270 //
     /* 1371435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371488 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1371491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371513 */     // GIR_Coverage, 22270,
     /* 1371513 */     GIR_EraseRootFromParent_Done,
     /* 1371514 */   // Label 19491: @1371514
     /* 1371514 */   GIM_Try, /*On fail goto*//*Label 19492*/ GIMT_Encode4(1371598), // Rule ID 22271 //
     /* 1371519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1371536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1371542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E16_MASK),
     /* 1371575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371597 */     // GIR_Coverage, 22271,
     /* 1371597 */     GIR_EraseRootFromParent_Done,
     /* 1371598 */   // Label 19492: @1371598
     /* 1371598 */   GIM_Try, /*On fail goto*//*Label 19493*/ GIMT_Encode4(1371682), // Rule ID 22274 //
     /* 1371603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371656 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1371659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371681 */     // GIR_Coverage, 22274,
     /* 1371681 */     GIR_EraseRootFromParent_Done,
     /* 1371682 */   // Label 19493: @1371682
     /* 1371682 */   GIM_Try, /*On fail goto*//*Label 19494*/ GIMT_Encode4(1371766), // Rule ID 22275 //
     /* 1371687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1371704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1371710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1371725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371740 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E16_MASK),
     /* 1371743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371765 */     // GIR_Coverage, 22275,
     /* 1371765 */     GIR_EraseRootFromParent_Done,
     /* 1371766 */   // Label 19494: @1371766
     /* 1371766 */   GIM_Try, /*On fail goto*//*Label 19495*/ GIMT_Encode4(1371850), // Rule ID 22278 //
     /* 1371771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1371827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371849 */     // GIR_Coverage, 22278,
     /* 1371849 */     GIR_EraseRootFromParent_Done,
     /* 1371850 */   // Label 19495: @1371850
     /* 1371850 */   GIM_Try, /*On fail goto*//*Label 19496*/ GIMT_Encode4(1371934), // Rule ID 22279 //
     /* 1371855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1371858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1371866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1371869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1371872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1371875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1371878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1371881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1371893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371908 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11437:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1371908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E16_MASK),
     /* 1371911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1371917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1371919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1371921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1371926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1371929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1371932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1371933 */     // GIR_Coverage, 22279,
     /* 1371933 */     GIR_EraseRootFromParent_Done,
     /* 1371934 */   // Label 19496: @1371934
     /* 1371934 */   GIM_Try, /*On fail goto*//*Label 19497*/ GIMT_Encode4(1372018), // Rule ID 22282 //
     /* 1371939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1371942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1371947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1371950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1371953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1371956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1371959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1371962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1371965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1371969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1371977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1371981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1371985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1371992 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1371992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1371995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1371997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1371999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372017 */     // GIR_Coverage, 22282,
     /* 1372017 */     GIR_EraseRootFromParent_Done,
     /* 1372018 */   // Label 19497: @1372018
     /* 1372018 */   GIM_Try, /*On fail goto*//*Label 19498*/ GIMT_Encode4(1372102), // Rule ID 22283 //
     /* 1372023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1372040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372076 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E32_MASK),
     /* 1372079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372101 */     // GIR_Coverage, 22283,
     /* 1372101 */     GIR_EraseRootFromParent_Done,
     /* 1372102 */   // Label 19498: @1372102
     /* 1372102 */   GIM_Try, /*On fail goto*//*Label 19499*/ GIMT_Encode4(1372186), // Rule ID 22286 //
     /* 1372107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1372124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372160 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1372163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372185 */     // GIR_Coverage, 22286,
     /* 1372185 */     GIR_EraseRootFromParent_Done,
     /* 1372186 */   // Label 19499: @1372186
     /* 1372186 */   GIM_Try, /*On fail goto*//*Label 19500*/ GIMT_Encode4(1372270), // Rule ID 22287 //
     /* 1372191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1372208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E32_MASK),
     /* 1372247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372269 */     // GIR_Coverage, 22287,
     /* 1372269 */     GIR_EraseRootFromParent_Done,
     /* 1372270 */   // Label 19500: @1372270
     /* 1372270 */   GIM_Try, /*On fail goto*//*Label 19501*/ GIMT_Encode4(1372354), // Rule ID 22290 //
     /* 1372275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1372292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372328 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1372331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372353 */     // GIR_Coverage, 22290,
     /* 1372353 */     GIR_EraseRootFromParent_Done,
     /* 1372354 */   // Label 19501: @1372354
     /* 1372354 */   GIM_Try, /*On fail goto*//*Label 19502*/ GIMT_Encode4(1372438), // Rule ID 22291 //
     /* 1372359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1372362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1372370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1372373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1372376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1372379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1372382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372412 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11437:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E32_MASK),
     /* 1372415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1372433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372437 */     // GIR_Coverage, 22291,
     /* 1372437 */     GIR_EraseRootFromParent_Done,
     /* 1372438 */   // Label 19502: @1372438
     /* 1372438 */   GIM_Try, /*On fail goto*//*Label 19503*/ GIMT_Encode4(1372522), // Rule ID 22294 //
     /* 1372443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1372499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372521 */     // GIR_Coverage, 22294,
     /* 1372521 */     GIR_EraseRootFromParent_Done,
     /* 1372522 */   // Label 19503: @1372522
     /* 1372522 */   GIM_Try, /*On fail goto*//*Label 19504*/ GIMT_Encode4(1372606), // Rule ID 22295 //
     /* 1372527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1372544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1372550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1372565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372580 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M2_E64_MASK),
     /* 1372583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372605 */     // GIR_Coverage, 22295,
     /* 1372605 */     GIR_EraseRootFromParent_Done,
     /* 1372606 */   // Label 19504: @1372606
     /* 1372606 */   GIM_Try, /*On fail goto*//*Label 19505*/ GIMT_Encode4(1372690), // Rule ID 22298 //
     /* 1372611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1372667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372689 */     // GIR_Coverage, 22298,
     /* 1372689 */     GIR_EraseRootFromParent_Done,
     /* 1372690 */   // Label 19505: @1372690
     /* 1372690 */   GIM_Try, /*On fail goto*//*Label 19506*/ GIMT_Encode4(1372774), // Rule ID 22299 //
     /* 1372695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1372712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1372718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1372733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M4_E64_MASK),
     /* 1372751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372773 */     // GIR_Coverage, 22299,
     /* 1372773 */     GIR_EraseRootFromParent_Done,
     /* 1372774 */   // Label 19506: @1372774
     /* 1372774 */   GIM_Try, /*On fail goto*//*Label 19507*/ GIMT_Encode4(1372858), // Rule ID 22302 //
     /* 1372779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1372782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372832 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1372832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1372835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372857 */     // GIR_Coverage, 22302,
     /* 1372857 */     GIR_EraseRootFromParent_Done,
     /* 1372858 */   // Label 19507: @1372858
     /* 1372858 */   GIM_Try, /*On fail goto*//*Label 19508*/ GIMT_Encode4(1372942), // Rule ID 22303 //
     /* 1372863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1372866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredminu_mask),
     /* 1372871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1372874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1372877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1372880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1372883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1372886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1372889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1372901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1372916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11437:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMINU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1372916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMINU_VS_M8_E64_MASK),
     /* 1372919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1372921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1372923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1372925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1372927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1372929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1372934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1372937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1372940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1372941 */     // GIR_Coverage, 22303,
     /* 1372941 */     GIR_EraseRootFromParent_Done,
     /* 1372942 */   // Label 19508: @1372942
     /* 1372942 */   GIM_Try, /*On fail goto*//*Label 19509*/ GIMT_Encode4(1373026), // Rule ID 22306 //
     /* 1372947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1372950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1372955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1372958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1372961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1372964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1372967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1372970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1372973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1372977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1372989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1372993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373000 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1373003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373025 */     // GIR_Coverage, 22306,
     /* 1373025 */     GIR_EraseRootFromParent_Done,
     /* 1373026 */   // Label 19509: @1373026
     /* 1373026 */   GIM_Try, /*On fail goto*//*Label 19510*/ GIMT_Encode4(1373110), // Rule ID 22307 //
     /* 1373031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1373048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF8_E8_MASK),
     /* 1373087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373109 */     // GIR_Coverage, 22307,
     /* 1373109 */     GIR_EraseRootFromParent_Done,
     /* 1373110 */   // Label 19510: @1373110
     /* 1373110 */   GIM_Try, /*On fail goto*//*Label 19511*/ GIMT_Encode4(1373194), // Rule ID 22310 //
     /* 1373115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1373132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373168 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1373171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373193 */     // GIR_Coverage, 22310,
     /* 1373193 */     GIR_EraseRootFromParent_Done,
     /* 1373194 */   // Label 19511: @1373194
     /* 1373194 */   GIM_Try, /*On fail goto*//*Label 19512*/ GIMT_Encode4(1373278), // Rule ID 22311 //
     /* 1373199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1373216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373252 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E8_MASK),
     /* 1373255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373277 */     // GIR_Coverage, 22311,
     /* 1373277 */     GIR_EraseRootFromParent_Done,
     /* 1373278 */   // Label 19512: @1373278
     /* 1373278 */   GIM_Try, /*On fail goto*//*Label 19513*/ GIMT_Encode4(1373362), // Rule ID 22314 //
     /* 1373283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1373300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373336 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1373339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373361 */     // GIR_Coverage, 22314,
     /* 1373361 */     GIR_EraseRootFromParent_Done,
     /* 1373362 */   // Label 19513: @1373362
     /* 1373362 */   GIM_Try, /*On fail goto*//*Label 19514*/ GIMT_Encode4(1373446), // Rule ID 22315 //
     /* 1373367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1373384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1373390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E8_MASK),
     /* 1373423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1373441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373445 */     // GIR_Coverage, 22315,
     /* 1373445 */     GIR_EraseRootFromParent_Done,
     /* 1373446 */   // Label 19514: @1373446
     /* 1373446 */   GIM_Try, /*On fail goto*//*Label 19515*/ GIMT_Encode4(1373530), // Rule ID 22318 //
     /* 1373451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1373507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373529 */     // GIR_Coverage, 22318,
     /* 1373529 */     GIR_EraseRootFromParent_Done,
     /* 1373530 */   // Label 19515: @1373530
     /* 1373530 */   GIM_Try, /*On fail goto*//*Label 19516*/ GIMT_Encode4(1373614), // Rule ID 22319 //
     /* 1373535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1373552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373588 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF4_E16_MASK),
     /* 1373591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373613 */     // GIR_Coverage, 22319,
     /* 1373613 */     GIR_EraseRootFromParent_Done,
     /* 1373614 */   // Label 19516: @1373614
     /* 1373614 */   GIM_Try, /*On fail goto*//*Label 19517*/ GIMT_Encode4(1373698), // Rule ID 22322 //
     /* 1373619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1373675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373697 */     // GIR_Coverage, 22322,
     /* 1373697 */     GIR_EraseRootFromParent_Done,
     /* 1373698 */   // Label 19517: @1373698
     /* 1373698 */   GIM_Try, /*On fail goto*//*Label 19518*/ GIMT_Encode4(1373782), // Rule ID 22323 //
     /* 1373703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1373714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1373717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1373720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1373723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1373726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373756 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E16_MASK),
     /* 1373759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1373777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373781 */     // GIR_Coverage, 22323,
     /* 1373781 */     GIR_EraseRootFromParent_Done,
     /* 1373782 */   // Label 19518: @1373782
     /* 1373782 */   GIM_Try, /*On fail goto*//*Label 19519*/ GIMT_Encode4(1373866), // Rule ID 22326 //
     /* 1373787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373840 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1373840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1373843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373865 */     // GIR_Coverage, 22326,
     /* 1373865 */     GIR_EraseRootFromParent_Done,
     /* 1373866 */   // Label 19519: @1373866
     /* 1373866 */   GIM_Try, /*On fail goto*//*Label 19520*/ GIMT_Encode4(1373950), // Rule ID 22327 //
     /* 1373871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1373874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1373882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1373885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1373888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1373891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1373894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1373897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1373917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1373924 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1373924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_MF2_E32_MASK),
     /* 1373927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1373929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1373931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1373933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1373935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1373937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1373942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1373945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1373948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1373949 */     // GIR_Coverage, 22327,
     /* 1373949 */     GIR_EraseRootFromParent_Done,
     /* 1373950 */   // Label 19520: @1373950
     /* 1373950 */   GIM_Try, /*On fail goto*//*Label 19521*/ GIMT_Encode4(1374034), // Rule ID 22330 //
     /* 1373955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1373958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1373963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1373966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1373969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1373972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1373975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1373978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1373981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1373985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1373997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1374011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374033 */     // GIR_Coverage, 22330,
     /* 1374033 */     GIR_EraseRootFromParent_Done,
     /* 1374034 */   // Label 19521: @1374034
     /* 1374034 */   GIM_Try, /*On fail goto*//*Label 19522*/ GIMT_Encode4(1374118), // Rule ID 22331 //
     /* 1374039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1374056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1374062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374092 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E8_MASK),
     /* 1374095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374117 */     // GIR_Coverage, 22331,
     /* 1374117 */     GIR_EraseRootFromParent_Done,
     /* 1374118 */   // Label 19522: @1374118
     /* 1374118 */   GIM_Try, /*On fail goto*//*Label 19523*/ GIMT_Encode4(1374202), // Rule ID 22334 //
     /* 1374123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1374140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1374179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374201 */     // GIR_Coverage, 22334,
     /* 1374201 */     GIR_EraseRootFromParent_Done,
     /* 1374202 */   // Label 19523: @1374202
     /* 1374202 */   GIM_Try, /*On fail goto*//*Label 19524*/ GIMT_Encode4(1374286), // Rule ID 22335 //
     /* 1374207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1374218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1374221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1374224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1374227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1374230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374260 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E16_MASK),
     /* 1374263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1374281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374285 */     // GIR_Coverage, 22335,
     /* 1374285 */     GIR_EraseRootFromParent_Done,
     /* 1374286 */   // Label 19524: @1374286
     /* 1374286 */   GIM_Try, /*On fail goto*//*Label 19525*/ GIMT_Encode4(1374370), // Rule ID 22338 //
     /* 1374291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1374308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374344 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1374347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374369 */     // GIR_Coverage, 22338,
     /* 1374369 */     GIR_EraseRootFromParent_Done,
     /* 1374370 */   // Label 19525: @1374370
     /* 1374370 */   GIM_Try, /*On fail goto*//*Label 19526*/ GIMT_Encode4(1374454), // Rule ID 22339 //
     /* 1374375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1374386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1374389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1374392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1374395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1374398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E32_MASK),
     /* 1374431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1374449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374453 */     // GIR_Coverage, 22339,
     /* 1374453 */     GIR_EraseRootFromParent_Done,
     /* 1374454 */   // Label 19526: @1374454
     /* 1374454 */   GIM_Try, /*On fail goto*//*Label 19527*/ GIMT_Encode4(1374538), // Rule ID 22342 //
     /* 1374459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1374462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1374515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374537 */     // GIR_Coverage, 22342,
     /* 1374537 */     GIR_EraseRootFromParent_Done,
     /* 1374538 */   // Label 19527: @1374538
     /* 1374538 */   GIM_Try, /*On fail goto*//*Label 19528*/ GIMT_Encode4(1374622), // Rule ID 22343 //
     /* 1374543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1374546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1374554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1374557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1374560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1374563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1374566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374596 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M1_E64_MASK),
     /* 1374599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1374617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374621 */     // GIR_Coverage, 22343,
     /* 1374621 */     GIR_EraseRootFromParent_Done,
     /* 1374622 */   // Label 19528: @1374622
     /* 1374622 */   GIM_Try, /*On fail goto*//*Label 19529*/ GIMT_Encode4(1374706), // Rule ID 22346 //
     /* 1374627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1374683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374705 */     // GIR_Coverage, 22346,
     /* 1374705 */     GIR_EraseRootFromParent_Done,
     /* 1374706 */   // Label 19529: @1374706
     /* 1374706 */   GIM_Try, /*On fail goto*//*Label 19530*/ GIMT_Encode4(1374790), // Rule ID 22347 //
     /* 1374711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1374728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1374734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1374749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E8_MASK),
     /* 1374767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374789 */     // GIR_Coverage, 22347,
     /* 1374789 */     GIR_EraseRootFromParent_Done,
     /* 1374790 */   // Label 19530: @1374790
     /* 1374790 */   GIM_Try, /*On fail goto*//*Label 19531*/ GIMT_Encode4(1374874), // Rule ID 22350 //
     /* 1374795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374848 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1374848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1374851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374872 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374873 */     // GIR_Coverage, 22350,
     /* 1374873 */     GIR_EraseRootFromParent_Done,
     /* 1374874 */   // Label 19531: @1374874
     /* 1374874 */   GIM_Try, /*On fail goto*//*Label 19532*/ GIMT_Encode4(1374958), // Rule ID 22351 //
     /* 1374879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1374882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1374896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1374902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1374905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1374917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1374925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1374932 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1374932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E8_MASK),
     /* 1374935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1374937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1374939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1374941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1374943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1374945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1374950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1374953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1374956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1374957 */     // GIR_Coverage, 22351,
     /* 1374957 */     GIR_EraseRootFromParent_Done,
     /* 1374958 */   // Label 19532: @1374958
     /* 1374958 */   GIM_Try, /*On fail goto*//*Label 19533*/ GIMT_Encode4(1375042), // Rule ID 22354 //
     /* 1374963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1374966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1374971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1374974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1374977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1374980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1374983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1374986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1374989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1374993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1374997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375016 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1375019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375041 */     // GIR_Coverage, 22354,
     /* 1375041 */     GIR_EraseRootFromParent_Done,
     /* 1375042 */   // Label 19533: @1375042
     /* 1375042 */   GIM_Try, /*On fail goto*//*Label 19534*/ GIMT_Encode4(1375126), // Rule ID 22355 //
     /* 1375047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1375058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1375061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1375064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1375067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1375070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11435:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E8_MASK),
     /* 1375103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1375121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375124 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375125 */     // GIR_Coverage, 22355,
     /* 1375125 */     GIR_EraseRootFromParent_Done,
     /* 1375126 */   // Label 19534: @1375126
     /* 1375126 */   GIM_Try, /*On fail goto*//*Label 19535*/ GIMT_Encode4(1375210), // Rule ID 22358 //
     /* 1375131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1375148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375184 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1375187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375209 */     // GIR_Coverage, 22358,
     /* 1375209 */     GIR_EraseRootFromParent_Done,
     /* 1375210 */   // Label 19535: @1375210
     /* 1375210 */   GIM_Try, /*On fail goto*//*Label 19536*/ GIMT_Encode4(1375294), // Rule ID 22359 //
     /* 1375215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1375232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375268 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E16_MASK),
     /* 1375271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375292 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375293 */     // GIR_Coverage, 22359,
     /* 1375293 */     GIR_EraseRootFromParent_Done,
     /* 1375294 */   // Label 19536: @1375294
     /* 1375294 */   GIM_Try, /*On fail goto*//*Label 19537*/ GIMT_Encode4(1375378), // Rule ID 22362 //
     /* 1375299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1375316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375352 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1375355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375377 */     // GIR_Coverage, 22362,
     /* 1375377 */     GIR_EraseRootFromParent_Done,
     /* 1375378 */   // Label 19537: @1375378
     /* 1375378 */   GIM_Try, /*On fail goto*//*Label 19538*/ GIMT_Encode4(1375462), // Rule ID 22363 //
     /* 1375383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1375400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375436 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E16_MASK),
     /* 1375439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375461 */     // GIR_Coverage, 22363,
     /* 1375461 */     GIR_EraseRootFromParent_Done,
     /* 1375462 */   // Label 19538: @1375462
     /* 1375462 */   GIM_Try, /*On fail goto*//*Label 19539*/ GIMT_Encode4(1375546), // Rule ID 22366 //
     /* 1375467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1375523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375544 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375545 */     // GIR_Coverage, 22366,
     /* 1375545 */     GIR_EraseRootFromParent_Done,
     /* 1375546 */   // Label 19539: @1375546
     /* 1375546 */   GIM_Try, /*On fail goto*//*Label 19540*/ GIMT_Encode4(1375630), // Rule ID 22367 //
     /* 1375551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1375562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1375565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1375568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1375571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1375574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1375589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375604 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11435:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E16_MASK),
     /* 1375607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1375625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375629 */     // GIR_Coverage, 22367,
     /* 1375629 */     GIR_EraseRootFromParent_Done,
     /* 1375630 */   // Label 19540: @1375630
     /* 1375630 */   GIM_Try, /*On fail goto*//*Label 19541*/ GIMT_Encode4(1375714), // Rule ID 22370 //
     /* 1375635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1375691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375713 */     // GIR_Coverage, 22370,
     /* 1375713 */     GIR_EraseRootFromParent_Done,
     /* 1375714 */   // Label 19541: @1375714
     /* 1375714 */   GIM_Try, /*On fail goto*//*Label 19542*/ GIMT_Encode4(1375798), // Rule ID 22371 //
     /* 1375719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1375736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1375742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1375757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375772 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E32_MASK),
     /* 1375775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375796 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375797 */     // GIR_Coverage, 22371,
     /* 1375797 */     GIR_EraseRootFromParent_Done,
     /* 1375798 */   // Label 19542: @1375798
     /* 1375798 */   GIM_Try, /*On fail goto*//*Label 19543*/ GIMT_Encode4(1375882), // Rule ID 22374 //
     /* 1375803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375856 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1375856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1375859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375881 */     // GIR_Coverage, 22374,
     /* 1375881 */     GIR_EraseRootFromParent_Done,
     /* 1375882 */   // Label 19543: @1375882
     /* 1375882 */   GIM_Try, /*On fail goto*//*Label 19544*/ GIMT_Encode4(1375966), // Rule ID 22375 //
     /* 1375887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1375890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1375904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1375910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1375913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1375917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1375925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1375929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1375933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1375940 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1375940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E32_MASK),
     /* 1375943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1375945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1375947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1375949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1375951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1375953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1375958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1375961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1375964 */     GIR_RootConstrainSelectedInstOperands,
     /* 1375965 */     // GIR_Coverage, 22375,
     /* 1375965 */     GIR_EraseRootFromParent_Done,
     /* 1375966 */   // Label 19544: @1375966
     /* 1375966 */   GIM_Try, /*On fail goto*//*Label 19545*/ GIMT_Encode4(1376050), // Rule ID 22378 //
     /* 1375971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1375974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1375979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1375982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1375985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1375988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1375991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1375994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1375997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376024 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1376027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376049 */     // GIR_Coverage, 22378,
     /* 1376049 */     GIR_EraseRootFromParent_Done,
     /* 1376050 */   // Label 19545: @1376050
     /* 1376050 */   GIM_Try, /*On fail goto*//*Label 19546*/ GIMT_Encode4(1376134), // Rule ID 22379 //
     /* 1376055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1376066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1376069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1376072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1376075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1376078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11435:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E32_MASK),
     /* 1376111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1376129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376133 */     // GIR_Coverage, 22379,
     /* 1376133 */     GIR_EraseRootFromParent_Done,
     /* 1376134 */   // Label 19546: @1376134
     /* 1376134 */   GIM_Try, /*On fail goto*//*Label 19547*/ GIMT_Encode4(1376218), // Rule ID 22382 //
     /* 1376139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1376156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1376195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376217 */     // GIR_Coverage, 22382,
     /* 1376217 */     GIR_EraseRootFromParent_Done,
     /* 1376218 */   // Label 19547: @1376218
     /* 1376218 */   GIM_Try, /*On fail goto*//*Label 19548*/ GIMT_Encode4(1376302), // Rule ID 22383 //
     /* 1376223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1376240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1376261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M2_E64_MASK),
     /* 1376279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376301 */     // GIR_Coverage, 22383,
     /* 1376301 */     GIR_EraseRootFromParent_Done,
     /* 1376302 */   // Label 19548: @1376302
     /* 1376302 */   GIM_Try, /*On fail goto*//*Label 19549*/ GIMT_Encode4(1376386), // Rule ID 22386 //
     /* 1376307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1376324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1376363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376385 */     // GIR_Coverage, 22386,
     /* 1376385 */     GIR_EraseRootFromParent_Done,
     /* 1376386 */   // Label 19549: @1376386
     /* 1376386 */   GIM_Try, /*On fail goto*//*Label 19550*/ GIMT_Encode4(1376470), // Rule ID 22387 //
     /* 1376391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1376408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1376414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1376429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376444 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M4_E64_MASK),
     /* 1376447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376469 */     // GIR_Coverage, 22387,
     /* 1376469 */     GIR_EraseRootFromParent_Done,
     /* 1376470 */   // Label 19550: @1376470
     /* 1376470 */   GIM_Try, /*On fail goto*//*Label 19551*/ GIMT_Encode4(1376554), // Rule ID 22390 //
     /* 1376475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1376478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376528 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1376531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376553 */     // GIR_Coverage, 22390,
     /* 1376553 */     GIR_EraseRootFromParent_Done,
     /* 1376554 */   // Label 19551: @1376554
     /* 1376554 */   GIM_Try, /*On fail goto*//*Label 19552*/ GIMT_Encode4(1376638), // Rule ID 22391 //
     /* 1376559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1376562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmin_mask),
     /* 1376567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1376570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1376573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1376576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1376579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1376582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1376597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376612 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11435:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMIN_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMIN_VS_M8_E64_MASK),
     /* 1376615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1376633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376637 */     // GIR_Coverage, 22391,
     /* 1376637 */     GIR_EraseRootFromParent_Done,
     /* 1376638 */   // Label 19552: @1376638
     /* 1376638 */   GIM_Try, /*On fail goto*//*Label 19553*/ GIMT_Encode4(1376722), // Rule ID 22394 //
     /* 1376643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1376651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376696 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1376699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376720 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376721 */     // GIR_Coverage, 22394,
     /* 1376721 */     GIR_EraseRootFromParent_Done,
     /* 1376722 */   // Label 19553: @1376722
     /* 1376722 */   GIM_Try, /*On fail goto*//*Label 19554*/ GIMT_Encode4(1376806), // Rule ID 22395 //
     /* 1376727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1376735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1376744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1376750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376780 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF8_E8_MASK),
     /* 1376783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376805 */     // GIR_Coverage, 22395,
     /* 1376805 */     GIR_EraseRootFromParent_Done,
     /* 1376806 */   // Label 19554: @1376806
     /* 1376806 */   GIM_Try, /*On fail goto*//*Label 19555*/ GIMT_Encode4(1376890), // Rule ID 22398 //
     /* 1376811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1376819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1376837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376864 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1376864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1376867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376888 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376889 */     // GIR_Coverage, 22398,
     /* 1376889 */     GIR_EraseRootFromParent_Done,
     /* 1376890 */   // Label 19555: @1376890
     /* 1376890 */   GIM_Try, /*On fail goto*//*Label 19556*/ GIMT_Encode4(1376974), // Rule ID 22399 //
     /* 1376895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1376898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1376903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1376912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1376918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1376921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1376925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1376937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1376941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1376948 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1376948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E8_MASK),
     /* 1376951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1376953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1376955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1376957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1376959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1376961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1376966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1376969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1376972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1376973 */     // GIR_Coverage, 22399,
     /* 1376973 */     GIR_EraseRootFromParent_Done,
     /* 1376974 */   // Label 19556: @1376974
     /* 1376974 */   GIM_Try, /*On fail goto*//*Label 19557*/ GIMT_Encode4(1377058), // Rule ID 22402 //
     /* 1376979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1376982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1376987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1376990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1376993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1376996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1376999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377032 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1377035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377057 */     // GIR_Coverage, 22402,
     /* 1377057 */     GIR_EraseRootFromParent_Done,
     /* 1377058 */   // Label 19557: @1377058
     /* 1377058 */   GIM_Try, /*On fail goto*//*Label 19558*/ GIMT_Encode4(1377142), // Rule ID 22403 //
     /* 1377063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1377080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377116 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E8_MASK),
     /* 1377119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377140 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377141 */     // GIR_Coverage, 22403,
     /* 1377141 */     GIR_EraseRootFromParent_Done,
     /* 1377142 */   // Label 19558: @1377142
     /* 1377142 */   GIM_Try, /*On fail goto*//*Label 19559*/ GIMT_Encode4(1377226), // Rule ID 22406 //
     /* 1377147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1377164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1377203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377225 */     // GIR_Coverage, 22406,
     /* 1377225 */     GIR_EraseRootFromParent_Done,
     /* 1377226 */   // Label 19559: @1377226
     /* 1377226 */   GIM_Try, /*On fail goto*//*Label 19560*/ GIMT_Encode4(1377310), // Rule ID 22407 //
     /* 1377231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1377248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF4_E16_MASK),
     /* 1377287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377309 */     // GIR_Coverage, 22407,
     /* 1377309 */     GIR_EraseRootFromParent_Done,
     /* 1377310 */   // Label 19560: @1377310
     /* 1377310 */   GIM_Try, /*On fail goto*//*Label 19561*/ GIMT_Encode4(1377394), // Rule ID 22410 //
     /* 1377315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1377371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377392 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377393 */     // GIR_Coverage, 22410,
     /* 1377393 */     GIR_EraseRootFromParent_Done,
     /* 1377394 */   // Label 19561: @1377394
     /* 1377394 */   GIM_Try, /*On fail goto*//*Label 19562*/ GIMT_Encode4(1377478), // Rule ID 22411 //
     /* 1377399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1377416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1377422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377452 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E16_MASK),
     /* 1377455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377477 */     // GIR_Coverage, 22411,
     /* 1377477 */     GIR_EraseRootFromParent_Done,
     /* 1377478 */   // Label 19562: @1377478
     /* 1377478 */   GIM_Try, /*On fail goto*//*Label 19563*/ GIMT_Encode4(1377562), // Rule ID 22414 //
     /* 1377483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1377539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377560 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377561 */     // GIR_Coverage, 22414,
     /* 1377561 */     GIR_EraseRootFromParent_Done,
     /* 1377562 */   // Label 19563: @1377562
     /* 1377562 */   GIM_Try, /*On fail goto*//*Label 19564*/ GIMT_Encode4(1377646), // Rule ID 22415 //
     /* 1377567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1377581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1377584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1377587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1377590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_MF2_E32_MASK),
     /* 1377623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1377641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377645 */     // GIR_Coverage, 22415,
     /* 1377645 */     GIR_EraseRootFromParent_Done,
     /* 1377646 */   // Label 19564: @1377646
     /* 1377646 */   GIM_Try, /*On fail goto*//*Label 19565*/ GIMT_Encode4(1377730), // Rule ID 22418 //
     /* 1377651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377704 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1377707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377729 */     // GIR_Coverage, 22418,
     /* 1377729 */     GIR_EraseRootFromParent_Done,
     /* 1377730 */   // Label 19565: @1377730
     /* 1377730 */   GIM_Try, /*On fail goto*//*Label 19566*/ GIMT_Encode4(1377814), // Rule ID 22419 //
     /* 1377735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1377746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1377749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1377752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1377755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1377758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E8_MASK),
     /* 1377791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1377809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377812 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377813 */     // GIR_Coverage, 22419,
     /* 1377813 */     GIR_EraseRootFromParent_Done,
     /* 1377814 */   // Label 19566: @1377814
     /* 1377814 */   GIM_Try, /*On fail goto*//*Label 19567*/ GIMT_Encode4(1377898), // Rule ID 22422 //
     /* 1377819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1377845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377872 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1377872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1377875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377897 */     // GIR_Coverage, 22422,
     /* 1377897 */     GIR_EraseRootFromParent_Done,
     /* 1377898 */   // Label 19567: @1377898
     /* 1377898 */   GIM_Try, /*On fail goto*//*Label 19568*/ GIMT_Encode4(1377982), // Rule ID 22423 //
     /* 1377903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1377906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1377914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1377917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1377920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1377923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1377926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1377929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1377933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1377945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1377949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1377956 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1377956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E16_MASK),
     /* 1377959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1377961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1377963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1377965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1377967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1377969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1377974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1377977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1377980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1377981 */     // GIR_Coverage, 22423,
     /* 1377981 */     GIR_EraseRootFromParent_Done,
     /* 1377982 */   // Label 19568: @1377982
     /* 1377982 */   GIM_Try, /*On fail goto*//*Label 19569*/ GIMT_Encode4(1378066), // Rule ID 22426 //
     /* 1377987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1377990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1377995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1377998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1378004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1378010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1378043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378065 */     // GIR_Coverage, 22426,
     /* 1378065 */     GIR_EraseRootFromParent_Done,
     /* 1378066 */   // Label 19569: @1378066
     /* 1378066 */   GIM_Try, /*On fail goto*//*Label 19570*/ GIMT_Encode4(1378150), // Rule ID 22427 //
     /* 1378071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1378082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1378085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1378088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1378091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1378094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378124 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E32_MASK),
     /* 1378127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1378145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378149 */     // GIR_Coverage, 22427,
     /* 1378149 */     GIR_EraseRootFromParent_Done,
     /* 1378150 */   // Label 19570: @1378150
     /* 1378150 */   GIM_Try, /*On fail goto*//*Label 19571*/ GIMT_Encode4(1378234), // Rule ID 22430 //
     /* 1378155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1378158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1378166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1378169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1378172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1378175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378208 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1378211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1378229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378233 */     // GIR_Coverage, 22430,
     /* 1378233 */     GIR_EraseRootFromParent_Done,
     /* 1378234 */   // Label 19571: @1378234
     /* 1378234 */   GIM_Try, /*On fail goto*//*Label 19572*/ GIMT_Encode4(1378318), // Rule ID 22431 //
     /* 1378239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1378242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1378250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1378253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1378256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1378259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1378262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M1_E64_MASK),
     /* 1378295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1378313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378317 */     // GIR_Coverage, 22431,
     /* 1378317 */     GIR_EraseRootFromParent_Done,
     /* 1378318 */   // Label 19572: @1378318
     /* 1378318 */   GIM_Try, /*On fail goto*//*Label 19573*/ GIMT_Encode4(1378402), // Rule ID 22434 //
     /* 1378323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378376 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1378379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378401 */     // GIR_Coverage, 22434,
     /* 1378401 */     GIR_EraseRootFromParent_Done,
     /* 1378402 */   // Label 19573: @1378402
     /* 1378402 */   GIM_Try, /*On fail goto*//*Label 19574*/ GIMT_Encode4(1378486), // Rule ID 22435 //
     /* 1378407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1378424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1378430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378460 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E8_MASK),
     /* 1378463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378485 */     // GIR_Coverage, 22435,
     /* 1378485 */     GIR_EraseRootFromParent_Done,
     /* 1378486 */   // Label 19574: @1378486
     /* 1378486 */   GIM_Try, /*On fail goto*//*Label 19575*/ GIMT_Encode4(1378570), // Rule ID 22438 //
     /* 1378491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1378547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378569 */     // GIR_Coverage, 22438,
     /* 1378569 */     GIR_EraseRootFromParent_Done,
     /* 1378570 */   // Label 19575: @1378570
     /* 1378570 */   GIM_Try, /*On fail goto*//*Label 19576*/ GIMT_Encode4(1378654), // Rule ID 22439 //
     /* 1378575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1378592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1378598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1378613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E8_MASK),
     /* 1378631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378653 */     // GIR_Coverage, 22439,
     /* 1378653 */     GIR_EraseRootFromParent_Done,
     /* 1378654 */   // Label 19576: @1378654
     /* 1378654 */   GIM_Try, /*On fail goto*//*Label 19577*/ GIMT_Encode4(1378738), // Rule ID 22442 //
     /* 1378659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378712 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1378715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378737 */     // GIR_Coverage, 22442,
     /* 1378737 */     GIR_EraseRootFromParent_Done,
     /* 1378738 */   // Label 19577: @1378738
     /* 1378738 */   GIM_Try, /*On fail goto*//*Label 19578*/ GIMT_Encode4(1378822), // Rule ID 22443 //
     /* 1378743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1378754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1378757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1378760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1378763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1378766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1378781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378796 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11433:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E8_MASK),
     /* 1378799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1378817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378821 */     // GIR_Coverage, 22443,
     /* 1378821 */     GIR_EraseRootFromParent_Done,
     /* 1378822 */   // Label 19578: @1378822
     /* 1378822 */   GIM_Try, /*On fail goto*//*Label 19579*/ GIMT_Encode4(1378906), // Rule ID 22446 //
     /* 1378827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1378853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1378880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1378883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378905 */     // GIR_Coverage, 22446,
     /* 1378905 */     GIR_EraseRootFromParent_Done,
     /* 1378906 */   // Label 19579: @1378906
     /* 1378906 */   GIM_Try, /*On fail goto*//*Label 19580*/ GIMT_Encode4(1378990), // Rule ID 22447 //
     /* 1378911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1378914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1378919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1378922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1378925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1378928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1378931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1378934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1378937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1378941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1378949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1378953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1378957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1378964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1378964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E16_MASK),
     /* 1378967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1378969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1378971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1378973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1378975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1378977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1378982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1378985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1378988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1378989 */     // GIR_Coverage, 22447,
     /* 1378989 */     GIR_EraseRootFromParent_Done,
     /* 1378990 */   // Label 19580: @1378990
     /* 1378990 */   GIM_Try, /*On fail goto*//*Label 19581*/ GIMT_Encode4(1379074), // Rule ID 22450 //
     /* 1378995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1378998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1379012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379048 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1379051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379073 */     // GIR_Coverage, 22450,
     /* 1379073 */     GIR_EraseRootFromParent_Done,
     /* 1379074 */   // Label 19581: @1379074
     /* 1379074 */   GIM_Try, /*On fail goto*//*Label 19582*/ GIMT_Encode4(1379158), // Rule ID 22451 //
     /* 1379079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1379096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379132 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E16_MASK),
     /* 1379135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379156 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379157 */     // GIR_Coverage, 22451,
     /* 1379157 */     GIR_EraseRootFromParent_Done,
     /* 1379158 */   // Label 19582: @1379158
     /* 1379158 */   GIM_Try, /*On fail goto*//*Label 19583*/ GIMT_Encode4(1379242), // Rule ID 22454 //
     /* 1379163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379216 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1379219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379241 */     // GIR_Coverage, 22454,
     /* 1379241 */     GIR_EraseRootFromParent_Done,
     /* 1379242 */   // Label 19583: @1379242
     /* 1379242 */   GIM_Try, /*On fail goto*//*Label 19584*/ GIMT_Encode4(1379326), // Rule ID 22455 //
     /* 1379247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1379258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1379261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1379264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1379267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1379270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11433:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E16_MASK),
     /* 1379303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1379321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379325 */     // GIR_Coverage, 22455,
     /* 1379325 */     GIR_EraseRootFromParent_Done,
     /* 1379326 */   // Label 19584: @1379326
     /* 1379326 */   GIM_Try, /*On fail goto*//*Label 19585*/ GIMT_Encode4(1379410), // Rule ID 22458 //
     /* 1379331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379384 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1379387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379408 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379409 */     // GIR_Coverage, 22458,
     /* 1379409 */     GIR_EraseRootFromParent_Done,
     /* 1379410 */   // Label 19585: @1379410
     /* 1379410 */   GIM_Try, /*On fail goto*//*Label 19586*/ GIMT_Encode4(1379494), // Rule ID 22459 //
     /* 1379415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1379432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1379438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E32_MASK),
     /* 1379471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379493 */     // GIR_Coverage, 22459,
     /* 1379493 */     GIR_EraseRootFromParent_Done,
     /* 1379494 */   // Label 19586: @1379494
     /* 1379494 */   GIM_Try, /*On fail goto*//*Label 19587*/ GIMT_Encode4(1379578), // Rule ID 22462 //
     /* 1379499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1379555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379576 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379577 */     // GIR_Coverage, 22462,
     /* 1379577 */     GIR_EraseRootFromParent_Done,
     /* 1379578 */   // Label 19587: @1379578
     /* 1379578 */   GIM_Try, /*On fail goto*//*Label 19588*/ GIMT_Encode4(1379662), // Rule ID 22463 //
     /* 1379583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1379600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1379606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1379621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379636 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E32_MASK),
     /* 1379639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379660 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379661 */     // GIR_Coverage, 22463,
     /* 1379661 */     GIR_EraseRootFromParent_Done,
     /* 1379662 */   // Label 19588: @1379662
     /* 1379662 */   GIM_Try, /*On fail goto*//*Label 19589*/ GIMT_Encode4(1379746), // Rule ID 22466 //
     /* 1379667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1379670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379720 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1379723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379745 */     // GIR_Coverage, 22466,
     /* 1379745 */     GIR_EraseRootFromParent_Done,
     /* 1379746 */   // Label 19589: @1379746
     /* 1379746 */   GIM_Try, /*On fail goto*//*Label 19590*/ GIMT_Encode4(1379830), // Rule ID 22467 //
     /* 1379751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1379754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1379762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1379765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1379768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1379771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1379774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1379789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379804 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11433:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E32_MASK),
     /* 1379807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1379825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379828 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379829 */     // GIR_Coverage, 22467,
     /* 1379829 */     GIR_EraseRootFromParent_Done,
     /* 1379830 */   // Label 19590: @1379830
     /* 1379830 */   GIM_Try, /*On fail goto*//*Label 19591*/ GIMT_Encode4(1379914), // Rule ID 22470 //
     /* 1379835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1379838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1379861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379888 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1379888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1379891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379913 */     // GIR_Coverage, 22470,
     /* 1379913 */     GIR_EraseRootFromParent_Done,
     /* 1379914 */   // Label 19591: @1379914
     /* 1379914 */   GIM_Try, /*On fail goto*//*Label 19592*/ GIMT_Encode4(1379998), // Rule ID 22471 //
     /* 1379919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1379922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1379927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1379930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1379933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1379936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1379939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1379942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1379945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1379949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1379957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1379961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1379965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1379972 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1379972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M2_E64_MASK),
     /* 1379975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1379977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1379979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1379981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1379983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1379985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1379990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1379993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1379996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1379997 */     // GIR_Coverage, 22471,
     /* 1379997 */     GIR_EraseRootFromParent_Done,
     /* 1379998 */   // Label 19592: @1379998
     /* 1379998 */   GIM_Try, /*On fail goto*//*Label 19593*/ GIMT_Encode4(1380082), // Rule ID 22474 //
     /* 1380003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1380011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380056 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1380059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380081 */     // GIR_Coverage, 22474,
     /* 1380081 */     GIR_EraseRootFromParent_Done,
     /* 1380082 */   // Label 19593: @1380082
     /* 1380082 */   GIM_Try, /*On fail goto*//*Label 19594*/ GIMT_Encode4(1380166), // Rule ID 22475 //
     /* 1380087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1380095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1380104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1380125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380140 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M4_E64_MASK),
     /* 1380143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380165 */     // GIR_Coverage, 22475,
     /* 1380165 */     GIR_EraseRootFromParent_Done,
     /* 1380166 */   // Label 19594: @1380166
     /* 1380166 */   GIM_Try, /*On fail goto*//*Label 19595*/ GIMT_Encode4(1380250), // Rule ID 22478 //
     /* 1380171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1380174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1380179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1380227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380249 */     // GIR_Coverage, 22478,
     /* 1380249 */     GIR_EraseRootFromParent_Done,
     /* 1380250 */   // Label 19595: @1380250
     /* 1380250 */   GIM_Try, /*On fail goto*//*Label 19596*/ GIMT_Encode4(1380334), // Rule ID 22479 //
     /* 1380255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1380258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmaxu_mask),
     /* 1380263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1380266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1380269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1380272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1380275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1380278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1380293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380308 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11433:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAXU_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAXU_VS_M8_E64_MASK),
     /* 1380311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1380329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380333 */     // GIR_Coverage, 22479,
     /* 1380333 */     GIR_EraseRootFromParent_Done,
     /* 1380334 */   // Label 19596: @1380334
     /* 1380334 */   GIM_Try, /*On fail goto*//*Label 19597*/ GIMT_Encode4(1380418), // Rule ID 22482 //
     /* 1380339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380392 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1380395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380417 */     // GIR_Coverage, 22482,
     /* 1380417 */     GIR_EraseRootFromParent_Done,
     /* 1380418 */   // Label 19597: @1380418
     /* 1380418 */   GIM_Try, /*On fail goto*//*Label 19598*/ GIMT_Encode4(1380502), // Rule ID 22483 //
     /* 1380423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1380440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380476 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF8_E8_MASK),
     /* 1380479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380501 */     // GIR_Coverage, 22483,
     /* 1380501 */     GIR_EraseRootFromParent_Done,
     /* 1380502 */   // Label 19598: @1380502
     /* 1380502 */   GIM_Try, /*On fail goto*//*Label 19599*/ GIMT_Encode4(1380586), // Rule ID 22486 //
     /* 1380507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1380563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380585 */     // GIR_Coverage, 22486,
     /* 1380585 */     GIR_EraseRootFromParent_Done,
     /* 1380586 */   // Label 19599: @1380586
     /* 1380586 */   GIM_Try, /*On fail goto*//*Label 19600*/ GIMT_Encode4(1380670), // Rule ID 22487 //
     /* 1380591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1380608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1380614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E8_MASK),
     /* 1380647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380669 */     // GIR_Coverage, 22487,
     /* 1380669 */     GIR_EraseRootFromParent_Done,
     /* 1380670 */   // Label 19600: @1380670
     /* 1380670 */   GIM_Try, /*On fail goto*//*Label 19601*/ GIMT_Encode4(1380754), // Rule ID 22490 //
     /* 1380675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380728 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1380731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380752 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380753 */     // GIR_Coverage, 22490,
     /* 1380753 */     GIR_EraseRootFromParent_Done,
     /* 1380754 */   // Label 19601: @1380754
     /* 1380754 */   GIM_Try, /*On fail goto*//*Label 19602*/ GIMT_Encode4(1380838), // Rule ID 22491 //
     /* 1380759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1380770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1380773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1380776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1380779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1380782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380812 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E8_MASK),
     /* 1380815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1380833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380837 */     // GIR_Coverage, 22491,
     /* 1380837 */     GIR_EraseRootFromParent_Done,
     /* 1380838 */   // Label 19602: @1380838
     /* 1380838 */   GIM_Try, /*On fail goto*//*Label 19603*/ GIMT_Encode4(1380922), // Rule ID 22494 //
     /* 1380843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1380846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1380869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380896 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1380896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1380899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1380917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1380920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1380921 */     // GIR_Coverage, 22494,
     /* 1380921 */     GIR_EraseRootFromParent_Done,
     /* 1380922 */   // Label 19603: @1380922
     /* 1380922 */   GIM_Try, /*On fail goto*//*Label 19604*/ GIMT_Encode4(1381006), // Rule ID 22495 //
     /* 1380927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1380930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1380935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1380938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1380941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1380944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1380947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1380950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1380953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1380957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1380969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1380973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1380980 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1380980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF4_E16_MASK),
     /* 1380983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1380985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1380987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1380989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1380991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1380993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1380998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381004 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381005 */     // GIR_Coverage, 22495,
     /* 1381005 */     GIR_EraseRootFromParent_Done,
     /* 1381006 */   // Label 19604: @1381006
     /* 1381006 */   GIM_Try, /*On fail goto*//*Label 19605*/ GIMT_Encode4(1381090), // Rule ID 22498 //
     /* 1381011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1381028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381064 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1381067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381089 */     // GIR_Coverage, 22498,
     /* 1381089 */     GIR_EraseRootFromParent_Done,
     /* 1381090 */   // Label 19605: @1381090
     /* 1381090 */   GIM_Try, /*On fail goto*//*Label 19606*/ GIMT_Encode4(1381174), // Rule ID 22499 //
     /* 1381095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1381112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381148 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E16_MASK),
     /* 1381151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381172 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381173 */     // GIR_Coverage, 22499,
     /* 1381173 */     GIR_EraseRootFromParent_Done,
     /* 1381174 */   // Label 19606: @1381174
     /* 1381174 */   GIM_Try, /*On fail goto*//*Label 19607*/ GIMT_Encode4(1381258), // Rule ID 22502 //
     /* 1381179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1381196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1381235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381257 */     // GIR_Coverage, 22502,
     /* 1381257 */     GIR_EraseRootFromParent_Done,
     /* 1381258 */   // Label 19607: @1381258
     /* 1381258 */   GIM_Try, /*On fail goto*//*Label 19608*/ GIMT_Encode4(1381342), // Rule ID 22503 //
     /* 1381263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1381280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381316 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_MF2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_MF2_E32_MASK),
     /* 1381319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381341 */     // GIR_Coverage, 22503,
     /* 1381341 */     GIR_EraseRootFromParent_Done,
     /* 1381342 */   // Label 19608: @1381342
     /* 1381342 */   GIM_Try, /*On fail goto*//*Label 19609*/ GIMT_Encode4(1381426), // Rule ID 22506 //
     /* 1381347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381400 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1381403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381424 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381425 */     // GIR_Coverage, 22506,
     /* 1381425 */     GIR_EraseRootFromParent_Done,
     /* 1381426 */   // Label 19609: @1381426
     /* 1381426 */   GIM_Try, /*On fail goto*//*Label 19610*/ GIMT_Encode4(1381510), // Rule ID 22507 //
     /* 1381431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1381442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1381445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1381448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1381451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1381454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381484 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E8_MASK),
     /* 1381487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1381505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381509 */     // GIR_Coverage, 22507,
     /* 1381509 */     GIR_EraseRootFromParent_Done,
     /* 1381510 */   // Label 19610: @1381510
     /* 1381510 */   GIM_Try, /*On fail goto*//*Label 19611*/ GIMT_Encode4(1381594), // Rule ID 22510 //
     /* 1381515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1381571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381593 */     // GIR_Coverage, 22510,
     /* 1381593 */     GIR_EraseRootFromParent_Done,
     /* 1381594 */   // Label 19611: @1381594
     /* 1381594 */   GIM_Try, /*On fail goto*//*Label 19612*/ GIMT_Encode4(1381678), // Rule ID 22511 //
     /* 1381599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1381610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1381613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1381616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1381619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1381622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381652 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E16_MASK),
     /* 1381655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1381673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381676 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381677 */     // GIR_Coverage, 22511,
     /* 1381677 */     GIR_EraseRootFromParent_Done,
     /* 1381678 */   // Label 19612: @1381678
     /* 1381678 */   GIM_Try, /*On fail goto*//*Label 19613*/ GIMT_Encode4(1381762), // Rule ID 22514 //
     /* 1381683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1381686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381736 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1381739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381761 */     // GIR_Coverage, 22514,
     /* 1381761 */     GIR_EraseRootFromParent_Done,
     /* 1381762 */   // Label 19613: @1381762
     /* 1381762 */   GIM_Try, /*On fail goto*//*Label 19614*/ GIMT_Encode4(1381846), // Rule ID 22515 //
     /* 1381767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1381770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1381778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1381781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1381784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1381787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1381790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381820 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E32_MASK),
     /* 1381823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1381841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381845 */     // GIR_Coverage, 22515,
     /* 1381845 */     GIR_EraseRootFromParent_Done,
     /* 1381846 */   // Label 19614: @1381846
     /* 1381846 */   GIM_Try, /*On fail goto*//*Label 19615*/ GIMT_Encode4(1381930), // Rule ID 22518 //
     /* 1381851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1381854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1381877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1381904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1381907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1381917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1381922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1381925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1381928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1381929 */     // GIR_Coverage, 22518,
     /* 1381929 */     GIR_EraseRootFromParent_Done,
     /* 1381930 */   // Label 19615: @1381930
     /* 1381930 */   GIM_Try, /*On fail goto*//*Label 19616*/ GIMT_Encode4(1382014), // Rule ID 22519 //
     /* 1381935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1381938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1381943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1381946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1381949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1381952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1381955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1381958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1381961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1381965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1381977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1381981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1381988 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1381988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M1_E64_MASK),
     /* 1381991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1381993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1381995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1381997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1381999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1382009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382013 */     // GIR_Coverage, 22519,
     /* 1382013 */     GIR_EraseRootFromParent_Done,
     /* 1382014 */   // Label 19616: @1382014
     /* 1382014 */   GIM_Try, /*On fail goto*//*Label 19617*/ GIMT_Encode4(1382098), // Rule ID 22522 //
     /* 1382019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1382036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382072 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1382075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382097 */     // GIR_Coverage, 22522,
     /* 1382097 */     GIR_EraseRootFromParent_Done,
     /* 1382098 */   // Label 19617: @1382098
     /* 1382098 */   GIM_Try, /*On fail goto*//*Label 19618*/ GIMT_Encode4(1382182), // Rule ID 22523 //
     /* 1382103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1382120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382156 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E8_MASK),
     /* 1382159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382181 */     // GIR_Coverage, 22523,
     /* 1382181 */     GIR_EraseRootFromParent_Done,
     /* 1382182 */   // Label 19618: @1382182
     /* 1382182 */   GIM_Try, /*On fail goto*//*Label 19619*/ GIMT_Encode4(1382266), // Rule ID 22526 //
     /* 1382187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1382204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1382243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382265 */     // GIR_Coverage, 22526,
     /* 1382265 */     GIR_EraseRootFromParent_Done,
     /* 1382266 */   // Label 19619: @1382266
     /* 1382266 */   GIM_Try, /*On fail goto*//*Label 19620*/ GIMT_Encode4(1382350), // Rule ID 22527 //
     /* 1382271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1382288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382324 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E8_MASK),
     /* 1382327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382349 */     // GIR_Coverage, 22527,
     /* 1382349 */     GIR_EraseRootFromParent_Done,
     /* 1382350 */   // Label 19620: @1382350
     /* 1382350 */   GIM_Try, /*On fail goto*//*Label 19621*/ GIMT_Encode4(1382434), // Rule ID 22530 //
     /* 1382355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382408 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1382411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382433 */     // GIR_Coverage, 22530,
     /* 1382433 */     GIR_EraseRootFromParent_Done,
     /* 1382434 */   // Label 19621: @1382434
     /* 1382434 */   GIM_Try, /*On fail goto*//*Label 19622*/ GIMT_Encode4(1382518), // Rule ID 22531 //
     /* 1382439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1382450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1382453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1382456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1382459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1382462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382492 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11431:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E8_MASK),
     /* 1382495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1382513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382516 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382517 */     // GIR_Coverage, 22531,
     /* 1382517 */     GIR_EraseRootFromParent_Done,
     /* 1382518 */   // Label 19622: @1382518
     /* 1382518 */   GIM_Try, /*On fail goto*//*Label 19623*/ GIMT_Encode4(1382602), // Rule ID 22534 //
     /* 1382523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382576 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1382579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382601 */     // GIR_Coverage, 22534,
     /* 1382601 */     GIR_EraseRootFromParent_Done,
     /* 1382602 */   // Label 19623: @1382602
     /* 1382602 */   GIM_Try, /*On fail goto*//*Label 19624*/ GIMT_Encode4(1382686), // Rule ID 22535 //
     /* 1382607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1382624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1382630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1382645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382660 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E16_MASK),
     /* 1382663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382685 */     // GIR_Coverage, 22535,
     /* 1382685 */     GIR_EraseRootFromParent_Done,
     /* 1382686 */   // Label 19624: @1382686
     /* 1382686 */   GIM_Try, /*On fail goto*//*Label 19625*/ GIMT_Encode4(1382770), // Rule ID 22538 //
     /* 1382691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1382747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382768 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382769 */     // GIR_Coverage, 22538,
     /* 1382769 */     GIR_EraseRootFromParent_Done,
     /* 1382770 */   // Label 19625: @1382770
     /* 1382770 */   GIM_Try, /*On fail goto*//*Label 19626*/ GIMT_Encode4(1382854), // Rule ID 22539 //
     /* 1382775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1382792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1382798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1382813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382828 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E16_MASK),
     /* 1382831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382853 */     // GIR_Coverage, 22539,
     /* 1382853 */     GIR_EraseRootFromParent_Done,
     /* 1382854 */   // Label 19626: @1382854
     /* 1382854 */   GIM_Try, /*On fail goto*//*Label 19627*/ GIMT_Encode4(1382938), // Rule ID 22542 //
     /* 1382859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1382862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1382885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1382912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1382915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1382917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1382919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1382921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1382923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1382925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1382930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1382933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1382936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1382937 */     // GIR_Coverage, 22542,
     /* 1382937 */     GIR_EraseRootFromParent_Done,
     /* 1382938 */   // Label 19627: @1382938
     /* 1382938 */   GIM_Try, /*On fail goto*//*Label 19628*/ GIMT_Encode4(1383022), // Rule ID 22543 //
     /* 1382943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1382946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1382951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1382954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1382957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1382960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1382963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1382966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1382969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1382973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1382981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1382985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1382989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1382996 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11431:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1382996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E16_MASK),
     /* 1382999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1383017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383020 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383021 */     // GIR_Coverage, 22543,
     /* 1383021 */     GIR_EraseRootFromParent_Done,
     /* 1383022 */   // Label 19628: @1383022
     /* 1383022 */   GIM_Try, /*On fail goto*//*Label 19629*/ GIMT_Encode4(1383106), // Rule ID 22546 //
     /* 1383027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1383044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383080 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1383083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383105 */     // GIR_Coverage, 22546,
     /* 1383105 */     GIR_EraseRootFromParent_Done,
     /* 1383106 */   // Label 19629: @1383106
     /* 1383106 */   GIM_Try, /*On fail goto*//*Label 19630*/ GIMT_Encode4(1383190), // Rule ID 22547 //
     /* 1383111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1383128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383164 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E32_MASK),
     /* 1383167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383188 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383189 */     // GIR_Coverage, 22547,
     /* 1383189 */     GIR_EraseRootFromParent_Done,
     /* 1383190 */   // Label 19630: @1383190
     /* 1383190 */   GIM_Try, /*On fail goto*//*Label 19631*/ GIMT_Encode4(1383274), // Rule ID 22550 //
     /* 1383195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1383212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383248 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1383251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383272 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383273 */     // GIR_Coverage, 22550,
     /* 1383273 */     GIR_EraseRootFromParent_Done,
     /* 1383274 */   // Label 19631: @1383274
     /* 1383274 */   GIM_Try, /*On fail goto*//*Label 19632*/ GIMT_Encode4(1383358), // Rule ID 22551 //
     /* 1383279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1383296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E32_MASK),
     /* 1383335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383357 */     // GIR_Coverage, 22551,
     /* 1383357 */     GIR_EraseRootFromParent_Done,
     /* 1383358 */   // Label 19632: @1383358
     /* 1383358 */   GIM_Try, /*On fail goto*//*Label 19633*/ GIMT_Encode4(1383442), // Rule ID 22554 //
     /* 1383363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1383366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383416 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1383419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383440 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383441 */     // GIR_Coverage, 22554,
     /* 1383441 */     GIR_EraseRootFromParent_Done,
     /* 1383442 */   // Label 19633: @1383442
     /* 1383442 */   GIM_Try, /*On fail goto*//*Label 19634*/ GIMT_Encode4(1383526), // Rule ID 22555 //
     /* 1383447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1383450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1383458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1383461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1383464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1383467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1383470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383500 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11431:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E32_MASK),
     /* 1383503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1383521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383525 */     // GIR_Coverage, 22555,
     /* 1383525 */     GIR_EraseRootFromParent_Done,
     /* 1383526 */   // Label 19634: @1383526
     /* 1383526 */   GIM_Try, /*On fail goto*//*Label 19635*/ GIMT_Encode4(1383610), // Rule ID 22558 //
     /* 1383531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1383587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383609 */     // GIR_Coverage, 22558,
     /* 1383609 */     GIR_EraseRootFromParent_Done,
     /* 1383610 */   // Label 19635: @1383610
     /* 1383610 */   GIM_Try, /*On fail goto*//*Label 19636*/ GIMT_Encode4(1383694), // Rule ID 22559 //
     /* 1383615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1383632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1383638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1383653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M2_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M2_E64_MASK),
     /* 1383671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383693 */     // GIR_Coverage, 22559,
     /* 1383693 */     GIR_EraseRootFromParent_Done,
     /* 1383694 */   // Label 19636: @1383694
     /* 1383694 */   GIM_Try, /*On fail goto*//*Label 19637*/ GIMT_Encode4(1383778), // Rule ID 22562 //
     /* 1383699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1383755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383777 */     // GIR_Coverage, 22562,
     /* 1383777 */     GIR_EraseRootFromParent_Done,
     /* 1383778 */   // Label 19637: @1383778
     /* 1383778 */   GIM_Try, /*On fail goto*//*Label 19638*/ GIMT_Encode4(1383862), // Rule ID 22563 //
     /* 1383783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1383800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1383806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1383821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383836 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M4_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1383836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M4_E64_MASK),
     /* 1383839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383861 */     // GIR_Coverage, 22563,
     /* 1383861 */     GIR_EraseRootFromParent_Done,
     /* 1383862 */   // Label 19638: @1383862
     /* 1383862 */   GIM_Try, /*On fail goto*//*Label 19639*/ GIMT_Encode4(1383946), // Rule ID 22566 //
     /* 1383867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1383870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1383893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1383920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1383920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1383923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1383925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1383927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1383929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1383931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1383933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1383938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1383941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1383944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1383945 */     // GIR_Coverage, 22566,
     /* 1383945 */     GIR_EraseRootFromParent_Done,
     /* 1383946 */   // Label 19639: @1383946
     /* 1383946 */   GIM_Try, /*On fail goto*//*Label 19640*/ GIMT_Encode4(1384030), // Rule ID 22567 //
     /* 1383951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1383954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vredmax_mask),
     /* 1383959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1383962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1383965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1383968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1383971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1383974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1383977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1383981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1383989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1383993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1383997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384004 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11431:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVREDMAX_VS_M8_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREDMAX_VS_M8_E64_MASK),
     /* 1384007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1384025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384029 */     // GIR_Coverage, 22567,
     /* 1384029 */     GIR_EraseRootFromParent_Done,
     /* 1384030 */   // Label 19640: @1384030
     /* 1384030 */   GIM_Try, /*On fail goto*//*Label 19641*/ GIMT_Encode4(1384114), // Rule ID 22570 //
     /* 1384035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1384052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1384091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384113 */     // GIR_Coverage, 22570,
     /* 1384113 */     GIR_EraseRootFromParent_Done,
     /* 1384114 */   // Label 19641: @1384114
     /* 1384114 */   GIM_Try, /*On fail goto*//*Label 19642*/ GIMT_Encode4(1384198), // Rule ID 22571 //
     /* 1384119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1384136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384172 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF8_E8_MASK),
     /* 1384175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384197 */     // GIR_Coverage, 22571,
     /* 1384197 */     GIR_EraseRootFromParent_Done,
     /* 1384198 */   // Label 19642: @1384198
     /* 1384198 */   GIM_Try, /*On fail goto*//*Label 19643*/ GIMT_Encode4(1384282), // Rule ID 22574 //
     /* 1384203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1384220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1384259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384281 */     // GIR_Coverage, 22574,
     /* 1384281 */     GIR_EraseRootFromParent_Done,
     /* 1384282 */   // Label 19643: @1384282
     /* 1384282 */   GIM_Try, /*On fail goto*//*Label 19644*/ GIMT_Encode4(1384366), // Rule ID 22575 //
     /* 1384287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1384304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384340 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E8_MASK),
     /* 1384343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384364 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384365 */     // GIR_Coverage, 22575,
     /* 1384365 */     GIR_EraseRootFromParent_Done,
     /* 1384366 */   // Label 19644: @1384366
     /* 1384366 */   GIM_Try, /*On fail goto*//*Label 19645*/ GIMT_Encode4(1384450), // Rule ID 22578 //
     /* 1384371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1384427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384449 */     // GIR_Coverage, 22578,
     /* 1384449 */     GIR_EraseRootFromParent_Done,
     /* 1384450 */   // Label 19645: @1384450
     /* 1384450 */   GIM_Try, /*On fail goto*//*Label 19646*/ GIMT_Encode4(1384534), // Rule ID 22579 //
     /* 1384455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1384466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1384469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1384472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1384475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1384478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384508 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E8_MASK),
     /* 1384511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1384529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384533 */     // GIR_Coverage, 22579,
     /* 1384533 */     GIR_EraseRootFromParent_Done,
     /* 1384534 */   // Label 19646: @1384534
     /* 1384534 */   GIM_Try, /*On fail goto*//*Label 19647*/ GIMT_Encode4(1384618), // Rule ID 22582 //
     /* 1384539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1384595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384616 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384617 */     // GIR_Coverage, 22582,
     /* 1384617 */     GIR_EraseRootFromParent_Done,
     /* 1384618 */   // Label 19647: @1384618
     /* 1384618 */   GIM_Try, /*On fail goto*//*Label 19648*/ GIMT_Encode4(1384702), // Rule ID 22583 //
     /* 1384623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1384640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384676 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF4_E16_MASK),
     /* 1384679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384701 */     // GIR_Coverage, 22583,
     /* 1384701 */     GIR_EraseRootFromParent_Done,
     /* 1384702 */   // Label 19648: @1384702
     /* 1384702 */   GIM_Try, /*On fail goto*//*Label 19649*/ GIMT_Encode4(1384786), // Rule ID 22586 //
     /* 1384707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384760 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1384763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384784 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384785 */     // GIR_Coverage, 22586,
     /* 1384785 */     GIR_EraseRootFromParent_Done,
     /* 1384786 */   // Label 19649: @1384786
     /* 1384786 */   GIM_Try, /*On fail goto*//*Label 19650*/ GIMT_Encode4(1384870), // Rule ID 22587 //
     /* 1384791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1384802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1384805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1384808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1384811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1384814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384844 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1384844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E16_MASK),
     /* 1384847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1384865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384869 */     // GIR_Coverage, 22587,
     /* 1384869 */     GIR_EraseRootFromParent_Done,
     /* 1384870 */   // Label 19650: @1384870
     /* 1384870 */   GIM_Try, /*On fail goto*//*Label 19651*/ GIMT_Encode4(1384954), // Rule ID 22590 //
     /* 1384875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1384878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1384901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1384921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1384928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1384928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1384931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1384933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1384935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1384937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1384939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1384941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1384946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1384949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1384952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1384953 */     // GIR_Coverage, 22590,
     /* 1384953 */     GIR_EraseRootFromParent_Done,
     /* 1384954 */   // Label 19651: @1384954
     /* 1384954 */   GIM_Try, /*On fail goto*//*Label 19652*/ GIMT_Encode4(1385038), // Rule ID 22591 //
     /* 1384959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1384962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1384967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1384970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1384973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1384976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1384979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1384982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1384985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1384989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1384997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385012 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_MF2_E32_MASK),
     /* 1385015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385036 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385037 */     // GIR_Coverage, 22591,
     /* 1385037 */     GIR_EraseRootFromParent_Done,
     /* 1385038 */   // Label 19652: @1385038
     /* 1385038 */   GIM_Try, /*On fail goto*//*Label 19653*/ GIMT_Encode4(1385122), // Rule ID 22594 //
     /* 1385043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1385060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1385099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385121 */     // GIR_Coverage, 22594,
     /* 1385121 */     GIR_EraseRootFromParent_Done,
     /* 1385122 */   // Label 19653: @1385122
     /* 1385122 */   GIM_Try, /*On fail goto*//*Label 19654*/ GIMT_Encode4(1385206), // Rule ID 22595 //
     /* 1385127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1385144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1385150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E8_MASK),
     /* 1385183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385205 */     // GIR_Coverage, 22595,
     /* 1385205 */     GIR_EraseRootFromParent_Done,
     /* 1385206 */   // Label 19654: @1385206
     /* 1385206 */   GIM_Try, /*On fail goto*//*Label 19655*/ GIMT_Encode4(1385290), // Rule ID 22598 //
     /* 1385211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1385228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1385267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385288 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385289 */     // GIR_Coverage, 22598,
     /* 1385289 */     GIR_EraseRootFromParent_Done,
     /* 1385290 */   // Label 19655: @1385290
     /* 1385290 */   GIM_Try, /*On fail goto*//*Label 19656*/ GIMT_Encode4(1385374), // Rule ID 22599 //
     /* 1385295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1385306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1385309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1385312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1385315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1385318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E16_MASK),
     /* 1385351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1385369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385373 */     // GIR_Coverage, 22599,
     /* 1385373 */     GIR_EraseRootFromParent_Done,
     /* 1385374 */   // Label 19656: @1385374
     /* 1385374 */   GIM_Try, /*On fail goto*//*Label 19657*/ GIMT_Encode4(1385458), // Rule ID 22602 //
     /* 1385379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385432 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1385435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385456 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385457 */     // GIR_Coverage, 22602,
     /* 1385457 */     GIR_EraseRootFromParent_Done,
     /* 1385458 */   // Label 19657: @1385458
     /* 1385458 */   GIM_Try, /*On fail goto*//*Label 19658*/ GIMT_Encode4(1385542), // Rule ID 22603 //
     /* 1385463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1385474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1385477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1385480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1385483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1385486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385516 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M1_E32_MASK),
     /* 1385519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1385537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385541 */     // GIR_Coverage, 22603,
     /* 1385541 */     GIR_EraseRootFromParent_Done,
     /* 1385542 */   // Label 19658: @1385542
     /* 1385542 */   GIM_Try, /*On fail goto*//*Label 19659*/ GIMT_Encode4(1385626), // Rule ID 22606 //
     /* 1385547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385600 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1385603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385625 */     // GIR_Coverage, 22606,
     /* 1385625 */     GIR_EraseRootFromParent_Done,
     /* 1385626 */   // Label 19659: @1385626
     /* 1385626 */   GIM_Try, /*On fail goto*//*Label 19660*/ GIMT_Encode4(1385710), // Rule ID 22607 //
     /* 1385631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1385648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1385654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1385669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385684 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E8_MASK),
     /* 1385687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385709 */     // GIR_Coverage, 22607,
     /* 1385709 */     GIR_EraseRootFromParent_Done,
     /* 1385710 */   // Label 19660: @1385710
     /* 1385710 */   GIM_Try, /*On fail goto*//*Label 19661*/ GIMT_Encode4(1385794), // Rule ID 22610 //
     /* 1385715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385768 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1385771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385793 */     // GIR_Coverage, 22610,
     /* 1385793 */     GIR_EraseRootFromParent_Done,
     /* 1385794 */   // Label 19661: @1385794
     /* 1385794 */   GIM_Try, /*On fail goto*//*Label 19662*/ GIMT_Encode4(1385878), // Rule ID 22611 //
     /* 1385799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1385816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1385822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1385837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1385852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E8_MASK),
     /* 1385855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385877 */     // GIR_Coverage, 22611,
     /* 1385877 */     GIR_EraseRootFromParent_Done,
     /* 1385878 */   // Label 19662: @1385878
     /* 1385878 */   GIM_Try, /*On fail goto*//*Label 19663*/ GIMT_Encode4(1385962), // Rule ID 22614 //
     /* 1385883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1385886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1385909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1385921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1385925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1385929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1385936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1385936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1385939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1385941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1385943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1385945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1385947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1385949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1385954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1385957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1385960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1385961 */     // GIR_Coverage, 22614,
     /* 1385961 */     GIR_EraseRootFromParent_Done,
     /* 1385962 */   // Label 19663: @1385962
     /* 1385962 */   GIM_Try, /*On fail goto*//*Label 19664*/ GIMT_Encode4(1386046), // Rule ID 22615 //
     /* 1385967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1385970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1385975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1385978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1385981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1385984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1385987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1385990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1385993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1385997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386020 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11595:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E8_MASK),
     /* 1386023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1386041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386045 */     // GIR_Coverage, 22615,
     /* 1386045 */     GIR_EraseRootFromParent_Done,
     /* 1386046 */   // Label 19664: @1386046
     /* 1386046 */   GIM_Try, /*On fail goto*//*Label 19665*/ GIMT_Encode4(1386130), // Rule ID 22618 //
     /* 1386051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1386068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1386107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386129 */     // GIR_Coverage, 22618,
     /* 1386129 */     GIR_EraseRootFromParent_Done,
     /* 1386130 */   // Label 19665: @1386130
     /* 1386130 */   GIM_Try, /*On fail goto*//*Label 19666*/ GIMT_Encode4(1386214), // Rule ID 22619 //
     /* 1386135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1386152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E16_MASK),
     /* 1386191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386213 */     // GIR_Coverage, 22619,
     /* 1386213 */     GIR_EraseRootFromParent_Done,
     /* 1386214 */   // Label 19666: @1386214
     /* 1386214 */   GIM_Try, /*On fail goto*//*Label 19667*/ GIMT_Encode4(1386298), // Rule ID 22622 //
     /* 1386219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1386275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386297 */     // GIR_Coverage, 22622,
     /* 1386297 */     GIR_EraseRootFromParent_Done,
     /* 1386298 */   // Label 19667: @1386298
     /* 1386298 */   GIM_Try, /*On fail goto*//*Label 19668*/ GIMT_Encode4(1386382), // Rule ID 22623 //
     /* 1386303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1386320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386356 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E16_MASK),
     /* 1386359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386380 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386381 */     // GIR_Coverage, 22623,
     /* 1386381 */     GIR_EraseRootFromParent_Done,
     /* 1386382 */   // Label 19668: @1386382
     /* 1386382 */   GIM_Try, /*On fail goto*//*Label 19669*/ GIMT_Encode4(1386466), // Rule ID 22626 //
     /* 1386387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386440 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1386443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386465 */     // GIR_Coverage, 22626,
     /* 1386465 */     GIR_EraseRootFromParent_Done,
     /* 1386466 */   // Label 19669: @1386466
     /* 1386466 */   GIM_Try, /*On fail goto*//*Label 19670*/ GIMT_Encode4(1386550), // Rule ID 22627 //
     /* 1386471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1386482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1386485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1386488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1386491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1386494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386524 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11595:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E16_MASK),
     /* 1386527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1386545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386549 */     // GIR_Coverage, 22627,
     /* 1386549 */     GIR_EraseRootFromParent_Done,
     /* 1386550 */   // Label 19670: @1386550
     /* 1386550 */   GIM_Try, /*On fail goto*//*Label 19671*/ GIMT_Encode4(1386634), // Rule ID 22630 //
     /* 1386555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386608 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1386611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386632 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386633 */     // GIR_Coverage, 22630,
     /* 1386633 */     GIR_EraseRootFromParent_Done,
     /* 1386634 */   // Label 19671: @1386634
     /* 1386634 */   GIM_Try, /*On fail goto*//*Label 19672*/ GIMT_Encode4(1386718), // Rule ID 22631 //
     /* 1386639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1386656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1386662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1386677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386692 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M2_E32_MASK),
     /* 1386695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386717 */     // GIR_Coverage, 22631,
     /* 1386717 */     GIR_EraseRootFromParent_Done,
     /* 1386718 */   // Label 19672: @1386718
     /* 1386718 */   GIM_Try, /*On fail goto*//*Label 19673*/ GIMT_Encode4(1386802), // Rule ID 22634 //
     /* 1386723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386776 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1386779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386800 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386801 */     // GIR_Coverage, 22634,
     /* 1386801 */     GIR_EraseRootFromParent_Done,
     /* 1386802 */   // Label 19673: @1386802
     /* 1386802 */   GIM_Try, /*On fail goto*//*Label 19674*/ GIMT_Encode4(1386886), // Rule ID 22635 //
     /* 1386807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1386824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1386830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1386833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1386845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1386860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M4_E32_MASK),
     /* 1386863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386884 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386885 */     // GIR_Coverage, 22635,
     /* 1386885 */     GIR_EraseRootFromParent_Done,
     /* 1386886 */   // Label 19674: @1386886
     /* 1386886 */   GIM_Try, /*On fail goto*//*Label 19675*/ GIMT_Encode4(1386970), // Rule ID 22638 //
     /* 1386891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1386894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1386917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1386921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1386929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1386933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1386937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1386944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1386944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1386947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1386949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1386951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1386953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1386955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1386957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1386962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1386965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1386968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1386969 */     // GIR_Coverage, 22638,
     /* 1386969 */     GIR_EraseRootFromParent_Done,
     /* 1386970 */   // Label 19675: @1386970
     /* 1386970 */   GIM_Try, /*On fail goto*//*Label 19676*/ GIMT_Encode4(1387054), // Rule ID 22639 //
     /* 1386975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1386978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsumu_mask),
     /* 1386983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1386986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1386989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1386992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1386995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1386998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1387013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387028 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11595:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUMU_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUMU_VS_M8_E32_MASK),
     /* 1387031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387052 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387053 */     // GIR_Coverage, 22639,
     /* 1387053 */     GIR_EraseRootFromParent_Done,
     /* 1387054 */   // Label 19676: @1387054
     /* 1387054 */   GIM_Try, /*On fail goto*//*Label 19677*/ GIMT_Encode4(1387138), // Rule ID 22642 //
     /* 1387059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387112 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1387115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387137 */     // GIR_Coverage, 22642,
     /* 1387137 */     GIR_EraseRootFromParent_Done,
     /* 1387138 */   // Label 19677: @1387138
     /* 1387138 */   GIM_Try, /*On fail goto*//*Label 19678*/ GIMT_Encode4(1387222), // Rule ID 22643 //
     /* 1387143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1387160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387196 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF8_E8_MASK),
     /* 1387199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387221 */     // GIR_Coverage, 22643,
     /* 1387221 */     GIR_EraseRootFromParent_Done,
     /* 1387222 */   // Label 19678: @1387222
     /* 1387222 */   GIM_Try, /*On fail goto*//*Label 19679*/ GIMT_Encode4(1387306), // Rule ID 22646 //
     /* 1387227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1387283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387304 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387305 */     // GIR_Coverage, 22646,
     /* 1387305 */     GIR_EraseRootFromParent_Done,
     /* 1387306 */   // Label 19679: @1387306
     /* 1387306 */   GIM_Try, /*On fail goto*//*Label 19680*/ GIMT_Encode4(1387390), // Rule ID 22647 //
     /* 1387311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1387328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387364 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E8_MASK),
     /* 1387367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387389 */     // GIR_Coverage, 22647,
     /* 1387389 */     GIR_EraseRootFromParent_Done,
     /* 1387390 */   // Label 19680: @1387390
     /* 1387390 */   GIM_Try, /*On fail goto*//*Label 19681*/ GIMT_Encode4(1387474), // Rule ID 22650 //
     /* 1387395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1387451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387473 */     // GIR_Coverage, 22650,
     /* 1387473 */     GIR_EraseRootFromParent_Done,
     /* 1387474 */   // Label 19681: @1387474
     /* 1387474 */   GIM_Try, /*On fail goto*//*Label 19682*/ GIMT_Encode4(1387558), // Rule ID 22651 //
     /* 1387479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1387490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1387493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1387496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1387499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1387502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387532 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E8_MASK),
     /* 1387535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1387553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387557 */     // GIR_Coverage, 22651,
     /* 1387557 */     GIR_EraseRootFromParent_Done,
     /* 1387558 */   // Label 19682: @1387558
     /* 1387558 */   GIM_Try, /*On fail goto*//*Label 19683*/ GIMT_Encode4(1387642), // Rule ID 22654 //
     /* 1387563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387616 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1387619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387641 */     // GIR_Coverage, 22654,
     /* 1387641 */     GIR_EraseRootFromParent_Done,
     /* 1387642 */   // Label 19683: @1387642
     /* 1387642 */   GIM_Try, /*On fail goto*//*Label 19684*/ GIMT_Encode4(1387726), // Rule ID 22655 //
     /* 1387647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1387664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF4_E16_MASK),
     /* 1387703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387725 */     // GIR_Coverage, 22655,
     /* 1387725 */     GIR_EraseRootFromParent_Done,
     /* 1387726 */   // Label 19684: @1387726
     /* 1387726 */   GIM_Try, /*On fail goto*//*Label 19685*/ GIMT_Encode4(1387810), // Rule ID 22658 //
     /* 1387731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387784 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1387787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387809 */     // GIR_Coverage, 22658,
     /* 1387809 */     GIR_EraseRootFromParent_Done,
     /* 1387810 */   // Label 19685: @1387810
     /* 1387810 */   GIM_Try, /*On fail goto*//*Label 19686*/ GIMT_Encode4(1387894), // Rule ID 22659 //
     /* 1387815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1387826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1387829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1387832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1387835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1387838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1387841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1387868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E16_MASK),
     /* 1387871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1387889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387893 */     // GIR_Coverage, 22659,
     /* 1387893 */     GIR_EraseRootFromParent_Done,
     /* 1387894 */   // Label 19686: @1387894
     /* 1387894 */   GIM_Try, /*On fail goto*//*Label 19687*/ GIMT_Encode4(1387978), // Rule ID 22662 //
     /* 1387899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1387902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1387916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1387919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1387922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1387925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1387929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1387941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1387945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1387952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1387952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1387955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1387957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1387959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1387961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1387963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1387965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1387970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1387973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1387976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1387977 */     // GIR_Coverage, 22662,
     /* 1387977 */     GIR_EraseRootFromParent_Done,
     /* 1387978 */   // Label 19687: @1387978
     /* 1387978 */   GIM_Try, /*On fail goto*//*Label 19688*/ GIMT_Encode4(1388062), // Rule ID 22663 //
     /* 1387983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1387986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1387991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1387994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1387997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1388000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1388006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388036 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_MF2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_MF2_E32_MASK),
     /* 1388039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388061 */     // GIR_Coverage, 22663,
     /* 1388061 */     GIR_EraseRootFromParent_Done,
     /* 1388062 */   // Label 19688: @1388062
     /* 1388062 */   GIM_Try, /*On fail goto*//*Label 19689*/ GIMT_Encode4(1388146), // Rule ID 22666 //
     /* 1388067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1388123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388145 */     // GIR_Coverage, 22666,
     /* 1388145 */     GIR_EraseRootFromParent_Done,
     /* 1388146 */   // Label 19689: @1388146
     /* 1388146 */   GIM_Try, /*On fail goto*//*Label 19690*/ GIMT_Encode4(1388230), // Rule ID 22667 //
     /* 1388151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1388168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1388174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388204 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E8_MASK),
     /* 1388207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388228 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388229 */     // GIR_Coverage, 22667,
     /* 1388229 */     GIR_EraseRootFromParent_Done,
     /* 1388230 */   // Label 19690: @1388230
     /* 1388230 */   GIM_Try, /*On fail goto*//*Label 19691*/ GIMT_Encode4(1388314), // Rule ID 22670 //
     /* 1388235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388288 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1388291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388313 */     // GIR_Coverage, 22670,
     /* 1388313 */     GIR_EraseRootFromParent_Done,
     /* 1388314 */   // Label 19691: @1388314
     /* 1388314 */   GIM_Try, /*On fail goto*//*Label 19692*/ GIMT_Encode4(1388398), // Rule ID 22671 //
     /* 1388319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1388330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1388333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1388336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1388339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1388342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388372 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E16_MASK),
     /* 1388375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1388393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388396 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388397 */     // GIR_Coverage, 22671,
     /* 1388397 */     GIR_EraseRootFromParent_Done,
     /* 1388398 */   // Label 19692: @1388398
     /* 1388398 */   GIM_Try, /*On fail goto*//*Label 19693*/ GIMT_Encode4(1388482), // Rule ID 22674 //
     /* 1388403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388456 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1388459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388481 */     // GIR_Coverage, 22674,
     /* 1388481 */     GIR_EraseRootFromParent_Done,
     /* 1388482 */   // Label 19693: @1388482
     /* 1388482 */   GIM_Try, /*On fail goto*//*Label 19694*/ GIMT_Encode4(1388566), // Rule ID 22675 //
     /* 1388487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1388498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1388501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1388504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1388507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1388510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M1_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M1_E32_MASK),
     /* 1388543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1388561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388565 */     // GIR_Coverage, 22675,
     /* 1388565 */     GIR_EraseRootFromParent_Done,
     /* 1388566 */   // Label 19694: @1388566
     /* 1388566 */   GIM_Try, /*On fail goto*//*Label 19695*/ GIMT_Encode4(1388650), // Rule ID 22678 //
     /* 1388571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1388627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388648 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388649 */     // GIR_Coverage, 22678,
     /* 1388649 */     GIR_EraseRootFromParent_Done,
     /* 1388650 */   // Label 19695: @1388650
     /* 1388650 */   GIM_Try, /*On fail goto*//*Label 19696*/ GIMT_Encode4(1388734), // Rule ID 22679 //
     /* 1388655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1388672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1388678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1388693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388708 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E8_MASK),
     /* 1388711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388733 */     // GIR_Coverage, 22679,
     /* 1388733 */     GIR_EraseRootFromParent_Done,
     /* 1388734 */   // Label 19696: @1388734
     /* 1388734 */   GIM_Try, /*On fail goto*//*Label 19697*/ GIMT_Encode4(1388818), // Rule ID 22682 //
     /* 1388739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388792 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1388795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388817 */     // GIR_Coverage, 22682,
     /* 1388817 */     GIR_EraseRootFromParent_Done,
     /* 1388818 */   // Label 19697: @1388818
     /* 1388818 */   GIM_Try, /*On fail goto*//*Label 19698*/ GIMT_Encode4(1388902), // Rule ID 22683 //
     /* 1388823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1388840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1388846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1388849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1388861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388876 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1388876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E8_MASK),
     /* 1388879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388900 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388901 */     // GIR_Coverage, 22683,
     /* 1388901 */     GIR_EraseRootFromParent_Done,
     /* 1388902 */   // Label 19698: @1388902
     /* 1388902 */   GIM_Try, /*On fail goto*//*Label 19699*/ GIMT_Encode4(1388986), // Rule ID 22686 //
     /* 1388907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1388910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1388918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1388921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1388924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1388927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1388930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1388933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1388937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1388945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1388949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1388953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1388960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 1388960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1388963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1388965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1388967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1388969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1388971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1388973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1388978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1388981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1388984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1388985 */     // GIR_Coverage, 22686,
     /* 1388985 */     GIR_EraseRootFromParent_Done,
     /* 1388986 */   // Label 19699: @1388986
     /* 1388986 */   GIM_Try, /*On fail goto*//*Label 19700*/ GIMT_Encode4(1389070), // Rule ID 22687 //
     /* 1388991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1388994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1388999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1389002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1389005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1389008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1389011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1389014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389044 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11593:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E8_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E8_MASK),
     /* 1389047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1389065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389068 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389069 */     // GIR_Coverage, 22687,
     /* 1389069 */     GIR_EraseRootFromParent_Done,
     /* 1389070 */   // Label 19700: @1389070
     /* 1389070 */   GIM_Try, /*On fail goto*//*Label 19701*/ GIMT_Encode4(1389154), // Rule ID 22690 //
     /* 1389075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389128 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1389131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389153 */     // GIR_Coverage, 22690,
     /* 1389153 */     GIR_EraseRootFromParent_Done,
     /* 1389154 */   // Label 19701: @1389154
     /* 1389154 */   GIM_Try, /*On fail goto*//*Label 19702*/ GIMT_Encode4(1389238), // Rule ID 22691 //
     /* 1389159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1389176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E16_MASK),
     /* 1389215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389237 */     // GIR_Coverage, 22691,
     /* 1389237 */     GIR_EraseRootFromParent_Done,
     /* 1389238 */   // Label 19702: @1389238
     /* 1389238 */   GIM_Try, /*On fail goto*//*Label 19703*/ GIMT_Encode4(1389322), // Rule ID 22694 //
     /* 1389243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389296 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1389299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389321 */     // GIR_Coverage, 22694,
     /* 1389321 */     GIR_EraseRootFromParent_Done,
     /* 1389322 */   // Label 19703: @1389322
     /* 1389322 */   GIM_Try, /*On fail goto*//*Label 19704*/ GIMT_Encode4(1389406), // Rule ID 22695 //
     /* 1389327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1389344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E16_MASK),
     /* 1389383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389405 */     // GIR_Coverage, 22695,
     /* 1389405 */     GIR_EraseRootFromParent_Done,
     /* 1389406 */   // Label 19704: @1389406
     /* 1389406 */   GIM_Try, /*On fail goto*//*Label 19705*/ GIMT_Encode4(1389490), // Rule ID 22698 //
     /* 1389411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389464 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1389467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389489 */     // GIR_Coverage, 22698,
     /* 1389489 */     GIR_EraseRootFromParent_Done,
     /* 1389490 */   // Label 19705: @1389490
     /* 1389490 */   GIM_Try, /*On fail goto*//*Label 19706*/ GIMT_Encode4(1389574), // Rule ID 22699 //
     /* 1389495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1389506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1389509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1389512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1389515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1389518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389548 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11593:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E16_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E16_MASK),
     /* 1389551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1389569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389573 */     // GIR_Coverage, 22699,
     /* 1389573 */     GIR_EraseRootFromParent_Done,
     /* 1389574 */   // Label 19706: @1389574
     /* 1389574 */   GIM_Try, /*On fail goto*//*Label 19707*/ GIMT_Encode4(1389658), // Rule ID 22702 //
     /* 1389579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389632 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1389635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389657 */     // GIR_Coverage, 22702,
     /* 1389657 */     GIR_EraseRootFromParent_Done,
     /* 1389658 */   // Label 19707: @1389658
     /* 1389658 */   GIM_Try, /*On fail goto*//*Label 19708*/ GIMT_Encode4(1389742), // Rule ID 22703 //
     /* 1389663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1389680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1389686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1389701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389716 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M2_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M2_E32_MASK),
     /* 1389719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389741 */     // GIR_Coverage, 22703,
     /* 1389741 */     GIR_EraseRootFromParent_Done,
     /* 1389742 */   // Label 19708: @1389742
     /* 1389742 */   GIM_Try, /*On fail goto*//*Label 19709*/ GIMT_Encode4(1389826), // Rule ID 22706 //
     /* 1389747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389800 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1389803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389825 */     // GIR_Coverage, 22706,
     /* 1389825 */     GIR_EraseRootFromParent_Done,
     /* 1389826 */   // Label 19709: @1389826
     /* 1389826 */   GIM_Try, /*On fail goto*//*Label 19710*/ GIMT_Encode4(1389910), // Rule ID 22707 //
     /* 1389831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1389834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1389848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1389854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1389857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1389869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M4_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1389884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M4_E32_MASK),
     /* 1389887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389909 */     // GIR_Coverage, 22707,
     /* 1389909 */     GIR_EraseRootFromParent_Done,
     /* 1389910 */   // Label 19710: @1389910
     /* 1389910 */   GIM_Try, /*On fail goto*//*Label 19711*/ GIMT_Encode4(1389994), // Rule ID 22710 //
     /* 1389915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1389918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1389923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1389926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1389929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1389932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1389935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1389938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1389941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1389945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1389953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1389957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1389961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1389968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1389968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1389971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1389973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1389975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1389977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1389979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1389981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1389986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1389989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1389992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1389993 */     // GIR_Coverage, 22710,
     /* 1389993 */     GIR_EraseRootFromParent_Done,
     /* 1389994 */   // Label 19711: @1389994
     /* 1389994 */   GIM_Try, /*On fail goto*//*Label 19712*/ GIMT_Encode4(1390078), // Rule ID 22711 //
     /* 1389999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1390002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwredsum_mask),
     /* 1390007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1390016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1390022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1390037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390052 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11593:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVWREDSUM_VS_M8_E32_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWREDSUM_VS_M8_E32_MASK),
     /* 1390055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390077 */     // GIR_Coverage, 22711,
     /* 1390077 */     GIR_EraseRootFromParent_Done,
     /* 1390078 */   // Label 19712: @1390078
     /* 1390078 */   GIM_Try, /*On fail goto*//*Label 19713*/ GIMT_Encode4(1390162), // Rule ID 22830 //
     /* 1390083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1390086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1390100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390136 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1390139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390161 */     // GIR_Coverage, 22830,
     /* 1390161 */     GIR_EraseRootFromParent_Done,
     /* 1390162 */   // Label 19713: @1390162
     /* 1390162 */   GIM_Try, /*On fail goto*//*Label 19714*/ GIMT_Encode4(1390246), // Rule ID 22831 //
     /* 1390167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1390170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1390184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390220 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF4_E16_MASK),
     /* 1390223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390244 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390245 */     // GIR_Coverage, 22831,
     /* 1390245 */     GIR_EraseRootFromParent_Done,
     /* 1390246 */   // Label 19714: @1390246
     /* 1390246 */   GIM_Try, /*On fail goto*//*Label 19715*/ GIMT_Encode4(1390330), // Rule ID 22834 //
     /* 1390251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1390254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1390268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390304 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1390307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390329 */     // GIR_Coverage, 22834,
     /* 1390329 */     GIR_EraseRootFromParent_Done,
     /* 1390330 */   // Label 19715: @1390330
     /* 1390330 */   GIM_Try, /*On fail goto*//*Label 19716*/ GIMT_Encode4(1390414), // Rule ID 22835 //
     /* 1390335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1390338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1390352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390388 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E16_MASK),
     /* 1390391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390412 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390413 */     // GIR_Coverage, 22835,
     /* 1390413 */     GIR_EraseRootFromParent_Done,
     /* 1390414 */   // Label 19716: @1390414
     /* 1390414 */   GIM_Try, /*On fail goto*//*Label 19717*/ GIMT_Encode4(1390498), // Rule ID 22838 //
     /* 1390419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1390422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1390436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1390475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390496 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390497 */     // GIR_Coverage, 22838,
     /* 1390497 */     GIR_EraseRootFromParent_Done,
     /* 1390498 */   // Label 19717: @1390498
     /* 1390498 */   GIM_Try, /*On fail goto*//*Label 19718*/ GIMT_Encode4(1390582), // Rule ID 22839 //
     /* 1390503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1390506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1390520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_MF2_E32_MASK),
     /* 1390559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390581 */     // GIR_Coverage, 22839,
     /* 1390581 */     GIR_EraseRootFromParent_Done,
     /* 1390582 */   // Label 19718: @1390582
     /* 1390582 */   GIM_Try, /*On fail goto*//*Label 19719*/ GIMT_Encode4(1390666), // Rule ID 22842 //
     /* 1390587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1390590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1390604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390640 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1390643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390664 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390665 */     // GIR_Coverage, 22842,
     /* 1390665 */     GIR_EraseRootFromParent_Done,
     /* 1390666 */   // Label 19719: @1390666
     /* 1390666 */   GIM_Try, /*On fail goto*//*Label 19720*/ GIMT_Encode4(1390750), // Rule ID 22843 //
     /* 1390671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1390674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1390682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1390685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1390688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1390691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1390694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390724 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E16_MASK),
     /* 1390727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1390745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390749 */     // GIR_Coverage, 22843,
     /* 1390749 */     GIR_EraseRootFromParent_Done,
     /* 1390750 */   // Label 19720: @1390750
     /* 1390750 */   GIM_Try, /*On fail goto*//*Label 19721*/ GIMT_Encode4(1390834), // Rule ID 22846 //
     /* 1390755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1390758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1390772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390808 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1390811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390833 */     // GIR_Coverage, 22846,
     /* 1390833 */     GIR_EraseRootFromParent_Done,
     /* 1390834 */   // Label 19721: @1390834
     /* 1390834 */   GIM_Try, /*On fail goto*//*Label 19722*/ GIMT_Encode4(1390918), // Rule ID 22847 //
     /* 1390839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1390842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1390850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1390853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1390856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1390859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1390862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1390865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1390892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E32_MASK),
     /* 1390895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1390913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1390916 */     GIR_RootConstrainSelectedInstOperands,
     /* 1390917 */     // GIR_Coverage, 22847,
     /* 1390917 */     GIR_EraseRootFromParent_Done,
     /* 1390918 */   // Label 19722: @1390918
     /* 1390918 */   GIM_Try, /*On fail goto*//*Label 19723*/ GIMT_Encode4(1391002), // Rule ID 22850 //
     /* 1390923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1390926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1390931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1390934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1390937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1390940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1390943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1390946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1390949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1390953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1390965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1390969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1390976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1390976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1390979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1390981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1390983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1390985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1390987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1390989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1390994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1390997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391001 */     // GIR_Coverage, 22850,
     /* 1391001 */     GIR_EraseRootFromParent_Done,
     /* 1391002 */   // Label 19723: @1391002
     /* 1391002 */   GIM_Try, /*On fail goto*//*Label 19724*/ GIMT_Encode4(1391086), // Rule ID 22851 //
     /* 1391007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1391010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1391018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1391021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1391024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1391027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1391030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391060 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M1_E64_MASK),
     /* 1391063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1391081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391085 */     // GIR_Coverage, 22851,
     /* 1391085 */     GIR_EraseRootFromParent_Done,
     /* 1391086 */   // Label 19724: @1391086
     /* 1391086 */   GIM_Try, /*On fail goto*//*Label 19725*/ GIMT_Encode4(1391170), // Rule ID 22854 //
     /* 1391091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1391094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1391108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1391147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391168 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391169 */     // GIR_Coverage, 22854,
     /* 1391169 */     GIR_EraseRootFromParent_Done,
     /* 1391170 */   // Label 19725: @1391170
     /* 1391170 */   GIM_Try, /*On fail goto*//*Label 19726*/ GIMT_Encode4(1391254), // Rule ID 22855 //
     /* 1391175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1391178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1391192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391228 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E16_MASK),
     /* 1391231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391253 */     // GIR_Coverage, 22855,
     /* 1391253 */     GIR_EraseRootFromParent_Done,
     /* 1391254 */   // Label 19726: @1391254
     /* 1391254 */   GIM_Try, /*On fail goto*//*Label 19727*/ GIMT_Encode4(1391338), // Rule ID 22858 //
     /* 1391259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1391262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1391276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391312 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1391315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391337 */     // GIR_Coverage, 22858,
     /* 1391337 */     GIR_EraseRootFromParent_Done,
     /* 1391338 */   // Label 19727: @1391338
     /* 1391338 */   GIM_Try, /*On fail goto*//*Label 19728*/ GIMT_Encode4(1391422), // Rule ID 22859 //
     /* 1391343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1391346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1391360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391396 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E16_MASK),
     /* 1391399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391421 */     // GIR_Coverage, 22859,
     /* 1391421 */     GIR_EraseRootFromParent_Done,
     /* 1391422 */   // Label 19728: @1391422
     /* 1391422 */   GIM_Try, /*On fail goto*//*Label 19729*/ GIMT_Encode4(1391506), // Rule ID 22862 //
     /* 1391427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1391430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1391444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1391450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391480 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1391483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391505 */     // GIR_Coverage, 22862,
     /* 1391505 */     GIR_EraseRootFromParent_Done,
     /* 1391506 */   // Label 19729: @1391506
     /* 1391506 */   GIM_Try, /*On fail goto*//*Label 19730*/ GIMT_Encode4(1391590), // Rule ID 22863 //
     /* 1391511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1391514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1391522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1391525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1391528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1391531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1391534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391564 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11187:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E16_MASK),
     /* 1391567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1391585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391589 */     // GIR_Coverage, 22863,
     /* 1391589 */     GIR_EraseRootFromParent_Done,
     /* 1391590 */   // Label 19730: @1391590
     /* 1391590 */   GIM_Try, /*On fail goto*//*Label 19731*/ GIMT_Encode4(1391674), // Rule ID 22866 //
     /* 1391595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1391612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391648 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1391651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391673 */     // GIR_Coverage, 22866,
     /* 1391673 */     GIR_EraseRootFromParent_Done,
     /* 1391674 */   // Label 19731: @1391674
     /* 1391674 */   GIM_Try, /*On fail goto*//*Label 19732*/ GIMT_Encode4(1391758), // Rule ID 22867 //
     /* 1391679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1391682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1391696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1391702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1391717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391732 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E32_MASK),
     /* 1391735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391757 */     // GIR_Coverage, 22867,
     /* 1391757 */     GIR_EraseRootFromParent_Done,
     /* 1391758 */   // Label 19732: @1391758
     /* 1391758 */   GIM_Try, /*On fail goto*//*Label 19733*/ GIMT_Encode4(1391842), // Rule ID 22870 //
     /* 1391763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391816 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1391819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391841 */     // GIR_Coverage, 22870,
     /* 1391841 */     GIR_EraseRootFromParent_Done,
     /* 1391842 */   // Label 19733: @1391842
     /* 1391842 */   GIM_Try, /*On fail goto*//*Label 19734*/ GIMT_Encode4(1391926), // Rule ID 22871 //
     /* 1391847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1391850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1391864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1391870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1391873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1391885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1391900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E32_MASK),
     /* 1391903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1391918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1391921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1391924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1391925 */     // GIR_Coverage, 22871,
     /* 1391925 */     GIR_EraseRootFromParent_Done,
     /* 1391926 */   // Label 19734: @1391926
     /* 1391926 */   GIM_Try, /*On fail goto*//*Label 19735*/ GIMT_Encode4(1392010), // Rule ID 22874 //
     /* 1391931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1391934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1391939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1391942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1391945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1391948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1391951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1391954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1391957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1391961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1391969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1391973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1391977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1391984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1391984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1391987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1391989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1391991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1391993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1391995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1391997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392008 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392009 */     // GIR_Coverage, 22874,
     /* 1392009 */     GIR_EraseRootFromParent_Done,
     /* 1392010 */   // Label 19735: @1392010
     /* 1392010 */   GIM_Try, /*On fail goto*//*Label 19736*/ GIMT_Encode4(1392094), // Rule ID 22875 //
     /* 1392015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1392018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1392032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1392038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392068 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11187:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E32_MASK),
     /* 1392071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1392089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392093 */     // GIR_Coverage, 22875,
     /* 1392093 */     GIR_EraseRootFromParent_Done,
     /* 1392094 */   // Label 19736: @1392094
     /* 1392094 */   GIM_Try, /*On fail goto*//*Label 19737*/ GIMT_Encode4(1392178), // Rule ID 22878 //
     /* 1392099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1392102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1392116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392152 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1392155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392177 */     // GIR_Coverage, 22878,
     /* 1392177 */     GIR_EraseRootFromParent_Done,
     /* 1392178 */   // Label 19737: @1392178
     /* 1392178 */   GIM_Try, /*On fail goto*//*Label 19738*/ GIMT_Encode4(1392262), // Rule ID 22879 //
     /* 1392183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1392186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1392200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1392221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392236 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M2_E64_MASK),
     /* 1392239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392260 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392261 */     // GIR_Coverage, 22879,
     /* 1392261 */     GIR_EraseRootFromParent_Done,
     /* 1392262 */   // Label 19738: @1392262
     /* 1392262 */   GIM_Try, /*On fail goto*//*Label 19739*/ GIMT_Encode4(1392346), // Rule ID 22882 //
     /* 1392267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1392270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1392284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392320 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1392323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392345 */     // GIR_Coverage, 22882,
     /* 1392345 */     GIR_EraseRootFromParent_Done,
     /* 1392346 */   // Label 19739: @1392346
     /* 1392346 */   GIM_Try, /*On fail goto*//*Label 19740*/ GIMT_Encode4(1392430), // Rule ID 22883 //
     /* 1392351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1392354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1392368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1392374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1392389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392404 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M4_E64_MASK),
     /* 1392407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392429 */     // GIR_Coverage, 22883,
     /* 1392429 */     GIR_EraseRootFromParent_Done,
     /* 1392430 */   // Label 19740: @1392430
     /* 1392430 */   GIM_Try, /*On fail goto*//*Label 19741*/ GIMT_Encode4(1392514), // Rule ID 22886 //
     /* 1392435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1392438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1392452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392488 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1392491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392512 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392513 */     // GIR_Coverage, 22886,
     /* 1392513 */     GIR_EraseRootFromParent_Done,
     /* 1392514 */   // Label 19741: @1392514
     /* 1392514 */   GIM_Try, /*On fail goto*//*Label 19742*/ GIMT_Encode4(1392598), // Rule ID 22887 //
     /* 1392519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1392522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmin_mask),
     /* 1392527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1392530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1392533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1392536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1392539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1392542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1392557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392572 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11187:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMIN_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMIN_VS_M8_E64_MASK),
     /* 1392575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1392593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392597 */     // GIR_Coverage, 22887,
     /* 1392597 */     GIR_EraseRootFromParent_Done,
     /* 1392598 */   // Label 19742: @1392598
     /* 1392598 */   GIM_Try, /*On fail goto*//*Label 19743*/ GIMT_Encode4(1392682), // Rule ID 22890 //
     /* 1392603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1392606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1392611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1392620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392656 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1392659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392680 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392681 */     // GIR_Coverage, 22890,
     /* 1392681 */     GIR_EraseRootFromParent_Done,
     /* 1392682 */   // Label 19743: @1392682
     /* 1392682 */   GIM_Try, /*On fail goto*//*Label 19744*/ GIMT_Encode4(1392766), // Rule ID 22891 //
     /* 1392687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1392690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1392695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1392704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392740 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF4_E16_MASK),
     /* 1392743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392765 */     // GIR_Coverage, 22891,
     /* 1392765 */     GIR_EraseRootFromParent_Done,
     /* 1392766 */   // Label 19744: @1392766
     /* 1392766 */   GIM_Try, /*On fail goto*//*Label 19745*/ GIMT_Encode4(1392850), // Rule ID 22894 //
     /* 1392771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1392774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1392779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392824 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1392827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392849 */     // GIR_Coverage, 22894,
     /* 1392849 */     GIR_EraseRootFromParent_Done,
     /* 1392850 */   // Label 19745: @1392850
     /* 1392850 */   GIM_Try, /*On fail goto*//*Label 19746*/ GIMT_Encode4(1392934), // Rule ID 22895 //
     /* 1392855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1392858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1392863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1392866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1392869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1392872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1392875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1392878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1392881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392908 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1392908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E16_MASK),
     /* 1392911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1392917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1392919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1392921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1392926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1392929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1392932 */     GIR_RootConstrainSelectedInstOperands,
     /* 1392933 */     // GIR_Coverage, 22895,
     /* 1392933 */     GIR_EraseRootFromParent_Done,
     /* 1392934 */   // Label 19746: @1392934
     /* 1392934 */   GIM_Try, /*On fail goto*//*Label 19747*/ GIMT_Encode4(1393018), // Rule ID 22898 //
     /* 1392939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1392942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1392947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1392950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1392953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1392956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1392959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1392962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1392965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1392969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1392981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1392985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1392992 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1392992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1392995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1392997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1392999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393017 */     // GIR_Coverage, 22898,
     /* 1393017 */     GIR_EraseRootFromParent_Done,
     /* 1393018 */   // Label 19747: @1393018
     /* 1393018 */   GIM_Try, /*On fail goto*//*Label 19748*/ GIMT_Encode4(1393102), // Rule ID 22899 //
     /* 1393023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1393026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1393040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393076 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_MF2_E32_MASK),
     /* 1393079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393101 */     // GIR_Coverage, 22899,
     /* 1393101 */     GIR_EraseRootFromParent_Done,
     /* 1393102 */   // Label 19748: @1393102
     /* 1393102 */   GIM_Try, /*On fail goto*//*Label 19749*/ GIMT_Encode4(1393186), // Rule ID 22902 //
     /* 1393107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1393110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1393124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393160 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1393163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393184 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393185 */     // GIR_Coverage, 22902,
     /* 1393185 */     GIR_EraseRootFromParent_Done,
     /* 1393186 */   // Label 19749: @1393186
     /* 1393186 */   GIM_Try, /*On fail goto*//*Label 19750*/ GIMT_Encode4(1393270), // Rule ID 22903 //
     /* 1393191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1393194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1393208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1393214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393244 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E16_MASK),
     /* 1393247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393269 */     // GIR_Coverage, 22903,
     /* 1393269 */     GIR_EraseRootFromParent_Done,
     /* 1393270 */   // Label 19750: @1393270
     /* 1393270 */   GIM_Try, /*On fail goto*//*Label 19751*/ GIMT_Encode4(1393354), // Rule ID 22906 //
     /* 1393275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1393278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1393292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393328 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1393331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393353 */     // GIR_Coverage, 22906,
     /* 1393353 */     GIR_EraseRootFromParent_Done,
     /* 1393354 */   // Label 19751: @1393354
     /* 1393354 */   GIM_Try, /*On fail goto*//*Label 19752*/ GIMT_Encode4(1393438), // Rule ID 22907 //
     /* 1393359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1393362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1393370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1393373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1393376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1393379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1393382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E32_MASK),
     /* 1393415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1393433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393437 */     // GIR_Coverage, 22907,
     /* 1393437 */     GIR_EraseRootFromParent_Done,
     /* 1393438 */   // Label 19752: @1393438
     /* 1393438 */   GIM_Try, /*On fail goto*//*Label 19753*/ GIMT_Encode4(1393522), // Rule ID 22910 //
     /* 1393443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1393446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1393460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393496 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1393499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1393517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393521 */     // GIR_Coverage, 22910,
     /* 1393521 */     GIR_EraseRootFromParent_Done,
     /* 1393522 */   // Label 19753: @1393522
     /* 1393522 */   GIM_Try, /*On fail goto*//*Label 19754*/ GIMT_Encode4(1393606), // Rule ID 22911 //
     /* 1393527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1393530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1393538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1393541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1393544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1393547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1393550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393580 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M1_E64_MASK),
     /* 1393583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1393601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393605 */     // GIR_Coverage, 22911,
     /* 1393605 */     GIR_EraseRootFromParent_Done,
     /* 1393606 */   // Label 19754: @1393606
     /* 1393606 */   GIM_Try, /*On fail goto*//*Label 19755*/ GIMT_Encode4(1393690), // Rule ID 22914 //
     /* 1393611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1393614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393664 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1393667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393689 */     // GIR_Coverage, 22914,
     /* 1393689 */     GIR_EraseRootFromParent_Done,
     /* 1393690 */   // Label 19755: @1393690
     /* 1393690 */   GIM_Try, /*On fail goto*//*Label 19756*/ GIMT_Encode4(1393774), // Rule ID 22915 //
     /* 1393695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1393698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1393712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1393718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1393733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393748 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E16_MASK),
     /* 1393751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393773 */     // GIR_Coverage, 22915,
     /* 1393773 */     GIR_EraseRootFromParent_Done,
     /* 1393774 */   // Label 19756: @1393774
     /* 1393774 */   GIM_Try, /*On fail goto*//*Label 19757*/ GIMT_Encode4(1393858), // Rule ID 22918 //
     /* 1393779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1393782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393832 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1393832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1393835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393857 */     // GIR_Coverage, 22918,
     /* 1393857 */     GIR_EraseRootFromParent_Done,
     /* 1393858 */   // Label 19757: @1393858
     /* 1393858 */   GIM_Try, /*On fail goto*//*Label 19758*/ GIMT_Encode4(1393942), // Rule ID 22919 //
     /* 1393863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1393866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1393880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1393886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1393889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1393901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1393916 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1393916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E16_MASK),
     /* 1393919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1393921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1393923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1393925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1393927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1393929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1393934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1393937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1393940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1393941 */     // GIR_Coverage, 22919,
     /* 1393941 */     GIR_EraseRootFromParent_Done,
     /* 1393942 */   // Label 19758: @1393942
     /* 1393942 */   GIM_Try, /*On fail goto*//*Label 19759*/ GIMT_Encode4(1394026), // Rule ID 22922 //
     /* 1393947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1393950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1393955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1393958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1393961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1393964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1393967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1393970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1393973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1393977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1393985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1393989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1393993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394000 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1394003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394024 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394025 */     // GIR_Coverage, 22922,
     /* 1394025 */     GIR_EraseRootFromParent_Done,
     /* 1394026 */   // Label 19759: @1394026
     /* 1394026 */   GIM_Try, /*On fail goto*//*Label 19760*/ GIMT_Encode4(1394110), // Rule ID 22923 //
     /* 1394031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1394034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1394042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1394045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1394048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1394051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1394054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394084 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11185:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E16_MASK),
     /* 1394087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1394105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394108 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394109 */     // GIR_Coverage, 22923,
     /* 1394109 */     GIR_EraseRootFromParent_Done,
     /* 1394110 */   // Label 19760: @1394110
     /* 1394110 */   GIM_Try, /*On fail goto*//*Label 19761*/ GIMT_Encode4(1394194), // Rule ID 22926 //
     /* 1394115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1394118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1394132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394168 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1394171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394193 */     // GIR_Coverage, 22926,
     /* 1394193 */     GIR_EraseRootFromParent_Done,
     /* 1394194 */   // Label 19761: @1394194
     /* 1394194 */   GIM_Try, /*On fail goto*//*Label 19762*/ GIMT_Encode4(1394278), // Rule ID 22927 //
     /* 1394199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1394202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1394216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394252 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E32_MASK),
     /* 1394255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394276 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394277 */     // GIR_Coverage, 22927,
     /* 1394277 */     GIR_EraseRootFromParent_Done,
     /* 1394278 */   // Label 19762: @1394278
     /* 1394278 */   GIM_Try, /*On fail goto*//*Label 19763*/ GIMT_Encode4(1394362), // Rule ID 22930 //
     /* 1394283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1394286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1394300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394336 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1394339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394361 */     // GIR_Coverage, 22930,
     /* 1394361 */     GIR_EraseRootFromParent_Done,
     /* 1394362 */   // Label 19763: @1394362
     /* 1394362 */   GIM_Try, /*On fail goto*//*Label 19764*/ GIMT_Encode4(1394446), // Rule ID 22931 //
     /* 1394367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1394370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1394384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E32_MASK),
     /* 1394423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394445 */     // GIR_Coverage, 22931,
     /* 1394445 */     GIR_EraseRootFromParent_Done,
     /* 1394446 */   // Label 19764: @1394446
     /* 1394446 */   GIM_Try, /*On fail goto*//*Label 19765*/ GIMT_Encode4(1394530), // Rule ID 22934 //
     /* 1394451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1394454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394504 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1394507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394529 */     // GIR_Coverage, 22934,
     /* 1394529 */     GIR_EraseRootFromParent_Done,
     /* 1394530 */   // Label 19765: @1394530
     /* 1394530 */   GIM_Try, /*On fail goto*//*Label 19766*/ GIMT_Encode4(1394614), // Rule ID 22935 //
     /* 1394535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1394538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1394546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1394549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1394552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1394555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1394558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394588 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11185:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E32_MASK),
     /* 1394591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1394609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394613 */     // GIR_Coverage, 22935,
     /* 1394613 */     GIR_EraseRootFromParent_Done,
     /* 1394614 */   // Label 19766: @1394614
     /* 1394614 */   GIM_Try, /*On fail goto*//*Label 19767*/ GIMT_Encode4(1394698), // Rule ID 22938 //
     /* 1394619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1394622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1394636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394672 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1394675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394697 */     // GIR_Coverage, 22938,
     /* 1394697 */     GIR_EraseRootFromParent_Done,
     /* 1394698 */   // Label 19767: @1394698
     /* 1394698 */   GIM_Try, /*On fail goto*//*Label 19768*/ GIMT_Encode4(1394782), // Rule ID 22939 //
     /* 1394703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1394706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1394720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1394726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1394741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394756 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M2_E64_MASK),
     /* 1394759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394780 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394781 */     // GIR_Coverage, 22939,
     /* 1394781 */     GIR_EraseRootFromParent_Done,
     /* 1394782 */   // Label 19768: @1394782
     /* 1394782 */   GIM_Try, /*On fail goto*//*Label 19769*/ GIMT_Encode4(1394866), // Rule ID 22942 //
     /* 1394787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1394790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1394804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394840 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1394840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1394843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394865 */     // GIR_Coverage, 22942,
     /* 1394865 */     GIR_EraseRootFromParent_Done,
     /* 1394866 */   // Label 19769: @1394866
     /* 1394866 */   GIM_Try, /*On fail goto*//*Label 19770*/ GIMT_Encode4(1394950), // Rule ID 22943 //
     /* 1394871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1394874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1394888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1394894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1394897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1394909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1394917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1394924 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1394924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M4_E64_MASK),
     /* 1394927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1394929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1394931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1394933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1394935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1394937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1394942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1394945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1394948 */     GIR_RootConstrainSelectedInstOperands,
     /* 1394949 */     // GIR_Coverage, 22943,
     /* 1394949 */     GIR_EraseRootFromParent_Done,
     /* 1394950 */   // Label 19770: @1394950
     /* 1394950 */   GIM_Try, /*On fail goto*//*Label 19771*/ GIMT_Encode4(1395034), // Rule ID 22946 //
     /* 1394955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1394958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1394963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1394966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1394969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1394972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1394975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1394978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1394981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1394985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1394993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1394997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395008 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1395008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1395011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1395029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395033 */     // GIR_Coverage, 22946,
     /* 1395033 */     GIR_EraseRootFromParent_Done,
     /* 1395034 */   // Label 19771: @1395034
     /* 1395034 */   GIM_Try, /*On fail goto*//*Label 19772*/ GIMT_Encode4(1395118), // Rule ID 22947 //
     /* 1395039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1395042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredmax_mask),
     /* 1395047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1395050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1395053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1395056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1395059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1395062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1395077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395092 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11185:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDMAX_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1395092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDMAX_VS_M8_E64_MASK),
     /* 1395095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1395099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1395103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1395113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1395116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395117 */     // GIR_Coverage, 22947,
     /* 1395117 */     GIR_EraseRootFromParent_Done,
     /* 1395118 */   // Label 19772: @1395118
     /* 1395118 */   GIM_Reject,
     /* 1395119 */ // Label 13792: @1395119
     /* 1395119 */ GIM_Try, /*On fail goto*//*Label 19773*/ GIMT_Encode4(2004276),
     /* 1395124 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /* 1395127 */   GIM_Try, /*On fail goto*//*Label 19774*/ GIMT_Encode4(1395213), // Rule ID 7240 //
     /* 1395132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1395143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1395146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1395149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395178 */     // MIs[0] policy
     /* 1395178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1395191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395212 */     // GIR_Coverage, 7240,
     /* 1395212 */     GIR_EraseRootFromParent_Done,
     /* 1395213 */   // Label 19774: @1395213
     /* 1395213 */   GIM_Try, /*On fail goto*//*Label 19775*/ GIMT_Encode4(1395299), // Rule ID 7241 //
     /* 1395218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1395229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1395232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1395235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395256 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395264 */     // MIs[0] policy
     /* 1395264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1395277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395298 */     // GIR_Coverage, 7241,
     /* 1395298 */     GIR_EraseRootFromParent_Done,
     /* 1395299 */   // Label 19775: @1395299
     /* 1395299 */   GIM_Try, /*On fail goto*//*Label 19776*/ GIMT_Encode4(1395385), // Rule ID 7244 //
     /* 1395304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1395315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1395318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1395321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395342 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395350 */     // MIs[0] policy
     /* 1395350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1395363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395384 */     // GIR_Coverage, 7244,
     /* 1395384 */     GIR_EraseRootFromParent_Done,
     /* 1395385 */   // Label 19776: @1395385
     /* 1395385 */   GIM_Try, /*On fail goto*//*Label 19777*/ GIMT_Encode4(1395471), // Rule ID 7245 //
     /* 1395390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1395401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1395404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1395407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395436 */     // MIs[0] policy
     /* 1395436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1395449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395470 */     // GIR_Coverage, 7245,
     /* 1395470 */     GIR_EraseRootFromParent_Done,
     /* 1395471 */   // Label 19777: @1395471
     /* 1395471 */   GIM_Try, /*On fail goto*//*Label 19778*/ GIMT_Encode4(1395557), // Rule ID 7248 //
     /* 1395476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1395487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1395490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1395493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395522 */     // MIs[0] policy
     /* 1395522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1395535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395556 */     // GIR_Coverage, 7248,
     /* 1395556 */     GIR_EraseRootFromParent_Done,
     /* 1395557 */   // Label 19778: @1395557
     /* 1395557 */   GIM_Try, /*On fail goto*//*Label 19779*/ GIMT_Encode4(1395643), // Rule ID 7249 //
     /* 1395562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1395573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1395576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1395579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1395585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395608 */     // MIs[0] policy
     /* 1395608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1395621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1395639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395642 */     // GIR_Coverage, 7249,
     /* 1395642 */     GIR_EraseRootFromParent_Done,
     /* 1395643 */   // Label 19779: @1395643
     /* 1395643 */   GIM_Try, /*On fail goto*//*Label 19780*/ GIMT_Encode4(1395729), // Rule ID 7252 //
     /* 1395648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1395659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1395662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1395665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395686 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395694 */     // MIs[0] policy
     /* 1395694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1395707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395728 */     // GIR_Coverage, 7252,
     /* 1395728 */     GIR_EraseRootFromParent_Done,
     /* 1395729 */   // Label 19780: @1395729
     /* 1395729 */   GIM_Try, /*On fail goto*//*Label 19781*/ GIMT_Encode4(1395815), // Rule ID 7253 //
     /* 1395734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1395745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1395748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1395751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1395757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395780 */     // MIs[0] policy
     /* 1395780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1395793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395814 */     // GIR_Coverage, 7253,
     /* 1395814 */     GIR_EraseRootFromParent_Done,
     /* 1395815 */   // Label 19781: @1395815
     /* 1395815 */   GIM_Try, /*On fail goto*//*Label 19782*/ GIMT_Encode4(1395901), // Rule ID 7256 //
     /* 1395820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1395831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1395834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1395837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1395840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1395846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395866 */     // MIs[0] policy
     /* 1395866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1395876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1395879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395900 */     // GIR_Coverage, 7256,
     /* 1395900 */     GIR_EraseRootFromParent_Done,
     /* 1395901 */   // Label 19782: @1395901
     /* 1395901 */   GIM_Try, /*On fail goto*//*Label 19783*/ GIMT_Encode4(1395987), // Rule ID 7257 //
     /* 1395906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1395909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1395914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1395917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1395920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1395923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1395926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1395929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1395932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1395936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1395944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1395948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1395952 */     // MIs[0] policy
     /* 1395952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1395955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1395962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1395962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1395965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1395967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1395969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1395973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1395975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1395980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1395983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1395985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1395986 */     // GIR_Coverage, 7257,
     /* 1395986 */     GIR_EraseRootFromParent_Done,
     /* 1395987 */   // Label 19783: @1395987
     /* 1395987 */   GIM_Try, /*On fail goto*//*Label 19784*/ GIMT_Encode4(1396073), // Rule ID 7260 //
     /* 1395992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1395995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1396003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1396006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1396009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396038 */     // MIs[0] policy
     /* 1396038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1396051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396072 */     // GIR_Coverage, 7260,
     /* 1396072 */     GIR_EraseRootFromParent_Done,
     /* 1396073 */   // Label 19784: @1396073
     /* 1396073 */   GIM_Try, /*On fail goto*//*Label 19785*/ GIMT_Encode4(1396159), // Rule ID 7261 //
     /* 1396078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1396089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1396092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1396095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396124 */     // MIs[0] policy
     /* 1396124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1396137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396158 */     // GIR_Coverage, 7261,
     /* 1396158 */     GIR_EraseRootFromParent_Done,
     /* 1396159 */   // Label 19785: @1396159
     /* 1396159 */   GIM_Try, /*On fail goto*//*Label 19786*/ GIMT_Encode4(1396245), // Rule ID 7264 //
     /* 1396164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1396175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1396178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1396181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396202 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396210 */     // MIs[0] policy
     /* 1396210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396244 */     // GIR_Coverage, 7264,
     /* 1396244 */     GIR_EraseRootFromParent_Done,
     /* 1396245 */   // Label 19786: @1396245
     /* 1396245 */   GIM_Try, /*On fail goto*//*Label 19787*/ GIMT_Encode4(1396331), // Rule ID 7265 //
     /* 1396250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1396261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1396264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1396267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1396273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396296 */     // MIs[0] policy
     /* 1396296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396330 */     // GIR_Coverage, 7265,
     /* 1396330 */     GIR_EraseRootFromParent_Done,
     /* 1396331 */   // Label 19787: @1396331
     /* 1396331 */   GIM_Try, /*On fail goto*//*Label 19788*/ GIMT_Encode4(1396417), // Rule ID 7268 //
     /* 1396336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1396353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396374 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396382 */     // MIs[0] policy
     /* 1396382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396416 */     // GIR_Coverage, 7268,
     /* 1396416 */     GIR_EraseRootFromParent_Done,
     /* 1396417 */   // Label 19788: @1396417
     /* 1396417 */   GIM_Try, /*On fail goto*//*Label 19789*/ GIMT_Encode4(1396503), // Rule ID 7269 //
     /* 1396422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1396433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1396436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1396439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1396445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396468 */     // MIs[0] policy
     /* 1396468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1396499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396502 */     // GIR_Coverage, 7269,
     /* 1396502 */     GIR_EraseRootFromParent_Done,
     /* 1396503 */   // Label 19789: @1396503
     /* 1396503 */   GIM_Try, /*On fail goto*//*Label 19790*/ GIMT_Encode4(1396589), // Rule ID 7272 //
     /* 1396508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1396525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396554 */     // MIs[0] policy
     /* 1396554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396588 */     // GIR_Coverage, 7272,
     /* 1396588 */     GIR_EraseRootFromParent_Done,
     /* 1396589 */   // Label 19790: @1396589
     /* 1396589 */   GIM_Try, /*On fail goto*//*Label 19791*/ GIMT_Encode4(1396675), // Rule ID 7273 //
     /* 1396594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1396605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1396608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1396611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1396617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396640 */     // MIs[0] policy
     /* 1396640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1396671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396674 */     // GIR_Coverage, 7273,
     /* 1396674 */     GIR_EraseRootFromParent_Done,
     /* 1396675 */   // Label 19791: @1396675
     /* 1396675 */   GIM_Try, /*On fail goto*//*Label 19792*/ GIMT_Encode4(1396761), // Rule ID 7276 //
     /* 1396680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1396683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1396697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396726 */     // MIs[0] policy
     /* 1396726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396760 */     // GIR_Coverage, 7276,
     /* 1396760 */     GIR_EraseRootFromParent_Done,
     /* 1396761 */   // Label 19792: @1396761
     /* 1396761 */   GIM_Try, /*On fail goto*//*Label 19793*/ GIMT_Encode4(1396847), // Rule ID 7277 //
     /* 1396766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1396769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1396777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1396780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1396783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1396789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1396796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1396804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396812 */     // MIs[0] policy
     /* 1396812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1396825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1396843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396846 */     // GIR_Coverage, 7277,
     /* 1396846 */     GIR_EraseRootFromParent_Done,
     /* 1396847 */   // Label 19793: @1396847
     /* 1396847 */   GIM_Try, /*On fail goto*//*Label 19794*/ GIMT_Encode4(1396933), // Rule ID 7280 //
     /* 1396852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1396855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1396863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1396866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1396869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1396872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1396878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1396882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396898 */     // MIs[0] policy
     /* 1396898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1396908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1396911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1396915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1396919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1396921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1396926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1396929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1396931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1396932 */     // GIR_Coverage, 7280,
     /* 1396932 */     GIR_EraseRootFromParent_Done,
     /* 1396933 */   // Label 19794: @1396933
     /* 1396933 */   GIM_Try, /*On fail goto*//*Label 19795*/ GIMT_Encode4(1397019), // Rule ID 7281 //
     /* 1396938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1396941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1396946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1396949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1396952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1396955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1396958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1396961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1396964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1396968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1396976 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1396980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1396984 */     // MIs[0] policy
     /* 1396984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1396987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1396994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1396994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1396997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1396999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397018 */     // GIR_Coverage, 7281,
     /* 1397018 */     GIR_EraseRootFromParent_Done,
     /* 1397019 */   // Label 19795: @1397019
     /* 1397019 */   GIM_Try, /*On fail goto*//*Label 19796*/ GIMT_Encode4(1397105), // Rule ID 7284 //
     /* 1397024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1397035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1397038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1397041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1397047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1397054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397070 */     // MIs[0] policy
     /* 1397070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1397083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397104 */     // GIR_Coverage, 7284,
     /* 1397104 */     GIR_EraseRootFromParent_Done,
     /* 1397105 */   // Label 19796: @1397105
     /* 1397105 */   GIM_Try, /*On fail goto*//*Label 19797*/ GIMT_Encode4(1397191), // Rule ID 7285 //
     /* 1397110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1397121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1397124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1397127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1397133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1397140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397156 */     // MIs[0] policy
     /* 1397156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1397169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397190 */     // GIR_Coverage, 7285,
     /* 1397190 */     GIR_EraseRootFromParent_Done,
     /* 1397191 */   // Label 19797: @1397191
     /* 1397191 */   GIM_Try, /*On fail goto*//*Label 19798*/ GIMT_Encode4(1397277), // Rule ID 7288 //
     /* 1397196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1397207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1397210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1397213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1397219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1397226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397242 */     // MIs[0] policy
     /* 1397242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1397255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397276 */     // GIR_Coverage, 7288,
     /* 1397276 */     GIR_EraseRootFromParent_Done,
     /* 1397277 */   // Label 19798: @1397277
     /* 1397277 */   GIM_Try, /*On fail goto*//*Label 19799*/ GIMT_Encode4(1397363), // Rule ID 7289 //
     /* 1397282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1397293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1397296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1397299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1397305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1397312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397320 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397328 */     // MIs[0] policy
     /* 1397328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1397341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1397359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397362 */     // GIR_Coverage, 7289,
     /* 1397362 */     GIR_EraseRootFromParent_Done,
     /* 1397363 */   // Label 19799: @1397363
     /* 1397363 */   GIM_Try, /*On fail goto*//*Label 19800*/ GIMT_Encode4(1397449), // Rule ID 7292 //
     /* 1397368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1397379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1397382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1397398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397414 */     // MIs[0] policy
     /* 1397414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1397427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397448 */     // GIR_Coverage, 7292,
     /* 1397448 */     GIR_EraseRootFromParent_Done,
     /* 1397449 */   // Label 19800: @1397449
     /* 1397449 */   GIM_Try, /*On fail goto*//*Label 19801*/ GIMT_Encode4(1397535), // Rule ID 7293 //
     /* 1397454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1397465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1397468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1397471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1397477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1397484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397492 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397500 */     // MIs[0] policy
     /* 1397500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1397513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397534 */     // GIR_Coverage, 7293,
     /* 1397534 */     GIR_EraseRootFromParent_Done,
     /* 1397535 */   // Label 19801: @1397535
     /* 1397535 */   GIM_Try, /*On fail goto*//*Label 19802*/ GIMT_Encode4(1397621), // Rule ID 7296 //
     /* 1397540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1397551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1397554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1397570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397586 */     // MIs[0] policy
     /* 1397586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1397599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397620 */     // GIR_Coverage, 7296,
     /* 1397620 */     GIR_EraseRootFromParent_Done,
     /* 1397621 */   // Label 19802: @1397621
     /* 1397621 */   GIM_Try, /*On fail goto*//*Label 19803*/ GIMT_Encode4(1397707), // Rule ID 7297 //
     /* 1397626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1397637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1397640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1397643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1397649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1397656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1397664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397672 */     // MIs[0] policy
     /* 1397672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1397685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397706 */     // GIR_Coverage, 7297,
     /* 1397706 */     GIR_EraseRootFromParent_Done,
     /* 1397707 */   // Label 19803: @1397707
     /* 1397707 */   GIM_Try, /*On fail goto*//*Label 19804*/ GIMT_Encode4(1397793), // Rule ID 7300 //
     /* 1397712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1397723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1397726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1397729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1397735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1397742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397750 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397758 */     // MIs[0] policy
     /* 1397758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1397771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397792 */     // GIR_Coverage, 7300,
     /* 1397792 */     GIR_EraseRootFromParent_Done,
     /* 1397793 */   // Label 19804: @1397793
     /* 1397793 */   GIM_Try, /*On fail goto*//*Label 19805*/ GIMT_Encode4(1397879), // Rule ID 7301 //
     /* 1397798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1397809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1397812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1397815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1397821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1397828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1397836 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397844 */     // MIs[0] policy
     /* 1397844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1397854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1397857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1397875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397878 */     // GIR_Coverage, 7301,
     /* 1397878 */     GIR_EraseRootFromParent_Done,
     /* 1397879 */   // Label 19805: @1397879
     /* 1397879 */   GIM_Try, /*On fail goto*//*Label 19806*/ GIMT_Encode4(1397965), // Rule ID 7304 //
     /* 1397884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1397887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1397895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1397898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1397901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1397904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1397910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1397914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1397922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1397926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1397930 */     // MIs[0] policy
     /* 1397930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1397933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1397940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1397940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1397943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1397945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1397947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1397951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1397953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1397958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1397961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1397963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1397964 */     // GIR_Coverage, 7304,
     /* 1397964 */     GIR_EraseRootFromParent_Done,
     /* 1397965 */   // Label 19806: @1397965
     /* 1397965 */   GIM_Try, /*On fail goto*//*Label 19807*/ GIMT_Encode4(1398051), // Rule ID 7305 //
     /* 1397970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1397973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1397978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1397981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1397984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1397987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1397990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1397993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1397996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398008 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398016 */     // MIs[0] policy
     /* 1398016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1398029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398050 */     // GIR_Coverage, 7305,
     /* 1398050 */     GIR_EraseRootFromParent_Done,
     /* 1398051 */   // Label 19807: @1398051
     /* 1398051 */   GIM_Try, /*On fail goto*//*Label 19808*/ GIMT_Encode4(1398137), // Rule ID 7308 //
     /* 1398056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1398067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1398070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398094 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398102 */     // MIs[0] policy
     /* 1398102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1398115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398136 */     // GIR_Coverage, 7308,
     /* 1398136 */     GIR_EraseRootFromParent_Done,
     /* 1398137 */   // Label 19808: @1398137
     /* 1398137 */   GIM_Try, /*On fail goto*//*Label 19809*/ GIMT_Encode4(1398223), // Rule ID 7309 //
     /* 1398142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1398153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1398156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1398159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398188 */     // MIs[0] policy
     /* 1398188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1398201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398222 */     // GIR_Coverage, 7309,
     /* 1398222 */     GIR_EraseRootFromParent_Done,
     /* 1398223 */   // Label 19809: @1398223
     /* 1398223 */   GIM_Try, /*On fail goto*//*Label 19810*/ GIMT_Encode4(1398309), // Rule ID 7312 //
     /* 1398228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1398231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1398239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1398242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398274 */     // MIs[0] policy
     /* 1398274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1398287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398308 */     // GIR_Coverage, 7312,
     /* 1398308 */     GIR_EraseRootFromParent_Done,
     /* 1398309 */   // Label 19810: @1398309
     /* 1398309 */   GIM_Try, /*On fail goto*//*Label 19811*/ GIMT_Encode4(1398395), // Rule ID 7313 //
     /* 1398314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1398317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1398325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1398328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1398331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1398337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398352 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398360 */     // MIs[0] policy
     /* 1398360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1398373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1398391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398394 */     // GIR_Coverage, 7313,
     /* 1398394 */     GIR_EraseRootFromParent_Done,
     /* 1398395 */   // Label 19811: @1398395
     /* 1398395 */   GIM_Try, /*On fail goto*//*Label 19812*/ GIMT_Encode4(1398481), // Rule ID 7316 //
     /* 1398400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1398403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1398411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1398414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398446 */     // MIs[0] policy
     /* 1398446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1398459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398480 */     // GIR_Coverage, 7316,
     /* 1398480 */     GIR_EraseRootFromParent_Done,
     /* 1398481 */   // Label 19812: @1398481
     /* 1398481 */   GIM_Try, /*On fail goto*//*Label 19813*/ GIMT_Encode4(1398567), // Rule ID 7317 //
     /* 1398486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1398489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1398497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1398500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1398503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1398509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1398516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1398524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398532 */     // MIs[0] policy
     /* 1398532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1398545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398566 */     // GIR_Coverage, 7317,
     /* 1398566 */     GIR_EraseRootFromParent_Done,
     /* 1398567 */   // Label 19813: @1398567
     /* 1398567 */   GIM_Try, /*On fail goto*//*Label 19814*/ GIMT_Encode4(1398653), // Rule ID 7320 //
     /* 1398572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1398575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1398583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1398586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398618 */     // MIs[0] policy
     /* 1398618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1398631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398652 */     // GIR_Coverage, 7320,
     /* 1398652 */     GIR_EraseRootFromParent_Done,
     /* 1398653 */   // Label 19814: @1398653
     /* 1398653 */   GIM_Try, /*On fail goto*//*Label 19815*/ GIMT_Encode4(1398739), // Rule ID 7321 //
     /* 1398658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1398661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1398669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1398672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1398675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1398681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1398688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1398696 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398704 */     // MIs[0] policy
     /* 1398704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1398717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398738 */     // GIR_Coverage, 7321,
     /* 1398738 */     GIR_EraseRootFromParent_Done,
     /* 1398739 */   // Label 19815: @1398739
     /* 1398739 */   GIM_Try, /*On fail goto*//*Label 19816*/ GIMT_Encode4(1398825), // Rule ID 7324 //
     /* 1398744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1398747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1398755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1398758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1398761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1398764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398790 */     // MIs[0] policy
     /* 1398790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i64] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1398803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398824 */     // GIR_Coverage, 7324,
     /* 1398824 */     GIR_EraseRootFromParent_Done,
     /* 1398825 */   // Label 19816: @1398825
     /* 1398825 */   GIM_Try, /*On fail goto*//*Label 19817*/ GIMT_Encode4(1398911), // Rule ID 7325 //
     /* 1398830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1398833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1398838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1398841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1398844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1398847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1398850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1398853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1398856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1398860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1398868 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /* 1398872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398876 */     // MIs[0] policy
     /* 1398876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, 1:{ *:[i32] }, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1398886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1398889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1398897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1398899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1398907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398910 */     // GIR_Coverage, 7325,
     /* 1398910 */     GIR_EraseRootFromParent_Done,
     /* 1398911 */   // Label 19817: @1398911
     /* 1398911 */   GIM_Try, /*On fail goto*//*Label 19818*/ GIMT_Encode4(1398999), // Rule ID 2638 //
     /* 1398916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1398919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1398924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1398927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1398930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1398933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1398936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1398939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1398943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1398951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1398955 */     // MIs[0] Operand 5
     /* 1398955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1398966 */     // MIs[0] policy
     /* 1398966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1398969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1398976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1398976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1398979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1398981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1398983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1398985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1398987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1398992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1398995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1398997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1398998 */     // GIR_Coverage, 2638,
     /* 1398998 */     GIR_EraseRootFromParent_Done,
     /* 1398999 */   // Label 19818: @1398999
     /* 1398999 */   GIM_Try, /*On fail goto*//*Label 19819*/ GIMT_Encode4(1399087), // Rule ID 2639 //
     /* 1399004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1399007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1399015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1399018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1399021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1399024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399043 */     // MIs[0] Operand 5
     /* 1399043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399054 */     // MIs[0] policy
     /* 1399054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399064 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4_MASK),
     /* 1399067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399086 */     // GIR_Coverage, 2639,
     /* 1399086 */     GIR_EraseRootFromParent_Done,
     /* 1399087 */   // Label 19819: @1399087
     /* 1399087 */   GIM_Try, /*On fail goto*//*Label 19820*/ GIMT_Encode4(1399175), // Rule ID 20522 //
     /* 1399092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1399095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1399103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1399106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1399112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399131 */     // MIs[0] Operand 5
     /* 1399131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399142 */     // MIs[0] policy
     /* 1399142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1399155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399174 */     // GIR_Coverage, 20522,
     /* 1399174 */     GIR_EraseRootFromParent_Done,
     /* 1399175 */   // Label 19820: @1399175
     /* 1399175 */   GIM_Try, /*On fail goto*//*Label 19821*/ GIMT_Encode4(1399263), // Rule ID 20523 //
     /* 1399180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1399183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1399191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1399194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1399197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1399200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399219 */     // MIs[0] Operand 5
     /* 1399219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399230 */     // MIs[0] policy
     /* 1399230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1399243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399262 */     // GIR_Coverage, 20523,
     /* 1399262 */     GIR_EraseRootFromParent_Done,
     /* 1399263 */   // Label 19821: @1399263
     /* 1399263 */   GIM_Try, /*On fail goto*//*Label 19822*/ GIMT_Encode4(1399351), // Rule ID 20526 //
     /* 1399268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1399271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1399279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1399282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1399288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399307 */     // MIs[0] Operand 5
     /* 1399307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399318 */     // MIs[0] policy
     /* 1399318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1399331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399350 */     // GIR_Coverage, 20526,
     /* 1399350 */     GIR_EraseRootFromParent_Done,
     /* 1399351 */   // Label 19822: @1399351
     /* 1399351 */   GIM_Try, /*On fail goto*//*Label 19823*/ GIMT_Encode4(1399439), // Rule ID 20527 //
     /* 1399356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1399359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1399367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1399370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1399373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1399376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399395 */     // MIs[0] Operand 5
     /* 1399395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399406 */     // MIs[0] policy
     /* 1399406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399416 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2_MASK),
     /* 1399419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399438 */     // GIR_Coverage, 20527,
     /* 1399438 */     GIR_EraseRootFromParent_Done,
     /* 1399439 */   // Label 19823: @1399439
     /* 1399439 */   GIM_Try, /*On fail goto*//*Label 19824*/ GIMT_Encode4(1399527), // Rule ID 20530 //
     /* 1399444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1399447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1399464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399483 */     // MIs[0] Operand 5
     /* 1399483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399494 */     // MIs[0] policy
     /* 1399494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399504 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399526 */     // GIR_Coverage, 20530,
     /* 1399526 */     GIR_EraseRootFromParent_Done,
     /* 1399527 */   // Label 19824: @1399527
     /* 1399527 */   GIM_Try, /*On fail goto*//*Label 19825*/ GIMT_Encode4(1399615), // Rule ID 20531 //
     /* 1399532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1399535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1399543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1399546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1399549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1399552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399571 */     // MIs[0] Operand 5
     /* 1399571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399582 */     // MIs[0] policy
     /* 1399582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399592 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1399611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399614 */     // GIR_Coverage, 20531,
     /* 1399614 */     GIR_EraseRootFromParent_Done,
     /* 1399615 */   // Label 19825: @1399615
     /* 1399615 */   GIM_Try, /*On fail goto*//*Label 19826*/ GIMT_Encode4(1399703), // Rule ID 20534 //
     /* 1399620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1399623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1399640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399659 */     // MIs[0] Operand 5
     /* 1399659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399670 */     // MIs[0] policy
     /* 1399670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399680 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399702 */     // GIR_Coverage, 20534,
     /* 1399702 */     GIR_EraseRootFromParent_Done,
     /* 1399703 */   // Label 19826: @1399703
     /* 1399703 */   GIM_Try, /*On fail goto*//*Label 19827*/ GIMT_Encode4(1399791), // Rule ID 20535 //
     /* 1399708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1399711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1399719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1399722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1399725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1399728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399747 */     // MIs[0] Operand 5
     /* 1399747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399758 */     // MIs[0] policy
     /* 1399758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1399787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399790 */     // GIR_Coverage, 20535,
     /* 1399790 */     GIR_EraseRootFromParent_Done,
     /* 1399791 */   // Label 19827: @1399791
     /* 1399791 */   GIM_Try, /*On fail goto*//*Label 19828*/ GIMT_Encode4(1399879), // Rule ID 20538 //
     /* 1399796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1399799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1399813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1399816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399835 */     // MIs[0] Operand 5
     /* 1399835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399846 */     // MIs[0] policy
     /* 1399846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1399856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399878 */     // GIR_Coverage, 20538,
     /* 1399878 */     GIR_EraseRootFromParent_Done,
     /* 1399879 */   // Label 19828: @1399879
     /* 1399879 */   GIM_Try, /*On fail goto*//*Label 19829*/ GIMT_Encode4(1399967), // Rule ID 20539 //
     /* 1399884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1399887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1399895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1399898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1399901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1399904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1399907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1399911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1399919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1399923 */     // MIs[0] Operand 5
     /* 1399923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1399934 */     // MIs[0] policy
     /* 1399934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1399937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1399944 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1399944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1_MASK),
     /* 1399947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1399949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1399951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1399953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1399955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1399960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1399963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1399965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1399966 */     // GIR_Coverage, 20539,
     /* 1399966 */     GIR_EraseRootFromParent_Done,
     /* 1399967 */   // Label 19829: @1399967
     /* 1399967 */   GIM_Try, /*On fail goto*//*Label 19830*/ GIMT_Encode4(1400055), // Rule ID 20542 //
     /* 1399972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1399975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1399980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1399983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1399986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1399989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1399992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1399995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1399999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400011 */     // MIs[0] Operand 5
     /* 1400011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400022 */     // MIs[0] policy
     /* 1400022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400032 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1400035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400054 */     // GIR_Coverage, 20542,
     /* 1400054 */     GIR_EraseRootFromParent_Done,
     /* 1400055 */   // Label 19830: @1400055
     /* 1400055 */   GIM_Try, /*On fail goto*//*Label 19831*/ GIMT_Encode4(1400143), // Rule ID 20543 //
     /* 1400060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1400063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1400071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1400074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1400077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1400080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1400087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400099 */     // MIs[0] Operand 5
     /* 1400099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400110 */     // MIs[0] policy
     /* 1400110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400120 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1400123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400142 */     // GIR_Coverage, 20543,
     /* 1400142 */     GIR_EraseRootFromParent_Done,
     /* 1400143 */   // Label 19831: @1400143
     /* 1400143 */   GIM_Try, /*On fail goto*//*Label 19832*/ GIMT_Encode4(1400231), // Rule ID 20546 //
     /* 1400148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1400151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1400159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1400162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1400168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400187 */     // MIs[0] Operand 5
     /* 1400187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400198 */     // MIs[0] policy
     /* 1400198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400208 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1400211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400230 */     // GIR_Coverage, 20546,
     /* 1400230 */     GIR_EraseRootFromParent_Done,
     /* 1400231 */   // Label 19832: @1400231
     /* 1400231 */   GIM_Try, /*On fail goto*//*Label 19833*/ GIMT_Encode4(1400319), // Rule ID 20547 //
     /* 1400236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1400239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1400247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1400250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1400253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1400256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400275 */     // MIs[0] Operand 5
     /* 1400275 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400286 */     // MIs[0] policy
     /* 1400286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400296 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1400299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400318 */     // GIR_Coverage, 20547,
     /* 1400318 */     GIR_EraseRootFromParent_Done,
     /* 1400319 */   // Label 19833: @1400319
     /* 1400319 */   GIM_Try, /*On fail goto*//*Label 19834*/ GIMT_Encode4(1400407), // Rule ID 20550 //
     /* 1400324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1400327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1400335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1400338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1400344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400363 */     // MIs[0] Operand 5
     /* 1400363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400374 */     // MIs[0] policy
     /* 1400374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400384 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1400387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400406 */     // GIR_Coverage, 20550,
     /* 1400406 */     GIR_EraseRootFromParent_Done,
     /* 1400407 */   // Label 19834: @1400407
     /* 1400407 */   GIM_Try, /*On fail goto*//*Label 19835*/ GIMT_Encode4(1400495), // Rule ID 20551 //
     /* 1400412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1400415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1400423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1400426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1400429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1400432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400451 */     // MIs[0] Operand 5
     /* 1400451 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400462 */     // MIs[0] policy
     /* 1400462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1400475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1400491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400494 */     // GIR_Coverage, 20551,
     /* 1400494 */     GIR_EraseRootFromParent_Done,
     /* 1400495 */   // Label 19835: @1400495
     /* 1400495 */   GIM_Try, /*On fail goto*//*Label 19836*/ GIMT_Encode4(1400583), // Rule ID 20554 //
     /* 1400500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1400503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1400511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1400514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1400520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1400527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400539 */     // MIs[0] Operand 5
     /* 1400539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400550 */     // MIs[0] policy
     /* 1400550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1400563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400582 */     // GIR_Coverage, 20554,
     /* 1400582 */     GIR_EraseRootFromParent_Done,
     /* 1400583 */   // Label 19836: @1400583
     /* 1400583 */   GIM_Try, /*On fail goto*//*Label 19837*/ GIMT_Encode4(1400671), // Rule ID 20555 //
     /* 1400588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1400591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1400599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1400602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1400605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1400608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1400615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1400623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400627 */     // MIs[0] Operand 5
     /* 1400627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400638 */     // MIs[0] policy
     /* 1400638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1400651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400670 */     // GIR_Coverage, 20555,
     /* 1400670 */     GIR_EraseRootFromParent_Done,
     /* 1400671 */   // Label 19837: @1400671
     /* 1400671 */   GIM_Try, /*On fail goto*//*Label 19838*/ GIMT_Encode4(1400759), // Rule ID 20558 //
     /* 1400676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1400679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1400687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1400690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1400696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400715 */     // MIs[0] Operand 5
     /* 1400715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400726 */     // MIs[0] policy
     /* 1400726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1400739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400758 */     // GIR_Coverage, 20558,
     /* 1400758 */     GIR_EraseRootFromParent_Done,
     /* 1400759 */   // Label 19838: @1400759
     /* 1400759 */   GIM_Try, /*On fail goto*//*Label 19839*/ GIMT_Encode4(1400847), // Rule ID 20559 //
     /* 1400764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1400767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1400775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1400778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1400781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1400784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1400791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1400799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400803 */     // MIs[0] Operand 5
     /* 1400803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400814 */     // MIs[0] policy
     /* 1400814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1400824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1400827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400846 */     // GIR_Coverage, 20559,
     /* 1400846 */     GIR_EraseRootFromParent_Done,
     /* 1400847 */   // Label 19839: @1400847
     /* 1400847 */   GIM_Try, /*On fail goto*//*Label 19840*/ GIMT_Encode4(1400935), // Rule ID 20562 //
     /* 1400852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1400855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1400863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1400866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1400869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1400872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1400875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400891 */     // MIs[0] Operand 5
     /* 1400891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400902 */     // MIs[0] policy
     /* 1400902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1400912 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1400912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1400915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1400917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1400919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1400921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1400923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1400928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1400931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1400933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1400934 */     // GIR_Coverage, 20562,
     /* 1400934 */     GIR_EraseRootFromParent_Done,
     /* 1400935 */   // Label 19840: @1400935
     /* 1400935 */   GIM_Try, /*On fail goto*//*Label 19841*/ GIMT_Encode4(1401023), // Rule ID 20563 //
     /* 1400940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1400943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1400948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1400951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1400954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1400957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1400960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1400963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1400967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1400975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1400979 */     // MIs[0] Operand 5
     /* 1400979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1400990 */     // MIs[0] policy
     /* 1400990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1400993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401000 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1401003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401022 */     // GIR_Coverage, 20563,
     /* 1401022 */     GIR_EraseRootFromParent_Done,
     /* 1401023 */   // Label 19841: @1401023
     /* 1401023 */   GIM_Try, /*On fail goto*//*Label 19842*/ GIMT_Encode4(1401111), // Rule ID 20566 //
     /* 1401028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1401031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1401039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1401042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1401048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401067 */     // MIs[0] Operand 5
     /* 1401067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401078 */     // MIs[0] policy
     /* 1401078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1401091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401110 */     // GIR_Coverage, 20566,
     /* 1401110 */     GIR_EraseRootFromParent_Done,
     /* 1401111 */   // Label 19842: @1401111
     /* 1401111 */   GIM_Try, /*On fail goto*//*Label 19843*/ GIMT_Encode4(1401199), // Rule ID 20567 //
     /* 1401116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1401119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1401127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1401130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1401133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1401136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1401143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1401151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401155 */     // MIs[0] Operand 5
     /* 1401155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401166 */     // MIs[0] policy
     /* 1401166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401176 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2_MASK),
     /* 1401179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401198 */     // GIR_Coverage, 20567,
     /* 1401198 */     GIR_EraseRootFromParent_Done,
     /* 1401199 */   // Label 19843: @1401199
     /* 1401199 */   GIM_Try, /*On fail goto*//*Label 19844*/ GIMT_Encode4(1401287), // Rule ID 20570 //
     /* 1401204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1401207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1401215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1401218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1401224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1401231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401243 */     // MIs[0] Operand 5
     /* 1401243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401254 */     // MIs[0] policy
     /* 1401254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401264 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1401267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401286 */     // GIR_Coverage, 20570,
     /* 1401286 */     GIR_EraseRootFromParent_Done,
     /* 1401287 */   // Label 19844: @1401287
     /* 1401287 */   GIM_Try, /*On fail goto*//*Label 19845*/ GIMT_Encode4(1401375), // Rule ID 20571 //
     /* 1401292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1401295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1401303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1401306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1401309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1401312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1401319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1401327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401331 */     // MIs[0] Operand 5
     /* 1401331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401342 */     // MIs[0] policy
     /* 1401342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4_MASK),
     /* 1401355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401374 */     // GIR_Coverage, 20571,
     /* 1401374 */     GIR_EraseRootFromParent_Done,
     /* 1401375 */   // Label 19845: @1401375
     /* 1401375 */   GIM_Try, /*On fail goto*//*Label 19846*/ GIMT_Encode4(1401463), // Rule ID 20574 //
     /* 1401380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1401383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1401391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1401394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1401400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1401407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401419 */     // MIs[0] Operand 5
     /* 1401419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401430 */     // MIs[0] policy
     /* 1401430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401440 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1401443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401462 */     // GIR_Coverage, 20574,
     /* 1401462 */     GIR_EraseRootFromParent_Done,
     /* 1401463 */   // Label 19846: @1401463
     /* 1401463 */   GIM_Try, /*On fail goto*//*Label 19847*/ GIMT_Encode4(1401551), // Rule ID 20575 //
     /* 1401468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1401471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1401476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1401479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1401482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1401485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1401488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1401495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1401503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401507 */     // MIs[0] Operand 5
     /* 1401507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401518 */     // MIs[0] policy
     /* 1401518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401528 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8_MASK),
     /* 1401531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1401547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401550 */     // GIR_Coverage, 20575,
     /* 1401550 */     GIR_EraseRootFromParent_Done,
     /* 1401551 */   // Label 19847: @1401551
     /* 1401551 */   GIM_Try, /*On fail goto*//*Label 19848*/ GIMT_Encode4(1401639), // Rule ID 20578 //
     /* 1401556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1401559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1401564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1401567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1401570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1401573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1401576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401595 */     // MIs[0] Operand 5
     /* 1401595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401606 */     // MIs[0] policy
     /* 1401606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401616 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1401619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401638 */     // GIR_Coverage, 20578,
     /* 1401638 */     GIR_EraseRootFromParent_Done,
     /* 1401639 */   // Label 19848: @1401639
     /* 1401639 */   GIM_Try, /*On fail goto*//*Label 19849*/ GIMT_Encode4(1401727), // Rule ID 20579 //
     /* 1401644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1401647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1401652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1401655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1401658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1401661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1401664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401683 */     // MIs[0] Operand 5
     /* 1401683 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401694 */     // MIs[0] policy
     /* 1401694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1401707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401726 */     // GIR_Coverage, 20579,
     /* 1401726 */     GIR_EraseRootFromParent_Done,
     /* 1401727 */   // Label 19849: @1401727
     /* 1401727 */   GIM_Try, /*On fail goto*//*Label 19850*/ GIMT_Encode4(1401815), // Rule ID 20582 //
     /* 1401732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1401735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1401740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1401743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1401746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1401749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1401752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401771 */     // MIs[0] Operand 5
     /* 1401771 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401782 */     // MIs[0] policy
     /* 1401782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1401795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401814 */     // GIR_Coverage, 20582,
     /* 1401814 */     GIR_EraseRootFromParent_Done,
     /* 1401815 */   // Label 19850: @1401815
     /* 1401815 */   GIM_Try, /*On fail goto*//*Label 19851*/ GIMT_Encode4(1401903), // Rule ID 20583 //
     /* 1401820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1401823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1401828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1401831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1401834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1401837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1401840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1401843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401859 */     // MIs[0] Operand 5
     /* 1401859 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401870 */     // MIs[0] policy
     /* 1401870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1401880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1401883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1401899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401902 */     // GIR_Coverage, 20583,
     /* 1401902 */     GIR_EraseRootFromParent_Done,
     /* 1401903 */   // Label 19851: @1401903
     /* 1401903 */   GIM_Try, /*On fail goto*//*Label 19852*/ GIMT_Encode4(1401991), // Rule ID 20586 //
     /* 1401908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1401911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1401916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1401919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1401922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1401925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1401928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1401931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1401935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1401943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1401947 */     // MIs[0] Operand 5
     /* 1401947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1401958 */     // MIs[0] policy
     /* 1401958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1401961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1401968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1401968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1401971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1401973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1401975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1401977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1401979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1401984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1401987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1401989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1401990 */     // GIR_Coverage, 20586,
     /* 1401990 */     GIR_EraseRootFromParent_Done,
     /* 1401991 */   // Label 19852: @1401991
     /* 1401991 */   GIM_Try, /*On fail goto*//*Label 19853*/ GIMT_Encode4(1402079), // Rule ID 20587 //
     /* 1401996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1401999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1402007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1402010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1402013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1402016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402035 */     // MIs[0] Operand 5
     /* 1402035 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402046 */     // MIs[0] policy
     /* 1402046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1402059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402065 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402078 */     // GIR_Coverage, 20587,
     /* 1402078 */     GIR_EraseRootFromParent_Done,
     /* 1402079 */   // Label 19853: @1402079
     /* 1402079 */   GIM_Try, /*On fail goto*//*Label 19854*/ GIMT_Encode4(1402167), // Rule ID 20590 //
     /* 1402084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1402087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1402095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1402098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1402101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1402104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402123 */     // MIs[0] Operand 5
     /* 1402123 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402134 */     // MIs[0] policy
     /* 1402134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402144 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402166 */     // GIR_Coverage, 20590,
     /* 1402166 */     GIR_EraseRootFromParent_Done,
     /* 1402167 */   // Label 19854: @1402167
     /* 1402167 */   GIM_Try, /*On fail goto*//*Label 19855*/ GIMT_Encode4(1402255), // Rule ID 20591 //
     /* 1402172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1402175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1402183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1402186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1402189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1402192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402211 */     // MIs[0] Operand 5
     /* 1402211 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402222 */     // MIs[0] policy
     /* 1402222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402241 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402254 */     // GIR_Coverage, 20591,
     /* 1402254 */     GIR_EraseRootFromParent_Done,
     /* 1402255 */   // Label 19855: @1402255
     /* 1402255 */   GIM_Try, /*On fail goto*//*Label 19856*/ GIMT_Encode4(1402343), // Rule ID 20594 //
     /* 1402260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1402263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1402277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1402280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402299 */     // MIs[0] Operand 5
     /* 1402299 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402310 */     // MIs[0] policy
     /* 1402310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402342 */     // GIR_Coverage, 20594,
     /* 1402342 */     GIR_EraseRootFromParent_Done,
     /* 1402343 */   // Label 19856: @1402343
     /* 1402343 */   GIM_Try, /*On fail goto*//*Label 19857*/ GIMT_Encode4(1402431), // Rule ID 20595 //
     /* 1402348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1402351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1402359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1402362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1402365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1402368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402387 */     // MIs[0] Operand 5
     /* 1402387 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402398 */     // MIs[0] policy
     /* 1402398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402408 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1402427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402430 */     // GIR_Coverage, 20595,
     /* 1402430 */     GIR_EraseRootFromParent_Done,
     /* 1402431 */   // Label 19857: @1402431
     /* 1402431 */   GIM_Try, /*On fail goto*//*Label 19858*/ GIMT_Encode4(1402519), // Rule ID 20598 //
     /* 1402436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1402439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1402453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1402456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402475 */     // MIs[0] Operand 5
     /* 1402475 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402486 */     // MIs[0] policy
     /* 1402486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402505 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402518 */     // GIR_Coverage, 20598,
     /* 1402518 */     GIR_EraseRootFromParent_Done,
     /* 1402519 */   // Label 19858: @1402519
     /* 1402519 */   GIM_Try, /*On fail goto*//*Label 19859*/ GIMT_Encode4(1402607), // Rule ID 20599 //
     /* 1402524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1402527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1402535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1402538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1402541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1402544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1402551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1402559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402563 */     // MIs[0] Operand 5
     /* 1402563 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402574 */     // MIs[0] policy
     /* 1402574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402584 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1_MASK),
     /* 1402587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1402603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402606 */     // GIR_Coverage, 20599,
     /* 1402606 */     GIR_EraseRootFromParent_Done,
     /* 1402607 */   // Label 19859: @1402607
     /* 1402607 */   GIM_Try, /*On fail goto*//*Label 19860*/ GIMT_Encode4(1402695), // Rule ID 20602 //
     /* 1402612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1402615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1402623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1402626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1402629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1402632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402651 */     // MIs[0] Operand 5
     /* 1402651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402662 */     // MIs[0] policy
     /* 1402662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402672 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1402675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402694 */     // GIR_Coverage, 20602,
     /* 1402694 */     GIR_EraseRootFromParent_Done,
     /* 1402695 */   // Label 19860: @1402695
     /* 1402695 */   GIM_Try, /*On fail goto*//*Label 19861*/ GIMT_Encode4(1402783), // Rule ID 20603 //
     /* 1402700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1402703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1402711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1402714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1402717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1402720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1402727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1402735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402739 */     // MIs[0] Operand 5
     /* 1402739 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402750 */     // MIs[0] policy
     /* 1402750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1402763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402769 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402782 */     // GIR_Coverage, 20603,
     /* 1402782 */     GIR_EraseRootFromParent_Done,
     /* 1402783 */   // Label 19861: @1402783
     /* 1402783 */   GIM_Try, /*On fail goto*//*Label 19862*/ GIMT_Encode4(1402871), // Rule ID 20606 //
     /* 1402788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1402791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1402799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1402802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1402805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1402808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402827 */     // MIs[0] Operand 5
     /* 1402827 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402838 */     // MIs[0] policy
     /* 1402838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1402848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1402851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402870 */     // GIR_Coverage, 20606,
     /* 1402870 */     GIR_EraseRootFromParent_Done,
     /* 1402871 */   // Label 19862: @1402871
     /* 1402871 */   GIM_Try, /*On fail goto*//*Label 19863*/ GIMT_Encode4(1402959), // Rule ID 20607 //
     /* 1402876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1402879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1402887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1402890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1402893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1402896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1402899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1402903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1402911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1402915 */     // MIs[0] Operand 5
     /* 1402915 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1402926 */     // MIs[0] policy
     /* 1402926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1402929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1402936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1402936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1402939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1402941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1402943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1402945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1402947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1402952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1402955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1402957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1402958 */     // GIR_Coverage, 20607,
     /* 1402958 */     GIR_EraseRootFromParent_Done,
     /* 1402959 */   // Label 19863: @1402959
     /* 1402959 */   GIM_Try, /*On fail goto*//*Label 19864*/ GIMT_Encode4(1403047), // Rule ID 20610 //
     /* 1402964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1402967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1402972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1402975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1402978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1402981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1402984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1402987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1402991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1402999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403003 */     // MIs[0] Operand 5
     /* 1403003 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403014 */     // MIs[0] policy
     /* 1403014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403024 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1403027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403046 */     // GIR_Coverage, 20610,
     /* 1403046 */     GIR_EraseRootFromParent_Done,
     /* 1403047 */   // Label 19864: @1403047
     /* 1403047 */   GIM_Try, /*On fail goto*//*Label 19865*/ GIMT_Encode4(1403135), // Rule ID 20611 //
     /* 1403052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1403055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1403063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1403066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1403069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1403072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403091 */     // MIs[0] Operand 5
     /* 1403091 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403102 */     // MIs[0] policy
     /* 1403102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403112 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1403115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1403131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403134 */     // GIR_Coverage, 20611,
     /* 1403134 */     GIR_EraseRootFromParent_Done,
     /* 1403135 */   // Label 19865: @1403135
     /* 1403135 */   GIM_Try, /*On fail goto*//*Label 19866*/ GIMT_Encode4(1403223), // Rule ID 20614 //
     /* 1403140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1403143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1403151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1403154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1403157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403179 */     // MIs[0] Operand 5
     /* 1403179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403190 */     // MIs[0] policy
     /* 1403190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1403203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403209 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403222 */     // GIR_Coverage, 20614,
     /* 1403222 */     GIR_EraseRootFromParent_Done,
     /* 1403223 */   // Label 19866: @1403223
     /* 1403223 */   GIM_Try, /*On fail goto*//*Label 19867*/ GIMT_Encode4(1403311), // Rule ID 20615 //
     /* 1403228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1403231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1403239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1403242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1403245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403267 */     // MIs[0] Operand 5
     /* 1403267 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403278 */     // MIs[0] policy
     /* 1403278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1403291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403310 */     // GIR_Coverage, 20615,
     /* 1403310 */     GIR_EraseRootFromParent_Done,
     /* 1403311 */   // Label 19867: @1403311
     /* 1403311 */   GIM_Try, /*On fail goto*//*Label 19868*/ GIMT_Encode4(1403399), // Rule ID 20618 //
     /* 1403316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1403319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1403327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1403330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1403333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1403336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403355 */     // MIs[0] Operand 5
     /* 1403355 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403366 */     // MIs[0] policy
     /* 1403366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403376 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1403379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403398 */     // GIR_Coverage, 20618,
     /* 1403398 */     GIR_EraseRootFromParent_Done,
     /* 1403399 */   // Label 19868: @1403399
     /* 1403399 */   GIM_Try, /*On fail goto*//*Label 19869*/ GIMT_Encode4(1403487), // Rule ID 20619 //
     /* 1403404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1403407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1403415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1403418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1403421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1403424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403443 */     // MIs[0] Operand 5
     /* 1403443 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403454 */     // MIs[0] policy
     /* 1403454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1403467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403486 */     // GIR_Coverage, 20619,
     /* 1403486 */     GIR_EraseRootFromParent_Done,
     /* 1403487 */   // Label 19869: @1403487
     /* 1403487 */   GIM_Try, /*On fail goto*//*Label 19870*/ GIMT_Encode4(1403575), // Rule ID 20622 //
     /* 1403492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1403495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1403503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1403506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1403509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1403512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403531 */     // MIs[0] Operand 5
     /* 1403531 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403542 */     // MIs[0] policy
     /* 1403542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403552 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1403555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403574 */     // GIR_Coverage, 20622,
     /* 1403574 */     GIR_EraseRootFromParent_Done,
     /* 1403575 */   // Label 19870: @1403575
     /* 1403575 */   GIM_Try, /*On fail goto*//*Label 19871*/ GIMT_Encode4(1403663), // Rule ID 20623 //
     /* 1403580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1403583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1403591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1403594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1403597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1403600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1403607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1403615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403619 */     // MIs[0] Operand 5
     /* 1403619 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403630 */     // MIs[0] policy
     /* 1403630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1403643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1403659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403662 */     // GIR_Coverage, 20623,
     /* 1403662 */     GIR_EraseRootFromParent_Done,
     /* 1403663 */   // Label 19871: @1403663
     /* 1403663 */   GIM_Try, /*On fail goto*//*Label 19872*/ GIMT_Encode4(1403751), // Rule ID 20626 //
     /* 1403668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1403671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1403679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1403682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1403685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1403688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403707 */     // MIs[0] Operand 5
     /* 1403707 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403718 */     // MIs[0] policy
     /* 1403718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1403731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403737 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403750 */     // GIR_Coverage, 20626,
     /* 1403750 */     GIR_EraseRootFromParent_Done,
     /* 1403751 */   // Label 19872: @1403751
     /* 1403751 */   GIM_Try, /*On fail goto*//*Label 19873*/ GIMT_Encode4(1403839), // Rule ID 20627 //
     /* 1403756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1403759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1403767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1403770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1403773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1403776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1403783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1403791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403795 */     // MIs[0] Operand 5
     /* 1403795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403806 */     // MIs[0] policy
     /* 1403806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2_MASK),
     /* 1403819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403838 */     // GIR_Coverage, 20627,
     /* 1403838 */     GIR_EraseRootFromParent_Done,
     /* 1403839 */   // Label 19873: @1403839
     /* 1403839 */   GIM_Try, /*On fail goto*//*Label 19874*/ GIMT_Encode4(1403927), // Rule ID 20630 //
     /* 1403844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1403847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1403855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1403858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1403861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1403867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403883 */     // MIs[0] Operand 5
     /* 1403883 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403894 */     // MIs[0] policy
     /* 1403894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403904 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1403904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1403907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1403913 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1403915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1403920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1403923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1403925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1403926 */     // GIR_Coverage, 20630,
     /* 1403926 */     GIR_EraseRootFromParent_Done,
     /* 1403927 */   // Label 19874: @1403927
     /* 1403927 */   GIM_Try, /*On fail goto*//*Label 19875*/ GIMT_Encode4(1404015), // Rule ID 20631 //
     /* 1403932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1403935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1403940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1403943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1403946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1403949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1403952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1403955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1403959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1403967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1403971 */     // MIs[0] Operand 5
     /* 1403971 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1403982 */     // MIs[0] policy
     /* 1403982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1403985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1403992 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1403992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4_MASK),
     /* 1403995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1403997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1403999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404014 */     // GIR_Coverage, 20631,
     /* 1404014 */     GIR_EraseRootFromParent_Done,
     /* 1404015 */   // Label 19875: @1404015
     /* 1404015 */   GIM_Try, /*On fail goto*//*Label 19876*/ GIMT_Encode4(1404103), // Rule ID 20634 //
     /* 1404020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1404023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1404028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1404031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1404034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1404037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404059 */     // MIs[0] Operand 5
     /* 1404059 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404070 */     // MIs[0] policy
     /* 1404070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1404083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404102 */     // GIR_Coverage, 20634,
     /* 1404102 */     GIR_EraseRootFromParent_Done,
     /* 1404103 */   // Label 19876: @1404103
     /* 1404103 */   GIM_Try, /*On fail goto*//*Label 19877*/ GIMT_Encode4(1404191), // Rule ID 20635 //
     /* 1404108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1404111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1404116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1404119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1404122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1404125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404147 */     // MIs[0] Operand 5
     /* 1404147 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404158 */     // MIs[0] policy
     /* 1404158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8_MASK),
     /* 1404171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404177 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1404187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404190 */     // GIR_Coverage, 20635,
     /* 1404190 */     GIR_EraseRootFromParent_Done,
     /* 1404191 */   // Label 19877: @1404191
     /* 1404191 */   GIM_Try, /*On fail goto*//*Label 19878*/ GIMT_Encode4(1404279), // Rule ID 20994 //
     /* 1404196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1404207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1404210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1404213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1404216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404235 */     // MIs[0] Operand 5
     /* 1404235 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404246 */     // MIs[0] policy
     /* 1404246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404256 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1404259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404278 */     // GIR_Coverage, 20994,
     /* 1404278 */     GIR_EraseRootFromParent_Done,
     /* 1404279 */   // Label 19878: @1404279
     /* 1404279 */   GIM_Try, /*On fail goto*//*Label 19879*/ GIMT_Encode4(1404367), // Rule ID 20995 //
     /* 1404284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1404295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1404298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1404301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1404304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404323 */     // MIs[0] Operand 5
     /* 1404323 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404334 */     // MIs[0] policy
     /* 1404334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4_MASK),
     /* 1404347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404366 */     // GIR_Coverage, 20995,
     /* 1404366 */     GIR_EraseRootFromParent_Done,
     /* 1404367 */   // Label 19879: @1404367
     /* 1404367 */   GIM_Try, /*On fail goto*//*Label 19880*/ GIMT_Encode4(1404455), // Rule ID 20998 //
     /* 1404372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1404389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1404392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404411 */     // MIs[0] Operand 5
     /* 1404411 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404422 */     // MIs[0] policy
     /* 1404422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1404435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404441 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404454 */     // GIR_Coverage, 20998,
     /* 1404454 */     GIR_EraseRootFromParent_Done,
     /* 1404455 */   // Label 19880: @1404455
     /* 1404455 */   GIM_Try, /*On fail goto*//*Label 19881*/ GIMT_Encode4(1404543), // Rule ID 20999 //
     /* 1404460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1404471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1404474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1404477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1404480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1404487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404499 */     // MIs[0] Operand 5
     /* 1404499 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404510 */     // MIs[0] policy
     /* 1404510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404520 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1404523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404542 */     // GIR_Coverage, 20999,
     /* 1404542 */     GIR_EraseRootFromParent_Done,
     /* 1404543 */   // Label 19881: @1404543
     /* 1404543 */   GIM_Try, /*On fail goto*//*Label 19882*/ GIMT_Encode4(1404631), // Rule ID 21002 //
     /* 1404548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1404565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1404568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404587 */     // MIs[0] Operand 5
     /* 1404587 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404598 */     // MIs[0] policy
     /* 1404598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404608 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1404611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404630 */     // GIR_Coverage, 21002,
     /* 1404630 */     GIR_EraseRootFromParent_Done,
     /* 1404631 */   // Label 19882: @1404631
     /* 1404631 */   GIM_Try, /*On fail goto*//*Label 19883*/ GIMT_Encode4(1404719), // Rule ID 21003 //
     /* 1404636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1404647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1404650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1404653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1404656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1404663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1404671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404675 */     // MIs[0] Operand 5
     /* 1404675 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404686 */     // MIs[0] policy
     /* 1404686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404696 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1404699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404718 */     // GIR_Coverage, 21003,
     /* 1404718 */     GIR_EraseRootFromParent_Done,
     /* 1404719 */   // Label 19883: @1404719
     /* 1404719 */   GIM_Try, /*On fail goto*//*Label 19884*/ GIMT_Encode4(1404807), // Rule ID 21006 //
     /* 1404724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404763 */     // MIs[0] Operand 5
     /* 1404763 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404774 */     // MIs[0] policy
     /* 1404774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404784 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1404787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404806 */     // GIR_Coverage, 21006,
     /* 1404806 */     GIR_EraseRootFromParent_Done,
     /* 1404807 */   // Label 19884: @1404807
     /* 1404807 */   GIM_Try, /*On fail goto*//*Label 19885*/ GIMT_Encode4(1404895), // Rule ID 21007 //
     /* 1404812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1404823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1404826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1404829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1404832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1404835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1404839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1404847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404851 */     // MIs[0] Operand 5
     /* 1404851 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404862 */     // MIs[0] policy
     /* 1404862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1404872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1404875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404881 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404894 */     // GIR_Coverage, 21007,
     /* 1404894 */     GIR_EraseRootFromParent_Done,
     /* 1404895 */   // Label 19885: @1404895
     /* 1404895 */   GIM_Try, /*On fail goto*//*Label 19886*/ GIMT_Encode4(1404983), // Rule ID 21010 //
     /* 1404900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1404903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1404914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1404917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1404920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1404923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1404927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1404931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1404935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1404939 */     // MIs[0] Operand 5
     /* 1404939 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1404950 */     // MIs[0] policy
     /* 1404950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1404953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1404960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1404960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1404963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1404965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1404967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1404969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1404971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1404976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1404979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1404981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1404982 */     // GIR_Coverage, 21010,
     /* 1404982 */     GIR_EraseRootFromParent_Done,
     /* 1404983 */   // Label 19886: @1404983
     /* 1404983 */   GIM_Try, /*On fail goto*//*Label 19887*/ GIMT_Encode4(1405071), // Rule ID 21011 //
     /* 1404988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1404991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1404996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1404999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1405002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1405005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1405008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405027 */     // MIs[0] Operand 5
     /* 1405027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405038 */     // MIs[0] policy
     /* 1405038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1405051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405070 */     // GIR_Coverage, 21011,
     /* 1405070 */     GIR_EraseRootFromParent_Done,
     /* 1405071 */   // Label 19887: @1405071
     /* 1405071 */   GIM_Try, /*On fail goto*//*Label 19888*/ GIMT_Encode4(1405159), // Rule ID 21014 //
     /* 1405076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1405079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405115 */     // MIs[0] Operand 5
     /* 1405115 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405126 */     // MIs[0] policy
     /* 1405126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405136 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1405139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405145 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405158 */     // GIR_Coverage, 21014,
     /* 1405158 */     GIR_EraseRootFromParent_Done,
     /* 1405159 */   // Label 19888: @1405159
     /* 1405159 */   GIM_Try, /*On fail goto*//*Label 19889*/ GIMT_Encode4(1405247), // Rule ID 21015 //
     /* 1405164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1405167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1405175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1405178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1405181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405203 */     // MIs[0] Operand 5
     /* 1405203 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405214 */     // MIs[0] policy
     /* 1405214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2_MASK),
     /* 1405227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405246 */     // GIR_Coverage, 21015,
     /* 1405246 */     GIR_EraseRootFromParent_Done,
     /* 1405247 */   // Label 19889: @1405247
     /* 1405247 */   GIM_Try, /*On fail goto*//*Label 19890*/ GIMT_Encode4(1405335), // Rule ID 21018 //
     /* 1405252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1405255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1405269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405291 */     // MIs[0] Operand 5
     /* 1405291 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405302 */     // MIs[0] policy
     /* 1405302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1405315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405334 */     // GIR_Coverage, 21018,
     /* 1405334 */     GIR_EraseRootFromParent_Done,
     /* 1405335 */   // Label 19890: @1405335
     /* 1405335 */   GIM_Try, /*On fail goto*//*Label 19891*/ GIMT_Encode4(1405423), // Rule ID 21019 //
     /* 1405340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1405343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1405351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1405354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1405357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1405367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405379 */     // MIs[0] Operand 5
     /* 1405379 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405390 */     // MIs[0] policy
     /* 1405390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1_MASK),
     /* 1405403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405422 */     // GIR_Coverage, 21019,
     /* 1405422 */     GIR_EraseRootFromParent_Done,
     /* 1405423 */   // Label 19891: @1405423
     /* 1405423 */   GIM_Try, /*On fail goto*//*Label 19892*/ GIMT_Encode4(1405511), // Rule ID 21022 //
     /* 1405428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1405431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1405445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1405448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405467 */     // MIs[0] Operand 5
     /* 1405467 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405478 */     // MIs[0] policy
     /* 1405478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405488 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1405491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405510 */     // GIR_Coverage, 21022,
     /* 1405510 */     GIR_EraseRootFromParent_Done,
     /* 1405511 */   // Label 19892: @1405511
     /* 1405511 */   GIM_Try, /*On fail goto*//*Label 19893*/ GIMT_Encode4(1405599), // Rule ID 21023 //
     /* 1405516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1405519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1405527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1405530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1405533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1405536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1405543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1405551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405555 */     // MIs[0] Operand 5
     /* 1405555 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405566 */     // MIs[0] policy
     /* 1405566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405576 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2_MASK),
     /* 1405579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405585 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405598 */     // GIR_Coverage, 21023,
     /* 1405598 */     GIR_EraseRootFromParent_Done,
     /* 1405599 */   // Label 19893: @1405599
     /* 1405599 */   GIM_Try, /*On fail goto*//*Label 19894*/ GIMT_Encode4(1405687), // Rule ID 21026 //
     /* 1405604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1405607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405643 */     // MIs[0] Operand 5
     /* 1405643 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405654 */     // MIs[0] policy
     /* 1405654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1405667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405686 */     // GIR_Coverage, 21026,
     /* 1405686 */     GIR_EraseRootFromParent_Done,
     /* 1405687 */   // Label 19894: @1405687
     /* 1405687 */   GIM_Try, /*On fail goto*//*Label 19895*/ GIMT_Encode4(1405775), // Rule ID 21027 //
     /* 1405692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1405695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1405700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1405703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1405706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1405709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1405712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1405719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1405723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1405727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405731 */     // MIs[0] Operand 5
     /* 1405731 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405742 */     // MIs[0] policy
     /* 1405742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4_MASK),
     /* 1405755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1405771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405774 */     // GIR_Coverage, 21027,
     /* 1405774 */     GIR_EraseRootFromParent_Done,
     /* 1405775 */   // Label 19895: @1405775
     /* 1405775 */   GIM_Try, /*On fail goto*//*Label 19896*/ GIMT_Encode4(1405863), // Rule ID 21030 //
     /* 1405780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1405788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405819 */     // MIs[0] Operand 5
     /* 1405819 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405830 */     // MIs[0] policy
     /* 1405830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1405840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405862 */     // GIR_Coverage, 21030,
     /* 1405862 */     GIR_EraseRootFromParent_Done,
     /* 1405863 */   // Label 19896: @1405863
     /* 1405863 */   GIM_Try, /*On fail goto*//*Label 19897*/ GIMT_Encode4(1405951), // Rule ID 21031 //
     /* 1405868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1405871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1405876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1405879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1405882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1405885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1405888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1405891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405907 */     // MIs[0] Operand 5
     /* 1405907 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1405918 */     // MIs[0] policy
     /* 1405918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1405921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1405928 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1405928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4_MASK),
     /* 1405931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1405933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1405935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1405937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1405939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1405944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1405947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1405949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1405950 */     // GIR_Coverage, 21031,
     /* 1405950 */     GIR_EraseRootFromParent_Done,
     /* 1405951 */   // Label 19897: @1405951
     /* 1405951 */   GIM_Try, /*On fail goto*//*Label 19898*/ GIMT_Encode4(1406039), // Rule ID 21034 //
     /* 1405956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1405959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1405964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1405967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1405970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1405973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1405976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1405979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1405983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1405991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1405995 */     // MIs[0] Operand 5
     /* 1405995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406006 */     // MIs[0] policy
     /* 1406006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406016 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406038 */     // GIR_Coverage, 21034,
     /* 1406038 */     GIR_EraseRootFromParent_Done,
     /* 1406039 */   // Label 19898: @1406039
     /* 1406039 */   GIM_Try, /*On fail goto*//*Label 19899*/ GIMT_Encode4(1406127), // Rule ID 21035 //
     /* 1406044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1406055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1406058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1406061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406083 */     // MIs[0] Operand 5
     /* 1406083 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406094 */     // MIs[0] policy
     /* 1406094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406113 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406126 */     // GIR_Coverage, 21035,
     /* 1406126 */     GIR_EraseRootFromParent_Done,
     /* 1406127 */   // Label 19899: @1406127
     /* 1406127 */   GIM_Try, /*On fail goto*//*Label 19900*/ GIMT_Encode4(1406215), // Rule ID 21038 //
     /* 1406132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1406143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1406146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406171 */     // MIs[0] Operand 5
     /* 1406171 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406182 */     // MIs[0] policy
     /* 1406182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1406195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406214 */     // GIR_Coverage, 21038,
     /* 1406214 */     GIR_EraseRootFromParent_Done,
     /* 1406215 */   // Label 19900: @1406215
     /* 1406215 */   GIM_Try, /*On fail goto*//*Label 19901*/ GIMT_Encode4(1406303), // Rule ID 21039 //
     /* 1406220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1406231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1406234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1406237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1406240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406259 */     // MIs[0] Operand 5
     /* 1406259 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406270 */     // MIs[0] policy
     /* 1406270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1406283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406302 */     // GIR_Coverage, 21039,
     /* 1406302 */     GIR_EraseRootFromParent_Done,
     /* 1406303 */   // Label 19901: @1406303
     /* 1406303 */   GIM_Try, /*On fail goto*//*Label 19902*/ GIMT_Encode4(1406391), // Rule ID 21042 //
     /* 1406308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1406319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1406322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406347 */     // MIs[0] Operand 5
     /* 1406347 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406358 */     // MIs[0] policy
     /* 1406358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406368 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1406371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406377 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406390 */     // GIR_Coverage, 21042,
     /* 1406390 */     GIR_EraseRootFromParent_Done,
     /* 1406391 */   // Label 19902: @1406391
     /* 1406391 */   GIM_Try, /*On fail goto*//*Label 19903*/ GIMT_Encode4(1406479), // Rule ID 21043 //
     /* 1406396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1406407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1406410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1406413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1406416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1406423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406435 */     // MIs[0] Operand 5
     /* 1406435 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406446 */     // MIs[0] policy
     /* 1406446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406456 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1406459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406478 */     // GIR_Coverage, 21043,
     /* 1406478 */     GIR_EraseRootFromParent_Done,
     /* 1406479 */   // Label 19903: @1406479
     /* 1406479 */   GIM_Try, /*On fail goto*//*Label 19904*/ GIMT_Encode4(1406567), // Rule ID 21046 //
     /* 1406484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1406487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1406495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1406498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1406511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406523 */     // MIs[0] Operand 5
     /* 1406523 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406534 */     // MIs[0] policy
     /* 1406534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406544 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1406547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406566 */     // GIR_Coverage, 21046,
     /* 1406566 */     GIR_EraseRootFromParent_Done,
     /* 1406567 */   // Label 19904: @1406567
     /* 1406567 */   GIM_Try, /*On fail goto*//*Label 19905*/ GIMT_Encode4(1406655), // Rule ID 21047 //
     /* 1406572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1406575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1406583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1406586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1406589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1406592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1406599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1406603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1406607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406611 */     // MIs[0] Operand 5
     /* 1406611 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406622 */     // MIs[0] policy
     /* 1406622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1406635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1406651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406654 */     // GIR_Coverage, 21047,
     /* 1406654 */     GIR_EraseRootFromParent_Done,
     /* 1406655 */   // Label 19905: @1406655
     /* 1406655 */   GIM_Try, /*On fail goto*//*Label 19906*/ GIMT_Encode4(1406743), // Rule ID 21050 //
     /* 1406660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1406663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406699 */     // MIs[0] Operand 5
     /* 1406699 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406710 */     // MIs[0] policy
     /* 1406710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406720 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406742 */     // GIR_Coverage, 21050,
     /* 1406742 */     GIR_EraseRootFromParent_Done,
     /* 1406743 */   // Label 19906: @1406743
     /* 1406743 */   GIM_Try, /*On fail goto*//*Label 19907*/ GIMT_Encode4(1406831), // Rule ID 21051 //
     /* 1406748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1406751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1406759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1406762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1406765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1406768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1406775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406787 */     // MIs[0] Operand 5
     /* 1406787 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406798 */     // MIs[0] policy
     /* 1406798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406808 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2_MASK),
     /* 1406811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406817 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406830 */     // GIR_Coverage, 21051,
     /* 1406830 */     GIR_EraseRootFromParent_Done,
     /* 1406831 */   // Label 19907: @1406831
     /* 1406831 */   GIM_Try, /*On fail goto*//*Label 19908*/ GIMT_Encode4(1406919), // Rule ID 21054 //
     /* 1406836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1406839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1406847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1406850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1406859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406875 */     // MIs[0] Operand 5
     /* 1406875 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406886 */     // MIs[0] policy
     /* 1406886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406896 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1406896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1406899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1406912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1406915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1406917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1406918 */     // GIR_Coverage, 21054,
     /* 1406918 */     GIR_EraseRootFromParent_Done,
     /* 1406919 */   // Label 19908: @1406919
     /* 1406919 */   GIM_Try, /*On fail goto*//*Label 19909*/ GIMT_Encode4(1407007), // Rule ID 21055 //
     /* 1406924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1406927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1406932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1406935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1406938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1406941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1406944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1406947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1406951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1406955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1406959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1406963 */     // MIs[0] Operand 5
     /* 1406963 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1406974 */     // MIs[0] policy
     /* 1406974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1406977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1406984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1406984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1_MASK),
     /* 1406987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1406989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1406991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1406993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1406995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407006 */     // GIR_Coverage, 21055,
     /* 1407006 */     GIR_EraseRootFromParent_Done,
     /* 1407007 */   // Label 19909: @1407007
     /* 1407007 */   GIM_Try, /*On fail goto*//*Label 19910*/ GIMT_Encode4(1407095), // Rule ID 21058 //
     /* 1407012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1407015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1407020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407051 */     // MIs[0] Operand 5
     /* 1407051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407062 */     // MIs[0] policy
     /* 1407062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1407075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407094 */     // GIR_Coverage, 21058,
     /* 1407094 */     GIR_EraseRootFromParent_Done,
     /* 1407095 */   // Label 19910: @1407095
     /* 1407095 */   GIM_Try, /*On fail goto*//*Label 19911*/ GIMT_Encode4(1407183), // Rule ID 21059 //
     /* 1407100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1407103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1407108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1407111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1407114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1407117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1407127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407139 */     // MIs[0] Operand 5
     /* 1407139 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407150 */     // MIs[0] policy
     /* 1407150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407160 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2_MASK),
     /* 1407163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407182 */     // GIR_Coverage, 21059,
     /* 1407182 */     GIR_EraseRootFromParent_Done,
     /* 1407183 */   // Label 19911: @1407183
     /* 1407183 */   GIM_Try, /*On fail goto*//*Label 19912*/ GIMT_Encode4(1407271), // Rule ID 21062 //
     /* 1407188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1407191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1407196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1407199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1407202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407227 */     // MIs[0] Operand 5
     /* 1407227 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407238 */     // MIs[0] policy
     /* 1407238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1407251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407257 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407270 */     // GIR_Coverage, 21062,
     /* 1407270 */     GIR_EraseRootFromParent_Done,
     /* 1407271 */   // Label 19912: @1407271
     /* 1407271 */   GIM_Try, /*On fail goto*//*Label 19913*/ GIMT_Encode4(1407359), // Rule ID 21063 //
     /* 1407276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1407279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1407284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1407287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1407290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1407293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1407303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1407307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1407311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407315 */     // MIs[0] Operand 5
     /* 1407315 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407326 */     // MIs[0] policy
     /* 1407326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407336 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4_MASK),
     /* 1407339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1407355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407358 */     // GIR_Coverage, 21063,
     /* 1407358 */     GIR_EraseRootFromParent_Done,
     /* 1407359 */   // Label 19913: @1407359
     /* 1407359 */   GIM_Try, /*On fail goto*//*Label 19914*/ GIMT_Encode4(1407447), // Rule ID 21366 //
     /* 1407364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1407375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1407378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1407381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1407384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407403 */     // MIs[0] Operand 5
     /* 1407403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407414 */     // MIs[0] policy
     /* 1407414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407424 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1407427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407446 */     // GIR_Coverage, 21366,
     /* 1407446 */     GIR_EraseRootFromParent_Done,
     /* 1407447 */   // Label 19914: @1407447
     /* 1407447 */   GIM_Try, /*On fail goto*//*Label 19915*/ GIMT_Encode4(1407535), // Rule ID 21367 //
     /* 1407452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1407463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1407466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1407469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1407472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407491 */     // MIs[0] Operand 5
     /* 1407491 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407502 */     // MIs[0] policy
     /* 1407502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8_MASK),
     /* 1407515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407521 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407534 */     // GIR_Coverage, 21367,
     /* 1407534 */     GIR_EraseRootFromParent_Done,
     /* 1407535 */   // Label 19915: @1407535
     /* 1407535 */   GIM_Try, /*On fail goto*//*Label 19916*/ GIMT_Encode4(1407623), // Rule ID 21370 //
     /* 1407540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1407551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1407554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1407557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407579 */     // MIs[0] Operand 5
     /* 1407579 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407590 */     // MIs[0] policy
     /* 1407590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1407603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407622 */     // GIR_Coverage, 21370,
     /* 1407622 */     GIR_EraseRootFromParent_Done,
     /* 1407623 */   // Label 19916: @1407623
     /* 1407623 */   GIM_Try, /*On fail goto*//*Label 19917*/ GIMT_Encode4(1407711), // Rule ID 21371 //
     /* 1407628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1407639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1407642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1407645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1407648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407667 */     // MIs[0] Operand 5
     /* 1407667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407678 */     // MIs[0] policy
     /* 1407678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1407691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407710 */     // GIR_Coverage, 21371,
     /* 1407710 */     GIR_EraseRootFromParent_Done,
     /* 1407711 */   // Label 19917: @1407711
     /* 1407711 */   GIM_Try, /*On fail goto*//*Label 19918*/ GIMT_Encode4(1407799), // Rule ID 21374 //
     /* 1407716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1407727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1407730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1407733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407755 */     // MIs[0] Operand 5
     /* 1407755 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407766 */     // MIs[0] policy
     /* 1407766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407776 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1407779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407785 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407798 */     // GIR_Coverage, 21374,
     /* 1407798 */     GIR_EraseRootFromParent_Done,
     /* 1407799 */   // Label 19918: @1407799
     /* 1407799 */   GIM_Try, /*On fail goto*//*Label 19919*/ GIMT_Encode4(1407887), // Rule ID 21375 //
     /* 1407804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1407815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1407818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1407821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1407824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1407827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407843 */     // MIs[0] Operand 5
     /* 1407843 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407854 */     // MIs[0] policy
     /* 1407854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407864 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1407864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1407867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407886 */     // GIR_Coverage, 21375,
     /* 1407886 */     GIR_EraseRootFromParent_Done,
     /* 1407887 */   // Label 19919: @1407887
     /* 1407887 */   GIM_Try, /*On fail goto*//*Label 19920*/ GIMT_Encode4(1407975), // Rule ID 21378 //
     /* 1407892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1407895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1407903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1407906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1407912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1407915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1407919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1407923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1407927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1407931 */     // MIs[0] Operand 5
     /* 1407931 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1407942 */     // MIs[0] policy
     /* 1407942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1407945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1407952 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1407952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1407955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1407957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1407959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1407961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1407963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1407968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1407971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1407973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1407974 */     // GIR_Coverage, 21378,
     /* 1407974 */     GIR_EraseRootFromParent_Done,
     /* 1407975 */   // Label 19920: @1407975
     /* 1407975 */   GIM_Try, /*On fail goto*//*Label 19921*/ GIMT_Encode4(1408063), // Rule ID 21379 //
     /* 1407980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1407983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1407988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1407991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1407994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1407997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408019 */     // MIs[0] Operand 5
     /* 1408019 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408030 */     // MIs[0] policy
     /* 1408030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408040 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1408043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408049 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1408059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408062 */     // GIR_Coverage, 21379,
     /* 1408062 */     GIR_EraseRootFromParent_Done,
     /* 1408063 */   // Label 19921: @1408063
     /* 1408063 */   GIM_Try, /*On fail goto*//*Label 19922*/ GIMT_Encode4(1408151), // Rule ID 21382 //
     /* 1408068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1408079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1408082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1408085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1408088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408107 */     // MIs[0] Operand 5
     /* 1408107 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408118 */     // MIs[0] policy
     /* 1408118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408128 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1408131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1408147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408150 */     // GIR_Coverage, 21382,
     /* 1408150 */     GIR_EraseRootFromParent_Done,
     /* 1408151 */   // Label 19922: @1408151
     /* 1408151 */   GIM_Try, /*On fail goto*//*Label 19923*/ GIMT_Encode4(1408239), // Rule ID 21383 //
     /* 1408156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1408167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1408170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1408173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1408176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408195 */     // MIs[0] Operand 5
     /* 1408195 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408206 */     // MIs[0] policy
     /* 1408206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1408219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408225 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1408235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408238 */     // GIR_Coverage, 21383,
     /* 1408238 */     GIR_EraseRootFromParent_Done,
     /* 1408239 */   // Label 19923: @1408239
     /* 1408239 */   GIM_Try, /*On fail goto*//*Label 19924*/ GIMT_Encode4(1408327), // Rule ID 21386 //
     /* 1408244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1408247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1408255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1408258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1408261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1408264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408283 */     // MIs[0] Operand 5
     /* 1408283 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408294 */     // MIs[0] policy
     /* 1408294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408304 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1408307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1408323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408326 */     // GIR_Coverage, 21386,
     /* 1408326 */     GIR_EraseRootFromParent_Done,
     /* 1408327 */   // Label 19924: @1408327
     /* 1408327 */   GIM_Try, /*On fail goto*//*Label 19925*/ GIMT_Encode4(1408415), // Rule ID 21387 //
     /* 1408332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1408335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1408343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1408346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1408349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1408352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1408359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1408367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408371 */     // MIs[0] Operand 5
     /* 1408371 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408382 */     // MIs[0] policy
     /* 1408382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408392 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1408395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1408411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408414 */     // GIR_Coverage, 21387,
     /* 1408414 */     GIR_EraseRootFromParent_Done,
     /* 1408415 */   // Label 19925: @1408415
     /* 1408415 */   GIM_Try, /*On fail goto*//*Label 19926*/ GIMT_Encode4(1408503), // Rule ID 21390 //
     /* 1408420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408459 */     // MIs[0] Operand 5
     /* 1408459 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408470 */     // MIs[0] policy
     /* 1408470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408480 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1408483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408489 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408502 */     // GIR_Coverage, 21390,
     /* 1408502 */     GIR_EraseRootFromParent_Done,
     /* 1408503 */   // Label 19926: @1408503
     /* 1408503 */   GIM_Try, /*On fail goto*//*Label 19927*/ GIMT_Encode4(1408591), // Rule ID 21391 //
     /* 1408508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1408519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1408522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1408525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1408528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408547 */     // MIs[0] Operand 5
     /* 1408547 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408558 */     // MIs[0] policy
     /* 1408558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4_MASK),
     /* 1408571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408590 */     // GIR_Coverage, 21391,
     /* 1408590 */     GIR_EraseRootFromParent_Done,
     /* 1408591 */   // Label 19927: @1408591
     /* 1408591 */   GIM_Try, /*On fail goto*//*Label 19928*/ GIMT_Encode4(1408679), // Rule ID 21394 //
     /* 1408596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408635 */     // MIs[0] Operand 5
     /* 1408635 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408646 */     // MIs[0] policy
     /* 1408646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408656 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1408659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408678 */     // GIR_Coverage, 21394,
     /* 1408678 */     GIR_EraseRootFromParent_Done,
     /* 1408679 */   // Label 19928: @1408679
     /* 1408679 */   GIM_Try, /*On fail goto*//*Label 19929*/ GIMT_Encode4(1408767), // Rule ID 21395 //
     /* 1408684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1408695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1408698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1408701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1408704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408723 */     // MIs[0] Operand 5
     /* 1408723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408734 */     // MIs[0] policy
     /* 1408734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408744 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1408747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408766 */     // GIR_Coverage, 21395,
     /* 1408766 */     GIR_EraseRootFromParent_Done,
     /* 1408767 */   // Label 19929: @1408767
     /* 1408767 */   GIM_Try, /*On fail goto*//*Label 19930*/ GIMT_Encode4(1408855), // Rule ID 21398 //
     /* 1408772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1408789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408811 */     // MIs[0] Operand 5
     /* 1408811 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408822 */     // MIs[0] policy
     /* 1408822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408832 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1408832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1408835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408854 */     // GIR_Coverage, 21398,
     /* 1408854 */     GIR_EraseRootFromParent_Done,
     /* 1408855 */   // Label 19930: @1408855
     /* 1408855 */   GIM_Try, /*On fail goto*//*Label 19931*/ GIMT_Encode4(1408943), // Rule ID 21399 //
     /* 1408860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1408863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1408871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1408874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1408877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1408880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1408883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1408887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1408891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408899 */     // MIs[0] Operand 5
     /* 1408899 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408910 */     // MIs[0] policy
     /* 1408910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1408913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1408920 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1408920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1408923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1408925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1408927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1408929 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1408931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1408936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1408939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1408941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1408942 */     // GIR_Coverage, 21399,
     /* 1408942 */     GIR_EraseRootFromParent_Done,
     /* 1408943 */   // Label 19931: @1408943
     /* 1408943 */   GIM_Try, /*On fail goto*//*Label 19932*/ GIMT_Encode4(1409031), // Rule ID 21402 //
     /* 1408948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1408951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1408956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1408959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1408962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1408965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1408968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1408971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1408975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1408979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1408983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1408987 */     // MIs[0] Operand 5
     /* 1408987 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1408998 */     // MIs[0] policy
     /* 1408998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409008 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1409011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409030 */     // GIR_Coverage, 21402,
     /* 1409030 */     GIR_EraseRootFromParent_Done,
     /* 1409031 */   // Label 19932: @1409031
     /* 1409031 */   GIM_Try, /*On fail goto*//*Label 19933*/ GIMT_Encode4(1409119), // Rule ID 21403 //
     /* 1409036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1409047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1409050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1409053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409075 */     // MIs[0] Operand 5
     /* 1409075 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409086 */     // MIs[0] policy
     /* 1409086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1409099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409118 */     // GIR_Coverage, 21403,
     /* 1409118 */     GIR_EraseRootFromParent_Done,
     /* 1409119 */   // Label 19933: @1409119
     /* 1409119 */   GIM_Try, /*On fail goto*//*Label 19934*/ GIMT_Encode4(1409207), // Rule ID 21406 //
     /* 1409124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1409127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1409141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409163 */     // MIs[0] Operand 5
     /* 1409163 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409174 */     // MIs[0] policy
     /* 1409174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409184 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1409187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409193 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409206 */     // GIR_Coverage, 21406,
     /* 1409206 */     GIR_EraseRootFromParent_Done,
     /* 1409207 */   // Label 19934: @1409207
     /* 1409207 */   GIM_Try, /*On fail goto*//*Label 19935*/ GIMT_Encode4(1409295), // Rule ID 21407 //
     /* 1409212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1409215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1409223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1409226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1409229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1409232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409251 */     // MIs[0] Operand 5
     /* 1409251 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409262 */     // MIs[0] policy
     /* 1409262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1409275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1409291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409294 */     // GIR_Coverage, 21407,
     /* 1409294 */     GIR_EraseRootFromParent_Done,
     /* 1409295 */   // Label 19935: @1409295
     /* 1409295 */   GIM_Try, /*On fail goto*//*Label 19936*/ GIMT_Encode4(1409383), // Rule ID 21410 //
     /* 1409300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1409303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409339 */     // MIs[0] Operand 5
     /* 1409339 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409350 */     // MIs[0] policy
     /* 1409350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409360 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1409363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409382 */     // GIR_Coverage, 21410,
     /* 1409382 */     GIR_EraseRootFromParent_Done,
     /* 1409383 */   // Label 19936: @1409383
     /* 1409383 */   GIM_Try, /*On fail goto*//*Label 19937*/ GIMT_Encode4(1409471), // Rule ID 21411 //
     /* 1409388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1409391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1409399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1409402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1409405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1409408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409427 */     // MIs[0] Operand 5
     /* 1409427 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409438 */     // MIs[0] policy
     /* 1409438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409448 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2_MASK),
     /* 1409451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409457 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409470 */     // GIR_Coverage, 21411,
     /* 1409470 */     GIR_EraseRootFromParent_Done,
     /* 1409471 */   // Label 19937: @1409471
     /* 1409471 */   GIM_Try, /*On fail goto*//*Label 19938*/ GIMT_Encode4(1409559), // Rule ID 21414 //
     /* 1409476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1409479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1409493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409515 */     // MIs[0] Operand 5
     /* 1409515 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409526 */     // MIs[0] policy
     /* 1409526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409536 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1409539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409558 */     // GIR_Coverage, 21414,
     /* 1409558 */     GIR_EraseRootFromParent_Done,
     /* 1409559 */   // Label 19938: @1409559
     /* 1409559 */   GIM_Try, /*On fail goto*//*Label 19939*/ GIMT_Encode4(1409647), // Rule ID 21415 //
     /* 1409564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1409567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1409575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1409578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1409581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1409584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1409591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1409595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409603 */     // MIs[0] Operand 5
     /* 1409603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409614 */     // MIs[0] policy
     /* 1409614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409624 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1_MASK),
     /* 1409627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409646 */     // GIR_Coverage, 21415,
     /* 1409646 */     GIR_EraseRootFromParent_Done,
     /* 1409647 */   // Label 19939: @1409647
     /* 1409647 */   GIM_Try, /*On fail goto*//*Label 19940*/ GIMT_Encode4(1409735), // Rule ID 21418 //
     /* 1409652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1409655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1409669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409691 */     // MIs[0] Operand 5
     /* 1409691 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409702 */     // MIs[0] policy
     /* 1409702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1409715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409721 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409734 */     // GIR_Coverage, 21418,
     /* 1409734 */     GIR_EraseRootFromParent_Done,
     /* 1409735 */   // Label 19940: @1409735
     /* 1409735 */   GIM_Try, /*On fail goto*//*Label 19941*/ GIMT_Encode4(1409823), // Rule ID 21419 //
     /* 1409740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1409743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1409751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1409754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1409757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1409760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1409767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1409771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409779 */     // MIs[0] Operand 5
     /* 1409779 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409790 */     // MIs[0] policy
     /* 1409790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2_MASK),
     /* 1409803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409822 */     // GIR_Coverage, 21419,
     /* 1409822 */     GIR_EraseRootFromParent_Done,
     /* 1409823 */   // Label 19941: @1409823
     /* 1409823 */   GIM_Try, /*On fail goto*//*Label 19942*/ GIMT_Encode4(1409911), // Rule ID 21422 //
     /* 1409828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1409831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1409845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1409851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409867 */     // MIs[0] Operand 5
     /* 1409867 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409878 */     // MIs[0] policy
     /* 1409878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409888 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1409888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1409891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409910 */     // GIR_Coverage, 21422,
     /* 1409910 */     GIR_EraseRootFromParent_Done,
     /* 1409911 */   // Label 19942: @1409911
     /* 1409911 */   GIM_Try, /*On fail goto*//*Label 19943*/ GIMT_Encode4(1409999), // Rule ID 21423 //
     /* 1409916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1409919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1409924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1409927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1409930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1409933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1409936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1409939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1409943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1409947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1409951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1409955 */     // MIs[0] Operand 5
     /* 1409955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1409966 */     // MIs[0] policy
     /* 1409966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1409969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1409976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1409976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4_MASK),
     /* 1409979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1409981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1409983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1409985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1409987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1409992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1409995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1409997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1409998 */     // GIR_Coverage, 21423,
     /* 1409998 */     GIR_EraseRootFromParent_Done,
     /* 1409999 */   // Label 19943: @1409999
     /* 1409999 */   GIM_Try, /*On fail goto*//*Label 19944*/ GIMT_Encode4(1410087), // Rule ID 21426 //
     /* 1410004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1410015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1410018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410043 */     // MIs[0] Operand 5
     /* 1410043 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410054 */     // MIs[0] policy
     /* 1410054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410064 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1410067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410086 */     // GIR_Coverage, 21426,
     /* 1410086 */     GIR_EraseRootFromParent_Done,
     /* 1410087 */   // Label 19944: @1410087
     /* 1410087 */   GIM_Try, /*On fail goto*//*Label 19945*/ GIMT_Encode4(1410175), // Rule ID 21427 //
     /* 1410092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1410103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1410106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1410109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1410112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410131 */     // MIs[0] Operand 5
     /* 1410131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410142 */     // MIs[0] policy
     /* 1410142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8_MASK),
     /* 1410155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410161 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410174 */     // GIR_Coverage, 21427,
     /* 1410174 */     GIR_EraseRootFromParent_Done,
     /* 1410175 */   // Label 19945: @1410175
     /* 1410175 */   GIM_Try, /*On fail goto*//*Label 19946*/ GIMT_Encode4(1410263), // Rule ID 21430 //
     /* 1410180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1410191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1410194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410219 */     // MIs[0] Operand 5
     /* 1410219 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410230 */     // MIs[0] policy
     /* 1410230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1410243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410262 */     // GIR_Coverage, 21430,
     /* 1410262 */     GIR_EraseRootFromParent_Done,
     /* 1410263 */   // Label 19946: @1410263
     /* 1410263 */   GIM_Try, /*On fail goto*//*Label 19947*/ GIMT_Encode4(1410351), // Rule ID 21431 //
     /* 1410268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1410279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1410282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1410285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1410288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410307 */     // MIs[0] Operand 5
     /* 1410307 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410318 */     // MIs[0] policy
     /* 1410318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410328 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1410331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410350 */     // GIR_Coverage, 21431,
     /* 1410350 */     GIR_EraseRootFromParent_Done,
     /* 1410351 */   // Label 19947: @1410351
     /* 1410351 */   GIM_Try, /*On fail goto*//*Label 19948*/ GIMT_Encode4(1410439), // Rule ID 21434 //
     /* 1410356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1410367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1410370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1410373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410395 */     // MIs[0] Operand 5
     /* 1410395 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410406 */     // MIs[0] policy
     /* 1410406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410416 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1410419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410425 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410438 */     // GIR_Coverage, 21434,
     /* 1410438 */     GIR_EraseRootFromParent_Done,
     /* 1410439 */   // Label 19948: @1410439
     /* 1410439 */   GIM_Try, /*On fail goto*//*Label 19949*/ GIMT_Encode4(1410527), // Rule ID 21435 //
     /* 1410444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1410455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1410458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1410461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1410464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410483 */     // MIs[0] Operand 5
     /* 1410483 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410494 */     // MIs[0] policy
     /* 1410494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1410507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410526 */     // GIR_Coverage, 21435,
     /* 1410526 */     GIR_EraseRootFromParent_Done,
     /* 1410527 */   // Label 19949: @1410527
     /* 1410527 */   GIM_Try, /*On fail goto*//*Label 19950*/ GIMT_Encode4(1410615), // Rule ID 21438 //
     /* 1410532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1410543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1410546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410571 */     // MIs[0] Operand 5
     /* 1410571 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410582 */     // MIs[0] policy
     /* 1410582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410592 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1410595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410614 */     // GIR_Coverage, 21438,
     /* 1410614 */     GIR_EraseRootFromParent_Done,
     /* 1410615 */   // Label 19950: @1410615
     /* 1410615 */   GIM_Try, /*On fail goto*//*Label 19951*/ GIMT_Encode4(1410703), // Rule ID 21439 //
     /* 1410620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1410631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1410634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1410637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1410640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1410647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1410651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410659 */     // MIs[0] Operand 5
     /* 1410659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410670 */     // MIs[0] policy
     /* 1410670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1410683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410702 */     // GIR_Coverage, 21439,
     /* 1410702 */     GIR_EraseRootFromParent_Done,
     /* 1410703 */   // Label 19951: @1410703
     /* 1410703 */   GIM_Try, /*On fail goto*//*Label 19952*/ GIMT_Encode4(1410791), // Rule ID 21442 //
     /* 1410708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1410719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1410722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410747 */     // MIs[0] Operand 5
     /* 1410747 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410758 */     // MIs[0] policy
     /* 1410758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410768 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1410771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410790 */     // GIR_Coverage, 21442,
     /* 1410790 */     GIR_EraseRootFromParent_Done,
     /* 1410791 */   // Label 19952: @1410791
     /* 1410791 */   GIM_Try, /*On fail goto*//*Label 19953*/ GIMT_Encode4(1410879), // Rule ID 21443 //
     /* 1410796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1410807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1410810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1410813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1410816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1410823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1410827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410835 */     // MIs[0] Operand 5
     /* 1410835 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410846 */     // MIs[0] policy
     /* 1410846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1410856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1410859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410865 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410878 */     // GIR_Coverage, 21443,
     /* 1410878 */     GIR_EraseRootFromParent_Done,
     /* 1410879 */   // Label 19953: @1410879
     /* 1410879 */   GIM_Try, /*On fail goto*//*Label 19954*/ GIMT_Encode4(1410967), // Rule ID 21446 //
     /* 1410884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1410887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1410895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1410898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1410907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1410915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1410919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1410923 */     // MIs[0] Operand 5
     /* 1410923 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1410934 */     // MIs[0] policy
     /* 1410934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1410937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1410944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1410944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1410947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1410949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1410951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1410953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1410955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1410960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1410963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1410965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1410966 */     // GIR_Coverage, 21446,
     /* 1410966 */     GIR_EraseRootFromParent_Done,
     /* 1410967 */   // Label 19954: @1410967
     /* 1410967 */   GIM_Try, /*On fail goto*//*Label 19955*/ GIMT_Encode4(1411055), // Rule ID 21447 //
     /* 1410972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1410975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1410980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1410983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1410986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1410989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1410992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1410995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1410999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411011 */     // MIs[0] Operand 5
     /* 1411011 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411022 */     // MIs[0] policy
     /* 1411022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1411035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1411051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411054 */     // GIR_Coverage, 21447,
     /* 1411054 */     GIR_EraseRootFromParent_Done,
     /* 1411055 */   // Label 19955: @1411055
     /* 1411055 */   GIM_Try, /*On fail goto*//*Label 19956*/ GIMT_Encode4(1411143), // Rule ID 21450 //
     /* 1411060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1411071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1411074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411099 */     // MIs[0] Operand 5
     /* 1411099 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411110 */     // MIs[0] policy
     /* 1411110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411120 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1411123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411129 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411142 */     // GIR_Coverage, 21450,
     /* 1411142 */     GIR_EraseRootFromParent_Done,
     /* 1411143 */   // Label 19956: @1411143
     /* 1411143 */   GIM_Try, /*On fail goto*//*Label 19957*/ GIMT_Encode4(1411231), // Rule ID 21451 //
     /* 1411148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1411159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1411162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1411165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411187 */     // MIs[0] Operand 5
     /* 1411187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411198 */     // MIs[0] policy
     /* 1411198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4_MASK),
     /* 1411211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411230 */     // GIR_Coverage, 21451,
     /* 1411230 */     GIR_EraseRootFromParent_Done,
     /* 1411231 */   // Label 19957: @1411231
     /* 1411231 */   GIM_Try, /*On fail goto*//*Label 19958*/ GIMT_Encode4(1411319), // Rule ID 21454 //
     /* 1411236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1411247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1411250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411275 */     // MIs[0] Operand 5
     /* 1411275 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411286 */     // MIs[0] policy
     /* 1411286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1411299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411318 */     // GIR_Coverage, 21454,
     /* 1411318 */     GIR_EraseRootFromParent_Done,
     /* 1411319 */   // Label 19958: @1411319
     /* 1411319 */   GIM_Try, /*On fail goto*//*Label 19959*/ GIMT_Encode4(1411407), // Rule ID 21455 //
     /* 1411324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1411335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1411338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1411341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1411344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411363 */     // MIs[0] Operand 5
     /* 1411363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411374 */     // MIs[0] policy
     /* 1411374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1411387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411393 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411406 */     // GIR_Coverage, 21455,
     /* 1411406 */     GIR_EraseRootFromParent_Done,
     /* 1411407 */   // Label 19959: @1411407
     /* 1411407 */   GIM_Try, /*On fail goto*//*Label 19960*/ GIMT_Encode4(1411495), // Rule ID 21458 //
     /* 1411412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1411423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1411426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1411429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411451 */     // MIs[0] Operand 5
     /* 1411451 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411462 */     // MIs[0] policy
     /* 1411462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1411475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411494 */     // GIR_Coverage, 21458,
     /* 1411494 */     GIR_EraseRootFromParent_Done,
     /* 1411495 */   // Label 19960: @1411495
     /* 1411495 */   GIM_Try, /*On fail goto*//*Label 19961*/ GIMT_Encode4(1411583), // Rule ID 21459 //
     /* 1411500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1411511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1411514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1411517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1411520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411539 */     // MIs[0] Operand 5
     /* 1411539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411550 */     // MIs[0] policy
     /* 1411550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1411563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411569 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411582 */     // GIR_Coverage, 21459,
     /* 1411582 */     GIR_EraseRootFromParent_Done,
     /* 1411583 */   // Label 19961: @1411583
     /* 1411583 */   GIM_Try, /*On fail goto*//*Label 19962*/ GIMT_Encode4(1411671), // Rule ID 21462 //
     /* 1411588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1411599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1411602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411627 */     // MIs[0] Operand 5
     /* 1411627 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411638 */     // MIs[0] policy
     /* 1411638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1411651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411670 */     // GIR_Coverage, 21462,
     /* 1411670 */     GIR_EraseRootFromParent_Done,
     /* 1411671 */   // Label 19962: @1411671
     /* 1411671 */   GIM_Try, /*On fail goto*//*Label 19963*/ GIMT_Encode4(1411759), // Rule ID 21463 //
     /* 1411676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1411687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1411690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1411693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1411696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1411703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1411707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411715 */     // MIs[0] Operand 5
     /* 1411715 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411726 */     // MIs[0] policy
     /* 1411726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411736 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1411739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411758 */     // GIR_Coverage, 21463,
     /* 1411758 */     GIR_EraseRootFromParent_Done,
     /* 1411759 */   // Label 19963: @1411759
     /* 1411759 */   GIM_Try, /*On fail goto*//*Label 19964*/ GIMT_Encode4(1411847), // Rule ID 21466 //
     /* 1411764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1411767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1411775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1411778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1411781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411803 */     // MIs[0] Operand 5
     /* 1411803 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411814 */     // MIs[0] policy
     /* 1411814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411824 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1411824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1411827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411833 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411846 */     // GIR_Coverage, 21466,
     /* 1411846 */     GIR_EraseRootFromParent_Done,
     /* 1411847 */   // Label 19964: @1411847
     /* 1411847 */   GIM_Try, /*On fail goto*//*Label 19965*/ GIMT_Encode4(1411935), // Rule ID 21467 //
     /* 1411852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1411855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1411863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1411866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1411869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1411872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1411875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1411879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1411883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1411887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411891 */     // MIs[0] Operand 5
     /* 1411891 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411902 */     // MIs[0] policy
     /* 1411902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1411912 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1411912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1411915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1411917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1411919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1411921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1411923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1411928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1411931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1411933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1411934 */     // GIR_Coverage, 21467,
     /* 1411934 */     GIR_EraseRootFromParent_Done,
     /* 1411935 */   // Label 19965: @1411935
     /* 1411935 */   GIM_Try, /*On fail goto*//*Label 19966*/ GIMT_Encode4(1412023), // Rule ID 21470 //
     /* 1411940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1411943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1411948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1411951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1411954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1411957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1411960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1411963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1411967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1411975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1411979 */     // MIs[0] Operand 5
     /* 1411979 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1411990 */     // MIs[0] policy
     /* 1411990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1411993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1412003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412022 */     // GIR_Coverage, 21470,
     /* 1412022 */     GIR_EraseRootFromParent_Done,
     /* 1412023 */   // Label 19966: @1412023
     /* 1412023 */   GIM_Try, /*On fail goto*//*Label 19967*/ GIMT_Encode4(1412111), // Rule ID 21471 //
     /* 1412028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1412031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1412039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1412042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1412045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1412048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412067 */     // MIs[0] Operand 5
     /* 1412067 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412078 */     // MIs[0] policy
     /* 1412078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412088 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2_MASK),
     /* 1412091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412097 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412110 */     // GIR_Coverage, 21471,
     /* 1412110 */     GIR_EraseRootFromParent_Done,
     /* 1412111 */   // Label 19967: @1412111
     /* 1412111 */   GIM_Try, /*On fail goto*//*Label 19968*/ GIMT_Encode4(1412199), // Rule ID 21474 //
     /* 1412116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1412119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1412133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412155 */     // MIs[0] Operand 5
     /* 1412155 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412166 */     // MIs[0] policy
     /* 1412166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412176 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1412179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412198 */     // GIR_Coverage, 21474,
     /* 1412198 */     GIR_EraseRootFromParent_Done,
     /* 1412199 */   // Label 19968: @1412199
     /* 1412199 */   GIM_Try, /*On fail goto*//*Label 19969*/ GIMT_Encode4(1412287), // Rule ID 21475 //
     /* 1412204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1412207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1412215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1412218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1412221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1412224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412243 */     // MIs[0] Operand 5
     /* 1412243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412254 */     // MIs[0] policy
     /* 1412254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412264 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1_MASK),
     /* 1412267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412286 */     // GIR_Coverage, 21475,
     /* 1412286 */     GIR_EraseRootFromParent_Done,
     /* 1412287 */   // Label 19969: @1412287
     /* 1412287 */   GIM_Try, /*On fail goto*//*Label 19970*/ GIMT_Encode4(1412375), // Rule ID 21478 //
     /* 1412292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1412295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1412309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412331 */     // MIs[0] Operand 5
     /* 1412331 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412342 */     // MIs[0] policy
     /* 1412342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412352 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1412355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412374 */     // GIR_Coverage, 21478,
     /* 1412374 */     GIR_EraseRootFromParent_Done,
     /* 1412375 */   // Label 19970: @1412375
     /* 1412375 */   GIM_Try, /*On fail goto*//*Label 19971*/ GIMT_Encode4(1412463), // Rule ID 21479 //
     /* 1412380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1412383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1412391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1412394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1412397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1412400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1412407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1412411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412419 */     // MIs[0] Operand 5
     /* 1412419 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412430 */     // MIs[0] policy
     /* 1412430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412440 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2_MASK),
     /* 1412443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412462 */     // GIR_Coverage, 21479,
     /* 1412462 */     GIR_EraseRootFromParent_Done,
     /* 1412463 */   // Label 19971: @1412463
     /* 1412463 */   GIM_Try, /*On fail goto*//*Label 19972*/ GIMT_Encode4(1412551), // Rule ID 21482 //
     /* 1412468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1412471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1412485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412507 */     // MIs[0] Operand 5
     /* 1412507 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412518 */     // MIs[0] policy
     /* 1412518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412528 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i64] }, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1412531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412550 */     // GIR_Coverage, 21482,
     /* 1412550 */     GIR_EraseRootFromParent_Done,
     /* 1412551 */   // Label 19972: @1412551
     /* 1412551 */   GIM_Try, /*On fail goto*//*Label 19973*/ GIMT_Encode4(1412639), // Rule ID 21483 //
     /* 1412556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1412559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1412564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1412567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1412570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1412573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1412576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1412583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1412587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1412591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412595 */     // MIs[0] Operand 5
     /* 1412595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/5, GIMT_Encode8(1),
     /* 1412606 */     // MIs[0] policy
     /* 1412606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412616 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, 1:{ *:[i32] }, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4_MASK),
     /* 1412619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1412625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1412627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1412635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412638 */     // GIR_Coverage, 21483,
     /* 1412638 */     GIR_EraseRootFromParent_Done,
     /* 1412639 */   // Label 19973: @1412639
     /* 1412639 */   GIM_Try, /*On fail goto*//*Label 19974*/ GIMT_Encode4(1412738), // Rule ID 2688 //
     /* 1412644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1412647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1412652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1412655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1412658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1412661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1412664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1412667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1412686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1412690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1412694 */     // MIs[1] Operand 1
     /* 1412694 */     // No operand predicates
     /* 1412694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412698 */     // MIs[0] policy
     /* 1412698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1412703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412710 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1412713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412719 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1412724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1412726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412734 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412736 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412737 */     // GIR_Coverage, 2688,
     /* 1412737 */     GIR_EraseRootFromParent_Done,
     /* 1412738 */   // Label 19974: @1412738
     /* 1412738 */   GIM_Try, /*On fail goto*//*Label 19975*/ GIMT_Encode4(1412837), // Rule ID 2689 //
     /* 1412743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1412746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1412751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1412754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1412757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1412760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1412763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1412766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1412785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1412789 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1412793 */     // MIs[1] Operand 1
     /* 1412793 */     // No operand predicates
     /* 1412793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412797 */     // MIs[0] policy
     /* 1412797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1412802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412809 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1412809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1412812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412818 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1412823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1412825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412836 */     // GIR_Coverage, 2689,
     /* 1412836 */     GIR_EraseRootFromParent_Done,
     /* 1412837 */   // Label 19975: @1412837
     /* 1412837 */   GIM_Try, /*On fail goto*//*Label 19976*/ GIMT_Encode4(1412936), // Rule ID 2696 //
     /* 1412842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1412845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1412850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1412853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1412856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1412859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1412862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1412865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1412868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1412884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1412888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1412892 */     // MIs[1] Operand 1
     /* 1412892 */     // No operand predicates
     /* 1412892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412896 */     // MIs[0] policy
     /* 1412896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1412901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1412908 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1412908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1412911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1412913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1412915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1412917 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1412922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1412924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1412929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1412932 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1412934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1412935 */     // GIR_Coverage, 2696,
     /* 1412935 */     GIR_EraseRootFromParent_Done,
     /* 1412936 */   // Label 19976: @1412936
     /* 1412936 */   GIM_Try, /*On fail goto*//*Label 19977*/ GIMT_Encode4(1413035), // Rule ID 2697 //
     /* 1412941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1412944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1412949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1412952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1412955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1412958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1412961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1412964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1412967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1412971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1412979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1412983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1412987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1412991 */     // MIs[1] Operand 1
     /* 1412991 */     // No operand predicates
     /* 1412991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1412995 */     // MIs[0] policy
     /* 1412995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1412998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413007 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1413010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413016 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1413031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413034 */     // GIR_Coverage, 2697,
     /* 1413034 */     GIR_EraseRootFromParent_Done,
     /* 1413035 */   // Label 19977: @1413035
     /* 1413035 */   GIM_Try, /*On fail goto*//*Label 19978*/ GIMT_Encode4(1413134), // Rule ID 2704 //
     /* 1413040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1413043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1413051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1413054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1413057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1413060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1413063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413090 */     // MIs[1] Operand 1
     /* 1413090 */     // No operand predicates
     /* 1413090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413094 */     // MIs[0] policy
     /* 1413094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413115 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1413130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413133 */     // GIR_Coverage, 2704,
     /* 1413133 */     GIR_EraseRootFromParent_Done,
     /* 1413134 */   // Label 19978: @1413134
     /* 1413134 */   GIM_Try, /*On fail goto*//*Label 19979*/ GIMT_Encode4(1413233), // Rule ID 2705 //
     /* 1413139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1413142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1413150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1413153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1413156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1413159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1413162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413189 */     // MIs[1] Operand 1
     /* 1413189 */     // No operand predicates
     /* 1413189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413193 */     // MIs[0] policy
     /* 1413193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413205 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413214 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1413229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413232 */     // GIR_Coverage, 2705,
     /* 1413232 */     GIR_EraseRootFromParent_Done,
     /* 1413233 */   // Label 19979: @1413233
     /* 1413233 */   GIM_Try, /*On fail goto*//*Label 19980*/ GIMT_Encode4(1413332), // Rule ID 2712 //
     /* 1413238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1413241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1413249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1413252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1413255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1413258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1413261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413288 */     // MIs[1] Operand 1
     /* 1413288 */     // No operand predicates
     /* 1413288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413292 */     // MIs[0] policy
     /* 1413292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413304 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1413307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413313 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413331 */     // GIR_Coverage, 2712,
     /* 1413331 */     GIR_EraseRootFromParent_Done,
     /* 1413332 */   // Label 19980: @1413332
     /* 1413332 */   GIM_Try, /*On fail goto*//*Label 19981*/ GIMT_Encode4(1413431), // Rule ID 2713 //
     /* 1413337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1413340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1413348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1413351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1413354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1413357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1413360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413387 */     // MIs[1] Operand 1
     /* 1413387 */     // No operand predicates
     /* 1413387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413391 */     // MIs[0] policy
     /* 1413391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413403 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1413406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413412 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413430 */     // GIR_Coverage, 2713,
     /* 1413430 */     GIR_EraseRootFromParent_Done,
     /* 1413431 */   // Label 19981: @1413431
     /* 1413431 */   GIM_Try, /*On fail goto*//*Label 19982*/ GIMT_Encode4(1413530), // Rule ID 2720 //
     /* 1413436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1413439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1413447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1413450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1413456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1413459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413482 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413486 */     // MIs[1] Operand 1
     /* 1413486 */     // No operand predicates
     /* 1413486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413490 */     // MIs[0] policy
     /* 1413490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413511 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413528 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413529 */     // GIR_Coverage, 2720,
     /* 1413529 */     GIR_EraseRootFromParent_Done,
     /* 1413530 */   // Label 19982: @1413530
     /* 1413530 */   GIM_Try, /*On fail goto*//*Label 19983*/ GIMT_Encode4(1413629), // Rule ID 2721 //
     /* 1413535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1413538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1413546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1413549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1413552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1413555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1413558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413581 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413585 */     // MIs[1] Operand 1
     /* 1413585 */     // No operand predicates
     /* 1413585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413589 */     // MIs[0] policy
     /* 1413589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413601 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413610 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1413625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413628 */     // GIR_Coverage, 2721,
     /* 1413628 */     GIR_EraseRootFromParent_Done,
     /* 1413629 */   // Label 19983: @1413629
     /* 1413629 */   GIM_Try, /*On fail goto*//*Label 19984*/ GIMT_Encode4(1413728), // Rule ID 2728 //
     /* 1413634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1413637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1413654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1413657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413680 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413684 */     // MIs[1] Operand 1
     /* 1413684 */     // No operand predicates
     /* 1413684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413688 */     // MIs[0] policy
     /* 1413688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413700 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413709 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413727 */     // GIR_Coverage, 2728,
     /* 1413727 */     GIR_EraseRootFromParent_Done,
     /* 1413728 */   // Label 19984: @1413728
     /* 1413728 */   GIM_Try, /*On fail goto*//*Label 19985*/ GIMT_Encode4(1413827), // Rule ID 2729 //
     /* 1413733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1413736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1413744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1413747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1413750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1413753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1413756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413783 */     // MIs[1] Operand 1
     /* 1413783 */     // No operand predicates
     /* 1413783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413787 */     // MIs[0] policy
     /* 1413787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413799 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1413802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413808 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1413823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413826 */     // GIR_Coverage, 2729,
     /* 1413826 */     GIR_EraseRootFromParent_Done,
     /* 1413827 */   // Label 19985: @1413827
     /* 1413827 */   GIM_Try, /*On fail goto*//*Label 19986*/ GIMT_Encode4(1413926), // Rule ID 2736 //
     /* 1413832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1413835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1413843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1413846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1413849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1413852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1413855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1413858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413882 */     // MIs[1] Operand 1
     /* 1413882 */     // No operand predicates
     /* 1413882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413886 */     // MIs[0] policy
     /* 1413886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413898 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1413898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1413901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1413903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1413905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1413907 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1413912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1413914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1413919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1413922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1413924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1413925 */     // GIR_Coverage, 2736,
     /* 1413925 */     GIR_EraseRootFromParent_Done,
     /* 1413926 */   // Label 19986: @1413926
     /* 1413926 */   GIM_Try, /*On fail goto*//*Label 19987*/ GIMT_Encode4(1414025), // Rule ID 2737 //
     /* 1413931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1413934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1413939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1413942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1413945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1413948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1413951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1413954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1413957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1413961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1413969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1413973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1413977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1413981 */     // MIs[1] Operand 1
     /* 1413981 */     // No operand predicates
     /* 1413981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1413985 */     // MIs[0] policy
     /* 1413985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1413988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1413990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1413997 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1413997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414006 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414024 */     // GIR_Coverage, 2737,
     /* 1414024 */     GIR_EraseRootFromParent_Done,
     /* 1414025 */   // Label 19987: @1414025
     /* 1414025 */   GIM_Try, /*On fail goto*//*Label 19988*/ GIMT_Encode4(1414124), // Rule ID 2744 //
     /* 1414030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1414033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1414041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1414044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1414050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1414053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414080 */     // MIs[1] Operand 1
     /* 1414080 */     // No operand predicates
     /* 1414080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414084 */     // MIs[0] policy
     /* 1414084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414105 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414123 */     // GIR_Coverage, 2744,
     /* 1414123 */     GIR_EraseRootFromParent_Done,
     /* 1414124 */   // Label 19988: @1414124
     /* 1414124 */   GIM_Try, /*On fail goto*//*Label 19989*/ GIMT_Encode4(1414223), // Rule ID 2745 //
     /* 1414129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1414132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1414140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1414143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1414146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1414149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1414152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414179 */     // MIs[1] Operand 1
     /* 1414179 */     // No operand predicates
     /* 1414179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414183 */     // MIs[0] policy
     /* 1414183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414195 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414204 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1414219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414222 */     // GIR_Coverage, 2745,
     /* 1414222 */     GIR_EraseRootFromParent_Done,
     /* 1414223 */   // Label 19989: @1414223
     /* 1414223 */   GIM_Try, /*On fail goto*//*Label 19990*/ GIMT_Encode4(1414322), // Rule ID 2752 //
     /* 1414228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1414231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1414239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1414242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1414245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1414248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1414251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414278 */     // MIs[1] Operand 1
     /* 1414278 */     // No operand predicates
     /* 1414278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414282 */     // MIs[0] policy
     /* 1414282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414294 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414303 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414318 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414320 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414321 */     // GIR_Coverage, 2752,
     /* 1414321 */     GIR_EraseRootFromParent_Done,
     /* 1414322 */   // Label 19990: @1414322
     /* 1414322 */   GIM_Try, /*On fail goto*//*Label 19991*/ GIMT_Encode4(1414421), // Rule ID 2753 //
     /* 1414327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1414330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1414338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1414341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1414344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1414347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1414350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414377 */     // MIs[1] Operand 1
     /* 1414377 */     // No operand predicates
     /* 1414377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414381 */     // MIs[0] policy
     /* 1414381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414393 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414402 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1414417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414420 */     // GIR_Coverage, 2753,
     /* 1414420 */     GIR_EraseRootFromParent_Done,
     /* 1414421 */   // Label 19991: @1414421
     /* 1414421 */   GIM_Try, /*On fail goto*//*Label 19992*/ GIMT_Encode4(1414520), // Rule ID 2760 //
     /* 1414426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1414429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1414437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1414440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1414443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1414446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1414449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414476 */     // MIs[1] Operand 1
     /* 1414476 */     // No operand predicates
     /* 1414476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414480 */     // MIs[0] policy
     /* 1414480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414492 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414501 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414519 */     // GIR_Coverage, 2760,
     /* 1414519 */     GIR_EraseRootFromParent_Done,
     /* 1414520 */   // Label 19992: @1414520
     /* 1414520 */   GIM_Try, /*On fail goto*//*Label 19993*/ GIMT_Encode4(1414619), // Rule ID 2761 //
     /* 1414525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1414528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1414536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1414539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1414542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1414545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1414548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1414555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1414563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414575 */     // MIs[1] Operand 1
     /* 1414575 */     // No operand predicates
     /* 1414575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414579 */     // MIs[0] policy
     /* 1414579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414591 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1414594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414600 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1414615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414618 */     // GIR_Coverage, 2761,
     /* 1414618 */     GIR_EraseRootFromParent_Done,
     /* 1414619 */   // Label 19993: @1414619
     /* 1414619 */   GIM_Try, /*On fail goto*//*Label 19994*/ GIMT_Encode4(1414718), // Rule ID 2768 //
     /* 1414624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1414627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1414641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1414644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1414647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414674 */     // MIs[1] Operand 1
     /* 1414674 */     // No operand predicates
     /* 1414674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414678 */     // MIs[0] policy
     /* 1414678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414690 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1414693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414699 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414717 */     // GIR_Coverage, 2768,
     /* 1414717 */     GIR_EraseRootFromParent_Done,
     /* 1414718 */   // Label 19994: @1414718
     /* 1414718 */   GIM_Try, /*On fail goto*//*Label 19995*/ GIMT_Encode4(1414817), // Rule ID 2769 //
     /* 1414723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1414726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1414734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1414737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1414740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1414743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1414746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1414753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1414761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414773 */     // MIs[1] Operand 1
     /* 1414773 */     // No operand predicates
     /* 1414773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414777 */     // MIs[0] policy
     /* 1414777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414789 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1414792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414798 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414816 */     // GIR_Coverage, 2769,
     /* 1414816 */     GIR_EraseRootFromParent_Done,
     /* 1414817 */   // Label 19995: @1414817
     /* 1414817 */   GIM_Try, /*On fail goto*//*Label 19996*/ GIMT_Encode4(1414916), // Rule ID 2776 //
     /* 1414822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1414825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1414839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1414842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1414845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1414848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414872 */     // MIs[1] Operand 1
     /* 1414872 */     // No operand predicates
     /* 1414872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414876 */     // MIs[0] policy
     /* 1414876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414888 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1414888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1414891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414897 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1414902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1414904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1414909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1414912 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1414914 */     GIR_RootConstrainSelectedInstOperands,
     /* 1414915 */     // GIR_Coverage, 2776,
     /* 1414915 */     GIR_EraseRootFromParent_Done,
     /* 1414916 */   // Label 19996: @1414916
     /* 1414916 */   GIM_Try, /*On fail goto*//*Label 19997*/ GIMT_Encode4(1415015), // Rule ID 2777 //
     /* 1414921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1414924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1414929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1414932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1414935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1414938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1414941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1414944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1414947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1414951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1414959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1414963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1414967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1414971 */     // MIs[1] Operand 1
     /* 1414971 */     // No operand predicates
     /* 1414971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1414975 */     // MIs[0] policy
     /* 1414975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1414978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1414980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1414987 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1414987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1414990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1414992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1414994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1414996 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415014 */     // GIR_Coverage, 2777,
     /* 1415014 */     GIR_EraseRootFromParent_Done,
     /* 1415015 */   // Label 19997: @1415015
     /* 1415015 */   GIM_Try, /*On fail goto*//*Label 19998*/ GIMT_Encode4(1415114), // Rule ID 2784 //
     /* 1415020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1415023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1415031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1415034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1415037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1415040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1415043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415066 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415070 */     // MIs[1] Operand 1
     /* 1415070 */     // No operand predicates
     /* 1415070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415074 */     // MIs[0] policy
     /* 1415074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415086 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1415089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415095 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415110 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415113 */     // GIR_Coverage, 2784,
     /* 1415113 */     GIR_EraseRootFromParent_Done,
     /* 1415114 */   // Label 19998: @1415114
     /* 1415114 */   GIM_Try, /*On fail goto*//*Label 19999*/ GIMT_Encode4(1415213), // Rule ID 2785 //
     /* 1415119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1415122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1415130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1415133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1415136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1415139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1415142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415165 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415169 */     // MIs[1] Operand 1
     /* 1415169 */     // No operand predicates
     /* 1415169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415173 */     // MIs[0] policy
     /* 1415173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415185 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1415188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415194 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1415209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415212 */     // GIR_Coverage, 2785,
     /* 1415212 */     GIR_EraseRootFromParent_Done,
     /* 1415213 */   // Label 19999: @1415213
     /* 1415213 */   GIM_Try, /*On fail goto*//*Label 20000*/ GIMT_Encode4(1415312), // Rule ID 2792 //
     /* 1415218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1415221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1415238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1415241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415268 */     // MIs[1] Operand 1
     /* 1415268 */     // No operand predicates
     /* 1415268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415272 */     // MIs[0] policy
     /* 1415272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415284 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1415287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415293 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415311 */     // GIR_Coverage, 2792,
     /* 1415311 */     GIR_EraseRootFromParent_Done,
     /* 1415312 */   // Label 20000: @1415312
     /* 1415312 */   GIM_Try, /*On fail goto*//*Label 20001*/ GIMT_Encode4(1415411), // Rule ID 2793 //
     /* 1415317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1415320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1415328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1415331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1415334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1415337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1415340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415367 */     // MIs[1] Operand 1
     /* 1415367 */     // No operand predicates
     /* 1415367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415371 */     // MIs[0] policy
     /* 1415371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415383 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1415386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415392 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415410 */     // GIR_Coverage, 2793,
     /* 1415410 */     GIR_EraseRootFromParent_Done,
     /* 1415411 */   // Label 20001: @1415411
     /* 1415411 */   GIM_Try, /*On fail goto*//*Label 20002*/ GIMT_Encode4(1415510), // Rule ID 2800 //
     /* 1415416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1415419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1415436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1415439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415466 */     // MIs[1] Operand 1
     /* 1415466 */     // No operand predicates
     /* 1415466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415470 */     // MIs[0] policy
     /* 1415470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1415485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415491 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415509 */     // GIR_Coverage, 2800,
     /* 1415509 */     GIR_EraseRootFromParent_Done,
     /* 1415510 */   // Label 20002: @1415510
     /* 1415510 */   GIM_Try, /*On fail goto*//*Label 20003*/ GIMT_Encode4(1415609), // Rule ID 2801 //
     /* 1415515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1415518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1415526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1415529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1415532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1415535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1415538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1415545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1415553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415565 */     // MIs[1] Operand 1
     /* 1415565 */     // No operand predicates
     /* 1415565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415569 */     // MIs[0] policy
     /* 1415569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415581 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1415584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415590 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415608 */     // GIR_Coverage, 2801,
     /* 1415608 */     GIR_EraseRootFromParent_Done,
     /* 1415609 */   // Label 20003: @1415609
     /* 1415609 */   GIM_Try, /*On fail goto*//*Label 20004*/ GIMT_Encode4(1415708), // Rule ID 2808 //
     /* 1415614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1415617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1415625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1415628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1415634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1415637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415664 */     // MIs[1] Operand 1
     /* 1415664 */     // No operand predicates
     /* 1415664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415668 */     // MIs[0] policy
     /* 1415668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415680 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1415683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415689 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415706 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415707 */     // GIR_Coverage, 2808,
     /* 1415707 */     GIR_EraseRootFromParent_Done,
     /* 1415708 */   // Label 20004: @1415708
     /* 1415708 */   GIM_Try, /*On fail goto*//*Label 20005*/ GIMT_Encode4(1415807), // Rule ID 2809 //
     /* 1415713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1415716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1415724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1415727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1415730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1415733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1415736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1415743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1415751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415763 */     // MIs[1] Operand 1
     /* 1415763 */     // No operand predicates
     /* 1415763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415767 */     // MIs[0] policy
     /* 1415767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415779 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1415782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415788 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1415803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415806 */     // GIR_Coverage, 2809,
     /* 1415806 */     GIR_EraseRootFromParent_Done,
     /* 1415807 */   // Label 20005: @1415807
     /* 1415807 */   GIM_Try, /*On fail goto*//*Label 20006*/ GIMT_Encode4(1415906), // Rule ID 2816 //
     /* 1415812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1415815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1415823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1415826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1415832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1415835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1415838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415862 */     // MIs[1] Operand 1
     /* 1415862 */     // No operand predicates
     /* 1415862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415866 */     // MIs[0] policy
     /* 1415866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415878 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1415878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1415881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415887 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1415902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1415904 */     GIR_RootConstrainSelectedInstOperands,
     /* 1415905 */     // GIR_Coverage, 2816,
     /* 1415905 */     GIR_EraseRootFromParent_Done,
     /* 1415906 */   // Label 20006: @1415906
     /* 1415906 */   GIM_Try, /*On fail goto*//*Label 20007*/ GIMT_Encode4(1416005), // Rule ID 2817 //
     /* 1415911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1415914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1415919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1415922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1415925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1415928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1415931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1415934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1415937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1415941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1415949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1415953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1415957 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1415961 */     // MIs[1] Operand 1
     /* 1415961 */     // No operand predicates
     /* 1415961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1415965 */     // MIs[0] policy
     /* 1415965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1415968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1415970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1415977 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1415977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1415980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1415982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1415984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1415986 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1415991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1415993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1415998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416004 */     // GIR_Coverage, 2817,
     /* 1416004 */     GIR_EraseRootFromParent_Done,
     /* 1416005 */   // Label 20007: @1416005
     /* 1416005 */   GIM_Try, /*On fail goto*//*Label 20008*/ GIMT_Encode4(1416104), // Rule ID 2824 //
     /* 1416010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1416013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1416030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1416033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416060 */     // MIs[1] Operand 1
     /* 1416060 */     // No operand predicates
     /* 1416060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416064 */     // MIs[0] policy
     /* 1416064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1416079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416085 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416103 */     // GIR_Coverage, 2824,
     /* 1416103 */     GIR_EraseRootFromParent_Done,
     /* 1416104 */   // Label 20008: @1416104
     /* 1416104 */   GIM_Try, /*On fail goto*//*Label 20009*/ GIMT_Encode4(1416203), // Rule ID 2825 //
     /* 1416109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1416112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1416120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1416123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1416126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1416129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1416132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416159 */     // MIs[1] Operand 1
     /* 1416159 */     // No operand predicates
     /* 1416159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416163 */     // MIs[0] policy
     /* 1416163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416175 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1416178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416184 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416202 */     // GIR_Coverage, 2825,
     /* 1416202 */     GIR_EraseRootFromParent_Done,
     /* 1416203 */   // Label 20009: @1416203
     /* 1416203 */   GIM_Try, /*On fail goto*//*Label 20010*/ GIMT_Encode4(1416302), // Rule ID 2832 //
     /* 1416208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1416211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1416219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1416222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1416228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1416231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416258 */     // MIs[1] Operand 1
     /* 1416258 */     // No operand predicates
     /* 1416258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416262 */     // MIs[0] policy
     /* 1416262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1416277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416283 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416301 */     // GIR_Coverage, 2832,
     /* 1416301 */     GIR_EraseRootFromParent_Done,
     /* 1416302 */   // Label 20010: @1416302
     /* 1416302 */   GIM_Try, /*On fail goto*//*Label 20011*/ GIMT_Encode4(1416401), // Rule ID 2833 //
     /* 1416307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1416310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1416318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1416321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1416324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1416327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1416330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416357 */     // MIs[1] Operand 1
     /* 1416357 */     // No operand predicates
     /* 1416357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416361 */     // MIs[0] policy
     /* 1416361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416373 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1416376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416382 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1416397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416400 */     // GIR_Coverage, 2833,
     /* 1416400 */     GIR_EraseRootFromParent_Done,
     /* 1416401 */   // Label 20011: @1416401
     /* 1416401 */   GIM_Try, /*On fail goto*//*Label 20012*/ GIMT_Encode4(1416500), // Rule ID 2840 //
     /* 1416406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1416409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1416417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1416420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1416426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1416429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416452 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416456 */     // MIs[1] Operand 1
     /* 1416456 */     // No operand predicates
     /* 1416456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416460 */     // MIs[0] policy
     /* 1416460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1416475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416481 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416496 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416498 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416499 */     // GIR_Coverage, 2840,
     /* 1416499 */     GIR_EraseRootFromParent_Done,
     /* 1416500 */   // Label 20012: @1416500
     /* 1416500 */   GIM_Try, /*On fail goto*//*Label 20013*/ GIMT_Encode4(1416599), // Rule ID 2841 //
     /* 1416505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1416508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1416516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1416519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1416522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1416525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1416528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1416535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1416543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416555 */     // MIs[1] Operand 1
     /* 1416555 */     // No operand predicates
     /* 1416555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416559 */     // MIs[0] policy
     /* 1416559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416571 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1416574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416580 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416598 */     // GIR_Coverage, 2841,
     /* 1416598 */     GIR_EraseRootFromParent_Done,
     /* 1416599 */   // Label 20013: @1416599
     /* 1416599 */   GIM_Try, /*On fail goto*//*Label 20014*/ GIMT_Encode4(1416698), // Rule ID 2848 //
     /* 1416604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1416607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1416615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1416618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1416624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1416627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416654 */     // MIs[1] Operand 1
     /* 1416654 */     // No operand predicates
     /* 1416654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416658 */     // MIs[0] policy
     /* 1416658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416670 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1416673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416679 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416697 */     // GIR_Coverage, 2848,
     /* 1416697 */     GIR_EraseRootFromParent_Done,
     /* 1416698 */   // Label 20014: @1416698
     /* 1416698 */   GIM_Try, /*On fail goto*//*Label 20015*/ GIMT_Encode4(1416797), // Rule ID 2849 //
     /* 1416703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1416706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1416714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1416717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1416720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1416723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1416726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1416733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1416741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416753 */     // MIs[1] Operand 1
     /* 1416753 */     // No operand predicates
     /* 1416753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416757 */     // MIs[0] policy
     /* 1416757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416769 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1416772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416778 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416796 */     // GIR_Coverage, 2849,
     /* 1416796 */     GIR_EraseRootFromParent_Done,
     /* 1416797 */   // Label 20015: @1416797
     /* 1416797 */   GIM_Try, /*On fail goto*//*Label 20016*/ GIMT_Encode4(1416896), // Rule ID 2856 //
     /* 1416802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1416805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1416813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1416816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1416822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1416825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1416828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416852 */     // MIs[1] Operand 1
     /* 1416852 */     // No operand predicates
     /* 1416852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416856 */     // MIs[0] policy
     /* 1416856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1416868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1416871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416877 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416895 */     // GIR_Coverage, 2856,
     /* 1416895 */     GIR_EraseRootFromParent_Done,
     /* 1416896 */   // Label 20016: @1416896
     /* 1416896 */   GIM_Try, /*On fail goto*//*Label 20017*/ GIMT_Encode4(1416995), // Rule ID 2857 //
     /* 1416901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1416904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1416909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1416912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1416915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1416918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1416921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1416924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1416927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1416931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1416939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1416943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1416947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5_plus1),
     /* 1416951 */     // MIs[1] Operand 1
     /* 1416951 */     // No operand predicates
     /* 1416951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1416955 */     // MIs[0] policy
     /* 1416955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1416958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1416960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1416967 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm5_plus1>>:$rs2), VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1416967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1416970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1416972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1416974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1416976 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // rs2
     /* 1416981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1416983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1416988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1416991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1416993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1416994 */     // GIR_Coverage, 2857,
     /* 1416994 */     GIR_EraseRootFromParent_Done,
     /* 1416995 */   // Label 20017: @1416995
     /* 1416995 */   GIM_Try, /*On fail goto*//*Label 20018*/ GIMT_Encode4(1417092), // Rule ID 3032 //
     /* 1417000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1417017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417050 */     // MIs[1] Operand 1
     /* 1417050 */     // No operand predicates
     /* 1417050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417054 */     // MIs[0] policy
     /* 1417054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417066 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1417069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417091 */     // GIR_Coverage, 3032,
     /* 1417091 */     GIR_EraseRootFromParent_Done,
     /* 1417092 */   // Label 20018: @1417092
     /* 1417092 */   GIM_Try, /*On fail goto*//*Label 20019*/ GIMT_Encode4(1417189), // Rule ID 3033 //
     /* 1417097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1417108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1417111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1417114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417147 */     // MIs[1] Operand 1
     /* 1417147 */     // No operand predicates
     /* 1417147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417151 */     // MIs[0] policy
     /* 1417151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417163 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF8_MASK),
     /* 1417166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417188 */     // GIR_Coverage, 3033,
     /* 1417188 */     GIR_EraseRootFromParent_Done,
     /* 1417189 */   // Label 20019: @1417189
     /* 1417189 */   GIM_Try, /*On fail goto*//*Label 20020*/ GIMT_Encode4(1417286), // Rule ID 3036 //
     /* 1417194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1417211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417244 */     // MIs[1] Operand 1
     /* 1417244 */     // No operand predicates
     /* 1417244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417248 */     // MIs[0] policy
     /* 1417248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417260 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417285 */     // GIR_Coverage, 3036,
     /* 1417285 */     GIR_EraseRootFromParent_Done,
     /* 1417286 */   // Label 20020: @1417286
     /* 1417286 */   GIM_Try, /*On fail goto*//*Label 20021*/ GIMT_Encode4(1417383), // Rule ID 3037 //
     /* 1417291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1417302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1417305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1417308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417341 */     // MIs[1] Operand 1
     /* 1417341 */     // No operand predicates
     /* 1417341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417345 */     // MIs[0] policy
     /* 1417345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417357 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417382 */     // GIR_Coverage, 3037,
     /* 1417382 */     GIR_EraseRootFromParent_Done,
     /* 1417383 */   // Label 20021: @1417383
     /* 1417383 */   GIM_Try, /*On fail goto*//*Label 20022*/ GIMT_Encode4(1417480), // Rule ID 3040 //
     /* 1417388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1417405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1417411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417438 */     // MIs[1] Operand 1
     /* 1417438 */     // No operand predicates
     /* 1417438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417442 */     // MIs[0] policy
     /* 1417442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417454 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417479 */     // GIR_Coverage, 3040,
     /* 1417479 */     GIR_EraseRootFromParent_Done,
     /* 1417480 */   // Label 20022: @1417480
     /* 1417480 */   GIM_Try, /*On fail goto*//*Label 20023*/ GIMT_Encode4(1417577), // Rule ID 3041 //
     /* 1417485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1417496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1417499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1417502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1417508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417535 */     // MIs[1] Operand 1
     /* 1417535 */     // No operand predicates
     /* 1417535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417539 */     // MIs[0] policy
     /* 1417539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417551 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1417573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417576 */     // GIR_Coverage, 3041,
     /* 1417576 */     GIR_EraseRootFromParent_Done,
     /* 1417577 */   // Label 20023: @1417577
     /* 1417577 */   GIM_Try, /*On fail goto*//*Label 20024*/ GIMT_Encode4(1417674), // Rule ID 3044 //
     /* 1417582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417632 */     // MIs[1] Operand 1
     /* 1417632 */     // No operand predicates
     /* 1417632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417636 */     // MIs[0] policy
     /* 1417636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417673 */     // GIR_Coverage, 3044,
     /* 1417673 */     GIR_EraseRootFromParent_Done,
     /* 1417674 */   // Label 20024: @1417674
     /* 1417674 */   GIM_Try, /*On fail goto*//*Label 20025*/ GIMT_Encode4(1417771), // Rule ID 3045 //
     /* 1417679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1417690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1417693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1417696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417729 */     // MIs[1] Operand 1
     /* 1417729 */     // No operand predicates
     /* 1417729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417733 */     // MIs[0] policy
     /* 1417733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417745 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF4_MASK),
     /* 1417748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417770 */     // GIR_Coverage, 3045,
     /* 1417770 */     GIR_EraseRootFromParent_Done,
     /* 1417771 */   // Label 20025: @1417771
     /* 1417771 */   GIM_Try, /*On fail goto*//*Label 20026*/ GIMT_Encode4(1417868), // Rule ID 3048 //
     /* 1417776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417826 */     // MIs[1] Operand 1
     /* 1417826 */     // No operand predicates
     /* 1417826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417830 */     // MIs[0] policy
     /* 1417830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1417842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417867 */     // GIR_Coverage, 3048,
     /* 1417867 */     GIR_EraseRootFromParent_Done,
     /* 1417868 */   // Label 20026: @1417868
     /* 1417868 */   GIM_Try, /*On fail goto*//*Label 20027*/ GIMT_Encode4(1417965), // Rule ID 3049 //
     /* 1417873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1417876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1417884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1417887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1417890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1417893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1417896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1417899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1417903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1417911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1417915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1417919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1417923 */     // MIs[1] Operand 1
     /* 1417923 */     // No operand predicates
     /* 1417923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1417927 */     // MIs[0] policy
     /* 1417927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1417930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1417932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1417939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1417939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1417942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1417944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1417946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1417948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1417951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1417953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1417958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1417961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1417963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1417964 */     // GIR_Coverage, 3049,
     /* 1417964 */     GIR_EraseRootFromParent_Done,
     /* 1417965 */   // Label 20027: @1417965
     /* 1417965 */   GIM_Try, /*On fail goto*//*Label 20028*/ GIMT_Encode4(1418062), // Rule ID 3052 //
     /* 1417970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1417973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1417978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1417981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1417984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1417987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1417990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1417993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1417996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418020 */     // MIs[1] Operand 1
     /* 1418020 */     // No operand predicates
     /* 1418020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418024 */     // MIs[0] policy
     /* 1418024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1418039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418061 */     // GIR_Coverage, 3052,
     /* 1418061 */     GIR_EraseRootFromParent_Done,
     /* 1418062 */   // Label 20028: @1418062
     /* 1418062 */   GIM_Try, /*On fail goto*//*Label 20029*/ GIMT_Encode4(1418159), // Rule ID 3053 //
     /* 1418067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1418078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1418081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1418084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418117 */     // MIs[1] Operand 1
     /* 1418117 */     // No operand predicates
     /* 1418117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418121 */     // MIs[0] policy
     /* 1418121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_MF2_MASK),
     /* 1418136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418158 */     // GIR_Coverage, 3053,
     /* 1418158 */     GIR_EraseRootFromParent_Done,
     /* 1418159 */   // Label 20029: @1418159
     /* 1418159 */   GIM_Try, /*On fail goto*//*Label 20030*/ GIMT_Encode4(1418256), // Rule ID 3056 //
     /* 1418164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1418181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1418187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418214 */     // MIs[1] Operand 1
     /* 1418214 */     // No operand predicates
     /* 1418214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418218 */     // MIs[0] policy
     /* 1418218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418255 */     // GIR_Coverage, 3056,
     /* 1418255 */     GIR_EraseRootFromParent_Done,
     /* 1418256 */   // Label 20030: @1418256
     /* 1418256 */   GIM_Try, /*On fail goto*//*Label 20031*/ GIMT_Encode4(1418353), // Rule ID 3057 //
     /* 1418261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1418272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1418275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1418278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1418284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418311 */     // MIs[1] Operand 1
     /* 1418311 */     // No operand predicates
     /* 1418311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418315 */     // MIs[0] policy
     /* 1418315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1418349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418352 */     // GIR_Coverage, 3057,
     /* 1418352 */     GIR_EraseRootFromParent_Done,
     /* 1418353 */   // Label 20031: @1418353
     /* 1418353 */   GIM_Try, /*On fail goto*//*Label 20032*/ GIMT_Encode4(1418450), // Rule ID 3060 //
     /* 1418358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1418381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418408 */     // MIs[1] Operand 1
     /* 1418408 */     // No operand predicates
     /* 1418408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418412 */     // MIs[0] policy
     /* 1418412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418424 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418449 */     // GIR_Coverage, 3060,
     /* 1418449 */     GIR_EraseRootFromParent_Done,
     /* 1418450 */   // Label 20032: @1418450
     /* 1418450 */   GIM_Try, /*On fail goto*//*Label 20033*/ GIMT_Encode4(1418547), // Rule ID 3061 //
     /* 1418455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1418466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1418469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1418472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1418478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418505 */     // MIs[1] Operand 1
     /* 1418505 */     // No operand predicates
     /* 1418505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418509 */     // MIs[0] policy
     /* 1418509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418521 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1418543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418546 */     // GIR_Coverage, 3061,
     /* 1418546 */     GIR_EraseRootFromParent_Done,
     /* 1418547 */   // Label 20033: @1418547
     /* 1418547 */   GIM_Try, /*On fail goto*//*Label 20034*/ GIMT_Encode4(1418644), // Rule ID 3064 //
     /* 1418552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1418575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418602 */     // MIs[1] Operand 1
     /* 1418602 */     // No operand predicates
     /* 1418602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418606 */     // MIs[0] policy
     /* 1418606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418643 */     // GIR_Coverage, 3064,
     /* 1418643 */     GIR_EraseRootFromParent_Done,
     /* 1418644 */   // Label 20034: @1418644
     /* 1418644 */   GIM_Try, /*On fail goto*//*Label 20035*/ GIMT_Encode4(1418741), // Rule ID 3065 //
     /* 1418649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1418652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1418660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1418663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1418666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1418672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418699 */     // MIs[1] Operand 1
     /* 1418699 */     // No operand predicates
     /* 1418699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418703 */     // MIs[0] policy
     /* 1418703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418715 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1418737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418740 */     // GIR_Coverage, 3065,
     /* 1418740 */     GIR_EraseRootFromParent_Done,
     /* 1418741 */   // Label 20035: @1418741
     /* 1418741 */   GIM_Try, /*On fail goto*//*Label 20036*/ GIMT_Encode4(1418838), // Rule ID 3068 //
     /* 1418746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1418749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1418757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1418760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418796 */     // MIs[1] Operand 1
     /* 1418796 */     // No operand predicates
     /* 1418796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418800 */     // MIs[0] policy
     /* 1418800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418812 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1418812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418837 */     // GIR_Coverage, 3068,
     /* 1418837 */     GIR_EraseRootFromParent_Done,
     /* 1418838 */   // Label 20036: @1418838
     /* 1418838 */   GIM_Try, /*On fail goto*//*Label 20037*/ GIMT_Encode4(1418935), // Rule ID 3069 //
     /* 1418843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1418846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1418854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1418857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1418860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1418863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1418866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1418869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1418873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1418881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418893 */     // MIs[1] Operand 1
     /* 1418893 */     // No operand predicates
     /* 1418893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418897 */     // MIs[0] policy
     /* 1418897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1418909 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1418909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M1_MASK),
     /* 1418912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1418914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1418916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1418918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1418921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1418923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1418928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1418931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1418933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1418934 */     // GIR_Coverage, 3069,
     /* 1418934 */     GIR_EraseRootFromParent_Done,
     /* 1418935 */   // Label 20037: @1418935
     /* 1418935 */   GIM_Try, /*On fail goto*//*Label 20038*/ GIMT_Encode4(1419032), // Rule ID 3072 //
     /* 1418940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1418943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1418948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1418951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1418954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1418957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1418960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1418963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1418966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1418970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1418978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1418982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1418986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1418990 */     // MIs[1] Operand 1
     /* 1418990 */     // No operand predicates
     /* 1418990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1418994 */     // MIs[0] policy
     /* 1418994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1418997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1418999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419006 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419031 */     // GIR_Coverage, 3072,
     /* 1419031 */     GIR_EraseRootFromParent_Done,
     /* 1419032 */   // Label 20038: @1419032
     /* 1419032 */   GIM_Try, /*On fail goto*//*Label 20039*/ GIMT_Encode4(1419129), // Rule ID 3073 //
     /* 1419037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1419048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1419051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1419054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419087 */     // MIs[1] Operand 1
     /* 1419087 */     // No operand predicates
     /* 1419087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419091 */     // MIs[0] policy
     /* 1419091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419103 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419128 */     // GIR_Coverage, 3073,
     /* 1419128 */     GIR_EraseRootFromParent_Done,
     /* 1419129 */   // Label 20039: @1419129
     /* 1419129 */   GIM_Try, /*On fail goto*//*Label 20040*/ GIMT_Encode4(1419226), // Rule ID 3076 //
     /* 1419134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1419145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1419148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1419151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419184 */     // MIs[1] Operand 1
     /* 1419184 */     // No operand predicates
     /* 1419184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419188 */     // MIs[0] policy
     /* 1419188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419225 */     // GIR_Coverage, 3076,
     /* 1419225 */     GIR_EraseRootFromParent_Done,
     /* 1419226 */   // Label 20040: @1419226
     /* 1419226 */   GIM_Try, /*On fail goto*//*Label 20041*/ GIMT_Encode4(1419323), // Rule ID 3077 //
     /* 1419231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1419242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1419245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1419248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419281 */     // MIs[1] Operand 1
     /* 1419281 */     // No operand predicates
     /* 1419281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419285 */     // MIs[0] policy
     /* 1419285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419297 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419322 */     // GIR_Coverage, 3077,
     /* 1419322 */     GIR_EraseRootFromParent_Done,
     /* 1419323 */   // Label 20041: @1419323
     /* 1419323 */   GIM_Try, /*On fail goto*//*Label 20042*/ GIMT_Encode4(1419420), // Rule ID 3080 //
     /* 1419328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1419339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1419342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1419345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1419351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419378 */     // MIs[1] Operand 1
     /* 1419378 */     // No operand predicates
     /* 1419378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419382 */     // MIs[0] policy
     /* 1419382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1419397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419419 */     // GIR_Coverage, 3080,
     /* 1419419 */     GIR_EraseRootFromParent_Done,
     /* 1419420 */   // Label 20042: @1419420
     /* 1419420 */   GIM_Try, /*On fail goto*//*Label 20043*/ GIMT_Encode4(1419517), // Rule ID 3081 //
     /* 1419425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1419436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1419439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1419442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1419448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419475 */     // MIs[1] Operand 1
     /* 1419475 */     // No operand predicates
     /* 1419475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419479 */     // MIs[0] policy
     /* 1419479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419491 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1419494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1419513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419516 */     // GIR_Coverage, 3081,
     /* 1419516 */     GIR_EraseRootFromParent_Done,
     /* 1419517 */   // Label 20043: @1419517
     /* 1419517 */   GIM_Try, /*On fail goto*//*Label 20044*/ GIMT_Encode4(1419614), // Rule ID 3084 //
     /* 1419522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1419539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1419545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419572 */     // MIs[1] Operand 1
     /* 1419572 */     // No operand predicates
     /* 1419572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419576 */     // MIs[0] policy
     /* 1419576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419588 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419613 */     // GIR_Coverage, 3084,
     /* 1419613 */     GIR_EraseRootFromParent_Done,
     /* 1419614 */   // Label 20044: @1419614
     /* 1419614 */   GIM_Try, /*On fail goto*//*Label 20045*/ GIMT_Encode4(1419711), // Rule ID 3085 //
     /* 1419619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1419630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1419633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1419636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1419642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1419649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1419657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419669 */     // MIs[1] Operand 1
     /* 1419669 */     // No operand predicates
     /* 1419669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419673 */     // MIs[0] policy
     /* 1419673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1419688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419710 */     // GIR_Coverage, 3085,
     /* 1419710 */     GIR_EraseRootFromParent_Done,
     /* 1419711 */   // Label 20045: @1419711
     /* 1419711 */   GIM_Try, /*On fail goto*//*Label 20046*/ GIMT_Encode4(1419808), // Rule ID 3088 //
     /* 1419716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1419733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419766 */     // MIs[1] Operand 1
     /* 1419766 */     // No operand predicates
     /* 1419766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419770 */     // MIs[0] policy
     /* 1419770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419782 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419807 */     // GIR_Coverage, 3088,
     /* 1419807 */     GIR_EraseRootFromParent_Done,
     /* 1419808 */   // Label 20046: @1419808
     /* 1419808 */   GIM_Try, /*On fail goto*//*Label 20047*/ GIMT_Encode4(1419905), // Rule ID 3089 //
     /* 1419813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1419816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1419824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1419827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1419830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1419833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1419836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1419839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1419843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1419851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419863 */     // MIs[1] Operand 1
     /* 1419863 */     // No operand predicates
     /* 1419863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419867 */     // MIs[0] policy
     /* 1419867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419879 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1419879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1419882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1419903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1419904 */     // GIR_Coverage, 3089,
     /* 1419904 */     GIR_EraseRootFromParent_Done,
     /* 1419905 */   // Label 20047: @1419905
     /* 1419905 */   GIM_Try, /*On fail goto*//*Label 20048*/ GIMT_Encode4(1420002), // Rule ID 3092 //
     /* 1419910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1419913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1419918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1419921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1419924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1419927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1419930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1419933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1419936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1419940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1419948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1419952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1419956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1419960 */     // MIs[1] Operand 1
     /* 1419960 */     // No operand predicates
     /* 1419960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1419964 */     // MIs[0] policy
     /* 1419964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1419967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1419969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1419976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1419976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1419979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1419981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1419983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1419985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1419988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1419990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1419995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1419998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420001 */     // GIR_Coverage, 3092,
     /* 1420001 */     GIR_EraseRootFromParent_Done,
     /* 1420002 */   // Label 20048: @1420002
     /* 1420002 */   GIM_Try, /*On fail goto*//*Label 20049*/ GIMT_Encode4(1420099), // Rule ID 3093 //
     /* 1420007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1420018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1420021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1420024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1420030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420057 */     // MIs[1] Operand 1
     /* 1420057 */     // No operand predicates
     /* 1420057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420061 */     // MIs[0] policy
     /* 1420061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420073 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1420095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420098 */     // GIR_Coverage, 3093,
     /* 1420098 */     GIR_EraseRootFromParent_Done,
     /* 1420099 */   // Label 20049: @1420099
     /* 1420099 */   GIM_Try, /*On fail goto*//*Label 20050*/ GIMT_Encode4(1420196), // Rule ID 3096 //
     /* 1420104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1420121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420154 */     // MIs[1] Operand 1
     /* 1420154 */     // No operand predicates
     /* 1420154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420158 */     // MIs[0] policy
     /* 1420158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420195 */     // GIR_Coverage, 3096,
     /* 1420195 */     GIR_EraseRootFromParent_Done,
     /* 1420196 */   // Label 20050: @1420196
     /* 1420196 */   GIM_Try, /*On fail goto*//*Label 20051*/ GIMT_Encode4(1420293), // Rule ID 3097 //
     /* 1420201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1420212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1420215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1420218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420251 */     // MIs[1] Operand 1
     /* 1420251 */     // No operand predicates
     /* 1420251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420255 */     // MIs[0] policy
     /* 1420255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420267 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420292 */     // GIR_Coverage, 3097,
     /* 1420292 */     GIR_EraseRootFromParent_Done,
     /* 1420293 */   // Label 20051: @1420293
     /* 1420293 */   GIM_Try, /*On fail goto*//*Label 20052*/ GIMT_Encode4(1420390), // Rule ID 3100 //
     /* 1420298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1420315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420348 */     // MIs[1] Operand 1
     /* 1420348 */     // No operand predicates
     /* 1420348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420352 */     // MIs[0] policy
     /* 1420352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1420367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420389 */     // GIR_Coverage, 3100,
     /* 1420389 */     GIR_EraseRootFromParent_Done,
     /* 1420390 */   // Label 20052: @1420390
     /* 1420390 */   GIM_Try, /*On fail goto*//*Label 20053*/ GIMT_Encode4(1420487), // Rule ID 3101 //
     /* 1420395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1420406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1420409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1420412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1420418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420445 */     // MIs[1] Operand 1
     /* 1420445 */     // No operand predicates
     /* 1420445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420449 */     // MIs[0] policy
     /* 1420449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420461 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1420464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420486 */     // GIR_Coverage, 3101,
     /* 1420486 */     GIR_EraseRootFromParent_Done,
     /* 1420487 */   // Label 20053: @1420487
     /* 1420487 */   GIM_Try, /*On fail goto*//*Label 20054*/ GIMT_Encode4(1420584), // Rule ID 3104 //
     /* 1420492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1420495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1420503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1420506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1420509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1420515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420542 */     // MIs[1] Operand 1
     /* 1420542 */     // No operand predicates
     /* 1420542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420546 */     // MIs[0] policy
     /* 1420546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420558 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420583 */     // GIR_Coverage, 3104,
     /* 1420583 */     GIR_EraseRootFromParent_Done,
     /* 1420584 */   // Label 20054: @1420584
     /* 1420584 */   GIM_Try, /*On fail goto*//*Label 20055*/ GIMT_Encode4(1420681), // Rule ID 3105 //
     /* 1420589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1420592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1420600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1420603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1420606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1420612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1420619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1420627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420639 */     // MIs[1] Operand 1
     /* 1420639 */     // No operand predicates
     /* 1420639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420643 */     // MIs[0] policy
     /* 1420643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420655 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1420658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1420677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420680 */     // GIR_Coverage, 3105,
     /* 1420680 */     GIR_EraseRootFromParent_Done,
     /* 1420681 */   // Label 20055: @1420681
     /* 1420681 */   GIM_Try, /*On fail goto*//*Label 20056*/ GIMT_Encode4(1420778), // Rule ID 3108 //
     /* 1420686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1420689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1420703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420736 */     // MIs[1] Operand 1
     /* 1420736 */     // No operand predicates
     /* 1420736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420740 */     // MIs[0] policy
     /* 1420740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420777 */     // GIR_Coverage, 3108,
     /* 1420777 */     GIR_EraseRootFromParent_Done,
     /* 1420778 */   // Label 20056: @1420778
     /* 1420778 */   GIM_Try, /*On fail goto*//*Label 20057*/ GIMT_Encode4(1420875), // Rule ID 3109 //
     /* 1420783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1420786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1420794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1420797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1420800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1420806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1420809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1420813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1420821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420833 */     // MIs[1] Operand 1
     /* 1420833 */     // No operand predicates
     /* 1420833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420837 */     // MIs[0] policy
     /* 1420837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420849 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1420849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M2_MASK),
     /* 1420852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420874 */     // GIR_Coverage, 3109,
     /* 1420874 */     GIR_EraseRootFromParent_Done,
     /* 1420875 */   // Label 20057: @1420875
     /* 1420875 */   GIM_Try, /*On fail goto*//*Label 20058*/ GIMT_Encode4(1420972), // Rule ID 3112 //
     /* 1420880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1420883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1420891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1420894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1420897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1420900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1420903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1420906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1420910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1420918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1420922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1420926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1420930 */     // MIs[1] Operand 1
     /* 1420930 */     // No operand predicates
     /* 1420930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1420934 */     // MIs[0] policy
     /* 1420934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1420937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1420939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1420946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1420946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1420949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1420951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1420953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1420955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1420958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1420960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1420965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1420968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1420970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1420971 */     // GIR_Coverage, 3112,
     /* 1420971 */     GIR_EraseRootFromParent_Done,
     /* 1420972 */   // Label 20058: @1420972
     /* 1420972 */   GIM_Try, /*On fail goto*//*Label 20059*/ GIMT_Encode4(1421069), // Rule ID 3113 //
     /* 1420977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1420980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1420985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1420988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1420991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1420994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1420997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1421007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1421015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421027 */     // MIs[1] Operand 1
     /* 1421027 */     // No operand predicates
     /* 1421027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421031 */     // MIs[0] policy
     /* 1421031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421043 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M4_MASK),
     /* 1421046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421068 */     // GIR_Coverage, 3113,
     /* 1421068 */     GIR_EraseRootFromParent_Done,
     /* 1421069 */   // Label 20059: @1421069
     /* 1421069 */   GIM_Try, /*On fail goto*//*Label 20060*/ GIMT_Encode4(1421166), // Rule ID 3116 //
     /* 1421074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1421077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1421085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1421088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1421091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421124 */     // MIs[1] Operand 1
     /* 1421124 */     // No operand predicates
     /* 1421124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421128 */     // MIs[0] policy
     /* 1421128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421165 */     // GIR_Coverage, 3116,
     /* 1421165 */     GIR_EraseRootFromParent_Done,
     /* 1421166 */   // Label 20060: @1421166
     /* 1421166 */   GIM_Try, /*On fail goto*//*Label 20061*/ GIMT_Encode4(1421263), // Rule ID 3117 //
     /* 1421171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1421174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1421179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1421182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1421185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1421188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1421194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1421201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1421209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421221 */     // MIs[1] Operand 1
     /* 1421221 */     // No operand predicates
     /* 1421221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421225 */     // MIs[0] policy
     /* 1421225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421237 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VI_M8_MASK),
     /* 1421240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1421259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421262 */     // GIR_Coverage, 3117,
     /* 1421262 */     GIR_EraseRootFromParent_Done,
     /* 1421263 */   // Label 20061: @1421263
     /* 1421263 */   GIM_Try, /*On fail goto*//*Label 20062*/ GIMT_Encode4(1421360), // Rule ID 3384 //
     /* 1421268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1421279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1421282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1421285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421318 */     // MIs[1] Operand 1
     /* 1421318 */     // No operand predicates
     /* 1421318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421322 */     // MIs[0] policy
     /* 1421322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1421337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421359 */     // GIR_Coverage, 3384,
     /* 1421359 */     GIR_EraseRootFromParent_Done,
     /* 1421360 */   // Label 20062: @1421360
     /* 1421360 */   GIM_Try, /*On fail goto*//*Label 20063*/ GIMT_Encode4(1421457), // Rule ID 3385 //
     /* 1421365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1421376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1421379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1421382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421415 */     // MIs[1] Operand 1
     /* 1421415 */     // No operand predicates
     /* 1421415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421419 */     // MIs[0] policy
     /* 1421419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421431 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF8_MASK),
     /* 1421434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421456 */     // GIR_Coverage, 3385,
     /* 1421456 */     GIR_EraseRootFromParent_Done,
     /* 1421457 */   // Label 20063: @1421457
     /* 1421457 */   GIM_Try, /*On fail goto*//*Label 20064*/ GIMT_Encode4(1421554), // Rule ID 3388 //
     /* 1421462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1421473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1421476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1421479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421512 */     // MIs[1] Operand 1
     /* 1421512 */     // No operand predicates
     /* 1421512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421516 */     // MIs[0] policy
     /* 1421516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1421531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421553 */     // GIR_Coverage, 3388,
     /* 1421553 */     GIR_EraseRootFromParent_Done,
     /* 1421554 */   // Label 20064: @1421554
     /* 1421554 */   GIM_Try, /*On fail goto*//*Label 20065*/ GIMT_Encode4(1421651), // Rule ID 3389 //
     /* 1421559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1421570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1421573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1421576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1421582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421609 */     // MIs[1] Operand 1
     /* 1421609 */     // No operand predicates
     /* 1421609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421613 */     // MIs[0] policy
     /* 1421613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421625 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1421628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421650 */     // GIR_Coverage, 3389,
     /* 1421650 */     GIR_EraseRootFromParent_Done,
     /* 1421651 */   // Label 20065: @1421651
     /* 1421651 */   GIM_Try, /*On fail goto*//*Label 20066*/ GIMT_Encode4(1421748), // Rule ID 3392 //
     /* 1421656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1421667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1421670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1421673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421706 */     // MIs[1] Operand 1
     /* 1421706 */     // No operand predicates
     /* 1421706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421710 */     // MIs[0] policy
     /* 1421710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421722 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1421725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421747 */     // GIR_Coverage, 3392,
     /* 1421747 */     GIR_EraseRootFromParent_Done,
     /* 1421748 */   // Label 20066: @1421748
     /* 1421748 */   GIM_Try, /*On fail goto*//*Label 20067*/ GIMT_Encode4(1421845), // Rule ID 3393 //
     /* 1421753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1421764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1421767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1421770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1421776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421803 */     // MIs[1] Operand 1
     /* 1421803 */     // No operand predicates
     /* 1421803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421807 */     // MIs[0] policy
     /* 1421807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421819 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1421819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1421822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1421841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421844 */     // GIR_Coverage, 3393,
     /* 1421844 */     GIR_EraseRootFromParent_Done,
     /* 1421845 */   // Label 20067: @1421845
     /* 1421845 */   GIM_Try, /*On fail goto*//*Label 20068*/ GIMT_Encode4(1421942), // Rule ID 3396 //
     /* 1421850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1421853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1421861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1421864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1421867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1421870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1421876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421900 */     // MIs[1] Operand 1
     /* 1421900 */     // No operand predicates
     /* 1421900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1421904 */     // MIs[0] policy
     /* 1421904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1421907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1421909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1421916 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1421916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1421919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1421921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1421923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1421925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1421928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1421930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1421935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1421938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1421940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1421941 */     // GIR_Coverage, 3396,
     /* 1421941 */     GIR_EraseRootFromParent_Done,
     /* 1421942 */   // Label 20068: @1421942
     /* 1421942 */   GIM_Try, /*On fail goto*//*Label 20069*/ GIMT_Encode4(1422039), // Rule ID 3397 //
     /* 1421947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1421950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1421955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1421958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1421961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1421964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1421967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1421970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1421973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1421977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1421985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1421989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1421993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1421997 */     // MIs[1] Operand 1
     /* 1421997 */     // No operand predicates
     /* 1421997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422001 */     // MIs[0] policy
     /* 1422001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422013 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF4_MASK),
     /* 1422016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422038 */     // GIR_Coverage, 3397,
     /* 1422038 */     GIR_EraseRootFromParent_Done,
     /* 1422039 */   // Label 20069: @1422039
     /* 1422039 */   GIM_Try, /*On fail goto*//*Label 20070*/ GIMT_Encode4(1422136), // Rule ID 3400 //
     /* 1422044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1422055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1422058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1422061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422094 */     // MIs[1] Operand 1
     /* 1422094 */     // No operand predicates
     /* 1422094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422098 */     // MIs[0] policy
     /* 1422098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422110 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1422113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422135 */     // GIR_Coverage, 3400,
     /* 1422135 */     GIR_EraseRootFromParent_Done,
     /* 1422136 */   // Label 20070: @1422136
     /* 1422136 */   GIM_Try, /*On fail goto*//*Label 20071*/ GIMT_Encode4(1422233), // Rule ID 3401 //
     /* 1422141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1422152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1422155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1422158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422191 */     // MIs[1] Operand 1
     /* 1422191 */     // No operand predicates
     /* 1422191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422195 */     // MIs[0] policy
     /* 1422195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422207 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1422210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422232 */     // GIR_Coverage, 3401,
     /* 1422232 */     GIR_EraseRootFromParent_Done,
     /* 1422233 */   // Label 20071: @1422233
     /* 1422233 */   GIM_Try, /*On fail goto*//*Label 20072*/ GIMT_Encode4(1422330), // Rule ID 3404 //
     /* 1422238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1422255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1422261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422288 */     // MIs[1] Operand 1
     /* 1422288 */     // No operand predicates
     /* 1422288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422292 */     // MIs[0] policy
     /* 1422292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422304 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1422307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422329 */     // GIR_Coverage, 3404,
     /* 1422329 */     GIR_EraseRootFromParent_Done,
     /* 1422330 */   // Label 20072: @1422330
     /* 1422330 */   GIM_Try, /*On fail goto*//*Label 20073*/ GIMT_Encode4(1422427), // Rule ID 3405 //
     /* 1422335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1422346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1422349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1422352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1422358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422385 */     // MIs[1] Operand 1
     /* 1422385 */     // No operand predicates
     /* 1422385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422389 */     // MIs[0] policy
     /* 1422389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422401 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_MF2_MASK),
     /* 1422404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422426 */     // GIR_Coverage, 3405,
     /* 1422426 */     GIR_EraseRootFromParent_Done,
     /* 1422427 */   // Label 20073: @1422427
     /* 1422427 */   GIM_Try, /*On fail goto*//*Label 20074*/ GIMT_Encode4(1422524), // Rule ID 3408 //
     /* 1422432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1422443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1422446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1422449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422482 */     // MIs[1] Operand 1
     /* 1422482 */     // No operand predicates
     /* 1422482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422486 */     // MIs[0] policy
     /* 1422486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422523 */     // GIR_Coverage, 3408,
     /* 1422523 */     GIR_EraseRootFromParent_Done,
     /* 1422524 */   // Label 20074: @1422524
     /* 1422524 */   GIM_Try, /*On fail goto*//*Label 20075*/ GIMT_Encode4(1422621), // Rule ID 3409 //
     /* 1422529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1422540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1422543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1422546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1422552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422579 */     // MIs[1] Operand 1
     /* 1422579 */     // No operand predicates
     /* 1422579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422583 */     // MIs[0] policy
     /* 1422583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422595 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1422617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422620 */     // GIR_Coverage, 3409,
     /* 1422620 */     GIR_EraseRootFromParent_Done,
     /* 1422621 */   // Label 20075: @1422621
     /* 1422621 */   GIM_Try, /*On fail goto*//*Label 20076*/ GIMT_Encode4(1422718), // Rule ID 3412 //
     /* 1422626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1422637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1422640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1422643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422676 */     // MIs[1] Operand 1
     /* 1422676 */     // No operand predicates
     /* 1422676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422680 */     // MIs[0] policy
     /* 1422680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422692 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422717 */     // GIR_Coverage, 3412,
     /* 1422717 */     GIR_EraseRootFromParent_Done,
     /* 1422718 */   // Label 20076: @1422718
     /* 1422718 */   GIM_Try, /*On fail goto*//*Label 20077*/ GIMT_Encode4(1422815), // Rule ID 3413 //
     /* 1422723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1422734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1422737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1422740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1422746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422773 */     // MIs[1] Operand 1
     /* 1422773 */     // No operand predicates
     /* 1422773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422777 */     // MIs[0] policy
     /* 1422777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1422811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422814 */     // GIR_Coverage, 3413,
     /* 1422814 */     GIR_EraseRootFromParent_Done,
     /* 1422815 */   // Label 20077: @1422815
     /* 1422815 */   GIM_Try, /*On fail goto*//*Label 20078*/ GIMT_Encode4(1422912), // Rule ID 3416 //
     /* 1422820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1422823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1422831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1422834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1422837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1422840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1422846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422870 */     // MIs[1] Operand 1
     /* 1422870 */     // No operand predicates
     /* 1422870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422874 */     // MIs[0] policy
     /* 1422874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1422886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1422905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1422908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1422910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422911 */     // GIR_Coverage, 3416,
     /* 1422911 */     GIR_EraseRootFromParent_Done,
     /* 1422912 */   // Label 20078: @1422912
     /* 1422912 */   GIM_Try, /*On fail goto*//*Label 20079*/ GIMT_Encode4(1423009), // Rule ID 3417 //
     /* 1422917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1422920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1422925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1422928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1422931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1422934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1422937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1422940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1422943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1422947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1422955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1422959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1422963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1422967 */     // MIs[1] Operand 1
     /* 1422967 */     // No operand predicates
     /* 1422967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1422971 */     // MIs[0] policy
     /* 1422971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1422974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1422976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1422983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1422983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1422986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1422988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1422990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1422992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1422995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1422997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1423005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423008 */     // GIR_Coverage, 3417,
     /* 1423008 */     GIR_EraseRootFromParent_Done,
     /* 1423009 */   // Label 20079: @1423009
     /* 1423009 */   GIM_Try, /*On fail goto*//*Label 20080*/ GIMT_Encode4(1423106), // Rule ID 3420 //
     /* 1423014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1423017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1423031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423064 */     // MIs[1] Operand 1
     /* 1423064 */     // No operand predicates
     /* 1423064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423068 */     // MIs[0] policy
     /* 1423068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423080 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1423083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423105 */     // GIR_Coverage, 3420,
     /* 1423105 */     GIR_EraseRootFromParent_Done,
     /* 1423106 */   // Label 20080: @1423106
     /* 1423106 */   GIM_Try, /*On fail goto*//*Label 20081*/ GIMT_Encode4(1423203), // Rule ID 3421 //
     /* 1423111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1423114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1423122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1423125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1423128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1423134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1423141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1423149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423161 */     // MIs[1] Operand 1
     /* 1423161 */     // No operand predicates
     /* 1423161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423165 */     // MIs[0] policy
     /* 1423165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423177 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M1_MASK),
     /* 1423180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1423199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423202 */     // GIR_Coverage, 3421,
     /* 1423202 */     GIR_EraseRootFromParent_Done,
     /* 1423203 */   // Label 20081: @1423203
     /* 1423203 */   GIM_Try, /*On fail goto*//*Label 20082*/ GIMT_Encode4(1423300), // Rule ID 3424 //
     /* 1423208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1423219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1423222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1423225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423258 */     // MIs[1] Operand 1
     /* 1423258 */     // No operand predicates
     /* 1423258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423262 */     // MIs[0] policy
     /* 1423262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423274 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1423277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423299 */     // GIR_Coverage, 3424,
     /* 1423299 */     GIR_EraseRootFromParent_Done,
     /* 1423300 */   // Label 20082: @1423300
     /* 1423300 */   GIM_Try, /*On fail goto*//*Label 20083*/ GIMT_Encode4(1423397), // Rule ID 3425 //
     /* 1423305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1423316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1423319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1423322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1423328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423355 */     // MIs[1] Operand 1
     /* 1423355 */     // No operand predicates
     /* 1423355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423359 */     // MIs[0] policy
     /* 1423359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423371 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1423374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423396 */     // GIR_Coverage, 3425,
     /* 1423396 */     GIR_EraseRootFromParent_Done,
     /* 1423397 */   // Label 20083: @1423397
     /* 1423397 */   GIM_Try, /*On fail goto*//*Label 20084*/ GIMT_Encode4(1423494), // Rule ID 3428 //
     /* 1423402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1423413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1423416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1423419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1423425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423452 */     // MIs[1] Operand 1
     /* 1423452 */     // No operand predicates
     /* 1423452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423456 */     // MIs[0] policy
     /* 1423456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423468 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1423471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423493 */     // GIR_Coverage, 3428,
     /* 1423493 */     GIR_EraseRootFromParent_Done,
     /* 1423494 */   // Label 20084: @1423494
     /* 1423494 */   GIM_Try, /*On fail goto*//*Label 20085*/ GIMT_Encode4(1423591), // Rule ID 3429 //
     /* 1423499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1423510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1423513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1423516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1423522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1423529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1423537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423549 */     // MIs[1] Operand 1
     /* 1423549 */     // No operand predicates
     /* 1423549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423553 */     // MIs[0] policy
     /* 1423553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423565 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1423568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423590 */     // GIR_Coverage, 3429,
     /* 1423590 */     GIR_EraseRootFromParent_Done,
     /* 1423591 */   // Label 20085: @1423591
     /* 1423591 */   GIM_Try, /*On fail goto*//*Label 20086*/ GIMT_Encode4(1423688), // Rule ID 3432 //
     /* 1423596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1423607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1423610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1423613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1423619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423646 */     // MIs[1] Operand 1
     /* 1423646 */     // No operand predicates
     /* 1423646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423650 */     // MIs[0] policy
     /* 1423650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1423665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423687 */     // GIR_Coverage, 3432,
     /* 1423687 */     GIR_EraseRootFromParent_Done,
     /* 1423688 */   // Label 20086: @1423688
     /* 1423688 */   GIM_Try, /*On fail goto*//*Label 20087*/ GIMT_Encode4(1423785), // Rule ID 3433 //
     /* 1423693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1423704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1423707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1423710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1423716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1423723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1423731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423743 */     // MIs[1] Operand 1
     /* 1423743 */     // No operand predicates
     /* 1423743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423747 */     // MIs[0] policy
     /* 1423747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423759 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1423762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1423781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423784 */     // GIR_Coverage, 3433,
     /* 1423784 */     GIR_EraseRootFromParent_Done,
     /* 1423785 */   // Label 20087: @1423785
     /* 1423785 */   GIM_Try, /*On fail goto*//*Label 20088*/ GIMT_Encode4(1423882), // Rule ID 3436 //
     /* 1423790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1423801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1423804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1423807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1423810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1423816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423840 */     // MIs[1] Operand 1
     /* 1423840 */     // No operand predicates
     /* 1423840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423844 */     // MIs[0] policy
     /* 1423844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1423856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1423859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423881 */     // GIR_Coverage, 3436,
     /* 1423881 */     GIR_EraseRootFromParent_Done,
     /* 1423882 */   // Label 20088: @1423882
     /* 1423882 */   GIM_Try, /*On fail goto*//*Label 20089*/ GIMT_Encode4(1423979), // Rule ID 3437 //
     /* 1423887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1423890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1423898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1423901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1423904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1423907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1423910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1423913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1423917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1423925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1423929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1423933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1423937 */     // MIs[1] Operand 1
     /* 1423937 */     // No operand predicates
     /* 1423937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1423941 */     // MIs[0] policy
     /* 1423941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1423944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1423946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1423953 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1423953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1423956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1423958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1423960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1423962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1423965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1423967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1423972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1423975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1423977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1423978 */     // GIR_Coverage, 3437,
     /* 1423978 */     GIR_EraseRootFromParent_Done,
     /* 1423979 */   // Label 20089: @1423979
     /* 1423979 */   GIM_Try, /*On fail goto*//*Label 20090*/ GIMT_Encode4(1424076), // Rule ID 3440 //
     /* 1423984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1423987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1423992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1423995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1423998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1424001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424034 */     // MIs[1] Operand 1
     /* 1424034 */     // No operand predicates
     /* 1424034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424038 */     // MIs[0] policy
     /* 1424038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1424053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424075 */     // GIR_Coverage, 3440,
     /* 1424075 */     GIR_EraseRootFromParent_Done,
     /* 1424076 */   // Label 20090: @1424076
     /* 1424076 */   GIM_Try, /*On fail goto*//*Label 20091*/ GIMT_Encode4(1424173), // Rule ID 3441 //
     /* 1424081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1424092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1424095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1424098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424131 */     // MIs[1] Operand 1
     /* 1424131 */     // No operand predicates
     /* 1424131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424135 */     // MIs[0] policy
     /* 1424135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424147 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1424150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424172 */     // GIR_Coverage, 3441,
     /* 1424172 */     GIR_EraseRootFromParent_Done,
     /* 1424173 */   // Label 20091: @1424173
     /* 1424173 */   GIM_Try, /*On fail goto*//*Label 20092*/ GIMT_Encode4(1424270), // Rule ID 3444 //
     /* 1424178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1424195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1424201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424228 */     // MIs[1] Operand 1
     /* 1424228 */     // No operand predicates
     /* 1424228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424232 */     // MIs[0] policy
     /* 1424232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424244 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1424247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424269 */     // GIR_Coverage, 3444,
     /* 1424269 */     GIR_EraseRootFromParent_Done,
     /* 1424270 */   // Label 20092: @1424270
     /* 1424270 */   GIM_Try, /*On fail goto*//*Label 20093*/ GIMT_Encode4(1424367), // Rule ID 3445 //
     /* 1424275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1424286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1424289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1424292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1424298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424325 */     // MIs[1] Operand 1
     /* 1424325 */     // No operand predicates
     /* 1424325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424329 */     // MIs[0] policy
     /* 1424329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424341 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1424344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1424363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424366 */     // GIR_Coverage, 3445,
     /* 1424366 */     GIR_EraseRootFromParent_Done,
     /* 1424367 */   // Label 20093: @1424367
     /* 1424367 */   GIM_Try, /*On fail goto*//*Label 20094*/ GIMT_Encode4(1424464), // Rule ID 3448 //
     /* 1424372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1424389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424422 */     // MIs[1] Operand 1
     /* 1424422 */     // No operand predicates
     /* 1424422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424426 */     // MIs[0] policy
     /* 1424426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1424441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424463 */     // GIR_Coverage, 3448,
     /* 1424463 */     GIR_EraseRootFromParent_Done,
     /* 1424464 */   // Label 20094: @1424464
     /* 1424464 */   GIM_Try, /*On fail goto*//*Label 20095*/ GIMT_Encode4(1424561), // Rule ID 3449 //
     /* 1424469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1424480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1424483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1424486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1424492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424519 */     // MIs[1] Operand 1
     /* 1424519 */     // No operand predicates
     /* 1424519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424523 */     // MIs[0] policy
     /* 1424523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424535 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1424538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424560 */     // GIR_Coverage, 3449,
     /* 1424560 */     GIR_EraseRootFromParent_Done,
     /* 1424561 */   // Label 20095: @1424561
     /* 1424561 */   GIM_Try, /*On fail goto*//*Label 20096*/ GIMT_Encode4(1424658), // Rule ID 3452 //
     /* 1424566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1424583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424616 */     // MIs[1] Operand 1
     /* 1424616 */     // No operand predicates
     /* 1424616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424620 */     // MIs[0] policy
     /* 1424620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1424635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424657 */     // GIR_Coverage, 3452,
     /* 1424657 */     GIR_EraseRootFromParent_Done,
     /* 1424658 */   // Label 20096: @1424658
     /* 1424658 */   GIM_Try, /*On fail goto*//*Label 20097*/ GIMT_Encode4(1424755), // Rule ID 3453 //
     /* 1424663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1424674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1424677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1424680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1424686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1424693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1424701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424713 */     // MIs[1] Operand 1
     /* 1424713 */     // No operand predicates
     /* 1424713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424717 */     // MIs[0] policy
     /* 1424717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424729 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1424732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424754 */     // GIR_Coverage, 3453,
     /* 1424754 */     GIR_EraseRootFromParent_Done,
     /* 1424755 */   // Label 20097: @1424755
     /* 1424755 */   GIM_Try, /*On fail goto*//*Label 20098*/ GIMT_Encode4(1424852), // Rule ID 3456 //
     /* 1424760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1424763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1424777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424810 */     // MIs[1] Operand 1
     /* 1424810 */     // No operand predicates
     /* 1424810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424814 */     // MIs[0] policy
     /* 1424814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1424826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1424829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424851 */     // GIR_Coverage, 3456,
     /* 1424851 */     GIR_EraseRootFromParent_Done,
     /* 1424852 */   // Label 20098: @1424852
     /* 1424852 */   GIM_Try, /*On fail goto*//*Label 20099*/ GIMT_Encode4(1424949), // Rule ID 3457 //
     /* 1424857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1424860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1424868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1424871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1424874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1424877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1424880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1424883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1424887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1424895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1424903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1424907 */     // MIs[1] Operand 1
     /* 1424907 */     // No operand predicates
     /* 1424907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1424911 */     // MIs[0] policy
     /* 1424911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1424914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1424916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1424923 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1424923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1424926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1424928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1424930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1424932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1424935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1424937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1424942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1424945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1424947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1424948 */     // GIR_Coverage, 3457,
     /* 1424948 */     GIR_EraseRootFromParent_Done,
     /* 1424949 */   // Label 20099: @1424949
     /* 1424949 */   GIM_Try, /*On fail goto*//*Label 20100*/ GIMT_Encode4(1425046), // Rule ID 3460 //
     /* 1424954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1424957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1424962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1424965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1424968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1424971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1424974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1424977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1424980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1424984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1424992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1424996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425004 */     // MIs[1] Operand 1
     /* 1425004 */     // No operand predicates
     /* 1425004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425008 */     // MIs[0] policy
     /* 1425008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425020 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1425023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425045 */     // GIR_Coverage, 3460,
     /* 1425045 */     GIR_EraseRootFromParent_Done,
     /* 1425046 */   // Label 20100: @1425046
     /* 1425046 */   GIM_Try, /*On fail goto*//*Label 20101*/ GIMT_Encode4(1425143), // Rule ID 3461 //
     /* 1425051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1425062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1425065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1425068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1425081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1425089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425101 */     // MIs[1] Operand 1
     /* 1425101 */     // No operand predicates
     /* 1425101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425105 */     // MIs[0] policy
     /* 1425105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425117 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M2_MASK),
     /* 1425120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425142 */     // GIR_Coverage, 3461,
     /* 1425142 */     GIR_EraseRootFromParent_Done,
     /* 1425143 */   // Label 20101: @1425143
     /* 1425143 */   GIM_Try, /*On fail goto*//*Label 20102*/ GIMT_Encode4(1425240), // Rule ID 3464 //
     /* 1425148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1425165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425198 */     // MIs[1] Operand 1
     /* 1425198 */     // No operand predicates
     /* 1425198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425202 */     // MIs[0] policy
     /* 1425202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425214 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1425217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425239 */     // GIR_Coverage, 3464,
     /* 1425239 */     GIR_EraseRootFromParent_Done,
     /* 1425240 */   // Label 20102: @1425240
     /* 1425240 */   GIM_Try, /*On fail goto*//*Label 20103*/ GIMT_Encode4(1425337), // Rule ID 3465 //
     /* 1425245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1425256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1425259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1425262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1425275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1425283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425295 */     // MIs[1] Operand 1
     /* 1425295 */     // No operand predicates
     /* 1425295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425299 */     // MIs[0] policy
     /* 1425299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425311 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M4_MASK),
     /* 1425314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425336 */     // GIR_Coverage, 3465,
     /* 1425336 */     GIR_EraseRootFromParent_Done,
     /* 1425337 */   // Label 20103: @1425337
     /* 1425337 */   GIM_Try, /*On fail goto*//*Label 20104*/ GIMT_Encode4(1425434), // Rule ID 3468 //
     /* 1425342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1425345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1425359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425392 */     // MIs[1] Operand 1
     /* 1425392 */     // No operand predicates
     /* 1425392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425396 */     // MIs[0] policy
     /* 1425396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425408 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1425411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425433 */     // GIR_Coverage, 3468,
     /* 1425433 */     GIR_EraseRootFromParent_Done,
     /* 1425434 */   // Label 20104: @1425434
     /* 1425434 */   GIM_Try, /*On fail goto*//*Label 20105*/ GIMT_Encode4(1425531), // Rule ID 3469 //
     /* 1425439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1425442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1425447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1425450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1425453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1425456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1425462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1425469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1425477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425489 */     // MIs[1] Operand 1
     /* 1425489 */     // No operand predicates
     /* 1425489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425493 */     // MIs[0] policy
     /* 1425493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425505 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VI_M8_MASK),
     /* 1425508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1425527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425530 */     // GIR_Coverage, 3469,
     /* 1425530 */     GIR_EraseRootFromParent_Done,
     /* 1425531 */   // Label 20105: @1425531
     /* 1425531 */   GIM_Try, /*On fail goto*//*Label 20106*/ GIMT_Encode4(1425628), // Rule ID 5832 //
     /* 1425536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1425544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1425547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1425550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1425553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425586 */     // MIs[1] Operand 1
     /* 1425586 */     // No operand predicates
     /* 1425586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425590 */     // MIs[0] policy
     /* 1425590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1425605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425627 */     // GIR_Coverage, 5832,
     /* 1425627 */     GIR_EraseRootFromParent_Done,
     /* 1425628 */   // Label 20106: @1425628
     /* 1425628 */   GIM_Try, /*On fail goto*//*Label 20107*/ GIMT_Encode4(1425725), // Rule ID 5833 //
     /* 1425633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1425641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1425644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1425647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1425650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1425656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425683 */     // MIs[1] Operand 1
     /* 1425683 */     // No operand predicates
     /* 1425683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425687 */     // MIs[0] policy
     /* 1425687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425699 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF8_MASK),
     /* 1425702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425724 */     // GIR_Coverage, 5833,
     /* 1425724 */     GIR_EraseRootFromParent_Done,
     /* 1425725 */   // Label 20107: @1425725
     /* 1425725 */   GIM_Try, /*On fail goto*//*Label 20108*/ GIMT_Encode4(1425822), // Rule ID 5836 //
     /* 1425730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1425738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1425741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1425744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1425747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425780 */     // MIs[1] Operand 1
     /* 1425780 */     // No operand predicates
     /* 1425780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425784 */     // MIs[0] policy
     /* 1425784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425796 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1425799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425821 */     // GIR_Coverage, 5836,
     /* 1425821 */     GIR_EraseRootFromParent_Done,
     /* 1425822 */   // Label 20108: @1425822
     /* 1425822 */   GIM_Try, /*On fail goto*//*Label 20109*/ GIMT_Encode4(1425919), // Rule ID 5837 //
     /* 1425827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1425830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1425835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1425838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1425841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1425844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1425847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1425850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1425853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425877 */     // MIs[1] Operand 1
     /* 1425877 */     // No operand predicates
     /* 1425877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425881 */     // MIs[0] policy
     /* 1425881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425893 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1425893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1425896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1425905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1425907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1425912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1425915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1425917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1425918 */     // GIR_Coverage, 5837,
     /* 1425918 */     GIR_EraseRootFromParent_Done,
     /* 1425919 */   // Label 20109: @1425919
     /* 1425919 */   GIM_Try, /*On fail goto*//*Label 20110*/ GIMT_Encode4(1426016), // Rule ID 5840 //
     /* 1425924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1425927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1425932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1425935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1425938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1425941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1425944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1425947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1425950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1425954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1425962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1425966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1425970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1425974 */     // MIs[1] Operand 1
     /* 1425974 */     // No operand predicates
     /* 1425974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1425978 */     // MIs[0] policy
     /* 1425978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1425981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1425983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1425990 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1425990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1425993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1425995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1425997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1425999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426015 */     // GIR_Coverage, 5840,
     /* 1426015 */     GIR_EraseRootFromParent_Done,
     /* 1426016 */   // Label 20110: @1426016
     /* 1426016 */   GIM_Try, /*On fail goto*//*Label 20111*/ GIMT_Encode4(1426113), // Rule ID 5841 //
     /* 1426021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1426032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1426035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1426038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426071 */     // MIs[1] Operand 1
     /* 1426071 */     // No operand predicates
     /* 1426071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426075 */     // MIs[0] policy
     /* 1426075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426087 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1426090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426112 */     // GIR_Coverage, 5841,
     /* 1426112 */     GIR_EraseRootFromParent_Done,
     /* 1426113 */   // Label 20111: @1426113
     /* 1426113 */   GIM_Try, /*On fail goto*//*Label 20112*/ GIMT_Encode4(1426210), // Rule ID 5844 //
     /* 1426118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1426129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1426132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1426135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426168 */     // MIs[1] Operand 1
     /* 1426168 */     // No operand predicates
     /* 1426168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426172 */     // MIs[0] policy
     /* 1426172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426184 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1426187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426209 */     // GIR_Coverage, 5844,
     /* 1426209 */     GIR_EraseRootFromParent_Done,
     /* 1426210 */   // Label 20112: @1426210
     /* 1426210 */   GIM_Try, /*On fail goto*//*Label 20113*/ GIMT_Encode4(1426307), // Rule ID 5845 //
     /* 1426215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1426226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1426229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1426232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426265 */     // MIs[1] Operand 1
     /* 1426265 */     // No operand predicates
     /* 1426265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426269 */     // MIs[0] policy
     /* 1426269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426281 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF4_MASK),
     /* 1426284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426306 */     // GIR_Coverage, 5845,
     /* 1426306 */     GIR_EraseRootFromParent_Done,
     /* 1426307 */   // Label 20113: @1426307
     /* 1426307 */   GIM_Try, /*On fail goto*//*Label 20114*/ GIMT_Encode4(1426404), // Rule ID 5848 //
     /* 1426312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1426323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1426326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1426329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426362 */     // MIs[1] Operand 1
     /* 1426362 */     // No operand predicates
     /* 1426362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426366 */     // MIs[0] policy
     /* 1426366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426378 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1426381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426403 */     // GIR_Coverage, 5848,
     /* 1426403 */     GIR_EraseRootFromParent_Done,
     /* 1426404 */   // Label 20114: @1426404
     /* 1426404 */   GIM_Try, /*On fail goto*//*Label 20115*/ GIMT_Encode4(1426501), // Rule ID 5849 //
     /* 1426409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1426420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1426423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1426426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1426432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426459 */     // MIs[1] Operand 1
     /* 1426459 */     // No operand predicates
     /* 1426459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426463 */     // MIs[0] policy
     /* 1426463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426475 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1426478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426500 */     // GIR_Coverage, 5849,
     /* 1426500 */     GIR_EraseRootFromParent_Done,
     /* 1426501 */   // Label 20115: @1426501
     /* 1426501 */   GIM_Try, /*On fail goto*//*Label 20116*/ GIMT_Encode4(1426598), // Rule ID 5852 //
     /* 1426506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1426517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1426520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1426523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426556 */     // MIs[1] Operand 1
     /* 1426556 */     // No operand predicates
     /* 1426556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426560 */     // MIs[0] policy
     /* 1426560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426572 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1426575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426597 */     // GIR_Coverage, 5852,
     /* 1426597 */     GIR_EraseRootFromParent_Done,
     /* 1426598 */   // Label 20116: @1426598
     /* 1426598 */   GIM_Try, /*On fail goto*//*Label 20117*/ GIMT_Encode4(1426695), // Rule ID 5853 //
     /* 1426603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1426614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1426617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1426620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1426626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426653 */     // MIs[1] Operand 1
     /* 1426653 */     // No operand predicates
     /* 1426653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426657 */     // MIs[0] policy
     /* 1426657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426669 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_MF2_MASK),
     /* 1426672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1426691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426694 */     // GIR_Coverage, 5853,
     /* 1426694 */     GIR_EraseRootFromParent_Done,
     /* 1426695 */   // Label 20117: @1426695
     /* 1426695 */   GIM_Try, /*On fail goto*//*Label 20118*/ GIMT_Encode4(1426792), // Rule ID 5856 //
     /* 1426700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1426711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1426714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1426717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426750 */     // MIs[1] Operand 1
     /* 1426750 */     // No operand predicates
     /* 1426750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426754 */     // MIs[0] policy
     /* 1426754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1426769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426791 */     // GIR_Coverage, 5856,
     /* 1426791 */     GIR_EraseRootFromParent_Done,
     /* 1426792 */   // Label 20118: @1426792
     /* 1426792 */   GIM_Try, /*On fail goto*//*Label 20119*/ GIMT_Encode4(1426889), // Rule ID 5857 //
     /* 1426797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1426808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1426811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1426814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1426817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1426820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1426823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426847 */     // MIs[1] Operand 1
     /* 1426847 */     // No operand predicates
     /* 1426847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426851 */     // MIs[0] policy
     /* 1426851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426863 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1426863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1426866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1426885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426888 */     // GIR_Coverage, 5857,
     /* 1426888 */     GIR_EraseRootFromParent_Done,
     /* 1426889 */   // Label 20119: @1426889
     /* 1426889 */   GIM_Try, /*On fail goto*//*Label 20120*/ GIMT_Encode4(1426986), // Rule ID 5860 //
     /* 1426894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1426897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1426905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1426908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1426911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1426914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1426917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1426920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1426924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1426932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1426936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1426940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1426944 */     // MIs[1] Operand 1
     /* 1426944 */     // No operand predicates
     /* 1426944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1426948 */     // MIs[0] policy
     /* 1426948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1426951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1426953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1426960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1426960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1426963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1426965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1426967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1426969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1426972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1426974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1426979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1426982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1426984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1426985 */     // GIR_Coverage, 5860,
     /* 1426985 */     GIR_EraseRootFromParent_Done,
     /* 1426986 */   // Label 20120: @1426986
     /* 1426986 */   GIM_Try, /*On fail goto*//*Label 20121*/ GIMT_Encode4(1427083), // Rule ID 5861 //
     /* 1426991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1426994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1426999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1427002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1427005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1427008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1427014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427041 */     // MIs[1] Operand 1
     /* 1427041 */     // No operand predicates
     /* 1427041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427045 */     // MIs[0] policy
     /* 1427045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427057 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1427060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1427079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427082 */     // GIR_Coverage, 5861,
     /* 1427082 */     GIR_EraseRootFromParent_Done,
     /* 1427083 */   // Label 20121: @1427083
     /* 1427083 */   GIM_Try, /*On fail goto*//*Label 20122*/ GIMT_Encode4(1427180), // Rule ID 5864 //
     /* 1427088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1427099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1427102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1427105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427138 */     // MIs[1] Operand 1
     /* 1427138 */     // No operand predicates
     /* 1427138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427142 */     // MIs[0] policy
     /* 1427142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427154 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1427157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427179 */     // GIR_Coverage, 5864,
     /* 1427179 */     GIR_EraseRootFromParent_Done,
     /* 1427180 */   // Label 20122: @1427180
     /* 1427180 */   GIM_Try, /*On fail goto*//*Label 20123*/ GIMT_Encode4(1427277), // Rule ID 5865 //
     /* 1427185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1427196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1427199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1427202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1427208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427235 */     // MIs[1] Operand 1
     /* 1427235 */     // No operand predicates
     /* 1427235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427239 */     // MIs[0] policy
     /* 1427239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427251 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1427254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1427273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427276 */     // GIR_Coverage, 5865,
     /* 1427276 */     GIR_EraseRootFromParent_Done,
     /* 1427277 */   // Label 20123: @1427277
     /* 1427277 */   GIM_Try, /*On fail goto*//*Label 20124*/ GIMT_Encode4(1427374), // Rule ID 5868 //
     /* 1427282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1427285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1427293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1427296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1427299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427332 */     // MIs[1] Operand 1
     /* 1427332 */     // No operand predicates
     /* 1427332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427336 */     // MIs[0] policy
     /* 1427336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427348 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1427351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427373 */     // GIR_Coverage, 5868,
     /* 1427373 */     GIR_EraseRootFromParent_Done,
     /* 1427374 */   // Label 20124: @1427374
     /* 1427374 */   GIM_Try, /*On fail goto*//*Label 20125*/ GIMT_Encode4(1427471), // Rule ID 5869 //
     /* 1427379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1427382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1427390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1427393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1427396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1427402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1427409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1427417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427429 */     // MIs[1] Operand 1
     /* 1427429 */     // No operand predicates
     /* 1427429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427433 */     // MIs[0] policy
     /* 1427433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427445 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M1_MASK),
     /* 1427448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1427467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427470 */     // GIR_Coverage, 5869,
     /* 1427470 */     GIR_EraseRootFromParent_Done,
     /* 1427471 */   // Label 20125: @1427471
     /* 1427471 */   GIM_Try, /*On fail goto*//*Label 20126*/ GIMT_Encode4(1427568), // Rule ID 5872 //
     /* 1427476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1427487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1427490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1427493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427526 */     // MIs[1] Operand 1
     /* 1427526 */     // No operand predicates
     /* 1427526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427530 */     // MIs[0] policy
     /* 1427530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1427545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427564 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427566 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427567 */     // GIR_Coverage, 5872,
     /* 1427567 */     GIR_EraseRootFromParent_Done,
     /* 1427568 */   // Label 20126: @1427568
     /* 1427568 */   GIM_Try, /*On fail goto*//*Label 20127*/ GIMT_Encode4(1427665), // Rule ID 5873 //
     /* 1427573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1427584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1427587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1427590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1427596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1427603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1427611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427623 */     // MIs[1] Operand 1
     /* 1427623 */     // No operand predicates
     /* 1427623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427627 */     // MIs[0] policy
     /* 1427627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1427642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427664 */     // GIR_Coverage, 5873,
     /* 1427664 */     GIR_EraseRootFromParent_Done,
     /* 1427665 */   // Label 20127: @1427665
     /* 1427665 */   GIM_Try, /*On fail goto*//*Label 20128*/ GIMT_Encode4(1427762), // Rule ID 5876 //
     /* 1427670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1427681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1427684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1427687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427716 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427720 */     // MIs[1] Operand 1
     /* 1427720 */     // No operand predicates
     /* 1427720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427724 */     // MIs[0] policy
     /* 1427724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427736 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1427739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427758 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427761 */     // GIR_Coverage, 5876,
     /* 1427761 */     GIR_EraseRootFromParent_Done,
     /* 1427762 */   // Label 20128: @1427762
     /* 1427762 */   GIM_Try, /*On fail goto*//*Label 20129*/ GIMT_Encode4(1427859), // Rule ID 5877 //
     /* 1427767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1427778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1427781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1427784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1427790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1427797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1427805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427817 */     // MIs[1] Operand 1
     /* 1427817 */     // No operand predicates
     /* 1427817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427821 */     // MIs[0] policy
     /* 1427821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427833 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1427833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1427836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427858 */     // GIR_Coverage, 5877,
     /* 1427858 */     GIR_EraseRootFromParent_Done,
     /* 1427859 */   // Label 20129: @1427859
     /* 1427859 */   GIM_Try, /*On fail goto*//*Label 20130*/ GIMT_Encode4(1427956), // Rule ID 5880 //
     /* 1427864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1427867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1427875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1427878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1427881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1427884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1427887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1427890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1427906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1427910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1427914 */     // MIs[1] Operand 1
     /* 1427914 */     // No operand predicates
     /* 1427914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1427918 */     // MIs[0] policy
     /* 1427918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1427921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1427923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1427930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1427930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1427933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1427935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1427937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1427939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1427942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1427944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1427949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1427952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1427954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1427955 */     // GIR_Coverage, 5880,
     /* 1427955 */     GIR_EraseRootFromParent_Done,
     /* 1427956 */   // Label 20130: @1427956
     /* 1427956 */   GIM_Try, /*On fail goto*//*Label 20131*/ GIMT_Encode4(1428053), // Rule ID 5881 //
     /* 1427961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1427964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1427969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1427972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1427975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1427978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1427981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1427984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1427987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1427991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1427999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428011 */     // MIs[1] Operand 1
     /* 1428011 */     // No operand predicates
     /* 1428011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428015 */     // MIs[0] policy
     /* 1428015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428027 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1428030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1428049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428052 */     // GIR_Coverage, 5881,
     /* 1428052 */     GIR_EraseRootFromParent_Done,
     /* 1428053 */   // Label 20131: @1428053
     /* 1428053 */   GIM_Try, /*On fail goto*//*Label 20132*/ GIMT_Encode4(1428150), // Rule ID 5884 //
     /* 1428058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1428069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1428072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1428075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428104 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428108 */     // MIs[1] Operand 1
     /* 1428108 */     // No operand predicates
     /* 1428108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428112 */     // MIs[0] policy
     /* 1428112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428115 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428124 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1428127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428146 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428149 */     // GIR_Coverage, 5884,
     /* 1428149 */     GIR_EraseRootFromParent_Done,
     /* 1428150 */   // Label 20132: @1428150
     /* 1428150 */   GIM_Try, /*On fail goto*//*Label 20133*/ GIMT_Encode4(1428247), // Rule ID 5885 //
     /* 1428155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1428166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1428169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1428172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428205 */     // MIs[1] Operand 1
     /* 1428205 */     // No operand predicates
     /* 1428205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428209 */     // MIs[0] policy
     /* 1428209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428221 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1428224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428246 */     // GIR_Coverage, 5885,
     /* 1428246 */     GIR_EraseRootFromParent_Done,
     /* 1428247 */   // Label 20133: @1428247
     /* 1428247 */   GIM_Try, /*On fail goto*//*Label 20134*/ GIMT_Encode4(1428344), // Rule ID 5888 //
     /* 1428252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1428263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1428266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1428269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1428275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428302 */     // MIs[1] Operand 1
     /* 1428302 */     // No operand predicates
     /* 1428302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428306 */     // MIs[0] policy
     /* 1428306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428318 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1428321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428340 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428343 */     // GIR_Coverage, 5888,
     /* 1428343 */     GIR_EraseRootFromParent_Done,
     /* 1428344 */   // Label 20134: @1428344
     /* 1428344 */   GIM_Try, /*On fail goto*//*Label 20135*/ GIMT_Encode4(1428441), // Rule ID 5889 //
     /* 1428349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1428360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1428363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1428366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1428372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428399 */     // MIs[1] Operand 1
     /* 1428399 */     // No operand predicates
     /* 1428399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428403 */     // MIs[0] policy
     /* 1428403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428415 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1428418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428440 */     // GIR_Coverage, 5889,
     /* 1428440 */     GIR_EraseRootFromParent_Done,
     /* 1428441 */   // Label 20135: @1428441
     /* 1428441 */   GIM_Try, /*On fail goto*//*Label 20136*/ GIMT_Encode4(1428538), // Rule ID 5892 //
     /* 1428446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1428457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1428460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1428463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1428469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428492 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428496 */     // MIs[1] Operand 1
     /* 1428496 */     // No operand predicates
     /* 1428496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428500 */     // MIs[0] policy
     /* 1428500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428512 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1428515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428534 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428537 */     // GIR_Coverage, 5892,
     /* 1428537 */     GIR_EraseRootFromParent_Done,
     /* 1428538 */   // Label 20136: @1428538
     /* 1428538 */   GIM_Try, /*On fail goto*//*Label 20137*/ GIMT_Encode4(1428635), // Rule ID 5893 //
     /* 1428543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1428554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1428557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1428560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1428566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1428573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1428581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428589 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428593 */     // MIs[1] Operand 1
     /* 1428593 */     // No operand predicates
     /* 1428593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428597 */     // MIs[0] policy
     /* 1428597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428609 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1428612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1428631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428634 */     // GIR_Coverage, 5893,
     /* 1428634 */     GIR_EraseRootFromParent_Done,
     /* 1428635 */   // Label 20137: @1428635
     /* 1428635 */   GIM_Try, /*On fail goto*//*Label 20138*/ GIMT_Encode4(1428732), // Rule ID 5896 //
     /* 1428640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1428651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1428654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1428657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428690 */     // MIs[1] Operand 1
     /* 1428690 */     // No operand predicates
     /* 1428690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428694 */     // MIs[0] policy
     /* 1428694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428706 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1428709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428728 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428731 */     // GIR_Coverage, 5896,
     /* 1428731 */     GIR_EraseRootFromParent_Done,
     /* 1428732 */   // Label 20138: @1428732
     /* 1428732 */   GIM_Try, /*On fail goto*//*Label 20139*/ GIMT_Encode4(1428829), // Rule ID 5897 //
     /* 1428737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1428748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1428751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1428754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1428760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1428767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1428775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428787 */     // MIs[1] Operand 1
     /* 1428787 */     // No operand predicates
     /* 1428787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428791 */     // MIs[0] policy
     /* 1428791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428803 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1428806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428828 */     // GIR_Coverage, 5897,
     /* 1428828 */     GIR_EraseRootFromParent_Done,
     /* 1428829 */   // Label 20139: @1428829
     /* 1428829 */   GIM_Try, /*On fail goto*//*Label 20140*/ GIMT_Encode4(1428926), // Rule ID 5900 //
     /* 1428834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1428837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1428845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1428848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1428851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1428854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1428860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428884 */     // MIs[1] Operand 1
     /* 1428884 */     // No operand predicates
     /* 1428884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428888 */     // MIs[0] policy
     /* 1428888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428900 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1428900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1428903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1428905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1428907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1428909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1428912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1428914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1428919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1428922 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1428924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1428925 */     // GIR_Coverage, 5900,
     /* 1428925 */     GIR_EraseRootFromParent_Done,
     /* 1428926 */   // Label 20140: @1428926
     /* 1428926 */   GIM_Try, /*On fail goto*//*Label 20141*/ GIMT_Encode4(1429023), // Rule ID 5901 //
     /* 1428931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1428934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1428939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1428942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1428945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1428948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1428951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1428954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1428957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1428961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1428969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1428973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1428977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1428981 */     // MIs[1] Operand 1
     /* 1428981 */     // No operand predicates
     /* 1428981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1428985 */     // MIs[0] policy
     /* 1428985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1428988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1428990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1428997 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1428997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1429000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429022 */     // GIR_Coverage, 5901,
     /* 1429022 */     GIR_EraseRootFromParent_Done,
     /* 1429023 */   // Label 20141: @1429023
     /* 1429023 */   GIM_Try, /*On fail goto*//*Label 20142*/ GIMT_Encode4(1429120), // Rule ID 5904 //
     /* 1429028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1429045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429078 */     // MIs[1] Operand 1
     /* 1429078 */     // No operand predicates
     /* 1429078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429082 */     // MIs[0] policy
     /* 1429082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429094 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1429097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429116 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429118 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429119 */     // GIR_Coverage, 5904,
     /* 1429119 */     GIR_EraseRootFromParent_Done,
     /* 1429120 */   // Label 20142: @1429120
     /* 1429120 */   GIM_Try, /*On fail goto*//*Label 20143*/ GIMT_Encode4(1429217), // Rule ID 5905 //
     /* 1429125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1429136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1429139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1429142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1429148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429175 */     // MIs[1] Operand 1
     /* 1429175 */     // No operand predicates
     /* 1429175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429179 */     // MIs[0] policy
     /* 1429179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429191 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1429194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1429213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429216 */     // GIR_Coverage, 5905,
     /* 1429216 */     GIR_EraseRootFromParent_Done,
     /* 1429217 */   // Label 20143: @1429217
     /* 1429217 */   GIM_Try, /*On fail goto*//*Label 20144*/ GIMT_Encode4(1429314), // Rule ID 5908 //
     /* 1429222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1429233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1429236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1429239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429268 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429272 */     // MIs[1] Operand 1
     /* 1429272 */     // No operand predicates
     /* 1429272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429276 */     // MIs[0] policy
     /* 1429276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429288 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1429291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429312 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429313 */     // GIR_Coverage, 5908,
     /* 1429313 */     GIR_EraseRootFromParent_Done,
     /* 1429314 */   // Label 20144: @1429314
     /* 1429314 */   GIM_Try, /*On fail goto*//*Label 20145*/ GIMT_Encode4(1429411), // Rule ID 5909 //
     /* 1429319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1429330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1429333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1429336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1429342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1429349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1429357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429365 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429369 */     // MIs[1] Operand 1
     /* 1429369 */     // No operand predicates
     /* 1429369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429373 */     // MIs[0] policy
     /* 1429373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M2_MASK),
     /* 1429388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429394 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429410 */     // GIR_Coverage, 5909,
     /* 1429410 */     GIR_EraseRootFromParent_Done,
     /* 1429411 */   // Label 20145: @1429411
     /* 1429411 */   GIM_Try, /*On fail goto*//*Label 20146*/ GIMT_Encode4(1429508), // Rule ID 5912 //
     /* 1429416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1429427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1429430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1429433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429462 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429466 */     // MIs[1] Operand 1
     /* 1429466 */     // No operand predicates
     /* 1429466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429470 */     // MIs[0] policy
     /* 1429470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429482 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1429485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429506 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429507 */     // GIR_Coverage, 5912,
     /* 1429507 */     GIR_EraseRootFromParent_Done,
     /* 1429508 */   // Label 20146: @1429508
     /* 1429508 */   GIM_Try, /*On fail goto*//*Label 20147*/ GIMT_Encode4(1429605), // Rule ID 5913 //
     /* 1429513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1429524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1429527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1429530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1429536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1429543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1429551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429563 */     // MIs[1] Operand 1
     /* 1429563 */     // No operand predicates
     /* 1429563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429567 */     // MIs[0] policy
     /* 1429567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429579 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M4_MASK),
     /* 1429582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429604 */     // GIR_Coverage, 5913,
     /* 1429604 */     GIR_EraseRootFromParent_Done,
     /* 1429605 */   // Label 20147: @1429605
     /* 1429605 */   GIM_Try, /*On fail goto*//*Label 20148*/ GIMT_Encode4(1429702), // Rule ID 5916 //
     /* 1429610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1429613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1429621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1429624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1429627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429660 */     // MIs[1] Operand 1
     /* 1429660 */     // No operand predicates
     /* 1429660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429664 */     // MIs[0] policy
     /* 1429664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429676 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1429679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429685 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429700 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429701 */     // GIR_Coverage, 5916,
     /* 1429701 */     GIR_EraseRootFromParent_Done,
     /* 1429702 */   // Label 20148: @1429702
     /* 1429702 */   GIM_Try, /*On fail goto*//*Label 20149*/ GIMT_Encode4(1429799), // Rule ID 5917 //
     /* 1429707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1429710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1429715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1429718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1429721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1429724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1429730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1429737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1429745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429753 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429757 */     // MIs[1] Operand 1
     /* 1429757 */     // No operand predicates
     /* 1429757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429761 */     // MIs[0] policy
     /* 1429761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429773 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VI_M8_MASK),
     /* 1429776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1429795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429798 */     // GIR_Coverage, 5917,
     /* 1429798 */     GIR_EraseRootFromParent_Done,
     /* 1429799 */   // Label 20149: @1429799
     /* 1429799 */   GIM_Try, /*On fail goto*//*Label 20150*/ GIMT_Encode4(1429896), // Rule ID 6096 //
     /* 1429804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1429807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1429812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1429815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1429818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1429821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1429824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1429830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429854 */     // MIs[1] Operand 1
     /* 1429854 */     // No operand predicates
     /* 1429854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429858 */     // MIs[0] policy
     /* 1429858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429870 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1429870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1429873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429894 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429895 */     // GIR_Coverage, 6096,
     /* 1429895 */     GIR_EraseRootFromParent_Done,
     /* 1429896 */   // Label 20150: @1429896
     /* 1429896 */   GIM_Try, /*On fail goto*//*Label 20151*/ GIMT_Encode4(1429993), // Rule ID 6097 //
     /* 1429901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1429904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1429909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1429912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1429915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1429918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1429921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1429924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1429927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1429931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1429939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1429943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1429947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1429951 */     // MIs[1] Operand 1
     /* 1429951 */     // No operand predicates
     /* 1429951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1429955 */     // MIs[0] policy
     /* 1429955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1429958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1429960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1429967 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1429967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF8_MASK),
     /* 1429970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1429972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1429974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1429976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1429979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1429981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1429986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1429989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1429991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1429992 */     // GIR_Coverage, 6097,
     /* 1429992 */     GIR_EraseRootFromParent_Done,
     /* 1429993 */   // Label 20151: @1429993
     /* 1429993 */   GIM_Try, /*On fail goto*//*Label 20152*/ GIMT_Encode4(1430090), // Rule ID 6100 //
     /* 1429998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1430009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1430012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1430015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430044 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430048 */     // MIs[1] Operand 1
     /* 1430048 */     // No operand predicates
     /* 1430048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430052 */     // MIs[0] policy
     /* 1430052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1430067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430088 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430089 */     // GIR_Coverage, 6100,
     /* 1430089 */     GIR_EraseRootFromParent_Done,
     /* 1430090 */   // Label 20152: @1430090
     /* 1430090 */   GIM_Try, /*On fail goto*//*Label 20153*/ GIMT_Encode4(1430187), // Rule ID 6101 //
     /* 1430095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1430106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1430109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1430112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430145 */     // MIs[1] Operand 1
     /* 1430145 */     // No operand predicates
     /* 1430145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430149 */     // MIs[0] policy
     /* 1430149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430161 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1430164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430186 */     // GIR_Coverage, 6101,
     /* 1430186 */     GIR_EraseRootFromParent_Done,
     /* 1430187 */   // Label 20153: @1430187
     /* 1430187 */   GIM_Try, /*On fail goto*//*Label 20154*/ GIMT_Encode4(1430284), // Rule ID 6104 //
     /* 1430192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1430203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1430206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1430209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430238 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430242 */     // MIs[1] Operand 1
     /* 1430242 */     // No operand predicates
     /* 1430242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430246 */     // MIs[0] policy
     /* 1430246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430258 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430282 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430283 */     // GIR_Coverage, 6104,
     /* 1430283 */     GIR_EraseRootFromParent_Done,
     /* 1430284 */   // Label 20154: @1430284
     /* 1430284 */   GIM_Try, /*On fail goto*//*Label 20155*/ GIMT_Encode4(1430381), // Rule ID 6105 //
     /* 1430289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1430300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1430303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1430306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1430312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430339 */     // MIs[1] Operand 1
     /* 1430339 */     // No operand predicates
     /* 1430339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430343 */     // MIs[0] policy
     /* 1430343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430355 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430360 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1430377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430380 */     // GIR_Coverage, 6105,
     /* 1430380 */     GIR_EraseRootFromParent_Done,
     /* 1430381 */   // Label 20155: @1430381
     /* 1430381 */   GIM_Try, /*On fail goto*//*Label 20156*/ GIMT_Encode4(1430478), // Rule ID 6108 //
     /* 1430386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430432 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430436 */     // MIs[1] Operand 1
     /* 1430436 */     // No operand predicates
     /* 1430436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430440 */     // MIs[0] policy
     /* 1430440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430452 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1430455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430476 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430477 */     // GIR_Coverage, 6108,
     /* 1430477 */     GIR_EraseRootFromParent_Done,
     /* 1430478 */   // Label 20156: @1430478
     /* 1430478 */   GIM_Try, /*On fail goto*//*Label 20157*/ GIMT_Encode4(1430575), // Rule ID 6109 //
     /* 1430483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1430494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1430497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1430500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430529 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430533 */     // MIs[1] Operand 1
     /* 1430533 */     // No operand predicates
     /* 1430533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430537 */     // MIs[0] policy
     /* 1430537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430549 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF4_MASK),
     /* 1430552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430574 */     // GIR_Coverage, 6109,
     /* 1430574 */     GIR_EraseRootFromParent_Done,
     /* 1430575 */   // Label 20157: @1430575
     /* 1430575 */   GIM_Try, /*On fail goto*//*Label 20158*/ GIMT_Encode4(1430672), // Rule ID 6112 //
     /* 1430580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430630 */     // MIs[1] Operand 1
     /* 1430630 */     // No operand predicates
     /* 1430630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430634 */     // MIs[0] policy
     /* 1430634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430668 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430670 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430671 */     // GIR_Coverage, 6112,
     /* 1430671 */     GIR_EraseRootFromParent_Done,
     /* 1430672 */   // Label 20158: @1430672
     /* 1430672 */   GIM_Try, /*On fail goto*//*Label 20159*/ GIMT_Encode4(1430769), // Rule ID 6113 //
     /* 1430677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1430688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1430691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1430694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1430700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430727 */     // MIs[1] Operand 1
     /* 1430727 */     // No operand predicates
     /* 1430727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430731 */     // MIs[0] policy
     /* 1430731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430743 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1430765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430768 */     // GIR_Coverage, 6113,
     /* 1430768 */     GIR_EraseRootFromParent_Done,
     /* 1430769 */   // Label 20159: @1430769
     /* 1430769 */   GIM_Try, /*On fail goto*//*Label 20160*/ GIMT_Encode4(1430866), // Rule ID 6116 //
     /* 1430774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430820 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430824 */     // MIs[1] Operand 1
     /* 1430824 */     // No operand predicates
     /* 1430824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430828 */     // MIs[0] policy
     /* 1430828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1430840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430862 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430864 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430865 */     // GIR_Coverage, 6116,
     /* 1430865 */     GIR_EraseRootFromParent_Done,
     /* 1430866 */   // Label 20160: @1430866
     /* 1430866 */   GIM_Try, /*On fail goto*//*Label 20161*/ GIMT_Encode4(1430963), // Rule ID 6117 //
     /* 1430871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1430874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1430882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1430885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1430888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1430891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1430894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1430897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1430909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1430913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1430917 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1430921 */     // MIs[1] Operand 1
     /* 1430921 */     // No operand predicates
     /* 1430921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1430925 */     // MIs[0] policy
     /* 1430925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1430928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1430930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1430937 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1430937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_MF2_MASK),
     /* 1430940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1430942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1430944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1430946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1430949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1430951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1430956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1430959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1430961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1430962 */     // GIR_Coverage, 6117,
     /* 1430962 */     GIR_EraseRootFromParent_Done,
     /* 1430963 */   // Label 20161: @1430963
     /* 1430963 */   GIM_Try, /*On fail goto*//*Label 20162*/ GIMT_Encode4(1431060), // Rule ID 6120 //
     /* 1430968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1430971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1430976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1430979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1430982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1430985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1430988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1430991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1430994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1430998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431018 */     // MIs[1] Operand 1
     /* 1431018 */     // No operand predicates
     /* 1431018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431022 */     // MIs[0] policy
     /* 1431022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431034 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431056 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431058 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431059 */     // GIR_Coverage, 6120,
     /* 1431059 */     GIR_EraseRootFromParent_Done,
     /* 1431060 */   // Label 20162: @1431060
     /* 1431060 */   GIM_Try, /*On fail goto*//*Label 20163*/ GIMT_Encode4(1431157), // Rule ID 6121 //
     /* 1431065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1431076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1431079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1431082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1431088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431115 */     // MIs[1] Operand 1
     /* 1431115 */     // No operand predicates
     /* 1431115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431119 */     // MIs[0] policy
     /* 1431119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431131 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431156 */     // GIR_Coverage, 6121,
     /* 1431156 */     GIR_EraseRootFromParent_Done,
     /* 1431157 */   // Label 20163: @1431157
     /* 1431157 */   GIM_Try, /*On fail goto*//*Label 20164*/ GIMT_Encode4(1431254), // Rule ID 6124 //
     /* 1431162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1431173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1431176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1431179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431212 */     // MIs[1] Operand 1
     /* 1431212 */     // No operand predicates
     /* 1431212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431216 */     // MIs[0] policy
     /* 1431216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431228 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431237 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431250 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431252 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431253 */     // GIR_Coverage, 6124,
     /* 1431253 */     GIR_EraseRootFromParent_Done,
     /* 1431254 */   // Label 20164: @1431254
     /* 1431254 */   GIM_Try, /*On fail goto*//*Label 20165*/ GIMT_Encode4(1431351), // Rule ID 6125 //
     /* 1431259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1431270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1431273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1431276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1431282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431305 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431309 */     // MIs[1] Operand 1
     /* 1431309 */     // No operand predicates
     /* 1431309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431313 */     // MIs[0] policy
     /* 1431313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431325 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431334 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1431347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431350 */     // GIR_Coverage, 6125,
     /* 1431350 */     GIR_EraseRootFromParent_Done,
     /* 1431351 */   // Label 20165: @1431351
     /* 1431351 */   GIM_Try, /*On fail goto*//*Label 20166*/ GIMT_Encode4(1431448), // Rule ID 6128 //
     /* 1431356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431406 */     // MIs[1] Operand 1
     /* 1431406 */     // No operand predicates
     /* 1431406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431410 */     // MIs[0] policy
     /* 1431410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431444 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431447 */     // GIR_Coverage, 6128,
     /* 1431447 */     GIR_EraseRootFromParent_Done,
     /* 1431448 */   // Label 20166: @1431448
     /* 1431448 */   GIM_Try, /*On fail goto*//*Label 20167*/ GIMT_Encode4(1431545), // Rule ID 6129 //
     /* 1431453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1431464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1431467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1431470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1431476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431503 */     // MIs[1] Operand 1
     /* 1431503 */     // No operand predicates
     /* 1431503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431507 */     // MIs[0] policy
     /* 1431507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431519 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1431541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431544 */     // GIR_Coverage, 6129,
     /* 1431544 */     GIR_EraseRootFromParent_Done,
     /* 1431545 */   // Label 20167: @1431545
     /* 1431545 */   GIM_Try, /*On fail goto*//*Label 20168*/ GIMT_Encode4(1431642), // Rule ID 6132 //
     /* 1431550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1431553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431596 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431600 */     // MIs[1] Operand 1
     /* 1431600 */     // No operand predicates
     /* 1431600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431604 */     // MIs[0] policy
     /* 1431604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431638 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431641 */     // GIR_Coverage, 6132,
     /* 1431641 */     GIR_EraseRootFromParent_Done,
     /* 1431642 */   // Label 20168: @1431642
     /* 1431642 */   GIM_Try, /*On fail goto*//*Label 20169*/ GIMT_Encode4(1431739), // Rule ID 6133 //
     /* 1431647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1431650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1431658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1431661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1431664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1431670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1431677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1431685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431697 */     // MIs[1] Operand 1
     /* 1431697 */     // No operand predicates
     /* 1431697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431701 */     // MIs[0] policy
     /* 1431701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431713 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M1_MASK),
     /* 1431716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431718 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1431735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431738 */     // GIR_Coverage, 6133,
     /* 1431738 */     GIR_EraseRootFromParent_Done,
     /* 1431739 */   // Label 20169: @1431739
     /* 1431739 */   GIM_Try, /*On fail goto*//*Label 20170*/ GIMT_Encode4(1431836), // Rule ID 6136 //
     /* 1431744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1431755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1431758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1431761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431794 */     // MIs[1] Operand 1
     /* 1431794 */     // No operand predicates
     /* 1431794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431798 */     // MIs[0] policy
     /* 1431798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431810 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1431810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1431813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431832 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431835 */     // GIR_Coverage, 6136,
     /* 1431835 */     GIR_EraseRootFromParent_Done,
     /* 1431836 */   // Label 20170: @1431836
     /* 1431836 */   GIM_Try, /*On fail goto*//*Label 20171*/ GIMT_Encode4(1431933), // Rule ID 6137 //
     /* 1431841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1431844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1431852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1431855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1431858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1431861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1431864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1431867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1431871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1431879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431887 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431891 */     // MIs[1] Operand 1
     /* 1431891 */     // No operand predicates
     /* 1431891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431895 */     // MIs[0] policy
     /* 1431895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1431907 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1431907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1431910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1431912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1431914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1431916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1431919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1431921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1431926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1431929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1431931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1431932 */     // GIR_Coverage, 6137,
     /* 1431932 */     GIR_EraseRootFromParent_Done,
     /* 1431933 */   // Label 20171: @1431933
     /* 1431933 */   GIM_Try, /*On fail goto*//*Label 20172*/ GIMT_Encode4(1432030), // Rule ID 6140 //
     /* 1431938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1431941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1431946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1431949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1431952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1431955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1431958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1431961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1431964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1431968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1431976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1431980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1431984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1431988 */     // MIs[1] Operand 1
     /* 1431988 */     // No operand predicates
     /* 1431988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1431992 */     // MIs[0] policy
     /* 1431992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1431995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1431997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432004 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1432007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432026 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432029 */     // GIR_Coverage, 6140,
     /* 1432029 */     GIR_EraseRootFromParent_Done,
     /* 1432030 */   // Label 20172: @1432030
     /* 1432030 */   GIM_Try, /*On fail goto*//*Label 20173*/ GIMT_Encode4(1432127), // Rule ID 6141 //
     /* 1432035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1432046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1432049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1432052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432085 */     // MIs[1] Operand 1
     /* 1432085 */     // No operand predicates
     /* 1432085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432089 */     // MIs[0] policy
     /* 1432089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432101 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1432104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432126 */     // GIR_Coverage, 6141,
     /* 1432126 */     GIR_EraseRootFromParent_Done,
     /* 1432127 */   // Label 20173: @1432127
     /* 1432127 */   GIM_Try, /*On fail goto*//*Label 20174*/ GIMT_Encode4(1432224), // Rule ID 6144 //
     /* 1432132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1432143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1432146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1432149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1432155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432178 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432182 */     // MIs[1] Operand 1
     /* 1432182 */     // No operand predicates
     /* 1432182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432186 */     // MIs[0] policy
     /* 1432186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432198 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1432201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432207 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432220 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432223 */     // GIR_Coverage, 6144,
     /* 1432223 */     GIR_EraseRootFromParent_Done,
     /* 1432224 */   // Label 20174: @1432224
     /* 1432224 */   GIM_Try, /*On fail goto*//*Label 20175*/ GIMT_Encode4(1432321), // Rule ID 6145 //
     /* 1432229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1432240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1432243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1432246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1432252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432279 */     // MIs[1] Operand 1
     /* 1432279 */     // No operand predicates
     /* 1432279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432283 */     // MIs[0] policy
     /* 1432283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432295 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1432298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1432317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432320 */     // GIR_Coverage, 6145,
     /* 1432320 */     GIR_EraseRootFromParent_Done,
     /* 1432321 */   // Label 20175: @1432321
     /* 1432321 */   GIM_Try, /*On fail goto*//*Label 20176*/ GIMT_Encode4(1432418), // Rule ID 6148 //
     /* 1432326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1432337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1432340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1432343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432376 */     // MIs[1] Operand 1
     /* 1432376 */     // No operand predicates
     /* 1432376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432380 */     // MIs[0] policy
     /* 1432380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432392 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1432395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432414 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432417 */     // GIR_Coverage, 6148,
     /* 1432417 */     GIR_EraseRootFromParent_Done,
     /* 1432418 */   // Label 20176: @1432418
     /* 1432418 */   GIM_Try, /*On fail goto*//*Label 20177*/ GIMT_Encode4(1432515), // Rule ID 6149 //
     /* 1432423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1432434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1432437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1432440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1432446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432469 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432473 */     // MIs[1] Operand 1
     /* 1432473 */     // No operand predicates
     /* 1432473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432477 */     // MIs[0] policy
     /* 1432477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432489 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1432492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432514 */     // GIR_Coverage, 6149,
     /* 1432514 */     GIR_EraseRootFromParent_Done,
     /* 1432515 */   // Label 20177: @1432515
     /* 1432515 */   GIM_Try, /*On fail goto*//*Label 20178*/ GIMT_Encode4(1432612), // Rule ID 6152 //
     /* 1432520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1432531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1432534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1432537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1432543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432570 */     // MIs[1] Operand 1
     /* 1432570 */     // No operand predicates
     /* 1432570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432574 */     // MIs[0] policy
     /* 1432574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432586 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1432589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432608 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432610 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432611 */     // GIR_Coverage, 6152,
     /* 1432611 */     GIR_EraseRootFromParent_Done,
     /* 1432612 */   // Label 20178: @1432612
     /* 1432612 */   GIM_Try, /*On fail goto*//*Label 20179*/ GIMT_Encode4(1432709), // Rule ID 6153 //
     /* 1432617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1432628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1432631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1432634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1432640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1432647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1432655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432667 */     // MIs[1] Operand 1
     /* 1432667 */     // No operand predicates
     /* 1432667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432671 */     // MIs[0] policy
     /* 1432671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432683 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1432686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432708 */     // GIR_Coverage, 6153,
     /* 1432708 */     GIR_EraseRootFromParent_Done,
     /* 1432709 */   // Label 20179: @1432709
     /* 1432709 */   GIM_Try, /*On fail goto*//*Label 20180*/ GIMT_Encode4(1432806), // Rule ID 6156 //
     /* 1432714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1432725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1432728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1432731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432764 */     // MIs[1] Operand 1
     /* 1432764 */     // No operand predicates
     /* 1432764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432768 */     // MIs[0] policy
     /* 1432768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432780 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1432783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432789 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432802 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432804 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432805 */     // GIR_Coverage, 6156,
     /* 1432805 */     GIR_EraseRootFromParent_Done,
     /* 1432806 */   // Label 20180: @1432806
     /* 1432806 */   GIM_Try, /*On fail goto*//*Label 20181*/ GIMT_Encode4(1432903), // Rule ID 6157 //
     /* 1432811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1432814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1432822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1432825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1432828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1432831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1432834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1432837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1432841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1432849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432857 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432861 */     // MIs[1] Operand 1
     /* 1432861 */     // No operand predicates
     /* 1432861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432865 */     // MIs[0] policy
     /* 1432865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432877 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1432877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1432880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1432899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432902 */     // GIR_Coverage, 6157,
     /* 1432902 */     GIR_EraseRootFromParent_Done,
     /* 1432903 */   // Label 20181: @1432903
     /* 1432903 */   GIM_Try, /*On fail goto*//*Label 20182*/ GIMT_Encode4(1433000), // Rule ID 6160 //
     /* 1432908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1432911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1432916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1432919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1432922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1432925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1432928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1432931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1432934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1432938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1432946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1432950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1432954 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1432958 */     // MIs[1] Operand 1
     /* 1432958 */     // No operand predicates
     /* 1432958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1432962 */     // MIs[0] policy
     /* 1432962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1432965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1432967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1432974 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1432974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1432977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1432979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1432981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1432983 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1432986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1432988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1432993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1432996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1432998 */     GIR_RootConstrainSelectedInstOperands,
     /* 1432999 */     // GIR_Coverage, 6160,
     /* 1432999 */     GIR_EraseRootFromParent_Done,
     /* 1433000 */   // Label 20182: @1433000
     /* 1433000 */   GIM_Try, /*On fail goto*//*Label 20183*/ GIMT_Encode4(1433097), // Rule ID 6161 //
     /* 1433005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1433016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1433019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1433022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433051 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433055 */     // MIs[1] Operand 1
     /* 1433055 */     // No operand predicates
     /* 1433055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433059 */     // MIs[0] policy
     /* 1433059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433071 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1433074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433096 */     // GIR_Coverage, 6161,
     /* 1433096 */     GIR_EraseRootFromParent_Done,
     /* 1433097 */   // Label 20183: @1433097
     /* 1433097 */   GIM_Try, /*On fail goto*//*Label 20184*/ GIMT_Encode4(1433194), // Rule ID 6164 //
     /* 1433102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1433113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1433116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1433119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433148 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433152 */     // MIs[1] Operand 1
     /* 1433152 */     // No operand predicates
     /* 1433152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433156 */     // MIs[0] policy
     /* 1433156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1433171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433192 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433193 */     // GIR_Coverage, 6164,
     /* 1433193 */     GIR_EraseRootFromParent_Done,
     /* 1433194 */   // Label 20184: @1433194
     /* 1433194 */   GIM_Try, /*On fail goto*//*Label 20185*/ GIMT_Encode4(1433291), // Rule ID 6165 //
     /* 1433199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1433210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1433213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1433216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433249 */     // MIs[1] Operand 1
     /* 1433249 */     // No operand predicates
     /* 1433249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433253 */     // MIs[0] policy
     /* 1433253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433265 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1433268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433270 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433290 */     // GIR_Coverage, 6165,
     /* 1433290 */     GIR_EraseRootFromParent_Done,
     /* 1433291 */   // Label 20185: @1433291
     /* 1433291 */   GIM_Try, /*On fail goto*//*Label 20186*/ GIMT_Encode4(1433388), // Rule ID 6168 //
     /* 1433296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1433299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1433307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1433310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1433313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433342 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433346 */     // MIs[1] Operand 1
     /* 1433346 */     // No operand predicates
     /* 1433346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433350 */     // MIs[0] policy
     /* 1433350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433362 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1433365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433386 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433387 */     // GIR_Coverage, 6168,
     /* 1433387 */     GIR_EraseRootFromParent_Done,
     /* 1433388 */   // Label 20186: @1433388
     /* 1433388 */   GIM_Try, /*On fail goto*//*Label 20187*/ GIMT_Encode4(1433485), // Rule ID 6169 //
     /* 1433393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1433396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1433404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1433407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1433410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1433416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433443 */     // MIs[1] Operand 1
     /* 1433443 */     // No operand predicates
     /* 1433443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433447 */     // MIs[0] policy
     /* 1433447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433459 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1433462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1433481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433484 */     // GIR_Coverage, 6169,
     /* 1433484 */     GIR_EraseRootFromParent_Done,
     /* 1433485 */   // Label 20187: @1433485
     /* 1433485 */   GIM_Try, /*On fail goto*//*Label 20188*/ GIMT_Encode4(1433582), // Rule ID 6172 //
     /* 1433490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1433501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1433504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1433507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433536 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433540 */     // MIs[1] Operand 1
     /* 1433540 */     // No operand predicates
     /* 1433540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433544 */     // MIs[0] policy
     /* 1433544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1433559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433580 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433581 */     // GIR_Coverage, 6172,
     /* 1433581 */     GIR_EraseRootFromParent_Done,
     /* 1433582 */   // Label 20188: @1433582
     /* 1433582 */   GIM_Try, /*On fail goto*//*Label 20189*/ GIMT_Encode4(1433679), // Rule ID 6173 //
     /* 1433587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1433598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1433601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1433604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1433610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1433617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1433625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433633 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433637 */     // MIs[1] Operand 1
     /* 1433637 */     // No operand predicates
     /* 1433637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433641 */     // MIs[0] policy
     /* 1433641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M2_MASK),
     /* 1433656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433678 */     // GIR_Coverage, 6173,
     /* 1433678 */     GIR_EraseRootFromParent_Done,
     /* 1433679 */   // Label 20189: @1433679
     /* 1433679 */   GIM_Try, /*On fail goto*//*Label 20190*/ GIMT_Encode4(1433776), // Rule ID 6176 //
     /* 1433684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1433695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1433698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1433701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433734 */     // MIs[1] Operand 1
     /* 1433734 */     // No operand predicates
     /* 1433734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433738 */     // MIs[0] policy
     /* 1433738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433750 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1433753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433774 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433775 */     // GIR_Coverage, 6176,
     /* 1433775 */     GIR_EraseRootFromParent_Done,
     /* 1433776 */   // Label 20190: @1433776
     /* 1433776 */   GIM_Try, /*On fail goto*//*Label 20191*/ GIMT_Encode4(1433873), // Rule ID 6177 //
     /* 1433781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1433792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1433795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1433798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1433804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1433807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1433811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1433819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433831 */     // MIs[1] Operand 1
     /* 1433831 */     // No operand predicates
     /* 1433831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433835 */     // MIs[0] policy
     /* 1433835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433847 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1433847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M4_MASK),
     /* 1433850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433872 */     // GIR_Coverage, 6177,
     /* 1433872 */     GIR_EraseRootFromParent_Done,
     /* 1433873 */   // Label 20191: @1433873
     /* 1433873 */   GIM_Try, /*On fail goto*//*Label 20192*/ GIMT_Encode4(1433970), // Rule ID 6180 //
     /* 1433878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1433881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1433889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1433892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1433895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1433898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1433904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1433908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1433916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1433920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1433924 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1433928 */     // MIs[1] Operand 1
     /* 1433928 */     // No operand predicates
     /* 1433928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1433932 */     // MIs[0] policy
     /* 1433932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1433935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1433937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1433944 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1433944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1433947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1433949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1433951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1433953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1433956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1433958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1433963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1433966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1433968 */     GIR_RootConstrainSelectedInstOperands,
     /* 1433969 */     // GIR_Coverage, 6180,
     /* 1433969 */     GIR_EraseRootFromParent_Done,
     /* 1433970 */   // Label 20192: @1433970
     /* 1433970 */   GIM_Try, /*On fail goto*//*Label 20193*/ GIMT_Encode4(1434067), // Rule ID 6181 //
     /* 1433975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1433978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1433983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1433986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1433989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1433992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1433995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1433998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1434005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1434013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434021 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434025 */     // MIs[1] Operand 1
     /* 1434025 */     // No operand predicates
     /* 1434025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434029 */     // MIs[0] policy
     /* 1434029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VI_M8_MASK),
     /* 1434044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1434063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434066 */     // GIR_Coverage, 6181,
     /* 1434066 */     GIR_EraseRootFromParent_Done,
     /* 1434067 */   // Label 20193: @1434067
     /* 1434067 */   GIM_Try, /*On fail goto*//*Label 20194*/ GIMT_Encode4(1434164), // Rule ID 6360 //
     /* 1434072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1434083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1434086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1434089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434118 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434122 */     // MIs[1] Operand 1
     /* 1434122 */     // No operand predicates
     /* 1434122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434126 */     // MIs[0] policy
     /* 1434126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1434141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434160 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434162 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434163 */     // GIR_Coverage, 6360,
     /* 1434163 */     GIR_EraseRootFromParent_Done,
     /* 1434164 */   // Label 20194: @1434164
     /* 1434164 */   GIM_Try, /*On fail goto*//*Label 20195*/ GIMT_Encode4(1434261), // Rule ID 6361 //
     /* 1434169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1434180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1434183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1434186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434215 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434219 */     // MIs[1] Operand 1
     /* 1434219 */     // No operand predicates
     /* 1434219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434223 */     // MIs[0] policy
     /* 1434223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF8_MASK),
     /* 1434238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434244 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434260 */     // GIR_Coverage, 6361,
     /* 1434260 */     GIR_EraseRootFromParent_Done,
     /* 1434261 */   // Label 20195: @1434261
     /* 1434261 */   GIM_Try, /*On fail goto*//*Label 20196*/ GIMT_Encode4(1434358), // Rule ID 6364 //
     /* 1434266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1434277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1434280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1434283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434312 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434316 */     // MIs[1] Operand 1
     /* 1434316 */     // No operand predicates
     /* 1434316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434320 */     // MIs[0] policy
     /* 1434320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434323 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434332 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1434335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434354 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434356 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434357 */     // GIR_Coverage, 6364,
     /* 1434357 */     GIR_EraseRootFromParent_Done,
     /* 1434358 */   // Label 20196: @1434358
     /* 1434358 */   GIM_Try, /*On fail goto*//*Label 20197*/ GIMT_Encode4(1434455), // Rule ID 6365 //
     /* 1434363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1434374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1434377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1434380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434409 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434413 */     // MIs[1] Operand 1
     /* 1434413 */     // No operand predicates
     /* 1434413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434417 */     // MIs[0] policy
     /* 1434417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434429 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1434432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434454 */     // GIR_Coverage, 6365,
     /* 1434454 */     GIR_EraseRootFromParent_Done,
     /* 1434455 */   // Label 20197: @1434455
     /* 1434455 */   GIM_Try, /*On fail goto*//*Label 20198*/ GIMT_Encode4(1434552), // Rule ID 6368 //
     /* 1434460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1434471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1434474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1434477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434510 */     // MIs[1] Operand 1
     /* 1434510 */     // No operand predicates
     /* 1434510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434514 */     // MIs[0] policy
     /* 1434514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434517 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1434529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434535 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434548 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434550 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434551 */     // GIR_Coverage, 6368,
     /* 1434551 */     GIR_EraseRootFromParent_Done,
     /* 1434552 */   // Label 20198: @1434552
     /* 1434552 */   GIM_Try, /*On fail goto*//*Label 20199*/ GIMT_Encode4(1434649), // Rule ID 6369 //
     /* 1434557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1434568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1434571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1434574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1434580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434607 */     // MIs[1] Operand 1
     /* 1434607 */     // No operand predicates
     /* 1434607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434611 */     // MIs[0] policy
     /* 1434611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434623 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1434626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434632 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1434645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434648 */     // GIR_Coverage, 6369,
     /* 1434648 */     GIR_EraseRootFromParent_Done,
     /* 1434649 */   // Label 20199: @1434649
     /* 1434649 */   GIM_Try, /*On fail goto*//*Label 20200*/ GIMT_Encode4(1434746), // Rule ID 6372 //
     /* 1434654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1434665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1434668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1434671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434704 */     // MIs[1] Operand 1
     /* 1434704 */     // No operand predicates
     /* 1434704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434708 */     // MIs[0] policy
     /* 1434708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434720 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1434723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434742 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434744 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434745 */     // GIR_Coverage, 6372,
     /* 1434745 */     GIR_EraseRootFromParent_Done,
     /* 1434746 */   // Label 20200: @1434746
     /* 1434746 */   GIM_Try, /*On fail goto*//*Label 20201*/ GIMT_Encode4(1434843), // Rule ID 6373 //
     /* 1434751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1434762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1434765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1434768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1434774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434801 */     // MIs[1] Operand 1
     /* 1434801 */     // No operand predicates
     /* 1434801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434805 */     // MIs[0] policy
     /* 1434805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434817 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1434817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF4_MASK),
     /* 1434820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434842 */     // GIR_Coverage, 6373,
     /* 1434842 */     GIR_EraseRootFromParent_Done,
     /* 1434843 */   // Label 20201: @1434843
     /* 1434843 */   GIM_Try, /*On fail goto*//*Label 20202*/ GIMT_Encode4(1434940), // Rule ID 6376 //
     /* 1434848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1434851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1434859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1434862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1434865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1434868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1434874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434894 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434898 */     // MIs[1] Operand 1
     /* 1434898 */     // No operand predicates
     /* 1434898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434902 */     // MIs[0] policy
     /* 1434902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1434905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1434907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1434914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1434914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1434917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1434919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1434921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1434923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1434926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1434928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1434933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1434936 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1434938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434939 */     // GIR_Coverage, 6376,
     /* 1434939 */     GIR_EraseRootFromParent_Done,
     /* 1434940 */   // Label 20202: @1434940
     /* 1434940 */   GIM_Try, /*On fail goto*//*Label 20203*/ GIMT_Encode4(1435037), // Rule ID 6377 //
     /* 1434945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1434948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1434953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1434956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1434959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1434962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1434965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1434968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1434971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1434975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1434983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1434987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1434991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1434995 */     // MIs[1] Operand 1
     /* 1434995 */     // No operand predicates
     /* 1434995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1434999 */     // MIs[0] policy
     /* 1434999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435011 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1435014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435036 */     // GIR_Coverage, 6377,
     /* 1435036 */     GIR_EraseRootFromParent_Done,
     /* 1435037 */   // Label 20203: @1435037
     /* 1435037 */   GIM_Try, /*On fail goto*//*Label 20204*/ GIMT_Encode4(1435134), // Rule ID 6380 //
     /* 1435042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435092 */     // MIs[1] Operand 1
     /* 1435092 */     // No operand predicates
     /* 1435092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435096 */     // MIs[0] policy
     /* 1435096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435108 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1435111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435130 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435133 */     // GIR_Coverage, 6380,
     /* 1435133 */     GIR_EraseRootFromParent_Done,
     /* 1435134 */   // Label 20204: @1435134
     /* 1435134 */   GIM_Try, /*On fail goto*//*Label 20205*/ GIMT_Encode4(1435231), // Rule ID 6381 //
     /* 1435139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1435150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1435153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1435156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435185 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435189 */     // MIs[1] Operand 1
     /* 1435189 */     // No operand predicates
     /* 1435189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435193 */     // MIs[0] policy
     /* 1435193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435205 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_MF2_MASK),
     /* 1435208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435230 */     // GIR_Coverage, 6381,
     /* 1435230 */     GIR_EraseRootFromParent_Done,
     /* 1435231 */   // Label 20205: @1435231
     /* 1435231 */   GIM_Try, /*On fail goto*//*Label 20206*/ GIMT_Encode4(1435328), // Rule ID 6384 //
     /* 1435236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1435247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1435250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1435253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435282 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435286 */     // MIs[1] Operand 1
     /* 1435286 */     // No operand predicates
     /* 1435286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435290 */     // MIs[0] policy
     /* 1435290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435302 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435324 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435327 */     // GIR_Coverage, 6384,
     /* 1435327 */     GIR_EraseRootFromParent_Done,
     /* 1435328 */   // Label 20206: @1435328
     /* 1435328 */   GIM_Try, /*On fail goto*//*Label 20207*/ GIMT_Encode4(1435425), // Rule ID 6385 //
     /* 1435333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1435344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1435347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1435350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1435356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435383 */     // MIs[1] Operand 1
     /* 1435383 */     // No operand predicates
     /* 1435383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435387 */     // MIs[0] policy
     /* 1435387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435399 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1435421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435424 */     // GIR_Coverage, 6385,
     /* 1435424 */     GIR_EraseRootFromParent_Done,
     /* 1435425 */   // Label 20207: @1435425
     /* 1435425 */   GIM_Try, /*On fail goto*//*Label 20208*/ GIMT_Encode4(1435522), // Rule ID 6388 //
     /* 1435430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435480 */     // MIs[1] Operand 1
     /* 1435480 */     // No operand predicates
     /* 1435480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435484 */     // MIs[0] policy
     /* 1435484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435496 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435518 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435521 */     // GIR_Coverage, 6388,
     /* 1435521 */     GIR_EraseRootFromParent_Done,
     /* 1435522 */   // Label 20208: @1435522
     /* 1435522 */   GIM_Try, /*On fail goto*//*Label 20209*/ GIMT_Encode4(1435619), // Rule ID 6389 //
     /* 1435527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1435538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1435541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1435544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1435550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435577 */     // MIs[1] Operand 1
     /* 1435577 */     // No operand predicates
     /* 1435577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435581 */     // MIs[0] policy
     /* 1435581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435593 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1435615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435618 */     // GIR_Coverage, 6389,
     /* 1435618 */     GIR_EraseRootFromParent_Done,
     /* 1435619 */   // Label 20209: @1435619
     /* 1435619 */   GIM_Try, /*On fail goto*//*Label 20210*/ GIMT_Encode4(1435716), // Rule ID 6392 //
     /* 1435624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1435627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1435635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1435638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1435641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435670 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435674 */     // MIs[1] Operand 1
     /* 1435674 */     // No operand predicates
     /* 1435674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435678 */     // MIs[0] policy
     /* 1435678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435690 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435712 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435715 */     // GIR_Coverage, 6392,
     /* 1435715 */     GIR_EraseRootFromParent_Done,
     /* 1435716 */   // Label 20210: @1435716
     /* 1435716 */   GIM_Try, /*On fail goto*//*Label 20211*/ GIMT_Encode4(1435813), // Rule ID 6393 //
     /* 1435721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1435724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1435732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1435735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1435738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1435744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435771 */     // MIs[1] Operand 1
     /* 1435771 */     // No operand predicates
     /* 1435771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435775 */     // MIs[0] policy
     /* 1435775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435787 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1435809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435812 */     // GIR_Coverage, 6393,
     /* 1435812 */     GIR_EraseRootFromParent_Done,
     /* 1435813 */   // Label 20211: @1435813
     /* 1435813 */   GIM_Try, /*On fail goto*//*Label 20212*/ GIMT_Encode4(1435910), // Rule ID 6396 //
     /* 1435818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1435821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1435829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1435832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1435835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1435838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1435844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435868 */     // MIs[1] Operand 1
     /* 1435868 */     // No operand predicates
     /* 1435868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435872 */     // MIs[0] policy
     /* 1435872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435884 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1435884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435893 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1435903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1435906 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1435908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1435909 */     // GIR_Coverage, 6396,
     /* 1435909 */     GIR_EraseRootFromParent_Done,
     /* 1435910 */   // Label 20212: @1435910
     /* 1435910 */   GIM_Try, /*On fail goto*//*Label 20213*/ GIMT_Encode4(1436007), // Rule ID 6397 //
     /* 1435915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1435918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1435923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1435926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1435929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1435932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1435935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1435938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1435941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1435945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1435953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1435957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1435961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1435965 */     // MIs[1] Operand 1
     /* 1435965 */     // No operand predicates
     /* 1435965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1435969 */     // MIs[0] policy
     /* 1435969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1435972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1435974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1435981 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1435981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M1_MASK),
     /* 1435984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1435986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1435988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1435990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1435993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1435995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1436003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436006 */     // GIR_Coverage, 6397,
     /* 1436006 */     GIR_EraseRootFromParent_Done,
     /* 1436007 */   // Label 20213: @1436007
     /* 1436007 */   GIM_Try, /*On fail goto*//*Label 20214*/ GIMT_Encode4(1436104), // Rule ID 6400 //
     /* 1436012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1436023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1436026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1436029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436058 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436062 */     // MIs[1] Operand 1
     /* 1436062 */     // No operand predicates
     /* 1436062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436066 */     // MIs[0] policy
     /* 1436066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436078 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1436081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436100 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436103 */     // GIR_Coverage, 6400,
     /* 1436103 */     GIR_EraseRootFromParent_Done,
     /* 1436104 */   // Label 20214: @1436104
     /* 1436104 */   GIM_Try, /*On fail goto*//*Label 20215*/ GIMT_Encode4(1436201), // Rule ID 6401 //
     /* 1436109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1436120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1436123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1436126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436159 */     // MIs[1] Operand 1
     /* 1436159 */     // No operand predicates
     /* 1436159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436163 */     // MIs[0] policy
     /* 1436163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436175 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1436178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436200 */     // GIR_Coverage, 6401,
     /* 1436200 */     GIR_EraseRootFromParent_Done,
     /* 1436201 */   // Label 20215: @1436201
     /* 1436201 */   GIM_Try, /*On fail goto*//*Label 20216*/ GIMT_Encode4(1436298), // Rule ID 6404 //
     /* 1436206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1436217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1436220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1436223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1436229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436252 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436256 */     // MIs[1] Operand 1
     /* 1436256 */     // No operand predicates
     /* 1436256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436260 */     // MIs[0] policy
     /* 1436260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1436275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436294 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436296 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436297 */     // GIR_Coverage, 6404,
     /* 1436297 */     GIR_EraseRootFromParent_Done,
     /* 1436298 */   // Label 20216: @1436298
     /* 1436298 */   GIM_Try, /*On fail goto*//*Label 20217*/ GIMT_Encode4(1436395), // Rule ID 6405 //
     /* 1436303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1436314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1436317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1436320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1436326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436353 */     // MIs[1] Operand 1
     /* 1436353 */     // No operand predicates
     /* 1436353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436357 */     // MIs[0] policy
     /* 1436357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436369 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1436372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436394 */     // GIR_Coverage, 6405,
     /* 1436394 */     GIR_EraseRootFromParent_Done,
     /* 1436395 */   // Label 20217: @1436395
     /* 1436395 */   GIM_Try, /*On fail goto*//*Label 20218*/ GIMT_Encode4(1436492), // Rule ID 6408 //
     /* 1436400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1436411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1436414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1436417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1436423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436446 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436450 */     // MIs[1] Operand 1
     /* 1436450 */     // No operand predicates
     /* 1436450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436454 */     // MIs[0] policy
     /* 1436454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436466 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1436469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436490 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436491 */     // GIR_Coverage, 6408,
     /* 1436491 */     GIR_EraseRootFromParent_Done,
     /* 1436492 */   // Label 20218: @1436492
     /* 1436492 */   GIM_Try, /*On fail goto*//*Label 20219*/ GIMT_Encode4(1436589), // Rule ID 6409 //
     /* 1436497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1436508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1436511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1436514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1436520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1436527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1436535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436543 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436547 */     // MIs[1] Operand 1
     /* 1436547 */     // No operand predicates
     /* 1436547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436551 */     // MIs[0] policy
     /* 1436551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436563 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1436566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436572 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1436585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436588 */     // GIR_Coverage, 6409,
     /* 1436588 */     GIR_EraseRootFromParent_Done,
     /* 1436589 */   // Label 20219: @1436589
     /* 1436589 */   GIM_Try, /*On fail goto*//*Label 20220*/ GIMT_Encode4(1436686), // Rule ID 6412 //
     /* 1436594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436640 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436644 */     // MIs[1] Operand 1
     /* 1436644 */     // No operand predicates
     /* 1436644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436648 */     // MIs[0] policy
     /* 1436648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1436663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436684 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436685 */     // GIR_Coverage, 6412,
     /* 1436685 */     GIR_EraseRootFromParent_Done,
     /* 1436686 */   // Label 20220: @1436686
     /* 1436686 */   GIM_Try, /*On fail goto*//*Label 20221*/ GIMT_Encode4(1436783), // Rule ID 6413 //
     /* 1436691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1436702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1436705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1436708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1436714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1436721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1436729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436737 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436741 */     // MIs[1] Operand 1
     /* 1436741 */     // No operand predicates
     /* 1436741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436745 */     // MIs[0] policy
     /* 1436745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436757 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1436760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436782 */     // GIR_Coverage, 6413,
     /* 1436782 */     GIR_EraseRootFromParent_Done,
     /* 1436783 */   // Label 20221: @1436783
     /* 1436783 */   GIM_Try, /*On fail goto*//*Label 20222*/ GIMT_Encode4(1436880), // Rule ID 6416 //
     /* 1436788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1436808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1436814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436838 */     // MIs[1] Operand 1
     /* 1436838 */     // No operand predicates
     /* 1436838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436842 */     // MIs[0] policy
     /* 1436842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436854 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1436854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1436857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436878 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436879 */     // GIR_Coverage, 6416,
     /* 1436879 */     GIR_EraseRootFromParent_Done,
     /* 1436880 */   // Label 20222: @1436880
     /* 1436880 */   GIM_Try, /*On fail goto*//*Label 20223*/ GIMT_Encode4(1436977), // Rule ID 6417 //
     /* 1436885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1436888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1436896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1436899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1436902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1436905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1436908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1436911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1436915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1436923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1436927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1436931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1436935 */     // MIs[1] Operand 1
     /* 1436935 */     // No operand predicates
     /* 1436935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1436939 */     // MIs[0] policy
     /* 1436939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1436942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1436944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1436951 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1436951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1436954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1436956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1436958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1436960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1436963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1436965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1436970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1436973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1436975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1436976 */     // GIR_Coverage, 6417,
     /* 1436976 */     GIR_EraseRootFromParent_Done,
     /* 1436977 */   // Label 20223: @1436977
     /* 1436977 */   GIM_Try, /*On fail goto*//*Label 20224*/ GIMT_Encode4(1437074), // Rule ID 6420 //
     /* 1436982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1436985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1436990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1436993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1436996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1436999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1437005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437032 */     // MIs[1] Operand 1
     /* 1437032 */     // No operand predicates
     /* 1437032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437036 */     // MIs[0] policy
     /* 1437036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437048 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1437051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437072 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437073 */     // GIR_Coverage, 6420,
     /* 1437073 */     GIR_EraseRootFromParent_Done,
     /* 1437074 */   // Label 20224: @1437074
     /* 1437074 */   GIM_Try, /*On fail goto*//*Label 20225*/ GIMT_Encode4(1437171), // Rule ID 6421 //
     /* 1437079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1437090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1437093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1437096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1437102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437129 */     // MIs[1] Operand 1
     /* 1437129 */     // No operand predicates
     /* 1437129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437133 */     // MIs[0] policy
     /* 1437133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437145 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1437148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437154 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1437167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437170 */     // GIR_Coverage, 6421,
     /* 1437170 */     GIR_EraseRootFromParent_Done,
     /* 1437171 */   // Label 20225: @1437171
     /* 1437171 */   GIM_Try, /*On fail goto*//*Label 20226*/ GIMT_Encode4(1437268), // Rule ID 6424 //
     /* 1437176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1437187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1437190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1437193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437222 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437226 */     // MIs[1] Operand 1
     /* 1437226 */     // No operand predicates
     /* 1437226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437230 */     // MIs[0] policy
     /* 1437230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1437245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437266 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437267 */     // GIR_Coverage, 6424,
     /* 1437267 */     GIR_EraseRootFromParent_Done,
     /* 1437268 */   // Label 20226: @1437268
     /* 1437268 */   GIM_Try, /*On fail goto*//*Label 20227*/ GIMT_Encode4(1437365), // Rule ID 6425 //
     /* 1437273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1437284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1437287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1437290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437323 */     // MIs[1] Operand 1
     /* 1437323 */     // No operand predicates
     /* 1437323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437327 */     // MIs[0] policy
     /* 1437327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1437342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437364 */     // GIR_Coverage, 6425,
     /* 1437364 */     GIR_EraseRootFromParent_Done,
     /* 1437365 */   // Label 20227: @1437365
     /* 1437365 */   GIM_Try, /*On fail goto*//*Label 20228*/ GIMT_Encode4(1437462), // Rule ID 6428 //
     /* 1437370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1437400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437420 */     // MIs[1] Operand 1
     /* 1437420 */     // No operand predicates
     /* 1437420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437424 */     // MIs[0] policy
     /* 1437424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1437439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437460 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437461 */     // GIR_Coverage, 6428,
     /* 1437461 */     GIR_EraseRootFromParent_Done,
     /* 1437462 */   // Label 20228: @1437462
     /* 1437462 */   GIM_Try, /*On fail goto*//*Label 20229*/ GIMT_Encode4(1437559), // Rule ID 6429 //
     /* 1437467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1437478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1437481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1437484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1437490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1437497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437513 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437517 */     // MIs[1] Operand 1
     /* 1437517 */     // No operand predicates
     /* 1437517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437521 */     // MIs[0] policy
     /* 1437521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437533 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1437536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437538 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437558 */     // GIR_Coverage, 6429,
     /* 1437558 */     GIR_EraseRootFromParent_Done,
     /* 1437559 */   // Label 20229: @1437559
     /* 1437559 */   GIM_Try, /*On fail goto*//*Label 20230*/ GIMT_Encode4(1437656), // Rule ID 6432 //
     /* 1437564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1437567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1437587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437614 */     // MIs[1] Operand 1
     /* 1437614 */     // No operand predicates
     /* 1437614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437618 */     // MIs[0] policy
     /* 1437618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1437633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437654 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437655 */     // GIR_Coverage, 6432,
     /* 1437655 */     GIR_EraseRootFromParent_Done,
     /* 1437656 */   // Label 20230: @1437656
     /* 1437656 */   GIM_Try, /*On fail goto*//*Label 20231*/ GIMT_Encode4(1437753), // Rule ID 6433 //
     /* 1437661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1437664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1437672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1437675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1437678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1437684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1437691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1437699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437711 */     // MIs[1] Operand 1
     /* 1437711 */     // No operand predicates
     /* 1437711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437715 */     // MIs[0] policy
     /* 1437715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437727 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1437730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1437749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437752 */     // GIR_Coverage, 6433,
     /* 1437752 */     GIR_EraseRootFromParent_Done,
     /* 1437753 */   // Label 20231: @1437753
     /* 1437753 */   GIM_Try, /*On fail goto*//*Label 20232*/ GIMT_Encode4(1437850), // Rule ID 6436 //
     /* 1437758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1437761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437804 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437808 */     // MIs[1] Operand 1
     /* 1437808 */     // No operand predicates
     /* 1437808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437812 */     // MIs[0] policy
     /* 1437812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1437824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1437827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437846 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437848 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437849 */     // GIR_Coverage, 6436,
     /* 1437849 */     GIR_EraseRootFromParent_Done,
     /* 1437850 */   // Label 20232: @1437850
     /* 1437850 */   GIM_Try, /*On fail goto*//*Label 20233*/ GIMT_Encode4(1437947), // Rule ID 6437 //
     /* 1437855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1437858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1437866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1437869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1437872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1437875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1437878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1437881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1437885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1437893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437901 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1437905 */     // MIs[1] Operand 1
     /* 1437905 */     // No operand predicates
     /* 1437905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1437909 */     // MIs[0] policy
     /* 1437909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1437912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1437914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1437921 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1437921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M2_MASK),
     /* 1437924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1437926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1437928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1437930 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1437933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1437935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1437940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1437943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1437945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1437946 */     // GIR_Coverage, 6437,
     /* 1437946 */     GIR_EraseRootFromParent_Done,
     /* 1437947 */   // Label 20233: @1437947
     /* 1437947 */   GIM_Try, /*On fail goto*//*Label 20234*/ GIMT_Encode4(1438044), // Rule ID 6440 //
     /* 1437952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1437955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1437960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1437963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1437966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1437969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1437972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1437975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1437978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1437982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1437990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1437994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1437998 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438002 */     // MIs[1] Operand 1
     /* 1438002 */     // No operand predicates
     /* 1438002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438006 */     // MIs[0] policy
     /* 1438006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1438021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438040 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438042 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438043 */     // GIR_Coverage, 6440,
     /* 1438043 */     GIR_EraseRootFromParent_Done,
     /* 1438044 */   // Label 20234: @1438044
     /* 1438044 */   GIM_Try, /*On fail goto*//*Label 20235*/ GIMT_Encode4(1438141), // Rule ID 6441 //
     /* 1438049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1438060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1438063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1438066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1438079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1438087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438099 */     // MIs[1] Operand 1
     /* 1438099 */     // No operand predicates
     /* 1438099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438103 */     // MIs[0] policy
     /* 1438103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438115 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M4_MASK),
     /* 1438118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438140 */     // GIR_Coverage, 6441,
     /* 1438140 */     GIR_EraseRootFromParent_Done,
     /* 1438141 */   // Label 20235: @1438141
     /* 1438141 */   GIM_Try, /*On fail goto*//*Label 20236*/ GIMT_Encode4(1438238), // Rule ID 6444 //
     /* 1438146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1438149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1438157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1438160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1438163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438192 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438196 */     // MIs[1] Operand 1
     /* 1438196 */     // No operand predicates
     /* 1438196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438200 */     // MIs[0] policy
     /* 1438200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438212 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1438215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438234 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438236 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438237 */     // GIR_Coverage, 6444,
     /* 1438237 */     GIR_EraseRootFromParent_Done,
     /* 1438238 */   // Label 20236: @1438238
     /* 1438238 */   GIM_Try, /*On fail goto*//*Label 20237*/ GIMT_Encode4(1438335), // Rule ID 6445 //
     /* 1438243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1438246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1438251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1438254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1438257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1438260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1438266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1438273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1438281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438289 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1438293 */     // MIs[1] Operand 1
     /* 1438293 */     // No operand predicates
     /* 1438293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438297 */     // MIs[0] policy
     /* 1438297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438309 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VI_M8_MASK),
     /* 1438312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1438331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438334 */     // GIR_Coverage, 6445,
     /* 1438334 */     GIR_EraseRootFromParent_Done,
     /* 1438335 */   // Label 20237: @1438335
     /* 1438335 */   GIM_Try, /*On fail goto*//*Label 20238*/ GIMT_Encode4(1438432), // Rule ID 6624 //
     /* 1438340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1438351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1438354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1438357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438390 */     // MIs[1] Operand 1
     /* 1438390 */     // No operand predicates
     /* 1438390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438394 */     // MIs[0] policy
     /* 1438394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438406 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1438409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438428 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438430 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438431 */     // GIR_Coverage, 6624,
     /* 1438431 */     GIR_EraseRootFromParent_Done,
     /* 1438432 */   // Label 20238: @1438432
     /* 1438432 */   GIM_Try, /*On fail goto*//*Label 20239*/ GIMT_Encode4(1438529), // Rule ID 6625 //
     /* 1438437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1438448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1438451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1438454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438483 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438487 */     // MIs[1] Operand 1
     /* 1438487 */     // No operand predicates
     /* 1438487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438491 */     // MIs[0] policy
     /* 1438491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438503 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF8_MASK),
     /* 1438506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438528 */     // GIR_Coverage, 6625,
     /* 1438528 */     GIR_EraseRootFromParent_Done,
     /* 1438529 */   // Label 20239: @1438529
     /* 1438529 */   GIM_Try, /*On fail goto*//*Label 20240*/ GIMT_Encode4(1438626), // Rule ID 6628 //
     /* 1438534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1438545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1438548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1438551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438584 */     // MIs[1] Operand 1
     /* 1438584 */     // No operand predicates
     /* 1438584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438588 */     // MIs[0] policy
     /* 1438588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438600 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1438603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438622 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438625 */     // GIR_Coverage, 6628,
     /* 1438625 */     GIR_EraseRootFromParent_Done,
     /* 1438626 */   // Label 20240: @1438626
     /* 1438626 */   GIM_Try, /*On fail goto*//*Label 20241*/ GIMT_Encode4(1438723), // Rule ID 6629 //
     /* 1438631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1438642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1438645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1438648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1438654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438677 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438681 */     // MIs[1] Operand 1
     /* 1438681 */     // No operand predicates
     /* 1438681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438685 */     // MIs[0] policy
     /* 1438685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1438700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438706 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438722 */     // GIR_Coverage, 6629,
     /* 1438722 */     GIR_EraseRootFromParent_Done,
     /* 1438723 */   // Label 20241: @1438723
     /* 1438723 */   GIM_Try, /*On fail goto*//*Label 20242*/ GIMT_Encode4(1438820), // Rule ID 6632 //
     /* 1438728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1438739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1438742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1438745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438778 */     // MIs[1] Operand 1
     /* 1438778 */     // No operand predicates
     /* 1438778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438782 */     // MIs[0] policy
     /* 1438782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438794 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1438797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438816 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438819 */     // GIR_Coverage, 6632,
     /* 1438819 */     GIR_EraseRootFromParent_Done,
     /* 1438820 */   // Label 20242: @1438820
     /* 1438820 */   GIM_Try, /*On fail goto*//*Label 20243*/ GIMT_Encode4(1438917), // Rule ID 6633 //
     /* 1438825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1438828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1438836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1438839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1438842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1438845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1438848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1438851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438871 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438875 */     // MIs[1] Operand 1
     /* 1438875 */     // No operand predicates
     /* 1438875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438879 */     // MIs[0] policy
     /* 1438879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438891 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1438891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1438894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438900 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1438903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1438905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1438910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1438913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1438915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1438916 */     // GIR_Coverage, 6633,
     /* 1438916 */     GIR_EraseRootFromParent_Done,
     /* 1438917 */   // Label 20243: @1438917
     /* 1438917 */   GIM_Try, /*On fail goto*//*Label 20244*/ GIMT_Encode4(1439014), // Rule ID 6636 //
     /* 1438922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1438925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1438930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1438933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1438936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1438939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1438942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1438945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1438948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1438952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1438960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1438964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1438968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1438972 */     // MIs[1] Operand 1
     /* 1438972 */     // No operand predicates
     /* 1438972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1438976 */     // MIs[0] policy
     /* 1438976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1438979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1438981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1438988 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1438988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1438991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1438993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1438995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1438997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439010 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439013 */     // GIR_Coverage, 6636,
     /* 1439013 */     GIR_EraseRootFromParent_Done,
     /* 1439014 */   // Label 20244: @1439014
     /* 1439014 */   GIM_Try, /*On fail goto*//*Label 20245*/ GIMT_Encode4(1439111), // Rule ID 6637 //
     /* 1439019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1439030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1439033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1439036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439065 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439069 */     // MIs[1] Operand 1
     /* 1439069 */     // No operand predicates
     /* 1439069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439073 */     // MIs[0] policy
     /* 1439073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439085 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF4_MASK),
     /* 1439088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439110 */     // GIR_Coverage, 6637,
     /* 1439110 */     GIR_EraseRootFromParent_Done,
     /* 1439111 */   // Label 20245: @1439111
     /* 1439111 */   GIM_Try, /*On fail goto*//*Label 20246*/ GIMT_Encode4(1439208), // Rule ID 6640 //
     /* 1439116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1439127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1439130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1439133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439166 */     // MIs[1] Operand 1
     /* 1439166 */     // No operand predicates
     /* 1439166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439170 */     // MIs[0] policy
     /* 1439170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439182 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1439185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439204 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439207 */     // GIR_Coverage, 6640,
     /* 1439207 */     GIR_EraseRootFromParent_Done,
     /* 1439208 */   // Label 20246: @1439208
     /* 1439208 */   GIM_Try, /*On fail goto*//*Label 20247*/ GIMT_Encode4(1439305), // Rule ID 6641 //
     /* 1439213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1439224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1439227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1439230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439263 */     // MIs[1] Operand 1
     /* 1439263 */     // No operand predicates
     /* 1439263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439267 */     // MIs[0] policy
     /* 1439267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439279 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1439282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439304 */     // GIR_Coverage, 6641,
     /* 1439304 */     GIR_EraseRootFromParent_Done,
     /* 1439305 */   // Label 20247: @1439305
     /* 1439305 */   GIM_Try, /*On fail goto*//*Label 20248*/ GIMT_Encode4(1439402), // Rule ID 6644 //
     /* 1439310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1439321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1439324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1439327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439360 */     // MIs[1] Operand 1
     /* 1439360 */     // No operand predicates
     /* 1439360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439364 */     // MIs[0] policy
     /* 1439364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1439379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439398 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439401 */     // GIR_Coverage, 6644,
     /* 1439401 */     GIR_EraseRootFromParent_Done,
     /* 1439402 */   // Label 20248: @1439402
     /* 1439402 */   GIM_Try, /*On fail goto*//*Label 20249*/ GIMT_Encode4(1439499), // Rule ID 6645 //
     /* 1439407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1439418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1439421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1439424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1439430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439453 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439457 */     // MIs[1] Operand 1
     /* 1439457 */     // No operand predicates
     /* 1439457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439461 */     // MIs[0] policy
     /* 1439461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439473 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_MF2_MASK),
     /* 1439476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439482 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439498 */     // GIR_Coverage, 6645,
     /* 1439498 */     GIR_EraseRootFromParent_Done,
     /* 1439499 */   // Label 20249: @1439499
     /* 1439499 */   GIM_Try, /*On fail goto*//*Label 20250*/ GIMT_Encode4(1439596), // Rule ID 6648 //
     /* 1439504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1439515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1439518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1439521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439550 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439554 */     // MIs[1] Operand 1
     /* 1439554 */     // No operand predicates
     /* 1439554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439558 */     // MIs[0] policy
     /* 1439558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439570 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1439573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439592 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439595 */     // GIR_Coverage, 6648,
     /* 1439595 */     GIR_EraseRootFromParent_Done,
     /* 1439596 */   // Label 20250: @1439596
     /* 1439596 */   GIM_Try, /*On fail goto*//*Label 20251*/ GIMT_Encode4(1439693), // Rule ID 6649 //
     /* 1439601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1439612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1439615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1439618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1439624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439647 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439651 */     // MIs[1] Operand 1
     /* 1439651 */     // No operand predicates
     /* 1439651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439655 */     // MIs[0] policy
     /* 1439655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439667 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1439670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1439689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439692 */     // GIR_Coverage, 6649,
     /* 1439692 */     GIR_EraseRootFromParent_Done,
     /* 1439693 */   // Label 20251: @1439693
     /* 1439693 */   GIM_Try, /*On fail goto*//*Label 20252*/ GIMT_Encode4(1439790), // Rule ID 6652 //
     /* 1439698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1439709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1439712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1439715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439748 */     // MIs[1] Operand 1
     /* 1439748 */     // No operand predicates
     /* 1439748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439752 */     // MIs[0] policy
     /* 1439752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1439767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439786 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439788 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439789 */     // GIR_Coverage, 6652,
     /* 1439789 */     GIR_EraseRootFromParent_Done,
     /* 1439790 */   // Label 20252: @1439790
     /* 1439790 */   GIM_Try, /*On fail goto*//*Label 20253*/ GIMT_Encode4(1439887), // Rule ID 6653 //
     /* 1439795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1439806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1439809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1439812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1439815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1439818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1439821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439845 */     // MIs[1] Operand 1
     /* 1439845 */     // No operand predicates
     /* 1439845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439849 */     // MIs[0] policy
     /* 1439849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439861 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1439861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1439864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439870 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1439883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439886 */     // GIR_Coverage, 6653,
     /* 1439886 */     GIR_EraseRootFromParent_Done,
     /* 1439887 */   // Label 20253: @1439887
     /* 1439887 */   GIM_Try, /*On fail goto*//*Label 20254*/ GIMT_Encode4(1439984), // Rule ID 6656 //
     /* 1439892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1439895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1439903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1439906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1439909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1439912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1439915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1439918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1439922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1439930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1439934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1439938 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1439942 */     // MIs[1] Operand 1
     /* 1439942 */     // No operand predicates
     /* 1439942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1439946 */     // MIs[0] policy
     /* 1439946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1439949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1439951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1439958 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1439958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1439961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1439963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1439965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1439967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1439970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1439972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1439977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1439980 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1439982 */     GIR_RootConstrainSelectedInstOperands,
     /* 1439983 */     // GIR_Coverage, 6656,
     /* 1439983 */     GIR_EraseRootFromParent_Done,
     /* 1439984 */   // Label 20254: @1439984
     /* 1439984 */   GIM_Try, /*On fail goto*//*Label 20255*/ GIMT_Encode4(1440081), // Rule ID 6657 //
     /* 1439989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1439992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1439997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1440000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1440003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1440006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1440012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440039 */     // MIs[1] Operand 1
     /* 1440039 */     // No operand predicates
     /* 1440039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440043 */     // MIs[0] policy
     /* 1440043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440055 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1440058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1440077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440080 */     // GIR_Coverage, 6657,
     /* 1440080 */     GIR_EraseRootFromParent_Done,
     /* 1440081 */   // Label 20255: @1440081
     /* 1440081 */   GIM_Try, /*On fail goto*//*Label 20256*/ GIMT_Encode4(1440178), // Rule ID 6660 //
     /* 1440086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1440089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1440097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1440100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1440103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440136 */     // MIs[1] Operand 1
     /* 1440136 */     // No operand predicates
     /* 1440136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440140 */     // MIs[0] policy
     /* 1440140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440152 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1440155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440176 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440177 */     // GIR_Coverage, 6660,
     /* 1440177 */     GIR_EraseRootFromParent_Done,
     /* 1440178 */   // Label 20256: @1440178
     /* 1440178 */   GIM_Try, /*On fail goto*//*Label 20257*/ GIMT_Encode4(1440275), // Rule ID 6661 //
     /* 1440183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1440186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1440194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1440197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1440200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1440206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1440213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1440221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440229 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440233 */     // MIs[1] Operand 1
     /* 1440233 */     // No operand predicates
     /* 1440233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440237 */     // MIs[0] policy
     /* 1440237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440249 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M1_MASK),
     /* 1440252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1440271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440274 */     // GIR_Coverage, 6661,
     /* 1440274 */     GIR_EraseRootFromParent_Done,
     /* 1440275 */   // Label 20257: @1440275
     /* 1440275 */   GIM_Try, /*On fail goto*//*Label 20258*/ GIMT_Encode4(1440372), // Rule ID 6664 //
     /* 1440280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1440291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1440294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1440297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440326 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440330 */     // MIs[1] Operand 1
     /* 1440330 */     // No operand predicates
     /* 1440330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440334 */     // MIs[0] policy
     /* 1440334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1440349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440370 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440371 */     // GIR_Coverage, 6664,
     /* 1440371 */     GIR_EraseRootFromParent_Done,
     /* 1440372 */   // Label 20258: @1440372
     /* 1440372 */   GIM_Try, /*On fail goto*//*Label 20259*/ GIMT_Encode4(1440469), // Rule ID 6665 //
     /* 1440377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1440388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1440391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1440394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1440400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440423 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440427 */     // MIs[1] Operand 1
     /* 1440427 */     // No operand predicates
     /* 1440427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440431 */     // MIs[0] policy
     /* 1440431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440443 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1440446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440448 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440468 */     // GIR_Coverage, 6665,
     /* 1440468 */     GIR_EraseRootFromParent_Done,
     /* 1440469 */   // Label 20259: @1440469
     /* 1440469 */   GIM_Try, /*On fail goto*//*Label 20260*/ GIMT_Encode4(1440566), // Rule ID 6668 //
     /* 1440474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1440485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1440488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1440491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1440497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440524 */     // MIs[1] Operand 1
     /* 1440524 */     // No operand predicates
     /* 1440524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440528 */     // MIs[0] policy
     /* 1440528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440540 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1440543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440564 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440565 */     // GIR_Coverage, 6668,
     /* 1440565 */     GIR_EraseRootFromParent_Done,
     /* 1440566 */   // Label 20260: @1440566
     /* 1440566 */   GIM_Try, /*On fail goto*//*Label 20261*/ GIMT_Encode4(1440663), // Rule ID 6669 //
     /* 1440571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1440582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1440585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1440588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1440594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1440601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1440609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440621 */     // MIs[1] Operand 1
     /* 1440621 */     // No operand predicates
     /* 1440621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440625 */     // MIs[0] policy
     /* 1440625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440637 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1440640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440662 */     // GIR_Coverage, 6669,
     /* 1440662 */     GIR_EraseRootFromParent_Done,
     /* 1440663 */   // Label 20261: @1440663
     /* 1440663 */   GIM_Try, /*On fail goto*//*Label 20262*/ GIMT_Encode4(1440760), // Rule ID 6672 //
     /* 1440668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1440679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1440682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1440685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1440691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440718 */     // MIs[1] Operand 1
     /* 1440718 */     // No operand predicates
     /* 1440718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440722 */     // MIs[0] policy
     /* 1440722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440734 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1440737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440743 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440758 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440759 */     // GIR_Coverage, 6672,
     /* 1440759 */     GIR_EraseRootFromParent_Done,
     /* 1440760 */   // Label 20262: @1440760
     /* 1440760 */   GIM_Try, /*On fail goto*//*Label 20263*/ GIMT_Encode4(1440857), // Rule ID 6673 //
     /* 1440765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1440776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1440779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1440782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1440788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1440795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1440803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440811 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440815 */     // MIs[1] Operand 1
     /* 1440815 */     // No operand predicates
     /* 1440815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440819 */     // MIs[0] policy
     /* 1440819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440831 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1440831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1440834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1440853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440856 */     // GIR_Coverage, 6673,
     /* 1440856 */     GIR_EraseRootFromParent_Done,
     /* 1440857 */   // Label 20263: @1440857
     /* 1440857 */   GIM_Try, /*On fail goto*//*Label 20264*/ GIMT_Encode4(1440954), // Rule ID 6676 //
     /* 1440862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1440865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1440873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1440876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1440879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1440882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1440888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1440904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1440908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1440912 */     // MIs[1] Operand 1
     /* 1440912 */     // No operand predicates
     /* 1440912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1440916 */     // MIs[0] policy
     /* 1440916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1440919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1440921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1440928 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1440928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1440931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1440933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1440935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1440937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1440940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1440942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1440947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1440950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1440952 */     GIR_RootConstrainSelectedInstOperands,
     /* 1440953 */     // GIR_Coverage, 6676,
     /* 1440953 */     GIR_EraseRootFromParent_Done,
     /* 1440954 */   // Label 20264: @1440954
     /* 1440954 */   GIM_Try, /*On fail goto*//*Label 20265*/ GIMT_Encode4(1441051), // Rule ID 6677 //
     /* 1440959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1440962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1440967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1440970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1440973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1440976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1440979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1440982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1440985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1440989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1440997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441009 */     // MIs[1] Operand 1
     /* 1441009 */     // No operand predicates
     /* 1441009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441013 */     // MIs[0] policy
     /* 1441013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1441028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441050 */     // GIR_Coverage, 6677,
     /* 1441050 */     GIR_EraseRootFromParent_Done,
     /* 1441051 */   // Label 20265: @1441051
     /* 1441051 */   GIM_Try, /*On fail goto*//*Label 20266*/ GIMT_Encode4(1441148), // Rule ID 6680 //
     /* 1441056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1441067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1441070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1441073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441102 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441106 */     // MIs[1] Operand 1
     /* 1441106 */     // No operand predicates
     /* 1441106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441110 */     // MIs[0] policy
     /* 1441110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441113 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441122 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1441125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441146 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441147 */     // GIR_Coverage, 6680,
     /* 1441147 */     GIR_EraseRootFromParent_Done,
     /* 1441148 */   // Label 20266: @1441148
     /* 1441148 */   GIM_Try, /*On fail goto*//*Label 20267*/ GIMT_Encode4(1441245), // Rule ID 6681 //
     /* 1441153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1441164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1441167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1441170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441199 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441203 */     // MIs[1] Operand 1
     /* 1441203 */     // No operand predicates
     /* 1441203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441207 */     // MIs[0] policy
     /* 1441207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441219 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1441222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441244 */     // GIR_Coverage, 6681,
     /* 1441244 */     GIR_EraseRootFromParent_Done,
     /* 1441245 */   // Label 20267: @1441245
     /* 1441245 */   GIM_Try, /*On fail goto*//*Label 20268*/ GIMT_Encode4(1441342), // Rule ID 6684 //
     /* 1441250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1441261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1441264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1441267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1441273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441300 */     // MIs[1] Operand 1
     /* 1441300 */     // No operand predicates
     /* 1441300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441304 */     // MIs[0] policy
     /* 1441304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441316 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1441319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441338 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441340 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441341 */     // GIR_Coverage, 6684,
     /* 1441341 */     GIR_EraseRootFromParent_Done,
     /* 1441342 */   // Label 20268: @1441342
     /* 1441342 */   GIM_Try, /*On fail goto*//*Label 20269*/ GIMT_Encode4(1441439), // Rule ID 6685 //
     /* 1441347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1441358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1441361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1441364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1441370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441397 */     // MIs[1] Operand 1
     /* 1441397 */     // No operand predicates
     /* 1441397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441401 */     // MIs[0] policy
     /* 1441401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441413 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1441416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1441435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441438 */     // GIR_Coverage, 6685,
     /* 1441438 */     GIR_EraseRootFromParent_Done,
     /* 1441439 */   // Label 20269: @1441439
     /* 1441439 */   GIM_Try, /*On fail goto*//*Label 20270*/ GIMT_Encode4(1441536), // Rule ID 6688 //
     /* 1441444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1441455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1441458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1441474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441490 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441494 */     // MIs[1] Operand 1
     /* 1441494 */     // No operand predicates
     /* 1441494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441498 */     // MIs[0] policy
     /* 1441498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441510 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1441513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441532 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441534 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441535 */     // GIR_Coverage, 6688,
     /* 1441535 */     GIR_EraseRootFromParent_Done,
     /* 1441536 */   // Label 20270: @1441536
     /* 1441536 */   GIM_Try, /*On fail goto*//*Label 20271*/ GIMT_Encode4(1441633), // Rule ID 6689 //
     /* 1441541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1441552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1441555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1441558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1441564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1441571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1441579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441587 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441591 */     // MIs[1] Operand 1
     /* 1441591 */     // No operand predicates
     /* 1441591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441595 */     // MIs[0] policy
     /* 1441595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441607 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1441610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441632 */     // GIR_Coverage, 6689,
     /* 1441632 */     GIR_EraseRootFromParent_Done,
     /* 1441633 */   // Label 20271: @1441633
     /* 1441633 */   GIM_Try, /*On fail goto*//*Label 20272*/ GIMT_Encode4(1441730), // Rule ID 6692 //
     /* 1441638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1441649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1441652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441684 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441688 */     // MIs[1] Operand 1
     /* 1441688 */     // No operand predicates
     /* 1441688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441692 */     // MIs[0] policy
     /* 1441692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1441707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441726 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441728 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441729 */     // GIR_Coverage, 6692,
     /* 1441729 */     GIR_EraseRootFromParent_Done,
     /* 1441730 */   // Label 20272: @1441730
     /* 1441730 */   GIM_Try, /*On fail goto*//*Label 20273*/ GIMT_Encode4(1441827), // Rule ID 6693 //
     /* 1441735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1441746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1441749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1441752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1441758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1441765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1441773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441785 */     // MIs[1] Operand 1
     /* 1441785 */     // No operand predicates
     /* 1441785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441789 */     // MIs[0] policy
     /* 1441789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441801 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1441804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441826 */     // GIR_Coverage, 6693,
     /* 1441826 */     GIR_EraseRootFromParent_Done,
     /* 1441827 */   // Label 20273: @1441827
     /* 1441827 */   GIM_Try, /*On fail goto*//*Label 20274*/ GIMT_Encode4(1441924), // Rule ID 6696 //
     /* 1441832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1441835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1441843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1441846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1441849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1441852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1441858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441878 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441882 */     // MIs[1] Operand 1
     /* 1441882 */     // No operand predicates
     /* 1441882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441886 */     // MIs[0] policy
     /* 1441886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441898 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1441898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1441901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1441903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1441905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1441907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1441910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1441912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1441917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1441920 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1441922 */     GIR_RootConstrainSelectedInstOperands,
     /* 1441923 */     // GIR_Coverage, 6696,
     /* 1441923 */     GIR_EraseRootFromParent_Done,
     /* 1441924 */   // Label 20274: @1441924
     /* 1441924 */   GIM_Try, /*On fail goto*//*Label 20275*/ GIMT_Encode4(1442021), // Rule ID 6697 //
     /* 1441929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1441932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1441937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1441940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1441943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1441946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1441949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1441952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1441955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1441959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1441967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1441971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1441975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1441979 */     // MIs[1] Operand 1
     /* 1441979 */     // No operand predicates
     /* 1441979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1441983 */     // MIs[0] policy
     /* 1441983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1441986 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1441988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1441995 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1441995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1441998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1442017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442020 */     // GIR_Coverage, 6697,
     /* 1442020 */     GIR_EraseRootFromParent_Done,
     /* 1442021 */   // Label 20275: @1442021
     /* 1442021 */   GIM_Try, /*On fail goto*//*Label 20276*/ GIMT_Encode4(1442118), // Rule ID 6700 //
     /* 1442026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1442043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442076 */     // MIs[1] Operand 1
     /* 1442076 */     // No operand predicates
     /* 1442076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442080 */     // MIs[0] policy
     /* 1442080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1442095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442114 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442117 */     // GIR_Coverage, 6700,
     /* 1442117 */     GIR_EraseRootFromParent_Done,
     /* 1442118 */   // Label 20276: @1442118
     /* 1442118 */   GIM_Try, /*On fail goto*//*Label 20277*/ GIMT_Encode4(1442215), // Rule ID 6701 //
     /* 1442123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1442134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1442137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1442140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1442153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1442161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442173 */     // MIs[1] Operand 1
     /* 1442173 */     // No operand predicates
     /* 1442173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442177 */     // MIs[0] policy
     /* 1442177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442189 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M2_MASK),
     /* 1442192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442214 */     // GIR_Coverage, 6701,
     /* 1442214 */     GIR_EraseRootFromParent_Done,
     /* 1442215 */   // Label 20277: @1442215
     /* 1442215 */   GIM_Try, /*On fail goto*//*Label 20278*/ GIMT_Encode4(1442312), // Rule ID 6704 //
     /* 1442220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1442237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442266 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442270 */     // MIs[1] Operand 1
     /* 1442270 */     // No operand predicates
     /* 1442270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442274 */     // MIs[0] policy
     /* 1442274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442286 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1442289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442295 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442308 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442311 */     // GIR_Coverage, 6704,
     /* 1442311 */     GIR_EraseRootFromParent_Done,
     /* 1442312 */   // Label 20278: @1442312
     /* 1442312 */   GIM_Try, /*On fail goto*//*Label 20279*/ GIMT_Encode4(1442409), // Rule ID 6705 //
     /* 1442317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1442328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1442331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1442334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1442340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1442347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1442355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442363 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442367 */     // MIs[1] Operand 1
     /* 1442367 */     // No operand predicates
     /* 1442367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442371 */     // MIs[0] policy
     /* 1442371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442383 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M4_MASK),
     /* 1442386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442408 */     // GIR_Coverage, 6705,
     /* 1442408 */     GIR_EraseRootFromParent_Done,
     /* 1442409 */   // Label 20279: @1442409
     /* 1442409 */   GIM_Try, /*On fail goto*//*Label 20280*/ GIMT_Encode4(1442506), // Rule ID 6708 //
     /* 1442414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1442417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1442425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1442428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1442431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442460 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442464 */     // MIs[1] Operand 1
     /* 1442464 */     // No operand predicates
     /* 1442464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442468 */     // MIs[0] policy
     /* 1442468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1442483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442502 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442505 */     // GIR_Coverage, 6708,
     /* 1442505 */     GIR_EraseRootFromParent_Done,
     /* 1442506 */   // Label 20280: @1442506
     /* 1442506 */   GIM_Try, /*On fail goto*//*Label 20281*/ GIMT_Encode4(1442603), // Rule ID 6709 //
     /* 1442511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1442514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1442519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1442522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1442525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1442528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1442534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1442541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1442549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442561 */     // MIs[1] Operand 1
     /* 1442561 */     // No operand predicates
     /* 1442561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442565 */     // MIs[0] policy
     /* 1442565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442577 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VI_M8_MASK),
     /* 1442580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1442599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442602 */     // GIR_Coverage, 6709,
     /* 1442602 */     GIR_EraseRootFromParent_Done,
     /* 1442603 */   // Label 20281: @1442603
     /* 1442603 */   GIM_Try, /*On fail goto*//*Label 20282*/ GIMT_Encode4(1442700), // Rule ID 6888 //
     /* 1442608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1442616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1442619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1442622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1442625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442654 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442658 */     // MIs[1] Operand 1
     /* 1442658 */     // No operand predicates
     /* 1442658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442662 */     // MIs[0] policy
     /* 1442662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442674 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1442677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442696 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442699 */     // GIR_Coverage, 6888,
     /* 1442699 */     GIR_EraseRootFromParent_Done,
     /* 1442700 */   // Label 20282: @1442700
     /* 1442700 */   GIM_Try, /*On fail goto*//*Label 20283*/ GIMT_Encode4(1442797), // Rule ID 6889 //
     /* 1442705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1442713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1442716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1442719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1442722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1442728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442751 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442755 */     // MIs[1] Operand 1
     /* 1442755 */     // No operand predicates
     /* 1442755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442759 */     // MIs[0] policy
     /* 1442759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442771 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF8_MASK),
     /* 1442774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442796 */     // GIR_Coverage, 6889,
     /* 1442796 */     GIR_EraseRootFromParent_Done,
     /* 1442797 */   // Label 20283: @1442797
     /* 1442797 */   GIM_Try, /*On fail goto*//*Label 20284*/ GIMT_Encode4(1442894), // Rule ID 6892 //
     /* 1442802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1442810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1442813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1442816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1442819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1442822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1442828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442848 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442852 */     // MIs[1] Operand 1
     /* 1442852 */     // No operand predicates
     /* 1442852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442856 */     // MIs[0] policy
     /* 1442856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442868 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1442868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1442871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442890 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442893 */     // GIR_Coverage, 6892,
     /* 1442893 */     GIR_EraseRootFromParent_Done,
     /* 1442894 */   // Label 20284: @1442894
     /* 1442894 */   GIM_Try, /*On fail goto*//*Label 20285*/ GIMT_Encode4(1442991), // Rule ID 6893 //
     /* 1442899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1442902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1442907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1442910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1442913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1442916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1442919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1442922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1442925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1442929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1442937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1442941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1442945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1442949 */     // MIs[1] Operand 1
     /* 1442949 */     // No operand predicates
     /* 1442949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1442953 */     // MIs[0] policy
     /* 1442953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1442956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1442958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1442965 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1442965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1442968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1442970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1442972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1442974 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1442977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1442979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1442984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1442987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1442989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1442990 */     // GIR_Coverage, 6893,
     /* 1442990 */     GIR_EraseRootFromParent_Done,
     /* 1442991 */   // Label 20285: @1442991
     /* 1442991 */   GIM_Try, /*On fail goto*//*Label 20286*/ GIMT_Encode4(1443088), // Rule ID 6896 //
     /* 1442996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1442999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1443007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1443010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1443013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443042 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443046 */     // MIs[1] Operand 1
     /* 1443046 */     // No operand predicates
     /* 1443046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443050 */     // MIs[0] policy
     /* 1443050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443062 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443071 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443084 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443087 */     // GIR_Coverage, 6896,
     /* 1443087 */     GIR_EraseRootFromParent_Done,
     /* 1443088 */   // Label 20286: @1443088
     /* 1443088 */   GIM_Try, /*On fail goto*//*Label 20287*/ GIMT_Encode4(1443185), // Rule ID 6897 //
     /* 1443093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1443104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1443107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1443110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443143 */     // MIs[1] Operand 1
     /* 1443143 */     // No operand predicates
     /* 1443143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443147 */     // MIs[0] policy
     /* 1443147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443159 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443168 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443184 */     // GIR_Coverage, 6897,
     /* 1443184 */     GIR_EraseRootFromParent_Done,
     /* 1443185 */   // Label 20287: @1443185
     /* 1443185 */   GIM_Try, /*On fail goto*//*Label 20288*/ GIMT_Encode4(1443282), // Rule ID 6900 //
     /* 1443190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1443201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1443204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443236 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443240 */     // MIs[1] Operand 1
     /* 1443240 */     // No operand predicates
     /* 1443240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443244 */     // MIs[0] policy
     /* 1443244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443256 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1443259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443265 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443278 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443281 */     // GIR_Coverage, 6900,
     /* 1443281 */     GIR_EraseRootFromParent_Done,
     /* 1443282 */   // Label 20288: @1443282
     /* 1443282 */   GIM_Try, /*On fail goto*//*Label 20289*/ GIMT_Encode4(1443379), // Rule ID 6901 //
     /* 1443287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1443298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1443301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1443304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443337 */     // MIs[1] Operand 1
     /* 1443337 */     // No operand predicates
     /* 1443337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443341 */     // MIs[0] policy
     /* 1443341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443353 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF4_MASK),
     /* 1443356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443378 */     // GIR_Coverage, 6901,
     /* 1443378 */     GIR_EraseRootFromParent_Done,
     /* 1443379 */   // Label 20289: @1443379
     /* 1443379 */   GIM_Try, /*On fail goto*//*Label 20290*/ GIMT_Encode4(1443476), // Rule ID 6904 //
     /* 1443384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1443395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1443398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443430 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443434 */     // MIs[1] Operand 1
     /* 1443434 */     // No operand predicates
     /* 1443434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443438 */     // MIs[0] policy
     /* 1443438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443472 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443474 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443475 */     // GIR_Coverage, 6904,
     /* 1443475 */     GIR_EraseRootFromParent_Done,
     /* 1443476 */   // Label 20290: @1443476
     /* 1443476 */   GIM_Try, /*On fail goto*//*Label 20291*/ GIMT_Encode4(1443573), // Rule ID 6905 //
     /* 1443481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1443492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1443495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1443498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1443504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443527 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443531 */     // MIs[1] Operand 1
     /* 1443531 */     // No operand predicates
     /* 1443531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443535 */     // MIs[0] policy
     /* 1443535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443547 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1443569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443572 */     // GIR_Coverage, 6905,
     /* 1443572 */     GIR_EraseRootFromParent_Done,
     /* 1443573 */   // Label 20291: @1443573
     /* 1443573 */   GIM_Try, /*On fail goto*//*Label 20292*/ GIMT_Encode4(1443670), // Rule ID 6908 //
     /* 1443578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1443595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443628 */     // MIs[1] Operand 1
     /* 1443628 */     // No operand predicates
     /* 1443628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443632 */     // MIs[0] policy
     /* 1443632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443668 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443669 */     // GIR_Coverage, 6908,
     /* 1443669 */     GIR_EraseRootFromParent_Done,
     /* 1443670 */   // Label 20292: @1443670
     /* 1443670 */   GIM_Try, /*On fail goto*//*Label 20293*/ GIMT_Encode4(1443767), // Rule ID 6909 //
     /* 1443675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1443686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1443689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1443692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1443698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443725 */     // MIs[1] Operand 1
     /* 1443725 */     // No operand predicates
     /* 1443725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443729 */     // MIs[0] policy
     /* 1443729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443741 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_MF2_MASK),
     /* 1443744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1443763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443766 */     // GIR_Coverage, 6909,
     /* 1443766 */     GIR_EraseRootFromParent_Done,
     /* 1443767 */   // Label 20293: @1443767
     /* 1443767 */   GIM_Try, /*On fail goto*//*Label 20294*/ GIMT_Encode4(1443864), // Rule ID 6912 //
     /* 1443772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1443783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1443786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1443789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443818 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443822 */     // MIs[1] Operand 1
     /* 1443822 */     // No operand predicates
     /* 1443822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443826 */     // MIs[0] policy
     /* 1443826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443838 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1443838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1443841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443862 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443863 */     // GIR_Coverage, 6912,
     /* 1443863 */     GIR_EraseRootFromParent_Done,
     /* 1443864 */   // Label 20294: @1443864
     /* 1443864 */   GIM_Try, /*On fail goto*//*Label 20295*/ GIMT_Encode4(1443961), // Rule ID 6913 //
     /* 1443869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1443872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1443880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1443883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1443886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1443889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1443892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1443895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1443907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1443911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1443915 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1443919 */     // MIs[1] Operand 1
     /* 1443919 */     // No operand predicates
     /* 1443919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1443923 */     // MIs[0] policy
     /* 1443923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1443926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1443928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1443935 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1443935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1443938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1443940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1443942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1443944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1443947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1443949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1443954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1443957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1443959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1443960 */     // GIR_Coverage, 6913,
     /* 1443960 */     GIR_EraseRootFromParent_Done,
     /* 1443961 */   // Label 20295: @1443961
     /* 1443961 */   GIM_Try, /*On fail goto*//*Label 20296*/ GIMT_Encode4(1444058), // Rule ID 6916 //
     /* 1443966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1443969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1443974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1443977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1443980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1443983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1443986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1443989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1443992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1443996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444016 */     // MIs[1] Operand 1
     /* 1444016 */     // No operand predicates
     /* 1444016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444020 */     // MIs[0] policy
     /* 1444020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444032 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444056 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444057 */     // GIR_Coverage, 6916,
     /* 1444057 */     GIR_EraseRootFromParent_Done,
     /* 1444058 */   // Label 20296: @1444058
     /* 1444058 */   GIM_Try, /*On fail goto*//*Label 20297*/ GIMT_Encode4(1444155), // Rule ID 6917 //
     /* 1444063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1444074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1444077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1444080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1444086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444113 */     // MIs[1] Operand 1
     /* 1444113 */     // No operand predicates
     /* 1444113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444117 */     // MIs[0] policy
     /* 1444117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444129 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1444151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444154 */     // GIR_Coverage, 6917,
     /* 1444154 */     GIR_EraseRootFromParent_Done,
     /* 1444155 */   // Label 20297: @1444155
     /* 1444155 */   GIM_Try, /*On fail goto*//*Label 20298*/ GIMT_Encode4(1444252), // Rule ID 6920 //
     /* 1444160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444206 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444210 */     // MIs[1] Operand 1
     /* 1444210 */     // No operand predicates
     /* 1444210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444214 */     // MIs[0] policy
     /* 1444214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444226 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444250 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444251 */     // GIR_Coverage, 6920,
     /* 1444251 */     GIR_EraseRootFromParent_Done,
     /* 1444252 */   // Label 20298: @1444252
     /* 1444252 */   GIM_Try, /*On fail goto*//*Label 20299*/ GIMT_Encode4(1444349), // Rule ID 6921 //
     /* 1444257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1444268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1444271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1444274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1444280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444303 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444307 */     // MIs[1] Operand 1
     /* 1444307 */     // No operand predicates
     /* 1444307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444311 */     // MIs[0] policy
     /* 1444311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444323 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1444345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444348 */     // GIR_Coverage, 6921,
     /* 1444348 */     GIR_EraseRootFromParent_Done,
     /* 1444349 */   // Label 20299: @1444349
     /* 1444349 */   GIM_Try, /*On fail goto*//*Label 20300*/ GIMT_Encode4(1444446), // Rule ID 6924 //
     /* 1444354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1444357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1444371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444400 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444404 */     // MIs[1] Operand 1
     /* 1444404 */     // No operand predicates
     /* 1444404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444408 */     // MIs[0] policy
     /* 1444408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444420 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444444 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444445 */     // GIR_Coverage, 6924,
     /* 1444445 */     GIR_EraseRootFromParent_Done,
     /* 1444446 */   // Label 20300: @1444446
     /* 1444446 */   GIM_Try, /*On fail goto*//*Label 20301*/ GIMT_Encode4(1444543), // Rule ID 6925 //
     /* 1444451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1444454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1444462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1444465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1444468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1444474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1444481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1444489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444501 */     // MIs[1] Operand 1
     /* 1444501 */     // No operand predicates
     /* 1444501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444505 */     // MIs[0] policy
     /* 1444505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444517 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M1_MASK),
     /* 1444520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1444539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444542 */     // GIR_Coverage, 6925,
     /* 1444542 */     GIR_EraseRootFromParent_Done,
     /* 1444543 */   // Label 20301: @1444543
     /* 1444543 */   GIM_Try, /*On fail goto*//*Label 20302*/ GIMT_Encode4(1444640), // Rule ID 6928 //
     /* 1444548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1444559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1444562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1444565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444594 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444598 */     // MIs[1] Operand 1
     /* 1444598 */     // No operand predicates
     /* 1444598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444602 */     // MIs[0] policy
     /* 1444602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444614 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1444617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444638 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444639 */     // GIR_Coverage, 6928,
     /* 1444639 */     GIR_EraseRootFromParent_Done,
     /* 1444640 */   // Label 20302: @1444640
     /* 1444640 */   GIM_Try, /*On fail goto*//*Label 20303*/ GIMT_Encode4(1444737), // Rule ID 6929 //
     /* 1444645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1444656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1444659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1444662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1444668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1444675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1444683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444691 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444695 */     // MIs[1] Operand 1
     /* 1444695 */     // No operand predicates
     /* 1444695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444699 */     // MIs[0] policy
     /* 1444699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444711 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1444714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444736 */     // GIR_Coverage, 6929,
     /* 1444736 */     GIR_EraseRootFromParent_Done,
     /* 1444737 */   // Label 20303: @1444737
     /* 1444737 */   GIM_Try, /*On fail goto*//*Label 20304*/ GIMT_Encode4(1444834), // Rule ID 6932 //
     /* 1444742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1444753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1444756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1444759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444792 */     // MIs[1] Operand 1
     /* 1444792 */     // No operand predicates
     /* 1444792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444796 */     // MIs[0] policy
     /* 1444796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444799 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444808 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1444808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1444811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444832 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444833 */     // GIR_Coverage, 6932,
     /* 1444833 */     GIR_EraseRootFromParent_Done,
     /* 1444834 */   // Label 20304: @1444834
     /* 1444834 */   GIM_Try, /*On fail goto*//*Label 20305*/ GIMT_Encode4(1444931), // Rule ID 6933 //
     /* 1444839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1444842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1444850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1444853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1444856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1444859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1444862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1444865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1444869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1444877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444889 */     // MIs[1] Operand 1
     /* 1444889 */     // No operand predicates
     /* 1444889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444893 */     // MIs[0] policy
     /* 1444893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1444905 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1444905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1444908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1444910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1444912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1444914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1444917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1444919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1444924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1444927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1444929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1444930 */     // GIR_Coverage, 6933,
     /* 1444930 */     GIR_EraseRootFromParent_Done,
     /* 1444931 */   // Label 20305: @1444931
     /* 1444931 */   GIM_Try, /*On fail goto*//*Label 20306*/ GIMT_Encode4(1445028), // Rule ID 6936 //
     /* 1444936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1444939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1444944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1444947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1444950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1444953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1444956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1444959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1444962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1444966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1444974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1444978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1444982 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1444986 */     // MIs[1] Operand 1
     /* 1444986 */     // No operand predicates
     /* 1444986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1444990 */     // MIs[0] policy
     /* 1444990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1444993 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1444995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1445005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445024 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445026 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445027 */     // GIR_Coverage, 6936,
     /* 1445027 */     GIR_EraseRootFromParent_Done,
     /* 1445028 */   // Label 20306: @1445028
     /* 1445028 */   GIM_Try, /*On fail goto*//*Label 20307*/ GIMT_Encode4(1445125), // Rule ID 6937 //
     /* 1445033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1445044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1445047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1445050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1445056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445079 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445083 */     // MIs[1] Operand 1
     /* 1445083 */     // No operand predicates
     /* 1445083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445087 */     // MIs[0] policy
     /* 1445087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445099 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1445102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1445121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445124 */     // GIR_Coverage, 6937,
     /* 1445124 */     GIR_EraseRootFromParent_Done,
     /* 1445125 */   // Label 20307: @1445125
     /* 1445125 */   GIM_Try, /*On fail goto*//*Label 20308*/ GIMT_Encode4(1445222), // Rule ID 6940 //
     /* 1445130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1445141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1445144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1445147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445176 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445180 */     // MIs[1] Operand 1
     /* 1445180 */     // No operand predicates
     /* 1445180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445184 */     // MIs[0] policy
     /* 1445184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1445199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445218 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445220 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445221 */     // GIR_Coverage, 6940,
     /* 1445221 */     GIR_EraseRootFromParent_Done,
     /* 1445222 */   // Label 20308: @1445222
     /* 1445222 */   GIM_Try, /*On fail goto*//*Label 20309*/ GIMT_Encode4(1445319), // Rule ID 6941 //
     /* 1445227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1445238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1445241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1445244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445277 */     // MIs[1] Operand 1
     /* 1445277 */     // No operand predicates
     /* 1445277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445281 */     // MIs[0] policy
     /* 1445281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1445296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445302 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445318 */     // GIR_Coverage, 6941,
     /* 1445318 */     GIR_EraseRootFromParent_Done,
     /* 1445319 */   // Label 20309: @1445319
     /* 1445319 */   GIM_Try, /*On fail goto*//*Label 20310*/ GIMT_Encode4(1445416), // Rule ID 6944 //
     /* 1445324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1445335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1445338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1445341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1445347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445370 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445374 */     // MIs[1] Operand 1
     /* 1445374 */     // No operand predicates
     /* 1445374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445378 */     // MIs[0] policy
     /* 1445378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445390 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1445393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445412 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445414 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445415 */     // GIR_Coverage, 6944,
     /* 1445415 */     GIR_EraseRootFromParent_Done,
     /* 1445416 */   // Label 20310: @1445416
     /* 1445416 */   GIM_Try, /*On fail goto*//*Label 20311*/ GIMT_Encode4(1445513), // Rule ID 6945 //
     /* 1445421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1445432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1445435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1445438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1445444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445467 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445471 */     // MIs[1] Operand 1
     /* 1445471 */     // No operand predicates
     /* 1445471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445475 */     // MIs[0] policy
     /* 1445475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445487 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1445490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445512 */     // GIR_Coverage, 6945,
     /* 1445512 */     GIR_EraseRootFromParent_Done,
     /* 1445513 */   // Label 20311: @1445513
     /* 1445513 */   GIM_Try, /*On fail goto*//*Label 20312*/ GIMT_Encode4(1445610), // Rule ID 6948 //
     /* 1445518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1445529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1445532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1445535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1445541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445564 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445568 */     // MIs[1] Operand 1
     /* 1445568 */     // No operand predicates
     /* 1445568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445572 */     // MIs[0] policy
     /* 1445572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445584 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1445587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445606 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445608 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445609 */     // GIR_Coverage, 6948,
     /* 1445609 */     GIR_EraseRootFromParent_Done,
     /* 1445610 */   // Label 20312: @1445610
     /* 1445610 */   GIM_Try, /*On fail goto*//*Label 20313*/ GIMT_Encode4(1445707), // Rule ID 6949 //
     /* 1445615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1445626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1445629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1445632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1445638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1445645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1445653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445665 */     // MIs[1] Operand 1
     /* 1445665 */     // No operand predicates
     /* 1445665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445669 */     // MIs[0] policy
     /* 1445669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445681 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1445684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1445703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445706 */     // GIR_Coverage, 6949,
     /* 1445706 */     GIR_EraseRootFromParent_Done,
     /* 1445707 */   // Label 20313: @1445707
     /* 1445707 */   GIM_Try, /*On fail goto*//*Label 20314*/ GIMT_Encode4(1445804), // Rule ID 6952 //
     /* 1445712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1445729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445758 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445762 */     // MIs[1] Operand 1
     /* 1445762 */     // No operand predicates
     /* 1445762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445766 */     // MIs[0] policy
     /* 1445766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1445781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445800 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445803 */     // GIR_Coverage, 6952,
     /* 1445803 */     GIR_EraseRootFromParent_Done,
     /* 1445804 */   // Label 20314: @1445804
     /* 1445804 */   GIM_Try, /*On fail goto*//*Label 20315*/ GIMT_Encode4(1445901), // Rule ID 6953 //
     /* 1445809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1445812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1445820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1445823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1445826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1445829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1445832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1445835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1445839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1445847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445855 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445859 */     // MIs[1] Operand 1
     /* 1445859 */     // No operand predicates
     /* 1445859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445863 */     // MIs[0] policy
     /* 1445863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1445875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1445878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445900 */     // GIR_Coverage, 6953,
     /* 1445900 */     GIR_EraseRootFromParent_Done,
     /* 1445901 */   // Label 20315: @1445901
     /* 1445901 */   GIM_Try, /*On fail goto*//*Label 20316*/ GIMT_Encode4(1445998), // Rule ID 6956 //
     /* 1445906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1445909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1445914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1445917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1445920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1445923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1445926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1445929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1445932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1445936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1445944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1445948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1445952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1445956 */     // MIs[1] Operand 1
     /* 1445956 */     // No operand predicates
     /* 1445956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1445960 */     // MIs[0] policy
     /* 1445960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1445963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1445965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1445972 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1445972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1445975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1445977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1445979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1445981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1445984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1445986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1445991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1445994 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1445996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1445997 */     // GIR_Coverage, 6956,
     /* 1445997 */     GIR_EraseRootFromParent_Done,
     /* 1445998 */   // Label 20316: @1445998
     /* 1445998 */   GIM_Try, /*On fail goto*//*Label 20317*/ GIMT_Encode4(1446095), // Rule ID 6957 //
     /* 1446003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1446014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1446017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1446020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446053 */     // MIs[1] Operand 1
     /* 1446053 */     // No operand predicates
     /* 1446053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446057 */     // MIs[0] policy
     /* 1446057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446069 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1446072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446094 */     // GIR_Coverage, 6957,
     /* 1446094 */     GIR_EraseRootFromParent_Done,
     /* 1446095 */   // Label 20317: @1446095
     /* 1446095 */   GIM_Try, /*On fail goto*//*Label 20318*/ GIMT_Encode4(1446192), // Rule ID 6960 //
     /* 1446100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1446117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446150 */     // MIs[1] Operand 1
     /* 1446150 */     // No operand predicates
     /* 1446150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446154 */     // MIs[0] policy
     /* 1446154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1446169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446188 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446191 */     // GIR_Coverage, 6960,
     /* 1446191 */     GIR_EraseRootFromParent_Done,
     /* 1446192 */   // Label 20318: @1446192
     /* 1446192 */   GIM_Try, /*On fail goto*//*Label 20319*/ GIMT_Encode4(1446289), // Rule ID 6961 //
     /* 1446197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1446208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1446211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1446214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1446220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446247 */     // MIs[1] Operand 1
     /* 1446247 */     // No operand predicates
     /* 1446247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446251 */     // MIs[0] policy
     /* 1446251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446263 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1446266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1446285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446288 */     // GIR_Coverage, 6961,
     /* 1446288 */     GIR_EraseRootFromParent_Done,
     /* 1446289 */   // Label 20319: @1446289
     /* 1446289 */   GIM_Try, /*On fail goto*//*Label 20320*/ GIMT_Encode4(1446386), // Rule ID 6964 //
     /* 1446294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1446305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1446308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1446311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446344 */     // MIs[1] Operand 1
     /* 1446344 */     // No operand predicates
     /* 1446344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446348 */     // MIs[0] policy
     /* 1446348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446351 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446360 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1446363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446382 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446385 */     // GIR_Coverage, 6964,
     /* 1446385 */     GIR_EraseRootFromParent_Done,
     /* 1446386 */   // Label 20320: @1446386
     /* 1446386 */   GIM_Try, /*On fail goto*//*Label 20321*/ GIMT_Encode4(1446483), // Rule ID 6965 //
     /* 1446391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1446402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1446405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1446408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1446414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1446421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1446429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446441 */     // MIs[1] Operand 1
     /* 1446441 */     // No operand predicates
     /* 1446441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446445 */     // MIs[0] policy
     /* 1446445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446457 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M2_MASK),
     /* 1446460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446466 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446482 */     // GIR_Coverage, 6965,
     /* 1446482 */     GIR_EraseRootFromParent_Done,
     /* 1446483 */   // Label 20321: @1446483
     /* 1446483 */   GIM_Try, /*On fail goto*//*Label 20322*/ GIMT_Encode4(1446580), // Rule ID 6968 //
     /* 1446488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1446499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1446502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1446505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446534 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446538 */     // MIs[1] Operand 1
     /* 1446538 */     // No operand predicates
     /* 1446538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446542 */     // MIs[0] policy
     /* 1446542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1446557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446563 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446576 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446579 */     // GIR_Coverage, 6968,
     /* 1446579 */     GIR_EraseRootFromParent_Done,
     /* 1446580 */   // Label 20322: @1446580
     /* 1446580 */   GIM_Try, /*On fail goto*//*Label 20323*/ GIMT_Encode4(1446677), // Rule ID 6969 //
     /* 1446585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1446596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1446599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1446602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1446608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1446615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1446623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446635 */     // MIs[1] Operand 1
     /* 1446635 */     // No operand predicates
     /* 1446635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446639 */     // MIs[0] policy
     /* 1446639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446651 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M4_MASK),
     /* 1446654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446676 */     // GIR_Coverage, 6969,
     /* 1446676 */     GIR_EraseRootFromParent_Done,
     /* 1446677 */   // Label 20323: @1446677
     /* 1446677 */   GIM_Try, /*On fail goto*//*Label 20324*/ GIMT_Encode4(1446774), // Rule ID 6972 //
     /* 1446682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1446685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1446699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446732 */     // MIs[1] Operand 1
     /* 1446732 */     // No operand predicates
     /* 1446732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446736 */     // MIs[0] policy
     /* 1446736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446748 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1446751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446770 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446773 */     // GIR_Coverage, 6972,
     /* 1446773 */     GIR_EraseRootFromParent_Done,
     /* 1446774 */   // Label 20324: @1446774
     /* 1446774 */   GIM_Try, /*On fail goto*//*Label 20325*/ GIMT_Encode4(1446871), // Rule ID 6973 //
     /* 1446779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1446782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1446787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1446790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1446793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1446796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1446802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1446809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1446817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446825 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446829 */     // MIs[1] Operand 1
     /* 1446829 */     // No operand predicates
     /* 1446829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446833 */     // MIs[0] policy
     /* 1446833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446845 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1446845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VI_M8_MASK),
     /* 1446848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1446867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446870 */     // GIR_Coverage, 6973,
     /* 1446870 */     GIR_EraseRootFromParent_Done,
     /* 1446871 */   // Label 20325: @1446871
     /* 1446871 */   GIM_Try, /*On fail goto*//*Label 20326*/ GIMT_Encode4(1446968), // Rule ID 7152 //
     /* 1446876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1446879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1446884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1446887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1446890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1446893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1446896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1446902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1446906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1446914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1446918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1446922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1446926 */     // MIs[1] Operand 1
     /* 1446926 */     // No operand predicates
     /* 1446926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1446930 */     // MIs[0] policy
     /* 1446930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1446933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1446935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1446942 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1446942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1446945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1446947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1446949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1446951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1446954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1446956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1446961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1446964 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1446966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1446967 */     // GIR_Coverage, 7152,
     /* 1446967 */     GIR_EraseRootFromParent_Done,
     /* 1446968 */   // Label 20326: @1446968
     /* 1446968 */   GIM_Try, /*On fail goto*//*Label 20327*/ GIMT_Encode4(1447065), // Rule ID 7153 //
     /* 1446973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1446976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1446981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1446984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1446987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1446990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1446993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1446996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1446999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447019 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447023 */     // MIs[1] Operand 1
     /* 1447023 */     // No operand predicates
     /* 1447023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447027 */     // MIs[0] policy
     /* 1447027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447030 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447039 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF8_MASK),
     /* 1447042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447064 */     // GIR_Coverage, 7153,
     /* 1447064 */     GIR_EraseRootFromParent_Done,
     /* 1447065 */   // Label 20327: @1447065
     /* 1447065 */   GIM_Try, /*On fail goto*//*Label 20328*/ GIMT_Encode4(1447162), // Rule ID 7156 //
     /* 1447070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1447081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1447084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1447087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447120 */     // MIs[1] Operand 1
     /* 1447120 */     // No operand predicates
     /* 1447120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447124 */     // MIs[0] policy
     /* 1447124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447136 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1447139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447158 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447160 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447161 */     // GIR_Coverage, 7156,
     /* 1447161 */     GIR_EraseRootFromParent_Done,
     /* 1447162 */   // Label 20328: @1447162
     /* 1447162 */   GIM_Try, /*On fail goto*//*Label 20329*/ GIMT_Encode4(1447259), // Rule ID 7157 //
     /* 1447167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1447178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1447181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1447184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447217 */     // MIs[1] Operand 1
     /* 1447217 */     // No operand predicates
     /* 1447217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447221 */     // MIs[0] policy
     /* 1447221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447233 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1447236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447258 */     // GIR_Coverage, 7157,
     /* 1447258 */     GIR_EraseRootFromParent_Done,
     /* 1447259 */   // Label 20329: @1447259
     /* 1447259 */   GIM_Try, /*On fail goto*//*Label 20330*/ GIMT_Encode4(1447356), // Rule ID 7160 //
     /* 1447264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1447275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1447278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1447281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447314 */     // MIs[1] Operand 1
     /* 1447314 */     // No operand predicates
     /* 1447314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447318 */     // MIs[0] policy
     /* 1447318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447330 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1447333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447354 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447355 */     // GIR_Coverage, 7160,
     /* 1447355 */     GIR_EraseRootFromParent_Done,
     /* 1447356 */   // Label 20330: @1447356
     /* 1447356 */   GIM_Try, /*On fail goto*//*Label 20331*/ GIMT_Encode4(1447453), // Rule ID 7161 //
     /* 1447361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1447372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1447375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1447378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1447384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447411 */     // MIs[1] Operand 1
     /* 1447411 */     // No operand predicates
     /* 1447411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447415 */     // MIs[0] policy
     /* 1447415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447427 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1447430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1447449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447452 */     // GIR_Coverage, 7161,
     /* 1447452 */     GIR_EraseRootFromParent_Done,
     /* 1447453 */   // Label 20331: @1447453
     /* 1447453 */   GIM_Try, /*On fail goto*//*Label 20332*/ GIMT_Encode4(1447550), // Rule ID 7164 //
     /* 1447458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1447469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1447472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1447475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447504 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447508 */     // MIs[1] Operand 1
     /* 1447508 */     // No operand predicates
     /* 1447508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447512 */     // MIs[0] policy
     /* 1447512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447524 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1447527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447533 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447548 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447549 */     // GIR_Coverage, 7164,
     /* 1447549 */     GIR_EraseRootFromParent_Done,
     /* 1447550 */   // Label 20332: @1447550
     /* 1447550 */   GIM_Try, /*On fail goto*//*Label 20333*/ GIMT_Encode4(1447647), // Rule ID 7165 //
     /* 1447555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1447566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1447569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1447572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447605 */     // MIs[1] Operand 1
     /* 1447605 */     // No operand predicates
     /* 1447605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447609 */     // MIs[0] policy
     /* 1447609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447621 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF4_MASK),
     /* 1447624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447646 */     // GIR_Coverage, 7165,
     /* 1447646 */     GIR_EraseRootFromParent_Done,
     /* 1447647 */   // Label 20333: @1447647
     /* 1447647 */   GIM_Try, /*On fail goto*//*Label 20334*/ GIMT_Encode4(1447744), // Rule ID 7168 //
     /* 1447652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1447663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1447666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1447669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447690 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447694 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447698 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447702 */     // MIs[1] Operand 1
     /* 1447702 */     // No operand predicates
     /* 1447702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447706 */     // MIs[0] policy
     /* 1447706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1447721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447742 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447743 */     // GIR_Coverage, 7168,
     /* 1447743 */     GIR_EraseRootFromParent_Done,
     /* 1447744 */   // Label 20334: @1447744
     /* 1447744 */   GIM_Try, /*On fail goto*//*Label 20335*/ GIMT_Encode4(1447841), // Rule ID 7169 //
     /* 1447749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1447760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1447763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1447766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1447772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447795 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447799 */     // MIs[1] Operand 1
     /* 1447799 */     // No operand predicates
     /* 1447799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447803 */     // MIs[0] policy
     /* 1447803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447815 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1447815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1447818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1447837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447840 */     // GIR_Coverage, 7169,
     /* 1447840 */     GIR_EraseRootFromParent_Done,
     /* 1447841 */   // Label 20335: @1447841
     /* 1447841 */   GIM_Try, /*On fail goto*//*Label 20336*/ GIMT_Encode4(1447938), // Rule ID 7172 //
     /* 1447846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1447849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1447857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1447860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1447863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1447866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1447872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447892 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447896 */     // MIs[1] Operand 1
     /* 1447896 */     // No operand predicates
     /* 1447896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447900 */     // MIs[0] policy
     /* 1447900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1447903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1447905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1447912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1447912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1447915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1447917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1447919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1447921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1447924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1447926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1447931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1447934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1447936 */     GIR_RootConstrainSelectedInstOperands,
     /* 1447937 */     // GIR_Coverage, 7172,
     /* 1447937 */     GIR_EraseRootFromParent_Done,
     /* 1447938 */   // Label 20336: @1447938
     /* 1447938 */   GIM_Try, /*On fail goto*//*Label 20337*/ GIMT_Encode4(1448035), // Rule ID 7173 //
     /* 1447943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1447946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1447951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1447954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1447957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1447960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1447963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1447966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1447969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1447973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1447981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1447985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1447989 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1447993 */     // MIs[1] Operand 1
     /* 1447993 */     // No operand predicates
     /* 1447993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1447997 */     // MIs[0] policy
     /* 1447997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448009 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_MF2_MASK),
     /* 1448012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448034 */     // GIR_Coverage, 7173,
     /* 1448034 */     GIR_EraseRootFromParent_Done,
     /* 1448035 */   // Label 20337: @1448035
     /* 1448035 */   GIM_Try, /*On fail goto*//*Label 20338*/ GIMT_Encode4(1448132), // Rule ID 7176 //
     /* 1448040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1448051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1448054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1448057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448090 */     // MIs[1] Operand 1
     /* 1448090 */     // No operand predicates
     /* 1448090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448094 */     // MIs[0] policy
     /* 1448094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448097 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448106 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448130 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448131 */     // GIR_Coverage, 7176,
     /* 1448131 */     GIR_EraseRootFromParent_Done,
     /* 1448132 */   // Label 20338: @1448132
     /* 1448132 */   GIM_Try, /*On fail goto*//*Label 20339*/ GIMT_Encode4(1448229), // Rule ID 7177 //
     /* 1448137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1448148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1448151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1448154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1448160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448183 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448187 */     // MIs[1] Operand 1
     /* 1448187 */     // No operand predicates
     /* 1448187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448191 */     // MIs[0] policy
     /* 1448191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448203 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448228 */     // GIR_Coverage, 7177,
     /* 1448228 */     GIR_EraseRootFromParent_Done,
     /* 1448229 */   // Label 20339: @1448229
     /* 1448229 */   GIM_Try, /*On fail goto*//*Label 20340*/ GIMT_Encode4(1448326), // Rule ID 7180 //
     /* 1448234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1448245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1448248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1448251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448280 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448284 */     // MIs[1] Operand 1
     /* 1448284 */     // No operand predicates
     /* 1448284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448288 */     // MIs[0] policy
     /* 1448288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448324 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448325 */     // GIR_Coverage, 7180,
     /* 1448325 */     GIR_EraseRootFromParent_Done,
     /* 1448326 */   // Label 20340: @1448326
     /* 1448326 */   GIM_Try, /*On fail goto*//*Label 20341*/ GIMT_Encode4(1448423), // Rule ID 7181 //
     /* 1448331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1448342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1448345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1448348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1448354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448381 */     // MIs[1] Operand 1
     /* 1448381 */     // No operand predicates
     /* 1448381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448385 */     // MIs[0] policy
     /* 1448385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448397 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1448419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448422 */     // GIR_Coverage, 7181,
     /* 1448422 */     GIR_EraseRootFromParent_Done,
     /* 1448423 */   // Label 20341: @1448423
     /* 1448423 */   GIM_Try, /*On fail goto*//*Label 20342*/ GIMT_Encode4(1448520), // Rule ID 7184 //
     /* 1448428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1448439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1448442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1448445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448478 */     // MIs[1] Operand 1
     /* 1448478 */     // No operand predicates
     /* 1448478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448482 */     // MIs[0] policy
     /* 1448482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448494 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448516 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448518 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448519 */     // GIR_Coverage, 7184,
     /* 1448519 */     GIR_EraseRootFromParent_Done,
     /* 1448520 */   // Label 20342: @1448520
     /* 1448520 */   GIM_Try, /*On fail goto*//*Label 20343*/ GIMT_Encode4(1448617), // Rule ID 7185 //
     /* 1448525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1448536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1448539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1448542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1448548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448575 */     // MIs[1] Operand 1
     /* 1448575 */     // No operand predicates
     /* 1448575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448579 */     // MIs[0] policy
     /* 1448579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448591 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1448613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448616 */     // GIR_Coverage, 7185,
     /* 1448616 */     GIR_EraseRootFromParent_Done,
     /* 1448617 */   // Label 20343: @1448617
     /* 1448617 */   GIM_Try, /*On fail goto*//*Label 20344*/ GIMT_Encode4(1448714), // Rule ID 7188 //
     /* 1448622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1448625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1448639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448668 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448672 */     // MIs[1] Operand 1
     /* 1448672 */     // No operand predicates
     /* 1448672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448676 */     // MIs[0] policy
     /* 1448676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448710 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448712 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448713 */     // GIR_Coverage, 7188,
     /* 1448713 */     GIR_EraseRootFromParent_Done,
     /* 1448714 */   // Label 20344: @1448714
     /* 1448714 */   GIM_Try, /*On fail goto*//*Label 20345*/ GIMT_Encode4(1448811), // Rule ID 7189 //
     /* 1448719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1448722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1448730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1448733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1448736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1448742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1448749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1448757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448769 */     // MIs[1] Operand 1
     /* 1448769 */     // No operand predicates
     /* 1448769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448773 */     // MIs[0] policy
     /* 1448773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448785 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M1_MASK),
     /* 1448788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448794 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1448807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448810 */     // GIR_Coverage, 7189,
     /* 1448810 */     GIR_EraseRootFromParent_Done,
     /* 1448811 */   // Label 20345: @1448811
     /* 1448811 */   GIM_Try, /*On fail goto*//*Label 20346*/ GIMT_Encode4(1448908), // Rule ID 7192 //
     /* 1448816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1448819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1448827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1448830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1448833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1448836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1448842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448862 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448866 */     // MIs[1] Operand 1
     /* 1448866 */     // No operand predicates
     /* 1448866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448870 */     // MIs[0] policy
     /* 1448870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448882 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1448882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1448885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1448904 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1448906 */     GIR_RootConstrainSelectedInstOperands,
     /* 1448907 */     // GIR_Coverage, 7192,
     /* 1448907 */     GIR_EraseRootFromParent_Done,
     /* 1448908 */   // Label 20346: @1448908
     /* 1448908 */   GIM_Try, /*On fail goto*//*Label 20347*/ GIMT_Encode4(1449005), // Rule ID 7193 //
     /* 1448913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1448916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1448921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1448924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1448927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1448930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1448933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1448936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1448939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1448943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1448951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1448955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1448959 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1448963 */     // MIs[1] Operand 1
     /* 1448963 */     // No operand predicates
     /* 1448963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1448967 */     // MIs[0] policy
     /* 1448967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1448970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1448972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1448979 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1448979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1448982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1448984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1448986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1448988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1448991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1448993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1448998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449004 */     // GIR_Coverage, 7193,
     /* 1449004 */     GIR_EraseRootFromParent_Done,
     /* 1449005 */   // Label 20347: @1449005
     /* 1449005 */   GIM_Try, /*On fail goto*//*Label 20348*/ GIMT_Encode4(1449102), // Rule ID 7196 //
     /* 1449010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1449021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1449024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1449027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449056 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449060 */     // MIs[1] Operand 1
     /* 1449060 */     // No operand predicates
     /* 1449060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449064 */     // MIs[0] policy
     /* 1449064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449076 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1449079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449098 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449100 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449101 */     // GIR_Coverage, 7196,
     /* 1449101 */     GIR_EraseRootFromParent_Done,
     /* 1449102 */   // Label 20348: @1449102
     /* 1449102 */   GIM_Try, /*On fail goto*//*Label 20349*/ GIMT_Encode4(1449199), // Rule ID 7197 //
     /* 1449107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1449118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1449121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1449124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449153 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449157 */     // MIs[1] Operand 1
     /* 1449157 */     // No operand predicates
     /* 1449157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449161 */     // MIs[0] policy
     /* 1449161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449173 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1449176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449178 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449198 */     // GIR_Coverage, 7197,
     /* 1449198 */     GIR_EraseRootFromParent_Done,
     /* 1449199 */   // Label 20349: @1449199
     /* 1449199 */   GIM_Try, /*On fail goto*//*Label 20350*/ GIMT_Encode4(1449296), // Rule ID 7200 //
     /* 1449204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1449215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1449218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1449221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1449227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449254 */     // MIs[1] Operand 1
     /* 1449254 */     // No operand predicates
     /* 1449254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449258 */     // MIs[0] policy
     /* 1449258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449270 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1449273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449292 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449294 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449295 */     // GIR_Coverage, 7200,
     /* 1449295 */     GIR_EraseRootFromParent_Done,
     /* 1449296 */   // Label 20350: @1449296
     /* 1449296 */   GIM_Try, /*On fail goto*//*Label 20351*/ GIMT_Encode4(1449393), // Rule ID 7201 //
     /* 1449301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1449312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1449315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1449318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1449324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449347 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449351 */     // MIs[1] Operand 1
     /* 1449351 */     // No operand predicates
     /* 1449351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449355 */     // MIs[0] policy
     /* 1449355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449367 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1449370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1449389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449392 */     // GIR_Coverage, 7201,
     /* 1449392 */     GIR_EraseRootFromParent_Done,
     /* 1449393 */   // Label 20351: @1449393
     /* 1449393 */   GIM_Try, /*On fail goto*//*Label 20352*/ GIMT_Encode4(1449490), // Rule ID 7204 //
     /* 1449398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1449409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1449412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449444 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449448 */     // MIs[1] Operand 1
     /* 1449448 */     // No operand predicates
     /* 1449448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449452 */     // MIs[0] policy
     /* 1449452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1449467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449486 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449489 */     // GIR_Coverage, 7204,
     /* 1449489 */     GIR_EraseRootFromParent_Done,
     /* 1449490 */   // Label 20352: @1449490
     /* 1449490 */   GIM_Try, /*On fail goto*//*Label 20353*/ GIMT_Encode4(1449587), // Rule ID 7205 //
     /* 1449495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1449506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1449509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1449512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1449518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1449525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1449533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449545 */     // MIs[1] Operand 1
     /* 1449545 */     // No operand predicates
     /* 1449545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449549 */     // MIs[0] policy
     /* 1449549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1449564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449586 */     // GIR_Coverage, 7205,
     /* 1449586 */     GIR_EraseRootFromParent_Done,
     /* 1449587 */   // Label 20353: @1449587
     /* 1449587 */   GIM_Try, /*On fail goto*//*Label 20354*/ GIMT_Encode4(1449684), // Rule ID 7208 //
     /* 1449592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1449603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1449606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449642 */     // MIs[1] Operand 1
     /* 1449642 */     // No operand predicates
     /* 1449642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449646 */     // MIs[0] policy
     /* 1449646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1449661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449680 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449683 */     // GIR_Coverage, 7208,
     /* 1449683 */     GIR_EraseRootFromParent_Done,
     /* 1449684 */   // Label 20354: @1449684
     /* 1449684 */   GIM_Try, /*On fail goto*//*Label 20355*/ GIMT_Encode4(1449781), // Rule ID 7209 //
     /* 1449689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1449700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1449703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1449706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1449712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1449719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1449727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449739 */     // MIs[1] Operand 1
     /* 1449739 */     // No operand predicates
     /* 1449739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449743 */     // MIs[0] policy
     /* 1449743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449755 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1449758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449780 */     // GIR_Coverage, 7209,
     /* 1449780 */     GIR_EraseRootFromParent_Done,
     /* 1449781 */   // Label 20355: @1449781
     /* 1449781 */   GIM_Try, /*On fail goto*//*Label 20356*/ GIMT_Encode4(1449878), // Rule ID 7212 //
     /* 1449786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1449797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1449800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1449803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1449806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1449812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449836 */     // MIs[1] Operand 1
     /* 1449836 */     // No operand predicates
     /* 1449836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449840 */     // MIs[0] policy
     /* 1449840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449852 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1449852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1449855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449874 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449877 */     // GIR_Coverage, 7212,
     /* 1449877 */     GIR_EraseRootFromParent_Done,
     /* 1449878 */   // Label 20356: @1449878
     /* 1449878 */   GIM_Try, /*On fail goto*//*Label 20357*/ GIMT_Encode4(1449975), // Rule ID 7213 //
     /* 1449883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1449886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1449894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1449897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1449900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1449903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1449906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1449909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1449913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1449921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1449925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1449929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1449933 */     // MIs[1] Operand 1
     /* 1449933 */     // No operand predicates
     /* 1449933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1449937 */     // MIs[0] policy
     /* 1449937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1449940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1449942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1449949 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1449949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1449952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1449954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1449956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1449958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1449961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1449963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1449968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1449971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1449973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1449974 */     // GIR_Coverage, 7213,
     /* 1449974 */     GIR_EraseRootFromParent_Done,
     /* 1449975 */   // Label 20357: @1449975
     /* 1449975 */   GIM_Try, /*On fail goto*//*Label 20358*/ GIMT_Encode4(1450072), // Rule ID 7216 //
     /* 1449980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1449983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1449988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1449991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1449994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1449997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450026 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450030 */     // MIs[1] Operand 1
     /* 1450030 */     // No operand predicates
     /* 1450030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450034 */     // MIs[0] policy
     /* 1450034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450046 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1450049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450068 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450071 */     // GIR_Coverage, 7216,
     /* 1450071 */     GIR_EraseRootFromParent_Done,
     /* 1450072 */   // Label 20358: @1450072
     /* 1450072 */   GIM_Try, /*On fail goto*//*Label 20359*/ GIMT_Encode4(1450169), // Rule ID 7217 //
     /* 1450077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1450088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1450091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1450094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450123 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450127 */     // MIs[1] Operand 1
     /* 1450127 */     // No operand predicates
     /* 1450127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450131 */     // MIs[0] policy
     /* 1450131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1450146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450168 */     // GIR_Coverage, 7217,
     /* 1450168 */     GIR_EraseRootFromParent_Done,
     /* 1450169 */   // Label 20359: @1450169
     /* 1450169 */   GIM_Try, /*On fail goto*//*Label 20360*/ GIMT_Encode4(1450266), // Rule ID 7220 //
     /* 1450174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1450185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1450188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450220 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450224 */     // MIs[1] Operand 1
     /* 1450224 */     // No operand predicates
     /* 1450224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450228 */     // MIs[0] policy
     /* 1450228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450231 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450240 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1450243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450262 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450265 */     // GIR_Coverage, 7220,
     /* 1450265 */     GIR_EraseRootFromParent_Done,
     /* 1450266 */   // Label 20360: @1450266
     /* 1450266 */   GIM_Try, /*On fail goto*//*Label 20361*/ GIMT_Encode4(1450363), // Rule ID 7221 //
     /* 1450271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1450282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1450285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1450288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450317 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450321 */     // MIs[1] Operand 1
     /* 1450321 */     // No operand predicates
     /* 1450321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450325 */     // MIs[0] policy
     /* 1450325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450328 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450337 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1450340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450362 */     // GIR_Coverage, 7221,
     /* 1450362 */     GIR_EraseRootFromParent_Done,
     /* 1450363 */   // Label 20361: @1450363
     /* 1450363 */   GIM_Try, /*On fail goto*//*Label 20362*/ GIMT_Encode4(1450460), // Rule ID 7224 //
     /* 1450368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1450371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1450379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1450382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1450385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1450398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450414 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450418 */     // MIs[1] Operand 1
     /* 1450418 */     // No operand predicates
     /* 1450418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450422 */     // MIs[0] policy
     /* 1450422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450434 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1450437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450456 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450459 */     // GIR_Coverage, 7224,
     /* 1450459 */     GIR_EraseRootFromParent_Done,
     /* 1450460 */   // Label 20362: @1450460
     /* 1450460 */   GIM_Try, /*On fail goto*//*Label 20363*/ GIMT_Encode4(1450557), // Rule ID 7225 //
     /* 1450465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1450468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1450476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1450479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1450482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1450488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1450495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450515 */     // MIs[1] Operand 1
     /* 1450515 */     // No operand predicates
     /* 1450515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450519 */     // MIs[0] policy
     /* 1450519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450531 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1450534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450540 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1450553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450556 */     // GIR_Coverage, 7225,
     /* 1450556 */     GIR_EraseRootFromParent_Done,
     /* 1450557 */   // Label 20363: @1450557
     /* 1450557 */   GIM_Try, /*On fail goto*//*Label 20364*/ GIMT_Encode4(1450654), // Rule ID 7228 //
     /* 1450562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1450579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450608 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450612 */     // MIs[1] Operand 1
     /* 1450612 */     // No operand predicates
     /* 1450612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450616 */     // MIs[0] policy
     /* 1450616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450628 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1450631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450650 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450652 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450653 */     // GIR_Coverage, 7228,
     /* 1450653 */     GIR_EraseRootFromParent_Done,
     /* 1450654 */   // Label 20364: @1450654
     /* 1450654 */   GIM_Try, /*On fail goto*//*Label 20365*/ GIMT_Encode4(1450751), // Rule ID 7229 //
     /* 1450659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1450662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1450670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1450673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1450676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1450682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1450689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1450697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450705 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450709 */     // MIs[1] Operand 1
     /* 1450709 */     // No operand predicates
     /* 1450709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450713 */     // MIs[0] policy
     /* 1450713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450725 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M2_MASK),
     /* 1450728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450750 */     // GIR_Coverage, 7229,
     /* 1450750 */     GIR_EraseRootFromParent_Done,
     /* 1450751 */   // Label 20365: @1450751
     /* 1450751 */   GIM_Try, /*On fail goto*//*Label 20366*/ GIMT_Encode4(1450848), // Rule ID 7232 //
     /* 1450756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1450773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450806 */     // MIs[1] Operand 1
     /* 1450806 */     // No operand predicates
     /* 1450806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450810 */     // MIs[0] policy
     /* 1450810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450822 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1450822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1450825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450846 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450847 */     // GIR_Coverage, 7232,
     /* 1450847 */     GIR_EraseRootFromParent_Done,
     /* 1450848 */   // Label 20366: @1450848
     /* 1450848 */   GIM_Try, /*On fail goto*//*Label 20367*/ GIMT_Encode4(1450945), // Rule ID 7233 //
     /* 1450853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1450856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1450864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1450867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1450870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1450873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1450876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1450879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1450883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1450891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1450903 */     // MIs[1] Operand 1
     /* 1450903 */     // No operand predicates
     /* 1450903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1450907 */     // MIs[0] policy
     /* 1450907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1450910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1450912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1450919 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1450919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M4_MASK),
     /* 1450922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1450924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1450926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1450928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1450931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1450933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1450938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1450941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1450943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1450944 */     // GIR_Coverage, 7233,
     /* 1450944 */     GIR_EraseRootFromParent_Done,
     /* 1450945 */   // Label 20367: @1450945
     /* 1450945 */   GIM_Try, /*On fail goto*//*Label 20368*/ GIMT_Encode4(1451042), // Rule ID 7236 //
     /* 1450950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1450953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1450958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1450961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1450964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1450967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1450970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1450973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1450976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1450980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1450988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1450992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1450996 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451000 */     // MIs[1] Operand 1
     /* 1451000 */     // No operand predicates
     /* 1451000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451004 */     // MIs[0] policy
     /* 1451004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451007 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1451019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451040 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451041 */     // GIR_Coverage, 7236,
     /* 1451041 */     GIR_EraseRootFromParent_Done,
     /* 1451042 */   // Label 20368: @1451042
     /* 1451042 */   GIM_Try, /*On fail goto*//*Label 20369*/ GIMT_Encode4(1451139), // Rule ID 7237 //
     /* 1451047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1451050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1451055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1451058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1451061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1451064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1451077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1451085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451093 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451097 */     // MIs[1] Operand 1
     /* 1451097 */     // No operand predicates
     /* 1451097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451101 */     // MIs[0] policy
     /* 1451101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451113 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VI_M8_MASK),
     /* 1451116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1451135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451138 */     // GIR_Coverage, 7237,
     /* 1451138 */     GIR_EraseRootFromParent_Done,
     /* 1451139 */   // Label 20369: @1451139
     /* 1451139 */   GIM_Try, /*On fail goto*//*Label 20370*/ GIMT_Encode4(1451236), // Rule ID 7448 //
     /* 1451144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1451155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1451158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1451161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451194 */     // MIs[1] Operand 1
     /* 1451194 */     // No operand predicates
     /* 1451194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451198 */     // MIs[0] policy
     /* 1451198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451210 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1451213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451234 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451235 */     // GIR_Coverage, 7448,
     /* 1451235 */     GIR_EraseRootFromParent_Done,
     /* 1451236 */   // Label 20370: @1451236
     /* 1451236 */   GIM_Try, /*On fail goto*//*Label 20371*/ GIMT_Encode4(1451333), // Rule ID 7449 //
     /* 1451241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1451252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1451255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1451258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1451264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451287 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451291 */     // MIs[1] Operand 1
     /* 1451291 */     // No operand predicates
     /* 1451291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451295 */     // MIs[0] policy
     /* 1451295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451307 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF8_MASK),
     /* 1451310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451332 */     // GIR_Coverage, 7449,
     /* 1451332 */     GIR_EraseRootFromParent_Done,
     /* 1451333 */   // Label 20371: @1451333
     /* 1451333 */   GIM_Try, /*On fail goto*//*Label 20372*/ GIMT_Encode4(1451430), // Rule ID 7452 //
     /* 1451338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1451349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1451352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1451355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451384 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451388 */     // MIs[1] Operand 1
     /* 1451388 */     // No operand predicates
     /* 1451388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451392 */     // MIs[0] policy
     /* 1451392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451404 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1451407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451428 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451429 */     // GIR_Coverage, 7452,
     /* 1451429 */     GIR_EraseRootFromParent_Done,
     /* 1451430 */   // Label 20372: @1451430
     /* 1451430 */   GIM_Try, /*On fail goto*//*Label 20373*/ GIMT_Encode4(1451527), // Rule ID 7453 //
     /* 1451435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1451446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1451449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1451452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1451458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451481 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451485 */     // MIs[1] Operand 1
     /* 1451485 */     // No operand predicates
     /* 1451485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451489 */     // MIs[0] policy
     /* 1451489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451501 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1451504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451526 */     // GIR_Coverage, 7453,
     /* 1451526 */     GIR_EraseRootFromParent_Done,
     /* 1451527 */   // Label 20373: @1451527
     /* 1451527 */   GIM_Try, /*On fail goto*//*Label 20374*/ GIMT_Encode4(1451624), // Rule ID 7456 //
     /* 1451532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1451543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1451546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451578 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451582 */     // MIs[1] Operand 1
     /* 1451582 */     // No operand predicates
     /* 1451582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451586 */     // MIs[0] policy
     /* 1451586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451598 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1451601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451622 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451623 */     // GIR_Coverage, 7456,
     /* 1451623 */     GIR_EraseRootFromParent_Done,
     /* 1451624 */   // Label 20374: @1451624
     /* 1451624 */   GIM_Try, /*On fail goto*//*Label 20375*/ GIMT_Encode4(1451721), // Rule ID 7457 //
     /* 1451629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1451640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1451643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1451646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1451652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451675 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451679 */     // MIs[1] Operand 1
     /* 1451679 */     // No operand predicates
     /* 1451679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451683 */     // MIs[0] policy
     /* 1451683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451695 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1451698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451720 */     // GIR_Coverage, 7457,
     /* 1451720 */     GIR_EraseRootFromParent_Done,
     /* 1451721 */   // Label 20375: @1451721
     /* 1451721 */   GIM_Try, /*On fail goto*//*Label 20376*/ GIMT_Encode4(1451818), // Rule ID 7460 //
     /* 1451726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1451737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1451740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451772 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451776 */     // MIs[1] Operand 1
     /* 1451776 */     // No operand predicates
     /* 1451776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451780 */     // MIs[0] policy
     /* 1451780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451792 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1451795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451816 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451817 */     // GIR_Coverage, 7460,
     /* 1451817 */     GIR_EraseRootFromParent_Done,
     /* 1451818 */   // Label 20376: @1451818
     /* 1451818 */   GIM_Try, /*On fail goto*//*Label 20377*/ GIMT_Encode4(1451915), // Rule ID 7461 //
     /* 1451823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1451826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1451834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1451837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1451840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1451843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1451846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1451849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1451853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1451857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451873 */     // MIs[1] Operand 1
     /* 1451873 */     // No operand predicates
     /* 1451873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451877 */     // MIs[0] policy
     /* 1451877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451889 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1451889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1451892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451898 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1451903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1451908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1451911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1451913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1451914 */     // GIR_Coverage, 7461,
     /* 1451914 */     GIR_EraseRootFromParent_Done,
     /* 1451915 */   // Label 20377: @1451915
     /* 1451915 */   GIM_Try, /*On fail goto*//*Label 20378*/ GIMT_Encode4(1452012), // Rule ID 7464 //
     /* 1451920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1451923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1451928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1451931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1451934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1451937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1451940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1451943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1451946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1451950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1451954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1451958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1451962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1451966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1451970 */     // MIs[1] Operand 1
     /* 1451970 */     // No operand predicates
     /* 1451970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1451974 */     // MIs[0] policy
     /* 1451974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1451977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1451979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1451986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1451986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1451989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1451991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1451993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1451995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1451998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452010 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452011 */     // GIR_Coverage, 7464,
     /* 1452011 */     GIR_EraseRootFromParent_Done,
     /* 1452012 */   // Label 20378: @1452012
     /* 1452012 */   GIM_Try, /*On fail goto*//*Label 20379*/ GIMT_Encode4(1452109), // Rule ID 7465 //
     /* 1452017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1452028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1452031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1452034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1452040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452063 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452067 */     // MIs[1] Operand 1
     /* 1452067 */     // No operand predicates
     /* 1452067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452071 */     // MIs[0] policy
     /* 1452071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452074 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452083 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1452086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452088 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452108 */     // GIR_Coverage, 7465,
     /* 1452108 */     GIR_EraseRootFromParent_Done,
     /* 1452109 */   // Label 20379: @1452109
     /* 1452109 */   GIM_Try, /*On fail goto*//*Label 20380*/ GIMT_Encode4(1452206), // Rule ID 7468 //
     /* 1452114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1452125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1452128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452160 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452164 */     // MIs[1] Operand 1
     /* 1452164 */     // No operand predicates
     /* 1452164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452168 */     // MIs[0] policy
     /* 1452168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452180 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1452183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452202 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452204 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452205 */     // GIR_Coverage, 7468,
     /* 1452205 */     GIR_EraseRootFromParent_Done,
     /* 1452206 */   // Label 20380: @1452206
     /* 1452206 */   GIM_Try, /*On fail goto*//*Label 20381*/ GIMT_Encode4(1452303), // Rule ID 7469 //
     /* 1452211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1452222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1452225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1452228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1452234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1452241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1452249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452261 */     // MIs[1] Operand 1
     /* 1452261 */     // No operand predicates
     /* 1452261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452265 */     // MIs[0] policy
     /* 1452265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452277 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1452280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1452299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452302 */     // GIR_Coverage, 7469,
     /* 1452302 */     GIR_EraseRootFromParent_Done,
     /* 1452303 */   // Label 20381: @1452303
     /* 1452303 */   GIM_Try, /*On fail goto*//*Label 20382*/ GIMT_Encode4(1452400), // Rule ID 7472 //
     /* 1452308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1452319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1452322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1452331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452358 */     // MIs[1] Operand 1
     /* 1452358 */     // No operand predicates
     /* 1452358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452362 */     // MIs[0] policy
     /* 1452362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452374 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1452377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452396 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452398 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452399 */     // GIR_Coverage, 7472,
     /* 1452399 */     GIR_EraseRootFromParent_Done,
     /* 1452400 */   // Label 20382: @1452400
     /* 1452400 */   GIM_Try, /*On fail goto*//*Label 20383*/ GIMT_Encode4(1452497), // Rule ID 7473 //
     /* 1452405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1452416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1452419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1452422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1452428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452451 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452455 */     // MIs[1] Operand 1
     /* 1452455 */     // No operand predicates
     /* 1452455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452459 */     // MIs[0] policy
     /* 1452459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452471 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF4_MASK),
     /* 1452474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452480 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452496 */     // GIR_Coverage, 7473,
     /* 1452496 */     GIR_EraseRootFromParent_Done,
     /* 1452497 */   // Label 20383: @1452497
     /* 1452497 */   GIM_Try, /*On fail goto*//*Label 20384*/ GIMT_Encode4(1452594), // Rule ID 7476 //
     /* 1452502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452552 */     // MIs[1] Operand 1
     /* 1452552 */     // No operand predicates
     /* 1452552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452556 */     // MIs[0] policy
     /* 1452556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1452571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452590 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452592 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452593 */     // GIR_Coverage, 7476,
     /* 1452593 */     GIR_EraseRootFromParent_Done,
     /* 1452594 */   // Label 20384: @1452594
     /* 1452594 */   GIM_Try, /*On fail goto*//*Label 20385*/ GIMT_Encode4(1452691), // Rule ID 7477 //
     /* 1452599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1452610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1452613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1452616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1452622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452645 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452649 */     // MIs[1] Operand 1
     /* 1452649 */     // No operand predicates
     /* 1452649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452653 */     // MIs[0] policy
     /* 1452653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452665 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1452668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452674 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452690 */     // GIR_Coverage, 7477,
     /* 1452690 */     GIR_EraseRootFromParent_Done,
     /* 1452691 */   // Label 20385: @1452691
     /* 1452691 */   GIM_Try, /*On fail goto*//*Label 20386*/ GIMT_Encode4(1452788), // Rule ID 7480 //
     /* 1452696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452746 */     // MIs[1] Operand 1
     /* 1452746 */     // No operand predicates
     /* 1452746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452750 */     // MIs[0] policy
     /* 1452750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452762 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1452765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452784 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452786 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452787 */     // GIR_Coverage, 7480,
     /* 1452787 */     GIR_EraseRootFromParent_Done,
     /* 1452788 */   // Label 20386: @1452788
     /* 1452788 */   GIM_Try, /*On fail goto*//*Label 20387*/ GIMT_Encode4(1452885), // Rule ID 7481 //
     /* 1452793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1452804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1452807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1452810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1452813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1452816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1452819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1452823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1452827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452843 */     // MIs[1] Operand 1
     /* 1452843 */     // No operand predicates
     /* 1452843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452847 */     // MIs[0] policy
     /* 1452847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452859 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1452859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1452862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452884 */     // GIR_Coverage, 7481,
     /* 1452884 */     GIR_EraseRootFromParent_Done,
     /* 1452885 */   // Label 20387: @1452885
     /* 1452885 */   GIM_Try, /*On fail goto*//*Label 20388*/ GIMT_Encode4(1452982), // Rule ID 7484 //
     /* 1452890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1452893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1452904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1452907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1452910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1452913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1452916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1452920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1452924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1452928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1452932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1452936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1452940 */     // MIs[1] Operand 1
     /* 1452940 */     // No operand predicates
     /* 1452940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1452944 */     // MIs[0] policy
     /* 1452944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1452947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1452949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1452956 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1452956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1452959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1452961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1452963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1452965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1452968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1452970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1452975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1452978 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1452980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1452981 */     // GIR_Coverage, 7484,
     /* 1452981 */     GIR_EraseRootFromParent_Done,
     /* 1452982 */   // Label 20388: @1452982
     /* 1452982 */   GIM_Try, /*On fail goto*//*Label 20389*/ GIMT_Encode4(1453079), // Rule ID 7485 //
     /* 1452987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1452990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1452995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1452998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1453001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1453004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453033 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453037 */     // MIs[1] Operand 1
     /* 1453037 */     // No operand predicates
     /* 1453037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453041 */     // MIs[0] policy
     /* 1453041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1453056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453078 */     // GIR_Coverage, 7485,
     /* 1453078 */     GIR_EraseRootFromParent_Done,
     /* 1453079 */   // Label 20389: @1453079
     /* 1453079 */   GIM_Try, /*On fail goto*//*Label 20390*/ GIMT_Encode4(1453176), // Rule ID 7488 //
     /* 1453084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1453087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1453095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1453098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453134 */     // MIs[1] Operand 1
     /* 1453134 */     // No operand predicates
     /* 1453134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453138 */     // MIs[0] policy
     /* 1453138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453150 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1453153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453172 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453175 */     // GIR_Coverage, 7488,
     /* 1453175 */     GIR_EraseRootFromParent_Done,
     /* 1453176 */   // Label 20390: @1453176
     /* 1453176 */   GIM_Try, /*On fail goto*//*Label 20391*/ GIMT_Encode4(1453273), // Rule ID 7489 //
     /* 1453181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1453184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1453192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1453195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1453198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1453204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453231 */     // MIs[1] Operand 1
     /* 1453231 */     // No operand predicates
     /* 1453231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453235 */     // MIs[0] policy
     /* 1453235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453247 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1453250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1453269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453272 */     // GIR_Coverage, 7489,
     /* 1453272 */     GIR_EraseRootFromParent_Done,
     /* 1453273 */   // Label 20391: @1453273
     /* 1453273 */   GIM_Try, /*On fail goto*//*Label 20392*/ GIMT_Encode4(1453370), // Rule ID 7492 //
     /* 1453278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1453281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1453289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1453292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1453295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453324 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453328 */     // MIs[1] Operand 1
     /* 1453328 */     // No operand predicates
     /* 1453328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453332 */     // MIs[0] policy
     /* 1453332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1453347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453366 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453369 */     // GIR_Coverage, 7492,
     /* 1453369 */     GIR_EraseRootFromParent_Done,
     /* 1453370 */   // Label 20392: @1453370
     /* 1453370 */   GIM_Try, /*On fail goto*//*Label 20393*/ GIMT_Encode4(1453467), // Rule ID 7493 //
     /* 1453375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1453378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1453386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1453389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1453392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1453398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453421 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453425 */     // MIs[1] Operand 1
     /* 1453425 */     // No operand predicates
     /* 1453425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453429 */     // MIs[0] policy
     /* 1453429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453441 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_MF2_MASK),
     /* 1453444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453466 */     // GIR_Coverage, 7493,
     /* 1453466 */     GIR_EraseRootFromParent_Done,
     /* 1453467 */   // Label 20393: @1453467
     /* 1453467 */   GIM_Try, /*On fail goto*//*Label 20394*/ GIMT_Encode4(1453564), // Rule ID 7496 //
     /* 1453472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1453475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1453483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1453486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453522 */     // MIs[1] Operand 1
     /* 1453522 */     // No operand predicates
     /* 1453522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453526 */     // MIs[0] policy
     /* 1453526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453538 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1453541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453560 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453563 */     // GIR_Coverage, 7496,
     /* 1453563 */     GIR_EraseRootFromParent_Done,
     /* 1453564 */   // Label 20394: @1453564
     /* 1453564 */   GIM_Try, /*On fail goto*//*Label 20395*/ GIMT_Encode4(1453661), // Rule ID 7497 //
     /* 1453569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1453572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1453580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1453583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1453586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1453592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1453599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1453603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453615 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453619 */     // MIs[1] Operand 1
     /* 1453619 */     // No operand predicates
     /* 1453619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453623 */     // MIs[0] policy
     /* 1453623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453635 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M1_MASK),
     /* 1453638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453660 */     // GIR_Coverage, 7497,
     /* 1453660 */     GIR_EraseRootFromParent_Done,
     /* 1453661 */   // Label 20395: @1453661
     /* 1453661 */   GIM_Try, /*On fail goto*//*Label 20396*/ GIMT_Encode4(1453758), // Rule ID 7500 //
     /* 1453666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1453669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1453677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1453680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453712 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453716 */     // MIs[1] Operand 1
     /* 1453716 */     // No operand predicates
     /* 1453716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453720 */     // MIs[0] policy
     /* 1453720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1453735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453754 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453757 */     // GIR_Coverage, 7500,
     /* 1453757 */     GIR_EraseRootFromParent_Done,
     /* 1453758 */   // Label 20396: @1453758
     /* 1453758 */   GIM_Try, /*On fail goto*//*Label 20397*/ GIMT_Encode4(1453855), // Rule ID 7501 //
     /* 1453763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1453766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1453774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1453777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1453780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1453786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1453793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1453797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453809 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453813 */     // MIs[1] Operand 1
     /* 1453813 */     // No operand predicates
     /* 1453813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453817 */     // MIs[0] policy
     /* 1453817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1453829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M2_MASK),
     /* 1453832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453854 */     // GIR_Coverage, 7501,
     /* 1453854 */     GIR_EraseRootFromParent_Done,
     /* 1453855 */   // Label 20397: @1453855
     /* 1453855 */   GIM_Try, /*On fail goto*//*Label 20398*/ GIMT_Encode4(1453952), // Rule ID 7504 //
     /* 1453860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1453863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1453880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1453886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1453906 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1453910 */     // MIs[1] Operand 1
     /* 1453910 */     // No operand predicates
     /* 1453910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1453914 */     // MIs[0] policy
     /* 1453914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1453917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1453919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1453926 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1453926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1453929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1453931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1453933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1453935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1453938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1453940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1453945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1453948 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1453950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1453951 */     // GIR_Coverage, 7504,
     /* 1453951 */     GIR_EraseRootFromParent_Done,
     /* 1453952 */   // Label 20398: @1453952
     /* 1453952 */   GIM_Try, /*On fail goto*//*Label 20399*/ GIMT_Encode4(1454049), // Rule ID 7505 //
     /* 1453957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1453960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1453965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1453968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1453971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1453974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1453977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1453980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1453983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1453987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1453991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1453995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1453999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454003 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454007 */     // MIs[1] Operand 1
     /* 1454007 */     // No operand predicates
     /* 1454007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454011 */     // MIs[0] policy
     /* 1454011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454023 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WI_M4_MASK),
     /* 1454026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1454045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454048 */     // GIR_Coverage, 7505,
     /* 1454048 */     GIR_EraseRootFromParent_Done,
     /* 1454049 */   // Label 20399: @1454049
     /* 1454049 */   GIM_Try, /*On fail goto*//*Label 20400*/ GIMT_Encode4(1454146), // Rule ID 7628 //
     /* 1454054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1454065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1454068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454104 */     // MIs[1] Operand 1
     /* 1454104 */     // No operand predicates
     /* 1454104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454108 */     // MIs[0] policy
     /* 1454108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454120 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1454123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454129 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454142 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454145 */     // GIR_Coverage, 7628,
     /* 1454145 */     GIR_EraseRootFromParent_Done,
     /* 1454146 */   // Label 20400: @1454146
     /* 1454146 */   GIM_Try, /*On fail goto*//*Label 20401*/ GIMT_Encode4(1454243), // Rule ID 7629 //
     /* 1454151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1454162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1454165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1454168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1454174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454197 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454201 */     // MIs[1] Operand 1
     /* 1454201 */     // No operand predicates
     /* 1454201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454205 */     // MIs[0] policy
     /* 1454205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454217 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF8_MASK),
     /* 1454220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454242 */     // GIR_Coverage, 7629,
     /* 1454242 */     GIR_EraseRootFromParent_Done,
     /* 1454243 */   // Label 20401: @1454243
     /* 1454243 */   GIM_Try, /*On fail goto*//*Label 20402*/ GIMT_Encode4(1454340), // Rule ID 7632 //
     /* 1454248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454298 */     // MIs[1] Operand 1
     /* 1454298 */     // No operand predicates
     /* 1454298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454302 */     // MIs[0] policy
     /* 1454302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1454317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454336 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454338 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454339 */     // GIR_Coverage, 7632,
     /* 1454339 */     GIR_EraseRootFromParent_Done,
     /* 1454340 */   // Label 20402: @1454340
     /* 1454340 */   GIM_Try, /*On fail goto*//*Label 20403*/ GIMT_Encode4(1454437), // Rule ID 7633 //
     /* 1454345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1454356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1454359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1454362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1454368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454391 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454395 */     // MIs[1] Operand 1
     /* 1454395 */     // No operand predicates
     /* 1454395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454399 */     // MIs[0] policy
     /* 1454399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454411 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1454414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454436 */     // GIR_Coverage, 7633,
     /* 1454436 */     GIR_EraseRootFromParent_Done,
     /* 1454437 */   // Label 20403: @1454437
     /* 1454437 */   GIM_Try, /*On fail goto*//*Label 20404*/ GIMT_Encode4(1454534), // Rule ID 7636 //
     /* 1454442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454488 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454492 */     // MIs[1] Operand 1
     /* 1454492 */     // No operand predicates
     /* 1454492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454496 */     // MIs[0] policy
     /* 1454496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1454511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454532 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454533 */     // GIR_Coverage, 7636,
     /* 1454533 */     GIR_EraseRootFromParent_Done,
     /* 1454534 */   // Label 20404: @1454534
     /* 1454534 */   GIM_Try, /*On fail goto*//*Label 20405*/ GIMT_Encode4(1454631), // Rule ID 7637 //
     /* 1454539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1454550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1454553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1454556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1454562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454585 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454589 */     // MIs[1] Operand 1
     /* 1454589 */     // No operand predicates
     /* 1454589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454593 */     // MIs[0] policy
     /* 1454593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454605 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1454608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454630 */     // GIR_Coverage, 7637,
     /* 1454630 */     GIR_EraseRootFromParent_Done,
     /* 1454631 */   // Label 20405: @1454631
     /* 1454631 */   GIM_Try, /*On fail goto*//*Label 20406*/ GIMT_Encode4(1454728), // Rule ID 7640 //
     /* 1454636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1454653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454682 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454686 */     // MIs[1] Operand 1
     /* 1454686 */     // No operand predicates
     /* 1454686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454690 */     // MIs[0] policy
     /* 1454690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454702 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1454705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454726 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454727 */     // GIR_Coverage, 7640,
     /* 1454727 */     GIR_EraseRootFromParent_Done,
     /* 1454728 */   // Label 20406: @1454728
     /* 1454728 */   GIM_Try, /*On fail goto*//*Label 20407*/ GIMT_Encode4(1454825), // Rule ID 7641 //
     /* 1454733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1454744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1454747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1454750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1454756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1454763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1454767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454783 */     // MIs[1] Operand 1
     /* 1454783 */     // No operand predicates
     /* 1454783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454787 */     // MIs[0] policy
     /* 1454787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454799 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1454802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454824 */     // GIR_Coverage, 7641,
     /* 1454824 */     GIR_EraseRootFromParent_Done,
     /* 1454825 */   // Label 20407: @1454825
     /* 1454825 */   GIM_Try, /*On fail goto*//*Label 20408*/ GIMT_Encode4(1454922), // Rule ID 7644 //
     /* 1454830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1454833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1454841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1454844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1454847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1454850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1454853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1454856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454880 */     // MIs[1] Operand 1
     /* 1454880 */     // No operand predicates
     /* 1454880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454884 */     // MIs[0] policy
     /* 1454884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454887 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1454896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1454899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1454903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1454905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1454908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1454910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1454915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1454918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1454920 */     GIR_RootConstrainSelectedInstOperands,
     /* 1454921 */     // GIR_Coverage, 7644,
     /* 1454921 */     GIR_EraseRootFromParent_Done,
     /* 1454922 */   // Label 20408: @1454922
     /* 1454922 */   GIM_Try, /*On fail goto*//*Label 20409*/ GIMT_Encode4(1455019), // Rule ID 7645 //
     /* 1454927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1454930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1454935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1454938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1454941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1454944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1454947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1454950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1454953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1454957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1454961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1454965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1454969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1454973 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1454977 */     // MIs[1] Operand 1
     /* 1454977 */     // No operand predicates
     /* 1454977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1454981 */     // MIs[0] policy
     /* 1454981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1454984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1454986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1454993 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1454993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1454996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1454998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455002 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455018 */     // GIR_Coverage, 7645,
     /* 1455018 */     GIR_EraseRootFromParent_Done,
     /* 1455019 */   // Label 20409: @1455019
     /* 1455019 */   GIM_Try, /*On fail goto*//*Label 20410*/ GIMT_Encode4(1455116), // Rule ID 7648 //
     /* 1455024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1455041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455070 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455074 */     // MIs[1] Operand 1
     /* 1455074 */     // No operand predicates
     /* 1455074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455078 */     // MIs[0] policy
     /* 1455078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455090 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1455093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455114 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455115 */     // GIR_Coverage, 7648,
     /* 1455115 */     GIR_EraseRootFromParent_Done,
     /* 1455116 */   // Label 20410: @1455116
     /* 1455116 */   GIM_Try, /*On fail goto*//*Label 20411*/ GIMT_Encode4(1455213), // Rule ID 7649 //
     /* 1455121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1455132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1455135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1455138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1455144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1455151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1455159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455163 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455167 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455171 */     // MIs[1] Operand 1
     /* 1455171 */     // No operand predicates
     /* 1455171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455175 */     // MIs[0] policy
     /* 1455175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455187 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1455190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1455209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455212 */     // GIR_Coverage, 7649,
     /* 1455212 */     GIR_EraseRootFromParent_Done,
     /* 1455213 */   // Label 20411: @1455213
     /* 1455213 */   GIM_Try, /*On fail goto*//*Label 20412*/ GIMT_Encode4(1455310), // Rule ID 7652 //
     /* 1455218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1455229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1455232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1455235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455264 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455268 */     // MIs[1] Operand 1
     /* 1455268 */     // No operand predicates
     /* 1455268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455272 */     // MIs[0] policy
     /* 1455272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455284 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1455287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455308 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455309 */     // GIR_Coverage, 7652,
     /* 1455309 */     GIR_EraseRootFromParent_Done,
     /* 1455310 */   // Label 20412: @1455310
     /* 1455310 */   GIM_Try, /*On fail goto*//*Label 20413*/ GIMT_Encode4(1455407), // Rule ID 7653 //
     /* 1455315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1455326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1455329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1455332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1455338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455365 */     // MIs[1] Operand 1
     /* 1455365 */     // No operand predicates
     /* 1455365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455369 */     // MIs[0] policy
     /* 1455369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455381 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF4_MASK),
     /* 1455384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455390 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455406 */     // GIR_Coverage, 7653,
     /* 1455406 */     GIR_EraseRootFromParent_Done,
     /* 1455407 */   // Label 20413: @1455407
     /* 1455407 */   GIM_Try, /*On fail goto*//*Label 20414*/ GIMT_Encode4(1455504), // Rule ID 7656 //
     /* 1455412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1455423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1455426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455462 */     // MIs[1] Operand 1
     /* 1455462 */     // No operand predicates
     /* 1455462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455466 */     // MIs[0] policy
     /* 1455466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455478 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1455481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455502 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455503 */     // GIR_Coverage, 7656,
     /* 1455503 */     GIR_EraseRootFromParent_Done,
     /* 1455504 */   // Label 20414: @1455504
     /* 1455504 */   GIM_Try, /*On fail goto*//*Label 20415*/ GIMT_Encode4(1455601), // Rule ID 7657 //
     /* 1455509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1455520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1455523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1455526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1455532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455559 */     // MIs[1] Operand 1
     /* 1455559 */     // No operand predicates
     /* 1455559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455563 */     // MIs[0] policy
     /* 1455563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455575 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1455578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455600 */     // GIR_Coverage, 7657,
     /* 1455600 */     GIR_EraseRootFromParent_Done,
     /* 1455601 */   // Label 20415: @1455601
     /* 1455601 */   GIM_Try, /*On fail goto*//*Label 20416*/ GIMT_Encode4(1455698), // Rule ID 7660 //
     /* 1455606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1455623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455652 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455656 */     // MIs[1] Operand 1
     /* 1455656 */     // No operand predicates
     /* 1455656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455660 */     // MIs[0] policy
     /* 1455660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455672 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1455675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455694 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455696 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455697 */     // GIR_Coverage, 7660,
     /* 1455697 */     GIR_EraseRootFromParent_Done,
     /* 1455698 */   // Label 20416: @1455698
     /* 1455698 */   GIM_Try, /*On fail goto*//*Label 20417*/ GIMT_Encode4(1455795), // Rule ID 7661 //
     /* 1455703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1455714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1455717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1455720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1455726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1455733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1455737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455749 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455753 */     // MIs[1] Operand 1
     /* 1455753 */     // No operand predicates
     /* 1455753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455757 */     // MIs[0] policy
     /* 1455757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455769 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1455772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455794 */     // GIR_Coverage, 7661,
     /* 1455794 */     GIR_EraseRootFromParent_Done,
     /* 1455795 */   // Label 20417: @1455795
     /* 1455795 */   GIM_Try, /*On fail goto*//*Label 20418*/ GIMT_Encode4(1455892), // Rule ID 7664 //
     /* 1455800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1455817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1455820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1455826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455850 */     // MIs[1] Operand 1
     /* 1455850 */     // No operand predicates
     /* 1455850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455854 */     // MIs[0] policy
     /* 1455854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1455866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1455869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455888 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455890 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455891 */     // GIR_Coverage, 7664,
     /* 1455891 */     GIR_EraseRootFromParent_Done,
     /* 1455892 */   // Label 20418: @1455892
     /* 1455892 */   GIM_Try, /*On fail goto*//*Label 20419*/ GIMT_Encode4(1455989), // Rule ID 7665 //
     /* 1455897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1455900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1455905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1455908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1455911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1455914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1455917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1455920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1455923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1455927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1455931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1455935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1455939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1455943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1455947 */     // MIs[1] Operand 1
     /* 1455947 */     // No operand predicates
     /* 1455947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1455951 */     // MIs[0] policy
     /* 1455951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1455954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1455956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1455963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1455963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1455966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1455968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1455970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1455972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1455975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1455977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1455982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1455985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1455987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1455988 */     // GIR_Coverage, 7665,
     /* 1455988 */     GIR_EraseRootFromParent_Done,
     /* 1455989 */   // Label 20419: @1455989
     /* 1455989 */   GIM_Try, /*On fail goto*//*Label 20420*/ GIMT_Encode4(1456086), // Rule ID 7668 //
     /* 1455994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1455997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456044 */     // MIs[1] Operand 1
     /* 1456044 */     // No operand predicates
     /* 1456044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456048 */     // MIs[0] policy
     /* 1456048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456060 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1456063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456082 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456084 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456085 */     // GIR_Coverage, 7668,
     /* 1456085 */     GIR_EraseRootFromParent_Done,
     /* 1456086 */   // Label 20420: @1456086
     /* 1456086 */   GIM_Try, /*On fail goto*//*Label 20421*/ GIMT_Encode4(1456183), // Rule ID 7669 //
     /* 1456091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1456094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1456102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1456105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1456108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1456114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456137 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456141 */     // MIs[1] Operand 1
     /* 1456141 */     // No operand predicates
     /* 1456141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456145 */     // MIs[0] policy
     /* 1456145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456157 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1456160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456166 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1456179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456182 */     // GIR_Coverage, 7669,
     /* 1456182 */     GIR_EraseRootFromParent_Done,
     /* 1456183 */   // Label 20421: @1456183
     /* 1456183 */   GIM_Try, /*On fail goto*//*Label 20422*/ GIMT_Encode4(1456280), // Rule ID 7672 //
     /* 1456188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1456191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1456199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1456202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1456205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1456211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456238 */     // MIs[1] Operand 1
     /* 1456238 */     // No operand predicates
     /* 1456238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456242 */     // MIs[0] policy
     /* 1456242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1456257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456276 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456278 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456279 */     // GIR_Coverage, 7672,
     /* 1456279 */     GIR_EraseRootFromParent_Done,
     /* 1456280 */   // Label 20422: @1456280
     /* 1456280 */   GIM_Try, /*On fail goto*//*Label 20423*/ GIMT_Encode4(1456377), // Rule ID 7673 //
     /* 1456285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1456288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1456296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1456299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1456302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1456308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456335 */     // MIs[1] Operand 1
     /* 1456335 */     // No operand predicates
     /* 1456335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456339 */     // MIs[0] policy
     /* 1456339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456351 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_MF2_MASK),
     /* 1456354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456356 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456376 */     // GIR_Coverage, 7673,
     /* 1456376 */     GIR_EraseRootFromParent_Done,
     /* 1456377 */   // Label 20423: @1456377
     /* 1456377 */   GIM_Try, /*On fail goto*//*Label 20424*/ GIMT_Encode4(1456474), // Rule ID 7676 //
     /* 1456382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1456385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1456393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1456396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456432 */     // MIs[1] Operand 1
     /* 1456432 */     // No operand predicates
     /* 1456432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456436 */     // MIs[0] policy
     /* 1456436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1456451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456470 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456472 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456473 */     // GIR_Coverage, 7676,
     /* 1456473 */     GIR_EraseRootFromParent_Done,
     /* 1456474 */   // Label 20424: @1456474
     /* 1456474 */   GIM_Try, /*On fail goto*//*Label 20425*/ GIMT_Encode4(1456571), // Rule ID 7677 //
     /* 1456479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1456482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1456490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1456493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1456496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1456502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456529 */     // MIs[1] Operand 1
     /* 1456529 */     // No operand predicates
     /* 1456529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456533 */     // MIs[0] policy
     /* 1456533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456545 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M1_MASK),
     /* 1456548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456570 */     // GIR_Coverage, 7677,
     /* 1456570 */     GIR_EraseRootFromParent_Done,
     /* 1456571 */   // Label 20425: @1456571
     /* 1456571 */   GIM_Try, /*On fail goto*//*Label 20426*/ GIMT_Encode4(1456668), // Rule ID 7680 //
     /* 1456576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1456579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1456593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456622 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456626 */     // MIs[1] Operand 1
     /* 1456626 */     // No operand predicates
     /* 1456626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456630 */     // MIs[0] policy
     /* 1456630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1456645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456664 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456667 */     // GIR_Coverage, 7680,
     /* 1456667 */     GIR_EraseRootFromParent_Done,
     /* 1456668 */   // Label 20426: @1456668
     /* 1456668 */   GIM_Try, /*On fail goto*//*Label 20427*/ GIMT_Encode4(1456765), // Rule ID 7681 //
     /* 1456673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1456676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1456684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1456687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1456690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1456696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1456703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1456707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456723 */     // MIs[1] Operand 1
     /* 1456723 */     // No operand predicates
     /* 1456723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456727 */     // MIs[0] policy
     /* 1456727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M2_MASK),
     /* 1456742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456764 */     // GIR_Coverage, 7681,
     /* 1456764 */     GIR_EraseRootFromParent_Done,
     /* 1456765 */   // Label 20427: @1456765
     /* 1456765 */   GIM_Try, /*On fail goto*//*Label 20428*/ GIMT_Encode4(1456862), // Rule ID 7684 //
     /* 1456770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1456773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1456787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456820 */     // MIs[1] Operand 1
     /* 1456820 */     // No operand predicates
     /* 1456820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456824 */     // MIs[0] policy
     /* 1456824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456836 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1456836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1456839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456858 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456861 */     // GIR_Coverage, 7684,
     /* 1456861 */     GIR_EraseRootFromParent_Done,
     /* 1456862 */   // Label 20428: @1456862
     /* 1456862 */   GIM_Try, /*On fail goto*//*Label 20429*/ GIMT_Encode4(1456959), // Rule ID 7685 //
     /* 1456867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1456870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1456875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1456878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1456881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1456884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1456887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1456890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1456893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1456897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1456901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1456905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1456909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1456913 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1456917 */     // MIs[1] Operand 1
     /* 1456917 */     // No operand predicates
     /* 1456917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1456921 */     // MIs[0] policy
     /* 1456921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1456924 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1456926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1456933 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1456933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WI_M4_MASK),
     /* 1456936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1456938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1456940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1456942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1456945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1456947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1456952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1456955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1456957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1456958 */     // GIR_Coverage, 7685,
     /* 1456958 */     GIR_EraseRootFromParent_Done,
     /* 1456959 */   // Label 20429: @1456959
     /* 1456959 */   GIM_Try, /*On fail goto*//*Label 20430*/ GIMT_Encode4(1457059), // Rule ID 14114 //
     /* 1456964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1456967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1456972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1456975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1456978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1456981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1456984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1456987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1456990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1456994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1456998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457014 */     // MIs[1] Operand 1
     /* 1457014 */     // No operand predicates
     /* 1457014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457018 */     // MIs[0] policy
     /* 1457018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1457033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457058 */     // GIR_Coverage, 14114,
     /* 1457058 */     GIR_EraseRootFromParent_Done,
     /* 1457059 */   // Label 20430: @1457059
     /* 1457059 */   GIM_Try, /*On fail goto*//*Label 20431*/ GIMT_Encode4(1457159), // Rule ID 14115 //
     /* 1457064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1457075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1457078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1457081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457114 */     // MIs[1] Operand 1
     /* 1457114 */     // No operand predicates
     /* 1457114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457118 */     // MIs[0] policy
     /* 1457118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457130 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF8_MASK),
     /* 1457133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457158 */     // GIR_Coverage, 14115,
     /* 1457158 */     GIR_EraseRootFromParent_Done,
     /* 1457159 */   // Label 20431: @1457159
     /* 1457159 */   GIM_Try, /*On fail goto*//*Label 20432*/ GIMT_Encode4(1457259), // Rule ID 14118 //
     /* 1457164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1457181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457214 */     // MIs[1] Operand 1
     /* 1457214 */     // No operand predicates
     /* 1457214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457218 */     // MIs[0] policy
     /* 1457218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457230 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1457233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457258 */     // GIR_Coverage, 14118,
     /* 1457258 */     GIR_EraseRootFromParent_Done,
     /* 1457259 */   // Label 20432: @1457259
     /* 1457259 */   GIM_Try, /*On fail goto*//*Label 20433*/ GIMT_Encode4(1457359), // Rule ID 14119 //
     /* 1457264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1457275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1457278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1457281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457314 */     // MIs[1] Operand 1
     /* 1457314 */     // No operand predicates
     /* 1457314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457318 */     // MIs[0] policy
     /* 1457318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1457333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457358 */     // GIR_Coverage, 14119,
     /* 1457358 */     GIR_EraseRootFromParent_Done,
     /* 1457359 */   // Label 20433: @1457359
     /* 1457359 */   GIM_Try, /*On fail goto*//*Label 20434*/ GIMT_Encode4(1457459), // Rule ID 14122 //
     /* 1457364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1457375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1457378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1457381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457414 */     // MIs[1] Operand 1
     /* 1457414 */     // No operand predicates
     /* 1457414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457418 */     // MIs[0] policy
     /* 1457418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457430 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1457433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457458 */     // GIR_Coverage, 14122,
     /* 1457458 */     GIR_EraseRootFromParent_Done,
     /* 1457459 */   // Label 20434: @1457459
     /* 1457459 */   GIM_Try, /*On fail goto*//*Label 20435*/ GIMT_Encode4(1457559), // Rule ID 14123 //
     /* 1457464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1457475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1457478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1457481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1457487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457514 */     // MIs[1] Operand 1
     /* 1457514 */     // No operand predicates
     /* 1457514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457518 */     // MIs[0] policy
     /* 1457518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457530 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1457533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1457552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457558 */     // GIR_Coverage, 14123,
     /* 1457558 */     GIR_EraseRootFromParent_Done,
     /* 1457559 */   // Label 20435: @1457559
     /* 1457559 */   GIM_Try, /*On fail goto*//*Label 20436*/ GIMT_Encode4(1457659), // Rule ID 14126 //
     /* 1457564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1457575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1457578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457614 */     // MIs[1] Operand 1
     /* 1457614 */     // No operand predicates
     /* 1457614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457618 */     // MIs[0] policy
     /* 1457618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1457633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457658 */     // GIR_Coverage, 14126,
     /* 1457658 */     GIR_EraseRootFromParent_Done,
     /* 1457659 */   // Label 20436: @1457659
     /* 1457659 */   GIM_Try, /*On fail goto*//*Label 20437*/ GIMT_Encode4(1457759), // Rule ID 14127 //
     /* 1457664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1457675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1457678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1457681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457714 */     // MIs[1] Operand 1
     /* 1457714 */     // No operand predicates
     /* 1457714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457718 */     // MIs[0] policy
     /* 1457718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457730 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF4_MASK),
     /* 1457733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457758 */     // GIR_Coverage, 14127,
     /* 1457758 */     GIR_EraseRootFromParent_Done,
     /* 1457759 */   // Label 20437: @1457759
     /* 1457759 */   GIM_Try, /*On fail goto*//*Label 20438*/ GIMT_Encode4(1457859), // Rule ID 14130 //
     /* 1457764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1457775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1457778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1457781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457814 */     // MIs[1] Operand 1
     /* 1457814 */     // No operand predicates
     /* 1457814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457818 */     // MIs[0] policy
     /* 1457818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457830 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1457830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1457833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457858 */     // GIR_Coverage, 14130,
     /* 1457858 */     GIR_EraseRootFromParent_Done,
     /* 1457859 */   // Label 20438: @1457859
     /* 1457859 */   GIM_Try, /*On fail goto*//*Label 20439*/ GIMT_Encode4(1457959), // Rule ID 14131 //
     /* 1457864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1457867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1457875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1457878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1457881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1457884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1457887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1457890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1457906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1457910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1457914 */     // MIs[1] Operand 1
     /* 1457914 */     // No operand predicates
     /* 1457914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1457918 */     // MIs[0] policy
     /* 1457918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1457921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1457923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1457930 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1457930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1457933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1457935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1457937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1457939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1457942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1457944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1457949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1457952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1457954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1457957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1457958 */     // GIR_Coverage, 14131,
     /* 1457958 */     GIR_EraseRootFromParent_Done,
     /* 1457959 */   // Label 20439: @1457959
     /* 1457959 */   GIM_Try, /*On fail goto*//*Label 20440*/ GIMT_Encode4(1458059), // Rule ID 14134 //
     /* 1457964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1457967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1457972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1457975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1457978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1457981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1457984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1457987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1457990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1457994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1457998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458014 */     // MIs[1] Operand 1
     /* 1458014 */     // No operand predicates
     /* 1458014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458018 */     // MIs[0] policy
     /* 1458018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1458033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458058 */     // GIR_Coverage, 14134,
     /* 1458058 */     GIR_EraseRootFromParent_Done,
     /* 1458059 */   // Label 20440: @1458059
     /* 1458059 */   GIM_Try, /*On fail goto*//*Label 20441*/ GIMT_Encode4(1458159), // Rule ID 14135 //
     /* 1458064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1458075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1458078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1458081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458114 */     // MIs[1] Operand 1
     /* 1458114 */     // No operand predicates
     /* 1458114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458118 */     // MIs[0] policy
     /* 1458118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458130 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_MF2_MASK),
     /* 1458133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458158 */     // GIR_Coverage, 14135,
     /* 1458158 */     GIR_EraseRootFromParent_Done,
     /* 1458159 */   // Label 20441: @1458159
     /* 1458159 */   GIM_Try, /*On fail goto*//*Label 20442*/ GIMT_Encode4(1458259), // Rule ID 14138 //
     /* 1458164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1458181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458214 */     // MIs[1] Operand 1
     /* 1458214 */     // No operand predicates
     /* 1458214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458218 */     // MIs[0] policy
     /* 1458218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458230 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458258 */     // GIR_Coverage, 14138,
     /* 1458258 */     GIR_EraseRootFromParent_Done,
     /* 1458259 */   // Label 20442: @1458259
     /* 1458259 */   GIM_Try, /*On fail goto*//*Label 20443*/ GIMT_Encode4(1458359), // Rule ID 14139 //
     /* 1458264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1458275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1458278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1458281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1458287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458314 */     // MIs[1] Operand 1
     /* 1458314 */     // No operand predicates
     /* 1458314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458318 */     // MIs[0] policy
     /* 1458318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458330 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1458352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458358 */     // GIR_Coverage, 14139,
     /* 1458358 */     GIR_EraseRootFromParent_Done,
     /* 1458359 */   // Label 20443: @1458359
     /* 1458359 */   GIM_Try, /*On fail goto*//*Label 20444*/ GIMT_Encode4(1458459), // Rule ID 14142 //
     /* 1458364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1458375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1458378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458414 */     // MIs[1] Operand 1
     /* 1458414 */     // No operand predicates
     /* 1458414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458418 */     // MIs[0] policy
     /* 1458418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458458 */     // GIR_Coverage, 14142,
     /* 1458458 */     GIR_EraseRootFromParent_Done,
     /* 1458459 */   // Label 20444: @1458459
     /* 1458459 */   GIM_Try, /*On fail goto*//*Label 20445*/ GIMT_Encode4(1458559), // Rule ID 14143 //
     /* 1458464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1458475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1458478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1458481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1458487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458514 */     // MIs[1] Operand 1
     /* 1458514 */     // No operand predicates
     /* 1458514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458518 */     // MIs[0] policy
     /* 1458518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458530 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1458552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458558 */     // GIR_Coverage, 14143,
     /* 1458558 */     GIR_EraseRootFromParent_Done,
     /* 1458559 */   // Label 20445: @1458559
     /* 1458559 */   GIM_Try, /*On fail goto*//*Label 20446*/ GIMT_Encode4(1458659), // Rule ID 14146 //
     /* 1458564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1458575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1458578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1458581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458614 */     // MIs[1] Operand 1
     /* 1458614 */     // No operand predicates
     /* 1458614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458618 */     // MIs[0] policy
     /* 1458618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458630 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458658 */     // GIR_Coverage, 14146,
     /* 1458658 */     GIR_EraseRootFromParent_Done,
     /* 1458659 */   // Label 20446: @1458659
     /* 1458659 */   GIM_Try, /*On fail goto*//*Label 20447*/ GIMT_Encode4(1458759), // Rule ID 14147 //
     /* 1458664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1458667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1458675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1458678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1458681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1458687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458714 */     // MIs[1] Operand 1
     /* 1458714 */     // No operand predicates
     /* 1458714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458718 */     // MIs[0] policy
     /* 1458718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1458752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458758 */     // GIR_Coverage, 14147,
     /* 1458758 */     GIR_EraseRootFromParent_Done,
     /* 1458759 */   // Label 20447: @1458759
     /* 1458759 */   GIM_Try, /*On fail goto*//*Label 20448*/ GIMT_Encode4(1458859), // Rule ID 14150 //
     /* 1458764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1458767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1458775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1458778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1458781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458814 */     // MIs[1] Operand 1
     /* 1458814 */     // No operand predicates
     /* 1458814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458818 */     // MIs[0] policy
     /* 1458818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458830 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1458830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458858 */     // GIR_Coverage, 14150,
     /* 1458858 */     GIR_EraseRootFromParent_Done,
     /* 1458859 */   // Label 20448: @1458859
     /* 1458859 */   GIM_Try, /*On fail goto*//*Label 20449*/ GIMT_Encode4(1458959), // Rule ID 14151 //
     /* 1458864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1458867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1458875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1458878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1458881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1458884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1458887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1458890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1458894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1458902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1458906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1458910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1458914 */     // MIs[1] Operand 1
     /* 1458914 */     // No operand predicates
     /* 1458914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1458918 */     // MIs[0] policy
     /* 1458918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1458921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1458923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1458930 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1458930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M1_MASK),
     /* 1458933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1458935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1458937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1458939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1458942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1458944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1458949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1458952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1458954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1458957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1458958 */     // GIR_Coverage, 14151,
     /* 1458958 */     GIR_EraseRootFromParent_Done,
     /* 1458959 */   // Label 20449: @1458959
     /* 1458959 */   GIM_Try, /*On fail goto*//*Label 20450*/ GIMT_Encode4(1459059), // Rule ID 14154 //
     /* 1458964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1458967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1458972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1458975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1458978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1458981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1458984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1458987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1458990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1458994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1458998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459014 */     // MIs[1] Operand 1
     /* 1459014 */     // No operand predicates
     /* 1459014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459018 */     // MIs[0] policy
     /* 1459018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459030 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1459033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459058 */     // GIR_Coverage, 14154,
     /* 1459058 */     GIR_EraseRootFromParent_Done,
     /* 1459059 */   // Label 20450: @1459059
     /* 1459059 */   GIM_Try, /*On fail goto*//*Label 20451*/ GIMT_Encode4(1459159), // Rule ID 14155 //
     /* 1459064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1459075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1459078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1459081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459114 */     // MIs[1] Operand 1
     /* 1459114 */     // No operand predicates
     /* 1459114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459118 */     // MIs[0] policy
     /* 1459118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1459133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459158 */     // GIR_Coverage, 14155,
     /* 1459158 */     GIR_EraseRootFromParent_Done,
     /* 1459159 */   // Label 20451: @1459159
     /* 1459159 */   GIM_Try, /*On fail goto*//*Label 20452*/ GIMT_Encode4(1459259), // Rule ID 14158 //
     /* 1459164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1459181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459214 */     // MIs[1] Operand 1
     /* 1459214 */     // No operand predicates
     /* 1459214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459218 */     // MIs[0] policy
     /* 1459218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459230 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1459233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459258 */     // GIR_Coverage, 14158,
     /* 1459258 */     GIR_EraseRootFromParent_Done,
     /* 1459259 */   // Label 20452: @1459259
     /* 1459259 */   GIM_Try, /*On fail goto*//*Label 20453*/ GIMT_Encode4(1459359), // Rule ID 14159 //
     /* 1459264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1459275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1459278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1459281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459314 */     // MIs[1] Operand 1
     /* 1459314 */     // No operand predicates
     /* 1459314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459318 */     // MIs[0] policy
     /* 1459318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459330 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1459333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459358 */     // GIR_Coverage, 14159,
     /* 1459358 */     GIR_EraseRootFromParent_Done,
     /* 1459359 */   // Label 20453: @1459359
     /* 1459359 */   GIM_Try, /*On fail goto*//*Label 20454*/ GIMT_Encode4(1459459), // Rule ID 14162 //
     /* 1459364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1459375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1459378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1459381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1459387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459414 */     // MIs[1] Operand 1
     /* 1459414 */     // No operand predicates
     /* 1459414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459418 */     // MIs[0] policy
     /* 1459418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459430 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1459433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459458 */     // GIR_Coverage, 14162,
     /* 1459458 */     GIR_EraseRootFromParent_Done,
     /* 1459459 */   // Label 20454: @1459459
     /* 1459459 */   GIM_Try, /*On fail goto*//*Label 20455*/ GIMT_Encode4(1459559), // Rule ID 14163 //
     /* 1459464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1459475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1459478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1459481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1459487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459514 */     // MIs[1] Operand 1
     /* 1459514 */     // No operand predicates
     /* 1459514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459518 */     // MIs[0] policy
     /* 1459518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1459533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1459552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459558 */     // GIR_Coverage, 14163,
     /* 1459558 */     GIR_EraseRootFromParent_Done,
     /* 1459559 */   // Label 20455: @1459559
     /* 1459559 */   GIM_Try, /*On fail goto*//*Label 20456*/ GIMT_Encode4(1459659), // Rule ID 14166 //
     /* 1459564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459614 */     // MIs[1] Operand 1
     /* 1459614 */     // No operand predicates
     /* 1459614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459618 */     // MIs[0] policy
     /* 1459618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1459633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459658 */     // GIR_Coverage, 14166,
     /* 1459658 */     GIR_EraseRootFromParent_Done,
     /* 1459659 */   // Label 20456: @1459659
     /* 1459659 */   GIM_Try, /*On fail goto*//*Label 20457*/ GIMT_Encode4(1459759), // Rule ID 14167 //
     /* 1459664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1459675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1459678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1459681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1459687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1459694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1459702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459714 */     // MIs[1] Operand 1
     /* 1459714 */     // No operand predicates
     /* 1459714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459718 */     // MIs[0] policy
     /* 1459718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1459733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459758 */     // GIR_Coverage, 14167,
     /* 1459758 */     GIR_EraseRootFromParent_Done,
     /* 1459759 */   // Label 20457: @1459759
     /* 1459759 */   GIM_Try, /*On fail goto*//*Label 20458*/ GIMT_Encode4(1459859), // Rule ID 14170 //
     /* 1459764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459814 */     // MIs[1] Operand 1
     /* 1459814 */     // No operand predicates
     /* 1459814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459818 */     // MIs[0] policy
     /* 1459818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459830 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1459830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1459833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459858 */     // GIR_Coverage, 14170,
     /* 1459858 */     GIR_EraseRootFromParent_Done,
     /* 1459859 */   // Label 20458: @1459859
     /* 1459859 */   GIM_Try, /*On fail goto*//*Label 20459*/ GIMT_Encode4(1459959), // Rule ID 14171 //
     /* 1459864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1459867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1459875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1459878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1459881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1459884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1459887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1459890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1459894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1459902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1459906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1459910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1459914 */     // MIs[1] Operand 1
     /* 1459914 */     // No operand predicates
     /* 1459914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1459918 */     // MIs[0] policy
     /* 1459918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1459921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1459923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1459930 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1459930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1459933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1459935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1459937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1459939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1459942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1459944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1459949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1459952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1459954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1459957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1459958 */     // GIR_Coverage, 14171,
     /* 1459958 */     GIR_EraseRootFromParent_Done,
     /* 1459959 */   // Label 20459: @1459959
     /* 1459959 */   GIM_Try, /*On fail goto*//*Label 20460*/ GIMT_Encode4(1460059), // Rule ID 14174 //
     /* 1459964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1459967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1459972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1459975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1459978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1459981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1459984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1459987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1459990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1459994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1459998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460014 */     // MIs[1] Operand 1
     /* 1460014 */     // No operand predicates
     /* 1460014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460018 */     // MIs[0] policy
     /* 1460018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460030 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1460033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460058 */     // GIR_Coverage, 14174,
     /* 1460058 */     GIR_EraseRootFromParent_Done,
     /* 1460059 */   // Label 20460: @1460059
     /* 1460059 */   GIM_Try, /*On fail goto*//*Label 20461*/ GIMT_Encode4(1460159), // Rule ID 14175 //
     /* 1460064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1460075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1460078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1460081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1460087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460114 */     // MIs[1] Operand 1
     /* 1460114 */     // No operand predicates
     /* 1460114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460118 */     // MIs[0] policy
     /* 1460118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460130 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1460133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1460152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460158 */     // GIR_Coverage, 14175,
     /* 1460158 */     GIR_EraseRootFromParent_Done,
     /* 1460159 */   // Label 20461: @1460159
     /* 1460159 */   GIM_Try, /*On fail goto*//*Label 20462*/ GIMT_Encode4(1460259), // Rule ID 14178 //
     /* 1460164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460214 */     // MIs[1] Operand 1
     /* 1460214 */     // No operand predicates
     /* 1460214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460218 */     // MIs[0] policy
     /* 1460218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1460233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460258 */     // GIR_Coverage, 14178,
     /* 1460258 */     GIR_EraseRootFromParent_Done,
     /* 1460259 */   // Label 20462: @1460259
     /* 1460259 */   GIM_Try, /*On fail goto*//*Label 20463*/ GIMT_Encode4(1460359), // Rule ID 14179 //
     /* 1460264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1460275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1460278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1460281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460314 */     // MIs[1] Operand 1
     /* 1460314 */     // No operand predicates
     /* 1460314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460318 */     // MIs[0] policy
     /* 1460318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1460333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460358 */     // GIR_Coverage, 14179,
     /* 1460358 */     GIR_EraseRootFromParent_Done,
     /* 1460359 */   // Label 20463: @1460359
     /* 1460359 */   GIM_Try, /*On fail goto*//*Label 20464*/ GIMT_Encode4(1460459), // Rule ID 14182 //
     /* 1460364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460414 */     // MIs[1] Operand 1
     /* 1460414 */     // No operand predicates
     /* 1460414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460418 */     // MIs[0] policy
     /* 1460418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1460433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460458 */     // GIR_Coverage, 14182,
     /* 1460458 */     GIR_EraseRootFromParent_Done,
     /* 1460459 */   // Label 20464: @1460459
     /* 1460459 */   GIM_Try, /*On fail goto*//*Label 20465*/ GIMT_Encode4(1460559), // Rule ID 14183 //
     /* 1460464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1460475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1460478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1460481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1460487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460514 */     // MIs[1] Operand 1
     /* 1460514 */     // No operand predicates
     /* 1460514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460518 */     // MIs[0] policy
     /* 1460518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1460533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460558 */     // GIR_Coverage, 14183,
     /* 1460558 */     GIR_EraseRootFromParent_Done,
     /* 1460559 */   // Label 20465: @1460559
     /* 1460559 */   GIM_Try, /*On fail goto*//*Label 20466*/ GIMT_Encode4(1460659), // Rule ID 14186 //
     /* 1460564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1460567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1460575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1460578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460614 */     // MIs[1] Operand 1
     /* 1460614 */     // No operand predicates
     /* 1460614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460618 */     // MIs[0] policy
     /* 1460618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460630 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1460633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460658 */     // GIR_Coverage, 14186,
     /* 1460658 */     GIR_EraseRootFromParent_Done,
     /* 1460659 */   // Label 20466: @1460659
     /* 1460659 */   GIM_Try, /*On fail goto*//*Label 20467*/ GIMT_Encode4(1460759), // Rule ID 14187 //
     /* 1460664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1460667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1460675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1460678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1460681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1460687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1460694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1460702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460714 */     // MIs[1] Operand 1
     /* 1460714 */     // No operand predicates
     /* 1460714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460718 */     // MIs[0] policy
     /* 1460718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460730 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1460733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1460752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460758 */     // GIR_Coverage, 14187,
     /* 1460758 */     GIR_EraseRootFromParent_Done,
     /* 1460759 */   // Label 20467: @1460759
     /* 1460759 */   GIM_Try, /*On fail goto*//*Label 20468*/ GIMT_Encode4(1460859), // Rule ID 14190 //
     /* 1460764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1460767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1460775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1460778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460814 */     // MIs[1] Operand 1
     /* 1460814 */     // No operand predicates
     /* 1460814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460818 */     // MIs[0] policy
     /* 1460818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460830 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1460830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1460833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1460852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460858 */     // GIR_Coverage, 14190,
     /* 1460858 */     GIR_EraseRootFromParent_Done,
     /* 1460859 */   // Label 20468: @1460859
     /* 1460859 */   GIM_Try, /*On fail goto*//*Label 20469*/ GIMT_Encode4(1460959), // Rule ID 14191 //
     /* 1460864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1460867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1460875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1460878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1460881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1460884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1460887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1460890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1460894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1460902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1460906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1460910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1460914 */     // MIs[1] Operand 1
     /* 1460914 */     // No operand predicates
     /* 1460914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1460918 */     // MIs[0] policy
     /* 1460918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1460921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1460923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1460930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1460930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M2_MASK),
     /* 1460933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1460935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1460937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1460939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1460942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1460944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1460949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1460952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1460954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1460957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1460958 */     // GIR_Coverage, 14191,
     /* 1460958 */     GIR_EraseRootFromParent_Done,
     /* 1460959 */   // Label 20469: @1460959
     /* 1460959 */   GIM_Try, /*On fail goto*//*Label 20470*/ GIMT_Encode4(1461059), // Rule ID 14194 //
     /* 1460964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1460967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1460972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1460975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1460978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1460981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1460984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1460987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1460990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1460994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1460998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461014 */     // MIs[1] Operand 1
     /* 1461014 */     // No operand predicates
     /* 1461014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461018 */     // MIs[0] policy
     /* 1461018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1461033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461058 */     // GIR_Coverage, 14194,
     /* 1461058 */     GIR_EraseRootFromParent_Done,
     /* 1461059 */   // Label 20470: @1461059
     /* 1461059 */   GIM_Try, /*On fail goto*//*Label 20471*/ GIMT_Encode4(1461159), // Rule ID 14195 //
     /* 1461064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1461067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1461075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1461078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1461081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1461094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1461102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461114 */     // MIs[1] Operand 1
     /* 1461114 */     // No operand predicates
     /* 1461114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461118 */     // MIs[0] policy
     /* 1461118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461130 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M4_MASK),
     /* 1461133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461158 */     // GIR_Coverage, 14195,
     /* 1461158 */     GIR_EraseRootFromParent_Done,
     /* 1461159 */   // Label 20471: @1461159
     /* 1461159 */   GIM_Try, /*On fail goto*//*Label 20472*/ GIMT_Encode4(1461259), // Rule ID 14198 //
     /* 1461164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1461167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461214 */     // MIs[1] Operand 1
     /* 1461214 */     // No operand predicates
     /* 1461214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461218 */     // MIs[0] policy
     /* 1461218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461230 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1461233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461258 */     // GIR_Coverage, 14198,
     /* 1461258 */     GIR_EraseRootFromParent_Done,
     /* 1461259 */   // Label 20472: @1461259
     /* 1461259 */   GIM_Try, /*On fail goto*//*Label 20473*/ GIMT_Encode4(1461359), // Rule ID 14199 //
     /* 1461264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1461267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1461272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1461275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1461278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1461281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1461287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1461294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1461302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461314 */     // MIs[1] Operand 1
     /* 1461314 */     // No operand predicates
     /* 1461314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461318 */     // MIs[0] policy
     /* 1461318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VI_M8_MASK),
     /* 1461333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1461352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461358 */     // GIR_Coverage, 14199,
     /* 1461358 */     GIR_EraseRootFromParent_Done,
     /* 1461359 */   // Label 20473: @1461359
     /* 1461359 */   GIM_Try, /*On fail goto*//*Label 20474*/ GIMT_Encode4(1461459), // Rule ID 14378 //
     /* 1461364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1461381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461414 */     // MIs[1] Operand 1
     /* 1461414 */     // No operand predicates
     /* 1461414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461418 */     // MIs[0] policy
     /* 1461418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461430 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1461433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461458 */     // GIR_Coverage, 14378,
     /* 1461458 */     GIR_EraseRootFromParent_Done,
     /* 1461459 */   // Label 20474: @1461459
     /* 1461459 */   GIM_Try, /*On fail goto*//*Label 20475*/ GIMT_Encode4(1461559), // Rule ID 14379 //
     /* 1461464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1461475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1461478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1461481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461514 */     // MIs[1] Operand 1
     /* 1461514 */     // No operand predicates
     /* 1461514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461518 */     // MIs[0] policy
     /* 1461518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461530 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF8_MASK),
     /* 1461533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461558 */     // GIR_Coverage, 14379,
     /* 1461558 */     GIR_EraseRootFromParent_Done,
     /* 1461559 */   // Label 20475: @1461559
     /* 1461559 */   GIM_Try, /*On fail goto*//*Label 20476*/ GIMT_Encode4(1461659), // Rule ID 14382 //
     /* 1461564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1461581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461614 */     // MIs[1] Operand 1
     /* 1461614 */     // No operand predicates
     /* 1461614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461618 */     // MIs[0] policy
     /* 1461618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461630 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1461633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461658 */     // GIR_Coverage, 14382,
     /* 1461658 */     GIR_EraseRootFromParent_Done,
     /* 1461659 */   // Label 20476: @1461659
     /* 1461659 */   GIM_Try, /*On fail goto*//*Label 20477*/ GIMT_Encode4(1461759), // Rule ID 14383 //
     /* 1461664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1461675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1461678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1461681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1461687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461714 */     // MIs[1] Operand 1
     /* 1461714 */     // No operand predicates
     /* 1461714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461718 */     // MIs[0] policy
     /* 1461718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461730 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1461733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461758 */     // GIR_Coverage, 14383,
     /* 1461758 */     GIR_EraseRootFromParent_Done,
     /* 1461759 */   // Label 20477: @1461759
     /* 1461759 */   GIM_Try, /*On fail goto*//*Label 20478*/ GIMT_Encode4(1461859), // Rule ID 14386 //
     /* 1461764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1461781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461814 */     // MIs[1] Operand 1
     /* 1461814 */     // No operand predicates
     /* 1461814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461818 */     // MIs[0] policy
     /* 1461818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461830 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1461830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1461833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461858 */     // GIR_Coverage, 14386,
     /* 1461858 */     GIR_EraseRootFromParent_Done,
     /* 1461859 */   // Label 20478: @1461859
     /* 1461859 */   GIM_Try, /*On fail goto*//*Label 20479*/ GIMT_Encode4(1461959), // Rule ID 14387 //
     /* 1461864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1461867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1461875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1461878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1461881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1461884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1461887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1461890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1461906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1461910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1461914 */     // MIs[1] Operand 1
     /* 1461914 */     // No operand predicates
     /* 1461914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1461918 */     // MIs[0] policy
     /* 1461918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1461921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1461923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1461930 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1461930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1461933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1461935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1461937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1461939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1461942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1461944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1461949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1461952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1461954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1461957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1461958 */     // GIR_Coverage, 14387,
     /* 1461958 */     GIR_EraseRootFromParent_Done,
     /* 1461959 */   // Label 20479: @1461959
     /* 1461959 */   GIM_Try, /*On fail goto*//*Label 20480*/ GIMT_Encode4(1462059), // Rule ID 14390 //
     /* 1461964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1461967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1461972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1461975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1461978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1461981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1461984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1461987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1461990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1461994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1461998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462014 */     // MIs[1] Operand 1
     /* 1462014 */     // No operand predicates
     /* 1462014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462018 */     // MIs[0] policy
     /* 1462018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462030 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1462033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462058 */     // GIR_Coverage, 14390,
     /* 1462058 */     GIR_EraseRootFromParent_Done,
     /* 1462059 */   // Label 20480: @1462059
     /* 1462059 */   GIM_Try, /*On fail goto*//*Label 20481*/ GIMT_Encode4(1462159), // Rule ID 14391 //
     /* 1462064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1462075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1462078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1462081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462114 */     // MIs[1] Operand 1
     /* 1462114 */     // No operand predicates
     /* 1462114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462118 */     // MIs[0] policy
     /* 1462118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF4_MASK),
     /* 1462133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462158 */     // GIR_Coverage, 14391,
     /* 1462158 */     GIR_EraseRootFromParent_Done,
     /* 1462159 */   // Label 20481: @1462159
     /* 1462159 */   GIM_Try, /*On fail goto*//*Label 20482*/ GIMT_Encode4(1462259), // Rule ID 14394 //
     /* 1462164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1462181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462214 */     // MIs[1] Operand 1
     /* 1462214 */     // No operand predicates
     /* 1462214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462218 */     // MIs[0] policy
     /* 1462218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462230 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1462233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462258 */     // GIR_Coverage, 14394,
     /* 1462258 */     GIR_EraseRootFromParent_Done,
     /* 1462259 */   // Label 20482: @1462259
     /* 1462259 */   GIM_Try, /*On fail goto*//*Label 20483*/ GIMT_Encode4(1462359), // Rule ID 14395 //
     /* 1462264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1462275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1462278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1462281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462314 */     // MIs[1] Operand 1
     /* 1462314 */     // No operand predicates
     /* 1462314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462318 */     // MIs[0] policy
     /* 1462318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462330 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1462333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462358 */     // GIR_Coverage, 14395,
     /* 1462358 */     GIR_EraseRootFromParent_Done,
     /* 1462359 */   // Label 20483: @1462359
     /* 1462359 */   GIM_Try, /*On fail goto*//*Label 20484*/ GIMT_Encode4(1462459), // Rule ID 14398 //
     /* 1462364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462414 */     // MIs[1] Operand 1
     /* 1462414 */     // No operand predicates
     /* 1462414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462418 */     // MIs[0] policy
     /* 1462418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1462433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462458 */     // GIR_Coverage, 14398,
     /* 1462458 */     GIR_EraseRootFromParent_Done,
     /* 1462459 */   // Label 20484: @1462459
     /* 1462459 */   GIM_Try, /*On fail goto*//*Label 20485*/ GIMT_Encode4(1462559), // Rule ID 14399 //
     /* 1462464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1462475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1462478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1462481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1462487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462514 */     // MIs[1] Operand 1
     /* 1462514 */     // No operand predicates
     /* 1462514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462518 */     // MIs[0] policy
     /* 1462518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462530 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_MF2_MASK),
     /* 1462533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1462552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462558 */     // GIR_Coverage, 14399,
     /* 1462558 */     GIR_EraseRootFromParent_Done,
     /* 1462559 */   // Label 20485: @1462559
     /* 1462559 */   GIM_Try, /*On fail goto*//*Label 20486*/ GIMT_Encode4(1462659), // Rule ID 14402 //
     /* 1462564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1462581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462614 */     // MIs[1] Operand 1
     /* 1462614 */     // No operand predicates
     /* 1462614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462618 */     // MIs[0] policy
     /* 1462618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1462633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462658 */     // GIR_Coverage, 14402,
     /* 1462658 */     GIR_EraseRootFromParent_Done,
     /* 1462659 */   // Label 20486: @1462659
     /* 1462659 */   GIM_Try, /*On fail goto*//*Label 20487*/ GIMT_Encode4(1462759), // Rule ID 14403 //
     /* 1462664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1462675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1462678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1462681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1462687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462714 */     // MIs[1] Operand 1
     /* 1462714 */     // No operand predicates
     /* 1462714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462718 */     // MIs[0] policy
     /* 1462718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1462733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1462752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462758 */     // GIR_Coverage, 14403,
     /* 1462758 */     GIR_EraseRootFromParent_Done,
     /* 1462759 */   // Label 20487: @1462759
     /* 1462759 */   GIM_Try, /*On fail goto*//*Label 20488*/ GIMT_Encode4(1462859), // Rule ID 14406 //
     /* 1462764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462814 */     // MIs[1] Operand 1
     /* 1462814 */     // No operand predicates
     /* 1462814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462818 */     // MIs[0] policy
     /* 1462818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1462830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1462833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462858 */     // GIR_Coverage, 14406,
     /* 1462858 */     GIR_EraseRootFromParent_Done,
     /* 1462859 */   // Label 20488: @1462859
     /* 1462859 */   GIM_Try, /*On fail goto*//*Label 20489*/ GIMT_Encode4(1462959), // Rule ID 14407 //
     /* 1462864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1462867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1462875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1462878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1462881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1462884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1462887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1462890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1462906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1462910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1462914 */     // MIs[1] Operand 1
     /* 1462914 */     // No operand predicates
     /* 1462914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1462918 */     // MIs[0] policy
     /* 1462918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1462921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1462923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1462930 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1462930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1462933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1462935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1462937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1462939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1462942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1462944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1462949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1462952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1462954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1462957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1462958 */     // GIR_Coverage, 14407,
     /* 1462958 */     GIR_EraseRootFromParent_Done,
     /* 1462959 */   // Label 20489: @1462959
     /* 1462959 */   GIM_Try, /*On fail goto*//*Label 20490*/ GIMT_Encode4(1463059), // Rule ID 14410 //
     /* 1462964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1462967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1462972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1462975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1462978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1462981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1462984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1462987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1462990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1462994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1462998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463014 */     // MIs[1] Operand 1
     /* 1463014 */     // No operand predicates
     /* 1463014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463018 */     // MIs[0] policy
     /* 1463018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463030 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1463033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463058 */     // GIR_Coverage, 14410,
     /* 1463058 */     GIR_EraseRootFromParent_Done,
     /* 1463059 */   // Label 20490: @1463059
     /* 1463059 */   GIM_Try, /*On fail goto*//*Label 20491*/ GIMT_Encode4(1463159), // Rule ID 14411 //
     /* 1463064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1463075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1463078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1463081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1463087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463114 */     // MIs[1] Operand 1
     /* 1463114 */     // No operand predicates
     /* 1463114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463118 */     // MIs[0] policy
     /* 1463118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463130 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1463133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1463152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463158 */     // GIR_Coverage, 14411,
     /* 1463158 */     GIR_EraseRootFromParent_Done,
     /* 1463159 */   // Label 20491: @1463159
     /* 1463159 */   GIM_Try, /*On fail goto*//*Label 20492*/ GIMT_Encode4(1463259), // Rule ID 14414 //
     /* 1463164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1463167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1463175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1463178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463214 */     // MIs[1] Operand 1
     /* 1463214 */     // No operand predicates
     /* 1463214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463218 */     // MIs[0] policy
     /* 1463218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1463233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463258 */     // GIR_Coverage, 14414,
     /* 1463258 */     GIR_EraseRootFromParent_Done,
     /* 1463259 */   // Label 20492: @1463259
     /* 1463259 */   GIM_Try, /*On fail goto*//*Label 20493*/ GIMT_Encode4(1463359), // Rule ID 14415 //
     /* 1463264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1463267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1463275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1463278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1463281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1463287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1463294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1463302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463314 */     // MIs[1] Operand 1
     /* 1463314 */     // No operand predicates
     /* 1463314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463318 */     // MIs[0] policy
     /* 1463318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463330 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M1_MASK),
     /* 1463333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1463352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463358 */     // GIR_Coverage, 14415,
     /* 1463358 */     GIR_EraseRootFromParent_Done,
     /* 1463359 */   // Label 20493: @1463359
     /* 1463359 */   GIM_Try, /*On fail goto*//*Label 20494*/ GIMT_Encode4(1463459), // Rule ID 14418 //
     /* 1463364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1463375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1463378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1463381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463414 */     // MIs[1] Operand 1
     /* 1463414 */     // No operand predicates
     /* 1463414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463418 */     // MIs[0] policy
     /* 1463418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463430 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1463433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463458 */     // GIR_Coverage, 14418,
     /* 1463458 */     GIR_EraseRootFromParent_Done,
     /* 1463459 */   // Label 20494: @1463459
     /* 1463459 */   GIM_Try, /*On fail goto*//*Label 20495*/ GIMT_Encode4(1463559), // Rule ID 14419 //
     /* 1463464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1463475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1463478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1463481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1463487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463514 */     // MIs[1] Operand 1
     /* 1463514 */     // No operand predicates
     /* 1463514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463518 */     // MIs[0] policy
     /* 1463518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463530 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1463533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463558 */     // GIR_Coverage, 14419,
     /* 1463558 */     GIR_EraseRootFromParent_Done,
     /* 1463559 */   // Label 20495: @1463559
     /* 1463559 */   GIM_Try, /*On fail goto*//*Label 20496*/ GIMT_Encode4(1463659), // Rule ID 14422 //
     /* 1463564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1463575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1463578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1463581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1463587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463614 */     // MIs[1] Operand 1
     /* 1463614 */     // No operand predicates
     /* 1463614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463618 */     // MIs[0] policy
     /* 1463618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463630 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1463633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463658 */     // GIR_Coverage, 14422,
     /* 1463658 */     GIR_EraseRootFromParent_Done,
     /* 1463659 */   // Label 20496: @1463659
     /* 1463659 */   GIM_Try, /*On fail goto*//*Label 20497*/ GIMT_Encode4(1463759), // Rule ID 14423 //
     /* 1463664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1463675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1463678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1463681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1463687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1463694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1463702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463714 */     // MIs[1] Operand 1
     /* 1463714 */     // No operand predicates
     /* 1463714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463718 */     // MIs[0] policy
     /* 1463718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463730 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1463733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463758 */     // GIR_Coverage, 14423,
     /* 1463758 */     GIR_EraseRootFromParent_Done,
     /* 1463759 */   // Label 20497: @1463759
     /* 1463759 */   GIM_Try, /*On fail goto*//*Label 20498*/ GIMT_Encode4(1463859), // Rule ID 14426 //
     /* 1463764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1463775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1463778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1463781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1463787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463814 */     // MIs[1] Operand 1
     /* 1463814 */     // No operand predicates
     /* 1463814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463818 */     // MIs[0] policy
     /* 1463818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463830 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1463830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1463833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463858 */     // GIR_Coverage, 14426,
     /* 1463858 */     GIR_EraseRootFromParent_Done,
     /* 1463859 */   // Label 20498: @1463859
     /* 1463859 */   GIM_Try, /*On fail goto*//*Label 20499*/ GIMT_Encode4(1463959), // Rule ID 14427 //
     /* 1463864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1463867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1463875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1463878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1463881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1463884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1463887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1463890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1463894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1463902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1463906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1463910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1463914 */     // MIs[1] Operand 1
     /* 1463914 */     // No operand predicates
     /* 1463914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1463918 */     // MIs[0] policy
     /* 1463918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1463921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1463923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1463930 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1463930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1463933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1463935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1463937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1463939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1463942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1463944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1463949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1463952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1463954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1463957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1463958 */     // GIR_Coverage, 14427,
     /* 1463958 */     GIR_EraseRootFromParent_Done,
     /* 1463959 */   // Label 20499: @1463959
     /* 1463959 */   GIM_Try, /*On fail goto*//*Label 20500*/ GIMT_Encode4(1464059), // Rule ID 14430 //
     /* 1463964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1463967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1463972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1463975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1463978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1463981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1463984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1463987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1463990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1463994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1463998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464014 */     // MIs[1] Operand 1
     /* 1464014 */     // No operand predicates
     /* 1464014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464018 */     // MIs[0] policy
     /* 1464018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1464033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464058 */     // GIR_Coverage, 14430,
     /* 1464058 */     GIR_EraseRootFromParent_Done,
     /* 1464059 */   // Label 20500: @1464059
     /* 1464059 */   GIM_Try, /*On fail goto*//*Label 20501*/ GIMT_Encode4(1464159), // Rule ID 14431 //
     /* 1464064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1464075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1464078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1464081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464114 */     // MIs[1] Operand 1
     /* 1464114 */     // No operand predicates
     /* 1464114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464118 */     // MIs[0] policy
     /* 1464118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1464133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464158 */     // GIR_Coverage, 14431,
     /* 1464158 */     GIR_EraseRootFromParent_Done,
     /* 1464159 */   // Label 20501: @1464159
     /* 1464159 */   GIM_Try, /*On fail goto*//*Label 20502*/ GIMT_Encode4(1464259), // Rule ID 14434 //
     /* 1464164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1464175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1464178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1464181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464214 */     // MIs[1] Operand 1
     /* 1464214 */     // No operand predicates
     /* 1464214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464218 */     // MIs[0] policy
     /* 1464218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464230 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1464233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464258 */     // GIR_Coverage, 14434,
     /* 1464258 */     GIR_EraseRootFromParent_Done,
     /* 1464259 */   // Label 20502: @1464259
     /* 1464259 */   GIM_Try, /*On fail goto*//*Label 20503*/ GIMT_Encode4(1464359), // Rule ID 14435 //
     /* 1464264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1464275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1464278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1464281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464314 */     // MIs[1] Operand 1
     /* 1464314 */     // No operand predicates
     /* 1464314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464318 */     // MIs[0] policy
     /* 1464318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464330 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1464333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464358 */     // GIR_Coverage, 14435,
     /* 1464358 */     GIR_EraseRootFromParent_Done,
     /* 1464359 */   // Label 20503: @1464359
     /* 1464359 */   GIM_Try, /*On fail goto*//*Label 20504*/ GIMT_Encode4(1464459), // Rule ID 14438 //
     /* 1464364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1464375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1464378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1464381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1464387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464414 */     // MIs[1] Operand 1
     /* 1464414 */     // No operand predicates
     /* 1464414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464418 */     // MIs[0] policy
     /* 1464418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464430 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1464433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464458 */     // GIR_Coverage, 14438,
     /* 1464458 */     GIR_EraseRootFromParent_Done,
     /* 1464459 */   // Label 20504: @1464459
     /* 1464459 */   GIM_Try, /*On fail goto*//*Label 20505*/ GIMT_Encode4(1464559), // Rule ID 14439 //
     /* 1464464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1464475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1464478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1464481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1464487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464514 */     // MIs[1] Operand 1
     /* 1464514 */     // No operand predicates
     /* 1464514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464518 */     // MIs[0] policy
     /* 1464518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1464533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1464552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464558 */     // GIR_Coverage, 14439,
     /* 1464558 */     GIR_EraseRootFromParent_Done,
     /* 1464559 */   // Label 20505: @1464559
     /* 1464559 */   GIM_Try, /*On fail goto*//*Label 20506*/ GIMT_Encode4(1464659), // Rule ID 14442 //
     /* 1464564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1464581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464614 */     // MIs[1] Operand 1
     /* 1464614 */     // No operand predicates
     /* 1464614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464618 */     // MIs[0] policy
     /* 1464618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1464633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464658 */     // GIR_Coverage, 14442,
     /* 1464658 */     GIR_EraseRootFromParent_Done,
     /* 1464659 */   // Label 20506: @1464659
     /* 1464659 */   GIM_Try, /*On fail goto*//*Label 20507*/ GIMT_Encode4(1464759), // Rule ID 14443 //
     /* 1464664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1464675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1464678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1464681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1464687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1464694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1464702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464714 */     // MIs[1] Operand 1
     /* 1464714 */     // No operand predicates
     /* 1464714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464718 */     // MIs[0] policy
     /* 1464718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1464733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464758 */     // GIR_Coverage, 14443,
     /* 1464758 */     GIR_EraseRootFromParent_Done,
     /* 1464759 */   // Label 20507: @1464759
     /* 1464759 */   GIM_Try, /*On fail goto*//*Label 20508*/ GIMT_Encode4(1464859), // Rule ID 14446 //
     /* 1464764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1464781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464814 */     // MIs[1] Operand 1
     /* 1464814 */     // No operand predicates
     /* 1464814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464818 */     // MIs[0] policy
     /* 1464818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464830 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1464830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1464833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464854 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464858 */     // GIR_Coverage, 14446,
     /* 1464858 */     GIR_EraseRootFromParent_Done,
     /* 1464859 */   // Label 20508: @1464859
     /* 1464859 */   GIM_Try, /*On fail goto*//*Label 20509*/ GIMT_Encode4(1464959), // Rule ID 14447 //
     /* 1464864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1464867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1464875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1464878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1464881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1464884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1464887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1464890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1464894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1464902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1464906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1464910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1464914 */     // MIs[1] Operand 1
     /* 1464914 */     // No operand predicates
     /* 1464914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1464918 */     // MIs[0] policy
     /* 1464918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1464921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1464923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1464930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1464930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1464933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1464935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1464937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1464939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1464942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1464944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1464949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1464952 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1464954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1464957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1464958 */     // GIR_Coverage, 14447,
     /* 1464958 */     GIR_EraseRootFromParent_Done,
     /* 1464959 */   // Label 20509: @1464959
     /* 1464959 */   GIM_Try, /*On fail goto*//*Label 20510*/ GIMT_Encode4(1465059), // Rule ID 14450 //
     /* 1464964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1464967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1464972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1464975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1464978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1464981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1464984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1464987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1464990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1464994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1464998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465014 */     // MIs[1] Operand 1
     /* 1465014 */     // No operand predicates
     /* 1465014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465018 */     // MIs[0] policy
     /* 1465018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1465033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465052 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465054 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465058 */     // GIR_Coverage, 14450,
     /* 1465058 */     GIR_EraseRootFromParent_Done,
     /* 1465059 */   // Label 20510: @1465059
     /* 1465059 */   GIM_Try, /*On fail goto*//*Label 20511*/ GIMT_Encode4(1465159), // Rule ID 14451 //
     /* 1465064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1465075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1465078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1465081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1465087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465110 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465114 */     // MIs[1] Operand 1
     /* 1465114 */     // No operand predicates
     /* 1465114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465118 */     // MIs[0] policy
     /* 1465118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1465133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1465152 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465154 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465158 */     // GIR_Coverage, 14451,
     /* 1465158 */     GIR_EraseRootFromParent_Done,
     /* 1465159 */   // Label 20511: @1465159
     /* 1465159 */   GIM_Try, /*On fail goto*//*Label 20512*/ GIMT_Encode4(1465259), // Rule ID 14454 //
     /* 1465164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1465175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1465178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1465181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465214 */     // MIs[1] Operand 1
     /* 1465214 */     // No operand predicates
     /* 1465214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465218 */     // MIs[0] policy
     /* 1465218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465230 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1465233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465254 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465258 */     // GIR_Coverage, 14454,
     /* 1465258 */     GIR_EraseRootFromParent_Done,
     /* 1465259 */   // Label 20512: @1465259
     /* 1465259 */   GIM_Try, /*On fail goto*//*Label 20513*/ GIMT_Encode4(1465359), // Rule ID 14455 //
     /* 1465264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1465275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1465278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1465281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1465294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1465302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465314 */     // MIs[1] Operand 1
     /* 1465314 */     // No operand predicates
     /* 1465314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465318 */     // MIs[0] policy
     /* 1465318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465330 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M2_MASK),
     /* 1465333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465358 */     // GIR_Coverage, 14455,
     /* 1465358 */     GIR_EraseRootFromParent_Done,
     /* 1465359 */   // Label 20513: @1465359
     /* 1465359 */   GIM_Try, /*On fail goto*//*Label 20514*/ GIMT_Encode4(1465459), // Rule ID 14458 //
     /* 1465364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1465375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1465378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1465381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465414 */     // MIs[1] Operand 1
     /* 1465414 */     // No operand predicates
     /* 1465414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465418 */     // MIs[0] policy
     /* 1465418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465430 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1465433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465458 */     // GIR_Coverage, 14458,
     /* 1465458 */     GIR_EraseRootFromParent_Done,
     /* 1465459 */   // Label 20514: @1465459
     /* 1465459 */   GIM_Try, /*On fail goto*//*Label 20515*/ GIMT_Encode4(1465559), // Rule ID 14459 //
     /* 1465464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1465475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1465478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1465481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1465487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1465494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1465502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465514 */     // MIs[1] Operand 1
     /* 1465514 */     // No operand predicates
     /* 1465514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465518 */     // MIs[0] policy
     /* 1465518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465530 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M4_MASK),
     /* 1465533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465558 */     // GIR_Coverage, 14459,
     /* 1465558 */     GIR_EraseRootFromParent_Done,
     /* 1465559 */   // Label 20515: @1465559
     /* 1465559 */   GIM_Try, /*On fail goto*//*Label 20516*/ GIMT_Encode4(1465659), // Rule ID 14462 //
     /* 1465564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1465567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1465575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1465578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1465581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465610 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465614 */     // MIs[1] Operand 1
     /* 1465614 */     // No operand predicates
     /* 1465614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465618 */     // MIs[0] policy
     /* 1465618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465630 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1465633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465658 */     // GIR_Coverage, 14462,
     /* 1465658 */     GIR_EraseRootFromParent_Done,
     /* 1465659 */   // Label 20516: @1465659
     /* 1465659 */   GIM_Try, /*On fail goto*//*Label 20517*/ GIMT_Encode4(1465759), // Rule ID 14463 //
     /* 1465664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1465667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1465672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1465675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1465678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1465681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1465687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1465694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1465702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm5),
     /* 1465714 */     // MIs[1] Operand 1
     /* 1465714 */     // No operand predicates
     /* 1465714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465718 */     // MIs[0] policy
     /* 1465718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465721 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465730 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VI_M8_MASK),
     /* 1465733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1465737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1465752 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465754 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1465757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465758 */     // GIR_Coverage, 14463,
     /* 1465758 */     GIR_EraseRootFromParent_Done,
     /* 1465759 */   // Label 20517: @1465759
     /* 1465759 */   GIM_Try, /*On fail goto*//*Label 20518*/ GIMT_Encode4(1465856), // Rule ID 23582 //
     /* 1465764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1465772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1465775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1465778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1465781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465814 */     // MIs[1] Operand 1
     /* 1465814 */     // No operand predicates
     /* 1465814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465818 */     // MIs[0] policy
     /* 1465818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465821 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1465830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1465833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1465837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465852 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465854 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465855 */     // GIR_Coverage, 23582,
     /* 1465855 */     GIR_EraseRootFromParent_Done,
     /* 1465856 */   // Label 20518: @1465856
     /* 1465856 */   GIM_Try, /*On fail goto*//*Label 20519*/ GIMT_Encode4(1465953), // Rule ID 23583 //
     /* 1465861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1465864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1465869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1465872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1465875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1465878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1465881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1465884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1465887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1465903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1465907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1465911 */     // MIs[1] Operand 1
     /* 1465911 */     // No operand predicates
     /* 1465911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1465915 */     // MIs[0] policy
     /* 1465915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1465918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1465920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1465927 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1465927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 1465930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1465932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1465934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1465936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1465939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1465941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1465946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1465949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1465951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1465952 */     // GIR_Coverage, 23583,
     /* 1465952 */     GIR_EraseRootFromParent_Done,
     /* 1465953 */   // Label 20519: @1465953
     /* 1465953 */   GIM_Try, /*On fail goto*//*Label 20520*/ GIMT_Encode4(1466050), // Rule ID 23586 //
     /* 1465958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1465961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1465966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1465969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1465972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1465975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1465978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1465981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1465984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1465988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1465996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466004 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466008 */     // MIs[1] Operand 1
     /* 1466008 */     // No operand predicates
     /* 1466008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466012 */     // MIs[0] policy
     /* 1466012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1466027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466046 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466049 */     // GIR_Coverage, 23586,
     /* 1466049 */     GIR_EraseRootFromParent_Done,
     /* 1466050 */   // Label 20520: @1466050
     /* 1466050 */   GIM_Try, /*On fail goto*//*Label 20521*/ GIMT_Encode4(1466147), // Rule ID 23587 //
     /* 1466055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1466066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1466069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1466072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466101 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466105 */     // MIs[1] Operand 1
     /* 1466105 */     // No operand predicates
     /* 1466105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466109 */     // MIs[0] policy
     /* 1466109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466121 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1466124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466146 */     // GIR_Coverage, 23587,
     /* 1466146 */     GIR_EraseRootFromParent_Done,
     /* 1466147 */   // Label 20521: @1466147
     /* 1466147 */   GIM_Try, /*On fail goto*//*Label 20522*/ GIMT_Encode4(1466244), // Rule ID 23590 //
     /* 1466152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1466163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1466166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1466169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466198 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466202 */     // MIs[1] Operand 1
     /* 1466202 */     // No operand predicates
     /* 1466202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466206 */     // MIs[0] policy
     /* 1466206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466218 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466240 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466243 */     // GIR_Coverage, 23590,
     /* 1466243 */     GIR_EraseRootFromParent_Done,
     /* 1466244 */   // Label 20522: @1466244
     /* 1466244 */   GIM_Try, /*On fail goto*//*Label 20523*/ GIMT_Encode4(1466341), // Rule ID 23591 //
     /* 1466249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1466260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1466263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1466266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1466272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466295 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466299 */     // MIs[1] Operand 1
     /* 1466299 */     // No operand predicates
     /* 1466299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466303 */     // MIs[0] policy
     /* 1466303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466306 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466315 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1466337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466340 */     // GIR_Coverage, 23591,
     /* 1466340 */     GIR_EraseRootFromParent_Done,
     /* 1466341 */   // Label 20523: @1466341
     /* 1466341 */   GIM_Try, /*On fail goto*//*Label 20524*/ GIMT_Encode4(1466438), // Rule ID 23594 //
     /* 1466346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1466357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1466360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466392 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466396 */     // MIs[1] Operand 1
     /* 1466396 */     // No operand predicates
     /* 1466396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466400 */     // MIs[0] policy
     /* 1466400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466412 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1466415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466434 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466437 */     // GIR_Coverage, 23594,
     /* 1466437 */     GIR_EraseRootFromParent_Done,
     /* 1466438 */   // Label 20524: @1466438
     /* 1466438 */   GIM_Try, /*On fail goto*//*Label 20525*/ GIMT_Encode4(1466535), // Rule ID 23595 //
     /* 1466443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1466454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1466457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1466460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466489 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466493 */     // MIs[1] Operand 1
     /* 1466493 */     // No operand predicates
     /* 1466493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466497 */     // MIs[0] policy
     /* 1466497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466509 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1466512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466534 */     // GIR_Coverage, 23595,
     /* 1466534 */     GIR_EraseRootFromParent_Done,
     /* 1466535 */   // Label 20525: @1466535
     /* 1466535 */   GIM_Try, /*On fail goto*//*Label 20526*/ GIMT_Encode4(1466632), // Rule ID 23598 //
     /* 1466540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1466551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1466554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466590 */     // MIs[1] Operand 1
     /* 1466590 */     // No operand predicates
     /* 1466590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466594 */     // MIs[0] policy
     /* 1466594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466606 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466615 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466628 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466631 */     // GIR_Coverage, 23598,
     /* 1466631 */     GIR_EraseRootFromParent_Done,
     /* 1466632 */   // Label 20526: @1466632
     /* 1466632 */   GIM_Try, /*On fail goto*//*Label 20527*/ GIMT_Encode4(1466729), // Rule ID 23599 //
     /* 1466637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1466648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1466651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1466654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1466660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466683 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466687 */     // MIs[1] Operand 1
     /* 1466687 */     // No operand predicates
     /* 1466687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466691 */     // MIs[0] policy
     /* 1466691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466703 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1466725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466728 */     // GIR_Coverage, 23599,
     /* 1466728 */     GIR_EraseRootFromParent_Done,
     /* 1466729 */   // Label 20527: @1466729
     /* 1466729 */   GIM_Try, /*On fail goto*//*Label 20528*/ GIMT_Encode4(1466826), // Rule ID 23602 //
     /* 1466734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1466751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466780 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466784 */     // MIs[1] Operand 1
     /* 1466784 */     // No operand predicates
     /* 1466784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466788 */     // MIs[0] policy
     /* 1466788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466800 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466809 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466822 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466825 */     // GIR_Coverage, 23602,
     /* 1466825 */     GIR_EraseRootFromParent_Done,
     /* 1466826 */   // Label 20528: @1466826
     /* 1466826 */   GIM_Try, /*On fail goto*//*Label 20529*/ GIMT_Encode4(1466923), // Rule ID 23603 //
     /* 1466831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1466834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1466842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1466845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1466848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1466851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1466854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1466857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466877 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466881 */     // MIs[1] Operand 1
     /* 1466881 */     // No operand predicates
     /* 1466881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466885 */     // MIs[0] policy
     /* 1466885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466897 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1466897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1466900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1466904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1466906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1466909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1466911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1466916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1466919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1466921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1466922 */     // GIR_Coverage, 23603,
     /* 1466922 */     GIR_EraseRootFromParent_Done,
     /* 1466923 */   // Label 20529: @1466923
     /* 1466923 */   GIM_Try, /*On fail goto*//*Label 20530*/ GIMT_Encode4(1467020), // Rule ID 23606 //
     /* 1466928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1466931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1466936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1466939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1466942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1466945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1466948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1466951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1466954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1466958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1466966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1466970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1466974 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1466978 */     // MIs[1] Operand 1
     /* 1466978 */     // No operand predicates
     /* 1466978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1466982 */     // MIs[0] policy
     /* 1466982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1466985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1466987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1466994 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1466994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1466997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1466999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467016 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467019 */     // GIR_Coverage, 23606,
     /* 1467019 */     GIR_EraseRootFromParent_Done,
     /* 1467020 */   // Label 20530: @1467020
     /* 1467020 */   GIM_Try, /*On fail goto*//*Label 20531*/ GIMT_Encode4(1467117), // Rule ID 23607 //
     /* 1467025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1467036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1467039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1467042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1467048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467071 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467075 */     // MIs[1] Operand 1
     /* 1467075 */     // No operand predicates
     /* 1467075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467079 */     // MIs[0] policy
     /* 1467079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467091 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467116 */     // GIR_Coverage, 23607,
     /* 1467116 */     GIR_EraseRootFromParent_Done,
     /* 1467117 */   // Label 20531: @1467117
     /* 1467117 */   GIM_Try, /*On fail goto*//*Label 20532*/ GIMT_Encode4(1467214), // Rule ID 23610 //
     /* 1467122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1467133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1467136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1467139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467172 */     // MIs[1] Operand 1
     /* 1467172 */     // No operand predicates
     /* 1467172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467176 */     // MIs[0] policy
     /* 1467176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467179 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467188 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467197 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467210 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467213 */     // GIR_Coverage, 23610,
     /* 1467213 */     GIR_EraseRootFromParent_Done,
     /* 1467214 */   // Label 20532: @1467214
     /* 1467214 */   GIM_Try, /*On fail goto*//*Label 20533*/ GIMT_Encode4(1467311), // Rule ID 23611 //
     /* 1467219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1467230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1467233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1467236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1467242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467269 */     // MIs[1] Operand 1
     /* 1467269 */     // No operand predicates
     /* 1467269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467273 */     // MIs[0] policy
     /* 1467273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467285 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1467307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467310 */     // GIR_Coverage, 23611,
     /* 1467310 */     GIR_EraseRootFromParent_Done,
     /* 1467311 */   // Label 20533: @1467311
     /* 1467311 */   GIM_Try, /*On fail goto*//*Label 20534*/ GIMT_Encode4(1467408), // Rule ID 23614 //
     /* 1467316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1467327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1467330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467366 */     // MIs[1] Operand 1
     /* 1467366 */     // No operand predicates
     /* 1467366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467370 */     // MIs[0] policy
     /* 1467370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467382 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467404 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467406 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467407 */     // GIR_Coverage, 23614,
     /* 1467407 */     GIR_EraseRootFromParent_Done,
     /* 1467408 */   // Label 20534: @1467408
     /* 1467408 */   GIM_Try, /*On fail goto*//*Label 20535*/ GIMT_Encode4(1467505), // Rule ID 23615 //
     /* 1467413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1467424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1467427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1467430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1467436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467459 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467463 */     // MIs[1] Operand 1
     /* 1467463 */     // No operand predicates
     /* 1467463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467467 */     // MIs[0] policy
     /* 1467467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467479 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1467501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467504 */     // GIR_Coverage, 23615,
     /* 1467504 */     GIR_EraseRootFromParent_Done,
     /* 1467505 */   // Label 20535: @1467505
     /* 1467505 */   GIM_Try, /*On fail goto*//*Label 20536*/ GIMT_Encode4(1467602), // Rule ID 23618 //
     /* 1467510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1467513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1467527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467556 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467560 */     // MIs[1] Operand 1
     /* 1467560 */     // No operand predicates
     /* 1467560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467564 */     // MIs[0] policy
     /* 1467564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467585 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467600 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467601 */     // GIR_Coverage, 23618,
     /* 1467601 */     GIR_EraseRootFromParent_Done,
     /* 1467602 */   // Label 20536: @1467602
     /* 1467602 */   GIM_Try, /*On fail goto*//*Label 20537*/ GIMT_Encode4(1467699), // Rule ID 23619 //
     /* 1467607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1467610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1467618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1467621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1467624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1467630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1467637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1467645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467653 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467657 */     // MIs[1] Operand 1
     /* 1467657 */     // No operand predicates
     /* 1467657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467661 */     // MIs[0] policy
     /* 1467661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467673 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1467676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1467695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467698 */     // GIR_Coverage, 23619,
     /* 1467698 */     GIR_EraseRootFromParent_Done,
     /* 1467699 */   // Label 20537: @1467699
     /* 1467699 */   GIM_Try, /*On fail goto*//*Label 20538*/ GIMT_Encode4(1467796), // Rule ID 23622 //
     /* 1467704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1467715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1467718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1467721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467750 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467754 */     // MIs[1] Operand 1
     /* 1467754 */     // No operand predicates
     /* 1467754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467758 */     // MIs[0] policy
     /* 1467758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467770 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1467773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467794 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467795 */     // GIR_Coverage, 23622,
     /* 1467795 */     GIR_EraseRootFromParent_Done,
     /* 1467796 */   // Label 20538: @1467796
     /* 1467796 */   GIM_Try, /*On fail goto*//*Label 20539*/ GIMT_Encode4(1467893), // Rule ID 23623 //
     /* 1467801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1467812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1467815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1467818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1467821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1467824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1467827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1467831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1467839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467847 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467851 */     // MIs[1] Operand 1
     /* 1467851 */     // No operand predicates
     /* 1467851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467855 */     // MIs[0] policy
     /* 1467855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1467867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1467870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467892 */     // GIR_Coverage, 23623,
     /* 1467892 */     GIR_EraseRootFromParent_Done,
     /* 1467893 */   // Label 20539: @1467893
     /* 1467893 */   GIM_Try, /*On fail goto*//*Label 20540*/ GIMT_Encode4(1467990), // Rule ID 23626 //
     /* 1467898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1467901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1467906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1467909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1467912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1467915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1467918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1467921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1467924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1467928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1467936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1467940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1467944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1467948 */     // MIs[1] Operand 1
     /* 1467948 */     // No operand predicates
     /* 1467948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1467952 */     // MIs[0] policy
     /* 1467952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1467955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1467957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1467964 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1467964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1467967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1467969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1467971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1467973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1467976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1467978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1467983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1467986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1467988 */     GIR_RootConstrainSelectedInstOperands,
     /* 1467989 */     // GIR_Coverage, 23626,
     /* 1467989 */     GIR_EraseRootFromParent_Done,
     /* 1467990 */   // Label 20540: @1467990
     /* 1467990 */   GIM_Try, /*On fail goto*//*Label 20541*/ GIMT_Encode4(1468087), // Rule ID 23627 //
     /* 1467995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1467998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1468006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1468009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1468012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468045 */     // MIs[1] Operand 1
     /* 1468045 */     // No operand predicates
     /* 1468045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468049 */     // MIs[0] policy
     /* 1468049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468061 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1468064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468086 */     // GIR_Coverage, 23627,
     /* 1468086 */     GIR_EraseRootFromParent_Done,
     /* 1468087 */   // Label 20541: @1468087
     /* 1468087 */   GIM_Try, /*On fail goto*//*Label 20542*/ GIMT_Encode4(1468184), // Rule ID 23630 //
     /* 1468092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1468103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1468106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1468109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1468115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468142 */     // MIs[1] Operand 1
     /* 1468142 */     // No operand predicates
     /* 1468142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468146 */     // MIs[0] policy
     /* 1468146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468158 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1468161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468182 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468183 */     // GIR_Coverage, 23630,
     /* 1468183 */     GIR_EraseRootFromParent_Done,
     /* 1468184 */   // Label 20542: @1468184
     /* 1468184 */   GIM_Try, /*On fail goto*//*Label 20543*/ GIMT_Encode4(1468281), // Rule ID 23631 //
     /* 1468189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1468200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1468203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1468206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1468212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468235 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468239 */     // MIs[1] Operand 1
     /* 1468239 */     // No operand predicates
     /* 1468239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468243 */     // MIs[0] policy
     /* 1468243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468255 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1468258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1468277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468280 */     // GIR_Coverage, 23631,
     /* 1468280 */     GIR_EraseRootFromParent_Done,
     /* 1468281 */   // Label 20543: @1468281
     /* 1468281 */   GIM_Try, /*On fail goto*//*Label 20544*/ GIMT_Encode4(1468378), // Rule ID 23634 //
     /* 1468286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1468297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1468300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468332 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468336 */     // MIs[1] Operand 1
     /* 1468336 */     // No operand predicates
     /* 1468336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468340 */     // MIs[0] policy
     /* 1468340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1468355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468376 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468377 */     // GIR_Coverage, 23634,
     /* 1468377 */     GIR_EraseRootFromParent_Done,
     /* 1468378 */   // Label 20544: @1468378
     /* 1468378 */   GIM_Try, /*On fail goto*//*Label 20545*/ GIMT_Encode4(1468475), // Rule ID 23635 //
     /* 1468383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1468394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1468397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1468400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1468406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468429 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468433 */     // MIs[1] Operand 1
     /* 1468433 */     // No operand predicates
     /* 1468433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468437 */     // MIs[0] policy
     /* 1468437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468449 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1468452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468474 */     // GIR_Coverage, 23635,
     /* 1468474 */     GIR_EraseRootFromParent_Done,
     /* 1468475 */   // Label 20545: @1468475
     /* 1468475 */   GIM_Try, /*On fail goto*//*Label 20546*/ GIMT_Encode4(1468572), // Rule ID 23638 //
     /* 1468480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1468491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1468494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1468503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468526 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468530 */     // MIs[1] Operand 1
     /* 1468530 */     // No operand predicates
     /* 1468530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468534 */     // MIs[0] policy
     /* 1468534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1468549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468570 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468571 */     // GIR_Coverage, 23638,
     /* 1468571 */     GIR_EraseRootFromParent_Done,
     /* 1468572 */   // Label 20546: @1468572
     /* 1468572 */   GIM_Try, /*On fail goto*//*Label 20547*/ GIMT_Encode4(1468669), // Rule ID 23639 //
     /* 1468577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1468588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1468591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1468594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1468600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1468607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1468615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468623 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468627 */     // MIs[1] Operand 1
     /* 1468627 */     // No operand predicates
     /* 1468627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468631 */     // MIs[0] policy
     /* 1468631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468643 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1468646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468668 */     // GIR_Coverage, 23639,
     /* 1468668 */     GIR_EraseRootFromParent_Done,
     /* 1468669 */   // Label 20547: @1468669
     /* 1468669 */   GIM_Try, /*On fail goto*//*Label 20548*/ GIMT_Encode4(1468766), // Rule ID 23642 //
     /* 1468674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1468685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1468688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1468691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468724 */     // MIs[1] Operand 1
     /* 1468724 */     // No operand predicates
     /* 1468724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468728 */     // MIs[0] policy
     /* 1468728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1468743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468764 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468765 */     // GIR_Coverage, 23642,
     /* 1468765 */     GIR_EraseRootFromParent_Done,
     /* 1468766 */   // Label 20548: @1468766
     /* 1468766 */   GIM_Try, /*On fail goto*//*Label 20549*/ GIMT_Encode4(1468863), // Rule ID 23643 //
     /* 1468771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1468782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1468785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1468788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1468794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1468801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1468809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468817 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468821 */     // MIs[1] Operand 1
     /* 1468821 */     // No operand predicates
     /* 1468821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468825 */     // MIs[0] policy
     /* 1468825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468828 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468837 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1468837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1468840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1468859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468862 */     // GIR_Coverage, 23643,
     /* 1468862 */     GIR_EraseRootFromParent_Done,
     /* 1468863 */   // Label 20549: @1468863
     /* 1468863 */   GIM_Try, /*On fail goto*//*Label 20550*/ GIMT_Encode4(1468960), // Rule ID 23646 //
     /* 1468868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1468871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1468879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1468882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1468885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1468888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1468894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1468910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1468914 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1468918 */     // MIs[1] Operand 1
     /* 1468918 */     // No operand predicates
     /* 1468918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1468922 */     // MIs[0] policy
     /* 1468922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1468925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1468927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1468934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1468934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1468937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1468939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1468941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1468943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1468946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1468948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1468953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1468956 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1468958 */     GIR_RootConstrainSelectedInstOperands,
     /* 1468959 */     // GIR_Coverage, 23646,
     /* 1468959 */     GIR_EraseRootFromParent_Done,
     /* 1468960 */   // Label 20550: @1468960
     /* 1468960 */   GIM_Try, /*On fail goto*//*Label 20551*/ GIMT_Encode4(1469057), // Rule ID 23647 //
     /* 1468965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1468968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1468973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1468976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1468979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1468982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1468985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1468988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1468991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1468995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1468999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469011 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469015 */     // MIs[1] Operand 1
     /* 1469015 */     // No operand predicates
     /* 1469015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469019 */     // MIs[0] policy
     /* 1469019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469031 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1469034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469056 */     // GIR_Coverage, 23647,
     /* 1469056 */     GIR_EraseRootFromParent_Done,
     /* 1469057 */   // Label 20551: @1469057
     /* 1469057 */   GIM_Try, /*On fail goto*//*Label 20552*/ GIMT_Encode4(1469154), // Rule ID 23650 //
     /* 1469062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1469073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1469076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469108 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469112 */     // MIs[1] Operand 1
     /* 1469112 */     // No operand predicates
     /* 1469112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469116 */     // MIs[0] policy
     /* 1469116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469128 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1469131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469150 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469152 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469153 */     // GIR_Coverage, 23650,
     /* 1469153 */     GIR_EraseRootFromParent_Done,
     /* 1469154 */   // Label 20552: @1469154
     /* 1469154 */   GIM_Try, /*On fail goto*//*Label 20553*/ GIMT_Encode4(1469251), // Rule ID 23651 //
     /* 1469159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1469170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1469173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1469176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469205 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469209 */     // MIs[1] Operand 1
     /* 1469209 */     // No operand predicates
     /* 1469209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469213 */     // MIs[0] policy
     /* 1469213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469225 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1469228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469234 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469250 */     // GIR_Coverage, 23651,
     /* 1469250 */     GIR_EraseRootFromParent_Done,
     /* 1469251 */   // Label 20553: @1469251
     /* 1469251 */   GIM_Try, /*On fail goto*//*Label 20554*/ GIMT_Encode4(1469348), // Rule ID 23654 //
     /* 1469256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1469259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1469267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1469270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1469273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469306 */     // MIs[1] Operand 1
     /* 1469306 */     // No operand predicates
     /* 1469306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469310 */     // MIs[0] policy
     /* 1469310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1469325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469344 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469346 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469347 */     // GIR_Coverage, 23654,
     /* 1469347 */     GIR_EraseRootFromParent_Done,
     /* 1469348 */   // Label 20554: @1469348
     /* 1469348 */   GIM_Try, /*On fail goto*//*Label 20555*/ GIMT_Encode4(1469445), // Rule ID 23655 //
     /* 1469353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1469356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1469364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1469367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1469370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1469376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469403 */     // MIs[1] Operand 1
     /* 1469403 */     // No operand predicates
     /* 1469403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469407 */     // MIs[0] policy
     /* 1469407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469419 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1469422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1469441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469444 */     // GIR_Coverage, 23655,
     /* 1469444 */     GIR_EraseRootFromParent_Done,
     /* 1469445 */   // Label 20555: @1469445
     /* 1469445 */   GIM_Try, /*On fail goto*//*Label 20556*/ GIMT_Encode4(1469542), // Rule ID 23658 //
     /* 1469450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1469461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1469464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1469467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469496 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469500 */     // MIs[1] Operand 1
     /* 1469500 */     // No operand predicates
     /* 1469500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469504 */     // MIs[0] policy
     /* 1469504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469507 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1469519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469538 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469540 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469541 */     // GIR_Coverage, 23658,
     /* 1469541 */     GIR_EraseRootFromParent_Done,
     /* 1469542 */   // Label 20556: @1469542
     /* 1469542 */   GIM_Try, /*On fail goto*//*Label 20557*/ GIMT_Encode4(1469639), // Rule ID 23659 //
     /* 1469547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1469558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1469561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1469564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1469570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1469577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1469585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469593 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469597 */     // MIs[1] Operand 1
     /* 1469597 */     // No operand predicates
     /* 1469597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469601 */     // MIs[0] policy
     /* 1469601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1469616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469622 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469638 */     // GIR_Coverage, 23659,
     /* 1469638 */     GIR_EraseRootFromParent_Done,
     /* 1469639 */   // Label 20557: @1469639
     /* 1469639 */   GIM_Try, /*On fail goto*//*Label 20558*/ GIMT_Encode4(1469736), // Rule ID 23662 //
     /* 1469644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1469661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469690 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469694 */     // MIs[1] Operand 1
     /* 1469694 */     // No operand predicates
     /* 1469694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469698 */     // MIs[0] policy
     /* 1469698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1469713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469732 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469735 */     // GIR_Coverage, 23662,
     /* 1469735 */     GIR_EraseRootFromParent_Done,
     /* 1469736 */   // Label 20558: @1469736
     /* 1469736 */   GIM_Try, /*On fail goto*//*Label 20559*/ GIMT_Encode4(1469833), // Rule ID 23663 //
     /* 1469741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1469752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1469755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1469758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1469764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1469771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1469779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469787 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469791 */     // MIs[1] Operand 1
     /* 1469791 */     // No operand predicates
     /* 1469791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469795 */     // MIs[0] policy
     /* 1469795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469807 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1469807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1469810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469832 */     // GIR_Coverage, 23663,
     /* 1469832 */     GIR_EraseRootFromParent_Done,
     /* 1469833 */   // Label 20559: @1469833
     /* 1469833 */   GIM_Try, /*On fail goto*//*Label 20560*/ GIMT_Encode4(1469930), // Rule ID 23666 //
     /* 1469838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1469841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1469849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1469852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1469855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1469858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1469864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469884 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469888 */     // MIs[1] Operand 1
     /* 1469888 */     // No operand predicates
     /* 1469888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469892 */     // MIs[0] policy
     /* 1469892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1469904 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1469904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1469907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1469909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1469911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1469913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1469916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1469918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1469923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1469926 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1469928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1469929 */     // GIR_Coverage, 23666,
     /* 1469929 */     GIR_EraseRootFromParent_Done,
     /* 1469930 */   // Label 20560: @1469930
     /* 1469930 */   GIM_Try, /*On fail goto*//*Label 20561*/ GIMT_Encode4(1470027), // Rule ID 23667 //
     /* 1469935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1469938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1469943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1469946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1469949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1469952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1469955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1469958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1469961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1469965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1469973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1469977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1469981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1469985 */     // MIs[1] Operand 1
     /* 1469985 */     // No operand predicates
     /* 1469985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1469989 */     // MIs[0] policy
     /* 1469989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1469992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1469994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470001 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1470004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1470023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470026 */     // GIR_Coverage, 23667,
     /* 1470026 */     GIR_EraseRootFromParent_Done,
     /* 1470027 */   // Label 20561: @1470027
     /* 1470027 */   GIM_Try, /*On fail goto*//*Label 20562*/ GIMT_Encode4(1470124), // Rule ID 23758 //
     /* 1470032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1470043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1470046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1470049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470082 */     // MIs[1] Operand 1
     /* 1470082 */     // No operand predicates
     /* 1470082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470086 */     // MIs[0] policy
     /* 1470086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470098 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1470101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470120 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470123 */     // GIR_Coverage, 23758,
     /* 1470123 */     GIR_EraseRootFromParent_Done,
     /* 1470124 */   // Label 20562: @1470124
     /* 1470124 */   GIM_Try, /*On fail goto*//*Label 20563*/ GIMT_Encode4(1470221), // Rule ID 23759 //
     /* 1470129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1470140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1470143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1470146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470175 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470179 */     // MIs[1] Operand 1
     /* 1470179 */     // No operand predicates
     /* 1470179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470183 */     // MIs[0] policy
     /* 1470183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470195 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 1470198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470220 */     // GIR_Coverage, 23759,
     /* 1470220 */     GIR_EraseRootFromParent_Done,
     /* 1470221 */   // Label 20563: @1470221
     /* 1470221 */   GIM_Try, /*On fail goto*//*Label 20564*/ GIMT_Encode4(1470318), // Rule ID 23762 //
     /* 1470226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1470237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1470240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1470243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470272 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470276 */     // MIs[1] Operand 1
     /* 1470276 */     // No operand predicates
     /* 1470276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470280 */     // MIs[0] policy
     /* 1470280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470292 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1470295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470314 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470317 */     // GIR_Coverage, 23762,
     /* 1470317 */     GIR_EraseRootFromParent_Done,
     /* 1470318 */   // Label 20564: @1470318
     /* 1470318 */   GIM_Try, /*On fail goto*//*Label 20565*/ GIMT_Encode4(1470415), // Rule ID 23763 //
     /* 1470323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1470334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1470337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1470340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470369 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470373 */     // MIs[1] Operand 1
     /* 1470373 */     // No operand predicates
     /* 1470373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470377 */     // MIs[0] policy
     /* 1470377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470380 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470389 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1470392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470398 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470414 */     // GIR_Coverage, 23763,
     /* 1470414 */     GIR_EraseRootFromParent_Done,
     /* 1470415 */   // Label 20565: @1470415
     /* 1470415 */   GIM_Try, /*On fail goto*//*Label 20566*/ GIMT_Encode4(1470512), // Rule ID 23766 //
     /* 1470420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1470431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1470434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1470437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470470 */     // MIs[1] Operand 1
     /* 1470470 */     // No operand predicates
     /* 1470470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470474 */     // MIs[0] policy
     /* 1470474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470477 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470486 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1470489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470508 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470511 */     // GIR_Coverage, 23766,
     /* 1470511 */     GIR_EraseRootFromParent_Done,
     /* 1470512 */   // Label 20566: @1470512
     /* 1470512 */   GIM_Try, /*On fail goto*//*Label 20567*/ GIMT_Encode4(1470609), // Rule ID 23767 //
     /* 1470517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1470528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1470531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1470534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1470540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470563 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470567 */     // MIs[1] Operand 1
     /* 1470567 */     // No operand predicates
     /* 1470567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470571 */     // MIs[0] policy
     /* 1470571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1470586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470592 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1470605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470608 */     // GIR_Coverage, 23767,
     /* 1470608 */     GIR_EraseRootFromParent_Done,
     /* 1470609 */   // Label 20567: @1470609
     /* 1470609 */   GIM_Try, /*On fail goto*//*Label 20568*/ GIMT_Encode4(1470706), // Rule ID 23770 //
     /* 1470614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1470631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470660 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470664 */     // MIs[1] Operand 1
     /* 1470664 */     // No operand predicates
     /* 1470664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470668 */     // MIs[0] policy
     /* 1470668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1470683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470702 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470705 */     // GIR_Coverage, 23770,
     /* 1470705 */     GIR_EraseRootFromParent_Done,
     /* 1470706 */   // Label 20568: @1470706
     /* 1470706 */   GIM_Try, /*On fail goto*//*Label 20569*/ GIMT_Encode4(1470803), // Rule ID 23771 //
     /* 1470711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1470722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1470725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1470728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1470734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470757 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470761 */     // MIs[1] Operand 1
     /* 1470761 */     // No operand predicates
     /* 1470761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470765 */     // MIs[0] policy
     /* 1470765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1470780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470802 */     // GIR_Coverage, 23771,
     /* 1470802 */     GIR_EraseRootFromParent_Done,
     /* 1470803 */   // Label 20569: @1470803
     /* 1470803 */   GIM_Try, /*On fail goto*//*Label 20570*/ GIMT_Encode4(1470900), // Rule ID 23774 //
     /* 1470808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1470811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1470819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1470822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1470825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1470828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1470834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470858 */     // MIs[1] Operand 1
     /* 1470858 */     // No operand predicates
     /* 1470858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470862 */     // MIs[0] policy
     /* 1470862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470874 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1470874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1470877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470896 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470898 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470899 */     // GIR_Coverage, 23774,
     /* 1470899 */     GIR_EraseRootFromParent_Done,
     /* 1470900 */   // Label 20570: @1470900
     /* 1470900 */   GIM_Try, /*On fail goto*//*Label 20571*/ GIMT_Encode4(1470997), // Rule ID 23775 //
     /* 1470905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1470908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1470913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1470916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1470919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1470922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1470925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1470928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1470931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1470935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1470943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1470947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1470951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1470955 */     // MIs[1] Operand 1
     /* 1470955 */     // No operand predicates
     /* 1470955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1470959 */     // MIs[0] policy
     /* 1470959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1470962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1470964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1470971 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1470971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1470974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1470976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1470978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1470980 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1470983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1470985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1470990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1470993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1470995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1470996 */     // GIR_Coverage, 23775,
     /* 1470996 */     GIR_EraseRootFromParent_Done,
     /* 1470997 */   // Label 20571: @1470997
     /* 1470997 */   GIM_Try, /*On fail goto*//*Label 20572*/ GIMT_Encode4(1471094), // Rule ID 23778 //
     /* 1471002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1471019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471048 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471052 */     // MIs[1] Operand 1
     /* 1471052 */     // No operand predicates
     /* 1471052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471056 */     // MIs[0] policy
     /* 1471056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471068 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1471071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471090 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471092 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471093 */     // GIR_Coverage, 23778,
     /* 1471093 */     GIR_EraseRootFromParent_Done,
     /* 1471094 */   // Label 20572: @1471094
     /* 1471094 */   GIM_Try, /*On fail goto*//*Label 20573*/ GIMT_Encode4(1471191), // Rule ID 23779 //
     /* 1471099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1471110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1471113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1471116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471145 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471149 */     // MIs[1] Operand 1
     /* 1471149 */     // No operand predicates
     /* 1471149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471153 */     // MIs[0] policy
     /* 1471153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471165 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1471168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471190 */     // GIR_Coverage, 23779,
     /* 1471190 */     GIR_EraseRootFromParent_Done,
     /* 1471191 */   // Label 20573: @1471191
     /* 1471191 */   GIM_Try, /*On fail goto*//*Label 20574*/ GIMT_Encode4(1471288), // Rule ID 23782 //
     /* 1471196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1471207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1471210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1471213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471246 */     // MIs[1] Operand 1
     /* 1471246 */     // No operand predicates
     /* 1471246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471250 */     // MIs[0] policy
     /* 1471250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471262 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471286 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471287 */     // GIR_Coverage, 23782,
     /* 1471287 */     GIR_EraseRootFromParent_Done,
     /* 1471288 */   // Label 20574: @1471288
     /* 1471288 */   GIM_Try, /*On fail goto*//*Label 20575*/ GIMT_Encode4(1471385), // Rule ID 23783 //
     /* 1471293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1471304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1471307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1471310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1471316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471343 */     // MIs[1] Operand 1
     /* 1471343 */     // No operand predicates
     /* 1471343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471347 */     // MIs[0] policy
     /* 1471347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471359 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1471381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471384 */     // GIR_Coverage, 23783,
     /* 1471384 */     GIR_EraseRootFromParent_Done,
     /* 1471385 */   // Label 20575: @1471385
     /* 1471385 */   GIM_Try, /*On fail goto*//*Label 20576*/ GIMT_Encode4(1471482), // Rule ID 23786 //
     /* 1471390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1471401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1471404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1471407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471436 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471440 */     // MIs[1] Operand 1
     /* 1471440 */     // No operand predicates
     /* 1471440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471444 */     // MIs[0] policy
     /* 1471444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471456 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471480 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471481 */     // GIR_Coverage, 23786,
     /* 1471481 */     GIR_EraseRootFromParent_Done,
     /* 1471482 */   // Label 20576: @1471482
     /* 1471482 */   GIM_Try, /*On fail goto*//*Label 20577*/ GIMT_Encode4(1471579), // Rule ID 23787 //
     /* 1471487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1471498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1471501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1471504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1471510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471533 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471537 */     // MIs[1] Operand 1
     /* 1471537 */     // No operand predicates
     /* 1471537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471541 */     // MIs[0] policy
     /* 1471541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471553 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471558 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1471575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471578 */     // GIR_Coverage, 23787,
     /* 1471578 */     GIR_EraseRootFromParent_Done,
     /* 1471579 */   // Label 20577: @1471579
     /* 1471579 */   GIM_Try, /*On fail goto*//*Label 20578*/ GIMT_Encode4(1471676), // Rule ID 23790 //
     /* 1471584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1471601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471634 */     // MIs[1] Operand 1
     /* 1471634 */     // No operand predicates
     /* 1471634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471638 */     // MIs[0] policy
     /* 1471638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471674 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471675 */     // GIR_Coverage, 23790,
     /* 1471675 */     GIR_EraseRootFromParent_Done,
     /* 1471676 */   // Label 20578: @1471676
     /* 1471676 */   GIM_Try, /*On fail goto*//*Label 20579*/ GIMT_Encode4(1471773), // Rule ID 23791 //
     /* 1471681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1471684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1471692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1471695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1471698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1471704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471731 */     // MIs[1] Operand 1
     /* 1471731 */     // No operand predicates
     /* 1471731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471735 */     // MIs[0] policy
     /* 1471735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471747 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1471769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471772 */     // GIR_Coverage, 23791,
     /* 1471772 */     GIR_EraseRootFromParent_Done,
     /* 1471773 */   // Label 20579: @1471773
     /* 1471773 */   GIM_Try, /*On fail goto*//*Label 20580*/ GIMT_Encode4(1471870), // Rule ID 23794 //
     /* 1471778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1471781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1471789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1471792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471824 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471828 */     // MIs[1] Operand 1
     /* 1471828 */     // No operand predicates
     /* 1471828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471832 */     // MIs[0] policy
     /* 1471832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1471844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471868 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471869 */     // GIR_Coverage, 23794,
     /* 1471869 */     GIR_EraseRootFromParent_Done,
     /* 1471870 */   // Label 20580: @1471870
     /* 1471870 */   GIM_Try, /*On fail goto*//*Label 20581*/ GIMT_Encode4(1471967), // Rule ID 23795 //
     /* 1471875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1471878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1471886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1471889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1471892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1471895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1471898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1471901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1471905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1471913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1471917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1471921 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1471925 */     // MIs[1] Operand 1
     /* 1471925 */     // No operand predicates
     /* 1471925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1471929 */     // MIs[0] policy
     /* 1471929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1471932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1471934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1471941 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1471941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1471944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1471946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1471948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1471950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1471953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1471955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1471960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1471963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1471965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1471966 */     // GIR_Coverage, 23795,
     /* 1471966 */     GIR_EraseRootFromParent_Done,
     /* 1471967 */   // Label 20581: @1471967
     /* 1471967 */   GIM_Try, /*On fail goto*//*Label 20582*/ GIMT_Encode4(1472064), // Rule ID 23798 //
     /* 1471972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1471975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1471980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1471983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1471986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1471989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1471992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1471995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1471998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472018 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472022 */     // MIs[1] Operand 1
     /* 1472022 */     // No operand predicates
     /* 1472022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472026 */     // MIs[0] policy
     /* 1472026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472038 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1472041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472062 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472063 */     // GIR_Coverage, 23798,
     /* 1472063 */     GIR_EraseRootFromParent_Done,
     /* 1472064 */   // Label 20582: @1472064
     /* 1472064 */   GIM_Try, /*On fail goto*//*Label 20583*/ GIMT_Encode4(1472161), // Rule ID 23799 //
     /* 1472069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1472080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1472083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1472086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472115 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472119 */     // MIs[1] Operand 1
     /* 1472119 */     // No operand predicates
     /* 1472119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472123 */     // MIs[0] policy
     /* 1472123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472135 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1472138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472160 */     // GIR_Coverage, 23799,
     /* 1472160 */     GIR_EraseRootFromParent_Done,
     /* 1472161 */   // Label 20583: @1472161
     /* 1472161 */   GIM_Try, /*On fail goto*//*Label 20584*/ GIMT_Encode4(1472258), // Rule ID 23802 //
     /* 1472166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1472183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1472189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472212 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472216 */     // MIs[1] Operand 1
     /* 1472216 */     // No operand predicates
     /* 1472216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472220 */     // MIs[0] policy
     /* 1472220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472232 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1472235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472256 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472257 */     // GIR_Coverage, 23802,
     /* 1472257 */     GIR_EraseRootFromParent_Done,
     /* 1472258 */   // Label 20584: @1472258
     /* 1472258 */   GIM_Try, /*On fail goto*//*Label 20585*/ GIMT_Encode4(1472355), // Rule ID 23803 //
     /* 1472263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1472274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1472277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1472280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1472286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472309 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472313 */     // MIs[1] Operand 1
     /* 1472313 */     // No operand predicates
     /* 1472313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472317 */     // MIs[0] policy
     /* 1472317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472329 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1472332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472354 */     // GIR_Coverage, 23803,
     /* 1472354 */     GIR_EraseRootFromParent_Done,
     /* 1472355 */   // Label 20585: @1472355
     /* 1472355 */   GIM_Try, /*On fail goto*//*Label 20586*/ GIMT_Encode4(1472452), // Rule ID 23806 //
     /* 1472360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1472371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1472374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1472377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1472383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472410 */     // MIs[1] Operand 1
     /* 1472410 */     // No operand predicates
     /* 1472410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472414 */     // MIs[0] policy
     /* 1472414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1472429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472448 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472450 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472451 */     // GIR_Coverage, 23806,
     /* 1472451 */     GIR_EraseRootFromParent_Done,
     /* 1472452 */   // Label 20586: @1472452
     /* 1472452 */   GIM_Try, /*On fail goto*//*Label 20587*/ GIMT_Encode4(1472549), // Rule ID 23807 //
     /* 1472457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1472468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1472471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1472474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1472480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472507 */     // MIs[1] Operand 1
     /* 1472507 */     // No operand predicates
     /* 1472507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472511 */     // MIs[0] policy
     /* 1472511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472523 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1472526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1472545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472548 */     // GIR_Coverage, 23807,
     /* 1472548 */     GIR_EraseRootFromParent_Done,
     /* 1472549 */   // Label 20587: @1472549
     /* 1472549 */   GIM_Try, /*On fail goto*//*Label 20588*/ GIMT_Encode4(1472646), // Rule ID 23810 //
     /* 1472554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1472565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1472568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472600 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472604 */     // MIs[1] Operand 1
     /* 1472604 */     // No operand predicates
     /* 1472604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472608 */     // MIs[0] policy
     /* 1472608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1472623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472642 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472644 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472645 */     // GIR_Coverage, 23810,
     /* 1472645 */     GIR_EraseRootFromParent_Done,
     /* 1472646 */   // Label 20588: @1472646
     /* 1472646 */   GIM_Try, /*On fail goto*//*Label 20589*/ GIMT_Encode4(1472743), // Rule ID 23811 //
     /* 1472651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1472662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1472665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1472668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1472674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1472681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1472689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472697 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472701 */     // MIs[1] Operand 1
     /* 1472701 */     // No operand predicates
     /* 1472701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472705 */     // MIs[0] policy
     /* 1472705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1472720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472742 */     // GIR_Coverage, 23811,
     /* 1472742 */     GIR_EraseRootFromParent_Done,
     /* 1472743 */   // Label 20589: @1472743
     /* 1472743 */   GIM_Try, /*On fail goto*//*Label 20590*/ GIMT_Encode4(1472840), // Rule ID 23814 //
     /* 1472748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1472759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1472762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472794 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472798 */     // MIs[1] Operand 1
     /* 1472798 */     // No operand predicates
     /* 1472798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472802 */     // MIs[0] policy
     /* 1472802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1472814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1472817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472836 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472839 */     // GIR_Coverage, 23814,
     /* 1472839 */     GIR_EraseRootFromParent_Done,
     /* 1472840 */   // Label 20590: @1472840
     /* 1472840 */   GIM_Try, /*On fail goto*//*Label 20591*/ GIMT_Encode4(1472937), // Rule ID 23815 //
     /* 1472845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1472848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1472856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1472859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1472862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1472865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1472868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1472871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1472875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1472883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472895 */     // MIs[1] Operand 1
     /* 1472895 */     // No operand predicates
     /* 1472895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472899 */     // MIs[0] policy
     /* 1472899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1472904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1472911 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1472911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1472914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1472916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1472918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1472920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1472923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1472925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1472930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1472933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1472935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1472936 */     // GIR_Coverage, 23815,
     /* 1472936 */     GIR_EraseRootFromParent_Done,
     /* 1472937 */   // Label 20591: @1472937
     /* 1472937 */   GIM_Try, /*On fail goto*//*Label 20592*/ GIMT_Encode4(1473034), // Rule ID 23818 //
     /* 1472942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1472945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1472950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1472953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1472956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1472959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1472962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1472965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1472968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1472972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1472980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1472984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1472988 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1472992 */     // MIs[1] Operand 1
     /* 1472992 */     // No operand predicates
     /* 1472992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1472996 */     // MIs[0] policy
     /* 1472996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1472999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1473011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473030 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473032 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473033 */     // GIR_Coverage, 23818,
     /* 1473033 */     GIR_EraseRootFromParent_Done,
     /* 1473034 */   // Label 20592: @1473034
     /* 1473034 */   GIM_Try, /*On fail goto*//*Label 20593*/ GIMT_Encode4(1473131), // Rule ID 23819 //
     /* 1473039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1473050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1473053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1473056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1473062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473089 */     // MIs[1] Operand 1
     /* 1473089 */     // No operand predicates
     /* 1473089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473093 */     // MIs[0] policy
     /* 1473093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473105 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1473108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473114 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1473127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473130 */     // GIR_Coverage, 23819,
     /* 1473130 */     GIR_EraseRootFromParent_Done,
     /* 1473131 */   // Label 20593: @1473131
     /* 1473131 */   GIM_Try, /*On fail goto*//*Label 20594*/ GIMT_Encode4(1473228), // Rule ID 23822 //
     /* 1473136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1473147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1473150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473182 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473186 */     // MIs[1] Operand 1
     /* 1473186 */     // No operand predicates
     /* 1473186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473190 */     // MIs[0] policy
     /* 1473190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473202 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1473205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473211 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473224 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473227 */     // GIR_Coverage, 23822,
     /* 1473227 */     GIR_EraseRootFromParent_Done,
     /* 1473228 */   // Label 20594: @1473228
     /* 1473228 */   GIM_Try, /*On fail goto*//*Label 20595*/ GIMT_Encode4(1473325), // Rule ID 23823 //
     /* 1473233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1473244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1473247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1473250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473279 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473283 */     // MIs[1] Operand 1
     /* 1473283 */     // No operand predicates
     /* 1473283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473287 */     // MIs[0] policy
     /* 1473287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1473302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473324 */     // GIR_Coverage, 23823,
     /* 1473324 */     GIR_EraseRootFromParent_Done,
     /* 1473325 */   // Label 20595: @1473325
     /* 1473325 */   GIM_Try, /*On fail goto*//*Label 20596*/ GIMT_Encode4(1473422), // Rule ID 23826 //
     /* 1473330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1473341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1473344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473376 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473380 */     // MIs[1] Operand 1
     /* 1473380 */     // No operand predicates
     /* 1473380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473384 */     // MIs[0] policy
     /* 1473384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473396 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1473399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473418 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473421 */     // GIR_Coverage, 23826,
     /* 1473421 */     GIR_EraseRootFromParent_Done,
     /* 1473422 */   // Label 20596: @1473422
     /* 1473422 */   GIM_Try, /*On fail goto*//*Label 20597*/ GIMT_Encode4(1473519), // Rule ID 23827 //
     /* 1473427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1473438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1473441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1473444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1473450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473473 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473477 */     // MIs[1] Operand 1
     /* 1473477 */     // No operand predicates
     /* 1473477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473481 */     // MIs[0] policy
     /* 1473481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473493 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1473496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473518 */     // GIR_Coverage, 23827,
     /* 1473518 */     GIR_EraseRootFromParent_Done,
     /* 1473519 */   // Label 20597: @1473519
     /* 1473519 */   GIM_Try, /*On fail goto*//*Label 20598*/ GIMT_Encode4(1473616), // Rule ID 23830 //
     /* 1473524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1473527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1473535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1473538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473570 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473574 */     // MIs[1] Operand 1
     /* 1473574 */     // No operand predicates
     /* 1473574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473578 */     // MIs[0] policy
     /* 1473578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473590 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1473593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473612 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473615 */     // GIR_Coverage, 23830,
     /* 1473615 */     GIR_EraseRootFromParent_Done,
     /* 1473616 */   // Label 20598: @1473616
     /* 1473616 */   GIM_Try, /*On fail goto*//*Label 20599*/ GIMT_Encode4(1473713), // Rule ID 23831 //
     /* 1473621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1473624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1473632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1473635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1473638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1473644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1473651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1473659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473671 */     // MIs[1] Operand 1
     /* 1473671 */     // No operand predicates
     /* 1473671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473675 */     // MIs[0] policy
     /* 1473675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473678 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473687 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1473690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1473709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473712 */     // GIR_Coverage, 23831,
     /* 1473712 */     GIR_EraseRootFromParent_Done,
     /* 1473713 */   // Label 20599: @1473713
     /* 1473713 */   GIM_Try, /*On fail goto*//*Label 20600*/ GIMT_Encode4(1473810), // Rule ID 23834 //
     /* 1473718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1473721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1473729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1473732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473764 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473768 */     // MIs[1] Operand 1
     /* 1473768 */     // No operand predicates
     /* 1473768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473772 */     // MIs[0] policy
     /* 1473772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1473787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473806 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473809 */     // GIR_Coverage, 23834,
     /* 1473809 */     GIR_EraseRootFromParent_Done,
     /* 1473810 */   // Label 20600: @1473810
     /* 1473810 */   GIM_Try, /*On fail goto*//*Label 20601*/ GIMT_Encode4(1473907), // Rule ID 23835 //
     /* 1473815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1473818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1473826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1473829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1473832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1473835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1473838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1473841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1473845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1473853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473861 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473865 */     // MIs[1] Operand 1
     /* 1473865 */     // No operand predicates
     /* 1473865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473869 */     // MIs[0] policy
     /* 1473869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1473881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1473884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473890 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1473903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1473905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1473906 */     // GIR_Coverage, 23835,
     /* 1473906 */     GIR_EraseRootFromParent_Done,
     /* 1473907 */   // Label 20601: @1473907
     /* 1473907 */   GIM_Try, /*On fail goto*//*Label 20602*/ GIMT_Encode4(1474004), // Rule ID 23838 //
     /* 1473912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1473915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1473920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1473923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1473926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1473929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1473932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1473935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1473938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1473942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1473950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1473954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1473958 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1473962 */     // MIs[1] Operand 1
     /* 1473962 */     // No operand predicates
     /* 1473962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1473966 */     // MIs[0] policy
     /* 1473966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1473969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1473971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1473978 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1473978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1473981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1473983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1473985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1473987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1473990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1473992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1473997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474000 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474003 */     // GIR_Coverage, 23838,
     /* 1474003 */     GIR_EraseRootFromParent_Done,
     /* 1474004 */   // Label 20602: @1474004
     /* 1474004 */   GIM_Try, /*On fail goto*//*Label 20603*/ GIMT_Encode4(1474101), // Rule ID 23839 //
     /* 1474009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1474020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1474023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1474026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1474039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1474047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474059 */     // MIs[1] Operand 1
     /* 1474059 */     // No operand predicates
     /* 1474059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474063 */     // MIs[0] policy
     /* 1474063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474075 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1474078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474100 */     // GIR_Coverage, 23839,
     /* 1474100 */     GIR_EraseRootFromParent_Done,
     /* 1474101 */   // Label 20603: @1474101
     /* 1474101 */   GIM_Try, /*On fail goto*//*Label 20604*/ GIMT_Encode4(1474198), // Rule ID 23842 //
     /* 1474106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1474109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1474117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1474120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474152 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474156 */     // MIs[1] Operand 1
     /* 1474156 */     // No operand predicates
     /* 1474156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474160 */     // MIs[0] policy
     /* 1474160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474172 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1474175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474194 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474197 */     // GIR_Coverage, 23842,
     /* 1474197 */     GIR_EraseRootFromParent_Done,
     /* 1474198 */   // Label 20604: @1474198
     /* 1474198 */   GIM_Try, /*On fail goto*//*Label 20605*/ GIMT_Encode4(1474295), // Rule ID 23843 //
     /* 1474203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1474206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1474211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1474214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1474217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1474220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1474226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1474233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1474241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474249 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474253 */     // MIs[1] Operand 1
     /* 1474253 */     // No operand predicates
     /* 1474253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474257 */     // MIs[0] policy
     /* 1474257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474269 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1474272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1474291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474294 */     // GIR_Coverage, 23843,
     /* 1474294 */     GIR_EraseRootFromParent_Done,
     /* 1474295 */   // Label 20605: @1474295
     /* 1474295 */   GIM_Try, /*On fail goto*//*Label 20606*/ GIMT_Encode4(1474392), // Rule ID 24082 //
     /* 1474300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1474303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1474311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1474314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1474317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474346 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474350 */     // MIs[1] Operand 1
     /* 1474350 */     // No operand predicates
     /* 1474350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474354 */     // MIs[0] policy
     /* 1474354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474357 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474366 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1474369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474388 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474391 */     // GIR_Coverage, 24082,
     /* 1474391 */     GIR_EraseRootFromParent_Done,
     /* 1474392 */   // Label 20606: @1474392
     /* 1474392 */   GIM_Try, /*On fail goto*//*Label 20607*/ GIMT_Encode4(1474489), // Rule ID 24083 //
     /* 1474397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1474400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1474408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1474411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1474414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474443 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474447 */     // MIs[1] Operand 1
     /* 1474447 */     // No operand predicates
     /* 1474447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474451 */     // MIs[0] policy
     /* 1474451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474463 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 1474466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474472 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474488 */     // GIR_Coverage, 24083,
     /* 1474488 */     GIR_EraseRootFromParent_Done,
     /* 1474489 */   // Label 20607: @1474489
     /* 1474489 */   GIM_Try, /*On fail goto*//*Label 20608*/ GIMT_Encode4(1474586), // Rule ID 24086 //
     /* 1474494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1474497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1474505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1474508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1474511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474540 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474544 */     // MIs[1] Operand 1
     /* 1474544 */     // No operand predicates
     /* 1474544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474548 */     // MIs[0] policy
     /* 1474548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474560 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1474563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474582 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474584 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474585 */     // GIR_Coverage, 24086,
     /* 1474585 */     GIR_EraseRootFromParent_Done,
     /* 1474586 */   // Label 20608: @1474586
     /* 1474586 */   GIM_Try, /*On fail goto*//*Label 20609*/ GIMT_Encode4(1474683), // Rule ID 24087 //
     /* 1474591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1474594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1474602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1474605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1474608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1474614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474637 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474641 */     // MIs[1] Operand 1
     /* 1474641 */     // No operand predicates
     /* 1474641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474645 */     // MIs[0] policy
     /* 1474645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474657 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1474660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474666 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474682 */     // GIR_Coverage, 24087,
     /* 1474682 */     GIR_EraseRootFromParent_Done,
     /* 1474683 */   // Label 20609: @1474683
     /* 1474683 */   GIM_Try, /*On fail goto*//*Label 20610*/ GIMT_Encode4(1474780), // Rule ID 24090 //
     /* 1474688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1474691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1474699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1474702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1474705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474734 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474738 */     // MIs[1] Operand 1
     /* 1474738 */     // No operand predicates
     /* 1474738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474742 */     // MIs[0] policy
     /* 1474742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474754 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1474757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474778 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474779 */     // GIR_Coverage, 24090,
     /* 1474779 */     GIR_EraseRootFromParent_Done,
     /* 1474780 */   // Label 20610: @1474780
     /* 1474780 */   GIM_Try, /*On fail goto*//*Label 20611*/ GIMT_Encode4(1474877), // Rule ID 24091 //
     /* 1474785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1474788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1474796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1474799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1474802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1474808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1474811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474835 */     // MIs[1] Operand 1
     /* 1474835 */     // No operand predicates
     /* 1474835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474839 */     // MIs[0] policy
     /* 1474839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474851 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1474851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 1474854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474860 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1474873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474876 */     // GIR_Coverage, 24091,
     /* 1474876 */     GIR_EraseRootFromParent_Done,
     /* 1474877 */   // Label 20611: @1474877
     /* 1474877 */   GIM_Try, /*On fail goto*//*Label 20612*/ GIMT_Encode4(1474974), // Rule ID 24094 //
     /* 1474882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1474885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1474902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1474905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1474908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1474912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1474920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1474924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1474928 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1474932 */     // MIs[1] Operand 1
     /* 1474932 */     // No operand predicates
     /* 1474932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1474936 */     // MIs[0] policy
     /* 1474936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1474939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1474941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1474948 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1474948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1474951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1474953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1474955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1474957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1474960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1474962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1474967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1474970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1474972 */     GIR_RootConstrainSelectedInstOperands,
     /* 1474973 */     // GIR_Coverage, 24094,
     /* 1474973 */     GIR_EraseRootFromParent_Done,
     /* 1474974 */   // Label 20612: @1474974
     /* 1474974 */   GIM_Try, /*On fail goto*//*Label 20613*/ GIMT_Encode4(1475071), // Rule ID 24095 //
     /* 1474979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1474982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1474987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1474990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1474993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1474996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1474999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1475002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475025 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475029 */     // MIs[1] Operand 1
     /* 1475029 */     // No operand predicates
     /* 1475029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475033 */     // MIs[0] policy
     /* 1475033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475045 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1475048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475070 */     // GIR_Coverage, 24095,
     /* 1475070 */     GIR_EraseRootFromParent_Done,
     /* 1475071 */   // Label 20613: @1475071
     /* 1475071 */   GIM_Try, /*On fail goto*//*Label 20614*/ GIMT_Encode4(1475168), // Rule ID 24098 //
     /* 1475076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1475079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1475087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1475090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1475093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475122 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475126 */     // MIs[1] Operand 1
     /* 1475126 */     // No operand predicates
     /* 1475126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475130 */     // MIs[0] policy
     /* 1475130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475142 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1475145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475166 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475167 */     // GIR_Coverage, 24098,
     /* 1475167 */     GIR_EraseRootFromParent_Done,
     /* 1475168 */   // Label 20614: @1475168
     /* 1475168 */   GIM_Try, /*On fail goto*//*Label 20615*/ GIMT_Encode4(1475265), // Rule ID 24099 //
     /* 1475173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1475176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1475184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1475187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1475190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1475196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475223 */     // MIs[1] Operand 1
     /* 1475223 */     // No operand predicates
     /* 1475223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475227 */     // MIs[0] policy
     /* 1475227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475239 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1475242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1475261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475264 */     // GIR_Coverage, 24099,
     /* 1475264 */     GIR_EraseRootFromParent_Done,
     /* 1475265 */   // Label 20615: @1475265
     /* 1475265 */   GIM_Try, /*On fail goto*//*Label 20616*/ GIMT_Encode4(1475362), // Rule ID 24102 //
     /* 1475270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1475273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1475281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1475284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1475287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1475293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475316 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475320 */     // MIs[1] Operand 1
     /* 1475320 */     // No operand predicates
     /* 1475320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475324 */     // MIs[0] policy
     /* 1475324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475336 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1475339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475360 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475361 */     // GIR_Coverage, 24102,
     /* 1475361 */     GIR_EraseRootFromParent_Done,
     /* 1475362 */   // Label 20616: @1475362
     /* 1475362 */   GIM_Try, /*On fail goto*//*Label 20617*/ GIMT_Encode4(1475459), // Rule ID 24103 //
     /* 1475367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1475370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1475378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1475381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1475384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1475390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1475397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1475405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475413 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475417 */     // MIs[1] Operand 1
     /* 1475417 */     // No operand predicates
     /* 1475417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475421 */     // MIs[0] policy
     /* 1475421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475433 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 1475436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475442 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1475455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475458 */     // GIR_Coverage, 24103,
     /* 1475458 */     GIR_EraseRootFromParent_Done,
     /* 1475459 */   // Label 20617: @1475459
     /* 1475459 */   GIM_Try, /*On fail goto*//*Label 20618*/ GIMT_Encode4(1475556), // Rule ID 24106 //
     /* 1475464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1475467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475514 */     // MIs[1] Operand 1
     /* 1475514 */     // No operand predicates
     /* 1475514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475518 */     // MIs[0] policy
     /* 1475518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475530 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475554 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475555 */     // GIR_Coverage, 24106,
     /* 1475555 */     GIR_EraseRootFromParent_Done,
     /* 1475556 */   // Label 20618: @1475556
     /* 1475556 */   GIM_Try, /*On fail goto*//*Label 20619*/ GIMT_Encode4(1475653), // Rule ID 24107 //
     /* 1475561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1475564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1475572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1475575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1475578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1475584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1475591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1475599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475607 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475611 */     // MIs[1] Operand 1
     /* 1475611 */     // No operand predicates
     /* 1475611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475615 */     // MIs[0] policy
     /* 1475615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475627 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1475630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475652 */     // GIR_Coverage, 24107,
     /* 1475652 */     GIR_EraseRootFromParent_Done,
     /* 1475653 */   // Label 20619: @1475653
     /* 1475653 */   GIM_Try, /*On fail goto*//*Label 20620*/ GIMT_Encode4(1475750), // Rule ID 24110 //
     /* 1475658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1475661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475704 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475708 */     // MIs[1] Operand 1
     /* 1475708 */     // No operand predicates
     /* 1475708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475712 */     // MIs[0] policy
     /* 1475712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475724 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475748 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475749 */     // GIR_Coverage, 24110,
     /* 1475749 */     GIR_EraseRootFromParent_Done,
     /* 1475750 */   // Label 20620: @1475750
     /* 1475750 */   GIM_Try, /*On fail goto*//*Label 20621*/ GIMT_Encode4(1475847), // Rule ID 24111 //
     /* 1475755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1475758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1475766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1475769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1475772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1475778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1475785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1475793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475805 */     // MIs[1] Operand 1
     /* 1475805 */     // No operand predicates
     /* 1475805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475809 */     // MIs[0] policy
     /* 1475809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475821 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1475821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1475824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475846 */     // GIR_Coverage, 24111,
     /* 1475846 */     GIR_EraseRootFromParent_Done,
     /* 1475847 */   // Label 20621: @1475847
     /* 1475847 */   GIM_Try, /*On fail goto*//*Label 20622*/ GIMT_Encode4(1475944), // Rule ID 24114 //
     /* 1475852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1475855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1475872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1475878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475898 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475902 */     // MIs[1] Operand 1
     /* 1475902 */     // No operand predicates
     /* 1475902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1475906 */     // MIs[0] policy
     /* 1475906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1475909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1475911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1475918 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1475918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1475921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1475923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1475925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1475927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1475930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1475932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1475937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1475940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1475942 */     GIR_RootConstrainSelectedInstOperands,
     /* 1475943 */     // GIR_Coverage, 24114,
     /* 1475943 */     GIR_EraseRootFromParent_Done,
     /* 1475944 */   // Label 20622: @1475944
     /* 1475944 */   GIM_Try, /*On fail goto*//*Label 20623*/ GIMT_Encode4(1476041), // Rule ID 24115 //
     /* 1475949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1475952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1475957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1475960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1475963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1475966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1475969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1475972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1475975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1475979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1475987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1475991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1475995 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1475999 */     // MIs[1] Operand 1
     /* 1475999 */     // No operand predicates
     /* 1475999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476003 */     // MIs[0] policy
     /* 1476003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476015 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1476037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476040 */     // GIR_Coverage, 24115,
     /* 1476040 */     GIR_EraseRootFromParent_Done,
     /* 1476041 */   // Label 20623: @1476041
     /* 1476041 */   GIM_Try, /*On fail goto*//*Label 20624*/ GIMT_Encode4(1476138), // Rule ID 24118 //
     /* 1476046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1476049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1476057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1476060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476092 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476096 */     // MIs[1] Operand 1
     /* 1476096 */     // No operand predicates
     /* 1476096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476100 */     // MIs[0] policy
     /* 1476100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476112 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476134 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476136 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476137 */     // GIR_Coverage, 24118,
     /* 1476137 */     GIR_EraseRootFromParent_Done,
     /* 1476138 */   // Label 20624: @1476138
     /* 1476138 */   GIM_Try, /*On fail goto*//*Label 20625*/ GIMT_Encode4(1476235), // Rule ID 24119 //
     /* 1476143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1476146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1476154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1476157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1476160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476193 */     // MIs[1] Operand 1
     /* 1476193 */     // No operand predicates
     /* 1476193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476197 */     // MIs[0] policy
     /* 1476197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476234 */     // GIR_Coverage, 24119,
     /* 1476234 */     GIR_EraseRootFromParent_Done,
     /* 1476235 */   // Label 20625: @1476235
     /* 1476235 */   GIM_Try, /*On fail goto*//*Label 20626*/ GIMT_Encode4(1476332), // Rule ID 24122 //
     /* 1476240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1476243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476286 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476290 */     // MIs[1] Operand 1
     /* 1476290 */     // No operand predicates
     /* 1476290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476294 */     // MIs[0] policy
     /* 1476294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476306 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476328 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476330 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476331 */     // GIR_Coverage, 24122,
     /* 1476331 */     GIR_EraseRootFromParent_Done,
     /* 1476332 */   // Label 20626: @1476332
     /* 1476332 */   GIM_Try, /*On fail goto*//*Label 20627*/ GIMT_Encode4(1476429), // Rule ID 24123 //
     /* 1476337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1476340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1476348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1476351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1476354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1476360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476383 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476387 */     // MIs[1] Operand 1
     /* 1476387 */     // No operand predicates
     /* 1476387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476391 */     // MIs[0] policy
     /* 1476391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476403 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476428 */     // GIR_Coverage, 24123,
     /* 1476428 */     GIR_EraseRootFromParent_Done,
     /* 1476429 */   // Label 20627: @1476429
     /* 1476429 */   GIM_Try, /*On fail goto*//*Label 20628*/ GIMT_Encode4(1476526), // Rule ID 24126 //
     /* 1476434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1476437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476480 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476484 */     // MIs[1] Operand 1
     /* 1476484 */     // No operand predicates
     /* 1476484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476488 */     // MIs[0] policy
     /* 1476488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476500 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476522 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476524 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476525 */     // GIR_Coverage, 24126,
     /* 1476525 */     GIR_EraseRootFromParent_Done,
     /* 1476526 */   // Label 20628: @1476526
     /* 1476526 */   GIM_Try, /*On fail goto*//*Label 20629*/ GIMT_Encode4(1476623), // Rule ID 24127 //
     /* 1476531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1476534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1476542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1476545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1476548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1476554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1476561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1476569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476581 */     // MIs[1] Operand 1
     /* 1476581 */     // No operand predicates
     /* 1476581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476585 */     // MIs[0] policy
     /* 1476585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476597 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1476600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1476619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476622 */     // GIR_Coverage, 24127,
     /* 1476622 */     GIR_EraseRootFromParent_Done,
     /* 1476623 */   // Label 20629: @1476623
     /* 1476623 */   GIM_Try, /*On fail goto*//*Label 20630*/ GIMT_Encode4(1476720), // Rule ID 24130 //
     /* 1476628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1476631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476674 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476678 */     // MIs[1] Operand 1
     /* 1476678 */     // No operand predicates
     /* 1476678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476682 */     // MIs[0] policy
     /* 1476682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476694 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476716 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476718 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476719 */     // GIR_Coverage, 24130,
     /* 1476719 */     GIR_EraseRootFromParent_Done,
     /* 1476720 */   // Label 20630: @1476720
     /* 1476720 */   GIM_Try, /*On fail goto*//*Label 20631*/ GIMT_Encode4(1476817), // Rule ID 24131 //
     /* 1476725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1476728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1476736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1476739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1476742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1476748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1476755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1476763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476775 */     // MIs[1] Operand 1
     /* 1476775 */     // No operand predicates
     /* 1476775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476779 */     // MIs[0] policy
     /* 1476779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 1476794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476816 */     // GIR_Coverage, 24131,
     /* 1476816 */     GIR_EraseRootFromParent_Done,
     /* 1476817 */   // Label 20631: @1476817
     /* 1476817 */   GIM_Try, /*On fail goto*//*Label 20632*/ GIMT_Encode4(1476914), // Rule ID 24134 //
     /* 1476822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1476825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1476842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1476848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476868 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476872 */     // MIs[1] Operand 1
     /* 1476872 */     // No operand predicates
     /* 1476872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476876 */     // MIs[0] policy
     /* 1476876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1476888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1476907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1476910 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1476912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1476913 */     // GIR_Coverage, 24134,
     /* 1476913 */     GIR_EraseRootFromParent_Done,
     /* 1476914 */   // Label 20632: @1476914
     /* 1476914 */   GIM_Try, /*On fail goto*//*Label 20633*/ GIMT_Encode4(1477011), // Rule ID 24135 //
     /* 1476919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1476922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1476927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1476930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1476933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1476936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1476939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1476942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1476945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1476949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1476957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1476961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1476965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1476969 */     // MIs[1] Operand 1
     /* 1476969 */     // No operand predicates
     /* 1476969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1476973 */     // MIs[0] policy
     /* 1476973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1476976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1476978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1476985 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1476985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 1476988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1476990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1476992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1476994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1476997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1476999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1477007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477010 */     // GIR_Coverage, 24135,
     /* 1477010 */     GIR_EraseRootFromParent_Done,
     /* 1477011 */   // Label 20633: @1477011
     /* 1477011 */   GIM_Try, /*On fail goto*//*Label 20634*/ GIMT_Encode4(1477108), // Rule ID 24138 //
     /* 1477016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1477019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1477027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1477030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477062 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477066 */     // MIs[1] Operand 1
     /* 1477066 */     // No operand predicates
     /* 1477066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477070 */     // MIs[0] policy
     /* 1477070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477082 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1477085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1477104 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477107 */     // GIR_Coverage, 24138,
     /* 1477107 */     GIR_EraseRootFromParent_Done,
     /* 1477108 */   // Label 20634: @1477108
     /* 1477108 */   GIM_Try, /*On fail goto*//*Label 20635*/ GIMT_Encode4(1477205), // Rule ID 24139 //
     /* 1477113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1477116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1477121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1477124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1477127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1477130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1477136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1477143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1477151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477159 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477163 */     // MIs[1] Operand 1
     /* 1477163 */     // No operand predicates
     /* 1477163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477167 */     // MIs[0] policy
     /* 1477167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477179 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 1477182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477188 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1477201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477204 */     // GIR_Coverage, 24139,
     /* 1477204 */     GIR_EraseRootFromParent_Done,
     /* 1477205 */   // Label 20635: @1477205
     /* 1477205 */   GIM_Try, /*On fail goto*//*Label 20636*/ GIMT_Encode4(1477302), // Rule ID 24202 //
     /* 1477210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1477213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477260 */     // MIs[1] Operand 1
     /* 1477260 */     // No operand predicates
     /* 1477260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477264 */     // MIs[0] policy
     /* 1477264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477276 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477298 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477301 */     // GIR_Coverage, 24202,
     /* 1477301 */     GIR_EraseRootFromParent_Done,
     /* 1477302 */   // Label 20636: @1477302
     /* 1477302 */   GIM_Try, /*On fail goto*//*Label 20637*/ GIMT_Encode4(1477399), // Rule ID 24203 //
     /* 1477307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1477310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1477318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1477321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1477324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477357 */     // MIs[1] Operand 1
     /* 1477357 */     // No operand predicates
     /* 1477357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477361 */     // MIs[0] policy
     /* 1477361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477373 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 1477376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477398 */     // GIR_Coverage, 24203,
     /* 1477398 */     GIR_EraseRootFromParent_Done,
     /* 1477399 */   // Label 20637: @1477399
     /* 1477399 */   GIM_Try, /*On fail goto*//*Label 20638*/ GIMT_Encode4(1477496), // Rule ID 24206 //
     /* 1477404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1477407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477450 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477454 */     // MIs[1] Operand 1
     /* 1477454 */     // No operand predicates
     /* 1477454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477458 */     // MIs[0] policy
     /* 1477458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477470 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477492 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477495 */     // GIR_Coverage, 24206,
     /* 1477495 */     GIR_EraseRootFromParent_Done,
     /* 1477496 */   // Label 20638: @1477496
     /* 1477496 */   GIM_Try, /*On fail goto*//*Label 20639*/ GIMT_Encode4(1477593), // Rule ID 24207 //
     /* 1477501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1477504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1477512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1477515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1477518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1477524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477547 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477551 */     // MIs[1] Operand 1
     /* 1477551 */     // No operand predicates
     /* 1477551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477555 */     // MIs[0] policy
     /* 1477555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477567 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477576 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477592 */     // GIR_Coverage, 24207,
     /* 1477592 */     GIR_EraseRootFromParent_Done,
     /* 1477593 */   // Label 20639: @1477593
     /* 1477593 */   GIM_Try, /*On fail goto*//*Label 20640*/ GIMT_Encode4(1477690), // Rule ID 24210 //
     /* 1477598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1477601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477648 */     // MIs[1] Operand 1
     /* 1477648 */     // No operand predicates
     /* 1477648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477652 */     // MIs[0] policy
     /* 1477652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477664 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477686 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477689 */     // GIR_Coverage, 24210,
     /* 1477689 */     GIR_EraseRootFromParent_Done,
     /* 1477690 */   // Label 20640: @1477690
     /* 1477690 */   GIM_Try, /*On fail goto*//*Label 20641*/ GIMT_Encode4(1477787), // Rule ID 24211 //
     /* 1477695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1477698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1477706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1477709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1477712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1477718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477745 */     // MIs[1] Operand 1
     /* 1477745 */     // No operand predicates
     /* 1477745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477749 */     // MIs[0] policy
     /* 1477749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477761 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 1477764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1477783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477786 */     // GIR_Coverage, 24211,
     /* 1477786 */     GIR_EraseRootFromParent_Done,
     /* 1477787 */   // Label 20641: @1477787
     /* 1477787 */   GIM_Try, /*On fail goto*//*Label 20642*/ GIMT_Encode4(1477884), // Rule ID 24214 //
     /* 1477792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1477795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1477806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1477809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1477812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1477818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477830 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477834 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477838 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477842 */     // MIs[1] Operand 1
     /* 1477842 */     // No operand predicates
     /* 1477842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477846 */     // MIs[0] policy
     /* 1477846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477858 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1477858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477880 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477883 */     // GIR_Coverage, 24214,
     /* 1477883 */     GIR_EraseRootFromParent_Done,
     /* 1477884 */   // Label 20642: @1477884
     /* 1477884 */   GIM_Try, /*On fail goto*//*Label 20643*/ GIMT_Encode4(1477981), // Rule ID 24215 //
     /* 1477889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1477892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1477900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1477903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1477906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1477909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1477912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1477915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1477919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1477927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1477931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1477935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1477939 */     // MIs[1] Operand 1
     /* 1477939 */     // No operand predicates
     /* 1477939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1477943 */     // MIs[0] policy
     /* 1477943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1477946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1477948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1477955 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1477955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1477958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1477960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1477962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1477964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1477967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1477969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1477974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1477977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1477979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1477980 */     // GIR_Coverage, 24215,
     /* 1477980 */     GIR_EraseRootFromParent_Done,
     /* 1477981 */   // Label 20643: @1477981
     /* 1477981 */   GIM_Try, /*On fail goto*//*Label 20644*/ GIMT_Encode4(1478078), // Rule ID 24218 //
     /* 1477986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1477989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1477994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1477997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478032 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478036 */     // MIs[1] Operand 1
     /* 1478036 */     // No operand predicates
     /* 1478036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478040 */     // MIs[0] policy
     /* 1478040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478052 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478074 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478076 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478077 */     // GIR_Coverage, 24218,
     /* 1478077 */     GIR_EraseRootFromParent_Done,
     /* 1478078 */   // Label 20644: @1478078
     /* 1478078 */   GIM_Try, /*On fail goto*//*Label 20645*/ GIMT_Encode4(1478175), // Rule ID 24219 //
     /* 1478083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1478086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1478094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1478097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1478100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1478106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478133 */     // MIs[1] Operand 1
     /* 1478133 */     // No operand predicates
     /* 1478133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478137 */     // MIs[0] policy
     /* 1478137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478149 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478158 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1478171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478174 */     // GIR_Coverage, 24219,
     /* 1478174 */     GIR_EraseRootFromParent_Done,
     /* 1478175 */   // Label 20645: @1478175
     /* 1478175 */   GIM_Try, /*On fail goto*//*Label 20646*/ GIMT_Encode4(1478272), // Rule ID 24222 //
     /* 1478180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1478183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478226 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478230 */     // MIs[1] Operand 1
     /* 1478230 */     // No operand predicates
     /* 1478230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478234 */     // MIs[0] policy
     /* 1478234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478246 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478268 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478270 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478271 */     // GIR_Coverage, 24222,
     /* 1478271 */     GIR_EraseRootFromParent_Done,
     /* 1478272 */   // Label 20646: @1478272
     /* 1478272 */   GIM_Try, /*On fail goto*//*Label 20647*/ GIMT_Encode4(1478369), // Rule ID 24223 //
     /* 1478277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1478280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1478288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1478291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1478294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1478300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1478307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1478315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478323 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478327 */     // MIs[1] Operand 1
     /* 1478327 */     // No operand predicates
     /* 1478327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478331 */     // MIs[0] policy
     /* 1478331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478343 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 1478346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478352 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1478365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478368 */     // GIR_Coverage, 24223,
     /* 1478368 */     GIR_EraseRootFromParent_Done,
     /* 1478369 */   // Label 20647: @1478369
     /* 1478369 */   GIM_Try, /*On fail goto*//*Label 20648*/ GIMT_Encode4(1478466), // Rule ID 24226 //
     /* 1478374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1478377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1478391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478420 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478424 */     // MIs[1] Operand 1
     /* 1478424 */     // No operand predicates
     /* 1478424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478428 */     // MIs[0] policy
     /* 1478428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478440 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478464 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478465 */     // GIR_Coverage, 24226,
     /* 1478465 */     GIR_EraseRootFromParent_Done,
     /* 1478466 */   // Label 20648: @1478466
     /* 1478466 */   GIM_Try, /*On fail goto*//*Label 20649*/ GIMT_Encode4(1478563), // Rule ID 24227 //
     /* 1478471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1478474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1478482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1478485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1478488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1478494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478521 */     // MIs[1] Operand 1
     /* 1478521 */     // No operand predicates
     /* 1478521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478525 */     // MIs[0] policy
     /* 1478525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478537 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1478540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478562 */     // GIR_Coverage, 24227,
     /* 1478562 */     GIR_EraseRootFromParent_Done,
     /* 1478563 */   // Label 20649: @1478563
     /* 1478563 */   GIM_Try, /*On fail goto*//*Label 20650*/ GIMT_Encode4(1478660), // Rule ID 24230 //
     /* 1478568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1478571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1478579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1478582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1478585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478618 */     // MIs[1] Operand 1
     /* 1478618 */     // No operand predicates
     /* 1478618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478622 */     // MIs[0] policy
     /* 1478622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478634 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478658 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478659 */     // GIR_Coverage, 24230,
     /* 1478659 */     GIR_EraseRootFromParent_Done,
     /* 1478660 */   // Label 20650: @1478660
     /* 1478660 */   GIM_Try, /*On fail goto*//*Label 20651*/ GIMT_Encode4(1478757), // Rule ID 24231 //
     /* 1478665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1478668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1478676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1478679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1478682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1478688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1478695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1478703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478711 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478715 */     // MIs[1] Operand 1
     /* 1478715 */     // No operand predicates
     /* 1478715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478719 */     // MIs[0] policy
     /* 1478719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478731 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1478734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478756 */     // GIR_Coverage, 24231,
     /* 1478756 */     GIR_EraseRootFromParent_Done,
     /* 1478757 */   // Label 20651: @1478757
     /* 1478757 */   GIM_Try, /*On fail goto*//*Label 20652*/ GIMT_Encode4(1478854), // Rule ID 24234 //
     /* 1478762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1478765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1478773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1478776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1478779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478808 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478812 */     // MIs[1] Operand 1
     /* 1478812 */     // No operand predicates
     /* 1478812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478816 */     // MIs[0] policy
     /* 1478816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478828 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1478828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1478831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478852 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478853 */     // GIR_Coverage, 24234,
     /* 1478853 */     GIR_EraseRootFromParent_Done,
     /* 1478854 */   // Label 20652: @1478854
     /* 1478854 */   GIM_Try, /*On fail goto*//*Label 20653*/ GIMT_Encode4(1478951), // Rule ID 24235 //
     /* 1478859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1478862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1478870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1478873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1478876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1478879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1478882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1478885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1478889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1478897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1478905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1478909 */     // MIs[1] Operand 1
     /* 1478909 */     // No operand predicates
     /* 1478909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1478913 */     // MIs[0] policy
     /* 1478913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1478916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1478918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1478925 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1478925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1478928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1478930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1478932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1478934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1478937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1478939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1478944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1478947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1478949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1478950 */     // GIR_Coverage, 24235,
     /* 1478950 */     GIR_EraseRootFromParent_Done,
     /* 1478951 */   // Label 20653: @1478951
     /* 1478951 */   GIM_Try, /*On fail goto*//*Label 20654*/ GIMT_Encode4(1479048), // Rule ID 24238 //
     /* 1478956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1478959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1478964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1478967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1478970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1478973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1478976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1478979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1478982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1478986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1478994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1478998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479002 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479006 */     // MIs[1] Operand 1
     /* 1479006 */     // No operand predicates
     /* 1479006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479010 */     // MIs[0] policy
     /* 1479010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479022 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479046 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479047 */     // GIR_Coverage, 24238,
     /* 1479047 */     GIR_EraseRootFromParent_Done,
     /* 1479048 */   // Label 20654: @1479048
     /* 1479048 */   GIM_Try, /*On fail goto*//*Label 20655*/ GIMT_Encode4(1479145), // Rule ID 24239 //
     /* 1479053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1479056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1479064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1479067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1479070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479099 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479103 */     // MIs[1] Operand 1
     /* 1479103 */     // No operand predicates
     /* 1479103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479107 */     // MIs[0] policy
     /* 1479107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479119 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479144 */     // GIR_Coverage, 24239,
     /* 1479144 */     GIR_EraseRootFromParent_Done,
     /* 1479145 */   // Label 20655: @1479145
     /* 1479145 */   GIM_Try, /*On fail goto*//*Label 20656*/ GIMT_Encode4(1479242), // Rule ID 24242 //
     /* 1479150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1479153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479200 */     // MIs[1] Operand 1
     /* 1479200 */     // No operand predicates
     /* 1479200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479204 */     // MIs[0] policy
     /* 1479204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479216 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479240 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479241 */     // GIR_Coverage, 24242,
     /* 1479241 */     GIR_EraseRootFromParent_Done,
     /* 1479242 */   // Label 20656: @1479242
     /* 1479242 */   GIM_Try, /*On fail goto*//*Label 20657*/ GIMT_Encode4(1479339), // Rule ID 24243 //
     /* 1479247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1479250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1479258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1479261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1479264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479297 */     // MIs[1] Operand 1
     /* 1479297 */     // No operand predicates
     /* 1479297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479301 */     // MIs[0] policy
     /* 1479301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479313 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479338 */     // GIR_Coverage, 24243,
     /* 1479338 */     GIR_EraseRootFromParent_Done,
     /* 1479339 */   // Label 20657: @1479339
     /* 1479339 */   GIM_Try, /*On fail goto*//*Label 20658*/ GIMT_Encode4(1479436), // Rule ID 24246 //
     /* 1479344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1479347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1479355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1479358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1479361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479394 */     // MIs[1] Operand 1
     /* 1479394 */     // No operand predicates
     /* 1479394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479398 */     // MIs[0] policy
     /* 1479398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479401 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479410 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479434 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479435 */     // GIR_Coverage, 24246,
     /* 1479435 */     GIR_EraseRootFromParent_Done,
     /* 1479436 */   // Label 20658: @1479436
     /* 1479436 */   GIM_Try, /*On fail goto*//*Label 20659*/ GIMT_Encode4(1479533), // Rule ID 24247 //
     /* 1479441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1479444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1479452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1479455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1479458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1479464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479487 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479491 */     // MIs[1] Operand 1
     /* 1479491 */     // No operand predicates
     /* 1479491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479495 */     // MIs[0] policy
     /* 1479495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479507 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1479529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479532 */     // GIR_Coverage, 24247,
     /* 1479532 */     GIR_EraseRootFromParent_Done,
     /* 1479533 */   // Label 20659: @1479533
     /* 1479533 */   GIM_Try, /*On fail goto*//*Label 20660*/ GIMT_Encode4(1479630), // Rule ID 24250 //
     /* 1479538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1479541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1479549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1479552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1479555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479588 */     // MIs[1] Operand 1
     /* 1479588 */     // No operand predicates
     /* 1479588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479592 */     // MIs[0] policy
     /* 1479592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479604 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479613 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479626 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479628 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479629 */     // GIR_Coverage, 24250,
     /* 1479629 */     GIR_EraseRootFromParent_Done,
     /* 1479630 */   // Label 20660: @1479630
     /* 1479630 */   GIM_Try, /*On fail goto*//*Label 20661*/ GIMT_Encode4(1479727), // Rule ID 24251 //
     /* 1479635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1479638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1479646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1479649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1479652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1479658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1479665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1479673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479685 */     // MIs[1] Operand 1
     /* 1479685 */     // No operand predicates
     /* 1479685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479689 */     // MIs[0] policy
     /* 1479689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479701 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 1479704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479726 */     // GIR_Coverage, 24251,
     /* 1479726 */     GIR_EraseRootFromParent_Done,
     /* 1479727 */   // Label 20661: @1479727
     /* 1479727 */   GIM_Try, /*On fail goto*//*Label 20662*/ GIMT_Encode4(1479824), // Rule ID 24254 //
     /* 1479732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1479735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1479743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1479746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1479749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479778 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479782 */     // MIs[1] Operand 1
     /* 1479782 */     // No operand predicates
     /* 1479782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479786 */     // MIs[0] policy
     /* 1479786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479798 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479820 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479822 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479823 */     // GIR_Coverage, 24254,
     /* 1479823 */     GIR_EraseRootFromParent_Done,
     /* 1479824 */   // Label 20662: @1479824
     /* 1479824 */   GIM_Try, /*On fail goto*//*Label 20663*/ GIMT_Encode4(1479921), // Rule ID 24255 //
     /* 1479829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1479832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1479840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1479843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1479846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1479849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1479852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1479855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1479859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1479867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479875 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479879 */     // MIs[1] Operand 1
     /* 1479879 */     // No operand predicates
     /* 1479879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479883 */     // MIs[0] policy
     /* 1479883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479895 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1479895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 1479898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1479904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1479907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1479909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1479914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1479917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1479919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1479920 */     // GIR_Coverage, 24255,
     /* 1479920 */     GIR_EraseRootFromParent_Done,
     /* 1479921 */   // Label 20663: @1479921
     /* 1479921 */   GIM_Try, /*On fail goto*//*Label 20664*/ GIMT_Encode4(1480018), // Rule ID 24258 //
     /* 1479926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1479929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1479934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1479937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1479940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1479943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1479946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1479949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1479952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1479956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1479964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1479968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1479972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1479976 */     // MIs[1] Operand 1
     /* 1479976 */     // No operand predicates
     /* 1479976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1479980 */     // MIs[0] policy
     /* 1479980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1479983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1479985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1479992 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1479992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1479995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1479997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1479999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480014 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480016 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480017 */     // GIR_Coverage, 24258,
     /* 1480017 */     GIR_EraseRootFromParent_Done,
     /* 1480018 */   // Label 20664: @1480018
     /* 1480018 */   GIM_Try, /*On fail goto*//*Label 20665*/ GIMT_Encode4(1480115), // Rule ID 24259 //
     /* 1480023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1480026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1480031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1480034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1480037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1480040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1480046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1480053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1480061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480073 */     // MIs[1] Operand 1
     /* 1480073 */     // No operand predicates
     /* 1480073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480077 */     // MIs[0] policy
     /* 1480077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480089 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 1480092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1480096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1480111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480114 */     // GIR_Coverage, 24259,
     /* 1480114 */     GIR_EraseRootFromParent_Done,
     /* 1480115 */   // Label 20665: @1480115
     /* 1480115 */   GIM_Try, /*On fail goto*//*Label 20666*/ GIMT_Encode4(1480212), // Rule ID 24558 //
     /* 1480120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1480131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1480134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1480137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480166 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480170 */     // MIs[1] Operand 1
     /* 1480170 */     // No operand predicates
     /* 1480170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480174 */     // MIs[0] policy
     /* 1480174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480177 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480186 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1480189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480208 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480210 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480211 */     // GIR_Coverage, 24558,
     /* 1480211 */     GIR_EraseRootFromParent_Done,
     /* 1480212 */   // Label 20666: @1480212
     /* 1480212 */   GIM_Try, /*On fail goto*//*Label 20667*/ GIMT_Encode4(1480309), // Rule ID 24559 //
     /* 1480217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1480228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1480231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1480234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480263 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480267 */     // MIs[1] Operand 1
     /* 1480267 */     // No operand predicates
     /* 1480267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480271 */     // MIs[0] policy
     /* 1480271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480283 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF8_MASK),
     /* 1480286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480308 */     // GIR_Coverage, 24559,
     /* 1480308 */     GIR_EraseRootFromParent_Done,
     /* 1480309 */   // Label 20667: @1480309
     /* 1480309 */   GIM_Try, /*On fail goto*//*Label 20668*/ GIMT_Encode4(1480406), // Rule ID 24562 //
     /* 1480314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1480325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1480328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1480331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480360 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480364 */     // MIs[1] Operand 1
     /* 1480364 */     // No operand predicates
     /* 1480364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480368 */     // MIs[0] policy
     /* 1480368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480380 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1480383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480402 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480405 */     // GIR_Coverage, 24562,
     /* 1480405 */     GIR_EraseRootFromParent_Done,
     /* 1480406 */   // Label 20668: @1480406
     /* 1480406 */   GIM_Try, /*On fail goto*//*Label 20669*/ GIMT_Encode4(1480503), // Rule ID 24563 //
     /* 1480411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1480422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1480425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1480428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480461 */     // MIs[1] Operand 1
     /* 1480461 */     // No operand predicates
     /* 1480461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480465 */     // MIs[0] policy
     /* 1480465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480477 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1480480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480502 */     // GIR_Coverage, 24563,
     /* 1480502 */     GIR_EraseRootFromParent_Done,
     /* 1480503 */   // Label 20669: @1480503
     /* 1480503 */   GIM_Try, /*On fail goto*//*Label 20670*/ GIMT_Encode4(1480600), // Rule ID 24566 //
     /* 1480508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1480519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1480522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1480525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480546 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480550 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480554 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480558 */     // MIs[1] Operand 1
     /* 1480558 */     // No operand predicates
     /* 1480558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480562 */     // MIs[0] policy
     /* 1480562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480574 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1480577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480596 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480599 */     // GIR_Coverage, 24566,
     /* 1480599 */     GIR_EraseRootFromParent_Done,
     /* 1480600 */   // Label 20670: @1480600
     /* 1480600 */   GIM_Try, /*On fail goto*//*Label 20671*/ GIMT_Encode4(1480697), // Rule ID 24567 //
     /* 1480605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1480616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1480619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1480622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1480628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480651 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480655 */     // MIs[1] Operand 1
     /* 1480655 */     // No operand predicates
     /* 1480655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480659 */     // MIs[0] policy
     /* 1480659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480671 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1480674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1480693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480696 */     // GIR_Coverage, 24567,
     /* 1480696 */     GIR_EraseRootFromParent_Done,
     /* 1480697 */   // Label 20671: @1480697
     /* 1480697 */   GIM_Try, /*On fail goto*//*Label 20672*/ GIMT_Encode4(1480794), // Rule ID 24570 //
     /* 1480702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1480713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1480716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1480719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480748 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480752 */     // MIs[1] Operand 1
     /* 1480752 */     // No operand predicates
     /* 1480752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480756 */     // MIs[0] policy
     /* 1480756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480759 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480768 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1480771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480777 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480790 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480793 */     // GIR_Coverage, 24570,
     /* 1480793 */     GIR_EraseRootFromParent_Done,
     /* 1480794 */   // Label 20672: @1480794
     /* 1480794 */   GIM_Try, /*On fail goto*//*Label 20673*/ GIMT_Encode4(1480891), // Rule ID 24571 //
     /* 1480799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1480810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1480813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1480816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1480819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1480822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1480825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480849 */     // MIs[1] Operand 1
     /* 1480849 */     // No operand predicates
     /* 1480849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480853 */     // MIs[0] policy
     /* 1480853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480865 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1480865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1480868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480874 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480890 */     // GIR_Coverage, 24571,
     /* 1480890 */     GIR_EraseRootFromParent_Done,
     /* 1480891 */   // Label 20673: @1480891
     /* 1480891 */   GIM_Try, /*On fail goto*//*Label 20674*/ GIMT_Encode4(1480988), // Rule ID 24574 //
     /* 1480896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1480899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1480904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1480907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1480910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1480913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1480916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1480919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1480922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1480926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1480934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1480938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1480942 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1480946 */     // MIs[1] Operand 1
     /* 1480946 */     // No operand predicates
     /* 1480946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1480950 */     // MIs[0] policy
     /* 1480950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1480953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1480955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1480962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1480962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1480965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1480967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1480969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1480971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1480974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1480976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1480981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1480984 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1480986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1480987 */     // GIR_Coverage, 24574,
     /* 1480987 */     GIR_EraseRootFromParent_Done,
     /* 1480988 */   // Label 20674: @1480988
     /* 1480988 */   GIM_Try, /*On fail goto*//*Label 20675*/ GIMT_Encode4(1481085), // Rule ID 24575 //
     /* 1480993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1480996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1481004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1481007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1481010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481039 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481043 */     // MIs[1] Operand 1
     /* 1481043 */     // No operand predicates
     /* 1481043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481047 */     // MIs[0] policy
     /* 1481047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1481062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481084 */     // GIR_Coverage, 24575,
     /* 1481084 */     GIR_EraseRootFromParent_Done,
     /* 1481085 */   // Label 20675: @1481085
     /* 1481085 */   GIM_Try, /*On fail goto*//*Label 20676*/ GIMT_Encode4(1481182), // Rule ID 24578 //
     /* 1481090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481140 */     // MIs[1] Operand 1
     /* 1481140 */     // No operand predicates
     /* 1481140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481144 */     // MIs[0] policy
     /* 1481144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1481159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481178 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481181 */     // GIR_Coverage, 24578,
     /* 1481181 */     GIR_EraseRootFromParent_Done,
     /* 1481182 */   // Label 20676: @1481182
     /* 1481182 */   GIM_Try, /*On fail goto*//*Label 20677*/ GIMT_Encode4(1481279), // Rule ID 24579 //
     /* 1481187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1481198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1481201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1481204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481233 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481237 */     // MIs[1] Operand 1
     /* 1481237 */     // No operand predicates
     /* 1481237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481241 */     // MIs[0] policy
     /* 1481241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481253 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1481256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481278 */     // GIR_Coverage, 24579,
     /* 1481278 */     GIR_EraseRootFromParent_Done,
     /* 1481279 */   // Label 20677: @1481279
     /* 1481279 */   GIM_Try, /*On fail goto*//*Label 20678*/ GIMT_Encode4(1481376), // Rule ID 24582 //
     /* 1481284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1481295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1481298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1481301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481334 */     // MIs[1] Operand 1
     /* 1481334 */     // No operand predicates
     /* 1481334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481338 */     // MIs[0] policy
     /* 1481338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481350 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481372 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481375 */     // GIR_Coverage, 24582,
     /* 1481375 */     GIR_EraseRootFromParent_Done,
     /* 1481376 */   // Label 20678: @1481376
     /* 1481376 */   GIM_Try, /*On fail goto*//*Label 20679*/ GIMT_Encode4(1481473), // Rule ID 24583 //
     /* 1481381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1481392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1481395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1481398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1481404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481427 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481431 */     // MIs[1] Operand 1
     /* 1481431 */     // No operand predicates
     /* 1481431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481435 */     // MIs[0] policy
     /* 1481435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481447 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1481469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481472 */     // GIR_Coverage, 24583,
     /* 1481472 */     GIR_EraseRootFromParent_Done,
     /* 1481473 */   // Label 20679: @1481473
     /* 1481473 */   GIM_Try, /*On fail goto*//*Label 20680*/ GIMT_Encode4(1481570), // Rule ID 24586 //
     /* 1481478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481528 */     // MIs[1] Operand 1
     /* 1481528 */     // No operand predicates
     /* 1481528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481532 */     // MIs[0] policy
     /* 1481532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481566 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481569 */     // GIR_Coverage, 24586,
     /* 1481569 */     GIR_EraseRootFromParent_Done,
     /* 1481570 */   // Label 20680: @1481570
     /* 1481570 */   GIM_Try, /*On fail goto*//*Label 20681*/ GIMT_Encode4(1481667), // Rule ID 24587 //
     /* 1481575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1481586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1481589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1481592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1481598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481625 */     // MIs[1] Operand 1
     /* 1481625 */     // No operand predicates
     /* 1481625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481629 */     // MIs[0] policy
     /* 1481629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481641 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1481663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481666 */     // GIR_Coverage, 24587,
     /* 1481666 */     GIR_EraseRootFromParent_Done,
     /* 1481667 */   // Label 20681: @1481667
     /* 1481667 */   GIM_Try, /*On fail goto*//*Label 20682*/ GIMT_Encode4(1481764), // Rule ID 24590 //
     /* 1481672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1481675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481718 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481722 */     // MIs[1] Operand 1
     /* 1481722 */     // No operand predicates
     /* 1481722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481726 */     // MIs[0] policy
     /* 1481726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481760 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481762 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481763 */     // GIR_Coverage, 24590,
     /* 1481763 */     GIR_EraseRootFromParent_Done,
     /* 1481764 */   // Label 20682: @1481764
     /* 1481764 */   GIM_Try, /*On fail goto*//*Label 20683*/ GIMT_Encode4(1481861), // Rule ID 24591 //
     /* 1481769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1481772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1481780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1481783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1481786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1481792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481815 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481819 */     // MIs[1] Operand 1
     /* 1481819 */     // No operand predicates
     /* 1481819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481823 */     // MIs[0] policy
     /* 1481823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481835 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1481835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1481857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481860 */     // GIR_Coverage, 24591,
     /* 1481860 */     GIR_EraseRootFromParent_Done,
     /* 1481861 */   // Label 20683: @1481861
     /* 1481861 */   GIM_Try, /*On fail goto*//*Label 20684*/ GIMT_Encode4(1481958), // Rule ID 24594 //
     /* 1481866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1481869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1481886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1481892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1481908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1481912 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1481916 */     // MIs[1] Operand 1
     /* 1481916 */     // No operand predicates
     /* 1481916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1481920 */     // MIs[0] policy
     /* 1481920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1481923 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1481925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1481932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1481932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1481935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1481937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1481939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1481941 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1481944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1481946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1481951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1481954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1481956 */     GIR_RootConstrainSelectedInstOperands,
     /* 1481957 */     // GIR_Coverage, 24594,
     /* 1481957 */     GIR_EraseRootFromParent_Done,
     /* 1481958 */   // Label 20684: @1481958
     /* 1481958 */   GIM_Try, /*On fail goto*//*Label 20685*/ GIMT_Encode4(1482055), // Rule ID 24595 //
     /* 1481963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1481966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1481971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1481974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1481977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1481980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1481983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1481986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1481989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1481993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1481997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1482001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482013 */     // MIs[1] Operand 1
     /* 1482013 */     // No operand predicates
     /* 1482013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482017 */     // MIs[0] policy
     /* 1482017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482029 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1482032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482038 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1482051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482054 */     // GIR_Coverage, 24595,
     /* 1482054 */     GIR_EraseRootFromParent_Done,
     /* 1482055 */   // Label 20685: @1482055
     /* 1482055 */   GIM_Try, /*On fail goto*//*Label 20686*/ GIMT_Encode4(1482152), // Rule ID 24598 //
     /* 1482060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1482071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1482074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1482077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482110 */     // MIs[1] Operand 1
     /* 1482110 */     // No operand predicates
     /* 1482110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482114 */     // MIs[0] policy
     /* 1482114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482126 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1482129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482135 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482150 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482151 */     // GIR_Coverage, 24598,
     /* 1482151 */     GIR_EraseRootFromParent_Done,
     /* 1482152 */   // Label 20686: @1482152
     /* 1482152 */   GIM_Try, /*On fail goto*//*Label 20687*/ GIMT_Encode4(1482249), // Rule ID 24599 //
     /* 1482157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1482168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1482171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1482174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482207 */     // MIs[1] Operand 1
     /* 1482207 */     // No operand predicates
     /* 1482207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482211 */     // MIs[0] policy
     /* 1482211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482223 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1482226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482248 */     // GIR_Coverage, 24599,
     /* 1482248 */     GIR_EraseRootFromParent_Done,
     /* 1482249 */   // Label 20687: @1482249
     /* 1482249 */   GIM_Try, /*On fail goto*//*Label 20688*/ GIMT_Encode4(1482346), // Rule ID 24602 //
     /* 1482254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1482265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1482268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1482271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482300 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482304 */     // MIs[1] Operand 1
     /* 1482304 */     // No operand predicates
     /* 1482304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482308 */     // MIs[0] policy
     /* 1482308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482320 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1482323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482344 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482345 */     // GIR_Coverage, 24602,
     /* 1482345 */     GIR_EraseRootFromParent_Done,
     /* 1482346 */   // Label 20688: @1482346
     /* 1482346 */   GIM_Try, /*On fail goto*//*Label 20689*/ GIMT_Encode4(1482443), // Rule ID 24603 //
     /* 1482351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1482362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1482365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1482368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1482374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482397 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482401 */     // MIs[1] Operand 1
     /* 1482401 */     // No operand predicates
     /* 1482401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482405 */     // MIs[0] policy
     /* 1482405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482408 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482417 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1482420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482442 */     // GIR_Coverage, 24603,
     /* 1482442 */     GIR_EraseRootFromParent_Done,
     /* 1482443 */   // Label 20689: @1482443
     /* 1482443 */   GIM_Try, /*On fail goto*//*Label 20690*/ GIMT_Encode4(1482540), // Rule ID 24606 //
     /* 1482448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1482459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1482462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1482465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1482471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482494 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482498 */     // MIs[1] Operand 1
     /* 1482498 */     // No operand predicates
     /* 1482498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482502 */     // MIs[0] policy
     /* 1482502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482514 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1482517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482538 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482539 */     // GIR_Coverage, 24606,
     /* 1482539 */     GIR_EraseRootFromParent_Done,
     /* 1482540 */   // Label 20690: @1482540
     /* 1482540 */   GIM_Try, /*On fail goto*//*Label 20691*/ GIMT_Encode4(1482637), // Rule ID 24607 //
     /* 1482545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1482556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1482559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1482562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1482568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1482575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1482583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482591 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482595 */     // MIs[1] Operand 1
     /* 1482595 */     // No operand predicates
     /* 1482595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482599 */     // MIs[0] policy
     /* 1482599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482611 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1482614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1482633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482636 */     // GIR_Coverage, 24607,
     /* 1482636 */     GIR_EraseRootFromParent_Done,
     /* 1482637 */   // Label 20691: @1482637
     /* 1482637 */   GIM_Try, /*On fail goto*//*Label 20692*/ GIMT_Encode4(1482734), // Rule ID 24610 //
     /* 1482642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482692 */     // MIs[1] Operand 1
     /* 1482692 */     // No operand predicates
     /* 1482692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482696 */     // MIs[0] policy
     /* 1482696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1482711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482732 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482733 */     // GIR_Coverage, 24610,
     /* 1482733 */     GIR_EraseRootFromParent_Done,
     /* 1482734 */   // Label 20692: @1482734
     /* 1482734 */   GIM_Try, /*On fail goto*//*Label 20693*/ GIMT_Encode4(1482831), // Rule ID 24611 //
     /* 1482739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1482750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1482753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1482756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1482762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1482769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1482777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482789 */     // MIs[1] Operand 1
     /* 1482789 */     // No operand predicates
     /* 1482789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482793 */     // MIs[0] policy
     /* 1482793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1482808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482810 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482830 */     // GIR_Coverage, 24611,
     /* 1482830 */     GIR_EraseRootFromParent_Done,
     /* 1482831 */   // Label 20693: @1482831
     /* 1482831 */   GIM_Try, /*On fail goto*//*Label 20694*/ GIMT_Encode4(1482928), // Rule ID 24614 //
     /* 1482836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1482839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1482856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1482862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482882 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482886 */     // MIs[1] Operand 1
     /* 1482886 */     // No operand predicates
     /* 1482886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482890 */     // MIs[0] policy
     /* 1482890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1482902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1482905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1482907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1482909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1482911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1482914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1482916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1482921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1482924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1482926 */     GIR_RootConstrainSelectedInstOperands,
     /* 1482927 */     // GIR_Coverage, 24614,
     /* 1482927 */     GIR_EraseRootFromParent_Done,
     /* 1482928 */   // Label 20694: @1482928
     /* 1482928 */   GIM_Try, /*On fail goto*//*Label 20695*/ GIMT_Encode4(1483025), // Rule ID 24615 //
     /* 1482933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1482936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1482941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1482944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1482947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1482950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1482953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1482956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1482959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1482963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1482971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1482975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1482979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1482983 */     // MIs[1] Operand 1
     /* 1482983 */     // No operand predicates
     /* 1482983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1482987 */     // MIs[0] policy
     /* 1482987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1482990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1482992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1482999 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1482999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1483002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483024 */     // GIR_Coverage, 24615,
     /* 1483024 */     GIR_EraseRootFromParent_Done,
     /* 1483025 */   // Label 20695: @1483025
     /* 1483025 */   GIM_Try, /*On fail goto*//*Label 20696*/ GIMT_Encode4(1483122), // Rule ID 24618 //
     /* 1483030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483076 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483080 */     // MIs[1] Operand 1
     /* 1483080 */     // No operand predicates
     /* 1483080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483084 */     // MIs[0] policy
     /* 1483084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483087 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1483099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483120 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483121 */     // GIR_Coverage, 24618,
     /* 1483121 */     GIR_EraseRootFromParent_Done,
     /* 1483122 */   // Label 20696: @1483122
     /* 1483122 */   GIM_Try, /*On fail goto*//*Label 20697*/ GIMT_Encode4(1483219), // Rule ID 24619 //
     /* 1483127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1483138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1483141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1483144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1483150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483177 */     // MIs[1] Operand 1
     /* 1483177 */     // No operand predicates
     /* 1483177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483181 */     // MIs[0] policy
     /* 1483181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483193 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1483196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1483215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483218 */     // GIR_Coverage, 24619,
     /* 1483218 */     GIR_EraseRootFromParent_Done,
     /* 1483219 */   // Label 20697: @1483219
     /* 1483219 */   GIM_Try, /*On fail goto*//*Label 20698*/ GIMT_Encode4(1483316), // Rule ID 24622 //
     /* 1483224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483270 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483274 */     // MIs[1] Operand 1
     /* 1483274 */     // No operand predicates
     /* 1483274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483278 */     // MIs[0] policy
     /* 1483278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1483293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483299 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483312 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483314 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483315 */     // GIR_Coverage, 24622,
     /* 1483315 */     GIR_EraseRootFromParent_Done,
     /* 1483316 */   // Label 20698: @1483316
     /* 1483316 */   GIM_Try, /*On fail goto*//*Label 20699*/ GIMT_Encode4(1483413), // Rule ID 24623 //
     /* 1483321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1483332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1483335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1483338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1483344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483367 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483371 */     // MIs[1] Operand 1
     /* 1483371 */     // No operand predicates
     /* 1483371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483375 */     // MIs[0] policy
     /* 1483375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483387 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1483390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483396 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483412 */     // GIR_Coverage, 24623,
     /* 1483412 */     GIR_EraseRootFromParent_Done,
     /* 1483413 */   // Label 20699: @1483413
     /* 1483413 */   GIM_Try, /*On fail goto*//*Label 20700*/ GIMT_Encode4(1483510), // Rule ID 24626 //
     /* 1483418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483464 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483468 */     // MIs[1] Operand 1
     /* 1483468 */     // No operand predicates
     /* 1483468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483472 */     // MIs[0] policy
     /* 1483472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483484 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1483487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483506 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483508 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483509 */     // GIR_Coverage, 24626,
     /* 1483509 */     GIR_EraseRootFromParent_Done,
     /* 1483510 */   // Label 20700: @1483510
     /* 1483510 */   GIM_Try, /*On fail goto*//*Label 20701*/ GIMT_Encode4(1483607), // Rule ID 24627 //
     /* 1483515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1483526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1483529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1483532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1483538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1483545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1483553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483565 */     // MIs[1] Operand 1
     /* 1483565 */     // No operand predicates
     /* 1483565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483569 */     // MIs[0] policy
     /* 1483569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483581 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1483584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483606 */     // GIR_Coverage, 24627,
     /* 1483606 */     GIR_EraseRootFromParent_Done,
     /* 1483607 */   // Label 20701: @1483607
     /* 1483607 */   GIM_Try, /*On fail goto*//*Label 20702*/ GIMT_Encode4(1483704), // Rule ID 24630 //
     /* 1483612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1483615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483658 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483662 */     // MIs[1] Operand 1
     /* 1483662 */     // No operand predicates
     /* 1483662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483666 */     // MIs[0] policy
     /* 1483666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483678 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1483681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483687 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483700 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483702 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483703 */     // GIR_Coverage, 24630,
     /* 1483703 */     GIR_EraseRootFromParent_Done,
     /* 1483704 */   // Label 20702: @1483704
     /* 1483704 */   GIM_Try, /*On fail goto*//*Label 20703*/ GIMT_Encode4(1483801), // Rule ID 24631 //
     /* 1483709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1483712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1483720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1483723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1483726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1483732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1483739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1483747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483755 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483759 */     // MIs[1] Operand 1
     /* 1483759 */     // No operand predicates
     /* 1483759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483763 */     // MIs[0] policy
     /* 1483763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483775 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1483778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483784 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1483797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483800 */     // GIR_Coverage, 24631,
     /* 1483800 */     GIR_EraseRootFromParent_Done,
     /* 1483801 */   // Label 20703: @1483801
     /* 1483801 */   GIM_Try, /*On fail goto*//*Label 20704*/ GIMT_Encode4(1483898), // Rule ID 24634 //
     /* 1483806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1483809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1483826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1483832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483856 */     // MIs[1] Operand 1
     /* 1483856 */     // No operand predicates
     /* 1483856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483860 */     // MIs[0] policy
     /* 1483860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1483872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1483875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483894 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483896 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483897 */     // GIR_Coverage, 24634,
     /* 1483897 */     GIR_EraseRootFromParent_Done,
     /* 1483898 */   // Label 20704: @1483898
     /* 1483898 */   GIM_Try, /*On fail goto*//*Label 20705*/ GIMT_Encode4(1483995), // Rule ID 24635 //
     /* 1483903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1483906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1483911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1483914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1483917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1483920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1483923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1483926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1483929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1483933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1483941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1483945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1483949 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1483953 */     // MIs[1] Operand 1
     /* 1483953 */     // No operand predicates
     /* 1483953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1483957 */     // MIs[0] policy
     /* 1483957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1483960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1483962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1483969 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1483969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1483972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1483974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1483976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1483978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1483981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1483983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1483988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1483991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1483993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1483994 */     // GIR_Coverage, 24635,
     /* 1483994 */     GIR_EraseRootFromParent_Done,
     /* 1483995 */   // Label 20705: @1483995
     /* 1483995 */   GIM_Try, /*On fail goto*//*Label 20706*/ GIMT_Encode4(1484092), // Rule ID 24638 //
     /* 1484000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484050 */     // MIs[1] Operand 1
     /* 1484050 */     // No operand predicates
     /* 1484050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484054 */     // MIs[0] policy
     /* 1484054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1484069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484088 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484091 */     // GIR_Coverage, 24638,
     /* 1484091 */     GIR_EraseRootFromParent_Done,
     /* 1484092 */   // Label 20706: @1484092
     /* 1484092 */   GIM_Try, /*On fail goto*//*Label 20707*/ GIMT_Encode4(1484189), // Rule ID 24639 //
     /* 1484097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1484108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1484111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1484114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1484127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1484135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484143 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484147 */     // MIs[1] Operand 1
     /* 1484147 */     // No operand predicates
     /* 1484147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484151 */     // MIs[0] policy
     /* 1484151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484163 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1484166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484188 */     // GIR_Coverage, 24639,
     /* 1484188 */     GIR_EraseRootFromParent_Done,
     /* 1484189 */   // Label 20707: @1484189
     /* 1484189 */   GIM_Try, /*On fail goto*//*Label 20708*/ GIMT_Encode4(1484286), // Rule ID 24642 //
     /* 1484194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1484197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484244 */     // MIs[1] Operand 1
     /* 1484244 */     // No operand predicates
     /* 1484244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484248 */     // MIs[0] policy
     /* 1484248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484260 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1484263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484282 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484285 */     // GIR_Coverage, 24642,
     /* 1484285 */     GIR_EraseRootFromParent_Done,
     /* 1484286 */   // Label 20708: @1484286
     /* 1484286 */   GIM_Try, /*On fail goto*//*Label 20709*/ GIMT_Encode4(1484383), // Rule ID 24643 //
     /* 1484291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1484294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1484302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1484305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1484308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1484314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1484321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1484329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484337 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484341 */     // MIs[1] Operand 1
     /* 1484341 */     // No operand predicates
     /* 1484341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484345 */     // MIs[0] policy
     /* 1484345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484357 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1484360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484382 */     // GIR_Coverage, 24643,
     /* 1484382 */     GIR_EraseRootFromParent_Done,
     /* 1484383 */   // Label 20709: @1484383
     /* 1484383 */   GIM_Try, /*On fail goto*//*Label 20710*/ GIMT_Encode4(1484480), // Rule ID 24802 //
     /* 1484388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1484391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484434 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484438 */     // MIs[1] Operand 1
     /* 1484438 */     // No operand predicates
     /* 1484438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484442 */     // MIs[0] policy
     /* 1484442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484454 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1484457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484476 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484479 */     // GIR_Coverage, 24802,
     /* 1484479 */     GIR_EraseRootFromParent_Done,
     /* 1484480 */   // Label 20710: @1484480
     /* 1484480 */   GIM_Try, /*On fail goto*//*Label 20711*/ GIMT_Encode4(1484577), // Rule ID 24803 //
     /* 1484485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1484488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1484496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1484499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1484502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484535 */     // MIs[1] Operand 1
     /* 1484535 */     // No operand predicates
     /* 1484535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484539 */     // MIs[0] policy
     /* 1484539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484551 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1484554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484576 */     // GIR_Coverage, 24803,
     /* 1484576 */     GIR_EraseRootFromParent_Done,
     /* 1484577 */   // Label 20711: @1484577
     /* 1484577 */   GIM_Try, /*On fail goto*//*Label 20712*/ GIMT_Encode4(1484674), // Rule ID 24806 //
     /* 1484582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1484585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484628 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484632 */     // MIs[1] Operand 1
     /* 1484632 */     // No operand predicates
     /* 1484632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484636 */     // MIs[0] policy
     /* 1484636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484648 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1484651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484670 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484673 */     // GIR_Coverage, 24806,
     /* 1484673 */     GIR_EraseRootFromParent_Done,
     /* 1484674 */   // Label 20712: @1484674
     /* 1484674 */   GIM_Try, /*On fail goto*//*Label 20713*/ GIMT_Encode4(1484771), // Rule ID 24807 //
     /* 1484679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1484682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1484690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1484693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1484696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1484702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484725 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484729 */     // MIs[1] Operand 1
     /* 1484729 */     // No operand predicates
     /* 1484729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484733 */     // MIs[0] policy
     /* 1484733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484745 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1484748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484754 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1484767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484770 */     // GIR_Coverage, 24807,
     /* 1484770 */     GIR_EraseRootFromParent_Done,
     /* 1484771 */   // Label 20713: @1484771
     /* 1484771 */   GIM_Try, /*On fail goto*//*Label 20714*/ GIMT_Encode4(1484868), // Rule ID 24810 //
     /* 1484776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1484779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484822 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484826 */     // MIs[1] Operand 1
     /* 1484826 */     // No operand predicates
     /* 1484826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484830 */     // MIs[0] policy
     /* 1484830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484842 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1484842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1484845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484864 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484867 */     // GIR_Coverage, 24810,
     /* 1484867 */     GIR_EraseRootFromParent_Done,
     /* 1484868 */   // Label 20714: @1484868
     /* 1484868 */   GIM_Try, /*On fail goto*//*Label 20715*/ GIMT_Encode4(1484965), // Rule ID 24811 //
     /* 1484873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1484876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1484884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1484887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1484890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1484893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1484896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1484899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1484903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1484911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1484915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1484919 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1484923 */     // MIs[1] Operand 1
     /* 1484923 */     // No operand predicates
     /* 1484923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1484927 */     // MIs[0] policy
     /* 1484927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1484930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1484932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1484939 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1484939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1484942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1484944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1484946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1484948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1484951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1484953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1484958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1484961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1484963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1484964 */     // GIR_Coverage, 24811,
     /* 1484964 */     GIR_EraseRootFromParent_Done,
     /* 1484965 */   // Label 20715: @1484965
     /* 1484965 */   GIM_Try, /*On fail goto*//*Label 20716*/ GIMT_Encode4(1485062), // Rule ID 24814 //
     /* 1484970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1484973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1484978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1484981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1484984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1484987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1484990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1484993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1484996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485016 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485020 */     // MIs[1] Operand 1
     /* 1485020 */     // No operand predicates
     /* 1485020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485024 */     // MIs[0] policy
     /* 1485024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1485039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485058 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485061 */     // GIR_Coverage, 24814,
     /* 1485061 */     GIR_EraseRootFromParent_Done,
     /* 1485062 */   // Label 20716: @1485062
     /* 1485062 */   GIM_Try, /*On fail goto*//*Label 20717*/ GIMT_Encode4(1485159), // Rule ID 24815 //
     /* 1485067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1485078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1485081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1485084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485113 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485117 */     // MIs[1] Operand 1
     /* 1485117 */     // No operand predicates
     /* 1485117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485121 */     // MIs[0] policy
     /* 1485121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1485136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485158 */     // GIR_Coverage, 24815,
     /* 1485158 */     GIR_EraseRootFromParent_Done,
     /* 1485159 */   // Label 20717: @1485159
     /* 1485159 */   GIM_Try, /*On fail goto*//*Label 20718*/ GIMT_Encode4(1485256), // Rule ID 24818 //
     /* 1485164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485210 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485214 */     // MIs[1] Operand 1
     /* 1485214 */     // No operand predicates
     /* 1485214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485218 */     // MIs[0] policy
     /* 1485218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485230 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1485233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485252 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485254 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485255 */     // GIR_Coverage, 24818,
     /* 1485255 */     GIR_EraseRootFromParent_Done,
     /* 1485256 */   // Label 20718: @1485256
     /* 1485256 */   GIM_Try, /*On fail goto*//*Label 20719*/ GIMT_Encode4(1485353), // Rule ID 24819 //
     /* 1485261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1485272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1485275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1485278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485307 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485311 */     // MIs[1] Operand 1
     /* 1485311 */     // No operand predicates
     /* 1485311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485315 */     // MIs[0] policy
     /* 1485315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485327 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1485330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485352 */     // GIR_Coverage, 24819,
     /* 1485352 */     GIR_EraseRootFromParent_Done,
     /* 1485353 */   // Label 20719: @1485353
     /* 1485353 */   GIM_Try, /*On fail goto*//*Label 20720*/ GIMT_Encode4(1485450), // Rule ID 24822 //
     /* 1485358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1485361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1485375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485404 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485408 */     // MIs[1] Operand 1
     /* 1485408 */     // No operand predicates
     /* 1485408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485412 */     // MIs[0] policy
     /* 1485412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485424 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1485427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485446 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485448 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485449 */     // GIR_Coverage, 24822,
     /* 1485449 */     GIR_EraseRootFromParent_Done,
     /* 1485450 */   // Label 20720: @1485450
     /* 1485450 */   GIM_Try, /*On fail goto*//*Label 20721*/ GIMT_Encode4(1485547), // Rule ID 24823 //
     /* 1485455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1485458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1485466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1485469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1485472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1485478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485501 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485505 */     // MIs[1] Operand 1
     /* 1485505 */     // No operand predicates
     /* 1485505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485509 */     // MIs[0] policy
     /* 1485509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485521 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1485524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1485543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485546 */     // GIR_Coverage, 24823,
     /* 1485546 */     GIR_EraseRootFromParent_Done,
     /* 1485547 */   // Label 20721: @1485547
     /* 1485547 */   GIM_Try, /*On fail goto*//*Label 20722*/ GIMT_Encode4(1485644), // Rule ID 24826 //
     /* 1485552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1485555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1485563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1485566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1485569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485598 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485602 */     // MIs[1] Operand 1
     /* 1485602 */     // No operand predicates
     /* 1485602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485606 */     // MIs[0] policy
     /* 1485606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485618 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1485621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485642 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485643 */     // GIR_Coverage, 24826,
     /* 1485643 */     GIR_EraseRootFromParent_Done,
     /* 1485644 */   // Label 20722: @1485644
     /* 1485644 */   GIM_Try, /*On fail goto*//*Label 20723*/ GIMT_Encode4(1485741), // Rule ID 24827 //
     /* 1485649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1485652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1485660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1485663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1485666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1485672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1485679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1485687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485695 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485699 */     // MIs[1] Operand 1
     /* 1485699 */     // No operand predicates
     /* 1485699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485703 */     // MIs[0] policy
     /* 1485703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1485718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485720 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485740 */     // GIR_Coverage, 24827,
     /* 1485740 */     GIR_EraseRootFromParent_Done,
     /* 1485741 */   // Label 20723: @1485741
     /* 1485741 */   GIM_Try, /*On fail goto*//*Label 20724*/ GIMT_Encode4(1485838), // Rule ID 24830 //
     /* 1485746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1485749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1485757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1485760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1485763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485792 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485796 */     // MIs[1] Operand 1
     /* 1485796 */     // No operand predicates
     /* 1485796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485800 */     // MIs[0] policy
     /* 1485800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485812 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1485812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1485815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485836 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485837 */     // GIR_Coverage, 24830,
     /* 1485837 */     GIR_EraseRootFromParent_Done,
     /* 1485838 */   // Label 20724: @1485838
     /* 1485838 */   GIM_Try, /*On fail goto*//*Label 20725*/ GIMT_Encode4(1485935), // Rule ID 24831 //
     /* 1485843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1485846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1485854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1485857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1485860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1485863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1485866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1485869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1485873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1485881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485893 */     // MIs[1] Operand 1
     /* 1485893 */     // No operand predicates
     /* 1485893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485897 */     // MIs[0] policy
     /* 1485897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1485909 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1485909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1485912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1485914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1485916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1485918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1485921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1485923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1485928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1485931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1485933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1485934 */     // GIR_Coverage, 24831,
     /* 1485934 */     GIR_EraseRootFromParent_Done,
     /* 1485935 */   // Label 20725: @1485935
     /* 1485935 */   GIM_Try, /*On fail goto*//*Label 20726*/ GIMT_Encode4(1486032), // Rule ID 24834 //
     /* 1485940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1485943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1485948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1485951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1485954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1485957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1485960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1485963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1485966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1485970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1485978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1485982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1485986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1485990 */     // MIs[1] Operand 1
     /* 1485990 */     // No operand predicates
     /* 1485990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1485994 */     // MIs[0] policy
     /* 1485994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1485997 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1485999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486006 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1486009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486015 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486030 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486031 */     // GIR_Coverage, 24834,
     /* 1486031 */     GIR_EraseRootFromParent_Done,
     /* 1486032 */   // Label 20726: @1486032
     /* 1486032 */   GIM_Try, /*On fail goto*//*Label 20727*/ GIMT_Encode4(1486129), // Rule ID 24835 //
     /* 1486037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1486040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1486048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1486051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1486054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1486067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1486075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486083 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486087 */     // MIs[1] Operand 1
     /* 1486087 */     // No operand predicates
     /* 1486087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486091 */     // MIs[0] policy
     /* 1486091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486103 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1486106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1486125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486128 */     // GIR_Coverage, 24835,
     /* 1486128 */     GIR_EraseRootFromParent_Done,
     /* 1486129 */   // Label 20727: @1486129
     /* 1486129 */   GIM_Try, /*On fail goto*//*Label 20728*/ GIMT_Encode4(1486226), // Rule ID 24886 //
     /* 1486134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1486137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1486145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1486148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1486151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486184 */     // MIs[1] Operand 1
     /* 1486184 */     // No operand predicates
     /* 1486184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486188 */     // MIs[0] policy
     /* 1486188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486200 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1486203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486224 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486225 */     // GIR_Coverage, 24886,
     /* 1486225 */     GIR_EraseRootFromParent_Done,
     /* 1486226 */   // Label 20728: @1486226
     /* 1486226 */   GIM_Try, /*On fail goto*//*Label 20729*/ GIMT_Encode4(1486323), // Rule ID 24887 //
     /* 1486231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1486234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1486242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1486245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1486248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1486254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486281 */     // MIs[1] Operand 1
     /* 1486281 */     // No operand predicates
     /* 1486281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486285 */     // MIs[0] policy
     /* 1486285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486297 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF4_MASK),
     /* 1486300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486322 */     // GIR_Coverage, 24887,
     /* 1486322 */     GIR_EraseRootFromParent_Done,
     /* 1486323 */   // Label 20729: @1486323
     /* 1486323 */   GIM_Try, /*On fail goto*//*Label 20730*/ GIMT_Encode4(1486420), // Rule ID 24890 //
     /* 1486328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1486331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1486339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1486342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1486345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486374 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486378 */     // MIs[1] Operand 1
     /* 1486378 */     // No operand predicates
     /* 1486378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486382 */     // MIs[0] policy
     /* 1486382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486394 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1486397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486418 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486419 */     // GIR_Coverage, 24890,
     /* 1486419 */     GIR_EraseRootFromParent_Done,
     /* 1486420 */   // Label 20730: @1486420
     /* 1486420 */   GIM_Try, /*On fail goto*//*Label 20731*/ GIMT_Encode4(1486517), // Rule ID 24891 //
     /* 1486425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1486428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1486436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1486439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1486442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1486448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486471 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486475 */     // MIs[1] Operand 1
     /* 1486475 */     // No operand predicates
     /* 1486475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486479 */     // MIs[0] policy
     /* 1486479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486491 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_MF2_MASK),
     /* 1486494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486500 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486516 */     // GIR_Coverage, 24891,
     /* 1486516 */     GIR_EraseRootFromParent_Done,
     /* 1486517 */   // Label 20731: @1486517
     /* 1486517 */   GIM_Try, /*On fail goto*//*Label 20732*/ GIMT_Encode4(1486614), // Rule ID 24894 //
     /* 1486522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1486525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1486533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1486536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1486539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486572 */     // MIs[1] Operand 1
     /* 1486572 */     // No operand predicates
     /* 1486572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486576 */     // MIs[0] policy
     /* 1486576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486588 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486612 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486613 */     // GIR_Coverage, 24894,
     /* 1486613 */     GIR_EraseRootFromParent_Done,
     /* 1486614 */   // Label 20732: @1486614
     /* 1486614 */   GIM_Try, /*On fail goto*//*Label 20733*/ GIMT_Encode4(1486711), // Rule ID 24895 //
     /* 1486619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1486622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1486630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1486633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1486636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1486642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1486649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1486657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486665 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486669 */     // MIs[1] Operand 1
     /* 1486669 */     // No operand predicates
     /* 1486669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486673 */     // MIs[0] policy
     /* 1486673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486685 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M1_MASK),
     /* 1486688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486710 */     // GIR_Coverage, 24895,
     /* 1486710 */     GIR_EraseRootFromParent_Done,
     /* 1486711 */   // Label 20733: @1486711
     /* 1486711 */   GIM_Try, /*On fail goto*//*Label 20734*/ GIMT_Encode4(1486808), // Rule ID 24898 //
     /* 1486716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1486719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1486727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1486730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1486733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486762 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486766 */     // MIs[1] Operand 1
     /* 1486766 */     // No operand predicates
     /* 1486766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486770 */     // MIs[0] policy
     /* 1486770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486773 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486782 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1486785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486791 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486804 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486806 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486807 */     // GIR_Coverage, 24898,
     /* 1486807 */     GIR_EraseRootFromParent_Done,
     /* 1486808 */   // Label 20734: @1486808
     /* 1486808 */   GIM_Try, /*On fail goto*//*Label 20735*/ GIMT_Encode4(1486905), // Rule ID 24899 //
     /* 1486813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1486816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1486824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1486827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1486830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1486833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1486836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1486839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1486843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1486851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486859 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486863 */     // MIs[1] Operand 1
     /* 1486863 */     // No operand predicates
     /* 1486863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486867 */     // MIs[0] policy
     /* 1486867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486879 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1486879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M2_MASK),
     /* 1486882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486888 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1486903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1486904 */     // GIR_Coverage, 24899,
     /* 1486904 */     GIR_EraseRootFromParent_Done,
     /* 1486905 */   // Label 20735: @1486905
     /* 1486905 */   GIM_Try, /*On fail goto*//*Label 20736*/ GIMT_Encode4(1487002), // Rule ID 24902 //
     /* 1486910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1486913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1486918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1486921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1486924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1486927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1486930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1486933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1486936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1486940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1486948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1486952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1486956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1486960 */     // MIs[1] Operand 1
     /* 1486960 */     // No operand predicates
     /* 1486960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1486964 */     // MIs[0] policy
     /* 1486964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1486967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1486969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1486976 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1486976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1486979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1486981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1486983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1486985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1486988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1486990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1486995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1486998 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487000 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487001 */     // GIR_Coverage, 24902,
     /* 1487001 */     GIR_EraseRootFromParent_Done,
     /* 1487002 */   // Label 20736: @1487002
     /* 1487002 */   GIM_Try, /*On fail goto*//*Label 20737*/ GIMT_Encode4(1487099), // Rule ID 24903 //
     /* 1487007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1487010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1487018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1487021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1487024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1487030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1487037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1487045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487057 */     // MIs[1] Operand 1
     /* 1487057 */     // No operand predicates
     /* 1487057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487061 */     // MIs[0] policy
     /* 1487061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487073 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M4_MASK),
     /* 1487076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487098 */     // GIR_Coverage, 24903,
     /* 1487098 */     GIR_EraseRootFromParent_Done,
     /* 1487099 */   // Label 20737: @1487099
     /* 1487099 */   GIM_Try, /*On fail goto*//*Label 20738*/ GIMT_Encode4(1487196), // Rule ID 24906 //
     /* 1487104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1487107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1487121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487142 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487146 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487150 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487154 */     // MIs[1] Operand 1
     /* 1487154 */     // No operand predicates
     /* 1487154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487158 */     // MIs[0] policy
     /* 1487158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487170 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1487173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487192 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487194 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487195 */     // GIR_Coverage, 24906,
     /* 1487195 */     GIR_EraseRootFromParent_Done,
     /* 1487196 */   // Label 20738: @1487196
     /* 1487196 */   GIM_Try, /*On fail goto*//*Label 20739*/ GIMT_Encode4(1487293), // Rule ID 24907 //
     /* 1487201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1487204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1487209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1487212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1487215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1487218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1487224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1487231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1487239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487247 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487251 */     // MIs[1] Operand 1
     /* 1487251 */     // No operand predicates
     /* 1487251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487255 */     // MIs[0] policy
     /* 1487255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487267 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VI_M8_MASK),
     /* 1487270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1487289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487292 */     // GIR_Coverage, 24907,
     /* 1487292 */     GIR_EraseRootFromParent_Done,
     /* 1487293 */   // Label 20739: @1487293
     /* 1487293 */   GIM_Try, /*On fail goto*//*Label 20740*/ GIMT_Encode4(1487390), // Rule ID 60910 //
     /* 1487298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1487301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487344 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487348 */     // MIs[1] Operand 1
     /* 1487348 */     // No operand predicates
     /* 1487348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487352 */     // MIs[0] policy
     /* 1487352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487364 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1487367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487386 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487388 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487389 */     // GIR_Coverage, 60910,
     /* 1487389 */     GIR_EraseRootFromParent_Done,
     /* 1487390 */   // Label 20740: @1487390
     /* 1487390 */   GIM_Try, /*On fail goto*//*Label 20741*/ GIMT_Encode4(1487487), // Rule ID 60911 //
     /* 1487395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1487398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1487406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1487409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1487412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1487418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487445 */     // MIs[1] Operand 1
     /* 1487445 */     // No operand predicates
     /* 1487445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487449 */     // MIs[0] policy
     /* 1487449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487461 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF8_MASK),
     /* 1487464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487486 */     // GIR_Coverage, 60911,
     /* 1487486 */     GIR_EraseRootFromParent_Done,
     /* 1487487 */   // Label 20741: @1487487
     /* 1487487 */   GIM_Try, /*On fail goto*//*Label 20742*/ GIMT_Encode4(1487584), // Rule ID 60918 //
     /* 1487492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1487495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487538 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487542 */     // MIs[1] Operand 1
     /* 1487542 */     // No operand predicates
     /* 1487542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487546 */     // MIs[0] policy
     /* 1487546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1487561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487580 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487583 */     // GIR_Coverage, 60918,
     /* 1487583 */     GIR_EraseRootFromParent_Done,
     /* 1487584 */   // Label 20742: @1487584
     /* 1487584 */   GIM_Try, /*On fail goto*//*Label 20743*/ GIMT_Encode4(1487681), // Rule ID 60919 //
     /* 1487589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1487592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1487600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1487603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1487606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1487612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487635 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487639 */     // MIs[1] Operand 1
     /* 1487639 */     // No operand predicates
     /* 1487639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487643 */     // MIs[0] policy
     /* 1487643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487655 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1487658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487680 */     // GIR_Coverage, 60919,
     /* 1487680 */     GIR_EraseRootFromParent_Done,
     /* 1487681 */   // Label 20743: @1487681
     /* 1487681 */   GIM_Try, /*On fail goto*//*Label 20744*/ GIMT_Encode4(1487778), // Rule ID 60926 //
     /* 1487686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1487689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1487697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1487700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487732 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487736 */     // MIs[1] Operand 1
     /* 1487736 */     // No operand predicates
     /* 1487736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487740 */     // MIs[0] policy
     /* 1487740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487752 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1487755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487774 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487777 */     // GIR_Coverage, 60926,
     /* 1487777 */     GIR_EraseRootFromParent_Done,
     /* 1487778 */   // Label 20744: @1487778
     /* 1487778 */   GIM_Try, /*On fail goto*//*Label 20745*/ GIMT_Encode4(1487875), // Rule ID 60927 //
     /* 1487783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1487786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1487794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1487797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1487800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1487806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1487809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1487813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487829 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487833 */     // MIs[1] Operand 1
     /* 1487833 */     // No operand predicates
     /* 1487833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487837 */     // MIs[0] policy
     /* 1487837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487849 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1487849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1487852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487874 */     // GIR_Coverage, 60927,
     /* 1487874 */     GIR_EraseRootFromParent_Done,
     /* 1487875 */   // Label 20745: @1487875
     /* 1487875 */   GIM_Try, /*On fail goto*//*Label 20746*/ GIMT_Encode4(1487972), // Rule ID 60934 //
     /* 1487880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1487883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1487891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1487894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1487900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1487903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1487906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1487910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1487914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1487918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1487922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1487926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1487930 */     // MIs[1] Operand 1
     /* 1487930 */     // No operand predicates
     /* 1487930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1487934 */     // MIs[0] policy
     /* 1487934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1487937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1487939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1487946 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1487946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1487949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1487951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1487953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1487955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1487958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1487960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1487965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1487968 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1487970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1487971 */     // GIR_Coverage, 60934,
     /* 1487971 */     GIR_EraseRootFromParent_Done,
     /* 1487972 */   // Label 20746: @1487972
     /* 1487972 */   GIM_Try, /*On fail goto*//*Label 20747*/ GIMT_Encode4(1488069), // Rule ID 60935 //
     /* 1487977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1487980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1487985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1487988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1487991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1487994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1487997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1488000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488023 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488027 */     // MIs[1] Operand 1
     /* 1488027 */     // No operand predicates
     /* 1488027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488031 */     // MIs[0] policy
     /* 1488031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488043 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1488046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488068 */     // GIR_Coverage, 60935,
     /* 1488068 */     GIR_EraseRootFromParent_Done,
     /* 1488069 */   // Label 20747: @1488069
     /* 1488069 */   GIM_Try, /*On fail goto*//*Label 20748*/ GIMT_Encode4(1488166), // Rule ID 60942 //
     /* 1488074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1488077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1488085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1488088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488124 */     // MIs[1] Operand 1
     /* 1488124 */     // No operand predicates
     /* 1488124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488128 */     // MIs[0] policy
     /* 1488128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1488143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488149 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488162 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488165 */     // GIR_Coverage, 60942,
     /* 1488165 */     GIR_EraseRootFromParent_Done,
     /* 1488166 */   // Label 20748: @1488166
     /* 1488166 */   GIM_Try, /*On fail goto*//*Label 20749*/ GIMT_Encode4(1488263), // Rule ID 60943 //
     /* 1488171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1488174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1488182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1488185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1488188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1488194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1488201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488217 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488221 */     // MIs[1] Operand 1
     /* 1488221 */     // No operand predicates
     /* 1488221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488225 */     // MIs[0] policy
     /* 1488225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488237 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1488240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488262 */     // GIR_Coverage, 60943,
     /* 1488262 */     GIR_EraseRootFromParent_Done,
     /* 1488263 */   // Label 20749: @1488263
     /* 1488263 */   GIM_Try, /*On fail goto*//*Label 20750*/ GIMT_Encode4(1488360), // Rule ID 60950 //
     /* 1488268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1488271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1488279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1488282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488314 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488318 */     // MIs[1] Operand 1
     /* 1488318 */     // No operand predicates
     /* 1488318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488322 */     // MIs[0] policy
     /* 1488322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1488337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488356 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488359 */     // GIR_Coverage, 60950,
     /* 1488359 */     GIR_EraseRootFromParent_Done,
     /* 1488360 */   // Label 20750: @1488360
     /* 1488360 */   GIM_Try, /*On fail goto*//*Label 20751*/ GIMT_Encode4(1488457), // Rule ID 60951 //
     /* 1488365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1488368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1488376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1488379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1488382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1488388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1488395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1488399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1488403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488415 */     // MIs[1] Operand 1
     /* 1488415 */     // No operand predicates
     /* 1488415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488419 */     // MIs[0] policy
     /* 1488419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488431 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1488434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1488453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488456 */     // GIR_Coverage, 60951,
     /* 1488456 */     GIR_EraseRootFromParent_Done,
     /* 1488457 */   // Label 20751: @1488457
     /* 1488457 */   GIM_Try, /*On fail goto*//*Label 20752*/ GIMT_Encode4(1488554), // Rule ID 60958 //
     /* 1488462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1488465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1488479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488512 */     // MIs[1] Operand 1
     /* 1488512 */     // No operand predicates
     /* 1488512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488516 */     // MIs[0] policy
     /* 1488516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488528 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1488531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488550 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488553 */     // GIR_Coverage, 60958,
     /* 1488553 */     GIR_EraseRootFromParent_Done,
     /* 1488554 */   // Label 20752: @1488554
     /* 1488554 */   GIM_Try, /*On fail goto*//*Label 20753*/ GIMT_Encode4(1488651), // Rule ID 60959 //
     /* 1488559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1488562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1488570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1488573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1488576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1488582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488609 */     // MIs[1] Operand 1
     /* 1488609 */     // No operand predicates
     /* 1488609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488613 */     // MIs[0] policy
     /* 1488613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488625 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF4_MASK),
     /* 1488628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488650 */     // GIR_Coverage, 60959,
     /* 1488650 */     GIR_EraseRootFromParent_Done,
     /* 1488651 */   // Label 20753: @1488651
     /* 1488651 */   GIM_Try, /*On fail goto*//*Label 20754*/ GIMT_Encode4(1488748), // Rule ID 60966 //
     /* 1488656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1488659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1488673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488702 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488706 */     // MIs[1] Operand 1
     /* 1488706 */     // No operand predicates
     /* 1488706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488710 */     // MIs[0] policy
     /* 1488710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488722 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1488725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488744 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488747 */     // GIR_Coverage, 60966,
     /* 1488747 */     GIR_EraseRootFromParent_Done,
     /* 1488748 */   // Label 20754: @1488748
     /* 1488748 */   GIM_Try, /*On fail goto*//*Label 20755*/ GIMT_Encode4(1488845), // Rule ID 60967 //
     /* 1488753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1488756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1488764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1488767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1488770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1488776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1488783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488803 */     // MIs[1] Operand 1
     /* 1488803 */     // No operand predicates
     /* 1488803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488807 */     // MIs[0] policy
     /* 1488807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488819 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1488819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1488822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488844 */     // GIR_Coverage, 60967,
     /* 1488844 */     GIR_EraseRootFromParent_Done,
     /* 1488845 */   // Label 20755: @1488845
     /* 1488845 */   GIM_Try, /*On fail goto*//*Label 20756*/ GIMT_Encode4(1488942), // Rule ID 60974 //
     /* 1488850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1488853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1488861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1488864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1488870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1488876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488900 */     // MIs[1] Operand 1
     /* 1488900 */     // No operand predicates
     /* 1488900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1488904 */     // MIs[0] policy
     /* 1488904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1488907 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1488909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1488916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1488916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1488919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1488921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1488923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1488925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1488928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1488930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1488935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1488938 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1488940 */     GIR_RootConstrainSelectedInstOperands,
     /* 1488941 */     // GIR_Coverage, 60974,
     /* 1488941 */     GIR_EraseRootFromParent_Done,
     /* 1488942 */   // Label 20756: @1488942
     /* 1488942 */   GIM_Try, /*On fail goto*//*Label 20757*/ GIMT_Encode4(1489039), // Rule ID 60975 //
     /* 1488947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1488950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1488955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1488958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1488961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1488964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1488967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1488970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1488973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1488977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1488981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1488985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1488989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1488993 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1488997 */     // MIs[1] Operand 1
     /* 1488997 */     // No operand predicates
     /* 1488997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489001 */     // MIs[0] policy
     /* 1489001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489013 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1489016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489038 */     // GIR_Coverage, 60975,
     /* 1489038 */     GIR_EraseRootFromParent_Done,
     /* 1489039 */   // Label 20757: @1489039
     /* 1489039 */   GIM_Try, /*On fail goto*//*Label 20758*/ GIMT_Encode4(1489136), // Rule ID 60982 //
     /* 1489044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1489047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489090 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489094 */     // MIs[1] Operand 1
     /* 1489094 */     // No operand predicates
     /* 1489094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489098 */     // MIs[0] policy
     /* 1489098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489110 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1489113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489134 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489135 */     // GIR_Coverage, 60982,
     /* 1489135 */     GIR_EraseRootFromParent_Done,
     /* 1489136 */   // Label 20758: @1489136
     /* 1489136 */   GIM_Try, /*On fail goto*//*Label 20759*/ GIMT_Encode4(1489233), // Rule ID 60983 //
     /* 1489141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1489144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1489152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1489155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1489158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1489164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489191 */     // MIs[1] Operand 1
     /* 1489191 */     // No operand predicates
     /* 1489191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489195 */     // MIs[0] policy
     /* 1489195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489207 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1489210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489232 */     // GIR_Coverage, 60983,
     /* 1489232 */     GIR_EraseRootFromParent_Done,
     /* 1489233 */   // Label 20759: @1489233
     /* 1489233 */   GIM_Try, /*On fail goto*//*Label 20760*/ GIMT_Encode4(1489330), // Rule ID 60990 //
     /* 1489238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1489241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489284 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489288 */     // MIs[1] Operand 1
     /* 1489288 */     // No operand predicates
     /* 1489288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489292 */     // MIs[0] policy
     /* 1489292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489304 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1489307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489328 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489329 */     // GIR_Coverage, 60990,
     /* 1489329 */     GIR_EraseRootFromParent_Done,
     /* 1489330 */   // Label 20760: @1489330
     /* 1489330 */   GIM_Try, /*On fail goto*//*Label 20761*/ GIMT_Encode4(1489427), // Rule ID 60991 //
     /* 1489335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1489338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1489346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1489349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1489352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1489358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1489365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1489369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489381 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489385 */     // MIs[1] Operand 1
     /* 1489385 */     // No operand predicates
     /* 1489385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489389 */     // MIs[0] policy
     /* 1489389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489401 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1489404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1489423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489426 */     // GIR_Coverage, 60991,
     /* 1489426 */     GIR_EraseRootFromParent_Done,
     /* 1489427 */   // Label 20761: @1489427
     /* 1489427 */   GIM_Try, /*On fail goto*//*Label 20762*/ GIMT_Encode4(1489524), // Rule ID 60998 //
     /* 1489432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1489435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1489449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489482 */     // MIs[1] Operand 1
     /* 1489482 */     // No operand predicates
     /* 1489482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489486 */     // MIs[0] policy
     /* 1489486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1489501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489522 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489523 */     // GIR_Coverage, 60998,
     /* 1489523 */     GIR_EraseRootFromParent_Done,
     /* 1489524 */   // Label 20762: @1489524
     /* 1489524 */   GIM_Try, /*On fail goto*//*Label 20763*/ GIMT_Encode4(1489621), // Rule ID 60999 //
     /* 1489529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1489532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1489540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1489543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1489546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1489552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1489559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489575 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489579 */     // MIs[1] Operand 1
     /* 1489579 */     // No operand predicates
     /* 1489579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489583 */     // MIs[0] policy
     /* 1489583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489595 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_MF2_MASK),
     /* 1489598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489604 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489620 */     // GIR_Coverage, 60999,
     /* 1489620 */     GIR_EraseRootFromParent_Done,
     /* 1489621 */   // Label 20763: @1489621
     /* 1489621 */   GIM_Try, /*On fail goto*//*Label 20764*/ GIMT_Encode4(1489718), // Rule ID 61006 //
     /* 1489626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1489629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1489637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1489640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1489643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489676 */     // MIs[1] Operand 1
     /* 1489676 */     // No operand predicates
     /* 1489676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489680 */     // MIs[0] policy
     /* 1489680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489683 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489692 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1489695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489701 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489716 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489717 */     // GIR_Coverage, 61006,
     /* 1489717 */     GIR_EraseRootFromParent_Done,
     /* 1489718 */   // Label 20764: @1489718
     /* 1489718 */   GIM_Try, /*On fail goto*//*Label 20765*/ GIMT_Encode4(1489815), // Rule ID 61007 //
     /* 1489723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1489726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1489734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1489737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1489740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1489746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1489753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1489761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489773 */     // MIs[1] Operand 1
     /* 1489773 */     // No operand predicates
     /* 1489773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489777 */     // MIs[0] policy
     /* 1489777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M1_MASK),
     /* 1489792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489814 */     // GIR_Coverage, 61007,
     /* 1489814 */     GIR_EraseRootFromParent_Done,
     /* 1489815 */   // Label 20765: @1489815
     /* 1489815 */   GIM_Try, /*On fail goto*//*Label 20766*/ GIMT_Encode4(1489912), // Rule ID 61014 //
     /* 1489820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1489823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1489831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1489834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1489840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1489846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489870 */     // MIs[1] Operand 1
     /* 1489870 */     // No operand predicates
     /* 1489870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489874 */     // MIs[0] policy
     /* 1489874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489886 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1489886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1489889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1489905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1489908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1489910 */     GIR_RootConstrainSelectedInstOperands,
     /* 1489911 */     // GIR_Coverage, 61014,
     /* 1489911 */     GIR_EraseRootFromParent_Done,
     /* 1489912 */   // Label 20766: @1489912
     /* 1489912 */   GIM_Try, /*On fail goto*//*Label 20767*/ GIMT_Encode4(1490009), // Rule ID 61015 //
     /* 1489917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1489920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1489925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1489928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1489931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1489934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1489937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1489940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1489943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1489947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1489951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1489955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1489959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1489963 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1489967 */     // MIs[1] Operand 1
     /* 1489967 */     // No operand predicates
     /* 1489967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1489971 */     // MIs[0] policy
     /* 1489971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1489974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1489976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1489983 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1489983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M2_MASK),
     /* 1489986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1489988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1489990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1489992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1489995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1489997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490008 */     // GIR_Coverage, 61015,
     /* 1490008 */     GIR_EraseRootFromParent_Done,
     /* 1490009 */   // Label 20767: @1490009
     /* 1490009 */   GIM_Try, /*On fail goto*//*Label 20768*/ GIMT_Encode4(1490106), // Rule ID 61022 //
     /* 1490014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1490017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1490022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490064 */     // MIs[1] Operand 1
     /* 1490064 */     // No operand predicates
     /* 1490064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490068 */     // MIs[0] policy
     /* 1490068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490080 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1490083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490104 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490105 */     // GIR_Coverage, 61022,
     /* 1490105 */     GIR_EraseRootFromParent_Done,
     /* 1490106 */   // Label 20768: @1490106
     /* 1490106 */   GIM_Try, /*On fail goto*//*Label 20769*/ GIMT_Encode4(1490203), // Rule ID 61023 //
     /* 1490111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1490114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1490119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1490122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1490125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1490128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1490134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1490141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1490145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1490149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 1490161 */     // MIs[1] Operand 1
     /* 1490161 */     // No operand predicates
     /* 1490161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490165 */     // MIs[0] policy
     /* 1490165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490177 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VI_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VI_M4_MASK),
     /* 1490180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1490199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490202 */     // GIR_Coverage, 61023,
     /* 1490202 */     GIR_EraseRootFromParent_Done,
     /* 1490203 */   // Label 20769: @1490203
     /* 1490203 */   GIM_Try, /*On fail goto*//*Label 20770*/ GIMT_Encode4(1490300), // Rule ID 61878 //
     /* 1490208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1490211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1490219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1490222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1490225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490254 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490258 */     // MIs[1] Operand 1
     /* 1490258 */     // No operand predicates
     /* 1490258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490262 */     // MIs[0] policy
     /* 1490262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1490277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490298 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490299 */     // GIR_Coverage, 61878,
     /* 1490299 */     GIR_EraseRootFromParent_Done,
     /* 1490300 */   // Label 20770: @1490300
     /* 1490300 */   GIM_Try, /*On fail goto*//*Label 20771*/ GIMT_Encode4(1490397), // Rule ID 61879 //
     /* 1490305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1490308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1490316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1490319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1490322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490355 */     // MIs[1] Operand 1
     /* 1490355 */     // No operand predicates
     /* 1490355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490359 */     // MIs[0] policy
     /* 1490359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490362 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490371 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF8_MASK),
     /* 1490374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490396 */     // GIR_Coverage, 61879,
     /* 1490396 */     GIR_EraseRootFromParent_Done,
     /* 1490397 */   // Label 20771: @1490397
     /* 1490397 */   GIM_Try, /*On fail goto*//*Label 20772*/ GIMT_Encode4(1490494), // Rule ID 61882 //
     /* 1490402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1490405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1490413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1490416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1490419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490448 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490452 */     // MIs[1] Operand 1
     /* 1490452 */     // No operand predicates
     /* 1490452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490456 */     // MIs[0] policy
     /* 1490456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1490471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490490 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490492 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490493 */     // GIR_Coverage, 61882,
     /* 1490493 */     GIR_EraseRootFromParent_Done,
     /* 1490494 */   // Label 20772: @1490494
     /* 1490494 */   GIM_Try, /*On fail goto*//*Label 20773*/ GIMT_Encode4(1490591), // Rule ID 61883 //
     /* 1490499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1490502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1490510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1490513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1490516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1490522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490545 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490549 */     // MIs[1] Operand 1
     /* 1490549 */     // No operand predicates
     /* 1490549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490553 */     // MIs[0] policy
     /* 1490553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490565 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1490568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490590 */     // GIR_Coverage, 61883,
     /* 1490590 */     GIR_EraseRootFromParent_Done,
     /* 1490591 */   // Label 20773: @1490591
     /* 1490591 */   GIM_Try, /*On fail goto*//*Label 20774*/ GIMT_Encode4(1490688), // Rule ID 61886 //
     /* 1490596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1490599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1490607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1490610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1490613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490642 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490646 */     // MIs[1] Operand 1
     /* 1490646 */     // No operand predicates
     /* 1490646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490650 */     // MIs[0] policy
     /* 1490650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490662 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1490665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490684 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490686 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490687 */     // GIR_Coverage, 61886,
     /* 1490687 */     GIR_EraseRootFromParent_Done,
     /* 1490688 */   // Label 20774: @1490688
     /* 1490688 */   GIM_Try, /*On fail goto*//*Label 20775*/ GIMT_Encode4(1490785), // Rule ID 61887 //
     /* 1490693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1490696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1490704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1490707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1490710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1490716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490739 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490743 */     // MIs[1] Operand 1
     /* 1490743 */     // No operand predicates
     /* 1490743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490747 */     // MIs[0] policy
     /* 1490747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490759 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1490762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1490781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490784 */     // GIR_Coverage, 61887,
     /* 1490784 */     GIR_EraseRootFromParent_Done,
     /* 1490785 */   // Label 20775: @1490785
     /* 1490785 */   GIM_Try, /*On fail goto*//*Label 20776*/ GIMT_Encode4(1490882), // Rule ID 61890 //
     /* 1490790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1490793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1490804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1490807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1490810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1490816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490840 */     // MIs[1] Operand 1
     /* 1490840 */     // No operand predicates
     /* 1490840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490844 */     // MIs[0] policy
     /* 1490844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1490856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1490859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490878 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490880 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490881 */     // GIR_Coverage, 61890,
     /* 1490881 */     GIR_EraseRootFromParent_Done,
     /* 1490882 */   // Label 20776: @1490882
     /* 1490882 */   GIM_Try, /*On fail goto*//*Label 20777*/ GIMT_Encode4(1490979), // Rule ID 61891 //
     /* 1490887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1490890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1490898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1490901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1490904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1490907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1490910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1490913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1490917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1490925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1490929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1490933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1490937 */     // MIs[1] Operand 1
     /* 1490937 */     // No operand predicates
     /* 1490937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1490941 */     // MIs[0] policy
     /* 1490941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1490944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1490946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1490953 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1490953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF4_MASK),
     /* 1490956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1490958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1490960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1490962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1490965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1490967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1490972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1490975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1490977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1490978 */     // GIR_Coverage, 61891,
     /* 1490978 */     GIR_EraseRootFromParent_Done,
     /* 1490979 */   // Label 20777: @1490979
     /* 1490979 */   GIM_Try, /*On fail goto*//*Label 20778*/ GIMT_Encode4(1491076), // Rule ID 61894 //
     /* 1490984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1490987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1490992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1490995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1490998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491030 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491034 */     // MIs[1] Operand 1
     /* 1491034 */     // No operand predicates
     /* 1491034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491038 */     // MIs[0] policy
     /* 1491038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491050 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1491053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491072 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491074 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491075 */     // GIR_Coverage, 61894,
     /* 1491075 */     GIR_EraseRootFromParent_Done,
     /* 1491076 */   // Label 20778: @1491076
     /* 1491076 */   GIM_Try, /*On fail goto*//*Label 20779*/ GIMT_Encode4(1491173), // Rule ID 61895 //
     /* 1491081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1491084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1491092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1491095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1491098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491131 */     // MIs[1] Operand 1
     /* 1491131 */     // No operand predicates
     /* 1491131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491135 */     // MIs[0] policy
     /* 1491135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491147 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1491150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491172 */     // GIR_Coverage, 61895,
     /* 1491172 */     GIR_EraseRootFromParent_Done,
     /* 1491173 */   // Label 20779: @1491173
     /* 1491173 */   GIM_Try, /*On fail goto*//*Label 20780*/ GIMT_Encode4(1491270), // Rule ID 61898 //
     /* 1491178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1491181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491228 */     // MIs[1] Operand 1
     /* 1491228 */     // No operand predicates
     /* 1491228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491232 */     // MIs[0] policy
     /* 1491232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491244 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1491247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491266 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491269 */     // GIR_Coverage, 61898,
     /* 1491269 */     GIR_EraseRootFromParent_Done,
     /* 1491270 */   // Label 20780: @1491270
     /* 1491270 */   GIM_Try, /*On fail goto*//*Label 20781*/ GIMT_Encode4(1491367), // Rule ID 61899 //
     /* 1491275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1491278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1491286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1491289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1491292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491325 */     // MIs[1] Operand 1
     /* 1491325 */     // No operand predicates
     /* 1491325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491329 */     // MIs[0] policy
     /* 1491329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491341 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_MF2_MASK),
     /* 1491344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491366 */     // GIR_Coverage, 61899,
     /* 1491366 */     GIR_EraseRootFromParent_Done,
     /* 1491367 */   // Label 20781: @1491367
     /* 1491367 */   GIM_Try, /*On fail goto*//*Label 20782*/ GIMT_Encode4(1491464), // Rule ID 61902 //
     /* 1491372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1491375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1491383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1491386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1491389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491418 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491422 */     // MIs[1] Operand 1
     /* 1491422 */     // No operand predicates
     /* 1491422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491426 */     // MIs[0] policy
     /* 1491426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491438 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491460 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491463 */     // GIR_Coverage, 61902,
     /* 1491463 */     GIR_EraseRootFromParent_Done,
     /* 1491464 */   // Label 20782: @1491464
     /* 1491464 */   GIM_Try, /*On fail goto*//*Label 20783*/ GIMT_Encode4(1491561), // Rule ID 61903 //
     /* 1491469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1491472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1491480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1491483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1491486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1491492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491519 */     // MIs[1] Operand 1
     /* 1491519 */     // No operand predicates
     /* 1491519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491523 */     // MIs[0] policy
     /* 1491523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491535 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491540 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1491557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491560 */     // GIR_Coverage, 61903,
     /* 1491560 */     GIR_EraseRootFromParent_Done,
     /* 1491561 */   // Label 20783: @1491561
     /* 1491561 */   GIM_Try, /*On fail goto*//*Label 20784*/ GIMT_Encode4(1491658), // Rule ID 61906 //
     /* 1491566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1491569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491612 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491616 */     // MIs[1] Operand 1
     /* 1491616 */     // No operand predicates
     /* 1491616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491620 */     // MIs[0] policy
     /* 1491620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491632 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491641 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491654 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491657 */     // GIR_Coverage, 61906,
     /* 1491657 */     GIR_EraseRootFromParent_Done,
     /* 1491658 */   // Label 20784: @1491658
     /* 1491658 */   GIM_Try, /*On fail goto*//*Label 20785*/ GIMT_Encode4(1491755), // Rule ID 61907 //
     /* 1491663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1491666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1491674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1491677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1491680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1491686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491709 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491713 */     // MIs[1] Operand 1
     /* 1491713 */     // No operand predicates
     /* 1491713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491717 */     // MIs[0] policy
     /* 1491717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491729 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491738 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1491751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491754 */     // GIR_Coverage, 61907,
     /* 1491754 */     GIR_EraseRootFromParent_Done,
     /* 1491755 */   // Label 20785: @1491755
     /* 1491755 */   GIM_Try, /*On fail goto*//*Label 20786*/ GIMT_Encode4(1491852), // Rule ID 61910 //
     /* 1491760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1491763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491810 */     // MIs[1] Operand 1
     /* 1491810 */     // No operand predicates
     /* 1491810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491814 */     // MIs[0] policy
     /* 1491814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1491826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491848 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491851 */     // GIR_Coverage, 61910,
     /* 1491851 */     GIR_EraseRootFromParent_Done,
     /* 1491852 */   // Label 20786: @1491852
     /* 1491852 */   GIM_Try, /*On fail goto*//*Label 20787*/ GIMT_Encode4(1491949), // Rule ID 61911 //
     /* 1491857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1491860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1491868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1491871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1491874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1491877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1491880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1491883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1491903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1491907 */     // MIs[1] Operand 1
     /* 1491907 */     // No operand predicates
     /* 1491907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1491911 */     // MIs[0] policy
     /* 1491911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1491914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1491916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1491923 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1491923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1491926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1491928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1491930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1491932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1491935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1491937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1491942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1491945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1491947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1491948 */     // GIR_Coverage, 61911,
     /* 1491948 */     GIR_EraseRootFromParent_Done,
     /* 1491949 */   // Label 20787: @1491949
     /* 1491949 */   GIM_Try, /*On fail goto*//*Label 20788*/ GIMT_Encode4(1492046), // Rule ID 61914 //
     /* 1491954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1491957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1491962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1491965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1491968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1491971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1491974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1491977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1491980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1491984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1491992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1491996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492000 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492004 */     // MIs[1] Operand 1
     /* 1492004 */     // No operand predicates
     /* 1492004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492008 */     // MIs[0] policy
     /* 1492008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1492023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492042 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492045 */     // GIR_Coverage, 61914,
     /* 1492045 */     GIR_EraseRootFromParent_Done,
     /* 1492046 */   // Label 20788: @1492046
     /* 1492046 */   GIM_Try, /*On fail goto*//*Label 20789*/ GIMT_Encode4(1492143), // Rule ID 61915 //
     /* 1492051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1492054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1492062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1492065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1492068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1492074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1492081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1492089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492097 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492101 */     // MIs[1] Operand 1
     /* 1492101 */     // No operand predicates
     /* 1492101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492105 */     // MIs[0] policy
     /* 1492105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492117 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M1_MASK),
     /* 1492120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1492139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492142 */     // GIR_Coverage, 61915,
     /* 1492142 */     GIR_EraseRootFromParent_Done,
     /* 1492143 */   // Label 20789: @1492143
     /* 1492143 */   GIM_Try, /*On fail goto*//*Label 20790*/ GIMT_Encode4(1492240), // Rule ID 61918 //
     /* 1492148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1492151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1492159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1492162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492198 */     // MIs[1] Operand 1
     /* 1492198 */     // No operand predicates
     /* 1492198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492202 */     // MIs[0] policy
     /* 1492202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492214 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1492217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492236 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492239 */     // GIR_Coverage, 61918,
     /* 1492239 */     GIR_EraseRootFromParent_Done,
     /* 1492240 */   // Label 20790: @1492240
     /* 1492240 */   GIM_Try, /*On fail goto*//*Label 20791*/ GIMT_Encode4(1492337), // Rule ID 61919 //
     /* 1492245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1492248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1492256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1492259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1492262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492295 */     // MIs[1] Operand 1
     /* 1492295 */     // No operand predicates
     /* 1492295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492299 */     // MIs[0] policy
     /* 1492299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492311 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1492314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492336 */     // GIR_Coverage, 61919,
     /* 1492336 */     GIR_EraseRootFromParent_Done,
     /* 1492337 */   // Label 20791: @1492337
     /* 1492337 */   GIM_Try, /*On fail goto*//*Label 20792*/ GIMT_Encode4(1492434), // Rule ID 61922 //
     /* 1492342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1492345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1492353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1492356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492388 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492392 */     // MIs[1] Operand 1
     /* 1492392 */     // No operand predicates
     /* 1492392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492396 */     // MIs[0] policy
     /* 1492396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1492411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492430 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492432 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492433 */     // GIR_Coverage, 61922,
     /* 1492433 */     GIR_EraseRootFromParent_Done,
     /* 1492434 */   // Label 20792: @1492434
     /* 1492434 */   GIM_Try, /*On fail goto*//*Label 20793*/ GIMT_Encode4(1492531), // Rule ID 61923 //
     /* 1492439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1492442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1492450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1492453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1492456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1492462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492489 */     // MIs[1] Operand 1
     /* 1492489 */     // No operand predicates
     /* 1492489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492493 */     // MIs[0] policy
     /* 1492493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492505 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1492508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492530 */     // GIR_Coverage, 61923,
     /* 1492530 */     GIR_EraseRootFromParent_Done,
     /* 1492531 */   // Label 20793: @1492531
     /* 1492531 */   GIM_Try, /*On fail goto*//*Label 20794*/ GIMT_Encode4(1492628), // Rule ID 61926 //
     /* 1492536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1492539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1492547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1492550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1492553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1492559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492586 */     // MIs[1] Operand 1
     /* 1492586 */     // No operand predicates
     /* 1492586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492590 */     // MIs[0] policy
     /* 1492590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492602 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1492605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492624 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492626 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492627 */     // GIR_Coverage, 61926,
     /* 1492627 */     GIR_EraseRootFromParent_Done,
     /* 1492628 */   // Label 20794: @1492628
     /* 1492628 */   GIM_Try, /*On fail goto*//*Label 20795*/ GIMT_Encode4(1492725), // Rule ID 61927 //
     /* 1492633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1492636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1492644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1492647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1492650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1492656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1492663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1492671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492683 */     // MIs[1] Operand 1
     /* 1492683 */     // No operand predicates
     /* 1492683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492687 */     // MIs[0] policy
     /* 1492687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492699 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1492702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1492721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492724 */     // GIR_Coverage, 61927,
     /* 1492724 */     GIR_EraseRootFromParent_Done,
     /* 1492725 */   // Label 20795: @1492725
     /* 1492725 */   GIM_Try, /*On fail goto*//*Label 20796*/ GIMT_Encode4(1492822), // Rule ID 61930 //
     /* 1492730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1492733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492780 */     // MIs[1] Operand 1
     /* 1492780 */     // No operand predicates
     /* 1492780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492784 */     // MIs[0] policy
     /* 1492784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1492799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492820 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492821 */     // GIR_Coverage, 61930,
     /* 1492821 */     GIR_EraseRootFromParent_Done,
     /* 1492822 */   // Label 20796: @1492822
     /* 1492822 */   GIM_Try, /*On fail goto*//*Label 20797*/ GIMT_Encode4(1492919), // Rule ID 61931 //
     /* 1492827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1492830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1492838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1492841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1492844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1492847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1492850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1492853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1492857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1492865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492873 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492877 */     // MIs[1] Operand 1
     /* 1492877 */     // No operand predicates
     /* 1492877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492881 */     // MIs[0] policy
     /* 1492881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1492893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1492896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492902 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1492905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1492907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1492912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1492915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1492917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1492918 */     // GIR_Coverage, 61931,
     /* 1492918 */     GIR_EraseRootFromParent_Done,
     /* 1492919 */   // Label 20797: @1492919
     /* 1492919 */   GIM_Try, /*On fail goto*//*Label 20798*/ GIMT_Encode4(1493016), // Rule ID 61934 //
     /* 1492924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1492927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1492932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1492935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1492938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1492941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1492944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1492947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1492950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1492954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1492962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1492966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1492970 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1492974 */     // MIs[1] Operand 1
     /* 1492974 */     // No operand predicates
     /* 1492974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1492978 */     // MIs[0] policy
     /* 1492978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1492981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1492983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1492990 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1492990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1492993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1492995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1492997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1492999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493014 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493015 */     // GIR_Coverage, 61934,
     /* 1493015 */     GIR_EraseRootFromParent_Done,
     /* 1493016 */   // Label 20798: @1493016
     /* 1493016 */   GIM_Try, /*On fail goto*//*Label 20799*/ GIMT_Encode4(1493113), // Rule ID 61935 //
     /* 1493021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1493032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1493035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1493038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493071 */     // MIs[1] Operand 1
     /* 1493071 */     // No operand predicates
     /* 1493071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493075 */     // MIs[0] policy
     /* 1493075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493087 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1493090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493096 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493112 */     // GIR_Coverage, 61935,
     /* 1493112 */     GIR_EraseRootFromParent_Done,
     /* 1493113 */   // Label 20799: @1493113
     /* 1493113 */   GIM_Try, /*On fail goto*//*Label 20800*/ GIMT_Encode4(1493210), // Rule ID 61938 //
     /* 1493118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1493121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493164 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493168 */     // MIs[1] Operand 1
     /* 1493168 */     // No operand predicates
     /* 1493168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493172 */     // MIs[0] policy
     /* 1493172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493184 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1493187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493208 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493209 */     // GIR_Coverage, 61938,
     /* 1493209 */     GIR_EraseRootFromParent_Done,
     /* 1493210 */   // Label 20800: @1493210
     /* 1493210 */   GIM_Try, /*On fail goto*//*Label 20801*/ GIMT_Encode4(1493307), // Rule ID 61939 //
     /* 1493215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1493226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1493229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1493232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1493238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493265 */     // MIs[1] Operand 1
     /* 1493265 */     // No operand predicates
     /* 1493265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493269 */     // MIs[0] policy
     /* 1493269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493272 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493281 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1493284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1493303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493306 */     // GIR_Coverage, 61939,
     /* 1493306 */     GIR_EraseRootFromParent_Done,
     /* 1493307 */   // Label 20801: @1493307
     /* 1493307 */   GIM_Try, /*On fail goto*//*Label 20802*/ GIMT_Encode4(1493404), // Rule ID 61942 //
     /* 1493312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1493315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493362 */     // MIs[1] Operand 1
     /* 1493362 */     // No operand predicates
     /* 1493362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493366 */     // MIs[0] policy
     /* 1493366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1493381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493402 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493403 */     // GIR_Coverage, 61942,
     /* 1493403 */     GIR_EraseRootFromParent_Done,
     /* 1493404 */   // Label 20802: @1493404
     /* 1493404 */   GIM_Try, /*On fail goto*//*Label 20803*/ GIMT_Encode4(1493501), // Rule ID 61943 //
     /* 1493409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1493420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1493423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1493426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1493432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493459 */     // MIs[1] Operand 1
     /* 1493459 */     // No operand predicates
     /* 1493459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493463 */     // MIs[0] policy
     /* 1493463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1493478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493500 */     // GIR_Coverage, 61943,
     /* 1493500 */     GIR_EraseRootFromParent_Done,
     /* 1493501 */   // Label 20803: @1493501
     /* 1493501 */   GIM_Try, /*On fail goto*//*Label 20804*/ GIMT_Encode4(1493598), // Rule ID 61946 //
     /* 1493506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1493509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493556 */     // MIs[1] Operand 1
     /* 1493556 */     // No operand predicates
     /* 1493556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493560 */     // MIs[0] policy
     /* 1493560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1493575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493596 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493597 */     // GIR_Coverage, 61946,
     /* 1493597 */     GIR_EraseRootFromParent_Done,
     /* 1493598 */   // Label 20804: @1493598
     /* 1493598 */   GIM_Try, /*On fail goto*//*Label 20805*/ GIMT_Encode4(1493695), // Rule ID 61947 //
     /* 1493603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1493614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1493617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1493620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1493626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1493633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1493641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493649 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493653 */     // MIs[1] Operand 1
     /* 1493653 */     // No operand predicates
     /* 1493653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493657 */     // MIs[0] policy
     /* 1493657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493669 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1493672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493694 */     // GIR_Coverage, 61947,
     /* 1493694 */     GIR_EraseRootFromParent_Done,
     /* 1493695 */   // Label 20805: @1493695
     /* 1493695 */   GIM_Try, /*On fail goto*//*Label 20806*/ GIMT_Encode4(1493792), // Rule ID 61950 //
     /* 1493700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1493703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493750 */     // MIs[1] Operand 1
     /* 1493750 */     // No operand predicates
     /* 1493750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493754 */     // MIs[0] policy
     /* 1493754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493766 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1493769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493790 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493791 */     // GIR_Coverage, 61950,
     /* 1493791 */     GIR_EraseRootFromParent_Done,
     /* 1493792 */   // Label 20806: @1493792
     /* 1493792 */   GIM_Try, /*On fail goto*//*Label 20807*/ GIMT_Encode4(1493889), // Rule ID 61951 //
     /* 1493797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1493808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1493811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1493814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1493817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1493820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1493823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1493827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1493835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493847 */     // MIs[1] Operand 1
     /* 1493847 */     // No operand predicates
     /* 1493847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493851 */     // MIs[0] policy
     /* 1493851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493863 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1493863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1493866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1493885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493888 */     // GIR_Coverage, 61951,
     /* 1493888 */     GIR_EraseRootFromParent_Done,
     /* 1493889 */   // Label 20807: @1493889
     /* 1493889 */   GIM_Try, /*On fail goto*//*Label 20808*/ GIMT_Encode4(1493986), // Rule ID 61954 //
     /* 1493894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1493897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1493905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1493908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1493911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1493914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1493917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1493920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1493924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1493932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1493936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1493940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1493944 */     // MIs[1] Operand 1
     /* 1493944 */     // No operand predicates
     /* 1493944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1493948 */     // MIs[0] policy
     /* 1493948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1493951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1493953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1493960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1493960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1493963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1493965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1493967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1493969 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1493972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1493974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1493979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1493982 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1493984 */     GIR_RootConstrainSelectedInstOperands,
     /* 1493985 */     // GIR_Coverage, 61954,
     /* 1493985 */     GIR_EraseRootFromParent_Done,
     /* 1493986 */   // Label 20808: @1493986
     /* 1493986 */   GIM_Try, /*On fail goto*//*Label 20809*/ GIMT_Encode4(1494083), // Rule ID 61955 //
     /* 1493991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1493994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1493999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1494002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1494005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1494008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1494014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1494021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1494029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494037 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494041 */     // MIs[1] Operand 1
     /* 1494041 */     // No operand predicates
     /* 1494041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494045 */     // MIs[0] policy
     /* 1494045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494057 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M2_MASK),
     /* 1494060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494082 */     // GIR_Coverage, 61955,
     /* 1494082 */     GIR_EraseRootFromParent_Done,
     /* 1494083 */   // Label 20809: @1494083
     /* 1494083 */   GIM_Try, /*On fail goto*//*Label 20810*/ GIMT_Encode4(1494180), // Rule ID 61958 //
     /* 1494088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1494091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494138 */     // MIs[1] Operand 1
     /* 1494138 */     // No operand predicates
     /* 1494138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494142 */     // MIs[0] policy
     /* 1494142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494154 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1494157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494176 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494178 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494179 */     // GIR_Coverage, 61958,
     /* 1494179 */     GIR_EraseRootFromParent_Done,
     /* 1494180 */   // Label 20810: @1494180
     /* 1494180 */   GIM_Try, /*On fail goto*//*Label 20811*/ GIMT_Encode4(1494277), // Rule ID 61959 //
     /* 1494185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1494188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1494196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1494199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1494202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1494208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1494215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1494223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494235 */     // MIs[1] Operand 1
     /* 1494235 */     // No operand predicates
     /* 1494235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494239 */     // MIs[0] policy
     /* 1494239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494251 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M4_MASK),
     /* 1494254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494260 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494276 */     // GIR_Coverage, 61959,
     /* 1494276 */     GIR_EraseRootFromParent_Done,
     /* 1494277 */   // Label 20811: @1494277
     /* 1494277 */   GIM_Try, /*On fail goto*//*Label 20812*/ GIMT_Encode4(1494374), // Rule ID 61962 //
     /* 1494282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1494285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1494302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494328 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494332 */     // MIs[1] Operand 1
     /* 1494332 */     // No operand predicates
     /* 1494332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494336 */     // MIs[0] policy
     /* 1494336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494348 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1494351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494370 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494372 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494373 */     // GIR_Coverage, 61962,
     /* 1494373 */     GIR_EraseRootFromParent_Done,
     /* 1494374 */   // Label 20812: @1494374
     /* 1494374 */   GIM_Try, /*On fail goto*//*Label 20813*/ GIMT_Encode4(1494471), // Rule ID 61963 //
     /* 1494379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1494382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1494387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1494390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1494393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1494396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1494399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1494402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1494409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1494417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 1494421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1494425 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm6),
     /* 1494429 */     // MIs[1] Operand 1
     /* 1494429 */     // No operand predicates
     /* 1494429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494433 */     // MIs[0] policy
     /* 1494433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 1494438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494445 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm6>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VI_M8_MASK),
     /* 1494448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494450 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 1494457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1494459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1494467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494470 */     // GIR_Coverage, 61963,
     /* 1494470 */     GIR_EraseRootFromParent_Done,
     /* 1494471 */   // Label 20813: @1494471
     /* 1494471 */   GIM_Try, /*On fail goto*//*Label 20814*/ GIMT_Encode4(1494553), // Rule ID 2598 //
     /* 1494476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1494479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1494484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1494496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494515 */     // MIs[0] round
     /* 1494515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494518 */     // MIs[0] policy
     /* 1494518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494528 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1494531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1494537 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1494539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494552 */     // GIR_Coverage, 2598,
     /* 1494552 */     GIR_EraseRootFromParent_Done,
     /* 1494553 */   // Label 20814: @1494553
     /* 1494553 */   GIM_Try, /*On fail goto*//*Label 20815*/ GIMT_Encode4(1494635), // Rule ID 2599 //
     /* 1494558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1494561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1494566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1494578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494597 */     // MIs[0] round
     /* 1494597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494600 */     // MIs[0] policy
     /* 1494600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494610 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16_MASK),
     /* 1494613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1494619 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1494621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494634 */     // GIR_Coverage, 2599,
     /* 1494634 */     GIR_EraseRootFromParent_Done,
     /* 1494635 */   // Label 20815: @1494635
     /* 1494635 */   GIM_Try, /*On fail goto*//*Label 20816*/ GIMT_Encode4(1494717), // Rule ID 2634 //
     /* 1494640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1494643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1494648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1494660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494679 */     // MIs[0] round
     /* 1494679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494682 */     // MIs[0] policy
     /* 1494682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1494695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1494701 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1494703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494716 */     // GIR_Coverage, 2634,
     /* 1494716 */     GIR_EraseRootFromParent_Done,
     /* 1494717 */   // Label 20816: @1494717
     /* 1494717 */   GIM_Try, /*On fail goto*//*Label 20817*/ GIMT_Encode4(1494799), // Rule ID 2635 //
     /* 1494722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1494725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1494730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1494742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1494749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1494761 */     // MIs[0] round
     /* 1494761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494764 */     // MIs[0] policy
     /* 1494764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494774 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF4_MASK),
     /* 1494777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1494781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1494783 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1494785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494798 */     // GIR_Coverage, 2635,
     /* 1494798 */     GIR_EraseRootFromParent_Done,
     /* 1494799 */   // Label 20817: @1494799
     /* 1494799 */   GIM_Try, /*On fail goto*//*Label 20818*/ GIMT_Encode4(1494881), // Rule ID 2666 //
     /* 1494804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1494807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1494812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1494824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494843 */     // MIs[0] round
     /* 1494843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494846 */     // MIs[0] policy
     /* 1494846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494856 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1494856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1494859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1494863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494880 */     // GIR_Coverage, 2666,
     /* 1494880 */     GIR_EraseRootFromParent_Done,
     /* 1494881 */   // Label 20818: @1494881
     /* 1494881 */   GIM_Try, /*On fail goto*//*Label 20819*/ GIMT_Encode4(1494963), // Rule ID 2667 //
     /* 1494886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1494889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1494894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1494897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1494900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1494903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1494906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1494909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494925 */     // MIs[0] round
     /* 1494925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1494928 */     // MIs[0] policy
     /* 1494928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1494931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1494938 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1494938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16),
     /* 1494941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1494943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1494945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1494947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1494949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1494951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1494956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1494959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1494961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1494962 */     // GIR_Coverage, 2667,
     /* 1494962 */     GIR_EraseRootFromParent_Done,
     /* 1494963 */   // Label 20819: @1494963
     /* 1494963 */   GIM_Try, /*On fail goto*//*Label 20820*/ GIMT_Encode4(1495045), // Rule ID 17638 //
     /* 1494968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1494971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1494976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1494979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1494982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1494985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1494988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1494991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1494999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495007 */     // MIs[0] round
     /* 1495007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495010 */     // MIs[0] policy
     /* 1495010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495020 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1495023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495044 */     // GIR_Coverage, 17638,
     /* 1495044 */     GIR_EraseRootFromParent_Done,
     /* 1495045 */   // Label 20820: @1495045
     /* 1495045 */   GIM_Try, /*On fail goto*//*Label 20821*/ GIMT_Encode4(1495127), // Rule ID 17639 //
     /* 1495050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1495053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1495061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1495064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1495067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1495070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495089 */     // MIs[0] round
     /* 1495089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495092 */     // MIs[0] policy
     /* 1495092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495102 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16),
     /* 1495105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495126 */     // GIR_Coverage, 17639,
     /* 1495126 */     GIR_EraseRootFromParent_Done,
     /* 1495127 */   // Label 20821: @1495127
     /* 1495127 */   GIM_Try, /*On fail goto*//*Label 20822*/ GIMT_Encode4(1495209), // Rule ID 17642 //
     /* 1495132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1495149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1495152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495171 */     // MIs[0] round
     /* 1495171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495174 */     // MIs[0] policy
     /* 1495174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495184 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1495187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495208 */     // GIR_Coverage, 17642,
     /* 1495208 */     GIR_EraseRootFromParent_Done,
     /* 1495209 */   // Label 20822: @1495209
     /* 1495209 */   GIM_Try, /*On fail goto*//*Label 20823*/ GIMT_Encode4(1495291), // Rule ID 17643 //
     /* 1495214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1495225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1495228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1495231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1495234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495253 */     // MIs[0] round
     /* 1495253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495256 */     // MIs[0] policy
     /* 1495256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495266 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32),
     /* 1495269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495290 */     // GIR_Coverage, 17643,
     /* 1495290 */     GIR_EraseRootFromParent_Done,
     /* 1495291 */   // Label 20823: @1495291
     /* 1495291 */   GIM_Try, /*On fail goto*//*Label 20824*/ GIMT_Encode4(1495373), // Rule ID 17646 //
     /* 1495296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1495299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1495307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1495310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1495316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495335 */     // MIs[0] round
     /* 1495335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495338 */     // MIs[0] policy
     /* 1495338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495348 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1495351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495372 */     // GIR_Coverage, 17646,
     /* 1495372 */     GIR_EraseRootFromParent_Done,
     /* 1495373 */   // Label 20824: @1495373
     /* 1495373 */   GIM_Try, /*On fail goto*//*Label 20825*/ GIMT_Encode4(1495455), // Rule ID 17647 //
     /* 1495378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1495381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1495389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1495392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1495395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1495398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495417 */     // MIs[0] round
     /* 1495417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495420 */     // MIs[0] policy
     /* 1495420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16),
     /* 1495433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495454 */     // GIR_Coverage, 17647,
     /* 1495454 */     GIR_EraseRootFromParent_Done,
     /* 1495455 */   // Label 20825: @1495455
     /* 1495455 */   GIM_Try, /*On fail goto*//*Label 20826*/ GIMT_Encode4(1495537), // Rule ID 17650 //
     /* 1495460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1495463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1495477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1495480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495499 */     // MIs[0] round
     /* 1495499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495502 */     // MIs[0] policy
     /* 1495502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495512 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1495515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495536 */     // GIR_Coverage, 17650,
     /* 1495536 */     GIR_EraseRootFromParent_Done,
     /* 1495537 */   // Label 20826: @1495537
     /* 1495537 */   GIM_Try, /*On fail goto*//*Label 20827*/ GIMT_Encode4(1495619), // Rule ID 17651 //
     /* 1495542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1495545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1495553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1495556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1495559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1495562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495581 */     // MIs[0] round
     /* 1495581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495584 */     // MIs[0] policy
     /* 1495584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495594 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32),
     /* 1495597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1495615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495618 */     // GIR_Coverage, 17651,
     /* 1495618 */     GIR_EraseRootFromParent_Done,
     /* 1495619 */   // Label 20827: @1495619
     /* 1495619 */   GIM_Try, /*On fail goto*//*Label 20828*/ GIMT_Encode4(1495701), // Rule ID 17654 //
     /* 1495624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1495627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1495635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1495638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1495641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1495644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495663 */     // MIs[0] round
     /* 1495663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495666 */     // MIs[0] policy
     /* 1495666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1495679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1495697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495700 */     // GIR_Coverage, 17654,
     /* 1495700 */     GIR_EraseRootFromParent_Done,
     /* 1495701 */   // Label 20828: @1495701
     /* 1495701 */   GIM_Try, /*On fail goto*//*Label 20829*/ GIMT_Encode4(1495783), // Rule ID 17655 //
     /* 1495706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1495709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1495717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1495720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1495723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1495726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1495745 */     // MIs[0] round
     /* 1495745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495748 */     // MIs[0] policy
     /* 1495748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495758 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64),
     /* 1495761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1495779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495782 */     // GIR_Coverage, 17655,
     /* 1495782 */     GIR_EraseRootFromParent_Done,
     /* 1495783 */   // Label 20829: @1495783
     /* 1495783 */   GIM_Try, /*On fail goto*//*Label 20830*/ GIMT_Encode4(1495865), // Rule ID 17658 //
     /* 1495788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1495791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1495808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495827 */     // MIs[0] round
     /* 1495827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495830 */     // MIs[0] policy
     /* 1495830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495840 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1495840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1495843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495864 */     // GIR_Coverage, 17658,
     /* 1495864 */     GIR_EraseRootFromParent_Done,
     /* 1495865 */   // Label 20830: @1495865
     /* 1495865 */   GIM_Try, /*On fail goto*//*Label 20831*/ GIMT_Encode4(1495947), // Rule ID 17659 //
     /* 1495870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1495873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1495881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1495884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1495887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1495890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1495893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1495909 */     // MIs[0] round
     /* 1495909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495912 */     // MIs[0] policy
     /* 1495912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1495922 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1495922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16),
     /* 1495925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1495927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1495929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1495931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1495933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1495935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1495940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1495943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1495945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1495946 */     // GIR_Coverage, 17659,
     /* 1495946 */     GIR_EraseRootFromParent_Done,
     /* 1495947 */   // Label 20831: @1495947
     /* 1495947 */   GIM_Try, /*On fail goto*//*Label 20832*/ GIMT_Encode4(1496029), // Rule ID 17662 //
     /* 1495952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1495955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1495960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1495963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1495966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1495969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1495972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1495975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1495991 */     // MIs[0] round
     /* 1495991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1495994 */     // MIs[0] policy
     /* 1495994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1495997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496004 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1496007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496028 */     // GIR_Coverage, 17662,
     /* 1496028 */     GIR_EraseRootFromParent_Done,
     /* 1496029 */   // Label 20832: @1496029
     /* 1496029 */   GIM_Try, /*On fail goto*//*Label 20833*/ GIMT_Encode4(1496111), // Rule ID 17663 //
     /* 1496034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1496037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1496045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1496048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1496051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1496054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496073 */     // MIs[0] round
     /* 1496073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496076 */     // MIs[0] policy
     /* 1496076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496086 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16),
     /* 1496089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496110 */     // GIR_Coverage, 17663,
     /* 1496110 */     GIR_EraseRootFromParent_Done,
     /* 1496111 */   // Label 20833: @1496111
     /* 1496111 */   GIM_Try, /*On fail goto*//*Label 20834*/ GIMT_Encode4(1496193), // Rule ID 17666 //
     /* 1496116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1496119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1496127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1496130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1496133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1496136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496155 */     // MIs[0] round
     /* 1496155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496158 */     // MIs[0] policy
     /* 1496158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496168 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1496171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496192 */     // GIR_Coverage, 17666,
     /* 1496192 */     GIR_EraseRootFromParent_Done,
     /* 1496193 */   // Label 20834: @1496193
     /* 1496193 */   GIM_Try, /*On fail goto*//*Label 20835*/ GIMT_Encode4(1496275), // Rule ID 17667 //
     /* 1496198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1496201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1496209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1496212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1496215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1496218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496237 */     // MIs[0] round
     /* 1496237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496240 */     // MIs[0] policy
     /* 1496240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496250 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16),
     /* 1496253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1496271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496274 */     // GIR_Coverage, 17667,
     /* 1496274 */     GIR_EraseRootFromParent_Done,
     /* 1496275 */   // Label 20835: @1496275
     /* 1496275 */   GIM_Try, /*On fail goto*//*Label 20836*/ GIMT_Encode4(1496357), // Rule ID 17670 //
     /* 1496280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1496283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1496291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1496294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1496300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496319 */     // MIs[0] round
     /* 1496319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496322 */     // MIs[0] policy
     /* 1496322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1496335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496356 */     // GIR_Coverage, 17670,
     /* 1496356 */     GIR_EraseRootFromParent_Done,
     /* 1496357 */   // Label 20836: @1496357
     /* 1496357 */   GIM_Try, /*On fail goto*//*Label 20837*/ GIMT_Encode4(1496439), // Rule ID 17671 //
     /* 1496362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1496365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1496373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1496376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1496379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1496382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496401 */     // MIs[0] round
     /* 1496401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496404 */     // MIs[0] policy
     /* 1496404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32),
     /* 1496417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496438 */     // GIR_Coverage, 17671,
     /* 1496438 */     GIR_EraseRootFromParent_Done,
     /* 1496439 */   // Label 20837: @1496439
     /* 1496439 */   GIM_Try, /*On fail goto*//*Label 20838*/ GIMT_Encode4(1496521), // Rule ID 17674 //
     /* 1496444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1496447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1496464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496483 */     // MIs[0] round
     /* 1496483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496486 */     // MIs[0] policy
     /* 1496486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496496 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1496499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496520 */     // GIR_Coverage, 17674,
     /* 1496520 */     GIR_EraseRootFromParent_Done,
     /* 1496521 */   // Label 20838: @1496521
     /* 1496521 */   GIM_Try, /*On fail goto*//*Label 20839*/ GIMT_Encode4(1496603), // Rule ID 17675 //
     /* 1496526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1496529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1496537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1496540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1496543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1496546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496565 */     // MIs[0] round
     /* 1496565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496568 */     // MIs[0] policy
     /* 1496568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496578 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32),
     /* 1496581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496602 */     // GIR_Coverage, 17675,
     /* 1496602 */     GIR_EraseRootFromParent_Done,
     /* 1496603 */   // Label 20839: @1496603
     /* 1496603 */   GIM_Try, /*On fail goto*//*Label 20840*/ GIMT_Encode4(1496685), // Rule ID 17678 //
     /* 1496608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1496611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1496625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1496628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496647 */     // MIs[0] round
     /* 1496647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496650 */     // MIs[0] policy
     /* 1496650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496660 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1496663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496684 */     // GIR_Coverage, 17678,
     /* 1496684 */     GIR_EraseRootFromParent_Done,
     /* 1496685 */   // Label 20840: @1496685
     /* 1496685 */   GIM_Try, /*On fail goto*//*Label 20841*/ GIMT_Encode4(1496767), // Rule ID 17679 //
     /* 1496690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1496693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1496701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1496704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1496707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1496710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1496729 */     // MIs[0] round
     /* 1496729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496732 */     // MIs[0] policy
     /* 1496732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496742 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32),
     /* 1496745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1496763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496766 */     // GIR_Coverage, 17679,
     /* 1496766 */     GIR_EraseRootFromParent_Done,
     /* 1496767 */   // Label 20841: @1496767
     /* 1496767 */   GIM_Try, /*On fail goto*//*Label 20842*/ GIMT_Encode4(1496849), // Rule ID 17682 //
     /* 1496772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1496775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1496789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1496792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496811 */     // MIs[0] round
     /* 1496811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496814 */     // MIs[0] policy
     /* 1496814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1496827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496848 */     // GIR_Coverage, 17682,
     /* 1496848 */     GIR_EraseRootFromParent_Done,
     /* 1496849 */   // Label 20842: @1496849
     /* 1496849 */   GIM_Try, /*On fail goto*//*Label 20843*/ GIMT_Encode4(1496931), // Rule ID 17683 //
     /* 1496854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1496857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1496865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1496868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1496871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1496874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1496877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1496893 */     // MIs[0] round
     /* 1496893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496896 */     // MIs[0] policy
     /* 1496896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496906 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1496906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64),
     /* 1496909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1496919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1496924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1496927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1496929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1496930 */     // GIR_Coverage, 17683,
     /* 1496930 */     GIR_EraseRootFromParent_Done,
     /* 1496931 */   // Label 20843: @1496931
     /* 1496931 */   GIM_Try, /*On fail goto*//*Label 20844*/ GIMT_Encode4(1497013), // Rule ID 17686 //
     /* 1496936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1496939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1496944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1496947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1496950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1496953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1496956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1496959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1496975 */     // MIs[0] round
     /* 1496975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1496978 */     // MIs[0] policy
     /* 1496978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1496981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1496988 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1496988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1496991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1496993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1496995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1496997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1496999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1497009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497012 */     // GIR_Coverage, 17686,
     /* 1497012 */     GIR_EraseRootFromParent_Done,
     /* 1497013 */   // Label 20844: @1497013
     /* 1497013 */   GIM_Try, /*On fail goto*//*Label 20845*/ GIMT_Encode4(1497095), // Rule ID 17687 //
     /* 1497018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1497021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1497029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1497032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1497035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1497038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1497057 */     // MIs[0] round
     /* 1497057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497060 */     // MIs[0] policy
     /* 1497060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497070 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64),
     /* 1497073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1497091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497094 */     // GIR_Coverage, 17687,
     /* 1497094 */     GIR_EraseRootFromParent_Done,
     /* 1497095 */   // Label 20845: @1497095
     /* 1497095 */   GIM_Try, /*On fail goto*//*Label 20846*/ GIMT_Encode4(1497177), // Rule ID 17690 //
     /* 1497100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1497103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1497117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1497120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497139 */     // MIs[0] round
     /* 1497139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497142 */     // MIs[0] policy
     /* 1497142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497152 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1497155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1497173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497176 */     // GIR_Coverage, 17690,
     /* 1497176 */     GIR_EraseRootFromParent_Done,
     /* 1497177 */   // Label 20846: @1497177
     /* 1497177 */   GIM_Try, /*On fail goto*//*Label 20847*/ GIMT_Encode4(1497259), // Rule ID 17691 //
     /* 1497182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1497185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1497193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1497196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1497199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1497202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1497221 */     // MIs[0] round
     /* 1497221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497224 */     // MIs[0] policy
     /* 1497224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497234 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64),
     /* 1497237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1497255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497258 */     // GIR_Coverage, 17691,
     /* 1497258 */     GIR_EraseRootFromParent_Done,
     /* 1497259 */   // Label 20847: @1497259
     /* 1497259 */   GIM_Try, /*On fail goto*//*Label 20848*/ GIMT_Encode4(1497341), // Rule ID 17694 //
     /* 1497264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1497267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1497284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497303 */     // MIs[0] round
     /* 1497303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497306 */     // MIs[0] policy
     /* 1497306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497316 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1497319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497340 */     // GIR_Coverage, 17694,
     /* 1497340 */     GIR_EraseRootFromParent_Done,
     /* 1497341 */   // Label 20848: @1497341
     /* 1497341 */   GIM_Try, /*On fail goto*//*Label 20849*/ GIMT_Encode4(1497423), // Rule ID 17695 //
     /* 1497346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1497349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1497357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1497360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1497366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497385 */     // MIs[0] round
     /* 1497385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497388 */     // MIs[0] policy
     /* 1497388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497398 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16),
     /* 1497401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497422 */     // GIR_Coverage, 17695,
     /* 1497422 */     GIR_EraseRootFromParent_Done,
     /* 1497423 */   // Label 20849: @1497423
     /* 1497423 */   GIM_Try, /*On fail goto*//*Label 20850*/ GIMT_Encode4(1497505), // Rule ID 17698 //
     /* 1497428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1497431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1497448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497467 */     // MIs[0] round
     /* 1497467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497470 */     // MIs[0] policy
     /* 1497470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497480 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1497483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497504 */     // GIR_Coverage, 17698,
     /* 1497504 */     GIR_EraseRootFromParent_Done,
     /* 1497505 */   // Label 20850: @1497505
     /* 1497505 */   GIM_Try, /*On fail goto*//*Label 20851*/ GIMT_Encode4(1497587), // Rule ID 17699 //
     /* 1497510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1497513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1497521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1497524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1497530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497549 */     // MIs[0] round
     /* 1497549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497552 */     // MIs[0] policy
     /* 1497552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497562 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16),
     /* 1497565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497586 */     // GIR_Coverage, 17699,
     /* 1497586 */     GIR_EraseRootFromParent_Done,
     /* 1497587 */   // Label 20851: @1497587
     /* 1497587 */   GIM_Try, /*On fail goto*//*Label 20852*/ GIMT_Encode4(1497669), // Rule ID 17702 //
     /* 1497592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1497595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1497609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1497612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1497627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497631 */     // MIs[0] round
     /* 1497631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497634 */     // MIs[0] policy
     /* 1497634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1497647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497668 */     // GIR_Coverage, 17702,
     /* 1497668 */     GIR_EraseRootFromParent_Done,
     /* 1497669 */   // Label 20852: @1497669
     /* 1497669 */   GIM_Try, /*On fail goto*//*Label 20853*/ GIMT_Encode4(1497751), // Rule ID 17703 //
     /* 1497674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1497677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1497685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1497688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1497691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1497694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1497709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497713 */     // MIs[0] round
     /* 1497713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497716 */     // MIs[0] policy
     /* 1497716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497726 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32),
     /* 1497729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497750 */     // GIR_Coverage, 17703,
     /* 1497750 */     GIR_EraseRootFromParent_Done,
     /* 1497751 */   // Label 20853: @1497751
     /* 1497751 */   GIM_Try, /*On fail goto*//*Label 20854*/ GIMT_Encode4(1497833), // Rule ID 17706 //
     /* 1497756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1497759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1497767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1497770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1497776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497795 */     // MIs[0] round
     /* 1497795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497798 */     // MIs[0] policy
     /* 1497798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497808 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1497811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497832 */     // GIR_Coverage, 17706,
     /* 1497832 */     GIR_EraseRootFromParent_Done,
     /* 1497833 */   // Label 20854: @1497833
     /* 1497833 */   GIM_Try, /*On fail goto*//*Label 20855*/ GIMT_Encode4(1497915), // Rule ID 17707 //
     /* 1497838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1497841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1497849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1497852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1497855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1497858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1497861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1497873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497877 */     // MIs[0] round
     /* 1497877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497880 */     // MIs[0] policy
     /* 1497880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497890 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11136:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1497890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16),
     /* 1497893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1497911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497914 */     // GIR_Coverage, 17707,
     /* 1497914 */     GIR_EraseRootFromParent_Done,
     /* 1497915 */   // Label 20855: @1497915
     /* 1497915 */   GIM_Try, /*On fail goto*//*Label 20856*/ GIMT_Encode4(1497997), // Rule ID 17710 //
     /* 1497920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1497923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1497928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1497931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1497934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1497937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1497940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1497943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1497955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1497959 */     // MIs[0] round
     /* 1497959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1497962 */     // MIs[0] policy
     /* 1497962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1497965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1497972 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1497972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1497975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1497977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1497979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1497981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1497983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1497985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1497990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1497993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1497995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1497996 */     // GIR_Coverage, 17710,
     /* 1497996 */     GIR_EraseRootFromParent_Done,
     /* 1497997 */   // Label 20856: @1497997
     /* 1497997 */   GIM_Try, /*On fail goto*//*Label 20857*/ GIMT_Encode4(1498079), // Rule ID 17711 //
     /* 1498002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1498005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1498013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1498016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1498019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1498022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1498037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498041 */     // MIs[0] round
     /* 1498041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498044 */     // MIs[0] policy
     /* 1498044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498054 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11136:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32),
     /* 1498057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498078 */     // GIR_Coverage, 17711,
     /* 1498078 */     GIR_EraseRootFromParent_Done,
     /* 1498079 */   // Label 20857: @1498079
     /* 1498079 */   GIM_Try, /*On fail goto*//*Label 20858*/ GIMT_Encode4(1498161), // Rule ID 17714 //
     /* 1498084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1498087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1498101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1498104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1498119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498123 */     // MIs[0] round
     /* 1498123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498126 */     // MIs[0] policy
     /* 1498126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1498139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498160 */     // GIR_Coverage, 17714,
     /* 1498160 */     GIR_EraseRootFromParent_Done,
     /* 1498161 */   // Label 20858: @1498161
     /* 1498161 */   GIM_Try, /*On fail goto*//*Label 20859*/ GIMT_Encode4(1498243), // Rule ID 17715 //
     /* 1498166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1498169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1498177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1498180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1498183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1498186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1498201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1498205 */     // MIs[0] round
     /* 1498205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498208 */     // MIs[0] policy
     /* 1498208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498218 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11136:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64),
     /* 1498221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1498239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498242 */     // GIR_Coverage, 17715,
     /* 1498242 */     GIR_EraseRootFromParent_Done,
     /* 1498243 */   // Label 20859: @1498243
     /* 1498243 */   GIM_Try, /*On fail goto*//*Label 20860*/ GIMT_Encode4(1498325), // Rule ID 17718 //
     /* 1498248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1498251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1498268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498287 */     // MIs[0] round
     /* 1498287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498290 */     // MIs[0] policy
     /* 1498290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498300 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1498303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498324 */     // GIR_Coverage, 17718,
     /* 1498324 */     GIR_EraseRootFromParent_Done,
     /* 1498325 */   // Label 20860: @1498325
     /* 1498325 */   GIM_Try, /*On fail goto*//*Label 20861*/ GIMT_Encode4(1498407), // Rule ID 17719 //
     /* 1498330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1498333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1498341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1498344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1498350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498369 */     // MIs[0] round
     /* 1498369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498372 */     // MIs[0] policy
     /* 1498372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498382 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16),
     /* 1498385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498406 */     // GIR_Coverage, 17719,
     /* 1498406 */     GIR_EraseRootFromParent_Done,
     /* 1498407 */   // Label 20861: @1498407
     /* 1498407 */   GIM_Try, /*On fail goto*//*Label 20862*/ GIMT_Encode4(1498489), // Rule ID 17722 //
     /* 1498412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1498415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1498423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1498426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1498432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498451 */     // MIs[0] round
     /* 1498451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498454 */     // MIs[0] policy
     /* 1498454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498464 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1498467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498488 */     // GIR_Coverage, 17722,
     /* 1498488 */     GIR_EraseRootFromParent_Done,
     /* 1498489 */   // Label 20862: @1498489
     /* 1498489 */   GIM_Try, /*On fail goto*//*Label 20863*/ GIMT_Encode4(1498571), // Rule ID 17723 //
     /* 1498494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1498497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1498505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1498508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1498514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498533 */     // MIs[0] round
     /* 1498533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498536 */     // MIs[0] policy
     /* 1498536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498546 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16),
     /* 1498549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498570 */     // GIR_Coverage, 17723,
     /* 1498570 */     GIR_EraseRootFromParent_Done,
     /* 1498571 */   // Label 20863: @1498571
     /* 1498571 */   GIM_Try, /*On fail goto*//*Label 20864*/ GIMT_Encode4(1498653), // Rule ID 17726 //
     /* 1498576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1498579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1498587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1498590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1498596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498615 */     // MIs[0] round
     /* 1498615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498618 */     // MIs[0] policy
     /* 1498618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498628 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1498631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498652 */     // GIR_Coverage, 17726,
     /* 1498652 */     GIR_EraseRootFromParent_Done,
     /* 1498653 */   // Label 20864: @1498653
     /* 1498653 */   GIM_Try, /*On fail goto*//*Label 20865*/ GIMT_Encode4(1498735), // Rule ID 17727 //
     /* 1498658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1498661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1498669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1498672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1498675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1498678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1498693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1498697 */     // MIs[0] round
     /* 1498697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498700 */     // MIs[0] policy
     /* 1498700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498710 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16),
     /* 1498713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1498731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498734 */     // GIR_Coverage, 17727,
     /* 1498734 */     GIR_EraseRootFromParent_Done,
     /* 1498735 */   // Label 20865: @1498735
     /* 1498735 */   GIM_Try, /*On fail goto*//*Label 20866*/ GIMT_Encode4(1498817), // Rule ID 17730 //
     /* 1498740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1498743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1498751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1498754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1498757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1498760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1498775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498779 */     // MIs[0] round
     /* 1498779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498782 */     // MIs[0] policy
     /* 1498782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498792 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1498795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498816 */     // GIR_Coverage, 17730,
     /* 1498816 */     GIR_EraseRootFromParent_Done,
     /* 1498817 */   // Label 20866: @1498817
     /* 1498817 */   GIM_Try, /*On fail goto*//*Label 20867*/ GIMT_Encode4(1498899), // Rule ID 17731 //
     /* 1498822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1498825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1498833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1498836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1498839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1498842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1498845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1498857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1498861 */     // MIs[0] round
     /* 1498861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498864 */     // MIs[0] policy
     /* 1498864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498874 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1498874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32),
     /* 1498877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498898 */     // GIR_Coverage, 17731,
     /* 1498898 */     GIR_EraseRootFromParent_Done,
     /* 1498899 */   // Label 20867: @1498899
     /* 1498899 */   GIM_Try, /*On fail goto*//*Label 20868*/ GIMT_Encode4(1498981), // Rule ID 17734 //
     /* 1498904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1498907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1498915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1498918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1498921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1498924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1498927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1498939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1498943 */     // MIs[0] round
     /* 1498943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1498946 */     // MIs[0] policy
     /* 1498946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1498949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1498956 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1498956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1498959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1498961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1498963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1498965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1498967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1498969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1498974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1498977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1498979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1498980 */     // GIR_Coverage, 17734,
     /* 1498980 */     GIR_EraseRootFromParent_Done,
     /* 1498981 */   // Label 20868: @1498981
     /* 1498981 */   GIM_Try, /*On fail goto*//*Label 20869*/ GIMT_Encode4(1499063), // Rule ID 17735 //
     /* 1498986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1498989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1498994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1498997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1499000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1499003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1499006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1499021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499025 */     // MIs[0] round
     /* 1499025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499028 */     // MIs[0] policy
     /* 1499028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499038 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32),
     /* 1499041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499062 */     // GIR_Coverage, 17735,
     /* 1499062 */     GIR_EraseRootFromParent_Done,
     /* 1499063 */   // Label 20869: @1499063
     /* 1499063 */   GIM_Try, /*On fail goto*//*Label 20870*/ GIMT_Encode4(1499145), // Rule ID 17738 //
     /* 1499068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1499071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1499085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1499088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1499103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499107 */     // MIs[0] round
     /* 1499107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499110 */     // MIs[0] policy
     /* 1499110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499120 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1499123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499144 */     // GIR_Coverage, 17738,
     /* 1499144 */     GIR_EraseRootFromParent_Done,
     /* 1499145 */   // Label 20870: @1499145
     /* 1499145 */   GIM_Try, /*On fail goto*//*Label 20871*/ GIMT_Encode4(1499227), // Rule ID 17739 //
     /* 1499150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1499153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1499161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1499164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1499167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1499170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1499185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499189 */     // MIs[0] round
     /* 1499189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499192 */     // MIs[0] policy
     /* 1499192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499202 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32),
     /* 1499205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1499223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499226 */     // GIR_Coverage, 17739,
     /* 1499226 */     GIR_EraseRootFromParent_Done,
     /* 1499227 */   // Label 20871: @1499227
     /* 1499227 */   GIM_Try, /*On fail goto*//*Label 20872*/ GIMT_Encode4(1499309), // Rule ID 17742 //
     /* 1499232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1499235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1499243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1499246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1499252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499271 */     // MIs[0] round
     /* 1499271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499274 */     // MIs[0] policy
     /* 1499274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1499287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499308 */     // GIR_Coverage, 17742,
     /* 1499308 */     GIR_EraseRootFromParent_Done,
     /* 1499309 */   // Label 20872: @1499309
     /* 1499309 */   GIM_Try, /*On fail goto*//*Label 20873*/ GIMT_Encode4(1499391), // Rule ID 17743 //
     /* 1499314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1499317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1499325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1499328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1499334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1499353 */     // MIs[0] round
     /* 1499353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499356 */     // MIs[0] policy
     /* 1499356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499366 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11136:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64),
     /* 1499369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499390 */     // GIR_Coverage, 17743,
     /* 1499390 */     GIR_EraseRootFromParent_Done,
     /* 1499391 */   // Label 20873: @1499391
     /* 1499391 */   GIM_Try, /*On fail goto*//*Label 20874*/ GIMT_Encode4(1499473), // Rule ID 17746 //
     /* 1499396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1499399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1499407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1499410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1499416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499435 */     // MIs[0] round
     /* 1499435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499438 */     // MIs[0] policy
     /* 1499438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499448 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1499451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499472 */     // GIR_Coverage, 17746,
     /* 1499472 */     GIR_EraseRootFromParent_Done,
     /* 1499473 */   // Label 20874: @1499473
     /* 1499473 */   GIM_Try, /*On fail goto*//*Label 20875*/ GIMT_Encode4(1499555), // Rule ID 17747 //
     /* 1499478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1499481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1499489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1499492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1499498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1499517 */     // MIs[0] round
     /* 1499517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499520 */     // MIs[0] policy
     /* 1499520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499530 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11136:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64),
     /* 1499533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499554 */     // GIR_Coverage, 17747,
     /* 1499554 */     GIR_EraseRootFromParent_Done,
     /* 1499555 */   // Label 20875: @1499555
     /* 1499555 */   GIM_Try, /*On fail goto*//*Label 20876*/ GIMT_Encode4(1499637), // Rule ID 17750 //
     /* 1499560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1499563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1499571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1499574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1499580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499599 */     // MIs[0] round
     /* 1499599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499602 */     // MIs[0] policy
     /* 1499602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499612 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1499615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499636 */     // GIR_Coverage, 17750,
     /* 1499636 */     GIR_EraseRootFromParent_Done,
     /* 1499637 */   // Label 20876: @1499637
     /* 1499637 */   GIM_Try, /*On fail goto*//*Label 20877*/ GIMT_Encode4(1499719), // Rule ID 17751 //
     /* 1499642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1499645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc),
     /* 1499650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1499653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1499656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1499659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1499662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1499677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1499681 */     // MIs[0] round
     /* 1499681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499684 */     // MIs[0] policy
     /* 1499684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11136:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64),
     /* 1499697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1499715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499718 */     // GIR_Coverage, 17751,
     /* 1499718 */     GIR_EraseRootFromParent_Done,
     /* 1499719 */   // Label 20877: @1499719
     /* 1499719 */   GIM_Try, /*On fail goto*//*Label 20878*/ GIMT_Encode4(1499801), // Rule ID 17754 //
     /* 1499724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1499727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1499732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1499744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499763 */     // MIs[0] round
     /* 1499763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499766 */     // MIs[0] policy
     /* 1499766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499776 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1499779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499800 */     // GIR_Coverage, 17754,
     /* 1499800 */     GIR_EraseRootFromParent_Done,
     /* 1499801 */   // Label 20878: @1499801
     /* 1499801 */   GIM_Try, /*On fail goto*//*Label 20879*/ GIMT_Encode4(1499883), // Rule ID 17755 //
     /* 1499806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1499809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1499814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1499817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1499820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1499823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1499826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499845 */     // MIs[0] round
     /* 1499845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499848 */     // MIs[0] policy
     /* 1499848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499858 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1499858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16),
     /* 1499861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499882 */     // GIR_Coverage, 17755,
     /* 1499882 */     GIR_EraseRootFromParent_Done,
     /* 1499883 */   // Label 20879: @1499883
     /* 1499883 */   GIM_Try, /*On fail goto*//*Label 20880*/ GIMT_Encode4(1499965), // Rule ID 17758 //
     /* 1499888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1499891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1499896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1499899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1499902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1499908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1499911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499927 */     // MIs[0] round
     /* 1499927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1499930 */     // MIs[0] policy
     /* 1499930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1499933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1499940 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1499940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1499943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1499945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1499947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1499949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1499951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1499953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1499958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1499961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1499963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1499964 */     // GIR_Coverage, 17758,
     /* 1499964 */     GIR_EraseRootFromParent_Done,
     /* 1499965 */   // Label 20880: @1499965
     /* 1499965 */   GIM_Try, /*On fail goto*//*Label 20881*/ GIMT_Encode4(1500047), // Rule ID 17759 //
     /* 1499970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1499973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1499978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1499981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1499984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1499987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1499990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1499993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1499997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500009 */     // MIs[0] round
     /* 1500009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500012 */     // MIs[0] policy
     /* 1500012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500022 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16),
     /* 1500025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500046 */     // GIR_Coverage, 17759,
     /* 1500046 */     GIR_EraseRootFromParent_Done,
     /* 1500047 */   // Label 20881: @1500047
     /* 1500047 */   GIM_Try, /*On fail goto*//*Label 20882*/ GIMT_Encode4(1500129), // Rule ID 17762 //
     /* 1500052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1500055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1500063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1500066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1500069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1500072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500091 */     // MIs[0] round
     /* 1500091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500094 */     // MIs[0] policy
     /* 1500094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500104 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1500107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500128 */     // GIR_Coverage, 17762,
     /* 1500128 */     GIR_EraseRootFromParent_Done,
     /* 1500129 */   // Label 20882: @1500129
     /* 1500129 */   GIM_Try, /*On fail goto*//*Label 20883*/ GIMT_Encode4(1500211), // Rule ID 17763 //
     /* 1500134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1500137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1500145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1500148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1500151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1500154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500173 */     // MIs[0] round
     /* 1500173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500176 */     // MIs[0] policy
     /* 1500176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500186 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32),
     /* 1500189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500210 */     // GIR_Coverage, 17763,
     /* 1500210 */     GIR_EraseRootFromParent_Done,
     /* 1500211 */   // Label 20883: @1500211
     /* 1500211 */   GIM_Try, /*On fail goto*//*Label 20884*/ GIMT_Encode4(1500293), // Rule ID 17766 //
     /* 1500216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1500227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1500230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1500233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1500236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500255 */     // MIs[0] round
     /* 1500255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500258 */     // MIs[0] policy
     /* 1500258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500268 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1500271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500292 */     // GIR_Coverage, 17766,
     /* 1500292 */     GIR_EraseRootFromParent_Done,
     /* 1500293 */   // Label 20884: @1500293
     /* 1500293 */   GIM_Try, /*On fail goto*//*Label 20885*/ GIMT_Encode4(1500375), // Rule ID 17767 //
     /* 1500298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1500309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1500312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1500315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1500318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500337 */     // MIs[0] round
     /* 1500337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500340 */     // MIs[0] policy
     /* 1500340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500350 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16),
     /* 1500353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500374 */     // GIR_Coverage, 17767,
     /* 1500374 */     GIR_EraseRootFromParent_Done,
     /* 1500375 */   // Label 20885: @1500375
     /* 1500375 */   GIM_Try, /*On fail goto*//*Label 20886*/ GIMT_Encode4(1500457), // Rule ID 17770 //
     /* 1500380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1500383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1500391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1500394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1500397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1500400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500419 */     // MIs[0] round
     /* 1500419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500422 */     // MIs[0] policy
     /* 1500422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500432 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1500435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500456 */     // GIR_Coverage, 17770,
     /* 1500456 */     GIR_EraseRootFromParent_Done,
     /* 1500457 */   // Label 20886: @1500457
     /* 1500457 */   GIM_Try, /*On fail goto*//*Label 20887*/ GIMT_Encode4(1500539), // Rule ID 17771 //
     /* 1500462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1500465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1500473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1500476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1500479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1500482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500501 */     // MIs[0] round
     /* 1500501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500504 */     // MIs[0] policy
     /* 1500504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500514 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32),
     /* 1500517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1500535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500538 */     // GIR_Coverage, 17771,
     /* 1500538 */     GIR_EraseRootFromParent_Done,
     /* 1500539 */   // Label 20887: @1500539
     /* 1500539 */   GIM_Try, /*On fail goto*//*Label 20888*/ GIMT_Encode4(1500621), // Rule ID 17774 //
     /* 1500544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1500547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1500555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1500558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1500561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1500564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500583 */     // MIs[0] round
     /* 1500583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500586 */     // MIs[0] policy
     /* 1500586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1500599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500620 */     // GIR_Coverage, 17774,
     /* 1500620 */     GIR_EraseRootFromParent_Done,
     /* 1500621 */   // Label 20888: @1500621
     /* 1500621 */   GIM_Try, /*On fail goto*//*Label 20889*/ GIMT_Encode4(1500703), // Rule ID 17775 //
     /* 1500626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1500629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1500637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1500640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1500643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1500646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1500665 */     // MIs[0] round
     /* 1500665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500668 */     // MIs[0] policy
     /* 1500668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500678 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64),
     /* 1500681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1500699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500702 */     // GIR_Coverage, 17775,
     /* 1500702 */     GIR_EraseRootFromParent_Done,
     /* 1500703 */   // Label 20889: @1500703
     /* 1500703 */   GIM_Try, /*On fail goto*//*Label 20890*/ GIMT_Encode4(1500785), // Rule ID 17778 //
     /* 1500708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1500719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1500722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1500725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1500728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500747 */     // MIs[0] round
     /* 1500747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500750 */     // MIs[0] policy
     /* 1500750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500760 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1500763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500784 */     // GIR_Coverage, 17778,
     /* 1500784 */     GIR_EraseRootFromParent_Done,
     /* 1500785 */   // Label 20890: @1500785
     /* 1500785 */   GIM_Try, /*On fail goto*//*Label 20891*/ GIMT_Encode4(1500867), // Rule ID 17779 //
     /* 1500790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1500801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1500804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1500807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1500810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1500829 */     // MIs[0] round
     /* 1500829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500832 */     // MIs[0] policy
     /* 1500832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500842 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1500842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16),
     /* 1500845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500866 */     // GIR_Coverage, 17779,
     /* 1500866 */     GIR_EraseRootFromParent_Done,
     /* 1500867 */   // Label 20891: @1500867
     /* 1500867 */   GIM_Try, /*On fail goto*//*Label 20892*/ GIMT_Encode4(1500949), // Rule ID 17782 //
     /* 1500872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1500875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1500892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1500895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500911 */     // MIs[0] round
     /* 1500911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500914 */     // MIs[0] policy
     /* 1500914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1500924 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1500924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1500927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1500929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1500931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1500933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1500935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1500937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1500942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1500945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1500947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1500948 */     // GIR_Coverage, 17782,
     /* 1500948 */     GIR_EraseRootFromParent_Done,
     /* 1500949 */   // Label 20892: @1500949
     /* 1500949 */   GIM_Try, /*On fail goto*//*Label 20893*/ GIMT_Encode4(1501031), // Rule ID 17783 //
     /* 1500954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1500957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1500962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1500965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1500968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1500971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1500974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1500977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1500993 */     // MIs[0] round
     /* 1500993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1500996 */     // MIs[0] policy
     /* 1500996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1500999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501006 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16),
     /* 1501009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501030 */     // GIR_Coverage, 17783,
     /* 1501030 */     GIR_EraseRootFromParent_Done,
     /* 1501031 */   // Label 20893: @1501031
     /* 1501031 */   GIM_Try, /*On fail goto*//*Label 20894*/ GIMT_Encode4(1501113), // Rule ID 17786 //
     /* 1501036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1501039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1501047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1501050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1501053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1501056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501075 */     // MIs[0] round
     /* 1501075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501078 */     // MIs[0] policy
     /* 1501078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501088 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1501091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501112 */     // GIR_Coverage, 17786,
     /* 1501112 */     GIR_EraseRootFromParent_Done,
     /* 1501113 */   // Label 20894: @1501113
     /* 1501113 */   GIM_Try, /*On fail goto*//*Label 20895*/ GIMT_Encode4(1501195), // Rule ID 17787 //
     /* 1501118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1501121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1501129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1501132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1501135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1501138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501157 */     // MIs[0] round
     /* 1501157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501160 */     // MIs[0] policy
     /* 1501160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501170 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16),
     /* 1501173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1501191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501194 */     // GIR_Coverage, 17787,
     /* 1501194 */     GIR_EraseRootFromParent_Done,
     /* 1501195 */   // Label 20895: @1501195
     /* 1501195 */   GIM_Try, /*On fail goto*//*Label 20896*/ GIMT_Encode4(1501277), // Rule ID 17790 //
     /* 1501200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1501211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1501214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1501217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1501220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501239 */     // MIs[0] round
     /* 1501239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501242 */     // MIs[0] policy
     /* 1501242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501252 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1501255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501276 */     // GIR_Coverage, 17790,
     /* 1501276 */     GIR_EraseRootFromParent_Done,
     /* 1501277 */   // Label 20896: @1501277
     /* 1501277 */   GIM_Try, /*On fail goto*//*Label 20897*/ GIMT_Encode4(1501359), // Rule ID 17791 //
     /* 1501282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1501293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1501296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1501299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1501302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501321 */     // MIs[0] round
     /* 1501321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501324 */     // MIs[0] policy
     /* 1501324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501334 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32),
     /* 1501337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501358 */     // GIR_Coverage, 17791,
     /* 1501358 */     GIR_EraseRootFromParent_Done,
     /* 1501359 */   // Label 20897: @1501359
     /* 1501359 */   GIM_Try, /*On fail goto*//*Label 20898*/ GIMT_Encode4(1501441), // Rule ID 17794 //
     /* 1501364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1501375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1501378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1501381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1501384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501403 */     // MIs[0] round
     /* 1501403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501406 */     // MIs[0] policy
     /* 1501406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501416 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1501419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501440 */     // GIR_Coverage, 17794,
     /* 1501440 */     GIR_EraseRootFromParent_Done,
     /* 1501441 */   // Label 20898: @1501441
     /* 1501441 */   GIM_Try, /*On fail goto*//*Label 20899*/ GIMT_Encode4(1501523), // Rule ID 17795 //
     /* 1501446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1501457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1501460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1501463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1501466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501485 */     // MIs[0] round
     /* 1501485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501488 */     // MIs[0] policy
     /* 1501488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501498 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32),
     /* 1501501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501522 */     // GIR_Coverage, 17795,
     /* 1501522 */     GIR_EraseRootFromParent_Done,
     /* 1501523 */   // Label 20899: @1501523
     /* 1501523 */   GIM_Try, /*On fail goto*//*Label 20900*/ GIMT_Encode4(1501605), // Rule ID 17798 //
     /* 1501528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1501531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1501539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1501542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1501545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1501548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501567 */     // MIs[0] round
     /* 1501567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501570 */     // MIs[0] policy
     /* 1501570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501580 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1501583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501604 */     // GIR_Coverage, 17798,
     /* 1501604 */     GIR_EraseRootFromParent_Done,
     /* 1501605 */   // Label 20900: @1501605
     /* 1501605 */   GIM_Try, /*On fail goto*//*Label 20901*/ GIMT_Encode4(1501687), // Rule ID 17799 //
     /* 1501610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1501613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1501621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1501624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1501627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1501630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1501649 */     // MIs[0] round
     /* 1501649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501652 */     // MIs[0] policy
     /* 1501652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501662 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32),
     /* 1501665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1501683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501686 */     // GIR_Coverage, 17799,
     /* 1501686 */     GIR_EraseRootFromParent_Done,
     /* 1501687 */   // Label 20901: @1501687
     /* 1501687 */   GIM_Try, /*On fail goto*//*Label 20902*/ GIMT_Encode4(1501769), // Rule ID 17802 //
     /* 1501692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1501695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1501712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501731 */     // MIs[0] round
     /* 1501731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501734 */     // MIs[0] policy
     /* 1501734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501744 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1501747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501768 */     // GIR_Coverage, 17802,
     /* 1501768 */     GIR_EraseRootFromParent_Done,
     /* 1501769 */   // Label 20902: @1501769
     /* 1501769 */   GIM_Try, /*On fail goto*//*Label 20903*/ GIMT_Encode4(1501851), // Rule ID 17803 //
     /* 1501774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1501777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1501785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1501788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1501791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1501794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1501813 */     // MIs[0] round
     /* 1501813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501816 */     // MIs[0] policy
     /* 1501816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501826 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64),
     /* 1501829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501850 */     // GIR_Coverage, 17803,
     /* 1501850 */     GIR_EraseRootFromParent_Done,
     /* 1501851 */   // Label 20903: @1501851
     /* 1501851 */   GIM_Try, /*On fail goto*//*Label 20904*/ GIMT_Encode4(1501933), // Rule ID 17806 //
     /* 1501856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1501859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1501876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1501879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501895 */     // MIs[0] round
     /* 1501895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501898 */     // MIs[0] policy
     /* 1501898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501908 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1501908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1501911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1501919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1501921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1501926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1501929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1501931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1501932 */     // GIR_Coverage, 17806,
     /* 1501932 */     GIR_EraseRootFromParent_Done,
     /* 1501933 */   // Label 20904: @1501933
     /* 1501933 */   GIM_Try, /*On fail goto*//*Label 20905*/ GIMT_Encode4(1502015), // Rule ID 17807 //
     /* 1501938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1501941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1501946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1501949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1501952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1501955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1501958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1501961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1501977 */     // MIs[0] round
     /* 1501977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1501980 */     // MIs[0] policy
     /* 1501980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1501983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1501990 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1501990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64),
     /* 1501993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1501995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1501997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1501999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502014 */     // GIR_Coverage, 17807,
     /* 1502014 */     GIR_EraseRootFromParent_Done,
     /* 1502015 */   // Label 20905: @1502015
     /* 1502015 */   GIM_Try, /*On fail goto*//*Label 20906*/ GIMT_Encode4(1502097), // Rule ID 17810 //
     /* 1502020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1502023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1502031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1502034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1502037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1502040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502059 */     // MIs[0] round
     /* 1502059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502062 */     // MIs[0] policy
     /* 1502062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502072 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1502075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502096 */     // GIR_Coverage, 17810,
     /* 1502096 */     GIR_EraseRootFromParent_Done,
     /* 1502097 */   // Label 20906: @1502097
     /* 1502097 */   GIM_Try, /*On fail goto*//*Label 20907*/ GIMT_Encode4(1502179), // Rule ID 17811 //
     /* 1502102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1502105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1502113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1502116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1502119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1502122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1502141 */     // MIs[0] round
     /* 1502141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502144 */     // MIs[0] policy
     /* 1502144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502154 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64),
     /* 1502157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1502175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502178 */     // GIR_Coverage, 17811,
     /* 1502178 */     GIR_EraseRootFromParent_Done,
     /* 1502179 */   // Label 20907: @1502179
     /* 1502179 */   GIM_Try, /*On fail goto*//*Label 20908*/ GIMT_Encode4(1502261), // Rule ID 17814 //
     /* 1502184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1502195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1502198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1502204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502223 */     // MIs[0] round
     /* 1502223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502226 */     // MIs[0] policy
     /* 1502226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502236 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1502239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502260 */     // GIR_Coverage, 17814,
     /* 1502260 */     GIR_EraseRootFromParent_Done,
     /* 1502261 */   // Label 20908: @1502261
     /* 1502261 */   GIM_Try, /*On fail goto*//*Label 20909*/ GIMT_Encode4(1502343), // Rule ID 17815 //
     /* 1502266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1502277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1502280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1502286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502305 */     // MIs[0] round
     /* 1502305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502308 */     // MIs[0] policy
     /* 1502308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502318 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16),
     /* 1502321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502342 */     // GIR_Coverage, 17815,
     /* 1502342 */     GIR_EraseRootFromParent_Done,
     /* 1502343 */   // Label 20909: @1502343
     /* 1502343 */   GIM_Try, /*On fail goto*//*Label 20910*/ GIMT_Encode4(1502425), // Rule ID 17818 //
     /* 1502348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502387 */     // MIs[0] round
     /* 1502387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502390 */     // MIs[0] policy
     /* 1502390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502400 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1502403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502424 */     // GIR_Coverage, 17818,
     /* 1502424 */     GIR_EraseRootFromParent_Done,
     /* 1502425 */   // Label 20910: @1502425
     /* 1502425 */   GIM_Try, /*On fail goto*//*Label 20911*/ GIMT_Encode4(1502507), // Rule ID 17819 //
     /* 1502430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1502441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1502444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1502450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502469 */     // MIs[0] round
     /* 1502469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502472 */     // MIs[0] policy
     /* 1502472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502482 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16),
     /* 1502485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502506 */     // GIR_Coverage, 17819,
     /* 1502506 */     GIR_EraseRootFromParent_Done,
     /* 1502507 */   // Label 20911: @1502507
     /* 1502507 */   GIM_Try, /*On fail goto*//*Label 20912*/ GIMT_Encode4(1502589), // Rule ID 17822 //
     /* 1502512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502551 */     // MIs[0] round
     /* 1502551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502554 */     // MIs[0] policy
     /* 1502554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502564 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1502567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502588 */     // GIR_Coverage, 17822,
     /* 1502588 */     GIR_EraseRootFromParent_Done,
     /* 1502589 */   // Label 20912: @1502589
     /* 1502589 */   GIM_Try, /*On fail goto*//*Label 20913*/ GIMT_Encode4(1502671), // Rule ID 17823 //
     /* 1502594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1502605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1502608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1502614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502633 */     // MIs[0] round
     /* 1502633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502636 */     // MIs[0] policy
     /* 1502636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32),
     /* 1502649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502670 */     // GIR_Coverage, 17823,
     /* 1502670 */     GIR_EraseRootFromParent_Done,
     /* 1502671 */   // Label 20913: @1502671
     /* 1502671 */   GIM_Try, /*On fail goto*//*Label 20914*/ GIMT_Encode4(1502753), // Rule ID 17826 //
     /* 1502676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1502679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502715 */     // MIs[0] round
     /* 1502715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502718 */     // MIs[0] policy
     /* 1502718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502728 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1502731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502752 */     // GIR_Coverage, 17826,
     /* 1502752 */     GIR_EraseRootFromParent_Done,
     /* 1502753 */   // Label 20914: @1502753
     /* 1502753 */   GIM_Try, /*On fail goto*//*Label 20915*/ GIMT_Encode4(1502835), // Rule ID 17827 //
     /* 1502758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1502761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1502769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1502772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1502775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1502778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1502793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502797 */     // MIs[0] round
     /* 1502797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502800 */     // MIs[0] policy
     /* 1502800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502810 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11172:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16),
     /* 1502813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1502831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502834 */     // GIR_Coverage, 17827,
     /* 1502834 */     GIR_EraseRootFromParent_Done,
     /* 1502835 */   // Label 20915: @1502835
     /* 1502835 */   GIM_Try, /*On fail goto*//*Label 20916*/ GIMT_Encode4(1502917), // Rule ID 17830 //
     /* 1502840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1502843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1502863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502879 */     // MIs[0] round
     /* 1502879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502882 */     // MIs[0] policy
     /* 1502882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1502892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1502895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502916 */     // GIR_Coverage, 17830,
     /* 1502916 */     GIR_EraseRootFromParent_Done,
     /* 1502917 */   // Label 20916: @1502917
     /* 1502917 */   GIM_Try, /*On fail goto*//*Label 20917*/ GIMT_Encode4(1502999), // Rule ID 17831 //
     /* 1502922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1502925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1502930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1502933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1502936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1502939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1502942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1502945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1502957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1502961 */     // MIs[0] round
     /* 1502961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1502964 */     // MIs[0] policy
     /* 1502964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1502967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1502974 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11172:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1502974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32),
     /* 1502977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1502979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1502981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1502983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1502985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1502987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1502992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1502995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1502997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1502998 */     // GIR_Coverage, 17831,
     /* 1502998 */     GIR_EraseRootFromParent_Done,
     /* 1502999 */   // Label 20917: @1502999
     /* 1502999 */   GIM_Try, /*On fail goto*//*Label 20918*/ GIMT_Encode4(1503081), // Rule ID 17834 //
     /* 1503004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1503007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1503015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1503018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1503024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503043 */     // MIs[0] round
     /* 1503043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503046 */     // MIs[0] policy
     /* 1503046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1503059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503080 */     // GIR_Coverage, 17834,
     /* 1503080 */     GIR_EraseRootFromParent_Done,
     /* 1503081 */   // Label 20918: @1503081
     /* 1503081 */   GIM_Try, /*On fail goto*//*Label 20919*/ GIMT_Encode4(1503163), // Rule ID 17835 //
     /* 1503086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1503089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1503097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1503100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1503103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1503106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1503121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1503125 */     // MIs[0] round
     /* 1503125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503128 */     // MIs[0] policy
     /* 1503128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503138 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11172:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64),
     /* 1503141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1503159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503162 */     // GIR_Coverage, 17835,
     /* 1503162 */     GIR_EraseRootFromParent_Done,
     /* 1503163 */   // Label 20919: @1503163
     /* 1503163 */   GIM_Try, /*On fail goto*//*Label 20920*/ GIMT_Encode4(1503245), // Rule ID 17838 //
     /* 1503168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1503179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1503182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1503188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503207 */     // MIs[0] round
     /* 1503207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503210 */     // MIs[0] policy
     /* 1503210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503220 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1503223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503244 */     // GIR_Coverage, 17838,
     /* 1503244 */     GIR_EraseRootFromParent_Done,
     /* 1503245 */   // Label 20920: @1503245
     /* 1503245 */   GIM_Try, /*On fail goto*//*Label 20921*/ GIMT_Encode4(1503327), // Rule ID 17839 //
     /* 1503250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1503261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1503264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1503270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503289 */     // MIs[0] round
     /* 1503289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503292 */     // MIs[0] policy
     /* 1503292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503302 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16),
     /* 1503305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503326 */     // GIR_Coverage, 17839,
     /* 1503326 */     GIR_EraseRootFromParent_Done,
     /* 1503327 */   // Label 20921: @1503327
     /* 1503327 */   GIM_Try, /*On fail goto*//*Label 20922*/ GIMT_Encode4(1503409), // Rule ID 17842 //
     /* 1503332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503371 */     // MIs[0] round
     /* 1503371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503374 */     // MIs[0] policy
     /* 1503374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503384 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1503387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503408 */     // GIR_Coverage, 17842,
     /* 1503408 */     GIR_EraseRootFromParent_Done,
     /* 1503409 */   // Label 20922: @1503409
     /* 1503409 */   GIM_Try, /*On fail goto*//*Label 20923*/ GIMT_Encode4(1503491), // Rule ID 17843 //
     /* 1503414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1503425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1503428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1503434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503453 */     // MIs[0] round
     /* 1503453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503456 */     // MIs[0] policy
     /* 1503456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503466 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16),
     /* 1503469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503490 */     // GIR_Coverage, 17843,
     /* 1503490 */     GIR_EraseRootFromParent_Done,
     /* 1503491 */   // Label 20923: @1503491
     /* 1503491 */   GIM_Try, /*On fail goto*//*Label 20924*/ GIMT_Encode4(1503573), // Rule ID 17846 //
     /* 1503496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1503499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503535 */     // MIs[0] round
     /* 1503535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503538 */     // MIs[0] policy
     /* 1503538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503548 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1503551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503572 */     // GIR_Coverage, 17846,
     /* 1503572 */     GIR_EraseRootFromParent_Done,
     /* 1503573 */   // Label 20924: @1503573
     /* 1503573 */   GIM_Try, /*On fail goto*//*Label 20925*/ GIMT_Encode4(1503655), // Rule ID 17847 //
     /* 1503578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1503581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1503589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1503592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1503595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1503598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1503613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1503617 */     // MIs[0] round
     /* 1503617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503620 */     // MIs[0] policy
     /* 1503620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503630 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16),
     /* 1503633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1503651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503654 */     // GIR_Coverage, 17847,
     /* 1503654 */     GIR_EraseRootFromParent_Done,
     /* 1503655 */   // Label 20925: @1503655
     /* 1503655 */   GIM_Try, /*On fail goto*//*Label 20926*/ GIMT_Encode4(1503737), // Rule ID 17850 //
     /* 1503660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503699 */     // MIs[0] round
     /* 1503699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503702 */     // MIs[0] policy
     /* 1503702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503712 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1503715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503736 */     // GIR_Coverage, 17850,
     /* 1503736 */     GIR_EraseRootFromParent_Done,
     /* 1503737 */   // Label 20926: @1503737
     /* 1503737 */   GIM_Try, /*On fail goto*//*Label 20927*/ GIMT_Encode4(1503819), // Rule ID 17851 //
     /* 1503742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1503753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1503756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1503762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1503781 */     // MIs[0] round
     /* 1503781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503784 */     // MIs[0] policy
     /* 1503784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503794 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32),
     /* 1503797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503818 */     // GIR_Coverage, 17851,
     /* 1503818 */     GIR_EraseRootFromParent_Done,
     /* 1503819 */   // Label 20927: @1503819
     /* 1503819 */   GIM_Try, /*On fail goto*//*Label 20928*/ GIMT_Encode4(1503901), // Rule ID 17854 //
     /* 1503824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1503847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503863 */     // MIs[0] round
     /* 1503863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503866 */     // MIs[0] policy
     /* 1503866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503876 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1503876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1503879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503900 */     // GIR_Coverage, 17854,
     /* 1503900 */     GIR_EraseRootFromParent_Done,
     /* 1503901 */   // Label 20928: @1503901
     /* 1503901 */   GIM_Try, /*On fail goto*//*Label 20929*/ GIMT_Encode4(1503983), // Rule ID 17855 //
     /* 1503906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1503909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1503917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1503920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1503923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1503926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1503929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1503941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1503945 */     // MIs[0] round
     /* 1503945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1503948 */     // MIs[0] policy
     /* 1503948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1503951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1503958 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1503958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32),
     /* 1503961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1503963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1503965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1503967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1503969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1503971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1503976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1503979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1503981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1503982 */     // GIR_Coverage, 17855,
     /* 1503982 */     GIR_EraseRootFromParent_Done,
     /* 1503983 */   // Label 20929: @1503983
     /* 1503983 */   GIM_Try, /*On fail goto*//*Label 20930*/ GIMT_Encode4(1504065), // Rule ID 17858 //
     /* 1503988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1503991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1503996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1503999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1504002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1504008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504027 */     // MIs[0] round
     /* 1504027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504030 */     // MIs[0] policy
     /* 1504030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504040 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1504043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504064 */     // GIR_Coverage, 17858,
     /* 1504064 */     GIR_EraseRootFromParent_Done,
     /* 1504065 */   // Label 20930: @1504065
     /* 1504065 */   GIM_Try, /*On fail goto*//*Label 20931*/ GIMT_Encode4(1504147), // Rule ID 17859 //
     /* 1504070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1504073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1504081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1504084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1504087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1504090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1504105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504109 */     // MIs[0] round
     /* 1504109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504112 */     // MIs[0] policy
     /* 1504112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504122 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32),
     /* 1504125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1504143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504146 */     // GIR_Coverage, 17859,
     /* 1504146 */     GIR_EraseRootFromParent_Done,
     /* 1504147 */   // Label 20931: @1504147
     /* 1504147 */   GIM_Try, /*On fail goto*//*Label 20932*/ GIMT_Encode4(1504229), // Rule ID 17862 //
     /* 1504152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1504163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1504166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1504172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504191 */     // MIs[0] round
     /* 1504191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504194 */     // MIs[0] policy
     /* 1504194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504204 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1504207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504228 */     // GIR_Coverage, 17862,
     /* 1504228 */     GIR_EraseRootFromParent_Done,
     /* 1504229 */   // Label 20932: @1504229
     /* 1504229 */   GIM_Try, /*On fail goto*//*Label 20933*/ GIMT_Encode4(1504311), // Rule ID 17863 //
     /* 1504234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1504245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1504248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1504254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1504273 */     // MIs[0] round
     /* 1504273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504276 */     // MIs[0] policy
     /* 1504276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504286 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11172:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64),
     /* 1504289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504310 */     // GIR_Coverage, 17863,
     /* 1504310 */     GIR_EraseRootFromParent_Done,
     /* 1504311 */   // Label 20933: @1504311
     /* 1504311 */   GIM_Try, /*On fail goto*//*Label 20934*/ GIMT_Encode4(1504393), // Rule ID 17866 //
     /* 1504316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504355 */     // MIs[0] round
     /* 1504355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504358 */     // MIs[0] policy
     /* 1504358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504368 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1504371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504392 */     // GIR_Coverage, 17866,
     /* 1504392 */     GIR_EraseRootFromParent_Done,
     /* 1504393 */   // Label 20934: @1504393
     /* 1504393 */   GIM_Try, /*On fail goto*//*Label 20935*/ GIMT_Encode4(1504475), // Rule ID 17867 //
     /* 1504398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1504409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1504412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1504418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1504437 */     // MIs[0] round
     /* 1504437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504440 */     // MIs[0] policy
     /* 1504440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504450 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11172:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64),
     /* 1504453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504474 */     // GIR_Coverage, 17867,
     /* 1504474 */     GIR_EraseRootFromParent_Done,
     /* 1504475 */   // Label 20935: @1504475
     /* 1504475 */   GIM_Try, /*On fail goto*//*Label 20936*/ GIMT_Encode4(1504557), // Rule ID 17870 //
     /* 1504480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1504483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504519 */     // MIs[0] round
     /* 1504519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504522 */     // MIs[0] policy
     /* 1504522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504532 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1504535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504556 */     // GIR_Coverage, 17870,
     /* 1504556 */     GIR_EraseRootFromParent_Done,
     /* 1504557 */   // Label 20936: @1504557
     /* 1504557 */   GIM_Try, /*On fail goto*//*Label 20937*/ GIMT_Encode4(1504639), // Rule ID 17871 //
     /* 1504562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1504565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc),
     /* 1504570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1504573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1504576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1504579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1504582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1504597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1504601 */     // MIs[0] round
     /* 1504601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504604 */     // MIs[0] policy
     /* 1504604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11172:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64),
     /* 1504617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1504635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504638 */     // GIR_Coverage, 17871,
     /* 1504638 */     GIR_EraseRootFromParent_Done,
     /* 1504639 */   // Label 20937: @1504639
     /* 1504639 */   GIM_Try, /*On fail goto*//*Label 20938*/ GIMT_Encode4(1504721), // Rule ID 17874 //
     /* 1504644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1504652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504683 */     // MIs[0] round
     /* 1504683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504686 */     // MIs[0] policy
     /* 1504686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504696 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1504699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504720 */     // GIR_Coverage, 17874,
     /* 1504720 */     GIR_EraseRootFromParent_Done,
     /* 1504721 */   // Label 20938: @1504721
     /* 1504721 */   GIM_Try, /*On fail goto*//*Label 20939*/ GIMT_Encode4(1504803), // Rule ID 17875 //
     /* 1504726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1504734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1504737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1504740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1504743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1504746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504765 */     // MIs[0] round
     /* 1504765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504768 */     // MIs[0] policy
     /* 1504768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504778 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16),
     /* 1504781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504802 */     // GIR_Coverage, 17875,
     /* 1504802 */     GIR_EraseRootFromParent_Done,
     /* 1504803 */   // Label 20939: @1504803
     /* 1504803 */   GIM_Try, /*On fail goto*//*Label 20940*/ GIMT_Encode4(1504885), // Rule ID 17878 //
     /* 1504808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1504811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1504816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504847 */     // MIs[0] round
     /* 1504847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504850 */     // MIs[0] policy
     /* 1504850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504860 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1504860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1504863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504884 */     // GIR_Coverage, 17878,
     /* 1504884 */     GIR_EraseRootFromParent_Done,
     /* 1504885 */   // Label 20940: @1504885
     /* 1504885 */   GIM_Try, /*On fail goto*//*Label 20941*/ GIMT_Encode4(1504967), // Rule ID 17879 //
     /* 1504890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1504893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1504898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1504901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1504904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1504907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1504910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1504913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504929 */     // MIs[0] round
     /* 1504929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1504932 */     // MIs[0] policy
     /* 1504932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1504935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1504942 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1504942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16),
     /* 1504945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1504947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1504949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1504951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1504953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1504955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1504960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1504963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1504965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1504966 */     // GIR_Coverage, 17879,
     /* 1504966 */     GIR_EraseRootFromParent_Done,
     /* 1504967 */   // Label 20941: @1504967
     /* 1504967 */   GIM_Try, /*On fail goto*//*Label 20942*/ GIMT_Encode4(1505049), // Rule ID 17882 //
     /* 1504972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1504975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1504980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1504983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1504986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1504989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1504992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1504995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1504999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505011 */     // MIs[0] round
     /* 1505011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505014 */     // MIs[0] policy
     /* 1505014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505024 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1505027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505048 */     // GIR_Coverage, 17882,
     /* 1505048 */     GIR_EraseRootFromParent_Done,
     /* 1505049 */   // Label 20942: @1505049
     /* 1505049 */   GIM_Try, /*On fail goto*//*Label 20943*/ GIMT_Encode4(1505131), // Rule ID 17883 //
     /* 1505054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1505065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1505068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1505071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1505074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505093 */     // MIs[0] round
     /* 1505093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505096 */     // MIs[0] policy
     /* 1505096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505106 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32),
     /* 1505109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505130 */     // GIR_Coverage, 17883,
     /* 1505130 */     GIR_EraseRootFromParent_Done,
     /* 1505131 */   // Label 20943: @1505131
     /* 1505131 */   GIM_Try, /*On fail goto*//*Label 20944*/ GIMT_Encode4(1505213), // Rule ID 17886 //
     /* 1505136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1505156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505175 */     // MIs[0] round
     /* 1505175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505178 */     // MIs[0] policy
     /* 1505178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505188 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1505191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505212 */     // GIR_Coverage, 17886,
     /* 1505212 */     GIR_EraseRootFromParent_Done,
     /* 1505213 */   // Label 20944: @1505213
     /* 1505213 */   GIM_Try, /*On fail goto*//*Label 20945*/ GIMT_Encode4(1505295), // Rule ID 17887 //
     /* 1505218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1505229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1505232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1505235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1505238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505257 */     // MIs[0] round
     /* 1505257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505260 */     // MIs[0] policy
     /* 1505260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505270 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16),
     /* 1505273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505294 */     // GIR_Coverage, 17887,
     /* 1505294 */     GIR_EraseRootFromParent_Done,
     /* 1505295 */   // Label 20945: @1505295
     /* 1505295 */   GIM_Try, /*On fail goto*//*Label 20946*/ GIMT_Encode4(1505377), // Rule ID 17890 //
     /* 1505300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1505303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505339 */     // MIs[0] round
     /* 1505339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505342 */     // MIs[0] policy
     /* 1505342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505352 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1505355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505376 */     // GIR_Coverage, 17890,
     /* 1505376 */     GIR_EraseRootFromParent_Done,
     /* 1505377 */   // Label 20946: @1505377
     /* 1505377 */   GIM_Try, /*On fail goto*//*Label 20947*/ GIMT_Encode4(1505459), // Rule ID 17891 //
     /* 1505382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1505385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1505393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1505396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1505399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1505402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505421 */     // MIs[0] round
     /* 1505421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505424 */     // MIs[0] policy
     /* 1505424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505434 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32),
     /* 1505437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1505455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505458 */     // GIR_Coverage, 17891,
     /* 1505458 */     GIR_EraseRootFromParent_Done,
     /* 1505459 */   // Label 20947: @1505459
     /* 1505459 */   GIM_Try, /*On fail goto*//*Label 20948*/ GIMT_Encode4(1505541), // Rule ID 17894 //
     /* 1505464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1505467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1505481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505503 */     // MIs[0] round
     /* 1505503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505506 */     // MIs[0] policy
     /* 1505506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1505519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505540 */     // GIR_Coverage, 17894,
     /* 1505540 */     GIR_EraseRootFromParent_Done,
     /* 1505541 */   // Label 20948: @1505541
     /* 1505541 */   GIM_Try, /*On fail goto*//*Label 20949*/ GIMT_Encode4(1505623), // Rule ID 17895 //
     /* 1505546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1505549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1505557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1505560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1505563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1505566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1505585 */     // MIs[0] round
     /* 1505585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505588 */     // MIs[0] policy
     /* 1505588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505598 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64),
     /* 1505601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1505619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505622 */     // GIR_Coverage, 17895,
     /* 1505622 */     GIR_EraseRootFromParent_Done,
     /* 1505623 */   // Label 20949: @1505623
     /* 1505623 */   GIM_Try, /*On fail goto*//*Label 20950*/ GIMT_Encode4(1505705), // Rule ID 17898 //
     /* 1505628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1505645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505667 */     // MIs[0] round
     /* 1505667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505670 */     // MIs[0] policy
     /* 1505670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505680 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1505683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505704 */     // GIR_Coverage, 17898,
     /* 1505704 */     GIR_EraseRootFromParent_Done,
     /* 1505705 */   // Label 20950: @1505705
     /* 1505705 */   GIM_Try, /*On fail goto*//*Label 20951*/ GIMT_Encode4(1505787), // Rule ID 17899 //
     /* 1505710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1505721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1505724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1505727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1505730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1505749 */     // MIs[0] round
     /* 1505749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505752 */     // MIs[0] policy
     /* 1505752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16),
     /* 1505765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505786 */     // GIR_Coverage, 17899,
     /* 1505786 */     GIR_EraseRootFromParent_Done,
     /* 1505787 */   // Label 20951: @1505787
     /* 1505787 */   GIM_Try, /*On fail goto*//*Label 20952*/ GIMT_Encode4(1505869), // Rule ID 17902 //
     /* 1505792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1505809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505831 */     // MIs[0] round
     /* 1505831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505834 */     // MIs[0] policy
     /* 1505834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505844 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1505844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1505847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505868 */     // GIR_Coverage, 17902,
     /* 1505868 */     GIR_EraseRootFromParent_Done,
     /* 1505869 */   // Label 20952: @1505869
     /* 1505869 */   GIM_Try, /*On fail goto*//*Label 20953*/ GIMT_Encode4(1505951), // Rule ID 17903 //
     /* 1505874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1505877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1505885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1505888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1505891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1505894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1505897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1505913 */     // MIs[0] round
     /* 1505913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505916 */     // MIs[0] policy
     /* 1505916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1505919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1505926 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1505926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16),
     /* 1505929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1505931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1505933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1505935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1505937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1505939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1505944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1505947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1505949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1505950 */     // GIR_Coverage, 17903,
     /* 1505950 */     GIR_EraseRootFromParent_Done,
     /* 1505951 */   // Label 20953: @1505951
     /* 1505951 */   GIM_Try, /*On fail goto*//*Label 20954*/ GIMT_Encode4(1506033), // Rule ID 17906 //
     /* 1505956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1505959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1505964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1505967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1505970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1505973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1505976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1505979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1505995 */     // MIs[0] round
     /* 1505995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1505998 */     // MIs[0] policy
     /* 1505998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506008 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1506011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506032 */     // GIR_Coverage, 17906,
     /* 1506032 */     GIR_EraseRootFromParent_Done,
     /* 1506033 */   // Label 20954: @1506033
     /* 1506033 */   GIM_Try, /*On fail goto*//*Label 20955*/ GIMT_Encode4(1506115), // Rule ID 17907 //
     /* 1506038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1506041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1506049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1506052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1506055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1506058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506077 */     // MIs[0] round
     /* 1506077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506080 */     // MIs[0] policy
     /* 1506080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506090 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16),
     /* 1506093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1506111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506114 */     // GIR_Coverage, 17907,
     /* 1506114 */     GIR_EraseRootFromParent_Done,
     /* 1506115 */   // Label 20955: @1506115
     /* 1506115 */   GIM_Try, /*On fail goto*//*Label 20956*/ GIMT_Encode4(1506197), // Rule ID 17910 //
     /* 1506120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1506140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506159 */     // MIs[0] round
     /* 1506159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506162 */     // MIs[0] policy
     /* 1506162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506172 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1506175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506196 */     // GIR_Coverage, 17910,
     /* 1506196 */     GIR_EraseRootFromParent_Done,
     /* 1506197 */   // Label 20956: @1506197
     /* 1506197 */   GIM_Try, /*On fail goto*//*Label 20957*/ GIMT_Encode4(1506279), // Rule ID 17911 //
     /* 1506202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1506213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1506216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1506219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1506222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506241 */     // MIs[0] round
     /* 1506241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506244 */     // MIs[0] policy
     /* 1506244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506254 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32),
     /* 1506257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506278 */     // GIR_Coverage, 17911,
     /* 1506278 */     GIR_EraseRootFromParent_Done,
     /* 1506279 */   // Label 20957: @1506279
     /* 1506279 */   GIM_Try, /*On fail goto*//*Label 20958*/ GIMT_Encode4(1506361), // Rule ID 17914 //
     /* 1506284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1506301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506323 */     // MIs[0] round
     /* 1506323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506326 */     // MIs[0] policy
     /* 1506326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506336 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1506339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506360 */     // GIR_Coverage, 17914,
     /* 1506360 */     GIR_EraseRootFromParent_Done,
     /* 1506361 */   // Label 20958: @1506361
     /* 1506361 */   GIM_Try, /*On fail goto*//*Label 20959*/ GIMT_Encode4(1506443), // Rule ID 17915 //
     /* 1506366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1506377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1506380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1506383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1506386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506405 */     // MIs[0] round
     /* 1506405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506408 */     // MIs[0] policy
     /* 1506408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506418 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32),
     /* 1506421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506442 */     // GIR_Coverage, 17915,
     /* 1506442 */     GIR_EraseRootFromParent_Done,
     /* 1506443 */   // Label 20959: @1506443
     /* 1506443 */   GIM_Try, /*On fail goto*//*Label 20960*/ GIMT_Encode4(1506525), // Rule ID 17918 //
     /* 1506448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1506451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1506465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506487 */     // MIs[0] round
     /* 1506487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506490 */     // MIs[0] policy
     /* 1506490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506500 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1506503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506524 */     // GIR_Coverage, 17918,
     /* 1506524 */     GIR_EraseRootFromParent_Done,
     /* 1506525 */   // Label 20960: @1506525
     /* 1506525 */   GIM_Try, /*On fail goto*//*Label 20961*/ GIMT_Encode4(1506607), // Rule ID 17919 //
     /* 1506530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1506533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1506541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1506544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1506547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1506550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506569 */     // MIs[0] round
     /* 1506569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506572 */     // MIs[0] policy
     /* 1506572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506582 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32),
     /* 1506585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1506603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506606 */     // GIR_Coverage, 17919,
     /* 1506606 */     GIR_EraseRootFromParent_Done,
     /* 1506607 */   // Label 20961: @1506607
     /* 1506607 */   GIM_Try, /*On fail goto*//*Label 20962*/ GIMT_Encode4(1506689), // Rule ID 17922 //
     /* 1506612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1506629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506651 */     // MIs[0] round
     /* 1506651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506654 */     // MIs[0] policy
     /* 1506654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506664 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1506667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506688 */     // GIR_Coverage, 17922,
     /* 1506688 */     GIR_EraseRootFromParent_Done,
     /* 1506689 */   // Label 20962: @1506689
     /* 1506689 */   GIM_Try, /*On fail goto*//*Label 20963*/ GIMT_Encode4(1506771), // Rule ID 17923 //
     /* 1506694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1506705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1506708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1506711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1506714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1506733 */     // MIs[0] round
     /* 1506733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506736 */     // MIs[0] policy
     /* 1506736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64),
     /* 1506749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506770 */     // GIR_Coverage, 17923,
     /* 1506770 */     GIR_EraseRootFromParent_Done,
     /* 1506771 */   // Label 20963: @1506771
     /* 1506771 */   GIM_Try, /*On fail goto*//*Label 20964*/ GIMT_Encode4(1506853), // Rule ID 17926 //
     /* 1506776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1506793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506815 */     // MIs[0] round
     /* 1506815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506818 */     // MIs[0] policy
     /* 1506818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506828 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1506831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506852 */     // GIR_Coverage, 17926,
     /* 1506852 */     GIR_EraseRootFromParent_Done,
     /* 1506853 */   // Label 20964: @1506853
     /* 1506853 */   GIM_Try, /*On fail goto*//*Label 20965*/ GIMT_Encode4(1506935), // Rule ID 17927 //
     /* 1506858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1506861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1506869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1506872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1506875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1506878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1506881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1506897 */     // MIs[0] round
     /* 1506897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506900 */     // MIs[0] policy
     /* 1506900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506910 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1506910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64),
     /* 1506913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1506919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1506921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1506923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1506928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1506931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1506933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1506934 */     // GIR_Coverage, 17927,
     /* 1506934 */     GIR_EraseRootFromParent_Done,
     /* 1506935 */   // Label 20965: @1506935
     /* 1506935 */   GIM_Try, /*On fail goto*//*Label 20966*/ GIMT_Encode4(1507017), // Rule ID 17930 //
     /* 1506940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1506943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1506948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1506951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1506954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1506957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1506960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1506963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1506979 */     // MIs[0] round
     /* 1506979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1506982 */     // MIs[0] policy
     /* 1506982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1506985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1506992 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1506992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1506995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1506997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1506999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507016 */     // GIR_Coverage, 17930,
     /* 1507016 */     GIR_EraseRootFromParent_Done,
     /* 1507017 */   // Label 20966: @1507017
     /* 1507017 */   GIM_Try, /*On fail goto*//*Label 20967*/ GIMT_Encode4(1507099), // Rule ID 17931 //
     /* 1507022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1507025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1507033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1507036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1507039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1507042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1507061 */     // MIs[0] round
     /* 1507061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507064 */     // MIs[0] policy
     /* 1507064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507074 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64),
     /* 1507077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507098 */     // GIR_Coverage, 17931,
     /* 1507098 */     GIR_EraseRootFromParent_Done,
     /* 1507099 */   // Label 20967: @1507099
     /* 1507099 */   GIM_Try, /*On fail goto*//*Label 20968*/ GIMT_Encode4(1507181), // Rule ID 17934 //
     /* 1507104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1507115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1507118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1507124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507143 */     // MIs[0] round
     /* 1507143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507146 */     // MIs[0] policy
     /* 1507146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507156 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1507159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507180 */     // GIR_Coverage, 17934,
     /* 1507180 */     GIR_EraseRootFromParent_Done,
     /* 1507181 */   // Label 20968: @1507181
     /* 1507181 */   GIM_Try, /*On fail goto*//*Label 20969*/ GIMT_Encode4(1507263), // Rule ID 17935 //
     /* 1507186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1507197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1507200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1507206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507225 */     // MIs[0] round
     /* 1507225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507228 */     // MIs[0] policy
     /* 1507228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507238 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16),
     /* 1507241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507262 */     // GIR_Coverage, 17935,
     /* 1507262 */     GIR_EraseRootFromParent_Done,
     /* 1507263 */   // Label 20969: @1507263
     /* 1507263 */   GIM_Try, /*On fail goto*//*Label 20970*/ GIMT_Encode4(1507345), // Rule ID 17938 //
     /* 1507268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507307 */     // MIs[0] round
     /* 1507307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507310 */     // MIs[0] policy
     /* 1507310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507320 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1507323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507344 */     // GIR_Coverage, 17938,
     /* 1507344 */     GIR_EraseRootFromParent_Done,
     /* 1507345 */   // Label 20970: @1507345
     /* 1507345 */   GIM_Try, /*On fail goto*//*Label 20971*/ GIMT_Encode4(1507427), // Rule ID 17939 //
     /* 1507350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1507361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1507364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1507370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507389 */     // MIs[0] round
     /* 1507389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507392 */     // MIs[0] policy
     /* 1507392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507402 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16),
     /* 1507405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507426 */     // GIR_Coverage, 17939,
     /* 1507426 */     GIR_EraseRootFromParent_Done,
     /* 1507427 */   // Label 20971: @1507427
     /* 1507427 */   GIM_Try, /*On fail goto*//*Label 20972*/ GIMT_Encode4(1507509), // Rule ID 17942 //
     /* 1507432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507471 */     // MIs[0] round
     /* 1507471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507474 */     // MIs[0] policy
     /* 1507474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507484 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1507487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507508 */     // GIR_Coverage, 17942,
     /* 1507508 */     GIR_EraseRootFromParent_Done,
     /* 1507509 */   // Label 20972: @1507509
     /* 1507509 */   GIM_Try, /*On fail goto*//*Label 20973*/ GIMT_Encode4(1507591), // Rule ID 17943 //
     /* 1507514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1507525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1507528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1507534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507553 */     // MIs[0] round
     /* 1507553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507556 */     // MIs[0] policy
     /* 1507556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507566 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32),
     /* 1507569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507590 */     // GIR_Coverage, 17943,
     /* 1507590 */     GIR_EraseRootFromParent_Done,
     /* 1507591 */   // Label 20973: @1507591
     /* 1507591 */   GIM_Try, /*On fail goto*//*Label 20974*/ GIMT_Encode4(1507673), // Rule ID 17946 //
     /* 1507596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1507599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507635 */     // MIs[0] round
     /* 1507635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507638 */     // MIs[0] policy
     /* 1507638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507648 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1507651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507672 */     // GIR_Coverage, 17946,
     /* 1507672 */     GIR_EraseRootFromParent_Done,
     /* 1507673 */   // Label 20974: @1507673
     /* 1507673 */   GIM_Try, /*On fail goto*//*Label 20975*/ GIMT_Encode4(1507755), // Rule ID 17947 //
     /* 1507678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1507681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1507689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1507692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1507695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1507698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1507713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507717 */     // MIs[0] round
     /* 1507717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507720 */     // MIs[0] policy
     /* 1507720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507730 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11145:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16),
     /* 1507733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1507751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507754 */     // GIR_Coverage, 17947,
     /* 1507754 */     GIR_EraseRootFromParent_Done,
     /* 1507755 */   // Label 20975: @1507755
     /* 1507755 */   GIM_Try, /*On fail goto*//*Label 20976*/ GIMT_Encode4(1507837), // Rule ID 17950 //
     /* 1507760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1507763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507799 */     // MIs[0] round
     /* 1507799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507802 */     // MIs[0] policy
     /* 1507802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507812 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1507815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507836 */     // GIR_Coverage, 17950,
     /* 1507836 */     GIR_EraseRootFromParent_Done,
     /* 1507837 */   // Label 20976: @1507837
     /* 1507837 */   GIM_Try, /*On fail goto*//*Label 20977*/ GIMT_Encode4(1507919), // Rule ID 17951 //
     /* 1507842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1507845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1507853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1507856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1507859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1507862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1507865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1507877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507881 */     // MIs[0] round
     /* 1507881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507884 */     // MIs[0] policy
     /* 1507884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507894 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11145:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1507894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32),
     /* 1507897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1507915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1507918 */     // GIR_Coverage, 17951,
     /* 1507918 */     GIR_EraseRootFromParent_Done,
     /* 1507919 */   // Label 20977: @1507919
     /* 1507919 */   GIM_Try, /*On fail goto*//*Label 20978*/ GIMT_Encode4(1508001), // Rule ID 17954 //
     /* 1507924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1507927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1507932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1507935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1507938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1507941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1507944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1507947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1507959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1507963 */     // MIs[0] round
     /* 1507963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1507966 */     // MIs[0] policy
     /* 1507966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1507969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1507976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1507976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1507979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1507981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1507983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1507985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1507987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1507989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1507994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1507997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1507999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508000 */     // GIR_Coverage, 17954,
     /* 1508000 */     GIR_EraseRootFromParent_Done,
     /* 1508001 */   // Label 20978: @1508001
     /* 1508001 */   GIM_Try, /*On fail goto*//*Label 20979*/ GIMT_Encode4(1508083), // Rule ID 17955 //
     /* 1508006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1508009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1508017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1508020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1508023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1508026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1508041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1508045 */     // MIs[0] round
     /* 1508045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508048 */     // MIs[0] policy
     /* 1508048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11145:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64),
     /* 1508061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1508079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508082 */     // GIR_Coverage, 17955,
     /* 1508082 */     GIR_EraseRootFromParent_Done,
     /* 1508083 */   // Label 20979: @1508083
     /* 1508083 */   GIM_Try, /*On fail goto*//*Label 20980*/ GIMT_Encode4(1508165), // Rule ID 17958 //
     /* 1508088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1508099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1508102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1508108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508127 */     // MIs[0] round
     /* 1508127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508130 */     // MIs[0] policy
     /* 1508130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508140 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1508143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508164 */     // GIR_Coverage, 17958,
     /* 1508164 */     GIR_EraseRootFromParent_Done,
     /* 1508165 */   // Label 20980: @1508165
     /* 1508165 */   GIM_Try, /*On fail goto*//*Label 20981*/ GIMT_Encode4(1508247), // Rule ID 17959 //
     /* 1508170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1508181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1508184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1508190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508209 */     // MIs[0] round
     /* 1508209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508212 */     // MIs[0] policy
     /* 1508212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508222 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16),
     /* 1508225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508246 */     // GIR_Coverage, 17959,
     /* 1508246 */     GIR_EraseRootFromParent_Done,
     /* 1508247 */   // Label 20981: @1508247
     /* 1508247 */   GIM_Try, /*On fail goto*//*Label 20982*/ GIMT_Encode4(1508329), // Rule ID 17962 //
     /* 1508252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508291 */     // MIs[0] round
     /* 1508291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508294 */     // MIs[0] policy
     /* 1508294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508304 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1508307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508328 */     // GIR_Coverage, 17962,
     /* 1508328 */     GIR_EraseRootFromParent_Done,
     /* 1508329 */   // Label 20982: @1508329
     /* 1508329 */   GIM_Try, /*On fail goto*//*Label 20983*/ GIMT_Encode4(1508411), // Rule ID 17963 //
     /* 1508334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1508345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1508348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1508354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508373 */     // MIs[0] round
     /* 1508373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508376 */     // MIs[0] policy
     /* 1508376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508386 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16),
     /* 1508389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508410 */     // GIR_Coverage, 17963,
     /* 1508410 */     GIR_EraseRootFromParent_Done,
     /* 1508411 */   // Label 20983: @1508411
     /* 1508411 */   GIM_Try, /*On fail goto*//*Label 20984*/ GIMT_Encode4(1508493), // Rule ID 17966 //
     /* 1508416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1508419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508455 */     // MIs[0] round
     /* 1508455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508458 */     // MIs[0] policy
     /* 1508458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508468 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1508471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508492 */     // GIR_Coverage, 17966,
     /* 1508492 */     GIR_EraseRootFromParent_Done,
     /* 1508493 */   // Label 20984: @1508493
     /* 1508493 */   GIM_Try, /*On fail goto*//*Label 20985*/ GIMT_Encode4(1508575), // Rule ID 17967 //
     /* 1508498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1508501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1508509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1508512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1508515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1508518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1508533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508537 */     // MIs[0] round
     /* 1508537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508540 */     // MIs[0] policy
     /* 1508540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508550 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16),
     /* 1508553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1508571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508574 */     // GIR_Coverage, 17967,
     /* 1508574 */     GIR_EraseRootFromParent_Done,
     /* 1508575 */   // Label 20985: @1508575
     /* 1508575 */   GIM_Try, /*On fail goto*//*Label 20986*/ GIMT_Encode4(1508657), // Rule ID 17970 //
     /* 1508580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508619 */     // MIs[0] round
     /* 1508619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508622 */     // MIs[0] policy
     /* 1508622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1508635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508656 */     // GIR_Coverage, 17970,
     /* 1508656 */     GIR_EraseRootFromParent_Done,
     /* 1508657 */   // Label 20986: @1508657
     /* 1508657 */   GIM_Try, /*On fail goto*//*Label 20987*/ GIMT_Encode4(1508739), // Rule ID 17971 //
     /* 1508662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1508673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1508676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1508682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1508701 */     // MIs[0] round
     /* 1508701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508704 */     // MIs[0] policy
     /* 1508704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508714 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32),
     /* 1508717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508738 */     // GIR_Coverage, 17971,
     /* 1508738 */     GIR_EraseRootFromParent_Done,
     /* 1508739 */   // Label 20987: @1508739
     /* 1508739 */   GIM_Try, /*On fail goto*//*Label 20988*/ GIMT_Encode4(1508821), // Rule ID 17974 //
     /* 1508744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508783 */     // MIs[0] round
     /* 1508783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508786 */     // MIs[0] policy
     /* 1508786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508796 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1508799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508820 */     // GIR_Coverage, 17974,
     /* 1508820 */     GIR_EraseRootFromParent_Done,
     /* 1508821 */   // Label 20988: @1508821
     /* 1508821 */   GIM_Try, /*On fail goto*//*Label 20989*/ GIMT_Encode4(1508903), // Rule ID 17975 //
     /* 1508826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1508837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1508840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1508846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1508849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1508865 */     // MIs[0] round
     /* 1508865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508868 */     // MIs[0] policy
     /* 1508868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508878 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1508878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32),
     /* 1508881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508902 */     // GIR_Coverage, 17975,
     /* 1508902 */     GIR_EraseRootFromParent_Done,
     /* 1508903 */   // Label 20989: @1508903
     /* 1508903 */   GIM_Try, /*On fail goto*//*Label 20990*/ GIMT_Encode4(1508985), // Rule ID 17978 //
     /* 1508908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1508911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1508919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1508922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1508925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1508928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1508931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1508943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1508947 */     // MIs[0] round
     /* 1508947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1508950 */     // MIs[0] policy
     /* 1508950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1508953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1508960 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1508960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1508963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1508965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1508967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1508969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1508971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1508973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1508978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1508981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1508983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1508984 */     // GIR_Coverage, 17978,
     /* 1508984 */     GIR_EraseRootFromParent_Done,
     /* 1508985 */   // Label 20990: @1508985
     /* 1508985 */   GIM_Try, /*On fail goto*//*Label 20991*/ GIMT_Encode4(1509067), // Rule ID 17979 //
     /* 1508990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1508993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1508998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1509001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1509004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1509007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1509010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1509025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509029 */     // MIs[0] round
     /* 1509029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509032 */     // MIs[0] policy
     /* 1509032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509042 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32),
     /* 1509045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509066 */     // GIR_Coverage, 17979,
     /* 1509066 */     GIR_EraseRootFromParent_Done,
     /* 1509067 */   // Label 20991: @1509067
     /* 1509067 */   GIM_Try, /*On fail goto*//*Label 20992*/ GIMT_Encode4(1509149), // Rule ID 17982 //
     /* 1509072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1509083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1509086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1509092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509111 */     // MIs[0] round
     /* 1509111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509114 */     // MIs[0] policy
     /* 1509114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1509127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509148 */     // GIR_Coverage, 17982,
     /* 1509148 */     GIR_EraseRootFromParent_Done,
     /* 1509149 */   // Label 20992: @1509149
     /* 1509149 */   GIM_Try, /*On fail goto*//*Label 20993*/ GIMT_Encode4(1509231), // Rule ID 17983 //
     /* 1509154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1509165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1509168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1509174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1509193 */     // MIs[0] round
     /* 1509193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509196 */     // MIs[0] policy
     /* 1509196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509206 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11145:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64),
     /* 1509209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509230 */     // GIR_Coverage, 17983,
     /* 1509230 */     GIR_EraseRootFromParent_Done,
     /* 1509231 */   // Label 20993: @1509231
     /* 1509231 */   GIM_Try, /*On fail goto*//*Label 20994*/ GIMT_Encode4(1509313), // Rule ID 17986 //
     /* 1509236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509275 */     // MIs[0] round
     /* 1509275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509278 */     // MIs[0] policy
     /* 1509278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509288 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1509291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509312 */     // GIR_Coverage, 17986,
     /* 1509312 */     GIR_EraseRootFromParent_Done,
     /* 1509313 */   // Label 20994: @1509313
     /* 1509313 */   GIM_Try, /*On fail goto*//*Label 20995*/ GIMT_Encode4(1509395), // Rule ID 17987 //
     /* 1509318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1509329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1509332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1509338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1509357 */     // MIs[0] round
     /* 1509357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509360 */     // MIs[0] policy
     /* 1509360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509370 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11145:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64),
     /* 1509373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509394 */     // GIR_Coverage, 17987,
     /* 1509394 */     GIR_EraseRootFromParent_Done,
     /* 1509395 */   // Label 20995: @1509395
     /* 1509395 */   GIM_Try, /*On fail goto*//*Label 20996*/ GIMT_Encode4(1509477), // Rule ID 17990 //
     /* 1509400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1509403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509439 */     // MIs[0] round
     /* 1509439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509442 */     // MIs[0] policy
     /* 1509442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509452 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1509455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509476 */     // GIR_Coverage, 17990,
     /* 1509476 */     GIR_EraseRootFromParent_Done,
     /* 1509477 */   // Label 20996: @1509477
     /* 1509477 */   GIM_Try, /*On fail goto*//*Label 20997*/ GIMT_Encode4(1509559), // Rule ID 17991 //
     /* 1509482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1509485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac),
     /* 1509490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1509493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1509496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1509499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1509502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1509517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1509521 */     // MIs[0] round
     /* 1509521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509524 */     // MIs[0] policy
     /* 1509524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509534 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11145:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64),
     /* 1509537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1509555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509558 */     // GIR_Coverage, 17991,
     /* 1509558 */     GIR_EraseRootFromParent_Done,
     /* 1509559 */   // Label 20997: @1509559
     /* 1509559 */   GIM_Try, /*On fail goto*//*Label 20998*/ GIMT_Encode4(1509641), // Rule ID 17994 //
     /* 1509564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1509581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509603 */     // MIs[0] round
     /* 1509603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509606 */     // MIs[0] policy
     /* 1509606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509616 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1509619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509640 */     // GIR_Coverage, 17994,
     /* 1509640 */     GIR_EraseRootFromParent_Done,
     /* 1509641 */   // Label 20998: @1509641
     /* 1509641 */   GIM_Try, /*On fail goto*//*Label 20999*/ GIMT_Encode4(1509723), // Rule ID 17995 //
     /* 1509646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1509657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1509660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1509663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1509666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509685 */     // MIs[0] round
     /* 1509685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509688 */     // MIs[0] policy
     /* 1509688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509698 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16),
     /* 1509701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509722 */     // GIR_Coverage, 17995,
     /* 1509722 */     GIR_EraseRootFromParent_Done,
     /* 1509723 */   // Label 20999: @1509723
     /* 1509723 */   GIM_Try, /*On fail goto*//*Label 21000*/ GIMT_Encode4(1509805), // Rule ID 17998 //
     /* 1509728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1509731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1509745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509767 */     // MIs[0] round
     /* 1509767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509770 */     // MIs[0] policy
     /* 1509770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509780 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1509783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509804 */     // GIR_Coverage, 17998,
     /* 1509804 */     GIR_EraseRootFromParent_Done,
     /* 1509805 */   // Label 21000: @1509805
     /* 1509805 */   GIM_Try, /*On fail goto*//*Label 21001*/ GIMT_Encode4(1509887), // Rule ID 17999 //
     /* 1509810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1509813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1509821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1509824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1509827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1509830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509849 */     // MIs[0] round
     /* 1509849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509852 */     // MIs[0] policy
     /* 1509852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509862 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1509862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16),
     /* 1509865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1509883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509886 */     // GIR_Coverage, 17999,
     /* 1509886 */     GIR_EraseRootFromParent_Done,
     /* 1509887 */   // Label 21001: @1509887
     /* 1509887 */   GIM_Try, /*On fail goto*//*Label 21002*/ GIMT_Encode4(1509969), // Rule ID 18002 //
     /* 1509892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1509895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1509909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1509915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1509931 */     // MIs[0] round
     /* 1509931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1509934 */     // MIs[0] policy
     /* 1509934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1509937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1509944 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1509944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1509947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1509949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1509951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1509953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1509955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1509957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1509962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1509965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1509967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1509968 */     // GIR_Coverage, 18002,
     /* 1509968 */     GIR_EraseRootFromParent_Done,
     /* 1509969 */   // Label 21002: @1509969
     /* 1509969 */   GIM_Try, /*On fail goto*//*Label 21003*/ GIMT_Encode4(1510051), // Rule ID 18003 //
     /* 1509974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1509977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1509982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1509985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1509988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1509991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1509994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1509997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510013 */     // MIs[0] round
     /* 1510013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510016 */     // MIs[0] policy
     /* 1510016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510026 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32),
     /* 1510029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510050 */     // GIR_Coverage, 18003,
     /* 1510050 */     GIR_EraseRootFromParent_Done,
     /* 1510051 */   // Label 21003: @1510051
     /* 1510051 */   GIM_Try, /*On fail goto*//*Label 21004*/ GIMT_Encode4(1510133), // Rule ID 18006 //
     /* 1510056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1510067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1510070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1510073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1510076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510095 */     // MIs[0] round
     /* 1510095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510098 */     // MIs[0] policy
     /* 1510098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510108 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1510111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510132 */     // GIR_Coverage, 18006,
     /* 1510132 */     GIR_EraseRootFromParent_Done,
     /* 1510133 */   // Label 21004: @1510133
     /* 1510133 */   GIM_Try, /*On fail goto*//*Label 21005*/ GIMT_Encode4(1510215), // Rule ID 18007 //
     /* 1510138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1510149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1510152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1510155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1510158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510177 */     // MIs[0] round
     /* 1510177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510180 */     // MIs[0] policy
     /* 1510180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16),
     /* 1510193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510214 */     // GIR_Coverage, 18007,
     /* 1510214 */     GIR_EraseRootFromParent_Done,
     /* 1510215 */   // Label 21005: @1510215
     /* 1510215 */   GIM_Try, /*On fail goto*//*Label 21006*/ GIMT_Encode4(1510297), // Rule ID 18010 //
     /* 1510220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1510223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1510231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1510234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1510237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1510240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510259 */     // MIs[0] round
     /* 1510259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510262 */     // MIs[0] policy
     /* 1510262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510272 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1510275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510296 */     // GIR_Coverage, 18010,
     /* 1510296 */     GIR_EraseRootFromParent_Done,
     /* 1510297 */   // Label 21006: @1510297
     /* 1510297 */   GIM_Try, /*On fail goto*//*Label 21007*/ GIMT_Encode4(1510379), // Rule ID 18011 //
     /* 1510302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1510305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1510313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1510316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1510319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1510322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510341 */     // MIs[0] round
     /* 1510341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510344 */     // MIs[0] policy
     /* 1510344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510354 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32),
     /* 1510357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1510375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510378 */     // GIR_Coverage, 18011,
     /* 1510378 */     GIR_EraseRootFromParent_Done,
     /* 1510379 */   // Label 21007: @1510379
     /* 1510379 */   GIM_Try, /*On fail goto*//*Label 21008*/ GIMT_Encode4(1510461), // Rule ID 18014 //
     /* 1510384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1510387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1510401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510423 */     // MIs[0] round
     /* 1510423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510426 */     // MIs[0] policy
     /* 1510426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1510439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510460 */     // GIR_Coverage, 18014,
     /* 1510460 */     GIR_EraseRootFromParent_Done,
     /* 1510461 */   // Label 21008: @1510461
     /* 1510461 */   GIM_Try, /*On fail goto*//*Label 21009*/ GIMT_Encode4(1510543), // Rule ID 18015 //
     /* 1510466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1510469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1510477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1510480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1510483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1510486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1510505 */     // MIs[0] round
     /* 1510505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510508 */     // MIs[0] policy
     /* 1510508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510518 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64),
     /* 1510521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1510539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510542 */     // GIR_Coverage, 18015,
     /* 1510542 */     GIR_EraseRootFromParent_Done,
     /* 1510543 */   // Label 21009: @1510543
     /* 1510543 */   GIM_Try, /*On fail goto*//*Label 21010*/ GIMT_Encode4(1510625), // Rule ID 18018 //
     /* 1510548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1510565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510587 */     // MIs[0] round
     /* 1510587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510590 */     // MIs[0] policy
     /* 1510590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510600 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1510603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510624 */     // GIR_Coverage, 18018,
     /* 1510624 */     GIR_EraseRootFromParent_Done,
     /* 1510625 */   // Label 21010: @1510625
     /* 1510625 */   GIM_Try, /*On fail goto*//*Label 21011*/ GIMT_Encode4(1510707), // Rule ID 18019 //
     /* 1510630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1510641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1510644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1510647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1510650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1510669 */     // MIs[0] round
     /* 1510669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510672 */     // MIs[0] policy
     /* 1510672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510682 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16),
     /* 1510685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510706 */     // GIR_Coverage, 18019,
     /* 1510706 */     GIR_EraseRootFromParent_Done,
     /* 1510707 */   // Label 21011: @1510707
     /* 1510707 */   GIM_Try, /*On fail goto*//*Label 21012*/ GIMT_Encode4(1510789), // Rule ID 18022 //
     /* 1510712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510751 */     // MIs[0] round
     /* 1510751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510754 */     // MIs[0] policy
     /* 1510754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510764 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1510767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510788 */     // GIR_Coverage, 18022,
     /* 1510788 */     GIR_EraseRootFromParent_Done,
     /* 1510789 */   // Label 21012: @1510789
     /* 1510789 */   GIM_Try, /*On fail goto*//*Label 21013*/ GIMT_Encode4(1510871), // Rule ID 18023 //
     /* 1510794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1510805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1510808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1510811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1510814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1510833 */     // MIs[0] round
     /* 1510833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510836 */     // MIs[0] policy
     /* 1510836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510846 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1510846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16),
     /* 1510849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510870 */     // GIR_Coverage, 18023,
     /* 1510870 */     GIR_EraseRootFromParent_Done,
     /* 1510871 */   // Label 21013: @1510871
     /* 1510871 */   GIM_Try, /*On fail goto*//*Label 21014*/ GIMT_Encode4(1510953), // Rule ID 18026 //
     /* 1510876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1510879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1510899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510915 */     // MIs[0] round
     /* 1510915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1510918 */     // MIs[0] policy
     /* 1510918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1510921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1510928 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1510928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1510931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1510933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1510935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1510937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1510939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1510941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1510946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1510949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1510951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1510952 */     // GIR_Coverage, 18026,
     /* 1510952 */     GIR_EraseRootFromParent_Done,
     /* 1510953 */   // Label 21014: @1510953
     /* 1510953 */   GIM_Try, /*On fail goto*//*Label 21015*/ GIMT_Encode4(1511035), // Rule ID 18027 //
     /* 1510958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1510961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1510966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1510969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1510972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1510975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1510978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1510981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1510997 */     // MIs[0] round
     /* 1510997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511000 */     // MIs[0] policy
     /* 1511000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511010 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16),
     /* 1511013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1511031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511034 */     // GIR_Coverage, 18027,
     /* 1511034 */     GIR_EraseRootFromParent_Done,
     /* 1511035 */   // Label 21015: @1511035
     /* 1511035 */   GIM_Try, /*On fail goto*//*Label 21016*/ GIMT_Encode4(1511117), // Rule ID 18030 //
     /* 1511040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1511051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1511054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1511057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1511060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511079 */     // MIs[0] round
     /* 1511079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511082 */     // MIs[0] policy
     /* 1511082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511092 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1511095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511116 */     // GIR_Coverage, 18030,
     /* 1511116 */     GIR_EraseRootFromParent_Done,
     /* 1511117 */   // Label 21016: @1511117
     /* 1511117 */   GIM_Try, /*On fail goto*//*Label 21017*/ GIMT_Encode4(1511199), // Rule ID 18031 //
     /* 1511122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1511133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1511136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1511139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1511142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511161 */     // MIs[0] round
     /* 1511161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511164 */     // MIs[0] policy
     /* 1511164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511174 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32),
     /* 1511177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511198 */     // GIR_Coverage, 18031,
     /* 1511198 */     GIR_EraseRootFromParent_Done,
     /* 1511199 */   // Label 21017: @1511199
     /* 1511199 */   GIM_Try, /*On fail goto*//*Label 21018*/ GIMT_Encode4(1511281), // Rule ID 18034 //
     /* 1511204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1511215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1511218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1511221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1511224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511243 */     // MIs[0] round
     /* 1511243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511246 */     // MIs[0] policy
     /* 1511246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511256 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1511259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511280 */     // GIR_Coverage, 18034,
     /* 1511280 */     GIR_EraseRootFromParent_Done,
     /* 1511281 */   // Label 21018: @1511281
     /* 1511281 */   GIM_Try, /*On fail goto*//*Label 21019*/ GIMT_Encode4(1511363), // Rule ID 18035 //
     /* 1511286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1511297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1511300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1511303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1511306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511325 */     // MIs[0] round
     /* 1511325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511328 */     // MIs[0] policy
     /* 1511328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511338 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32),
     /* 1511341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511362 */     // GIR_Coverage, 18035,
     /* 1511362 */     GIR_EraseRootFromParent_Done,
     /* 1511363 */   // Label 21019: @1511363
     /* 1511363 */   GIM_Try, /*On fail goto*//*Label 21020*/ GIMT_Encode4(1511445), // Rule ID 18038 //
     /* 1511368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1511371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1511385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511407 */     // MIs[0] round
     /* 1511407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511410 */     // MIs[0] policy
     /* 1511410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511420 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1511423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511444 */     // GIR_Coverage, 18038,
     /* 1511444 */     GIR_EraseRootFromParent_Done,
     /* 1511445 */   // Label 21020: @1511445
     /* 1511445 */   GIM_Try, /*On fail goto*//*Label 21021*/ GIMT_Encode4(1511527), // Rule ID 18039 //
     /* 1511450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1511453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1511461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1511464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1511467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1511470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511489 */     // MIs[0] round
     /* 1511489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511492 */     // MIs[0] policy
     /* 1511492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511502 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32),
     /* 1511505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1511523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511526 */     // GIR_Coverage, 18039,
     /* 1511526 */     GIR_EraseRootFromParent_Done,
     /* 1511527 */   // Label 21021: @1511527
     /* 1511527 */   GIM_Try, /*On fail goto*//*Label 21022*/ GIMT_Encode4(1511609), // Rule ID 18042 //
     /* 1511532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1511549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511571 */     // MIs[0] round
     /* 1511571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511574 */     // MIs[0] policy
     /* 1511574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511584 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1511587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511608 */     // GIR_Coverage, 18042,
     /* 1511608 */     GIR_EraseRootFromParent_Done,
     /* 1511609 */   // Label 21022: @1511609
     /* 1511609 */   GIM_Try, /*On fail goto*//*Label 21023*/ GIMT_Encode4(1511691), // Rule ID 18043 //
     /* 1511614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1511625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1511628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1511631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1511634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1511653 */     // MIs[0] round
     /* 1511653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511656 */     // MIs[0] policy
     /* 1511656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64),
     /* 1511669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511690 */     // GIR_Coverage, 18043,
     /* 1511690 */     GIR_EraseRootFromParent_Done,
     /* 1511691 */   // Label 21023: @1511691
     /* 1511691 */   GIM_Try, /*On fail goto*//*Label 21024*/ GIMT_Encode4(1511773), // Rule ID 18046 //
     /* 1511696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511735 */     // MIs[0] round
     /* 1511735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511738 */     // MIs[0] policy
     /* 1511738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511748 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1511751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511772 */     // GIR_Coverage, 18046,
     /* 1511772 */     GIR_EraseRootFromParent_Done,
     /* 1511773 */   // Label 21024: @1511773
     /* 1511773 */   GIM_Try, /*On fail goto*//*Label 21025*/ GIMT_Encode4(1511855), // Rule ID 18047 //
     /* 1511778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1511789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1511792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1511795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1511798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1511817 */     // MIs[0] round
     /* 1511817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511820 */     // MIs[0] policy
     /* 1511820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511830 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64),
     /* 1511833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511854 */     // GIR_Coverage, 18047,
     /* 1511854 */     GIR_EraseRootFromParent_Done,
     /* 1511855 */   // Label 21025: @1511855
     /* 1511855 */   GIM_Try, /*On fail goto*//*Label 21026*/ GIMT_Encode4(1511937), // Rule ID 18050 //
     /* 1511860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1511863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1511883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511899 */     // MIs[0] round
     /* 1511899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511902 */     // MIs[0] policy
     /* 1511902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511912 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1511912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1511915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1511919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1511921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1511923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1511925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1511930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1511933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1511935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1511936 */     // GIR_Coverage, 18050,
     /* 1511936 */     GIR_EraseRootFromParent_Done,
     /* 1511937 */   // Label 21026: @1511937
     /* 1511937 */   GIM_Try, /*On fail goto*//*Label 21027*/ GIMT_Encode4(1512019), // Rule ID 18051 //
     /* 1511942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1511945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1511950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1511953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1511956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1511959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1511962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1511965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1511981 */     // MIs[0] round
     /* 1511981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1511984 */     // MIs[0] policy
     /* 1511984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1511987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1511994 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1511994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64),
     /* 1511997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1511999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512018 */     // GIR_Coverage, 18051,
     /* 1512018 */     GIR_EraseRootFromParent_Done,
     /* 1512019 */   // Label 21027: @1512019
     /* 1512019 */   GIM_Try, /*On fail goto*//*Label 21028*/ GIMT_Encode4(1512101), // Rule ID 18054 //
     /* 1512024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1512035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1512038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512063 */     // MIs[0] round
     /* 1512063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512066 */     // MIs[0] policy
     /* 1512066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512076 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1512079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512100 */     // GIR_Coverage, 18054,
     /* 1512100 */     GIR_EraseRootFromParent_Done,
     /* 1512101 */   // Label 21028: @1512101
     /* 1512101 */   GIM_Try, /*On fail goto*//*Label 21029*/ GIMT_Encode4(1512183), // Rule ID 18055 //
     /* 1512106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1512117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1512120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1512126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512145 */     // MIs[0] round
     /* 1512145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512148 */     // MIs[0] policy
     /* 1512148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512158 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16),
     /* 1512161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512182 */     // GIR_Coverage, 18055,
     /* 1512182 */     GIR_EraseRootFromParent_Done,
     /* 1512183 */   // Label 21029: @1512183
     /* 1512183 */   GIM_Try, /*On fail goto*//*Label 21030*/ GIMT_Encode4(1512265), // Rule ID 18058 //
     /* 1512188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1512199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1512202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1512208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512227 */     // MIs[0] round
     /* 1512227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512230 */     // MIs[0] policy
     /* 1512230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512240 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1512243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512264 */     // GIR_Coverage, 18058,
     /* 1512264 */     GIR_EraseRootFromParent_Done,
     /* 1512265 */   // Label 21030: @1512265
     /* 1512265 */   GIM_Try, /*On fail goto*//*Label 21031*/ GIMT_Encode4(1512347), // Rule ID 18059 //
     /* 1512270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1512281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1512284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1512290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512309 */     // MIs[0] round
     /* 1512309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512312 */     // MIs[0] policy
     /* 1512312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512322 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16),
     /* 1512325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512346 */     // GIR_Coverage, 18059,
     /* 1512346 */     GIR_EraseRootFromParent_Done,
     /* 1512347 */   // Label 21031: @1512347
     /* 1512347 */   GIM_Try, /*On fail goto*//*Label 21032*/ GIMT_Encode4(1512429), // Rule ID 18062 //
     /* 1512352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512391 */     // MIs[0] round
     /* 1512391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512394 */     // MIs[0] policy
     /* 1512394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512404 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1512407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512428 */     // GIR_Coverage, 18062,
     /* 1512428 */     GIR_EraseRootFromParent_Done,
     /* 1512429 */   // Label 21032: @1512429
     /* 1512429 */   GIM_Try, /*On fail goto*//*Label 21033*/ GIMT_Encode4(1512511), // Rule ID 18063 //
     /* 1512434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1512445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1512448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1512454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512473 */     // MIs[0] round
     /* 1512473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512476 */     // MIs[0] policy
     /* 1512476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512486 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32),
     /* 1512489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512510 */     // GIR_Coverage, 18063,
     /* 1512510 */     GIR_EraseRootFromParent_Done,
     /* 1512511 */   // Label 21033: @1512511
     /* 1512511 */   GIM_Try, /*On fail goto*//*Label 21034*/ GIMT_Encode4(1512593), // Rule ID 18066 //
     /* 1512516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1512519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512555 */     // MIs[0] round
     /* 1512555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512558 */     // MIs[0] policy
     /* 1512558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512568 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1512571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512592 */     // GIR_Coverage, 18066,
     /* 1512592 */     GIR_EraseRootFromParent_Done,
     /* 1512593 */   // Label 21034: @1512593
     /* 1512593 */   GIM_Try, /*On fail goto*//*Label 21035*/ GIMT_Encode4(1512675), // Rule ID 18067 //
     /* 1512598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1512601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1512609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1512612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1512615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1512618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1512633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512637 */     // MIs[0] round
     /* 1512637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512640 */     // MIs[0] policy
     /* 1512640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512650 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11176:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16),
     /* 1512653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1512671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512674 */     // GIR_Coverage, 18067,
     /* 1512674 */     GIR_EraseRootFromParent_Done,
     /* 1512675 */   // Label 21035: @1512675
     /* 1512675 */   GIM_Try, /*On fail goto*//*Label 21036*/ GIMT_Encode4(1512757), // Rule ID 18070 //
     /* 1512680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1512683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512719 */     // MIs[0] round
     /* 1512719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512722 */     // MIs[0] policy
     /* 1512722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512732 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1512735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512756 */     // GIR_Coverage, 18070,
     /* 1512756 */     GIR_EraseRootFromParent_Done,
     /* 1512757 */   // Label 21036: @1512757
     /* 1512757 */   GIM_Try, /*On fail goto*//*Label 21037*/ GIMT_Encode4(1512839), // Rule ID 18071 //
     /* 1512762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1512765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1512773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1512776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1512779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1512782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1512797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512801 */     // MIs[0] round
     /* 1512801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512804 */     // MIs[0] policy
     /* 1512804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512814 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11176:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32),
     /* 1512817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1512835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512838 */     // GIR_Coverage, 18071,
     /* 1512838 */     GIR_EraseRootFromParent_Done,
     /* 1512839 */   // Label 21037: @1512839
     /* 1512839 */   GIM_Try, /*On fail goto*//*Label 21038*/ GIMT_Encode4(1512921), // Rule ID 18074 //
     /* 1512844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1512847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1512861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1512867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1512879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512883 */     // MIs[0] round
     /* 1512883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512886 */     // MIs[0] policy
     /* 1512886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1512896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1512899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1512919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1512920 */     // GIR_Coverage, 18074,
     /* 1512920 */     GIR_EraseRootFromParent_Done,
     /* 1512921 */   // Label 21038: @1512921
     /* 1512921 */   GIM_Try, /*On fail goto*//*Label 21039*/ GIMT_Encode4(1513003), // Rule ID 18075 //
     /* 1512926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1512929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1512934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1512937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1512940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1512943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1512946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1512949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1512961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1512965 */     // MIs[0] round
     /* 1512965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1512968 */     // MIs[0] policy
     /* 1512968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1512971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1512978 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11176:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1512978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64),
     /* 1512981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1512983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1512985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1512987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1512989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1512991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1512996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1512999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513002 */     // GIR_Coverage, 18075,
     /* 1513002 */     GIR_EraseRootFromParent_Done,
     /* 1513003 */   // Label 21039: @1513003
     /* 1513003 */   GIM_Try, /*On fail goto*//*Label 21040*/ GIMT_Encode4(1513085), // Rule ID 18078 //
     /* 1513008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1513019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1513022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513047 */     // MIs[0] round
     /* 1513047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513050 */     // MIs[0] policy
     /* 1513050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513060 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1513063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513084 */     // GIR_Coverage, 18078,
     /* 1513084 */     GIR_EraseRootFromParent_Done,
     /* 1513085 */   // Label 21040: @1513085
     /* 1513085 */   GIM_Try, /*On fail goto*//*Label 21041*/ GIMT_Encode4(1513167), // Rule ID 18079 //
     /* 1513090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1513101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1513104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1513110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513129 */     // MIs[0] round
     /* 1513129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513132 */     // MIs[0] policy
     /* 1513132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513142 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16),
     /* 1513145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513166 */     // GIR_Coverage, 18079,
     /* 1513166 */     GIR_EraseRootFromParent_Done,
     /* 1513167 */   // Label 21041: @1513167
     /* 1513167 */   GIM_Try, /*On fail goto*//*Label 21042*/ GIMT_Encode4(1513249), // Rule ID 18082 //
     /* 1513172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1513183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1513186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513211 */     // MIs[0] round
     /* 1513211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513214 */     // MIs[0] policy
     /* 1513214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513224 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1513227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513248 */     // GIR_Coverage, 18082,
     /* 1513248 */     GIR_EraseRootFromParent_Done,
     /* 1513249 */   // Label 21042: @1513249
     /* 1513249 */   GIM_Try, /*On fail goto*//*Label 21043*/ GIMT_Encode4(1513331), // Rule ID 18083 //
     /* 1513254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1513265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1513268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1513274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513293 */     // MIs[0] round
     /* 1513293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513296 */     // MIs[0] policy
     /* 1513296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513306 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16),
     /* 1513309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513330 */     // GIR_Coverage, 18083,
     /* 1513330 */     GIR_EraseRootFromParent_Done,
     /* 1513331 */   // Label 21043: @1513331
     /* 1513331 */   GIM_Try, /*On fail goto*//*Label 21044*/ GIMT_Encode4(1513413), // Rule ID 18086 //
     /* 1513336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1513339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513375 */     // MIs[0] round
     /* 1513375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513378 */     // MIs[0] policy
     /* 1513378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513388 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1513391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513412 */     // GIR_Coverage, 18086,
     /* 1513412 */     GIR_EraseRootFromParent_Done,
     /* 1513413 */   // Label 21044: @1513413
     /* 1513413 */   GIM_Try, /*On fail goto*//*Label 21045*/ GIMT_Encode4(1513495), // Rule ID 18087 //
     /* 1513418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1513421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1513429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1513432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1513435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1513438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1513453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513457 */     // MIs[0] round
     /* 1513457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513460 */     // MIs[0] policy
     /* 1513460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513470 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16),
     /* 1513473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1513491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513494 */     // GIR_Coverage, 18087,
     /* 1513494 */     GIR_EraseRootFromParent_Done,
     /* 1513495 */   // Label 21045: @1513495
     /* 1513495 */   GIM_Try, /*On fail goto*//*Label 21046*/ GIMT_Encode4(1513577), // Rule ID 18090 //
     /* 1513500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513539 */     // MIs[0] round
     /* 1513539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513542 */     // MIs[0] policy
     /* 1513542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513552 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1513555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513576 */     // GIR_Coverage, 18090,
     /* 1513576 */     GIR_EraseRootFromParent_Done,
     /* 1513577 */   // Label 21046: @1513577
     /* 1513577 */   GIM_Try, /*On fail goto*//*Label 21047*/ GIMT_Encode4(1513659), // Rule ID 18091 //
     /* 1513582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1513593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1513596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1513602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1513621 */     // MIs[0] round
     /* 1513621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513624 */     // MIs[0] policy
     /* 1513624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32),
     /* 1513637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513658 */     // GIR_Coverage, 18091,
     /* 1513658 */     GIR_EraseRootFromParent_Done,
     /* 1513659 */   // Label 21047: @1513659
     /* 1513659 */   GIM_Try, /*On fail goto*//*Label 21048*/ GIMT_Encode4(1513741), // Rule ID 18094 //
     /* 1513664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513703 */     // MIs[0] round
     /* 1513703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513706 */     // MIs[0] policy
     /* 1513706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513716 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1513719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513740 */     // GIR_Coverage, 18094,
     /* 1513740 */     GIR_EraseRootFromParent_Done,
     /* 1513741 */   // Label 21048: @1513741
     /* 1513741 */   GIM_Try, /*On fail goto*//*Label 21049*/ GIMT_Encode4(1513823), // Rule ID 18095 //
     /* 1513746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1513757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1513760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1513766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1513785 */     // MIs[0] round
     /* 1513785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513788 */     // MIs[0] policy
     /* 1513788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513798 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32),
     /* 1513801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513822 */     // GIR_Coverage, 18095,
     /* 1513822 */     GIR_EraseRootFromParent_Done,
     /* 1513823 */   // Label 21049: @1513823
     /* 1513823 */   GIM_Try, /*On fail goto*//*Label 21050*/ GIMT_Encode4(1513905), // Rule ID 18098 //
     /* 1513828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1513831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1513851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513867 */     // MIs[0] round
     /* 1513867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513870 */     // MIs[0] policy
     /* 1513870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513880 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1513880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1513883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513904 */     // GIR_Coverage, 18098,
     /* 1513904 */     GIR_EraseRootFromParent_Done,
     /* 1513905 */   // Label 21050: @1513905
     /* 1513905 */   GIM_Try, /*On fail goto*//*Label 21051*/ GIMT_Encode4(1513987), // Rule ID 18099 //
     /* 1513910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1513913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1513918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1513921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1513924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1513927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1513930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1513933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1513945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1513949 */     // MIs[0] round
     /* 1513949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1513952 */     // MIs[0] policy
     /* 1513952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1513955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1513962 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1513962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32),
     /* 1513965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1513967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1513969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1513971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1513973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1513975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1513980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1513983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1513985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1513986 */     // GIR_Coverage, 18099,
     /* 1513986 */     GIR_EraseRootFromParent_Done,
     /* 1513987 */   // Label 21051: @1513987
     /* 1513987 */   GIM_Try, /*On fail goto*//*Label 21052*/ GIMT_Encode4(1514069), // Rule ID 18102 //
     /* 1513992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1513995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1514003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1514006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1514012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514031 */     // MIs[0] round
     /* 1514031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514034 */     // MIs[0] policy
     /* 1514034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514044 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1514047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514068 */     // GIR_Coverage, 18102,
     /* 1514068 */     GIR_EraseRootFromParent_Done,
     /* 1514069 */   // Label 21052: @1514069
     /* 1514069 */   GIM_Try, /*On fail goto*//*Label 21053*/ GIMT_Encode4(1514151), // Rule ID 18103 //
     /* 1514074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1514085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1514088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1514094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1514113 */     // MIs[0] round
     /* 1514113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514116 */     // MIs[0] policy
     /* 1514116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514126 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11176:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64),
     /* 1514129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514150 */     // GIR_Coverage, 18103,
     /* 1514150 */     GIR_EraseRootFromParent_Done,
     /* 1514151 */   // Label 21053: @1514151
     /* 1514151 */   GIM_Try, /*On fail goto*//*Label 21054*/ GIMT_Encode4(1514233), // Rule ID 18106 //
     /* 1514156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1514167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1514170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1514176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514195 */     // MIs[0] round
     /* 1514195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514198 */     // MIs[0] policy
     /* 1514198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514208 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1514211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514232 */     // GIR_Coverage, 18106,
     /* 1514232 */     GIR_EraseRootFromParent_Done,
     /* 1514233 */   // Label 21054: @1514233
     /* 1514233 */   GIM_Try, /*On fail goto*//*Label 21055*/ GIMT_Encode4(1514315), // Rule ID 18107 //
     /* 1514238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1514249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1514252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1514258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1514277 */     // MIs[0] round
     /* 1514277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514280 */     // MIs[0] policy
     /* 1514280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11176:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64),
     /* 1514293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514314 */     // GIR_Coverage, 18107,
     /* 1514314 */     GIR_EraseRootFromParent_Done,
     /* 1514315 */   // Label 21055: @1514315
     /* 1514315 */   GIM_Try, /*On fail goto*//*Label 21056*/ GIMT_Encode4(1514397), // Rule ID 18110 //
     /* 1514320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1514323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514359 */     // MIs[0] round
     /* 1514359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514362 */     // MIs[0] policy
     /* 1514362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514372 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1514375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514396 */     // GIR_Coverage, 18110,
     /* 1514396 */     GIR_EraseRootFromParent_Done,
     /* 1514397 */   // Label 21056: @1514397
     /* 1514397 */   GIM_Try, /*On fail goto*//*Label 21057*/ GIMT_Encode4(1514479), // Rule ID 18111 //
     /* 1514402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1514405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac),
     /* 1514410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1514413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1514416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1514419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1514422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1514437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1514441 */     // MIs[0] round
     /* 1514441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514444 */     // MIs[0] policy
     /* 1514444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514454 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11176:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64),
     /* 1514457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1514475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514478 */     // GIR_Coverage, 18111,
     /* 1514478 */     GIR_EraseRootFromParent_Done,
     /* 1514479 */   // Label 21057: @1514479
     /* 1514479 */   GIM_Try, /*On fail goto*//*Label 21058*/ GIMT_Encode4(1514561), // Rule ID 18114 //
     /* 1514484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1514501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514523 */     // MIs[0] round
     /* 1514523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514526 */     // MIs[0] policy
     /* 1514526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514536 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1514539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514560 */     // GIR_Coverage, 18114,
     /* 1514560 */     GIR_EraseRootFromParent_Done,
     /* 1514561 */   // Label 21058: @1514561
     /* 1514561 */   GIM_Try, /*On fail goto*//*Label 21059*/ GIMT_Encode4(1514643), // Rule ID 18115 //
     /* 1514566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1514577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1514580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1514583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1514586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514605 */     // MIs[0] round
     /* 1514605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514608 */     // MIs[0] policy
     /* 1514608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514618 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 1514621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514642 */     // GIR_Coverage, 18115,
     /* 1514642 */     GIR_EraseRootFromParent_Done,
     /* 1514643 */   // Label 21059: @1514643
     /* 1514643 */   GIM_Try, /*On fail goto*//*Label 21060*/ GIMT_Encode4(1514725), // Rule ID 18118 //
     /* 1514648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1514665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514687 */     // MIs[0] round
     /* 1514687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514690 */     // MIs[0] policy
     /* 1514690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1514703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514724 */     // GIR_Coverage, 18118,
     /* 1514724 */     GIR_EraseRootFromParent_Done,
     /* 1514725 */   // Label 21060: @1514725
     /* 1514725 */   GIM_Try, /*On fail goto*//*Label 21061*/ GIMT_Encode4(1514807), // Rule ID 18119 //
     /* 1514730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1514733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1514741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1514744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1514747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1514750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514769 */     // MIs[0] round
     /* 1514769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514772 */     // MIs[0] policy
     /* 1514772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514782 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 1514785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1514803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514806 */     // GIR_Coverage, 18119,
     /* 1514806 */     GIR_EraseRootFromParent_Done,
     /* 1514807 */   // Label 21061: @1514807
     /* 1514807 */   GIM_Try, /*On fail goto*//*Label 21062*/ GIMT_Encode4(1514889), // Rule ID 18122 //
     /* 1514812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1514815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1514829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514851 */     // MIs[0] round
     /* 1514851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514854 */     // MIs[0] policy
     /* 1514854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1514864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1514867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514888 */     // GIR_Coverage, 18122,
     /* 1514888 */     GIR_EraseRootFromParent_Done,
     /* 1514889 */   // Label 21062: @1514889
     /* 1514889 */   GIM_Try, /*On fail goto*//*Label 21063*/ GIMT_Encode4(1514971), // Rule ID 18123 //
     /* 1514894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1514897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1514905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1514908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1514911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1514914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1514917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1514933 */     // MIs[0] round
     /* 1514933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1514936 */     // MIs[0] policy
     /* 1514936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1514939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1514946 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1514946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 1514949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1514951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1514953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1514955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1514957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1514959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1514964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1514967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1514969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1514970 */     // GIR_Coverage, 18123,
     /* 1514970 */     GIR_EraseRootFromParent_Done,
     /* 1514971 */   // Label 21063: @1514971
     /* 1514971 */   GIM_Try, /*On fail goto*//*Label 21064*/ GIMT_Encode4(1515053), // Rule ID 18126 //
     /* 1514976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1514979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1514984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1514987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1514990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1514993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1514996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1514999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515015 */     // MIs[0] round
     /* 1515015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515018 */     // MIs[0] policy
     /* 1515018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515028 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1515031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515052 */     // GIR_Coverage, 18126,
     /* 1515052 */     GIR_EraseRootFromParent_Done,
     /* 1515053 */   // Label 21064: @1515053
     /* 1515053 */   GIM_Try, /*On fail goto*//*Label 21065*/ GIMT_Encode4(1515135), // Rule ID 18127 //
     /* 1515058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1515069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1515072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1515075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1515078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515097 */     // MIs[0] round
     /* 1515097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515100 */     // MIs[0] policy
     /* 1515100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 1515113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515134 */     // GIR_Coverage, 18127,
     /* 1515134 */     GIR_EraseRootFromParent_Done,
     /* 1515135 */   // Label 21065: @1515135
     /* 1515135 */   GIM_Try, /*On fail goto*//*Label 21066*/ GIMT_Encode4(1515217), // Rule ID 18130 //
     /* 1515140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1515157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1515160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515179 */     // MIs[0] round
     /* 1515179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515182 */     // MIs[0] policy
     /* 1515182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515192 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1515195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515216 */     // GIR_Coverage, 18130,
     /* 1515216 */     GIR_EraseRootFromParent_Done,
     /* 1515217 */   // Label 21066: @1515217
     /* 1515217 */   GIM_Try, /*On fail goto*//*Label 21067*/ GIMT_Encode4(1515299), // Rule ID 18131 //
     /* 1515222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1515225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1515233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1515236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1515239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1515242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515261 */     // MIs[0] round
     /* 1515261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515264 */     // MIs[0] policy
     /* 1515264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515274 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 1515277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1515295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515298 */     // GIR_Coverage, 18131,
     /* 1515298 */     GIR_EraseRootFromParent_Done,
     /* 1515299 */   // Label 21067: @1515299
     /* 1515299 */   GIM_Try, /*On fail goto*//*Label 21068*/ GIMT_Encode4(1515381), // Rule ID 18134 //
     /* 1515304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1515307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1515321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515343 */     // MIs[0] round
     /* 1515343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515346 */     // MIs[0] policy
     /* 1515346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1515359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515380 */     // GIR_Coverage, 18134,
     /* 1515380 */     GIR_EraseRootFromParent_Done,
     /* 1515381 */   // Label 21068: @1515381
     /* 1515381 */   GIM_Try, /*On fail goto*//*Label 21069*/ GIMT_Encode4(1515463), // Rule ID 18135 //
     /* 1515386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1515389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1515397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1515400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1515403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1515406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1515425 */     // MIs[0] round
     /* 1515425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515428 */     // MIs[0] policy
     /* 1515428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515438 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 1515441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1515459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515462 */     // GIR_Coverage, 18135,
     /* 1515462 */     GIR_EraseRootFromParent_Done,
     /* 1515463 */   // Label 21069: @1515463
     /* 1515463 */   GIM_Try, /*On fail goto*//*Label 21070*/ GIMT_Encode4(1515545), // Rule ID 18138 //
     /* 1515468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1515485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515507 */     // MIs[0] round
     /* 1515507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515510 */     // MIs[0] policy
     /* 1515510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1515523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515544 */     // GIR_Coverage, 18138,
     /* 1515544 */     GIR_EraseRootFromParent_Done,
     /* 1515545 */   // Label 21070: @1515545
     /* 1515545 */   GIM_Try, /*On fail goto*//*Label 21071*/ GIMT_Encode4(1515627), // Rule ID 18139 //
     /* 1515550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1515561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1515564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1515567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1515570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515589 */     // MIs[0] round
     /* 1515589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515592 */     // MIs[0] policy
     /* 1515592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515602 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 1515605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515626 */     // GIR_Coverage, 18139,
     /* 1515626 */     GIR_EraseRootFromParent_Done,
     /* 1515627 */   // Label 21071: @1515627
     /* 1515627 */   GIM_Try, /*On fail goto*//*Label 21072*/ GIMT_Encode4(1515709), // Rule ID 18142 //
     /* 1515632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1515649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515671 */     // MIs[0] round
     /* 1515671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515674 */     // MIs[0] policy
     /* 1515674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1515687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515708 */     // GIR_Coverage, 18142,
     /* 1515708 */     GIR_EraseRootFromParent_Done,
     /* 1515709 */   // Label 21072: @1515709
     /* 1515709 */   GIM_Try, /*On fail goto*//*Label 21073*/ GIMT_Encode4(1515791), // Rule ID 18143 //
     /* 1515714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1515725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1515728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1515731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1515734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1515753 */     // MIs[0] round
     /* 1515753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515756 */     // MIs[0] policy
     /* 1515756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515766 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 1515769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515790 */     // GIR_Coverage, 18143,
     /* 1515790 */     GIR_EraseRootFromParent_Done,
     /* 1515791 */   // Label 21073: @1515791
     /* 1515791 */   GIM_Try, /*On fail goto*//*Label 21074*/ GIMT_Encode4(1515873), // Rule ID 18146 //
     /* 1515796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1515799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1515813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515835 */     // MIs[0] round
     /* 1515835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515838 */     // MIs[0] policy
     /* 1515838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515848 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1515848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1515851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515872 */     // GIR_Coverage, 18146,
     /* 1515872 */     GIR_EraseRootFromParent_Done,
     /* 1515873 */   // Label 21074: @1515873
     /* 1515873 */   GIM_Try, /*On fail goto*//*Label 21075*/ GIMT_Encode4(1515955), // Rule ID 18147 //
     /* 1515878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1515881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1515889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1515892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1515895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1515898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1515901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1515917 */     // MIs[0] round
     /* 1515917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1515920 */     // MIs[0] policy
     /* 1515920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1515923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1515930 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1515930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 1515933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1515935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1515937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1515939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1515941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1515943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1515948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1515951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1515953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1515954 */     // GIR_Coverage, 18147,
     /* 1515954 */     GIR_EraseRootFromParent_Done,
     /* 1515955 */   // Label 21075: @1515955
     /* 1515955 */   GIM_Try, /*On fail goto*//*Label 21076*/ GIMT_Encode4(1516037), // Rule ID 18150 //
     /* 1515960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1515963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1515968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1515971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1515974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1515977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1515980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1515983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1515999 */     // MIs[0] round
     /* 1515999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516002 */     // MIs[0] policy
     /* 1516002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1516015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516036 */     // GIR_Coverage, 18150,
     /* 1516036 */     GIR_EraseRootFromParent_Done,
     /* 1516037 */   // Label 21076: @1516037
     /* 1516037 */   GIM_Try, /*On fail goto*//*Label 21077*/ GIMT_Encode4(1516119), // Rule ID 18151 //
     /* 1516042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1516053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1516056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1516059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1516062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516081 */     // MIs[0] round
     /* 1516081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516084 */     // MIs[0] policy
     /* 1516084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 1516097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516118 */     // GIR_Coverage, 18151,
     /* 1516118 */     GIR_EraseRootFromParent_Done,
     /* 1516119 */   // Label 21077: @1516119
     /* 1516119 */   GIM_Try, /*On fail goto*//*Label 21078*/ GIMT_Encode4(1516201), // Rule ID 18154 //
     /* 1516124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1516135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1516138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1516144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516163 */     // MIs[0] round
     /* 1516163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516166 */     // MIs[0] policy
     /* 1516166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1516179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516200 */     // GIR_Coverage, 18154,
     /* 1516200 */     GIR_EraseRootFromParent_Done,
     /* 1516201 */   // Label 21078: @1516201
     /* 1516201 */   GIM_Try, /*On fail goto*//*Label 21079*/ GIMT_Encode4(1516283), // Rule ID 18155 //
     /* 1516206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1516217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1516220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1516223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1516226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516245 */     // MIs[0] round
     /* 1516245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516248 */     // MIs[0] policy
     /* 1516248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 1516261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516282 */     // GIR_Coverage, 18155,
     /* 1516282 */     GIR_EraseRootFromParent_Done,
     /* 1516283 */   // Label 21079: @1516283
     /* 1516283 */   GIM_Try, /*On fail goto*//*Label 21080*/ GIMT_Encode4(1516365), // Rule ID 18158 //
     /* 1516288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1516291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1516305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516327 */     // MIs[0] round
     /* 1516327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516330 */     // MIs[0] policy
     /* 1516330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516340 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1516343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516364 */     // GIR_Coverage, 18158,
     /* 1516364 */     GIR_EraseRootFromParent_Done,
     /* 1516365 */   // Label 21080: @1516365
     /* 1516365 */   GIM_Try, /*On fail goto*//*Label 21081*/ GIMT_Encode4(1516447), // Rule ID 18159 //
     /* 1516370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1516373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1516381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1516384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1516387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1516390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516409 */     // MIs[0] round
     /* 1516409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516412 */     // MIs[0] policy
     /* 1516412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 1516425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1516443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516446 */     // GIR_Coverage, 18159,
     /* 1516446 */     GIR_EraseRootFromParent_Done,
     /* 1516447 */   // Label 21081: @1516447
     /* 1516447 */   GIM_Try, /*On fail goto*//*Label 21082*/ GIMT_Encode4(1516529), // Rule ID 18162 //
     /* 1516452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1516469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516491 */     // MIs[0] round
     /* 1516491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516494 */     // MIs[0] policy
     /* 1516494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1516507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516528 */     // GIR_Coverage, 18162,
     /* 1516528 */     GIR_EraseRootFromParent_Done,
     /* 1516529 */   // Label 21082: @1516529
     /* 1516529 */   GIM_Try, /*On fail goto*//*Label 21083*/ GIMT_Encode4(1516611), // Rule ID 18163 //
     /* 1516534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1516545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1516548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1516551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1516554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1516573 */     // MIs[0] round
     /* 1516573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516576 */     // MIs[0] policy
     /* 1516576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516586 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 1516589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516610 */     // GIR_Coverage, 18163,
     /* 1516610 */     GIR_EraseRootFromParent_Done,
     /* 1516611 */   // Label 21083: @1516611
     /* 1516611 */   GIM_Try, /*On fail goto*//*Label 21084*/ GIMT_Encode4(1516693), // Rule ID 18166 //
     /* 1516616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1516633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516655 */     // MIs[0] round
     /* 1516655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516658 */     // MIs[0] policy
     /* 1516658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1516671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516692 */     // GIR_Coverage, 18166,
     /* 1516692 */     GIR_EraseRootFromParent_Done,
     /* 1516693 */   // Label 21084: @1516693
     /* 1516693 */   GIM_Try, /*On fail goto*//*Label 21085*/ GIMT_Encode4(1516775), // Rule ID 18167 //
     /* 1516698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1516709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1516712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1516715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1516718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1516737 */     // MIs[0] round
     /* 1516737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516740 */     // MIs[0] policy
     /* 1516740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 1516753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516774 */     // GIR_Coverage, 18167,
     /* 1516774 */     GIR_EraseRootFromParent_Done,
     /* 1516775 */   // Label 21085: @1516775
     /* 1516775 */   GIM_Try, /*On fail goto*//*Label 21086*/ GIMT_Encode4(1516857), // Rule ID 18170 //
     /* 1516780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1516783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1516797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516819 */     // MIs[0] round
     /* 1516819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516822 */     // MIs[0] policy
     /* 1516822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1516835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516856 */     // GIR_Coverage, 18170,
     /* 1516856 */     GIR_EraseRootFromParent_Done,
     /* 1516857 */   // Label 21086: @1516857
     /* 1516857 */   GIM_Try, /*On fail goto*//*Label 21087*/ GIMT_Encode4(1516939), // Rule ID 18171 //
     /* 1516862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1516865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1516873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1516876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1516879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1516882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1516885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1516901 */     // MIs[0] round
     /* 1516901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516904 */     // MIs[0] policy
     /* 1516904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516914 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1516914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 1516917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1516919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1516921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1516923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1516925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1516927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1516932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1516935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1516937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1516938 */     // GIR_Coverage, 18171,
     /* 1516938 */     GIR_EraseRootFromParent_Done,
     /* 1516939 */   // Label 21087: @1516939
     /* 1516939 */   GIM_Try, /*On fail goto*//*Label 21088*/ GIMT_Encode4(1517021), // Rule ID 18174 //
     /* 1516944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1516947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1516952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1516955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1516958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1516961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1516964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1516967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1516979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1516983 */     // MIs[0] round
     /* 1516983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1516986 */     // MIs[0] policy
     /* 1516986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1516989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1516996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1516996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1516999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517020 */     // GIR_Coverage, 18174,
     /* 1517020 */     GIR_EraseRootFromParent_Done,
     /* 1517021 */   // Label 21088: @1517021
     /* 1517021 */   GIM_Try, /*On fail goto*//*Label 21089*/ GIMT_Encode4(1517103), // Rule ID 18175 //
     /* 1517026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1517037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1517040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1517046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517065 */     // MIs[0] round
     /* 1517065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517068 */     // MIs[0] policy
     /* 1517068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517078 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16),
     /* 1517081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517102 */     // GIR_Coverage, 18175,
     /* 1517102 */     GIR_EraseRootFromParent_Done,
     /* 1517103 */   // Label 21089: @1517103
     /* 1517103 */   GIM_Try, /*On fail goto*//*Label 21090*/ GIMT_Encode4(1517185), // Rule ID 18178 //
     /* 1517108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1517128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517147 */     // MIs[0] round
     /* 1517147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517150 */     // MIs[0] policy
     /* 1517150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517160 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1517163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517184 */     // GIR_Coverage, 18178,
     /* 1517184 */     GIR_EraseRootFromParent_Done,
     /* 1517185 */   // Label 21090: @1517185
     /* 1517185 */   GIM_Try, /*On fail goto*//*Label 21091*/ GIMT_Encode4(1517267), // Rule ID 18179 //
     /* 1517190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1517201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1517204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1517210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517229 */     // MIs[0] round
     /* 1517229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517232 */     // MIs[0] policy
     /* 1517232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517242 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16),
     /* 1517245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517266 */     // GIR_Coverage, 18179,
     /* 1517266 */     GIR_EraseRootFromParent_Done,
     /* 1517267 */   // Label 21091: @1517267
     /* 1517267 */   GIM_Try, /*On fail goto*//*Label 21092*/ GIMT_Encode4(1517349), // Rule ID 18182 //
     /* 1517272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517311 */     // MIs[0] round
     /* 1517311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517314 */     // MIs[0] policy
     /* 1517314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1517327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517348 */     // GIR_Coverage, 18182,
     /* 1517348 */     GIR_EraseRootFromParent_Done,
     /* 1517349 */   // Label 21092: @1517349
     /* 1517349 */   GIM_Try, /*On fail goto*//*Label 21093*/ GIMT_Encode4(1517431), // Rule ID 18183 //
     /* 1517354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1517365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1517368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1517374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517393 */     // MIs[0] round
     /* 1517393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517396 */     // MIs[0] policy
     /* 1517396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517406 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32),
     /* 1517409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517430 */     // GIR_Coverage, 18183,
     /* 1517430 */     GIR_EraseRootFromParent_Done,
     /* 1517431 */   // Label 21093: @1517431
     /* 1517431 */   GIM_Try, /*On fail goto*//*Label 21094*/ GIMT_Encode4(1517513), // Rule ID 18186 //
     /* 1517436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517475 */     // MIs[0] round
     /* 1517475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517478 */     // MIs[0] policy
     /* 1517478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1517491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517512 */     // GIR_Coverage, 18186,
     /* 1517512 */     GIR_EraseRootFromParent_Done,
     /* 1517513 */   // Label 21094: @1517513
     /* 1517513 */   GIM_Try, /*On fail goto*//*Label 21095*/ GIMT_Encode4(1517595), // Rule ID 18187 //
     /* 1517518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1517521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1517529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1517532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1517538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517557 */     // MIs[0] round
     /* 1517557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517560 */     // MIs[0] policy
     /* 1517560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517570 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11138:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16),
     /* 1517573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1517591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517594 */     // GIR_Coverage, 18187,
     /* 1517594 */     GIR_EraseRootFromParent_Done,
     /* 1517595 */   // Label 21095: @1517595
     /* 1517595 */   GIM_Try, /*On fail goto*//*Label 21096*/ GIMT_Encode4(1517677), // Rule ID 18190 //
     /* 1517600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1517603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517639 */     // MIs[0] round
     /* 1517639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517642 */     // MIs[0] policy
     /* 1517642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1517655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517676 */     // GIR_Coverage, 18190,
     /* 1517676 */     GIR_EraseRootFromParent_Done,
     /* 1517677 */   // Label 21096: @1517677
     /* 1517677 */   GIM_Try, /*On fail goto*//*Label 21097*/ GIMT_Encode4(1517759), // Rule ID 18191 //
     /* 1517682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1517685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1517693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1517696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1517699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1517702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1517717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517721 */     // MIs[0] round
     /* 1517721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517724 */     // MIs[0] policy
     /* 1517724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11138:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32),
     /* 1517737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1517755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517758 */     // GIR_Coverage, 18191,
     /* 1517758 */     GIR_EraseRootFromParent_Done,
     /* 1517759 */   // Label 21097: @1517759
     /* 1517759 */   GIM_Try, /*On fail goto*//*Label 21098*/ GIMT_Encode4(1517841), // Rule ID 18194 //
     /* 1517764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1517767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1517781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1517799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517803 */     // MIs[0] round
     /* 1517803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517806 */     // MIs[0] policy
     /* 1517806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1517819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517840 */     // GIR_Coverage, 18194,
     /* 1517840 */     GIR_EraseRootFromParent_Done,
     /* 1517841 */   // Label 21098: @1517841
     /* 1517841 */   GIM_Try, /*On fail goto*//*Label 21099*/ GIMT_Encode4(1517923), // Rule ID 18195 //
     /* 1517846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1517849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1517857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1517860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1517863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1517866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1517869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1517881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1517885 */     // MIs[0] round
     /* 1517885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517888 */     // MIs[0] policy
     /* 1517888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11138:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1517898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64),
     /* 1517901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1517919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1517921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1517922 */     // GIR_Coverage, 18195,
     /* 1517922 */     GIR_EraseRootFromParent_Done,
     /* 1517923 */   // Label 21099: @1517923
     /* 1517923 */   GIM_Try, /*On fail goto*//*Label 21100*/ GIMT_Encode4(1518005), // Rule ID 18198 //
     /* 1517928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1517931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1517936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1517939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1517942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1517945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1517948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1517951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1517963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1517967 */     // MIs[0] round
     /* 1517967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1517970 */     // MIs[0] policy
     /* 1517970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1517973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1517980 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1517980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1517983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1517985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1517987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1517989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1517991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1517993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1517998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518004 */     // GIR_Coverage, 18198,
     /* 1518004 */     GIR_EraseRootFromParent_Done,
     /* 1518005 */   // Label 21100: @1518005
     /* 1518005 */   GIM_Try, /*On fail goto*//*Label 21101*/ GIMT_Encode4(1518087), // Rule ID 18199 //
     /* 1518010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1518021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1518024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1518030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518049 */     // MIs[0] round
     /* 1518049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518052 */     // MIs[0] policy
     /* 1518052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518062 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16),
     /* 1518065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518086 */     // GIR_Coverage, 18199,
     /* 1518086 */     GIR_EraseRootFromParent_Done,
     /* 1518087 */   // Label 21101: @1518087
     /* 1518087 */   GIM_Try, /*On fail goto*//*Label 21102*/ GIMT_Encode4(1518169), // Rule ID 18202 //
     /* 1518092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1518103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1518106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518131 */     // MIs[0] round
     /* 1518131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518134 */     // MIs[0] policy
     /* 1518134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1518147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518168 */     // GIR_Coverage, 18202,
     /* 1518168 */     GIR_EraseRootFromParent_Done,
     /* 1518169 */   // Label 21102: @1518169
     /* 1518169 */   GIM_Try, /*On fail goto*//*Label 21103*/ GIMT_Encode4(1518251), // Rule ID 18203 //
     /* 1518174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1518185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1518188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1518194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518213 */     // MIs[0] round
     /* 1518213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518216 */     // MIs[0] policy
     /* 1518216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518226 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16),
     /* 1518229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518250 */     // GIR_Coverage, 18203,
     /* 1518250 */     GIR_EraseRootFromParent_Done,
     /* 1518251 */   // Label 21103: @1518251
     /* 1518251 */   GIM_Try, /*On fail goto*//*Label 21104*/ GIMT_Encode4(1518333), // Rule ID 18206 //
     /* 1518256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1518259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518295 */     // MIs[0] round
     /* 1518295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518298 */     // MIs[0] policy
     /* 1518298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518308 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1518311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518332 */     // GIR_Coverage, 18206,
     /* 1518332 */     GIR_EraseRootFromParent_Done,
     /* 1518333 */   // Label 21104: @1518333
     /* 1518333 */   GIM_Try, /*On fail goto*//*Label 21105*/ GIMT_Encode4(1518415), // Rule ID 18207 //
     /* 1518338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1518341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1518349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1518352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1518355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1518358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1518373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518377 */     // MIs[0] round
     /* 1518377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518380 */     // MIs[0] policy
     /* 1518380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518390 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16),
     /* 1518393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1518411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518414 */     // GIR_Coverage, 18207,
     /* 1518414 */     GIR_EraseRootFromParent_Done,
     /* 1518415 */   // Label 21105: @1518415
     /* 1518415 */   GIM_Try, /*On fail goto*//*Label 21106*/ GIMT_Encode4(1518497), // Rule ID 18210 //
     /* 1518420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518459 */     // MIs[0] round
     /* 1518459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518462 */     // MIs[0] policy
     /* 1518462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1518475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518496 */     // GIR_Coverage, 18210,
     /* 1518496 */     GIR_EraseRootFromParent_Done,
     /* 1518497 */   // Label 21106: @1518497
     /* 1518497 */   GIM_Try, /*On fail goto*//*Label 21107*/ GIMT_Encode4(1518579), // Rule ID 18211 //
     /* 1518502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1518513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1518516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1518522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518541 */     // MIs[0] round
     /* 1518541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518544 */     // MIs[0] policy
     /* 1518544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32),
     /* 1518557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518578 */     // GIR_Coverage, 18211,
     /* 1518578 */     GIR_EraseRootFromParent_Done,
     /* 1518579 */   // Label 21107: @1518579
     /* 1518579 */   GIM_Try, /*On fail goto*//*Label 21108*/ GIMT_Encode4(1518661), // Rule ID 18214 //
     /* 1518584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518623 */     // MIs[0] round
     /* 1518623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518626 */     // MIs[0] policy
     /* 1518626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1518639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518660 */     // GIR_Coverage, 18214,
     /* 1518660 */     GIR_EraseRootFromParent_Done,
     /* 1518661 */   // Label 21108: @1518661
     /* 1518661 */   GIM_Try, /*On fail goto*//*Label 21109*/ GIMT_Encode4(1518743), // Rule ID 18215 //
     /* 1518666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1518677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1518680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1518686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1518705 */     // MIs[0] round
     /* 1518705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518708 */     // MIs[0] policy
     /* 1518708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32),
     /* 1518721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518742 */     // GIR_Coverage, 18215,
     /* 1518742 */     GIR_EraseRootFromParent_Done,
     /* 1518743 */   // Label 21109: @1518743
     /* 1518743 */   GIM_Try, /*On fail goto*//*Label 21110*/ GIMT_Encode4(1518825), // Rule ID 18218 //
     /* 1518748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1518751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518787 */     // MIs[0] round
     /* 1518787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518790 */     // MIs[0] policy
     /* 1518790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518800 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1518803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518824 */     // GIR_Coverage, 18218,
     /* 1518824 */     GIR_EraseRootFromParent_Done,
     /* 1518825 */   // Label 21110: @1518825
     /* 1518825 */   GIM_Try, /*On fail goto*//*Label 21111*/ GIMT_Encode4(1518907), // Rule ID 18219 //
     /* 1518830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1518833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1518841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1518844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1518847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1518850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1518853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1518865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1518869 */     // MIs[0] round
     /* 1518869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518872 */     // MIs[0] policy
     /* 1518872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518882 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1518882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32),
     /* 1518885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1518903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518906 */     // GIR_Coverage, 18219,
     /* 1518906 */     GIR_EraseRootFromParent_Done,
     /* 1518907 */   // Label 21111: @1518907
     /* 1518907 */   GIM_Try, /*On fail goto*//*Label 21112*/ GIMT_Encode4(1518989), // Rule ID 18222 //
     /* 1518912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1518915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1518920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1518923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1518926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1518929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1518932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1518935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1518947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1518951 */     // MIs[0] round
     /* 1518951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1518954 */     // MIs[0] policy
     /* 1518954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1518957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1518964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1518964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1518967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1518969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1518971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1518973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1518975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1518977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1518982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1518985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1518987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1518988 */     // GIR_Coverage, 18222,
     /* 1518988 */     GIR_EraseRootFromParent_Done,
     /* 1518989 */   // Label 21112: @1518989
     /* 1518989 */   GIM_Try, /*On fail goto*//*Label 21113*/ GIMT_Encode4(1519071), // Rule ID 18223 //
     /* 1518994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1518997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1519005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1519008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1519014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1519033 */     // MIs[0] round
     /* 1519033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519036 */     // MIs[0] policy
     /* 1519036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519046 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11138:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64),
     /* 1519049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519070 */     // GIR_Coverage, 18223,
     /* 1519070 */     GIR_EraseRootFromParent_Done,
     /* 1519071 */   // Label 21113: @1519071
     /* 1519071 */   GIM_Try, /*On fail goto*//*Label 21114*/ GIMT_Encode4(1519153), // Rule ID 18226 //
     /* 1519076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1519096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519115 */     // MIs[0] round
     /* 1519115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519118 */     // MIs[0] policy
     /* 1519118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1519131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519152 */     // GIR_Coverage, 18226,
     /* 1519152 */     GIR_EraseRootFromParent_Done,
     /* 1519153 */   // Label 21114: @1519153
     /* 1519153 */   GIM_Try, /*On fail goto*//*Label 21115*/ GIMT_Encode4(1519235), // Rule ID 18227 //
     /* 1519158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1519169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1519172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1519178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1519197 */     // MIs[0] round
     /* 1519197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519200 */     // MIs[0] policy
     /* 1519200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519210 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11138:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64),
     /* 1519213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519234 */     // GIR_Coverage, 18227,
     /* 1519234 */     GIR_EraseRootFromParent_Done,
     /* 1519235 */   // Label 21115: @1519235
     /* 1519235 */   GIM_Try, /*On fail goto*//*Label 21116*/ GIMT_Encode4(1519317), // Rule ID 18230 //
     /* 1519240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1519243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519279 */     // MIs[0] round
     /* 1519279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519282 */     // MIs[0] policy
     /* 1519282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519292 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1519295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519316 */     // GIR_Coverage, 18230,
     /* 1519316 */     GIR_EraseRootFromParent_Done,
     /* 1519317 */   // Label 21116: @1519317
     /* 1519317 */   GIM_Try, /*On fail goto*//*Label 21117*/ GIMT_Encode4(1519399), // Rule ID 18231 //
     /* 1519322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1519325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd),
     /* 1519330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1519333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1519336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1519339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1519342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1519357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1519361 */     // MIs[0] round
     /* 1519361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519364 */     // MIs[0] policy
     /* 1519364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11138:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64),
     /* 1519377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1519395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519398 */     // GIR_Coverage, 18231,
     /* 1519398 */     GIR_EraseRootFromParent_Done,
     /* 1519399 */   // Label 21117: @1519399
     /* 1519399 */   GIM_Try, /*On fail goto*//*Label 21118*/ GIMT_Encode4(1519481), // Rule ID 18234 //
     /* 1519404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1519421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519443 */     // MIs[0] round
     /* 1519443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519446 */     // MIs[0] policy
     /* 1519446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519456 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1519459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519480 */     // GIR_Coverage, 18234,
     /* 1519480 */     GIR_EraseRootFromParent_Done,
     /* 1519481 */   // Label 21118: @1519481
     /* 1519481 */   GIM_Try, /*On fail goto*//*Label 21119*/ GIMT_Encode4(1519563), // Rule ID 18235 //
     /* 1519486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1519497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1519500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1519503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1519506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519525 */     // MIs[0] round
     /* 1519525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519528 */     // MIs[0] policy
     /* 1519528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519538 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 1519541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519562 */     // GIR_Coverage, 18235,
     /* 1519562 */     GIR_EraseRootFromParent_Done,
     /* 1519563 */   // Label 21119: @1519563
     /* 1519563 */   GIM_Try, /*On fail goto*//*Label 21120*/ GIMT_Encode4(1519645), // Rule ID 18238 //
     /* 1519568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1519585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519607 */     // MIs[0] round
     /* 1519607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519610 */     // MIs[0] policy
     /* 1519610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519620 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1519623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519644 */     // GIR_Coverage, 18238,
     /* 1519644 */     GIR_EraseRootFromParent_Done,
     /* 1519645 */   // Label 21120: @1519645
     /* 1519645 */   GIM_Try, /*On fail goto*//*Label 21121*/ GIMT_Encode4(1519727), // Rule ID 18239 //
     /* 1519650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1519661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1519664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1519667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1519670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519689 */     // MIs[0] round
     /* 1519689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519692 */     // MIs[0] policy
     /* 1519692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519702 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 1519705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519726 */     // GIR_Coverage, 18239,
     /* 1519726 */     GIR_EraseRootFromParent_Done,
     /* 1519727 */   // Label 21121: @1519727
     /* 1519727 */   GIM_Try, /*On fail goto*//*Label 21122*/ GIMT_Encode4(1519809), // Rule ID 18242 //
     /* 1519732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1519735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1519749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519771 */     // MIs[0] round
     /* 1519771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519774 */     // MIs[0] policy
     /* 1519774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519784 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1519787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519808 */     // GIR_Coverage, 18242,
     /* 1519808 */     GIR_EraseRootFromParent_Done,
     /* 1519809 */   // Label 21122: @1519809
     /* 1519809 */   GIM_Try, /*On fail goto*//*Label 21123*/ GIMT_Encode4(1519891), // Rule ID 18243 //
     /* 1519814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1519817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1519825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1519828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1519831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1519834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1519837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519853 */     // MIs[0] round
     /* 1519853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519856 */     // MIs[0] policy
     /* 1519856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519866 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1519866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 1519869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1519887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519890 */     // GIR_Coverage, 18243,
     /* 1519890 */     GIR_EraseRootFromParent_Done,
     /* 1519891 */   // Label 21123: @1519891
     /* 1519891 */   GIM_Try, /*On fail goto*//*Label 21124*/ GIMT_Encode4(1519973), // Rule ID 18246 //
     /* 1519896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1519899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1519913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1519919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1519935 */     // MIs[0] round
     /* 1519935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1519938 */     // MIs[0] policy
     /* 1519938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1519941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1519948 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1519948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1519951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1519953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1519955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1519957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1519959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1519961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1519966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1519969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1519971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1519972 */     // GIR_Coverage, 18246,
     /* 1519972 */     GIR_EraseRootFromParent_Done,
     /* 1519973 */   // Label 21124: @1519973
     /* 1519973 */   GIM_Try, /*On fail goto*//*Label 21125*/ GIMT_Encode4(1520055), // Rule ID 18247 //
     /* 1519978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1519981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1519986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1519989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1519992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1519995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1519998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520017 */     // MIs[0] round
     /* 1520017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520020 */     // MIs[0] policy
     /* 1520020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 1520033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520054 */     // GIR_Coverage, 18247,
     /* 1520054 */     GIR_EraseRootFromParent_Done,
     /* 1520055 */   // Label 21125: @1520055
     /* 1520055 */   GIM_Try, /*On fail goto*//*Label 21126*/ GIMT_Encode4(1520137), // Rule ID 18250 //
     /* 1520060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1520077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1520080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520099 */     // MIs[0] round
     /* 1520099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520102 */     // MIs[0] policy
     /* 1520102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1520115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520136 */     // GIR_Coverage, 18250,
     /* 1520136 */     GIR_EraseRootFromParent_Done,
     /* 1520137 */   // Label 21126: @1520137
     /* 1520137 */   GIM_Try, /*On fail goto*//*Label 21127*/ GIMT_Encode4(1520219), // Rule ID 18251 //
     /* 1520142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1520153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1520156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1520159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1520162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520181 */     // MIs[0] round
     /* 1520181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520184 */     // MIs[0] policy
     /* 1520184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520194 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 1520197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520218 */     // GIR_Coverage, 18251,
     /* 1520218 */     GIR_EraseRootFromParent_Done,
     /* 1520219 */   // Label 21127: @1520219
     /* 1520219 */   GIM_Try, /*On fail goto*//*Label 21128*/ GIMT_Encode4(1520301), // Rule ID 18254 //
     /* 1520224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1520227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1520235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1520238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1520241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1520244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520263 */     // MIs[0] round
     /* 1520263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520266 */     // MIs[0] policy
     /* 1520266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520276 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1520279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520300 */     // GIR_Coverage, 18254,
     /* 1520300 */     GIR_EraseRootFromParent_Done,
     /* 1520301 */   // Label 21128: @1520301
     /* 1520301 */   GIM_Try, /*On fail goto*//*Label 21129*/ GIMT_Encode4(1520383), // Rule ID 18255 //
     /* 1520306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1520309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1520317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1520320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1520323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1520326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1520345 */     // MIs[0] round
     /* 1520345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520348 */     // MIs[0] policy
     /* 1520348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520358 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 1520361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1520379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520382 */     // GIR_Coverage, 18255,
     /* 1520382 */     GIR_EraseRootFromParent_Done,
     /* 1520383 */   // Label 21129: @1520383
     /* 1520383 */   GIM_Try, /*On fail goto*//*Label 21130*/ GIMT_Encode4(1520465), // Rule ID 18258 //
     /* 1520388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1520405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520427 */     // MIs[0] round
     /* 1520427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520430 */     // MIs[0] policy
     /* 1520430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520440 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1520443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520464 */     // GIR_Coverage, 18258,
     /* 1520464 */     GIR_EraseRootFromParent_Done,
     /* 1520465 */   // Label 21130: @1520465
     /* 1520465 */   GIM_Try, /*On fail goto*//*Label 21131*/ GIMT_Encode4(1520547), // Rule ID 18259 //
     /* 1520470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1520481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1520484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1520487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1520490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520509 */     // MIs[0] round
     /* 1520509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520512 */     // MIs[0] policy
     /* 1520512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520522 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 1520525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520546 */     // GIR_Coverage, 18259,
     /* 1520546 */     GIR_EraseRootFromParent_Done,
     /* 1520547 */   // Label 21131: @1520547
     /* 1520547 */   GIM_Try, /*On fail goto*//*Label 21132*/ GIMT_Encode4(1520629), // Rule ID 18262 //
     /* 1520552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1520569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520591 */     // MIs[0] round
     /* 1520591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520594 */     // MIs[0] policy
     /* 1520594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520604 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1520607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520628 */     // GIR_Coverage, 18262,
     /* 1520628 */     GIR_EraseRootFromParent_Done,
     /* 1520629 */   // Label 21132: @1520629
     /* 1520629 */   GIM_Try, /*On fail goto*//*Label 21133*/ GIMT_Encode4(1520711), // Rule ID 18263 //
     /* 1520634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1520645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1520648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1520651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1520654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1520673 */     // MIs[0] round
     /* 1520673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520676 */     // MIs[0] policy
     /* 1520676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520686 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 1520689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520710 */     // GIR_Coverage, 18263,
     /* 1520710 */     GIR_EraseRootFromParent_Done,
     /* 1520711 */   // Label 21133: @1520711
     /* 1520711 */   GIM_Try, /*On fail goto*//*Label 21134*/ GIMT_Encode4(1520793), // Rule ID 18266 //
     /* 1520716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1520719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1520733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520755 */     // MIs[0] round
     /* 1520755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520758 */     // MIs[0] policy
     /* 1520758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520768 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1520771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520792 */     // GIR_Coverage, 18266,
     /* 1520792 */     GIR_EraseRootFromParent_Done,
     /* 1520793 */   // Label 21134: @1520793
     /* 1520793 */   GIM_Try, /*On fail goto*//*Label 21135*/ GIMT_Encode4(1520875), // Rule ID 18267 //
     /* 1520798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1520801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1520809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1520812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1520815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1520818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1520837 */     // MIs[0] round
     /* 1520837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520840 */     // MIs[0] policy
     /* 1520840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520850 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1520850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 1520853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1520871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520874 */     // GIR_Coverage, 18267,
     /* 1520874 */     GIR_EraseRootFromParent_Done,
     /* 1520875 */   // Label 21135: @1520875
     /* 1520875 */   GIM_Try, /*On fail goto*//*Label 21136*/ GIMT_Encode4(1520957), // Rule ID 18270 //
     /* 1520880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1520883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1520897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1520903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520919 */     // MIs[0] round
     /* 1520919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1520922 */     // MIs[0] policy
     /* 1520922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1520925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1520932 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1520932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1520935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1520937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1520939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1520941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1520943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1520945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1520950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1520953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1520955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1520956 */     // GIR_Coverage, 18270,
     /* 1520956 */     GIR_EraseRootFromParent_Done,
     /* 1520957 */   // Label 21136: @1520957
     /* 1520957 */   GIM_Try, /*On fail goto*//*Label 21137*/ GIMT_Encode4(1521039), // Rule ID 18271 //
     /* 1520962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1520965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1520970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1520973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1520976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1520979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1520982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1520985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1520997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521001 */     // MIs[0] round
     /* 1521001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521004 */     // MIs[0] policy
     /* 1521004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521014 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 1521017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521038 */     // GIR_Coverage, 18271,
     /* 1521038 */     GIR_EraseRootFromParent_Done,
     /* 1521039 */   // Label 21137: @1521039
     /* 1521039 */   GIM_Try, /*On fail goto*//*Label 21138*/ GIMT_Encode4(1521121), // Rule ID 18274 //
     /* 1521044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1521064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521083 */     // MIs[0] round
     /* 1521083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521086 */     // MIs[0] policy
     /* 1521086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521096 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1521099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521120 */     // GIR_Coverage, 18274,
     /* 1521120 */     GIR_EraseRootFromParent_Done,
     /* 1521121 */   // Label 21138: @1521121
     /* 1521121 */   GIM_Try, /*On fail goto*//*Label 21139*/ GIMT_Encode4(1521203), // Rule ID 18275 //
     /* 1521126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1521137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1521140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1521143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1521146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521165 */     // MIs[0] round
     /* 1521165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521168 */     // MIs[0] policy
     /* 1521168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521178 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 1521181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521202 */     // GIR_Coverage, 18275,
     /* 1521202 */     GIR_EraseRootFromParent_Done,
     /* 1521203 */   // Label 21139: @1521203
     /* 1521203 */   GIM_Try, /*On fail goto*//*Label 21140*/ GIMT_Encode4(1521285), // Rule ID 18278 //
     /* 1521208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1521211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1521225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1521228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521247 */     // MIs[0] round
     /* 1521247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521250 */     // MIs[0] policy
     /* 1521250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521260 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1521263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521284 */     // GIR_Coverage, 18278,
     /* 1521284 */     GIR_EraseRootFromParent_Done,
     /* 1521285 */   // Label 21140: @1521285
     /* 1521285 */   GIM_Try, /*On fail goto*//*Label 21141*/ GIMT_Encode4(1521367), // Rule ID 18279 //
     /* 1521290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1521293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1521301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1521304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1521307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1521310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521329 */     // MIs[0] round
     /* 1521329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521332 */     // MIs[0] policy
     /* 1521332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 1521345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1521363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521366 */     // GIR_Coverage, 18279,
     /* 1521366 */     GIR_EraseRootFromParent_Done,
     /* 1521367 */   // Label 21141: @1521367
     /* 1521367 */   GIM_Try, /*On fail goto*//*Label 21142*/ GIMT_Encode4(1521449), // Rule ID 18282 //
     /* 1521372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1521389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521411 */     // MIs[0] round
     /* 1521411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521414 */     // MIs[0] policy
     /* 1521414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521424 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1521427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521448 */     // GIR_Coverage, 18282,
     /* 1521448 */     GIR_EraseRootFromParent_Done,
     /* 1521449 */   // Label 21142: @1521449
     /* 1521449 */   GIM_Try, /*On fail goto*//*Label 21143*/ GIMT_Encode4(1521531), // Rule ID 18283 //
     /* 1521454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1521465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1521468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1521471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1521474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1521493 */     // MIs[0] round
     /* 1521493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521496 */     // MIs[0] policy
     /* 1521496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521506 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 1521509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521530 */     // GIR_Coverage, 18283,
     /* 1521530 */     GIR_EraseRootFromParent_Done,
     /* 1521531 */   // Label 21143: @1521531
     /* 1521531 */   GIM_Try, /*On fail goto*//*Label 21144*/ GIMT_Encode4(1521613), // Rule ID 18286 //
     /* 1521536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1521553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521575 */     // MIs[0] round
     /* 1521575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521578 */     // MIs[0] policy
     /* 1521578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521588 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1521591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521612 */     // GIR_Coverage, 18286,
     /* 1521612 */     GIR_EraseRootFromParent_Done,
     /* 1521613 */   // Label 21144: @1521613
     /* 1521613 */   GIM_Try, /*On fail goto*//*Label 21145*/ GIMT_Encode4(1521695), // Rule ID 18287 //
     /* 1521618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1521629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1521632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1521635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1521638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1521657 */     // MIs[0] round
     /* 1521657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521660 */     // MIs[0] policy
     /* 1521660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521670 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 1521673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521694 */     // GIR_Coverage, 18287,
     /* 1521694 */     GIR_EraseRootFromParent_Done,
     /* 1521695 */   // Label 21145: @1521695
     /* 1521695 */   GIM_Try, /*On fail goto*//*Label 21146*/ GIMT_Encode4(1521777), // Rule ID 18290 //
     /* 1521700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1521703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1521717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521739 */     // MIs[0] round
     /* 1521739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521742 */     // MIs[0] policy
     /* 1521742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521752 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1521755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521776 */     // GIR_Coverage, 18290,
     /* 1521776 */     GIR_EraseRootFromParent_Done,
     /* 1521777 */   // Label 21146: @1521777
     /* 1521777 */   GIM_Try, /*On fail goto*//*Label 21147*/ GIMT_Encode4(1521859), // Rule ID 18291 //
     /* 1521782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1521785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1521793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1521796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1521799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1521802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1521821 */     // MIs[0] round
     /* 1521821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521824 */     // MIs[0] policy
     /* 1521824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521834 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 1521837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1521855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521858 */     // GIR_Coverage, 18291,
     /* 1521858 */     GIR_EraseRootFromParent_Done,
     /* 1521859 */   // Label 21147: @1521859
     /* 1521859 */   GIM_Try, /*On fail goto*//*Label 21148*/ GIMT_Encode4(1521941), // Rule ID 18294 //
     /* 1521864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1521867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1521887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521903 */     // MIs[0] round
     /* 1521903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521906 */     // MIs[0] policy
     /* 1521906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521916 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1521916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1521919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1521921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1521923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1521925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1521927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1521929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1521934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1521937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1521939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1521940 */     // GIR_Coverage, 18294,
     /* 1521940 */     GIR_EraseRootFromParent_Done,
     /* 1521941 */   // Label 21148: @1521941
     /* 1521941 */   GIM_Try, /*On fail goto*//*Label 21149*/ GIMT_Encode4(1522023), // Rule ID 18295 //
     /* 1521946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1521949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1521954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1521957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1521960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1521963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1521966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1521969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1521981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1521985 */     // MIs[0] round
     /* 1521985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1521988 */     // MIs[0] policy
     /* 1521988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1521991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1521998 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1521998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16),
     /* 1522001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522022 */     // GIR_Coverage, 18295,
     /* 1522022 */     GIR_EraseRootFromParent_Done,
     /* 1522023 */   // Label 21149: @1522023
     /* 1522023 */   GIM_Try, /*On fail goto*//*Label 21150*/ GIMT_Encode4(1522105), // Rule ID 18298 //
     /* 1522028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1522048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522067 */     // MIs[0] round
     /* 1522067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522070 */     // MIs[0] policy
     /* 1522070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522080 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1522083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522104 */     // GIR_Coverage, 18298,
     /* 1522104 */     GIR_EraseRootFromParent_Done,
     /* 1522105 */   // Label 21150: @1522105
     /* 1522105 */   GIM_Try, /*On fail goto*//*Label 21151*/ GIMT_Encode4(1522187), // Rule ID 18299 //
     /* 1522110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1522121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1522124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1522130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522149 */     // MIs[0] round
     /* 1522149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522152 */     // MIs[0] policy
     /* 1522152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522162 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16),
     /* 1522165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522186 */     // GIR_Coverage, 18299,
     /* 1522186 */     GIR_EraseRootFromParent_Done,
     /* 1522187 */   // Label 21151: @1522187
     /* 1522187 */   GIM_Try, /*On fail goto*//*Label 21152*/ GIMT_Encode4(1522269), // Rule ID 18302 //
     /* 1522192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1522203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1522206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1522212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522231 */     // MIs[0] round
     /* 1522231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522234 */     // MIs[0] policy
     /* 1522234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522244 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1522247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522268 */     // GIR_Coverage, 18302,
     /* 1522268 */     GIR_EraseRootFromParent_Done,
     /* 1522269 */   // Label 21152: @1522269
     /* 1522269 */   GIM_Try, /*On fail goto*//*Label 21153*/ GIMT_Encode4(1522351), // Rule ID 18303 //
     /* 1522274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1522285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1522288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1522294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522313 */     // MIs[0] round
     /* 1522313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522316 */     // MIs[0] policy
     /* 1522316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522326 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32),
     /* 1522329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522350 */     // GIR_Coverage, 18303,
     /* 1522350 */     GIR_EraseRootFromParent_Done,
     /* 1522351 */   // Label 21153: @1522351
     /* 1522351 */   GIM_Try, /*On fail goto*//*Label 21154*/ GIMT_Encode4(1522433), // Rule ID 18306 //
     /* 1522356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522395 */     // MIs[0] round
     /* 1522395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522398 */     // MIs[0] policy
     /* 1522398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522408 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1522411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522432 */     // GIR_Coverage, 18306,
     /* 1522432 */     GIR_EraseRootFromParent_Done,
     /* 1522433 */   // Label 21154: @1522433
     /* 1522433 */   GIM_Try, /*On fail goto*//*Label 21155*/ GIMT_Encode4(1522515), // Rule ID 18307 //
     /* 1522438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1522449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1522452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1522458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522477 */     // MIs[0] round
     /* 1522477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522480 */     // MIs[0] policy
     /* 1522480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522490 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11174:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16),
     /* 1522493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522514 */     // GIR_Coverage, 18307,
     /* 1522514 */     GIR_EraseRootFromParent_Done,
     /* 1522515 */   // Label 21155: @1522515
     /* 1522515 */   GIM_Try, /*On fail goto*//*Label 21156*/ GIMT_Encode4(1522597), // Rule ID 18310 //
     /* 1522520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1522523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522559 */     // MIs[0] round
     /* 1522559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522562 */     // MIs[0] policy
     /* 1522562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522572 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1522575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522596 */     // GIR_Coverage, 18310,
     /* 1522596 */     GIR_EraseRootFromParent_Done,
     /* 1522597 */   // Label 21156: @1522597
     /* 1522597 */   GIM_Try, /*On fail goto*//*Label 21157*/ GIMT_Encode4(1522679), // Rule ID 18311 //
     /* 1522602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1522605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1522613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1522616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1522619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1522622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1522637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522641 */     // MIs[0] round
     /* 1522641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522644 */     // MIs[0] policy
     /* 1522644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522654 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11174:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32),
     /* 1522657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1522675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522678 */     // GIR_Coverage, 18311,
     /* 1522678 */     GIR_EraseRootFromParent_Done,
     /* 1522679 */   // Label 21157: @1522679
     /* 1522679 */   GIM_Try, /*On fail goto*//*Label 21158*/ GIMT_Encode4(1522761), // Rule ID 18314 //
     /* 1522684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1522687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1522701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1522719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522723 */     // MIs[0] round
     /* 1522723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522726 */     // MIs[0] policy
     /* 1522726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522736 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1522739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522760 */     // GIR_Coverage, 18314,
     /* 1522760 */     GIR_EraseRootFromParent_Done,
     /* 1522761 */   // Label 21158: @1522761
     /* 1522761 */   GIM_Try, /*On fail goto*//*Label 21159*/ GIMT_Encode4(1522843), // Rule ID 18315 //
     /* 1522766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1522769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1522777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1522780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1522783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1522786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1522801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1522805 */     // MIs[0] round
     /* 1522805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522808 */     // MIs[0] policy
     /* 1522808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522818 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11174:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64),
     /* 1522821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1522839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522842 */     // GIR_Coverage, 18315,
     /* 1522842 */     GIR_EraseRootFromParent_Done,
     /* 1522843 */   // Label 21159: @1522843
     /* 1522843 */   GIM_Try, /*On fail goto*//*Label 21160*/ GIMT_Encode4(1522925), // Rule ID 18318 //
     /* 1522848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1522851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1522871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522887 */     // MIs[0] round
     /* 1522887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522890 */     // MIs[0] policy
     /* 1522890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522900 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1522900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1522903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1522918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1522921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1522923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1522924 */     // GIR_Coverage, 18318,
     /* 1522924 */     GIR_EraseRootFromParent_Done,
     /* 1522925 */   // Label 21160: @1522925
     /* 1522925 */   GIM_Try, /*On fail goto*//*Label 21161*/ GIMT_Encode4(1523007), // Rule ID 18319 //
     /* 1522930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1522933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1522938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1522941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1522944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1522947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1522950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1522953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1522965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1522969 */     // MIs[0] round
     /* 1522969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1522972 */     // MIs[0] policy
     /* 1522972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1522975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1522982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1522982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16),
     /* 1522985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1522987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1522989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1522991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1522993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1522995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523006 */     // GIR_Coverage, 18319,
     /* 1523006 */     GIR_EraseRootFromParent_Done,
     /* 1523007 */   // Label 21161: @1523007
     /* 1523007 */   GIM_Try, /*On fail goto*//*Label 21162*/ GIMT_Encode4(1523089), // Rule ID 18322 //
     /* 1523012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1523023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1523026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523051 */     // MIs[0] round
     /* 1523051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523054 */     // MIs[0] policy
     /* 1523054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523064 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1523067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523088 */     // GIR_Coverage, 18322,
     /* 1523088 */     GIR_EraseRootFromParent_Done,
     /* 1523089 */   // Label 21162: @1523089
     /* 1523089 */   GIM_Try, /*On fail goto*//*Label 21163*/ GIMT_Encode4(1523171), // Rule ID 18323 //
     /* 1523094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1523105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1523108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1523114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523133 */     // MIs[0] round
     /* 1523133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523136 */     // MIs[0] policy
     /* 1523136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523146 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16),
     /* 1523149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523170 */     // GIR_Coverage, 18323,
     /* 1523170 */     GIR_EraseRootFromParent_Done,
     /* 1523171 */   // Label 21163: @1523171
     /* 1523171 */   GIM_Try, /*On fail goto*//*Label 21164*/ GIMT_Encode4(1523253), // Rule ID 18326 //
     /* 1523176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1523179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1523187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1523190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1523196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523215 */     // MIs[0] round
     /* 1523215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523218 */     // MIs[0] policy
     /* 1523218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523228 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1523231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523252 */     // GIR_Coverage, 18326,
     /* 1523252 */     GIR_EraseRootFromParent_Done,
     /* 1523253 */   // Label 21164: @1523253
     /* 1523253 */   GIM_Try, /*On fail goto*//*Label 21165*/ GIMT_Encode4(1523335), // Rule ID 18327 //
     /* 1523258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1523261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1523269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1523272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1523275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1523278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1523293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523297 */     // MIs[0] round
     /* 1523297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523300 */     // MIs[0] policy
     /* 1523300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523310 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16),
     /* 1523313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1523331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523334 */     // GIR_Coverage, 18327,
     /* 1523334 */     GIR_EraseRootFromParent_Done,
     /* 1523335 */   // Label 21165: @1523335
     /* 1523335 */   GIM_Try, /*On fail goto*//*Label 21166*/ GIMT_Encode4(1523417), // Rule ID 18330 //
     /* 1523340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523379 */     // MIs[0] round
     /* 1523379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523382 */     // MIs[0] policy
     /* 1523382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523392 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1523395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523416 */     // GIR_Coverage, 18330,
     /* 1523416 */     GIR_EraseRootFromParent_Done,
     /* 1523417 */   // Label 21166: @1523417
     /* 1523417 */   GIM_Try, /*On fail goto*//*Label 21167*/ GIMT_Encode4(1523499), // Rule ID 18331 //
     /* 1523422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1523433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1523436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1523442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523461 */     // MIs[0] round
     /* 1523461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523464 */     // MIs[0] policy
     /* 1523464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523474 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32),
     /* 1523477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523498 */     // GIR_Coverage, 18331,
     /* 1523498 */     GIR_EraseRootFromParent_Done,
     /* 1523499 */   // Label 21167: @1523499
     /* 1523499 */   GIM_Try, /*On fail goto*//*Label 21168*/ GIMT_Encode4(1523581), // Rule ID 18334 //
     /* 1523504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523543 */     // MIs[0] round
     /* 1523543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523546 */     // MIs[0] policy
     /* 1523546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523556 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1523559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523580 */     // GIR_Coverage, 18334,
     /* 1523580 */     GIR_EraseRootFromParent_Done,
     /* 1523581 */   // Label 21168: @1523581
     /* 1523581 */   GIM_Try, /*On fail goto*//*Label 21169*/ GIMT_Encode4(1523663), // Rule ID 18335 //
     /* 1523586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1523597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1523600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1523606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1523625 */     // MIs[0] round
     /* 1523625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523628 */     // MIs[0] policy
     /* 1523628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523638 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32),
     /* 1523641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523662 */     // GIR_Coverage, 18335,
     /* 1523662 */     GIR_EraseRootFromParent_Done,
     /* 1523663 */   // Label 21169: @1523663
     /* 1523663 */   GIM_Try, /*On fail goto*//*Label 21170*/ GIMT_Encode4(1523745), // Rule ID 18338 //
     /* 1523668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1523671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523707 */     // MIs[0] round
     /* 1523707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523710 */     // MIs[0] policy
     /* 1523710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1523723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523744 */     // GIR_Coverage, 18338,
     /* 1523744 */     GIR_EraseRootFromParent_Done,
     /* 1523745 */   // Label 21170: @1523745
     /* 1523745 */   GIM_Try, /*On fail goto*//*Label 21171*/ GIMT_Encode4(1523827), // Rule ID 18339 //
     /* 1523750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1523753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1523761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1523764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1523767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1523770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1523785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1523789 */     // MIs[0] round
     /* 1523789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523792 */     // MIs[0] policy
     /* 1523792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523802 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32),
     /* 1523805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1523823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523826 */     // GIR_Coverage, 18339,
     /* 1523826 */     GIR_EraseRootFromParent_Done,
     /* 1523827 */   // Label 21171: @1523827
     /* 1523827 */   GIM_Try, /*On fail goto*//*Label 21172*/ GIMT_Encode4(1523909), // Rule ID 18342 //
     /* 1523832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1523855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523871 */     // MIs[0] round
     /* 1523871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523874 */     // MIs[0] policy
     /* 1523874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523884 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1523884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1523887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523908 */     // GIR_Coverage, 18342,
     /* 1523908 */     GIR_EraseRootFromParent_Done,
     /* 1523909 */   // Label 21172: @1523909
     /* 1523909 */   GIM_Try, /*On fail goto*//*Label 21173*/ GIMT_Encode4(1523991), // Rule ID 18343 //
     /* 1523914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1523917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1523922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1523925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1523928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1523931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1523934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1523937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1523949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1523953 */     // MIs[0] round
     /* 1523953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1523956 */     // MIs[0] policy
     /* 1523956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1523959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1523966 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11174:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1523966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64),
     /* 1523969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1523971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1523973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1523975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1523977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1523979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1523984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1523987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1523989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1523990 */     // GIR_Coverage, 18343,
     /* 1523990 */     GIR_EraseRootFromParent_Done,
     /* 1523991 */   // Label 21173: @1523991
     /* 1523991 */   GIM_Try, /*On fail goto*//*Label 21174*/ GIMT_Encode4(1524073), // Rule ID 18346 //
     /* 1523996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1523999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1524016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524035 */     // MIs[0] round
     /* 1524035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524038 */     // MIs[0] policy
     /* 1524038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524048 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1524051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524072 */     // GIR_Coverage, 18346,
     /* 1524072 */     GIR_EraseRootFromParent_Done,
     /* 1524073 */   // Label 21174: @1524073
     /* 1524073 */   GIM_Try, /*On fail goto*//*Label 21175*/ GIMT_Encode4(1524155), // Rule ID 18347 //
     /* 1524078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1524089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1524092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1524098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1524117 */     // MIs[0] round
     /* 1524117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524120 */     // MIs[0] policy
     /* 1524120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524130 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11174:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64),
     /* 1524133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524154 */     // GIR_Coverage, 18347,
     /* 1524154 */     GIR_EraseRootFromParent_Done,
     /* 1524155 */   // Label 21175: @1524155
     /* 1524155 */   GIM_Try, /*On fail goto*//*Label 21176*/ GIMT_Encode4(1524237), // Rule ID 18350 //
     /* 1524160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1524163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1524180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524199 */     // MIs[0] round
     /* 1524199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524202 */     // MIs[0] policy
     /* 1524202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524212 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1524215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524236 */     // GIR_Coverage, 18350,
     /* 1524236 */     GIR_EraseRootFromParent_Done,
     /* 1524237 */   // Label 21176: @1524237
     /* 1524237 */   GIM_Try, /*On fail goto*//*Label 21177*/ GIMT_Encode4(1524319), // Rule ID 18351 //
     /* 1524242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1524245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd),
     /* 1524250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1524253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1524256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1524259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1524262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1524277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1524281 */     // MIs[0] round
     /* 1524281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524284 */     // MIs[0] policy
     /* 1524284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524294 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11174:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64),
     /* 1524297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1524315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524318 */     // GIR_Coverage, 18351,
     /* 1524318 */     GIR_EraseRootFromParent_Done,
     /* 1524319 */   // Label 21177: @1524319
     /* 1524319 */   GIM_Try, /*On fail goto*//*Label 21178*/ GIMT_Encode4(1524401), // Rule ID 18354 //
     /* 1524324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1524341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524363 */     // MIs[0] round
     /* 1524363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524366 */     // MIs[0] policy
     /* 1524366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524376 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1524379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524400 */     // GIR_Coverage, 18354,
     /* 1524400 */     GIR_EraseRootFromParent_Done,
     /* 1524401 */   // Label 21178: @1524401
     /* 1524401 */   GIM_Try, /*On fail goto*//*Label 21179*/ GIMT_Encode4(1524483), // Rule ID 18355 //
     /* 1524406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1524417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1524420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1524423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1524426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524445 */     // MIs[0] round
     /* 1524445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524448 */     // MIs[0] policy
     /* 1524448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524458 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 1524461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524482 */     // GIR_Coverage, 18355,
     /* 1524482 */     GIR_EraseRootFromParent_Done,
     /* 1524483 */   // Label 21179: @1524483
     /* 1524483 */   GIM_Try, /*On fail goto*//*Label 21180*/ GIMT_Encode4(1524565), // Rule ID 18358 //
     /* 1524488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1524505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524527 */     // MIs[0] round
     /* 1524527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524530 */     // MIs[0] policy
     /* 1524530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524540 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1524543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524564 */     // GIR_Coverage, 18358,
     /* 1524564 */     GIR_EraseRootFromParent_Done,
     /* 1524565 */   // Label 21180: @1524565
     /* 1524565 */   GIM_Try, /*On fail goto*//*Label 21181*/ GIMT_Encode4(1524647), // Rule ID 18359 //
     /* 1524570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1524581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1524584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1524587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1524590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524609 */     // MIs[0] round
     /* 1524609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524612 */     // MIs[0] policy
     /* 1524612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 1524625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524646 */     // GIR_Coverage, 18359,
     /* 1524646 */     GIR_EraseRootFromParent_Done,
     /* 1524647 */   // Label 21181: @1524647
     /* 1524647 */   GIM_Try, /*On fail goto*//*Label 21182*/ GIMT_Encode4(1524729), // Rule ID 18362 //
     /* 1524652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1524669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524691 */     // MIs[0] round
     /* 1524691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524694 */     // MIs[0] policy
     /* 1524694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1524707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524728 */     // GIR_Coverage, 18362,
     /* 1524728 */     GIR_EraseRootFromParent_Done,
     /* 1524729 */   // Label 21182: @1524729
     /* 1524729 */   GIM_Try, /*On fail goto*//*Label 21183*/ GIMT_Encode4(1524811), // Rule ID 18363 //
     /* 1524734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1524737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1524745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1524748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1524751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1524754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524773 */     // MIs[0] round
     /* 1524773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524776 */     // MIs[0] policy
     /* 1524776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524786 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 1524789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1524807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524810 */     // GIR_Coverage, 18363,
     /* 1524810 */     GIR_EraseRootFromParent_Done,
     /* 1524811 */   // Label 21183: @1524811
     /* 1524811 */   GIM_Try, /*On fail goto*//*Label 21184*/ GIMT_Encode4(1524893), // Rule ID 18366 //
     /* 1524816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1524819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1524833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1524839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524855 */     // MIs[0] round
     /* 1524855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524858 */     // MIs[0] policy
     /* 1524858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524868 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1524868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1524871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524892 */     // GIR_Coverage, 18366,
     /* 1524892 */     GIR_EraseRootFromParent_Done,
     /* 1524893 */   // Label 21184: @1524893
     /* 1524893 */   GIM_Try, /*On fail goto*//*Label 21185*/ GIMT_Encode4(1524975), // Rule ID 18367 //
     /* 1524898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1524901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1524909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1524912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1524915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1524918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1524921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1524937 */     // MIs[0] round
     /* 1524937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1524940 */     // MIs[0] policy
     /* 1524940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1524943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1524950 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1524950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 1524953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1524955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1524957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1524959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1524961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1524963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1524968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1524971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1524973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1524974 */     // GIR_Coverage, 18367,
     /* 1524974 */     GIR_EraseRootFromParent_Done,
     /* 1524975 */   // Label 21185: @1524975
     /* 1524975 */   GIM_Try, /*On fail goto*//*Label 21186*/ GIMT_Encode4(1525057), // Rule ID 18370 //
     /* 1524980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1524983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1524988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1524991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1524994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1524997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1525000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525019 */     // MIs[0] round
     /* 1525019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525022 */     // MIs[0] policy
     /* 1525022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525032 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1525035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525056 */     // GIR_Coverage, 18370,
     /* 1525056 */     GIR_EraseRootFromParent_Done,
     /* 1525057 */   // Label 21186: @1525057
     /* 1525057 */   GIM_Try, /*On fail goto*//*Label 21187*/ GIMT_Encode4(1525139), // Rule ID 18371 //
     /* 1525062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1525073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1525076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1525079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1525082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525101 */     // MIs[0] round
     /* 1525101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525104 */     // MIs[0] policy
     /* 1525104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525114 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 1525117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525138 */     // GIR_Coverage, 18371,
     /* 1525138 */     GIR_EraseRootFromParent_Done,
     /* 1525139 */   // Label 21187: @1525139
     /* 1525139 */   GIM_Try, /*On fail goto*//*Label 21188*/ GIMT_Encode4(1525221), // Rule ID 18374 //
     /* 1525144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1525147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1525155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1525158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1525161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1525164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525183 */     // MIs[0] round
     /* 1525183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525186 */     // MIs[0] policy
     /* 1525186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525196 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1525199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525220 */     // GIR_Coverage, 18374,
     /* 1525220 */     GIR_EraseRootFromParent_Done,
     /* 1525221 */   // Label 21188: @1525221
     /* 1525221 */   GIM_Try, /*On fail goto*//*Label 21189*/ GIMT_Encode4(1525303), // Rule ID 18375 //
     /* 1525226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1525229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1525237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1525240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1525243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1525246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1525265 */     // MIs[0] round
     /* 1525265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525268 */     // MIs[0] policy
     /* 1525268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525278 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 1525281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1525299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525302 */     // GIR_Coverage, 18375,
     /* 1525302 */     GIR_EraseRootFromParent_Done,
     /* 1525303 */   // Label 21189: @1525303
     /* 1525303 */   GIM_Try, /*On fail goto*//*Label 21190*/ GIMT_Encode4(1525385), // Rule ID 18378 //
     /* 1525308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1525325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525347 */     // MIs[0] round
     /* 1525347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525350 */     // MIs[0] policy
     /* 1525350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1525363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525384 */     // GIR_Coverage, 18378,
     /* 1525384 */     GIR_EraseRootFromParent_Done,
     /* 1525385 */   // Label 21190: @1525385
     /* 1525385 */   GIM_Try, /*On fail goto*//*Label 21191*/ GIMT_Encode4(1525467), // Rule ID 18379 //
     /* 1525390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1525401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1525404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1525407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1525410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525429 */     // MIs[0] round
     /* 1525429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525432 */     // MIs[0] policy
     /* 1525432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 1525445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525466 */     // GIR_Coverage, 18379,
     /* 1525466 */     GIR_EraseRootFromParent_Done,
     /* 1525467 */   // Label 21191: @1525467
     /* 1525467 */   GIM_Try, /*On fail goto*//*Label 21192*/ GIMT_Encode4(1525549), // Rule ID 18382 //
     /* 1525472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1525489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525511 */     // MIs[0] round
     /* 1525511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525514 */     // MIs[0] policy
     /* 1525514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525524 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1525527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525548 */     // GIR_Coverage, 18382,
     /* 1525548 */     GIR_EraseRootFromParent_Done,
     /* 1525549 */   // Label 21192: @1525549
     /* 1525549 */   GIM_Try, /*On fail goto*//*Label 21193*/ GIMT_Encode4(1525631), // Rule ID 18383 //
     /* 1525554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1525565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1525568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1525571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1525574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525593 */     // MIs[0] round
     /* 1525593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525596 */     // MIs[0] policy
     /* 1525596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 1525609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525630 */     // GIR_Coverage, 18383,
     /* 1525630 */     GIR_EraseRootFromParent_Done,
     /* 1525631 */   // Label 21193: @1525631
     /* 1525631 */   GIM_Try, /*On fail goto*//*Label 21194*/ GIMT_Encode4(1525713), // Rule ID 18386 //
     /* 1525636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1525639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1525653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525675 */     // MIs[0] round
     /* 1525675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525678 */     // MIs[0] policy
     /* 1525678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525688 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1525691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525712 */     // GIR_Coverage, 18386,
     /* 1525712 */     GIR_EraseRootFromParent_Done,
     /* 1525713 */   // Label 21194: @1525713
     /* 1525713 */   GIM_Try, /*On fail goto*//*Label 21195*/ GIMT_Encode4(1525795), // Rule ID 18387 //
     /* 1525718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1525721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1525729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1525732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1525735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1525738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1525757 */     // MIs[0] round
     /* 1525757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525760 */     // MIs[0] policy
     /* 1525760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525770 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 1525773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1525791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525794 */     // GIR_Coverage, 18387,
     /* 1525794 */     GIR_EraseRootFromParent_Done,
     /* 1525795 */   // Label 21195: @1525795
     /* 1525795 */   GIM_Try, /*On fail goto*//*Label 21196*/ GIMT_Encode4(1525877), // Rule ID 18390 //
     /* 1525800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1525817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525839 */     // MIs[0] round
     /* 1525839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525842 */     // MIs[0] policy
     /* 1525842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525852 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1525852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1525855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525876 */     // GIR_Coverage, 18390,
     /* 1525876 */     GIR_EraseRootFromParent_Done,
     /* 1525877 */   // Label 21196: @1525877
     /* 1525877 */   GIM_Try, /*On fail goto*//*Label 21197*/ GIMT_Encode4(1525959), // Rule ID 18391 //
     /* 1525882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1525885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1525893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1525896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1525899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1525902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1525905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1525921 */     // MIs[0] round
     /* 1525921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1525924 */     // MIs[0] policy
     /* 1525924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1525927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1525934 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1525934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 1525937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1525939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1525941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1525943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1525945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1525947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1525952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1525955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1525957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1525958 */     // GIR_Coverage, 18391,
     /* 1525958 */     GIR_EraseRootFromParent_Done,
     /* 1525959 */   // Label 21197: @1525959
     /* 1525959 */   GIM_Try, /*On fail goto*//*Label 21198*/ GIMT_Encode4(1526041), // Rule ID 18394 //
     /* 1525964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1525967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1525972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1525975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1525978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1525981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1525984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1525987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1525999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526003 */     // MIs[0] round
     /* 1526003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526006 */     // MIs[0] policy
     /* 1526006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526016 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1526019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526040 */     // GIR_Coverage, 18394,
     /* 1526040 */     GIR_EraseRootFromParent_Done,
     /* 1526041 */   // Label 21198: @1526041
     /* 1526041 */   GIM_Try, /*On fail goto*//*Label 21199*/ GIMT_Encode4(1526123), // Rule ID 18395 //
     /* 1526046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1526057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1526060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1526063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1526066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526085 */     // MIs[0] round
     /* 1526085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526088 */     // MIs[0] policy
     /* 1526088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526098 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 1526101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526122 */     // GIR_Coverage, 18395,
     /* 1526122 */     GIR_EraseRootFromParent_Done,
     /* 1526123 */   // Label 21199: @1526123
     /* 1526123 */   GIM_Try, /*On fail goto*//*Label 21200*/ GIMT_Encode4(1526205), // Rule ID 18398 //
     /* 1526128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1526131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1526145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1526148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526167 */     // MIs[0] round
     /* 1526167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526170 */     // MIs[0] policy
     /* 1526170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526180 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1526183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526204 */     // GIR_Coverage, 18398,
     /* 1526204 */     GIR_EraseRootFromParent_Done,
     /* 1526205 */   // Label 21200: @1526205
     /* 1526205 */   GIM_Try, /*On fail goto*//*Label 21201*/ GIMT_Encode4(1526287), // Rule ID 18399 //
     /* 1526210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1526213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1526221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1526224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1526227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1526230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526249 */     // MIs[0] round
     /* 1526249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526252 */     // MIs[0] policy
     /* 1526252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526262 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 1526265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1526283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526286 */     // GIR_Coverage, 18399,
     /* 1526286 */     GIR_EraseRootFromParent_Done,
     /* 1526287 */   // Label 21201: @1526287
     /* 1526287 */   GIM_Try, /*On fail goto*//*Label 21202*/ GIMT_Encode4(1526369), // Rule ID 18402 //
     /* 1526292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1526309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526331 */     // MIs[0] round
     /* 1526331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526334 */     // MIs[0] policy
     /* 1526334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1526347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526368 */     // GIR_Coverage, 18402,
     /* 1526368 */     GIR_EraseRootFromParent_Done,
     /* 1526369 */   // Label 21202: @1526369
     /* 1526369 */   GIM_Try, /*On fail goto*//*Label 21203*/ GIMT_Encode4(1526451), // Rule ID 18403 //
     /* 1526374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1526385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1526388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1526391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1526394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1526413 */     // MIs[0] round
     /* 1526413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526416 */     // MIs[0] policy
     /* 1526416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526426 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 1526429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526450 */     // GIR_Coverage, 18403,
     /* 1526450 */     GIR_EraseRootFromParent_Done,
     /* 1526451 */   // Label 21203: @1526451
     /* 1526451 */   GIM_Try, /*On fail goto*//*Label 21204*/ GIMT_Encode4(1526533), // Rule ID 18406 //
     /* 1526456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1526473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526495 */     // MIs[0] round
     /* 1526495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526498 */     // MIs[0] policy
     /* 1526498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526508 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1526511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526532 */     // GIR_Coverage, 18406,
     /* 1526532 */     GIR_EraseRootFromParent_Done,
     /* 1526533 */   // Label 21204: @1526533
     /* 1526533 */   GIM_Try, /*On fail goto*//*Label 21205*/ GIMT_Encode4(1526615), // Rule ID 18407 //
     /* 1526538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1526549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1526552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1526555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1526558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1526577 */     // MIs[0] round
     /* 1526577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526580 */     // MIs[0] policy
     /* 1526580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526590 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 1526593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526614 */     // GIR_Coverage, 18407,
     /* 1526614 */     GIR_EraseRootFromParent_Done,
     /* 1526615 */   // Label 21205: @1526615
     /* 1526615 */   GIM_Try, /*On fail goto*//*Label 21206*/ GIMT_Encode4(1526697), // Rule ID 18410 //
     /* 1526620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1526623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1526637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526659 */     // MIs[0] round
     /* 1526659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526662 */     // MIs[0] policy
     /* 1526662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526672 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1526675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526696 */     // GIR_Coverage, 18410,
     /* 1526696 */     GIR_EraseRootFromParent_Done,
     /* 1526697 */   // Label 21206: @1526697
     /* 1526697 */   GIM_Try, /*On fail goto*//*Label 21207*/ GIMT_Encode4(1526779), // Rule ID 18411 //
     /* 1526702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1526705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1526713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1526716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1526719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1526722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1526741 */     // MIs[0] round
     /* 1526741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526744 */     // MIs[0] policy
     /* 1526744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526754 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 1526757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1526775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526778 */     // GIR_Coverage, 18411,
     /* 1526778 */     GIR_EraseRootFromParent_Done,
     /* 1526779 */   // Label 21207: @1526779
     /* 1526779 */   GIM_Try, /*On fail goto*//*Label 21208*/ GIMT_Encode4(1526861), // Rule ID 18414 //
     /* 1526784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526823 */     // MIs[0] round
     /* 1526823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526826 */     // MIs[0] policy
     /* 1526826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526836 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1526836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1526839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526860 */     // GIR_Coverage, 18414,
     /* 1526860 */     GIR_EraseRootFromParent_Done,
     /* 1526861 */   // Label 21208: @1526861
     /* 1526861 */   GIM_Try, /*On fail goto*//*Label 21209*/ GIMT_Encode4(1526943), // Rule ID 18415 //
     /* 1526866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1526869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1526877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1526880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1526886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1526889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526905 */     // MIs[0] round
     /* 1526905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526908 */     // MIs[0] policy
     /* 1526908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1526918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1526918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16),
     /* 1526921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1526923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1526925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1526927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1526929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1526931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1526936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1526939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1526941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1526942 */     // GIR_Coverage, 18415,
     /* 1526942 */     GIR_EraseRootFromParent_Done,
     /* 1526943 */   // Label 21209: @1526943
     /* 1526943 */   GIM_Try, /*On fail goto*//*Label 21210*/ GIMT_Encode4(1527025), // Rule ID 18418 //
     /* 1526948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1526951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1526956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1526959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1526962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1526965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1526968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1526971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1526983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1526987 */     // MIs[0] round
     /* 1526987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1526990 */     // MIs[0] policy
     /* 1526990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1526993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527000 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1527003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527024 */     // GIR_Coverage, 18418,
     /* 1527024 */     GIR_EraseRootFromParent_Done,
     /* 1527025 */   // Label 21210: @1527025
     /* 1527025 */   GIM_Try, /*On fail goto*//*Label 21211*/ GIMT_Encode4(1527107), // Rule ID 18419 //
     /* 1527030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1527041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1527044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1527050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527069 */     // MIs[0] round
     /* 1527069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527072 */     // MIs[0] policy
     /* 1527072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527082 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16),
     /* 1527085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527106 */     // GIR_Coverage, 18419,
     /* 1527106 */     GIR_EraseRootFromParent_Done,
     /* 1527107 */   // Label 21211: @1527107
     /* 1527107 */   GIM_Try, /*On fail goto*//*Label 21212*/ GIMT_Encode4(1527189), // Rule ID 18422 //
     /* 1527112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1527123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1527126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1527132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527151 */     // MIs[0] round
     /* 1527151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527154 */     // MIs[0] policy
     /* 1527154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527164 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1527167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527188 */     // GIR_Coverage, 18422,
     /* 1527188 */     GIR_EraseRootFromParent_Done,
     /* 1527189 */   // Label 21212: @1527189
     /* 1527189 */   GIM_Try, /*On fail goto*//*Label 21213*/ GIMT_Encode4(1527271), // Rule ID 18423 //
     /* 1527194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1527205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1527208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1527214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527233 */     // MIs[0] round
     /* 1527233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527236 */     // MIs[0] policy
     /* 1527236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527246 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32),
     /* 1527249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527270 */     // GIR_Coverage, 18423,
     /* 1527270 */     GIR_EraseRootFromParent_Done,
     /* 1527271 */   // Label 21213: @1527271
     /* 1527271 */   GIM_Try, /*On fail goto*//*Label 21214*/ GIMT_Encode4(1527353), // Rule ID 18426 //
     /* 1527276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527315 */     // MIs[0] round
     /* 1527315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527318 */     // MIs[0] policy
     /* 1527318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527328 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1527331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527352 */     // GIR_Coverage, 18426,
     /* 1527352 */     GIR_EraseRootFromParent_Done,
     /* 1527353 */   // Label 21214: @1527353
     /* 1527353 */   GIM_Try, /*On fail goto*//*Label 21215*/ GIMT_Encode4(1527435), // Rule ID 18427 //
     /* 1527358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1527369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1527372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1527378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527397 */     // MIs[0] round
     /* 1527397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527400 */     // MIs[0] policy
     /* 1527400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527410 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11147:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16),
     /* 1527413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527434 */     // GIR_Coverage, 18427,
     /* 1527434 */     GIR_EraseRootFromParent_Done,
     /* 1527435 */   // Label 21215: @1527435
     /* 1527435 */   GIM_Try, /*On fail goto*//*Label 21216*/ GIMT_Encode4(1527517), // Rule ID 18430 //
     /* 1527440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1527443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527479 */     // MIs[0] round
     /* 1527479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527482 */     // MIs[0] policy
     /* 1527482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527492 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1527495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527516 */     // GIR_Coverage, 18430,
     /* 1527516 */     GIR_EraseRootFromParent_Done,
     /* 1527517 */   // Label 21216: @1527517
     /* 1527517 */   GIM_Try, /*On fail goto*//*Label 21217*/ GIMT_Encode4(1527599), // Rule ID 18431 //
     /* 1527522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1527525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1527533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1527536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1527539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1527542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1527557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527561 */     // MIs[0] round
     /* 1527561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527564 */     // MIs[0] policy
     /* 1527564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527574 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11147:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32),
     /* 1527577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1527595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527598 */     // GIR_Coverage, 18431,
     /* 1527598 */     GIR_EraseRootFromParent_Done,
     /* 1527599 */   // Label 21217: @1527599
     /* 1527599 */   GIM_Try, /*On fail goto*//*Label 21218*/ GIMT_Encode4(1527681), // Rule ID 18434 //
     /* 1527604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1527607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1527621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1527639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527643 */     // MIs[0] round
     /* 1527643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527646 */     // MIs[0] policy
     /* 1527646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527656 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1527659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527680 */     // GIR_Coverage, 18434,
     /* 1527680 */     GIR_EraseRootFromParent_Done,
     /* 1527681 */   // Label 21218: @1527681
     /* 1527681 */   GIM_Try, /*On fail goto*//*Label 21219*/ GIMT_Encode4(1527763), // Rule ID 18435 //
     /* 1527686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1527689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1527697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1527700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1527703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1527706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1527721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1527725 */     // MIs[0] round
     /* 1527725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527728 */     // MIs[0] policy
     /* 1527728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527738 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11147:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64),
     /* 1527741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1527759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527762 */     // GIR_Coverage, 18435,
     /* 1527762 */     GIR_EraseRootFromParent_Done,
     /* 1527763 */   // Label 21219: @1527763
     /* 1527763 */   GIM_Try, /*On fail goto*//*Label 21220*/ GIMT_Encode4(1527845), // Rule ID 18438 //
     /* 1527768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527807 */     // MIs[0] round
     /* 1527807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527810 */     // MIs[0] policy
     /* 1527810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1527823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527844 */     // GIR_Coverage, 18438,
     /* 1527844 */     GIR_EraseRootFromParent_Done,
     /* 1527845 */   // Label 21220: @1527845
     /* 1527845 */   GIM_Try, /*On fail goto*//*Label 21221*/ GIMT_Encode4(1527927), // Rule ID 18439 //
     /* 1527850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1527853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1527861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1527864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1527870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1527873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1527889 */     // MIs[0] round
     /* 1527889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527892 */     // MIs[0] policy
     /* 1527892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1527902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16),
     /* 1527905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1527920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1527923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1527925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1527926 */     // GIR_Coverage, 18439,
     /* 1527926 */     GIR_EraseRootFromParent_Done,
     /* 1527927 */   // Label 21221: @1527927
     /* 1527927 */   GIM_Try, /*On fail goto*//*Label 21222*/ GIMT_Encode4(1528009), // Rule ID 18442 //
     /* 1527932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1527935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1527940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1527943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1527946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1527949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1527952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1527955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1527967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1527971 */     // MIs[0] round
     /* 1527971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1527974 */     // MIs[0] policy
     /* 1527974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1527977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1527984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1527984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1527987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1527989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1527991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1527993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1527995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1527997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528008 */     // GIR_Coverage, 18442,
     /* 1528008 */     GIR_EraseRootFromParent_Done,
     /* 1528009 */   // Label 21222: @1528009
     /* 1528009 */   GIM_Try, /*On fail goto*//*Label 21223*/ GIMT_Encode4(1528091), // Rule ID 18443 //
     /* 1528014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1528025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1528028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1528034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528053 */     // MIs[0] round
     /* 1528053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528056 */     // MIs[0] policy
     /* 1528056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528066 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16),
     /* 1528069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528090 */     // GIR_Coverage, 18443,
     /* 1528090 */     GIR_EraseRootFromParent_Done,
     /* 1528091 */   // Label 21223: @1528091
     /* 1528091 */   GIM_Try, /*On fail goto*//*Label 21224*/ GIMT_Encode4(1528173), // Rule ID 18446 //
     /* 1528096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1528099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1528116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528135 */     // MIs[0] round
     /* 1528135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528138 */     // MIs[0] policy
     /* 1528138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528148 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1528151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528172 */     // GIR_Coverage, 18446,
     /* 1528172 */     GIR_EraseRootFromParent_Done,
     /* 1528173 */   // Label 21224: @1528173
     /* 1528173 */   GIM_Try, /*On fail goto*//*Label 21225*/ GIMT_Encode4(1528255), // Rule ID 18447 //
     /* 1528178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1528181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1528189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1528192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1528195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1528198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1528213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528217 */     // MIs[0] round
     /* 1528217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528220 */     // MIs[0] policy
     /* 1528220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528230 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16),
     /* 1528233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1528251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528254 */     // GIR_Coverage, 18447,
     /* 1528254 */     GIR_EraseRootFromParent_Done,
     /* 1528255 */   // Label 21225: @1528255
     /* 1528255 */   GIM_Try, /*On fail goto*//*Label 21226*/ GIMT_Encode4(1528337), // Rule ID 18450 //
     /* 1528260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528299 */     // MIs[0] round
     /* 1528299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528302 */     // MIs[0] policy
     /* 1528302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528312 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1528315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528336 */     // GIR_Coverage, 18450,
     /* 1528336 */     GIR_EraseRootFromParent_Done,
     /* 1528337 */   // Label 21226: @1528337
     /* 1528337 */   GIM_Try, /*On fail goto*//*Label 21227*/ GIMT_Encode4(1528419), // Rule ID 18451 //
     /* 1528342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1528353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1528356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1528362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528381 */     // MIs[0] round
     /* 1528381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528384 */     // MIs[0] policy
     /* 1528384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528394 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32),
     /* 1528397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528418 */     // GIR_Coverage, 18451,
     /* 1528418 */     GIR_EraseRootFromParent_Done,
     /* 1528419 */   // Label 21227: @1528419
     /* 1528419 */   GIM_Try, /*On fail goto*//*Label 21228*/ GIMT_Encode4(1528501), // Rule ID 18454 //
     /* 1528424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528463 */     // MIs[0] round
     /* 1528463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528466 */     // MIs[0] policy
     /* 1528466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528476 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1528479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528500 */     // GIR_Coverage, 18454,
     /* 1528500 */     GIR_EraseRootFromParent_Done,
     /* 1528501 */   // Label 21228: @1528501
     /* 1528501 */   GIM_Try, /*On fail goto*//*Label 21229*/ GIMT_Encode4(1528583), // Rule ID 18455 //
     /* 1528506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1528517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1528520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1528526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528545 */     // MIs[0] round
     /* 1528545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528548 */     // MIs[0] policy
     /* 1528548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528558 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32),
     /* 1528561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528582 */     // GIR_Coverage, 18455,
     /* 1528582 */     GIR_EraseRootFromParent_Done,
     /* 1528583 */   // Label 21229: @1528583
     /* 1528583 */   GIM_Try, /*On fail goto*//*Label 21230*/ GIMT_Encode4(1528665), // Rule ID 18458 //
     /* 1528588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1528591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528627 */     // MIs[0] round
     /* 1528627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528630 */     // MIs[0] policy
     /* 1528630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1528643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528664 */     // GIR_Coverage, 18458,
     /* 1528664 */     GIR_EraseRootFromParent_Done,
     /* 1528665 */   // Label 21230: @1528665
     /* 1528665 */   GIM_Try, /*On fail goto*//*Label 21231*/ GIMT_Encode4(1528747), // Rule ID 18459 //
     /* 1528670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1528673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1528681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1528684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1528687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1528690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1528705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1528709 */     // MIs[0] round
     /* 1528709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528712 */     // MIs[0] policy
     /* 1528712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528722 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32),
     /* 1528725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1528743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528746 */     // GIR_Coverage, 18459,
     /* 1528746 */     GIR_EraseRootFromParent_Done,
     /* 1528747 */   // Label 21231: @1528747
     /* 1528747 */   GIM_Try, /*On fail goto*//*Label 21232*/ GIMT_Encode4(1528829), // Rule ID 18462 //
     /* 1528752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528791 */     // MIs[0] round
     /* 1528791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528794 */     // MIs[0] policy
     /* 1528794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528804 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1528807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528828 */     // GIR_Coverage, 18462,
     /* 1528828 */     GIR_EraseRootFromParent_Done,
     /* 1528829 */   // Label 21232: @1528829
     /* 1528829 */   GIM_Try, /*On fail goto*//*Label 21233*/ GIMT_Encode4(1528911), // Rule ID 18463 //
     /* 1528834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1528837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1528845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1528848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1528854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1528857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1528873 */     // MIs[0] round
     /* 1528873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528876 */     // MIs[0] policy
     /* 1528876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528886 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11147:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1528886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64),
     /* 1528889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528910 */     // GIR_Coverage, 18463,
     /* 1528910 */     GIR_EraseRootFromParent_Done,
     /* 1528911 */   // Label 21233: @1528911
     /* 1528911 */   GIM_Try, /*On fail goto*//*Label 21234*/ GIMT_Encode4(1528993), // Rule ID 18466 //
     /* 1528916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1528919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1528924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1528927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1528930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1528933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1528936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1528939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1528951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1528955 */     // MIs[0] round
     /* 1528955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1528958 */     // MIs[0] policy
     /* 1528958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1528961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1528968 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1528968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1528971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1528973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1528975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1528977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1528979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1528981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1528986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1528989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1528991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1528992 */     // GIR_Coverage, 18466,
     /* 1528992 */     GIR_EraseRootFromParent_Done,
     /* 1528993 */   // Label 21234: @1528993
     /* 1528993 */   GIM_Try, /*On fail goto*//*Label 21235*/ GIMT_Encode4(1529075), // Rule ID 18467 //
     /* 1528998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1529009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1529012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1529018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1529037 */     // MIs[0] round
     /* 1529037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529040 */     // MIs[0] policy
     /* 1529040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529050 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11147:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64),
     /* 1529053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529074 */     // GIR_Coverage, 18467,
     /* 1529074 */     GIR_EraseRootFromParent_Done,
     /* 1529075 */   // Label 21235: @1529075
     /* 1529075 */   GIM_Try, /*On fail goto*//*Label 21236*/ GIMT_Encode4(1529157), // Rule ID 18470 //
     /* 1529080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1529083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1529100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529119 */     // MIs[0] round
     /* 1529119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529122 */     // MIs[0] policy
     /* 1529122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529132 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1529135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529156 */     // GIR_Coverage, 18470,
     /* 1529156 */     GIR_EraseRootFromParent_Done,
     /* 1529157 */   // Label 21236: @1529157
     /* 1529157 */   GIM_Try, /*On fail goto*//*Label 21237*/ GIMT_Encode4(1529239), // Rule ID 18471 //
     /* 1529162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1529165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub),
     /* 1529170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1529173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1529176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1529179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1529182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1529197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1529201 */     // MIs[0] round
     /* 1529201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529204 */     // MIs[0] policy
     /* 1529204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529214 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11147:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64),
     /* 1529217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1529235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529238 */     // GIR_Coverage, 18471,
     /* 1529238 */     GIR_EraseRootFromParent_Done,
     /* 1529239 */   // Label 21237: @1529239
     /* 1529239 */   GIM_Try, /*On fail goto*//*Label 21238*/ GIMT_Encode4(1529321), // Rule ID 18474 //
     /* 1529244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1529261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529283 */     // MIs[0] round
     /* 1529283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529286 */     // MIs[0] policy
     /* 1529286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529296 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1529299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529320 */     // GIR_Coverage, 18474,
     /* 1529320 */     GIR_EraseRootFromParent_Done,
     /* 1529321 */   // Label 21238: @1529321
     /* 1529321 */   GIM_Try, /*On fail goto*//*Label 21239*/ GIMT_Encode4(1529403), // Rule ID 18475 //
     /* 1529326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1529337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1529340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1529343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1529346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529365 */     // MIs[0] round
     /* 1529365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529368 */     // MIs[0] policy
     /* 1529368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529378 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 1529381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529402 */     // GIR_Coverage, 18475,
     /* 1529402 */     GIR_EraseRootFromParent_Done,
     /* 1529403 */   // Label 21239: @1529403
     /* 1529403 */   GIM_Try, /*On fail goto*//*Label 21240*/ GIMT_Encode4(1529485), // Rule ID 18478 //
     /* 1529408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1529425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529447 */     // MIs[0] round
     /* 1529447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529450 */     // MIs[0] policy
     /* 1529450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529460 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1529463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529484 */     // GIR_Coverage, 18478,
     /* 1529484 */     GIR_EraseRootFromParent_Done,
     /* 1529485 */   // Label 21240: @1529485
     /* 1529485 */   GIM_Try, /*On fail goto*//*Label 21241*/ GIMT_Encode4(1529567), // Rule ID 18479 //
     /* 1529490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1529501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1529504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1529507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1529510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529529 */     // MIs[0] round
     /* 1529529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529532 */     // MIs[0] policy
     /* 1529532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529542 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 1529545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529566 */     // GIR_Coverage, 18479,
     /* 1529566 */     GIR_EraseRootFromParent_Done,
     /* 1529567 */   // Label 21241: @1529567
     /* 1529567 */   GIM_Try, /*On fail goto*//*Label 21242*/ GIMT_Encode4(1529649), // Rule ID 18482 //
     /* 1529572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529611 */     // MIs[0] round
     /* 1529611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529614 */     // MIs[0] policy
     /* 1529614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1529627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529648 */     // GIR_Coverage, 18482,
     /* 1529648 */     GIR_EraseRootFromParent_Done,
     /* 1529649 */   // Label 21242: @1529649
     /* 1529649 */   GIM_Try, /*On fail goto*//*Label 21243*/ GIMT_Encode4(1529731), // Rule ID 18483 //
     /* 1529654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1529665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1529668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1529671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1529674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529693 */     // MIs[0] round
     /* 1529693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529696 */     // MIs[0] policy
     /* 1529696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 1529709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529730 */     // GIR_Coverage, 18483,
     /* 1529730 */     GIR_EraseRootFromParent_Done,
     /* 1529731 */   // Label 21243: @1529731
     /* 1529731 */   GIM_Try, /*On fail goto*//*Label 21244*/ GIMT_Encode4(1529813), // Rule ID 18486 //
     /* 1529736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1529739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1529753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529775 */     // MIs[0] round
     /* 1529775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529778 */     // MIs[0] policy
     /* 1529778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529788 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1529791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529812 */     // GIR_Coverage, 18486,
     /* 1529812 */     GIR_EraseRootFromParent_Done,
     /* 1529813 */   // Label 21244: @1529813
     /* 1529813 */   GIM_Try, /*On fail goto*//*Label 21245*/ GIMT_Encode4(1529895), // Rule ID 18487 //
     /* 1529818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1529821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1529829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1529832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1529835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1529838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1529841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529857 */     // MIs[0] round
     /* 1529857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529860 */     // MIs[0] policy
     /* 1529860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1529870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 1529873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1529891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529894 */     // GIR_Coverage, 18487,
     /* 1529894 */     GIR_EraseRootFromParent_Done,
     /* 1529895 */   // Label 21245: @1529895
     /* 1529895 */   GIM_Try, /*On fail goto*//*Label 21246*/ GIMT_Encode4(1529977), // Rule ID 18490 //
     /* 1529900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1529903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1529920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1529923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1529939 */     // MIs[0] round
     /* 1529939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1529942 */     // MIs[0] policy
     /* 1529942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1529945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1529952 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1529952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1529955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1529957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1529959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1529961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1529963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1529965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1529970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1529973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1529975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1529976 */     // GIR_Coverage, 18490,
     /* 1529976 */     GIR_EraseRootFromParent_Done,
     /* 1529977 */   // Label 21246: @1529977
     /* 1529977 */   GIM_Try, /*On fail goto*//*Label 21247*/ GIMT_Encode4(1530059), // Rule ID 18491 //
     /* 1529982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1529985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1529990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1529993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1529996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1529999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1530002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530021 */     // MIs[0] round
     /* 1530021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530024 */     // MIs[0] policy
     /* 1530024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530034 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 1530037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530058 */     // GIR_Coverage, 18491,
     /* 1530058 */     GIR_EraseRootFromParent_Done,
     /* 1530059 */   // Label 21247: @1530059
     /* 1530059 */   GIM_Try, /*On fail goto*//*Label 21248*/ GIMT_Encode4(1530141), // Rule ID 18494 //
     /* 1530064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1530067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1530075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1530078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1530081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1530084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530103 */     // MIs[0] round
     /* 1530103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530106 */     // MIs[0] policy
     /* 1530106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530116 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1530119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530140 */     // GIR_Coverage, 18494,
     /* 1530140 */     GIR_EraseRootFromParent_Done,
     /* 1530141 */   // Label 21248: @1530141
     /* 1530141 */   GIM_Try, /*On fail goto*//*Label 21249*/ GIMT_Encode4(1530223), // Rule ID 18495 //
     /* 1530146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1530149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1530157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1530160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1530163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1530166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1530185 */     // MIs[0] round
     /* 1530185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530188 */     // MIs[0] policy
     /* 1530188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530198 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 1530201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1530219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530222 */     // GIR_Coverage, 18495,
     /* 1530222 */     GIR_EraseRootFromParent_Done,
     /* 1530223 */   // Label 21249: @1530223
     /* 1530223 */   GIM_Try, /*On fail goto*//*Label 21250*/ GIMT_Encode4(1530305), // Rule ID 18498 //
     /* 1530228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1530245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530267 */     // MIs[0] round
     /* 1530267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530270 */     // MIs[0] policy
     /* 1530270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530280 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1530283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530304 */     // GIR_Coverage, 18498,
     /* 1530304 */     GIR_EraseRootFromParent_Done,
     /* 1530305 */   // Label 21250: @1530305
     /* 1530305 */   GIM_Try, /*On fail goto*//*Label 21251*/ GIMT_Encode4(1530387), // Rule ID 18499 //
     /* 1530310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1530321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1530324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1530327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1530330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530349 */     // MIs[0] round
     /* 1530349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530352 */     // MIs[0] policy
     /* 1530352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530362 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 1530365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530386 */     // GIR_Coverage, 18499,
     /* 1530386 */     GIR_EraseRootFromParent_Done,
     /* 1530387 */   // Label 21251: @1530387
     /* 1530387 */   GIM_Try, /*On fail goto*//*Label 21252*/ GIMT_Encode4(1530469), // Rule ID 18502 //
     /* 1530392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1530409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530431 */     // MIs[0] round
     /* 1530431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530434 */     // MIs[0] policy
     /* 1530434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530444 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1530447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530468 */     // GIR_Coverage, 18502,
     /* 1530468 */     GIR_EraseRootFromParent_Done,
     /* 1530469 */   // Label 21252: @1530469
     /* 1530469 */   GIM_Try, /*On fail goto*//*Label 21253*/ GIMT_Encode4(1530551), // Rule ID 18503 //
     /* 1530474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1530485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1530488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1530491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1530494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530513 */     // MIs[0] round
     /* 1530513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530516 */     // MIs[0] policy
     /* 1530516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530526 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 1530529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530550 */     // GIR_Coverage, 18503,
     /* 1530550 */     GIR_EraseRootFromParent_Done,
     /* 1530551 */   // Label 21253: @1530551
     /* 1530551 */   GIM_Try, /*On fail goto*//*Label 21254*/ GIMT_Encode4(1530633), // Rule ID 18506 //
     /* 1530556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1530559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1530573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530595 */     // MIs[0] round
     /* 1530595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530598 */     // MIs[0] policy
     /* 1530598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530608 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1530611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530632 */     // GIR_Coverage, 18506,
     /* 1530632 */     GIR_EraseRootFromParent_Done,
     /* 1530633 */   // Label 21254: @1530633
     /* 1530633 */   GIM_Try, /*On fail goto*//*Label 21255*/ GIMT_Encode4(1530715), // Rule ID 18507 //
     /* 1530638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1530641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1530649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1530652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1530655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1530658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1530677 */     // MIs[0] round
     /* 1530677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530680 */     // MIs[0] policy
     /* 1530680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530690 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 1530693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1530711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530714 */     // GIR_Coverage, 18507,
     /* 1530714 */     GIR_EraseRootFromParent_Done,
     /* 1530715 */   // Label 21255: @1530715
     /* 1530715 */   GIM_Try, /*On fail goto*//*Label 21256*/ GIMT_Encode4(1530797), // Rule ID 18510 //
     /* 1530720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1530737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530759 */     // MIs[0] round
     /* 1530759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530762 */     // MIs[0] policy
     /* 1530762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530772 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1530775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530796 */     // GIR_Coverage, 18510,
     /* 1530796 */     GIR_EraseRootFromParent_Done,
     /* 1530797 */   // Label 21256: @1530797
     /* 1530797 */   GIM_Try, /*On fail goto*//*Label 21257*/ GIMT_Encode4(1530879), // Rule ID 18511 //
     /* 1530802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1530813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1530816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1530819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1530822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1530841 */     // MIs[0] round
     /* 1530841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530844 */     // MIs[0] policy
     /* 1530844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1530854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 1530857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530878 */     // GIR_Coverage, 18511,
     /* 1530878 */     GIR_EraseRootFromParent_Done,
     /* 1530879 */   // Label 21257: @1530879
     /* 1530879 */   GIM_Try, /*On fail goto*//*Label 21258*/ GIMT_Encode4(1530961), // Rule ID 18514 //
     /* 1530884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1530887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1530901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1530907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530923 */     // MIs[0] round
     /* 1530923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1530926 */     // MIs[0] policy
     /* 1530926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1530929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1530936 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1530936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1530939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1530941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1530943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1530945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1530947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1530949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1530954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1530957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1530959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1530960 */     // GIR_Coverage, 18514,
     /* 1530960 */     GIR_EraseRootFromParent_Done,
     /* 1530961 */   // Label 21258: @1530961
     /* 1530961 */   GIM_Try, /*On fail goto*//*Label 21259*/ GIMT_Encode4(1531043), // Rule ID 18515 //
     /* 1530966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1530969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1530974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1530977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1530980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1530983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1530986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1530989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1530997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531005 */     // MIs[0] round
     /* 1531005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531008 */     // MIs[0] policy
     /* 1531008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531018 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 1531021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531042 */     // GIR_Coverage, 18515,
     /* 1531042 */     GIR_EraseRootFromParent_Done,
     /* 1531043 */   // Label 21259: @1531043
     /* 1531043 */   GIM_Try, /*On fail goto*//*Label 21260*/ GIMT_Encode4(1531125), // Rule ID 18518 //
     /* 1531048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1531051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1531065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1531068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531087 */     // MIs[0] round
     /* 1531087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531090 */     // MIs[0] policy
     /* 1531090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531100 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1531103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531124 */     // GIR_Coverage, 18518,
     /* 1531124 */     GIR_EraseRootFromParent_Done,
     /* 1531125 */   // Label 21260: @1531125
     /* 1531125 */   GIM_Try, /*On fail goto*//*Label 21261*/ GIMT_Encode4(1531207), // Rule ID 18519 //
     /* 1531130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1531133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1531141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1531144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1531147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1531150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531169 */     // MIs[0] round
     /* 1531169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531172 */     // MIs[0] policy
     /* 1531172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 1531185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1531203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531206 */     // GIR_Coverage, 18519,
     /* 1531206 */     GIR_EraseRootFromParent_Done,
     /* 1531207 */   // Label 21261: @1531207
     /* 1531207 */   GIM_Try, /*On fail goto*//*Label 21262*/ GIMT_Encode4(1531289), // Rule ID 18522 //
     /* 1531212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1531229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1531232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531251 */     // MIs[0] round
     /* 1531251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531254 */     // MIs[0] policy
     /* 1531254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531264 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1531267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531288 */     // GIR_Coverage, 18522,
     /* 1531288 */     GIR_EraseRootFromParent_Done,
     /* 1531289 */   // Label 21262: @1531289
     /* 1531289 */   GIM_Try, /*On fail goto*//*Label 21263*/ GIMT_Encode4(1531371), // Rule ID 18523 //
     /* 1531294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1531305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1531308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1531311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1531314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1531333 */     // MIs[0] round
     /* 1531333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531336 */     // MIs[0] policy
     /* 1531336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531346 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 1531349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531370 */     // GIR_Coverage, 18523,
     /* 1531370 */     GIR_EraseRootFromParent_Done,
     /* 1531371 */   // Label 21263: @1531371
     /* 1531371 */   GIM_Try, /*On fail goto*//*Label 21264*/ GIMT_Encode4(1531453), // Rule ID 18526 //
     /* 1531376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1531393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531415 */     // MIs[0] round
     /* 1531415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531418 */     // MIs[0] policy
     /* 1531418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531428 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1531431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531452 */     // GIR_Coverage, 18526,
     /* 1531452 */     GIR_EraseRootFromParent_Done,
     /* 1531453 */   // Label 21264: @1531453
     /* 1531453 */   GIM_Try, /*On fail goto*//*Label 21265*/ GIMT_Encode4(1531535), // Rule ID 18527 //
     /* 1531458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1531469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1531472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1531475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1531478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1531497 */     // MIs[0] round
     /* 1531497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531500 */     // MIs[0] policy
     /* 1531500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531510 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 1531513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531534 */     // GIR_Coverage, 18527,
     /* 1531534 */     GIR_EraseRootFromParent_Done,
     /* 1531535 */   // Label 21265: @1531535
     /* 1531535 */   GIM_Try, /*On fail goto*//*Label 21266*/ GIMT_Encode4(1531617), // Rule ID 18530 //
     /* 1531540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1531543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1531557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531579 */     // MIs[0] round
     /* 1531579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531582 */     // MIs[0] policy
     /* 1531582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531592 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1531595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531616 */     // GIR_Coverage, 18530,
     /* 1531616 */     GIR_EraseRootFromParent_Done,
     /* 1531617 */   // Label 21266: @1531617
     /* 1531617 */   GIM_Try, /*On fail goto*//*Label 21267*/ GIMT_Encode4(1531699), // Rule ID 18531 //
     /* 1531622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1531625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1531633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1531636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1531639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1531642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1531661 */     // MIs[0] round
     /* 1531661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531664 */     // MIs[0] policy
     /* 1531664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531674 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 1531677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1531695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531698 */     // GIR_Coverage, 18531,
     /* 1531698 */     GIR_EraseRootFromParent_Done,
     /* 1531699 */   // Label 21267: @1531699
     /* 1531699 */   GIM_Try, /*On fail goto*//*Label 21268*/ GIMT_Encode4(1531781), // Rule ID 18534 //
     /* 1531704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531743 */     // MIs[0] round
     /* 1531743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531746 */     // MIs[0] policy
     /* 1531746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531756 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1531759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531767 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531780 */     // GIR_Coverage, 18534,
     /* 1531780 */     GIR_EraseRootFromParent_Done,
     /* 1531781 */   // Label 21268: @1531781
     /* 1531781 */   GIM_Try, /*On fail goto*//*Label 21269*/ GIMT_Encode4(1531863), // Rule ID 18535 //
     /* 1531786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1531797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1531800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1531806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531825 */     // MIs[0] round
     /* 1531825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531828 */     // MIs[0] policy
     /* 1531828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531838 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1531838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16),
     /* 1531841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531849 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531862 */     // GIR_Coverage, 18535,
     /* 1531862 */     GIR_EraseRootFromParent_Done,
     /* 1531863 */   // Label 21269: @1531863
     /* 1531863 */   GIM_Try, /*On fail goto*//*Label 21270*/ GIMT_Encode4(1531945), // Rule ID 18538 //
     /* 1531868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1531871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1531891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531907 */     // MIs[0] round
     /* 1531907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531910 */     // MIs[0] policy
     /* 1531910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1531920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1531920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1531923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1531925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1531927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1531929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1531931 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1531933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1531938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1531941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1531943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1531944 */     // GIR_Coverage, 18538,
     /* 1531944 */     GIR_EraseRootFromParent_Done,
     /* 1531945 */   // Label 21270: @1531945
     /* 1531945 */   GIM_Try, /*On fail goto*//*Label 21271*/ GIMT_Encode4(1532027), // Rule ID 18539 //
     /* 1531950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1531953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1531958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1531961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1531964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1531967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1531970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1531973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1531985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1531989 */     // MIs[0] round
     /* 1531989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1531992 */     // MIs[0] policy
     /* 1531992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1531995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532002 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16),
     /* 1532005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532013 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532026 */     // GIR_Coverage, 18539,
     /* 1532026 */     GIR_EraseRootFromParent_Done,
     /* 1532027 */   // Label 21271: @1532027
     /* 1532027 */   GIM_Try, /*On fail goto*//*Label 21272*/ GIMT_Encode4(1532109), // Rule ID 18542 //
     /* 1532032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1532043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1532046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1532052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532071 */     // MIs[0] round
     /* 1532071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532074 */     // MIs[0] policy
     /* 1532074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1532087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532095 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532108 */     // GIR_Coverage, 18542,
     /* 1532108 */     GIR_EraseRootFromParent_Done,
     /* 1532109 */   // Label 21272: @1532109
     /* 1532109 */   GIM_Try, /*On fail goto*//*Label 21273*/ GIMT_Encode4(1532191), // Rule ID 18543 //
     /* 1532114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1532125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1532128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1532134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532153 */     // MIs[0] round
     /* 1532153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532156 */     // MIs[0] policy
     /* 1532156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532166 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32),
     /* 1532169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532177 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532190 */     // GIR_Coverage, 18543,
     /* 1532190 */     GIR_EraseRootFromParent_Done,
     /* 1532191 */   // Label 21273: @1532191
     /* 1532191 */   GIM_Try, /*On fail goto*//*Label 21274*/ GIMT_Encode4(1532273), // Rule ID 18546 //
     /* 1532196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1532216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532235 */     // MIs[0] round
     /* 1532235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532238 */     // MIs[0] policy
     /* 1532238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532248 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1532251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532259 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532272 */     // GIR_Coverage, 18546,
     /* 1532272 */     GIR_EraseRootFromParent_Done,
     /* 1532273 */   // Label 21274: @1532273
     /* 1532273 */   GIM_Try, /*On fail goto*//*Label 21275*/ GIMT_Encode4(1532355), // Rule ID 18547 //
     /* 1532278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1532289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1532292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1532298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532317 */     // MIs[0] round
     /* 1532317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532320 */     // MIs[0] policy
     /* 1532320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532330 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11178:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16),
     /* 1532333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532341 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532354 */     // GIR_Coverage, 18547,
     /* 1532354 */     GIR_EraseRootFromParent_Done,
     /* 1532355 */   // Label 21275: @1532355
     /* 1532355 */   GIM_Try, /*On fail goto*//*Label 21276*/ GIMT_Encode4(1532437), // Rule ID 18550 //
     /* 1532360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1532363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532399 */     // MIs[0] round
     /* 1532399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532402 */     // MIs[0] policy
     /* 1532402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532412 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1532415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532423 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532436 */     // GIR_Coverage, 18550,
     /* 1532436 */     GIR_EraseRootFromParent_Done,
     /* 1532437 */   // Label 21276: @1532437
     /* 1532437 */   GIM_Try, /*On fail goto*//*Label 21277*/ GIMT_Encode4(1532519), // Rule ID 18551 //
     /* 1532442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1532445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1532453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1532456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1532459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1532462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1532477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532481 */     // MIs[0] round
     /* 1532481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532484 */     // MIs[0] policy
     /* 1532484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11178:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32),
     /* 1532497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532505 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1532515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532518 */     // GIR_Coverage, 18551,
     /* 1532518 */     GIR_EraseRootFromParent_Done,
     /* 1532519 */   // Label 21277: @1532519
     /* 1532519 */   GIM_Try, /*On fail goto*//*Label 21278*/ GIMT_Encode4(1532601), // Rule ID 18554 //
     /* 1532524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1532527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1532541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1532559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532563 */     // MIs[0] round
     /* 1532563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532566 */     // MIs[0] policy
     /* 1532566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532576 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1532579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532587 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532600 */     // GIR_Coverage, 18554,
     /* 1532600 */     GIR_EraseRootFromParent_Done,
     /* 1532601 */   // Label 21278: @1532601
     /* 1532601 */   GIM_Try, /*On fail goto*//*Label 21279*/ GIMT_Encode4(1532683), // Rule ID 18555 //
     /* 1532606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1532609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1532617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1532620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1532623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1532626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1532641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1532645 */     // MIs[0] round
     /* 1532645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532648 */     // MIs[0] policy
     /* 1532648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532658 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11178:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64),
     /* 1532661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532669 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1532679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532682 */     // GIR_Coverage, 18555,
     /* 1532682 */     GIR_EraseRootFromParent_Done,
     /* 1532683 */   // Label 21279: @1532683
     /* 1532683 */   GIM_Try, /*On fail goto*//*Label 21280*/ GIMT_Encode4(1532765), // Rule ID 18558 //
     /* 1532688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532727 */     // MIs[0] round
     /* 1532727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532730 */     // MIs[0] policy
     /* 1532730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532740 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1532743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532751 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532764 */     // GIR_Coverage, 18558,
     /* 1532764 */     GIR_EraseRootFromParent_Done,
     /* 1532765 */   // Label 21280: @1532765
     /* 1532765 */   GIM_Try, /*On fail goto*//*Label 21281*/ GIMT_Encode4(1532847), // Rule ID 18559 //
     /* 1532770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1532781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1532784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1532790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1532809 */     // MIs[0] round
     /* 1532809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532812 */     // MIs[0] policy
     /* 1532812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532822 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16),
     /* 1532825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532833 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532846 */     // GIR_Coverage, 18559,
     /* 1532846 */     GIR_EraseRootFromParent_Done,
     /* 1532847 */   // Label 21281: @1532847
     /* 1532847 */   GIM_Try, /*On fail goto*//*Label 21282*/ GIMT_Encode4(1532929), // Rule ID 18562 //
     /* 1532852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1532855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1532875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532891 */     // MIs[0] round
     /* 1532891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532894 */     // MIs[0] policy
     /* 1532894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532904 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1532904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1532907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532915 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1532922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1532925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1532927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1532928 */     // GIR_Coverage, 18562,
     /* 1532928 */     GIR_EraseRootFromParent_Done,
     /* 1532929 */   // Label 21282: @1532929
     /* 1532929 */   GIM_Try, /*On fail goto*//*Label 21283*/ GIMT_Encode4(1533011), // Rule ID 18563 //
     /* 1532934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1532937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1532942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1532945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1532948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1532951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1532954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1532957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1532969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1532973 */     // MIs[0] round
     /* 1532973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1532976 */     // MIs[0] policy
     /* 1532976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1532979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1532986 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1532986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16),
     /* 1532989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1532991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1532993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1532995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1532997 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1532999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533010 */     // GIR_Coverage, 18563,
     /* 1533010 */     GIR_EraseRootFromParent_Done,
     /* 1533011 */   // Label 21283: @1533011
     /* 1533011 */   GIM_Try, /*On fail goto*//*Label 21284*/ GIMT_Encode4(1533093), // Rule ID 18566 //
     /* 1533016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1533019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1533036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533055 */     // MIs[0] round
     /* 1533055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533058 */     // MIs[0] policy
     /* 1533058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533068 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1533071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533079 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533092 */     // GIR_Coverage, 18566,
     /* 1533092 */     GIR_EraseRootFromParent_Done,
     /* 1533093 */   // Label 21284: @1533093
     /* 1533093 */   GIM_Try, /*On fail goto*//*Label 21285*/ GIMT_Encode4(1533175), // Rule ID 18567 //
     /* 1533098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1533101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1533109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1533112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1533115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1533118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1533133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533137 */     // MIs[0] round
     /* 1533137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533140 */     // MIs[0] policy
     /* 1533140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533150 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16),
     /* 1533153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533161 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1533171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533174 */     // GIR_Coverage, 18567,
     /* 1533174 */     GIR_EraseRootFromParent_Done,
     /* 1533175 */   // Label 21285: @1533175
     /* 1533175 */   GIM_Try, /*On fail goto*//*Label 21286*/ GIMT_Encode4(1533257), // Rule ID 18570 //
     /* 1533180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1533200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533219 */     // MIs[0] round
     /* 1533219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533222 */     // MIs[0] policy
     /* 1533222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1533235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533243 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533256 */     // GIR_Coverage, 18570,
     /* 1533256 */     GIR_EraseRootFromParent_Done,
     /* 1533257 */   // Label 21286: @1533257
     /* 1533257 */   GIM_Try, /*On fail goto*//*Label 21287*/ GIMT_Encode4(1533339), // Rule ID 18571 //
     /* 1533262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1533273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1533276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1533282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533301 */     // MIs[0] round
     /* 1533301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533304 */     // MIs[0] policy
     /* 1533304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533314 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32),
     /* 1533317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533325 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533338 */     // GIR_Coverage, 18571,
     /* 1533338 */     GIR_EraseRootFromParent_Done,
     /* 1533339 */   // Label 21287: @1533339
     /* 1533339 */   GIM_Try, /*On fail goto*//*Label 21288*/ GIMT_Encode4(1533421), // Rule ID 18574 //
     /* 1533344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533383 */     // MIs[0] round
     /* 1533383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533386 */     // MIs[0] policy
     /* 1533386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533396 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1533399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533407 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533420 */     // GIR_Coverage, 18574,
     /* 1533420 */     GIR_EraseRootFromParent_Done,
     /* 1533421 */   // Label 21288: @1533421
     /* 1533421 */   GIM_Try, /*On fail goto*//*Label 21289*/ GIMT_Encode4(1533503), // Rule ID 18575 //
     /* 1533426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1533437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1533440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1533446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533465 */     // MIs[0] round
     /* 1533465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533468 */     // MIs[0] policy
     /* 1533468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32),
     /* 1533481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533489 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533502 */     // GIR_Coverage, 18575,
     /* 1533502 */     GIR_EraseRootFromParent_Done,
     /* 1533503 */   // Label 21289: @1533503
     /* 1533503 */   GIM_Try, /*On fail goto*//*Label 21290*/ GIMT_Encode4(1533585), // Rule ID 18578 //
     /* 1533508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1533511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533547 */     // MIs[0] round
     /* 1533547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533550 */     // MIs[0] policy
     /* 1533550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533560 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1533563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533571 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533584 */     // GIR_Coverage, 18578,
     /* 1533584 */     GIR_EraseRootFromParent_Done,
     /* 1533585 */   // Label 21290: @1533585
     /* 1533585 */   GIM_Try, /*On fail goto*//*Label 21291*/ GIMT_Encode4(1533667), // Rule ID 18579 //
     /* 1533590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1533593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1533601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1533604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1533607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1533610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1533625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1533629 */     // MIs[0] round
     /* 1533629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533632 */     // MIs[0] policy
     /* 1533632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533642 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32),
     /* 1533645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533653 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1533663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533666 */     // GIR_Coverage, 18579,
     /* 1533666 */     GIR_EraseRootFromParent_Done,
     /* 1533667 */   // Label 21291: @1533667
     /* 1533667 */   GIM_Try, /*On fail goto*//*Label 21292*/ GIMT_Encode4(1533749), // Rule ID 18582 //
     /* 1533672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533711 */     // MIs[0] round
     /* 1533711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533714 */     // MIs[0] policy
     /* 1533714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533724 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1533727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533735 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533748 */     // GIR_Coverage, 18582,
     /* 1533748 */     GIR_EraseRootFromParent_Done,
     /* 1533749 */   // Label 21292: @1533749
     /* 1533749 */   GIM_Try, /*On fail goto*//*Label 21293*/ GIMT_Encode4(1533831), // Rule ID 18583 //
     /* 1533754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1533765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1533768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1533774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1533793 */     // MIs[0] round
     /* 1533793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533796 */     // MIs[0] policy
     /* 1533796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533806 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11178:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64),
     /* 1533809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533817 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533830 */     // GIR_Coverage, 18583,
     /* 1533830 */     GIR_EraseRootFromParent_Done,
     /* 1533831 */   // Label 21293: @1533831
     /* 1533831 */   GIM_Try, /*On fail goto*//*Label 21294*/ GIMT_Encode4(1533913), // Rule ID 18586 //
     /* 1533836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1533839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1533859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533875 */     // MIs[0] round
     /* 1533875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533878 */     // MIs[0] policy
     /* 1533878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533888 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1533888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1533891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533899 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533912 */     // GIR_Coverage, 18586,
     /* 1533912 */     GIR_EraseRootFromParent_Done,
     /* 1533913 */   // Label 21294: @1533913
     /* 1533913 */   GIM_Try, /*On fail goto*//*Label 21295*/ GIMT_Encode4(1533995), // Rule ID 18587 //
     /* 1533918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1533921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1533926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1533929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1533932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1533935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1533938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1533941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1533953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1533957 */     // MIs[0] round
     /* 1533957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1533960 */     // MIs[0] policy
     /* 1533960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1533963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1533970 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11178:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1533970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64),
     /* 1533973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1533975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1533977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1533979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1533981 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1533983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1533988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1533991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1533993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1533994 */     // GIR_Coverage, 18587,
     /* 1533994 */     GIR_EraseRootFromParent_Done,
     /* 1533995 */   // Label 21295: @1533995
     /* 1533995 */   GIM_Try, /*On fail goto*//*Label 21296*/ GIMT_Encode4(1534077), // Rule ID 18590 //
     /* 1534000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1534003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1534020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534039 */     // MIs[0] round
     /* 1534039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534042 */     // MIs[0] policy
     /* 1534042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534052 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1534055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534063 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534076 */     // GIR_Coverage, 18590,
     /* 1534076 */     GIR_EraseRootFromParent_Done,
     /* 1534077 */   // Label 21296: @1534077
     /* 1534077 */   GIM_Try, /*On fail goto*//*Label 21297*/ GIMT_Encode4(1534159), // Rule ID 18591 //
     /* 1534082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1534085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub),
     /* 1534090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1534093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1534096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1534099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1534102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1534117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534121 */     // MIs[0] round
     /* 1534121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534124 */     // MIs[0] policy
     /* 1534124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534134 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11178:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64),
     /* 1534137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534145 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1534155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534158 */     // GIR_Coverage, 18591,
     /* 1534158 */     GIR_EraseRootFromParent_Done,
     /* 1534159 */   // Label 21297: @1534159
     /* 1534159 */   GIM_Try, /*On fail goto*//*Label 21298*/ GIMT_Encode4(1534241), // Rule ID 18594 //
     /* 1534164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1534167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1534184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534203 */     // MIs[0] round
     /* 1534203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534206 */     // MIs[0] policy
     /* 1534206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534216 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1534219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534227 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534240 */     // GIR_Coverage, 18594,
     /* 1534240 */     GIR_EraseRootFromParent_Done,
     /* 1534241 */   // Label 21298: @1534241
     /* 1534241 */   GIM_Try, /*On fail goto*//*Label 21299*/ GIMT_Encode4(1534323), // Rule ID 18595 //
     /* 1534246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1534249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1534257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1534260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1534263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1534266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534285 */     // MIs[0] round
     /* 1534285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534288 */     // MIs[0] policy
     /* 1534288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534298 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16),
     /* 1534301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534309 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534322 */     // GIR_Coverage, 18595,
     /* 1534322 */     GIR_EraseRootFromParent_Done,
     /* 1534323 */   // Label 21299: @1534323
     /* 1534323 */   GIM_Try, /*On fail goto*//*Label 21300*/ GIMT_Encode4(1534405), // Rule ID 18598 //
     /* 1534328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1534331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1534345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534367 */     // MIs[0] round
     /* 1534367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534370 */     // MIs[0] policy
     /* 1534370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534380 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1534383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534391 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534404 */     // GIR_Coverage, 18598,
     /* 1534404 */     GIR_EraseRootFromParent_Done,
     /* 1534405 */   // Label 21300: @1534405
     /* 1534405 */   GIM_Try, /*On fail goto*//*Label 21301*/ GIMT_Encode4(1534487), // Rule ID 18599 //
     /* 1534410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1534413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1534421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1534424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1534427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1534430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534449 */     // MIs[0] round
     /* 1534449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534452 */     // MIs[0] policy
     /* 1534452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534462 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16),
     /* 1534465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534473 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534486 */     // GIR_Coverage, 18599,
     /* 1534486 */     GIR_EraseRootFromParent_Done,
     /* 1534487 */   // Label 21301: @1534487
     /* 1534487 */   GIM_Try, /*On fail goto*//*Label 21302*/ GIMT_Encode4(1534569), // Rule ID 18602 //
     /* 1534492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1534495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1534509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534531 */     // MIs[0] round
     /* 1534531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534534 */     // MIs[0] policy
     /* 1534534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534544 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1534547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534555 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534568 */     // GIR_Coverage, 18602,
     /* 1534568 */     GIR_EraseRootFromParent_Done,
     /* 1534569 */   // Label 21302: @1534569
     /* 1534569 */   GIM_Try, /*On fail goto*//*Label 21303*/ GIMT_Encode4(1534651), // Rule ID 18603 //
     /* 1534574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1534577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1534585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1534588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1534591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1534594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1534613 */     // MIs[0] round
     /* 1534613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534616 */     // MIs[0] policy
     /* 1534616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534626 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16),
     /* 1534629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534637 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534650 */     // GIR_Coverage, 18603,
     /* 1534650 */     GIR_EraseRootFromParent_Done,
     /* 1534651 */   // Label 21303: @1534651
     /* 1534651 */   GIM_Try, /*On fail goto*//*Label 21304*/ GIMT_Encode4(1534733), // Rule ID 18606 //
     /* 1534656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1534659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1534667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1534670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1534673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534695 */     // MIs[0] round
     /* 1534695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534698 */     // MIs[0] policy
     /* 1534698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534708 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1534711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534719 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534732 */     // GIR_Coverage, 18606,
     /* 1534732 */     GIR_EraseRootFromParent_Done,
     /* 1534733 */   // Label 21304: @1534733
     /* 1534733 */   GIM_Try, /*On fail goto*//*Label 21305*/ GIMT_Encode4(1534815), // Rule ID 18607 //
     /* 1534738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1534741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1534749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1534752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1534755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1534758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1534777 */     // MIs[0] round
     /* 1534777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534780 */     // MIs[0] policy
     /* 1534780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534790 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16),
     /* 1534793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534801 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534814 */     // GIR_Coverage, 18607,
     /* 1534814 */     GIR_EraseRootFromParent_Done,
     /* 1534815 */   // Label 21305: @1534815
     /* 1534815 */   GIM_Try, /*On fail goto*//*Label 21306*/ GIMT_Encode4(1534897), // Rule ID 18610 //
     /* 1534820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1534823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1534831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1534834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1534837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1534843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534859 */     // MIs[0] round
     /* 1534859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534862 */     // MIs[0] policy
     /* 1534862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534872 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1534872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1534875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534883 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534896 */     // GIR_Coverage, 18610,
     /* 1534896 */     GIR_EraseRootFromParent_Done,
     /* 1534897 */   // Label 21306: @1534897
     /* 1534897 */   GIM_Try, /*On fail goto*//*Label 21307*/ GIMT_Encode4(1534979), // Rule ID 18611 //
     /* 1534902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1534905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1534913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1534916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1534919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1534922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1534925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1534933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1534941 */     // MIs[0] round
     /* 1534941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1534944 */     // MIs[0] policy
     /* 1534944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1534947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1534954 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1534954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16),
     /* 1534957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1534959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1534961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1534963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1534965 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1534967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1534972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1534975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1534977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1534978 */     // GIR_Coverage, 18611,
     /* 1534978 */     GIR_EraseRootFromParent_Done,
     /* 1534979 */   // Label 21307: @1534979
     /* 1534979 */   GIM_Try, /*On fail goto*//*Label 21308*/ GIMT_Encode4(1535061), // Rule ID 18614 //
     /* 1534984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1534987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1534992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1534995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1534998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1535004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535023 */     // MIs[0] round
     /* 1535023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535026 */     // MIs[0] policy
     /* 1535026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535036 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1535039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535047 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535060 */     // GIR_Coverage, 18614,
     /* 1535060 */     GIR_EraseRootFromParent_Done,
     /* 1535061 */   // Label 21308: @1535061
     /* 1535061 */   GIM_Try, /*On fail goto*//*Label 21309*/ GIMT_Encode4(1535143), // Rule ID 18615 //
     /* 1535066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1535069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1535077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1535080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1535083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1535086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535105 */     // MIs[0] round
     /* 1535105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535108 */     // MIs[0] policy
     /* 1535108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535118 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32),
     /* 1535121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535129 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535142 */     // GIR_Coverage, 18615,
     /* 1535142 */     GIR_EraseRootFromParent_Done,
     /* 1535143 */   // Label 21309: @1535143
     /* 1535143 */   GIM_Try, /*On fail goto*//*Label 21310*/ GIMT_Encode4(1535225), // Rule ID 18618 //
     /* 1535148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1535151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1535165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1535168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535187 */     // MIs[0] round
     /* 1535187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535190 */     // MIs[0] policy
     /* 1535190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535200 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1535203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535211 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535224 */     // GIR_Coverage, 18618,
     /* 1535224 */     GIR_EraseRootFromParent_Done,
     /* 1535225 */   // Label 21310: @1535225
     /* 1535225 */   GIM_Try, /*On fail goto*//*Label 21311*/ GIMT_Encode4(1535307), // Rule ID 18619 //
     /* 1535230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1535233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1535241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1535244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1535247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1535250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535269 */     // MIs[0] round
     /* 1535269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535272 */     // MIs[0] policy
     /* 1535272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535282 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32),
     /* 1535285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535293 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535306 */     // GIR_Coverage, 18619,
     /* 1535306 */     GIR_EraseRootFromParent_Done,
     /* 1535307 */   // Label 21311: @1535307
     /* 1535307 */   GIM_Try, /*On fail goto*//*Label 21312*/ GIMT_Encode4(1535389), // Rule ID 18622 //
     /* 1535312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1535315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1535329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535351 */     // MIs[0] round
     /* 1535351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535354 */     // MIs[0] policy
     /* 1535354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535364 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1535367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535375 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535388 */     // GIR_Coverage, 18622,
     /* 1535388 */     GIR_EraseRootFromParent_Done,
     /* 1535389 */   // Label 21312: @1535389
     /* 1535389 */   GIM_Try, /*On fail goto*//*Label 21313*/ GIMT_Encode4(1535471), // Rule ID 18623 //
     /* 1535394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1535397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1535405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1535408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1535411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1535414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535433 */     // MIs[0] round
     /* 1535433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535436 */     // MIs[0] policy
     /* 1535436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535446 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32),
     /* 1535449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535457 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535470 */     // GIR_Coverage, 18623,
     /* 1535470 */     GIR_EraseRootFromParent_Done,
     /* 1535471 */   // Label 21313: @1535471
     /* 1535471 */   GIM_Try, /*On fail goto*//*Label 21314*/ GIMT_Encode4(1535553), // Rule ID 18626 //
     /* 1535476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1535479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1535493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535515 */     // MIs[0] round
     /* 1535515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535518 */     // MIs[0] policy
     /* 1535518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535528 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1535531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535539 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535552 */     // GIR_Coverage, 18626,
     /* 1535552 */     GIR_EraseRootFromParent_Done,
     /* 1535553 */   // Label 21314: @1535553
     /* 1535553 */   GIM_Try, /*On fail goto*//*Label 21315*/ GIMT_Encode4(1535635), // Rule ID 18627 //
     /* 1535558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1535561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1535569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1535572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1535575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1535578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1535589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1535597 */     // MIs[0] round
     /* 1535597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535600 */     // MIs[0] policy
     /* 1535600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535610 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32),
     /* 1535613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535621 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1535631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535634 */     // GIR_Coverage, 18627,
     /* 1535634 */     GIR_EraseRootFromParent_Done,
     /* 1535635 */   // Label 21315: @1535635
     /* 1535635 */   GIM_Try, /*On fail goto*//*Label 21316*/ GIMT_Encode4(1535717), // Rule ID 18630 //
     /* 1535640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1535643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535679 */     // MIs[0] round
     /* 1535679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535682 */     // MIs[0] policy
     /* 1535682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535692 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1535695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535703 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535716 */     // GIR_Coverage, 18630,
     /* 1535716 */     GIR_EraseRootFromParent_Done,
     /* 1535717 */   // Label 21316: @1535717
     /* 1535717 */   GIM_Try, /*On fail goto*//*Label 21317*/ GIMT_Encode4(1535799), // Rule ID 18631 //
     /* 1535722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1535725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1535733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1535736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1535742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535761 */     // MIs[0] round
     /* 1535761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535764 */     // MIs[0] policy
     /* 1535764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535774 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16),
     /* 1535777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535785 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535798 */     // GIR_Coverage, 18631,
     /* 1535798 */     GIR_EraseRootFromParent_Done,
     /* 1535799 */   // Label 21317: @1535799
     /* 1535799 */   GIM_Try, /*On fail goto*//*Label 21318*/ GIMT_Encode4(1535881), // Rule ID 18634 //
     /* 1535804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1535807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1535815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1535818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1535824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535843 */     // MIs[0] round
     /* 1535843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535846 */     // MIs[0] policy
     /* 1535846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1535856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1535859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535867 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535880 */     // GIR_Coverage, 18634,
     /* 1535880 */     GIR_EraseRootFromParent_Done,
     /* 1535881 */   // Label 21318: @1535881
     /* 1535881 */   GIM_Try, /*On fail goto*//*Label 21319*/ GIMT_Encode4(1535963), // Rule ID 18635 //
     /* 1535886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1535889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1535897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1535900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1535906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1535909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1535921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1535925 */     // MIs[0] round
     /* 1535925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1535928 */     // MIs[0] policy
     /* 1535928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1535931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1535938 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11230:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1535938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16),
     /* 1535941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1535943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1535945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1535947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1535949 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1535951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1535956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1535959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1535961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1535962 */     // GIR_Coverage, 18635,
     /* 1535962 */     GIR_EraseRootFromParent_Done,
     /* 1535963 */   // Label 21319: @1535963
     /* 1535963 */   GIM_Try, /*On fail goto*//*Label 21320*/ GIMT_Encode4(1536045), // Rule ID 18638 //
     /* 1535968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1535971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1535976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1535979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1535982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1535985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1535988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1535991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1535999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536007 */     // MIs[0] round
     /* 1536007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536010 */     // MIs[0] policy
     /* 1536010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1536023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536031 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536044 */     // GIR_Coverage, 18638,
     /* 1536044 */     GIR_EraseRootFromParent_Done,
     /* 1536045 */   // Label 21320: @1536045
     /* 1536045 */   GIM_Try, /*On fail goto*//*Label 21321*/ GIMT_Encode4(1536127), // Rule ID 18639 //
     /* 1536050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1536053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1536061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1536064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1536070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536089 */     // MIs[0] round
     /* 1536089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536092 */     // MIs[0] policy
     /* 1536092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536102 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16),
     /* 1536105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536113 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536126 */     // GIR_Coverage, 18639,
     /* 1536126 */     GIR_EraseRootFromParent_Done,
     /* 1536127 */   // Label 21321: @1536127
     /* 1536127 */   GIM_Try, /*On fail goto*//*Label 21322*/ GIMT_Encode4(1536209), // Rule ID 18642 //
     /* 1536132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1536135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536171 */     // MIs[0] round
     /* 1536171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536174 */     // MIs[0] policy
     /* 1536174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536184 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1536187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536195 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536208 */     // GIR_Coverage, 18642,
     /* 1536208 */     GIR_EraseRootFromParent_Done,
     /* 1536209 */   // Label 21322: @1536209
     /* 1536209 */   GIM_Try, /*On fail goto*//*Label 21323*/ GIMT_Encode4(1536291), // Rule ID 18643 //
     /* 1536214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1536217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1536225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1536228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1536234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536253 */     // MIs[0] round
     /* 1536253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536256 */     // MIs[0] policy
     /* 1536256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536266 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16),
     /* 1536269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536277 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536290 */     // GIR_Coverage, 18643,
     /* 1536290 */     GIR_EraseRootFromParent_Done,
     /* 1536291 */   // Label 21323: @1536291
     /* 1536291 */   GIM_Try, /*On fail goto*//*Label 21324*/ GIMT_Encode4(1536373), // Rule ID 18646 //
     /* 1536296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1536299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1536316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536335 */     // MIs[0] round
     /* 1536335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536338 */     // MIs[0] policy
     /* 1536338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536348 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1536351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536359 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536372 */     // GIR_Coverage, 18646,
     /* 1536372 */     GIR_EraseRootFromParent_Done,
     /* 1536373 */   // Label 21324: @1536373
     /* 1536373 */   GIM_Try, /*On fail goto*//*Label 21325*/ GIMT_Encode4(1536455), // Rule ID 18647 //
     /* 1536378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1536381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1536389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1536392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1536395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1536398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1536413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536417 */     // MIs[0] round
     /* 1536417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536420 */     // MIs[0] policy
     /* 1536420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536430 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16),
     /* 1536433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536441 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1536451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536454 */     // GIR_Coverage, 18647,
     /* 1536454 */     GIR_EraseRootFromParent_Done,
     /* 1536455 */   // Label 21325: @1536455
     /* 1536455 */   GIM_Try, /*On fail goto*//*Label 21326*/ GIMT_Encode4(1536537), // Rule ID 18650 //
     /* 1536460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1536463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536499 */     // MIs[0] round
     /* 1536499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536502 */     // MIs[0] policy
     /* 1536502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536512 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1536515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536523 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536536 */     // GIR_Coverage, 18650,
     /* 1536536 */     GIR_EraseRootFromParent_Done,
     /* 1536537 */   // Label 21326: @1536537
     /* 1536537 */   GIM_Try, /*On fail goto*//*Label 21327*/ GIMT_Encode4(1536619), // Rule ID 18651 //
     /* 1536542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1536545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1536553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1536556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1536562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536581 */     // MIs[0] round
     /* 1536581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536584 */     // MIs[0] policy
     /* 1536584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536594 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11230:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32),
     /* 1536597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536605 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536618 */     // GIR_Coverage, 18651,
     /* 1536618 */     GIR_EraseRootFromParent_Done,
     /* 1536619 */   // Label 21327: @1536619
     /* 1536619 */   GIM_Try, /*On fail goto*//*Label 21328*/ GIMT_Encode4(1536701), // Rule ID 18654 //
     /* 1536624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1536627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536663 */     // MIs[0] round
     /* 1536663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536666 */     // MIs[0] policy
     /* 1536666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536676 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1536679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536687 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536700 */     // GIR_Coverage, 18654,
     /* 1536700 */     GIR_EraseRootFromParent_Done,
     /* 1536701 */   // Label 21328: @1536701
     /* 1536701 */   GIM_Try, /*On fail goto*//*Label 21329*/ GIMT_Encode4(1536783), // Rule ID 18655 //
     /* 1536706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1536709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1536717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1536720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1536726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1536745 */     // MIs[0] round
     /* 1536745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536748 */     // MIs[0] policy
     /* 1536748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536758 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11230:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32),
     /* 1536761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536769 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536782 */     // GIR_Coverage, 18655,
     /* 1536782 */     GIR_EraseRootFromParent_Done,
     /* 1536783 */   // Label 21329: @1536783
     /* 1536783 */   GIM_Try, /*On fail goto*//*Label 21330*/ GIMT_Encode4(1536865), // Rule ID 18658 //
     /* 1536788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1536791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1536808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536827 */     // MIs[0] round
     /* 1536827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536830 */     // MIs[0] policy
     /* 1536830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536840 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1536840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1536843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536851 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536864 */     // GIR_Coverage, 18658,
     /* 1536864 */     GIR_EraseRootFromParent_Done,
     /* 1536865 */   // Label 21330: @1536865
     /* 1536865 */   GIM_Try, /*On fail goto*//*Label 21331*/ GIMT_Encode4(1536947), // Rule ID 18659 //
     /* 1536870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1536873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1536881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1536884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1536890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1536893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1536909 */     // MIs[0] round
     /* 1536909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536912 */     // MIs[0] policy
     /* 1536912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1536922 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11230:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1536922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32),
     /* 1536925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1536927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1536929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1536931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1536933 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1536935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1536940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1536943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1536945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1536946 */     // GIR_Coverage, 18659,
     /* 1536946 */     GIR_EraseRootFromParent_Done,
     /* 1536947 */   // Label 21331: @1536947
     /* 1536947 */   GIM_Try, /*On fail goto*//*Label 21332*/ GIMT_Encode4(1537029), // Rule ID 18662 //
     /* 1536952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1536955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1536960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1536963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1536966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1536969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1536972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1536975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1536983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1536987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1536991 */     // MIs[0] round
     /* 1536991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1536994 */     // MIs[0] policy
     /* 1536994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1536997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537004 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1537007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537015 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537028 */     // GIR_Coverage, 18662,
     /* 1537028 */     GIR_EraseRootFromParent_Done,
     /* 1537029 */   // Label 21332: @1537029
     /* 1537029 */   GIM_Try, /*On fail goto*//*Label 21333*/ GIMT_Encode4(1537111), // Rule ID 18663 //
     /* 1537034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1537037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc),
     /* 1537042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1537045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1537048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1537051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1537054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1537069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537073 */     // MIs[0] round
     /* 1537073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537076 */     // MIs[0] policy
     /* 1537076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537086 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11230:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32),
     /* 1537089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537097 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1537107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537110 */     // GIR_Coverage, 18663,
     /* 1537110 */     GIR_EraseRootFromParent_Done,
     /* 1537111 */   // Label 21333: @1537111
     /* 1537111 */   GIM_Try, /*On fail goto*//*Label 21334*/ GIMT_Encode4(1537193), // Rule ID 18666 //
     /* 1537116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1537119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1537127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1537130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1537133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1537136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537155 */     // MIs[0] round
     /* 1537155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537158 */     // MIs[0] policy
     /* 1537158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537168 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1537171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537179 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537192 */     // GIR_Coverage, 18666,
     /* 1537192 */     GIR_EraseRootFromParent_Done,
     /* 1537193 */   // Label 21334: @1537193
     /* 1537193 */   GIM_Try, /*On fail goto*//*Label 21335*/ GIMT_Encode4(1537275), // Rule ID 18667 //
     /* 1537198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1537201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1537209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1537212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1537215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1537218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537237 */     // MIs[0] round
     /* 1537237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537240 */     // MIs[0] policy
     /* 1537240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537250 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16),
     /* 1537253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537261 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537274 */     // GIR_Coverage, 18667,
     /* 1537274 */     GIR_EraseRootFromParent_Done,
     /* 1537275 */   // Label 21335: @1537275
     /* 1537275 */   GIM_Try, /*On fail goto*//*Label 21336*/ GIMT_Encode4(1537357), // Rule ID 18670 //
     /* 1537280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1537283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1537297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1537300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537319 */     // MIs[0] round
     /* 1537319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537322 */     // MIs[0] policy
     /* 1537322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537332 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1537335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537343 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537356 */     // GIR_Coverage, 18670,
     /* 1537356 */     GIR_EraseRootFromParent_Done,
     /* 1537357 */   // Label 21336: @1537357
     /* 1537357 */   GIM_Try, /*On fail goto*//*Label 21337*/ GIMT_Encode4(1537439), // Rule ID 18671 //
     /* 1537362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1537365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1537373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1537376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1537379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1537382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537401 */     // MIs[0] round
     /* 1537401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537404 */     // MIs[0] policy
     /* 1537404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16),
     /* 1537417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537425 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537438 */     // GIR_Coverage, 18671,
     /* 1537438 */     GIR_EraseRootFromParent_Done,
     /* 1537439 */   // Label 21337: @1537439
     /* 1537439 */   GIM_Try, /*On fail goto*//*Label 21338*/ GIMT_Encode4(1537521), // Rule ID 18674 //
     /* 1537444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1537447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1537461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1537464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537483 */     // MIs[0] round
     /* 1537483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537486 */     // MIs[0] policy
     /* 1537486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537496 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1537499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537507 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537520 */     // GIR_Coverage, 18674,
     /* 1537520 */     GIR_EraseRootFromParent_Done,
     /* 1537521 */   // Label 21338: @1537521
     /* 1537521 */   GIM_Try, /*On fail goto*//*Label 21339*/ GIMT_Encode4(1537603), // Rule ID 18675 //
     /* 1537526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1537529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1537537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1537540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1537543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1537546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537565 */     // MIs[0] round
     /* 1537565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537568 */     // MIs[0] policy
     /* 1537568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537578 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16),
     /* 1537581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537589 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537602 */     // GIR_Coverage, 18675,
     /* 1537602 */     GIR_EraseRootFromParent_Done,
     /* 1537603 */   // Label 21339: @1537603
     /* 1537603 */   GIM_Try, /*On fail goto*//*Label 21340*/ GIMT_Encode4(1537685), // Rule ID 18678 //
     /* 1537608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1537611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537647 */     // MIs[0] round
     /* 1537647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537650 */     // MIs[0] policy
     /* 1537650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537660 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1537663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537671 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537684 */     // GIR_Coverage, 18678,
     /* 1537684 */     GIR_EraseRootFromParent_Done,
     /* 1537685 */   // Label 21340: @1537685
     /* 1537685 */   GIM_Try, /*On fail goto*//*Label 21341*/ GIMT_Encode4(1537767), // Rule ID 18679 //
     /* 1537690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1537693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1537701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1537704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1537707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1537710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1537729 */     // MIs[0] round
     /* 1537729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537732 */     // MIs[0] policy
     /* 1537732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537742 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16),
     /* 1537745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537753 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537766 */     // GIR_Coverage, 18679,
     /* 1537766 */     GIR_EraseRootFromParent_Done,
     /* 1537767 */   // Label 21341: @1537767
     /* 1537767 */   GIM_Try, /*On fail goto*//*Label 21342*/ GIMT_Encode4(1537849), // Rule ID 18682 //
     /* 1537772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1537775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537811 */     // MIs[0] round
     /* 1537811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537814 */     // MIs[0] policy
     /* 1537814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537824 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1537827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537835 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537848 */     // GIR_Coverage, 18682,
     /* 1537848 */     GIR_EraseRootFromParent_Done,
     /* 1537849 */   // Label 21342: @1537849
     /* 1537849 */   GIM_Try, /*On fail goto*//*Label 21343*/ GIMT_Encode4(1537931), // Rule ID 18683 //
     /* 1537854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1537857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1537865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1537868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1537871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1537874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1537877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1537885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1537893 */     // MIs[0] round
     /* 1537893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537896 */     // MIs[0] policy
     /* 1537896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537906 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1537906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16),
     /* 1537909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537917 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1537919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1537924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1537927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1537929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1537930 */     // GIR_Coverage, 18683,
     /* 1537930 */     GIR_EraseRootFromParent_Done,
     /* 1537931 */   // Label 21343: @1537931
     /* 1537931 */   GIM_Try, /*On fail goto*//*Label 21344*/ GIMT_Encode4(1538013), // Rule ID 18686 //
     /* 1537936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1537939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1537944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1537947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1537950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1537953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1537956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1537959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1537975 */     // MIs[0] round
     /* 1537975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1537978 */     // MIs[0] policy
     /* 1537978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1537981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1537988 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1537988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1537991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1537993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1537995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1537997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1537999 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538012 */     // GIR_Coverage, 18686,
     /* 1538012 */     GIR_EraseRootFromParent_Done,
     /* 1538013 */   // Label 21344: @1538013
     /* 1538013 */   GIM_Try, /*On fail goto*//*Label 21345*/ GIMT_Encode4(1538095), // Rule ID 18687 //
     /* 1538018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1538021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1538029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1538032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1538035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1538038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538057 */     // MIs[0] round
     /* 1538057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538060 */     // MIs[0] policy
     /* 1538060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538070 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32),
     /* 1538073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538081 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538094 */     // GIR_Coverage, 18687,
     /* 1538094 */     GIR_EraseRootFromParent_Done,
     /* 1538095 */   // Label 21345: @1538095
     /* 1538095 */   GIM_Try, /*On fail goto*//*Label 21346*/ GIMT_Encode4(1538177), // Rule ID 18690 //
     /* 1538100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1538103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1538117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1538120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538139 */     // MIs[0] round
     /* 1538139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538142 */     // MIs[0] policy
     /* 1538142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538152 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1538155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538163 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538176 */     // GIR_Coverage, 18690,
     /* 1538176 */     GIR_EraseRootFromParent_Done,
     /* 1538177 */   // Label 21346: @1538177
     /* 1538177 */   GIM_Try, /*On fail goto*//*Label 21347*/ GIMT_Encode4(1538259), // Rule ID 18691 //
     /* 1538182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1538185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1538193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1538196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1538199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1538202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538221 */     // MIs[0] round
     /* 1538221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538224 */     // MIs[0] policy
     /* 1538224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538234 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32),
     /* 1538237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538245 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538258 */     // GIR_Coverage, 18691,
     /* 1538258 */     GIR_EraseRootFromParent_Done,
     /* 1538259 */   // Label 21347: @1538259
     /* 1538259 */   GIM_Try, /*On fail goto*//*Label 21348*/ GIMT_Encode4(1538341), // Rule ID 18694 //
     /* 1538264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1538267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1538281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1538284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538303 */     // MIs[0] round
     /* 1538303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538306 */     // MIs[0] policy
     /* 1538306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538316 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1538319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538327 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538340 */     // GIR_Coverage, 18694,
     /* 1538340 */     GIR_EraseRootFromParent_Done,
     /* 1538341 */   // Label 21348: @1538341
     /* 1538341 */   GIM_Try, /*On fail goto*//*Label 21349*/ GIMT_Encode4(1538423), // Rule ID 18695 //
     /* 1538346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1538349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1538357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1538360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1538363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1538366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538385 */     // MIs[0] round
     /* 1538385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538388 */     // MIs[0] policy
     /* 1538388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538398 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32),
     /* 1538401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538409 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538422 */     // GIR_Coverage, 18695,
     /* 1538422 */     GIR_EraseRootFromParent_Done,
     /* 1538423 */   // Label 21349: @1538423
     /* 1538423 */   GIM_Try, /*On fail goto*//*Label 21350*/ GIMT_Encode4(1538505), // Rule ID 18698 //
     /* 1538428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1538431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538467 */     // MIs[0] round
     /* 1538467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538470 */     // MIs[0] policy
     /* 1538470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538480 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1538483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538491 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538504 */     // GIR_Coverage, 18698,
     /* 1538504 */     GIR_EraseRootFromParent_Done,
     /* 1538505 */   // Label 21350: @1538505
     /* 1538505 */   GIM_Try, /*On fail goto*//*Label 21351*/ GIMT_Encode4(1538587), // Rule ID 18699 //
     /* 1538510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1538513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1538521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1538524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1538527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1538530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1538541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1538549 */     // MIs[0] round
     /* 1538549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538552 */     // MIs[0] policy
     /* 1538552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538562 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32),
     /* 1538565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538573 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1538583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538586 */     // GIR_Coverage, 18699,
     /* 1538586 */     GIR_EraseRootFromParent_Done,
     /* 1538587 */   // Label 21351: @1538587
     /* 1538587 */   GIM_Try, /*On fail goto*//*Label 21352*/ GIMT_Encode4(1538669), // Rule ID 18702 //
     /* 1538592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538631 */     // MIs[0] round
     /* 1538631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538634 */     // MIs[0] policy
     /* 1538634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538644 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1538647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538655 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538668 */     // GIR_Coverage, 18702,
     /* 1538668 */     GIR_EraseRootFromParent_Done,
     /* 1538669 */   // Label 21352: @1538669
     /* 1538669 */   GIM_Try, /*On fail goto*//*Label 21353*/ GIMT_Encode4(1538751), // Rule ID 18703 //
     /* 1538674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1538677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1538685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1538688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1538694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538713 */     // MIs[0] round
     /* 1538713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538716 */     // MIs[0] policy
     /* 1538716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538726 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16),
     /* 1538729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538737 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538750 */     // GIR_Coverage, 18703,
     /* 1538750 */     GIR_EraseRootFromParent_Done,
     /* 1538751 */   // Label 21353: @1538751
     /* 1538751 */   GIM_Try, /*On fail goto*//*Label 21354*/ GIMT_Encode4(1538833), // Rule ID 18706 //
     /* 1538756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538795 */     // MIs[0] round
     /* 1538795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538798 */     // MIs[0] policy
     /* 1538798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538808 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1538811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538819 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538832 */     // GIR_Coverage, 18706,
     /* 1538832 */     GIR_EraseRootFromParent_Done,
     /* 1538833 */   // Label 21354: @1538833
     /* 1538833 */   GIM_Try, /*On fail goto*//*Label 21355*/ GIMT_Encode4(1538915), // Rule ID 18707 //
     /* 1538838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1538841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1538849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1538852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1538858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1538861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538877 */     // MIs[0] round
     /* 1538877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538880 */     // MIs[0] policy
     /* 1538880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538890 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11238:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1538890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16),
     /* 1538893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538901 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538914 */     // GIR_Coverage, 18707,
     /* 1538914 */     GIR_EraseRootFromParent_Done,
     /* 1538915 */   // Label 21355: @1538915
     /* 1538915 */   GIM_Try, /*On fail goto*//*Label 21356*/ GIMT_Encode4(1538997), // Rule ID 18710 //
     /* 1538920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1538923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1538928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1538931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1538934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1538937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1538940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1538943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1538951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1538955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1538959 */     // MIs[0] round
     /* 1538959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1538962 */     // MIs[0] policy
     /* 1538962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1538965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1538972 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1538972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1538975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1538977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1538979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1538981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1538983 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1538985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1538990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1538993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1538995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1538996 */     // GIR_Coverage, 18710,
     /* 1538996 */     GIR_EraseRootFromParent_Done,
     /* 1538997 */   // Label 21356: @1538997
     /* 1538997 */   GIM_Try, /*On fail goto*//*Label 21357*/ GIMT_Encode4(1539079), // Rule ID 18711 //
     /* 1539002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1539005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1539013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1539016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1539022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539041 */     // MIs[0] round
     /* 1539041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539044 */     // MIs[0] policy
     /* 1539044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16),
     /* 1539057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539065 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539078 */     // GIR_Coverage, 18711,
     /* 1539078 */     GIR_EraseRootFromParent_Done,
     /* 1539079 */   // Label 21357: @1539079
     /* 1539079 */   GIM_Try, /*On fail goto*//*Label 21358*/ GIMT_Encode4(1539161), // Rule ID 18714 //
     /* 1539084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1539087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539123 */     // MIs[0] round
     /* 1539123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539126 */     // MIs[0] policy
     /* 1539126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539136 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1539139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539147 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539160 */     // GIR_Coverage, 18714,
     /* 1539160 */     GIR_EraseRootFromParent_Done,
     /* 1539161 */   // Label 21358: @1539161
     /* 1539161 */   GIM_Try, /*On fail goto*//*Label 21359*/ GIMT_Encode4(1539243), // Rule ID 18715 //
     /* 1539166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1539169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1539177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1539180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1539186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539205 */     // MIs[0] round
     /* 1539205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539208 */     // MIs[0] policy
     /* 1539208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539218 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16),
     /* 1539221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539229 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539242 */     // GIR_Coverage, 18715,
     /* 1539242 */     GIR_EraseRootFromParent_Done,
     /* 1539243 */   // Label 21359: @1539243
     /* 1539243 */   GIM_Try, /*On fail goto*//*Label 21360*/ GIMT_Encode4(1539325), // Rule ID 18718 //
     /* 1539248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1539251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539287 */     // MIs[0] round
     /* 1539287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539290 */     // MIs[0] policy
     /* 1539290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539300 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1539303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539311 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539324 */     // GIR_Coverage, 18718,
     /* 1539324 */     GIR_EraseRootFromParent_Done,
     /* 1539325 */   // Label 21360: @1539325
     /* 1539325 */   GIM_Try, /*On fail goto*//*Label 21361*/ GIMT_Encode4(1539407), // Rule ID 18719 //
     /* 1539330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1539333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1539341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1539344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1539347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1539350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1539365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539369 */     // MIs[0] round
     /* 1539369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539372 */     // MIs[0] policy
     /* 1539372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539382 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16),
     /* 1539385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539393 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1539403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539406 */     // GIR_Coverage, 18719,
     /* 1539406 */     GIR_EraseRootFromParent_Done,
     /* 1539407 */   // Label 21361: @1539407
     /* 1539407 */   GIM_Try, /*On fail goto*//*Label 21362*/ GIMT_Encode4(1539489), // Rule ID 18722 //
     /* 1539412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539451 */     // MIs[0] round
     /* 1539451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539454 */     // MIs[0] policy
     /* 1539454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539464 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1539467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539475 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539488 */     // GIR_Coverage, 18722,
     /* 1539488 */     GIR_EraseRootFromParent_Done,
     /* 1539489 */   // Label 21362: @1539489
     /* 1539489 */   GIM_Try, /*On fail goto*//*Label 21363*/ GIMT_Encode4(1539571), // Rule ID 18723 //
     /* 1539494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1539505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1539508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1539514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539533 */     // MIs[0] round
     /* 1539533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539536 */     // MIs[0] policy
     /* 1539536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539546 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11238:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32),
     /* 1539549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539557 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539570 */     // GIR_Coverage, 18723,
     /* 1539570 */     GIR_EraseRootFromParent_Done,
     /* 1539571 */   // Label 21363: @1539571
     /* 1539571 */   GIM_Try, /*On fail goto*//*Label 21364*/ GIMT_Encode4(1539653), // Rule ID 18726 //
     /* 1539576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539615 */     // MIs[0] round
     /* 1539615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539618 */     // MIs[0] policy
     /* 1539618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539628 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1539631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539639 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539652 */     // GIR_Coverage, 18726,
     /* 1539652 */     GIR_EraseRootFromParent_Done,
     /* 1539653 */   // Label 21364: @1539653
     /* 1539653 */   GIM_Try, /*On fail goto*//*Label 21365*/ GIMT_Encode4(1539735), // Rule ID 18727 //
     /* 1539658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1539669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1539672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1539678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1539697 */     // MIs[0] round
     /* 1539697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539700 */     // MIs[0] policy
     /* 1539700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539710 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11238:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32),
     /* 1539713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539721 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539734 */     // GIR_Coverage, 18727,
     /* 1539734 */     GIR_EraseRootFromParent_Done,
     /* 1539735 */   // Label 21365: @1539735
     /* 1539735 */   GIM_Try, /*On fail goto*//*Label 21366*/ GIMT_Encode4(1539817), // Rule ID 18730 //
     /* 1539740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539779 */     // MIs[0] round
     /* 1539779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539782 */     // MIs[0] policy
     /* 1539782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539792 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1539795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539803 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539816 */     // GIR_Coverage, 18730,
     /* 1539816 */     GIR_EraseRootFromParent_Done,
     /* 1539817 */   // Label 21366: @1539817
     /* 1539817 */   GIM_Try, /*On fail goto*//*Label 21367*/ GIMT_Encode4(1539899), // Rule ID 18731 //
     /* 1539822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1539833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1539836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1539842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1539845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1539861 */     // MIs[0] round
     /* 1539861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539864 */     // MIs[0] policy
     /* 1539864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539874 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11238:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1539874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32),
     /* 1539877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539885 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539898 */     // GIR_Coverage, 18731,
     /* 1539898 */     GIR_EraseRootFromParent_Done,
     /* 1539899 */   // Label 21367: @1539899
     /* 1539899 */   GIM_Try, /*On fail goto*//*Label 21368*/ GIMT_Encode4(1539981), // Rule ID 18734 //
     /* 1539904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1539907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1539918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1539921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1539924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1539927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1539935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1539939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1539943 */     // MIs[0] round
     /* 1539943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1539946 */     // MIs[0] policy
     /* 1539946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1539949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1539956 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1539956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1539959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1539961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1539963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1539965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1539967 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1539969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1539974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1539977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1539979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1539980 */     // GIR_Coverage, 18734,
     /* 1539980 */     GIR_EraseRootFromParent_Done,
     /* 1539981 */   // Label 21368: @1539981
     /* 1539981 */   GIM_Try, /*On fail goto*//*Label 21369*/ GIMT_Encode4(1540063), // Rule ID 18735 //
     /* 1539986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1539989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc),
     /* 1539994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1539997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1540000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1540003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1540006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1540021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540025 */     // MIs[0] round
     /* 1540025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540028 */     // MIs[0] policy
     /* 1540028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540038 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11238:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32),
     /* 1540041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540049 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540062 */     // GIR_Coverage, 18735,
     /* 1540062 */     GIR_EraseRootFromParent_Done,
     /* 1540063 */   // Label 21369: @1540063
     /* 1540063 */   GIM_Try, /*On fail goto*//*Label 21370*/ GIMT_Encode4(1540145), // Rule ID 18738 //
     /* 1540068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540107 */     // MIs[0] round
     /* 1540107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540110 */     // MIs[0] policy
     /* 1540110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540120 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1540123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540131 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540144 */     // GIR_Coverage, 18738,
     /* 1540144 */     GIR_EraseRootFromParent_Done,
     /* 1540145 */   // Label 21370: @1540145
     /* 1540145 */   GIM_Try, /*On fail goto*//*Label 21371*/ GIMT_Encode4(1540227), // Rule ID 18739 //
     /* 1540150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1540161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1540164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1540167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1540170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540189 */     // MIs[0] round
     /* 1540189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540192 */     // MIs[0] policy
     /* 1540192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540202 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16),
     /* 1540205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540213 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540226 */     // GIR_Coverage, 18739,
     /* 1540226 */     GIR_EraseRootFromParent_Done,
     /* 1540227 */   // Label 21371: @1540227
     /* 1540227 */   GIM_Try, /*On fail goto*//*Label 21372*/ GIMT_Encode4(1540309), // Rule ID 18742 //
     /* 1540232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540271 */     // MIs[0] round
     /* 1540271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540274 */     // MIs[0] policy
     /* 1540274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540284 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1540287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540295 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540308 */     // GIR_Coverage, 18742,
     /* 1540308 */     GIR_EraseRootFromParent_Done,
     /* 1540309 */   // Label 21372: @1540309
     /* 1540309 */   GIM_Try, /*On fail goto*//*Label 21373*/ GIMT_Encode4(1540391), // Rule ID 18743 //
     /* 1540314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1540325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1540328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1540331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1540334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540353 */     // MIs[0] round
     /* 1540353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540356 */     // MIs[0] policy
     /* 1540356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540366 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16),
     /* 1540369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540377 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540390 */     // GIR_Coverage, 18743,
     /* 1540390 */     GIR_EraseRootFromParent_Done,
     /* 1540391 */   // Label 21373: @1540391
     /* 1540391 */   GIM_Try, /*On fail goto*//*Label 21374*/ GIMT_Encode4(1540473), // Rule ID 18746 //
     /* 1540396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540435 */     // MIs[0] round
     /* 1540435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540438 */     // MIs[0] policy
     /* 1540438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540448 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1540451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540459 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540472 */     // GIR_Coverage, 18746,
     /* 1540472 */     GIR_EraseRootFromParent_Done,
     /* 1540473 */   // Label 21374: @1540473
     /* 1540473 */   GIM_Try, /*On fail goto*//*Label 21375*/ GIMT_Encode4(1540555), // Rule ID 18747 //
     /* 1540478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1540489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1540492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1540495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1540498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540517 */     // MIs[0] round
     /* 1540517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540520 */     // MIs[0] policy
     /* 1540520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540530 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16),
     /* 1540533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540541 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540554 */     // GIR_Coverage, 18747,
     /* 1540554 */     GIR_EraseRootFromParent_Done,
     /* 1540555 */   // Label 21375: @1540555
     /* 1540555 */   GIM_Try, /*On fail goto*//*Label 21376*/ GIMT_Encode4(1540637), // Rule ID 18750 //
     /* 1540560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540599 */     // MIs[0] round
     /* 1540599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540602 */     // MIs[0] policy
     /* 1540602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540612 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1540615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540623 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540636 */     // GIR_Coverage, 18750,
     /* 1540636 */     GIR_EraseRootFromParent_Done,
     /* 1540637 */   // Label 21376: @1540637
     /* 1540637 */   GIM_Try, /*On fail goto*//*Label 21377*/ GIMT_Encode4(1540719), // Rule ID 18751 //
     /* 1540642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1540653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1540656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1540659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1540662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1540681 */     // MIs[0] round
     /* 1540681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540684 */     // MIs[0] policy
     /* 1540684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540694 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16),
     /* 1540697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540705 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540718 */     // GIR_Coverage, 18751,
     /* 1540718 */     GIR_EraseRootFromParent_Done,
     /* 1540719 */   // Label 21377: @1540719
     /* 1540719 */   GIM_Try, /*On fail goto*//*Label 21378*/ GIMT_Encode4(1540801), // Rule ID 18754 //
     /* 1540724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1540727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540763 */     // MIs[0] round
     /* 1540763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540766 */     // MIs[0] policy
     /* 1540766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540776 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1540779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540787 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540800 */     // GIR_Coverage, 18754,
     /* 1540800 */     GIR_EraseRootFromParent_Done,
     /* 1540801 */   // Label 21378: @1540801
     /* 1540801 */   GIM_Try, /*On fail goto*//*Label 21379*/ GIMT_Encode4(1540883), // Rule ID 18755 //
     /* 1540806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1540809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1540817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1540820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1540823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1540826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1540837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1540845 */     // MIs[0] round
     /* 1540845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540848 */     // MIs[0] policy
     /* 1540848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540858 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1540858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16),
     /* 1540861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540869 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1540879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540882 */     // GIR_Coverage, 18755,
     /* 1540882 */     GIR_EraseRootFromParent_Done,
     /* 1540883 */   // Label 21379: @1540883
     /* 1540883 */   GIM_Try, /*On fail goto*//*Label 21380*/ GIMT_Encode4(1540965), // Rule ID 18758 //
     /* 1540888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1540891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1540905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1540911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540927 */     // MIs[0] round
     /* 1540927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1540930 */     // MIs[0] policy
     /* 1540930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1540933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1540940 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1540940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1540943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1540945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1540947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1540949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1540951 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1540953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1540958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1540961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1540963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1540964 */     // GIR_Coverage, 18758,
     /* 1540964 */     GIR_EraseRootFromParent_Done,
     /* 1540965 */   // Label 21380: @1540965
     /* 1540965 */   GIM_Try, /*On fail goto*//*Label 21381*/ GIMT_Encode4(1541047), // Rule ID 18759 //
     /* 1540970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1540973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1540978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1540981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1540984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1540987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1540990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1540993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1540997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541009 */     // MIs[0] round
     /* 1541009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541012 */     // MIs[0] policy
     /* 1541012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32),
     /* 1541025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541033 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541046 */     // GIR_Coverage, 18759,
     /* 1541046 */     GIR_EraseRootFromParent_Done,
     /* 1541047 */   // Label 21381: @1541047
     /* 1541047 */   GIM_Try, /*On fail goto*//*Label 21382*/ GIMT_Encode4(1541129), // Rule ID 18762 //
     /* 1541052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541091 */     // MIs[0] round
     /* 1541091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541094 */     // MIs[0] policy
     /* 1541094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541104 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1541107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541115 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541128 */     // GIR_Coverage, 18762,
     /* 1541128 */     GIR_EraseRootFromParent_Done,
     /* 1541129 */   // Label 21382: @1541129
     /* 1541129 */   GIM_Try, /*On fail goto*//*Label 21383*/ GIMT_Encode4(1541211), // Rule ID 18763 //
     /* 1541134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1541145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1541148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1541151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1541154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541173 */     // MIs[0] round
     /* 1541173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541176 */     // MIs[0] policy
     /* 1541176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32),
     /* 1541189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541197 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541210 */     // GIR_Coverage, 18763,
     /* 1541210 */     GIR_EraseRootFromParent_Done,
     /* 1541211 */   // Label 21383: @1541211
     /* 1541211 */   GIM_Try, /*On fail goto*//*Label 21384*/ GIMT_Encode4(1541293), // Rule ID 18766 //
     /* 1541216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541255 */     // MIs[0] round
     /* 1541255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541258 */     // MIs[0] policy
     /* 1541258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541268 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1541271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541279 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541292 */     // GIR_Coverage, 18766,
     /* 1541292 */     GIR_EraseRootFromParent_Done,
     /* 1541293 */   // Label 21384: @1541293
     /* 1541293 */   GIM_Try, /*On fail goto*//*Label 21385*/ GIMT_Encode4(1541375), // Rule ID 18767 //
     /* 1541298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1541309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1541312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1541315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1541318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541337 */     // MIs[0] round
     /* 1541337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541340 */     // MIs[0] policy
     /* 1541340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541350 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32),
     /* 1541353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541361 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541374 */     // GIR_Coverage, 18767,
     /* 1541374 */     GIR_EraseRootFromParent_Done,
     /* 1541375 */   // Label 21385: @1541375
     /* 1541375 */   GIM_Try, /*On fail goto*//*Label 21386*/ GIMT_Encode4(1541457), // Rule ID 18770 //
     /* 1541380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1541383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541419 */     // MIs[0] round
     /* 1541419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541422 */     // MIs[0] policy
     /* 1541422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541432 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1541435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541443 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541456 */     // GIR_Coverage, 18770,
     /* 1541456 */     GIR_EraseRootFromParent_Done,
     /* 1541457 */   // Label 21386: @1541457
     /* 1541457 */   GIM_Try, /*On fail goto*//*Label 21387*/ GIMT_Encode4(1541539), // Rule ID 18771 //
     /* 1541462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1541465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1541473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1541476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1541479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1541482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1541493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1541501 */     // MIs[0] round
     /* 1541501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541504 */     // MIs[0] policy
     /* 1541504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541514 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32),
     /* 1541517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541525 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1541535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541538 */     // GIR_Coverage, 18771,
     /* 1541538 */     GIR_EraseRootFromParent_Done,
     /* 1541539 */   // Label 21387: @1541539
     /* 1541539 */   GIM_Try, /*On fail goto*//*Label 21388*/ GIMT_Encode4(1541621), // Rule ID 18774 //
     /* 1541544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541564 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541583 */     // MIs[0] round
     /* 1541583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541586 */     // MIs[0] policy
     /* 1541586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541596 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1541599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541607 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541620 */     // GIR_Coverage, 18774,
     /* 1541620 */     GIR_EraseRootFromParent_Done,
     /* 1541621 */   // Label 21388: @1541621
     /* 1541621 */   GIM_Try, /*On fail goto*//*Label 21389*/ GIMT_Encode4(1541703), // Rule ID 18775 //
     /* 1541626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1541637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1541640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1541646 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541665 */     // MIs[0] round
     /* 1541665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541668 */     // MIs[0] policy
     /* 1541668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541678 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16),
     /* 1541681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541689 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541702 */     // GIR_Coverage, 18775,
     /* 1541702 */     GIR_EraseRootFromParent_Done,
     /* 1541703 */   // Label 21389: @1541703
     /* 1541703 */   GIM_Try, /*On fail goto*//*Label 21390*/ GIMT_Encode4(1541785), // Rule ID 18778 //
     /* 1541708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541747 */     // MIs[0] round
     /* 1541747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541750 */     // MIs[0] policy
     /* 1541750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541760 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1541763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541771 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541784 */     // GIR_Coverage, 18778,
     /* 1541784 */     GIR_EraseRootFromParent_Done,
     /* 1541785 */   // Label 21390: @1541785
     /* 1541785 */   GIM_Try, /*On fail goto*//*Label 21391*/ GIMT_Encode4(1541867), // Rule ID 18779 //
     /* 1541790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1541801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1541804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1541810 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541829 */     // MIs[0] round
     /* 1541829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541832 */     // MIs[0] policy
     /* 1541832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541842 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11234:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1541842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16),
     /* 1541845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541853 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541866 */     // GIR_Coverage, 18779,
     /* 1541866 */     GIR_EraseRootFromParent_Done,
     /* 1541867 */   // Label 21391: @1541867
     /* 1541867 */   GIM_Try, /*On fail goto*//*Label 21392*/ GIMT_Encode4(1541949), // Rule ID 18782 //
     /* 1541872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1541875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541892 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1541895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541911 */     // MIs[0] round
     /* 1541911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541914 */     // MIs[0] policy
     /* 1541914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1541924 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1541924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1541927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1541929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1541931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1541933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1541935 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1541937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1541942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1541945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1541947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1541948 */     // GIR_Coverage, 18782,
     /* 1541948 */     GIR_EraseRootFromParent_Done,
     /* 1541949 */   // Label 21392: @1541949
     /* 1541949 */   GIM_Try, /*On fail goto*//*Label 21393*/ GIMT_Encode4(1542031), // Rule ID 18783 //
     /* 1541954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1541957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1541962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1541965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1541968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1541971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1541974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1541977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1541985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1541989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1541993 */     // MIs[0] round
     /* 1541993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1541996 */     // MIs[0] policy
     /* 1541996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1541999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542006 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16),
     /* 1542009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542017 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542030 */     // GIR_Coverage, 18783,
     /* 1542030 */     GIR_EraseRootFromParent_Done,
     /* 1542031 */   // Label 21393: @1542031
     /* 1542031 */   GIM_Try, /*On fail goto*//*Label 21394*/ GIMT_Encode4(1542113), // Rule ID 18786 //
     /* 1542036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542056 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542075 */     // MIs[0] round
     /* 1542075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542078 */     // MIs[0] policy
     /* 1542078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542088 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1542091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542099 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542112 */     // GIR_Coverage, 18786,
     /* 1542112 */     GIR_EraseRootFromParent_Done,
     /* 1542113 */   // Label 21394: @1542113
     /* 1542113 */   GIM_Try, /*On fail goto*//*Label 21395*/ GIMT_Encode4(1542195), // Rule ID 18787 //
     /* 1542118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1542129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1542132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1542138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542157 */     // MIs[0] round
     /* 1542157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542160 */     // MIs[0] policy
     /* 1542160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16),
     /* 1542173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542181 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542194 */     // GIR_Coverage, 18787,
     /* 1542194 */     GIR_EraseRootFromParent_Done,
     /* 1542195 */   // Label 21395: @1542195
     /* 1542195 */   GIM_Try, /*On fail goto*//*Label 21396*/ GIMT_Encode4(1542277), // Rule ID 18790 //
     /* 1542200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1542203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542239 */     // MIs[0] round
     /* 1542239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542242 */     // MIs[0] policy
     /* 1542242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542252 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1542255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542263 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542276 */     // GIR_Coverage, 18790,
     /* 1542276 */     GIR_EraseRootFromParent_Done,
     /* 1542277 */   // Label 21396: @1542277
     /* 1542277 */   GIM_Try, /*On fail goto*//*Label 21397*/ GIMT_Encode4(1542359), // Rule ID 18791 //
     /* 1542282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1542285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1542293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1542296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1542299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1542302 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1542317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542321 */     // MIs[0] round
     /* 1542321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542324 */     // MIs[0] policy
     /* 1542324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542334 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16),
     /* 1542337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542345 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1542355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542358 */     // GIR_Coverage, 18791,
     /* 1542358 */     GIR_EraseRootFromParent_Done,
     /* 1542359 */   // Label 21397: @1542359
     /* 1542359 */   GIM_Try, /*On fail goto*//*Label 21398*/ GIMT_Encode4(1542441), // Rule ID 18794 //
     /* 1542364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542384 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542403 */     // MIs[0] round
     /* 1542403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542406 */     // MIs[0] policy
     /* 1542406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542416 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1542419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542427 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542440 */     // GIR_Coverage, 18794,
     /* 1542440 */     GIR_EraseRootFromParent_Done,
     /* 1542441 */   // Label 21398: @1542441
     /* 1542441 */   GIM_Try, /*On fail goto*//*Label 21399*/ GIMT_Encode4(1542523), // Rule ID 18795 //
     /* 1542446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1542457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1542460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1542466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542485 */     // MIs[0] round
     /* 1542485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542488 */     // MIs[0] policy
     /* 1542488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542498 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11234:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32),
     /* 1542501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542509 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542522 */     // GIR_Coverage, 18795,
     /* 1542522 */     GIR_EraseRootFromParent_Done,
     /* 1542523 */   // Label 21399: @1542523
     /* 1542523 */   GIM_Try, /*On fail goto*//*Label 21400*/ GIMT_Encode4(1542605), // Rule ID 18798 //
     /* 1542528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542548 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542567 */     // MIs[0] round
     /* 1542567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542570 */     // MIs[0] policy
     /* 1542570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542580 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1542583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542591 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542604 */     // GIR_Coverage, 18798,
     /* 1542604 */     GIR_EraseRootFromParent_Done,
     /* 1542605 */   // Label 21400: @1542605
     /* 1542605 */   GIM_Try, /*On fail goto*//*Label 21401*/ GIMT_Encode4(1542687), // Rule ID 18799 //
     /* 1542610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1542621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1542624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1542630 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1542649 */     // MIs[0] round
     /* 1542649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542652 */     // MIs[0] policy
     /* 1542652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542662 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11234:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32),
     /* 1542665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542673 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542686 */     // GIR_Coverage, 18799,
     /* 1542686 */     GIR_EraseRootFromParent_Done,
     /* 1542687 */   // Label 21401: @1542687
     /* 1542687 */   GIM_Try, /*On fail goto*//*Label 21402*/ GIMT_Encode4(1542769), // Rule ID 18802 //
     /* 1542692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542731 */     // MIs[0] round
     /* 1542731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542734 */     // MIs[0] policy
     /* 1542734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542744 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1542747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542755 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542768 */     // GIR_Coverage, 18802,
     /* 1542768 */     GIR_EraseRootFromParent_Done,
     /* 1542769 */   // Label 21402: @1542769
     /* 1542769 */   GIM_Try, /*On fail goto*//*Label 21403*/ GIMT_Encode4(1542851), // Rule ID 18803 //
     /* 1542774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1542785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1542788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1542794 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1542813 */     // MIs[0] round
     /* 1542813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542816 */     // MIs[0] policy
     /* 1542816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542826 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11234:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32),
     /* 1542829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542837 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542850 */     // GIR_Coverage, 18803,
     /* 1542850 */     GIR_EraseRootFromParent_Done,
     /* 1542851 */   // Label 21403: @1542851
     /* 1542851 */   GIM_Try, /*On fail goto*//*Label 21404*/ GIMT_Encode4(1542933), // Rule ID 18806 //
     /* 1542856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1542859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542876 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1542879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542895 */     // MIs[0] round
     /* 1542895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542898 */     // MIs[0] policy
     /* 1542898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542908 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1542908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1542911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1542919 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1542921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1542926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1542929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1542931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1542932 */     // GIR_Coverage, 18806,
     /* 1542932 */     GIR_EraseRootFromParent_Done,
     /* 1542933 */   // Label 21404: @1542933
     /* 1542933 */   GIM_Try, /*On fail goto*//*Label 21405*/ GIMT_Encode4(1543015), // Rule ID 18807 //
     /* 1542938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1542941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac),
     /* 1542946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1542949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1542952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1542955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1542958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1542961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1542969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1542973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1542977 */     // MIs[0] round
     /* 1542977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1542980 */     // MIs[0] policy
     /* 1542980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1542983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1542990 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11234:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1542990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32),
     /* 1542993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1542995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1542997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1542999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543001 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543014 */     // GIR_Coverage, 18807,
     /* 1543014 */     GIR_EraseRootFromParent_Done,
     /* 1543015 */   // Label 21405: @1543015
     /* 1543015 */   GIM_Try, /*On fail goto*//*Label 21406*/ GIMT_Encode4(1543097), // Rule ID 18810 //
     /* 1543020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543040 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543059 */     // MIs[0] round
     /* 1543059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543062 */     // MIs[0] policy
     /* 1543062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543072 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1543075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543083 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543096 */     // GIR_Coverage, 18810,
     /* 1543096 */     GIR_EraseRootFromParent_Done,
     /* 1543097 */   // Label 21406: @1543097
     /* 1543097 */   GIM_Try, /*On fail goto*//*Label 21407*/ GIMT_Encode4(1543179), // Rule ID 18811 //
     /* 1543102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1543113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1543116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1543119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1543122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543141 */     // MIs[0] round
     /* 1543141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543144 */     // MIs[0] policy
     /* 1543144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543154 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16),
     /* 1543157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543165 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543178 */     // GIR_Coverage, 18811,
     /* 1543178 */     GIR_EraseRootFromParent_Done,
     /* 1543179 */   // Label 21407: @1543179
     /* 1543179 */   GIM_Try, /*On fail goto*//*Label 21408*/ GIMT_Encode4(1543261), // Rule ID 18814 //
     /* 1543184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543223 */     // MIs[0] round
     /* 1543223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543226 */     // MIs[0] policy
     /* 1543226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543236 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1543239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543247 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543260 */     // GIR_Coverage, 18814,
     /* 1543260 */     GIR_EraseRootFromParent_Done,
     /* 1543261 */   // Label 21408: @1543261
     /* 1543261 */   GIM_Try, /*On fail goto*//*Label 21409*/ GIMT_Encode4(1543343), // Rule ID 18815 //
     /* 1543266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1543277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1543280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1543283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1543286 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543305 */     // MIs[0] round
     /* 1543305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543308 */     // MIs[0] policy
     /* 1543308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543318 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16),
     /* 1543321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543329 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543342 */     // GIR_Coverage, 18815,
     /* 1543342 */     GIR_EraseRootFromParent_Done,
     /* 1543343 */   // Label 21409: @1543343
     /* 1543343 */   GIM_Try, /*On fail goto*//*Label 21410*/ GIMT_Encode4(1543425), // Rule ID 18818 //
     /* 1543348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1543365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543368 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543387 */     // MIs[0] round
     /* 1543387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543390 */     // MIs[0] policy
     /* 1543390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543400 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1543403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543411 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543424 */     // GIR_Coverage, 18818,
     /* 1543424 */     GIR_EraseRootFromParent_Done,
     /* 1543425 */   // Label 21410: @1543425
     /* 1543425 */   GIM_Try, /*On fail goto*//*Label 21411*/ GIMT_Encode4(1543507), // Rule ID 18819 //
     /* 1543430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1543441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1543444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1543447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1543450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543469 */     // MIs[0] round
     /* 1543469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543472 */     // MIs[0] policy
     /* 1543472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16),
     /* 1543485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543493 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543506 */     // GIR_Coverage, 18819,
     /* 1543506 */     GIR_EraseRootFromParent_Done,
     /* 1543507 */   // Label 21411: @1543507
     /* 1543507 */   GIM_Try, /*On fail goto*//*Label 21412*/ GIMT_Encode4(1543589), // Rule ID 18822 //
     /* 1543512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1543529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543551 */     // MIs[0] round
     /* 1543551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543554 */     // MIs[0] policy
     /* 1543554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543564 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1543567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543575 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543588 */     // GIR_Coverage, 18822,
     /* 1543588 */     GIR_EraseRootFromParent_Done,
     /* 1543589 */   // Label 21412: @1543589
     /* 1543589 */   GIM_Try, /*On fail goto*//*Label 21413*/ GIMT_Encode4(1543671), // Rule ID 18823 //
     /* 1543594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1543605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1543608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1543611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1543614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1543633 */     // MIs[0] round
     /* 1543633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543636 */     // MIs[0] policy
     /* 1543636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543646 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16),
     /* 1543649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543657 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543670 */     // GIR_Coverage, 18823,
     /* 1543670 */     GIR_EraseRootFromParent_Done,
     /* 1543671 */   // Label 21413: @1543671
     /* 1543671 */   GIM_Try, /*On fail goto*//*Label 21414*/ GIMT_Encode4(1543753), // Rule ID 18826 //
     /* 1543676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1543679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1543693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543715 */     // MIs[0] round
     /* 1543715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543718 */     // MIs[0] policy
     /* 1543718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543728 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1543731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543739 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543752 */     // GIR_Coverage, 18826,
     /* 1543752 */     GIR_EraseRootFromParent_Done,
     /* 1543753 */   // Label 21414: @1543753
     /* 1543753 */   GIM_Try, /*On fail goto*//*Label 21415*/ GIMT_Encode4(1543835), // Rule ID 18827 //
     /* 1543758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1543761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1543769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1543772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1543775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1543778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1543789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1543797 */     // MIs[0] round
     /* 1543797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543800 */     // MIs[0] policy
     /* 1543800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543810 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16),
     /* 1543813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543821 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1543831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543834 */     // GIR_Coverage, 18827,
     /* 1543834 */     GIR_EraseRootFromParent_Done,
     /* 1543835 */   // Label 21415: @1543835
     /* 1543835 */   GIM_Try, /*On fail goto*//*Label 21416*/ GIMT_Encode4(1543917), // Rule ID 18830 //
     /* 1543840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1543843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1543857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543860 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1543863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543879 */     // MIs[0] round
     /* 1543879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543882 */     // MIs[0] policy
     /* 1543882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543892 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1543892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1543895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543903 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543916 */     // GIR_Coverage, 18830,
     /* 1543916 */     GIR_EraseRootFromParent_Done,
     /* 1543917 */   // Label 21416: @1543917
     /* 1543917 */   GIM_Try, /*On fail goto*//*Label 21417*/ GIMT_Encode4(1543999), // Rule ID 18831 //
     /* 1543922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1543925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1543930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1543933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1543936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1543939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1543942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1543945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1543961 */     // MIs[0] round
     /* 1543961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1543964 */     // MIs[0] policy
     /* 1543964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1543967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1543974 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1543974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32),
     /* 1543977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1543979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1543981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1543983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1543985 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1543987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1543992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1543995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1543997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1543998 */     // GIR_Coverage, 18831,
     /* 1543998 */     GIR_EraseRootFromParent_Done,
     /* 1543999 */   // Label 21417: @1543999
     /* 1543999 */   GIM_Try, /*On fail goto*//*Label 21418*/ GIMT_Encode4(1544081), // Rule ID 18834 //
     /* 1544004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544024 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544043 */     // MIs[0] round
     /* 1544043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544046 */     // MIs[0] policy
     /* 1544046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544056 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1544059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544067 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544080 */     // GIR_Coverage, 18834,
     /* 1544080 */     GIR_EraseRootFromParent_Done,
     /* 1544081 */   // Label 21418: @1544081
     /* 1544081 */   GIM_Try, /*On fail goto*//*Label 21419*/ GIMT_Encode4(1544163), // Rule ID 18835 //
     /* 1544086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1544097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1544100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1544103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1544106 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544125 */     // MIs[0] round
     /* 1544125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544128 */     // MIs[0] policy
     /* 1544128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544138 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32),
     /* 1544141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544149 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544162 */     // GIR_Coverage, 18835,
     /* 1544162 */     GIR_EraseRootFromParent_Done,
     /* 1544163 */   // Label 21419: @1544163
     /* 1544163 */   GIM_Try, /*On fail goto*//*Label 21420*/ GIMT_Encode4(1544245), // Rule ID 18838 //
     /* 1544168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544207 */     // MIs[0] round
     /* 1544207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544210 */     // MIs[0] policy
     /* 1544210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544220 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1544223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544231 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544244 */     // GIR_Coverage, 18838,
     /* 1544244 */     GIR_EraseRootFromParent_Done,
     /* 1544245 */   // Label 21420: @1544245
     /* 1544245 */   GIM_Try, /*On fail goto*//*Label 21421*/ GIMT_Encode4(1544327), // Rule ID 18839 //
     /* 1544250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1544261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1544264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1544267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1544270 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544289 */     // MIs[0] round
     /* 1544289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544292 */     // MIs[0] policy
     /* 1544292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544302 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32),
     /* 1544305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544313 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544326 */     // GIR_Coverage, 18839,
     /* 1544326 */     GIR_EraseRootFromParent_Done,
     /* 1544327 */   // Label 21421: @1544327
     /* 1544327 */   GIM_Try, /*On fail goto*//*Label 21422*/ GIMT_Encode4(1544409), // Rule ID 18842 //
     /* 1544332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1544335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1544349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544371 */     // MIs[0] round
     /* 1544371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544374 */     // MIs[0] policy
     /* 1544374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544384 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1544387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544395 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544408 */     // GIR_Coverage, 18842,
     /* 1544408 */     GIR_EraseRootFromParent_Done,
     /* 1544409 */   // Label 21422: @1544409
     /* 1544409 */   GIM_Try, /*On fail goto*//*Label 21423*/ GIMT_Encode4(1544491), // Rule ID 18843 //
     /* 1544414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1544417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1544425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1544428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1544431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1544434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1544445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1544453 */     // MIs[0] round
     /* 1544453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544456 */     // MIs[0] policy
     /* 1544456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544466 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32),
     /* 1544469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544477 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1544487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544490 */     // GIR_Coverage, 18843,
     /* 1544490 */     GIR_EraseRootFromParent_Done,
     /* 1544491 */   // Label 21423: @1544491
     /* 1544491 */   GIM_Try, /*On fail goto*//*Label 21424*/ GIMT_Encode4(1544573), // Rule ID 18846 //
     /* 1544496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544516 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544535 */     // MIs[0] round
     /* 1544535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544538 */     // MIs[0] policy
     /* 1544538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544548 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1544551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544559 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544572 */     // GIR_Coverage, 18846,
     /* 1544572 */     GIR_EraseRootFromParent_Done,
     /* 1544573 */   // Label 21424: @1544573
     /* 1544573 */   GIM_Try, /*On fail goto*//*Label 21425*/ GIMT_Encode4(1544655), // Rule ID 18847 //
     /* 1544578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1544589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1544592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1544598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544617 */     // MIs[0] round
     /* 1544617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544620 */     // MIs[0] policy
     /* 1544620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544630 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16),
     /* 1544633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544641 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544654 */     // GIR_Coverage, 18847,
     /* 1544654 */     GIR_EraseRootFromParent_Done,
     /* 1544655 */   // Label 21425: @1544655
     /* 1544655 */   GIM_Try, /*On fail goto*//*Label 21426*/ GIMT_Encode4(1544737), // Rule ID 18850 //
     /* 1544660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544680 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544699 */     // MIs[0] round
     /* 1544699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544702 */     // MIs[0] policy
     /* 1544702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544712 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1544715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544723 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544736 */     // GIR_Coverage, 18850,
     /* 1544736 */     GIR_EraseRootFromParent_Done,
     /* 1544737 */   // Label 21426: @1544737
     /* 1544737 */   GIM_Try, /*On fail goto*//*Label 21427*/ GIMT_Encode4(1544819), // Rule ID 18851 //
     /* 1544742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1544753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1544756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1544762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544781 */     // MIs[0] round
     /* 1544781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544784 */     // MIs[0] policy
     /* 1544784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544794 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11240:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16),
     /* 1544797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544805 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544818 */     // GIR_Coverage, 18851,
     /* 1544818 */     GIR_EraseRootFromParent_Done,
     /* 1544819 */   // Label 21427: @1544819
     /* 1544819 */   GIM_Try, /*On fail goto*//*Label 21428*/ GIMT_Encode4(1544901), // Rule ID 18854 //
     /* 1544824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1544847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544863 */     // MIs[0] round
     /* 1544863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544866 */     // MIs[0] policy
     /* 1544866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1544876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1544879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544887 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544900 */     // GIR_Coverage, 18854,
     /* 1544900 */     GIR_EraseRootFromParent_Done,
     /* 1544901 */   // Label 21428: @1544901
     /* 1544901 */   GIM_Try, /*On fail goto*//*Label 21429*/ GIMT_Encode4(1544983), // Rule ID 18855 //
     /* 1544906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1544909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1544917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1544920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1544923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1544926 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1544929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1544937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1544941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1544945 */     // MIs[0] round
     /* 1544945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1544948 */     // MIs[0] policy
     /* 1544948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1544951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1544958 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1544958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16),
     /* 1544961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1544963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1544965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1544967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1544969 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1544971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1544976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1544979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1544981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1544982 */     // GIR_Coverage, 18855,
     /* 1544982 */     GIR_EraseRootFromParent_Done,
     /* 1544983 */   // Label 21429: @1544983
     /* 1544983 */   GIM_Try, /*On fail goto*//*Label 21430*/ GIMT_Encode4(1545065), // Rule ID 18858 //
     /* 1544988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1544991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1544996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1544999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545008 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545027 */     // MIs[0] round
     /* 1545027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545030 */     // MIs[0] policy
     /* 1545030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545040 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1545043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545051 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545064 */     // GIR_Coverage, 18858,
     /* 1545064 */     GIR_EraseRootFromParent_Done,
     /* 1545065 */   // Label 21430: @1545065
     /* 1545065 */   GIM_Try, /*On fail goto*//*Label 21431*/ GIMT_Encode4(1545147), // Rule ID 18859 //
     /* 1545070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1545081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1545084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1545090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545109 */     // MIs[0] round
     /* 1545109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545112 */     // MIs[0] policy
     /* 1545112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545122 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16),
     /* 1545125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545133 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545146 */     // GIR_Coverage, 18859,
     /* 1545146 */     GIR_EraseRootFromParent_Done,
     /* 1545147 */   // Label 21431: @1545147
     /* 1545147 */   GIM_Try, /*On fail goto*//*Label 21432*/ GIMT_Encode4(1545229), // Rule ID 18862 //
     /* 1545152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 1545155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545172 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545191 */     // MIs[0] round
     /* 1545191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545194 */     // MIs[0] policy
     /* 1545194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545204 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1545207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545215 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545228 */     // GIR_Coverage, 18862,
     /* 1545228 */     GIR_EraseRootFromParent_Done,
     /* 1545229 */   // Label 21432: @1545229
     /* 1545229 */   GIM_Try, /*On fail goto*//*Label 21433*/ GIMT_Encode4(1545311), // Rule ID 18863 //
     /* 1545234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 1545237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1545245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1545248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 1545251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1545254 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1545269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545273 */     // MIs[0] round
     /* 1545273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545276 */     // MIs[0] policy
     /* 1545276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545286 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16),
     /* 1545289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545297 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1545307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545310 */     // GIR_Coverage, 18863,
     /* 1545310 */     GIR_EraseRootFromParent_Done,
     /* 1545311 */   // Label 21433: @1545311
     /* 1545311 */   GIM_Try, /*On fail goto*//*Label 21434*/ GIMT_Encode4(1545393), // Rule ID 18866 //
     /* 1545316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545355 */     // MIs[0] round
     /* 1545355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545358 */     // MIs[0] policy
     /* 1545358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545368 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1545371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545379 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545392 */     // GIR_Coverage, 18866,
     /* 1545392 */     GIR_EraseRootFromParent_Done,
     /* 1545393 */   // Label 21434: @1545393
     /* 1545393 */   GIM_Try, /*On fail goto*//*Label 21435*/ GIMT_Encode4(1545475), // Rule ID 18867 //
     /* 1545398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1545409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1545412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1545418 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545437 */     // MIs[0] round
     /* 1545437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545440 */     // MIs[0] policy
     /* 1545440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545450 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11240:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32),
     /* 1545453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545461 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545474 */     // GIR_Coverage, 18867,
     /* 1545474 */     GIR_EraseRootFromParent_Done,
     /* 1545475 */   // Label 21435: @1545475
     /* 1545475 */   GIM_Try, /*On fail goto*//*Label 21436*/ GIMT_Encode4(1545557), // Rule ID 18870 //
     /* 1545480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545519 */     // MIs[0] round
     /* 1545519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545522 */     // MIs[0] policy
     /* 1545522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545532 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1545535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545543 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545556 */     // GIR_Coverage, 18870,
     /* 1545556 */     GIR_EraseRootFromParent_Done,
     /* 1545557 */   // Label 21436: @1545557
     /* 1545557 */   GIM_Try, /*On fail goto*//*Label 21437*/ GIMT_Encode4(1545639), // Rule ID 18871 //
     /* 1545562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1545573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1545576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1545582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1545601 */     // MIs[0] round
     /* 1545601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545604 */     // MIs[0] policy
     /* 1545604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545614 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11240:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32),
     /* 1545617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545625 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545638 */     // GIR_Coverage, 18871,
     /* 1545638 */     GIR_EraseRootFromParent_Done,
     /* 1545639 */   // Label 21437: @1545639
     /* 1545639 */   GIM_Try, /*On fail goto*//*Label 21438*/ GIMT_Encode4(1545721), // Rule ID 18874 //
     /* 1545644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545664 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545683 */     // MIs[0] round
     /* 1545683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545686 */     // MIs[0] policy
     /* 1545686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545696 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1545699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545707 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545720 */     // GIR_Coverage, 18874,
     /* 1545720 */     GIR_EraseRootFromParent_Done,
     /* 1545721 */   // Label 21438: @1545721
     /* 1545721 */   GIM_Try, /*On fail goto*//*Label 21439*/ GIMT_Encode4(1545803), // Rule ID 18875 //
     /* 1545726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1545737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1545740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1545746 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1545765 */     // MIs[0] round
     /* 1545765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545768 */     // MIs[0] policy
     /* 1545768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545778 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11240:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32),
     /* 1545781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545789 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545802 */     // GIR_Coverage, 18875,
     /* 1545802 */     GIR_EraseRootFromParent_Done,
     /* 1545803 */   // Label 21439: @1545803
     /* 1545803 */   GIM_Try, /*On fail goto*//*Label 21440*/ GIMT_Encode4(1545885), // Rule ID 18878 //
     /* 1545808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1545811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545847 */     // MIs[0] round
     /* 1545847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545850 */     // MIs[0] policy
     /* 1545850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545860 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1545860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1545863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545871 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545884 */     // GIR_Coverage, 18878,
     /* 1545884 */     GIR_EraseRootFromParent_Done,
     /* 1545885 */   // Label 21440: @1545885
     /* 1545885 */   GIM_Try, /*On fail goto*//*Label 21441*/ GIMT_Encode4(1545967), // Rule ID 18879 //
     /* 1545890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1545893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac),
     /* 1545898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1545901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1545904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1545907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1545910 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1545913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1545921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1545925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1545929 */     // MIs[0] round
     /* 1545929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1545932 */     // MIs[0] policy
     /* 1545932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1545935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1545942 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11240:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1545942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32),
     /* 1545945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1545947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1545949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1545951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1545953 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1545955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1545960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1545963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1545965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1545966 */     // GIR_Coverage, 18879,
     /* 1545966 */     GIR_EraseRootFromParent_Done,
     /* 1545967 */   // Label 21441: @1545967
     /* 1545967 */   GIM_Try, /*On fail goto*//*Label 21442*/ GIMT_Encode4(1546049), // Rule ID 18884 //
     /* 1545972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1545975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1545980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1545983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1545986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1545989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1545992 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1545995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1545999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546011 */     // MIs[0] round
     /* 1546011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546014 */     // MIs[0] policy
     /* 1546014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546024 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1546027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546033 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546035 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546048 */     // GIR_Coverage, 18884,
     /* 1546048 */     GIR_EraseRootFromParent_Done,
     /* 1546049 */   // Label 21442: @1546049
     /* 1546049 */   GIM_Try, /*On fail goto*//*Label 21443*/ GIMT_Encode4(1546131), // Rule ID 18885 //
     /* 1546054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1546057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1546065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1546068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1546071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1546074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546093 */     // MIs[0] round
     /* 1546093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546096 */     // MIs[0] policy
     /* 1546096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546106 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16_MASK),
     /* 1546109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546115 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546117 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546130 */     // GIR_Coverage, 18885,
     /* 1546130 */     GIR_EraseRootFromParent_Done,
     /* 1546131 */   // Label 21443: @1546131
     /* 1546131 */   GIM_Try, /*On fail goto*//*Label 21444*/ GIMT_Encode4(1546213), // Rule ID 18888 //
     /* 1546136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1546139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1546153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1546156 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546175 */     // MIs[0] round
     /* 1546175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546178 */     // MIs[0] policy
     /* 1546178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546188 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1546191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546197 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546199 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546212 */     // GIR_Coverage, 18888,
     /* 1546212 */     GIR_EraseRootFromParent_Done,
     /* 1546213 */   // Label 21444: @1546213
     /* 1546213 */   GIM_Try, /*On fail goto*//*Label 21445*/ GIMT_Encode4(1546295), // Rule ID 18889 //
     /* 1546218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1546221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1546229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1546232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1546235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1546238 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546257 */     // MIs[0] round
     /* 1546257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546260 */     // MIs[0] policy
     /* 1546260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546270 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32_MASK),
     /* 1546273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546279 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546281 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546294 */     // GIR_Coverage, 18889,
     /* 1546294 */     GIR_EraseRootFromParent_Done,
     /* 1546295 */   // Label 21445: @1546295
     /* 1546295 */   GIM_Try, /*On fail goto*//*Label 21446*/ GIMT_Encode4(1546377), // Rule ID 18892 //
     /* 1546300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1546303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1546311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1546314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1546317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1546320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546339 */     // MIs[0] round
     /* 1546339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546342 */     // MIs[0] policy
     /* 1546342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546352 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1546355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546363 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546376 */     // GIR_Coverage, 18892,
     /* 1546376 */     GIR_EraseRootFromParent_Done,
     /* 1546377 */   // Label 21446: @1546377
     /* 1546377 */   GIM_Try, /*On fail goto*//*Label 21447*/ GIMT_Encode4(1546459), // Rule ID 18893 //
     /* 1546382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1546385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1546393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1546396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1546399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1546402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546421 */     // MIs[0] round
     /* 1546421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546424 */     // MIs[0] policy
     /* 1546424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546434 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11207:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16_MASK),
     /* 1546437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546443 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546445 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546458 */     // GIR_Coverage, 18893,
     /* 1546458 */     GIR_EraseRootFromParent_Done,
     /* 1546459 */   // Label 21447: @1546459
     /* 1546459 */   GIM_Try, /*On fail goto*//*Label 21448*/ GIMT_Encode4(1546541), // Rule ID 18896 //
     /* 1546464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1546467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1546481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1546484 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546503 */     // MIs[0] round
     /* 1546503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546506 */     // MIs[0] policy
     /* 1546506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546516 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1546519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546527 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546540 */     // GIR_Coverage, 18896,
     /* 1546540 */     GIR_EraseRootFromParent_Done,
     /* 1546541 */   // Label 21448: @1546541
     /* 1546541 */   GIM_Try, /*On fail goto*//*Label 21449*/ GIMT_Encode4(1546623), // Rule ID 18897 //
     /* 1546546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1546549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1546557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1546560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1546563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1546566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546585 */     // MIs[0] round
     /* 1546585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546588 */     // MIs[0] policy
     /* 1546588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546598 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11207:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32_MASK),
     /* 1546601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546607 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546609 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1546619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546622 */     // GIR_Coverage, 18897,
     /* 1546622 */     GIR_EraseRootFromParent_Done,
     /* 1546623 */   // Label 21449: @1546623
     /* 1546623 */   GIM_Try, /*On fail goto*//*Label 21450*/ GIMT_Encode4(1546705), // Rule ID 18900 //
     /* 1546628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1546631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1546645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1546648 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546667 */     // MIs[0] round
     /* 1546667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546670 */     // MIs[0] policy
     /* 1546670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546680 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1546683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546691 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1546701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546704 */     // GIR_Coverage, 18900,
     /* 1546704 */     GIR_EraseRootFromParent_Done,
     /* 1546705 */   // Label 21450: @1546705
     /* 1546705 */   GIM_Try, /*On fail goto*//*Label 21451*/ GIMT_Encode4(1546787), // Rule ID 18901 //
     /* 1546710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1546713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1546721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1546724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1546727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1546730 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1546737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1546745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546749 */     // MIs[0] round
     /* 1546749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546752 */     // MIs[0] policy
     /* 1546752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546762 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11207:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64_MASK),
     /* 1546765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546771 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546773 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1546783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546786 */     // GIR_Coverage, 18901,
     /* 1546786 */     GIR_EraseRootFromParent_Done,
     /* 1546787 */   // Label 21451: @1546787
     /* 1546787 */   GIM_Try, /*On fail goto*//*Label 21452*/ GIMT_Encode4(1546869), // Rule ID 18904 //
     /* 1546792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1546795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1546803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1546806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1546809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1546812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1546819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546831 */     // MIs[0] round
     /* 1546831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546834 */     // MIs[0] policy
     /* 1546834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1546844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1546847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546855 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546868 */     // GIR_Coverage, 18904,
     /* 1546868 */     GIR_EraseRootFromParent_Done,
     /* 1546869 */   // Label 21452: @1546869
     /* 1546869 */   GIM_Try, /*On fail goto*//*Label 21453*/ GIMT_Encode4(1546951), // Rule ID 18905 //
     /* 1546874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1546877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1546885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1546888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1546891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1546894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1546897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1546901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1546909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546913 */     // MIs[0] round
     /* 1546913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546916 */     // MIs[0] policy
     /* 1546916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1546919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1546926 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1546926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16_MASK),
     /* 1546929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1546931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1546933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1546935 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1546937 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1546939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1546944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1546947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1546949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1546950 */     // GIR_Coverage, 18905,
     /* 1546950 */     GIR_EraseRootFromParent_Done,
     /* 1546951 */   // Label 21453: @1546951
     /* 1546951 */   GIM_Try, /*On fail goto*//*Label 21454*/ GIMT_Encode4(1547033), // Rule ID 18908 //
     /* 1546956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1546959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1546964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1546967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1546970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1546973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1546976 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1546979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1546983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1546991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1546995 */     // MIs[0] round
     /* 1546995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1546998 */     // MIs[0] policy
     /* 1546998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547008 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1547011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547019 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547032 */     // GIR_Coverage, 18908,
     /* 1547032 */     GIR_EraseRootFromParent_Done,
     /* 1547033 */   // Label 21454: @1547033
     /* 1547033 */   GIM_Try, /*On fail goto*//*Label 21455*/ GIMT_Encode4(1547115), // Rule ID 18909 //
     /* 1547038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1547041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1547049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1547052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1547055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1547058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547077 */     // MIs[0] round
     /* 1547077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547080 */     // MIs[0] policy
     /* 1547080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547090 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16_MASK),
     /* 1547093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547101 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547114 */     // GIR_Coverage, 18909,
     /* 1547114 */     GIR_EraseRootFromParent_Done,
     /* 1547115 */   // Label 21455: @1547115
     /* 1547115 */   GIM_Try, /*On fail goto*//*Label 21456*/ GIMT_Encode4(1547197), // Rule ID 18912 //
     /* 1547120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1547123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1547131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1547134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1547137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1547140 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547159 */     // MIs[0] round
     /* 1547159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547162 */     // MIs[0] policy
     /* 1547162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547172 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1547175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547181 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547183 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547196 */     // GIR_Coverage, 18912,
     /* 1547196 */     GIR_EraseRootFromParent_Done,
     /* 1547197 */   // Label 21456: @1547197
     /* 1547197 */   GIM_Try, /*On fail goto*//*Label 21457*/ GIMT_Encode4(1547279), // Rule ID 18913 //
     /* 1547202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1547205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1547213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1547216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1547219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1547222 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547241 */     // MIs[0] round
     /* 1547241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547244 */     // MIs[0] policy
     /* 1547244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547254 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16_MASK),
     /* 1547257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547265 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1547275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547278 */     // GIR_Coverage, 18913,
     /* 1547278 */     GIR_EraseRootFromParent_Done,
     /* 1547279 */   // Label 21457: @1547279
     /* 1547279 */   GIM_Try, /*On fail goto*//*Label 21458*/ GIMT_Encode4(1547361), // Rule ID 18916 //
     /* 1547284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1547287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1547304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547323 */     // MIs[0] round
     /* 1547323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547326 */     // MIs[0] policy
     /* 1547326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547336 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1547339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547345 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547347 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547360 */     // GIR_Coverage, 18916,
     /* 1547360 */     GIR_EraseRootFromParent_Done,
     /* 1547361 */   // Label 21458: @1547361
     /* 1547361 */   GIM_Try, /*On fail goto*//*Label 21459*/ GIMT_Encode4(1547443), // Rule ID 18917 //
     /* 1547366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1547369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1547377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1547380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1547383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1547386 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547405 */     // MIs[0] round
     /* 1547405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547408 */     // MIs[0] policy
     /* 1547408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547418 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32_MASK),
     /* 1547421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547429 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547442 */     // GIR_Coverage, 18917,
     /* 1547442 */     GIR_EraseRootFromParent_Done,
     /* 1547443 */   // Label 21459: @1547443
     /* 1547443 */   GIM_Try, /*On fail goto*//*Label 21460*/ GIMT_Encode4(1547525), // Rule ID 18920 //
     /* 1547448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1547451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1547465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1547468 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547487 */     // MIs[0] round
     /* 1547487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547490 */     // MIs[0] policy
     /* 1547490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547500 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1547503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547509 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547511 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547524 */     // GIR_Coverage, 18920,
     /* 1547524 */     GIR_EraseRootFromParent_Done,
     /* 1547525 */   // Label 21460: @1547525
     /* 1547525 */   GIM_Try, /*On fail goto*//*Label 21461*/ GIMT_Encode4(1547607), // Rule ID 18921 //
     /* 1547530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1547533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1547541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1547544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1547547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1547550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547569 */     // MIs[0] round
     /* 1547569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547572 */     // MIs[0] policy
     /* 1547572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547582 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32_MASK),
     /* 1547585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547591 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547593 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547606 */     // GIR_Coverage, 18921,
     /* 1547606 */     GIR_EraseRootFromParent_Done,
     /* 1547607 */   // Label 21461: @1547607
     /* 1547607 */   GIM_Try, /*On fail goto*//*Label 21462*/ GIMT_Encode4(1547689), // Rule ID 18924 //
     /* 1547612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1547615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1547629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1547632 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547651 */     // MIs[0] round
     /* 1547651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547654 */     // MIs[0] policy
     /* 1547654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547664 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1547667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547673 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547675 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547688 */     // GIR_Coverage, 18924,
     /* 1547688 */     GIR_EraseRootFromParent_Done,
     /* 1547689 */   // Label 21462: @1547689
     /* 1547689 */   GIM_Try, /*On fail goto*//*Label 21463*/ GIMT_Encode4(1547771), // Rule ID 18925 //
     /* 1547694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1547697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1547705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1547708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1547711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1547714 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1547721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1547729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547733 */     // MIs[0] round
     /* 1547733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547736 */     // MIs[0] policy
     /* 1547736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547746 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32_MASK),
     /* 1547749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547755 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547757 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1547767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547770 */     // GIR_Coverage, 18925,
     /* 1547770 */     GIR_EraseRootFromParent_Done,
     /* 1547771 */   // Label 21463: @1547771
     /* 1547771 */   GIM_Try, /*On fail goto*//*Label 21464*/ GIMT_Encode4(1547853), // Rule ID 18928 //
     /* 1547776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1547779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1547793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1547796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547815 */     // MIs[0] round
     /* 1547815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547818 */     // MIs[0] policy
     /* 1547818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547828 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1547831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547837 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547839 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1547849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547852 */     // GIR_Coverage, 18928,
     /* 1547852 */     GIR_EraseRootFromParent_Done,
     /* 1547853 */   // Label 21464: @1547853
     /* 1547853 */   GIM_Try, /*On fail goto*//*Label 21465*/ GIMT_Encode4(1547935), // Rule ID 18929 //
     /* 1547858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1547861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1547869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1547872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1547875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1547878 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1547881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1547885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1547893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547897 */     // MIs[0] round
     /* 1547897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547900 */     // MIs[0] policy
     /* 1547900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547910 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11207:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1547910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64_MASK),
     /* 1547913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1547919 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1547921 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1547923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1547928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1547931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1547933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1547934 */     // GIR_Coverage, 18929,
     /* 1547934 */     GIR_EraseRootFromParent_Done,
     /* 1547935 */   // Label 21465: @1547935
     /* 1547935 */   GIM_Try, /*On fail goto*//*Label 21466*/ GIMT_Encode4(1548017), // Rule ID 18932 //
     /* 1547940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1547943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1547948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1547951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1547954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1547957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1547960 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1547963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1547967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1547975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1547979 */     // MIs[0] round
     /* 1547979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1547982 */     // MIs[0] policy
     /* 1547982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1547985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1547992 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1547992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1547995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1547997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1547999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548001 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548003 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1548013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548016 */     // GIR_Coverage, 18932,
     /* 1548016 */     GIR_EraseRootFromParent_Done,
     /* 1548017 */   // Label 21466: @1548017
     /* 1548017 */   GIM_Try, /*On fail goto*//*Label 21467*/ GIMT_Encode4(1548099), // Rule ID 18933 //
     /* 1548022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1548025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1548030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1548033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1548036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1548039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1548042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1548049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1548057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548061 */     // MIs[0] round
     /* 1548061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548064 */     // MIs[0] policy
     /* 1548064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548074 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11207:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64_MASK),
     /* 1548077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548083 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548085 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1548095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548098 */     // GIR_Coverage, 18933,
     /* 1548098 */     GIR_EraseRootFromParent_Done,
     /* 1548099 */   // Label 21467: @1548099
     /* 1548099 */   GIM_Try, /*On fail goto*//*Label 21468*/ GIMT_Encode4(1548181), // Rule ID 18936 //
     /* 1548104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1548107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1548112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1548121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1548124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1548131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548143 */     // MIs[0] round
     /* 1548143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548146 */     // MIs[0] policy
     /* 1548146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1548159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548165 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548167 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1548177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548180 */     // GIR_Coverage, 18936,
     /* 1548180 */     GIR_EraseRootFromParent_Done,
     /* 1548181 */   // Label 21468: @1548181
     /* 1548181 */   GIM_Try, /*On fail goto*//*Label 21469*/ GIMT_Encode4(1548263), // Rule ID 18937 //
     /* 1548186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1548189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsqrt_mask),
     /* 1548194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1548197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1548200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1548203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1548206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1548213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1548221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548225 */     // MIs[0] round
     /* 1548225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548228 */     // MIs[0] policy
     /* 1548228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548238 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11207:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSQRT_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64_MASK),
     /* 1548241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548247 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548249 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1548259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548262 */     // GIR_Coverage, 18937,
     /* 1548262 */     GIR_EraseRootFromParent_Done,
     /* 1548263 */   // Label 21469: @1548263
     /* 1548263 */   GIM_Try, /*On fail goto*//*Label 21470*/ GIMT_Encode4(1548345), // Rule ID 18996 //
     /* 1548268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1548271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1548279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1548282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1548285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1548288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548307 */     // MIs[0] round
     /* 1548307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548310 */     // MIs[0] policy
     /* 1548310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548320 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1548323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548329 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548331 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548344 */     // GIR_Coverage, 18996,
     /* 1548344 */     GIR_EraseRootFromParent_Done,
     /* 1548345 */   // Label 21470: @1548345
     /* 1548345 */   GIM_Try, /*On fail goto*//*Label 21471*/ GIMT_Encode4(1548427), // Rule ID 18997 //
     /* 1548350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1548353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1548361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1548364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1548367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1548370 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548389 */     // MIs[0] round
     /* 1548389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548392 */     // MIs[0] policy
     /* 1548392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548402 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF4_E16_MASK),
     /* 1548405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548413 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548426 */     // GIR_Coverage, 18997,
     /* 1548426 */     GIR_EraseRootFromParent_Done,
     /* 1548427 */   // Label 21471: @1548427
     /* 1548427 */   GIM_Try, /*On fail goto*//*Label 21472*/ GIMT_Encode4(1548509), // Rule ID 19000 //
     /* 1548432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1548435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1548443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1548446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1548449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1548452 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548471 */     // MIs[0] round
     /* 1548471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548474 */     // MIs[0] policy
     /* 1548474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548484 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1548487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548493 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548495 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548508 */     // GIR_Coverage, 19000,
     /* 1548508 */     GIR_EraseRootFromParent_Done,
     /* 1548509 */   // Label 21472: @1548509
     /* 1548509 */   GIM_Try, /*On fail goto*//*Label 21473*/ GIMT_Encode4(1548591), // Rule ID 19001 //
     /* 1548514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1548517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1548525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1548528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1548531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1548534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548553 */     // MIs[0] round
     /* 1548553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548556 */     // MIs[0] policy
     /* 1548556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548566 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E16_MASK),
     /* 1548569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548575 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548577 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548590 */     // GIR_Coverage, 19001,
     /* 1548590 */     GIR_EraseRootFromParent_Done,
     /* 1548591 */   // Label 21473: @1548591
     /* 1548591 */   GIM_Try, /*On fail goto*//*Label 21474*/ GIMT_Encode4(1548673), // Rule ID 19004 //
     /* 1548596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1548599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1548616 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548635 */     // MIs[0] round
     /* 1548635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548638 */     // MIs[0] policy
     /* 1548638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548648 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1548651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548657 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548659 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548672 */     // GIR_Coverage, 19004,
     /* 1548672 */     GIR_EraseRootFromParent_Done,
     /* 1548673 */   // Label 21474: @1548673
     /* 1548673 */   GIM_Try, /*On fail goto*//*Label 21475*/ GIMT_Encode4(1548755), // Rule ID 19005 //
     /* 1548678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1548681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1548689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1548692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1548695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1548698 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548717 */     // MIs[0] round
     /* 1548717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548720 */     // MIs[0] policy
     /* 1548720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548730 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_MF2_E32_MASK),
     /* 1548733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548741 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548754 */     // GIR_Coverage, 19005,
     /* 1548754 */     GIR_EraseRootFromParent_Done,
     /* 1548755 */   // Label 21475: @1548755
     /* 1548755 */   GIM_Try, /*On fail goto*//*Label 21476*/ GIMT_Encode4(1548837), // Rule ID 19008 //
     /* 1548760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1548763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1548771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1548774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1548777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1548780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548799 */     // MIs[0] round
     /* 1548799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548802 */     // MIs[0] policy
     /* 1548802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548812 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1548815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548821 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548823 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548836 */     // GIR_Coverage, 19008,
     /* 1548836 */     GIR_EraseRootFromParent_Done,
     /* 1548837 */   // Label 21476: @1548837
     /* 1548837 */   GIM_Try, /*On fail goto*//*Label 21477*/ GIMT_Encode4(1548919), // Rule ID 19009 //
     /* 1548842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1548845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1548853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1548856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1548859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1548862 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1548865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548881 */     // MIs[0] round
     /* 1548881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548884 */     // MIs[0] policy
     /* 1548884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548894 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11183:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1548894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E16_MASK),
     /* 1548897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548903 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548905 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1548915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1548918 */     // GIR_Coverage, 19009,
     /* 1548918 */     GIR_EraseRootFromParent_Done,
     /* 1548919 */   // Label 21477: @1548919
     /* 1548919 */   GIM_Try, /*On fail goto*//*Label 21478*/ GIMT_Encode4(1549001), // Rule ID 19012 //
     /* 1548924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1548927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1548932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1548935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1548938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1548941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1548944 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1548947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1548951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1548959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1548963 */     // MIs[0] round
     /* 1548963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1548966 */     // MIs[0] policy
     /* 1548966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1548969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1548976 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1548976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1548979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1548981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1548983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1548985 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1548987 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1548989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1548994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1548997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1548999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549000 */     // GIR_Coverage, 19012,
     /* 1549000 */     GIR_EraseRootFromParent_Done,
     /* 1549001 */   // Label 21478: @1549001
     /* 1549001 */   GIM_Try, /*On fail goto*//*Label 21479*/ GIMT_Encode4(1549083), // Rule ID 19013 //
     /* 1549006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1549009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1549017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1549020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1549023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1549026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1549033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549045 */     // MIs[0] round
     /* 1549045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549048 */     // MIs[0] policy
     /* 1549048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549058 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11183:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E32_MASK),
     /* 1549061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549069 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549082 */     // GIR_Coverage, 19013,
     /* 1549082 */     GIR_EraseRootFromParent_Done,
     /* 1549083 */   // Label 21479: @1549083
     /* 1549083 */   GIM_Try, /*On fail goto*//*Label 21480*/ GIMT_Encode4(1549165), // Rule ID 19016 //
     /* 1549088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1549091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1549105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1549108 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1549115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549127 */     // MIs[0] round
     /* 1549127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549130 */     // MIs[0] policy
     /* 1549130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549140 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1549143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549149 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549151 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1549161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549164 */     // GIR_Coverage, 19016,
     /* 1549164 */     GIR_EraseRootFromParent_Done,
     /* 1549165 */   // Label 21480: @1549165
     /* 1549165 */   GIM_Try, /*On fail goto*//*Label 21481*/ GIMT_Encode4(1549247), // Rule ID 19017 //
     /* 1549170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1549173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1549181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1549184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1549187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1549190 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1549197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1549205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549209 */     // MIs[0] round
     /* 1549209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549212 */     // MIs[0] policy
     /* 1549212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549222 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11183:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M1_E64_MASK),
     /* 1549225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549233 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1549243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549246 */     // GIR_Coverage, 19017,
     /* 1549246 */     GIR_EraseRootFromParent_Done,
     /* 1549247 */   // Label 21481: @1549247
     /* 1549247 */   GIM_Try, /*On fail goto*//*Label 21482*/ GIMT_Encode4(1549329), // Rule ID 19020 //
     /* 1549252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1549255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1549263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1549266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1549269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1549272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549291 */     // MIs[0] round
     /* 1549291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549294 */     // MIs[0] policy
     /* 1549294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1549307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549313 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549315 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549328 */     // GIR_Coverage, 19020,
     /* 1549328 */     GIR_EraseRootFromParent_Done,
     /* 1549329 */   // Label 21482: @1549329
     /* 1549329 */   GIM_Try, /*On fail goto*//*Label 21483*/ GIMT_Encode4(1549411), // Rule ID 19021 //
     /* 1549334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1549337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1549345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1549348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1549351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1549354 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549373 */     // MIs[0] round
     /* 1549373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549376 */     // MIs[0] policy
     /* 1549376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549386 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E16_MASK),
     /* 1549389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549395 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549397 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549410 */     // GIR_Coverage, 19021,
     /* 1549410 */     GIR_EraseRootFromParent_Done,
     /* 1549411 */   // Label 21483: @1549411
     /* 1549411 */   GIM_Try, /*On fail goto*//*Label 21484*/ GIMT_Encode4(1549493), // Rule ID 19024 //
     /* 1549416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1549419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1549427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1549430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1549433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1549436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549455 */     // MIs[0] round
     /* 1549455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549458 */     // MIs[0] policy
     /* 1549458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549468 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1549471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549479 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549492 */     // GIR_Coverage, 19024,
     /* 1549492 */     GIR_EraseRootFromParent_Done,
     /* 1549493 */   // Label 21484: @1549493
     /* 1549493 */   GIM_Try, /*On fail goto*//*Label 21485*/ GIMT_Encode4(1549575), // Rule ID 19025 //
     /* 1549498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1549501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1549509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1549512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1549515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1549518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549537 */     // MIs[0] round
     /* 1549537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549540 */     // MIs[0] policy
     /* 1549540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549550 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E16_MASK),
     /* 1549553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549559 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549561 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549574 */     // GIR_Coverage, 19025,
     /* 1549574 */     GIR_EraseRootFromParent_Done,
     /* 1549575 */   // Label 21485: @1549575
     /* 1549575 */   GIM_Try, /*On fail goto*//*Label 21486*/ GIMT_Encode4(1549657), // Rule ID 19028 //
     /* 1549580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1549583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1549591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1549594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1549597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1549600 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1549607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549619 */     // MIs[0] round
     /* 1549619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549622 */     // MIs[0] policy
     /* 1549622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549632 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1549635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549641 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549643 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549656 */     // GIR_Coverage, 19028,
     /* 1549656 */     GIR_EraseRootFromParent_Done,
     /* 1549657 */   // Label 21486: @1549657
     /* 1549657 */   GIM_Try, /*On fail goto*//*Label 21487*/ GIMT_Encode4(1549739), // Rule ID 19029 //
     /* 1549662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1549665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1549673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1549676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1549679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1549682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1549689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1549697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549701 */     // MIs[0] round
     /* 1549701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549704 */     // MIs[0] policy
     /* 1549704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549714 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E16_MASK),
     /* 1549717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549723 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549725 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1549735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549738 */     // GIR_Coverage, 19029,
     /* 1549738 */     GIR_EraseRootFromParent_Done,
     /* 1549739 */   // Label 21487: @1549739
     /* 1549739 */   GIM_Try, /*On fail goto*//*Label 21488*/ GIMT_Encode4(1549821), // Rule ID 19032 //
     /* 1549744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1549747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1549761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1549764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549783 */     // MIs[0] round
     /* 1549783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549786 */     // MIs[0] policy
     /* 1549786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549796 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1549799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549807 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549820 */     // GIR_Coverage, 19032,
     /* 1549820 */     GIR_EraseRootFromParent_Done,
     /* 1549821 */   // Label 21488: @1549821
     /* 1549821 */   GIM_Try, /*On fail goto*//*Label 21489*/ GIMT_Encode4(1549903), // Rule ID 19033 //
     /* 1549826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1549829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1549837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1549840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1549843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1549846 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1549849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1549853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1549861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549865 */     // MIs[0] round
     /* 1549865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549868 */     // MIs[0] policy
     /* 1549868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549878 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1549878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E32_MASK),
     /* 1549881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549887 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549889 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549902 */     // GIR_Coverage, 19033,
     /* 1549902 */     GIR_EraseRootFromParent_Done,
     /* 1549903 */   // Label 21489: @1549903
     /* 1549903 */   GIM_Try, /*On fail goto*//*Label 21490*/ GIMT_Encode4(1549985), // Rule ID 19036 //
     /* 1549908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1549911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1549919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1549922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1549925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1549928 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1549931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1549935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1549943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1549947 */     // MIs[0] round
     /* 1549947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1549950 */     // MIs[0] policy
     /* 1549950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1549953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1549960 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1549960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1549963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1549965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1549967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1549969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1549971 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1549973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1549978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1549981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1549983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1549984 */     // GIR_Coverage, 19036,
     /* 1549984 */     GIR_EraseRootFromParent_Done,
     /* 1549985 */   // Label 21490: @1549985
     /* 1549985 */   GIM_Try, /*On fail goto*//*Label 21491*/ GIMT_Encode4(1550067), // Rule ID 19037 //
     /* 1549990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1549993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1549998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1550001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1550004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1550007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1550010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1550017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550029 */     // MIs[0] round
     /* 1550029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550032 */     // MIs[0] policy
     /* 1550032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550042 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E32_MASK),
     /* 1550045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550051 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550053 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550066 */     // GIR_Coverage, 19037,
     /* 1550066 */     GIR_EraseRootFromParent_Done,
     /* 1550067 */   // Label 21491: @1550067
     /* 1550067 */   GIM_Try, /*On fail goto*//*Label 21492*/ GIMT_Encode4(1550149), // Rule ID 19040 //
     /* 1550072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1550075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1550089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1550092 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550111 */     // MIs[0] round
     /* 1550111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550114 */     // MIs[0] policy
     /* 1550114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550124 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1550127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550133 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550135 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550148 */     // GIR_Coverage, 19040,
     /* 1550148 */     GIR_EraseRootFromParent_Done,
     /* 1550149 */   // Label 21492: @1550149
     /* 1550149 */   GIM_Try, /*On fail goto*//*Label 21493*/ GIMT_Encode4(1550231), // Rule ID 19041 //
     /* 1550154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1550157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1550165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1550168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1550171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1550174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550193 */     // MIs[0] round
     /* 1550193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550196 */     // MIs[0] policy
     /* 1550196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550206 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E32_MASK),
     /* 1550209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550215 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550217 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550230 */     // GIR_Coverage, 19041,
     /* 1550230 */     GIR_EraseRootFromParent_Done,
     /* 1550231 */   // Label 21493: @1550231
     /* 1550231 */   GIM_Try, /*On fail goto*//*Label 21494*/ GIMT_Encode4(1550313), // Rule ID 19044 //
     /* 1550236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1550239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1550253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1550263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550275 */     // MIs[0] round
     /* 1550275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550278 */     // MIs[0] policy
     /* 1550278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550288 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1550291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550297 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550299 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550312 */     // GIR_Coverage, 19044,
     /* 1550312 */     GIR_EraseRootFromParent_Done,
     /* 1550313 */   // Label 21494: @1550313
     /* 1550313 */   GIM_Try, /*On fail goto*//*Label 21495*/ GIMT_Encode4(1550395), // Rule ID 19045 //
     /* 1550318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1550321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1550329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1550332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1550335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550338 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1550345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1550353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550357 */     // MIs[0] round
     /* 1550357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550360 */     // MIs[0] policy
     /* 1550360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11183:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M2_E64_MASK),
     /* 1550373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550379 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550381 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550394 */     // GIR_Coverage, 19045,
     /* 1550394 */     GIR_EraseRootFromParent_Done,
     /* 1550395 */   // Label 21495: @1550395
     /* 1550395 */   GIM_Try, /*On fail goto*//*Label 21496*/ GIMT_Encode4(1550477), // Rule ID 19048 //
     /* 1550400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1550403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1550417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1550420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1550427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550439 */     // MIs[0] round
     /* 1550439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550442 */     // MIs[0] policy
     /* 1550442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550452 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1550455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550461 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550463 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550476 */     // GIR_Coverage, 19048,
     /* 1550476 */     GIR_EraseRootFromParent_Done,
     /* 1550477 */   // Label 21496: @1550477
     /* 1550477 */   GIM_Try, /*On fail goto*//*Label 21497*/ GIMT_Encode4(1550559), // Rule ID 19049 //
     /* 1550482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1550485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1550493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1550496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1550499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1550502 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1550509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1550517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550521 */     // MIs[0] round
     /* 1550521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550524 */     // MIs[0] policy
     /* 1550524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550534 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11183:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M4_E64_MASK),
     /* 1550537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550543 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550545 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550558 */     // GIR_Coverage, 19049,
     /* 1550558 */     GIR_EraseRootFromParent_Done,
     /* 1550559 */   // Label 21497: @1550559
     /* 1550559 */   GIM_Try, /*On fail goto*//*Label 21498*/ GIMT_Encode4(1550641), // Rule ID 19052 //
     /* 1550564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1550567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1550581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1550584 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550603 */     // MIs[0] round
     /* 1550603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550606 */     // MIs[0] policy
     /* 1550606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550616 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1550619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550625 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550627 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550640 */     // GIR_Coverage, 19052,
     /* 1550640 */     GIR_EraseRootFromParent_Done,
     /* 1550641 */   // Label 21498: @1550641
     /* 1550641 */   GIM_Try, /*On fail goto*//*Label 21499*/ GIMT_Encode4(1550723), // Rule ID 19053 //
     /* 1550646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1550649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrec7_mask),
     /* 1550654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1550657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1550660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1550663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1550666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1550673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1550681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550685 */     // MIs[0] round
     /* 1550685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550688 */     // MIs[0] policy
     /* 1550688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550698 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11183:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFREC7_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREC7_V_M8_E64_MASK),
     /* 1550701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550707 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550709 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1550719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550722 */     // GIR_Coverage, 19053,
     /* 1550722 */     GIR_EraseRootFromParent_Done,
     /* 1550723 */   // Label 21499: @1550723
     /* 1550723 */   GIM_Try, /*On fail goto*//*Label 21500*/ GIMT_Encode4(1550805), // Rule ID 20638 //
     /* 1550728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1550731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1550736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550767 */     // MIs[0] round
     /* 1550767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550770 */     // MIs[0] policy
     /* 1550770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1550783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550789 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550791 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550804 */     // GIR_Coverage, 20638,
     /* 1550804 */     GIR_EraseRootFromParent_Done,
     /* 1550805 */   // Label 21500: @1550805
     /* 1550805 */   GIM_Try, /*On fail goto*//*Label 21501*/ GIMT_Encode4(1550887), // Rule ID 20639 //
     /* 1550810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1550813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1550818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1550821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1550824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1550827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1550830 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550849 */     // MIs[0] round
     /* 1550849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550852 */     // MIs[0] policy
     /* 1550852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550862 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1550862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1550865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550873 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1550883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550886 */     // GIR_Coverage, 20639,
     /* 1550886 */     GIR_EraseRootFromParent_Done,
     /* 1550887 */   // Label 21501: @1550887
     /* 1550887 */   GIM_Try, /*On fail goto*//*Label 21502*/ GIMT_Encode4(1550969), // Rule ID 20642 //
     /* 1550892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1550895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1550900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1550912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1550915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1550919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1550927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1550931 */     // MIs[0] round
     /* 1550931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1550934 */     // MIs[0] policy
     /* 1550934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1550937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1550944 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1550944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1550947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1550949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1550951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1550953 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1550955 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1550957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1550962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1550965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1550967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1550968 */     // GIR_Coverage, 20642,
     /* 1550968 */     GIR_EraseRootFromParent_Done,
     /* 1550969 */   // Label 21502: @1550969
     /* 1550969 */   GIM_Try, /*On fail goto*//*Label 21503*/ GIMT_Encode4(1551051), // Rule ID 20643 //
     /* 1550974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1550977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1550982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1550985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1550988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1550991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1550994 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1550997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551013 */     // MIs[0] round
     /* 1551013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551016 */     // MIs[0] policy
     /* 1551016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_MF2_MASK),
     /* 1551029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551035 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551037 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551050 */     // GIR_Coverage, 20643,
     /* 1551050 */     GIR_EraseRootFromParent_Done,
     /* 1551051 */   // Label 21503: @1551051
     /* 1551051 */   GIM_Try, /*On fail goto*//*Label 21504*/ GIMT_Encode4(1551133), // Rule ID 20646 //
     /* 1551056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1551059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1551067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1551070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1551073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1551076 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551095 */     // MIs[0] round
     /* 1551095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551098 */     // MIs[0] policy
     /* 1551098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551108 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551117 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551119 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551132 */     // GIR_Coverage, 20646,
     /* 1551132 */     GIR_EraseRootFromParent_Done,
     /* 1551133 */   // Label 21504: @1551133
     /* 1551133 */   GIM_Try, /*On fail goto*//*Label 21505*/ GIMT_Encode4(1551215), // Rule ID 20647 //
     /* 1551138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1551141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1551149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1551152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1551155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1551158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551177 */     // MIs[0] round
     /* 1551177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551180 */     // MIs[0] policy
     /* 1551180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551190 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11129:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551199 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551201 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551214 */     // GIR_Coverage, 20647,
     /* 1551214 */     GIR_EraseRootFromParent_Done,
     /* 1551215 */   // Label 21505: @1551215
     /* 1551215 */   GIM_Try, /*On fail goto*//*Label 21506*/ GIMT_Encode4(1551297), // Rule ID 20650 //
     /* 1551220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1551223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1551240 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551259 */     // MIs[0] round
     /* 1551259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551262 */     // MIs[0] policy
     /* 1551262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551272 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551281 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551283 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551296 */     // GIR_Coverage, 20650,
     /* 1551296 */     GIR_EraseRootFromParent_Done,
     /* 1551297 */   // Label 21506: @1551297
     /* 1551297 */   GIM_Try, /*On fail goto*//*Label 21507*/ GIMT_Encode4(1551379), // Rule ID 20651 //
     /* 1551302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1551305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1551313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1551316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1551319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1551322 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551341 */     // MIs[0] round
     /* 1551341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551344 */     // MIs[0] policy
     /* 1551344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11129:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551363 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551365 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1551375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551378 */     // GIR_Coverage, 20651,
     /* 1551378 */     GIR_EraseRootFromParent_Done,
     /* 1551379 */   // Label 21507: @1551379
     /* 1551379 */   GIM_Try, /*On fail goto*//*Label 21508*/ GIMT_Encode4(1551461), // Rule ID 20654 //
     /* 1551384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1551387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1551401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1551404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551423 */     // MIs[0] round
     /* 1551423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551426 */     // MIs[0] policy
     /* 1551426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551436 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551445 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551447 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1551457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551460 */     // GIR_Coverage, 20654,
     /* 1551460 */     GIR_EraseRootFromParent_Done,
     /* 1551461 */   // Label 21508: @1551461
     /* 1551461 */   GIM_Try, /*On fail goto*//*Label 21509*/ GIMT_Encode4(1551543), // Rule ID 20655 //
     /* 1551466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1551469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1551477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1551480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1551483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1551486 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1551493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1551501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551505 */     // MIs[0] round
     /* 1551505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551508 */     // MIs[0] policy
     /* 1551508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551518 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11129:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M1_MASK),
     /* 1551521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551527 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551529 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1551539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551542 */     // GIR_Coverage, 20655,
     /* 1551542 */     GIR_EraseRootFromParent_Done,
     /* 1551543 */   // Label 21509: @1551543
     /* 1551543 */   GIM_Try, /*On fail goto*//*Label 21510*/ GIMT_Encode4(1551625), // Rule ID 20658 //
     /* 1551548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1551551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1551559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1551562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551568 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551587 */     // MIs[0] round
     /* 1551587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551590 */     // MIs[0] policy
     /* 1551590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1551603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551609 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551611 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551624 */     // GIR_Coverage, 20658,
     /* 1551624 */     GIR_EraseRootFromParent_Done,
     /* 1551625 */   // Label 21510: @1551625
     /* 1551625 */   GIM_Try, /*On fail goto*//*Label 21511*/ GIMT_Encode4(1551707), // Rule ID 20659 //
     /* 1551630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1551633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1551641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1551644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1551647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1551650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1551657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1551665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551669 */     // MIs[0] round
     /* 1551669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551672 */     // MIs[0] policy
     /* 1551672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1551685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551691 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551693 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551706 */     // GIR_Coverage, 20659,
     /* 1551706 */     GIR_EraseRootFromParent_Done,
     /* 1551707 */   // Label 21511: @1551707
     /* 1551707 */   GIM_Try, /*On fail goto*//*Label 21512*/ GIMT_Encode4(1551789), // Rule ID 20662 //
     /* 1551712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1551715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1551723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1551726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1551732 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551751 */     // MIs[0] round
     /* 1551751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551754 */     // MIs[0] policy
     /* 1551754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1551767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551773 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551775 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551788 */     // GIR_Coverage, 20662,
     /* 1551788 */     GIR_EraseRootFromParent_Done,
     /* 1551789 */   // Label 21512: @1551789
     /* 1551789 */   GIM_Try, /*On fail goto*//*Label 21513*/ GIMT_Encode4(1551871), // Rule ID 20663 //
     /* 1551794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1551797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1551805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1551808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1551811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1551814 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1551821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1551829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551833 */     // MIs[0] round
     /* 1551833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551836 */     // MIs[0] policy
     /* 1551836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551846 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1551846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1551849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551857 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551870 */     // GIR_Coverage, 20663,
     /* 1551870 */     GIR_EraseRootFromParent_Done,
     /* 1551871 */   // Label 21513: @1551871
     /* 1551871 */   GIM_Try, /*On fail goto*//*Label 21514*/ GIMT_Encode4(1551953), // Rule ID 20666 //
     /* 1551876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1551879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1551896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1551899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551915 */     // MIs[0] round
     /* 1551915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1551918 */     // MIs[0] policy
     /* 1551918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1551921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1551928 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1551928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1551931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1551933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1551935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1551937 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1551939 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1551941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1551946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1551949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1551951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1551952 */     // GIR_Coverage, 20666,
     /* 1551952 */     GIR_EraseRootFromParent_Done,
     /* 1551953 */   // Label 21514: @1551953
     /* 1551953 */   GIM_Try, /*On fail goto*//*Label 21515*/ GIMT_Encode4(1552035), // Rule ID 20667 //
     /* 1551958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1551961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1551966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1551969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1551972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1551975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1551978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1551981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1551985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1551993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1551997 */     // MIs[0] round
     /* 1551997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552000 */     // MIs[0] policy
     /* 1552000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552010 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1552013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552019 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552021 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1552031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552034 */     // GIR_Coverage, 20667,
     /* 1552034 */     GIR_EraseRootFromParent_Done,
     /* 1552035 */   // Label 21515: @1552035
     /* 1552035 */   GIM_Try, /*On fail goto*//*Label 21516*/ GIMT_Encode4(1552117), // Rule ID 20670 //
     /* 1552040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1552043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1552051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1552054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1552057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552079 */     // MIs[0] round
     /* 1552079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552082 */     // MIs[0] policy
     /* 1552082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552092 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1552095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552101 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552103 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552116 */     // GIR_Coverage, 20670,
     /* 1552116 */     GIR_EraseRootFromParent_Done,
     /* 1552117 */   // Label 21516: @1552117
     /* 1552117 */   GIM_Try, /*On fail goto*//*Label 21517*/ GIMT_Encode4(1552199), // Rule ID 20671 //
     /* 1552122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1552125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1552133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1552136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1552139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552161 */     // MIs[0] round
     /* 1552161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552164 */     // MIs[0] policy
     /* 1552164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1552177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552185 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552198 */     // GIR_Coverage, 20671,
     /* 1552198 */     GIR_EraseRootFromParent_Done,
     /* 1552199 */   // Label 21517: @1552199
     /* 1552199 */   GIM_Try, /*On fail goto*//*Label 21518*/ GIMT_Encode4(1552281), // Rule ID 20674 //
     /* 1552204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1552207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1552221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552224 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552243 */     // MIs[0] round
     /* 1552243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552246 */     // MIs[0] policy
     /* 1552246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1552259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552265 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552267 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552280 */     // GIR_Coverage, 20674,
     /* 1552280 */     GIR_EraseRootFromParent_Done,
     /* 1552281 */   // Label 21518: @1552281
     /* 1552281 */   GIM_Try, /*On fail goto*//*Label 21519*/ GIMT_Encode4(1552363), // Rule ID 20675 //
     /* 1552286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1552289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1552297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1552300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1552303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552306 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552325 */     // MIs[0] round
     /* 1552325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552328 */     // MIs[0] policy
     /* 1552328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552338 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1552341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552347 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552349 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552362 */     // GIR_Coverage, 20675,
     /* 1552362 */     GIR_EraseRootFromParent_Done,
     /* 1552363 */   // Label 21519: @1552363
     /* 1552363 */   GIM_Try, /*On fail goto*//*Label 21520*/ GIMT_Encode4(1552445), // Rule ID 20678 //
     /* 1552368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1552371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1552385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1552388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552407 */     // MIs[0] round
     /* 1552407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552410 */     // MIs[0] policy
     /* 1552410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1552423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552429 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552431 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552444 */     // GIR_Coverage, 20678,
     /* 1552444 */     GIR_EraseRootFromParent_Done,
     /* 1552445 */   // Label 21520: @1552445
     /* 1552445 */   GIM_Try, /*On fail goto*//*Label 21521*/ GIMT_Encode4(1552527), // Rule ID 20679 //
     /* 1552450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1552453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1552461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1552464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1552467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1552470 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552489 */     // MIs[0] round
     /* 1552489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552492 */     // MIs[0] policy
     /* 1552492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1552505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552513 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1552523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552526 */     // GIR_Coverage, 20679,
     /* 1552526 */     GIR_EraseRootFromParent_Done,
     /* 1552527 */   // Label 21521: @1552527
     /* 1552527 */   GIM_Try, /*On fail goto*//*Label 21522*/ GIMT_Encode4(1552609), // Rule ID 20682 //
     /* 1552532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1552535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552552 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552571 */     // MIs[0] round
     /* 1552571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552574 */     // MIs[0] policy
     /* 1552574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552584 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1552587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552595 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552608 */     // GIR_Coverage, 20682,
     /* 1552608 */     GIR_EraseRootFromParent_Done,
     /* 1552609 */   // Label 21522: @1552609
     /* 1552609 */   GIM_Try, /*On fail goto*//*Label 21523*/ GIMT_Encode4(1552691), // Rule ID 20683 //
     /* 1552614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1552617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1552625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1552628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1552631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1552634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1552641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1552649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552653 */     // MIs[0] round
     /* 1552653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552656 */     // MIs[0] policy
     /* 1552656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11129:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M2_MASK),
     /* 1552669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552677 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552690 */     // GIR_Coverage, 20683,
     /* 1552690 */     GIR_EraseRootFromParent_Done,
     /* 1552691 */   // Label 21523: @1552691
     /* 1552691 */   GIM_Try, /*On fail goto*//*Label 21524*/ GIMT_Encode4(1552773), // Rule ID 20686 //
     /* 1552696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1552699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552716 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552735 */     // MIs[0] round
     /* 1552735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552738 */     // MIs[0] policy
     /* 1552738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1552751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552757 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552759 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552772 */     // GIR_Coverage, 20686,
     /* 1552772 */     GIR_EraseRootFromParent_Done,
     /* 1552773 */   // Label 21524: @1552773
     /* 1552773 */   GIM_Try, /*On fail goto*//*Label 21525*/ GIMT_Encode4(1552855), // Rule ID 20687 //
     /* 1552778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1552781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1552789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1552792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1552795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1552798 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1552805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1552813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552817 */     // MIs[0] round
     /* 1552817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552820 */     // MIs[0] policy
     /* 1552820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552830 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11129:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M4_MASK),
     /* 1552833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552839 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552841 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552854 */     // GIR_Coverage, 20687,
     /* 1552854 */     GIR_EraseRootFromParent_Done,
     /* 1552855 */   // Label 21525: @1552855
     /* 1552855 */   GIM_Try, /*On fail goto*//*Label 21526*/ GIMT_Encode4(1552937), // Rule ID 20690 //
     /* 1552860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1552863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1552883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552899 */     // MIs[0] round
     /* 1552899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552902 */     // MIs[0] policy
     /* 1552902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552912 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1552912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1552915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1552919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1552921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1552923 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1552925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1552930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1552933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1552935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1552936 */     // GIR_Coverage, 20690,
     /* 1552936 */     GIR_EraseRootFromParent_Done,
     /* 1552937 */   // Label 21526: @1552937
     /* 1552937 */   GIM_Try, /*On fail goto*//*Label 21527*/ GIMT_Encode4(1553019), // Rule ID 20691 //
     /* 1552942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1552945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_x_f_v_mask),
     /* 1552950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1552953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1552956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1552959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1552962 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1552965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1552969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1552977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1552981 */     // MIs[0] round
     /* 1552981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1552984 */     // MIs[0] policy
     /* 1552984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1552987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1552994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11129:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_X_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1552994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_X_F_V_M8_MASK),
     /* 1552997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1552999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553005 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553018 */     // GIR_Coverage, 20691,
     /* 1553018 */     GIR_EraseRootFromParent_Done,
     /* 1553019 */   // Label 21527: @1553019
     /* 1553019 */   GIM_Try, /*On fail goto*//*Label 21528*/ GIMT_Encode4(1553101), // Rule ID 20694 //
     /* 1553024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1553027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1553035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1553038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553044 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553063 */     // MIs[0] round
     /* 1553063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553066 */     // MIs[0] policy
     /* 1553066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553076 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1553079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553087 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553100 */     // GIR_Coverage, 20694,
     /* 1553100 */     GIR_EraseRootFromParent_Done,
     /* 1553101 */   // Label 21528: @1553101
     /* 1553101 */   GIM_Try, /*On fail goto*//*Label 21529*/ GIMT_Encode4(1553183), // Rule ID 20695 //
     /* 1553106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1553109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1553117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1553120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1553123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553145 */     // MIs[0] round
     /* 1553145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553148 */     // MIs[0] policy
     /* 1553148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553158 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF4_MASK),
     /* 1553161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553167 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553169 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553182 */     // GIR_Coverage, 20695,
     /* 1553182 */     GIR_EraseRootFromParent_Done,
     /* 1553183 */   // Label 21529: @1553183
     /* 1553183 */   GIM_Try, /*On fail goto*//*Label 21530*/ GIMT_Encode4(1553265), // Rule ID 20698 //
     /* 1553188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1553191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553208 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553227 */     // MIs[0] round
     /* 1553227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553230 */     // MIs[0] policy
     /* 1553230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553240 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1553243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553249 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553251 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553264 */     // GIR_Coverage, 20698,
     /* 1553264 */     GIR_EraseRootFromParent_Done,
     /* 1553265 */   // Label 21530: @1553265
     /* 1553265 */   GIM_Try, /*On fail goto*//*Label 21531*/ GIMT_Encode4(1553347), // Rule ID 20699 //
     /* 1553270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1553273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1553281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1553284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1553287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553290 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553309 */     // MIs[0] round
     /* 1553309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553312 */     // MIs[0] policy
     /* 1553312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553322 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1553325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553333 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553346 */     // GIR_Coverage, 20699,
     /* 1553346 */     GIR_EraseRootFromParent_Done,
     /* 1553347 */   // Label 21531: @1553347
     /* 1553347 */   GIM_Try, /*On fail goto*//*Label 21532*/ GIMT_Encode4(1553429), // Rule ID 20702 //
     /* 1553352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1553355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553391 */     // MIs[0] round
     /* 1553391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553394 */     // MIs[0] policy
     /* 1553394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553404 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1553407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553413 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553415 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553428 */     // GIR_Coverage, 20702,
     /* 1553428 */     GIR_EraseRootFromParent_Done,
     /* 1553429 */   // Label 21532: @1553429
     /* 1553429 */   GIM_Try, /*On fail goto*//*Label 21533*/ GIMT_Encode4(1553511), // Rule ID 20703 //
     /* 1553434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1553437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1553445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1553448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1553451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553454 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553473 */     // MIs[0] round
     /* 1553473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553476 */     // MIs[0] policy
     /* 1553476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_MF2_MASK),
     /* 1553489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553495 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553497 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553510 */     // GIR_Coverage, 20703,
     /* 1553510 */     GIR_EraseRootFromParent_Done,
     /* 1553511 */   // Label 21533: @1553511
     /* 1553511 */   GIM_Try, /*On fail goto*//*Label 21534*/ GIMT_Encode4(1553593), // Rule ID 20706 //
     /* 1553516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1553519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553536 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553555 */     // MIs[0] round
     /* 1553555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553558 */     // MIs[0] policy
     /* 1553558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553568 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553577 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553579 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553592 */     // GIR_Coverage, 20706,
     /* 1553592 */     GIR_EraseRootFromParent_Done,
     /* 1553593 */   // Label 21534: @1553593
     /* 1553593 */   GIM_Try, /*On fail goto*//*Label 21535*/ GIMT_Encode4(1553675), // Rule ID 20707 //
     /* 1553598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1553601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1553609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1553612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1553615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1553618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553637 */     // MIs[0] round
     /* 1553637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553640 */     // MIs[0] policy
     /* 1553640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553650 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11131:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553659 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553661 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1553671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553674 */     // GIR_Coverage, 20707,
     /* 1553674 */     GIR_EraseRootFromParent_Done,
     /* 1553675 */   // Label 21535: @1553675
     /* 1553675 */   GIM_Try, /*On fail goto*//*Label 21536*/ GIMT_Encode4(1553757), // Rule ID 20710 //
     /* 1553680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1553683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553700 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553719 */     // MIs[0] round
     /* 1553719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553722 */     // MIs[0] policy
     /* 1553722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553741 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553743 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553756 */     // GIR_Coverage, 20710,
     /* 1553756 */     GIR_EraseRootFromParent_Done,
     /* 1553757 */   // Label 21536: @1553757
     /* 1553757 */   GIM_Try, /*On fail goto*//*Label 21537*/ GIMT_Encode4(1553839), // Rule ID 20711 //
     /* 1553762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1553765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1553773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1553776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1553779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1553782 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553801 */     // MIs[0] round
     /* 1553801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553804 */     // MIs[0] policy
     /* 1553804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553814 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11131:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553823 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553825 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1553835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553838 */     // GIR_Coverage, 20711,
     /* 1553838 */     GIR_EraseRootFromParent_Done,
     /* 1553839 */   // Label 21537: @1553839
     /* 1553839 */   GIM_Try, /*On fail goto*//*Label 21538*/ GIMT_Encode4(1553921), // Rule ID 20714 //
     /* 1553844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1553847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1553867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553883 */     // MIs[0] round
     /* 1553883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553886 */     // MIs[0] policy
     /* 1553886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553896 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1553896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553905 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553907 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1553919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1553920 */     // GIR_Coverage, 20714,
     /* 1553920 */     GIR_EraseRootFromParent_Done,
     /* 1553921 */   // Label 21538: @1553921
     /* 1553921 */   GIM_Try, /*On fail goto*//*Label 21539*/ GIMT_Encode4(1554003), // Rule ID 20715 //
     /* 1553926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1553929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1553934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1553937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1553940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1553943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1553946 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1553949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1553953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1553961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1553965 */     // MIs[0] round
     /* 1553965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1553968 */     // MIs[0] policy
     /* 1553968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1553971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1553978 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11131:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1553978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M1_MASK),
     /* 1553981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1553983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1553985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1553987 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1553989 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1553991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1553996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1553999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554002 */     // GIR_Coverage, 20715,
     /* 1554002 */     GIR_EraseRootFromParent_Done,
     /* 1554003 */   // Label 21539: @1554003
     /* 1554003 */   GIM_Try, /*On fail goto*//*Label 21540*/ GIMT_Encode4(1554085), // Rule ID 20718 //
     /* 1554008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1554011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1554019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1554022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1554025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554028 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554047 */     // MIs[0] round
     /* 1554047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554050 */     // MIs[0] policy
     /* 1554050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1554063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554069 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554071 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554084 */     // GIR_Coverage, 20718,
     /* 1554084 */     GIR_EraseRootFromParent_Done,
     /* 1554085 */   // Label 21540: @1554085
     /* 1554085 */   GIM_Try, /*On fail goto*//*Label 21541*/ GIMT_Encode4(1554167), // Rule ID 20719 //
     /* 1554090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1554093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1554101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1554104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1554107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554129 */     // MIs[0] round
     /* 1554129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554132 */     // MIs[0] policy
     /* 1554132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554142 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1554145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554151 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554153 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554166 */     // GIR_Coverage, 20719,
     /* 1554166 */     GIR_EraseRootFromParent_Done,
     /* 1554167 */   // Label 21541: @1554167
     /* 1554167 */   GIM_Try, /*On fail goto*//*Label 21542*/ GIMT_Encode4(1554249), // Rule ID 20722 //
     /* 1554172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1554175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554211 */     // MIs[0] round
     /* 1554211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554214 */     // MIs[0] policy
     /* 1554214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554224 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1554227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554233 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554235 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554248 */     // GIR_Coverage, 20722,
     /* 1554248 */     GIR_EraseRootFromParent_Done,
     /* 1554249 */   // Label 21542: @1554249
     /* 1554249 */   GIM_Try, /*On fail goto*//*Label 21543*/ GIMT_Encode4(1554331), // Rule ID 20723 //
     /* 1554254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1554257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1554265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1554268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1554271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554293 */     // MIs[0] round
     /* 1554293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554296 */     // MIs[0] policy
     /* 1554296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1554309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554317 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554330 */     // GIR_Coverage, 20723,
     /* 1554330 */     GIR_EraseRootFromParent_Done,
     /* 1554331 */   // Label 21543: @1554331
     /* 1554331 */   GIM_Try, /*On fail goto*//*Label 21544*/ GIMT_Encode4(1554413), // Rule ID 20726 //
     /* 1554336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1554339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554375 */     // MIs[0] round
     /* 1554375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554378 */     // MIs[0] policy
     /* 1554378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554388 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1554391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554397 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554399 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554412 */     // GIR_Coverage, 20726,
     /* 1554412 */     GIR_EraseRootFromParent_Done,
     /* 1554413 */   // Label 21544: @1554413
     /* 1554413 */   GIM_Try, /*On fail goto*//*Label 21545*/ GIMT_Encode4(1554495), // Rule ID 20727 //
     /* 1554418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1554421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1554429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1554432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1554435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1554438 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554457 */     // MIs[0] round
     /* 1554457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554460 */     // MIs[0] policy
     /* 1554460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554470 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1554473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554479 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554481 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1554491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554494 */     // GIR_Coverage, 20727,
     /* 1554494 */     GIR_EraseRootFromParent_Done,
     /* 1554495 */   // Label 21545: @1554495
     /* 1554495 */   GIM_Try, /*On fail goto*//*Label 21546*/ GIMT_Encode4(1554577), // Rule ID 20730 //
     /* 1554500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1554503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554520 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554539 */     // MIs[0] round
     /* 1554539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554542 */     // MIs[0] policy
     /* 1554542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1554555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554561 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554563 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554576 */     // GIR_Coverage, 20730,
     /* 1554576 */     GIR_EraseRootFromParent_Done,
     /* 1554577 */   // Label 21546: @1554577
     /* 1554577 */   GIM_Try, /*On fail goto*//*Label 21547*/ GIMT_Encode4(1554659), // Rule ID 20731 //
     /* 1554582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1554585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1554593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1554596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1554599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1554602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1554609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1554617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554621 */     // MIs[0] round
     /* 1554621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554624 */     // MIs[0] policy
     /* 1554624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1554637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554643 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554645 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554658 */     // GIR_Coverage, 20731,
     /* 1554658 */     GIR_EraseRootFromParent_Done,
     /* 1554659 */   // Label 21547: @1554659
     /* 1554659 */   GIM_Try, /*On fail goto*//*Label 21548*/ GIMT_Encode4(1554741), // Rule ID 20734 //
     /* 1554664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1554667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554703 */     // MIs[0] round
     /* 1554703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554706 */     // MIs[0] policy
     /* 1554706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554716 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1554719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554725 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554727 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554740 */     // GIR_Coverage, 20734,
     /* 1554740 */     GIR_EraseRootFromParent_Done,
     /* 1554741 */   // Label 21548: @1554741
     /* 1554741 */   GIM_Try, /*On fail goto*//*Label 21549*/ GIMT_Encode4(1554823), // Rule ID 20735 //
     /* 1554746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1554749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1554757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1554760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1554763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1554766 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1554773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1554781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554785 */     // MIs[0] round
     /* 1554785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554788 */     // MIs[0] policy
     /* 1554788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1554801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554807 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554809 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554822 */     // GIR_Coverage, 20735,
     /* 1554822 */     GIR_EraseRootFromParent_Done,
     /* 1554823 */   // Label 21549: @1554823
     /* 1554823 */   GIM_Try, /*On fail goto*//*Label 21550*/ GIMT_Encode4(1554905), // Rule ID 20738 //
     /* 1554828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1554831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1554851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554867 */     // MIs[0] round
     /* 1554867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554870 */     // MIs[0] policy
     /* 1554870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554880 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1554880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1554883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554889 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554891 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554904 */     // GIR_Coverage, 20738,
     /* 1554904 */     GIR_EraseRootFromParent_Done,
     /* 1554905 */   // Label 21550: @1554905
     /* 1554905 */   GIM_Try, /*On fail goto*//*Label 21551*/ GIMT_Encode4(1554987), // Rule ID 20739 //
     /* 1554910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1554913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1554918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1554921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1554924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1554927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1554930 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1554933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1554937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1554945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1554949 */     // MIs[0] round
     /* 1554949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1554952 */     // MIs[0] policy
     /* 1554952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1554955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1554962 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1554962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1554965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1554967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1554969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1554971 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1554973 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1554975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1554980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1554983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1554985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1554986 */     // GIR_Coverage, 20739,
     /* 1554986 */     GIR_EraseRootFromParent_Done,
     /* 1554987 */   // Label 21551: @1554987
     /* 1554987 */   GIM_Try, /*On fail goto*//*Label 21552*/ GIMT_Encode4(1555069), // Rule ID 20742 //
     /* 1554992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1554995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1555003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1555006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1555009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555012 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555031 */     // MIs[0] round
     /* 1555031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555034 */     // MIs[0] policy
     /* 1555034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1555047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555053 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555055 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555068 */     // GIR_Coverage, 20742,
     /* 1555068 */     GIR_EraseRootFromParent_Done,
     /* 1555069 */   // Label 21552: @1555069
     /* 1555069 */   GIM_Try, /*On fail goto*//*Label 21553*/ GIMT_Encode4(1555151), // Rule ID 20743 //
     /* 1555074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1555077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1555085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1555088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1555091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1555101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1555109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555113 */     // MIs[0] round
     /* 1555113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555116 */     // MIs[0] policy
     /* 1555116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555126 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11131:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M2_MASK),
     /* 1555129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555135 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555137 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555150 */     // GIR_Coverage, 20743,
     /* 1555150 */     GIR_EraseRootFromParent_Done,
     /* 1555151 */   // Label 21553: @1555151
     /* 1555151 */   GIM_Try, /*On fail goto*//*Label 21554*/ GIMT_Encode4(1555233), // Rule ID 20746 //
     /* 1555156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1555159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555176 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555195 */     // MIs[0] round
     /* 1555195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555198 */     // MIs[0] policy
     /* 1555198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555208 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1555211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555217 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555219 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555232 */     // GIR_Coverage, 20746,
     /* 1555232 */     GIR_EraseRootFromParent_Done,
     /* 1555233 */   // Label 21554: @1555233
     /* 1555233 */   GIM_Try, /*On fail goto*//*Label 21555*/ GIMT_Encode4(1555315), // Rule ID 20747 //
     /* 1555238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1555241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1555249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1555252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1555255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555258 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1555265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1555273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555277 */     // MIs[0] round
     /* 1555277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555280 */     // MIs[0] policy
     /* 1555280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11131:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M4_MASK),
     /* 1555293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555299 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555301 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555314 */     // GIR_Coverage, 20747,
     /* 1555314 */     GIR_EraseRootFromParent_Done,
     /* 1555315 */   // Label 21555: @1555315
     /* 1555315 */   GIM_Try, /*On fail goto*//*Label 21556*/ GIMT_Encode4(1555397), // Rule ID 20750 //
     /* 1555320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1555323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555359 */     // MIs[0] round
     /* 1555359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555362 */     // MIs[0] policy
     /* 1555362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555372 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1555375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555383 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555396 */     // GIR_Coverage, 20750,
     /* 1555396 */     GIR_EraseRootFromParent_Done,
     /* 1555397 */   // Label 21556: @1555397
     /* 1555397 */   GIM_Try, /*On fail goto*//*Label 21557*/ GIMT_Encode4(1555479), // Rule ID 20751 //
     /* 1555402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1555405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_xu_f_v_mask),
     /* 1555410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1555413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1555416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1555419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1555422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1555429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1555437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555441 */     // MIs[0] round
     /* 1555441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555444 */     // MIs[0] policy
     /* 1555444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11131:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_XU_F_V_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_XU_F_V_M8_MASK),
     /* 1555457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555463 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555465 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1555475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555478 */     // GIR_Coverage, 20751,
     /* 1555478 */     GIR_EraseRootFromParent_Done,
     /* 1555479 */   // Label 21557: @1555479
     /* 1555479 */   GIM_Try, /*On fail goto*//*Label 21558*/ GIMT_Encode4(1555561), // Rule ID 20874 //
     /* 1555484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555504 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555523 */     // MIs[0] round
     /* 1555523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555526 */     // MIs[0] policy
     /* 1555526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555536 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1555539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555545 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555547 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555560 */     // GIR_Coverage, 20874,
     /* 1555560 */     GIR_EraseRootFromParent_Done,
     /* 1555561 */   // Label 21558: @1555561
     /* 1555561 */   GIM_Try, /*On fail goto*//*Label 21559*/ GIMT_Encode4(1555643), // Rule ID 20875 //
     /* 1555566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1555569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1555577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1555580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1555583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555605 */     // MIs[0] round
     /* 1555605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555608 */     // MIs[0] policy
     /* 1555608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555618 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16_MASK),
     /* 1555621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555629 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555642 */     // GIR_Coverage, 20875,
     /* 1555642 */     GIR_EraseRootFromParent_Done,
     /* 1555643 */   // Label 21559: @1555643
     /* 1555643 */   GIM_Try, /*On fail goto*//*Label 21560*/ GIMT_Encode4(1555725), // Rule ID 20878 //
     /* 1555648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555668 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555687 */     // MIs[0] round
     /* 1555687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555690 */     // MIs[0] policy
     /* 1555690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555700 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1555703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555709 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555711 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555724 */     // GIR_Coverage, 20878,
     /* 1555724 */     GIR_EraseRootFromParent_Done,
     /* 1555725 */   // Label 21560: @1555725
     /* 1555725 */   GIM_Try, /*On fail goto*//*Label 21561*/ GIMT_Encode4(1555807), // Rule ID 20879 //
     /* 1555730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1555733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1555741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1555744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1555747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1555750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555769 */     // MIs[0] round
     /* 1555769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555772 */     // MIs[0] policy
     /* 1555772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555782 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16_MASK),
     /* 1555785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555791 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555793 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1555803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555806 */     // GIR_Coverage, 20879,
     /* 1555806 */     GIR_EraseRootFromParent_Done,
     /* 1555807 */   // Label 21561: @1555807
     /* 1555807 */   GIM_Try, /*On fail goto*//*Label 21562*/ GIMT_Encode4(1555889), // Rule ID 20882 //
     /* 1555812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1555815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555851 */     // MIs[0] round
     /* 1555851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555854 */     // MIs[0] policy
     /* 1555854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555864 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1555864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1555867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555873 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555875 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555888 */     // GIR_Coverage, 20882,
     /* 1555888 */     GIR_EraseRootFromParent_Done,
     /* 1555889 */   // Label 21562: @1555889
     /* 1555889 */   GIM_Try, /*On fail goto*//*Label 21563*/ GIMT_Encode4(1555971), // Rule ID 20883 //
     /* 1555894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1555897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1555905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1555908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1555911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1555914 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1555917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1555921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1555929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1555933 */     // MIs[0] round
     /* 1555933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1555936 */     // MIs[0] policy
     /* 1555936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1555939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1555946 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1555946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32_MASK),
     /* 1555949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1555951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1555953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1555955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1555957 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1555959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1555964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1555967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1555969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1555970 */     // GIR_Coverage, 20883,
     /* 1555970 */     GIR_EraseRootFromParent_Done,
     /* 1555971 */   // Label 21563: @1555971
     /* 1555971 */   GIM_Try, /*On fail goto*//*Label 21564*/ GIMT_Encode4(1556053), // Rule ID 20886 //
     /* 1555976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1555979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1555984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1555987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1555990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1555993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1555996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1555999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556015 */     // MIs[0] round
     /* 1556015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556018 */     // MIs[0] policy
     /* 1556018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556028 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1556031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556039 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556052 */     // GIR_Coverage, 20886,
     /* 1556052 */     GIR_EraseRootFromParent_Done,
     /* 1556053 */   // Label 21564: @1556053
     /* 1556053 */   GIM_Try, /*On fail goto*//*Label 21565*/ GIMT_Encode4(1556135), // Rule ID 20887 //
     /* 1556058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1556069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1556072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1556075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556097 */     // MIs[0] round
     /* 1556097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556100 */     // MIs[0] policy
     /* 1556100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556110 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11121:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16_MASK),
     /* 1556113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556121 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556134 */     // GIR_Coverage, 20887,
     /* 1556134 */     GIR_EraseRootFromParent_Done,
     /* 1556135 */   // Label 21565: @1556135
     /* 1556135 */   GIM_Try, /*On fail goto*//*Label 21566*/ GIMT_Encode4(1556217), // Rule ID 20890 //
     /* 1556140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1556143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556160 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556179 */     // MIs[0] round
     /* 1556179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556182 */     // MIs[0] policy
     /* 1556182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556192 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1556195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556201 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556203 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556216 */     // GIR_Coverage, 20890,
     /* 1556216 */     GIR_EraseRootFromParent_Done,
     /* 1556217 */   // Label 21566: @1556217
     /* 1556217 */   GIM_Try, /*On fail goto*//*Label 21567*/ GIMT_Encode4(1556299), // Rule ID 20891 //
     /* 1556222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1556225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1556233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1556236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1556239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1556242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556261 */     // MIs[0] round
     /* 1556261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556264 */     // MIs[0] policy
     /* 1556264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556274 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11121:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32_MASK),
     /* 1556277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556283 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556285 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1556295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556298 */     // GIR_Coverage, 20891,
     /* 1556298 */     GIR_EraseRootFromParent_Done,
     /* 1556299 */   // Label 21567: @1556299
     /* 1556299 */   GIM_Try, /*On fail goto*//*Label 21568*/ GIMT_Encode4(1556381), // Rule ID 20894 //
     /* 1556304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1556307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556324 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556343 */     // MIs[0] round
     /* 1556343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556346 */     // MIs[0] policy
     /* 1556346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556356 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1556359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556367 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556380 */     // GIR_Coverage, 20894,
     /* 1556380 */     GIR_EraseRootFromParent_Done,
     /* 1556381 */   // Label 21568: @1556381
     /* 1556381 */   GIM_Try, /*On fail goto*//*Label 21569*/ GIMT_Encode4(1556463), // Rule ID 20895 //
     /* 1556386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1556389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1556397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1556400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1556403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1556406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1556413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1556421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556425 */     // MIs[0] round
     /* 1556425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556428 */     // MIs[0] policy
     /* 1556428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556438 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11121:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64_MASK),
     /* 1556441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556447 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556449 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1556459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556462 */     // GIR_Coverage, 20895,
     /* 1556462 */     GIR_EraseRootFromParent_Done,
     /* 1556463 */   // Label 21569: @1556463
     /* 1556463 */   GIM_Try, /*On fail goto*//*Label 21570*/ GIMT_Encode4(1556545), // Rule ID 20898 //
     /* 1556468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1556471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556507 */     // MIs[0] round
     /* 1556507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556510 */     // MIs[0] policy
     /* 1556510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1556523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556531 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556544 */     // GIR_Coverage, 20898,
     /* 1556544 */     GIR_EraseRootFromParent_Done,
     /* 1556545 */   // Label 21570: @1556545
     /* 1556545 */   GIM_Try, /*On fail goto*//*Label 21571*/ GIMT_Encode4(1556627), // Rule ID 20899 //
     /* 1556550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1556561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1556564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1556567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1556570 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556589 */     // MIs[0] round
     /* 1556589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556592 */     // MIs[0] policy
     /* 1556592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556602 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16_MASK),
     /* 1556605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556611 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556613 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556626 */     // GIR_Coverage, 20899,
     /* 1556626 */     GIR_EraseRootFromParent_Done,
     /* 1556627 */   // Label 21571: @1556627
     /* 1556627 */   GIM_Try, /*On fail goto*//*Label 21572*/ GIMT_Encode4(1556709), // Rule ID 20902 //
     /* 1556632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1556635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556652 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556671 */     // MIs[0] round
     /* 1556671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556674 */     // MIs[0] policy
     /* 1556674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556684 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1556687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556695 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556708 */     // GIR_Coverage, 20902,
     /* 1556708 */     GIR_EraseRootFromParent_Done,
     /* 1556709 */   // Label 21572: @1556709
     /* 1556709 */   GIM_Try, /*On fail goto*//*Label 21573*/ GIMT_Encode4(1556791), // Rule ID 20903 //
     /* 1556714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1556725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1556728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1556731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1556734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1556741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1556749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556753 */     // MIs[0] round
     /* 1556753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556756 */     // MIs[0] policy
     /* 1556756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556766 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16_MASK),
     /* 1556769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556777 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556790 */     // GIR_Coverage, 20903,
     /* 1556790 */     GIR_EraseRootFromParent_Done,
     /* 1556791 */   // Label 21573: @1556791
     /* 1556791 */   GIM_Try, /*On fail goto*//*Label 21574*/ GIMT_Encode4(1556873), // Rule ID 20906 //
     /* 1556796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1556799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556816 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556835 */     // MIs[0] round
     /* 1556835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556838 */     // MIs[0] policy
     /* 1556838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556848 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1556848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1556851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556857 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556859 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556872 */     // GIR_Coverage, 20906,
     /* 1556872 */     GIR_EraseRootFromParent_Done,
     /* 1556873 */   // Label 21574: @1556873
     /* 1556873 */   GIM_Try, /*On fail goto*//*Label 21575*/ GIMT_Encode4(1556955), // Rule ID 20907 //
     /* 1556878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1556881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1556889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1556892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1556895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1556898 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1556901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1556905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1556913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556917 */     // MIs[0] round
     /* 1556917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1556920 */     // MIs[0] policy
     /* 1556920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1556923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1556930 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1556930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16_MASK),
     /* 1556933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1556935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1556937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1556939 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1556941 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1556943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1556948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1556951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1556953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1556954 */     // GIR_Coverage, 20907,
     /* 1556954 */     GIR_EraseRootFromParent_Done,
     /* 1556955 */   // Label 21575: @1556955
     /* 1556955 */   GIM_Try, /*On fail goto*//*Label 21576*/ GIMT_Encode4(1557037), // Rule ID 20910 //
     /* 1556960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1556963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1556968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1556971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1556974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1556977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1556980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1556983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1556987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1556995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1556999 */     // MIs[0] round
     /* 1556999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557002 */     // MIs[0] policy
     /* 1557002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557012 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1557015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557021 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557023 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557036 */     // GIR_Coverage, 20910,
     /* 1557036 */     GIR_EraseRootFromParent_Done,
     /* 1557037 */   // Label 21576: @1557037
     /* 1557037 */   GIM_Try, /*On fail goto*//*Label 21577*/ GIMT_Encode4(1557119), // Rule ID 20911 //
     /* 1557042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1557053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1557056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1557059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557062 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557081 */     // MIs[0] round
     /* 1557081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557084 */     // MIs[0] policy
     /* 1557084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557094 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32_MASK),
     /* 1557097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557103 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557105 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557118 */     // GIR_Coverage, 20911,
     /* 1557118 */     GIR_EraseRootFromParent_Done,
     /* 1557119 */   // Label 21577: @1557119
     /* 1557119 */   GIM_Try, /*On fail goto*//*Label 21578*/ GIMT_Encode4(1557201), // Rule ID 20914 //
     /* 1557124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557144 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557163 */     // MIs[0] round
     /* 1557163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557166 */     // MIs[0] policy
     /* 1557166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1557179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557185 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557187 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557200 */     // GIR_Coverage, 20914,
     /* 1557200 */     GIR_EraseRootFromParent_Done,
     /* 1557201 */   // Label 21578: @1557201
     /* 1557201 */   GIM_Try, /*On fail goto*//*Label 21579*/ GIMT_Encode4(1557283), // Rule ID 20915 //
     /* 1557206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1557217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1557220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1557223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557245 */     // MIs[0] round
     /* 1557245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557248 */     // MIs[0] policy
     /* 1557248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557258 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32_MASK),
     /* 1557261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557267 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557269 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557282 */     // GIR_Coverage, 20915,
     /* 1557282 */     GIR_EraseRootFromParent_Done,
     /* 1557283 */   // Label 21579: @1557283
     /* 1557283 */   GIM_Try, /*On fail goto*//*Label 21580*/ GIMT_Encode4(1557365), // Rule ID 20918 //
     /* 1557288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1557291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557308 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557327 */     // MIs[0] round
     /* 1557327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557330 */     // MIs[0] policy
     /* 1557330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557340 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1557343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557349 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557351 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557364 */     // GIR_Coverage, 20918,
     /* 1557364 */     GIR_EraseRootFromParent_Done,
     /* 1557365 */   // Label 21580: @1557365
     /* 1557365 */   GIM_Try, /*On fail goto*//*Label 21581*/ GIMT_Encode4(1557447), // Rule ID 20919 //
     /* 1557370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1557373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1557381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1557384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1557387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1557390 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557409 */     // MIs[0] round
     /* 1557409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557412 */     // MIs[0] policy
     /* 1557412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557422 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32_MASK),
     /* 1557425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557431 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557433 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1557443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557446 */     // GIR_Coverage, 20919,
     /* 1557446 */     GIR_EraseRootFromParent_Done,
     /* 1557447 */   // Label 21581: @1557447
     /* 1557447 */   GIM_Try, /*On fail goto*//*Label 21582*/ GIMT_Encode4(1557529), // Rule ID 20922 //
     /* 1557452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557491 */     // MIs[0] round
     /* 1557491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557494 */     // MIs[0] policy
     /* 1557494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557504 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1557507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557513 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557515 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557528 */     // GIR_Coverage, 20922,
     /* 1557528 */     GIR_EraseRootFromParent_Done,
     /* 1557529 */   // Label 21582: @1557529
     /* 1557529 */   GIM_Try, /*On fail goto*//*Label 21583*/ GIMT_Encode4(1557611), // Rule ID 20923 //
     /* 1557534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1557537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1557545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1557548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1557551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1557554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1557561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1557569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557573 */     // MIs[0] round
     /* 1557573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557576 */     // MIs[0] policy
     /* 1557576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557586 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11121:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64_MASK),
     /* 1557589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557595 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557597 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557610 */     // GIR_Coverage, 20923,
     /* 1557610 */     GIR_EraseRootFromParent_Done,
     /* 1557611 */   // Label 21583: @1557611
     /* 1557611 */   GIM_Try, /*On fail goto*//*Label 21584*/ GIMT_Encode4(1557693), // Rule ID 20926 //
     /* 1557616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557636 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557655 */     // MIs[0] round
     /* 1557655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557658 */     // MIs[0] policy
     /* 1557658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557668 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1557671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557677 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557679 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557692 */     // GIR_Coverage, 20926,
     /* 1557692 */     GIR_EraseRootFromParent_Done,
     /* 1557693 */   // Label 21584: @1557693
     /* 1557693 */   GIM_Try, /*On fail goto*//*Label 21585*/ GIMT_Encode4(1557775), // Rule ID 20927 //
     /* 1557698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1557701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1557709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1557712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1557715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1557718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1557725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1557733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557737 */     // MIs[0] round
     /* 1557737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557740 */     // MIs[0] policy
     /* 1557740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11121:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64_MASK),
     /* 1557753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557759 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557761 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557774 */     // GIR_Coverage, 20927,
     /* 1557774 */     GIR_EraseRootFromParent_Done,
     /* 1557775 */   // Label 21585: @1557775
     /* 1557775 */   GIM_Try, /*On fail goto*//*Label 21586*/ GIMT_Encode4(1557857), // Rule ID 20930 //
     /* 1557780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1557783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557800 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557819 */     // MIs[0] round
     /* 1557819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557822 */     // MIs[0] policy
     /* 1557822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557832 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1557835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557841 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557843 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557856 */     // GIR_Coverage, 20930,
     /* 1557856 */     GIR_EraseRootFromParent_Done,
     /* 1557857 */   // Label 21586: @1557857
     /* 1557857 */   GIM_Try, /*On fail goto*//*Label 21587*/ GIMT_Encode4(1557939), // Rule ID 20931 //
     /* 1557862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1557865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_x_v_mask),
     /* 1557870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1557873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1557876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1557879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1557882 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1557885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1557889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1557897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557901 */     // MIs[0] round
     /* 1557901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557904 */     // MIs[0] policy
     /* 1557904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557914 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11121:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_X_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1557914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64_MASK),
     /* 1557917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1557919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1557921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1557923 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1557925 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1557927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1557932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1557935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1557937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1557938 */     // GIR_Coverage, 20931,
     /* 1557938 */     GIR_EraseRootFromParent_Done,
     /* 1557939 */   // Label 21587: @1557939
     /* 1557939 */   GIM_Try, /*On fail goto*//*Label 21588*/ GIMT_Encode4(1558021), // Rule ID 20934 //
     /* 1557944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1557947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1557952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1557955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1557958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1557961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1557964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1557967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1557971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1557979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1557983 */     // MIs[0] round
     /* 1557983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1557986 */     // MIs[0] policy
     /* 1557986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1557989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1557996 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1557996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1557999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558005 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558007 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558020 */     // GIR_Coverage, 20934,
     /* 1558020 */     GIR_EraseRootFromParent_Done,
     /* 1558021 */   // Label 21588: @1558021
     /* 1558021 */   GIM_Try, /*On fail goto*//*Label 21589*/ GIMT_Encode4(1558103), // Rule ID 20935 //
     /* 1558026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1558037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1558040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1558043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558065 */     // MIs[0] round
     /* 1558065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558068 */     // MIs[0] policy
     /* 1558068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558078 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16_MASK),
     /* 1558081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558089 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558102 */     // GIR_Coverage, 20935,
     /* 1558102 */     GIR_EraseRootFromParent_Done,
     /* 1558103 */   // Label 21589: @1558103
     /* 1558103 */   GIM_Try, /*On fail goto*//*Label 21590*/ GIMT_Encode4(1558185), // Rule ID 20938 //
     /* 1558108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1558119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1558122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1558125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558128 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558147 */     // MIs[0] round
     /* 1558147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558150 */     // MIs[0] policy
     /* 1558150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558160 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1558163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558169 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558171 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558184 */     // GIR_Coverage, 20938,
     /* 1558184 */     GIR_EraseRootFromParent_Done,
     /* 1558185 */   // Label 21590: @1558185
     /* 1558185 */   GIM_Try, /*On fail goto*//*Label 21591*/ GIMT_Encode4(1558267), // Rule ID 20939 //
     /* 1558190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1558201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1558204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1558207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558229 */     // MIs[0] round
     /* 1558229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558232 */     // MIs[0] policy
     /* 1558232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558242 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16_MASK),
     /* 1558245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558253 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558266 */     // GIR_Coverage, 20939,
     /* 1558266 */     GIR_EraseRootFromParent_Done,
     /* 1558267 */   // Label 21591: @1558267
     /* 1558267 */   GIM_Try, /*On fail goto*//*Label 21592*/ GIMT_Encode4(1558349), // Rule ID 20942 //
     /* 1558272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1558283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1558286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1558289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558292 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558311 */     // MIs[0] round
     /* 1558311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558314 */     // MIs[0] policy
     /* 1558314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558324 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1558327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558335 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558348 */     // GIR_Coverage, 20942,
     /* 1558348 */     GIR_EraseRootFromParent_Done,
     /* 1558349 */   // Label 21592: @1558349
     /* 1558349 */   GIM_Try, /*On fail goto*//*Label 21593*/ GIMT_Encode4(1558431), // Rule ID 20943 //
     /* 1558354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1558365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1558368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1558371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558374 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558393 */     // MIs[0] round
     /* 1558393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558396 */     // MIs[0] policy
     /* 1558396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558406 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32_MASK),
     /* 1558409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558415 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558417 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558430 */     // GIR_Coverage, 20943,
     /* 1558430 */     GIR_EraseRootFromParent_Done,
     /* 1558431 */   // Label 21593: @1558431
     /* 1558431 */   GIM_Try, /*On fail goto*//*Label 21594*/ GIMT_Encode4(1558513), // Rule ID 20946 //
     /* 1558436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558475 */     // MIs[0] round
     /* 1558475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558478 */     // MIs[0] policy
     /* 1558478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558488 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1558491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558497 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558499 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558512 */     // GIR_Coverage, 20946,
     /* 1558512 */     GIR_EraseRootFromParent_Done,
     /* 1558513 */   // Label 21594: @1558513
     /* 1558513 */   GIM_Try, /*On fail goto*//*Label 21595*/ GIMT_Encode4(1558595), // Rule ID 20947 //
     /* 1558518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1558521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1558529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1558532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1558535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1558538 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558557 */     // MIs[0] round
     /* 1558557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558560 */     // MIs[0] policy
     /* 1558560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558570 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11123:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16_MASK),
     /* 1558573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558579 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558581 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1558591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558594 */     // GIR_Coverage, 20947,
     /* 1558594 */     GIR_EraseRootFromParent_Done,
     /* 1558595 */   // Label 21595: @1558595
     /* 1558595 */   GIM_Try, /*On fail goto*//*Label 21596*/ GIMT_Encode4(1558677), // Rule ID 20950 //
     /* 1558600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1558603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558620 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558639 */     // MIs[0] round
     /* 1558639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558642 */     // MIs[0] policy
     /* 1558642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558652 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1558655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558661 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558663 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558676 */     // GIR_Coverage, 20950,
     /* 1558676 */     GIR_EraseRootFromParent_Done,
     /* 1558677 */   // Label 21596: @1558677
     /* 1558677 */   GIM_Try, /*On fail goto*//*Label 21597*/ GIMT_Encode4(1558759), // Rule ID 20951 //
     /* 1558682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1558685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1558693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1558696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1558699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1558702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558721 */     // MIs[0] round
     /* 1558721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558724 */     // MIs[0] policy
     /* 1558724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558734 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11123:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32_MASK),
     /* 1558737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558743 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558745 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1558755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558758 */     // GIR_Coverage, 20951,
     /* 1558758 */     GIR_EraseRootFromParent_Done,
     /* 1558759 */   // Label 21597: @1558759
     /* 1558759 */   GIM_Try, /*On fail goto*//*Label 21598*/ GIMT_Encode4(1558841), // Rule ID 20954 //
     /* 1558764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1558767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558784 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558803 */     // MIs[0] round
     /* 1558803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558806 */     // MIs[0] policy
     /* 1558806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1558819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558827 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558840 */     // GIR_Coverage, 20954,
     /* 1558840 */     GIR_EraseRootFromParent_Done,
     /* 1558841 */   // Label 21598: @1558841
     /* 1558841 */   GIM_Try, /*On fail goto*//*Label 21599*/ GIMT_Encode4(1558923), // Rule ID 20955 //
     /* 1558846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1558849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1558857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1558860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1558863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1558866 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1558869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1558873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1558881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558885 */     // MIs[0] round
     /* 1558885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558888 */     // MIs[0] policy
     /* 1558888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558898 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11123:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1558898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64_MASK),
     /* 1558901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558907 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558909 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1558919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1558921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1558922 */     // GIR_Coverage, 20955,
     /* 1558922 */     GIR_EraseRootFromParent_Done,
     /* 1558923 */   // Label 21599: @1558923
     /* 1558923 */   GIM_Try, /*On fail goto*//*Label 21600*/ GIMT_Encode4(1559005), // Rule ID 20958 //
     /* 1558928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1558931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1558936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1558939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1558942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1558945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1558948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1558951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1558955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1558963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1558967 */     // MIs[0] round
     /* 1558967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1558970 */     // MIs[0] policy
     /* 1558970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1558973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1558980 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1558980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1558983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1558985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1558987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1558989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1558991 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1558993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1558998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559004 */     // GIR_Coverage, 20958,
     /* 1559004 */     GIR_EraseRootFromParent_Done,
     /* 1559005 */   // Label 21600: @1559005
     /* 1559005 */   GIM_Try, /*On fail goto*//*Label 21601*/ GIMT_Encode4(1559087), // Rule ID 20959 //
     /* 1559010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1559021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1559024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1559027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559030 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559049 */     // MIs[0] round
     /* 1559049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559052 */     // MIs[0] policy
     /* 1559052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559062 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16_MASK),
     /* 1559065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559073 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559086 */     // GIR_Coverage, 20959,
     /* 1559086 */     GIR_EraseRootFromParent_Done,
     /* 1559087 */   // Label 21601: @1559087
     /* 1559087 */   GIM_Try, /*On fail goto*//*Label 21602*/ GIMT_Encode4(1559169), // Rule ID 20962 //
     /* 1559092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559112 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559131 */     // MIs[0] round
     /* 1559131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559134 */     // MIs[0] policy
     /* 1559134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559144 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1559147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559153 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559155 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559168 */     // GIR_Coverage, 20962,
     /* 1559168 */     GIR_EraseRootFromParent_Done,
     /* 1559169 */   // Label 21602: @1559169
     /* 1559169 */   GIM_Try, /*On fail goto*//*Label 21603*/ GIMT_Encode4(1559251), // Rule ID 20963 //
     /* 1559174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1559185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1559188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1559191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559213 */     // MIs[0] round
     /* 1559213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559216 */     // MIs[0] policy
     /* 1559216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559226 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16_MASK),
     /* 1559229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559235 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559237 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559250 */     // GIR_Coverage, 20963,
     /* 1559250 */     GIR_EraseRootFromParent_Done,
     /* 1559251 */   // Label 21603: @1559251
     /* 1559251 */   GIM_Try, /*On fail goto*//*Label 21604*/ GIMT_Encode4(1559333), // Rule ID 20966 //
     /* 1559256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1559259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1559276 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559295 */     // MIs[0] round
     /* 1559295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559298 */     // MIs[0] policy
     /* 1559298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559308 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1559311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559317 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559319 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559332 */     // GIR_Coverage, 20966,
     /* 1559332 */     GIR_EraseRootFromParent_Done,
     /* 1559333 */   // Label 21604: @1559333
     /* 1559333 */   GIM_Try, /*On fail goto*//*Label 21605*/ GIMT_Encode4(1559415), // Rule ID 20967 //
     /* 1559338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1559341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1559349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1559352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1559355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1559358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559377 */     // MIs[0] round
     /* 1559377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559380 */     // MIs[0] policy
     /* 1559380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559390 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16_MASK),
     /* 1559393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559399 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559401 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1559411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559414 */     // GIR_Coverage, 20967,
     /* 1559414 */     GIR_EraseRootFromParent_Done,
     /* 1559415 */   // Label 21605: @1559415
     /* 1559415 */   GIM_Try, /*On fail goto*//*Label 21606*/ GIMT_Encode4(1559497), // Rule ID 20970 //
     /* 1559420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559459 */     // MIs[0] round
     /* 1559459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559462 */     // MIs[0] policy
     /* 1559462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559472 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1559475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559483 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559496 */     // GIR_Coverage, 20970,
     /* 1559496 */     GIR_EraseRootFromParent_Done,
     /* 1559497 */   // Label 21606: @1559497
     /* 1559497 */   GIM_Try, /*On fail goto*//*Label 21607*/ GIMT_Encode4(1559579), // Rule ID 20971 //
     /* 1559502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1559513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1559516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1559519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1559522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559541 */     // MIs[0] round
     /* 1559541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559544 */     // MIs[0] policy
     /* 1559544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559554 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32_MASK),
     /* 1559557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559563 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559565 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559578 */     // GIR_Coverage, 20971,
     /* 1559578 */     GIR_EraseRootFromParent_Done,
     /* 1559579 */   // Label 21607: @1559579
     /* 1559579 */   GIM_Try, /*On fail goto*//*Label 21608*/ GIMT_Encode4(1559661), // Rule ID 20974 //
     /* 1559584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559604 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559623 */     // MIs[0] round
     /* 1559623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559626 */     // MIs[0] policy
     /* 1559626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559636 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1559639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559647 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559660 */     // GIR_Coverage, 20974,
     /* 1559660 */     GIR_EraseRootFromParent_Done,
     /* 1559661 */   // Label 21608: @1559661
     /* 1559661 */   GIM_Try, /*On fail goto*//*Label 21609*/ GIMT_Encode4(1559743), // Rule ID 20975 //
     /* 1559666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1559677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1559680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1559683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1559686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1559693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1559701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559705 */     // MIs[0] round
     /* 1559705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559708 */     // MIs[0] policy
     /* 1559708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559718 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32_MASK),
     /* 1559721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559727 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559729 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559742 */     // GIR_Coverage, 20975,
     /* 1559742 */     GIR_EraseRootFromParent_Done,
     /* 1559743 */   // Label 21609: @1559743
     /* 1559743 */   GIM_Try, /*On fail goto*//*Label 21610*/ GIMT_Encode4(1559825), // Rule ID 20978 //
     /* 1559748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1559751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559787 */     // MIs[0] round
     /* 1559787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559790 */     // MIs[0] policy
     /* 1559790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559800 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1559803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559811 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559824 */     // GIR_Coverage, 20978,
     /* 1559824 */     GIR_EraseRootFromParent_Done,
     /* 1559825 */   // Label 21610: @1559825
     /* 1559825 */   GIM_Try, /*On fail goto*//*Label 21611*/ GIMT_Encode4(1559907), // Rule ID 20979 //
     /* 1559830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1559833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1559841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1559844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1559847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1559850 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1559853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1559857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1559865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559869 */     // MIs[0] round
     /* 1559869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559872 */     // MIs[0] policy
     /* 1559872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559882 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1559882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32_MASK),
     /* 1559885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559891 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559893 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1559903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559906 */     // GIR_Coverage, 20979,
     /* 1559906 */     GIR_EraseRootFromParent_Done,
     /* 1559907 */   // Label 21611: @1559907
     /* 1559907 */   GIM_Try, /*On fail goto*//*Label 21612*/ GIMT_Encode4(1559989), // Rule ID 20982 //
     /* 1559912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1559915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1559920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1559923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1559926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1559929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1559932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1559935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1559939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1559947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1559951 */     // MIs[0] round
     /* 1559951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1559954 */     // MIs[0] policy
     /* 1559954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1559957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1559964 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1559964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1559967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1559969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1559971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1559973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1559975 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1559977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1559982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1559985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1559987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1559988 */     // GIR_Coverage, 20982,
     /* 1559988 */     GIR_EraseRootFromParent_Done,
     /* 1559989 */   // Label 21612: @1559989
     /* 1559989 */   GIM_Try, /*On fail goto*//*Label 21613*/ GIMT_Encode4(1560071), // Rule ID 20983 //
     /* 1559994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1559997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1560002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1560005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1560008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1560011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560014 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560033 */     // MIs[0] round
     /* 1560033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560036 */     // MIs[0] policy
     /* 1560036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560046 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11123:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64_MASK),
     /* 1560049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560055 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560057 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560070 */     // GIR_Coverage, 20983,
     /* 1560070 */     GIR_EraseRootFromParent_Done,
     /* 1560071 */   // Label 21613: @1560071
     /* 1560071 */   GIM_Try, /*On fail goto*//*Label 21614*/ GIMT_Encode4(1560153), // Rule ID 20986 //
     /* 1560076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1560084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560096 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560115 */     // MIs[0] round
     /* 1560115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560118 */     // MIs[0] policy
     /* 1560118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560128 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1560131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560139 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560152 */     // GIR_Coverage, 20986,
     /* 1560152 */     GIR_EraseRootFromParent_Done,
     /* 1560153 */   // Label 21614: @1560153
     /* 1560153 */   GIM_Try, /*On fail goto*//*Label 21615*/ GIMT_Encode4(1560235), // Rule ID 20987 //
     /* 1560158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1560166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1560169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1560172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1560175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560197 */     // MIs[0] round
     /* 1560197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560200 */     // MIs[0] policy
     /* 1560200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560210 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11123:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64_MASK),
     /* 1560213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560221 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560234 */     // GIR_Coverage, 20987,
     /* 1560234 */     GIR_EraseRootFromParent_Done,
     /* 1560235 */   // Label 21615: @1560235
     /* 1560235 */   GIM_Try, /*On fail goto*//*Label 21616*/ GIMT_Encode4(1560317), // Rule ID 20990 //
     /* 1560240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 1560243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1560248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560260 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560279 */     // MIs[0] round
     /* 1560279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560282 */     // MIs[0] policy
     /* 1560282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560292 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1560295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560301 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560303 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560316 */     // GIR_Coverage, 20990,
     /* 1560316 */     GIR_EraseRootFromParent_Done,
     /* 1560317 */   // Label 21616: @1560317
     /* 1560317 */   GIM_Try, /*On fail goto*//*Label 21617*/ GIMT_Encode4(1560399), // Rule ID 20991 //
     /* 1560322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 1560325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfcvt_f_xu_v_mask),
     /* 1560330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1560333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1560336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1560339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1560349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1560357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560361 */     // MIs[0] round
     /* 1560361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560364 */     // MIs[0] policy
     /* 1560364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560374 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11123:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFCVT_F_XU_V_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64_MASK),
     /* 1560377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560383 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560385 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1560395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560398 */     // GIR_Coverage, 20991,
     /* 1560398 */     GIR_EraseRootFromParent_Done,
     /* 1560399 */   // Label 21617: @1560399
     /* 1560399 */   GIM_Try, /*On fail goto*//*Label 21618*/ GIMT_Encode4(1560481), // Rule ID 21066 //
     /* 1560404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560443 */     // MIs[0] round
     /* 1560443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560446 */     // MIs[0] policy
     /* 1560446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1560459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560465 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560467 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560480 */     // GIR_Coverage, 21066,
     /* 1560480 */     GIR_EraseRootFromParent_Done,
     /* 1560481 */   // Label 21618: @1560481
     /* 1560481 */   GIM_Try, /*On fail goto*//*Label 21619*/ GIMT_Encode4(1560563), // Rule ID 21067 //
     /* 1560486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1560497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1560500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1560503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1560506 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560525 */     // MIs[0] round
     /* 1560525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560528 */     // MIs[0] policy
     /* 1560528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560538 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF4_MASK),
     /* 1560541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560547 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560549 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560562 */     // GIR_Coverage, 21067,
     /* 1560562 */     GIR_EraseRootFromParent_Done,
     /* 1560563 */   // Label 21619: @1560563
     /* 1560563 */   GIM_Try, /*On fail goto*//*Label 21620*/ GIMT_Encode4(1560645), // Rule ID 21070 //
     /* 1560568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560588 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560607 */     // MIs[0] round
     /* 1560607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560610 */     // MIs[0] policy
     /* 1560610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1560623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560629 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560631 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560644 */     // GIR_Coverage, 21070,
     /* 1560644 */     GIR_EraseRootFromParent_Done,
     /* 1560645 */   // Label 21620: @1560645
     /* 1560645 */   GIM_Try, /*On fail goto*//*Label 21621*/ GIMT_Encode4(1560727), // Rule ID 21071 //
     /* 1560650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1560661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1560664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1560667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1560670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1560677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560689 */     // MIs[0] round
     /* 1560689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560692 */     // MIs[0] policy
     /* 1560692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560702 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11227:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1560705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560711 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560713 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560726 */     // GIR_Coverage, 21071,
     /* 1560726 */     GIR_EraseRootFromParent_Done,
     /* 1560727 */   // Label 21621: @1560727
     /* 1560727 */   GIM_Try, /*On fail goto*//*Label 21622*/ GIMT_Encode4(1560809), // Rule ID 21074 //
     /* 1560732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1560743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1560746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560752 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560771 */     // MIs[0] round
     /* 1560771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560774 */     // MIs[0] policy
     /* 1560774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560784 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1560787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560793 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560795 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560808 */     // GIR_Coverage, 21074,
     /* 1560808 */     GIR_EraseRootFromParent_Done,
     /* 1560809 */   // Label 21622: @1560809
     /* 1560809 */   GIM_Try, /*On fail goto*//*Label 21623*/ GIMT_Encode4(1560891), // Rule ID 21075 //
     /* 1560814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1560825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1560828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1560831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1560834 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1560837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1560841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1560849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560853 */     // MIs[0] round
     /* 1560853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560856 */     // MIs[0] policy
     /* 1560856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1560866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1560869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560875 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560877 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560890 */     // GIR_Coverage, 21075,
     /* 1560890 */     GIR_EraseRootFromParent_Done,
     /* 1560891 */   // Label 21623: @1560891
     /* 1560891 */   GIM_Try, /*On fail goto*//*Label 21624*/ GIMT_Encode4(1560973), // Rule ID 21078 //
     /* 1560896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1560899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1560907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1560910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1560919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1560923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1560927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1560931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1560935 */     // MIs[0] round
     /* 1560935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1560938 */     // MIs[0] policy
     /* 1560938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1560941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1560948 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1560948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1560951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1560953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1560955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1560957 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1560959 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1560961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1560966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1560969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1560971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1560972 */     // GIR_Coverage, 21078,
     /* 1560972 */     GIR_EraseRootFromParent_Done,
     /* 1560973 */   // Label 21624: @1560973
     /* 1560973 */   GIM_Try, /*On fail goto*//*Label 21625*/ GIMT_Encode4(1561055), // Rule ID 21079 //
     /* 1560978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1560981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1560986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1560989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1560992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1560995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1560998 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561017 */     // MIs[0] round
     /* 1561017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561020 */     // MIs[0] policy
     /* 1561020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561030 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1561033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561041 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561054 */     // GIR_Coverage, 21079,
     /* 1561054 */     GIR_EraseRootFromParent_Done,
     /* 1561055 */   // Label 21625: @1561055
     /* 1561055 */   GIM_Try, /*On fail goto*//*Label 21626*/ GIMT_Encode4(1561137), // Rule ID 21082 //
     /* 1561060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561099 */     // MIs[0] round
     /* 1561099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561102 */     // MIs[0] policy
     /* 1561102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561112 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1561115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561121 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561123 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561136 */     // GIR_Coverage, 21082,
     /* 1561136 */     GIR_EraseRootFromParent_Done,
     /* 1561137 */   // Label 21626: @1561137
     /* 1561137 */   GIM_Try, /*On fail goto*//*Label 21627*/ GIMT_Encode4(1561219), // Rule ID 21083 //
     /* 1561142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1561153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1561156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1561159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1561162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561181 */     // MIs[0] round
     /* 1561181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561184 */     // MIs[0] policy
     /* 1561184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1561197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561203 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561205 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561218 */     // GIR_Coverage, 21083,
     /* 1561218 */     GIR_EraseRootFromParent_Done,
     /* 1561219 */   // Label 21627: @1561219
     /* 1561219 */   GIM_Try, /*On fail goto*//*Label 21628*/ GIMT_Encode4(1561301), // Rule ID 21086 //
     /* 1561224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1561227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1561235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561244 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561263 */     // MIs[0] round
     /* 1561263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561266 */     // MIs[0] policy
     /* 1561266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1561279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561285 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561287 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561300 */     // GIR_Coverage, 21086,
     /* 1561300 */     GIR_EraseRootFromParent_Done,
     /* 1561301 */   // Label 21628: @1561301
     /* 1561301 */   GIM_Try, /*On fail goto*//*Label 21629*/ GIMT_Encode4(1561383), // Rule ID 21087 //
     /* 1561306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1561309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1561317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1561320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1561323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561326 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561345 */     // MIs[0] round
     /* 1561345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561348 */     // MIs[0] policy
     /* 1561348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561358 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11227:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_MF2_MASK),
     /* 1561361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561367 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561369 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561382 */     // GIR_Coverage, 21087,
     /* 1561382 */     GIR_EraseRootFromParent_Done,
     /* 1561383 */   // Label 21629: @1561383
     /* 1561383 */   GIM_Try, /*On fail goto*//*Label 21630*/ GIMT_Encode4(1561465), // Rule ID 21090 //
     /* 1561388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1561391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561427 */     // MIs[0] round
     /* 1561427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561430 */     // MIs[0] policy
     /* 1561430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1561443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561449 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561451 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561464 */     // GIR_Coverage, 21090,
     /* 1561464 */     GIR_EraseRootFromParent_Done,
     /* 1561465 */   // Label 21630: @1561465
     /* 1561465 */   GIM_Try, /*On fail goto*//*Label 21631*/ GIMT_Encode4(1561547), // Rule ID 21091 //
     /* 1561470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1561473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1561481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1561484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1561487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1561490 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1561497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561509 */     // MIs[0] round
     /* 1561509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561512 */     // MIs[0] policy
     /* 1561512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561522 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11227:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M1_MASK),
     /* 1561525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561533 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561546 */     // GIR_Coverage, 21091,
     /* 1561546 */     GIR_EraseRootFromParent_Done,
     /* 1561547 */   // Label 21631: @1561547
     /* 1561547 */   GIM_Try, /*On fail goto*//*Label 21632*/ GIMT_Encode4(1561629), // Rule ID 21094 //
     /* 1561552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1561555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561572 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561591 */     // MIs[0] round
     /* 1561591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561594 */     // MIs[0] policy
     /* 1561594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1561607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561613 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561615 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561628 */     // GIR_Coverage, 21094,
     /* 1561628 */     GIR_EraseRootFromParent_Done,
     /* 1561629 */   // Label 21632: @1561629
     /* 1561629 */   GIM_Try, /*On fail goto*//*Label 21633*/ GIMT_Encode4(1561711), // Rule ID 21095 //
     /* 1561634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1561637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1561645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1561648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1561651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1561654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1561661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1561669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561673 */     // MIs[0] round
     /* 1561673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561676 */     // MIs[0] policy
     /* 1561676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561686 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11227:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M2_MASK),
     /* 1561689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561697 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561710 */     // GIR_Coverage, 21095,
     /* 1561710 */     GIR_EraseRootFromParent_Done,
     /* 1561711 */   // Label 21633: @1561711
     /* 1561711 */   GIM_Try, /*On fail goto*//*Label 21634*/ GIMT_Encode4(1561793), // Rule ID 21098 //
     /* 1561716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1561719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561736 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561755 */     // MIs[0] round
     /* 1561755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561758 */     // MIs[0] policy
     /* 1561758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1561771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561779 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561792 */     // GIR_Coverage, 21098,
     /* 1561792 */     GIR_EraseRootFromParent_Done,
     /* 1561793 */   // Label 21634: @1561793
     /* 1561793 */   GIM_Try, /*On fail goto*//*Label 21635*/ GIMT_Encode4(1561875), // Rule ID 21099 //
     /* 1561798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1561801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_xu_f_v_mask),
     /* 1561806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1561809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1561812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1561815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1561818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1561825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1561829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1561833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561837 */     // MIs[0] round
     /* 1561837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561840 */     // MIs[0] policy
     /* 1561840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561850 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11227:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_XU_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1561850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_XU_F_V_M4_MASK),
     /* 1561853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561861 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1561871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561874 */     // GIR_Coverage, 21099,
     /* 1561874 */     GIR_EraseRootFromParent_Done,
     /* 1561875 */   // Label 21635: @1561875
     /* 1561875 */   GIM_Try, /*On fail goto*//*Label 21636*/ GIMT_Encode4(1561957), // Rule ID 21102 //
     /* 1561880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1561883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1561888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1561897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1561903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1561919 */     // MIs[0] round
     /* 1561919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1561922 */     // MIs[0] policy
     /* 1561922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1561925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1561932 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1561932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1561935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1561937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1561939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1561941 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1561943 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1561945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1561950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1561953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1561955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1561956 */     // GIR_Coverage, 21102,
     /* 1561956 */     GIR_EraseRootFromParent_Done,
     /* 1561957 */   // Label 21636: @1561957
     /* 1561957 */   GIM_Try, /*On fail goto*//*Label 21637*/ GIMT_Encode4(1562039), // Rule ID 21103 //
     /* 1561962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1561965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1561970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1561973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1561976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1561979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1561982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1561985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1561989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1561997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562001 */     // MIs[0] round
     /* 1562001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562004 */     // MIs[0] policy
     /* 1562004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF4_MASK),
     /* 1562017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562025 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562038 */     // GIR_Coverage, 21103,
     /* 1562038 */     GIR_EraseRootFromParent_Done,
     /* 1562039 */   // Label 21637: @1562039
     /* 1562039 */   GIM_Try, /*On fail goto*//*Label 21638*/ GIMT_Encode4(1562121), // Rule ID 21106 //
     /* 1562044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562083 */     // MIs[0] round
     /* 1562083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562086 */     // MIs[0] policy
     /* 1562086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562096 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1562099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562105 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562107 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562120 */     // GIR_Coverage, 21106,
     /* 1562120 */     GIR_EraseRootFromParent_Done,
     /* 1562121 */   // Label 21638: @1562121
     /* 1562121 */   GIM_Try, /*On fail goto*//*Label 21639*/ GIMT_Encode4(1562203), // Rule ID 21107 //
     /* 1562126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1562137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1562140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1562143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562165 */     // MIs[0] round
     /* 1562165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562168 */     // MIs[0] policy
     /* 1562168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11225:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1562181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562189 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562202 */     // GIR_Coverage, 21107,
     /* 1562202 */     GIR_EraseRootFromParent_Done,
     /* 1562203 */   // Label 21639: @1562203
     /* 1562203 */   GIM_Try, /*On fail goto*//*Label 21640*/ GIMT_Encode4(1562285), // Rule ID 21110 //
     /* 1562208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1562219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1562222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562247 */     // MIs[0] round
     /* 1562247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562250 */     // MIs[0] policy
     /* 1562250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1562263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562269 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562271 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562284 */     // GIR_Coverage, 21110,
     /* 1562284 */     GIR_EraseRootFromParent_Done,
     /* 1562285 */   // Label 21640: @1562285
     /* 1562285 */   GIM_Try, /*On fail goto*//*Label 21641*/ GIMT_Encode4(1562367), // Rule ID 21111 //
     /* 1562290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1562301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1562304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1562307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1562310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562329 */     // MIs[0] round
     /* 1562329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562332 */     // MIs[0] policy
     /* 1562332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1562345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562353 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562366 */     // GIR_Coverage, 21111,
     /* 1562366 */     GIR_EraseRootFromParent_Done,
     /* 1562367 */   // Label 21641: @1562367
     /* 1562367 */   GIM_Try, /*On fail goto*//*Label 21642*/ GIMT_Encode4(1562449), // Rule ID 21114 //
     /* 1562372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1562383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1562386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1562389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562392 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562411 */     // MIs[0] round
     /* 1562411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562414 */     // MIs[0] policy
     /* 1562414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1562427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562435 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562448 */     // GIR_Coverage, 21114,
     /* 1562448 */     GIR_EraseRootFromParent_Done,
     /* 1562449 */   // Label 21642: @1562449
     /* 1562449 */   GIM_Try, /*On fail goto*//*Label 21643*/ GIMT_Encode4(1562531), // Rule ID 21115 //
     /* 1562454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1562465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1562468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1562471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1562474 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1562481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562493 */     // MIs[0] round
     /* 1562493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562496 */     // MIs[0] policy
     /* 1562496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562506 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1562509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562515 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562517 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562530 */     // GIR_Coverage, 21115,
     /* 1562530 */     GIR_EraseRootFromParent_Done,
     /* 1562531 */   // Label 21643: @1562531
     /* 1562531 */   GIM_Try, /*On fail goto*//*Label 21644*/ GIMT_Encode4(1562613), // Rule ID 21118 //
     /* 1562536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1562539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1562547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1562550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562575 */     // MIs[0] round
     /* 1562575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562578 */     // MIs[0] policy
     /* 1562578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1562591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562599 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562612 */     // GIR_Coverage, 21118,
     /* 1562612 */     GIR_EraseRootFromParent_Done,
     /* 1562613 */   // Label 21644: @1562613
     /* 1562613 */   GIM_Try, /*On fail goto*//*Label 21645*/ GIMT_Encode4(1562695), // Rule ID 21119 //
     /* 1562618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1562621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1562629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1562632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1562635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1562638 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1562645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1562649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1562653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562657 */     // MIs[0] round
     /* 1562657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562660 */     // MIs[0] policy
     /* 1562660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562670 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1562673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562679 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562681 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1562691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562694 */     // GIR_Coverage, 21119,
     /* 1562694 */     GIR_EraseRootFromParent_Done,
     /* 1562695 */   // Label 21645: @1562695
     /* 1562695 */   GIM_Try, /*On fail goto*//*Label 21646*/ GIMT_Encode4(1562777), // Rule ID 21122 //
     /* 1562700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1562703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562720 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562739 */     // MIs[0] round
     /* 1562739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562742 */     // MIs[0] policy
     /* 1562742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562752 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1562755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562761 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562763 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562776 */     // GIR_Coverage, 21122,
     /* 1562776 */     GIR_EraseRootFromParent_Done,
     /* 1562777 */   // Label 21646: @1562777
     /* 1562777 */   GIM_Try, /*On fail goto*//*Label 21647*/ GIMT_Encode4(1562859), // Rule ID 21123 //
     /* 1562782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1562785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1562793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1562796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1562799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1562802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1562809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562821 */     // MIs[0] round
     /* 1562821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562824 */     // MIs[0] policy
     /* 1562824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11225:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_MF2_MASK),
     /* 1562837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562843 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562845 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562858 */     // GIR_Coverage, 21123,
     /* 1562858 */     GIR_EraseRootFromParent_Done,
     /* 1562859 */   // Label 21647: @1562859
     /* 1562859 */   GIM_Try, /*On fail goto*//*Label 21648*/ GIMT_Encode4(1562941), // Rule ID 21126 //
     /* 1562864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1562867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562884 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1562887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562903 */     // MIs[0] round
     /* 1562903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562906 */     // MIs[0] policy
     /* 1562906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562916 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1562916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1562919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1562921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1562923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1562925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1562927 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1562929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1562934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1562937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1562939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1562940 */     // GIR_Coverage, 21126,
     /* 1562940 */     GIR_EraseRootFromParent_Done,
     /* 1562941 */   // Label 21648: @1562941
     /* 1562941 */   GIM_Try, /*On fail goto*//*Label 21649*/ GIMT_Encode4(1563023), // Rule ID 21127 //
     /* 1562946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1562949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1562954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1562957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1562960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1562963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1562966 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1562969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1562973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1562977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1562981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1562985 */     // MIs[0] round
     /* 1562985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1562988 */     // MIs[0] policy
     /* 1562988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1562991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1562998 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11225:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1562998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M1_MASK),
     /* 1563001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563007 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563009 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563022 */     // GIR_Coverage, 21127,
     /* 1563022 */     GIR_EraseRootFromParent_Done,
     /* 1563023 */   // Label 21649: @1563023
     /* 1563023 */   GIM_Try, /*On fail goto*//*Label 21650*/ GIMT_Encode4(1563105), // Rule ID 21130 //
     /* 1563028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1563031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1563036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563067 */     // MIs[0] round
     /* 1563067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563070 */     // MIs[0] policy
     /* 1563070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1563083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563089 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563091 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563104 */     // GIR_Coverage, 21130,
     /* 1563104 */     GIR_EraseRootFromParent_Done,
     /* 1563105 */   // Label 21650: @1563105
     /* 1563105 */   GIM_Try, /*On fail goto*//*Label 21651*/ GIMT_Encode4(1563187), // Rule ID 21131 //
     /* 1563110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1563113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1563118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1563121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1563124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1563127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563130 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1563137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563149 */     // MIs[0] round
     /* 1563149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563152 */     // MIs[0] policy
     /* 1563152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11225:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M2_MASK),
     /* 1563165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563171 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563173 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563186 */     // GIR_Coverage, 21131,
     /* 1563186 */     GIR_EraseRootFromParent_Done,
     /* 1563187 */   // Label 21651: @1563187
     /* 1563187 */   GIM_Try, /*On fail goto*//*Label 21652*/ GIMT_Encode4(1563269), // Rule ID 21134 //
     /* 1563192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1563195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1563200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1563203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1563206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563212 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563231 */     // MIs[0] round
     /* 1563231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563234 */     // MIs[0] policy
     /* 1563234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563244 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1563247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563253 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563255 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563268 */     // GIR_Coverage, 21134,
     /* 1563268 */     GIR_EraseRootFromParent_Done,
     /* 1563269 */   // Label 21652: @1563269
     /* 1563269 */   GIM_Try, /*On fail goto*//*Label 21653*/ GIMT_Encode4(1563351), // Rule ID 21135 //
     /* 1563274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1563277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwcvt_x_f_v_mask),
     /* 1563282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1563285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1563288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1563291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1563301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1563305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1563309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563313 */     // MIs[0] round
     /* 1563313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563316 */     // MIs[0] policy
     /* 1563316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563326 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11225:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWCVT_X_F_V_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_X_F_V_M4_MASK),
     /* 1563329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563335 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563337 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1563347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563350 */     // GIR_Coverage, 21135,
     /* 1563350 */     GIR_EraseRootFromParent_Done,
     /* 1563351 */   // Label 21653: @1563351
     /* 1563351 */   GIM_Try, /*On fail goto*//*Label 21654*/ GIMT_Encode4(1563433), // Rule ID 21486 //
     /* 1563356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1563367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1563370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1563373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563376 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563395 */     // MIs[0] round
     /* 1563395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563398 */     // MIs[0] policy
     /* 1563398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563408 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1563411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563417 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563419 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563432 */     // GIR_Coverage, 21486,
     /* 1563432 */     GIR_EraseRootFromParent_Done,
     /* 1563433 */   // Label 21654: @1563433
     /* 1563433 */   GIM_Try, /*On fail goto*//*Label 21655*/ GIMT_Encode4(1563515), // Rule ID 21487 //
     /* 1563438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1563449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1563452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1563455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1563458 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563477 */     // MIs[0] round
     /* 1563477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563480 */     // MIs[0] policy
     /* 1563480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF8_MASK),
     /* 1563493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563499 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563501 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563514 */     // GIR_Coverage, 21487,
     /* 1563514 */     GIR_EraseRootFromParent_Done,
     /* 1563515 */   // Label 21655: @1563515
     /* 1563515 */   GIM_Try, /*On fail goto*//*Label 21656*/ GIMT_Encode4(1563597), // Rule ID 21490 //
     /* 1563520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1563531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1563534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1563537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563559 */     // MIs[0] round
     /* 1563559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563562 */     // MIs[0] policy
     /* 1563562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563572 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1563575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563581 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563583 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563596 */     // GIR_Coverage, 21490,
     /* 1563596 */     GIR_EraseRootFromParent_Done,
     /* 1563597 */   // Label 21656: @1563597
     /* 1563597 */   GIM_Try, /*On fail goto*//*Label 21657*/ GIMT_Encode4(1563679), // Rule ID 21491 //
     /* 1563602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1563613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1563616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1563619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1563622 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563641 */     // MIs[0] round
     /* 1563641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563644 */     // MIs[0] policy
     /* 1563644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563654 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1563657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563663 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563665 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563678 */     // GIR_Coverage, 21491,
     /* 1563678 */     GIR_EraseRootFromParent_Done,
     /* 1563679 */   // Label 21657: @1563679
     /* 1563679 */   GIM_Try, /*On fail goto*//*Label 21658*/ GIMT_Encode4(1563761), // Rule ID 21494 //
     /* 1563684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1563695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1563698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563704 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563723 */     // MIs[0] round
     /* 1563723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563726 */     // MIs[0] policy
     /* 1563726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1563739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563745 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563747 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563760 */     // GIR_Coverage, 21494,
     /* 1563760 */     GIR_EraseRootFromParent_Done,
     /* 1563761 */   // Label 21658: @1563761
     /* 1563761 */   GIM_Try, /*On fail goto*//*Label 21659*/ GIMT_Encode4(1563843), // Rule ID 21495 //
     /* 1563766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1563777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1563780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1563783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1563786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563805 */     // MIs[0] round
     /* 1563805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563808 */     // MIs[0] policy
     /* 1563808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563818 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1563821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563827 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563829 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563842 */     // GIR_Coverage, 21495,
     /* 1563842 */     GIR_EraseRootFromParent_Done,
     /* 1563843 */   // Label 21659: @1563843
     /* 1563843 */   GIM_Try, /*On fail goto*//*Label 21660*/ GIMT_Encode4(1563925), // Rule ID 21498 //
     /* 1563848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1563851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1563859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1563862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563868 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1563871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563887 */     // MIs[0] round
     /* 1563887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563890 */     // MIs[0] policy
     /* 1563890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563900 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1563900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1563903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563909 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563911 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1563918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1563921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1563923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1563924 */     // GIR_Coverage, 21498,
     /* 1563924 */     GIR_EraseRootFromParent_Done,
     /* 1563925 */   // Label 21660: @1563925
     /* 1563925 */   GIM_Try, /*On fail goto*//*Label 21661*/ GIMT_Encode4(1564007), // Rule ID 21499 //
     /* 1563930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1563933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1563938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1563941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1563944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1563947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1563950 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1563953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1563957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1563961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1563965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1563969 */     // MIs[0] round
     /* 1563969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1563972 */     // MIs[0] policy
     /* 1563972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1563975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1563982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11169:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1563982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1563985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1563987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1563989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1563991 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1563993 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1563995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564006 */     // GIR_Coverage, 21499,
     /* 1564006 */     GIR_EraseRootFromParent_Done,
     /* 1564007 */   // Label 21661: @1564007
     /* 1564007 */   GIM_Try, /*On fail goto*//*Label 21662*/ GIMT_Encode4(1564089), // Rule ID 21502 //
     /* 1564012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1564023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1564026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1564029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564051 */     // MIs[0] round
     /* 1564051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564054 */     // MIs[0] policy
     /* 1564054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1564067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564073 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564075 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564088 */     // GIR_Coverage, 21502,
     /* 1564088 */     GIR_EraseRootFromParent_Done,
     /* 1564089 */   // Label 21662: @1564089
     /* 1564089 */   GIM_Try, /*On fail goto*//*Label 21663*/ GIMT_Encode4(1564171), // Rule ID 21503 //
     /* 1564094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1564105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1564108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1564111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1564114 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564133 */     // MIs[0] round
     /* 1564133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564136 */     // MIs[0] policy
     /* 1564136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564146 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1564149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564155 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564157 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564170 */     // GIR_Coverage, 21503,
     /* 1564170 */     GIR_EraseRootFromParent_Done,
     /* 1564171 */   // Label 21663: @1564171
     /* 1564171 */   GIM_Try, /*On fail goto*//*Label 21664*/ GIMT_Encode4(1564253), // Rule ID 21506 //
     /* 1564176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1564179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1564187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1564190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1564193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1564196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564215 */     // MIs[0] round
     /* 1564215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564218 */     // MIs[0] policy
     /* 1564218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564228 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1564231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564237 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564239 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564252 */     // GIR_Coverage, 21506,
     /* 1564252 */     GIR_EraseRootFromParent_Done,
     /* 1564253 */   // Label 21664: @1564253
     /* 1564253 */   GIM_Try, /*On fail goto*//*Label 21665*/ GIMT_Encode4(1564335), // Rule ID 21507 //
     /* 1564258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1564261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1564269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1564272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1564275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1564278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1564285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1564293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564297 */     // MIs[0] round
     /* 1564297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564300 */     // MIs[0] policy
     /* 1564300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564310 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1564313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564319 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564321 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1564331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564334 */     // GIR_Coverage, 21507,
     /* 1564334 */     GIR_EraseRootFromParent_Done,
     /* 1564335 */   // Label 21665: @1564335
     /* 1564335 */   GIM_Try, /*On fail goto*//*Label 21666*/ GIMT_Encode4(1564417), // Rule ID 21510 //
     /* 1564340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564360 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564379 */     // MIs[0] round
     /* 1564379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564382 */     // MIs[0] policy
     /* 1564382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564392 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1564395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564401 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564403 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564416 */     // GIR_Coverage, 21510,
     /* 1564416 */     GIR_EraseRootFromParent_Done,
     /* 1564417 */   // Label 21666: @1564417
     /* 1564417 */   GIM_Try, /*On fail goto*//*Label 21667*/ GIMT_Encode4(1564499), // Rule ID 21511 //
     /* 1564422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1564433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1564436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1564439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1564442 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564461 */     // MIs[0] round
     /* 1564461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564464 */     // MIs[0] policy
     /* 1564464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF4_MASK),
     /* 1564477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564485 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564498 */     // GIR_Coverage, 21511,
     /* 1564498 */     GIR_EraseRootFromParent_Done,
     /* 1564499 */   // Label 21667: @1564499
     /* 1564499 */   GIM_Try, /*On fail goto*//*Label 21668*/ GIMT_Encode4(1564581), // Rule ID 21514 //
     /* 1564504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1564521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564543 */     // MIs[0] round
     /* 1564543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564546 */     // MIs[0] policy
     /* 1564546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564556 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1564559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564565 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564567 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564580 */     // GIR_Coverage, 21514,
     /* 1564580 */     GIR_EraseRootFromParent_Done,
     /* 1564581 */   // Label 21668: @1564581
     /* 1564581 */   GIM_Try, /*On fail goto*//*Label 21669*/ GIMT_Encode4(1564663), // Rule ID 21515 //
     /* 1564586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1564597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1564600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1564603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1564606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564625 */     // MIs[0] round
     /* 1564625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564628 */     // MIs[0] policy
     /* 1564628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1564641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564647 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564649 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564662 */     // GIR_Coverage, 21515,
     /* 1564662 */     GIR_EraseRootFromParent_Done,
     /* 1564663 */   // Label 21669: @1564663
     /* 1564663 */   GIM_Try, /*On fail goto*//*Label 21670*/ GIMT_Encode4(1564745), // Rule ID 21518 //
     /* 1564668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1564679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1564682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564688 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564707 */     // MIs[0] round
     /* 1564707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564710 */     // MIs[0] policy
     /* 1564710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1564723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564729 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564731 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564744 */     // GIR_Coverage, 21518,
     /* 1564744 */     GIR_EraseRootFromParent_Done,
     /* 1564745 */   // Label 21670: @1564745
     /* 1564745 */   GIM_Try, /*On fail goto*//*Label 21671*/ GIMT_Encode4(1564827), // Rule ID 21519 //
     /* 1564750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1564761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1564764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1564767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1564770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1564777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1564781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564789 */     // MIs[0] round
     /* 1564789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564792 */     // MIs[0] policy
     /* 1564792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11169:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1564805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564813 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564826 */     // GIR_Coverage, 21519,
     /* 1564826 */     GIR_EraseRootFromParent_Done,
     /* 1564827 */   // Label 21671: @1564827
     /* 1564827 */   GIM_Try, /*On fail goto*//*Label 21672*/ GIMT_Encode4(1564909), // Rule ID 21522 //
     /* 1564832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1564843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1564846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564852 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1564855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564871 */     // MIs[0] round
     /* 1564871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564874 */     // MIs[0] policy
     /* 1564874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1564884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1564887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564893 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564895 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564908 */     // GIR_Coverage, 21522,
     /* 1564908 */     GIR_EraseRootFromParent_Done,
     /* 1564909 */   // Label 21672: @1564909
     /* 1564909 */   GIM_Try, /*On fail goto*//*Label 21673*/ GIMT_Encode4(1564991), // Rule ID 21523 //
     /* 1564914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1564917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1564922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1564925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1564928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1564931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1564934 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1564937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1564941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1564945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1564949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1564953 */     // MIs[0] round
     /* 1564953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1564956 */     // MIs[0] policy
     /* 1564956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1564959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1564966 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1564966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1564969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1564971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1564973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1564975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1564977 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1564979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1564984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1564987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1564989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1564990 */     // GIR_Coverage, 21523,
     /* 1564990 */     GIR_EraseRootFromParent_Done,
     /* 1564991 */   // Label 21673: @1564991
     /* 1564991 */   GIM_Try, /*On fail goto*//*Label 21674*/ GIMT_Encode4(1565073), // Rule ID 21526 //
     /* 1564996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1564999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1565013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565035 */     // MIs[0] round
     /* 1565035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565038 */     // MIs[0] policy
     /* 1565038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1565051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565057 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565059 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565072 */     // GIR_Coverage, 21526,
     /* 1565072 */     GIR_EraseRootFromParent_Done,
     /* 1565073 */   // Label 21674: @1565073
     /* 1565073 */   GIM_Try, /*On fail goto*//*Label 21675*/ GIMT_Encode4(1565155), // Rule ID 21527 //
     /* 1565078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1565081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1565089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1565092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1565095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1565098 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565117 */     // MIs[0] round
     /* 1565117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565120 */     // MIs[0] policy
     /* 1565120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1565133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565141 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1565151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565154 */     // GIR_Coverage, 21527,
     /* 1565154 */     GIR_EraseRootFromParent_Done,
     /* 1565155 */   // Label 21675: @1565155
     /* 1565155 */   GIM_Try, /*On fail goto*//*Label 21676*/ GIMT_Encode4(1565237), // Rule ID 21530 //
     /* 1565160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1565163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565180 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565199 */     // MIs[0] round
     /* 1565199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565202 */     // MIs[0] policy
     /* 1565202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565212 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1565215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565221 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565223 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565236 */     // GIR_Coverage, 21530,
     /* 1565236 */     GIR_EraseRootFromParent_Done,
     /* 1565237 */   // Label 21676: @1565237
     /* 1565237 */   GIM_Try, /*On fail goto*//*Label 21677*/ GIMT_Encode4(1565319), // Rule ID 21531 //
     /* 1565242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1565245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1565253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1565256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1565259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565281 */     // MIs[0] round
     /* 1565281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565284 */     // MIs[0] policy
     /* 1565284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_MF2_MASK),
     /* 1565297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565305 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565318 */     // GIR_Coverage, 21531,
     /* 1565318 */     GIR_EraseRootFromParent_Done,
     /* 1565319 */   // Label 21677: @1565319
     /* 1565319 */   GIM_Try, /*On fail goto*//*Label 21678*/ GIMT_Encode4(1565401), // Rule ID 21534 //
     /* 1565324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1565327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1565341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565363 */     // MIs[0] round
     /* 1565363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565366 */     // MIs[0] policy
     /* 1565366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565376 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1565379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565385 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565387 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565400 */     // GIR_Coverage, 21534,
     /* 1565400 */     GIR_EraseRootFromParent_Done,
     /* 1565401 */   // Label 21678: @1565401
     /* 1565401 */   GIM_Try, /*On fail goto*//*Label 21679*/ GIMT_Encode4(1565483), // Rule ID 21535 //
     /* 1565406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1565409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1565417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1565420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1565423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1565426 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565445 */     // MIs[0] round
     /* 1565445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565448 */     // MIs[0] policy
     /* 1565448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565458 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11169:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M1_MASK),
     /* 1565461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565469 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565482 */     // GIR_Coverage, 21535,
     /* 1565482 */     GIR_EraseRootFromParent_Done,
     /* 1565483 */   // Label 21679: @1565483
     /* 1565483 */   GIM_Try, /*On fail goto*//*Label 21680*/ GIMT_Encode4(1565565), // Rule ID 21538 //
     /* 1565488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1565491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1565499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1565502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1565505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565527 */     // MIs[0] round
     /* 1565527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565530 */     // MIs[0] policy
     /* 1565530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1565543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565549 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565551 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565564 */     // GIR_Coverage, 21538,
     /* 1565564 */     GIR_EraseRootFromParent_Done,
     /* 1565565 */   // Label 21680: @1565565
     /* 1565565 */   GIM_Try, /*On fail goto*//*Label 21681*/ GIMT_Encode4(1565647), // Rule ID 21539 //
     /* 1565570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1565573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1565581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1565584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1565587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1565590 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1565597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1565601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565609 */     // MIs[0] round
     /* 1565609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565612 */     // MIs[0] policy
     /* 1565612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11169:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M2_MASK),
     /* 1565625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565633 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565646 */     // GIR_Coverage, 21539,
     /* 1565646 */     GIR_EraseRootFromParent_Done,
     /* 1565647 */   // Label 21681: @1565647
     /* 1565647 */   GIM_Try, /*On fail goto*//*Label 21682*/ GIMT_Encode4(1565729), // Rule ID 21542 //
     /* 1565652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1565655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1565669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565672 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565691 */     // MIs[0] round
     /* 1565691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565694 */     // MIs[0] policy
     /* 1565694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565704 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1565707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565713 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565715 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565728 */     // GIR_Coverage, 21542,
     /* 1565728 */     GIR_EraseRootFromParent_Done,
     /* 1565729 */   // Label 21682: @1565729
     /* 1565729 */   GIM_Try, /*On fail goto*//*Label 21683*/ GIMT_Encode4(1565811), // Rule ID 21543 //
     /* 1565734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1565737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_xu_f_w_mask),
     /* 1565742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1565745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1565748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1565751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1565754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1565761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1565765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1565769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565773 */     // MIs[0] round
     /* 1565773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565776 */     // MIs[0] policy
     /* 1565776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565786 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11169:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_XU_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_XU_F_W_M4_MASK),
     /* 1565789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565797 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1565807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565810 */     // GIR_Coverage, 21543,
     /* 1565810 */     GIR_EraseRootFromParent_Done,
     /* 1565811 */   // Label 21683: @1565811
     /* 1565811 */   GIM_Try, /*On fail goto*//*Label 21684*/ GIMT_Encode4(1565893), // Rule ID 21546 //
     /* 1565816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1565824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1565827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1565830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565836 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1565839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565855 */     // MIs[0] round
     /* 1565855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565858 */     // MIs[0] policy
     /* 1565858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565868 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1565868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1565871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565879 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1565889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565892 */     // GIR_Coverage, 21546,
     /* 1565892 */     GIR_EraseRootFromParent_Done,
     /* 1565893 */   // Label 21684: @1565893
     /* 1565893 */   GIM_Try, /*On fail goto*//*Label 21685*/ GIMT_Encode4(1565975), // Rule ID 21547 //
     /* 1565898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1565901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1565906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1565909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1565912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1565915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1565918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1565921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1565925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1565933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1565937 */     // MIs[0] round
     /* 1565937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1565940 */     // MIs[0] policy
     /* 1565940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1565943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1565950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1565950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF8_MASK),
     /* 1565953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1565955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1565957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1565959 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1565961 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1565963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1565968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1565971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1565973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1565974 */     // GIR_Coverage, 21547,
     /* 1565974 */     GIR_EraseRootFromParent_Done,
     /* 1565975 */   // Label 21685: @1565975
     /* 1565975 */   GIM_Try, /*On fail goto*//*Label 21686*/ GIMT_Encode4(1566057), // Rule ID 21550 //
     /* 1565980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1565983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1565988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1565991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1565994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1565997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566019 */     // MIs[0] round
     /* 1566019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566022 */     // MIs[0] policy
     /* 1566022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566032 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1566035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566043 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566056 */     // GIR_Coverage, 21550,
     /* 1566056 */     GIR_EraseRootFromParent_Done,
     /* 1566057 */   // Label 21686: @1566057
     /* 1566057 */   GIM_Try, /*On fail goto*//*Label 21687*/ GIMT_Encode4(1566139), // Rule ID 21551 //
     /* 1566062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1566073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1566076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1566079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566082 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566101 */     // MIs[0] round
     /* 1566101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566104 */     // MIs[0] policy
     /* 1566104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566114 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1566117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566123 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566125 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566138 */     // GIR_Coverage, 21551,
     /* 1566138 */     GIR_EraseRootFromParent_Done,
     /* 1566139 */   // Label 21687: @1566139
     /* 1566139 */   GIM_Try, /*On fail goto*//*Label 21688*/ GIMT_Encode4(1566221), // Rule ID 21554 //
     /* 1566144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1566155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1566158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566164 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566183 */     // MIs[0] round
     /* 1566183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566186 */     // MIs[0] policy
     /* 1566186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1566199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566207 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566220 */     // GIR_Coverage, 21554,
     /* 1566220 */     GIR_EraseRootFromParent_Done,
     /* 1566221 */   // Label 21688: @1566221
     /* 1566221 */   GIM_Try, /*On fail goto*//*Label 21689*/ GIMT_Encode4(1566303), // Rule ID 21555 //
     /* 1566226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1566237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1566240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1566243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1566246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566265 */     // MIs[0] round
     /* 1566265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566268 */     // MIs[0] policy
     /* 1566268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566278 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1566281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566287 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566289 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566302 */     // GIR_Coverage, 21555,
     /* 1566302 */     GIR_EraseRootFromParent_Done,
     /* 1566303 */   // Label 21689: @1566303
     /* 1566303 */   GIM_Try, /*On fail goto*//*Label 21690*/ GIMT_Encode4(1566385), // Rule ID 21558 //
     /* 1566308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1566319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1566322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566328 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566347 */     // MIs[0] round
     /* 1566347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566350 */     // MIs[0] policy
     /* 1566350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566360 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1566363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566369 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566371 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566384 */     // GIR_Coverage, 21558,
     /* 1566384 */     GIR_EraseRootFromParent_Done,
     /* 1566385 */   // Label 21690: @1566385
     /* 1566385 */   GIM_Try, /*On fail goto*//*Label 21691*/ GIMT_Encode4(1566467), // Rule ID 21559 //
     /* 1566390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1566401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1566404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1566407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1566410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566429 */     // MIs[0] round
     /* 1566429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566432 */     // MIs[0] policy
     /* 1566432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11167:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1566445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566451 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566453 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566466 */     // GIR_Coverage, 21559,
     /* 1566466 */     GIR_EraseRootFromParent_Done,
     /* 1566467 */   // Label 21691: @1566467
     /* 1566467 */   GIM_Try, /*On fail goto*//*Label 21692*/ GIMT_Encode4(1566549), // Rule ID 21562 //
     /* 1566472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1566483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1566486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566511 */     // MIs[0] round
     /* 1566511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566514 */     // MIs[0] policy
     /* 1566514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1566527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566533 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566535 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566548 */     // GIR_Coverage, 21562,
     /* 1566548 */     GIR_EraseRootFromParent_Done,
     /* 1566549 */   // Label 21692: @1566549
     /* 1566549 */   GIM_Try, /*On fail goto*//*Label 21693*/ GIMT_Encode4(1566631), // Rule ID 21563 //
     /* 1566554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1566565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1566568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1566571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1566574 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1566581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1566585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566593 */     // MIs[0] round
     /* 1566593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566596 */     // MIs[0] policy
     /* 1566596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566606 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1566609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566615 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566617 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566630 */     // GIR_Coverage, 21563,
     /* 1566630 */     GIR_EraseRootFromParent_Done,
     /* 1566631 */   // Label 21693: @1566631
     /* 1566631 */   GIM_Try, /*On fail goto*//*Label 21694*/ GIMT_Encode4(1566713), // Rule ID 21566 //
     /* 1566636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1566639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1566647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1566650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566675 */     // MIs[0] round
     /* 1566675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566678 */     // MIs[0] policy
     /* 1566678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566688 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1566691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566697 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566699 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566712 */     // GIR_Coverage, 21566,
     /* 1566712 */     GIR_EraseRootFromParent_Done,
     /* 1566713 */   // Label 21694: @1566713
     /* 1566713 */   GIM_Try, /*On fail goto*//*Label 21695*/ GIMT_Encode4(1566795), // Rule ID 21567 //
     /* 1566718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1566721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1566729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1566732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1566735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 1566738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1566745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1566749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1566753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566757 */     // MIs[0] round
     /* 1566757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566760 */     // MIs[0] policy
     /* 1566760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566770 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1566773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566779 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566781 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1566791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566794 */     // GIR_Coverage, 21567,
     /* 1566794 */     GIR_EraseRootFromParent_Done,
     /* 1566795 */   // Label 21695: @1566795
     /* 1566795 */   GIM_Try, /*On fail goto*//*Label 21696*/ GIMT_Encode4(1566877), // Rule ID 21570 //
     /* 1566800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1566811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1566814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1566817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566820 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566839 */     // MIs[0] round
     /* 1566839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566842 */     // MIs[0] policy
     /* 1566842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566852 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1566852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1566855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566861 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566863 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566876 */     // GIR_Coverage, 21570,
     /* 1566876 */     GIR_EraseRootFromParent_Done,
     /* 1566877 */   // Label 21696: @1566877
     /* 1566877 */   GIM_Try, /*On fail goto*//*Label 21697*/ GIMT_Encode4(1566959), // Rule ID 21571 //
     /* 1566882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1566885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1566893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1566896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1566899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1566902 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1566905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1566921 */     // MIs[0] round
     /* 1566921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1566924 */     // MIs[0] policy
     /* 1566924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1566927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1566934 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1566934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF4_MASK),
     /* 1566937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1566939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1566941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1566943 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1566945 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1566947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1566952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1566955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1566957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1566958 */     // GIR_Coverage, 21571,
     /* 1566958 */     GIR_EraseRootFromParent_Done,
     /* 1566959 */   // Label 21697: @1566959
     /* 1566959 */   GIM_Try, /*On fail goto*//*Label 21698*/ GIMT_Encode4(1567041), // Rule ID 21574 //
     /* 1566964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1566967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1566972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1566975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1566978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1566981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1566984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1566987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1566991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1566999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567003 */     // MIs[0] round
     /* 1567003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567006 */     // MIs[0] policy
     /* 1567006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567016 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1567019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567025 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567027 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567040 */     // GIR_Coverage, 21574,
     /* 1567040 */     GIR_EraseRootFromParent_Done,
     /* 1567041 */   // Label 21698: @1567041
     /* 1567041 */   GIM_Try, /*On fail goto*//*Label 21699*/ GIMT_Encode4(1567123), // Rule ID 21575 //
     /* 1567046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1567057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1567060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1567063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567066 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567085 */     // MIs[0] round
     /* 1567085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567088 */     // MIs[0] policy
     /* 1567088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1567101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567107 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567109 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567122 */     // GIR_Coverage, 21575,
     /* 1567122 */     GIR_EraseRootFromParent_Done,
     /* 1567123 */   // Label 21699: @1567123
     /* 1567123 */   GIM_Try, /*On fail goto*//*Label 21700*/ GIMT_Encode4(1567205), // Rule ID 21578 //
     /* 1567128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1567139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1567142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567148 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567167 */     // MIs[0] round
     /* 1567167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567170 */     // MIs[0] policy
     /* 1567170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567180 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1567183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567191 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567204 */     // GIR_Coverage, 21578,
     /* 1567204 */     GIR_EraseRootFromParent_Done,
     /* 1567205 */   // Label 21700: @1567205
     /* 1567205 */   GIM_Try, /*On fail goto*//*Label 21701*/ GIMT_Encode4(1567287), // Rule ID 21579 //
     /* 1567210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1567221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1567224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1567227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567249 */     // MIs[0] round
     /* 1567249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567252 */     // MIs[0] policy
     /* 1567252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11167:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1567265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567271 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567273 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567286 */     // GIR_Coverage, 21579,
     /* 1567286 */     GIR_EraseRootFromParent_Done,
     /* 1567287 */   // Label 21701: @1567287
     /* 1567287 */   GIM_Try, /*On fail goto*//*Label 21702*/ GIMT_Encode4(1567369), // Rule ID 21582 //
     /* 1567292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1567303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1567306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567312 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567331 */     // MIs[0] round
     /* 1567331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567334 */     // MIs[0] policy
     /* 1567334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1567347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567353 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567355 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567368 */     // GIR_Coverage, 21582,
     /* 1567368 */     GIR_EraseRootFromParent_Done,
     /* 1567369 */   // Label 21702: @1567369
     /* 1567369 */   GIM_Try, /*On fail goto*//*Label 21703*/ GIMT_Encode4(1567451), // Rule ID 21583 //
     /* 1567374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1567385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1567388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1567391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1567394 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567413 */     // MIs[0] round
     /* 1567413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567416 */     // MIs[0] policy
     /* 1567416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1567429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567435 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567437 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567450 */     // GIR_Coverage, 21583,
     /* 1567450 */     GIR_EraseRootFromParent_Done,
     /* 1567451 */   // Label 21703: @1567451
     /* 1567451 */   GIM_Try, /*On fail goto*//*Label 21704*/ GIMT_Encode4(1567533), // Rule ID 21586 //
     /* 1567456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1567459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1567467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1567470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567495 */     // MIs[0] round
     /* 1567495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567498 */     // MIs[0] policy
     /* 1567498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567508 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1567511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567519 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567532 */     // GIR_Coverage, 21586,
     /* 1567532 */     GIR_EraseRootFromParent_Done,
     /* 1567533 */   // Label 21704: @1567533
     /* 1567533 */   GIM_Try, /*On fail goto*//*Label 21705*/ GIMT_Encode4(1567615), // Rule ID 21587 //
     /* 1567538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1567541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1567549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1567552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1567555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1567558 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1567565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1567573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567577 */     // MIs[0] round
     /* 1567577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567580 */     // MIs[0] policy
     /* 1567580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1567593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567599 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567601 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1567611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567614 */     // GIR_Coverage, 21587,
     /* 1567614 */     GIR_EraseRootFromParent_Done,
     /* 1567615 */   // Label 21705: @1567615
     /* 1567615 */   GIM_Try, /*On fail goto*//*Label 21706*/ GIMT_Encode4(1567697), // Rule ID 21590 //
     /* 1567620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1567623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1567637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567640 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567659 */     // MIs[0] round
     /* 1567659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567662 */     // MIs[0] policy
     /* 1567662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1567675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567681 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567683 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567696 */     // GIR_Coverage, 21590,
     /* 1567696 */     GIR_EraseRootFromParent_Done,
     /* 1567697 */   // Label 21706: @1567697
     /* 1567697 */   GIM_Try, /*On fail goto*//*Label 21707*/ GIMT_Encode4(1567779), // Rule ID 21591 //
     /* 1567702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1567705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1567713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1567716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1567719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1567722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567741 */     // MIs[0] round
     /* 1567741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567744 */     // MIs[0] policy
     /* 1567744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567754 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_MF2_MASK),
     /* 1567757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567763 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567765 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567778 */     // GIR_Coverage, 21591,
     /* 1567778 */     GIR_EraseRootFromParent_Done,
     /* 1567779 */   // Label 21707: @1567779
     /* 1567779 */   GIM_Try, /*On fail goto*//*Label 21708*/ GIMT_Encode4(1567861), // Rule ID 21594 //
     /* 1567784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1567787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567804 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567823 */     // MIs[0] round
     /* 1567823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567826 */     // MIs[0] policy
     /* 1567826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1567836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1567839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567847 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567860 */     // GIR_Coverage, 21594,
     /* 1567860 */     GIR_EraseRootFromParent_Done,
     /* 1567861 */   // Label 21708: @1567861
     /* 1567861 */   GIM_Try, /*On fail goto*//*Label 21709*/ GIMT_Encode4(1567943), // Rule ID 21595 //
     /* 1567866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1567869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1567877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1567880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1567883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1567886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1567889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1567893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1567897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567905 */     // MIs[0] round
     /* 1567905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567908 */     // MIs[0] policy
     /* 1567908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1567918 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11167:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1567918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M1_MASK),
     /* 1567921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1567923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1567925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1567927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1567929 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1567931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1567936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1567939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1567941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1567942 */     // GIR_Coverage, 21595,
     /* 1567942 */     GIR_EraseRootFromParent_Done,
     /* 1567943 */   // Label 21709: @1567943
     /* 1567943 */   GIM_Try, /*On fail goto*//*Label 21710*/ GIMT_Encode4(1568025), // Rule ID 21598 //
     /* 1567948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1567951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1567956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1567959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1567962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1567965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1567968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1567971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1567975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1567979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1567983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1567987 */     // MIs[0] round
     /* 1567987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1567990 */     // MIs[0] policy
     /* 1567990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1567993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1568003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568009 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568011 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568024 */     // GIR_Coverage, 21598,
     /* 1568024 */     GIR_EraseRootFromParent_Done,
     /* 1568025 */   // Label 21710: @1568025
     /* 1568025 */   GIM_Try, /*On fail goto*//*Label 21711*/ GIMT_Encode4(1568107), // Rule ID 21599 //
     /* 1568030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1568033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1568038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1568041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1568044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1568047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568050 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568069 */     // MIs[0] round
     /* 1568069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568072 */     // MIs[0] policy
     /* 1568072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11167:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M2_MASK),
     /* 1568085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568091 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568093 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568106 */     // GIR_Coverage, 21599,
     /* 1568106 */     GIR_EraseRootFromParent_Done,
     /* 1568107 */   // Label 21711: @1568107
     /* 1568107 */   GIM_Try, /*On fail goto*//*Label 21712*/ GIMT_Encode4(1568189), // Rule ID 21602 //
     /* 1568112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1568115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1568120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1568129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568151 */     // MIs[0] round
     /* 1568151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568154 */     // MIs[0] policy
     /* 1568154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568164 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1568167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568173 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568175 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568188 */     // GIR_Coverage, 21602,
     /* 1568188 */     GIR_EraseRootFromParent_Done,
     /* 1568189 */   // Label 21712: @1568189
     /* 1568189 */   GIM_Try, /*On fail goto*//*Label 21713*/ GIMT_Encode4(1568271), // Rule ID 21603 //
     /* 1568194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1568197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_x_f_w_mask),
     /* 1568202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1568205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1568208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1568211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568214 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568233 */     // MIs[0] round
     /* 1568233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568236 */     // MIs[0] policy
     /* 1568236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568246 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11167:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_X_F_W_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_X_F_W_M4_MASK),
     /* 1568249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568257 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1568267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568270 */     // GIR_Coverage, 21603,
     /* 1568270 */     GIR_EraseRootFromParent_Done,
     /* 1568271 */   // Label 21713: @1568271
     /* 1568271 */   GIM_Try, /*On fail goto*//*Label 21714*/ GIMT_Encode4(1568353), // Rule ID 21726 //
     /* 1568276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568296 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568315 */     // MIs[0] round
     /* 1568315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568318 */     // MIs[0] policy
     /* 1568318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568328 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1568331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568337 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568339 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568352 */     // GIR_Coverage, 21726,
     /* 1568352 */     GIR_EraseRootFromParent_Done,
     /* 1568353 */   // Label 21714: @1568353
     /* 1568353 */   GIM_Try, /*On fail goto*//*Label 21715*/ GIMT_Encode4(1568435), // Rule ID 21727 //
     /* 1568358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1568369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1568372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1568375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1568378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568397 */     // MIs[0] round
     /* 1568397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568400 */     // MIs[0] policy
     /* 1568400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568410 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16_MASK),
     /* 1568413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568419 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568421 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568434 */     // GIR_Coverage, 21727,
     /* 1568434 */     GIR_EraseRootFromParent_Done,
     /* 1568435 */   // Label 21715: @1568435
     /* 1568435 */   GIM_Try, /*On fail goto*//*Label 21716*/ GIMT_Encode4(1568517), // Rule ID 21730 //
     /* 1568440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568460 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568479 */     // MIs[0] round
     /* 1568479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568482 */     // MIs[0] policy
     /* 1568482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568492 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1568495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568501 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568503 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568516 */     // GIR_Coverage, 21730,
     /* 1568516 */     GIR_EraseRootFromParent_Done,
     /* 1568517 */   // Label 21716: @1568517
     /* 1568517 */   GIM_Try, /*On fail goto*//*Label 21717*/ GIMT_Encode4(1568599), // Rule ID 21731 //
     /* 1568522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1568533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1568536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1568539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1568542 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568561 */     // MIs[0] round
     /* 1568561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568564 */     // MIs[0] policy
     /* 1568564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568574 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16_MASK),
     /* 1568577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568585 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568598 */     // GIR_Coverage, 21731,
     /* 1568598 */     GIR_EraseRootFromParent_Done,
     /* 1568599 */   // Label 21717: @1568599
     /* 1568599 */   GIM_Try, /*On fail goto*//*Label 21718*/ GIMT_Encode4(1568681), // Rule ID 21734 //
     /* 1568604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1568615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1568618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568643 */     // MIs[0] round
     /* 1568643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568646 */     // MIs[0] policy
     /* 1568646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568656 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1568659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568665 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568667 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568680 */     // GIR_Coverage, 21734,
     /* 1568680 */     GIR_EraseRootFromParent_Done,
     /* 1568681 */   // Label 21718: @1568681
     /* 1568681 */   GIM_Try, /*On fail goto*//*Label 21719*/ GIMT_Encode4(1568763), // Rule ID 21735 //
     /* 1568686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1568697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1568700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1568703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1568706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1568713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1568717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568725 */     // MIs[0] round
     /* 1568725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568728 */     // MIs[0] policy
     /* 1568728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568738 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11159:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16_MASK),
     /* 1568741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568749 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568762 */     // GIR_Coverage, 21735,
     /* 1568762 */     GIR_EraseRootFromParent_Done,
     /* 1568763 */   // Label 21719: @1568763
     /* 1568763 */   GIM_Try, /*On fail goto*//*Label 21720*/ GIMT_Encode4(1568845), // Rule ID 21738 //
     /* 1568768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1568779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1568782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568788 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568807 */     // MIs[0] round
     /* 1568807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568810 */     // MIs[0] policy
     /* 1568810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568820 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1568823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568829 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568831 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568844 */     // GIR_Coverage, 21738,
     /* 1568844 */     GIR_EraseRootFromParent_Done,
     /* 1568845 */   // Label 21720: @1568845
     /* 1568845 */   GIM_Try, /*On fail goto*//*Label 21721*/ GIMT_Encode4(1568927), // Rule ID 21739 //
     /* 1568850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1568853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1568861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1568864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1568867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1568870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1568873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1568877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1568881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568889 */     // MIs[0] round
     /* 1568889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568892 */     // MIs[0] policy
     /* 1568892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1568902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16_MASK),
     /* 1568905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568911 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568913 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1568920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1568923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1568925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1568926 */     // GIR_Coverage, 21739,
     /* 1568926 */     GIR_EraseRootFromParent_Done,
     /* 1568927 */   // Label 21721: @1568927
     /* 1568927 */   GIM_Try, /*On fail goto*//*Label 21722*/ GIMT_Encode4(1569009), // Rule ID 21742 //
     /* 1568932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1568935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1568940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1568943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1568946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1568949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1568952 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1568955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1568959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1568963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1568967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1568971 */     // MIs[0] round
     /* 1568971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1568974 */     // MIs[0] policy
     /* 1568974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1568977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1568984 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1568984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1568987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1568989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1568991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1568993 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1568995 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1568997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569008 */     // GIR_Coverage, 21742,
     /* 1569008 */     GIR_EraseRootFromParent_Done,
     /* 1569009 */   // Label 21722: @1569009
     /* 1569009 */   GIM_Try, /*On fail goto*//*Label 21723*/ GIMT_Encode4(1569091), // Rule ID 21743 //
     /* 1569014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1569025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1569028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1569031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1569034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569053 */     // MIs[0] round
     /* 1569053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569056 */     // MIs[0] policy
     /* 1569056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569066 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16_MASK),
     /* 1569069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569077 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569090 */     // GIR_Coverage, 21743,
     /* 1569090 */     GIR_EraseRootFromParent_Done,
     /* 1569091 */   // Label 21723: @1569091
     /* 1569091 */   GIM_Try, /*On fail goto*//*Label 21724*/ GIMT_Encode4(1569173), // Rule ID 21746 //
     /* 1569096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569135 */     // MIs[0] round
     /* 1569135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569138 */     // MIs[0] policy
     /* 1569138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569148 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1569151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569157 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569159 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569172 */     // GIR_Coverage, 21746,
     /* 1569172 */     GIR_EraseRootFromParent_Done,
     /* 1569173 */   // Label 21724: @1569173
     /* 1569173 */   GIM_Try, /*On fail goto*//*Label 21725*/ GIMT_Encode4(1569255), // Rule ID 21747 //
     /* 1569178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1569189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1569192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1569195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569198 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569217 */     // MIs[0] round
     /* 1569217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569220 */     // MIs[0] policy
     /* 1569220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569230 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32_MASK),
     /* 1569233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569241 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569254 */     // GIR_Coverage, 21747,
     /* 1569254 */     GIR_EraseRootFromParent_Done,
     /* 1569255 */   // Label 21725: @1569255
     /* 1569255 */   GIM_Try, /*On fail goto*//*Label 21726*/ GIMT_Encode4(1569337), // Rule ID 21750 //
     /* 1569260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1569277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569299 */     // MIs[0] round
     /* 1569299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569302 */     // MIs[0] policy
     /* 1569302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569312 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1569315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569321 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569323 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569336 */     // GIR_Coverage, 21750,
     /* 1569336 */     GIR_EraseRootFromParent_Done,
     /* 1569337 */   // Label 21726: @1569337
     /* 1569337 */   GIM_Try, /*On fail goto*//*Label 21727*/ GIMT_Encode4(1569419), // Rule ID 21751 //
     /* 1569342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1569353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1569356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1569359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569381 */     // MIs[0] round
     /* 1569381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569384 */     // MIs[0] policy
     /* 1569384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569394 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11159:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32_MASK),
     /* 1569397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569403 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569405 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569418 */     // GIR_Coverage, 21751,
     /* 1569418 */     GIR_EraseRootFromParent_Done,
     /* 1569419 */   // Label 21727: @1569419
     /* 1569419 */   GIM_Try, /*On fail goto*//*Label 21728*/ GIMT_Encode4(1569501), // Rule ID 21754 //
     /* 1569424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1569441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569444 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569463 */     // MIs[0] round
     /* 1569463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569466 */     // MIs[0] policy
     /* 1569466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569476 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1569479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569485 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569487 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569500 */     // GIR_Coverage, 21754,
     /* 1569500 */     GIR_EraseRootFromParent_Done,
     /* 1569501 */   // Label 21728: @1569501
     /* 1569501 */   GIM_Try, /*On fail goto*//*Label 21729*/ GIMT_Encode4(1569583), // Rule ID 21755 //
     /* 1569506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1569517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1569520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1569523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1569526 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1569533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1569537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569545 */     // MIs[0] round
     /* 1569545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569548 */     // MIs[0] policy
     /* 1569548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569558 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11159:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32_MASK),
     /* 1569561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569567 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569569 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569582 */     // GIR_Coverage, 21755,
     /* 1569582 */     GIR_EraseRootFromParent_Done,
     /* 1569583 */   // Label 21729: @1569583
     /* 1569583 */   GIM_Try, /*On fail goto*//*Label 21730*/ GIMT_Encode4(1569665), // Rule ID 21758 //
     /* 1569588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1569591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1569605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569627 */     // MIs[0] round
     /* 1569627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569630 */     // MIs[0] policy
     /* 1569630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569640 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1569643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569651 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569664 */     // GIR_Coverage, 21758,
     /* 1569664 */     GIR_EraseRootFromParent_Done,
     /* 1569665 */   // Label 21730: @1569665
     /* 1569665 */   GIM_Try, /*On fail goto*//*Label 21731*/ GIMT_Encode4(1569747), // Rule ID 21759 //
     /* 1569670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1569673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_xu_w_mask),
     /* 1569678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1569681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1569684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1569687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1569690 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1569697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1569701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1569705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569709 */     // MIs[0] round
     /* 1569709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569712 */     // MIs[0] policy
     /* 1569712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569722 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11159:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_XU_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32_MASK),
     /* 1569725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569731 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569733 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1569743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569746 */     // GIR_Coverage, 21759,
     /* 1569746 */     GIR_EraseRootFromParent_Done,
     /* 1569747 */   // Label 21731: @1569747
     /* 1569747 */   GIM_Try, /*On fail goto*//*Label 21732*/ GIMT_Encode4(1569829), // Rule ID 21762 //
     /* 1569752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1569760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1569763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1569766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569772 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569791 */     // MIs[0] round
     /* 1569791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569794 */     // MIs[0] policy
     /* 1569794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569804 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1569807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569813 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569815 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569828 */     // GIR_Coverage, 21762,
     /* 1569828 */     GIR_EraseRootFromParent_Done,
     /* 1569829 */   // Label 21732: @1569829
     /* 1569829 */   GIM_Try, /*On fail goto*//*Label 21733*/ GIMT_Encode4(1569911), // Rule ID 21763 //
     /* 1569834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1569837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1569842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1569845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1569848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1569851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1569854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1569857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569873 */     // MIs[0] round
     /* 1569873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569876 */     // MIs[0] policy
     /* 1569876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569886 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1569886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16_MASK),
     /* 1569889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569895 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569897 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569910 */     // GIR_Coverage, 21763,
     /* 1569910 */     GIR_EraseRootFromParent_Done,
     /* 1569911 */   // Label 21733: @1569911
     /* 1569911 */   GIM_Try, /*On fail goto*//*Label 21734*/ GIMT_Encode4(1569993), // Rule ID 21766 //
     /* 1569916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1569919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1569924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1569927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1569930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1569933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1569936 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1569939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1569943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1569951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1569955 */     // MIs[0] round
     /* 1569955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1569958 */     // MIs[0] policy
     /* 1569958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1569961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1569968 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1569968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1569971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1569973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1569975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1569977 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1569979 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1569981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1569986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1569989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1569991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1569992 */     // GIR_Coverage, 21766,
     /* 1569992 */     GIR_EraseRootFromParent_Done,
     /* 1569993 */   // Label 21734: @1569993
     /* 1569993 */   GIM_Try, /*On fail goto*//*Label 21735*/ GIMT_Encode4(1570075), // Rule ID 21767 //
     /* 1569998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1570009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1570012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1570015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570018 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570037 */     // MIs[0] round
     /* 1570037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570040 */     // MIs[0] policy
     /* 1570040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570050 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16_MASK),
     /* 1570053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570059 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570061 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570074 */     // GIR_Coverage, 21767,
     /* 1570074 */     GIR_EraseRootFromParent_Done,
     /* 1570075 */   // Label 21735: @1570075
     /* 1570075 */   GIM_Try, /*On fail goto*//*Label 21736*/ GIMT_Encode4(1570157), // Rule ID 21770 //
     /* 1570080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1570091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1570094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570119 */     // MIs[0] round
     /* 1570119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570122 */     // MIs[0] policy
     /* 1570122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570132 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1570135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570141 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570143 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570156 */     // GIR_Coverage, 21770,
     /* 1570156 */     GIR_EraseRootFromParent_Done,
     /* 1570157 */   // Label 21736: @1570157
     /* 1570157 */   GIM_Try, /*On fail goto*//*Label 21737*/ GIMT_Encode4(1570239), // Rule ID 21771 //
     /* 1570162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1570173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1570176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1570179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570182 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570201 */     // MIs[0] round
     /* 1570201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570204 */     // MIs[0] policy
     /* 1570204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570214 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11157:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16_MASK),
     /* 1570217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570223 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570225 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570238 */     // GIR_Coverage, 21771,
     /* 1570238 */     GIR_EraseRootFromParent_Done,
     /* 1570239 */   // Label 21737: @1570239
     /* 1570239 */   GIM_Try, /*On fail goto*//*Label 21738*/ GIMT_Encode4(1570321), // Rule ID 21774 //
     /* 1570244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1570255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1570258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570264 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570283 */     // MIs[0] round
     /* 1570283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570286 */     // MIs[0] policy
     /* 1570286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570296 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1570299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570305 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570307 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570320 */     // GIR_Coverage, 21774,
     /* 1570320 */     GIR_EraseRootFromParent_Done,
     /* 1570321 */   // Label 21738: @1570321
     /* 1570321 */   GIM_Try, /*On fail goto*//*Label 21739*/ GIMT_Encode4(1570403), // Rule ID 21775 //
     /* 1570326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1570337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1570340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1570343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1570346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570365 */     // MIs[0] round
     /* 1570365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570368 */     // MIs[0] policy
     /* 1570368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570378 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16_MASK),
     /* 1570381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570387 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570389 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570402 */     // GIR_Coverage, 21775,
     /* 1570402 */     GIR_EraseRootFromParent_Done,
     /* 1570403 */   // Label 21739: @1570403
     /* 1570403 */   GIM_Try, /*On fail goto*//*Label 21740*/ GIMT_Encode4(1570485), // Rule ID 21778 //
     /* 1570408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1570411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1570419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1570422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1570425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570428 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570447 */     // MIs[0] round
     /* 1570447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570450 */     // MIs[0] policy
     /* 1570450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570460 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1570463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570469 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570471 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570484 */     // GIR_Coverage, 21778,
     /* 1570484 */     GIR_EraseRootFromParent_Done,
     /* 1570485 */   // Label 21740: @1570485
     /* 1570485 */   GIM_Try, /*On fail goto*//*Label 21741*/ GIMT_Encode4(1570567), // Rule ID 21779 //
     /* 1570490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1570493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1570501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1570504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1570507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1570510 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1570517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1570525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570529 */     // MIs[0] round
     /* 1570529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570532 */     // MIs[0] policy
     /* 1570532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570542 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16_MASK),
     /* 1570545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570551 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570553 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1570563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570566 */     // GIR_Coverage, 21779,
     /* 1570566 */     GIR_EraseRootFromParent_Done,
     /* 1570567 */   // Label 21741: @1570567
     /* 1570567 */   GIM_Try, /*On fail goto*//*Label 21742*/ GIMT_Encode4(1570649), // Rule ID 21782 //
     /* 1570572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1570583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1570586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1570589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570611 */     // MIs[0] round
     /* 1570611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570614 */     // MIs[0] policy
     /* 1570614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570624 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1570627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570635 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570648 */     // GIR_Coverage, 21782,
     /* 1570648 */     GIR_EraseRootFromParent_Done,
     /* 1570649 */   // Label 21742: @1570649
     /* 1570649 */   GIM_Try, /*On fail goto*//*Label 21743*/ GIMT_Encode4(1570731), // Rule ID 21783 //
     /* 1570654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1570665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1570668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1570671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1570674 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570693 */     // MIs[0] round
     /* 1570693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570696 */     // MIs[0] policy
     /* 1570696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570706 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32_MASK),
     /* 1570709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570715 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570717 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570730 */     // GIR_Coverage, 21783,
     /* 1570730 */     GIR_EraseRootFromParent_Done,
     /* 1570731 */   // Label 21743: @1570731
     /* 1570731 */   GIM_Try, /*On fail goto*//*Label 21744*/ GIMT_Encode4(1570813), // Rule ID 21786 //
     /* 1570736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1570747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1570750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1570753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570756 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570775 */     // MIs[0] round
     /* 1570775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570778 */     // MIs[0] policy
     /* 1570778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570788 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1570791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570797 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570799 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570812 */     // GIR_Coverage, 21786,
     /* 1570812 */     GIR_EraseRootFromParent_Done,
     /* 1570813 */   // Label 21744: @1570813
     /* 1570813 */   GIM_Try, /*On fail goto*//*Label 21745*/ GIMT_Encode4(1570895), // Rule ID 21787 //
     /* 1570818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1570829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1570832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1570835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1570838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1570841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1570845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1570849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570857 */     // MIs[0] round
     /* 1570857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570860 */     // MIs[0] policy
     /* 1570860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570870 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11157:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1570870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32_MASK),
     /* 1570873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570879 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570881 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570894 */     // GIR_Coverage, 21787,
     /* 1570894 */     GIR_EraseRootFromParent_Done,
     /* 1570895 */   // Label 21745: @1570895
     /* 1570895 */   GIM_Try, /*On fail goto*//*Label 21746*/ GIMT_Encode4(1570977), // Rule ID 21790 //
     /* 1570900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1570903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1570911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1570914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1570917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1570920 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1570923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1570927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1570931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1570935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1570939 */     // MIs[0] round
     /* 1570939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1570942 */     // MIs[0] policy
     /* 1570942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1570945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1570952 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1570952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1570955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1570957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1570959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1570961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1570963 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1570965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1570970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1570973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1570975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1570976 */     // GIR_Coverage, 21790,
     /* 1570976 */     GIR_EraseRootFromParent_Done,
     /* 1570977 */   // Label 21746: @1570977
     /* 1570977 */   GIM_Try, /*On fail goto*//*Label 21747*/ GIMT_Encode4(1571059), // Rule ID 21791 //
     /* 1570982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1570985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1570990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1570993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1570996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1570999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571002 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571021 */     // MIs[0] round
     /* 1571021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571024 */     // MIs[0] policy
     /* 1571024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571034 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11157:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32_MASK),
     /* 1571037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571043 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571045 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571058 */     // GIR_Coverage, 21791,
     /* 1571058 */     GIR_EraseRootFromParent_Done,
     /* 1571059 */   // Label 21747: @1571059
     /* 1571059 */   GIM_Try, /*On fail goto*//*Label 21748*/ GIMT_Encode4(1571141), // Rule ID 21794 //
     /* 1571064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 1571067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1571072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571103 */     // MIs[0] round
     /* 1571103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571106 */     // MIs[0] policy
     /* 1571106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571116 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1571119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571125 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571127 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571140 */     // GIR_Coverage, 21794,
     /* 1571140 */     GIR_EraseRootFromParent_Done,
     /* 1571141 */   // Label 21748: @1571141
     /* 1571141 */   GIM_Try, /*On fail goto*//*Label 21749*/ GIMT_Encode4(1571223), // Rule ID 21795 //
     /* 1571146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 1571149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_x_w_mask),
     /* 1571154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571166 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571185 */     // MIs[0] round
     /* 1571185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571188 */     // MIs[0] policy
     /* 1571188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571198 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11157:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_X_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32_MASK),
     /* 1571201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571207 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571209 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571222 */     // GIR_Coverage, 21795,
     /* 1571222 */     GIR_EraseRootFromParent_Done,
     /* 1571223 */   // Label 21749: @1571223
     /* 1571223 */   GIM_Try, /*On fail goto*//*Label 21750*/ GIMT_Encode4(1571305), // Rule ID 21798 //
     /* 1571228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1571231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571248 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571267 */     // MIs[0] round
     /* 1571267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571270 */     // MIs[0] policy
     /* 1571270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571280 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1571283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571291 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571304 */     // GIR_Coverage, 21798,
     /* 1571304 */     GIR_EraseRootFromParent_Done,
     /* 1571305 */   // Label 21750: @1571305
     /* 1571305 */   GIM_Try, /*On fail goto*//*Label 21751*/ GIMT_Encode4(1571387), // Rule ID 21799 //
     /* 1571310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1571313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1571321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1571324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1571327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571349 */     // MIs[0] round
     /* 1571349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571352 */     // MIs[0] policy
     /* 1571352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571362 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32_MASK),
     /* 1571365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571373 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571386 */     // GIR_Coverage, 21799,
     /* 1571386 */     GIR_EraseRootFromParent_Done,
     /* 1571387 */   // Label 21751: @1571387
     /* 1571387 */   GIM_Try, /*On fail goto*//*Label 21752*/ GIMT_Encode4(1571469), // Rule ID 21802 //
     /* 1571392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1571395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571412 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571431 */     // MIs[0] round
     /* 1571431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571434 */     // MIs[0] policy
     /* 1571434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571444 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1571447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571455 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571468 */     // GIR_Coverage, 21802,
     /* 1571468 */     GIR_EraseRootFromParent_Done,
     /* 1571469 */   // Label 21752: @1571469
     /* 1571469 */   GIM_Try, /*On fail goto*//*Label 21753*/ GIMT_Encode4(1571551), // Rule ID 21803 //
     /* 1571474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1571477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1571485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1571488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1571491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1571494 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571513 */     // MIs[0] round
     /* 1571513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571516 */     // MIs[0] policy
     /* 1571516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571526 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32_MASK),
     /* 1571529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571535 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571537 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571550 */     // GIR_Coverage, 21803,
     /* 1571550 */     GIR_EraseRootFromParent_Done,
     /* 1571551 */   // Label 21753: @1571551
     /* 1571551 */   GIM_Try, /*On fail goto*//*Label 21754*/ GIMT_Encode4(1571633), // Rule ID 21806 //
     /* 1571556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1571559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1571567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1571570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1571573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571595 */     // MIs[0] round
     /* 1571595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571598 */     // MIs[0] policy
     /* 1571598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571608 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1571611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571617 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571619 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571632 */     // GIR_Coverage, 21806,
     /* 1571632 */     GIR_EraseRootFromParent_Done,
     /* 1571633 */   // Label 21754: @1571633
     /* 1571633 */   GIM_Try, /*On fail goto*//*Label 21755*/ GIMT_Encode4(1571715), // Rule ID 21807 //
     /* 1571638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1571641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1571649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1571652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1571655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1571658 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1571665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1571669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571677 */     // MIs[0] round
     /* 1571677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571680 */     // MIs[0] policy
     /* 1571680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571690 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32_MASK),
     /* 1571693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571701 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571714 */     // GIR_Coverage, 21807,
     /* 1571714 */     GIR_EraseRootFromParent_Done,
     /* 1571715 */   // Label 21755: @1571715
     /* 1571715 */   GIM_Try, /*On fail goto*//*Label 21756*/ GIMT_Encode4(1571797), // Rule ID 21810 //
     /* 1571720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 1571723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571740 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571759 */     // MIs[0] round
     /* 1571759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571762 */     // MIs[0] policy
     /* 1571762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571772 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1571775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571781 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571783 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571796 */     // GIR_Coverage, 21810,
     /* 1571796 */     GIR_EraseRootFromParent_Done,
     /* 1571797 */   // Label 21756: @1571797
     /* 1571797 */   GIM_Try, /*On fail goto*//*Label 21757*/ GIMT_Encode4(1571879), // Rule ID 21811 //
     /* 1571802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 1571805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1571813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1571816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1571819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1571822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1571829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1571833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1571837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571841 */     // MIs[0] round
     /* 1571841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571844 */     // MIs[0] policy
     /* 1571844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571854 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1571854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32_MASK),
     /* 1571857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571863 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571865 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1571875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571878 */     // GIR_Coverage, 21811,
     /* 1571878 */     GIR_EraseRootFromParent_Done,
     /* 1571879 */   // Label 21757: @1571879
     /* 1571879 */   GIM_Try, /*On fail goto*//*Label 21758*/ GIMT_Encode4(1571961), // Rule ID 21814 //
     /* 1571884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1571887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1571907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1571923 */     // MIs[0] round
     /* 1571923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1571926 */     // MIs[0] policy
     /* 1571926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1571929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1571936 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1571936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1571939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1571941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1571943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1571945 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1571947 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1571949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1571954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1571957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1571959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1571960 */     // GIR_Coverage, 21814,
     /* 1571960 */     GIR_EraseRootFromParent_Done,
     /* 1571961 */   // Label 21758: @1571961
     /* 1571961 */   GIM_Try, /*On fail goto*//*Label 21759*/ GIMT_Encode4(1572043), // Rule ID 21815 //
     /* 1571966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1571969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1571974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1571977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1571980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1571983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 1571986 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1571989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1571993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1571997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572005 */     // MIs[0] round
     /* 1572005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572008 */     // MIs[0] policy
     /* 1572008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572018 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16_MASK),
     /* 1572021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572029 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572042 */     // GIR_Coverage, 21815,
     /* 1572042 */     GIR_EraseRootFromParent_Done,
     /* 1572043 */   // Label 21759: @1572043
     /* 1572043 */   GIM_Try, /*On fail goto*//*Label 21760*/ GIMT_Encode4(1572125), // Rule ID 21818 //
     /* 1572048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1572051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1572065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572087 */     // MIs[0] round
     /* 1572087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572090 */     // MIs[0] policy
     /* 1572090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572100 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1572103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572111 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572124 */     // GIR_Coverage, 21818,
     /* 1572124 */     GIR_EraseRootFromParent_Done,
     /* 1572125 */   // Label 21760: @1572125
     /* 1572125 */   GIM_Try, /*On fail goto*//*Label 21761*/ GIMT_Encode4(1572207), // Rule ID 21819 //
     /* 1572130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1572133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1572147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 1572150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572169 */     // MIs[0] round
     /* 1572169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572172 */     // MIs[0] policy
     /* 1572172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572182 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16_MASK),
     /* 1572185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572193 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572206 */     // GIR_Coverage, 21819,
     /* 1572206 */     GIR_EraseRootFromParent_Done,
     /* 1572207 */   // Label 21761: @1572207
     /* 1572207 */   GIM_Try, /*On fail goto*//*Label 21762*/ GIMT_Encode4(1572289), // Rule ID 21822 //
     /* 1572212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1572215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1572223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1572226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1572229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572232 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572251 */     // MIs[0] round
     /* 1572251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572254 */     // MIs[0] policy
     /* 1572254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572264 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1572267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572273 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572275 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572288 */     // GIR_Coverage, 21822,
     /* 1572288 */     GIR_EraseRootFromParent_Done,
     /* 1572289 */   // Label 21762: @1572289
     /* 1572289 */   GIM_Try, /*On fail goto*//*Label 21763*/ GIMT_Encode4(1572371), // Rule ID 21823 //
     /* 1572294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1572297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1572305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1572308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1572311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 1572314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572333 */     // MIs[0] round
     /* 1572333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572336 */     // MIs[0] policy
     /* 1572336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572346 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11155:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16_MASK),
     /* 1572349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572355 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572357 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572370 */     // GIR_Coverage, 21823,
     /* 1572370 */     GIR_EraseRootFromParent_Done,
     /* 1572371 */   // Label 21763: @1572371
     /* 1572371 */   GIM_Try, /*On fail goto*//*Label 21764*/ GIMT_Encode4(1572453), // Rule ID 21826 //
     /* 1572376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1572379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1572387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1572390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1572393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572396 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572415 */     // MIs[0] round
     /* 1572415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572418 */     // MIs[0] policy
     /* 1572418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1572431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572437 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572439 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572452 */     // GIR_Coverage, 21826,
     /* 1572452 */     GIR_EraseRootFromParent_Done,
     /* 1572453 */   // Label 21764: @1572453
     /* 1572453 */   GIM_Try, /*On fail goto*//*Label 21765*/ GIMT_Encode4(1572535), // Rule ID 21827 //
     /* 1572458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1572461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1572469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1572472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1572475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 1572478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1572485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1572489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572497 */     // MIs[0] round
     /* 1572497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572500 */     // MIs[0] policy
     /* 1572500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572510 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11155:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16_MASK),
     /* 1572513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572519 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572521 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572534 */     // GIR_Coverage, 21827,
     /* 1572534 */     GIR_EraseRootFromParent_Done,
     /* 1572535 */   // Label 21765: @1572535
     /* 1572535 */   GIM_Try, /*On fail goto*//*Label 21766*/ GIMT_Encode4(1572617), // Rule ID 21830 //
     /* 1572540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1572543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572579 */     // MIs[0] round
     /* 1572579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572582 */     // MIs[0] policy
     /* 1572582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572592 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1572595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572601 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572603 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572616 */     // GIR_Coverage, 21830,
     /* 1572616 */     GIR_EraseRootFromParent_Done,
     /* 1572617 */   // Label 21766: @1572617
     /* 1572617 */   GIM_Try, /*On fail goto*//*Label 21767*/ GIMT_Encode4(1572699), // Rule ID 21831 //
     /* 1572622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1572625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfncvt_f_f_w_mask),
     /* 1572630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1572633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1572636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1572639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 1572642 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1572649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1572653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1572657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572661 */     // MIs[0] round
     /* 1572661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 1572664 */     // MIs[0] policy
     /* 1572664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572674 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11155:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNCVT_F_F_W_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16_MASK),
     /* 1572677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1572683 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 1572685 */     GIR_RootToRootCopy, /*OpIdx*/5, // round
     /* 1572687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1572695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572698 */     // GIR_Coverage, 21831,
     /* 1572698 */     GIR_EraseRootFromParent_Done,
     /* 1572699 */   // Label 21767: @1572699
     /* 1572699 */   GIM_Try, /*On fail goto*//*Label 21768*/ GIMT_Encode4(1572781), // Rule ID 2648 //
     /* 1572704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1572712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1572721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572724 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572735 */     // MIs[0] passthru
     /* 1572735 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1572740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572748 */     // MIs[0] policy
     /* 1572748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572758 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1572761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572780 */     // GIR_Coverage, 2648,
     /* 1572780 */     GIR_EraseRootFromParent_Done,
     /* 1572781 */   // Label 21768: @1572781
     /* 1572781 */   GIM_Try, /*On fail goto*//*Label 21769*/ GIMT_Encode4(1572863), // Rule ID 2649 //
     /* 1572786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1572794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1572797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1572800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1572803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1572806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572817 */     // MIs[0] passthru
     /* 1572817 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1572822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572830 */     // MIs[0] policy
     /* 1572830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572840 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1572840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK_TIED),
     /* 1572843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572862 */     // GIR_Coverage, 2649,
     /* 1572862 */     GIR_EraseRootFromParent_Done,
     /* 1572863 */   // Label 21769: @1572863
     /* 1572863 */   GIM_Try, /*On fail goto*//*Label 21770*/ GIMT_Encode4(1572945), // Rule ID 3956 //
     /* 1572868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1572871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1572876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1572885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1572888 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1572891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572899 */     // MIs[0] passthru
     /* 1572899 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1572904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572912 */     // MIs[0] policy
     /* 1572912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1572922 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1572922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1572925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1572927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1572929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1572931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1572933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1572938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1572941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1572943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1572944 */     // GIR_Coverage, 3956,
     /* 1572944 */     GIR_EraseRootFromParent_Done,
     /* 1572945 */   // Label 21770: @1572945
     /* 1572945 */   GIM_Try, /*On fail goto*//*Label 21771*/ GIMT_Encode4(1573027), // Rule ID 3957 //
     /* 1572950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1572953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1572958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1572961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1572964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1572967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1572970 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1572973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1572977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572981 */     // MIs[0] passthru
     /* 1572981 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1572986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1572990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1572994 */     // MIs[0] policy
     /* 1572994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1572997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573004 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1573007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573026 */     // GIR_Coverage, 3957,
     /* 1573026 */     GIR_EraseRootFromParent_Done,
     /* 1573027 */   // Label 21771: @1573027
     /* 1573027 */   GIM_Try, /*On fail goto*//*Label 21772*/ GIMT_Encode4(1573109), // Rule ID 3966 //
     /* 1573032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1573049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1573052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573063 */     // MIs[0] passthru
     /* 1573063 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573076 */     // MIs[0] policy
     /* 1573076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573086 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1573089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573108 */     // GIR_Coverage, 3966,
     /* 1573108 */     GIR_EraseRootFromParent_Done,
     /* 1573109 */   // Label 21772: @1573109
     /* 1573109 */   GIM_Try, /*On fail goto*//*Label 21773*/ GIMT_Encode4(1573191), // Rule ID 3967 //
     /* 1573114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1573125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1573128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1573131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1573134 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573145 */     // MIs[0] passthru
     /* 1573145 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573158 */     // MIs[0] policy
     /* 1573158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573168 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1573171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573190 */     // GIR_Coverage, 3967,
     /* 1573190 */     GIR_EraseRootFromParent_Done,
     /* 1573191 */   // Label 21773: @1573191
     /* 1573191 */   GIM_Try, /*On fail goto*//*Label 21774*/ GIMT_Encode4(1573273), // Rule ID 3976 //
     /* 1573196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1573213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1573216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573227 */     // MIs[0] passthru
     /* 1573227 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573240 */     // MIs[0] policy
     /* 1573240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1573253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573272 */     // GIR_Coverage, 3976,
     /* 1573272 */     GIR_EraseRootFromParent_Done,
     /* 1573273 */   // Label 21774: @1573273
     /* 1573273 */   GIM_Try, /*On fail goto*//*Label 21775*/ GIMT_Encode4(1573355), // Rule ID 3977 //
     /* 1573278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1573289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1573292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1573295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1573298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1573305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573309 */     // MIs[0] passthru
     /* 1573309 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573322 */     // MIs[0] policy
     /* 1573322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1573335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573354 */     // GIR_Coverage, 3977,
     /* 1573354 */     GIR_EraseRootFromParent_Done,
     /* 1573355 */   // Label 21775: @1573355
     /* 1573355 */   GIM_Try, /*On fail goto*//*Label 21776*/ GIMT_Encode4(1573437), // Rule ID 3986 //
     /* 1573360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1573371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1573374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1573377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1573380 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573391 */     // MIs[0] passthru
     /* 1573391 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573404 */     // MIs[0] policy
     /* 1573404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1573417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573436 */     // GIR_Coverage, 3986,
     /* 1573436 */     GIR_EraseRootFromParent_Done,
     /* 1573437 */   // Label 21776: @1573437
     /* 1573437 */   GIM_Try, /*On fail goto*//*Label 21777*/ GIMT_Encode4(1573519), // Rule ID 3987 //
     /* 1573442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1573453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1573456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1573459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1573462 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1573469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573473 */     // MIs[0] passthru
     /* 1573473 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1573482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573486 */     // MIs[0] policy
     /* 1573486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1573499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573518 */     // GIR_Coverage, 3987,
     /* 1573518 */     GIR_EraseRootFromParent_Done,
     /* 1573519 */   // Label 21777: @1573519
     /* 1573519 */   GIM_Try, /*On fail goto*//*Label 21778*/ GIMT_Encode4(1573601), // Rule ID 3996 //
     /* 1573524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1573535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1573538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1573541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1573544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573555 */     // MIs[0] passthru
     /* 1573555 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573568 */     // MIs[0] policy
     /* 1573568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573578 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1573581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573600 */     // GIR_Coverage, 3996,
     /* 1573600 */     GIR_EraseRootFromParent_Done,
     /* 1573601 */   // Label 21778: @1573601
     /* 1573601 */   GIM_Try, /*On fail goto*//*Label 21779*/ GIMT_Encode4(1573683), // Rule ID 3997 //
     /* 1573606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1573617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1573620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1573623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1573626 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1573633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1573637 */     // MIs[0] passthru
     /* 1573637 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1573646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573650 */     // MIs[0] policy
     /* 1573650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1573663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1573679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573682 */     // GIR_Coverage, 3997,
     /* 1573682 */     GIR_EraseRootFromParent_Done,
     /* 1573683 */   // Label 21779: @1573683
     /* 1573683 */   GIM_Try, /*On fail goto*//*Label 21780*/ GIMT_Encode4(1573765), // Rule ID 4006 //
     /* 1573688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1573699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1573702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1573705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1573708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573719 */     // MIs[0] passthru
     /* 1573719 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573732 */     // MIs[0] policy
     /* 1573732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573742 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1573745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573764 */     // GIR_Coverage, 4006,
     /* 1573764 */     GIR_EraseRootFromParent_Done,
     /* 1573765 */   // Label 21780: @1573765
     /* 1573765 */   GIM_Try, /*On fail goto*//*Label 21781*/ GIMT_Encode4(1573847), // Rule ID 4007 //
     /* 1573770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1573781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1573784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1573787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1573790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573801 */     // MIs[0] passthru
     /* 1573801 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573814 */     // MIs[0] policy
     /* 1573814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573824 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK_TIED),
     /* 1573827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573846 */     // GIR_Coverage, 4007,
     /* 1573846 */     GIR_EraseRootFromParent_Done,
     /* 1573847 */   // Label 21781: @1573847
     /* 1573847 */   GIM_Try, /*On fail goto*//*Label 21782*/ GIMT_Encode4(1573929), // Rule ID 4016 //
     /* 1573852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1573855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1573869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1573872 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1573875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573883 */     // MIs[0] passthru
     /* 1573883 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573896 */     // MIs[0] policy
     /* 1573896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573906 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1573906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1573909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1573922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1573925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1573927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1573928 */     // GIR_Coverage, 4016,
     /* 1573928 */     GIR_EraseRootFromParent_Done,
     /* 1573929 */   // Label 21782: @1573929
     /* 1573929 */   GIM_Try, /*On fail goto*//*Label 21783*/ GIMT_Encode4(1574011), // Rule ID 4017 //
     /* 1573934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1573937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1573942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1573945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1573948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1573951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1573954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1573957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1573961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573965 */     // MIs[0] passthru
     /* 1573965 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1573970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1573974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1573978 */     // MIs[0] policy
     /* 1573978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1573981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1573988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1573988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1573991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1573993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1573995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1573997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1573999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574010 */     // GIR_Coverage, 4017,
     /* 1574010 */     GIR_EraseRootFromParent_Done,
     /* 1574011 */   // Label 21783: @1574011
     /* 1574011 */   GIM_Try, /*On fail goto*//*Label 21784*/ GIMT_Encode4(1574093), // Rule ID 4026 //
     /* 1574016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1574033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574036 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574047 */     // MIs[0] passthru
     /* 1574047 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574060 */     // MIs[0] policy
     /* 1574060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1574073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574092 */     // GIR_Coverage, 4026,
     /* 1574092 */     GIR_EraseRootFromParent_Done,
     /* 1574093 */   // Label 21784: @1574093
     /* 1574093 */   GIM_Try, /*On fail goto*//*Label 21785*/ GIMT_Encode4(1574175), // Rule ID 4027 //
     /* 1574098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1574109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1574112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1574115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574118 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574129 */     // MIs[0] passthru
     /* 1574129 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574142 */     // MIs[0] policy
     /* 1574142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1574155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574174 */     // GIR_Coverage, 4027,
     /* 1574174 */     GIR_EraseRootFromParent_Done,
     /* 1574175 */   // Label 21785: @1574175
     /* 1574175 */   GIM_Try, /*On fail goto*//*Label 21786*/ GIMT_Encode4(1574257), // Rule ID 4036 //
     /* 1574180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1574197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1574200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574211 */     // MIs[0] passthru
     /* 1574211 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574224 */     // MIs[0] policy
     /* 1574224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1574237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574256 */     // GIR_Coverage, 4036,
     /* 1574256 */     GIR_EraseRootFromParent_Done,
     /* 1574257 */   // Label 21786: @1574257
     /* 1574257 */   GIM_Try, /*On fail goto*//*Label 21787*/ GIMT_Encode4(1574339), // Rule ID 4037 //
     /* 1574262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1574273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1574276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1574279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1574282 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574293 */     // MIs[0] passthru
     /* 1574293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574306 */     // MIs[0] policy
     /* 1574306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1574319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574338 */     // GIR_Coverage, 4037,
     /* 1574338 */     GIR_EraseRootFromParent_Done,
     /* 1574339 */   // Label 21787: @1574339
     /* 1574339 */   GIM_Try, /*On fail goto*//*Label 21788*/ GIMT_Encode4(1574421), // Rule ID 4046 //
     /* 1574344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1574347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1574355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1574358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1574361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574364 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574375 */     // MIs[0] passthru
     /* 1574375 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574388 */     // MIs[0] policy
     /* 1574388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574398 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1574401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574420 */     // GIR_Coverage, 4046,
     /* 1574420 */     GIR_EraseRootFromParent_Done,
     /* 1574421 */   // Label 21788: @1574421
     /* 1574421 */   GIM_Try, /*On fail goto*//*Label 21789*/ GIMT_Encode4(1574503), // Rule ID 4047 //
     /* 1574426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1574429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1574437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1574440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1574443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1574446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1574453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1574457 */     // MIs[0] passthru
     /* 1574457 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574470 */     // MIs[0] policy
     /* 1574470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574480 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1574483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1574499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574502 */     // GIR_Coverage, 4047,
     /* 1574502 */     GIR_EraseRootFromParent_Done,
     /* 1574503 */   // Label 21789: @1574503
     /* 1574503 */   GIM_Try, /*On fail goto*//*Label 21790*/ GIMT_Encode4(1574585), // Rule ID 4056 //
     /* 1574508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1574511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1574519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1574522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1574525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1574528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574539 */     // MIs[0] passthru
     /* 1574539 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574552 */     // MIs[0] policy
     /* 1574552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574562 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1574565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574584 */     // GIR_Coverage, 4056,
     /* 1574584 */     GIR_EraseRootFromParent_Done,
     /* 1574585 */   // Label 21790: @1574585
     /* 1574585 */   GIM_Try, /*On fail goto*//*Label 21791*/ GIMT_Encode4(1574667), // Rule ID 4057 //
     /* 1574590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1574593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1574601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1574604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1574607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1574610 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1574617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574621 */     // MIs[0] passthru
     /* 1574621 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574634 */     // MIs[0] policy
     /* 1574634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK_TIED),
     /* 1574647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574666 */     // GIR_Coverage, 4057,
     /* 1574666 */     GIR_EraseRootFromParent_Done,
     /* 1574667 */   // Label 21791: @1574667
     /* 1574667 */   GIM_Try, /*On fail goto*//*Label 21792*/ GIMT_Encode4(1574749), // Rule ID 4066 //
     /* 1574672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1574675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1574683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1574686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1574689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1574692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574703 */     // MIs[0] passthru
     /* 1574703 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574716 */     // MIs[0] policy
     /* 1574716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574726 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1574729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574748 */     // GIR_Coverage, 4066,
     /* 1574748 */     GIR_EraseRootFromParent_Done,
     /* 1574749 */   // Label 21792: @1574749
     /* 1574749 */   GIM_Try, /*On fail goto*//*Label 21793*/ GIMT_Encode4(1574831), // Rule ID 4067 //
     /* 1574754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1574757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1574765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1574768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1574771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1574774 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1574781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574785 */     // MIs[0] passthru
     /* 1574785 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1574794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574798 */     // MIs[0] policy
     /* 1574798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK_TIED),
     /* 1574811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574830 */     // GIR_Coverage, 4067,
     /* 1574830 */     GIR_EraseRootFromParent_Done,
     /* 1574831 */   // Label 21793: @1574831
     /* 1574831 */   GIM_Try, /*On fail goto*//*Label 21794*/ GIMT_Encode4(1574913), // Rule ID 4076 //
     /* 1574836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1574839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1574847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1574850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1574853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574856 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1574859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574867 */     // MIs[0] passthru
     /* 1574867 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574880 */     // MIs[0] policy
     /* 1574880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574890 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1574890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1574893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574912 */     // GIR_Coverage, 4076,
     /* 1574912 */     GIR_EraseRootFromParent_Done,
     /* 1574913 */   // Label 21794: @1574913
     /* 1574913 */   GIM_Try, /*On fail goto*//*Label 21795*/ GIMT_Encode4(1574995), // Rule ID 4077 //
     /* 1574918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1574921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1574926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1574929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1574932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1574935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1574938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1574941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1574945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1574949 */     // MIs[0] passthru
     /* 1574949 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1574954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1574958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1574962 */     // MIs[0] policy
     /* 1574962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1574965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1574972 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1574972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK_TIED),
     /* 1574975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1574977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1574979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1574981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1574983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1574988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1574991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1574993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1574994 */     // GIR_Coverage, 4077,
     /* 1574994 */     GIR_EraseRootFromParent_Done,
     /* 1574995 */   // Label 21795: @1574995
     /* 1574995 */   GIM_Try, /*On fail goto*//*Label 21796*/ GIMT_Encode4(1575077), // Rule ID 4086 //
     /* 1575000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1575003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1575008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1575011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1575014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1575017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575020 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1575027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575031 */     // MIs[0] passthru
     /* 1575031 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575044 */     // MIs[0] policy
     /* 1575044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1575057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575076 */     // GIR_Coverage, 4086,
     /* 1575076 */     GIR_EraseRootFromParent_Done,
     /* 1575077 */   // Label 21796: @1575077
     /* 1575077 */   GIM_Try, /*On fail goto*//*Label 21797*/ GIMT_Encode4(1575159), // Rule ID 4087 //
     /* 1575082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1575085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1575090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1575093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1575096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1575099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575102 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1575109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1575113 */     // MIs[0] passthru
     /* 1575113 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575126 */     // MIs[0] policy
     /* 1575126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575136 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK_TIED),
     /* 1575139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1575155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575158 */     // GIR_Coverage, 4087,
     /* 1575158 */     GIR_EraseRootFromParent_Done,
     /* 1575159 */   // Label 21797: @1575159
     /* 1575159 */   GIM_Try, /*On fail goto*//*Label 21798*/ GIMT_Encode4(1575241), // Rule ID 4156 //
     /* 1575164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1575181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1575184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575195 */     // MIs[0] passthru
     /* 1575195 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575208 */     // MIs[0] policy
     /* 1575208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575218 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1575221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575240 */     // GIR_Coverage, 4156,
     /* 1575240 */     GIR_EraseRootFromParent_Done,
     /* 1575241 */   // Label 21798: @1575241
     /* 1575241 */   GIM_Try, /*On fail goto*//*Label 21799*/ GIMT_Encode4(1575323), // Rule ID 4157 //
     /* 1575246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1575257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1575260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1575263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1575266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575277 */     // MIs[0] passthru
     /* 1575277 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575290 */     // MIs[0] policy
     /* 1575290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK_TIED),
     /* 1575303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575322 */     // GIR_Coverage, 4157,
     /* 1575322 */     GIR_EraseRootFromParent_Done,
     /* 1575323 */   // Label 21799: @1575323
     /* 1575323 */   GIM_Try, /*On fail goto*//*Label 21800*/ GIMT_Encode4(1575405), // Rule ID 4166 //
     /* 1575328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1575345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575348 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575359 */     // MIs[0] passthru
     /* 1575359 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575372 */     // MIs[0] policy
     /* 1575372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1575385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575404 */     // GIR_Coverage, 4166,
     /* 1575404 */     GIR_EraseRootFromParent_Done,
     /* 1575405 */   // Label 21800: @1575405
     /* 1575405 */   GIM_Try, /*On fail goto*//*Label 21801*/ GIMT_Encode4(1575487), // Rule ID 4167 //
     /* 1575410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1575421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1575424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1575427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1575430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575441 */     // MIs[0] passthru
     /* 1575441 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575454 */     // MIs[0] policy
     /* 1575454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575464 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1575467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575486 */     // GIR_Coverage, 4167,
     /* 1575486 */     GIR_EraseRootFromParent_Done,
     /* 1575487 */   // Label 21801: @1575487
     /* 1575487 */   GIM_Try, /*On fail goto*//*Label 21802*/ GIMT_Encode4(1575569), // Rule ID 4176 //
     /* 1575492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1575509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575512 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575523 */     // MIs[0] passthru
     /* 1575523 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575536 */     // MIs[0] policy
     /* 1575536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1575549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575568 */     // GIR_Coverage, 4176,
     /* 1575568 */     GIR_EraseRootFromParent_Done,
     /* 1575569 */   // Label 21802: @1575569
     /* 1575569 */   GIM_Try, /*On fail goto*//*Label 21803*/ GIMT_Encode4(1575651), // Rule ID 4177 //
     /* 1575574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1575585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1575588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1575591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1575594 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1575601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575605 */     // MIs[0] passthru
     /* 1575605 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575618 */     // MIs[0] policy
     /* 1575618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575628 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1575631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575650 */     // GIR_Coverage, 4177,
     /* 1575650 */     GIR_EraseRootFromParent_Done,
     /* 1575651 */   // Label 21803: @1575651
     /* 1575651 */   GIM_Try, /*On fail goto*//*Label 21804*/ GIMT_Encode4(1575733), // Rule ID 4186 //
     /* 1575656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1575673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575687 */     // MIs[0] passthru
     /* 1575687 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575700 */     // MIs[0] policy
     /* 1575700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575710 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1575713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575732 */     // GIR_Coverage, 4186,
     /* 1575732 */     GIR_EraseRootFromParent_Done,
     /* 1575733 */   // Label 21804: @1575733
     /* 1575733 */   GIM_Try, /*On fail goto*//*Label 21805*/ GIMT_Encode4(1575815), // Rule ID 4187 //
     /* 1575738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1575749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1575752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1575755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1575758 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1575765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575769 */     // MIs[0] passthru
     /* 1575769 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1575778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575782 */     // MIs[0] policy
     /* 1575782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1575795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575814 */     // GIR_Coverage, 4187,
     /* 1575814 */     GIR_EraseRootFromParent_Done,
     /* 1575815 */   // Label 21805: @1575815
     /* 1575815 */   GIM_Try, /*On fail goto*//*Label 21806*/ GIMT_Encode4(1575897), // Rule ID 4196 //
     /* 1575820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1575837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1575840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1575843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575851 */     // MIs[0] passthru
     /* 1575851 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575864 */     // MIs[0] policy
     /* 1575864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1575874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1575877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575896 */     // GIR_Coverage, 4196,
     /* 1575896 */     GIR_EraseRootFromParent_Done,
     /* 1575897 */   // Label 21806: @1575897
     /* 1575897 */   GIM_Try, /*On fail goto*//*Label 21807*/ GIMT_Encode4(1575979), // Rule ID 4197 //
     /* 1575902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1575905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1575913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1575916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1575919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1575922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1575925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1575929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1575933 */     // MIs[0] passthru
     /* 1575933 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1575938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1575942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1575946 */     // MIs[0] policy
     /* 1575946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1575949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1575956 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1575956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1575959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1575961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1575963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1575965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1575967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1575972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1575975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1575977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1575978 */     // GIR_Coverage, 4197,
     /* 1575978 */     GIR_EraseRootFromParent_Done,
     /* 1575979 */   // Label 21807: @1575979
     /* 1575979 */   GIM_Try, /*On fail goto*//*Label 21808*/ GIMT_Encode4(1576061), // Rule ID 4206 //
     /* 1575984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1575987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1575992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1575995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1575998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1576001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1576004 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1576011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576015 */     // MIs[0] passthru
     /* 1576015 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576028 */     // MIs[0] policy
     /* 1576028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576038 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1576041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576060 */     // GIR_Coverage, 4206,
     /* 1576060 */     GIR_EraseRootFromParent_Done,
     /* 1576061 */   // Label 21808: @1576061
     /* 1576061 */   GIM_Try, /*On fail goto*//*Label 21809*/ GIMT_Encode4(1576143), // Rule ID 4207 //
     /* 1576066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1576077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1576080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1576083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1576086 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1576093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576097 */     // MIs[0] passthru
     /* 1576097 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576110 */     // MIs[0] policy
     /* 1576110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1576123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1576139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576142 */     // GIR_Coverage, 4207,
     /* 1576142 */     GIR_EraseRootFromParent_Done,
     /* 1576143 */   // Label 21809: @1576143
     /* 1576143 */   GIM_Try, /*On fail goto*//*Label 21810*/ GIMT_Encode4(1576225), // Rule ID 4216 //
     /* 1576148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1576165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576179 */     // MIs[0] passthru
     /* 1576179 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576192 */     // MIs[0] policy
     /* 1576192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576202 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1576205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576224 */     // GIR_Coverage, 4216,
     /* 1576224 */     GIR_EraseRootFromParent_Done,
     /* 1576225 */   // Label 21810: @1576225
     /* 1576225 */   GIM_Try, /*On fail goto*//*Label 21811*/ GIMT_Encode4(1576307), // Rule ID 4217 //
     /* 1576230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1576241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1576244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1576247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576250 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576261 */     // MIs[0] passthru
     /* 1576261 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576274 */     // MIs[0] policy
     /* 1576274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576284 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK_TIED),
     /* 1576287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576306 */     // GIR_Coverage, 4217,
     /* 1576306 */     GIR_EraseRootFromParent_Done,
     /* 1576307 */   // Label 21811: @1576307
     /* 1576307 */   GIM_Try, /*On fail goto*//*Label 21812*/ GIMT_Encode4(1576389), // Rule ID 4226 //
     /* 1576312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1576329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1576332 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576343 */     // MIs[0] passthru
     /* 1576343 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576356 */     // MIs[0] policy
     /* 1576356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576366 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1576369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576388 */     // GIR_Coverage, 4226,
     /* 1576388 */     GIR_EraseRootFromParent_Done,
     /* 1576389 */   // Label 21812: @1576389
     /* 1576389 */   GIM_Try, /*On fail goto*//*Label 21813*/ GIMT_Encode4(1576471), // Rule ID 4227 //
     /* 1576394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1576405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1576408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1576411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1576414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576425 */     // MIs[0] passthru
     /* 1576425 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576438 */     // MIs[0] policy
     /* 1576438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576448 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1576451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576470 */     // GIR_Coverage, 4227,
     /* 1576470 */     GIR_EraseRootFromParent_Done,
     /* 1576471 */   // Label 21813: @1576471
     /* 1576471 */   GIM_Try, /*On fail goto*//*Label 21814*/ GIMT_Encode4(1576553), // Rule ID 4236 //
     /* 1576476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1576493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1576496 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576507 */     // MIs[0] passthru
     /* 1576507 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576520 */     // MIs[0] policy
     /* 1576520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576530 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1576533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576552 */     // GIR_Coverage, 4236,
     /* 1576552 */     GIR_EraseRootFromParent_Done,
     /* 1576553 */   // Label 21814: @1576553
     /* 1576553 */   GIM_Try, /*On fail goto*//*Label 21815*/ GIMT_Encode4(1576635), // Rule ID 4237 //
     /* 1576558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1576569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1576572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1576575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1576578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1576585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576589 */     // MIs[0] passthru
     /* 1576589 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576602 */     // MIs[0] policy
     /* 1576602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1576615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576634 */     // GIR_Coverage, 4237,
     /* 1576634 */     GIR_EraseRootFromParent_Done,
     /* 1576635 */   // Label 21815: @1576635
     /* 1576635 */   GIM_Try, /*On fail goto*//*Label 21816*/ GIMT_Encode4(1576717), // Rule ID 4246 //
     /* 1576640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1576657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1576660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576671 */     // MIs[0] passthru
     /* 1576671 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576684 */     // MIs[0] policy
     /* 1576684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576694 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1576697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576716 */     // GIR_Coverage, 4246,
     /* 1576716 */     GIR_EraseRootFromParent_Done,
     /* 1576717 */   // Label 21816: @1576717
     /* 1576717 */   GIM_Try, /*On fail goto*//*Label 21817*/ GIMT_Encode4(1576799), // Rule ID 4247 //
     /* 1576722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1576733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1576736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1576739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1576742 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1576749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576753 */     // MIs[0] passthru
     /* 1576753 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1576762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576766 */     // MIs[0] policy
     /* 1576766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1576779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576798 */     // GIR_Coverage, 4247,
     /* 1576798 */     GIR_EraseRootFromParent_Done,
     /* 1576799 */   // Label 21817: @1576799
     /* 1576799 */   GIM_Try, /*On fail goto*//*Label 21818*/ GIMT_Encode4(1576881), // Rule ID 4256 //
     /* 1576804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1576807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1576815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1576818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1576821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1576824 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1576831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576835 */     // MIs[0] passthru
     /* 1576835 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576848 */     // MIs[0] policy
     /* 1576848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1576858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1576861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576880 */     // GIR_Coverage, 4256,
     /* 1576880 */     GIR_EraseRootFromParent_Done,
     /* 1576881 */   // Label 21818: @1576881
     /* 1576881 */   GIM_Try, /*On fail goto*//*Label 21819*/ GIMT_Encode4(1576963), // Rule ID 4257 //
     /* 1576886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1576889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1576897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1576900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1576903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1576906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1576909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1576913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1576917 */     // MIs[0] passthru
     /* 1576917 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1576922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1576926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1576930 */     // MIs[0] policy
     /* 1576930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1576933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1576940 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1576940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1576943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1576945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1576947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1576949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1576951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1576956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1576959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1576961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1576962 */     // GIR_Coverage, 4257,
     /* 1576962 */     GIR_EraseRootFromParent_Done,
     /* 1576963 */   // Label 21819: @1576963
     /* 1576963 */   GIM_Try, /*On fail goto*//*Label 21820*/ GIMT_Encode4(1577045), // Rule ID 4266 //
     /* 1576968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1576971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1576976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1576979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1576982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1576985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1576988 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1576991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1576995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1576999 */     // MIs[0] passthru
     /* 1576999 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577012 */     // MIs[0] policy
     /* 1577012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577022 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1577025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577044 */     // GIR_Coverage, 4266,
     /* 1577044 */     GIR_EraseRootFromParent_Done,
     /* 1577045 */   // Label 21820: @1577045
     /* 1577045 */   GIM_Try, /*On fail goto*//*Label 21821*/ GIMT_Encode4(1577127), // Rule ID 4267 //
     /* 1577050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1577053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1577061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1577064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1577067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577081 */     // MIs[0] passthru
     /* 1577081 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577094 */     // MIs[0] policy
     /* 1577094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577104 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK_TIED),
     /* 1577107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577126 */     // GIR_Coverage, 4267,
     /* 1577126 */     GIR_EraseRootFromParent_Done,
     /* 1577127 */   // Label 21821: @1577127
     /* 1577127 */   GIM_Try, /*On fail goto*//*Label 21822*/ GIMT_Encode4(1577209), // Rule ID 4276 //
     /* 1577132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1577135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1577143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1577146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1577149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577163 */     // MIs[0] passthru
     /* 1577163 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577176 */     // MIs[0] policy
     /* 1577176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577186 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1577189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577208 */     // GIR_Coverage, 4276,
     /* 1577208 */     GIR_EraseRootFromParent_Done,
     /* 1577209 */   // Label 21822: @1577209
     /* 1577209 */   GIM_Try, /*On fail goto*//*Label 21823*/ GIMT_Encode4(1577291), // Rule ID 4277 //
     /* 1577214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1577217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1577225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1577228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1577231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577234 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1577241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577245 */     // MIs[0] passthru
     /* 1577245 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577258 */     // MIs[0] policy
     /* 1577258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577268 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK_TIED),
     /* 1577271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577290 */     // GIR_Coverage, 4277,
     /* 1577290 */     GIR_EraseRootFromParent_Done,
     /* 1577291 */   // Label 21823: @1577291
     /* 1577291 */   GIM_Try, /*On fail goto*//*Label 21824*/ GIMT_Encode4(1577373), // Rule ID 4286 //
     /* 1577296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1577299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1577307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1577310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1577313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1577316 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577327 */     // MIs[0] passthru
     /* 1577327 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577340 */     // MIs[0] policy
     /* 1577340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577350 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1577353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577372 */     // GIR_Coverage, 4286,
     /* 1577372 */     GIR_EraseRootFromParent_Done,
     /* 1577373 */   // Label 21824: @1577373
     /* 1577373 */   GIM_Try, /*On fail goto*//*Label 21825*/ GIMT_Encode4(1577455), // Rule ID 4287 //
     /* 1577378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1577381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1577389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1577392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1577395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1577398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1577405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577409 */     // MIs[0] passthru
     /* 1577409 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1577418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577422 */     // MIs[0] policy
     /* 1577422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577432 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK_TIED),
     /* 1577435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577454 */     // GIR_Coverage, 4287,
     /* 1577454 */     GIR_EraseRootFromParent_Done,
     /* 1577455 */   // Label 21825: @1577455
     /* 1577455 */   GIM_Try, /*On fail goto*//*Label 21826*/ GIMT_Encode4(1577537), // Rule ID 4296 //
     /* 1577460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1577463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1577471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1577474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1577477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577491 */     // MIs[0] passthru
     /* 1577491 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577504 */     // MIs[0] policy
     /* 1577504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577514 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1577517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577536 */     // GIR_Coverage, 4296,
     /* 1577536 */     GIR_EraseRootFromParent_Done,
     /* 1577537 */   // Label 21826: @1577537
     /* 1577537 */   GIM_Try, /*On fail goto*//*Label 21827*/ GIMT_Encode4(1577619), // Rule ID 4297 //
     /* 1577542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1577545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1577550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1577553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1577556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1577559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1577562 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1577569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1577573 */     // MIs[0] passthru
     /* 1577573 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1577582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577586 */     // MIs[0] policy
     /* 1577586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577596 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK_TIED),
     /* 1577599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1577615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577618 */     // GIR_Coverage, 4297,
     /* 1577618 */     GIR_EraseRootFromParent_Done,
     /* 1577619 */   // Label 21827: @1577619
     /* 1577619 */   GIM_Try, /*On fail goto*//*Label 21828*/ GIMT_Encode4(1577701), // Rule ID 4366 //
     /* 1577624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1577632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1577641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577655 */     // MIs[0] passthru
     /* 1577655 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577668 */     // MIs[0] policy
     /* 1577668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1577681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577700 */     // GIR_Coverage, 4366,
     /* 1577700 */     GIR_EraseRootFromParent_Done,
     /* 1577701 */   // Label 21828: @1577701
     /* 1577701 */   GIM_Try, /*On fail goto*//*Label 21829*/ GIMT_Encode4(1577783), // Rule ID 4367 //
     /* 1577706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1577714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1577717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1577720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1577723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1577726 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577737 */     // MIs[0] passthru
     /* 1577737 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577750 */     // MIs[0] policy
     /* 1577750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK_TIED),
     /* 1577763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577782 */     // GIR_Coverage, 4367,
     /* 1577782 */     GIR_EraseRootFromParent_Done,
     /* 1577783 */   // Label 21829: @1577783
     /* 1577783 */   GIM_Try, /*On fail goto*//*Label 21830*/ GIMT_Encode4(1577865), // Rule ID 4376 //
     /* 1577788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1577796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1577805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577808 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577819 */     // MIs[0] passthru
     /* 1577819 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577832 */     // MIs[0] policy
     /* 1577832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1577842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1577845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577864 */     // GIR_Coverage, 4376,
     /* 1577864 */     GIR_EraseRootFromParent_Done,
     /* 1577865 */   // Label 21830: @1577865
     /* 1577865 */   GIM_Try, /*On fail goto*//*Label 21831*/ GIMT_Encode4(1577947), // Rule ID 4377 //
     /* 1577870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1577873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1577878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1577881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1577884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1577887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1577890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1577893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577901 */     // MIs[0] passthru
     /* 1577901 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577914 */     // MIs[0] policy
     /* 1577914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1577924 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1577924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1577927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1577929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1577931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1577933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1577935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1577940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1577943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1577945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1577946 */     // GIR_Coverage, 4377,
     /* 1577946 */     GIR_EraseRootFromParent_Done,
     /* 1577947 */   // Label 21831: @1577947
     /* 1577947 */   GIM_Try, /*On fail goto*//*Label 21832*/ GIMT_Encode4(1578029), // Rule ID 4386 //
     /* 1577952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1577955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1577960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1577963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1577966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1577969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1577972 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1577975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1577979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577983 */     // MIs[0] passthru
     /* 1577983 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1577988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1577992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1577996 */     // MIs[0] policy
     /* 1577996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1577999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578006 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1578009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578028 */     // GIR_Coverage, 4386,
     /* 1578028 */     GIR_EraseRootFromParent_Done,
     /* 1578029 */   // Label 21832: @1578029
     /* 1578029 */   GIM_Try, /*On fail goto*//*Label 21833*/ GIMT_Encode4(1578111), // Rule ID 4387 //
     /* 1578034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1578045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1578048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1578051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578065 */     // MIs[0] passthru
     /* 1578065 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578078 */     // MIs[0] policy
     /* 1578078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578088 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1578091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578110 */     // GIR_Coverage, 4387,
     /* 1578110 */     GIR_EraseRootFromParent_Done,
     /* 1578111 */   // Label 21833: @1578111
     /* 1578111 */   GIM_Try, /*On fail goto*//*Label 21834*/ GIMT_Encode4(1578193), // Rule ID 4396 //
     /* 1578116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1578133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578147 */     // MIs[0] passthru
     /* 1578147 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578160 */     // MIs[0] policy
     /* 1578160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1578173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578192 */     // GIR_Coverage, 4396,
     /* 1578192 */     GIR_EraseRootFromParent_Done,
     /* 1578193 */   // Label 21834: @1578193
     /* 1578193 */   GIM_Try, /*On fail goto*//*Label 21835*/ GIMT_Encode4(1578275), // Rule ID 4397 //
     /* 1578198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1578209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1578212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1578215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1578218 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578229 */     // MIs[0] passthru
     /* 1578229 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578242 */     // MIs[0] policy
     /* 1578242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1578255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578274 */     // GIR_Coverage, 4397,
     /* 1578274 */     GIR_EraseRootFromParent_Done,
     /* 1578275 */   // Label 21835: @1578275
     /* 1578275 */   GIM_Try, /*On fail goto*//*Label 21836*/ GIMT_Encode4(1578357), // Rule ID 4406 //
     /* 1578280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1578297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578300 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578311 */     // MIs[0] passthru
     /* 1578311 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578324 */     // MIs[0] policy
     /* 1578324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578334 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1578337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578356 */     // GIR_Coverage, 4406,
     /* 1578356 */     GIR_EraseRootFromParent_Done,
     /* 1578357 */   // Label 21836: @1578357
     /* 1578357 */   GIM_Try, /*On fail goto*//*Label 21837*/ GIMT_Encode4(1578439), // Rule ID 4407 //
     /* 1578362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1578373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1578376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1578379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1578382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1578389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578393 */     // MIs[0] passthru
     /* 1578393 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578406 */     // MIs[0] policy
     /* 1578406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578416 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1578419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578438 */     // GIR_Coverage, 4407,
     /* 1578438 */     GIR_EraseRootFromParent_Done,
     /* 1578439 */   // Label 21837: @1578439
     /* 1578439 */   GIM_Try, /*On fail goto*//*Label 21838*/ GIMT_Encode4(1578521), // Rule ID 4416 //
     /* 1578444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1578455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1578458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1578461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1578464 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578475 */     // MIs[0] passthru
     /* 1578475 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578488 */     // MIs[0] policy
     /* 1578488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578498 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1578501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578520 */     // GIR_Coverage, 4416,
     /* 1578520 */     GIR_EraseRootFromParent_Done,
     /* 1578521 */   // Label 21838: @1578521
     /* 1578521 */   GIM_Try, /*On fail goto*//*Label 21839*/ GIMT_Encode4(1578603), // Rule ID 4417 //
     /* 1578526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1578537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1578540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1578543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1578546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1578553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1578557 */     // MIs[0] passthru
     /* 1578557 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1578566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578570 */     // MIs[0] policy
     /* 1578570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578580 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1578583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1578599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578602 */     // GIR_Coverage, 4417,
     /* 1578602 */     GIR_EraseRootFromParent_Done,
     /* 1578603 */   // Label 21839: @1578603
     /* 1578603 */   GIM_Try, /*On fail goto*//*Label 21840*/ GIMT_Encode4(1578685), // Rule ID 4426 //
     /* 1578608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1578625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578639 */     // MIs[0] passthru
     /* 1578639 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578652 */     // MIs[0] policy
     /* 1578652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1578665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578684 */     // GIR_Coverage, 4426,
     /* 1578684 */     GIR_EraseRootFromParent_Done,
     /* 1578685 */   // Label 21840: @1578685
     /* 1578685 */   GIM_Try, /*On fail goto*//*Label 21841*/ GIMT_Encode4(1578767), // Rule ID 4427 //
     /* 1578690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1578701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1578704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1578707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1578710 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578721 */     // MIs[0] passthru
     /* 1578721 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578734 */     // MIs[0] policy
     /* 1578734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578744 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK_TIED),
     /* 1578747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578766 */     // GIR_Coverage, 4427,
     /* 1578766 */     GIR_EraseRootFromParent_Done,
     /* 1578767 */   // Label 21841: @1578767
     /* 1578767 */   GIM_Try, /*On fail goto*//*Label 21842*/ GIMT_Encode4(1578849), // Rule ID 4436 //
     /* 1578772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1578789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578792 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578803 */     // MIs[0] passthru
     /* 1578803 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578816 */     // MIs[0] policy
     /* 1578816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578826 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1578829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578848 */     // GIR_Coverage, 4436,
     /* 1578848 */     GIR_EraseRootFromParent_Done,
     /* 1578849 */   // Label 21842: @1578849
     /* 1578849 */   GIM_Try, /*On fail goto*//*Label 21843*/ GIMT_Encode4(1578931), // Rule ID 4437 //
     /* 1578854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1578857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1578865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1578868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1578871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1578874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1578877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1578881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578885 */     // MIs[0] passthru
     /* 1578885 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578898 */     // MIs[0] policy
     /* 1578898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578908 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1578908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1578911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1578919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1578924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1578927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1578929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1578930 */     // GIR_Coverage, 4437,
     /* 1578930 */     GIR_EraseRootFromParent_Done,
     /* 1578931 */   // Label 21843: @1578931
     /* 1578931 */   GIM_Try, /*On fail goto*//*Label 21844*/ GIMT_Encode4(1579013), // Rule ID 4446 //
     /* 1578936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1578939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1578944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1578947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1578950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1578953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1578956 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1578959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1578963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1578967 */     // MIs[0] passthru
     /* 1578967 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1578972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1578976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1578980 */     // MIs[0] policy
     /* 1578980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1578983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1578990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1578990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1578993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1578995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1578997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1578999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579012 */     // GIR_Coverage, 4446,
     /* 1579012 */     GIR_EraseRootFromParent_Done,
     /* 1579013 */   // Label 21844: @1579013
     /* 1579013 */   GIM_Try, /*On fail goto*//*Label 21845*/ GIMT_Encode4(1579095), // Rule ID 4447 //
     /* 1579018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1579029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1579032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1579035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579038 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579049 */     // MIs[0] passthru
     /* 1579049 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579062 */     // MIs[0] policy
     /* 1579062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1579075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579094 */     // GIR_Coverage, 4447,
     /* 1579094 */     GIR_EraseRootFromParent_Done,
     /* 1579095 */   // Label 21845: @1579095
     /* 1579095 */   GIM_Try, /*On fail goto*//*Label 21846*/ GIMT_Encode4(1579177), // Rule ID 4456 //
     /* 1579100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1579117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579131 */     // MIs[0] passthru
     /* 1579131 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579144 */     // MIs[0] policy
     /* 1579144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579154 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1579157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579176 */     // GIR_Coverage, 4456,
     /* 1579176 */     GIR_EraseRootFromParent_Done,
     /* 1579177 */   // Label 21846: @1579177
     /* 1579177 */   GIM_Try, /*On fail goto*//*Label 21847*/ GIMT_Encode4(1579259), // Rule ID 4457 //
     /* 1579182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1579193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1579196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1579199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579213 */     // MIs[0] passthru
     /* 1579213 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579226 */     // MIs[0] policy
     /* 1579226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1579239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579258 */     // GIR_Coverage, 4457,
     /* 1579258 */     GIR_EraseRootFromParent_Done,
     /* 1579259 */   // Label 21847: @1579259
     /* 1579259 */   GIM_Try, /*On fail goto*//*Label 21848*/ GIMT_Encode4(1579341), // Rule ID 4466 //
     /* 1579264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1579267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1579275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1579278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1579281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1579284 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579295 */     // MIs[0] passthru
     /* 1579295 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579308 */     // MIs[0] policy
     /* 1579308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579318 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1579321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579340 */     // GIR_Coverage, 4466,
     /* 1579340 */     GIR_EraseRootFromParent_Done,
     /* 1579341 */   // Label 21848: @1579341
     /* 1579341 */   GIM_Try, /*On fail goto*//*Label 21849*/ GIMT_Encode4(1579423), // Rule ID 4467 //
     /* 1579346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1579349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1579357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1579360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1579363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1579366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579377 */     // MIs[0] passthru
     /* 1579377 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579390 */     // MIs[0] policy
     /* 1579390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1579403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1579419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579422 */     // GIR_Coverage, 4467,
     /* 1579422 */     GIR_EraseRootFromParent_Done,
     /* 1579423 */   // Label 21849: @1579423
     /* 1579423 */   GIM_Try, /*On fail goto*//*Label 21850*/ GIMT_Encode4(1579505), // Rule ID 4476 //
     /* 1579428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1579439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1579442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1579445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579448 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579459 */     // MIs[0] passthru
     /* 1579459 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579472 */     // MIs[0] policy
     /* 1579472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579482 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1579485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579504 */     // GIR_Coverage, 4476,
     /* 1579504 */     GIR_EraseRootFromParent_Done,
     /* 1579505 */   // Label 21850: @1579505
     /* 1579505 */   GIM_Try, /*On fail goto*//*Label 21851*/ GIMT_Encode4(1579587), // Rule ID 4477 //
     /* 1579510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1579521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1579524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1579527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1579530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1579537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579541 */     // MIs[0] passthru
     /* 1579541 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579554 */     // MIs[0] policy
     /* 1579554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579564 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK_TIED),
     /* 1579567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579586 */     // GIR_Coverage, 4477,
     /* 1579586 */     GIR_EraseRootFromParent_Done,
     /* 1579587 */   // Label 21851: @1579587
     /* 1579587 */   GIM_Try, /*On fail goto*//*Label 21852*/ GIMT_Encode4(1579669), // Rule ID 4486 //
     /* 1579592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1579603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1579606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1579609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579623 */     // MIs[0] passthru
     /* 1579623 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579636 */     // MIs[0] policy
     /* 1579636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579646 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1579649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579668 */     // GIR_Coverage, 4486,
     /* 1579668 */     GIR_EraseRootFromParent_Done,
     /* 1579669 */   // Label 21852: @1579669
     /* 1579669 */   GIM_Try, /*On fail goto*//*Label 21853*/ GIMT_Encode4(1579751), // Rule ID 4487 //
     /* 1579674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1579685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1579688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1579691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1579694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1579701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579705 */     // MIs[0] passthru
     /* 1579705 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1579714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579718 */     // MIs[0] policy
     /* 1579718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK_TIED),
     /* 1579731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579750 */     // GIR_Coverage, 4487,
     /* 1579750 */     GIR_EraseRootFromParent_Done,
     /* 1579751 */   // Label 21853: @1579751
     /* 1579751 */   GIM_Try, /*On fail goto*//*Label 21854*/ GIMT_Encode4(1579833), // Rule ID 4496 //
     /* 1579756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1579767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1579770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1579773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579787 */     // MIs[0] passthru
     /* 1579787 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579800 */     // MIs[0] policy
     /* 1579800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579810 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1579813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579832 */     // GIR_Coverage, 4496,
     /* 1579832 */     GIR_EraseRootFromParent_Done,
     /* 1579833 */   // Label 21854: @1579833
     /* 1579833 */   GIM_Try, /*On fail goto*//*Label 21855*/ GIMT_Encode4(1579915), // Rule ID 4497 //
     /* 1579838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1579841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1579849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1579852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1579855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1579858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1579861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1579865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579869 */     // MIs[0] passthru
     /* 1579869 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1579878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579882 */     // MIs[0] policy
     /* 1579882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579892 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1579892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK_TIED),
     /* 1579895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579914 */     // GIR_Coverage, 4497,
     /* 1579914 */     GIR_EraseRootFromParent_Done,
     /* 1579915 */   // Label 21855: @1579915
     /* 1579915 */   GIM_Try, /*On fail goto*//*Label 21856*/ GIMT_Encode4(1579997), // Rule ID 4506 //
     /* 1579920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1579923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1579928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1579931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1579934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1579937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1579940 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1579943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1579947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1579951 */     // MIs[0] passthru
     /* 1579951 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1579956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1579960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1579964 */     // MIs[0] policy
     /* 1579964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1579967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1579974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1579974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1579977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1579979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1579981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1579983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1579985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1579990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1579993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1579995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1579996 */     // GIR_Coverage, 4506,
     /* 1579996 */     GIR_EraseRootFromParent_Done,
     /* 1579997 */   // Label 21856: @1579997
     /* 1579997 */   GIM_Try, /*On fail goto*//*Label 21857*/ GIMT_Encode4(1580079), // Rule ID 4507 //
     /* 1580002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1580005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1580010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1580013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1580016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1580019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580033 */     // MIs[0] passthru
     /* 1580033 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580046 */     // MIs[0] policy
     /* 1580046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK_TIED),
     /* 1580059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1580075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580078 */     // GIR_Coverage, 4507,
     /* 1580078 */     GIR_EraseRootFromParent_Done,
     /* 1580079 */   // Label 21857: @1580079
     /* 1580079 */   GIM_Try, /*On fail goto*//*Label 21858*/ GIMT_Encode4(1580161), // Rule ID 4576 //
     /* 1580084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1580095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1580098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1580101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580104 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580115 */     // MIs[0] passthru
     /* 1580115 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580128 */     // MIs[0] policy
     /* 1580128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580138 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1580141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580160 */     // GIR_Coverage, 4576,
     /* 1580160 */     GIR_EraseRootFromParent_Done,
     /* 1580161 */   // Label 21858: @1580161
     /* 1580161 */   GIM_Try, /*On fail goto*//*Label 21859*/ GIMT_Encode4(1580243), // Rule ID 4577 //
     /* 1580166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1580177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1580180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1580183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1580186 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580197 */     // MIs[0] passthru
     /* 1580197 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580210 */     // MIs[0] policy
     /* 1580210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580220 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK_TIED:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK_TIED),
     /* 1580223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580242 */     // GIR_Coverage, 4577,
     /* 1580242 */     GIR_EraseRootFromParent_Done,
     /* 1580243 */   // Label 21859: @1580243
     /* 1580243 */   GIM_Try, /*On fail goto*//*Label 21860*/ GIMT_Encode4(1580325), // Rule ID 4586 //
     /* 1580248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1580265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580279 */     // MIs[0] passthru
     /* 1580279 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580292 */     // MIs[0] policy
     /* 1580292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1580305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580324 */     // GIR_Coverage, 4586,
     /* 1580324 */     GIR_EraseRootFromParent_Done,
     /* 1580325 */   // Label 21860: @1580325
     /* 1580325 */   GIM_Try, /*On fail goto*//*Label 21861*/ GIMT_Encode4(1580407), // Rule ID 4587 //
     /* 1580330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1580341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1580344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1580347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1580350 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580361 */     // MIs[0] passthru
     /* 1580361 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580374 */     // MIs[0] policy
     /* 1580374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580384 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1580387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580406 */     // GIR_Coverage, 4587,
     /* 1580406 */     GIR_EraseRootFromParent_Done,
     /* 1580407 */   // Label 21861: @1580407
     /* 1580407 */   GIM_Try, /*On fail goto*//*Label 21862*/ GIMT_Encode4(1580489), // Rule ID 4596 //
     /* 1580412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580432 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580443 */     // MIs[0] passthru
     /* 1580443 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580456 */     // MIs[0] policy
     /* 1580456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1580469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580488 */     // GIR_Coverage, 4596,
     /* 1580488 */     GIR_EraseRootFromParent_Done,
     /* 1580489 */   // Label 21862: @1580489
     /* 1580489 */   GIM_Try, /*On fail goto*//*Label 21863*/ GIMT_Encode4(1580571), // Rule ID 4597 //
     /* 1580494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1580505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1580508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1580511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1580514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1580521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580525 */     // MIs[0] passthru
     /* 1580525 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580538 */     // MIs[0] policy
     /* 1580538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580548 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1580551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580570 */     // GIR_Coverage, 4597,
     /* 1580570 */     GIR_EraseRootFromParent_Done,
     /* 1580571 */   // Label 21863: @1580571
     /* 1580571 */   GIM_Try, /*On fail goto*//*Label 21864*/ GIMT_Encode4(1580653), // Rule ID 4606 //
     /* 1580576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580596 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580607 */     // MIs[0] passthru
     /* 1580607 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580620 */     // MIs[0] policy
     /* 1580620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1580633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580652 */     // GIR_Coverage, 4606,
     /* 1580652 */     GIR_EraseRootFromParent_Done,
     /* 1580653 */   // Label 21864: @1580653
     /* 1580653 */   GIM_Try, /*On fail goto*//*Label 21865*/ GIMT_Encode4(1580735), // Rule ID 4607 //
     /* 1580658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1580669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1580672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1580675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1580678 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1580685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580689 */     // MIs[0] passthru
     /* 1580689 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1580698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580702 */     // MIs[0] policy
     /* 1580702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1580715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580734 */     // GIR_Coverage, 4607,
     /* 1580734 */     GIR_EraseRootFromParent_Done,
     /* 1580735 */   // Label 21865: @1580735
     /* 1580735 */   GIM_Try, /*On fail goto*//*Label 21866*/ GIMT_Encode4(1580817), // Rule ID 4616 //
     /* 1580740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580771 */     // MIs[0] passthru
     /* 1580771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580784 */     // MIs[0] policy
     /* 1580784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580794 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1580797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580816 */     // GIR_Coverage, 4616,
     /* 1580816 */     GIR_EraseRootFromParent_Done,
     /* 1580817 */   // Label 21866: @1580817
     /* 1580817 */   GIM_Try, /*On fail goto*//*Label 21867*/ GIMT_Encode4(1580899), // Rule ID 4617 //
     /* 1580822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1580833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1580836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1580839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1580842 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1580845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1580849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580853 */     // MIs[0] passthru
     /* 1580853 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1580862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580866 */     // MIs[0] policy
     /* 1580866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580876 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1580876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1580879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580898 */     // GIR_Coverage, 4617,
     /* 1580898 */     GIR_EraseRootFromParent_Done,
     /* 1580899 */   // Label 21867: @1580899
     /* 1580899 */   GIM_Try, /*On fail goto*//*Label 21868*/ GIMT_Encode4(1580981), // Rule ID 4626 //
     /* 1580904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1580907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1580918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1580921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1580924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1580927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1580931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1580935 */     // MIs[0] passthru
     /* 1580935 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1580940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1580944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1580948 */     // MIs[0] policy
     /* 1580948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1580951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1580958 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1580958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1580961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1580963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1580965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1580967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1580969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1580974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1580977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1580979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1580980 */     // GIR_Coverage, 4626,
     /* 1580980 */     GIR_EraseRootFromParent_Done,
     /* 1580981 */   // Label 21868: @1580981
     /* 1580981 */   GIM_Try, /*On fail goto*//*Label 21869*/ GIMT_Encode4(1581063), // Rule ID 4627 //
     /* 1580986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1580989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1580994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1580997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1581000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1581003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1581006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581017 */     // MIs[0] passthru
     /* 1581017 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581030 */     // MIs[0] policy
     /* 1581030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1581043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1581059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581062 */     // GIR_Coverage, 4627,
     /* 1581062 */     GIR_EraseRootFromParent_Done,
     /* 1581063 */   // Label 21869: @1581063
     /* 1581063 */   GIM_Try, /*On fail goto*//*Label 21870*/ GIMT_Encode4(1581145), // Rule ID 4636 //
     /* 1581068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1581085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581088 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581099 */     // MIs[0] passthru
     /* 1581099 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581112 */     // MIs[0] policy
     /* 1581112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1581125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581144 */     // GIR_Coverage, 4636,
     /* 1581144 */     GIR_EraseRootFromParent_Done,
     /* 1581145 */   // Label 21870: @1581145
     /* 1581145 */   GIM_Try, /*On fail goto*//*Label 21871*/ GIMT_Encode4(1581227), // Rule ID 4637 //
     /* 1581150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1581161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1581164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1581167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581170 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581181 */     // MIs[0] passthru
     /* 1581181 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581194 */     // MIs[0] policy
     /* 1581194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581204 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK_TIED:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK_TIED),
     /* 1581207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581226 */     // GIR_Coverage, 4637,
     /* 1581226 */     GIR_EraseRootFromParent_Done,
     /* 1581227 */   // Label 21871: @1581227
     /* 1581227 */   GIM_Try, /*On fail goto*//*Label 21872*/ GIMT_Encode4(1581309), // Rule ID 4646 //
     /* 1581232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1581249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581263 */     // MIs[0] passthru
     /* 1581263 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581276 */     // MIs[0] policy
     /* 1581276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581286 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1581289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581308 */     // GIR_Coverage, 4646,
     /* 1581308 */     GIR_EraseRootFromParent_Done,
     /* 1581309 */   // Label 21872: @1581309
     /* 1581309 */   GIM_Try, /*On fail goto*//*Label 21873*/ GIMT_Encode4(1581391), // Rule ID 4647 //
     /* 1581314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1581325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1581328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1581331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1581334 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581345 */     // MIs[0] passthru
     /* 1581345 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581358 */     // MIs[0] policy
     /* 1581358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581368 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1581371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581390 */     // GIR_Coverage, 4647,
     /* 1581390 */     GIR_EraseRootFromParent_Done,
     /* 1581391 */   // Label 21873: @1581391
     /* 1581391 */   GIM_Try, /*On fail goto*//*Label 21874*/ GIMT_Encode4(1581473), // Rule ID 4656 //
     /* 1581396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581416 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581427 */     // MIs[0] passthru
     /* 1581427 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581440 */     // MIs[0] policy
     /* 1581440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1581453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581472 */     // GIR_Coverage, 4656,
     /* 1581472 */     GIR_EraseRootFromParent_Done,
     /* 1581473 */   // Label 21874: @1581473
     /* 1581473 */   GIM_Try, /*On fail goto*//*Label 21875*/ GIMT_Encode4(1581555), // Rule ID 4657 //
     /* 1581478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1581489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1581492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1581495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1581498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1581505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581509 */     // MIs[0] passthru
     /* 1581509 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581522 */     // MIs[0] policy
     /* 1581522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581532 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1581535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581554 */     // GIR_Coverage, 4657,
     /* 1581554 */     GIR_EraseRootFromParent_Done,
     /* 1581555 */   // Label 21875: @1581555
     /* 1581555 */   GIM_Try, /*On fail goto*//*Label 21876*/ GIMT_Encode4(1581637), // Rule ID 4666 //
     /* 1581560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581580 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581591 */     // MIs[0] passthru
     /* 1581591 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581604 */     // MIs[0] policy
     /* 1581604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581614 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1581617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581636 */     // GIR_Coverage, 4666,
     /* 1581636 */     GIR_EraseRootFromParent_Done,
     /* 1581637 */   // Label 21876: @1581637
     /* 1581637 */   GIM_Try, /*On fail goto*//*Label 21877*/ GIMT_Encode4(1581719), // Rule ID 4667 //
     /* 1581642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1581653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1581656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1581659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1581662 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1581669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581673 */     // MIs[0] passthru
     /* 1581673 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1581682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581686 */     // MIs[0] policy
     /* 1581686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581696 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1581699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581718 */     // GIR_Coverage, 4667,
     /* 1581718 */     GIR_EraseRootFromParent_Done,
     /* 1581719 */   // Label 21877: @1581719
     /* 1581719 */   GIM_Try, /*On fail goto*//*Label 21878*/ GIMT_Encode4(1581801), // Rule ID 4676 //
     /* 1581724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1581727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581755 */     // MIs[0] passthru
     /* 1581755 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581768 */     // MIs[0] policy
     /* 1581768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1581781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581800 */     // GIR_Coverage, 4676,
     /* 1581800 */     GIR_EraseRootFromParent_Done,
     /* 1581801 */   // Label 21878: @1581801
     /* 1581801 */   GIM_Try, /*On fail goto*//*Label 21879*/ GIMT_Encode4(1581883), // Rule ID 4677 //
     /* 1581806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1581809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1581817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1581820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1581823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1581826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1581833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1581837 */     // MIs[0] passthru
     /* 1581837 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1581846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581850 */     // MIs[0] policy
     /* 1581850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581860 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1581860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1581863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1581879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581882 */     // GIR_Coverage, 4677,
     /* 1581882 */     GIR_EraseRootFromParent_Done,
     /* 1581883 */   // Label 21879: @1581883
     /* 1581883 */   GIM_Try, /*On fail goto*//*Label 21880*/ GIMT_Encode4(1581965), // Rule ID 4686 //
     /* 1581888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1581891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1581911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581919 */     // MIs[0] passthru
     /* 1581919 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1581924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1581928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1581932 */     // MIs[0] policy
     /* 1581932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1581935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1581942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1581942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1581945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1581947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1581949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1581951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1581953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1581958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1581961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1581963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1581964 */     // GIR_Coverage, 4686,
     /* 1581964 */     GIR_EraseRootFromParent_Done,
     /* 1581965 */   // Label 21880: @1581965
     /* 1581965 */   GIM_Try, /*On fail goto*//*Label 21881*/ GIMT_Encode4(1582047), // Rule ID 4687 //
     /* 1581970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1581973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1581978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1581981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1581984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1581987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1581990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1581993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1581997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582001 */     // MIs[0] passthru
     /* 1582001 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582014 */     // MIs[0] policy
     /* 1582014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582024 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK_TIED:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK_TIED),
     /* 1582027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582046 */     // GIR_Coverage, 4687,
     /* 1582046 */     GIR_EraseRootFromParent_Done,
     /* 1582047 */   // Label 21881: @1582047
     /* 1582047 */   GIM_Try, /*On fail goto*//*Label 21882*/ GIMT_Encode4(1582129), // Rule ID 4696 //
     /* 1582052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1582055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1582063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1582066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1582069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582072 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582083 */     // MIs[0] passthru
     /* 1582083 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582096 */     // MIs[0] policy
     /* 1582096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582106 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1582109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582128 */     // GIR_Coverage, 4696,
     /* 1582128 */     GIR_EraseRootFromParent_Done,
     /* 1582129 */   // Label 21882: @1582129
     /* 1582129 */   GIM_Try, /*On fail goto*//*Label 21883*/ GIMT_Encode4(1582211), // Rule ID 4697 //
     /* 1582134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1582137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1582145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1582148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1582151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1582154 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1582161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582165 */     // MIs[0] passthru
     /* 1582165 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582178 */     // MIs[0] policy
     /* 1582178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK_TIED:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK_TIED),
     /* 1582191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582210 */     // GIR_Coverage, 4697,
     /* 1582210 */     GIR_EraseRootFromParent_Done,
     /* 1582211 */   // Label 21883: @1582211
     /* 1582211 */   GIM_Try, /*On fail goto*//*Label 21884*/ GIMT_Encode4(1582293), // Rule ID 4706 //
     /* 1582216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1582219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1582227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1582230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1582233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582247 */     // MIs[0] passthru
     /* 1582247 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582260 */     // MIs[0] policy
     /* 1582260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1582273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582292 */     // GIR_Coverage, 4706,
     /* 1582292 */     GIR_EraseRootFromParent_Done,
     /* 1582293 */   // Label 21884: @1582293
     /* 1582293 */   GIM_Try, /*On fail goto*//*Label 21885*/ GIMT_Encode4(1582375), // Rule ID 4707 //
     /* 1582298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1582301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1582309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1582312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1582315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1582318 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1582325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582329 */     // MIs[0] passthru
     /* 1582329 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1582338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582342 */     // MIs[0] policy
     /* 1582342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK_TIED:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK_TIED),
     /* 1582355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582374 */     // GIR_Coverage, 4707,
     /* 1582374 */     GIR_EraseRootFromParent_Done,
     /* 1582375 */   // Label 21885: @1582375
     /* 1582375 */   GIM_Try, /*On fail goto*//*Label 21886*/ GIMT_Encode4(1582457), // Rule ID 4716 //
     /* 1582380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1582383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582400 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582411 */     // MIs[0] passthru
     /* 1582411 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582424 */     // MIs[0] policy
     /* 1582424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582434 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1582437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582456 */     // GIR_Coverage, 4716,
     /* 1582456 */     GIR_EraseRootFromParent_Done,
     /* 1582457 */   // Label 21886: @1582457
     /* 1582457 */   GIM_Try, /*On fail goto*//*Label 21887*/ GIMT_Encode4(1582539), // Rule ID 4717 //
     /* 1582462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1582465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1582470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1582473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1582476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1582479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1582482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1582489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1582493 */     // MIs[0] passthru
     /* 1582493 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 1582498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1582502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582506 */     // MIs[0] policy
     /* 1582506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582516 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK_TIED:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK_TIED),
     /* 1582519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1582535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582538 */     // GIR_Coverage, 4717,
     /* 1582538 */     GIR_EraseRootFromParent_Done,
     /* 1582539 */   // Label 21887: @1582539
     /* 1582539 */   GIM_Try, /*On fail goto*//*Label 21888*/ GIMT_Encode4(1582625), // Rule ID 2612 //
     /* 1582544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1582552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1582555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1582558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1582561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582590 */     // MIs[0] policy
     /* 1582590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582600 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1582603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582624 */     // GIR_Coverage, 2612,
     /* 1582624 */     GIR_EraseRootFromParent_Done,
     /* 1582625 */   // Label 21888: @1582625
     /* 1582625 */   GIM_Try, /*On fail goto*//*Label 21889*/ GIMT_Encode4(1582711), // Rule ID 2613 //
     /* 1582630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1582638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1582641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1582644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1582647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582676 */     // MIs[0] policy
     /* 1582676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582686 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF8_MASK),
     /* 1582689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582710 */     // GIR_Coverage, 2613,
     /* 1582710 */     GIR_EraseRootFromParent_Done,
     /* 1582711 */   // Label 21889: @1582711
     /* 1582711 */   GIM_Try, /*On fail goto*//*Label 21890*/ GIMT_Encode4(1582797), // Rule ID 2650 //
     /* 1582716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1582733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582762 */     // MIs[0] policy
     /* 1582762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582772 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1582775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582796 */     // GIR_Coverage, 2650,
     /* 1582796 */     GIR_EraseRootFromParent_Done,
     /* 1582797 */   // Label 21890: @1582797
     /* 1582797 */   GIM_Try, /*On fail goto*//*Label 21891*/ GIMT_Encode4(1582883), // Rule ID 2651 //
     /* 1582802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1582810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1582813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1582816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1582819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1582828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582848 */     // MIs[0] policy
     /* 1582848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582858 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1582858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF8_MASK),
     /* 1582861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1582865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582882 */     // GIR_Coverage, 2651,
     /* 1582882 */     GIR_EraseRootFromParent_Done,
     /* 1582883 */   // Label 21891: @1582883
     /* 1582883 */   GIM_Try, /*On fail goto*//*Label 21892*/ GIMT_Encode4(1582969), // Rule ID 2664 //
     /* 1582888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1582891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1582896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1582899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1582902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1582905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1582914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1582918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1582930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1582934 */     // MIs[0] policy
     /* 1582934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1582937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1582944 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1582944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1582947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1582949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1582951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1582953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1582955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1582957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1582962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1582965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1582967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1582968 */     // GIR_Coverage, 2664,
     /* 1582968 */     GIR_EraseRootFromParent_Done,
     /* 1582969 */   // Label 21892: @1582969
     /* 1582969 */   GIM_Try, /*On fail goto*//*Label 21893*/ GIMT_Encode4(1583055), // Rule ID 2665 //
     /* 1582974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1582977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1582982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1582985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1582988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1582991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1582994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1582997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583020 */     // MIs[0] policy
     /* 1583020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583030 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF8_MASK),
     /* 1583033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1583037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1583039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1583041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583054 */     // GIR_Coverage, 2665,
     /* 1583054 */     GIR_EraseRootFromParent_Done,
     /* 1583055 */   // Label 21893: @1583055
     /* 1583055 */   GIM_Try, /*On fail goto*//*Label 21894*/ GIMT_Encode4(1583141), // Rule ID 2684 //
     /* 1583060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1583071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1583074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1583077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583106 */     // MIs[0] policy
     /* 1583106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583116 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1583119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583140 */     // GIR_Coverage, 2684,
     /* 1583140 */     GIR_EraseRootFromParent_Done,
     /* 1583141 */   // Label 21894: @1583141
     /* 1583141 */   GIM_Try, /*On fail goto*//*Label 21895*/ GIMT_Encode4(1583227), // Rule ID 2685 //
     /* 1583146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1583157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1583160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1583163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1583166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583192 */     // MIs[0] policy
     /* 1583192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583202 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1583205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583226 */     // GIR_Coverage, 2685,
     /* 1583226 */     GIR_EraseRootFromParent_Done,
     /* 1583227 */   // Label 21895: @1583227
     /* 1583227 */   GIM_Try, /*On fail goto*//*Label 21896*/ GIMT_Encode4(1583313), // Rule ID 2692 //
     /* 1583232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1583243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1583246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1583249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583278 */     // MIs[0] policy
     /* 1583278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583288 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1583291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583312 */     // GIR_Coverage, 2692,
     /* 1583312 */     GIR_EraseRootFromParent_Done,
     /* 1583313 */   // Label 21896: @1583313
     /* 1583313 */   GIM_Try, /*On fail goto*//*Label 21897*/ GIMT_Encode4(1583399), // Rule ID 2693 //
     /* 1583318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1583329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1583332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1583335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1583338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583364 */     // MIs[0] policy
     /* 1583364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583374 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1583377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583398 */     // GIR_Coverage, 2693,
     /* 1583398 */     GIR_EraseRootFromParent_Done,
     /* 1583399 */   // Label 21897: @1583399
     /* 1583399 */   GIM_Try, /*On fail goto*//*Label 21898*/ GIMT_Encode4(1583485), // Rule ID 2700 //
     /* 1583404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1583415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1583418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1583421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583450 */     // MIs[0] policy
     /* 1583450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583460 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1583463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583484 */     // GIR_Coverage, 2700,
     /* 1583484 */     GIR_EraseRootFromParent_Done,
     /* 1583485 */   // Label 21898: @1583485
     /* 1583485 */   GIM_Try, /*On fail goto*//*Label 21899*/ GIMT_Encode4(1583571), // Rule ID 2701 //
     /* 1583490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1583501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1583504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1583507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1583510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1583513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583536 */     // MIs[0] policy
     /* 1583536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583546 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1583549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1583567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583570 */     // GIR_Coverage, 2701,
     /* 1583570 */     GIR_EraseRootFromParent_Done,
     /* 1583571 */   // Label 21899: @1583571
     /* 1583571 */   GIM_Try, /*On fail goto*//*Label 21900*/ GIMT_Encode4(1583657), // Rule ID 2708 //
     /* 1583576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1583593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583622 */     // MIs[0] policy
     /* 1583622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583632 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1583635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583656 */     // GIR_Coverage, 2708,
     /* 1583656 */     GIR_EraseRootFromParent_Done,
     /* 1583657 */   // Label 21900: @1583657
     /* 1583657 */   GIM_Try, /*On fail goto*//*Label 21901*/ GIMT_Encode4(1583743), // Rule ID 2709 //
     /* 1583662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1583673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1583676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1583679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1583682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583708 */     // MIs[0] policy
     /* 1583708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583718 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1583721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583742 */     // GIR_Coverage, 2709,
     /* 1583742 */     GIR_EraseRootFromParent_Done,
     /* 1583743 */   // Label 21901: @1583743
     /* 1583743 */   GIM_Try, /*On fail goto*//*Label 21902*/ GIMT_Encode4(1583829), // Rule ID 2716 //
     /* 1583748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1583765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583794 */     // MIs[0] policy
     /* 1583794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1583807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583828 */     // GIR_Coverage, 2716,
     /* 1583828 */     GIR_EraseRootFromParent_Done,
     /* 1583829 */   // Label 21902: @1583829
     /* 1583829 */   GIM_Try, /*On fail goto*//*Label 21903*/ GIMT_Encode4(1583915), // Rule ID 2717 //
     /* 1583834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1583837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1583845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1583848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1583851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1583854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1583857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1583860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583880 */     // MIs[0] policy
     /* 1583880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583890 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1583890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1583893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1583911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1583914 */     // GIR_Coverage, 2717,
     /* 1583914 */     GIR_EraseRootFromParent_Done,
     /* 1583915 */   // Label 21903: @1583915
     /* 1583915 */   GIM_Try, /*On fail goto*//*Label 21904*/ GIMT_Encode4(1584001), // Rule ID 2724 //
     /* 1583920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1583923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1583928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1583931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1583934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1583937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1583940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1583943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1583946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1583950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1583962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1583966 */     // MIs[0] policy
     /* 1583966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1583969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1583976 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1583976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1583979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1583981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1583983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1583985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1583987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1583989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1583994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1583997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1583999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584000 */     // GIR_Coverage, 2724,
     /* 1584000 */     GIR_EraseRootFromParent_Done,
     /* 1584001 */   // Label 21904: @1584001
     /* 1584001 */   GIM_Try, /*On fail goto*//*Label 21905*/ GIMT_Encode4(1584087), // Rule ID 2725 //
     /* 1584006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1584017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1584020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1584023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1584026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584052 */     // MIs[0] policy
     /* 1584052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584062 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1584065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584086 */     // GIR_Coverage, 2725,
     /* 1584086 */     GIR_EraseRootFromParent_Done,
     /* 1584087 */   // Label 21905: @1584087
     /* 1584087 */   GIM_Try, /*On fail goto*//*Label 21906*/ GIMT_Encode4(1584173), // Rule ID 2732 //
     /* 1584092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1584103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1584106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1584109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584138 */     // MIs[0] policy
     /* 1584138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584148 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584172 */     // GIR_Coverage, 2732,
     /* 1584172 */     GIR_EraseRootFromParent_Done,
     /* 1584173 */   // Label 21906: @1584173
     /* 1584173 */   GIM_Try, /*On fail goto*//*Label 21907*/ GIMT_Encode4(1584259), // Rule ID 2733 //
     /* 1584178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1584189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1584192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1584195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1584198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1584201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584224 */     // MIs[0] policy
     /* 1584224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584234 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584258 */     // GIR_Coverage, 2733,
     /* 1584258 */     GIR_EraseRootFromParent_Done,
     /* 1584259 */   // Label 21907: @1584259
     /* 1584259 */   GIM_Try, /*On fail goto*//*Label 21908*/ GIMT_Encode4(1584345), // Rule ID 2740 //
     /* 1584264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1584281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584310 */     // MIs[0] policy
     /* 1584310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584320 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584344 */     // GIR_Coverage, 2740,
     /* 1584344 */     GIR_EraseRootFromParent_Done,
     /* 1584345 */   // Label 21908: @1584345
     /* 1584345 */   GIM_Try, /*On fail goto*//*Label 21909*/ GIMT_Encode4(1584431), // Rule ID 2741 //
     /* 1584350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1584361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1584364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1584367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1584370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1584373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584396 */     // MIs[0] policy
     /* 1584396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1584427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584430 */     // GIR_Coverage, 2741,
     /* 1584430 */     GIR_EraseRootFromParent_Done,
     /* 1584431 */   // Label 21909: @1584431
     /* 1584431 */   GIM_Try, /*On fail goto*//*Label 21910*/ GIMT_Encode4(1584517), // Rule ID 2748 //
     /* 1584436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1584453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584482 */     // MIs[0] policy
     /* 1584482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584492 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584516 */     // GIR_Coverage, 2748,
     /* 1584516 */     GIR_EraseRootFromParent_Done,
     /* 1584517 */   // Label 21910: @1584517
     /* 1584517 */   GIM_Try, /*On fail goto*//*Label 21911*/ GIMT_Encode4(1584603), // Rule ID 2749 //
     /* 1584522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1584533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1584536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1584539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1584542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1584545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584568 */     // MIs[0] policy
     /* 1584568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584578 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1584599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584602 */     // GIR_Coverage, 2749,
     /* 1584602 */     GIR_EraseRootFromParent_Done,
     /* 1584603 */   // Label 21911: @1584603
     /* 1584603 */   GIM_Try, /*On fail goto*//*Label 21912*/ GIMT_Encode4(1584689), // Rule ID 2756 //
     /* 1584608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1584611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1584625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1584628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584654 */     // MIs[0] policy
     /* 1584654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584664 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1584685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584688 */     // GIR_Coverage, 2756,
     /* 1584688 */     GIR_EraseRootFromParent_Done,
     /* 1584689 */   // Label 21912: @1584689
     /* 1584689 */   GIM_Try, /*On fail goto*//*Label 21913*/ GIMT_Encode4(1584775), // Rule ID 2757 //
     /* 1584694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1584697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1584705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1584708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1584711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1584714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1584717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1584724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1584736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584740 */     // MIs[0] policy
     /* 1584740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584750 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1584753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1584771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584774 */     // GIR_Coverage, 2757,
     /* 1584774 */     GIR_EraseRootFromParent_Done,
     /* 1584775 */   // Label 21913: @1584775
     /* 1584775 */   GIM_Try, /*On fail goto*//*Label 21914*/ GIMT_Encode4(1584861), // Rule ID 2764 //
     /* 1584780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1584791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1584794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1584797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584826 */     // MIs[0] policy
     /* 1584826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1584836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1584839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584860 */     // GIR_Coverage, 2764,
     /* 1584860 */     GIR_EraseRootFromParent_Done,
     /* 1584861 */   // Label 21914: @1584861
     /* 1584861 */   GIM_Try, /*On fail goto*//*Label 21915*/ GIMT_Encode4(1584947), // Rule ID 2765 //
     /* 1584866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1584869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1584877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1584880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1584883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1584886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1584889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1584892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1584896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1584908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584912 */     // MIs[0] policy
     /* 1584912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1584915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1584922 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1584922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1584925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1584927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1584929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1584931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1584933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1584935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1584940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1584943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1584945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1584946 */     // GIR_Coverage, 2765,
     /* 1584946 */     GIR_EraseRootFromParent_Done,
     /* 1584947 */   // Label 21915: @1584947
     /* 1584947 */   GIM_Try, /*On fail goto*//*Label 21916*/ GIMT_Encode4(1585033), // Rule ID 2772 //
     /* 1584952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1584955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1584960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1584963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1584966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1584969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1584972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1584975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1584978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1584982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1584994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1584998 */     // MIs[0] policy
     /* 1584998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585008 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1585011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585032 */     // GIR_Coverage, 2772,
     /* 1585032 */     GIR_EraseRootFromParent_Done,
     /* 1585033 */   // Label 21916: @1585033
     /* 1585033 */   GIM_Try, /*On fail goto*//*Label 21917*/ GIMT_Encode4(1585119), // Rule ID 2773 //
     /* 1585038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1585049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1585052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1585055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1585058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585084 */     // MIs[0] policy
     /* 1585084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585094 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1585097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585118 */     // GIR_Coverage, 2773,
     /* 1585118 */     GIR_EraseRootFromParent_Done,
     /* 1585119 */   // Label 21917: @1585119
     /* 1585119 */   GIM_Try, /*On fail goto*//*Label 21918*/ GIMT_Encode4(1585205), // Rule ID 2780 //
     /* 1585124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1585135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1585138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1585141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1585144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1585147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585170 */     // MIs[0] policy
     /* 1585170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585180 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1585183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585204 */     // GIR_Coverage, 2780,
     /* 1585204 */     GIR_EraseRootFromParent_Done,
     /* 1585205 */   // Label 21918: @1585205
     /* 1585205 */   GIM_Try, /*On fail goto*//*Label 21919*/ GIMT_Encode4(1585291), // Rule ID 2781 //
     /* 1585210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1585221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1585224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1585227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1585230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1585233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585256 */     // MIs[0] policy
     /* 1585256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585266 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1585269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1585287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585290 */     // GIR_Coverage, 2781,
     /* 1585290 */     GIR_EraseRootFromParent_Done,
     /* 1585291 */   // Label 21919: @1585291
     /* 1585291 */   GIM_Try, /*On fail goto*//*Label 21920*/ GIMT_Encode4(1585377), // Rule ID 2788 //
     /* 1585296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1585313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585342 */     // MIs[0] policy
     /* 1585342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1585355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585376 */     // GIR_Coverage, 2788,
     /* 1585376 */     GIR_EraseRootFromParent_Done,
     /* 1585377 */   // Label 21920: @1585377
     /* 1585377 */   GIM_Try, /*On fail goto*//*Label 21921*/ GIMT_Encode4(1585463), // Rule ID 2789 //
     /* 1585382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1585393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1585396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1585399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1585402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1585405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585428 */     // MIs[0] policy
     /* 1585428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585438 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1585441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585462 */     // GIR_Coverage, 2789,
     /* 1585462 */     GIR_EraseRootFromParent_Done,
     /* 1585463 */   // Label 21921: @1585463
     /* 1585463 */   GIM_Try, /*On fail goto*//*Label 21922*/ GIMT_Encode4(1585549), // Rule ID 2796 //
     /* 1585468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1585485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585514 */     // MIs[0] policy
     /* 1585514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585524 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1585527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585548 */     // GIR_Coverage, 2796,
     /* 1585548 */     GIR_EraseRootFromParent_Done,
     /* 1585549 */   // Label 21922: @1585549
     /* 1585549 */   GIM_Try, /*On fail goto*//*Label 21923*/ GIMT_Encode4(1585635), // Rule ID 2797 //
     /* 1585554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1585565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1585568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1585571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1585574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1585577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1585584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1585596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585600 */     // MIs[0] policy
     /* 1585600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585610 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1585613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585634 */     // GIR_Coverage, 2797,
     /* 1585634 */     GIR_EraseRootFromParent_Done,
     /* 1585635 */   // Label 21923: @1585635
     /* 1585635 */   GIM_Try, /*On fail goto*//*Label 21924*/ GIMT_Encode4(1585721), // Rule ID 2804 //
     /* 1585640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1585657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1585660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585686 */     // MIs[0] policy
     /* 1585686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585696 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1585699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585720 */     // GIR_Coverage, 2804,
     /* 1585720 */     GIR_EraseRootFromParent_Done,
     /* 1585721 */   // Label 21924: @1585721
     /* 1585721 */   GIM_Try, /*On fail goto*//*Label 21925*/ GIMT_Encode4(1585807), // Rule ID 2805 //
     /* 1585726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1585737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1585740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1585743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1585746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1585749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1585756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1585768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585772 */     // MIs[0] policy
     /* 1585772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585782 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1585785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1585803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585806 */     // GIR_Coverage, 2805,
     /* 1585806 */     GIR_EraseRootFromParent_Done,
     /* 1585807 */   // Label 21925: @1585807
     /* 1585807 */   GIM_Try, /*On fail goto*//*Label 21926*/ GIMT_Encode4(1585893), // Rule ID 2812 //
     /* 1585812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1585829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1585838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585858 */     // MIs[0] policy
     /* 1585858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1585868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1585871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585892 */     // GIR_Coverage, 2812,
     /* 1585892 */     GIR_EraseRootFromParent_Done,
     /* 1585893 */   // Label 21926: @1585893
     /* 1585893 */   GIM_Try, /*On fail goto*//*Label 21927*/ GIMT_Encode4(1585979), // Rule ID 2813 //
     /* 1585898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1585901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1585909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1585912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1585915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1585918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1585921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1585924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1585928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1585940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1585944 */     // MIs[0] policy
     /* 1585944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1585947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1585954 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1585954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1585957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1585959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1585961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1585963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1585965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1585967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1585972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1585975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1585977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1585978 */     // GIR_Coverage, 2813,
     /* 1585978 */     GIR_EraseRootFromParent_Done,
     /* 1585979 */   // Label 21927: @1585979
     /* 1585979 */   GIM_Try, /*On fail goto*//*Label 21928*/ GIMT_Encode4(1586065), // Rule ID 2820 //
     /* 1585984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1585987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1585992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1585995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1585998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1586001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586030 */     // MIs[0] policy
     /* 1586030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586040 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1586043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586064 */     // GIR_Coverage, 2820,
     /* 1586064 */     GIR_EraseRootFromParent_Done,
     /* 1586065 */   // Label 21928: @1586065
     /* 1586065 */   GIM_Try, /*On fail goto*//*Label 21929*/ GIMT_Encode4(1586151), // Rule ID 2821 //
     /* 1586070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1586081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1586084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1586087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1586090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586116 */     // MIs[0] policy
     /* 1586116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586126 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1586129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586150 */     // GIR_Coverage, 2821,
     /* 1586150 */     GIR_EraseRootFromParent_Done,
     /* 1586151 */   // Label 21929: @1586151
     /* 1586151 */   GIM_Try, /*On fail goto*//*Label 21930*/ GIMT_Encode4(1586237), // Rule ID 2828 //
     /* 1586156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1586173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1586176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586202 */     // MIs[0] policy
     /* 1586202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586212 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1586215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586236 */     // GIR_Coverage, 2828,
     /* 1586236 */     GIR_EraseRootFromParent_Done,
     /* 1586237 */   // Label 21930: @1586237
     /* 1586237 */   GIM_Try, /*On fail goto*//*Label 21931*/ GIMT_Encode4(1586323), // Rule ID 2829 //
     /* 1586242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1586253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1586256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1586259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1586262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1586265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586288 */     // MIs[0] policy
     /* 1586288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586298 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1586301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1586319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586322 */     // GIR_Coverage, 2829,
     /* 1586322 */     GIR_EraseRootFromParent_Done,
     /* 1586323 */   // Label 21931: @1586323
     /* 1586323 */   GIM_Try, /*On fail goto*//*Label 21932*/ GIMT_Encode4(1586409), // Rule ID 2836 //
     /* 1586328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1586345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1586348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586374 */     // MIs[0] policy
     /* 1586374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586384 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1586387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586408 */     // GIR_Coverage, 2836,
     /* 1586408 */     GIR_EraseRootFromParent_Done,
     /* 1586409 */   // Label 21932: @1586409
     /* 1586409 */   GIM_Try, /*On fail goto*//*Label 21933*/ GIMT_Encode4(1586495), // Rule ID 2837 //
     /* 1586414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1586425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1586428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1586431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1586434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1586444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1586456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586460 */     // MIs[0] policy
     /* 1586460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586470 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1586473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586494 */     // GIR_Coverage, 2837,
     /* 1586494 */     GIR_EraseRootFromParent_Done,
     /* 1586495 */   // Label 21933: @1586495
     /* 1586495 */   GIM_Try, /*On fail goto*//*Label 21934*/ GIMT_Encode4(1586581), // Rule ID 2844 //
     /* 1586500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1586517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1586520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586546 */     // MIs[0] policy
     /* 1586546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586556 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1586559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586580 */     // GIR_Coverage, 2844,
     /* 1586580 */     GIR_EraseRootFromParent_Done,
     /* 1586581 */   // Label 21934: @1586581
     /* 1586581 */   GIM_Try, /*On fail goto*//*Label 21935*/ GIMT_Encode4(1586667), // Rule ID 2845 //
     /* 1586586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1586597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1586600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1586603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1586606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1586609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1586616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1586628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586632 */     // MIs[0] policy
     /* 1586632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586642 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1586645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586666 */     // GIR_Coverage, 2845,
     /* 1586666 */     GIR_EraseRootFromParent_Done,
     /* 1586667 */   // Label 21935: @1586667
     /* 1586667 */   GIM_Try, /*On fail goto*//*Label 21936*/ GIMT_Encode4(1586753), // Rule ID 2852 //
     /* 1586672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1586675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1586689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1586692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586718 */     // MIs[0] policy
     /* 1586718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586728 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1586731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586752 */     // GIR_Coverage, 2852,
     /* 1586752 */     GIR_EraseRootFromParent_Done,
     /* 1586753 */   // Label 21936: @1586753
     /* 1586753 */   GIM_Try, /*On fail goto*//*Label 21937*/ GIMT_Encode4(1586839), // Rule ID 2853 //
     /* 1586758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1586761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1586766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1586769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1586772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1586775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1586778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1586781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1586788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1586800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586804 */     // MIs[0] policy
     /* 1586804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586814 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1586817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs1
     /* 1586823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 1586825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1586835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586838 */     // GIR_Coverage, 2853,
     /* 1586838 */     GIR_EraseRootFromParent_Done,
     /* 1586839 */   // Label 21937: @1586839
     /* 1586839 */   GIM_Try, /*On fail goto*//*Label 21938*/ GIMT_Encode4(1586925), // Rule ID 2860 //
     /* 1586844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1586847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1586852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1586855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1586858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1586861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1586870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586890 */     // MIs[0] policy
     /* 1586890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586900 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1586900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1586903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1586918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1586921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1586923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1586924 */     // GIR_Coverage, 2860,
     /* 1586924 */     GIR_EraseRootFromParent_Done,
     /* 1586925 */   // Label 21938: @1586925
     /* 1586925 */   GIM_Try, /*On fail goto*//*Label 21939*/ GIMT_Encode4(1587011), // Rule ID 2861 //
     /* 1586930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1586933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1586938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1586941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1586944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1586947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1586950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1586953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1586956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1586960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1586972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1586976 */     // MIs[0] policy
     /* 1586976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1586979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1586986 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1586986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1586989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1586991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1586993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1586995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1586997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1586999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587010 */     // GIR_Coverage, 2861,
     /* 1587010 */     GIR_EraseRootFromParent_Done,
     /* 1587011 */   // Label 21939: @1587011
     /* 1587011 */   GIM_Try, /*On fail goto*//*Label 21940*/ GIMT_Encode4(1587097), // Rule ID 2864 //
     /* 1587016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587062 */     // MIs[0] policy
     /* 1587062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587072 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587096 */     // GIR_Coverage, 2864,
     /* 1587096 */     GIR_EraseRootFromParent_Done,
     /* 1587097 */   // Label 21940: @1587097
     /* 1587097 */   GIM_Try, /*On fail goto*//*Label 21941*/ GIMT_Encode4(1587183), // Rule ID 2865 //
     /* 1587102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1587113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1587116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1587119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1587122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587148 */     // MIs[0] policy
     /* 1587148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587158 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587182 */     // GIR_Coverage, 2865,
     /* 1587182 */     GIR_EraseRootFromParent_Done,
     /* 1587183 */   // Label 21941: @1587183
     /* 1587183 */   GIM_Try, /*On fail goto*//*Label 21942*/ GIMT_Encode4(1587269), // Rule ID 2868 //
     /* 1587188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587234 */     // MIs[0] policy
     /* 1587234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587244 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1587247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587268 */     // GIR_Coverage, 2868,
     /* 1587268 */     GIR_EraseRootFromParent_Done,
     /* 1587269 */   // Label 21942: @1587269
     /* 1587269 */   GIM_Try, /*On fail goto*//*Label 21943*/ GIMT_Encode4(1587355), // Rule ID 2869 //
     /* 1587274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1587285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1587288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1587291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1587294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587320 */     // MIs[0] policy
     /* 1587320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587330 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF4_MASK),
     /* 1587333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587354 */     // GIR_Coverage, 2869,
     /* 1587354 */     GIR_EraseRootFromParent_Done,
     /* 1587355 */   // Label 21943: @1587355
     /* 1587355 */   GIM_Try, /*On fail goto*//*Label 21944*/ GIMT_Encode4(1587441), // Rule ID 2872 //
     /* 1587360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1587377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587406 */     // MIs[0] policy
     /* 1587406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587416 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587440 */     // GIR_Coverage, 2872,
     /* 1587440 */     GIR_EraseRootFromParent_Done,
     /* 1587441 */   // Label 21944: @1587441
     /* 1587441 */   GIM_Try, /*On fail goto*//*Label 21945*/ GIMT_Encode4(1587527), // Rule ID 2873 //
     /* 1587446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1587457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1587460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1587463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1587466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1587469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587492 */     // MIs[0] policy
     /* 1587492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587502 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587526 */     // GIR_Coverage, 2873,
     /* 1587526 */     GIR_EraseRootFromParent_Done,
     /* 1587527 */   // Label 21945: @1587527
     /* 1587527 */   GIM_Try, /*On fail goto*//*Label 21946*/ GIMT_Encode4(1587613), // Rule ID 2876 //
     /* 1587532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1587549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1587552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587578 */     // MIs[0] policy
     /* 1587578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587588 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587612 */     // GIR_Coverage, 2876,
     /* 1587612 */     GIR_EraseRootFromParent_Done,
     /* 1587613 */   // Label 21946: @1587613
     /* 1587613 */   GIM_Try, /*On fail goto*//*Label 21947*/ GIMT_Encode4(1587699), // Rule ID 2877 //
     /* 1587618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1587629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1587632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1587635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1587638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1587641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587664 */     // MIs[0] policy
     /* 1587664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587674 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_MF2_MASK),
     /* 1587677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1587695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587698 */     // GIR_Coverage, 2877,
     /* 1587698 */     GIR_EraseRootFromParent_Done,
     /* 1587699 */   // Label 21947: @1587699
     /* 1587699 */   GIM_Try, /*On fail goto*//*Label 21948*/ GIMT_Encode4(1587785), // Rule ID 2880 //
     /* 1587704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1587715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1587718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1587721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587750 */     // MIs[0] policy
     /* 1587750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587760 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1587763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587784 */     // GIR_Coverage, 2880,
     /* 1587784 */     GIR_EraseRootFromParent_Done,
     /* 1587785 */   // Label 21948: @1587785
     /* 1587785 */   GIM_Try, /*On fail goto*//*Label 21949*/ GIMT_Encode4(1587871), // Rule ID 2881 //
     /* 1587790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1587801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1587804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1587807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1587810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1587813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587836 */     // MIs[0] policy
     /* 1587836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587846 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1587846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1587849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1587867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587870 */     // GIR_Coverage, 2881,
     /* 1587870 */     GIR_EraseRootFromParent_Done,
     /* 1587871 */   // Label 21949: @1587871
     /* 1587871 */   GIM_Try, /*On fail goto*//*Label 21950*/ GIMT_Encode4(1587957), // Rule ID 2884 //
     /* 1587876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1587879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1587893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1587896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1587902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1587922 */     // MIs[0] policy
     /* 1587922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1587925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1587932 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1587932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1587935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1587937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1587939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1587941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1587943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1587945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1587950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1587953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1587955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1587956 */     // GIR_Coverage, 2884,
     /* 1587956 */     GIR_EraseRootFromParent_Done,
     /* 1587957 */   // Label 21950: @1587957
     /* 1587957 */   GIM_Try, /*On fail goto*//*Label 21951*/ GIMT_Encode4(1588043), // Rule ID 2885 //
     /* 1587962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1587965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1587970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1587973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1587976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1587979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1587982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1587985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1587988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1587992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1587996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588008 */     // MIs[0] policy
     /* 1588008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1588021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588042 */     // GIR_Coverage, 2885,
     /* 1588042 */     GIR_EraseRootFromParent_Done,
     /* 1588043 */   // Label 21951: @1588043
     /* 1588043 */   GIM_Try, /*On fail goto*//*Label 21952*/ GIMT_Encode4(1588129), // Rule ID 2888 //
     /* 1588048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588094 */     // MIs[0] policy
     /* 1588094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588104 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1588107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588128 */     // GIR_Coverage, 2888,
     /* 1588128 */     GIR_EraseRootFromParent_Done,
     /* 1588129 */   // Label 21952: @1588129
     /* 1588129 */   GIM_Try, /*On fail goto*//*Label 21953*/ GIMT_Encode4(1588215), // Rule ID 2889 //
     /* 1588134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1588145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1588148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1588151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1588154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1588157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588180 */     // MIs[0] policy
     /* 1588180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588190 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1588193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1588211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588214 */     // GIR_Coverage, 2889,
     /* 1588214 */     GIR_EraseRootFromParent_Done,
     /* 1588215 */   // Label 21953: @1588215
     /* 1588215 */   GIM_Try, /*On fail goto*//*Label 21954*/ GIMT_Encode4(1588301), // Rule ID 2892 //
     /* 1588220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1588223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1588237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1588240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588266 */     // MIs[0] policy
     /* 1588266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1588279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1588297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588300 */     // GIR_Coverage, 2892,
     /* 1588300 */     GIR_EraseRootFromParent_Done,
     /* 1588301 */   // Label 21954: @1588301
     /* 1588301 */   GIM_Try, /*On fail goto*//*Label 21955*/ GIMT_Encode4(1588387), // Rule ID 2893 //
     /* 1588306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1588309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1588317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1588320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1588323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1588326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1588329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1588336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1588348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588352 */     // MIs[0] policy
     /* 1588352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M1_MASK),
     /* 1588365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1588383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588386 */     // GIR_Coverage, 2893,
     /* 1588386 */     GIR_EraseRootFromParent_Done,
     /* 1588387 */   // Label 21955: @1588387
     /* 1588387 */   GIM_Try, /*On fail goto*//*Label 21956*/ GIMT_Encode4(1588473), // Rule ID 2896 //
     /* 1588392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1588403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1588406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1588409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1588412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588438 */     // MIs[0] policy
     /* 1588438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588448 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1588451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588472 */     // GIR_Coverage, 2896,
     /* 1588472 */     GIR_EraseRootFromParent_Done,
     /* 1588473 */   // Label 21956: @1588473
     /* 1588473 */   GIM_Try, /*On fail goto*//*Label 21957*/ GIMT_Encode4(1588559), // Rule ID 2897 //
     /* 1588478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1588489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1588492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1588495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1588498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1588501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588524 */     // MIs[0] policy
     /* 1588524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588534 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1588537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588558 */     // GIR_Coverage, 2897,
     /* 1588558 */     GIR_EraseRootFromParent_Done,
     /* 1588559 */   // Label 21957: @1588559
     /* 1588559 */   GIM_Try, /*On fail goto*//*Label 21958*/ GIMT_Encode4(1588645), // Rule ID 2900 //
     /* 1588564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1588575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1588578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1588581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588610 */     // MIs[0] policy
     /* 1588610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588620 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1588623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588644 */     // GIR_Coverage, 2900,
     /* 1588644 */     GIR_EraseRootFromParent_Done,
     /* 1588645 */   // Label 21958: @1588645
     /* 1588645 */   GIM_Try, /*On fail goto*//*Label 21959*/ GIMT_Encode4(1588731), // Rule ID 2901 //
     /* 1588650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1588661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1588664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1588667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1588670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1588673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1588680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1588692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588696 */     // MIs[0] policy
     /* 1588696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588706 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1588709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588730 */     // GIR_Coverage, 2901,
     /* 1588730 */     GIR_EraseRootFromParent_Done,
     /* 1588731 */   // Label 21959: @1588731
     /* 1588731 */   GIM_Try, /*On fail goto*//*Label 21960*/ GIMT_Encode4(1588817), // Rule ID 2904 //
     /* 1588736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1588747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1588750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1588753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1588756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1588759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588782 */     // MIs[0] policy
     /* 1588782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588792 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1588795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588816 */     // GIR_Coverage, 2904,
     /* 1588816 */     GIR_EraseRootFromParent_Done,
     /* 1588817 */   // Label 21960: @1588817
     /* 1588817 */   GIM_Try, /*On fail goto*//*Label 21961*/ GIMT_Encode4(1588903), // Rule ID 2905 //
     /* 1588822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1588833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1588836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1588839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1588842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1588845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1588848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1588852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1588864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588868 */     // MIs[0] policy
     /* 1588868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588878 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1588878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1588881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1588899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588902 */     // GIR_Coverage, 2905,
     /* 1588902 */     GIR_EraseRootFromParent_Done,
     /* 1588903 */   // Label 21961: @1588903
     /* 1588903 */   GIM_Try, /*On fail goto*//*Label 21962*/ GIMT_Encode4(1588989), // Rule ID 2908 //
     /* 1588908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1588911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1588916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1588919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1588922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1588925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1588928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1588931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1588934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1588938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1588950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1588954 */     // MIs[0] policy
     /* 1588954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1588957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1588964 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1588964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1588967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1588969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1588971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1588973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1588975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1588977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1588982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1588985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1588987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1588988 */     // GIR_Coverage, 2908,
     /* 1588988 */     GIR_EraseRootFromParent_Done,
     /* 1588989 */   // Label 21962: @1588989
     /* 1588989 */   GIM_Try, /*On fail goto*//*Label 21963*/ GIMT_Encode4(1589075), // Rule ID 2909 //
     /* 1588994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1588997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1589005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1589008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1589011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1589014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589040 */     // MIs[0] policy
     /* 1589040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589050 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1589053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589074 */     // GIR_Coverage, 2909,
     /* 1589074 */     GIR_EraseRootFromParent_Done,
     /* 1589075 */   // Label 21963: @1589075
     /* 1589075 */   GIM_Try, /*On fail goto*//*Label 21964*/ GIMT_Encode4(1589161), // Rule ID 2912 //
     /* 1589080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589126 */     // MIs[0] policy
     /* 1589126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589136 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1589139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589160 */     // GIR_Coverage, 2912,
     /* 1589160 */     GIR_EraseRootFromParent_Done,
     /* 1589161 */   // Label 21964: @1589161
     /* 1589161 */   GIM_Try, /*On fail goto*//*Label 21965*/ GIMT_Encode4(1589247), // Rule ID 2913 //
     /* 1589166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1589177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1589180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1589183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1589186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589212 */     // MIs[0] policy
     /* 1589212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589222 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1589225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589246 */     // GIR_Coverage, 2913,
     /* 1589246 */     GIR_EraseRootFromParent_Done,
     /* 1589247 */   // Label 21965: @1589247
     /* 1589247 */   GIM_Try, /*On fail goto*//*Label 21966*/ GIMT_Encode4(1589333), // Rule ID 2916 //
     /* 1589252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1589263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1589266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1589269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1589272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589298 */     // MIs[0] policy
     /* 1589298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589308 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1589311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589332 */     // GIR_Coverage, 2916,
     /* 1589332 */     GIR_EraseRootFromParent_Done,
     /* 1589333 */   // Label 21966: @1589333
     /* 1589333 */   GIM_Try, /*On fail goto*//*Label 21967*/ GIMT_Encode4(1589419), // Rule ID 2917 //
     /* 1589338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1589349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1589352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1589355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1589358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1589361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589384 */     // MIs[0] policy
     /* 1589384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589394 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1589397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1589415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589418 */     // GIR_Coverage, 2917,
     /* 1589418 */     GIR_EraseRootFromParent_Done,
     /* 1589419 */   // Label 21967: @1589419
     /* 1589419 */   GIM_Try, /*On fail goto*//*Label 21968*/ GIMT_Encode4(1589505), // Rule ID 2920 //
     /* 1589424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1589441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589470 */     // MIs[0] policy
     /* 1589470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589480 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1589483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589504 */     // GIR_Coverage, 2920,
     /* 1589504 */     GIR_EraseRootFromParent_Done,
     /* 1589505 */   // Label 21968: @1589505
     /* 1589505 */   GIM_Try, /*On fail goto*//*Label 21969*/ GIMT_Encode4(1589591), // Rule ID 2921 //
     /* 1589510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1589521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1589524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1589527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1589530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1589533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589556 */     // MIs[0] policy
     /* 1589556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1589569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589590 */     // GIR_Coverage, 2921,
     /* 1589590 */     GIR_EraseRootFromParent_Done,
     /* 1589591 */   // Label 21969: @1589591
     /* 1589591 */   GIM_Try, /*On fail goto*//*Label 21970*/ GIMT_Encode4(1589677), // Rule ID 2924 //
     /* 1589596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1589613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589642 */     // MIs[0] policy
     /* 1589642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589652 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1589655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589676 */     // GIR_Coverage, 2924,
     /* 1589676 */     GIR_EraseRootFromParent_Done,
     /* 1589677 */   // Label 21970: @1589677
     /* 1589677 */   GIM_Try, /*On fail goto*//*Label 21971*/ GIMT_Encode4(1589763), // Rule ID 2925 //
     /* 1589682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1589693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1589696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1589699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1589702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1589705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1589712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1589724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589728 */     // MIs[0] policy
     /* 1589728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589738 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1589741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589762 */     // GIR_Coverage, 2925,
     /* 1589762 */     GIR_EraseRootFromParent_Done,
     /* 1589763 */   // Label 21971: @1589763
     /* 1589763 */   GIM_Try, /*On fail goto*//*Label 21972*/ GIMT_Encode4(1589849), // Rule ID 2928 //
     /* 1589768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1589771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1589779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1589782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1589785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1589788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589814 */     // MIs[0] policy
     /* 1589814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589824 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1589827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589848 */     // GIR_Coverage, 2928,
     /* 1589848 */     GIR_EraseRootFromParent_Done,
     /* 1589849 */   // Label 21972: @1589849
     /* 1589849 */   GIM_Try, /*On fail goto*//*Label 21973*/ GIMT_Encode4(1589935), // Rule ID 2929 //
     /* 1589854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1589857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1589865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1589868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1589871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1589874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1589877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1589880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1589884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1589896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589900 */     // MIs[0] policy
     /* 1589900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589910 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1589910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1589913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1589915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1589917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1589919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1589921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1589923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1589928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1589931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1589933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1589934 */     // GIR_Coverage, 2929,
     /* 1589934 */     GIR_EraseRootFromParent_Done,
     /* 1589935 */   // Label 21973: @1589935
     /* 1589935 */   GIM_Try, /*On fail goto*//*Label 21974*/ GIMT_Encode4(1590021), // Rule ID 2932 //
     /* 1589940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1589943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1589948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1589951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1589954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1589957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1589960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1589963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1589966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1589970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1589982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1589986 */     // MIs[0] policy
     /* 1589986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1589989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1589996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1589996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1589999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590020 */     // GIR_Coverage, 2932,
     /* 1590020 */     GIR_EraseRootFromParent_Done,
     /* 1590021 */   // Label 21974: @1590021
     /* 1590021 */   GIM_Try, /*On fail goto*//*Label 21975*/ GIMT_Encode4(1590107), // Rule ID 2933 //
     /* 1590026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1590037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1590040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1590043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1590046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1590056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1590068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590072 */     // MIs[0] policy
     /* 1590072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590082 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M2_MASK),
     /* 1590085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590106 */     // GIR_Coverage, 2933,
     /* 1590106 */     GIR_EraseRootFromParent_Done,
     /* 1590107 */   // Label 21975: @1590107
     /* 1590107 */   GIM_Try, /*On fail goto*//*Label 21976*/ GIMT_Encode4(1590193), // Rule ID 2936 //
     /* 1590112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1590132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590158 */     // MIs[0] policy
     /* 1590158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590168 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1590171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590192 */     // GIR_Coverage, 2936,
     /* 1590192 */     GIR_EraseRootFromParent_Done,
     /* 1590193 */   // Label 21976: @1590193
     /* 1590193 */   GIM_Try, /*On fail goto*//*Label 21977*/ GIMT_Encode4(1590279), // Rule ID 2937 //
     /* 1590198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1590209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1590212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1590215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1590218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1590228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1590240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590244 */     // MIs[0] policy
     /* 1590244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590254 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M4_MASK),
     /* 1590257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590278 */     // GIR_Coverage, 2937,
     /* 1590278 */     GIR_EraseRootFromParent_Done,
     /* 1590279 */   // Label 21977: @1590279
     /* 1590279 */   GIM_Try, /*On fail goto*//*Label 21978*/ GIMT_Encode4(1590365), // Rule ID 2940 //
     /* 1590284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1590287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1590301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1590304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590330 */     // MIs[0] policy
     /* 1590330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590340 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1590343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590364 */     // GIR_Coverage, 2940,
     /* 1590364 */     GIR_EraseRootFromParent_Done,
     /* 1590365 */   // Label 21978: @1590365
     /* 1590365 */   GIM_Try, /*On fail goto*//*Label 21979*/ GIMT_Encode4(1590451), // Rule ID 2941 //
     /* 1590370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1590373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1590381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1590384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1590387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1590390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1590393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1590400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1590412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590416 */     // MIs[0] policy
     /* 1590416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VV_M8_MASK),
     /* 1590429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1590447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590450 */     // GIR_Coverage, 2941,
     /* 1590450 */     GIR_EraseRootFromParent_Done,
     /* 1590451 */   // Label 21979: @1590451
     /* 1590451 */   GIM_Try, /*On fail goto*//*Label 21980*/ GIMT_Encode4(1590537), // Rule ID 2944 //
     /* 1590456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590502 */     // MIs[0] policy
     /* 1590502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590512 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1590515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590536 */     // GIR_Coverage, 2944,
     /* 1590536 */     GIR_EraseRootFromParent_Done,
     /* 1590537 */   // Label 21980: @1590537
     /* 1590537 */   GIM_Try, /*On fail goto*//*Label 21981*/ GIMT_Encode4(1590623), // Rule ID 2945 //
     /* 1590542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1590553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1590556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1590559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590588 */     // MIs[0] policy
     /* 1590588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590598 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF8_MASK),
     /* 1590601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590622 */     // GIR_Coverage, 2945,
     /* 1590622 */     GIR_EraseRootFromParent_Done,
     /* 1590623 */   // Label 21981: @1590623
     /* 1590623 */   GIM_Try, /*On fail goto*//*Label 21982*/ GIMT_Encode4(1590709), // Rule ID 2948 //
     /* 1590628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590674 */     // MIs[0] policy
     /* 1590674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590684 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1590687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590708 */     // GIR_Coverage, 2948,
     /* 1590708 */     GIR_EraseRootFromParent_Done,
     /* 1590709 */   // Label 21982: @1590709
     /* 1590709 */   GIM_Try, /*On fail goto*//*Label 21983*/ GIMT_Encode4(1590795), // Rule ID 2949 //
     /* 1590714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1590725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1590728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1590731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1590737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590760 */     // MIs[0] policy
     /* 1590760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590770 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1590773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590794 */     // GIR_Coverage, 2949,
     /* 1590794 */     GIR_EraseRootFromParent_Done,
     /* 1590795 */   // Label 21983: @1590795
     /* 1590795 */   GIM_Try, /*On fail goto*//*Label 21984*/ GIMT_Encode4(1590881), // Rule ID 2952 //
     /* 1590800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590846 */     // MIs[0] policy
     /* 1590846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590856 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1590856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1590859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590880 */     // GIR_Coverage, 2952,
     /* 1590880 */     GIR_EraseRootFromParent_Done,
     /* 1590881 */   // Label 21984: @1590881
     /* 1590881 */   GIM_Try, /*On fail goto*//*Label 21985*/ GIMT_Encode4(1590967), // Rule ID 2953 //
     /* 1590886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1590889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1590897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1590900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1590903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1590906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1590909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1590912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1590916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1590924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1590928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1590932 */     // MIs[0] policy
     /* 1590932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1590935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1590942 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1590942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1590945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1590947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1590949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1590951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1590953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1590955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1590960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1590963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1590965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1590966 */     // GIR_Coverage, 2953,
     /* 1590966 */     GIR_EraseRootFromParent_Done,
     /* 1590967 */   // Label 21985: @1590967
     /* 1590967 */   GIM_Try, /*On fail goto*//*Label 21986*/ GIMT_Encode4(1591053), // Rule ID 2956 //
     /* 1590972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1590975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1590980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1590983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1590986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1590989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1590992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1590995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1590998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591018 */     // MIs[0] policy
     /* 1591018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1591031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591052 */     // GIR_Coverage, 2956,
     /* 1591052 */     GIR_EraseRootFromParent_Done,
     /* 1591053 */   // Label 21986: @1591053
     /* 1591053 */   GIM_Try, /*On fail goto*//*Label 21987*/ GIMT_Encode4(1591139), // Rule ID 2957 //
     /* 1591058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1591069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1591072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1591075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591104 */     // MIs[0] policy
     /* 1591104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591114 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF4_MASK),
     /* 1591117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591138 */     // GIR_Coverage, 2957,
     /* 1591138 */     GIR_EraseRootFromParent_Done,
     /* 1591139 */   // Label 21987: @1591139
     /* 1591139 */   GIM_Try, /*On fail goto*//*Label 21988*/ GIMT_Encode4(1591225), // Rule ID 2960 //
     /* 1591144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1591164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591190 */     // MIs[0] policy
     /* 1591190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591200 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1591203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591224 */     // GIR_Coverage, 2960,
     /* 1591224 */     GIR_EraseRootFromParent_Done,
     /* 1591225 */   // Label 21988: @1591225
     /* 1591225 */   GIM_Try, /*On fail goto*//*Label 21989*/ GIMT_Encode4(1591311), // Rule ID 2961 //
     /* 1591230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1591241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1591244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1591247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591276 */     // MIs[0] policy
     /* 1591276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591286 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1591289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591310 */     // GIR_Coverage, 2961,
     /* 1591310 */     GIR_EraseRootFromParent_Done,
     /* 1591311 */   // Label 21989: @1591311
     /* 1591311 */   GIM_Try, /*On fail goto*//*Label 21990*/ GIMT_Encode4(1591397), // Rule ID 2964 //
     /* 1591316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1591336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591362 */     // MIs[0] policy
     /* 1591362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591372 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1591375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591396 */     // GIR_Coverage, 2964,
     /* 1591396 */     GIR_EraseRootFromParent_Done,
     /* 1591397 */   // Label 21990: @1591397
     /* 1591397 */   GIM_Try, /*On fail goto*//*Label 21991*/ GIMT_Encode4(1591483), // Rule ID 2965 //
     /* 1591402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1591413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1591416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1591419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1591425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591448 */     // MIs[0] policy
     /* 1591448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591458 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_MF2_MASK),
     /* 1591461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591482 */     // GIR_Coverage, 2965,
     /* 1591482 */     GIR_EraseRootFromParent_Done,
     /* 1591483 */   // Label 21991: @1591483
     /* 1591483 */   GIM_Try, /*On fail goto*//*Label 21992*/ GIMT_Encode4(1591569), // Rule ID 2968 //
     /* 1591488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1591508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591534 */     // MIs[0] policy
     /* 1591534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591544 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591568 */     // GIR_Coverage, 2968,
     /* 1591568 */     GIR_EraseRootFromParent_Done,
     /* 1591569 */   // Label 21992: @1591569
     /* 1591569 */   GIM_Try, /*On fail goto*//*Label 21993*/ GIMT_Encode4(1591655), // Rule ID 2969 //
     /* 1591574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1591585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1591588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1591591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1591597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591620 */     // MIs[0] policy
     /* 1591620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591630 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11075:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1591651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591654 */     // GIR_Coverage, 2969,
     /* 1591654 */     GIR_EraseRootFromParent_Done,
     /* 1591655 */   // Label 21993: @1591655
     /* 1591655 */   GIM_Try, /*On fail goto*//*Label 21994*/ GIMT_Encode4(1591741), // Rule ID 2972 //
     /* 1591660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1591680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591706 */     // MIs[0] policy
     /* 1591706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591716 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591740 */     // GIR_Coverage, 2972,
     /* 1591740 */     GIR_EraseRootFromParent_Done,
     /* 1591741 */   // Label 21994: @1591741
     /* 1591741 */   GIM_Try, /*On fail goto*//*Label 21995*/ GIMT_Encode4(1591827), // Rule ID 2973 //
     /* 1591746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1591757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1591760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1591763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1591769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591792 */     // MIs[0] policy
     /* 1591792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591802 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11075:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1591823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591826 */     // GIR_Coverage, 2973,
     /* 1591826 */     GIR_EraseRootFromParent_Done,
     /* 1591827 */   // Label 21995: @1591827
     /* 1591827 */   GIM_Try, /*On fail goto*//*Label 21996*/ GIMT_Encode4(1591913), // Rule ID 2976 //
     /* 1591832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1591835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1591852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1591858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591878 */     // MIs[0] policy
     /* 1591878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1591888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591912 */     // GIR_Coverage, 2976,
     /* 1591912 */     GIR_EraseRootFromParent_Done,
     /* 1591913 */   // Label 21996: @1591913
     /* 1591913 */   GIM_Try, /*On fail goto*//*Label 21997*/ GIMT_Encode4(1591999), // Rule ID 2977 //
     /* 1591918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1591921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1591926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1591929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1591932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1591935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1591938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1591941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1591944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1591948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1591956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1591960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1591964 */     // MIs[0] policy
     /* 1591964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1591967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1591974 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11075:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1591974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1591977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1591979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1591981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1591983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1591985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1591987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1591992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1591995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1591997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1591998 */     // GIR_Coverage, 2977,
     /* 1591998 */     GIR_EraseRootFromParent_Done,
     /* 1591999 */   // Label 21997: @1591999
     /* 1591999 */   GIM_Try, /*On fail goto*//*Label 21998*/ GIMT_Encode4(1592085), // Rule ID 2980 //
     /* 1592004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1592007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592050 */     // MIs[0] policy
     /* 1592050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592060 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1592063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592084 */     // GIR_Coverage, 2980,
     /* 1592084 */     GIR_EraseRootFromParent_Done,
     /* 1592085 */   // Label 21998: @1592085
     /* 1592085 */   GIM_Try, /*On fail goto*//*Label 21999*/ GIMT_Encode4(1592171), // Rule ID 2981 //
     /* 1592090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1592093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1592101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1592104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1592107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1592113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1592120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1592128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592136 */     // MIs[0] policy
     /* 1592136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592146 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11075:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M1_MASK),
     /* 1592149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1592167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592170 */     // GIR_Coverage, 2981,
     /* 1592170 */     GIR_EraseRootFromParent_Done,
     /* 1592171 */   // Label 21999: @1592171
     /* 1592171 */   GIM_Try, /*On fail goto*//*Label 22000*/ GIMT_Encode4(1592257), // Rule ID 2984 //
     /* 1592176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592222 */     // MIs[0] policy
     /* 1592222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592232 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1592235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592256 */     // GIR_Coverage, 2984,
     /* 1592256 */     GIR_EraseRootFromParent_Done,
     /* 1592257 */   // Label 22000: @1592257
     /* 1592257 */   GIM_Try, /*On fail goto*//*Label 22001*/ GIMT_Encode4(1592343), // Rule ID 2985 //
     /* 1592262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1592273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1592276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1592279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592308 */     // MIs[0] policy
     /* 1592308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592318 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1592321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592342 */     // GIR_Coverage, 2985,
     /* 1592342 */     GIR_EraseRootFromParent_Done,
     /* 1592343 */   // Label 22001: @1592343
     /* 1592343 */   GIM_Try, /*On fail goto*//*Label 22002*/ GIMT_Encode4(1592429), // Rule ID 2988 //
     /* 1592348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592394 */     // MIs[0] policy
     /* 1592394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592404 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1592407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592428 */     // GIR_Coverage, 2988,
     /* 1592428 */     GIR_EraseRootFromParent_Done,
     /* 1592429 */   // Label 22002: @1592429
     /* 1592429 */   GIM_Try, /*On fail goto*//*Label 22003*/ GIMT_Encode4(1592515), // Rule ID 2989 //
     /* 1592434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1592445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1592448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1592451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1592457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592480 */     // MIs[0] policy
     /* 1592480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592490 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1592493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592514 */     // GIR_Coverage, 2989,
     /* 1592514 */     GIR_EraseRootFromParent_Done,
     /* 1592515 */   // Label 22003: @1592515
     /* 1592515 */   GIM_Try, /*On fail goto*//*Label 22004*/ GIMT_Encode4(1592601), // Rule ID 2992 //
     /* 1592520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592566 */     // MIs[0] policy
     /* 1592566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592576 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1592579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592600 */     // GIR_Coverage, 2992,
     /* 1592600 */     GIR_EraseRootFromParent_Done,
     /* 1592601 */   // Label 22004: @1592601
     /* 1592601 */   GIM_Try, /*On fail goto*//*Label 22005*/ GIMT_Encode4(1592687), // Rule ID 2993 //
     /* 1592606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1592617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1592620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1592623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1592629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1592636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1592644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592652 */     // MIs[0] policy
     /* 1592652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592662 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1592665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1592683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592686 */     // GIR_Coverage, 2993,
     /* 1592686 */     GIR_EraseRootFromParent_Done,
     /* 1592687 */   // Label 22005: @1592687
     /* 1592687 */   GIM_Try, /*On fail goto*//*Label 22006*/ GIMT_Encode4(1592773), // Rule ID 2996 //
     /* 1592692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592738 */     // MIs[0] policy
     /* 1592738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592748 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1592751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592772 */     // GIR_Coverage, 2996,
     /* 1592772 */     GIR_EraseRootFromParent_Done,
     /* 1592773 */   // Label 22006: @1592773
     /* 1592773 */   GIM_Try, /*On fail goto*//*Label 22007*/ GIMT_Encode4(1592859), // Rule ID 2997 //
     /* 1592778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1592789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1592792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1592795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1592801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1592808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1592816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592824 */     // MIs[0] policy
     /* 1592824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1592834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1592837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592858 */     // GIR_Coverage, 2997,
     /* 1592858 */     GIR_EraseRootFromParent_Done,
     /* 1592859 */   // Label 22007: @1592859
     /* 1592859 */   GIM_Try, /*On fail goto*//*Label 22008*/ GIMT_Encode4(1592945), // Rule ID 3000 //
     /* 1592864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1592867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1592884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1592890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592910 */     // MIs[0] policy
     /* 1592910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1592920 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1592920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1592923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1592925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1592927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1592929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1592931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1592933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1592938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1592941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1592943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1592944 */     // GIR_Coverage, 3000,
     /* 1592944 */     GIR_EraseRootFromParent_Done,
     /* 1592945 */   // Label 22008: @1592945
     /* 1592945 */   GIM_Try, /*On fail goto*//*Label 22009*/ GIMT_Encode4(1593031), // Rule ID 3001 //
     /* 1592950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1592953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1592958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1592961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1592964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1592967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1592970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1592973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1592976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1592980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1592988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1592992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1592996 */     // MIs[0] policy
     /* 1592996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1592999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593006 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1593009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593030 */     // GIR_Coverage, 3001,
     /* 1593030 */     GIR_EraseRootFromParent_Done,
     /* 1593031 */   // Label 22009: @1593031
     /* 1593031 */   GIM_Try, /*On fail goto*//*Label 22010*/ GIMT_Encode4(1593117), // Rule ID 3004 //
     /* 1593036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593082 */     // MIs[0] policy
     /* 1593082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593092 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1593095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593116 */     // GIR_Coverage, 3004,
     /* 1593116 */     GIR_EraseRootFromParent_Done,
     /* 1593117 */   // Label 22010: @1593117
     /* 1593117 */   GIM_Try, /*On fail goto*//*Label 22011*/ GIMT_Encode4(1593203), // Rule ID 3005 //
     /* 1593122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1593133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1593136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1593139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1593142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1593145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593168 */     // MIs[0] policy
     /* 1593168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593178 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1593181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1593199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593202 */     // GIR_Coverage, 3005,
     /* 1593202 */     GIR_EraseRootFromParent_Done,
     /* 1593203 */   // Label 22011: @1593203
     /* 1593203 */   GIM_Try, /*On fail goto*//*Label 22012*/ GIMT_Encode4(1593289), // Rule ID 3008 //
     /* 1593208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593254 */     // MIs[0] policy
     /* 1593254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1593267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593288 */     // GIR_Coverage, 3008,
     /* 1593288 */     GIR_EraseRootFromParent_Done,
     /* 1593289 */   // Label 22012: @1593289
     /* 1593289 */   GIM_Try, /*On fail goto*//*Label 22013*/ GIMT_Encode4(1593375), // Rule ID 3009 //
     /* 1593294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1593305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1593308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1593311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1593314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593340 */     // MIs[0] policy
     /* 1593340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1593353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593374 */     // GIR_Coverage, 3009,
     /* 1593374 */     GIR_EraseRootFromParent_Done,
     /* 1593375 */   // Label 22013: @1593375
     /* 1593375 */   GIM_Try, /*On fail goto*//*Label 22014*/ GIMT_Encode4(1593461), // Rule ID 3012 //
     /* 1593380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593426 */     // MIs[0] policy
     /* 1593426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1593439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593460 */     // GIR_Coverage, 3012,
     /* 1593460 */     GIR_EraseRootFromParent_Done,
     /* 1593461 */   // Label 22014: @1593461
     /* 1593461 */   GIM_Try, /*On fail goto*//*Label 22015*/ GIMT_Encode4(1593547), // Rule ID 3013 //
     /* 1593466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1593477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1593480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1593483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1593486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1593489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593512 */     // MIs[0] policy
     /* 1593512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1593525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593546 */     // GIR_Coverage, 3013,
     /* 1593546 */     GIR_EraseRootFromParent_Done,
     /* 1593547 */   // Label 22015: @1593547
     /* 1593547 */   GIM_Try, /*On fail goto*//*Label 22016*/ GIMT_Encode4(1593633), // Rule ID 3016 //
     /* 1593552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1593555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593598 */     // MIs[0] policy
     /* 1593598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1593611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593632 */     // GIR_Coverage, 3016,
     /* 1593632 */     GIR_EraseRootFromParent_Done,
     /* 1593633 */   // Label 22016: @1593633
     /* 1593633 */   GIM_Try, /*On fail goto*//*Label 22017*/ GIMT_Encode4(1593719), // Rule ID 3017 //
     /* 1593638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1593641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1593649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1593652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1593655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1593658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1593661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1593668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1593676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593684 */     // MIs[0] policy
     /* 1593684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1593697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1593715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593718 */     // GIR_Coverage, 3017,
     /* 1593718 */     GIR_EraseRootFromParent_Done,
     /* 1593719 */   // Label 22017: @1593719
     /* 1593719 */   GIM_Try, /*On fail goto*//*Label 22018*/ GIMT_Encode4(1593805), // Rule ID 3020 //
     /* 1593724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593770 */     // MIs[0] policy
     /* 1593770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1593783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593804 */     // GIR_Coverage, 3020,
     /* 1593804 */     GIR_EraseRootFromParent_Done,
     /* 1593805 */   // Label 22018: @1593805
     /* 1593805 */   GIM_Try, /*On fail goto*//*Label 22019*/ GIMT_Encode4(1593891), // Rule ID 3021 //
     /* 1593810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1593821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1593824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1593827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1593830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1593833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1593836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1593840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1593848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593856 */     // MIs[0] policy
     /* 1593856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593866 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11075:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1593866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M2_MASK),
     /* 1593869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593890 */     // GIR_Coverage, 3021,
     /* 1593890 */     GIR_EraseRootFromParent_Done,
     /* 1593891 */   // Label 22019: @1593891
     /* 1593891 */   GIM_Try, /*On fail goto*//*Label 22020*/ GIMT_Encode4(1593977), // Rule ID 3024 //
     /* 1593896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1593899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1593916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1593919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1593922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1593926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1593934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1593938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1593942 */     // MIs[0] policy
     /* 1593942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1593945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1593952 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1593952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1593955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1593957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1593959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1593961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1593963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1593965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1593970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1593973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1593975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1593976 */     // GIR_Coverage, 3024,
     /* 1593976 */     GIR_EraseRootFromParent_Done,
     /* 1593977 */   // Label 22020: @1593977
     /* 1593977 */   GIM_Try, /*On fail goto*//*Label 22021*/ GIMT_Encode4(1594063), // Rule ID 3025 //
     /* 1593982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1593985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1593990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1593993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1593996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1593999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1594012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1594020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594028 */     // MIs[0] policy
     /* 1594028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594038 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11075:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M4_MASK),
     /* 1594041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594062 */     // GIR_Coverage, 3025,
     /* 1594062 */     GIR_EraseRootFromParent_Done,
     /* 1594063 */   // Label 22021: @1594063
     /* 1594063 */   GIM_Try, /*On fail goto*//*Label 22022*/ GIMT_Encode4(1594149), // Rule ID 3028 //
     /* 1594068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1594071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1594088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594114 */     // MIs[0] policy
     /* 1594114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594124 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1594127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594148 */     // GIR_Coverage, 3028,
     /* 1594148 */     GIR_EraseRootFromParent_Done,
     /* 1594149 */   // Label 22022: @1594149
     /* 1594149 */   GIM_Try, /*On fail goto*//*Label 22023*/ GIMT_Encode4(1594235), // Rule ID 3029 //
     /* 1594154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1594157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vadd_mask),
     /* 1594162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1594165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1594168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1594171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1594174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1594177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1594184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1594192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1594196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594200 */     // MIs[0] policy
     /* 1594200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594210 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11075:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVADD_VX_M8_MASK),
     /* 1594213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1594231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594234 */     // GIR_Coverage, 3029,
     /* 1594234 */     GIR_EraseRootFromParent_Done,
     /* 1594235 */   // Label 22023: @1594235
     /* 1594235 */   GIM_Try, /*On fail goto*//*Label 22024*/ GIMT_Encode4(1594321), // Rule ID 3120 //
     /* 1594240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1594260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594286 */     // MIs[0] policy
     /* 1594286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594296 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1594299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594320 */     // GIR_Coverage, 3120,
     /* 1594320 */     GIR_EraseRootFromParent_Done,
     /* 1594321 */   // Label 22024: @1594321
     /* 1594321 */   GIM_Try, /*On fail goto*//*Label 22025*/ GIMT_Encode4(1594407), // Rule ID 3121 //
     /* 1594326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1594337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1594340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1594343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1594346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594372 */     // MIs[0] policy
     /* 1594372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594382 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF8_MASK),
     /* 1594385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594406 */     // GIR_Coverage, 3121,
     /* 1594406 */     GIR_EraseRootFromParent_Done,
     /* 1594407 */   // Label 22025: @1594407
     /* 1594407 */   GIM_Try, /*On fail goto*//*Label 22026*/ GIMT_Encode4(1594493), // Rule ID 3124 //
     /* 1594412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1594432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594458 */     // MIs[0] policy
     /* 1594458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594468 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594492 */     // GIR_Coverage, 3124,
     /* 1594492 */     GIR_EraseRootFromParent_Done,
     /* 1594493 */   // Label 22026: @1594493
     /* 1594493 */   GIM_Try, /*On fail goto*//*Label 22027*/ GIMT_Encode4(1594579), // Rule ID 3125 //
     /* 1594498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1594509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1594512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1594515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1594518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594544 */     // MIs[0] policy
     /* 1594544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594554 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594578 */     // GIR_Coverage, 3125,
     /* 1594578 */     GIR_EraseRootFromParent_Done,
     /* 1594579 */   // Label 22027: @1594579
     /* 1594579 */   GIM_Try, /*On fail goto*//*Label 22028*/ GIMT_Encode4(1594665), // Rule ID 3128 //
     /* 1594584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594630 */     // MIs[0] policy
     /* 1594630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594640 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594664 */     // GIR_Coverage, 3128,
     /* 1594664 */     GIR_EraseRootFromParent_Done,
     /* 1594665 */   // Label 22028: @1594665
     /* 1594665 */   GIM_Try, /*On fail goto*//*Label 22029*/ GIMT_Encode4(1594751), // Rule ID 3129 //
     /* 1594670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1594681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1594684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1594687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1594690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1594693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594716 */     // MIs[0] policy
     /* 1594716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594726 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1594747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594750 */     // GIR_Coverage, 3129,
     /* 1594750 */     GIR_EraseRootFromParent_Done,
     /* 1594751 */   // Label 22029: @1594751
     /* 1594751 */   GIM_Try, /*On fail goto*//*Label 22030*/ GIMT_Encode4(1594837), // Rule ID 3132 //
     /* 1594756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594802 */     // MIs[0] policy
     /* 1594802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594812 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594836 */     // GIR_Coverage, 3132,
     /* 1594836 */     GIR_EraseRootFromParent_Done,
     /* 1594837 */   // Label 22030: @1594837
     /* 1594837 */   GIM_Try, /*On fail goto*//*Label 22031*/ GIMT_Encode4(1594923), // Rule ID 3133 //
     /* 1594842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1594845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1594853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1594856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1594859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1594862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1594865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1594868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594888 */     // MIs[0] policy
     /* 1594888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594898 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1594898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF4_MASK),
     /* 1594901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1594916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1594919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1594921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1594922 */     // GIR_Coverage, 3133,
     /* 1594922 */     GIR_EraseRootFromParent_Done,
     /* 1594923 */   // Label 22031: @1594923
     /* 1594923 */   GIM_Try, /*On fail goto*//*Label 22032*/ GIMT_Encode4(1595009), // Rule ID 3136 //
     /* 1594928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1594931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1594936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1594939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1594942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1594945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1594948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1594951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1594954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1594958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1594970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1594974 */     // MIs[0] policy
     /* 1594974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1594977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1594984 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1594984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1594987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1594989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1594991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1594993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1594995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1594997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595008 */     // GIR_Coverage, 3136,
     /* 1595008 */     GIR_EraseRootFromParent_Done,
     /* 1595009 */   // Label 22032: @1595009
     /* 1595009 */   GIM_Try, /*On fail goto*//*Label 22033*/ GIMT_Encode4(1595095), // Rule ID 3137 //
     /* 1595014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1595025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1595028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1595031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1595034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595060 */     // MIs[0] policy
     /* 1595060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595070 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1595073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595094 */     // GIR_Coverage, 3137,
     /* 1595094 */     GIR_EraseRootFromParent_Done,
     /* 1595095 */   // Label 22033: @1595095
     /* 1595095 */   GIM_Try, /*On fail goto*//*Label 22034*/ GIMT_Encode4(1595181), // Rule ID 3140 //
     /* 1595100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1595120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595146 */     // MIs[0] policy
     /* 1595146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595156 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1595159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595180 */     // GIR_Coverage, 3140,
     /* 1595180 */     GIR_EraseRootFromParent_Done,
     /* 1595181 */   // Label 22034: @1595181
     /* 1595181 */   GIM_Try, /*On fail goto*//*Label 22035*/ GIMT_Encode4(1595267), // Rule ID 3141 //
     /* 1595186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1595197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1595200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1595203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1595206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595232 */     // MIs[0] policy
     /* 1595232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_MF2_MASK),
     /* 1595245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595266 */     // GIR_Coverage, 3141,
     /* 1595266 */     GIR_EraseRootFromParent_Done,
     /* 1595267 */   // Label 22035: @1595267
     /* 1595267 */   GIM_Try, /*On fail goto*//*Label 22036*/ GIMT_Encode4(1595353), // Rule ID 3144 //
     /* 1595272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1595292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595318 */     // MIs[0] policy
     /* 1595318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595328 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595352 */     // GIR_Coverage, 3144,
     /* 1595352 */     GIR_EraseRootFromParent_Done,
     /* 1595353 */   // Label 22036: @1595353
     /* 1595353 */   GIM_Try, /*On fail goto*//*Label 22037*/ GIMT_Encode4(1595439), // Rule ID 3145 //
     /* 1595358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1595369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1595372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1595375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1595378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1595381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595404 */     // MIs[0] policy
     /* 1595404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595414 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1595435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595438 */     // GIR_Coverage, 3145,
     /* 1595438 */     GIR_EraseRootFromParent_Done,
     /* 1595439 */   // Label 22037: @1595439
     /* 1595439 */   GIM_Try, /*On fail goto*//*Label 22038*/ GIMT_Encode4(1595525), // Rule ID 3148 //
     /* 1595444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1595464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595490 */     // MIs[0] policy
     /* 1595490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595500 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595524 */     // GIR_Coverage, 3148,
     /* 1595524 */     GIR_EraseRootFromParent_Done,
     /* 1595525 */   // Label 22038: @1595525
     /* 1595525 */   GIM_Try, /*On fail goto*//*Label 22039*/ GIMT_Encode4(1595611), // Rule ID 3149 //
     /* 1595530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1595541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1595544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1595547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1595550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1595553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595576 */     // MIs[0] policy
     /* 1595576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595586 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1595607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595610 */     // GIR_Coverage, 3149,
     /* 1595610 */     GIR_EraseRootFromParent_Done,
     /* 1595611 */   // Label 22039: @1595611
     /* 1595611 */   GIM_Try, /*On fail goto*//*Label 22040*/ GIMT_Encode4(1595697), // Rule ID 3152 //
     /* 1595616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595662 */     // MIs[0] policy
     /* 1595662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595696 */     // GIR_Coverage, 3152,
     /* 1595696 */     GIR_EraseRootFromParent_Done,
     /* 1595697 */   // Label 22040: @1595697
     /* 1595697 */   GIM_Try, /*On fail goto*//*Label 22041*/ GIMT_Encode4(1595783), // Rule ID 3153 //
     /* 1595702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1595705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1595713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1595716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1595719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1595722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1595725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595748 */     // MIs[0] policy
     /* 1595748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1595779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595782 */     // GIR_Coverage, 3153,
     /* 1595782 */     GIR_EraseRootFromParent_Done,
     /* 1595783 */   // Label 22041: @1595783
     /* 1595783 */   GIM_Try, /*On fail goto*//*Label 22042*/ GIMT_Encode4(1595869), // Rule ID 3156 //
     /* 1595788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1595791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595834 */     // MIs[0] policy
     /* 1595834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595844 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1595844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595868 */     // GIR_Coverage, 3156,
     /* 1595868 */     GIR_EraseRootFromParent_Done,
     /* 1595869 */   // Label 22042: @1595869
     /* 1595869 */   GIM_Try, /*On fail goto*//*Label 22043*/ GIMT_Encode4(1595955), // Rule ID 3157 //
     /* 1595874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1595877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1595885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1595888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1595891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1595894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1595897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1595900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1595904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1595916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1595920 */     // MIs[0] policy
     /* 1595920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1595923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1595930 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1595930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M1_MASK),
     /* 1595933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1595935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1595937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1595939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1595941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1595943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1595948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1595951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1595953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1595954 */     // GIR_Coverage, 3157,
     /* 1595954 */     GIR_EraseRootFromParent_Done,
     /* 1595955 */   // Label 22043: @1595955
     /* 1595955 */   GIM_Try, /*On fail goto*//*Label 22044*/ GIMT_Encode4(1596041), // Rule ID 3160 //
     /* 1595960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1595963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1595968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1595971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1595974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1595977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1595980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1595983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1595986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1595990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1595998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596006 */     // MIs[0] policy
     /* 1596006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596040 */     // GIR_Coverage, 3160,
     /* 1596040 */     GIR_EraseRootFromParent_Done,
     /* 1596041 */   // Label 22044: @1596041
     /* 1596041 */   GIM_Try, /*On fail goto*//*Label 22045*/ GIMT_Encode4(1596127), // Rule ID 3161 //
     /* 1596046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1596057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1596060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1596063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1596066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596092 */     // MIs[0] policy
     /* 1596092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596102 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596126 */     // GIR_Coverage, 3161,
     /* 1596126 */     GIR_EraseRootFromParent_Done,
     /* 1596127 */   // Label 22045: @1596127
     /* 1596127 */   GIM_Try, /*On fail goto*//*Label 22046*/ GIMT_Encode4(1596213), // Rule ID 3164 //
     /* 1596132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1596152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596178 */     // MIs[0] policy
     /* 1596178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596188 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596212 */     // GIR_Coverage, 3164,
     /* 1596212 */     GIR_EraseRootFromParent_Done,
     /* 1596213 */   // Label 22046: @1596213
     /* 1596213 */   GIM_Try, /*On fail goto*//*Label 22047*/ GIMT_Encode4(1596299), // Rule ID 3165 //
     /* 1596218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1596229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1596232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1596235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1596238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596264 */     // MIs[0] policy
     /* 1596264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596274 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596298 */     // GIR_Coverage, 3165,
     /* 1596298 */     GIR_EraseRootFromParent_Done,
     /* 1596299 */   // Label 22047: @1596299
     /* 1596299 */   GIM_Try, /*On fail goto*//*Label 22048*/ GIMT_Encode4(1596385), // Rule ID 3168 //
     /* 1596304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1596324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596350 */     // MIs[0] policy
     /* 1596350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596360 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596384 */     // GIR_Coverage, 3168,
     /* 1596384 */     GIR_EraseRootFromParent_Done,
     /* 1596385 */   // Label 22048: @1596385
     /* 1596385 */   GIM_Try, /*On fail goto*//*Label 22049*/ GIMT_Encode4(1596471), // Rule ID 3169 //
     /* 1596390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1596401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1596404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1596407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1596410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1596413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596436 */     // MIs[0] policy
     /* 1596436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596446 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1596467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596470 */     // GIR_Coverage, 3169,
     /* 1596470 */     GIR_EraseRootFromParent_Done,
     /* 1596471 */   // Label 22049: @1596471
     /* 1596471 */   GIM_Try, /*On fail goto*//*Label 22050*/ GIMT_Encode4(1596557), // Rule ID 3172 //
     /* 1596476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1596496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596522 */     // MIs[0] policy
     /* 1596522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596556 */     // GIR_Coverage, 3172,
     /* 1596556 */     GIR_EraseRootFromParent_Done,
     /* 1596557 */   // Label 22050: @1596557
     /* 1596557 */   GIM_Try, /*On fail goto*//*Label 22051*/ GIMT_Encode4(1596643), // Rule ID 3173 //
     /* 1596562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1596573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1596576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1596579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1596582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1596585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1596592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1596604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596608 */     // MIs[0] policy
     /* 1596608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1596621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596642 */     // GIR_Coverage, 3173,
     /* 1596642 */     GIR_EraseRootFromParent_Done,
     /* 1596643 */   // Label 22051: @1596643
     /* 1596643 */   GIM_Try, /*On fail goto*//*Label 22052*/ GIMT_Encode4(1596729), // Rule ID 3176 //
     /* 1596648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596694 */     // MIs[0] policy
     /* 1596694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596704 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596728 */     // GIR_Coverage, 3176,
     /* 1596728 */     GIR_EraseRootFromParent_Done,
     /* 1596729 */   // Label 22052: @1596729
     /* 1596729 */   GIM_Try, /*On fail goto*//*Label 22053*/ GIMT_Encode4(1596815), // Rule ID 3177 //
     /* 1596734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1596745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1596748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1596751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1596754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1596757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1596764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1596776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596780 */     // MIs[0] policy
     /* 1596780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1596793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596814 */     // GIR_Coverage, 3177,
     /* 1596814 */     GIR_EraseRootFromParent_Done,
     /* 1596815 */   // Label 22053: @1596815
     /* 1596815 */   GIM_Try, /*On fail goto*//*Label 22054*/ GIMT_Encode4(1596901), // Rule ID 3180 //
     /* 1596820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1596846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596866 */     // MIs[0] policy
     /* 1596866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1596876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596900 */     // GIR_Coverage, 3180,
     /* 1596900 */     GIR_EraseRootFromParent_Done,
     /* 1596901 */   // Label 22054: @1596901
     /* 1596901 */   GIM_Try, /*On fail goto*//*Label 22055*/ GIMT_Encode4(1596987), // Rule ID 3181 //
     /* 1596906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1596909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1596914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1596917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1596920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1596923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1596926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1596929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1596932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1596936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1596948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1596952 */     // MIs[0] policy
     /* 1596952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1596955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1596962 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1596962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1596965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1596967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1596969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1596971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1596973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1596975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1596980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1596983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1596985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1596986 */     // GIR_Coverage, 3181,
     /* 1596986 */     GIR_EraseRootFromParent_Done,
     /* 1596987 */   // Label 22055: @1596987
     /* 1596987 */   GIM_Try, /*On fail goto*//*Label 22056*/ GIMT_Encode4(1597073), // Rule ID 3184 //
     /* 1596992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1596995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1597012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597038 */     // MIs[0] policy
     /* 1597038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1597051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597072 */     // GIR_Coverage, 3184,
     /* 1597072 */     GIR_EraseRootFromParent_Done,
     /* 1597073 */   // Label 22056: @1597073
     /* 1597073 */   GIM_Try, /*On fail goto*//*Label 22057*/ GIMT_Encode4(1597159), // Rule ID 3185 //
     /* 1597078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1597089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1597092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1597095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1597098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597124 */     // MIs[0] policy
     /* 1597124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597134 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1597137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597158 */     // GIR_Coverage, 3185,
     /* 1597158 */     GIR_EraseRootFromParent_Done,
     /* 1597159 */   // Label 22057: @1597159
     /* 1597159 */   GIM_Try, /*On fail goto*//*Label 22058*/ GIMT_Encode4(1597245), // Rule ID 3188 //
     /* 1597164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1597184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597210 */     // MIs[0] policy
     /* 1597210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597220 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1597223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597244 */     // GIR_Coverage, 3188,
     /* 1597244 */     GIR_EraseRootFromParent_Done,
     /* 1597245 */   // Label 22058: @1597245
     /* 1597245 */   GIM_Try, /*On fail goto*//*Label 22059*/ GIMT_Encode4(1597331), // Rule ID 3189 //
     /* 1597250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1597261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1597264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1597267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1597270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597296 */     // MIs[0] policy
     /* 1597296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597306 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1597309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597330 */     // GIR_Coverage, 3189,
     /* 1597330 */     GIR_EraseRootFromParent_Done,
     /* 1597331 */   // Label 22059: @1597331
     /* 1597331 */   GIM_Try, /*On fail goto*//*Label 22060*/ GIMT_Encode4(1597417), // Rule ID 3192 //
     /* 1597336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1597339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1597347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1597350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1597353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1597356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597382 */     // MIs[0] policy
     /* 1597382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597392 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597416 */     // GIR_Coverage, 3192,
     /* 1597416 */     GIR_EraseRootFromParent_Done,
     /* 1597417 */   // Label 22060: @1597417
     /* 1597417 */   GIM_Try, /*On fail goto*//*Label 22061*/ GIMT_Encode4(1597503), // Rule ID 3193 //
     /* 1597422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1597425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1597433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1597436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1597439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1597442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1597445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597468 */     // MIs[0] policy
     /* 1597468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597478 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1597499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597502 */     // GIR_Coverage, 3193,
     /* 1597502 */     GIR_EraseRootFromParent_Done,
     /* 1597503 */   // Label 22061: @1597503
     /* 1597503 */   GIM_Try, /*On fail goto*//*Label 22062*/ GIMT_Encode4(1597589), // Rule ID 3196 //
     /* 1597508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597554 */     // MIs[0] policy
     /* 1597554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1597567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597588 */     // GIR_Coverage, 3196,
     /* 1597588 */     GIR_EraseRootFromParent_Done,
     /* 1597589 */   // Label 22062: @1597589
     /* 1597589 */   GIM_Try, /*On fail goto*//*Label 22063*/ GIMT_Encode4(1597675), // Rule ID 3197 //
     /* 1597594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1597605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1597608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1597611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1597614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1597617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1597624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1597636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597640 */     // MIs[0] policy
     /* 1597640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597650 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M2_MASK),
     /* 1597653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597674 */     // GIR_Coverage, 3197,
     /* 1597674 */     GIR_EraseRootFromParent_Done,
     /* 1597675 */   // Label 22063: @1597675
     /* 1597675 */   GIM_Try, /*On fail goto*//*Label 22064*/ GIMT_Encode4(1597761), // Rule ID 3200 //
     /* 1597680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597726 */     // MIs[0] policy
     /* 1597726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597736 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1597739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597760 */     // GIR_Coverage, 3200,
     /* 1597760 */     GIR_EraseRootFromParent_Done,
     /* 1597761 */   // Label 22064: @1597761
     /* 1597761 */   GIM_Try, /*On fail goto*//*Label 22065*/ GIMT_Encode4(1597847), // Rule ID 3201 //
     /* 1597766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1597777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1597780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1597783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1597786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1597789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1597796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1597808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597812 */     // MIs[0] policy
     /* 1597812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597822 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M4_MASK),
     /* 1597825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597846 */     // GIR_Coverage, 3201,
     /* 1597846 */     GIR_EraseRootFromParent_Done,
     /* 1597847 */   // Label 22065: @1597847
     /* 1597847 */   GIM_Try, /*On fail goto*//*Label 22066*/ GIMT_Encode4(1597933), // Rule ID 3204 //
     /* 1597852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1597855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1597878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597898 */     // MIs[0] policy
     /* 1597898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597908 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1597908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1597915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1597917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1597919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1597921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1597926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1597929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1597931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1597932 */     // GIR_Coverage, 3204,
     /* 1597932 */     GIR_EraseRootFromParent_Done,
     /* 1597933 */   // Label 22066: @1597933
     /* 1597933 */   GIM_Try, /*On fail goto*//*Label 22067*/ GIMT_Encode4(1598019), // Rule ID 3205 //
     /* 1597938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1597941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1597946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1597949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1597952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1597955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1597958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1597961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1597964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1597968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1597980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1597984 */     // MIs[0] policy
     /* 1597984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1597987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1597994 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1597994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VV_M8_MASK),
     /* 1597997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1597999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1598015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598018 */     // GIR_Coverage, 3205,
     /* 1598018 */     GIR_EraseRootFromParent_Done,
     /* 1598019 */   // Label 22067: @1598019
     /* 1598019 */   GIM_Try, /*On fail goto*//*Label 22068*/ GIMT_Encode4(1598105), // Rule ID 3208 //
     /* 1598024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1598041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598070 */     // MIs[0] policy
     /* 1598070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1598083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598104 */     // GIR_Coverage, 3208,
     /* 1598104 */     GIR_EraseRootFromParent_Done,
     /* 1598105 */   // Label 22068: @1598105
     /* 1598105 */   GIM_Try, /*On fail goto*//*Label 22069*/ GIMT_Encode4(1598191), // Rule ID 3209 //
     /* 1598110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1598121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1598124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1598127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598156 */     // MIs[0] policy
     /* 1598156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598166 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF8_MASK),
     /* 1598169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598190 */     // GIR_Coverage, 3209,
     /* 1598190 */     GIR_EraseRootFromParent_Done,
     /* 1598191 */   // Label 22069: @1598191
     /* 1598191 */   GIM_Try, /*On fail goto*//*Label 22070*/ GIMT_Encode4(1598277), // Rule ID 3212 //
     /* 1598196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1598213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598242 */     // MIs[0] policy
     /* 1598242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598252 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1598255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598276 */     // GIR_Coverage, 3212,
     /* 1598276 */     GIR_EraseRootFromParent_Done,
     /* 1598277 */   // Label 22070: @1598277
     /* 1598277 */   GIM_Try, /*On fail goto*//*Label 22071*/ GIMT_Encode4(1598363), // Rule ID 3213 //
     /* 1598282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1598293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1598296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1598299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598328 */     // MIs[0] policy
     /* 1598328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598338 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1598341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598362 */     // GIR_Coverage, 3213,
     /* 1598362 */     GIR_EraseRootFromParent_Done,
     /* 1598363 */   // Label 22071: @1598363
     /* 1598363 */   GIM_Try, /*On fail goto*//*Label 22072*/ GIMT_Encode4(1598449), // Rule ID 3216 //
     /* 1598368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1598379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1598382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1598385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598414 */     // MIs[0] policy
     /* 1598414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598424 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1598427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598448 */     // GIR_Coverage, 3216,
     /* 1598448 */     GIR_EraseRootFromParent_Done,
     /* 1598449 */   // Label 22072: @1598449
     /* 1598449 */   GIM_Try, /*On fail goto*//*Label 22073*/ GIMT_Encode4(1598535), // Rule ID 3217 //
     /* 1598454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1598465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1598468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1598471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1598477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598500 */     // MIs[0] policy
     /* 1598500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598510 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1598513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1598531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598534 */     // GIR_Coverage, 3217,
     /* 1598534 */     GIR_EraseRootFromParent_Done,
     /* 1598535 */   // Label 22073: @1598535
     /* 1598535 */   GIM_Try, /*On fail goto*//*Label 22074*/ GIMT_Encode4(1598621), // Rule ID 3220 //
     /* 1598540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598586 */     // MIs[0] policy
     /* 1598586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1598599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598620 */     // GIR_Coverage, 3220,
     /* 1598620 */     GIR_EraseRootFromParent_Done,
     /* 1598621 */   // Label 22074: @1598621
     /* 1598621 */   GIM_Try, /*On fail goto*//*Label 22075*/ GIMT_Encode4(1598707), // Rule ID 3221 //
     /* 1598626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1598637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1598640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1598643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598672 */     // MIs[0] policy
     /* 1598672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF4_MASK),
     /* 1598685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598706 */     // GIR_Coverage, 3221,
     /* 1598706 */     GIR_EraseRootFromParent_Done,
     /* 1598707 */   // Label 22075: @1598707
     /* 1598707 */   GIM_Try, /*On fail goto*//*Label 22076*/ GIMT_Encode4(1598793), // Rule ID 3224 //
     /* 1598712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598758 */     // MIs[0] policy
     /* 1598758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1598771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598792 */     // GIR_Coverage, 3224,
     /* 1598792 */     GIR_EraseRootFromParent_Done,
     /* 1598793 */   // Label 22076: @1598793
     /* 1598793 */   GIM_Try, /*On fail goto*//*Label 22077*/ GIMT_Encode4(1598879), // Rule ID 3225 //
     /* 1598798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1598809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1598812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1598815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1598821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598844 */     // MIs[0] policy
     /* 1598844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1598854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1598857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1598875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598878 */     // GIR_Coverage, 3225,
     /* 1598878 */     GIR_EraseRootFromParent_Done,
     /* 1598879 */   // Label 22077: @1598879
     /* 1598879 */   GIM_Try, /*On fail goto*//*Label 22078*/ GIMT_Encode4(1598965), // Rule ID 3228 //
     /* 1598884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1598887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1598904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1598910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1598914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1598922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1598926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1598930 */     // MIs[0] policy
     /* 1598930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1598933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1598940 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1598940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1598943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1598945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1598947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1598949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1598951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1598953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1598958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1598961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1598963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1598964 */     // GIR_Coverage, 3228,
     /* 1598964 */     GIR_EraseRootFromParent_Done,
     /* 1598965 */   // Label 22078: @1598965
     /* 1598965 */   GIM_Try, /*On fail goto*//*Label 22079*/ GIMT_Encode4(1599051), // Rule ID 3229 //
     /* 1598970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1598973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1598978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1598981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1598984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1598987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1598990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1598993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1598996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599016 */     // MIs[0] policy
     /* 1599016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599026 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_MF2_MASK),
     /* 1599029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599050 */     // GIR_Coverage, 3229,
     /* 1599050 */     GIR_EraseRootFromParent_Done,
     /* 1599051 */   // Label 22079: @1599051
     /* 1599051 */   GIM_Try, /*On fail goto*//*Label 22080*/ GIMT_Encode4(1599137), // Rule ID 3232 //
     /* 1599056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1599067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1599070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1599073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599102 */     // MIs[0] policy
     /* 1599102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599112 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599136 */     // GIR_Coverage, 3232,
     /* 1599136 */     GIR_EraseRootFromParent_Done,
     /* 1599137 */   // Label 22080: @1599137
     /* 1599137 */   GIM_Try, /*On fail goto*//*Label 22081*/ GIMT_Encode4(1599223), // Rule ID 3233 //
     /* 1599142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1599153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1599156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1599159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1599165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599188 */     // MIs[0] policy
     /* 1599188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599198 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11553:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599222 */     // GIR_Coverage, 3233,
     /* 1599222 */     GIR_EraseRootFromParent_Done,
     /* 1599223 */   // Label 22081: @1599223
     /* 1599223 */   GIM_Try, /*On fail goto*//*Label 22082*/ GIMT_Encode4(1599309), // Rule ID 3236 //
     /* 1599228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1599245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599274 */     // MIs[0] policy
     /* 1599274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599284 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599308 */     // GIR_Coverage, 3236,
     /* 1599308 */     GIR_EraseRootFromParent_Done,
     /* 1599309 */   // Label 22082: @1599309
     /* 1599309 */   GIM_Try, /*On fail goto*//*Label 22083*/ GIMT_Encode4(1599395), // Rule ID 3237 //
     /* 1599314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1599325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1599328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1599331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1599337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599360 */     // MIs[0] policy
     /* 1599360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599370 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11553:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1599391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599394 */     // GIR_Coverage, 3237,
     /* 1599394 */     GIR_EraseRootFromParent_Done,
     /* 1599395 */   // Label 22083: @1599395
     /* 1599395 */   GIM_Try, /*On fail goto*//*Label 22084*/ GIMT_Encode4(1599481), // Rule ID 3240 //
     /* 1599400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1599411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1599414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1599417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599446 */     // MIs[0] policy
     /* 1599446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599456 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599480 */     // GIR_Coverage, 3240,
     /* 1599480 */     GIR_EraseRootFromParent_Done,
     /* 1599481 */   // Label 22084: @1599481
     /* 1599481 */   GIM_Try, /*On fail goto*//*Label 22085*/ GIMT_Encode4(1599567), // Rule ID 3241 //
     /* 1599486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1599497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1599500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1599503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1599509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599532 */     // MIs[0] policy
     /* 1599532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599542 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11553:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1599563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599566 */     // GIR_Coverage, 3241,
     /* 1599566 */     GIR_EraseRootFromParent_Done,
     /* 1599567 */   // Label 22085: @1599567
     /* 1599567 */   GIM_Try, /*On fail goto*//*Label 22086*/ GIMT_Encode4(1599653), // Rule ID 3244 //
     /* 1599572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1599575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599618 */     // MIs[0] policy
     /* 1599618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599628 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599652 */     // GIR_Coverage, 3244,
     /* 1599652 */     GIR_EraseRootFromParent_Done,
     /* 1599653 */   // Label 22086: @1599653
     /* 1599653 */   GIM_Try, /*On fail goto*//*Label 22087*/ GIMT_Encode4(1599739), // Rule ID 3245 //
     /* 1599658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1599661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1599669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1599672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1599675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1599681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1599688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1599696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599704 */     // MIs[0] policy
     /* 1599704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599714 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11553:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M1_MASK),
     /* 1599717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1599735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599738 */     // GIR_Coverage, 3245,
     /* 1599738 */     GIR_EraseRootFromParent_Done,
     /* 1599739 */   // Label 22087: @1599739
     /* 1599739 */   GIM_Try, /*On fail goto*//*Label 22088*/ GIMT_Encode4(1599825), // Rule ID 3248 //
     /* 1599744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599790 */     // MIs[0] policy
     /* 1599790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599800 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1599803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599824 */     // GIR_Coverage, 3248,
     /* 1599824 */     GIR_EraseRootFromParent_Done,
     /* 1599825 */   // Label 22088: @1599825
     /* 1599825 */   GIM_Try, /*On fail goto*//*Label 22089*/ GIMT_Encode4(1599911), // Rule ID 3249 //
     /* 1599830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1599833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1599841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1599844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1599847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1599850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1599853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1599856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1599860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1599868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599876 */     // MIs[0] policy
     /* 1599876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1599886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1599889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599910 */     // GIR_Coverage, 3249,
     /* 1599910 */     GIR_EraseRootFromParent_Done,
     /* 1599911 */   // Label 22089: @1599911
     /* 1599911 */   GIM_Try, /*On fail goto*//*Label 22090*/ GIMT_Encode4(1599997), // Rule ID 3252 //
     /* 1599916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1599919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1599924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1599927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1599930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1599933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1599936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1599939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1599942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1599946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1599954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1599958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1599962 */     // MIs[0] policy
     /* 1599962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1599965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1599972 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1599972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1599975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1599977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1599979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1599981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1599983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1599985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1599990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1599993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1599995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1599996 */     // GIR_Coverage, 3252,
     /* 1599996 */     GIR_EraseRootFromParent_Done,
     /* 1599997 */   // Label 22090: @1599997
     /* 1599997 */   GIM_Try, /*On fail goto*//*Label 22091*/ GIMT_Encode4(1600083), // Rule ID 3253 //
     /* 1600002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1600013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1600016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1600019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600048 */     // MIs[0] policy
     /* 1600048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600058 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1600061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600082 */     // GIR_Coverage, 3253,
     /* 1600082 */     GIR_EraseRootFromParent_Done,
     /* 1600083 */   // Label 22091: @1600083
     /* 1600083 */   GIM_Try, /*On fail goto*//*Label 22092*/ GIMT_Encode4(1600169), // Rule ID 3256 //
     /* 1600088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1600099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1600102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1600105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1600111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600134 */     // MIs[0] policy
     /* 1600134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600144 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1600147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600168 */     // GIR_Coverage, 3256,
     /* 1600168 */     GIR_EraseRootFromParent_Done,
     /* 1600169 */   // Label 22092: @1600169
     /* 1600169 */   GIM_Try, /*On fail goto*//*Label 22093*/ GIMT_Encode4(1600255), // Rule ID 3257 //
     /* 1600174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1600185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1600188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1600191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1600197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600220 */     // MIs[0] policy
     /* 1600220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600230 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1600233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1600251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600254 */     // GIR_Coverage, 3257,
     /* 1600254 */     GIR_EraseRootFromParent_Done,
     /* 1600255 */   // Label 22093: @1600255
     /* 1600255 */   GIM_Try, /*On fail goto*//*Label 22094*/ GIMT_Encode4(1600341), // Rule ID 3260 //
     /* 1600260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1600271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1600274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1600277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600306 */     // MIs[0] policy
     /* 1600306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600316 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1600319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600340 */     // GIR_Coverage, 3260,
     /* 1600340 */     GIR_EraseRootFromParent_Done,
     /* 1600341 */   // Label 22094: @1600341
     /* 1600341 */   GIM_Try, /*On fail goto*//*Label 22095*/ GIMT_Encode4(1600427), // Rule ID 3261 //
     /* 1600346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1600357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1600360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1600363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600392 */     // MIs[0] policy
     /* 1600392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600402 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1600405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600426 */     // GIR_Coverage, 3261,
     /* 1600426 */     GIR_EraseRootFromParent_Done,
     /* 1600427 */   // Label 22095: @1600427
     /* 1600427 */   GIM_Try, /*On fail goto*//*Label 22096*/ GIMT_Encode4(1600513), // Rule ID 3264 //
     /* 1600432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1600443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1600446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1600449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600478 */     // MIs[0] policy
     /* 1600478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600488 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1600491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600512 */     // GIR_Coverage, 3264,
     /* 1600512 */     GIR_EraseRootFromParent_Done,
     /* 1600513 */   // Label 22096: @1600513
     /* 1600513 */   GIM_Try, /*On fail goto*//*Label 22097*/ GIMT_Encode4(1600599), // Rule ID 3265 //
     /* 1600518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1600529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1600532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1600535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1600541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600564 */     // MIs[0] policy
     /* 1600564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600574 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1600577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600598 */     // GIR_Coverage, 3265,
     /* 1600598 */     GIR_EraseRootFromParent_Done,
     /* 1600599 */   // Label 22097: @1600599
     /* 1600599 */   GIM_Try, /*On fail goto*//*Label 22098*/ GIMT_Encode4(1600685), // Rule ID 3268 //
     /* 1600604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600650 */     // MIs[0] policy
     /* 1600650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600660 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1600663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600684 */     // GIR_Coverage, 3268,
     /* 1600684 */     GIR_EraseRootFromParent_Done,
     /* 1600685 */   // Label 22098: @1600685
     /* 1600685 */   GIM_Try, /*On fail goto*//*Label 22099*/ GIMT_Encode4(1600771), // Rule ID 3269 //
     /* 1600690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1600701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1600704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1600707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1600713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1600720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1600728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600736 */     // MIs[0] policy
     /* 1600736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600746 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1600749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1600767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600770 */     // GIR_Coverage, 3269,
     /* 1600770 */     GIR_EraseRootFromParent_Done,
     /* 1600771 */   // Label 22099: @1600771
     /* 1600771 */   GIM_Try, /*On fail goto*//*Label 22100*/ GIMT_Encode4(1600857), // Rule ID 3272 //
     /* 1600776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600822 */     // MIs[0] policy
     /* 1600822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1600832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1600835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600856 */     // GIR_Coverage, 3272,
     /* 1600856 */     GIR_EraseRootFromParent_Done,
     /* 1600857 */   // Label 22100: @1600857
     /* 1600857 */   GIM_Try, /*On fail goto*//*Label 22101*/ GIMT_Encode4(1600943), // Rule ID 3273 //
     /* 1600862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1600865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1600873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1600876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1600879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1600882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1600885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1600888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1600892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1600900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600908 */     // MIs[0] policy
     /* 1600908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1600918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1600918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1600921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1600923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1600925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1600927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1600929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1600931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1600936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1600939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1600941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1600942 */     // GIR_Coverage, 3273,
     /* 1600942 */     GIR_EraseRootFromParent_Done,
     /* 1600943 */   // Label 22101: @1600943
     /* 1600943 */   GIM_Try, /*On fail goto*//*Label 22102*/ GIMT_Encode4(1601029), // Rule ID 3276 //
     /* 1600948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1600951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1600956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1600959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1600962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1600965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1600968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1600971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1600974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1600978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1600986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1600990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1600994 */     // MIs[0] policy
     /* 1600994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1600997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601004 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1601007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601028 */     // GIR_Coverage, 3276,
     /* 1601028 */     GIR_EraseRootFromParent_Done,
     /* 1601029 */   // Label 22102: @1601029
     /* 1601029 */   GIM_Try, /*On fail goto*//*Label 22103*/ GIMT_Encode4(1601115), // Rule ID 3277 //
     /* 1601034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1601045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1601048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1601051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601080 */     // MIs[0] policy
     /* 1601080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601090 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1601093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601114 */     // GIR_Coverage, 3277,
     /* 1601114 */     GIR_EraseRootFromParent_Done,
     /* 1601115 */   // Label 22103: @1601115
     /* 1601115 */   GIM_Try, /*On fail goto*//*Label 22104*/ GIMT_Encode4(1601201), // Rule ID 3280 //
     /* 1601120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1601131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1601134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1601137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601166 */     // MIs[0] policy
     /* 1601166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601176 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1601179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601200 */     // GIR_Coverage, 3280,
     /* 1601200 */     GIR_EraseRootFromParent_Done,
     /* 1601201 */   // Label 22104: @1601201
     /* 1601201 */   GIM_Try, /*On fail goto*//*Label 22105*/ GIMT_Encode4(1601287), // Rule ID 3281 //
     /* 1601206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1601217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1601220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1601223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1601229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601252 */     // MIs[0] policy
     /* 1601252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601262 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1601265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1601283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601286 */     // GIR_Coverage, 3281,
     /* 1601286 */     GIR_EraseRootFromParent_Done,
     /* 1601287 */   // Label 22105: @1601287
     /* 1601287 */   GIM_Try, /*On fail goto*//*Label 22106*/ GIMT_Encode4(1601373), // Rule ID 3284 //
     /* 1601292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1601303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1601306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1601309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601338 */     // MIs[0] policy
     /* 1601338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601348 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1601351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601372 */     // GIR_Coverage, 3284,
     /* 1601372 */     GIR_EraseRootFromParent_Done,
     /* 1601373 */   // Label 22106: @1601373
     /* 1601373 */   GIM_Try, /*On fail goto*//*Label 22107*/ GIMT_Encode4(1601459), // Rule ID 3285 //
     /* 1601378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1601389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1601392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1601395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1601401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1601408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1601416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601424 */     // MIs[0] policy
     /* 1601424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601434 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11553:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M2_MASK),
     /* 1601437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601458 */     // GIR_Coverage, 3285,
     /* 1601458 */     GIR_EraseRootFromParent_Done,
     /* 1601459 */   // Label 22107: @1601459
     /* 1601459 */   GIM_Try, /*On fail goto*//*Label 22108*/ GIMT_Encode4(1601545), // Rule ID 3288 //
     /* 1601464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1601475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1601478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1601481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601510 */     // MIs[0] policy
     /* 1601510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601520 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1601523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601544 */     // GIR_Coverage, 3288,
     /* 1601544 */     GIR_EraseRootFromParent_Done,
     /* 1601545 */   // Label 22108: @1601545
     /* 1601545 */   GIM_Try, /*On fail goto*//*Label 22109*/ GIMT_Encode4(1601631), // Rule ID 3289 //
     /* 1601550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1601561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1601564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1601567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1601573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1601580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1601588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601596 */     // MIs[0] policy
     /* 1601596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601606 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11553:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M4_MASK),
     /* 1601609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601630 */     // GIR_Coverage, 3289,
     /* 1601630 */     GIR_EraseRootFromParent_Done,
     /* 1601631 */   // Label 22109: @1601631
     /* 1601631 */   GIM_Try, /*On fail goto*//*Label 22110*/ GIMT_Encode4(1601717), // Rule ID 3292 //
     /* 1601636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1601639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601682 */     // MIs[0] policy
     /* 1601682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601692 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1601695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601716 */     // GIR_Coverage, 3292,
     /* 1601716 */     GIR_EraseRootFromParent_Done,
     /* 1601717 */   // Label 22110: @1601717
     /* 1601717 */   GIM_Try, /*On fail goto*//*Label 22111*/ GIMT_Encode4(1601803), // Rule ID 3293 //
     /* 1601722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1601725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsub_mask),
     /* 1601730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1601733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1601736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1601739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1601745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1601752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1601760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601768 */     // MIs[0] policy
     /* 1601768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601778 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11553:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSUB_VX_M8_MASK),
     /* 1601781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1601799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601802 */     // GIR_Coverage, 3293,
     /* 1601802 */     GIR_EraseRootFromParent_Done,
     /* 1601803 */   // Label 22111: @1601803
     /* 1601803 */   GIM_Try, /*On fail goto*//*Label 22112*/ GIMT_Encode4(1601889), // Rule ID 3296 //
     /* 1601808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1601816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1601828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1601834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601854 */     // MIs[0] policy
     /* 1601854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601864 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1601864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1601867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601888 */     // GIR_Coverage, 3296,
     /* 1601888 */     GIR_EraseRootFromParent_Done,
     /* 1601889 */   // Label 22112: @1601889
     /* 1601889 */   GIM_Try, /*On fail goto*//*Label 22113*/ GIMT_Encode4(1601975), // Rule ID 3297 //
     /* 1601894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1601897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1601902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1601905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1601908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1601911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1601914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1601917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1601920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1601924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1601932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1601936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1601940 */     // MIs[0] policy
     /* 1601940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1601943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1601950 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1601950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF8_MASK),
     /* 1601953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1601955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1601957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1601959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1601961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1601963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1601968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1601971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1601973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1601974 */     // GIR_Coverage, 3297,
     /* 1601974 */     GIR_EraseRootFromParent_Done,
     /* 1601975 */   // Label 22113: @1601975
     /* 1601975 */   GIM_Try, /*On fail goto*//*Label 22114*/ GIMT_Encode4(1602061), // Rule ID 3300 //
     /* 1601980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1601983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1601988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1601991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1601994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1601997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602026 */     // MIs[0] policy
     /* 1602026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602036 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1602039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602060 */     // GIR_Coverage, 3300,
     /* 1602060 */     GIR_EraseRootFromParent_Done,
     /* 1602061 */   // Label 22114: @1602061
     /* 1602061 */   GIM_Try, /*On fail goto*//*Label 22115*/ GIMT_Encode4(1602147), // Rule ID 3301 //
     /* 1602066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1602077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1602080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1602083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602112 */     // MIs[0] policy
     /* 1602112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602122 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1602125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602146 */     // GIR_Coverage, 3301,
     /* 1602146 */     GIR_EraseRootFromParent_Done,
     /* 1602147 */   // Label 22115: @1602147
     /* 1602147 */   GIM_Try, /*On fail goto*//*Label 22116*/ GIMT_Encode4(1602233), // Rule ID 3304 //
     /* 1602152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1602163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1602166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1602169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602198 */     // MIs[0] policy
     /* 1602198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602208 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602232 */     // GIR_Coverage, 3304,
     /* 1602232 */     GIR_EraseRootFromParent_Done,
     /* 1602233 */   // Label 22116: @1602233
     /* 1602233 */   GIM_Try, /*On fail goto*//*Label 22117*/ GIMT_Encode4(1602319), // Rule ID 3305 //
     /* 1602238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1602249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1602252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1602255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1602261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602284 */     // MIs[0] policy
     /* 1602284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602294 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602318 */     // GIR_Coverage, 3305,
     /* 1602318 */     GIR_EraseRootFromParent_Done,
     /* 1602319 */   // Label 22117: @1602319
     /* 1602319 */   GIM_Try, /*On fail goto*//*Label 22118*/ GIMT_Encode4(1602405), // Rule ID 3308 //
     /* 1602324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1602335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1602338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1602341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602370 */     // MIs[0] policy
     /* 1602370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602380 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1602383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602404 */     // GIR_Coverage, 3308,
     /* 1602404 */     GIR_EraseRootFromParent_Done,
     /* 1602405 */   // Label 22118: @1602405
     /* 1602405 */   GIM_Try, /*On fail goto*//*Label 22119*/ GIMT_Encode4(1602491), // Rule ID 3309 //
     /* 1602410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1602421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1602424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1602427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602456 */     // MIs[0] policy
     /* 1602456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602466 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF4_MASK),
     /* 1602469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602490 */     // GIR_Coverage, 3309,
     /* 1602490 */     GIR_EraseRootFromParent_Done,
     /* 1602491 */   // Label 22119: @1602491
     /* 1602491 */   GIM_Try, /*On fail goto*//*Label 22120*/ GIMT_Encode4(1602577), // Rule ID 3312 //
     /* 1602496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1602513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602542 */     // MIs[0] policy
     /* 1602542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602552 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602576 */     // GIR_Coverage, 3312,
     /* 1602576 */     GIR_EraseRootFromParent_Done,
     /* 1602577 */   // Label 22120: @1602577
     /* 1602577 */   GIM_Try, /*On fail goto*//*Label 22121*/ GIMT_Encode4(1602663), // Rule ID 3313 //
     /* 1602582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1602593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1602596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1602599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1602605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602628 */     // MIs[0] policy
     /* 1602628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602638 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1602659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602662 */     // GIR_Coverage, 3313,
     /* 1602662 */     GIR_EraseRootFromParent_Done,
     /* 1602663 */   // Label 22121: @1602663
     /* 1602663 */   GIM_Try, /*On fail goto*//*Label 22122*/ GIMT_Encode4(1602749), // Rule ID 3316 //
     /* 1602668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602714 */     // MIs[0] policy
     /* 1602714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602724 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602748 */     // GIR_Coverage, 3316,
     /* 1602748 */     GIR_EraseRootFromParent_Done,
     /* 1602749 */   // Label 22122: @1602749
     /* 1602749 */   GIM_Try, /*On fail goto*//*Label 22123*/ GIMT_Encode4(1602835), // Rule ID 3317 //
     /* 1602754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1602765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1602768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1602771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1602777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602800 */     // MIs[0] policy
     /* 1602800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602810 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_MF2_MASK),
     /* 1602813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1602831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602834 */     // GIR_Coverage, 3317,
     /* 1602834 */     GIR_EraseRootFromParent_Done,
     /* 1602835 */   // Label 22123: @1602835
     /* 1602835 */   GIM_Try, /*On fail goto*//*Label 22124*/ GIMT_Encode4(1602921), // Rule ID 3320 //
     /* 1602840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1602843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1602860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1602866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602886 */     // MIs[0] policy
     /* 1602886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602896 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1602896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1602899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1602914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1602917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1602919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1602920 */     // GIR_Coverage, 3320,
     /* 1602920 */     GIR_EraseRootFromParent_Done,
     /* 1602921 */   // Label 22124: @1602921
     /* 1602921 */   GIM_Try, /*On fail goto*//*Label 22125*/ GIMT_Encode4(1603007), // Rule ID 3321 //
     /* 1602926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1602929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1602934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1602937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1602940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1602943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1602946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1602949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1602952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1602956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1602964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1602968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1602972 */     // MIs[0] policy
     /* 1602972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1602975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1602982 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11461:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1602982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1602985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1602987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1602989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1602991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1602993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1602995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603006 */     // GIR_Coverage, 3321,
     /* 1603006 */     GIR_EraseRootFromParent_Done,
     /* 1603007 */   // Label 22125: @1603007
     /* 1603007 */   GIM_Try, /*On fail goto*//*Label 22126*/ GIMT_Encode4(1603093), // Rule ID 3324 //
     /* 1603012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1603023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1603026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603058 */     // MIs[0] policy
     /* 1603058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603068 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603092 */     // GIR_Coverage, 3324,
     /* 1603092 */     GIR_EraseRootFromParent_Done,
     /* 1603093 */   // Label 22126: @1603093
     /* 1603093 */   GIM_Try, /*On fail goto*//*Label 22127*/ GIMT_Encode4(1603179), // Rule ID 3325 //
     /* 1603098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1603109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1603112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1603115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1603121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603144 */     // MIs[0] policy
     /* 1603144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603154 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11461:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1603175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603178 */     // GIR_Coverage, 3325,
     /* 1603178 */     GIR_EraseRootFromParent_Done,
     /* 1603179 */   // Label 22127: @1603179
     /* 1603179 */   GIM_Try, /*On fail goto*//*Label 22128*/ GIMT_Encode4(1603265), // Rule ID 3328 //
     /* 1603184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1603195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1603198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1603201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603230 */     // MIs[0] policy
     /* 1603230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603240 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603264 */     // GIR_Coverage, 3328,
     /* 1603264 */     GIR_EraseRootFromParent_Done,
     /* 1603265 */   // Label 22128: @1603265
     /* 1603265 */   GIM_Try, /*On fail goto*//*Label 22129*/ GIMT_Encode4(1603351), // Rule ID 3329 //
     /* 1603270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1603281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1603284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1603287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1603293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603316 */     // MIs[0] policy
     /* 1603316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603326 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11461:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1603347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603350 */     // GIR_Coverage, 3329,
     /* 1603350 */     GIR_EraseRootFromParent_Done,
     /* 1603351 */   // Label 22129: @1603351
     /* 1603351 */   GIM_Try, /*On fail goto*//*Label 22130*/ GIMT_Encode4(1603437), // Rule ID 3332 //
     /* 1603356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1603359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1603367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1603370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1603373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603402 */     // MIs[0] policy
     /* 1603402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603412 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1603433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603436 */     // GIR_Coverage, 3332,
     /* 1603436 */     GIR_EraseRootFromParent_Done,
     /* 1603437 */   // Label 22130: @1603437
     /* 1603437 */   GIM_Try, /*On fail goto*//*Label 22131*/ GIMT_Encode4(1603523), // Rule ID 3333 //
     /* 1603442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1603445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1603453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1603456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1603459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1603465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1603472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1603480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603488 */     // MIs[0] policy
     /* 1603488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603498 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11461:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M1_MASK),
     /* 1603501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1603519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603522 */     // GIR_Coverage, 3333,
     /* 1603522 */     GIR_EraseRootFromParent_Done,
     /* 1603523 */   // Label 22131: @1603523
     /* 1603523 */   GIM_Try, /*On fail goto*//*Label 22132*/ GIMT_Encode4(1603609), // Rule ID 3336 //
     /* 1603528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603574 */     // MIs[0] policy
     /* 1603574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603584 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1603587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603608 */     // GIR_Coverage, 3336,
     /* 1603608 */     GIR_EraseRootFromParent_Done,
     /* 1603609 */   // Label 22132: @1603609
     /* 1603609 */   GIM_Try, /*On fail goto*//*Label 22133*/ GIMT_Encode4(1603695), // Rule ID 3337 //
     /* 1603614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1603625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1603628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1603631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1603637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1603644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1603652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603660 */     // MIs[0] policy
     /* 1603660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1603673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603694 */     // GIR_Coverage, 3337,
     /* 1603694 */     GIR_EraseRootFromParent_Done,
     /* 1603695 */   // Label 22133: @1603695
     /* 1603695 */   GIM_Try, /*On fail goto*//*Label 22134*/ GIMT_Encode4(1603781), // Rule ID 3340 //
     /* 1603700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603746 */     // MIs[0] policy
     /* 1603746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603756 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1603759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603780 */     // GIR_Coverage, 3340,
     /* 1603780 */     GIR_EraseRootFromParent_Done,
     /* 1603781 */   // Label 22134: @1603781
     /* 1603781 */   GIM_Try, /*On fail goto*//*Label 22135*/ GIMT_Encode4(1603867), // Rule ID 3341 //
     /* 1603786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1603797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1603800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1603803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1603809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1603816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1603824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603832 */     // MIs[0] policy
     /* 1603832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603842 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1603842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1603845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603866 */     // GIR_Coverage, 3341,
     /* 1603866 */     GIR_EraseRootFromParent_Done,
     /* 1603867 */   // Label 22135: @1603867
     /* 1603867 */   GIM_Try, /*On fail goto*//*Label 22136*/ GIMT_Encode4(1603953), // Rule ID 3344 //
     /* 1603872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1603875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1603892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1603898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1603914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1603918 */     // MIs[0] policy
     /* 1603918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1603921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1603928 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1603928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1603931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1603933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1603935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1603937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1603939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1603941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1603946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1603949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1603951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1603952 */     // GIR_Coverage, 3344,
     /* 1603952 */     GIR_EraseRootFromParent_Done,
     /* 1603953 */   // Label 22136: @1603953
     /* 1603953 */   GIM_Try, /*On fail goto*//*Label 22137*/ GIMT_Encode4(1604039), // Rule ID 3345 //
     /* 1603958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1603961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1603966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1603969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1603972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1603975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1603978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1603981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1603984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1603988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1603996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604004 */     // MIs[0] policy
     /* 1604004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604014 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1604017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1604035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604038 */     // GIR_Coverage, 3345,
     /* 1604038 */     GIR_EraseRootFromParent_Done,
     /* 1604039 */   // Label 22137: @1604039
     /* 1604039 */   GIM_Try, /*On fail goto*//*Label 22138*/ GIMT_Encode4(1604125), // Rule ID 3348 //
     /* 1604044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1604055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1604058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1604061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604090 */     // MIs[0] policy
     /* 1604090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604100 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1604103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604124 */     // GIR_Coverage, 3348,
     /* 1604124 */     GIR_EraseRootFromParent_Done,
     /* 1604125 */   // Label 22138: @1604125
     /* 1604125 */   GIM_Try, /*On fail goto*//*Label 22139*/ GIMT_Encode4(1604211), // Rule ID 3349 //
     /* 1604130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1604141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1604144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1604147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604176 */     // MIs[0] policy
     /* 1604176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604186 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1604189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604210 */     // GIR_Coverage, 3349,
     /* 1604210 */     GIR_EraseRootFromParent_Done,
     /* 1604211 */   // Label 22139: @1604211
     /* 1604211 */   GIM_Try, /*On fail goto*//*Label 22140*/ GIMT_Encode4(1604297), // Rule ID 3352 //
     /* 1604216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1604227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1604230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604262 */     // MIs[0] policy
     /* 1604262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604272 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1604275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604296 */     // GIR_Coverage, 3352,
     /* 1604296 */     GIR_EraseRootFromParent_Done,
     /* 1604297 */   // Label 22140: @1604297
     /* 1604297 */   GIM_Try, /*On fail goto*//*Label 22141*/ GIMT_Encode4(1604383), // Rule ID 3353 //
     /* 1604302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1604313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1604316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1604319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604348 */     // MIs[0] policy
     /* 1604348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604358 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1604361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604382 */     // GIR_Coverage, 3353,
     /* 1604382 */     GIR_EraseRootFromParent_Done,
     /* 1604383 */   // Label 22141: @1604383
     /* 1604383 */   GIM_Try, /*On fail goto*//*Label 22142*/ GIMT_Encode4(1604469), // Rule ID 3356 //
     /* 1604388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1604399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1604402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1604405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604434 */     // MIs[0] policy
     /* 1604434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604444 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1604447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604468 */     // GIR_Coverage, 3356,
     /* 1604468 */     GIR_EraseRootFromParent_Done,
     /* 1604469 */   // Label 22142: @1604469
     /* 1604469 */   GIM_Try, /*On fail goto*//*Label 22143*/ GIMT_Encode4(1604555), // Rule ID 3357 //
     /* 1604474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1604485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1604488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1604491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1604497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604520 */     // MIs[0] policy
     /* 1604520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604530 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1604533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1604551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604554 */     // GIR_Coverage, 3357,
     /* 1604554 */     GIR_EraseRootFromParent_Done,
     /* 1604555 */   // Label 22143: @1604555
     /* 1604555 */   GIM_Try, /*On fail goto*//*Label 22144*/ GIMT_Encode4(1604641), // Rule ID 3360 //
     /* 1604560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604606 */     // MIs[0] policy
     /* 1604606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604616 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1604619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604640 */     // GIR_Coverage, 3360,
     /* 1604640 */     GIR_EraseRootFromParent_Done,
     /* 1604641 */   // Label 22144: @1604641
     /* 1604641 */   GIM_Try, /*On fail goto*//*Label 22145*/ GIMT_Encode4(1604727), // Rule ID 3361 //
     /* 1604646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1604657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1604660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1604663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1604669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1604676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1604684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604692 */     // MIs[0] policy
     /* 1604692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1604705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604726 */     // GIR_Coverage, 3361,
     /* 1604726 */     GIR_EraseRootFromParent_Done,
     /* 1604727 */   // Label 22145: @1604727
     /* 1604727 */   GIM_Try, /*On fail goto*//*Label 22146*/ GIMT_Encode4(1604813), // Rule ID 3364 //
     /* 1604732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604778 */     // MIs[0] policy
     /* 1604778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604788 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1604791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604812 */     // GIR_Coverage, 3364,
     /* 1604812 */     GIR_EraseRootFromParent_Done,
     /* 1604813 */   // Label 22146: @1604813
     /* 1604813 */   GIM_Try, /*On fail goto*//*Label 22147*/ GIMT_Encode4(1604899), // Rule ID 3365 //
     /* 1604818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1604829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1604832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1604835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1604838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1604841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1604844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1604848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1604856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604864 */     // MIs[0] policy
     /* 1604864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604874 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1604874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1604877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604898 */     // GIR_Coverage, 3365,
     /* 1604898 */     GIR_EraseRootFromParent_Done,
     /* 1604899 */   // Label 22147: @1604899
     /* 1604899 */   GIM_Try, /*On fail goto*//*Label 22148*/ GIMT_Encode4(1604985), // Rule ID 3368 //
     /* 1604904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1604907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1604915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1604918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1604921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1604924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1604927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1604930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1604934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1604942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1604946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1604950 */     // MIs[0] policy
     /* 1604950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1604953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1604960 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1604960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1604963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1604965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1604967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1604969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1604971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1604973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1604978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1604981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1604983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1604984 */     // GIR_Coverage, 3368,
     /* 1604984 */     GIR_EraseRootFromParent_Done,
     /* 1604985 */   // Label 22148: @1604985
     /* 1604985 */   GIM_Try, /*On fail goto*//*Label 22149*/ GIMT_Encode4(1605071), // Rule ID 3369 //
     /* 1604990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1604993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1604998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1605001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1605004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1605007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1605013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605036 */     // MIs[0] policy
     /* 1605036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605046 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1605049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1605067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605070 */     // GIR_Coverage, 3369,
     /* 1605070 */     GIR_EraseRootFromParent_Done,
     /* 1605071 */   // Label 22149: @1605071
     /* 1605071 */   GIM_Try, /*On fail goto*//*Label 22150*/ GIMT_Encode4(1605157), // Rule ID 3372 //
     /* 1605076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1605087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1605090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605122 */     // MIs[0] policy
     /* 1605122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605132 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1605135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605156 */     // GIR_Coverage, 3372,
     /* 1605156 */     GIR_EraseRootFromParent_Done,
     /* 1605157 */   // Label 22150: @1605157
     /* 1605157 */   GIM_Try, /*On fail goto*//*Label 22151*/ GIMT_Encode4(1605243), // Rule ID 3373 //
     /* 1605162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1605173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1605176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1605179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1605192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1605200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605208 */     // MIs[0] policy
     /* 1605208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605218 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11461:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M2_MASK),
     /* 1605221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605242 */     // GIR_Coverage, 3373,
     /* 1605242 */     GIR_EraseRootFromParent_Done,
     /* 1605243 */   // Label 22151: @1605243
     /* 1605243 */   GIM_Try, /*On fail goto*//*Label 22152*/ GIMT_Encode4(1605329), // Rule ID 3376 //
     /* 1605248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1605259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1605262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605294 */     // MIs[0] policy
     /* 1605294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605304 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1605307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605328 */     // GIR_Coverage, 3376,
     /* 1605328 */     GIR_EraseRootFromParent_Done,
     /* 1605329 */   // Label 22152: @1605329
     /* 1605329 */   GIM_Try, /*On fail goto*//*Label 22153*/ GIMT_Encode4(1605415), // Rule ID 3377 //
     /* 1605334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1605345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1605348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1605351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1605364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1605372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605380 */     // MIs[0] policy
     /* 1605380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11461:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M4_MASK),
     /* 1605393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605414 */     // GIR_Coverage, 3377,
     /* 1605414 */     GIR_EraseRootFromParent_Done,
     /* 1605415 */   // Label 22153: @1605415
     /* 1605415 */   GIM_Try, /*On fail goto*//*Label 22154*/ GIMT_Encode4(1605501), // Rule ID 3380 //
     /* 1605420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1605423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1605431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1605434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1605440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605466 */     // MIs[0] policy
     /* 1605466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605476 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1605479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605500 */     // GIR_Coverage, 3380,
     /* 1605500 */     GIR_EraseRootFromParent_Done,
     /* 1605501 */   // Label 22154: @1605501
     /* 1605501 */   GIM_Try, /*On fail goto*//*Label 22155*/ GIMT_Encode4(1605587), // Rule ID 3381 //
     /* 1605506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1605509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrsub_mask),
     /* 1605514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1605517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1605520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1605523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1605526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1605529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1605536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1605544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1605548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605552 */     // MIs[0] policy
     /* 1605552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605562 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11461:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRSUB_VX_M8_MASK),
     /* 1605565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1605583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605586 */     // GIR_Coverage, 3381,
     /* 1605586 */     GIR_EraseRootFromParent_Done,
     /* 1605587 */   // Label 22155: @1605587
     /* 1605587 */   GIM_Try, /*On fail goto*//*Label 22156*/ GIMT_Encode4(1605673), // Rule ID 3472 //
     /* 1605592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1605600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1605612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605638 */     // MIs[0] policy
     /* 1605638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605648 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1605651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605672 */     // GIR_Coverage, 3472,
     /* 1605672 */     GIR_EraseRootFromParent_Done,
     /* 1605673 */   // Label 22156: @1605673
     /* 1605673 */   GIM_Try, /*On fail goto*//*Label 22157*/ GIMT_Encode4(1605759), // Rule ID 3473 //
     /* 1605678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1605686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1605689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1605692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1605695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1605698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1605701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605724 */     // MIs[0] policy
     /* 1605724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605734 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF8_MASK),
     /* 1605737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605758 */     // GIR_Coverage, 3473,
     /* 1605758 */     GIR_EraseRootFromParent_Done,
     /* 1605759 */   // Label 22157: @1605759
     /* 1605759 */   GIM_Try, /*On fail goto*//*Label 22158*/ GIMT_Encode4(1605845), // Rule ID 3476 //
     /* 1605764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1605772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1605784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605810 */     // MIs[0] policy
     /* 1605810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605820 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1605823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605844 */     // GIR_Coverage, 3476,
     /* 1605844 */     GIR_EraseRootFromParent_Done,
     /* 1605845 */   // Label 22158: @1605845
     /* 1605845 */   GIM_Try, /*On fail goto*//*Label 22159*/ GIMT_Encode4(1605931), // Rule ID 3477 //
     /* 1605850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1605853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1605858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1605861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1605864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1605867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1605870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1605873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1605876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605896 */     // MIs[0] policy
     /* 1605896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605906 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1605906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1605909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1605915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1605917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1605919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1605924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1605927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1605929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1605930 */     // GIR_Coverage, 3477,
     /* 1605930 */     GIR_EraseRootFromParent_Done,
     /* 1605931 */   // Label 22159: @1605931
     /* 1605931 */   GIM_Try, /*On fail goto*//*Label 22160*/ GIMT_Encode4(1606017), // Rule ID 3480 //
     /* 1605936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1605939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1605944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1605947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1605950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1605953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1605956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1605959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1605962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1605966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1605978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1605982 */     // MIs[0] policy
     /* 1605982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1605985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1605992 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1605992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1605995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1605997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1605999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606016 */     // GIR_Coverage, 3480,
     /* 1606016 */     GIR_EraseRootFromParent_Done,
     /* 1606017 */   // Label 22160: @1606017
     /* 1606017 */   GIM_Try, /*On fail goto*//*Label 22161*/ GIMT_Encode4(1606103), // Rule ID 3481 //
     /* 1606022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1606033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1606036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1606039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1606042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606068 */     // MIs[0] policy
     /* 1606068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606078 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1606081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606102 */     // GIR_Coverage, 3481,
     /* 1606102 */     GIR_EraseRootFromParent_Done,
     /* 1606103 */   // Label 22161: @1606103
     /* 1606103 */   GIM_Try, /*On fail goto*//*Label 22162*/ GIMT_Encode4(1606189), // Rule ID 3484 //
     /* 1606108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1606128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606154 */     // MIs[0] policy
     /* 1606154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606164 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1606167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606188 */     // GIR_Coverage, 3484,
     /* 1606188 */     GIR_EraseRootFromParent_Done,
     /* 1606189 */   // Label 22162: @1606189
     /* 1606189 */   GIM_Try, /*On fail goto*//*Label 22163*/ GIMT_Encode4(1606275), // Rule ID 3485 //
     /* 1606194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1606205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1606208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1606211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1606214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1606217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606240 */     // MIs[0] policy
     /* 1606240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606250 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1606253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606274 */     // GIR_Coverage, 3485,
     /* 1606274 */     GIR_EraseRootFromParent_Done,
     /* 1606275 */   // Label 22163: @1606275
     /* 1606275 */   GIM_Try, /*On fail goto*//*Label 22164*/ GIMT_Encode4(1606361), // Rule ID 3488 //
     /* 1606280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1606291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1606294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1606300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606326 */     // MIs[0] policy
     /* 1606326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606336 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1606339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606360 */     // GIR_Coverage, 3488,
     /* 1606360 */     GIR_EraseRootFromParent_Done,
     /* 1606361 */   // Label 22164: @1606361
     /* 1606361 */   GIM_Try, /*On fail goto*//*Label 22165*/ GIMT_Encode4(1606447), // Rule ID 3489 //
     /* 1606366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1606377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1606380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1606383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1606386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1606389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1606396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1606408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606412 */     // MIs[0] policy
     /* 1606412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606422 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1606425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606446 */     // GIR_Coverage, 3489,
     /* 1606446 */     GIR_EraseRootFromParent_Done,
     /* 1606447 */   // Label 22165: @1606447
     /* 1606447 */   GIM_Try, /*On fail goto*//*Label 22166*/ GIMT_Encode4(1606533), // Rule ID 3492 //
     /* 1606452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1606463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1606466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1606472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606498 */     // MIs[0] policy
     /* 1606498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606508 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1606511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606532 */     // GIR_Coverage, 3492,
     /* 1606532 */     GIR_EraseRootFromParent_Done,
     /* 1606533 */   // Label 22166: @1606533
     /* 1606533 */   GIM_Try, /*On fail goto*//*Label 22167*/ GIMT_Encode4(1606619), // Rule ID 3493 //
     /* 1606538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1606549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1606552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1606555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1606558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1606561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1606568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1606572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1606580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606584 */     // MIs[0] policy
     /* 1606584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606594 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1606597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1606615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606618 */     // GIR_Coverage, 3493,
     /* 1606618 */     GIR_EraseRootFromParent_Done,
     /* 1606619 */   // Label 22167: @1606619
     /* 1606619 */   GIM_Try, /*On fail goto*//*Label 22168*/ GIMT_Encode4(1606705), // Rule ID 3496 //
     /* 1606624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1606635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1606638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1606641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1606644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606670 */     // MIs[0] policy
     /* 1606670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606680 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1606683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606704 */     // GIR_Coverage, 3496,
     /* 1606704 */     GIR_EraseRootFromParent_Done,
     /* 1606705 */   // Label 22168: @1606705
     /* 1606705 */   GIM_Try, /*On fail goto*//*Label 22169*/ GIMT_Encode4(1606791), // Rule ID 3497 //
     /* 1606710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1606721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1606724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1606727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1606730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1606733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606756 */     // MIs[0] policy
     /* 1606756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606766 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF4_MASK),
     /* 1606769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606790 */     // GIR_Coverage, 3497,
     /* 1606790 */     GIR_EraseRootFromParent_Done,
     /* 1606791 */   // Label 22169: @1606791
     /* 1606791 */   GIM_Try, /*On fail goto*//*Label 22170*/ GIMT_Encode4(1606877), // Rule ID 3500 //
     /* 1606796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1606816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606842 */     // MIs[0] policy
     /* 1606842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606852 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1606852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1606855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606876 */     // GIR_Coverage, 3500,
     /* 1606876 */     GIR_EraseRootFromParent_Done,
     /* 1606877 */   // Label 22170: @1606877
     /* 1606877 */   GIM_Try, /*On fail goto*//*Label 22171*/ GIMT_Encode4(1606963), // Rule ID 3501 //
     /* 1606882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1606885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1606893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1606896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1606899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1606902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1606905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1606908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1606912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1606924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1606928 */     // MIs[0] policy
     /* 1606928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1606931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1606938 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1606938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1606941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1606943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1606945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1606947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1606949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1606951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1606956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1606959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1606961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1606962 */     // GIR_Coverage, 3501,
     /* 1606962 */     GIR_EraseRootFromParent_Done,
     /* 1606963 */   // Label 22171: @1606963
     /* 1606963 */   GIM_Try, /*On fail goto*//*Label 22172*/ GIMT_Encode4(1607049), // Rule ID 3504 //
     /* 1606968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1606971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1606976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1606979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1606982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1606985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1606988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1606991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1606994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1606998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607014 */     // MIs[0] policy
     /* 1607014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607024 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1607027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607048 */     // GIR_Coverage, 3504,
     /* 1607048 */     GIR_EraseRootFromParent_Done,
     /* 1607049 */   // Label 22172: @1607049
     /* 1607049 */   GIM_Try, /*On fail goto*//*Label 22173*/ GIMT_Encode4(1607135), // Rule ID 3505 //
     /* 1607054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1607065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1607068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1607071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1607074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607100 */     // MIs[0] policy
     /* 1607100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1607113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607134 */     // GIR_Coverage, 3505,
     /* 1607134 */     GIR_EraseRootFromParent_Done,
     /* 1607135 */   // Label 22173: @1607135
     /* 1607135 */   GIM_Try, /*On fail goto*//*Label 22174*/ GIMT_Encode4(1607221), // Rule ID 3508 //
     /* 1607140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1607160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607186 */     // MIs[0] policy
     /* 1607186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607196 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1607199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607220 */     // GIR_Coverage, 3508,
     /* 1607220 */     GIR_EraseRootFromParent_Done,
     /* 1607221 */   // Label 22174: @1607221
     /* 1607221 */   GIM_Try, /*On fail goto*//*Label 22175*/ GIMT_Encode4(1607307), // Rule ID 3509 //
     /* 1607226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1607237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1607240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1607243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1607246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1607249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607272 */     // MIs[0] policy
     /* 1607272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607282 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1607285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607306 */     // GIR_Coverage, 3509,
     /* 1607306 */     GIR_EraseRootFromParent_Done,
     /* 1607307 */   // Label 22175: @1607307
     /* 1607307 */   GIM_Try, /*On fail goto*//*Label 22176*/ GIMT_Encode4(1607393), // Rule ID 3512 //
     /* 1607312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1607315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1607332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607358 */     // MIs[0] policy
     /* 1607358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607368 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1607371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607392 */     // GIR_Coverage, 3512,
     /* 1607392 */     GIR_EraseRootFromParent_Done,
     /* 1607393 */   // Label 22176: @1607393
     /* 1607393 */   GIM_Try, /*On fail goto*//*Label 22177*/ GIMT_Encode4(1607479), // Rule ID 3513 //
     /* 1607398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1607401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1607409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1607412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1607415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1607418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1607421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1607428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1607432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607444 */     // MIs[0] policy
     /* 1607444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607454 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1607457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1607475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607478 */     // GIR_Coverage, 3513,
     /* 1607478 */     GIR_EraseRootFromParent_Done,
     /* 1607479 */   // Label 22177: @1607479
     /* 1607479 */   GIM_Try, /*On fail goto*//*Label 22178*/ GIMT_Encode4(1607565), // Rule ID 3516 //
     /* 1607484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1607487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1607495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1607498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1607504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607530 */     // MIs[0] policy
     /* 1607530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607540 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1607543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607564 */     // GIR_Coverage, 3516,
     /* 1607564 */     GIR_EraseRootFromParent_Done,
     /* 1607565 */   // Label 22178: @1607565
     /* 1607565 */   GIM_Try, /*On fail goto*//*Label 22179*/ GIMT_Encode4(1607651), // Rule ID 3517 //
     /* 1607570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1607573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1607581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1607584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1607587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1607590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1607593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1607600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607616 */     // MIs[0] policy
     /* 1607616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607626 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_MF2_MASK),
     /* 1607629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607650 */     // GIR_Coverage, 3517,
     /* 1607650 */     GIR_EraseRootFromParent_Done,
     /* 1607651 */   // Label 22179: @1607651
     /* 1607651 */   GIM_Try, /*On fail goto*//*Label 22180*/ GIMT_Encode4(1607737), // Rule ID 3520 //
     /* 1607656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1607659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1607676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607702 */     // MIs[0] policy
     /* 1607702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1607715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607736 */     // GIR_Coverage, 3520,
     /* 1607736 */     GIR_EraseRootFromParent_Done,
     /* 1607737 */   // Label 22180: @1607737
     /* 1607737 */   GIM_Try, /*On fail goto*//*Label 22181*/ GIMT_Encode4(1607823), // Rule ID 3521 //
     /* 1607742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1607745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1607753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1607756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1607759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1607762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1607765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1607772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1607784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607788 */     // MIs[0] policy
     /* 1607788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M1_MASK),
     /* 1607801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607822 */     // GIR_Coverage, 3521,
     /* 1607822 */     GIR_EraseRootFromParent_Done,
     /* 1607823 */   // Label 22181: @1607823
     /* 1607823 */   GIM_Try, /*On fail goto*//*Label 22182*/ GIMT_Encode4(1607909), // Rule ID 3524 //
     /* 1607828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1607831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1607839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1607842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1607848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1607854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607874 */     // MIs[0] policy
     /* 1607874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607884 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1607884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1607887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607908 */     // GIR_Coverage, 3524,
     /* 1607908 */     GIR_EraseRootFromParent_Done,
     /* 1607909 */   // Label 22182: @1607909
     /* 1607909 */   GIM_Try, /*On fail goto*//*Label 22183*/ GIMT_Encode4(1607995), // Rule ID 3525 //
     /* 1607914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1607917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1607922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1607925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1607928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1607931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1607934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1607937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1607940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1607944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1607948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1607956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1607960 */     // MIs[0] policy
     /* 1607960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1607963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1607970 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1607970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M2_MASK),
     /* 1607973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1607975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1607977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1607979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1607981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1607983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1607988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1607991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1607993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1607994 */     // GIR_Coverage, 3525,
     /* 1607994 */     GIR_EraseRootFromParent_Done,
     /* 1607995 */   // Label 22183: @1607995
     /* 1607995 */   GIM_Try, /*On fail goto*//*Label 22184*/ GIMT_Encode4(1608081), // Rule ID 3528 //
     /* 1608000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1608003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1608020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608046 */     // MIs[0] policy
     /* 1608046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608056 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1608059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608080 */     // GIR_Coverage, 3528,
     /* 1608080 */     GIR_EraseRootFromParent_Done,
     /* 1608081 */   // Label 22184: @1608081
     /* 1608081 */   GIM_Try, /*On fail goto*//*Label 22185*/ GIMT_Encode4(1608167), // Rule ID 3529 //
     /* 1608086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1608089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1608097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1608100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1608103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1608106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1608116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1608120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608132 */     // MIs[0] policy
     /* 1608132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608142 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VV_M4_MASK),
     /* 1608145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1608163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608166 */     // GIR_Coverage, 3529,
     /* 1608166 */     GIR_EraseRootFromParent_Done,
     /* 1608167 */   // Label 22185: @1608167
     /* 1608167 */   GIM_Try, /*On fail goto*//*Label 22186*/ GIMT_Encode4(1608253), // Rule ID 3532 //
     /* 1608172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1608183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1608186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608218 */     // MIs[0] policy
     /* 1608218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608228 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1608231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608252 */     // GIR_Coverage, 3532,
     /* 1608252 */     GIR_EraseRootFromParent_Done,
     /* 1608253 */   // Label 22186: @1608253
     /* 1608253 */   GIM_Try, /*On fail goto*//*Label 22187*/ GIMT_Encode4(1608339), // Rule ID 3533 //
     /* 1608258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1608269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1608272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1608275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1608281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608304 */     // MIs[0] policy
     /* 1608304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608314 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF8_MASK),
     /* 1608317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608338 */     // GIR_Coverage, 3533,
     /* 1608338 */     GIR_EraseRootFromParent_Done,
     /* 1608339 */   // Label 22187: @1608339
     /* 1608339 */   GIM_Try, /*On fail goto*//*Label 22188*/ GIMT_Encode4(1608425), // Rule ID 3536 //
     /* 1608344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1608355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1608358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608390 */     // MIs[0] policy
     /* 1608390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1608403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608424 */     // GIR_Coverage, 3536,
     /* 1608424 */     GIR_EraseRootFromParent_Done,
     /* 1608425 */   // Label 22188: @1608425
     /* 1608425 */   GIM_Try, /*On fail goto*//*Label 22189*/ GIMT_Encode4(1608511), // Rule ID 3537 //
     /* 1608430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1608441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1608444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1608447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1608453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608476 */     // MIs[0] policy
     /* 1608476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608486 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1608489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608510 */     // GIR_Coverage, 3537,
     /* 1608510 */     GIR_EraseRootFromParent_Done,
     /* 1608511 */   // Label 22189: @1608511
     /* 1608511 */   GIM_Try, /*On fail goto*//*Label 22190*/ GIMT_Encode4(1608597), // Rule ID 3540 //
     /* 1608516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1608527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1608530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608562 */     // MIs[0] policy
     /* 1608562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608572 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1608575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608596 */     // GIR_Coverage, 3540,
     /* 1608596 */     GIR_EraseRootFromParent_Done,
     /* 1608597 */   // Label 22190: @1608597
     /* 1608597 */   GIM_Try, /*On fail goto*//*Label 22191*/ GIMT_Encode4(1608683), // Rule ID 3541 //
     /* 1608602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1608613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1608616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1608619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1608625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1608632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608648 */     // MIs[0] policy
     /* 1608648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608658 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11575:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1608661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608682 */     // GIR_Coverage, 3541,
     /* 1608682 */     GIR_EraseRootFromParent_Done,
     /* 1608683 */   // Label 22191: @1608683
     /* 1608683 */   GIM_Try, /*On fail goto*//*Label 22192*/ GIMT_Encode4(1608769), // Rule ID 3544 //
     /* 1608688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1608699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1608702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1608705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608734 */     // MIs[0] policy
     /* 1608734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608744 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1608747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608768 */     // GIR_Coverage, 3544,
     /* 1608768 */     GIR_EraseRootFromParent_Done,
     /* 1608769 */   // Label 22192: @1608769
     /* 1608769 */   GIM_Try, /*On fail goto*//*Label 22193*/ GIMT_Encode4(1608855), // Rule ID 3545 //
     /* 1608774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1608785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1608788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1608791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1608797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1608804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1608812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608820 */     // MIs[0] policy
     /* 1608820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608830 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1608830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1608833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608854 */     // GIR_Coverage, 3545,
     /* 1608854 */     GIR_EraseRootFromParent_Done,
     /* 1608855 */   // Label 22193: @1608855
     /* 1608855 */   GIM_Try, /*On fail goto*//*Label 22194*/ GIMT_Encode4(1608941), // Rule ID 3548 //
     /* 1608860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1608863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1608871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1608874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1608877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1608880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1608886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608906 */     // MIs[0] policy
     /* 1608906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1608916 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1608916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1608919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1608921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1608923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1608925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1608927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1608929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1608934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1608937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1608939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1608940 */     // GIR_Coverage, 3548,
     /* 1608940 */     GIR_EraseRootFromParent_Done,
     /* 1608941 */   // Label 22194: @1608941
     /* 1608941 */   GIM_Try, /*On fail goto*//*Label 22195*/ GIMT_Encode4(1609027), // Rule ID 3549 //
     /* 1608946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1608949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1608954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1608957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1608960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1608963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1608966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1608969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1608972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1608976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1608980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1608984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1608988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1608992 */     // MIs[0] policy
     /* 1608992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1608995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609002 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1609005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609026 */     // GIR_Coverage, 3549,
     /* 1609026 */     GIR_EraseRootFromParent_Done,
     /* 1609027 */   // Label 22195: @1609027
     /* 1609027 */   GIM_Try, /*On fail goto*//*Label 22196*/ GIMT_Encode4(1609113), // Rule ID 3552 //
     /* 1609032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1609043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1609046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1609049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1609055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609078 */     // MIs[0] policy
     /* 1609078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609088 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1609091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609112 */     // GIR_Coverage, 3552,
     /* 1609112 */     GIR_EraseRootFromParent_Done,
     /* 1609113 */   // Label 22196: @1609113
     /* 1609113 */   GIM_Try, /*On fail goto*//*Label 22197*/ GIMT_Encode4(1609199), // Rule ID 3553 //
     /* 1609118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1609129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1609132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1609135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1609141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609164 */     // MIs[0] policy
     /* 1609164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609174 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1609177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1609195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609198 */     // GIR_Coverage, 3553,
     /* 1609198 */     GIR_EraseRootFromParent_Done,
     /* 1609199 */   // Label 22197: @1609199
     /* 1609199 */   GIM_Try, /*On fail goto*//*Label 22198*/ GIMT_Encode4(1609285), // Rule ID 3556 //
     /* 1609204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609250 */     // MIs[0] policy
     /* 1609250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609260 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1609263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609284 */     // GIR_Coverage, 3556,
     /* 1609284 */     GIR_EraseRootFromParent_Done,
     /* 1609285 */   // Label 22198: @1609285
     /* 1609285 */   GIM_Try, /*On fail goto*//*Label 22199*/ GIMT_Encode4(1609371), // Rule ID 3557 //
     /* 1609290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1609301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1609304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1609307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1609313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609336 */     // MIs[0] policy
     /* 1609336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF4_MASK),
     /* 1609349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609370 */     // GIR_Coverage, 3557,
     /* 1609370 */     GIR_EraseRootFromParent_Done,
     /* 1609371 */   // Label 22199: @1609371
     /* 1609371 */   GIM_Try, /*On fail goto*//*Label 22200*/ GIMT_Encode4(1609457), // Rule ID 3560 //
     /* 1609376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609422 */     // MIs[0] policy
     /* 1609422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609432 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1609435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609456 */     // GIR_Coverage, 3560,
     /* 1609456 */     GIR_EraseRootFromParent_Done,
     /* 1609457 */   // Label 22200: @1609457
     /* 1609457 */   GIM_Try, /*On fail goto*//*Label 22201*/ GIMT_Encode4(1609543), // Rule ID 3561 //
     /* 1609462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1609473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1609476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1609479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1609485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1609492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609508 */     // MIs[0] policy
     /* 1609508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609518 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11575:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1609521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609542 */     // GIR_Coverage, 3561,
     /* 1609542 */     GIR_EraseRootFromParent_Done,
     /* 1609543 */   // Label 22201: @1609543
     /* 1609543 */   GIM_Try, /*On fail goto*//*Label 22202*/ GIMT_Encode4(1609629), // Rule ID 3564 //
     /* 1609548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1609559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1609562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1609578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609594 */     // MIs[0] policy
     /* 1609594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1609607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609628 */     // GIR_Coverage, 3564,
     /* 1609628 */     GIR_EraseRootFromParent_Done,
     /* 1609629 */   // Label 22202: @1609629
     /* 1609629 */   GIM_Try, /*On fail goto*//*Label 22203*/ GIMT_Encode4(1609715), // Rule ID 3565 //
     /* 1609634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1609645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1609648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1609651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1609657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1609664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1609672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609680 */     // MIs[0] policy
     /* 1609680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1609693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609714 */     // GIR_Coverage, 3565,
     /* 1609714 */     GIR_EraseRootFromParent_Done,
     /* 1609715 */   // Label 22203: @1609715
     /* 1609715 */   GIM_Try, /*On fail goto*//*Label 22204*/ GIMT_Encode4(1609801), // Rule ID 3568 //
     /* 1609720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1609731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1609734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1609737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609766 */     // MIs[0] policy
     /* 1609766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1609779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609800 */     // GIR_Coverage, 3568,
     /* 1609800 */     GIR_EraseRootFromParent_Done,
     /* 1609801 */   // Label 22204: @1609801
     /* 1609801 */   GIM_Try, /*On fail goto*//*Label 22205*/ GIMT_Encode4(1609887), // Rule ID 3569 //
     /* 1609806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1609817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1609820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1609823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1609829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1609832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1609836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1609844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609852 */     // MIs[0] policy
     /* 1609852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1609862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1609865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609886 */     // GIR_Coverage, 3569,
     /* 1609886 */     GIR_EraseRootFromParent_Done,
     /* 1609887 */   // Label 22205: @1609887
     /* 1609887 */   GIM_Try, /*On fail goto*//*Label 22206*/ GIMT_Encode4(1609973), // Rule ID 3572 //
     /* 1609892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1609895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1609903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1609906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1609909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1609912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1609915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1609918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1609922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1609926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1609930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1609934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1609938 */     // MIs[0] policy
     /* 1609938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1609941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1609948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1609948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1609951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1609953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1609955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1609957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1609959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1609961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1609966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1609969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1609971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1609972 */     // GIR_Coverage, 3572,
     /* 1609972 */     GIR_EraseRootFromParent_Done,
     /* 1609973 */   // Label 22206: @1609973
     /* 1609973 */   GIM_Try, /*On fail goto*//*Label 22207*/ GIMT_Encode4(1610059), // Rule ID 3573 //
     /* 1609978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1609981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1609986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1609989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1609992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1609995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1609998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1610001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610024 */     // MIs[0] policy
     /* 1610024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1610037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1610055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610058 */     // GIR_Coverage, 3573,
     /* 1610058 */     GIR_EraseRootFromParent_Done,
     /* 1610059 */   // Label 22207: @1610059
     /* 1610059 */   GIM_Try, /*On fail goto*//*Label 22208*/ GIMT_Encode4(1610145), // Rule ID 3576 //
     /* 1610064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1610067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1610081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610110 */     // MIs[0] policy
     /* 1610110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610120 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1610123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610144 */     // GIR_Coverage, 3576,
     /* 1610144 */     GIR_EraseRootFromParent_Done,
     /* 1610145 */   // Label 22208: @1610145
     /* 1610145 */   GIM_Try, /*On fail goto*//*Label 22209*/ GIMT_Encode4(1610231), // Rule ID 3577 //
     /* 1610150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1610153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1610161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1610164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1610167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610196 */     // MIs[0] policy
     /* 1610196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11575:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_MF2_MASK),
     /* 1610209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610230 */     // GIR_Coverage, 3577,
     /* 1610230 */     GIR_EraseRootFromParent_Done,
     /* 1610231 */   // Label 22209: @1610231
     /* 1610231 */   GIM_Try, /*On fail goto*//*Label 22210*/ GIMT_Encode4(1610317), // Rule ID 3580 //
     /* 1610236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1610239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1610247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1610250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610282 */     // MIs[0] policy
     /* 1610282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610292 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1610295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610316 */     // GIR_Coverage, 3580,
     /* 1610316 */     GIR_EraseRootFromParent_Done,
     /* 1610317 */   // Label 22210: @1610317
     /* 1610317 */   GIM_Try, /*On fail goto*//*Label 22211*/ GIMT_Encode4(1610403), // Rule ID 3581 //
     /* 1610322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1610325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1610333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1610336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1610339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1610352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610368 */     // MIs[0] policy
     /* 1610368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610378 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11575:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M1_MASK),
     /* 1610381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610402 */     // GIR_Coverage, 3581,
     /* 1610402 */     GIR_EraseRootFromParent_Done,
     /* 1610403 */   // Label 22211: @1610403
     /* 1610403 */   GIM_Try, /*On fail goto*//*Label 22212*/ GIMT_Encode4(1610489), // Rule ID 3584 //
     /* 1610408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1610411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1610419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1610422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1610425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610454 */     // MIs[0] policy
     /* 1610454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610464 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1610467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610488 */     // GIR_Coverage, 3584,
     /* 1610488 */     GIR_EraseRootFromParent_Done,
     /* 1610489 */   // Label 22212: @1610489
     /* 1610489 */   GIM_Try, /*On fail goto*//*Label 22213*/ GIMT_Encode4(1610575), // Rule ID 3585 //
     /* 1610494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1610497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1610505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1610508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1610511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1610517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1610524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1610532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610540 */     // MIs[0] policy
     /* 1610540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610550 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11575:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M2_MASK),
     /* 1610553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610574 */     // GIR_Coverage, 3585,
     /* 1610574 */     GIR_EraseRootFromParent_Done,
     /* 1610575 */   // Label 22213: @1610575
     /* 1610575 */   GIM_Try, /*On fail goto*//*Label 22214*/ GIMT_Encode4(1610661), // Rule ID 3588 //
     /* 1610580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1610583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1610591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1610594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1610597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1610600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610626 */     // MIs[0] policy
     /* 1610626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610636 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1610639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610660 */     // GIR_Coverage, 3588,
     /* 1610660 */     GIR_EraseRootFromParent_Done,
     /* 1610661 */   // Label 22214: @1610661
     /* 1610661 */   GIM_Try, /*On fail goto*//*Label 22215*/ GIMT_Encode4(1610747), // Rule ID 3589 //
     /* 1610666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1610669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_mask),
     /* 1610674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1610677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1610680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1610683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1610686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1610689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1610696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1610700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1610704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1610708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610712 */     // MIs[0] policy
     /* 1610712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610722 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11575:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_VX_M4_MASK),
     /* 1610725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1610743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610746 */     // GIR_Coverage, 3589,
     /* 1610746 */     GIR_EraseRootFromParent_Done,
     /* 1610747 */   // Label 22215: @1610747
     /* 1610747 */   GIM_Try, /*On fail goto*//*Label 22216*/ GIMT_Encode4(1610833), // Rule ID 3592 //
     /* 1610752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1610760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1610763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1610766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1610769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1610772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610798 */     // MIs[0] policy
     /* 1610798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610808 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1610811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610832 */     // GIR_Coverage, 3592,
     /* 1610832 */     GIR_EraseRootFromParent_Done,
     /* 1610833 */   // Label 22216: @1610833
     /* 1610833 */   GIM_Try, /*On fail goto*//*Label 22217*/ GIMT_Encode4(1610919), // Rule ID 3593 //
     /* 1610838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1610841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1610846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1610849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1610852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1610855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1610858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1610861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1610864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610884 */     // MIs[0] policy
     /* 1610884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610894 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1610894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF8_MASK),
     /* 1610897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1610915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1610917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1610918 */     // GIR_Coverage, 3593,
     /* 1610918 */     GIR_EraseRootFromParent_Done,
     /* 1610919 */   // Label 22217: @1610919
     /* 1610919 */   GIM_Try, /*On fail goto*//*Label 22218*/ GIMT_Encode4(1611005), // Rule ID 3596 //
     /* 1610924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1610927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1610932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1610935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1610938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1610941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1610944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1610947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1610950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1610954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1610966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1610970 */     // MIs[0] policy
     /* 1610970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1610973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1610980 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1610980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1610983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1610985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1610987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1610989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1610991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1610993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1610998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611004 */     // GIR_Coverage, 3596,
     /* 1611004 */     GIR_EraseRootFromParent_Done,
     /* 1611005 */   // Label 22218: @1611005
     /* 1611005 */   GIM_Try, /*On fail goto*//*Label 22219*/ GIMT_Encode4(1611091), // Rule ID 3597 //
     /* 1611010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1611021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1611024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1611027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1611030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611056 */     // MIs[0] policy
     /* 1611056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611066 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1611069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611090 */     // GIR_Coverage, 3597,
     /* 1611090 */     GIR_EraseRootFromParent_Done,
     /* 1611091 */   // Label 22219: @1611091
     /* 1611091 */   GIM_Try, /*On fail goto*//*Label 22220*/ GIMT_Encode4(1611177), // Rule ID 3600 //
     /* 1611096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1611107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1611110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1611113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1611116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611142 */     // MIs[0] policy
     /* 1611142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1611155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611176 */     // GIR_Coverage, 3600,
     /* 1611176 */     GIR_EraseRootFromParent_Done,
     /* 1611177 */   // Label 22220: @1611177
     /* 1611177 */   GIM_Try, /*On fail goto*//*Label 22221*/ GIMT_Encode4(1611263), // Rule ID 3601 //
     /* 1611182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1611193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1611196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1611199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1611202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1611205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611228 */     // MIs[0] policy
     /* 1611228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1611241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611262 */     // GIR_Coverage, 3601,
     /* 1611262 */     GIR_EraseRootFromParent_Done,
     /* 1611263 */   // Label 22221: @1611263
     /* 1611263 */   GIM_Try, /*On fail goto*//*Label 22222*/ GIMT_Encode4(1611349), // Rule ID 3604 //
     /* 1611268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1611285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1611288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611314 */     // MIs[0] policy
     /* 1611314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1611327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611348 */     // GIR_Coverage, 3604,
     /* 1611348 */     GIR_EraseRootFromParent_Done,
     /* 1611349 */   // Label 22222: @1611349
     /* 1611349 */   GIM_Try, /*On fail goto*//*Label 22223*/ GIMT_Encode4(1611435), // Rule ID 3605 //
     /* 1611354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1611365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1611368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1611371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1611374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1611377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1611384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611400 */     // MIs[0] policy
     /* 1611400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611410 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1611413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611434 */     // GIR_Coverage, 3605,
     /* 1611434 */     GIR_EraseRootFromParent_Done,
     /* 1611435 */   // Label 22223: @1611435
     /* 1611435 */   GIM_Try, /*On fail goto*//*Label 22224*/ GIMT_Encode4(1611521), // Rule ID 3608 //
     /* 1611440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1611457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1611460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611486 */     // MIs[0] policy
     /* 1611486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611496 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1611499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611520 */     // GIR_Coverage, 3608,
     /* 1611520 */     GIR_EraseRootFromParent_Done,
     /* 1611521 */   // Label 22224: @1611521
     /* 1611521 */   GIM_Try, /*On fail goto*//*Label 22225*/ GIMT_Encode4(1611607), // Rule ID 3609 //
     /* 1611526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1611537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1611540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1611543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1611546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1611549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1611556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1611568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611572 */     // MIs[0] policy
     /* 1611572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611582 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1611585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611606 */     // GIR_Coverage, 3609,
     /* 1611606 */     GIR_EraseRootFromParent_Done,
     /* 1611607 */   // Label 22225: @1611607
     /* 1611607 */   GIM_Try, /*On fail goto*//*Label 22226*/ GIMT_Encode4(1611693), // Rule ID 3612 //
     /* 1611612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1611629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1611632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611658 */     // MIs[0] policy
     /* 1611658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611668 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1611671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611692 */     // GIR_Coverage, 3612,
     /* 1611692 */     GIR_EraseRootFromParent_Done,
     /* 1611693 */   // Label 22226: @1611693
     /* 1611693 */   GIM_Try, /*On fail goto*//*Label 22227*/ GIMT_Encode4(1611779), // Rule ID 3613 //
     /* 1611698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1611709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1611712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1611715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1611718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1611721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1611728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1611732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1611740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611744 */     // MIs[0] policy
     /* 1611744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611754 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1611757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1611775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611778 */     // GIR_Coverage, 3613,
     /* 1611778 */     GIR_EraseRootFromParent_Done,
     /* 1611779 */   // Label 22227: @1611779
     /* 1611779 */   GIM_Try, /*On fail goto*//*Label 22228*/ GIMT_Encode4(1611865), // Rule ID 3616 //
     /* 1611784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1611795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1611798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1611801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1611804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1611807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611830 */     // MIs[0] policy
     /* 1611830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611840 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1611840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1611843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611864 */     // GIR_Coverage, 3616,
     /* 1611864 */     GIR_EraseRootFromParent_Done,
     /* 1611865 */   // Label 22228: @1611865
     /* 1611865 */   GIM_Try, /*On fail goto*//*Label 22229*/ GIMT_Encode4(1611951), // Rule ID 3617 //
     /* 1611870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1611873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1611881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1611884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1611887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1611890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1611893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1611896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1611916 */     // MIs[0] policy
     /* 1611916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1611919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1611926 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1611926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF4_MASK),
     /* 1611929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1611931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1611933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1611935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1611937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1611939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1611944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1611947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1611949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1611950 */     // GIR_Coverage, 3617,
     /* 1611950 */     GIR_EraseRootFromParent_Done,
     /* 1611951 */   // Label 22229: @1611951
     /* 1611951 */   GIM_Try, /*On fail goto*//*Label 22230*/ GIMT_Encode4(1612037), // Rule ID 3620 //
     /* 1611956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1611959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1611964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1611967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1611970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1611973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1611976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1611979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1611982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1611986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1611998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612002 */     // MIs[0] policy
     /* 1612002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1612015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612036 */     // GIR_Coverage, 3620,
     /* 1612036 */     GIR_EraseRootFromParent_Done,
     /* 1612037 */   // Label 22230: @1612037
     /* 1612037 */   GIM_Try, /*On fail goto*//*Label 22231*/ GIMT_Encode4(1612123), // Rule ID 3621 //
     /* 1612042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1612053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1612056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1612059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1612062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612088 */     // MIs[0] policy
     /* 1612088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1612101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612122 */     // GIR_Coverage, 3621,
     /* 1612122 */     GIR_EraseRootFromParent_Done,
     /* 1612123 */   // Label 22231: @1612123
     /* 1612123 */   GIM_Try, /*On fail goto*//*Label 22232*/ GIMT_Encode4(1612209), // Rule ID 3624 //
     /* 1612128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1612139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1612142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1612145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1612148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612174 */     // MIs[0] policy
     /* 1612174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1612187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612208 */     // GIR_Coverage, 3624,
     /* 1612208 */     GIR_EraseRootFromParent_Done,
     /* 1612209 */   // Label 22232: @1612209
     /* 1612209 */   GIM_Try, /*On fail goto*//*Label 22233*/ GIMT_Encode4(1612295), // Rule ID 3625 //
     /* 1612214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1612225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1612228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1612231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1612234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1612237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612260 */     // MIs[0] policy
     /* 1612260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1612273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612294 */     // GIR_Coverage, 3625,
     /* 1612294 */     GIR_EraseRootFromParent_Done,
     /* 1612295 */   // Label 22233: @1612295
     /* 1612295 */   GIM_Try, /*On fail goto*//*Label 22234*/ GIMT_Encode4(1612381), // Rule ID 3628 //
     /* 1612300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1612311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1612314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1612317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1612320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612346 */     // MIs[0] policy
     /* 1612346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612356 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1612359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612380 */     // GIR_Coverage, 3628,
     /* 1612380 */     GIR_EraseRootFromParent_Done,
     /* 1612381 */   // Label 22234: @1612381
     /* 1612381 */   GIM_Try, /*On fail goto*//*Label 22235*/ GIMT_Encode4(1612467), // Rule ID 3629 //
     /* 1612386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1612397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1612400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1612403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1612406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1612409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1612416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612432 */     // MIs[0] policy
     /* 1612432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612442 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1612445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612466 */     // GIR_Coverage, 3629,
     /* 1612466 */     GIR_EraseRootFromParent_Done,
     /* 1612467 */   // Label 22235: @1612467
     /* 1612467 */   GIM_Try, /*On fail goto*//*Label 22236*/ GIMT_Encode4(1612553), // Rule ID 3632 //
     /* 1612472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1612475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1612483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1612486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1612489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1612492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612518 */     // MIs[0] policy
     /* 1612518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612528 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1612531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612552 */     // GIR_Coverage, 3632,
     /* 1612552 */     GIR_EraseRootFromParent_Done,
     /* 1612553 */   // Label 22236: @1612553
     /* 1612553 */   GIM_Try, /*On fail goto*//*Label 22237*/ GIMT_Encode4(1612639), // Rule ID 3633 //
     /* 1612558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1612561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1612569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1612572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1612575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1612578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1612581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1612588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1612592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1612600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612604 */     // MIs[0] policy
     /* 1612604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612614 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1612617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1612635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612638 */     // GIR_Coverage, 3633,
     /* 1612638 */     GIR_EraseRootFromParent_Done,
     /* 1612639 */   // Label 22237: @1612639
     /* 1612639 */   GIM_Try, /*On fail goto*//*Label 22238*/ GIMT_Encode4(1612725), // Rule ID 3636 //
     /* 1612644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1612655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1612658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1612661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1612664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612690 */     // MIs[0] policy
     /* 1612690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612700 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1612703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612724 */     // GIR_Coverage, 3636,
     /* 1612724 */     GIR_EraseRootFromParent_Done,
     /* 1612725 */   // Label 22238: @1612725
     /* 1612725 */   GIM_Try, /*On fail goto*//*Label 22239*/ GIMT_Encode4(1612811), // Rule ID 3637 //
     /* 1612730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1612733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1612741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1612744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1612747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1612750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1612753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1612760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612776 */     // MIs[0] policy
     /* 1612776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_MF2_MASK),
     /* 1612789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612810 */     // GIR_Coverage, 3637,
     /* 1612810 */     GIR_EraseRootFromParent_Done,
     /* 1612811 */   // Label 22239: @1612811
     /* 1612811 */   GIM_Try, /*On fail goto*//*Label 22240*/ GIMT_Encode4(1612897), // Rule ID 3640 //
     /* 1612816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1612833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1612836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1612842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612862 */     // MIs[0] policy
     /* 1612862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612872 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1612872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1612875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612896 */     // GIR_Coverage, 3640,
     /* 1612896 */     GIR_EraseRootFromParent_Done,
     /* 1612897 */   // Label 22240: @1612897
     /* 1612897 */   GIM_Try, /*On fail goto*//*Label 22241*/ GIMT_Encode4(1612983), // Rule ID 3641 //
     /* 1612902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1612905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1612913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1612916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1612919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1612922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1612925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1612928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1612932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1612936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1612944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1612948 */     // MIs[0] policy
     /* 1612948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1612951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1612958 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1612958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M1_MASK),
     /* 1612961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1612963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1612965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1612967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1612969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1612971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1612976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1612979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1612981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1612982 */     // GIR_Coverage, 3641,
     /* 1612982 */     GIR_EraseRootFromParent_Done,
     /* 1612983 */   // Label 22241: @1612983
     /* 1612983 */   GIM_Try, /*On fail goto*//*Label 22242*/ GIMT_Encode4(1613069), // Rule ID 3644 //
     /* 1612988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1612991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1612996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1612999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1613002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1613005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1613008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613034 */     // MIs[0] policy
     /* 1613034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613044 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1613047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613068 */     // GIR_Coverage, 3644,
     /* 1613068 */     GIR_EraseRootFromParent_Done,
     /* 1613069 */   // Label 22242: @1613069
     /* 1613069 */   GIM_Try, /*On fail goto*//*Label 22243*/ GIMT_Encode4(1613155), // Rule ID 3645 //
     /* 1613074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1613077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1613085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1613088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1613091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1613094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1613104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613120 */     // MIs[0] policy
     /* 1613120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613130 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M2_MASK),
     /* 1613133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613154 */     // GIR_Coverage, 3645,
     /* 1613154 */     GIR_EraseRootFromParent_Done,
     /* 1613155 */   // Label 22243: @1613155
     /* 1613155 */   GIM_Try, /*On fail goto*//*Label 22244*/ GIMT_Encode4(1613241), // Rule ID 3648 //
     /* 1613160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1613163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1613171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1613174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1613177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1613180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613206 */     // MIs[0] policy
     /* 1613206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613216 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1613219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613240 */     // GIR_Coverage, 3648,
     /* 1613240 */     GIR_EraseRootFromParent_Done,
     /* 1613241 */   // Label 22244: @1613241
     /* 1613241 */   GIM_Try, /*On fail goto*//*Label 22245*/ GIMT_Encode4(1613327), // Rule ID 3649 //
     /* 1613246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1613249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1613257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1613260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1613263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1613266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1613276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1613280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1613288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613292 */     // MIs[0] policy
     /* 1613292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613302 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VV_M4_MASK),
     /* 1613305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1613323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613326 */     // GIR_Coverage, 3649,
     /* 1613326 */     GIR_EraseRootFromParent_Done,
     /* 1613327 */   // Label 22245: @1613327
     /* 1613327 */   GIM_Try, /*On fail goto*//*Label 22246*/ GIMT_Encode4(1613413), // Rule ID 3652 //
     /* 1613332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1613343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1613346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1613349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613378 */     // MIs[0] policy
     /* 1613378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1613391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613412 */     // GIR_Coverage, 3652,
     /* 1613412 */     GIR_EraseRootFromParent_Done,
     /* 1613413 */   // Label 22246: @1613413
     /* 1613413 */   GIM_Try, /*On fail goto*//*Label 22247*/ GIMT_Encode4(1613499), // Rule ID 3653 //
     /* 1613418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1613429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1613432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1613435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1613441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613464 */     // MIs[0] policy
     /* 1613464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF8_MASK),
     /* 1613477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613498 */     // GIR_Coverage, 3653,
     /* 1613498 */     GIR_EraseRootFromParent_Done,
     /* 1613499 */   // Label 22247: @1613499
     /* 1613499 */   GIM_Try, /*On fail goto*//*Label 22248*/ GIMT_Encode4(1613585), // Rule ID 3656 //
     /* 1613504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1613515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1613518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1613521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613550 */     // MIs[0] policy
     /* 1613550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613560 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1613563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613584 */     // GIR_Coverage, 3656,
     /* 1613584 */     GIR_EraseRootFromParent_Done,
     /* 1613585 */   // Label 22248: @1613585
     /* 1613585 */   GIM_Try, /*On fail goto*//*Label 22249*/ GIMT_Encode4(1613671), // Rule ID 3657 //
     /* 1613590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1613601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1613604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1613607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1613613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613636 */     // MIs[0] policy
     /* 1613636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613646 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1613649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613670 */     // GIR_Coverage, 3657,
     /* 1613670 */     GIR_EraseRootFromParent_Done,
     /* 1613671 */   // Label 22249: @1613671
     /* 1613671 */   GIM_Try, /*On fail goto*//*Label 22250*/ GIMT_Encode4(1613757), // Rule ID 3660 //
     /* 1613676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613722 */     // MIs[0] policy
     /* 1613722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1613735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613756 */     // GIR_Coverage, 3660,
     /* 1613756 */     GIR_EraseRootFromParent_Done,
     /* 1613757 */   // Label 22250: @1613757
     /* 1613757 */   GIM_Try, /*On fail goto*//*Label 22251*/ GIMT_Encode4(1613843), // Rule ID 3661 //
     /* 1613762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1613773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1613776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1613779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1613785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1613792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613808 */     // MIs[0] policy
     /* 1613808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11603:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1613821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613842 */     // GIR_Coverage, 3661,
     /* 1613842 */     GIR_EraseRootFromParent_Done,
     /* 1613843 */   // Label 22251: @1613843
     /* 1613843 */   GIM_Try, /*On fail goto*//*Label 22252*/ GIMT_Encode4(1613929), // Rule ID 3664 //
     /* 1613848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1613851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1613868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1613874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613894 */     // MIs[0] policy
     /* 1613894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613904 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1613904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1613907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1613915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1613917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1613922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1613925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1613927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1613928 */     // GIR_Coverage, 3664,
     /* 1613928 */     GIR_EraseRootFromParent_Done,
     /* 1613929 */   // Label 22252: @1613929
     /* 1613929 */   GIM_Try, /*On fail goto*//*Label 22253*/ GIMT_Encode4(1614015), // Rule ID 3665 //
     /* 1613934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1613937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1613942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1613945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1613948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1613951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1613954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1613957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1613960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1613964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1613968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1613972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1613976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1613980 */     // MIs[0] policy
     /* 1613980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1613983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1613990 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1613990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1613993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1613995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1613997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1613999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614014 */     // GIR_Coverage, 3665,
     /* 1614014 */     GIR_EraseRootFromParent_Done,
     /* 1614015 */   // Label 22253: @1614015
     /* 1614015 */   GIM_Try, /*On fail goto*//*Label 22254*/ GIMT_Encode4(1614101), // Rule ID 3668 //
     /* 1614020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1614037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614066 */     // MIs[0] policy
     /* 1614066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614076 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1614079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614100 */     // GIR_Coverage, 3668,
     /* 1614100 */     GIR_EraseRootFromParent_Done,
     /* 1614101 */   // Label 22254: @1614101
     /* 1614101 */   GIM_Try, /*On fail goto*//*Label 22255*/ GIMT_Encode4(1614187), // Rule ID 3669 //
     /* 1614106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1614117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1614120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1614123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1614129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614152 */     // MIs[0] policy
     /* 1614152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614162 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1614165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614186 */     // GIR_Coverage, 3669,
     /* 1614186 */     GIR_EraseRootFromParent_Done,
     /* 1614187 */   // Label 22255: @1614187
     /* 1614187 */   GIM_Try, /*On fail goto*//*Label 22256*/ GIMT_Encode4(1614273), // Rule ID 3672 //
     /* 1614192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1614203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1614206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614238 */     // MIs[0] policy
     /* 1614238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614248 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1614251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614272 */     // GIR_Coverage, 3672,
     /* 1614272 */     GIR_EraseRootFromParent_Done,
     /* 1614273 */   // Label 22256: @1614273
     /* 1614273 */   GIM_Try, /*On fail goto*//*Label 22257*/ GIMT_Encode4(1614359), // Rule ID 3673 //
     /* 1614278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1614289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1614292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1614295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1614301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1614308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1614312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614324 */     // MIs[0] policy
     /* 1614324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614334 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1614337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1614355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614358 */     // GIR_Coverage, 3673,
     /* 1614358 */     GIR_EraseRootFromParent_Done,
     /* 1614359 */   // Label 22257: @1614359
     /* 1614359 */   GIM_Try, /*On fail goto*//*Label 22258*/ GIMT_Encode4(1614445), // Rule ID 3676 //
     /* 1614364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1614375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1614378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1614381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614410 */     // MIs[0] policy
     /* 1614410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614420 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1614423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614444 */     // GIR_Coverage, 3676,
     /* 1614444 */     GIR_EraseRootFromParent_Done,
     /* 1614445 */   // Label 22258: @1614445
     /* 1614445 */   GIM_Try, /*On fail goto*//*Label 22259*/ GIMT_Encode4(1614531), // Rule ID 3677 //
     /* 1614450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1614461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1614464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1614467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1614473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614496 */     // MIs[0] policy
     /* 1614496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614506 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF4_MASK),
     /* 1614509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614530 */     // GIR_Coverage, 3677,
     /* 1614530 */     GIR_EraseRootFromParent_Done,
     /* 1614531 */   // Label 22259: @1614531
     /* 1614531 */   GIM_Try, /*On fail goto*//*Label 22260*/ GIMT_Encode4(1614617), // Rule ID 3680 //
     /* 1614536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1614547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1614550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1614553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614582 */     // MIs[0] policy
     /* 1614582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1614595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614616 */     // GIR_Coverage, 3680,
     /* 1614616 */     GIR_EraseRootFromParent_Done,
     /* 1614617 */   // Label 22260: @1614617
     /* 1614617 */   GIM_Try, /*On fail goto*//*Label 22261*/ GIMT_Encode4(1614703), // Rule ID 3681 //
     /* 1614622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1614633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1614636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1614639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1614645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1614652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614668 */     // MIs[0] policy
     /* 1614668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614678 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11603:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1614681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614702 */     // GIR_Coverage, 3681,
     /* 1614702 */     GIR_EraseRootFromParent_Done,
     /* 1614703 */   // Label 22261: @1614703
     /* 1614703 */   GIM_Try, /*On fail goto*//*Label 22262*/ GIMT_Encode4(1614789), // Rule ID 3684 //
     /* 1614708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614754 */     // MIs[0] policy
     /* 1614754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1614767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614788 */     // GIR_Coverage, 3684,
     /* 1614788 */     GIR_EraseRootFromParent_Done,
     /* 1614789 */   // Label 22262: @1614789
     /* 1614789 */   GIM_Try, /*On fail goto*//*Label 22263*/ GIMT_Encode4(1614875), // Rule ID 3685 //
     /* 1614794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1614805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1614808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1614811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1614817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1614824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1614832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614840 */     // MIs[0] policy
     /* 1614840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1614850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1614853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614874 */     // GIR_Coverage, 3685,
     /* 1614874 */     GIR_EraseRootFromParent_Done,
     /* 1614875 */   // Label 22263: @1614875
     /* 1614875 */   GIM_Try, /*On fail goto*//*Label 22264*/ GIMT_Encode4(1614961), // Rule ID 3688 //
     /* 1614880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1614883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1614900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1614906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1614914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1614918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1614922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1614926 */     // MIs[0] policy
     /* 1614926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1614929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1614936 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1614936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1614939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1614941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1614943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1614945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1614947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1614949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1614954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1614957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1614959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1614960 */     // GIR_Coverage, 3688,
     /* 1614960 */     GIR_EraseRootFromParent_Done,
     /* 1614961 */   // Label 22264: @1614961
     /* 1614961 */   GIM_Try, /*On fail goto*//*Label 22265*/ GIMT_Encode4(1615047), // Rule ID 3689 //
     /* 1614966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1614969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1614974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1614977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1614980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1614983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1614986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1614989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1614992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1614996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615012 */     // MIs[0] policy
     /* 1615012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615022 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1615025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615046 */     // GIR_Coverage, 3689,
     /* 1615046 */     GIR_EraseRootFromParent_Done,
     /* 1615047 */   // Label 22265: @1615047
     /* 1615047 */   GIM_Try, /*On fail goto*//*Label 22266*/ GIMT_Encode4(1615133), // Rule ID 3692 //
     /* 1615052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1615069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615098 */     // MIs[0] policy
     /* 1615098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615108 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1615111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615132 */     // GIR_Coverage, 3692,
     /* 1615132 */     GIR_EraseRootFromParent_Done,
     /* 1615133 */   // Label 22266: @1615133
     /* 1615133 */   GIM_Try, /*On fail goto*//*Label 22267*/ GIMT_Encode4(1615219), // Rule ID 3693 //
     /* 1615138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1615141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1615149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1615152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1615155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1615161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615184 */     // MIs[0] policy
     /* 1615184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615194 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1615197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1615215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615218 */     // GIR_Coverage, 3693,
     /* 1615218 */     GIR_EraseRootFromParent_Done,
     /* 1615219 */   // Label 22267: @1615219
     /* 1615219 */   GIM_Try, /*On fail goto*//*Label 22268*/ GIMT_Encode4(1615305), // Rule ID 3696 //
     /* 1615224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1615235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1615238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1615241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615270 */     // MIs[0] policy
     /* 1615270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1615283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615304 */     // GIR_Coverage, 3696,
     /* 1615304 */     GIR_EraseRootFromParent_Done,
     /* 1615305 */   // Label 22268: @1615305
     /* 1615305 */   GIM_Try, /*On fail goto*//*Label 22269*/ GIMT_Encode4(1615391), // Rule ID 3697 //
     /* 1615310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1615321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1615324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1615327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615356 */     // MIs[0] policy
     /* 1615356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11603:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_MF2_MASK),
     /* 1615369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615390 */     // GIR_Coverage, 3697,
     /* 1615390 */     GIR_EraseRootFromParent_Done,
     /* 1615391 */   // Label 22269: @1615391
     /* 1615391 */   GIM_Try, /*On fail goto*//*Label 22270*/ GIMT_Encode4(1615477), // Rule ID 3700 //
     /* 1615396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1615413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615442 */     // MIs[0] policy
     /* 1615442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615452 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1615455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615476 */     // GIR_Coverage, 3700,
     /* 1615476 */     GIR_EraseRootFromParent_Done,
     /* 1615477 */   // Label 22270: @1615477
     /* 1615477 */   GIM_Try, /*On fail goto*//*Label 22271*/ GIMT_Encode4(1615563), // Rule ID 3701 //
     /* 1615482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1615493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1615496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1615499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1615505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1615512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615528 */     // MIs[0] policy
     /* 1615528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11603:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M1_MASK),
     /* 1615541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615562 */     // GIR_Coverage, 3701,
     /* 1615562 */     GIR_EraseRootFromParent_Done,
     /* 1615563 */   // Label 22271: @1615563
     /* 1615563 */   GIM_Try, /*On fail goto*//*Label 22272*/ GIMT_Encode4(1615649), // Rule ID 3704 //
     /* 1615568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615614 */     // MIs[0] policy
     /* 1615614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615624 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1615627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615648 */     // GIR_Coverage, 3704,
     /* 1615648 */     GIR_EraseRootFromParent_Done,
     /* 1615649 */   // Label 22272: @1615649
     /* 1615649 */   GIM_Try, /*On fail goto*//*Label 22273*/ GIMT_Encode4(1615735), // Rule ID 3705 //
     /* 1615654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1615665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1615668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1615671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1615677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1615684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1615692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615700 */     // MIs[0] policy
     /* 1615700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615710 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11603:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M2_MASK),
     /* 1615713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615734 */     // GIR_Coverage, 3705,
     /* 1615734 */     GIR_EraseRootFromParent_Done,
     /* 1615735 */   // Label 22273: @1615735
     /* 1615735 */   GIM_Try, /*On fail goto*//*Label 22274*/ GIMT_Encode4(1615821), // Rule ID 3708 //
     /* 1615740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1615743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1615760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615786 */     // MIs[0] policy
     /* 1615786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615796 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1615799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615820 */     // GIR_Coverage, 3708,
     /* 1615820 */     GIR_EraseRootFromParent_Done,
     /* 1615821 */   // Label 22274: @1615821
     /* 1615821 */   GIM_Try, /*On fail goto*//*Label 22275*/ GIMT_Encode4(1615907), // Rule ID 3709 //
     /* 1615826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1615829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_mask),
     /* 1615834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1615837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1615840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1615843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1615846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1615849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1615852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1615856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1615860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1615864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1615868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615872 */     // MIs[0] policy
     /* 1615872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615882 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11603:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1615882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_VX_M4_MASK),
     /* 1615885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1615903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615906 */     // GIR_Coverage, 3709,
     /* 1615906 */     GIR_EraseRootFromParent_Done,
     /* 1615907 */   // Label 22275: @1615907
     /* 1615907 */   GIM_Try, /*On fail goto*//*Label 22276*/ GIMT_Encode4(1615993), // Rule ID 3712 //
     /* 1615912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1615915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1615920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1615923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1615926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1615929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1615932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1615935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1615938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1615942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1615954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1615958 */     // MIs[0] policy
     /* 1615958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1615961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1615968 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1615968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1615971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1615973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1615975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1615977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1615979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1615981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1615986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1615989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1615991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1615992 */     // GIR_Coverage, 3712,
     /* 1615992 */     GIR_EraseRootFromParent_Done,
     /* 1615993 */   // Label 22276: @1615993
     /* 1615993 */   GIM_Try, /*On fail goto*//*Label 22277*/ GIMT_Encode4(1616079), // Rule ID 3713 //
     /* 1615998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1616009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1616012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1616015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1616018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616044 */     // MIs[0] policy
     /* 1616044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF8_MASK),
     /* 1616057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616078 */     // GIR_Coverage, 3713,
     /* 1616078 */     GIR_EraseRootFromParent_Done,
     /* 1616079 */   // Label 22277: @1616079
     /* 1616079 */   GIM_Try, /*On fail goto*//*Label 22278*/ GIMT_Encode4(1616165), // Rule ID 3716 //
     /* 1616084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616130 */     // MIs[0] policy
     /* 1616130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616140 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1616143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616164 */     // GIR_Coverage, 3716,
     /* 1616164 */     GIR_EraseRootFromParent_Done,
     /* 1616165 */   // Label 22278: @1616165
     /* 1616165 */   GIM_Try, /*On fail goto*//*Label 22279*/ GIMT_Encode4(1616251), // Rule ID 3717 //
     /* 1616170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1616181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1616184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1616187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1616190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1616193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616216 */     // MIs[0] policy
     /* 1616216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616226 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1616229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616250 */     // GIR_Coverage, 3717,
     /* 1616250 */     GIR_EraseRootFromParent_Done,
     /* 1616251 */   // Label 22279: @1616251
     /* 1616251 */   GIM_Try, /*On fail goto*//*Label 22280*/ GIMT_Encode4(1616337), // Rule ID 3720 //
     /* 1616256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1616267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1616270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616302 */     // MIs[0] policy
     /* 1616302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1616315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616336 */     // GIR_Coverage, 3720,
     /* 1616336 */     GIR_EraseRootFromParent_Done,
     /* 1616337 */   // Label 22280: @1616337
     /* 1616337 */   GIM_Try, /*On fail goto*//*Label 22281*/ GIMT_Encode4(1616423), // Rule ID 3721 //
     /* 1616342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1616353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1616356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1616359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1616362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1616365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616388 */     // MIs[0] policy
     /* 1616388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1616401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616422 */     // GIR_Coverage, 3721,
     /* 1616422 */     GIR_EraseRootFromParent_Done,
     /* 1616423 */   // Label 22281: @1616423
     /* 1616423 */   GIM_Try, /*On fail goto*//*Label 22282*/ GIMT_Encode4(1616509), // Rule ID 3724 //
     /* 1616428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1616439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1616442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1616445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1616448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616474 */     // MIs[0] policy
     /* 1616474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1616487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616508 */     // GIR_Coverage, 3724,
     /* 1616508 */     GIR_EraseRootFromParent_Done,
     /* 1616509 */   // Label 22282: @1616509
     /* 1616509 */   GIM_Try, /*On fail goto*//*Label 22283*/ GIMT_Encode4(1616595), // Rule ID 3725 //
     /* 1616514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1616525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1616528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1616531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1616534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1616537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1616544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616560 */     // MIs[0] policy
     /* 1616560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1616573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616594 */     // GIR_Coverage, 3725,
     /* 1616594 */     GIR_EraseRootFromParent_Done,
     /* 1616595 */   // Label 22283: @1616595
     /* 1616595 */   GIM_Try, /*On fail goto*//*Label 22284*/ GIMT_Encode4(1616681), // Rule ID 3728 //
     /* 1616600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1616620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616646 */     // MIs[0] policy
     /* 1616646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1616659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616680 */     // GIR_Coverage, 3728,
     /* 1616680 */     GIR_EraseRootFromParent_Done,
     /* 1616681 */   // Label 22284: @1616681
     /* 1616681 */   GIM_Try, /*On fail goto*//*Label 22285*/ GIMT_Encode4(1616767), // Rule ID 3729 //
     /* 1616686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1616697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1616700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1616703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1616706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1616709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1616716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1616728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616732 */     // MIs[0] policy
     /* 1616732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1616745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616766 */     // GIR_Coverage, 3729,
     /* 1616766 */     GIR_EraseRootFromParent_Done,
     /* 1616767 */   // Label 22285: @1616767
     /* 1616767 */   GIM_Try, /*On fail goto*//*Label 22286*/ GIMT_Encode4(1616853), // Rule ID 3732 //
     /* 1616772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1616792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616818 */     // MIs[0] policy
     /* 1616818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1616828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1616831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616852 */     // GIR_Coverage, 3732,
     /* 1616852 */     GIR_EraseRootFromParent_Done,
     /* 1616853 */   // Label 22286: @1616853
     /* 1616853 */   GIM_Try, /*On fail goto*//*Label 22287*/ GIMT_Encode4(1616939), // Rule ID 3733 //
     /* 1616858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1616861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1616869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1616872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1616875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1616878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1616881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1616884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1616888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1616892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1616900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616904 */     // MIs[0] policy
     /* 1616904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1616914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1616914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1616917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1616919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1616921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1616923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1616925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1616927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1616932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1616935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1616937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1616938 */     // GIR_Coverage, 3733,
     /* 1616938 */     GIR_EraseRootFromParent_Done,
     /* 1616939 */   // Label 22287: @1616939
     /* 1616939 */   GIM_Try, /*On fail goto*//*Label 22288*/ GIMT_Encode4(1617025), // Rule ID 3736 //
     /* 1616944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1616947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1616952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1616955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1616958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1616961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1616964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1616967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1616970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1616974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1616986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1616990 */     // MIs[0] policy
     /* 1616990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1616993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1617003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617024 */     // GIR_Coverage, 3736,
     /* 1617024 */     GIR_EraseRootFromParent_Done,
     /* 1617025 */   // Label 22288: @1617025
     /* 1617025 */   GIM_Try, /*On fail goto*//*Label 22289*/ GIMT_Encode4(1617111), // Rule ID 3737 //
     /* 1617030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1617041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1617044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1617047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1617050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617076 */     // MIs[0] policy
     /* 1617076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF4_MASK),
     /* 1617089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617110 */     // GIR_Coverage, 3737,
     /* 1617110 */     GIR_EraseRootFromParent_Done,
     /* 1617111 */   // Label 22289: @1617111
     /* 1617111 */   GIM_Try, /*On fail goto*//*Label 22290*/ GIMT_Encode4(1617197), // Rule ID 3740 //
     /* 1617116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1617133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1617136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617162 */     // MIs[0] policy
     /* 1617162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617172 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1617175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617196 */     // GIR_Coverage, 3740,
     /* 1617196 */     GIR_EraseRootFromParent_Done,
     /* 1617197 */   // Label 22290: @1617197
     /* 1617197 */   GIM_Try, /*On fail goto*//*Label 22291*/ GIMT_Encode4(1617283), // Rule ID 3741 //
     /* 1617202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1617213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1617216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1617219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1617222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617248 */     // MIs[0] policy
     /* 1617248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617258 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1617261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617282 */     // GIR_Coverage, 3741,
     /* 1617282 */     GIR_EraseRootFromParent_Done,
     /* 1617283 */   // Label 22291: @1617283
     /* 1617283 */   GIM_Try, /*On fail goto*//*Label 22292*/ GIMT_Encode4(1617369), // Rule ID 3744 //
     /* 1617288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1617299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1617302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617334 */     // MIs[0] policy
     /* 1617334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1617347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617368 */     // GIR_Coverage, 3744,
     /* 1617368 */     GIR_EraseRootFromParent_Done,
     /* 1617369 */   // Label 22292: @1617369
     /* 1617369 */   GIM_Try, /*On fail goto*//*Label 22293*/ GIMT_Encode4(1617455), // Rule ID 3745 //
     /* 1617374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1617385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1617388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1617391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1617394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1617397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1617404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617420 */     // MIs[0] policy
     /* 1617420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1617433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617454 */     // GIR_Coverage, 3745,
     /* 1617454 */     GIR_EraseRootFromParent_Done,
     /* 1617455 */   // Label 22293: @1617455
     /* 1617455 */   GIM_Try, /*On fail goto*//*Label 22294*/ GIMT_Encode4(1617541), // Rule ID 3748 //
     /* 1617460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1617471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1617474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1617477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1617480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617506 */     // MIs[0] policy
     /* 1617506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617516 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1617519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617540 */     // GIR_Coverage, 3748,
     /* 1617540 */     GIR_EraseRootFromParent_Done,
     /* 1617541 */   // Label 22294: @1617541
     /* 1617541 */   GIM_Try, /*On fail goto*//*Label 22295*/ GIMT_Encode4(1617627), // Rule ID 3749 //
     /* 1617546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1617557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1617560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1617563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1617566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1617569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1617576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1617588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617592 */     // MIs[0] policy
     /* 1617592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617602 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1617605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617626 */     // GIR_Coverage, 3749,
     /* 1617626 */     GIR_EraseRootFromParent_Done,
     /* 1617627 */   // Label 22295: @1617627
     /* 1617627 */   GIM_Try, /*On fail goto*//*Label 22296*/ GIMT_Encode4(1617713), // Rule ID 3752 //
     /* 1617632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1617635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1617652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617678 */     // MIs[0] policy
     /* 1617678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617688 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1617691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617712 */     // GIR_Coverage, 3752,
     /* 1617712 */     GIR_EraseRootFromParent_Done,
     /* 1617713 */   // Label 22296: @1617713
     /* 1617713 */   GIM_Try, /*On fail goto*//*Label 22297*/ GIMT_Encode4(1617799), // Rule ID 3753 //
     /* 1617718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1617721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1617729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1617732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1617735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1617738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1617741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1617748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1617752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1617760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617764 */     // MIs[0] policy
     /* 1617764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617774 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1617777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1617795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617798 */     // GIR_Coverage, 3753,
     /* 1617798 */     GIR_EraseRootFromParent_Done,
     /* 1617799 */   // Label 22297: @1617799
     /* 1617799 */   GIM_Try, /*On fail goto*//*Label 22298*/ GIMT_Encode4(1617885), // Rule ID 3756 //
     /* 1617804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1617830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617850 */     // MIs[0] policy
     /* 1617850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1617860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1617863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617884 */     // GIR_Coverage, 3756,
     /* 1617884 */     GIR_EraseRootFromParent_Done,
     /* 1617885 */   // Label 22298: @1617885
     /* 1617885 */   GIM_Try, /*On fail goto*//*Label 22299*/ GIMT_Encode4(1617971), // Rule ID 3757 //
     /* 1617890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1617893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1617901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1617904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1617907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1617910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1617913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1617916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1617920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1617932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1617936 */     // MIs[0] policy
     /* 1617936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1617939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1617946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1617946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_MF2_MASK),
     /* 1617949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1617951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1617953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1617955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1617957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1617959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1617964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1617967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1617969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1617970 */     // GIR_Coverage, 3757,
     /* 1617970 */     GIR_EraseRootFromParent_Done,
     /* 1617971 */   // Label 22299: @1617971
     /* 1617971 */   GIM_Try, /*On fail goto*//*Label 22300*/ GIMT_Encode4(1618057), // Rule ID 3760 //
     /* 1617976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1617979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1617984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1617987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1617990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1617993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1617996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1617999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618022 */     // MIs[0] policy
     /* 1618022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618032 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1618035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618056 */     // GIR_Coverage, 3760,
     /* 1618056 */     GIR_EraseRootFromParent_Done,
     /* 1618057 */   // Label 22300: @1618057
     /* 1618057 */   GIM_Try, /*On fail goto*//*Label 22301*/ GIMT_Encode4(1618143), // Rule ID 3761 //
     /* 1618062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1618073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1618076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1618079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1618082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1618092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618108 */     // MIs[0] policy
     /* 1618108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M1_MASK),
     /* 1618121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618142 */     // GIR_Coverage, 3761,
     /* 1618142 */     GIR_EraseRootFromParent_Done,
     /* 1618143 */   // Label 22301: @1618143
     /* 1618143 */   GIM_Try, /*On fail goto*//*Label 22302*/ GIMT_Encode4(1618229), // Rule ID 3764 //
     /* 1618148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1618151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1618159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1618162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618194 */     // MIs[0] policy
     /* 1618194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618204 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1618207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618228 */     // GIR_Coverage, 3764,
     /* 1618228 */     GIR_EraseRootFromParent_Done,
     /* 1618229 */   // Label 22302: @1618229
     /* 1618229 */   GIM_Try, /*On fail goto*//*Label 22303*/ GIMT_Encode4(1618315), // Rule ID 3765 //
     /* 1618234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1618245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1618248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1618251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1618254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1618264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1618276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618280 */     // MIs[0] policy
     /* 1618280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618290 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M2_MASK),
     /* 1618293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618314 */     // GIR_Coverage, 3765,
     /* 1618314 */     GIR_EraseRootFromParent_Done,
     /* 1618315 */   // Label 22303: @1618315
     /* 1618315 */   GIM_Try, /*On fail goto*//*Label 22304*/ GIMT_Encode4(1618401), // Rule ID 3768 //
     /* 1618320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1618323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1618331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1618334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1618337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1618340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618366 */     // MIs[0] policy
     /* 1618366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618376 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1618379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618400 */     // GIR_Coverage, 3768,
     /* 1618400 */     GIR_EraseRootFromParent_Done,
     /* 1618401 */   // Label 22304: @1618401
     /* 1618401 */   GIM_Try, /*On fail goto*//*Label 22305*/ GIMT_Encode4(1618487), // Rule ID 3769 //
     /* 1618406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1618409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1618417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1618420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1618423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1618426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1618429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1618436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1618440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1618448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618452 */     // MIs[0] policy
     /* 1618452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618462 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VV_M4_MASK),
     /* 1618465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1618483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618486 */     // GIR_Coverage, 3769,
     /* 1618486 */     GIR_EraseRootFromParent_Done,
     /* 1618487 */   // Label 22305: @1618487
     /* 1618487 */   GIM_Try, /*On fail goto*//*Label 22306*/ GIMT_Encode4(1618573), // Rule ID 3772 //
     /* 1618492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1618503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1618506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1618509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618538 */     // MIs[0] policy
     /* 1618538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618548 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1618551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618572 */     // GIR_Coverage, 3772,
     /* 1618572 */     GIR_EraseRootFromParent_Done,
     /* 1618573 */   // Label 22306: @1618573
     /* 1618573 */   GIM_Try, /*On fail goto*//*Label 22307*/ GIMT_Encode4(1618659), // Rule ID 3773 //
     /* 1618578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1618589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1618592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1618595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1618601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618624 */     // MIs[0] policy
     /* 1618624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618634 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF8_MASK),
     /* 1618637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618658 */     // GIR_Coverage, 3773,
     /* 1618658 */     GIR_EraseRootFromParent_Done,
     /* 1618659 */   // Label 22307: @1618659
     /* 1618659 */   GIM_Try, /*On fail goto*//*Label 22308*/ GIMT_Encode4(1618745), // Rule ID 3776 //
     /* 1618664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618710 */     // MIs[0] policy
     /* 1618710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618720 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1618723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618744 */     // GIR_Coverage, 3776,
     /* 1618744 */     GIR_EraseRootFromParent_Done,
     /* 1618745 */   // Label 22308: @1618745
     /* 1618745 */   GIM_Try, /*On fail goto*//*Label 22309*/ GIMT_Encode4(1618831), // Rule ID 3777 //
     /* 1618750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1618761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1618764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1618767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1618773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618796 */     // MIs[0] policy
     /* 1618796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618806 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1618809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618830 */     // GIR_Coverage, 3777,
     /* 1618830 */     GIR_EraseRootFromParent_Done,
     /* 1618831 */   // Label 22309: @1618831
     /* 1618831 */   GIM_Try, /*On fail goto*//*Label 22310*/ GIMT_Encode4(1618917), // Rule ID 3780 //
     /* 1618836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1618839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1618856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1618862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618882 */     // MIs[0] policy
     /* 1618882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618892 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1618892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1618895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1618915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1618916 */     // GIR_Coverage, 3780,
     /* 1618916 */     GIR_EraseRootFromParent_Done,
     /* 1618917 */   // Label 22310: @1618917
     /* 1618917 */   GIM_Try, /*On fail goto*//*Label 22311*/ GIMT_Encode4(1619003), // Rule ID 3781 //
     /* 1618922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1618925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1618930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1618933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1618936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1618939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1618942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1618945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1618948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1618952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1618960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1618964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1618968 */     // MIs[0] policy
     /* 1618968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1618971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1618978 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11571:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1618978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1618981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1618983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1618985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1618987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1618989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1618991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1618996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1618999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619002 */     // GIR_Coverage, 3781,
     /* 1619002 */     GIR_EraseRootFromParent_Done,
     /* 1619003 */   // Label 22311: @1619003
     /* 1619003 */   GIM_Try, /*On fail goto*//*Label 22312*/ GIMT_Encode4(1619089), // Rule ID 3784 //
     /* 1619008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1619019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1619022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1619025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619054 */     // MIs[0] policy
     /* 1619054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619064 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1619067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619088 */     // GIR_Coverage, 3784,
     /* 1619088 */     GIR_EraseRootFromParent_Done,
     /* 1619089 */   // Label 22312: @1619089
     /* 1619089 */   GIM_Try, /*On fail goto*//*Label 22313*/ GIMT_Encode4(1619175), // Rule ID 3785 //
     /* 1619094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1619105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1619108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1619111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1619117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619140 */     // MIs[0] policy
     /* 1619140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619150 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1619153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619174 */     // GIR_Coverage, 3785,
     /* 1619174 */     GIR_EraseRootFromParent_Done,
     /* 1619175 */   // Label 22313: @1619175
     /* 1619175 */   GIM_Try, /*On fail goto*//*Label 22314*/ GIMT_Encode4(1619261), // Rule ID 3788 //
     /* 1619180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1619191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1619194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1619197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619226 */     // MIs[0] policy
     /* 1619226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619236 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1619239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619260 */     // GIR_Coverage, 3788,
     /* 1619260 */     GIR_EraseRootFromParent_Done,
     /* 1619261 */   // Label 22314: @1619261
     /* 1619261 */   GIM_Try, /*On fail goto*//*Label 22315*/ GIMT_Encode4(1619347), // Rule ID 3789 //
     /* 1619266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1619277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1619280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1619283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1619289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1619296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619312 */     // MIs[0] policy
     /* 1619312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619322 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1619325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619346 */     // GIR_Coverage, 3789,
     /* 1619346 */     GIR_EraseRootFromParent_Done,
     /* 1619347 */   // Label 22315: @1619347
     /* 1619347 */   GIM_Try, /*On fail goto*//*Label 22316*/ GIMT_Encode4(1619433), // Rule ID 3792 //
     /* 1619352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1619363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1619366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1619369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1619375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619398 */     // MIs[0] policy
     /* 1619398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619408 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1619411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619432 */     // GIR_Coverage, 3792,
     /* 1619432 */     GIR_EraseRootFromParent_Done,
     /* 1619433 */   // Label 22316: @1619433
     /* 1619433 */   GIM_Try, /*On fail goto*//*Label 22317*/ GIMT_Encode4(1619519), // Rule ID 3793 //
     /* 1619438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1619449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1619452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1619455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1619461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1619468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1619472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1619476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619484 */     // MIs[0] policy
     /* 1619484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619494 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1619497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1619515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619518 */     // GIR_Coverage, 3793,
     /* 1619518 */     GIR_EraseRootFromParent_Done,
     /* 1619519 */   // Label 22317: @1619519
     /* 1619519 */   GIM_Try, /*On fail goto*//*Label 22318*/ GIMT_Encode4(1619605), // Rule ID 3796 //
     /* 1619524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1619535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1619538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1619541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619570 */     // MIs[0] policy
     /* 1619570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619580 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1619583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619604 */     // GIR_Coverage, 3796,
     /* 1619604 */     GIR_EraseRootFromParent_Done,
     /* 1619605 */   // Label 22318: @1619605
     /* 1619605 */   GIM_Try, /*On fail goto*//*Label 22319*/ GIMT_Encode4(1619691), // Rule ID 3797 //
     /* 1619610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1619621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1619624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1619627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1619633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619656 */     // MIs[0] policy
     /* 1619656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619666 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF4_MASK),
     /* 1619669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619690 */     // GIR_Coverage, 3797,
     /* 1619690 */     GIR_EraseRootFromParent_Done,
     /* 1619691 */   // Label 22319: @1619691
     /* 1619691 */   GIM_Try, /*On fail goto*//*Label 22320*/ GIMT_Encode4(1619777), // Rule ID 3800 //
     /* 1619696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619742 */     // MIs[0] policy
     /* 1619742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619752 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1619755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619776 */     // GIR_Coverage, 3800,
     /* 1619776 */     GIR_EraseRootFromParent_Done,
     /* 1619777 */   // Label 22320: @1619777
     /* 1619777 */   GIM_Try, /*On fail goto*//*Label 22321*/ GIMT_Encode4(1619863), // Rule ID 3801 //
     /* 1619782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1619793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1619796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1619799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1619805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1619812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619828 */     // MIs[0] policy
     /* 1619828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619838 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11571:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1619838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1619841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619862 */     // GIR_Coverage, 3801,
     /* 1619862 */     GIR_EraseRootFromParent_Done,
     /* 1619863 */   // Label 22321: @1619863
     /* 1619863 */   GIM_Try, /*On fail goto*//*Label 22322*/ GIMT_Encode4(1619949), // Rule ID 3804 //
     /* 1619868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1619871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1619888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1619894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1619914 */     // MIs[0] policy
     /* 1619914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1619917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1619924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1619924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1619927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1619929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1619931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1619933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1619935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1619937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1619942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1619945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1619947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1619948 */     // GIR_Coverage, 3804,
     /* 1619948 */     GIR_EraseRootFromParent_Done,
     /* 1619949 */   // Label 22322: @1619949
     /* 1619949 */   GIM_Try, /*On fail goto*//*Label 22323*/ GIMT_Encode4(1620035), // Rule ID 3805 //
     /* 1619954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1619957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1619962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1619965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1619968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1619971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1619974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1619977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1619980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1619984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1619988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1619992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1619996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620000 */     // MIs[0] policy
     /* 1620000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620010 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1620013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620034 */     // GIR_Coverage, 3805,
     /* 1620034 */     GIR_EraseRootFromParent_Done,
     /* 1620035 */   // Label 22323: @1620035
     /* 1620035 */   GIM_Try, /*On fail goto*//*Label 22324*/ GIMT_Encode4(1620121), // Rule ID 3808 //
     /* 1620040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1620051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1620054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1620057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620086 */     // MIs[0] policy
     /* 1620086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620096 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1620099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620120 */     // GIR_Coverage, 3808,
     /* 1620120 */     GIR_EraseRootFromParent_Done,
     /* 1620121 */   // Label 22324: @1620121
     /* 1620121 */   GIM_Try, /*On fail goto*//*Label 22325*/ GIMT_Encode4(1620207), // Rule ID 3809 //
     /* 1620126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1620137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1620140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1620143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620172 */     // MIs[0] policy
     /* 1620172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620182 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1620185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620206 */     // GIR_Coverage, 3809,
     /* 1620206 */     GIR_EraseRootFromParent_Done,
     /* 1620207 */   // Label 22325: @1620207
     /* 1620207 */   GIM_Try, /*On fail goto*//*Label 22326*/ GIMT_Encode4(1620293), // Rule ID 3812 //
     /* 1620212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1620215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1620223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1620226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1620229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620258 */     // MIs[0] policy
     /* 1620258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620268 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1620271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620292 */     // GIR_Coverage, 3812,
     /* 1620292 */     GIR_EraseRootFromParent_Done,
     /* 1620293 */   // Label 22326: @1620293
     /* 1620293 */   GIM_Try, /*On fail goto*//*Label 22327*/ GIMT_Encode4(1620379), // Rule ID 3813 //
     /* 1620298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1620301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1620309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1620312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1620315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1620321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620344 */     // MIs[0] policy
     /* 1620344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620354 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1620357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1620375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620378 */     // GIR_Coverage, 3813,
     /* 1620378 */     GIR_EraseRootFromParent_Done,
     /* 1620379 */   // Label 22327: @1620379
     /* 1620379 */   GIM_Try, /*On fail goto*//*Label 22328*/ GIMT_Encode4(1620465), // Rule ID 3816 //
     /* 1620384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1620395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1620398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620430 */     // MIs[0] policy
     /* 1620430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1620443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620464 */     // GIR_Coverage, 3816,
     /* 1620464 */     GIR_EraseRootFromParent_Done,
     /* 1620465 */   // Label 22328: @1620465
     /* 1620465 */   GIM_Try, /*On fail goto*//*Label 22329*/ GIMT_Encode4(1620551), // Rule ID 3817 //
     /* 1620470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1620481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1620484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1620487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1620493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1620500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620516 */     // MIs[0] policy
     /* 1620516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11571:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_MF2_MASK),
     /* 1620529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620550 */     // GIR_Coverage, 3817,
     /* 1620550 */     GIR_EraseRootFromParent_Done,
     /* 1620551 */   // Label 22329: @1620551
     /* 1620551 */   GIM_Try, /*On fail goto*//*Label 22330*/ GIMT_Encode4(1620637), // Rule ID 3820 //
     /* 1620556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1620567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1620570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1620573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620602 */     // MIs[0] policy
     /* 1620602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620612 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1620615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620636 */     // GIR_Coverage, 3820,
     /* 1620636 */     GIR_EraseRootFromParent_Done,
     /* 1620637 */   // Label 22330: @1620637
     /* 1620637 */   GIM_Try, /*On fail goto*//*Label 22331*/ GIMT_Encode4(1620723), // Rule ID 3821 //
     /* 1620642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1620653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1620656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1620659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1620665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1620672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1620680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620688 */     // MIs[0] policy
     /* 1620688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620698 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11571:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M1_MASK),
     /* 1620701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620722 */     // GIR_Coverage, 3821,
     /* 1620722 */     GIR_EraseRootFromParent_Done,
     /* 1620723 */   // Label 22331: @1620723
     /* 1620723 */   GIM_Try, /*On fail goto*//*Label 22332*/ GIMT_Encode4(1620809), // Rule ID 3824 //
     /* 1620728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620774 */     // MIs[0] policy
     /* 1620774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1620787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620808 */     // GIR_Coverage, 3824,
     /* 1620808 */     GIR_EraseRootFromParent_Done,
     /* 1620809 */   // Label 22332: @1620809
     /* 1620809 */   GIM_Try, /*On fail goto*//*Label 22333*/ GIMT_Encode4(1620895), // Rule ID 3825 //
     /* 1620814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1620825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1620828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1620831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1620834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1620837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1620840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1620844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1620852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620860 */     // MIs[0] policy
     /* 1620860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620870 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11571:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1620870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M2_MASK),
     /* 1620873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620894 */     // GIR_Coverage, 3825,
     /* 1620894 */     GIR_EraseRootFromParent_Done,
     /* 1620895 */   // Label 22333: @1620895
     /* 1620895 */   GIM_Try, /*On fail goto*//*Label 22334*/ GIMT_Encode4(1620981), // Rule ID 3828 //
     /* 1620900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1620903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1620914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1620917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1620920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1620923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1620926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1620930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1620934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1620938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1620942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1620946 */     // MIs[0] policy
     /* 1620946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1620949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1620956 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1620956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1620959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1620961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1620963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1620965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1620967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1620969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1620974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1620977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1620979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1620980 */     // GIR_Coverage, 3828,
     /* 1620980 */     GIR_EraseRootFromParent_Done,
     /* 1620981 */   // Label 22334: @1620981
     /* 1620981 */   GIM_Try, /*On fail goto*//*Label 22335*/ GIMT_Encode4(1621067), // Rule ID 3829 //
     /* 1620986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1620989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_mask),
     /* 1620994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1620997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1621000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1621003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1621006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1621028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621032 */     // MIs[0] policy
     /* 1621032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621042 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11571:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_VX_M4_MASK),
     /* 1621045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1621063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621066 */     // GIR_Coverage, 3829,
     /* 1621066 */     GIR_EraseRootFromParent_Done,
     /* 1621067 */   // Label 22335: @1621067
     /* 1621067 */   GIM_Try, /*On fail goto*//*Label 22336*/ GIMT_Encode4(1621153), // Rule ID 3832 //
     /* 1621072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1621083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1621086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1621089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1621092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621118 */     // MIs[0] policy
     /* 1621118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1621131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621152 */     // GIR_Coverage, 3832,
     /* 1621152 */     GIR_EraseRootFromParent_Done,
     /* 1621153 */   // Label 22336: @1621153
     /* 1621153 */   GIM_Try, /*On fail goto*//*Label 22337*/ GIMT_Encode4(1621239), // Rule ID 3833 //
     /* 1621158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1621169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1621172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1621175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1621178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1621181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621204 */     // MIs[0] policy
     /* 1621204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF8_MASK),
     /* 1621217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621238 */     // GIR_Coverage, 3833,
     /* 1621238 */     GIR_EraseRootFromParent_Done,
     /* 1621239 */   // Label 22337: @1621239
     /* 1621239 */   GIM_Try, /*On fail goto*//*Label 22338*/ GIMT_Encode4(1621325), // Rule ID 3836 //
     /* 1621244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1621255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1621258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1621261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1621264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621290 */     // MIs[0] policy
     /* 1621290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1621303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621324 */     // GIR_Coverage, 3836,
     /* 1621324 */     GIR_EraseRootFromParent_Done,
     /* 1621325 */   // Label 22338: @1621325
     /* 1621325 */   GIM_Try, /*On fail goto*//*Label 22339*/ GIMT_Encode4(1621411), // Rule ID 3837 //
     /* 1621330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1621341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1621344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1621347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1621350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1621353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621376 */     // MIs[0] policy
     /* 1621376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1621389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621410 */     // GIR_Coverage, 3837,
     /* 1621410 */     GIR_EraseRootFromParent_Done,
     /* 1621411 */   // Label 22339: @1621411
     /* 1621411 */   GIM_Try, /*On fail goto*//*Label 22340*/ GIMT_Encode4(1621497), // Rule ID 3840 //
     /* 1621416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1621433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1621436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621462 */     // MIs[0] policy
     /* 1621462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1621475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621496 */     // GIR_Coverage, 3840,
     /* 1621496 */     GIR_EraseRootFromParent_Done,
     /* 1621497 */   // Label 22340: @1621497
     /* 1621497 */   GIM_Try, /*On fail goto*//*Label 22341*/ GIMT_Encode4(1621583), // Rule ID 3841 //
     /* 1621502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1621513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1621516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1621519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1621522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1621525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1621532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621548 */     // MIs[0] policy
     /* 1621548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1621561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621582 */     // GIR_Coverage, 3841,
     /* 1621582 */     GIR_EraseRootFromParent_Done,
     /* 1621583 */   // Label 22341: @1621583
     /* 1621583 */   GIM_Try, /*On fail goto*//*Label 22342*/ GIMT_Encode4(1621669), // Rule ID 3844 //
     /* 1621588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1621599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1621608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621634 */     // MIs[0] policy
     /* 1621634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621644 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1621647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621668 */     // GIR_Coverage, 3844,
     /* 1621668 */     GIR_EraseRootFromParent_Done,
     /* 1621669 */   // Label 22342: @1621669
     /* 1621669 */   GIM_Try, /*On fail goto*//*Label 22343*/ GIMT_Encode4(1621755), // Rule ID 3845 //
     /* 1621674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1621685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1621688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1621691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1621694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1621697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1621704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1621716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621720 */     // MIs[0] policy
     /* 1621720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621730 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1621733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621754 */     // GIR_Coverage, 3845,
     /* 1621754 */     GIR_EraseRootFromParent_Done,
     /* 1621755 */   // Label 22343: @1621755
     /* 1621755 */   GIM_Try, /*On fail goto*//*Label 22344*/ GIMT_Encode4(1621841), // Rule ID 3848 //
     /* 1621760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1621780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621806 */     // MIs[0] policy
     /* 1621806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621816 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1621819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621840 */     // GIR_Coverage, 3848,
     /* 1621840 */     GIR_EraseRootFromParent_Done,
     /* 1621841 */   // Label 22344: @1621841
     /* 1621841 */   GIM_Try, /*On fail goto*//*Label 22345*/ GIMT_Encode4(1621927), // Rule ID 3849 //
     /* 1621846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1621849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1621857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1621860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1621863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1621866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1621869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1621872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1621876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1621888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621892 */     // MIs[0] policy
     /* 1621892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621902 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1621902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1621905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1621915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1621920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1621923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1621925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1621926 */     // GIR_Coverage, 3849,
     /* 1621926 */     GIR_EraseRootFromParent_Done,
     /* 1621927 */   // Label 22345: @1621927
     /* 1621927 */   GIM_Try, /*On fail goto*//*Label 22346*/ GIMT_Encode4(1622013), // Rule ID 3852 //
     /* 1621932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1621935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1621940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1621943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1621946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1621949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1621952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1621955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1621958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1621962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1621966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1621974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1621978 */     // MIs[0] policy
     /* 1621978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1621981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1621988 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1621988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1621991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1621993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1621995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1621997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1621999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622012 */     // GIR_Coverage, 3852,
     /* 1622012 */     GIR_EraseRootFromParent_Done,
     /* 1622013 */   // Label 22346: @1622013
     /* 1622013 */   GIM_Try, /*On fail goto*//*Label 22347*/ GIMT_Encode4(1622099), // Rule ID 3853 //
     /* 1622018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1622029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1622032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1622035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1622038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1622041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622064 */     // MIs[0] policy
     /* 1622064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622074 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1622077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1622095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622098 */     // GIR_Coverage, 3853,
     /* 1622098 */     GIR_EraseRootFromParent_Done,
     /* 1622099 */   // Label 22347: @1622099
     /* 1622099 */   GIM_Try, /*On fail goto*//*Label 22348*/ GIMT_Encode4(1622185), // Rule ID 3856 //
     /* 1622104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1622115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1622118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1622121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1622124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622150 */     // MIs[0] policy
     /* 1622150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622160 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1622163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622184 */     // GIR_Coverage, 3856,
     /* 1622184 */     GIR_EraseRootFromParent_Done,
     /* 1622185 */   // Label 22348: @1622185
     /* 1622185 */   GIM_Try, /*On fail goto*//*Label 22349*/ GIMT_Encode4(1622271), // Rule ID 3857 //
     /* 1622190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1622201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1622204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1622207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1622210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622236 */     // MIs[0] policy
     /* 1622236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622246 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF4_MASK),
     /* 1622249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622270 */     // GIR_Coverage, 3857,
     /* 1622270 */     GIR_EraseRootFromParent_Done,
     /* 1622271 */   // Label 22349: @1622271
     /* 1622271 */   GIM_Try, /*On fail goto*//*Label 22350*/ GIMT_Encode4(1622357), // Rule ID 3860 //
     /* 1622276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1622287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1622290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1622293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1622296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622322 */     // MIs[0] policy
     /* 1622322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622332 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1622335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622356 */     // GIR_Coverage, 3860,
     /* 1622356 */     GIR_EraseRootFromParent_Done,
     /* 1622357 */   // Label 22350: @1622357
     /* 1622357 */   GIM_Try, /*On fail goto*//*Label 22351*/ GIMT_Encode4(1622443), // Rule ID 3861 //
     /* 1622362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1622373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1622376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1622379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1622382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1622385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622408 */     // MIs[0] policy
     /* 1622408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622418 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1622421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622442 */     // GIR_Coverage, 3861,
     /* 1622442 */     GIR_EraseRootFromParent_Done,
     /* 1622443 */   // Label 22351: @1622443
     /* 1622443 */   GIM_Try, /*On fail goto*//*Label 22352*/ GIMT_Encode4(1622529), // Rule ID 3864 //
     /* 1622448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1622465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1622468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622494 */     // MIs[0] policy
     /* 1622494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1622507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622528 */     // GIR_Coverage, 3864,
     /* 1622528 */     GIR_EraseRootFromParent_Done,
     /* 1622529 */   // Label 22352: @1622529
     /* 1622529 */   GIM_Try, /*On fail goto*//*Label 22353*/ GIMT_Encode4(1622615), // Rule ID 3865 //
     /* 1622534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1622545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1622548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1622551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1622554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1622557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1622564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622580 */     // MIs[0] policy
     /* 1622580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1622593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622614 */     // GIR_Coverage, 3865,
     /* 1622614 */     GIR_EraseRootFromParent_Done,
     /* 1622615 */   // Label 22353: @1622615
     /* 1622615 */   GIM_Try, /*On fail goto*//*Label 22354*/ GIMT_Encode4(1622701), // Rule ID 3868 //
     /* 1622620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1622640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622666 */     // MIs[0] policy
     /* 1622666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622676 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1622679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622700 */     // GIR_Coverage, 3868,
     /* 1622700 */     GIR_EraseRootFromParent_Done,
     /* 1622701 */   // Label 22354: @1622701
     /* 1622701 */   GIM_Try, /*On fail goto*//*Label 22355*/ GIMT_Encode4(1622787), // Rule ID 3869 //
     /* 1622706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1622717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1622720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1622723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1622726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1622729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1622736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1622748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622752 */     // MIs[0] policy
     /* 1622752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622762 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1622765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622786 */     // GIR_Coverage, 3869,
     /* 1622786 */     GIR_EraseRootFromParent_Done,
     /* 1622787 */   // Label 22355: @1622787
     /* 1622787 */   GIM_Try, /*On fail goto*//*Label 22356*/ GIMT_Encode4(1622873), // Rule ID 3872 //
     /* 1622792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1622795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1622812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622838 */     // MIs[0] policy
     /* 1622838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622848 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1622848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1622851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622872 */     // GIR_Coverage, 3872,
     /* 1622872 */     GIR_EraseRootFromParent_Done,
     /* 1622873 */   // Label 22356: @1622873
     /* 1622873 */   GIM_Try, /*On fail goto*//*Label 22357*/ GIMT_Encode4(1622959), // Rule ID 3873 //
     /* 1622878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1622881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1622889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1622892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1622895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1622898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1622901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1622904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1622908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1622912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1622920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1622924 */     // MIs[0] policy
     /* 1622924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1622927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1622934 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1622934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1622937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1622939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1622941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1622943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1622945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1622947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1622952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1622955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1622957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1622958 */     // GIR_Coverage, 3873,
     /* 1622958 */     GIR_EraseRootFromParent_Done,
     /* 1622959 */   // Label 22357: @1622959
     /* 1622959 */   GIM_Try, /*On fail goto*//*Label 22358*/ GIMT_Encode4(1623045), // Rule ID 3876 //
     /* 1622964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1622967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1622972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1622975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1622978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1622981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1622984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1622987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1622990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1622994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1622998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623010 */     // MIs[0] policy
     /* 1623010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623020 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1623023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623044 */     // GIR_Coverage, 3876,
     /* 1623044 */     GIR_EraseRootFromParent_Done,
     /* 1623045 */   // Label 22358: @1623045
     /* 1623045 */   GIM_Try, /*On fail goto*//*Label 22359*/ GIMT_Encode4(1623131), // Rule ID 3877 //
     /* 1623050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1623061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1623064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1623067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1623070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623096 */     // MIs[0] policy
     /* 1623096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623106 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_MF2_MASK),
     /* 1623109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623130 */     // GIR_Coverage, 3877,
     /* 1623130 */     GIR_EraseRootFromParent_Done,
     /* 1623131 */   // Label 22359: @1623131
     /* 1623131 */   GIM_Try, /*On fail goto*//*Label 22360*/ GIMT_Encode4(1623217), // Rule ID 3880 //
     /* 1623136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1623153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1623156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623182 */     // MIs[0] policy
     /* 1623182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1623195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623216 */     // GIR_Coverage, 3880,
     /* 1623216 */     GIR_EraseRootFromParent_Done,
     /* 1623217 */   // Label 22360: @1623217
     /* 1623217 */   GIM_Try, /*On fail goto*//*Label 22361*/ GIMT_Encode4(1623303), // Rule ID 3881 //
     /* 1623222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1623233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1623236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1623239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1623242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1623252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623268 */     // MIs[0] policy
     /* 1623268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M1_MASK),
     /* 1623281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623302 */     // GIR_Coverage, 3881,
     /* 1623302 */     GIR_EraseRootFromParent_Done,
     /* 1623303 */   // Label 22361: @1623303
     /* 1623303 */   GIM_Try, /*On fail goto*//*Label 22362*/ GIMT_Encode4(1623389), // Rule ID 3884 //
     /* 1623308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1623325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1623328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623354 */     // MIs[0] policy
     /* 1623354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1623367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623388 */     // GIR_Coverage, 3884,
     /* 1623388 */     GIR_EraseRootFromParent_Done,
     /* 1623389 */   // Label 22362: @1623389
     /* 1623389 */   GIM_Try, /*On fail goto*//*Label 22363*/ GIMT_Encode4(1623475), // Rule ID 3885 //
     /* 1623394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1623405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1623408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1623411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1623414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1623417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1623424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1623436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623440 */     // MIs[0] policy
     /* 1623440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M2_MASK),
     /* 1623453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623474 */     // GIR_Coverage, 3885,
     /* 1623474 */     GIR_EraseRootFromParent_Done,
     /* 1623475 */   // Label 22363: @1623475
     /* 1623475 */   GIM_Try, /*On fail goto*//*Label 22364*/ GIMT_Encode4(1623561), // Rule ID 3888 //
     /* 1623480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1623483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1623497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1623500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623526 */     // MIs[0] policy
     /* 1623526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1623539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623560 */     // GIR_Coverage, 3888,
     /* 1623560 */     GIR_EraseRootFromParent_Done,
     /* 1623561 */   // Label 22364: @1623561
     /* 1623561 */   GIM_Try, /*On fail goto*//*Label 22365*/ GIMT_Encode4(1623647), // Rule ID 3889 //
     /* 1623566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1623569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1623577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1623580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1623583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1623586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1623589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1623596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1623600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1623608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623612 */     // MIs[0] policy
     /* 1623612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VV_M4_MASK),
     /* 1623625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1623643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623646 */     // GIR_Coverage, 3889,
     /* 1623646 */     GIR_EraseRootFromParent_Done,
     /* 1623647 */   // Label 22365: @1623647
     /* 1623647 */   GIM_Try, /*On fail goto*//*Label 22366*/ GIMT_Encode4(1623733), // Rule ID 3892 //
     /* 1623652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623698 */     // MIs[0] policy
     /* 1623698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623708 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1623711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623732 */     // GIR_Coverage, 3892,
     /* 1623732 */     GIR_EraseRootFromParent_Done,
     /* 1623733 */   // Label 22366: @1623733
     /* 1623733 */   GIM_Try, /*On fail goto*//*Label 22367*/ GIMT_Encode4(1623819), // Rule ID 3893 //
     /* 1623738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1623749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1623752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1623755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1623761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623784 */     // MIs[0] policy
     /* 1623784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623794 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF8_MASK),
     /* 1623797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623818 */     // GIR_Coverage, 3893,
     /* 1623818 */     GIR_EraseRootFromParent_Done,
     /* 1623819 */   // Label 22367: @1623819
     /* 1623819 */   GIM_Try, /*On fail goto*//*Label 22368*/ GIMT_Encode4(1623905), // Rule ID 3896 //
     /* 1623824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1623844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1623850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623870 */     // MIs[0] policy
     /* 1623870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623880 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1623880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1623883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623904 */     // GIR_Coverage, 3896,
     /* 1623904 */     GIR_EraseRootFromParent_Done,
     /* 1623905 */   // Label 22368: @1623905
     /* 1623905 */   GIM_Try, /*On fail goto*//*Label 22369*/ GIMT_Encode4(1623991), // Rule ID 3897 //
     /* 1623910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1623913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1623918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1623921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1623924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1623927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1623930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1623933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1623936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1623940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1623948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1623952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1623956 */     // MIs[0] policy
     /* 1623956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1623959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1623966 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1623966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1623969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1623971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1623973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1623975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1623977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1623979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1623984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1623987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1623989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1623990 */     // GIR_Coverage, 3897,
     /* 1623990 */     GIR_EraseRootFromParent_Done,
     /* 1623991 */   // Label 22369: @1623991
     /* 1623991 */   GIM_Try, /*On fail goto*//*Label 22370*/ GIMT_Encode4(1624077), // Rule ID 3900 //
     /* 1623996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1623999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624042 */     // MIs[0] policy
     /* 1624042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624052 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1624055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624076 */     // GIR_Coverage, 3900,
     /* 1624076 */     GIR_EraseRootFromParent_Done,
     /* 1624077 */   // Label 22370: @1624077
     /* 1624077 */   GIM_Try, /*On fail goto*//*Label 22371*/ GIMT_Encode4(1624163), // Rule ID 3901 //
     /* 1624082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1624093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1624096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1624099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1624105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624128 */     // MIs[0] policy
     /* 1624128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624138 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11599:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1624141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624162 */     // GIR_Coverage, 3901,
     /* 1624162 */     GIR_EraseRootFromParent_Done,
     /* 1624163 */   // Label 22371: @1624163
     /* 1624163 */   GIM_Try, /*On fail goto*//*Label 22372*/ GIMT_Encode4(1624249), // Rule ID 3904 //
     /* 1624168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1624179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1624182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624214 */     // MIs[0] policy
     /* 1624214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1624227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624248 */     // GIR_Coverage, 3904,
     /* 1624248 */     GIR_EraseRootFromParent_Done,
     /* 1624249 */   // Label 22372: @1624249
     /* 1624249 */   GIM_Try, /*On fail goto*//*Label 22373*/ GIMT_Encode4(1624335), // Rule ID 3905 //
     /* 1624254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1624265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1624268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1624271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1624277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1624284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624300 */     // MIs[0] policy
     /* 1624300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624310 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1624313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624334 */     // GIR_Coverage, 3905,
     /* 1624334 */     GIR_EraseRootFromParent_Done,
     /* 1624335 */   // Label 22373: @1624335
     /* 1624335 */   GIM_Try, /*On fail goto*//*Label 22374*/ GIMT_Encode4(1624421), // Rule ID 3908 //
     /* 1624340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1624351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1624354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1624357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624386 */     // MIs[0] policy
     /* 1624386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624396 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1624399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624420 */     // GIR_Coverage, 3908,
     /* 1624420 */     GIR_EraseRootFromParent_Done,
     /* 1624421 */   // Label 22374: @1624421
     /* 1624421 */   GIM_Try, /*On fail goto*//*Label 22375*/ GIMT_Encode4(1624507), // Rule ID 3909 //
     /* 1624426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1624437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1624440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1624443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1624449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1624456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1624464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624472 */     // MIs[0] policy
     /* 1624472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624482 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1624485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624506 */     // GIR_Coverage, 3909,
     /* 1624506 */     GIR_EraseRootFromParent_Done,
     /* 1624507 */   // Label 22375: @1624507
     /* 1624507 */   GIM_Try, /*On fail goto*//*Label 22376*/ GIMT_Encode4(1624593), // Rule ID 3912 //
     /* 1624512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1624523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1624526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1624529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1624535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624558 */     // MIs[0] policy
     /* 1624558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624568 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1624571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624592 */     // GIR_Coverage, 3912,
     /* 1624592 */     GIR_EraseRootFromParent_Done,
     /* 1624593 */   // Label 22376: @1624593
     /* 1624593 */   GIM_Try, /*On fail goto*//*Label 22377*/ GIMT_Encode4(1624679), // Rule ID 3913 //
     /* 1624598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1624609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1624612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1624615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1624621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1624628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1624632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1624636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624644 */     // MIs[0] policy
     /* 1624644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624654 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1624657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1624675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624678 */     // GIR_Coverage, 3913,
     /* 1624678 */     GIR_EraseRootFromParent_Done,
     /* 1624679 */   // Label 22377: @1624679
     /* 1624679 */   GIM_Try, /*On fail goto*//*Label 22378*/ GIMT_Encode4(1624765), // Rule ID 3916 //
     /* 1624684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624730 */     // MIs[0] policy
     /* 1624730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624740 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1624743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624764 */     // GIR_Coverage, 3916,
     /* 1624764 */     GIR_EraseRootFromParent_Done,
     /* 1624765 */   // Label 22378: @1624765
     /* 1624765 */   GIM_Try, /*On fail goto*//*Label 22379*/ GIMT_Encode4(1624851), // Rule ID 3917 //
     /* 1624770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1624781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1624784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1624787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1624793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624816 */     // MIs[0] policy
     /* 1624816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624826 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF4_MASK),
     /* 1624829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624850 */     // GIR_Coverage, 3917,
     /* 1624850 */     GIR_EraseRootFromParent_Done,
     /* 1624851 */   // Label 22379: @1624851
     /* 1624851 */   GIM_Try, /*On fail goto*//*Label 22380*/ GIMT_Encode4(1624937), // Rule ID 3920 //
     /* 1624856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1624859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1624876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1624882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624902 */     // MIs[0] policy
     /* 1624902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624912 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1624912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1624915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1624917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1624919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1624921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1624923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1624925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1624930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1624933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1624935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1624936 */     // GIR_Coverage, 3920,
     /* 1624936 */     GIR_EraseRootFromParent_Done,
     /* 1624937 */   // Label 22380: @1624937
     /* 1624937 */   GIM_Try, /*On fail goto*//*Label 22381*/ GIMT_Encode4(1625023), // Rule ID 3921 //
     /* 1624942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1624945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1624950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1624953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1624956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1624959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1624962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1624965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1624968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1624972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1624980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1624984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1624988 */     // MIs[0] policy
     /* 1624988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1624991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1624998 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11599:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1624998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1625001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625022 */     // GIR_Coverage, 3921,
     /* 1625022 */     GIR_EraseRootFromParent_Done,
     /* 1625023 */   // Label 22381: @1625023
     /* 1625023 */   GIM_Try, /*On fail goto*//*Label 22382*/ GIMT_Encode4(1625109), // Rule ID 3924 //
     /* 1625028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1625039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1625042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1625045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625074 */     // MIs[0] policy
     /* 1625074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625084 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1625087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625108 */     // GIR_Coverage, 3924,
     /* 1625108 */     GIR_EraseRootFromParent_Done,
     /* 1625109 */   // Label 22382: @1625109
     /* 1625109 */   GIM_Try, /*On fail goto*//*Label 22383*/ GIMT_Encode4(1625195), // Rule ID 3925 //
     /* 1625114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1625125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1625128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1625131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625160 */     // MIs[0] policy
     /* 1625160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1625173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625194 */     // GIR_Coverage, 3925,
     /* 1625194 */     GIR_EraseRootFromParent_Done,
     /* 1625195 */   // Label 22383: @1625195
     /* 1625195 */   GIM_Try, /*On fail goto*//*Label 22384*/ GIMT_Encode4(1625281), // Rule ID 3928 //
     /* 1625200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1625211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1625214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1625217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625246 */     // MIs[0] policy
     /* 1625246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625256 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1625259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625280 */     // GIR_Coverage, 3928,
     /* 1625280 */     GIR_EraseRootFromParent_Done,
     /* 1625281 */   // Label 22384: @1625281
     /* 1625281 */   GIM_Try, /*On fail goto*//*Label 22385*/ GIMT_Encode4(1625367), // Rule ID 3929 //
     /* 1625286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1625297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1625300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1625303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1625309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625332 */     // MIs[0] policy
     /* 1625332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625342 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1625345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625366 */     // GIR_Coverage, 3929,
     /* 1625366 */     GIR_EraseRootFromParent_Done,
     /* 1625367 */   // Label 22385: @1625367
     /* 1625367 */   GIM_Try, /*On fail goto*//*Label 22386*/ GIMT_Encode4(1625453), // Rule ID 3932 //
     /* 1625372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1625375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1625383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1625386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1625389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625418 */     // MIs[0] policy
     /* 1625418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625428 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1625431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625452 */     // GIR_Coverage, 3932,
     /* 1625452 */     GIR_EraseRootFromParent_Done,
     /* 1625453 */   // Label 22386: @1625453
     /* 1625453 */   GIM_Try, /*On fail goto*//*Label 22387*/ GIMT_Encode4(1625539), // Rule ID 3933 //
     /* 1625458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1625461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1625469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1625472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1625475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1625481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1625488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1625492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625504 */     // MIs[0] policy
     /* 1625504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625514 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1625517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1625535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625538 */     // GIR_Coverage, 3933,
     /* 1625538 */     GIR_EraseRootFromParent_Done,
     /* 1625539 */   // Label 22387: @1625539
     /* 1625539 */   GIM_Try, /*On fail goto*//*Label 22388*/ GIMT_Encode4(1625625), // Rule ID 3936 //
     /* 1625544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1625561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625590 */     // MIs[0] policy
     /* 1625590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1625603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625624 */     // GIR_Coverage, 3936,
     /* 1625624 */     GIR_EraseRootFromParent_Done,
     /* 1625625 */   // Label 22388: @1625625
     /* 1625625 */   GIM_Try, /*On fail goto*//*Label 22389*/ GIMT_Encode4(1625711), // Rule ID 3937 //
     /* 1625630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1625641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1625644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1625647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1625653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1625660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625676 */     // MIs[0] policy
     /* 1625676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11599:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_MF2_MASK),
     /* 1625689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625710 */     // GIR_Coverage, 3937,
     /* 1625710 */     GIR_EraseRootFromParent_Done,
     /* 1625711 */   // Label 22389: @1625711
     /* 1625711 */   GIM_Try, /*On fail goto*//*Label 22390*/ GIMT_Encode4(1625797), // Rule ID 3940 //
     /* 1625716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625762 */     // MIs[0] policy
     /* 1625762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625772 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1625775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625796 */     // GIR_Coverage, 3940,
     /* 1625796 */     GIR_EraseRootFromParent_Done,
     /* 1625797 */   // Label 22390: @1625797
     /* 1625797 */   GIM_Try, /*On fail goto*//*Label 22391*/ GIMT_Encode4(1625883), // Rule ID 3941 //
     /* 1625802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1625813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1625816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1625819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1625825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1625828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1625832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1625840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625848 */     // MIs[0] policy
     /* 1625848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11599:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1625858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M1_MASK),
     /* 1625861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625882 */     // GIR_Coverage, 3941,
     /* 1625882 */     GIR_EraseRootFromParent_Done,
     /* 1625883 */   // Label 22391: @1625883
     /* 1625883 */   GIM_Try, /*On fail goto*//*Label 22392*/ GIMT_Encode4(1625969), // Rule ID 3944 //
     /* 1625888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1625891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1625908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1625914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1625918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1625922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1625926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1625930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1625934 */     // MIs[0] policy
     /* 1625934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1625937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1625944 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1625944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1625947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1625949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1625951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1625953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1625955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1625957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1625962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1625965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1625967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1625968 */     // GIR_Coverage, 3944,
     /* 1625968 */     GIR_EraseRootFromParent_Done,
     /* 1625969 */   // Label 22392: @1625969
     /* 1625969 */   GIM_Try, /*On fail goto*//*Label 22393*/ GIMT_Encode4(1626055), // Rule ID 3945 //
     /* 1625974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1625977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1625982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1625985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1625988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1625991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1625994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1625997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626020 */     // MIs[0] policy
     /* 1626020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626030 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11599:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M2_MASK),
     /* 1626033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626054 */     // GIR_Coverage, 3945,
     /* 1626054 */     GIR_EraseRootFromParent_Done,
     /* 1626055 */   // Label 22393: @1626055
     /* 1626055 */   GIM_Try, /*On fail goto*//*Label 22394*/ GIMT_Encode4(1626141), // Rule ID 3948 //
     /* 1626060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1626063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1626071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1626074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1626080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626106 */     // MIs[0] policy
     /* 1626106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626116 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1626119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626140 */     // GIR_Coverage, 3948,
     /* 1626140 */     GIR_EraseRootFromParent_Done,
     /* 1626141 */   // Label 22394: @1626141
     /* 1626141 */   GIM_Try, /*On fail goto*//*Label 22395*/ GIMT_Encode4(1626227), // Rule ID 3949 //
     /* 1626146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1626149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_mask),
     /* 1626154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1626157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1626160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1626163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1626166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1626188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626192 */     // MIs[0] policy
     /* 1626192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626202 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11599:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_VX_M4_MASK),
     /* 1626205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1626223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626226 */     // GIR_Coverage, 3949,
     /* 1626226 */     GIR_EraseRootFromParent_Done,
     /* 1626227 */   // Label 22395: @1626227
     /* 1626227 */   GIM_Try, /*On fail goto*//*Label 22396*/ GIMT_Encode4(1626313), // Rule ID 3958 //
     /* 1626232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1626243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1626246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1626252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626278 */     // MIs[0] policy
     /* 1626278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1626291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626312 */     // GIR_Coverage, 3958,
     /* 1626312 */     GIR_EraseRootFromParent_Done,
     /* 1626313 */   // Label 22396: @1626313
     /* 1626313 */   GIM_Try, /*On fail goto*//*Label 22397*/ GIMT_Encode4(1626399), // Rule ID 3959 //
     /* 1626318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1626329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1626332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1626335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1626338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1626341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626364 */     // MIs[0] policy
     /* 1626364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626374 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1626377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626398 */     // GIR_Coverage, 3959,
     /* 1626398 */     GIR_EraseRootFromParent_Done,
     /* 1626399 */   // Label 22397: @1626399
     /* 1626399 */   GIM_Try, /*On fail goto*//*Label 22398*/ GIMT_Encode4(1626485), // Rule ID 3968 //
     /* 1626404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1626415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1626418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1626424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626450 */     // MIs[0] policy
     /* 1626450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626460 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1626463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626484 */     // GIR_Coverage, 3968,
     /* 1626484 */     GIR_EraseRootFromParent_Done,
     /* 1626485 */   // Label 22398: @1626485
     /* 1626485 */   GIM_Try, /*On fail goto*//*Label 22399*/ GIMT_Encode4(1626571), // Rule ID 3969 //
     /* 1626490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1626501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1626504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1626507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1626510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1626513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1626520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626536 */     // MIs[0] policy
     /* 1626536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626546 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1626549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626570 */     // GIR_Coverage, 3969,
     /* 1626570 */     GIR_EraseRootFromParent_Done,
     /* 1626571 */   // Label 22399: @1626571
     /* 1626571 */   GIM_Try, /*On fail goto*//*Label 22400*/ GIMT_Encode4(1626657), // Rule ID 3978 //
     /* 1626576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1626596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626622 */     // MIs[0] policy
     /* 1626622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626632 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1626635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626656 */     // GIR_Coverage, 3978,
     /* 1626656 */     GIR_EraseRootFromParent_Done,
     /* 1626657 */   // Label 22400: @1626657
     /* 1626657 */   GIM_Try, /*On fail goto*//*Label 22401*/ GIMT_Encode4(1626743), // Rule ID 3979 //
     /* 1626662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1626673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1626676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1626679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1626682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1626685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1626692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1626704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626708 */     // MIs[0] policy
     /* 1626708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1626721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626742 */     // GIR_Coverage, 3979,
     /* 1626742 */     GIR_EraseRootFromParent_Done,
     /* 1626743 */   // Label 22401: @1626743
     /* 1626743 */   GIM_Try, /*On fail goto*//*Label 22402*/ GIMT_Encode4(1626829), // Rule ID 3988 //
     /* 1626748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1626768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626794 */     // MIs[0] policy
     /* 1626794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1626807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626828 */     // GIR_Coverage, 3988,
     /* 1626828 */     GIR_EraseRootFromParent_Done,
     /* 1626829 */   // Label 22402: @1626829
     /* 1626829 */   GIM_Try, /*On fail goto*//*Label 22403*/ GIMT_Encode4(1626915), // Rule ID 3989 //
     /* 1626834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1626837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1626845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1626848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1626851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1626854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1626857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1626860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1626864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1626876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626880 */     // MIs[0] policy
     /* 1626880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626890 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1626890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1626893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1626914 */     // GIR_Coverage, 3989,
     /* 1626914 */     GIR_EraseRootFromParent_Done,
     /* 1626915 */   // Label 22403: @1626915
     /* 1626915 */   GIM_Try, /*On fail goto*//*Label 22404*/ GIMT_Encode4(1627001), // Rule ID 3998 //
     /* 1626920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1626923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1626928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1626931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1626934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1626937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1626940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1626943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1626946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1626950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1626958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1626962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1626966 */     // MIs[0] policy
     /* 1626966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1626969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1626976 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1626976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1626979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1626981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1626983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1626985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1626987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1626989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1626994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1626997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1626999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627000 */     // GIR_Coverage, 3998,
     /* 1627000 */     GIR_EraseRootFromParent_Done,
     /* 1627001 */   // Label 22404: @1627001
     /* 1627001 */   GIM_Try, /*On fail goto*//*Label 22405*/ GIMT_Encode4(1627087), // Rule ID 3999 //
     /* 1627006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1627017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1627020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1627023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1627026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1627029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627052 */     // MIs[0] policy
     /* 1627052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627062 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1627065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1627083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627086 */     // GIR_Coverage, 3999,
     /* 1627086 */     GIR_EraseRootFromParent_Done,
     /* 1627087 */   // Label 22405: @1627087
     /* 1627087 */   GIM_Try, /*On fail goto*//*Label 22406*/ GIMT_Encode4(1627173), // Rule ID 4008 //
     /* 1627092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1627103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1627106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1627112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627138 */     // MIs[0] policy
     /* 1627138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1627151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627172 */     // GIR_Coverage, 4008,
     /* 1627172 */     GIR_EraseRootFromParent_Done,
     /* 1627173 */   // Label 22406: @1627173
     /* 1627173 */   GIM_Try, /*On fail goto*//*Label 22407*/ GIMT_Encode4(1627259), // Rule ID 4009 //
     /* 1627178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1627189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1627192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1627195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1627198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627224 */     // MIs[0] policy
     /* 1627224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627234 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF4_MASK),
     /* 1627237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627258 */     // GIR_Coverage, 4009,
     /* 1627258 */     GIR_EraseRootFromParent_Done,
     /* 1627259 */   // Label 22407: @1627259
     /* 1627259 */   GIM_Try, /*On fail goto*//*Label 22408*/ GIMT_Encode4(1627345), // Rule ID 4018 //
     /* 1627264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1627275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1627278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1627284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627310 */     // MIs[0] policy
     /* 1627310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627320 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1627323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627344 */     // GIR_Coverage, 4018,
     /* 1627344 */     GIR_EraseRootFromParent_Done,
     /* 1627345 */   // Label 22408: @1627345
     /* 1627345 */   GIM_Try, /*On fail goto*//*Label 22409*/ GIMT_Encode4(1627431), // Rule ID 4019 //
     /* 1627350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1627361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1627364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1627367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1627370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1627373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627396 */     // MIs[0] policy
     /* 1627396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627406 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1627409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627430 */     // GIR_Coverage, 4019,
     /* 1627430 */     GIR_EraseRootFromParent_Done,
     /* 1627431 */   // Label 22409: @1627431
     /* 1627431 */   GIM_Try, /*On fail goto*//*Label 22410*/ GIMT_Encode4(1627517), // Rule ID 4028 //
     /* 1627436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1627456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627482 */     // MIs[0] policy
     /* 1627482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1627495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627516 */     // GIR_Coverage, 4028,
     /* 1627516 */     GIR_EraseRootFromParent_Done,
     /* 1627517 */   // Label 22410: @1627517
     /* 1627517 */   GIM_Try, /*On fail goto*//*Label 22411*/ GIMT_Encode4(1627603), // Rule ID 4029 //
     /* 1627522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1627533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1627536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1627539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1627542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1627545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1627552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627568 */     // MIs[0] policy
     /* 1627568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627578 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1627581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627602 */     // GIR_Coverage, 4029,
     /* 1627602 */     GIR_EraseRootFromParent_Done,
     /* 1627603 */   // Label 22411: @1627603
     /* 1627603 */   GIM_Try, /*On fail goto*//*Label 22412*/ GIMT_Encode4(1627689), // Rule ID 4038 //
     /* 1627608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1627628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627654 */     // MIs[0] policy
     /* 1627654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627664 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1627667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627688 */     // GIR_Coverage, 4038,
     /* 1627688 */     GIR_EraseRootFromParent_Done,
     /* 1627689 */   // Label 22412: @1627689
     /* 1627689 */   GIM_Try, /*On fail goto*//*Label 22413*/ GIMT_Encode4(1627775), // Rule ID 4039 //
     /* 1627694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1627705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1627708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1627711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1627714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1627717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1627724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1627736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627740 */     // MIs[0] policy
     /* 1627740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627750 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1627753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627774 */     // GIR_Coverage, 4039,
     /* 1627774 */     GIR_EraseRootFromParent_Done,
     /* 1627775 */   // Label 22413: @1627775
     /* 1627775 */   GIM_Try, /*On fail goto*//*Label 22414*/ GIMT_Encode4(1627861), // Rule ID 4048 //
     /* 1627780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1627783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1627797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1627800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627826 */     // MIs[0] policy
     /* 1627826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627836 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1627836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1627839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627860 */     // GIR_Coverage, 4048,
     /* 1627860 */     GIR_EraseRootFromParent_Done,
     /* 1627861 */   // Label 22414: @1627861
     /* 1627861 */   GIM_Try, /*On fail goto*//*Label 22415*/ GIMT_Encode4(1627947), // Rule ID 4049 //
     /* 1627866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1627869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1627877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1627880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1627883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1627886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1627889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1627892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1627896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1627904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1627908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627912 */     // MIs[0] policy
     /* 1627912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1627915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1627922 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1627922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1627925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1627927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1627929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1627931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1627933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1627935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1627940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1627943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1627945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1627946 */     // GIR_Coverage, 4049,
     /* 1627946 */     GIR_EraseRootFromParent_Done,
     /* 1627947 */   // Label 22415: @1627947
     /* 1627947 */   GIM_Try, /*On fail goto*//*Label 22416*/ GIMT_Encode4(1628033), // Rule ID 4058 //
     /* 1627952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1627955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1627960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1627963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1627966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1627969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1627972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1627975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1627978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1627982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1627994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1627998 */     // MIs[0] policy
     /* 1627998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1628011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628032 */     // GIR_Coverage, 4058,
     /* 1628032 */     GIR_EraseRootFromParent_Done,
     /* 1628033 */   // Label 22416: @1628033
     /* 1628033 */   GIM_Try, /*On fail goto*//*Label 22417*/ GIMT_Encode4(1628119), // Rule ID 4059 //
     /* 1628038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1628049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1628052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1628055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1628058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628084 */     // MIs[0] policy
     /* 1628084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_MF2_MASK),
     /* 1628097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628118 */     // GIR_Coverage, 4059,
     /* 1628118 */     GIR_EraseRootFromParent_Done,
     /* 1628119 */   // Label 22417: @1628119
     /* 1628119 */   GIM_Try, /*On fail goto*//*Label 22418*/ GIMT_Encode4(1628205), // Rule ID 4068 //
     /* 1628124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1628135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1628138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1628141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1628144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628170 */     // MIs[0] policy
     /* 1628170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1628183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628204 */     // GIR_Coverage, 4068,
     /* 1628204 */     GIR_EraseRootFromParent_Done,
     /* 1628205 */   // Label 22418: @1628205
     /* 1628205 */   GIM_Try, /*On fail goto*//*Label 22419*/ GIMT_Encode4(1628291), // Rule ID 4069 //
     /* 1628210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1628221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1628224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1628227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1628230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1628240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628256 */     // MIs[0] policy
     /* 1628256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628266 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M1_MASK),
     /* 1628269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628290 */     // GIR_Coverage, 4069,
     /* 1628290 */     GIR_EraseRootFromParent_Done,
     /* 1628291 */   // Label 22419: @1628291
     /* 1628291 */   GIM_Try, /*On fail goto*//*Label 22420*/ GIMT_Encode4(1628377), // Rule ID 4078 //
     /* 1628296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1628307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1628310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1628313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1628316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628342 */     // MIs[0] policy
     /* 1628342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628352 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1628355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628376 */     // GIR_Coverage, 4078,
     /* 1628376 */     GIR_EraseRootFromParent_Done,
     /* 1628377 */   // Label 22420: @1628377
     /* 1628377 */   GIM_Try, /*On fail goto*//*Label 22421*/ GIMT_Encode4(1628463), // Rule ID 4079 //
     /* 1628382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1628393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1628396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1628399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1628402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1628405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1628412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1628424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628428 */     // MIs[0] policy
     /* 1628428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M2_MASK),
     /* 1628441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628462 */     // GIR_Coverage, 4079,
     /* 1628462 */     GIR_EraseRootFromParent_Done,
     /* 1628463 */   // Label 22421: @1628463
     /* 1628463 */   GIM_Try, /*On fail goto*//*Label 22422*/ GIMT_Encode4(1628549), // Rule ID 4088 //
     /* 1628468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1628471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1628485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1628488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628514 */     // MIs[0] policy
     /* 1628514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628524 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1628527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628548 */     // GIR_Coverage, 4088,
     /* 1628548 */     GIR_EraseRootFromParent_Done,
     /* 1628549 */   // Label 22422: @1628549
     /* 1628549 */   GIM_Try, /*On fail goto*//*Label 22423*/ GIMT_Encode4(1628635), // Rule ID 4089 //
     /* 1628554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1628557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1628565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1628568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1628571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1628574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1628577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1628584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1628592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1628596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628600 */     // MIs[0] policy
     /* 1628600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628610 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WV_M4_MASK),
     /* 1628613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1628631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628634 */     // GIR_Coverage, 4089,
     /* 1628634 */     GIR_EraseRootFromParent_Done,
     /* 1628635 */   // Label 22423: @1628635
     /* 1628635 */   GIM_Try, /*On fail goto*//*Label 22424*/ GIMT_Encode4(1628721), // Rule ID 4092 //
     /* 1628640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628686 */     // MIs[0] policy
     /* 1628686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628696 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1628699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628720 */     // GIR_Coverage, 4092,
     /* 1628720 */     GIR_EraseRootFromParent_Done,
     /* 1628721 */   // Label 22424: @1628721
     /* 1628721 */   GIM_Try, /*On fail goto*//*Label 22425*/ GIMT_Encode4(1628807), // Rule ID 4093 //
     /* 1628726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1628737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1628740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1628743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1628749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628772 */     // MIs[0] policy
     /* 1628772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628782 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF8_MASK),
     /* 1628785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628806 */     // GIR_Coverage, 4093,
     /* 1628806 */     GIR_EraseRootFromParent_Done,
     /* 1628807 */   // Label 22425: @1628807
     /* 1628807 */   GIM_Try, /*On fail goto*//*Label 22426*/ GIMT_Encode4(1628893), // Rule ID 4096 //
     /* 1628812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1628832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1628838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628858 */     // MIs[0] policy
     /* 1628858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1628868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1628871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628892 */     // GIR_Coverage, 4096,
     /* 1628892 */     GIR_EraseRootFromParent_Done,
     /* 1628893 */   // Label 22426: @1628893
     /* 1628893 */   GIM_Try, /*On fail goto*//*Label 22427*/ GIMT_Encode4(1628979), // Rule ID 4097 //
     /* 1628898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1628901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1628909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1628912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1628915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1628918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1628921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1628924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1628928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1628936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1628940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1628944 */     // MIs[0] policy
     /* 1628944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1628947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1628954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1628954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1628957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1628959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1628961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1628963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1628965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1628967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1628972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1628975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1628977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1628978 */     // GIR_Coverage, 4097,
     /* 1628978 */     GIR_EraseRootFromParent_Done,
     /* 1628979 */   // Label 22427: @1628979
     /* 1628979 */   GIM_Try, /*On fail goto*//*Label 22428*/ GIMT_Encode4(1629065), // Rule ID 4100 //
     /* 1628984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1628987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1628992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1628995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1628998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629030 */     // MIs[0] policy
     /* 1629030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1629043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629064 */     // GIR_Coverage, 4100,
     /* 1629064 */     GIR_EraseRootFromParent_Done,
     /* 1629065 */   // Label 22428: @1629065
     /* 1629065 */   GIM_Try, /*On fail goto*//*Label 22429*/ GIMT_Encode4(1629151), // Rule ID 4101 //
     /* 1629070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1629081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1629084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1629087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1629093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629116 */     // MIs[0] policy
     /* 1629116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11577:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1629129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629150 */     // GIR_Coverage, 4101,
     /* 1629150 */     GIR_EraseRootFromParent_Done,
     /* 1629151 */   // Label 22429: @1629151
     /* 1629151 */   GIM_Try, /*On fail goto*//*Label 22430*/ GIMT_Encode4(1629237), // Rule ID 4104 //
     /* 1629156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629202 */     // MIs[0] policy
     /* 1629202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1629215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629236 */     // GIR_Coverage, 4104,
     /* 1629236 */     GIR_EraseRootFromParent_Done,
     /* 1629237 */   // Label 22430: @1629237
     /* 1629237 */   GIM_Try, /*On fail goto*//*Label 22431*/ GIMT_Encode4(1629323), // Rule ID 4105 //
     /* 1629242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1629253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1629256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1629259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1629265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1629272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1629280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629288 */     // MIs[0] policy
     /* 1629288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1629301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629322 */     // GIR_Coverage, 4105,
     /* 1629322 */     GIR_EraseRootFromParent_Done,
     /* 1629323 */   // Label 22431: @1629323
     /* 1629323 */   GIM_Try, /*On fail goto*//*Label 22432*/ GIMT_Encode4(1629409), // Rule ID 4108 //
     /* 1629328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629374 */     // MIs[0] policy
     /* 1629374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629384 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1629387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629408 */     // GIR_Coverage, 4108,
     /* 1629408 */     GIR_EraseRootFromParent_Done,
     /* 1629409 */   // Label 22432: @1629409
     /* 1629409 */   GIM_Try, /*On fail goto*//*Label 22433*/ GIMT_Encode4(1629495), // Rule ID 4109 //
     /* 1629414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1629425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1629428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1629431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1629437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1629444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1629452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629460 */     // MIs[0] policy
     /* 1629460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629470 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1629473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629494 */     // GIR_Coverage, 4109,
     /* 1629494 */     GIR_EraseRootFromParent_Done,
     /* 1629495 */   // Label 22433: @1629495
     /* 1629495 */   GIM_Try, /*On fail goto*//*Label 22434*/ GIMT_Encode4(1629581), // Rule ID 4112 //
     /* 1629500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1629517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629546 */     // MIs[0] policy
     /* 1629546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629556 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1629559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629580 */     // GIR_Coverage, 4112,
     /* 1629580 */     GIR_EraseRootFromParent_Done,
     /* 1629581 */   // Label 22434: @1629581
     /* 1629581 */   GIM_Try, /*On fail goto*//*Label 22435*/ GIMT_Encode4(1629667), // Rule ID 4113 //
     /* 1629586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1629597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1629600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1629603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1629609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1629616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1629624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629632 */     // MIs[0] policy
     /* 1629632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629642 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1629645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1629663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629666 */     // GIR_Coverage, 4113,
     /* 1629666 */     GIR_EraseRootFromParent_Done,
     /* 1629667 */   // Label 22435: @1629667
     /* 1629667 */   GIM_Try, /*On fail goto*//*Label 22436*/ GIMT_Encode4(1629753), // Rule ID 4116 //
     /* 1629672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629718 */     // MIs[0] policy
     /* 1629718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629728 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1629731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629752 */     // GIR_Coverage, 4116,
     /* 1629752 */     GIR_EraseRootFromParent_Done,
     /* 1629753 */   // Label 22436: @1629753
     /* 1629753 */   GIM_Try, /*On fail goto*//*Label 22437*/ GIMT_Encode4(1629839), // Rule ID 4117 //
     /* 1629758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1629769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1629772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1629775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1629781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629804 */     // MIs[0] policy
     /* 1629804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629814 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF4_MASK),
     /* 1629817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629838 */     // GIR_Coverage, 4117,
     /* 1629838 */     GIR_EraseRootFromParent_Done,
     /* 1629839 */   // Label 22437: @1629839
     /* 1629839 */   GIM_Try, /*On fail goto*//*Label 22438*/ GIMT_Encode4(1629925), // Rule ID 4120 //
     /* 1629844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1629847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1629864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1629870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629890 */     // MIs[0] policy
     /* 1629890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1629900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1629903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1629918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1629921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1629923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1629924 */     // GIR_Coverage, 4120,
     /* 1629924 */     GIR_EraseRootFromParent_Done,
     /* 1629925 */   // Label 22438: @1629925
     /* 1629925 */   GIM_Try, /*On fail goto*//*Label 22439*/ GIMT_Encode4(1630011), // Rule ID 4121 //
     /* 1629930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1629933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1629938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1629941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1629944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1629947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1629950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1629953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1629956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1629960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1629968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1629972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1629976 */     // MIs[0] policy
     /* 1629976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1629979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1629986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11577:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1629986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1629989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1629991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1629993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1629995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1629997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1629999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630010 */     // GIR_Coverage, 4121,
     /* 1630010 */     GIR_EraseRootFromParent_Done,
     /* 1630011 */   // Label 22439: @1630011
     /* 1630011 */   GIM_Try, /*On fail goto*//*Label 22440*/ GIMT_Encode4(1630097), // Rule ID 4124 //
     /* 1630016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630062 */     // MIs[0] policy
     /* 1630062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1630075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630096 */     // GIR_Coverage, 4124,
     /* 1630096 */     GIR_EraseRootFromParent_Done,
     /* 1630097 */   // Label 22440: @1630097
     /* 1630097 */   GIM_Try, /*On fail goto*//*Label 22441*/ GIMT_Encode4(1630183), // Rule ID 4125 //
     /* 1630102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1630113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1630116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1630119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630148 */     // MIs[0] policy
     /* 1630148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630158 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1630161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630182 */     // GIR_Coverage, 4125,
     /* 1630182 */     GIR_EraseRootFromParent_Done,
     /* 1630183 */   // Label 22441: @1630183
     /* 1630183 */   GIM_Try, /*On fail goto*//*Label 22442*/ GIMT_Encode4(1630269), // Rule ID 4128 //
     /* 1630188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630234 */     // MIs[0] policy
     /* 1630234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630244 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1630247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630268 */     // GIR_Coverage, 4128,
     /* 1630268 */     GIR_EraseRootFromParent_Done,
     /* 1630269 */   // Label 22442: @1630269
     /* 1630269 */   GIM_Try, /*On fail goto*//*Label 22443*/ GIMT_Encode4(1630355), // Rule ID 4129 //
     /* 1630274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1630285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1630288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1630291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1630297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630320 */     // MIs[0] policy
     /* 1630320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630330 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1630333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630354 */     // GIR_Coverage, 4129,
     /* 1630354 */     GIR_EraseRootFromParent_Done,
     /* 1630355 */   // Label 22443: @1630355
     /* 1630355 */   GIM_Try, /*On fail goto*//*Label 22444*/ GIMT_Encode4(1630441), // Rule ID 4132 //
     /* 1630360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1630363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1630377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630406 */     // MIs[0] policy
     /* 1630406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1630419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630440 */     // GIR_Coverage, 4132,
     /* 1630440 */     GIR_EraseRootFromParent_Done,
     /* 1630441 */   // Label 22444: @1630441
     /* 1630441 */   GIM_Try, /*On fail goto*//*Label 22445*/ GIMT_Encode4(1630527), // Rule ID 4133 //
     /* 1630446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1630449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1630457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1630460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1630463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1630469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1630476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1630484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630492 */     // MIs[0] policy
     /* 1630492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630502 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1630505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1630523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630526 */     // GIR_Coverage, 4133,
     /* 1630526 */     GIR_EraseRootFromParent_Done,
     /* 1630527 */   // Label 22445: @1630527
     /* 1630527 */   GIM_Try, /*On fail goto*//*Label 22446*/ GIMT_Encode4(1630613), // Rule ID 4136 //
     /* 1630532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1630549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630578 */     // MIs[0] policy
     /* 1630578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1630591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630612 */     // GIR_Coverage, 4136,
     /* 1630612 */     GIR_EraseRootFromParent_Done,
     /* 1630613 */   // Label 22446: @1630613
     /* 1630613 */   GIM_Try, /*On fail goto*//*Label 22447*/ GIMT_Encode4(1630699), // Rule ID 4137 //
     /* 1630618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1630629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1630632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1630635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1630641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1630648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1630656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630664 */     // MIs[0] policy
     /* 1630664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11577:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_MF2_MASK),
     /* 1630677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630698 */     // GIR_Coverage, 4137,
     /* 1630698 */     GIR_EraseRootFromParent_Done,
     /* 1630699 */   // Label 22447: @1630699
     /* 1630699 */   GIM_Try, /*On fail goto*//*Label 22448*/ GIMT_Encode4(1630785), // Rule ID 4140 //
     /* 1630704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1630721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630750 */     // MIs[0] policy
     /* 1630750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1630763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630784 */     // GIR_Coverage, 4140,
     /* 1630784 */     GIR_EraseRootFromParent_Done,
     /* 1630785 */   // Label 22448: @1630785
     /* 1630785 */   GIM_Try, /*On fail goto*//*Label 22449*/ GIMT_Encode4(1630871), // Rule ID 4141 //
     /* 1630790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1630801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1630804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1630807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1630813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1630820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1630828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630836 */     // MIs[0] policy
     /* 1630836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11577:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1630846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M1_MASK),
     /* 1630849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630870 */     // GIR_Coverage, 4141,
     /* 1630870 */     GIR_EraseRootFromParent_Done,
     /* 1630871 */   // Label 22449: @1630871
     /* 1630871 */   GIM_Try, /*On fail goto*//*Label 22450*/ GIMT_Encode4(1630957), // Rule ID 4144 //
     /* 1630876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1630879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1630893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1630896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1630902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1630918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1630922 */     // MIs[0] policy
     /* 1630922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1630925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1630932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1630932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1630935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1630937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1630939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1630941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1630943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1630945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1630950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1630953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1630955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1630956 */     // GIR_Coverage, 4144,
     /* 1630956 */     GIR_EraseRootFromParent_Done,
     /* 1630957 */   // Label 22450: @1630957
     /* 1630957 */   GIM_Try, /*On fail goto*//*Label 22451*/ GIMT_Encode4(1631043), // Rule ID 4145 //
     /* 1630962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1630965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1630970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1630973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1630976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1630979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1630982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1630985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1630988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1630992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1630996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631008 */     // MIs[0] policy
     /* 1631008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11577:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M2_MASK),
     /* 1631021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631042 */     // GIR_Coverage, 4145,
     /* 1631042 */     GIR_EraseRootFromParent_Done,
     /* 1631043 */   // Label 22451: @1631043
     /* 1631043 */   GIM_Try, /*On fail goto*//*Label 22452*/ GIMT_Encode4(1631129), // Rule ID 4148 //
     /* 1631048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1631051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1631065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1631068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631094 */     // MIs[0] policy
     /* 1631094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1631107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631128 */     // GIR_Coverage, 4148,
     /* 1631128 */     GIR_EraseRootFromParent_Done,
     /* 1631129 */   // Label 22452: @1631129
     /* 1631129 */   GIM_Try, /*On fail goto*//*Label 22453*/ GIMT_Encode4(1631215), // Rule ID 4149 //
     /* 1631134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1631137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwaddu_w_mask),
     /* 1631142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1631145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1631148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1631151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1631154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1631164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1631172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1631176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631180 */     // MIs[0] policy
     /* 1631180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11577:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADDU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADDU_WX_M4_MASK),
     /* 1631193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1631211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631214 */     // GIR_Coverage, 4149,
     /* 1631214 */     GIR_EraseRootFromParent_Done,
     /* 1631215 */   // Label 22453: @1631215
     /* 1631215 */   GIM_Try, /*On fail goto*//*Label 22454*/ GIMT_Encode4(1631301), // Rule ID 4158 //
     /* 1631220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631266 */     // MIs[0] policy
     /* 1631266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631276 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1631279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631300 */     // GIR_Coverage, 4158,
     /* 1631300 */     GIR_EraseRootFromParent_Done,
     /* 1631301 */   // Label 22454: @1631301
     /* 1631301 */   GIM_Try, /*On fail goto*//*Label 22455*/ GIMT_Encode4(1631387), // Rule ID 4159 //
     /* 1631306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1631317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1631320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1631323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1631326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1631329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631352 */     // MIs[0] policy
     /* 1631352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631362 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF8_MASK),
     /* 1631365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631386 */     // GIR_Coverage, 4159,
     /* 1631386 */     GIR_EraseRootFromParent_Done,
     /* 1631387 */   // Label 22455: @1631387
     /* 1631387 */   GIM_Try, /*On fail goto*//*Label 22456*/ GIMT_Encode4(1631473), // Rule ID 4168 //
     /* 1631392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1631403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1631406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631438 */     // MIs[0] policy
     /* 1631438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631448 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1631451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631472 */     // GIR_Coverage, 4168,
     /* 1631472 */     GIR_EraseRootFromParent_Done,
     /* 1631473 */   // Label 22456: @1631473
     /* 1631473 */   GIM_Try, /*On fail goto*//*Label 22457*/ GIMT_Encode4(1631559), // Rule ID 4169 //
     /* 1631478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1631489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1631492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1631495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1631498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1631501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631524 */     // MIs[0] policy
     /* 1631524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631534 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1631537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631558 */     // GIR_Coverage, 4169,
     /* 1631558 */     GIR_EraseRootFromParent_Done,
     /* 1631559 */   // Label 22457: @1631559
     /* 1631559 */   GIM_Try, /*On fail goto*//*Label 22458*/ GIMT_Encode4(1631645), // Rule ID 4178 //
     /* 1631564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631610 */     // MIs[0] policy
     /* 1631610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631620 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1631623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631644 */     // GIR_Coverage, 4178,
     /* 1631644 */     GIR_EraseRootFromParent_Done,
     /* 1631645 */   // Label 22458: @1631645
     /* 1631645 */   GIM_Try, /*On fail goto*//*Label 22459*/ GIMT_Encode4(1631731), // Rule ID 4179 //
     /* 1631650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1631661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1631664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1631667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1631670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1631673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1631680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631696 */     // MIs[0] policy
     /* 1631696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1631709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631730 */     // GIR_Coverage, 4179,
     /* 1631730 */     GIR_EraseRootFromParent_Done,
     /* 1631731 */   // Label 22459: @1631731
     /* 1631731 */   GIM_Try, /*On fail goto*//*Label 22460*/ GIMT_Encode4(1631817), // Rule ID 4188 //
     /* 1631736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1631756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631782 */     // MIs[0] policy
     /* 1631782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1631795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631816 */     // GIR_Coverage, 4188,
     /* 1631816 */     GIR_EraseRootFromParent_Done,
     /* 1631817 */   // Label 22460: @1631817
     /* 1631817 */   GIM_Try, /*On fail goto*//*Label 22461*/ GIMT_Encode4(1631903), // Rule ID 4189 //
     /* 1631822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1631833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1631836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1631839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1631842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1631845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1631848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1631852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1631864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631868 */     // MIs[0] policy
     /* 1631868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631878 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1631878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1631881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631902 */     // GIR_Coverage, 4189,
     /* 1631902 */     GIR_EraseRootFromParent_Done,
     /* 1631903 */   // Label 22461: @1631903
     /* 1631903 */   GIM_Try, /*On fail goto*//*Label 22462*/ GIMT_Encode4(1631989), // Rule ID 4198 //
     /* 1631908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1631911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1631916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1631919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1631922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1631925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1631928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1631931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1631934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1631938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1631946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1631950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1631954 */     // MIs[0] policy
     /* 1631954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1631957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1631964 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1631964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1631967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1631969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1631971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1631973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1631975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1631977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1631982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1631985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1631987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1631988 */     // GIR_Coverage, 4198,
     /* 1631988 */     GIR_EraseRootFromParent_Done,
     /* 1631989 */   // Label 22462: @1631989
     /* 1631989 */   GIM_Try, /*On fail goto*//*Label 22463*/ GIMT_Encode4(1632075), // Rule ID 4199 //
     /* 1631994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1631997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1632005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1632008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1632011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1632014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632040 */     // MIs[0] policy
     /* 1632040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632050 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1632053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632074 */     // GIR_Coverage, 4199,
     /* 1632074 */     GIR_EraseRootFromParent_Done,
     /* 1632075 */   // Label 22463: @1632075
     /* 1632075 */   GIM_Try, /*On fail goto*//*Label 22464*/ GIMT_Encode4(1632161), // Rule ID 4208 //
     /* 1632080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1632091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1632094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1632097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1632100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1632103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632126 */     // MIs[0] policy
     /* 1632126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632136 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1632139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632160 */     // GIR_Coverage, 4208,
     /* 1632160 */     GIR_EraseRootFromParent_Done,
     /* 1632161 */   // Label 22464: @1632161
     /* 1632161 */   GIM_Try, /*On fail goto*//*Label 22465*/ GIMT_Encode4(1632247), // Rule ID 4209 //
     /* 1632166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1632177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1632180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1632183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1632186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1632189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632212 */     // MIs[0] policy
     /* 1632212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632222 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1632225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1632243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632246 */     // GIR_Coverage, 4209,
     /* 1632246 */     GIR_EraseRootFromParent_Done,
     /* 1632247 */   // Label 22465: @1632247
     /* 1632247 */   GIM_Try, /*On fail goto*//*Label 22466*/ GIMT_Encode4(1632333), // Rule ID 4218 //
     /* 1632252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1632272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632298 */     // MIs[0] policy
     /* 1632298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632308 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1632311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632332 */     // GIR_Coverage, 4218,
     /* 1632332 */     GIR_EraseRootFromParent_Done,
     /* 1632333 */   // Label 22466: @1632333
     /* 1632333 */   GIM_Try, /*On fail goto*//*Label 22467*/ GIMT_Encode4(1632419), // Rule ID 4219 //
     /* 1632338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1632349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1632352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1632355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1632358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1632361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632384 */     // MIs[0] policy
     /* 1632384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632394 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF4_MASK),
     /* 1632397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632418 */     // GIR_Coverage, 4219,
     /* 1632418 */     GIR_EraseRootFromParent_Done,
     /* 1632419 */   // Label 22467: @1632419
     /* 1632419 */   GIM_Try, /*On fail goto*//*Label 22468*/ GIMT_Encode4(1632505), // Rule ID 4228 //
     /* 1632424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1632444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632470 */     // MIs[0] policy
     /* 1632470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632480 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1632483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632504 */     // GIR_Coverage, 4228,
     /* 1632504 */     GIR_EraseRootFromParent_Done,
     /* 1632505 */   // Label 22468: @1632505
     /* 1632505 */   GIM_Try, /*On fail goto*//*Label 22469*/ GIMT_Encode4(1632591), // Rule ID 4229 //
     /* 1632510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1632521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1632524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1632527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1632530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1632533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1632540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632556 */     // MIs[0] policy
     /* 1632556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632566 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1632569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632590 */     // GIR_Coverage, 4229,
     /* 1632590 */     GIR_EraseRootFromParent_Done,
     /* 1632591 */   // Label 22469: @1632591
     /* 1632591 */   GIM_Try, /*On fail goto*//*Label 22470*/ GIMT_Encode4(1632677), // Rule ID 4238 //
     /* 1632596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632642 */     // MIs[0] policy
     /* 1632642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632652 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1632655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632676 */     // GIR_Coverage, 4238,
     /* 1632676 */     GIR_EraseRootFromParent_Done,
     /* 1632677 */   // Label 22470: @1632677
     /* 1632677 */   GIM_Try, /*On fail goto*//*Label 22471*/ GIMT_Encode4(1632763), // Rule ID 4239 //
     /* 1632682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1632693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1632696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1632699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1632702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1632705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1632712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1632724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632728 */     // MIs[0] policy
     /* 1632728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632738 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1632741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632762 */     // GIR_Coverage, 4239,
     /* 1632762 */     GIR_EraseRootFromParent_Done,
     /* 1632763 */   // Label 22471: @1632763
     /* 1632763 */   GIM_Try, /*On fail goto*//*Label 22472*/ GIMT_Encode4(1632849), // Rule ID 4248 //
     /* 1632768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1632788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632814 */     // MIs[0] policy
     /* 1632814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632824 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1632827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632848 */     // GIR_Coverage, 4248,
     /* 1632848 */     GIR_EraseRootFromParent_Done,
     /* 1632849 */   // Label 22472: @1632849
     /* 1632849 */   GIM_Try, /*On fail goto*//*Label 22473*/ GIMT_Encode4(1632935), // Rule ID 4249 //
     /* 1632854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1632857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1632865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1632868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1632871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1632874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1632877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1632880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1632884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1632896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632900 */     // MIs[0] policy
     /* 1632900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632910 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1632910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1632913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1632915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1632917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1632919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1632921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1632923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1632928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1632931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1632933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1632934 */     // GIR_Coverage, 4249,
     /* 1632934 */     GIR_EraseRootFromParent_Done,
     /* 1632935 */   // Label 22473: @1632935
     /* 1632935 */   GIM_Try, /*On fail goto*//*Label 22474*/ GIMT_Encode4(1633021), // Rule ID 4258 //
     /* 1632940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1632943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1632948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1632951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1632954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1632957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1632960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1632963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1632966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1632970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1632978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1632982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1632986 */     // MIs[0] policy
     /* 1632986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1632989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1632996 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1632996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1632999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633020 */     // GIR_Coverage, 4258,
     /* 1633020 */     GIR_EraseRootFromParent_Done,
     /* 1633021 */   // Label 22474: @1633021
     /* 1633021 */   GIM_Try, /*On fail goto*//*Label 22475*/ GIMT_Encode4(1633107), // Rule ID 4259 //
     /* 1633026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1633037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1633040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1633043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1633046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1633049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633072 */     // MIs[0] policy
     /* 1633072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633082 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1633085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1633103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633106 */     // GIR_Coverage, 4259,
     /* 1633106 */     GIR_EraseRootFromParent_Done,
     /* 1633107 */   // Label 22475: @1633107
     /* 1633107 */   GIM_Try, /*On fail goto*//*Label 22476*/ GIMT_Encode4(1633193), // Rule ID 4268 //
     /* 1633112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1633123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1633126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1633129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1633132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633158 */     // MIs[0] policy
     /* 1633158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1633171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633192 */     // GIR_Coverage, 4268,
     /* 1633192 */     GIR_EraseRootFromParent_Done,
     /* 1633193 */   // Label 22476: @1633193
     /* 1633193 */   GIM_Try, /*On fail goto*//*Label 22477*/ GIMT_Encode4(1633279), // Rule ID 4269 //
     /* 1633198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1633209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1633212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1633215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1633218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633244 */     // MIs[0] policy
     /* 1633244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_MF2_MASK),
     /* 1633257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633278 */     // GIR_Coverage, 4269,
     /* 1633278 */     GIR_EraseRootFromParent_Done,
     /* 1633279 */   // Label 22477: @1633279
     /* 1633279 */   GIM_Try, /*On fail goto*//*Label 22478*/ GIMT_Encode4(1633365), // Rule ID 4278 //
     /* 1633284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1633295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1633298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1633301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1633304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633330 */     // MIs[0] policy
     /* 1633330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1633343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633364 */     // GIR_Coverage, 4278,
     /* 1633364 */     GIR_EraseRootFromParent_Done,
     /* 1633365 */   // Label 22478: @1633365
     /* 1633365 */   GIM_Try, /*On fail goto*//*Label 22479*/ GIMT_Encode4(1633451), // Rule ID 4279 //
     /* 1633370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1633381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1633384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1633387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1633390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1633400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633416 */     // MIs[0] policy
     /* 1633416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M1_MASK),
     /* 1633429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633450 */     // GIR_Coverage, 4279,
     /* 1633450 */     GIR_EraseRootFromParent_Done,
     /* 1633451 */   // Label 22479: @1633451
     /* 1633451 */   GIM_Try, /*On fail goto*//*Label 22480*/ GIMT_Encode4(1633537), // Rule ID 4288 //
     /* 1633456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1633473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1633476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633502 */     // MIs[0] policy
     /* 1633502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633512 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1633515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633536 */     // GIR_Coverage, 4288,
     /* 1633536 */     GIR_EraseRootFromParent_Done,
     /* 1633537 */   // Label 22480: @1633537
     /* 1633537 */   GIM_Try, /*On fail goto*//*Label 22481*/ GIMT_Encode4(1633623), // Rule ID 4289 //
     /* 1633542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1633553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1633556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1633559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1633562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1633565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1633572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1633584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633588 */     // MIs[0] policy
     /* 1633588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633598 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M2_MASK),
     /* 1633601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633622 */     // GIR_Coverage, 4289,
     /* 1633622 */     GIR_EraseRootFromParent_Done,
     /* 1633623 */   // Label 22481: @1633623
     /* 1633623 */   GIM_Try, /*On fail goto*//*Label 22482*/ GIMT_Encode4(1633709), // Rule ID 4298 //
     /* 1633628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1633631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1633645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1633648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633674 */     // MIs[0] policy
     /* 1633674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633684 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1633687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633708 */     // GIR_Coverage, 4298,
     /* 1633708 */     GIR_EraseRootFromParent_Done,
     /* 1633709 */   // Label 22482: @1633709
     /* 1633709 */   GIM_Try, /*On fail goto*//*Label 22483*/ GIMT_Encode4(1633795), // Rule ID 4299 //
     /* 1633714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1633717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1633725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1633728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1633731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1633734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1633737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1633744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1633752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1633756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633760 */     // MIs[0] policy
     /* 1633760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633770 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WV_M4_MASK),
     /* 1633773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1633791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633794 */     // GIR_Coverage, 4299,
     /* 1633794 */     GIR_EraseRootFromParent_Done,
     /* 1633795 */   // Label 22483: @1633795
     /* 1633795 */   GIM_Try, /*On fail goto*//*Label 22484*/ GIMT_Encode4(1633881), // Rule ID 4302 //
     /* 1633800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1633811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1633814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1633817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633846 */     // MIs[0] policy
     /* 1633846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633856 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1633856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1633859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633880 */     // GIR_Coverage, 4302,
     /* 1633880 */     GIR_EraseRootFromParent_Done,
     /* 1633881 */   // Label 22484: @1633881
     /* 1633881 */   GIM_Try, /*On fail goto*//*Label 22485*/ GIMT_Encode4(1633967), // Rule ID 4303 //
     /* 1633886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1633889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1633897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1633900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1633903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1633906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1633909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1633912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1633916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1633924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1633928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1633932 */     // MIs[0] policy
     /* 1633932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1633935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1633942 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1633942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF8_MASK),
     /* 1633945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1633947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1633949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1633951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1633953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1633955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1633960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1633963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1633965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1633966 */     // GIR_Coverage, 4303,
     /* 1633966 */     GIR_EraseRootFromParent_Done,
     /* 1633967 */   // Label 22485: @1633967
     /* 1633967 */   GIM_Try, /*On fail goto*//*Label 22486*/ GIMT_Encode4(1634053), // Rule ID 4306 //
     /* 1633972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1633975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1633980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1633983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1633986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1633989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1633992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1633995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1633998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634018 */     // MIs[0] policy
     /* 1634018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634028 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1634031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634052 */     // GIR_Coverage, 4306,
     /* 1634052 */     GIR_EraseRootFromParent_Done,
     /* 1634053 */   // Label 22486: @1634053
     /* 1634053 */   GIM_Try, /*On fail goto*//*Label 22487*/ GIMT_Encode4(1634139), // Rule ID 4307 //
     /* 1634058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1634069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1634072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1634075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1634081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634104 */     // MIs[0] policy
     /* 1634104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634114 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1634117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634138 */     // GIR_Coverage, 4307,
     /* 1634138 */     GIR_EraseRootFromParent_Done,
     /* 1634139 */   // Label 22487: @1634139
     /* 1634139 */   GIM_Try, /*On fail goto*//*Label 22488*/ GIMT_Encode4(1634225), // Rule ID 4310 //
     /* 1634144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1634155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1634158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1634161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634190 */     // MIs[0] policy
     /* 1634190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634200 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1634203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634224 */     // GIR_Coverage, 4310,
     /* 1634224 */     GIR_EraseRootFromParent_Done,
     /* 1634225 */   // Label 22488: @1634225
     /* 1634225 */   GIM_Try, /*On fail goto*//*Label 22489*/ GIMT_Encode4(1634311), // Rule ID 4311 //
     /* 1634230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1634241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1634244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1634247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1634253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634276 */     // MIs[0] policy
     /* 1634276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634286 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11605:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1634289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634310 */     // GIR_Coverage, 4311,
     /* 1634310 */     GIR_EraseRootFromParent_Done,
     /* 1634311 */   // Label 22489: @1634311
     /* 1634311 */   GIM_Try, /*On fail goto*//*Label 22490*/ GIMT_Encode4(1634397), // Rule ID 4314 //
     /* 1634316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1634327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1634330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1634333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634362 */     // MIs[0] policy
     /* 1634362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634372 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1634375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634396 */     // GIR_Coverage, 4314,
     /* 1634396 */     GIR_EraseRootFromParent_Done,
     /* 1634397 */   // Label 22490: @1634397
     /* 1634397 */   GIM_Try, /*On fail goto*//*Label 22491*/ GIMT_Encode4(1634483), // Rule ID 4315 //
     /* 1634402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1634413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1634416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1634419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1634425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1634432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1634440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634448 */     // MIs[0] policy
     /* 1634448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1634461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634482 */     // GIR_Coverage, 4315,
     /* 1634482 */     GIR_EraseRootFromParent_Done,
     /* 1634483 */   // Label 22491: @1634483
     /* 1634483 */   GIM_Try, /*On fail goto*//*Label 22492*/ GIMT_Encode4(1634569), // Rule ID 4318 //
     /* 1634488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1634499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1634502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1634505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634534 */     // MIs[0] policy
     /* 1634534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634544 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1634547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634568 */     // GIR_Coverage, 4318,
     /* 1634568 */     GIR_EraseRootFromParent_Done,
     /* 1634569 */   // Label 22492: @1634569
     /* 1634569 */   GIM_Try, /*On fail goto*//*Label 22493*/ GIMT_Encode4(1634655), // Rule ID 4319 //
     /* 1634574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1634585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1634588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1634591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1634597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1634604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1634612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634620 */     // MIs[0] policy
     /* 1634620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634630 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1634633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634654 */     // GIR_Coverage, 4319,
     /* 1634654 */     GIR_EraseRootFromParent_Done,
     /* 1634655 */   // Label 22493: @1634655
     /* 1634655 */   GIM_Try, /*On fail goto*//*Label 22494*/ GIMT_Encode4(1634741), // Rule ID 4322 //
     /* 1634660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1634671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1634674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1634677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634706 */     // MIs[0] policy
     /* 1634706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634716 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1634719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634740 */     // GIR_Coverage, 4322,
     /* 1634740 */     GIR_EraseRootFromParent_Done,
     /* 1634741 */   // Label 22494: @1634741
     /* 1634741 */   GIM_Try, /*On fail goto*//*Label 22495*/ GIMT_Encode4(1634827), // Rule ID 4323 //
     /* 1634746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1634757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1634760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1634763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1634769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1634776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1634784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634792 */     // MIs[0] policy
     /* 1634792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634802 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1634805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1634823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634826 */     // GIR_Coverage, 4323,
     /* 1634826 */     GIR_EraseRootFromParent_Done,
     /* 1634827 */   // Label 22495: @1634827
     /* 1634827 */   GIM_Try, /*On fail goto*//*Label 22496*/ GIMT_Encode4(1634913), // Rule ID 4326 //
     /* 1634832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1634835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1634852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1634858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634878 */     // MIs[0] policy
     /* 1634878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1634888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1634891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634912 */     // GIR_Coverage, 4326,
     /* 1634912 */     GIR_EraseRootFromParent_Done,
     /* 1634913 */   // Label 22496: @1634913
     /* 1634913 */   GIM_Try, /*On fail goto*//*Label 22497*/ GIMT_Encode4(1634999), // Rule ID 4327 //
     /* 1634918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1634921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1634926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1634929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1634932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1634935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1634938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1634941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1634944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1634948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1634956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1634960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1634964 */     // MIs[0] policy
     /* 1634964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1634967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1634974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1634974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF4_MASK),
     /* 1634977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1634979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1634981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1634983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1634985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1634987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1634992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1634995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1634997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1634998 */     // GIR_Coverage, 4327,
     /* 1634998 */     GIR_EraseRootFromParent_Done,
     /* 1634999 */   // Label 22497: @1634999
     /* 1634999 */   GIM_Try, /*On fail goto*//*Label 22498*/ GIMT_Encode4(1635085), // Rule ID 4330 //
     /* 1635004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1635015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1635018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1635021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635050 */     // MIs[0] policy
     /* 1635050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635060 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1635063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635084 */     // GIR_Coverage, 4330,
     /* 1635084 */     GIR_EraseRootFromParent_Done,
     /* 1635085 */   // Label 22498: @1635085
     /* 1635085 */   GIM_Try, /*On fail goto*//*Label 22499*/ GIMT_Encode4(1635171), // Rule ID 4331 //
     /* 1635090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1635101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1635104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1635107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635136 */     // MIs[0] policy
     /* 1635136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635146 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11605:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1635149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635170 */     // GIR_Coverage, 4331,
     /* 1635170 */     GIR_EraseRootFromParent_Done,
     /* 1635171 */   // Label 22499: @1635171
     /* 1635171 */   GIM_Try, /*On fail goto*//*Label 22500*/ GIMT_Encode4(1635257), // Rule ID 4334 //
     /* 1635176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1635187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1635190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1635193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635222 */     // MIs[0] policy
     /* 1635222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1635235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635256 */     // GIR_Coverage, 4334,
     /* 1635256 */     GIR_EraseRootFromParent_Done,
     /* 1635257 */   // Label 22500: @1635257
     /* 1635257 */   GIM_Try, /*On fail goto*//*Label 22501*/ GIMT_Encode4(1635343), // Rule ID 4335 //
     /* 1635262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1635273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1635276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1635279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1635285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635308 */     // MIs[0] policy
     /* 1635308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635318 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1635321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635342 */     // GIR_Coverage, 4335,
     /* 1635342 */     GIR_EraseRootFromParent_Done,
     /* 1635343 */   // Label 22501: @1635343
     /* 1635343 */   GIM_Try, /*On fail goto*//*Label 22502*/ GIMT_Encode4(1635429), // Rule ID 4338 //
     /* 1635348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1635359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1635362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1635365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635394 */     // MIs[0] policy
     /* 1635394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635404 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1635407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635428 */     // GIR_Coverage, 4338,
     /* 1635428 */     GIR_EraseRootFromParent_Done,
     /* 1635429 */   // Label 22502: @1635429
     /* 1635429 */   GIM_Try, /*On fail goto*//*Label 22503*/ GIMT_Encode4(1635515), // Rule ID 4339 //
     /* 1635434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1635445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1635448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1635451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1635457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1635464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1635472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635480 */     // MIs[0] policy
     /* 1635480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635490 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1635493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635514 */     // GIR_Coverage, 4339,
     /* 1635514 */     GIR_EraseRootFromParent_Done,
     /* 1635515 */   // Label 22503: @1635515
     /* 1635515 */   GIM_Try, /*On fail goto*//*Label 22504*/ GIMT_Encode4(1635601), // Rule ID 4342 //
     /* 1635520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1635523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1635531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1635534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1635537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635566 */     // MIs[0] policy
     /* 1635566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635576 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1635579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635600 */     // GIR_Coverage, 4342,
     /* 1635600 */     GIR_EraseRootFromParent_Done,
     /* 1635601 */   // Label 22504: @1635601
     /* 1635601 */   GIM_Try, /*On fail goto*//*Label 22505*/ GIMT_Encode4(1635687), // Rule ID 4343 //
     /* 1635606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1635609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1635617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1635620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1635623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1635629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1635636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1635644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635652 */     // MIs[0] policy
     /* 1635652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635662 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1635665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1635683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635686 */     // GIR_Coverage, 4343,
     /* 1635686 */     GIR_EraseRootFromParent_Done,
     /* 1635687 */   // Label 22505: @1635687
     /* 1635687 */   GIM_Try, /*On fail goto*//*Label 22506*/ GIMT_Encode4(1635773), // Rule ID 4346 //
     /* 1635692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635738 */     // MIs[0] policy
     /* 1635738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635748 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1635751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635772 */     // GIR_Coverage, 4346,
     /* 1635772 */     GIR_EraseRootFromParent_Done,
     /* 1635773 */   // Label 22506: @1635773
     /* 1635773 */   GIM_Try, /*On fail goto*//*Label 22507*/ GIMT_Encode4(1635859), // Rule ID 4347 //
     /* 1635778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1635789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1635792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1635795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1635801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1635808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1635816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635824 */     // MIs[0] policy
     /* 1635824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635834 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11605:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1635834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_MF2_MASK),
     /* 1635837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635858 */     // GIR_Coverage, 4347,
     /* 1635858 */     GIR_EraseRootFromParent_Done,
     /* 1635859 */   // Label 22507: @1635859
     /* 1635859 */   GIM_Try, /*On fail goto*//*Label 22508*/ GIMT_Encode4(1635945), // Rule ID 4350 //
     /* 1635864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1635867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1635884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1635890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635910 */     // MIs[0] policy
     /* 1635910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1635920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1635920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1635923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1635925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1635927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1635929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1635931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1635933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1635938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1635941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1635943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1635944 */     // GIR_Coverage, 4350,
     /* 1635944 */     GIR_EraseRootFromParent_Done,
     /* 1635945 */   // Label 22508: @1635945
     /* 1635945 */   GIM_Try, /*On fail goto*//*Label 22509*/ GIMT_Encode4(1636031), // Rule ID 4351 //
     /* 1635950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1635953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1635958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1635961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1635964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1635967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1635970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1635973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1635976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1635980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1635988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1635992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1635996 */     // MIs[0] policy
     /* 1635996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1635999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636006 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11605:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M1_MASK),
     /* 1636009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636030 */     // GIR_Coverage, 4351,
     /* 1636030 */     GIR_EraseRootFromParent_Done,
     /* 1636031 */   // Label 22509: @1636031
     /* 1636031 */   GIM_Try, /*On fail goto*//*Label 22510*/ GIMT_Encode4(1636117), // Rule ID 4354 //
     /* 1636036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1636039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1636047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1636050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1636053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636082 */     // MIs[0] policy
     /* 1636082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636092 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1636095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636116 */     // GIR_Coverage, 4354,
     /* 1636116 */     GIR_EraseRootFromParent_Done,
     /* 1636117 */   // Label 22510: @1636117
     /* 1636117 */   GIM_Try, /*On fail goto*//*Label 22511*/ GIMT_Encode4(1636203), // Rule ID 4355 //
     /* 1636122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1636133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1636136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1636139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1636152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1636160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636168 */     // MIs[0] policy
     /* 1636168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636178 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11605:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M2_MASK),
     /* 1636181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636202 */     // GIR_Coverage, 4355,
     /* 1636202 */     GIR_EraseRootFromParent_Done,
     /* 1636203 */   // Label 22511: @1636203
     /* 1636203 */   GIM_Try, /*On fail goto*//*Label 22512*/ GIMT_Encode4(1636289), // Rule ID 4358 //
     /* 1636208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1636211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1636219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1636222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1636225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1636228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636254 */     // MIs[0] policy
     /* 1636254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636264 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1636267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636288 */     // GIR_Coverage, 4358,
     /* 1636288 */     GIR_EraseRootFromParent_Done,
     /* 1636289 */   // Label 22512: @1636289
     /* 1636289 */   GIM_Try, /*On fail goto*//*Label 22513*/ GIMT_Encode4(1636375), // Rule ID 4359 //
     /* 1636294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1636297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsubu_w_mask),
     /* 1636302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1636305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1636308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1636311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1636314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1636324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1636332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1636336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636340 */     // MIs[0] policy
     /* 1636340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636350 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11605:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUBU_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUBU_WX_M4_MASK),
     /* 1636353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1636371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636374 */     // GIR_Coverage, 4359,
     /* 1636374 */     GIR_EraseRootFromParent_Done,
     /* 1636375 */   // Label 22513: @1636375
     /* 1636375 */   GIM_Try, /*On fail goto*//*Label 22514*/ GIMT_Encode4(1636461), // Rule ID 4368 //
     /* 1636380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1636391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1636394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1636397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1636400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636426 */     // MIs[0] policy
     /* 1636426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636436 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1636439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636460 */     // GIR_Coverage, 4368,
     /* 1636460 */     GIR_EraseRootFromParent_Done,
     /* 1636461 */   // Label 22514: @1636461
     /* 1636461 */   GIM_Try, /*On fail goto*//*Label 22515*/ GIMT_Encode4(1636547), // Rule ID 4369 //
     /* 1636466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1636477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1636480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1636483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1636486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1636489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636512 */     // MIs[0] policy
     /* 1636512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636522 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF8_MASK),
     /* 1636525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636546 */     // GIR_Coverage, 4369,
     /* 1636546 */     GIR_EraseRootFromParent_Done,
     /* 1636547 */   // Label 22515: @1636547
     /* 1636547 */   GIM_Try, /*On fail goto*//*Label 22516*/ GIMT_Encode4(1636633), // Rule ID 4378 //
     /* 1636552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1636563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1636566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1636569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1636572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636598 */     // MIs[0] policy
     /* 1636598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636608 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1636611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636632 */     // GIR_Coverage, 4378,
     /* 1636632 */     GIR_EraseRootFromParent_Done,
     /* 1636633 */   // Label 22516: @1636633
     /* 1636633 */   GIM_Try, /*On fail goto*//*Label 22517*/ GIMT_Encode4(1636719), // Rule ID 4379 //
     /* 1636638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1636649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1636652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1636655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1636658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1636661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636684 */     // MIs[0] policy
     /* 1636684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636694 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1636697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636718 */     // GIR_Coverage, 4379,
     /* 1636718 */     GIR_EraseRootFromParent_Done,
     /* 1636719 */   // Label 22517: @1636719
     /* 1636719 */   GIM_Try, /*On fail goto*//*Label 22518*/ GIMT_Encode4(1636805), // Rule ID 4388 //
     /* 1636724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1636744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636770 */     // MIs[0] policy
     /* 1636770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636780 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1636783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636804 */     // GIR_Coverage, 4388,
     /* 1636804 */     GIR_EraseRootFromParent_Done,
     /* 1636805 */   // Label 22518: @1636805
     /* 1636805 */   GIM_Try, /*On fail goto*//*Label 22519*/ GIMT_Encode4(1636891), // Rule ID 4389 //
     /* 1636810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1636821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1636824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1636827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1636830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1636833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1636836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1636840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636856 */     // MIs[0] policy
     /* 1636856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636866 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1636866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1636869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636890 */     // GIR_Coverage, 4389,
     /* 1636890 */     GIR_EraseRootFromParent_Done,
     /* 1636891 */   // Label 22519: @1636891
     /* 1636891 */   GIM_Try, /*On fail goto*//*Label 22520*/ GIMT_Encode4(1636977), // Rule ID 4398 //
     /* 1636896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1636899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1636916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1636919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1636922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1636926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1636934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1636938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1636942 */     // MIs[0] policy
     /* 1636942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1636945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1636952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1636952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1636955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1636957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1636959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1636961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1636963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1636965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1636970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1636973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1636975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1636976 */     // GIR_Coverage, 4398,
     /* 1636976 */     GIR_EraseRootFromParent_Done,
     /* 1636977 */   // Label 22520: @1636977
     /* 1636977 */   GIM_Try, /*On fail goto*//*Label 22521*/ GIMT_Encode4(1637063), // Rule ID 4399 //
     /* 1636982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1636985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1636990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1636993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1636996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1636999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1637002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637028 */     // MIs[0] policy
     /* 1637028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637038 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1637041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637062 */     // GIR_Coverage, 4399,
     /* 1637062 */     GIR_EraseRootFromParent_Done,
     /* 1637063 */   // Label 22521: @1637063
     /* 1637063 */   GIM_Try, /*On fail goto*//*Label 22522*/ GIMT_Encode4(1637149), // Rule ID 4408 //
     /* 1637068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1637088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637114 */     // MIs[0] policy
     /* 1637114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637124 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1637127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637148 */     // GIR_Coverage, 4408,
     /* 1637148 */     GIR_EraseRootFromParent_Done,
     /* 1637149 */   // Label 22522: @1637149
     /* 1637149 */   GIM_Try, /*On fail goto*//*Label 22523*/ GIMT_Encode4(1637235), // Rule ID 4409 //
     /* 1637154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1637165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1637168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1637171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1637174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1637177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637200 */     // MIs[0] policy
     /* 1637200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637210 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1637213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637234 */     // GIR_Coverage, 4409,
     /* 1637234 */     GIR_EraseRootFromParent_Done,
     /* 1637235 */   // Label 22523: @1637235
     /* 1637235 */   GIM_Try, /*On fail goto*//*Label 22524*/ GIMT_Encode4(1637321), // Rule ID 4418 //
     /* 1637240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1637260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637286 */     // MIs[0] policy
     /* 1637286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637296 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1637299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637320 */     // GIR_Coverage, 4418,
     /* 1637320 */     GIR_EraseRootFromParent_Done,
     /* 1637321 */   // Label 22524: @1637321
     /* 1637321 */   GIM_Try, /*On fail goto*//*Label 22525*/ GIMT_Encode4(1637407), // Rule ID 4419 //
     /* 1637326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1637337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1637340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1637343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1637346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1637349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1637356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1637364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637372 */     // MIs[0] policy
     /* 1637372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637382 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1637385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1637403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637406 */     // GIR_Coverage, 4419,
     /* 1637406 */     GIR_EraseRootFromParent_Done,
     /* 1637407 */   // Label 22525: @1637407
     /* 1637407 */   GIM_Try, /*On fail goto*//*Label 22526*/ GIMT_Encode4(1637493), // Rule ID 4428 //
     /* 1637412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1637423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1637426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1637429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1637432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637458 */     // MIs[0] policy
     /* 1637458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1637471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637492 */     // GIR_Coverage, 4428,
     /* 1637492 */     GIR_EraseRootFromParent_Done,
     /* 1637493 */   // Label 22526: @1637493
     /* 1637493 */   GIM_Try, /*On fail goto*//*Label 22527*/ GIMT_Encode4(1637579), // Rule ID 4429 //
     /* 1637498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1637509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1637512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1637515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1637518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1637521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637544 */     // MIs[0] policy
     /* 1637544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF4_MASK),
     /* 1637557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637578 */     // GIR_Coverage, 4429,
     /* 1637578 */     GIR_EraseRootFromParent_Done,
     /* 1637579 */   // Label 22527: @1637579
     /* 1637579 */   GIM_Try, /*On fail goto*//*Label 22528*/ GIMT_Encode4(1637665), // Rule ID 4438 //
     /* 1637584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1637595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1637598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1637601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1637604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637630 */     // MIs[0] policy
     /* 1637630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637640 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1637643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637664 */     // GIR_Coverage, 4438,
     /* 1637664 */     GIR_EraseRootFromParent_Done,
     /* 1637665 */   // Label 22528: @1637665
     /* 1637665 */   GIM_Try, /*On fail goto*//*Label 22529*/ GIMT_Encode4(1637751), // Rule ID 4439 //
     /* 1637670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1637681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1637684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1637687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1637690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1637693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1637700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637716 */     // MIs[0] policy
     /* 1637716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637726 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1637729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637750 */     // GIR_Coverage, 4439,
     /* 1637750 */     GIR_EraseRootFromParent_Done,
     /* 1637751 */   // Label 22529: @1637751
     /* 1637751 */   GIM_Try, /*On fail goto*//*Label 22530*/ GIMT_Encode4(1637837), // Rule ID 4448 //
     /* 1637756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1637776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637802 */     // MIs[0] policy
     /* 1637802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637812 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1637815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637836 */     // GIR_Coverage, 4448,
     /* 1637836 */     GIR_EraseRootFromParent_Done,
     /* 1637837 */   // Label 22530: @1637837
     /* 1637837 */   GIM_Try, /*On fail goto*//*Label 22531*/ GIMT_Encode4(1637923), // Rule ID 4449 //
     /* 1637842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1637845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1637853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1637856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1637859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1637862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1637865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1637868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1637872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1637884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637888 */     // MIs[0] policy
     /* 1637888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637898 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1637898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1637901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1637916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1637919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1637921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1637922 */     // GIR_Coverage, 4449,
     /* 1637922 */     GIR_EraseRootFromParent_Done,
     /* 1637923 */   // Label 22531: @1637923
     /* 1637923 */   GIM_Try, /*On fail goto*//*Label 22532*/ GIMT_Encode4(1638009), // Rule ID 4458 //
     /* 1637928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1637931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1637936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1637939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1637942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1637945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1637948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1637951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1637954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1637958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1637966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1637970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1637974 */     // MIs[0] policy
     /* 1637974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1637977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1637984 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1637984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1637987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1637989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1637991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1637993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1637995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1637997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638008 */     // GIR_Coverage, 4458,
     /* 1638008 */     GIR_EraseRootFromParent_Done,
     /* 1638009 */   // Label 22532: @1638009
     /* 1638009 */   GIM_Try, /*On fail goto*//*Label 22533*/ GIMT_Encode4(1638095), // Rule ID 4459 //
     /* 1638014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1638025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1638028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1638031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1638034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638060 */     // MIs[0] policy
     /* 1638060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638070 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1638073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638094 */     // GIR_Coverage, 4459,
     /* 1638094 */     GIR_EraseRootFromParent_Done,
     /* 1638095 */   // Label 22533: @1638095
     /* 1638095 */   GIM_Try, /*On fail goto*//*Label 22534*/ GIMT_Encode4(1638181), // Rule ID 4468 //
     /* 1638100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1638120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638146 */     // MIs[0] policy
     /* 1638146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638156 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1638159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638180 */     // GIR_Coverage, 4468,
     /* 1638180 */     GIR_EraseRootFromParent_Done,
     /* 1638181 */   // Label 22534: @1638181
     /* 1638181 */   GIM_Try, /*On fail goto*//*Label 22535*/ GIMT_Encode4(1638267), // Rule ID 4469 //
     /* 1638186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1638189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1638197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1638200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1638203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1638206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1638209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638232 */     // MIs[0] policy
     /* 1638232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638242 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1638245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1638263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638266 */     // GIR_Coverage, 4469,
     /* 1638266 */     GIR_EraseRootFromParent_Done,
     /* 1638267 */   // Label 22535: @1638267
     /* 1638267 */   GIM_Try, /*On fail goto*//*Label 22536*/ GIMT_Encode4(1638353), // Rule ID 4478 //
     /* 1638272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1638283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1638286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1638289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1638292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638318 */     // MIs[0] policy
     /* 1638318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638328 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1638331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638352 */     // GIR_Coverage, 4478,
     /* 1638352 */     GIR_EraseRootFromParent_Done,
     /* 1638353 */   // Label 22536: @1638353
     /* 1638353 */   GIM_Try, /*On fail goto*//*Label 22537*/ GIMT_Encode4(1638439), // Rule ID 4479 //
     /* 1638358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1638369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1638372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1638375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1638378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638404 */     // MIs[0] policy
     /* 1638404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638414 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_MF2_MASK),
     /* 1638417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638438 */     // GIR_Coverage, 4479,
     /* 1638438 */     GIR_EraseRootFromParent_Done,
     /* 1638439 */   // Label 22537: @1638439
     /* 1638439 */   GIM_Try, /*On fail goto*//*Label 22538*/ GIMT_Encode4(1638525), // Rule ID 4488 //
     /* 1638444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1638464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638490 */     // MIs[0] policy
     /* 1638490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638500 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1638503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638524 */     // GIR_Coverage, 4488,
     /* 1638524 */     GIR_EraseRootFromParent_Done,
     /* 1638525 */   // Label 22538: @1638525
     /* 1638525 */   GIM_Try, /*On fail goto*//*Label 22539*/ GIMT_Encode4(1638611), // Rule ID 4489 //
     /* 1638530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1638541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1638544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1638547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1638550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1638553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1638560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638576 */     // MIs[0] policy
     /* 1638576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M1_MASK),
     /* 1638589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638610 */     // GIR_Coverage, 4489,
     /* 1638610 */     GIR_EraseRootFromParent_Done,
     /* 1638611 */   // Label 22539: @1638611
     /* 1638611 */   GIM_Try, /*On fail goto*//*Label 22540*/ GIMT_Encode4(1638697), // Rule ID 4498 //
     /* 1638616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1638636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638662 */     // MIs[0] policy
     /* 1638662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638672 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1638675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638696 */     // GIR_Coverage, 4498,
     /* 1638696 */     GIR_EraseRootFromParent_Done,
     /* 1638697 */   // Label 22540: @1638697
     /* 1638697 */   GIM_Try, /*On fail goto*//*Label 22541*/ GIMT_Encode4(1638783), // Rule ID 4499 //
     /* 1638702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1638713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1638716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1638719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1638722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1638725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1638732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1638744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638748 */     // MIs[0] policy
     /* 1638748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638758 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M2_MASK),
     /* 1638761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638782 */     // GIR_Coverage, 4499,
     /* 1638782 */     GIR_EraseRootFromParent_Done,
     /* 1638783 */   // Label 22541: @1638783
     /* 1638783 */   GIM_Try, /*On fail goto*//*Label 22542*/ GIMT_Encode4(1638869), // Rule ID 4508 //
     /* 1638788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1638791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1638808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638834 */     // MIs[0] policy
     /* 1638834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638844 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1638844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1638847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638868 */     // GIR_Coverage, 4508,
     /* 1638868 */     GIR_EraseRootFromParent_Done,
     /* 1638869 */   // Label 22542: @1638869
     /* 1638869 */   GIM_Try, /*On fail goto*//*Label 22543*/ GIMT_Encode4(1638955), // Rule ID 4509 //
     /* 1638874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1638877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1638885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1638888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1638891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1638894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1638897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1638900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1638904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1638912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1638916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1638920 */     // MIs[0] policy
     /* 1638920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1638923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1638930 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1638930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WV_M4_MASK),
     /* 1638933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1638935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1638937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1638939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1638941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1638943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1638948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1638951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1638953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1638954 */     // GIR_Coverage, 4509,
     /* 1638954 */     GIR_EraseRootFromParent_Done,
     /* 1638955 */   // Label 22543: @1638955
     /* 1638955 */   GIM_Try, /*On fail goto*//*Label 22544*/ GIMT_Encode4(1639041), // Rule ID 4512 //
     /* 1638960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1638963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1638968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1638971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1638974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1638977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1638980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1638983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1638986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1638990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1638998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639006 */     // MIs[0] policy
     /* 1639006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639016 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1639019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639040 */     // GIR_Coverage, 4512,
     /* 1639040 */     GIR_EraseRootFromParent_Done,
     /* 1639041 */   // Label 22544: @1639041
     /* 1639041 */   GIM_Try, /*On fail goto*//*Label 22545*/ GIMT_Encode4(1639127), // Rule ID 4513 //
     /* 1639046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1639057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1639060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1639063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1639069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639092 */     // MIs[0] policy
     /* 1639092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639102 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF8_MASK),
     /* 1639105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639126 */     // GIR_Coverage, 4513,
     /* 1639126 */     GIR_EraseRootFromParent_Done,
     /* 1639127 */   // Label 22545: @1639127
     /* 1639127 */   GIM_Try, /*On fail goto*//*Label 22546*/ GIMT_Encode4(1639213), // Rule ID 4516 //
     /* 1639132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639178 */     // MIs[0] policy
     /* 1639178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639188 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1639191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639212 */     // GIR_Coverage, 4516,
     /* 1639212 */     GIR_EraseRootFromParent_Done,
     /* 1639213 */   // Label 22546: @1639213
     /* 1639213 */   GIM_Try, /*On fail goto*//*Label 22547*/ GIMT_Encode4(1639299), // Rule ID 4517 //
     /* 1639218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1639229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1639232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1639235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1639241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639264 */     // MIs[0] policy
     /* 1639264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639274 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1639277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639298 */     // GIR_Coverage, 4517,
     /* 1639298 */     GIR_EraseRootFromParent_Done,
     /* 1639299 */   // Label 22547: @1639299
     /* 1639299 */   GIM_Try, /*On fail goto*//*Label 22548*/ GIMT_Encode4(1639385), // Rule ID 4520 //
     /* 1639304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1639315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1639318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1639321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639350 */     // MIs[0] policy
     /* 1639350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639360 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1639363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639384 */     // GIR_Coverage, 4520,
     /* 1639384 */     GIR_EraseRootFromParent_Done,
     /* 1639385 */   // Label 22548: @1639385
     /* 1639385 */   GIM_Try, /*On fail goto*//*Label 22549*/ GIMT_Encode4(1639471), // Rule ID 4521 //
     /* 1639390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1639401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1639404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1639407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1639413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1639420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1639428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639436 */     // MIs[0] policy
     /* 1639436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639446 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11573:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1639449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639470 */     // GIR_Coverage, 4521,
     /* 1639470 */     GIR_EraseRootFromParent_Done,
     /* 1639471 */   // Label 22549: @1639471
     /* 1639471 */   GIM_Try, /*On fail goto*//*Label 22550*/ GIMT_Encode4(1639557), // Rule ID 4524 //
     /* 1639476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1639487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1639490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1639493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639522 */     // MIs[0] policy
     /* 1639522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1639535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639556 */     // GIR_Coverage, 4524,
     /* 1639556 */     GIR_EraseRootFromParent_Done,
     /* 1639557 */   // Label 22550: @1639557
     /* 1639557 */   GIM_Try, /*On fail goto*//*Label 22551*/ GIMT_Encode4(1639643), // Rule ID 4525 //
     /* 1639562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1639573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1639576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1639579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1639585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1639592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1639600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639608 */     // MIs[0] policy
     /* 1639608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1639621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639642 */     // GIR_Coverage, 4525,
     /* 1639642 */     GIR_EraseRootFromParent_Done,
     /* 1639643 */   // Label 22551: @1639643
     /* 1639643 */   GIM_Try, /*On fail goto*//*Label 22552*/ GIMT_Encode4(1639729), // Rule ID 4528 //
     /* 1639648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639694 */     // MIs[0] policy
     /* 1639694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639704 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1639707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639728 */     // GIR_Coverage, 4528,
     /* 1639728 */     GIR_EraseRootFromParent_Done,
     /* 1639729 */   // Label 22552: @1639729
     /* 1639729 */   GIM_Try, /*On fail goto*//*Label 22553*/ GIMT_Encode4(1639815), // Rule ID 4529 //
     /* 1639734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1639745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1639748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1639751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1639757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1639764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1639772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639780 */     // MIs[0] policy
     /* 1639780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639790 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1639793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639814 */     // GIR_Coverage, 4529,
     /* 1639814 */     GIR_EraseRootFromParent_Done,
     /* 1639815 */   // Label 22553: @1639815
     /* 1639815 */   GIM_Try, /*On fail goto*//*Label 22554*/ GIMT_Encode4(1639901), // Rule ID 4532 //
     /* 1639820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1639840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1639846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639866 */     // MIs[0] policy
     /* 1639866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639876 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1639876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1639879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639900 */     // GIR_Coverage, 4532,
     /* 1639900 */     GIR_EraseRootFromParent_Done,
     /* 1639901 */   // Label 22554: @1639901
     /* 1639901 */   GIM_Try, /*On fail goto*//*Label 22555*/ GIMT_Encode4(1639987), // Rule ID 4533 //
     /* 1639906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1639909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1639914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1639917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1639920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1639923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1639926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1639929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1639932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1639936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1639944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1639948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1639952 */     // MIs[0] policy
     /* 1639952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1639955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1639962 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1639962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1639965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1639967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1639969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1639971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1639973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1639975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1639980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1639983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1639985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1639986 */     // GIR_Coverage, 4533,
     /* 1639986 */     GIR_EraseRootFromParent_Done,
     /* 1639987 */   // Label 22555: @1639987
     /* 1639987 */   GIM_Try, /*On fail goto*//*Label 22556*/ GIMT_Encode4(1640073), // Rule ID 4536 //
     /* 1639992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1639995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1640003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1640006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1640009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640038 */     // MIs[0] policy
     /* 1640038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1640051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640072 */     // GIR_Coverage, 4536,
     /* 1640072 */     GIR_EraseRootFromParent_Done,
     /* 1640073 */   // Label 22556: @1640073
     /* 1640073 */   GIM_Try, /*On fail goto*//*Label 22557*/ GIMT_Encode4(1640159), // Rule ID 4537 //
     /* 1640078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1640089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1640092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1640095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640124 */     // MIs[0] policy
     /* 1640124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF4_MASK),
     /* 1640137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640158 */     // GIR_Coverage, 4537,
     /* 1640158 */     GIR_EraseRootFromParent_Done,
     /* 1640159 */   // Label 22557: @1640159
     /* 1640159 */   GIM_Try, /*On fail goto*//*Label 22558*/ GIMT_Encode4(1640245), // Rule ID 4540 //
     /* 1640164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640210 */     // MIs[0] policy
     /* 1640210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640220 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1640223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640244 */     // GIR_Coverage, 4540,
     /* 1640244 */     GIR_EraseRootFromParent_Done,
     /* 1640245 */   // Label 22558: @1640245
     /* 1640245 */   GIM_Try, /*On fail goto*//*Label 22559*/ GIMT_Encode4(1640331), // Rule ID 4541 //
     /* 1640250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1640261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1640264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1640267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1640273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640296 */     // MIs[0] policy
     /* 1640296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640306 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11573:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1640309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640330 */     // GIR_Coverage, 4541,
     /* 1640330 */     GIR_EraseRootFromParent_Done,
     /* 1640331 */   // Label 22559: @1640331
     /* 1640331 */   GIM_Try, /*On fail goto*//*Label 22560*/ GIMT_Encode4(1640417), // Rule ID 4544 //
     /* 1640336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1640347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1640350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1640353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640382 */     // MIs[0] policy
     /* 1640382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1640395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640416 */     // GIR_Coverage, 4544,
     /* 1640416 */     GIR_EraseRootFromParent_Done,
     /* 1640417 */   // Label 22560: @1640417
     /* 1640417 */   GIM_Try, /*On fail goto*//*Label 22561*/ GIMT_Encode4(1640503), // Rule ID 4545 //
     /* 1640422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1640433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1640436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1640439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1640445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1640452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1640460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640468 */     // MIs[0] policy
     /* 1640468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640478 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1640481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640502 */     // GIR_Coverage, 4545,
     /* 1640502 */     GIR_EraseRootFromParent_Done,
     /* 1640503 */   // Label 22561: @1640503
     /* 1640503 */   GIM_Try, /*On fail goto*//*Label 22562*/ GIMT_Encode4(1640589), // Rule ID 4548 //
     /* 1640508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1640519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1640522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1640525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640554 */     // MIs[0] policy
     /* 1640554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640564 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1640567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640588 */     // GIR_Coverage, 4548,
     /* 1640588 */     GIR_EraseRootFromParent_Done,
     /* 1640589 */   // Label 22562: @1640589
     /* 1640589 */   GIM_Try, /*On fail goto*//*Label 22563*/ GIMT_Encode4(1640675), // Rule ID 4549 //
     /* 1640594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1640605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1640608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1640611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1640617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1640624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1640632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640640 */     // MIs[0] policy
     /* 1640640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640650 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1640653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640674 */     // GIR_Coverage, 4549,
     /* 1640674 */     GIR_EraseRootFromParent_Done,
     /* 1640675 */   // Label 22563: @1640675
     /* 1640675 */   GIM_Try, /*On fail goto*//*Label 22564*/ GIMT_Encode4(1640761), // Rule ID 4552 //
     /* 1640680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1640683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640726 */     // MIs[0] policy
     /* 1640726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640736 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1640739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640760 */     // GIR_Coverage, 4552,
     /* 1640760 */     GIR_EraseRootFromParent_Done,
     /* 1640761 */   // Label 22564: @1640761
     /* 1640761 */   GIM_Try, /*On fail goto*//*Label 22565*/ GIMT_Encode4(1640847), // Rule ID 4553 //
     /* 1640766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1640769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1640777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1640780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1640783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1640789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1640796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1640804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640812 */     // MIs[0] policy
     /* 1640812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640822 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1640825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1640843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640846 */     // GIR_Coverage, 4553,
     /* 1640846 */     GIR_EraseRootFromParent_Done,
     /* 1640847 */   // Label 22565: @1640847
     /* 1640847 */   GIM_Try, /*On fail goto*//*Label 22566*/ GIMT_Encode4(1640933), // Rule ID 4556 //
     /* 1640852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1640855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1640872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1640878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640898 */     // MIs[0] policy
     /* 1640898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640908 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1640908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1640911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1640915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1640917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1640919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1640921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1640926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1640929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1640931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1640932 */     // GIR_Coverage, 4556,
     /* 1640932 */     GIR_EraseRootFromParent_Done,
     /* 1640933 */   // Label 22566: @1640933
     /* 1640933 */   GIM_Try, /*On fail goto*//*Label 22567*/ GIMT_Encode4(1641019), // Rule ID 4557 //
     /* 1640938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1640941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1640946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1640949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1640952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1640955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1640958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1640961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1640964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1640968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1640976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1640980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1640984 */     // MIs[0] policy
     /* 1640984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1640987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1640994 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11573:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1640994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_MF2_MASK),
     /* 1640997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1640999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641018 */     // GIR_Coverage, 4557,
     /* 1641018 */     GIR_EraseRootFromParent_Done,
     /* 1641019 */   // Label 22567: @1641019
     /* 1641019 */   GIM_Try, /*On fail goto*//*Label 22568*/ GIMT_Encode4(1641105), // Rule ID 4560 //
     /* 1641024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1641035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1641038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1641041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641070 */     // MIs[0] policy
     /* 1641070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1641083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641104 */     // GIR_Coverage, 4560,
     /* 1641104 */     GIR_EraseRootFromParent_Done,
     /* 1641105 */   // Label 22568: @1641105
     /* 1641105 */   GIM_Try, /*On fail goto*//*Label 22569*/ GIMT_Encode4(1641191), // Rule ID 4561 //
     /* 1641110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1641121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1641124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1641127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1641140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1641148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641156 */     // MIs[0] policy
     /* 1641156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11573:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M1_MASK),
     /* 1641169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641190 */     // GIR_Coverage, 4561,
     /* 1641190 */     GIR_EraseRootFromParent_Done,
     /* 1641191 */   // Label 22569: @1641191
     /* 1641191 */   GIM_Try, /*On fail goto*//*Label 22570*/ GIMT_Encode4(1641277), // Rule ID 4564 //
     /* 1641196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1641207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1641210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1641213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641242 */     // MIs[0] policy
     /* 1641242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1641255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641276 */     // GIR_Coverage, 4564,
     /* 1641276 */     GIR_EraseRootFromParent_Done,
     /* 1641277 */   // Label 22570: @1641277
     /* 1641277 */   GIM_Try, /*On fail goto*//*Label 22571*/ GIMT_Encode4(1641363), // Rule ID 4565 //
     /* 1641282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1641293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1641296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1641299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1641312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1641320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641328 */     // MIs[0] policy
     /* 1641328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11573:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M2_MASK),
     /* 1641341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641362 */     // GIR_Coverage, 4565,
     /* 1641362 */     GIR_EraseRootFromParent_Done,
     /* 1641363 */   // Label 22571: @1641363
     /* 1641363 */   GIM_Try, /*On fail goto*//*Label 22572*/ GIMT_Encode4(1641449), // Rule ID 4568 //
     /* 1641368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1641371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1641379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1641382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1641385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1641388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641414 */     // MIs[0] policy
     /* 1641414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1641427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641448 */     // GIR_Coverage, 4568,
     /* 1641448 */     GIR_EraseRootFromParent_Done,
     /* 1641449 */   // Label 22572: @1641449
     /* 1641449 */   GIM_Try, /*On fail goto*//*Label 22573*/ GIMT_Encode4(1641535), // Rule ID 4569 //
     /* 1641454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1641457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwadd_w_mask),
     /* 1641462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1641465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1641468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1641471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1641474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1641477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1641484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1641492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1641496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641500 */     // MIs[0] policy
     /* 1641500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11573:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWADD_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWADD_WX_M4_MASK),
     /* 1641513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1641531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641534 */     // GIR_Coverage, 4569,
     /* 1641534 */     GIR_EraseRootFromParent_Done,
     /* 1641535 */   // Label 22573: @1641535
     /* 1641535 */   GIM_Try, /*On fail goto*//*Label 22574*/ GIMT_Encode4(1641621), // Rule ID 4578 //
     /* 1641540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1641551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1641554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1641557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1641560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641586 */     // MIs[0] policy
     /* 1641586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641596 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1641599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641620 */     // GIR_Coverage, 4578,
     /* 1641620 */     GIR_EraseRootFromParent_Done,
     /* 1641621 */   // Label 22574: @1641621
     /* 1641621 */   GIM_Try, /*On fail goto*//*Label 22575*/ GIMT_Encode4(1641707), // Rule ID 4579 //
     /* 1641626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1641637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1641640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1641643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1641646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1641649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641672 */     // MIs[0] policy
     /* 1641672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF8_MASK),
     /* 1641685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641706 */     // GIR_Coverage, 4579,
     /* 1641706 */     GIR_EraseRootFromParent_Done,
     /* 1641707 */   // Label 22575: @1641707
     /* 1641707 */   GIM_Try, /*On fail goto*//*Label 22576*/ GIMT_Encode4(1641793), // Rule ID 4588 //
     /* 1641712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1641732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641758 */     // MIs[0] policy
     /* 1641758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641768 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1641771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641792 */     // GIR_Coverage, 4588,
     /* 1641792 */     GIR_EraseRootFromParent_Done,
     /* 1641793 */   // Label 22576: @1641793
     /* 1641793 */   GIM_Try, /*On fail goto*//*Label 22577*/ GIMT_Encode4(1641879), // Rule ID 4589 //
     /* 1641798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1641809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1641812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1641815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1641818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1641821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641844 */     // MIs[0] policy
     /* 1641844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641854 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1641854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1641857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641878 */     // GIR_Coverage, 4589,
     /* 1641878 */     GIR_EraseRootFromParent_Done,
     /* 1641879 */   // Label 22577: @1641879
     /* 1641879 */   GIM_Try, /*On fail goto*//*Label 22578*/ GIMT_Encode4(1641965), // Rule ID 4598 //
     /* 1641884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1641887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1641904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1641910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1641914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1641926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1641930 */     // MIs[0] policy
     /* 1641930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1641933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1641940 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1641940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1641943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1641945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1641947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1641949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1641951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1641953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1641958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1641961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1641963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1641964 */     // GIR_Coverage, 4598,
     /* 1641964 */     GIR_EraseRootFromParent_Done,
     /* 1641965 */   // Label 22578: @1641965
     /* 1641965 */   GIM_Try, /*On fail goto*//*Label 22579*/ GIMT_Encode4(1642051), // Rule ID 4599 //
     /* 1641970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1641973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1641978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1641981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1641984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1641987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1641990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1641993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1641996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642016 */     // MIs[0] policy
     /* 1642016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642026 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1642029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642050 */     // GIR_Coverage, 4599,
     /* 1642050 */     GIR_EraseRootFromParent_Done,
     /* 1642051 */   // Label 22579: @1642051
     /* 1642051 */   GIM_Try, /*On fail goto*//*Label 22580*/ GIMT_Encode4(1642137), // Rule ID 4608 //
     /* 1642056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1642067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1642070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1642073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1642076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642102 */     // MIs[0] policy
     /* 1642102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1642115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642136 */     // GIR_Coverage, 4608,
     /* 1642136 */     GIR_EraseRootFromParent_Done,
     /* 1642137 */   // Label 22580: @1642137
     /* 1642137 */   GIM_Try, /*On fail goto*//*Label 22581*/ GIMT_Encode4(1642223), // Rule ID 4609 //
     /* 1642142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1642153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1642156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1642159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1642162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1642165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642188 */     // MIs[0] policy
     /* 1642188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642198 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1642201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642222 */     // GIR_Coverage, 4609,
     /* 1642222 */     GIR_EraseRootFromParent_Done,
     /* 1642223 */   // Label 22581: @1642223
     /* 1642223 */   GIM_Try, /*On fail goto*//*Label 22582*/ GIMT_Encode4(1642309), // Rule ID 4618 //
     /* 1642228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1642239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1642242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1642245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1642248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642274 */     // MIs[0] policy
     /* 1642274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642284 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1642287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642308 */     // GIR_Coverage, 4618,
     /* 1642308 */     GIR_EraseRootFromParent_Done,
     /* 1642309 */   // Label 22582: @1642309
     /* 1642309 */   GIM_Try, /*On fail goto*//*Label 22583*/ GIMT_Encode4(1642395), // Rule ID 4619 //
     /* 1642314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1642325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1642328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1642331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1642334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1642337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1642344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642360 */     // MIs[0] policy
     /* 1642360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642370 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1642373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642394 */     // GIR_Coverage, 4619,
     /* 1642394 */     GIR_EraseRootFromParent_Done,
     /* 1642395 */   // Label 22583: @1642395
     /* 1642395 */   GIM_Try, /*On fail goto*//*Label 22584*/ GIMT_Encode4(1642481), // Rule ID 4628 //
     /* 1642400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1642411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1642414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1642417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1642420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1642423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642446 */     // MIs[0] policy
     /* 1642446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642456 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1642459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642480 */     // GIR_Coverage, 4628,
     /* 1642480 */     GIR_EraseRootFromParent_Done,
     /* 1642481 */   // Label 22584: @1642481
     /* 1642481 */   GIM_Try, /*On fail goto*//*Label 22585*/ GIMT_Encode4(1642567), // Rule ID 4629 //
     /* 1642486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1642497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1642500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1642503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1642506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1642509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1642516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1642524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1642528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642532 */     // MIs[0] policy
     /* 1642532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642542 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1642545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1642563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642566 */     // GIR_Coverage, 4629,
     /* 1642566 */     GIR_EraseRootFromParent_Done,
     /* 1642567 */   // Label 22585: @1642567
     /* 1642567 */   GIM_Try, /*On fail goto*//*Label 22586*/ GIMT_Encode4(1642653), // Rule ID 4638 //
     /* 1642572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1642583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1642586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1642589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1642592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642618 */     // MIs[0] policy
     /* 1642618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642628 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1642631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642652 */     // GIR_Coverage, 4638,
     /* 1642652 */     GIR_EraseRootFromParent_Done,
     /* 1642653 */   // Label 22586: @1642653
     /* 1642653 */   GIM_Try, /*On fail goto*//*Label 22587*/ GIMT_Encode4(1642739), // Rule ID 4639 //
     /* 1642658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1642669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1642672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1642675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1642678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1642681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642704 */     // MIs[0] policy
     /* 1642704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642714 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF4_MASK),
     /* 1642717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642738 */     // GIR_Coverage, 4639,
     /* 1642738 */     GIR_EraseRootFromParent_Done,
     /* 1642739 */   // Label 22587: @1642739
     /* 1642739 */   GIM_Try, /*On fail goto*//*Label 22588*/ GIMT_Encode4(1642825), // Rule ID 4648 //
     /* 1642744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1642764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642790 */     // MIs[0] policy
     /* 1642790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642800 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1642803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642824 */     // GIR_Coverage, 4648,
     /* 1642824 */     GIR_EraseRootFromParent_Done,
     /* 1642825 */   // Label 22588: @1642825
     /* 1642825 */   GIM_Try, /*On fail goto*//*Label 22589*/ GIMT_Encode4(1642911), // Rule ID 4649 //
     /* 1642830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1642833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1642841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1642844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1642847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1642850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1642853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1642856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1642860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642876 */     // MIs[0] policy
     /* 1642876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642886 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1642886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1642889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642910 */     // GIR_Coverage, 4649,
     /* 1642910 */     GIR_EraseRootFromParent_Done,
     /* 1642911 */   // Label 22589: @1642911
     /* 1642911 */   GIM_Try, /*On fail goto*//*Label 22590*/ GIMT_Encode4(1642997), // Rule ID 4658 //
     /* 1642916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1642919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1642924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1642927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1642930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1642933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1642936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1642939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1642942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1642946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1642954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1642958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1642962 */     // MIs[0] policy
     /* 1642962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1642965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1642972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1642972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1642975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1642977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1642979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1642981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1642983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1642985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1642990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1642993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1642995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1642996 */     // GIR_Coverage, 4658,
     /* 1642996 */     GIR_EraseRootFromParent_Done,
     /* 1642997 */   // Label 22590: @1642997
     /* 1642997 */   GIM_Try, /*On fail goto*//*Label 22591*/ GIMT_Encode4(1643083), // Rule ID 4659 //
     /* 1643002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1643013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1643016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1643019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1643022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643048 */     // MIs[0] policy
     /* 1643048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1643061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643082 */     // GIR_Coverage, 4659,
     /* 1643082 */     GIR_EraseRootFromParent_Done,
     /* 1643083 */   // Label 22591: @1643083
     /* 1643083 */   GIM_Try, /*On fail goto*//*Label 22592*/ GIMT_Encode4(1643169), // Rule ID 4668 //
     /* 1643088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1643099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1643102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1643105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1643108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643134 */     // MIs[0] policy
     /* 1643134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643144 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1643147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643168 */     // GIR_Coverage, 4668,
     /* 1643168 */     GIR_EraseRootFromParent_Done,
     /* 1643169 */   // Label 22592: @1643169
     /* 1643169 */   GIM_Try, /*On fail goto*//*Label 22593*/ GIMT_Encode4(1643255), // Rule ID 4669 //
     /* 1643174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1643185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1643188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1643191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1643194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643220 */     // MIs[0] policy
     /* 1643220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1643233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643254 */     // GIR_Coverage, 4669,
     /* 1643254 */     GIR_EraseRootFromParent_Done,
     /* 1643255 */   // Label 22593: @1643255
     /* 1643255 */   GIM_Try, /*On fail goto*//*Label 22594*/ GIMT_Encode4(1643341), // Rule ID 4678 //
     /* 1643260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1643263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1643271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1643274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1643277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1643280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643306 */     // MIs[0] policy
     /* 1643306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643316 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1643319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643340 */     // GIR_Coverage, 4678,
     /* 1643340 */     GIR_EraseRootFromParent_Done,
     /* 1643341 */   // Label 22594: @1643341
     /* 1643341 */   GIM_Try, /*On fail goto*//*Label 22595*/ GIMT_Encode4(1643427), // Rule ID 4679 //
     /* 1643346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1643349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1643357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1643360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1643363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1643366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1643369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643392 */     // MIs[0] policy
     /* 1643392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643402 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1643405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1643423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643426 */     // GIR_Coverage, 4679,
     /* 1643426 */     GIR_EraseRootFromParent_Done,
     /* 1643427 */   // Label 22595: @1643427
     /* 1643427 */   GIM_Try, /*On fail goto*//*Label 22596*/ GIMT_Encode4(1643513), // Rule ID 4688 //
     /* 1643432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1643443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1643446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1643449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1643452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643478 */     // MIs[0] policy
     /* 1643478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643488 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1643491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643512 */     // GIR_Coverage, 4688,
     /* 1643512 */     GIR_EraseRootFromParent_Done,
     /* 1643513 */   // Label 22596: @1643513
     /* 1643513 */   GIM_Try, /*On fail goto*//*Label 22597*/ GIMT_Encode4(1643599), // Rule ID 4689 //
     /* 1643518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1643529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1643532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1643535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1643538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1643541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1643548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643564 */     // MIs[0] policy
     /* 1643564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643574 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_MF2_MASK),
     /* 1643577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643598 */     // GIR_Coverage, 4689,
     /* 1643598 */     GIR_EraseRootFromParent_Done,
     /* 1643599 */   // Label 22597: @1643599
     /* 1643599 */   GIM_Try, /*On fail goto*//*Label 22598*/ GIMT_Encode4(1643685), // Rule ID 4698 //
     /* 1643604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1643624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643650 */     // MIs[0] policy
     /* 1643650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1643663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643684 */     // GIR_Coverage, 4698,
     /* 1643684 */     GIR_EraseRootFromParent_Done,
     /* 1643685 */   // Label 22598: @1643685
     /* 1643685 */   GIM_Try, /*On fail goto*//*Label 22599*/ GIMT_Encode4(1643771), // Rule ID 4699 //
     /* 1643690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1643701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1643704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1643707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1643710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1643713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1643720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1643732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643736 */     // MIs[0] policy
     /* 1643736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M1_MASK),
     /* 1643749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643770 */     // GIR_Coverage, 4699,
     /* 1643770 */     GIR_EraseRootFromParent_Done,
     /* 1643771 */   // Label 22599: @1643771
     /* 1643771 */   GIM_Try, /*On fail goto*//*Label 22600*/ GIMT_Encode4(1643857), // Rule ID 4708 //
     /* 1643776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1643796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643822 */     // MIs[0] policy
     /* 1643822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1643832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1643835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643856 */     // GIR_Coverage, 4708,
     /* 1643856 */     GIR_EraseRootFromParent_Done,
     /* 1643857 */   // Label 22600: @1643857
     /* 1643857 */   GIM_Try, /*On fail goto*//*Label 22601*/ GIMT_Encode4(1643943), // Rule ID 4709 //
     /* 1643862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1643865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1643873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1643876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1643879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1643882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1643885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1643888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1643892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1643904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643908 */     // MIs[0] policy
     /* 1643908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1643918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1643918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M2_MASK),
     /* 1643921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1643923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1643925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1643927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1643929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1643931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1643936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1643939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1643941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1643942 */     // GIR_Coverage, 4709,
     /* 1643942 */     GIR_EraseRootFromParent_Done,
     /* 1643943 */   // Label 22601: @1643943
     /* 1643943 */   GIM_Try, /*On fail goto*//*Label 22602*/ GIMT_Encode4(1644029), // Rule ID 4718 //
     /* 1643948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1643951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1643956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1643959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1643962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1643965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1643968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1643971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1643974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1643978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1643986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1643990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1643994 */     // MIs[0] policy
     /* 1643994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1643997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1644007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644028 */     // GIR_Coverage, 4718,
     /* 1644028 */     GIR_EraseRootFromParent_Done,
     /* 1644029 */   // Label 22602: @1644029
     /* 1644029 */   GIM_Try, /*On fail goto*//*Label 22603*/ GIMT_Encode4(1644115), // Rule ID 4719 //
     /* 1644034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1644037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1644045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1644048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1644051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1644054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1644064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1644072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644080 */     // MIs[0] policy
     /* 1644080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WV_M4_MASK),
     /* 1644093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1644111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644114 */     // GIR_Coverage, 4719,
     /* 1644114 */     GIR_EraseRootFromParent_Done,
     /* 1644115 */   // Label 22603: @1644115
     /* 1644115 */   GIM_Try, /*On fail goto*//*Label 22604*/ GIMT_Encode4(1644201), // Rule ID 4722 //
     /* 1644120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1644131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1644134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1644137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644166 */     // MIs[0] policy
     /* 1644166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644176 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1644179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644200 */     // GIR_Coverage, 4722,
     /* 1644200 */     GIR_EraseRootFromParent_Done,
     /* 1644201 */   // Label 22604: @1644201
     /* 1644201 */   GIM_Try, /*On fail goto*//*Label 22605*/ GIMT_Encode4(1644287), // Rule ID 4723 //
     /* 1644206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1644217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1644220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1644223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1644229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644252 */     // MIs[0] policy
     /* 1644252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644262 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF8_MASK),
     /* 1644265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644286 */     // GIR_Coverage, 4723,
     /* 1644286 */     GIR_EraseRootFromParent_Done,
     /* 1644287 */   // Label 22605: @1644287
     /* 1644287 */   GIM_Try, /*On fail goto*//*Label 22606*/ GIMT_Encode4(1644373), // Rule ID 4726 //
     /* 1644292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1644303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1644306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1644309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644338 */     // MIs[0] policy
     /* 1644338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644348 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1644351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644372 */     // GIR_Coverage, 4726,
     /* 1644372 */     GIR_EraseRootFromParent_Done,
     /* 1644373 */   // Label 22606: @1644373
     /* 1644373 */   GIM_Try, /*On fail goto*//*Label 22607*/ GIMT_Encode4(1644459), // Rule ID 4727 //
     /* 1644378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1644389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1644392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1644395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1644401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644424 */     // MIs[0] policy
     /* 1644424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644434 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1644437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644458 */     // GIR_Coverage, 4727,
     /* 1644458 */     GIR_EraseRootFromParent_Done,
     /* 1644459 */   // Label 22607: @1644459
     /* 1644459 */   GIM_Try, /*On fail goto*//*Label 22608*/ GIMT_Encode4(1644545), // Rule ID 4730 //
     /* 1644464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1644475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1644478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1644481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644510 */     // MIs[0] policy
     /* 1644510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644520 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1644523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644544 */     // GIR_Coverage, 4730,
     /* 1644544 */     GIR_EraseRootFromParent_Done,
     /* 1644545 */   // Label 22608: @1644545
     /* 1644545 */   GIM_Try, /*On fail goto*//*Label 22609*/ GIMT_Encode4(1644631), // Rule ID 4731 //
     /* 1644550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1644561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1644564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1644567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1644573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1644580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1644588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644596 */     // MIs[0] policy
     /* 1644596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644606 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11601:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1644609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644630 */     // GIR_Coverage, 4731,
     /* 1644630 */     GIR_EraseRootFromParent_Done,
     /* 1644631 */   // Label 22609: @1644631
     /* 1644631 */   GIM_Try, /*On fail goto*//*Label 22610*/ GIMT_Encode4(1644717), // Rule ID 4734 //
     /* 1644636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644682 */     // MIs[0] policy
     /* 1644682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1644695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644716 */     // GIR_Coverage, 4734,
     /* 1644716 */     GIR_EraseRootFromParent_Done,
     /* 1644717 */   // Label 22610: @1644717
     /* 1644717 */   GIM_Try, /*On fail goto*//*Label 22611*/ GIMT_Encode4(1644803), // Rule ID 4735 //
     /* 1644722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1644733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1644736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1644739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1644745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1644752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1644760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644768 */     // MIs[0] policy
     /* 1644768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644778 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1644781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644802 */     // GIR_Coverage, 4735,
     /* 1644802 */     GIR_EraseRootFromParent_Done,
     /* 1644803 */   // Label 22611: @1644803
     /* 1644803 */   GIM_Try, /*On fail goto*//*Label 22612*/ GIMT_Encode4(1644889), // Rule ID 4738 //
     /* 1644808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1644828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1644834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644854 */     // MIs[0] policy
     /* 1644854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644864 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1644864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1644867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644888 */     // GIR_Coverage, 4738,
     /* 1644888 */     GIR_EraseRootFromParent_Done,
     /* 1644889 */   // Label 22612: @1644889
     /* 1644889 */   GIM_Try, /*On fail goto*//*Label 22613*/ GIMT_Encode4(1644975), // Rule ID 4739 //
     /* 1644894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1644897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1644905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1644908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1644911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1644914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1644917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1644920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1644924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1644932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1644936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1644940 */     // MIs[0] policy
     /* 1644940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1644943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1644950 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1644950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1644953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1644955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1644957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1644959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1644961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1644963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1644968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1644971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1644973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1644974 */     // GIR_Coverage, 4739,
     /* 1644974 */     GIR_EraseRootFromParent_Done,
     /* 1644975 */   // Label 22613: @1644975
     /* 1644975 */   GIM_Try, /*On fail goto*//*Label 22614*/ GIMT_Encode4(1645061), // Rule ID 4742 //
     /* 1644980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1644983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1644988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1644991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1644994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1644997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645026 */     // MIs[0] policy
     /* 1645026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645036 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1645039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645060 */     // GIR_Coverage, 4742,
     /* 1645060 */     GIR_EraseRootFromParent_Done,
     /* 1645061 */   // Label 22614: @1645061
     /* 1645061 */   GIM_Try, /*On fail goto*//*Label 22615*/ GIMT_Encode4(1645147), // Rule ID 4743 //
     /* 1645066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1645077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1645080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1645083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1645089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645112 */     // MIs[0] policy
     /* 1645112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645122 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1645125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1645143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645146 */     // GIR_Coverage, 4743,
     /* 1645146 */     GIR_EraseRootFromParent_Done,
     /* 1645147 */   // Label 22615: @1645147
     /* 1645147 */   GIM_Try, /*On fail goto*//*Label 22616*/ GIMT_Encode4(1645233), // Rule ID 4746 //
     /* 1645152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1645163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1645166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1645169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645198 */     // MIs[0] policy
     /* 1645198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645208 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1645211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645232 */     // GIR_Coverage, 4746,
     /* 1645232 */     GIR_EraseRootFromParent_Done,
     /* 1645233 */   // Label 22616: @1645233
     /* 1645233 */   GIM_Try, /*On fail goto*//*Label 22617*/ GIMT_Encode4(1645319), // Rule ID 4747 //
     /* 1645238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1645249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1645252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1645255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1645261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645284 */     // MIs[0] policy
     /* 1645284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645294 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF4_MASK),
     /* 1645297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645318 */     // GIR_Coverage, 4747,
     /* 1645318 */     GIR_EraseRootFromParent_Done,
     /* 1645319 */   // Label 22617: @1645319
     /* 1645319 */   GIM_Try, /*On fail goto*//*Label 22618*/ GIMT_Encode4(1645405), // Rule ID 4750 //
     /* 1645324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1645335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1645338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1645341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645370 */     // MIs[0] policy
     /* 1645370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645380 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1645383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645404 */     // GIR_Coverage, 4750,
     /* 1645404 */     GIR_EraseRootFromParent_Done,
     /* 1645405 */   // Label 22618: @1645405
     /* 1645405 */   GIM_Try, /*On fail goto*//*Label 22619*/ GIMT_Encode4(1645491), // Rule ID 4751 //
     /* 1645410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1645421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1645424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1645427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1645433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1645440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1645448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645456 */     // MIs[0] policy
     /* 1645456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645466 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11601:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1645469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645490 */     // GIR_Coverage, 4751,
     /* 1645490 */     GIR_EraseRootFromParent_Done,
     /* 1645491 */   // Label 22619: @1645491
     /* 1645491 */   GIM_Try, /*On fail goto*//*Label 22620*/ GIMT_Encode4(1645577), // Rule ID 4754 //
     /* 1645496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645542 */     // MIs[0] policy
     /* 1645542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645552 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1645555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645576 */     // GIR_Coverage, 4754,
     /* 1645576 */     GIR_EraseRootFromParent_Done,
     /* 1645577 */   // Label 22620: @1645577
     /* 1645577 */   GIM_Try, /*On fail goto*//*Label 22621*/ GIMT_Encode4(1645663), // Rule ID 4755 //
     /* 1645582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1645593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1645596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1645599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1645605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1645612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1645620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645628 */     // MIs[0] policy
     /* 1645628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645638 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1645641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645662 */     // GIR_Coverage, 4755,
     /* 1645662 */     GIR_EraseRootFromParent_Done,
     /* 1645663 */   // Label 22621: @1645663
     /* 1645663 */   GIM_Try, /*On fail goto*//*Label 22622*/ GIMT_Encode4(1645749), // Rule ID 4758 //
     /* 1645668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645714 */     // MIs[0] policy
     /* 1645714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645724 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1645727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645748 */     // GIR_Coverage, 4758,
     /* 1645748 */     GIR_EraseRootFromParent_Done,
     /* 1645749 */   // Label 22622: @1645749
     /* 1645749 */   GIM_Try, /*On fail goto*//*Label 22623*/ GIMT_Encode4(1645835), // Rule ID 4759 //
     /* 1645754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1645765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1645768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1645771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1645777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1645784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1645792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645800 */     // MIs[0] policy
     /* 1645800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645810 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1645813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645834 */     // GIR_Coverage, 4759,
     /* 1645834 */     GIR_EraseRootFromParent_Done,
     /* 1645835 */   // Label 22623: @1645835
     /* 1645835 */   GIM_Try, /*On fail goto*//*Label 22624*/ GIMT_Encode4(1645921), // Rule ID 4762 //
     /* 1645840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1645843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1645860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1645866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645886 */     // MIs[0] policy
     /* 1645886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645896 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1645896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1645899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1645914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1645917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1645919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1645920 */     // GIR_Coverage, 4762,
     /* 1645920 */     GIR_EraseRootFromParent_Done,
     /* 1645921 */   // Label 22624: @1645921
     /* 1645921 */   GIM_Try, /*On fail goto*//*Label 22625*/ GIMT_Encode4(1646007), // Rule ID 4763 //
     /* 1645926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1645929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1645934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1645937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1645940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1645943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1645946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1645949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1645952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1645956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1645964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1645968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1645972 */     // MIs[0] policy
     /* 1645972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1645975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1645982 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1645982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1645985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1645987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1645989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1645991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1645993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1645995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1646003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646006 */     // GIR_Coverage, 4763,
     /* 1646006 */     GIR_EraseRootFromParent_Done,
     /* 1646007 */   // Label 22625: @1646007
     /* 1646007 */   GIM_Try, /*On fail goto*//*Label 22626*/ GIMT_Encode4(1646093), // Rule ID 4766 //
     /* 1646012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1646023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1646026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1646029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646058 */     // MIs[0] policy
     /* 1646058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646068 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1646071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646092 */     // GIR_Coverage, 4766,
     /* 1646092 */     GIR_EraseRootFromParent_Done,
     /* 1646093 */   // Label 22626: @1646093
     /* 1646093 */   GIM_Try, /*On fail goto*//*Label 22627*/ GIMT_Encode4(1646179), // Rule ID 4767 //
     /* 1646098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1646109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1646112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1646115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646144 */     // MIs[0] policy
     /* 1646144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646154 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11601:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_MF2_MASK),
     /* 1646157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646178 */     // GIR_Coverage, 4767,
     /* 1646178 */     GIR_EraseRootFromParent_Done,
     /* 1646179 */   // Label 22627: @1646179
     /* 1646179 */   GIM_Try, /*On fail goto*//*Label 22628*/ GIMT_Encode4(1646265), // Rule ID 4770 //
     /* 1646184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1646195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1646198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1646201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646230 */     // MIs[0] policy
     /* 1646230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1646243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646264 */     // GIR_Coverage, 4770,
     /* 1646264 */     GIR_EraseRootFromParent_Done,
     /* 1646265 */   // Label 22628: @1646265
     /* 1646265 */   GIM_Try, /*On fail goto*//*Label 22629*/ GIMT_Encode4(1646351), // Rule ID 4771 //
     /* 1646270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1646281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1646284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1646287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1646300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1646308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646316 */     // MIs[0] policy
     /* 1646316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11601:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M1_MASK),
     /* 1646329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646350 */     // GIR_Coverage, 4771,
     /* 1646350 */     GIR_EraseRootFromParent_Done,
     /* 1646351 */   // Label 22629: @1646351
     /* 1646351 */   GIM_Try, /*On fail goto*//*Label 22630*/ GIMT_Encode4(1646437), // Rule ID 4774 //
     /* 1646356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646402 */     // MIs[0] policy
     /* 1646402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1646415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646436 */     // GIR_Coverage, 4774,
     /* 1646436 */     GIR_EraseRootFromParent_Done,
     /* 1646437 */   // Label 22630: @1646437
     /* 1646437 */   GIM_Try, /*On fail goto*//*Label 22631*/ GIMT_Encode4(1646523), // Rule ID 4775 //
     /* 1646442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1646453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1646456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1646459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1646465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1646472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1646480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646488 */     // MIs[0] policy
     /* 1646488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11601:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M2_MASK),
     /* 1646501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646522 */     // GIR_Coverage, 4775,
     /* 1646522 */     GIR_EraseRootFromParent_Done,
     /* 1646523 */   // Label 22631: @1646523
     /* 1646523 */   GIM_Try, /*On fail goto*//*Label 22632*/ GIMT_Encode4(1646609), // Rule ID 4778 //
     /* 1646528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1646531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1646548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646574 */     // MIs[0] policy
     /* 1646574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1646587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646608 */     // GIR_Coverage, 4778,
     /* 1646608 */     GIR_EraseRootFromParent_Done,
     /* 1646609 */   // Label 22632: @1646609
     /* 1646609 */   GIM_Try, /*On fail goto*//*Label 22633*/ GIMT_Encode4(1646695), // Rule ID 4779 //
     /* 1646614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1646617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsub_w_mask),
     /* 1646622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1646625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1646628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1646631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1646634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1646637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1646644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1646652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1646656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646660 */     // MIs[0] policy
     /* 1646660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11601:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSUB_WX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSUB_WX_M4_MASK),
     /* 1646673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1646691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646694 */     // GIR_Coverage, 4779,
     /* 1646694 */     GIR_EraseRootFromParent_Done,
     /* 1646695 */   // Label 22633: @1646695
     /* 1646695 */   GIM_Try, /*On fail goto*//*Label 22634*/ GIMT_Encode4(1646781), // Rule ID 5656 //
     /* 1646700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1646708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1646711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1646714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1646717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646746 */     // MIs[0] policy
     /* 1646746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1646759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646780 */     // GIR_Coverage, 5656,
     /* 1646780 */     GIR_EraseRootFromParent_Done,
     /* 1646781 */   // Label 22634: @1646781
     /* 1646781 */   GIM_Try, /*On fail goto*//*Label 22635*/ GIMT_Encode4(1646867), // Rule ID 5657 //
     /* 1646786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1646794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1646797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1646800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1646803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1646806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1646809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646832 */     // MIs[0] policy
     /* 1646832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1646842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF8_MASK),
     /* 1646845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646866 */     // GIR_Coverage, 5657,
     /* 1646866 */     GIR_EraseRootFromParent_Done,
     /* 1646867 */   // Label 22635: @1646867
     /* 1646867 */   GIM_Try, /*On fail goto*//*Label 22636*/ GIMT_Encode4(1646953), // Rule ID 5660 //
     /* 1646872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1646875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1646880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1646883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1646886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1646889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1646898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1646918 */     // MIs[0] policy
     /* 1646918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1646921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1646928 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1646928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1646931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1646933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1646935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1646937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1646939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1646941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1646946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1646949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1646951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1646952 */     // GIR_Coverage, 5660,
     /* 1646952 */     GIR_EraseRootFromParent_Done,
     /* 1646953 */   // Label 22636: @1646953
     /* 1646953 */   GIM_Try, /*On fail goto*//*Label 22637*/ GIMT_Encode4(1647039), // Rule ID 5661 //
     /* 1646958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1646961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1646966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1646969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1646972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1646975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1646978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1646981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1646984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1646988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1646996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647004 */     // MIs[0] policy
     /* 1647004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1647017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647038 */     // GIR_Coverage, 5661,
     /* 1647038 */     GIR_EraseRootFromParent_Done,
     /* 1647039 */   // Label 22637: @1647039
     /* 1647039 */   GIM_Try, /*On fail goto*//*Label 22638*/ GIMT_Encode4(1647125), // Rule ID 5664 //
     /* 1647044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1647055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1647058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1647061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1647064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647090 */     // MIs[0] policy
     /* 1647090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647124 */     // GIR_Coverage, 5664,
     /* 1647124 */     GIR_EraseRootFromParent_Done,
     /* 1647125 */   // Label 22638: @1647125
     /* 1647125 */   GIM_Try, /*On fail goto*//*Label 22639*/ GIMT_Encode4(1647211), // Rule ID 5665 //
     /* 1647130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1647141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1647144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1647147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1647150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647176 */     // MIs[0] policy
     /* 1647176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647210 */     // GIR_Coverage, 5665,
     /* 1647210 */     GIR_EraseRootFromParent_Done,
     /* 1647211 */   // Label 22639: @1647211
     /* 1647211 */   GIM_Try, /*On fail goto*//*Label 22640*/ GIMT_Encode4(1647297), // Rule ID 5668 //
     /* 1647216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1647227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1647230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1647233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647262 */     // MIs[0] policy
     /* 1647262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1647275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647296 */     // GIR_Coverage, 5668,
     /* 1647296 */     GIR_EraseRootFromParent_Done,
     /* 1647297 */   // Label 22640: @1647297
     /* 1647297 */   GIM_Try, /*On fail goto*//*Label 22641*/ GIMT_Encode4(1647383), // Rule ID 5669 //
     /* 1647302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1647313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1647316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1647319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1647322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647348 */     // MIs[0] policy
     /* 1647348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF4_MASK),
     /* 1647361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647382 */     // GIR_Coverage, 5669,
     /* 1647382 */     GIR_EraseRootFromParent_Done,
     /* 1647383 */   // Label 22641: @1647383
     /* 1647383 */   GIM_Try, /*On fail goto*//*Label 22642*/ GIMT_Encode4(1647469), // Rule ID 5672 //
     /* 1647388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1647399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1647402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1647405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647434 */     // MIs[0] policy
     /* 1647434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647468 */     // GIR_Coverage, 5672,
     /* 1647468 */     GIR_EraseRootFromParent_Done,
     /* 1647469 */   // Label 22642: @1647469
     /* 1647469 */   GIM_Try, /*On fail goto*//*Label 22643*/ GIMT_Encode4(1647555), // Rule ID 5673 //
     /* 1647474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1647485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1647488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1647491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1647494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1647497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647520 */     // MIs[0] policy
     /* 1647520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647554 */     // GIR_Coverage, 5673,
     /* 1647554 */     GIR_EraseRootFromParent_Done,
     /* 1647555 */   // Label 22643: @1647555
     /* 1647555 */   GIM_Try, /*On fail goto*//*Label 22644*/ GIMT_Encode4(1647641), // Rule ID 5676 //
     /* 1647560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647606 */     // MIs[0] policy
     /* 1647606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647640 */     // GIR_Coverage, 5676,
     /* 1647640 */     GIR_EraseRootFromParent_Done,
     /* 1647641 */   // Label 22644: @1647641
     /* 1647641 */   GIM_Try, /*On fail goto*//*Label 22645*/ GIMT_Encode4(1647727), // Rule ID 5677 //
     /* 1647646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1647657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1647660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1647663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1647666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1647669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647692 */     // MIs[0] policy
     /* 1647692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_MF2_MASK),
     /* 1647705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1647723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647726 */     // GIR_Coverage, 5677,
     /* 1647726 */     GIR_EraseRootFromParent_Done,
     /* 1647727 */   // Label 22645: @1647727
     /* 1647727 */   GIM_Try, /*On fail goto*//*Label 22646*/ GIMT_Encode4(1647813), // Rule ID 5680 //
     /* 1647732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1647743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1647746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1647749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647778 */     // MIs[0] policy
     /* 1647778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1647791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647812 */     // GIR_Coverage, 5680,
     /* 1647812 */     GIR_EraseRootFromParent_Done,
     /* 1647813 */   // Label 22646: @1647813
     /* 1647813 */   GIM_Try, /*On fail goto*//*Label 22647*/ GIMT_Encode4(1647899), // Rule ID 5681 //
     /* 1647818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1647829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1647832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1647835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1647838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1647841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1647844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647864 */     // MIs[0] policy
     /* 1647864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1647874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1647877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1647895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647898 */     // GIR_Coverage, 5681,
     /* 1647898 */     GIR_EraseRootFromParent_Done,
     /* 1647899 */   // Label 22647: @1647899
     /* 1647899 */   GIM_Try, /*On fail goto*//*Label 22648*/ GIMT_Encode4(1647985), // Rule ID 5684 //
     /* 1647904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1647907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1647915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1647918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1647921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1647924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1647927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1647930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1647934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1647946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1647950 */     // MIs[0] policy
     /* 1647950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1647953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1647960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1647960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1647963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1647965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1647967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1647969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1647971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1647973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1647978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1647981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1647983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1647984 */     // GIR_Coverage, 5684,
     /* 1647984 */     GIR_EraseRootFromParent_Done,
     /* 1647985 */   // Label 22648: @1647985
     /* 1647985 */   GIM_Try, /*On fail goto*//*Label 22649*/ GIMT_Encode4(1648071), // Rule ID 5685 //
     /* 1647990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1647993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1647998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1648001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1648004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1648007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1648010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1648013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648036 */     // MIs[0] policy
     /* 1648036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1648049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1648067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648070 */     // GIR_Coverage, 5685,
     /* 1648070 */     GIR_EraseRootFromParent_Done,
     /* 1648071 */   // Label 22649: @1648071
     /* 1648071 */   GIM_Try, /*On fail goto*//*Label 22650*/ GIMT_Encode4(1648157), // Rule ID 5688 //
     /* 1648076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1648087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1648090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1648093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1648096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648122 */     // MIs[0] policy
     /* 1648122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1648135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648156 */     // GIR_Coverage, 5688,
     /* 1648156 */     GIR_EraseRootFromParent_Done,
     /* 1648157 */   // Label 22650: @1648157
     /* 1648157 */   GIM_Try, /*On fail goto*//*Label 22651*/ GIMT_Encode4(1648243), // Rule ID 5689 //
     /* 1648162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1648173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1648176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1648179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1648182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1648185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648208 */     // MIs[0] policy
     /* 1648208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1648221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1648239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648242 */     // GIR_Coverage, 5689,
     /* 1648242 */     GIR_EraseRootFromParent_Done,
     /* 1648243 */   // Label 22651: @1648243
     /* 1648243 */   GIM_Try, /*On fail goto*//*Label 22652*/ GIMT_Encode4(1648329), // Rule ID 5692 //
     /* 1648248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1648251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1648268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648294 */     // MIs[0] policy
     /* 1648294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1648307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1648325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648328 */     // GIR_Coverage, 5692,
     /* 1648328 */     GIR_EraseRootFromParent_Done,
     /* 1648329 */   // Label 22652: @1648329
     /* 1648329 */   GIM_Try, /*On fail goto*//*Label 22653*/ GIMT_Encode4(1648415), // Rule ID 5693 //
     /* 1648334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1648337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1648345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1648348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1648351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1648354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1648357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1648364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1648376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648380 */     // MIs[0] policy
     /* 1648380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M1_MASK),
     /* 1648393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1648411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648414 */     // GIR_Coverage, 5693,
     /* 1648414 */     GIR_EraseRootFromParent_Done,
     /* 1648415 */   // Label 22653: @1648415
     /* 1648415 */   GIM_Try, /*On fail goto*//*Label 22654*/ GIMT_Encode4(1648501), // Rule ID 5696 //
     /* 1648420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1648431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1648434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1648437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648466 */     // MIs[0] policy
     /* 1648466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1648479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648500 */     // GIR_Coverage, 5696,
     /* 1648500 */     GIR_EraseRootFromParent_Done,
     /* 1648501 */   // Label 22654: @1648501
     /* 1648501 */   GIM_Try, /*On fail goto*//*Label 22655*/ GIMT_Encode4(1648587), // Rule ID 5697 //
     /* 1648506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1648517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1648520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1648523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1648526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1648529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648552 */     // MIs[0] policy
     /* 1648552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1648565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648586 */     // GIR_Coverage, 5697,
     /* 1648586 */     GIR_EraseRootFromParent_Done,
     /* 1648587 */   // Label 22655: @1648587
     /* 1648587 */   GIM_Try, /*On fail goto*//*Label 22656*/ GIMT_Encode4(1648673), // Rule ID 5700 //
     /* 1648592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1648603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1648606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1648609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1648612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648638 */     // MIs[0] policy
     /* 1648638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648648 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1648651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648672 */     // GIR_Coverage, 5700,
     /* 1648672 */     GIR_EraseRootFromParent_Done,
     /* 1648673 */   // Label 22656: @1648673
     /* 1648673 */   GIM_Try, /*On fail goto*//*Label 22657*/ GIMT_Encode4(1648759), // Rule ID 5701 //
     /* 1648678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1648689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1648692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1648695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1648698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1648701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1648708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1648720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648724 */     // MIs[0] policy
     /* 1648724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1648737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648758 */     // GIR_Coverage, 5701,
     /* 1648758 */     GIR_EraseRootFromParent_Done,
     /* 1648759 */   // Label 22657: @1648759
     /* 1648759 */   GIM_Try, /*On fail goto*//*Label 22658*/ GIMT_Encode4(1648845), // Rule ID 5704 //
     /* 1648764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1648775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1648778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1648781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1648784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1648787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648810 */     // MIs[0] policy
     /* 1648810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648820 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1648823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648844 */     // GIR_Coverage, 5704,
     /* 1648844 */     GIR_EraseRootFromParent_Done,
     /* 1648845 */   // Label 22658: @1648845
     /* 1648845 */   GIM_Try, /*On fail goto*//*Label 22659*/ GIMT_Encode4(1648931), // Rule ID 5705 //
     /* 1648850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1648853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1648861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1648864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1648867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1648870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1648873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1648876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1648880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1648892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648896 */     // MIs[0] policy
     /* 1648896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1648906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1648909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1648915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1648917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1648919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1648924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1648927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1648929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1648930 */     // GIR_Coverage, 5705,
     /* 1648930 */     GIR_EraseRootFromParent_Done,
     /* 1648931 */   // Label 22659: @1648931
     /* 1648931 */   GIM_Try, /*On fail goto*//*Label 22660*/ GIMT_Encode4(1649017), // Rule ID 5708 //
     /* 1648936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1648939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1648944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1648947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1648950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1648953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1648956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1648959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1648962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1648966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1648978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1648982 */     // MIs[0] policy
     /* 1648982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1648985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1648992 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1648992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1648995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1648997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1648999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649016 */     // GIR_Coverage, 5708,
     /* 1649016 */     GIR_EraseRootFromParent_Done,
     /* 1649017 */   // Label 22660: @1649017
     /* 1649017 */   GIM_Try, /*On fail goto*//*Label 22661*/ GIMT_Encode4(1649103), // Rule ID 5709 //
     /* 1649022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1649033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1649036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1649039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1649042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649068 */     // MIs[0] policy
     /* 1649068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1649081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649102 */     // GIR_Coverage, 5709,
     /* 1649102 */     GIR_EraseRootFromParent_Done,
     /* 1649103 */   // Label 22661: @1649103
     /* 1649103 */   GIM_Try, /*On fail goto*//*Label 22662*/ GIMT_Encode4(1649189), // Rule ID 5712 //
     /* 1649108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649154 */     // MIs[0] policy
     /* 1649154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1649167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649188 */     // GIR_Coverage, 5712,
     /* 1649188 */     GIR_EraseRootFromParent_Done,
     /* 1649189 */   // Label 22662: @1649189
     /* 1649189 */   GIM_Try, /*On fail goto*//*Label 22663*/ GIMT_Encode4(1649275), // Rule ID 5713 //
     /* 1649194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1649205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1649208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1649211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1649214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649240 */     // MIs[0] policy
     /* 1649240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649250 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1649253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649274 */     // GIR_Coverage, 5713,
     /* 1649274 */     GIR_EraseRootFromParent_Done,
     /* 1649275 */   // Label 22663: @1649275
     /* 1649275 */   GIM_Try, /*On fail goto*//*Label 22664*/ GIMT_Encode4(1649361), // Rule ID 5716 //
     /* 1649280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1649300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649326 */     // MIs[0] policy
     /* 1649326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1649339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649360 */     // GIR_Coverage, 5716,
     /* 1649360 */     GIR_EraseRootFromParent_Done,
     /* 1649361 */   // Label 22664: @1649361
     /* 1649361 */   GIM_Try, /*On fail goto*//*Label 22665*/ GIMT_Encode4(1649447), // Rule ID 5717 //
     /* 1649366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1649377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1649380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1649383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1649386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1649389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649412 */     // MIs[0] policy
     /* 1649412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1649425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1649443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649446 */     // GIR_Coverage, 5717,
     /* 1649446 */     GIR_EraseRootFromParent_Done,
     /* 1649447 */   // Label 22665: @1649447
     /* 1649447 */   GIM_Try, /*On fail goto*//*Label 22666*/ GIMT_Encode4(1649533), // Rule ID 5720 //
     /* 1649452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1649472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649498 */     // MIs[0] policy
     /* 1649498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1649511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649532 */     // GIR_Coverage, 5720,
     /* 1649532 */     GIR_EraseRootFromParent_Done,
     /* 1649533 */   // Label 22666: @1649533
     /* 1649533 */   GIM_Try, /*On fail goto*//*Label 22667*/ GIMT_Encode4(1649619), // Rule ID 5721 //
     /* 1649538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1649549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1649552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1649555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1649558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1649561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1649580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649584 */     // MIs[0] policy
     /* 1649584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1649597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649618 */     // GIR_Coverage, 5721,
     /* 1649618 */     GIR_EraseRootFromParent_Done,
     /* 1649619 */   // Label 22667: @1649619
     /* 1649619 */   GIM_Try, /*On fail goto*//*Label 22668*/ GIMT_Encode4(1649705), // Rule ID 5724 //
     /* 1649624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649670 */     // MIs[0] policy
     /* 1649670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1649683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649704 */     // GIR_Coverage, 5724,
     /* 1649704 */     GIR_EraseRootFromParent_Done,
     /* 1649705 */   // Label 22668: @1649705
     /* 1649705 */   GIM_Try, /*On fail goto*//*Label 22669*/ GIMT_Encode4(1649791), // Rule ID 5725 //
     /* 1649710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1649721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1649724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1649727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1649730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1649733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1649740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1649752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649756 */     // MIs[0] policy
     /* 1649756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1649769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649790 */     // GIR_Coverage, 5725,
     /* 1649790 */     GIR_EraseRootFromParent_Done,
     /* 1649791 */   // Label 22669: @1649791
     /* 1649791 */   GIM_Try, /*On fail goto*//*Label 22670*/ GIMT_Encode4(1649877), // Rule ID 5728 //
     /* 1649796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1649799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1649816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649842 */     // MIs[0] policy
     /* 1649842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1649852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1649855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649876 */     // GIR_Coverage, 5728,
     /* 1649876 */     GIR_EraseRootFromParent_Done,
     /* 1649877 */   // Label 22670: @1649877
     /* 1649877 */   GIM_Try, /*On fail goto*//*Label 22671*/ GIMT_Encode4(1649963), // Rule ID 5729 //
     /* 1649882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1649885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1649893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1649896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1649899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1649902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1649905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1649908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1649912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1649924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1649928 */     // MIs[0] policy
     /* 1649928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1649931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1649938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1649938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1649941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1649943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1649945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1649947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1649949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1649951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1649956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1649959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1649961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1649962 */     // GIR_Coverage, 5729,
     /* 1649962 */     GIR_EraseRootFromParent_Done,
     /* 1649963 */   // Label 22671: @1649963
     /* 1649963 */   GIM_Try, /*On fail goto*//*Label 22672*/ GIMT_Encode4(1650049), // Rule ID 5732 //
     /* 1649968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1649971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1649976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1649979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1649982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1649985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1649988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1649991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1649994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1649998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650014 */     // MIs[0] policy
     /* 1650014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1650027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650048 */     // GIR_Coverage, 5732,
     /* 1650048 */     GIR_EraseRootFromParent_Done,
     /* 1650049 */   // Label 22672: @1650049
     /* 1650049 */   GIM_Try, /*On fail goto*//*Label 22673*/ GIMT_Encode4(1650135), // Rule ID 5733 //
     /* 1650054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1650057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1650065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1650068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1650071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1650074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1650084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1650096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650100 */     // MIs[0] policy
     /* 1650100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M2_MASK),
     /* 1650113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650134 */     // GIR_Coverage, 5733,
     /* 1650134 */     GIR_EraseRootFromParent_Done,
     /* 1650135 */   // Label 22673: @1650135
     /* 1650135 */   GIM_Try, /*On fail goto*//*Label 22674*/ GIMT_Encode4(1650221), // Rule ID 5736 //
     /* 1650140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1650143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1650160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650186 */     // MIs[0] policy
     /* 1650186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1650199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650220 */     // GIR_Coverage, 5736,
     /* 1650220 */     GIR_EraseRootFromParent_Done,
     /* 1650221 */   // Label 22674: @1650221
     /* 1650221 */   GIM_Try, /*On fail goto*//*Label 22675*/ GIMT_Encode4(1650307), // Rule ID 5737 //
     /* 1650226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1650229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1650237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1650240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1650243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1650246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1650256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1650268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650272 */     // MIs[0] policy
     /* 1650272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M4_MASK),
     /* 1650285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650306 */     // GIR_Coverage, 5737,
     /* 1650306 */     GIR_EraseRootFromParent_Done,
     /* 1650307 */   // Label 22675: @1650307
     /* 1650307 */   GIM_Try, /*On fail goto*//*Label 22676*/ GIMT_Encode4(1650393), // Rule ID 5740 //
     /* 1650312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1650315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1650332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650358 */     // MIs[0] policy
     /* 1650358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1650371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650392 */     // GIR_Coverage, 5740,
     /* 1650392 */     GIR_EraseRootFromParent_Done,
     /* 1650393 */   // Label 22676: @1650393
     /* 1650393 */   GIM_Try, /*On fail goto*//*Label 22677*/ GIMT_Encode4(1650479), // Rule ID 5741 //
     /* 1650398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1650401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1650409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1650412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1650415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1650418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1650421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1650428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1650440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650444 */     // MIs[0] policy
     /* 1650444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VV_M8_MASK),
     /* 1650457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1650475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650478 */     // GIR_Coverage, 5741,
     /* 1650478 */     GIR_EraseRootFromParent_Done,
     /* 1650479 */   // Label 22677: @1650479
     /* 1650479 */   GIM_Try, /*On fail goto*//*Label 22678*/ GIMT_Encode4(1650565), // Rule ID 5744 //
     /* 1650484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1650495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1650498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1650501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650530 */     // MIs[0] policy
     /* 1650530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1650543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650564 */     // GIR_Coverage, 5744,
     /* 1650564 */     GIR_EraseRootFromParent_Done,
     /* 1650565 */   // Label 22678: @1650565
     /* 1650565 */   GIM_Try, /*On fail goto*//*Label 22679*/ GIMT_Encode4(1650651), // Rule ID 5745 //
     /* 1650570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1650581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1650584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1650587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1650593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650616 */     // MIs[0] policy
     /* 1650616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF8_MASK),
     /* 1650629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650650 */     // GIR_Coverage, 5745,
     /* 1650650 */     GIR_EraseRootFromParent_Done,
     /* 1650651 */   // Label 22679: @1650651
     /* 1650651 */   GIM_Try, /*On fail goto*//*Label 22680*/ GIMT_Encode4(1650737), // Rule ID 5748 //
     /* 1650656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1650667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1650670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1650673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650702 */     // MIs[0] policy
     /* 1650702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1650715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650736 */     // GIR_Coverage, 5748,
     /* 1650736 */     GIR_EraseRootFromParent_Done,
     /* 1650737 */   // Label 22680: @1650737
     /* 1650737 */   GIM_Try, /*On fail goto*//*Label 22681*/ GIMT_Encode4(1650823), // Rule ID 5749 //
     /* 1650742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1650753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1650756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1650759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1650765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650788 */     // MIs[0] policy
     /* 1650788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1650801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650822 */     // GIR_Coverage, 5749,
     /* 1650822 */     GIR_EraseRootFromParent_Done,
     /* 1650823 */   // Label 22681: @1650823
     /* 1650823 */   GIM_Try, /*On fail goto*//*Label 22682*/ GIMT_Encode4(1650909), // Rule ID 5752 //
     /* 1650828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1650831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1650839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1650842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1650845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1650848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1650854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650874 */     // MIs[0] policy
     /* 1650874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1650884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1650887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650908 */     // GIR_Coverage, 5752,
     /* 1650908 */     GIR_EraseRootFromParent_Done,
     /* 1650909 */   // Label 22682: @1650909
     /* 1650909 */   GIM_Try, /*On fail goto*//*Label 22683*/ GIMT_Encode4(1650995), // Rule ID 5753 //
     /* 1650914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1650917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1650922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1650925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1650928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1650931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1650934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1650937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1650940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1650944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1650952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1650956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1650960 */     // MIs[0] policy
     /* 1650960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1650963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1650970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1650970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1650973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1650975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1650977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1650979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1650981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1650983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1650988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1650991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1650993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1650994 */     // GIR_Coverage, 5753,
     /* 1650994 */     GIR_EraseRootFromParent_Done,
     /* 1650995 */   // Label 22683: @1650995
     /* 1650995 */   GIM_Try, /*On fail goto*//*Label 22684*/ GIMT_Encode4(1651081), // Rule ID 5756 //
     /* 1651000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651046 */     // MIs[0] policy
     /* 1651046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1651059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651080 */     // GIR_Coverage, 5756,
     /* 1651080 */     GIR_EraseRootFromParent_Done,
     /* 1651081 */   // Label 22684: @1651081
     /* 1651081 */   GIM_Try, /*On fail goto*//*Label 22685*/ GIMT_Encode4(1651167), // Rule ID 5757 //
     /* 1651086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1651097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1651100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1651103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651132 */     // MIs[0] policy
     /* 1651132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF4_MASK),
     /* 1651145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651166 */     // GIR_Coverage, 5757,
     /* 1651166 */     GIR_EraseRootFromParent_Done,
     /* 1651167 */   // Label 22685: @1651167
     /* 1651167 */   GIM_Try, /*On fail goto*//*Label 22686*/ GIMT_Encode4(1651253), // Rule ID 5760 //
     /* 1651172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651218 */     // MIs[0] policy
     /* 1651218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1651231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651252 */     // GIR_Coverage, 5760,
     /* 1651252 */     GIR_EraseRootFromParent_Done,
     /* 1651253 */   // Label 22686: @1651253
     /* 1651253 */   GIM_Try, /*On fail goto*//*Label 22687*/ GIMT_Encode4(1651339), // Rule ID 5761 //
     /* 1651258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1651269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1651272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1651275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651304 */     // MIs[0] policy
     /* 1651304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1651317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651338 */     // GIR_Coverage, 5761,
     /* 1651338 */     GIR_EraseRootFromParent_Done,
     /* 1651339 */   // Label 22687: @1651339
     /* 1651339 */   GIM_Try, /*On fail goto*//*Label 22688*/ GIMT_Encode4(1651425), // Rule ID 5764 //
     /* 1651344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651390 */     // MIs[0] policy
     /* 1651390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1651403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651424 */     // GIR_Coverage, 5764,
     /* 1651424 */     GIR_EraseRootFromParent_Done,
     /* 1651425 */   // Label 22688: @1651425
     /* 1651425 */   GIM_Try, /*On fail goto*//*Label 22689*/ GIMT_Encode4(1651511), // Rule ID 5765 //
     /* 1651430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1651441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1651444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1651447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1651453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651476 */     // MIs[0] policy
     /* 1651476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_MF2_MASK),
     /* 1651489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651510 */     // GIR_Coverage, 5765,
     /* 1651510 */     GIR_EraseRootFromParent_Done,
     /* 1651511 */   // Label 22689: @1651511
     /* 1651511 */   GIM_Try, /*On fail goto*//*Label 22690*/ GIMT_Encode4(1651597), // Rule ID 5768 //
     /* 1651516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1651527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1651530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1651533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651562 */     // MIs[0] policy
     /* 1651562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1651575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651596 */     // GIR_Coverage, 5768,
     /* 1651596 */     GIR_EraseRootFromParent_Done,
     /* 1651597 */   // Label 22690: @1651597
     /* 1651597 */   GIM_Try, /*On fail goto*//*Label 22691*/ GIMT_Encode4(1651683), // Rule ID 5769 //
     /* 1651602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1651613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1651616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1651619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1651625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651648 */     // MIs[0] policy
     /* 1651648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11088:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1651661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1651679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651682 */     // GIR_Coverage, 5769,
     /* 1651682 */     GIR_EraseRootFromParent_Done,
     /* 1651683 */   // Label 22691: @1651683
     /* 1651683 */   GIM_Try, /*On fail goto*//*Label 22692*/ GIMT_Encode4(1651769), // Rule ID 5772 //
     /* 1651688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651734 */     // MIs[0] policy
     /* 1651734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1651747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651768 */     // GIR_Coverage, 5772,
     /* 1651768 */     GIR_EraseRootFromParent_Done,
     /* 1651769 */   // Label 22692: @1651769
     /* 1651769 */   GIM_Try, /*On fail goto*//*Label 22693*/ GIMT_Encode4(1651855), // Rule ID 5773 //
     /* 1651774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1651785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1651788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1651791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1651797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651820 */     // MIs[0] policy
     /* 1651820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11088:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1651830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1651833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1651851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651854 */     // GIR_Coverage, 5773,
     /* 1651854 */     GIR_EraseRootFromParent_Done,
     /* 1651855 */   // Label 22693: @1651855
     /* 1651855 */   GIM_Try, /*On fail goto*//*Label 22694*/ GIMT_Encode4(1651941), // Rule ID 5776 //
     /* 1651860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1651863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1651871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1651874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1651877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1651880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1651886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651906 */     // MIs[0] policy
     /* 1651906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1651916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1651916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1651919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1651921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1651923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1651925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1651927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1651929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1651934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1651937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1651939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1651940 */     // GIR_Coverage, 5776,
     /* 1651940 */     GIR_EraseRootFromParent_Done,
     /* 1651941 */   // Label 22694: @1651941
     /* 1651941 */   GIM_Try, /*On fail goto*//*Label 22695*/ GIMT_Encode4(1652027), // Rule ID 5777 //
     /* 1651946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1651949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1651954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1651957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1651960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1651963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1651966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1651969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1651972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1651976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1651984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1651988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1651992 */     // MIs[0] policy
     /* 1651992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1651995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11088:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1652005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1652023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652026 */     // GIR_Coverage, 5777,
     /* 1652026 */     GIR_EraseRootFromParent_Done,
     /* 1652027 */   // Label 22695: @1652027
     /* 1652027 */   GIM_Try, /*On fail goto*//*Label 22696*/ GIMT_Encode4(1652113), // Rule ID 5780 //
     /* 1652032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1652035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652078 */     // MIs[0] policy
     /* 1652078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1652091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1652109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652112 */     // GIR_Coverage, 5780,
     /* 1652112 */     GIR_EraseRootFromParent_Done,
     /* 1652113 */   // Label 22696: @1652113
     /* 1652113 */   GIM_Try, /*On fail goto*//*Label 22697*/ GIMT_Encode4(1652199), // Rule ID 5781 //
     /* 1652118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1652121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1652129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1652132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1652135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1652141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1652148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1652156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652164 */     // MIs[0] policy
     /* 1652164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11088:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M1_MASK),
     /* 1652177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1652195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652198 */     // GIR_Coverage, 5781,
     /* 1652198 */     GIR_EraseRootFromParent_Done,
     /* 1652199 */   // Label 22697: @1652199
     /* 1652199 */   GIM_Try, /*On fail goto*//*Label 22698*/ GIMT_Encode4(1652285), // Rule ID 5784 //
     /* 1652204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1652215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1652218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1652221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652250 */     // MIs[0] policy
     /* 1652250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1652263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652284 */     // GIR_Coverage, 5784,
     /* 1652284 */     GIR_EraseRootFromParent_Done,
     /* 1652285 */   // Label 22698: @1652285
     /* 1652285 */   GIM_Try, /*On fail goto*//*Label 22699*/ GIMT_Encode4(1652371), // Rule ID 5785 //
     /* 1652290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1652301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1652304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1652307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652336 */     // MIs[0] policy
     /* 1652336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1652349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652370 */     // GIR_Coverage, 5785,
     /* 1652370 */     GIR_EraseRootFromParent_Done,
     /* 1652371 */   // Label 22699: @1652371
     /* 1652371 */   GIM_Try, /*On fail goto*//*Label 22700*/ GIMT_Encode4(1652457), // Rule ID 5788 //
     /* 1652376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1652387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1652390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1652393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652422 */     // MIs[0] policy
     /* 1652422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1652435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652456 */     // GIR_Coverage, 5788,
     /* 1652456 */     GIR_EraseRootFromParent_Done,
     /* 1652457 */   // Label 22700: @1652457
     /* 1652457 */   GIM_Try, /*On fail goto*//*Label 22701*/ GIMT_Encode4(1652543), // Rule ID 5789 //
     /* 1652462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1652473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1652476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1652479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1652485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652508 */     // MIs[0] policy
     /* 1652508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1652521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652542 */     // GIR_Coverage, 5789,
     /* 1652542 */     GIR_EraseRootFromParent_Done,
     /* 1652543 */   // Label 22701: @1652543
     /* 1652543 */   GIM_Try, /*On fail goto*//*Label 22702*/ GIMT_Encode4(1652629), // Rule ID 5792 //
     /* 1652548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1652559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1652562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1652565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1652571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652594 */     // MIs[0] policy
     /* 1652594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1652607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652628 */     // GIR_Coverage, 5792,
     /* 1652628 */     GIR_EraseRootFromParent_Done,
     /* 1652629 */   // Label 22702: @1652629
     /* 1652629 */   GIM_Try, /*On fail goto*//*Label 22703*/ GIMT_Encode4(1652715), // Rule ID 5793 //
     /* 1652634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1652645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1652648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1652651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1652657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1652664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1652672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652680 */     // MIs[0] policy
     /* 1652680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1652693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1652711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652714 */     // GIR_Coverage, 5793,
     /* 1652714 */     GIR_EraseRootFromParent_Done,
     /* 1652715 */   // Label 22703: @1652715
     /* 1652715 */   GIM_Try, /*On fail goto*//*Label 22704*/ GIMT_Encode4(1652801), // Rule ID 5796 //
     /* 1652720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1652731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1652734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1652737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652766 */     // MIs[0] policy
     /* 1652766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1652779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652800 */     // GIR_Coverage, 5796,
     /* 1652800 */     GIR_EraseRootFromParent_Done,
     /* 1652801 */   // Label 22704: @1652801
     /* 1652801 */   GIM_Try, /*On fail goto*//*Label 22705*/ GIMT_Encode4(1652887), // Rule ID 5797 //
     /* 1652806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1652817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1652820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1652823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1652829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1652832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1652836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1652844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652852 */     // MIs[0] policy
     /* 1652852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1652862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1652865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652886 */     // GIR_Coverage, 5797,
     /* 1652886 */     GIR_EraseRootFromParent_Done,
     /* 1652887 */   // Label 22705: @1652887
     /* 1652887 */   GIM_Try, /*On fail goto*//*Label 22706*/ GIMT_Encode4(1652973), // Rule ID 5800 //
     /* 1652892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1652895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1652903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1652906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1652909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1652912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1652915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1652918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1652922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1652930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1652934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1652938 */     // MIs[0] policy
     /* 1652938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1652941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1652948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1652948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1652951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1652953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1652955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1652957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1652959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1652961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1652966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1652969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1652971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1652972 */     // GIR_Coverage, 5800,
     /* 1652972 */     GIR_EraseRootFromParent_Done,
     /* 1652973 */   // Label 22706: @1652973
     /* 1652973 */   GIM_Try, /*On fail goto*//*Label 22707*/ GIMT_Encode4(1653059), // Rule ID 5801 //
     /* 1652978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1652981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1652986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1652989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1652992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1652995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1652998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653024 */     // MIs[0] policy
     /* 1653024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1653037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653058 */     // GIR_Coverage, 5801,
     /* 1653058 */     GIR_EraseRootFromParent_Done,
     /* 1653059 */   // Label 22707: @1653059
     /* 1653059 */   GIM_Try, /*On fail goto*//*Label 22708*/ GIMT_Encode4(1653145), // Rule ID 5804 //
     /* 1653064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1653075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1653078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1653081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1653087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653110 */     // MIs[0] policy
     /* 1653110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1653123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653144 */     // GIR_Coverage, 5804,
     /* 1653144 */     GIR_EraseRootFromParent_Done,
     /* 1653145 */   // Label 22708: @1653145
     /* 1653145 */   GIM_Try, /*On fail goto*//*Label 22709*/ GIMT_Encode4(1653231), // Rule ID 5805 //
     /* 1653150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1653161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1653164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1653167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1653173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653196 */     // MIs[0] policy
     /* 1653196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1653209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1653227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653230 */     // GIR_Coverage, 5805,
     /* 1653230 */     GIR_EraseRootFromParent_Done,
     /* 1653231 */   // Label 22709: @1653231
     /* 1653231 */   GIM_Try, /*On fail goto*//*Label 22710*/ GIMT_Encode4(1653317), // Rule ID 5808 //
     /* 1653236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653282 */     // MIs[0] policy
     /* 1653282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1653295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653316 */     // GIR_Coverage, 5808,
     /* 1653316 */     GIR_EraseRootFromParent_Done,
     /* 1653317 */   // Label 22710: @1653317
     /* 1653317 */   GIM_Try, /*On fail goto*//*Label 22711*/ GIMT_Encode4(1653403), // Rule ID 5809 //
     /* 1653322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1653333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1653336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1653339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653368 */     // MIs[0] policy
     /* 1653368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1653381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653402 */     // GIR_Coverage, 5809,
     /* 1653402 */     GIR_EraseRootFromParent_Done,
     /* 1653403 */   // Label 22711: @1653403
     /* 1653403 */   GIM_Try, /*On fail goto*//*Label 22712*/ GIMT_Encode4(1653489), // Rule ID 5812 //
     /* 1653408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1653419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1653422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1653425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653454 */     // MIs[0] policy
     /* 1653454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1653467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653488 */     // GIR_Coverage, 5812,
     /* 1653488 */     GIR_EraseRootFromParent_Done,
     /* 1653489 */   // Label 22712: @1653489
     /* 1653489 */   GIM_Try, /*On fail goto*//*Label 22713*/ GIMT_Encode4(1653575), // Rule ID 5813 //
     /* 1653494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1653505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1653508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1653511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1653517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653540 */     // MIs[0] policy
     /* 1653540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1653553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653574 */     // GIR_Coverage, 5813,
     /* 1653574 */     GIR_EraseRootFromParent_Done,
     /* 1653575 */   // Label 22713: @1653575
     /* 1653575 */   GIM_Try, /*On fail goto*//*Label 22714*/ GIMT_Encode4(1653661), // Rule ID 5816 //
     /* 1653580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1653583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1653591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1653594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1653597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653626 */     // MIs[0] policy
     /* 1653626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1653639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653660 */     // GIR_Coverage, 5816,
     /* 1653660 */     GIR_EraseRootFromParent_Done,
     /* 1653661 */   // Label 22714: @1653661
     /* 1653661 */   GIM_Try, /*On fail goto*//*Label 22715*/ GIMT_Encode4(1653747), // Rule ID 5817 //
     /* 1653666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1653669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1653677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1653680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1653683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1653689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1653696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1653704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653712 */     // MIs[0] policy
     /* 1653712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1653725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1653743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653746 */     // GIR_Coverage, 5817,
     /* 1653746 */     GIR_EraseRootFromParent_Done,
     /* 1653747 */   // Label 22715: @1653747
     /* 1653747 */   GIM_Try, /*On fail goto*//*Label 22716*/ GIMT_Encode4(1653833), // Rule ID 5820 //
     /* 1653752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1653755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653798 */     // MIs[0] policy
     /* 1653798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1653811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1653829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653832 */     // GIR_Coverage, 5820,
     /* 1653832 */     GIR_EraseRootFromParent_Done,
     /* 1653833 */   // Label 22716: @1653833
     /* 1653833 */   GIM_Try, /*On fail goto*//*Label 22717*/ GIMT_Encode4(1653919), // Rule ID 5821 //
     /* 1653838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1653841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1653849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1653852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1653855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1653858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1653861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1653864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1653868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1653876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653884 */     // MIs[0] policy
     /* 1653884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11088:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1653894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M2_MASK),
     /* 1653897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1653915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1653917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1653918 */     // GIR_Coverage, 5821,
     /* 1653918 */     GIR_EraseRootFromParent_Done,
     /* 1653919 */   // Label 22717: @1653919
     /* 1653919 */   GIM_Try, /*On fail goto*//*Label 22718*/ GIMT_Encode4(1654005), // Rule ID 5824 //
     /* 1653924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1653927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1653932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1653935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1653938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1653941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1653944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1653947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1653950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1653954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1653962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1653966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1653970 */     // MIs[0] policy
     /* 1653970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1653973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1653980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1653980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1653983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1653985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1653987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1653989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1653991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1653993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1653998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654004 */     // GIR_Coverage, 5824,
     /* 1654004 */     GIR_EraseRootFromParent_Done,
     /* 1654005 */   // Label 22718: @1654005
     /* 1654005 */   GIM_Try, /*On fail goto*//*Label 22719*/ GIMT_Encode4(1654091), // Rule ID 5825 //
     /* 1654010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1654021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1654024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1654027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1654030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1654040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1654048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654056 */     // MIs[0] policy
     /* 1654056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11088:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M4_MASK),
     /* 1654069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654090 */     // GIR_Coverage, 5825,
     /* 1654090 */     GIR_EraseRootFromParent_Done,
     /* 1654091 */   // Label 22719: @1654091
     /* 1654091 */   GIM_Try, /*On fail goto*//*Label 22720*/ GIMT_Encode4(1654177), // Rule ID 5828 //
     /* 1654096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1654099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1654116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654142 */     // MIs[0] policy
     /* 1654142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1654155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654176 */     // GIR_Coverage, 5828,
     /* 1654176 */     GIR_EraseRootFromParent_Done,
     /* 1654177 */   // Label 22720: @1654177
     /* 1654177 */   GIM_Try, /*On fail goto*//*Label 22721*/ GIMT_Encode4(1654263), // Rule ID 5829 //
     /* 1654182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1654185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vand_mask),
     /* 1654190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1654193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1654196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1654199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1654202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1654205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1654212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1654220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1654224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654228 */     // MIs[0] policy
     /* 1654228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11088:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAND_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAND_VX_M8_MASK),
     /* 1654241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1654259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654262 */     // GIR_Coverage, 5829,
     /* 1654262 */     GIR_EraseRootFromParent_Done,
     /* 1654263 */   // Label 22721: @1654263
     /* 1654263 */   GIM_Try, /*On fail goto*//*Label 22722*/ GIMT_Encode4(1654349), // Rule ID 5920 //
     /* 1654268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1654279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1654282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1654285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1654288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654314 */     // MIs[0] policy
     /* 1654314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654324 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1654327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654348 */     // GIR_Coverage, 5920,
     /* 1654348 */     GIR_EraseRootFromParent_Done,
     /* 1654349 */   // Label 22722: @1654349
     /* 1654349 */   GIM_Try, /*On fail goto*//*Label 22723*/ GIMT_Encode4(1654435), // Rule ID 5921 //
     /* 1654354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1654365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1654368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1654371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1654374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654400 */     // MIs[0] policy
     /* 1654400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF8_MASK),
     /* 1654413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654434 */     // GIR_Coverage, 5921,
     /* 1654434 */     GIR_EraseRootFromParent_Done,
     /* 1654435 */   // Label 22723: @1654435
     /* 1654435 */   GIM_Try, /*On fail goto*//*Label 22724*/ GIMT_Encode4(1654521), // Rule ID 5924 //
     /* 1654440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1654451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1654454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1654457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1654460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654486 */     // MIs[0] policy
     /* 1654486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1654499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654520 */     // GIR_Coverage, 5924,
     /* 1654520 */     GIR_EraseRootFromParent_Done,
     /* 1654521 */   // Label 22724: @1654521
     /* 1654521 */   GIM_Try, /*On fail goto*//*Label 22725*/ GIMT_Encode4(1654607), // Rule ID 5925 //
     /* 1654526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1654537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1654540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1654543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1654546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654572 */     // MIs[0] policy
     /* 1654572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1654585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654606 */     // GIR_Coverage, 5925,
     /* 1654606 */     GIR_EraseRootFromParent_Done,
     /* 1654607 */   // Label 22725: @1654607
     /* 1654607 */   GIM_Try, /*On fail goto*//*Label 22726*/ GIMT_Encode4(1654693), // Rule ID 5928 //
     /* 1654612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654658 */     // MIs[0] policy
     /* 1654658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1654671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654692 */     // GIR_Coverage, 5928,
     /* 1654692 */     GIR_EraseRootFromParent_Done,
     /* 1654693 */   // Label 22726: @1654693
     /* 1654693 */   GIM_Try, /*On fail goto*//*Label 22727*/ GIMT_Encode4(1654779), // Rule ID 5929 //
     /* 1654698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1654709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1654712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1654715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1654718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1654721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654744 */     // MIs[0] policy
     /* 1654744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1654757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1654775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654778 */     // GIR_Coverage, 5929,
     /* 1654778 */     GIR_EraseRootFromParent_Done,
     /* 1654779 */   // Label 22727: @1654779
     /* 1654779 */   GIM_Try, /*On fail goto*//*Label 22728*/ GIMT_Encode4(1654865), // Rule ID 5932 //
     /* 1654784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654830 */     // MIs[0] policy
     /* 1654830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654840 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1654840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1654843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654864 */     // GIR_Coverage, 5932,
     /* 1654864 */     GIR_EraseRootFromParent_Done,
     /* 1654865 */   // Label 22728: @1654865
     /* 1654865 */   GIM_Try, /*On fail goto*//*Label 22729*/ GIMT_Encode4(1654951), // Rule ID 5933 //
     /* 1654870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1654873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1654881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1654884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1654887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1654890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1654893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1654896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1654916 */     // MIs[0] policy
     /* 1654916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1654919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1654926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1654926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF4_MASK),
     /* 1654929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1654931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1654933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1654935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1654937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1654939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1654944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1654947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1654949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1654950 */     // GIR_Coverage, 5933,
     /* 1654950 */     GIR_EraseRootFromParent_Done,
     /* 1654951 */   // Label 22729: @1654951
     /* 1654951 */   GIM_Try, /*On fail goto*//*Label 22730*/ GIMT_Encode4(1655037), // Rule ID 5936 //
     /* 1654956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1654959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1654964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1654967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1654970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1654973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1654976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1654979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1654982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1654986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1654998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655002 */     // MIs[0] policy
     /* 1655002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1655015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655036 */     // GIR_Coverage, 5936,
     /* 1655036 */     GIR_EraseRootFromParent_Done,
     /* 1655037 */   // Label 22730: @1655037
     /* 1655037 */   GIM_Try, /*On fail goto*//*Label 22731*/ GIMT_Encode4(1655123), // Rule ID 5937 //
     /* 1655042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1655053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1655056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1655059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1655062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655088 */     // MIs[0] policy
     /* 1655088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1655101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655122 */     // GIR_Coverage, 5937,
     /* 1655122 */     GIR_EraseRootFromParent_Done,
     /* 1655123 */   // Label 22731: @1655123
     /* 1655123 */   GIM_Try, /*On fail goto*//*Label 22732*/ GIMT_Encode4(1655209), // Rule ID 5940 //
     /* 1655128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1655148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655174 */     // MIs[0] policy
     /* 1655174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1655187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655208 */     // GIR_Coverage, 5940,
     /* 1655208 */     GIR_EraseRootFromParent_Done,
     /* 1655209 */   // Label 22732: @1655209
     /* 1655209 */   GIM_Try, /*On fail goto*//*Label 22733*/ GIMT_Encode4(1655295), // Rule ID 5941 //
     /* 1655214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1655225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1655228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1655231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1655234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655260 */     // MIs[0] policy
     /* 1655260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_MF2_MASK),
     /* 1655273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655294 */     // GIR_Coverage, 5941,
     /* 1655294 */     GIR_EraseRootFromParent_Done,
     /* 1655295 */   // Label 22733: @1655295
     /* 1655295 */   GIM_Try, /*On fail goto*//*Label 22734*/ GIMT_Encode4(1655381), // Rule ID 5944 //
     /* 1655300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1655311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1655314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1655317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1655320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655346 */     // MIs[0] policy
     /* 1655346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655380 */     // GIR_Coverage, 5944,
     /* 1655380 */     GIR_EraseRootFromParent_Done,
     /* 1655381 */   // Label 22734: @1655381
     /* 1655381 */   GIM_Try, /*On fail goto*//*Label 22735*/ GIMT_Encode4(1655467), // Rule ID 5945 //
     /* 1655386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1655397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1655400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1655403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1655406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1655409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655432 */     // MIs[0] policy
     /* 1655432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1655463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655466 */     // GIR_Coverage, 5945,
     /* 1655466 */     GIR_EraseRootFromParent_Done,
     /* 1655467 */   // Label 22735: @1655467
     /* 1655467 */   GIM_Try, /*On fail goto*//*Label 22736*/ GIMT_Encode4(1655553), // Rule ID 5948 //
     /* 1655472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1655483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1655486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1655489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1655492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655518 */     // MIs[0] policy
     /* 1655518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655552 */     // GIR_Coverage, 5948,
     /* 1655552 */     GIR_EraseRootFromParent_Done,
     /* 1655553 */   // Label 22736: @1655553
     /* 1655553 */   GIM_Try, /*On fail goto*//*Label 22737*/ GIMT_Encode4(1655639), // Rule ID 5949 //
     /* 1655558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1655569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1655572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1655575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1655578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1655581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655604 */     // MIs[0] policy
     /* 1655604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1655635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655638 */     // GIR_Coverage, 5949,
     /* 1655638 */     GIR_EraseRootFromParent_Done,
     /* 1655639 */   // Label 22737: @1655639
     /* 1655639 */   GIM_Try, /*On fail goto*//*Label 22738*/ GIMT_Encode4(1655725), // Rule ID 5952 //
     /* 1655644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655690 */     // MIs[0] policy
     /* 1655690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655724 */     // GIR_Coverage, 5952,
     /* 1655724 */     GIR_EraseRootFromParent_Done,
     /* 1655725 */   // Label 22738: @1655725
     /* 1655725 */   GIM_Try, /*On fail goto*//*Label 22739*/ GIMT_Encode4(1655811), // Rule ID 5953 //
     /* 1655730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1655733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1655741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1655744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1655747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1655750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1655753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655776 */     // MIs[0] policy
     /* 1655776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1655807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655810 */     // GIR_Coverage, 5953,
     /* 1655810 */     GIR_EraseRootFromParent_Done,
     /* 1655811 */   // Label 22739: @1655811
     /* 1655811 */   GIM_Try, /*On fail goto*//*Label 22740*/ GIMT_Encode4(1655897), // Rule ID 5956 //
     /* 1655816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1655819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1655842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655862 */     // MIs[0] policy
     /* 1655862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655872 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1655872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655896 */     // GIR_Coverage, 5956,
     /* 1655896 */     GIR_EraseRootFromParent_Done,
     /* 1655897 */   // Label 22740: @1655897
     /* 1655897 */   GIM_Try, /*On fail goto*//*Label 22741*/ GIMT_Encode4(1655983), // Rule ID 5957 //
     /* 1655902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1655905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1655913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1655916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1655919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1655922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1655925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1655928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1655932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1655944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1655948 */     // MIs[0] policy
     /* 1655948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1655951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1655958 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1655958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M1_MASK),
     /* 1655961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1655963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1655965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1655967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1655969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1655971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1655976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1655979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1655981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1655982 */     // GIR_Coverage, 5957,
     /* 1655982 */     GIR_EraseRootFromParent_Done,
     /* 1655983 */   // Label 22741: @1655983
     /* 1655983 */   GIM_Try, /*On fail goto*//*Label 22742*/ GIMT_Encode4(1656069), // Rule ID 5960 //
     /* 1655988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1655991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1655996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1655999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1656002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1656005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1656008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656034 */     // MIs[0] policy
     /* 1656034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656044 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1656047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656068 */     // GIR_Coverage, 5960,
     /* 1656068 */     GIR_EraseRootFromParent_Done,
     /* 1656069 */   // Label 22742: @1656069
     /* 1656069 */   GIM_Try, /*On fail goto*//*Label 22743*/ GIMT_Encode4(1656155), // Rule ID 5961 //
     /* 1656074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1656085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1656088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1656091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1656094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656120 */     // MIs[0] policy
     /* 1656120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656130 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1656133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656154 */     // GIR_Coverage, 5961,
     /* 1656154 */     GIR_EraseRootFromParent_Done,
     /* 1656155 */   // Label 22743: @1656155
     /* 1656155 */   GIM_Try, /*On fail goto*//*Label 22744*/ GIMT_Encode4(1656241), // Rule ID 5964 //
     /* 1656160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1656171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1656174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1656177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1656180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656206 */     // MIs[0] policy
     /* 1656206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656216 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1656219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656240 */     // GIR_Coverage, 5964,
     /* 1656240 */     GIR_EraseRootFromParent_Done,
     /* 1656241 */   // Label 22744: @1656241
     /* 1656241 */   GIM_Try, /*On fail goto*//*Label 22745*/ GIMT_Encode4(1656327), // Rule ID 5965 //
     /* 1656246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1656257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1656260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1656263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1656266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656292 */     // MIs[0] policy
     /* 1656292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656302 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1656305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656326 */     // GIR_Coverage, 5965,
     /* 1656326 */     GIR_EraseRootFromParent_Done,
     /* 1656327 */   // Label 22745: @1656327
     /* 1656327 */   GIM_Try, /*On fail goto*//*Label 22746*/ GIMT_Encode4(1656413), // Rule ID 5968 //
     /* 1656332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1656343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1656346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1656349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1656352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1656355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656378 */     // MIs[0] policy
     /* 1656378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656388 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1656391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656412 */     // GIR_Coverage, 5968,
     /* 1656412 */     GIR_EraseRootFromParent_Done,
     /* 1656413 */   // Label 22746: @1656413
     /* 1656413 */   GIM_Try, /*On fail goto*//*Label 22747*/ GIMT_Encode4(1656499), // Rule ID 5969 //
     /* 1656418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1656429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1656432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1656435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1656438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1656441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656464 */     // MIs[0] policy
     /* 1656464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656474 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1656477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1656495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656498 */     // GIR_Coverage, 5969,
     /* 1656498 */     GIR_EraseRootFromParent_Done,
     /* 1656499 */   // Label 22747: @1656499
     /* 1656499 */   GIM_Try, /*On fail goto*//*Label 22748*/ GIMT_Encode4(1656585), // Rule ID 5972 //
     /* 1656504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1656515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656550 */     // MIs[0] policy
     /* 1656550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656560 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1656563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656584 */     // GIR_Coverage, 5972,
     /* 1656584 */     GIR_EraseRootFromParent_Done,
     /* 1656585 */   // Label 22748: @1656585
     /* 1656585 */   GIM_Try, /*On fail goto*//*Label 22749*/ GIMT_Encode4(1656671), // Rule ID 5973 //
     /* 1656590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1656601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1656604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1656607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1656610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1656613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1656620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1656632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656636 */     // MIs[0] policy
     /* 1656636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656646 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1656649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656670 */     // GIR_Coverage, 5973,
     /* 1656670 */     GIR_EraseRootFromParent_Done,
     /* 1656671 */   // Label 22749: @1656671
     /* 1656671 */   GIM_Try, /*On fail goto*//*Label 22750*/ GIMT_Encode4(1656757), // Rule ID 5976 //
     /* 1656676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656722 */     // MIs[0] policy
     /* 1656722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656732 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1656735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656756 */     // GIR_Coverage, 5976,
     /* 1656756 */     GIR_EraseRootFromParent_Done,
     /* 1656757 */   // Label 22750: @1656757
     /* 1656757 */   GIM_Try, /*On fail goto*//*Label 22751*/ GIMT_Encode4(1656843), // Rule ID 5977 //
     /* 1656762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1656773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1656776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1656779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1656782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1656785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1656792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1656804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656808 */     // MIs[0] policy
     /* 1656808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656818 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1656821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656842 */     // GIR_Coverage, 5977,
     /* 1656842 */     GIR_EraseRootFromParent_Done,
     /* 1656843 */   // Label 22751: @1656843
     /* 1656843 */   GIM_Try, /*On fail goto*//*Label 22752*/ GIMT_Encode4(1656929), // Rule ID 5980 //
     /* 1656848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1656851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1656874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656894 */     // MIs[0] policy
     /* 1656894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656904 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1656904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1656907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1656915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1656917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1656922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1656925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1656927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1656928 */     // GIR_Coverage, 5980,
     /* 1656928 */     GIR_EraseRootFromParent_Done,
     /* 1656929 */   // Label 22752: @1656929
     /* 1656929 */   GIM_Try, /*On fail goto*//*Label 22753*/ GIMT_Encode4(1657015), // Rule ID 5981 //
     /* 1656934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1656937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1656942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1656945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1656948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1656951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1656954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1656957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1656960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1656964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1656976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1656980 */     // MIs[0] policy
     /* 1656980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1656983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1656990 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1656990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1656993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1656995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1656997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1656999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1657011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657014 */     // GIR_Coverage, 5981,
     /* 1657014 */     GIR_EraseRootFromParent_Done,
     /* 1657015 */   // Label 22753: @1657015
     /* 1657015 */   GIM_Try, /*On fail goto*//*Label 22754*/ GIMT_Encode4(1657101), // Rule ID 5984 //
     /* 1657020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1657031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1657034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1657037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1657040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657066 */     // MIs[0] policy
     /* 1657066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657076 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1657079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657100 */     // GIR_Coverage, 5984,
     /* 1657100 */     GIR_EraseRootFromParent_Done,
     /* 1657101 */   // Label 22754: @1657101
     /* 1657101 */   GIM_Try, /*On fail goto*//*Label 22755*/ GIMT_Encode4(1657187), // Rule ID 5985 //
     /* 1657106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1657117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1657120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1657123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1657126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657152 */     // MIs[0] policy
     /* 1657152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1657165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657186 */     // GIR_Coverage, 5985,
     /* 1657186 */     GIR_EraseRootFromParent_Done,
     /* 1657187 */   // Label 22755: @1657187
     /* 1657187 */   GIM_Try, /*On fail goto*//*Label 22756*/ GIMT_Encode4(1657273), // Rule ID 5988 //
     /* 1657192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1657203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1657206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1657209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1657212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657238 */     // MIs[0] policy
     /* 1657238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657248 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1657251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657272 */     // GIR_Coverage, 5988,
     /* 1657272 */     GIR_EraseRootFromParent_Done,
     /* 1657273 */   // Label 22756: @1657273
     /* 1657273 */   GIM_Try, /*On fail goto*//*Label 22757*/ GIMT_Encode4(1657359), // Rule ID 5989 //
     /* 1657278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1657289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1657292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1657295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1657298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657324 */     // MIs[0] policy
     /* 1657324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657334 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1657337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657358 */     // GIR_Coverage, 5989,
     /* 1657358 */     GIR_EraseRootFromParent_Done,
     /* 1657359 */   // Label 22757: @1657359
     /* 1657359 */   GIM_Try, /*On fail goto*//*Label 22758*/ GIMT_Encode4(1657445), // Rule ID 5992 //
     /* 1657364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1657367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1657375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1657378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1657381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1657384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657410 */     // MIs[0] policy
     /* 1657410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1657423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657444 */     // GIR_Coverage, 5992,
     /* 1657444 */     GIR_EraseRootFromParent_Done,
     /* 1657445 */   // Label 22758: @1657445
     /* 1657445 */   GIM_Try, /*On fail goto*//*Label 22759*/ GIMT_Encode4(1657531), // Rule ID 5993 //
     /* 1657450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1657453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1657461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1657464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1657467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1657470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1657473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657496 */     // MIs[0] policy
     /* 1657496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657506 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1657509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1657527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657530 */     // GIR_Coverage, 5993,
     /* 1657530 */     GIR_EraseRootFromParent_Done,
     /* 1657531 */   // Label 22759: @1657531
     /* 1657531 */   GIM_Try, /*On fail goto*//*Label 22760*/ GIMT_Encode4(1657617), // Rule ID 5996 //
     /* 1657536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657582 */     // MIs[0] policy
     /* 1657582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657592 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1657595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657616 */     // GIR_Coverage, 5996,
     /* 1657616 */     GIR_EraseRootFromParent_Done,
     /* 1657617 */   // Label 22760: @1657617
     /* 1657617 */   GIM_Try, /*On fail goto*//*Label 22761*/ GIMT_Encode4(1657703), // Rule ID 5997 //
     /* 1657622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1657633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1657636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1657639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1657642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1657645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1657652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1657664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657668 */     // MIs[0] policy
     /* 1657668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657678 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M2_MASK),
     /* 1657681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657702 */     // GIR_Coverage, 5997,
     /* 1657702 */     GIR_EraseRootFromParent_Done,
     /* 1657703 */   // Label 22761: @1657703
     /* 1657703 */   GIM_Try, /*On fail goto*//*Label 22762*/ GIMT_Encode4(1657789), // Rule ID 6000 //
     /* 1657708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657754 */     // MIs[0] policy
     /* 1657754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1657767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657788 */     // GIR_Coverage, 6000,
     /* 1657788 */     GIR_EraseRootFromParent_Done,
     /* 1657789 */   // Label 22762: @1657789
     /* 1657789 */   GIM_Try, /*On fail goto*//*Label 22763*/ GIMT_Encode4(1657875), // Rule ID 6001 //
     /* 1657794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1657805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1657808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1657811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1657814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1657817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1657824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1657836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657840 */     // MIs[0] policy
     /* 1657840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657850 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1657850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M4_MASK),
     /* 1657853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657874 */     // GIR_Coverage, 6001,
     /* 1657874 */     GIR_EraseRootFromParent_Done,
     /* 1657875 */   // Label 22763: @1657875
     /* 1657875 */   GIM_Try, /*On fail goto*//*Label 22764*/ GIMT_Encode4(1657961), // Rule ID 6004 //
     /* 1657880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1657883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1657906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1657922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1657926 */     // MIs[0] policy
     /* 1657926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1657929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1657936 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1657936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1657939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1657941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1657943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1657945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1657947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1657949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1657954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1657957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1657959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1657960 */     // GIR_Coverage, 6004,
     /* 1657960 */     GIR_EraseRootFromParent_Done,
     /* 1657961 */   // Label 22764: @1657961
     /* 1657961 */   GIM_Try, /*On fail goto*//*Label 22765*/ GIMT_Encode4(1658047), // Rule ID 6005 //
     /* 1657966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1657969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1657974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1657977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1657980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1657983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1657986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1657989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1657992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1657996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1658008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658012 */     // MIs[0] policy
     /* 1658012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658022 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VV_M8_MASK),
     /* 1658025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1658043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658046 */     // GIR_Coverage, 6005,
     /* 1658046 */     GIR_EraseRootFromParent_Done,
     /* 1658047 */   // Label 22765: @1658047
     /* 1658047 */   GIM_Try, /*On fail goto*//*Label 22766*/ GIMT_Encode4(1658133), // Rule ID 6008 //
     /* 1658052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658098 */     // MIs[0] policy
     /* 1658098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658108 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1658111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658132 */     // GIR_Coverage, 6008,
     /* 1658132 */     GIR_EraseRootFromParent_Done,
     /* 1658133 */   // Label 22766: @1658133
     /* 1658133 */   GIM_Try, /*On fail goto*//*Label 22767*/ GIMT_Encode4(1658219), // Rule ID 6009 //
     /* 1658138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1658149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1658152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1658155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658184 */     // MIs[0] policy
     /* 1658184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658194 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF8_MASK),
     /* 1658197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658218 */     // GIR_Coverage, 6009,
     /* 1658218 */     GIR_EraseRootFromParent_Done,
     /* 1658219 */   // Label 22767: @1658219
     /* 1658219 */   GIM_Try, /*On fail goto*//*Label 22768*/ GIMT_Encode4(1658305), // Rule ID 6012 //
     /* 1658224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1658235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1658238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1658241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658270 */     // MIs[0] policy
     /* 1658270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658280 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1658283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658304 */     // GIR_Coverage, 6012,
     /* 1658304 */     GIR_EraseRootFromParent_Done,
     /* 1658305 */   // Label 22768: @1658305
     /* 1658305 */   GIM_Try, /*On fail goto*//*Label 22769*/ GIMT_Encode4(1658391), // Rule ID 6013 //
     /* 1658310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1658321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1658324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1658327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658356 */     // MIs[0] policy
     /* 1658356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658366 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1658369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658390 */     // GIR_Coverage, 6013,
     /* 1658390 */     GIR_EraseRootFromParent_Done,
     /* 1658391 */   // Label 22769: @1658391
     /* 1658391 */   GIM_Try, /*On fail goto*//*Label 22770*/ GIMT_Encode4(1658477), // Rule ID 6016 //
     /* 1658396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1658407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1658410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1658413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658442 */     // MIs[0] policy
     /* 1658442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658452 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1658455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658476 */     // GIR_Coverage, 6016,
     /* 1658476 */     GIR_EraseRootFromParent_Done,
     /* 1658477 */   // Label 22770: @1658477
     /* 1658477 */   GIM_Try, /*On fail goto*//*Label 22771*/ GIMT_Encode4(1658563), // Rule ID 6017 //
     /* 1658482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1658493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1658496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1658499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1658505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658528 */     // MIs[0] policy
     /* 1658528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658538 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1658541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1658559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658562 */     // GIR_Coverage, 6017,
     /* 1658562 */     GIR_EraseRootFromParent_Done,
     /* 1658563 */   // Label 22771: @1658563
     /* 1658563 */   GIM_Try, /*On fail goto*//*Label 22772*/ GIMT_Encode4(1658649), // Rule ID 6020 //
     /* 1658568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658614 */     // MIs[0] policy
     /* 1658614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658624 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1658627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658648 */     // GIR_Coverage, 6020,
     /* 1658648 */     GIR_EraseRootFromParent_Done,
     /* 1658649 */   // Label 22772: @1658649
     /* 1658649 */   GIM_Try, /*On fail goto*//*Label 22773*/ GIMT_Encode4(1658735), // Rule ID 6021 //
     /* 1658654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1658665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1658668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1658671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658700 */     // MIs[0] policy
     /* 1658700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658710 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF4_MASK),
     /* 1658713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658734 */     // GIR_Coverage, 6021,
     /* 1658734 */     GIR_EraseRootFromParent_Done,
     /* 1658735 */   // Label 22773: @1658735
     /* 1658735 */   GIM_Try, /*On fail goto*//*Label 22774*/ GIMT_Encode4(1658821), // Rule ID 6024 //
     /* 1658740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658786 */     // MIs[0] policy
     /* 1658786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658796 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1658799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658820 */     // GIR_Coverage, 6024,
     /* 1658820 */     GIR_EraseRootFromParent_Done,
     /* 1658821 */   // Label 22774: @1658821
     /* 1658821 */   GIM_Try, /*On fail goto*//*Label 22775*/ GIMT_Encode4(1658907), // Rule ID 6025 //
     /* 1658826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1658829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1658837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1658840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1658843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1658846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1658849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1658852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658872 */     // MIs[0] policy
     /* 1658872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658882 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1658882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1658885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1658903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658906 */     // GIR_Coverage, 6025,
     /* 1658906 */     GIR_EraseRootFromParent_Done,
     /* 1658907 */   // Label 22775: @1658907
     /* 1658907 */   GIM_Try, /*On fail goto*//*Label 22776*/ GIMT_Encode4(1658993), // Rule ID 6028 //
     /* 1658912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1658915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1658920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1658923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1658926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1658929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1658932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1658935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1658938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1658942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1658950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1658954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1658958 */     // MIs[0] policy
     /* 1658958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1658961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1658968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1658968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1658971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1658973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1658975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1658977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1658979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1658981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1658986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1658989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1658991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1658992 */     // GIR_Coverage, 6028,
     /* 1658992 */     GIR_EraseRootFromParent_Done,
     /* 1658993 */   // Label 22776: @1658993
     /* 1658993 */   GIM_Try, /*On fail goto*//*Label 22777*/ GIMT_Encode4(1659079), // Rule ID 6029 //
     /* 1658998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1659009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1659012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1659015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659044 */     // MIs[0] policy
     /* 1659044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_MF2_MASK),
     /* 1659057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659078 */     // GIR_Coverage, 6029,
     /* 1659078 */     GIR_EraseRootFromParent_Done,
     /* 1659079 */   // Label 22777: @1659079
     /* 1659079 */   GIM_Try, /*On fail goto*//*Label 22778*/ GIMT_Encode4(1659165), // Rule ID 6032 //
     /* 1659084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659130 */     // MIs[0] policy
     /* 1659130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659140 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659164 */     // GIR_Coverage, 6032,
     /* 1659164 */     GIR_EraseRootFromParent_Done,
     /* 1659165 */   // Label 22778: @1659165
     /* 1659165 */   GIM_Try, /*On fail goto*//*Label 22779*/ GIMT_Encode4(1659251), // Rule ID 6033 //
     /* 1659170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1659181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1659184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1659187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1659193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659216 */     // MIs[0] policy
     /* 1659216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659226 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11427:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659250 */     // GIR_Coverage, 6033,
     /* 1659250 */     GIR_EraseRootFromParent_Done,
     /* 1659251 */   // Label 22779: @1659251
     /* 1659251 */   GIM_Try, /*On fail goto*//*Label 22780*/ GIMT_Encode4(1659337), // Rule ID 6036 //
     /* 1659256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1659267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1659270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1659273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659302 */     // MIs[0] policy
     /* 1659302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659312 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659336 */     // GIR_Coverage, 6036,
     /* 1659336 */     GIR_EraseRootFromParent_Done,
     /* 1659337 */   // Label 22780: @1659337
     /* 1659337 */   GIM_Try, /*On fail goto*//*Label 22781*/ GIMT_Encode4(1659423), // Rule ID 6037 //
     /* 1659342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1659353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1659356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1659359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1659365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659388 */     // MIs[0] policy
     /* 1659388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11427:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1659419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659422 */     // GIR_Coverage, 6037,
     /* 1659422 */     GIR_EraseRootFromParent_Done,
     /* 1659423 */   // Label 22781: @1659423
     /* 1659423 */   GIM_Try, /*On fail goto*//*Label 22782*/ GIMT_Encode4(1659509), // Rule ID 6040 //
     /* 1659428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1659439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1659442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1659445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659474 */     // MIs[0] policy
     /* 1659474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659484 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659508 */     // GIR_Coverage, 6040,
     /* 1659508 */     GIR_EraseRootFromParent_Done,
     /* 1659509 */   // Label 22782: @1659509
     /* 1659509 */   GIM_Try, /*On fail goto*//*Label 22783*/ GIMT_Encode4(1659595), // Rule ID 6041 //
     /* 1659514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1659525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1659528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1659531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1659537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659560 */     // MIs[0] policy
     /* 1659560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659570 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11427:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1659591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659594 */     // GIR_Coverage, 6041,
     /* 1659594 */     GIR_EraseRootFromParent_Done,
     /* 1659595 */   // Label 22783: @1659595
     /* 1659595 */   GIM_Try, /*On fail goto*//*Label 22784*/ GIMT_Encode4(1659681), // Rule ID 6044 //
     /* 1659600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1659603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659646 */     // MIs[0] policy
     /* 1659646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659656 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659680 */     // GIR_Coverage, 6044,
     /* 1659680 */     GIR_EraseRootFromParent_Done,
     /* 1659681 */   // Label 22784: @1659681
     /* 1659681 */   GIM_Try, /*On fail goto*//*Label 22785*/ GIMT_Encode4(1659767), // Rule ID 6045 //
     /* 1659686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1659689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1659697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1659700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1659703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1659709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1659716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1659724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659732 */     // MIs[0] policy
     /* 1659732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659742 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11427:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M1_MASK),
     /* 1659745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1659763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659766 */     // GIR_Coverage, 6045,
     /* 1659766 */     GIR_EraseRootFromParent_Done,
     /* 1659767 */   // Label 22785: @1659767
     /* 1659767 */   GIM_Try, /*On fail goto*//*Label 22786*/ GIMT_Encode4(1659853), // Rule ID 6048 //
     /* 1659772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659818 */     // MIs[0] policy
     /* 1659818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659828 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1659828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1659831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659852 */     // GIR_Coverage, 6048,
     /* 1659852 */     GIR_EraseRootFromParent_Done,
     /* 1659853 */   // Label 22786: @1659853
     /* 1659853 */   GIM_Try, /*On fail goto*//*Label 22787*/ GIMT_Encode4(1659939), // Rule ID 6049 //
     /* 1659858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1659861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1659869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1659872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1659875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1659878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1659881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1659884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1659888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1659896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659904 */     // MIs[0] policy
     /* 1659904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1659914 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1659914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1659917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1659919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1659921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1659923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1659925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1659927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1659932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1659935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1659937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1659938 */     // GIR_Coverage, 6049,
     /* 1659938 */     GIR_EraseRootFromParent_Done,
     /* 1659939 */   // Label 22787: @1659939
     /* 1659939 */   GIM_Try, /*On fail goto*//*Label 22788*/ GIMT_Encode4(1660025), // Rule ID 6052 //
     /* 1659944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1659947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1659952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1659955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1659958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1659961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1659964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1659967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1659970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1659974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1659982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1659986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1659990 */     // MIs[0] policy
     /* 1659990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1659993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660000 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1660003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660024 */     // GIR_Coverage, 6052,
     /* 1660024 */     GIR_EraseRootFromParent_Done,
     /* 1660025 */   // Label 22788: @1660025
     /* 1660025 */   GIM_Try, /*On fail goto*//*Label 22789*/ GIMT_Encode4(1660111), // Rule ID 6053 //
     /* 1660030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1660041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1660044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1660047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660076 */     // MIs[0] policy
     /* 1660076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660086 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1660089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660110 */     // GIR_Coverage, 6053,
     /* 1660110 */     GIR_EraseRootFromParent_Done,
     /* 1660111 */   // Label 22789: @1660111
     /* 1660111 */   GIM_Try, /*On fail goto*//*Label 22790*/ GIMT_Encode4(1660197), // Rule ID 6056 //
     /* 1660116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660162 */     // MIs[0] policy
     /* 1660162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660172 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1660175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660196 */     // GIR_Coverage, 6056,
     /* 1660196 */     GIR_EraseRootFromParent_Done,
     /* 1660197 */   // Label 22790: @1660197
     /* 1660197 */   GIM_Try, /*On fail goto*//*Label 22791*/ GIMT_Encode4(1660283), // Rule ID 6057 //
     /* 1660202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1660213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1660216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1660219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1660225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660248 */     // MIs[0] policy
     /* 1660248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660258 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1660261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1660279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660282 */     // GIR_Coverage, 6057,
     /* 1660282 */     GIR_EraseRootFromParent_Done,
     /* 1660283 */   // Label 22791: @1660283
     /* 1660283 */   GIM_Try, /*On fail goto*//*Label 22792*/ GIMT_Encode4(1660369), // Rule ID 6060 //
     /* 1660288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660334 */     // MIs[0] policy
     /* 1660334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660344 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1660347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660368 */     // GIR_Coverage, 6060,
     /* 1660368 */     GIR_EraseRootFromParent_Done,
     /* 1660369 */   // Label 22792: @1660369
     /* 1660369 */   GIM_Try, /*On fail goto*//*Label 22793*/ GIMT_Encode4(1660455), // Rule ID 6061 //
     /* 1660374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1660385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1660388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1660391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660420 */     // MIs[0] policy
     /* 1660420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1660433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660454 */     // GIR_Coverage, 6061,
     /* 1660454 */     GIR_EraseRootFromParent_Done,
     /* 1660455 */   // Label 22793: @1660455
     /* 1660455 */   GIM_Try, /*On fail goto*//*Label 22794*/ GIMT_Encode4(1660541), // Rule ID 6064 //
     /* 1660460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1660471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1660474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1660477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660506 */     // MIs[0] policy
     /* 1660506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660516 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1660519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660540 */     // GIR_Coverage, 6064,
     /* 1660540 */     GIR_EraseRootFromParent_Done,
     /* 1660541 */   // Label 22794: @1660541
     /* 1660541 */   GIM_Try, /*On fail goto*//*Label 22795*/ GIMT_Encode4(1660627), // Rule ID 6065 //
     /* 1660546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1660557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1660560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1660563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1660569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1660576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1660584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660592 */     // MIs[0] policy
     /* 1660592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660602 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1660605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660626 */     // GIR_Coverage, 6065,
     /* 1660626 */     GIR_EraseRootFromParent_Done,
     /* 1660627 */   // Label 22795: @1660627
     /* 1660627 */   GIM_Try, /*On fail goto*//*Label 22796*/ GIMT_Encode4(1660713), // Rule ID 6068 //
     /* 1660632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660678 */     // MIs[0] policy
     /* 1660678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660688 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1660691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660712 */     // GIR_Coverage, 6068,
     /* 1660712 */     GIR_EraseRootFromParent_Done,
     /* 1660713 */   // Label 22796: @1660713
     /* 1660713 */   GIM_Try, /*On fail goto*//*Label 22797*/ GIMT_Encode4(1660799), // Rule ID 6069 //
     /* 1660718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1660729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1660732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1660735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1660741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1660748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1660756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660764 */     // MIs[0] policy
     /* 1660764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660774 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1660777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1660795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660798 */     // GIR_Coverage, 6069,
     /* 1660798 */     GIR_EraseRootFromParent_Done,
     /* 1660799 */   // Label 22797: @1660799
     /* 1660799 */   GIM_Try, /*On fail goto*//*Label 22798*/ GIMT_Encode4(1660885), // Rule ID 6072 //
     /* 1660804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1660830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660850 */     // MIs[0] policy
     /* 1660850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660860 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1660860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1660863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660884 */     // GIR_Coverage, 6072,
     /* 1660884 */     GIR_EraseRootFromParent_Done,
     /* 1660885 */   // Label 22798: @1660885
     /* 1660885 */   GIM_Try, /*On fail goto*//*Label 22799*/ GIMT_Encode4(1660971), // Rule ID 6073 //
     /* 1660890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1660893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1660901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1660904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1660907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1660910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1660913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1660916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1660920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1660928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1660932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1660936 */     // MIs[0] policy
     /* 1660936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1660939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1660946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1660946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1660949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1660951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1660953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1660955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1660957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1660959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1660964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1660967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1660969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1660970 */     // GIR_Coverage, 6073,
     /* 1660970 */     GIR_EraseRootFromParent_Done,
     /* 1660971 */   // Label 22799: @1660971
     /* 1660971 */   GIM_Try, /*On fail goto*//*Label 22800*/ GIMT_Encode4(1661057), // Rule ID 6076 //
     /* 1660976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1660979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1660984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1660987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1660990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1660993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1660996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1660999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661022 */     // MIs[0] policy
     /* 1661022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661032 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1661035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661056 */     // GIR_Coverage, 6076,
     /* 1661056 */     GIR_EraseRootFromParent_Done,
     /* 1661057 */   // Label 22800: @1661057
     /* 1661057 */   GIM_Try, /*On fail goto*//*Label 22801*/ GIMT_Encode4(1661143), // Rule ID 6077 //
     /* 1661062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1661073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1661076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1661079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661108 */     // MIs[0] policy
     /* 1661108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661118 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1661121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661142 */     // GIR_Coverage, 6077,
     /* 1661142 */     GIR_EraseRootFromParent_Done,
     /* 1661143 */   // Label 22801: @1661143
     /* 1661143 */   GIM_Try, /*On fail goto*//*Label 22802*/ GIMT_Encode4(1661229), // Rule ID 6080 //
     /* 1661148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661194 */     // MIs[0] policy
     /* 1661194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661204 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1661207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661228 */     // GIR_Coverage, 6080,
     /* 1661228 */     GIR_EraseRootFromParent_Done,
     /* 1661229 */   // Label 22802: @1661229
     /* 1661229 */   GIM_Try, /*On fail goto*//*Label 22803*/ GIMT_Encode4(1661315), // Rule ID 6081 //
     /* 1661234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1661245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1661248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1661251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1661257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661280 */     // MIs[0] policy
     /* 1661280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661290 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1661293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1661311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661314 */     // GIR_Coverage, 6081,
     /* 1661314 */     GIR_EraseRootFromParent_Done,
     /* 1661315 */   // Label 22803: @1661315
     /* 1661315 */   GIM_Try, /*On fail goto*//*Label 22804*/ GIMT_Encode4(1661401), // Rule ID 6084 //
     /* 1661320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1661331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1661334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1661337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661366 */     // MIs[0] policy
     /* 1661366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661376 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1661379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661400 */     // GIR_Coverage, 6084,
     /* 1661400 */     GIR_EraseRootFromParent_Done,
     /* 1661401 */   // Label 22804: @1661401
     /* 1661401 */   GIM_Try, /*On fail goto*//*Label 22805*/ GIMT_Encode4(1661487), // Rule ID 6085 //
     /* 1661406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1661417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1661420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1661423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1661429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1661436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1661444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661452 */     // MIs[0] policy
     /* 1661452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661462 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11427:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M2_MASK),
     /* 1661465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661486 */     // GIR_Coverage, 6085,
     /* 1661486 */     GIR_EraseRootFromParent_Done,
     /* 1661487 */   // Label 22805: @1661487
     /* 1661487 */   GIM_Try, /*On fail goto*//*Label 22806*/ GIMT_Encode4(1661573), // Rule ID 6088 //
     /* 1661492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1661503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1661506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1661509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661538 */     // MIs[0] policy
     /* 1661538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661548 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1661551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661572 */     // GIR_Coverage, 6088,
     /* 1661572 */     GIR_EraseRootFromParent_Done,
     /* 1661573 */   // Label 22806: @1661573
     /* 1661573 */   GIM_Try, /*On fail goto*//*Label 22807*/ GIMT_Encode4(1661659), // Rule ID 6089 //
     /* 1661578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1661589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1661592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1661595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1661601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1661608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1661616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661624 */     // MIs[0] policy
     /* 1661624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661634 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11427:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M4_MASK),
     /* 1661637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661658 */     // GIR_Coverage, 6089,
     /* 1661658 */     GIR_EraseRootFromParent_Done,
     /* 1661659 */   // Label 22807: @1661659
     /* 1661659 */   GIM_Try, /*On fail goto*//*Label 22808*/ GIMT_Encode4(1661745), // Rule ID 6092 //
     /* 1661664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1661667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1661684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661710 */     // MIs[0] policy
     /* 1661710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661720 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1661723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661744 */     // GIR_Coverage, 6092,
     /* 1661744 */     GIR_EraseRootFromParent_Done,
     /* 1661745 */   // Label 22808: @1661745
     /* 1661745 */   GIM_Try, /*On fail goto*//*Label 22809*/ GIMT_Encode4(1661831), // Rule ID 6093 //
     /* 1661750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1661753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vor_mask),
     /* 1661758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1661761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1661764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1661767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1661770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1661773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1661780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1661788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1661792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661796 */     // MIs[0] policy
     /* 1661796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661806 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11427:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVOR_VX_M8_MASK),
     /* 1661809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1661827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661830 */     // GIR_Coverage, 6093,
     /* 1661830 */     GIR_EraseRootFromParent_Done,
     /* 1661831 */   // Label 22809: @1661831
     /* 1661831 */   GIM_Try, /*On fail goto*//*Label 22810*/ GIMT_Encode4(1661917), // Rule ID 6184 //
     /* 1661836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1661839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1661844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1661862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661882 */     // MIs[0] policy
     /* 1661882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661892 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1661892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1661895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1661915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1661916 */     // GIR_Coverage, 6184,
     /* 1661916 */     GIR_EraseRootFromParent_Done,
     /* 1661917 */   // Label 22810: @1661917
     /* 1661917 */   GIM_Try, /*On fail goto*//*Label 22811*/ GIMT_Encode4(1662003), // Rule ID 6185 //
     /* 1661922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1661925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1661930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1661933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1661936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1661939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1661942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1661945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1661948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1661952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1661964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1661968 */     // MIs[0] policy
     /* 1661968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1661971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1661978 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1661978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF8_MASK),
     /* 1661981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1661983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1661985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1661987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1661989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1661991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1661996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1661999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662002 */     // GIR_Coverage, 6185,
     /* 1662002 */     GIR_EraseRootFromParent_Done,
     /* 1662003 */   // Label 22811: @1662003
     /* 1662003 */   GIM_Try, /*On fail goto*//*Label 22812*/ GIMT_Encode4(1662089), // Rule ID 6188 //
     /* 1662008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1662028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662054 */     // MIs[0] policy
     /* 1662054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662064 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1662067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662088 */     // GIR_Coverage, 6188,
     /* 1662088 */     GIR_EraseRootFromParent_Done,
     /* 1662089 */   // Label 22812: @1662089
     /* 1662089 */   GIM_Try, /*On fail goto*//*Label 22813*/ GIMT_Encode4(1662175), // Rule ID 6189 //
     /* 1662094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1662105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1662108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1662111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1662114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662140 */     // MIs[0] policy
     /* 1662140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662150 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1662153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662174 */     // GIR_Coverage, 6189,
     /* 1662174 */     GIR_EraseRootFromParent_Done,
     /* 1662175 */   // Label 22813: @1662175
     /* 1662175 */   GIM_Try, /*On fail goto*//*Label 22814*/ GIMT_Encode4(1662261), // Rule ID 6192 //
     /* 1662180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1662200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662226 */     // MIs[0] policy
     /* 1662226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662236 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662260 */     // GIR_Coverage, 6192,
     /* 1662260 */     GIR_EraseRootFromParent_Done,
     /* 1662261 */   // Label 22814: @1662261
     /* 1662261 */   GIM_Try, /*On fail goto*//*Label 22815*/ GIMT_Encode4(1662347), // Rule ID 6193 //
     /* 1662266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1662277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1662280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1662283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1662286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1662289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662312 */     // MIs[0] policy
     /* 1662312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662322 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662346 */     // GIR_Coverage, 6193,
     /* 1662346 */     GIR_EraseRootFromParent_Done,
     /* 1662347 */   // Label 22815: @1662347
     /* 1662347 */   GIM_Try, /*On fail goto*//*Label 22816*/ GIMT_Encode4(1662433), // Rule ID 6196 //
     /* 1662352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1662363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1662366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1662369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1662372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662398 */     // MIs[0] policy
     /* 1662398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662408 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1662411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662432 */     // GIR_Coverage, 6196,
     /* 1662432 */     GIR_EraseRootFromParent_Done,
     /* 1662433 */   // Label 22816: @1662433
     /* 1662433 */   GIM_Try, /*On fail goto*//*Label 22817*/ GIMT_Encode4(1662519), // Rule ID 6197 //
     /* 1662438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1662449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1662452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1662455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1662458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662484 */     // MIs[0] policy
     /* 1662484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662494 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF4_MASK),
     /* 1662497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662518 */     // GIR_Coverage, 6197,
     /* 1662518 */     GIR_EraseRootFromParent_Done,
     /* 1662519 */   // Label 22817: @1662519
     /* 1662519 */   GIM_Try, /*On fail goto*//*Label 22818*/ GIMT_Encode4(1662605), // Rule ID 6200 //
     /* 1662524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662570 */     // MIs[0] policy
     /* 1662570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662580 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662604 */     // GIR_Coverage, 6200,
     /* 1662604 */     GIR_EraseRootFromParent_Done,
     /* 1662605 */   // Label 22818: @1662605
     /* 1662605 */   GIM_Try, /*On fail goto*//*Label 22819*/ GIMT_Encode4(1662691), // Rule ID 6201 //
     /* 1662610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1662621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1662624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1662627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1662630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1662633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662656 */     // MIs[0] policy
     /* 1662656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662666 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1662687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662690 */     // GIR_Coverage, 6201,
     /* 1662690 */     GIR_EraseRootFromParent_Done,
     /* 1662691 */   // Label 22819: @1662691
     /* 1662691 */   GIM_Try, /*On fail goto*//*Label 22820*/ GIMT_Encode4(1662777), // Rule ID 6204 //
     /* 1662696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662742 */     // MIs[0] policy
     /* 1662742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662752 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662776 */     // GIR_Coverage, 6204,
     /* 1662776 */     GIR_EraseRootFromParent_Done,
     /* 1662777 */   // Label 22820: @1662777
     /* 1662777 */   GIM_Try, /*On fail goto*//*Label 22821*/ GIMT_Encode4(1662863), // Rule ID 6205 //
     /* 1662782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1662793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1662796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1662799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1662802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1662805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662828 */     // MIs[0] policy
     /* 1662828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662838 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1662838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_MF2_MASK),
     /* 1662841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1662859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662862 */     // GIR_Coverage, 6205,
     /* 1662862 */     GIR_EraseRootFromParent_Done,
     /* 1662863 */   // Label 22821: @1662863
     /* 1662863 */   GIM_Try, /*On fail goto*//*Label 22822*/ GIMT_Encode4(1662949), // Rule ID 6208 //
     /* 1662868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1662871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1662894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1662914 */     // MIs[0] policy
     /* 1662914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1662917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1662924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1662924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1662927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1662929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1662931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1662933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1662935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1662937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1662942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1662945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1662947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1662948 */     // GIR_Coverage, 6208,
     /* 1662948 */     GIR_EraseRootFromParent_Done,
     /* 1662949 */   // Label 22822: @1662949
     /* 1662949 */   GIM_Try, /*On fail goto*//*Label 22823*/ GIMT_Encode4(1663035), // Rule ID 6209 //
     /* 1662954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1662957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1662962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1662965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1662968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1662971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1662974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1662977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1662980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1662984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1662996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663000 */     // MIs[0] policy
     /* 1663000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663010 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663034 */     // GIR_Coverage, 6209,
     /* 1663034 */     GIR_EraseRootFromParent_Done,
     /* 1663035 */   // Label 22823: @1663035
     /* 1663035 */   GIM_Try, /*On fail goto*//*Label 22824*/ GIMT_Encode4(1663121), // Rule ID 6212 //
     /* 1663040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1663060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663086 */     // MIs[0] policy
     /* 1663086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663096 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663120 */     // GIR_Coverage, 6212,
     /* 1663120 */     GIR_EraseRootFromParent_Done,
     /* 1663121 */   // Label 22824: @1663121
     /* 1663121 */   GIM_Try, /*On fail goto*//*Label 22825*/ GIMT_Encode4(1663207), // Rule ID 6213 //
     /* 1663126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1663137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1663140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1663143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1663146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1663149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663172 */     // MIs[0] policy
     /* 1663172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663182 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1663203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663206 */     // GIR_Coverage, 6213,
     /* 1663206 */     GIR_EraseRootFromParent_Done,
     /* 1663207 */   // Label 22825: @1663207
     /* 1663207 */   GIM_Try, /*On fail goto*//*Label 22826*/ GIMT_Encode4(1663293), // Rule ID 6216 //
     /* 1663212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1663232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663258 */     // MIs[0] policy
     /* 1663258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663268 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663292 */     // GIR_Coverage, 6216,
     /* 1663292 */     GIR_EraseRootFromParent_Done,
     /* 1663293 */   // Label 22826: @1663293
     /* 1663293 */   GIM_Try, /*On fail goto*//*Label 22827*/ GIMT_Encode4(1663379), // Rule ID 6217 //
     /* 1663298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1663309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1663312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1663315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1663318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1663321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663344 */     // MIs[0] policy
     /* 1663344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663354 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1663375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663378 */     // GIR_Coverage, 6217,
     /* 1663378 */     GIR_EraseRootFromParent_Done,
     /* 1663379 */   // Label 22827: @1663379
     /* 1663379 */   GIM_Try, /*On fail goto*//*Label 22828*/ GIMT_Encode4(1663465), // Rule ID 6220 //
     /* 1663384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1663387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1663395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1663398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1663401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1663404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663430 */     // MIs[0] policy
     /* 1663430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663440 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1663461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663464 */     // GIR_Coverage, 6220,
     /* 1663464 */     GIR_EraseRootFromParent_Done,
     /* 1663465 */   // Label 22828: @1663465
     /* 1663465 */   GIM_Try, /*On fail goto*//*Label 22829*/ GIMT_Encode4(1663551), // Rule ID 6221 //
     /* 1663470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1663473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1663481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1663484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1663487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1663490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1663493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1663500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1663512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663516 */     // MIs[0] policy
     /* 1663516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663526 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M1_MASK),
     /* 1663529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1663547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663550 */     // GIR_Coverage, 6221,
     /* 1663550 */     GIR_EraseRootFromParent_Done,
     /* 1663551 */   // Label 22829: @1663551
     /* 1663551 */   GIM_Try, /*On fail goto*//*Label 22830*/ GIMT_Encode4(1663637), // Rule ID 6224 //
     /* 1663556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663602 */     // MIs[0] policy
     /* 1663602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663612 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1663615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663636 */     // GIR_Coverage, 6224,
     /* 1663636 */     GIR_EraseRootFromParent_Done,
     /* 1663637 */   // Label 22830: @1663637
     /* 1663637 */   GIM_Try, /*On fail goto*//*Label 22831*/ GIMT_Encode4(1663723), // Rule ID 6225 //
     /* 1663642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1663653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1663656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1663659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1663662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1663665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1663672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1663684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663688 */     // MIs[0] policy
     /* 1663688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663698 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1663701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663722 */     // GIR_Coverage, 6225,
     /* 1663722 */     GIR_EraseRootFromParent_Done,
     /* 1663723 */   // Label 22831: @1663723
     /* 1663723 */   GIM_Try, /*On fail goto*//*Label 22832*/ GIMT_Encode4(1663809), // Rule ID 6228 //
     /* 1663728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663774 */     // MIs[0] policy
     /* 1663774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663784 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1663787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663808 */     // GIR_Coverage, 6228,
     /* 1663808 */     GIR_EraseRootFromParent_Done,
     /* 1663809 */   // Label 22832: @1663809
     /* 1663809 */   GIM_Try, /*On fail goto*//*Label 22833*/ GIMT_Encode4(1663895), // Rule ID 6229 //
     /* 1663814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1663825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1663828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1663831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1663834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1663837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1663840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1663844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1663856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663860 */     // MIs[0] policy
     /* 1663860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663870 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1663870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1663873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663894 */     // GIR_Coverage, 6229,
     /* 1663894 */     GIR_EraseRootFromParent_Done,
     /* 1663895 */   // Label 22833: @1663895
     /* 1663895 */   GIM_Try, /*On fail goto*//*Label 22834*/ GIMT_Encode4(1663981), // Rule ID 6232 //
     /* 1663900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1663903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1663914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1663917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1663920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1663923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1663926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1663930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1663942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1663946 */     // MIs[0] policy
     /* 1663946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1663949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1663956 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1663956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1663959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1663961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1663963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1663965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1663967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1663969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1663974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1663977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1663979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1663980 */     // GIR_Coverage, 6232,
     /* 1663980 */     GIR_EraseRootFromParent_Done,
     /* 1663981 */   // Label 22834: @1663981
     /* 1663981 */   GIM_Try, /*On fail goto*//*Label 22835*/ GIMT_Encode4(1664067), // Rule ID 6233 //
     /* 1663986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1663989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1663994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1663997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1664000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1664003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1664006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1664009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664032 */     // MIs[0] policy
     /* 1664032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664042 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1664045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1664063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664066 */     // GIR_Coverage, 6233,
     /* 1664066 */     GIR_EraseRootFromParent_Done,
     /* 1664067 */   // Label 22835: @1664067
     /* 1664067 */   GIM_Try, /*On fail goto*//*Label 22836*/ GIMT_Encode4(1664153), // Rule ID 6236 //
     /* 1664072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1664083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1664086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1664089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1664092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664118 */     // MIs[0] policy
     /* 1664118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664128 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1664131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664152 */     // GIR_Coverage, 6236,
     /* 1664152 */     GIR_EraseRootFromParent_Done,
     /* 1664153 */   // Label 22836: @1664153
     /* 1664153 */   GIM_Try, /*On fail goto*//*Label 22837*/ GIMT_Encode4(1664239), // Rule ID 6237 //
     /* 1664158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1664169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1664172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1664175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1664178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664204 */     // MIs[0] policy
     /* 1664204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664214 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1664217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664238 */     // GIR_Coverage, 6237,
     /* 1664238 */     GIR_EraseRootFromParent_Done,
     /* 1664239 */   // Label 22837: @1664239
     /* 1664239 */   GIM_Try, /*On fail goto*//*Label 22838*/ GIMT_Encode4(1664325), // Rule ID 6240 //
     /* 1664244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1664264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664290 */     // MIs[0] policy
     /* 1664290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664300 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1664303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664324 */     // GIR_Coverage, 6240,
     /* 1664324 */     GIR_EraseRootFromParent_Done,
     /* 1664325 */   // Label 22838: @1664325
     /* 1664325 */   GIM_Try, /*On fail goto*//*Label 22839*/ GIMT_Encode4(1664411), // Rule ID 6241 //
     /* 1664330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1664341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1664344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1664347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1664350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664376 */     // MIs[0] policy
     /* 1664376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664386 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1664389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664410 */     // GIR_Coverage, 6241,
     /* 1664410 */     GIR_EraseRootFromParent_Done,
     /* 1664411 */   // Label 22839: @1664411
     /* 1664411 */   GIM_Try, /*On fail goto*//*Label 22840*/ GIMT_Encode4(1664497), // Rule ID 6244 //
     /* 1664416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1664436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664462 */     // MIs[0] policy
     /* 1664462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664472 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1664475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664496 */     // GIR_Coverage, 6244,
     /* 1664496 */     GIR_EraseRootFromParent_Done,
     /* 1664497 */   // Label 22840: @1664497
     /* 1664497 */   GIM_Try, /*On fail goto*//*Label 22841*/ GIMT_Encode4(1664583), // Rule ID 6245 //
     /* 1664502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1664513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1664516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1664519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1664522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1664525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664548 */     // MIs[0] policy
     /* 1664548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664558 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1664561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1664579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664582 */     // GIR_Coverage, 6245,
     /* 1664582 */     GIR_EraseRootFromParent_Done,
     /* 1664583 */   // Label 22841: @1664583
     /* 1664583 */   GIM_Try, /*On fail goto*//*Label 22842*/ GIMT_Encode4(1664669), // Rule ID 6248 //
     /* 1664588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664634 */     // MIs[0] policy
     /* 1664634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664644 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1664647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664668 */     // GIR_Coverage, 6248,
     /* 1664668 */     GIR_EraseRootFromParent_Done,
     /* 1664669 */   // Label 22842: @1664669
     /* 1664669 */   GIM_Try, /*On fail goto*//*Label 22843*/ GIMT_Encode4(1664755), // Rule ID 6249 //
     /* 1664674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1664685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1664688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1664691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1664694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1664697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1664704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1664716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664720 */     // MIs[0] policy
     /* 1664720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664730 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1664733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664754 */     // GIR_Coverage, 6249,
     /* 1664754 */     GIR_EraseRootFromParent_Done,
     /* 1664755 */   // Label 22843: @1664755
     /* 1664755 */   GIM_Try, /*On fail goto*//*Label 22844*/ GIMT_Encode4(1664841), // Rule ID 6252 //
     /* 1664760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664806 */     // MIs[0] policy
     /* 1664806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664816 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1664819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664840 */     // GIR_Coverage, 6252,
     /* 1664840 */     GIR_EraseRootFromParent_Done,
     /* 1664841 */   // Label 22844: @1664841
     /* 1664841 */   GIM_Try, /*On fail goto*//*Label 22845*/ GIMT_Encode4(1664927), // Rule ID 6253 //
     /* 1664846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1664849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1664857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1664860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1664863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1664866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1664869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1664872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1664876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1664888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664892 */     // MIs[0] policy
     /* 1664892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664902 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1664902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1664905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1664915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1664920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1664923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1664925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1664926 */     // GIR_Coverage, 6253,
     /* 1664926 */     GIR_EraseRootFromParent_Done,
     /* 1664927 */   // Label 22845: @1664927
     /* 1664927 */   GIM_Try, /*On fail goto*//*Label 22846*/ GIMT_Encode4(1665013), // Rule ID 6256 //
     /* 1664932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1664935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1664940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1664943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1664946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1664949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1664952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1664955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1664958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1664962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1664974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1664978 */     // MIs[0] policy
     /* 1664978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1664981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1664988 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1664988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1664991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1664993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1664995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1664997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1664999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665012 */     // GIR_Coverage, 6256,
     /* 1665012 */     GIR_EraseRootFromParent_Done,
     /* 1665013 */   // Label 22846: @1665013
     /* 1665013 */   GIM_Try, /*On fail goto*//*Label 22847*/ GIMT_Encode4(1665099), // Rule ID 6257 //
     /* 1665018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1665029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1665032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1665035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1665038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1665041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665064 */     // MIs[0] policy
     /* 1665064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665074 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1665077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1665095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665098 */     // GIR_Coverage, 6257,
     /* 1665098 */     GIR_EraseRootFromParent_Done,
     /* 1665099 */   // Label 22847: @1665099
     /* 1665099 */   GIM_Try, /*On fail goto*//*Label 22848*/ GIMT_Encode4(1665185), // Rule ID 6260 //
     /* 1665104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1665107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1665124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665150 */     // MIs[0] policy
     /* 1665150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665160 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1665163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665184 */     // GIR_Coverage, 6260,
     /* 1665184 */     GIR_EraseRootFromParent_Done,
     /* 1665185 */   // Label 22848: @1665185
     /* 1665185 */   GIM_Try, /*On fail goto*//*Label 22849*/ GIMT_Encode4(1665271), // Rule ID 6261 //
     /* 1665190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1665201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1665204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1665207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1665210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1665220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1665232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665236 */     // MIs[0] policy
     /* 1665236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M2_MASK),
     /* 1665249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665270 */     // GIR_Coverage, 6261,
     /* 1665270 */     GIR_EraseRootFromParent_Done,
     /* 1665271 */   // Label 22849: @1665271
     /* 1665271 */   GIM_Try, /*On fail goto*//*Label 22850*/ GIMT_Encode4(1665357), // Rule ID 6264 //
     /* 1665276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1665279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1665296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665322 */     // MIs[0] policy
     /* 1665322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1665335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665356 */     // GIR_Coverage, 6264,
     /* 1665356 */     GIR_EraseRootFromParent_Done,
     /* 1665357 */   // Label 22850: @1665357
     /* 1665357 */   GIM_Try, /*On fail goto*//*Label 22851*/ GIMT_Encode4(1665443), // Rule ID 6265 //
     /* 1665362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1665373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1665376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1665379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1665382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1665392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1665404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665408 */     // MIs[0] policy
     /* 1665408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665418 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M4_MASK),
     /* 1665421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665442 */     // GIR_Coverage, 6265,
     /* 1665442 */     GIR_EraseRootFromParent_Done,
     /* 1665443 */   // Label 22851: @1665443
     /* 1665443 */   GIM_Try, /*On fail goto*//*Label 22852*/ GIMT_Encode4(1665529), // Rule ID 6268 //
     /* 1665448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1665451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665494 */     // MIs[0] policy
     /* 1665494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665504 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1665507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665528 */     // GIR_Coverage, 6268,
     /* 1665528 */     GIR_EraseRootFromParent_Done,
     /* 1665529 */   // Label 22852: @1665529
     /* 1665529 */   GIM_Try, /*On fail goto*//*Label 22853*/ GIMT_Encode4(1665615), // Rule ID 6269 //
     /* 1665534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1665537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1665545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1665548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1665551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1665554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1665557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1665564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1665576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665580 */     // MIs[0] policy
     /* 1665580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665590 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VV_M8_MASK),
     /* 1665593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1665611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665614 */     // GIR_Coverage, 6269,
     /* 1665614 */     GIR_EraseRootFromParent_Done,
     /* 1665615 */   // Label 22853: @1665615
     /* 1665615 */   GIM_Try, /*On fail goto*//*Label 22854*/ GIMT_Encode4(1665701), // Rule ID 6272 //
     /* 1665620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665666 */     // MIs[0] policy
     /* 1665666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665676 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1665679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665700 */     // GIR_Coverage, 6272,
     /* 1665700 */     GIR_EraseRootFromParent_Done,
     /* 1665701 */   // Label 22854: @1665701
     /* 1665701 */   GIM_Try, /*On fail goto*//*Label 22855*/ GIMT_Encode4(1665787), // Rule ID 6273 //
     /* 1665706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1665717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1665720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1665723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1665729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665752 */     // MIs[0] policy
     /* 1665752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665762 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF8_MASK),
     /* 1665765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665786 */     // GIR_Coverage, 6273,
     /* 1665786 */     GIR_EraseRootFromParent_Done,
     /* 1665787 */   // Label 22855: @1665787
     /* 1665787 */   GIM_Try, /*On fail goto*//*Label 22856*/ GIMT_Encode4(1665873), // Rule ID 6276 //
     /* 1665792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665838 */     // MIs[0] policy
     /* 1665838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665848 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1665848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1665851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665872 */     // GIR_Coverage, 6276,
     /* 1665872 */     GIR_EraseRootFromParent_Done,
     /* 1665873 */   // Label 22856: @1665873
     /* 1665873 */   GIM_Try, /*On fail goto*//*Label 22857*/ GIMT_Encode4(1665959), // Rule ID 6277 //
     /* 1665878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1665881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1665889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1665892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1665895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1665898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1665901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1665904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1665920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1665924 */     // MIs[0] policy
     /* 1665924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1665927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1665934 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1665934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1665937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1665939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1665941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1665943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1665945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1665947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1665952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1665955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1665957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1665958 */     // GIR_Coverage, 6277,
     /* 1665958 */     GIR_EraseRootFromParent_Done,
     /* 1665959 */   // Label 22857: @1665959
     /* 1665959 */   GIM_Try, /*On fail goto*//*Label 22858*/ GIMT_Encode4(1666045), // Rule ID 6280 //
     /* 1665964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1665967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1665972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1665975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1665978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1665981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1665984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1665987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1665990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1665994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1665998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666010 */     // MIs[0] policy
     /* 1666010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666020 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666044 */     // GIR_Coverage, 6280,
     /* 1666044 */     GIR_EraseRootFromParent_Done,
     /* 1666045 */   // Label 22858: @1666045
     /* 1666045 */   GIM_Try, /*On fail goto*//*Label 22859*/ GIMT_Encode4(1666131), // Rule ID 6281 //
     /* 1666050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1666061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1666064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1666067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666096 */     // MIs[0] policy
     /* 1666096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666106 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666130 */     // GIR_Coverage, 6281,
     /* 1666130 */     GIR_EraseRootFromParent_Done,
     /* 1666131 */   // Label 22859: @1666131
     /* 1666131 */   GIM_Try, /*On fail goto*//*Label 22860*/ GIMT_Encode4(1666217), // Rule ID 6284 //
     /* 1666136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1666147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1666150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1666153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666182 */     // MIs[0] policy
     /* 1666182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666192 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1666195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666216 */     // GIR_Coverage, 6284,
     /* 1666216 */     GIR_EraseRootFromParent_Done,
     /* 1666217 */   // Label 22860: @1666217
     /* 1666217 */   GIM_Try, /*On fail goto*//*Label 22861*/ GIMT_Encode4(1666303), // Rule ID 6285 //
     /* 1666222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1666233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1666236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1666239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666268 */     // MIs[0] policy
     /* 1666268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666278 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF4_MASK),
     /* 1666281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666302 */     // GIR_Coverage, 6285,
     /* 1666302 */     GIR_EraseRootFromParent_Done,
     /* 1666303 */   // Label 22861: @1666303
     /* 1666303 */   GIM_Try, /*On fail goto*//*Label 22862*/ GIMT_Encode4(1666389), // Rule ID 6288 //
     /* 1666308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1666319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1666322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1666325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666354 */     // MIs[0] policy
     /* 1666354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666364 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666388 */     // GIR_Coverage, 6288,
     /* 1666388 */     GIR_EraseRootFromParent_Done,
     /* 1666389 */   // Label 22862: @1666389
     /* 1666389 */   GIM_Try, /*On fail goto*//*Label 22863*/ GIMT_Encode4(1666475), // Rule ID 6289 //
     /* 1666394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1666405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1666408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1666411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1666417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666440 */     // MIs[0] policy
     /* 1666440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666450 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666474 */     // GIR_Coverage, 6289,
     /* 1666474 */     GIR_EraseRootFromParent_Done,
     /* 1666475 */   // Label 22863: @1666475
     /* 1666475 */   GIM_Try, /*On fail goto*//*Label 22864*/ GIMT_Encode4(1666561), // Rule ID 6292 //
     /* 1666480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1666491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1666494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1666497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666526 */     // MIs[0] policy
     /* 1666526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666536 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666560 */     // GIR_Coverage, 6292,
     /* 1666560 */     GIR_EraseRootFromParent_Done,
     /* 1666561 */   // Label 22864: @1666561
     /* 1666561 */   GIM_Try, /*On fail goto*//*Label 22865*/ GIMT_Encode4(1666647), // Rule ID 6293 //
     /* 1666566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1666577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1666580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1666583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1666589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666612 */     // MIs[0] policy
     /* 1666612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666622 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_MF2_MASK),
     /* 1666625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1666643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666646 */     // GIR_Coverage, 6293,
     /* 1666646 */     GIR_EraseRootFromParent_Done,
     /* 1666647 */   // Label 22865: @1666647
     /* 1666647 */   GIM_Try, /*On fail goto*//*Label 22866*/ GIMT_Encode4(1666733), // Rule ID 6296 //
     /* 1666652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666698 */     // MIs[0] policy
     /* 1666698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666708 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1666711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666732 */     // GIR_Coverage, 6296,
     /* 1666732 */     GIR_EraseRootFromParent_Done,
     /* 1666733 */   // Label 22866: @1666733
     /* 1666733 */   GIM_Try, /*On fail goto*//*Label 22867*/ GIMT_Encode4(1666819), // Rule ID 6297 //
     /* 1666738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1666749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1666752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1666755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1666761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666784 */     // MIs[0] policy
     /* 1666784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666794 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11607:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1666797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1666815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666818 */     // GIR_Coverage, 6297,
     /* 1666818 */     GIR_EraseRootFromParent_Done,
     /* 1666819 */   // Label 22867: @1666819
     /* 1666819 */   GIM_Try, /*On fail goto*//*Label 22868*/ GIMT_Encode4(1666905), // Rule ID 6300 //
     /* 1666824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1666844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1666850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666870 */     // MIs[0] policy
     /* 1666870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666880 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1666880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1666883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666904 */     // GIR_Coverage, 6300,
     /* 1666904 */     GIR_EraseRootFromParent_Done,
     /* 1666905 */   // Label 22868: @1666905
     /* 1666905 */   GIM_Try, /*On fail goto*//*Label 22869*/ GIMT_Encode4(1666991), // Rule ID 6301 //
     /* 1666910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1666913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1666918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1666921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1666924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1666927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1666930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1666933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1666936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1666940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1666948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1666952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1666956 */     // MIs[0] policy
     /* 1666956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1666959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1666966 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11607:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1666966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1666969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1666971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1666973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1666975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1666977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1666979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1666984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1666987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1666989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1666990 */     // GIR_Coverage, 6301,
     /* 1666990 */     GIR_EraseRootFromParent_Done,
     /* 1666991 */   // Label 22869: @1666991
     /* 1666991 */   GIM_Try, /*On fail goto*//*Label 22870*/ GIMT_Encode4(1667077), // Rule ID 6304 //
     /* 1666996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1666999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1667007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1667010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1667013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667042 */     // MIs[0] policy
     /* 1667042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667052 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1667055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667076 */     // GIR_Coverage, 6304,
     /* 1667076 */     GIR_EraseRootFromParent_Done,
     /* 1667077 */   // Label 22870: @1667077
     /* 1667077 */   GIM_Try, /*On fail goto*//*Label 22871*/ GIMT_Encode4(1667163), // Rule ID 6305 //
     /* 1667082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1667093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1667096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1667099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1667105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667128 */     // MIs[0] policy
     /* 1667128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667138 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11607:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1667141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1667159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667162 */     // GIR_Coverage, 6305,
     /* 1667162 */     GIR_EraseRootFromParent_Done,
     /* 1667163 */   // Label 22871: @1667163
     /* 1667163 */   GIM_Try, /*On fail goto*//*Label 22872*/ GIMT_Encode4(1667249), // Rule ID 6308 //
     /* 1667168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1667171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667214 */     // MIs[0] policy
     /* 1667214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667224 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1667227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667248 */     // GIR_Coverage, 6308,
     /* 1667248 */     GIR_EraseRootFromParent_Done,
     /* 1667249 */   // Label 22872: @1667249
     /* 1667249 */   GIM_Try, /*On fail goto*//*Label 22873*/ GIMT_Encode4(1667335), // Rule ID 6309 //
     /* 1667254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1667257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1667265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1667268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1667271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1667277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1667284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1667292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667300 */     // MIs[0] policy
     /* 1667300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667310 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11607:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M1_MASK),
     /* 1667313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1667331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667334 */     // GIR_Coverage, 6309,
     /* 1667334 */     GIR_EraseRootFromParent_Done,
     /* 1667335 */   // Label 22873: @1667335
     /* 1667335 */   GIM_Try, /*On fail goto*//*Label 22874*/ GIMT_Encode4(1667421), // Rule ID 6312 //
     /* 1667340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1667351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1667354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1667357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667386 */     // MIs[0] policy
     /* 1667386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667396 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1667399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667420 */     // GIR_Coverage, 6312,
     /* 1667420 */     GIR_EraseRootFromParent_Done,
     /* 1667421 */   // Label 22874: @1667421
     /* 1667421 */   GIM_Try, /*On fail goto*//*Label 22875*/ GIMT_Encode4(1667507), // Rule ID 6313 //
     /* 1667426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1667437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1667440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1667443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1667449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667472 */     // MIs[0] policy
     /* 1667472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1667485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667506 */     // GIR_Coverage, 6313,
     /* 1667506 */     GIR_EraseRootFromParent_Done,
     /* 1667507 */   // Label 22875: @1667507
     /* 1667507 */   GIM_Try, /*On fail goto*//*Label 22876*/ GIMT_Encode4(1667593), // Rule ID 6316 //
     /* 1667512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667558 */     // MIs[0] policy
     /* 1667558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667568 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1667571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667592 */     // GIR_Coverage, 6316,
     /* 1667592 */     GIR_EraseRootFromParent_Done,
     /* 1667593 */   // Label 22876: @1667593
     /* 1667593 */   GIM_Try, /*On fail goto*//*Label 22877*/ GIMT_Encode4(1667679), // Rule ID 6317 //
     /* 1667598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1667609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1667612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1667615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1667621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1667628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1667636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667644 */     // MIs[0] policy
     /* 1667644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667654 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1667657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667678 */     // GIR_Coverage, 6317,
     /* 1667678 */     GIR_EraseRootFromParent_Done,
     /* 1667679 */   // Label 22877: @1667679
     /* 1667679 */   GIM_Try, /*On fail goto*//*Label 22878*/ GIMT_Encode4(1667765), // Rule ID 6320 //
     /* 1667684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667730 */     // MIs[0] policy
     /* 1667730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1667743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667764 */     // GIR_Coverage, 6320,
     /* 1667764 */     GIR_EraseRootFromParent_Done,
     /* 1667765 */   // Label 22878: @1667765
     /* 1667765 */   GIM_Try, /*On fail goto*//*Label 22879*/ GIMT_Encode4(1667851), // Rule ID 6321 //
     /* 1667770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1667781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1667784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1667787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1667793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1667800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1667808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667816 */     // MIs[0] policy
     /* 1667816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667826 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1667829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1667847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667850 */     // GIR_Coverage, 6321,
     /* 1667850 */     GIR_EraseRootFromParent_Done,
     /* 1667851 */   // Label 22879: @1667851
     /* 1667851 */   GIM_Try, /*On fail goto*//*Label 22880*/ GIMT_Encode4(1667937), // Rule ID 6324 //
     /* 1667856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1667859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1667876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1667882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667902 */     // MIs[0] policy
     /* 1667902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667912 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1667912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1667915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1667917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1667919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1667921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1667923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1667925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1667930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1667933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1667935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1667936 */     // GIR_Coverage, 6324,
     /* 1667936 */     GIR_EraseRootFromParent_Done,
     /* 1667937 */   // Label 22880: @1667937
     /* 1667937 */   GIM_Try, /*On fail goto*//*Label 22881*/ GIMT_Encode4(1668023), // Rule ID 6325 //
     /* 1667942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1667945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1667950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1667953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1667956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1667959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1667962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1667965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1667968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1667972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1667980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1667984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1667988 */     // MIs[0] policy
     /* 1667988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1667991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1667998 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1667998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1668001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668022 */     // GIR_Coverage, 6325,
     /* 1668022 */     GIR_EraseRootFromParent_Done,
     /* 1668023 */   // Label 22881: @1668023
     /* 1668023 */   GIM_Try, /*On fail goto*//*Label 22882*/ GIMT_Encode4(1668109), // Rule ID 6328 //
     /* 1668028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1668039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1668042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1668045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668074 */     // MIs[0] policy
     /* 1668074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668084 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1668087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668108 */     // GIR_Coverage, 6328,
     /* 1668108 */     GIR_EraseRootFromParent_Done,
     /* 1668109 */   // Label 22882: @1668109
     /* 1668109 */   GIM_Try, /*On fail goto*//*Label 22883*/ GIMT_Encode4(1668195), // Rule ID 6329 //
     /* 1668114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1668125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1668128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1668131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668160 */     // MIs[0] policy
     /* 1668160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668170 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1668173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668194 */     // GIR_Coverage, 6329,
     /* 1668194 */     GIR_EraseRootFromParent_Done,
     /* 1668195 */   // Label 22883: @1668195
     /* 1668195 */   GIM_Try, /*On fail goto*//*Label 22884*/ GIMT_Encode4(1668281), // Rule ID 6332 //
     /* 1668200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1668211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1668214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1668217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668246 */     // MIs[0] policy
     /* 1668246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668256 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1668259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668280 */     // GIR_Coverage, 6332,
     /* 1668280 */     GIR_EraseRootFromParent_Done,
     /* 1668281 */   // Label 22884: @1668281
     /* 1668281 */   GIM_Try, /*On fail goto*//*Label 22885*/ GIMT_Encode4(1668367), // Rule ID 6333 //
     /* 1668286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1668297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1668300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1668303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1668309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668332 */     // MIs[0] policy
     /* 1668332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668342 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1668345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1668363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668366 */     // GIR_Coverage, 6333,
     /* 1668366 */     GIR_EraseRootFromParent_Done,
     /* 1668367 */   // Label 22885: @1668367
     /* 1668367 */   GIM_Try, /*On fail goto*//*Label 22886*/ GIMT_Encode4(1668453), // Rule ID 6336 //
     /* 1668372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1668383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1668386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1668389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668418 */     // MIs[0] policy
     /* 1668418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1668431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668452 */     // GIR_Coverage, 6336,
     /* 1668452 */     GIR_EraseRootFromParent_Done,
     /* 1668453 */   // Label 22886: @1668453
     /* 1668453 */   GIM_Try, /*On fail goto*//*Label 22887*/ GIMT_Encode4(1668539), // Rule ID 6337 //
     /* 1668458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1668469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1668472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1668475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1668481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668504 */     // MIs[0] policy
     /* 1668504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668514 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1668517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668538 */     // GIR_Coverage, 6337,
     /* 1668538 */     GIR_EraseRootFromParent_Done,
     /* 1668539 */   // Label 22887: @1668539
     /* 1668539 */   GIM_Try, /*On fail goto*//*Label 22888*/ GIMT_Encode4(1668625), // Rule ID 6340 //
     /* 1668544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668590 */     // MIs[0] policy
     /* 1668590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668600 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1668603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668624 */     // GIR_Coverage, 6340,
     /* 1668624 */     GIR_EraseRootFromParent_Done,
     /* 1668625 */   // Label 22888: @1668625
     /* 1668625 */   GIM_Try, /*On fail goto*//*Label 22889*/ GIMT_Encode4(1668711), // Rule ID 6341 //
     /* 1668630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1668641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1668644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1668647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1668653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1668660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1668668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668676 */     // MIs[0] policy
     /* 1668676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668686 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1668689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668710 */     // GIR_Coverage, 6341,
     /* 1668710 */     GIR_EraseRootFromParent_Done,
     /* 1668711 */   // Label 22889: @1668711
     /* 1668711 */   GIM_Try, /*On fail goto*//*Label 22890*/ GIMT_Encode4(1668797), // Rule ID 6344 //
     /* 1668716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1668719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668762 */     // MIs[0] policy
     /* 1668762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668772 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1668775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668796 */     // GIR_Coverage, 6344,
     /* 1668796 */     GIR_EraseRootFromParent_Done,
     /* 1668797 */   // Label 22890: @1668797
     /* 1668797 */   GIM_Try, /*On fail goto*//*Label 22891*/ GIMT_Encode4(1668883), // Rule ID 6345 //
     /* 1668802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1668805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1668813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1668816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1668819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1668825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1668828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1668832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1668840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668848 */     // MIs[0] policy
     /* 1668848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668858 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1668858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1668861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1668879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668882 */     // GIR_Coverage, 6345,
     /* 1668882 */     GIR_EraseRootFromParent_Done,
     /* 1668883 */   // Label 22891: @1668883
     /* 1668883 */   GIM_Try, /*On fail goto*//*Label 22892*/ GIMT_Encode4(1668969), // Rule ID 6348 //
     /* 1668888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1668891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1668908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1668914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1668918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1668926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1668930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1668934 */     // MIs[0] policy
     /* 1668934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1668937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1668944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1668944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1668947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1668949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1668951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1668953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1668955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1668957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1668962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1668965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1668967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1668968 */     // GIR_Coverage, 6348,
     /* 1668968 */     GIR_EraseRootFromParent_Done,
     /* 1668969 */   // Label 22892: @1668969
     /* 1668969 */   GIM_Try, /*On fail goto*//*Label 22893*/ GIMT_Encode4(1669055), // Rule ID 6349 //
     /* 1668974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1668977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1668982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1668985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1668988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1668991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1668994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1668997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1669004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1669012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669020 */     // MIs[0] policy
     /* 1669020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11607:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M2_MASK),
     /* 1669033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669054 */     // GIR_Coverage, 6349,
     /* 1669054 */     GIR_EraseRootFromParent_Done,
     /* 1669055 */   // Label 22893: @1669055
     /* 1669055 */   GIM_Try, /*On fail goto*//*Label 22894*/ GIMT_Encode4(1669141), // Rule ID 6352 //
     /* 1669060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1669071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1669074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1669077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669106 */     // MIs[0] policy
     /* 1669106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1669119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669140 */     // GIR_Coverage, 6352,
     /* 1669140 */     GIR_EraseRootFromParent_Done,
     /* 1669141 */   // Label 22894: @1669141
     /* 1669141 */   GIM_Try, /*On fail goto*//*Label 22895*/ GIMT_Encode4(1669227), // Rule ID 6353 //
     /* 1669146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1669149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1669157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1669160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1669163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1669176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1669184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669192 */     // MIs[0] policy
     /* 1669192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11607:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M4_MASK),
     /* 1669205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669226 */     // GIR_Coverage, 6353,
     /* 1669226 */     GIR_EraseRootFromParent_Done,
     /* 1669227 */   // Label 22895: @1669227
     /* 1669227 */   GIM_Try, /*On fail goto*//*Label 22896*/ GIMT_Encode4(1669313), // Rule ID 6356 //
     /* 1669232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1669235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1669243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1669246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1669249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1669252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669278 */     // MIs[0] policy
     /* 1669278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669288 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1669291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669312 */     // GIR_Coverage, 6356,
     /* 1669312 */     GIR_EraseRootFromParent_Done,
     /* 1669313 */   // Label 22896: @1669313
     /* 1669313 */   GIM_Try, /*On fail goto*//*Label 22897*/ GIMT_Encode4(1669399), // Rule ID 6357 //
     /* 1669318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1669321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vxor_mask),
     /* 1669326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1669329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1669332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1669335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1669338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1669341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1669348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1669356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1669360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669364 */     // MIs[0] policy
     /* 1669364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11607:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVXOR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVXOR_VX_M8_MASK),
     /* 1669377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1669395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669398 */     // GIR_Coverage, 6357,
     /* 1669398 */     GIR_EraseRootFromParent_Done,
     /* 1669399 */   // Label 22897: @1669399
     /* 1669399 */   GIM_Try, /*On fail goto*//*Label 22898*/ GIMT_Encode4(1669485), // Rule ID 6448 //
     /* 1669404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1669415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1669418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1669421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1669424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669450 */     // MIs[0] policy
     /* 1669450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1669463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669484 */     // GIR_Coverage, 6448,
     /* 1669484 */     GIR_EraseRootFromParent_Done,
     /* 1669485 */   // Label 22898: @1669485
     /* 1669485 */   GIM_Try, /*On fail goto*//*Label 22899*/ GIMT_Encode4(1669571), // Rule ID 6449 //
     /* 1669490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1669501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1669504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1669507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1669510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669536 */     // MIs[0] policy
     /* 1669536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669546 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8_MASK),
     /* 1669549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669570 */     // GIR_Coverage, 6449,
     /* 1669570 */     GIR_EraseRootFromParent_Done,
     /* 1669571 */   // Label 22899: @1669571
     /* 1669571 */   GIM_Try, /*On fail goto*//*Label 22900*/ GIMT_Encode4(1669657), // Rule ID 6452 //
     /* 1669576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669622 */     // MIs[0] policy
     /* 1669622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669632 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1669635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669656 */     // GIR_Coverage, 6452,
     /* 1669656 */     GIR_EraseRootFromParent_Done,
     /* 1669657 */   // Label 22900: @1669657
     /* 1669657 */   GIM_Try, /*On fail goto*//*Label 22901*/ GIMT_Encode4(1669743), // Rule ID 6453 //
     /* 1669662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1669673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1669676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1669679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1669682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1669685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669708 */     // MIs[0] policy
     /* 1669708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669718 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1669721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669742 */     // GIR_Coverage, 6453,
     /* 1669742 */     GIR_EraseRootFromParent_Done,
     /* 1669743 */   // Label 22901: @1669743
     /* 1669743 */   GIM_Try, /*On fail goto*//*Label 22902*/ GIMT_Encode4(1669829), // Rule ID 6456 //
     /* 1669748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669794 */     // MIs[0] policy
     /* 1669794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669804 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1669807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669828 */     // GIR_Coverage, 6456,
     /* 1669828 */     GIR_EraseRootFromParent_Done,
     /* 1669829 */   // Label 22902: @1669829
     /* 1669829 */   GIM_Try, /*On fail goto*//*Label 22903*/ GIMT_Encode4(1669915), // Rule ID 6457 //
     /* 1669834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1669837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1669845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1669848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1669851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1669854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1669857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1669860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669880 */     // MIs[0] policy
     /* 1669880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669890 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1669890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1669893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1669911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1669914 */     // GIR_Coverage, 6457,
     /* 1669914 */     GIR_EraseRootFromParent_Done,
     /* 1669915 */   // Label 22903: @1669915
     /* 1669915 */   GIM_Try, /*On fail goto*//*Label 22904*/ GIMT_Encode4(1670001), // Rule ID 6460 //
     /* 1669920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1669923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1669928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1669931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1669934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1669937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1669940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1669943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1669946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1669950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1669962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1669966 */     // MIs[0] policy
     /* 1669966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1669969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1669976 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1669976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1669979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1669981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1669983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1669985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1669987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1669989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1669994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1669997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1669999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670000 */     // GIR_Coverage, 6460,
     /* 1670000 */     GIR_EraseRootFromParent_Done,
     /* 1670001 */   // Label 22904: @1670001
     /* 1670001 */   GIM_Try, /*On fail goto*//*Label 22905*/ GIMT_Encode4(1670087), // Rule ID 6461 //
     /* 1670006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1670017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1670020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1670023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1670026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670052 */     // MIs[0] policy
     /* 1670052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670062 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4_MASK),
     /* 1670065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670086 */     // GIR_Coverage, 6461,
     /* 1670086 */     GIR_EraseRootFromParent_Done,
     /* 1670087 */   // Label 22905: @1670087
     /* 1670087 */   GIM_Try, /*On fail goto*//*Label 22906*/ GIMT_Encode4(1670173), // Rule ID 6464 //
     /* 1670092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1670103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1670106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1670109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1670112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670138 */     // MIs[0] policy
     /* 1670138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1670151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670172 */     // GIR_Coverage, 6464,
     /* 1670172 */     GIR_EraseRootFromParent_Done,
     /* 1670173 */   // Label 22906: @1670173
     /* 1670173 */   GIM_Try, /*On fail goto*//*Label 22907*/ GIMT_Encode4(1670259), // Rule ID 6465 //
     /* 1670178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1670189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1670192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1670195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1670198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670224 */     // MIs[0] policy
     /* 1670224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670234 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1670237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670258 */     // GIR_Coverage, 6465,
     /* 1670258 */     GIR_EraseRootFromParent_Done,
     /* 1670259 */   // Label 22907: @1670259
     /* 1670259 */   GIM_Try, /*On fail goto*//*Label 22908*/ GIMT_Encode4(1670345), // Rule ID 6468 //
     /* 1670264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1670275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1670278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1670281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1670284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670310 */     // MIs[0] policy
     /* 1670310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670320 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1670323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670344 */     // GIR_Coverage, 6468,
     /* 1670344 */     GIR_EraseRootFromParent_Done,
     /* 1670345 */   // Label 22908: @1670345
     /* 1670345 */   GIM_Try, /*On fail goto*//*Label 22909*/ GIMT_Encode4(1670431), // Rule ID 6469 //
     /* 1670350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1670361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1670364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1670367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1670370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670396 */     // MIs[0] policy
     /* 1670396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670406 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2_MASK),
     /* 1670409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670430 */     // GIR_Coverage, 6469,
     /* 1670430 */     GIR_EraseRootFromParent_Done,
     /* 1670431 */   // Label 22909: @1670431
     /* 1670431 */   GIM_Try, /*On fail goto*//*Label 22910*/ GIMT_Encode4(1670517), // Rule ID 6472 //
     /* 1670436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670482 */     // MIs[0] policy
     /* 1670482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670492 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670516 */     // GIR_Coverage, 6472,
     /* 1670516 */     GIR_EraseRootFromParent_Done,
     /* 1670517 */   // Label 22910: @1670517
     /* 1670517 */   GIM_Try, /*On fail goto*//*Label 22911*/ GIMT_Encode4(1670603), // Rule ID 6473 //
     /* 1670522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1670533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1670536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1670539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1670542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1670545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670568 */     // MIs[0] policy
     /* 1670568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670578 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1670599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670602 */     // GIR_Coverage, 6473,
     /* 1670602 */     GIR_EraseRootFromParent_Done,
     /* 1670603 */   // Label 22911: @1670603
     /* 1670603 */   GIM_Try, /*On fail goto*//*Label 22912*/ GIMT_Encode4(1670689), // Rule ID 6476 //
     /* 1670608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670654 */     // MIs[0] policy
     /* 1670654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670664 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670688 */     // GIR_Coverage, 6476,
     /* 1670688 */     GIR_EraseRootFromParent_Done,
     /* 1670689 */   // Label 22912: @1670689
     /* 1670689 */   GIM_Try, /*On fail goto*//*Label 22913*/ GIMT_Encode4(1670775), // Rule ID 6477 //
     /* 1670694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1670705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1670708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1670711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1670714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1670717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670740 */     // MIs[0] policy
     /* 1670740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670750 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1670771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670774 */     // GIR_Coverage, 6477,
     /* 1670774 */     GIR_EraseRootFromParent_Done,
     /* 1670775 */   // Label 22913: @1670775
     /* 1670775 */   GIM_Try, /*On fail goto*//*Label 22914*/ GIMT_Encode4(1670861), // Rule ID 6480 //
     /* 1670780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1670783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670826 */     // MIs[0] policy
     /* 1670826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670836 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1670836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670860 */     // GIR_Coverage, 6480,
     /* 1670860 */     GIR_EraseRootFromParent_Done,
     /* 1670861 */   // Label 22914: @1670861
     /* 1670861 */   GIM_Try, /*On fail goto*//*Label 22915*/ GIMT_Encode4(1670947), // Rule ID 6481 //
     /* 1670866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1670869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1670877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1670880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1670883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1670886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1670889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1670892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670912 */     // MIs[0] policy
     /* 1670912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1670915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1670922 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1670922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1670925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1670927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1670929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1670931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1670933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1670935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1670940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1670943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1670945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1670946 */     // GIR_Coverage, 6481,
     /* 1670946 */     GIR_EraseRootFromParent_Done,
     /* 1670947 */   // Label 22915: @1670947
     /* 1670947 */   GIM_Try, /*On fail goto*//*Label 22916*/ GIMT_Encode4(1671033), // Rule ID 6484 //
     /* 1670952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1670955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1670960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1670963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1670966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1670969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1670972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1670975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1670978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1670982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1670994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1670998 */     // MIs[0] policy
     /* 1670998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671008 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1671011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671032 */     // GIR_Coverage, 6484,
     /* 1671032 */     GIR_EraseRootFromParent_Done,
     /* 1671033 */   // Label 22916: @1671033
     /* 1671033 */   GIM_Try, /*On fail goto*//*Label 22917*/ GIMT_Encode4(1671119), // Rule ID 6485 //
     /* 1671038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1671041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1671049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1671052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1671055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1671058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1671061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1671068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1671080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671084 */     // MIs[0] policy
     /* 1671084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671094 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1_MASK),
     /* 1671097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1671115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671118 */     // GIR_Coverage, 6485,
     /* 1671118 */     GIR_EraseRootFromParent_Done,
     /* 1671119 */   // Label 22917: @1671119
     /* 1671119 */   GIM_Try, /*On fail goto*//*Label 22918*/ GIMT_Encode4(1671205), // Rule ID 6488 //
     /* 1671124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1671135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1671138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1671141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1671144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671170 */     // MIs[0] policy
     /* 1671170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671180 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1671183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671204 */     // GIR_Coverage, 6488,
     /* 1671204 */     GIR_EraseRootFromParent_Done,
     /* 1671205 */   // Label 22918: @1671205
     /* 1671205 */   GIM_Try, /*On fail goto*//*Label 22919*/ GIMT_Encode4(1671291), // Rule ID 6489 //
     /* 1671210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1671221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1671224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1671227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1671230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671256 */     // MIs[0] policy
     /* 1671256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1671269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671290 */     // GIR_Coverage, 6489,
     /* 1671290 */     GIR_EraseRootFromParent_Done,
     /* 1671291 */   // Label 22919: @1671291
     /* 1671291 */   GIM_Try, /*On fail goto*//*Label 22920*/ GIMT_Encode4(1671377), // Rule ID 6492 //
     /* 1671296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1671307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1671310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1671313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1671316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671342 */     // MIs[0] policy
     /* 1671342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671352 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1671355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671376 */     // GIR_Coverage, 6492,
     /* 1671376 */     GIR_EraseRootFromParent_Done,
     /* 1671377 */   // Label 22920: @1671377
     /* 1671377 */   GIM_Try, /*On fail goto*//*Label 22921*/ GIMT_Encode4(1671463), // Rule ID 6493 //
     /* 1671382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1671393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1671396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1671399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1671402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1671405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671428 */     // MIs[0] policy
     /* 1671428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1671441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671462 */     // GIR_Coverage, 6493,
     /* 1671462 */     GIR_EraseRootFromParent_Done,
     /* 1671463 */   // Label 22921: @1671463
     /* 1671463 */   GIM_Try, /*On fail goto*//*Label 22922*/ GIMT_Encode4(1671549), // Rule ID 6496 //
     /* 1671468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671514 */     // MIs[0] policy
     /* 1671514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671524 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1671527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671548 */     // GIR_Coverage, 6496,
     /* 1671548 */     GIR_EraseRootFromParent_Done,
     /* 1671549 */   // Label 22922: @1671549
     /* 1671549 */   GIM_Try, /*On fail goto*//*Label 22923*/ GIMT_Encode4(1671635), // Rule ID 6497 //
     /* 1671554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1671565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1671568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1671571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1671574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1671577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1671584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1671596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671600 */     // MIs[0] policy
     /* 1671600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671610 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1671613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1671631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671634 */     // GIR_Coverage, 6497,
     /* 1671634 */     GIR_EraseRootFromParent_Done,
     /* 1671635 */   // Label 22923: @1671635
     /* 1671635 */   GIM_Try, /*On fail goto*//*Label 22924*/ GIMT_Encode4(1671721), // Rule ID 6500 //
     /* 1671640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671686 */     // MIs[0] policy
     /* 1671686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671696 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1671699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671720 */     // GIR_Coverage, 6500,
     /* 1671720 */     GIR_EraseRootFromParent_Done,
     /* 1671721 */   // Label 22924: @1671721
     /* 1671721 */   GIM_Try, /*On fail goto*//*Label 22925*/ GIMT_Encode4(1671807), // Rule ID 6501 //
     /* 1671726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1671737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1671740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1671743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1671746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1671749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1671756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1671768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671772 */     // MIs[0] policy
     /* 1671772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671782 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1671785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671806 */     // GIR_Coverage, 6501,
     /* 1671806 */     GIR_EraseRootFromParent_Done,
     /* 1671807 */   // Label 22925: @1671807
     /* 1671807 */   GIM_Try, /*On fail goto*//*Label 22926*/ GIMT_Encode4(1671893), // Rule ID 6504 //
     /* 1671812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1671838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671858 */     // MIs[0] policy
     /* 1671858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671868 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1671868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1671871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671892 */     // GIR_Coverage, 6504,
     /* 1671892 */     GIR_EraseRootFromParent_Done,
     /* 1671893 */   // Label 22926: @1671893
     /* 1671893 */   GIM_Try, /*On fail goto*//*Label 22927*/ GIMT_Encode4(1671979), // Rule ID 6505 //
     /* 1671898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1671901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1671909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1671912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1671915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1671918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1671921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1671924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1671928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1671940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1671944 */     // MIs[0] policy
     /* 1671944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1671947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1671954 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1671954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1671957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1671959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1671961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1671963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1671965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1671967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1671972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1671975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1671977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1671978 */     // GIR_Coverage, 6505,
     /* 1671978 */     GIR_EraseRootFromParent_Done,
     /* 1671979 */   // Label 22927: @1671979
     /* 1671979 */   GIM_Try, /*On fail goto*//*Label 22928*/ GIMT_Encode4(1672065), // Rule ID 6508 //
     /* 1671984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1671987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1671992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1671995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1671998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1672001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1672004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1672007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672030 */     // MIs[0] policy
     /* 1672030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672040 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1672043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672064 */     // GIR_Coverage, 6508,
     /* 1672064 */     GIR_EraseRootFromParent_Done,
     /* 1672065 */   // Label 22928: @1672065
     /* 1672065 */   GIM_Try, /*On fail goto*//*Label 22929*/ GIMT_Encode4(1672151), // Rule ID 6509 //
     /* 1672070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1672081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1672084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1672087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1672090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1672093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672116 */     // MIs[0] policy
     /* 1672116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672126 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1672129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1672147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672150 */     // GIR_Coverage, 6509,
     /* 1672150 */     GIR_EraseRootFromParent_Done,
     /* 1672151 */   // Label 22929: @1672151
     /* 1672151 */   GIM_Try, /*On fail goto*//*Label 22930*/ GIMT_Encode4(1672237), // Rule ID 6512 //
     /* 1672156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1672167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1672170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1672173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1672176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672202 */     // MIs[0] policy
     /* 1672202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1672215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672236 */     // GIR_Coverage, 6512,
     /* 1672236 */     GIR_EraseRootFromParent_Done,
     /* 1672237 */   // Label 22930: @1672237
     /* 1672237 */   GIM_Try, /*On fail goto*//*Label 22931*/ GIMT_Encode4(1672323), // Rule ID 6513 //
     /* 1672242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1672253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1672256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1672259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1672262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672288 */     // MIs[0] policy
     /* 1672288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1672301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672322 */     // GIR_Coverage, 6513,
     /* 1672322 */     GIR_EraseRootFromParent_Done,
     /* 1672323 */   // Label 22931: @1672323
     /* 1672323 */   GIM_Try, /*On fail goto*//*Label 22932*/ GIMT_Encode4(1672409), // Rule ID 6516 //
     /* 1672328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1672348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672374 */     // MIs[0] policy
     /* 1672374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672384 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1672387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672408 */     // GIR_Coverage, 6516,
     /* 1672408 */     GIR_EraseRootFromParent_Done,
     /* 1672409 */   // Label 22932: @1672409
     /* 1672409 */   GIM_Try, /*On fail goto*//*Label 22933*/ GIMT_Encode4(1672495), // Rule ID 6517 //
     /* 1672414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1672425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1672428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1672431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1672434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1672437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672460 */     // MIs[0] policy
     /* 1672460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672470 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1672473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672494 */     // GIR_Coverage, 6517,
     /* 1672494 */     GIR_EraseRootFromParent_Done,
     /* 1672495 */   // Label 22933: @1672495
     /* 1672495 */   GIM_Try, /*On fail goto*//*Label 22934*/ GIMT_Encode4(1672581), // Rule ID 6520 //
     /* 1672500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1672503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672546 */     // MIs[0] policy
     /* 1672546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1672559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672580 */     // GIR_Coverage, 6520,
     /* 1672580 */     GIR_EraseRootFromParent_Done,
     /* 1672581 */   // Label 22934: @1672581
     /* 1672581 */   GIM_Try, /*On fail goto*//*Label 22935*/ GIMT_Encode4(1672667), // Rule ID 6521 //
     /* 1672586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1672589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1672597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1672600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1672603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1672606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1672609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1672616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1672628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672632 */     // MIs[0] policy
     /* 1672632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672642 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1672645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1672663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672666 */     // GIR_Coverage, 6521,
     /* 1672666 */     GIR_EraseRootFromParent_Done,
     /* 1672667 */   // Label 22935: @1672667
     /* 1672667 */   GIM_Try, /*On fail goto*//*Label 22936*/ GIMT_Encode4(1672753), // Rule ID 6524 //
     /* 1672672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672718 */     // MIs[0] policy
     /* 1672718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1672731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672752 */     // GIR_Coverage, 6524,
     /* 1672752 */     GIR_EraseRootFromParent_Done,
     /* 1672753 */   // Label 22936: @1672753
     /* 1672753 */   GIM_Try, /*On fail goto*//*Label 22937*/ GIMT_Encode4(1672839), // Rule ID 6525 //
     /* 1672758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1672769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1672772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1672775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1672778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1672781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1672788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1672800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672804 */     // MIs[0] policy
     /* 1672804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672814 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2_MASK),
     /* 1672817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672838 */     // GIR_Coverage, 6525,
     /* 1672838 */     GIR_EraseRootFromParent_Done,
     /* 1672839 */   // Label 22937: @1672839
     /* 1672839 */   GIM_Try, /*On fail goto*//*Label 22938*/ GIMT_Encode4(1672925), // Rule ID 6528 //
     /* 1672844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1672847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1672870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672890 */     // MIs[0] policy
     /* 1672890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672900 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1672900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1672903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1672918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1672921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1672923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1672924 */     // GIR_Coverage, 6528,
     /* 1672924 */     GIR_EraseRootFromParent_Done,
     /* 1672925 */   // Label 22938: @1672925
     /* 1672925 */   GIM_Try, /*On fail goto*//*Label 22939*/ GIMT_Encode4(1673011), // Rule ID 6529 //
     /* 1672930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1672933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1672938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1672941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1672944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1672947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1672950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1672953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1672956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1672960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1672972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1672976 */     // MIs[0] policy
     /* 1672976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1672979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1672986 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1672986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4_MASK),
     /* 1672989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1672991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1672993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1672995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1672997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1672999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673010 */     // GIR_Coverage, 6529,
     /* 1673010 */     GIR_EraseRootFromParent_Done,
     /* 1673011 */   // Label 22939: @1673011
     /* 1673011 */   GIM_Try, /*On fail goto*//*Label 22940*/ GIMT_Encode4(1673097), // Rule ID 6532 //
     /* 1673016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1673019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1673027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1673030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1673033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1673036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673062 */     // MIs[0] policy
     /* 1673062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673072 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1673075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673096 */     // GIR_Coverage, 6532,
     /* 1673096 */     GIR_EraseRootFromParent_Done,
     /* 1673097 */   // Label 22940: @1673097
     /* 1673097 */   GIM_Try, /*On fail goto*//*Label 22941*/ GIMT_Encode4(1673183), // Rule ID 6533 //
     /* 1673102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1673105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1673113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1673116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1673119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1673122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1673125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1673132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1673144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673148 */     // MIs[0] policy
     /* 1673148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673158 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8_MASK),
     /* 1673161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1673179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673182 */     // GIR_Coverage, 6533,
     /* 1673182 */     GIR_EraseRootFromParent_Done,
     /* 1673183 */   // Label 22941: @1673183
     /* 1673183 */   GIM_Try, /*On fail goto*//*Label 22942*/ GIMT_Encode4(1673269), // Rule ID 6536 //
     /* 1673188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1673199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1673202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1673205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673234 */     // MIs[0] policy
     /* 1673234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673244 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1673247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673268 */     // GIR_Coverage, 6536,
     /* 1673268 */     GIR_EraseRootFromParent_Done,
     /* 1673269 */   // Label 22942: @1673269
     /* 1673269 */   GIM_Try, /*On fail goto*//*Label 22943*/ GIMT_Encode4(1673355), // Rule ID 6537 //
     /* 1673274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1673285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1673288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1673291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673320 */     // MIs[0] policy
     /* 1673320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673330 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF8_MASK),
     /* 1673333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673354 */     // GIR_Coverage, 6537,
     /* 1673354 */     GIR_EraseRootFromParent_Done,
     /* 1673355 */   // Label 22943: @1673355
     /* 1673355 */   GIM_Try, /*On fail goto*//*Label 22944*/ GIMT_Encode4(1673441), // Rule ID 6540 //
     /* 1673360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1673371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1673374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1673377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673406 */     // MIs[0] policy
     /* 1673406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673416 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1673419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673440 */     // GIR_Coverage, 6540,
     /* 1673440 */     GIR_EraseRootFromParent_Done,
     /* 1673441 */   // Label 22944: @1673441
     /* 1673441 */   GIM_Try, /*On fail goto*//*Label 22945*/ GIMT_Encode4(1673527), // Rule ID 6541 //
     /* 1673446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1673457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1673460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1673463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673492 */     // MIs[0] policy
     /* 1673492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673502 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1673505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673526 */     // GIR_Coverage, 6541,
     /* 1673526 */     GIR_EraseRootFromParent_Done,
     /* 1673527 */   // Label 22945: @1673527
     /* 1673527 */   GIM_Try, /*On fail goto*//*Label 22946*/ GIMT_Encode4(1673613), // Rule ID 6544 //
     /* 1673532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673578 */     // MIs[0] policy
     /* 1673578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673588 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1673591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673612 */     // GIR_Coverage, 6544,
     /* 1673612 */     GIR_EraseRootFromParent_Done,
     /* 1673613 */   // Label 22946: @1673613
     /* 1673613 */   GIM_Try, /*On fail goto*//*Label 22947*/ GIMT_Encode4(1673699), // Rule ID 6545 //
     /* 1673618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1673629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1673632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1673635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1673641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673664 */     // MIs[0] policy
     /* 1673664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673674 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1673677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1673695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673698 */     // GIR_Coverage, 6545,
     /* 1673698 */     GIR_EraseRootFromParent_Done,
     /* 1673699 */   // Label 22947: @1673699
     /* 1673699 */   GIM_Try, /*On fail goto*//*Label 22948*/ GIMT_Encode4(1673785), // Rule ID 6548 //
     /* 1673704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673750 */     // MIs[0] policy
     /* 1673750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673760 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1673763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673784 */     // GIR_Coverage, 6548,
     /* 1673784 */     GIR_EraseRootFromParent_Done,
     /* 1673785 */   // Label 22948: @1673785
     /* 1673785 */   GIM_Try, /*On fail goto*//*Label 22949*/ GIMT_Encode4(1673871), // Rule ID 6549 //
     /* 1673790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1673801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1673804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1673807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1673813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673836 */     // MIs[0] policy
     /* 1673836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673846 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1673846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF4_MASK),
     /* 1673849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673870 */     // GIR_Coverage, 6549,
     /* 1673870 */     GIR_EraseRootFromParent_Done,
     /* 1673871 */   // Label 22949: @1673871
     /* 1673871 */   GIM_Try, /*On fail goto*//*Label 22950*/ GIMT_Encode4(1673957), // Rule ID 6552 //
     /* 1673876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1673879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1673896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1673902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1673918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1673922 */     // MIs[0] policy
     /* 1673922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1673925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1673932 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1673932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1673935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1673937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1673939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1673941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1673943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1673945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1673950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1673953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1673955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1673956 */     // GIR_Coverage, 6552,
     /* 1673956 */     GIR_EraseRootFromParent_Done,
     /* 1673957 */   // Label 22950: @1673957
     /* 1673957 */   GIM_Try, /*On fail goto*//*Label 22951*/ GIMT_Encode4(1674043), // Rule ID 6553 //
     /* 1673962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1673965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1673970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1673973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1673976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1673979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1673982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1673985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1673988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1673992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1673996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674008 */     // MIs[0] policy
     /* 1674008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674018 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1674021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674042 */     // GIR_Coverage, 6553,
     /* 1674042 */     GIR_EraseRootFromParent_Done,
     /* 1674043 */   // Label 22951: @1674043
     /* 1674043 */   GIM_Try, /*On fail goto*//*Label 22952*/ GIMT_Encode4(1674129), // Rule ID 6556 //
     /* 1674048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1674059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1674062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1674065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674094 */     // MIs[0] policy
     /* 1674094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674104 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1674107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674128 */     // GIR_Coverage, 6556,
     /* 1674128 */     GIR_EraseRootFromParent_Done,
     /* 1674129 */   // Label 22952: @1674129
     /* 1674129 */   GIM_Try, /*On fail goto*//*Label 22953*/ GIMT_Encode4(1674215), // Rule ID 6557 //
     /* 1674134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1674145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1674148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1674151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674180 */     // MIs[0] policy
     /* 1674180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674190 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_MF2_MASK),
     /* 1674193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674214 */     // GIR_Coverage, 6557,
     /* 1674214 */     GIR_EraseRootFromParent_Done,
     /* 1674215 */   // Label 22953: @1674215
     /* 1674215 */   GIM_Try, /*On fail goto*//*Label 22954*/ GIMT_Encode4(1674301), // Rule ID 6560 //
     /* 1674220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1674231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1674234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1674237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674266 */     // MIs[0] policy
     /* 1674266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674300 */     // GIR_Coverage, 6560,
     /* 1674300 */     GIR_EraseRootFromParent_Done,
     /* 1674301 */   // Label 22954: @1674301
     /* 1674301 */   GIM_Try, /*On fail goto*//*Label 22955*/ GIMT_Encode4(1674387), // Rule ID 6561 //
     /* 1674306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1674317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1674320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1674323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1674329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674352 */     // MIs[0] policy
     /* 1674352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674362 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11485:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674386 */     // GIR_Coverage, 6561,
     /* 1674386 */     GIR_EraseRootFromParent_Done,
     /* 1674387 */   // Label 22955: @1674387
     /* 1674387 */   GIM_Try, /*On fail goto*//*Label 22956*/ GIMT_Encode4(1674473), // Rule ID 6564 //
     /* 1674392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1674403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1674406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1674409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674438 */     // MIs[0] policy
     /* 1674438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674448 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674472 */     // GIR_Coverage, 6564,
     /* 1674472 */     GIR_EraseRootFromParent_Done,
     /* 1674473 */   // Label 22956: @1674473
     /* 1674473 */   GIM_Try, /*On fail goto*//*Label 22957*/ GIMT_Encode4(1674559), // Rule ID 6565 //
     /* 1674478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1674489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1674492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1674495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1674501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674524 */     // MIs[0] policy
     /* 1674524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674534 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11485:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1674555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674558 */     // GIR_Coverage, 6565,
     /* 1674558 */     GIR_EraseRootFromParent_Done,
     /* 1674559 */   // Label 22957: @1674559
     /* 1674559 */   GIM_Try, /*On fail goto*//*Label 22958*/ GIMT_Encode4(1674645), // Rule ID 6568 //
     /* 1674564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674610 */     // MIs[0] policy
     /* 1674610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674620 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674644 */     // GIR_Coverage, 6568,
     /* 1674644 */     GIR_EraseRootFromParent_Done,
     /* 1674645 */   // Label 22958: @1674645
     /* 1674645 */   GIM_Try, /*On fail goto*//*Label 22959*/ GIMT_Encode4(1674731), // Rule ID 6569 //
     /* 1674650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1674661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1674664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1674667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1674673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674696 */     // MIs[0] policy
     /* 1674696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674706 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11485:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1674727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674730 */     // GIR_Coverage, 6569,
     /* 1674730 */     GIR_EraseRootFromParent_Done,
     /* 1674731 */   // Label 22959: @1674731
     /* 1674731 */   GIM_Try, /*On fail goto*//*Label 22960*/ GIMT_Encode4(1674817), // Rule ID 6572 //
     /* 1674736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1674739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674782 */     // MIs[0] policy
     /* 1674782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674792 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674816 */     // GIR_Coverage, 6572,
     /* 1674816 */     GIR_EraseRootFromParent_Done,
     /* 1674817 */   // Label 22960: @1674817
     /* 1674817 */   GIM_Try, /*On fail goto*//*Label 22961*/ GIMT_Encode4(1674903), // Rule ID 6573 //
     /* 1674822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1674825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1674833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1674836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1674839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1674842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1674845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1674848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1674852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1674860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674868 */     // MIs[0] policy
     /* 1674868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674878 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11485:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1674878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M1_MASK),
     /* 1674881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1674899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674902 */     // GIR_Coverage, 6573,
     /* 1674902 */     GIR_EraseRootFromParent_Done,
     /* 1674903 */   // Label 22961: @1674903
     /* 1674903 */   GIM_Try, /*On fail goto*//*Label 22962*/ GIMT_Encode4(1674989), // Rule ID 6576 //
     /* 1674908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1674911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1674916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1674919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1674922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1674925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1674928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1674931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1674934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1674938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1674946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1674950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1674954 */     // MIs[0] policy
     /* 1674954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1674957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1674964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1674964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1674967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1674969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1674971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1674973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1674975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1674977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1674982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1674985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1674987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1674988 */     // GIR_Coverage, 6576,
     /* 1674988 */     GIR_EraseRootFromParent_Done,
     /* 1674989 */   // Label 22962: @1674989
     /* 1674989 */   GIM_Try, /*On fail goto*//*Label 22963*/ GIMT_Encode4(1675075), // Rule ID 6577 //
     /* 1674994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1674997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1675005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1675008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1675011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675040 */     // MIs[0] policy
     /* 1675040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675050 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1675053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675074 */     // GIR_Coverage, 6577,
     /* 1675074 */     GIR_EraseRootFromParent_Done,
     /* 1675075 */   // Label 22963: @1675075
     /* 1675075 */   GIM_Try, /*On fail goto*//*Label 22964*/ GIMT_Encode4(1675161), // Rule ID 6580 //
     /* 1675080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1675091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1675094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1675097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675126 */     // MIs[0] policy
     /* 1675126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675136 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1675139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675160 */     // GIR_Coverage, 6580,
     /* 1675160 */     GIR_EraseRootFromParent_Done,
     /* 1675161 */   // Label 22964: @1675161
     /* 1675161 */   GIM_Try, /*On fail goto*//*Label 22965*/ GIMT_Encode4(1675247), // Rule ID 6581 //
     /* 1675166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1675177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1675180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1675183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675212 */     // MIs[0] policy
     /* 1675212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675222 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1675225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675246 */     // GIR_Coverage, 6581,
     /* 1675246 */     GIR_EraseRootFromParent_Done,
     /* 1675247 */   // Label 22965: @1675247
     /* 1675247 */   GIM_Try, /*On fail goto*//*Label 22966*/ GIMT_Encode4(1675333), // Rule ID 6584 //
     /* 1675252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1675263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1675266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1675269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1675275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675298 */     // MIs[0] policy
     /* 1675298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1675311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675332 */     // GIR_Coverage, 6584,
     /* 1675332 */     GIR_EraseRootFromParent_Done,
     /* 1675333 */   // Label 22966: @1675333
     /* 1675333 */   GIM_Try, /*On fail goto*//*Label 22967*/ GIMT_Encode4(1675419), // Rule ID 6585 //
     /* 1675338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1675349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1675352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1675355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1675361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675384 */     // MIs[0] policy
     /* 1675384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675394 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1675397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1675415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675418 */     // GIR_Coverage, 6585,
     /* 1675418 */     GIR_EraseRootFromParent_Done,
     /* 1675419 */   // Label 22967: @1675419
     /* 1675419 */   GIM_Try, /*On fail goto*//*Label 22968*/ GIMT_Encode4(1675505), // Rule ID 6588 //
     /* 1675424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675470 */     // MIs[0] policy
     /* 1675470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1675483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675504 */     // GIR_Coverage, 6588,
     /* 1675504 */     GIR_EraseRootFromParent_Done,
     /* 1675505 */   // Label 22968: @1675505
     /* 1675505 */   GIM_Try, /*On fail goto*//*Label 22969*/ GIMT_Encode4(1675591), // Rule ID 6589 //
     /* 1675510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1675521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1675524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1675527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1675533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675556 */     // MIs[0] policy
     /* 1675556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675566 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1675569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675590 */     // GIR_Coverage, 6589,
     /* 1675590 */     GIR_EraseRootFromParent_Done,
     /* 1675591 */   // Label 22969: @1675591
     /* 1675591 */   GIM_Try, /*On fail goto*//*Label 22970*/ GIMT_Encode4(1675677), // Rule ID 6592 //
     /* 1675596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675642 */     // MIs[0] policy
     /* 1675642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675652 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1675655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675676 */     // GIR_Coverage, 6592,
     /* 1675676 */     GIR_EraseRootFromParent_Done,
     /* 1675677 */   // Label 22970: @1675677
     /* 1675677 */   GIM_Try, /*On fail goto*//*Label 22971*/ GIMT_Encode4(1675763), // Rule ID 6593 //
     /* 1675682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1675693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1675696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1675699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1675705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1675712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1675720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675728 */     // MIs[0] policy
     /* 1675728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675738 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1675741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675762 */     // GIR_Coverage, 6593,
     /* 1675762 */     GIR_EraseRootFromParent_Done,
     /* 1675763 */   // Label 22971: @1675763
     /* 1675763 */   GIM_Try, /*On fail goto*//*Label 22972*/ GIMT_Encode4(1675849), // Rule ID 6596 //
     /* 1675768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675814 */     // MIs[0] policy
     /* 1675814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675824 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1675827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675848 */     // GIR_Coverage, 6596,
     /* 1675848 */     GIR_EraseRootFromParent_Done,
     /* 1675849 */   // Label 22972: @1675849
     /* 1675849 */   GIM_Try, /*On fail goto*//*Label 22973*/ GIMT_Encode4(1675935), // Rule ID 6597 //
     /* 1675854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1675857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1675865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1675868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1675871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1675874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1675877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1675880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1675884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1675892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675900 */     // MIs[0] policy
     /* 1675900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675910 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1675910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1675913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1675915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1675917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1675919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1675921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1675923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1675928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1675931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1675933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1675934 */     // GIR_Coverage, 6597,
     /* 1675934 */     GIR_EraseRootFromParent_Done,
     /* 1675935 */   // Label 22973: @1675935
     /* 1675935 */   GIM_Try, /*On fail goto*//*Label 22974*/ GIMT_Encode4(1676021), // Rule ID 6600 //
     /* 1675940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1675943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1675948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1675951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1675954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1675957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1675960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1675963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1675966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1675970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1675978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1675982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1675986 */     // MIs[0] policy
     /* 1675986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1675989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1675996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1675996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1675999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676020 */     // GIR_Coverage, 6600,
     /* 1676020 */     GIR_EraseRootFromParent_Done,
     /* 1676021 */   // Label 22974: @1676021
     /* 1676021 */   GIM_Try, /*On fail goto*//*Label 22975*/ GIMT_Encode4(1676107), // Rule ID 6601 //
     /* 1676026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1676037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1676040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1676043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676072 */     // MIs[0] policy
     /* 1676072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1676085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676106 */     // GIR_Coverage, 6601,
     /* 1676106 */     GIR_EraseRootFromParent_Done,
     /* 1676107 */   // Label 22975: @1676107
     /* 1676107 */   GIM_Try, /*On fail goto*//*Label 22976*/ GIMT_Encode4(1676193), // Rule ID 6604 //
     /* 1676112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1676123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1676126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1676129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676158 */     // MIs[0] policy
     /* 1676158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1676171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676192 */     // GIR_Coverage, 6604,
     /* 1676192 */     GIR_EraseRootFromParent_Done,
     /* 1676193 */   // Label 22976: @1676193
     /* 1676193 */   GIM_Try, /*On fail goto*//*Label 22977*/ GIMT_Encode4(1676279), // Rule ID 6605 //
     /* 1676198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1676209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1676212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1676215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676244 */     // MIs[0] policy
     /* 1676244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1676257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676278 */     // GIR_Coverage, 6605,
     /* 1676278 */     GIR_EraseRootFromParent_Done,
     /* 1676279 */   // Label 22977: @1676279
     /* 1676279 */   GIM_Try, /*On fail goto*//*Label 22978*/ GIMT_Encode4(1676365), // Rule ID 6608 //
     /* 1676284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1676295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1676298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1676301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676330 */     // MIs[0] policy
     /* 1676330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1676343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676364 */     // GIR_Coverage, 6608,
     /* 1676364 */     GIR_EraseRootFromParent_Done,
     /* 1676365 */   // Label 22978: @1676365
     /* 1676365 */   GIM_Try, /*On fail goto*//*Label 22979*/ GIMT_Encode4(1676451), // Rule ID 6609 //
     /* 1676370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1676373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1676381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1676384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1676387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1676393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676416 */     // MIs[0] policy
     /* 1676416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1676429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1676447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676450 */     // GIR_Coverage, 6609,
     /* 1676450 */     GIR_EraseRootFromParent_Done,
     /* 1676451 */   // Label 22979: @1676451
     /* 1676451 */   GIM_Try, /*On fail goto*//*Label 22980*/ GIMT_Encode4(1676537), // Rule ID 6612 //
     /* 1676456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676502 */     // MIs[0] policy
     /* 1676502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1676515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676536 */     // GIR_Coverage, 6612,
     /* 1676536 */     GIR_EraseRootFromParent_Done,
     /* 1676537 */   // Label 22980: @1676537
     /* 1676537 */   GIM_Try, /*On fail goto*//*Label 22981*/ GIMT_Encode4(1676623), // Rule ID 6613 //
     /* 1676542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1676553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1676556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1676559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1676565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1676572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1676580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676588 */     // MIs[0] policy
     /* 1676588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11485:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M2_MASK),
     /* 1676601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676622 */     // GIR_Coverage, 6613,
     /* 1676622 */     GIR_EraseRootFromParent_Done,
     /* 1676623 */   // Label 22981: @1676623
     /* 1676623 */   GIM_Try, /*On fail goto*//*Label 22982*/ GIMT_Encode4(1676709), // Rule ID 6616 //
     /* 1676628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676674 */     // MIs[0] policy
     /* 1676674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1676687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676708 */     // GIR_Coverage, 6616,
     /* 1676708 */     GIR_EraseRootFromParent_Done,
     /* 1676709 */   // Label 22982: @1676709
     /* 1676709 */   GIM_Try, /*On fail goto*//*Label 22983*/ GIMT_Encode4(1676795), // Rule ID 6617 //
     /* 1676714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1676725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1676728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1676731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1676737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1676744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1676752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676760 */     // MIs[0] policy
     /* 1676760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11485:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M4_MASK),
     /* 1676773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676794 */     // GIR_Coverage, 6617,
     /* 1676794 */     GIR_EraseRootFromParent_Done,
     /* 1676795 */   // Label 22983: @1676795
     /* 1676795 */   GIM_Try, /*On fail goto*//*Label 22984*/ GIMT_Encode4(1676881), // Rule ID 6620 //
     /* 1676800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1676803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1676820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676846 */     // MIs[0] policy
     /* 1676846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1676856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1676859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676880 */     // GIR_Coverage, 6620,
     /* 1676880 */     GIR_EraseRootFromParent_Done,
     /* 1676881 */   // Label 22984: @1676881
     /* 1676881 */   GIM_Try, /*On fail goto*//*Label 22985*/ GIMT_Encode4(1676967), // Rule ID 6621 //
     /* 1676886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1676889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsll_mask),
     /* 1676894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1676897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1676900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1676903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1676906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1676909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1676912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1676916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1676924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1676928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1676932 */     // MIs[0] policy
     /* 1676932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1676935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1676942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11485:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1676942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VX_M8_MASK),
     /* 1676945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1676947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1676949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1676951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1676953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1676955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1676960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1676963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1676965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1676966 */     // GIR_Coverage, 6621,
     /* 1676966 */     GIR_EraseRootFromParent_Done,
     /* 1676967 */   // Label 22985: @1676967
     /* 1676967 */   GIM_Try, /*On fail goto*//*Label 22986*/ GIMT_Encode4(1677053), // Rule ID 6712 //
     /* 1676972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1676975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1676980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1676983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1676986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1676989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1676992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1676995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1676998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677018 */     // MIs[0] policy
     /* 1677018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1677031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677052 */     // GIR_Coverage, 6712,
     /* 1677052 */     GIR_EraseRootFromParent_Done,
     /* 1677053 */   // Label 22986: @1677053
     /* 1677053 */   GIM_Try, /*On fail goto*//*Label 22987*/ GIMT_Encode4(1677139), // Rule ID 6713 //
     /* 1677058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1677069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1677072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1677075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1677078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677104 */     // MIs[0] policy
     /* 1677104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8_MASK),
     /* 1677117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677138 */     // GIR_Coverage, 6713,
     /* 1677138 */     GIR_EraseRootFromParent_Done,
     /* 1677139 */   // Label 22987: @1677139
     /* 1677139 */   GIM_Try, /*On fail goto*//*Label 22988*/ GIMT_Encode4(1677225), // Rule ID 6716 //
     /* 1677144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1677155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1677158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1677161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1677164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677190 */     // MIs[0] policy
     /* 1677190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1677203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677224 */     // GIR_Coverage, 6716,
     /* 1677224 */     GIR_EraseRootFromParent_Done,
     /* 1677225 */   // Label 22988: @1677225
     /* 1677225 */   GIM_Try, /*On fail goto*//*Label 22989*/ GIMT_Encode4(1677311), // Rule ID 6717 //
     /* 1677230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1677241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1677244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1677247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1677250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677276 */     // MIs[0] policy
     /* 1677276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1677289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677310 */     // GIR_Coverage, 6717,
     /* 1677310 */     GIR_EraseRootFromParent_Done,
     /* 1677311 */   // Label 22989: @1677311
     /* 1677311 */   GIM_Try, /*On fail goto*//*Label 22990*/ GIMT_Encode4(1677397), // Rule ID 6720 //
     /* 1677316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1677336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677362 */     // MIs[0] policy
     /* 1677362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677396 */     // GIR_Coverage, 6720,
     /* 1677396 */     GIR_EraseRootFromParent_Done,
     /* 1677397 */   // Label 22990: @1677397
     /* 1677397 */   GIM_Try, /*On fail goto*//*Label 22991*/ GIMT_Encode4(1677483), // Rule ID 6721 //
     /* 1677402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1677413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1677416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1677419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1677422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1677425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677448 */     // MIs[0] policy
     /* 1677448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1677479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677482 */     // GIR_Coverage, 6721,
     /* 1677482 */     GIR_EraseRootFromParent_Done,
     /* 1677483 */   // Label 22991: @1677483
     /* 1677483 */   GIM_Try, /*On fail goto*//*Label 22992*/ GIMT_Encode4(1677569), // Rule ID 6724 //
     /* 1677488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677534 */     // MIs[0] policy
     /* 1677534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1677547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677568 */     // GIR_Coverage, 6724,
     /* 1677568 */     GIR_EraseRootFromParent_Done,
     /* 1677569 */   // Label 22992: @1677569
     /* 1677569 */   GIM_Try, /*On fail goto*//*Label 22993*/ GIMT_Encode4(1677655), // Rule ID 6725 //
     /* 1677574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1677585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1677588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1677591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1677594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677620 */     // MIs[0] policy
     /* 1677620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4_MASK),
     /* 1677633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677654 */     // GIR_Coverage, 6725,
     /* 1677654 */     GIR_EraseRootFromParent_Done,
     /* 1677655 */   // Label 22993: @1677655
     /* 1677655 */   GIM_Try, /*On fail goto*//*Label 22994*/ GIMT_Encode4(1677741), // Rule ID 6728 //
     /* 1677660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677706 */     // MIs[0] policy
     /* 1677706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677740 */     // GIR_Coverage, 6728,
     /* 1677740 */     GIR_EraseRootFromParent_Done,
     /* 1677741 */   // Label 22994: @1677741
     /* 1677741 */   GIM_Try, /*On fail goto*//*Label 22995*/ GIMT_Encode4(1677827), // Rule ID 6729 //
     /* 1677746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1677757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1677760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1677763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1677766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1677769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677792 */     // MIs[0] policy
     /* 1677792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1677823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677826 */     // GIR_Coverage, 6729,
     /* 1677826 */     GIR_EraseRootFromParent_Done,
     /* 1677827 */   // Label 22995: @1677827
     /* 1677827 */   GIM_Try, /*On fail goto*//*Label 22996*/ GIMT_Encode4(1677913), // Rule ID 6732 //
     /* 1677832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1677835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1677858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677878 */     // MIs[0] policy
     /* 1677878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1677888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677912 */     // GIR_Coverage, 6732,
     /* 1677912 */     GIR_EraseRootFromParent_Done,
     /* 1677913 */   // Label 22996: @1677913
     /* 1677913 */   GIM_Try, /*On fail goto*//*Label 22997*/ GIMT_Encode4(1677999), // Rule ID 6733 //
     /* 1677918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1677921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1677926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1677929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1677932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1677935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1677938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1677941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1677944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1677948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1677960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1677964 */     // MIs[0] policy
     /* 1677964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1677967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1677974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1677974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2_MASK),
     /* 1677977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1677979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1677981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1677983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1677985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1677987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1677992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1677995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1677997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1677998 */     // GIR_Coverage, 6733,
     /* 1677998 */     GIR_EraseRootFromParent_Done,
     /* 1677999 */   // Label 22997: @1677999
     /* 1677999 */   GIM_Try, /*On fail goto*//*Label 22998*/ GIMT_Encode4(1678085), // Rule ID 6736 //
     /* 1678004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1678015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1678018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1678021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1678024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678050 */     // MIs[0] policy
     /* 1678050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678084 */     // GIR_Coverage, 6736,
     /* 1678084 */     GIR_EraseRootFromParent_Done,
     /* 1678085 */   // Label 22998: @1678085
     /* 1678085 */   GIM_Try, /*On fail goto*//*Label 22999*/ GIMT_Encode4(1678171), // Rule ID 6737 //
     /* 1678090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1678101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1678104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1678107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1678110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1678113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678136 */     // MIs[0] policy
     /* 1678136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678170 */     // GIR_Coverage, 6737,
     /* 1678170 */     GIR_EraseRootFromParent_Done,
     /* 1678171 */   // Label 22999: @1678171
     /* 1678171 */   GIM_Try, /*On fail goto*//*Label 23000*/ GIMT_Encode4(1678257), // Rule ID 6740 //
     /* 1678176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1678187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1678190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1678193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1678196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678222 */     // MIs[0] policy
     /* 1678222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678256 */     // GIR_Coverage, 6740,
     /* 1678256 */     GIR_EraseRootFromParent_Done,
     /* 1678257 */   // Label 23000: @1678257
     /* 1678257 */   GIM_Try, /*On fail goto*//*Label 23001*/ GIMT_Encode4(1678343), // Rule ID 6741 //
     /* 1678262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1678273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1678276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1678279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1678282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1678285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678308 */     // MIs[0] policy
     /* 1678308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1678339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678342 */     // GIR_Coverage, 6741,
     /* 1678342 */     GIR_EraseRootFromParent_Done,
     /* 1678343 */   // Label 23001: @1678343
     /* 1678343 */   GIM_Try, /*On fail goto*//*Label 23002*/ GIMT_Encode4(1678429), // Rule ID 6744 //
     /* 1678348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1678359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1678362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1678365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1678368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678394 */     // MIs[0] policy
     /* 1678394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678428 */     // GIR_Coverage, 6744,
     /* 1678428 */     GIR_EraseRootFromParent_Done,
     /* 1678429 */   // Label 23002: @1678429
     /* 1678429 */   GIM_Try, /*On fail goto*//*Label 23003*/ GIMT_Encode4(1678515), // Rule ID 6745 //
     /* 1678434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1678445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1678448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1678451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1678454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1678457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678480 */     // MIs[0] policy
     /* 1678480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1678511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678514 */     // GIR_Coverage, 6745,
     /* 1678514 */     GIR_EraseRootFromParent_Done,
     /* 1678515 */   // Label 23003: @1678515
     /* 1678515 */   GIM_Try, /*On fail goto*//*Label 23004*/ GIMT_Encode4(1678601), // Rule ID 6748 //
     /* 1678520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1678523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678566 */     // MIs[0] policy
     /* 1678566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678600 */     // GIR_Coverage, 6748,
     /* 1678600 */     GIR_EraseRootFromParent_Done,
     /* 1678601 */   // Label 23004: @1678601
     /* 1678601 */   GIM_Try, /*On fail goto*//*Label 23005*/ GIMT_Encode4(1678687), // Rule ID 6749 //
     /* 1678606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1678609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1678617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1678620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1678623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1678626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1678629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1678636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1678648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678652 */     // MIs[0] policy
     /* 1678652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1_MASK),
     /* 1678665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1678683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678686 */     // GIR_Coverage, 6749,
     /* 1678686 */     GIR_EraseRootFromParent_Done,
     /* 1678687 */   // Label 23005: @1678687
     /* 1678687 */   GIM_Try, /*On fail goto*//*Label 23006*/ GIMT_Encode4(1678773), // Rule ID 6752 //
     /* 1678692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678738 */     // MIs[0] policy
     /* 1678738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1678751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678772 */     // GIR_Coverage, 6752,
     /* 1678772 */     GIR_EraseRootFromParent_Done,
     /* 1678773 */   // Label 23006: @1678773
     /* 1678773 */   GIM_Try, /*On fail goto*//*Label 23007*/ GIMT_Encode4(1678859), // Rule ID 6753 //
     /* 1678778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1678789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1678792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1678795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1678798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1678801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1678808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1678820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678824 */     // MIs[0] policy
     /* 1678824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1678834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1678837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678858 */     // GIR_Coverage, 6753,
     /* 1678858 */     GIR_EraseRootFromParent_Done,
     /* 1678859 */   // Label 23007: @1678859
     /* 1678859 */   GIM_Try, /*On fail goto*//*Label 23008*/ GIMT_Encode4(1678945), // Rule ID 6756 //
     /* 1678864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1678867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1678890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678910 */     // MIs[0] policy
     /* 1678910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1678920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1678920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1678923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1678925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1678927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1678929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1678931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1678933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1678938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1678941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1678943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1678944 */     // GIR_Coverage, 6756,
     /* 1678944 */     GIR_EraseRootFromParent_Done,
     /* 1678945 */   // Label 23008: @1678945
     /* 1678945 */   GIM_Try, /*On fail goto*//*Label 23009*/ GIMT_Encode4(1679031), // Rule ID 6757 //
     /* 1678950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1678953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1678958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1678961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1678964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1678967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1678970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1678973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1678976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1678980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1678992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1678996 */     // MIs[0] policy
     /* 1678996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1678999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1679009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679030 */     // GIR_Coverage, 6757,
     /* 1679030 */     GIR_EraseRootFromParent_Done,
     /* 1679031 */   // Label 23009: @1679031
     /* 1679031 */   GIM_Try, /*On fail goto*//*Label 23010*/ GIMT_Encode4(1679117), // Rule ID 6760 //
     /* 1679036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1679047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1679050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1679053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1679056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1679059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679082 */     // MIs[0] policy
     /* 1679082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1679095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679116 */     // GIR_Coverage, 6760,
     /* 1679116 */     GIR_EraseRootFromParent_Done,
     /* 1679117 */   // Label 23010: @1679117
     /* 1679117 */   GIM_Try, /*On fail goto*//*Label 23011*/ GIMT_Encode4(1679203), // Rule ID 6761 //
     /* 1679122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1679133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1679136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1679139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1679142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1679145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679168 */     // MIs[0] policy
     /* 1679168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1679181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1679199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679202 */     // GIR_Coverage, 6761,
     /* 1679202 */     GIR_EraseRootFromParent_Done,
     /* 1679203 */   // Label 23011: @1679203
     /* 1679203 */   GIM_Try, /*On fail goto*//*Label 23012*/ GIMT_Encode4(1679289), // Rule ID 6764 //
     /* 1679208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1679219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1679222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1679225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1679228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679254 */     // MIs[0] policy
     /* 1679254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1679267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679288 */     // GIR_Coverage, 6764,
     /* 1679288 */     GIR_EraseRootFromParent_Done,
     /* 1679289 */   // Label 23012: @1679289
     /* 1679289 */   GIM_Try, /*On fail goto*//*Label 23013*/ GIMT_Encode4(1679375), // Rule ID 6765 //
     /* 1679294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1679305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1679308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1679311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1679314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679340 */     // MIs[0] policy
     /* 1679340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1679353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679374 */     // GIR_Coverage, 6765,
     /* 1679374 */     GIR_EraseRootFromParent_Done,
     /* 1679375 */   // Label 23013: @1679375
     /* 1679375 */   GIM_Try, /*On fail goto*//*Label 23014*/ GIMT_Encode4(1679461), // Rule ID 6768 //
     /* 1679380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1679391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1679394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1679397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1679400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679426 */     // MIs[0] policy
     /* 1679426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1679439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679460 */     // GIR_Coverage, 6768,
     /* 1679460 */     GIR_EraseRootFromParent_Done,
     /* 1679461 */   // Label 23014: @1679461
     /* 1679461 */   GIM_Try, /*On fail goto*//*Label 23015*/ GIMT_Encode4(1679547), // Rule ID 6769 //
     /* 1679466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1679477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1679480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1679483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1679486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1679489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679512 */     // MIs[0] policy
     /* 1679512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1679525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679546 */     // GIR_Coverage, 6769,
     /* 1679546 */     GIR_EraseRootFromParent_Done,
     /* 1679547 */   // Label 23015: @1679547
     /* 1679547 */   GIM_Try, /*On fail goto*//*Label 23016*/ GIMT_Encode4(1679633), // Rule ID 6772 //
     /* 1679552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679598 */     // MIs[0] policy
     /* 1679598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1679611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679632 */     // GIR_Coverage, 6772,
     /* 1679632 */     GIR_EraseRootFromParent_Done,
     /* 1679633 */   // Label 23016: @1679633
     /* 1679633 */   GIM_Try, /*On fail goto*//*Label 23017*/ GIMT_Encode4(1679719), // Rule ID 6773 //
     /* 1679638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1679649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1679652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1679655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1679658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1679661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1679668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1679680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679684 */     // MIs[0] policy
     /* 1679684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1679697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1679715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679718 */     // GIR_Coverage, 6773,
     /* 1679718 */     GIR_EraseRootFromParent_Done,
     /* 1679719 */   // Label 23017: @1679719
     /* 1679719 */   GIM_Try, /*On fail goto*//*Label 23018*/ GIMT_Encode4(1679805), // Rule ID 6776 //
     /* 1679724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679770 */     // MIs[0] policy
     /* 1679770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1679783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679804 */     // GIR_Coverage, 6776,
     /* 1679804 */     GIR_EraseRootFromParent_Done,
     /* 1679805 */   // Label 23018: @1679805
     /* 1679805 */   GIM_Try, /*On fail goto*//*Label 23019*/ GIMT_Encode4(1679891), // Rule ID 6777 //
     /* 1679810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1679821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1679824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1679827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1679830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1679833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1679836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1679840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1679852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679856 */     // MIs[0] policy
     /* 1679856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1679866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1679869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679890 */     // GIR_Coverage, 6777,
     /* 1679890 */     GIR_EraseRootFromParent_Done,
     /* 1679891 */   // Label 23019: @1679891
     /* 1679891 */   GIM_Try, /*On fail goto*//*Label 23020*/ GIMT_Encode4(1679977), // Rule ID 6780 //
     /* 1679896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1679899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1679916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1679919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1679922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1679926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1679938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1679942 */     // MIs[0] policy
     /* 1679942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1679945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1679952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1679952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1679955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1679957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1679959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1679961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1679963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1679965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1679970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1679973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1679975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1679976 */     // GIR_Coverage, 6780,
     /* 1679976 */     GIR_EraseRootFromParent_Done,
     /* 1679977 */   // Label 23020: @1679977
     /* 1679977 */   GIM_Try, /*On fail goto*//*Label 23021*/ GIMT_Encode4(1680063), // Rule ID 6781 //
     /* 1679982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1679985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1679990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1679993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1679996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1679999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1680002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680028 */     // MIs[0] policy
     /* 1680028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1680041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680062 */     // GIR_Coverage, 6781,
     /* 1680062 */     GIR_EraseRootFromParent_Done,
     /* 1680063 */   // Label 23021: @1680063
     /* 1680063 */   GIM_Try, /*On fail goto*//*Label 23022*/ GIMT_Encode4(1680149), // Rule ID 6784 //
     /* 1680068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1680079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1680082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1680085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1680088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1680091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680114 */     // MIs[0] policy
     /* 1680114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1680127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680148 */     // GIR_Coverage, 6784,
     /* 1680148 */     GIR_EraseRootFromParent_Done,
     /* 1680149 */   // Label 23022: @1680149
     /* 1680149 */   GIM_Try, /*On fail goto*//*Label 23023*/ GIMT_Encode4(1680235), // Rule ID 6785 //
     /* 1680154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1680165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1680168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1680171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1680174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1680177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680200 */     // MIs[0] policy
     /* 1680200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1680213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1680231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680234 */     // GIR_Coverage, 6785,
     /* 1680234 */     GIR_EraseRootFromParent_Done,
     /* 1680235 */   // Label 23023: @1680235
     /* 1680235 */   GIM_Try, /*On fail goto*//*Label 23024*/ GIMT_Encode4(1680321), // Rule ID 6788 //
     /* 1680240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1680251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1680254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1680257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1680260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680286 */     // MIs[0] policy
     /* 1680286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1680299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680320 */     // GIR_Coverage, 6788,
     /* 1680320 */     GIR_EraseRootFromParent_Done,
     /* 1680321 */   // Label 23024: @1680321
     /* 1680321 */   GIM_Try, /*On fail goto*//*Label 23025*/ GIMT_Encode4(1680407), // Rule ID 6789 //
     /* 1680326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1680337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1680340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1680343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1680346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1680356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1680368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680372 */     // MIs[0] policy
     /* 1680372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2_MASK),
     /* 1680385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680406 */     // GIR_Coverage, 6789,
     /* 1680406 */     GIR_EraseRootFromParent_Done,
     /* 1680407 */   // Label 23025: @1680407
     /* 1680407 */   GIM_Try, /*On fail goto*//*Label 23026*/ GIMT_Encode4(1680493), // Rule ID 6792 //
     /* 1680412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680458 */     // MIs[0] policy
     /* 1680458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1680471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680492 */     // GIR_Coverage, 6792,
     /* 1680492 */     GIR_EraseRootFromParent_Done,
     /* 1680493 */   // Label 23026: @1680493
     /* 1680493 */   GIM_Try, /*On fail goto*//*Label 23027*/ GIMT_Encode4(1680579), // Rule ID 6793 //
     /* 1680498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1680509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1680512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1680515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1680518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1680521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1680528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1680540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680544 */     // MIs[0] policy
     /* 1680544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4_MASK),
     /* 1680557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680578 */     // GIR_Coverage, 6793,
     /* 1680578 */     GIR_EraseRootFromParent_Done,
     /* 1680579 */   // Label 23027: @1680579
     /* 1680579 */   GIM_Try, /*On fail goto*//*Label 23028*/ GIMT_Encode4(1680665), // Rule ID 6796 //
     /* 1680584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1680587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680630 */     // MIs[0] policy
     /* 1680630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1680643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680664 */     // GIR_Coverage, 6796,
     /* 1680664 */     GIR_EraseRootFromParent_Done,
     /* 1680665 */   // Label 23028: @1680665
     /* 1680665 */   GIM_Try, /*On fail goto*//*Label 23029*/ GIMT_Encode4(1680751), // Rule ID 6797 //
     /* 1680670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1680673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1680681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1680684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1680687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1680690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1680693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1680700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1680712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680716 */     // MIs[0] policy
     /* 1680716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8_MASK),
     /* 1680729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1680747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680750 */     // GIR_Coverage, 6797,
     /* 1680750 */     GIR_EraseRootFromParent_Done,
     /* 1680751 */   // Label 23029: @1680751
     /* 1680751 */   GIM_Try, /*On fail goto*//*Label 23030*/ GIMT_Encode4(1680837), // Rule ID 6800 //
     /* 1680756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680802 */     // MIs[0] policy
     /* 1680802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1680815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680836 */     // GIR_Coverage, 6800,
     /* 1680836 */     GIR_EraseRootFromParent_Done,
     /* 1680837 */   // Label 23030: @1680837
     /* 1680837 */   GIM_Try, /*On fail goto*//*Label 23031*/ GIMT_Encode4(1680923), // Rule ID 6801 //
     /* 1680842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1680845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1680853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1680856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1680859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1680862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1680865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1680868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680888 */     // MIs[0] policy
     /* 1680888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1680898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF8_MASK),
     /* 1680901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1680916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1680919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1680921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1680922 */     // GIR_Coverage, 6801,
     /* 1680922 */     GIR_EraseRootFromParent_Done,
     /* 1680923 */   // Label 23031: @1680923
     /* 1680923 */   GIM_Try, /*On fail goto*//*Label 23032*/ GIMT_Encode4(1681009), // Rule ID 6804 //
     /* 1680928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1680931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1680936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1680939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1680942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1680945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1680948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1680951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1680954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1680958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1680966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1680970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1680974 */     // MIs[0] policy
     /* 1680974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1680977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1680984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1680984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1680987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1680989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1680991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1680993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1680995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1680997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681008 */     // GIR_Coverage, 6804,
     /* 1681008 */     GIR_EraseRootFromParent_Done,
     /* 1681009 */   // Label 23032: @1681009
     /* 1681009 */   GIM_Try, /*On fail goto*//*Label 23033*/ GIMT_Encode4(1681095), // Rule ID 6805 //
     /* 1681014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1681025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1681028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1681031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681060 */     // MIs[0] policy
     /* 1681060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1681073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681094 */     // GIR_Coverage, 6805,
     /* 1681094 */     GIR_EraseRootFromParent_Done,
     /* 1681095 */   // Label 23033: @1681095
     /* 1681095 */   GIM_Try, /*On fail goto*//*Label 23034*/ GIMT_Encode4(1681181), // Rule ID 6808 //
     /* 1681100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1681111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1681114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1681117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681146 */     // MIs[0] policy
     /* 1681146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681180 */     // GIR_Coverage, 6808,
     /* 1681180 */     GIR_EraseRootFromParent_Done,
     /* 1681181 */   // Label 23034: @1681181
     /* 1681181 */   GIM_Try, /*On fail goto*//*Label 23035*/ GIMT_Encode4(1681267), // Rule ID 6809 //
     /* 1681186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1681197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1681200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1681203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681232 */     // MIs[0] policy
     /* 1681232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681242 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681266 */     // GIR_Coverage, 6809,
     /* 1681266 */     GIR_EraseRootFromParent_Done,
     /* 1681267 */   // Label 23035: @1681267
     /* 1681267 */   GIM_Try, /*On fail goto*//*Label 23036*/ GIMT_Encode4(1681353), // Rule ID 6812 //
     /* 1681272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1681283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1681286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1681289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681318 */     // MIs[0] policy
     /* 1681318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1681331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681352 */     // GIR_Coverage, 6812,
     /* 1681352 */     GIR_EraseRootFromParent_Done,
     /* 1681353 */   // Label 23036: @1681353
     /* 1681353 */   GIM_Try, /*On fail goto*//*Label 23037*/ GIMT_Encode4(1681439), // Rule ID 6813 //
     /* 1681358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1681369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1681372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1681375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681404 */     // MIs[0] policy
     /* 1681404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF4_MASK),
     /* 1681417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681438 */     // GIR_Coverage, 6813,
     /* 1681438 */     GIR_EraseRootFromParent_Done,
     /* 1681439 */   // Label 23037: @1681439
     /* 1681439 */   GIM_Try, /*On fail goto*//*Label 23038*/ GIMT_Encode4(1681525), // Rule ID 6816 //
     /* 1681444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681490 */     // MIs[0] policy
     /* 1681490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681524 */     // GIR_Coverage, 6816,
     /* 1681524 */     GIR_EraseRootFromParent_Done,
     /* 1681525 */   // Label 23038: @1681525
     /* 1681525 */   GIM_Try, /*On fail goto*//*Label 23039*/ GIMT_Encode4(1681611), // Rule ID 6817 //
     /* 1681530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1681541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1681544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1681547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1681553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681576 */     // MIs[0] policy
     /* 1681576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1681607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681610 */     // GIR_Coverage, 6817,
     /* 1681610 */     GIR_EraseRootFromParent_Done,
     /* 1681611 */   // Label 23039: @1681611
     /* 1681611 */   GIM_Try, /*On fail goto*//*Label 23040*/ GIMT_Encode4(1681697), // Rule ID 6820 //
     /* 1681616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681662 */     // MIs[0] policy
     /* 1681662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681696 */     // GIR_Coverage, 6820,
     /* 1681696 */     GIR_EraseRootFromParent_Done,
     /* 1681697 */   // Label 23040: @1681697
     /* 1681697 */   GIM_Try, /*On fail goto*//*Label 23041*/ GIMT_Encode4(1681783), // Rule ID 6821 //
     /* 1681702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1681713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1681716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1681719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1681725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681748 */     // MIs[0] policy
     /* 1681748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_MF2_MASK),
     /* 1681761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1681779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681782 */     // GIR_Coverage, 6821,
     /* 1681782 */     GIR_EraseRootFromParent_Done,
     /* 1681783 */   // Label 23041: @1681783
     /* 1681783 */   GIM_Try, /*On fail goto*//*Label 23042*/ GIMT_Encode4(1681869), // Rule ID 6824 //
     /* 1681788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681834 */     // MIs[0] policy
     /* 1681834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1681844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1681847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681868 */     // GIR_Coverage, 6824,
     /* 1681868 */     GIR_EraseRootFromParent_Done,
     /* 1681869 */   // Label 23042: @1681869
     /* 1681869 */   GIM_Try, /*On fail goto*//*Label 23043*/ GIMT_Encode4(1681955), // Rule ID 6825 //
     /* 1681874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1681877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1681885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1681888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1681891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1681894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1681897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1681900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1681916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1681920 */     // MIs[0] policy
     /* 1681920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1681923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1681930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11513:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1681930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1681933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1681935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1681937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1681939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1681941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1681943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1681948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1681951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1681953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1681954 */     // GIR_Coverage, 6825,
     /* 1681954 */     GIR_EraseRootFromParent_Done,
     /* 1681955 */   // Label 23043: @1681955
     /* 1681955 */   GIM_Try, /*On fail goto*//*Label 23044*/ GIMT_Encode4(1682041), // Rule ID 6828 //
     /* 1681960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1681963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1681968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1681971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1681974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1681977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1681980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1681983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1681986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1681990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1681998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682006 */     // MIs[0] policy
     /* 1682006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682040 */     // GIR_Coverage, 6828,
     /* 1682040 */     GIR_EraseRootFromParent_Done,
     /* 1682041 */   // Label 23044: @1682041
     /* 1682041 */   GIM_Try, /*On fail goto*//*Label 23045*/ GIMT_Encode4(1682127), // Rule ID 6829 //
     /* 1682046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1682057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1682060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1682063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1682069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682092 */     // MIs[0] policy
     /* 1682092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11513:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1682123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682126 */     // GIR_Coverage, 6829,
     /* 1682126 */     GIR_EraseRootFromParent_Done,
     /* 1682127 */   // Label 23045: @1682127
     /* 1682127 */   GIM_Try, /*On fail goto*//*Label 23046*/ GIMT_Encode4(1682213), // Rule ID 6832 //
     /* 1682132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1682143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1682146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1682149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682178 */     // MIs[0] policy
     /* 1682178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682212 */     // GIR_Coverage, 6832,
     /* 1682212 */     GIR_EraseRootFromParent_Done,
     /* 1682213 */   // Label 23046: @1682213
     /* 1682213 */   GIM_Try, /*On fail goto*//*Label 23047*/ GIMT_Encode4(1682299), // Rule ID 6833 //
     /* 1682218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1682229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1682232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1682235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1682241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682264 */     // MIs[0] policy
     /* 1682264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11513:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1682295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682298 */     // GIR_Coverage, 6833,
     /* 1682298 */     GIR_EraseRootFromParent_Done,
     /* 1682299 */   // Label 23047: @1682299
     /* 1682299 */   GIM_Try, /*On fail goto*//*Label 23048*/ GIMT_Encode4(1682385), // Rule ID 6836 //
     /* 1682304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1682307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1682315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682350 */     // MIs[0] policy
     /* 1682350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1682381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682384 */     // GIR_Coverage, 6836,
     /* 1682384 */     GIR_EraseRootFromParent_Done,
     /* 1682385 */   // Label 23048: @1682385
     /* 1682385 */   GIM_Try, /*On fail goto*//*Label 23049*/ GIMT_Encode4(1682471), // Rule ID 6837 //
     /* 1682390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1682393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1682401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1682404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1682407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1682413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1682420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1682428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682436 */     // MIs[0] policy
     /* 1682436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11513:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M1_MASK),
     /* 1682449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1682467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682470 */     // GIR_Coverage, 6837,
     /* 1682470 */     GIR_EraseRootFromParent_Done,
     /* 1682471 */   // Label 23049: @1682471
     /* 1682471 */   GIM_Try, /*On fail goto*//*Label 23050*/ GIMT_Encode4(1682557), // Rule ID 6840 //
     /* 1682476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682522 */     // MIs[0] policy
     /* 1682522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1682535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682556 */     // GIR_Coverage, 6840,
     /* 1682556 */     GIR_EraseRootFromParent_Done,
     /* 1682557 */   // Label 23050: @1682557
     /* 1682557 */   GIM_Try, /*On fail goto*//*Label 23051*/ GIMT_Encode4(1682643), // Rule ID 6841 //
     /* 1682562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1682573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1682576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1682579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1682585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1682592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1682600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682608 */     // MIs[0] policy
     /* 1682608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1682621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682642 */     // GIR_Coverage, 6841,
     /* 1682642 */     GIR_EraseRootFromParent_Done,
     /* 1682643 */   // Label 23051: @1682643
     /* 1682643 */   GIM_Try, /*On fail goto*//*Label 23052*/ GIMT_Encode4(1682729), // Rule ID 6844 //
     /* 1682648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682694 */     // MIs[0] policy
     /* 1682694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1682707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682728 */     // GIR_Coverage, 6844,
     /* 1682728 */     GIR_EraseRootFromParent_Done,
     /* 1682729 */   // Label 23052: @1682729
     /* 1682729 */   GIM_Try, /*On fail goto*//*Label 23053*/ GIMT_Encode4(1682815), // Rule ID 6845 //
     /* 1682734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1682745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1682748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1682751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1682757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1682764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1682772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682780 */     // MIs[0] policy
     /* 1682780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1682793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682814 */     // GIR_Coverage, 6845,
     /* 1682814 */     GIR_EraseRootFromParent_Done,
     /* 1682815 */   // Label 23053: @1682815
     /* 1682815 */   GIM_Try, /*On fail goto*//*Label 23054*/ GIMT_Encode4(1682901), // Rule ID 6848 //
     /* 1682820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1682840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1682846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682866 */     // MIs[0] policy
     /* 1682866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1682876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1682879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682900 */     // GIR_Coverage, 6848,
     /* 1682900 */     GIR_EraseRootFromParent_Done,
     /* 1682901 */   // Label 23054: @1682901
     /* 1682901 */   GIM_Try, /*On fail goto*//*Label 23055*/ GIMT_Encode4(1682987), // Rule ID 6849 //
     /* 1682906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1682909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1682914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1682917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1682920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1682923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1682926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1682929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1682932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1682936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1682944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1682948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1682952 */     // MIs[0] policy
     /* 1682952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1682955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1682962 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1682962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1682965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1682967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1682969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1682971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1682973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1682975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1682980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1682983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1682985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1682986 */     // GIR_Coverage, 6849,
     /* 1682986 */     GIR_EraseRootFromParent_Done,
     /* 1682987 */   // Label 23055: @1682987
     /* 1682987 */   GIM_Try, /*On fail goto*//*Label 23056*/ GIMT_Encode4(1683073), // Rule ID 6852 //
     /* 1682992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1682995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1683003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1683006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1683009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683038 */     // MIs[0] policy
     /* 1683038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1683051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683072 */     // GIR_Coverage, 6852,
     /* 1683072 */     GIR_EraseRootFromParent_Done,
     /* 1683073 */   // Label 23056: @1683073
     /* 1683073 */   GIM_Try, /*On fail goto*//*Label 23057*/ GIMT_Encode4(1683159), // Rule ID 6853 //
     /* 1683078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1683089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1683092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1683095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683124 */     // MIs[0] policy
     /* 1683124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1683137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683158 */     // GIR_Coverage, 6853,
     /* 1683158 */     GIR_EraseRootFromParent_Done,
     /* 1683159 */   // Label 23057: @1683159
     /* 1683159 */   GIM_Try, /*On fail goto*//*Label 23058*/ GIMT_Encode4(1683245), // Rule ID 6856 //
     /* 1683164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1683175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1683178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1683181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683210 */     // MIs[0] policy
     /* 1683210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1683223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683244 */     // GIR_Coverage, 6856,
     /* 1683244 */     GIR_EraseRootFromParent_Done,
     /* 1683245 */   // Label 23058: @1683245
     /* 1683245 */   GIM_Try, /*On fail goto*//*Label 23059*/ GIMT_Encode4(1683331), // Rule ID 6857 //
     /* 1683250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1683261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1683264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1683267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683296 */     // MIs[0] policy
     /* 1683296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1683309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683330 */     // GIR_Coverage, 6857,
     /* 1683330 */     GIR_EraseRootFromParent_Done,
     /* 1683331 */   // Label 23059: @1683331
     /* 1683331 */   GIM_Try, /*On fail goto*//*Label 23060*/ GIMT_Encode4(1683417), // Rule ID 6860 //
     /* 1683336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1683347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1683350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1683353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683382 */     // MIs[0] policy
     /* 1683382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1683395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683416 */     // GIR_Coverage, 6860,
     /* 1683416 */     GIR_EraseRootFromParent_Done,
     /* 1683417 */   // Label 23060: @1683417
     /* 1683417 */   GIM_Try, /*On fail goto*//*Label 23061*/ GIMT_Encode4(1683503), // Rule ID 6861 //
     /* 1683422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1683433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1683436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1683439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1683445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683468 */     // MIs[0] policy
     /* 1683468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1683481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1683499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683502 */     // GIR_Coverage, 6861,
     /* 1683502 */     GIR_EraseRootFromParent_Done,
     /* 1683503 */   // Label 23061: @1683503
     /* 1683503 */   GIM_Try, /*On fail goto*//*Label 23062*/ GIMT_Encode4(1683589), // Rule ID 6864 //
     /* 1683508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683554 */     // MIs[0] policy
     /* 1683554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1683567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683588 */     // GIR_Coverage, 6864,
     /* 1683588 */     GIR_EraseRootFromParent_Done,
     /* 1683589 */   // Label 23062: @1683589
     /* 1683589 */   GIM_Try, /*On fail goto*//*Label 23063*/ GIMT_Encode4(1683675), // Rule ID 6865 //
     /* 1683594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1683605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1683608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1683611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1683617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1683624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1683632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683640 */     // MIs[0] policy
     /* 1683640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1683653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683674 */     // GIR_Coverage, 6865,
     /* 1683674 */     GIR_EraseRootFromParent_Done,
     /* 1683675 */   // Label 23063: @1683675
     /* 1683675 */   GIM_Try, /*On fail goto*//*Label 23064*/ GIMT_Encode4(1683761), // Rule ID 6868 //
     /* 1683680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683726 */     // MIs[0] policy
     /* 1683726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1683739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683760 */     // GIR_Coverage, 6868,
     /* 1683760 */     GIR_EraseRootFromParent_Done,
     /* 1683761 */   // Label 23064: @1683761
     /* 1683761 */   GIM_Try, /*On fail goto*//*Label 23065*/ GIMT_Encode4(1683847), // Rule ID 6869 //
     /* 1683766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1683777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1683780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1683783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1683789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1683796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1683804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683812 */     // MIs[0] policy
     /* 1683812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1683825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683846 */     // GIR_Coverage, 6869,
     /* 1683846 */     GIR_EraseRootFromParent_Done,
     /* 1683847 */   // Label 23065: @1683847
     /* 1683847 */   GIM_Try, /*On fail goto*//*Label 23066*/ GIMT_Encode4(1683933), // Rule ID 6872 //
     /* 1683852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1683855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1683872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1683878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683898 */     // MIs[0] policy
     /* 1683898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1683908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1683911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1683915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1683917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1683919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1683921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1683926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1683929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1683931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1683932 */     // GIR_Coverage, 6872,
     /* 1683932 */     GIR_EraseRootFromParent_Done,
     /* 1683933 */   // Label 23066: @1683933
     /* 1683933 */   GIM_Try, /*On fail goto*//*Label 23067*/ GIMT_Encode4(1684019), // Rule ID 6873 //
     /* 1683938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1683941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1683946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1683949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1683952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1683955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1683958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1683961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1683964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1683968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1683976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1683980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1683984 */     // MIs[0] policy
     /* 1683984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1683987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1683994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1683994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1683997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1683999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1684015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684018 */     // GIR_Coverage, 6873,
     /* 1684018 */     GIR_EraseRootFromParent_Done,
     /* 1684019 */   // Label 23067: @1684019
     /* 1684019 */   GIM_Try, /*On fail goto*//*Label 23068*/ GIMT_Encode4(1684105), // Rule ID 6876 //
     /* 1684024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1684035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1684038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1684041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684070 */     // MIs[0] policy
     /* 1684070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1684083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684104 */     // GIR_Coverage, 6876,
     /* 1684104 */     GIR_EraseRootFromParent_Done,
     /* 1684105 */   // Label 23068: @1684105
     /* 1684105 */   GIM_Try, /*On fail goto*//*Label 23069*/ GIMT_Encode4(1684191), // Rule ID 6877 //
     /* 1684110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1684121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1684124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1684127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1684140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1684148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684156 */     // MIs[0] policy
     /* 1684156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11513:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M2_MASK),
     /* 1684169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684190 */     // GIR_Coverage, 6877,
     /* 1684190 */     GIR_EraseRootFromParent_Done,
     /* 1684191 */   // Label 23069: @1684191
     /* 1684191 */   GIM_Try, /*On fail goto*//*Label 23070*/ GIMT_Encode4(1684277), // Rule ID 6880 //
     /* 1684196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1684207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1684210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1684213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684242 */     // MIs[0] policy
     /* 1684242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1684255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684276 */     // GIR_Coverage, 6880,
     /* 1684276 */     GIR_EraseRootFromParent_Done,
     /* 1684277 */   // Label 23070: @1684277
     /* 1684277 */   GIM_Try, /*On fail goto*//*Label 23071*/ GIMT_Encode4(1684363), // Rule ID 6881 //
     /* 1684282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1684293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1684296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1684299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1684312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1684320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684328 */     // MIs[0] policy
     /* 1684328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11513:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M4_MASK),
     /* 1684341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684362 */     // GIR_Coverage, 6881,
     /* 1684362 */     GIR_EraseRootFromParent_Done,
     /* 1684363 */   // Label 23071: @1684363
     /* 1684363 */   GIM_Try, /*On fail goto*//*Label 23072*/ GIMT_Encode4(1684449), // Rule ID 6884 //
     /* 1684368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1684371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1684379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1684382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1684385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1684388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684414 */     // MIs[0] policy
     /* 1684414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1684427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684448 */     // GIR_Coverage, 6884,
     /* 1684448 */     GIR_EraseRootFromParent_Done,
     /* 1684449 */   // Label 23072: @1684449
     /* 1684449 */   GIM_Try, /*On fail goto*//*Label 23073*/ GIMT_Encode4(1684535), // Rule ID 6885 //
     /* 1684454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1684457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsrl_mask),
     /* 1684462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1684465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1684468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1684471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1684474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1684477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1684484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1684492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1684496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684500 */     // MIs[0] policy
     /* 1684500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11513:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VX_M8_MASK),
     /* 1684513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1684531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684534 */     // GIR_Coverage, 6885,
     /* 1684534 */     GIR_EraseRootFromParent_Done,
     /* 1684535 */   // Label 23073: @1684535
     /* 1684535 */   GIM_Try, /*On fail goto*//*Label 23074*/ GIMT_Encode4(1684621), // Rule ID 6976 //
     /* 1684540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684586 */     // MIs[0] policy
     /* 1684586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1684599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684620 */     // GIR_Coverage, 6976,
     /* 1684620 */     GIR_EraseRootFromParent_Done,
     /* 1684621 */   // Label 23074: @1684621
     /* 1684621 */   GIM_Try, /*On fail goto*//*Label 23075*/ GIMT_Encode4(1684707), // Rule ID 6977 //
     /* 1684626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1684637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1684640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1684643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1684646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1684649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684672 */     // MIs[0] policy
     /* 1684672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8_MASK),
     /* 1684685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684706 */     // GIR_Coverage, 6977,
     /* 1684706 */     GIR_EraseRootFromParent_Done,
     /* 1684707 */   // Label 23075: @1684707
     /* 1684707 */   GIM_Try, /*On fail goto*//*Label 23076*/ GIMT_Encode4(1684793), // Rule ID 6980 //
     /* 1684712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684758 */     // MIs[0] policy
     /* 1684758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1684771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684792 */     // GIR_Coverage, 6980,
     /* 1684792 */     GIR_EraseRootFromParent_Done,
     /* 1684793 */   // Label 23076: @1684793
     /* 1684793 */   GIM_Try, /*On fail goto*//*Label 23077*/ GIMT_Encode4(1684879), // Rule ID 6981 //
     /* 1684798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1684809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1684812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1684815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1684818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1684821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684844 */     // MIs[0] policy
     /* 1684844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1684854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1684857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684878 */     // GIR_Coverage, 6981,
     /* 1684878 */     GIR_EraseRootFromParent_Done,
     /* 1684879 */   // Label 23077: @1684879
     /* 1684879 */   GIM_Try, /*On fail goto*//*Label 23078*/ GIMT_Encode4(1684965), // Rule ID 6984 //
     /* 1684884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1684887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1684910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1684914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1684926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1684930 */     // MIs[0] policy
     /* 1684930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1684933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1684940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1684940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1684943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1684945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1684947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1684949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1684951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1684953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1684958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1684961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1684963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1684964 */     // GIR_Coverage, 6984,
     /* 1684964 */     GIR_EraseRootFromParent_Done,
     /* 1684965 */   // Label 23078: @1684965
     /* 1684965 */   GIM_Try, /*On fail goto*//*Label 23079*/ GIMT_Encode4(1685051), // Rule ID 6985 //
     /* 1684970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1684973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1684978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1684981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1684984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1684987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1684990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1684993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1684996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685016 */     // MIs[0] policy
     /* 1685016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1685029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685050 */     // GIR_Coverage, 6985,
     /* 1685050 */     GIR_EraseRootFromParent_Done,
     /* 1685051 */   // Label 23079: @1685051
     /* 1685051 */   GIM_Try, /*On fail goto*//*Label 23080*/ GIMT_Encode4(1685137), // Rule ID 6988 //
     /* 1685056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1685067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1685070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1685073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1685076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685102 */     // MIs[0] policy
     /* 1685102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1685115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685136 */     // GIR_Coverage, 6988,
     /* 1685136 */     GIR_EraseRootFromParent_Done,
     /* 1685137 */   // Label 23080: @1685137
     /* 1685137 */   GIM_Try, /*On fail goto*//*Label 23081*/ GIMT_Encode4(1685223), // Rule ID 6989 //
     /* 1685142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1685153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1685156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1685159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1685162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685188 */     // MIs[0] policy
     /* 1685188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4_MASK),
     /* 1685201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685222 */     // GIR_Coverage, 6989,
     /* 1685222 */     GIR_EraseRootFromParent_Done,
     /* 1685223 */   // Label 23081: @1685223
     /* 1685223 */   GIM_Try, /*On fail goto*//*Label 23082*/ GIMT_Encode4(1685309), // Rule ID 6992 //
     /* 1685228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1685239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1685242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1685245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1685248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685274 */     // MIs[0] policy
     /* 1685274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1685287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685308 */     // GIR_Coverage, 6992,
     /* 1685308 */     GIR_EraseRootFromParent_Done,
     /* 1685309 */   // Label 23082: @1685309
     /* 1685309 */   GIM_Try, /*On fail goto*//*Label 23083*/ GIMT_Encode4(1685395), // Rule ID 6993 //
     /* 1685314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1685325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1685328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1685331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1685334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685360 */     // MIs[0] policy
     /* 1685360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1685373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685394 */     // GIR_Coverage, 6993,
     /* 1685394 */     GIR_EraseRootFromParent_Done,
     /* 1685395 */   // Label 23083: @1685395
     /* 1685395 */   GIM_Try, /*On fail goto*//*Label 23084*/ GIMT_Encode4(1685481), // Rule ID 6996 //
     /* 1685400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1685411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1685414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1685417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1685420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685446 */     // MIs[0] policy
     /* 1685446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1685459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685480 */     // GIR_Coverage, 6996,
     /* 1685480 */     GIR_EraseRootFromParent_Done,
     /* 1685481 */   // Label 23084: @1685481
     /* 1685481 */   GIM_Try, /*On fail goto*//*Label 23085*/ GIMT_Encode4(1685567), // Rule ID 6997 //
     /* 1685486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1685497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1685500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1685503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1685506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1685509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685532 */     // MIs[0] policy
     /* 1685532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2_MASK),
     /* 1685545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685566 */     // GIR_Coverage, 6997,
     /* 1685566 */     GIR_EraseRootFromParent_Done,
     /* 1685567 */   // Label 23085: @1685567
     /* 1685567 */   GIM_Try, /*On fail goto*//*Label 23086*/ GIMT_Encode4(1685653), // Rule ID 7000 //
     /* 1685572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685618 */     // MIs[0] policy
     /* 1685618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1685631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685652 */     // GIR_Coverage, 7000,
     /* 1685652 */     GIR_EraseRootFromParent_Done,
     /* 1685653 */   // Label 23086: @1685653
     /* 1685653 */   GIM_Try, /*On fail goto*//*Label 23087*/ GIMT_Encode4(1685739), // Rule ID 7001 //
     /* 1685658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1685669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1685672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1685675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1685678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1685681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685704 */     // MIs[0] policy
     /* 1685704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1685717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1685735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685738 */     // GIR_Coverage, 7001,
     /* 1685738 */     GIR_EraseRootFromParent_Done,
     /* 1685739 */   // Label 23087: @1685739
     /* 1685739 */   GIM_Try, /*On fail goto*//*Label 23088*/ GIMT_Encode4(1685825), // Rule ID 7004 //
     /* 1685744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685790 */     // MIs[0] policy
     /* 1685790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1685803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685824 */     // GIR_Coverage, 7004,
     /* 1685824 */     GIR_EraseRootFromParent_Done,
     /* 1685825 */   // Label 23088: @1685825
     /* 1685825 */   GIM_Try, /*On fail goto*//*Label 23089*/ GIMT_Encode4(1685911), // Rule ID 7005 //
     /* 1685830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1685833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1685841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1685844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1685847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1685850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1685853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1685856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685876 */     // MIs[0] policy
     /* 1685876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1685886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1685889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1685907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685910 */     // GIR_Coverage, 7005,
     /* 1685910 */     GIR_EraseRootFromParent_Done,
     /* 1685911 */   // Label 23089: @1685911
     /* 1685911 */   GIM_Try, /*On fail goto*//*Label 23090*/ GIMT_Encode4(1685997), // Rule ID 7008 //
     /* 1685916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1685919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1685924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1685927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1685930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1685933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1685936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1685939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1685942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1685946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1685958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1685962 */     // MIs[0] policy
     /* 1685962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1685965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1685972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1685972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1685975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1685977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1685979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1685981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1685983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1685985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1685990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1685993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1685995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1685996 */     // GIR_Coverage, 7008,
     /* 1685996 */     GIR_EraseRootFromParent_Done,
     /* 1685997 */   // Label 23090: @1685997
     /* 1685997 */   GIM_Try, /*On fail goto*//*Label 23091*/ GIMT_Encode4(1686083), // Rule ID 7009 //
     /* 1686002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1686013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1686016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1686019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1686022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1686025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686048 */     // MIs[0] policy
     /* 1686048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1686061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1686079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686082 */     // GIR_Coverage, 7009,
     /* 1686082 */     GIR_EraseRootFromParent_Done,
     /* 1686083 */   // Label 23091: @1686083
     /* 1686083 */   GIM_Try, /*On fail goto*//*Label 23092*/ GIMT_Encode4(1686169), // Rule ID 7012 //
     /* 1686088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1686091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1686099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1686102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1686105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1686108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1686111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686134 */     // MIs[0] policy
     /* 1686134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1686147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686168 */     // GIR_Coverage, 7012,
     /* 1686168 */     GIR_EraseRootFromParent_Done,
     /* 1686169 */   // Label 23092: @1686169
     /* 1686169 */   GIM_Try, /*On fail goto*//*Label 23093*/ GIMT_Encode4(1686255), // Rule ID 7013 //
     /* 1686174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1686177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1686185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1686188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1686191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1686194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1686197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1686204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1686216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686220 */     // MIs[0] policy
     /* 1686220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1_MASK),
     /* 1686233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1686251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686254 */     // GIR_Coverage, 7013,
     /* 1686254 */     GIR_EraseRootFromParent_Done,
     /* 1686255 */   // Label 23093: @1686255
     /* 1686255 */   GIM_Try, /*On fail goto*//*Label 23094*/ GIMT_Encode4(1686341), // Rule ID 7016 //
     /* 1686260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1686271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1686274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1686277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1686280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686306 */     // MIs[0] policy
     /* 1686306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1686319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686340 */     // GIR_Coverage, 7016,
     /* 1686340 */     GIR_EraseRootFromParent_Done,
     /* 1686341 */   // Label 23094: @1686341
     /* 1686341 */   GIM_Try, /*On fail goto*//*Label 23095*/ GIMT_Encode4(1686427), // Rule ID 7017 //
     /* 1686346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1686357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1686360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1686363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1686366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686392 */     // MIs[0] policy
     /* 1686392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1686405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686426 */     // GIR_Coverage, 7017,
     /* 1686426 */     GIR_EraseRootFromParent_Done,
     /* 1686427 */   // Label 23095: @1686427
     /* 1686427 */   GIM_Try, /*On fail goto*//*Label 23096*/ GIMT_Encode4(1686513), // Rule ID 7020 //
     /* 1686432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686478 */     // MIs[0] policy
     /* 1686478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1686491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686512 */     // GIR_Coverage, 7020,
     /* 1686512 */     GIR_EraseRootFromParent_Done,
     /* 1686513 */   // Label 23096: @1686513
     /* 1686513 */   GIM_Try, /*On fail goto*//*Label 23097*/ GIMT_Encode4(1686599), // Rule ID 7021 //
     /* 1686518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1686529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1686532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1686535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1686538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1686541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686564 */     // MIs[0] policy
     /* 1686564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1686577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686598 */     // GIR_Coverage, 7021,
     /* 1686598 */     GIR_EraseRootFromParent_Done,
     /* 1686599 */   // Label 23097: @1686599
     /* 1686599 */   GIM_Try, /*On fail goto*//*Label 23098*/ GIMT_Encode4(1686685), // Rule ID 7024 //
     /* 1686604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686650 */     // MIs[0] policy
     /* 1686650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1686663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686684 */     // GIR_Coverage, 7024,
     /* 1686684 */     GIR_EraseRootFromParent_Done,
     /* 1686685 */   // Label 23098: @1686685
     /* 1686685 */   GIM_Try, /*On fail goto*//*Label 23099*/ GIMT_Encode4(1686771), // Rule ID 7025 //
     /* 1686690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1686701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1686704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1686707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1686710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1686713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1686720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1686732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686736 */     // MIs[0] policy
     /* 1686736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1686749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1686767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686770 */     // GIR_Coverage, 7025,
     /* 1686770 */     GIR_EraseRootFromParent_Done,
     /* 1686771 */   // Label 23099: @1686771
     /* 1686771 */   GIM_Try, /*On fail goto*//*Label 23100*/ GIMT_Encode4(1686857), // Rule ID 7028 //
     /* 1686776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686822 */     // MIs[0] policy
     /* 1686822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1686832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1686835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686856 */     // GIR_Coverage, 7028,
     /* 1686856 */     GIR_EraseRootFromParent_Done,
     /* 1686857 */   // Label 23100: @1686857
     /* 1686857 */   GIM_Try, /*On fail goto*//*Label 23101*/ GIMT_Encode4(1686943), // Rule ID 7029 //
     /* 1686862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1686865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1686873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1686876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1686879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1686882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1686885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1686888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1686892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1686904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686908 */     // MIs[0] policy
     /* 1686908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1686918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1686918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1686921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1686923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1686925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1686927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1686929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1686931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1686936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1686939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1686941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1686942 */     // GIR_Coverage, 7029,
     /* 1686942 */     GIR_EraseRootFromParent_Done,
     /* 1686943 */   // Label 23101: @1686943
     /* 1686943 */   GIM_Try, /*On fail goto*//*Label 23102*/ GIMT_Encode4(1687029), // Rule ID 7032 //
     /* 1686948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1686951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1686956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1686959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1686962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1686965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1686968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1686971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1686974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1686978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1686990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1686994 */     // MIs[0] policy
     /* 1686994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1686997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1687007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687028 */     // GIR_Coverage, 7032,
     /* 1687028 */     GIR_EraseRootFromParent_Done,
     /* 1687029 */   // Label 23102: @1687029
     /* 1687029 */   GIM_Try, /*On fail goto*//*Label 23103*/ GIMT_Encode4(1687115), // Rule ID 7033 //
     /* 1687034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1687045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1687048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1687051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1687054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687080 */     // MIs[0] policy
     /* 1687080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1687093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687114 */     // GIR_Coverage, 7033,
     /* 1687114 */     GIR_EraseRootFromParent_Done,
     /* 1687115 */   // Label 23103: @1687115
     /* 1687115 */   GIM_Try, /*On fail goto*//*Label 23104*/ GIMT_Encode4(1687201), // Rule ID 7036 //
     /* 1687120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1687131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1687134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1687137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1687140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687166 */     // MIs[0] policy
     /* 1687166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1687179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687200 */     // GIR_Coverage, 7036,
     /* 1687200 */     GIR_EraseRootFromParent_Done,
     /* 1687201 */   // Label 23104: @1687201
     /* 1687201 */   GIM_Try, /*On fail goto*//*Label 23105*/ GIMT_Encode4(1687287), // Rule ID 7037 //
     /* 1687206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1687217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1687220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1687223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1687226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1687229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687252 */     // MIs[0] policy
     /* 1687252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1687265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1687283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687286 */     // GIR_Coverage, 7037,
     /* 1687286 */     GIR_EraseRootFromParent_Done,
     /* 1687287 */   // Label 23105: @1687287
     /* 1687287 */   GIM_Try, /*On fail goto*//*Label 23106*/ GIMT_Encode4(1687373), // Rule ID 7040 //
     /* 1687292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1687303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1687306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1687309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1687312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687338 */     // MIs[0] policy
     /* 1687338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1687351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687372 */     // GIR_Coverage, 7040,
     /* 1687372 */     GIR_EraseRootFromParent_Done,
     /* 1687373 */   // Label 23106: @1687373
     /* 1687373 */   GIM_Try, /*On fail goto*//*Label 23107*/ GIMT_Encode4(1687459), // Rule ID 7041 //
     /* 1687378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1687389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1687392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1687395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1687398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1687401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687424 */     // MIs[0] policy
     /* 1687424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1687437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687458 */     // GIR_Coverage, 7041,
     /* 1687458 */     GIR_EraseRootFromParent_Done,
     /* 1687459 */   // Label 23107: @1687459
     /* 1687459 */   GIM_Try, /*On fail goto*//*Label 23108*/ GIMT_Encode4(1687545), // Rule ID 7044 //
     /* 1687464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687510 */     // MIs[0] policy
     /* 1687510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1687523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687544 */     // GIR_Coverage, 7044,
     /* 1687544 */     GIR_EraseRootFromParent_Done,
     /* 1687545 */   // Label 23108: @1687545
     /* 1687545 */   GIM_Try, /*On fail goto*//*Label 23109*/ GIMT_Encode4(1687631), // Rule ID 7045 //
     /* 1687550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1687561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1687564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1687567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1687570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1687573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1687580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1687592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687596 */     // MIs[0] policy
     /* 1687596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1687609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687630 */     // GIR_Coverage, 7045,
     /* 1687630 */     GIR_EraseRootFromParent_Done,
     /* 1687631 */   // Label 23109: @1687631
     /* 1687631 */   GIM_Try, /*On fail goto*//*Label 23110*/ GIMT_Encode4(1687717), // Rule ID 7048 //
     /* 1687636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1687639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687682 */     // MIs[0] policy
     /* 1687682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1687695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687716 */     // GIR_Coverage, 7048,
     /* 1687716 */     GIR_EraseRootFromParent_Done,
     /* 1687717 */   // Label 23110: @1687717
     /* 1687717 */   GIM_Try, /*On fail goto*//*Label 23111*/ GIMT_Encode4(1687803), // Rule ID 7049 //
     /* 1687722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1687725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1687733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1687736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1687739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1687742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1687745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1687752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1687764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687768 */     // MIs[0] policy
     /* 1687768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1687781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1687799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687802 */     // GIR_Coverage, 7049,
     /* 1687802 */     GIR_EraseRootFromParent_Done,
     /* 1687803 */   // Label 23111: @1687803
     /* 1687803 */   GIM_Try, /*On fail goto*//*Label 23112*/ GIMT_Encode4(1687889), // Rule ID 7052 //
     /* 1687808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1687834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687854 */     // MIs[0] policy
     /* 1687854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1687864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1687867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687888 */     // GIR_Coverage, 7052,
     /* 1687888 */     GIR_EraseRootFromParent_Done,
     /* 1687889 */   // Label 23112: @1687889
     /* 1687889 */   GIM_Try, /*On fail goto*//*Label 23113*/ GIMT_Encode4(1687975), // Rule ID 7053 //
     /* 1687894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1687897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1687905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1687908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1687911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1687914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1687917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1687920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1687924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1687936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1687940 */     // MIs[0] policy
     /* 1687940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1687943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1687950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1687950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2_MASK),
     /* 1687953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1687955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1687957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1687959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1687961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1687963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1687968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1687971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1687973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1687974 */     // GIR_Coverage, 7053,
     /* 1687974 */     GIR_EraseRootFromParent_Done,
     /* 1687975 */   // Label 23113: @1687975
     /* 1687975 */   GIM_Try, /*On fail goto*//*Label 23114*/ GIMT_Encode4(1688061), // Rule ID 7056 //
     /* 1687980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1687983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1687988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1687991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1687994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1687997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1688000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688026 */     // MIs[0] policy
     /* 1688026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1688039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688060 */     // GIR_Coverage, 7056,
     /* 1688060 */     GIR_EraseRootFromParent_Done,
     /* 1688061 */   // Label 23114: @1688061
     /* 1688061 */   GIM_Try, /*On fail goto*//*Label 23115*/ GIMT_Encode4(1688147), // Rule ID 7057 //
     /* 1688066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1688077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1688080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1688083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1688086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1688096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1688108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688112 */     // MIs[0] policy
     /* 1688112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4_MASK),
     /* 1688125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688146 */     // GIR_Coverage, 7057,
     /* 1688146 */     GIR_EraseRootFromParent_Done,
     /* 1688147 */   // Label 23115: @1688147
     /* 1688147 */   GIM_Try, /*On fail goto*//*Label 23116*/ GIMT_Encode4(1688233), // Rule ID 7060 //
     /* 1688152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1688155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1688163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1688166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1688169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1688172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688198 */     // MIs[0] policy
     /* 1688198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1688211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688232 */     // GIR_Coverage, 7060,
     /* 1688232 */     GIR_EraseRootFromParent_Done,
     /* 1688233 */   // Label 23116: @1688233
     /* 1688233 */   GIM_Try, /*On fail goto*//*Label 23117*/ GIMT_Encode4(1688319), // Rule ID 7061 //
     /* 1688238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1688241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1688249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1688252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1688255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1688258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1688261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1688268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1688280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688284 */     // MIs[0] policy
     /* 1688284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8_MASK),
     /* 1688297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1688315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688318 */     // GIR_Coverage, 7061,
     /* 1688318 */     GIR_EraseRootFromParent_Done,
     /* 1688319 */   // Label 23117: @1688319
     /* 1688319 */   GIM_Try, /*On fail goto*//*Label 23118*/ GIMT_Encode4(1688405), // Rule ID 7064 //
     /* 1688324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688370 */     // MIs[0] policy
     /* 1688370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1688383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688404 */     // GIR_Coverage, 7064,
     /* 1688404 */     GIR_EraseRootFromParent_Done,
     /* 1688405 */   // Label 23118: @1688405
     /* 1688405 */   GIM_Try, /*On fail goto*//*Label 23119*/ GIMT_Encode4(1688491), // Rule ID 7065 //
     /* 1688410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1688421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1688424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1688427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688456 */     // MIs[0] policy
     /* 1688456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF8_MASK),
     /* 1688469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688490 */     // GIR_Coverage, 7065,
     /* 1688490 */     GIR_EraseRootFromParent_Done,
     /* 1688491 */   // Label 23119: @1688491
     /* 1688491 */   GIM_Try, /*On fail goto*//*Label 23120*/ GIMT_Encode4(1688577), // Rule ID 7068 //
     /* 1688496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688542 */     // MIs[0] policy
     /* 1688542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1688555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688576 */     // GIR_Coverage, 7068,
     /* 1688576 */     GIR_EraseRootFromParent_Done,
     /* 1688577 */   // Label 23120: @1688577
     /* 1688577 */   GIM_Try, /*On fail goto*//*Label 23121*/ GIMT_Encode4(1688663), // Rule ID 7069 //
     /* 1688582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1688593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1688596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1688599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1688605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688628 */     // MIs[0] policy
     /* 1688628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688638 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1688641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688662 */     // GIR_Coverage, 7069,
     /* 1688662 */     GIR_EraseRootFromParent_Done,
     /* 1688663 */   // Label 23121: @1688663
     /* 1688663 */   GIM_Try, /*On fail goto*//*Label 23122*/ GIMT_Encode4(1688749), // Rule ID 7072 //
     /* 1688668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688714 */     // MIs[0] policy
     /* 1688714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1688727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688748 */     // GIR_Coverage, 7072,
     /* 1688748 */     GIR_EraseRootFromParent_Done,
     /* 1688749 */   // Label 23122: @1688749
     /* 1688749 */   GIM_Try, /*On fail goto*//*Label 23123*/ GIMT_Encode4(1688835), // Rule ID 7073 //
     /* 1688754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1688765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1688768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1688771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1688777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688800 */     // MIs[0] policy
     /* 1688800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1688813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1688831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688834 */     // GIR_Coverage, 7073,
     /* 1688834 */     GIR_EraseRootFromParent_Done,
     /* 1688835 */   // Label 23123: @1688835
     /* 1688835 */   GIM_Try, /*On fail goto*//*Label 23124*/ GIMT_Encode4(1688921), // Rule ID 7076 //
     /* 1688840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1688843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1688860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1688866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688886 */     // MIs[0] policy
     /* 1688886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1688896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1688899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1688914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1688917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1688919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1688920 */     // GIR_Coverage, 7076,
     /* 1688920 */     GIR_EraseRootFromParent_Done,
     /* 1688921 */   // Label 23124: @1688921
     /* 1688921 */   GIM_Try, /*On fail goto*//*Label 23125*/ GIMT_Encode4(1689007), // Rule ID 7077 //
     /* 1688926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1688929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1688934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1688937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1688940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1688943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1688946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1688949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1688952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1688956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1688964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1688968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1688972 */     // MIs[0] policy
     /* 1688972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1688975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1688982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1688982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF4_MASK),
     /* 1688985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1688987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1688989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1688991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1688993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1688995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689006 */     // GIR_Coverage, 7077,
     /* 1689006 */     GIR_EraseRootFromParent_Done,
     /* 1689007 */   // Label 23125: @1689007
     /* 1689007 */   GIM_Try, /*On fail goto*//*Label 23126*/ GIMT_Encode4(1689093), // Rule ID 7080 //
     /* 1689012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1689023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1689026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1689029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689058 */     // MIs[0] policy
     /* 1689058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1689071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689092 */     // GIR_Coverage, 7080,
     /* 1689092 */     GIR_EraseRootFromParent_Done,
     /* 1689093 */   // Label 23126: @1689093
     /* 1689093 */   GIM_Try, /*On fail goto*//*Label 23127*/ GIMT_Encode4(1689179), // Rule ID 7081 //
     /* 1689098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1689109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1689112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1689115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689144 */     // MIs[0] policy
     /* 1689144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1689157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689178 */     // GIR_Coverage, 7081,
     /* 1689178 */     GIR_EraseRootFromParent_Done,
     /* 1689179 */   // Label 23127: @1689179
     /* 1689179 */   GIM_Try, /*On fail goto*//*Label 23128*/ GIMT_Encode4(1689265), // Rule ID 7084 //
     /* 1689184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1689195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1689198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1689201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689230 */     // MIs[0] policy
     /* 1689230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1689243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689264 */     // GIR_Coverage, 7084,
     /* 1689264 */     GIR_EraseRootFromParent_Done,
     /* 1689265 */   // Label 23128: @1689265
     /* 1689265 */   GIM_Try, /*On fail goto*//*Label 23129*/ GIMT_Encode4(1689351), // Rule ID 7085 //
     /* 1689270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1689281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1689284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1689287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689316 */     // MIs[0] policy
     /* 1689316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_MF2_MASK),
     /* 1689329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689350 */     // GIR_Coverage, 7085,
     /* 1689350 */     GIR_EraseRootFromParent_Done,
     /* 1689351 */   // Label 23129: @1689351
     /* 1689351 */   GIM_Try, /*On fail goto*//*Label 23130*/ GIMT_Encode4(1689437), // Rule ID 7088 //
     /* 1689356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1689367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1689370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1689373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689402 */     // MIs[0] policy
     /* 1689402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689436 */     // GIR_Coverage, 7088,
     /* 1689436 */     GIR_EraseRootFromParent_Done,
     /* 1689437 */   // Label 23130: @1689437
     /* 1689437 */   GIM_Try, /*On fail goto*//*Label 23131*/ GIMT_Encode4(1689523), // Rule ID 7089 //
     /* 1689442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1689453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1689456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1689459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1689465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689488 */     // MIs[0] policy
     /* 1689488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11511:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1689519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689522 */     // GIR_Coverage, 7089,
     /* 1689522 */     GIR_EraseRootFromParent_Done,
     /* 1689523 */   // Label 23131: @1689523
     /* 1689523 */   GIM_Try, /*On fail goto*//*Label 23132*/ GIMT_Encode4(1689609), // Rule ID 7092 //
     /* 1689528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689574 */     // MIs[0] policy
     /* 1689574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689608 */     // GIR_Coverage, 7092,
     /* 1689608 */     GIR_EraseRootFromParent_Done,
     /* 1689609 */   // Label 23132: @1689609
     /* 1689609 */   GIM_Try, /*On fail goto*//*Label 23133*/ GIMT_Encode4(1689695), // Rule ID 7093 //
     /* 1689614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1689625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1689628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1689631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1689637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689660 */     // MIs[0] policy
     /* 1689660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11511:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1689691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689694 */     // GIR_Coverage, 7093,
     /* 1689694 */     GIR_EraseRootFromParent_Done,
     /* 1689695 */   // Label 23133: @1689695
     /* 1689695 */   GIM_Try, /*On fail goto*//*Label 23134*/ GIMT_Encode4(1689781), // Rule ID 7096 //
     /* 1689700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1689703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689746 */     // MIs[0] policy
     /* 1689746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689780 */     // GIR_Coverage, 7096,
     /* 1689780 */     GIR_EraseRootFromParent_Done,
     /* 1689781 */   // Label 23134: @1689781
     /* 1689781 */   GIM_Try, /*On fail goto*//*Label 23135*/ GIMT_Encode4(1689867), // Rule ID 7097 //
     /* 1689786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1689789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1689797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1689800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1689803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1689809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689832 */     // MIs[0] policy
     /* 1689832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11511:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1689842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1689863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689866 */     // GIR_Coverage, 7097,
     /* 1689866 */     GIR_EraseRootFromParent_Done,
     /* 1689867 */   // Label 23135: @1689867
     /* 1689867 */   GIM_Try, /*On fail goto*//*Label 23136*/ GIMT_Encode4(1689953), // Rule ID 7100 //
     /* 1689872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1689875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1689892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1689898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1689914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1689918 */     // MIs[0] policy
     /* 1689918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1689921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1689928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1689928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1689931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1689933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1689935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1689937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1689939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1689941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1689946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1689949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1689951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1689952 */     // GIR_Coverage, 7100,
     /* 1689952 */     GIR_EraseRootFromParent_Done,
     /* 1689953 */   // Label 23136: @1689953
     /* 1689953 */   GIM_Try, /*On fail goto*//*Label 23137*/ GIMT_Encode4(1690039), // Rule ID 7101 //
     /* 1689958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1689961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1689966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1689969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1689972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1689975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1689978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1689981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1689984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1689988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1689996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690004 */     // MIs[0] policy
     /* 1690004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11511:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M1_MASK),
     /* 1690017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1690035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690038 */     // GIR_Coverage, 7101,
     /* 1690038 */     GIR_EraseRootFromParent_Done,
     /* 1690039 */   // Label 23137: @1690039
     /* 1690039 */   GIM_Try, /*On fail goto*//*Label 23138*/ GIMT_Encode4(1690125), // Rule ID 7104 //
     /* 1690044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1690055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1690058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1690061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690090 */     // MIs[0] policy
     /* 1690090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1690103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690124 */     // GIR_Coverage, 7104,
     /* 1690124 */     GIR_EraseRootFromParent_Done,
     /* 1690125 */   // Label 23138: @1690125
     /* 1690125 */   GIM_Try, /*On fail goto*//*Label 23139*/ GIMT_Encode4(1690211), // Rule ID 7105 //
     /* 1690130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1690141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1690144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1690147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690176 */     // MIs[0] policy
     /* 1690176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1690189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690210 */     // GIR_Coverage, 7105,
     /* 1690210 */     GIR_EraseRootFromParent_Done,
     /* 1690211 */   // Label 23139: @1690211
     /* 1690211 */   GIM_Try, /*On fail goto*//*Label 23140*/ GIMT_Encode4(1690297), // Rule ID 7108 //
     /* 1690216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1690227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1690230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1690233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690262 */     // MIs[0] policy
     /* 1690262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1690275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690296 */     // GIR_Coverage, 7108,
     /* 1690296 */     GIR_EraseRootFromParent_Done,
     /* 1690297 */   // Label 23140: @1690297
     /* 1690297 */   GIM_Try, /*On fail goto*//*Label 23141*/ GIMT_Encode4(1690383), // Rule ID 7109 //
     /* 1690302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1690313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1690316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1690319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690348 */     // MIs[0] policy
     /* 1690348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1690361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690382 */     // GIR_Coverage, 7109,
     /* 1690382 */     GIR_EraseRootFromParent_Done,
     /* 1690383 */   // Label 23141: @1690383
     /* 1690383 */   GIM_Try, /*On fail goto*//*Label 23142*/ GIMT_Encode4(1690469), // Rule ID 7112 //
     /* 1690388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1690399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1690402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1690405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1690411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690434 */     // MIs[0] policy
     /* 1690434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1690447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690468 */     // GIR_Coverage, 7112,
     /* 1690468 */     GIR_EraseRootFromParent_Done,
     /* 1690469 */   // Label 23142: @1690469
     /* 1690469 */   GIM_Try, /*On fail goto*//*Label 23143*/ GIMT_Encode4(1690555), // Rule ID 7113 //
     /* 1690474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1690485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1690488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1690491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1690497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690520 */     // MIs[0] policy
     /* 1690520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1690533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1690551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690554 */     // GIR_Coverage, 7113,
     /* 1690554 */     GIR_EraseRootFromParent_Done,
     /* 1690555 */   // Label 23143: @1690555
     /* 1690555 */   GIM_Try, /*On fail goto*//*Label 23144*/ GIMT_Encode4(1690641), // Rule ID 7116 //
     /* 1690560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690606 */     // MIs[0] policy
     /* 1690606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1690619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690640 */     // GIR_Coverage, 7116,
     /* 1690640 */     GIR_EraseRootFromParent_Done,
     /* 1690641 */   // Label 23144: @1690641
     /* 1690641 */   GIM_Try, /*On fail goto*//*Label 23145*/ GIMT_Encode4(1690727), // Rule ID 7117 //
     /* 1690646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1690657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1690660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1690663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1690669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1690676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1690684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690692 */     // MIs[0] policy
     /* 1690692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1690705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690726 */     // GIR_Coverage, 7117,
     /* 1690726 */     GIR_EraseRootFromParent_Done,
     /* 1690727 */   // Label 23145: @1690727
     /* 1690727 */   GIM_Try, /*On fail goto*//*Label 23146*/ GIMT_Encode4(1690813), // Rule ID 7120 //
     /* 1690732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690778 */     // MIs[0] policy
     /* 1690778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1690791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690812 */     // GIR_Coverage, 7120,
     /* 1690812 */     GIR_EraseRootFromParent_Done,
     /* 1690813 */   // Label 23146: @1690813
     /* 1690813 */   GIM_Try, /*On fail goto*//*Label 23147*/ GIMT_Encode4(1690899), // Rule ID 7121 //
     /* 1690818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1690829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1690832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1690835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1690838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1690841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1690844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1690848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1690856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690864 */     // MIs[0] policy
     /* 1690864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1690874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1690877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690898 */     // GIR_Coverage, 7121,
     /* 1690898 */     GIR_EraseRootFromParent_Done,
     /* 1690899 */   // Label 23147: @1690899
     /* 1690899 */   GIM_Try, /*On fail goto*//*Label 23148*/ GIMT_Encode4(1690985), // Rule ID 7124 //
     /* 1690904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1690907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1690915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1690918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1690921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1690924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1690927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1690930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1690934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1690942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1690946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1690950 */     // MIs[0] policy
     /* 1690950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1690953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1690960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1690960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1690963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1690965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1690967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1690969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1690971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1690973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1690978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1690981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1690983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1690984 */     // GIR_Coverage, 7124,
     /* 1690984 */     GIR_EraseRootFromParent_Done,
     /* 1690985 */   // Label 23148: @1690985
     /* 1690985 */   GIM_Try, /*On fail goto*//*Label 23149*/ GIMT_Encode4(1691071), // Rule ID 7125 //
     /* 1690990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1690993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1690998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1691001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1691004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1691007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1691013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691036 */     // MIs[0] policy
     /* 1691036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1691049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1691067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691070 */     // GIR_Coverage, 7125,
     /* 1691070 */     GIR_EraseRootFromParent_Done,
     /* 1691071 */   // Label 23149: @1691071
     /* 1691071 */   GIM_Try, /*On fail goto*//*Label 23150*/ GIMT_Encode4(1691157), // Rule ID 7128 //
     /* 1691076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1691087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1691090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1691093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691122 */     // MIs[0] policy
     /* 1691122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1691135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691156 */     // GIR_Coverage, 7128,
     /* 1691156 */     GIR_EraseRootFromParent_Done,
     /* 1691157 */   // Label 23150: @1691157
     /* 1691157 */   GIM_Try, /*On fail goto*//*Label 23151*/ GIMT_Encode4(1691243), // Rule ID 7129 //
     /* 1691162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1691173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1691176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1691179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691208 */     // MIs[0] policy
     /* 1691208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1691221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691242 */     // GIR_Coverage, 7129,
     /* 1691242 */     GIR_EraseRootFromParent_Done,
     /* 1691243 */   // Label 23151: @1691243
     /* 1691243 */   GIM_Try, /*On fail goto*//*Label 23152*/ GIMT_Encode4(1691329), // Rule ID 7132 //
     /* 1691248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1691259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1691262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1691265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691294 */     // MIs[0] policy
     /* 1691294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1691307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691328 */     // GIR_Coverage, 7132,
     /* 1691328 */     GIR_EraseRootFromParent_Done,
     /* 1691329 */   // Label 23152: @1691329
     /* 1691329 */   GIM_Try, /*On fail goto*//*Label 23153*/ GIMT_Encode4(1691415), // Rule ID 7133 //
     /* 1691334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1691345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1691348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1691351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691380 */     // MIs[0] policy
     /* 1691380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1691393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691414 */     // GIR_Coverage, 7133,
     /* 1691414 */     GIR_EraseRootFromParent_Done,
     /* 1691415 */   // Label 23153: @1691415
     /* 1691415 */   GIM_Try, /*On fail goto*//*Label 23154*/ GIMT_Encode4(1691501), // Rule ID 7136 //
     /* 1691420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1691423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691466 */     // MIs[0] policy
     /* 1691466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1691479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691500 */     // GIR_Coverage, 7136,
     /* 1691500 */     GIR_EraseRootFromParent_Done,
     /* 1691501 */   // Label 23154: @1691501
     /* 1691501 */   GIM_Try, /*On fail goto*//*Label 23155*/ GIMT_Encode4(1691587), // Rule ID 7137 //
     /* 1691506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1691509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1691517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1691520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1691523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1691529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691552 */     // MIs[0] policy
     /* 1691552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1691565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1691583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691586 */     // GIR_Coverage, 7137,
     /* 1691586 */     GIR_EraseRootFromParent_Done,
     /* 1691587 */   // Label 23155: @1691587
     /* 1691587 */   GIM_Try, /*On fail goto*//*Label 23156*/ GIMT_Encode4(1691673), // Rule ID 7140 //
     /* 1691592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691638 */     // MIs[0] policy
     /* 1691638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1691651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691672 */     // GIR_Coverage, 7140,
     /* 1691672 */     GIR_EraseRootFromParent_Done,
     /* 1691673 */   // Label 23156: @1691673
     /* 1691673 */   GIM_Try, /*On fail goto*//*Label 23157*/ GIMT_Encode4(1691759), // Rule ID 7141 //
     /* 1691678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1691689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1691692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1691695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1691701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1691708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1691716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691724 */     // MIs[0] policy
     /* 1691724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11511:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M2_MASK),
     /* 1691737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691758 */     // GIR_Coverage, 7141,
     /* 1691758 */     GIR_EraseRootFromParent_Done,
     /* 1691759 */   // Label 23157: @1691759
     /* 1691759 */   GIM_Try, /*On fail goto*//*Label 23158*/ GIMT_Encode4(1691845), // Rule ID 7144 //
     /* 1691764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691810 */     // MIs[0] policy
     /* 1691810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1691823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691844 */     // GIR_Coverage, 7144,
     /* 1691844 */     GIR_EraseRootFromParent_Done,
     /* 1691845 */   // Label 23158: @1691845
     /* 1691845 */   GIM_Try, /*On fail goto*//*Label 23159*/ GIMT_Encode4(1691931), // Rule ID 7145 //
     /* 1691850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1691853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1691861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1691864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1691867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1691870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1691873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1691876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1691880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1691888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691896 */     // MIs[0] policy
     /* 1691896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11511:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1691906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M4_MASK),
     /* 1691909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1691915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1691917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1691919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1691924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1691927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1691929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1691930 */     // GIR_Coverage, 7145,
     /* 1691930 */     GIR_EraseRootFromParent_Done,
     /* 1691931 */   // Label 23159: @1691931
     /* 1691931 */   GIM_Try, /*On fail goto*//*Label 23160*/ GIMT_Encode4(1692017), // Rule ID 7148 //
     /* 1691936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1691939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1691944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1691947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1691950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1691953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1691956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1691959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1691962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1691966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1691974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1691978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1691982 */     // MIs[0] policy
     /* 1691982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1691985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1691992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1691992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1691995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1691997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1691999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692016 */     // GIR_Coverage, 7148,
     /* 1692016 */     GIR_EraseRootFromParent_Done,
     /* 1692017 */   // Label 23160: @1692017
     /* 1692017 */   GIM_Try, /*On fail goto*//*Label 23161*/ GIMT_Encode4(1692103), // Rule ID 7149 //
     /* 1692022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1692025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsra_mask),
     /* 1692030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1692033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1692036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1692039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1692042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1692052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1692060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1692064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692068 */     // MIs[0] policy
     /* 1692068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11511:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VX_M8_MASK),
     /* 1692081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1692099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692102 */     // GIR_Coverage, 7149,
     /* 1692102 */     GIR_EraseRootFromParent_Done,
     /* 1692103 */   // Label 23161: @1692103
     /* 1692103 */   GIM_Try, /*On fail goto*//*Label 23162*/ GIMT_Encode4(1692189), // Rule ID 7328 //
     /* 1692108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1692119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1692122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1692128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692154 */     // MIs[0] policy
     /* 1692154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1692167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692188 */     // GIR_Coverage, 7328,
     /* 1692188 */     GIR_EraseRootFromParent_Done,
     /* 1692189 */   // Label 23162: @1692189
     /* 1692189 */   GIM_Try, /*On fail goto*//*Label 23163*/ GIMT_Encode4(1692275), // Rule ID 7329 //
     /* 1692194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1692205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1692208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1692211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1692214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1692217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692240 */     // MIs[0] policy
     /* 1692240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF8_MASK),
     /* 1692253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692274 */     // GIR_Coverage, 7329,
     /* 1692274 */     GIR_EraseRootFromParent_Done,
     /* 1692275 */   // Label 23163: @1692275
     /* 1692275 */   GIM_Try, /*On fail goto*//*Label 23164*/ GIMT_Encode4(1692361), // Rule ID 7332 //
     /* 1692280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1692291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1692294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1692300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692326 */     // MIs[0] policy
     /* 1692326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1692339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692360 */     // GIR_Coverage, 7332,
     /* 1692360 */     GIR_EraseRootFromParent_Done,
     /* 1692361 */   // Label 23164: @1692361
     /* 1692361 */   GIM_Try, /*On fail goto*//*Label 23165*/ GIMT_Encode4(1692447), // Rule ID 7333 //
     /* 1692366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1692377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1692380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1692383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1692386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1692389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692412 */     // MIs[0] policy
     /* 1692412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692422 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1692425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692446 */     // GIR_Coverage, 7333,
     /* 1692446 */     GIR_EraseRootFromParent_Done,
     /* 1692447 */   // Label 23165: @1692447
     /* 1692447 */   GIM_Try, /*On fail goto*//*Label 23166*/ GIMT_Encode4(1692533), // Rule ID 7336 //
     /* 1692452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692498 */     // MIs[0] policy
     /* 1692498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1692511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692532 */     // GIR_Coverage, 7336,
     /* 1692532 */     GIR_EraseRootFromParent_Done,
     /* 1692533 */   // Label 23166: @1692533
     /* 1692533 */   GIM_Try, /*On fail goto*//*Label 23167*/ GIMT_Encode4(1692619), // Rule ID 7337 //
     /* 1692538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1692549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1692552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1692555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1692558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1692561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692584 */     // MIs[0] policy
     /* 1692584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692594 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1692597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692618 */     // GIR_Coverage, 7337,
     /* 1692618 */     GIR_EraseRootFromParent_Done,
     /* 1692619 */   // Label 23167: @1692619
     /* 1692619 */   GIM_Try, /*On fail goto*//*Label 23168*/ GIMT_Encode4(1692705), // Rule ID 7340 //
     /* 1692624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1692641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692670 */     // MIs[0] policy
     /* 1692670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692680 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1692683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692704 */     // GIR_Coverage, 7340,
     /* 1692704 */     GIR_EraseRootFromParent_Done,
     /* 1692705 */   // Label 23168: @1692705
     /* 1692705 */   GIM_Try, /*On fail goto*//*Label 23169*/ GIMT_Encode4(1692791), // Rule ID 7341 //
     /* 1692710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1692721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1692724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1692727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1692730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1692733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1692740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1692752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692756 */     // MIs[0] policy
     /* 1692756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692766 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1692769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692790 */     // GIR_Coverage, 7341,
     /* 1692790 */     GIR_EraseRootFromParent_Done,
     /* 1692791 */   // Label 23169: @1692791
     /* 1692791 */   GIM_Try, /*On fail goto*//*Label 23170*/ GIMT_Encode4(1692877), // Rule ID 7344 //
     /* 1692796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1692813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692842 */     // MIs[0] policy
     /* 1692842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692852 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1692852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1692855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692876 */     // GIR_Coverage, 7344,
     /* 1692876 */     GIR_EraseRootFromParent_Done,
     /* 1692877 */   // Label 23170: @1692877
     /* 1692877 */   GIM_Try, /*On fail goto*//*Label 23171*/ GIMT_Encode4(1692963), // Rule ID 7345 //
     /* 1692882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1692885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1692893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1692896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1692899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1692902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1692905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1692908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1692912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1692920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1692924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1692928 */     // MIs[0] policy
     /* 1692928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1692931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1692938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1692938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1692941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1692943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1692945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1692947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1692949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1692951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1692956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1692959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1692961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1692962 */     // GIR_Coverage, 7345,
     /* 1692962 */     GIR_EraseRootFromParent_Done,
     /* 1692963 */   // Label 23171: @1692963
     /* 1692963 */   GIM_Try, /*On fail goto*//*Label 23172*/ GIMT_Encode4(1693049), // Rule ID 7348 //
     /* 1692968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1692971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1692976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1692979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1692982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1692985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1692988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1692991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1692994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1692998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693014 */     // MIs[0] policy
     /* 1693014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693024 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1693027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693048 */     // GIR_Coverage, 7348,
     /* 1693048 */     GIR_EraseRootFromParent_Done,
     /* 1693049 */   // Label 23172: @1693049
     /* 1693049 */   GIM_Try, /*On fail goto*//*Label 23173*/ GIMT_Encode4(1693135), // Rule ID 7349 //
     /* 1693054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1693065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1693068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1693071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1693074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1693077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693100 */     // MIs[0] policy
     /* 1693100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693110 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1693113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1693131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693134 */     // GIR_Coverage, 7349,
     /* 1693134 */     GIR_EraseRootFromParent_Done,
     /* 1693135 */   // Label 23173: @1693135
     /* 1693135 */   GIM_Try, /*On fail goto*//*Label 23174*/ GIMT_Encode4(1693221), // Rule ID 7352 //
     /* 1693140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1693151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1693154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1693157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1693160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693186 */     // MIs[0] policy
     /* 1693186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693196 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1693199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693220 */     // GIR_Coverage, 7352,
     /* 1693220 */     GIR_EraseRootFromParent_Done,
     /* 1693221 */   // Label 23174: @1693221
     /* 1693221 */   GIM_Try, /*On fail goto*//*Label 23175*/ GIMT_Encode4(1693307), // Rule ID 7353 //
     /* 1693226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1693237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1693240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1693243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1693246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1693249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693272 */     // MIs[0] policy
     /* 1693272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693282 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF4_MASK),
     /* 1693285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693306 */     // GIR_Coverage, 7353,
     /* 1693306 */     GIR_EraseRootFromParent_Done,
     /* 1693307 */   // Label 23175: @1693307
     /* 1693307 */   GIM_Try, /*On fail goto*//*Label 23176*/ GIMT_Encode4(1693393), // Rule ID 7356 //
     /* 1693312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1693323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1693326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1693332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693358 */     // MIs[0] policy
     /* 1693358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693368 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1693371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693392 */     // GIR_Coverage, 7356,
     /* 1693392 */     GIR_EraseRootFromParent_Done,
     /* 1693393 */   // Label 23176: @1693393
     /* 1693393 */   GIM_Try, /*On fail goto*//*Label 23177*/ GIMT_Encode4(1693479), // Rule ID 7357 //
     /* 1693398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1693409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1693412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1693415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1693418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1693421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693444 */     // MIs[0] policy
     /* 1693444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693454 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1693457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693478 */     // GIR_Coverage, 7357,
     /* 1693478 */     GIR_EraseRootFromParent_Done,
     /* 1693479 */   // Label 23177: @1693479
     /* 1693479 */   GIM_Try, /*On fail goto*//*Label 23178*/ GIMT_Encode4(1693565), // Rule ID 7360 //
     /* 1693484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1693504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693530 */     // MIs[0] policy
     /* 1693530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693540 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1693543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693564 */     // GIR_Coverage, 7360,
     /* 1693564 */     GIR_EraseRootFromParent_Done,
     /* 1693565 */   // Label 23178: @1693565
     /* 1693565 */   GIM_Try, /*On fail goto*//*Label 23179*/ GIMT_Encode4(1693651), // Rule ID 7361 //
     /* 1693570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1693581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1693584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1693587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1693590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1693593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1693600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1693612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693616 */     // MIs[0] policy
     /* 1693616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693626 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1693629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693650 */     // GIR_Coverage, 7361,
     /* 1693650 */     GIR_EraseRootFromParent_Done,
     /* 1693651 */   // Label 23179: @1693651
     /* 1693651 */   GIM_Try, /*On fail goto*//*Label 23180*/ GIMT_Encode4(1693737), // Rule ID 7364 //
     /* 1693656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1693673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693702 */     // MIs[0] policy
     /* 1693702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693712 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1693715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693736 */     // GIR_Coverage, 7364,
     /* 1693736 */     GIR_EraseRootFromParent_Done,
     /* 1693737 */   // Label 23180: @1693737
     /* 1693737 */   GIM_Try, /*On fail goto*//*Label 23181*/ GIMT_Encode4(1693823), // Rule ID 7365 //
     /* 1693742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1693753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1693756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1693759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1693762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1693765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1693772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1693784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693788 */     // MIs[0] policy
     /* 1693788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1693801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693822 */     // GIR_Coverage, 7365,
     /* 1693822 */     GIR_EraseRootFromParent_Done,
     /* 1693823 */   // Label 23181: @1693823
     /* 1693823 */   GIM_Try, /*On fail goto*//*Label 23182*/ GIMT_Encode4(1693909), // Rule ID 7368 //
     /* 1693828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1693831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1693845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1693854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693874 */     // MIs[0] policy
     /* 1693874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693884 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1693884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1693887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693908 */     // GIR_Coverage, 7368,
     /* 1693908 */     GIR_EraseRootFromParent_Done,
     /* 1693909 */   // Label 23182: @1693909
     /* 1693909 */   GIM_Try, /*On fail goto*//*Label 23183*/ GIMT_Encode4(1693995), // Rule ID 7369 //
     /* 1693914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1693917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1693922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1693925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1693928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1693931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1693934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1693937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1693940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1693944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1693952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1693956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1693960 */     // MIs[0] policy
     /* 1693960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1693963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1693970 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1693970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1693973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1693975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1693977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1693979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1693981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1693983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1693988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1693991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1693993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1693994 */     // GIR_Coverage, 7369,
     /* 1693994 */     GIR_EraseRootFromParent_Done,
     /* 1693995 */   // Label 23183: @1693995
     /* 1693995 */   GIM_Try, /*On fail goto*//*Label 23184*/ GIMT_Encode4(1694081), // Rule ID 7372 //
     /* 1694000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1694003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1694011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1694014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1694017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1694020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694046 */     // MIs[0] policy
     /* 1694046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1694059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694080 */     // GIR_Coverage, 7372,
     /* 1694080 */     GIR_EraseRootFromParent_Done,
     /* 1694081 */   // Label 23184: @1694081
     /* 1694081 */   GIM_Try, /*On fail goto*//*Label 23185*/ GIMT_Encode4(1694167), // Rule ID 7373 //
     /* 1694086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1694089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1694097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1694100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1694103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1694106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694132 */     // MIs[0] policy
     /* 1694132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694142 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_MF2_MASK),
     /* 1694145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694166 */     // GIR_Coverage, 7373,
     /* 1694166 */     GIR_EraseRootFromParent_Done,
     /* 1694167 */   // Label 23185: @1694167
     /* 1694167 */   GIM_Try, /*On fail goto*//*Label 23186*/ GIMT_Encode4(1694253), // Rule ID 7376 //
     /* 1694172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1694175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1694183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1694186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1694192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694218 */     // MIs[0] policy
     /* 1694218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1694231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694252 */     // GIR_Coverage, 7376,
     /* 1694252 */     GIR_EraseRootFromParent_Done,
     /* 1694253 */   // Label 23186: @1694253
     /* 1694253 */   GIM_Try, /*On fail goto*//*Label 23187*/ GIMT_Encode4(1694339), // Rule ID 7377 //
     /* 1694258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1694261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1694269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1694272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1694275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1694278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694304 */     // MIs[0] policy
     /* 1694304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M1_MASK),
     /* 1694317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694338 */     // GIR_Coverage, 7377,
     /* 1694338 */     GIR_EraseRootFromParent_Done,
     /* 1694339 */   // Label 23187: @1694339
     /* 1694339 */   GIM_Try, /*On fail goto*//*Label 23188*/ GIMT_Encode4(1694425), // Rule ID 7380 //
     /* 1694344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1694347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694390 */     // MIs[0] policy
     /* 1694390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1694403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694424 */     // GIR_Coverage, 7380,
     /* 1694424 */     GIR_EraseRootFromParent_Done,
     /* 1694425 */   // Label 23188: @1694425
     /* 1694425 */   GIM_Try, /*On fail goto*//*Label 23189*/ GIMT_Encode4(1694511), // Rule ID 7381 //
     /* 1694430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1694433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1694441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1694444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1694447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1694450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1694453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1694460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1694472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694476 */     // MIs[0] policy
     /* 1694476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M2_MASK),
     /* 1694489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694510 */     // GIR_Coverage, 7381,
     /* 1694510 */     GIR_EraseRootFromParent_Done,
     /* 1694511 */   // Label 23189: @1694511
     /* 1694511 */   GIM_Try, /*On fail goto*//*Label 23190*/ GIMT_Encode4(1694597), // Rule ID 7384 //
     /* 1694516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1694519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694562 */     // MIs[0] policy
     /* 1694562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1694575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694596 */     // GIR_Coverage, 7384,
     /* 1694596 */     GIR_EraseRootFromParent_Done,
     /* 1694597 */   // Label 23190: @1694597
     /* 1694597 */   GIM_Try, /*On fail goto*//*Label 23191*/ GIMT_Encode4(1694683), // Rule ID 7385 //
     /* 1694602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1694605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1694613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1694616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1694619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1694622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1694625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1694632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1694640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1694644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694648 */     // MIs[0] policy
     /* 1694648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WV_M4_MASK),
     /* 1694661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1694679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694682 */     // GIR_Coverage, 7385,
     /* 1694682 */     GIR_EraseRootFromParent_Done,
     /* 1694683 */   // Label 23191: @1694683
     /* 1694683 */   GIM_Try, /*On fail goto*//*Label 23192*/ GIMT_Encode4(1694769), // Rule ID 7388 //
     /* 1694688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1694699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1694702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1694705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694734 */     // MIs[0] policy
     /* 1694734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1694747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694768 */     // GIR_Coverage, 7388,
     /* 1694768 */     GIR_EraseRootFromParent_Done,
     /* 1694769 */   // Label 23192: @1694769
     /* 1694769 */   GIM_Try, /*On fail goto*//*Label 23193*/ GIMT_Encode4(1694855), // Rule ID 7389 //
     /* 1694774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1694785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1694788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1694791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1694797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694820 */     // MIs[0] policy
     /* 1694820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1694830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF8_MASK),
     /* 1694833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694854 */     // GIR_Coverage, 7389,
     /* 1694854 */     GIR_EraseRootFromParent_Done,
     /* 1694855 */   // Label 23193: @1694855
     /* 1694855 */   GIM_Try, /*On fail goto*//*Label 23194*/ GIMT_Encode4(1694941), // Rule ID 7392 //
     /* 1694860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1694863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1694871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1694874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1694877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1694880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1694886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694906 */     // MIs[0] policy
     /* 1694906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1694916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1694916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1694919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1694921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1694923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1694925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1694927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1694929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1694934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1694937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1694939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1694940 */     // GIR_Coverage, 7392,
     /* 1694940 */     GIR_EraseRootFromParent_Done,
     /* 1694941 */   // Label 23194: @1694941
     /* 1694941 */   GIM_Try, /*On fail goto*//*Label 23195*/ GIMT_Encode4(1695027), // Rule ID 7393 //
     /* 1694946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1694949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1694954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1694957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1694960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1694963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1694966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1694969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1694972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1694976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1694984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1694988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1694992 */     // MIs[0] policy
     /* 1694992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1694995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1695005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695026 */     // GIR_Coverage, 7393,
     /* 1695026 */     GIR_EraseRootFromParent_Done,
     /* 1695027 */   // Label 23195: @1695027
     /* 1695027 */   GIM_Try, /*On fail goto*//*Label 23196*/ GIMT_Encode4(1695113), // Rule ID 7396 //
     /* 1695032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1695049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695078 */     // MIs[0] policy
     /* 1695078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695088 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1695091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695112 */     // GIR_Coverage, 7396,
     /* 1695112 */     GIR_EraseRootFromParent_Done,
     /* 1695113 */   // Label 23196: @1695113
     /* 1695113 */   GIM_Try, /*On fail goto*//*Label 23197*/ GIMT_Encode4(1695199), // Rule ID 7397 //
     /* 1695118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1695129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1695132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1695135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1695141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695164 */     // MIs[0] policy
     /* 1695164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1695177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695198 */     // GIR_Coverage, 7397,
     /* 1695198 */     GIR_EraseRootFromParent_Done,
     /* 1695199 */   // Label 23197: @1695199
     /* 1695199 */   GIM_Try, /*On fail goto*//*Label 23198*/ GIMT_Encode4(1695285), // Rule ID 7400 //
     /* 1695204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1695215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1695218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1695221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695250 */     // MIs[0] policy
     /* 1695250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695260 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1695263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695284 */     // GIR_Coverage, 7400,
     /* 1695284 */     GIR_EraseRootFromParent_Done,
     /* 1695285 */   // Label 23198: @1695285
     /* 1695285 */   GIM_Try, /*On fail goto*//*Label 23199*/ GIMT_Encode4(1695371), // Rule ID 7401 //
     /* 1695290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1695301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1695304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1695307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1695313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695336 */     // MIs[0] policy
     /* 1695336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695346 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11425:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1695349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695370 */     // GIR_Coverage, 7401,
     /* 1695370 */     GIR_EraseRootFromParent_Done,
     /* 1695371 */   // Label 23199: @1695371
     /* 1695371 */   GIM_Try, /*On fail goto*//*Label 23200*/ GIMT_Encode4(1695457), // Rule ID 7404 //
     /* 1695376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1695387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1695390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1695393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695422 */     // MIs[0] policy
     /* 1695422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695432 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1695435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695456 */     // GIR_Coverage, 7404,
     /* 1695456 */     GIR_EraseRootFromParent_Done,
     /* 1695457 */   // Label 23200: @1695457
     /* 1695457 */   GIM_Try, /*On fail goto*//*Label 23201*/ GIMT_Encode4(1695543), // Rule ID 7405 //
     /* 1695462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1695473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1695476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1695479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1695485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1695492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1695496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695508 */     // MIs[0] policy
     /* 1695508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695518 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1695521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695542 */     // GIR_Coverage, 7405,
     /* 1695542 */     GIR_EraseRootFromParent_Done,
     /* 1695543 */   // Label 23201: @1695543
     /* 1695543 */   GIM_Try, /*On fail goto*//*Label 23202*/ GIMT_Encode4(1695629), // Rule ID 7408 //
     /* 1695548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1695559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1695562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1695565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1695571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695594 */     // MIs[0] policy
     /* 1695594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695604 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1695607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695628 */     // GIR_Coverage, 7408,
     /* 1695628 */     GIR_EraseRootFromParent_Done,
     /* 1695629 */   // Label 23202: @1695629
     /* 1695629 */   GIM_Try, /*On fail goto*//*Label 23203*/ GIMT_Encode4(1695715), // Rule ID 7409 //
     /* 1695634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1695645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1695648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1695651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1695657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1695664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1695668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1695672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695680 */     // MIs[0] policy
     /* 1695680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695690 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1695693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1695711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695714 */     // GIR_Coverage, 7409,
     /* 1695714 */     GIR_EraseRootFromParent_Done,
     /* 1695715 */   // Label 23203: @1695715
     /* 1695715 */   GIM_Try, /*On fail goto*//*Label 23204*/ GIMT_Encode4(1695801), // Rule ID 7412 //
     /* 1695720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695766 */     // MIs[0] policy
     /* 1695766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695776 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1695779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695800 */     // GIR_Coverage, 7412,
     /* 1695800 */     GIR_EraseRootFromParent_Done,
     /* 1695801 */   // Label 23204: @1695801
     /* 1695801 */   GIM_Try, /*On fail goto*//*Label 23205*/ GIMT_Encode4(1695887), // Rule ID 7413 //
     /* 1695806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1695817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1695820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1695823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1695829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1695832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695852 */     // MIs[0] policy
     /* 1695852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695862 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1695862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF4_MASK),
     /* 1695865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695886 */     // GIR_Coverage, 7413,
     /* 1695886 */     GIR_EraseRootFromParent_Done,
     /* 1695887 */   // Label 23205: @1695887
     /* 1695887 */   GIM_Try, /*On fail goto*//*Label 23206*/ GIMT_Encode4(1695973), // Rule ID 7416 //
     /* 1695892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1695895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1695909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1695912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1695915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1695918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1695922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1695930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1695934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1695938 */     // MIs[0] policy
     /* 1695938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1695941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1695948 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1695948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1695951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1695953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1695955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1695957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1695959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1695961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1695966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1695969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1695971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1695972 */     // GIR_Coverage, 7416,
     /* 1695972 */     GIR_EraseRootFromParent_Done,
     /* 1695973 */   // Label 23206: @1695973
     /* 1695973 */   GIM_Try, /*On fail goto*//*Label 23207*/ GIMT_Encode4(1696059), // Rule ID 7417 //
     /* 1695978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1695981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1695986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1695989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1695992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1695995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1695998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696024 */     // MIs[0] policy
     /* 1696024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696034 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1696037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696058 */     // GIR_Coverage, 7417,
     /* 1696058 */     GIR_EraseRootFromParent_Done,
     /* 1696059 */   // Label 23207: @1696059
     /* 1696059 */   GIM_Try, /*On fail goto*//*Label 23208*/ GIMT_Encode4(1696145), // Rule ID 7420 //
     /* 1696064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1696081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696110 */     // MIs[0] policy
     /* 1696110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696120 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1696123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696144 */     // GIR_Coverage, 7420,
     /* 1696144 */     GIR_EraseRootFromParent_Done,
     /* 1696145 */   // Label 23208: @1696145
     /* 1696145 */   GIM_Try, /*On fail goto*//*Label 23209*/ GIMT_Encode4(1696231), // Rule ID 7421 //
     /* 1696150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1696161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1696164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1696167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696196 */     // MIs[0] policy
     /* 1696196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696206 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11425:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1696209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696230 */     // GIR_Coverage, 7421,
     /* 1696230 */     GIR_EraseRootFromParent_Done,
     /* 1696231 */   // Label 23209: @1696231
     /* 1696231 */   GIM_Try, /*On fail goto*//*Label 23210*/ GIMT_Encode4(1696317), // Rule ID 7424 //
     /* 1696236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1696247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1696250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1696253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696282 */     // MIs[0] policy
     /* 1696282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1696295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696316 */     // GIR_Coverage, 7424,
     /* 1696316 */     GIR_EraseRootFromParent_Done,
     /* 1696317 */   // Label 23210: @1696317
     /* 1696317 */   GIM_Try, /*On fail goto*//*Label 23211*/ GIMT_Encode4(1696403), // Rule ID 7425 //
     /* 1696322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1696333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1696336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1696339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1696345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696368 */     // MIs[0] policy
     /* 1696368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696378 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1696381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696402 */     // GIR_Coverage, 7425,
     /* 1696402 */     GIR_EraseRootFromParent_Done,
     /* 1696403 */   // Label 23211: @1696403
     /* 1696403 */   GIM_Try, /*On fail goto*//*Label 23212*/ GIMT_Encode4(1696489), // Rule ID 7428 //
     /* 1696408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1696411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1696419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1696422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1696425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696454 */     // MIs[0] policy
     /* 1696454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696464 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1696467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696488 */     // GIR_Coverage, 7428,
     /* 1696488 */     GIR_EraseRootFromParent_Done,
     /* 1696489 */   // Label 23212: @1696489
     /* 1696489 */   GIM_Try, /*On fail goto*//*Label 23213*/ GIMT_Encode4(1696575), // Rule ID 7429 //
     /* 1696494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1696497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1696505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1696508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1696511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1696517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1696524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1696532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696540 */     // MIs[0] policy
     /* 1696540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696550 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1696553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1696571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696574 */     // GIR_Coverage, 7429,
     /* 1696574 */     GIR_EraseRootFromParent_Done,
     /* 1696575 */   // Label 23213: @1696575
     /* 1696575 */   GIM_Try, /*On fail goto*//*Label 23214*/ GIMT_Encode4(1696661), // Rule ID 7432 //
     /* 1696580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1696583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696626 */     // MIs[0] policy
     /* 1696626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696636 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1696639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696660 */     // GIR_Coverage, 7432,
     /* 1696660 */     GIR_EraseRootFromParent_Done,
     /* 1696661 */   // Label 23214: @1696661
     /* 1696661 */   GIM_Try, /*On fail goto*//*Label 23215*/ GIMT_Encode4(1696747), // Rule ID 7433 //
     /* 1696666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1696669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1696677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1696680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1696683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1696689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696712 */     // MIs[0] policy
     /* 1696712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696722 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_MF2_MASK),
     /* 1696725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696746 */     // GIR_Coverage, 7433,
     /* 1696746 */     GIR_EraseRootFromParent_Done,
     /* 1696747 */   // Label 23215: @1696747
     /* 1696747 */   GIM_Try, /*On fail goto*//*Label 23216*/ GIMT_Encode4(1696833), // Rule ID 7436 //
     /* 1696752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1696755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1696769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696798 */     // MIs[0] policy
     /* 1696798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696808 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1696811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696832 */     // GIR_Coverage, 7436,
     /* 1696832 */     GIR_EraseRootFromParent_Done,
     /* 1696833 */   // Label 23216: @1696833
     /* 1696833 */   GIM_Try, /*On fail goto*//*Label 23217*/ GIMT_Encode4(1696919), // Rule ID 7437 //
     /* 1696838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1696841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1696849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1696852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1696855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1696858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1696861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1696864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1696868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1696872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696884 */     // MIs[0] policy
     /* 1696884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696894 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11425:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1696894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M1_MASK),
     /* 1696897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1696915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1696917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1696918 */     // GIR_Coverage, 7437,
     /* 1696918 */     GIR_EraseRootFromParent_Done,
     /* 1696919 */   // Label 23217: @1696919
     /* 1696919 */   GIM_Try, /*On fail goto*//*Label 23218*/ GIMT_Encode4(1697005), // Rule ID 7440 //
     /* 1696924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1696927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1696932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1696935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1696938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1696941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1696944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1696947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1696950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1696954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1696958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1696962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1696966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1696970 */     // MIs[0] policy
     /* 1696970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1696973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1696980 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1696980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1696983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1696985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1696987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1696989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1696991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1696993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1696998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697004 */     // GIR_Coverage, 7440,
     /* 1697004 */     GIR_EraseRootFromParent_Done,
     /* 1697005 */   // Label 23218: @1697005
     /* 1697005 */   GIM_Try, /*On fail goto*//*Label 23219*/ GIMT_Encode4(1697091), // Rule ID 7441 //
     /* 1697010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1697013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1697021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1697024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1697027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697056 */     // MIs[0] policy
     /* 1697056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11425:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M2_MASK),
     /* 1697069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697090 */     // GIR_Coverage, 7441,
     /* 1697090 */     GIR_EraseRootFromParent_Done,
     /* 1697091 */   // Label 23219: @1697091
     /* 1697091 */   GIM_Try, /*On fail goto*//*Label 23220*/ GIMT_Encode4(1697177), // Rule ID 7444 //
     /* 1697096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1697099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1697113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1697116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697142 */     // MIs[0] policy
     /* 1697142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697152 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1697155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697176 */     // GIR_Coverage, 7444,
     /* 1697176 */     GIR_EraseRootFromParent_Done,
     /* 1697177 */   // Label 23220: @1697177
     /* 1697177 */   GIM_Try, /*On fail goto*//*Label 23221*/ GIMT_Encode4(1697263), // Rule ID 7445 //
     /* 1697182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1697185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsrl_mask),
     /* 1697190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1697193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1697196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1697199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1697202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1697212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1697220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1697224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697228 */     // MIs[0] policy
     /* 1697228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11425:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRL_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRL_WX_M4_MASK),
     /* 1697241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1697259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697262 */     // GIR_Coverage, 7445,
     /* 1697262 */     GIR_EraseRootFromParent_Done,
     /* 1697263 */   // Label 23221: @1697263
     /* 1697263 */   GIM_Try, /*On fail goto*//*Label 23222*/ GIMT_Encode4(1697349), // Rule ID 7508 //
     /* 1697268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1697279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1697282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1697285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1697288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697314 */     // MIs[0] policy
     /* 1697314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697324 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1697327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697348 */     // GIR_Coverage, 7508,
     /* 1697348 */     GIR_EraseRootFromParent_Done,
     /* 1697349 */   // Label 23222: @1697349
     /* 1697349 */   GIM_Try, /*On fail goto*//*Label 23223*/ GIMT_Encode4(1697435), // Rule ID 7509 //
     /* 1697354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1697365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1697368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1697371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1697374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1697377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697400 */     // MIs[0] policy
     /* 1697400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF8_MASK),
     /* 1697413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697434 */     // GIR_Coverage, 7509,
     /* 1697434 */     GIR_EraseRootFromParent_Done,
     /* 1697435 */   // Label 23223: @1697435
     /* 1697435 */   GIM_Try, /*On fail goto*//*Label 23224*/ GIMT_Encode4(1697521), // Rule ID 7512 //
     /* 1697440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1697451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1697454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1697457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1697460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1697463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697486 */     // MIs[0] policy
     /* 1697486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1697499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697520 */     // GIR_Coverage, 7512,
     /* 1697520 */     GIR_EraseRootFromParent_Done,
     /* 1697521 */   // Label 23224: @1697521
     /* 1697521 */   GIM_Try, /*On fail goto*//*Label 23225*/ GIMT_Encode4(1697607), // Rule ID 7513 //
     /* 1697526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1697537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1697540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1697543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1697546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1697549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697572 */     // MIs[0] policy
     /* 1697572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1697585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697606 */     // GIR_Coverage, 7513,
     /* 1697606 */     GIR_EraseRootFromParent_Done,
     /* 1697607 */   // Label 23225: @1697607
     /* 1697607 */   GIM_Try, /*On fail goto*//*Label 23226*/ GIMT_Encode4(1697693), // Rule ID 7516 //
     /* 1697612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1697623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1697626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1697629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1697632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697658 */     // MIs[0] policy
     /* 1697658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1697671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697692 */     // GIR_Coverage, 7516,
     /* 1697692 */     GIR_EraseRootFromParent_Done,
     /* 1697693 */   // Label 23226: @1697693
     /* 1697693 */   GIM_Try, /*On fail goto*//*Label 23227*/ GIMT_Encode4(1697779), // Rule ID 7517 //
     /* 1697698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1697709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1697712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1697715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1697718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1697721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697744 */     // MIs[0] policy
     /* 1697744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1697757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697778 */     // GIR_Coverage, 7517,
     /* 1697778 */     GIR_EraseRootFromParent_Done,
     /* 1697779 */   // Label 23227: @1697779
     /* 1697779 */   GIM_Try, /*On fail goto*//*Label 23228*/ GIMT_Encode4(1697865), // Rule ID 7520 //
     /* 1697784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1697795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1697798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1697804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697830 */     // MIs[0] policy
     /* 1697830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1697840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1697843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697864 */     // GIR_Coverage, 7520,
     /* 1697864 */     GIR_EraseRootFromParent_Done,
     /* 1697865 */   // Label 23228: @1697865
     /* 1697865 */   GIM_Try, /*On fail goto*//*Label 23229*/ GIMT_Encode4(1697951), // Rule ID 7521 //
     /* 1697870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1697873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1697881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1697884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1697887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1697890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1697893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1697896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1697900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1697912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1697916 */     // MIs[0] policy
     /* 1697916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1697919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1697926 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1697926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1697929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1697931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1697933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1697935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1697937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1697939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1697944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1697947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1697949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1697950 */     // GIR_Coverage, 7521,
     /* 1697950 */     GIR_EraseRootFromParent_Done,
     /* 1697951 */   // Label 23229: @1697951
     /* 1697951 */   GIM_Try, /*On fail goto*//*Label 23230*/ GIMT_Encode4(1698037), // Rule ID 7524 //
     /* 1697956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1697959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1697964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1697967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1697970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1697973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1697976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1697979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1697982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1697986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1697994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1697998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698002 */     // MIs[0] policy
     /* 1698002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1698015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698036 */     // GIR_Coverage, 7524,
     /* 1698036 */     GIR_EraseRootFromParent_Done,
     /* 1698037 */   // Label 23230: @1698037
     /* 1698037 */   GIM_Try, /*On fail goto*//*Label 23231*/ GIMT_Encode4(1698123), // Rule ID 7525 //
     /* 1698042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1698053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1698056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1698059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1698062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1698065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698088 */     // MIs[0] policy
     /* 1698088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698098 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1698101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698122 */     // GIR_Coverage, 7525,
     /* 1698122 */     GIR_EraseRootFromParent_Done,
     /* 1698123 */   // Label 23231: @1698123
     /* 1698123 */   GIM_Try, /*On fail goto*//*Label 23232*/ GIMT_Encode4(1698209), // Rule ID 7528 //
     /* 1698128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1698139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1698142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1698148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698174 */     // MIs[0] policy
     /* 1698174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698184 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1698187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698208 */     // GIR_Coverage, 7528,
     /* 1698208 */     GIR_EraseRootFromParent_Done,
     /* 1698209 */   // Label 23232: @1698209
     /* 1698209 */   GIM_Try, /*On fail goto*//*Label 23233*/ GIMT_Encode4(1698295), // Rule ID 7529 //
     /* 1698214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1698225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1698228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1698231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1698234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1698237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1698244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1698252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698260 */     // MIs[0] policy
     /* 1698260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698270 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1698273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1698291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698294 */     // GIR_Coverage, 7529,
     /* 1698294 */     GIR_EraseRootFromParent_Done,
     /* 1698295 */   // Label 23233: @1698295
     /* 1698295 */   GIM_Try, /*On fail goto*//*Label 23234*/ GIMT_Encode4(1698381), // Rule ID 7532 //
     /* 1698300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1698311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1698314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1698317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1698320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698346 */     // MIs[0] policy
     /* 1698346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698356 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1698359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698380 */     // GIR_Coverage, 7532,
     /* 1698380 */     GIR_EraseRootFromParent_Done,
     /* 1698381 */   // Label 23234: @1698381
     /* 1698381 */   GIM_Try, /*On fail goto*//*Label 23235*/ GIMT_Encode4(1698467), // Rule ID 7533 //
     /* 1698386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1698397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1698400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1698403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1698406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1698409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698432 */     // MIs[0] policy
     /* 1698432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698442 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF4_MASK),
     /* 1698445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698466 */     // GIR_Coverage, 7533,
     /* 1698466 */     GIR_EraseRootFromParent_Done,
     /* 1698467 */   // Label 23235: @1698467
     /* 1698467 */   GIM_Try, /*On fail goto*//*Label 23236*/ GIMT_Encode4(1698553), // Rule ID 7536 //
     /* 1698472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1698483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1698486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1698489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1698492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698518 */     // MIs[0] policy
     /* 1698518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698528 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1698531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698552 */     // GIR_Coverage, 7536,
     /* 1698552 */     GIR_EraseRootFromParent_Done,
     /* 1698553 */   // Label 23236: @1698553
     /* 1698553 */   GIM_Try, /*On fail goto*//*Label 23237*/ GIMT_Encode4(1698639), // Rule ID 7537 //
     /* 1698558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1698569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1698572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1698575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1698578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1698581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698604 */     // MIs[0] policy
     /* 1698604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698614 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1698617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698638 */     // GIR_Coverage, 7537,
     /* 1698638 */     GIR_EraseRootFromParent_Done,
     /* 1698639 */   // Label 23237: @1698639
     /* 1698639 */   GIM_Try, /*On fail goto*//*Label 23238*/ GIMT_Encode4(1698725), // Rule ID 7540 //
     /* 1698644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1698655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1698658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1698664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698690 */     // MIs[0] policy
     /* 1698690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698700 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1698703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698724 */     // GIR_Coverage, 7540,
     /* 1698724 */     GIR_EraseRootFromParent_Done,
     /* 1698725 */   // Label 23238: @1698725
     /* 1698725 */   GIM_Try, /*On fail goto*//*Label 23239*/ GIMT_Encode4(1698811), // Rule ID 7541 //
     /* 1698730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1698741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1698744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1698747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1698750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1698753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1698760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1698772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698776 */     // MIs[0] policy
     /* 1698776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1698789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698810 */     // GIR_Coverage, 7541,
     /* 1698810 */     GIR_EraseRootFromParent_Done,
     /* 1698811 */   // Label 23239: @1698811
     /* 1698811 */   GIM_Try, /*On fail goto*//*Label 23240*/ GIMT_Encode4(1698897), // Rule ID 7544 //
     /* 1698816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1698827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1698830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1698836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1698842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698862 */     // MIs[0] policy
     /* 1698862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1698872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1698875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698896 */     // GIR_Coverage, 7544,
     /* 1698896 */     GIR_EraseRootFromParent_Done,
     /* 1698897 */   // Label 23240: @1698897
     /* 1698897 */   GIM_Try, /*On fail goto*//*Label 23241*/ GIMT_Encode4(1698983), // Rule ID 7545 //
     /* 1698902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1698905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1698913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1698916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1698919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1698922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1698925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1698928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1698932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1698940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1698944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1698948 */     // MIs[0] policy
     /* 1698948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1698951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1698958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1698958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1698961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1698963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1698965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1698967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1698969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1698971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1698976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1698979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1698981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1698982 */     // GIR_Coverage, 7545,
     /* 1698982 */     GIR_EraseRootFromParent_Done,
     /* 1698983 */   // Label 23241: @1698983
     /* 1698983 */   GIM_Try, /*On fail goto*//*Label 23242*/ GIMT_Encode4(1699069), // Rule ID 7548 //
     /* 1698988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1698991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1698996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1698999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1699002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1699005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1699008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699034 */     // MIs[0] policy
     /* 1699034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1699047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699068 */     // GIR_Coverage, 7548,
     /* 1699068 */     GIR_EraseRootFromParent_Done,
     /* 1699069 */   // Label 23242: @1699069
     /* 1699069 */   GIM_Try, /*On fail goto*//*Label 23243*/ GIMT_Encode4(1699155), // Rule ID 7549 //
     /* 1699074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1699085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1699088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1699091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1699094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1699097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699120 */     // MIs[0] policy
     /* 1699120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1699133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1699151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699154 */     // GIR_Coverage, 7549,
     /* 1699154 */     GIR_EraseRootFromParent_Done,
     /* 1699155 */   // Label 23243: @1699155
     /* 1699155 */   GIM_Try, /*On fail goto*//*Label 23244*/ GIMT_Encode4(1699241), // Rule ID 7552 //
     /* 1699160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1699163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1699171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1699174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1699177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1699180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699206 */     // MIs[0] policy
     /* 1699206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1699219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699240 */     // GIR_Coverage, 7552,
     /* 1699240 */     GIR_EraseRootFromParent_Done,
     /* 1699241 */   // Label 23244: @1699241
     /* 1699241 */   GIM_Try, /*On fail goto*//*Label 23245*/ GIMT_Encode4(1699327), // Rule ID 7553 //
     /* 1699246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1699249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1699257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1699260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1699263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1699266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699292 */     // MIs[0] policy
     /* 1699292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_MF2_MASK),
     /* 1699305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699326 */     // GIR_Coverage, 7553,
     /* 1699326 */     GIR_EraseRootFromParent_Done,
     /* 1699327 */   // Label 23245: @1699327
     /* 1699327 */   GIM_Try, /*On fail goto*//*Label 23246*/ GIMT_Encode4(1699413), // Rule ID 7556 //
     /* 1699332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1699335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1699343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1699346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1699349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1699352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699378 */     // MIs[0] policy
     /* 1699378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699388 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1699391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699412 */     // GIR_Coverage, 7556,
     /* 1699412 */     GIR_EraseRootFromParent_Done,
     /* 1699413 */   // Label 23246: @1699413
     /* 1699413 */   GIM_Try, /*On fail goto*//*Label 23247*/ GIMT_Encode4(1699499), // Rule ID 7557 //
     /* 1699418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1699421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1699429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1699432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1699435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1699438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1699441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699464 */     // MIs[0] policy
     /* 1699464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699474 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M1_MASK),
     /* 1699477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699498 */     // GIR_Coverage, 7557,
     /* 1699498 */     GIR_EraseRootFromParent_Done,
     /* 1699499 */   // Label 23247: @1699499
     /* 1699499 */   GIM_Try, /*On fail goto*//*Label 23248*/ GIMT_Encode4(1699585), // Rule ID 7560 //
     /* 1699504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1699507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1699515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1699518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1699521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1699524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699550 */     // MIs[0] policy
     /* 1699550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1699563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699584 */     // GIR_Coverage, 7560,
     /* 1699584 */     GIR_EraseRootFromParent_Done,
     /* 1699585 */   // Label 23248: @1699585
     /* 1699585 */   GIM_Try, /*On fail goto*//*Label 23249*/ GIMT_Encode4(1699671), // Rule ID 7561 //
     /* 1699590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1699593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1699601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1699604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1699607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1699610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1699613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1699620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1699632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699636 */     // MIs[0] policy
     /* 1699636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699646 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M2_MASK),
     /* 1699649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699670 */     // GIR_Coverage, 7561,
     /* 1699670 */     GIR_EraseRootFromParent_Done,
     /* 1699671 */   // Label 23249: @1699671
     /* 1699671 */   GIM_Try, /*On fail goto*//*Label 23250*/ GIMT_Encode4(1699757), // Rule ID 7564 //
     /* 1699676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1699679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1699687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1699690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1699696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699722 */     // MIs[0] policy
     /* 1699722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699732 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1699735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699756 */     // GIR_Coverage, 7564,
     /* 1699756 */     GIR_EraseRootFromParent_Done,
     /* 1699757 */   // Label 23250: @1699757
     /* 1699757 */   GIM_Try, /*On fail goto*//*Label 23251*/ GIMT_Encode4(1699843), // Rule ID 7565 //
     /* 1699762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1699765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1699773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1699776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1699779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1699782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1699785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1699792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1699800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1699804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699808 */     // MIs[0] policy
     /* 1699808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699818 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WV_M4_MASK),
     /* 1699821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1699839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699842 */     // GIR_Coverage, 7565,
     /* 1699842 */     GIR_EraseRootFromParent_Done,
     /* 1699843 */   // Label 23251: @1699843
     /* 1699843 */   GIM_Try, /*On fail goto*//*Label 23252*/ GIMT_Encode4(1699929), // Rule ID 7568 //
     /* 1699848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1699851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1699868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1699874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699894 */     // MIs[0] policy
     /* 1699894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699904 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1699904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1699907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1699915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1699917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1699922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1699925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1699927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1699928 */     // GIR_Coverage, 7568,
     /* 1699928 */     GIR_EraseRootFromParent_Done,
     /* 1699929 */   // Label 23252: @1699929
     /* 1699929 */   GIM_Try, /*On fail goto*//*Label 23253*/ GIMT_Encode4(1700015), // Rule ID 7569 //
     /* 1699934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1699937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1699942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1699945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1699948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1699951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1699954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1699957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1699960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1699964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1699972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1699976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1699980 */     // MIs[0] policy
     /* 1699980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1699983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1699990 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1699990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF8_MASK),
     /* 1699993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1699995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1699997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1699999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700014 */     // GIR_Coverage, 7569,
     /* 1700014 */     GIR_EraseRootFromParent_Done,
     /* 1700015 */   // Label 23253: @1700015
     /* 1700015 */   GIM_Try, /*On fail goto*//*Label 23254*/ GIMT_Encode4(1700101), // Rule ID 7572 //
     /* 1700020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1700031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1700034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1700037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700066 */     // MIs[0] policy
     /* 1700066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700076 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1700079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700100 */     // GIR_Coverage, 7572,
     /* 1700100 */     GIR_EraseRootFromParent_Done,
     /* 1700101 */   // Label 23254: @1700101
     /* 1700101 */   GIM_Try, /*On fail goto*//*Label 23255*/ GIMT_Encode4(1700187), // Rule ID 7573 //
     /* 1700106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1700117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1700120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1700123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1700129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700152 */     // MIs[0] policy
     /* 1700152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700162 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1700165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700186 */     // GIR_Coverage, 7573,
     /* 1700186 */     GIR_EraseRootFromParent_Done,
     /* 1700187 */   // Label 23255: @1700187
     /* 1700187 */   GIM_Try, /*On fail goto*//*Label 23256*/ GIMT_Encode4(1700273), // Rule ID 7576 //
     /* 1700192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1700203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1700206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1700209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700238 */     // MIs[0] policy
     /* 1700238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700248 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1700251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700272 */     // GIR_Coverage, 7576,
     /* 1700272 */     GIR_EraseRootFromParent_Done,
     /* 1700273 */   // Label 23256: @1700273
     /* 1700273 */   GIM_Try, /*On fail goto*//*Label 23257*/ GIMT_Encode4(1700359), // Rule ID 7577 //
     /* 1700278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1700289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1700292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1700295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1700301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700324 */     // MIs[0] policy
     /* 1700324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700334 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1700337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700358 */     // GIR_Coverage, 7577,
     /* 1700358 */     GIR_EraseRootFromParent_Done,
     /* 1700359 */   // Label 23257: @1700359
     /* 1700359 */   GIM_Try, /*On fail goto*//*Label 23258*/ GIMT_Encode4(1700445), // Rule ID 7580 //
     /* 1700364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1700375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1700378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1700381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700410 */     // MIs[0] policy
     /* 1700410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1700423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700444 */     // GIR_Coverage, 7580,
     /* 1700444 */     GIR_EraseRootFromParent_Done,
     /* 1700445 */   // Label 23258: @1700445
     /* 1700445 */   GIM_Try, /*On fail goto*//*Label 23259*/ GIMT_Encode4(1700531), // Rule ID 7581 //
     /* 1700450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1700461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1700464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1700467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1700473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700496 */     // MIs[0] policy
     /* 1700496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700506 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11423:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1700509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700530 */     // GIR_Coverage, 7581,
     /* 1700530 */     GIR_EraseRootFromParent_Done,
     /* 1700531 */   // Label 23259: @1700531
     /* 1700531 */   GIM_Try, /*On fail goto*//*Label 23260*/ GIMT_Encode4(1700617), // Rule ID 7584 //
     /* 1700536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1700547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1700550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1700553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700582 */     // MIs[0] policy
     /* 1700582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700592 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1700595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700616 */     // GIR_Coverage, 7584,
     /* 1700616 */     GIR_EraseRootFromParent_Done,
     /* 1700617 */   // Label 23260: @1700617
     /* 1700617 */   GIM_Try, /*On fail goto*//*Label 23261*/ GIMT_Encode4(1700703), // Rule ID 7585 //
     /* 1700622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1700633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1700636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1700639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1700645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1700652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1700656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700668 */     // MIs[0] policy
     /* 1700668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700678 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1700681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700702 */     // GIR_Coverage, 7585,
     /* 1700702 */     GIR_EraseRootFromParent_Done,
     /* 1700703 */   // Label 23261: @1700703
     /* 1700703 */   GIM_Try, /*On fail goto*//*Label 23262*/ GIMT_Encode4(1700789), // Rule ID 7588 //
     /* 1700708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700754 */     // MIs[0] policy
     /* 1700754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700764 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1700767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700788 */     // GIR_Coverage, 7588,
     /* 1700788 */     GIR_EraseRootFromParent_Done,
     /* 1700789 */   // Label 23262: @1700789
     /* 1700789 */   GIM_Try, /*On fail goto*//*Label 23263*/ GIMT_Encode4(1700875), // Rule ID 7589 //
     /* 1700794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1700805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1700808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1700811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1700817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1700824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1700828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1700832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700840 */     // MIs[0] policy
     /* 1700840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700850 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1700850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1700853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1700871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700874 */     // GIR_Coverage, 7589,
     /* 1700874 */     GIR_EraseRootFromParent_Done,
     /* 1700875 */   // Label 23263: @1700875
     /* 1700875 */   GIM_Try, /*On fail goto*//*Label 23264*/ GIMT_Encode4(1700961), // Rule ID 7592 //
     /* 1700880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1700883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1700900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1700906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1700918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1700922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1700926 */     // MIs[0] policy
     /* 1700926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1700929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1700936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1700936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1700939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1700941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1700943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1700945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1700947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1700949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1700954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1700957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1700959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1700960 */     // GIR_Coverage, 7592,
     /* 1700960 */     GIR_EraseRootFromParent_Done,
     /* 1700961 */   // Label 23264: @1700961
     /* 1700961 */   GIM_Try, /*On fail goto*//*Label 23265*/ GIMT_Encode4(1701047), // Rule ID 7593 //
     /* 1700966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1700969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1700974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1700977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1700980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1700983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1700986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1700989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1700992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1700996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701012 */     // MIs[0] policy
     /* 1701012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF4_MASK),
     /* 1701025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701046 */     // GIR_Coverage, 7593,
     /* 1701046 */     GIR_EraseRootFromParent_Done,
     /* 1701047 */   // Label 23265: @1701047
     /* 1701047 */   GIM_Try, /*On fail goto*//*Label 23266*/ GIMT_Encode4(1701133), // Rule ID 7596 //
     /* 1701052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1701063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1701066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1701069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701098 */     // MIs[0] policy
     /* 1701098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1701111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701132 */     // GIR_Coverage, 7596,
     /* 1701132 */     GIR_EraseRootFromParent_Done,
     /* 1701133 */   // Label 23266: @1701133
     /* 1701133 */   GIM_Try, /*On fail goto*//*Label 23267*/ GIMT_Encode4(1701219), // Rule ID 7597 //
     /* 1701138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1701149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1701152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1701155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701184 */     // MIs[0] policy
     /* 1701184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1701197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701218 */     // GIR_Coverage, 7597,
     /* 1701218 */     GIR_EraseRootFromParent_Done,
     /* 1701219 */   // Label 23267: @1701219
     /* 1701219 */   GIM_Try, /*On fail goto*//*Label 23268*/ GIMT_Encode4(1701305), // Rule ID 7600 //
     /* 1701224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1701235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1701238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701270 */     // MIs[0] policy
     /* 1701270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701280 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1701283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701304 */     // GIR_Coverage, 7600,
     /* 1701304 */     GIR_EraseRootFromParent_Done,
     /* 1701305 */   // Label 23268: @1701305
     /* 1701305 */   GIM_Try, /*On fail goto*//*Label 23269*/ GIMT_Encode4(1701391), // Rule ID 7601 //
     /* 1701310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1701321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1701324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1701327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1701333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701356 */     // MIs[0] policy
     /* 1701356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701366 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11423:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1701369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701390 */     // GIR_Coverage, 7601,
     /* 1701390 */     GIR_EraseRootFromParent_Done,
     /* 1701391 */   // Label 23269: @1701391
     /* 1701391 */   GIM_Try, /*On fail goto*//*Label 23270*/ GIMT_Encode4(1701477), // Rule ID 7604 //
     /* 1701396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1701407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1701410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701442 */     // MIs[0] policy
     /* 1701442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701452 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1701455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701476 */     // GIR_Coverage, 7604,
     /* 1701476 */     GIR_EraseRootFromParent_Done,
     /* 1701477 */   // Label 23270: @1701477
     /* 1701477 */   GIM_Try, /*On fail goto*//*Label 23271*/ GIMT_Encode4(1701563), // Rule ID 7605 //
     /* 1701482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1701493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1701496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1701499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1701505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1701512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701528 */     // MIs[0] policy
     /* 1701528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701538 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1701541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701562 */     // GIR_Coverage, 7605,
     /* 1701562 */     GIR_EraseRootFromParent_Done,
     /* 1701563 */   // Label 23271: @1701563
     /* 1701563 */   GIM_Try, /*On fail goto*//*Label 23272*/ GIMT_Encode4(1701649), // Rule ID 7608 //
     /* 1701568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1701571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1701579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1701582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1701585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701614 */     // MIs[0] policy
     /* 1701614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701624 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1701627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701648 */     // GIR_Coverage, 7608,
     /* 1701648 */     GIR_EraseRootFromParent_Done,
     /* 1701649 */   // Label 23272: @1701649
     /* 1701649 */   GIM_Try, /*On fail goto*//*Label 23273*/ GIMT_Encode4(1701735), // Rule ID 7609 //
     /* 1701654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1701657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1701665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1701668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1701671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1701677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1701684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1701688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1701692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701700 */     // MIs[0] policy
     /* 1701700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701710 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1701713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1701731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701734 */     // GIR_Coverage, 7609,
     /* 1701734 */     GIR_EraseRootFromParent_Done,
     /* 1701735 */   // Label 23273: @1701735
     /* 1701735 */   GIM_Try, /*On fail goto*//*Label 23274*/ GIMT_Encode4(1701821), // Rule ID 7612 //
     /* 1701740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701786 */     // MIs[0] policy
     /* 1701786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701796 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1701799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701820 */     // GIR_Coverage, 7612,
     /* 1701820 */     GIR_EraseRootFromParent_Done,
     /* 1701821 */   // Label 23274: @1701821
     /* 1701821 */   GIM_Try, /*On fail goto*//*Label 23275*/ GIMT_Encode4(1701907), // Rule ID 7613 //
     /* 1701826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1701829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1701837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1701840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1701843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1701846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1701849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1701852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701872 */     // MIs[0] policy
     /* 1701872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701882 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1701882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_MF2_MASK),
     /* 1701885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701906 */     // GIR_Coverage, 7613,
     /* 1701906 */     GIR_EraseRootFromParent_Done,
     /* 1701907 */   // Label 23275: @1701907
     /* 1701907 */   GIM_Try, /*On fail goto*//*Label 23276*/ GIMT_Encode4(1701993), // Rule ID 7616 //
     /* 1701912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1701915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1701920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1701923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1701926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1701929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1701932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1701935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1701938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1701942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1701946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1701950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1701954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1701958 */     // MIs[0] policy
     /* 1701958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1701961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1701968 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1701968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1701971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1701973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1701975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1701977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1701979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1701981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1701986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1701989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1701991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1701992 */     // GIR_Coverage, 7616,
     /* 1701992 */     GIR_EraseRootFromParent_Done,
     /* 1701993 */   // Label 23276: @1701993
     /* 1701993 */   GIM_Try, /*On fail goto*//*Label 23277*/ GIMT_Encode4(1702079), // Rule ID 7617 //
     /* 1701998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1702001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1702009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1702012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1702015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702044 */     // MIs[0] policy
     /* 1702044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702054 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11423:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M1_MASK),
     /* 1702057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702078 */     // GIR_Coverage, 7617,
     /* 1702078 */     GIR_EraseRootFromParent_Done,
     /* 1702079 */   // Label 23277: @1702079
     /* 1702079 */   GIM_Try, /*On fail goto*//*Label 23278*/ GIMT_Encode4(1702165), // Rule ID 7620 //
     /* 1702084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1702087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1702095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1702098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1702101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702130 */     // MIs[0] policy
     /* 1702130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1702143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702164 */     // GIR_Coverage, 7620,
     /* 1702164 */     GIR_EraseRootFromParent_Done,
     /* 1702165 */   // Label 23278: @1702165
     /* 1702165 */   GIM_Try, /*On fail goto*//*Label 23279*/ GIMT_Encode4(1702251), // Rule ID 7621 //
     /* 1702170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1702173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1702181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1702184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1702187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1702200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1702204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702216 */     // MIs[0] policy
     /* 1702216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11423:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M2_MASK),
     /* 1702229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702250 */     // GIR_Coverage, 7621,
     /* 1702250 */     GIR_EraseRootFromParent_Done,
     /* 1702251 */   // Label 23279: @1702251
     /* 1702251 */   GIM_Try, /*On fail goto*//*Label 23280*/ GIMT_Encode4(1702337), // Rule ID 7624 //
     /* 1702256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1702259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1702267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1702270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1702273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1702276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702302 */     // MIs[0] policy
     /* 1702302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702312 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1702315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702336 */     // GIR_Coverage, 7624,
     /* 1702336 */     GIR_EraseRootFromParent_Done,
     /* 1702337 */   // Label 23280: @1702337
     /* 1702337 */   GIM_Try, /*On fail goto*//*Label 23281*/ GIMT_Encode4(1702423), // Rule ID 7625 //
     /* 1702342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1702345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnsra_mask),
     /* 1702350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1702353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1702356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1702359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1702362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1702365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1702372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1702376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1702380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1702384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702388 */     // MIs[0] policy
     /* 1702388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702398 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11423:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNSRA_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNSRA_WX_M4_MASK),
     /* 1702401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1702419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702422 */     // GIR_Coverage, 7625,
     /* 1702422 */     GIR_EraseRootFromParent_Done,
     /* 1702423 */   // Label 23281: @1702423
     /* 1702423 */   GIM_Try, /*On fail goto*//*Label 23282*/ GIMT_Encode4(1702509), // Rule ID 10140 //
     /* 1702428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1702439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1702442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1702445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1702448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702474 */     // MIs[0] policy
     /* 1702474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1702487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702508 */     // GIR_Coverage, 10140,
     /* 1702508 */     GIR_EraseRootFromParent_Done,
     /* 1702509 */   // Label 23282: @1702509
     /* 1702509 */   GIM_Try, /*On fail goto*//*Label 23283*/ GIMT_Encode4(1702595), // Rule ID 10141 //
     /* 1702514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1702525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1702528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1702531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1702534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702560 */     // MIs[0] policy
     /* 1702560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702570 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8_MASK),
     /* 1702573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702594 */     // GIR_Coverage, 10141,
     /* 1702594 */     GIR_EraseRootFromParent_Done,
     /* 1702595 */   // Label 23283: @1702595
     /* 1702595 */   GIM_Try, /*On fail goto*//*Label 23284*/ GIMT_Encode4(1702681), // Rule ID 10144 //
     /* 1702600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1702617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1702620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702646 */     // MIs[0] policy
     /* 1702646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702656 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1702659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702680 */     // GIR_Coverage, 10144,
     /* 1702680 */     GIR_EraseRootFromParent_Done,
     /* 1702681 */   // Label 23284: @1702681
     /* 1702681 */   GIM_Try, /*On fail goto*//*Label 23285*/ GIMT_Encode4(1702767), // Rule ID 10145 //
     /* 1702686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1702697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1702700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1702703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1702706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1702709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702732 */     // MIs[0] policy
     /* 1702732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702742 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1702745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702766 */     // GIR_Coverage, 10145,
     /* 1702766 */     GIR_EraseRootFromParent_Done,
     /* 1702767 */   // Label 23285: @1702767
     /* 1702767 */   GIM_Try, /*On fail goto*//*Label 23286*/ GIMT_Encode4(1702853), // Rule ID 10148 //
     /* 1702772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1702789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1702792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702818 */     // MIs[0] policy
     /* 1702818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702828 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1702828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1702831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702852 */     // GIR_Coverage, 10148,
     /* 1702852 */     GIR_EraseRootFromParent_Done,
     /* 1702853 */   // Label 23286: @1702853
     /* 1702853 */   GIM_Try, /*On fail goto*//*Label 23287*/ GIMT_Encode4(1702939), // Rule ID 10149 //
     /* 1702858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1702861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1702869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1702872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1702875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1702878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1702881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1702884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702904 */     // MIs[0] policy
     /* 1702904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1702914 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1702914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1702917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1702919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1702921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1702923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1702925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1702927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1702932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1702935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1702937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1702938 */     // GIR_Coverage, 10149,
     /* 1702938 */     GIR_EraseRootFromParent_Done,
     /* 1702939 */   // Label 23287: @1702939
     /* 1702939 */   GIM_Try, /*On fail goto*//*Label 23288*/ GIMT_Encode4(1703025), // Rule ID 10152 //
     /* 1702944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1702947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1702952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1702955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1702958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1702961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1702964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1702967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1702970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1702974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1702986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1702990 */     // MIs[0] policy
     /* 1702990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1702993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703000 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1703003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703024 */     // GIR_Coverage, 10152,
     /* 1703024 */     GIR_EraseRootFromParent_Done,
     /* 1703025 */   // Label 23288: @1703025
     /* 1703025 */   GIM_Try, /*On fail goto*//*Label 23289*/ GIMT_Encode4(1703111), // Rule ID 10153 //
     /* 1703030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1703041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1703044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1703047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1703050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703076 */     // MIs[0] policy
     /* 1703076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703086 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4_MASK),
     /* 1703089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703110 */     // GIR_Coverage, 10153,
     /* 1703110 */     GIR_EraseRootFromParent_Done,
     /* 1703111 */   // Label 23289: @1703111
     /* 1703111 */   GIM_Try, /*On fail goto*//*Label 23290*/ GIMT_Encode4(1703197), // Rule ID 10156 //
     /* 1703116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1703133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1703136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703162 */     // MIs[0] policy
     /* 1703162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703172 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1703175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703196 */     // GIR_Coverage, 10156,
     /* 1703196 */     GIR_EraseRootFromParent_Done,
     /* 1703197 */   // Label 23290: @1703197
     /* 1703197 */   GIM_Try, /*On fail goto*//*Label 23291*/ GIMT_Encode4(1703283), // Rule ID 10157 //
     /* 1703202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1703213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1703216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1703219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1703222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703248 */     // MIs[0] policy
     /* 1703248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703258 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1703261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703282 */     // GIR_Coverage, 10157,
     /* 1703282 */     GIR_EraseRootFromParent_Done,
     /* 1703283 */   // Label 23291: @1703283
     /* 1703283 */   GIM_Try, /*On fail goto*//*Label 23292*/ GIMT_Encode4(1703369), // Rule ID 10160 //
     /* 1703288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1703308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703334 */     // MIs[0] policy
     /* 1703334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703344 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1703347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703368 */     // GIR_Coverage, 10160,
     /* 1703368 */     GIR_EraseRootFromParent_Done,
     /* 1703369 */   // Label 23292: @1703369
     /* 1703369 */   GIM_Try, /*On fail goto*//*Label 23293*/ GIMT_Encode4(1703455), // Rule ID 10161 //
     /* 1703374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1703385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1703388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1703391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1703394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703420 */     // MIs[0] policy
     /* 1703420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703430 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2_MASK),
     /* 1703433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703454 */     // GIR_Coverage, 10161,
     /* 1703454 */     GIR_EraseRootFromParent_Done,
     /* 1703455 */   // Label 23293: @1703455
     /* 1703455 */   GIM_Try, /*On fail goto*//*Label 23294*/ GIMT_Encode4(1703541), // Rule ID 10164 //
     /* 1703460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1703471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1703474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1703477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1703480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703506 */     // MIs[0] policy
     /* 1703506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703540 */     // GIR_Coverage, 10164,
     /* 1703540 */     GIR_EraseRootFromParent_Done,
     /* 1703541 */   // Label 23294: @1703541
     /* 1703541 */   GIM_Try, /*On fail goto*//*Label 23295*/ GIMT_Encode4(1703627), // Rule ID 10165 //
     /* 1703546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1703557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1703560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1703563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1703566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1703569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703592 */     // MIs[0] policy
     /* 1703592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703602 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1703623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703626 */     // GIR_Coverage, 10165,
     /* 1703626 */     GIR_EraseRootFromParent_Done,
     /* 1703627 */   // Label 23295: @1703627
     /* 1703627 */   GIM_Try, /*On fail goto*//*Label 23296*/ GIMT_Encode4(1703713), // Rule ID 10168 //
     /* 1703632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1703649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1703652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703678 */     // MIs[0] policy
     /* 1703678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703688 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703712 */     // GIR_Coverage, 10168,
     /* 1703712 */     GIR_EraseRootFromParent_Done,
     /* 1703713 */   // Label 23296: @1703713
     /* 1703713 */   GIM_Try, /*On fail goto*//*Label 23297*/ GIMT_Encode4(1703799), // Rule ID 10169 //
     /* 1703718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1703729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1703732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1703735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1703738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1703741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703764 */     // MIs[0] policy
     /* 1703764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703774 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1703795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703798 */     // GIR_Coverage, 10169,
     /* 1703798 */     GIR_EraseRootFromParent_Done,
     /* 1703799 */   // Label 23297: @1703799
     /* 1703799 */   GIM_Try, /*On fail goto*//*Label 23298*/ GIMT_Encode4(1703885), // Rule ID 10172 //
     /* 1703804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1703807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1703824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1703830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703850 */     // MIs[0] policy
     /* 1703850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1703860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703884 */     // GIR_Coverage, 10172,
     /* 1703884 */     GIR_EraseRootFromParent_Done,
     /* 1703885 */   // Label 23298: @1703885
     /* 1703885 */   GIM_Try, /*On fail goto*//*Label 23299*/ GIMT_Encode4(1703971), // Rule ID 10173 //
     /* 1703890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1703893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1703901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1703904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1703907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1703910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1703913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1703916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1703920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1703932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1703936 */     // MIs[0] policy
     /* 1703936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1703939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1703946 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1703946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1703949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1703951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1703953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1703955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1703957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1703959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1703964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1703967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1703969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1703970 */     // GIR_Coverage, 10173,
     /* 1703970 */     GIR_EraseRootFromParent_Done,
     /* 1703971 */   // Label 23299: @1703971
     /* 1703971 */   GIM_Try, /*On fail goto*//*Label 23300*/ GIMT_Encode4(1704057), // Rule ID 10176 //
     /* 1703976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1703979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1703984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1703987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1703990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1703993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1703996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1703999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704022 */     // MIs[0] policy
     /* 1704022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704032 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1704035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1704053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704056 */     // GIR_Coverage, 10176,
     /* 1704056 */     GIR_EraseRootFromParent_Done,
     /* 1704057 */   // Label 23300: @1704057
     /* 1704057 */   GIM_Try, /*On fail goto*//*Label 23301*/ GIMT_Encode4(1704143), // Rule ID 10177 //
     /* 1704062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1704065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1704073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1704076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1704079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1704082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1704085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1704092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1704104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704108 */     // MIs[0] policy
     /* 1704108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704118 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1_MASK),
     /* 1704121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1704139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704142 */     // GIR_Coverage, 10177,
     /* 1704142 */     GIR_EraseRootFromParent_Done,
     /* 1704143 */   // Label 23301: @1704143
     /* 1704143 */   GIM_Try, /*On fail goto*//*Label 23302*/ GIMT_Encode4(1704229), // Rule ID 10180 //
     /* 1704148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1704165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704194 */     // MIs[0] policy
     /* 1704194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704204 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1704207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704228 */     // GIR_Coverage, 10180,
     /* 1704228 */     GIR_EraseRootFromParent_Done,
     /* 1704229 */   // Label 23302: @1704229
     /* 1704229 */   GIM_Try, /*On fail goto*//*Label 23303*/ GIMT_Encode4(1704315), // Rule ID 10181 //
     /* 1704234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1704245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1704248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1704251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1704254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704280 */     // MIs[0] policy
     /* 1704280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704290 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1704293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704314 */     // GIR_Coverage, 10181,
     /* 1704314 */     GIR_EraseRootFromParent_Done,
     /* 1704315 */   // Label 23303: @1704315
     /* 1704315 */   GIM_Try, /*On fail goto*//*Label 23304*/ GIMT_Encode4(1704401), // Rule ID 10184 //
     /* 1704320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1704337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704366 */     // MIs[0] policy
     /* 1704366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704376 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1704379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704400 */     // GIR_Coverage, 10184,
     /* 1704400 */     GIR_EraseRootFromParent_Done,
     /* 1704401 */   // Label 23304: @1704401
     /* 1704401 */   GIM_Try, /*On fail goto*//*Label 23305*/ GIMT_Encode4(1704487), // Rule ID 10185 //
     /* 1704406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1704417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1704420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1704423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1704426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1704429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704452 */     // MIs[0] policy
     /* 1704452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704462 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1704465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704486 */     // GIR_Coverage, 10185,
     /* 1704486 */     GIR_EraseRootFromParent_Done,
     /* 1704487 */   // Label 23305: @1704487
     /* 1704487 */   GIM_Try, /*On fail goto*//*Label 23306*/ GIMT_Encode4(1704573), // Rule ID 10188 //
     /* 1704492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1704503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1704506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1704509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1704512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1704515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1704522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704538 */     // MIs[0] policy
     /* 1704538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704548 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1704551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704572 */     // GIR_Coverage, 10188,
     /* 1704572 */     GIR_EraseRootFromParent_Done,
     /* 1704573 */   // Label 23306: @1704573
     /* 1704573 */   GIM_Try, /*On fail goto*//*Label 23307*/ GIMT_Encode4(1704659), // Rule ID 10189 //
     /* 1704578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1704589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1704592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1704595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1704598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1704601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1704608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1704620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704624 */     // MIs[0] policy
     /* 1704624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704634 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1704637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1704655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704658 */     // GIR_Coverage, 10189,
     /* 1704658 */     GIR_EraseRootFromParent_Done,
     /* 1704659 */   // Label 23307: @1704659
     /* 1704659 */   GIM_Try, /*On fail goto*//*Label 23308*/ GIMT_Encode4(1704745), // Rule ID 10192 //
     /* 1704664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1704675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1704678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1704684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704710 */     // MIs[0] policy
     /* 1704710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704720 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1704723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704744 */     // GIR_Coverage, 10192,
     /* 1704744 */     GIR_EraseRootFromParent_Done,
     /* 1704745 */   // Label 23308: @1704745
     /* 1704745 */   GIM_Try, /*On fail goto*//*Label 23309*/ GIMT_Encode4(1704831), // Rule ID 10193 //
     /* 1704750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1704761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1704764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1704767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1704770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1704773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1704780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1704792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704796 */     // MIs[0] policy
     /* 1704796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1704809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704830 */     // GIR_Coverage, 10193,
     /* 1704830 */     GIR_EraseRootFromParent_Done,
     /* 1704831 */   // Label 23309: @1704831
     /* 1704831 */   GIM_Try, /*On fail goto*//*Label 23310*/ GIMT_Encode4(1704917), // Rule ID 10196 //
     /* 1704836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1704839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1704847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1704850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1704856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1704862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704882 */     // MIs[0] policy
     /* 1704882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704892 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1704892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1704895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1704915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1704916 */     // GIR_Coverage, 10196,
     /* 1704916 */     GIR_EraseRootFromParent_Done,
     /* 1704917 */   // Label 23310: @1704917
     /* 1704917 */   GIM_Try, /*On fail goto*//*Label 23311*/ GIMT_Encode4(1705003), // Rule ID 10197 //
     /* 1704922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1704925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1704930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1704933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1704936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1704939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1704942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1704945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1704948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1704952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1704964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1704968 */     // MIs[0] policy
     /* 1704968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1704971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1704978 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1704978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1704981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1704983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1704985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1704987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1704989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1704991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1704996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1704999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705002 */     // GIR_Coverage, 10197,
     /* 1705002 */     GIR_EraseRootFromParent_Done,
     /* 1705003 */   // Label 23311: @1705003
     /* 1705003 */   GIM_Try, /*On fail goto*//*Label 23312*/ GIMT_Encode4(1705089), // Rule ID 10200 //
     /* 1705008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1705019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1705022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1705028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705054 */     // MIs[0] policy
     /* 1705054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705064 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1705067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705088 */     // GIR_Coverage, 10200,
     /* 1705088 */     GIR_EraseRootFromParent_Done,
     /* 1705089 */   // Label 23312: @1705089
     /* 1705089 */   GIM_Try, /*On fail goto*//*Label 23313*/ GIMT_Encode4(1705175), // Rule ID 10201 //
     /* 1705094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1705105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1705108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1705111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1705114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1705117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705140 */     // MIs[0] policy
     /* 1705140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705150 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1705153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1705171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705174 */     // GIR_Coverage, 10201,
     /* 1705174 */     GIR_EraseRootFromParent_Done,
     /* 1705175 */   // Label 23313: @1705175
     /* 1705175 */   GIM_Try, /*On fail goto*//*Label 23314*/ GIMT_Encode4(1705261), // Rule ID 10204 //
     /* 1705180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1705191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1705194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1705200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705226 */     // MIs[0] policy
     /* 1705226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705236 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1705239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705260 */     // GIR_Coverage, 10204,
     /* 1705260 */     GIR_EraseRootFromParent_Done,
     /* 1705261 */   // Label 23314: @1705261
     /* 1705261 */   GIM_Try, /*On fail goto*//*Label 23315*/ GIMT_Encode4(1705347), // Rule ID 10205 //
     /* 1705266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1705277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1705280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1705283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1705286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705312 */     // MIs[0] policy
     /* 1705312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705322 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1705325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705346 */     // GIR_Coverage, 10205,
     /* 1705346 */     GIR_EraseRootFromParent_Done,
     /* 1705347 */   // Label 23315: @1705347
     /* 1705347 */   GIM_Try, /*On fail goto*//*Label 23316*/ GIMT_Encode4(1705433), // Rule ID 10208 //
     /* 1705352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1705363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1705366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1705372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705398 */     // MIs[0] policy
     /* 1705398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705408 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1705411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705432 */     // GIR_Coverage, 10208,
     /* 1705432 */     GIR_EraseRootFromParent_Done,
     /* 1705433 */   // Label 23316: @1705433
     /* 1705433 */   GIM_Try, /*On fail goto*//*Label 23317*/ GIMT_Encode4(1705519), // Rule ID 10209 //
     /* 1705438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1705449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1705452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1705455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1705458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1705461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705484 */     // MIs[0] policy
     /* 1705484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705494 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1705497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705518 */     // GIR_Coverage, 10209,
     /* 1705518 */     GIR_EraseRootFromParent_Done,
     /* 1705519 */   // Label 23317: @1705519
     /* 1705519 */   GIM_Try, /*On fail goto*//*Label 23318*/ GIMT_Encode4(1705605), // Rule ID 10212 //
     /* 1705524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1705527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1705535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1705538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1705544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705570 */     // MIs[0] policy
     /* 1705570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705580 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1705583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705604 */     // GIR_Coverage, 10212,
     /* 1705604 */     GIR_EraseRootFromParent_Done,
     /* 1705605 */   // Label 23318: @1705605
     /* 1705605 */   GIM_Try, /*On fail goto*//*Label 23319*/ GIMT_Encode4(1705691), // Rule ID 10213 //
     /* 1705610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1705613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1705621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1705624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1705627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1705630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1705633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1705640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1705652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705656 */     // MIs[0] policy
     /* 1705656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705666 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1705669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1705687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705690 */     // GIR_Coverage, 10213,
     /* 1705690 */     GIR_EraseRootFromParent_Done,
     /* 1705691 */   // Label 23319: @1705691
     /* 1705691 */   GIM_Try, /*On fail goto*//*Label 23320*/ GIMT_Encode4(1705777), // Rule ID 10216 //
     /* 1705696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1705699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1705707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1705710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1705713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1705716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705742 */     // MIs[0] policy
     /* 1705742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705752 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1705755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1705773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705776 */     // GIR_Coverage, 10216,
     /* 1705776 */     GIR_EraseRootFromParent_Done,
     /* 1705777 */   // Label 23320: @1705777
     /* 1705777 */   GIM_Try, /*On fail goto*//*Label 23321*/ GIMT_Encode4(1705863), // Rule ID 10217 //
     /* 1705782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1705785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1705793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1705796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1705799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1705802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1705805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1705812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1705824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705828 */     // MIs[0] policy
     /* 1705828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705838 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1705838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2_MASK),
     /* 1705841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1705859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705862 */     // GIR_Coverage, 10217,
     /* 1705862 */     GIR_EraseRootFromParent_Done,
     /* 1705863 */   // Label 23321: @1705863
     /* 1705863 */   GIM_Try, /*On fail goto*//*Label 23322*/ GIMT_Encode4(1705949), // Rule ID 10220 //
     /* 1705868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1705871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1705879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1705882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1705885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1705888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1705894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1705914 */     // MIs[0] policy
     /* 1705914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1705917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1705924 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1705924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1705927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1705929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1705931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1705933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1705935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1705937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1705942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1705945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1705947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1705948 */     // GIR_Coverage, 10220,
     /* 1705948 */     GIR_EraseRootFromParent_Done,
     /* 1705949 */   // Label 23322: @1705949
     /* 1705949 */   GIM_Try, /*On fail goto*//*Label 23323*/ GIMT_Encode4(1706035), // Rule ID 10221 //
     /* 1705954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1705957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1705962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1705965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1705968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1705971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1705974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1705977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1705980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1705984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1705996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706000 */     // MIs[0] policy
     /* 1706000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706010 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4_MASK),
     /* 1706013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1706031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706034 */     // GIR_Coverage, 10221,
     /* 1706034 */     GIR_EraseRootFromParent_Done,
     /* 1706035 */   // Label 23323: @1706035
     /* 1706035 */   GIM_Try, /*On fail goto*//*Label 23324*/ GIMT_Encode4(1706121), // Rule ID 10224 //
     /* 1706040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1706043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1706051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1706054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1706060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1706070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706086 */     // MIs[0] policy
     /* 1706086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706096 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1706099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1706117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706120 */     // GIR_Coverage, 10224,
     /* 1706120 */     GIR_EraseRootFromParent_Done,
     /* 1706121 */   // Label 23324: @1706121
     /* 1706121 */   GIM_Try, /*On fail goto*//*Label 23325*/ GIMT_Encode4(1706207), // Rule ID 10225 //
     /* 1706126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1706129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1706137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1706140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1706143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1706146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1706149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1706156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1706168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706172 */     // MIs[0] policy
     /* 1706172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706182 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8_MASK),
     /* 1706185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1706203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706206 */     // GIR_Coverage, 10225,
     /* 1706206 */     GIR_EraseRootFromParent_Done,
     /* 1706207 */   // Label 23325: @1706207
     /* 1706207 */   GIM_Try, /*On fail goto*//*Label 23326*/ GIMT_Encode4(1706293), // Rule ID 10228 //
     /* 1706212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1706229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706258 */     // MIs[0] policy
     /* 1706258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706268 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1706271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706292 */     // GIR_Coverage, 10228,
     /* 1706292 */     GIR_EraseRootFromParent_Done,
     /* 1706293 */   // Label 23326: @1706293
     /* 1706293 */   GIM_Try, /*On fail goto*//*Label 23327*/ GIMT_Encode4(1706379), // Rule ID 10229 //
     /* 1706298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1706309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1706312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1706315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706344 */     // MIs[0] policy
     /* 1706344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF8_MASK),
     /* 1706357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706378 */     // GIR_Coverage, 10229,
     /* 1706378 */     GIR_EraseRootFromParent_Done,
     /* 1706379 */   // Label 23327: @1706379
     /* 1706379 */   GIM_Try, /*On fail goto*//*Label 23328*/ GIMT_Encode4(1706465), // Rule ID 10232 //
     /* 1706384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1706401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706430 */     // MIs[0] policy
     /* 1706430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706440 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1706443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706464 */     // GIR_Coverage, 10232,
     /* 1706464 */     GIR_EraseRootFromParent_Done,
     /* 1706465 */   // Label 23328: @1706465
     /* 1706465 */   GIM_Try, /*On fail goto*//*Label 23329*/ GIMT_Encode4(1706551), // Rule ID 10233 //
     /* 1706470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1706481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1706484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1706487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706516 */     // MIs[0] policy
     /* 1706516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706526 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1706529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706550 */     // GIR_Coverage, 10233,
     /* 1706550 */     GIR_EraseRootFromParent_Done,
     /* 1706551 */   // Label 23329: @1706551
     /* 1706551 */   GIM_Try, /*On fail goto*//*Label 23330*/ GIMT_Encode4(1706637), // Rule ID 10236 //
     /* 1706556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1706573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706602 */     // MIs[0] policy
     /* 1706602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706612 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1706615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706636 */     // GIR_Coverage, 10236,
     /* 1706636 */     GIR_EraseRootFromParent_Done,
     /* 1706637 */   // Label 23330: @1706637
     /* 1706637 */   GIM_Try, /*On fail goto*//*Label 23331*/ GIMT_Encode4(1706723), // Rule ID 10237 //
     /* 1706642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1706653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1706656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1706659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1706665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706688 */     // MIs[0] policy
     /* 1706688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706698 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1706701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1706719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706722 */     // GIR_Coverage, 10237,
     /* 1706722 */     GIR_EraseRootFromParent_Done,
     /* 1706723 */   // Label 23331: @1706723
     /* 1706723 */   GIM_Try, /*On fail goto*//*Label 23332*/ GIMT_Encode4(1706809), // Rule ID 10240 //
     /* 1706728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1706739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1706742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706774 */     // MIs[0] policy
     /* 1706774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706784 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1706787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706808 */     // GIR_Coverage, 10240,
     /* 1706808 */     GIR_EraseRootFromParent_Done,
     /* 1706809 */   // Label 23332: @1706809
     /* 1706809 */   GIM_Try, /*On fail goto*//*Label 23333*/ GIMT_Encode4(1706895), // Rule ID 10241 //
     /* 1706814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1706825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1706828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1706831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1706834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1706837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1706840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706860 */     // MIs[0] policy
     /* 1706860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706870 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1706870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF4_MASK),
     /* 1706873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706894 */     // GIR_Coverage, 10241,
     /* 1706894 */     GIR_EraseRootFromParent_Done,
     /* 1706895 */   // Label 23333: @1706895
     /* 1706895 */   GIM_Try, /*On fail goto*//*Label 23334*/ GIMT_Encode4(1706981), // Rule ID 10244 //
     /* 1706900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1706903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1706911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1706914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1706917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1706920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1706923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1706926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1706930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1706938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1706942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1706946 */     // MIs[0] policy
     /* 1706946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1706949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1706956 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1706956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1706959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1706961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1706963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1706965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1706967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1706969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1706974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1706977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1706979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1706980 */     // GIR_Coverage, 10244,
     /* 1706980 */     GIR_EraseRootFromParent_Done,
     /* 1706981 */   // Label 23334: @1706981
     /* 1706981 */   GIM_Try, /*On fail goto*//*Label 23335*/ GIMT_Encode4(1707067), // Rule ID 10245 //
     /* 1706986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1706989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1706994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1706997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1707000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1707003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707032 */     // MIs[0] policy
     /* 1707032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707042 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1707045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707066 */     // GIR_Coverage, 10245,
     /* 1707066 */     GIR_EraseRootFromParent_Done,
     /* 1707067 */   // Label 23335: @1707067
     /* 1707067 */   GIM_Try, /*On fail goto*//*Label 23336*/ GIMT_Encode4(1707153), // Rule ID 10248 //
     /* 1707072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707118 */     // MIs[0] policy
     /* 1707118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707128 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1707131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707152 */     // GIR_Coverage, 10248,
     /* 1707152 */     GIR_EraseRootFromParent_Done,
     /* 1707153 */   // Label 23336: @1707153
     /* 1707153 */   GIM_Try, /*On fail goto*//*Label 23337*/ GIMT_Encode4(1707239), // Rule ID 10249 //
     /* 1707158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1707169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1707172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1707175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707204 */     // MIs[0] policy
     /* 1707204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707214 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_MF2_MASK),
     /* 1707217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707238 */     // GIR_Coverage, 10249,
     /* 1707238 */     GIR_EraseRootFromParent_Done,
     /* 1707239 */   // Label 23337: @1707239
     /* 1707239 */   GIM_Try, /*On fail goto*//*Label 23338*/ GIMT_Encode4(1707325), // Rule ID 10252 //
     /* 1707244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707290 */     // MIs[0] policy
     /* 1707290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707300 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707324 */     // GIR_Coverage, 10252,
     /* 1707324 */     GIR_EraseRootFromParent_Done,
     /* 1707325 */   // Label 23338: @1707325
     /* 1707325 */   GIM_Try, /*On fail goto*//*Label 23339*/ GIMT_Encode4(1707411), // Rule ID 10253 //
     /* 1707330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1707341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1707344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1707347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1707353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707376 */     // MIs[0] policy
     /* 1707376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707386 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11366:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1707407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707410 */     // GIR_Coverage, 10253,
     /* 1707410 */     GIR_EraseRootFromParent_Done,
     /* 1707411 */   // Label 23339: @1707411
     /* 1707411 */   GIM_Try, /*On fail goto*//*Label 23340*/ GIMT_Encode4(1707497), // Rule ID 10256 //
     /* 1707416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707462 */     // MIs[0] policy
     /* 1707462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707472 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707496 */     // GIR_Coverage, 10256,
     /* 1707496 */     GIR_EraseRootFromParent_Done,
     /* 1707497 */   // Label 23340: @1707497
     /* 1707497 */   GIM_Try, /*On fail goto*//*Label 23341*/ GIMT_Encode4(1707583), // Rule ID 10257 //
     /* 1707502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1707513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1707516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1707519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1707525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707548 */     // MIs[0] policy
     /* 1707548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707558 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11366:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1707579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707582 */     // GIR_Coverage, 10257,
     /* 1707582 */     GIR_EraseRootFromParent_Done,
     /* 1707583 */   // Label 23341: @1707583
     /* 1707583 */   GIM_Try, /*On fail goto*//*Label 23342*/ GIMT_Encode4(1707669), // Rule ID 10260 //
     /* 1707588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1707599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1707602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707634 */     // MIs[0] policy
     /* 1707634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707644 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707668 */     // GIR_Coverage, 10260,
     /* 1707668 */     GIR_EraseRootFromParent_Done,
     /* 1707669 */   // Label 23342: @1707669
     /* 1707669 */   GIM_Try, /*On fail goto*//*Label 23343*/ GIMT_Encode4(1707755), // Rule ID 10261 //
     /* 1707674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1707677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1707685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1707688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1707691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1707697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707720 */     // MIs[0] policy
     /* 1707720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707730 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11366:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1707751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707754 */     // GIR_Coverage, 10261,
     /* 1707754 */     GIR_EraseRootFromParent_Done,
     /* 1707755 */   // Label 23343: @1707755
     /* 1707755 */   GIM_Try, /*On fail goto*//*Label 23344*/ GIMT_Encode4(1707841), // Rule ID 10264 //
     /* 1707760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1707763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1707771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1707774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1707777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707806 */     // MIs[0] policy
     /* 1707806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707816 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1707837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707840 */     // GIR_Coverage, 10264,
     /* 1707840 */     GIR_EraseRootFromParent_Done,
     /* 1707841 */   // Label 23344: @1707841
     /* 1707841 */   GIM_Try, /*On fail goto*//*Label 23345*/ GIMT_Encode4(1707927), // Rule ID 10265 //
     /* 1707846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1707849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1707857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1707860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1707863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1707866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1707869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1707872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1707876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1707884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707892 */     // MIs[0] policy
     /* 1707892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707902 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11366:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1707902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M1_MASK),
     /* 1707905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1707915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1707920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1707923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1707925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1707926 */     // GIR_Coverage, 10265,
     /* 1707926 */     GIR_EraseRootFromParent_Done,
     /* 1707927 */   // Label 23345: @1707927
     /* 1707927 */   GIM_Try, /*On fail goto*//*Label 23346*/ GIMT_Encode4(1708013), // Rule ID 10268 //
     /* 1707932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1707935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1707940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1707943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1707946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1707949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1707952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1707955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1707958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1707962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1707970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1707974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1707978 */     // MIs[0] policy
     /* 1707978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1707981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1707988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1707988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1707991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1707993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1707995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1707997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1707999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708012 */     // GIR_Coverage, 10268,
     /* 1708012 */     GIR_EraseRootFromParent_Done,
     /* 1708013 */   // Label 23346: @1708013
     /* 1708013 */   GIM_Try, /*On fail goto*//*Label 23347*/ GIMT_Encode4(1708099), // Rule ID 10269 //
     /* 1708018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1708029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1708032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1708035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708064 */     // MIs[0] policy
     /* 1708064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708074 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1708077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708098 */     // GIR_Coverage, 10269,
     /* 1708098 */     GIR_EraseRootFromParent_Done,
     /* 1708099 */   // Label 23347: @1708099
     /* 1708099 */   GIM_Try, /*On fail goto*//*Label 23348*/ GIMT_Encode4(1708185), // Rule ID 10272 //
     /* 1708104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1708121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708150 */     // MIs[0] policy
     /* 1708150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708160 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1708163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708184 */     // GIR_Coverage, 10272,
     /* 1708184 */     GIR_EraseRootFromParent_Done,
     /* 1708185 */   // Label 23348: @1708185
     /* 1708185 */   GIM_Try, /*On fail goto*//*Label 23349*/ GIMT_Encode4(1708271), // Rule ID 10273 //
     /* 1708190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1708201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1708204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1708207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708236 */     // MIs[0] policy
     /* 1708236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708246 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1708249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708270 */     // GIR_Coverage, 10273,
     /* 1708270 */     GIR_EraseRootFromParent_Done,
     /* 1708271 */   // Label 23349: @1708271
     /* 1708271 */   GIM_Try, /*On fail goto*//*Label 23350*/ GIMT_Encode4(1708357), // Rule ID 10276 //
     /* 1708276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1708287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1708290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1708293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1708299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708322 */     // MIs[0] policy
     /* 1708322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1708335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708356 */     // GIR_Coverage, 10276,
     /* 1708356 */     GIR_EraseRootFromParent_Done,
     /* 1708357 */   // Label 23350: @1708357
     /* 1708357 */   GIM_Try, /*On fail goto*//*Label 23351*/ GIMT_Encode4(1708443), // Rule ID 10277 //
     /* 1708362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1708373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1708376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1708379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1708385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708408 */     // MIs[0] policy
     /* 1708408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708418 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1708421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1708439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708442 */     // GIR_Coverage, 10277,
     /* 1708442 */     GIR_EraseRootFromParent_Done,
     /* 1708443 */   // Label 23351: @1708443
     /* 1708443 */   GIM_Try, /*On fail goto*//*Label 23352*/ GIMT_Encode4(1708529), // Rule ID 10280 //
     /* 1708448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708494 */     // MIs[0] policy
     /* 1708494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708504 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1708507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708528 */     // GIR_Coverage, 10280,
     /* 1708528 */     GIR_EraseRootFromParent_Done,
     /* 1708529 */   // Label 23352: @1708529
     /* 1708529 */   GIM_Try, /*On fail goto*//*Label 23353*/ GIMT_Encode4(1708615), // Rule ID 10281 //
     /* 1708534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1708545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1708548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1708551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1708557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708580 */     // MIs[0] policy
     /* 1708580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1708593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708614 */     // GIR_Coverage, 10281,
     /* 1708614 */     GIR_EraseRootFromParent_Done,
     /* 1708615 */   // Label 23353: @1708615
     /* 1708615 */   GIM_Try, /*On fail goto*//*Label 23354*/ GIMT_Encode4(1708701), // Rule ID 10284 //
     /* 1708620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708666 */     // MIs[0] policy
     /* 1708666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1708679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708700 */     // GIR_Coverage, 10284,
     /* 1708700 */     GIR_EraseRootFromParent_Done,
     /* 1708701 */   // Label 23354: @1708701
     /* 1708701 */   GIM_Try, /*On fail goto*//*Label 23355*/ GIMT_Encode4(1708787), // Rule ID 10285 //
     /* 1708706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1708717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1708720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1708723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1708729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1708736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1708744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708752 */     // MIs[0] policy
     /* 1708752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708762 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1708765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708786 */     // GIR_Coverage, 10285,
     /* 1708786 */     GIR_EraseRootFromParent_Done,
     /* 1708787 */   // Label 23355: @1708787
     /* 1708787 */   GIM_Try, /*On fail goto*//*Label 23356*/ GIMT_Encode4(1708873), // Rule ID 10288 //
     /* 1708792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1708803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1708806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1708809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708838 */     // MIs[0] policy
     /* 1708838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708848 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1708848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1708851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708872 */     // GIR_Coverage, 10288,
     /* 1708872 */     GIR_EraseRootFromParent_Done,
     /* 1708873 */   // Label 23356: @1708873
     /* 1708873 */   GIM_Try, /*On fail goto*//*Label 23357*/ GIMT_Encode4(1708959), // Rule ID 10289 //
     /* 1708878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1708881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1708889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1708892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1708895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1708898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1708901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1708904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1708908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1708916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1708920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1708924 */     // MIs[0] policy
     /* 1708924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1708927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1708934 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1708934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1708937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1708939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1708941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1708943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1708945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1708947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1708952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1708955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1708957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1708958 */     // GIR_Coverage, 10289,
     /* 1708958 */     GIR_EraseRootFromParent_Done,
     /* 1708959 */   // Label 23357: @1708959
     /* 1708959 */   GIM_Try, /*On fail goto*//*Label 23358*/ GIMT_Encode4(1709045), // Rule ID 10292 //
     /* 1708964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1708967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1708972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1708975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1708978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1708981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1708984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1708987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1708990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1708994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1708998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709010 */     // MIs[0] policy
     /* 1709010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1709023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709044 */     // GIR_Coverage, 10292,
     /* 1709044 */     GIR_EraseRootFromParent_Done,
     /* 1709045 */   // Label 23358: @1709045
     /* 1709045 */   GIM_Try, /*On fail goto*//*Label 23359*/ GIMT_Encode4(1709131), // Rule ID 10293 //
     /* 1709050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1709061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1709064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1709067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709096 */     // MIs[0] policy
     /* 1709096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709106 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1709109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709130 */     // GIR_Coverage, 10293,
     /* 1709130 */     GIR_EraseRootFromParent_Done,
     /* 1709131 */   // Label 23359: @1709131
     /* 1709131 */   GIM_Try, /*On fail goto*//*Label 23360*/ GIMT_Encode4(1709217), // Rule ID 10296 //
     /* 1709136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709182 */     // MIs[0] policy
     /* 1709182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709192 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1709195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709216 */     // GIR_Coverage, 10296,
     /* 1709216 */     GIR_EraseRootFromParent_Done,
     /* 1709217 */   // Label 23360: @1709217
     /* 1709217 */   GIM_Try, /*On fail goto*//*Label 23361*/ GIMT_Encode4(1709303), // Rule ID 10297 //
     /* 1709222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1709233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1709236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1709239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709268 */     // MIs[0] policy
     /* 1709268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709278 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1709281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709302 */     // GIR_Coverage, 10297,
     /* 1709302 */     GIR_EraseRootFromParent_Done,
     /* 1709303 */   // Label 23361: @1709303
     /* 1709303 */   GIM_Try, /*On fail goto*//*Label 23362*/ GIMT_Encode4(1709389), // Rule ID 10300 //
     /* 1709308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1709319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1709322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709354 */     // MIs[0] policy
     /* 1709354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709364 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1709367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709388 */     // GIR_Coverage, 10300,
     /* 1709388 */     GIR_EraseRootFromParent_Done,
     /* 1709389 */   // Label 23362: @1709389
     /* 1709389 */   GIM_Try, /*On fail goto*//*Label 23363*/ GIMT_Encode4(1709475), // Rule ID 10301 //
     /* 1709394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1709397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1709405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1709408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1709411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1709417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709440 */     // MIs[0] policy
     /* 1709440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709450 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1709453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1709471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709474 */     // GIR_Coverage, 10301,
     /* 1709474 */     GIR_EraseRootFromParent_Done,
     /* 1709475 */   // Label 23363: @1709475
     /* 1709475 */   GIM_Try, /*On fail goto*//*Label 23364*/ GIMT_Encode4(1709561), // Rule ID 10304 //
     /* 1709480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1709483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1709491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1709494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709526 */     // MIs[0] policy
     /* 1709526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709536 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1709539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709560 */     // GIR_Coverage, 10304,
     /* 1709560 */     GIR_EraseRootFromParent_Done,
     /* 1709561 */   // Label 23364: @1709561
     /* 1709561 */   GIM_Try, /*On fail goto*//*Label 23365*/ GIMT_Encode4(1709647), // Rule ID 10305 //
     /* 1709566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1709569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1709577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1709580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1709583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1709589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1709596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1709604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709612 */     // MIs[0] policy
     /* 1709612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709622 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11366:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M2_MASK),
     /* 1709625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709646 */     // GIR_Coverage, 10305,
     /* 1709646 */     GIR_EraseRootFromParent_Done,
     /* 1709647 */   // Label 23365: @1709647
     /* 1709647 */   GIM_Try, /*On fail goto*//*Label 23366*/ GIMT_Encode4(1709733), // Rule ID 10308 //
     /* 1709652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1709655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1709663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1709666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709698 */     // MIs[0] policy
     /* 1709698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709708 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1709711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709732 */     // GIR_Coverage, 10308,
     /* 1709732 */     GIR_EraseRootFromParent_Done,
     /* 1709733 */   // Label 23366: @1709733
     /* 1709733 */   GIM_Try, /*On fail goto*//*Label 23367*/ GIMT_Encode4(1709819), // Rule ID 10309 //
     /* 1709738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1709741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1709749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1709752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1709755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1709761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1709768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1709776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709784 */     // MIs[0] policy
     /* 1709784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709794 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11366:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M4_MASK),
     /* 1709797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709818 */     // GIR_Coverage, 10309,
     /* 1709818 */     GIR_EraseRootFromParent_Done,
     /* 1709819 */   // Label 23367: @1709819
     /* 1709819 */   GIM_Try, /*On fail goto*//*Label 23368*/ GIMT_Encode4(1709905), // Rule ID 10312 //
     /* 1709824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1709827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1709835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1709838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1709844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1709850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709870 */     // MIs[0] policy
     /* 1709870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709880 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1709880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1709883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709904 */     // GIR_Coverage, 10312,
     /* 1709904 */     GIR_EraseRootFromParent_Done,
     /* 1709905 */   // Label 23368: @1709905
     /* 1709905 */   GIM_Try, /*On fail goto*//*Label 23369*/ GIMT_Encode4(1709991), // Rule ID 10313 //
     /* 1709910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1709913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vminu_mask),
     /* 1709918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1709921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1709924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1709927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1709930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1709933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1709936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1709940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1709948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1709952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1709956 */     // MIs[0] policy
     /* 1709956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1709959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1709966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11366:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMINU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1709966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VX_M8_MASK),
     /* 1709969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1709971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1709973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1709975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1709977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1709979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1709984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1709987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1709989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1709990 */     // GIR_Coverage, 10313,
     /* 1709990 */     GIR_EraseRootFromParent_Done,
     /* 1709991 */   // Label 23369: @1709991
     /* 1709991 */   GIM_Try, /*On fail goto*//*Label 23370*/ GIMT_Encode4(1710077), // Rule ID 10316 //
     /* 1709996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1709999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1710013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1710016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710042 */     // MIs[0] policy
     /* 1710042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710052 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1710055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710076 */     // GIR_Coverage, 10316,
     /* 1710076 */     GIR_EraseRootFromParent_Done,
     /* 1710077 */   // Label 23370: @1710077
     /* 1710077 */   GIM_Try, /*On fail goto*//*Label 23371*/ GIMT_Encode4(1710163), // Rule ID 10317 //
     /* 1710082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1710093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1710096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1710099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1710102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710128 */     // MIs[0] policy
     /* 1710128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710138 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8_MASK),
     /* 1710141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710162 */     // GIR_Coverage, 10317,
     /* 1710162 */     GIR_EraseRootFromParent_Done,
     /* 1710163 */   // Label 23371: @1710163
     /* 1710163 */   GIM_Try, /*On fail goto*//*Label 23372*/ GIMT_Encode4(1710249), // Rule ID 10320 //
     /* 1710168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1710185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1710188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710214 */     // MIs[0] policy
     /* 1710214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710224 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1710227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710248 */     // GIR_Coverage, 10320,
     /* 1710248 */     GIR_EraseRootFromParent_Done,
     /* 1710249 */   // Label 23372: @1710249
     /* 1710249 */   GIM_Try, /*On fail goto*//*Label 23373*/ GIMT_Encode4(1710335), // Rule ID 10321 //
     /* 1710254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1710265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1710268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1710271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1710274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710300 */     // MIs[0] policy
     /* 1710300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1710313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710334 */     // GIR_Coverage, 10321,
     /* 1710334 */     GIR_EraseRootFromParent_Done,
     /* 1710335 */   // Label 23373: @1710335
     /* 1710335 */   GIM_Try, /*On fail goto*//*Label 23374*/ GIMT_Encode4(1710421), // Rule ID 10324 //
     /* 1710340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1710351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1710354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1710357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1710360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710386 */     // MIs[0] policy
     /* 1710386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710396 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1710399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710420 */     // GIR_Coverage, 10324,
     /* 1710420 */     GIR_EraseRootFromParent_Done,
     /* 1710421 */   // Label 23374: @1710421
     /* 1710421 */   GIM_Try, /*On fail goto*//*Label 23375*/ GIMT_Encode4(1710507), // Rule ID 10325 //
     /* 1710426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1710437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1710440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1710443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1710446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1710449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710472 */     // MIs[0] policy
     /* 1710472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710482 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1710485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1710503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710506 */     // GIR_Coverage, 10325,
     /* 1710506 */     GIR_EraseRootFromParent_Done,
     /* 1710507 */   // Label 23375: @1710507
     /* 1710507 */   GIM_Try, /*On fail goto*//*Label 23376*/ GIMT_Encode4(1710593), // Rule ID 10328 //
     /* 1710512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710558 */     // MIs[0] policy
     /* 1710558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1710571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710592 */     // GIR_Coverage, 10328,
     /* 1710592 */     GIR_EraseRootFromParent_Done,
     /* 1710593 */   // Label 23376: @1710593
     /* 1710593 */   GIM_Try, /*On fail goto*//*Label 23377*/ GIMT_Encode4(1710679), // Rule ID 10329 //
     /* 1710598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1710609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1710612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1710615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1710618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710644 */     // MIs[0] policy
     /* 1710644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710654 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4_MASK),
     /* 1710657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710678 */     // GIR_Coverage, 10329,
     /* 1710678 */     GIR_EraseRootFromParent_Done,
     /* 1710679 */   // Label 23377: @1710679
     /* 1710679 */   GIM_Try, /*On fail goto*//*Label 23378*/ GIMT_Encode4(1710765), // Rule ID 10332 //
     /* 1710684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710730 */     // MIs[0] policy
     /* 1710730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710740 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1710743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710764 */     // GIR_Coverage, 10332,
     /* 1710764 */     GIR_EraseRootFromParent_Done,
     /* 1710765 */   // Label 23378: @1710765
     /* 1710765 */   GIM_Try, /*On fail goto*//*Label 23379*/ GIMT_Encode4(1710851), // Rule ID 10333 //
     /* 1710770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1710781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1710784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1710787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1710790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1710793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710816 */     // MIs[0] policy
     /* 1710816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710826 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1710829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1710847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710850 */     // GIR_Coverage, 10333,
     /* 1710850 */     GIR_EraseRootFromParent_Done,
     /* 1710851 */   // Label 23379: @1710851
     /* 1710851 */   GIM_Try, /*On fail goto*//*Label 23380*/ GIMT_Encode4(1710937), // Rule ID 10336 //
     /* 1710856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1710859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1710882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710902 */     // MIs[0] policy
     /* 1710902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1710912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1710915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1710917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1710919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1710921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1710923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1710925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1710930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1710933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1710935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1710936 */     // GIR_Coverage, 10336,
     /* 1710936 */     GIR_EraseRootFromParent_Done,
     /* 1710937 */   // Label 23380: @1710937
     /* 1710937 */   GIM_Try, /*On fail goto*//*Label 23381*/ GIMT_Encode4(1711023), // Rule ID 10337 //
     /* 1710942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1710945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1710950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1710953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1710956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1710959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1710962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1710965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1710968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1710972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1710984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1710988 */     // MIs[0] policy
     /* 1710988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1710991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1710998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1710998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2_MASK),
     /* 1711001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711022 */     // GIR_Coverage, 10337,
     /* 1711022 */     GIR_EraseRootFromParent_Done,
     /* 1711023 */   // Label 23381: @1711023
     /* 1711023 */   GIM_Try, /*On fail goto*//*Label 23382*/ GIMT_Encode4(1711109), // Rule ID 10340 //
     /* 1711028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1711039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1711042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1711045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1711048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711074 */     // MIs[0] policy
     /* 1711074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711084 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711108 */     // GIR_Coverage, 10340,
     /* 1711108 */     GIR_EraseRootFromParent_Done,
     /* 1711109 */   // Label 23382: @1711109
     /* 1711109 */   GIM_Try, /*On fail goto*//*Label 23383*/ GIMT_Encode4(1711195), // Rule ID 10341 //
     /* 1711114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1711125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1711128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1711131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1711134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1711137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711160 */     // MIs[0] policy
     /* 1711160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711170 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711194 */     // GIR_Coverage, 10341,
     /* 1711194 */     GIR_EraseRootFromParent_Done,
     /* 1711195 */   // Label 23383: @1711195
     /* 1711195 */   GIM_Try, /*On fail goto*//*Label 23384*/ GIMT_Encode4(1711281), // Rule ID 10344 //
     /* 1711200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1711220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711246 */     // MIs[0] policy
     /* 1711246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711256 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711280 */     // GIR_Coverage, 10344,
     /* 1711280 */     GIR_EraseRootFromParent_Done,
     /* 1711281 */   // Label 23384: @1711281
     /* 1711281 */   GIM_Try, /*On fail goto*//*Label 23385*/ GIMT_Encode4(1711367), // Rule ID 10345 //
     /* 1711286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1711297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1711300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1711303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1711306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1711309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711332 */     // MIs[0] policy
     /* 1711332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711342 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1711363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711366 */     // GIR_Coverage, 10345,
     /* 1711366 */     GIR_EraseRootFromParent_Done,
     /* 1711367 */   // Label 23385: @1711367
     /* 1711367 */   GIM_Try, /*On fail goto*//*Label 23386*/ GIMT_Encode4(1711453), // Rule ID 10348 //
     /* 1711372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1711383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1711386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1711392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711418 */     // MIs[0] policy
     /* 1711418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711428 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711452 */     // GIR_Coverage, 10348,
     /* 1711452 */     GIR_EraseRootFromParent_Done,
     /* 1711453 */   // Label 23386: @1711453
     /* 1711453 */   GIM_Try, /*On fail goto*//*Label 23387*/ GIMT_Encode4(1711539), // Rule ID 10349 //
     /* 1711458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1711469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1711472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1711475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1711478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1711481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711504 */     // MIs[0] policy
     /* 1711504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711514 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1711535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711538 */     // GIR_Coverage, 10349,
     /* 1711538 */     GIR_EraseRootFromParent_Done,
     /* 1711539 */   // Label 23387: @1711539
     /* 1711539 */   GIM_Try, /*On fail goto*//*Label 23388*/ GIMT_Encode4(1711625), // Rule ID 10352 //
     /* 1711544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1711547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711590 */     // MIs[0] policy
     /* 1711590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711600 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711624 */     // GIR_Coverage, 10352,
     /* 1711624 */     GIR_EraseRootFromParent_Done,
     /* 1711625 */   // Label 23388: @1711625
     /* 1711625 */   GIM_Try, /*On fail goto*//*Label 23389*/ GIMT_Encode4(1711711), // Rule ID 10353 //
     /* 1711630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1711633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1711641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1711644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1711647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1711650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1711653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1711660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1711672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711676 */     // MIs[0] policy
     /* 1711676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711686 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1_MASK),
     /* 1711689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1711707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711710 */     // GIR_Coverage, 10353,
     /* 1711710 */     GIR_EraseRootFromParent_Done,
     /* 1711711 */   // Label 23389: @1711711
     /* 1711711 */   GIM_Try, /*On fail goto*//*Label 23390*/ GIMT_Encode4(1711797), // Rule ID 10356 //
     /* 1711716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711762 */     // MIs[0] policy
     /* 1711762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711772 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1711775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711796 */     // GIR_Coverage, 10356,
     /* 1711796 */     GIR_EraseRootFromParent_Done,
     /* 1711797 */   // Label 23390: @1711797
     /* 1711797 */   GIM_Try, /*On fail goto*//*Label 23391*/ GIMT_Encode4(1711883), // Rule ID 10357 //
     /* 1711802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1711813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1711816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1711819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1711822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1711825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1711828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1711832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1711844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711848 */     // MIs[0] policy
     /* 1711848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1711858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1711861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711882 */     // GIR_Coverage, 10357,
     /* 1711882 */     GIR_EraseRootFromParent_Done,
     /* 1711883 */   // Label 23391: @1711883
     /* 1711883 */   GIM_Try, /*On fail goto*//*Label 23392*/ GIMT_Encode4(1711969), // Rule ID 10360 //
     /* 1711888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1711891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1711914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1711918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1711930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1711934 */     // MIs[0] policy
     /* 1711934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1711937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1711944 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1711944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1711947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1711949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1711951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1711953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1711955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1711957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1711962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1711965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1711967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1711968 */     // GIR_Coverage, 10360,
     /* 1711968 */     GIR_EraseRootFromParent_Done,
     /* 1711969 */   // Label 23392: @1711969
     /* 1711969 */   GIM_Try, /*On fail goto*//*Label 23393*/ GIMT_Encode4(1712055), // Rule ID 10361 //
     /* 1711974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1711977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1711982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1711985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1711988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1711991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1711994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1711997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712020 */     // MIs[0] policy
     /* 1712020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712030 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1712033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712054 */     // GIR_Coverage, 10361,
     /* 1712054 */     GIR_EraseRootFromParent_Done,
     /* 1712055 */   // Label 23393: @1712055
     /* 1712055 */   GIM_Try, /*On fail goto*//*Label 23394*/ GIMT_Encode4(1712141), // Rule ID 10364 //
     /* 1712060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1712071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1712074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1712077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1712080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1712083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712106 */     // MIs[0] policy
     /* 1712106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712116 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1712119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712140 */     // GIR_Coverage, 10364,
     /* 1712140 */     GIR_EraseRootFromParent_Done,
     /* 1712141 */   // Label 23394: @1712141
     /* 1712141 */   GIM_Try, /*On fail goto*//*Label 23395*/ GIMT_Encode4(1712227), // Rule ID 10365 //
     /* 1712146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1712157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1712160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1712163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1712166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1712169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712192 */     // MIs[0] policy
     /* 1712192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712202 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1712205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1712223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712226 */     // GIR_Coverage, 10365,
     /* 1712226 */     GIR_EraseRootFromParent_Done,
     /* 1712227 */   // Label 23395: @1712227
     /* 1712227 */   GIM_Try, /*On fail goto*//*Label 23396*/ GIMT_Encode4(1712313), // Rule ID 10368 //
     /* 1712232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1712249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1712252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712278 */     // MIs[0] policy
     /* 1712278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712288 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1712291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712312 */     // GIR_Coverage, 10368,
     /* 1712312 */     GIR_EraseRootFromParent_Done,
     /* 1712313 */   // Label 23396: @1712313
     /* 1712313 */   GIM_Try, /*On fail goto*//*Label 23397*/ GIMT_Encode4(1712399), // Rule ID 10369 //
     /* 1712318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1712329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1712332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1712335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1712338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712364 */     // MIs[0] policy
     /* 1712364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1712377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712398 */     // GIR_Coverage, 10369,
     /* 1712398 */     GIR_EraseRootFromParent_Done,
     /* 1712399 */   // Label 23397: @1712399
     /* 1712399 */   GIM_Try, /*On fail goto*//*Label 23398*/ GIMT_Encode4(1712485), // Rule ID 10372 //
     /* 1712404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1712421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1712424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712450 */     // MIs[0] policy
     /* 1712450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712460 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1712463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712484 */     // GIR_Coverage, 10372,
     /* 1712484 */     GIR_EraseRootFromParent_Done,
     /* 1712485 */   // Label 23398: @1712485
     /* 1712485 */   GIM_Try, /*On fail goto*//*Label 23399*/ GIMT_Encode4(1712571), // Rule ID 10373 //
     /* 1712490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1712501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1712504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1712507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1712510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1712513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712536 */     // MIs[0] policy
     /* 1712536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712546 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1712549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712570 */     // GIR_Coverage, 10373,
     /* 1712570 */     GIR_EraseRootFromParent_Done,
     /* 1712571 */   // Label 23399: @1712571
     /* 1712571 */   GIM_Try, /*On fail goto*//*Label 23400*/ GIMT_Encode4(1712657), // Rule ID 10376 //
     /* 1712576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712622 */     // MIs[0] policy
     /* 1712622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712632 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1712635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712656 */     // GIR_Coverage, 10376,
     /* 1712656 */     GIR_EraseRootFromParent_Done,
     /* 1712657 */   // Label 23400: @1712657
     /* 1712657 */   GIM_Try, /*On fail goto*//*Label 23401*/ GIMT_Encode4(1712743), // Rule ID 10377 //
     /* 1712662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1712673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1712676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1712679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1712682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1712685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1712692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1712704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712708 */     // MIs[0] policy
     /* 1712708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712718 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1712721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1712739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712742 */     // GIR_Coverage, 10377,
     /* 1712742 */     GIR_EraseRootFromParent_Done,
     /* 1712743 */   // Label 23401: @1712743
     /* 1712743 */   GIM_Try, /*On fail goto*//*Label 23402*/ GIMT_Encode4(1712829), // Rule ID 10380 //
     /* 1712748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712794 */     // MIs[0] policy
     /* 1712794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712804 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1712807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712828 */     // GIR_Coverage, 10380,
     /* 1712828 */     GIR_EraseRootFromParent_Done,
     /* 1712829 */   // Label 23402: @1712829
     /* 1712829 */   GIM_Try, /*On fail goto*//*Label 23403*/ GIMT_Encode4(1712915), // Rule ID 10381 //
     /* 1712834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1712837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1712845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1712848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1712851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1712854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1712857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1712860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1712864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1712876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712880 */     // MIs[0] policy
     /* 1712880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1712890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1712893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1712914 */     // GIR_Coverage, 10381,
     /* 1712914 */     GIR_EraseRootFromParent_Done,
     /* 1712915 */   // Label 23403: @1712915
     /* 1712915 */   GIM_Try, /*On fail goto*//*Label 23404*/ GIMT_Encode4(1713001), // Rule ID 10384 //
     /* 1712920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1712923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1712928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1712931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1712934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1712937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1712940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1712943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1712946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1712950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1712962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1712966 */     // MIs[0] policy
     /* 1712966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1712969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1712976 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1712976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1712979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1712981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1712983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1712985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1712987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1712989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1712994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1712997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1712999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713000 */     // GIR_Coverage, 10384,
     /* 1713000 */     GIR_EraseRootFromParent_Done,
     /* 1713001 */   // Label 23404: @1713001
     /* 1713001 */   GIM_Try, /*On fail goto*//*Label 23405*/ GIMT_Encode4(1713087), // Rule ID 10385 //
     /* 1713006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1713017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1713020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1713023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1713026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713052 */     // MIs[0] policy
     /* 1713052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713062 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1713065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713086 */     // GIR_Coverage, 10385,
     /* 1713086 */     GIR_EraseRootFromParent_Done,
     /* 1713087 */   // Label 23405: @1713087
     /* 1713087 */   GIM_Try, /*On fail goto*//*Label 23406*/ GIMT_Encode4(1713173), // Rule ID 10388 //
     /* 1713092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1713103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1713106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1713109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1713112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713138 */     // MIs[0] policy
     /* 1713138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713148 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1713151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713172 */     // GIR_Coverage, 10388,
     /* 1713172 */     GIR_EraseRootFromParent_Done,
     /* 1713173 */   // Label 23406: @1713173
     /* 1713173 */   GIM_Try, /*On fail goto*//*Label 23407*/ GIMT_Encode4(1713259), // Rule ID 10389 //
     /* 1713178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1713189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1713192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1713195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1713198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1713201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713224 */     // MIs[0] policy
     /* 1713224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713234 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1713237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1713255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713258 */     // GIR_Coverage, 10389,
     /* 1713258 */     GIR_EraseRootFromParent_Done,
     /* 1713259 */   // Label 23407: @1713259
     /* 1713259 */   GIM_Try, /*On fail goto*//*Label 23408*/ GIMT_Encode4(1713345), // Rule ID 10392 //
     /* 1713264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1713275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1713278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1713281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1713284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713310 */     // MIs[0] policy
     /* 1713310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1713323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713344 */     // GIR_Coverage, 10392,
     /* 1713344 */     GIR_EraseRootFromParent_Done,
     /* 1713345 */   // Label 23408: @1713345
     /* 1713345 */   GIM_Try, /*On fail goto*//*Label 23409*/ GIMT_Encode4(1713431), // Rule ID 10393 //
     /* 1713350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1713361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1713364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1713367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1713370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1713380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1713392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713396 */     // MIs[0] policy
     /* 1713396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713406 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2_MASK),
     /* 1713409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713430 */     // GIR_Coverage, 10393,
     /* 1713430 */     GIR_EraseRootFromParent_Done,
     /* 1713431 */   // Label 23409: @1713431
     /* 1713431 */   GIM_Try, /*On fail goto*//*Label 23410*/ GIMT_Encode4(1713517), // Rule ID 10396 //
     /* 1713436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1713447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1713450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1713453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1713456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713482 */     // MIs[0] policy
     /* 1713482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713492 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1713495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713516 */     // GIR_Coverage, 10396,
     /* 1713516 */     GIR_EraseRootFromParent_Done,
     /* 1713517 */   // Label 23410: @1713517
     /* 1713517 */   GIM_Try, /*On fail goto*//*Label 23411*/ GIMT_Encode4(1713603), // Rule ID 10397 //
     /* 1713522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1713533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1713536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1713539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1713542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1713545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1713552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1713564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713568 */     // MIs[0] policy
     /* 1713568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713578 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4_MASK),
     /* 1713581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713602 */     // GIR_Coverage, 10397,
     /* 1713602 */     GIR_EraseRootFromParent_Done,
     /* 1713603 */   // Label 23411: @1713603
     /* 1713603 */   GIM_Try, /*On fail goto*//*Label 23412*/ GIMT_Encode4(1713689), // Rule ID 10400 //
     /* 1713608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1713611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713654 */     // MIs[0] policy
     /* 1713654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713664 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1713667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713688 */     // GIR_Coverage, 10400,
     /* 1713688 */     GIR_EraseRootFromParent_Done,
     /* 1713689 */   // Label 23412: @1713689
     /* 1713689 */   GIM_Try, /*On fail goto*//*Label 23413*/ GIMT_Encode4(1713775), // Rule ID 10401 //
     /* 1713694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1713697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1713705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1713708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1713711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1713714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1713717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1713724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1713736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713740 */     // MIs[0] policy
     /* 1713740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713750 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8_MASK),
     /* 1713753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1713771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713774 */     // GIR_Coverage, 10401,
     /* 1713774 */     GIR_EraseRootFromParent_Done,
     /* 1713775 */   // Label 23413: @1713775
     /* 1713775 */   GIM_Try, /*On fail goto*//*Label 23414*/ GIMT_Encode4(1713861), // Rule ID 10404 //
     /* 1713780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713826 */     // MIs[0] policy
     /* 1713826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713836 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1713836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1713839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713860 */     // GIR_Coverage, 10404,
     /* 1713860 */     GIR_EraseRootFromParent_Done,
     /* 1713861 */   // Label 23414: @1713861
     /* 1713861 */   GIM_Try, /*On fail goto*//*Label 23415*/ GIMT_Encode4(1713947), // Rule ID 10405 //
     /* 1713866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1713869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1713877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1713880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1713883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1713886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1713889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1713892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713912 */     // MIs[0] policy
     /* 1713912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1713915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1713922 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1713922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF8_MASK),
     /* 1713925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1713927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1713929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1713931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1713933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1713935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1713940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1713943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1713945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1713946 */     // GIR_Coverage, 10405,
     /* 1713946 */     GIR_EraseRootFromParent_Done,
     /* 1713947 */   // Label 23415: @1713947
     /* 1713947 */   GIM_Try, /*On fail goto*//*Label 23416*/ GIMT_Encode4(1714033), // Rule ID 10408 //
     /* 1713952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1713955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1713960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1713963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1713966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1713969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1713972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1713975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1713978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1713982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1713990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1713994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1713998 */     // MIs[0] policy
     /* 1713998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714008 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1714011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714032 */     // GIR_Coverage, 10408,
     /* 1714032 */     GIR_EraseRootFromParent_Done,
     /* 1714033 */   // Label 23416: @1714033
     /* 1714033 */   GIM_Try, /*On fail goto*//*Label 23417*/ GIMT_Encode4(1714119), // Rule ID 10409 //
     /* 1714038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1714049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1714052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1714055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714084 */     // MIs[0] policy
     /* 1714084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714094 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1714097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714118 */     // GIR_Coverage, 10409,
     /* 1714118 */     GIR_EraseRootFromParent_Done,
     /* 1714119 */   // Label 23417: @1714119
     /* 1714119 */   GIM_Try, /*On fail goto*//*Label 23418*/ GIMT_Encode4(1714205), // Rule ID 10412 //
     /* 1714124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1714135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1714138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1714141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714170 */     // MIs[0] policy
     /* 1714170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714180 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714204 */     // GIR_Coverage, 10412,
     /* 1714204 */     GIR_EraseRootFromParent_Done,
     /* 1714205 */   // Label 23418: @1714205
     /* 1714205 */   GIM_Try, /*On fail goto*//*Label 23419*/ GIMT_Encode4(1714291), // Rule ID 10413 //
     /* 1714210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1714221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1714224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1714227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1714233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714256 */     // MIs[0] policy
     /* 1714256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714266 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714290 */     // GIR_Coverage, 10413,
     /* 1714290 */     GIR_EraseRootFromParent_Done,
     /* 1714291 */   // Label 23419: @1714291
     /* 1714291 */   GIM_Try, /*On fail goto*//*Label 23420*/ GIMT_Encode4(1714377), // Rule ID 10416 //
     /* 1714296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1714307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1714310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1714313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714342 */     // MIs[0] policy
     /* 1714342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714352 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1714355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714376 */     // GIR_Coverage, 10416,
     /* 1714376 */     GIR_EraseRootFromParent_Done,
     /* 1714377 */   // Label 23420: @1714377
     /* 1714377 */   GIM_Try, /*On fail goto*//*Label 23421*/ GIMT_Encode4(1714463), // Rule ID 10417 //
     /* 1714382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1714393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1714396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1714399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714428 */     // MIs[0] policy
     /* 1714428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714438 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF4_MASK),
     /* 1714441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714462 */     // GIR_Coverage, 10417,
     /* 1714462 */     GIR_EraseRootFromParent_Done,
     /* 1714463 */   // Label 23421: @1714463
     /* 1714463 */   GIM_Try, /*On fail goto*//*Label 23422*/ GIMT_Encode4(1714549), // Rule ID 10420 //
     /* 1714468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1714479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1714482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1714485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714514 */     // MIs[0] policy
     /* 1714514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714524 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714548 */     // GIR_Coverage, 10420,
     /* 1714548 */     GIR_EraseRootFromParent_Done,
     /* 1714549 */   // Label 23422: @1714549
     /* 1714549 */   GIM_Try, /*On fail goto*//*Label 23423*/ GIMT_Encode4(1714635), // Rule ID 10421 //
     /* 1714554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1714565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1714568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1714571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1714577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714600 */     // MIs[0] policy
     /* 1714600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714610 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1714631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714634 */     // GIR_Coverage, 10421,
     /* 1714634 */     GIR_EraseRootFromParent_Done,
     /* 1714635 */   // Label 23423: @1714635
     /* 1714635 */   GIM_Try, /*On fail goto*//*Label 23424*/ GIMT_Encode4(1714721), // Rule ID 10424 //
     /* 1714640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714686 */     // MIs[0] policy
     /* 1714686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714696 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714720 */     // GIR_Coverage, 10424,
     /* 1714720 */     GIR_EraseRootFromParent_Done,
     /* 1714721 */   // Label 23424: @1714721
     /* 1714721 */   GIM_Try, /*On fail goto*//*Label 23425*/ GIMT_Encode4(1714807), // Rule ID 10425 //
     /* 1714726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1714737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1714740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1714743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1714749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714772 */     // MIs[0] policy
     /* 1714772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714782 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_MF2_MASK),
     /* 1714785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1714803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714806 */     // GIR_Coverage, 10425,
     /* 1714806 */     GIR_EraseRootFromParent_Done,
     /* 1714807 */   // Label 23425: @1714807
     /* 1714807 */   GIM_Try, /*On fail goto*//*Label 23426*/ GIMT_Encode4(1714893), // Rule ID 10428 //
     /* 1714812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1714832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1714838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714858 */     // MIs[0] policy
     /* 1714858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714868 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1714868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1714871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714892 */     // GIR_Coverage, 10428,
     /* 1714892 */     GIR_EraseRootFromParent_Done,
     /* 1714893 */   // Label 23426: @1714893
     /* 1714893 */   GIM_Try, /*On fail goto*//*Label 23427*/ GIMT_Encode4(1714979), // Rule ID 10429 //
     /* 1714898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1714901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1714909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1714912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1714915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1714918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1714921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1714924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1714928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1714936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1714940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1714944 */     // MIs[0] policy
     /* 1714944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1714947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1714954 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11364:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1714954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1714957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1714959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1714961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1714963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1714965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1714967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1714972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1714975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1714977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1714978 */     // GIR_Coverage, 10429,
     /* 1714978 */     GIR_EraseRootFromParent_Done,
     /* 1714979 */   // Label 23427: @1714979
     /* 1714979 */   GIM_Try, /*On fail goto*//*Label 23428*/ GIMT_Encode4(1715065), // Rule ID 10432 //
     /* 1714984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1714987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1714992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1714995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1714998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715030 */     // MIs[0] policy
     /* 1715030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715040 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715064 */     // GIR_Coverage, 10432,
     /* 1715064 */     GIR_EraseRootFromParent_Done,
     /* 1715065 */   // Label 23428: @1715065
     /* 1715065 */   GIM_Try, /*On fail goto*//*Label 23429*/ GIMT_Encode4(1715151), // Rule ID 10433 //
     /* 1715070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1715081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1715084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1715087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1715093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715116 */     // MIs[0] policy
     /* 1715116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715126 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11364:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1715147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715150 */     // GIR_Coverage, 10433,
     /* 1715150 */     GIR_EraseRootFromParent_Done,
     /* 1715151 */   // Label 23429: @1715151
     /* 1715151 */   GIM_Try, /*On fail goto*//*Label 23430*/ GIMT_Encode4(1715237), // Rule ID 10436 //
     /* 1715156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1715167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1715170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1715173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715202 */     // MIs[0] policy
     /* 1715202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715212 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715236 */     // GIR_Coverage, 10436,
     /* 1715236 */     GIR_EraseRootFromParent_Done,
     /* 1715237 */   // Label 23430: @1715237
     /* 1715237 */   GIM_Try, /*On fail goto*//*Label 23431*/ GIMT_Encode4(1715323), // Rule ID 10437 //
     /* 1715242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1715253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1715256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1715259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1715265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715288 */     // MIs[0] policy
     /* 1715288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715298 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11364:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1715319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715322 */     // GIR_Coverage, 10437,
     /* 1715322 */     GIR_EraseRootFromParent_Done,
     /* 1715323 */   // Label 23431: @1715323
     /* 1715323 */   GIM_Try, /*On fail goto*//*Label 23432*/ GIMT_Encode4(1715409), // Rule ID 10440 //
     /* 1715328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1715331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1715339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1715342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1715345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715374 */     // MIs[0] policy
     /* 1715374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715384 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1715405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715408 */     // GIR_Coverage, 10440,
     /* 1715408 */     GIR_EraseRootFromParent_Done,
     /* 1715409 */   // Label 23432: @1715409
     /* 1715409 */   GIM_Try, /*On fail goto*//*Label 23433*/ GIMT_Encode4(1715495), // Rule ID 10441 //
     /* 1715414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1715417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1715425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1715428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1715431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1715437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1715444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1715452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715460 */     // MIs[0] policy
     /* 1715460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715470 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11364:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M1_MASK),
     /* 1715473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1715491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715494 */     // GIR_Coverage, 10441,
     /* 1715494 */     GIR_EraseRootFromParent_Done,
     /* 1715495 */   // Label 23433: @1715495
     /* 1715495 */   GIM_Try, /*On fail goto*//*Label 23434*/ GIMT_Encode4(1715581), // Rule ID 10444 //
     /* 1715500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1715511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1715514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715546 */     // MIs[0] policy
     /* 1715546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1715559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715580 */     // GIR_Coverage, 10444,
     /* 1715580 */     GIR_EraseRootFromParent_Done,
     /* 1715581 */   // Label 23434: @1715581
     /* 1715581 */   GIM_Try, /*On fail goto*//*Label 23435*/ GIMT_Encode4(1715667), // Rule ID 10445 //
     /* 1715586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1715597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1715600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1715603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1715609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1715616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1715624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715632 */     // MIs[0] policy
     /* 1715632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715642 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1715645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715666 */     // GIR_Coverage, 10445,
     /* 1715666 */     GIR_EraseRootFromParent_Done,
     /* 1715667 */   // Label 23435: @1715667
     /* 1715667 */   GIM_Try, /*On fail goto*//*Label 23436*/ GIMT_Encode4(1715753), // Rule ID 10448 //
     /* 1715672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715718 */     // MIs[0] policy
     /* 1715718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715728 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1715731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715752 */     // GIR_Coverage, 10448,
     /* 1715752 */     GIR_EraseRootFromParent_Done,
     /* 1715753 */   // Label 23436: @1715753
     /* 1715753 */   GIM_Try, /*On fail goto*//*Label 23437*/ GIMT_Encode4(1715839), // Rule ID 10449 //
     /* 1715758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1715769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1715772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1715775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1715781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1715788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1715796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715804 */     // MIs[0] policy
     /* 1715804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1715817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715838 */     // GIR_Coverage, 10449,
     /* 1715838 */     GIR_EraseRootFromParent_Done,
     /* 1715839 */   // Label 23437: @1715839
     /* 1715839 */   GIM_Try, /*On fail goto*//*Label 23438*/ GIMT_Encode4(1715925), // Rule ID 10452 //
     /* 1715844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1715847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1715864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1715870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715890 */     // MIs[0] policy
     /* 1715890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715900 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1715900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1715903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1715918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1715921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1715923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1715924 */     // GIR_Coverage, 10452,
     /* 1715924 */     GIR_EraseRootFromParent_Done,
     /* 1715925 */   // Label 23438: @1715925
     /* 1715925 */   GIM_Try, /*On fail goto*//*Label 23439*/ GIMT_Encode4(1716011), // Rule ID 10453 //
     /* 1715930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1715933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1715938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1715941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1715944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1715947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1715950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1715953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1715956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1715960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1715968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1715972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1715976 */     // MIs[0] policy
     /* 1715976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1715979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1715986 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1715986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1715989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1715991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1715993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1715995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1715997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1715999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1716007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716010 */     // GIR_Coverage, 10453,
     /* 1716010 */     GIR_EraseRootFromParent_Done,
     /* 1716011 */   // Label 23439: @1716011
     /* 1716011 */   GIM_Try, /*On fail goto*//*Label 23440*/ GIMT_Encode4(1716097), // Rule ID 10456 //
     /* 1716016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1716027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1716030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1716033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716062 */     // MIs[0] policy
     /* 1716062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716072 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1716075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716096 */     // GIR_Coverage, 10456,
     /* 1716096 */     GIR_EraseRootFromParent_Done,
     /* 1716097 */   // Label 23440: @1716097
     /* 1716097 */   GIM_Try, /*On fail goto*//*Label 23441*/ GIMT_Encode4(1716183), // Rule ID 10457 //
     /* 1716102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1716113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1716116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1716119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716148 */     // MIs[0] policy
     /* 1716148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716158 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1716161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716182 */     // GIR_Coverage, 10457,
     /* 1716182 */     GIR_EraseRootFromParent_Done,
     /* 1716183 */   // Label 23441: @1716183
     /* 1716183 */   GIM_Try, /*On fail goto*//*Label 23442*/ GIMT_Encode4(1716269), // Rule ID 10460 //
     /* 1716188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1716199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1716202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1716205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716234 */     // MIs[0] policy
     /* 1716234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716244 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1716247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716268 */     // GIR_Coverage, 10460,
     /* 1716268 */     GIR_EraseRootFromParent_Done,
     /* 1716269 */   // Label 23442: @1716269
     /* 1716269 */   GIM_Try, /*On fail goto*//*Label 23443*/ GIMT_Encode4(1716355), // Rule ID 10461 //
     /* 1716274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1716285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1716288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1716291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716320 */     // MIs[0] policy
     /* 1716320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716330 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1716333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716354 */     // GIR_Coverage, 10461,
     /* 1716354 */     GIR_EraseRootFromParent_Done,
     /* 1716355 */   // Label 23443: @1716355
     /* 1716355 */   GIM_Try, /*On fail goto*//*Label 23444*/ GIMT_Encode4(1716441), // Rule ID 10464 //
     /* 1716360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1716371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1716374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1716377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716406 */     // MIs[0] policy
     /* 1716406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716416 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1716419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716440 */     // GIR_Coverage, 10464,
     /* 1716440 */     GIR_EraseRootFromParent_Done,
     /* 1716441 */   // Label 23444: @1716441
     /* 1716441 */   GIM_Try, /*On fail goto*//*Label 23445*/ GIMT_Encode4(1716527), // Rule ID 10465 //
     /* 1716446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1716457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1716460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1716463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1716469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716492 */     // MIs[0] policy
     /* 1716492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716502 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1716505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1716523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716526 */     // GIR_Coverage, 10465,
     /* 1716526 */     GIR_EraseRootFromParent_Done,
     /* 1716527 */   // Label 23445: @1716527
     /* 1716527 */   GIM_Try, /*On fail goto*//*Label 23446*/ GIMT_Encode4(1716613), // Rule ID 10468 //
     /* 1716532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716578 */     // MIs[0] policy
     /* 1716578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716588 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1716591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716612 */     // GIR_Coverage, 10468,
     /* 1716612 */     GIR_EraseRootFromParent_Done,
     /* 1716613 */   // Label 23446: @1716613
     /* 1716613 */   GIM_Try, /*On fail goto*//*Label 23447*/ GIMT_Encode4(1716699), // Rule ID 10469 //
     /* 1716618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1716629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1716632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1716635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1716641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1716648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1716656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716664 */     // MIs[0] policy
     /* 1716664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716674 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1716677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716698 */     // GIR_Coverage, 10469,
     /* 1716698 */     GIR_EraseRootFromParent_Done,
     /* 1716699 */   // Label 23447: @1716699
     /* 1716699 */   GIM_Try, /*On fail goto*//*Label 23448*/ GIMT_Encode4(1716785), // Rule ID 10472 //
     /* 1716704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716750 */     // MIs[0] policy
     /* 1716750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716760 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1716763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716784 */     // GIR_Coverage, 10472,
     /* 1716784 */     GIR_EraseRootFromParent_Done,
     /* 1716785 */   // Label 23448: @1716785
     /* 1716785 */   GIM_Try, /*On fail goto*//*Label 23449*/ GIMT_Encode4(1716871), // Rule ID 10473 //
     /* 1716790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1716801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1716804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1716807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1716813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1716820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1716828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716836 */     // MIs[0] policy
     /* 1716836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716846 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1716846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1716849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716870 */     // GIR_Coverage, 10473,
     /* 1716870 */     GIR_EraseRootFromParent_Done,
     /* 1716871 */   // Label 23449: @1716871
     /* 1716871 */   GIM_Try, /*On fail goto*//*Label 23450*/ GIMT_Encode4(1716957), // Rule ID 10476 //
     /* 1716876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1716879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1716896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1716902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1716918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1716922 */     // MIs[0] policy
     /* 1716922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1716925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1716932 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1716932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1716935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1716937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1716939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1716941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1716943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1716945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1716950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1716953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1716955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1716956 */     // GIR_Coverage, 10476,
     /* 1716956 */     GIR_EraseRootFromParent_Done,
     /* 1716957 */   // Label 23450: @1716957
     /* 1716957 */   GIM_Try, /*On fail goto*//*Label 23451*/ GIMT_Encode4(1717043), // Rule ID 10477 //
     /* 1716962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1716965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1716970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1716973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1716976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1716979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1716982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1716985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1716988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1716992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1716996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717008 */     // MIs[0] policy
     /* 1717008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717018 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1717021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1717039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717042 */     // GIR_Coverage, 10477,
     /* 1717042 */     GIR_EraseRootFromParent_Done,
     /* 1717043 */   // Label 23451: @1717043
     /* 1717043 */   GIM_Try, /*On fail goto*//*Label 23452*/ GIMT_Encode4(1717129), // Rule ID 10480 //
     /* 1717048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1717059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1717062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1717065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717094 */     // MIs[0] policy
     /* 1717094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1717107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717128 */     // GIR_Coverage, 10480,
     /* 1717128 */     GIR_EraseRootFromParent_Done,
     /* 1717129 */   // Label 23452: @1717129
     /* 1717129 */   GIM_Try, /*On fail goto*//*Label 23453*/ GIMT_Encode4(1717215), // Rule ID 10481 //
     /* 1717134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1717137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1717145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1717148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1717151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1717164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1717172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717180 */     // MIs[0] policy
     /* 1717180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11364:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M2_MASK),
     /* 1717193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717214 */     // GIR_Coverage, 10481,
     /* 1717214 */     GIR_EraseRootFromParent_Done,
     /* 1717215 */   // Label 23453: @1717215
     /* 1717215 */   GIM_Try, /*On fail goto*//*Label 23454*/ GIMT_Encode4(1717301), // Rule ID 10484 //
     /* 1717220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1717231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1717234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1717237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717266 */     // MIs[0] policy
     /* 1717266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1717279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717300 */     // GIR_Coverage, 10484,
     /* 1717300 */     GIR_EraseRootFromParent_Done,
     /* 1717301 */   // Label 23454: @1717301
     /* 1717301 */   GIM_Try, /*On fail goto*//*Label 23455*/ GIMT_Encode4(1717387), // Rule ID 10485 //
     /* 1717306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1717309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1717317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1717320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1717323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1717336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1717344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717352 */     // MIs[0] policy
     /* 1717352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11364:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M4_MASK),
     /* 1717365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717386 */     // GIR_Coverage, 10485,
     /* 1717386 */     GIR_EraseRootFromParent_Done,
     /* 1717387 */   // Label 23455: @1717387
     /* 1717387 */   GIM_Try, /*On fail goto*//*Label 23456*/ GIMT_Encode4(1717473), // Rule ID 10488 //
     /* 1717392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1717395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1717403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1717406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1717409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1717412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717438 */     // MIs[0] policy
     /* 1717438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1717451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717472 */     // GIR_Coverage, 10488,
     /* 1717472 */     GIR_EraseRootFromParent_Done,
     /* 1717473 */   // Label 23456: @1717473
     /* 1717473 */   GIM_Try, /*On fail goto*//*Label 23457*/ GIMT_Encode4(1717559), // Rule ID 10489 //
     /* 1717478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1717481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmin_mask),
     /* 1717486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1717489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1717492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1717495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1717498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1717501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1717508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1717516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1717520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717524 */     // MIs[0] policy
     /* 1717524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11364:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMIN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VX_M8_MASK),
     /* 1717537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1717555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717558 */     // GIR_Coverage, 10489,
     /* 1717558 */     GIR_EraseRootFromParent_Done,
     /* 1717559 */   // Label 23457: @1717559
     /* 1717559 */   GIM_Try, /*On fail goto*//*Label 23458*/ GIMT_Encode4(1717645), // Rule ID 10492 //
     /* 1717564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1717572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717610 */     // MIs[0] policy
     /* 1717610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717620 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1717623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717644 */     // GIR_Coverage, 10492,
     /* 1717644 */     GIR_EraseRootFromParent_Done,
     /* 1717645 */   // Label 23458: @1717645
     /* 1717645 */   GIM_Try, /*On fail goto*//*Label 23459*/ GIMT_Encode4(1717731), // Rule ID 10493 //
     /* 1717650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1717658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1717661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1717664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1717667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1717670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1717673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717696 */     // MIs[0] policy
     /* 1717696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717706 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8_MASK),
     /* 1717709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717730 */     // GIR_Coverage, 10493,
     /* 1717730 */     GIR_EraseRootFromParent_Done,
     /* 1717731 */   // Label 23459: @1717731
     /* 1717731 */   GIM_Try, /*On fail goto*//*Label 23460*/ GIMT_Encode4(1717817), // Rule ID 10496 //
     /* 1717736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1717744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717782 */     // MIs[0] policy
     /* 1717782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717792 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1717795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717816 */     // GIR_Coverage, 10496,
     /* 1717816 */     GIR_EraseRootFromParent_Done,
     /* 1717817 */   // Label 23460: @1717817
     /* 1717817 */   GIM_Try, /*On fail goto*//*Label 23461*/ GIMT_Encode4(1717903), // Rule ID 10497 //
     /* 1717822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1717830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1717833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1717836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1717839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1717842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1717845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1717848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717868 */     // MIs[0] policy
     /* 1717868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717878 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1717878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1717881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717902 */     // GIR_Coverage, 10497,
     /* 1717902 */     GIR_EraseRootFromParent_Done,
     /* 1717903 */   // Label 23461: @1717903
     /* 1717903 */   GIM_Try, /*On fail goto*//*Label 23462*/ GIMT_Encode4(1717989), // Rule ID 10500 //
     /* 1717908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1717911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1717916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1717919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1717922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1717925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1717928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1717931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1717934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1717938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1717950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1717954 */     // MIs[0] policy
     /* 1717954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1717957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1717964 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1717964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1717967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1717969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1717971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1717973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1717975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1717977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1717982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1717985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1717987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1717988 */     // GIR_Coverage, 10500,
     /* 1717988 */     GIR_EraseRootFromParent_Done,
     /* 1717989 */   // Label 23462: @1717989
     /* 1717989 */   GIM_Try, /*On fail goto*//*Label 23463*/ GIMT_Encode4(1718075), // Rule ID 10501 //
     /* 1717994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1717997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1718005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1718008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1718011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1718014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718040 */     // MIs[0] policy
     /* 1718040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718050 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1718053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718074 */     // GIR_Coverage, 10501,
     /* 1718074 */     GIR_EraseRootFromParent_Done,
     /* 1718075 */   // Label 23463: @1718075
     /* 1718075 */   GIM_Try, /*On fail goto*//*Label 23464*/ GIMT_Encode4(1718161), // Rule ID 10504 //
     /* 1718080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1718091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1718094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1718097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1718100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718126 */     // MIs[0] policy
     /* 1718126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718136 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1718139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718160 */     // GIR_Coverage, 10504,
     /* 1718160 */     GIR_EraseRootFromParent_Done,
     /* 1718161 */   // Label 23464: @1718161
     /* 1718161 */   GIM_Try, /*On fail goto*//*Label 23465*/ GIMT_Encode4(1718247), // Rule ID 10505 //
     /* 1718166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1718177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1718180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1718183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1718186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718212 */     // MIs[0] policy
     /* 1718212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4_MASK),
     /* 1718225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718246 */     // GIR_Coverage, 10505,
     /* 1718246 */     GIR_EraseRootFromParent_Done,
     /* 1718247 */   // Label 23465: @1718247
     /* 1718247 */   GIM_Try, /*On fail goto*//*Label 23466*/ GIMT_Encode4(1718333), // Rule ID 10508 //
     /* 1718252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1718263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1718266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1718269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1718272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718298 */     // MIs[0] policy
     /* 1718298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718308 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1718311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718332 */     // GIR_Coverage, 10508,
     /* 1718332 */     GIR_EraseRootFromParent_Done,
     /* 1718333 */   // Label 23466: @1718333
     /* 1718333 */   GIM_Try, /*On fail goto*//*Label 23467*/ GIMT_Encode4(1718419), // Rule ID 10509 //
     /* 1718338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1718349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1718352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1718355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1718358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718384 */     // MIs[0] policy
     /* 1718384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718394 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1718397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718418 */     // GIR_Coverage, 10509,
     /* 1718418 */     GIR_EraseRootFromParent_Done,
     /* 1718419 */   // Label 23467: @1718419
     /* 1718419 */   GIM_Try, /*On fail goto*//*Label 23468*/ GIMT_Encode4(1718505), // Rule ID 10512 //
     /* 1718424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1718435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1718438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1718441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1718444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718470 */     // MIs[0] policy
     /* 1718470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1718483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718504 */     // GIR_Coverage, 10512,
     /* 1718504 */     GIR_EraseRootFromParent_Done,
     /* 1718505 */   // Label 23468: @1718505
     /* 1718505 */   GIM_Try, /*On fail goto*//*Label 23469*/ GIMT_Encode4(1718591), // Rule ID 10513 //
     /* 1718510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1718521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1718524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1718527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1718530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1718533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718556 */     // MIs[0] policy
     /* 1718556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718566 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2_MASK),
     /* 1718569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1718587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718590 */     // GIR_Coverage, 10513,
     /* 1718590 */     GIR_EraseRootFromParent_Done,
     /* 1718591 */   // Label 23469: @1718591
     /* 1718591 */   GIM_Try, /*On fail goto*//*Label 23470*/ GIMT_Encode4(1718677), // Rule ID 10516 //
     /* 1718596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718642 */     // MIs[0] policy
     /* 1718642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718652 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1718655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718676 */     // GIR_Coverage, 10516,
     /* 1718676 */     GIR_EraseRootFromParent_Done,
     /* 1718677 */   // Label 23470: @1718677
     /* 1718677 */   GIM_Try, /*On fail goto*//*Label 23471*/ GIMT_Encode4(1718763), // Rule ID 10517 //
     /* 1718682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1718693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1718696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1718699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1718702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1718705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718728 */     // MIs[0] policy
     /* 1718728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1718741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1718759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718762 */     // GIR_Coverage, 10517,
     /* 1718762 */     GIR_EraseRootFromParent_Done,
     /* 1718763 */   // Label 23471: @1718763
     /* 1718763 */   GIM_Try, /*On fail goto*//*Label 23472*/ GIMT_Encode4(1718849), // Rule ID 10520 //
     /* 1718768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718814 */     // MIs[0] policy
     /* 1718814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718824 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1718827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718848 */     // GIR_Coverage, 10520,
     /* 1718848 */     GIR_EraseRootFromParent_Done,
     /* 1718849 */   // Label 23472: @1718849
     /* 1718849 */   GIM_Try, /*On fail goto*//*Label 23473*/ GIMT_Encode4(1718935), // Rule ID 10521 //
     /* 1718854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1718857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1718865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1718868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1718871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1718874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1718877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1718880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718900 */     // MIs[0] policy
     /* 1718900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718910 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1718910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1718913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1718915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1718917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1718919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1718921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1718923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1718928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1718931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1718933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1718934 */     // GIR_Coverage, 10521,
     /* 1718934 */     GIR_EraseRootFromParent_Done,
     /* 1718935 */   // Label 23473: @1718935
     /* 1718935 */   GIM_Try, /*On fail goto*//*Label 23474*/ GIMT_Encode4(1719021), // Rule ID 10524 //
     /* 1718940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1718943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1718948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1718951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1718954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1718957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1718960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1718963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1718966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1718970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1718982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1718986 */     // MIs[0] policy
     /* 1718986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1718989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1718996 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1718996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1718999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719020 */     // GIR_Coverage, 10524,
     /* 1719020 */     GIR_EraseRootFromParent_Done,
     /* 1719021 */   // Label 23474: @1719021
     /* 1719021 */   GIM_Try, /*On fail goto*//*Label 23475*/ GIMT_Encode4(1719107), // Rule ID 10525 //
     /* 1719026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1719037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1719040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1719043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1719046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1719049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719072 */     // MIs[0] policy
     /* 1719072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719082 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1719085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1719103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719106 */     // GIR_Coverage, 10525,
     /* 1719106 */     GIR_EraseRootFromParent_Done,
     /* 1719107 */   // Label 23475: @1719107
     /* 1719107 */   GIM_Try, /*On fail goto*//*Label 23476*/ GIMT_Encode4(1719193), // Rule ID 10528 //
     /* 1719112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1719115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1719123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1719126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1719129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1719132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719158 */     // MIs[0] policy
     /* 1719158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719168 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1719171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719192 */     // GIR_Coverage, 10528,
     /* 1719192 */     GIR_EraseRootFromParent_Done,
     /* 1719193 */   // Label 23476: @1719193
     /* 1719193 */   GIM_Try, /*On fail goto*//*Label 23477*/ GIMT_Encode4(1719279), // Rule ID 10529 //
     /* 1719198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1719201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1719209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1719212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1719215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1719218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1719221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1719228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1719240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719244 */     // MIs[0] policy
     /* 1719244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719254 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1_MASK),
     /* 1719257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1719275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719278 */     // GIR_Coverage, 10529,
     /* 1719278 */     GIR_EraseRootFromParent_Done,
     /* 1719279 */   // Label 23477: @1719279
     /* 1719279 */   GIM_Try, /*On fail goto*//*Label 23478*/ GIMT_Encode4(1719365), // Rule ID 10532 //
     /* 1719284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1719295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1719298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1719301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1719304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719330 */     // MIs[0] policy
     /* 1719330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719340 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1719343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719364 */     // GIR_Coverage, 10532,
     /* 1719364 */     GIR_EraseRootFromParent_Done,
     /* 1719365 */   // Label 23478: @1719365
     /* 1719365 */   GIM_Try, /*On fail goto*//*Label 23479*/ GIMT_Encode4(1719451), // Rule ID 10533 //
     /* 1719370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1719381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1719384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1719387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1719390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719416 */     // MIs[0] policy
     /* 1719416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719426 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1719429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719450 */     // GIR_Coverage, 10533,
     /* 1719450 */     GIR_EraseRootFromParent_Done,
     /* 1719451 */   // Label 23479: @1719451
     /* 1719451 */   GIM_Try, /*On fail goto*//*Label 23480*/ GIMT_Encode4(1719537), // Rule ID 10536 //
     /* 1719456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1719467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1719470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1719473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1719476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719502 */     // MIs[0] policy
     /* 1719502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719512 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1719515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719536 */     // GIR_Coverage, 10536,
     /* 1719536 */     GIR_EraseRootFromParent_Done,
     /* 1719537 */   // Label 23480: @1719537
     /* 1719537 */   GIM_Try, /*On fail goto*//*Label 23481*/ GIMT_Encode4(1719623), // Rule ID 10537 //
     /* 1719542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1719553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1719556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1719559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1719562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1719565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1719572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1719584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719588 */     // MIs[0] policy
     /* 1719588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719598 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1719601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719622 */     // GIR_Coverage, 10537,
     /* 1719622 */     GIR_EraseRootFromParent_Done,
     /* 1719623 */   // Label 23481: @1719623
     /* 1719623 */   GIM_Try, /*On fail goto*//*Label 23482*/ GIMT_Encode4(1719709), // Rule ID 10540 //
     /* 1719628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719674 */     // MIs[0] policy
     /* 1719674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719684 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1719687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719708 */     // GIR_Coverage, 10540,
     /* 1719708 */     GIR_EraseRootFromParent_Done,
     /* 1719709 */   // Label 23482: @1719709
     /* 1719709 */   GIM_Try, /*On fail goto*//*Label 23483*/ GIMT_Encode4(1719795), // Rule ID 10541 //
     /* 1719714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1719725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1719728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1719731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1719734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1719737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1719744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1719756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719760 */     // MIs[0] policy
     /* 1719760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719770 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1719773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1719791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719794 */     // GIR_Coverage, 10541,
     /* 1719794 */     GIR_EraseRootFromParent_Done,
     /* 1719795 */   // Label 23483: @1719795
     /* 1719795 */   GIM_Try, /*On fail goto*//*Label 23484*/ GIMT_Encode4(1719881), // Rule ID 10544 //
     /* 1719800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719846 */     // MIs[0] policy
     /* 1719846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719856 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1719856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1719859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719880 */     // GIR_Coverage, 10544,
     /* 1719880 */     GIR_EraseRootFromParent_Done,
     /* 1719881 */   // Label 23484: @1719881
     /* 1719881 */   GIM_Try, /*On fail goto*//*Label 23485*/ GIMT_Encode4(1719967), // Rule ID 10545 //
     /* 1719886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1719889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1719897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1719900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1719903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1719906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1719909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1719912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1719916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1719928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1719932 */     // MIs[0] policy
     /* 1719932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1719935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1719942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1719942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1719945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1719947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1719949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1719951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1719953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1719955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1719960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1719963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1719965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1719966 */     // GIR_Coverage, 10545,
     /* 1719966 */     GIR_EraseRootFromParent_Done,
     /* 1719967 */   // Label 23485: @1719967
     /* 1719967 */   GIM_Try, /*On fail goto*//*Label 23486*/ GIMT_Encode4(1720053), // Rule ID 10548 //
     /* 1719972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1719975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1719980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1719983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1719986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1719989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1719992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1719995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1719998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720018 */     // MIs[0] policy
     /* 1720018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720028 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1720031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720052 */     // GIR_Coverage, 10548,
     /* 1720052 */     GIR_EraseRootFromParent_Done,
     /* 1720053 */   // Label 23486: @1720053
     /* 1720053 */   GIM_Try, /*On fail goto*//*Label 23487*/ GIMT_Encode4(1720139), // Rule ID 10549 //
     /* 1720058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1720069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1720072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1720075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1720078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720104 */     // MIs[0] policy
     /* 1720104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720114 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1720117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720138 */     // GIR_Coverage, 10549,
     /* 1720138 */     GIR_EraseRootFromParent_Done,
     /* 1720139 */   // Label 23487: @1720139
     /* 1720139 */   GIM_Try, /*On fail goto*//*Label 23488*/ GIMT_Encode4(1720225), // Rule ID 10552 //
     /* 1720144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1720155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1720158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1720161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1720164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720190 */     // MIs[0] policy
     /* 1720190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720200 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1720203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720224 */     // GIR_Coverage, 10552,
     /* 1720224 */     GIR_EraseRootFromParent_Done,
     /* 1720225 */   // Label 23488: @1720225
     /* 1720225 */   GIM_Try, /*On fail goto*//*Label 23489*/ GIMT_Encode4(1720311), // Rule ID 10553 //
     /* 1720230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1720241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1720244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1720247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1720250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1720253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720276 */     // MIs[0] policy
     /* 1720276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720286 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1720289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1720307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720310 */     // GIR_Coverage, 10553,
     /* 1720310 */     GIR_EraseRootFromParent_Done,
     /* 1720311 */   // Label 23489: @1720311
     /* 1720311 */   GIM_Try, /*On fail goto*//*Label 23490*/ GIMT_Encode4(1720397), // Rule ID 10556 //
     /* 1720316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1720327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1720330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1720333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1720336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720362 */     // MIs[0] policy
     /* 1720362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1720375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720396 */     // GIR_Coverage, 10556,
     /* 1720396 */     GIR_EraseRootFromParent_Done,
     /* 1720397 */   // Label 23490: @1720397
     /* 1720397 */   GIM_Try, /*On fail goto*//*Label 23491*/ GIMT_Encode4(1720483), // Rule ID 10557 //
     /* 1720402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1720413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1720416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1720419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1720422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1720425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720448 */     // MIs[0] policy
     /* 1720448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720458 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1720461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720482 */     // GIR_Coverage, 10557,
     /* 1720482 */     GIR_EraseRootFromParent_Done,
     /* 1720483 */   // Label 23491: @1720483
     /* 1720483 */   GIM_Try, /*On fail goto*//*Label 23492*/ GIMT_Encode4(1720569), // Rule ID 10560 //
     /* 1720488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1720499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1720502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1720505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1720508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720534 */     // MIs[0] policy
     /* 1720534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1720547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720568 */     // GIR_Coverage, 10560,
     /* 1720568 */     GIR_EraseRootFromParent_Done,
     /* 1720569 */   // Label 23492: @1720569
     /* 1720569 */   GIM_Try, /*On fail goto*//*Label 23493*/ GIMT_Encode4(1720655), // Rule ID 10561 //
     /* 1720574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1720585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1720588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1720591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1720594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1720597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1720604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1720616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720620 */     // MIs[0] policy
     /* 1720620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1720633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720654 */     // GIR_Coverage, 10561,
     /* 1720654 */     GIR_EraseRootFromParent_Done,
     /* 1720655 */   // Label 23493: @1720655
     /* 1720655 */   GIM_Try, /*On fail goto*//*Label 23494*/ GIMT_Encode4(1720741), // Rule ID 10564 //
     /* 1720660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1720663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720706 */     // MIs[0] policy
     /* 1720706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720716 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1720719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720740 */     // GIR_Coverage, 10564,
     /* 1720740 */     GIR_EraseRootFromParent_Done,
     /* 1720741 */   // Label 23494: @1720741
     /* 1720741 */   GIM_Try, /*On fail goto*//*Label 23495*/ GIMT_Encode4(1720827), // Rule ID 10565 //
     /* 1720746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1720749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1720757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1720760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1720763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1720766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1720769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1720776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1720788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720792 */     // MIs[0] policy
     /* 1720792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720802 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1720805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1720823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720826 */     // GIR_Coverage, 10565,
     /* 1720826 */     GIR_EraseRootFromParent_Done,
     /* 1720827 */   // Label 23495: @1720827
     /* 1720827 */   GIM_Try, /*On fail goto*//*Label 23496*/ GIMT_Encode4(1720913), // Rule ID 10568 //
     /* 1720832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1720835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1720858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720878 */     // MIs[0] policy
     /* 1720878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1720888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1720891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720912 */     // GIR_Coverage, 10568,
     /* 1720912 */     GIR_EraseRootFromParent_Done,
     /* 1720913 */   // Label 23496: @1720913
     /* 1720913 */   GIM_Try, /*On fail goto*//*Label 23497*/ GIMT_Encode4(1720999), // Rule ID 10569 //
     /* 1720918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1720921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1720926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1720929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1720932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1720935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1720938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1720941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1720944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1720948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1720960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1720964 */     // MIs[0] policy
     /* 1720964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1720967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1720974 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1720974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2_MASK),
     /* 1720977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1720979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1720981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1720983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1720985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1720987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1720992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1720995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1720997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1720998 */     // GIR_Coverage, 10569,
     /* 1720998 */     GIR_EraseRootFromParent_Done,
     /* 1720999 */   // Label 23497: @1720999
     /* 1720999 */   GIM_Try, /*On fail goto*//*Label 23498*/ GIMT_Encode4(1721085), // Rule ID 10572 //
     /* 1721004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1721021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1721024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721050 */     // MIs[0] policy
     /* 1721050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721060 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1721063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721084 */     // GIR_Coverage, 10572,
     /* 1721084 */     GIR_EraseRootFromParent_Done,
     /* 1721085 */   // Label 23498: @1721085
     /* 1721085 */   GIM_Try, /*On fail goto*//*Label 23499*/ GIMT_Encode4(1721171), // Rule ID 10573 //
     /* 1721090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1721101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1721104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1721107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1721110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1721120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1721132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721136 */     // MIs[0] policy
     /* 1721136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721146 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4_MASK),
     /* 1721149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721170 */     // GIR_Coverage, 10573,
     /* 1721170 */     GIR_EraseRootFromParent_Done,
     /* 1721171 */   // Label 23499: @1721171
     /* 1721171 */   GIM_Try, /*On fail goto*//*Label 23500*/ GIMT_Encode4(1721257), // Rule ID 10576 //
     /* 1721176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1721179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1721187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1721190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1721193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1721196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721222 */     // MIs[0] policy
     /* 1721222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1721235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721256 */     // GIR_Coverage, 10576,
     /* 1721256 */     GIR_EraseRootFromParent_Done,
     /* 1721257 */   // Label 23500: @1721257
     /* 1721257 */   GIM_Try, /*On fail goto*//*Label 23501*/ GIMT_Encode4(1721343), // Rule ID 10577 //
     /* 1721262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1721265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1721273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1721276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1721279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1721282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1721285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1721292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1721304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721308 */     // MIs[0] policy
     /* 1721308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721318 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8_MASK),
     /* 1721321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1721339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721342 */     // GIR_Coverage, 10577,
     /* 1721342 */     GIR_EraseRootFromParent_Done,
     /* 1721343 */   // Label 23501: @1721343
     /* 1721343 */   GIM_Try, /*On fail goto*//*Label 23502*/ GIMT_Encode4(1721429), // Rule ID 10580 //
     /* 1721348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1721359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1721362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1721365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721394 */     // MIs[0] policy
     /* 1721394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721404 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1721407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721428 */     // GIR_Coverage, 10580,
     /* 1721428 */     GIR_EraseRootFromParent_Done,
     /* 1721429 */   // Label 23502: @1721429
     /* 1721429 */   GIM_Try, /*On fail goto*//*Label 23503*/ GIMT_Encode4(1721515), // Rule ID 10581 //
     /* 1721434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1721445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1721448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1721451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721480 */     // MIs[0] policy
     /* 1721480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721490 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF8_MASK),
     /* 1721493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721514 */     // GIR_Coverage, 10581,
     /* 1721514 */     GIR_EraseRootFromParent_Done,
     /* 1721515 */   // Label 23503: @1721515
     /* 1721515 */   GIM_Try, /*On fail goto*//*Label 23504*/ GIMT_Encode4(1721601), // Rule ID 10584 //
     /* 1721520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721566 */     // MIs[0] policy
     /* 1721566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721576 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1721579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721600 */     // GIR_Coverage, 10584,
     /* 1721600 */     GIR_EraseRootFromParent_Done,
     /* 1721601 */   // Label 23504: @1721601
     /* 1721601 */   GIM_Try, /*On fail goto*//*Label 23505*/ GIMT_Encode4(1721687), // Rule ID 10585 //
     /* 1721606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1721617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1721620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1721623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1721629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721652 */     // MIs[0] policy
     /* 1721652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721662 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1721665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721686 */     // GIR_Coverage, 10585,
     /* 1721686 */     GIR_EraseRootFromParent_Done,
     /* 1721687 */   // Label 23505: @1721687
     /* 1721687 */   GIM_Try, /*On fail goto*//*Label 23506*/ GIMT_Encode4(1721773), // Rule ID 10588 //
     /* 1721692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721738 */     // MIs[0] policy
     /* 1721738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721748 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1721751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721772 */     // GIR_Coverage, 10588,
     /* 1721772 */     GIR_EraseRootFromParent_Done,
     /* 1721773 */   // Label 23506: @1721773
     /* 1721773 */   GIM_Try, /*On fail goto*//*Label 23507*/ GIMT_Encode4(1721859), // Rule ID 10589 //
     /* 1721778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1721789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1721792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1721795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1721801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721824 */     // MIs[0] policy
     /* 1721824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721834 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1721834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1721837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1721855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721858 */     // GIR_Coverage, 10589,
     /* 1721858 */     GIR_EraseRootFromParent_Done,
     /* 1721859 */   // Label 23507: @1721859
     /* 1721859 */   GIM_Try, /*On fail goto*//*Label 23508*/ GIMT_Encode4(1721945), // Rule ID 10592 //
     /* 1721864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1721867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1721884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1721890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721910 */     // MIs[0] policy
     /* 1721910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1721920 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1721920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1721923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1721925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1721927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1721929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1721931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1721933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1721938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1721941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1721943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1721944 */     // GIR_Coverage, 10592,
     /* 1721944 */     GIR_EraseRootFromParent_Done,
     /* 1721945 */   // Label 23508: @1721945
     /* 1721945 */   GIM_Try, /*On fail goto*//*Label 23509*/ GIMT_Encode4(1722031), // Rule ID 10593 //
     /* 1721950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1721953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1721958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1721961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1721964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1721967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1721970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1721973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1721976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1721980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1721988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1721992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1721996 */     // MIs[0] policy
     /* 1721996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1721999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722006 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF4_MASK),
     /* 1722009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722030 */     // GIR_Coverage, 10593,
     /* 1722030 */     GIR_EraseRootFromParent_Done,
     /* 1722031 */   // Label 23509: @1722031
     /* 1722031 */   GIM_Try, /*On fail goto*//*Label 23510*/ GIMT_Encode4(1722117), // Rule ID 10596 //
     /* 1722036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1722047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1722050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1722053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722082 */     // MIs[0] policy
     /* 1722082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722092 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1722095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722116 */     // GIR_Coverage, 10596,
     /* 1722116 */     GIR_EraseRootFromParent_Done,
     /* 1722117 */   // Label 23510: @1722117
     /* 1722117 */   GIM_Try, /*On fail goto*//*Label 23511*/ GIMT_Encode4(1722203), // Rule ID 10597 //
     /* 1722122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1722133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1722136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1722139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722168 */     // MIs[0] policy
     /* 1722168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722178 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1722181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722202 */     // GIR_Coverage, 10597,
     /* 1722202 */     GIR_EraseRootFromParent_Done,
     /* 1722203 */   // Label 23511: @1722203
     /* 1722203 */   GIM_Try, /*On fail goto*//*Label 23512*/ GIMT_Encode4(1722289), // Rule ID 10600 //
     /* 1722208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1722219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1722222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1722225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722254 */     // MIs[0] policy
     /* 1722254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722264 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1722267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722288 */     // GIR_Coverage, 10600,
     /* 1722288 */     GIR_EraseRootFromParent_Done,
     /* 1722289 */   // Label 23512: @1722289
     /* 1722289 */   GIM_Try, /*On fail goto*//*Label 23513*/ GIMT_Encode4(1722375), // Rule ID 10601 //
     /* 1722294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1722305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1722308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1722311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722340 */     // MIs[0] policy
     /* 1722340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722350 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_MF2_MASK),
     /* 1722353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722374 */     // GIR_Coverage, 10601,
     /* 1722374 */     GIR_EraseRootFromParent_Done,
     /* 1722375 */   // Label 23513: @1722375
     /* 1722375 */   GIM_Try, /*On fail goto*//*Label 23514*/ GIMT_Encode4(1722461), // Rule ID 10604 //
     /* 1722380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1722391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1722394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1722397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722426 */     // MIs[0] policy
     /* 1722426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722436 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722460 */     // GIR_Coverage, 10604,
     /* 1722460 */     GIR_EraseRootFromParent_Done,
     /* 1722461 */   // Label 23514: @1722461
     /* 1722461 */   GIM_Try, /*On fail goto*//*Label 23515*/ GIMT_Encode4(1722547), // Rule ID 10605 //
     /* 1722466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1722477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1722480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1722483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1722489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722512 */     // MIs[0] policy
     /* 1722512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722522 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11348:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1722543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722546 */     // GIR_Coverage, 10605,
     /* 1722546 */     GIR_EraseRootFromParent_Done,
     /* 1722547 */   // Label 23515: @1722547
     /* 1722547 */   GIM_Try, /*On fail goto*//*Label 23516*/ GIMT_Encode4(1722633), // Rule ID 10608 //
     /* 1722552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722598 */     // MIs[0] policy
     /* 1722598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722608 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722632 */     // GIR_Coverage, 10608,
     /* 1722632 */     GIR_EraseRootFromParent_Done,
     /* 1722633 */   // Label 23516: @1722633
     /* 1722633 */   GIM_Try, /*On fail goto*//*Label 23517*/ GIMT_Encode4(1722719), // Rule ID 10609 //
     /* 1722638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1722649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1722652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1722655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1722661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722684 */     // MIs[0] policy
     /* 1722684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722694 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11348:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1722715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722718 */     // GIR_Coverage, 10609,
     /* 1722718 */     GIR_EraseRootFromParent_Done,
     /* 1722719 */   // Label 23517: @1722719
     /* 1722719 */   GIM_Try, /*On fail goto*//*Label 23518*/ GIMT_Encode4(1722805), // Rule ID 10612 //
     /* 1722724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1722727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722770 */     // MIs[0] policy
     /* 1722770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722780 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722804 */     // GIR_Coverage, 10612,
     /* 1722804 */     GIR_EraseRootFromParent_Done,
     /* 1722805 */   // Label 23518: @1722805
     /* 1722805 */   GIM_Try, /*On fail goto*//*Label 23519*/ GIMT_Encode4(1722891), // Rule ID 10613 //
     /* 1722810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1722813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1722821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1722824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1722827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1722830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1722833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1722836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722856 */     // MIs[0] policy
     /* 1722856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722866 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11348:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1722866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1722887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722890 */     // GIR_Coverage, 10613,
     /* 1722890 */     GIR_EraseRootFromParent_Done,
     /* 1722891 */   // Label 23519: @1722891
     /* 1722891 */   GIM_Try, /*On fail goto*//*Label 23520*/ GIMT_Encode4(1722977), // Rule ID 10616 //
     /* 1722896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1722899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1722916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1722919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1722922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1722926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1722934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1722938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1722942 */     // MIs[0] policy
     /* 1722942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1722945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1722952 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1722952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1722955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1722957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1722959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1722961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1722963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1722965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1722970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1722973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1722975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1722976 */     // GIR_Coverage, 10616,
     /* 1722976 */     GIR_EraseRootFromParent_Done,
     /* 1722977 */   // Label 23520: @1722977
     /* 1722977 */   GIM_Try, /*On fail goto*//*Label 23521*/ GIMT_Encode4(1723063), // Rule ID 10617 //
     /* 1722982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1722985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1722990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1722993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1722996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1722999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1723005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1723012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1723020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723028 */     // MIs[0] policy
     /* 1723028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11348:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M1_MASK),
     /* 1723041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1723059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723062 */     // GIR_Coverage, 10617,
     /* 1723062 */     GIR_EraseRootFromParent_Done,
     /* 1723063 */   // Label 23521: @1723063
     /* 1723063 */   GIM_Try, /*On fail goto*//*Label 23522*/ GIMT_Encode4(1723149), // Rule ID 10620 //
     /* 1723068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1723079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1723082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1723085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723114 */     // MIs[0] policy
     /* 1723114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723124 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1723127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723148 */     // GIR_Coverage, 10620,
     /* 1723148 */     GIR_EraseRootFromParent_Done,
     /* 1723149 */   // Label 23522: @1723149
     /* 1723149 */   GIM_Try, /*On fail goto*//*Label 23523*/ GIMT_Encode4(1723235), // Rule ID 10621 //
     /* 1723154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1723165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1723168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1723171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723200 */     // MIs[0] policy
     /* 1723200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723210 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1723213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723234 */     // GIR_Coverage, 10621,
     /* 1723234 */     GIR_EraseRootFromParent_Done,
     /* 1723235 */   // Label 23523: @1723235
     /* 1723235 */   GIM_Try, /*On fail goto*//*Label 23524*/ GIMT_Encode4(1723321), // Rule ID 10624 //
     /* 1723240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1723251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1723254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1723257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723286 */     // MIs[0] policy
     /* 1723286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723296 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1723299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723320 */     // GIR_Coverage, 10624,
     /* 1723320 */     GIR_EraseRootFromParent_Done,
     /* 1723321 */   // Label 23524: @1723321
     /* 1723321 */   GIM_Try, /*On fail goto*//*Label 23525*/ GIMT_Encode4(1723407), // Rule ID 10625 //
     /* 1723326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1723337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1723340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1723343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723372 */     // MIs[0] policy
     /* 1723372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723382 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1723385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723406 */     // GIR_Coverage, 10625,
     /* 1723406 */     GIR_EraseRootFromParent_Done,
     /* 1723407 */   // Label 23525: @1723407
     /* 1723407 */   GIM_Try, /*On fail goto*//*Label 23526*/ GIMT_Encode4(1723493), // Rule ID 10628 //
     /* 1723412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1723423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1723426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1723429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1723435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723458 */     // MIs[0] policy
     /* 1723458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723468 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1723471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723492 */     // GIR_Coverage, 10628,
     /* 1723492 */     GIR_EraseRootFromParent_Done,
     /* 1723493 */   // Label 23526: @1723493
     /* 1723493 */   GIM_Try, /*On fail goto*//*Label 23527*/ GIMT_Encode4(1723579), // Rule ID 10629 //
     /* 1723498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1723509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1723512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1723515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1723521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723544 */     // MIs[0] policy
     /* 1723544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723554 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1723557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1723575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723578 */     // GIR_Coverage, 10629,
     /* 1723578 */     GIR_EraseRootFromParent_Done,
     /* 1723579 */   // Label 23527: @1723579
     /* 1723579 */   GIM_Try, /*On fail goto*//*Label 23528*/ GIMT_Encode4(1723665), // Rule ID 10632 //
     /* 1723584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723630 */     // MIs[0] policy
     /* 1723630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723640 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1723643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723664 */     // GIR_Coverage, 10632,
     /* 1723664 */     GIR_EraseRootFromParent_Done,
     /* 1723665 */   // Label 23528: @1723665
     /* 1723665 */   GIM_Try, /*On fail goto*//*Label 23529*/ GIMT_Encode4(1723751), // Rule ID 10633 //
     /* 1723670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1723681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1723684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1723687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1723693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1723700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1723708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723716 */     // MIs[0] policy
     /* 1723716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1723729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723750 */     // GIR_Coverage, 10633,
     /* 1723750 */     GIR_EraseRootFromParent_Done,
     /* 1723751 */   // Label 23529: @1723751
     /* 1723751 */   GIM_Try, /*On fail goto*//*Label 23530*/ GIMT_Encode4(1723837), // Rule ID 10636 //
     /* 1723756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723802 */     // MIs[0] policy
     /* 1723802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723812 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1723815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723836 */     // GIR_Coverage, 10636,
     /* 1723836 */     GIR_EraseRootFromParent_Done,
     /* 1723837 */   // Label 23530: @1723837
     /* 1723837 */   GIM_Try, /*On fail goto*//*Label 23531*/ GIMT_Encode4(1723923), // Rule ID 10637 //
     /* 1723842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1723845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1723853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1723856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1723859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1723862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1723865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1723868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1723872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1723880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723888 */     // MIs[0] policy
     /* 1723888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723898 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1723898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1723901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1723916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1723919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1723921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1723922 */     // GIR_Coverage, 10637,
     /* 1723922 */     GIR_EraseRootFromParent_Done,
     /* 1723923 */   // Label 23531: @1723923
     /* 1723923 */   GIM_Try, /*On fail goto*//*Label 23532*/ GIMT_Encode4(1724009), // Rule ID 10640 //
     /* 1723928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1723931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1723936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1723939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1723942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1723945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1723948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1723951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1723954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1723958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1723966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1723970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1723974 */     // MIs[0] policy
     /* 1723974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1723977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1723984 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1723984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1723987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1723989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1723991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1723993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1723995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1723997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724008 */     // GIR_Coverage, 10640,
     /* 1724008 */     GIR_EraseRootFromParent_Done,
     /* 1724009 */   // Label 23532: @1724009
     /* 1724009 */   GIM_Try, /*On fail goto*//*Label 23533*/ GIMT_Encode4(1724095), // Rule ID 10641 //
     /* 1724014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1724025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1724028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1724031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1724037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724060 */     // MIs[0] policy
     /* 1724060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724070 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1724073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1724091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724094 */     // GIR_Coverage, 10641,
     /* 1724094 */     GIR_EraseRootFromParent_Done,
     /* 1724095 */   // Label 23533: @1724095
     /* 1724095 */   GIM_Try, /*On fail goto*//*Label 23534*/ GIMT_Encode4(1724181), // Rule ID 10644 //
     /* 1724100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1724111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1724114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1724117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724146 */     // MIs[0] policy
     /* 1724146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1724159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724180 */     // GIR_Coverage, 10644,
     /* 1724180 */     GIR_EraseRootFromParent_Done,
     /* 1724181 */   // Label 23534: @1724181
     /* 1724181 */   GIM_Try, /*On fail goto*//*Label 23535*/ GIMT_Encode4(1724267), // Rule ID 10645 //
     /* 1724186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1724197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1724200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1724203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724232 */     // MIs[0] policy
     /* 1724232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1724245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724266 */     // GIR_Coverage, 10645,
     /* 1724266 */     GIR_EraseRootFromParent_Done,
     /* 1724267 */   // Label 23535: @1724267
     /* 1724267 */   GIM_Try, /*On fail goto*//*Label 23536*/ GIMT_Encode4(1724353), // Rule ID 10648 //
     /* 1724272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1724283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1724286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1724289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724318 */     // MIs[0] policy
     /* 1724318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1724331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724352 */     // GIR_Coverage, 10648,
     /* 1724352 */     GIR_EraseRootFromParent_Done,
     /* 1724353 */   // Label 23536: @1724353
     /* 1724353 */   GIM_Try, /*On fail goto*//*Label 23537*/ GIMT_Encode4(1724439), // Rule ID 10649 //
     /* 1724358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1724369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1724372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1724375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724404 */     // MIs[0] policy
     /* 1724404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1724417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724438 */     // GIR_Coverage, 10649,
     /* 1724438 */     GIR_EraseRootFromParent_Done,
     /* 1724439 */   // Label 23537: @1724439
     /* 1724439 */   GIM_Try, /*On fail goto*//*Label 23538*/ GIMT_Encode4(1724525), // Rule ID 10652 //
     /* 1724444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1724447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1724455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1724458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1724461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724490 */     // MIs[0] policy
     /* 1724490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1724503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724524 */     // GIR_Coverage, 10652,
     /* 1724524 */     GIR_EraseRootFromParent_Done,
     /* 1724525 */   // Label 23538: @1724525
     /* 1724525 */   GIM_Try, /*On fail goto*//*Label 23539*/ GIMT_Encode4(1724611), // Rule ID 10653 //
     /* 1724530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1724533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1724541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1724544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1724547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1724553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724576 */     // MIs[0] policy
     /* 1724576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1724589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1724607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724610 */     // GIR_Coverage, 10653,
     /* 1724610 */     GIR_EraseRootFromParent_Done,
     /* 1724611 */   // Label 23539: @1724611
     /* 1724611 */   GIM_Try, /*On fail goto*//*Label 23540*/ GIMT_Encode4(1724697), // Rule ID 10656 //
     /* 1724616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724662 */     // MIs[0] policy
     /* 1724662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1724675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724696 */     // GIR_Coverage, 10656,
     /* 1724696 */     GIR_EraseRootFromParent_Done,
     /* 1724697 */   // Label 23540: @1724697
     /* 1724697 */   GIM_Try, /*On fail goto*//*Label 23541*/ GIMT_Encode4(1724783), // Rule ID 10657 //
     /* 1724702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1724713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1724716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1724719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1724725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1724732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1724740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724748 */     // MIs[0] policy
     /* 1724748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724758 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11348:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M2_MASK),
     /* 1724761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724782 */     // GIR_Coverage, 10657,
     /* 1724782 */     GIR_EraseRootFromParent_Done,
     /* 1724783 */   // Label 23541: @1724783
     /* 1724783 */   GIM_Try, /*On fail goto*//*Label 23542*/ GIMT_Encode4(1724869), // Rule ID 10660 //
     /* 1724788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724834 */     // MIs[0] policy
     /* 1724834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724844 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1724844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1724847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724868 */     // GIR_Coverage, 10660,
     /* 1724868 */     GIR_EraseRootFromParent_Done,
     /* 1724869 */   // Label 23542: @1724869
     /* 1724869 */   GIM_Try, /*On fail goto*//*Label 23543*/ GIMT_Encode4(1724955), // Rule ID 10661 //
     /* 1724874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1724877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1724885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1724888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1724891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1724894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1724897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1724900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1724904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1724912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1724916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1724920 */     // MIs[0] policy
     /* 1724920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1724923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1724930 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11348:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1724930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M4_MASK),
     /* 1724933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1724935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1724937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1724939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1724941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1724943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1724948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1724951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1724953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1724954 */     // GIR_Coverage, 10661,
     /* 1724954 */     GIR_EraseRootFromParent_Done,
     /* 1724955 */   // Label 23543: @1724955
     /* 1724955 */   GIM_Try, /*On fail goto*//*Label 23544*/ GIMT_Encode4(1725041), // Rule ID 10664 //
     /* 1724960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1724963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1724968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1724971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1724974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1724977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1724980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1724983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1724986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1724990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1724998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725006 */     // MIs[0] policy
     /* 1725006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725016 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1725019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725040 */     // GIR_Coverage, 10664,
     /* 1725040 */     GIR_EraseRootFromParent_Done,
     /* 1725041 */   // Label 23544: @1725041
     /* 1725041 */   GIM_Try, /*On fail goto*//*Label 23545*/ GIMT_Encode4(1725127), // Rule ID 10665 //
     /* 1725046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1725049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmaxu_mask),
     /* 1725054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1725057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1725060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1725063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1725066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1725069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1725076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1725084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1725088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725092 */     // MIs[0] policy
     /* 1725092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725102 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11348:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAXU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VX_M8_MASK),
     /* 1725105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1725123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725126 */     // GIR_Coverage, 10665,
     /* 1725126 */     GIR_EraseRootFromParent_Done,
     /* 1725127 */   // Label 23545: @1725127
     /* 1725127 */   GIM_Try, /*On fail goto*//*Label 23546*/ GIMT_Encode4(1725213), // Rule ID 10668 //
     /* 1725132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1725143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1725146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1725149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1725152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725178 */     // MIs[0] policy
     /* 1725178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725188 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1725191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725212 */     // GIR_Coverage, 10668,
     /* 1725212 */     GIR_EraseRootFromParent_Done,
     /* 1725213 */   // Label 23546: @1725213
     /* 1725213 */   GIM_Try, /*On fail goto*//*Label 23547*/ GIMT_Encode4(1725299), // Rule ID 10669 //
     /* 1725218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1725229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1725232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1725235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1725238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725264 */     // MIs[0] policy
     /* 1725264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725274 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8_MASK),
     /* 1725277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725298 */     // GIR_Coverage, 10669,
     /* 1725298 */     GIR_EraseRootFromParent_Done,
     /* 1725299 */   // Label 23547: @1725299
     /* 1725299 */   GIM_Try, /*On fail goto*//*Label 23548*/ GIMT_Encode4(1725385), // Rule ID 10672 //
     /* 1725304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1725315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1725318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1725321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1725324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725350 */     // MIs[0] policy
     /* 1725350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725360 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1725363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725384 */     // GIR_Coverage, 10672,
     /* 1725384 */     GIR_EraseRootFromParent_Done,
     /* 1725385 */   // Label 23548: @1725385
     /* 1725385 */   GIM_Try, /*On fail goto*//*Label 23549*/ GIMT_Encode4(1725471), // Rule ID 10673 //
     /* 1725390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1725401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1725404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1725407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1725410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725436 */     // MIs[0] policy
     /* 1725436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725446 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1725449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725470 */     // GIR_Coverage, 10673,
     /* 1725470 */     GIR_EraseRootFromParent_Done,
     /* 1725471 */   // Label 23549: @1725471
     /* 1725471 */   GIM_Try, /*On fail goto*//*Label 23550*/ GIMT_Encode4(1725557), // Rule ID 10676 //
     /* 1725476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1725487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1725490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1725493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1725496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725522 */     // MIs[0] policy
     /* 1725522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725532 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1725535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725556 */     // GIR_Coverage, 10676,
     /* 1725556 */     GIR_EraseRootFromParent_Done,
     /* 1725557 */   // Label 23550: @1725557
     /* 1725557 */   GIM_Try, /*On fail goto*//*Label 23551*/ GIMT_Encode4(1725643), // Rule ID 10677 //
     /* 1725562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1725573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1725576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1725579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1725582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1725585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725608 */     // MIs[0] policy
     /* 1725608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725618 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1725621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1725639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725642 */     // GIR_Coverage, 10677,
     /* 1725642 */     GIR_EraseRootFromParent_Done,
     /* 1725643 */   // Label 23551: @1725643
     /* 1725643 */   GIM_Try, /*On fail goto*//*Label 23552*/ GIMT_Encode4(1725729), // Rule ID 10680 //
     /* 1725648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725694 */     // MIs[0] policy
     /* 1725694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725704 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1725707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725728 */     // GIR_Coverage, 10680,
     /* 1725728 */     GIR_EraseRootFromParent_Done,
     /* 1725729 */   // Label 23552: @1725729
     /* 1725729 */   GIM_Try, /*On fail goto*//*Label 23553*/ GIMT_Encode4(1725815), // Rule ID 10681 //
     /* 1725734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1725745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1725748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1725751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1725754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1725757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725780 */     // MIs[0] policy
     /* 1725780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725790 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4_MASK),
     /* 1725793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725814 */     // GIR_Coverage, 10681,
     /* 1725814 */     GIR_EraseRootFromParent_Done,
     /* 1725815 */   // Label 23553: @1725815
     /* 1725815 */   GIM_Try, /*On fail goto*//*Label 23554*/ GIMT_Encode4(1725901), // Rule ID 10684 //
     /* 1725820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1725846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725866 */     // MIs[0] policy
     /* 1725866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1725876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1725879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725900 */     // GIR_Coverage, 10684,
     /* 1725900 */     GIR_EraseRootFromParent_Done,
     /* 1725901 */   // Label 23554: @1725901
     /* 1725901 */   GIM_Try, /*On fail goto*//*Label 23555*/ GIMT_Encode4(1725987), // Rule ID 10685 //
     /* 1725906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1725909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1725914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1725917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1725920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1725923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1725926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1725929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1725932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1725936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1725948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1725952 */     // MIs[0] policy
     /* 1725952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1725955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1725962 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1725962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1725965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1725967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1725969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1725971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1725973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1725975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1725980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1725983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1725985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1725986 */     // GIR_Coverage, 10685,
     /* 1725986 */     GIR_EraseRootFromParent_Done,
     /* 1725987 */   // Label 23555: @1725987
     /* 1725987 */   GIM_Try, /*On fail goto*//*Label 23556*/ GIMT_Encode4(1726073), // Rule ID 10688 //
     /* 1725992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1725995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1726009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1726012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726038 */     // MIs[0] policy
     /* 1726038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726048 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1726051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726072 */     // GIR_Coverage, 10688,
     /* 1726072 */     GIR_EraseRootFromParent_Done,
     /* 1726073 */   // Label 23556: @1726073
     /* 1726073 */   GIM_Try, /*On fail goto*//*Label 23557*/ GIMT_Encode4(1726159), // Rule ID 10689 //
     /* 1726078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1726089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1726092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1726095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1726098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726124 */     // MIs[0] policy
     /* 1726124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726134 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2_MASK),
     /* 1726137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726158 */     // GIR_Coverage, 10689,
     /* 1726158 */     GIR_EraseRootFromParent_Done,
     /* 1726159 */   // Label 23557: @1726159
     /* 1726159 */   GIM_Try, /*On fail goto*//*Label 23558*/ GIMT_Encode4(1726245), // Rule ID 10692 //
     /* 1726164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1726175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1726178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1726181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1726184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726210 */     // MIs[0] policy
     /* 1726210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726244 */     // GIR_Coverage, 10692,
     /* 1726244 */     GIR_EraseRootFromParent_Done,
     /* 1726245 */   // Label 23558: @1726245
     /* 1726245 */   GIM_Try, /*On fail goto*//*Label 23559*/ GIMT_Encode4(1726331), // Rule ID 10693 //
     /* 1726250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1726261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1726264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1726267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1726270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1726273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726296 */     // MIs[0] policy
     /* 1726296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726306 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726330 */     // GIR_Coverage, 10693,
     /* 1726330 */     GIR_EraseRootFromParent_Done,
     /* 1726331 */   // Label 23559: @1726331
     /* 1726331 */   GIM_Try, /*On fail goto*//*Label 23560*/ GIMT_Encode4(1726417), // Rule ID 10696 //
     /* 1726336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1726347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1726350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1726353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1726356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726382 */     // MIs[0] policy
     /* 1726382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726392 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726416 */     // GIR_Coverage, 10696,
     /* 1726416 */     GIR_EraseRootFromParent_Done,
     /* 1726417 */   // Label 23560: @1726417
     /* 1726417 */   GIM_Try, /*On fail goto*//*Label 23561*/ GIMT_Encode4(1726503), // Rule ID 10697 //
     /* 1726422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1726433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1726436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1726439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1726442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1726445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726468 */     // MIs[0] policy
     /* 1726468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726478 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1726499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726502 */     // GIR_Coverage, 10697,
     /* 1726502 */     GIR_EraseRootFromParent_Done,
     /* 1726503 */   // Label 23561: @1726503
     /* 1726503 */   GIM_Try, /*On fail goto*//*Label 23562*/ GIMT_Encode4(1726589), // Rule ID 10700 //
     /* 1726508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726554 */     // MIs[0] policy
     /* 1726554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726588 */     // GIR_Coverage, 10700,
     /* 1726588 */     GIR_EraseRootFromParent_Done,
     /* 1726589 */   // Label 23562: @1726589
     /* 1726589 */   GIM_Try, /*On fail goto*//*Label 23563*/ GIMT_Encode4(1726675), // Rule ID 10701 //
     /* 1726594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1726605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1726608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1726611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1726614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1726617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726640 */     // MIs[0] policy
     /* 1726640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1726671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726674 */     // GIR_Coverage, 10701,
     /* 1726674 */     GIR_EraseRootFromParent_Done,
     /* 1726675 */   // Label 23563: @1726675
     /* 1726675 */   GIM_Try, /*On fail goto*//*Label 23564*/ GIMT_Encode4(1726761), // Rule ID 10704 //
     /* 1726680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1726683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726726 */     // MIs[0] policy
     /* 1726726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726736 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726760 */     // GIR_Coverage, 10704,
     /* 1726760 */     GIR_EraseRootFromParent_Done,
     /* 1726761 */   // Label 23564: @1726761
     /* 1726761 */   GIM_Try, /*On fail goto*//*Label 23565*/ GIMT_Encode4(1726847), // Rule ID 10705 //
     /* 1726766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1726769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1726777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1726780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1726783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1726786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1726789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1726796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1726808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726812 */     // MIs[0] policy
     /* 1726812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726822 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1_MASK),
     /* 1726825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1726843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726846 */     // GIR_Coverage, 10705,
     /* 1726846 */     GIR_EraseRootFromParent_Done,
     /* 1726847 */   // Label 23565: @1726847
     /* 1726847 */   GIM_Try, /*On fail goto*//*Label 23566*/ GIMT_Encode4(1726933), // Rule ID 10708 //
     /* 1726852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1726855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1726878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726898 */     // MIs[0] policy
     /* 1726898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726908 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1726908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1726911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1726915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1726917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1726919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1726921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1726926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1726929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1726931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1726932 */     // GIR_Coverage, 10708,
     /* 1726932 */     GIR_EraseRootFromParent_Done,
     /* 1726933 */   // Label 23566: @1726933
     /* 1726933 */   GIM_Try, /*On fail goto*//*Label 23567*/ GIMT_Encode4(1727019), // Rule ID 10709 //
     /* 1726938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1726941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1726946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1726949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1726952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1726955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1726958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1726961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1726964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1726968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1726980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1726984 */     // MIs[0] policy
     /* 1726984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1726987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1726994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1726994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1726997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1726999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727018 */     // GIR_Coverage, 10709,
     /* 1727018 */     GIR_EraseRootFromParent_Done,
     /* 1727019 */   // Label 23567: @1727019
     /* 1727019 */   GIM_Try, /*On fail goto*//*Label 23568*/ GIMT_Encode4(1727105), // Rule ID 10712 //
     /* 1727024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1727035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1727038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1727041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1727044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727070 */     // MIs[0] policy
     /* 1727070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727080 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1727083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727104 */     // GIR_Coverage, 10712,
     /* 1727104 */     GIR_EraseRootFromParent_Done,
     /* 1727105 */   // Label 23568: @1727105
     /* 1727105 */   GIM_Try, /*On fail goto*//*Label 23569*/ GIMT_Encode4(1727191), // Rule ID 10713 //
     /* 1727110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1727121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1727124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1727127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1727130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727156 */     // MIs[0] policy
     /* 1727156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727166 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1727169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727190 */     // GIR_Coverage, 10713,
     /* 1727190 */     GIR_EraseRootFromParent_Done,
     /* 1727191 */   // Label 23569: @1727191
     /* 1727191 */   GIM_Try, /*On fail goto*//*Label 23570*/ GIMT_Encode4(1727277), // Rule ID 10716 //
     /* 1727196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1727207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1727210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1727213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1727216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1727219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727242 */     // MIs[0] policy
     /* 1727242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727252 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1727255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727276 */     // GIR_Coverage, 10716,
     /* 1727276 */     GIR_EraseRootFromParent_Done,
     /* 1727277 */   // Label 23570: @1727277
     /* 1727277 */   GIM_Try, /*On fail goto*//*Label 23571*/ GIMT_Encode4(1727363), // Rule ID 10717 //
     /* 1727282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1727293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1727296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1727299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1727302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1727305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727328 */     // MIs[0] policy
     /* 1727328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727338 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1727341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1727359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727362 */     // GIR_Coverage, 10717,
     /* 1727362 */     GIR_EraseRootFromParent_Done,
     /* 1727363 */   // Label 23571: @1727363
     /* 1727363 */   GIM_Try, /*On fail goto*//*Label 23572*/ GIMT_Encode4(1727449), // Rule ID 10720 //
     /* 1727368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1727379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1727382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1727385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1727388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727414 */     // MIs[0] policy
     /* 1727414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1727427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727448 */     // GIR_Coverage, 10720,
     /* 1727448 */     GIR_EraseRootFromParent_Done,
     /* 1727449 */   // Label 23572: @1727449
     /* 1727449 */   GIM_Try, /*On fail goto*//*Label 23573*/ GIMT_Encode4(1727535), // Rule ID 10721 //
     /* 1727454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1727465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1727468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1727471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1727474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1727477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727500 */     // MIs[0] policy
     /* 1727500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1727513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727534 */     // GIR_Coverage, 10721,
     /* 1727534 */     GIR_EraseRootFromParent_Done,
     /* 1727535 */   // Label 23573: @1727535
     /* 1727535 */   GIM_Try, /*On fail goto*//*Label 23574*/ GIMT_Encode4(1727621), // Rule ID 10724 //
     /* 1727540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727586 */     // MIs[0] policy
     /* 1727586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1727599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727620 */     // GIR_Coverage, 10724,
     /* 1727620 */     GIR_EraseRootFromParent_Done,
     /* 1727621 */   // Label 23574: @1727621
     /* 1727621 */   GIM_Try, /*On fail goto*//*Label 23575*/ GIMT_Encode4(1727707), // Rule ID 10725 //
     /* 1727626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1727637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1727640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1727643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1727646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1727649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1727656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1727668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727672 */     // MIs[0] policy
     /* 1727672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727682 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1727685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727706 */     // GIR_Coverage, 10725,
     /* 1727706 */     GIR_EraseRootFromParent_Done,
     /* 1727707 */   // Label 23575: @1727707
     /* 1727707 */   GIM_Try, /*On fail goto*//*Label 23576*/ GIMT_Encode4(1727793), // Rule ID 10728 //
     /* 1727712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727758 */     // MIs[0] policy
     /* 1727758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727768 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1727771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727792 */     // GIR_Coverage, 10728,
     /* 1727792 */     GIR_EraseRootFromParent_Done,
     /* 1727793 */   // Label 23576: @1727793
     /* 1727793 */   GIM_Try, /*On fail goto*//*Label 23577*/ GIMT_Encode4(1727879), // Rule ID 10729 //
     /* 1727798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1727809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1727812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1727815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1727818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1727821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1727828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1727840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727844 */     // MIs[0] policy
     /* 1727844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1727854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1727857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1727875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727878 */     // GIR_Coverage, 10729,
     /* 1727878 */     GIR_EraseRootFromParent_Done,
     /* 1727879 */   // Label 23577: @1727879
     /* 1727879 */   GIM_Try, /*On fail goto*//*Label 23578*/ GIMT_Encode4(1727965), // Rule ID 10732 //
     /* 1727884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1727887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1727910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1727914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1727926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1727930 */     // MIs[0] policy
     /* 1727930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1727933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1727940 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1727940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1727943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1727945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1727947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1727949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1727951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1727953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1727958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1727961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1727963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1727964 */     // GIR_Coverage, 10732,
     /* 1727964 */     GIR_EraseRootFromParent_Done,
     /* 1727965 */   // Label 23578: @1727965
     /* 1727965 */   GIM_Try, /*On fail goto*//*Label 23579*/ GIMT_Encode4(1728051), // Rule ID 10733 //
     /* 1727970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1727973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1727978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1727981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1727984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1727987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1727990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1727993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1727996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728016 */     // MIs[0] policy
     /* 1728016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728026 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1728029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728050 */     // GIR_Coverage, 10733,
     /* 1728050 */     GIR_EraseRootFromParent_Done,
     /* 1728051 */   // Label 23579: @1728051
     /* 1728051 */   GIM_Try, /*On fail goto*//*Label 23580*/ GIMT_Encode4(1728137), // Rule ID 10736 //
     /* 1728056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1728067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1728070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1728073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1728076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728102 */     // MIs[0] policy
     /* 1728102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728112 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1728115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728136 */     // GIR_Coverage, 10736,
     /* 1728136 */     GIR_EraseRootFromParent_Done,
     /* 1728137 */   // Label 23580: @1728137
     /* 1728137 */   GIM_Try, /*On fail goto*//*Label 23581*/ GIMT_Encode4(1728223), // Rule ID 10737 //
     /* 1728142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1728153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1728156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1728159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1728162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728188 */     // MIs[0] policy
     /* 1728188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728198 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1728201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728222 */     // GIR_Coverage, 10737,
     /* 1728222 */     GIR_EraseRootFromParent_Done,
     /* 1728223 */   // Label 23581: @1728223
     /* 1728223 */   GIM_Try, /*On fail goto*//*Label 23582*/ GIMT_Encode4(1728309), // Rule ID 10740 //
     /* 1728228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1728239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1728242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1728245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1728248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728274 */     // MIs[0] policy
     /* 1728274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728284 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1728287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728308 */     // GIR_Coverage, 10740,
     /* 1728308 */     GIR_EraseRootFromParent_Done,
     /* 1728309 */   // Label 23582: @1728309
     /* 1728309 */   GIM_Try, /*On fail goto*//*Label 23583*/ GIMT_Encode4(1728395), // Rule ID 10741 //
     /* 1728314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1728317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1728325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1728328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1728331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1728334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1728337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728360 */     // MIs[0] policy
     /* 1728360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728370 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1728373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1728391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728394 */     // GIR_Coverage, 10741,
     /* 1728394 */     GIR_EraseRootFromParent_Done,
     /* 1728395 */   // Label 23583: @1728395
     /* 1728395 */   GIM_Try, /*On fail goto*//*Label 23584*/ GIMT_Encode4(1728481), // Rule ID 10744 //
     /* 1728400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1728411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1728414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1728417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1728420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728446 */     // MIs[0] policy
     /* 1728446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1728459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728480 */     // GIR_Coverage, 10744,
     /* 1728480 */     GIR_EraseRootFromParent_Done,
     /* 1728481 */   // Label 23584: @1728481
     /* 1728481 */   GIM_Try, /*On fail goto*//*Label 23585*/ GIMT_Encode4(1728567), // Rule ID 10745 //
     /* 1728486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1728497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1728500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1728503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1728506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1728509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1728516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1728528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728532 */     // MIs[0] policy
     /* 1728532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728542 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2_MASK),
     /* 1728545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728566 */     // GIR_Coverage, 10745,
     /* 1728566 */     GIR_EraseRootFromParent_Done,
     /* 1728567 */   // Label 23585: @1728567
     /* 1728567 */   GIM_Try, /*On fail goto*//*Label 23586*/ GIMT_Encode4(1728653), // Rule ID 10748 //
     /* 1728572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728618 */     // MIs[0] policy
     /* 1728618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728628 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1728631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728652 */     // GIR_Coverage, 10748,
     /* 1728652 */     GIR_EraseRootFromParent_Done,
     /* 1728653 */   // Label 23586: @1728653
     /* 1728653 */   GIM_Try, /*On fail goto*//*Label 23587*/ GIMT_Encode4(1728739), // Rule ID 10749 //
     /* 1728658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1728669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1728672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1728675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1728678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1728681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1728688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1728700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728704 */     // MIs[0] policy
     /* 1728704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728714 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4_MASK),
     /* 1728717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728738 */     // GIR_Coverage, 10749,
     /* 1728738 */     GIR_EraseRootFromParent_Done,
     /* 1728739 */   // Label 23587: @1728739
     /* 1728739 */   GIM_Try, /*On fail goto*//*Label 23588*/ GIMT_Encode4(1728825), // Rule ID 10752 //
     /* 1728744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1728747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728790 */     // MIs[0] policy
     /* 1728790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728800 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1728803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728824 */     // GIR_Coverage, 10752,
     /* 1728824 */     GIR_EraseRootFromParent_Done,
     /* 1728825 */   // Label 23588: @1728825
     /* 1728825 */   GIM_Try, /*On fail goto*//*Label 23589*/ GIMT_Encode4(1728911), // Rule ID 10753 //
     /* 1728830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1728833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1728841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1728844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1728847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1728850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1728853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1728856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1728860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1728872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728876 */     // MIs[0] policy
     /* 1728876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728886 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1728886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8_MASK),
     /* 1728889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1728907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728910 */     // GIR_Coverage, 10753,
     /* 1728910 */     GIR_EraseRootFromParent_Done,
     /* 1728911 */   // Label 23589: @1728911
     /* 1728911 */   GIM_Try, /*On fail goto*//*Label 23590*/ GIMT_Encode4(1728997), // Rule ID 10756 //
     /* 1728916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1728919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1728924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1728927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1728930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1728933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1728936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1728939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1728942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1728946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1728954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1728958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1728962 */     // MIs[0] policy
     /* 1728962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1728965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1728972 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1728972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1728975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1728977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1728979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1728981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1728983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1728985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1728990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1728993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1728995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1728996 */     // GIR_Coverage, 10756,
     /* 1728996 */     GIR_EraseRootFromParent_Done,
     /* 1728997 */   // Label 23590: @1728997
     /* 1728997 */   GIM_Try, /*On fail goto*//*Label 23591*/ GIMT_Encode4(1729083), // Rule ID 10757 //
     /* 1729002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1729013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1729016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1729019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729048 */     // MIs[0] policy
     /* 1729048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729058 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF8_MASK),
     /* 1729061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729082 */     // GIR_Coverage, 10757,
     /* 1729082 */     GIR_EraseRootFromParent_Done,
     /* 1729083 */   // Label 23591: @1729083
     /* 1729083 */   GIM_Try, /*On fail goto*//*Label 23592*/ GIMT_Encode4(1729169), // Rule ID 10760 //
     /* 1729088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1729099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1729102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1729105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729134 */     // MIs[0] policy
     /* 1729134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729144 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1729147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729168 */     // GIR_Coverage, 10760,
     /* 1729168 */     GIR_EraseRootFromParent_Done,
     /* 1729169 */   // Label 23592: @1729169
     /* 1729169 */   GIM_Try, /*On fail goto*//*Label 23593*/ GIMT_Encode4(1729255), // Rule ID 10761 //
     /* 1729174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1729185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1729188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1729191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729220 */     // MIs[0] policy
     /* 1729220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729230 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1729233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729254 */     // GIR_Coverage, 10761,
     /* 1729254 */     GIR_EraseRootFromParent_Done,
     /* 1729255 */   // Label 23593: @1729255
     /* 1729255 */   GIM_Try, /*On fail goto*//*Label 23594*/ GIMT_Encode4(1729341), // Rule ID 10764 //
     /* 1729260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1729271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1729274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1729277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729306 */     // MIs[0] policy
     /* 1729306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729316 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729340 */     // GIR_Coverage, 10764,
     /* 1729340 */     GIR_EraseRootFromParent_Done,
     /* 1729341 */   // Label 23594: @1729341
     /* 1729341 */   GIM_Try, /*On fail goto*//*Label 23595*/ GIMT_Encode4(1729427), // Rule ID 10765 //
     /* 1729346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1729357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1729360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1729363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1729369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729392 */     // MIs[0] policy
     /* 1729392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729402 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1729423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729426 */     // GIR_Coverage, 10765,
     /* 1729426 */     GIR_EraseRootFromParent_Done,
     /* 1729427 */   // Label 23595: @1729427
     /* 1729427 */   GIM_Try, /*On fail goto*//*Label 23596*/ GIMT_Encode4(1729513), // Rule ID 10768 //
     /* 1729432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1729443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1729446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1729449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729478 */     // MIs[0] policy
     /* 1729478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729488 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1729491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729512 */     // GIR_Coverage, 10768,
     /* 1729512 */     GIR_EraseRootFromParent_Done,
     /* 1729513 */   // Label 23596: @1729513
     /* 1729513 */   GIM_Try, /*On fail goto*//*Label 23597*/ GIMT_Encode4(1729599), // Rule ID 10769 //
     /* 1729518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1729529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1729532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1729535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729564 */     // MIs[0] policy
     /* 1729564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729574 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF4_MASK),
     /* 1729577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729598 */     // GIR_Coverage, 10769,
     /* 1729598 */     GIR_EraseRootFromParent_Done,
     /* 1729599 */   // Label 23597: @1729599
     /* 1729599 */   GIM_Try, /*On fail goto*//*Label 23598*/ GIMT_Encode4(1729685), // Rule ID 10772 //
     /* 1729604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729650 */     // MIs[0] policy
     /* 1729650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729660 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729684 */     // GIR_Coverage, 10772,
     /* 1729684 */     GIR_EraseRootFromParent_Done,
     /* 1729685 */   // Label 23598: @1729685
     /* 1729685 */   GIM_Try, /*On fail goto*//*Label 23599*/ GIMT_Encode4(1729771), // Rule ID 10773 //
     /* 1729690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1729701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1729704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1729707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1729713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729736 */     // MIs[0] policy
     /* 1729736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729746 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1729767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729770 */     // GIR_Coverage, 10773,
     /* 1729770 */     GIR_EraseRootFromParent_Done,
     /* 1729771 */   // Label 23599: @1729771
     /* 1729771 */   GIM_Try, /*On fail goto*//*Label 23600*/ GIMT_Encode4(1729857), // Rule ID 10776 //
     /* 1729776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729822 */     // MIs[0] policy
     /* 1729822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729832 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1729832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729856 */     // GIR_Coverage, 10776,
     /* 1729856 */     GIR_EraseRootFromParent_Done,
     /* 1729857 */   // Label 23600: @1729857
     /* 1729857 */   GIM_Try, /*On fail goto*//*Label 23601*/ GIMT_Encode4(1729943), // Rule ID 10777 //
     /* 1729862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1729865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1729873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1729876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1729879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1729882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1729885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1729888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729908 */     // MIs[0] policy
     /* 1729908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1729918 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1729918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_MF2_MASK),
     /* 1729921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1729923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1729925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1729927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1729929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1729931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1729936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1729939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1729941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1729942 */     // GIR_Coverage, 10777,
     /* 1729942 */     GIR_EraseRootFromParent_Done,
     /* 1729943 */   // Label 23601: @1729943
     /* 1729943 */   GIM_Try, /*On fail goto*//*Label 23602*/ GIMT_Encode4(1730029), // Rule ID 10780 //
     /* 1729948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1729951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1729956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1729959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1729962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1729965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1729968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1729971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1729974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1729978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1729986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1729990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1729994 */     // MIs[0] policy
     /* 1729994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1729997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730028 */     // GIR_Coverage, 10780,
     /* 1730028 */     GIR_EraseRootFromParent_Done,
     /* 1730029 */   // Label 23602: @1730029
     /* 1730029 */   GIM_Try, /*On fail goto*//*Label 23603*/ GIMT_Encode4(1730115), // Rule ID 10781 //
     /* 1730034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1730045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1730048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1730051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1730057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730080 */     // MIs[0] policy
     /* 1730080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730090 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11346:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730114 */     // GIR_Coverage, 10781,
     /* 1730114 */     GIR_EraseRootFromParent_Done,
     /* 1730115 */   // Label 23603: @1730115
     /* 1730115 */   GIM_Try, /*On fail goto*//*Label 23604*/ GIMT_Encode4(1730201), // Rule ID 10784 //
     /* 1730120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1730131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1730134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1730137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730166 */     // MIs[0] policy
     /* 1730166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730176 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730200 */     // GIR_Coverage, 10784,
     /* 1730200 */     GIR_EraseRootFromParent_Done,
     /* 1730201 */   // Label 23604: @1730201
     /* 1730201 */   GIM_Try, /*On fail goto*//*Label 23605*/ GIMT_Encode4(1730287), // Rule ID 10785 //
     /* 1730206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1730217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1730220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1730223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1730229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730252 */     // MIs[0] policy
     /* 1730252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730262 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11346:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1730283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730286 */     // GIR_Coverage, 10785,
     /* 1730286 */     GIR_EraseRootFromParent_Done,
     /* 1730287 */   // Label 23605: @1730287
     /* 1730287 */   GIM_Try, /*On fail goto*//*Label 23606*/ GIMT_Encode4(1730373), // Rule ID 10788 //
     /* 1730292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1730303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1730306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1730309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730338 */     // MIs[0] policy
     /* 1730338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730348 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730372 */     // GIR_Coverage, 10788,
     /* 1730372 */     GIR_EraseRootFromParent_Done,
     /* 1730373 */   // Label 23606: @1730373
     /* 1730373 */   GIM_Try, /*On fail goto*//*Label 23607*/ GIMT_Encode4(1730459), // Rule ID 10789 //
     /* 1730378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1730389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1730392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1730395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1730401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730424 */     // MIs[0] policy
     /* 1730424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730434 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11346:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1730455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730458 */     // GIR_Coverage, 10789,
     /* 1730458 */     GIR_EraseRootFromParent_Done,
     /* 1730459 */   // Label 23607: @1730459
     /* 1730459 */   GIM_Try, /*On fail goto*//*Label 23608*/ GIMT_Encode4(1730545), // Rule ID 10792 //
     /* 1730464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1730467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1730475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1730478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1730481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730510 */     // MIs[0] policy
     /* 1730510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730520 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730544 */     // GIR_Coverage, 10792,
     /* 1730544 */     GIR_EraseRootFromParent_Done,
     /* 1730545 */   // Label 23608: @1730545
     /* 1730545 */   GIM_Try, /*On fail goto*//*Label 23609*/ GIMT_Encode4(1730631), // Rule ID 10793 //
     /* 1730550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1730553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1730561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1730564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1730567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1730573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1730580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1730588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730596 */     // MIs[0] policy
     /* 1730596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730606 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11346:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M1_MASK),
     /* 1730609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1730627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730630 */     // GIR_Coverage, 10793,
     /* 1730630 */     GIR_EraseRootFromParent_Done,
     /* 1730631 */   // Label 23609: @1730631
     /* 1730631 */   GIM_Try, /*On fail goto*//*Label 23610*/ GIMT_Encode4(1730717), // Rule ID 10796 //
     /* 1730636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730682 */     // MIs[0] policy
     /* 1730682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730692 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1730695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730716 */     // GIR_Coverage, 10796,
     /* 1730716 */     GIR_EraseRootFromParent_Done,
     /* 1730717 */   // Label 23610: @1730717
     /* 1730717 */   GIM_Try, /*On fail goto*//*Label 23611*/ GIMT_Encode4(1730803), // Rule ID 10797 //
     /* 1730722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1730733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1730736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1730739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1730745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1730752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1730760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730768 */     // MIs[0] policy
     /* 1730768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730778 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1730781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730802 */     // GIR_Coverage, 10797,
     /* 1730802 */     GIR_EraseRootFromParent_Done,
     /* 1730803 */   // Label 23611: @1730803
     /* 1730803 */   GIM_Try, /*On fail goto*//*Label 23612*/ GIMT_Encode4(1730889), // Rule ID 10800 //
     /* 1730808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1730828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1730834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730854 */     // MIs[0] policy
     /* 1730854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730864 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1730864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1730867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730888 */     // GIR_Coverage, 10800,
     /* 1730888 */     GIR_EraseRootFromParent_Done,
     /* 1730889 */   // Label 23612: @1730889
     /* 1730889 */   GIM_Try, /*On fail goto*//*Label 23613*/ GIMT_Encode4(1730975), // Rule ID 10801 //
     /* 1730894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1730897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1730905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1730908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1730911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1730914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1730917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1730920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1730924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1730932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1730936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1730940 */     // MIs[0] policy
     /* 1730940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1730943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1730950 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1730950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1730953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1730955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1730957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1730959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1730961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1730963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1730968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1730971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1730973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1730974 */     // GIR_Coverage, 10801,
     /* 1730974 */     GIR_EraseRootFromParent_Done,
     /* 1730975 */   // Label 23613: @1730975
     /* 1730975 */   GIM_Try, /*On fail goto*//*Label 23614*/ GIMT_Encode4(1731061), // Rule ID 10804 //
     /* 1730980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1730983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1730988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1730991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1730994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1730997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731026 */     // MIs[0] policy
     /* 1731026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731036 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1731039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731060 */     // GIR_Coverage, 10804,
     /* 1731060 */     GIR_EraseRootFromParent_Done,
     /* 1731061 */   // Label 23614: @1731061
     /* 1731061 */   GIM_Try, /*On fail goto*//*Label 23615*/ GIMT_Encode4(1731147), // Rule ID 10805 //
     /* 1731066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1731077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1731080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1731083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1731089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731112 */     // MIs[0] policy
     /* 1731112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731122 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1731125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1731143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731146 */     // GIR_Coverage, 10805,
     /* 1731146 */     GIR_EraseRootFromParent_Done,
     /* 1731147 */   // Label 23615: @1731147
     /* 1731147 */   GIM_Try, /*On fail goto*//*Label 23616*/ GIMT_Encode4(1731233), // Rule ID 10808 //
     /* 1731152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1731163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1731166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1731169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731198 */     // MIs[0] policy
     /* 1731198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731208 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1731211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731232 */     // GIR_Coverage, 10808,
     /* 1731232 */     GIR_EraseRootFromParent_Done,
     /* 1731233 */   // Label 23616: @1731233
     /* 1731233 */   GIM_Try, /*On fail goto*//*Label 23617*/ GIMT_Encode4(1731319), // Rule ID 10809 //
     /* 1731238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1731249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1731252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1731255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731284 */     // MIs[0] policy
     /* 1731284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731294 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1731297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731318 */     // GIR_Coverage, 10809,
     /* 1731318 */     GIR_EraseRootFromParent_Done,
     /* 1731319 */   // Label 23617: @1731319
     /* 1731319 */   GIM_Try, /*On fail goto*//*Label 23618*/ GIMT_Encode4(1731405), // Rule ID 10812 //
     /* 1731324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1731335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1731338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1731341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731370 */     // MIs[0] policy
     /* 1731370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731380 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1731383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731404 */     // GIR_Coverage, 10812,
     /* 1731404 */     GIR_EraseRootFromParent_Done,
     /* 1731405 */   // Label 23618: @1731405
     /* 1731405 */   GIM_Try, /*On fail goto*//*Label 23619*/ GIMT_Encode4(1731491), // Rule ID 10813 //
     /* 1731410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1731421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1731424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1731427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1731433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731456 */     // MIs[0] policy
     /* 1731456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731466 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1731469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731490 */     // GIR_Coverage, 10813,
     /* 1731490 */     GIR_EraseRootFromParent_Done,
     /* 1731491 */   // Label 23619: @1731491
     /* 1731491 */   GIM_Try, /*On fail goto*//*Label 23620*/ GIMT_Encode4(1731577), // Rule ID 10816 //
     /* 1731496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1731507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1731510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1731513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731542 */     // MIs[0] policy
     /* 1731542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731552 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1731555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731576 */     // GIR_Coverage, 10816,
     /* 1731576 */     GIR_EraseRootFromParent_Done,
     /* 1731577 */   // Label 23620: @1731577
     /* 1731577 */   GIM_Try, /*On fail goto*//*Label 23621*/ GIMT_Encode4(1731663), // Rule ID 10817 //
     /* 1731582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1731593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1731596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1731599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1731605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1731612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1731620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731628 */     // MIs[0] policy
     /* 1731628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731638 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1731641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1731659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731662 */     // GIR_Coverage, 10817,
     /* 1731662 */     GIR_EraseRootFromParent_Done,
     /* 1731663 */   // Label 23621: @1731663
     /* 1731663 */   GIM_Try, /*On fail goto*//*Label 23622*/ GIMT_Encode4(1731749), // Rule ID 10820 //
     /* 1731668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731714 */     // MIs[0] policy
     /* 1731714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1731727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731748 */     // GIR_Coverage, 10820,
     /* 1731748 */     GIR_EraseRootFromParent_Done,
     /* 1731749 */   // Label 23622: @1731749
     /* 1731749 */   GIM_Try, /*On fail goto*//*Label 23623*/ GIMT_Encode4(1731835), // Rule ID 10821 //
     /* 1731754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1731765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1731768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1731771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1731777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1731784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1731792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731800 */     // MIs[0] policy
     /* 1731800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731810 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1731813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731834 */     // GIR_Coverage, 10821,
     /* 1731834 */     GIR_EraseRootFromParent_Done,
     /* 1731835 */   // Label 23623: @1731835
     /* 1731835 */   GIM_Try, /*On fail goto*//*Label 23624*/ GIMT_Encode4(1731921), // Rule ID 10824 //
     /* 1731840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1731843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1731860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1731866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731886 */     // MIs[0] policy
     /* 1731886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731896 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1731896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1731899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1731914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1731917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1731919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1731920 */     // GIR_Coverage, 10824,
     /* 1731920 */     GIR_EraseRootFromParent_Done,
     /* 1731921 */   // Label 23624: @1731921
     /* 1731921 */   GIM_Try, /*On fail goto*//*Label 23625*/ GIMT_Encode4(1732007), // Rule ID 10825 //
     /* 1731926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1731929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1731934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1731937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1731940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1731943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1731946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1731949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1731952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1731956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1731964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1731968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1731972 */     // MIs[0] policy
     /* 1731972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1731975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1731982 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1731982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1731985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1731987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1731989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1731991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1731993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1731995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732006 */     // GIR_Coverage, 10825,
     /* 1732006 */     GIR_EraseRootFromParent_Done,
     /* 1732007 */   // Label 23625: @1732007
     /* 1732007 */   GIM_Try, /*On fail goto*//*Label 23626*/ GIMT_Encode4(1732093), // Rule ID 10828 //
     /* 1732012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1732029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732058 */     // MIs[0] policy
     /* 1732058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732068 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1732071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732092 */     // GIR_Coverage, 10828,
     /* 1732092 */     GIR_EraseRootFromParent_Done,
     /* 1732093 */   // Label 23626: @1732093
     /* 1732093 */   GIM_Try, /*On fail goto*//*Label 23627*/ GIMT_Encode4(1732179), // Rule ID 10829 //
     /* 1732098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1732109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1732112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1732115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1732121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732144 */     // MIs[0] policy
     /* 1732144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732154 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1732157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1732175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732178 */     // GIR_Coverage, 10829,
     /* 1732178 */     GIR_EraseRootFromParent_Done,
     /* 1732179 */   // Label 23627: @1732179
     /* 1732179 */   GIM_Try, /*On fail goto*//*Label 23628*/ GIMT_Encode4(1732265), // Rule ID 10832 //
     /* 1732184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1732195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1732198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1732201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732230 */     // MIs[0] policy
     /* 1732230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1732243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732264 */     // GIR_Coverage, 10832,
     /* 1732264 */     GIR_EraseRootFromParent_Done,
     /* 1732265 */   // Label 23628: @1732265
     /* 1732265 */   GIM_Try, /*On fail goto*//*Label 23629*/ GIMT_Encode4(1732351), // Rule ID 10833 //
     /* 1732270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1732281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1732284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1732287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1732300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1732308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732316 */     // MIs[0] policy
     /* 1732316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732326 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11346:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M2_MASK),
     /* 1732329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732350 */     // GIR_Coverage, 10833,
     /* 1732350 */     GIR_EraseRootFromParent_Done,
     /* 1732351 */   // Label 23629: @1732351
     /* 1732351 */   GIM_Try, /*On fail goto*//*Label 23630*/ GIMT_Encode4(1732437), // Rule ID 10836 //
     /* 1732356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1732367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1732370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1732373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732402 */     // MIs[0] policy
     /* 1732402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732412 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1732415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732436 */     // GIR_Coverage, 10836,
     /* 1732436 */     GIR_EraseRootFromParent_Done,
     /* 1732437 */   // Label 23630: @1732437
     /* 1732437 */   GIM_Try, /*On fail goto*//*Label 23631*/ GIMT_Encode4(1732523), // Rule ID 10837 //
     /* 1732442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1732453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1732456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1732459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1732465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1732472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1732480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732488 */     // MIs[0] policy
     /* 1732488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732498 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11346:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M4_MASK),
     /* 1732501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732522 */     // GIR_Coverage, 10837,
     /* 1732522 */     GIR_EraseRootFromParent_Done,
     /* 1732523 */   // Label 23631: @1732523
     /* 1732523 */   GIM_Try, /*On fail goto*//*Label 23632*/ GIMT_Encode4(1732609), // Rule ID 10840 //
     /* 1732528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1732531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1732548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732574 */     // MIs[0] policy
     /* 1732574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732584 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1732587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732608 */     // GIR_Coverage, 10840,
     /* 1732608 */     GIR_EraseRootFromParent_Done,
     /* 1732609 */   // Label 23632: @1732609
     /* 1732609 */   GIM_Try, /*On fail goto*//*Label 23633*/ GIMT_Encode4(1732695), // Rule ID 10841 //
     /* 1732614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1732617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmax_mask),
     /* 1732622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1732625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1732628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1732631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1732634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1732637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1732644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1732652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1732656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732660 */     // MIs[0] policy
     /* 1732660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732670 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11346:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMAX_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VX_M8_MASK),
     /* 1732673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1732691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732694 */     // GIR_Coverage, 10841,
     /* 1732694 */     GIR_EraseRootFromParent_Done,
     /* 1732695 */   // Label 23633: @1732695
     /* 1732695 */   GIM_Try, /*On fail goto*//*Label 23634*/ GIMT_Encode4(1732781), // Rule ID 10844 //
     /* 1732700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1732708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732746 */     // MIs[0] policy
     /* 1732746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1732759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732780 */     // GIR_Coverage, 10844,
     /* 1732780 */     GIR_EraseRootFromParent_Done,
     /* 1732781 */   // Label 23634: @1732781
     /* 1732781 */   GIM_Try, /*On fail goto*//*Label 23635*/ GIMT_Encode4(1732867), // Rule ID 10845 //
     /* 1732786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1732794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1732797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1732800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1732803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1732806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1732809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732832 */     // MIs[0] policy
     /* 1732832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732842 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1732842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF8_MASK),
     /* 1732845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732866 */     // GIR_Coverage, 10845,
     /* 1732866 */     GIR_EraseRootFromParent_Done,
     /* 1732867 */   // Label 23635: @1732867
     /* 1732867 */   GIM_Try, /*On fail goto*//*Label 23636*/ GIMT_Encode4(1732953), // Rule ID 10848 //
     /* 1732872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1732875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1732880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1732898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1732918 */     // MIs[0] policy
     /* 1732918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1732921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1732928 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1732928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1732931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1732933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1732935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1732937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1732939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1732941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1732946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1732949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1732951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1732952 */     // GIR_Coverage, 10848,
     /* 1732952 */     GIR_EraseRootFromParent_Done,
     /* 1732953 */   // Label 23636: @1732953
     /* 1732953 */   GIM_Try, /*On fail goto*//*Label 23637*/ GIMT_Encode4(1733039), // Rule ID 10849 //
     /* 1732958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1732961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1732966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1732969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1732972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1732975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1732978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1732981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1732984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1732988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1732996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733004 */     // MIs[0] policy
     /* 1733004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733014 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1733017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733038 */     // GIR_Coverage, 10849,
     /* 1733038 */     GIR_EraseRootFromParent_Done,
     /* 1733039 */   // Label 23637: @1733039
     /* 1733039 */   GIM_Try, /*On fail goto*//*Label 23638*/ GIMT_Encode4(1733125), // Rule ID 10852 //
     /* 1733044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1733055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1733058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1733061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1733064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733090 */     // MIs[0] policy
     /* 1733090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733100 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733124 */     // GIR_Coverage, 10852,
     /* 1733124 */     GIR_EraseRootFromParent_Done,
     /* 1733125 */   // Label 23638: @1733125
     /* 1733125 */   GIM_Try, /*On fail goto*//*Label 23639*/ GIMT_Encode4(1733211), // Rule ID 10853 //
     /* 1733130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1733141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1733144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1733147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1733150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733176 */     // MIs[0] policy
     /* 1733176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733186 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733210 */     // GIR_Coverage, 10853,
     /* 1733210 */     GIR_EraseRootFromParent_Done,
     /* 1733211 */   // Label 23639: @1733211
     /* 1733211 */   GIM_Try, /*On fail goto*//*Label 23640*/ GIMT_Encode4(1733297), // Rule ID 10856 //
     /* 1733216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1733227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1733230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1733233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1733236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733262 */     // MIs[0] policy
     /* 1733262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733272 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1733275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733296 */     // GIR_Coverage, 10856,
     /* 1733296 */     GIR_EraseRootFromParent_Done,
     /* 1733297 */   // Label 23640: @1733297
     /* 1733297 */   GIM_Try, /*On fail goto*//*Label 23641*/ GIMT_Encode4(1733383), // Rule ID 10857 //
     /* 1733302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1733313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1733316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1733319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1733322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733348 */     // MIs[0] policy
     /* 1733348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733358 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF4_MASK),
     /* 1733361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733382 */     // GIR_Coverage, 10857,
     /* 1733382 */     GIR_EraseRootFromParent_Done,
     /* 1733383 */   // Label 23641: @1733383
     /* 1733383 */   GIM_Try, /*On fail goto*//*Label 23642*/ GIMT_Encode4(1733469), // Rule ID 10860 //
     /* 1733388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1733399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1733402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1733405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1733408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733434 */     // MIs[0] policy
     /* 1733434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733444 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733468 */     // GIR_Coverage, 10860,
     /* 1733468 */     GIR_EraseRootFromParent_Done,
     /* 1733469 */   // Label 23642: @1733469
     /* 1733469 */   GIM_Try, /*On fail goto*//*Label 23643*/ GIMT_Encode4(1733555), // Rule ID 10861 //
     /* 1733474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1733485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1733488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1733491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1733494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1733497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733520 */     // MIs[0] policy
     /* 1733520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733530 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733554 */     // GIR_Coverage, 10861,
     /* 1733554 */     GIR_EraseRootFromParent_Done,
     /* 1733555 */   // Label 23643: @1733555
     /* 1733555 */   GIM_Try, /*On fail goto*//*Label 23644*/ GIMT_Encode4(1733641), // Rule ID 10864 //
     /* 1733560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733606 */     // MIs[0] policy
     /* 1733606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733616 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733640 */     // GIR_Coverage, 10864,
     /* 1733640 */     GIR_EraseRootFromParent_Done,
     /* 1733641 */   // Label 23644: @1733641
     /* 1733641 */   GIM_Try, /*On fail goto*//*Label 23645*/ GIMT_Encode4(1733727), // Rule ID 10865 //
     /* 1733646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1733657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1733660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1733663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1733666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1733669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733692 */     // MIs[0] policy
     /* 1733692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733702 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_MF2_MASK),
     /* 1733705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1733723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733726 */     // GIR_Coverage, 10865,
     /* 1733726 */     GIR_EraseRootFromParent_Done,
     /* 1733727 */   // Label 23645: @1733727
     /* 1733727 */   GIM_Try, /*On fail goto*//*Label 23646*/ GIMT_Encode4(1733813), // Rule ID 10868 //
     /* 1733732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733778 */     // MIs[0] policy
     /* 1733778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733788 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1733791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733812 */     // GIR_Coverage, 10868,
     /* 1733812 */     GIR_EraseRootFromParent_Done,
     /* 1733813 */   // Label 23646: @1733813
     /* 1733813 */   GIM_Try, /*On fail goto*//*Label 23647*/ GIMT_Encode4(1733899), // Rule ID 10869 //
     /* 1733818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1733829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1733832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1733835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1733838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1733841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1733844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733864 */     // MIs[0] policy
     /* 1733864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733874 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1733874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1733877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1733895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733898 */     // GIR_Coverage, 10869,
     /* 1733898 */     GIR_EraseRootFromParent_Done,
     /* 1733899 */   // Label 23647: @1733899
     /* 1733899 */   GIM_Try, /*On fail goto*//*Label 23648*/ GIMT_Encode4(1733985), // Rule ID 10872 //
     /* 1733904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1733907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1733915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1733918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1733921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1733924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1733927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1733930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1733934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1733946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1733950 */     // MIs[0] policy
     /* 1733950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1733953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1733960 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1733960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1733963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1733965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1733967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1733969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1733971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1733973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1733978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1733981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1733983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1733984 */     // GIR_Coverage, 10872,
     /* 1733984 */     GIR_EraseRootFromParent_Done,
     /* 1733985 */   // Label 23648: @1733985
     /* 1733985 */   GIM_Try, /*On fail goto*//*Label 23649*/ GIMT_Encode4(1734071), // Rule ID 10873 //
     /* 1733990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1733993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1733998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1734001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1734004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1734007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1734010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1734013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734036 */     // MIs[0] policy
     /* 1734036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734046 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1734049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1734067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734070 */     // GIR_Coverage, 10873,
     /* 1734070 */     GIR_EraseRootFromParent_Done,
     /* 1734071 */   // Label 23649: @1734071
     /* 1734071 */   GIM_Try, /*On fail goto*//*Label 23650*/ GIMT_Encode4(1734157), // Rule ID 10876 //
     /* 1734076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1734087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1734090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1734093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1734096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734122 */     // MIs[0] policy
     /* 1734122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734132 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1734135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734156 */     // GIR_Coverage, 10876,
     /* 1734156 */     GIR_EraseRootFromParent_Done,
     /* 1734157 */   // Label 23650: @1734157
     /* 1734157 */   GIM_Try, /*On fail goto*//*Label 23651*/ GIMT_Encode4(1734243), // Rule ID 10877 //
     /* 1734162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1734173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1734176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1734179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1734182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1734185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734208 */     // MIs[0] policy
     /* 1734208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734218 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1734221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1734239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734242 */     // GIR_Coverage, 10877,
     /* 1734242 */     GIR_EraseRootFromParent_Done,
     /* 1734243 */   // Label 23651: @1734243
     /* 1734243 */   GIM_Try, /*On fail goto*//*Label 23652*/ GIMT_Encode4(1734329), // Rule ID 10880 //
     /* 1734248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1734251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1734259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1734262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1734265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1734268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734294 */     // MIs[0] policy
     /* 1734294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734304 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1734307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1734325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734328 */     // GIR_Coverage, 10880,
     /* 1734328 */     GIR_EraseRootFromParent_Done,
     /* 1734329 */   // Label 23652: @1734329
     /* 1734329 */   GIM_Try, /*On fail goto*//*Label 23653*/ GIMT_Encode4(1734415), // Rule ID 10881 //
     /* 1734334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1734337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1734345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1734348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1734351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1734354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1734357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1734364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1734376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734380 */     // MIs[0] policy
     /* 1734380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734390 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M1_MASK),
     /* 1734393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1734411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734414 */     // GIR_Coverage, 10881,
     /* 1734414 */     GIR_EraseRootFromParent_Done,
     /* 1734415 */   // Label 23653: @1734415
     /* 1734415 */   GIM_Try, /*On fail goto*//*Label 23654*/ GIMT_Encode4(1734501), // Rule ID 10884 //
     /* 1734420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1734431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1734434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1734437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1734440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734466 */     // MIs[0] policy
     /* 1734466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734476 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1734479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734500 */     // GIR_Coverage, 10884,
     /* 1734500 */     GIR_EraseRootFromParent_Done,
     /* 1734501 */   // Label 23654: @1734501
     /* 1734501 */   GIM_Try, /*On fail goto*//*Label 23655*/ GIMT_Encode4(1734587), // Rule ID 10885 //
     /* 1734506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1734517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1734520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1734523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1734526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1734529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734552 */     // MIs[0] policy
     /* 1734552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734562 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1734565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734586 */     // GIR_Coverage, 10885,
     /* 1734586 */     GIR_EraseRootFromParent_Done,
     /* 1734587 */   // Label 23655: @1734587
     /* 1734587 */   GIM_Try, /*On fail goto*//*Label 23656*/ GIMT_Encode4(1734673), // Rule ID 10888 //
     /* 1734592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734638 */     // MIs[0] policy
     /* 1734638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734648 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1734651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734672 */     // GIR_Coverage, 10888,
     /* 1734672 */     GIR_EraseRootFromParent_Done,
     /* 1734673 */   // Label 23656: @1734673
     /* 1734673 */   GIM_Try, /*On fail goto*//*Label 23657*/ GIMT_Encode4(1734759), // Rule ID 10889 //
     /* 1734678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1734689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1734692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1734695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1734698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1734701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1734708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1734720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734724 */     // MIs[0] policy
     /* 1734724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734734 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1734737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734758 */     // GIR_Coverage, 10889,
     /* 1734758 */     GIR_EraseRootFromParent_Done,
     /* 1734759 */   // Label 23657: @1734759
     /* 1734759 */   GIM_Try, /*On fail goto*//*Label 23658*/ GIMT_Encode4(1734845), // Rule ID 10892 //
     /* 1734764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734810 */     // MIs[0] policy
     /* 1734810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734820 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1734823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734844 */     // GIR_Coverage, 10892,
     /* 1734844 */     GIR_EraseRootFromParent_Done,
     /* 1734845 */   // Label 23658: @1734845
     /* 1734845 */   GIM_Try, /*On fail goto*//*Label 23659*/ GIMT_Encode4(1734931), // Rule ID 10893 //
     /* 1734850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1734853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1734861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1734864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1734867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1734870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1734873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1734876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1734880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1734892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734896 */     // MIs[0] policy
     /* 1734896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734906 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1734906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1734909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1734915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1734917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1734919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1734924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1734927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1734929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1734930 */     // GIR_Coverage, 10893,
     /* 1734930 */     GIR_EraseRootFromParent_Done,
     /* 1734931 */   // Label 23659: @1734931
     /* 1734931 */   GIM_Try, /*On fail goto*//*Label 23660*/ GIMT_Encode4(1735017), // Rule ID 10896 //
     /* 1734936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1734939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1734944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1734947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1734950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1734953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1734956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1734959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1734962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1734966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1734978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1734982 */     // MIs[0] policy
     /* 1734982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1734985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1734992 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1734992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1734995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1734997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1734999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735016 */     // GIR_Coverage, 10896,
     /* 1735016 */     GIR_EraseRootFromParent_Done,
     /* 1735017 */   // Label 23660: @1735017
     /* 1735017 */   GIM_Try, /*On fail goto*//*Label 23661*/ GIMT_Encode4(1735103), // Rule ID 10897 //
     /* 1735022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1735033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1735036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1735039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1735042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735068 */     // MIs[0] policy
     /* 1735068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735078 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1735081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735102 */     // GIR_Coverage, 10897,
     /* 1735102 */     GIR_EraseRootFromParent_Done,
     /* 1735103 */   // Label 23661: @1735103
     /* 1735103 */   GIM_Try, /*On fail goto*//*Label 23662*/ GIMT_Encode4(1735189), // Rule ID 10900 //
     /* 1735108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1735119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1735122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1735125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1735128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735154 */     // MIs[0] policy
     /* 1735154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735164 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1735167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735188 */     // GIR_Coverage, 10900,
     /* 1735188 */     GIR_EraseRootFromParent_Done,
     /* 1735189 */   // Label 23662: @1735189
     /* 1735189 */   GIM_Try, /*On fail goto*//*Label 23663*/ GIMT_Encode4(1735275), // Rule ID 10901 //
     /* 1735194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1735205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1735208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1735211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1735214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735240 */     // MIs[0] policy
     /* 1735240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735250 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1735253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735274 */     // GIR_Coverage, 10901,
     /* 1735274 */     GIR_EraseRootFromParent_Done,
     /* 1735275 */   // Label 23663: @1735275
     /* 1735275 */   GIM_Try, /*On fail goto*//*Label 23664*/ GIMT_Encode4(1735361), // Rule ID 10904 //
     /* 1735280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1735291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1735294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1735297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1735300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735326 */     // MIs[0] policy
     /* 1735326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735336 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1735339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735360 */     // GIR_Coverage, 10904,
     /* 1735360 */     GIR_EraseRootFromParent_Done,
     /* 1735361 */   // Label 23664: @1735361
     /* 1735361 */   GIM_Try, /*On fail goto*//*Label 23665*/ GIMT_Encode4(1735447), // Rule ID 10905 //
     /* 1735366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1735377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1735380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1735383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1735386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1735389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735412 */     // MIs[0] policy
     /* 1735412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735422 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1735425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1735443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735446 */     // GIR_Coverage, 10905,
     /* 1735446 */     GIR_EraseRootFromParent_Done,
     /* 1735447 */   // Label 23665: @1735447
     /* 1735447 */   GIM_Try, /*On fail goto*//*Label 23666*/ GIMT_Encode4(1735533), // Rule ID 10908 //
     /* 1735452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1735463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1735466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1735469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1735472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735498 */     // MIs[0] policy
     /* 1735498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1735511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735532 */     // GIR_Coverage, 10908,
     /* 1735532 */     GIR_EraseRootFromParent_Done,
     /* 1735533 */   // Label 23666: @1735533
     /* 1735533 */   GIM_Try, /*On fail goto*//*Label 23667*/ GIMT_Encode4(1735619), // Rule ID 10909 //
     /* 1735538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1735549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1735552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1735555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1735558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1735561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1735580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735584 */     // MIs[0] policy
     /* 1735584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735594 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1735597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735618 */     // GIR_Coverage, 10909,
     /* 1735618 */     GIR_EraseRootFromParent_Done,
     /* 1735619 */   // Label 23667: @1735619
     /* 1735619 */   GIM_Try, /*On fail goto*//*Label 23668*/ GIMT_Encode4(1735705), // Rule ID 10912 //
     /* 1735624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735670 */     // MIs[0] policy
     /* 1735670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735680 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1735683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735704 */     // GIR_Coverage, 10912,
     /* 1735704 */     GIR_EraseRootFromParent_Done,
     /* 1735705 */   // Label 23668: @1735705
     /* 1735705 */   GIM_Try, /*On fail goto*//*Label 23669*/ GIMT_Encode4(1735791), // Rule ID 10913 //
     /* 1735710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1735721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1735724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1735727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1735730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1735733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1735740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1735752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735756 */     // MIs[0] policy
     /* 1735756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735766 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1735769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735790 */     // GIR_Coverage, 10913,
     /* 1735790 */     GIR_EraseRootFromParent_Done,
     /* 1735791 */   // Label 23669: @1735791
     /* 1735791 */   GIM_Try, /*On fail goto*//*Label 23670*/ GIMT_Encode4(1735877), // Rule ID 10916 //
     /* 1735796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1735799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735842 */     // MIs[0] policy
     /* 1735842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735852 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1735852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1735855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735876 */     // GIR_Coverage, 10916,
     /* 1735876 */     GIR_EraseRootFromParent_Done,
     /* 1735877 */   // Label 23670: @1735877
     /* 1735877 */   GIM_Try, /*On fail goto*//*Label 23671*/ GIMT_Encode4(1735963), // Rule ID 10917 //
     /* 1735882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1735885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1735893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1735896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1735899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1735902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1735905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1735908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1735912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1735924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1735928 */     // MIs[0] policy
     /* 1735928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1735931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1735938 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1735938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1735941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1735943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1735945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1735947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1735949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1735951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1735956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1735959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1735961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1735962 */     // GIR_Coverage, 10917,
     /* 1735962 */     GIR_EraseRootFromParent_Done,
     /* 1735963 */   // Label 23671: @1735963
     /* 1735963 */   GIM_Try, /*On fail goto*//*Label 23672*/ GIMT_Encode4(1736049), // Rule ID 10920 //
     /* 1735968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1735971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1735976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1735979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1735982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1735985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1735988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1735991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1735994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1735998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736014 */     // MIs[0] policy
     /* 1736014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1736027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736048 */     // GIR_Coverage, 10920,
     /* 1736048 */     GIR_EraseRootFromParent_Done,
     /* 1736049 */   // Label 23672: @1736049
     /* 1736049 */   GIM_Try, /*On fail goto*//*Label 23673*/ GIMT_Encode4(1736135), // Rule ID 10921 //
     /* 1736054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1736065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1736068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1736071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1736074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1736084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1736096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736100 */     // MIs[0] policy
     /* 1736100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M2_MASK),
     /* 1736113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736134 */     // GIR_Coverage, 10921,
     /* 1736134 */     GIR_EraseRootFromParent_Done,
     /* 1736135 */   // Label 23673: @1736135
     /* 1736135 */   GIM_Try, /*On fail goto*//*Label 23674*/ GIMT_Encode4(1736221), // Rule ID 10924 //
     /* 1736140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1736151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1736154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1736157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1736160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736186 */     // MIs[0] policy
     /* 1736186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736196 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1736199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736220 */     // GIR_Coverage, 10924,
     /* 1736220 */     GIR_EraseRootFromParent_Done,
     /* 1736221 */   // Label 23674: @1736221
     /* 1736221 */   GIM_Try, /*On fail goto*//*Label 23675*/ GIMT_Encode4(1736307), // Rule ID 10925 //
     /* 1736226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1736237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1736240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1736243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1736246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1736256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1736268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736272 */     // MIs[0] policy
     /* 1736272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736282 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M4_MASK),
     /* 1736285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736306 */     // GIR_Coverage, 10925,
     /* 1736306 */     GIR_EraseRootFromParent_Done,
     /* 1736307 */   // Label 23675: @1736307
     /* 1736307 */   GIM_Try, /*On fail goto*//*Label 23676*/ GIMT_Encode4(1736393), // Rule ID 10928 //
     /* 1736312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1736315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1736323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1736326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1736329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1736332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736358 */     // MIs[0] policy
     /* 1736358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736368 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1736371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736392 */     // GIR_Coverage, 10928,
     /* 1736392 */     GIR_EraseRootFromParent_Done,
     /* 1736393 */   // Label 23676: @1736393
     /* 1736393 */   GIM_Try, /*On fail goto*//*Label 23677*/ GIMT_Encode4(1736479), // Rule ID 10929 //
     /* 1736398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1736401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1736409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1736412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1736415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1736418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1736421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1736428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1736440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736444 */     // MIs[0] policy
     /* 1736444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736454 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VV_M8_MASK),
     /* 1736457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1736475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736478 */     // GIR_Coverage, 10929,
     /* 1736478 */     GIR_EraseRootFromParent_Done,
     /* 1736479 */   // Label 23677: @1736479
     /* 1736479 */   GIM_Try, /*On fail goto*//*Label 23678*/ GIMT_Encode4(1736565), // Rule ID 10932 //
     /* 1736484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1736495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1736498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1736501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736530 */     // MIs[0] policy
     /* 1736530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736540 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1736543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736564 */     // GIR_Coverage, 10932,
     /* 1736564 */     GIR_EraseRootFromParent_Done,
     /* 1736565 */   // Label 23678: @1736565
     /* 1736565 */   GIM_Try, /*On fail goto*//*Label 23679*/ GIMT_Encode4(1736651), // Rule ID 10933 //
     /* 1736570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1736581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1736584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1736587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1736593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736616 */     // MIs[0] policy
     /* 1736616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736626 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF8_MASK),
     /* 1736629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736650 */     // GIR_Coverage, 10933,
     /* 1736650 */     GIR_EraseRootFromParent_Done,
     /* 1736651 */   // Label 23679: @1736651
     /* 1736651 */   GIM_Try, /*On fail goto*//*Label 23680*/ GIMT_Encode4(1736737), // Rule ID 10936 //
     /* 1736656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736702 */     // MIs[0] policy
     /* 1736702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736712 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1736715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736736 */     // GIR_Coverage, 10936,
     /* 1736736 */     GIR_EraseRootFromParent_Done,
     /* 1736737 */   // Label 23680: @1736737
     /* 1736737 */   GIM_Try, /*On fail goto*//*Label 23681*/ GIMT_Encode4(1736823), // Rule ID 10937 //
     /* 1736742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1736753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1736756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1736759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1736765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736788 */     // MIs[0] policy
     /* 1736788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736798 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1736801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736822 */     // GIR_Coverage, 10937,
     /* 1736822 */     GIR_EraseRootFromParent_Done,
     /* 1736823 */   // Label 23681: @1736823
     /* 1736823 */   GIM_Try, /*On fail goto*//*Label 23682*/ GIMT_Encode4(1736909), // Rule ID 10940 //
     /* 1736828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1736831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1736848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1736854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736874 */     // MIs[0] policy
     /* 1736874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736884 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1736884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1736887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736908 */     // GIR_Coverage, 10940,
     /* 1736908 */     GIR_EraseRootFromParent_Done,
     /* 1736909 */   // Label 23682: @1736909
     /* 1736909 */   GIM_Try, /*On fail goto*//*Label 23683*/ GIMT_Encode4(1736995), // Rule ID 10941 //
     /* 1736914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1736917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1736922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1736925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1736928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1736931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1736934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1736937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1736940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1736944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1736952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1736956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1736960 */     // MIs[0] policy
     /* 1736960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1736963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1736970 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1736970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1736973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1736975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1736977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1736979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1736981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1736983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1736988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1736991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1736993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1736994 */     // GIR_Coverage, 10941,
     /* 1736994 */     GIR_EraseRootFromParent_Done,
     /* 1736995 */   // Label 23683: @1736995
     /* 1736995 */   GIM_Try, /*On fail goto*//*Label 23684*/ GIMT_Encode4(1737081), // Rule ID 10944 //
     /* 1737000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737046 */     // MIs[0] policy
     /* 1737046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737056 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1737059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737080 */     // GIR_Coverage, 10944,
     /* 1737080 */     GIR_EraseRootFromParent_Done,
     /* 1737081 */   // Label 23684: @1737081
     /* 1737081 */   GIM_Try, /*On fail goto*//*Label 23685*/ GIMT_Encode4(1737167), // Rule ID 10945 //
     /* 1737086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1737097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1737100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1737103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737132 */     // MIs[0] policy
     /* 1737132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737142 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF4_MASK),
     /* 1737145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737166 */     // GIR_Coverage, 10945,
     /* 1737166 */     GIR_EraseRootFromParent_Done,
     /* 1737167 */   // Label 23685: @1737167
     /* 1737167 */   GIM_Try, /*On fail goto*//*Label 23686*/ GIMT_Encode4(1737253), // Rule ID 10948 //
     /* 1737172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1737183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1737186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1737189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737218 */     // MIs[0] policy
     /* 1737218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737228 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1737231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737252 */     // GIR_Coverage, 10948,
     /* 1737252 */     GIR_EraseRootFromParent_Done,
     /* 1737253 */   // Label 23686: @1737253
     /* 1737253 */   GIM_Try, /*On fail goto*//*Label 23687*/ GIMT_Encode4(1737339), // Rule ID 10949 //
     /* 1737258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1737269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1737272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1737275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737304 */     // MIs[0] policy
     /* 1737304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737314 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1737317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737338 */     // GIR_Coverage, 10949,
     /* 1737338 */     GIR_EraseRootFromParent_Done,
     /* 1737339 */   // Label 23687: @1737339
     /* 1737339 */   GIM_Try, /*On fail goto*//*Label 23688*/ GIMT_Encode4(1737425), // Rule ID 10952 //
     /* 1737344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1737355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1737358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1737361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737390 */     // MIs[0] policy
     /* 1737390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737400 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1737403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737424 */     // GIR_Coverage, 10952,
     /* 1737424 */     GIR_EraseRootFromParent_Done,
     /* 1737425 */   // Label 23688: @1737425
     /* 1737425 */   GIM_Try, /*On fail goto*//*Label 23689*/ GIMT_Encode4(1737511), // Rule ID 10953 //
     /* 1737430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1737441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1737444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1737447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1737453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737476 */     // MIs[0] policy
     /* 1737476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737486 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_MF2_MASK),
     /* 1737489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737510 */     // GIR_Coverage, 10953,
     /* 1737510 */     GIR_EraseRootFromParent_Done,
     /* 1737511 */   // Label 23689: @1737511
     /* 1737511 */   GIM_Try, /*On fail goto*//*Label 23690*/ GIMT_Encode4(1737597), // Rule ID 10956 //
     /* 1737516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737562 */     // MIs[0] policy
     /* 1737562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737572 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1737575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737596 */     // GIR_Coverage, 10956,
     /* 1737596 */     GIR_EraseRootFromParent_Done,
     /* 1737597 */   // Label 23690: @1737597
     /* 1737597 */   GIM_Try, /*On fail goto*//*Label 23691*/ GIMT_Encode4(1737683), // Rule ID 10957 //
     /* 1737602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1737613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1737616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1737619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1737625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737648 */     // MIs[0] policy
     /* 1737648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737658 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11401:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1737661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1737679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737682 */     // GIR_Coverage, 10957,
     /* 1737682 */     GIR_EraseRootFromParent_Done,
     /* 1737683 */   // Label 23691: @1737683
     /* 1737683 */   GIM_Try, /*On fail goto*//*Label 23692*/ GIMT_Encode4(1737769), // Rule ID 10960 //
     /* 1737688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737734 */     // MIs[0] policy
     /* 1737734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737744 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1737747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737768 */     // GIR_Coverage, 10960,
     /* 1737768 */     GIR_EraseRootFromParent_Done,
     /* 1737769 */   // Label 23692: @1737769
     /* 1737769 */   GIM_Try, /*On fail goto*//*Label 23693*/ GIMT_Encode4(1737855), // Rule ID 10961 //
     /* 1737774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1737785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1737788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1737791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1737797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737820 */     // MIs[0] policy
     /* 1737820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737830 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11401:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1737830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1737833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1737851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737854 */     // GIR_Coverage, 10961,
     /* 1737854 */     GIR_EraseRootFromParent_Done,
     /* 1737855 */   // Label 23693: @1737855
     /* 1737855 */   GIM_Try, /*On fail goto*//*Label 23694*/ GIMT_Encode4(1737941), // Rule ID 10964 //
     /* 1737860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1737863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1737880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1737886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737906 */     // MIs[0] policy
     /* 1737906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1737916 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1737916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1737919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1737921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1737923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1737925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1737927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1737929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1737934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1737937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1737939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1737940 */     // GIR_Coverage, 10964,
     /* 1737940 */     GIR_EraseRootFromParent_Done,
     /* 1737941 */   // Label 23694: @1737941
     /* 1737941 */   GIM_Try, /*On fail goto*//*Label 23695*/ GIMT_Encode4(1738027), // Rule ID 10965 //
     /* 1737946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1737949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1737954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1737957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1737960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1737963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1737966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1737969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1737972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1737976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1737984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1737988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1737992 */     // MIs[0] policy
     /* 1737992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1737995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738002 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11401:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1738005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1738023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738026 */     // GIR_Coverage, 10965,
     /* 1738026 */     GIR_EraseRootFromParent_Done,
     /* 1738027 */   // Label 23695: @1738027
     /* 1738027 */   GIM_Try, /*On fail goto*//*Label 23696*/ GIMT_Encode4(1738113), // Rule ID 10968 //
     /* 1738032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1738035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1738043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1738046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1738049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738078 */     // MIs[0] policy
     /* 1738078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738088 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1738091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738112 */     // GIR_Coverage, 10968,
     /* 1738112 */     GIR_EraseRootFromParent_Done,
     /* 1738113 */   // Label 23696: @1738113
     /* 1738113 */   GIM_Try, /*On fail goto*//*Label 23697*/ GIMT_Encode4(1738199), // Rule ID 10969 //
     /* 1738118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1738121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1738129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1738132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1738135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1738141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1738148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1738156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738164 */     // MIs[0] policy
     /* 1738164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738174 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11401:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M1_MASK),
     /* 1738177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1738195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738198 */     // GIR_Coverage, 10969,
     /* 1738198 */     GIR_EraseRootFromParent_Done,
     /* 1738199 */   // Label 23697: @1738199
     /* 1738199 */   GIM_Try, /*On fail goto*//*Label 23698*/ GIMT_Encode4(1738285), // Rule ID 10972 //
     /* 1738204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1738215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1738218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1738221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738250 */     // MIs[0] policy
     /* 1738250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738260 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1738263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738284 */     // GIR_Coverage, 10972,
     /* 1738284 */     GIR_EraseRootFromParent_Done,
     /* 1738285 */   // Label 23698: @1738285
     /* 1738285 */   GIM_Try, /*On fail goto*//*Label 23699*/ GIMT_Encode4(1738371), // Rule ID 10973 //
     /* 1738290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1738301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1738304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1738307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738336 */     // MIs[0] policy
     /* 1738336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1738349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738370 */     // GIR_Coverage, 10973,
     /* 1738370 */     GIR_EraseRootFromParent_Done,
     /* 1738371 */   // Label 23699: @1738371
     /* 1738371 */   GIM_Try, /*On fail goto*//*Label 23700*/ GIMT_Encode4(1738457), // Rule ID 10976 //
     /* 1738376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1738387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1738390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1738393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738422 */     // MIs[0] policy
     /* 1738422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738432 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1738435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738456 */     // GIR_Coverage, 10976,
     /* 1738456 */     GIR_EraseRootFromParent_Done,
     /* 1738457 */   // Label 23700: @1738457
     /* 1738457 */   GIM_Try, /*On fail goto*//*Label 23701*/ GIMT_Encode4(1738543), // Rule ID 10977 //
     /* 1738462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1738473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1738476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1738479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1738485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738508 */     // MIs[0] policy
     /* 1738508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738518 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1738521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738542 */     // GIR_Coverage, 10977,
     /* 1738542 */     GIR_EraseRootFromParent_Done,
     /* 1738543 */   // Label 23701: @1738543
     /* 1738543 */   GIM_Try, /*On fail goto*//*Label 23702*/ GIMT_Encode4(1738629), // Rule ID 10980 //
     /* 1738548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738594 */     // MIs[0] policy
     /* 1738594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1738607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738628 */     // GIR_Coverage, 10980,
     /* 1738628 */     GIR_EraseRootFromParent_Done,
     /* 1738629 */   // Label 23702: @1738629
     /* 1738629 */   GIM_Try, /*On fail goto*//*Label 23703*/ GIMT_Encode4(1738715), // Rule ID 10981 //
     /* 1738634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1738645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1738648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1738651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1738657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1738664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1738672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738680 */     // MIs[0] policy
     /* 1738680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738690 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1738693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1738711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738714 */     // GIR_Coverage, 10981,
     /* 1738714 */     GIR_EraseRootFromParent_Done,
     /* 1738715 */   // Label 23703: @1738715
     /* 1738715 */   GIM_Try, /*On fail goto*//*Label 23704*/ GIMT_Encode4(1738801), // Rule ID 10984 //
     /* 1738720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738766 */     // MIs[0] policy
     /* 1738766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1738779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738800 */     // GIR_Coverage, 10984,
     /* 1738800 */     GIR_EraseRootFromParent_Done,
     /* 1738801 */   // Label 23704: @1738801
     /* 1738801 */   GIM_Try, /*On fail goto*//*Label 23705*/ GIMT_Encode4(1738887), // Rule ID 10985 //
     /* 1738806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1738817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1738820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1738823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1738829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1738832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1738836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1738844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738852 */     // MIs[0] policy
     /* 1738852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738862 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1738862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1738865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738886 */     // GIR_Coverage, 10985,
     /* 1738886 */     GIR_EraseRootFromParent_Done,
     /* 1738887 */   // Label 23705: @1738887
     /* 1738887 */   GIM_Try, /*On fail goto*//*Label 23706*/ GIMT_Encode4(1738973), // Rule ID 10988 //
     /* 1738892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1738895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1738912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1738915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1738918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1738922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1738930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1738934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1738938 */     // MIs[0] policy
     /* 1738938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1738941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1738948 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1738948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1738951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1738953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1738955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1738957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1738959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1738961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1738966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1738969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1738971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1738972 */     // GIR_Coverage, 10988,
     /* 1738972 */     GIR_EraseRootFromParent_Done,
     /* 1738973 */   // Label 23706: @1738973
     /* 1738973 */   GIM_Try, /*On fail goto*//*Label 23707*/ GIMT_Encode4(1739059), // Rule ID 10989 //
     /* 1738978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1738981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1738986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1738989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1738992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1738995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1738998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739024 */     // MIs[0] policy
     /* 1739024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739034 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1739037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739058 */     // GIR_Coverage, 10989,
     /* 1739058 */     GIR_EraseRootFromParent_Done,
     /* 1739059 */   // Label 23707: @1739059
     /* 1739059 */   GIM_Try, /*On fail goto*//*Label 23708*/ GIMT_Encode4(1739145), // Rule ID 10992 //
     /* 1739064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1739075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1739078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1739081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739110 */     // MIs[0] policy
     /* 1739110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739120 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1739123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739144 */     // GIR_Coverage, 10992,
     /* 1739144 */     GIR_EraseRootFromParent_Done,
     /* 1739145 */   // Label 23708: @1739145
     /* 1739145 */   GIM_Try, /*On fail goto*//*Label 23709*/ GIMT_Encode4(1739231), // Rule ID 10993 //
     /* 1739150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1739161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1739164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1739167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1739173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739196 */     // MIs[0] policy
     /* 1739196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739206 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1739209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1739227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739230 */     // GIR_Coverage, 10993,
     /* 1739230 */     GIR_EraseRootFromParent_Done,
     /* 1739231 */   // Label 23709: @1739231
     /* 1739231 */   GIM_Try, /*On fail goto*//*Label 23710*/ GIMT_Encode4(1739317), // Rule ID 10996 //
     /* 1739236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1739247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1739250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1739253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739282 */     // MIs[0] policy
     /* 1739282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739292 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1739295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739316 */     // GIR_Coverage, 10996,
     /* 1739316 */     GIR_EraseRootFromParent_Done,
     /* 1739317 */   // Label 23710: @1739317
     /* 1739317 */   GIM_Try, /*On fail goto*//*Label 23711*/ GIMT_Encode4(1739403), // Rule ID 10997 //
     /* 1739322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1739333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1739336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1739339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739368 */     // MIs[0] policy
     /* 1739368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739378 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1739381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739402 */     // GIR_Coverage, 10997,
     /* 1739402 */     GIR_EraseRootFromParent_Done,
     /* 1739403 */   // Label 23711: @1739403
     /* 1739403 */   GIM_Try, /*On fail goto*//*Label 23712*/ GIMT_Encode4(1739489), // Rule ID 11000 //
     /* 1739408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1739419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1739422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1739425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739454 */     // MIs[0] policy
     /* 1739454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739464 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1739467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739488 */     // GIR_Coverage, 11000,
     /* 1739488 */     GIR_EraseRootFromParent_Done,
     /* 1739489 */   // Label 23712: @1739489
     /* 1739489 */   GIM_Try, /*On fail goto*//*Label 23713*/ GIMT_Encode4(1739575), // Rule ID 11001 //
     /* 1739494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1739505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1739508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1739511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1739517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739540 */     // MIs[0] policy
     /* 1739540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739550 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1739553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739574 */     // GIR_Coverage, 11001,
     /* 1739574 */     GIR_EraseRootFromParent_Done,
     /* 1739575 */   // Label 23713: @1739575
     /* 1739575 */   GIM_Try, /*On fail goto*//*Label 23714*/ GIMT_Encode4(1739661), // Rule ID 11004 //
     /* 1739580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1739583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739626 */     // MIs[0] policy
     /* 1739626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739636 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1739639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739660 */     // GIR_Coverage, 11004,
     /* 1739660 */     GIR_EraseRootFromParent_Done,
     /* 1739661 */   // Label 23714: @1739661
     /* 1739661 */   GIM_Try, /*On fail goto*//*Label 23715*/ GIMT_Encode4(1739747), // Rule ID 11005 //
     /* 1739666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1739669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1739677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1739680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1739683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1739689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1739696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1739704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739712 */     // MIs[0] policy
     /* 1739712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739722 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1739725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1739743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739746 */     // GIR_Coverage, 11005,
     /* 1739746 */     GIR_EraseRootFromParent_Done,
     /* 1739747 */   // Label 23715: @1739747
     /* 1739747 */   GIM_Try, /*On fail goto*//*Label 23716*/ GIMT_Encode4(1739833), // Rule ID 11008 //
     /* 1739752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739798 */     // MIs[0] policy
     /* 1739798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1739811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739832 */     // GIR_Coverage, 11008,
     /* 1739832 */     GIR_EraseRootFromParent_Done,
     /* 1739833 */   // Label 23716: @1739833
     /* 1739833 */   GIM_Try, /*On fail goto*//*Label 23717*/ GIMT_Encode4(1739919), // Rule ID 11009 //
     /* 1739838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1739841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1739849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1739852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1739855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1739858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1739861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1739864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1739868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1739876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739884 */     // MIs[0] policy
     /* 1739884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11401:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1739894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M2_MASK),
     /* 1739897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1739915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1739917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1739918 */     // GIR_Coverage, 11009,
     /* 1739918 */     GIR_EraseRootFromParent_Done,
     /* 1739919 */   // Label 23717: @1739919
     /* 1739919 */   GIM_Try, /*On fail goto*//*Label 23718*/ GIMT_Encode4(1740005), // Rule ID 11012 //
     /* 1739924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1739927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1739932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1739935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1739938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1739941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1739944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1739947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1739950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1739954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1739962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1739966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1739970 */     // MIs[0] policy
     /* 1739970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1739973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1739980 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1739980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1739983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1739985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1739987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1739989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1739991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1739993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1739998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740004 */     // GIR_Coverage, 11012,
     /* 1740004 */     GIR_EraseRootFromParent_Done,
     /* 1740005 */   // Label 23718: @1740005
     /* 1740005 */   GIM_Try, /*On fail goto*//*Label 23719*/ GIMT_Encode4(1740091), // Rule ID 11013 //
     /* 1740010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1740021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1740024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1740027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1740040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1740048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740056 */     // MIs[0] policy
     /* 1740056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740066 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11401:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M4_MASK),
     /* 1740069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740090 */     // GIR_Coverage, 11013,
     /* 1740090 */     GIR_EraseRootFromParent_Done,
     /* 1740091 */   // Label 23719: @1740091
     /* 1740091 */   GIM_Try, /*On fail goto*//*Label 23720*/ GIMT_Encode4(1740177), // Rule ID 11016 //
     /* 1740096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1740099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1740107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1740110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1740113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1740116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740142 */     // MIs[0] policy
     /* 1740142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740152 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1740155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740176 */     // GIR_Coverage, 11016,
     /* 1740176 */     GIR_EraseRootFromParent_Done,
     /* 1740177 */   // Label 23720: @1740177
     /* 1740177 */   GIM_Try, /*On fail goto*//*Label 23721*/ GIMT_Encode4(1740263), // Rule ID 11017 //
     /* 1740182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1740185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmul_mask),
     /* 1740190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1740193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1740196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1740199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1740202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1740205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1740212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1740220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1740224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740228 */     // MIs[0] policy
     /* 1740228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740238 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11401:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMUL_VX_M8_MASK),
     /* 1740241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1740259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740262 */     // GIR_Coverage, 11017,
     /* 1740262 */     GIR_EraseRootFromParent_Done,
     /* 1740263 */   // Label 23721: @1740263
     /* 1740263 */   GIM_Try, /*On fail goto*//*Label 23722*/ GIMT_Encode4(1740349), // Rule ID 11020 //
     /* 1740268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1740279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1740282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1740285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1740288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740314 */     // MIs[0] policy
     /* 1740314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740324 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1740327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740348 */     // GIR_Coverage, 11020,
     /* 1740348 */     GIR_EraseRootFromParent_Done,
     /* 1740349 */   // Label 23722: @1740349
     /* 1740349 */   GIM_Try, /*On fail goto*//*Label 23723*/ GIMT_Encode4(1740435), // Rule ID 11021 //
     /* 1740354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1740365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1740368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1740371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1740374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740400 */     // MIs[0] policy
     /* 1740400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740410 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8_MASK),
     /* 1740413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740434 */     // GIR_Coverage, 11021,
     /* 1740434 */     GIR_EraseRootFromParent_Done,
     /* 1740435 */   // Label 23723: @1740435
     /* 1740435 */   GIM_Try, /*On fail goto*//*Label 23724*/ GIMT_Encode4(1740521), // Rule ID 11024 //
     /* 1740440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1740451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1740454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1740457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1740460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740486 */     // MIs[0] policy
     /* 1740486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740496 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1740499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740520 */     // GIR_Coverage, 11024,
     /* 1740520 */     GIR_EraseRootFromParent_Done,
     /* 1740521 */   // Label 23724: @1740521
     /* 1740521 */   GIM_Try, /*On fail goto*//*Label 23725*/ GIMT_Encode4(1740607), // Rule ID 11025 //
     /* 1740526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1740537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1740540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1740543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1740546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740572 */     // MIs[0] policy
     /* 1740572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740582 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1740585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740606 */     // GIR_Coverage, 11025,
     /* 1740606 */     GIR_EraseRootFromParent_Done,
     /* 1740607 */   // Label 23725: @1740607
     /* 1740607 */   GIM_Try, /*On fail goto*//*Label 23726*/ GIMT_Encode4(1740693), // Rule ID 11028 //
     /* 1740612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740658 */     // MIs[0] policy
     /* 1740658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740668 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1740671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740692 */     // GIR_Coverage, 11028,
     /* 1740692 */     GIR_EraseRootFromParent_Done,
     /* 1740693 */   // Label 23726: @1740693
     /* 1740693 */   GIM_Try, /*On fail goto*//*Label 23727*/ GIMT_Encode4(1740779), // Rule ID 11029 //
     /* 1740698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1740709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1740712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1740715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1740718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1740721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740744 */     // MIs[0] policy
     /* 1740744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1740757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1740775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740778 */     // GIR_Coverage, 11029,
     /* 1740778 */     GIR_EraseRootFromParent_Done,
     /* 1740779 */   // Label 23727: @1740779
     /* 1740779 */   GIM_Try, /*On fail goto*//*Label 23728*/ GIMT_Encode4(1740865), // Rule ID 11032 //
     /* 1740784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740830 */     // MIs[0] policy
     /* 1740830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740840 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1740840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1740843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740864 */     // GIR_Coverage, 11032,
     /* 1740864 */     GIR_EraseRootFromParent_Done,
     /* 1740865 */   // Label 23728: @1740865
     /* 1740865 */   GIM_Try, /*On fail goto*//*Label 23729*/ GIMT_Encode4(1740951), // Rule ID 11033 //
     /* 1740870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1740873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1740881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1740884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1740887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1740890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1740893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1740896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1740916 */     // MIs[0] policy
     /* 1740916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1740919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1740926 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1740926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4_MASK),
     /* 1740929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1740931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1740933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1740935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1740937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1740939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1740944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1740947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1740949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1740950 */     // GIR_Coverage, 11033,
     /* 1740950 */     GIR_EraseRootFromParent_Done,
     /* 1740951 */   // Label 23729: @1740951
     /* 1740951 */   GIM_Try, /*On fail goto*//*Label 23730*/ GIMT_Encode4(1741037), // Rule ID 11036 //
     /* 1740956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1740959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1740964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1740967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1740970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1740973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1740976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1740979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1740982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1740986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1740998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741002 */     // MIs[0] policy
     /* 1741002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741012 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1741015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741036 */     // GIR_Coverage, 11036,
     /* 1741036 */     GIR_EraseRootFromParent_Done,
     /* 1741037 */   // Label 23730: @1741037
     /* 1741037 */   GIM_Try, /*On fail goto*//*Label 23731*/ GIMT_Encode4(1741123), // Rule ID 11037 //
     /* 1741042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1741053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1741056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1741059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1741062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741088 */     // MIs[0] policy
     /* 1741088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741098 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1741101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741122 */     // GIR_Coverage, 11037,
     /* 1741122 */     GIR_EraseRootFromParent_Done,
     /* 1741123 */   // Label 23731: @1741123
     /* 1741123 */   GIM_Try, /*On fail goto*//*Label 23732*/ GIMT_Encode4(1741209), // Rule ID 11040 //
     /* 1741128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1741139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1741142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1741145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1741148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741174 */     // MIs[0] policy
     /* 1741174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741184 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1741187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741208 */     // GIR_Coverage, 11040,
     /* 1741208 */     GIR_EraseRootFromParent_Done,
     /* 1741209 */   // Label 23732: @1741209
     /* 1741209 */   GIM_Try, /*On fail goto*//*Label 23733*/ GIMT_Encode4(1741295), // Rule ID 11041 //
     /* 1741214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1741225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1741228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1741231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1741234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1741237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741260 */     // MIs[0] policy
     /* 1741260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741270 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2_MASK),
     /* 1741273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741294 */     // GIR_Coverage, 11041,
     /* 1741294 */     GIR_EraseRootFromParent_Done,
     /* 1741295 */   // Label 23733: @1741295
     /* 1741295 */   GIM_Try, /*On fail goto*//*Label 23734*/ GIMT_Encode4(1741381), // Rule ID 11044 //
     /* 1741300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1741311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1741314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1741317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1741320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741346 */     // MIs[0] policy
     /* 1741346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741356 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741380 */     // GIR_Coverage, 11044,
     /* 1741380 */     GIR_EraseRootFromParent_Done,
     /* 1741381 */   // Label 23734: @1741381
     /* 1741381 */   GIM_Try, /*On fail goto*//*Label 23735*/ GIMT_Encode4(1741467), // Rule ID 11045 //
     /* 1741386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1741397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1741400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1741403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1741406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1741409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741432 */     // MIs[0] policy
     /* 1741432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741442 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741466 */     // GIR_Coverage, 11045,
     /* 1741466 */     GIR_EraseRootFromParent_Done,
     /* 1741467 */   // Label 23735: @1741467
     /* 1741467 */   GIM_Try, /*On fail goto*//*Label 23736*/ GIMT_Encode4(1741553), // Rule ID 11048 //
     /* 1741472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1741483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1741486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1741489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1741492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741518 */     // MIs[0] policy
     /* 1741518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741528 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741552 */     // GIR_Coverage, 11048,
     /* 1741552 */     GIR_EraseRootFromParent_Done,
     /* 1741553 */   // Label 23736: @1741553
     /* 1741553 */   GIM_Try, /*On fail goto*//*Label 23737*/ GIMT_Encode4(1741639), // Rule ID 11049 //
     /* 1741558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1741569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1741572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1741575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1741578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1741581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741604 */     // MIs[0] policy
     /* 1741604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741614 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1741635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741638 */     // GIR_Coverage, 11049,
     /* 1741638 */     GIR_EraseRootFromParent_Done,
     /* 1741639 */   // Label 23737: @1741639
     /* 1741639 */   GIM_Try, /*On fail goto*//*Label 23738*/ GIMT_Encode4(1741725), // Rule ID 11052 //
     /* 1741644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741690 */     // MIs[0] policy
     /* 1741690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741700 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741724 */     // GIR_Coverage, 11052,
     /* 1741724 */     GIR_EraseRootFromParent_Done,
     /* 1741725 */   // Label 23738: @1741725
     /* 1741725 */   GIM_Try, /*On fail goto*//*Label 23739*/ GIMT_Encode4(1741811), // Rule ID 11053 //
     /* 1741730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1741741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1741744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1741747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1741750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1741753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1741760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1741772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741776 */     // MIs[0] policy
     /* 1741776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741786 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1741789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1741807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741810 */     // GIR_Coverage, 11053,
     /* 1741810 */     GIR_EraseRootFromParent_Done,
     /* 1741811 */   // Label 23739: @1741811
     /* 1741811 */   GIM_Try, /*On fail goto*//*Label 23740*/ GIMT_Encode4(1741897), // Rule ID 11056 //
     /* 1741816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1741842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741862 */     // MIs[0] policy
     /* 1741862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1741872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1741875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741896 */     // GIR_Coverage, 11056,
     /* 1741896 */     GIR_EraseRootFromParent_Done,
     /* 1741897 */   // Label 23740: @1741897
     /* 1741897 */   GIM_Try, /*On fail goto*//*Label 23741*/ GIMT_Encode4(1741983), // Rule ID 11057 //
     /* 1741902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1741905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1741913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1741916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1741919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1741922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1741925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1741928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1741932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1741944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1741948 */     // MIs[0] policy
     /* 1741948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1741951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1741958 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1741958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1741961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1741963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1741965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1741967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1741969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1741971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1741976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1741979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1741981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1741982 */     // GIR_Coverage, 11057,
     /* 1741982 */     GIR_EraseRootFromParent_Done,
     /* 1741983 */   // Label 23741: @1741983
     /* 1741983 */   GIM_Try, /*On fail goto*//*Label 23742*/ GIMT_Encode4(1742069), // Rule ID 11060 //
     /* 1741988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1741991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1741996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1741999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1742002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1742005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1742008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742034 */     // MIs[0] policy
     /* 1742034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742044 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1742047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742068 */     // GIR_Coverage, 11060,
     /* 1742068 */     GIR_EraseRootFromParent_Done,
     /* 1742069 */   // Label 23742: @1742069
     /* 1742069 */   GIM_Try, /*On fail goto*//*Label 23743*/ GIMT_Encode4(1742155), // Rule ID 11061 //
     /* 1742074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1742085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1742088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1742091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1742094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742120 */     // MIs[0] policy
     /* 1742120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742130 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1742133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742154 */     // GIR_Coverage, 11061,
     /* 1742154 */     GIR_EraseRootFromParent_Done,
     /* 1742155 */   // Label 23743: @1742155
     /* 1742155 */   GIM_Try, /*On fail goto*//*Label 23744*/ GIMT_Encode4(1742241), // Rule ID 11064 //
     /* 1742160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1742171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1742174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1742177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1742180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1742183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742206 */     // MIs[0] policy
     /* 1742206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742216 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1742219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742240 */     // GIR_Coverage, 11064,
     /* 1742240 */     GIR_EraseRootFromParent_Done,
     /* 1742241 */   // Label 23744: @1742241
     /* 1742241 */   GIM_Try, /*On fail goto*//*Label 23745*/ GIMT_Encode4(1742327), // Rule ID 11065 //
     /* 1742246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1742257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1742260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1742263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1742266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1742269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742292 */     // MIs[0] policy
     /* 1742292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742302 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1742305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1742323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742326 */     // GIR_Coverage, 11065,
     /* 1742326 */     GIR_EraseRootFromParent_Done,
     /* 1742327 */   // Label 23745: @1742327
     /* 1742327 */   GIM_Try, /*On fail goto*//*Label 23746*/ GIMT_Encode4(1742413), // Rule ID 11068 //
     /* 1742332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1742343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742378 */     // MIs[0] policy
     /* 1742378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1742391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742412 */     // GIR_Coverage, 11068,
     /* 1742412 */     GIR_EraseRootFromParent_Done,
     /* 1742413 */   // Label 23746: @1742413
     /* 1742413 */   GIM_Try, /*On fail goto*//*Label 23747*/ GIMT_Encode4(1742499), // Rule ID 11069 //
     /* 1742418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1742429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1742432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1742435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1742438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1742441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742464 */     // MIs[0] policy
     /* 1742464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1742477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742498 */     // GIR_Coverage, 11069,
     /* 1742498 */     GIR_EraseRootFromParent_Done,
     /* 1742499 */   // Label 23747: @1742499
     /* 1742499 */   GIM_Try, /*On fail goto*//*Label 23748*/ GIMT_Encode4(1742585), // Rule ID 11072 //
     /* 1742504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742550 */     // MIs[0] policy
     /* 1742550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742560 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1742563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742584 */     // GIR_Coverage, 11072,
     /* 1742584 */     GIR_EraseRootFromParent_Done,
     /* 1742585 */   // Label 23748: @1742585
     /* 1742585 */   GIM_Try, /*On fail goto*//*Label 23749*/ GIMT_Encode4(1742671), // Rule ID 11073 //
     /* 1742590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1742601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1742604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1742607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1742610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1742613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1742620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1742632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742636 */     // MIs[0] policy
     /* 1742636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742646 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1742649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742670 */     // GIR_Coverage, 11073,
     /* 1742670 */     GIR_EraseRootFromParent_Done,
     /* 1742671 */   // Label 23749: @1742671
     /* 1742671 */   GIM_Try, /*On fail goto*//*Label 23750*/ GIMT_Encode4(1742757), // Rule ID 11076 //
     /* 1742676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742722 */     // MIs[0] policy
     /* 1742722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742732 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1742735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742756 */     // GIR_Coverage, 11076,
     /* 1742756 */     GIR_EraseRootFromParent_Done,
     /* 1742757 */   // Label 23750: @1742757
     /* 1742757 */   GIM_Try, /*On fail goto*//*Label 23751*/ GIMT_Encode4(1742843), // Rule ID 11077 //
     /* 1742762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1742773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1742776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1742779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1742782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1742785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1742792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1742804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742808 */     // MIs[0] policy
     /* 1742808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742818 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1742821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1742839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742842 */     // GIR_Coverage, 11077,
     /* 1742842 */     GIR_EraseRootFromParent_Done,
     /* 1742843 */   // Label 23751: @1742843
     /* 1742843 */   GIM_Try, /*On fail goto*//*Label 23752*/ GIMT_Encode4(1742929), // Rule ID 11080 //
     /* 1742848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1742851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1742874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742894 */     // MIs[0] policy
     /* 1742894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742904 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1742904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1742907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1742915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1742917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1742922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1742925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1742927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1742928 */     // GIR_Coverage, 11080,
     /* 1742928 */     GIR_EraseRootFromParent_Done,
     /* 1742929 */   // Label 23752: @1742929
     /* 1742929 */   GIM_Try, /*On fail goto*//*Label 23753*/ GIMT_Encode4(1743015), // Rule ID 11081 //
     /* 1742934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1742937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1742942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1742945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1742948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1742951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1742954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1742957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1742960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1742964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1742976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1742980 */     // MIs[0] policy
     /* 1742980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1742983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1742990 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1742990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1742993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1742995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1742997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1742999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743014 */     // GIR_Coverage, 11081,
     /* 1743014 */     GIR_EraseRootFromParent_Done,
     /* 1743015 */   // Label 23753: @1743015
     /* 1743015 */   GIM_Try, /*On fail goto*//*Label 23754*/ GIMT_Encode4(1743101), // Rule ID 11084 //
     /* 1743020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1743031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1743034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1743037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1743040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743066 */     // MIs[0] policy
     /* 1743066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743076 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1743079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743100 */     // GIR_Coverage, 11084,
     /* 1743100 */     GIR_EraseRootFromParent_Done,
     /* 1743101 */   // Label 23754: @1743101
     /* 1743101 */   GIM_Try, /*On fail goto*//*Label 23755*/ GIMT_Encode4(1743187), // Rule ID 11085 //
     /* 1743106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1743117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1743120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1743123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1743126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1743129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1743136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1743148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743152 */     // MIs[0] policy
     /* 1743152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743162 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1743165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743186 */     // GIR_Coverage, 11085,
     /* 1743186 */     GIR_EraseRootFromParent_Done,
     /* 1743187 */   // Label 23755: @1743187
     /* 1743187 */   GIM_Try, /*On fail goto*//*Label 23756*/ GIMT_Encode4(1743273), // Rule ID 11088 //
     /* 1743192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1743203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1743206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1743209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1743212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743238 */     // MIs[0] policy
     /* 1743238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743248 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1743251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743272 */     // GIR_Coverage, 11088,
     /* 1743272 */     GIR_EraseRootFromParent_Done,
     /* 1743273 */   // Label 23756: @1743273
     /* 1743273 */   GIM_Try, /*On fail goto*//*Label 23757*/ GIMT_Encode4(1743359), // Rule ID 11089 //
     /* 1743278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1743289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1743292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1743295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1743298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1743301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1743308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1743320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743324 */     // MIs[0] policy
     /* 1743324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743334 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1743337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1743355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743358 */     // GIR_Coverage, 11089,
     /* 1743358 */     GIR_EraseRootFromParent_Done,
     /* 1743359 */   // Label 23757: @1743359
     /* 1743359 */   GIM_Try, /*On fail goto*//*Label 23758*/ GIMT_Encode4(1743445), // Rule ID 11092 //
     /* 1743364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743410 */     // MIs[0] policy
     /* 1743410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1743423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743444 */     // GIR_Coverage, 11092,
     /* 1743444 */     GIR_EraseRootFromParent_Done,
     /* 1743445 */   // Label 23758: @1743445
     /* 1743445 */   GIM_Try, /*On fail goto*//*Label 23759*/ GIMT_Encode4(1743531), // Rule ID 11093 //
     /* 1743450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1743461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1743464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1743467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743496 */     // MIs[0] policy
     /* 1743496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743506 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF8_MASK),
     /* 1743509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743530 */     // GIR_Coverage, 11093,
     /* 1743530 */     GIR_EraseRootFromParent_Done,
     /* 1743531 */   // Label 23759: @1743531
     /* 1743531 */   GIM_Try, /*On fail goto*//*Label 23760*/ GIMT_Encode4(1743617), // Rule ID 11096 //
     /* 1743536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743582 */     // MIs[0] policy
     /* 1743582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1743595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743616 */     // GIR_Coverage, 11096,
     /* 1743616 */     GIR_EraseRootFromParent_Done,
     /* 1743617 */   // Label 23760: @1743617
     /* 1743617 */   GIM_Try, /*On fail goto*//*Label 23761*/ GIMT_Encode4(1743703), // Rule ID 11097 //
     /* 1743622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1743633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1743636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1743639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1743645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743668 */     // MIs[0] policy
     /* 1743668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1743681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743702 */     // GIR_Coverage, 11097,
     /* 1743702 */     GIR_EraseRootFromParent_Done,
     /* 1743703 */   // Label 23761: @1743703
     /* 1743703 */   GIM_Try, /*On fail goto*//*Label 23762*/ GIMT_Encode4(1743789), // Rule ID 11100 //
     /* 1743708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743754 */     // MIs[0] policy
     /* 1743754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1743767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743788 */     // GIR_Coverage, 11100,
     /* 1743788 */     GIR_EraseRootFromParent_Done,
     /* 1743789 */   // Label 23762: @1743789
     /* 1743789 */   GIM_Try, /*On fail goto*//*Label 23763*/ GIMT_Encode4(1743875), // Rule ID 11101 //
     /* 1743794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1743805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1743808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1743811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1743817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743840 */     // MIs[0] policy
     /* 1743840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743850 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1743850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1743853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1743871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743874 */     // GIR_Coverage, 11101,
     /* 1743874 */     GIR_EraseRootFromParent_Done,
     /* 1743875 */   // Label 23763: @1743875
     /* 1743875 */   GIM_Try, /*On fail goto*//*Label 23764*/ GIMT_Encode4(1743961), // Rule ID 11104 //
     /* 1743880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1743883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1743900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1743906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1743918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1743922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1743926 */     // MIs[0] policy
     /* 1743926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1743929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1743936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1743936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1743939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1743941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1743943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1743945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1743947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1743949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1743954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1743957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1743959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1743960 */     // GIR_Coverage, 11104,
     /* 1743960 */     GIR_EraseRootFromParent_Done,
     /* 1743961 */   // Label 23764: @1743961
     /* 1743961 */   GIM_Try, /*On fail goto*//*Label 23765*/ GIMT_Encode4(1744047), // Rule ID 11105 //
     /* 1743966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1743969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1743974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1743977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1743980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1743983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1743986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1743989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1743992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1743996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744012 */     // MIs[0] policy
     /* 1744012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF4_MASK),
     /* 1744025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744046 */     // GIR_Coverage, 11105,
     /* 1744046 */     GIR_EraseRootFromParent_Done,
     /* 1744047 */   // Label 23765: @1744047
     /* 1744047 */   GIM_Try, /*On fail goto*//*Label 23766*/ GIMT_Encode4(1744133), // Rule ID 11108 //
     /* 1744052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744098 */     // MIs[0] policy
     /* 1744098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1744111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744132 */     // GIR_Coverage, 11108,
     /* 1744132 */     GIR_EraseRootFromParent_Done,
     /* 1744133 */   // Label 23766: @1744133
     /* 1744133 */   GIM_Try, /*On fail goto*//*Label 23767*/ GIMT_Encode4(1744219), // Rule ID 11109 //
     /* 1744138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1744149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1744152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1744155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744184 */     // MIs[0] policy
     /* 1744184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1744197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744218 */     // GIR_Coverage, 11109,
     /* 1744218 */     GIR_EraseRootFromParent_Done,
     /* 1744219 */   // Label 23767: @1744219
     /* 1744219 */   GIM_Try, /*On fail goto*//*Label 23768*/ GIMT_Encode4(1744305), // Rule ID 11112 //
     /* 1744224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744270 */     // MIs[0] policy
     /* 1744270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1744283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744304 */     // GIR_Coverage, 11112,
     /* 1744304 */     GIR_EraseRootFromParent_Done,
     /* 1744305 */   // Label 23768: @1744305
     /* 1744305 */   GIM_Try, /*On fail goto*//*Label 23769*/ GIMT_Encode4(1744391), // Rule ID 11113 //
     /* 1744310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1744321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1744324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1744327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1744333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744356 */     // MIs[0] policy
     /* 1744356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_MF2_MASK),
     /* 1744369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744390 */     // GIR_Coverage, 11113,
     /* 1744390 */     GIR_EraseRootFromParent_Done,
     /* 1744391 */   // Label 23769: @1744391
     /* 1744391 */   GIM_Try, /*On fail goto*//*Label 23770*/ GIMT_Encode4(1744477), // Rule ID 11116 //
     /* 1744396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744442 */     // MIs[0] policy
     /* 1744442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744476 */     // GIR_Coverage, 11116,
     /* 1744476 */     GIR_EraseRootFromParent_Done,
     /* 1744477 */   // Label 23770: @1744477
     /* 1744477 */   GIM_Try, /*On fail goto*//*Label 23771*/ GIMT_Encode4(1744563), // Rule ID 11117 //
     /* 1744482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1744493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1744496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1744499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1744505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744528 */     // MIs[0] policy
     /* 1744528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11403:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744562 */     // GIR_Coverage, 11117,
     /* 1744562 */     GIR_EraseRootFromParent_Done,
     /* 1744563 */   // Label 23771: @1744563
     /* 1744563 */   GIM_Try, /*On fail goto*//*Label 23772*/ GIMT_Encode4(1744649), // Rule ID 11120 //
     /* 1744568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744614 */     // MIs[0] policy
     /* 1744614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744648 */     // GIR_Coverage, 11120,
     /* 1744648 */     GIR_EraseRootFromParent_Done,
     /* 1744649 */   // Label 23772: @1744649
     /* 1744649 */   GIM_Try, /*On fail goto*//*Label 23773*/ GIMT_Encode4(1744735), // Rule ID 11121 //
     /* 1744654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1744665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1744668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1744671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1744677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744700 */     // MIs[0] policy
     /* 1744700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11403:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1744731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744734 */     // GIR_Coverage, 11121,
     /* 1744734 */     GIR_EraseRootFromParent_Done,
     /* 1744735 */   // Label 23773: @1744735
     /* 1744735 */   GIM_Try, /*On fail goto*//*Label 23774*/ GIMT_Encode4(1744821), // Rule ID 11124 //
     /* 1744740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744786 */     // MIs[0] policy
     /* 1744786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744820 */     // GIR_Coverage, 11124,
     /* 1744820 */     GIR_EraseRootFromParent_Done,
     /* 1744821 */   // Label 23774: @1744821
     /* 1744821 */   GIM_Try, /*On fail goto*//*Label 23775*/ GIMT_Encode4(1744907), // Rule ID 11125 //
     /* 1744826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1744829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1744837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1744840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1744843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1744846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1744849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1744852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1744856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1744864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744872 */     // MIs[0] policy
     /* 1744872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11403:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1744882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1744885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1744903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744906 */     // GIR_Coverage, 11125,
     /* 1744906 */     GIR_EraseRootFromParent_Done,
     /* 1744907 */   // Label 23775: @1744907
     /* 1744907 */   GIM_Try, /*On fail goto*//*Label 23776*/ GIMT_Encode4(1744993), // Rule ID 11128 //
     /* 1744912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1744915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1744920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1744923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1744926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1744929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1744932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1744935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1744938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1744942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1744950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1744954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1744958 */     // MIs[0] policy
     /* 1744958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1744961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1744968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1744968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1744971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1744973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1744975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1744977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1744979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1744981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1744986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1744989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1744991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1744992 */     // GIR_Coverage, 11128,
     /* 1744992 */     GIR_EraseRootFromParent_Done,
     /* 1744993 */   // Label 23776: @1744993
     /* 1744993 */   GIM_Try, /*On fail goto*//*Label 23777*/ GIMT_Encode4(1745079), // Rule ID 11129 //
     /* 1744998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1745009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1745012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1745015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745044 */     // MIs[0] policy
     /* 1745044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745054 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1745057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745078 */     // GIR_Coverage, 11129,
     /* 1745078 */     GIR_EraseRootFromParent_Done,
     /* 1745079 */   // Label 23777: @1745079
     /* 1745079 */   GIM_Try, /*On fail goto*//*Label 23778*/ GIMT_Encode4(1745165), // Rule ID 11132 //
     /* 1745084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745130 */     // MIs[0] policy
     /* 1745130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745140 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1745143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745164 */     // GIR_Coverage, 11132,
     /* 1745164 */     GIR_EraseRootFromParent_Done,
     /* 1745165 */   // Label 23778: @1745165
     /* 1745165 */   GIM_Try, /*On fail goto*//*Label 23779*/ GIMT_Encode4(1745251), // Rule ID 11133 //
     /* 1745170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1745181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1745184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1745187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745216 */     // MIs[0] policy
     /* 1745216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745226 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1745229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745250 */     // GIR_Coverage, 11133,
     /* 1745250 */     GIR_EraseRootFromParent_Done,
     /* 1745251 */   // Label 23779: @1745251
     /* 1745251 */   GIM_Try, /*On fail goto*//*Label 23780*/ GIMT_Encode4(1745337), // Rule ID 11136 //
     /* 1745256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745302 */     // MIs[0] policy
     /* 1745302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1745315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745336 */     // GIR_Coverage, 11136,
     /* 1745336 */     GIR_EraseRootFromParent_Done,
     /* 1745337 */   // Label 23780: @1745337
     /* 1745337 */   GIM_Try, /*On fail goto*//*Label 23781*/ GIMT_Encode4(1745423), // Rule ID 11137 //
     /* 1745342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1745353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1745356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1745359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1745365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745388 */     // MIs[0] policy
     /* 1745388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745398 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1745401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1745419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745422 */     // GIR_Coverage, 11137,
     /* 1745422 */     GIR_EraseRootFromParent_Done,
     /* 1745423 */   // Label 23781: @1745423
     /* 1745423 */   GIM_Try, /*On fail goto*//*Label 23782*/ GIMT_Encode4(1745509), // Rule ID 11140 //
     /* 1745428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745474 */     // MIs[0] policy
     /* 1745474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745484 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1745487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745508 */     // GIR_Coverage, 11140,
     /* 1745508 */     GIR_EraseRootFromParent_Done,
     /* 1745509 */   // Label 23782: @1745509
     /* 1745509 */   GIM_Try, /*On fail goto*//*Label 23783*/ GIMT_Encode4(1745595), // Rule ID 11141 //
     /* 1745514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1745525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1745528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1745531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1745537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745560 */     // MIs[0] policy
     /* 1745560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745570 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1745573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745594 */     // GIR_Coverage, 11141,
     /* 1745594 */     GIR_EraseRootFromParent_Done,
     /* 1745595 */   // Label 23783: @1745595
     /* 1745595 */   GIM_Try, /*On fail goto*//*Label 23784*/ GIMT_Encode4(1745681), // Rule ID 11144 //
     /* 1745600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745646 */     // MIs[0] policy
     /* 1745646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745656 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1745659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745680 */     // GIR_Coverage, 11144,
     /* 1745680 */     GIR_EraseRootFromParent_Done,
     /* 1745681 */   // Label 23784: @1745681
     /* 1745681 */   GIM_Try, /*On fail goto*//*Label 23785*/ GIMT_Encode4(1745767), // Rule ID 11145 //
     /* 1745686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1745697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1745700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1745703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1745709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1745716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1745724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745732 */     // MIs[0] policy
     /* 1745732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745742 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1745745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745766 */     // GIR_Coverage, 11145,
     /* 1745766 */     GIR_EraseRootFromParent_Done,
     /* 1745767 */   // Label 23785: @1745767
     /* 1745767 */   GIM_Try, /*On fail goto*//*Label 23786*/ GIMT_Encode4(1745853), // Rule ID 11148 //
     /* 1745772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745818 */     // MIs[0] policy
     /* 1745818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745828 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1745828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1745831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745852 */     // GIR_Coverage, 11148,
     /* 1745852 */     GIR_EraseRootFromParent_Done,
     /* 1745853 */   // Label 23786: @1745853
     /* 1745853 */   GIM_Try, /*On fail goto*//*Label 23787*/ GIMT_Encode4(1745939), // Rule ID 11149 //
     /* 1745858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1745861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1745869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1745872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1745875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1745878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1745881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1745884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1745888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1745896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745904 */     // MIs[0] policy
     /* 1745904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1745914 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1745914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1745917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1745919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1745921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1745923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1745925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1745927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1745932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1745935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1745937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1745938 */     // GIR_Coverage, 11149,
     /* 1745938 */     GIR_EraseRootFromParent_Done,
     /* 1745939 */   // Label 23787: @1745939
     /* 1745939 */   GIM_Try, /*On fail goto*//*Label 23788*/ GIMT_Encode4(1746025), // Rule ID 11152 //
     /* 1745944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1745947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1745952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1745955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1745958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1745961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1745964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1745967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1745970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1745974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1745982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1745986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1745990 */     // MIs[0] policy
     /* 1745990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1745993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746000 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1746003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746024 */     // GIR_Coverage, 11152,
     /* 1746024 */     GIR_EraseRootFromParent_Done,
     /* 1746025 */   // Label 23788: @1746025
     /* 1746025 */   GIM_Try, /*On fail goto*//*Label 23789*/ GIMT_Encode4(1746111), // Rule ID 11153 //
     /* 1746030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1746041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1746044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1746047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1746060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1746068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746076 */     // MIs[0] policy
     /* 1746076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1746089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746110 */     // GIR_Coverage, 11153,
     /* 1746110 */     GIR_EraseRootFromParent_Done,
     /* 1746111 */   // Label 23789: @1746111
     /* 1746111 */   GIM_Try, /*On fail goto*//*Label 23790*/ GIMT_Encode4(1746197), // Rule ID 11156 //
     /* 1746116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746162 */     // MIs[0] policy
     /* 1746162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746172 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1746175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746196 */     // GIR_Coverage, 11156,
     /* 1746196 */     GIR_EraseRootFromParent_Done,
     /* 1746197 */   // Label 23790: @1746197
     /* 1746197 */   GIM_Try, /*On fail goto*//*Label 23791*/ GIMT_Encode4(1746283), // Rule ID 11157 //
     /* 1746202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1746213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1746216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1746219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1746225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1746232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1746240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746248 */     // MIs[0] policy
     /* 1746248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746258 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1746261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746282 */     // GIR_Coverage, 11157,
     /* 1746282 */     GIR_EraseRootFromParent_Done,
     /* 1746283 */   // Label 23791: @1746283
     /* 1746283 */   GIM_Try, /*On fail goto*//*Label 23792*/ GIMT_Encode4(1746369), // Rule ID 11160 //
     /* 1746288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1746308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746334 */     // MIs[0] policy
     /* 1746334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746344 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1746347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746368 */     // GIR_Coverage, 11160,
     /* 1746368 */     GIR_EraseRootFromParent_Done,
     /* 1746369 */   // Label 23792: @1746369
     /* 1746369 */   GIM_Try, /*On fail goto*//*Label 23793*/ GIMT_Encode4(1746455), // Rule ID 11161 //
     /* 1746374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1746382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1746385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1746388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1746391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1746394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1746397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1746404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1746412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1746416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746420 */     // MIs[0] policy
     /* 1746420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746430 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1746433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1746451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746454 */     // GIR_Coverage, 11161,
     /* 1746454 */     GIR_EraseRootFromParent_Done,
     /* 1746455 */   // Label 23793: @1746455
     /* 1746455 */   GIM_Try, /*On fail goto*//*Label 23794*/ GIMT_Encode4(1746541), // Rule ID 11164 //
     /* 1746460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746506 */     // MIs[0] policy
     /* 1746506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1746519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746540 */     // GIR_Coverage, 11164,
     /* 1746540 */     GIR_EraseRootFromParent_Done,
     /* 1746541 */   // Label 23794: @1746541
     /* 1746541 */   GIM_Try, /*On fail goto*//*Label 23795*/ GIMT_Encode4(1746627), // Rule ID 11165 //
     /* 1746546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1746557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1746560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1746563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1746566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746592 */     // MIs[0] policy
     /* 1746592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8_MASK),
     /* 1746605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746626 */     // GIR_Coverage, 11165,
     /* 1746626 */     GIR_EraseRootFromParent_Done,
     /* 1746627 */   // Label 23795: @1746627
     /* 1746627 */   GIM_Try, /*On fail goto*//*Label 23796*/ GIMT_Encode4(1746713), // Rule ID 11168 //
     /* 1746632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1746643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1746646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1746649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1746652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746678 */     // MIs[0] policy
     /* 1746678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1746691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746712 */     // GIR_Coverage, 11168,
     /* 1746712 */     GIR_EraseRootFromParent_Done,
     /* 1746713 */   // Label 23796: @1746713
     /* 1746713 */   GIM_Try, /*On fail goto*//*Label 23797*/ GIMT_Encode4(1746799), // Rule ID 11169 //
     /* 1746718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1746729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1746732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1746735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1746738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1746741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746764 */     // MIs[0] policy
     /* 1746764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1746777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746798 */     // GIR_Coverage, 11169,
     /* 1746798 */     GIR_EraseRootFromParent_Done,
     /* 1746799 */   // Label 23797: @1746799
     /* 1746799 */   GIM_Try, /*On fail goto*//*Label 23798*/ GIMT_Encode4(1746885), // Rule ID 11172 //
     /* 1746804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1746815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1746818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1746821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1746824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1746830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746850 */     // MIs[0] policy
     /* 1746850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1746860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1746863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746884 */     // GIR_Coverage, 11172,
     /* 1746884 */     GIR_EraseRootFromParent_Done,
     /* 1746885 */   // Label 23798: @1746885
     /* 1746885 */   GIM_Try, /*On fail goto*//*Label 23799*/ GIMT_Encode4(1746971), // Rule ID 11173 //
     /* 1746890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1746893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1746901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1746904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1746907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1746910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1746913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1746916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1746920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1746932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1746936 */     // MIs[0] policy
     /* 1746936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1746939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1746946 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1746946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1746949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1746951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1746953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1746955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1746957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1746959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1746964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1746967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1746969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1746970 */     // GIR_Coverage, 11173,
     /* 1746970 */     GIR_EraseRootFromParent_Done,
     /* 1746971 */   // Label 23799: @1746971
     /* 1746971 */   GIM_Try, /*On fail goto*//*Label 23800*/ GIMT_Encode4(1747057), // Rule ID 11176 //
     /* 1746976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1746979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1746984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1746987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1746990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1746993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1746996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1746999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747022 */     // MIs[0] policy
     /* 1747022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1747035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747056 */     // GIR_Coverage, 11176,
     /* 1747056 */     GIR_EraseRootFromParent_Done,
     /* 1747057 */   // Label 23800: @1747057
     /* 1747057 */   GIM_Try, /*On fail goto*//*Label 23801*/ GIMT_Encode4(1747143), // Rule ID 11177 //
     /* 1747062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1747073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1747076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1747079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1747082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747108 */     // MIs[0] policy
     /* 1747108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4_MASK),
     /* 1747121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747142 */     // GIR_Coverage, 11177,
     /* 1747142 */     GIR_EraseRootFromParent_Done,
     /* 1747143 */   // Label 23801: @1747143
     /* 1747143 */   GIM_Try, /*On fail goto*//*Label 23802*/ GIMT_Encode4(1747229), // Rule ID 11180 //
     /* 1747148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747194 */     // MIs[0] policy
     /* 1747194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1747207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747228 */     // GIR_Coverage, 11180,
     /* 1747228 */     GIR_EraseRootFromParent_Done,
     /* 1747229 */   // Label 23802: @1747229
     /* 1747229 */   GIM_Try, /*On fail goto*//*Label 23803*/ GIMT_Encode4(1747315), // Rule ID 11181 //
     /* 1747234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1747245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1747248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1747251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1747254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747280 */     // MIs[0] policy
     /* 1747280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1747293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747314 */     // GIR_Coverage, 11181,
     /* 1747314 */     GIR_EraseRootFromParent_Done,
     /* 1747315 */   // Label 23803: @1747315
     /* 1747315 */   GIM_Try, /*On fail goto*//*Label 23804*/ GIMT_Encode4(1747401), // Rule ID 11184 //
     /* 1747320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747366 */     // MIs[0] policy
     /* 1747366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1747379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747400 */     // GIR_Coverage, 11184,
     /* 1747400 */     GIR_EraseRootFromParent_Done,
     /* 1747401 */   // Label 23804: @1747401
     /* 1747401 */   GIM_Try, /*On fail goto*//*Label 23805*/ GIMT_Encode4(1747487), // Rule ID 11185 //
     /* 1747406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1747417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1747420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1747423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1747426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1747429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747452 */     // MIs[0] policy
     /* 1747452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2_MASK),
     /* 1747465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747486 */     // GIR_Coverage, 11185,
     /* 1747486 */     GIR_EraseRootFromParent_Done,
     /* 1747487 */   // Label 23805: @1747487
     /* 1747487 */   GIM_Try, /*On fail goto*//*Label 23806*/ GIMT_Encode4(1747573), // Rule ID 11188 //
     /* 1747492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1747512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747538 */     // MIs[0] policy
     /* 1747538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747572 */     // GIR_Coverage, 11188,
     /* 1747572 */     GIR_EraseRootFromParent_Done,
     /* 1747573 */   // Label 23806: @1747573
     /* 1747573 */   GIM_Try, /*On fail goto*//*Label 23807*/ GIMT_Encode4(1747659), // Rule ID 11189 //
     /* 1747578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1747589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1747592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1747595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1747598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1747601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747624 */     // MIs[0] policy
     /* 1747624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1747655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747658 */     // GIR_Coverage, 11189,
     /* 1747658 */     GIR_EraseRootFromParent_Done,
     /* 1747659 */   // Label 23807: @1747659
     /* 1747659 */   GIM_Try, /*On fail goto*//*Label 23808*/ GIMT_Encode4(1747745), // Rule ID 11192 //
     /* 1747664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1747675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1747678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1747681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1747684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747710 */     // MIs[0] policy
     /* 1747710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747744 */     // GIR_Coverage, 11192,
     /* 1747744 */     GIR_EraseRootFromParent_Done,
     /* 1747745 */   // Label 23808: @1747745
     /* 1747745 */   GIM_Try, /*On fail goto*//*Label 23809*/ GIMT_Encode4(1747831), // Rule ID 11193 //
     /* 1747750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1747761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1747764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1747767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1747770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1747773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747796 */     // MIs[0] policy
     /* 1747796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1747827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747830 */     // GIR_Coverage, 11193,
     /* 1747830 */     GIR_EraseRootFromParent_Done,
     /* 1747831 */   // Label 23809: @1747831
     /* 1747831 */   GIM_Try, /*On fail goto*//*Label 23810*/ GIMT_Encode4(1747917), // Rule ID 11196 //
     /* 1747836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1747839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1747847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1747850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1747853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1747856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1747862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747882 */     // MIs[0] policy
     /* 1747882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1747892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1747915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1747916 */     // GIR_Coverage, 11196,
     /* 1747916 */     GIR_EraseRootFromParent_Done,
     /* 1747917 */   // Label 23810: @1747917
     /* 1747917 */   GIM_Try, /*On fail goto*//*Label 23811*/ GIMT_Encode4(1748003), // Rule ID 11197 //
     /* 1747922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1747925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1747930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1747933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1747936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1747939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1747942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1747945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1747948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1747952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1747964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1747968 */     // MIs[0] policy
     /* 1747968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1747971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1747978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1747978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1747981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1747983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1747985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1747987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1747989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1747991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1747996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1747999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748002 */     // GIR_Coverage, 11197,
     /* 1748002 */     GIR_EraseRootFromParent_Done,
     /* 1748003 */   // Label 23811: @1748003
     /* 1748003 */   GIM_Try, /*On fail goto*//*Label 23812*/ GIMT_Encode4(1748089), // Rule ID 11200 //
     /* 1748008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748054 */     // MIs[0] policy
     /* 1748054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748064 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1748067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748088 */     // GIR_Coverage, 11200,
     /* 1748088 */     GIR_EraseRootFromParent_Done,
     /* 1748089 */   // Label 23812: @1748089
     /* 1748089 */   GIM_Try, /*On fail goto*//*Label 23813*/ GIMT_Encode4(1748175), // Rule ID 11201 //
     /* 1748094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1748105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1748108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1748111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1748114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748140 */     // MIs[0] policy
     /* 1748140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748150 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1748153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748174 */     // GIR_Coverage, 11201,
     /* 1748174 */     GIR_EraseRootFromParent_Done,
     /* 1748175 */   // Label 23813: @1748175
     /* 1748175 */   GIM_Try, /*On fail goto*//*Label 23814*/ GIMT_Encode4(1748261), // Rule ID 11204 //
     /* 1748180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748226 */     // MIs[0] policy
     /* 1748226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748236 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1748239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748260 */     // GIR_Coverage, 11204,
     /* 1748260 */     GIR_EraseRootFromParent_Done,
     /* 1748261 */   // Label 23814: @1748261
     /* 1748261 */   GIM_Try, /*On fail goto*//*Label 23815*/ GIMT_Encode4(1748347), // Rule ID 11205 //
     /* 1748266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1748277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1748280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1748283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1748286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748312 */     // MIs[0] policy
     /* 1748312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748322 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1748325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748346 */     // GIR_Coverage, 11205,
     /* 1748346 */     GIR_EraseRootFromParent_Done,
     /* 1748347 */   // Label 23815: @1748347
     /* 1748347 */   GIM_Try, /*On fail goto*//*Label 23816*/ GIMT_Encode4(1748433), // Rule ID 11208 //
     /* 1748352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748398 */     // MIs[0] policy
     /* 1748398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748408 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1748411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748432 */     // GIR_Coverage, 11208,
     /* 1748432 */     GIR_EraseRootFromParent_Done,
     /* 1748433 */   // Label 23816: @1748433
     /* 1748433 */   GIM_Try, /*On fail goto*//*Label 23817*/ GIMT_Encode4(1748519), // Rule ID 11209 //
     /* 1748438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1748449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1748452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1748455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1748458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1748461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748484 */     // MIs[0] policy
     /* 1748484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748494 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1748497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1748515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748518 */     // GIR_Coverage, 11209,
     /* 1748518 */     GIR_EraseRootFromParent_Done,
     /* 1748519 */   // Label 23817: @1748519
     /* 1748519 */   GIM_Try, /*On fail goto*//*Label 23818*/ GIMT_Encode4(1748605), // Rule ID 11212 //
     /* 1748524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1748541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1748544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748570 */     // MIs[0] policy
     /* 1748570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748580 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1748583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748604 */     // GIR_Coverage, 11212,
     /* 1748604 */     GIR_EraseRootFromParent_Done,
     /* 1748605 */   // Label 23818: @1748605
     /* 1748605 */   GIM_Try, /*On fail goto*//*Label 23819*/ GIMT_Encode4(1748691), // Rule ID 11213 //
     /* 1748610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1748621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1748624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1748627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1748630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1748633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1748640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1748652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748656 */     // MIs[0] policy
     /* 1748656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748666 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1748669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748690 */     // GIR_Coverage, 11213,
     /* 1748690 */     GIR_EraseRootFromParent_Done,
     /* 1748691 */   // Label 23819: @1748691
     /* 1748691 */   GIM_Try, /*On fail goto*//*Label 23820*/ GIMT_Encode4(1748777), // Rule ID 11216 //
     /* 1748696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1748707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1748710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1748713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1748716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748742 */     // MIs[0] policy
     /* 1748742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748752 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1748755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748776 */     // GIR_Coverage, 11216,
     /* 1748776 */     GIR_EraseRootFromParent_Done,
     /* 1748777 */   // Label 23820: @1748777
     /* 1748777 */   GIM_Try, /*On fail goto*//*Label 23821*/ GIMT_Encode4(1748863), // Rule ID 11217 //
     /* 1748782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1748793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1748796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1748799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1748802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1748805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1748812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1748824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748828 */     // MIs[0] policy
     /* 1748828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748838 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1748838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1748841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748862 */     // GIR_Coverage, 11217,
     /* 1748862 */     GIR_EraseRootFromParent_Done,
     /* 1748863 */   // Label 23821: @1748863
     /* 1748863 */   GIM_Try, /*On fail goto*//*Label 23822*/ GIMT_Encode4(1748949), // Rule ID 11220 //
     /* 1748868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1748871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1748879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1748882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1748885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1748888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1748894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1748914 */     // MIs[0] policy
     /* 1748914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1748917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1748924 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1748924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1748927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1748929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1748931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1748933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1748935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1748937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1748942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1748945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1748947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1748948 */     // GIR_Coverage, 11220,
     /* 1748948 */     GIR_EraseRootFromParent_Done,
     /* 1748949 */   // Label 23822: @1748949
     /* 1748949 */   GIM_Try, /*On fail goto*//*Label 23823*/ GIMT_Encode4(1749035), // Rule ID 11221 //
     /* 1748954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1748957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1748962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1748965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1748968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1748971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1748974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1748977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1748980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1748984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1748996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749000 */     // MIs[0] policy
     /* 1749000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749010 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1749013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1749031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749034 */     // GIR_Coverage, 11221,
     /* 1749034 */     GIR_EraseRootFromParent_Done,
     /* 1749035 */   // Label 23823: @1749035
     /* 1749035 */   GIM_Try, /*On fail goto*//*Label 23824*/ GIMT_Encode4(1749121), // Rule ID 11224 //
     /* 1749040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749086 */     // MIs[0] policy
     /* 1749086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749096 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1749099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749120 */     // GIR_Coverage, 11224,
     /* 1749120 */     GIR_EraseRootFromParent_Done,
     /* 1749121 */   // Label 23824: @1749121
     /* 1749121 */   GIM_Try, /*On fail goto*//*Label 23825*/ GIMT_Encode4(1749207), // Rule ID 11225 //
     /* 1749126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1749137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1749140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1749143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1749146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1749156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1749168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749172 */     // MIs[0] policy
     /* 1749172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749182 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1749185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749206 */     // GIR_Coverage, 11225,
     /* 1749206 */     GIR_EraseRootFromParent_Done,
     /* 1749207 */   // Label 23825: @1749207
     /* 1749207 */   GIM_Try, /*On fail goto*//*Label 23826*/ GIMT_Encode4(1749293), // Rule ID 11228 //
     /* 1749212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749258 */     // MIs[0] policy
     /* 1749258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749268 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1749271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749292 */     // GIR_Coverage, 11228,
     /* 1749292 */     GIR_EraseRootFromParent_Done,
     /* 1749293 */   // Label 23826: @1749293
     /* 1749293 */   GIM_Try, /*On fail goto*//*Label 23827*/ GIMT_Encode4(1749379), // Rule ID 11229 //
     /* 1749298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1749309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1749312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1749315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1749318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1749321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1749328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1749340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749344 */     // MIs[0] policy
     /* 1749344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749354 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1749357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749378 */     // GIR_Coverage, 11229,
     /* 1749378 */     GIR_EraseRootFromParent_Done,
     /* 1749379 */   // Label 23827: @1749379
     /* 1749379 */   GIM_Try, /*On fail goto*//*Label 23828*/ GIMT_Encode4(1749465), // Rule ID 11232 //
     /* 1749384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749430 */     // MIs[0] policy
     /* 1749430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749440 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1749443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749464 */     // GIR_Coverage, 11232,
     /* 1749464 */     GIR_EraseRootFromParent_Done,
     /* 1749465 */   // Label 23828: @1749465
     /* 1749465 */   GIM_Try, /*On fail goto*//*Label 23829*/ GIMT_Encode4(1749551), // Rule ID 11233 //
     /* 1749470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1749481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1749484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1749487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1749490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1749493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1749500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1749512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749516 */     // MIs[0] policy
     /* 1749516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749526 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1749529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1749547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749550 */     // GIR_Coverage, 11233,
     /* 1749550 */     GIR_EraseRootFromParent_Done,
     /* 1749551 */   // Label 23829: @1749551
     /* 1749551 */   GIM_Try, /*On fail goto*//*Label 23830*/ GIMT_Encode4(1749637), // Rule ID 11236 //
     /* 1749556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1749567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1749570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1749573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749602 */     // MIs[0] policy
     /* 1749602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749612 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1749615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749636 */     // GIR_Coverage, 11236,
     /* 1749636 */     GIR_EraseRootFromParent_Done,
     /* 1749637 */   // Label 23830: @1749637
     /* 1749637 */   GIM_Try, /*On fail goto*//*Label 23831*/ GIMT_Encode4(1749723), // Rule ID 11237 //
     /* 1749642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1749653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1749656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1749659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1749665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749688 */     // MIs[0] policy
     /* 1749688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749698 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF8_MASK),
     /* 1749701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749722 */     // GIR_Coverage, 11237,
     /* 1749722 */     GIR_EraseRootFromParent_Done,
     /* 1749723 */   // Label 23831: @1749723
     /* 1749723 */   GIM_Try, /*On fail goto*//*Label 23832*/ GIMT_Encode4(1749809), // Rule ID 11240 //
     /* 1749728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1749739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1749742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1749745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749774 */     // MIs[0] policy
     /* 1749774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749784 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1749787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749808 */     // GIR_Coverage, 11240,
     /* 1749808 */     GIR_EraseRootFromParent_Done,
     /* 1749809 */   // Label 23832: @1749809
     /* 1749809 */   GIM_Try, /*On fail goto*//*Label 23833*/ GIMT_Encode4(1749895), // Rule ID 11241 //
     /* 1749814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1749825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1749828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1749831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1749834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1749837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1749840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749860 */     // MIs[0] policy
     /* 1749860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749870 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1749870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1749873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749894 */     // GIR_Coverage, 11241,
     /* 1749894 */     GIR_EraseRootFromParent_Done,
     /* 1749895 */   // Label 23833: @1749895
     /* 1749895 */   GIM_Try, /*On fail goto*//*Label 23834*/ GIMT_Encode4(1749981), // Rule ID 11244 //
     /* 1749900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1749903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1749911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1749914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1749917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1749920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1749923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1749926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1749930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1749938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1749942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1749946 */     // MIs[0] policy
     /* 1749946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1749949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1749956 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1749956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1749959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1749961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1749963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1749965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1749967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1749969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1749974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1749977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1749979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1749980 */     // GIR_Coverage, 11244,
     /* 1749980 */     GIR_EraseRootFromParent_Done,
     /* 1749981 */   // Label 23834: @1749981
     /* 1749981 */   GIM_Try, /*On fail goto*//*Label 23835*/ GIMT_Encode4(1750067), // Rule ID 11245 //
     /* 1749986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1749989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1749994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1749997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1750000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1750003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750032 */     // MIs[0] policy
     /* 1750032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750042 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1750045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750066 */     // GIR_Coverage, 11245,
     /* 1750066 */     GIR_EraseRootFromParent_Done,
     /* 1750067 */   // Label 23835: @1750067
     /* 1750067 */   GIM_Try, /*On fail goto*//*Label 23836*/ GIMT_Encode4(1750153), // Rule ID 11248 //
     /* 1750072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750118 */     // MIs[0] policy
     /* 1750118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750128 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1750131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750152 */     // GIR_Coverage, 11248,
     /* 1750152 */     GIR_EraseRootFromParent_Done,
     /* 1750153 */   // Label 23836: @1750153
     /* 1750153 */   GIM_Try, /*On fail goto*//*Label 23837*/ GIMT_Encode4(1750239), // Rule ID 11249 //
     /* 1750158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1750169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1750172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1750175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750204 */     // MIs[0] policy
     /* 1750204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750214 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF4_MASK),
     /* 1750217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750238 */     // GIR_Coverage, 11249,
     /* 1750238 */     GIR_EraseRootFromParent_Done,
     /* 1750239 */   // Label 23837: @1750239
     /* 1750239 */   GIM_Try, /*On fail goto*//*Label 23838*/ GIMT_Encode4(1750325), // Rule ID 11252 //
     /* 1750244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750290 */     // MIs[0] policy
     /* 1750290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750300 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1750303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750324 */     // GIR_Coverage, 11252,
     /* 1750324 */     GIR_EraseRootFromParent_Done,
     /* 1750325 */   // Label 23838: @1750325
     /* 1750325 */   GIM_Try, /*On fail goto*//*Label 23839*/ GIMT_Encode4(1750411), // Rule ID 11253 //
     /* 1750330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1750341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1750344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1750347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750376 */     // MIs[0] policy
     /* 1750376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750386 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1750389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750410 */     // GIR_Coverage, 11253,
     /* 1750410 */     GIR_EraseRootFromParent_Done,
     /* 1750411 */   // Label 23839: @1750411
     /* 1750411 */   GIM_Try, /*On fail goto*//*Label 23840*/ GIMT_Encode4(1750497), // Rule ID 11256 //
     /* 1750416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750462 */     // MIs[0] policy
     /* 1750462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750472 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1750475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750496 */     // GIR_Coverage, 11256,
     /* 1750496 */     GIR_EraseRootFromParent_Done,
     /* 1750497 */   // Label 23840: @1750497
     /* 1750497 */   GIM_Try, /*On fail goto*//*Label 23841*/ GIMT_Encode4(1750583), // Rule ID 11257 //
     /* 1750502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1750513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1750516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1750519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1750525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750548 */     // MIs[0] policy
     /* 1750548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750558 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_MF2_MASK),
     /* 1750561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1750579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750582 */     // GIR_Coverage, 11257,
     /* 1750582 */     GIR_EraseRootFromParent_Done,
     /* 1750583 */   // Label 23841: @1750583
     /* 1750583 */   GIM_Try, /*On fail goto*//*Label 23842*/ GIMT_Encode4(1750669), // Rule ID 11260 //
     /* 1750588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1750599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1750602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1750605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750634 */     // MIs[0] policy
     /* 1750634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1750647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750668 */     // GIR_Coverage, 11260,
     /* 1750668 */     GIR_EraseRootFromParent_Done,
     /* 1750669 */   // Label 23842: @1750669
     /* 1750669 */   GIM_Try, /*On fail goto*//*Label 23843*/ GIMT_Encode4(1750755), // Rule ID 11261 //
     /* 1750674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1750685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1750688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1750691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1750697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750720 */     // MIs[0] policy
     /* 1750720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750730 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11407:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1750733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1750751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750754 */     // GIR_Coverage, 11261,
     /* 1750754 */     GIR_EraseRootFromParent_Done,
     /* 1750755 */   // Label 23843: @1750755
     /* 1750755 */   GIM_Try, /*On fail goto*//*Label 23844*/ GIMT_Encode4(1750841), // Rule ID 11264 //
     /* 1750760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1750771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1750774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1750777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750806 */     // MIs[0] policy
     /* 1750806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750816 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1750819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750840 */     // GIR_Coverage, 11264,
     /* 1750840 */     GIR_EraseRootFromParent_Done,
     /* 1750841 */   // Label 23844: @1750841
     /* 1750841 */   GIM_Try, /*On fail goto*//*Label 23845*/ GIMT_Encode4(1750927), // Rule ID 11265 //
     /* 1750846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1750849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1750857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1750860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1750863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1750866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1750869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1750872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750892 */     // MIs[0] policy
     /* 1750892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750902 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11407:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1750902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1750905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1750915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1750920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1750923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1750925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1750926 */     // GIR_Coverage, 11265,
     /* 1750926 */     GIR_EraseRootFromParent_Done,
     /* 1750927 */   // Label 23845: @1750927
     /* 1750927 */   GIM_Try, /*On fail goto*//*Label 23846*/ GIMT_Encode4(1751013), // Rule ID 11268 //
     /* 1750932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1750935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1750940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1750943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1750946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1750949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1750952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1750955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1750958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1750962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1750970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1750974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1750978 */     // MIs[0] policy
     /* 1750978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1750981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1750988 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1750988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1750991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1750993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1750995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1750997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1750999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751012 */     // GIR_Coverage, 11268,
     /* 1751012 */     GIR_EraseRootFromParent_Done,
     /* 1751013 */   // Label 23846: @1751013
     /* 1751013 */   GIM_Try, /*On fail goto*//*Label 23847*/ GIMT_Encode4(1751099), // Rule ID 11269 //
     /* 1751018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1751029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1751032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1751035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1751041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1751048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1751056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751064 */     // MIs[0] policy
     /* 1751064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751074 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11407:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1751077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1751095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751098 */     // GIR_Coverage, 11269,
     /* 1751098 */     GIR_EraseRootFromParent_Done,
     /* 1751099 */   // Label 23847: @1751099
     /* 1751099 */   GIM_Try, /*On fail goto*//*Label 23848*/ GIMT_Encode4(1751185), // Rule ID 11272 //
     /* 1751104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751150 */     // MIs[0] policy
     /* 1751150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751160 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1751163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751184 */     // GIR_Coverage, 11272,
     /* 1751184 */     GIR_EraseRootFromParent_Done,
     /* 1751185 */   // Label 23848: @1751185
     /* 1751185 */   GIM_Try, /*On fail goto*//*Label 23849*/ GIMT_Encode4(1751271), // Rule ID 11273 //
     /* 1751190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1751201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1751204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1751207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751236 */     // MIs[0] policy
     /* 1751236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751246 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1751249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751270 */     // GIR_Coverage, 11273,
     /* 1751270 */     GIR_EraseRootFromParent_Done,
     /* 1751271 */   // Label 23849: @1751271
     /* 1751271 */   GIM_Try, /*On fail goto*//*Label 23850*/ GIMT_Encode4(1751357), // Rule ID 11276 //
     /* 1751276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751322 */     // MIs[0] policy
     /* 1751322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751332 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1751335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751356 */     // GIR_Coverage, 11276,
     /* 1751356 */     GIR_EraseRootFromParent_Done,
     /* 1751357 */   // Label 23850: @1751357
     /* 1751357 */   GIM_Try, /*On fail goto*//*Label 23851*/ GIMT_Encode4(1751443), // Rule ID 11277 //
     /* 1751362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1751373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1751376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1751379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751408 */     // MIs[0] policy
     /* 1751408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751418 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1751421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751442 */     // GIR_Coverage, 11277,
     /* 1751442 */     GIR_EraseRootFromParent_Done,
     /* 1751443 */   // Label 23851: @1751443
     /* 1751443 */   GIM_Try, /*On fail goto*//*Label 23852*/ GIMT_Encode4(1751529), // Rule ID 11280 //
     /* 1751448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751494 */     // MIs[0] policy
     /* 1751494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751504 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1751507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751528 */     // GIR_Coverage, 11280,
     /* 1751528 */     GIR_EraseRootFromParent_Done,
     /* 1751529 */   // Label 23852: @1751529
     /* 1751529 */   GIM_Try, /*On fail goto*//*Label 23853*/ GIMT_Encode4(1751615), // Rule ID 11281 //
     /* 1751534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1751545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1751548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1751551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1751557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751580 */     // MIs[0] policy
     /* 1751580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751590 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1751593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1751611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751614 */     // GIR_Coverage, 11281,
     /* 1751614 */     GIR_EraseRootFromParent_Done,
     /* 1751615 */   // Label 23853: @1751615
     /* 1751615 */   GIM_Try, /*On fail goto*//*Label 23854*/ GIMT_Encode4(1751701), // Rule ID 11284 //
     /* 1751620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1751631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1751634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1751637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751666 */     // MIs[0] policy
     /* 1751666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751676 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1751679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751700 */     // GIR_Coverage, 11284,
     /* 1751700 */     GIR_EraseRootFromParent_Done,
     /* 1751701 */   // Label 23854: @1751701
     /* 1751701 */   GIM_Try, /*On fail goto*//*Label 23855*/ GIMT_Encode4(1751787), // Rule ID 11285 //
     /* 1751706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1751717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1751720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1751723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1751729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1751736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1751744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751752 */     // MIs[0] policy
     /* 1751752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1751765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751786 */     // GIR_Coverage, 11285,
     /* 1751786 */     GIR_EraseRootFromParent_Done,
     /* 1751787 */   // Label 23855: @1751787
     /* 1751787 */   GIM_Try, /*On fail goto*//*Label 23856*/ GIMT_Encode4(1751873), // Rule ID 11288 //
     /* 1751792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1751803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1751806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1751809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751838 */     // MIs[0] policy
     /* 1751838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751848 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1751848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1751851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751872 */     // GIR_Coverage, 11288,
     /* 1751872 */     GIR_EraseRootFromParent_Done,
     /* 1751873 */   // Label 23856: @1751873
     /* 1751873 */   GIM_Try, /*On fail goto*//*Label 23857*/ GIMT_Encode4(1751959), // Rule ID 11289 //
     /* 1751878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1751881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1751889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1751892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1751895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1751898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1751901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1751904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1751908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1751916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1751920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1751924 */     // MIs[0] policy
     /* 1751924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1751927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1751934 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1751934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1751937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1751939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1751941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1751943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1751945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1751947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1751952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1751955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1751957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1751958 */     // GIR_Coverage, 11289,
     /* 1751958 */     GIR_EraseRootFromParent_Done,
     /* 1751959 */   // Label 23857: @1751959
     /* 1751959 */   GIM_Try, /*On fail goto*//*Label 23858*/ GIMT_Encode4(1752045), // Rule ID 11292 //
     /* 1751964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1751967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1751972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1751975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1751978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1751981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1751984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1751987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1751990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1751994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1751998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752010 */     // MIs[0] policy
     /* 1752010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752020 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1752023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752044 */     // GIR_Coverage, 11292,
     /* 1752044 */     GIR_EraseRootFromParent_Done,
     /* 1752045 */   // Label 23858: @1752045
     /* 1752045 */   GIM_Try, /*On fail goto*//*Label 23859*/ GIMT_Encode4(1752131), // Rule ID 11293 //
     /* 1752050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1752061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1752064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1752067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1752073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752096 */     // MIs[0] policy
     /* 1752096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1752109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1752127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752130 */     // GIR_Coverage, 11293,
     /* 1752130 */     GIR_EraseRootFromParent_Done,
     /* 1752131 */   // Label 23859: @1752131
     /* 1752131 */   GIM_Try, /*On fail goto*//*Label 23860*/ GIMT_Encode4(1752217), // Rule ID 11296 //
     /* 1752136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752182 */     // MIs[0] policy
     /* 1752182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1752195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752216 */     // GIR_Coverage, 11296,
     /* 1752216 */     GIR_EraseRootFromParent_Done,
     /* 1752217 */   // Label 23860: @1752217
     /* 1752217 */   GIM_Try, /*On fail goto*//*Label 23861*/ GIMT_Encode4(1752303), // Rule ID 11297 //
     /* 1752222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1752233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1752236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1752239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1752245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1752252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1752260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752268 */     // MIs[0] policy
     /* 1752268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1752281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752302 */     // GIR_Coverage, 11297,
     /* 1752302 */     GIR_EraseRootFromParent_Done,
     /* 1752303 */   // Label 23861: @1752303
     /* 1752303 */   GIM_Try, /*On fail goto*//*Label 23862*/ GIMT_Encode4(1752389), // Rule ID 11300 //
     /* 1752308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752354 */     // MIs[0] policy
     /* 1752354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752364 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1752367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752388 */     // GIR_Coverage, 11300,
     /* 1752388 */     GIR_EraseRootFromParent_Done,
     /* 1752389 */   // Label 23862: @1752389
     /* 1752389 */   GIM_Try, /*On fail goto*//*Label 23863*/ GIMT_Encode4(1752475), // Rule ID 11301 //
     /* 1752394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1752405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1752408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1752411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1752417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1752424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1752432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752440 */     // MIs[0] policy
     /* 1752440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752450 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1752453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752474 */     // GIR_Coverage, 11301,
     /* 1752474 */     GIR_EraseRootFromParent_Done,
     /* 1752475 */   // Label 23863: @1752475
     /* 1752475 */   GIM_Try, /*On fail goto*//*Label 23864*/ GIMT_Encode4(1752561), // Rule ID 11304 //
     /* 1752480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1752500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752526 */     // MIs[0] policy
     /* 1752526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752536 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1752539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752560 */     // GIR_Coverage, 11304,
     /* 1752560 */     GIR_EraseRootFromParent_Done,
     /* 1752561 */   // Label 23864: @1752561
     /* 1752561 */   GIM_Try, /*On fail goto*//*Label 23865*/ GIMT_Encode4(1752647), // Rule ID 11305 //
     /* 1752566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1752574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1752577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1752580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1752583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1752586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1752589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1752596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1752604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1752608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752612 */     // MIs[0] policy
     /* 1752612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752622 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1752625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1752643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752646 */     // GIR_Coverage, 11305,
     /* 1752646 */     GIR_EraseRootFromParent_Done,
     /* 1752647 */   // Label 23865: @1752647
     /* 1752647 */   GIM_Try, /*On fail goto*//*Label 23866*/ GIMT_Encode4(1752733), // Rule ID 11308 //
     /* 1752652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1752660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1752663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1752666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1752669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1752672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752698 */     // MIs[0] policy
     /* 1752698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1752711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752732 */     // GIR_Coverage, 11308,
     /* 1752732 */     GIR_EraseRootFromParent_Done,
     /* 1752733 */   // Label 23866: @1752733
     /* 1752733 */   GIM_Try, /*On fail goto*//*Label 23867*/ GIMT_Encode4(1752819), // Rule ID 11309 //
     /* 1752738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1752746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1752749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1752752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1752755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1752758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1752761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752784 */     // MIs[0] policy
     /* 1752784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752794 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF8_MASK),
     /* 1752797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752818 */     // GIR_Coverage, 11309,
     /* 1752818 */     GIR_EraseRootFromParent_Done,
     /* 1752819 */   // Label 23867: @1752819
     /* 1752819 */   GIM_Try, /*On fail goto*//*Label 23868*/ GIMT_Encode4(1752905), // Rule ID 11312 //
     /* 1752824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1752832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1752835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1752838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1752841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1752844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1752850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752870 */     // MIs[0] policy
     /* 1752870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1752880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1752883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752904 */     // GIR_Coverage, 11312,
     /* 1752904 */     GIR_EraseRootFromParent_Done,
     /* 1752905 */   // Label 23868: @1752905
     /* 1752905 */   GIM_Try, /*On fail goto*//*Label 23869*/ GIMT_Encode4(1752991), // Rule ID 11313 //
     /* 1752910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1752913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1752918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1752921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1752924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1752927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1752930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1752933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1752936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1752940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1752952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1752956 */     // MIs[0] policy
     /* 1752956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1752959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1752966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1752966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1752969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1752971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1752973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1752975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1752977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1752979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1752984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1752987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1752989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1752990 */     // GIR_Coverage, 11313,
     /* 1752990 */     GIR_EraseRootFromParent_Done,
     /* 1752991 */   // Label 23869: @1752991
     /* 1752991 */   GIM_Try, /*On fail goto*//*Label 23870*/ GIMT_Encode4(1753077), // Rule ID 11316 //
     /* 1752996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1752999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753042 */     // MIs[0] policy
     /* 1753042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753076 */     // GIR_Coverage, 11316,
     /* 1753076 */     GIR_EraseRootFromParent_Done,
     /* 1753077 */   // Label 23870: @1753077
     /* 1753077 */   GIM_Try, /*On fail goto*//*Label 23871*/ GIMT_Encode4(1753163), // Rule ID 11317 //
     /* 1753082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1753093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1753096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1753099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1753102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753128 */     // MIs[0] policy
     /* 1753128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753162 */     // GIR_Coverage, 11317,
     /* 1753162 */     GIR_EraseRootFromParent_Done,
     /* 1753163 */   // Label 23871: @1753163
     /* 1753163 */   GIM_Try, /*On fail goto*//*Label 23872*/ GIMT_Encode4(1753249), // Rule ID 11320 //
     /* 1753168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753214 */     // MIs[0] policy
     /* 1753214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1753227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753248 */     // GIR_Coverage, 11320,
     /* 1753248 */     GIR_EraseRootFromParent_Done,
     /* 1753249 */   // Label 23872: @1753249
     /* 1753249 */   GIM_Try, /*On fail goto*//*Label 23873*/ GIMT_Encode4(1753335), // Rule ID 11321 //
     /* 1753254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1753265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1753268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1753271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1753274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753300 */     // MIs[0] policy
     /* 1753300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF4_MASK),
     /* 1753313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753334 */     // GIR_Coverage, 11321,
     /* 1753334 */     GIR_EraseRootFromParent_Done,
     /* 1753335 */   // Label 23873: @1753335
     /* 1753335 */   GIM_Try, /*On fail goto*//*Label 23874*/ GIMT_Encode4(1753421), // Rule ID 11324 //
     /* 1753340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753386 */     // MIs[0] policy
     /* 1753386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753420 */     // GIR_Coverage, 11324,
     /* 1753420 */     GIR_EraseRootFromParent_Done,
     /* 1753421 */   // Label 23874: @1753421
     /* 1753421 */   GIM_Try, /*On fail goto*//*Label 23875*/ GIMT_Encode4(1753507), // Rule ID 11325 //
     /* 1753426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1753437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1753440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1753443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1753446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1753449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753472 */     // MIs[0] policy
     /* 1753472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753506 */     // GIR_Coverage, 11325,
     /* 1753506 */     GIR_EraseRootFromParent_Done,
     /* 1753507 */   // Label 23875: @1753507
     /* 1753507 */   GIM_Try, /*On fail goto*//*Label 23876*/ GIMT_Encode4(1753593), // Rule ID 11328 //
     /* 1753512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1753529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1753532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753558 */     // MIs[0] policy
     /* 1753558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753592 */     // GIR_Coverage, 11328,
     /* 1753592 */     GIR_EraseRootFromParent_Done,
     /* 1753593 */   // Label 23876: @1753593
     /* 1753593 */   GIM_Try, /*On fail goto*//*Label 23877*/ GIMT_Encode4(1753679), // Rule ID 11329 //
     /* 1753598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1753609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1753612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1753615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1753618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1753621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753644 */     // MIs[0] policy
     /* 1753644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_MF2_MASK),
     /* 1753657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1753675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753678 */     // GIR_Coverage, 11329,
     /* 1753678 */     GIR_EraseRootFromParent_Done,
     /* 1753679 */   // Label 23877: @1753679
     /* 1753679 */   GIM_Try, /*On fail goto*//*Label 23878*/ GIMT_Encode4(1753765), // Rule ID 11332 //
     /* 1753684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1753695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1753698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1753701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1753704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753730 */     // MIs[0] policy
     /* 1753730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1753743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753764 */     // GIR_Coverage, 11332,
     /* 1753764 */     GIR_EraseRootFromParent_Done,
     /* 1753765 */   // Label 23878: @1753765
     /* 1753765 */   GIM_Try, /*On fail goto*//*Label 23879*/ GIMT_Encode4(1753851), // Rule ID 11333 //
     /* 1753770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1753781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1753784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1753787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1753790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1753793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753816 */     // MIs[0] policy
     /* 1753816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1753829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1753847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753850 */     // GIR_Coverage, 11333,
     /* 1753850 */     GIR_EraseRootFromParent_Done,
     /* 1753851 */   // Label 23879: @1753851
     /* 1753851 */   GIM_Try, /*On fail goto*//*Label 23880*/ GIMT_Encode4(1753937), // Rule ID 11336 //
     /* 1753856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1753859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1753867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1753870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1753873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1753876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1753882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753902 */     // MIs[0] policy
     /* 1753902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1753912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1753915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1753917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1753919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1753921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1753923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1753925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1753930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1753933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1753935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1753936 */     // GIR_Coverage, 11336,
     /* 1753936 */     GIR_EraseRootFromParent_Done,
     /* 1753937 */   // Label 23880: @1753937
     /* 1753937 */   GIM_Try, /*On fail goto*//*Label 23881*/ GIMT_Encode4(1754023), // Rule ID 11337 //
     /* 1753942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1753945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1753950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1753953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1753956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1753959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1753962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1753965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1753968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1753972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1753984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1753988 */     // MIs[0] policy
     /* 1753988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1753991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1753998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1753998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1754001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754022 */     // GIR_Coverage, 11337,
     /* 1754022 */     GIR_EraseRootFromParent_Done,
     /* 1754023 */   // Label 23881: @1754023
     /* 1754023 */   GIM_Try, /*On fail goto*//*Label 23882*/ GIMT_Encode4(1754109), // Rule ID 11340 //
     /* 1754028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754074 */     // MIs[0] policy
     /* 1754074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1754087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754108 */     // GIR_Coverage, 11340,
     /* 1754108 */     GIR_EraseRootFromParent_Done,
     /* 1754109 */   // Label 23882: @1754109
     /* 1754109 */   GIM_Try, /*On fail goto*//*Label 23883*/ GIMT_Encode4(1754195), // Rule ID 11341 //
     /* 1754114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1754125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1754128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1754131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1754134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1754137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1754144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1754156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754160 */     // MIs[0] policy
     /* 1754160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1754173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1754191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754194 */     // GIR_Coverage, 11341,
     /* 1754194 */     GIR_EraseRootFromParent_Done,
     /* 1754195 */   // Label 23883: @1754195
     /* 1754195 */   GIM_Try, /*On fail goto*//*Label 23884*/ GIMT_Encode4(1754281), // Rule ID 11344 //
     /* 1754200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754246 */     // MIs[0] policy
     /* 1754246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1754259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754280 */     // GIR_Coverage, 11344,
     /* 1754280 */     GIR_EraseRootFromParent_Done,
     /* 1754281 */   // Label 23884: @1754281
     /* 1754281 */   GIM_Try, /*On fail goto*//*Label 23885*/ GIMT_Encode4(1754367), // Rule ID 11345 //
     /* 1754286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1754297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1754300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1754303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1754306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754332 */     // MIs[0] policy
     /* 1754332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754342 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1754345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754366 */     // GIR_Coverage, 11345,
     /* 1754366 */     GIR_EraseRootFromParent_Done,
     /* 1754367 */   // Label 23885: @1754367
     /* 1754367 */   GIM_Try, /*On fail goto*//*Label 23886*/ GIMT_Encode4(1754453), // Rule ID 11348 //
     /* 1754372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754418 */     // MIs[0] policy
     /* 1754418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754428 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1754431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754452 */     // GIR_Coverage, 11348,
     /* 1754452 */     GIR_EraseRootFromParent_Done,
     /* 1754453 */   // Label 23886: @1754453
     /* 1754453 */   GIM_Try, /*On fail goto*//*Label 23887*/ GIMT_Encode4(1754539), // Rule ID 11349 //
     /* 1754458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1754469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1754472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1754475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1754478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1754481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754504 */     // MIs[0] policy
     /* 1754504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754514 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1754517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754538 */     // GIR_Coverage, 11349,
     /* 1754538 */     GIR_EraseRootFromParent_Done,
     /* 1754539 */   // Label 23887: @1754539
     /* 1754539 */   GIM_Try, /*On fail goto*//*Label 23888*/ GIMT_Encode4(1754625), // Rule ID 11352 //
     /* 1754544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1754555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1754558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1754561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1754564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1754567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754590 */     // MIs[0] policy
     /* 1754590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754600 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1754603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754624 */     // GIR_Coverage, 11352,
     /* 1754624 */     GIR_EraseRootFromParent_Done,
     /* 1754625 */   // Label 23888: @1754625
     /* 1754625 */   GIM_Try, /*On fail goto*//*Label 23889*/ GIMT_Encode4(1754711), // Rule ID 11353 //
     /* 1754630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1754641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1754644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1754647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1754650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1754653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1754660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1754672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754676 */     // MIs[0] policy
     /* 1754676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754686 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1754689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1754707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754710 */     // GIR_Coverage, 11353,
     /* 1754710 */     GIR_EraseRootFromParent_Done,
     /* 1754711 */   // Label 23889: @1754711
     /* 1754711 */   GIM_Try, /*On fail goto*//*Label 23890*/ GIMT_Encode4(1754797), // Rule ID 11356 //
     /* 1754716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1754727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1754730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1754733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1754736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754762 */     // MIs[0] policy
     /* 1754762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1754775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754796 */     // GIR_Coverage, 11356,
     /* 1754796 */     GIR_EraseRootFromParent_Done,
     /* 1754797 */   // Label 23890: @1754797
     /* 1754797 */   GIM_Try, /*On fail goto*//*Label 23891*/ GIMT_Encode4(1754883), // Rule ID 11357 //
     /* 1754802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1754813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1754816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1754819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1754822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1754825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1754828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1754832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1754844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754848 */     // MIs[0] policy
     /* 1754848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1754858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1754861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754882 */     // GIR_Coverage, 11357,
     /* 1754882 */     GIR_EraseRootFromParent_Done,
     /* 1754883 */   // Label 23891: @1754883
     /* 1754883 */   GIM_Try, /*On fail goto*//*Label 23892*/ GIMT_Encode4(1754969), // Rule ID 11360 //
     /* 1754888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1754891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1754899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1754902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1754905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1754908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1754914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1754918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1754930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1754934 */     // MIs[0] policy
     /* 1754934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1754937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1754944 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1754944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1754947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1754949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1754951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1754953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1754955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1754957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1754962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1754965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1754967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1754968 */     // GIR_Coverage, 11360,
     /* 1754968 */     GIR_EraseRootFromParent_Done,
     /* 1754969 */   // Label 23892: @1754969
     /* 1754969 */   GIM_Try, /*On fail goto*//*Label 23893*/ GIMT_Encode4(1755055), // Rule ID 11361 //
     /* 1754974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1754977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1754982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1754985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1754988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1754991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1754994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1754997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755020 */     // MIs[0] policy
     /* 1755020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755030 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1755033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755054 */     // GIR_Coverage, 11361,
     /* 1755054 */     GIR_EraseRootFromParent_Done,
     /* 1755055 */   // Label 23893: @1755055
     /* 1755055 */   GIM_Try, /*On fail goto*//*Label 23894*/ GIMT_Encode4(1755141), // Rule ID 11364 //
     /* 1755060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755106 */     // MIs[0] policy
     /* 1755106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755116 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1755119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755140 */     // GIR_Coverage, 11364,
     /* 1755140 */     GIR_EraseRootFromParent_Done,
     /* 1755141 */   // Label 23894: @1755141
     /* 1755141 */   GIM_Try, /*On fail goto*//*Label 23895*/ GIMT_Encode4(1755227), // Rule ID 11365 //
     /* 1755146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1755157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1755160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1755163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1755166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1755169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755192 */     // MIs[0] policy
     /* 1755192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755202 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1755205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1755223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755226 */     // GIR_Coverage, 11365,
     /* 1755226 */     GIR_EraseRootFromParent_Done,
     /* 1755227 */   // Label 23895: @1755227
     /* 1755227 */   GIM_Try, /*On fail goto*//*Label 23896*/ GIMT_Encode4(1755313), // Rule ID 11368 //
     /* 1755232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755278 */     // MIs[0] policy
     /* 1755278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755288 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1755291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755312 */     // GIR_Coverage, 11368,
     /* 1755312 */     GIR_EraseRootFromParent_Done,
     /* 1755313 */   // Label 23896: @1755313
     /* 1755313 */   GIM_Try, /*On fail goto*//*Label 23897*/ GIMT_Encode4(1755399), // Rule ID 11369 //
     /* 1755318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1755329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1755332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1755335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1755338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1755341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1755348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1755360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755364 */     // MIs[0] policy
     /* 1755364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755374 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1755377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755398 */     // GIR_Coverage, 11369,
     /* 1755398 */     GIR_EraseRootFromParent_Done,
     /* 1755399 */   // Label 23897: @1755399
     /* 1755399 */   GIM_Try, /*On fail goto*//*Label 23898*/ GIMT_Encode4(1755485), // Rule ID 11372 //
     /* 1755404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755450 */     // MIs[0] policy
     /* 1755450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755460 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1755463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755484 */     // GIR_Coverage, 11372,
     /* 1755484 */     GIR_EraseRootFromParent_Done,
     /* 1755485 */   // Label 23898: @1755485
     /* 1755485 */   GIM_Try, /*On fail goto*//*Label 23899*/ GIMT_Encode4(1755571), // Rule ID 11373 //
     /* 1755490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1755501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1755504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1755507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1755510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1755513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1755520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1755532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755536 */     // MIs[0] policy
     /* 1755536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1755549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755570 */     // GIR_Coverage, 11373,
     /* 1755570 */     GIR_EraseRootFromParent_Done,
     /* 1755571 */   // Label 23899: @1755571
     /* 1755571 */   GIM_Try, /*On fail goto*//*Label 23900*/ GIMT_Encode4(1755657), // Rule ID 11376 //
     /* 1755576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1755587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1755590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1755593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1755596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755622 */     // MIs[0] policy
     /* 1755622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755632 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1755635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755656 */     // GIR_Coverage, 11376,
     /* 1755656 */     GIR_EraseRootFromParent_Done,
     /* 1755657 */   // Label 23900: @1755657
     /* 1755657 */   GIM_Try, /*On fail goto*//*Label 23901*/ GIMT_Encode4(1755743), // Rule ID 11377 //
     /* 1755662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1755673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1755676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1755679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1755682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1755685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1755692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1755704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755708 */     // MIs[0] policy
     /* 1755708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755718 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1755721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1755739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755742 */     // GIR_Coverage, 11377,
     /* 1755742 */     GIR_EraseRootFromParent_Done,
     /* 1755743 */   // Label 23901: @1755743
     /* 1755743 */   GIM_Try, /*On fail goto*//*Label 23902*/ GIMT_Encode4(1755829), // Rule ID 11380 //
     /* 1755748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1755759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1755762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1755765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1755771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755794 */     // MIs[0] policy
     /* 1755794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755804 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1755807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755828 */     // GIR_Coverage, 11380,
     /* 1755828 */     GIR_EraseRootFromParent_Done,
     /* 1755829 */   // Label 23902: @1755829
     /* 1755829 */   GIM_Try, /*On fail goto*//*Label 23903*/ GIMT_Encode4(1755915), // Rule ID 11381 //
     /* 1755834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1755837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1755845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1755848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1755851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1755854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1755857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1755860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755880 */     // MIs[0] policy
     /* 1755880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755890 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1755890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF8_MASK),
     /* 1755893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1755914 */     // GIR_Coverage, 11381,
     /* 1755914 */     GIR_EraseRootFromParent_Done,
     /* 1755915 */   // Label 23903: @1755915
     /* 1755915 */   GIM_Try, /*On fail goto*//*Label 23904*/ GIMT_Encode4(1756001), // Rule ID 11384 //
     /* 1755920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1755923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1755928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1755931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1755934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1755937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1755940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1755943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1755946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1755950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1755958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1755962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1755966 */     // MIs[0] policy
     /* 1755966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1755969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1755976 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1755976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1755979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1755981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1755983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1755985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1755987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1755989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1755994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1755997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1755999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756000 */     // GIR_Coverage, 11384,
     /* 1756000 */     GIR_EraseRootFromParent_Done,
     /* 1756001 */   // Label 23904: @1756001
     /* 1756001 */   GIM_Try, /*On fail goto*//*Label 23905*/ GIMT_Encode4(1756087), // Rule ID 11385 //
     /* 1756006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1756017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1756020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1756023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756052 */     // MIs[0] policy
     /* 1756052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756062 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1756065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756086 */     // GIR_Coverage, 11385,
     /* 1756086 */     GIR_EraseRootFromParent_Done,
     /* 1756087 */   // Label 23905: @1756087
     /* 1756087 */   GIM_Try, /*On fail goto*//*Label 23906*/ GIMT_Encode4(1756173), // Rule ID 11388 //
     /* 1756092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756138 */     // MIs[0] policy
     /* 1756138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756148 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756172 */     // GIR_Coverage, 11388,
     /* 1756172 */     GIR_EraseRootFromParent_Done,
     /* 1756173 */   // Label 23906: @1756173
     /* 1756173 */   GIM_Try, /*On fail goto*//*Label 23907*/ GIMT_Encode4(1756259), // Rule ID 11389 //
     /* 1756178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1756189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1756192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1756195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756224 */     // MIs[0] policy
     /* 1756224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756234 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756258 */     // GIR_Coverage, 11389,
     /* 1756258 */     GIR_EraseRootFromParent_Done,
     /* 1756259 */   // Label 23907: @1756259
     /* 1756259 */   GIM_Try, /*On fail goto*//*Label 23908*/ GIMT_Encode4(1756345), // Rule ID 11392 //
     /* 1756264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756310 */     // MIs[0] policy
     /* 1756310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756320 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1756323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756344 */     // GIR_Coverage, 11392,
     /* 1756344 */     GIR_EraseRootFromParent_Done,
     /* 1756345 */   // Label 23908: @1756345
     /* 1756345 */   GIM_Try, /*On fail goto*//*Label 23909*/ GIMT_Encode4(1756431), // Rule ID 11393 //
     /* 1756350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1756361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1756364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1756367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756396 */     // MIs[0] policy
     /* 1756396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756406 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF4_MASK),
     /* 1756409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756430 */     // GIR_Coverage, 11393,
     /* 1756430 */     GIR_EraseRootFromParent_Done,
     /* 1756431 */   // Label 23909: @1756431
     /* 1756431 */   GIM_Try, /*On fail goto*//*Label 23910*/ GIMT_Encode4(1756517), // Rule ID 11396 //
     /* 1756436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756482 */     // MIs[0] policy
     /* 1756482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756492 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756516 */     // GIR_Coverage, 11396,
     /* 1756516 */     GIR_EraseRootFromParent_Done,
     /* 1756517 */   // Label 23910: @1756517
     /* 1756517 */   GIM_Try, /*On fail goto*//*Label 23911*/ GIMT_Encode4(1756603), // Rule ID 11397 //
     /* 1756522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1756533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1756536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1756539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1756545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756568 */     // MIs[0] policy
     /* 1756568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756578 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1756599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756602 */     // GIR_Coverage, 11397,
     /* 1756602 */     GIR_EraseRootFromParent_Done,
     /* 1756603 */   // Label 23911: @1756603
     /* 1756603 */   GIM_Try, /*On fail goto*//*Label 23912*/ GIMT_Encode4(1756689), // Rule ID 11400 //
     /* 1756608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1756619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1756622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1756625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756654 */     // MIs[0] policy
     /* 1756654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756664 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756688 */     // GIR_Coverage, 11400,
     /* 1756688 */     GIR_EraseRootFromParent_Done,
     /* 1756689 */   // Label 23912: @1756689
     /* 1756689 */   GIM_Try, /*On fail goto*//*Label 23913*/ GIMT_Encode4(1756775), // Rule ID 11401 //
     /* 1756694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1756705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1756708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1756711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1756717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756740 */     // MIs[0] policy
     /* 1756740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756750 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_MF2_MASK),
     /* 1756753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1756771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756774 */     // GIR_Coverage, 11401,
     /* 1756774 */     GIR_EraseRootFromParent_Done,
     /* 1756775 */   // Label 23913: @1756775
     /* 1756775 */   GIM_Try, /*On fail goto*//*Label 23914*/ GIMT_Encode4(1756861), // Rule ID 11404 //
     /* 1756780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1756791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1756794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1756797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756826 */     // MIs[0] policy
     /* 1756826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756836 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1756836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1756839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756860 */     // GIR_Coverage, 11404,
     /* 1756860 */     GIR_EraseRootFromParent_Done,
     /* 1756861 */   // Label 23914: @1756861
     /* 1756861 */   GIM_Try, /*On fail goto*//*Label 23915*/ GIMT_Encode4(1756947), // Rule ID 11405 //
     /* 1756866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1756869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1756877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1756880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1756883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1756886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1756889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1756892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756912 */     // MIs[0] policy
     /* 1756912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1756915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1756922 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11405:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1756922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1756925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1756927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1756929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1756931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1756933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1756935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1756940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1756943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1756945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1756946 */     // GIR_Coverage, 11405,
     /* 1756946 */     GIR_EraseRootFromParent_Done,
     /* 1756947 */   // Label 23915: @1756947
     /* 1756947 */   GIM_Try, /*On fail goto*//*Label 23916*/ GIMT_Encode4(1757033), // Rule ID 11408 //
     /* 1756952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1756955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1756960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1756963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1756966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1756969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1756972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1756975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1756978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1756982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1756990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1756994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1756998 */     // MIs[0] policy
     /* 1756998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757008 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1757011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757032 */     // GIR_Coverage, 11408,
     /* 1757032 */     GIR_EraseRootFromParent_Done,
     /* 1757033 */   // Label 23916: @1757033
     /* 1757033 */   GIM_Try, /*On fail goto*//*Label 23917*/ GIMT_Encode4(1757119), // Rule ID 11409 //
     /* 1757038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1757049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1757052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1757055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1757061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757084 */     // MIs[0] policy
     /* 1757084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757094 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11405:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1757097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757118 */     // GIR_Coverage, 11409,
     /* 1757118 */     GIR_EraseRootFromParent_Done,
     /* 1757119 */   // Label 23917: @1757119
     /* 1757119 */   GIM_Try, /*On fail goto*//*Label 23918*/ GIMT_Encode4(1757205), // Rule ID 11412 //
     /* 1757124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757170 */     // MIs[0] policy
     /* 1757170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757180 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1757183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757204 */     // GIR_Coverage, 11412,
     /* 1757204 */     GIR_EraseRootFromParent_Done,
     /* 1757205 */   // Label 23918: @1757205
     /* 1757205 */   GIM_Try, /*On fail goto*//*Label 23919*/ GIMT_Encode4(1757291), // Rule ID 11413 //
     /* 1757210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1757221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1757224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1757227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1757233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1757240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1757248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757256 */     // MIs[0] policy
     /* 1757256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757266 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11405:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1757269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1757287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757290 */     // GIR_Coverage, 11413,
     /* 1757290 */     GIR_EraseRootFromParent_Done,
     /* 1757291 */   // Label 23919: @1757291
     /* 1757291 */   GIM_Try, /*On fail goto*//*Label 23920*/ GIMT_Encode4(1757377), // Rule ID 11416 //
     /* 1757296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757342 */     // MIs[0] policy
     /* 1757342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757352 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1757355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757376 */     // GIR_Coverage, 11416,
     /* 1757376 */     GIR_EraseRootFromParent_Done,
     /* 1757377 */   // Label 23920: @1757377
     /* 1757377 */   GIM_Try, /*On fail goto*//*Label 23921*/ GIMT_Encode4(1757463), // Rule ID 11417 //
     /* 1757382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1757393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1757396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1757399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1757405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757428 */     // MIs[0] policy
     /* 1757428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757438 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1757441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757462 */     // GIR_Coverage, 11417,
     /* 1757462 */     GIR_EraseRootFromParent_Done,
     /* 1757463 */   // Label 23921: @1757463
     /* 1757463 */   GIM_Try, /*On fail goto*//*Label 23922*/ GIMT_Encode4(1757549), // Rule ID 11420 //
     /* 1757468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757514 */     // MIs[0] policy
     /* 1757514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757524 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1757527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757548 */     // GIR_Coverage, 11420,
     /* 1757548 */     GIR_EraseRootFromParent_Done,
     /* 1757549 */   // Label 23922: @1757549
     /* 1757549 */   GIM_Try, /*On fail goto*//*Label 23923*/ GIMT_Encode4(1757635), // Rule ID 11421 //
     /* 1757554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1757565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1757568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1757571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1757577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1757584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1757592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757600 */     // MIs[0] policy
     /* 1757600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757610 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1757613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757634 */     // GIR_Coverage, 11421,
     /* 1757634 */     GIR_EraseRootFromParent_Done,
     /* 1757635 */   // Label 23923: @1757635
     /* 1757635 */   GIM_Try, /*On fail goto*//*Label 23924*/ GIMT_Encode4(1757721), // Rule ID 11424 //
     /* 1757640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1757651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1757654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1757657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1757663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757686 */     // MIs[0] policy
     /* 1757686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757696 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1757699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757720 */     // GIR_Coverage, 11424,
     /* 1757720 */     GIR_EraseRootFromParent_Done,
     /* 1757721 */   // Label 23924: @1757721
     /* 1757721 */   GIM_Try, /*On fail goto*//*Label 23925*/ GIMT_Encode4(1757807), // Rule ID 11425 //
     /* 1757726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1757737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1757740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1757743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1757749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1757756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1757764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757772 */     // MIs[0] policy
     /* 1757772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757782 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1757785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1757803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757806 */     // GIR_Coverage, 11425,
     /* 1757806 */     GIR_EraseRootFromParent_Done,
     /* 1757807 */   // Label 23925: @1757807
     /* 1757807 */   GIM_Try, /*On fail goto*//*Label 23926*/ GIMT_Encode4(1757893), // Rule ID 11428 //
     /* 1757812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1757823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1757826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1757829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1757832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1757838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757858 */     // MIs[0] policy
     /* 1757858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757868 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1757868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1757871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757892 */     // GIR_Coverage, 11428,
     /* 1757892 */     GIR_EraseRootFromParent_Done,
     /* 1757893 */   // Label 23926: @1757893
     /* 1757893 */   GIM_Try, /*On fail goto*//*Label 23927*/ GIMT_Encode4(1757979), // Rule ID 11429 //
     /* 1757898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1757901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1757909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1757912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1757915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1757918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1757921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1757924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1757928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1757936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1757940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1757944 */     // MIs[0] policy
     /* 1757944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1757947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1757954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1757954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1757957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1757959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1757961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1757963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1757965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1757967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1757972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1757975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1757977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1757978 */     // GIR_Coverage, 11429,
     /* 1757978 */     GIR_EraseRootFromParent_Done,
     /* 1757979 */   // Label 23927: @1757979
     /* 1757979 */   GIM_Try, /*On fail goto*//*Label 23928*/ GIMT_Encode4(1758065), // Rule ID 11432 //
     /* 1757984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1757987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1757992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1757995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1757998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758030 */     // MIs[0] policy
     /* 1758030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758040 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1758043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758064 */     // GIR_Coverage, 11432,
     /* 1758064 */     GIR_EraseRootFromParent_Done,
     /* 1758065 */   // Label 23928: @1758065
     /* 1758065 */   GIM_Try, /*On fail goto*//*Label 23929*/ GIMT_Encode4(1758151), // Rule ID 11433 //
     /* 1758070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1758081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1758084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1758087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758116 */     // MIs[0] policy
     /* 1758116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758126 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1758129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758150 */     // GIR_Coverage, 11433,
     /* 1758150 */     GIR_EraseRootFromParent_Done,
     /* 1758151 */   // Label 23929: @1758151
     /* 1758151 */   GIM_Try, /*On fail goto*//*Label 23930*/ GIMT_Encode4(1758237), // Rule ID 11436 //
     /* 1758156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758202 */     // MIs[0] policy
     /* 1758202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758212 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1758215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758236 */     // GIR_Coverage, 11436,
     /* 1758236 */     GIR_EraseRootFromParent_Done,
     /* 1758237 */   // Label 23930: @1758237
     /* 1758237 */   GIM_Try, /*On fail goto*//*Label 23931*/ GIMT_Encode4(1758323), // Rule ID 11437 //
     /* 1758242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1758253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1758256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1758259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1758265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758288 */     // MIs[0] policy
     /* 1758288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758298 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1758301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1758319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758322 */     // GIR_Coverage, 11437,
     /* 1758322 */     GIR_EraseRootFromParent_Done,
     /* 1758323 */   // Label 23931: @1758323
     /* 1758323 */   GIM_Try, /*On fail goto*//*Label 23932*/ GIMT_Encode4(1758409), // Rule ID 11440 //
     /* 1758328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758374 */     // MIs[0] policy
     /* 1758374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758384 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1758387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758408 */     // GIR_Coverage, 11440,
     /* 1758408 */     GIR_EraseRootFromParent_Done,
     /* 1758409 */   // Label 23932: @1758409
     /* 1758409 */   GIM_Try, /*On fail goto*//*Label 23933*/ GIMT_Encode4(1758495), // Rule ID 11441 //
     /* 1758414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1758425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1758428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1758431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1758437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1758444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1758452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758460 */     // MIs[0] policy
     /* 1758460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758470 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1758473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758494 */     // GIR_Coverage, 11441,
     /* 1758494 */     GIR_EraseRootFromParent_Done,
     /* 1758495 */   // Label 23933: @1758495
     /* 1758495 */   GIM_Try, /*On fail goto*//*Label 23934*/ GIMT_Encode4(1758581), // Rule ID 11444 //
     /* 1758500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1758511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1758514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1758517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758546 */     // MIs[0] policy
     /* 1758546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758556 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1758559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758580 */     // GIR_Coverage, 11444,
     /* 1758580 */     GIR_EraseRootFromParent_Done,
     /* 1758581 */   // Label 23934: @1758581
     /* 1758581 */   GIM_Try, /*On fail goto*//*Label 23935*/ GIMT_Encode4(1758667), // Rule ID 11445 //
     /* 1758586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1758597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1758600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1758603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1758609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1758616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1758624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758632 */     // MIs[0] policy
     /* 1758632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758642 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1758645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758666 */     // GIR_Coverage, 11445,
     /* 1758666 */     GIR_EraseRootFromParent_Done,
     /* 1758667 */   // Label 23935: @1758667
     /* 1758667 */   GIM_Try, /*On fail goto*//*Label 23936*/ GIMT_Encode4(1758753), // Rule ID 11448 //
     /* 1758672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1758675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1758683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1758686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1758689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1758692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758718 */     // MIs[0] policy
     /* 1758718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758728 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1758731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758752 */     // GIR_Coverage, 11448,
     /* 1758752 */     GIR_EraseRootFromParent_Done,
     /* 1758753 */   // Label 23936: @1758753
     /* 1758753 */   GIM_Try, /*On fail goto*//*Label 23937*/ GIMT_Encode4(1758839), // Rule ID 11449 //
     /* 1758758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1758761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1758766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1758769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1758772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1758775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1758778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1758781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1758788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1758796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1758800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758804 */     // MIs[0] policy
     /* 1758804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758814 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1758817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1758835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758838 */     // GIR_Coverage, 11449,
     /* 1758838 */     GIR_EraseRootFromParent_Done,
     /* 1758839 */   // Label 23937: @1758839
     /* 1758839 */   GIM_Try, /*On fail goto*//*Label 23938*/ GIMT_Encode4(1758925), // Rule ID 11452 //
     /* 1758844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1758847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1758852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1758855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1758858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1758861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1758864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1758867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1758870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758890 */     // MIs[0] policy
     /* 1758890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758900 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1758900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1758903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1758918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1758921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1758923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1758924 */     // GIR_Coverage, 11452,
     /* 1758924 */     GIR_EraseRootFromParent_Done,
     /* 1758925 */   // Label 23938: @1758925
     /* 1758925 */   GIM_Try, /*On fail goto*//*Label 23939*/ GIMT_Encode4(1759011), // Rule ID 11453 //
     /* 1758930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1758933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1758938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1758941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1758944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1758947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1758950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1758953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1758956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1758960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1758972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1758976 */     // MIs[0] policy
     /* 1758976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1758979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1758986 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1758986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1_MASK),
     /* 1758989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1758991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1758993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1758995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1758997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1758999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759010 */     // GIR_Coverage, 11453,
     /* 1759010 */     GIR_EraseRootFromParent_Done,
     /* 1759011 */   // Label 23939: @1759011
     /* 1759011 */   GIM_Try, /*On fail goto*//*Label 23940*/ GIMT_Encode4(1759097), // Rule ID 11456 //
     /* 1759016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1759027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1759030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1759033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1759036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759062 */     // MIs[0] policy
     /* 1759062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1759075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759096 */     // GIR_Coverage, 11456,
     /* 1759096 */     GIR_EraseRootFromParent_Done,
     /* 1759097 */   // Label 23940: @1759097
     /* 1759097 */   GIM_Try, /*On fail goto*//*Label 23941*/ GIMT_Encode4(1759183), // Rule ID 11457 //
     /* 1759102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1759113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1759116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1759119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1759122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759148 */     // MIs[0] policy
     /* 1759148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759158 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2_MASK),
     /* 1759161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759182 */     // GIR_Coverage, 11457,
     /* 1759182 */     GIR_EraseRootFromParent_Done,
     /* 1759183 */   // Label 23941: @1759183
     /* 1759183 */   GIM_Try, /*On fail goto*//*Label 23942*/ GIMT_Encode4(1759269), // Rule ID 11460 //
     /* 1759188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1759199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1759202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1759205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1759208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759234 */     // MIs[0] policy
     /* 1759234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759244 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1759247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759268 */     // GIR_Coverage, 11460,
     /* 1759268 */     GIR_EraseRootFromParent_Done,
     /* 1759269 */   // Label 23942: @1759269
     /* 1759269 */   GIM_Try, /*On fail goto*//*Label 23943*/ GIMT_Encode4(1759355), // Rule ID 11461 //
     /* 1759274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1759285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1759288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1759291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1759294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759320 */     // MIs[0] policy
     /* 1759320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759330 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4_MASK),
     /* 1759333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759354 */     // GIR_Coverage, 11461,
     /* 1759354 */     GIR_EraseRootFromParent_Done,
     /* 1759355 */   // Label 23943: @1759355
     /* 1759355 */   GIM_Try, /*On fail goto*//*Label 23944*/ GIMT_Encode4(1759441), // Rule ID 11464 //
     /* 1759360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1759371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1759374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1759377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1759380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759406 */     // MIs[0] policy
     /* 1759406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759416 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1759419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759440 */     // GIR_Coverage, 11464,
     /* 1759440 */     GIR_EraseRootFromParent_Done,
     /* 1759441 */   // Label 23944: @1759441
     /* 1759441 */   GIM_Try, /*On fail goto*//*Label 23945*/ GIMT_Encode4(1759527), // Rule ID 11465 //
     /* 1759446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1759457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1759460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1759463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1759466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1759469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1759476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1759488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759492 */     // MIs[0] policy
     /* 1759492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759502 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8_MASK),
     /* 1759505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759526 */     // GIR_Coverage, 11465,
     /* 1759526 */     GIR_EraseRootFromParent_Done,
     /* 1759527 */   // Label 23945: @1759527
     /* 1759527 */   GIM_Try, /*On fail goto*//*Label 23946*/ GIMT_Encode4(1759613), // Rule ID 11468 //
     /* 1759532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1759543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1759546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1759549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759578 */     // MIs[0] policy
     /* 1759578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759588 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1759591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759612 */     // GIR_Coverage, 11468,
     /* 1759612 */     GIR_EraseRootFromParent_Done,
     /* 1759613 */   // Label 23946: @1759613
     /* 1759613 */   GIM_Try, /*On fail goto*//*Label 23947*/ GIMT_Encode4(1759699), // Rule ID 11469 //
     /* 1759618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1759629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1759632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1759635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1759641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1759648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1759656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759664 */     // MIs[0] policy
     /* 1759664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759674 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11403:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M1_MASK),
     /* 1759677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759698 */     // GIR_Coverage, 11469,
     /* 1759698 */     GIR_EraseRootFromParent_Done,
     /* 1759699 */   // Label 23947: @1759699
     /* 1759699 */   GIM_Try, /*On fail goto*//*Label 23948*/ GIMT_Encode4(1759785), // Rule ID 11472 //
     /* 1759704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1759715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1759718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1759721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759750 */     // MIs[0] policy
     /* 1759750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1759763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759784 */     // GIR_Coverage, 11472,
     /* 1759784 */     GIR_EraseRootFromParent_Done,
     /* 1759785 */   // Label 23948: @1759785
     /* 1759785 */   GIM_Try, /*On fail goto*//*Label 23949*/ GIMT_Encode4(1759871), // Rule ID 11473 //
     /* 1759790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1759801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1759804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1759807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1759813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1759820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1759828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759836 */     // MIs[0] policy
     /* 1759836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11403:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1759846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M2_MASK),
     /* 1759849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759870 */     // GIR_Coverage, 11473,
     /* 1759870 */     GIR_EraseRootFromParent_Done,
     /* 1759871 */   // Label 23949: @1759871
     /* 1759871 */   GIM_Try, /*On fail goto*//*Label 23950*/ GIMT_Encode4(1759957), // Rule ID 11476 //
     /* 1759876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1759879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1759887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1759890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1759893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1759896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1759902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1759918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1759922 */     // MIs[0] policy
     /* 1759922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1759925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1759932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1759932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1759935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1759937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1759939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1759941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1759943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1759945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1759950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1759953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1759955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1759956 */     // GIR_Coverage, 11476,
     /* 1759956 */     GIR_EraseRootFromParent_Done,
     /* 1759957 */   // Label 23950: @1759957
     /* 1759957 */   GIM_Try, /*On fail goto*//*Label 23951*/ GIMT_Encode4(1760043), // Rule ID 11477 //
     /* 1759962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1759965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1759970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1759973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1759976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1759979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1759982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1759985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1759988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1759992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1759996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760008 */     // MIs[0] policy
     /* 1760008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11403:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M4_MASK),
     /* 1760021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760042 */     // GIR_Coverage, 11477,
     /* 1760042 */     GIR_EraseRootFromParent_Done,
     /* 1760043 */   // Label 23951: @1760043
     /* 1760043 */   GIM_Try, /*On fail goto*//*Label 23952*/ GIMT_Encode4(1760129), // Rule ID 11480 //
     /* 1760048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1760056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1760065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760094 */     // MIs[0] policy
     /* 1760094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1760107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760128 */     // GIR_Coverage, 11480,
     /* 1760128 */     GIR_EraseRootFromParent_Done,
     /* 1760129 */   // Label 23952: @1760129
     /* 1760129 */   GIM_Try, /*On fail goto*//*Label 23953*/ GIMT_Encode4(1760215), // Rule ID 11481 //
     /* 1760134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulh_mask),
     /* 1760142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1760151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1760154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760180 */     // MIs[0] policy
     /* 1760180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11403:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VX_M8_MASK),
     /* 1760193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760214 */     // GIR_Coverage, 11481,
     /* 1760214 */     GIR_EraseRootFromParent_Done,
     /* 1760215 */   // Label 23953: @1760215
     /* 1760215 */   GIM_Try, /*On fail goto*//*Label 23954*/ GIMT_Encode4(1760301), // Rule ID 11484 //
     /* 1760220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1760231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1760234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1760237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1760240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760266 */     // MIs[0] policy
     /* 1760266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760276 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1760279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760300 */     // GIR_Coverage, 11484,
     /* 1760300 */     GIR_EraseRootFromParent_Done,
     /* 1760301 */   // Label 23954: @1760301
     /* 1760301 */   GIM_Try, /*On fail goto*//*Label 23955*/ GIMT_Encode4(1760387), // Rule ID 11485 //
     /* 1760306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1760317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1760320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1760323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1760326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760352 */     // MIs[0] policy
     /* 1760352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760362 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1_MASK),
     /* 1760365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760386 */     // GIR_Coverage, 11485,
     /* 1760386 */     GIR_EraseRootFromParent_Done,
     /* 1760387 */   // Label 23955: @1760387
     /* 1760387 */   GIM_Try, /*On fail goto*//*Label 23956*/ GIMT_Encode4(1760473), // Rule ID 11488 //
     /* 1760392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1760403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1760406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1760409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1760412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760438 */     // MIs[0] policy
     /* 1760438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1760451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760472 */     // GIR_Coverage, 11488,
     /* 1760472 */     GIR_EraseRootFromParent_Done,
     /* 1760473 */   // Label 23956: @1760473
     /* 1760473 */   GIM_Try, /*On fail goto*//*Label 23957*/ GIMT_Encode4(1760559), // Rule ID 11489 //
     /* 1760478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1760489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1760492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1760495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1760498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1760501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1760508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1760520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760524 */     // MIs[0] policy
     /* 1760524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2_MASK),
     /* 1760537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760558 */     // GIR_Coverage, 11489,
     /* 1760558 */     GIR_EraseRootFromParent_Done,
     /* 1760559 */   // Label 23957: @1760559
     /* 1760559 */   GIM_Try, /*On fail goto*//*Label 23958*/ GIMT_Encode4(1760645), // Rule ID 11492 //
     /* 1760564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1760575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1760578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1760581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1760584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1760594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760610 */     // MIs[0] policy
     /* 1760610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760620 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1760623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760644 */     // GIR_Coverage, 11492,
     /* 1760644 */     GIR_EraseRootFromParent_Done,
     /* 1760645 */   // Label 23958: @1760645
     /* 1760645 */   GIM_Try, /*On fail goto*//*Label 23959*/ GIMT_Encode4(1760731), // Rule ID 11493 //
     /* 1760650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1760661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1760664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1760667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1760670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1760673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1760680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1760692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760696 */     // MIs[0] policy
     /* 1760696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760706 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4_MASK),
     /* 1760709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760730 */     // GIR_Coverage, 11493,
     /* 1760730 */     GIR_EraseRootFromParent_Done,
     /* 1760731 */   // Label 23959: @1760731
     /* 1760731 */   GIM_Try, /*On fail goto*//*Label 23960*/ GIMT_Encode4(1760817), // Rule ID 11496 //
     /* 1760736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1760753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1760756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760782 */     // MIs[0] policy
     /* 1760782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760792 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1760795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760816 */     // GIR_Coverage, 11496,
     /* 1760816 */     GIR_EraseRootFromParent_Done,
     /* 1760817 */   // Label 23960: @1760817
     /* 1760817 */   GIM_Try, /*On fail goto*//*Label 23961*/ GIMT_Encode4(1760903), // Rule ID 11497 //
     /* 1760822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1760833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1760836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1760839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1760842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1760845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1760848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1760852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1760864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760868 */     // MIs[0] policy
     /* 1760868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760878 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1760878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8_MASK),
     /* 1760881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760902 */     // GIR_Coverage, 11497,
     /* 1760902 */     GIR_EraseRootFromParent_Done,
     /* 1760903 */   // Label 23961: @1760903
     /* 1760903 */   GIM_Try, /*On fail goto*//*Label 23962*/ GIMT_Encode4(1760989), // Rule ID 11500 //
     /* 1760908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1760911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1760916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1760919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1760922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1760925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1760928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1760931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1760934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1760938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1760946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1760950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1760954 */     // MIs[0] policy
     /* 1760954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1760957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1760964 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1760964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1760967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1760969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1760971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1760973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1760975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1760977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1760982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1760985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1760987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1760988 */     // GIR_Coverage, 11500,
     /* 1760988 */     GIR_EraseRootFromParent_Done,
     /* 1760989 */   // Label 23962: @1760989
     /* 1760989 */   GIM_Try, /*On fail goto*//*Label 23963*/ GIMT_Encode4(1761075), // Rule ID 11501 //
     /* 1760994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1760997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1761005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1761008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1761011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761040 */     // MIs[0] policy
     /* 1761040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761050 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11407:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M1_MASK),
     /* 1761053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761074 */     // GIR_Coverage, 11501,
     /* 1761074 */     GIR_EraseRootFromParent_Done,
     /* 1761075 */   // Label 23963: @1761075
     /* 1761075 */   GIM_Try, /*On fail goto*//*Label 23964*/ GIMT_Encode4(1761161), // Rule ID 11504 //
     /* 1761080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1761091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1761094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1761097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761126 */     // MIs[0] policy
     /* 1761126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1761139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761160 */     // GIR_Coverage, 11504,
     /* 1761160 */     GIR_EraseRootFromParent_Done,
     /* 1761161 */   // Label 23964: @1761161
     /* 1761161 */   GIM_Try, /*On fail goto*//*Label 23965*/ GIMT_Encode4(1761247), // Rule ID 11505 //
     /* 1761166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1761169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1761177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1761180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1761183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761212 */     // MIs[0] policy
     /* 1761212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11407:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M2_MASK),
     /* 1761225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761246 */     // GIR_Coverage, 11505,
     /* 1761246 */     GIR_EraseRootFromParent_Done,
     /* 1761247 */   // Label 23965: @1761247
     /* 1761247 */   GIM_Try, /*On fail goto*//*Label 23966*/ GIMT_Encode4(1761333), // Rule ID 11508 //
     /* 1761252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1761263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1761266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1761269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761298 */     // MIs[0] policy
     /* 1761298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761308 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1761311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761332 */     // GIR_Coverage, 11508,
     /* 1761332 */     GIR_EraseRootFromParent_Done,
     /* 1761333 */   // Label 23966: @1761333
     /* 1761333 */   GIM_Try, /*On fail goto*//*Label 23967*/ GIMT_Encode4(1761419), // Rule ID 11509 //
     /* 1761338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1761341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1761349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1761352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1761355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761384 */     // MIs[0] policy
     /* 1761384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761394 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11407:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M4_MASK),
     /* 1761397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761418 */     // GIR_Coverage, 11509,
     /* 1761418 */     GIR_EraseRootFromParent_Done,
     /* 1761419 */   // Label 23967: @1761419
     /* 1761419 */   GIM_Try, /*On fail goto*//*Label 23968*/ GIMT_Encode4(1761505), // Rule ID 11512 //
     /* 1761424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1761435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1761438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1761441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1761444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761470 */     // MIs[0] policy
     /* 1761470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761480 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1761483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761504 */     // GIR_Coverage, 11512,
     /* 1761504 */     GIR_EraseRootFromParent_Done,
     /* 1761505 */   // Label 23968: @1761505
     /* 1761505 */   GIM_Try, /*On fail goto*//*Label 23969*/ GIMT_Encode4(1761591), // Rule ID 11513 //
     /* 1761510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1761513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhu_mask),
     /* 1761518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1761521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1761524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1761527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1761530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1761533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1761540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1761548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1761552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761556 */     // MIs[0] policy
     /* 1761556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761566 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11407:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VX_M8_MASK),
     /* 1761569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761590 */     // GIR_Coverage, 11513,
     /* 1761590 */     GIR_EraseRootFromParent_Done,
     /* 1761591 */   // Label 23969: @1761591
     /* 1761591 */   GIM_Try, /*On fail goto*//*Label 23970*/ GIMT_Encode4(1761677), // Rule ID 11516 //
     /* 1761596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1761607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1761610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1761613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1761616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761642 */     // MIs[0] policy
     /* 1761642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761652 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761676 */     // GIR_Coverage, 11516,
     /* 1761676 */     GIR_EraseRootFromParent_Done,
     /* 1761677 */   // Label 23970: @1761677
     /* 1761677 */   GIM_Try, /*On fail goto*//*Label 23971*/ GIMT_Encode4(1761763), // Rule ID 11517 //
     /* 1761682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1761685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1761693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1761696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1761699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1761702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1761705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1761712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1761724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761728 */     // MIs[0] policy
     /* 1761728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761738 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M1_MASK),
     /* 1761741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761762 */     // GIR_Coverage, 11517,
     /* 1761762 */     GIR_EraseRootFromParent_Done,
     /* 1761763 */   // Label 23971: @1761763
     /* 1761763 */   GIM_Try, /*On fail goto*//*Label 23972*/ GIMT_Encode4(1761849), // Rule ID 11520 //
     /* 1761768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1761779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1761782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1761785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1761788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761814 */     // MIs[0] policy
     /* 1761814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761848 */     // GIR_Coverage, 11520,
     /* 1761848 */     GIR_EraseRootFromParent_Done,
     /* 1761849 */   // Label 23972: @1761849
     /* 1761849 */   GIM_Try, /*On fail goto*//*Label 23973*/ GIMT_Encode4(1761935), // Rule ID 11521 //
     /* 1761854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1761857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1761865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1761868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1761871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1761874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1761877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1761880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1761884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1761896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761900 */     // MIs[0] policy
     /* 1761900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1761910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M2_MASK),
     /* 1761913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1761915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1761917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1761919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1761921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1761923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1761928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1761931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1761933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1761934 */     // GIR_Coverage, 11521,
     /* 1761934 */     GIR_EraseRootFromParent_Done,
     /* 1761935 */   // Label 23973: @1761935
     /* 1761935 */   GIM_Try, /*On fail goto*//*Label 23974*/ GIMT_Encode4(1762021), // Rule ID 11524 //
     /* 1761940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1761943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1761948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1761951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1761954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1761957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1761960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1761963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1761966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1761970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1761982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1761986 */     // MIs[0] policy
     /* 1761986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1761989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1761996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1761996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1761999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762020 */     // GIR_Coverage, 11524,
     /* 1762020 */     GIR_EraseRootFromParent_Done,
     /* 1762021 */   // Label 23974: @1762021
     /* 1762021 */   GIM_Try, /*On fail goto*//*Label 23975*/ GIMT_Encode4(1762107), // Rule ID 11525 //
     /* 1762026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1762037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1762040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1762043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1762046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762072 */     // MIs[0] policy
     /* 1762072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762082 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M4_MASK),
     /* 1762085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762106 */     // GIR_Coverage, 11525,
     /* 1762106 */     GIR_EraseRootFromParent_Done,
     /* 1762107 */   // Label 23975: @1762107
     /* 1762107 */   GIM_Try, /*On fail goto*//*Label 23976*/ GIMT_Encode4(1762193), // Rule ID 11528 //
     /* 1762112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1762115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1762129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1762132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762158 */     // MIs[0] policy
     /* 1762158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762168 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762192 */     // GIR_Coverage, 11528,
     /* 1762192 */     GIR_EraseRootFromParent_Done,
     /* 1762193 */   // Label 23976: @1762193
     /* 1762193 */   GIM_Try, /*On fail goto*//*Label 23977*/ GIMT_Encode4(1762279), // Rule ID 11529 //
     /* 1762198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1762215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1762218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762244 */     // MIs[0] policy
     /* 1762244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762254 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VV_M8_MASK),
     /* 1762257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762278 */     // GIR_Coverage, 11529,
     /* 1762278 */     GIR_EraseRootFromParent_Done,
     /* 1762279 */   // Label 23977: @1762279
     /* 1762279 */   GIM_Try, /*On fail goto*//*Label 23978*/ GIMT_Encode4(1762365), // Rule ID 11532 //
     /* 1762284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1762287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1762295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1762298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1762301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762330 */     // MIs[0] policy
     /* 1762330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762340 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1762343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762364 */     // GIR_Coverage, 11532,
     /* 1762364 */     GIR_EraseRootFromParent_Done,
     /* 1762365 */   // Label 23978: @1762365
     /* 1762365 */   GIM_Try, /*On fail goto*//*Label 23979*/ GIMT_Encode4(1762451), // Rule ID 11533 //
     /* 1762370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1762381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1762384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1762387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1762400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1762408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762416 */     // MIs[0] policy
     /* 1762416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762426 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11405:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M1_MASK),
     /* 1762429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762450 */     // GIR_Coverage, 11533,
     /* 1762450 */     GIR_EraseRootFromParent_Done,
     /* 1762451 */   // Label 23979: @1762451
     /* 1762451 */   GIM_Try, /*On fail goto*//*Label 23980*/ GIMT_Encode4(1762537), // Rule ID 11536 //
     /* 1762456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1762459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1762467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1762470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1762473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762502 */     // MIs[0] policy
     /* 1762502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762512 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762536 */     // GIR_Coverage, 11536,
     /* 1762536 */     GIR_EraseRootFromParent_Done,
     /* 1762537 */   // Label 23980: @1762537
     /* 1762537 */   GIM_Try, /*On fail goto*//*Label 23981*/ GIMT_Encode4(1762623), // Rule ID 11537 //
     /* 1762542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1762553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1762556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1762559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1762565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1762572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1762580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762588 */     // MIs[0] policy
     /* 1762588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11405:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M2_MASK),
     /* 1762601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762622 */     // GIR_Coverage, 11537,
     /* 1762622 */     GIR_EraseRootFromParent_Done,
     /* 1762623 */   // Label 23981: @1762623
     /* 1762623 */   GIM_Try, /*On fail goto*//*Label 23982*/ GIMT_Encode4(1762709), // Rule ID 11540 //
     /* 1762628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1762631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1762639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1762642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1762645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762674 */     // MIs[0] policy
     /* 1762674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762684 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762708 */     // GIR_Coverage, 11540,
     /* 1762708 */     GIR_EraseRootFromParent_Done,
     /* 1762709 */   // Label 23982: @1762709
     /* 1762709 */   GIM_Try, /*On fail goto*//*Label 23983*/ GIMT_Encode4(1762795), // Rule ID 11541 //
     /* 1762714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1762725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1762728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1762731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1762737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1762744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1762752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762760 */     // MIs[0] policy
     /* 1762760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762770 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11405:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M4_MASK),
     /* 1762773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762794 */     // GIR_Coverage, 11541,
     /* 1762794 */     GIR_EraseRootFromParent_Done,
     /* 1762795 */   // Label 23983: @1762795
     /* 1762795 */   GIM_Try, /*On fail goto*//*Label 23984*/ GIMT_Encode4(1762881), // Rule ID 11544 //
     /* 1762800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 1762803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1762817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1762820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762846 */     // MIs[0] policy
     /* 1762846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762856 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1762856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762880 */     // GIR_Coverage, 11544,
     /* 1762880 */     GIR_EraseRootFromParent_Done,
     /* 1762881 */   // Label 23984: @1762881
     /* 1762881 */   GIM_Try, /*On fail goto*//*Label 23985*/ GIMT_Encode4(1762967), // Rule ID 11545 //
     /* 1762886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 1762889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmulhsu_mask),
     /* 1762894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1762897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1762900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1762903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1762906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1762909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1762912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1762916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1762924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1762928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1762932 */     // MIs[0] policy
     /* 1762932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1762935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1762942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11405:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMULHSU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1762942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHSU_VX_M8_MASK),
     /* 1762945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1762947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1762949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1762951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1762953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1762955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1762960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1762963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1762965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1762966 */     // GIR_Coverage, 11545,
     /* 1762966 */     GIR_EraseRootFromParent_Done,
     /* 1762967 */   // Label 23985: @1762967
     /* 1762967 */   GIM_Try, /*On fail goto*//*Label 23986*/ GIMT_Encode4(1763053), // Rule ID 11548 //
     /* 1762972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1762975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1762980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1762983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1762986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1762989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1762992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1762995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1762998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763018 */     // MIs[0] policy
     /* 1763018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763028 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1763031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763052 */     // GIR_Coverage, 11548,
     /* 1763052 */     GIR_EraseRootFromParent_Done,
     /* 1763053 */   // Label 23986: @1763053
     /* 1763053 */   GIM_Try, /*On fail goto*//*Label 23987*/ GIMT_Encode4(1763139), // Rule ID 11549 //
     /* 1763058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1763069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1763072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1763075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1763078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763104 */     // MIs[0] policy
     /* 1763104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763114 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF8_E8_MASK),
     /* 1763117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763138 */     // GIR_Coverage, 11549,
     /* 1763138 */     GIR_EraseRootFromParent_Done,
     /* 1763139 */   // Label 23987: @1763139
     /* 1763139 */   GIM_Try, /*On fail goto*//*Label 23988*/ GIMT_Encode4(1763225), // Rule ID 11552 //
     /* 1763144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763190 */     // MIs[0] policy
     /* 1763190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763200 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1763203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763224 */     // GIR_Coverage, 11552,
     /* 1763224 */     GIR_EraseRootFromParent_Done,
     /* 1763225 */   // Label 23988: @1763225
     /* 1763225 */   GIM_Try, /*On fail goto*//*Label 23989*/ GIMT_Encode4(1763311), // Rule ID 11553 //
     /* 1763230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1763241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1763244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1763247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1763250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763276 */     // MIs[0] policy
     /* 1763276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763286 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E8_MASK),
     /* 1763289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763310 */     // GIR_Coverage, 11553,
     /* 1763310 */     GIR_EraseRootFromParent_Done,
     /* 1763311 */   // Label 23989: @1763311
     /* 1763311 */   GIM_Try, /*On fail goto*//*Label 23990*/ GIMT_Encode4(1763397), // Rule ID 11556 //
     /* 1763316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763362 */     // MIs[0] policy
     /* 1763362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763372 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1763375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763396 */     // GIR_Coverage, 11556,
     /* 1763396 */     GIR_EraseRootFromParent_Done,
     /* 1763397 */   // Label 23990: @1763397
     /* 1763397 */   GIM_Try, /*On fail goto*//*Label 23991*/ GIMT_Encode4(1763483), // Rule ID 11557 //
     /* 1763402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1763413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1763416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1763419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1763422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1763425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763448 */     // MIs[0] policy
     /* 1763448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763458 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E8_MASK),
     /* 1763461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1763479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763482 */     // GIR_Coverage, 11557,
     /* 1763482 */     GIR_EraseRootFromParent_Done,
     /* 1763483 */   // Label 23991: @1763483
     /* 1763483 */   GIM_Try, /*On fail goto*//*Label 23992*/ GIMT_Encode4(1763569), // Rule ID 11560 //
     /* 1763488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763534 */     // MIs[0] policy
     /* 1763534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763544 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1763547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763568 */     // GIR_Coverage, 11560,
     /* 1763568 */     GIR_EraseRootFromParent_Done,
     /* 1763569 */   // Label 23992: @1763569
     /* 1763569 */   GIM_Try, /*On fail goto*//*Label 23993*/ GIMT_Encode4(1763655), // Rule ID 11561 //
     /* 1763574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1763585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1763588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1763591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1763594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763620 */     // MIs[0] policy
     /* 1763620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763630 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF4_E16_MASK),
     /* 1763633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763654 */     // GIR_Coverage, 11561,
     /* 1763654 */     GIR_EraseRootFromParent_Done,
     /* 1763655 */   // Label 23993: @1763655
     /* 1763655 */   GIM_Try, /*On fail goto*//*Label 23994*/ GIMT_Encode4(1763741), // Rule ID 11564 //
     /* 1763660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763706 */     // MIs[0] policy
     /* 1763706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763716 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1763719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763740 */     // GIR_Coverage, 11564,
     /* 1763740 */     GIR_EraseRootFromParent_Done,
     /* 1763741 */   // Label 23994: @1763741
     /* 1763741 */   GIM_Try, /*On fail goto*//*Label 23995*/ GIMT_Encode4(1763827), // Rule ID 11565 //
     /* 1763746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1763757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1763760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1763763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1763766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1763769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763792 */     // MIs[0] policy
     /* 1763792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763802 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E16_MASK),
     /* 1763805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1763823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763826 */     // GIR_Coverage, 11565,
     /* 1763826 */     GIR_EraseRootFromParent_Done,
     /* 1763827 */   // Label 23995: @1763827
     /* 1763827 */   GIM_Try, /*On fail goto*//*Label 23996*/ GIMT_Encode4(1763913), // Rule ID 11568 //
     /* 1763832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1763835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1763852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1763858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763878 */     // MIs[0] policy
     /* 1763878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763888 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1763888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1763891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763912 */     // GIR_Coverage, 11568,
     /* 1763912 */     GIR_EraseRootFromParent_Done,
     /* 1763913 */   // Label 23996: @1763913
     /* 1763913 */   GIM_Try, /*On fail goto*//*Label 23997*/ GIMT_Encode4(1763999), // Rule ID 11569 //
     /* 1763918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1763921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1763926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1763929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1763932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1763935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1763938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1763941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1763944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1763948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1763960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1763964 */     // MIs[0] policy
     /* 1763964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1763967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1763974 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1763974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_MF2_E32_MASK),
     /* 1763977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1763979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1763981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1763983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1763985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1763987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1763992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1763995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1763997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1763998 */     // GIR_Coverage, 11569,
     /* 1763998 */     GIR_EraseRootFromParent_Done,
     /* 1763999 */   // Label 23997: @1763999
     /* 1763999 */   GIM_Try, /*On fail goto*//*Label 23998*/ GIMT_Encode4(1764085), // Rule ID 11572 //
     /* 1764004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764050 */     // MIs[0] policy
     /* 1764050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764060 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1764063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764084 */     // GIR_Coverage, 11572,
     /* 1764084 */     GIR_EraseRootFromParent_Done,
     /* 1764085 */   // Label 23998: @1764085
     /* 1764085 */   GIM_Try, /*On fail goto*//*Label 23999*/ GIMT_Encode4(1764171), // Rule ID 11573 //
     /* 1764090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1764101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1764104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1764107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1764110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1764113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764136 */     // MIs[0] policy
     /* 1764136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764146 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E8_MASK),
     /* 1764149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764170 */     // GIR_Coverage, 11573,
     /* 1764170 */     GIR_EraseRootFromParent_Done,
     /* 1764171 */   // Label 23999: @1764171
     /* 1764171 */   GIM_Try, /*On fail goto*//*Label 24000*/ GIMT_Encode4(1764257), // Rule ID 11576 //
     /* 1764176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764222 */     // MIs[0] policy
     /* 1764222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764232 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1764235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764256 */     // GIR_Coverage, 11576,
     /* 1764256 */     GIR_EraseRootFromParent_Done,
     /* 1764257 */   // Label 24000: @1764257
     /* 1764257 */   GIM_Try, /*On fail goto*//*Label 24001*/ GIMT_Encode4(1764343), // Rule ID 11577 //
     /* 1764262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1764273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1764276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1764279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1764282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1764285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764308 */     // MIs[0] policy
     /* 1764308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764318 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E16_MASK),
     /* 1764321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1764339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764342 */     // GIR_Coverage, 11577,
     /* 1764342 */     GIR_EraseRootFromParent_Done,
     /* 1764343 */   // Label 24001: @1764343
     /* 1764343 */   GIM_Try, /*On fail goto*//*Label 24002*/ GIMT_Encode4(1764429), // Rule ID 11580 //
     /* 1764348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764394 */     // MIs[0] policy
     /* 1764394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1764407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764428 */     // GIR_Coverage, 11580,
     /* 1764428 */     GIR_EraseRootFromParent_Done,
     /* 1764429 */   // Label 24002: @1764429
     /* 1764429 */   GIM_Try, /*On fail goto*//*Label 24003*/ GIMT_Encode4(1764515), // Rule ID 11581 //
     /* 1764434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1764445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1764448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1764451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1764454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1764457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764480 */     // MIs[0] policy
     /* 1764480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E32_MASK),
     /* 1764493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1764511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764514 */     // GIR_Coverage, 11581,
     /* 1764514 */     GIR_EraseRootFromParent_Done,
     /* 1764515 */   // Label 24003: @1764515
     /* 1764515 */   GIM_Try, /*On fail goto*//*Label 24004*/ GIMT_Encode4(1764601), // Rule ID 11584 //
     /* 1764520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1764523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764566 */     // MIs[0] policy
     /* 1764566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764576 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1764579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764600 */     // GIR_Coverage, 11584,
     /* 1764600 */     GIR_EraseRootFromParent_Done,
     /* 1764601 */   // Label 24004: @1764601
     /* 1764601 */   GIM_Try, /*On fail goto*//*Label 24005*/ GIMT_Encode4(1764687), // Rule ID 11585 //
     /* 1764606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1764609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1764617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1764620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1764623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1764626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1764629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1764636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1764648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764652 */     // MIs[0] policy
     /* 1764652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764662 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M1_E64_MASK),
     /* 1764665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1764683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764686 */     // GIR_Coverage, 11585,
     /* 1764686 */     GIR_EraseRootFromParent_Done,
     /* 1764687 */   // Label 24005: @1764687
     /* 1764687 */   GIM_Try, /*On fail goto*//*Label 24006*/ GIMT_Encode4(1764773), // Rule ID 11588 //
     /* 1764692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764738 */     // MIs[0] policy
     /* 1764738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764748 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1764751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764772 */     // GIR_Coverage, 11588,
     /* 1764772 */     GIR_EraseRootFromParent_Done,
     /* 1764773 */   // Label 24006: @1764773
     /* 1764773 */   GIM_Try, /*On fail goto*//*Label 24007*/ GIMT_Encode4(1764859), // Rule ID 11589 //
     /* 1764778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1764789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1764792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1764795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1764798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1764801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1764808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1764820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764824 */     // MIs[0] policy
     /* 1764824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1764834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E8_MASK),
     /* 1764837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764858 */     // GIR_Coverage, 11589,
     /* 1764858 */     GIR_EraseRootFromParent_Done,
     /* 1764859 */   // Label 24007: @1764859
     /* 1764859 */   GIM_Try, /*On fail goto*//*Label 24008*/ GIMT_Encode4(1764945), // Rule ID 11592 //
     /* 1764864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1764867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1764884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1764890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764910 */     // MIs[0] policy
     /* 1764910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1764920 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1764920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1764923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1764925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1764927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1764929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1764931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1764933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1764938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1764941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1764943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1764944 */     // GIR_Coverage, 11592,
     /* 1764944 */     GIR_EraseRootFromParent_Done,
     /* 1764945 */   // Label 24008: @1764945
     /* 1764945 */   GIM_Try, /*On fail goto*//*Label 24009*/ GIMT_Encode4(1765031), // Rule ID 11593 //
     /* 1764950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1764953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1764958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1764961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1764964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1764967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1764970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1764973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1764976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1764980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1764992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1764996 */     // MIs[0] policy
     /* 1764996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1764999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765006 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E8_MASK),
     /* 1765009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765030 */     // GIR_Coverage, 11593,
     /* 1765030 */     GIR_EraseRootFromParent_Done,
     /* 1765031 */   // Label 24009: @1765031
     /* 1765031 */   GIM_Try, /*On fail goto*//*Label 24010*/ GIMT_Encode4(1765117), // Rule ID 11596 //
     /* 1765036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1765047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1765050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1765053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1765056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1765059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765082 */     // MIs[0] policy
     /* 1765082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765092 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1765095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765116 */     // GIR_Coverage, 11596,
     /* 1765116 */     GIR_EraseRootFromParent_Done,
     /* 1765117 */   // Label 24010: @1765117
     /* 1765117 */   GIM_Try, /*On fail goto*//*Label 24011*/ GIMT_Encode4(1765203), // Rule ID 11597 //
     /* 1765122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1765133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1765136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1765139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1765142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1765145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765168 */     // MIs[0] policy
     /* 1765168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765178 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E8_MASK),
     /* 1765181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1765199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765202 */     // GIR_Coverage, 11597,
     /* 1765202 */     GIR_EraseRootFromParent_Done,
     /* 1765203 */   // Label 24011: @1765203
     /* 1765203 */   GIM_Try, /*On fail goto*//*Label 24012*/ GIMT_Encode4(1765289), // Rule ID 11600 //
     /* 1765208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765254 */     // MIs[0] policy
     /* 1765254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765264 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1765267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765288 */     // GIR_Coverage, 11600,
     /* 1765288 */     GIR_EraseRootFromParent_Done,
     /* 1765289 */   // Label 24012: @1765289
     /* 1765289 */   GIM_Try, /*On fail goto*//*Label 24013*/ GIMT_Encode4(1765375), // Rule ID 11601 //
     /* 1765294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1765305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1765308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1765311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1765314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765340 */     // MIs[0] policy
     /* 1765340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765350 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E16_MASK),
     /* 1765353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765374 */     // GIR_Coverage, 11601,
     /* 1765374 */     GIR_EraseRootFromParent_Done,
     /* 1765375 */   // Label 24013: @1765375
     /* 1765375 */   GIM_Try, /*On fail goto*//*Label 24014*/ GIMT_Encode4(1765461), // Rule ID 11604 //
     /* 1765380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765426 */     // MIs[0] policy
     /* 1765426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765436 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1765439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765460 */     // GIR_Coverage, 11604,
     /* 1765460 */     GIR_EraseRootFromParent_Done,
     /* 1765461 */   // Label 24014: @1765461
     /* 1765461 */   GIM_Try, /*On fail goto*//*Label 24015*/ GIMT_Encode4(1765547), // Rule ID 11605 //
     /* 1765466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1765477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1765480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1765483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1765486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1765489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765512 */     // MIs[0] policy
     /* 1765512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765522 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E16_MASK),
     /* 1765525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765546 */     // GIR_Coverage, 11605,
     /* 1765546 */     GIR_EraseRootFromParent_Done,
     /* 1765547 */   // Label 24015: @1765547
     /* 1765547 */   GIM_Try, /*On fail goto*//*Label 24016*/ GIMT_Encode4(1765633), // Rule ID 11608 //
     /* 1765552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765598 */     // MIs[0] policy
     /* 1765598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765608 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1765611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765632 */     // GIR_Coverage, 11608,
     /* 1765632 */     GIR_EraseRootFromParent_Done,
     /* 1765633 */   // Label 24016: @1765633
     /* 1765633 */   GIM_Try, /*On fail goto*//*Label 24017*/ GIMT_Encode4(1765719), // Rule ID 11609 //
     /* 1765638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1765649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1765652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1765655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1765658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1765661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1765668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1765680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765684 */     // MIs[0] policy
     /* 1765684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765694 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E16_MASK),
     /* 1765697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1765715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765718 */     // GIR_Coverage, 11609,
     /* 1765718 */     GIR_EraseRootFromParent_Done,
     /* 1765719 */   // Label 24017: @1765719
     /* 1765719 */   GIM_Try, /*On fail goto*//*Label 24018*/ GIMT_Encode4(1765805), // Rule ID 11612 //
     /* 1765724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765770 */     // MIs[0] policy
     /* 1765770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765780 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1765783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765804 */     // GIR_Coverage, 11612,
     /* 1765804 */     GIR_EraseRootFromParent_Done,
     /* 1765805 */   // Label 24018: @1765805
     /* 1765805 */   GIM_Try, /*On fail goto*//*Label 24019*/ GIMT_Encode4(1765891), // Rule ID 11613 //
     /* 1765810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1765821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1765824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1765827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1765830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1765833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1765836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1765840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1765852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765856 */     // MIs[0] policy
     /* 1765856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765866 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1765866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E32_MASK),
     /* 1765869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765890 */     // GIR_Coverage, 11613,
     /* 1765890 */     GIR_EraseRootFromParent_Done,
     /* 1765891 */   // Label 24019: @1765891
     /* 1765891 */   GIM_Try, /*On fail goto*//*Label 24020*/ GIMT_Encode4(1765977), // Rule ID 11616 //
     /* 1765896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1765899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1765916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1765919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1765922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1765926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1765938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1765942 */     // MIs[0] policy
     /* 1765942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1765945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1765952 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1765952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1765955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1765957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1765959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1765961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1765963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1765965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1765970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1765973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1765975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1765976 */     // GIR_Coverage, 11616,
     /* 1765976 */     GIR_EraseRootFromParent_Done,
     /* 1765977 */   // Label 24020: @1765977
     /* 1765977 */   GIM_Try, /*On fail goto*//*Label 24021*/ GIMT_Encode4(1766063), // Rule ID 11617 //
     /* 1765982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1765985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1765990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1765993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1765996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1765999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1766002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766028 */     // MIs[0] policy
     /* 1766028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766038 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E32_MASK),
     /* 1766041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766062 */     // GIR_Coverage, 11617,
     /* 1766062 */     GIR_EraseRootFromParent_Done,
     /* 1766063 */   // Label 24021: @1766063
     /* 1766063 */   GIM_Try, /*On fail goto*//*Label 24022*/ GIMT_Encode4(1766149), // Rule ID 11620 //
     /* 1766068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766114 */     // MIs[0] policy
     /* 1766114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766124 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1766127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766148 */     // GIR_Coverage, 11620,
     /* 1766148 */     GIR_EraseRootFromParent_Done,
     /* 1766149 */   // Label 24022: @1766149
     /* 1766149 */   GIM_Try, /*On fail goto*//*Label 24023*/ GIMT_Encode4(1766235), // Rule ID 11621 //
     /* 1766154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1766165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1766168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1766171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1766174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1766177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766200 */     // MIs[0] policy
     /* 1766200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766210 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E32_MASK),
     /* 1766213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1766231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766234 */     // GIR_Coverage, 11621,
     /* 1766234 */     GIR_EraseRootFromParent_Done,
     /* 1766235 */   // Label 24023: @1766235
     /* 1766235 */   GIM_Try, /*On fail goto*//*Label 24024*/ GIMT_Encode4(1766321), // Rule ID 11624 //
     /* 1766240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766286 */     // MIs[0] policy
     /* 1766286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1766299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766320 */     // GIR_Coverage, 11624,
     /* 1766320 */     GIR_EraseRootFromParent_Done,
     /* 1766321 */   // Label 24024: @1766321
     /* 1766321 */   GIM_Try, /*On fail goto*//*Label 24025*/ GIMT_Encode4(1766407), // Rule ID 11625 //
     /* 1766326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1766337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1766340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1766343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1766346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1766356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1766368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766372 */     // MIs[0] policy
     /* 1766372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766382 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M2_E64_MASK),
     /* 1766385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766406 */     // GIR_Coverage, 11625,
     /* 1766406 */     GIR_EraseRootFromParent_Done,
     /* 1766407 */   // Label 24025: @1766407
     /* 1766407 */   GIM_Try, /*On fail goto*//*Label 24026*/ GIMT_Encode4(1766493), // Rule ID 11628 //
     /* 1766412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766458 */     // MIs[0] policy
     /* 1766458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766468 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1766471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766492 */     // GIR_Coverage, 11628,
     /* 1766492 */     GIR_EraseRootFromParent_Done,
     /* 1766493 */   // Label 24026: @1766493
     /* 1766493 */   GIM_Try, /*On fail goto*//*Label 24027*/ GIMT_Encode4(1766579), // Rule ID 11629 //
     /* 1766498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1766509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1766512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1766515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1766518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1766521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1766528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1766540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766544 */     // MIs[0] policy
     /* 1766544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766554 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M4_E64_MASK),
     /* 1766557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766578 */     // GIR_Coverage, 11629,
     /* 1766578 */     GIR_EraseRootFromParent_Done,
     /* 1766579 */   // Label 24027: @1766579
     /* 1766579 */   GIM_Try, /*On fail goto*//*Label 24028*/ GIMT_Encode4(1766665), // Rule ID 11632 //
     /* 1766584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1766587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766630 */     // MIs[0] policy
     /* 1766630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766640 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1766643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766664 */     // GIR_Coverage, 11632,
     /* 1766664 */     GIR_EraseRootFromParent_Done,
     /* 1766665 */   // Label 24028: @1766665
     /* 1766665 */   GIM_Try, /*On fail goto*//*Label 24029*/ GIMT_Encode4(1766751), // Rule ID 11633 //
     /* 1766670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1766673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1766681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1766684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1766687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1766690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1766693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1766700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1766712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766716 */     // MIs[0] policy
     /* 1766716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766726 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VV_M8_E64_MASK),
     /* 1766729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1766747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766750 */     // GIR_Coverage, 11633,
     /* 1766750 */     GIR_EraseRootFromParent_Done,
     /* 1766751 */   // Label 24029: @1766751
     /* 1766751 */   GIM_Try, /*On fail goto*//*Label 24030*/ GIMT_Encode4(1766837), // Rule ID 11636 //
     /* 1766756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1766767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1766770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1766773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766802 */     // MIs[0] policy
     /* 1766802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766812 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1766815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766836 */     // GIR_Coverage, 11636,
     /* 1766836 */     GIR_EraseRootFromParent_Done,
     /* 1766837 */   // Label 24030: @1766837
     /* 1766837 */   GIM_Try, /*On fail goto*//*Label 24031*/ GIMT_Encode4(1766923), // Rule ID 11637 //
     /* 1766842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1766845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1766853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1766856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1766859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1766862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1766865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1766868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766888 */     // MIs[0] policy
     /* 1766888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766898 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1766898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF8_E8_MASK),
     /* 1766901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1766916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1766919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1766921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1766922 */     // GIR_Coverage, 11637,
     /* 1766922 */     GIR_EraseRootFromParent_Done,
     /* 1766923 */   // Label 24031: @1766923
     /* 1766923 */   GIM_Try, /*On fail goto*//*Label 24032*/ GIMT_Encode4(1767009), // Rule ID 11640 //
     /* 1766928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1766931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1766936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1766939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1766942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1766945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1766948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1766951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1766954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1766958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1766966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1766970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1766974 */     // MIs[0] policy
     /* 1766974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1766977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1766984 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1766984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1766987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1766989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1766991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1766993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1766995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1766997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767008 */     // GIR_Coverage, 11640,
     /* 1767008 */     GIR_EraseRootFromParent_Done,
     /* 1767009 */   // Label 24032: @1767009
     /* 1767009 */   GIM_Try, /*On fail goto*//*Label 24033*/ GIMT_Encode4(1767095), // Rule ID 11641 //
     /* 1767014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1767025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1767028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1767031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767060 */     // MIs[0] policy
     /* 1767060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767070 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E8_MASK),
     /* 1767073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767094 */     // GIR_Coverage, 11641,
     /* 1767094 */     GIR_EraseRootFromParent_Done,
     /* 1767095 */   // Label 24033: @1767095
     /* 1767095 */   GIM_Try, /*On fail goto*//*Label 24034*/ GIMT_Encode4(1767181), // Rule ID 11644 //
     /* 1767100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767146 */     // MIs[0] policy
     /* 1767146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767156 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1767159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767180 */     // GIR_Coverage, 11644,
     /* 1767180 */     GIR_EraseRootFromParent_Done,
     /* 1767181 */   // Label 24034: @1767181
     /* 1767181 */   GIM_Try, /*On fail goto*//*Label 24035*/ GIMT_Encode4(1767267), // Rule ID 11645 //
     /* 1767186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1767197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1767200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1767203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767232 */     // MIs[0] policy
     /* 1767232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767242 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E8_MASK),
     /* 1767245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767266 */     // GIR_Coverage, 11645,
     /* 1767266 */     GIR_EraseRootFromParent_Done,
     /* 1767267 */   // Label 24035: @1767267
     /* 1767267 */   GIM_Try, /*On fail goto*//*Label 24036*/ GIMT_Encode4(1767353), // Rule ID 11648 //
     /* 1767272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767318 */     // MIs[0] policy
     /* 1767318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767328 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1767331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767352 */     // GIR_Coverage, 11648,
     /* 1767352 */     GIR_EraseRootFromParent_Done,
     /* 1767353 */   // Label 24036: @1767353
     /* 1767353 */   GIM_Try, /*On fail goto*//*Label 24037*/ GIMT_Encode4(1767439), // Rule ID 11649 //
     /* 1767358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1767369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1767372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1767375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767404 */     // MIs[0] policy
     /* 1767404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767414 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF4_E16_MASK),
     /* 1767417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767438 */     // GIR_Coverage, 11649,
     /* 1767438 */     GIR_EraseRootFromParent_Done,
     /* 1767439 */   // Label 24037: @1767439
     /* 1767439 */   GIM_Try, /*On fail goto*//*Label 24038*/ GIMT_Encode4(1767525), // Rule ID 11652 //
     /* 1767444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1767455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1767458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1767461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767490 */     // MIs[0] policy
     /* 1767490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767500 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1767503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767524 */     // GIR_Coverage, 11652,
     /* 1767524 */     GIR_EraseRootFromParent_Done,
     /* 1767525 */   // Label 24038: @1767525
     /* 1767525 */   GIM_Try, /*On fail goto*//*Label 24039*/ GIMT_Encode4(1767611), // Rule ID 11653 //
     /* 1767530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1767541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1767544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1767547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1767553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767576 */     // MIs[0] policy
     /* 1767576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767586 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E16_MASK),
     /* 1767589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1767607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767610 */     // GIR_Coverage, 11653,
     /* 1767610 */     GIR_EraseRootFromParent_Done,
     /* 1767611 */   // Label 24039: @1767611
     /* 1767611 */   GIM_Try, /*On fail goto*//*Label 24040*/ GIMT_Encode4(1767697), // Rule ID 11656 //
     /* 1767616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767662 */     // MIs[0] policy
     /* 1767662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767672 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1767675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767696 */     // GIR_Coverage, 11656,
     /* 1767696 */     GIR_EraseRootFromParent_Done,
     /* 1767697 */   // Label 24040: @1767697
     /* 1767697 */   GIM_Try, /*On fail goto*//*Label 24041*/ GIMT_Encode4(1767783), // Rule ID 11657 //
     /* 1767702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1767713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1767716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1767719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1767725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767748 */     // MIs[0] policy
     /* 1767748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767758 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_MF2_E32_MASK),
     /* 1767761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1767779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767782 */     // GIR_Coverage, 11657,
     /* 1767782 */     GIR_EraseRootFromParent_Done,
     /* 1767783 */   // Label 24041: @1767783
     /* 1767783 */   GIM_Try, /*On fail goto*//*Label 24042*/ GIMT_Encode4(1767869), // Rule ID 11660 //
     /* 1767788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1767799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1767802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1767805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767834 */     // MIs[0] policy
     /* 1767834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767844 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1767844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1767847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767868 */     // GIR_Coverage, 11660,
     /* 1767868 */     GIR_EraseRootFromParent_Done,
     /* 1767869 */   // Label 24042: @1767869
     /* 1767869 */   GIM_Try, /*On fail goto*//*Label 24043*/ GIMT_Encode4(1767955), // Rule ID 11661 //
     /* 1767874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1767877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1767885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1767888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1767891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1767894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1767897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1767900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1767916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1767920 */     // MIs[0] policy
     /* 1767920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1767923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1767930 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11115:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1767930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E8_MASK),
     /* 1767933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1767935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1767937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1767939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1767941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1767943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1767948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1767951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1767953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1767954 */     // GIR_Coverage, 11661,
     /* 1767954 */     GIR_EraseRootFromParent_Done,
     /* 1767955 */   // Label 24043: @1767955
     /* 1767955 */   GIM_Try, /*On fail goto*//*Label 24044*/ GIMT_Encode4(1768041), // Rule ID 11664 //
     /* 1767960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1767963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1767968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1767971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1767974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1767977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1767980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1767983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1767986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1767990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1767998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768006 */     // MIs[0] policy
     /* 1768006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768016 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1768019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768040 */     // GIR_Coverage, 11664,
     /* 1768040 */     GIR_EraseRootFromParent_Done,
     /* 1768041 */   // Label 24044: @1768041
     /* 1768041 */   GIM_Try, /*On fail goto*//*Label 24045*/ GIMT_Encode4(1768127), // Rule ID 11665 //
     /* 1768046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1768057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1768060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1768063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1768069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768092 */     // MIs[0] policy
     /* 1768092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11115:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E16_MASK),
     /* 1768105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1768123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768126 */     // GIR_Coverage, 11665,
     /* 1768126 */     GIR_EraseRootFromParent_Done,
     /* 1768127 */   // Label 24045: @1768127
     /* 1768127 */   GIM_Try, /*On fail goto*//*Label 24046*/ GIMT_Encode4(1768213), // Rule ID 11668 //
     /* 1768132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768178 */     // MIs[0] policy
     /* 1768178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768188 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1768191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768212 */     // GIR_Coverage, 11668,
     /* 1768212 */     GIR_EraseRootFromParent_Done,
     /* 1768213 */   // Label 24046: @1768213
     /* 1768213 */   GIM_Try, /*On fail goto*//*Label 24047*/ GIMT_Encode4(1768299), // Rule ID 11669 //
     /* 1768218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1768229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1768232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1768235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1768241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768264 */     // MIs[0] policy
     /* 1768264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768274 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11115:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E32_MASK),
     /* 1768277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1768295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768298 */     // GIR_Coverage, 11669,
     /* 1768298 */     GIR_EraseRootFromParent_Done,
     /* 1768299 */   // Label 24047: @1768299
     /* 1768299 */   GIM_Try, /*On fail goto*//*Label 24048*/ GIMT_Encode4(1768385), // Rule ID 11672 //
     /* 1768304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1768307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768350 */     // MIs[0] policy
     /* 1768350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768360 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1768363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768384 */     // GIR_Coverage, 11672,
     /* 1768384 */     GIR_EraseRootFromParent_Done,
     /* 1768385 */   // Label 24048: @1768385
     /* 1768385 */   GIM_Try, /*On fail goto*//*Label 24049*/ GIMT_Encode4(1768471), // Rule ID 11673 //
     /* 1768390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1768393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1768401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1768404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1768407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1768413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1768420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1768428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768436 */     // MIs[0] policy
     /* 1768436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768446 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11115:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M1_E64_MASK),
     /* 1768449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1768467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768470 */     // GIR_Coverage, 11673,
     /* 1768470 */     GIR_EraseRootFromParent_Done,
     /* 1768471 */   // Label 24049: @1768471
     /* 1768471 */   GIM_Try, /*On fail goto*//*Label 24050*/ GIMT_Encode4(1768557), // Rule ID 11676 //
     /* 1768476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1768487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1768490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1768493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768522 */     // MIs[0] policy
     /* 1768522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768532 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1768535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768556 */     // GIR_Coverage, 11676,
     /* 1768556 */     GIR_EraseRootFromParent_Done,
     /* 1768557 */   // Label 24050: @1768557
     /* 1768557 */   GIM_Try, /*On fail goto*//*Label 24051*/ GIMT_Encode4(1768643), // Rule ID 11677 //
     /* 1768562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1768573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1768576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1768579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1768585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1768592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1768600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768608 */     // MIs[0] policy
     /* 1768608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768618 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E8_MASK),
     /* 1768621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768642 */     // GIR_Coverage, 11677,
     /* 1768642 */     GIR_EraseRootFromParent_Done,
     /* 1768643 */   // Label 24051: @1768643
     /* 1768643 */   GIM_Try, /*On fail goto*//*Label 24052*/ GIMT_Encode4(1768729), // Rule ID 11680 //
     /* 1768648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1768659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1768662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1768665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768694 */     // MIs[0] policy
     /* 1768694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1768707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768728 */     // GIR_Coverage, 11680,
     /* 1768728 */     GIR_EraseRootFromParent_Done,
     /* 1768729 */   // Label 24052: @1768729
     /* 1768729 */   GIM_Try, /*On fail goto*//*Label 24053*/ GIMT_Encode4(1768815), // Rule ID 11681 //
     /* 1768734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1768745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1768748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1768751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1768757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1768764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1768772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768780 */     // MIs[0] policy
     /* 1768780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768790 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E8_MASK),
     /* 1768793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768814 */     // GIR_Coverage, 11681,
     /* 1768814 */     GIR_EraseRootFromParent_Done,
     /* 1768815 */   // Label 24053: @1768815
     /* 1768815 */   GIM_Try, /*On fail goto*//*Label 24054*/ GIMT_Encode4(1768901), // Rule ID 11684 //
     /* 1768820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1768831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1768834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1768837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1768840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1768843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1768846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768866 */     // MIs[0] policy
     /* 1768866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768876 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1768876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1768879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768900 */     // GIR_Coverage, 11684,
     /* 1768900 */     GIR_EraseRootFromParent_Done,
     /* 1768901 */   // Label 24054: @1768901
     /* 1768901 */   GIM_Try, /*On fail goto*//*Label 24055*/ GIMT_Encode4(1768987), // Rule ID 11685 //
     /* 1768906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1768909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1768914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1768917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1768920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1768923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1768926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1768929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1768932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1768936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1768944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1768948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1768952 */     // MIs[0] policy
     /* 1768952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1768955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1768962 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1768962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E8_MASK),
     /* 1768965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1768967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1768969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1768971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1768973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1768975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1768980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1768983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1768985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1768986 */     // GIR_Coverage, 11685,
     /* 1768986 */     GIR_EraseRootFromParent_Done,
     /* 1768987 */   // Label 24055: @1768987
     /* 1768987 */   GIM_Try, /*On fail goto*//*Label 24056*/ GIMT_Encode4(1769073), // Rule ID 11688 //
     /* 1768992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1768995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769038 */     // MIs[0] policy
     /* 1769038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769048 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1769051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769072 */     // GIR_Coverage, 11688,
     /* 1769072 */     GIR_EraseRootFromParent_Done,
     /* 1769073 */   // Label 24056: @1769073
     /* 1769073 */   GIM_Try, /*On fail goto*//*Label 24057*/ GIMT_Encode4(1769159), // Rule ID 11689 //
     /* 1769078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1769089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1769092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1769095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769124 */     // MIs[0] policy
     /* 1769124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769134 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E16_MASK),
     /* 1769137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769158 */     // GIR_Coverage, 11689,
     /* 1769158 */     GIR_EraseRootFromParent_Done,
     /* 1769159 */   // Label 24057: @1769159
     /* 1769159 */   GIM_Try, /*On fail goto*//*Label 24058*/ GIMT_Encode4(1769245), // Rule ID 11692 //
     /* 1769164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769210 */     // MIs[0] policy
     /* 1769210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769220 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1769223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769244 */     // GIR_Coverage, 11692,
     /* 1769244 */     GIR_EraseRootFromParent_Done,
     /* 1769245 */   // Label 24058: @1769245
     /* 1769245 */   GIM_Try, /*On fail goto*//*Label 24059*/ GIMT_Encode4(1769331), // Rule ID 11693 //
     /* 1769250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1769261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1769264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1769267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769296 */     // MIs[0] policy
     /* 1769296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769306 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E16_MASK),
     /* 1769309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769330 */     // GIR_Coverage, 11693,
     /* 1769330 */     GIR_EraseRootFromParent_Done,
     /* 1769331 */   // Label 24059: @1769331
     /* 1769331 */   GIM_Try, /*On fail goto*//*Label 24060*/ GIMT_Encode4(1769417), // Rule ID 11696 //
     /* 1769336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1769347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1769350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1769353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769382 */     // MIs[0] policy
     /* 1769382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769392 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1769395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769416 */     // GIR_Coverage, 11696,
     /* 1769416 */     GIR_EraseRootFromParent_Done,
     /* 1769417 */   // Label 24060: @1769417
     /* 1769417 */   GIM_Try, /*On fail goto*//*Label 24061*/ GIMT_Encode4(1769503), // Rule ID 11697 //
     /* 1769422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1769433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1769436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1769439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1769445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769468 */     // MIs[0] policy
     /* 1769468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769478 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E16_MASK),
     /* 1769481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1769499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769502 */     // GIR_Coverage, 11697,
     /* 1769502 */     GIR_EraseRootFromParent_Done,
     /* 1769503 */   // Label 24061: @1769503
     /* 1769503 */   GIM_Try, /*On fail goto*//*Label 24062*/ GIMT_Encode4(1769589), // Rule ID 11700 //
     /* 1769508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1769519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1769522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1769525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769554 */     // MIs[0] policy
     /* 1769554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1769567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769588 */     // GIR_Coverage, 11700,
     /* 1769588 */     GIR_EraseRootFromParent_Done,
     /* 1769589 */   // Label 24062: @1769589
     /* 1769589 */   GIM_Try, /*On fail goto*//*Label 24063*/ GIMT_Encode4(1769675), // Rule ID 11701 //
     /* 1769594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1769605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1769608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1769611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1769617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1769624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1769632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769640 */     // MIs[0] policy
     /* 1769640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E32_MASK),
     /* 1769653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769674 */     // GIR_Coverage, 11701,
     /* 1769674 */     GIR_EraseRootFromParent_Done,
     /* 1769675 */   // Label 24063: @1769675
     /* 1769675 */   GIM_Try, /*On fail goto*//*Label 24064*/ GIMT_Encode4(1769761), // Rule ID 11704 //
     /* 1769680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1769691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1769694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1769697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769726 */     // MIs[0] policy
     /* 1769726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1769739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769760 */     // GIR_Coverage, 11704,
     /* 1769760 */     GIR_EraseRootFromParent_Done,
     /* 1769761 */   // Label 24064: @1769761
     /* 1769761 */   GIM_Try, /*On fail goto*//*Label 24065*/ GIMT_Encode4(1769847), // Rule ID 11705 //
     /* 1769766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1769777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1769780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1769783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1769789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1769796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1769804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769812 */     // MIs[0] policy
     /* 1769812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E32_MASK),
     /* 1769825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769846 */     // GIR_Coverage, 11705,
     /* 1769846 */     GIR_EraseRootFromParent_Done,
     /* 1769847 */   // Label 24065: @1769847
     /* 1769847 */   GIM_Try, /*On fail goto*//*Label 24066*/ GIMT_Encode4(1769933), // Rule ID 11708 //
     /* 1769852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1769855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1769863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1769866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1769869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1769872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1769878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769898 */     // MIs[0] policy
     /* 1769898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1769908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1769911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1769915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1769917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1769919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1769921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1769926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1769929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1769931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1769932 */     // GIR_Coverage, 11708,
     /* 1769932 */     GIR_EraseRootFromParent_Done,
     /* 1769933 */   // Label 24066: @1769933
     /* 1769933 */   GIM_Try, /*On fail goto*//*Label 24067*/ GIMT_Encode4(1770019), // Rule ID 11709 //
     /* 1769938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1769941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1769946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1769949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1769952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1769955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1769958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1769961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1769964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1769968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1769976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1769980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1769984 */     // MIs[0] policy
     /* 1769984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1769987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1769994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1769994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E32_MASK),
     /* 1769997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1769999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1770015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770018 */     // GIR_Coverage, 11709,
     /* 1770018 */     GIR_EraseRootFromParent_Done,
     /* 1770019 */   // Label 24067: @1770019
     /* 1770019 */   GIM_Try, /*On fail goto*//*Label 24068*/ GIMT_Encode4(1770105), // Rule ID 11712 //
     /* 1770024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770070 */     // MIs[0] policy
     /* 1770070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770080 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1770083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770104 */     // GIR_Coverage, 11712,
     /* 1770104 */     GIR_EraseRootFromParent_Done,
     /* 1770105 */   // Label 24068: @1770105
     /* 1770105 */   GIM_Try, /*On fail goto*//*Label 24069*/ GIMT_Encode4(1770191), // Rule ID 11713 //
     /* 1770110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1770121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1770124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1770127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1770140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1770148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770156 */     // MIs[0] policy
     /* 1770156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770166 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11115:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M2_E64_MASK),
     /* 1770169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770190 */     // GIR_Coverage, 11713,
     /* 1770190 */     GIR_EraseRootFromParent_Done,
     /* 1770191 */   // Label 24069: @1770191
     /* 1770191 */   GIM_Try, /*On fail goto*//*Label 24070*/ GIMT_Encode4(1770277), // Rule ID 11716 //
     /* 1770196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770242 */     // MIs[0] policy
     /* 1770242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770252 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1770255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770276 */     // GIR_Coverage, 11716,
     /* 1770276 */     GIR_EraseRootFromParent_Done,
     /* 1770277 */   // Label 24070: @1770277
     /* 1770277 */   GIM_Try, /*On fail goto*//*Label 24071*/ GIMT_Encode4(1770363), // Rule ID 11717 //
     /* 1770282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1770293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1770296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1770299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1770312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1770320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770328 */     // MIs[0] policy
     /* 1770328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770338 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11115:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M4_E64_MASK),
     /* 1770341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770362 */     // GIR_Coverage, 11717,
     /* 1770362 */     GIR_EraseRootFromParent_Done,
     /* 1770363 */   // Label 24071: @1770363
     /* 1770363 */   GIM_Try, /*On fail goto*//*Label 24072*/ GIMT_Encode4(1770449), // Rule ID 11720 //
     /* 1770368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1770371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1770388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770414 */     // MIs[0] policy
     /* 1770414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770424 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1770427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770448 */     // GIR_Coverage, 11720,
     /* 1770448 */     GIR_EraseRootFromParent_Done,
     /* 1770449 */   // Label 24072: @1770449
     /* 1770449 */   GIM_Try, /*On fail goto*//*Label 24073*/ GIMT_Encode4(1770535), // Rule ID 11721 //
     /* 1770454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1770457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdivu_mask),
     /* 1770462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1770465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1770468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1770471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1770474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1770477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1770484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1770492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1770496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770500 */     // MIs[0] policy
     /* 1770500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11115:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIVU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIVU_VX_M8_E64_MASK),
     /* 1770513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1770531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770534 */     // GIR_Coverage, 11721,
     /* 1770534 */     GIR_EraseRootFromParent_Done,
     /* 1770535 */   // Label 24073: @1770535
     /* 1770535 */   GIM_Try, /*On fail goto*//*Label 24074*/ GIMT_Encode4(1770621), // Rule ID 11724 //
     /* 1770540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770586 */     // MIs[0] policy
     /* 1770586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770596 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1770599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770620 */     // GIR_Coverage, 11724,
     /* 1770620 */     GIR_EraseRootFromParent_Done,
     /* 1770621 */   // Label 24074: @1770621
     /* 1770621 */   GIM_Try, /*On fail goto*//*Label 24075*/ GIMT_Encode4(1770707), // Rule ID 11725 //
     /* 1770626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1770637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1770640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1770643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1770646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1770649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770672 */     // MIs[0] policy
     /* 1770672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770682 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF8_E8_MASK),
     /* 1770685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770706 */     // GIR_Coverage, 11725,
     /* 1770706 */     GIR_EraseRootFromParent_Done,
     /* 1770707 */   // Label 24075: @1770707
     /* 1770707 */   GIM_Try, /*On fail goto*//*Label 24076*/ GIMT_Encode4(1770793), // Rule ID 11728 //
     /* 1770712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770758 */     // MIs[0] policy
     /* 1770758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770768 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1770771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770792 */     // GIR_Coverage, 11728,
     /* 1770792 */     GIR_EraseRootFromParent_Done,
     /* 1770793 */   // Label 24076: @1770793
     /* 1770793 */   GIM_Try, /*On fail goto*//*Label 24077*/ GIMT_Encode4(1770879), // Rule ID 11729 //
     /* 1770798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1770809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1770812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1770815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1770818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1770821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770844 */     // MIs[0] policy
     /* 1770844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770854 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1770854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E8_MASK),
     /* 1770857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770878 */     // GIR_Coverage, 11729,
     /* 1770878 */     GIR_EraseRootFromParent_Done,
     /* 1770879 */   // Label 24077: @1770879
     /* 1770879 */   GIM_Try, /*On fail goto*//*Label 24078*/ GIMT_Encode4(1770965), // Rule ID 11732 //
     /* 1770884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1770887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1770910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1770914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1770926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1770930 */     // MIs[0] policy
     /* 1770930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1770933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1770940 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1770940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1770943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1770945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1770947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1770949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1770951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1770953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1770958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1770961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1770963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1770964 */     // GIR_Coverage, 11732,
     /* 1770964 */     GIR_EraseRootFromParent_Done,
     /* 1770965 */   // Label 24078: @1770965
     /* 1770965 */   GIM_Try, /*On fail goto*//*Label 24079*/ GIMT_Encode4(1771051), // Rule ID 11733 //
     /* 1770970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1770973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1770978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1770981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1770984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1770987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1770990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1770993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1770996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771016 */     // MIs[0] policy
     /* 1771016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771026 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E8_MASK),
     /* 1771029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771050 */     // GIR_Coverage, 11733,
     /* 1771050 */     GIR_EraseRootFromParent_Done,
     /* 1771051 */   // Label 24079: @1771051
     /* 1771051 */   GIM_Try, /*On fail goto*//*Label 24080*/ GIMT_Encode4(1771137), // Rule ID 11736 //
     /* 1771056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1771076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771102 */     // MIs[0] policy
     /* 1771102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771112 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1771115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771136 */     // GIR_Coverage, 11736,
     /* 1771136 */     GIR_EraseRootFromParent_Done,
     /* 1771137 */   // Label 24080: @1771137
     /* 1771137 */   GIM_Try, /*On fail goto*//*Label 24081*/ GIMT_Encode4(1771223), // Rule ID 11737 //
     /* 1771142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1771153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1771156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1771159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1771162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771188 */     // MIs[0] policy
     /* 1771188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771198 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF4_E16_MASK),
     /* 1771201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771222 */     // GIR_Coverage, 11737,
     /* 1771222 */     GIR_EraseRootFromParent_Done,
     /* 1771223 */   // Label 24081: @1771223
     /* 1771223 */   GIM_Try, /*On fail goto*//*Label 24082*/ GIMT_Encode4(1771309), // Rule ID 11740 //
     /* 1771228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1771248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771274 */     // MIs[0] policy
     /* 1771274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771284 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1771287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771308 */     // GIR_Coverage, 11740,
     /* 1771308 */     GIR_EraseRootFromParent_Done,
     /* 1771309 */   // Label 24082: @1771309
     /* 1771309 */   GIM_Try, /*On fail goto*//*Label 24083*/ GIMT_Encode4(1771395), // Rule ID 11741 //
     /* 1771314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1771325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1771328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1771331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1771334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771360 */     // MIs[0] policy
     /* 1771360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771370 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E16_MASK),
     /* 1771373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771394 */     // GIR_Coverage, 11741,
     /* 1771394 */     GIR_EraseRootFromParent_Done,
     /* 1771395 */   // Label 24083: @1771395
     /* 1771395 */   GIM_Try, /*On fail goto*//*Label 24084*/ GIMT_Encode4(1771481), // Rule ID 11744 //
     /* 1771400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1771411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1771414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1771417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1771420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771446 */     // MIs[0] policy
     /* 1771446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771456 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1771459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771480 */     // GIR_Coverage, 11744,
     /* 1771480 */     GIR_EraseRootFromParent_Done,
     /* 1771481 */   // Label 24084: @1771481
     /* 1771481 */   GIM_Try, /*On fail goto*//*Label 24085*/ GIMT_Encode4(1771567), // Rule ID 11745 //
     /* 1771486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1771497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1771500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1771503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1771506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1771509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771532 */     // MIs[0] policy
     /* 1771532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771542 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_MF2_E32_MASK),
     /* 1771545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771566 */     // GIR_Coverage, 11745,
     /* 1771566 */     GIR_EraseRootFromParent_Done,
     /* 1771567 */   // Label 24085: @1771567
     /* 1771567 */   GIM_Try, /*On fail goto*//*Label 24086*/ GIMT_Encode4(1771653), // Rule ID 11748 //
     /* 1771572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771618 */     // MIs[0] policy
     /* 1771618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771628 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1771631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771652 */     // GIR_Coverage, 11748,
     /* 1771652 */     GIR_EraseRootFromParent_Done,
     /* 1771653 */   // Label 24086: @1771653
     /* 1771653 */   GIM_Try, /*On fail goto*//*Label 24087*/ GIMT_Encode4(1771739), // Rule ID 11749 //
     /* 1771658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1771669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1771672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1771675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1771678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1771681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771704 */     // MIs[0] policy
     /* 1771704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771714 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E8_MASK),
     /* 1771717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1771735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771738 */     // GIR_Coverage, 11749,
     /* 1771738 */     GIR_EraseRootFromParent_Done,
     /* 1771739 */   // Label 24087: @1771739
     /* 1771739 */   GIM_Try, /*On fail goto*//*Label 24088*/ GIMT_Encode4(1771825), // Rule ID 11752 //
     /* 1771744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771790 */     // MIs[0] policy
     /* 1771790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771800 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1771803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771824 */     // GIR_Coverage, 11752,
     /* 1771824 */     GIR_EraseRootFromParent_Done,
     /* 1771825 */   // Label 24088: @1771825
     /* 1771825 */   GIM_Try, /*On fail goto*//*Label 24089*/ GIMT_Encode4(1771911), // Rule ID 11753 //
     /* 1771830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1771833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1771841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1771844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1771847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1771850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1771853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1771856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771876 */     // MIs[0] policy
     /* 1771876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771886 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1771886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E16_MASK),
     /* 1771889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1771907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771910 */     // GIR_Coverage, 11753,
     /* 1771910 */     GIR_EraseRootFromParent_Done,
     /* 1771911 */   // Label 24089: @1771911
     /* 1771911 */   GIM_Try, /*On fail goto*//*Label 24090*/ GIMT_Encode4(1771997), // Rule ID 11756 //
     /* 1771916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1771919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1771924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1771927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1771930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1771933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1771936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1771939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1771942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1771946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1771958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1771962 */     // MIs[0] policy
     /* 1771962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1771965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1771972 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1771972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1771975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1771977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1771979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1771981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1771983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1771985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1771990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1771993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1771995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1771996 */     // GIR_Coverage, 11756,
     /* 1771996 */     GIR_EraseRootFromParent_Done,
     /* 1771997 */   // Label 24090: @1771997
     /* 1771997 */   GIM_Try, /*On fail goto*//*Label 24091*/ GIMT_Encode4(1772083), // Rule ID 11757 //
     /* 1772002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1772013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1772016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1772019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1772022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1772025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772048 */     // MIs[0] policy
     /* 1772048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772058 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E32_MASK),
     /* 1772061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1772079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772082 */     // GIR_Coverage, 11757,
     /* 1772082 */     GIR_EraseRootFromParent_Done,
     /* 1772083 */   // Label 24091: @1772083
     /* 1772083 */   GIM_Try, /*On fail goto*//*Label 24092*/ GIMT_Encode4(1772169), // Rule ID 11760 //
     /* 1772088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1772091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772134 */     // MIs[0] policy
     /* 1772134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772144 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1772147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772168 */     // GIR_Coverage, 11760,
     /* 1772168 */     GIR_EraseRootFromParent_Done,
     /* 1772169 */   // Label 24092: @1772169
     /* 1772169 */   GIM_Try, /*On fail goto*//*Label 24093*/ GIMT_Encode4(1772255), // Rule ID 11761 //
     /* 1772174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1772177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1772185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1772188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1772191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1772194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1772197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1772204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1772216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772220 */     // MIs[0] policy
     /* 1772220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772230 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M1_E64_MASK),
     /* 1772233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1772251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772254 */     // GIR_Coverage, 11761,
     /* 1772254 */     GIR_EraseRootFromParent_Done,
     /* 1772255 */   // Label 24093: @1772255
     /* 1772255 */   GIM_Try, /*On fail goto*//*Label 24094*/ GIMT_Encode4(1772341), // Rule ID 11764 //
     /* 1772260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1772280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772306 */     // MIs[0] policy
     /* 1772306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772316 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1772319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772340 */     // GIR_Coverage, 11764,
     /* 1772340 */     GIR_EraseRootFromParent_Done,
     /* 1772341 */   // Label 24094: @1772341
     /* 1772341 */   GIM_Try, /*On fail goto*//*Label 24095*/ GIMT_Encode4(1772427), // Rule ID 11765 //
     /* 1772346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1772357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1772360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1772363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1772366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772392 */     // MIs[0] policy
     /* 1772392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772402 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E8_MASK),
     /* 1772405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772426 */     // GIR_Coverage, 11765,
     /* 1772426 */     GIR_EraseRootFromParent_Done,
     /* 1772427 */   // Label 24095: @1772427
     /* 1772427 */   GIM_Try, /*On fail goto*//*Label 24096*/ GIMT_Encode4(1772513), // Rule ID 11768 //
     /* 1772432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772478 */     // MIs[0] policy
     /* 1772478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772488 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1772491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772512 */     // GIR_Coverage, 11768,
     /* 1772512 */     GIR_EraseRootFromParent_Done,
     /* 1772513 */   // Label 24096: @1772513
     /* 1772513 */   GIM_Try, /*On fail goto*//*Label 24097*/ GIMT_Encode4(1772599), // Rule ID 11769 //
     /* 1772518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1772529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1772532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1772535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1772538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1772541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772564 */     // MIs[0] policy
     /* 1772564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772574 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E8_MASK),
     /* 1772577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772598 */     // GIR_Coverage, 11769,
     /* 1772598 */     GIR_EraseRootFromParent_Done,
     /* 1772599 */   // Label 24097: @1772599
     /* 1772599 */   GIM_Try, /*On fail goto*//*Label 24098*/ GIMT_Encode4(1772685), // Rule ID 11772 //
     /* 1772604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772650 */     // MIs[0] policy
     /* 1772650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772660 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1772663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772684 */     // GIR_Coverage, 11772,
     /* 1772684 */     GIR_EraseRootFromParent_Done,
     /* 1772685 */   // Label 24098: @1772685
     /* 1772685 */   GIM_Try, /*On fail goto*//*Label 24099*/ GIMT_Encode4(1772771), // Rule ID 11773 //
     /* 1772690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1772701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1772704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1772707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1772710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1772713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1772720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1772732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772736 */     // MIs[0] policy
     /* 1772736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772746 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E8_MASK),
     /* 1772749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1772767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772770 */     // GIR_Coverage, 11773,
     /* 1772770 */     GIR_EraseRootFromParent_Done,
     /* 1772771 */   // Label 24099: @1772771
     /* 1772771 */   GIM_Try, /*On fail goto*//*Label 24100*/ GIMT_Encode4(1772857), // Rule ID 11776 //
     /* 1772776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772822 */     // MIs[0] policy
     /* 1772822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772832 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1772832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1772835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772856 */     // GIR_Coverage, 11776,
     /* 1772856 */     GIR_EraseRootFromParent_Done,
     /* 1772857 */   // Label 24100: @1772857
     /* 1772857 */   GIM_Try, /*On fail goto*//*Label 24101*/ GIMT_Encode4(1772943), // Rule ID 11777 //
     /* 1772862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1772865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1772873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1772876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1772879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1772882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1772885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1772888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1772892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1772904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772908 */     // MIs[0] policy
     /* 1772908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1772918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1772918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E16_MASK),
     /* 1772921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1772923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1772925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1772927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1772929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1772931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1772936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1772939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1772941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1772942 */     // GIR_Coverage, 11777,
     /* 1772942 */     GIR_EraseRootFromParent_Done,
     /* 1772943 */   // Label 24101: @1772943
     /* 1772943 */   GIM_Try, /*On fail goto*//*Label 24102*/ GIMT_Encode4(1773029), // Rule ID 11780 //
     /* 1772948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1772951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1772956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1772959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1772962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1772965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1772968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1772971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1772974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1772978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1772990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1772994 */     // MIs[0] policy
     /* 1772994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1772997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773004 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1773007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773028 */     // GIR_Coverage, 11780,
     /* 1773028 */     GIR_EraseRootFromParent_Done,
     /* 1773029 */   // Label 24102: @1773029
     /* 1773029 */   GIM_Try, /*On fail goto*//*Label 24103*/ GIMT_Encode4(1773115), // Rule ID 11781 //
     /* 1773034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1773045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1773048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1773051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1773054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773080 */     // MIs[0] policy
     /* 1773080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773090 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E16_MASK),
     /* 1773093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773114 */     // GIR_Coverage, 11781,
     /* 1773114 */     GIR_EraseRootFromParent_Done,
     /* 1773115 */   // Label 24103: @1773115
     /* 1773115 */   GIM_Try, /*On fail goto*//*Label 24104*/ GIMT_Encode4(1773201), // Rule ID 11784 //
     /* 1773120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1773140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773166 */     // MIs[0] policy
     /* 1773166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773176 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1773179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773200 */     // GIR_Coverage, 11784,
     /* 1773200 */     GIR_EraseRootFromParent_Done,
     /* 1773201 */   // Label 24104: @1773201
     /* 1773201 */   GIM_Try, /*On fail goto*//*Label 24105*/ GIMT_Encode4(1773287), // Rule ID 11785 //
     /* 1773206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1773217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1773220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1773223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1773226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1773229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773252 */     // MIs[0] policy
     /* 1773252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E16_MASK),
     /* 1773265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1773283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773286 */     // GIR_Coverage, 11785,
     /* 1773286 */     GIR_EraseRootFromParent_Done,
     /* 1773287 */   // Label 24105: @1773287
     /* 1773287 */   GIM_Try, /*On fail goto*//*Label 24106*/ GIMT_Encode4(1773373), // Rule ID 11788 //
     /* 1773292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1773312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773338 */     // MIs[0] policy
     /* 1773338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1773351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773372 */     // GIR_Coverage, 11788,
     /* 1773372 */     GIR_EraseRootFromParent_Done,
     /* 1773373 */   // Label 24106: @1773373
     /* 1773373 */   GIM_Try, /*On fail goto*//*Label 24107*/ GIMT_Encode4(1773459), // Rule ID 11789 //
     /* 1773378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1773389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1773392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1773395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1773398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1773401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773424 */     // MIs[0] policy
     /* 1773424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E32_MASK),
     /* 1773437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773458 */     // GIR_Coverage, 11789,
     /* 1773458 */     GIR_EraseRootFromParent_Done,
     /* 1773459 */   // Label 24107: @1773459
     /* 1773459 */   GIM_Try, /*On fail goto*//*Label 24108*/ GIMT_Encode4(1773545), // Rule ID 11792 //
     /* 1773464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773510 */     // MIs[0] policy
     /* 1773510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773520 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1773523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773544 */     // GIR_Coverage, 11792,
     /* 1773544 */     GIR_EraseRootFromParent_Done,
     /* 1773545 */   // Label 24108: @1773545
     /* 1773545 */   GIM_Try, /*On fail goto*//*Label 24109*/ GIMT_Encode4(1773631), // Rule ID 11793 //
     /* 1773550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1773561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1773564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1773567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1773570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1773573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1773580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1773592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773596 */     // MIs[0] policy
     /* 1773596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773606 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E32_MASK),
     /* 1773609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773630 */     // GIR_Coverage, 11793,
     /* 1773630 */     GIR_EraseRootFromParent_Done,
     /* 1773631 */   // Label 24109: @1773631
     /* 1773631 */   GIM_Try, /*On fail goto*//*Label 24110*/ GIMT_Encode4(1773717), // Rule ID 11796 //
     /* 1773636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1773639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773682 */     // MIs[0] policy
     /* 1773682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773692 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1773695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773716 */     // GIR_Coverage, 11796,
     /* 1773716 */     GIR_EraseRootFromParent_Done,
     /* 1773717 */   // Label 24110: @1773717
     /* 1773717 */   GIM_Try, /*On fail goto*//*Label 24111*/ GIMT_Encode4(1773803), // Rule ID 11797 //
     /* 1773722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1773725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1773733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1773736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1773739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1773742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1773745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1773752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1773764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773768 */     // MIs[0] policy
     /* 1773768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773778 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E32_MASK),
     /* 1773781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1773799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773802 */     // GIR_Coverage, 11797,
     /* 1773802 */     GIR_EraseRootFromParent_Done,
     /* 1773803 */   // Label 24111: @1773803
     /* 1773803 */   GIM_Try, /*On fail goto*//*Label 24112*/ GIMT_Encode4(1773889), // Rule ID 11800 //
     /* 1773808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1773834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773854 */     // MIs[0] policy
     /* 1773854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1773864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1773867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773888 */     // GIR_Coverage, 11800,
     /* 1773888 */     GIR_EraseRootFromParent_Done,
     /* 1773889 */   // Label 24112: @1773889
     /* 1773889 */   GIM_Try, /*On fail goto*//*Label 24113*/ GIMT_Encode4(1773975), // Rule ID 11801 //
     /* 1773894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1773897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1773905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1773908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1773911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1773914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1773917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1773920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1773924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1773936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1773940 */     // MIs[0] policy
     /* 1773940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1773943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1773950 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1773950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M2_E64_MASK),
     /* 1773953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1773955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1773957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1773959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1773961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1773963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1773968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1773971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1773973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1773974 */     // GIR_Coverage, 11801,
     /* 1773974 */     GIR_EraseRootFromParent_Done,
     /* 1773975 */   // Label 24113: @1773975
     /* 1773975 */   GIM_Try, /*On fail goto*//*Label 24114*/ GIMT_Encode4(1774061), // Rule ID 11804 //
     /* 1773980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1773983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1773988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1773991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1773994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1773997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1774000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774026 */     // MIs[0] policy
     /* 1774026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774036 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1774039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774060 */     // GIR_Coverage, 11804,
     /* 1774060 */     GIR_EraseRootFromParent_Done,
     /* 1774061 */   // Label 24114: @1774061
     /* 1774061 */   GIM_Try, /*On fail goto*//*Label 24115*/ GIMT_Encode4(1774147), // Rule ID 11805 //
     /* 1774066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1774077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1774080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1774083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1774086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1774096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1774108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774112 */     // MIs[0] policy
     /* 1774112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774122 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M4_E64_MASK),
     /* 1774125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774146 */     // GIR_Coverage, 11805,
     /* 1774146 */     GIR_EraseRootFromParent_Done,
     /* 1774147 */   // Label 24115: @1774147
     /* 1774147 */   GIM_Try, /*On fail goto*//*Label 24116*/ GIMT_Encode4(1774233), // Rule ID 11808 //
     /* 1774152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1774155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1774172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774198 */     // MIs[0] policy
     /* 1774198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774208 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1774211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774232 */     // GIR_Coverage, 11808,
     /* 1774232 */     GIR_EraseRootFromParent_Done,
     /* 1774233 */   // Label 24116: @1774233
     /* 1774233 */   GIM_Try, /*On fail goto*//*Label 24117*/ GIMT_Encode4(1774319), // Rule ID 11809 //
     /* 1774238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1774241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1774249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1774252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1774255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1774258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1774261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1774268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1774280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774284 */     // MIs[0] policy
     /* 1774284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774294 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VV_M8_E64_MASK),
     /* 1774297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1774315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774318 */     // GIR_Coverage, 11809,
     /* 1774318 */     GIR_EraseRootFromParent_Done,
     /* 1774319 */   // Label 24117: @1774319
     /* 1774319 */   GIM_Try, /*On fail goto*//*Label 24118*/ GIMT_Encode4(1774405), // Rule ID 11812 //
     /* 1774324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774370 */     // MIs[0] policy
     /* 1774370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774380 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1774383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774404 */     // GIR_Coverage, 11812,
     /* 1774404 */     GIR_EraseRootFromParent_Done,
     /* 1774405 */   // Label 24118: @1774405
     /* 1774405 */   GIM_Try, /*On fail goto*//*Label 24119*/ GIMT_Encode4(1774491), // Rule ID 11813 //
     /* 1774410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1774421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1774424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1774427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774456 */     // MIs[0] policy
     /* 1774456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774466 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF8_E8_MASK),
     /* 1774469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774490 */     // GIR_Coverage, 11813,
     /* 1774490 */     GIR_EraseRootFromParent_Done,
     /* 1774491 */   // Label 24119: @1774491
     /* 1774491 */   GIM_Try, /*On fail goto*//*Label 24120*/ GIMT_Encode4(1774577), // Rule ID 11816 //
     /* 1774496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1774507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774542 */     // MIs[0] policy
     /* 1774542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774552 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1774555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774576 */     // GIR_Coverage, 11816,
     /* 1774576 */     GIR_EraseRootFromParent_Done,
     /* 1774577 */   // Label 24120: @1774577
     /* 1774577 */   GIM_Try, /*On fail goto*//*Label 24121*/ GIMT_Encode4(1774663), // Rule ID 11817 //
     /* 1774582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1774593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1774596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1774599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1774605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774628 */     // MIs[0] policy
     /* 1774628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774638 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E8_MASK),
     /* 1774641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774662 */     // GIR_Coverage, 11817,
     /* 1774662 */     GIR_EraseRootFromParent_Done,
     /* 1774663 */   // Label 24121: @1774663
     /* 1774663 */   GIM_Try, /*On fail goto*//*Label 24122*/ GIMT_Encode4(1774749), // Rule ID 11820 //
     /* 1774668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774714 */     // MIs[0] policy
     /* 1774714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774724 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1774727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774748 */     // GIR_Coverage, 11820,
     /* 1774748 */     GIR_EraseRootFromParent_Done,
     /* 1774749 */   // Label 24122: @1774749
     /* 1774749 */   GIM_Try, /*On fail goto*//*Label 24123*/ GIMT_Encode4(1774835), // Rule ID 11821 //
     /* 1774754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1774765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1774768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1774771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1774777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774800 */     // MIs[0] policy
     /* 1774800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774810 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E8_MASK),
     /* 1774813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1774831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774834 */     // GIR_Coverage, 11821,
     /* 1774834 */     GIR_EraseRootFromParent_Done,
     /* 1774835 */   // Label 24123: @1774835
     /* 1774835 */   GIM_Try, /*On fail goto*//*Label 24124*/ GIMT_Encode4(1774921), // Rule ID 11824 //
     /* 1774840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1774843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1774860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1774866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774886 */     // MIs[0] policy
     /* 1774886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774896 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1774896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1774899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1774914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1774917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1774919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1774920 */     // GIR_Coverage, 11824,
     /* 1774920 */     GIR_EraseRootFromParent_Done,
     /* 1774921 */   // Label 24124: @1774921
     /* 1774921 */   GIM_Try, /*On fail goto*//*Label 24125*/ GIMT_Encode4(1775007), // Rule ID 11825 //
     /* 1774926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1774929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1774934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1774937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1774940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1774943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1774946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1774949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1774952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1774956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1774964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1774968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1774972 */     // MIs[0] policy
     /* 1774972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1774975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1774982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1774982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF4_E16_MASK),
     /* 1774985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1774987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1774989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1774991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1774993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1774995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775006 */     // GIR_Coverage, 11825,
     /* 1775006 */     GIR_EraseRootFromParent_Done,
     /* 1775007 */   // Label 24125: @1775007
     /* 1775007 */   GIM_Try, /*On fail goto*//*Label 24126*/ GIMT_Encode4(1775093), // Rule ID 11828 //
     /* 1775012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775058 */     // MIs[0] policy
     /* 1775058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775068 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1775071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775092 */     // GIR_Coverage, 11828,
     /* 1775092 */     GIR_EraseRootFromParent_Done,
     /* 1775093 */   // Label 24126: @1775093
     /* 1775093 */   GIM_Try, /*On fail goto*//*Label 24127*/ GIMT_Encode4(1775179), // Rule ID 11829 //
     /* 1775098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1775109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1775112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1775115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775144 */     // MIs[0] policy
     /* 1775144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775154 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E16_MASK),
     /* 1775157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775178 */     // GIR_Coverage, 11829,
     /* 1775178 */     GIR_EraseRootFromParent_Done,
     /* 1775179 */   // Label 24127: @1775179
     /* 1775179 */   GIM_Try, /*On fail goto*//*Label 24128*/ GIMT_Encode4(1775265), // Rule ID 11832 //
     /* 1775184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775230 */     // MIs[0] policy
     /* 1775230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775240 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1775243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775264 */     // GIR_Coverage, 11832,
     /* 1775264 */     GIR_EraseRootFromParent_Done,
     /* 1775265 */   // Label 24128: @1775265
     /* 1775265 */   GIM_Try, /*On fail goto*//*Label 24129*/ GIMT_Encode4(1775351), // Rule ID 11833 //
     /* 1775270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1775281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1775284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1775287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775316 */     // MIs[0] policy
     /* 1775316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_MF2_E32_MASK),
     /* 1775329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775350 */     // GIR_Coverage, 11833,
     /* 1775350 */     GIR_EraseRootFromParent_Done,
     /* 1775351 */   // Label 24129: @1775351
     /* 1775351 */   GIM_Try, /*On fail goto*//*Label 24130*/ GIMT_Encode4(1775437), // Rule ID 11836 //
     /* 1775356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1775367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1775370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1775373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775402 */     // MIs[0] policy
     /* 1775402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775412 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1775415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775436 */     // GIR_Coverage, 11836,
     /* 1775436 */     GIR_EraseRootFromParent_Done,
     /* 1775437 */   // Label 24130: @1775437
     /* 1775437 */   GIM_Try, /*On fail goto*//*Label 24131*/ GIMT_Encode4(1775523), // Rule ID 11837 //
     /* 1775442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1775453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1775456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1775459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1775465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775488 */     // MIs[0] policy
     /* 1775488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775498 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11113:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E8_MASK),
     /* 1775501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1775519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775522 */     // GIR_Coverage, 11837,
     /* 1775522 */     GIR_EraseRootFromParent_Done,
     /* 1775523 */   // Label 24131: @1775523
     /* 1775523 */   GIM_Try, /*On fail goto*//*Label 24132*/ GIMT_Encode4(1775609), // Rule ID 11840 //
     /* 1775528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775574 */     // MIs[0] policy
     /* 1775574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1775587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775608 */     // GIR_Coverage, 11840,
     /* 1775608 */     GIR_EraseRootFromParent_Done,
     /* 1775609 */   // Label 24132: @1775609
     /* 1775609 */   GIM_Try, /*On fail goto*//*Label 24133*/ GIMT_Encode4(1775695), // Rule ID 11841 //
     /* 1775614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1775625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1775628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1775631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1775637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775660 */     // MIs[0] policy
     /* 1775660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775670 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11113:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E16_MASK),
     /* 1775673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1775691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775694 */     // GIR_Coverage, 11841,
     /* 1775694 */     GIR_EraseRootFromParent_Done,
     /* 1775695 */   // Label 24133: @1775695
     /* 1775695 */   GIM_Try, /*On fail goto*//*Label 24134*/ GIMT_Encode4(1775781), // Rule ID 11844 //
     /* 1775700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1775703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775746 */     // MIs[0] policy
     /* 1775746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775756 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1775759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775780 */     // GIR_Coverage, 11844,
     /* 1775780 */     GIR_EraseRootFromParent_Done,
     /* 1775781 */   // Label 24134: @1775781
     /* 1775781 */   GIM_Try, /*On fail goto*//*Label 24135*/ GIMT_Encode4(1775867), // Rule ID 11845 //
     /* 1775786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1775789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1775797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1775800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1775803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1775809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775832 */     // MIs[0] policy
     /* 1775832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775842 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11113:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1775842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E32_MASK),
     /* 1775845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1775863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775866 */     // GIR_Coverage, 11845,
     /* 1775866 */     GIR_EraseRootFromParent_Done,
     /* 1775867 */   // Label 24135: @1775867
     /* 1775867 */   GIM_Try, /*On fail goto*//*Label 24136*/ GIMT_Encode4(1775953), // Rule ID 11848 //
     /* 1775872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1775875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1775892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1775898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1775914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1775918 */     // MIs[0] policy
     /* 1775918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1775921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1775928 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1775928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1775931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1775933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1775935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1775937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1775939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1775941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1775946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1775949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1775951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1775952 */     // GIR_Coverage, 11848,
     /* 1775952 */     GIR_EraseRootFromParent_Done,
     /* 1775953 */   // Label 24136: @1775953
     /* 1775953 */   GIM_Try, /*On fail goto*//*Label 24137*/ GIMT_Encode4(1776039), // Rule ID 11849 //
     /* 1775958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1775961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1775966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1775969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1775972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1775975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1775978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1775981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1775984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1775988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1775996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776004 */     // MIs[0] policy
     /* 1776004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11113:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M1_E64_MASK),
     /* 1776017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1776035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776038 */     // GIR_Coverage, 11849,
     /* 1776038 */     GIR_EraseRootFromParent_Done,
     /* 1776039 */   // Label 24137: @1776039
     /* 1776039 */   GIM_Try, /*On fail goto*//*Label 24138*/ GIMT_Encode4(1776125), // Rule ID 11852 //
     /* 1776044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776090 */     // MIs[0] policy
     /* 1776090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776100 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1776103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776124 */     // GIR_Coverage, 11852,
     /* 1776124 */     GIR_EraseRootFromParent_Done,
     /* 1776125 */   // Label 24138: @1776125
     /* 1776125 */   GIM_Try, /*On fail goto*//*Label 24139*/ GIMT_Encode4(1776211), // Rule ID 11853 //
     /* 1776130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1776141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1776144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1776147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776176 */     // MIs[0] policy
     /* 1776176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E8_MASK),
     /* 1776189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776210 */     // GIR_Coverage, 11853,
     /* 1776210 */     GIR_EraseRootFromParent_Done,
     /* 1776211 */   // Label 24139: @1776211
     /* 1776211 */   GIM_Try, /*On fail goto*//*Label 24140*/ GIMT_Encode4(1776297), // Rule ID 11856 //
     /* 1776216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776262 */     // MIs[0] policy
     /* 1776262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776272 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1776275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776296 */     // GIR_Coverage, 11856,
     /* 1776296 */     GIR_EraseRootFromParent_Done,
     /* 1776297 */   // Label 24140: @1776297
     /* 1776297 */   GIM_Try, /*On fail goto*//*Label 24141*/ GIMT_Encode4(1776383), // Rule ID 11857 //
     /* 1776302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1776313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1776316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1776319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776348 */     // MIs[0] policy
     /* 1776348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776358 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E8_MASK),
     /* 1776361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776382 */     // GIR_Coverage, 11857,
     /* 1776382 */     GIR_EraseRootFromParent_Done,
     /* 1776383 */   // Label 24141: @1776383
     /* 1776383 */   GIM_Try, /*On fail goto*//*Label 24142*/ GIMT_Encode4(1776469), // Rule ID 11860 //
     /* 1776388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1776399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1776402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1776405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1776411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776434 */     // MIs[0] policy
     /* 1776434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776444 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1776447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776468 */     // GIR_Coverage, 11860,
     /* 1776468 */     GIR_EraseRootFromParent_Done,
     /* 1776469 */   // Label 24142: @1776469
     /* 1776469 */   GIM_Try, /*On fail goto*//*Label 24143*/ GIMT_Encode4(1776555), // Rule ID 11861 //
     /* 1776474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1776485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1776488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1776491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1776497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776520 */     // MIs[0] policy
     /* 1776520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776530 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E8_MASK),
     /* 1776533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1776551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776554 */     // GIR_Coverage, 11861,
     /* 1776554 */     GIR_EraseRootFromParent_Done,
     /* 1776555 */   // Label 24143: @1776555
     /* 1776555 */   GIM_Try, /*On fail goto*//*Label 24144*/ GIMT_Encode4(1776641), // Rule ID 11864 //
     /* 1776560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776606 */     // MIs[0] policy
     /* 1776606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776616 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1776619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776640 */     // GIR_Coverage, 11864,
     /* 1776640 */     GIR_EraseRootFromParent_Done,
     /* 1776641 */   // Label 24144: @1776641
     /* 1776641 */   GIM_Try, /*On fail goto*//*Label 24145*/ GIMT_Encode4(1776727), // Rule ID 11865 //
     /* 1776646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1776657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1776660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1776663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1776669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1776676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1776684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776692 */     // MIs[0] policy
     /* 1776692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776702 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E16_MASK),
     /* 1776705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776726 */     // GIR_Coverage, 11865,
     /* 1776726 */     GIR_EraseRootFromParent_Done,
     /* 1776727 */   // Label 24145: @1776727
     /* 1776727 */   GIM_Try, /*On fail goto*//*Label 24146*/ GIMT_Encode4(1776813), // Rule ID 11868 //
     /* 1776732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776778 */     // MIs[0] policy
     /* 1776778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776788 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1776791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776812 */     // GIR_Coverage, 11868,
     /* 1776812 */     GIR_EraseRootFromParent_Done,
     /* 1776813 */   // Label 24146: @1776813
     /* 1776813 */   GIM_Try, /*On fail goto*//*Label 24147*/ GIMT_Encode4(1776899), // Rule ID 11869 //
     /* 1776818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1776829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1776832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1776835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1776838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1776841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1776844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1776848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1776856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776864 */     // MIs[0] policy
     /* 1776864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1776874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E16_MASK),
     /* 1776877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776898 */     // GIR_Coverage, 11869,
     /* 1776898 */     GIR_EraseRootFromParent_Done,
     /* 1776899 */   // Label 24147: @1776899
     /* 1776899 */   GIM_Try, /*On fail goto*//*Label 24148*/ GIMT_Encode4(1776985), // Rule ID 11872 //
     /* 1776904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1776907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1776915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1776918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1776921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1776924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1776927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1776930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1776934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1776942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1776946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1776950 */     // MIs[0] policy
     /* 1776950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1776953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1776960 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1776960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1776963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1776965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1776967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1776969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1776971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1776973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1776978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1776981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1776983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1776984 */     // GIR_Coverage, 11872,
     /* 1776984 */     GIR_EraseRootFromParent_Done,
     /* 1776985 */   // Label 24148: @1776985
     /* 1776985 */   GIM_Try, /*On fail goto*//*Label 24149*/ GIMT_Encode4(1777071), // Rule ID 11873 //
     /* 1776990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1776993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1776998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1777001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1777004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1777007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1777013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777036 */     // MIs[0] policy
     /* 1777036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777046 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E16_MASK),
     /* 1777049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1777067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777070 */     // GIR_Coverage, 11873,
     /* 1777070 */     GIR_EraseRootFromParent_Done,
     /* 1777071 */   // Label 24149: @1777071
     /* 1777071 */   GIM_Try, /*On fail goto*//*Label 24150*/ GIMT_Encode4(1777157), // Rule ID 11876 //
     /* 1777076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777122 */     // MIs[0] policy
     /* 1777122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777132 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1777135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777156 */     // GIR_Coverage, 11876,
     /* 1777156 */     GIR_EraseRootFromParent_Done,
     /* 1777157 */   // Label 24150: @1777157
     /* 1777157 */   GIM_Try, /*On fail goto*//*Label 24151*/ GIMT_Encode4(1777243), // Rule ID 11877 //
     /* 1777162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1777173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1777176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1777179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777208 */     // MIs[0] policy
     /* 1777208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777218 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E32_MASK),
     /* 1777221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777242 */     // GIR_Coverage, 11877,
     /* 1777242 */     GIR_EraseRootFromParent_Done,
     /* 1777243 */   // Label 24151: @1777243
     /* 1777243 */   GIM_Try, /*On fail goto*//*Label 24152*/ GIMT_Encode4(1777329), // Rule ID 11880 //
     /* 1777248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777294 */     // MIs[0] policy
     /* 1777294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777304 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1777307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777328 */     // GIR_Coverage, 11880,
     /* 1777328 */     GIR_EraseRootFromParent_Done,
     /* 1777329 */   // Label 24152: @1777329
     /* 1777329 */   GIM_Try, /*On fail goto*//*Label 24153*/ GIMT_Encode4(1777415), // Rule ID 11881 //
     /* 1777334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1777345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1777348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1777351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777380 */     // MIs[0] policy
     /* 1777380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777390 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E32_MASK),
     /* 1777393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777414 */     // GIR_Coverage, 11881,
     /* 1777414 */     GIR_EraseRootFromParent_Done,
     /* 1777415 */   // Label 24153: @1777415
     /* 1777415 */   GIM_Try, /*On fail goto*//*Label 24154*/ GIMT_Encode4(1777501), // Rule ID 11884 //
     /* 1777420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1777423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1777434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1777437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777466 */     // MIs[0] policy
     /* 1777466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777476 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1777479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777500 */     // GIR_Coverage, 11884,
     /* 1777500 */     GIR_EraseRootFromParent_Done,
     /* 1777501 */   // Label 24154: @1777501
     /* 1777501 */   GIM_Try, /*On fail goto*//*Label 24155*/ GIMT_Encode4(1777587), // Rule ID 11885 //
     /* 1777506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1777509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1777517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1777520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1777523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1777529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777552 */     // MIs[0] policy
     /* 1777552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777562 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E32_MASK),
     /* 1777565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1777583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777586 */     // GIR_Coverage, 11885,
     /* 1777586 */     GIR_EraseRootFromParent_Done,
     /* 1777587 */   // Label 24155: @1777587
     /* 1777587 */   GIM_Try, /*On fail goto*//*Label 24156*/ GIMT_Encode4(1777673), // Rule ID 11888 //
     /* 1777592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777638 */     // MIs[0] policy
     /* 1777638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1777651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777672 */     // GIR_Coverage, 11888,
     /* 1777672 */     GIR_EraseRootFromParent_Done,
     /* 1777673 */   // Label 24156: @1777673
     /* 1777673 */   GIM_Try, /*On fail goto*//*Label 24157*/ GIMT_Encode4(1777759), // Rule ID 11889 //
     /* 1777678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1777689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1777692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1777695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1777701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1777708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1777716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777724 */     // MIs[0] policy
     /* 1777724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11113:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M2_E64_MASK),
     /* 1777737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777758 */     // GIR_Coverage, 11889,
     /* 1777758 */     GIR_EraseRootFromParent_Done,
     /* 1777759 */   // Label 24157: @1777759
     /* 1777759 */   GIM_Try, /*On fail goto*//*Label 24158*/ GIMT_Encode4(1777845), // Rule ID 11892 //
     /* 1777764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777810 */     // MIs[0] policy
     /* 1777810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777820 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1777823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777844 */     // GIR_Coverage, 11892,
     /* 1777844 */     GIR_EraseRootFromParent_Done,
     /* 1777845 */   // Label 24158: @1777845
     /* 1777845 */   GIM_Try, /*On fail goto*//*Label 24159*/ GIMT_Encode4(1777931), // Rule ID 11893 //
     /* 1777850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1777853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1777861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1777864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1777867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1777870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1777873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1777876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1777880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1777888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777896 */     // MIs[0] policy
     /* 1777896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777906 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11113:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1777906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M4_E64_MASK),
     /* 1777909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1777915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1777917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1777919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1777924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1777927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1777929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1777930 */     // GIR_Coverage, 11893,
     /* 1777930 */     GIR_EraseRootFromParent_Done,
     /* 1777931 */   // Label 24159: @1777931
     /* 1777931 */   GIM_Try, /*On fail goto*//*Label 24160*/ GIMT_Encode4(1778017), // Rule ID 11896 //
     /* 1777936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1777939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1777944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1777947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1777950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1777953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1777956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1777959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1777962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1777966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1777974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1777978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1777982 */     // MIs[0] policy
     /* 1777982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1777985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1777992 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1777992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1777995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1777997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1777999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778016 */     // GIR_Coverage, 11896,
     /* 1778016 */     GIR_EraseRootFromParent_Done,
     /* 1778017 */   // Label 24160: @1778017
     /* 1778017 */   GIM_Try, /*On fail goto*//*Label 24161*/ GIMT_Encode4(1778103), // Rule ID 11897 //
     /* 1778022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1778025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vdiv_mask),
     /* 1778030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1778033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1778036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1778039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1778042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1778045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1778052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1778060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1778064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778068 */     // MIs[0] policy
     /* 1778068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778078 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11113:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVDIV_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVDIV_VX_M8_E64_MASK),
     /* 1778081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1778099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778102 */     // GIR_Coverage, 11897,
     /* 1778102 */     GIR_EraseRootFromParent_Done,
     /* 1778103 */   // Label 24161: @1778103
     /* 1778103 */   GIM_Try, /*On fail goto*//*Label 24162*/ GIMT_Encode4(1778189), // Rule ID 11900 //
     /* 1778108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1778128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778154 */     // MIs[0] policy
     /* 1778154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778164 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1778167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778188 */     // GIR_Coverage, 11900,
     /* 1778188 */     GIR_EraseRootFromParent_Done,
     /* 1778189 */   // Label 24162: @1778189
     /* 1778189 */   GIM_Try, /*On fail goto*//*Label 24163*/ GIMT_Encode4(1778275), // Rule ID 11901 //
     /* 1778194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1778205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1778208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1778211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1778214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778240 */     // MIs[0] policy
     /* 1778240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778250 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF8_E8_MASK),
     /* 1778253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778274 */     // GIR_Coverage, 11901,
     /* 1778274 */     GIR_EraseRootFromParent_Done,
     /* 1778275 */   // Label 24163: @1778275
     /* 1778275 */   GIM_Try, /*On fail goto*//*Label 24164*/ GIMT_Encode4(1778361), // Rule ID 11904 //
     /* 1778280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1778300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778326 */     // MIs[0] policy
     /* 1778326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778336 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1778339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778360 */     // GIR_Coverage, 11904,
     /* 1778360 */     GIR_EraseRootFromParent_Done,
     /* 1778361 */   // Label 24164: @1778361
     /* 1778361 */   GIM_Try, /*On fail goto*//*Label 24165*/ GIMT_Encode4(1778447), // Rule ID 11905 //
     /* 1778366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1778377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1778380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1778383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1778386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778412 */     // MIs[0] policy
     /* 1778412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778422 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E8_MASK),
     /* 1778425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778446 */     // GIR_Coverage, 11905,
     /* 1778446 */     GIR_EraseRootFromParent_Done,
     /* 1778447 */   // Label 24165: @1778447
     /* 1778447 */   GIM_Try, /*On fail goto*//*Label 24166*/ GIMT_Encode4(1778533), // Rule ID 11908 //
     /* 1778452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1778463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1778466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1778469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1778472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778498 */     // MIs[0] policy
     /* 1778498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1778511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778532 */     // GIR_Coverage, 11908,
     /* 1778532 */     GIR_EraseRootFromParent_Done,
     /* 1778533 */   // Label 24166: @1778533
     /* 1778533 */   GIM_Try, /*On fail goto*//*Label 24167*/ GIMT_Encode4(1778619), // Rule ID 11909 //
     /* 1778538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1778549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1778552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1778555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1778558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1778561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778584 */     // MIs[0] policy
     /* 1778584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778594 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E8_MASK),
     /* 1778597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1778615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778618 */     // GIR_Coverage, 11909,
     /* 1778618 */     GIR_EraseRootFromParent_Done,
     /* 1778619 */   // Label 24167: @1778619
     /* 1778619 */   GIM_Try, /*On fail goto*//*Label 24168*/ GIMT_Encode4(1778705), // Rule ID 11912 //
     /* 1778624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778670 */     // MIs[0] policy
     /* 1778670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778680 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1778683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778704 */     // GIR_Coverage, 11912,
     /* 1778704 */     GIR_EraseRootFromParent_Done,
     /* 1778705 */   // Label 24168: @1778705
     /* 1778705 */   GIM_Try, /*On fail goto*//*Label 24169*/ GIMT_Encode4(1778791), // Rule ID 11913 //
     /* 1778710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1778721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1778724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1778727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1778730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778756 */     // MIs[0] policy
     /* 1778756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778766 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF4_E16_MASK),
     /* 1778769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778790 */     // GIR_Coverage, 11913,
     /* 1778790 */     GIR_EraseRootFromParent_Done,
     /* 1778791 */   // Label 24169: @1778791
     /* 1778791 */   GIM_Try, /*On fail goto*//*Label 24170*/ GIMT_Encode4(1778877), // Rule ID 11916 //
     /* 1778796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778842 */     // MIs[0] policy
     /* 1778842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1778852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1778855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778876 */     // GIR_Coverage, 11916,
     /* 1778876 */     GIR_EraseRootFromParent_Done,
     /* 1778877 */   // Label 24170: @1778877
     /* 1778877 */   GIM_Try, /*On fail goto*//*Label 24171*/ GIMT_Encode4(1778963), // Rule ID 11917 //
     /* 1778882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1778885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1778893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1778896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1778899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1778902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1778905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1778908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1778924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1778928 */     // MIs[0] policy
     /* 1778928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1778931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1778938 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1778938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E16_MASK),
     /* 1778941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1778943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1778945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1778947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1778949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1778951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1778956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1778959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1778961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1778962 */     // GIR_Coverage, 11917,
     /* 1778962 */     GIR_EraseRootFromParent_Done,
     /* 1778963 */   // Label 24171: @1778963
     /* 1778963 */   GIM_Try, /*On fail goto*//*Label 24172*/ GIMT_Encode4(1779049), // Rule ID 11920 //
     /* 1778968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1778971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1778976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1778979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1778982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1778985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1778988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1778991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1778994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1778998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779014 */     // MIs[0] policy
     /* 1779014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779024 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1779027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779048 */     // GIR_Coverage, 11920,
     /* 1779048 */     GIR_EraseRootFromParent_Done,
     /* 1779049 */   // Label 24172: @1779049
     /* 1779049 */   GIM_Try, /*On fail goto*//*Label 24173*/ GIMT_Encode4(1779135), // Rule ID 11921 //
     /* 1779054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1779065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1779068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1779071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1779074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779100 */     // MIs[0] policy
     /* 1779100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779110 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_MF2_E32_MASK),
     /* 1779113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779134 */     // GIR_Coverage, 11921,
     /* 1779134 */     GIR_EraseRootFromParent_Done,
     /* 1779135 */   // Label 24173: @1779135
     /* 1779135 */   GIM_Try, /*On fail goto*//*Label 24174*/ GIMT_Encode4(1779221), // Rule ID 11924 //
     /* 1779140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1779160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779186 */     // MIs[0] policy
     /* 1779186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779196 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1779199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779220 */     // GIR_Coverage, 11924,
     /* 1779220 */     GIR_EraseRootFromParent_Done,
     /* 1779221 */   // Label 24174: @1779221
     /* 1779221 */   GIM_Try, /*On fail goto*//*Label 24175*/ GIMT_Encode4(1779307), // Rule ID 11925 //
     /* 1779226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1779237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1779240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1779243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1779246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1779249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779272 */     // MIs[0] policy
     /* 1779272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779282 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E8_MASK),
     /* 1779285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779306 */     // GIR_Coverage, 11925,
     /* 1779306 */     GIR_EraseRootFromParent_Done,
     /* 1779307 */   // Label 24175: @1779307
     /* 1779307 */   GIM_Try, /*On fail goto*//*Label 24176*/ GIMT_Encode4(1779393), // Rule ID 11928 //
     /* 1779312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1779323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1779326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1779329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1779332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779358 */     // MIs[0] policy
     /* 1779358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1779371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779392 */     // GIR_Coverage, 11928,
     /* 1779392 */     GIR_EraseRootFromParent_Done,
     /* 1779393 */   // Label 24176: @1779393
     /* 1779393 */   GIM_Try, /*On fail goto*//*Label 24177*/ GIMT_Encode4(1779479), // Rule ID 11929 //
     /* 1779398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1779409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1779412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1779415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1779418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1779421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779444 */     // MIs[0] policy
     /* 1779444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E16_MASK),
     /* 1779457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1779475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779478 */     // GIR_Coverage, 11929,
     /* 1779478 */     GIR_EraseRootFromParent_Done,
     /* 1779479 */   // Label 24177: @1779479
     /* 1779479 */   GIM_Try, /*On fail goto*//*Label 24178*/ GIMT_Encode4(1779565), // Rule ID 11932 //
     /* 1779484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1779495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1779498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1779501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1779504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779530 */     // MIs[0] policy
     /* 1779530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779540 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1779543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779564 */     // GIR_Coverage, 11932,
     /* 1779564 */     GIR_EraseRootFromParent_Done,
     /* 1779565 */   // Label 24178: @1779565
     /* 1779565 */   GIM_Try, /*On fail goto*//*Label 24179*/ GIMT_Encode4(1779651), // Rule ID 11933 //
     /* 1779570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1779581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1779584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1779587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1779590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1779593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779616 */     // MIs[0] policy
     /* 1779616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779626 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E32_MASK),
     /* 1779629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1779647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779650 */     // GIR_Coverage, 11933,
     /* 1779650 */     GIR_EraseRootFromParent_Done,
     /* 1779651 */   // Label 24179: @1779651
     /* 1779651 */   GIM_Try, /*On fail goto*//*Label 24180*/ GIMT_Encode4(1779737), // Rule ID 11936 //
     /* 1779656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1779659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779702 */     // MIs[0] policy
     /* 1779702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779712 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1779715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779736 */     // GIR_Coverage, 11936,
     /* 1779736 */     GIR_EraseRootFromParent_Done,
     /* 1779737 */   // Label 24180: @1779737
     /* 1779737 */   GIM_Try, /*On fail goto*//*Label 24181*/ GIMT_Encode4(1779823), // Rule ID 11937 //
     /* 1779742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1779745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1779753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1779756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1779759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1779762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1779765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1779772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1779784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779788 */     // MIs[0] policy
     /* 1779788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779798 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M1_E64_MASK),
     /* 1779801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1779819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779822 */     // GIR_Coverage, 11937,
     /* 1779822 */     GIR_EraseRootFromParent_Done,
     /* 1779823 */   // Label 24181: @1779823
     /* 1779823 */   GIM_Try, /*On fail goto*//*Label 24182*/ GIMT_Encode4(1779909), // Rule ID 11940 //
     /* 1779828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1779831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1779854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779874 */     // MIs[0] policy
     /* 1779874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1779884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1779887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779908 */     // GIR_Coverage, 11940,
     /* 1779908 */     GIR_EraseRootFromParent_Done,
     /* 1779909 */   // Label 24182: @1779909
     /* 1779909 */   GIM_Try, /*On fail goto*//*Label 24183*/ GIMT_Encode4(1779995), // Rule ID 11941 //
     /* 1779914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1779917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1779922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1779925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1779928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1779931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1779934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1779937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1779940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1779944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1779956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1779960 */     // MIs[0] policy
     /* 1779960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1779963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1779970 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1779970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E8_MASK),
     /* 1779973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1779975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1779977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1779979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1779981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1779983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1779988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1779991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1779993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1779994 */     // GIR_Coverage, 11941,
     /* 1779994 */     GIR_EraseRootFromParent_Done,
     /* 1779995 */   // Label 24183: @1779995
     /* 1779995 */   GIM_Try, /*On fail goto*//*Label 24184*/ GIMT_Encode4(1780081), // Rule ID 11944 //
     /* 1780000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1780020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780046 */     // MIs[0] policy
     /* 1780046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780056 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1780059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780080 */     // GIR_Coverage, 11944,
     /* 1780080 */     GIR_EraseRootFromParent_Done,
     /* 1780081 */   // Label 24184: @1780081
     /* 1780081 */   GIM_Try, /*On fail goto*//*Label 24185*/ GIMT_Encode4(1780167), // Rule ID 11945 //
     /* 1780086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1780097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1780100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1780103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1780106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780132 */     // MIs[0] policy
     /* 1780132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E8_MASK),
     /* 1780145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780166 */     // GIR_Coverage, 11945,
     /* 1780166 */     GIR_EraseRootFromParent_Done,
     /* 1780167 */   // Label 24185: @1780167
     /* 1780167 */   GIM_Try, /*On fail goto*//*Label 24186*/ GIMT_Encode4(1780253), // Rule ID 11948 //
     /* 1780172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1780192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780218 */     // MIs[0] policy
     /* 1780218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780228 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1780231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780252 */     // GIR_Coverage, 11948,
     /* 1780252 */     GIR_EraseRootFromParent_Done,
     /* 1780253 */   // Label 24186: @1780253
     /* 1780253 */   GIM_Try, /*On fail goto*//*Label 24187*/ GIMT_Encode4(1780339), // Rule ID 11949 //
     /* 1780258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1780269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1780272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1780275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1780278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1780281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780304 */     // MIs[0] policy
     /* 1780304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E8_MASK),
     /* 1780317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1780335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780338 */     // GIR_Coverage, 11949,
     /* 1780338 */     GIR_EraseRootFromParent_Done,
     /* 1780339 */   // Label 24187: @1780339
     /* 1780339 */   GIM_Try, /*On fail goto*//*Label 24188*/ GIMT_Encode4(1780425), // Rule ID 11952 //
     /* 1780344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1780355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1780358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1780361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1780364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780390 */     // MIs[0] policy
     /* 1780390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780400 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1780403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780424 */     // GIR_Coverage, 11952,
     /* 1780424 */     GIR_EraseRootFromParent_Done,
     /* 1780425 */   // Label 24188: @1780425
     /* 1780425 */   GIM_Try, /*On fail goto*//*Label 24189*/ GIMT_Encode4(1780511), // Rule ID 11953 //
     /* 1780430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1780441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1780444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1780447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1780450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1780453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780476 */     // MIs[0] policy
     /* 1780476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E16_MASK),
     /* 1780489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780510 */     // GIR_Coverage, 11953,
     /* 1780510 */     GIR_EraseRootFromParent_Done,
     /* 1780511 */   // Label 24189: @1780511
     /* 1780511 */   GIM_Try, /*On fail goto*//*Label 24190*/ GIMT_Encode4(1780597), // Rule ID 11956 //
     /* 1780516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780562 */     // MIs[0] policy
     /* 1780562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780572 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1780575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780596 */     // GIR_Coverage, 11956,
     /* 1780596 */     GIR_EraseRootFromParent_Done,
     /* 1780597 */   // Label 24190: @1780597
     /* 1780597 */   GIM_Try, /*On fail goto*//*Label 24191*/ GIMT_Encode4(1780683), // Rule ID 11957 //
     /* 1780602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1780613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1780616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1780619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1780622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1780625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1780632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1780644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780648 */     // MIs[0] policy
     /* 1780648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780658 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E16_MASK),
     /* 1780661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780682 */     // GIR_Coverage, 11957,
     /* 1780682 */     GIR_EraseRootFromParent_Done,
     /* 1780683 */   // Label 24191: @1780683
     /* 1780683 */   GIM_Try, /*On fail goto*//*Label 24192*/ GIMT_Encode4(1780769), // Rule ID 11960 //
     /* 1780688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780734 */     // MIs[0] policy
     /* 1780734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780744 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1780747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780768 */     // GIR_Coverage, 11960,
     /* 1780768 */     GIR_EraseRootFromParent_Done,
     /* 1780769 */   // Label 24192: @1780769
     /* 1780769 */   GIM_Try, /*On fail goto*//*Label 24193*/ GIMT_Encode4(1780855), // Rule ID 11961 //
     /* 1780774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1780785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1780788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1780791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1780794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1780797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1780804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1780816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780820 */     // MIs[0] policy
     /* 1780820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780830 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1780830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E16_MASK),
     /* 1780833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1780851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780854 */     // GIR_Coverage, 11961,
     /* 1780854 */     GIR_EraseRootFromParent_Done,
     /* 1780855 */   // Label 24193: @1780855
     /* 1780855 */   GIM_Try, /*On fail goto*//*Label 24194*/ GIMT_Encode4(1780941), // Rule ID 11964 //
     /* 1780860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1780863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1780886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780906 */     // MIs[0] policy
     /* 1780906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1780916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1780916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1780919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1780921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1780923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1780925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1780927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1780929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1780934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1780937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1780939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1780940 */     // GIR_Coverage, 11964,
     /* 1780940 */     GIR_EraseRootFromParent_Done,
     /* 1780941 */   // Label 24194: @1780941
     /* 1780941 */   GIM_Try, /*On fail goto*//*Label 24195*/ GIMT_Encode4(1781027), // Rule ID 11965 //
     /* 1780946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1780949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1780954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1780957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1780960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1780963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1780966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1780969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1780972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1780976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1780988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1780992 */     // MIs[0] policy
     /* 1780992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1780995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E32_MASK),
     /* 1781005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781026 */     // GIR_Coverage, 11965,
     /* 1781026 */     GIR_EraseRootFromParent_Done,
     /* 1781027 */   // Label 24195: @1781027
     /* 1781027 */   GIM_Try, /*On fail goto*//*Label 24196*/ GIMT_Encode4(1781113), // Rule ID 11968 //
     /* 1781032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1781052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781078 */     // MIs[0] policy
     /* 1781078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781088 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1781091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781112 */     // GIR_Coverage, 11968,
     /* 1781112 */     GIR_EraseRootFromParent_Done,
     /* 1781113 */   // Label 24196: @1781113
     /* 1781113 */   GIM_Try, /*On fail goto*//*Label 24197*/ GIMT_Encode4(1781199), // Rule ID 11969 //
     /* 1781118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1781129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1781132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1781135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1781138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781164 */     // MIs[0] policy
     /* 1781164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781174 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E32_MASK),
     /* 1781177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781198 */     // GIR_Coverage, 11969,
     /* 1781198 */     GIR_EraseRootFromParent_Done,
     /* 1781199 */   // Label 24197: @1781199
     /* 1781199 */   GIM_Try, /*On fail goto*//*Label 24198*/ GIMT_Encode4(1781285), // Rule ID 11972 //
     /* 1781204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1781224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781250 */     // MIs[0] policy
     /* 1781250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781260 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1781263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781284 */     // GIR_Coverage, 11972,
     /* 1781284 */     GIR_EraseRootFromParent_Done,
     /* 1781285 */   // Label 24198: @1781285
     /* 1781285 */   GIM_Try, /*On fail goto*//*Label 24199*/ GIMT_Encode4(1781371), // Rule ID 11973 //
     /* 1781290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1781301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1781304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1781307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1781310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1781313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781336 */     // MIs[0] policy
     /* 1781336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781346 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E32_MASK),
     /* 1781349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1781367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781370 */     // GIR_Coverage, 11973,
     /* 1781370 */     GIR_EraseRootFromParent_Done,
     /* 1781371 */   // Label 24199: @1781371
     /* 1781371 */   GIM_Try, /*On fail goto*//*Label 24200*/ GIMT_Encode4(1781457), // Rule ID 11976 //
     /* 1781376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1781387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1781390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1781393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1781396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781422 */     // MIs[0] policy
     /* 1781422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1781435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781456 */     // GIR_Coverage, 11976,
     /* 1781456 */     GIR_EraseRootFromParent_Done,
     /* 1781457 */   // Label 24200: @1781457
     /* 1781457 */   GIM_Try, /*On fail goto*//*Label 24201*/ GIMT_Encode4(1781543), // Rule ID 11977 //
     /* 1781462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1781473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1781476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1781479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1781482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1781485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1781492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1781504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781508 */     // MIs[0] policy
     /* 1781508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781518 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M2_E64_MASK),
     /* 1781521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781542 */     // GIR_Coverage, 11977,
     /* 1781542 */     GIR_EraseRootFromParent_Done,
     /* 1781543 */   // Label 24201: @1781543
     /* 1781543 */   GIM_Try, /*On fail goto*//*Label 24202*/ GIMT_Encode4(1781629), // Rule ID 11980 //
     /* 1781548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781594 */     // MIs[0] policy
     /* 1781594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781604 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1781607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781628 */     // GIR_Coverage, 11980,
     /* 1781628 */     GIR_EraseRootFromParent_Done,
     /* 1781629 */   // Label 24202: @1781629
     /* 1781629 */   GIM_Try, /*On fail goto*//*Label 24203*/ GIMT_Encode4(1781715), // Rule ID 11981 //
     /* 1781634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1781645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1781648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1781651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1781654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1781657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1781664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1781676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781680 */     // MIs[0] policy
     /* 1781680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781690 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M4_E64_MASK),
     /* 1781693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781714 */     // GIR_Coverage, 11981,
     /* 1781714 */     GIR_EraseRootFromParent_Done,
     /* 1781715 */   // Label 24203: @1781715
     /* 1781715 */   GIM_Try, /*On fail goto*//*Label 24204*/ GIMT_Encode4(1781801), // Rule ID 11984 //
     /* 1781720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1781723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781766 */     // MIs[0] policy
     /* 1781766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781776 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1781779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781800 */     // GIR_Coverage, 11984,
     /* 1781800 */     GIR_EraseRootFromParent_Done,
     /* 1781801 */   // Label 24204: @1781801
     /* 1781801 */   GIM_Try, /*On fail goto*//*Label 24205*/ GIMT_Encode4(1781887), // Rule ID 11985 //
     /* 1781806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1781809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1781817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1781820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1781823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1781826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1781829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1781832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1781836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1781848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781852 */     // MIs[0] policy
     /* 1781852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781862 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1781862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VV_M8_E64_MASK),
     /* 1781865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1781883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781886 */     // GIR_Coverage, 11985,
     /* 1781886 */     GIR_EraseRootFromParent_Done,
     /* 1781887 */   // Label 24205: @1781887
     /* 1781887 */   GIM_Try, /*On fail goto*//*Label 24206*/ GIMT_Encode4(1781973), // Rule ID 11988 //
     /* 1781892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1781895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1781912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1781915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1781918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1781922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1781930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1781934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1781938 */     // MIs[0] policy
     /* 1781938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1781941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1781948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1781948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1781951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1781953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1781955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1781957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1781959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1781961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1781966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1781969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1781971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1781972 */     // GIR_Coverage, 11988,
     /* 1781972 */     GIR_EraseRootFromParent_Done,
     /* 1781973 */   // Label 24206: @1781973
     /* 1781973 */   GIM_Try, /*On fail goto*//*Label 24207*/ GIMT_Encode4(1782059), // Rule ID 11989 //
     /* 1781978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1781981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1781986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1781989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1781992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1781995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1781998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782024 */     // MIs[0] policy
     /* 1782024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782034 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF8_E8_MASK),
     /* 1782037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782058 */     // GIR_Coverage, 11989,
     /* 1782058 */     GIR_EraseRootFromParent_Done,
     /* 1782059 */   // Label 24207: @1782059
     /* 1782059 */   GIM_Try, /*On fail goto*//*Label 24208*/ GIMT_Encode4(1782145), // Rule ID 11992 //
     /* 1782064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782110 */     // MIs[0] policy
     /* 1782110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782120 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1782123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782144 */     // GIR_Coverage, 11992,
     /* 1782144 */     GIR_EraseRootFromParent_Done,
     /* 1782145 */   // Label 24208: @1782145
     /* 1782145 */   GIM_Try, /*On fail goto*//*Label 24209*/ GIMT_Encode4(1782231), // Rule ID 11993 //
     /* 1782150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1782161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1782164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1782167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782196 */     // MIs[0] policy
     /* 1782196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782206 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E8_MASK),
     /* 1782209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782230 */     // GIR_Coverage, 11993,
     /* 1782230 */     GIR_EraseRootFromParent_Done,
     /* 1782231 */   // Label 24209: @1782231
     /* 1782231 */   GIM_Try, /*On fail goto*//*Label 24210*/ GIMT_Encode4(1782317), // Rule ID 11996 //
     /* 1782236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1782247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1782250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1782253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782282 */     // MIs[0] policy
     /* 1782282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782292 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1782295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782316 */     // GIR_Coverage, 11996,
     /* 1782316 */     GIR_EraseRootFromParent_Done,
     /* 1782317 */   // Label 24210: @1782317
     /* 1782317 */   GIM_Try, /*On fail goto*//*Label 24211*/ GIMT_Encode4(1782403), // Rule ID 11997 //
     /* 1782322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1782333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1782336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1782339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1782345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782368 */     // MIs[0] policy
     /* 1782368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782378 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E8_MASK),
     /* 1782381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1782399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782402 */     // GIR_Coverage, 11997,
     /* 1782402 */     GIR_EraseRootFromParent_Done,
     /* 1782403 */   // Label 24211: @1782403
     /* 1782403 */   GIM_Try, /*On fail goto*//*Label 24212*/ GIMT_Encode4(1782489), // Rule ID 12000 //
     /* 1782408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1782419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1782422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1782425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782454 */     // MIs[0] policy
     /* 1782454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782464 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1782467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782488 */     // GIR_Coverage, 12000,
     /* 1782488 */     GIR_EraseRootFromParent_Done,
     /* 1782489 */   // Label 24212: @1782489
     /* 1782489 */   GIM_Try, /*On fail goto*//*Label 24213*/ GIMT_Encode4(1782575), // Rule ID 12001 //
     /* 1782494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1782505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1782508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1782511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782540 */     // MIs[0] policy
     /* 1782540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782550 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF4_E16_MASK),
     /* 1782553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782574 */     // GIR_Coverage, 12001,
     /* 1782574 */     GIR_EraseRootFromParent_Done,
     /* 1782575 */   // Label 24213: @1782575
     /* 1782575 */   GIM_Try, /*On fail goto*//*Label 24214*/ GIMT_Encode4(1782661), // Rule ID 12004 //
     /* 1782580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782626 */     // MIs[0] policy
     /* 1782626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782636 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1782639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782660 */     // GIR_Coverage, 12004,
     /* 1782660 */     GIR_EraseRootFromParent_Done,
     /* 1782661 */   // Label 24214: @1782661
     /* 1782661 */   GIM_Try, /*On fail goto*//*Label 24215*/ GIMT_Encode4(1782747), // Rule ID 12005 //
     /* 1782666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1782677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1782680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1782683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1782689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782712 */     // MIs[0] policy
     /* 1782712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782722 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E16_MASK),
     /* 1782725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1782743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782746 */     // GIR_Coverage, 12005,
     /* 1782746 */     GIR_EraseRootFromParent_Done,
     /* 1782747 */   // Label 24215: @1782747
     /* 1782747 */   GIM_Try, /*On fail goto*//*Label 24216*/ GIMT_Encode4(1782833), // Rule ID 12008 //
     /* 1782752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782798 */     // MIs[0] policy
     /* 1782798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782808 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1782811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782832 */     // GIR_Coverage, 12008,
     /* 1782832 */     GIR_EraseRootFromParent_Done,
     /* 1782833 */   // Label 24216: @1782833
     /* 1782833 */   GIM_Try, /*On fail goto*//*Label 24217*/ GIMT_Encode4(1782919), // Rule ID 12009 //
     /* 1782838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1782841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1782849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1782852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1782855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1782858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1782861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1782864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782884 */     // MIs[0] policy
     /* 1782884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782894 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1782894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_MF2_E32_MASK),
     /* 1782897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1782915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1782917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1782918 */     // GIR_Coverage, 12009,
     /* 1782918 */     GIR_EraseRootFromParent_Done,
     /* 1782919 */   // Label 24217: @1782919
     /* 1782919 */   GIM_Try, /*On fail goto*//*Label 24218*/ GIMT_Encode4(1783005), // Rule ID 12012 //
     /* 1782924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1782927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1782932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1782935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1782938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1782941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1782944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1782947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1782950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1782954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1782962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1782966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1782970 */     // MIs[0] policy
     /* 1782970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1782973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1782980 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1782980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1782983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1782985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1782987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1782989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1782991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1782993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1782998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783004 */     // GIR_Coverage, 12012,
     /* 1783004 */     GIR_EraseRootFromParent_Done,
     /* 1783005 */   // Label 24218: @1783005
     /* 1783005 */   GIM_Try, /*On fail goto*//*Label 24219*/ GIMT_Encode4(1783091), // Rule ID 12013 //
     /* 1783010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1783021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1783024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1783027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1783033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783056 */     // MIs[0] policy
     /* 1783056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783066 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11447:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E8_MASK),
     /* 1783069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783090 */     // GIR_Coverage, 12013,
     /* 1783090 */     GIR_EraseRootFromParent_Done,
     /* 1783091 */   // Label 24219: @1783091
     /* 1783091 */   GIM_Try, /*On fail goto*//*Label 24220*/ GIMT_Encode4(1783177), // Rule ID 12016 //
     /* 1783096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783142 */     // MIs[0] policy
     /* 1783142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783152 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1783155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783176 */     // GIR_Coverage, 12016,
     /* 1783176 */     GIR_EraseRootFromParent_Done,
     /* 1783177 */   // Label 24220: @1783177
     /* 1783177 */   GIM_Try, /*On fail goto*//*Label 24221*/ GIMT_Encode4(1783263), // Rule ID 12017 //
     /* 1783182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1783193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1783196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1783199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1783205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783228 */     // MIs[0] policy
     /* 1783228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783238 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11447:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E16_MASK),
     /* 1783241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1783259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783262 */     // GIR_Coverage, 12017,
     /* 1783262 */     GIR_EraseRootFromParent_Done,
     /* 1783263 */   // Label 24221: @1783263
     /* 1783263 */   GIM_Try, /*On fail goto*//*Label 24222*/ GIMT_Encode4(1783349), // Rule ID 12020 //
     /* 1783268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1783279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1783282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1783285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783314 */     // MIs[0] policy
     /* 1783314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783324 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1783327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783348 */     // GIR_Coverage, 12020,
     /* 1783348 */     GIR_EraseRootFromParent_Done,
     /* 1783349 */   // Label 24222: @1783349
     /* 1783349 */   GIM_Try, /*On fail goto*//*Label 24223*/ GIMT_Encode4(1783435), // Rule ID 12021 //
     /* 1783354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1783365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1783368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1783371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1783377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783400 */     // MIs[0] policy
     /* 1783400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783410 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11447:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E32_MASK),
     /* 1783413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1783431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783434 */     // GIR_Coverage, 12021,
     /* 1783434 */     GIR_EraseRootFromParent_Done,
     /* 1783435 */   // Label 24223: @1783435
     /* 1783435 */   GIM_Try, /*On fail goto*//*Label 24224*/ GIMT_Encode4(1783521), // Rule ID 12024 //
     /* 1783440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1783443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1783451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1783454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1783457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783486 */     // MIs[0] policy
     /* 1783486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783496 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1783499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783520 */     // GIR_Coverage, 12024,
     /* 1783520 */     GIR_EraseRootFromParent_Done,
     /* 1783521 */   // Label 24224: @1783521
     /* 1783521 */   GIM_Try, /*On fail goto*//*Label 24225*/ GIMT_Encode4(1783607), // Rule ID 12025 //
     /* 1783526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1783529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1783537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1783540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1783543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1783549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1783556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1783564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783572 */     // MIs[0] policy
     /* 1783572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783582 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11447:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M1_E64_MASK),
     /* 1783585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1783603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783606 */     // GIR_Coverage, 12025,
     /* 1783606 */     GIR_EraseRootFromParent_Done,
     /* 1783607 */   // Label 24225: @1783607
     /* 1783607 */   GIM_Try, /*On fail goto*//*Label 24226*/ GIMT_Encode4(1783693), // Rule ID 12028 //
     /* 1783612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783658 */     // MIs[0] policy
     /* 1783658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1783671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783692 */     // GIR_Coverage, 12028,
     /* 1783692 */     GIR_EraseRootFromParent_Done,
     /* 1783693 */   // Label 24226: @1783693
     /* 1783693 */   GIM_Try, /*On fail goto*//*Label 24227*/ GIMT_Encode4(1783779), // Rule ID 12029 //
     /* 1783698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1783709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1783712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1783715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1783721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1783728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1783736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783744 */     // MIs[0] policy
     /* 1783744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783754 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E8_MASK),
     /* 1783757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783778 */     // GIR_Coverage, 12029,
     /* 1783778 */     GIR_EraseRootFromParent_Done,
     /* 1783779 */   // Label 24227: @1783779
     /* 1783779 */   GIM_Try, /*On fail goto*//*Label 24228*/ GIMT_Encode4(1783865), // Rule ID 12032 //
     /* 1783784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783830 */     // MIs[0] policy
     /* 1783830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1783840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1783843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783864 */     // GIR_Coverage, 12032,
     /* 1783864 */     GIR_EraseRootFromParent_Done,
     /* 1783865 */   // Label 24228: @1783865
     /* 1783865 */   GIM_Try, /*On fail goto*//*Label 24229*/ GIMT_Encode4(1783951), // Rule ID 12033 //
     /* 1783870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1783873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1783881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1783884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1783887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1783890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1783893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1783896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1783900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1783908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1783916 */     // MIs[0] policy
     /* 1783916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1783919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1783926 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1783926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E8_MASK),
     /* 1783929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1783931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1783933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1783935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1783937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1783939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1783944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1783947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1783949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1783950 */     // GIR_Coverage, 12033,
     /* 1783950 */     GIR_EraseRootFromParent_Done,
     /* 1783951 */   // Label 24229: @1783951
     /* 1783951 */   GIM_Try, /*On fail goto*//*Label 24230*/ GIMT_Encode4(1784037), // Rule ID 12036 //
     /* 1783956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1783959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1783964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1783967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1783970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1783973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1783976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1783979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1783982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1783986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1783994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1783998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784002 */     // MIs[0] policy
     /* 1784002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784012 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1784015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784036 */     // GIR_Coverage, 12036,
     /* 1784036 */     GIR_EraseRootFromParent_Done,
     /* 1784037 */   // Label 24230: @1784037
     /* 1784037 */   GIM_Try, /*On fail goto*//*Label 24231*/ GIMT_Encode4(1784123), // Rule ID 12037 //
     /* 1784042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1784053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1784056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1784059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1784065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784088 */     // MIs[0] policy
     /* 1784088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784098 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E8_MASK),
     /* 1784101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1784119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784122 */     // GIR_Coverage, 12037,
     /* 1784122 */     GIR_EraseRootFromParent_Done,
     /* 1784123 */   // Label 24231: @1784123
     /* 1784123 */   GIM_Try, /*On fail goto*//*Label 24232*/ GIMT_Encode4(1784209), // Rule ID 12040 //
     /* 1784128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784174 */     // MIs[0] policy
     /* 1784174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784184 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1784187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784208 */     // GIR_Coverage, 12040,
     /* 1784208 */     GIR_EraseRootFromParent_Done,
     /* 1784209 */   // Label 24232: @1784209
     /* 1784209 */   GIM_Try, /*On fail goto*//*Label 24233*/ GIMT_Encode4(1784295), // Rule ID 12041 //
     /* 1784214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1784225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1784228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1784231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784260 */     // MIs[0] policy
     /* 1784260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E16_MASK),
     /* 1784273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784294 */     // GIR_Coverage, 12041,
     /* 1784294 */     GIR_EraseRootFromParent_Done,
     /* 1784295 */   // Label 24233: @1784295
     /* 1784295 */   GIM_Try, /*On fail goto*//*Label 24234*/ GIMT_Encode4(1784381), // Rule ID 12044 //
     /* 1784300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1784311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1784314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1784317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784346 */     // MIs[0] policy
     /* 1784346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784356 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1784359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784380 */     // GIR_Coverage, 12044,
     /* 1784380 */     GIR_EraseRootFromParent_Done,
     /* 1784381 */   // Label 24234: @1784381
     /* 1784381 */   GIM_Try, /*On fail goto*//*Label 24235*/ GIMT_Encode4(1784467), // Rule ID 12045 //
     /* 1784386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1784397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1784400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1784403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1784409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784432 */     // MIs[0] policy
     /* 1784432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784442 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E16_MASK),
     /* 1784445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784466 */     // GIR_Coverage, 12045,
     /* 1784466 */     GIR_EraseRootFromParent_Done,
     /* 1784467 */   // Label 24235: @1784467
     /* 1784467 */   GIM_Try, /*On fail goto*//*Label 24236*/ GIMT_Encode4(1784553), // Rule ID 12048 //
     /* 1784472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1784483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1784486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1784489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784518 */     // MIs[0] policy
     /* 1784518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784528 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1784531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784552 */     // GIR_Coverage, 12048,
     /* 1784552 */     GIR_EraseRootFromParent_Done,
     /* 1784553 */   // Label 24236: @1784553
     /* 1784553 */   GIM_Try, /*On fail goto*//*Label 24237*/ GIMT_Encode4(1784639), // Rule ID 12049 //
     /* 1784558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1784569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1784572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1784575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1784581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1784588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1784596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784604 */     // MIs[0] policy
     /* 1784604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784614 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E16_MASK),
     /* 1784617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1784635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784638 */     // GIR_Coverage, 12049,
     /* 1784638 */     GIR_EraseRootFromParent_Done,
     /* 1784639 */   // Label 24237: @1784639
     /* 1784639 */   GIM_Try, /*On fail goto*//*Label 24238*/ GIMT_Encode4(1784725), // Rule ID 12052 //
     /* 1784644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784690 */     // MIs[0] policy
     /* 1784690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1784703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784724 */     // GIR_Coverage, 12052,
     /* 1784724 */     GIR_EraseRootFromParent_Done,
     /* 1784725 */   // Label 24238: @1784725
     /* 1784725 */   GIM_Try, /*On fail goto*//*Label 24239*/ GIMT_Encode4(1784811), // Rule ID 12053 //
     /* 1784730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1784741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1784744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1784747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1784753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1784760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1784768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784776 */     // MIs[0] policy
     /* 1784776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784786 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E32_MASK),
     /* 1784789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784810 */     // GIR_Coverage, 12053,
     /* 1784810 */     GIR_EraseRootFromParent_Done,
     /* 1784811 */   // Label 24239: @1784811
     /* 1784811 */   GIM_Try, /*On fail goto*//*Label 24240*/ GIMT_Encode4(1784897), // Rule ID 12056 //
     /* 1784816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1784836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1784842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784862 */     // MIs[0] policy
     /* 1784862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784872 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1784872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1784875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784896 */     // GIR_Coverage, 12056,
     /* 1784896 */     GIR_EraseRootFromParent_Done,
     /* 1784897 */   // Label 24240: @1784897
     /* 1784897 */   GIM_Try, /*On fail goto*//*Label 24241*/ GIMT_Encode4(1784983), // Rule ID 12057 //
     /* 1784902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1784905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1784913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1784916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1784919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1784922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1784925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1784928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1784932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1784940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1784944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1784948 */     // MIs[0] policy
     /* 1784948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1784951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1784958 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1784958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E32_MASK),
     /* 1784961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1784963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1784965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1784967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1784969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1784971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1784976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1784979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1784981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1784982 */     // GIR_Coverage, 12057,
     /* 1784982 */     GIR_EraseRootFromParent_Done,
     /* 1784983 */   // Label 24241: @1784983
     /* 1784983 */   GIM_Try, /*On fail goto*//*Label 24242*/ GIMT_Encode4(1785069), // Rule ID 12060 //
     /* 1784988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1784991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1784996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1784999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785034 */     // MIs[0] policy
     /* 1785034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785044 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1785047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785068 */     // GIR_Coverage, 12060,
     /* 1785068 */     GIR_EraseRootFromParent_Done,
     /* 1785069 */   // Label 24242: @1785069
     /* 1785069 */   GIM_Try, /*On fail goto*//*Label 24243*/ GIMT_Encode4(1785155), // Rule ID 12061 //
     /* 1785074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1785085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1785088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1785091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1785097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785120 */     // MIs[0] policy
     /* 1785120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785130 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E32_MASK),
     /* 1785133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1785151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785154 */     // GIR_Coverage, 12061,
     /* 1785154 */     GIR_EraseRootFromParent_Done,
     /* 1785155 */   // Label 24243: @1785155
     /* 1785155 */   GIM_Try, /*On fail goto*//*Label 24244*/ GIMT_Encode4(1785241), // Rule ID 12064 //
     /* 1785160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1785171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1785174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1785177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785206 */     // MIs[0] policy
     /* 1785206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785216 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1785219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785240 */     // GIR_Coverage, 12064,
     /* 1785240 */     GIR_EraseRootFromParent_Done,
     /* 1785241 */   // Label 24244: @1785241
     /* 1785241 */   GIM_Try, /*On fail goto*//*Label 24245*/ GIMT_Encode4(1785327), // Rule ID 12065 //
     /* 1785246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1785257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1785260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1785263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1785276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1785284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785292 */     // MIs[0] policy
     /* 1785292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785302 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11447:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M2_E64_MASK),
     /* 1785305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785326 */     // GIR_Coverage, 12065,
     /* 1785326 */     GIR_EraseRootFromParent_Done,
     /* 1785327 */   // Label 24245: @1785327
     /* 1785327 */   GIM_Try, /*On fail goto*//*Label 24246*/ GIMT_Encode4(1785413), // Rule ID 12068 //
     /* 1785332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1785343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1785346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1785349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785378 */     // MIs[0] policy
     /* 1785378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785388 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1785391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785412 */     // GIR_Coverage, 12068,
     /* 1785412 */     GIR_EraseRootFromParent_Done,
     /* 1785413 */   // Label 24246: @1785413
     /* 1785413 */   GIM_Try, /*On fail goto*//*Label 24247*/ GIMT_Encode4(1785499), // Rule ID 12069 //
     /* 1785418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1785429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1785432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1785435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1785441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1785448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1785456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785464 */     // MIs[0] policy
     /* 1785464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785474 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11447:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M4_E64_MASK),
     /* 1785477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785498 */     // GIR_Coverage, 12069,
     /* 1785498 */     GIR_EraseRootFromParent_Done,
     /* 1785499 */   // Label 24247: @1785499
     /* 1785499 */   GIM_Try, /*On fail goto*//*Label 24248*/ GIMT_Encode4(1785585), // Rule ID 12072 //
     /* 1785504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1785507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1785515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1785524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785550 */     // MIs[0] policy
     /* 1785550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785560 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1785563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785584 */     // GIR_Coverage, 12072,
     /* 1785584 */     GIR_EraseRootFromParent_Done,
     /* 1785585 */   // Label 24248: @1785585
     /* 1785585 */   GIM_Try, /*On fail goto*//*Label 24249*/ GIMT_Encode4(1785671), // Rule ID 12073 //
     /* 1785590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1785593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vremu_mask),
     /* 1785598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1785601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1785604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1785607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1785610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1785613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1785620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1785628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1785632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785636 */     // MIs[0] policy
     /* 1785636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785646 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11447:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREMU_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREMU_VX_M8_E64_MASK),
     /* 1785649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1785667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785670 */     // GIR_Coverage, 12073,
     /* 1785670 */     GIR_EraseRootFromParent_Done,
     /* 1785671 */   // Label 24249: @1785671
     /* 1785671 */   GIM_Try, /*On fail goto*//*Label 24250*/ GIMT_Encode4(1785757), // Rule ID 12076 //
     /* 1785676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1785684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785722 */     // MIs[0] policy
     /* 1785722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785732 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1785735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785756 */     // GIR_Coverage, 12076,
     /* 1785756 */     GIR_EraseRootFromParent_Done,
     /* 1785757 */   // Label 24250: @1785757
     /* 1785757 */   GIM_Try, /*On fail goto*//*Label 24251*/ GIMT_Encode4(1785843), // Rule ID 12077 //
     /* 1785762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1785770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1785773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1785776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1785779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1785782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1785785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785808 */     // MIs[0] policy
     /* 1785808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785818 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF8_E8_MASK),
     /* 1785821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785842 */     // GIR_Coverage, 12077,
     /* 1785842 */     GIR_EraseRootFromParent_Done,
     /* 1785843 */   // Label 24251: @1785843
     /* 1785843 */   GIM_Try, /*On fail goto*//*Label 24252*/ GIMT_Encode4(1785929), // Rule ID 12080 //
     /* 1785848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1785851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1785856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1785874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785894 */     // MIs[0] policy
     /* 1785894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785904 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1785904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1785907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1785915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1785917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1785922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1785925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1785927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1785928 */     // GIR_Coverage, 12080,
     /* 1785928 */     GIR_EraseRootFromParent_Done,
     /* 1785929 */   // Label 24252: @1785929
     /* 1785929 */   GIM_Try, /*On fail goto*//*Label 24253*/ GIMT_Encode4(1786015), // Rule ID 12081 //
     /* 1785934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1785937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1785942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1785945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1785948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1785951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1785954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1785957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1785960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1785964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1785976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1785980 */     // MIs[0] policy
     /* 1785980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1785983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1785990 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1785990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E8_MASK),
     /* 1785993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1785995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1785997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1785999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786014 */     // GIR_Coverage, 12081,
     /* 1786014 */     GIR_EraseRootFromParent_Done,
     /* 1786015 */   // Label 24253: @1786015
     /* 1786015 */   GIM_Try, /*On fail goto*//*Label 24254*/ GIMT_Encode4(1786101), // Rule ID 12084 //
     /* 1786020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1786040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786066 */     // MIs[0] policy
     /* 1786066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786076 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1786079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786100 */     // GIR_Coverage, 12084,
     /* 1786100 */     GIR_EraseRootFromParent_Done,
     /* 1786101 */   // Label 24254: @1786101
     /* 1786101 */   GIM_Try, /*On fail goto*//*Label 24255*/ GIMT_Encode4(1786187), // Rule ID 12085 //
     /* 1786106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1786117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1786120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1786123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1786126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786152 */     // MIs[0] policy
     /* 1786152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786162 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E8_MASK),
     /* 1786165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786186 */     // GIR_Coverage, 12085,
     /* 1786186 */     GIR_EraseRootFromParent_Done,
     /* 1786187 */   // Label 24255: @1786187
     /* 1786187 */   GIM_Try, /*On fail goto*//*Label 24256*/ GIMT_Encode4(1786273), // Rule ID 12088 //
     /* 1786192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1786203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1786206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1786209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1786212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786238 */     // MIs[0] policy
     /* 1786238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786248 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1786251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786272 */     // GIR_Coverage, 12088,
     /* 1786272 */     GIR_EraseRootFromParent_Done,
     /* 1786273 */   // Label 24256: @1786273
     /* 1786273 */   GIM_Try, /*On fail goto*//*Label 24257*/ GIMT_Encode4(1786359), // Rule ID 12089 //
     /* 1786278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1786289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1786292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1786295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1786298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786324 */     // MIs[0] policy
     /* 1786324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786334 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF4_E16_MASK),
     /* 1786337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786358 */     // GIR_Coverage, 12089,
     /* 1786358 */     GIR_EraseRootFromParent_Done,
     /* 1786359 */   // Label 24257: @1786359
     /* 1786359 */   GIM_Try, /*On fail goto*//*Label 24258*/ GIMT_Encode4(1786445), // Rule ID 12092 //
     /* 1786364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1786375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1786378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1786381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1786384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786410 */     // MIs[0] policy
     /* 1786410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786420 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1786423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786444 */     // GIR_Coverage, 12092,
     /* 1786444 */     GIR_EraseRootFromParent_Done,
     /* 1786445 */   // Label 24258: @1786445
     /* 1786445 */   GIM_Try, /*On fail goto*//*Label 24259*/ GIMT_Encode4(1786531), // Rule ID 12093 //
     /* 1786450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1786461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1786464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1786467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1786470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1786473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786496 */     // MIs[0] policy
     /* 1786496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786506 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E16_MASK),
     /* 1786509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786530 */     // GIR_Coverage, 12093,
     /* 1786530 */     GIR_EraseRootFromParent_Done,
     /* 1786531 */   // Label 24259: @1786531
     /* 1786531 */   GIM_Try, /*On fail goto*//*Label 24260*/ GIMT_Encode4(1786617), // Rule ID 12096 //
     /* 1786536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786582 */     // MIs[0] policy
     /* 1786582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786592 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1786595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786616 */     // GIR_Coverage, 12096,
     /* 1786616 */     GIR_EraseRootFromParent_Done,
     /* 1786617 */   // Label 24260: @1786617
     /* 1786617 */   GIM_Try, /*On fail goto*//*Label 24261*/ GIMT_Encode4(1786703), // Rule ID 12097 //
     /* 1786622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1786633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1786636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1786639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1786642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1786645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786668 */     // MIs[0] policy
     /* 1786668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786678 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_MF2_E32_MASK),
     /* 1786681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1786699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786702 */     // GIR_Coverage, 12097,
     /* 1786702 */     GIR_EraseRootFromParent_Done,
     /* 1786703 */   // Label 24261: @1786703
     /* 1786703 */   GIM_Try, /*On fail goto*//*Label 24262*/ GIMT_Encode4(1786789), // Rule ID 12100 //
     /* 1786708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786754 */     // MIs[0] policy
     /* 1786754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786764 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1786767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786788 */     // GIR_Coverage, 12100,
     /* 1786788 */     GIR_EraseRootFromParent_Done,
     /* 1786789 */   // Label 24262: @1786789
     /* 1786789 */   GIM_Try, /*On fail goto*//*Label 24263*/ GIMT_Encode4(1786875), // Rule ID 12101 //
     /* 1786794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1786805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1786808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1786811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1786814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1786817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786840 */     // MIs[0] policy
     /* 1786840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786850 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1786850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E8_MASK),
     /* 1786853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1786871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786874 */     // GIR_Coverage, 12101,
     /* 1786874 */     GIR_EraseRootFromParent_Done,
     /* 1786875 */   // Label 24263: @1786875
     /* 1786875 */   GIM_Try, /*On fail goto*//*Label 24264*/ GIMT_Encode4(1786961), // Rule ID 12104 //
     /* 1786880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1786883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1786906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1786922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1786926 */     // MIs[0] policy
     /* 1786926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1786929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1786936 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1786936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1786939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1786941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1786943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1786945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1786947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1786949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1786954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1786957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1786959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1786960 */     // GIR_Coverage, 12104,
     /* 1786960 */     GIR_EraseRootFromParent_Done,
     /* 1786961 */   // Label 24264: @1786961
     /* 1786961 */   GIM_Try, /*On fail goto*//*Label 24265*/ GIMT_Encode4(1787047), // Rule ID 12105 //
     /* 1786966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1786969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1786974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1786977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1786980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1786983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1786986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1786989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1786992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1786996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787012 */     // MIs[0] policy
     /* 1787012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787022 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E16_MASK),
     /* 1787025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787046 */     // GIR_Coverage, 12105,
     /* 1787046 */     GIR_EraseRootFromParent_Done,
     /* 1787047 */   // Label 24265: @1787047
     /* 1787047 */   GIM_Try, /*On fail goto*//*Label 24266*/ GIMT_Encode4(1787133), // Rule ID 12108 //
     /* 1787052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1787063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1787066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1787069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1787072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787098 */     // MIs[0] policy
     /* 1787098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787108 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1787111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787132 */     // GIR_Coverage, 12108,
     /* 1787132 */     GIR_EraseRootFromParent_Done,
     /* 1787133 */   // Label 24266: @1787133
     /* 1787133 */   GIM_Try, /*On fail goto*//*Label 24267*/ GIMT_Encode4(1787219), // Rule ID 12109 //
     /* 1787138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1787149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1787152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1787155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1787158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1787161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787184 */     // MIs[0] policy
     /* 1787184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787194 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E32_MASK),
     /* 1787197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1787215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787218 */     // GIR_Coverage, 12109,
     /* 1787218 */     GIR_EraseRootFromParent_Done,
     /* 1787219 */   // Label 24267: @1787219
     /* 1787219 */   GIM_Try, /*On fail goto*//*Label 24268*/ GIMT_Encode4(1787305), // Rule ID 12112 //
     /* 1787224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1787227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1787235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1787238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1787241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1787244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787270 */     // MIs[0] policy
     /* 1787270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787280 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1787283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1787301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787304 */     // GIR_Coverage, 12112,
     /* 1787304 */     GIR_EraseRootFromParent_Done,
     /* 1787305 */   // Label 24268: @1787305
     /* 1787305 */   GIM_Try, /*On fail goto*//*Label 24269*/ GIMT_Encode4(1787391), // Rule ID 12113 //
     /* 1787310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1787313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1787321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1787324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1787327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1787330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1787333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1787340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1787352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787356 */     // MIs[0] policy
     /* 1787356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787366 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M1_E64_MASK),
     /* 1787369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1787387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787390 */     // GIR_Coverage, 12113,
     /* 1787390 */     GIR_EraseRootFromParent_Done,
     /* 1787391 */   // Label 24269: @1787391
     /* 1787391 */   GIM_Try, /*On fail goto*//*Label 24270*/ GIMT_Encode4(1787477), // Rule ID 12116 //
     /* 1787396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1787407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1787410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1787413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1787416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787442 */     // MIs[0] policy
     /* 1787442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1787455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787476 */     // GIR_Coverage, 12116,
     /* 1787476 */     GIR_EraseRootFromParent_Done,
     /* 1787477 */   // Label 24270: @1787477
     /* 1787477 */   GIM_Try, /*On fail goto*//*Label 24271*/ GIMT_Encode4(1787563), // Rule ID 12117 //
     /* 1787482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1787493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1787496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1787499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1787502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1787505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787528 */     // MIs[0] policy
     /* 1787528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787538 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E8_MASK),
     /* 1787541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787562 */     // GIR_Coverage, 12117,
     /* 1787562 */     GIR_EraseRootFromParent_Done,
     /* 1787563 */   // Label 24271: @1787563
     /* 1787563 */   GIM_Try, /*On fail goto*//*Label 24272*/ GIMT_Encode4(1787649), // Rule ID 12120 //
     /* 1787568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787614 */     // MIs[0] policy
     /* 1787614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787624 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1787627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787648 */     // GIR_Coverage, 12120,
     /* 1787648 */     GIR_EraseRootFromParent_Done,
     /* 1787649 */   // Label 24272: @1787649
     /* 1787649 */   GIM_Try, /*On fail goto*//*Label 24273*/ GIMT_Encode4(1787735), // Rule ID 12121 //
     /* 1787654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1787665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1787668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1787671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1787674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1787677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1787684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1787696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787700 */     // MIs[0] policy
     /* 1787700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787710 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E8_MASK),
     /* 1787713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787734 */     // GIR_Coverage, 12121,
     /* 1787734 */     GIR_EraseRootFromParent_Done,
     /* 1787735 */   // Label 24273: @1787735
     /* 1787735 */   GIM_Try, /*On fail goto*//*Label 24274*/ GIMT_Encode4(1787821), // Rule ID 12124 //
     /* 1787740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787786 */     // MIs[0] policy
     /* 1787786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787796 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1787799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787820 */     // GIR_Coverage, 12124,
     /* 1787820 */     GIR_EraseRootFromParent_Done,
     /* 1787821 */   // Label 24274: @1787821
     /* 1787821 */   GIM_Try, /*On fail goto*//*Label 24275*/ GIMT_Encode4(1787907), // Rule ID 12125 //
     /* 1787826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1787829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1787837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1787840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1787843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1787846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1787849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1787852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1787856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1787868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787872 */     // MIs[0] policy
     /* 1787872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787882 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1787882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E8_MASK),
     /* 1787885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1787903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787906 */     // GIR_Coverage, 12125,
     /* 1787906 */     GIR_EraseRootFromParent_Done,
     /* 1787907 */   // Label 24275: @1787907
     /* 1787907 */   GIM_Try, /*On fail goto*//*Label 24276*/ GIMT_Encode4(1787993), // Rule ID 12128 //
     /* 1787912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1787915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1787920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1787923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1787926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1787929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1787932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1787935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1787938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1787942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1787954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1787958 */     // MIs[0] policy
     /* 1787958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1787961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1787968 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1787968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1787971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1787973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1787975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1787977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1787979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1787981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1787986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1787989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1787991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1787992 */     // GIR_Coverage, 12128,
     /* 1787992 */     GIR_EraseRootFromParent_Done,
     /* 1787993 */   // Label 24276: @1787993
     /* 1787993 */   GIM_Try, /*On fail goto*//*Label 24277*/ GIMT_Encode4(1788079), // Rule ID 12129 //
     /* 1787998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1788009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1788012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1788015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1788018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788044 */     // MIs[0] policy
     /* 1788044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788054 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E16_MASK),
     /* 1788057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788078 */     // GIR_Coverage, 12129,
     /* 1788078 */     GIR_EraseRootFromParent_Done,
     /* 1788079 */   // Label 24277: @1788079
     /* 1788079 */   GIM_Try, /*On fail goto*//*Label 24278*/ GIMT_Encode4(1788165), // Rule ID 12132 //
     /* 1788084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1788095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1788098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1788101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1788104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788130 */     // MIs[0] policy
     /* 1788130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1788143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788164 */     // GIR_Coverage, 12132,
     /* 1788164 */     GIR_EraseRootFromParent_Done,
     /* 1788165 */   // Label 24278: @1788165
     /* 1788165 */   GIM_Try, /*On fail goto*//*Label 24279*/ GIMT_Encode4(1788251), // Rule ID 12133 //
     /* 1788170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1788181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1788184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1788187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1788190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788216 */     // MIs[0] policy
     /* 1788216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788226 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E16_MASK),
     /* 1788229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788250 */     // GIR_Coverage, 12133,
     /* 1788250 */     GIR_EraseRootFromParent_Done,
     /* 1788251 */   // Label 24279: @1788251
     /* 1788251 */   GIM_Try, /*On fail goto*//*Label 24280*/ GIMT_Encode4(1788337), // Rule ID 12136 //
     /* 1788256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1788267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1788270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1788273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1788276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788302 */     // MIs[0] policy
     /* 1788302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788312 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1788315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788336 */     // GIR_Coverage, 12136,
     /* 1788336 */     GIR_EraseRootFromParent_Done,
     /* 1788337 */   // Label 24280: @1788337
     /* 1788337 */   GIM_Try, /*On fail goto*//*Label 24281*/ GIMT_Encode4(1788423), // Rule ID 12137 //
     /* 1788342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1788353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1788356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1788359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1788362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1788365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788388 */     // MIs[0] policy
     /* 1788388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788398 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E16_MASK),
     /* 1788401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1788419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788422 */     // GIR_Coverage, 12137,
     /* 1788422 */     GIR_EraseRootFromParent_Done,
     /* 1788423 */   // Label 24281: @1788423
     /* 1788423 */   GIM_Try, /*On fail goto*//*Label 24282*/ GIMT_Encode4(1788509), // Rule ID 12140 //
     /* 1788428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1788439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1788442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1788445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1788448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788474 */     // MIs[0] policy
     /* 1788474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788484 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1788487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788508 */     // GIR_Coverage, 12140,
     /* 1788508 */     GIR_EraseRootFromParent_Done,
     /* 1788509 */   // Label 24282: @1788509
     /* 1788509 */   GIM_Try, /*On fail goto*//*Label 24283*/ GIMT_Encode4(1788595), // Rule ID 12141 //
     /* 1788514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1788525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1788528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1788531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1788534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1788537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788560 */     // MIs[0] policy
     /* 1788560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788570 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E32_MASK),
     /* 1788573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788594 */     // GIR_Coverage, 12141,
     /* 1788594 */     GIR_EraseRootFromParent_Done,
     /* 1788595 */   // Label 24283: @1788595
     /* 1788595 */   GIM_Try, /*On fail goto*//*Label 24284*/ GIMT_Encode4(1788681), // Rule ID 12144 //
     /* 1788600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788646 */     // MIs[0] policy
     /* 1788646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788656 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1788659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788680 */     // GIR_Coverage, 12144,
     /* 1788680 */     GIR_EraseRootFromParent_Done,
     /* 1788681 */   // Label 24284: @1788681
     /* 1788681 */   GIM_Try, /*On fail goto*//*Label 24285*/ GIMT_Encode4(1788767), // Rule ID 12145 //
     /* 1788686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1788697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1788700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1788703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1788706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1788709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1788716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1788728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788732 */     // MIs[0] policy
     /* 1788732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788742 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E32_MASK),
     /* 1788745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788766 */     // GIR_Coverage, 12145,
     /* 1788766 */     GIR_EraseRootFromParent_Done,
     /* 1788767 */   // Label 24285: @1788767
     /* 1788767 */   GIM_Try, /*On fail goto*//*Label 24286*/ GIMT_Encode4(1788853), // Rule ID 12148 //
     /* 1788772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1788775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788818 */     // MIs[0] policy
     /* 1788818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788828 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1788828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1788831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788852 */     // GIR_Coverage, 12148,
     /* 1788852 */     GIR_EraseRootFromParent_Done,
     /* 1788853 */   // Label 24286: @1788853
     /* 1788853 */   GIM_Try, /*On fail goto*//*Label 24287*/ GIMT_Encode4(1788939), // Rule ID 12149 //
     /* 1788858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1788861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1788869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1788872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1788875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1788878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1788881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1788884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1788888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1788900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788904 */     // MIs[0] policy
     /* 1788904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1788914 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1788914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E32_MASK),
     /* 1788917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1788919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1788921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1788923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1788925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1788927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1788932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1788935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1788937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1788938 */     // GIR_Coverage, 12149,
     /* 1788938 */     GIR_EraseRootFromParent_Done,
     /* 1788939 */   // Label 24287: @1788939
     /* 1788939 */   GIM_Try, /*On fail goto*//*Label 24288*/ GIMT_Encode4(1789025), // Rule ID 12152 //
     /* 1788944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1788947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1788952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1788955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1788958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1788961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1788964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1788967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1788970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1788974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1788986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1788990 */     // MIs[0] policy
     /* 1788990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1788993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1789003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789024 */     // GIR_Coverage, 12152,
     /* 1789024 */     GIR_EraseRootFromParent_Done,
     /* 1789025 */   // Label 24288: @1789025
     /* 1789025 */   GIM_Try, /*On fail goto*//*Label 24289*/ GIMT_Encode4(1789111), // Rule ID 12153 //
     /* 1789030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1789041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1789044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1789047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1789050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1789060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1789072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789076 */     // MIs[0] policy
     /* 1789076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789086 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M2_E64_MASK),
     /* 1789089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789110 */     // GIR_Coverage, 12153,
     /* 1789110 */     GIR_EraseRootFromParent_Done,
     /* 1789111 */   // Label 24289: @1789111
     /* 1789111 */   GIM_Try, /*On fail goto*//*Label 24290*/ GIMT_Encode4(1789197), // Rule ID 12156 //
     /* 1789116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1789127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1789130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1789133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1789136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789162 */     // MIs[0] policy
     /* 1789162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789172 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1789175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789196 */     // GIR_Coverage, 12156,
     /* 1789196 */     GIR_EraseRootFromParent_Done,
     /* 1789197 */   // Label 24290: @1789197
     /* 1789197 */   GIM_Try, /*On fail goto*//*Label 24291*/ GIMT_Encode4(1789283), // Rule ID 12157 //
     /* 1789202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1789213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1789216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1789219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1789222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1789232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1789244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789248 */     // MIs[0] policy
     /* 1789248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789258 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M4_E64_MASK),
     /* 1789261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789282 */     // GIR_Coverage, 12157,
     /* 1789282 */     GIR_EraseRootFromParent_Done,
     /* 1789283 */   // Label 24291: @1789283
     /* 1789283 */   GIM_Try, /*On fail goto*//*Label 24292*/ GIMT_Encode4(1789369), // Rule ID 12160 //
     /* 1789288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1789291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1789299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1789302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1789305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1789308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789334 */     // MIs[0] policy
     /* 1789334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789344 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1789347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789368 */     // GIR_Coverage, 12160,
     /* 1789368 */     GIR_EraseRootFromParent_Done,
     /* 1789369 */   // Label 24292: @1789369
     /* 1789369 */   GIM_Try, /*On fail goto*//*Label 24293*/ GIMT_Encode4(1789455), // Rule ID 12161 //
     /* 1789374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1789377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1789385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1789388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1789391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1789394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1789397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1789404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1789416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789420 */     // MIs[0] policy
     /* 1789420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789430 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VV_M8_E64_MASK),
     /* 1789433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1789451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789454 */     // GIR_Coverage, 12161,
     /* 1789454 */     GIR_EraseRootFromParent_Done,
     /* 1789455 */   // Label 24293: @1789455
     /* 1789455 */   GIM_Try, /*On fail goto*//*Label 24294*/ GIMT_Encode4(1789541), // Rule ID 12164 //
     /* 1789460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1789471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1789474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1789477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789506 */     // MIs[0] policy
     /* 1789506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789516 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1789519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789540 */     // GIR_Coverage, 12164,
     /* 1789540 */     GIR_EraseRootFromParent_Done,
     /* 1789541 */   // Label 24294: @1789541
     /* 1789541 */   GIM_Try, /*On fail goto*//*Label 24295*/ GIMT_Encode4(1789627), // Rule ID 12165 //
     /* 1789546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1789557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1789560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1789563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789592 */     // MIs[0] policy
     /* 1789592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789602 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF8_E8_MASK),
     /* 1789605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789626 */     // GIR_Coverage, 12165,
     /* 1789626 */     GIR_EraseRootFromParent_Done,
     /* 1789627 */   // Label 24295: @1789627
     /* 1789627 */   GIM_Try, /*On fail goto*//*Label 24296*/ GIMT_Encode4(1789713), // Rule ID 12168 //
     /* 1789632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789678 */     // MIs[0] policy
     /* 1789678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789688 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1789691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789712 */     // GIR_Coverage, 12168,
     /* 1789712 */     GIR_EraseRootFromParent_Done,
     /* 1789713 */   // Label 24296: @1789713
     /* 1789713 */   GIM_Try, /*On fail goto*//*Label 24297*/ GIMT_Encode4(1789799), // Rule ID 12169 //
     /* 1789718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1789729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1789732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1789735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1789741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789764 */     // MIs[0] policy
     /* 1789764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789774 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E8_MASK),
     /* 1789777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789798 */     // GIR_Coverage, 12169,
     /* 1789798 */     GIR_EraseRootFromParent_Done,
     /* 1789799 */   // Label 24297: @1789799
     /* 1789799 */   GIM_Try, /*On fail goto*//*Label 24298*/ GIMT_Encode4(1789885), // Rule ID 12172 //
     /* 1789804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1789830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789850 */     // MIs[0] policy
     /* 1789850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789860 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1789860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1789863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789884 */     // GIR_Coverage, 12172,
     /* 1789884 */     GIR_EraseRootFromParent_Done,
     /* 1789885 */   // Label 24298: @1789885
     /* 1789885 */   GIM_Try, /*On fail goto*//*Label 24299*/ GIMT_Encode4(1789971), // Rule ID 12173 //
     /* 1789890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1789893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1789901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1789904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1789907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1789910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1789913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1789916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1789920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1789928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1789932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1789936 */     // MIs[0] policy
     /* 1789936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1789939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1789946 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1789946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E8_MASK),
     /* 1789949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1789951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1789953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1789955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1789957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1789959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1789964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1789967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1789969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1789970 */     // GIR_Coverage, 12173,
     /* 1789970 */     GIR_EraseRootFromParent_Done,
     /* 1789971 */   // Label 24299: @1789971
     /* 1789971 */   GIM_Try, /*On fail goto*//*Label 24300*/ GIMT_Encode4(1790057), // Rule ID 12176 //
     /* 1789976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1789979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1789984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1789987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1789990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1789993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1789996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1789999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790022 */     // MIs[0] policy
     /* 1790022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790032 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1790035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790056 */     // GIR_Coverage, 12176,
     /* 1790056 */     GIR_EraseRootFromParent_Done,
     /* 1790057 */   // Label 24300: @1790057
     /* 1790057 */   GIM_Try, /*On fail goto*//*Label 24301*/ GIMT_Encode4(1790143), // Rule ID 12177 //
     /* 1790062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1790073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1790076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1790079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790108 */     // MIs[0] policy
     /* 1790108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790118 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF4_E16_MASK),
     /* 1790121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790142 */     // GIR_Coverage, 12177,
     /* 1790142 */     GIR_EraseRootFromParent_Done,
     /* 1790143 */   // Label 24301: @1790143
     /* 1790143 */   GIM_Try, /*On fail goto*//*Label 24302*/ GIMT_Encode4(1790229), // Rule ID 12180 //
     /* 1790148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1790159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1790162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1790165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790194 */     // MIs[0] policy
     /* 1790194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790204 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1790207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790228 */     // GIR_Coverage, 12180,
     /* 1790228 */     GIR_EraseRootFromParent_Done,
     /* 1790229 */   // Label 24302: @1790229
     /* 1790229 */   GIM_Try, /*On fail goto*//*Label 24303*/ GIMT_Encode4(1790315), // Rule ID 12181 //
     /* 1790234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1790245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1790248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1790251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790280 */     // MIs[0] policy
     /* 1790280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790290 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E16_MASK),
     /* 1790293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790314 */     // GIR_Coverage, 12181,
     /* 1790314 */     GIR_EraseRootFromParent_Done,
     /* 1790315 */   // Label 24303: @1790315
     /* 1790315 */   GIM_Try, /*On fail goto*//*Label 24304*/ GIMT_Encode4(1790401), // Rule ID 12184 //
     /* 1790320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1790331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1790334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1790337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790366 */     // MIs[0] policy
     /* 1790366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790376 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1790379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790400 */     // GIR_Coverage, 12184,
     /* 1790400 */     GIR_EraseRootFromParent_Done,
     /* 1790401 */   // Label 24304: @1790401
     /* 1790401 */   GIM_Try, /*On fail goto*//*Label 24305*/ GIMT_Encode4(1790487), // Rule ID 12185 //
     /* 1790406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1790417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1790420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1790423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1790429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790452 */     // MIs[0] policy
     /* 1790452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790462 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_MF2_E32_MASK),
     /* 1790465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790486 */     // GIR_Coverage, 12185,
     /* 1790486 */     GIR_EraseRootFromParent_Done,
     /* 1790487 */   // Label 24305: @1790487
     /* 1790487 */   GIM_Try, /*On fail goto*//*Label 24306*/ GIMT_Encode4(1790573), // Rule ID 12188 //
     /* 1790492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1790503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1790506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1790509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790538 */     // MIs[0] policy
     /* 1790538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790548 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1790551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790572 */     // GIR_Coverage, 12188,
     /* 1790572 */     GIR_EraseRootFromParent_Done,
     /* 1790573 */   // Label 24306: @1790573
     /* 1790573 */   GIM_Try, /*On fail goto*//*Label 24307*/ GIMT_Encode4(1790659), // Rule ID 12189 //
     /* 1790578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1790589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1790592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1790595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1790601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790624 */     // MIs[0] policy
     /* 1790624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790634 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11445:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E8_MASK),
     /* 1790637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1790655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790658 */     // GIR_Coverage, 12189,
     /* 1790658 */     GIR_EraseRootFromParent_Done,
     /* 1790659 */   // Label 24307: @1790659
     /* 1790659 */   GIM_Try, /*On fail goto*//*Label 24308*/ GIMT_Encode4(1790745), // Rule ID 12192 //
     /* 1790664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790710 */     // MIs[0] policy
     /* 1790710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790720 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1790723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790744 */     // GIR_Coverage, 12192,
     /* 1790744 */     GIR_EraseRootFromParent_Done,
     /* 1790745 */   // Label 24308: @1790745
     /* 1790745 */   GIM_Try, /*On fail goto*//*Label 24309*/ GIMT_Encode4(1790831), // Rule ID 12193 //
     /* 1790750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1790761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1790764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1790767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1790773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790796 */     // MIs[0] policy
     /* 1790796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790806 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11445:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E16_MASK),
     /* 1790809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1790827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790830 */     // GIR_Coverage, 12193,
     /* 1790830 */     GIR_EraseRootFromParent_Done,
     /* 1790831 */   // Label 24309: @1790831
     /* 1790831 */   GIM_Try, /*On fail goto*//*Label 24310*/ GIMT_Encode4(1790917), // Rule ID 12196 //
     /* 1790836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1790839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1790856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1790862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790882 */     // MIs[0] policy
     /* 1790882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1790892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1790895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1790915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1790916 */     // GIR_Coverage, 12196,
     /* 1790916 */     GIR_EraseRootFromParent_Done,
     /* 1790917 */   // Label 24310: @1790917
     /* 1790917 */   GIM_Try, /*On fail goto*//*Label 24311*/ GIMT_Encode4(1791003), // Rule ID 12197 //
     /* 1790922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1790925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1790930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1790933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1790936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1790939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1790942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1790945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1790948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1790952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1790960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1790964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1790968 */     // MIs[0] policy
     /* 1790968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1790971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1790978 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11445:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1790978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E32_MASK),
     /* 1790981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1790983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1790985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1790987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1790989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1790991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1790996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1790999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791002 */     // GIR_Coverage, 12197,
     /* 1791002 */     GIR_EraseRootFromParent_Done,
     /* 1791003 */   // Label 24311: @1791003
     /* 1791003 */   GIM_Try, /*On fail goto*//*Label 24312*/ GIMT_Encode4(1791089), // Rule ID 12200 //
     /* 1791008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1791011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1791019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1791022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1791025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791054 */     // MIs[0] policy
     /* 1791054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791064 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1791067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791088 */     // GIR_Coverage, 12200,
     /* 1791088 */     GIR_EraseRootFromParent_Done,
     /* 1791089 */   // Label 24312: @1791089
     /* 1791089 */   GIM_Try, /*On fail goto*//*Label 24313*/ GIMT_Encode4(1791175), // Rule ID 12201 //
     /* 1791094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1791097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1791105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1791108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1791111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1791117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1791124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1791132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791140 */     // MIs[0] policy
     /* 1791140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791150 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11445:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M1_E64_MASK),
     /* 1791153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1791171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791174 */     // GIR_Coverage, 12201,
     /* 1791174 */     GIR_EraseRootFromParent_Done,
     /* 1791175 */   // Label 24313: @1791175
     /* 1791175 */   GIM_Try, /*On fail goto*//*Label 24314*/ GIMT_Encode4(1791261), // Rule ID 12204 //
     /* 1791180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1791191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1791194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1791197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791226 */     // MIs[0] policy
     /* 1791226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1791239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791260 */     // GIR_Coverage, 12204,
     /* 1791260 */     GIR_EraseRootFromParent_Done,
     /* 1791261 */   // Label 24314: @1791261
     /* 1791261 */   GIM_Try, /*On fail goto*//*Label 24315*/ GIMT_Encode4(1791347), // Rule ID 12205 //
     /* 1791266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1791277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1791280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1791283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791312 */     // MIs[0] policy
     /* 1791312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E8_MASK),
     /* 1791325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791346 */     // GIR_Coverage, 12205,
     /* 1791346 */     GIR_EraseRootFromParent_Done,
     /* 1791347 */   // Label 24315: @1791347
     /* 1791347 */   GIM_Try, /*On fail goto*//*Label 24316*/ GIMT_Encode4(1791433), // Rule ID 12208 //
     /* 1791352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1791363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1791366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1791369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791398 */     // MIs[0] policy
     /* 1791398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791408 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1791411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791432 */     // GIR_Coverage, 12208,
     /* 1791432 */     GIR_EraseRootFromParent_Done,
     /* 1791433 */   // Label 24316: @1791433
     /* 1791433 */   GIM_Try, /*On fail goto*//*Label 24317*/ GIMT_Encode4(1791519), // Rule ID 12209 //
     /* 1791438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1791449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1791452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1791455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1791461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791484 */     // MIs[0] policy
     /* 1791484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791494 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E8_MASK),
     /* 1791497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791518 */     // GIR_Coverage, 12209,
     /* 1791518 */     GIR_EraseRootFromParent_Done,
     /* 1791519 */   // Label 24317: @1791519
     /* 1791519 */   GIM_Try, /*On fail goto*//*Label 24318*/ GIMT_Encode4(1791605), // Rule ID 12212 //
     /* 1791524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791570 */     // MIs[0] policy
     /* 1791570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791580 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1791583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791604 */     // GIR_Coverage, 12212,
     /* 1791604 */     GIR_EraseRootFromParent_Done,
     /* 1791605 */   // Label 24318: @1791605
     /* 1791605 */   GIM_Try, /*On fail goto*//*Label 24319*/ GIMT_Encode4(1791691), // Rule ID 12213 //
     /* 1791610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1791621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1791624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1791627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1791633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1791640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1791648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791656 */     // MIs[0] policy
     /* 1791656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791666 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E8_MASK),
     /* 1791669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1791687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791690 */     // GIR_Coverage, 12213,
     /* 1791690 */     GIR_EraseRootFromParent_Done,
     /* 1791691 */   // Label 24319: @1791691
     /* 1791691 */   GIM_Try, /*On fail goto*//*Label 24320*/ GIMT_Encode4(1791777), // Rule ID 12216 //
     /* 1791696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791742 */     // MIs[0] policy
     /* 1791742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1791755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791776 */     // GIR_Coverage, 12216,
     /* 1791776 */     GIR_EraseRootFromParent_Done,
     /* 1791777 */   // Label 24320: @1791777
     /* 1791777 */   GIM_Try, /*On fail goto*//*Label 24321*/ GIMT_Encode4(1791863), // Rule ID 12217 //
     /* 1791782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1791793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1791796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1791799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1791805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1791812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1791820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791828 */     // MIs[0] policy
     /* 1791828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1791838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E16_MASK),
     /* 1791841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791862 */     // GIR_Coverage, 12217,
     /* 1791862 */     GIR_EraseRootFromParent_Done,
     /* 1791863 */   // Label 24321: @1791863
     /* 1791863 */   GIM_Try, /*On fail goto*//*Label 24322*/ GIMT_Encode4(1791949), // Rule ID 12220 //
     /* 1791868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1791871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1791888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1791894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1791914 */     // MIs[0] policy
     /* 1791914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1791917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1791924 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1791924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1791927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1791929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1791931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1791933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1791935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1791937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1791942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1791945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1791947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1791948 */     // GIR_Coverage, 12220,
     /* 1791948 */     GIR_EraseRootFromParent_Done,
     /* 1791949 */   // Label 24322: @1791949
     /* 1791949 */   GIM_Try, /*On fail goto*//*Label 24323*/ GIMT_Encode4(1792035), // Rule ID 12221 //
     /* 1791954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1791957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1791962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1791965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1791968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1791971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1791974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1791977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1791980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1791984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1791992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1791996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792000 */     // MIs[0] policy
     /* 1792000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792010 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E16_MASK),
     /* 1792013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792034 */     // GIR_Coverage, 12221,
     /* 1792034 */     GIR_EraseRootFromParent_Done,
     /* 1792035 */   // Label 24323: @1792035
     /* 1792035 */   GIM_Try, /*On fail goto*//*Label 24324*/ GIMT_Encode4(1792121), // Rule ID 12224 //
     /* 1792040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1792051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1792054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1792057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792086 */     // MIs[0] policy
     /* 1792086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792096 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1792099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792120 */     // GIR_Coverage, 12224,
     /* 1792120 */     GIR_EraseRootFromParent_Done,
     /* 1792121 */   // Label 24324: @1792121
     /* 1792121 */   GIM_Try, /*On fail goto*//*Label 24325*/ GIMT_Encode4(1792207), // Rule ID 12225 //
     /* 1792126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1792137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1792140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1792143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1792149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792172 */     // MIs[0] policy
     /* 1792172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792182 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E16_MASK),
     /* 1792185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1792203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792206 */     // GIR_Coverage, 12225,
     /* 1792206 */     GIR_EraseRootFromParent_Done,
     /* 1792207 */   // Label 24325: @1792207
     /* 1792207 */   GIM_Try, /*On fail goto*//*Label 24326*/ GIMT_Encode4(1792293), // Rule ID 12228 //
     /* 1792212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1792223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1792226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1792229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792258 */     // MIs[0] policy
     /* 1792258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792268 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1792271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792292 */     // GIR_Coverage, 12228,
     /* 1792292 */     GIR_EraseRootFromParent_Done,
     /* 1792293 */   // Label 24326: @1792293
     /* 1792293 */   GIM_Try, /*On fail goto*//*Label 24327*/ GIMT_Encode4(1792379), // Rule ID 12229 //
     /* 1792298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1792309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1792312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1792315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792344 */     // MIs[0] policy
     /* 1792344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E32_MASK),
     /* 1792357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792378 */     // GIR_Coverage, 12229,
     /* 1792378 */     GIR_EraseRootFromParent_Done,
     /* 1792379 */   // Label 24327: @1792379
     /* 1792379 */   GIM_Try, /*On fail goto*//*Label 24328*/ GIMT_Encode4(1792465), // Rule ID 12232 //
     /* 1792384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1792395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1792398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1792401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792430 */     // MIs[0] policy
     /* 1792430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792440 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1792443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792464 */     // GIR_Coverage, 12232,
     /* 1792464 */     GIR_EraseRootFromParent_Done,
     /* 1792465 */   // Label 24328: @1792465
     /* 1792465 */   GIM_Try, /*On fail goto*//*Label 24329*/ GIMT_Encode4(1792551), // Rule ID 12233 //
     /* 1792470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1792481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1792484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1792487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1792493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792516 */     // MIs[0] policy
     /* 1792516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E32_MASK),
     /* 1792529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792550 */     // GIR_Coverage, 12233,
     /* 1792550 */     GIR_EraseRootFromParent_Done,
     /* 1792551 */   // Label 24329: @1792551
     /* 1792551 */   GIM_Try, /*On fail goto*//*Label 24330*/ GIMT_Encode4(1792637), // Rule ID 12236 //
     /* 1792556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1792559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792602 */     // MIs[0] policy
     /* 1792602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792612 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1792615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792636 */     // GIR_Coverage, 12236,
     /* 1792636 */     GIR_EraseRootFromParent_Done,
     /* 1792637 */   // Label 24330: @1792637
     /* 1792637 */   GIM_Try, /*On fail goto*//*Label 24331*/ GIMT_Encode4(1792723), // Rule ID 12237 //
     /* 1792642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1792645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1792653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1792656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1792659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1792665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1792672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1792680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792688 */     // MIs[0] policy
     /* 1792688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792698 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E32_MASK),
     /* 1792701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1792719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792722 */     // GIR_Coverage, 12237,
     /* 1792722 */     GIR_EraseRootFromParent_Done,
     /* 1792723 */   // Label 24331: @1792723
     /* 1792723 */   GIM_Try, /*On fail goto*//*Label 24332*/ GIMT_Encode4(1792809), // Rule ID 12240 //
     /* 1792728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792774 */     // MIs[0] policy
     /* 1792774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1792787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792808 */     // GIR_Coverage, 12240,
     /* 1792808 */     GIR_EraseRootFromParent_Done,
     /* 1792809 */   // Label 24332: @1792809
     /* 1792809 */   GIM_Try, /*On fail goto*//*Label 24333*/ GIMT_Encode4(1792895), // Rule ID 12241 //
     /* 1792814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1792825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1792828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1792831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1792834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1792837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1792840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1792844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1792852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792860 */     // MIs[0] policy
     /* 1792860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11445:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1792870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M2_E64_MASK),
     /* 1792873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792894 */     // GIR_Coverage, 12241,
     /* 1792894 */     GIR_EraseRootFromParent_Done,
     /* 1792895 */   // Label 24333: @1792895
     /* 1792895 */   GIM_Try, /*On fail goto*//*Label 24334*/ GIMT_Encode4(1792981), // Rule ID 12244 //
     /* 1792900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1792903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1792914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1792917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1792920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1792923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1792926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1792930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1792938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1792942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1792946 */     // MIs[0] policy
     /* 1792946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1792949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1792956 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1792956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1792959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1792961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1792963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1792965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1792967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1792969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1792974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1792977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1792979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1792980 */     // GIR_Coverage, 12244,
     /* 1792980 */     GIR_EraseRootFromParent_Done,
     /* 1792981 */   // Label 24334: @1792981
     /* 1792981 */   GIM_Try, /*On fail goto*//*Label 24335*/ GIMT_Encode4(1793067), // Rule ID 12245 //
     /* 1792986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1792989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1792994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1792997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1793000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1793003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793032 */     // MIs[0] policy
     /* 1793032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793042 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11445:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M4_E64_MASK),
     /* 1793045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793066 */     // GIR_Coverage, 12245,
     /* 1793066 */     GIR_EraseRootFromParent_Done,
     /* 1793067 */   // Label 24335: @1793067
     /* 1793067 */   GIM_Try, /*On fail goto*//*Label 24336*/ GIMT_Encode4(1793153), // Rule ID 12248 //
     /* 1793072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1793075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1793083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1793086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1793089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1793092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793118 */     // MIs[0] policy
     /* 1793118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793128 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1793131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793152 */     // GIR_Coverage, 12248,
     /* 1793152 */     GIR_EraseRootFromParent_Done,
     /* 1793153 */   // Label 24336: @1793153
     /* 1793153 */   GIM_Try, /*On fail goto*//*Label 24337*/ GIMT_Encode4(1793239), // Rule ID 12249 //
     /* 1793158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1793161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrem_mask),
     /* 1793166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1793169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1793172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1793175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1793178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1793188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1793196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1793200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793204 */     // MIs[0] policy
     /* 1793204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793214 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11445:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVREM_VX_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREM_VX_M8_E64_MASK),
     /* 1793217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1793235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793238 */     // GIR_Coverage, 12249,
     /* 1793238 */     GIR_EraseRootFromParent_Done,
     /* 1793239 */   // Label 24337: @1793239
     /* 1793239 */   GIM_Try, /*On fail goto*//*Label 24338*/ GIMT_Encode4(1793325), // Rule ID 12252 //
     /* 1793244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1793261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1793264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793290 */     // MIs[0] policy
     /* 1793290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793300 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1793303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793324 */     // GIR_Coverage, 12252,
     /* 1793324 */     GIR_EraseRootFromParent_Done,
     /* 1793325 */   // Label 24338: @1793325
     /* 1793325 */   GIM_Try, /*On fail goto*//*Label 24339*/ GIMT_Encode4(1793411), // Rule ID 12253 //
     /* 1793330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1793341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1793344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1793347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1793350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1793353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793376 */     // MIs[0] policy
     /* 1793376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793386 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF8_MASK),
     /* 1793389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793410 */     // GIR_Coverage, 12253,
     /* 1793410 */     GIR_EraseRootFromParent_Done,
     /* 1793411 */   // Label 24339: @1793411
     /* 1793411 */   GIM_Try, /*On fail goto*//*Label 24340*/ GIMT_Encode4(1793497), // Rule ID 12256 //
     /* 1793416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1793433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1793436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793462 */     // MIs[0] policy
     /* 1793462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793472 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1793475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793496 */     // GIR_Coverage, 12256,
     /* 1793496 */     GIR_EraseRootFromParent_Done,
     /* 1793497 */   // Label 24340: @1793497
     /* 1793497 */   GIM_Try, /*On fail goto*//*Label 24341*/ GIMT_Encode4(1793583), // Rule ID 12257 //
     /* 1793502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1793513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1793516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1793519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1793522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1793525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793548 */     // MIs[0] policy
     /* 1793548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793558 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1793561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793582 */     // GIR_Coverage, 12257,
     /* 1793582 */     GIR_EraseRootFromParent_Done,
     /* 1793583 */   // Label 24341: @1793583
     /* 1793583 */   GIM_Try, /*On fail goto*//*Label 24342*/ GIMT_Encode4(1793669), // Rule ID 12260 //
     /* 1793588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793634 */     // MIs[0] policy
     /* 1793634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793644 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1793647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793668 */     // GIR_Coverage, 12260,
     /* 1793668 */     GIR_EraseRootFromParent_Done,
     /* 1793669 */   // Label 24342: @1793669
     /* 1793669 */   GIM_Try, /*On fail goto*//*Label 24343*/ GIMT_Encode4(1793755), // Rule ID 12261 //
     /* 1793674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1793685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1793688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1793691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1793694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1793697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1793704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793720 */     // MIs[0] policy
     /* 1793720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793730 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1793733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793754 */     // GIR_Coverage, 12261,
     /* 1793754 */     GIR_EraseRootFromParent_Done,
     /* 1793755 */   // Label 24343: @1793755
     /* 1793755 */   GIM_Try, /*On fail goto*//*Label 24344*/ GIMT_Encode4(1793841), // Rule ID 12264 //
     /* 1793760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1793771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1793774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793806 */     // MIs[0] policy
     /* 1793806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793816 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1793819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793840 */     // GIR_Coverage, 12264,
     /* 1793840 */     GIR_EraseRootFromParent_Done,
     /* 1793841 */   // Label 24344: @1793841
     /* 1793841 */   GIM_Try, /*On fail goto*//*Label 24345*/ GIMT_Encode4(1793927), // Rule ID 12265 //
     /* 1793846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1793849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1793857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1793860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1793863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1793866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1793869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1793872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1793876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1793888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793892 */     // MIs[0] policy
     /* 1793892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793902 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1793902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1793905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1793915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1793920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1793923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1793925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1793926 */     // GIR_Coverage, 12265,
     /* 1793926 */     GIR_EraseRootFromParent_Done,
     /* 1793927 */   // Label 24345: @1793927
     /* 1793927 */   GIM_Try, /*On fail goto*//*Label 24346*/ GIMT_Encode4(1794013), // Rule ID 12268 //
     /* 1793932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1793935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1793940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1793943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1793946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1793949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1793952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1793955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1793958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1793962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1793966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1793974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1793978 */     // MIs[0] policy
     /* 1793978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1793981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1793988 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1793988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1793991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1793993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1793995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1793997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1793999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794012 */     // GIR_Coverage, 12268,
     /* 1794012 */     GIR_EraseRootFromParent_Done,
     /* 1794013 */   // Label 24346: @1794013
     /* 1794013 */   GIM_Try, /*On fail goto*//*Label 24347*/ GIMT_Encode4(1794099), // Rule ID 12269 //
     /* 1794018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1794029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1794032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1794035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1794038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794064 */     // MIs[0] policy
     /* 1794064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1794077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794098 */     // GIR_Coverage, 12269,
     /* 1794098 */     GIR_EraseRootFromParent_Done,
     /* 1794099 */   // Label 24347: @1794099
     /* 1794099 */   GIM_Try, /*On fail goto*//*Label 24348*/ GIMT_Encode4(1794185), // Rule ID 12272 //
     /* 1794104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794150 */     // MIs[0] policy
     /* 1794150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794160 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1794163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794184 */     // GIR_Coverage, 12272,
     /* 1794184 */     GIR_EraseRootFromParent_Done,
     /* 1794185 */   // Label 24348: @1794185
     /* 1794185 */   GIM_Try, /*On fail goto*//*Label 24349*/ GIMT_Encode4(1794271), // Rule ID 12273 //
     /* 1794190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1794201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1794204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1794207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1794210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1794213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794236 */     // MIs[0] policy
     /* 1794236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794246 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1794249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1794267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794270 */     // GIR_Coverage, 12273,
     /* 1794270 */     GIR_EraseRootFromParent_Done,
     /* 1794271 */   // Label 24349: @1794271
     /* 1794271 */   GIM_Try, /*On fail goto*//*Label 24350*/ GIMT_Encode4(1794357), // Rule ID 12276 //
     /* 1794276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1794296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794322 */     // MIs[0] policy
     /* 1794322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794332 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1794335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794356 */     // GIR_Coverage, 12276,
     /* 1794356 */     GIR_EraseRootFromParent_Done,
     /* 1794357 */   // Label 24350: @1794357
     /* 1794357 */   GIM_Try, /*On fail goto*//*Label 24351*/ GIMT_Encode4(1794443), // Rule ID 12277 //
     /* 1794362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1794373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1794376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1794379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1794382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1794385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794408 */     // MIs[0] policy
     /* 1794408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794418 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF4_MASK),
     /* 1794421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794442 */     // GIR_Coverage, 12277,
     /* 1794442 */     GIR_EraseRootFromParent_Done,
     /* 1794443 */   // Label 24351: @1794443
     /* 1794443 */   GIM_Try, /*On fail goto*//*Label 24352*/ GIMT_Encode4(1794529), // Rule ID 12280 //
     /* 1794448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1794468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794494 */     // MIs[0] policy
     /* 1794494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794504 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1794507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794528 */     // GIR_Coverage, 12280,
     /* 1794528 */     GIR_EraseRootFromParent_Done,
     /* 1794529 */   // Label 24352: @1794529
     /* 1794529 */   GIM_Try, /*On fail goto*//*Label 24353*/ GIMT_Encode4(1794615), // Rule ID 12281 //
     /* 1794534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1794545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1794548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1794551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1794554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1794557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1794564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794580 */     // MIs[0] policy
     /* 1794580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794590 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1794593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794614 */     // GIR_Coverage, 12281,
     /* 1794614 */     GIR_EraseRootFromParent_Done,
     /* 1794615 */   // Label 24353: @1794615
     /* 1794615 */   GIM_Try, /*On fail goto*//*Label 24354*/ GIMT_Encode4(1794701), // Rule ID 12284 //
     /* 1794620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1794631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1794634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794666 */     // MIs[0] policy
     /* 1794666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1794679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794700 */     // GIR_Coverage, 12284,
     /* 1794700 */     GIR_EraseRootFromParent_Done,
     /* 1794701 */   // Label 24354: @1794701
     /* 1794701 */   GIM_Try, /*On fail goto*//*Label 24355*/ GIMT_Encode4(1794787), // Rule ID 12285 //
     /* 1794706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1794717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1794720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1794723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1794726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1794729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1794736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1794748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794752 */     // MIs[0] policy
     /* 1794752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1794765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794786 */     // GIR_Coverage, 12285,
     /* 1794786 */     GIR_EraseRootFromParent_Done,
     /* 1794787 */   // Label 24355: @1794787
     /* 1794787 */   GIM_Try, /*On fail goto*//*Label 24356*/ GIMT_Encode4(1794873), // Rule ID 12288 //
     /* 1794792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1794803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1794806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794838 */     // MIs[0] policy
     /* 1794838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1794848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1794851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794872 */     // GIR_Coverage, 12288,
     /* 1794872 */     GIR_EraseRootFromParent_Done,
     /* 1794873 */   // Label 24356: @1794873
     /* 1794873 */   GIM_Try, /*On fail goto*//*Label 24357*/ GIMT_Encode4(1794959), // Rule ID 12289 //
     /* 1794878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1794881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1794889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1794892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1794895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1794898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1794901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1794904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1794908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1794912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1794920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1794924 */     // MIs[0] policy
     /* 1794924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1794927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1794934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1794934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1794937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1794939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1794941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1794943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1794945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1794947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1794952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1794955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1794957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1794958 */     // GIR_Coverage, 12289,
     /* 1794958 */     GIR_EraseRootFromParent_Done,
     /* 1794959 */   // Label 24357: @1794959
     /* 1794959 */   GIM_Try, /*On fail goto*//*Label 24358*/ GIMT_Encode4(1795045), // Rule ID 12292 //
     /* 1794964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1794967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1794972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1794975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1794978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1794981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1794984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1794987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1794990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1794994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1794998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795010 */     // MIs[0] policy
     /* 1795010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1795023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795044 */     // GIR_Coverage, 12292,
     /* 1795044 */     GIR_EraseRootFromParent_Done,
     /* 1795045 */   // Label 24358: @1795045
     /* 1795045 */   GIM_Try, /*On fail goto*//*Label 24359*/ GIMT_Encode4(1795131), // Rule ID 12293 //
     /* 1795050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1795061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1795064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1795067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1795070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1795073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795096 */     // MIs[0] policy
     /* 1795096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1795109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1795127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795130 */     // GIR_Coverage, 12293,
     /* 1795130 */     GIR_EraseRootFromParent_Done,
     /* 1795131 */   // Label 24359: @1795131
     /* 1795131 */   GIM_Try, /*On fail goto*//*Label 24360*/ GIMT_Encode4(1795217), // Rule ID 12296 //
     /* 1795136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1795139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1795153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1795156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795182 */     // MIs[0] policy
     /* 1795182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795192 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1795195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795216 */     // GIR_Coverage, 12296,
     /* 1795216 */     GIR_EraseRootFromParent_Done,
     /* 1795217 */   // Label 24360: @1795217
     /* 1795217 */   GIM_Try, /*On fail goto*//*Label 24361*/ GIMT_Encode4(1795303), // Rule ID 12297 //
     /* 1795222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1795225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1795233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1795236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1795239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1795242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795268 */     // MIs[0] policy
     /* 1795268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795278 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_MF2_MASK),
     /* 1795281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795302 */     // GIR_Coverage, 12297,
     /* 1795302 */     GIR_EraseRootFromParent_Done,
     /* 1795303 */   // Label 24361: @1795303
     /* 1795303 */   GIM_Try, /*On fail goto*//*Label 24362*/ GIMT_Encode4(1795389), // Rule ID 12300 //
     /* 1795308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1795311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1795328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795354 */     // MIs[0] policy
     /* 1795354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1795367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795388 */     // GIR_Coverage, 12300,
     /* 1795388 */     GIR_EraseRootFromParent_Done,
     /* 1795389 */   // Label 24362: @1795389
     /* 1795389 */   GIM_Try, /*On fail goto*//*Label 24363*/ GIMT_Encode4(1795475), // Rule ID 12301 //
     /* 1795394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1795397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1795405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1795408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1795411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1795414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1795417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1795424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795440 */     // MIs[0] policy
     /* 1795440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M1_MASK),
     /* 1795453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795474 */     // GIR_Coverage, 12301,
     /* 1795474 */     GIR_EraseRootFromParent_Done,
     /* 1795475 */   // Label 24363: @1795475
     /* 1795475 */   GIM_Try, /*On fail goto*//*Label 24364*/ GIMT_Encode4(1795561), // Rule ID 12304 //
     /* 1795480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1795483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795526 */     // MIs[0] policy
     /* 1795526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1795539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795560 */     // GIR_Coverage, 12304,
     /* 1795560 */     GIR_EraseRootFromParent_Done,
     /* 1795561 */   // Label 24364: @1795561
     /* 1795561 */   GIM_Try, /*On fail goto*//*Label 24365*/ GIMT_Encode4(1795647), // Rule ID 12305 //
     /* 1795566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1795569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1795577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1795580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1795583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1795586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1795589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1795596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1795608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795612 */     // MIs[0] policy
     /* 1795612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M2_MASK),
     /* 1795625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795646 */     // GIR_Coverage, 12305,
     /* 1795646 */     GIR_EraseRootFromParent_Done,
     /* 1795647 */   // Label 24365: @1795647
     /* 1795647 */   GIM_Try, /*On fail goto*//*Label 24366*/ GIMT_Encode4(1795733), // Rule ID 12308 //
     /* 1795652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1795655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795698 */     // MIs[0] policy
     /* 1795698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1795711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795732 */     // GIR_Coverage, 12308,
     /* 1795732 */     GIR_EraseRootFromParent_Done,
     /* 1795733 */   // Label 24366: @1795733
     /* 1795733 */   GIM_Try, /*On fail goto*//*Label 24367*/ GIMT_Encode4(1795819), // Rule ID 12309 //
     /* 1795738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1795741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1795749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1795752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1795755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1795758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1795761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1795768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1795772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1795780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795784 */     // MIs[0] policy
     /* 1795784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VV_M4_MASK),
     /* 1795797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1795815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795818 */     // GIR_Coverage, 12309,
     /* 1795818 */     GIR_EraseRootFromParent_Done,
     /* 1795819 */   // Label 24367: @1795819
     /* 1795819 */   GIM_Try, /*On fail goto*//*Label 24368*/ GIMT_Encode4(1795905), // Rule ID 12312 //
     /* 1795824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1795835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1795838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1795841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1795844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1795850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795870 */     // MIs[0] policy
     /* 1795870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1795880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1795883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795904 */     // GIR_Coverage, 12312,
     /* 1795904 */     GIR_EraseRootFromParent_Done,
     /* 1795905 */   // Label 24368: @1795905
     /* 1795905 */   GIM_Try, /*On fail goto*//*Label 24369*/ GIMT_Encode4(1795991), // Rule ID 12313 //
     /* 1795910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1795913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1795918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1795921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1795924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1795927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1795930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1795933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1795936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1795940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1795948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1795952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1795956 */     // MIs[0] policy
     /* 1795956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1795959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1795966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1795966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF8_MASK),
     /* 1795969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1795971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1795973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1795975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1795977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1795979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1795984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1795987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1795989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1795990 */     // GIR_Coverage, 12313,
     /* 1795990 */     GIR_EraseRootFromParent_Done,
     /* 1795991 */   // Label 24369: @1795991
     /* 1795991 */   GIM_Try, /*On fail goto*//*Label 24370*/ GIMT_Encode4(1796077), // Rule ID 12316 //
     /* 1795996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1795999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796042 */     // MIs[0] policy
     /* 1796042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1796055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796076 */     // GIR_Coverage, 12316,
     /* 1796076 */     GIR_EraseRootFromParent_Done,
     /* 1796077 */   // Label 24370: @1796077
     /* 1796077 */   GIM_Try, /*On fail goto*//*Label 24371*/ GIMT_Encode4(1796163), // Rule ID 12317 //
     /* 1796082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1796093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1796096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1796099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1796105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796128 */     // MIs[0] policy
     /* 1796128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1796141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796162 */     // GIR_Coverage, 12317,
     /* 1796162 */     GIR_EraseRootFromParent_Done,
     /* 1796163 */   // Label 24371: @1796163
     /* 1796163 */   GIM_Try, /*On fail goto*//*Label 24372*/ GIMT_Encode4(1796249), // Rule ID 12320 //
     /* 1796168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1796179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1796182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796214 */     // MIs[0] policy
     /* 1796214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1796227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796248 */     // GIR_Coverage, 12320,
     /* 1796248 */     GIR_EraseRootFromParent_Done,
     /* 1796249 */   // Label 24372: @1796249
     /* 1796249 */   GIM_Try, /*On fail goto*//*Label 24373*/ GIMT_Encode4(1796335), // Rule ID 12321 //
     /* 1796254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1796265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1796268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1796271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1796277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796300 */     // MIs[0] policy
     /* 1796300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11587:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1796313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796334 */     // GIR_Coverage, 12321,
     /* 1796334 */     GIR_EraseRootFromParent_Done,
     /* 1796335 */   // Label 24373: @1796335
     /* 1796335 */   GIM_Try, /*On fail goto*//*Label 24374*/ GIMT_Encode4(1796421), // Rule ID 12324 //
     /* 1796340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1796351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1796354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1796357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796386 */     // MIs[0] policy
     /* 1796386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1796399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796420 */     // GIR_Coverage, 12324,
     /* 1796420 */     GIR_EraseRootFromParent_Done,
     /* 1796421 */   // Label 24374: @1796421
     /* 1796421 */   GIM_Try, /*On fail goto*//*Label 24375*/ GIMT_Encode4(1796507), // Rule ID 12325 //
     /* 1796426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1796437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1796440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1796443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1796449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1796456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796472 */     // MIs[0] policy
     /* 1796472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1796485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796506 */     // GIR_Coverage, 12325,
     /* 1796506 */     GIR_EraseRootFromParent_Done,
     /* 1796507 */   // Label 24375: @1796507
     /* 1796507 */   GIM_Try, /*On fail goto*//*Label 24376*/ GIMT_Encode4(1796593), // Rule ID 12328 //
     /* 1796512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1796523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1796526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1796529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796558 */     // MIs[0] policy
     /* 1796558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1796571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796592 */     // GIR_Coverage, 12328,
     /* 1796592 */     GIR_EraseRootFromParent_Done,
     /* 1796593 */   // Label 24376: @1796593
     /* 1796593 */   GIM_Try, /*On fail goto*//*Label 24377*/ GIMT_Encode4(1796679), // Rule ID 12329 //
     /* 1796598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1796609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1796612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1796615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1796621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1796628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1796636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796644 */     // MIs[0] policy
     /* 1796644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1796657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796678 */     // GIR_Coverage, 12329,
     /* 1796678 */     GIR_EraseRootFromParent_Done,
     /* 1796679 */   // Label 24377: @1796679
     /* 1796679 */   GIM_Try, /*On fail goto*//*Label 24378*/ GIMT_Encode4(1796765), // Rule ID 12332 //
     /* 1796684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1796695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1796698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1796701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1796707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796730 */     // MIs[0] policy
     /* 1796730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1796743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796764 */     // GIR_Coverage, 12332,
     /* 1796764 */     GIR_EraseRootFromParent_Done,
     /* 1796765 */   // Label 24378: @1796765
     /* 1796765 */   GIM_Try, /*On fail goto*//*Label 24379*/ GIMT_Encode4(1796851), // Rule ID 12333 //
     /* 1796770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1796781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1796784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1796787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1796793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1796800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1796804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1796808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796816 */     // MIs[0] policy
     /* 1796816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796826 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1796829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1796847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796850 */     // GIR_Coverage, 12333,
     /* 1796850 */     GIR_EraseRootFromParent_Done,
     /* 1796851 */   // Label 24379: @1796851
     /* 1796851 */   GIM_Try, /*On fail goto*//*Label 24380*/ GIMT_Encode4(1796937), // Rule ID 12336 //
     /* 1796856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1796859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1796867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1796870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1796876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1796882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796902 */     // MIs[0] policy
     /* 1796902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1796912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1796915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1796917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1796919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1796921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1796923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1796925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1796930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1796933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1796935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1796936 */     // GIR_Coverage, 12336,
     /* 1796936 */     GIR_EraseRootFromParent_Done,
     /* 1796937 */   // Label 24380: @1796937
     /* 1796937 */   GIM_Try, /*On fail goto*//*Label 24381*/ GIMT_Encode4(1797023), // Rule ID 12337 //
     /* 1796942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1796945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1796950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1796953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1796956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1796959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1796962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1796965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1796968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1796972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1796980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1796984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1796988 */     // MIs[0] policy
     /* 1796988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1796991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1796998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1796998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF4_MASK),
     /* 1797001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797022 */     // GIR_Coverage, 12337,
     /* 1797022 */     GIR_EraseRootFromParent_Done,
     /* 1797023 */   // Label 24381: @1797023
     /* 1797023 */   GIM_Try, /*On fail goto*//*Label 24382*/ GIMT_Encode4(1797109), // Rule ID 12340 //
     /* 1797028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797074 */     // MIs[0] policy
     /* 1797074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1797087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797108 */     // GIR_Coverage, 12340,
     /* 1797108 */     GIR_EraseRootFromParent_Done,
     /* 1797109 */   // Label 24382: @1797109
     /* 1797109 */   GIM_Try, /*On fail goto*//*Label 24383*/ GIMT_Encode4(1797195), // Rule ID 12341 //
     /* 1797114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1797125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1797128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1797131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797160 */     // MIs[0] policy
     /* 1797160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11587:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1797173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797194 */     // GIR_Coverage, 12341,
     /* 1797194 */     GIR_EraseRootFromParent_Done,
     /* 1797195 */   // Label 24383: @1797195
     /* 1797195 */   GIM_Try, /*On fail goto*//*Label 24384*/ GIMT_Encode4(1797281), // Rule ID 12344 //
     /* 1797200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1797211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1797214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797246 */     // MIs[0] policy
     /* 1797246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1797259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797280 */     // GIR_Coverage, 12344,
     /* 1797280 */     GIR_EraseRootFromParent_Done,
     /* 1797281 */   // Label 24384: @1797281
     /* 1797281 */   GIM_Try, /*On fail goto*//*Label 24385*/ GIMT_Encode4(1797367), // Rule ID 12345 //
     /* 1797286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1797297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1797300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1797303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1797309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797332 */     // MIs[0] policy
     /* 1797332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1797345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797366 */     // GIR_Coverage, 12345,
     /* 1797366 */     GIR_EraseRootFromParent_Done,
     /* 1797367 */   // Label 24385: @1797367
     /* 1797367 */   GIM_Try, /*On fail goto*//*Label 24386*/ GIMT_Encode4(1797453), // Rule ID 12348 //
     /* 1797372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1797383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1797386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1797389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797418 */     // MIs[0] policy
     /* 1797418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1797431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797452 */     // GIR_Coverage, 12348,
     /* 1797452 */     GIR_EraseRootFromParent_Done,
     /* 1797453 */   // Label 24386: @1797453
     /* 1797453 */   GIM_Try, /*On fail goto*//*Label 24387*/ GIMT_Encode4(1797539), // Rule ID 12349 //
     /* 1797458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1797469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1797472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1797475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1797481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1797488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797504 */     // MIs[0] policy
     /* 1797504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1797517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797538 */     // GIR_Coverage, 12349,
     /* 1797538 */     GIR_EraseRootFromParent_Done,
     /* 1797539 */   // Label 24387: @1797539
     /* 1797539 */   GIM_Try, /*On fail goto*//*Label 24388*/ GIMT_Encode4(1797625), // Rule ID 12352 //
     /* 1797544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1797547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1797555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1797558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1797561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1797574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797590 */     // MIs[0] policy
     /* 1797590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1797603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797624 */     // GIR_Coverage, 12352,
     /* 1797624 */     GIR_EraseRootFromParent_Done,
     /* 1797625 */   // Label 24388: @1797625
     /* 1797625 */   GIM_Try, /*On fail goto*//*Label 24389*/ GIMT_Encode4(1797711), // Rule ID 12353 //
     /* 1797630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1797633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1797641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1797644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1797647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1797653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1797660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1797664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1797668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797676 */     // MIs[0] policy
     /* 1797676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1797689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1797707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797710 */     // GIR_Coverage, 12353,
     /* 1797710 */     GIR_EraseRootFromParent_Done,
     /* 1797711 */   // Label 24389: @1797711
     /* 1797711 */   GIM_Try, /*On fail goto*//*Label 24390*/ GIMT_Encode4(1797797), // Rule ID 12356 //
     /* 1797716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1797719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797762 */     // MIs[0] policy
     /* 1797762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1797775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797796 */     // GIR_Coverage, 12356,
     /* 1797796 */     GIR_EraseRootFromParent_Done,
     /* 1797797 */   // Label 24390: @1797797
     /* 1797797 */   GIM_Try, /*On fail goto*//*Label 24391*/ GIMT_Encode4(1797883), // Rule ID 12357 //
     /* 1797802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1797805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1797813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1797816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1797819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1797825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1797828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1797832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797848 */     // MIs[0] policy
     /* 1797848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11587:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1797858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_MF2_MASK),
     /* 1797861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797882 */     // GIR_Coverage, 12357,
     /* 1797882 */     GIR_EraseRootFromParent_Done,
     /* 1797883 */   // Label 24391: @1797883
     /* 1797883 */   GIM_Try, /*On fail goto*//*Label 24392*/ GIMT_Encode4(1797969), // Rule ID 12360 //
     /* 1797888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1797891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1797899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1797902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1797908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1797914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1797918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1797922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1797926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1797930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1797934 */     // MIs[0] policy
     /* 1797934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1797937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1797944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1797944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1797947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1797949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1797951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1797953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1797955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1797957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1797962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1797965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1797967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1797968 */     // GIR_Coverage, 12360,
     /* 1797968 */     GIR_EraseRootFromParent_Done,
     /* 1797969 */   // Label 24392: @1797969
     /* 1797969 */   GIM_Try, /*On fail goto*//*Label 24393*/ GIMT_Encode4(1798055), // Rule ID 12361 //
     /* 1797974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1797977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1797982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1797985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1797988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1797991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1797994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1797997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798020 */     // MIs[0] policy
     /* 1798020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11587:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M1_MASK),
     /* 1798033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798054 */     // GIR_Coverage, 12361,
     /* 1798054 */     GIR_EraseRootFromParent_Done,
     /* 1798055 */   // Label 24393: @1798055
     /* 1798055 */   GIM_Try, /*On fail goto*//*Label 24394*/ GIMT_Encode4(1798141), // Rule ID 12364 //
     /* 1798060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1798063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1798071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1798074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798106 */     // MIs[0] policy
     /* 1798106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1798119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798140 */     // GIR_Coverage, 12364,
     /* 1798140 */     GIR_EraseRootFromParent_Done,
     /* 1798141 */   // Label 24394: @1798141
     /* 1798141 */   GIM_Try, /*On fail goto*//*Label 24395*/ GIMT_Encode4(1798227), // Rule ID 12365 //
     /* 1798146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1798149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1798157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1798160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1798163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1798176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798192 */     // MIs[0] policy
     /* 1798192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11587:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M2_MASK),
     /* 1798205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798226 */     // GIR_Coverage, 12365,
     /* 1798226 */     GIR_EraseRootFromParent_Done,
     /* 1798227 */   // Label 24395: @1798227
     /* 1798227 */   GIM_Try, /*On fail goto*//*Label 24396*/ GIMT_Encode4(1798313), // Rule ID 12368 //
     /* 1798232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1798235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1798243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1798246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1798252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798278 */     // MIs[0] policy
     /* 1798278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798288 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1798291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798312 */     // GIR_Coverage, 12368,
     /* 1798312 */     GIR_EraseRootFromParent_Done,
     /* 1798313 */   // Label 24396: @1798313
     /* 1798313 */   GIM_Try, /*On fail goto*//*Label 24397*/ GIMT_Encode4(1798399), // Rule ID 12369 //
     /* 1798318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1798321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmul_mask),
     /* 1798326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1798329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1798332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1798335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1798338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1798348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1798352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1798356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1798360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798364 */     // MIs[0] policy
     /* 1798364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11587:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMUL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMUL_VX_M4_MASK),
     /* 1798377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1798395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798398 */     // GIR_Coverage, 12369,
     /* 1798398 */     GIR_EraseRootFromParent_Done,
     /* 1798399 */   // Label 24397: @1798399
     /* 1798399 */   GIM_Try, /*On fail goto*//*Label 24398*/ GIMT_Encode4(1798485), // Rule ID 12372 //
     /* 1798404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1798415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1798418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1798421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1798424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798450 */     // MIs[0] policy
     /* 1798450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1798463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798484 */     // GIR_Coverage, 12372,
     /* 1798484 */     GIR_EraseRootFromParent_Done,
     /* 1798485 */   // Label 24398: @1798485
     /* 1798485 */   GIM_Try, /*On fail goto*//*Label 24399*/ GIMT_Encode4(1798571), // Rule ID 12373 //
     /* 1798490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1798501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1798504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1798507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1798510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1798513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798536 */     // MIs[0] policy
     /* 1798536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF8_MASK),
     /* 1798549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798570 */     // GIR_Coverage, 12373,
     /* 1798570 */     GIR_EraseRootFromParent_Done,
     /* 1798571 */   // Label 24399: @1798571
     /* 1798571 */   GIM_Try, /*On fail goto*//*Label 24400*/ GIMT_Encode4(1798657), // Rule ID 12376 //
     /* 1798576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1798587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1798590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1798593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1798596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798622 */     // MIs[0] policy
     /* 1798622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1798635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798656 */     // GIR_Coverage, 12376,
     /* 1798656 */     GIR_EraseRootFromParent_Done,
     /* 1798657 */   // Label 24400: @1798657
     /* 1798657 */   GIM_Try, /*On fail goto*//*Label 24401*/ GIMT_Encode4(1798743), // Rule ID 12377 //
     /* 1798662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1798673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1798676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1798679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1798682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1798685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798708 */     // MIs[0] policy
     /* 1798708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1798721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798742 */     // GIR_Coverage, 12377,
     /* 1798742 */     GIR_EraseRootFromParent_Done,
     /* 1798743 */   // Label 24401: @1798743
     /* 1798743 */   GIM_Try, /*On fail goto*//*Label 24402*/ GIMT_Encode4(1798829), // Rule ID 12380 //
     /* 1798748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1798759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1798762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1798765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1798768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798794 */     // MIs[0] policy
     /* 1798794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1798807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798828 */     // GIR_Coverage, 12380,
     /* 1798828 */     GIR_EraseRootFromParent_Done,
     /* 1798829 */   // Label 24402: @1798829
     /* 1798829 */   GIM_Try, /*On fail goto*//*Label 24403*/ GIMT_Encode4(1798915), // Rule ID 12381 //
     /* 1798834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1798837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1798845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1798848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1798851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1798854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1798857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1798860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1798864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798880 */     // MIs[0] policy
     /* 1798880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1798890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1798893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1798914 */     // GIR_Coverage, 12381,
     /* 1798914 */     GIR_EraseRootFromParent_Done,
     /* 1798915 */   // Label 24403: @1798915
     /* 1798915 */   GIM_Try, /*On fail goto*//*Label 24404*/ GIMT_Encode4(1799001), // Rule ID 12384 //
     /* 1798920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1798923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1798928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1798931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1798934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1798937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1798940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1798943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1798946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1798950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1798954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1798962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1798966 */     // MIs[0] policy
     /* 1798966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1798969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1798976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1798976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1798979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1798981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1798983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1798985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1798987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1798989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1798994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1798997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1798999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799000 */     // GIR_Coverage, 12384,
     /* 1799000 */     GIR_EraseRootFromParent_Done,
     /* 1799001 */   // Label 24404: @1799001
     /* 1799001 */   GIM_Try, /*On fail goto*//*Label 24405*/ GIMT_Encode4(1799087), // Rule ID 12385 //
     /* 1799006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1799017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1799020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1799023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1799026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799052 */     // MIs[0] policy
     /* 1799052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1799065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799086 */     // GIR_Coverage, 12385,
     /* 1799086 */     GIR_EraseRootFromParent_Done,
     /* 1799087 */   // Label 24405: @1799087
     /* 1799087 */   GIM_Try, /*On fail goto*//*Label 24406*/ GIMT_Encode4(1799173), // Rule ID 12388 //
     /* 1799092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1799103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1799106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1799109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1799112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799138 */     // MIs[0] policy
     /* 1799138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1799151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799172 */     // GIR_Coverage, 12388,
     /* 1799172 */     GIR_EraseRootFromParent_Done,
     /* 1799173 */   // Label 24406: @1799173
     /* 1799173 */   GIM_Try, /*On fail goto*//*Label 24407*/ GIMT_Encode4(1799259), // Rule ID 12389 //
     /* 1799178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1799189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1799192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1799195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1799198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1799201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799224 */     // MIs[0] policy
     /* 1799224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1799237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799258 */     // GIR_Coverage, 12389,
     /* 1799258 */     GIR_EraseRootFromParent_Done,
     /* 1799259 */   // Label 24407: @1799259
     /* 1799259 */   GIM_Try, /*On fail goto*//*Label 24408*/ GIMT_Encode4(1799345), // Rule ID 12392 //
     /* 1799264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1799281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1799284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799310 */     // MIs[0] policy
     /* 1799310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1799323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799344 */     // GIR_Coverage, 12392,
     /* 1799344 */     GIR_EraseRootFromParent_Done,
     /* 1799345 */   // Label 24408: @1799345
     /* 1799345 */   GIM_Try, /*On fail goto*//*Label 24409*/ GIMT_Encode4(1799431), // Rule ID 12393 //
     /* 1799350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1799361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1799364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1799367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1799370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1799373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1799380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1799384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799396 */     // MIs[0] policy
     /* 1799396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1799409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1799427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799430 */     // GIR_Coverage, 12393,
     /* 1799430 */     GIR_EraseRootFromParent_Done,
     /* 1799431 */   // Label 24409: @1799431
     /* 1799431 */   GIM_Try, /*On fail goto*//*Label 24410*/ GIMT_Encode4(1799517), // Rule ID 12396 //
     /* 1799436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1799447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1799450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1799453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1799456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799482 */     // MIs[0] policy
     /* 1799482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1799495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799516 */     // GIR_Coverage, 12396,
     /* 1799516 */     GIR_EraseRootFromParent_Done,
     /* 1799517 */   // Label 24410: @1799517
     /* 1799517 */   GIM_Try, /*On fail goto*//*Label 24411*/ GIMT_Encode4(1799603), // Rule ID 12397 //
     /* 1799522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1799533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1799536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1799539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1799542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1799545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799568 */     // MIs[0] policy
     /* 1799568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF4_MASK),
     /* 1799581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799602 */     // GIR_Coverage, 12397,
     /* 1799602 */     GIR_EraseRootFromParent_Done,
     /* 1799603 */   // Label 24411: @1799603
     /* 1799603 */   GIM_Try, /*On fail goto*//*Label 24412*/ GIMT_Encode4(1799689), // Rule ID 12400 //
     /* 1799608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1799619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1799622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1799625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1799628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799654 */     // MIs[0] policy
     /* 1799654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1799667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799688 */     // GIR_Coverage, 12400,
     /* 1799688 */     GIR_EraseRootFromParent_Done,
     /* 1799689 */   // Label 24412: @1799689
     /* 1799689 */   GIM_Try, /*On fail goto*//*Label 24413*/ GIMT_Encode4(1799775), // Rule ID 12401 //
     /* 1799694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1799705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1799708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1799711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1799714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1799717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1799724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799740 */     // MIs[0] policy
     /* 1799740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1799753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799774 */     // GIR_Coverage, 12401,
     /* 1799774 */     GIR_EraseRootFromParent_Done,
     /* 1799775 */   // Label 24413: @1799775
     /* 1799775 */   GIM_Try, /*On fail goto*//*Label 24414*/ GIMT_Encode4(1799861), // Rule ID 12404 //
     /* 1799780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1799797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1799800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799826 */     // MIs[0] policy
     /* 1799826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1799836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1799839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799860 */     // GIR_Coverage, 12404,
     /* 1799860 */     GIR_EraseRootFromParent_Done,
     /* 1799861 */   // Label 24414: @1799861
     /* 1799861 */   GIM_Try, /*On fail goto*//*Label 24415*/ GIMT_Encode4(1799947), // Rule ID 12405 //
     /* 1799866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1799869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1799877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1799880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1799883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1799886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1799889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1799892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1799896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1799908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799912 */     // MIs[0] policy
     /* 1799912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1799915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1799922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1799922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1799925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1799927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1799929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1799931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1799933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1799935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1799940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1799943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1799945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1799946 */     // GIR_Coverage, 12405,
     /* 1799946 */     GIR_EraseRootFromParent_Done,
     /* 1799947 */   // Label 24415: @1799947
     /* 1799947 */   GIM_Try, /*On fail goto*//*Label 24416*/ GIMT_Encode4(1800033), // Rule ID 12408 //
     /* 1799952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1799955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1799960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1799963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1799966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1799969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1799972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1799975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1799978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1799982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1799986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1799994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1799998 */     // MIs[0] policy
     /* 1799998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1800011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800032 */     // GIR_Coverage, 12408,
     /* 1800032 */     GIR_EraseRootFromParent_Done,
     /* 1800033 */   // Label 24416: @1800033
     /* 1800033 */   GIM_Try, /*On fail goto*//*Label 24417*/ GIMT_Encode4(1800119), // Rule ID 12409 //
     /* 1800038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1800049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1800052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1800055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1800058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800084 */     // MIs[0] policy
     /* 1800084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1800097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800118 */     // GIR_Coverage, 12409,
     /* 1800118 */     GIR_EraseRootFromParent_Done,
     /* 1800119 */   // Label 24417: @1800119
     /* 1800119 */   GIM_Try, /*On fail goto*//*Label 24418*/ GIMT_Encode4(1800205), // Rule ID 12412 //
     /* 1800124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1800135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1800138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1800141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1800144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800170 */     // MIs[0] policy
     /* 1800170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1800183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800204 */     // GIR_Coverage, 12412,
     /* 1800204 */     GIR_EraseRootFromParent_Done,
     /* 1800205 */   // Label 24418: @1800205
     /* 1800205 */   GIM_Try, /*On fail goto*//*Label 24419*/ GIMT_Encode4(1800291), // Rule ID 12413 //
     /* 1800210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1800213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1800221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1800224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1800227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1800230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1800233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800256 */     // MIs[0] policy
     /* 1800256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1800269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1800287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800290 */     // GIR_Coverage, 12413,
     /* 1800290 */     GIR_EraseRootFromParent_Done,
     /* 1800291 */   // Label 24419: @1800291
     /* 1800291 */   GIM_Try, /*On fail goto*//*Label 24420*/ GIMT_Encode4(1800377), // Rule ID 12416 //
     /* 1800296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1800299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1800307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1800310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1800313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1800316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800342 */     // MIs[0] policy
     /* 1800342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1800355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800376 */     // GIR_Coverage, 12416,
     /* 1800376 */     GIR_EraseRootFromParent_Done,
     /* 1800377 */   // Label 24420: @1800377
     /* 1800377 */   GIM_Try, /*On fail goto*//*Label 24421*/ GIMT_Encode4(1800463), // Rule ID 12417 //
     /* 1800382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1800385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1800393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1800396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1800399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1800402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1800405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1800412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800428 */     // MIs[0] policy
     /* 1800428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_MF2_MASK),
     /* 1800441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800462 */     // GIR_Coverage, 12417,
     /* 1800462 */     GIR_EraseRootFromParent_Done,
     /* 1800463 */   // Label 24421: @1800463
     /* 1800463 */   GIM_Try, /*On fail goto*//*Label 24422*/ GIMT_Encode4(1800549), // Rule ID 12420 //
     /* 1800468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1800471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1800479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1800482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1800485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1800488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800514 */     // MIs[0] policy
     /* 1800514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1800527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800548 */     // GIR_Coverage, 12420,
     /* 1800548 */     GIR_EraseRootFromParent_Done,
     /* 1800549 */   // Label 24422: @1800549
     /* 1800549 */   GIM_Try, /*On fail goto*//*Label 24423*/ GIMT_Encode4(1800635), // Rule ID 12421 //
     /* 1800554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1800557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1800565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1800568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1800571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1800574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1800577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1800584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1800596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800600 */     // MIs[0] policy
     /* 1800600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M1_MASK),
     /* 1800613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800634 */     // GIR_Coverage, 12421,
     /* 1800634 */     GIR_EraseRootFromParent_Done,
     /* 1800635 */   // Label 24423: @1800635
     /* 1800635 */   GIM_Try, /*On fail goto*//*Label 24424*/ GIMT_Encode4(1800721), // Rule ID 12424 //
     /* 1800640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1800643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1800651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1800654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1800657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1800660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800686 */     // MIs[0] policy
     /* 1800686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1800699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800720 */     // GIR_Coverage, 12424,
     /* 1800720 */     GIR_EraseRootFromParent_Done,
     /* 1800721 */   // Label 24424: @1800721
     /* 1800721 */   GIM_Try, /*On fail goto*//*Label 24425*/ GIMT_Encode4(1800807), // Rule ID 12425 //
     /* 1800726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1800729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1800737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1800740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1800743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1800746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1800749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1800756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1800768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800772 */     // MIs[0] policy
     /* 1800772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M2_MASK),
     /* 1800785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800806 */     // GIR_Coverage, 12425,
     /* 1800806 */     GIR_EraseRootFromParent_Done,
     /* 1800807 */   // Label 24425: @1800807
     /* 1800807 */   GIM_Try, /*On fail goto*//*Label 24426*/ GIMT_Encode4(1800893), // Rule ID 12428 //
     /* 1800812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1800815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1800829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1800832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1800838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800858 */     // MIs[0] policy
     /* 1800858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1800868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1800871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800892 */     // GIR_Coverage, 12428,
     /* 1800892 */     GIR_EraseRootFromParent_Done,
     /* 1800893 */   // Label 24426: @1800893
     /* 1800893 */   GIM_Try, /*On fail goto*//*Label 24427*/ GIMT_Encode4(1800979), // Rule ID 12429 //
     /* 1800898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1800901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1800909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1800912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1800915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1800918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1800921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1800924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1800928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1800932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1800940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1800944 */     // MIs[0] policy
     /* 1800944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1800947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1800954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1800954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VV_M4_MASK),
     /* 1800957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1800959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1800961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1800963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1800965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1800967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1800972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1800975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1800977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1800978 */     // GIR_Coverage, 12429,
     /* 1800978 */     GIR_EraseRootFromParent_Done,
     /* 1800979 */   // Label 24427: @1800979
     /* 1800979 */   GIM_Try, /*On fail goto*//*Label 24428*/ GIMT_Encode4(1801065), // Rule ID 12432 //
     /* 1800984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1800987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1800992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1800995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1800998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1801001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801030 */     // MIs[0] policy
     /* 1801030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1801043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801064 */     // GIR_Coverage, 12432,
     /* 1801064 */     GIR_EraseRootFromParent_Done,
     /* 1801065 */   // Label 24428: @1801065
     /* 1801065 */   GIM_Try, /*On fail goto*//*Label 24429*/ GIMT_Encode4(1801151), // Rule ID 12433 //
     /* 1801070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1801081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1801084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1801087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1801093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801116 */     // MIs[0] policy
     /* 1801116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801126 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF8_MASK),
     /* 1801129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801150 */     // GIR_Coverage, 12433,
     /* 1801150 */     GIR_EraseRootFromParent_Done,
     /* 1801151 */   // Label 24429: @1801151
     /* 1801151 */   GIM_Try, /*On fail goto*//*Label 24430*/ GIMT_Encode4(1801237), // Rule ID 12436 //
     /* 1801156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1801167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1801170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1801173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801202 */     // MIs[0] policy
     /* 1801202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1801215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801236 */     // GIR_Coverage, 12436,
     /* 1801236 */     GIR_EraseRootFromParent_Done,
     /* 1801237 */   // Label 24430: @1801237
     /* 1801237 */   GIM_Try, /*On fail goto*//*Label 24431*/ GIMT_Encode4(1801323), // Rule ID 12437 //
     /* 1801242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1801253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1801256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1801259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1801265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801288 */     // MIs[0] policy
     /* 1801288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1801301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801322 */     // GIR_Coverage, 12437,
     /* 1801322 */     GIR_EraseRootFromParent_Done,
     /* 1801323 */   // Label 24431: @1801323
     /* 1801323 */   GIM_Try, /*On fail goto*//*Label 24432*/ GIMT_Encode4(1801409), // Rule ID 12440 //
     /* 1801328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1801339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1801342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1801345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801374 */     // MIs[0] policy
     /* 1801374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1801387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801408 */     // GIR_Coverage, 12440,
     /* 1801408 */     GIR_EraseRootFromParent_Done,
     /* 1801409 */   // Label 24432: @1801409
     /* 1801409 */   GIM_Try, /*On fail goto*//*Label 24433*/ GIMT_Encode4(1801495), // Rule ID 12441 //
     /* 1801414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1801425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1801428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1801431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1801437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1801444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801460 */     // MIs[0] policy
     /* 1801460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11591:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1801473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801494 */     // GIR_Coverage, 12441,
     /* 1801494 */     GIR_EraseRootFromParent_Done,
     /* 1801495 */   // Label 24433: @1801495
     /* 1801495 */   GIM_Try, /*On fail goto*//*Label 24434*/ GIMT_Encode4(1801581), // Rule ID 12444 //
     /* 1801500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1801511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1801514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1801517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801546 */     // MIs[0] policy
     /* 1801546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1801559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801580 */     // GIR_Coverage, 12444,
     /* 1801580 */     GIR_EraseRootFromParent_Done,
     /* 1801581 */   // Label 24434: @1801581
     /* 1801581 */   GIM_Try, /*On fail goto*//*Label 24435*/ GIMT_Encode4(1801667), // Rule ID 12445 //
     /* 1801586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1801597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1801600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1801603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1801609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1801616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1801624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801632 */     // MIs[0] policy
     /* 1801632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1801645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801666 */     // GIR_Coverage, 12445,
     /* 1801666 */     GIR_EraseRootFromParent_Done,
     /* 1801667 */   // Label 24435: @1801667
     /* 1801667 */   GIM_Try, /*On fail goto*//*Label 24436*/ GIMT_Encode4(1801753), // Rule ID 12448 //
     /* 1801672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1801683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1801686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801718 */     // MIs[0] policy
     /* 1801718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1801731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801752 */     // GIR_Coverage, 12448,
     /* 1801752 */     GIR_EraseRootFromParent_Done,
     /* 1801753 */   // Label 24436: @1801753
     /* 1801753 */   GIM_Try, /*On fail goto*//*Label 24437*/ GIMT_Encode4(1801839), // Rule ID 12449 //
     /* 1801758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1801769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1801772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1801775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1801781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1801788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1801796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801804 */     // MIs[0] policy
     /* 1801804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1801817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801838 */     // GIR_Coverage, 12449,
     /* 1801838 */     GIR_EraseRootFromParent_Done,
     /* 1801839 */   // Label 24437: @1801839
     /* 1801839 */   GIM_Try, /*On fail goto*//*Label 24438*/ GIMT_Encode4(1801925), // Rule ID 12452 //
     /* 1801844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1801847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1801864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1801870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801890 */     // MIs[0] policy
     /* 1801890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801900 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1801900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1801903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1801918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1801921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1801923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1801924 */     // GIR_Coverage, 12452,
     /* 1801924 */     GIR_EraseRootFromParent_Done,
     /* 1801925 */   // Label 24438: @1801925
     /* 1801925 */   GIM_Try, /*On fail goto*//*Label 24439*/ GIMT_Encode4(1802011), // Rule ID 12453 //
     /* 1801930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1801933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1801938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1801941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1801944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1801947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1801950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1801953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1801956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1801960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1801964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1801968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1801972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1801976 */     // MIs[0] policy
     /* 1801976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1801979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1801986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1801986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1801989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1801991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1801993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1801995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1801997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1801999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1802007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802010 */     // GIR_Coverage, 12453,
     /* 1802010 */     GIR_EraseRootFromParent_Done,
     /* 1802011 */   // Label 24439: @1802011
     /* 1802011 */   GIM_Try, /*On fail goto*//*Label 24440*/ GIMT_Encode4(1802097), // Rule ID 12456 //
     /* 1802016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1802027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1802030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1802033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802062 */     // MIs[0] policy
     /* 1802062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1802075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802096 */     // GIR_Coverage, 12456,
     /* 1802096 */     GIR_EraseRootFromParent_Done,
     /* 1802097 */   // Label 24440: @1802097
     /* 1802097 */   GIM_Try, /*On fail goto*//*Label 24441*/ GIMT_Encode4(1802183), // Rule ID 12457 //
     /* 1802102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1802113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1802116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1802119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802148 */     // MIs[0] policy
     /* 1802148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF4_MASK),
     /* 1802161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802182 */     // GIR_Coverage, 12457,
     /* 1802182 */     GIR_EraseRootFromParent_Done,
     /* 1802183 */   // Label 24441: @1802183
     /* 1802183 */   GIM_Try, /*On fail goto*//*Label 24442*/ GIMT_Encode4(1802269), // Rule ID 12460 //
     /* 1802188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1802199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1802202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1802205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802234 */     // MIs[0] policy
     /* 1802234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1802247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802268 */     // GIR_Coverage, 12460,
     /* 1802268 */     GIR_EraseRootFromParent_Done,
     /* 1802269 */   // Label 24442: @1802269
     /* 1802269 */   GIM_Try, /*On fail goto*//*Label 24443*/ GIMT_Encode4(1802355), // Rule ID 12461 //
     /* 1802274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1802285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1802288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1802291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1802297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802320 */     // MIs[0] policy
     /* 1802320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11591:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1802333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802354 */     // GIR_Coverage, 12461,
     /* 1802354 */     GIR_EraseRootFromParent_Done,
     /* 1802355 */   // Label 24443: @1802355
     /* 1802355 */   GIM_Try, /*On fail goto*//*Label 24444*/ GIMT_Encode4(1802441), // Rule ID 12464 //
     /* 1802360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1802371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1802374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1802377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802406 */     // MIs[0] policy
     /* 1802406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1802419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802440 */     // GIR_Coverage, 12464,
     /* 1802440 */     GIR_EraseRootFromParent_Done,
     /* 1802441 */   // Label 24444: @1802441
     /* 1802441 */   GIM_Try, /*On fail goto*//*Label 24445*/ GIMT_Encode4(1802527), // Rule ID 12465 //
     /* 1802446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1802457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1802460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1802463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1802469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1802476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802492 */     // MIs[0] policy
     /* 1802492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1802505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802526 */     // GIR_Coverage, 12465,
     /* 1802526 */     GIR_EraseRootFromParent_Done,
     /* 1802527 */   // Label 24445: @1802527
     /* 1802527 */   GIM_Try, /*On fail goto*//*Label 24446*/ GIMT_Encode4(1802613), // Rule ID 12468 //
     /* 1802532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1802543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1802546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1802549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802578 */     // MIs[0] policy
     /* 1802578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1802591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802612 */     // GIR_Coverage, 12468,
     /* 1802612 */     GIR_EraseRootFromParent_Done,
     /* 1802613 */   // Label 24446: @1802613
     /* 1802613 */   GIM_Try, /*On fail goto*//*Label 24447*/ GIMT_Encode4(1802699), // Rule ID 12469 //
     /* 1802618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1802629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1802632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1802635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1802641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1802648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1802656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802664 */     // MIs[0] policy
     /* 1802664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1802677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802698 */     // GIR_Coverage, 12469,
     /* 1802698 */     GIR_EraseRootFromParent_Done,
     /* 1802699 */   // Label 24447: @1802699
     /* 1802699 */   GIM_Try, /*On fail goto*//*Label 24448*/ GIMT_Encode4(1802785), // Rule ID 12472 //
     /* 1802704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1802707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802750 */     // MIs[0] policy
     /* 1802750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1802763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802784 */     // GIR_Coverage, 12472,
     /* 1802784 */     GIR_EraseRootFromParent_Done,
     /* 1802785 */   // Label 24448: @1802785
     /* 1802785 */   GIM_Try, /*On fail goto*//*Label 24449*/ GIMT_Encode4(1802871), // Rule ID 12473 //
     /* 1802790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1802793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1802801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1802804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1802807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1802813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1802820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1802824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1802828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802836 */     // MIs[0] policy
     /* 1802836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1802846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1802849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1802867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802870 */     // GIR_Coverage, 12473,
     /* 1802870 */     GIR_EraseRootFromParent_Done,
     /* 1802871 */   // Label 24449: @1802871
     /* 1802871 */   GIM_Try, /*On fail goto*//*Label 24450*/ GIMT_Encode4(1802957), // Rule ID 12476 //
     /* 1802876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1802879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1802896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1802902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1802918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1802922 */     // MIs[0] policy
     /* 1802922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1802925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1802932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1802932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1802935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1802937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1802939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1802941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1802943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1802945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1802950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1802953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1802955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1802956 */     // GIR_Coverage, 12476,
     /* 1802956 */     GIR_EraseRootFromParent_Done,
     /* 1802957 */   // Label 24450: @1802957
     /* 1802957 */   GIM_Try, /*On fail goto*//*Label 24451*/ GIMT_Encode4(1803043), // Rule ID 12477 //
     /* 1802962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1802965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1802970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1802973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1802976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1802979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1802982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1802985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1802988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1802992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1802996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803008 */     // MIs[0] policy
     /* 1803008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11591:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_MF2_MASK),
     /* 1803021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803042 */     // GIR_Coverage, 12477,
     /* 1803042 */     GIR_EraseRootFromParent_Done,
     /* 1803043 */   // Label 24451: @1803043
     /* 1803043 */   GIM_Try, /*On fail goto*//*Label 24452*/ GIMT_Encode4(1803129), // Rule ID 12480 //
     /* 1803048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1803051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1803059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1803062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1803065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803094 */     // MIs[0] policy
     /* 1803094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1803107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803128 */     // GIR_Coverage, 12480,
     /* 1803128 */     GIR_EraseRootFromParent_Done,
     /* 1803129 */   // Label 24452: @1803129
     /* 1803129 */   GIM_Try, /*On fail goto*//*Label 24453*/ GIMT_Encode4(1803215), // Rule ID 12481 //
     /* 1803134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1803137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1803145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1803148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1803151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1803164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803180 */     // MIs[0] policy
     /* 1803180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11591:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M1_MASK),
     /* 1803193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803214 */     // GIR_Coverage, 12481,
     /* 1803214 */     GIR_EraseRootFromParent_Done,
     /* 1803215 */   // Label 24453: @1803215
     /* 1803215 */   GIM_Try, /*On fail goto*//*Label 24454*/ GIMT_Encode4(1803301), // Rule ID 12484 //
     /* 1803220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1803223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1803231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1803234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1803237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803266 */     // MIs[0] policy
     /* 1803266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1803279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803300 */     // GIR_Coverage, 12484,
     /* 1803300 */     GIR_EraseRootFromParent_Done,
     /* 1803301 */   // Label 24454: @1803301
     /* 1803301 */   GIM_Try, /*On fail goto*//*Label 24455*/ GIMT_Encode4(1803387), // Rule ID 12485 //
     /* 1803306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1803309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1803317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1803320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1803323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1803336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1803344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803352 */     // MIs[0] policy
     /* 1803352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11591:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M2_MASK),
     /* 1803365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803386 */     // GIR_Coverage, 12485,
     /* 1803386 */     GIR_EraseRootFromParent_Done,
     /* 1803387 */   // Label 24455: @1803387
     /* 1803387 */   GIM_Try, /*On fail goto*//*Label 24456*/ GIMT_Encode4(1803473), // Rule ID 12488 //
     /* 1803392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1803395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1803403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1803406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1803409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1803412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803438 */     // MIs[0] policy
     /* 1803438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1803451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803472 */     // GIR_Coverage, 12488,
     /* 1803472 */     GIR_EraseRootFromParent_Done,
     /* 1803473 */   // Label 24456: @1803473
     /* 1803473 */   GIM_Try, /*On fail goto*//*Label 24457*/ GIMT_Encode4(1803559), // Rule ID 12489 //
     /* 1803478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1803481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulu_mask),
     /* 1803486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1803489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1803492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1803495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1803498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1803501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1803508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1803512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1803516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1803520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803524 */     // MIs[0] policy
     /* 1803524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11591:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULU_VX_M4_MASK),
     /* 1803537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1803555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803558 */     // GIR_Coverage, 12489,
     /* 1803558 */     GIR_EraseRootFromParent_Done,
     /* 1803559 */   // Label 24457: @1803559
     /* 1803559 */   GIM_Try, /*On fail goto*//*Label 24458*/ GIMT_Encode4(1803645), // Rule ID 12492 //
     /* 1803564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1803572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1803575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1803578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1803581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1803584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803610 */     // MIs[0] policy
     /* 1803610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1803623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803644 */     // GIR_Coverage, 12492,
     /* 1803644 */     GIR_EraseRootFromParent_Done,
     /* 1803645 */   // Label 24458: @1803645
     /* 1803645 */   GIM_Try, /*On fail goto*//*Label 24459*/ GIMT_Encode4(1803731), // Rule ID 12493 //
     /* 1803650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1803658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1803661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1803664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1803667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1803670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1803673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803696 */     // MIs[0] policy
     /* 1803696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF8_MASK),
     /* 1803709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803730 */     // GIR_Coverage, 12493,
     /* 1803730 */     GIR_EraseRootFromParent_Done,
     /* 1803731 */   // Label 24459: @1803731
     /* 1803731 */   GIM_Try, /*On fail goto*//*Label 24460*/ GIMT_Encode4(1803817), // Rule ID 12496 //
     /* 1803736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1803744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1803756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803782 */     // MIs[0] policy
     /* 1803782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1803795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803816 */     // GIR_Coverage, 12496,
     /* 1803816 */     GIR_EraseRootFromParent_Done,
     /* 1803817 */   // Label 24460: @1803817
     /* 1803817 */   GIM_Try, /*On fail goto*//*Label 24461*/ GIMT_Encode4(1803903), // Rule ID 12497 //
     /* 1803822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1803830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1803833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1803836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1803839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1803842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1803845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1803848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803868 */     // MIs[0] policy
     /* 1803868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1803878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1803881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803902 */     // GIR_Coverage, 12497,
     /* 1803902 */     GIR_EraseRootFromParent_Done,
     /* 1803903 */   // Label 24461: @1803903
     /* 1803903 */   GIM_Try, /*On fail goto*//*Label 24462*/ GIMT_Encode4(1803989), // Rule ID 12500 //
     /* 1803908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1803911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1803916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1803919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1803922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1803925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1803928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1803931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1803934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1803938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1803950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1803954 */     // MIs[0] policy
     /* 1803954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1803957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1803964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1803964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1803967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1803969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1803971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1803973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1803975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1803977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1803982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1803985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1803987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1803988 */     // GIR_Coverage, 12500,
     /* 1803988 */     GIR_EraseRootFromParent_Done,
     /* 1803989 */   // Label 24462: @1803989
     /* 1803989 */   GIM_Try, /*On fail goto*//*Label 24463*/ GIMT_Encode4(1804075), // Rule ID 12501 //
     /* 1803994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1803997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1804005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1804008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1804011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1804014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804040 */     // MIs[0] policy
     /* 1804040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1804053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804074 */     // GIR_Coverage, 12501,
     /* 1804074 */     GIR_EraseRootFromParent_Done,
     /* 1804075 */   // Label 24463: @1804075
     /* 1804075 */   GIM_Try, /*On fail goto*//*Label 24464*/ GIMT_Encode4(1804161), // Rule ID 12504 //
     /* 1804080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1804091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1804094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1804097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1804100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804126 */     // MIs[0] policy
     /* 1804126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1804139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804160 */     // GIR_Coverage, 12504,
     /* 1804160 */     GIR_EraseRootFromParent_Done,
     /* 1804161 */   // Label 24464: @1804161
     /* 1804161 */   GIM_Try, /*On fail goto*//*Label 24465*/ GIMT_Encode4(1804247), // Rule ID 12505 //
     /* 1804166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1804177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1804180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1804183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1804186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1804189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804212 */     // MIs[0] policy
     /* 1804212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1804225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804246 */     // GIR_Coverage, 12505,
     /* 1804246 */     GIR_EraseRootFromParent_Done,
     /* 1804247 */   // Label 24465: @1804247
     /* 1804247 */   GIM_Try, /*On fail goto*//*Label 24466*/ GIMT_Encode4(1804333), // Rule ID 12508 //
     /* 1804252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1804263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1804266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1804269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1804272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804298 */     // MIs[0] policy
     /* 1804298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804308 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1804311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804332 */     // GIR_Coverage, 12508,
     /* 1804332 */     GIR_EraseRootFromParent_Done,
     /* 1804333 */   // Label 24466: @1804333
     /* 1804333 */   GIM_Try, /*On fail goto*//*Label 24467*/ GIMT_Encode4(1804419), // Rule ID 12509 //
     /* 1804338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1804349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1804352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1804355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1804358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1804361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1804368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804384 */     // MIs[0] policy
     /* 1804384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1804397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804418 */     // GIR_Coverage, 12509,
     /* 1804418 */     GIR_EraseRootFromParent_Done,
     /* 1804419 */   // Label 24467: @1804419
     /* 1804419 */   GIM_Try, /*On fail goto*//*Label 24468*/ GIMT_Encode4(1804505), // Rule ID 12512 //
     /* 1804424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1804435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1804438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1804441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1804444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1804447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804470 */     // MIs[0] policy
     /* 1804470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1804483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804504 */     // GIR_Coverage, 12512,
     /* 1804504 */     GIR_EraseRootFromParent_Done,
     /* 1804505 */   // Label 24468: @1804505
     /* 1804505 */   GIM_Try, /*On fail goto*//*Label 24469*/ GIMT_Encode4(1804591), // Rule ID 12513 //
     /* 1804510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1804521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1804524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1804527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1804530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1804533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1804540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1804544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1804552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804556 */     // MIs[0] policy
     /* 1804556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1804569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1804587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804590 */     // GIR_Coverage, 12513,
     /* 1804590 */     GIR_EraseRootFromParent_Done,
     /* 1804591 */   // Label 24469: @1804591
     /* 1804591 */   GIM_Try, /*On fail goto*//*Label 24470*/ GIMT_Encode4(1804677), // Rule ID 12516 //
     /* 1804596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804642 */     // MIs[0] policy
     /* 1804642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1804655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804676 */     // GIR_Coverage, 12516,
     /* 1804676 */     GIR_EraseRootFromParent_Done,
     /* 1804677 */   // Label 24470: @1804677
     /* 1804677 */   GIM_Try, /*On fail goto*//*Label 24471*/ GIMT_Encode4(1804763), // Rule ID 12517 //
     /* 1804682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1804693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1804696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1804699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1804702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1804705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804728 */     // MIs[0] policy
     /* 1804728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF4_MASK),
     /* 1804741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804762 */     // GIR_Coverage, 12517,
     /* 1804762 */     GIR_EraseRootFromParent_Done,
     /* 1804763 */   // Label 24471: @1804763
     /* 1804763 */   GIM_Try, /*On fail goto*//*Label 24472*/ GIMT_Encode4(1804849), // Rule ID 12520 //
     /* 1804768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804814 */     // MIs[0] policy
     /* 1804814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1804827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804848 */     // GIR_Coverage, 12520,
     /* 1804848 */     GIR_EraseRootFromParent_Done,
     /* 1804849 */   // Label 24472: @1804849
     /* 1804849 */   GIM_Try, /*On fail goto*//*Label 24473*/ GIMT_Encode4(1804935), // Rule ID 12521 //
     /* 1804854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1804857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1804865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1804868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1804871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1804874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1804877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1804880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1804884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804900 */     // MIs[0] policy
     /* 1804900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1804910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1804913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1804915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1804917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1804919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1804921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1804923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1804928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1804931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1804933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1804934 */     // GIR_Coverage, 12521,
     /* 1804934 */     GIR_EraseRootFromParent_Done,
     /* 1804935 */   // Label 24473: @1804935
     /* 1804935 */   GIM_Try, /*On fail goto*//*Label 24474*/ GIMT_Encode4(1805021), // Rule ID 12524 //
     /* 1804940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1804943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1804948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1804951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1804954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1804957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1804960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1804963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1804966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1804970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1804974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1804982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1804986 */     // MIs[0] policy
     /* 1804986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1804989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1804996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1804996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1804999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805020 */     // GIR_Coverage, 12524,
     /* 1805020 */     GIR_EraseRootFromParent_Done,
     /* 1805021 */   // Label 24474: @1805021
     /* 1805021 */   GIM_Try, /*On fail goto*//*Label 24475*/ GIMT_Encode4(1805107), // Rule ID 12525 //
     /* 1805026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1805037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1805040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1805043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1805046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805072 */     // MIs[0] policy
     /* 1805072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1805085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805106 */     // GIR_Coverage, 12525,
     /* 1805106 */     GIR_EraseRootFromParent_Done,
     /* 1805107 */   // Label 24475: @1805107
     /* 1805107 */   GIM_Try, /*On fail goto*//*Label 24476*/ GIMT_Encode4(1805193), // Rule ID 12528 //
     /* 1805112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1805123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1805126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805158 */     // MIs[0] policy
     /* 1805158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1805171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805192 */     // GIR_Coverage, 12528,
     /* 1805192 */     GIR_EraseRootFromParent_Done,
     /* 1805193 */   // Label 24476: @1805193
     /* 1805193 */   GIM_Try, /*On fail goto*//*Label 24477*/ GIMT_Encode4(1805279), // Rule ID 12529 //
     /* 1805198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1805209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1805212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1805215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1805218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805244 */     // MIs[0] policy
     /* 1805244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1805257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805278 */     // GIR_Coverage, 12529,
     /* 1805278 */     GIR_EraseRootFromParent_Done,
     /* 1805279 */   // Label 24477: @1805279
     /* 1805279 */   GIM_Try, /*On fail goto*//*Label 24478*/ GIMT_Encode4(1805365), // Rule ID 12532 //
     /* 1805284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1805287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1805295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1805298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805330 */     // MIs[0] policy
     /* 1805330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1805343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805364 */     // GIR_Coverage, 12532,
     /* 1805364 */     GIR_EraseRootFromParent_Done,
     /* 1805365 */   // Label 24478: @1805365
     /* 1805365 */   GIM_Try, /*On fail goto*//*Label 24479*/ GIMT_Encode4(1805451), // Rule ID 12533 //
     /* 1805370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1805373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1805381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1805384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1805387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1805390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1805393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1805400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1805404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805416 */     // MIs[0] policy
     /* 1805416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1805429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1805447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805450 */     // GIR_Coverage, 12533,
     /* 1805450 */     GIR_EraseRootFromParent_Done,
     /* 1805451 */   // Label 24479: @1805451
     /* 1805451 */   GIM_Try, /*On fail goto*//*Label 24480*/ GIMT_Encode4(1805537), // Rule ID 12536 //
     /* 1805456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805502 */     // MIs[0] policy
     /* 1805502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1805515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805536 */     // GIR_Coverage, 12536,
     /* 1805536 */     GIR_EraseRootFromParent_Done,
     /* 1805537 */   // Label 24480: @1805537
     /* 1805537 */   GIM_Try, /*On fail goto*//*Label 24481*/ GIMT_Encode4(1805623), // Rule ID 12537 //
     /* 1805542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1805553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1805556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1805559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1805562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1805565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1805572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805588 */     // MIs[0] policy
     /* 1805588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_MF2_MASK),
     /* 1805601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805622 */     // GIR_Coverage, 12537,
     /* 1805622 */     GIR_EraseRootFromParent_Done,
     /* 1805623 */   // Label 24481: @1805623
     /* 1805623 */   GIM_Try, /*On fail goto*//*Label 24482*/ GIMT_Encode4(1805709), // Rule ID 12540 //
     /* 1805628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805674 */     // MIs[0] policy
     /* 1805674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1805687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805708 */     // GIR_Coverage, 12540,
     /* 1805708 */     GIR_EraseRootFromParent_Done,
     /* 1805709 */   // Label 24482: @1805709
     /* 1805709 */   GIM_Try, /*On fail goto*//*Label 24483*/ GIMT_Encode4(1805795), // Rule ID 12541 //
     /* 1805714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1805725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1805728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1805731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1805734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1805737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1805744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1805756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805760 */     // MIs[0] policy
     /* 1805760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M1_MASK),
     /* 1805773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805794 */     // GIR_Coverage, 12541,
     /* 1805794 */     GIR_EraseRootFromParent_Done,
     /* 1805795 */   // Label 24483: @1805795
     /* 1805795 */   GIM_Try, /*On fail goto*//*Label 24484*/ GIMT_Encode4(1805881), // Rule ID 12544 //
     /* 1805800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1805820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805846 */     // MIs[0] policy
     /* 1805846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1805856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1805859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805880 */     // GIR_Coverage, 12544,
     /* 1805880 */     GIR_EraseRootFromParent_Done,
     /* 1805881 */   // Label 24484: @1805881
     /* 1805881 */   GIM_Try, /*On fail goto*//*Label 24485*/ GIMT_Encode4(1805967), // Rule ID 12545 //
     /* 1805886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1805889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1805897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1805900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1805903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1805906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1805909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1805912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1805916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1805920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1805928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1805932 */     // MIs[0] policy
     /* 1805932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1805935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1805942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1805942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M2_MASK),
     /* 1805945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1805947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1805949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1805951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1805953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1805955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1805960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1805963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1805965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1805966 */     // GIR_Coverage, 12545,
     /* 1805966 */     GIR_EraseRootFromParent_Done,
     /* 1805967 */   // Label 24485: @1805967
     /* 1805967 */   GIM_Try, /*On fail goto*//*Label 24486*/ GIMT_Encode4(1806053), // Rule ID 12548 //
     /* 1805972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1805975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1805980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1805983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1805986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1805989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1805992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1805995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1805998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806018 */     // MIs[0] policy
     /* 1806018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1806031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806052 */     // GIR_Coverage, 12548,
     /* 1806052 */     GIR_EraseRootFromParent_Done,
     /* 1806053 */   // Label 24486: @1806053
     /* 1806053 */   GIM_Try, /*On fail goto*//*Label 24487*/ GIMT_Encode4(1806139), // Rule ID 12549 //
     /* 1806058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1806061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1806069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1806072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1806075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1806078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1806088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1806092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806104 */     // MIs[0] policy
     /* 1806104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VV_M4_MASK),
     /* 1806117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1806135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806138 */     // GIR_Coverage, 12549,
     /* 1806138 */     GIR_EraseRootFromParent_Done,
     /* 1806139 */   // Label 24487: @1806139
     /* 1806139 */   GIM_Try, /*On fail goto*//*Label 24488*/ GIMT_Encode4(1806225), // Rule ID 12552 //
     /* 1806144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1806155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1806158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1806161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806190 */     // MIs[0] policy
     /* 1806190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1806203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806224 */     // GIR_Coverage, 12552,
     /* 1806224 */     GIR_EraseRootFromParent_Done,
     /* 1806225 */   // Label 24488: @1806225
     /* 1806225 */   GIM_Try, /*On fail goto*//*Label 24489*/ GIMT_Encode4(1806311), // Rule ID 12553 //
     /* 1806230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1806241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1806244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1806247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1806253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806276 */     // MIs[0] policy
     /* 1806276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF8_MASK),
     /* 1806289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806310 */     // GIR_Coverage, 12553,
     /* 1806310 */     GIR_EraseRootFromParent_Done,
     /* 1806311 */   // Label 24489: @1806311
     /* 1806311 */   GIM_Try, /*On fail goto*//*Label 24490*/ GIMT_Encode4(1806397), // Rule ID 12556 //
     /* 1806316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1806327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1806330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1806333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806362 */     // MIs[0] policy
     /* 1806362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1806375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806396 */     // GIR_Coverage, 12556,
     /* 1806396 */     GIR_EraseRootFromParent_Done,
     /* 1806397 */   // Label 24490: @1806397
     /* 1806397 */   GIM_Try, /*On fail goto*//*Label 24491*/ GIMT_Encode4(1806483), // Rule ID 12557 //
     /* 1806402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1806413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1806416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1806419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1806425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806448 */     // MIs[0] policy
     /* 1806448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806458 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1806461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806482 */     // GIR_Coverage, 12557,
     /* 1806482 */     GIR_EraseRootFromParent_Done,
     /* 1806483 */   // Label 24491: @1806483
     /* 1806483 */   GIM_Try, /*On fail goto*//*Label 24492*/ GIMT_Encode4(1806569), // Rule ID 12560 //
     /* 1806488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1806499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1806502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1806505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806534 */     // MIs[0] policy
     /* 1806534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1806547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806568 */     // GIR_Coverage, 12560,
     /* 1806568 */     GIR_EraseRootFromParent_Done,
     /* 1806569 */   // Label 24492: @1806569
     /* 1806569 */   GIM_Try, /*On fail goto*//*Label 24493*/ GIMT_Encode4(1806655), // Rule ID 12561 //
     /* 1806574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1806585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1806588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1806591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1806597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1806604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806620 */     // MIs[0] policy
     /* 1806620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11589:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1806633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806654 */     // GIR_Coverage, 12561,
     /* 1806654 */     GIR_EraseRootFromParent_Done,
     /* 1806655 */   // Label 24493: @1806655
     /* 1806655 */   GIM_Try, /*On fail goto*//*Label 24494*/ GIMT_Encode4(1806741), // Rule ID 12564 //
     /* 1806660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806706 */     // MIs[0] policy
     /* 1806706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1806719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806740 */     // GIR_Coverage, 12564,
     /* 1806740 */     GIR_EraseRootFromParent_Done,
     /* 1806741 */   // Label 24494: @1806741
     /* 1806741 */   GIM_Try, /*On fail goto*//*Label 24495*/ GIMT_Encode4(1806827), // Rule ID 12565 //
     /* 1806746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1806757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1806760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1806763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1806769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1806776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1806784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806792 */     // MIs[0] policy
     /* 1806792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1806805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806826 */     // GIR_Coverage, 12565,
     /* 1806826 */     GIR_EraseRootFromParent_Done,
     /* 1806827 */   // Label 24495: @1806827
     /* 1806827 */   GIM_Try, /*On fail goto*//*Label 24496*/ GIMT_Encode4(1806913), // Rule ID 12568 //
     /* 1806832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1806835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1806852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1806858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806878 */     // MIs[0] policy
     /* 1806878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806888 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1806888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1806891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806912 */     // GIR_Coverage, 12568,
     /* 1806912 */     GIR_EraseRootFromParent_Done,
     /* 1806913 */   // Label 24496: @1806913
     /* 1806913 */   GIM_Try, /*On fail goto*//*Label 24497*/ GIMT_Encode4(1806999), // Rule ID 12569 //
     /* 1806918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1806921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1806926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1806929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1806932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1806935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1806938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1806941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1806944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1806948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1806952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1806956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1806960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1806964 */     // MIs[0] policy
     /* 1806964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1806967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1806974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1806974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1806977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1806979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1806981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1806983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1806985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1806987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1806992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1806995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1806997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1806998 */     // GIR_Coverage, 12569,
     /* 1806998 */     GIR_EraseRootFromParent_Done,
     /* 1806999 */   // Label 24497: @1806999
     /* 1806999 */   GIM_Try, /*On fail goto*//*Label 24498*/ GIMT_Encode4(1807085), // Rule ID 12572 //
     /* 1807004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1807015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1807018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1807021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1807027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807050 */     // MIs[0] policy
     /* 1807050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1807063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807084 */     // GIR_Coverage, 12572,
     /* 1807084 */     GIR_EraseRootFromParent_Done,
     /* 1807085 */   // Label 24498: @1807085
     /* 1807085 */   GIM_Try, /*On fail goto*//*Label 24499*/ GIMT_Encode4(1807171), // Rule ID 12573 //
     /* 1807090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1807101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1807104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1807107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1807113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807136 */     // MIs[0] policy
     /* 1807136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1807149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1807167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807170 */     // GIR_Coverage, 12573,
     /* 1807170 */     GIR_EraseRootFromParent_Done,
     /* 1807171 */   // Label 24499: @1807171
     /* 1807171 */   GIM_Try, /*On fail goto*//*Label 24500*/ GIMT_Encode4(1807257), // Rule ID 12576 //
     /* 1807176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807222 */     // MIs[0] policy
     /* 1807222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807232 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1807235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807256 */     // GIR_Coverage, 12576,
     /* 1807256 */     GIR_EraseRootFromParent_Done,
     /* 1807257 */   // Label 24500: @1807257
     /* 1807257 */   GIM_Try, /*On fail goto*//*Label 24501*/ GIMT_Encode4(1807343), // Rule ID 12577 //
     /* 1807262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1807273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1807276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1807279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1807285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807308 */     // MIs[0] policy
     /* 1807308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF4_MASK),
     /* 1807321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807342 */     // GIR_Coverage, 12577,
     /* 1807342 */     GIR_EraseRootFromParent_Done,
     /* 1807343 */   // Label 24501: @1807343
     /* 1807343 */   GIM_Try, /*On fail goto*//*Label 24502*/ GIMT_Encode4(1807429), // Rule ID 12580 //
     /* 1807348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1807359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1807362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807394 */     // MIs[0] policy
     /* 1807394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1807407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807428 */     // GIR_Coverage, 12580,
     /* 1807428 */     GIR_EraseRootFromParent_Done,
     /* 1807429 */   // Label 24502: @1807429
     /* 1807429 */   GIM_Try, /*On fail goto*//*Label 24503*/ GIMT_Encode4(1807515), // Rule ID 12581 //
     /* 1807434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1807445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1807448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1807451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1807457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1807464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807480 */     // MIs[0] policy
     /* 1807480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11589:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1807493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807514 */     // GIR_Coverage, 12581,
     /* 1807514 */     GIR_EraseRootFromParent_Done,
     /* 1807515 */   // Label 24503: @1807515
     /* 1807515 */   GIM_Try, /*On fail goto*//*Label 24504*/ GIMT_Encode4(1807601), // Rule ID 12584 //
     /* 1807520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1807531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1807534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807566 */     // MIs[0] policy
     /* 1807566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1807579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807600 */     // GIR_Coverage, 12584,
     /* 1807600 */     GIR_EraseRootFromParent_Done,
     /* 1807601 */   // Label 24504: @1807601
     /* 1807601 */   GIM_Try, /*On fail goto*//*Label 24505*/ GIMT_Encode4(1807687), // Rule ID 12585 //
     /* 1807606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1807617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1807620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1807623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1807629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1807636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1807644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807652 */     // MIs[0] policy
     /* 1807652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1807665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807686 */     // GIR_Coverage, 12585,
     /* 1807686 */     GIR_EraseRootFromParent_Done,
     /* 1807687 */   // Label 24505: @1807687
     /* 1807687 */   GIM_Try, /*On fail goto*//*Label 24506*/ GIMT_Encode4(1807773), // Rule ID 12588 //
     /* 1807692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807738 */     // MIs[0] policy
     /* 1807738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1807751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807772 */     // GIR_Coverage, 12588,
     /* 1807772 */     GIR_EraseRootFromParent_Done,
     /* 1807773 */   // Label 24506: @1807773
     /* 1807773 */   GIM_Try, /*On fail goto*//*Label 24507*/ GIMT_Encode4(1807859), // Rule ID 12589 //
     /* 1807778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1807789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1807792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1807795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1807801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1807808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1807816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807824 */     // MIs[0] policy
     /* 1807824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1807834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1807837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807858 */     // GIR_Coverage, 12589,
     /* 1807858 */     GIR_EraseRootFromParent_Done,
     /* 1807859 */   // Label 24507: @1807859
     /* 1807859 */   GIM_Try, /*On fail goto*//*Label 24508*/ GIMT_Encode4(1807945), // Rule ID 12592 //
     /* 1807864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1807867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1807884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1807890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807910 */     // MIs[0] policy
     /* 1807910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1807920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1807920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1807923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1807925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1807927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1807929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1807931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1807933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1807938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1807941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1807943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1807944 */     // GIR_Coverage, 12592,
     /* 1807944 */     GIR_EraseRootFromParent_Done,
     /* 1807945 */   // Label 24508: @1807945
     /* 1807945 */   GIM_Try, /*On fail goto*//*Label 24509*/ GIMT_Encode4(1808031), // Rule ID 12593 //
     /* 1807950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1807953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1807958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1807961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1807964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1807967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1807970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1807973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1807976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1807980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1807984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1807988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1807992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1807996 */     // MIs[0] policy
     /* 1807996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1807999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1808009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1808027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808030 */     // GIR_Coverage, 12593,
     /* 1808030 */     GIR_EraseRootFromParent_Done,
     /* 1808031 */   // Label 24509: @1808031
     /* 1808031 */   GIM_Try, /*On fail goto*//*Label 24510*/ GIMT_Encode4(1808117), // Rule ID 12596 //
     /* 1808036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1808053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808082 */     // MIs[0] policy
     /* 1808082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1808095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808116 */     // GIR_Coverage, 12596,
     /* 1808116 */     GIR_EraseRootFromParent_Done,
     /* 1808117 */   // Label 24510: @1808117
     /* 1808117 */   GIM_Try, /*On fail goto*//*Label 24511*/ GIMT_Encode4(1808203), // Rule ID 12597 //
     /* 1808122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1808133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1808136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1808139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1808145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808168 */     // MIs[0] policy
     /* 1808168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11589:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_MF2_MASK),
     /* 1808181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808202 */     // GIR_Coverage, 12597,
     /* 1808202 */     GIR_EraseRootFromParent_Done,
     /* 1808203 */   // Label 24511: @1808203
     /* 1808203 */   GIM_Try, /*On fail goto*//*Label 24512*/ GIMT_Encode4(1808289), // Rule ID 12600 //
     /* 1808208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1808219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1808222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1808225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808254 */     // MIs[0] policy
     /* 1808254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1808267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808288 */     // GIR_Coverage, 12600,
     /* 1808288 */     GIR_EraseRootFromParent_Done,
     /* 1808289 */   // Label 24512: @1808289
     /* 1808289 */   GIM_Try, /*On fail goto*//*Label 24513*/ GIMT_Encode4(1808375), // Rule ID 12601 //
     /* 1808294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1808305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1808308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1808311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1808324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808340 */     // MIs[0] policy
     /* 1808340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11589:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M1_MASK),
     /* 1808353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808374 */     // GIR_Coverage, 12601,
     /* 1808374 */     GIR_EraseRootFromParent_Done,
     /* 1808375 */   // Label 24513: @1808375
     /* 1808375 */   GIM_Try, /*On fail goto*//*Label 24514*/ GIMT_Encode4(1808461), // Rule ID 12604 //
     /* 1808380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1808391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1808394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808426 */     // MIs[0] policy
     /* 1808426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1808439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808460 */     // GIR_Coverage, 12604,
     /* 1808460 */     GIR_EraseRootFromParent_Done,
     /* 1808461 */   // Label 24514: @1808461
     /* 1808461 */   GIM_Try, /*On fail goto*//*Label 24515*/ GIMT_Encode4(1808547), // Rule ID 12605 //
     /* 1808466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1808477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1808480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1808483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1808496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1808504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808512 */     // MIs[0] policy
     /* 1808512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808522 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11589:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M2_MASK),
     /* 1808525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808546 */     // GIR_Coverage, 12605,
     /* 1808546 */     GIR_EraseRootFromParent_Done,
     /* 1808547 */   // Label 24515: @1808547
     /* 1808547 */   GIM_Try, /*On fail goto*//*Label 24516*/ GIMT_Encode4(1808633), // Rule ID 12608 //
     /* 1808552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1808555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1808563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1808566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1808569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1808572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808598 */     // MIs[0] policy
     /* 1808598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1808611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808632 */     // GIR_Coverage, 12608,
     /* 1808632 */     GIR_EraseRootFromParent_Done,
     /* 1808633 */   // Label 24516: @1808633
     /* 1808633 */   GIM_Try, /*On fail goto*//*Label 24517*/ GIMT_Encode4(1808719), // Rule ID 12609 //
     /* 1808638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1808641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmulsu_mask),
     /* 1808646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1808649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1808652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1808655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1808658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1808661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1808668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1808672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1808676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1808680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808684 */     // MIs[0] policy
     /* 1808684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11589:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMULSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMULSU_VX_M4_MASK),
     /* 1808697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1808701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1808715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808718 */     // GIR_Coverage, 12609,
     /* 1808718 */     GIR_EraseRootFromParent_Done,
     /* 1808719 */   // Label 24517: @1808719
     /* 1808719 */   GIM_Try, /*On fail goto*//*Label 24518*/ GIMT_Encode4(1808805), // Rule ID 12612 //
     /* 1808724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1808732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1808735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1808738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1808744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808770 */     // MIs[0] policy
     /* 1808770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808780 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1808783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1808787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808804 */     // GIR_Coverage, 12612,
     /* 1808804 */     GIR_EraseRootFromParent_Done,
     /* 1808805 */   // Label 24518: @1808805
     /* 1808805 */   GIM_Try, /*On fail goto*//*Label 24519*/ GIMT_Encode4(1808891), // Rule ID 12613 //
     /* 1808810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1808818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1808821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1808824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1808827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1808830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1808833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1808836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808856 */     // MIs[0] policy
     /* 1808856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1808866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1808869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1808873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808890 */     // GIR_Coverage, 12613,
     /* 1808890 */     GIR_EraseRootFromParent_Done,
     /* 1808891 */   // Label 24519: @1808891
     /* 1808891 */   GIM_Try, /*On fail goto*//*Label 24520*/ GIMT_Encode4(1808977), // Rule ID 12616 //
     /* 1808896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1808899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1808904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1808907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1808910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1808916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1808919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1808922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1808926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1808938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1808942 */     // MIs[0] policy
     /* 1808942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1808945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1808952 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1808952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1808955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1808957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1808959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1808961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1808963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1808965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1808970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1808973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1808975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1808976 */     // GIR_Coverage, 12616,
     /* 1808976 */     GIR_EraseRootFromParent_Done,
     /* 1808977 */   // Label 24520: @1808977
     /* 1808977 */   GIM_Try, /*On fail goto*//*Label 24521*/ GIMT_Encode4(1809063), // Rule ID 12617 //
     /* 1808982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1808985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1808990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1808993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1808996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1808999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1809002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809028 */     // MIs[0] policy
     /* 1809028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809038 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1809041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809062 */     // GIR_Coverage, 12617,
     /* 1809062 */     GIR_EraseRootFromParent_Done,
     /* 1809063 */   // Label 24521: @1809063
     /* 1809063 */   GIM_Try, /*On fail goto*//*Label 24522*/ GIMT_Encode4(1809149), // Rule ID 12620 //
     /* 1809068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1809079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1809082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809114 */     // MIs[0] policy
     /* 1809114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809124 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1809127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809148 */     // GIR_Coverage, 12620,
     /* 1809148 */     GIR_EraseRootFromParent_Done,
     /* 1809149 */   // Label 24522: @1809149
     /* 1809149 */   GIM_Try, /*On fail goto*//*Label 24523*/ GIMT_Encode4(1809235), // Rule ID 12621 //
     /* 1809154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1809165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1809168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1809171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1809174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809200 */     // MIs[0] policy
     /* 1809200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809210 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF4_MASK),
     /* 1809213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809234 */     // GIR_Coverage, 12621,
     /* 1809234 */     GIR_EraseRootFromParent_Done,
     /* 1809235 */   // Label 24523: @1809235
     /* 1809235 */   GIM_Try, /*On fail goto*//*Label 24524*/ GIMT_Encode4(1809321), // Rule ID 12624 //
     /* 1809240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1809251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1809254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1809260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809286 */     // MIs[0] policy
     /* 1809286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809296 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1809299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809320 */     // GIR_Coverage, 12624,
     /* 1809320 */     GIR_EraseRootFromParent_Done,
     /* 1809321 */   // Label 24524: @1809321
     /* 1809321 */   GIM_Try, /*On fail goto*//*Label 24525*/ GIMT_Encode4(1809407), // Rule ID 12625 //
     /* 1809326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1809337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1809340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1809343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1809346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809372 */     // MIs[0] policy
     /* 1809372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1809385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809406 */     // GIR_Coverage, 12625,
     /* 1809406 */     GIR_EraseRootFromParent_Done,
     /* 1809407 */   // Label 24525: @1809407
     /* 1809407 */   GIM_Try, /*On fail goto*//*Label 24526*/ GIMT_Encode4(1809493), // Rule ID 12628 //
     /* 1809412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1809432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809458 */     // MIs[0] policy
     /* 1809458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809468 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1809471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809492 */     // GIR_Coverage, 12628,
     /* 1809492 */     GIR_EraseRootFromParent_Done,
     /* 1809493 */   // Label 24526: @1809493
     /* 1809493 */   GIM_Try, /*On fail goto*//*Label 24527*/ GIMT_Encode4(1809579), // Rule ID 12629 //
     /* 1809498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1809509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1809512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1809515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1809518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1809521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809544 */     // MIs[0] policy
     /* 1809544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809554 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_MF2_MASK),
     /* 1809557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1809575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809578 */     // GIR_Coverage, 12629,
     /* 1809578 */     GIR_EraseRootFromParent_Done,
     /* 1809579 */   // Label 24527: @1809579
     /* 1809579 */   GIM_Try, /*On fail goto*//*Label 24528*/ GIMT_Encode4(1809665), // Rule ID 12632 //
     /* 1809584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1809595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1809598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1809601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1809604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809630 */     // MIs[0] policy
     /* 1809630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809640 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1809643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809664 */     // GIR_Coverage, 12632,
     /* 1809664 */     GIR_EraseRootFromParent_Done,
     /* 1809665 */   // Label 24528: @1809665
     /* 1809665 */   GIM_Try, /*On fail goto*//*Label 24529*/ GIMT_Encode4(1809751), // Rule ID 12633 //
     /* 1809670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1809681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1809684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1809687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1809690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1809693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809716 */     // MIs[0] policy
     /* 1809716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809726 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1809729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1809747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809750 */     // GIR_Coverage, 12633,
     /* 1809750 */     GIR_EraseRootFromParent_Done,
     /* 1809751 */   // Label 24529: @1809751
     /* 1809751 */   GIM_Try, /*On fail goto*//*Label 24530*/ GIMT_Encode4(1809837), // Rule ID 12636 //
     /* 1809756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1809767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1809770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1809776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809802 */     // MIs[0] policy
     /* 1809802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809812 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1809815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809836 */     // GIR_Coverage, 12636,
     /* 1809836 */     GIR_EraseRootFromParent_Done,
     /* 1809837 */   // Label 24530: @1809837
     /* 1809837 */   GIM_Try, /*On fail goto*//*Label 24531*/ GIMT_Encode4(1809923), // Rule ID 12637 //
     /* 1809842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1809845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1809853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1809856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1809859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1809862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1809865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1809868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809888 */     // MIs[0] policy
     /* 1809888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809898 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1809898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1809901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1809916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1809919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1809921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1809922 */     // GIR_Coverage, 12637,
     /* 1809922 */     GIR_EraseRootFromParent_Done,
     /* 1809923 */   // Label 24531: @1809923
     /* 1809923 */   GIM_Try, /*On fail goto*//*Label 24532*/ GIMT_Encode4(1810009), // Rule ID 12640 //
     /* 1809928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1809931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1809936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1809939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1809942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1809945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1809948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1809951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1809954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1809958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1809970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1809974 */     // MIs[0] policy
     /* 1809974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1809977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1809984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1809984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1809987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1809989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1809991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1809993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1809995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1809997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810008 */     // GIR_Coverage, 12640,
     /* 1810008 */     GIR_EraseRootFromParent_Done,
     /* 1810009 */   // Label 24532: @1810009
     /* 1810009 */   GIM_Try, /*On fail goto*//*Label 24533*/ GIMT_Encode4(1810095), // Rule ID 12641 //
     /* 1810014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1810025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1810028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1810031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1810034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1810037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810060 */     // MIs[0] policy
     /* 1810060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1810073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1810091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810094 */     // GIR_Coverage, 12641,
     /* 1810094 */     GIR_EraseRootFromParent_Done,
     /* 1810095 */   // Label 24533: @1810095
     /* 1810095 */   GIM_Try, /*On fail goto*//*Label 24534*/ GIMT_Encode4(1810181), // Rule ID 12644 //
     /* 1810100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1810103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1810117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1810120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810146 */     // MIs[0] policy
     /* 1810146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810156 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1810159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1810177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810180 */     // GIR_Coverage, 12644,
     /* 1810180 */     GIR_EraseRootFromParent_Done,
     /* 1810181 */   // Label 24534: @1810181
     /* 1810181 */   GIM_Try, /*On fail goto*//*Label 24535*/ GIMT_Encode4(1810267), // Rule ID 12645 //
     /* 1810186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1810189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1810197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1810200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1810203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1810206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1810209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1810216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1810228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810232 */     // MIs[0] policy
     /* 1810232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810242 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M1_MASK),
     /* 1810245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1810263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810266 */     // GIR_Coverage, 12645,
     /* 1810266 */     GIR_EraseRootFromParent_Done,
     /* 1810267 */   // Label 24535: @1810267
     /* 1810267 */   GIM_Try, /*On fail goto*//*Label 24536*/ GIMT_Encode4(1810353), // Rule ID 12648 //
     /* 1810272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1810283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1810286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810318 */     // MIs[0] policy
     /* 1810318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810328 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1810331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810352 */     // GIR_Coverage, 12648,
     /* 1810352 */     GIR_EraseRootFromParent_Done,
     /* 1810353 */   // Label 24536: @1810353
     /* 1810353 */   GIM_Try, /*On fail goto*//*Label 24537*/ GIMT_Encode4(1810439), // Rule ID 12649 //
     /* 1810358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1810369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1810372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1810375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1810378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810404 */     // MIs[0] policy
     /* 1810404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810414 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1810417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810438 */     // GIR_Coverage, 12649,
     /* 1810438 */     GIR_EraseRootFromParent_Done,
     /* 1810439 */   // Label 24537: @1810439
     /* 1810439 */   GIM_Try, /*On fail goto*//*Label 24538*/ GIMT_Encode4(1810525), // Rule ID 12652 //
     /* 1810444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1810455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1810458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1810461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1810464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1810467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810490 */     // MIs[0] policy
     /* 1810490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810500 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1810503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810524 */     // GIR_Coverage, 12652,
     /* 1810524 */     GIR_EraseRootFromParent_Done,
     /* 1810525 */   // Label 24538: @1810525
     /* 1810525 */   GIM_Try, /*On fail goto*//*Label 24539*/ GIMT_Encode4(1810611), // Rule ID 12653 //
     /* 1810530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1810541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1810544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1810547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1810550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1810553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810576 */     // MIs[0] policy
     /* 1810576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810586 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1810589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810610 */     // GIR_Coverage, 12653,
     /* 1810610 */     GIR_EraseRootFromParent_Done,
     /* 1810611 */   // Label 24539: @1810611
     /* 1810611 */   GIM_Try, /*On fail goto*//*Label 24540*/ GIMT_Encode4(1810697), // Rule ID 12656 //
     /* 1810616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1810627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1810630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1810633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1810636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1810639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810662 */     // MIs[0] policy
     /* 1810662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810672 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1810675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810696 */     // GIR_Coverage, 12656,
     /* 1810696 */     GIR_EraseRootFromParent_Done,
     /* 1810697 */   // Label 24540: @1810697
     /* 1810697 */   GIM_Try, /*On fail goto*//*Label 24541*/ GIMT_Encode4(1810783), // Rule ID 12657 //
     /* 1810702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1810713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1810716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1810719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1810722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1810725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1810732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1810744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810748 */     // MIs[0] policy
     /* 1810748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810758 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1810761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1810779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810782 */     // GIR_Coverage, 12657,
     /* 1810782 */     GIR_EraseRootFromParent_Done,
     /* 1810783 */   // Label 24541: @1810783
     /* 1810783 */   GIM_Try, /*On fail goto*//*Label 24542*/ GIMT_Encode4(1810869), // Rule ID 12660 //
     /* 1810788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810834 */     // MIs[0] policy
     /* 1810834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1810844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1810847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810868 */     // GIR_Coverage, 12660,
     /* 1810868 */     GIR_EraseRootFromParent_Done,
     /* 1810869 */   // Label 24542: @1810869
     /* 1810869 */   GIM_Try, /*On fail goto*//*Label 24543*/ GIMT_Encode4(1810955), // Rule ID 12661 //
     /* 1810874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1810877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1810885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1810888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1810891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1810894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1810897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1810900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1810904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1810916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1810920 */     // MIs[0] policy
     /* 1810920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1810923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1810930 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1810930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1810933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1810935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1810937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1810939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1810941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1810943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1810948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1810951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1810953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1810954 */     // GIR_Coverage, 12661,
     /* 1810954 */     GIR_EraseRootFromParent_Done,
     /* 1810955 */   // Label 24543: @1810955
     /* 1810955 */   GIM_Try, /*On fail goto*//*Label 24544*/ GIMT_Encode4(1811041), // Rule ID 12664 //
     /* 1810960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1810963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1810968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1810971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1810974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1810977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1810980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1810983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1810986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1810990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1810998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811006 */     // MIs[0] policy
     /* 1811006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811016 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1811019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811040 */     // GIR_Coverage, 12664,
     /* 1811040 */     GIR_EraseRootFromParent_Done,
     /* 1811041 */   // Label 24544: @1811041
     /* 1811041 */   GIM_Try, /*On fail goto*//*Label 24545*/ GIMT_Encode4(1811127), // Rule ID 12665 //
     /* 1811046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1811057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1811060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1811063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1811066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811092 */     // MIs[0] policy
     /* 1811092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811102 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1811105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811126 */     // GIR_Coverage, 12665,
     /* 1811126 */     GIR_EraseRootFromParent_Done,
     /* 1811127 */   // Label 24545: @1811127
     /* 1811127 */   GIM_Try, /*On fail goto*//*Label 24546*/ GIMT_Encode4(1811213), // Rule ID 12668 //
     /* 1811132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1811149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1811152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811178 */     // MIs[0] policy
     /* 1811178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811188 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1811191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811212 */     // GIR_Coverage, 12668,
     /* 1811212 */     GIR_EraseRootFromParent_Done,
     /* 1811213 */   // Label 24546: @1811213
     /* 1811213 */   GIM_Try, /*On fail goto*//*Label 24547*/ GIMT_Encode4(1811299), // Rule ID 12669 //
     /* 1811218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1811229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1811232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1811235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1811238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1811241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811264 */     // MIs[0] policy
     /* 1811264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1811277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1811295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811298 */     // GIR_Coverage, 12669,
     /* 1811298 */     GIR_EraseRootFromParent_Done,
     /* 1811299 */   // Label 24547: @1811299
     /* 1811299 */   GIM_Try, /*On fail goto*//*Label 24548*/ GIMT_Encode4(1811385), // Rule ID 12672 //
     /* 1811304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811350 */     // MIs[0] policy
     /* 1811350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811360 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1811363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811384 */     // GIR_Coverage, 12672,
     /* 1811384 */     GIR_EraseRootFromParent_Done,
     /* 1811385 */   // Label 24548: @1811385
     /* 1811385 */   GIM_Try, /*On fail goto*//*Label 24549*/ GIMT_Encode4(1811471), // Rule ID 12673 //
     /* 1811390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1811401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1811404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1811407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1811410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1811413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811436 */     // MIs[0] policy
     /* 1811436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811446 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1811449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811470 */     // GIR_Coverage, 12673,
     /* 1811470 */     GIR_EraseRootFromParent_Done,
     /* 1811471 */   // Label 24549: @1811471
     /* 1811471 */   GIM_Try, /*On fail goto*//*Label 24550*/ GIMT_Encode4(1811557), // Rule ID 12676 //
     /* 1811476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811522 */     // MIs[0] policy
     /* 1811522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1811535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811556 */     // GIR_Coverage, 12676,
     /* 1811556 */     GIR_EraseRootFromParent_Done,
     /* 1811557 */   // Label 24550: @1811557
     /* 1811557 */   GIM_Try, /*On fail goto*//*Label 24551*/ GIMT_Encode4(1811643), // Rule ID 12677 //
     /* 1811562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1811573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1811576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1811579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1811582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1811585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1811592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1811604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811608 */     // MIs[0] policy
     /* 1811608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811618 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1811621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811642 */     // GIR_Coverage, 12677,
     /* 1811642 */     GIR_EraseRootFromParent_Done,
     /* 1811643 */   // Label 24551: @1811643
     /* 1811643 */   GIM_Try, /*On fail goto*//*Label 24552*/ GIMT_Encode4(1811729), // Rule ID 12680 //
     /* 1811648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1811651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1811665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1811668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811694 */     // MIs[0] policy
     /* 1811694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1811707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811728 */     // GIR_Coverage, 12680,
     /* 1811728 */     GIR_EraseRootFromParent_Done,
     /* 1811729 */   // Label 24552: @1811729
     /* 1811729 */   GIM_Try, /*On fail goto*//*Label 24553*/ GIMT_Encode4(1811815), // Rule ID 12681 //
     /* 1811734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1811737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1811745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1811748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1811751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1811754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1811757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1811764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1811776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811780 */     // MIs[0] policy
     /* 1811780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811790 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1811793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1811811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811814 */     // GIR_Coverage, 12681,
     /* 1811814 */     GIR_EraseRootFromParent_Done,
     /* 1811815 */   // Label 24553: @1811815
     /* 1811815 */   GIM_Try, /*On fail goto*//*Label 24554*/ GIMT_Encode4(1811901), // Rule ID 12684 //
     /* 1811820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1811823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1811831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1811834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1811837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1811840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1811846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811866 */     // MIs[0] policy
     /* 1811866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811876 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1811876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1811879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1811897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811900 */     // GIR_Coverage, 12684,
     /* 1811900 */     GIR_EraseRootFromParent_Done,
     /* 1811901 */   // Label 24554: @1811901
     /* 1811901 */   GIM_Try, /*On fail goto*//*Label 24555*/ GIMT_Encode4(1811987), // Rule ID 12685 //
     /* 1811906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1811909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1811914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1811917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1811920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1811923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1811926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1811929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1811932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1811936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1811948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1811952 */     // MIs[0] policy
     /* 1811952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1811955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1811962 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1811962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M2_MASK),
     /* 1811965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1811967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1811969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1811971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1811973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1811975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1811980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1811983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1811985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1811986 */     // GIR_Coverage, 12685,
     /* 1811986 */     GIR_EraseRootFromParent_Done,
     /* 1811987 */   // Label 24555: @1811987
     /* 1811987 */   GIM_Try, /*On fail goto*//*Label 24556*/ GIMT_Encode4(1812073), // Rule ID 12688 //
     /* 1811992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1811995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1812009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1812012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812038 */     // MIs[0] policy
     /* 1812038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1812051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812072 */     // GIR_Coverage, 12688,
     /* 1812072 */     GIR_EraseRootFromParent_Done,
     /* 1812073 */   // Label 24556: @1812073
     /* 1812073 */   GIM_Try, /*On fail goto*//*Label 24557*/ GIMT_Encode4(1812159), // Rule ID 12689 //
     /* 1812078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1812081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1812089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1812092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1812095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1812098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1812108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1812120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812124 */     // MIs[0] policy
     /* 1812124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812134 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M4_MASK),
     /* 1812137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812158 */     // GIR_Coverage, 12689,
     /* 1812158 */     GIR_EraseRootFromParent_Done,
     /* 1812159 */   // Label 24557: @1812159
     /* 1812159 */   GIM_Try, /*On fail goto*//*Label 24558*/ GIMT_Encode4(1812245), // Rule ID 12692 //
     /* 1812164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1812167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1812181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1812184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812210 */     // MIs[0] policy
     /* 1812210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812220 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1812223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812244 */     // GIR_Coverage, 12692,
     /* 1812244 */     GIR_EraseRootFromParent_Done,
     /* 1812245 */   // Label 24558: @1812245
     /* 1812245 */   GIM_Try, /*On fail goto*//*Label 24559*/ GIMT_Encode4(1812331), // Rule ID 12693 //
     /* 1812250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1812253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1812261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1812264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1812267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1812270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1812273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1812280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1812292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812296 */     // MIs[0] policy
     /* 1812296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812306 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VV_M8_MASK),
     /* 1812309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1812327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812330 */     // GIR_Coverage, 12693,
     /* 1812330 */     GIR_EraseRootFromParent_Done,
     /* 1812331 */   // Label 24559: @1812331
     /* 1812331 */   GIM_Try, /*On fail goto*//*Label 24560*/ GIMT_Encode4(1812417), // Rule ID 12696 //
     /* 1812336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1812347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1812350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1812353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1812356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812382 */     // MIs[0] policy
     /* 1812382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812392 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1812395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812416 */     // GIR_Coverage, 12696,
     /* 1812416 */     GIR_EraseRootFromParent_Done,
     /* 1812417 */   // Label 24560: @1812417
     /* 1812417 */   GIM_Try, /*On fail goto*//*Label 24561*/ GIMT_Encode4(1812503), // Rule ID 12697 //
     /* 1812422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1812433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1812436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1812439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1812442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812468 */     // MIs[0] policy
     /* 1812468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812478 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF8_MASK),
     /* 1812481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812502 */     // GIR_Coverage, 12697,
     /* 1812502 */     GIR_EraseRootFromParent_Done,
     /* 1812503 */   // Label 24561: @1812503
     /* 1812503 */   GIM_Try, /*On fail goto*//*Label 24562*/ GIMT_Encode4(1812589), // Rule ID 12700 //
     /* 1812508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1812519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1812522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1812525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1812528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812554 */     // MIs[0] policy
     /* 1812554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812564 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1812567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812588 */     // GIR_Coverage, 12700,
     /* 1812588 */     GIR_EraseRootFromParent_Done,
     /* 1812589 */   // Label 24562: @1812589
     /* 1812589 */   GIM_Try, /*On fail goto*//*Label 24563*/ GIMT_Encode4(1812675), // Rule ID 12701 //
     /* 1812594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1812605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1812608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1812611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1812614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1812617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812640 */     // MIs[0] policy
     /* 1812640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812650 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1812653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812674 */     // GIR_Coverage, 12701,
     /* 1812674 */     GIR_EraseRootFromParent_Done,
     /* 1812675 */   // Label 24563: @1812675
     /* 1812675 */   GIM_Try, /*On fail goto*//*Label 24564*/ GIMT_Encode4(1812761), // Rule ID 12704 //
     /* 1812680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1812691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1812694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1812697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1812700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812726 */     // MIs[0] policy
     /* 1812726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812736 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1812739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812760 */     // GIR_Coverage, 12704,
     /* 1812760 */     GIR_EraseRootFromParent_Done,
     /* 1812761 */   // Label 24564: @1812761
     /* 1812761 */   GIM_Try, /*On fail goto*//*Label 24565*/ GIMT_Encode4(1812847), // Rule ID 12705 //
     /* 1812766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1812777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1812780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1812783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1812786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1812789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812812 */     // MIs[0] policy
     /* 1812812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812822 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1812825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1812843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812846 */     // GIR_Coverage, 12705,
     /* 1812846 */     GIR_EraseRootFromParent_Done,
     /* 1812847 */   // Label 24565: @1812847
     /* 1812847 */   GIM_Try, /*On fail goto*//*Label 24566*/ GIMT_Encode4(1812933), // Rule ID 12708 //
     /* 1812852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1812855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1812869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1812872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1812878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812898 */     // MIs[0] policy
     /* 1812898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812908 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1812908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1812911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1812915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1812917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1812919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1812921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1812926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1812929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1812931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1812932 */     // GIR_Coverage, 12708,
     /* 1812932 */     GIR_EraseRootFromParent_Done,
     /* 1812933 */   // Label 24566: @1812933
     /* 1812933 */   GIM_Try, /*On fail goto*//*Label 24567*/ GIMT_Encode4(1813019), // Rule ID 12709 //
     /* 1812938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1812941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1812946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1812949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1812952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1812955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1812958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1812961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1812964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1812968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1812976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1812980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1812984 */     // MIs[0] policy
     /* 1812984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1812987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1812994 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1812994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF4_MASK),
     /* 1812997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1812999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813018 */     // GIR_Coverage, 12709,
     /* 1813018 */     GIR_EraseRootFromParent_Done,
     /* 1813019 */   // Label 24567: @1813019
     /* 1813019 */   GIM_Try, /*On fail goto*//*Label 24568*/ GIMT_Encode4(1813105), // Rule ID 12712 //
     /* 1813024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1813044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813070 */     // MIs[0] policy
     /* 1813070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813080 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1813083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813104 */     // GIR_Coverage, 12712,
     /* 1813104 */     GIR_EraseRootFromParent_Done,
     /* 1813105 */   // Label 24568: @1813105
     /* 1813105 */   GIM_Try, /*On fail goto*//*Label 24569*/ GIMT_Encode4(1813191), // Rule ID 12713 //
     /* 1813110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1813121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1813124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1813130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813156 */     // MIs[0] policy
     /* 1813156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813166 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1813169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813190 */     // GIR_Coverage, 12713,
     /* 1813190 */     GIR_EraseRootFromParent_Done,
     /* 1813191 */   // Label 24569: @1813191
     /* 1813191 */   GIM_Try, /*On fail goto*//*Label 24570*/ GIMT_Encode4(1813277), // Rule ID 12716 //
     /* 1813196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1813216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813242 */     // MIs[0] policy
     /* 1813242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813252 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1813255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813276 */     // GIR_Coverage, 12716,
     /* 1813276 */     GIR_EraseRootFromParent_Done,
     /* 1813277 */   // Label 24570: @1813277
     /* 1813277 */   GIM_Try, /*On fail goto*//*Label 24571*/ GIMT_Encode4(1813363), // Rule ID 12717 //
     /* 1813282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1813293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1813296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1813302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813328 */     // MIs[0] policy
     /* 1813328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_MF2_MASK),
     /* 1813341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813362 */     // GIR_Coverage, 12717,
     /* 1813362 */     GIR_EraseRootFromParent_Done,
     /* 1813363 */   // Label 24571: @1813363
     /* 1813363 */   GIM_Try, /*On fail goto*//*Label 24572*/ GIMT_Encode4(1813449), // Rule ID 12720 //
     /* 1813368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1813379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1813382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1813388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813414 */     // MIs[0] policy
     /* 1813414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813424 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813448 */     // GIR_Coverage, 12720,
     /* 1813448 */     GIR_EraseRootFromParent_Done,
     /* 1813449 */   // Label 24572: @1813449
     /* 1813449 */   GIM_Try, /*On fail goto*//*Label 24573*/ GIMT_Encode4(1813535), // Rule ID 12721 //
     /* 1813454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1813465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1813468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1813474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1813477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813500 */     // MIs[0] policy
     /* 1813500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813510 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11342:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1813531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813534 */     // GIR_Coverage, 12721,
     /* 1813534 */     GIR_EraseRootFromParent_Done,
     /* 1813535 */   // Label 24573: @1813535
     /* 1813535 */   GIM_Try, /*On fail goto*//*Label 24574*/ GIMT_Encode4(1813621), // Rule ID 12724 //
     /* 1813540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1813560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813586 */     // MIs[0] policy
     /* 1813586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813596 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813620 */     // GIR_Coverage, 12724,
     /* 1813620 */     GIR_EraseRootFromParent_Done,
     /* 1813621 */   // Label 24574: @1813621
     /* 1813621 */   GIM_Try, /*On fail goto*//*Label 24575*/ GIMT_Encode4(1813707), // Rule ID 12725 //
     /* 1813626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1813637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1813640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1813646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1813649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813672 */     // MIs[0] policy
     /* 1813672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11342:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1813703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813706 */     // GIR_Coverage, 12725,
     /* 1813706 */     GIR_EraseRootFromParent_Done,
     /* 1813707 */   // Label 24575: @1813707
     /* 1813707 */   GIM_Try, /*On fail goto*//*Label 24576*/ GIMT_Encode4(1813793), // Rule ID 12728 //
     /* 1813712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1813715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1813732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813758 */     // MIs[0] policy
     /* 1813758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813768 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813792 */     // GIR_Coverage, 12728,
     /* 1813792 */     GIR_EraseRootFromParent_Done,
     /* 1813793 */   // Label 24576: @1813793
     /* 1813793 */   GIM_Try, /*On fail goto*//*Label 24577*/ GIMT_Encode4(1813879), // Rule ID 12729 //
     /* 1813798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1813801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1813809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1813812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1813818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1813821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813844 */     // MIs[0] policy
     /* 1813844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11342:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1813854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1813875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813878 */     // GIR_Coverage, 12729,
     /* 1813878 */     GIR_EraseRootFromParent_Done,
     /* 1813879 */   // Label 24577: @1813879
     /* 1813879 */   GIM_Try, /*On fail goto*//*Label 24578*/ GIMT_Encode4(1813965), // Rule ID 12732 //
     /* 1813884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1813887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1813901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1813904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1813910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1813914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1813922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1813926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1813930 */     // MIs[0] policy
     /* 1813930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1813933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1813940 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1813940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1813943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1813945 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1813947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1813949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1813951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1813953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1813958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1813961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1813963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1813964 */     // GIR_Coverage, 12732,
     /* 1813964 */     GIR_EraseRootFromParent_Done,
     /* 1813965 */   // Label 24578: @1813965
     /* 1813965 */   GIM_Try, /*On fail goto*//*Label 24579*/ GIMT_Encode4(1814051), // Rule ID 12733 //
     /* 1813970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1813973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1813978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1813981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1813984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1813987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1813990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1813993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1813996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1814000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1814012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814016 */     // MIs[0] policy
     /* 1814016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814026 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11342:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M1_MASK),
     /* 1814029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1814047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814050 */     // GIR_Coverage, 12733,
     /* 1814050 */     GIR_EraseRootFromParent_Done,
     /* 1814051 */   // Label 24579: @1814051
     /* 1814051 */   GIM_Try, /*On fail goto*//*Label 24580*/ GIMT_Encode4(1814137), // Rule ID 12736 //
     /* 1814056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1814067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1814070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814102 */     // MIs[0] policy
     /* 1814102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814112 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1814115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814136 */     // GIR_Coverage, 12736,
     /* 1814136 */     GIR_EraseRootFromParent_Done,
     /* 1814137 */   // Label 24580: @1814137
     /* 1814137 */   GIM_Try, /*On fail goto*//*Label 24581*/ GIMT_Encode4(1814223), // Rule ID 12737 //
     /* 1814142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1814153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1814156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1814159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1814162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814188 */     // MIs[0] policy
     /* 1814188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814198 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1814201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814222 */     // GIR_Coverage, 12737,
     /* 1814222 */     GIR_EraseRootFromParent_Done,
     /* 1814223 */   // Label 24581: @1814223
     /* 1814223 */   GIM_Try, /*On fail goto*//*Label 24582*/ GIMT_Encode4(1814309), // Rule ID 12740 //
     /* 1814228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1814239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1814242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814274 */     // MIs[0] policy
     /* 1814274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814284 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1814287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814308 */     // GIR_Coverage, 12740,
     /* 1814308 */     GIR_EraseRootFromParent_Done,
     /* 1814309 */   // Label 24582: @1814309
     /* 1814309 */   GIM_Try, /*On fail goto*//*Label 24583*/ GIMT_Encode4(1814395), // Rule ID 12741 //
     /* 1814314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1814325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1814328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1814331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1814334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814360 */     // MIs[0] policy
     /* 1814360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814370 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1814373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814375 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814394 */     // GIR_Coverage, 12741,
     /* 1814394 */     GIR_EraseRootFromParent_Done,
     /* 1814395 */   // Label 24583: @1814395
     /* 1814395 */   GIM_Try, /*On fail goto*//*Label 24584*/ GIMT_Encode4(1814481), // Rule ID 12744 //
     /* 1814400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1814411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1814414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1814420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1814423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814446 */     // MIs[0] policy
     /* 1814446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814456 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1814459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814480 */     // GIR_Coverage, 12744,
     /* 1814480 */     GIR_EraseRootFromParent_Done,
     /* 1814481 */   // Label 24584: @1814481
     /* 1814481 */   GIM_Try, /*On fail goto*//*Label 24585*/ GIMT_Encode4(1814567), // Rule ID 12745 //
     /* 1814486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1814497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1814500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1814503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1814506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1814509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814532 */     // MIs[0] policy
     /* 1814532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814542 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1814545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1814563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814566 */     // GIR_Coverage, 12745,
     /* 1814566 */     GIR_EraseRootFromParent_Done,
     /* 1814567 */   // Label 24585: @1814567
     /* 1814567 */   GIM_Try, /*On fail goto*//*Label 24586*/ GIMT_Encode4(1814653), // Rule ID 12748 //
     /* 1814572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1814583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1814586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1814592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814618 */     // MIs[0] policy
     /* 1814618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1814631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814652 */     // GIR_Coverage, 12748,
     /* 1814652 */     GIR_EraseRootFromParent_Done,
     /* 1814653 */   // Label 24586: @1814653
     /* 1814653 */   GIM_Try, /*On fail goto*//*Label 24587*/ GIMT_Encode4(1814739), // Rule ID 12749 //
     /* 1814658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1814669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1814672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1814675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1814678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1814681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1814688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1814700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814704 */     // MIs[0] policy
     /* 1814704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814714 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1814717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814738 */     // GIR_Coverage, 12749,
     /* 1814738 */     GIR_EraseRootFromParent_Done,
     /* 1814739 */   // Label 24587: @1814739
     /* 1814739 */   GIM_Try, /*On fail goto*//*Label 24588*/ GIMT_Encode4(1814825), // Rule ID 12752 //
     /* 1814744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1814755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1814758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1814764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814790 */     // MIs[0] policy
     /* 1814790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814800 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1814803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814824 */     // GIR_Coverage, 12752,
     /* 1814824 */     GIR_EraseRootFromParent_Done,
     /* 1814825 */   // Label 24588: @1814825
     /* 1814825 */   GIM_Try, /*On fail goto*//*Label 24589*/ GIMT_Encode4(1814911), // Rule ID 12753 //
     /* 1814830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1814833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1814841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1814844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1814847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1814850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1814853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1814856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1814860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1814872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814876 */     // MIs[0] policy
     /* 1814876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814886 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1814886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1814889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814910 */     // GIR_Coverage, 12753,
     /* 1814910 */     GIR_EraseRootFromParent_Done,
     /* 1814911 */   // Label 24589: @1814911
     /* 1814911 */   GIM_Try, /*On fail goto*//*Label 24590*/ GIMT_Encode4(1814997), // Rule ID 12756 //
     /* 1814916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1814919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1814924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1814927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1814930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1814933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1814936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1814939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1814942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1814946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1814954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1814958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1814962 */     // MIs[0] policy
     /* 1814962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1814965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1814972 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1814972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1814975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1814977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1814979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1814981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1814983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1814985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1814990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1814993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1814995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1814996 */     // GIR_Coverage, 12756,
     /* 1814996 */     GIR_EraseRootFromParent_Done,
     /* 1814997 */   // Label 24590: @1814997
     /* 1814997 */   GIM_Try, /*On fail goto*//*Label 24591*/ GIMT_Encode4(1815083), // Rule ID 12757 //
     /* 1815002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1815013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1815016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1815022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1815025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815048 */     // MIs[0] policy
     /* 1815048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815058 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1815061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1815079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815082 */     // GIR_Coverage, 12757,
     /* 1815082 */     GIR_EraseRootFromParent_Done,
     /* 1815083 */   // Label 24591: @1815083
     /* 1815083 */   GIM_Try, /*On fail goto*//*Label 24592*/ GIMT_Encode4(1815169), // Rule ID 12760 //
     /* 1815088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1815108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815134 */     // MIs[0] policy
     /* 1815134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815144 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1815147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815168 */     // GIR_Coverage, 12760,
     /* 1815168 */     GIR_EraseRootFromParent_Done,
     /* 1815169 */   // Label 24592: @1815169
     /* 1815169 */   GIM_Try, /*On fail goto*//*Label 24593*/ GIMT_Encode4(1815255), // Rule ID 12761 //
     /* 1815174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1815185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1815188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1815194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815220 */     // MIs[0] policy
     /* 1815220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815230 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1815233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815254 */     // GIR_Coverage, 12761,
     /* 1815254 */     GIR_EraseRootFromParent_Done,
     /* 1815255 */   // Label 24593: @1815255
     /* 1815255 */   GIM_Try, /*On fail goto*//*Label 24594*/ GIMT_Encode4(1815341), // Rule ID 12764 //
     /* 1815260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1815280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815306 */     // MIs[0] policy
     /* 1815306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815316 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1815319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815340 */     // GIR_Coverage, 12764,
     /* 1815340 */     GIR_EraseRootFromParent_Done,
     /* 1815341 */   // Label 24594: @1815341
     /* 1815341 */   GIM_Try, /*On fail goto*//*Label 24595*/ GIMT_Encode4(1815427), // Rule ID 12765 //
     /* 1815346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1815357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1815360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1815366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815392 */     // MIs[0] policy
     /* 1815392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815402 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1815405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815426 */     // GIR_Coverage, 12765,
     /* 1815426 */     GIR_EraseRootFromParent_Done,
     /* 1815427 */   // Label 24595: @1815427
     /* 1815427 */   GIM_Try, /*On fail goto*//*Label 24596*/ GIMT_Encode4(1815513), // Rule ID 12768 //
     /* 1815432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1815435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1815452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815478 */     // MIs[0] policy
     /* 1815478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815488 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1815491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815512 */     // GIR_Coverage, 12768,
     /* 1815512 */     GIR_EraseRootFromParent_Done,
     /* 1815513 */   // Label 24596: @1815513
     /* 1815513 */   GIM_Try, /*On fail goto*//*Label 24597*/ GIMT_Encode4(1815599), // Rule ID 12769 //
     /* 1815518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1815521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1815529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1815532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1815538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1815541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815564 */     // MIs[0] policy
     /* 1815564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815574 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1815577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1815595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815598 */     // GIR_Coverage, 12769,
     /* 1815598 */     GIR_EraseRootFromParent_Done,
     /* 1815599 */   // Label 24597: @1815599
     /* 1815599 */   GIM_Try, /*On fail goto*//*Label 24598*/ GIMT_Encode4(1815685), // Rule ID 12772 //
     /* 1815604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1815607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1815624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815650 */     // MIs[0] policy
     /* 1815650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1815663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815684 */     // GIR_Coverage, 12772,
     /* 1815684 */     GIR_EraseRootFromParent_Done,
     /* 1815685 */   // Label 24598: @1815685
     /* 1815685 */   GIM_Try, /*On fail goto*//*Label 24599*/ GIMT_Encode4(1815771), // Rule ID 12773 //
     /* 1815690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1815693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1815701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1815704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1815710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1815713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1815720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1815732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815736 */     // MIs[0] policy
     /* 1815736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815746 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11342:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M2_MASK),
     /* 1815749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815770 */     // GIR_Coverage, 12773,
     /* 1815770 */     GIR_EraseRootFromParent_Done,
     /* 1815771 */   // Label 24599: @1815771
     /* 1815771 */   GIM_Try, /*On fail goto*//*Label 24600*/ GIMT_Encode4(1815857), // Rule ID 12776 //
     /* 1815776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1815779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1815796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815822 */     // MIs[0] policy
     /* 1815822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815832 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1815832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1815835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815856 */     // GIR_Coverage, 12776,
     /* 1815856 */     GIR_EraseRootFromParent_Done,
     /* 1815857 */   // Label 24600: @1815857
     /* 1815857 */   GIM_Try, /*On fail goto*//*Label 24601*/ GIMT_Encode4(1815943), // Rule ID 12777 //
     /* 1815862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1815865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1815873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1815876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1815879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1815882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1815885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1815888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1815892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1815904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815908 */     // MIs[0] policy
     /* 1815908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1815918 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11342:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1815918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M4_MASK),
     /* 1815921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1815923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1815925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1815927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1815929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1815931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1815936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1815939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1815941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1815942 */     // GIR_Coverage, 12777,
     /* 1815942 */     GIR_EraseRootFromParent_Done,
     /* 1815943 */   // Label 24601: @1815943
     /* 1815943 */   GIM_Try, /*On fail goto*//*Label 24602*/ GIMT_Encode4(1816029), // Rule ID 12780 //
     /* 1815948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1815951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1815956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1815959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1815962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1815965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1815968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1815971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1815974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1815978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1815986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1815990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1815994 */     // MIs[0] policy
     /* 1815994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1815997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816004 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1816007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816028 */     // GIR_Coverage, 12780,
     /* 1816028 */     GIR_EraseRootFromParent_Done,
     /* 1816029 */   // Label 24602: @1816029
     /* 1816029 */   GIM_Try, /*On fail goto*//*Label 24603*/ GIMT_Encode4(1816115), // Rule ID 12781 //
     /* 1816034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1816037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmadd_mask),
     /* 1816042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1816045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1816048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1816051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1816054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1816057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1816064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1816072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1816076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816080 */     // MIs[0] policy
     /* 1816080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11342:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMADD_VX_M8_MASK),
     /* 1816093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1816111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816114 */     // GIR_Coverage, 12781,
     /* 1816114 */     GIR_EraseRootFromParent_Done,
     /* 1816115 */   // Label 24603: @1816115
     /* 1816115 */   GIM_Try, /*On fail goto*//*Label 24604*/ GIMT_Encode4(1816201), // Rule ID 12784 //
     /* 1816120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1816131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1816134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1816137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1816140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816166 */     // MIs[0] policy
     /* 1816166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816176 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1816179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816200 */     // GIR_Coverage, 12784,
     /* 1816200 */     GIR_EraseRootFromParent_Done,
     /* 1816201 */   // Label 24604: @1816201
     /* 1816201 */   GIM_Try, /*On fail goto*//*Label 24605*/ GIMT_Encode4(1816287), // Rule ID 12785 //
     /* 1816206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1816217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1816220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1816223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1816226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816252 */     // MIs[0] policy
     /* 1816252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816262 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF8_MASK),
     /* 1816265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816286 */     // GIR_Coverage, 12785,
     /* 1816286 */     GIR_EraseRootFromParent_Done,
     /* 1816287 */   // Label 24605: @1816287
     /* 1816287 */   GIM_Try, /*On fail goto*//*Label 24606*/ GIMT_Encode4(1816373), // Rule ID 12788 //
     /* 1816292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1816303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1816306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1816309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1816312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816338 */     // MIs[0] policy
     /* 1816338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816348 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1816351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816372 */     // GIR_Coverage, 12788,
     /* 1816372 */     GIR_EraseRootFromParent_Done,
     /* 1816373 */   // Label 24606: @1816373
     /* 1816373 */   GIM_Try, /*On fail goto*//*Label 24607*/ GIMT_Encode4(1816459), // Rule ID 12789 //
     /* 1816378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1816389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1816392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1816395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1816398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816424 */     // MIs[0] policy
     /* 1816424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1816437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816458 */     // GIR_Coverage, 12789,
     /* 1816458 */     GIR_EraseRootFromParent_Done,
     /* 1816459 */   // Label 24607: @1816459
     /* 1816459 */   GIM_Try, /*On fail goto*//*Label 24608*/ GIMT_Encode4(1816545), // Rule ID 12792 //
     /* 1816464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1816475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1816478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1816481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1816484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816510 */     // MIs[0] policy
     /* 1816510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816520 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1816523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816544 */     // GIR_Coverage, 12792,
     /* 1816544 */     GIR_EraseRootFromParent_Done,
     /* 1816545 */   // Label 24608: @1816545
     /* 1816545 */   GIM_Try, /*On fail goto*//*Label 24609*/ GIMT_Encode4(1816631), // Rule ID 12793 //
     /* 1816550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1816561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1816564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1816567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1816570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1816573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816596 */     // MIs[0] policy
     /* 1816596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816606 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1816609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1816627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816630 */     // GIR_Coverage, 12793,
     /* 1816630 */     GIR_EraseRootFromParent_Done,
     /* 1816631 */   // Label 24609: @1816631
     /* 1816631 */   GIM_Try, /*On fail goto*//*Label 24610*/ GIMT_Encode4(1816717), // Rule ID 12796 //
     /* 1816636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816682 */     // MIs[0] policy
     /* 1816682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816692 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1816695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816716 */     // GIR_Coverage, 12796,
     /* 1816716 */     GIR_EraseRootFromParent_Done,
     /* 1816717 */   // Label 24610: @1816717
     /* 1816717 */   GIM_Try, /*On fail goto*//*Label 24611*/ GIMT_Encode4(1816803), // Rule ID 12797 //
     /* 1816722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1816733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1816736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1816739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1816742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1816745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816768 */     // MIs[0] policy
     /* 1816768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816778 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF4_MASK),
     /* 1816781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816802 */     // GIR_Coverage, 12797,
     /* 1816802 */     GIR_EraseRootFromParent_Done,
     /* 1816803 */   // Label 24611: @1816803
     /* 1816803 */   GIM_Try, /*On fail goto*//*Label 24612*/ GIMT_Encode4(1816889), // Rule ID 12800 //
     /* 1816808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1816834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816854 */     // MIs[0] policy
     /* 1816854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1816864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1816867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816888 */     // GIR_Coverage, 12800,
     /* 1816888 */     GIR_EraseRootFromParent_Done,
     /* 1816889 */   // Label 24612: @1816889
     /* 1816889 */   GIM_Try, /*On fail goto*//*Label 24613*/ GIMT_Encode4(1816975), // Rule ID 12801 //
     /* 1816894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1816897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1816905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1816908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1816911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1816914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1816917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1816920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1816924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1816936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1816940 */     // MIs[0] policy
     /* 1816940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1816943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1816950 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1816950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1816953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1816955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1816957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1816959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1816961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1816963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1816968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1816971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1816973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1816974 */     // GIR_Coverage, 12801,
     /* 1816974 */     GIR_EraseRootFromParent_Done,
     /* 1816975 */   // Label 24613: @1816975
     /* 1816975 */   GIM_Try, /*On fail goto*//*Label 24614*/ GIMT_Encode4(1817061), // Rule ID 12804 //
     /* 1816980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1816983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1816988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1816991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1816994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1816997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1817000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817026 */     // MIs[0] policy
     /* 1817026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817036 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1817039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817041 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817060 */     // GIR_Coverage, 12804,
     /* 1817060 */     GIR_EraseRootFromParent_Done,
     /* 1817061 */   // Label 24614: @1817061
     /* 1817061 */   GIM_Try, /*On fail goto*//*Label 24615*/ GIMT_Encode4(1817147), // Rule ID 12805 //
     /* 1817066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1817077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1817080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1817083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1817086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817112 */     // MIs[0] policy
     /* 1817112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817122 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_MF2_MASK),
     /* 1817125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817146 */     // GIR_Coverage, 12805,
     /* 1817146 */     GIR_EraseRootFromParent_Done,
     /* 1817147 */   // Label 24615: @1817147
     /* 1817147 */   GIM_Try, /*On fail goto*//*Label 24616*/ GIMT_Encode4(1817233), // Rule ID 12808 //
     /* 1817152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1817163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1817166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1817169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1817172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817198 */     // MIs[0] policy
     /* 1817198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817208 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817232 */     // GIR_Coverage, 12808,
     /* 1817232 */     GIR_EraseRootFromParent_Done,
     /* 1817233 */   // Label 24616: @1817233
     /* 1817233 */   GIM_Try, /*On fail goto*//*Label 24617*/ GIMT_Encode4(1817319), // Rule ID 12809 //
     /* 1817238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1817249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1817252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1817255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1817258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1817261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817284 */     // MIs[0] policy
     /* 1817284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817294 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817318 */     // GIR_Coverage, 12809,
     /* 1817318 */     GIR_EraseRootFromParent_Done,
     /* 1817319 */   // Label 24617: @1817319
     /* 1817319 */   GIM_Try, /*On fail goto*//*Label 24618*/ GIMT_Encode4(1817405), // Rule ID 12812 //
     /* 1817324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1817335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1817338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1817341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1817344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817370 */     // MIs[0] policy
     /* 1817370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817380 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817404 */     // GIR_Coverage, 12812,
     /* 1817404 */     GIR_EraseRootFromParent_Done,
     /* 1817405 */   // Label 24618: @1817405
     /* 1817405 */   GIM_Try, /*On fail goto*//*Label 24619*/ GIMT_Encode4(1817491), // Rule ID 12813 //
     /* 1817410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1817421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1817424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1817427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1817430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1817433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817456 */     // MIs[0] policy
     /* 1817456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817466 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1817487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817490 */     // GIR_Coverage, 12813,
     /* 1817490 */     GIR_EraseRootFromParent_Done,
     /* 1817491 */   // Label 24619: @1817491
     /* 1817491 */   GIM_Try, /*On fail goto*//*Label 24620*/ GIMT_Encode4(1817577), // Rule ID 12816 //
     /* 1817496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1817513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817542 */     // MIs[0] policy
     /* 1817542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817552 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817576 */     // GIR_Coverage, 12816,
     /* 1817576 */     GIR_EraseRootFromParent_Done,
     /* 1817577 */   // Label 24620: @1817577
     /* 1817577 */   GIM_Try, /*On fail goto*//*Label 24621*/ GIMT_Encode4(1817663), // Rule ID 12817 //
     /* 1817582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1817593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1817596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1817599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1817602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1817605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817628 */     // MIs[0] policy
     /* 1817628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817638 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1817659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817662 */     // GIR_Coverage, 12817,
     /* 1817662 */     GIR_EraseRootFromParent_Done,
     /* 1817663 */   // Label 24621: @1817663
     /* 1817663 */   GIM_Try, /*On fail goto*//*Label 24622*/ GIMT_Encode4(1817749), // Rule ID 12820 //
     /* 1817668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1817671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817714 */     // MIs[0] policy
     /* 1817714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817724 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817748 */     // GIR_Coverage, 12820,
     /* 1817748 */     GIR_EraseRootFromParent_Done,
     /* 1817749 */   // Label 24622: @1817749
     /* 1817749 */   GIM_Try, /*On fail goto*//*Label 24623*/ GIMT_Encode4(1817835), // Rule ID 12821 //
     /* 1817754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1817757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1817765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1817768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1817771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1817774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1817777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1817784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1817796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817800 */     // MIs[0] policy
     /* 1817800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817810 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M1_MASK),
     /* 1817813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1817831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817834 */     // GIR_Coverage, 12821,
     /* 1817834 */     GIR_EraseRootFromParent_Done,
     /* 1817835 */   // Label 24623: @1817835
     /* 1817835 */   GIM_Try, /*On fail goto*//*Label 24624*/ GIMT_Encode4(1817921), // Rule ID 12824 //
     /* 1817840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1817843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1817866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817886 */     // MIs[0] policy
     /* 1817886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817896 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1817896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1817899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1817914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1817917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1817919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1817920 */     // GIR_Coverage, 12824,
     /* 1817920 */     GIR_EraseRootFromParent_Done,
     /* 1817921 */   // Label 24624: @1817921
     /* 1817921 */   GIM_Try, /*On fail goto*//*Label 24625*/ GIMT_Encode4(1818007), // Rule ID 12825 //
     /* 1817926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1817929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1817934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1817937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1817940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1817943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1817946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1817949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1817952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1817956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1817968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1817972 */     // MIs[0] policy
     /* 1817972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1817975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1817982 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1817982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1817985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1817987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1817989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1817991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1817993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1817995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818006 */     // GIR_Coverage, 12825,
     /* 1818006 */     GIR_EraseRootFromParent_Done,
     /* 1818007 */   // Label 24625: @1818007
     /* 1818007 */   GIM_Try, /*On fail goto*//*Label 24626*/ GIMT_Encode4(1818093), // Rule ID 12828 //
     /* 1818012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1818023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1818026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1818029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1818032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818058 */     // MIs[0] policy
     /* 1818058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818068 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1818071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818092 */     // GIR_Coverage, 12828,
     /* 1818092 */     GIR_EraseRootFromParent_Done,
     /* 1818093 */   // Label 24626: @1818093
     /* 1818093 */   GIM_Try, /*On fail goto*//*Label 24627*/ GIMT_Encode4(1818179), // Rule ID 12829 //
     /* 1818098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1818109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1818112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1818115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1818118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818144 */     // MIs[0] policy
     /* 1818144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818154 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1818157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818178 */     // GIR_Coverage, 12829,
     /* 1818178 */     GIR_EraseRootFromParent_Done,
     /* 1818179 */   // Label 24627: @1818179
     /* 1818179 */   GIM_Try, /*On fail goto*//*Label 24628*/ GIMT_Encode4(1818265), // Rule ID 12832 //
     /* 1818184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1818195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1818198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1818201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1818204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1818207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818230 */     // MIs[0] policy
     /* 1818230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818240 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1818243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818264 */     // GIR_Coverage, 12832,
     /* 1818264 */     GIR_EraseRootFromParent_Done,
     /* 1818265 */   // Label 24628: @1818265
     /* 1818265 */   GIM_Try, /*On fail goto*//*Label 24629*/ GIMT_Encode4(1818351), // Rule ID 12833 //
     /* 1818270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1818281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1818284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1818287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1818290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1818293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818316 */     // MIs[0] policy
     /* 1818316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818326 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1818329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1818347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818350 */     // GIR_Coverage, 12833,
     /* 1818350 */     GIR_EraseRootFromParent_Done,
     /* 1818351 */   // Label 24629: @1818351
     /* 1818351 */   GIM_Try, /*On fail goto*//*Label 24630*/ GIMT_Encode4(1818437), // Rule ID 12836 //
     /* 1818356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1818367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1818370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1818376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818402 */     // MIs[0] policy
     /* 1818402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818412 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1818415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818436 */     // GIR_Coverage, 12836,
     /* 1818436 */     GIR_EraseRootFromParent_Done,
     /* 1818437 */   // Label 24630: @1818437
     /* 1818437 */   GIM_Try, /*On fail goto*//*Label 24631*/ GIMT_Encode4(1818523), // Rule ID 12837 //
     /* 1818442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1818453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1818456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1818459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1818462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1818465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818488 */     // MIs[0] policy
     /* 1818488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1818501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818522 */     // GIR_Coverage, 12837,
     /* 1818522 */     GIR_EraseRootFromParent_Done,
     /* 1818523 */   // Label 24631: @1818523
     /* 1818523 */   GIM_Try, /*On fail goto*//*Label 24632*/ GIMT_Encode4(1818609), // Rule ID 12840 //
     /* 1818528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818574 */     // MIs[0] policy
     /* 1818574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1818587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818608 */     // GIR_Coverage, 12840,
     /* 1818608 */     GIR_EraseRootFromParent_Done,
     /* 1818609 */   // Label 24632: @1818609
     /* 1818609 */   GIM_Try, /*On fail goto*//*Label 24633*/ GIMT_Encode4(1818695), // Rule ID 12841 //
     /* 1818614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1818625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1818628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1818631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1818634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1818637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1818644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1818656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818660 */     // MIs[0] policy
     /* 1818660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818670 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1818673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818694 */     // GIR_Coverage, 12841,
     /* 1818694 */     GIR_EraseRootFromParent_Done,
     /* 1818695 */   // Label 24633: @1818695
     /* 1818695 */   GIM_Try, /*On fail goto*//*Label 24634*/ GIMT_Encode4(1818781), // Rule ID 12844 //
     /* 1818700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818746 */     // MIs[0] policy
     /* 1818746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818756 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1818759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818780 */     // GIR_Coverage, 12844,
     /* 1818780 */     GIR_EraseRootFromParent_Done,
     /* 1818781 */   // Label 24634: @1818781
     /* 1818781 */   GIM_Try, /*On fail goto*//*Label 24635*/ GIMT_Encode4(1818867), // Rule ID 12845 //
     /* 1818786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1818797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1818800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1818803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1818806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1818809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1818816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1818828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818832 */     // MIs[0] policy
     /* 1818832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818842 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1818842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1818845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1818863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818866 */     // GIR_Coverage, 12845,
     /* 1818866 */     GIR_EraseRootFromParent_Done,
     /* 1818867 */   // Label 24635: @1818867
     /* 1818867 */   GIM_Try, /*On fail goto*//*Label 24636*/ GIMT_Encode4(1818953), // Rule ID 12848 //
     /* 1818872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1818875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1818898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1818918 */     // MIs[0] policy
     /* 1818918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1818921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1818928 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1818928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1818931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1818933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1818935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1818937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1818939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1818941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1818946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1818949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1818951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1818952 */     // GIR_Coverage, 12848,
     /* 1818952 */     GIR_EraseRootFromParent_Done,
     /* 1818953 */   // Label 24636: @1818953
     /* 1818953 */   GIM_Try, /*On fail goto*//*Label 24637*/ GIMT_Encode4(1819039), // Rule ID 12849 //
     /* 1818958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1818961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1818966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1818969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1818972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1818975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1818978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1818981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1818984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1818988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1818996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819004 */     // MIs[0] policy
     /* 1819004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819014 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1819017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819038 */     // GIR_Coverage, 12849,
     /* 1819038 */     GIR_EraseRootFromParent_Done,
     /* 1819039 */   // Label 24637: @1819039
     /* 1819039 */   GIM_Try, /*On fail goto*//*Label 24638*/ GIMT_Encode4(1819125), // Rule ID 12852 //
     /* 1819044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1819061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1819064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819090 */     // MIs[0] policy
     /* 1819090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819100 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1819103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819124 */     // GIR_Coverage, 12852,
     /* 1819124 */     GIR_EraseRootFromParent_Done,
     /* 1819125 */   // Label 24638: @1819125
     /* 1819125 */   GIM_Try, /*On fail goto*//*Label 24639*/ GIMT_Encode4(1819211), // Rule ID 12853 //
     /* 1819130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1819141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1819144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1819147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1819150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819176 */     // MIs[0] policy
     /* 1819176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819186 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1819189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819210 */     // GIR_Coverage, 12853,
     /* 1819210 */     GIR_EraseRootFromParent_Done,
     /* 1819211 */   // Label 24639: @1819211
     /* 1819211 */   GIM_Try, /*On fail goto*//*Label 24640*/ GIMT_Encode4(1819297), // Rule ID 12856 //
     /* 1819216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1819233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1819236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819262 */     // MIs[0] policy
     /* 1819262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819272 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1819275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819296 */     // GIR_Coverage, 12856,
     /* 1819296 */     GIR_EraseRootFromParent_Done,
     /* 1819297 */   // Label 24640: @1819297
     /* 1819297 */   GIM_Try, /*On fail goto*//*Label 24641*/ GIMT_Encode4(1819383), // Rule ID 12857 //
     /* 1819302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1819313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1819316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1819319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1819322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1819325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819348 */     // MIs[0] policy
     /* 1819348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819358 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1819361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1819379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819382 */     // GIR_Coverage, 12857,
     /* 1819382 */     GIR_EraseRootFromParent_Done,
     /* 1819383 */   // Label 24641: @1819383
     /* 1819383 */   GIM_Try, /*On fail goto*//*Label 24642*/ GIMT_Encode4(1819469), // Rule ID 12860 //
     /* 1819388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1819399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1819402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1819405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1819408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819434 */     // MIs[0] policy
     /* 1819434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1819447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819468 */     // GIR_Coverage, 12860,
     /* 1819468 */     GIR_EraseRootFromParent_Done,
     /* 1819469 */   // Label 24642: @1819469
     /* 1819469 */   GIM_Try, /*On fail goto*//*Label 24643*/ GIMT_Encode4(1819555), // Rule ID 12861 //
     /* 1819474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1819485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1819488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1819491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1819494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1819497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1819504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1819516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819520 */     // MIs[0] policy
     /* 1819520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M2_MASK),
     /* 1819533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819554 */     // GIR_Coverage, 12861,
     /* 1819554 */     GIR_EraseRootFromParent_Done,
     /* 1819555 */   // Label 24643: @1819555
     /* 1819555 */   GIM_Try, /*On fail goto*//*Label 24644*/ GIMT_Encode4(1819641), // Rule ID 12864 //
     /* 1819560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819606 */     // MIs[0] policy
     /* 1819606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819616 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1819619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819640 */     // GIR_Coverage, 12864,
     /* 1819640 */     GIR_EraseRootFromParent_Done,
     /* 1819641 */   // Label 24644: @1819641
     /* 1819641 */   GIM_Try, /*On fail goto*//*Label 24645*/ GIMT_Encode4(1819727), // Rule ID 12865 //
     /* 1819646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1819657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1819660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1819663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1819666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1819669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1819676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1819688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819692 */     // MIs[0] policy
     /* 1819692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819702 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M4_MASK),
     /* 1819705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819726 */     // GIR_Coverage, 12865,
     /* 1819726 */     GIR_EraseRootFromParent_Done,
     /* 1819727 */   // Label 24645: @1819727
     /* 1819727 */   GIM_Try, /*On fail goto*//*Label 24646*/ GIMT_Encode4(1819813), // Rule ID 12868 //
     /* 1819732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1819735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819778 */     // MIs[0] policy
     /* 1819778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819788 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1819791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819812 */     // GIR_Coverage, 12868,
     /* 1819812 */     GIR_EraseRootFromParent_Done,
     /* 1819813 */   // Label 24646: @1819813
     /* 1819813 */   GIM_Try, /*On fail goto*//*Label 24647*/ GIMT_Encode4(1819899), // Rule ID 12869 //
     /* 1819818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1819821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1819829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1819832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1819835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1819838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1819841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1819844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1819848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1819860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819864 */     // MIs[0] policy
     /* 1819864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819874 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1819874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VV_M8_MASK),
     /* 1819877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1819895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819898 */     // GIR_Coverage, 12869,
     /* 1819898 */     GIR_EraseRootFromParent_Done,
     /* 1819899 */   // Label 24647: @1819899
     /* 1819899 */   GIM_Try, /*On fail goto*//*Label 24648*/ GIMT_Encode4(1819985), // Rule ID 12872 //
     /* 1819904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1819907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1819915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1819918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1819921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1819924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1819927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1819930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1819934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1819942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1819946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1819950 */     // MIs[0] policy
     /* 1819950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1819953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1819960 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1819960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1819963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1819965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1819967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1819969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1819971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1819973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1819978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1819981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1819983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1819984 */     // GIR_Coverage, 12872,
     /* 1819984 */     GIR_EraseRootFromParent_Done,
     /* 1819985 */   // Label 24648: @1819985
     /* 1819985 */   GIM_Try, /*On fail goto*//*Label 24649*/ GIMT_Encode4(1820071), // Rule ID 12873 //
     /* 1819990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1819993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1819998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1820001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1820004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1820010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820036 */     // MIs[0] policy
     /* 1820036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820046 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF8_MASK),
     /* 1820049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820070 */     // GIR_Coverage, 12873,
     /* 1820070 */     GIR_EraseRootFromParent_Done,
     /* 1820071 */   // Label 24649: @1820071
     /* 1820071 */   GIM_Try, /*On fail goto*//*Label 24650*/ GIMT_Encode4(1820157), // Rule ID 12876 //
     /* 1820076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1820096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820122 */     // MIs[0] policy
     /* 1820122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820132 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1820135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820156 */     // GIR_Coverage, 12876,
     /* 1820156 */     GIR_EraseRootFromParent_Done,
     /* 1820157 */   // Label 24650: @1820157
     /* 1820157 */   GIM_Try, /*On fail goto*//*Label 24651*/ GIMT_Encode4(1820243), // Rule ID 12877 //
     /* 1820162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1820173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1820176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1820182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820208 */     // MIs[0] policy
     /* 1820208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820218 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1820221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820242 */     // GIR_Coverage, 12877,
     /* 1820242 */     GIR_EraseRootFromParent_Done,
     /* 1820243 */   // Label 24651: @1820243
     /* 1820243 */   GIM_Try, /*On fail goto*//*Label 24652*/ GIMT_Encode4(1820329), // Rule ID 12880 //
     /* 1820248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1820268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820294 */     // MIs[0] policy
     /* 1820294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820304 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820328 */     // GIR_Coverage, 12880,
     /* 1820328 */     GIR_EraseRootFromParent_Done,
     /* 1820329 */   // Label 24652: @1820329
     /* 1820329 */   GIM_Try, /*On fail goto*//*Label 24653*/ GIMT_Encode4(1820415), // Rule ID 12881 //
     /* 1820334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1820345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1820348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1820354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1820357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820380 */     // MIs[0] policy
     /* 1820380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820390 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1820411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820414 */     // GIR_Coverage, 12881,
     /* 1820414 */     GIR_EraseRootFromParent_Done,
     /* 1820415 */   // Label 24653: @1820415
     /* 1820415 */   GIM_Try, /*On fail goto*//*Label 24654*/ GIMT_Encode4(1820501), // Rule ID 12884 //
     /* 1820420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1820440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820466 */     // MIs[0] policy
     /* 1820466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820476 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1820479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820500 */     // GIR_Coverage, 12884,
     /* 1820500 */     GIR_EraseRootFromParent_Done,
     /* 1820501 */   // Label 24654: @1820501
     /* 1820501 */   GIM_Try, /*On fail goto*//*Label 24655*/ GIMT_Encode4(1820587), // Rule ID 12885 //
     /* 1820506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1820517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1820520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1820526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820552 */     // MIs[0] policy
     /* 1820552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820562 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF4_MASK),
     /* 1820565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820586 */     // GIR_Coverage, 12885,
     /* 1820586 */     GIR_EraseRootFromParent_Done,
     /* 1820587 */   // Label 24655: @1820587
     /* 1820587 */   GIM_Try, /*On fail goto*//*Label 24656*/ GIMT_Encode4(1820673), // Rule ID 12888 //
     /* 1820592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820638 */     // MIs[0] policy
     /* 1820638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820648 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820672 */     // GIR_Coverage, 12888,
     /* 1820672 */     GIR_EraseRootFromParent_Done,
     /* 1820673 */   // Label 24656: @1820673
     /* 1820673 */   GIM_Try, /*On fail goto*//*Label 24657*/ GIMT_Encode4(1820759), // Rule ID 12889 //
     /* 1820678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1820689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1820692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1820698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1820701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820724 */     // MIs[0] policy
     /* 1820724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820734 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1820755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820758 */     // GIR_Coverage, 12889,
     /* 1820758 */     GIR_EraseRootFromParent_Done,
     /* 1820759 */   // Label 24657: @1820759
     /* 1820759 */   GIM_Try, /*On fail goto*//*Label 24658*/ GIMT_Encode4(1820845), // Rule ID 12892 //
     /* 1820764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820810 */     // MIs[0] policy
     /* 1820810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820820 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820844 */     // GIR_Coverage, 12892,
     /* 1820844 */     GIR_EraseRootFromParent_Done,
     /* 1820845 */   // Label 24658: @1820845
     /* 1820845 */   GIM_Try, /*On fail goto*//*Label 24659*/ GIMT_Encode4(1820931), // Rule ID 12893 //
     /* 1820850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1820853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1820861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1820864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1820867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1820870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1820873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1820876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820896 */     // MIs[0] policy
     /* 1820896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820906 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1820906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_MF2_MASK),
     /* 1820909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1820915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1820917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1820919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1820924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1820927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1820929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1820930 */     // GIR_Coverage, 12893,
     /* 1820930 */     GIR_EraseRootFromParent_Done,
     /* 1820931 */   // Label 24659: @1820931
     /* 1820931 */   GIM_Try, /*On fail goto*//*Label 24660*/ GIMT_Encode4(1821017), // Rule ID 12896 //
     /* 1820936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1820939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1820944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1820947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1820950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1820953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1820956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1820959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1820962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1820966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1820974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1820978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1820982 */     // MIs[0] policy
     /* 1820982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1820985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1820992 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1820992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1820995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1820997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1820999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821016 */     // GIR_Coverage, 12896,
     /* 1821016 */     GIR_EraseRootFromParent_Done,
     /* 1821017 */   // Label 24660: @1821017
     /* 1821017 */   GIM_Try, /*On fail goto*//*Label 24661*/ GIMT_Encode4(1821103), // Rule ID 12897 //
     /* 1821022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1821033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1821036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1821042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1821045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821068 */     // MIs[0] policy
     /* 1821068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821078 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11421:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821102 */     // GIR_Coverage, 12897,
     /* 1821102 */     GIR_EraseRootFromParent_Done,
     /* 1821103 */   // Label 24661: @1821103
     /* 1821103 */   GIM_Try, /*On fail goto*//*Label 24662*/ GIMT_Encode4(1821189), // Rule ID 12900 //
     /* 1821108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1821128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821154 */     // MIs[0] policy
     /* 1821154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821188 */     // GIR_Coverage, 12900,
     /* 1821188 */     GIR_EraseRootFromParent_Done,
     /* 1821189 */   // Label 24662: @1821189
     /* 1821189 */   GIM_Try, /*On fail goto*//*Label 24663*/ GIMT_Encode4(1821275), // Rule ID 12901 //
     /* 1821194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1821205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1821208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1821214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1821217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821240 */     // MIs[0] policy
     /* 1821240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821250 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11421:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1821271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821274 */     // GIR_Coverage, 12901,
     /* 1821274 */     GIR_EraseRootFromParent_Done,
     /* 1821275 */   // Label 24663: @1821275
     /* 1821275 */   GIM_Try, /*On fail goto*//*Label 24664*/ GIMT_Encode4(1821361), // Rule ID 12904 //
     /* 1821280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1821300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821326 */     // MIs[0] policy
     /* 1821326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821360 */     // GIR_Coverage, 12904,
     /* 1821360 */     GIR_EraseRootFromParent_Done,
     /* 1821361 */   // Label 24664: @1821361
     /* 1821361 */   GIM_Try, /*On fail goto*//*Label 24665*/ GIMT_Encode4(1821447), // Rule ID 12905 //
     /* 1821366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1821377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1821380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1821386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1821389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821412 */     // MIs[0] policy
     /* 1821412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821422 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11421:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1821443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821446 */     // GIR_Coverage, 12905,
     /* 1821446 */     GIR_EraseRootFromParent_Done,
     /* 1821447 */   // Label 24665: @1821447
     /* 1821447 */   GIM_Try, /*On fail goto*//*Label 24666*/ GIMT_Encode4(1821533), // Rule ID 12908 //
     /* 1821452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1821455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1821472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821498 */     // MIs[0] policy
     /* 1821498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821508 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821532 */     // GIR_Coverage, 12908,
     /* 1821532 */     GIR_EraseRootFromParent_Done,
     /* 1821533 */   // Label 24666: @1821533
     /* 1821533 */   GIM_Try, /*On fail goto*//*Label 24667*/ GIMT_Encode4(1821619), // Rule ID 12909 //
     /* 1821538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1821541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1821549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1821552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1821558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1821561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1821568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1821580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821584 */     // MIs[0] policy
     /* 1821584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821594 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11421:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M1_MASK),
     /* 1821597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1821615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821618 */     // GIR_Coverage, 12909,
     /* 1821618 */     GIR_EraseRootFromParent_Done,
     /* 1821619 */   // Label 24667: @1821619
     /* 1821619 */   GIM_Try, /*On fail goto*//*Label 24668*/ GIMT_Encode4(1821705), // Rule ID 12912 //
     /* 1821624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821670 */     // MIs[0] policy
     /* 1821670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821680 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1821683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821704 */     // GIR_Coverage, 12912,
     /* 1821704 */     GIR_EraseRootFromParent_Done,
     /* 1821705 */   // Label 24668: @1821705
     /* 1821705 */   GIM_Try, /*On fail goto*//*Label 24669*/ GIMT_Encode4(1821791), // Rule ID 12913 //
     /* 1821710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1821721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1821724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1821730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1821733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1821740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1821752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821756 */     // MIs[0] policy
     /* 1821756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821766 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1821769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821790 */     // GIR_Coverage, 12913,
     /* 1821790 */     GIR_EraseRootFromParent_Done,
     /* 1821791 */   // Label 24669: @1821791
     /* 1821791 */   GIM_Try, /*On fail goto*//*Label 24670*/ GIMT_Encode4(1821877), // Rule ID 12916 //
     /* 1821796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821842 */     // MIs[0] policy
     /* 1821842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821852 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1821852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1821855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821876 */     // GIR_Coverage, 12916,
     /* 1821876 */     GIR_EraseRootFromParent_Done,
     /* 1821877 */   // Label 24670: @1821877
     /* 1821877 */   GIM_Try, /*On fail goto*//*Label 24671*/ GIMT_Encode4(1821963), // Rule ID 12917 //
     /* 1821882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1821885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1821893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1821896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1821899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1821902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1821905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1821908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1821912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1821920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1821924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1821928 */     // MIs[0] policy
     /* 1821928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1821931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1821938 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1821938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1821941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1821943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1821945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1821947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1821949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1821951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1821956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1821959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1821961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1821962 */     // GIR_Coverage, 12917,
     /* 1821962 */     GIR_EraseRootFromParent_Done,
     /* 1821963 */   // Label 24671: @1821963
     /* 1821963 */   GIM_Try, /*On fail goto*//*Label 24672*/ GIMT_Encode4(1822049), // Rule ID 12920 //
     /* 1821968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1821971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1821976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1821979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1821982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1821985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1821988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1821991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1821994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1821998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822014 */     // MIs[0] policy
     /* 1822014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822024 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1822027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822048 */     // GIR_Coverage, 12920,
     /* 1822048 */     GIR_EraseRootFromParent_Done,
     /* 1822049 */   // Label 24672: @1822049
     /* 1822049 */   GIM_Try, /*On fail goto*//*Label 24673*/ GIMT_Encode4(1822135), // Rule ID 12921 //
     /* 1822054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1822065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1822068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1822074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1822077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822100 */     // MIs[0] policy
     /* 1822100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822110 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1822113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1822131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822134 */     // GIR_Coverage, 12921,
     /* 1822134 */     GIR_EraseRootFromParent_Done,
     /* 1822135 */   // Label 24673: @1822135
     /* 1822135 */   GIM_Try, /*On fail goto*//*Label 24674*/ GIMT_Encode4(1822221), // Rule ID 12924 //
     /* 1822140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1822160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822186 */     // MIs[0] policy
     /* 1822186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1822199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822220 */     // GIR_Coverage, 12924,
     /* 1822220 */     GIR_EraseRootFromParent_Done,
     /* 1822221 */   // Label 24674: @1822221
     /* 1822221 */   GIM_Try, /*On fail goto*//*Label 24675*/ GIMT_Encode4(1822307), // Rule ID 12925 //
     /* 1822226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1822237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1822240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1822246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822272 */     // MIs[0] policy
     /* 1822272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822282 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1822285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822306 */     // GIR_Coverage, 12925,
     /* 1822306 */     GIR_EraseRootFromParent_Done,
     /* 1822307 */   // Label 24675: @1822307
     /* 1822307 */   GIM_Try, /*On fail goto*//*Label 24676*/ GIMT_Encode4(1822393), // Rule ID 12928 //
     /* 1822312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1822332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822358 */     // MIs[0] policy
     /* 1822358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822368 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1822371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822392 */     // GIR_Coverage, 12928,
     /* 1822392 */     GIR_EraseRootFromParent_Done,
     /* 1822393 */   // Label 24676: @1822393
     /* 1822393 */   GIM_Try, /*On fail goto*//*Label 24677*/ GIMT_Encode4(1822479), // Rule ID 12929 //
     /* 1822398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1822409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1822412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1822418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1822421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822444 */     // MIs[0] policy
     /* 1822444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822454 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1822457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822478 */     // GIR_Coverage, 12929,
     /* 1822478 */     GIR_EraseRootFromParent_Done,
     /* 1822479 */   // Label 24677: @1822479
     /* 1822479 */   GIM_Try, /*On fail goto*//*Label 24678*/ GIMT_Encode4(1822565), // Rule ID 12932 //
     /* 1822484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1822504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822530 */     // MIs[0] policy
     /* 1822530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822540 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1822543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822564 */     // GIR_Coverage, 12932,
     /* 1822564 */     GIR_EraseRootFromParent_Done,
     /* 1822565 */   // Label 24678: @1822565
     /* 1822565 */   GIM_Try, /*On fail goto*//*Label 24679*/ GIMT_Encode4(1822651), // Rule ID 12933 //
     /* 1822570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1822581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1822584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1822590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1822593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1822600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1822612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822616 */     // MIs[0] policy
     /* 1822616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822626 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1822629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1822647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822650 */     // GIR_Coverage, 12933,
     /* 1822650 */     GIR_EraseRootFromParent_Done,
     /* 1822651 */   // Label 24679: @1822651
     /* 1822651 */   GIM_Try, /*On fail goto*//*Label 24680*/ GIMT_Encode4(1822737), // Rule ID 12936 //
     /* 1822656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822702 */     // MIs[0] policy
     /* 1822702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1822715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822736 */     // GIR_Coverage, 12936,
     /* 1822736 */     GIR_EraseRootFromParent_Done,
     /* 1822737 */   // Label 24680: @1822737
     /* 1822737 */   GIM_Try, /*On fail goto*//*Label 24681*/ GIMT_Encode4(1822823), // Rule ID 12937 //
     /* 1822742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1822753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1822756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1822762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1822765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1822772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1822784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822788 */     // MIs[0] policy
     /* 1822788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1822801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822822 */     // GIR_Coverage, 12937,
     /* 1822822 */     GIR_EraseRootFromParent_Done,
     /* 1822823 */   // Label 24681: @1822823
     /* 1822823 */   GIM_Try, /*On fail goto*//*Label 24682*/ GIMT_Encode4(1822909), // Rule ID 12940 //
     /* 1822828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1822831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1822845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1822854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822874 */     // MIs[0] policy
     /* 1822874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822884 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1822884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1822887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822908 */     // GIR_Coverage, 12940,
     /* 1822908 */     GIR_EraseRootFromParent_Done,
     /* 1822909 */   // Label 24682: @1822909
     /* 1822909 */   GIM_Try, /*On fail goto*//*Label 24683*/ GIMT_Encode4(1822995), // Rule ID 12941 //
     /* 1822914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1822917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1822922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1822925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1822928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1822931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1822934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1822937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1822940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1822944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1822952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1822956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1822960 */     // MIs[0] policy
     /* 1822960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1822963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1822970 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1822970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1822973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1822975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1822977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1822979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1822981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1822983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1822988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1822991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1822993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1822994 */     // GIR_Coverage, 12941,
     /* 1822994 */     GIR_EraseRootFromParent_Done,
     /* 1822995 */   // Label 24683: @1822995
     /* 1822995 */   GIM_Try, /*On fail goto*//*Label 24684*/ GIMT_Encode4(1823081), // Rule ID 12944 //
     /* 1823000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1823020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823046 */     // MIs[0] policy
     /* 1823046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823056 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1823059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823080 */     // GIR_Coverage, 12944,
     /* 1823080 */     GIR_EraseRootFromParent_Done,
     /* 1823081 */   // Label 24684: @1823081
     /* 1823081 */   GIM_Try, /*On fail goto*//*Label 24685*/ GIMT_Encode4(1823167), // Rule ID 12945 //
     /* 1823086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1823097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1823100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1823106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1823109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823132 */     // MIs[0] policy
     /* 1823132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823142 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1823145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1823163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823166 */     // GIR_Coverage, 12945,
     /* 1823166 */     GIR_EraseRootFromParent_Done,
     /* 1823167 */   // Label 24685: @1823167
     /* 1823167 */   GIM_Try, /*On fail goto*//*Label 24686*/ GIMT_Encode4(1823253), // Rule ID 12948 //
     /* 1823172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1823192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823218 */     // MIs[0] policy
     /* 1823218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823228 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1823231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823252 */     // GIR_Coverage, 12948,
     /* 1823252 */     GIR_EraseRootFromParent_Done,
     /* 1823253 */   // Label 24686: @1823253
     /* 1823253 */   GIM_Try, /*On fail goto*//*Label 24687*/ GIMT_Encode4(1823339), // Rule ID 12949 //
     /* 1823258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1823269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1823272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1823278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1823288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1823300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823304 */     // MIs[0] policy
     /* 1823304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11421:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M2_MASK),
     /* 1823317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823338 */     // GIR_Coverage, 12949,
     /* 1823338 */     GIR_EraseRootFromParent_Done,
     /* 1823339 */   // Label 24687: @1823339
     /* 1823339 */   GIM_Try, /*On fail goto*//*Label 24688*/ GIMT_Encode4(1823425), // Rule ID 12952 //
     /* 1823344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1823355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1823358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1823364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823390 */     // MIs[0] policy
     /* 1823390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823400 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1823403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823424 */     // GIR_Coverage, 12952,
     /* 1823424 */     GIR_EraseRootFromParent_Done,
     /* 1823425 */   // Label 24688: @1823425
     /* 1823425 */   GIM_Try, /*On fail goto*//*Label 24689*/ GIMT_Encode4(1823511), // Rule ID 12953 //
     /* 1823430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1823441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1823444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1823450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1823453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1823460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1823472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823476 */     // MIs[0] policy
     /* 1823476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823486 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11421:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M4_MASK),
     /* 1823489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823510 */     // GIR_Coverage, 12953,
     /* 1823510 */     GIR_EraseRootFromParent_Done,
     /* 1823511 */   // Label 24689: @1823511
     /* 1823511 */   GIM_Try, /*On fail goto*//*Label 24690*/ GIMT_Encode4(1823597), // Rule ID 12956 //
     /* 1823516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1823519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1823533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823562 */     // MIs[0] policy
     /* 1823562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823572 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1823575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823596 */     // GIR_Coverage, 12956,
     /* 1823596 */     GIR_EraseRootFromParent_Done,
     /* 1823597 */   // Label 24690: @1823597
     /* 1823597 */   GIM_Try, /*On fail goto*//*Label 24691*/ GIMT_Encode4(1823683), // Rule ID 12957 //
     /* 1823602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1823605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsub_mask),
     /* 1823610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1823613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1823616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1823619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1823622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1823625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1823632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1823640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1823644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823648 */     // MIs[0] policy
     /* 1823648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823658 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11421:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSUB_VX_M8_MASK),
     /* 1823661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1823679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823682 */     // GIR_Coverage, 12957,
     /* 1823682 */     GIR_EraseRootFromParent_Done,
     /* 1823683 */   // Label 24691: @1823683
     /* 1823683 */   GIM_Try, /*On fail goto*//*Label 24692*/ GIMT_Encode4(1823769), // Rule ID 12960 //
     /* 1823688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1823696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823734 */     // MIs[0] policy
     /* 1823734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823744 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1823747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823768 */     // GIR_Coverage, 12960,
     /* 1823768 */     GIR_EraseRootFromParent_Done,
     /* 1823769 */   // Label 24692: @1823769
     /* 1823769 */   GIM_Try, /*On fail goto*//*Label 24693*/ GIMT_Encode4(1823855), // Rule ID 12961 //
     /* 1823774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1823782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1823785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1823788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1823791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1823794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1823797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823820 */     // MIs[0] policy
     /* 1823820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823830 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1823830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF8_MASK),
     /* 1823833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823854 */     // GIR_Coverage, 12961,
     /* 1823854 */     GIR_EraseRootFromParent_Done,
     /* 1823855 */   // Label 24693: @1823855
     /* 1823855 */   GIM_Try, /*On fail goto*//*Label 24694*/ GIMT_Encode4(1823941), // Rule ID 12964 //
     /* 1823860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1823863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1823868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1823886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823906 */     // MIs[0] policy
     /* 1823906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1823916 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1823916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1823919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1823921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1823923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1823925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1823927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1823929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1823934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1823937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1823939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1823940 */     // GIR_Coverage, 12964,
     /* 1823940 */     GIR_EraseRootFromParent_Done,
     /* 1823941 */   // Label 24694: @1823941
     /* 1823941 */   GIM_Try, /*On fail goto*//*Label 24695*/ GIMT_Encode4(1824027), // Rule ID 12965 //
     /* 1823946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1823949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1823954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1823957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1823960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1823963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1823966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1823969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1823972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1823976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1823988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1823992 */     // MIs[0] policy
     /* 1823992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1823995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1824005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824026 */     // GIR_Coverage, 12965,
     /* 1824026 */     GIR_EraseRootFromParent_Done,
     /* 1824027 */   // Label 24695: @1824027
     /* 1824027 */   GIM_Try, /*On fail goto*//*Label 24696*/ GIMT_Encode4(1824113), // Rule ID 12968 //
     /* 1824032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1824049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1824052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824078 */     // MIs[0] policy
     /* 1824078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824088 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824112 */     // GIR_Coverage, 12968,
     /* 1824112 */     GIR_EraseRootFromParent_Done,
     /* 1824113 */   // Label 24696: @1824113
     /* 1824113 */   GIM_Try, /*On fail goto*//*Label 24697*/ GIMT_Encode4(1824199), // Rule ID 12969 //
     /* 1824118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1824129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1824132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1824135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1824138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824164 */     // MIs[0] policy
     /* 1824164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824174 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824198 */     // GIR_Coverage, 12969,
     /* 1824198 */     GIR_EraseRootFromParent_Done,
     /* 1824199 */   // Label 24697: @1824199
     /* 1824199 */   GIM_Try, /*On fail goto*//*Label 24698*/ GIMT_Encode4(1824285), // Rule ID 12972 //
     /* 1824204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1824221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1824224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824250 */     // MIs[0] policy
     /* 1824250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824260 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1824263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824284 */     // GIR_Coverage, 12972,
     /* 1824284 */     GIR_EraseRootFromParent_Done,
     /* 1824285 */   // Label 24698: @1824285
     /* 1824285 */   GIM_Try, /*On fail goto*//*Label 24699*/ GIMT_Encode4(1824371), // Rule ID 12973 //
     /* 1824290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1824301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1824304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1824307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1824310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824336 */     // MIs[0] policy
     /* 1824336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824346 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF4_MASK),
     /* 1824349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824370 */     // GIR_Coverage, 12973,
     /* 1824370 */     GIR_EraseRootFromParent_Done,
     /* 1824371 */   // Label 24699: @1824371
     /* 1824371 */   GIM_Try, /*On fail goto*//*Label 24700*/ GIMT_Encode4(1824457), // Rule ID 12976 //
     /* 1824376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1824387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1824390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1824393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1824396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824422 */     // MIs[0] policy
     /* 1824422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824432 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824456 */     // GIR_Coverage, 12976,
     /* 1824456 */     GIR_EraseRootFromParent_Done,
     /* 1824457 */   // Label 24700: @1824457
     /* 1824457 */   GIM_Try, /*On fail goto*//*Label 24701*/ GIMT_Encode4(1824543), // Rule ID 12977 //
     /* 1824462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1824473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1824476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1824479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1824482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1824485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824508 */     // MIs[0] policy
     /* 1824508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824518 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824542 */     // GIR_Coverage, 12977,
     /* 1824542 */     GIR_EraseRootFromParent_Done,
     /* 1824543 */   // Label 24701: @1824543
     /* 1824543 */   GIM_Try, /*On fail goto*//*Label 24702*/ GIMT_Encode4(1824629), // Rule ID 12980 //
     /* 1824548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824594 */     // MIs[0] policy
     /* 1824594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824604 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824628 */     // GIR_Coverage, 12980,
     /* 1824628 */     GIR_EraseRootFromParent_Done,
     /* 1824629 */   // Label 24702: @1824629
     /* 1824629 */   GIM_Try, /*On fail goto*//*Label 24703*/ GIMT_Encode4(1824715), // Rule ID 12981 //
     /* 1824634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1824645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1824648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1824651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1824654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1824657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824680 */     // MIs[0] policy
     /* 1824680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824690 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_MF2_MASK),
     /* 1824693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1824711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824714 */     // GIR_Coverage, 12981,
     /* 1824714 */     GIR_EraseRootFromParent_Done,
     /* 1824715 */   // Label 24703: @1824715
     /* 1824715 */   GIM_Try, /*On fail goto*//*Label 24704*/ GIMT_Encode4(1824801), // Rule ID 12984 //
     /* 1824720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824766 */     // MIs[0] policy
     /* 1824766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824776 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1824779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824800 */     // GIR_Coverage, 12984,
     /* 1824800 */     GIR_EraseRootFromParent_Done,
     /* 1824801 */   // Label 24704: @1824801
     /* 1824801 */   GIM_Try, /*On fail goto*//*Label 24705*/ GIMT_Encode4(1824887), // Rule ID 12985 //
     /* 1824806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1824817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1824820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1824823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1824826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1824829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1824832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824852 */     // MIs[0] policy
     /* 1824852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824862 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1824862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1824865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1824883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824886 */     // GIR_Coverage, 12985,
     /* 1824886 */     GIR_EraseRootFromParent_Done,
     /* 1824887 */   // Label 24705: @1824887
     /* 1824887 */   GIM_Try, /*On fail goto*//*Label 24706*/ GIMT_Encode4(1824973), // Rule ID 12988 //
     /* 1824892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1824895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1824915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1824918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1824922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1824934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1824938 */     // MIs[0] policy
     /* 1824938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1824941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1824948 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1824948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1824951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1824953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1824955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1824957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1824959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1824961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1824966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1824969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1824971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1824972 */     // GIR_Coverage, 12988,
     /* 1824972 */     GIR_EraseRootFromParent_Done,
     /* 1824973 */   // Label 24706: @1824973
     /* 1824973 */   GIM_Try, /*On fail goto*//*Label 24707*/ GIMT_Encode4(1825059), // Rule ID 12989 //
     /* 1824978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1824981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1824986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1824989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1824992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1824995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1824998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1825001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825024 */     // MIs[0] policy
     /* 1825024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825034 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1825037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1825055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825058 */     // GIR_Coverage, 12989,
     /* 1825058 */     GIR_EraseRootFromParent_Done,
     /* 1825059 */   // Label 24707: @1825059
     /* 1825059 */   GIM_Try, /*On fail goto*//*Label 24708*/ GIMT_Encode4(1825145), // Rule ID 12992 //
     /* 1825064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1825081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1825084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825110 */     // MIs[0] policy
     /* 1825110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825120 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1825123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825144 */     // GIR_Coverage, 12992,
     /* 1825144 */     GIR_EraseRootFromParent_Done,
     /* 1825145 */   // Label 24708: @1825145
     /* 1825145 */   GIM_Try, /*On fail goto*//*Label 24709*/ GIMT_Encode4(1825231), // Rule ID 12993 //
     /* 1825150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1825161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1825164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1825167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1825170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1825173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825196 */     // MIs[0] policy
     /* 1825196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825206 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1825209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1825227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825230 */     // GIR_Coverage, 12993,
     /* 1825230 */     GIR_EraseRootFromParent_Done,
     /* 1825231 */   // Label 24709: @1825231
     /* 1825231 */   GIM_Try, /*On fail goto*//*Label 24710*/ GIMT_Encode4(1825317), // Rule ID 12996 //
     /* 1825236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1825239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1825253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1825256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825282 */     // MIs[0] policy
     /* 1825282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1825295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825316 */     // GIR_Coverage, 12996,
     /* 1825316 */     GIR_EraseRootFromParent_Done,
     /* 1825317 */   // Label 24710: @1825317
     /* 1825317 */   GIM_Try, /*On fail goto*//*Label 24711*/ GIMT_Encode4(1825403), // Rule ID 12997 //
     /* 1825322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1825325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1825333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1825336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1825339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1825342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1825345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1825352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1825364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825368 */     // MIs[0] policy
     /* 1825368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M1_MASK),
     /* 1825381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1825399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825402 */     // GIR_Coverage, 12997,
     /* 1825402 */     GIR_EraseRootFromParent_Done,
     /* 1825403 */   // Label 24711: @1825403
     /* 1825403 */   GIM_Try, /*On fail goto*//*Label 24712*/ GIMT_Encode4(1825489), // Rule ID 13000 //
     /* 1825408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1825419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1825425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1825428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825454 */     // MIs[0] policy
     /* 1825454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825464 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1825467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825488 */     // GIR_Coverage, 13000,
     /* 1825488 */     GIR_EraseRootFromParent_Done,
     /* 1825489 */   // Label 24712: @1825489
     /* 1825489 */   GIM_Try, /*On fail goto*//*Label 24713*/ GIMT_Encode4(1825575), // Rule ID 13001 //
     /* 1825494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1825505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1825508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1825511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1825514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1825517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825540 */     // MIs[0] policy
     /* 1825540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1825553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825574 */     // GIR_Coverage, 13001,
     /* 1825574 */     GIR_EraseRootFromParent_Done,
     /* 1825575 */   // Label 24713: @1825575
     /* 1825575 */   GIM_Try, /*On fail goto*//*Label 24714*/ GIMT_Encode4(1825661), // Rule ID 13004 //
     /* 1825580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825626 */     // MIs[0] policy
     /* 1825626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825636 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1825639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825660 */     // GIR_Coverage, 13004,
     /* 1825660 */     GIR_EraseRootFromParent_Done,
     /* 1825661 */   // Label 24714: @1825661
     /* 1825661 */   GIM_Try, /*On fail goto*//*Label 24715*/ GIMT_Encode4(1825747), // Rule ID 13005 //
     /* 1825666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1825677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1825680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1825683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1825686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1825689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1825696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1825708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825712 */     // MIs[0] policy
     /* 1825712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825722 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1825725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825746 */     // GIR_Coverage, 13005,
     /* 1825746 */     GIR_EraseRootFromParent_Done,
     /* 1825747 */   // Label 24715: @1825747
     /* 1825747 */   GIM_Try, /*On fail goto*//*Label 24716*/ GIMT_Encode4(1825833), // Rule ID 13008 //
     /* 1825752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825798 */     // MIs[0] policy
     /* 1825798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825808 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1825811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825832 */     // GIR_Coverage, 13008,
     /* 1825832 */     GIR_EraseRootFromParent_Done,
     /* 1825833 */   // Label 24716: @1825833
     /* 1825833 */   GIM_Try, /*On fail goto*//*Label 24717*/ GIMT_Encode4(1825919), // Rule ID 13009 //
     /* 1825838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1825841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1825849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1825852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1825855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1825858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1825861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1825864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1825868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1825880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825884 */     // MIs[0] policy
     /* 1825884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825894 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1825894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1825897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1825915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1825917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1825918 */     // GIR_Coverage, 13009,
     /* 1825918 */     GIR_EraseRootFromParent_Done,
     /* 1825919 */   // Label 24717: @1825919
     /* 1825919 */   GIM_Try, /*On fail goto*//*Label 24718*/ GIMT_Encode4(1826005), // Rule ID 13012 //
     /* 1825924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1825927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1825932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1825935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1825938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1825941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1825944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1825947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1825950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1825954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1825966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1825970 */     // MIs[0] policy
     /* 1825970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1825973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1825980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1825980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1825983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1825985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1825987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1825989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1825991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1825993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1825998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826004 */     // GIR_Coverage, 13012,
     /* 1826004 */     GIR_EraseRootFromParent_Done,
     /* 1826005 */   // Label 24718: @1826005
     /* 1826005 */   GIM_Try, /*On fail goto*//*Label 24719*/ GIMT_Encode4(1826091), // Rule ID 13013 //
     /* 1826010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1826021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1826024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1826027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1826030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826056 */     // MIs[0] policy
     /* 1826056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826066 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1826069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826090 */     // GIR_Coverage, 13013,
     /* 1826090 */     GIR_EraseRootFromParent_Done,
     /* 1826091 */   // Label 24719: @1826091
     /* 1826091 */   GIM_Try, /*On fail goto*//*Label 24720*/ GIMT_Encode4(1826177), // Rule ID 13016 //
     /* 1826096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1826113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1826116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826142 */     // MIs[0] policy
     /* 1826142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826152 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1826155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826176 */     // GIR_Coverage, 13016,
     /* 1826176 */     GIR_EraseRootFromParent_Done,
     /* 1826177 */   // Label 24720: @1826177
     /* 1826177 */   GIM_Try, /*On fail goto*//*Label 24721*/ GIMT_Encode4(1826263), // Rule ID 13017 //
     /* 1826182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1826193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1826196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1826199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1826202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826228 */     // MIs[0] policy
     /* 1826228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826238 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1826241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826262 */     // GIR_Coverage, 13017,
     /* 1826262 */     GIR_EraseRootFromParent_Done,
     /* 1826263 */   // Label 24721: @1826263
     /* 1826263 */   GIM_Try, /*On fail goto*//*Label 24722*/ GIMT_Encode4(1826349), // Rule ID 13020 //
     /* 1826268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1826285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1826288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826314 */     // MIs[0] policy
     /* 1826314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826324 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1826327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826348 */     // GIR_Coverage, 13020,
     /* 1826348 */     GIR_EraseRootFromParent_Done,
     /* 1826349 */   // Label 24722: @1826349
     /* 1826349 */   GIM_Try, /*On fail goto*//*Label 24723*/ GIMT_Encode4(1826435), // Rule ID 13021 //
     /* 1826354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1826365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1826368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1826371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1826374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1826377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826400 */     // MIs[0] policy
     /* 1826400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826410 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1826413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1826431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826434 */     // GIR_Coverage, 13021,
     /* 1826434 */     GIR_EraseRootFromParent_Done,
     /* 1826435 */   // Label 24723: @1826435
     /* 1826435 */   GIM_Try, /*On fail goto*//*Label 24724*/ GIMT_Encode4(1826521), // Rule ID 13024 //
     /* 1826440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1826460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826486 */     // MIs[0] policy
     /* 1826486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826496 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1826499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826520 */     // GIR_Coverage, 13024,
     /* 1826520 */     GIR_EraseRootFromParent_Done,
     /* 1826521 */   // Label 24724: @1826521
     /* 1826521 */   GIM_Try, /*On fail goto*//*Label 24725*/ GIMT_Encode4(1826607), // Rule ID 13025 //
     /* 1826526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1826537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1826540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1826543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1826546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1826549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826572 */     // MIs[0] policy
     /* 1826572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826582 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1826585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826606 */     // GIR_Coverage, 13025,
     /* 1826606 */     GIR_EraseRootFromParent_Done,
     /* 1826607 */   // Label 24725: @1826607
     /* 1826607 */   GIM_Try, /*On fail goto*//*Label 24726*/ GIMT_Encode4(1826693), // Rule ID 13028 //
     /* 1826612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826658 */     // MIs[0] policy
     /* 1826658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826668 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1826671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826673 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826692 */     // GIR_Coverage, 13028,
     /* 1826692 */     GIR_EraseRootFromParent_Done,
     /* 1826693 */   // Label 24726: @1826693
     /* 1826693 */   GIM_Try, /*On fail goto*//*Label 24727*/ GIMT_Encode4(1826779), // Rule ID 13029 //
     /* 1826698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1826709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1826712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1826715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1826718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1826721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1826728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1826740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826744 */     // MIs[0] policy
     /* 1826744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826754 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1826757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826759 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826778 */     // GIR_Coverage, 13029,
     /* 1826778 */     GIR_EraseRootFromParent_Done,
     /* 1826779 */   // Label 24727: @1826779
     /* 1826779 */   GIM_Try, /*On fail goto*//*Label 24728*/ GIMT_Encode4(1826865), // Rule ID 13032 //
     /* 1826784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1826787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826830 */     // MIs[0] policy
     /* 1826830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826840 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1826840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1826843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826864 */     // GIR_Coverage, 13032,
     /* 1826864 */     GIR_EraseRootFromParent_Done,
     /* 1826865 */   // Label 24728: @1826865
     /* 1826865 */   GIM_Try, /*On fail goto*//*Label 24729*/ GIMT_Encode4(1826951), // Rule ID 13033 //
     /* 1826870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1826873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1826881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1826884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1826887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1826890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1826893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1826896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1826900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1826912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1826916 */     // MIs[0] policy
     /* 1826916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1826919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1826926 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1826926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1826929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1826931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1826933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1826935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1826937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1826939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1826944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1826947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1826949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1826950 */     // GIR_Coverage, 13033,
     /* 1826950 */     GIR_EraseRootFromParent_Done,
     /* 1826951 */   // Label 24729: @1826951
     /* 1826951 */   GIM_Try, /*On fail goto*//*Label 24730*/ GIMT_Encode4(1827037), // Rule ID 13036 //
     /* 1826956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1826959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1826964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1826967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1826970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1826973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1826976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1826979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1826982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1826986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1826998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827002 */     // MIs[0] policy
     /* 1827002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827012 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1827015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827036 */     // GIR_Coverage, 13036,
     /* 1827036 */     GIR_EraseRootFromParent_Done,
     /* 1827037 */   // Label 24730: @1827037
     /* 1827037 */   GIM_Try, /*On fail goto*//*Label 24731*/ GIMT_Encode4(1827123), // Rule ID 13037 //
     /* 1827042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1827053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1827056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1827059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1827062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1827072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1827084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827088 */     // MIs[0] policy
     /* 1827088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827098 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M2_MASK),
     /* 1827101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827122 */     // GIR_Coverage, 13037,
     /* 1827122 */     GIR_EraseRootFromParent_Done,
     /* 1827123 */   // Label 24731: @1827123
     /* 1827123 */   GIM_Try, /*On fail goto*//*Label 24732*/ GIMT_Encode4(1827209), // Rule ID 13040 //
     /* 1827128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1827145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1827148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827174 */     // MIs[0] policy
     /* 1827174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827184 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1827187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827208 */     // GIR_Coverage, 13040,
     /* 1827208 */     GIR_EraseRootFromParent_Done,
     /* 1827209 */   // Label 24732: @1827209
     /* 1827209 */   GIM_Try, /*On fail goto*//*Label 24733*/ GIMT_Encode4(1827295), // Rule ID 13041 //
     /* 1827214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1827225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1827228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1827231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1827234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1827244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1827256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827260 */     // MIs[0] policy
     /* 1827260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827270 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M4_MASK),
     /* 1827273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827294 */     // GIR_Coverage, 13041,
     /* 1827294 */     GIR_EraseRootFromParent_Done,
     /* 1827295 */   // Label 24733: @1827295
     /* 1827295 */   GIM_Try, /*On fail goto*//*Label 24734*/ GIMT_Encode4(1827381), // Rule ID 13044 //
     /* 1827300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1827303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1827317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1827320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827346 */     // MIs[0] policy
     /* 1827346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827356 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1827359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827380 */     // GIR_Coverage, 13044,
     /* 1827380 */     GIR_EraseRootFromParent_Done,
     /* 1827381 */   // Label 24734: @1827381
     /* 1827381 */   GIM_Try, /*On fail goto*//*Label 24735*/ GIMT_Encode4(1827467), // Rule ID 13045 //
     /* 1827386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1827389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1827397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1827400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1827403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1827406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1827409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1827416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1827428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827432 */     // MIs[0] policy
     /* 1827432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827442 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VV_M8_MASK),
     /* 1827445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1827463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827466 */     // GIR_Coverage, 13045,
     /* 1827466 */     GIR_EraseRootFromParent_Done,
     /* 1827467 */   // Label 24735: @1827467
     /* 1827467 */   GIM_Try, /*On fail goto*//*Label 24736*/ GIMT_Encode4(1827553), // Rule ID 13048 //
     /* 1827472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1827492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827518 */     // MIs[0] policy
     /* 1827518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827528 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1827531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827552 */     // GIR_Coverage, 13048,
     /* 1827552 */     GIR_EraseRootFromParent_Done,
     /* 1827553 */   // Label 24736: @1827553
     /* 1827553 */   GIM_Try, /*On fail goto*//*Label 24737*/ GIMT_Encode4(1827639), // Rule ID 13049 //
     /* 1827558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1827569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1827572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1827578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1827581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827604 */     // MIs[0] policy
     /* 1827604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827614 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF8_MASK),
     /* 1827617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827638 */     // GIR_Coverage, 13049,
     /* 1827638 */     GIR_EraseRootFromParent_Done,
     /* 1827639 */   // Label 24737: @1827639
     /* 1827639 */   GIM_Try, /*On fail goto*//*Label 24738*/ GIMT_Encode4(1827725), // Rule ID 13052 //
     /* 1827644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827690 */     // MIs[0] policy
     /* 1827690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827700 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1827703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827724 */     // GIR_Coverage, 13052,
     /* 1827724 */     GIR_EraseRootFromParent_Done,
     /* 1827725 */   // Label 24738: @1827725
     /* 1827725 */   GIM_Try, /*On fail goto*//*Label 24739*/ GIMT_Encode4(1827811), // Rule ID 13053 //
     /* 1827730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1827741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1827744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1827750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1827753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827776 */     // MIs[0] policy
     /* 1827776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827786 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1827789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827810 */     // GIR_Coverage, 13053,
     /* 1827810 */     GIR_EraseRootFromParent_Done,
     /* 1827811 */   // Label 24739: @1827811
     /* 1827811 */   GIM_Try, /*On fail goto*//*Label 24740*/ GIMT_Encode4(1827897), // Rule ID 13056 //
     /* 1827816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1827833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1827842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827862 */     // MIs[0] policy
     /* 1827862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827872 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1827872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1827875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827896 */     // GIR_Coverage, 13056,
     /* 1827896 */     GIR_EraseRootFromParent_Done,
     /* 1827897 */   // Label 24740: @1827897
     /* 1827897 */   GIM_Try, /*On fail goto*//*Label 24741*/ GIMT_Encode4(1827983), // Rule ID 13057 //
     /* 1827902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1827905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1827913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1827916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1827919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1827922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1827925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1827928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1827932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1827940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1827944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1827948 */     // MIs[0] policy
     /* 1827948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1827951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1827958 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1827958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1827961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1827963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1827965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1827967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1827969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1827971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1827976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1827979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1827981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1827982 */     // GIR_Coverage, 13057,
     /* 1827982 */     GIR_EraseRootFromParent_Done,
     /* 1827983 */   // Label 24741: @1827983
     /* 1827983 */   GIM_Try, /*On fail goto*//*Label 24742*/ GIMT_Encode4(1828069), // Rule ID 13060 //
     /* 1827988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1827991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1827996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1827999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1828008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828034 */     // MIs[0] policy
     /* 1828034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828044 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1828047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828068 */     // GIR_Coverage, 13060,
     /* 1828068 */     GIR_EraseRootFromParent_Done,
     /* 1828069 */   // Label 24742: @1828069
     /* 1828069 */   GIM_Try, /*On fail goto*//*Label 24743*/ GIMT_Encode4(1828155), // Rule ID 13061 //
     /* 1828074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1828085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1828088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1828094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828120 */     // MIs[0] policy
     /* 1828120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828130 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF4_MASK),
     /* 1828133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828154 */     // GIR_Coverage, 13061,
     /* 1828154 */     GIR_EraseRootFromParent_Done,
     /* 1828155 */   // Label 24743: @1828155
     /* 1828155 */   GIM_Try, /*On fail goto*//*Label 24744*/ GIMT_Encode4(1828241), // Rule ID 13064 //
     /* 1828160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1828180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828206 */     // MIs[0] policy
     /* 1828206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1828219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828240 */     // GIR_Coverage, 13064,
     /* 1828240 */     GIR_EraseRootFromParent_Done,
     /* 1828241 */   // Label 24744: @1828241
     /* 1828241 */   GIM_Try, /*On fail goto*//*Label 24745*/ GIMT_Encode4(1828327), // Rule ID 13065 //
     /* 1828246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1828257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1828260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1828266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828292 */     // MIs[0] policy
     /* 1828292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828302 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1828305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828326 */     // GIR_Coverage, 13065,
     /* 1828326 */     GIR_EraseRootFromParent_Done,
     /* 1828327 */   // Label 24745: @1828327
     /* 1828327 */   GIM_Try, /*On fail goto*//*Label 24746*/ GIMT_Encode4(1828413), // Rule ID 13068 //
     /* 1828332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1828346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1828352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828378 */     // MIs[0] policy
     /* 1828378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828388 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1828391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828412 */     // GIR_Coverage, 13068,
     /* 1828412 */     GIR_EraseRootFromParent_Done,
     /* 1828413 */   // Label 24746: @1828413
     /* 1828413 */   GIM_Try, /*On fail goto*//*Label 24747*/ GIMT_Encode4(1828499), // Rule ID 13069 //
     /* 1828418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1828429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1828432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1828438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1828441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828464 */     // MIs[0] policy
     /* 1828464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828474 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_MF2_MASK),
     /* 1828477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828498 */     // GIR_Coverage, 13069,
     /* 1828498 */     GIR_EraseRootFromParent_Done,
     /* 1828499 */   // Label 24747: @1828499
     /* 1828499 */   GIM_Try, /*On fail goto*//*Label 24748*/ GIMT_Encode4(1828585), // Rule ID 13072 //
     /* 1828504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828550 */     // MIs[0] policy
     /* 1828550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828560 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828584 */     // GIR_Coverage, 13072,
     /* 1828584 */     GIR_EraseRootFromParent_Done,
     /* 1828585 */   // Label 24748: @1828585
     /* 1828585 */   GIM_Try, /*On fail goto*//*Label 24749*/ GIMT_Encode4(1828671), // Rule ID 13073 //
     /* 1828590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1828601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1828604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1828610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1828613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828636 */     // MIs[0] policy
     /* 1828636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828646 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11338:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1828667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828670 */     // GIR_Coverage, 13073,
     /* 1828670 */     GIR_EraseRootFromParent_Done,
     /* 1828671 */   // Label 24749: @1828671
     /* 1828671 */   GIM_Try, /*On fail goto*//*Label 24750*/ GIMT_Encode4(1828757), // Rule ID 13076 //
     /* 1828676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828722 */     // MIs[0] policy
     /* 1828722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828732 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828756 */     // GIR_Coverage, 13076,
     /* 1828756 */     GIR_EraseRootFromParent_Done,
     /* 1828757 */   // Label 24750: @1828757
     /* 1828757 */   GIM_Try, /*On fail goto*//*Label 24751*/ GIMT_Encode4(1828843), // Rule ID 13077 //
     /* 1828762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1828773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1828776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1828782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1828785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828808 */     // MIs[0] policy
     /* 1828808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828818 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11338:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1828839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828842 */     // GIR_Coverage, 13077,
     /* 1828842 */     GIR_EraseRootFromParent_Done,
     /* 1828843 */   // Label 24751: @1828843
     /* 1828843 */   GIM_Try, /*On fail goto*//*Label 24752*/ GIMT_Encode4(1828929), // Rule ID 13080 //
     /* 1828848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1828851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1828865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1828874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828894 */     // MIs[0] policy
     /* 1828894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828904 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1828904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1828915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1828917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1828922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1828925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1828927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1828928 */     // GIR_Coverage, 13080,
     /* 1828928 */     GIR_EraseRootFromParent_Done,
     /* 1828929 */   // Label 24752: @1828929
     /* 1828929 */   GIM_Try, /*On fail goto*//*Label 24753*/ GIMT_Encode4(1829015), // Rule ID 13081 //
     /* 1828934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1828937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1828942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1828945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1828948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1828951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1828954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1828957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1828960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1828964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1828972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1828976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1828980 */     // MIs[0] policy
     /* 1828980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1828983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1828990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11338:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1828990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1828993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1828995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1828997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1828999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1829011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829014 */     // GIR_Coverage, 13081,
     /* 1829014 */     GIR_EraseRootFromParent_Done,
     /* 1829015 */   // Label 24753: @1829015
     /* 1829015 */   GIM_Try, /*On fail goto*//*Label 24754*/ GIMT_Encode4(1829101), // Rule ID 13084 //
     /* 1829020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1829023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1829040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829066 */     // MIs[0] policy
     /* 1829066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829076 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1829079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829100 */     // GIR_Coverage, 13084,
     /* 1829100 */     GIR_EraseRootFromParent_Done,
     /* 1829101 */   // Label 24754: @1829101
     /* 1829101 */   GIM_Try, /*On fail goto*//*Label 24755*/ GIMT_Encode4(1829187), // Rule ID 13085 //
     /* 1829106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1829109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1829117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1829120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1829126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1829129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1829136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1829148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829152 */     // MIs[0] policy
     /* 1829152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829162 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11338:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M1_MASK),
     /* 1829165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1829183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829186 */     // GIR_Coverage, 13085,
     /* 1829186 */     GIR_EraseRootFromParent_Done,
     /* 1829187 */   // Label 24755: @1829187
     /* 1829187 */   GIM_Try, /*On fail goto*//*Label 24756*/ GIMT_Encode4(1829273), // Rule ID 13088 //
     /* 1829192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1829212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829238 */     // MIs[0] policy
     /* 1829238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1829251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829272 */     // GIR_Coverage, 13088,
     /* 1829272 */     GIR_EraseRootFromParent_Done,
     /* 1829273 */   // Label 24756: @1829273
     /* 1829273 */   GIM_Try, /*On fail goto*//*Label 24757*/ GIMT_Encode4(1829359), // Rule ID 13089 //
     /* 1829278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1829289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1829292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1829298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829324 */     // MIs[0] policy
     /* 1829324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829334 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1829337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829358 */     // GIR_Coverage, 13089,
     /* 1829358 */     GIR_EraseRootFromParent_Done,
     /* 1829359 */   // Label 24757: @1829359
     /* 1829359 */   GIM_Try, /*On fail goto*//*Label 24758*/ GIMT_Encode4(1829445), // Rule ID 13092 //
     /* 1829364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1829375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1829378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1829384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829410 */     // MIs[0] policy
     /* 1829410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829420 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1829423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829444 */     // GIR_Coverage, 13092,
     /* 1829444 */     GIR_EraseRootFromParent_Done,
     /* 1829445 */   // Label 24758: @1829445
     /* 1829445 */   GIM_Try, /*On fail goto*//*Label 24759*/ GIMT_Encode4(1829531), // Rule ID 13093 //
     /* 1829450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1829461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1829464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1829470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1829473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829496 */     // MIs[0] policy
     /* 1829496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829506 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1829509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829530 */     // GIR_Coverage, 13093,
     /* 1829530 */     GIR_EraseRootFromParent_Done,
     /* 1829531 */   // Label 24759: @1829531
     /* 1829531 */   GIM_Try, /*On fail goto*//*Label 24760*/ GIMT_Encode4(1829617), // Rule ID 13096 //
     /* 1829536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829582 */     // MIs[0] policy
     /* 1829582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829592 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1829595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829616 */     // GIR_Coverage, 13096,
     /* 1829616 */     GIR_EraseRootFromParent_Done,
     /* 1829617 */   // Label 24760: @1829617
     /* 1829617 */   GIM_Try, /*On fail goto*//*Label 24761*/ GIMT_Encode4(1829703), // Rule ID 13097 //
     /* 1829622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1829633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1829636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1829642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1829645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1829652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1829664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829668 */     // MIs[0] policy
     /* 1829668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829678 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1829681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1829699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829702 */     // GIR_Coverage, 13097,
     /* 1829702 */     GIR_EraseRootFromParent_Done,
     /* 1829703 */   // Label 24761: @1829703
     /* 1829703 */   GIM_Try, /*On fail goto*//*Label 24762*/ GIMT_Encode4(1829789), // Rule ID 13100 //
     /* 1829708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829754 */     // MIs[0] policy
     /* 1829754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829764 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1829767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829788 */     // GIR_Coverage, 13100,
     /* 1829788 */     GIR_EraseRootFromParent_Done,
     /* 1829789 */   // Label 24762: @1829789
     /* 1829789 */   GIM_Try, /*On fail goto*//*Label 24763*/ GIMT_Encode4(1829875), // Rule ID 13101 //
     /* 1829794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1829805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1829808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1829814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1829817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1829824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1829836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829840 */     // MIs[0] policy
     /* 1829840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1829850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1829853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829874 */     // GIR_Coverage, 13101,
     /* 1829874 */     GIR_EraseRootFromParent_Done,
     /* 1829875 */   // Label 24763: @1829875
     /* 1829875 */   GIM_Try, /*On fail goto*//*Label 24764*/ GIMT_Encode4(1829961), // Rule ID 13104 //
     /* 1829880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1829883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1829897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1829906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1829918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1829922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1829926 */     // MIs[0] policy
     /* 1829926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1829929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1829936 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1829936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1829939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1829941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1829943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1829945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1829947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1829949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1829954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1829957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1829959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1829960 */     // GIR_Coverage, 13104,
     /* 1829960 */     GIR_EraseRootFromParent_Done,
     /* 1829961 */   // Label 24764: @1829961
     /* 1829961 */   GIM_Try, /*On fail goto*//*Label 24765*/ GIMT_Encode4(1830047), // Rule ID 13105 //
     /* 1829966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1829969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1829974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1829977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1829980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1829983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1829986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1829989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1829992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1829996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830012 */     // MIs[0] policy
     /* 1830012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830022 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1830025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830046 */     // GIR_Coverage, 13105,
     /* 1830046 */     GIR_EraseRootFromParent_Done,
     /* 1830047 */   // Label 24765: @1830047
     /* 1830047 */   GIM_Try, /*On fail goto*//*Label 24766*/ GIMT_Encode4(1830133), // Rule ID 13108 //
     /* 1830052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1830072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830098 */     // MIs[0] policy
     /* 1830098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830108 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1830111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830132 */     // GIR_Coverage, 13108,
     /* 1830132 */     GIR_EraseRootFromParent_Done,
     /* 1830133 */   // Label 24766: @1830133
     /* 1830133 */   GIM_Try, /*On fail goto*//*Label 24767*/ GIMT_Encode4(1830219), // Rule ID 13109 //
     /* 1830138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1830149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1830152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1830158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1830161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830184 */     // MIs[0] policy
     /* 1830184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830194 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1830197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1830215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830218 */     // GIR_Coverage, 13109,
     /* 1830218 */     GIR_EraseRootFromParent_Done,
     /* 1830219 */   // Label 24767: @1830219
     /* 1830219 */   GIM_Try, /*On fail goto*//*Label 24768*/ GIMT_Encode4(1830305), // Rule ID 13112 //
     /* 1830224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1830244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830270 */     // MIs[0] policy
     /* 1830270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1830283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830304 */     // GIR_Coverage, 13112,
     /* 1830304 */     GIR_EraseRootFromParent_Done,
     /* 1830305 */   // Label 24768: @1830305
     /* 1830305 */   GIM_Try, /*On fail goto*//*Label 24769*/ GIMT_Encode4(1830391), // Rule ID 13113 //
     /* 1830310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1830321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1830324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1830330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830356 */     // MIs[0] policy
     /* 1830356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1830369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830390 */     // GIR_Coverage, 13113,
     /* 1830390 */     GIR_EraseRootFromParent_Done,
     /* 1830391 */   // Label 24769: @1830391
     /* 1830391 */   GIM_Try, /*On fail goto*//*Label 24770*/ GIMT_Encode4(1830477), // Rule ID 13116 //
     /* 1830396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1830407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1830410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1830416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830442 */     // MIs[0] policy
     /* 1830442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830452 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1830455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830476 */     // GIR_Coverage, 13116,
     /* 1830476 */     GIR_EraseRootFromParent_Done,
     /* 1830477 */   // Label 24770: @1830477
     /* 1830477 */   GIM_Try, /*On fail goto*//*Label 24771*/ GIMT_Encode4(1830563), // Rule ID 13117 //
     /* 1830482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1830493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1830496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1830502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1830505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830528 */     // MIs[0] policy
     /* 1830528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830538 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1830541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830562 */     // GIR_Coverage, 13117,
     /* 1830562 */     GIR_EraseRootFromParent_Done,
     /* 1830563 */   // Label 24771: @1830563
     /* 1830563 */   GIM_Try, /*On fail goto*//*Label 24772*/ GIMT_Encode4(1830649), // Rule ID 13120 //
     /* 1830568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1830571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830614 */     // MIs[0] policy
     /* 1830614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830624 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1830627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830648 */     // GIR_Coverage, 13120,
     /* 1830648 */     GIR_EraseRootFromParent_Done,
     /* 1830649 */   // Label 24772: @1830649
     /* 1830649 */   GIM_Try, /*On fail goto*//*Label 24773*/ GIMT_Encode4(1830735), // Rule ID 13121 //
     /* 1830654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1830657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1830665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1830668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1830674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1830677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1830684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1830696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830700 */     // MIs[0] policy
     /* 1830700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830710 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1830713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1830731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830734 */     // GIR_Coverage, 13121,
     /* 1830734 */     GIR_EraseRootFromParent_Done,
     /* 1830735 */   // Label 24773: @1830735
     /* 1830735 */   GIM_Try, /*On fail goto*//*Label 24774*/ GIMT_Encode4(1830821), // Rule ID 13124 //
     /* 1830740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830786 */     // MIs[0] policy
     /* 1830786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830796 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1830799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830820 */     // GIR_Coverage, 13124,
     /* 1830820 */     GIR_EraseRootFromParent_Done,
     /* 1830821 */   // Label 24774: @1830821
     /* 1830821 */   GIM_Try, /*On fail goto*//*Label 24775*/ GIMT_Encode4(1830907), // Rule ID 13125 //
     /* 1830826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1830829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1830837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1830840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1830843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1830846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1830849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1830852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1830856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1830868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830872 */     // MIs[0] policy
     /* 1830872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11338:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1830882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M2_MASK),
     /* 1830885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830906 */     // GIR_Coverage, 13125,
     /* 1830906 */     GIR_EraseRootFromParent_Done,
     /* 1830907 */   // Label 24775: @1830907
     /* 1830907 */   GIM_Try, /*On fail goto*//*Label 24776*/ GIMT_Encode4(1830993), // Rule ID 13128 //
     /* 1830912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1830915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1830920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1830923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1830926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1830929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1830932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1830935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1830938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1830942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1830950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1830954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1830958 */     // MIs[0] policy
     /* 1830958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1830961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1830968 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1830968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1830971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1830973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1830975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1830977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1830979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1830981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1830986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1830989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1830991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1830992 */     // GIR_Coverage, 13128,
     /* 1830992 */     GIR_EraseRootFromParent_Done,
     /* 1830993 */   // Label 24776: @1830993
     /* 1830993 */   GIM_Try, /*On fail goto*//*Label 24777*/ GIMT_Encode4(1831079), // Rule ID 13129 //
     /* 1830998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1831009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1831012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1831018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1831028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1831040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831044 */     // MIs[0] policy
     /* 1831044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831054 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11338:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M4_MASK),
     /* 1831057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831078 */     // GIR_Coverage, 13129,
     /* 1831078 */     GIR_EraseRootFromParent_Done,
     /* 1831079 */   // Label 24777: @1831079
     /* 1831079 */   GIM_Try, /*On fail goto*//*Label 24778*/ GIMT_Encode4(1831165), // Rule ID 13132 //
     /* 1831084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1831087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1831101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1831104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831130 */     // MIs[0] policy
     /* 1831130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831140 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1831143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831164 */     // GIR_Coverage, 13132,
     /* 1831164 */     GIR_EraseRootFromParent_Done,
     /* 1831165 */   // Label 24778: @1831165
     /* 1831165 */   GIM_Try, /*On fail goto*//*Label 24779*/ GIMT_Encode4(1831251), // Rule ID 13133 //
     /* 1831170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1831173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vmacc_mask),
     /* 1831178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1831181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1831184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1831187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1831190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1831193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1831200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1831208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1831212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831216 */     // MIs[0] policy
     /* 1831216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831226 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11338:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVMACC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMACC_VX_M8_MASK),
     /* 1831229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1831247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831250 */     // GIR_Coverage, 13133,
     /* 1831250 */     GIR_EraseRootFromParent_Done,
     /* 1831251 */   // Label 24779: @1831251
     /* 1831251 */   GIM_Try, /*On fail goto*//*Label 24780*/ GIMT_Encode4(1831337), // Rule ID 13136 //
     /* 1831256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1831273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1831276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831302 */     // MIs[0] policy
     /* 1831302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831312 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1831315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831336 */     // GIR_Coverage, 13136,
     /* 1831336 */     GIR_EraseRootFromParent_Done,
     /* 1831337 */   // Label 24780: @1831337
     /* 1831337 */   GIM_Try, /*On fail goto*//*Label 24781*/ GIMT_Encode4(1831423), // Rule ID 13137 //
     /* 1831342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1831353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1831356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1831359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1831362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831388 */     // MIs[0] policy
     /* 1831388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831398 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF8_MASK),
     /* 1831401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831403 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831422 */     // GIR_Coverage, 13137,
     /* 1831422 */     GIR_EraseRootFromParent_Done,
     /* 1831423 */   // Label 24781: @1831423
     /* 1831423 */   GIM_Try, /*On fail goto*//*Label 24782*/ GIMT_Encode4(1831509), // Rule ID 13140 //
     /* 1831428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1831448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831474 */     // MIs[0] policy
     /* 1831474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831484 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1831487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831508 */     // GIR_Coverage, 13140,
     /* 1831508 */     GIR_EraseRootFromParent_Done,
     /* 1831509 */   // Label 24782: @1831509
     /* 1831509 */   GIM_Try, /*On fail goto*//*Label 24783*/ GIMT_Encode4(1831595), // Rule ID 13141 //
     /* 1831514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1831525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1831528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1831531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1831534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831560 */     // MIs[0] policy
     /* 1831560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831570 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1831573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831594 */     // GIR_Coverage, 13141,
     /* 1831594 */     GIR_EraseRootFromParent_Done,
     /* 1831595 */   // Label 24783: @1831595
     /* 1831595 */   GIM_Try, /*On fail goto*//*Label 24784*/ GIMT_Encode4(1831681), // Rule ID 13144 //
     /* 1831600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831646 */     // MIs[0] policy
     /* 1831646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831656 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1831659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831680 */     // GIR_Coverage, 13144,
     /* 1831680 */     GIR_EraseRootFromParent_Done,
     /* 1831681 */   // Label 24784: @1831681
     /* 1831681 */   GIM_Try, /*On fail goto*//*Label 24785*/ GIMT_Encode4(1831767), // Rule ID 13145 //
     /* 1831686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1831697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1831700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1831703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1831706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1831709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831732 */     // MIs[0] policy
     /* 1831732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831742 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1831745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831747 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1831763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831766 */     // GIR_Coverage, 13145,
     /* 1831766 */     GIR_EraseRootFromParent_Done,
     /* 1831767 */   // Label 24785: @1831767
     /* 1831767 */   GIM_Try, /*On fail goto*//*Label 24786*/ GIMT_Encode4(1831853), // Rule ID 13148 //
     /* 1831772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831818 */     // MIs[0] policy
     /* 1831818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831828 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1831828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1831831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831852 */     // GIR_Coverage, 13148,
     /* 1831852 */     GIR_EraseRootFromParent_Done,
     /* 1831853 */   // Label 24786: @1831853
     /* 1831853 */   GIM_Try, /*On fail goto*//*Label 24787*/ GIMT_Encode4(1831939), // Rule ID 13149 //
     /* 1831858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1831861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1831869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1831872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1831875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1831878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1831881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1831884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831904 */     // MIs[0] policy
     /* 1831904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1831914 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1831914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF4_MASK),
     /* 1831917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1831919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1831921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1831923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1831925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1831927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1831932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1831935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1831937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1831938 */     // GIR_Coverage, 13149,
     /* 1831938 */     GIR_EraseRootFromParent_Done,
     /* 1831939 */   // Label 24787: @1831939
     /* 1831939 */   GIM_Try, /*On fail goto*//*Label 24788*/ GIMT_Encode4(1832025), // Rule ID 13152 //
     /* 1831944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1831947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1831952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1831955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1831958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1831961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1831964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1831967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1831970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1831974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1831986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1831990 */     // MIs[0] policy
     /* 1831990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1831993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832000 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1832003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832024 */     // GIR_Coverage, 13152,
     /* 1832024 */     GIR_EraseRootFromParent_Done,
     /* 1832025 */   // Label 24788: @1832025
     /* 1832025 */   GIM_Try, /*On fail goto*//*Label 24789*/ GIMT_Encode4(1832111), // Rule ID 13153 //
     /* 1832030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1832041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1832044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1832047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1832050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832076 */     // MIs[0] policy
     /* 1832076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832086 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1832089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832110 */     // GIR_Coverage, 13153,
     /* 1832110 */     GIR_EraseRootFromParent_Done,
     /* 1832111 */   // Label 24789: @1832111
     /* 1832111 */   GIM_Try, /*On fail goto*//*Label 24790*/ GIMT_Encode4(1832197), // Rule ID 13156 //
     /* 1832116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1832133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1832136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832162 */     // MIs[0] policy
     /* 1832162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832172 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1832175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832196 */     // GIR_Coverage, 13156,
     /* 1832196 */     GIR_EraseRootFromParent_Done,
     /* 1832197 */   // Label 24790: @1832197
     /* 1832197 */   GIM_Try, /*On fail goto*//*Label 24791*/ GIMT_Encode4(1832283), // Rule ID 13157 //
     /* 1832202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1832213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1832216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1832219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1832222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832248 */     // MIs[0] policy
     /* 1832248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832258 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_MF2_MASK),
     /* 1832261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832282 */     // GIR_Coverage, 13157,
     /* 1832282 */     GIR_EraseRootFromParent_Done,
     /* 1832283 */   // Label 24791: @1832283
     /* 1832283 */   GIM_Try, /*On fail goto*//*Label 24792*/ GIMT_Encode4(1832369), // Rule ID 13160 //
     /* 1832288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1832305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1832308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832334 */     // MIs[0] policy
     /* 1832334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832344 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832368 */     // GIR_Coverage, 13160,
     /* 1832368 */     GIR_EraseRootFromParent_Done,
     /* 1832369 */   // Label 24792: @1832369
     /* 1832369 */   GIM_Try, /*On fail goto*//*Label 24793*/ GIMT_Encode4(1832455), // Rule ID 13161 //
     /* 1832374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1832385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1832388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1832391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1832394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1832397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832420 */     // MIs[0] policy
     /* 1832420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832430 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1832451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832454 */     // GIR_Coverage, 13161,
     /* 1832454 */     GIR_EraseRootFromParent_Done,
     /* 1832455 */   // Label 24793: @1832455
     /* 1832455 */   GIM_Try, /*On fail goto*//*Label 24794*/ GIMT_Encode4(1832541), // Rule ID 13164 //
     /* 1832460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1832480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832506 */     // MIs[0] policy
     /* 1832506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832516 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832540 */     // GIR_Coverage, 13164,
     /* 1832540 */     GIR_EraseRootFromParent_Done,
     /* 1832541 */   // Label 24794: @1832541
     /* 1832541 */   GIM_Try, /*On fail goto*//*Label 24795*/ GIMT_Encode4(1832627), // Rule ID 13165 //
     /* 1832546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1832557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1832560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1832563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1832566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1832569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832592 */     // MIs[0] policy
     /* 1832592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832602 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1832623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832626 */     // GIR_Coverage, 13165,
     /* 1832626 */     GIR_EraseRootFromParent_Done,
     /* 1832627 */   // Label 24795: @1832627
     /* 1832627 */   GIM_Try, /*On fail goto*//*Label 24796*/ GIMT_Encode4(1832713), // Rule ID 13168 //
     /* 1832632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832678 */     // MIs[0] policy
     /* 1832678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832688 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832712 */     // GIR_Coverage, 13168,
     /* 1832712 */     GIR_EraseRootFromParent_Done,
     /* 1832713 */   // Label 24796: @1832713
     /* 1832713 */   GIM_Try, /*On fail goto*//*Label 24797*/ GIMT_Encode4(1832799), // Rule ID 13169 //
     /* 1832718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1832721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1832729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1832732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1832735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1832738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1832741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832764 */     // MIs[0] policy
     /* 1832764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832774 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1832795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832798 */     // GIR_Coverage, 13169,
     /* 1832798 */     GIR_EraseRootFromParent_Done,
     /* 1832799 */   // Label 24797: @1832799
     /* 1832799 */   GIM_Try, /*On fail goto*//*Label 24798*/ GIMT_Encode4(1832885), // Rule ID 13172 //
     /* 1832804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1832807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1832830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832850 */     // MIs[0] policy
     /* 1832850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832860 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1832860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832884 */     // GIR_Coverage, 13172,
     /* 1832884 */     GIR_EraseRootFromParent_Done,
     /* 1832885 */   // Label 24798: @1832885
     /* 1832885 */   GIM_Try, /*On fail goto*//*Label 24799*/ GIMT_Encode4(1832971), // Rule ID 13173 //
     /* 1832890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1832893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1832901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1832904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1832907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1832910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1832913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1832916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1832920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1832932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1832936 */     // MIs[0] policy
     /* 1832936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1832939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1832946 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1832946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M1_MASK),
     /* 1832949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1832951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1832953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1832955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1832957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1832959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1832964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1832967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1832969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1832970 */     // GIR_Coverage, 13173,
     /* 1832970 */     GIR_EraseRootFromParent_Done,
     /* 1832971 */   // Label 24799: @1832971
     /* 1832971 */   GIM_Try, /*On fail goto*//*Label 24800*/ GIMT_Encode4(1833057), // Rule ID 13176 //
     /* 1832976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1832979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1832984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1832987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1832990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1832993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1832996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1832999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833022 */     // MIs[0] policy
     /* 1833022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833032 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1833035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833056 */     // GIR_Coverage, 13176,
     /* 1833056 */     GIR_EraseRootFromParent_Done,
     /* 1833057 */   // Label 24800: @1833057
     /* 1833057 */   GIM_Try, /*On fail goto*//*Label 24801*/ GIMT_Encode4(1833143), // Rule ID 13177 //
     /* 1833062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1833073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1833076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1833079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1833082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833108 */     // MIs[0] policy
     /* 1833108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833118 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1833121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833142 */     // GIR_Coverage, 13177,
     /* 1833142 */     GIR_EraseRootFromParent_Done,
     /* 1833143 */   // Label 24801: @1833143
     /* 1833143 */   GIM_Try, /*On fail goto*//*Label 24802*/ GIMT_Encode4(1833229), // Rule ID 13180 //
     /* 1833148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1833165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1833168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833194 */     // MIs[0] policy
     /* 1833194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833204 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1833207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833228 */     // GIR_Coverage, 13180,
     /* 1833228 */     GIR_EraseRootFromParent_Done,
     /* 1833229 */   // Label 24802: @1833229
     /* 1833229 */   GIM_Try, /*On fail goto*//*Label 24803*/ GIMT_Encode4(1833315), // Rule ID 13181 //
     /* 1833234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1833245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1833248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1833251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1833254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833280 */     // MIs[0] policy
     /* 1833280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833290 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1833293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833314 */     // GIR_Coverage, 13181,
     /* 1833314 */     GIR_EraseRootFromParent_Done,
     /* 1833315 */   // Label 24803: @1833315
     /* 1833315 */   GIM_Try, /*On fail goto*//*Label 24804*/ GIMT_Encode4(1833401), // Rule ID 13184 //
     /* 1833320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1833337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1833340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833366 */     // MIs[0] policy
     /* 1833366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833376 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1833379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833400 */     // GIR_Coverage, 13184,
     /* 1833400 */     GIR_EraseRootFromParent_Done,
     /* 1833401 */   // Label 24804: @1833401
     /* 1833401 */   GIM_Try, /*On fail goto*//*Label 24805*/ GIMT_Encode4(1833487), // Rule ID 13185 //
     /* 1833406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1833417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1833420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1833423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1833426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1833429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833452 */     // MIs[0] policy
     /* 1833452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833462 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1833465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1833483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833486 */     // GIR_Coverage, 13185,
     /* 1833486 */     GIR_EraseRootFromParent_Done,
     /* 1833487 */   // Label 24805: @1833487
     /* 1833487 */   GIM_Try, /*On fail goto*//*Label 24806*/ GIMT_Encode4(1833573), // Rule ID 13188 //
     /* 1833492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1833512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833538 */     // MIs[0] policy
     /* 1833538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1833551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833572 */     // GIR_Coverage, 13188,
     /* 1833572 */     GIR_EraseRootFromParent_Done,
     /* 1833573 */   // Label 24806: @1833573
     /* 1833573 */   GIM_Try, /*On fail goto*//*Label 24807*/ GIMT_Encode4(1833659), // Rule ID 13189 //
     /* 1833578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1833589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1833592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1833595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1833598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1833601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1833608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1833620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833624 */     // MIs[0] policy
     /* 1833624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833634 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1833637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833658 */     // GIR_Coverage, 13189,
     /* 1833658 */     GIR_EraseRootFromParent_Done,
     /* 1833659 */   // Label 24807: @1833659
     /* 1833659 */   GIM_Try, /*On fail goto*//*Label 24808*/ GIMT_Encode4(1833745), // Rule ID 13192 //
     /* 1833664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833710 */     // MIs[0] policy
     /* 1833710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833720 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1833723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833744 */     // GIR_Coverage, 13192,
     /* 1833744 */     GIR_EraseRootFromParent_Done,
     /* 1833745 */   // Label 24808: @1833745
     /* 1833745 */   GIM_Try, /*On fail goto*//*Label 24809*/ GIMT_Encode4(1833831), // Rule ID 13193 //
     /* 1833750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1833761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1833764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1833767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1833770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1833773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1833780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1833792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833796 */     // MIs[0] policy
     /* 1833796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833806 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1833809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833830 */     // GIR_Coverage, 13193,
     /* 1833830 */     GIR_EraseRootFromParent_Done,
     /* 1833831 */   // Label 24809: @1833831
     /* 1833831 */   GIM_Try, /*On fail goto*//*Label 24810*/ GIMT_Encode4(1833917), // Rule ID 13196 //
     /* 1833836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1833839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1833862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833882 */     // MIs[0] policy
     /* 1833882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833892 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1833892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1833895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1833915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1833916 */     // GIR_Coverage, 13196,
     /* 1833916 */     GIR_EraseRootFromParent_Done,
     /* 1833917 */   // Label 24810: @1833917
     /* 1833917 */   GIM_Try, /*On fail goto*//*Label 24811*/ GIMT_Encode4(1834003), // Rule ID 13197 //
     /* 1833922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1833925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1833930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1833933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1833936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1833939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1833942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1833945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1833948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1833952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1833964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1833968 */     // MIs[0] policy
     /* 1833968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1833971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1833978 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1833978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1833981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1833983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1833985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1833987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1833989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1833991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1833996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1833999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834002 */     // GIR_Coverage, 13197,
     /* 1834002 */     GIR_EraseRootFromParent_Done,
     /* 1834003 */   // Label 24811: @1834003
     /* 1834003 */   GIM_Try, /*On fail goto*//*Label 24812*/ GIMT_Encode4(1834089), // Rule ID 13200 //
     /* 1834008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1834025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1834028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834054 */     // MIs[0] policy
     /* 1834054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1834067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834088 */     // GIR_Coverage, 13200,
     /* 1834088 */     GIR_EraseRootFromParent_Done,
     /* 1834089 */   // Label 24812: @1834089
     /* 1834089 */   GIM_Try, /*On fail goto*//*Label 24813*/ GIMT_Encode4(1834175), // Rule ID 13201 //
     /* 1834094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1834105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1834108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1834111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1834114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834140 */     // MIs[0] policy
     /* 1834140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834150 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1834153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834174 */     // GIR_Coverage, 13201,
     /* 1834174 */     GIR_EraseRootFromParent_Done,
     /* 1834175 */   // Label 24813: @1834175
     /* 1834175 */   GIM_Try, /*On fail goto*//*Label 24814*/ GIMT_Encode4(1834261), // Rule ID 13204 //
     /* 1834180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1834197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1834200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834226 */     // MIs[0] policy
     /* 1834226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834236 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1834239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834260 */     // GIR_Coverage, 13204,
     /* 1834260 */     GIR_EraseRootFromParent_Done,
     /* 1834261 */   // Label 24814: @1834261
     /* 1834261 */   GIM_Try, /*On fail goto*//*Label 24815*/ GIMT_Encode4(1834347), // Rule ID 13205 //
     /* 1834266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1834277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1834280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1834283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1834286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834312 */     // MIs[0] policy
     /* 1834312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834322 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1834325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834346 */     // GIR_Coverage, 13205,
     /* 1834346 */     GIR_EraseRootFromParent_Done,
     /* 1834347 */   // Label 24815: @1834347
     /* 1834347 */   GIM_Try, /*On fail goto*//*Label 24816*/ GIMT_Encode4(1834433), // Rule ID 13208 //
     /* 1834352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1834355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1834363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1834366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1834369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1834372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834398 */     // MIs[0] policy
     /* 1834398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1834411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834432 */     // GIR_Coverage, 13208,
     /* 1834432 */     GIR_EraseRootFromParent_Done,
     /* 1834433 */   // Label 24816: @1834433
     /* 1834433 */   GIM_Try, /*On fail goto*//*Label 24817*/ GIMT_Encode4(1834519), // Rule ID 13209 //
     /* 1834438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1834441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1834449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1834452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1834455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1834458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1834461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834484 */     // MIs[0] policy
     /* 1834484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834494 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1834497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1834515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834518 */     // GIR_Coverage, 13209,
     /* 1834518 */     GIR_EraseRootFromParent_Done,
     /* 1834519 */   // Label 24817: @1834519
     /* 1834519 */   GIM_Try, /*On fail goto*//*Label 24818*/ GIMT_Encode4(1834605), // Rule ID 13212 //
     /* 1834524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834570 */     // MIs[0] policy
     /* 1834570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834580 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1834583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834604 */     // GIR_Coverage, 13212,
     /* 1834604 */     GIR_EraseRootFromParent_Done,
     /* 1834605 */   // Label 24818: @1834605
     /* 1834605 */   GIM_Try, /*On fail goto*//*Label 24819*/ GIMT_Encode4(1834691), // Rule ID 13213 //
     /* 1834610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1834621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1834624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1834627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1834630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1834633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1834640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1834652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834656 */     // MIs[0] policy
     /* 1834656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M2_MASK),
     /* 1834669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834690 */     // GIR_Coverage, 13213,
     /* 1834690 */     GIR_EraseRootFromParent_Done,
     /* 1834691 */   // Label 24819: @1834691
     /* 1834691 */   GIM_Try, /*On fail goto*//*Label 24820*/ GIMT_Encode4(1834777), // Rule ID 13216 //
     /* 1834696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834742 */     // MIs[0] policy
     /* 1834742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834752 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1834755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834776 */     // GIR_Coverage, 13216,
     /* 1834776 */     GIR_EraseRootFromParent_Done,
     /* 1834777 */   // Label 24820: @1834777
     /* 1834777 */   GIM_Try, /*On fail goto*//*Label 24821*/ GIMT_Encode4(1834863), // Rule ID 13217 //
     /* 1834782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1834793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1834796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1834799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1834802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1834805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1834812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1834824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834828 */     // MIs[0] policy
     /* 1834828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834838 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1834838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M4_MASK),
     /* 1834841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834862 */     // GIR_Coverage, 13217,
     /* 1834862 */     GIR_EraseRootFromParent_Done,
     /* 1834863 */   // Label 24821: @1834863
     /* 1834863 */   GIM_Try, /*On fail goto*//*Label 24822*/ GIMT_Encode4(1834949), // Rule ID 13220 //
     /* 1834868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1834871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1834894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1834914 */     // MIs[0] policy
     /* 1834914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1834917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1834924 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1834924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1834927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1834929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1834931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1834933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1834935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1834937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1834942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1834945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1834947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1834948 */     // GIR_Coverage, 13220,
     /* 1834948 */     GIR_EraseRootFromParent_Done,
     /* 1834949 */   // Label 24822: @1834949
     /* 1834949 */   GIM_Try, /*On fail goto*//*Label 24823*/ GIMT_Encode4(1835035), // Rule ID 13221 //
     /* 1834954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1834957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1834962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1834965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1834968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1834971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1834974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1834977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1834980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1834984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1834996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835000 */     // MIs[0] policy
     /* 1835000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835010 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VV_M8_MASK),
     /* 1835013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1835031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835034 */     // GIR_Coverage, 13221,
     /* 1835034 */     GIR_EraseRootFromParent_Done,
     /* 1835035 */   // Label 24823: @1835035
     /* 1835035 */   GIM_Try, /*On fail goto*//*Label 24824*/ GIMT_Encode4(1835121), // Rule ID 13224 //
     /* 1835040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1835051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1835054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1835060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835086 */     // MIs[0] policy
     /* 1835086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835096 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1835099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835120 */     // GIR_Coverage, 13224,
     /* 1835120 */     GIR_EraseRootFromParent_Done,
     /* 1835121 */   // Label 24824: @1835121
     /* 1835121 */   GIM_Try, /*On fail goto*//*Label 24825*/ GIMT_Encode4(1835207), // Rule ID 13225 //
     /* 1835126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1835137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1835140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1835146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835172 */     // MIs[0] policy
     /* 1835172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835182 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF8_MASK),
     /* 1835185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835206 */     // GIR_Coverage, 13225,
     /* 1835206 */     GIR_EraseRootFromParent_Done,
     /* 1835207 */   // Label 24825: @1835207
     /* 1835207 */   GIM_Try, /*On fail goto*//*Label 24826*/ GIMT_Encode4(1835293), // Rule ID 13228 //
     /* 1835212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1835223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1835226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1835232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835258 */     // MIs[0] policy
     /* 1835258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1835271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835292 */     // GIR_Coverage, 13228,
     /* 1835292 */     GIR_EraseRootFromParent_Done,
     /* 1835293 */   // Label 24826: @1835293
     /* 1835293 */   GIM_Try, /*On fail goto*//*Label 24827*/ GIMT_Encode4(1835379), // Rule ID 13229 //
     /* 1835298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1835309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1835312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1835318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835344 */     // MIs[0] policy
     /* 1835344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835354 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1835357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835378 */     // GIR_Coverage, 13229,
     /* 1835378 */     GIR_EraseRootFromParent_Done,
     /* 1835379 */   // Label 24827: @1835379
     /* 1835379 */   GIM_Try, /*On fail goto*//*Label 24828*/ GIMT_Encode4(1835465), // Rule ID 13232 //
     /* 1835384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1835395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1835398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1835404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835430 */     // MIs[0] policy
     /* 1835430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835440 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1835443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835464 */     // GIR_Coverage, 13232,
     /* 1835464 */     GIR_EraseRootFromParent_Done,
     /* 1835465 */   // Label 24828: @1835465
     /* 1835465 */   GIM_Try, /*On fail goto*//*Label 24829*/ GIMT_Encode4(1835551), // Rule ID 13233 //
     /* 1835470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1835481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1835484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1835490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1835493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835516 */     // MIs[0] policy
     /* 1835516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835526 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1835529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1835547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835550 */     // GIR_Coverage, 13233,
     /* 1835550 */     GIR_EraseRootFromParent_Done,
     /* 1835551 */   // Label 24829: @1835551
     /* 1835551 */   GIM_Try, /*On fail goto*//*Label 24830*/ GIMT_Encode4(1835637), // Rule ID 13236 //
     /* 1835556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835602 */     // MIs[0] policy
     /* 1835602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835612 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1835615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835636 */     // GIR_Coverage, 13236,
     /* 1835636 */     GIR_EraseRootFromParent_Done,
     /* 1835637 */   // Label 24830: @1835637
     /* 1835637 */   GIM_Try, /*On fail goto*//*Label 24831*/ GIMT_Encode4(1835723), // Rule ID 13237 //
     /* 1835642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1835653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1835656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1835662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835688 */     // MIs[0] policy
     /* 1835688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835698 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF4_MASK),
     /* 1835701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835722 */     // GIR_Coverage, 13237,
     /* 1835722 */     GIR_EraseRootFromParent_Done,
     /* 1835723 */   // Label 24831: @1835723
     /* 1835723 */   GIM_Try, /*On fail goto*//*Label 24832*/ GIMT_Encode4(1835809), // Rule ID 13240 //
     /* 1835728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835774 */     // MIs[0] policy
     /* 1835774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835784 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1835787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835808 */     // GIR_Coverage, 13240,
     /* 1835808 */     GIR_EraseRootFromParent_Done,
     /* 1835809 */   // Label 24832: @1835809
     /* 1835809 */   GIM_Try, /*On fail goto*//*Label 24833*/ GIMT_Encode4(1835895), // Rule ID 13241 //
     /* 1835814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1835825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1835828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1835831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1835834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1835837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1835840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835860 */     // MIs[0] policy
     /* 1835860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835870 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1835870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1835873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1835891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835894 */     // GIR_Coverage, 13241,
     /* 1835894 */     GIR_EraseRootFromParent_Done,
     /* 1835895 */   // Label 24833: @1835895
     /* 1835895 */   GIM_Try, /*On fail goto*//*Label 24834*/ GIMT_Encode4(1835981), // Rule ID 13244 //
     /* 1835900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1835903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1835914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1835917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1835920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1835923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1835926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1835930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1835938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1835942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1835946 */     // MIs[0] policy
     /* 1835946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1835949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1835956 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1835956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1835959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1835961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1835963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1835965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1835967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1835969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1835974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1835977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1835979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1835980 */     // GIR_Coverage, 13244,
     /* 1835980 */     GIR_EraseRootFromParent_Done,
     /* 1835981 */   // Label 24834: @1835981
     /* 1835981 */   GIM_Try, /*On fail goto*//*Label 24835*/ GIMT_Encode4(1836067), // Rule ID 13245 //
     /* 1835986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1835989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1835994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1835997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1836000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1836006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836032 */     // MIs[0] policy
     /* 1836032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_MF2_MASK),
     /* 1836045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836066 */     // GIR_Coverage, 13245,
     /* 1836066 */     GIR_EraseRootFromParent_Done,
     /* 1836067 */   // Label 24835: @1836067
     /* 1836067 */   GIM_Try, /*On fail goto*//*Label 24836*/ GIMT_Encode4(1836153), // Rule ID 13248 //
     /* 1836072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1836083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1836086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1836092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836118 */     // MIs[0] policy
     /* 1836118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836128 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836152 */     // GIR_Coverage, 13248,
     /* 1836152 */     GIR_EraseRootFromParent_Done,
     /* 1836153 */   // Label 24836: @1836153
     /* 1836153 */   GIM_Try, /*On fail goto*//*Label 24837*/ GIMT_Encode4(1836239), // Rule ID 13249 //
     /* 1836158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1836169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1836172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1836178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1836181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836204 */     // MIs[0] policy
     /* 1836204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836214 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11419:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836238 */     // GIR_Coverage, 13249,
     /* 1836238 */     GIR_EraseRootFromParent_Done,
     /* 1836239 */   // Label 24837: @1836239
     /* 1836239 */   GIM_Try, /*On fail goto*//*Label 24838*/ GIMT_Encode4(1836325), // Rule ID 13252 //
     /* 1836244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1836255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1836258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1836264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836290 */     // MIs[0] policy
     /* 1836290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836300 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836324 */     // GIR_Coverage, 13252,
     /* 1836324 */     GIR_EraseRootFromParent_Done,
     /* 1836325 */   // Label 24838: @1836325
     /* 1836325 */   GIM_Try, /*On fail goto*//*Label 24839*/ GIMT_Encode4(1836411), // Rule ID 13253 //
     /* 1836330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1836341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1836344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1836350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1836353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836376 */     // MIs[0] policy
     /* 1836376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836386 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11419:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1836407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836410 */     // GIR_Coverage, 13253,
     /* 1836410 */     GIR_EraseRootFromParent_Done,
     /* 1836411 */   // Label 24839: @1836411
     /* 1836411 */   GIM_Try, /*On fail goto*//*Label 24840*/ GIMT_Encode4(1836497), // Rule ID 13256 //
     /* 1836416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1836427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1836436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836462 */     // MIs[0] policy
     /* 1836462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836472 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836496 */     // GIR_Coverage, 13256,
     /* 1836496 */     GIR_EraseRootFromParent_Done,
     /* 1836497 */   // Label 24840: @1836497
     /* 1836497 */   GIM_Try, /*On fail goto*//*Label 24841*/ GIMT_Encode4(1836583), // Rule ID 13257 //
     /* 1836502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1836513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1836516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1836522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1836525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836548 */     // MIs[0] policy
     /* 1836548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836558 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11419:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1836579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836582 */     // GIR_Coverage, 13257,
     /* 1836582 */     GIR_EraseRootFromParent_Done,
     /* 1836583 */   // Label 24841: @1836583
     /* 1836583 */   GIM_Try, /*On fail goto*//*Label 24842*/ GIMT_Encode4(1836669), // Rule ID 13260 //
     /* 1836588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1836591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836634 */     // MIs[0] policy
     /* 1836634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836644 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836668 */     // GIR_Coverage, 13260,
     /* 1836668 */     GIR_EraseRootFromParent_Done,
     /* 1836669 */   // Label 24842: @1836669
     /* 1836669 */   GIM_Try, /*On fail goto*//*Label 24843*/ GIMT_Encode4(1836755), // Rule ID 13261 //
     /* 1836674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1836677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1836685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1836688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1836694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1836697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1836704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1836716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836720 */     // MIs[0] policy
     /* 1836720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836730 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11419:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M1_MASK),
     /* 1836733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1836751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836754 */     // GIR_Coverage, 13261,
     /* 1836754 */     GIR_EraseRootFromParent_Done,
     /* 1836755 */   // Label 24843: @1836755
     /* 1836755 */   GIM_Try, /*On fail goto*//*Label 24844*/ GIMT_Encode4(1836841), // Rule ID 13264 //
     /* 1836760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836806 */     // MIs[0] policy
     /* 1836806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836816 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1836819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836840 */     // GIR_Coverage, 13264,
     /* 1836840 */     GIR_EraseRootFromParent_Done,
     /* 1836841 */   // Label 24844: @1836841
     /* 1836841 */   GIM_Try, /*On fail goto*//*Label 24845*/ GIMT_Encode4(1836927), // Rule ID 13265 //
     /* 1836846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1836849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1836857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1836860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1836863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1836866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1836869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1836872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1836876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1836888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836892 */     // MIs[0] policy
     /* 1836892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836902 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1836902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1836905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1836915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1836920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1836923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1836925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1836926 */     // GIR_Coverage, 13265,
     /* 1836926 */     GIR_EraseRootFromParent_Done,
     /* 1836927 */   // Label 24845: @1836927
     /* 1836927 */   GIM_Try, /*On fail goto*//*Label 24846*/ GIMT_Encode4(1837013), // Rule ID 13268 //
     /* 1836932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1836935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1836940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1836943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1836946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1836949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1836952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1836955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1836958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1836962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1836970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1836974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1836978 */     // MIs[0] policy
     /* 1836978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1836981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1836988 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1836988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1836991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1836993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1836995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1836997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1836999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837012 */     // GIR_Coverage, 13268,
     /* 1837012 */     GIR_EraseRootFromParent_Done,
     /* 1837013 */   // Label 24846: @1837013
     /* 1837013 */   GIM_Try, /*On fail goto*//*Label 24847*/ GIMT_Encode4(1837099), // Rule ID 13269 //
     /* 1837018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1837029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1837032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1837038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837064 */     // MIs[0] policy
     /* 1837064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837074 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1837077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837098 */     // GIR_Coverage, 13269,
     /* 1837098 */     GIR_EraseRootFromParent_Done,
     /* 1837099 */   // Label 24847: @1837099
     /* 1837099 */   GIM_Try, /*On fail goto*//*Label 24848*/ GIMT_Encode4(1837185), // Rule ID 13272 //
     /* 1837104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1837115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1837118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1837124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1837127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837150 */     // MIs[0] policy
     /* 1837150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837160 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1837163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837184 */     // GIR_Coverage, 13272,
     /* 1837184 */     GIR_EraseRootFromParent_Done,
     /* 1837185 */   // Label 24848: @1837185
     /* 1837185 */   GIM_Try, /*On fail goto*//*Label 24849*/ GIMT_Encode4(1837271), // Rule ID 13273 //
     /* 1837190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1837201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1837204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1837210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1837213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837236 */     // MIs[0] policy
     /* 1837236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837246 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1837249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1837267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837270 */     // GIR_Coverage, 13273,
     /* 1837270 */     GIR_EraseRootFromParent_Done,
     /* 1837271 */   // Label 24849: @1837271
     /* 1837271 */   GIM_Try, /*On fail goto*//*Label 24850*/ GIMT_Encode4(1837357), // Rule ID 13276 //
     /* 1837276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1837287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1837290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1837296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837322 */     // MIs[0] policy
     /* 1837322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837332 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1837335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837356 */     // GIR_Coverage, 13276,
     /* 1837356 */     GIR_EraseRootFromParent_Done,
     /* 1837357 */   // Label 24850: @1837357
     /* 1837357 */   GIM_Try, /*On fail goto*//*Label 24851*/ GIMT_Encode4(1837443), // Rule ID 13277 //
     /* 1837362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1837373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1837376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1837382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837408 */     // MIs[0] policy
     /* 1837408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837418 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1837421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837442 */     // GIR_Coverage, 13277,
     /* 1837442 */     GIR_EraseRootFromParent_Done,
     /* 1837443 */   // Label 24851: @1837443
     /* 1837443 */   GIM_Try, /*On fail goto*//*Label 24852*/ GIMT_Encode4(1837529), // Rule ID 13280 //
     /* 1837448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1837459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1837462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1837468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837494 */     // MIs[0] policy
     /* 1837494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837504 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1837507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837528 */     // GIR_Coverage, 13280,
     /* 1837528 */     GIR_EraseRootFromParent_Done,
     /* 1837529 */   // Label 24852: @1837529
     /* 1837529 */   GIM_Try, /*On fail goto*//*Label 24853*/ GIMT_Encode4(1837615), // Rule ID 13281 //
     /* 1837534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1837545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1837548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1837554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1837557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837580 */     // MIs[0] policy
     /* 1837580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837590 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1837593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837614 */     // GIR_Coverage, 13281,
     /* 1837614 */     GIR_EraseRootFromParent_Done,
     /* 1837615 */   // Label 24853: @1837615
     /* 1837615 */   GIM_Try, /*On fail goto*//*Label 24854*/ GIMT_Encode4(1837701), // Rule ID 13284 //
     /* 1837620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837666 */     // MIs[0] policy
     /* 1837666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837676 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1837679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837700 */     // GIR_Coverage, 13284,
     /* 1837700 */     GIR_EraseRootFromParent_Done,
     /* 1837701 */   // Label 24854: @1837701
     /* 1837701 */   GIM_Try, /*On fail goto*//*Label 24855*/ GIMT_Encode4(1837787), // Rule ID 13285 //
     /* 1837706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1837717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1837720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1837726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1837729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1837736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1837748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837752 */     // MIs[0] policy
     /* 1837752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837762 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1837765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1837783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837786 */     // GIR_Coverage, 13285,
     /* 1837786 */     GIR_EraseRootFromParent_Done,
     /* 1837787 */   // Label 24855: @1837787
     /* 1837787 */   GIM_Try, /*On fail goto*//*Label 24856*/ GIMT_Encode4(1837873), // Rule ID 13288 //
     /* 1837792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837838 */     // MIs[0] policy
     /* 1837838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837848 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1837848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1837851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837872 */     // GIR_Coverage, 13288,
     /* 1837872 */     GIR_EraseRootFromParent_Done,
     /* 1837873 */   // Label 24856: @1837873
     /* 1837873 */   GIM_Try, /*On fail goto*//*Label 24857*/ GIMT_Encode4(1837959), // Rule ID 13289 //
     /* 1837878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1837881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1837889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1837892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1837895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1837898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1837901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1837904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1837908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1837916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1837920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1837924 */     // MIs[0] policy
     /* 1837924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1837927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1837934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1837934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1837937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1837939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1837941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1837943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1837945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1837947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1837952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1837955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1837957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1837958 */     // GIR_Coverage, 13289,
     /* 1837958 */     GIR_EraseRootFromParent_Done,
     /* 1837959 */   // Label 24857: @1837959
     /* 1837959 */   GIM_Try, /*On fail goto*//*Label 24858*/ GIMT_Encode4(1838045), // Rule ID 13292 //
     /* 1837964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1837967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1837972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1837975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1837978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1837981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1837984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1837987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1837990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1837994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1837998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838010 */     // MIs[0] policy
     /* 1838010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838020 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1838023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838044 */     // GIR_Coverage, 13292,
     /* 1838044 */     GIR_EraseRootFromParent_Done,
     /* 1838045 */   // Label 24858: @1838045
     /* 1838045 */   GIM_Try, /*On fail goto*//*Label 24859*/ GIMT_Encode4(1838131), // Rule ID 13293 //
     /* 1838050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1838061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1838064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1838070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838096 */     // MIs[0] policy
     /* 1838096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838106 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1838109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838130 */     // GIR_Coverage, 13293,
     /* 1838130 */     GIR_EraseRootFromParent_Done,
     /* 1838131 */   // Label 24859: @1838131
     /* 1838131 */   GIM_Try, /*On fail goto*//*Label 24860*/ GIMT_Encode4(1838217), // Rule ID 13296 //
     /* 1838136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1838147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1838150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1838156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838182 */     // MIs[0] policy
     /* 1838182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838192 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1838195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838216 */     // GIR_Coverage, 13296,
     /* 1838216 */     GIR_EraseRootFromParent_Done,
     /* 1838217 */   // Label 24860: @1838217
     /* 1838217 */   GIM_Try, /*On fail goto*//*Label 24861*/ GIMT_Encode4(1838303), // Rule ID 13297 //
     /* 1838222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1838233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1838236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1838242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1838245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838268 */     // MIs[0] policy
     /* 1838268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838278 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1838281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1838299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838302 */     // GIR_Coverage, 13297,
     /* 1838302 */     GIR_EraseRootFromParent_Done,
     /* 1838303 */   // Label 24861: @1838303
     /* 1838303 */   GIM_Try, /*On fail goto*//*Label 24862*/ GIMT_Encode4(1838389), // Rule ID 13300 //
     /* 1838308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1838319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1838322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1838328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838354 */     // MIs[0] policy
     /* 1838354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838364 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1838367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838388 */     // GIR_Coverage, 13300,
     /* 1838388 */     GIR_EraseRootFromParent_Done,
     /* 1838389 */   // Label 24862: @1838389
     /* 1838389 */   GIM_Try, /*On fail goto*//*Label 24863*/ GIMT_Encode4(1838475), // Rule ID 13301 //
     /* 1838394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1838405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1838408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1838414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1838417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1838424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1838436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838440 */     // MIs[0] policy
     /* 1838440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838450 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11419:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M2_MASK),
     /* 1838453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838474 */     // GIR_Coverage, 13301,
     /* 1838474 */     GIR_EraseRootFromParent_Done,
     /* 1838475 */   // Label 24863: @1838475
     /* 1838475 */   GIM_Try, /*On fail goto*//*Label 24864*/ GIMT_Encode4(1838561), // Rule ID 13304 //
     /* 1838480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1838491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1838494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1838500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838526 */     // MIs[0] policy
     /* 1838526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838536 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1838539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838560 */     // GIR_Coverage, 13304,
     /* 1838560 */     GIR_EraseRootFromParent_Done,
     /* 1838561 */   // Label 24864: @1838561
     /* 1838561 */   GIM_Try, /*On fail goto*//*Label 24865*/ GIMT_Encode4(1838647), // Rule ID 13305 //
     /* 1838566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1838577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1838580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1838586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1838589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1838596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1838608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838612 */     // MIs[0] policy
     /* 1838612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838622 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11419:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M4_MASK),
     /* 1838625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838646 */     // GIR_Coverage, 13305,
     /* 1838646 */     GIR_EraseRootFromParent_Done,
     /* 1838647 */   // Label 24865: @1838647
     /* 1838647 */   GIM_Try, /*On fail goto*//*Label 24866*/ GIMT_Encode4(1838733), // Rule ID 13308 //
     /* 1838652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1838655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1838669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838698 */     // MIs[0] policy
     /* 1838698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838708 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1838711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838732 */     // GIR_Coverage, 13308,
     /* 1838732 */     GIR_EraseRootFromParent_Done,
     /* 1838733 */   // Label 24866: @1838733
     /* 1838733 */   GIM_Try, /*On fail goto*//*Label 24867*/ GIMT_Encode4(1838819), // Rule ID 13309 //
     /* 1838738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1838741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnmsac_mask),
     /* 1838746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1838749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1838752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1838755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1838758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1838761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1838768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1838776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1838780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838784 */     // MIs[0] policy
     /* 1838784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838794 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11419:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNMSAC_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNMSAC_VX_M8_MASK),
     /* 1838797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1838815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838818 */     // GIR_Coverage, 13309,
     /* 1838818 */     GIR_EraseRootFromParent_Done,
     /* 1838819 */   // Label 24867: @1838819
     /* 1838819 */   GIM_Try, /*On fail goto*//*Label 24868*/ GIMT_Encode4(1838905), // Rule ID 13312 //
     /* 1838824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1838832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1838850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838870 */     // MIs[0] policy
     /* 1838870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838880 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1838880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1838883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838904 */     // GIR_Coverage, 13312,
     /* 1838904 */     GIR_EraseRootFromParent_Done,
     /* 1838905 */   // Label 24868: @1838905
     /* 1838905 */   GIM_Try, /*On fail goto*//*Label 24869*/ GIMT_Encode4(1838991), // Rule ID 13313 //
     /* 1838910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1838913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1838918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1838921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1838924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1838927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1838930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1838933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1838936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1838940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1838952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1838956 */     // MIs[0] policy
     /* 1838956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1838959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1838966 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1838966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF8_MASK),
     /* 1838969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1838971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1838973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1838975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1838977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1838979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1838984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1838987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1838989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1838990 */     // GIR_Coverage, 13313,
     /* 1838990 */     GIR_EraseRootFromParent_Done,
     /* 1838991 */   // Label 24869: @1838991
     /* 1838991 */   GIM_Try, /*On fail goto*//*Label 24870*/ GIMT_Encode4(1839077), // Rule ID 13316 //
     /* 1838996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1838999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1839013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1839016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839042 */     // MIs[0] policy
     /* 1839042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839052 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1839055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839076 */     // GIR_Coverage, 13316,
     /* 1839076 */     GIR_EraseRootFromParent_Done,
     /* 1839077 */   // Label 24870: @1839077
     /* 1839077 */   GIM_Try, /*On fail goto*//*Label 24871*/ GIMT_Encode4(1839163), // Rule ID 13317 //
     /* 1839082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1839093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1839096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1839099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1839102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1839105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839128 */     // MIs[0] policy
     /* 1839128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839138 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1839141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839162 */     // GIR_Coverage, 13317,
     /* 1839162 */     GIR_EraseRootFromParent_Done,
     /* 1839163 */   // Label 24871: @1839163
     /* 1839163 */   GIM_Try, /*On fail goto*//*Label 24872*/ GIMT_Encode4(1839249), // Rule ID 13320 //
     /* 1839168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1839185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1839188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839214 */     // MIs[0] policy
     /* 1839214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839224 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1839227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839248 */     // GIR_Coverage, 13320,
     /* 1839248 */     GIR_EraseRootFromParent_Done,
     /* 1839249 */   // Label 24872: @1839249
     /* 1839249 */   GIM_Try, /*On fail goto*//*Label 24873*/ GIMT_Encode4(1839335), // Rule ID 13321 //
     /* 1839254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1839265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1839268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1839271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1839274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1839277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839300 */     // MIs[0] policy
     /* 1839300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839310 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1839313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839334 */     // GIR_Coverage, 13321,
     /* 1839334 */     GIR_EraseRootFromParent_Done,
     /* 1839335 */   // Label 24873: @1839335
     /* 1839335 */   GIM_Try, /*On fail goto*//*Label 24874*/ GIMT_Encode4(1839421), // Rule ID 13324 //
     /* 1839340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1839351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1839354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839386 */     // MIs[0] policy
     /* 1839386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1839399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839420 */     // GIR_Coverage, 13324,
     /* 1839420 */     GIR_EraseRootFromParent_Done,
     /* 1839421 */   // Label 24874: @1839421
     /* 1839421 */   GIM_Try, /*On fail goto*//*Label 24875*/ GIMT_Encode4(1839507), // Rule ID 13325 //
     /* 1839426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1839437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1839440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1839443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1839446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1839449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1839456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839472 */     // MIs[0] policy
     /* 1839472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1839485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839506 */     // GIR_Coverage, 13325,
     /* 1839506 */     GIR_EraseRootFromParent_Done,
     /* 1839507 */   // Label 24875: @1839507
     /* 1839507 */   GIM_Try, /*On fail goto*//*Label 24876*/ GIMT_Encode4(1839593), // Rule ID 13328 //
     /* 1839512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1839523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1839526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839558 */     // MIs[0] policy
     /* 1839558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839568 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1839571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839592 */     // GIR_Coverage, 13328,
     /* 1839592 */     GIR_EraseRootFromParent_Done,
     /* 1839593 */   // Label 24876: @1839593
     /* 1839593 */   GIM_Try, /*On fail goto*//*Label 24877*/ GIMT_Encode4(1839679), // Rule ID 13329 //
     /* 1839598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1839609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1839612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1839615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1839618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1839621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1839628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1839640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839644 */     // MIs[0] policy
     /* 1839644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839654 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1839657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839678 */     // GIR_Coverage, 13329,
     /* 1839678 */     GIR_EraseRootFromParent_Done,
     /* 1839679 */   // Label 24877: @1839679
     /* 1839679 */   GIM_Try, /*On fail goto*//*Label 24878*/ GIMT_Encode4(1839765), // Rule ID 13332 //
     /* 1839684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1839695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1839698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839730 */     // MIs[0] policy
     /* 1839730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839740 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1839743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839745 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839764 */     // GIR_Coverage, 13332,
     /* 1839764 */     GIR_EraseRootFromParent_Done,
     /* 1839765 */   // Label 24878: @1839765
     /* 1839765 */   GIM_Try, /*On fail goto*//*Label 24879*/ GIMT_Encode4(1839851), // Rule ID 13333 //
     /* 1839770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1839781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1839784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1839787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1839790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1839793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1839800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1839804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1839812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839816 */     // MIs[0] policy
     /* 1839816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839826 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1839829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1839847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839850 */     // GIR_Coverage, 13333,
     /* 1839850 */     GIR_EraseRootFromParent_Done,
     /* 1839851 */   // Label 24879: @1839851
     /* 1839851 */   GIM_Try, /*On fail goto*//*Label 24880*/ GIMT_Encode4(1839937), // Rule ID 13336 //
     /* 1839856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1839859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1839873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1839876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1839882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839902 */     // MIs[0] policy
     /* 1839902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839912 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1839912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1839915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1839917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1839919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1839921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1839923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1839925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1839930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1839933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1839935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839936 */     // GIR_Coverage, 13336,
     /* 1839936 */     GIR_EraseRootFromParent_Done,
     /* 1839937 */   // Label 24880: @1839937
     /* 1839937 */   GIM_Try, /*On fail goto*//*Label 24881*/ GIMT_Encode4(1840023), // Rule ID 13337 //
     /* 1839942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1839945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1839950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1839953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1839956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1839959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1839962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1839965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1839968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1839972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1839984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1839988 */     // MIs[0] policy
     /* 1839988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1839991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1839998 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1839998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF4_MASK),
     /* 1840001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840022 */     // GIR_Coverage, 13337,
     /* 1840022 */     GIR_EraseRootFromParent_Done,
     /* 1840023 */   // Label 24881: @1840023
     /* 1840023 */   GIM_Try, /*On fail goto*//*Label 24882*/ GIMT_Encode4(1840109), // Rule ID 13340 //
     /* 1840028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1840039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1840042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1840045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1840048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840074 */     // MIs[0] policy
     /* 1840074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1840087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840108 */     // GIR_Coverage, 13340,
     /* 1840108 */     GIR_EraseRootFromParent_Done,
     /* 1840109 */   // Label 24882: @1840109
     /* 1840109 */   GIM_Try, /*On fail goto*//*Label 24883*/ GIMT_Encode4(1840195), // Rule ID 13341 //
     /* 1840114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1840125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1840128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1840131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1840134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840160 */     // MIs[0] policy
     /* 1840160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1840173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840194 */     // GIR_Coverage, 13341,
     /* 1840194 */     GIR_EraseRootFromParent_Done,
     /* 1840195 */   // Label 24883: @1840195
     /* 1840195 */   GIM_Try, /*On fail goto*//*Label 24884*/ GIMT_Encode4(1840281), // Rule ID 13344 //
     /* 1840200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1840217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1840220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840246 */     // MIs[0] policy
     /* 1840246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840256 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1840259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840280 */     // GIR_Coverage, 13344,
     /* 1840280 */     GIR_EraseRootFromParent_Done,
     /* 1840281 */   // Label 24884: @1840281
     /* 1840281 */   GIM_Try, /*On fail goto*//*Label 24885*/ GIMT_Encode4(1840367), // Rule ID 13345 //
     /* 1840286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1840297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1840300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1840303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1840306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1840309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840332 */     // MIs[0] policy
     /* 1840332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1840345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840366 */     // GIR_Coverage, 13345,
     /* 1840366 */     GIR_EraseRootFromParent_Done,
     /* 1840367 */   // Label 24885: @1840367
     /* 1840367 */   GIM_Try, /*On fail goto*//*Label 24886*/ GIMT_Encode4(1840453), // Rule ID 13348 //
     /* 1840372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840418 */     // MIs[0] policy
     /* 1840418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840428 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1840431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840452 */     // GIR_Coverage, 13348,
     /* 1840452 */     GIR_EraseRootFromParent_Done,
     /* 1840453 */   // Label 24886: @1840453
     /* 1840453 */   GIM_Try, /*On fail goto*//*Label 24887*/ GIMT_Encode4(1840539), // Rule ID 13349 //
     /* 1840458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1840469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1840472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1840475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1840478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1840481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1840488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840504 */     // MIs[0] policy
     /* 1840504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840514 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1840517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840538 */     // GIR_Coverage, 13349,
     /* 1840538 */     GIR_EraseRootFromParent_Done,
     /* 1840539 */   // Label 24887: @1840539
     /* 1840539 */   GIM_Try, /*On fail goto*//*Label 24888*/ GIMT_Encode4(1840625), // Rule ID 13352 //
     /* 1840544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1840547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1840555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1840558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840590 */     // MIs[0] policy
     /* 1840590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840600 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1840603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840624 */     // GIR_Coverage, 13352,
     /* 1840624 */     GIR_EraseRootFromParent_Done,
     /* 1840625 */   // Label 24888: @1840625
     /* 1840625 */   GIM_Try, /*On fail goto*//*Label 24889*/ GIMT_Encode4(1840711), // Rule ID 13353 //
     /* 1840630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1840633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1840641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1840644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1840647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1840650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1840653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1840660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1840664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1840672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840676 */     // MIs[0] policy
     /* 1840676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840686 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1840689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1840707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840710 */     // GIR_Coverage, 13353,
     /* 1840710 */     GIR_EraseRootFromParent_Done,
     /* 1840711 */   // Label 24889: @1840711
     /* 1840711 */   GIM_Try, /*On fail goto*//*Label 24890*/ GIMT_Encode4(1840797), // Rule ID 13356 //
     /* 1840716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1840719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1840727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1840730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1840733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1840736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840762 */     // MIs[0] policy
     /* 1840762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840772 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1840775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840796 */     // GIR_Coverage, 13356,
     /* 1840796 */     GIR_EraseRootFromParent_Done,
     /* 1840797 */   // Label 24890: @1840797
     /* 1840797 */   GIM_Try, /*On fail goto*//*Label 24891*/ GIMT_Encode4(1840883), // Rule ID 13357 //
     /* 1840802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1840805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1840813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1840816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1840819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1840822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1840825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1840828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1840832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840848 */     // MIs[0] policy
     /* 1840848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840858 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1840858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_MF2_MASK),
     /* 1840861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840882 */     // GIR_Coverage, 13357,
     /* 1840882 */     GIR_EraseRootFromParent_Done,
     /* 1840883 */   // Label 24891: @1840883
     /* 1840883 */   GIM_Try, /*On fail goto*//*Label 24892*/ GIMT_Encode4(1840969), // Rule ID 13360 //
     /* 1840888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1840891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1840899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1840902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1840905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1840908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1840914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1840918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1840922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1840930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1840934 */     // MIs[0] policy
     /* 1840934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1840937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1840944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1840944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1840947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1840949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1840951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1840953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1840955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1840957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1840962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1840965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1840967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1840968 */     // GIR_Coverage, 13360,
     /* 1840968 */     GIR_EraseRootFromParent_Done,
     /* 1840969 */   // Label 24892: @1840969
     /* 1840969 */   GIM_Try, /*On fail goto*//*Label 24893*/ GIMT_Encode4(1841055), // Rule ID 13361 //
     /* 1840974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1840977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1840982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1840985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1840988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1840991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1840994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1840997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841020 */     // MIs[0] policy
     /* 1841020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841030 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M1_MASK),
     /* 1841033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841054 */     // GIR_Coverage, 13361,
     /* 1841054 */     GIR_EraseRootFromParent_Done,
     /* 1841055 */   // Label 24893: @1841055
     /* 1841055 */   GIM_Try, /*On fail goto*//*Label 24894*/ GIMT_Encode4(1841141), // Rule ID 13364 //
     /* 1841060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1841063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841106 */     // MIs[0] policy
     /* 1841106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841116 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1841119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841121 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841140 */     // GIR_Coverage, 13364,
     /* 1841140 */     GIR_EraseRootFromParent_Done,
     /* 1841141 */   // Label 24894: @1841141
     /* 1841141 */   GIM_Try, /*On fail goto*//*Label 24895*/ GIMT_Encode4(1841227), // Rule ID 13365 //
     /* 1841146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1841149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1841157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1841160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1841163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1841166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1841176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841192 */     // MIs[0] policy
     /* 1841192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841202 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M2_MASK),
     /* 1841205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841226 */     // GIR_Coverage, 13365,
     /* 1841226 */     GIR_EraseRootFromParent_Done,
     /* 1841227 */   // Label 24895: @1841227
     /* 1841227 */   GIM_Try, /*On fail goto*//*Label 24896*/ GIMT_Encode4(1841313), // Rule ID 13368 //
     /* 1841232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1841235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841278 */     // MIs[0] policy
     /* 1841278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841288 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1841291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841293 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841312 */     // GIR_Coverage, 13368,
     /* 1841312 */     GIR_EraseRootFromParent_Done,
     /* 1841313 */   // Label 24896: @1841313
     /* 1841313 */   GIM_Try, /*On fail goto*//*Label 24897*/ GIMT_Encode4(1841399), // Rule ID 13369 //
     /* 1841318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1841321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1841329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1841332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1841335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1841338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1841348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1841352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1841360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841364 */     // MIs[0] policy
     /* 1841364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841374 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VV_M4_MASK),
     /* 1841377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1841395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841398 */     // GIR_Coverage, 13369,
     /* 1841398 */     GIR_EraseRootFromParent_Done,
     /* 1841399 */   // Label 24897: @1841399
     /* 1841399 */   GIM_Try, /*On fail goto*//*Label 24898*/ GIMT_Encode4(1841485), // Rule ID 13372 //
     /* 1841404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1841415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1841418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841450 */     // MIs[0] policy
     /* 1841450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841460 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1841463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841484 */     // GIR_Coverage, 13372,
     /* 1841484 */     GIR_EraseRootFromParent_Done,
     /* 1841485 */   // Label 24898: @1841485
     /* 1841485 */   GIM_Try, /*On fail goto*//*Label 24899*/ GIMT_Encode4(1841571), // Rule ID 13373 //
     /* 1841490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1841501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1841504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1841510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1841513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841536 */     // MIs[0] policy
     /* 1841536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841546 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF8_MASK),
     /* 1841549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841570 */     // GIR_Coverage, 13373,
     /* 1841570 */     GIR_EraseRootFromParent_Done,
     /* 1841571 */   // Label 24899: @1841571
     /* 1841571 */   GIM_Try, /*On fail goto*//*Label 24900*/ GIMT_Encode4(1841657), // Rule ID 13376 //
     /* 1841576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1841587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1841590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841622 */     // MIs[0] policy
     /* 1841622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841632 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1841635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841656 */     // GIR_Coverage, 13376,
     /* 1841656 */     GIR_EraseRootFromParent_Done,
     /* 1841657 */   // Label 24900: @1841657
     /* 1841657 */   GIM_Try, /*On fail goto*//*Label 24901*/ GIMT_Encode4(1841743), // Rule ID 13377 //
     /* 1841662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1841673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1841676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1841682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1841685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841708 */     // MIs[0] policy
     /* 1841708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841718 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1841721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841742 */     // GIR_Coverage, 13377,
     /* 1841742 */     GIR_EraseRootFromParent_Done,
     /* 1841743 */   // Label 24901: @1841743
     /* 1841743 */   GIM_Try, /*On fail goto*//*Label 24902*/ GIMT_Encode4(1841829), // Rule ID 13380 //
     /* 1841748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1841759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1841762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1841768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841794 */     // MIs[0] policy
     /* 1841794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841804 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1841807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841828 */     // GIR_Coverage, 13380,
     /* 1841828 */     GIR_EraseRootFromParent_Done,
     /* 1841829 */   // Label 24902: @1841829
     /* 1841829 */   GIM_Try, /*On fail goto*//*Label 24903*/ GIMT_Encode4(1841915), // Rule ID 13381 //
     /* 1841834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1841837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1841845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1841848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1841851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1841854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1841857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1841860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1841864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841880 */     // MIs[0] policy
     /* 1841880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841890 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11583:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1841890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1841893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1841914 */     // GIR_Coverage, 13381,
     /* 1841914 */     GIR_EraseRootFromParent_Done,
     /* 1841915 */   // Label 24903: @1841915
     /* 1841915 */   GIM_Try, /*On fail goto*//*Label 24904*/ GIMT_Encode4(1842001), // Rule ID 13384 //
     /* 1841920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1841923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1841928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1841931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1841934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1841937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1841940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1841943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1841946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1841950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1841954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1841958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1841962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1841966 */     // MIs[0] policy
     /* 1841966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1841969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1841976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1841976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1841979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1841981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1841983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1841985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1841987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1841989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1841994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1841997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1841999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842000 */     // GIR_Coverage, 13384,
     /* 1842000 */     GIR_EraseRootFromParent_Done,
     /* 1842001 */   // Label 24904: @1842001
     /* 1842001 */   GIM_Try, /*On fail goto*//*Label 24905*/ GIMT_Encode4(1842087), // Rule ID 13385 //
     /* 1842006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1842017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1842020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1842026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842052 */     // MIs[0] policy
     /* 1842052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842062 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1842065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842086 */     // GIR_Coverage, 13385,
     /* 1842086 */     GIR_EraseRootFromParent_Done,
     /* 1842087 */   // Label 24905: @1842087
     /* 1842087 */   GIM_Try, /*On fail goto*//*Label 24906*/ GIMT_Encode4(1842173), // Rule ID 13388 //
     /* 1842092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1842103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1842106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1842112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842138 */     // MIs[0] policy
     /* 1842138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842148 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1842151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842172 */     // GIR_Coverage, 13388,
     /* 1842172 */     GIR_EraseRootFromParent_Done,
     /* 1842173 */   // Label 24906: @1842173
     /* 1842173 */   GIM_Try, /*On fail goto*//*Label 24907*/ GIMT_Encode4(1842259), // Rule ID 13389 //
     /* 1842178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1842189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1842192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1842198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1842201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842224 */     // MIs[0] policy
     /* 1842224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1842237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842258 */     // GIR_Coverage, 13389,
     /* 1842258 */     GIR_EraseRootFromParent_Done,
     /* 1842259 */   // Label 24907: @1842259
     /* 1842259 */   GIM_Try, /*On fail goto*//*Label 24908*/ GIMT_Encode4(1842345), // Rule ID 13392 //
     /* 1842264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1842275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1842278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1842284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1842287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842310 */     // MIs[0] policy
     /* 1842310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842320 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1842323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842344 */     // GIR_Coverage, 13392,
     /* 1842344 */     GIR_EraseRootFromParent_Done,
     /* 1842345 */   // Label 24908: @1842345
     /* 1842345 */   GIM_Try, /*On fail goto*//*Label 24909*/ GIMT_Encode4(1842431), // Rule ID 13393 //
     /* 1842350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1842361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1842364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1842370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1842373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1842380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1842384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842396 */     // MIs[0] policy
     /* 1842396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842406 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1842409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1842427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842430 */     // GIR_Coverage, 13393,
     /* 1842430 */     GIR_EraseRootFromParent_Done,
     /* 1842431 */   // Label 24909: @1842431
     /* 1842431 */   GIM_Try, /*On fail goto*//*Label 24910*/ GIMT_Encode4(1842517), // Rule ID 13396 //
     /* 1842436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842482 */     // MIs[0] policy
     /* 1842482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842492 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1842495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842516 */     // GIR_Coverage, 13396,
     /* 1842516 */     GIR_EraseRootFromParent_Done,
     /* 1842517 */   // Label 24910: @1842517
     /* 1842517 */   GIM_Try, /*On fail goto*//*Label 24911*/ GIMT_Encode4(1842603), // Rule ID 13397 //
     /* 1842522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1842533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1842536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1842542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1842545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842568 */     // MIs[0] policy
     /* 1842568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF4_MASK),
     /* 1842581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842602 */     // GIR_Coverage, 13397,
     /* 1842602 */     GIR_EraseRootFromParent_Done,
     /* 1842603 */   // Label 24911: @1842603
     /* 1842603 */   GIM_Try, /*On fail goto*//*Label 24912*/ GIMT_Encode4(1842689), // Rule ID 13400 //
     /* 1842608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1842619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1842622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842654 */     // MIs[0] policy
     /* 1842654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842664 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1842667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842688 */     // GIR_Coverage, 13400,
     /* 1842688 */     GIR_EraseRootFromParent_Done,
     /* 1842689 */   // Label 24912: @1842689
     /* 1842689 */   GIM_Try, /*On fail goto*//*Label 24913*/ GIMT_Encode4(1842775), // Rule ID 13401 //
     /* 1842694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1842705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1842708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1842714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1842717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1842724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842740 */     // MIs[0] policy
     /* 1842740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11583:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1842753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842774 */     // GIR_Coverage, 13401,
     /* 1842774 */     GIR_EraseRootFromParent_Done,
     /* 1842775 */   // Label 24913: @1842775
     /* 1842775 */   GIM_Try, /*On fail goto*//*Label 24914*/ GIMT_Encode4(1842861), // Rule ID 13404 //
     /* 1842780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1842791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1842794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842826 */     // MIs[0] policy
     /* 1842826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842836 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1842836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1842839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842860 */     // GIR_Coverage, 13404,
     /* 1842860 */     GIR_EraseRootFromParent_Done,
     /* 1842861 */   // Label 24914: @1842861
     /* 1842861 */   GIM_Try, /*On fail goto*//*Label 24915*/ GIMT_Encode4(1842947), // Rule ID 13405 //
     /* 1842866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1842869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1842877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1842880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1842883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1842886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1842889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1842892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1842896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1842908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842912 */     // MIs[0] policy
     /* 1842912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1842915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1842922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1842922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1842925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1842927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1842929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1842931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1842933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1842935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1842940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1842943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1842945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1842946 */     // GIR_Coverage, 13405,
     /* 1842946 */     GIR_EraseRootFromParent_Done,
     /* 1842947 */   // Label 24915: @1842947
     /* 1842947 */   GIM_Try, /*On fail goto*//*Label 24916*/ GIMT_Encode4(1843033), // Rule ID 13408 //
     /* 1842952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1842955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1842960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1842963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1842966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1842969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1842972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1842975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1842978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1842982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1842986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1842990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1842994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1842998 */     // MIs[0] policy
     /* 1842998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843008 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1843011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843013 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843032 */     // GIR_Coverage, 13408,
     /* 1843032 */     GIR_EraseRootFromParent_Done,
     /* 1843033 */   // Label 24916: @1843033
     /* 1843033 */   GIM_Try, /*On fail goto*//*Label 24917*/ GIMT_Encode4(1843119), // Rule ID 13409 //
     /* 1843038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1843049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1843052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1843058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843084 */     // MIs[0] policy
     /* 1843084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843094 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1843097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843118 */     // GIR_Coverage, 13409,
     /* 1843118 */     GIR_EraseRootFromParent_Done,
     /* 1843119 */   // Label 24917: @1843119
     /* 1843119 */   GIM_Try, /*On fail goto*//*Label 24918*/ GIMT_Encode4(1843205), // Rule ID 13412 //
     /* 1843124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1843135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1843138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1843144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843170 */     // MIs[0] policy
     /* 1843170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843180 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1843183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843204 */     // GIR_Coverage, 13412,
     /* 1843204 */     GIR_EraseRootFromParent_Done,
     /* 1843205 */   // Label 24918: @1843205
     /* 1843205 */   GIM_Try, /*On fail goto*//*Label 24919*/ GIMT_Encode4(1843291), // Rule ID 13413 //
     /* 1843210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1843213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1843221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1843224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1843230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1843233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843256 */     // MIs[0] policy
     /* 1843256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843266 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1843269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1843287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843290 */     // GIR_Coverage, 13413,
     /* 1843290 */     GIR_EraseRootFromParent_Done,
     /* 1843291 */   // Label 24919: @1843291
     /* 1843291 */   GIM_Try, /*On fail goto*//*Label 24920*/ GIMT_Encode4(1843377), // Rule ID 13416 //
     /* 1843296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1843299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1843316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843342 */     // MIs[0] policy
     /* 1843342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843352 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1843355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843376 */     // GIR_Coverage, 13416,
     /* 1843376 */     GIR_EraseRootFromParent_Done,
     /* 1843377 */   // Label 24920: @1843377
     /* 1843377 */   GIM_Try, /*On fail goto*//*Label 24921*/ GIMT_Encode4(1843463), // Rule ID 13417 //
     /* 1843382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1843385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1843393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1843396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1843402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1843405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1843412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843428 */     // MIs[0] policy
     /* 1843428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843438 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11583:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_MF2_MASK),
     /* 1843441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843462 */     // GIR_Coverage, 13417,
     /* 1843462 */     GIR_EraseRootFromParent_Done,
     /* 1843463 */   // Label 24921: @1843463
     /* 1843463 */   GIM_Try, /*On fail goto*//*Label 24922*/ GIMT_Encode4(1843549), // Rule ID 13420 //
     /* 1843468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1843471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1843479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1843482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843514 */     // MIs[0] policy
     /* 1843514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1843527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843548 */     // GIR_Coverage, 13420,
     /* 1843548 */     GIR_EraseRootFromParent_Done,
     /* 1843549 */   // Label 24922: @1843549
     /* 1843549 */   GIM_Try, /*On fail goto*//*Label 24923*/ GIMT_Encode4(1843635), // Rule ID 13421 //
     /* 1843554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1843557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1843565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1843568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1843574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1843577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1843584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1843596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843600 */     // MIs[0] policy
     /* 1843600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11583:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M1_MASK),
     /* 1843613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843634 */     // GIR_Coverage, 13421,
     /* 1843634 */     GIR_EraseRootFromParent_Done,
     /* 1843635 */   // Label 24923: @1843635
     /* 1843635 */   GIM_Try, /*On fail goto*//*Label 24924*/ GIMT_Encode4(1843721), // Rule ID 13424 //
     /* 1843640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1843643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1843651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1843654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1843660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843686 */     // MIs[0] policy
     /* 1843686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843696 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1843699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843720 */     // GIR_Coverage, 13424,
     /* 1843720 */     GIR_EraseRootFromParent_Done,
     /* 1843721 */   // Label 24924: @1843721
     /* 1843721 */   GIM_Try, /*On fail goto*//*Label 24925*/ GIMT_Encode4(1843807), // Rule ID 13425 //
     /* 1843726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1843729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1843737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1843740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1843746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1843749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1843756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1843768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843772 */     // MIs[0] policy
     /* 1843772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843782 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11583:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M2_MASK),
     /* 1843785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843806 */     // GIR_Coverage, 13425,
     /* 1843806 */     GIR_EraseRootFromParent_Done,
     /* 1843807 */   // Label 24925: @1843807
     /* 1843807 */   GIM_Try, /*On fail goto*//*Label 24926*/ GIMT_Encode4(1843893), // Rule ID 13428 //
     /* 1843812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1843815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1843823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1843826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1843829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1843832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1843838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843858 */     // MIs[0] policy
     /* 1843858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843868 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1843868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1843871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843892 */     // GIR_Coverage, 13428,
     /* 1843892 */     GIR_EraseRootFromParent_Done,
     /* 1843893 */   // Label 24926: @1843893
     /* 1843893 */   GIM_Try, /*On fail goto*//*Label 24927*/ GIMT_Encode4(1843979), // Rule ID 13429 //
     /* 1843898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1843901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccu_mask),
     /* 1843906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1843909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1843912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1843915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1843918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1843921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1843924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1843928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1843932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1843936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1843940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1843944 */     // MIs[0] policy
     /* 1843944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1843947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1843954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11583:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1843954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCU_VX_M4_MASK),
     /* 1843957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1843959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1843961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1843963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1843965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1843967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1843972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1843975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1843977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1843978 */     // GIR_Coverage, 13429,
     /* 1843978 */     GIR_EraseRootFromParent_Done,
     /* 1843979 */   // Label 24927: @1843979
     /* 1843979 */   GIM_Try, /*On fail goto*//*Label 24928*/ GIMT_Encode4(1844065), // Rule ID 13432 //
     /* 1843984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1843987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1843992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1843995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1843998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1844001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1844004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1844007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844030 */     // MIs[0] policy
     /* 1844030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1844043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844064 */     // GIR_Coverage, 13432,
     /* 1844064 */     GIR_EraseRootFromParent_Done,
     /* 1844065 */   // Label 24928: @1844065
     /* 1844065 */   GIM_Try, /*On fail goto*//*Label 24929*/ GIMT_Encode4(1844151), // Rule ID 13433 //
     /* 1844070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1844081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1844084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1844087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1844090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1844093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844116 */     // MIs[0] policy
     /* 1844116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844126 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF8_MASK),
     /* 1844129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844150 */     // GIR_Coverage, 13433,
     /* 1844150 */     GIR_EraseRootFromParent_Done,
     /* 1844151 */   // Label 24929: @1844151
     /* 1844151 */   GIM_Try, /*On fail goto*//*Label 24930*/ GIMT_Encode4(1844237), // Rule ID 13436 //
     /* 1844156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1844167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1844170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1844173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1844176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844202 */     // MIs[0] policy
     /* 1844202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1844215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844236 */     // GIR_Coverage, 13436,
     /* 1844236 */     GIR_EraseRootFromParent_Done,
     /* 1844237 */   // Label 24930: @1844237
     /* 1844237 */   GIM_Try, /*On fail goto*//*Label 24931*/ GIMT_Encode4(1844323), // Rule ID 13437 //
     /* 1844242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1844253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1844256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1844259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1844262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1844265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844288 */     // MIs[0] policy
     /* 1844288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1844301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844322 */     // GIR_Coverage, 13437,
     /* 1844322 */     GIR_EraseRootFromParent_Done,
     /* 1844323 */   // Label 24931: @1844323
     /* 1844323 */   GIM_Try, /*On fail goto*//*Label 24932*/ GIMT_Encode4(1844409), // Rule ID 13440 //
     /* 1844328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1844339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1844342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1844345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1844348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844374 */     // MIs[0] policy
     /* 1844374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844384 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1844387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844408 */     // GIR_Coverage, 13440,
     /* 1844408 */     GIR_EraseRootFromParent_Done,
     /* 1844409 */   // Label 24932: @1844409
     /* 1844409 */   GIM_Try, /*On fail goto*//*Label 24933*/ GIMT_Encode4(1844495), // Rule ID 13441 //
     /* 1844414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1844425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1844428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1844431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1844434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1844437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1844444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844460 */     // MIs[0] policy
     /* 1844460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844470 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1844473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844475 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844494 */     // GIR_Coverage, 13441,
     /* 1844494 */     GIR_EraseRootFromParent_Done,
     /* 1844495 */   // Label 24933: @1844495
     /* 1844495 */   GIM_Try, /*On fail goto*//*Label 24934*/ GIMT_Encode4(1844581), // Rule ID 13444 //
     /* 1844500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1844517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1844520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844546 */     // MIs[0] policy
     /* 1844546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1844559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844580 */     // GIR_Coverage, 13444,
     /* 1844580 */     GIR_EraseRootFromParent_Done,
     /* 1844581 */   // Label 24934: @1844581
     /* 1844581 */   GIM_Try, /*On fail goto*//*Label 24935*/ GIMT_Encode4(1844667), // Rule ID 13445 //
     /* 1844586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1844597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1844600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1844603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1844606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1844609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1844616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1844628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844632 */     // MIs[0] policy
     /* 1844632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844642 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1844645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844666 */     // GIR_Coverage, 13445,
     /* 1844666 */     GIR_EraseRootFromParent_Done,
     /* 1844667 */   // Label 24935: @1844667
     /* 1844667 */   GIM_Try, /*On fail goto*//*Label 24936*/ GIMT_Encode4(1844753), // Rule ID 13448 //
     /* 1844672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1844689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1844692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844718 */     // MIs[0] policy
     /* 1844718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844728 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1844731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844752 */     // GIR_Coverage, 13448,
     /* 1844752 */     GIR_EraseRootFromParent_Done,
     /* 1844753 */   // Label 24936: @1844753
     /* 1844753 */   GIM_Try, /*On fail goto*//*Label 24937*/ GIMT_Encode4(1844839), // Rule ID 13449 //
     /* 1844758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1844769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1844772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1844775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1844778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1844781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1844788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1844800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844804 */     // MIs[0] policy
     /* 1844804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844814 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1844817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844838 */     // GIR_Coverage, 13449,
     /* 1844838 */     GIR_EraseRootFromParent_Done,
     /* 1844839 */   // Label 24937: @1844839
     /* 1844839 */   GIM_Try, /*On fail goto*//*Label 24938*/ GIMT_Encode4(1844925), // Rule ID 13452 //
     /* 1844844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1844847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1844861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1844870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844890 */     // MIs[0] policy
     /* 1844890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844900 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1844900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1844903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1844918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1844921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1844923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1844924 */     // GIR_Coverage, 13452,
     /* 1844924 */     GIR_EraseRootFromParent_Done,
     /* 1844925 */   // Label 24938: @1844925
     /* 1844925 */   GIM_Try, /*On fail goto*//*Label 24939*/ GIMT_Encode4(1845011), // Rule ID 13453 //
     /* 1844930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1844933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1844938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1844941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1844944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1844947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1844950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1844953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1844956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1844960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1844964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1844972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1844976 */     // MIs[0] policy
     /* 1844976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1844979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1844986 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1844986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1844989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1844991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1844993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1844995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1844997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1844999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1845007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845010 */     // GIR_Coverage, 13453,
     /* 1845010 */     GIR_EraseRootFromParent_Done,
     /* 1845011 */   // Label 24939: @1845011
     /* 1845011 */   GIM_Try, /*On fail goto*//*Label 24940*/ GIMT_Encode4(1845097), // Rule ID 13456 //
     /* 1845016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1845027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1845030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1845033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1845036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845062 */     // MIs[0] policy
     /* 1845062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845072 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1845075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845096 */     // GIR_Coverage, 13456,
     /* 1845096 */     GIR_EraseRootFromParent_Done,
     /* 1845097 */   // Label 24940: @1845097
     /* 1845097 */   GIM_Try, /*On fail goto*//*Label 24941*/ GIMT_Encode4(1845183), // Rule ID 13457 //
     /* 1845102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1845113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1845116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1845119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1845122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845148 */     // MIs[0] policy
     /* 1845148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845158 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF4_MASK),
     /* 1845161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845182 */     // GIR_Coverage, 13457,
     /* 1845182 */     GIR_EraseRootFromParent_Done,
     /* 1845183 */   // Label 24941: @1845183
     /* 1845183 */   GIM_Try, /*On fail goto*//*Label 24942*/ GIMT_Encode4(1845269), // Rule ID 13460 //
     /* 1845188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1845199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1845202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1845205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1845208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845234 */     // MIs[0] policy
     /* 1845234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845244 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1845247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845268 */     // GIR_Coverage, 13460,
     /* 1845268 */     GIR_EraseRootFromParent_Done,
     /* 1845269 */   // Label 24942: @1845269
     /* 1845269 */   GIM_Try, /*On fail goto*//*Label 24943*/ GIMT_Encode4(1845355), // Rule ID 13461 //
     /* 1845274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1845285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1845288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1845291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1845294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1845297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845320 */     // MIs[0] policy
     /* 1845320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845330 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1845333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845354 */     // GIR_Coverage, 13461,
     /* 1845354 */     GIR_EraseRootFromParent_Done,
     /* 1845355 */   // Label 24943: @1845355
     /* 1845355 */   GIM_Try, /*On fail goto*//*Label 24944*/ GIMT_Encode4(1845441), // Rule ID 13464 //
     /* 1845360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1845371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1845374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1845377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1845380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845406 */     // MIs[0] policy
     /* 1845406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1845419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845440 */     // GIR_Coverage, 13464,
     /* 1845440 */     GIR_EraseRootFromParent_Done,
     /* 1845441 */   // Label 24944: @1845441
     /* 1845441 */   GIM_Try, /*On fail goto*//*Label 24945*/ GIMT_Encode4(1845527), // Rule ID 13465 //
     /* 1845446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1845457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1845460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1845463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1845466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1845469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1845476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845492 */     // MIs[0] policy
     /* 1845492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845502 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1845505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845526 */     // GIR_Coverage, 13465,
     /* 1845526 */     GIR_EraseRootFromParent_Done,
     /* 1845527 */   // Label 24945: @1845527
     /* 1845527 */   GIM_Try, /*On fail goto*//*Label 24946*/ GIMT_Encode4(1845613), // Rule ID 13468 //
     /* 1845532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1845549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1845552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845578 */     // MIs[0] policy
     /* 1845578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845588 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1845591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845612 */     // GIR_Coverage, 13468,
     /* 1845612 */     GIR_EraseRootFromParent_Done,
     /* 1845613 */   // Label 24946: @1845613
     /* 1845613 */   GIM_Try, /*On fail goto*//*Label 24947*/ GIMT_Encode4(1845699), // Rule ID 13469 //
     /* 1845618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1845629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1845632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1845635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1845638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1845641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1845648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1845660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845664 */     // MIs[0] policy
     /* 1845664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845674 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1845677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845698 */     // GIR_Coverage, 13469,
     /* 1845698 */     GIR_EraseRootFromParent_Done,
     /* 1845699 */   // Label 24947: @1845699
     /* 1845699 */   GIM_Try, /*On fail goto*//*Label 24948*/ GIMT_Encode4(1845785), // Rule ID 13472 //
     /* 1845704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1845707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1845721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1845724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845750 */     // MIs[0] policy
     /* 1845750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845760 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1845763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845784 */     // GIR_Coverage, 13472,
     /* 1845784 */     GIR_EraseRootFromParent_Done,
     /* 1845785 */   // Label 24948: @1845785
     /* 1845785 */   GIM_Try, /*On fail goto*//*Label 24949*/ GIMT_Encode4(1845871), // Rule ID 13473 //
     /* 1845790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1845793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1845801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1845804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1845807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1845810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1845813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1845820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1845824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1845832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845836 */     // MIs[0] policy
     /* 1845836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845846 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1845846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1845849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1845867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845870 */     // GIR_Coverage, 13473,
     /* 1845870 */     GIR_EraseRootFromParent_Done,
     /* 1845871 */   // Label 24949: @1845871
     /* 1845871 */   GIM_Try, /*On fail goto*//*Label 24950*/ GIMT_Encode4(1845957), // Rule ID 13476 //
     /* 1845876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1845879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1845887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1845890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1845893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1845896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1845902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1845922 */     // MIs[0] policy
     /* 1845922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1845925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1845932 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1845932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1845935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1845937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1845939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1845941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1845943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1845945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1845950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1845953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1845955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1845956 */     // GIR_Coverage, 13476,
     /* 1845956 */     GIR_EraseRootFromParent_Done,
     /* 1845957 */   // Label 24950: @1845957
     /* 1845957 */   GIM_Try, /*On fail goto*//*Label 24951*/ GIMT_Encode4(1846043), // Rule ID 13477 //
     /* 1845962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1845965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1845970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1845973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1845976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1845979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1845982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1845985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1845988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1845992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1845996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846008 */     // MIs[0] policy
     /* 1846008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846018 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_MF2_MASK),
     /* 1846021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846042 */     // GIR_Coverage, 13477,
     /* 1846042 */     GIR_EraseRootFromParent_Done,
     /* 1846043 */   // Label 24951: @1846043
     /* 1846043 */   GIM_Try, /*On fail goto*//*Label 24952*/ GIMT_Encode4(1846129), // Rule ID 13480 //
     /* 1846048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1846051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1846059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1846062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1846065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1846068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846094 */     // MIs[0] policy
     /* 1846094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846104 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1846107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846128 */     // GIR_Coverage, 13480,
     /* 1846128 */     GIR_EraseRootFromParent_Done,
     /* 1846129 */   // Label 24952: @1846129
     /* 1846129 */   GIM_Try, /*On fail goto*//*Label 24953*/ GIMT_Encode4(1846215), // Rule ID 13481 //
     /* 1846134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1846137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1846145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1846148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1846151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1846154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1846164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846180 */     // MIs[0] policy
     /* 1846180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846190 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M1_MASK),
     /* 1846193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846214 */     // GIR_Coverage, 13481,
     /* 1846214 */     GIR_EraseRootFromParent_Done,
     /* 1846215 */   // Label 24953: @1846215
     /* 1846215 */   GIM_Try, /*On fail goto*//*Label 24954*/ GIMT_Encode4(1846301), // Rule ID 13484 //
     /* 1846220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1846223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1846231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1846234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1846237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1846240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846266 */     // MIs[0] policy
     /* 1846266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846276 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1846279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846300 */     // GIR_Coverage, 13484,
     /* 1846300 */     GIR_EraseRootFromParent_Done,
     /* 1846301 */   // Label 24954: @1846301
     /* 1846301 */   GIM_Try, /*On fail goto*//*Label 24955*/ GIMT_Encode4(1846387), // Rule ID 13485 //
     /* 1846306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1846309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1846317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1846320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1846323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1846326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1846336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1846348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846352 */     // MIs[0] policy
     /* 1846352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846362 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M2_MASK),
     /* 1846365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846386 */     // GIR_Coverage, 13485,
     /* 1846386 */     GIR_EraseRootFromParent_Done,
     /* 1846387 */   // Label 24955: @1846387
     /* 1846387 */   GIM_Try, /*On fail goto*//*Label 24956*/ GIMT_Encode4(1846473), // Rule ID 13488 //
     /* 1846392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1846395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1846403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1846406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1846409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1846412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846438 */     // MIs[0] policy
     /* 1846438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846448 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1846451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846472 */     // GIR_Coverage, 13488,
     /* 1846472 */     GIR_EraseRootFromParent_Done,
     /* 1846473 */   // Label 24956: @1846473
     /* 1846473 */   GIM_Try, /*On fail goto*//*Label 24957*/ GIMT_Encode4(1846559), // Rule ID 13489 //
     /* 1846478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1846481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1846489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1846492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1846495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1846498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1846501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1846508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1846512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1846520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846524 */     // MIs[0] policy
     /* 1846524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846534 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VV_M4_MASK),
     /* 1846537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1846555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846558 */     // GIR_Coverage, 13489,
     /* 1846558 */     GIR_EraseRootFromParent_Done,
     /* 1846559 */   // Label 24957: @1846559
     /* 1846559 */   GIM_Try, /*On fail goto*//*Label 24958*/ GIMT_Encode4(1846645), // Rule ID 13492 //
     /* 1846564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1846575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1846584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846610 */     // MIs[0] policy
     /* 1846610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846620 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1846623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846644 */     // GIR_Coverage, 13492,
     /* 1846644 */     GIR_EraseRootFromParent_Done,
     /* 1846645 */   // Label 24958: @1846645
     /* 1846645 */   GIM_Try, /*On fail goto*//*Label 24959*/ GIMT_Encode4(1846731), // Rule ID 13493 //
     /* 1846650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1846661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1846664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1846670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1846673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846696 */     // MIs[0] policy
     /* 1846696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846706 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF8_MASK),
     /* 1846709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846730 */     // GIR_Coverage, 13493,
     /* 1846730 */     GIR_EraseRootFromParent_Done,
     /* 1846731 */   // Label 24959: @1846731
     /* 1846731 */   GIM_Try, /*On fail goto*//*Label 24960*/ GIMT_Encode4(1846817), // Rule ID 13496 //
     /* 1846736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846782 */     // MIs[0] policy
     /* 1846782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846792 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1846795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846816 */     // GIR_Coverage, 13496,
     /* 1846816 */     GIR_EraseRootFromParent_Done,
     /* 1846817 */   // Label 24960: @1846817
     /* 1846817 */   GIM_Try, /*On fail goto*//*Label 24961*/ GIMT_Encode4(1846903), // Rule ID 13497 //
     /* 1846822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1846833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1846836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1846839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1846842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1846845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1846848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846868 */     // MIs[0] policy
     /* 1846868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846878 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1846878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1846881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846902 */     // GIR_Coverage, 13497,
     /* 1846902 */     GIR_EraseRootFromParent_Done,
     /* 1846903 */   // Label 24961: @1846903
     /* 1846903 */   GIM_Try, /*On fail goto*//*Label 24962*/ GIMT_Encode4(1846989), // Rule ID 13500 //
     /* 1846908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1846911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1846916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1846919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1846922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1846925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1846928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1846931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1846934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1846938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1846946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1846950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1846954 */     // MIs[0] policy
     /* 1846954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1846957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1846964 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1846964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1846967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1846969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1846971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1846973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1846975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1846977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1846982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1846985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1846987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1846988 */     // GIR_Coverage, 13500,
     /* 1846988 */     GIR_EraseRootFromParent_Done,
     /* 1846989 */   // Label 24962: @1846989
     /* 1846989 */   GIM_Try, /*On fail goto*//*Label 24963*/ GIMT_Encode4(1847075), // Rule ID 13501 //
     /* 1846994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1846997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1847005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1847008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1847014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847040 */     // MIs[0] policy
     /* 1847040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847050 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11579:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1847053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847074 */     // GIR_Coverage, 13501,
     /* 1847074 */     GIR_EraseRootFromParent_Done,
     /* 1847075 */   // Label 24963: @1847075
     /* 1847075 */   GIM_Try, /*On fail goto*//*Label 24964*/ GIMT_Encode4(1847161), // Rule ID 13504 //
     /* 1847080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1847100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847126 */     // MIs[0] policy
     /* 1847126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847136 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1847139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847160 */     // GIR_Coverage, 13504,
     /* 1847160 */     GIR_EraseRootFromParent_Done,
     /* 1847161 */   // Label 24964: @1847161
     /* 1847161 */   GIM_Try, /*On fail goto*//*Label 24965*/ GIMT_Encode4(1847247), // Rule ID 13505 //
     /* 1847166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1847177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1847180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1847186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1847189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847212 */     // MIs[0] policy
     /* 1847212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1847225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847246 */     // GIR_Coverage, 13505,
     /* 1847246 */     GIR_EraseRootFromParent_Done,
     /* 1847247 */   // Label 24965: @1847247
     /* 1847247 */   GIM_Try, /*On fail goto*//*Label 24966*/ GIMT_Encode4(1847333), // Rule ID 13508 //
     /* 1847252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1847263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1847266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847298 */     // MIs[0] policy
     /* 1847298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847308 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1847311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847332 */     // GIR_Coverage, 13508,
     /* 1847332 */     GIR_EraseRootFromParent_Done,
     /* 1847333 */   // Label 24966: @1847333
     /* 1847333 */   GIM_Try, /*On fail goto*//*Label 24967*/ GIMT_Encode4(1847419), // Rule ID 13509 //
     /* 1847338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1847349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1847352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1847358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1847361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1847368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847384 */     // MIs[0] policy
     /* 1847384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847394 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1847397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847418 */     // GIR_Coverage, 13509,
     /* 1847418 */     GIR_EraseRootFromParent_Done,
     /* 1847419 */   // Label 24967: @1847419
     /* 1847419 */   GIM_Try, /*On fail goto*//*Label 24968*/ GIMT_Encode4(1847505), // Rule ID 13512 //
     /* 1847424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1847435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1847438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847470 */     // MIs[0] policy
     /* 1847470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847480 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1847483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847485 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847504 */     // GIR_Coverage, 13512,
     /* 1847504 */     GIR_EraseRootFromParent_Done,
     /* 1847505 */   // Label 24968: @1847505
     /* 1847505 */   GIM_Try, /*On fail goto*//*Label 24969*/ GIMT_Encode4(1847591), // Rule ID 13513 //
     /* 1847510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1847521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1847524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1847530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1847533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1847540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1847544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1847552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847556 */     // MIs[0] policy
     /* 1847556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847566 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1847569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1847587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847590 */     // GIR_Coverage, 13513,
     /* 1847590 */     GIR_EraseRootFromParent_Done,
     /* 1847591 */   // Label 24969: @1847591
     /* 1847591 */   GIM_Try, /*On fail goto*//*Label 24970*/ GIMT_Encode4(1847677), // Rule ID 13516 //
     /* 1847596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1847607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1847610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1847616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847642 */     // MIs[0] policy
     /* 1847642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847652 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1847655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847676 */     // GIR_Coverage, 13516,
     /* 1847676 */     GIR_EraseRootFromParent_Done,
     /* 1847677 */   // Label 24970: @1847677
     /* 1847677 */   GIM_Try, /*On fail goto*//*Label 24971*/ GIMT_Encode4(1847763), // Rule ID 13517 //
     /* 1847682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1847693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1847696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1847702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1847705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847728 */     // MIs[0] policy
     /* 1847728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847738 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF4_MASK),
     /* 1847741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847762 */     // GIR_Coverage, 13517,
     /* 1847762 */     GIR_EraseRootFromParent_Done,
     /* 1847763 */   // Label 24971: @1847763
     /* 1847763 */   GIM_Try, /*On fail goto*//*Label 24972*/ GIMT_Encode4(1847849), // Rule ID 13520 //
     /* 1847768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847814 */     // MIs[0] policy
     /* 1847814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847824 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1847827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847848 */     // GIR_Coverage, 13520,
     /* 1847848 */     GIR_EraseRootFromParent_Done,
     /* 1847849 */   // Label 24972: @1847849
     /* 1847849 */   GIM_Try, /*On fail goto*//*Label 24973*/ GIMT_Encode4(1847935), // Rule ID 13521 //
     /* 1847854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1847857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1847865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1847868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1847871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1847874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1847877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1847880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1847884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847900 */     // MIs[0] policy
     /* 1847900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847910 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11579:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1847910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1847913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1847915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1847917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1847919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1847921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1847923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1847928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1847931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1847933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1847934 */     // GIR_Coverage, 13521,
     /* 1847934 */     GIR_EraseRootFromParent_Done,
     /* 1847935 */   // Label 24973: @1847935
     /* 1847935 */   GIM_Try, /*On fail goto*//*Label 24974*/ GIMT_Encode4(1848021), // Rule ID 13524 //
     /* 1847940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1847943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1847948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1847951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1847954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1847957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1847960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1847963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1847966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1847970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1847974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1847978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1847982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1847986 */     // MIs[0] policy
     /* 1847986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1847989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1847996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1847996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1847999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848020 */     // GIR_Coverage, 13524,
     /* 1848020 */     GIR_EraseRootFromParent_Done,
     /* 1848021 */   // Label 24974: @1848021
     /* 1848021 */   GIM_Try, /*On fail goto*//*Label 24975*/ GIMT_Encode4(1848107), // Rule ID 13525 //
     /* 1848026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1848037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1848040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1848046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848072 */     // MIs[0] policy
     /* 1848072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848082 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1848085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848106 */     // GIR_Coverage, 13525,
     /* 1848106 */     GIR_EraseRootFromParent_Done,
     /* 1848107 */   // Label 24975: @1848107
     /* 1848107 */   GIM_Try, /*On fail goto*//*Label 24976*/ GIMT_Encode4(1848193), // Rule ID 13528 //
     /* 1848112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1848132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848158 */     // MIs[0] policy
     /* 1848158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848168 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1848171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848192 */     // GIR_Coverage, 13528,
     /* 1848192 */     GIR_EraseRootFromParent_Done,
     /* 1848193 */   // Label 24976: @1848193
     /* 1848193 */   GIM_Try, /*On fail goto*//*Label 24977*/ GIMT_Encode4(1848279), // Rule ID 13529 //
     /* 1848198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1848209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1848212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1848218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848244 */     // MIs[0] policy
     /* 1848244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1848257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848278 */     // GIR_Coverage, 13529,
     /* 1848278 */     GIR_EraseRootFromParent_Done,
     /* 1848279 */   // Label 24977: @1848279
     /* 1848279 */   GIM_Try, /*On fail goto*//*Label 24978*/ GIMT_Encode4(1848365), // Rule ID 13532 //
     /* 1848284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1848287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1848304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848330 */     // MIs[0] policy
     /* 1848330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848340 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1848343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848364 */     // GIR_Coverage, 13532,
     /* 1848364 */     GIR_EraseRootFromParent_Done,
     /* 1848365 */   // Label 24978: @1848365
     /* 1848365 */   GIM_Try, /*On fail goto*//*Label 24979*/ GIMT_Encode4(1848451), // Rule ID 13533 //
     /* 1848370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1848373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1848381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1848384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1848390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1848393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1848400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1848404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848416 */     // MIs[0] policy
     /* 1848416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848426 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1848429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1848447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848450 */     // GIR_Coverage, 13533,
     /* 1848450 */     GIR_EraseRootFromParent_Done,
     /* 1848451 */   // Label 24979: @1848451
     /* 1848451 */   GIM_Try, /*On fail goto*//*Label 24980*/ GIMT_Encode4(1848537), // Rule ID 13536 //
     /* 1848456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1848467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1848470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1848476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848502 */     // MIs[0] policy
     /* 1848502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848512 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1848515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848536 */     // GIR_Coverage, 13536,
     /* 1848536 */     GIR_EraseRootFromParent_Done,
     /* 1848537 */   // Label 24980: @1848537
     /* 1848537 */   GIM_Try, /*On fail goto*//*Label 24981*/ GIMT_Encode4(1848623), // Rule ID 13537 //
     /* 1848542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1848553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1848556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1848562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1848565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1848572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848588 */     // MIs[0] policy
     /* 1848588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848598 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11579:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_MF2_MASK),
     /* 1848601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848622 */     // GIR_Coverage, 13537,
     /* 1848622 */     GIR_EraseRootFromParent_Done,
     /* 1848623 */   // Label 24981: @1848623
     /* 1848623 */   GIM_Try, /*On fail goto*//*Label 24982*/ GIMT_Encode4(1848709), // Rule ID 13540 //
     /* 1848628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1848648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848674 */     // MIs[0] policy
     /* 1848674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1848687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848708 */     // GIR_Coverage, 13540,
     /* 1848708 */     GIR_EraseRootFromParent_Done,
     /* 1848709 */   // Label 24982: @1848709
     /* 1848709 */   GIM_Try, /*On fail goto*//*Label 24983*/ GIMT_Encode4(1848795), // Rule ID 13541 //
     /* 1848714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1848725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1848728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1848734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1848737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1848744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1848756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848760 */     // MIs[0] policy
     /* 1848760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848770 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11579:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M1_MASK),
     /* 1848773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848794 */     // GIR_Coverage, 13541,
     /* 1848794 */     GIR_EraseRootFromParent_Done,
     /* 1848795 */   // Label 24983: @1848795
     /* 1848795 */   GIM_Try, /*On fail goto*//*Label 24984*/ GIMT_Encode4(1848881), // Rule ID 13544 //
     /* 1848800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848846 */     // MIs[0] policy
     /* 1848846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848856 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1848856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1848859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848880 */     // GIR_Coverage, 13544,
     /* 1848880 */     GIR_EraseRootFromParent_Done,
     /* 1848881 */   // Label 24984: @1848881
     /* 1848881 */   GIM_Try, /*On fail goto*//*Label 24985*/ GIMT_Encode4(1848967), // Rule ID 13545 //
     /* 1848886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1848889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1848897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1848900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1848903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1848906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1848909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1848912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1848916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1848920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1848924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1848928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1848932 */     // MIs[0] policy
     /* 1848932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1848935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1848942 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11579:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1848942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M2_MASK),
     /* 1848945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1848947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1848949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1848951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1848953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1848955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1848960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1848963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1848965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1848966 */     // GIR_Coverage, 13545,
     /* 1848966 */     GIR_EraseRootFromParent_Done,
     /* 1848967 */   // Label 24985: @1848967
     /* 1848967 */   GIM_Try, /*On fail goto*//*Label 24986*/ GIMT_Encode4(1849053), // Rule ID 13548 //
     /* 1848972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1848975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1848980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1848983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1848986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1848989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1848992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1848995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1848998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849018 */     // MIs[0] policy
     /* 1849018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849028 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1849031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1849049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849052 */     // GIR_Coverage, 13548,
     /* 1849052 */     GIR_EraseRootFromParent_Done,
     /* 1849053 */   // Label 24986: @1849053
     /* 1849053 */   GIM_Try, /*On fail goto*//*Label 24987*/ GIMT_Encode4(1849139), // Rule ID 13549 //
     /* 1849058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1849061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmacc_mask),
     /* 1849066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1849069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1849072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1849075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1849078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1849088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1849092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1849096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849104 */     // MIs[0] policy
     /* 1849104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849114 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11579:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACC_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACC_VX_M4_MASK),
     /* 1849117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1849135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849138 */     // GIR_Coverage, 13549,
     /* 1849138 */     GIR_EraseRootFromParent_Done,
     /* 1849139 */   // Label 24987: @1849139
     /* 1849139 */   GIM_Try, /*On fail goto*//*Label 24988*/ GIMT_Encode4(1849225), // Rule ID 13552 //
     /* 1849144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1849164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849190 */     // MIs[0] policy
     /* 1849190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849200 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1849203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849224 */     // GIR_Coverage, 13552,
     /* 1849224 */     GIR_EraseRootFromParent_Done,
     /* 1849225 */   // Label 24988: @1849225
     /* 1849225 */   GIM_Try, /*On fail goto*//*Label 24989*/ GIMT_Encode4(1849311), // Rule ID 13553 //
     /* 1849230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1849241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1849244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1849247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1849250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1849253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849276 */     // MIs[0] policy
     /* 1849276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849286 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF8_MASK),
     /* 1849289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849310 */     // GIR_Coverage, 13553,
     /* 1849310 */     GIR_EraseRootFromParent_Done,
     /* 1849311 */   // Label 24989: @1849311
     /* 1849311 */   GIM_Try, /*On fail goto*//*Label 24990*/ GIMT_Encode4(1849397), // Rule ID 13556 //
     /* 1849316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1849327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1849330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1849336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849362 */     // MIs[0] policy
     /* 1849362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849372 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1849375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849396 */     // GIR_Coverage, 13556,
     /* 1849396 */     GIR_EraseRootFromParent_Done,
     /* 1849397 */   // Label 24990: @1849397
     /* 1849397 */   GIM_Try, /*On fail goto*//*Label 24991*/ GIMT_Encode4(1849483), // Rule ID 13557 //
     /* 1849402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1849413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1849416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1849419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1849422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1849425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849448 */     // MIs[0] policy
     /* 1849448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849458 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1849461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849482 */     // GIR_Coverage, 13557,
     /* 1849482 */     GIR_EraseRootFromParent_Done,
     /* 1849483 */   // Label 24991: @1849483
     /* 1849483 */   GIM_Try, /*On fail goto*//*Label 24992*/ GIMT_Encode4(1849569), // Rule ID 13560 //
     /* 1849488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1849499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1849502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1849508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849534 */     // MIs[0] policy
     /* 1849534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849544 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1849547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849568 */     // GIR_Coverage, 13560,
     /* 1849568 */     GIR_EraseRootFromParent_Done,
     /* 1849569 */   // Label 24992: @1849569
     /* 1849569 */   GIM_Try, /*On fail goto*//*Label 24993*/ GIMT_Encode4(1849655), // Rule ID 13561 //
     /* 1849574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1849585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1849588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1849591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1849594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1849597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1849604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849620 */     // MIs[0] policy
     /* 1849620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849630 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1849633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849654 */     // GIR_Coverage, 13561,
     /* 1849654 */     GIR_EraseRootFromParent_Done,
     /* 1849655 */   // Label 24993: @1849655
     /* 1849655 */   GIM_Try, /*On fail goto*//*Label 24994*/ GIMT_Encode4(1849741), // Rule ID 13564 //
     /* 1849660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1849677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849706 */     // MIs[0] policy
     /* 1849706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1849719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849740 */     // GIR_Coverage, 13564,
     /* 1849740 */     GIR_EraseRootFromParent_Done,
     /* 1849741 */   // Label 24994: @1849741
     /* 1849741 */   GIM_Try, /*On fail goto*//*Label 24995*/ GIMT_Encode4(1849827), // Rule ID 13565 //
     /* 1849746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1849757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1849760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1849763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1849766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1849769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1849776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1849788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849792 */     // MIs[0] policy
     /* 1849792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1849805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849826 */     // GIR_Coverage, 13565,
     /* 1849826 */     GIR_EraseRootFromParent_Done,
     /* 1849827 */   // Label 24995: @1849827
     /* 1849827 */   GIM_Try, /*On fail goto*//*Label 24996*/ GIMT_Encode4(1849913), // Rule ID 13568 //
     /* 1849832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1849835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1849849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1849858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849878 */     // MIs[0] policy
     /* 1849878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849888 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1849888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1849891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849912 */     // GIR_Coverage, 13568,
     /* 1849912 */     GIR_EraseRootFromParent_Done,
     /* 1849913 */   // Label 24996: @1849913
     /* 1849913 */   GIM_Try, /*On fail goto*//*Label 24997*/ GIMT_Encode4(1849999), // Rule ID 13569 //
     /* 1849918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1849921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1849926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1849929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1849932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1849935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1849938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1849941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1849944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1849948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1849952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1849960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1849964 */     // MIs[0] policy
     /* 1849964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1849967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1849974 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1849974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1849977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1849979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1849981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1849983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1849985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1849987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1849992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1849995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1849997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1849998 */     // GIR_Coverage, 13569,
     /* 1849998 */     GIR_EraseRootFromParent_Done,
     /* 1849999 */   // Label 24997: @1849999
     /* 1849999 */   GIM_Try, /*On fail goto*//*Label 24998*/ GIMT_Encode4(1850085), // Rule ID 13572 //
     /* 1850004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1850015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1850018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1850021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1850024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1850027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850050 */     // MIs[0] policy
     /* 1850050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850060 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1850063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850084 */     // GIR_Coverage, 13572,
     /* 1850084 */     GIR_EraseRootFromParent_Done,
     /* 1850085 */   // Label 24998: @1850085
     /* 1850085 */   GIM_Try, /*On fail goto*//*Label 24999*/ GIMT_Encode4(1850171), // Rule ID 13573 //
     /* 1850090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1850101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1850104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1850107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1850110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1850113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850136 */     // MIs[0] policy
     /* 1850136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850146 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1850149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1850167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850170 */     // GIR_Coverage, 13573,
     /* 1850170 */     GIR_EraseRootFromParent_Done,
     /* 1850171 */   // Label 24999: @1850171
     /* 1850171 */   GIM_Try, /*On fail goto*//*Label 25000*/ GIMT_Encode4(1850257), // Rule ID 13576 //
     /* 1850176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1850193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1850196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850222 */     // MIs[0] policy
     /* 1850222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850232 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1850235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850256 */     // GIR_Coverage, 13576,
     /* 1850256 */     GIR_EraseRootFromParent_Done,
     /* 1850257 */   // Label 25000: @1850257
     /* 1850257 */   GIM_Try, /*On fail goto*//*Label 25001*/ GIMT_Encode4(1850343), // Rule ID 13577 //
     /* 1850262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1850273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1850276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1850279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1850282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1850285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850308 */     // MIs[0] policy
     /* 1850308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850318 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF4_MASK),
     /* 1850321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850342 */     // GIR_Coverage, 13577,
     /* 1850342 */     GIR_EraseRootFromParent_Done,
     /* 1850343 */   // Label 25001: @1850343
     /* 1850343 */   GIM_Try, /*On fail goto*//*Label 25002*/ GIMT_Encode4(1850429), // Rule ID 13580 //
     /* 1850348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1850368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850394 */     // MIs[0] policy
     /* 1850394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850404 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1850407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850428 */     // GIR_Coverage, 13580,
     /* 1850428 */     GIR_EraseRootFromParent_Done,
     /* 1850429 */   // Label 25002: @1850429
     /* 1850429 */   GIM_Try, /*On fail goto*//*Label 25003*/ GIMT_Encode4(1850515), // Rule ID 13581 //
     /* 1850434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1850445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1850448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1850451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1850454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1850457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1850464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850480 */     // MIs[0] policy
     /* 1850480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850490 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1850493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850514 */     // GIR_Coverage, 13581,
     /* 1850514 */     GIR_EraseRootFromParent_Done,
     /* 1850515 */   // Label 25003: @1850515
     /* 1850515 */   GIM_Try, /*On fail goto*//*Label 25004*/ GIMT_Encode4(1850601), // Rule ID 13584 //
     /* 1850520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1850531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1850534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1850540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850566 */     // MIs[0] policy
     /* 1850566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1850579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850600 */     // GIR_Coverage, 13584,
     /* 1850600 */     GIR_EraseRootFromParent_Done,
     /* 1850601 */   // Label 25004: @1850601
     /* 1850601 */   GIM_Try, /*On fail goto*//*Label 25005*/ GIMT_Encode4(1850687), // Rule ID 13585 //
     /* 1850606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1850617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1850620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1850623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1850626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1850629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1850636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1850648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850652 */     // MIs[0] policy
     /* 1850652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850662 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1850665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850686 */     // GIR_Coverage, 13585,
     /* 1850686 */     GIR_EraseRootFromParent_Done,
     /* 1850687 */   // Label 25005: @1850687
     /* 1850687 */   GIM_Try, /*On fail goto*//*Label 25006*/ GIMT_Encode4(1850773), // Rule ID 13588 //
     /* 1850692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1850709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850738 */     // MIs[0] policy
     /* 1850738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850748 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1850751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850772 */     // GIR_Coverage, 13588,
     /* 1850772 */     GIR_EraseRootFromParent_Done,
     /* 1850773 */   // Label 25006: @1850773
     /* 1850773 */   GIM_Try, /*On fail goto*//*Label 25007*/ GIMT_Encode4(1850859), // Rule ID 13589 //
     /* 1850778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1850789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1850792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1850795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1850798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1850801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1850808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1850820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850824 */     // MIs[0] policy
     /* 1850824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850834 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1850834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1850837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850858 */     // GIR_Coverage, 13589,
     /* 1850858 */     GIR_EraseRootFromParent_Done,
     /* 1850859 */   // Label 25007: @1850859
     /* 1850859 */   GIM_Try, /*On fail goto*//*Label 25008*/ GIMT_Encode4(1850945), // Rule ID 13592 //
     /* 1850864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1850867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1850881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1850890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850910 */     // MIs[0] policy
     /* 1850910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1850920 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1850920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1850923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1850925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1850927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1850929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1850931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1850933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1850938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1850941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1850943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1850944 */     // GIR_Coverage, 13592,
     /* 1850944 */     GIR_EraseRootFromParent_Done,
     /* 1850945 */   // Label 25008: @1850945
     /* 1850945 */   GIM_Try, /*On fail goto*//*Label 25009*/ GIMT_Encode4(1851031), // Rule ID 13593 //
     /* 1850950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1850953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1850958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1850961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1850964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1850967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1850970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1850973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1850976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1850980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1850984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1850992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1850996 */     // MIs[0] policy
     /* 1850996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1850999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851006 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1851009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1851027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851030 */     // GIR_Coverage, 13593,
     /* 1851030 */     GIR_EraseRootFromParent_Done,
     /* 1851031 */   // Label 25009: @1851031
     /* 1851031 */   GIM_Try, /*On fail goto*//*Label 25010*/ GIMT_Encode4(1851117), // Rule ID 13596 //
     /* 1851036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1851047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1851050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1851053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1851056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851082 */     // MIs[0] policy
     /* 1851082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851092 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1851095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851116 */     // GIR_Coverage, 13596,
     /* 1851116 */     GIR_EraseRootFromParent_Done,
     /* 1851117 */   // Label 25010: @1851117
     /* 1851117 */   GIM_Try, /*On fail goto*//*Label 25011*/ GIMT_Encode4(1851203), // Rule ID 13597 //
     /* 1851122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1851133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1851136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1851139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1851142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851168 */     // MIs[0] policy
     /* 1851168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851178 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_MF2_MASK),
     /* 1851181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851202 */     // GIR_Coverage, 13597,
     /* 1851202 */     GIR_EraseRootFromParent_Done,
     /* 1851203 */   // Label 25011: @1851203
     /* 1851203 */   GIM_Try, /*On fail goto*//*Label 25012*/ GIMT_Encode4(1851289), // Rule ID 13600 //
     /* 1851208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1851219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1851222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1851225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1851228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851254 */     // MIs[0] policy
     /* 1851254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851264 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1851267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851288 */     // GIR_Coverage, 13600,
     /* 1851288 */     GIR_EraseRootFromParent_Done,
     /* 1851289 */   // Label 25012: @1851289
     /* 1851289 */   GIM_Try, /*On fail goto*//*Label 25013*/ GIMT_Encode4(1851375), // Rule ID 13601 //
     /* 1851294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1851305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1851308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1851311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1851314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1851324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851340 */     // MIs[0] policy
     /* 1851340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851350 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M1_MASK),
     /* 1851353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851374 */     // GIR_Coverage, 13601,
     /* 1851374 */     GIR_EraseRootFromParent_Done,
     /* 1851375 */   // Label 25013: @1851375
     /* 1851375 */   GIM_Try, /*On fail goto*//*Label 25014*/ GIMT_Encode4(1851461), // Rule ID 13604 //
     /* 1851380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1851391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1851394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1851397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1851400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851426 */     // MIs[0] policy
     /* 1851426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851436 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1851439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851460 */     // GIR_Coverage, 13604,
     /* 1851460 */     GIR_EraseRootFromParent_Done,
     /* 1851461 */   // Label 25014: @1851461
     /* 1851461 */   GIM_Try, /*On fail goto*//*Label 25015*/ GIMT_Encode4(1851547), // Rule ID 13605 //
     /* 1851466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1851477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1851480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1851483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1851486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1851489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1851496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1851508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851512 */     // MIs[0] policy
     /* 1851512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851522 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M2_MASK),
     /* 1851525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851546 */     // GIR_Coverage, 13605,
     /* 1851546 */     GIR_EraseRootFromParent_Done,
     /* 1851547 */   // Label 25015: @1851547
     /* 1851547 */   GIM_Try, /*On fail goto*//*Label 25016*/ GIMT_Encode4(1851633), // Rule ID 13608 //
     /* 1851552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1851555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1851563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1851566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1851569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1851572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851598 */     // MIs[0] policy
     /* 1851598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851608 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1851611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851632 */     // GIR_Coverage, 13608,
     /* 1851632 */     GIR_EraseRootFromParent_Done,
     /* 1851633 */   // Label 25016: @1851633
     /* 1851633 */   GIM_Try, /*On fail goto*//*Label 25017*/ GIMT_Encode4(1851719), // Rule ID 13609 //
     /* 1851638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1851641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1851649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1851652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1851655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1851658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1851661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1851668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1851672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1851680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851684 */     // MIs[0] policy
     /* 1851684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851694 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VV_M4_MASK),
     /* 1851697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1851715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851718 */     // GIR_Coverage, 13609,
     /* 1851718 */     GIR_EraseRootFromParent_Done,
     /* 1851719 */   // Label 25017: @1851719
     /* 1851719 */   GIM_Try, /*On fail goto*//*Label 25018*/ GIMT_Encode4(1851805), // Rule ID 13612 //
     /* 1851724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851770 */     // MIs[0] policy
     /* 1851770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851780 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1851783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851804 */     // GIR_Coverage, 13612,
     /* 1851804 */     GIR_EraseRootFromParent_Done,
     /* 1851805 */   // Label 25018: @1851805
     /* 1851805 */   GIM_Try, /*On fail goto*//*Label 25019*/ GIMT_Encode4(1851891), // Rule ID 13613 //
     /* 1851810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1851821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1851824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1851830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1851833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1851836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851856 */     // MIs[0] policy
     /* 1851856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851866 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1851866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF8_MASK),
     /* 1851869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851890 */     // GIR_Coverage, 13613,
     /* 1851890 */     GIR_EraseRootFromParent_Done,
     /* 1851891 */   // Label 25019: @1851891
     /* 1851891 */   GIM_Try, /*On fail goto*//*Label 25020*/ GIMT_Encode4(1851977), // Rule ID 13616 //
     /* 1851896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1851899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1851913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1851916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1851919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1851922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1851926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1851934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1851938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1851942 */     // MIs[0] policy
     /* 1851942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1851945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1851952 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1851952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1851955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1851957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1851959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1851961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1851963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1851965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1851970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1851973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1851975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1851976 */     // GIR_Coverage, 13616,
     /* 1851976 */     GIR_EraseRootFromParent_Done,
     /* 1851977 */   // Label 25020: @1851977
     /* 1851977 */   GIM_Try, /*On fail goto*//*Label 25021*/ GIMT_Encode4(1852063), // Rule ID 13617 //
     /* 1851982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1851985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1851990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1851993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1851996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1851999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1852002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852028 */     // MIs[0] policy
     /* 1852028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852038 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1852041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852062 */     // GIR_Coverage, 13617,
     /* 1852062 */     GIR_EraseRootFromParent_Done,
     /* 1852063 */   // Label 25021: @1852063
     /* 1852063 */   GIM_Try, /*On fail goto*//*Label 25022*/ GIMT_Encode4(1852149), // Rule ID 13620 //
     /* 1852068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1852079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1852082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1852088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852114 */     // MIs[0] policy
     /* 1852114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852124 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1852127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852148 */     // GIR_Coverage, 13620,
     /* 1852148 */     GIR_EraseRootFromParent_Done,
     /* 1852149 */   // Label 25022: @1852149
     /* 1852149 */   GIM_Try, /*On fail goto*//*Label 25023*/ GIMT_Encode4(1852235), // Rule ID 13621 //
     /* 1852154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1852165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1852168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1852174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1852177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852200 */     // MIs[0] policy
     /* 1852200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852210 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11581:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1852213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852234 */     // GIR_Coverage, 13621,
     /* 1852234 */     GIR_EraseRootFromParent_Done,
     /* 1852235 */   // Label 25023: @1852235
     /* 1852235 */   GIM_Try, /*On fail goto*//*Label 25024*/ GIMT_Encode4(1852321), // Rule ID 13624 //
     /* 1852240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1852251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1852254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1852260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852286 */     // MIs[0] policy
     /* 1852286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852296 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1852299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852320 */     // GIR_Coverage, 13624,
     /* 1852320 */     GIR_EraseRootFromParent_Done,
     /* 1852321 */   // Label 25024: @1852321
     /* 1852321 */   GIM_Try, /*On fail goto*//*Label 25025*/ GIMT_Encode4(1852407), // Rule ID 13625 //
     /* 1852326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1852337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1852340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1852346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1852349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1852356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852372 */     // MIs[0] policy
     /* 1852372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852382 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1852385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852406 */     // GIR_Coverage, 13625,
     /* 1852406 */     GIR_EraseRootFromParent_Done,
     /* 1852407 */   // Label 25025: @1852407
     /* 1852407 */   GIM_Try, /*On fail goto*//*Label 25026*/ GIMT_Encode4(1852493), // Rule ID 13628 //
     /* 1852412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1852423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1852426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1852432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852458 */     // MIs[0] policy
     /* 1852458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852468 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1852471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852492 */     // GIR_Coverage, 13628,
     /* 1852492 */     GIR_EraseRootFromParent_Done,
     /* 1852493 */   // Label 25026: @1852493
     /* 1852493 */   GIM_Try, /*On fail goto*//*Label 25027*/ GIMT_Encode4(1852579), // Rule ID 13629 //
     /* 1852498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1852509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1852512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1852518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1852521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1852528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1852540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852544 */     // MIs[0] policy
     /* 1852544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852554 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1852557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852578 */     // GIR_Coverage, 13629,
     /* 1852578 */     GIR_EraseRootFromParent_Done,
     /* 1852579 */   // Label 25027: @1852579
     /* 1852579 */   GIM_Try, /*On fail goto*//*Label 25028*/ GIMT_Encode4(1852665), // Rule ID 13632 //
     /* 1852584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852630 */     // MIs[0] policy
     /* 1852630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852640 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1852643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852664 */     // GIR_Coverage, 13632,
     /* 1852664 */     GIR_EraseRootFromParent_Done,
     /* 1852665 */   // Label 25028: @1852665
     /* 1852665 */   GIM_Try, /*On fail goto*//*Label 25029*/ GIMT_Encode4(1852751), // Rule ID 13633 //
     /* 1852670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1852681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1852684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1852690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1852693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1852700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1852704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1852712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852716 */     // MIs[0] policy
     /* 1852716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852726 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1852729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1852747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852750 */     // GIR_Coverage, 13633,
     /* 1852750 */     GIR_EraseRootFromParent_Done,
     /* 1852751 */   // Label 25029: @1852751
     /* 1852751 */   GIM_Try, /*On fail goto*//*Label 25030*/ GIMT_Encode4(1852837), // Rule ID 13636 //
     /* 1852756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852802 */     // MIs[0] policy
     /* 1852802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852812 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1852815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852836 */     // GIR_Coverage, 13636,
     /* 1852836 */     GIR_EraseRootFromParent_Done,
     /* 1852837 */   // Label 25030: @1852837
     /* 1852837 */   GIM_Try, /*On fail goto*//*Label 25031*/ GIMT_Encode4(1852923), // Rule ID 13637 //
     /* 1852842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1852845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1852853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1852856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1852859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1852862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1852865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1852868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852888 */     // MIs[0] policy
     /* 1852888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852898 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1852898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF4_MASK),
     /* 1852901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1852916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1852919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1852921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1852922 */     // GIR_Coverage, 13637,
     /* 1852922 */     GIR_EraseRootFromParent_Done,
     /* 1852923 */   // Label 25031: @1852923
     /* 1852923 */   GIM_Try, /*On fail goto*//*Label 25032*/ GIMT_Encode4(1853009), // Rule ID 13640 //
     /* 1852928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1852931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1852936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1852939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1852942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1852945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1852948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1852951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1852954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1852958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1852966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1852970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1852974 */     // MIs[0] policy
     /* 1852974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1852977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1852984 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1852984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1852987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1852989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1852991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1852993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1852995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1852997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853008 */     // GIR_Coverage, 13640,
     /* 1853008 */     GIR_EraseRootFromParent_Done,
     /* 1853009 */   // Label 25032: @1853009
     /* 1853009 */   GIM_Try, /*On fail goto*//*Label 25033*/ GIMT_Encode4(1853095), // Rule ID 13641 //
     /* 1853014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1853025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1853028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1853034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853060 */     // MIs[0] policy
     /* 1853060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853070 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11581:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1853073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853094 */     // GIR_Coverage, 13641,
     /* 1853094 */     GIR_EraseRootFromParent_Done,
     /* 1853095 */   // Label 25033: @1853095
     /* 1853095 */   GIM_Try, /*On fail goto*//*Label 25034*/ GIMT_Encode4(1853181), // Rule ID 13644 //
     /* 1853100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1853111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1853114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853146 */     // MIs[0] policy
     /* 1853146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853156 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1853159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853180 */     // GIR_Coverage, 13644,
     /* 1853180 */     GIR_EraseRootFromParent_Done,
     /* 1853181 */   // Label 25034: @1853181
     /* 1853181 */   GIM_Try, /*On fail goto*//*Label 25035*/ GIMT_Encode4(1853267), // Rule ID 13645 //
     /* 1853186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1853197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1853200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1853206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853232 */     // MIs[0] policy
     /* 1853232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853242 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1853245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853266 */     // GIR_Coverage, 13645,
     /* 1853266 */     GIR_EraseRootFromParent_Done,
     /* 1853267 */   // Label 25035: @1853267
     /* 1853267 */   GIM_Try, /*On fail goto*//*Label 25036*/ GIMT_Encode4(1853353), // Rule ID 13648 //
     /* 1853272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1853283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1853286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1853292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853318 */     // MIs[0] policy
     /* 1853318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853328 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1853331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853352 */     // GIR_Coverage, 13648,
     /* 1853352 */     GIR_EraseRootFromParent_Done,
     /* 1853353 */   // Label 25036: @1853353
     /* 1853353 */   GIM_Try, /*On fail goto*//*Label 25037*/ GIMT_Encode4(1853439), // Rule ID 13649 //
     /* 1853358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1853369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1853372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1853378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1853381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853404 */     // MIs[0] policy
     /* 1853404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853414 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1853417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853438 */     // GIR_Coverage, 13649,
     /* 1853438 */     GIR_EraseRootFromParent_Done,
     /* 1853439 */   // Label 25037: @1853439
     /* 1853439 */   GIM_Try, /*On fail goto*//*Label 25038*/ GIMT_Encode4(1853525), // Rule ID 13652 //
     /* 1853444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1853447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1853455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1853458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1853464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853490 */     // MIs[0] policy
     /* 1853490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853500 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1853503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853524 */     // GIR_Coverage, 13652,
     /* 1853524 */     GIR_EraseRootFromParent_Done,
     /* 1853525 */   // Label 25038: @1853525
     /* 1853525 */   GIM_Try, /*On fail goto*//*Label 25039*/ GIMT_Encode4(1853611), // Rule ID 13653 //
     /* 1853530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1853533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1853541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1853544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1853550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1853553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1853560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1853564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853576 */     // MIs[0] policy
     /* 1853576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853586 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1853589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1853607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853610 */     // GIR_Coverage, 13653,
     /* 1853610 */     GIR_EraseRootFromParent_Done,
     /* 1853611 */   // Label 25039: @1853611
     /* 1853611 */   GIM_Try, /*On fail goto*//*Label 25040*/ GIMT_Encode4(1853697), // Rule ID 13656 //
     /* 1853616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853662 */     // MIs[0] policy
     /* 1853662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1853675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853696 */     // GIR_Coverage, 13656,
     /* 1853696 */     GIR_EraseRootFromParent_Done,
     /* 1853697 */   // Label 25040: @1853697
     /* 1853697 */   GIM_Try, /*On fail goto*//*Label 25041*/ GIMT_Encode4(1853783), // Rule ID 13657 //
     /* 1853702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1853713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1853716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1853722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1853725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1853732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853748 */     // MIs[0] policy
     /* 1853748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11581:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_MF2_MASK),
     /* 1853761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853782 */     // GIR_Coverage, 13657,
     /* 1853782 */     GIR_EraseRootFromParent_Done,
     /* 1853783 */   // Label 25041: @1853783
     /* 1853783 */   GIM_Try, /*On fail goto*//*Label 25042*/ GIMT_Encode4(1853869), // Rule ID 13660 //
     /* 1853788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853834 */     // MIs[0] policy
     /* 1853834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853844 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1853844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1853847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853868 */     // GIR_Coverage, 13660,
     /* 1853868 */     GIR_EraseRootFromParent_Done,
     /* 1853869 */   // Label 25042: @1853869
     /* 1853869 */   GIM_Try, /*On fail goto*//*Label 25043*/ GIMT_Encode4(1853955), // Rule ID 13661 //
     /* 1853874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1853877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1853885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1853888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1853891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1853894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1853897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1853900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1853904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1853908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1853916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1853920 */     // MIs[0] policy
     /* 1853920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1853923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1853930 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11581:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1853930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M1_MASK),
     /* 1853933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1853935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1853937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1853939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1853941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1853943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1853948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1853951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1853953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1853954 */     // GIR_Coverage, 13661,
     /* 1853954 */     GIR_EraseRootFromParent_Done,
     /* 1853955 */   // Label 25043: @1853955
     /* 1853955 */   GIM_Try, /*On fail goto*//*Label 25044*/ GIMT_Encode4(1854041), // Rule ID 13664 //
     /* 1853960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1853963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1853968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1853971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1853974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1853977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1853980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1853983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1853986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1853990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1853994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1853998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854006 */     // MIs[0] policy
     /* 1854006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854016 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1854019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854040 */     // GIR_Coverage, 13664,
     /* 1854040 */     GIR_EraseRootFromParent_Done,
     /* 1854041 */   // Label 25044: @1854041
     /* 1854041 */   GIM_Try, /*On fail goto*//*Label 25045*/ GIMT_Encode4(1854127), // Rule ID 13665 //
     /* 1854046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1854049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1854057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1854060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1854066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1854076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854092 */     // MIs[0] policy
     /* 1854092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854102 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11581:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M2_MASK),
     /* 1854105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854126 */     // GIR_Coverage, 13665,
     /* 1854126 */     GIR_EraseRootFromParent_Done,
     /* 1854127 */   // Label 25045: @1854127
     /* 1854127 */   GIM_Try, /*On fail goto*//*Label 25046*/ GIMT_Encode4(1854213), // Rule ID 13668 //
     /* 1854132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1854135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1854143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1854146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1854152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854178 */     // MIs[0] policy
     /* 1854178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854188 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1854191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854212 */     // GIR_Coverage, 13668,
     /* 1854212 */     GIR_EraseRootFromParent_Done,
     /* 1854213 */   // Label 25046: @1854213
     /* 1854213 */   GIM_Try, /*On fail goto*//*Label 25047*/ GIMT_Encode4(1854299), // Rule ID 13669 //
     /* 1854218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1854221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccsu_mask),
     /* 1854226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1854229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1854232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1854238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1854248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1854252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1854260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854264 */     // MIs[0] policy
     /* 1854264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854274 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11581:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCSU_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCSU_VX_M4_MASK),
     /* 1854277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1854295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854298 */     // GIR_Coverage, 13669,
     /* 1854298 */     GIR_EraseRootFromParent_Done,
     /* 1854299 */   // Label 25047: @1854299
     /* 1854299 */   GIM_Try, /*On fail goto*//*Label 25048*/ GIMT_Encode4(1854385), // Rule ID 13672 //
     /* 1854304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1854315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1854318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1854324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854350 */     // MIs[0] policy
     /* 1854350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854360 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1854363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854384 */     // GIR_Coverage, 13672,
     /* 1854384 */     GIR_EraseRootFromParent_Done,
     /* 1854385 */   // Label 25048: @1854385
     /* 1854385 */   GIM_Try, /*On fail goto*//*Label 25049*/ GIMT_Encode4(1854471), // Rule ID 13673 //
     /* 1854390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1854401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1854404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1854410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1854413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854436 */     // MIs[0] policy
     /* 1854436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854446 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF8_MASK),
     /* 1854449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854470 */     // GIR_Coverage, 13673,
     /* 1854470 */     GIR_EraseRootFromParent_Done,
     /* 1854471 */   // Label 25049: @1854471
     /* 1854471 */   GIM_Try, /*On fail goto*//*Label 25050*/ GIMT_Encode4(1854557), // Rule ID 13676 //
     /* 1854476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1854487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1854490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1854496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854522 */     // MIs[0] policy
     /* 1854522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854532 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1854535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854556 */     // GIR_Coverage, 13676,
     /* 1854556 */     GIR_EraseRootFromParent_Done,
     /* 1854557 */   // Label 25050: @1854557
     /* 1854557 */   GIM_Try, /*On fail goto*//*Label 25051*/ GIMT_Encode4(1854643), // Rule ID 13677 //
     /* 1854562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1854573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1854576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1854582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1854585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854608 */     // MIs[0] policy
     /* 1854608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854618 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1854621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854642 */     // GIR_Coverage, 13677,
     /* 1854642 */     GIR_EraseRootFromParent_Done,
     /* 1854643 */   // Label 25051: @1854643
     /* 1854643 */   GIM_Try, /*On fail goto*//*Label 25052*/ GIMT_Encode4(1854729), // Rule ID 13680 //
     /* 1854648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854694 */     // MIs[0] policy
     /* 1854694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854704 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1854707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854728 */     // GIR_Coverage, 13680,
     /* 1854728 */     GIR_EraseRootFromParent_Done,
     /* 1854729 */   // Label 25052: @1854729
     /* 1854729 */   GIM_Try, /*On fail goto*//*Label 25053*/ GIMT_Encode4(1854815), // Rule ID 13681 //
     /* 1854734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1854745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1854748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1854754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1854757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1854764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854780 */     // MIs[0] policy
     /* 1854780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854790 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11585:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1854793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854814 */     // GIR_Coverage, 13681,
     /* 1854814 */     GIR_EraseRootFromParent_Done,
     /* 1854815 */   // Label 25053: @1854815
     /* 1854815 */   GIM_Try, /*On fail goto*//*Label 25054*/ GIMT_Encode4(1854901), // Rule ID 13684 //
     /* 1854820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1854837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1854846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854866 */     // MIs[0] policy
     /* 1854866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1854876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1854879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854900 */     // GIR_Coverage, 13684,
     /* 1854900 */     GIR_EraseRootFromParent_Done,
     /* 1854901 */   // Label 25054: @1854901
     /* 1854901 */   GIM_Try, /*On fail goto*//*Label 25055*/ GIMT_Encode4(1854987), // Rule ID 13685 //
     /* 1854906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1854909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1854914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1854917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1854920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1854923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1854926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1854929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1854932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1854936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1854940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1854944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1854948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1854952 */     // MIs[0] policy
     /* 1854952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1854955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1854962 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1854962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1854965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1854967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1854969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1854971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1854973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1854975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1854980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1854983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1854985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1854986 */     // GIR_Coverage, 13685,
     /* 1854986 */     GIR_EraseRootFromParent_Done,
     /* 1854987 */   // Label 25055: @1854987
     /* 1854987 */   GIM_Try, /*On fail goto*//*Label 25056*/ GIMT_Encode4(1855073), // Rule ID 13688 //
     /* 1854992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1854995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1855012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855038 */     // MIs[0] policy
     /* 1855038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855048 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1855051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855072 */     // GIR_Coverage, 13688,
     /* 1855072 */     GIR_EraseRootFromParent_Done,
     /* 1855073 */   // Label 25056: @1855073
     /* 1855073 */   GIM_Try, /*On fail goto*//*Label 25057*/ GIMT_Encode4(1855159), // Rule ID 13689 //
     /* 1855078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1855089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1855092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1855098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1855101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855124 */     // MIs[0] policy
     /* 1855124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855134 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1855137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855158 */     // GIR_Coverage, 13689,
     /* 1855158 */     GIR_EraseRootFromParent_Done,
     /* 1855159 */   // Label 25057: @1855159
     /* 1855159 */   GIM_Try, /*On fail goto*//*Label 25058*/ GIMT_Encode4(1855245), // Rule ID 13692 //
     /* 1855164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1855184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855210 */     // MIs[0] policy
     /* 1855210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855220 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1855223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855244 */     // GIR_Coverage, 13692,
     /* 1855244 */     GIR_EraseRootFromParent_Done,
     /* 1855245 */   // Label 25058: @1855245
     /* 1855245 */   GIM_Try, /*On fail goto*//*Label 25059*/ GIMT_Encode4(1855331), // Rule ID 13693 //
     /* 1855250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1855261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1855264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1855270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1855273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1855280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1855284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855296 */     // MIs[0] policy
     /* 1855296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855306 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1855309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1855327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855330 */     // GIR_Coverage, 13693,
     /* 1855330 */     GIR_EraseRootFromParent_Done,
     /* 1855331 */   // Label 25059: @1855331
     /* 1855331 */   GIM_Try, /*On fail goto*//*Label 25060*/ GIMT_Encode4(1855417), // Rule ID 13696 //
     /* 1855336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1855347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1855350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1855356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855382 */     // MIs[0] policy
     /* 1855382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855392 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1855395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855416 */     // GIR_Coverage, 13696,
     /* 1855416 */     GIR_EraseRootFromParent_Done,
     /* 1855417 */   // Label 25060: @1855417
     /* 1855417 */   GIM_Try, /*On fail goto*//*Label 25061*/ GIMT_Encode4(1855503), // Rule ID 13697 //
     /* 1855422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1855433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1855436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1855442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1855445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855468 */     // MIs[0] policy
     /* 1855468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855478 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF4_MASK),
     /* 1855481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855502 */     // GIR_Coverage, 13697,
     /* 1855502 */     GIR_EraseRootFromParent_Done,
     /* 1855503 */   // Label 25061: @1855503
     /* 1855503 */   GIM_Try, /*On fail goto*//*Label 25062*/ GIMT_Encode4(1855589), // Rule ID 13700 //
     /* 1855508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1855519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1855522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1855528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855554 */     // MIs[0] policy
     /* 1855554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855564 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1855567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855588 */     // GIR_Coverage, 13700,
     /* 1855588 */     GIR_EraseRootFromParent_Done,
     /* 1855589 */   // Label 25062: @1855589
     /* 1855589 */   GIM_Try, /*On fail goto*//*Label 25063*/ GIMT_Encode4(1855675), // Rule ID 13701 //
     /* 1855594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1855605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1855608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1855614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1855617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1855624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855640 */     // MIs[0] policy
     /* 1855640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855650 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11585:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1855653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855674 */     // GIR_Coverage, 13701,
     /* 1855674 */     GIR_EraseRootFromParent_Done,
     /* 1855675 */   // Label 25063: @1855675
     /* 1855675 */   GIM_Try, /*On fail goto*//*Label 25064*/ GIMT_Encode4(1855761), // Rule ID 13704 //
     /* 1855680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855726 */     // MIs[0] policy
     /* 1855726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1855739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855760 */     // GIR_Coverage, 13704,
     /* 1855760 */     GIR_EraseRootFromParent_Done,
     /* 1855761 */   // Label 25064: @1855761
     /* 1855761 */   GIM_Try, /*On fail goto*//*Label 25065*/ GIMT_Encode4(1855847), // Rule ID 13705 //
     /* 1855766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1855777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1855780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1855786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1855789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1855796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1855808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855812 */     // MIs[0] policy
     /* 1855812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855822 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1855825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855846 */     // GIR_Coverage, 13705,
     /* 1855846 */     GIR_EraseRootFromParent_Done,
     /* 1855847 */   // Label 25065: @1855847
     /* 1855847 */   GIM_Try, /*On fail goto*//*Label 25066*/ GIMT_Encode4(1855933), // Rule ID 13708 //
     /* 1855852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1855855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1855869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1855878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855898 */     // MIs[0] policy
     /* 1855898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855908 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1855908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1855911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1855915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1855917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1855919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1855921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1855926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1855929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1855931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1855932 */     // GIR_Coverage, 13708,
     /* 1855932 */     GIR_EraseRootFromParent_Done,
     /* 1855933 */   // Label 25066: @1855933
     /* 1855933 */   GIM_Try, /*On fail goto*//*Label 25067*/ GIMT_Encode4(1856019), // Rule ID 13709 //
     /* 1855938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1855941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1855946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1855949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1855952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1855955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1855958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1855961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1855964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1855968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1855972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1855976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1855980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1855984 */     // MIs[0] policy
     /* 1855984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1855987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1855994 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1855994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1855997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1855999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856018 */     // GIR_Coverage, 13709,
     /* 1856018 */     GIR_EraseRootFromParent_Done,
     /* 1856019 */   // Label 25067: @1856019
     /* 1856019 */   GIM_Try, /*On fail goto*//*Label 25068*/ GIMT_Encode4(1856105), // Rule ID 13712 //
     /* 1856024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856070 */     // MIs[0] policy
     /* 1856070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856080 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1856083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856104 */     // GIR_Coverage, 13712,
     /* 1856104 */     GIR_EraseRootFromParent_Done,
     /* 1856105 */   // Label 25068: @1856105
     /* 1856105 */   GIM_Try, /*On fail goto*//*Label 25069*/ GIMT_Encode4(1856191), // Rule ID 13713 //
     /* 1856110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1856121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1856124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1856130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1856133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856156 */     // MIs[0] policy
     /* 1856156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856166 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1856169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1856187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856190 */     // GIR_Coverage, 13713,
     /* 1856190 */     GIR_EraseRootFromParent_Done,
     /* 1856191 */   // Label 25069: @1856191
     /* 1856191 */   GIM_Try, /*On fail goto*//*Label 25070*/ GIMT_Encode4(1856277), // Rule ID 13716 //
     /* 1856196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1856207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1856210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856242 */     // MIs[0] policy
     /* 1856242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856252 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1856255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856276 */     // GIR_Coverage, 13716,
     /* 1856276 */     GIR_EraseRootFromParent_Done,
     /* 1856277 */   // Label 25070: @1856277
     /* 1856277 */   GIM_Try, /*On fail goto*//*Label 25071*/ GIMT_Encode4(1856363), // Rule ID 13717 //
     /* 1856282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1856293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1856296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1856302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856328 */     // MIs[0] policy
     /* 1856328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856338 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11585:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_MF2_MASK),
     /* 1856341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856362 */     // GIR_Coverage, 13717,
     /* 1856362 */     GIR_EraseRootFromParent_Done,
     /* 1856363 */   // Label 25071: @1856363
     /* 1856363 */   GIM_Try, /*On fail goto*//*Label 25072*/ GIMT_Encode4(1856449), // Rule ID 13720 //
     /* 1856368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1856388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856414 */     // MIs[0] policy
     /* 1856414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1856427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856448 */     // GIR_Coverage, 13720,
     /* 1856448 */     GIR_EraseRootFromParent_Done,
     /* 1856449 */   // Label 25072: @1856449
     /* 1856449 */   GIM_Try, /*On fail goto*//*Label 25073*/ GIMT_Encode4(1856535), // Rule ID 13721 //
     /* 1856454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1856465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1856468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1856474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1856477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1856484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856500 */     // MIs[0] policy
     /* 1856500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11585:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M1_MASK),
     /* 1856513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856534 */     // GIR_Coverage, 13721,
     /* 1856534 */     GIR_EraseRootFromParent_Done,
     /* 1856535 */   // Label 25073: @1856535
     /* 1856535 */   GIM_Try, /*On fail goto*//*Label 25074*/ GIMT_Encode4(1856621), // Rule ID 13724 //
     /* 1856540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1856560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856586 */     // MIs[0] policy
     /* 1856586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856596 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1856599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856620 */     // GIR_Coverage, 13724,
     /* 1856620 */     GIR_EraseRootFromParent_Done,
     /* 1856621 */   // Label 25074: @1856621
     /* 1856621 */   GIM_Try, /*On fail goto*//*Label 25075*/ GIMT_Encode4(1856707), // Rule ID 13725 //
     /* 1856626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1856637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1856640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1856646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1856649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1856656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1856668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856672 */     // MIs[0] policy
     /* 1856672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856682 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11585:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M2_MASK),
     /* 1856685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856706 */     // GIR_Coverage, 13725,
     /* 1856706 */     GIR_EraseRootFromParent_Done,
     /* 1856707 */   // Label 25075: @1856707
     /* 1856707 */   GIM_Try, /*On fail goto*//*Label 25076*/ GIMT_Encode4(1856793), // Rule ID 13728 //
     /* 1856712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1856715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1856729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856758 */     // MIs[0] policy
     /* 1856758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856768 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1856771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856792 */     // GIR_Coverage, 13728,
     /* 1856792 */     GIR_EraseRootFromParent_Done,
     /* 1856793 */   // Label 25076: @1856793
     /* 1856793 */   GIM_Try, /*On fail goto*//*Label 25077*/ GIMT_Encode4(1856879), // Rule ID 13729 //
     /* 1856798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1856801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwmaccus_mask),
     /* 1856806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1856809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1856812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1856815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1856818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1856821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1856828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1856832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1856836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1856840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856844 */     // MIs[0] policy
     /* 1856844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856854 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11585:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWMACCUS_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1856854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWMACCUS_VX_M4_MASK),
     /* 1856857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856859 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1856861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1856875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856878 */     // GIR_Coverage, 13729,
     /* 1856878 */     GIR_EraseRootFromParent_Done,
     /* 1856879 */   // Label 25077: @1856879
     /* 1856879 */   GIM_Try, /*On fail goto*//*Label 25078*/ GIMT_Encode4(1856968), // Rule ID 13938 //
     /* 1856884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1856887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1856892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1856895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1856898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1856910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1856914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1856926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1856930 */     // MIs[0] policy
     /* 1856930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1856933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1856940 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1856940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1856943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1856945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1856947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1856949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1856951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1856953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1856958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1856961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1856963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1856966 */     GIR_RootConstrainSelectedInstOperands,
     /* 1856967 */     // GIR_Coverage, 13938,
     /* 1856967 */     GIR_EraseRootFromParent_Done,
     /* 1856968 */   // Label 25078: @1856968
     /* 1856968 */   GIM_Try, /*On fail goto*//*Label 25079*/ GIMT_Encode4(1857057), // Rule ID 13939 //
     /* 1856973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1856976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1856981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1856984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1856987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1856990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1856993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1856996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1856999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857019 */     // MIs[0] policy
     /* 1857019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857029 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8_MASK),
     /* 1857032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857050 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857052 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857056 */     // GIR_Coverage, 13939,
     /* 1857056 */     GIR_EraseRootFromParent_Done,
     /* 1857057 */   // Label 25079: @1857057
     /* 1857057 */   GIM_Try, /*On fail goto*//*Label 25080*/ GIMT_Encode4(1857146), // Rule ID 13942 //
     /* 1857062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1857073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1857076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1857079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1857082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857108 */     // MIs[0] policy
     /* 1857108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857118 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1857121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857141 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857144 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857145 */     // GIR_Coverage, 13942,
     /* 1857145 */     GIR_EraseRootFromParent_Done,
     /* 1857146 */   // Label 25080: @1857146
     /* 1857146 */   GIM_Try, /*On fail goto*//*Label 25081*/ GIMT_Encode4(1857235), // Rule ID 13943 //
     /* 1857151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1857162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1857165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1857168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1857171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857174 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857197 */     // MIs[0] policy
     /* 1857197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857207 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1857210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857228 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857230 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857234 */     // GIR_Coverage, 13943,
     /* 1857234 */     GIR_EraseRootFromParent_Done,
     /* 1857235 */   // Label 25081: @1857235
     /* 1857235 */   GIM_Try, /*On fail goto*//*Label 25082*/ GIMT_Encode4(1857324), // Rule ID 13946 //
     /* 1857240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1857251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1857254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1857257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1857260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857286 */     // MIs[0] policy
     /* 1857286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857296 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857322 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857323 */     // GIR_Coverage, 13946,
     /* 1857323 */     GIR_EraseRootFromParent_Done,
     /* 1857324 */   // Label 25082: @1857324
     /* 1857324 */   GIM_Try, /*On fail goto*//*Label 25083*/ GIMT_Encode4(1857413), // Rule ID 13947 //
     /* 1857329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1857340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1857343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1857346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1857349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1857352 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857375 */     // MIs[0] policy
     /* 1857375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857385 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1857406 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857408 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857412 */     // GIR_Coverage, 13947,
     /* 1857412 */     GIR_EraseRootFromParent_Done,
     /* 1857413 */   // Label 25083: @1857413
     /* 1857413 */   GIM_Try, /*On fail goto*//*Label 25084*/ GIMT_Encode4(1857502), // Rule ID 13950 //
     /* 1857418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1857429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1857432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857464 */     // MIs[0] policy
     /* 1857464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857474 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1857477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857497 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857500 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857501 */     // GIR_Coverage, 13950,
     /* 1857501 */     GIR_EraseRootFromParent_Done,
     /* 1857502 */   // Label 25084: @1857502
     /* 1857502 */   GIM_Try, /*On fail goto*//*Label 25085*/ GIMT_Encode4(1857591), // Rule ID 13951 //
     /* 1857507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1857518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1857521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1857524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1857527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857530 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857553 */     // MIs[0] policy
     /* 1857553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857563 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4_MASK),
     /* 1857566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857584 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857586 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857590 */     // GIR_Coverage, 13951,
     /* 1857590 */     GIR_EraseRootFromParent_Done,
     /* 1857591 */   // Label 25085: @1857591
     /* 1857591 */   GIM_Try, /*On fail goto*//*Label 25086*/ GIMT_Encode4(1857680), // Rule ID 13954 //
     /* 1857596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1857607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1857610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857642 */     // MIs[0] policy
     /* 1857642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857652 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857678 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857679 */     // GIR_Coverage, 13954,
     /* 1857679 */     GIR_EraseRootFromParent_Done,
     /* 1857680 */   // Label 25086: @1857680
     /* 1857680 */   GIM_Try, /*On fail goto*//*Label 25087*/ GIMT_Encode4(1857769), // Rule ID 13955 //
     /* 1857685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1857696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1857699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1857702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1857705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1857708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857731 */     // MIs[0] policy
     /* 1857731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857741 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1857762 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857768 */     // GIR_Coverage, 13955,
     /* 1857768 */     GIR_EraseRootFromParent_Done,
     /* 1857769 */   // Label 25087: @1857769
     /* 1857769 */   GIM_Try, /*On fail goto*//*Label 25088*/ GIMT_Encode4(1857858), // Rule ID 13958 //
     /* 1857774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857820 */     // MIs[0] policy
     /* 1857820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857830 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1857830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857856 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857857 */     // GIR_Coverage, 13958,
     /* 1857857 */     GIR_EraseRootFromParent_Done,
     /* 1857858 */   // Label 25088: @1857858
     /* 1857858 */   GIM_Try, /*On fail goto*//*Label 25089*/ GIMT_Encode4(1857947), // Rule ID 13959 //
     /* 1857863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1857866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1857874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1857877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1857880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1857883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1857886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1857889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857909 */     // MIs[0] policy
     /* 1857909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1857912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1857919 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1857919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2_MASK),
     /* 1857922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1857924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1857926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1857928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1857930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1857932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1857937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1857940 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1857942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1857945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1857946 */     // GIR_Coverage, 13959,
     /* 1857946 */     GIR_EraseRootFromParent_Done,
     /* 1857947 */   // Label 25089: @1857947
     /* 1857947 */   GIM_Try, /*On fail goto*//*Label 25090*/ GIMT_Encode4(1858036), // Rule ID 13962 //
     /* 1857952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1857955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1857960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1857963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1857966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1857969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1857972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1857975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1857978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1857982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1857994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1857998 */     // MIs[0] policy
     /* 1857998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858008 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858034 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858035 */     // GIR_Coverage, 13962,
     /* 1858035 */     GIR_EraseRootFromParent_Done,
     /* 1858036 */   // Label 25090: @1858036
     /* 1858036 */   GIM_Try, /*On fail goto*//*Label 25091*/ GIMT_Encode4(1858125), // Rule ID 13963 //
     /* 1858041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1858052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1858055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1858058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1858061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1858064 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858087 */     // MIs[0] policy
     /* 1858087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858097 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858118 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858124 */     // GIR_Coverage, 13963,
     /* 1858124 */     GIR_EraseRootFromParent_Done,
     /* 1858125 */   // Label 25091: @1858125
     /* 1858125 */   GIM_Try, /*On fail goto*//*Label 25092*/ GIMT_Encode4(1858214), // Rule ID 13966 //
     /* 1858130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1858147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1858150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858176 */     // MIs[0] policy
     /* 1858176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858186 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858209 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858212 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858213 */     // GIR_Coverage, 13966,
     /* 1858213 */     GIR_EraseRootFromParent_Done,
     /* 1858214 */   // Label 25092: @1858214
     /* 1858214 */   GIM_Try, /*On fail goto*//*Label 25093*/ GIMT_Encode4(1858303), // Rule ID 13967 //
     /* 1858219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1858230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1858233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1858236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1858239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1858242 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858265 */     // MIs[0] policy
     /* 1858265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858275 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1858296 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858298 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858302 */     // GIR_Coverage, 13967,
     /* 1858302 */     GIR_EraseRootFromParent_Done,
     /* 1858303 */   // Label 25093: @1858303
     /* 1858303 */   GIM_Try, /*On fail goto*//*Label 25094*/ GIMT_Encode4(1858392), // Rule ID 13970 //
     /* 1858308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858354 */     // MIs[0] policy
     /* 1858354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858364 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858390 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858391 */     // GIR_Coverage, 13970,
     /* 1858391 */     GIR_EraseRootFromParent_Done,
     /* 1858392 */   // Label 25094: @1858392
     /* 1858392 */   GIM_Try, /*On fail goto*//*Label 25095*/ GIMT_Encode4(1858481), // Rule ID 13971 //
     /* 1858397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1858408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1858411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1858414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1858417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1858420 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858443 */     // MIs[0] policy
     /* 1858443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858453 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1858474 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858476 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858480 */     // GIR_Coverage, 13971,
     /* 1858480 */     GIR_EraseRootFromParent_Done,
     /* 1858481 */   // Label 25095: @1858481
     /* 1858481 */   GIM_Try, /*On fail goto*//*Label 25096*/ GIMT_Encode4(1858570), // Rule ID 13974 //
     /* 1858486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1858489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1858503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1858506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858532 */     // MIs[0] policy
     /* 1858532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858542 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858568 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858569 */     // GIR_Coverage, 13974,
     /* 1858569 */     GIR_EraseRootFromParent_Done,
     /* 1858570 */   // Label 25096: @1858570
     /* 1858570 */   GIM_Try, /*On fail goto*//*Label 25097*/ GIMT_Encode4(1858659), // Rule ID 13975 //
     /* 1858575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1858578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1858586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1858589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1858592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1858595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1858598 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1858605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1858617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858621 */     // MIs[0] policy
     /* 1858621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858631 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1_MASK),
     /* 1858634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1858652 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858654 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858658 */     // GIR_Coverage, 13975,
     /* 1858658 */     GIR_EraseRootFromParent_Done,
     /* 1858659 */   // Label 25097: @1858659
     /* 1858659 */   GIM_Try, /*On fail goto*//*Label 25098*/ GIMT_Encode4(1858748), // Rule ID 13978 //
     /* 1858664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1858675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1858678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1858681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1858684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858710 */     // MIs[0] policy
     /* 1858710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858720 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1858723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858743 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858746 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858747 */     // GIR_Coverage, 13978,
     /* 1858747 */     GIR_EraseRootFromParent_Done,
     /* 1858748 */   // Label 25098: @1858748
     /* 1858748 */   GIM_Try, /*On fail goto*//*Label 25099*/ GIMT_Encode4(1858837), // Rule ID 13979 //
     /* 1858753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1858764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1858767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1858770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1858773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1858776 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1858783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1858795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858799 */     // MIs[0] policy
     /* 1858799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858809 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1858812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858814 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858830 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858832 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858836 */     // GIR_Coverage, 13979,
     /* 1858836 */     GIR_EraseRootFromParent_Done,
     /* 1858837 */   // Label 25099: @1858837
     /* 1858837 */   GIM_Try, /*On fail goto*//*Label 25100*/ GIMT_Encode4(1858926), // Rule ID 13982 //
     /* 1858842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1858845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1858853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1858856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1858859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1858862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1858865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1858868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858888 */     // MIs[0] policy
     /* 1858888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858898 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1858898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1858901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1858911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1858916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1858919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1858921 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1858924 */     GIR_RootConstrainSelectedInstOperands,
     /* 1858925 */     // GIR_Coverage, 13982,
     /* 1858925 */     GIR_EraseRootFromParent_Done,
     /* 1858926 */   // Label 25100: @1858926
     /* 1858926 */   GIM_Try, /*On fail goto*//*Label 25101*/ GIMT_Encode4(1859015), // Rule ID 13983 //
     /* 1858931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1858934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1858939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1858942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1858945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1858948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1858951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1858954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1858957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1858961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1858973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1858977 */     // MIs[0] policy
     /* 1858977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1858980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1858987 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1858987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1858990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1858992 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1858994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1858996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1858998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859008 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859010 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859014 */     // GIR_Coverage, 13983,
     /* 1859014 */     GIR_EraseRootFromParent_Done,
     /* 1859015 */   // Label 25101: @1859015
     /* 1859015 */   GIM_Try, /*On fail goto*//*Label 25102*/ GIMT_Encode4(1859104), // Rule ID 13986 //
     /* 1859020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1859031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1859034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1859037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1859040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1859043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859066 */     // MIs[0] policy
     /* 1859066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859076 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1859079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859102 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859103 */     // GIR_Coverage, 13986,
     /* 1859103 */     GIR_EraseRootFromParent_Done,
     /* 1859104 */   // Label 25102: @1859104
     /* 1859104 */   GIM_Try, /*On fail goto*//*Label 25103*/ GIMT_Encode4(1859193), // Rule ID 13987 //
     /* 1859109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1859120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1859123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1859126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1859129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1859132 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859155 */     // MIs[0] policy
     /* 1859155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859165 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1859168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1859186 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859192 */     // GIR_Coverage, 13987,
     /* 1859192 */     GIR_EraseRootFromParent_Done,
     /* 1859193 */   // Label 25103: @1859193
     /* 1859193 */   GIM_Try, /*On fail goto*//*Label 25104*/ GIMT_Encode4(1859282), // Rule ID 13990 //
     /* 1859198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1859215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859244 */     // MIs[0] policy
     /* 1859244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1859257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859280 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859281 */     // GIR_Coverage, 13990,
     /* 1859281 */     GIR_EraseRootFromParent_Done,
     /* 1859282 */   // Label 25104: @1859282
     /* 1859282 */   GIM_Try, /*On fail goto*//*Label 25105*/ GIMT_Encode4(1859371), // Rule ID 13991 //
     /* 1859287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1859298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1859301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1859304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1859307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859310 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859333 */     // MIs[0] policy
     /* 1859333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859343 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1859346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859364 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859366 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859370 */     // GIR_Coverage, 13991,
     /* 1859370 */     GIR_EraseRootFromParent_Done,
     /* 1859371 */   // Label 25105: @1859371
     /* 1859371 */   GIM_Try, /*On fail goto*//*Label 25106*/ GIMT_Encode4(1859460), // Rule ID 13994 //
     /* 1859376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1859393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1859396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859422 */     // MIs[0] policy
     /* 1859422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859432 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1859435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859458 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859459 */     // GIR_Coverage, 13994,
     /* 1859459 */     GIR_EraseRootFromParent_Done,
     /* 1859460 */   // Label 25106: @1859460
     /* 1859460 */   GIM_Try, /*On fail goto*//*Label 25107*/ GIMT_Encode4(1859549), // Rule ID 13995 //
     /* 1859465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1859476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1859479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1859482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1859485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1859488 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859511 */     // MIs[0] policy
     /* 1859511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859521 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1859524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859542 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859548 */     // GIR_Coverage, 13995,
     /* 1859548 */     GIR_EraseRootFromParent_Done,
     /* 1859549 */   // Label 25107: @1859549
     /* 1859549 */   GIM_Try, /*On fail goto*//*Label 25108*/ GIMT_Encode4(1859638), // Rule ID 13998 //
     /* 1859554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1859571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1859574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859600 */     // MIs[0] policy
     /* 1859600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859610 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1859613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859633 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859636 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859637 */     // GIR_Coverage, 13998,
     /* 1859637 */     GIR_EraseRootFromParent_Done,
     /* 1859638 */   // Label 25108: @1859638
     /* 1859638 */   GIM_Try, /*On fail goto*//*Label 25109*/ GIMT_Encode4(1859727), // Rule ID 13999 //
     /* 1859643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1859654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1859657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1859660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1859663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1859666 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1859673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1859685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859689 */     // MIs[0] policy
     /* 1859689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859699 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1859702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1859720 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859726 */     // GIR_Coverage, 13999,
     /* 1859726 */     GIR_EraseRootFromParent_Done,
     /* 1859727 */   // Label 25109: @1859727
     /* 1859727 */   GIM_Try, /*On fail goto*//*Label 25110*/ GIMT_Encode4(1859816), // Rule ID 14002 //
     /* 1859732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1859749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1859752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859778 */     // MIs[0] policy
     /* 1859778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859788 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1859791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859814 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859815 */     // GIR_Coverage, 14002,
     /* 1859815 */     GIR_EraseRootFromParent_Done,
     /* 1859816 */   // Label 25110: @1859816
     /* 1859816 */   GIM_Try, /*On fail goto*//*Label 25111*/ GIMT_Encode4(1859905), // Rule ID 14003 //
     /* 1859821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1859824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1859832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1859835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1859838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1859841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1859844 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1859847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1859851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1859863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859867 */     // MIs[0] policy
     /* 1859867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859877 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1859877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1859880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859898 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859900 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859904 */     // GIR_Coverage, 14003,
     /* 1859904 */     GIR_EraseRootFromParent_Done,
     /* 1859905 */   // Label 25111: @1859905
     /* 1859905 */   GIM_Try, /*On fail goto*//*Label 25112*/ GIMT_Encode4(1859994), // Rule ID 14006 //
     /* 1859910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1859913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1859918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1859921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1859924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1859927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1859930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1859933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1859936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1859940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1859952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1859956 */     // MIs[0] policy
     /* 1859956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1859959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1859966 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1859966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1859969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1859971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1859973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1859975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1859977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1859979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1859984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1859987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1859989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1859992 */     GIR_RootConstrainSelectedInstOperands,
     /* 1859993 */     // GIR_Coverage, 14006,
     /* 1859993 */     GIR_EraseRootFromParent_Done,
     /* 1859994 */   // Label 25112: @1859994
     /* 1859994 */   GIM_Try, /*On fail goto*//*Label 25113*/ GIMT_Encode4(1860083), // Rule ID 14007 //
     /* 1859999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1860010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1860013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1860016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1860019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860045 */     // MIs[0] policy
     /* 1860045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860055 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1860058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860076 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860082 */     // GIR_Coverage, 14007,
     /* 1860082 */     GIR_EraseRootFromParent_Done,
     /* 1860083 */   // Label 25113: @1860083
     /* 1860083 */   GIM_Try, /*On fail goto*//*Label 25114*/ GIMT_Encode4(1860172), // Rule ID 14010 //
     /* 1860088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1860105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1860108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860134 */     // MIs[0] policy
     /* 1860134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860144 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1860147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860170 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860171 */     // GIR_Coverage, 14010,
     /* 1860171 */     GIR_EraseRootFromParent_Done,
     /* 1860172 */   // Label 25114: @1860172
     /* 1860172 */   GIM_Try, /*On fail goto*//*Label 25115*/ GIMT_Encode4(1860261), // Rule ID 14011 //
     /* 1860177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1860188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1860191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1860194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1860197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1860200 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860223 */     // MIs[0] policy
     /* 1860223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860233 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1860236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1860254 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860256 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860260 */     // GIR_Coverage, 14011,
     /* 1860260 */     GIR_EraseRootFromParent_Done,
     /* 1860261 */   // Label 25115: @1860261
     /* 1860261 */   GIM_Try, /*On fail goto*//*Label 25116*/ GIMT_Encode4(1860350), // Rule ID 14014 //
     /* 1860266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1860269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1860283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1860286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860312 */     // MIs[0] policy
     /* 1860312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860322 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1860325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860348 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860349 */     // GIR_Coverage, 14014,
     /* 1860349 */     GIR_EraseRootFromParent_Done,
     /* 1860350 */   // Label 25116: @1860350
     /* 1860350 */   GIM_Try, /*On fail goto*//*Label 25117*/ GIMT_Encode4(1860439), // Rule ID 14015 //
     /* 1860355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1860358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1860366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1860369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1860372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1860375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1860378 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1860385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1860397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860401 */     // MIs[0] policy
     /* 1860401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2_MASK),
     /* 1860414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860432 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860434 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860438 */     // GIR_Coverage, 14015,
     /* 1860438 */     GIR_EraseRootFromParent_Done,
     /* 1860439 */   // Label 25117: @1860439
     /* 1860439 */   GIM_Try, /*On fail goto*//*Label 25118*/ GIMT_Encode4(1860528), // Rule ID 14018 //
     /* 1860444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1860447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1860461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1860464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860490 */     // MIs[0] policy
     /* 1860490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860500 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1860503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860526 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860527 */     // GIR_Coverage, 14018,
     /* 1860527 */     GIR_EraseRootFromParent_Done,
     /* 1860528 */   // Label 25118: @1860528
     /* 1860528 */   GIM_Try, /*On fail goto*//*Label 25119*/ GIMT_Encode4(1860617), // Rule ID 14019 //
     /* 1860533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1860536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1860544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1860547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1860550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1860553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1860556 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1860563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1860575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860579 */     // MIs[0] policy
     /* 1860579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860589 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4_MASK),
     /* 1860592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860610 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860612 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860616 */     // GIR_Coverage, 14019,
     /* 1860616 */     GIR_EraseRootFromParent_Done,
     /* 1860617 */   // Label 25119: @1860617
     /* 1860617 */   GIM_Try, /*On fail goto*//*Label 25120*/ GIMT_Encode4(1860706), // Rule ID 14022 //
     /* 1860622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1860625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1860639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1860642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860668 */     // MIs[0] policy
     /* 1860668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860678 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1860681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860701 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860704 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860705 */     // GIR_Coverage, 14022,
     /* 1860705 */     GIR_EraseRootFromParent_Done,
     /* 1860706 */   // Label 25120: @1860706
     /* 1860706 */   GIM_Try, /*On fail goto*//*Label 25121*/ GIMT_Encode4(1860795), // Rule ID 14023 //
     /* 1860711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1860714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1860722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1860725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1860728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1860731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1860734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1860741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1860753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860757 */     // MIs[0] policy
     /* 1860757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860767 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8_MASK),
     /* 1860770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1860788 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860790 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860794 */     // GIR_Coverage, 14023,
     /* 1860794 */     GIR_EraseRootFromParent_Done,
     /* 1860795 */   // Label 25121: @1860795
     /* 1860795 */   GIM_Try, /*On fail goto*//*Label 25122*/ GIMT_Encode4(1860884), // Rule ID 14026 //
     /* 1860800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1860811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1860814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1860817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1860820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1860826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860846 */     // MIs[0] policy
     /* 1860846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860856 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1860856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1860859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860879 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860882 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860883 */     // GIR_Coverage, 14026,
     /* 1860883 */     GIR_EraseRootFromParent_Done,
     /* 1860884 */   // Label 25122: @1860884
     /* 1860884 */   GIM_Try, /*On fail goto*//*Label 25123*/ GIMT_Encode4(1860973), // Rule ID 14027 //
     /* 1860889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1860892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1860900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1860903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1860906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1860909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1860912 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1860915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1860919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1860927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1860931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1860935 */     // MIs[0] policy
     /* 1860935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1860938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1860945 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1860945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF8_MASK),
     /* 1860948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1860950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1860952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1860954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1860956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1860958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1860963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1860966 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1860968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1860971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1860972 */     // GIR_Coverage, 14027,
     /* 1860972 */     GIR_EraseRootFromParent_Done,
     /* 1860973 */   // Label 25123: @1860973
     /* 1860973 */   GIM_Try, /*On fail goto*//*Label 25124*/ GIMT_Encode4(1861062), // Rule ID 14030 //
     /* 1860978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1860981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1860986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1860989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1860992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1860995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1860998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861024 */     // MIs[0] policy
     /* 1861024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861034 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1861037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861060 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861061 */     // GIR_Coverage, 14030,
     /* 1861061 */     GIR_EraseRootFromParent_Done,
     /* 1861062 */   // Label 25124: @1861062
     /* 1861062 */   GIM_Try, /*On fail goto*//*Label 25125*/ GIMT_Encode4(1861151), // Rule ID 14031 //
     /* 1861067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1861078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1861081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1861084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861113 */     // MIs[0] policy
     /* 1861113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861123 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1861126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861144 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861150 */     // GIR_Coverage, 14031,
     /* 1861150 */     GIR_EraseRootFromParent_Done,
     /* 1861151 */   // Label 25125: @1861151
     /* 1861151 */   GIM_Try, /*On fail goto*//*Label 25126*/ GIMT_Encode4(1861240), // Rule ID 14034 //
     /* 1861156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1861167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1861170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1861173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861202 */     // MIs[0] policy
     /* 1861202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861212 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861235 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861238 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861239 */     // GIR_Coverage, 14034,
     /* 1861239 */     GIR_EraseRootFromParent_Done,
     /* 1861240 */   // Label 25126: @1861240
     /* 1861240 */   GIM_Try, /*On fail goto*//*Label 25127*/ GIMT_Encode4(1861329), // Rule ID 14035 //
     /* 1861245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1861256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1861259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1861262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1861268 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861291 */     // MIs[0] policy
     /* 1861291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861301 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861322 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861328 */     // GIR_Coverage, 14035,
     /* 1861328 */     GIR_EraseRootFromParent_Done,
     /* 1861329 */   // Label 25127: @1861329
     /* 1861329 */   GIM_Try, /*On fail goto*//*Label 25128*/ GIMT_Encode4(1861418), // Rule ID 14038 //
     /* 1861334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1861351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861380 */     // MIs[0] policy
     /* 1861380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861390 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1861393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861416 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861417 */     // GIR_Coverage, 14038,
     /* 1861417 */     GIR_EraseRootFromParent_Done,
     /* 1861418 */   // Label 25128: @1861418
     /* 1861418 */   GIM_Try, /*On fail goto*//*Label 25129*/ GIMT_Encode4(1861507), // Rule ID 14039 //
     /* 1861423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1861434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1861437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1861440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861446 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861469 */     // MIs[0] policy
     /* 1861469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861479 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF4_MASK),
     /* 1861482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861500 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861502 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861506 */     // GIR_Coverage, 14039,
     /* 1861506 */     GIR_EraseRootFromParent_Done,
     /* 1861507 */   // Label 25129: @1861507
     /* 1861507 */   GIM_Try, /*On fail goto*//*Label 25130*/ GIMT_Encode4(1861596), // Rule ID 14042 //
     /* 1861512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1861529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861558 */     // MIs[0] policy
     /* 1861558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861568 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861594 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861595 */     // GIR_Coverage, 14042,
     /* 1861595 */     GIR_EraseRootFromParent_Done,
     /* 1861596 */   // Label 25130: @1861596
     /* 1861596 */   GIM_Try, /*On fail goto*//*Label 25131*/ GIMT_Encode4(1861685), // Rule ID 14043 //
     /* 1861601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1861612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1861615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1861618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1861624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861647 */     // MIs[0] policy
     /* 1861647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861657 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1861678 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861680 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861684 */     // GIR_Coverage, 14043,
     /* 1861684 */     GIR_EraseRootFromParent_Done,
     /* 1861685 */   // Label 25131: @1861685
     /* 1861685 */   GIM_Try, /*On fail goto*//*Label 25132*/ GIMT_Encode4(1861774), // Rule ID 14046 //
     /* 1861690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1861701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1861704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1861707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861736 */     // MIs[0] policy
     /* 1861736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861746 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861769 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861772 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861773 */     // GIR_Coverage, 14046,
     /* 1861773 */     GIR_EraseRootFromParent_Done,
     /* 1861774 */   // Label 25132: @1861774
     /* 1861774 */   GIM_Try, /*On fail goto*//*Label 25133*/ GIMT_Encode4(1861863), // Rule ID 14047 //
     /* 1861779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1861790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1861793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1861796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1861802 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861825 */     // MIs[0] policy
     /* 1861825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861835 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1861835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_MF2_MASK),
     /* 1861838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1861856 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861858 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861862 */     // GIR_Coverage, 14047,
     /* 1861862 */     GIR_EraseRootFromParent_Done,
     /* 1861863 */   // Label 25133: @1861863
     /* 1861863 */   GIM_Try, /*On fail goto*//*Label 25134*/ GIMT_Encode4(1861952), // Rule ID 14050 //
     /* 1861868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1861871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1861879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1861882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1861885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1861888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1861894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1861914 */     // MIs[0] policy
     /* 1861914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1861917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1861924 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1861924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1861927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1861929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1861931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1861933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1861935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1861937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1861942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1861945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1861947 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1861950 */     GIR_RootConstrainSelectedInstOperands,
     /* 1861951 */     // GIR_Coverage, 14050,
     /* 1861951 */     GIR_EraseRootFromParent_Done,
     /* 1861952 */   // Label 25134: @1861952
     /* 1861952 */   GIM_Try, /*On fail goto*//*Label 25135*/ GIMT_Encode4(1862041), // Rule ID 14051 //
     /* 1861957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1861960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1861965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1861968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1861971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1861974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1861977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1861980 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1861983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1861987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1861995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1861999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862003 */     // MIs[0] policy
     /* 1862003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862013 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11465:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862034 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862036 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862040 */     // GIR_Coverage, 14051,
     /* 1862040 */     GIR_EraseRootFromParent_Done,
     /* 1862041 */   // Label 25135: @1862041
     /* 1862041 */   GIM_Try, /*On fail goto*//*Label 25136*/ GIMT_Encode4(1862130), // Rule ID 14054 //
     /* 1862046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862092 */     // MIs[0] policy
     /* 1862092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862102 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862128 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862129 */     // GIR_Coverage, 14054,
     /* 1862129 */     GIR_EraseRootFromParent_Done,
     /* 1862130 */   // Label 25136: @1862130
     /* 1862130 */   GIM_Try, /*On fail goto*//*Label 25137*/ GIMT_Encode4(1862219), // Rule ID 14055 //
     /* 1862135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1862146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1862149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1862152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1862155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1862158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862181 */     // MIs[0] policy
     /* 1862181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862191 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11465:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1862212 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862214 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862218 */     // GIR_Coverage, 14055,
     /* 1862218 */     GIR_EraseRootFromParent_Done,
     /* 1862219 */   // Label 25137: @1862219
     /* 1862219 */   GIM_Try, /*On fail goto*//*Label 25138*/ GIMT_Encode4(1862308), // Rule ID 14058 //
     /* 1862224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862270 */     // MIs[0] policy
     /* 1862270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862280 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862303 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862306 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862307 */     // GIR_Coverage, 14058,
     /* 1862307 */     GIR_EraseRootFromParent_Done,
     /* 1862308 */   // Label 25138: @1862308
     /* 1862308 */   GIM_Try, /*On fail goto*//*Label 25139*/ GIMT_Encode4(1862397), // Rule ID 14059 //
     /* 1862313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1862324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1862327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1862330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1862333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1862336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862359 */     // MIs[0] policy
     /* 1862359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862369 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11465:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1862390 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862392 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862396 */     // GIR_Coverage, 14059,
     /* 1862396 */     GIR_EraseRootFromParent_Done,
     /* 1862397 */   // Label 25139: @1862397
     /* 1862397 */   GIM_Try, /*On fail goto*//*Label 25140*/ GIMT_Encode4(1862486), // Rule ID 14062 //
     /* 1862402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1862405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862448 */     // MIs[0] policy
     /* 1862448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862458 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1862479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862484 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862485 */     // GIR_Coverage, 14062,
     /* 1862485 */     GIR_EraseRootFromParent_Done,
     /* 1862486 */   // Label 25140: @1862486
     /* 1862486 */   GIM_Try, /*On fail goto*//*Label 25141*/ GIMT_Encode4(1862575), // Rule ID 14063 //
     /* 1862491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1862494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1862502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1862505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1862508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1862511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1862514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1862521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1862529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862537 */     // MIs[0] policy
     /* 1862537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862547 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11465:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M1_MASK),
     /* 1862550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1862568 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862574 */     // GIR_Coverage, 14063,
     /* 1862574 */     GIR_EraseRootFromParent_Done,
     /* 1862575 */   // Label 25141: @1862575
     /* 1862575 */   GIM_Try, /*On fail goto*//*Label 25142*/ GIMT_Encode4(1862664), // Rule ID 14066 //
     /* 1862580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1862591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1862594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1862597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862626 */     // MIs[0] policy
     /* 1862626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862636 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1862639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862659 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862662 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862663 */     // GIR_Coverage, 14066,
     /* 1862663 */     GIR_EraseRootFromParent_Done,
     /* 1862664 */   // Label 25142: @1862664
     /* 1862664 */   GIM_Try, /*On fail goto*//*Label 25143*/ GIMT_Encode4(1862753), // Rule ID 14067 //
     /* 1862669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1862680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1862683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1862686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1862689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1862692 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1862699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1862707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862715 */     // MIs[0] policy
     /* 1862715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862725 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1862728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862746 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862748 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862752 */     // GIR_Coverage, 14067,
     /* 1862752 */     GIR_EraseRootFromParent_Done,
     /* 1862753 */   // Label 25143: @1862753
     /* 1862753 */   GIM_Try, /*On fail goto*//*Label 25144*/ GIMT_Encode4(1862842), // Rule ID 14070 //
     /* 1862758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1862769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1862772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1862775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862804 */     // MIs[0] policy
     /* 1862804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862814 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1862817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862837 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862840 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862841 */     // GIR_Coverage, 14070,
     /* 1862841 */     GIR_EraseRootFromParent_Done,
     /* 1862842 */   // Label 25144: @1862842
     /* 1862842 */   GIM_Try, /*On fail goto*//*Label 25145*/ GIMT_Encode4(1862931), // Rule ID 14071 //
     /* 1862847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1862850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1862858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1862861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1862864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1862867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1862870 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1862873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1862877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1862885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862893 */     // MIs[0] policy
     /* 1862893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862903 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1862903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1862906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1862912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1862914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1862916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1862921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1862924 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1862926 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1862929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1862930 */     // GIR_Coverage, 14071,
     /* 1862930 */     GIR_EraseRootFromParent_Done,
     /* 1862931 */   // Label 25145: @1862931
     /* 1862931 */   GIM_Try, /*On fail goto*//*Label 25146*/ GIMT_Encode4(1863020), // Rule ID 14074 //
     /* 1862936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1862939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1862944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1862947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1862950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1862953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1862956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1862959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1862962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1862966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1862974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1862978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1862982 */     // MIs[0] policy
     /* 1862982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1862985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1862992 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1862992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1862995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1862997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1862999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863018 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863019 */     // GIR_Coverage, 14074,
     /* 1863019 */     GIR_EraseRootFromParent_Done,
     /* 1863020 */   // Label 25146: @1863020
     /* 1863020 */   GIM_Try, /*On fail goto*//*Label 25147*/ GIMT_Encode4(1863109), // Rule ID 14075 //
     /* 1863025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1863036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1863039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1863042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1863048 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863071 */     // MIs[0] policy
     /* 1863071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863081 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1863084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863086 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1863102 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863108 */     // GIR_Coverage, 14075,
     /* 1863108 */     GIR_EraseRootFromParent_Done,
     /* 1863109 */   // Label 25147: @1863109
     /* 1863109 */   GIM_Try, /*On fail goto*//*Label 25148*/ GIMT_Encode4(1863198), // Rule ID 14078 //
     /* 1863114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1863125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1863128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1863131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1863134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863160 */     // MIs[0] policy
     /* 1863160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863170 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1863173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863196 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863197 */     // GIR_Coverage, 14078,
     /* 1863197 */     GIR_EraseRootFromParent_Done,
     /* 1863198 */   // Label 25148: @1863198
     /* 1863198 */   GIM_Try, /*On fail goto*//*Label 25149*/ GIMT_Encode4(1863287), // Rule ID 14079 //
     /* 1863203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1863214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1863217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1863220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863249 */     // MIs[0] policy
     /* 1863249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1863262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863264 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863280 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863286 */     // GIR_Coverage, 14079,
     /* 1863286 */     GIR_EraseRootFromParent_Done,
     /* 1863287 */   // Label 25149: @1863287
     /* 1863287 */   GIM_Try, /*On fail goto*//*Label 25150*/ GIMT_Encode4(1863376), // Rule ID 14082 //
     /* 1863292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1863312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863338 */     // MIs[0] policy
     /* 1863338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863348 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1863351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863374 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863375 */     // GIR_Coverage, 14082,
     /* 1863375 */     GIR_EraseRootFromParent_Done,
     /* 1863376 */   // Label 25150: @1863376
     /* 1863376 */   GIM_Try, /*On fail goto*//*Label 25151*/ GIMT_Encode4(1863465), // Rule ID 14083 //
     /* 1863381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1863392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1863395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1863398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1863404 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863427 */     // MIs[0] policy
     /* 1863427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863437 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1863440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863458 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863464 */     // GIR_Coverage, 14083,
     /* 1863464 */     GIR_EraseRootFromParent_Done,
     /* 1863465 */   // Label 25151: @1863465
     /* 1863465 */   GIM_Try, /*On fail goto*//*Label 25152*/ GIMT_Encode4(1863554), // Rule ID 14086 //
     /* 1863470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1863487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1863490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863516 */     // MIs[0] policy
     /* 1863516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863526 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1863529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863552 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863553 */     // GIR_Coverage, 14086,
     /* 1863553 */     GIR_EraseRootFromParent_Done,
     /* 1863554 */   // Label 25152: @1863554
     /* 1863554 */   GIM_Try, /*On fail goto*//*Label 25153*/ GIMT_Encode4(1863643), // Rule ID 14087 //
     /* 1863559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1863570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1863573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1863576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1863582 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1863589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1863597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863605 */     // MIs[0] policy
     /* 1863605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863615 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1863618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1863636 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863638 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863642 */     // GIR_Coverage, 14087,
     /* 1863642 */     GIR_EraseRootFromParent_Done,
     /* 1863643 */   // Label 25153: @1863643
     /* 1863643 */   GIM_Try, /*On fail goto*//*Label 25154*/ GIMT_Encode4(1863732), // Rule ID 14090 //
     /* 1863648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1863665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1863668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863694 */     // MIs[0] policy
     /* 1863694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1863707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863727 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863730 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863731 */     // GIR_Coverage, 14090,
     /* 1863731 */     GIR_EraseRootFromParent_Done,
     /* 1863732 */   // Label 25154: @1863732
     /* 1863732 */   GIM_Try, /*On fail goto*//*Label 25155*/ GIMT_Encode4(1863821), // Rule ID 14091 //
     /* 1863737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1863748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1863751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1863754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1863760 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1863767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1863775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863783 */     // MIs[0] policy
     /* 1863783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863793 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1863796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863814 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863816 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863820 */     // GIR_Coverage, 14091,
     /* 1863820 */     GIR_EraseRootFromParent_Done,
     /* 1863821 */   // Label 25155: @1863821
     /* 1863821 */   GIM_Try, /*On fail goto*//*Label 25156*/ GIMT_Encode4(1863910), // Rule ID 14094 //
     /* 1863826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1863829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1863843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1863846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1863852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863872 */     // MIs[0] policy
     /* 1863872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863882 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1863882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1863885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863905 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863908 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863909 */     // GIR_Coverage, 14094,
     /* 1863909 */     GIR_EraseRootFromParent_Done,
     /* 1863910 */   // Label 25156: @1863910
     /* 1863910 */   GIM_Try, /*On fail goto*//*Label 25157*/ GIMT_Encode4(1863999), // Rule ID 14095 //
     /* 1863915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1863918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1863923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1863926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1863929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1863932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1863935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1863938 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1863941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1863945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1863953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1863957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1863961 */     // MIs[0] policy
     /* 1863961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1863964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1863971 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1863971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1863974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1863976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1863978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1863980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1863982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1863984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1863989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1863992 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1863994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1863997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1863998 */     // GIR_Coverage, 14095,
     /* 1863998 */     GIR_EraseRootFromParent_Done,
     /* 1863999 */   // Label 25157: @1863999
     /* 1863999 */   GIM_Try, /*On fail goto*//*Label 25158*/ GIMT_Encode4(1864088), // Rule ID 14098 //
     /* 1864004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1864015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1864018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1864021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1864024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1864027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864050 */     // MIs[0] policy
     /* 1864050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864060 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1864063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864086 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864087 */     // GIR_Coverage, 14098,
     /* 1864087 */     GIR_EraseRootFromParent_Done,
     /* 1864088 */   // Label 25158: @1864088
     /* 1864088 */   GIM_Try, /*On fail goto*//*Label 25159*/ GIMT_Encode4(1864177), // Rule ID 14099 //
     /* 1864093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1864104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1864107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1864110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1864113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1864116 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864139 */     // MIs[0] policy
     /* 1864139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864149 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1864152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1864170 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864176 */     // GIR_Coverage, 14099,
     /* 1864176 */     GIR_EraseRootFromParent_Done,
     /* 1864177 */   // Label 25159: @1864177
     /* 1864177 */   GIM_Try, /*On fail goto*//*Label 25160*/ GIMT_Encode4(1864266), // Rule ID 14102 //
     /* 1864182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1864202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864228 */     // MIs[0] policy
     /* 1864228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1864241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864264 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864265 */     // GIR_Coverage, 14102,
     /* 1864265 */     GIR_EraseRootFromParent_Done,
     /* 1864266 */   // Label 25160: @1864266
     /* 1864266 */   GIM_Try, /*On fail goto*//*Label 25161*/ GIMT_Encode4(1864355), // Rule ID 14103 //
     /* 1864271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1864274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1864282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1864285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1864288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1864291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1864301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1864309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864317 */     // MIs[0] policy
     /* 1864317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864327 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11465:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M2_MASK),
     /* 1864330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864348 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864354 */     // GIR_Coverage, 14103,
     /* 1864354 */     GIR_EraseRootFromParent_Done,
     /* 1864355 */   // Label 25161: @1864355
     /* 1864355 */   GIM_Try, /*On fail goto*//*Label 25162*/ GIMT_Encode4(1864444), // Rule ID 14106 //
     /* 1864360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1864380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864406 */     // MIs[0] policy
     /* 1864406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864416 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1864419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864442 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864443 */     // GIR_Coverage, 14106,
     /* 1864443 */     GIR_EraseRootFromParent_Done,
     /* 1864444 */   // Label 25162: @1864444
     /* 1864444 */   GIM_Try, /*On fail goto*//*Label 25163*/ GIMT_Encode4(1864533), // Rule ID 14107 //
     /* 1864449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1864452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1864460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1864463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1864466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1864469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1864472 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1864479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1864487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864495 */     // MIs[0] policy
     /* 1864495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864505 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11465:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M4_MASK),
     /* 1864508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864526 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864528 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864532 */     // GIR_Coverage, 14107,
     /* 1864532 */     GIR_EraseRootFromParent_Done,
     /* 1864533 */   // Label 25163: @1864533
     /* 1864533 */   GIM_Try, /*On fail goto*//*Label 25164*/ GIMT_Encode4(1864622), // Rule ID 14110 //
     /* 1864538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1864541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1864555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1864558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864584 */     // MIs[0] policy
     /* 1864584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864594 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1864597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864620 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864621 */     // GIR_Coverage, 14110,
     /* 1864621 */     GIR_EraseRootFromParent_Done,
     /* 1864622 */   // Label 25164: @1864622
     /* 1864622 */   GIM_Try, /*On fail goto*//*Label 25165*/ GIMT_Encode4(1864711), // Rule ID 14111 //
     /* 1864627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1864630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsaddu_mask),
     /* 1864635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1864638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1864641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1864644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1864647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1864650 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1864657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1864665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1864669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864673 */     // MIs[0] policy
     /* 1864673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864683 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11465:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VX_M8_MASK),
     /* 1864686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1864704 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864706 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864710 */     // GIR_Coverage, 14111,
     /* 1864710 */     GIR_EraseRootFromParent_Done,
     /* 1864711 */   // Label 25165: @1864711
     /* 1864711 */   GIM_Try, /*On fail goto*//*Label 25166*/ GIMT_Encode4(1864800), // Rule ID 14202 //
     /* 1864716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1864724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1864727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1864730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864762 */     // MIs[0] policy
     /* 1864762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864772 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1864775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864798 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864799 */     // GIR_Coverage, 14202,
     /* 1864799 */     GIR_EraseRootFromParent_Done,
     /* 1864800 */   // Label 25166: @1864800
     /* 1864800 */   GIM_Try, /*On fail goto*//*Label 25167*/ GIMT_Encode4(1864889), // Rule ID 14203 //
     /* 1864805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1864813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1864816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1864819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1864822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1864825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1864828 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1864831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864851 */     // MIs[0] policy
     /* 1864851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864861 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1864861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8_MASK),
     /* 1864864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864882 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864888 */     // GIR_Coverage, 14203,
     /* 1864888 */     GIR_EraseRootFromParent_Done,
     /* 1864889 */   // Label 25167: @1864889
     /* 1864889 */   GIM_Try, /*On fail goto*//*Label 25168*/ GIMT_Encode4(1864978), // Rule ID 14206 //
     /* 1864894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1864897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1864902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1864911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1864914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1864917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1864920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1864924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1864936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1864940 */     // MIs[0] policy
     /* 1864940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1864943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1864950 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1864950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1864953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1864955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1864957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1864959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1864961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1864963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1864968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1864971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1864973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1864976 */     GIR_RootConstrainSelectedInstOperands,
     /* 1864977 */     // GIR_Coverage, 14206,
     /* 1864977 */     GIR_EraseRootFromParent_Done,
     /* 1864978 */   // Label 25168: @1864978
     /* 1864978 */   GIM_Try, /*On fail goto*//*Label 25169*/ GIMT_Encode4(1865067), // Rule ID 14207 //
     /* 1864983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1864986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1864991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1864994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1864997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1865000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1865003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865006 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865029 */     // MIs[0] policy
     /* 1865029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865039 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1865042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865060 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865062 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865066 */     // GIR_Coverage, 14207,
     /* 1865066 */     GIR_EraseRootFromParent_Done,
     /* 1865067 */   // Label 25169: @1865067
     /* 1865067 */   GIM_Try, /*On fail goto*//*Label 25170*/ GIMT_Encode4(1865156), // Rule ID 14210 //
     /* 1865072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1865083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1865086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1865089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1865092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865118 */     // MIs[0] policy
     /* 1865118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865128 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865154 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865155 */     // GIR_Coverage, 14210,
     /* 1865155 */     GIR_EraseRootFromParent_Done,
     /* 1865156 */   // Label 25170: @1865156
     /* 1865156 */   GIM_Try, /*On fail goto*//*Label 25171*/ GIMT_Encode4(1865245), // Rule ID 14211 //
     /* 1865161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1865172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1865175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1865178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1865181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865207 */     // MIs[0] policy
     /* 1865207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865217 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865238 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865244 */     // GIR_Coverage, 14211,
     /* 1865244 */     GIR_EraseRootFromParent_Done,
     /* 1865245 */   // Label 25171: @1865245
     /* 1865245 */   GIM_Try, /*On fail goto*//*Label 25172*/ GIMT_Encode4(1865334), // Rule ID 14214 //
     /* 1865250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1865261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1865264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865296 */     // MIs[0] policy
     /* 1865296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865306 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1865309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865332 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865333 */     // GIR_Coverage, 14214,
     /* 1865333 */     GIR_EraseRootFromParent_Done,
     /* 1865334 */   // Label 25172: @1865334
     /* 1865334 */   GIM_Try, /*On fail goto*//*Label 25173*/ GIMT_Encode4(1865423), // Rule ID 14215 //
     /* 1865339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1865350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1865353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1865356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1865359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865385 */     // MIs[0] policy
     /* 1865385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865395 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4_MASK),
     /* 1865398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865416 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865422 */     // GIR_Coverage, 14215,
     /* 1865422 */     GIR_EraseRootFromParent_Done,
     /* 1865423 */   // Label 25173: @1865423
     /* 1865423 */   GIM_Try, /*On fail goto*//*Label 25174*/ GIMT_Encode4(1865512), // Rule ID 14218 //
     /* 1865428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1865439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1865442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1865448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865474 */     // MIs[0] policy
     /* 1865474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865484 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865510 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865511 */     // GIR_Coverage, 14218,
     /* 1865511 */     GIR_EraseRootFromParent_Done,
     /* 1865512 */   // Label 25174: @1865512
     /* 1865512 */   GIM_Try, /*On fail goto*//*Label 25175*/ GIMT_Encode4(1865601), // Rule ID 14219 //
     /* 1865517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1865528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1865531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1865534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1865537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1865540 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865563 */     // MIs[0] policy
     /* 1865563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865573 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1865594 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865596 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865600 */     // GIR_Coverage, 14219,
     /* 1865600 */     GIR_EraseRootFromParent_Done,
     /* 1865601 */   // Label 25175: @1865601
     /* 1865601 */   GIM_Try, /*On fail goto*//*Label 25176*/ GIMT_Encode4(1865690), // Rule ID 14222 //
     /* 1865606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1865623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1865626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865652 */     // MIs[0] policy
     /* 1865652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865662 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865688 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865689 */     // GIR_Coverage, 14222,
     /* 1865689 */     GIR_EraseRootFromParent_Done,
     /* 1865690 */   // Label 25176: @1865690
     /* 1865690 */   GIM_Try, /*On fail goto*//*Label 25177*/ GIMT_Encode4(1865779), // Rule ID 14223 //
     /* 1865695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1865706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1865709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1865712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1865715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1865718 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865741 */     // MIs[0] policy
     /* 1865741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865751 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2_MASK),
     /* 1865754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1865772 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865778 */     // GIR_Coverage, 14223,
     /* 1865778 */     GIR_EraseRootFromParent_Done,
     /* 1865779 */   // Label 25177: @1865779
     /* 1865779 */   GIM_Try, /*On fail goto*//*Label 25178*/ GIMT_Encode4(1865868), // Rule ID 14226 //
     /* 1865784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865830 */     // MIs[0] policy
     /* 1865830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865840 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1865840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1865843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865863 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865866 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865867 */     // GIR_Coverage, 14226,
     /* 1865867 */     GIR_EraseRootFromParent_Done,
     /* 1865868 */   // Label 25178: @1865868
     /* 1865868 */   GIM_Try, /*On fail goto*//*Label 25179*/ GIMT_Encode4(1865957), // Rule ID 14227 //
     /* 1865873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1865876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1865884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1865887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1865890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1865893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1865896 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1865899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1865919 */     // MIs[0] policy
     /* 1865919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1865922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1865929 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1865929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1865932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1865934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1865936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1865938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1865940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1865942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1865947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1865950 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1865952 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1865955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1865956 */     // GIR_Coverage, 14227,
     /* 1865956 */     GIR_EraseRootFromParent_Done,
     /* 1865957 */   // Label 25179: @1865957
     /* 1865957 */   GIM_Try, /*On fail goto*//*Label 25180*/ GIMT_Encode4(1866046), // Rule ID 14230 //
     /* 1865962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1865965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1865970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1865973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1865976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1865979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1865982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1865985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1865988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1865992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1865996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866008 */     // MIs[0] policy
     /* 1866008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866018 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866044 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866045 */     // GIR_Coverage, 14230,
     /* 1866045 */     GIR_EraseRootFromParent_Done,
     /* 1866046 */   // Label 25180: @1866046
     /* 1866046 */   GIM_Try, /*On fail goto*//*Label 25181*/ GIMT_Encode4(1866135), // Rule ID 14231 //
     /* 1866051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1866062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1866065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1866068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1866071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1866074 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866097 */     // MIs[0] policy
     /* 1866097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866107 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1866128 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866134 */     // GIR_Coverage, 14231,
     /* 1866134 */     GIR_EraseRootFromParent_Done,
     /* 1866135 */   // Label 25181: @1866135
     /* 1866135 */   GIM_Try, /*On fail goto*//*Label 25182*/ GIMT_Encode4(1866224), // Rule ID 14234 //
     /* 1866140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1866151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1866154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866186 */     // MIs[0] policy
     /* 1866186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866196 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866222 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866223 */     // GIR_Coverage, 14234,
     /* 1866223 */     GIR_EraseRootFromParent_Done,
     /* 1866224 */   // Label 25182: @1866224
     /* 1866224 */   GIM_Try, /*On fail goto*//*Label 25183*/ GIMT_Encode4(1866313), // Rule ID 14235 //
     /* 1866229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1866240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1866243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1866246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1866249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1866252 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866275 */     // MIs[0] policy
     /* 1866275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866285 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1866306 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866308 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866312 */     // GIR_Coverage, 14235,
     /* 1866312 */     GIR_EraseRootFromParent_Done,
     /* 1866313 */   // Label 25183: @1866313
     /* 1866313 */   GIM_Try, /*On fail goto*//*Label 25184*/ GIMT_Encode4(1866402), // Rule ID 14238 //
     /* 1866318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1866321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1866335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1866338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866364 */     // MIs[0] policy
     /* 1866364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866374 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866397 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866400 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866401 */     // GIR_Coverage, 14238,
     /* 1866401 */     GIR_EraseRootFromParent_Done,
     /* 1866402 */   // Label 25184: @1866402
     /* 1866402 */   GIM_Try, /*On fail goto*//*Label 25185*/ GIMT_Encode4(1866491), // Rule ID 14239 //
     /* 1866407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1866410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1866418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1866421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1866424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1866427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1866430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1866437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1866449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866453 */     // MIs[0] policy
     /* 1866453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866463 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1_MASK),
     /* 1866466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1866484 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866486 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866490 */     // GIR_Coverage, 14239,
     /* 1866490 */     GIR_EraseRootFromParent_Done,
     /* 1866491 */   // Label 25185: @1866491
     /* 1866491 */   GIM_Try, /*On fail goto*//*Label 25186*/ GIMT_Encode4(1866580), // Rule ID 14242 //
     /* 1866496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1866507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1866510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1866513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1866516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866542 */     // MIs[0] policy
     /* 1866542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866552 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1866555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866578 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866579 */     // GIR_Coverage, 14242,
     /* 1866579 */     GIR_EraseRootFromParent_Done,
     /* 1866580 */   // Label 25186: @1866580
     /* 1866580 */   GIM_Try, /*On fail goto*//*Label 25187*/ GIMT_Encode4(1866669), // Rule ID 14243 //
     /* 1866585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1866596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1866599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1866602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1866605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1866608 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1866615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1866627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866631 */     // MIs[0] policy
     /* 1866631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866641 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1866644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866662 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866664 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866668 */     // GIR_Coverage, 14243,
     /* 1866668 */     GIR_EraseRootFromParent_Done,
     /* 1866669 */   // Label 25187: @1866669
     /* 1866669 */   GIM_Try, /*On fail goto*//*Label 25188*/ GIMT_Encode4(1866758), // Rule ID 14246 //
     /* 1866674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1866685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1866688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1866691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1866694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866720 */     // MIs[0] policy
     /* 1866720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866730 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1866733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866753 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866756 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866757 */     // GIR_Coverage, 14246,
     /* 1866757 */     GIR_EraseRootFromParent_Done,
     /* 1866758 */   // Label 25188: @1866758
     /* 1866758 */   GIM_Try, /*On fail goto*//*Label 25189*/ GIMT_Encode4(1866847), // Rule ID 14247 //
     /* 1866763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1866774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1866777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1866780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1866783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1866786 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1866793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1866805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866809 */     // MIs[0] policy
     /* 1866809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866819 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1866822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866840 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866846 */     // GIR_Coverage, 14247,
     /* 1866846 */     GIR_EraseRootFromParent_Done,
     /* 1866847 */   // Label 25189: @1866847
     /* 1866847 */   GIM_Try, /*On fail goto*//*Label 25190*/ GIMT_Encode4(1866936), // Rule ID 14250 //
     /* 1866852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1866855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1866878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866898 */     // MIs[0] policy
     /* 1866898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866908 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1866908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1866911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1866913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1866915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1866917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1866919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1866921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1866926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1866929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1866931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1866934 */     GIR_RootConstrainSelectedInstOperands,
     /* 1866935 */     // GIR_Coverage, 14250,
     /* 1866935 */     GIR_EraseRootFromParent_Done,
     /* 1866936 */   // Label 25190: @1866936
     /* 1866936 */   GIM_Try, /*On fail goto*//*Label 25191*/ GIMT_Encode4(1867025), // Rule ID 14251 //
     /* 1866941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1866944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1866949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1866952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1866955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1866958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1866961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1866964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1866967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1866971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1866983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1866987 */     // MIs[0] policy
     /* 1866987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1866990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1866997 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1866997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1867000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1867018 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867024 */     // GIR_Coverage, 14251,
     /* 1867024 */     GIR_EraseRootFromParent_Done,
     /* 1867025 */   // Label 25191: @1867025
     /* 1867025 */   GIM_Try, /*On fail goto*//*Label 25192*/ GIMT_Encode4(1867114), // Rule ID 14254 //
     /* 1867030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1867047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1867050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867076 */     // MIs[0] policy
     /* 1867076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867086 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1867089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867109 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867112 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867113 */     // GIR_Coverage, 14254,
     /* 1867113 */     GIR_EraseRootFromParent_Done,
     /* 1867114 */   // Label 25192: @1867114
     /* 1867114 */   GIM_Try, /*On fail goto*//*Label 25193*/ GIMT_Encode4(1867203), // Rule ID 14255 //
     /* 1867119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1867130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1867133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1867136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1867139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867142 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867165 */     // MIs[0] policy
     /* 1867165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1867178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867196 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867198 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867202 */     // GIR_Coverage, 14255,
     /* 1867202 */     GIR_EraseRootFromParent_Done,
     /* 1867203 */   // Label 25193: @1867203
     /* 1867203 */   GIM_Try, /*On fail goto*//*Label 25194*/ GIMT_Encode4(1867292), // Rule ID 14258 //
     /* 1867208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1867225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1867228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867254 */     // MIs[0] policy
     /* 1867254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867264 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1867267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867290 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867291 */     // GIR_Coverage, 14258,
     /* 1867291 */     GIR_EraseRootFromParent_Done,
     /* 1867292 */   // Label 25194: @1867292
     /* 1867292 */   GIM_Try, /*On fail goto*//*Label 25195*/ GIMT_Encode4(1867381), // Rule ID 14259 //
     /* 1867297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1867308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1867311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1867314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1867317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867320 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867343 */     // MIs[0] policy
     /* 1867343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867353 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1867356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867358 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867374 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867376 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867380 */     // GIR_Coverage, 14259,
     /* 1867380 */     GIR_EraseRootFromParent_Done,
     /* 1867381 */   // Label 25195: @1867381
     /* 1867381 */   GIM_Try, /*On fail goto*//*Label 25196*/ GIMT_Encode4(1867470), // Rule ID 14262 //
     /* 1867386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1867397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1867400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1867403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1867406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867432 */     // MIs[0] policy
     /* 1867432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867442 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1867445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867468 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867469 */     // GIR_Coverage, 14262,
     /* 1867469 */     GIR_EraseRootFromParent_Done,
     /* 1867470 */   // Label 25196: @1867470
     /* 1867470 */   GIM_Try, /*On fail goto*//*Label 25197*/ GIMT_Encode4(1867559), // Rule ID 14263 //
     /* 1867475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1867486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1867489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1867492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1867495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1867498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867521 */     // MIs[0] policy
     /* 1867521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867531 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1867534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867536 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1867552 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867554 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867558 */     // GIR_Coverage, 14263,
     /* 1867558 */     GIR_EraseRootFromParent_Done,
     /* 1867559 */   // Label 25197: @1867559
     /* 1867559 */   GIM_Try, /*On fail goto*//*Label 25198*/ GIMT_Encode4(1867648), // Rule ID 14266 //
     /* 1867564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1867575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1867578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1867581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1867584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867610 */     // MIs[0] policy
     /* 1867610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867620 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1867623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867646 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867647 */     // GIR_Coverage, 14266,
     /* 1867647 */     GIR_EraseRootFromParent_Done,
     /* 1867648 */   // Label 25198: @1867648
     /* 1867648 */   GIM_Try, /*On fail goto*//*Label 25199*/ GIMT_Encode4(1867737), // Rule ID 14267 //
     /* 1867653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1867664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1867667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1867670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1867673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1867676 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1867683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1867695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867699 */     // MIs[0] policy
     /* 1867699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867709 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1867712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867730 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867732 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867736 */     // GIR_Coverage, 14267,
     /* 1867736 */     GIR_EraseRootFromParent_Done,
     /* 1867737 */   // Label 25199: @1867737
     /* 1867737 */   GIM_Try, /*On fail goto*//*Label 25200*/ GIMT_Encode4(1867826), // Rule ID 14270 //
     /* 1867742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1867753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1867756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1867759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867788 */     // MIs[0] policy
     /* 1867788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867798 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1867801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867824 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867825 */     // GIR_Coverage, 14270,
     /* 1867825 */     GIR_EraseRootFromParent_Done,
     /* 1867826 */   // Label 25200: @1867826
     /* 1867826 */   GIM_Try, /*On fail goto*//*Label 25201*/ GIMT_Encode4(1867915), // Rule ID 14271 //
     /* 1867831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1867834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1867842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1867845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1867848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1867851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1867854 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1867857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1867861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1867873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867877 */     // MIs[0] policy
     /* 1867877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867887 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1867887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1867890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867908 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1867913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1867914 */     // GIR_Coverage, 14271,
     /* 1867914 */     GIR_EraseRootFromParent_Done,
     /* 1867915 */   // Label 25201: @1867915
     /* 1867915 */   GIM_Try, /*On fail goto*//*Label 25202*/ GIMT_Encode4(1868004), // Rule ID 14274 //
     /* 1867920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1867923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1867928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1867931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1867934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1867937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1867940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1867943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1867946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1867950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1867962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1867966 */     // MIs[0] policy
     /* 1867966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1867969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1867976 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1867976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1867979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1867981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1867983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1867985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1867987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1867989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1867994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1867997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1867999 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868002 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868003 */     // GIR_Coverage, 14274,
     /* 1868003 */     GIR_EraseRootFromParent_Done,
     /* 1868004 */   // Label 25202: @1868004
     /* 1868004 */   GIM_Try, /*On fail goto*//*Label 25203*/ GIMT_Encode4(1868093), // Rule ID 14275 //
     /* 1868009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1868020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1868023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1868026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1868029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1868032 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868055 */     // MIs[0] policy
     /* 1868055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868065 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1868068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1868086 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868088 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868092 */     // GIR_Coverage, 14275,
     /* 1868092 */     GIR_EraseRootFromParent_Done,
     /* 1868093 */   // Label 25203: @1868093
     /* 1868093 */   GIM_Try, /*On fail goto*//*Label 25204*/ GIMT_Encode4(1868182), // Rule ID 14278 //
     /* 1868098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1868109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1868112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1868115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1868118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868144 */     // MIs[0] policy
     /* 1868144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1868157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868180 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868181 */     // GIR_Coverage, 14278,
     /* 1868181 */     GIR_EraseRootFromParent_Done,
     /* 1868182 */   // Label 25204: @1868182
     /* 1868182 */   GIM_Try, /*On fail goto*//*Label 25205*/ GIMT_Encode4(1868271), // Rule ID 14279 //
     /* 1868187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1868198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1868201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1868204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1868207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868210 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1868217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1868229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868233 */     // MIs[0] policy
     /* 1868233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2_MASK),
     /* 1868246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868264 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868266 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868270 */     // GIR_Coverage, 14279,
     /* 1868270 */     GIR_EraseRootFromParent_Done,
     /* 1868271 */   // Label 25205: @1868271
     /* 1868271 */   GIM_Try, /*On fail goto*//*Label 25206*/ GIMT_Encode4(1868360), // Rule ID 14282 //
     /* 1868276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1868287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1868290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1868293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1868296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868322 */     // MIs[0] policy
     /* 1868322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868332 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1868335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868358 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868359 */     // GIR_Coverage, 14282,
     /* 1868359 */     GIR_EraseRootFromParent_Done,
     /* 1868360 */   // Label 25206: @1868360
     /* 1868360 */   GIM_Try, /*On fail goto*//*Label 25207*/ GIMT_Encode4(1868449), // Rule ID 14283 //
     /* 1868365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1868376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1868379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1868382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1868385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1868388 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1868395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1868407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868411 */     // MIs[0] policy
     /* 1868411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868421 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4_MASK),
     /* 1868424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868442 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868448 */     // GIR_Coverage, 14283,
     /* 1868448 */     GIR_EraseRootFromParent_Done,
     /* 1868449 */   // Label 25207: @1868449
     /* 1868449 */   GIM_Try, /*On fail goto*//*Label 25208*/ GIMT_Encode4(1868538), // Rule ID 14286 //
     /* 1868454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1868457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1868465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1868468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1868471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1868474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868500 */     // MIs[0] policy
     /* 1868500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868510 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1868513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868536 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868537 */     // GIR_Coverage, 14286,
     /* 1868537 */     GIR_EraseRootFromParent_Done,
     /* 1868538 */   // Label 25208: @1868538
     /* 1868538 */   GIM_Try, /*On fail goto*//*Label 25209*/ GIMT_Encode4(1868627), // Rule ID 14287 //
     /* 1868543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1868546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1868554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1868557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1868560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1868563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1868566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1868573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1868585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868589 */     // MIs[0] policy
     /* 1868589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868599 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8_MASK),
     /* 1868602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1868620 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868622 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868626 */     // GIR_Coverage, 14287,
     /* 1868626 */     GIR_EraseRootFromParent_Done,
     /* 1868627 */   // Label 25209: @1868627
     /* 1868627 */   GIM_Try, /*On fail goto*//*Label 25210*/ GIMT_Encode4(1868716), // Rule ID 14290 //
     /* 1868632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1868643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1868646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1868649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868678 */     // MIs[0] policy
     /* 1868678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868688 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1868691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868714 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868715 */     // GIR_Coverage, 14290,
     /* 1868715 */     GIR_EraseRootFromParent_Done,
     /* 1868716 */   // Label 25210: @1868716
     /* 1868716 */   GIM_Try, /*On fail goto*//*Label 25211*/ GIMT_Encode4(1868805), // Rule ID 14291 //
     /* 1868721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1868732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1868735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1868738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1868744 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868767 */     // MIs[0] policy
     /* 1868767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868777 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF8_MASK),
     /* 1868780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868798 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868800 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868804 */     // GIR_Coverage, 14291,
     /* 1868804 */     GIR_EraseRootFromParent_Done,
     /* 1868805 */   // Label 25211: @1868805
     /* 1868805 */   GIM_Try, /*On fail goto*//*Label 25212*/ GIMT_Encode4(1868894), // Rule ID 14294 //
     /* 1868810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1868830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1868836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868856 */     // MIs[0] policy
     /* 1868856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868866 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1868866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1868869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868889 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868892 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868893 */     // GIR_Coverage, 14294,
     /* 1868893 */     GIR_EraseRootFromParent_Done,
     /* 1868894 */   // Label 25212: @1868894
     /* 1868894 */   GIM_Try, /*On fail goto*//*Label 25213*/ GIMT_Encode4(1868983), // Rule ID 14295 //
     /* 1868899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1868902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1868910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1868913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1868916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1868919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1868922 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1868925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1868929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1868937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1868941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1868945 */     // MIs[0] policy
     /* 1868945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1868948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1868955 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1868955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1868958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1868960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1868962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1868964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1868966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1868968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1868973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1868976 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1868978 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1868981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1868982 */     // GIR_Coverage, 14295,
     /* 1868982 */     GIR_EraseRootFromParent_Done,
     /* 1868983 */   // Label 25213: @1868983
     /* 1868983 */   GIM_Try, /*On fail goto*//*Label 25214*/ GIMT_Encode4(1869072), // Rule ID 14298 //
     /* 1868988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1868991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1868996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1868999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1869002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1869005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869034 */     // MIs[0] policy
     /* 1869034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869044 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869070 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869071 */     // GIR_Coverage, 14298,
     /* 1869071 */     GIR_EraseRootFromParent_Done,
     /* 1869072 */   // Label 25214: @1869072
     /* 1869072 */   GIM_Try, /*On fail goto*//*Label 25215*/ GIMT_Encode4(1869161), // Rule ID 14299 //
     /* 1869077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1869088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1869091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1869094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869100 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869123 */     // MIs[0] policy
     /* 1869123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869133 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869154 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869160 */     // GIR_Coverage, 14299,
     /* 1869160 */     GIR_EraseRootFromParent_Done,
     /* 1869161 */   // Label 25215: @1869161
     /* 1869161 */   GIM_Try, /*On fail goto*//*Label 25216*/ GIMT_Encode4(1869250), // Rule ID 14302 //
     /* 1869166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1869177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1869180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1869183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869212 */     // MIs[0] policy
     /* 1869212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869222 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1869225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869248 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869249 */     // GIR_Coverage, 14302,
     /* 1869249 */     GIR_EraseRootFromParent_Done,
     /* 1869250 */   // Label 25216: @1869250
     /* 1869250 */   GIM_Try, /*On fail goto*//*Label 25217*/ GIMT_Encode4(1869339), // Rule ID 14303 //
     /* 1869255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1869266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1869269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1869272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869278 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869301 */     // MIs[0] policy
     /* 1869301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869311 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF4_MASK),
     /* 1869314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869332 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869334 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869338 */     // GIR_Coverage, 14303,
     /* 1869338 */     GIR_EraseRootFromParent_Done,
     /* 1869339 */   // Label 25217: @1869339
     /* 1869339 */   GIM_Try, /*On fail goto*//*Label 25218*/ GIMT_Encode4(1869428), // Rule ID 14306 //
     /* 1869344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1869355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1869358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1869361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869390 */     // MIs[0] policy
     /* 1869390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869400 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869423 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869426 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869427 */     // GIR_Coverage, 14306,
     /* 1869427 */     GIR_EraseRootFromParent_Done,
     /* 1869428 */   // Label 25218: @1869428
     /* 1869428 */   GIM_Try, /*On fail goto*//*Label 25219*/ GIMT_Encode4(1869517), // Rule ID 14307 //
     /* 1869433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1869444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1869447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1869450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1869456 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869479 */     // MIs[0] policy
     /* 1869479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869489 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869510 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869512 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869516 */     // GIR_Coverage, 14307,
     /* 1869516 */     GIR_EraseRootFromParent_Done,
     /* 1869517 */   // Label 25219: @1869517
     /* 1869517 */   GIM_Try, /*On fail goto*//*Label 25220*/ GIMT_Encode4(1869606), // Rule ID 14310 //
     /* 1869522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1869533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1869536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1869539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869568 */     // MIs[0] policy
     /* 1869568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869578 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869604 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869605 */     // GIR_Coverage, 14310,
     /* 1869605 */     GIR_EraseRootFromParent_Done,
     /* 1869606 */   // Label 25220: @1869606
     /* 1869606 */   GIM_Try, /*On fail goto*//*Label 25221*/ GIMT_Encode4(1869695), // Rule ID 14311 //
     /* 1869611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1869622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1869625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1869628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1869634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869657 */     // MIs[0] policy
     /* 1869657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869667 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_MF2_MASK),
     /* 1869670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1869688 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869690 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869694 */     // GIR_Coverage, 14311,
     /* 1869694 */     GIR_EraseRootFromParent_Done,
     /* 1869695 */   // Label 25221: @1869695
     /* 1869695 */   GIM_Try, /*On fail goto*//*Label 25222*/ GIMT_Encode4(1869784), // Rule ID 14314 //
     /* 1869700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1869711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1869714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1869717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869746 */     // MIs[0] policy
     /* 1869746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869756 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1869759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869779 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869782 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869783 */     // GIR_Coverage, 14314,
     /* 1869783 */     GIR_EraseRootFromParent_Done,
     /* 1869784 */   // Label 25222: @1869784
     /* 1869784 */   GIM_Try, /*On fail goto*//*Label 25223*/ GIMT_Encode4(1869873), // Rule ID 14315 //
     /* 1869789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1869800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1869803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1869806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1869812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869835 */     // MIs[0] policy
     /* 1869835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869845 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11463:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1869845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1869848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1869866 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869872 */     // GIR_Coverage, 14315,
     /* 1869872 */     GIR_EraseRootFromParent_Done,
     /* 1869873 */   // Label 25223: @1869873
     /* 1869873 */   GIM_Try, /*On fail goto*//*Label 25224*/ GIMT_Encode4(1869962), // Rule ID 14318 //
     /* 1869878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1869881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1869898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1869904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1869916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1869920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1869924 */     // MIs[0] policy
     /* 1869924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1869927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1869934 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1869934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1869937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1869939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1869941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1869943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1869945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1869947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1869952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1869955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1869957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1869960 */     GIR_RootConstrainSelectedInstOperands,
     /* 1869961 */     // GIR_Coverage, 14318,
     /* 1869961 */     GIR_EraseRootFromParent_Done,
     /* 1869962 */   // Label 25224: @1869962
     /* 1869962 */   GIM_Try, /*On fail goto*//*Label 25225*/ GIMT_Encode4(1870051), // Rule ID 14319 //
     /* 1869967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1869970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1869975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1869978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1869981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1869984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1869987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1869990 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1869993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1869997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870013 */     // MIs[0] policy
     /* 1870013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870023 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11463:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1870026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1870044 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870046 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870050 */     // GIR_Coverage, 14319,
     /* 1870050 */     GIR_EraseRootFromParent_Done,
     /* 1870051 */   // Label 25225: @1870051
     /* 1870051 */   GIM_Try, /*On fail goto*//*Label 25226*/ GIMT_Encode4(1870140), // Rule ID 14322 //
     /* 1870056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1870067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1870070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1870073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870102 */     // MIs[0] policy
     /* 1870102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870112 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1870115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870138 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870139 */     // GIR_Coverage, 14322,
     /* 1870139 */     GIR_EraseRootFromParent_Done,
     /* 1870140 */   // Label 25226: @1870140
     /* 1870140 */   GIM_Try, /*On fail goto*//*Label 25227*/ GIMT_Encode4(1870229), // Rule ID 14323 //
     /* 1870145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1870156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1870159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1870162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1870168 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870191 */     // MIs[0] policy
     /* 1870191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870201 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11463:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1870204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1870222 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870224 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870228 */     // GIR_Coverage, 14323,
     /* 1870228 */     GIR_EraseRootFromParent_Done,
     /* 1870229 */   // Label 25227: @1870229
     /* 1870229 */   GIM_Try, /*On fail goto*//*Label 25228*/ GIMT_Encode4(1870318), // Rule ID 14326 //
     /* 1870234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1870237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870280 */     // MIs[0] policy
     /* 1870280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870290 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1870293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870316 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870317 */     // GIR_Coverage, 14326,
     /* 1870317 */     GIR_EraseRootFromParent_Done,
     /* 1870318 */   // Label 25228: @1870318
     /* 1870318 */   GIM_Try, /*On fail goto*//*Label 25229*/ GIMT_Encode4(1870407), // Rule ID 14327 //
     /* 1870323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1870326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1870334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1870337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1870340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1870346 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1870353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1870361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870369 */     // MIs[0] policy
     /* 1870369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870379 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11463:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M1_MASK),
     /* 1870382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1870400 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870406 */     // GIR_Coverage, 14327,
     /* 1870406 */     GIR_EraseRootFromParent_Done,
     /* 1870407 */   // Label 25229: @1870407
     /* 1870407 */   GIM_Try, /*On fail goto*//*Label 25230*/ GIMT_Encode4(1870496), // Rule ID 14330 //
     /* 1870412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1870423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1870426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1870429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870458 */     // MIs[0] policy
     /* 1870458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870468 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1870471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870494 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870495 */     // GIR_Coverage, 14330,
     /* 1870495 */     GIR_EraseRootFromParent_Done,
     /* 1870496 */   // Label 25230: @1870496
     /* 1870496 */   GIM_Try, /*On fail goto*//*Label 25231*/ GIMT_Encode4(1870585), // Rule ID 14331 //
     /* 1870501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1870512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1870515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1870518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1870524 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870547 */     // MIs[0] policy
     /* 1870547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870557 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1870560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870578 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870580 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870584 */     // GIR_Coverage, 14331,
     /* 1870584 */     GIR_EraseRootFromParent_Done,
     /* 1870585 */   // Label 25231: @1870585
     /* 1870585 */   GIM_Try, /*On fail goto*//*Label 25232*/ GIMT_Encode4(1870674), // Rule ID 14334 //
     /* 1870590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1870601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1870604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1870607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870636 */     // MIs[0] policy
     /* 1870636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870646 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1870649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870672 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870673 */     // GIR_Coverage, 14334,
     /* 1870673 */     GIR_EraseRootFromParent_Done,
     /* 1870674 */   // Label 25232: @1870674
     /* 1870674 */   GIM_Try, /*On fail goto*//*Label 25233*/ GIMT_Encode4(1870763), // Rule ID 14335 //
     /* 1870679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1870690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1870693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1870696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1870702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1870709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1870717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870725 */     // MIs[0] policy
     /* 1870725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870735 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1870738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870756 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870758 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870762 */     // GIR_Coverage, 14335,
     /* 1870762 */     GIR_EraseRootFromParent_Done,
     /* 1870763 */   // Label 25233: @1870763
     /* 1870763 */   GIM_Try, /*On fail goto*//*Label 25234*/ GIMT_Encode4(1870852), // Rule ID 14338 //
     /* 1870768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1870779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870814 */     // MIs[0] policy
     /* 1870814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870824 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1870824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1870827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870850 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870851 */     // GIR_Coverage, 14338,
     /* 1870851 */     GIR_EraseRootFromParent_Done,
     /* 1870852 */   // Label 25234: @1870852
     /* 1870852 */   GIM_Try, /*On fail goto*//*Label 25235*/ GIMT_Encode4(1870941), // Rule ID 14339 //
     /* 1870857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1870860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1870868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1870871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1870874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1870877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1870880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1870883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1870887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1870895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870903 */     // MIs[0] policy
     /* 1870903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1870913 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1870913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1870916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1870918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1870920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1870922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1870924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1870926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1870931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1870934 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1870936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1870939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1870940 */     // GIR_Coverage, 14339,
     /* 1870940 */     GIR_EraseRootFromParent_Done,
     /* 1870941 */   // Label 25235: @1870941
     /* 1870941 */   GIM_Try, /*On fail goto*//*Label 25236*/ GIMT_Encode4(1871030), // Rule ID 14342 //
     /* 1870946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1870949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1870954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1870957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1870960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1870963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1870966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1870969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1870972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1870976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1870984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1870988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1870992 */     // MIs[0] policy
     /* 1870992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1870995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871002 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1871005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871028 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871029 */     // GIR_Coverage, 14342,
     /* 1871029 */     GIR_EraseRootFromParent_Done,
     /* 1871030 */   // Label 25236: @1871030
     /* 1871030 */   GIM_Try, /*On fail goto*//*Label 25237*/ GIMT_Encode4(1871119), // Rule ID 14343 //
     /* 1871035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1871046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1871049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1871052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871058 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871081 */     // MIs[0] policy
     /* 1871081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1871094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871112 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871114 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871118 */     // GIR_Coverage, 14343,
     /* 1871118 */     GIR_EraseRootFromParent_Done,
     /* 1871119 */   // Label 25237: @1871119
     /* 1871119 */   GIM_Try, /*On fail goto*//*Label 25238*/ GIMT_Encode4(1871208), // Rule ID 14346 //
     /* 1871124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1871135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1871138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1871141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871170 */     // MIs[0] policy
     /* 1871170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871180 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1871183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871203 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871206 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871207 */     // GIR_Coverage, 14346,
     /* 1871207 */     GIR_EraseRootFromParent_Done,
     /* 1871208 */   // Label 25238: @1871208
     /* 1871208 */   GIM_Try, /*On fail goto*//*Label 25239*/ GIMT_Encode4(1871297), // Rule ID 14347 //
     /* 1871213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1871224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1871227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1871230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871236 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871259 */     // MIs[0] policy
     /* 1871259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871269 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1871272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871290 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871292 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871296 */     // GIR_Coverage, 14347,
     /* 1871296 */     GIR_EraseRootFromParent_Done,
     /* 1871297 */   // Label 25239: @1871297
     /* 1871297 */   GIM_Try, /*On fail goto*//*Label 25240*/ GIMT_Encode4(1871386), // Rule ID 14350 //
     /* 1871302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1871313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1871316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1871319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871348 */     // MIs[0] policy
     /* 1871348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871358 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1871361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871384 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871385 */     // GIR_Coverage, 14350,
     /* 1871385 */     GIR_EraseRootFromParent_Done,
     /* 1871386 */   // Label 25240: @1871386
     /* 1871386 */   GIM_Try, /*On fail goto*//*Label 25241*/ GIMT_Encode4(1871475), // Rule ID 14351 //
     /* 1871391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1871402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1871405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1871408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1871414 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871437 */     // MIs[0] policy
     /* 1871437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871447 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1871450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871452 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1871468 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871474 */     // GIR_Coverage, 14351,
     /* 1871474 */     GIR_EraseRootFromParent_Done,
     /* 1871475 */   // Label 25241: @1871475
     /* 1871475 */   GIM_Try, /*On fail goto*//*Label 25242*/ GIMT_Encode4(1871564), // Rule ID 14354 //
     /* 1871480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1871491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1871494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1871497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871526 */     // MIs[0] policy
     /* 1871526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1871539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871562 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871563 */     // GIR_Coverage, 14354,
     /* 1871563 */     GIR_EraseRootFromParent_Done,
     /* 1871564 */   // Label 25242: @1871564
     /* 1871564 */   GIM_Try, /*On fail goto*//*Label 25243*/ GIMT_Encode4(1871653), // Rule ID 14355 //
     /* 1871569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1871580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1871583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1871586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1871592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1871599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1871607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871615 */     // MIs[0] policy
     /* 1871615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871625 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1871628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871630 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871646 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871648 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871652 */     // GIR_Coverage, 14355,
     /* 1871652 */     GIR_EraseRootFromParent_Done,
     /* 1871653 */   // Label 25243: @1871653
     /* 1871653 */   GIM_Try, /*On fail goto*//*Label 25244*/ GIMT_Encode4(1871742), // Rule ID 14358 //
     /* 1871658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1871669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1871672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1871675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871704 */     // MIs[0] policy
     /* 1871704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871714 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1871717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871740 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871741 */     // GIR_Coverage, 14358,
     /* 1871741 */     GIR_EraseRootFromParent_Done,
     /* 1871742 */   // Label 25244: @1871742
     /* 1871742 */   GIM_Try, /*On fail goto*//*Label 25245*/ GIMT_Encode4(1871831), // Rule ID 14359 //
     /* 1871747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1871758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1871761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1871764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1871770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1871777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1871785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871793 */     // MIs[0] policy
     /* 1871793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871803 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1871806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871824 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871826 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871830 */     // GIR_Coverage, 14359,
     /* 1871830 */     GIR_EraseRootFromParent_Done,
     /* 1871831 */   // Label 25245: @1871831
     /* 1871831 */   GIM_Try, /*On fail goto*//*Label 25246*/ GIMT_Encode4(1871920), // Rule ID 14362 //
     /* 1871836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1871839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1871856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1871862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871882 */     // MIs[0] policy
     /* 1871882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871892 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1871892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1871895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1871913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1871915 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1871918 */     GIR_RootConstrainSelectedInstOperands,
     /* 1871919 */     // GIR_Coverage, 14362,
     /* 1871919 */     GIR_EraseRootFromParent_Done,
     /* 1871920 */   // Label 25246: @1871920
     /* 1871920 */   GIM_Try, /*On fail goto*//*Label 25247*/ GIMT_Encode4(1872009), // Rule ID 14363 //
     /* 1871925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1871928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1871933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1871936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1871939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1871942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1871945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1871948 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1871951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1871955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1871963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1871967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1871971 */     // MIs[0] policy
     /* 1871971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1871974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1871981 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1871981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1871984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1871986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1871988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1871990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1871992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1871994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1871999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1872002 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872008 */     // GIR_Coverage, 14363,
     /* 1872008 */     GIR_EraseRootFromParent_Done,
     /* 1872009 */   // Label 25247: @1872009
     /* 1872009 */   GIM_Try, /*On fail goto*//*Label 25248*/ GIMT_Encode4(1872098), // Rule ID 14366 //
     /* 1872014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1872025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1872028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1872031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872060 */     // MIs[0] policy
     /* 1872060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1872073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872096 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872097 */     // GIR_Coverage, 14366,
     /* 1872097 */     GIR_EraseRootFromParent_Done,
     /* 1872098 */   // Label 25248: @1872098
     /* 1872098 */   GIM_Try, /*On fail goto*//*Label 25249*/ GIMT_Encode4(1872187), // Rule ID 14367 //
     /* 1872103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1872114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1872117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1872120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872126 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1872133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1872141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872149 */     // MIs[0] policy
     /* 1872149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872159 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11463:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M2_MASK),
     /* 1872162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872180 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872182 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872186 */     // GIR_Coverage, 14367,
     /* 1872186 */     GIR_EraseRootFromParent_Done,
     /* 1872187 */   // Label 25249: @1872187
     /* 1872187 */   GIM_Try, /*On fail goto*//*Label 25250*/ GIMT_Encode4(1872276), // Rule ID 14370 //
     /* 1872192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872238 */     // MIs[0] policy
     /* 1872238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872248 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1872251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872274 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872275 */     // GIR_Coverage, 14370,
     /* 1872275 */     GIR_EraseRootFromParent_Done,
     /* 1872276 */   // Label 25250: @1872276
     /* 1872276 */   GIM_Try, /*On fail goto*//*Label 25251*/ GIMT_Encode4(1872365), // Rule ID 14371 //
     /* 1872281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1872292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1872295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1872298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872304 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1872311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1872319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872327 */     // MIs[0] policy
     /* 1872327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872337 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11463:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M4_MASK),
     /* 1872340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872358 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872364 */     // GIR_Coverage, 14371,
     /* 1872364 */     GIR_EraseRootFromParent_Done,
     /* 1872365 */   // Label 25251: @1872365
     /* 1872365 */   GIM_Try, /*On fail goto*//*Label 25252*/ GIMT_Encode4(1872454), // Rule ID 14374 //
     /* 1872370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1872373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1872390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872416 */     // MIs[0] policy
     /* 1872416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872426 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1872429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872449 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872452 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872453 */     // GIR_Coverage, 14374,
     /* 1872453 */     GIR_EraseRootFromParent_Done,
     /* 1872454 */   // Label 25252: @1872454
     /* 1872454 */   GIM_Try, /*On fail goto*//*Label 25253*/ GIMT_Encode4(1872543), // Rule ID 14375 //
     /* 1872459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1872462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsadd_mask),
     /* 1872467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1872470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1872473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1872476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1872479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1872482 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1872489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1872497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1872501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872505 */     // MIs[0] policy
     /* 1872505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872515 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11463:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VX_M8_MASK),
     /* 1872518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1872536 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872542 */     // GIR_Coverage, 14375,
     /* 1872542 */     GIR_EraseRootFromParent_Done,
     /* 1872543 */   // Label 25253: @1872543
     /* 1872543 */   GIM_Try, /*On fail goto*//*Label 25254*/ GIMT_Encode4(1872632), // Rule ID 14466 //
     /* 1872548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1872556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1872559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1872562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1872565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1872568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872594 */     // MIs[0] policy
     /* 1872594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872604 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1872607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872630 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872631 */     // GIR_Coverage, 14466,
     /* 1872631 */     GIR_EraseRootFromParent_Done,
     /* 1872632 */   // Label 25254: @1872632
     /* 1872632 */   GIM_Try, /*On fail goto*//*Label 25255*/ GIMT_Encode4(1872721), // Rule ID 14467 //
     /* 1872637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1872645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1872648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1872651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1872654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1872657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1872660 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872683 */     // MIs[0] policy
     /* 1872683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872693 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8_MASK),
     /* 1872696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872714 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872716 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872720 */     // GIR_Coverage, 14467,
     /* 1872720 */     GIR_EraseRootFromParent_Done,
     /* 1872721 */   // Label 25255: @1872721
     /* 1872721 */   GIM_Try, /*On fail goto*//*Label 25256*/ GIMT_Encode4(1872810), // Rule ID 14470 //
     /* 1872726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1872734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872772 */     // MIs[0] policy
     /* 1872772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872782 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1872785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872808 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872809 */     // GIR_Coverage, 14470,
     /* 1872809 */     GIR_EraseRootFromParent_Done,
     /* 1872810 */   // Label 25256: @1872810
     /* 1872810 */   GIM_Try, /*On fail goto*//*Label 25257*/ GIMT_Encode4(1872899), // Rule ID 14471 //
     /* 1872815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1872823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1872826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1872829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1872832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1872835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1872838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1872841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872861 */     // MIs[0] policy
     /* 1872861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872871 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1872871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1872874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872892 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872898 */     // GIR_Coverage, 14471,
     /* 1872898 */     GIR_EraseRootFromParent_Done,
     /* 1872899 */   // Label 25257: @1872899
     /* 1872899 */   GIM_Try, /*On fail goto*//*Label 25258*/ GIMT_Encode4(1872988), // Rule ID 14474 //
     /* 1872904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1872907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1872912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1872915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1872918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1872921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1872924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1872927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1872930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1872934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1872946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1872950 */     // MIs[0] policy
     /* 1872950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1872953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1872960 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1872960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1872963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1872965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1872967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1872969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1872971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1872973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1872978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1872981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1872983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1872986 */     GIR_RootConstrainSelectedInstOperands,
     /* 1872987 */     // GIR_Coverage, 14474,
     /* 1872987 */     GIR_EraseRootFromParent_Done,
     /* 1872988 */   // Label 25258: @1872988
     /* 1872988 */   GIM_Try, /*On fail goto*//*Label 25259*/ GIMT_Encode4(1873077), // Rule ID 14475 //
     /* 1872993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1872996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1873004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1873007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1873010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1873013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873016 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873039 */     // MIs[0] policy
     /* 1873039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873049 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1873052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873070 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873072 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873076 */     // GIR_Coverage, 14475,
     /* 1873076 */     GIR_EraseRootFromParent_Done,
     /* 1873077 */   // Label 25259: @1873077
     /* 1873077 */   GIM_Try, /*On fail goto*//*Label 25260*/ GIMT_Encode4(1873166), // Rule ID 14478 //
     /* 1873082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1873093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1873096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1873099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1873102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873128 */     // MIs[0] policy
     /* 1873128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873138 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1873141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873164 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873165 */     // GIR_Coverage, 14478,
     /* 1873165 */     GIR_EraseRootFromParent_Done,
     /* 1873166 */   // Label 25260: @1873166
     /* 1873166 */   GIM_Try, /*On fail goto*//*Label 25261*/ GIMT_Encode4(1873255), // Rule ID 14479 //
     /* 1873171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1873182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1873185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1873188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1873191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873194 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873217 */     // MIs[0] policy
     /* 1873217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873227 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4_MASK),
     /* 1873230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873248 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873254 */     // GIR_Coverage, 14479,
     /* 1873254 */     GIR_EraseRootFromParent_Done,
     /* 1873255 */   // Label 25261: @1873255
     /* 1873255 */   GIM_Try, /*On fail goto*//*Label 25262*/ GIMT_Encode4(1873344), // Rule ID 14482 //
     /* 1873260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1873280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873306 */     // MIs[0] policy
     /* 1873306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873316 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1873319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873342 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873343 */     // GIR_Coverage, 14482,
     /* 1873343 */     GIR_EraseRootFromParent_Done,
     /* 1873344 */   // Label 25262: @1873344
     /* 1873344 */   GIM_Try, /*On fail goto*//*Label 25263*/ GIMT_Encode4(1873433), // Rule ID 14483 //
     /* 1873349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1873360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1873363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1873366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1873369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873395 */     // MIs[0] policy
     /* 1873395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873405 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1873408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873426 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873428 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873432 */     // GIR_Coverage, 14483,
     /* 1873432 */     GIR_EraseRootFromParent_Done,
     /* 1873433 */   // Label 25263: @1873433
     /* 1873433 */   GIM_Try, /*On fail goto*//*Label 25264*/ GIMT_Encode4(1873522), // Rule ID 14486 //
     /* 1873438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1873458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873484 */     // MIs[0] policy
     /* 1873484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873494 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1873497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873517 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873520 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873521 */     // GIR_Coverage, 14486,
     /* 1873521 */     GIR_EraseRootFromParent_Done,
     /* 1873522 */   // Label 25264: @1873522
     /* 1873522 */   GIM_Try, /*On fail goto*//*Label 25265*/ GIMT_Encode4(1873611), // Rule ID 14487 //
     /* 1873527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1873538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1873541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1873544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1873547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1873550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873573 */     // MIs[0] policy
     /* 1873573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873583 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2_MASK),
     /* 1873586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1873604 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873606 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873610 */     // GIR_Coverage, 14487,
     /* 1873610 */     GIR_EraseRootFromParent_Done,
     /* 1873611 */   // Label 25265: @1873611
     /* 1873611 */   GIM_Try, /*On fail goto*//*Label 25266*/ GIMT_Encode4(1873700), // Rule ID 14490 //
     /* 1873616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1873627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1873630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1873633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1873636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873662 */     // MIs[0] policy
     /* 1873662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873672 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1873675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873698 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873699 */     // GIR_Coverage, 14490,
     /* 1873699 */     GIR_EraseRootFromParent_Done,
     /* 1873700 */   // Label 25266: @1873700
     /* 1873700 */   GIM_Try, /*On fail goto*//*Label 25267*/ GIMT_Encode4(1873789), // Rule ID 14491 //
     /* 1873705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1873716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1873719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1873722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1873725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1873728 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873751 */     // MIs[0] policy
     /* 1873751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873761 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1873764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1873782 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873784 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873788 */     // GIR_Coverage, 14491,
     /* 1873788 */     GIR_EraseRootFromParent_Done,
     /* 1873789 */   // Label 25267: @1873789
     /* 1873789 */   GIM_Try, /*On fail goto*//*Label 25268*/ GIMT_Encode4(1873878), // Rule ID 14494 //
     /* 1873794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873840 */     // MIs[0] policy
     /* 1873840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873850 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1873850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1873853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873876 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873877 */     // GIR_Coverage, 14494,
     /* 1873877 */     GIR_EraseRootFromParent_Done,
     /* 1873878 */   // Label 25268: @1873878
     /* 1873878 */   GIM_Try, /*On fail goto*//*Label 25269*/ GIMT_Encode4(1873967), // Rule ID 14495 //
     /* 1873883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1873886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1873894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1873897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1873900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1873903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1873906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1873909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1873913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1873925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1873929 */     // MIs[0] policy
     /* 1873929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1873932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1873939 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1873939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1873942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1873944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1873946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1873948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1873950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1873952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1873957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1873960 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1873962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1873965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1873966 */     // GIR_Coverage, 14495,
     /* 1873966 */     GIR_EraseRootFromParent_Done,
     /* 1873967 */   // Label 25269: @1873967
     /* 1873967 */   GIM_Try, /*On fail goto*//*Label 25270*/ GIMT_Encode4(1874056), // Rule ID 14498 //
     /* 1873972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1873975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1873980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1873983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1873986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1873989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1873992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1873995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1873998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874018 */     // MIs[0] policy
     /* 1874018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874028 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1874031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874054 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874055 */     // GIR_Coverage, 14498,
     /* 1874055 */     GIR_EraseRootFromParent_Done,
     /* 1874056 */   // Label 25270: @1874056
     /* 1874056 */   GIM_Try, /*On fail goto*//*Label 25271*/ GIMT_Encode4(1874145), // Rule ID 14499 //
     /* 1874061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1874072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1874075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1874078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1874081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1874084 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874107 */     // MIs[0] policy
     /* 1874107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874117 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1874120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1874138 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874144 */     // GIR_Coverage, 14499,
     /* 1874144 */     GIR_EraseRootFromParent_Done,
     /* 1874145 */   // Label 25271: @1874145
     /* 1874145 */   GIM_Try, /*On fail goto*//*Label 25272*/ GIMT_Encode4(1874234), // Rule ID 14502 //
     /* 1874150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1874153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1874161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1874164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1874167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1874170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1874173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874196 */     // MIs[0] policy
     /* 1874196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874206 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1874209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874229 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874232 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874233 */     // GIR_Coverage, 14502,
     /* 1874233 */     GIR_EraseRootFromParent_Done,
     /* 1874234 */   // Label 25272: @1874234
     /* 1874234 */   GIM_Try, /*On fail goto*//*Label 25273*/ GIMT_Encode4(1874323), // Rule ID 14503 //
     /* 1874239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1874242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1874250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1874253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1874256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1874259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1874262 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1874269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1874281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874285 */     // MIs[0] policy
     /* 1874285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874295 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1_MASK),
     /* 1874298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1874316 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874318 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874322 */     // GIR_Coverage, 14503,
     /* 1874322 */     GIR_EraseRootFromParent_Done,
     /* 1874323 */   // Label 25273: @1874323
     /* 1874323 */   GIM_Try, /*On fail goto*//*Label 25274*/ GIMT_Encode4(1874412), // Rule ID 14506 //
     /* 1874328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1874348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874374 */     // MIs[0] policy
     /* 1874374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1874387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874410 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874411 */     // GIR_Coverage, 14506,
     /* 1874411 */     GIR_EraseRootFromParent_Done,
     /* 1874412 */   // Label 25274: @1874412
     /* 1874412 */   GIM_Try, /*On fail goto*//*Label 25275*/ GIMT_Encode4(1874501), // Rule ID 14507 //
     /* 1874417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1874428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1874431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1874434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1874437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1874440 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874463 */     // MIs[0] policy
     /* 1874463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874473 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1874476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874494 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874496 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874500 */     // GIR_Coverage, 14507,
     /* 1874500 */     GIR_EraseRootFromParent_Done,
     /* 1874501 */   // Label 25275: @1874501
     /* 1874501 */   GIM_Try, /*On fail goto*//*Label 25276*/ GIMT_Encode4(1874590), // Rule ID 14510 //
     /* 1874506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1874517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1874520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1874523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1874526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874552 */     // MIs[0] policy
     /* 1874552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874562 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1874565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874588 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874589 */     // GIR_Coverage, 14510,
     /* 1874589 */     GIR_EraseRootFromParent_Done,
     /* 1874590 */   // Label 25276: @1874590
     /* 1874590 */   GIM_Try, /*On fail goto*//*Label 25277*/ GIMT_Encode4(1874679), // Rule ID 14511 //
     /* 1874595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1874606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1874609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1874612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1874615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1874618 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1874625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1874637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874641 */     // MIs[0] policy
     /* 1874641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874651 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1874654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874672 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874678 */     // GIR_Coverage, 14511,
     /* 1874678 */     GIR_EraseRootFromParent_Done,
     /* 1874679 */   // Label 25277: @1874679
     /* 1874679 */   GIM_Try, /*On fail goto*//*Label 25278*/ GIMT_Encode4(1874768), // Rule ID 14514 //
     /* 1874684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874730 */     // MIs[0] policy
     /* 1874730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874740 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1874743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874766 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874767 */     // GIR_Coverage, 14514,
     /* 1874767 */     GIR_EraseRootFromParent_Done,
     /* 1874768 */   // Label 25278: @1874768
     /* 1874768 */   GIM_Try, /*On fail goto*//*Label 25279*/ GIMT_Encode4(1874857), // Rule ID 14515 //
     /* 1874773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1874784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1874787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1874790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1874793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1874796 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1874803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1874815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874819 */     // MIs[0] policy
     /* 1874819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874829 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1874829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1874832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1874850 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874852 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874856 */     // GIR_Coverage, 14515,
     /* 1874856 */     GIR_EraseRootFromParent_Done,
     /* 1874857 */   // Label 25279: @1874857
     /* 1874857 */   GIM_Try, /*On fail goto*//*Label 25280*/ GIMT_Encode4(1874946), // Rule ID 14518 //
     /* 1874862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1874865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1874888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874908 */     // MIs[0] policy
     /* 1874908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1874911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1874918 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1874918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1874921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1874923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1874925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1874927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1874929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1874931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1874936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1874939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1874941 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1874944 */     GIR_RootConstrainSelectedInstOperands,
     /* 1874945 */     // GIR_Coverage, 14518,
     /* 1874945 */     GIR_EraseRootFromParent_Done,
     /* 1874946 */   // Label 25280: @1874946
     /* 1874946 */   GIM_Try, /*On fail goto*//*Label 25281*/ GIMT_Encode4(1875035), // Rule ID 14519 //
     /* 1874951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1874954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1874959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1874962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1874965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1874968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1874971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1874974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1874977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1874981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1874993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1874997 */     // MIs[0] policy
     /* 1874997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875007 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1875010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875028 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875034 */     // GIR_Coverage, 14519,
     /* 1875034 */     GIR_EraseRootFromParent_Done,
     /* 1875035 */   // Label 25281: @1875035
     /* 1875035 */   GIM_Try, /*On fail goto*//*Label 25282*/ GIMT_Encode4(1875124), // Rule ID 14522 //
     /* 1875040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1875051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1875054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1875057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1875060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875086 */     // MIs[0] policy
     /* 1875086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875096 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1875099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875119 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875122 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875123 */     // GIR_Coverage, 14522,
     /* 1875123 */     GIR_EraseRootFromParent_Done,
     /* 1875124 */   // Label 25282: @1875124
     /* 1875124 */   GIM_Try, /*On fail goto*//*Label 25283*/ GIMT_Encode4(1875213), // Rule ID 14523 //
     /* 1875129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1875140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1875143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1875146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1875149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875152 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875175 */     // MIs[0] policy
     /* 1875175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875185 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1875188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875206 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875208 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875212 */     // GIR_Coverage, 14523,
     /* 1875212 */     GIR_EraseRootFromParent_Done,
     /* 1875213 */   // Label 25283: @1875213
     /* 1875213 */   GIM_Try, /*On fail goto*//*Label 25284*/ GIMT_Encode4(1875302), // Rule ID 14526 //
     /* 1875218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1875238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875264 */     // MIs[0] policy
     /* 1875264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875274 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1875277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875297 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875300 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875301 */     // GIR_Coverage, 14526,
     /* 1875301 */     GIR_EraseRootFromParent_Done,
     /* 1875302 */   // Label 25284: @1875302
     /* 1875302 */   GIM_Try, /*On fail goto*//*Label 25285*/ GIMT_Encode4(1875391), // Rule ID 14527 //
     /* 1875307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1875318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1875321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1875324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1875327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1875330 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875353 */     // MIs[0] policy
     /* 1875353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875363 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1875366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1875384 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875386 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875390 */     // GIR_Coverage, 14527,
     /* 1875390 */     GIR_EraseRootFromParent_Done,
     /* 1875391 */   // Label 25285: @1875391
     /* 1875391 */   GIM_Try, /*On fail goto*//*Label 25286*/ GIMT_Encode4(1875480), // Rule ID 14530 //
     /* 1875396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1875416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875442 */     // MIs[0] policy
     /* 1875442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1875455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875478 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875479 */     // GIR_Coverage, 14530,
     /* 1875479 */     GIR_EraseRootFromParent_Done,
     /* 1875480 */   // Label 25286: @1875480
     /* 1875480 */   GIM_Try, /*On fail goto*//*Label 25287*/ GIMT_Encode4(1875569), // Rule ID 14531 //
     /* 1875485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1875496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1875499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1875502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1875505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1875508 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875531 */     // MIs[0] policy
     /* 1875531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875541 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1875544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875562 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875568 */     // GIR_Coverage, 14531,
     /* 1875568 */     GIR_EraseRootFromParent_Done,
     /* 1875569 */   // Label 25287: @1875569
     /* 1875569 */   GIM_Try, /*On fail goto*//*Label 25288*/ GIMT_Encode4(1875658), // Rule ID 14534 //
     /* 1875574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1875585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1875588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1875591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1875594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875620 */     // MIs[0] policy
     /* 1875620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875630 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1875633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875656 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875657 */     // GIR_Coverage, 14534,
     /* 1875657 */     GIR_EraseRootFromParent_Done,
     /* 1875658 */   // Label 25288: @1875658
     /* 1875658 */   GIM_Try, /*On fail goto*//*Label 25289*/ GIMT_Encode4(1875747), // Rule ID 14535 //
     /* 1875663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1875674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1875677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1875680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1875683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1875686 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1875693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1875705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875709 */     // MIs[0] policy
     /* 1875709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875719 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1875722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875724 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875740 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875742 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875746 */     // GIR_Coverage, 14535,
     /* 1875746 */     GIR_EraseRootFromParent_Done,
     /* 1875747 */   // Label 25289: @1875747
     /* 1875747 */   GIM_Try, /*On fail goto*//*Label 25290*/ GIMT_Encode4(1875836), // Rule ID 14538 //
     /* 1875752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1875755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875798 */     // MIs[0] policy
     /* 1875798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875808 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1875811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875834 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875835 */     // GIR_Coverage, 14538,
     /* 1875835 */     GIR_EraseRootFromParent_Done,
     /* 1875836 */   // Label 25290: @1875836
     /* 1875836 */   GIM_Try, /*On fail goto*//*Label 25291*/ GIMT_Encode4(1875925), // Rule ID 14539 //
     /* 1875841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1875844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1875852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1875855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1875858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1875861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1875864 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1875867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1875871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1875883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875887 */     // MIs[0] policy
     /* 1875887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875897 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1875897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1875900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875902 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1875915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1875918 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1875920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1875923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875924 */     // GIR_Coverage, 14539,
     /* 1875924 */     GIR_EraseRootFromParent_Done,
     /* 1875925 */   // Label 25291: @1875925
     /* 1875925 */   GIM_Try, /*On fail goto*//*Label 25292*/ GIMT_Encode4(1876014), // Rule ID 14542 //
     /* 1875930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1875933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1875938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1875941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1875944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1875947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1875950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1875953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1875956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1875960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1875972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1875976 */     // MIs[0] policy
     /* 1875976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1875979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1875986 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1875986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1875989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1875991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1875993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1875995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1875997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1875999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876012 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876013 */     // GIR_Coverage, 14542,
     /* 1876013 */     GIR_EraseRootFromParent_Done,
     /* 1876014 */   // Label 25292: @1876014
     /* 1876014 */   GIM_Try, /*On fail goto*//*Label 25293*/ GIMT_Encode4(1876103), // Rule ID 14543 //
     /* 1876019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1876030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1876033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1876036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1876039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1876049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1876061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876065 */     // MIs[0] policy
     /* 1876065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876075 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2_MASK),
     /* 1876078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876096 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876098 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876102 */     // GIR_Coverage, 14543,
     /* 1876102 */     GIR_EraseRootFromParent_Done,
     /* 1876103 */   // Label 25293: @1876103
     /* 1876103 */   GIM_Try, /*On fail goto*//*Label 25294*/ GIMT_Encode4(1876192), // Rule ID 14546 //
     /* 1876108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1876119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1876122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1876125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1876128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876154 */     // MIs[0] policy
     /* 1876154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876164 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1876167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876187 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876190 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876191 */     // GIR_Coverage, 14546,
     /* 1876191 */     GIR_EraseRootFromParent_Done,
     /* 1876192 */   // Label 25294: @1876192
     /* 1876192 */   GIM_Try, /*On fail goto*//*Label 25295*/ GIMT_Encode4(1876281), // Rule ID 14547 //
     /* 1876197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1876208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1876211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1876214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1876217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1876227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1876239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876243 */     // MIs[0] policy
     /* 1876243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876253 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4_MASK),
     /* 1876256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876274 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876276 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876280 */     // GIR_Coverage, 14547,
     /* 1876280 */     GIR_EraseRootFromParent_Done,
     /* 1876281 */   // Label 25295: @1876281
     /* 1876281 */   GIM_Try, /*On fail goto*//*Label 25296*/ GIMT_Encode4(1876370), // Rule ID 14550 //
     /* 1876286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1876289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1876306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876332 */     // MIs[0] policy
     /* 1876332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876342 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1876345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876368 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876369 */     // GIR_Coverage, 14550,
     /* 1876369 */     GIR_EraseRootFromParent_Done,
     /* 1876370 */   // Label 25296: @1876370
     /* 1876370 */   GIM_Try, /*On fail goto*//*Label 25297*/ GIMT_Encode4(1876459), // Rule ID 14551 //
     /* 1876375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1876378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1876386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1876389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1876392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1876395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1876398 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1876405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1876417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876421 */     // MIs[0] policy
     /* 1876421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876431 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8_MASK),
     /* 1876434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1876452 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876454 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876458 */     // GIR_Coverage, 14551,
     /* 1876458 */     GIR_EraseRootFromParent_Done,
     /* 1876459 */   // Label 25297: @1876459
     /* 1876459 */   GIM_Try, /*On fail goto*//*Label 25298*/ GIMT_Encode4(1876548), // Rule ID 14554 //
     /* 1876464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1876475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1876478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1876481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876510 */     // MIs[0] policy
     /* 1876510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876520 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1876523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876543 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876546 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876547 */     // GIR_Coverage, 14554,
     /* 1876547 */     GIR_EraseRootFromParent_Done,
     /* 1876548 */   // Label 25298: @1876548
     /* 1876548 */   GIM_Try, /*On fail goto*//*Label 25299*/ GIMT_Encode4(1876637), // Rule ID 14555 //
     /* 1876553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1876564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1876567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1876570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1876576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876599 */     // MIs[0] policy
     /* 1876599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876609 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF8_MASK),
     /* 1876612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876630 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876632 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876636 */     // GIR_Coverage, 14555,
     /* 1876636 */     GIR_EraseRootFromParent_Done,
     /* 1876637 */   // Label 25299: @1876637
     /* 1876637 */   GIM_Try, /*On fail goto*//*Label 25300*/ GIMT_Encode4(1876726), // Rule ID 14558 //
     /* 1876642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1876653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1876656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1876659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876688 */     // MIs[0] policy
     /* 1876688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876698 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1876701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876724 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876725 */     // GIR_Coverage, 14558,
     /* 1876725 */     GIR_EraseRootFromParent_Done,
     /* 1876726 */   // Label 25300: @1876726
     /* 1876726 */   GIM_Try, /*On fail goto*//*Label 25301*/ GIMT_Encode4(1876815), // Rule ID 14559 //
     /* 1876731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1876742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1876745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1876748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1876754 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876777 */     // MIs[0] policy
     /* 1876777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876787 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1876790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876808 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876810 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876814 */     // GIR_Coverage, 14559,
     /* 1876814 */     GIR_EraseRootFromParent_Done,
     /* 1876815 */   // Label 25301: @1876815
     /* 1876815 */   GIM_Try, /*On fail goto*//*Label 25302*/ GIMT_Encode4(1876904), // Rule ID 14562 //
     /* 1876820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1876823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1876840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1876846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876866 */     // MIs[0] policy
     /* 1876866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876876 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1876876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1876879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876902 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876903 */     // GIR_Coverage, 14562,
     /* 1876903 */     GIR_EraseRootFromParent_Done,
     /* 1876904 */   // Label 25302: @1876904
     /* 1876904 */   GIM_Try, /*On fail goto*//*Label 25303*/ GIMT_Encode4(1876993), // Rule ID 14563 //
     /* 1876909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1876912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1876917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1876920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1876923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1876926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1876929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1876932 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1876935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1876939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1876947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1876951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1876955 */     // MIs[0] policy
     /* 1876955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1876958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1876965 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1876965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1876968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1876970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1876972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1876974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1876976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1876978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1876983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1876986 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1876988 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1876991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1876992 */     // GIR_Coverage, 14563,
     /* 1876992 */     GIR_EraseRootFromParent_Done,
     /* 1876993 */   // Label 25303: @1876993
     /* 1876993 */   GIM_Try, /*On fail goto*//*Label 25304*/ GIMT_Encode4(1877082), // Rule ID 14566 //
     /* 1876998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1877009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1877012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1877015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877044 */     // MIs[0] policy
     /* 1877044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877054 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1877057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877080 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877081 */     // GIR_Coverage, 14566,
     /* 1877081 */     GIR_EraseRootFromParent_Done,
     /* 1877082 */   // Label 25304: @1877082
     /* 1877082 */   GIM_Try, /*On fail goto*//*Label 25305*/ GIMT_Encode4(1877171), // Rule ID 14567 //
     /* 1877087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1877098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1877101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1877104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877133 */     // MIs[0] policy
     /* 1877133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877143 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF4_MASK),
     /* 1877146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877164 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877166 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877170 */     // GIR_Coverage, 14567,
     /* 1877170 */     GIR_EraseRootFromParent_Done,
     /* 1877171 */   // Label 25305: @1877171
     /* 1877171 */   GIM_Try, /*On fail goto*//*Label 25306*/ GIMT_Encode4(1877260), // Rule ID 14570 //
     /* 1877176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1877187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1877190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1877193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877222 */     // MIs[0] policy
     /* 1877222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877232 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1877235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877258 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877259 */     // GIR_Coverage, 14570,
     /* 1877259 */     GIR_EraseRootFromParent_Done,
     /* 1877260 */   // Label 25306: @1877260
     /* 1877260 */   GIM_Try, /*On fail goto*//*Label 25307*/ GIMT_Encode4(1877349), // Rule ID 14571 //
     /* 1877265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1877276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1877279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1877282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877288 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877311 */     // MIs[0] policy
     /* 1877311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877321 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1877324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877342 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877348 */     // GIR_Coverage, 14571,
     /* 1877348 */     GIR_EraseRootFromParent_Done,
     /* 1877349 */   // Label 25307: @1877349
     /* 1877349 */   GIM_Try, /*On fail goto*//*Label 25308*/ GIMT_Encode4(1877438), // Rule ID 14574 //
     /* 1877354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877400 */     // MIs[0] policy
     /* 1877400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877410 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1877413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877436 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877437 */     // GIR_Coverage, 14574,
     /* 1877437 */     GIR_EraseRootFromParent_Done,
     /* 1877438 */   // Label 25308: @1877438
     /* 1877438 */   GIM_Try, /*On fail goto*//*Label 25309*/ GIMT_Encode4(1877527), // Rule ID 14575 //
     /* 1877443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1877454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1877457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1877460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1877466 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877489 */     // MIs[0] policy
     /* 1877489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877499 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_MF2_MASK),
     /* 1877502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877520 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877526 */     // GIR_Coverage, 14575,
     /* 1877526 */     GIR_EraseRootFromParent_Done,
     /* 1877527 */   // Label 25309: @1877527
     /* 1877527 */   GIM_Try, /*On fail goto*//*Label 25310*/ GIMT_Encode4(1877616), // Rule ID 14578 //
     /* 1877532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1877543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1877546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1877549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877578 */     // MIs[0] policy
     /* 1877578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877588 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1877591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877614 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877615 */     // GIR_Coverage, 14578,
     /* 1877615 */     GIR_EraseRootFromParent_Done,
     /* 1877616 */   // Label 25310: @1877616
     /* 1877616 */   GIM_Try, /*On fail goto*//*Label 25311*/ GIMT_Encode4(1877705), // Rule ID 14579 //
     /* 1877621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1877632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1877635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1877638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1877644 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877667 */     // MIs[0] policy
     /* 1877667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877677 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11551:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1877680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1877698 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877704 */     // GIR_Coverage, 14579,
     /* 1877704 */     GIR_EraseRootFromParent_Done,
     /* 1877705 */   // Label 25311: @1877705
     /* 1877705 */   GIM_Try, /*On fail goto*//*Label 25312*/ GIMT_Encode4(1877794), // Rule ID 14582 //
     /* 1877710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877756 */     // MIs[0] policy
     /* 1877756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877766 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1877769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877792 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877793 */     // GIR_Coverage, 14582,
     /* 1877793 */     GIR_EraseRootFromParent_Done,
     /* 1877794 */   // Label 25312: @1877794
     /* 1877794 */   GIM_Try, /*On fail goto*//*Label 25313*/ GIMT_Encode4(1877883), // Rule ID 14583 //
     /* 1877799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1877810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1877813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1877816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1877822 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1877825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877845 */     // MIs[0] policy
     /* 1877845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877855 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11551:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1877855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1877858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1877876 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877882 */     // GIR_Coverage, 14583,
     /* 1877882 */     GIR_EraseRootFromParent_Done,
     /* 1877883 */   // Label 25313: @1877883
     /* 1877883 */   GIM_Try, /*On fail goto*//*Label 25314*/ GIMT_Encode4(1877972), // Rule ID 14586 //
     /* 1877888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1877891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1877908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1877911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1877914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1877918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1877926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1877930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1877934 */     // MIs[0] policy
     /* 1877934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1877937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1877944 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1877944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1877947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1877949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1877951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1877953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1877955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1877957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1877962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1877965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1877967 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1877970 */     GIR_RootConstrainSelectedInstOperands,
     /* 1877971 */     // GIR_Coverage, 14586,
     /* 1877971 */     GIR_EraseRootFromParent_Done,
     /* 1877972 */   // Label 25314: @1877972
     /* 1877972 */   GIM_Try, /*On fail goto*//*Label 25315*/ GIMT_Encode4(1878061), // Rule ID 14587 //
     /* 1877977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1877980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1877985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1877988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1877991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1877994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1877997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1878000 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878023 */     // MIs[0] policy
     /* 1878023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878033 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11551:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1878036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1878054 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878060 */     // GIR_Coverage, 14587,
     /* 1878060 */     GIR_EraseRootFromParent_Done,
     /* 1878061 */   // Label 25315: @1878061
     /* 1878061 */   GIM_Try, /*On fail goto*//*Label 25316*/ GIMT_Encode4(1878150), // Rule ID 14590 //
     /* 1878066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1878069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1878077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1878080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1878083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1878089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878112 */     // MIs[0] policy
     /* 1878112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878122 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1878125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878148 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878149 */     // GIR_Coverage, 14590,
     /* 1878149 */     GIR_EraseRootFromParent_Done,
     /* 1878150 */   // Label 25316: @1878150
     /* 1878150 */   GIM_Try, /*On fail goto*//*Label 25317*/ GIMT_Encode4(1878239), // Rule ID 14591 //
     /* 1878155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1878158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1878166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1878169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1878172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1878178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1878185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1878193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878201 */     // MIs[0] policy
     /* 1878201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878211 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11551:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M1_MASK),
     /* 1878214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1878232 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878234 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878238 */     // GIR_Coverage, 14591,
     /* 1878238 */     GIR_EraseRootFromParent_Done,
     /* 1878239 */   // Label 25317: @1878239
     /* 1878239 */   GIM_Try, /*On fail goto*//*Label 25318*/ GIMT_Encode4(1878328), // Rule ID 14594 //
     /* 1878244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1878255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1878258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1878261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878290 */     // MIs[0] policy
     /* 1878290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878300 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1878303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878323 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878326 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878327 */     // GIR_Coverage, 14594,
     /* 1878327 */     GIR_EraseRootFromParent_Done,
     /* 1878328 */   // Label 25318: @1878328
     /* 1878328 */   GIM_Try, /*On fail goto*//*Label 25319*/ GIMT_Encode4(1878417), // Rule ID 14595 //
     /* 1878333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1878344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1878347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1878350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878356 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878379 */     // MIs[0] policy
     /* 1878379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878389 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1878392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878410 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878412 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878416 */     // GIR_Coverage, 14595,
     /* 1878416 */     GIR_EraseRootFromParent_Done,
     /* 1878417 */   // Label 25319: @1878417
     /* 1878417 */   GIM_Try, /*On fail goto*//*Label 25320*/ GIMT_Encode4(1878506), // Rule ID 14598 //
     /* 1878422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878468 */     // MIs[0] policy
     /* 1878468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878478 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1878481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878504 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878505 */     // GIR_Coverage, 14598,
     /* 1878505 */     GIR_EraseRootFromParent_Done,
     /* 1878506 */   // Label 25320: @1878506
     /* 1878506 */   GIM_Try, /*On fail goto*//*Label 25321*/ GIMT_Encode4(1878595), // Rule ID 14599 //
     /* 1878511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1878522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1878525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1878528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1878534 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878557 */     // MIs[0] policy
     /* 1878557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878567 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1878570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878588 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878590 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878594 */     // GIR_Coverage, 14599,
     /* 1878594 */     GIR_EraseRootFromParent_Done,
     /* 1878595 */   // Label 25321: @1878595
     /* 1878595 */   GIM_Try, /*On fail goto*//*Label 25322*/ GIMT_Encode4(1878684), // Rule ID 14602 //
     /* 1878600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1878611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1878614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1878617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1878623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878646 */     // MIs[0] policy
     /* 1878646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878656 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1878659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878679 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878682 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878683 */     // GIR_Coverage, 14602,
     /* 1878683 */     GIR_EraseRootFromParent_Done,
     /* 1878684 */   // Label 25322: @1878684
     /* 1878684 */   GIM_Try, /*On fail goto*//*Label 25323*/ GIMT_Encode4(1878773), // Rule ID 14603 //
     /* 1878689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1878700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1878703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1878706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1878712 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1878719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1878727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878735 */     // MIs[0] policy
     /* 1878735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878745 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1878748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1878766 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878768 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878772 */     // GIR_Coverage, 14603,
     /* 1878772 */     GIR_EraseRootFromParent_Done,
     /* 1878773 */   // Label 25323: @1878773
     /* 1878773 */   GIM_Try, /*On fail goto*//*Label 25324*/ GIMT_Encode4(1878862), // Rule ID 14606 //
     /* 1878778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878824 */     // MIs[0] policy
     /* 1878824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878834 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1878834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1878837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878860 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878861 */     // GIR_Coverage, 14606,
     /* 1878861 */     GIR_EraseRootFromParent_Done,
     /* 1878862 */   // Label 25324: @1878862
     /* 1878862 */   GIM_Try, /*On fail goto*//*Label 25325*/ GIMT_Encode4(1878951), // Rule ID 14607 //
     /* 1878867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1878870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1878878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1878881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1878884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1878887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1878890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1878893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1878897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1878905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1878913 */     // MIs[0] policy
     /* 1878913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1878916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1878923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1878923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1878926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1878928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1878930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1878932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1878934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1878936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1878941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1878944 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1878946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1878949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1878950 */     // GIR_Coverage, 14607,
     /* 1878950 */     GIR_EraseRootFromParent_Done,
     /* 1878951 */   // Label 25325: @1878951
     /* 1878951 */   GIM_Try, /*On fail goto*//*Label 25326*/ GIMT_Encode4(1879040), // Rule ID 14610 //
     /* 1878956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1878959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1878964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1878967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1878970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1878973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1878976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1878979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1878982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1878986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1878994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1878998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879002 */     // MIs[0] policy
     /* 1879002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879012 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1879015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879038 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879039 */     // GIR_Coverage, 14610,
     /* 1879039 */     GIR_EraseRootFromParent_Done,
     /* 1879040 */   // Label 25326: @1879040
     /* 1879040 */   GIM_Try, /*On fail goto*//*Label 25327*/ GIMT_Encode4(1879129), // Rule ID 14611 //
     /* 1879045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1879056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1879059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1879062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879068 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879091 */     // MIs[0] policy
     /* 1879091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879101 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1879104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879122 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879128 */     // GIR_Coverage, 14611,
     /* 1879128 */     GIR_EraseRootFromParent_Done,
     /* 1879129 */   // Label 25327: @1879129
     /* 1879129 */   GIM_Try, /*On fail goto*//*Label 25328*/ GIMT_Encode4(1879218), // Rule ID 14614 //
     /* 1879134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1879145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1879148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1879151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1879157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879180 */     // MIs[0] policy
     /* 1879180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1879193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879216 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879217 */     // GIR_Coverage, 14614,
     /* 1879217 */     GIR_EraseRootFromParent_Done,
     /* 1879218 */   // Label 25328: @1879218
     /* 1879218 */   GIM_Try, /*On fail goto*//*Label 25329*/ GIMT_Encode4(1879307), // Rule ID 14615 //
     /* 1879223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1879234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1879237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1879240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1879246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879269 */     // MIs[0] policy
     /* 1879269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879279 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1879282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1879300 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879306 */     // GIR_Coverage, 14615,
     /* 1879306 */     GIR_EraseRootFromParent_Done,
     /* 1879307 */   // Label 25329: @1879307
     /* 1879307 */   GIM_Try, /*On fail goto*//*Label 25330*/ GIMT_Encode4(1879396), // Rule ID 14618 //
     /* 1879312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1879323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1879326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1879329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879358 */     // MIs[0] policy
     /* 1879358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1879371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879391 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879394 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879395 */     // GIR_Coverage, 14618,
     /* 1879395 */     GIR_EraseRootFromParent_Done,
     /* 1879396 */   // Label 25330: @1879396
     /* 1879396 */   GIM_Try, /*On fail goto*//*Label 25331*/ GIMT_Encode4(1879485), // Rule ID 14619 //
     /* 1879401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1879412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1879415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1879418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1879424 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879447 */     // MIs[0] policy
     /* 1879447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879457 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1879460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879478 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879480 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879484 */     // GIR_Coverage, 14619,
     /* 1879484 */     GIR_EraseRootFromParent_Done,
     /* 1879485 */   // Label 25331: @1879485
     /* 1879485 */   GIM_Try, /*On fail goto*//*Label 25332*/ GIMT_Encode4(1879574), // Rule ID 14622 //
     /* 1879490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1879501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1879504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1879507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879536 */     // MIs[0] policy
     /* 1879536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879546 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1879549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879572 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879573 */     // GIR_Coverage, 14622,
     /* 1879573 */     GIR_EraseRootFromParent_Done,
     /* 1879574 */   // Label 25332: @1879574
     /* 1879574 */   GIM_Try, /*On fail goto*//*Label 25333*/ GIMT_Encode4(1879663), // Rule ID 14623 //
     /* 1879579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1879590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1879593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1879596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1879602 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1879609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1879617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879625 */     // MIs[0] policy
     /* 1879625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879635 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1879638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879656 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879658 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879662 */     // GIR_Coverage, 14623,
     /* 1879662 */     GIR_EraseRootFromParent_Done,
     /* 1879663 */   // Label 25333: @1879663
     /* 1879663 */   GIM_Try, /*On fail goto*//*Label 25334*/ GIMT_Encode4(1879752), // Rule ID 14626 //
     /* 1879668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1879671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1879679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1879682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1879685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879714 */     // MIs[0] policy
     /* 1879714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879724 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1879727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879750 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879751 */     // GIR_Coverage, 14626,
     /* 1879751 */     GIR_EraseRootFromParent_Done,
     /* 1879752 */   // Label 25334: @1879752
     /* 1879752 */   GIM_Try, /*On fail goto*//*Label 25335*/ GIMT_Encode4(1879841), // Rule ID 14627 //
     /* 1879757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1879760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1879768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1879771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1879774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1879780 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1879787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1879795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879803 */     // MIs[0] policy
     /* 1879803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879813 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1879816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1879834 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879840 */     // GIR_Coverage, 14627,
     /* 1879840 */     GIR_EraseRootFromParent_Done,
     /* 1879841 */   // Label 25335: @1879841
     /* 1879841 */   GIM_Try, /*On fail goto*//*Label 25336*/ GIMT_Encode4(1879930), // Rule ID 14630 //
     /* 1879846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1879849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1879866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1879872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879892 */     // MIs[0] policy
     /* 1879892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879902 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1879902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1879905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1879911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1879913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1879915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1879920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1879923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1879925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1879928 */     GIR_RootConstrainSelectedInstOperands,
     /* 1879929 */     // GIR_Coverage, 14630,
     /* 1879929 */     GIR_EraseRootFromParent_Done,
     /* 1879930 */   // Label 25336: @1879930
     /* 1879930 */   GIM_Try, /*On fail goto*//*Label 25337*/ GIMT_Encode4(1880019), // Rule ID 14631 //
     /* 1879935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1879938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1879943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1879946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1879949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1879952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1879955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1879958 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1879961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1879965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1879973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1879977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1879981 */     // MIs[0] policy
     /* 1879981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1879984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1879991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11551:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1879991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M2_MASK),
     /* 1879994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1879996 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1879998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880012 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880014 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880018 */     // GIR_Coverage, 14631,
     /* 1880018 */     GIR_EraseRootFromParent_Done,
     /* 1880019 */   // Label 25337: @1880019
     /* 1880019 */   GIM_Try, /*On fail goto*//*Label 25338*/ GIMT_Encode4(1880108), // Rule ID 14634 //
     /* 1880024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1880035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1880038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1880041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1880054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880070 */     // MIs[0] policy
     /* 1880070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880080 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1880083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880103 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880107 */     // GIR_Coverage, 14634,
     /* 1880107 */     GIR_EraseRootFromParent_Done,
     /* 1880108 */   // Label 25338: @1880108
     /* 1880108 */   GIM_Try, /*On fail goto*//*Label 25339*/ GIMT_Encode4(1880197), // Rule ID 14635 //
     /* 1880113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1880124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1880127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1880130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880136 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1880143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1880151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880159 */     // MIs[0] policy
     /* 1880159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880169 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11551:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M4_MASK),
     /* 1880172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880190 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880192 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880196 */     // GIR_Coverage, 14635,
     /* 1880196 */     GIR_EraseRootFromParent_Done,
     /* 1880197 */   // Label 25339: @1880197
     /* 1880197 */   GIM_Try, /*On fail goto*//*Label 25340*/ GIMT_Encode4(1880286), // Rule ID 14638 //
     /* 1880202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1880205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1880213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1880216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1880219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1880222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880248 */     // MIs[0] policy
     /* 1880248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1880261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880281 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880285 */     // GIR_Coverage, 14638,
     /* 1880285 */     GIR_EraseRootFromParent_Done,
     /* 1880286 */   // Label 25340: @1880286
     /* 1880286 */   GIM_Try, /*On fail goto*//*Label 25341*/ GIMT_Encode4(1880375), // Rule ID 14639 //
     /* 1880291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1880294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssubu_mask),
     /* 1880299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1880302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1880305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1880308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1880311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1880314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1880321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1880329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1880333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880337 */     // MIs[0] policy
     /* 1880337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880347 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11551:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VX_M8_MASK),
     /* 1880350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1880368 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880370 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880374 */     // GIR_Coverage, 14639,
     /* 1880374 */     GIR_EraseRootFromParent_Done,
     /* 1880375 */   // Label 25341: @1880375
     /* 1880375 */   GIM_Try, /*On fail goto*//*Label 25342*/ GIMT_Encode4(1880464), // Rule ID 14642 //
     /* 1880380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1880391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1880394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1880400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880426 */     // MIs[0] policy
     /* 1880426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1880439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880463 */     // GIR_Coverage, 14642,
     /* 1880463 */     GIR_EraseRootFromParent_Done,
     /* 1880464 */   // Label 25342: @1880464
     /* 1880464 */   GIM_Try, /*On fail goto*//*Label 25343*/ GIMT_Encode4(1880553), // Rule ID 14643 //
     /* 1880469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1880480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1880483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1880486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1880489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880492 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880515 */     // MIs[0] policy
     /* 1880515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880525 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8_MASK),
     /* 1880528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880546 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880548 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880552 */     // GIR_Coverage, 14643,
     /* 1880552 */     GIR_EraseRootFromParent_Done,
     /* 1880553 */   // Label 25343: @1880553
     /* 1880553 */   GIM_Try, /*On fail goto*//*Label 25344*/ GIMT_Encode4(1880642), // Rule ID 14646 //
     /* 1880558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1880569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1880572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1880575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1880578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880604 */     // MIs[0] policy
     /* 1880604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1880617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880637 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880641 */     // GIR_Coverage, 14646,
     /* 1880641 */     GIR_EraseRootFromParent_Done,
     /* 1880642 */   // Label 25344: @1880642
     /* 1880642 */   GIM_Try, /*On fail goto*//*Label 25345*/ GIMT_Encode4(1880731), // Rule ID 14647 //
     /* 1880647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1880658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1880661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1880664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1880667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1880670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880693 */     // MIs[0] policy
     /* 1880693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880703 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1880706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880724 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880730 */     // GIR_Coverage, 14647,
     /* 1880730 */     GIR_EraseRootFromParent_Done,
     /* 1880731 */   // Label 25345: @1880731
     /* 1880731 */   GIM_Try, /*On fail goto*//*Label 25346*/ GIMT_Encode4(1880820), // Rule ID 14650 //
     /* 1880736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880782 */     // MIs[0] policy
     /* 1880782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1880795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880819 */     // GIR_Coverage, 14650,
     /* 1880819 */     GIR_EraseRootFromParent_Done,
     /* 1880820 */   // Label 25346: @1880820
     /* 1880820 */   GIM_Try, /*On fail goto*//*Label 25347*/ GIMT_Encode4(1880909), // Rule ID 14651 //
     /* 1880825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1880828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1880836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1880839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1880842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1880845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1880848 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1880851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880871 */     // MIs[0] policy
     /* 1880871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880881 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1880881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1880884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1880902 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880908 */     // GIR_Coverage, 14651,
     /* 1880908 */     GIR_EraseRootFromParent_Done,
     /* 1880909 */   // Label 25347: @1880909
     /* 1880909 */   GIM_Try, /*On fail goto*//*Label 25348*/ GIMT_Encode4(1880998), // Rule ID 14654 //
     /* 1880914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1880917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1880922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1880925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1880928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1880931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1880934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1880937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1880940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1880944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1880956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1880960 */     // MIs[0] policy
     /* 1880960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1880963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1880970 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1880970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1880973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1880975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1880977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1880979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1880981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1880983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1880988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1880991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1880993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1880996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1880997 */     // GIR_Coverage, 14654,
     /* 1880997 */     GIR_EraseRootFromParent_Done,
     /* 1880998 */   // Label 25348: @1880998
     /* 1880998 */   GIM_Try, /*On fail goto*//*Label 25349*/ GIMT_Encode4(1881087), // Rule ID 14655 //
     /* 1881003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1881014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1881017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1881020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1881023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881026 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881049 */     // MIs[0] policy
     /* 1881049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881059 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4_MASK),
     /* 1881062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881080 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881086 */     // GIR_Coverage, 14655,
     /* 1881086 */     GIR_EraseRootFromParent_Done,
     /* 1881087 */   // Label 25349: @1881087
     /* 1881087 */   GIM_Try, /*On fail goto*//*Label 25350*/ GIMT_Encode4(1881176), // Rule ID 14658 //
     /* 1881092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1881103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1881106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1881109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1881112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881138 */     // MIs[0] policy
     /* 1881138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881148 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1881151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881175 */     // GIR_Coverage, 14658,
     /* 1881175 */     GIR_EraseRootFromParent_Done,
     /* 1881176 */   // Label 25350: @1881176
     /* 1881176 */   GIM_Try, /*On fail goto*//*Label 25351*/ GIMT_Encode4(1881265), // Rule ID 14659 //
     /* 1881181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1881192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1881195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1881198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1881201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881204 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881227 */     // MIs[0] policy
     /* 1881227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881237 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1881240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881258 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881260 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881264 */     // GIR_Coverage, 14659,
     /* 1881264 */     GIR_EraseRootFromParent_Done,
     /* 1881265 */   // Label 25351: @1881265
     /* 1881265 */   GIM_Try, /*On fail goto*//*Label 25352*/ GIMT_Encode4(1881354), // Rule ID 14662 //
     /* 1881270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1881281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1881284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1881287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1881290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881316 */     // MIs[0] policy
     /* 1881316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881326 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1881329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881353 */     // GIR_Coverage, 14662,
     /* 1881353 */     GIR_EraseRootFromParent_Done,
     /* 1881354 */   // Label 25352: @1881354
     /* 1881354 */   GIM_Try, /*On fail goto*//*Label 25353*/ GIMT_Encode4(1881443), // Rule ID 14663 //
     /* 1881359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1881370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1881373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1881376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1881379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1881382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881405 */     // MIs[0] policy
     /* 1881405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881415 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2_MASK),
     /* 1881418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881436 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881442 */     // GIR_Coverage, 14663,
     /* 1881442 */     GIR_EraseRootFromParent_Done,
     /* 1881443 */   // Label 25353: @1881443
     /* 1881443 */   GIM_Try, /*On fail goto*//*Label 25354*/ GIMT_Encode4(1881532), // Rule ID 14666 //
     /* 1881448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1881468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881494 */     // MIs[0] policy
     /* 1881494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881504 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881531 */     // GIR_Coverage, 14666,
     /* 1881531 */     GIR_EraseRootFromParent_Done,
     /* 1881532 */   // Label 25354: @1881532
     /* 1881532 */   GIM_Try, /*On fail goto*//*Label 25355*/ GIMT_Encode4(1881621), // Rule ID 14667 //
     /* 1881537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1881548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1881551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1881554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1881557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1881560 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881583 */     // MIs[0] policy
     /* 1881583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881593 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1881614 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881616 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881620 */     // GIR_Coverage, 14667,
     /* 1881620 */     GIR_EraseRootFromParent_Done,
     /* 1881621 */   // Label 25355: @1881621
     /* 1881621 */   GIM_Try, /*On fail goto*//*Label 25356*/ GIMT_Encode4(1881710), // Rule ID 14670 //
     /* 1881626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1881637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1881640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1881643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1881646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881672 */     // MIs[0] policy
     /* 1881672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881682 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881709 */     // GIR_Coverage, 14670,
     /* 1881709 */     GIR_EraseRootFromParent_Done,
     /* 1881710 */   // Label 25356: @1881710
     /* 1881710 */   GIM_Try, /*On fail goto*//*Label 25357*/ GIMT_Encode4(1881799), // Rule ID 14671 //
     /* 1881715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1881726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1881729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1881732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1881735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1881738 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881761 */     // MIs[0] policy
     /* 1881761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881771 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1881792 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881794 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881798 */     // GIR_Coverage, 14671,
     /* 1881798 */     GIR_EraseRootFromParent_Done,
     /* 1881799 */   // Label 25357: @1881799
     /* 1881799 */   GIM_Try, /*On fail goto*//*Label 25358*/ GIMT_Encode4(1881888), // Rule ID 14674 //
     /* 1881804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1881807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1881830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881850 */     // MIs[0] policy
     /* 1881850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881860 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1881860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881887 */     // GIR_Coverage, 14674,
     /* 1881887 */     GIR_EraseRootFromParent_Done,
     /* 1881888 */   // Label 25358: @1881888
     /* 1881888 */   GIM_Try, /*On fail goto*//*Label 25359*/ GIMT_Encode4(1881977), // Rule ID 14675 //
     /* 1881893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1881896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1881904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1881907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1881910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1881913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1881916 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1881919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1881923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1881935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1881939 */     // MIs[0] policy
     /* 1881939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1881942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1881949 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1881949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1881952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1881954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1881956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1881958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1881960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1881962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1881967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1881970 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1881972 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1881975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1881976 */     // GIR_Coverage, 14675,
     /* 1881976 */     GIR_EraseRootFromParent_Done,
     /* 1881977 */   // Label 25359: @1881977
     /* 1881977 */   GIM_Try, /*On fail goto*//*Label 25360*/ GIMT_Encode4(1882066), // Rule ID 14678 //
     /* 1881982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1881985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1881990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1881993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1881996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1881999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1882002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1882005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882028 */     // MIs[0] policy
     /* 1882028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882038 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1882041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882061 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882065 */     // GIR_Coverage, 14678,
     /* 1882065 */     GIR_EraseRootFromParent_Done,
     /* 1882066 */   // Label 25360: @1882066
     /* 1882066 */   GIM_Try, /*On fail goto*//*Label 25361*/ GIMT_Encode4(1882155), // Rule ID 14679 //
     /* 1882071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1882074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1882082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1882085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1882088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1882091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1882094 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1882101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1882113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882117 */     // MIs[0] policy
     /* 1882117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882127 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1_MASK),
     /* 1882130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1882148 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882150 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882154 */     // GIR_Coverage, 14679,
     /* 1882154 */     GIR_EraseRootFromParent_Done,
     /* 1882155 */   // Label 25361: @1882155
     /* 1882155 */   GIM_Try, /*On fail goto*//*Label 25362*/ GIMT_Encode4(1882244), // Rule ID 14682 //
     /* 1882160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1882171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1882174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1882177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1882180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882206 */     // MIs[0] policy
     /* 1882206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882216 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1882219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882239 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882243 */     // GIR_Coverage, 14682,
     /* 1882243 */     GIR_EraseRootFromParent_Done,
     /* 1882244 */   // Label 25362: @1882244
     /* 1882244 */   GIM_Try, /*On fail goto*//*Label 25363*/ GIMT_Encode4(1882333), // Rule ID 14683 //
     /* 1882249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1882260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1882263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1882266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1882269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882272 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882295 */     // MIs[0] policy
     /* 1882295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882305 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1882308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882326 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882328 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882332 */     // GIR_Coverage, 14683,
     /* 1882332 */     GIR_EraseRootFromParent_Done,
     /* 1882333 */   // Label 25363: @1882333
     /* 1882333 */   GIM_Try, /*On fail goto*//*Label 25364*/ GIMT_Encode4(1882422), // Rule ID 14686 //
     /* 1882338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1882349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1882352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1882355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1882358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882384 */     // MIs[0] policy
     /* 1882384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882394 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1882397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882417 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882421 */     // GIR_Coverage, 14686,
     /* 1882421 */     GIR_EraseRootFromParent_Done,
     /* 1882422 */   // Label 25364: @1882422
     /* 1882422 */   GIM_Try, /*On fail goto*//*Label 25365*/ GIMT_Encode4(1882511), // Rule ID 14687 //
     /* 1882427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1882438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1882441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1882444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1882447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1882450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882473 */     // MIs[0] policy
     /* 1882473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882483 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1882486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882504 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882506 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882510 */     // GIR_Coverage, 14687,
     /* 1882510 */     GIR_EraseRootFromParent_Done,
     /* 1882511 */   // Label 25365: @1882511
     /* 1882511 */   GIM_Try, /*On fail goto*//*Label 25366*/ GIMT_Encode4(1882600), // Rule ID 14690 //
     /* 1882516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1882527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1882530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1882533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1882536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1882539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882562 */     // MIs[0] policy
     /* 1882562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882572 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1882575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882599 */     // GIR_Coverage, 14690,
     /* 1882599 */     GIR_EraseRootFromParent_Done,
     /* 1882600 */   // Label 25366: @1882600
     /* 1882600 */   GIM_Try, /*On fail goto*//*Label 25367*/ GIMT_Encode4(1882689), // Rule ID 14691 //
     /* 1882605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1882616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1882619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1882622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1882625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1882628 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1882635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1882647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882651 */     // MIs[0] policy
     /* 1882651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882661 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1882664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1882682 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882688 */     // GIR_Coverage, 14691,
     /* 1882688 */     GIR_EraseRootFromParent_Done,
     /* 1882689 */   // Label 25367: @1882689
     /* 1882689 */   GIM_Try, /*On fail goto*//*Label 25368*/ GIMT_Encode4(1882778), // Rule ID 14694 //
     /* 1882694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882740 */     // MIs[0] policy
     /* 1882740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882750 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1882753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882777 */     // GIR_Coverage, 14694,
     /* 1882777 */     GIR_EraseRootFromParent_Done,
     /* 1882778 */   // Label 25368: @1882778
     /* 1882778 */   GIM_Try, /*On fail goto*//*Label 25369*/ GIMT_Encode4(1882867), // Rule ID 14695 //
     /* 1882783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1882794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1882797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1882800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1882803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1882806 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1882813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1882825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882829 */     // MIs[0] policy
     /* 1882829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882839 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1882839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1882842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882860 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882866 */     // GIR_Coverage, 14695,
     /* 1882866 */     GIR_EraseRootFromParent_Done,
     /* 1882867 */   // Label 25369: @1882867
     /* 1882867 */   GIM_Try, /*On fail goto*//*Label 25370*/ GIMT_Encode4(1882956), // Rule ID 14698 //
     /* 1882872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1882875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1882898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1882918 */     // MIs[0] policy
     /* 1882918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1882921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1882928 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1882928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1882931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1882933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1882935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1882937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1882939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1882941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1882946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1882949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1882951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1882954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1882955 */     // GIR_Coverage, 14698,
     /* 1882955 */     GIR_EraseRootFromParent_Done,
     /* 1882956 */   // Label 25370: @1882956
     /* 1882956 */   GIM_Try, /*On fail goto*//*Label 25371*/ GIMT_Encode4(1883045), // Rule ID 14699 //
     /* 1882961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1882964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1882969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1882972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1882975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1882978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1882981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1882984 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1882987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1882991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1882999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883007 */     // MIs[0] policy
     /* 1883007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883017 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1883020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883038 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883044 */     // GIR_Coverage, 14699,
     /* 1883044 */     GIR_EraseRootFromParent_Done,
     /* 1883045 */   // Label 25371: @1883045
     /* 1883045 */   GIM_Try, /*On fail goto*//*Label 25372*/ GIMT_Encode4(1883134), // Rule ID 14702 //
     /* 1883050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1883061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1883064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1883067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1883070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1883073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883096 */     // MIs[0] policy
     /* 1883096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883106 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1883109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883129 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883133 */     // GIR_Coverage, 14702,
     /* 1883133 */     GIR_EraseRootFromParent_Done,
     /* 1883134 */   // Label 25372: @1883134
     /* 1883134 */   GIM_Try, /*On fail goto*//*Label 25373*/ GIMT_Encode4(1883223), // Rule ID 14703 //
     /* 1883139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1883150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1883153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1883156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1883159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1883162 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883185 */     // MIs[0] policy
     /* 1883185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883195 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1883198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1883216 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883218 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883222 */     // GIR_Coverage, 14703,
     /* 1883222 */     GIR_EraseRootFromParent_Done,
     /* 1883223 */   // Label 25373: @1883223
     /* 1883223 */   GIM_Try, /*On fail goto*//*Label 25374*/ GIMT_Encode4(1883312), // Rule ID 14706 //
     /* 1883228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1883239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1883242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1883245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1883248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883274 */     // MIs[0] policy
     /* 1883274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883284 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1883287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883307 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883311 */     // GIR_Coverage, 14706,
     /* 1883311 */     GIR_EraseRootFromParent_Done,
     /* 1883312 */   // Label 25374: @1883312
     /* 1883312 */   GIM_Try, /*On fail goto*//*Label 25375*/ GIMT_Encode4(1883401), // Rule ID 14707 //
     /* 1883317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1883328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1883331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1883334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1883337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883363 */     // MIs[0] policy
     /* 1883363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1883376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883394 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883400 */     // GIR_Coverage, 14707,
     /* 1883400 */     GIR_EraseRootFromParent_Done,
     /* 1883401 */   // Label 25375: @1883401
     /* 1883401 */   GIM_Try, /*On fail goto*//*Label 25376*/ GIMT_Encode4(1883490), // Rule ID 14710 //
     /* 1883406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1883417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1883420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1883423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1883426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883452 */     // MIs[0] policy
     /* 1883452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883462 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1883465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883485 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883489 */     // GIR_Coverage, 14710,
     /* 1883489 */     GIR_EraseRootFromParent_Done,
     /* 1883490 */   // Label 25376: @1883490
     /* 1883490 */   GIM_Try, /*On fail goto*//*Label 25377*/ GIMT_Encode4(1883579), // Rule ID 14711 //
     /* 1883495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1883506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1883509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1883512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1883515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1883518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883541 */     // MIs[0] policy
     /* 1883541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883551 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1883554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883572 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883574 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883578 */     // GIR_Coverage, 14711,
     /* 1883578 */     GIR_EraseRootFromParent_Done,
     /* 1883579 */   // Label 25377: @1883579
     /* 1883579 */   GIM_Try, /*On fail goto*//*Label 25378*/ GIMT_Encode4(1883668), // Rule ID 14714 //
     /* 1883584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1883587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1883595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1883598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1883601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1883604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883630 */     // MIs[0] policy
     /* 1883630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883640 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1883643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883667 */     // GIR_Coverage, 14714,
     /* 1883667 */     GIR_EraseRootFromParent_Done,
     /* 1883668 */   // Label 25378: @1883668
     /* 1883668 */   GIM_Try, /*On fail goto*//*Label 25379*/ GIMT_Encode4(1883757), // Rule ID 14715 //
     /* 1883673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1883676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1883684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1883687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1883690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1883693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1883696 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1883703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1883715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883719 */     // MIs[0] policy
     /* 1883719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883729 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1883732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1883750 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883756 */     // GIR_Coverage, 14715,
     /* 1883756 */     GIR_EraseRootFromParent_Done,
     /* 1883757 */   // Label 25379: @1883757
     /* 1883757 */   GIM_Try, /*On fail goto*//*Label 25380*/ GIMT_Encode4(1883846), // Rule ID 14718 //
     /* 1883762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883808 */     // MIs[0] policy
     /* 1883808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883818 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1883821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883845 */     // GIR_Coverage, 14718,
     /* 1883845 */     GIR_EraseRootFromParent_Done,
     /* 1883846 */   // Label 25380: @1883846
     /* 1883846 */   GIM_Try, /*On fail goto*//*Label 25381*/ GIMT_Encode4(1883935), // Rule ID 14719 //
     /* 1883851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1883854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1883862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1883865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1883868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1883871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1883874 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1883877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1883881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1883893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883897 */     // MIs[0] policy
     /* 1883897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1883907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2_MASK),
     /* 1883910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1883912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1883914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1883916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1883918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1883920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1883925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1883928 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1883930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1883933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1883934 */     // GIR_Coverage, 14719,
     /* 1883934 */     GIR_EraseRootFromParent_Done,
     /* 1883935 */   // Label 25381: @1883935
     /* 1883935 */   GIM_Try, /*On fail goto*//*Label 25382*/ GIMT_Encode4(1884024), // Rule ID 14722 //
     /* 1883940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1883943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1883948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1883951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1883954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1883957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1883960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1883963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1883966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1883970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1883982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1883986 */     // MIs[0] policy
     /* 1883986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1883989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1883996 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1883996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1883999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884023 */     // GIR_Coverage, 14722,
     /* 1884023 */     GIR_EraseRootFromParent_Done,
     /* 1884024 */   // Label 25382: @1884024
     /* 1884024 */   GIM_Try, /*On fail goto*//*Label 25383*/ GIMT_Encode4(1884113), // Rule ID 14723 //
     /* 1884029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1884040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1884043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1884046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1884049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1884059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1884071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884075 */     // MIs[0] policy
     /* 1884075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884085 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4_MASK),
     /* 1884088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884106 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884108 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884112 */     // GIR_Coverage, 14723,
     /* 1884112 */     GIR_EraseRootFromParent_Done,
     /* 1884113 */   // Label 25383: @1884113
     /* 1884113 */   GIM_Try, /*On fail goto*//*Label 25384*/ GIMT_Encode4(1884202), // Rule ID 14726 //
     /* 1884118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1884121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1884129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1884132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1884135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1884138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884164 */     // MIs[0] policy
     /* 1884164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884174 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1884177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884197 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884201 */     // GIR_Coverage, 14726,
     /* 1884201 */     GIR_EraseRootFromParent_Done,
     /* 1884202 */   // Label 25384: @1884202
     /* 1884202 */   GIM_Try, /*On fail goto*//*Label 25385*/ GIMT_Encode4(1884291), // Rule ID 14727 //
     /* 1884207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1884210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1884218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1884221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1884224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1884227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1884230 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1884237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1884249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884253 */     // MIs[0] policy
     /* 1884253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884263 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8_MASK),
     /* 1884266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884268 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1884284 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884286 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884290 */     // GIR_Coverage, 14727,
     /* 1884290 */     GIR_EraseRootFromParent_Done,
     /* 1884291 */   // Label 25385: @1884291
     /* 1884291 */   GIM_Try, /*On fail goto*//*Label 25386*/ GIMT_Encode4(1884380), // Rule ID 14730 //
     /* 1884296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1884307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1884310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1884313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884342 */     // MIs[0] policy
     /* 1884342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884352 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1884355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884379 */     // GIR_Coverage, 14730,
     /* 1884379 */     GIR_EraseRootFromParent_Done,
     /* 1884380 */   // Label 25386: @1884380
     /* 1884380 */   GIM_Try, /*On fail goto*//*Label 25387*/ GIMT_Encode4(1884469), // Rule ID 14731 //
     /* 1884385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1884396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1884399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1884402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884408 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884431 */     // MIs[0] policy
     /* 1884431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884441 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF8_MASK),
     /* 1884444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884446 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884462 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884464 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884468 */     // GIR_Coverage, 14731,
     /* 1884468 */     GIR_EraseRootFromParent_Done,
     /* 1884469 */   // Label 25387: @1884469
     /* 1884469 */   GIM_Try, /*On fail goto*//*Label 25388*/ GIMT_Encode4(1884558), // Rule ID 14734 //
     /* 1884474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1884485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1884488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1884491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884520 */     // MIs[0] policy
     /* 1884520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884530 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1884533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884557 */     // GIR_Coverage, 14734,
     /* 1884557 */     GIR_EraseRootFromParent_Done,
     /* 1884558 */   // Label 25388: @1884558
     /* 1884558 */   GIM_Try, /*On fail goto*//*Label 25389*/ GIMT_Encode4(1884647), // Rule ID 14735 //
     /* 1884563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1884574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1884577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1884580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1884586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884609 */     // MIs[0] policy
     /* 1884609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884619 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1884622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884640 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884646 */     // GIR_Coverage, 14735,
     /* 1884646 */     GIR_EraseRootFromParent_Done,
     /* 1884647 */   // Label 25389: @1884647
     /* 1884647 */   GIM_Try, /*On fail goto*//*Label 25390*/ GIMT_Encode4(1884736), // Rule ID 14738 //
     /* 1884652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1884663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1884666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1884669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884698 */     // MIs[0] policy
     /* 1884698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884708 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1884711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884735 */     // GIR_Coverage, 14738,
     /* 1884735 */     GIR_EraseRootFromParent_Done,
     /* 1884736 */   // Label 25390: @1884736
     /* 1884736 */   GIM_Try, /*On fail goto*//*Label 25391*/ GIMT_Encode4(1884825), // Rule ID 14739 //
     /* 1884741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1884752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1884755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1884758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1884764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884787 */     // MIs[0] policy
     /* 1884787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884797 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1884800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1884818 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884824 */     // GIR_Coverage, 14739,
     /* 1884824 */     GIR_EraseRootFromParent_Done,
     /* 1884825 */   // Label 25391: @1884825
     /* 1884825 */   GIM_Try, /*On fail goto*//*Label 25392*/ GIMT_Encode4(1884914), // Rule ID 14742 //
     /* 1884830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1884833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1884850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1884856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884876 */     // MIs[0] policy
     /* 1884876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884886 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1884886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1884889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1884912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1884913 */     // GIR_Coverage, 14742,
     /* 1884913 */     GIR_EraseRootFromParent_Done,
     /* 1884914 */   // Label 25392: @1884914
     /* 1884914 */   GIM_Try, /*On fail goto*//*Label 25393*/ GIMT_Encode4(1885003), // Rule ID 14743 //
     /* 1884919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1884922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1884927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1884930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1884933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1884936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1884939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1884942 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1884945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1884949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1884957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1884961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1884965 */     // MIs[0] policy
     /* 1884965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1884968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1884975 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1884975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF4_MASK),
     /* 1884978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1884980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1884982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1884984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1884986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1884988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1884993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1884996 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1884998 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885002 */     // GIR_Coverage, 14743,
     /* 1885002 */     GIR_EraseRootFromParent_Done,
     /* 1885003 */   // Label 25393: @1885003
     /* 1885003 */   GIM_Try, /*On fail goto*//*Label 25394*/ GIMT_Encode4(1885092), // Rule ID 14746 //
     /* 1885008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1885019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1885022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1885025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885054 */     // MIs[0] policy
     /* 1885054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885064 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1885067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885090 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885091 */     // GIR_Coverage, 14746,
     /* 1885091 */     GIR_EraseRootFromParent_Done,
     /* 1885092 */   // Label 25394: @1885092
     /* 1885092 */   GIM_Try, /*On fail goto*//*Label 25395*/ GIMT_Encode4(1885181), // Rule ID 14747 //
     /* 1885097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1885108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1885111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1885114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885120 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885143 */     // MIs[0] policy
     /* 1885143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885153 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1885156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885174 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885176 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885180 */     // GIR_Coverage, 14747,
     /* 1885180 */     GIR_EraseRootFromParent_Done,
     /* 1885181 */   // Label 25395: @1885181
     /* 1885181 */   GIM_Try, /*On fail goto*//*Label 25396*/ GIMT_Encode4(1885270), // Rule ID 14750 //
     /* 1885186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1885197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1885200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1885203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885232 */     // MIs[0] policy
     /* 1885232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1885245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885265 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885268 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885269 */     // GIR_Coverage, 14750,
     /* 1885269 */     GIR_EraseRootFromParent_Done,
     /* 1885270 */   // Label 25396: @1885270
     /* 1885270 */   GIM_Try, /*On fail goto*//*Label 25397*/ GIMT_Encode4(1885359), // Rule ID 14751 //
     /* 1885275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1885286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1885289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1885292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885298 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885321 */     // MIs[0] policy
     /* 1885321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885331 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_MF2_MASK),
     /* 1885334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885352 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885354 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885358 */     // GIR_Coverage, 14751,
     /* 1885358 */     GIR_EraseRootFromParent_Done,
     /* 1885359 */   // Label 25397: @1885359
     /* 1885359 */   GIM_Try, /*On fail goto*//*Label 25398*/ GIMT_Encode4(1885448), // Rule ID 14754 //
     /* 1885364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1885375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1885378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1885381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885410 */     // MIs[0] policy
     /* 1885410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885420 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885443 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885446 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885447 */     // GIR_Coverage, 14754,
     /* 1885447 */     GIR_EraseRootFromParent_Done,
     /* 1885448 */   // Label 25398: @1885448
     /* 1885448 */   GIM_Try, /*On fail goto*//*Label 25399*/ GIMT_Encode4(1885537), // Rule ID 14755 //
     /* 1885453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1885464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1885467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1885470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1885476 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885499 */     // MIs[0] policy
     /* 1885499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885509 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11549:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1885530 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885532 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885536 */     // GIR_Coverage, 14755,
     /* 1885536 */     GIR_EraseRootFromParent_Done,
     /* 1885537 */   // Label 25399: @1885537
     /* 1885537 */   GIM_Try, /*On fail goto*//*Label 25400*/ GIMT_Encode4(1885626), // Rule ID 14758 //
     /* 1885542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1885553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1885556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1885559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885588 */     // MIs[0] policy
     /* 1885588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885624 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885625 */     // GIR_Coverage, 14758,
     /* 1885625 */     GIR_EraseRootFromParent_Done,
     /* 1885626 */   // Label 25400: @1885626
     /* 1885626 */   GIM_Try, /*On fail goto*//*Label 25401*/ GIMT_Encode4(1885715), // Rule ID 14759 //
     /* 1885631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1885642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1885645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1885648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1885654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885677 */     // MIs[0] policy
     /* 1885677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885687 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11549:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1885708 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885710 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885714 */     // GIR_Coverage, 14759,
     /* 1885714 */     GIR_EraseRootFromParent_Done,
     /* 1885715 */   // Label 25401: @1885715
     /* 1885715 */   GIM_Try, /*On fail goto*//*Label 25402*/ GIMT_Encode4(1885804), // Rule ID 14762 //
     /* 1885720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1885723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885766 */     // MIs[0] policy
     /* 1885766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885776 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885802 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885803 */     // GIR_Coverage, 14762,
     /* 1885803 */     GIR_EraseRootFromParent_Done,
     /* 1885804 */   // Label 25402: @1885804
     /* 1885804 */   GIM_Try, /*On fail goto*//*Label 25403*/ GIMT_Encode4(1885893), // Rule ID 14763 //
     /* 1885809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1885812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1885820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1885823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1885826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1885829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1885832 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1885835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885855 */     // MIs[0] policy
     /* 1885855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885865 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11549:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1885865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1885886 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885892 */     // GIR_Coverage, 14763,
     /* 1885892 */     GIR_EraseRootFromParent_Done,
     /* 1885893 */   // Label 25403: @1885893
     /* 1885893 */   GIM_Try, /*On fail goto*//*Label 25404*/ GIMT_Encode4(1885982), // Rule ID 14766 //
     /* 1885898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1885901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1885912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1885915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1885918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1885921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1885924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1885928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1885936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1885940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1885944 */     // MIs[0] policy
     /* 1885944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1885947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1885954 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1885954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1885957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1885959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1885961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1885963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1885965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1885967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1885972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1885975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1885977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1885980 */     GIR_RootConstrainSelectedInstOperands,
     /* 1885981 */     // GIR_Coverage, 14766,
     /* 1885981 */     GIR_EraseRootFromParent_Done,
     /* 1885982 */   // Label 25404: @1885982
     /* 1885982 */   GIM_Try, /*On fail goto*//*Label 25405*/ GIMT_Encode4(1886071), // Rule ID 14767 //
     /* 1885987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1885990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1885995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1885998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1886001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1886004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1886010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1886017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1886025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886033 */     // MIs[0] policy
     /* 1886033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886043 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11549:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M1_MASK),
     /* 1886046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1886064 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886070 */     // GIR_Coverage, 14767,
     /* 1886070 */     GIR_EraseRootFromParent_Done,
     /* 1886071 */   // Label 25405: @1886071
     /* 1886071 */   GIM_Try, /*On fail goto*//*Label 25406*/ GIMT_Encode4(1886160), // Rule ID 14770 //
     /* 1886076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1886087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1886090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1886093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886122 */     // MIs[0] policy
     /* 1886122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1886135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886158 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886159 */     // GIR_Coverage, 14770,
     /* 1886159 */     GIR_EraseRootFromParent_Done,
     /* 1886160 */   // Label 25406: @1886160
     /* 1886160 */   GIM_Try, /*On fail goto*//*Label 25407*/ GIMT_Encode4(1886249), // Rule ID 14771 //
     /* 1886165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1886176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1886179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1886182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886188 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886211 */     // MIs[0] policy
     /* 1886211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886221 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1886224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886242 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886248 */     // GIR_Coverage, 14771,
     /* 1886248 */     GIR_EraseRootFromParent_Done,
     /* 1886249 */   // Label 25407: @1886249
     /* 1886249 */   GIM_Try, /*On fail goto*//*Label 25408*/ GIMT_Encode4(1886338), // Rule ID 14774 //
     /* 1886254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1886265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1886268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1886271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886300 */     // MIs[0] policy
     /* 1886300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886310 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1886313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886333 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886336 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886337 */     // GIR_Coverage, 14774,
     /* 1886337 */     GIR_EraseRootFromParent_Done,
     /* 1886338 */   // Label 25408: @1886338
     /* 1886338 */   GIM_Try, /*On fail goto*//*Label 25409*/ GIMT_Encode4(1886427), // Rule ID 14775 //
     /* 1886343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1886354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1886357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1886360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886366 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886389 */     // MIs[0] policy
     /* 1886389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886399 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1886402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886420 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886422 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886426 */     // GIR_Coverage, 14775,
     /* 1886426 */     GIR_EraseRootFromParent_Done,
     /* 1886427 */   // Label 25409: @1886427
     /* 1886427 */   GIM_Try, /*On fail goto*//*Label 25410*/ GIMT_Encode4(1886516), // Rule ID 14778 //
     /* 1886432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1886443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1886446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1886449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1886455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886478 */     // MIs[0] policy
     /* 1886478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886488 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1886491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886511 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886514 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886515 */     // GIR_Coverage, 14778,
     /* 1886515 */     GIR_EraseRootFromParent_Done,
     /* 1886516 */   // Label 25410: @1886516
     /* 1886516 */   GIM_Try, /*On fail goto*//*Label 25411*/ GIMT_Encode4(1886605), // Rule ID 14779 //
     /* 1886521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1886532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1886535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1886538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1886544 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1886559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886567 */     // MIs[0] policy
     /* 1886567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886577 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1886580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1886598 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886600 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886604 */     // GIR_Coverage, 14779,
     /* 1886604 */     GIR_EraseRootFromParent_Done,
     /* 1886605 */   // Label 25411: @1886605
     /* 1886605 */   GIM_Try, /*On fail goto*//*Label 25412*/ GIMT_Encode4(1886694), // Rule ID 14782 //
     /* 1886610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1886621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1886624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1886627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886656 */     // MIs[0] policy
     /* 1886656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886666 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1886669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886692 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886693 */     // GIR_Coverage, 14782,
     /* 1886693 */     GIR_EraseRootFromParent_Done,
     /* 1886694 */   // Label 25412: @1886694
     /* 1886694 */   GIM_Try, /*On fail goto*//*Label 25413*/ GIMT_Encode4(1886783), // Rule ID 14783 //
     /* 1886699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1886710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1886713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1886716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1886722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1886729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1886737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886745 */     // MIs[0] policy
     /* 1886745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886755 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1886758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886776 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886778 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886782 */     // GIR_Coverage, 14783,
     /* 1886782 */     GIR_EraseRootFromParent_Done,
     /* 1886783 */   // Label 25413: @1886783
     /* 1886783 */   GIM_Try, /*On fail goto*//*Label 25414*/ GIMT_Encode4(1886872), // Rule ID 14786 //
     /* 1886788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886834 */     // MIs[0] policy
     /* 1886834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886844 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1886844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1886847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886867 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886870 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886871 */     // GIR_Coverage, 14786,
     /* 1886871 */     GIR_EraseRootFromParent_Done,
     /* 1886872 */   // Label 25414: @1886872
     /* 1886872 */   GIM_Try, /*On fail goto*//*Label 25415*/ GIMT_Encode4(1886961), // Rule ID 14787 //
     /* 1886877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1886880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1886888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1886891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1886894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1886897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1886900 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1886903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1886907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1886915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1886919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1886923 */     // MIs[0] policy
     /* 1886923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1886926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1886933 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1886933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1886936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1886938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1886940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1886942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1886944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1886946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1886951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1886954 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1886956 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1886959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1886960 */     // GIR_Coverage, 14787,
     /* 1886960 */     GIR_EraseRootFromParent_Done,
     /* 1886961 */   // Label 25415: @1886961
     /* 1886961 */   GIM_Try, /*On fail goto*//*Label 25416*/ GIMT_Encode4(1887050), // Rule ID 14790 //
     /* 1886966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1886969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1886974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1886977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1886980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1886983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1886986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1886989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1886992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1886996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887012 */     // MIs[0] policy
     /* 1887012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1887025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887048 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887049 */     // GIR_Coverage, 14790,
     /* 1887049 */     GIR_EraseRootFromParent_Done,
     /* 1887050 */   // Label 25416: @1887050
     /* 1887050 */   GIM_Try, /*On fail goto*//*Label 25417*/ GIMT_Encode4(1887139), // Rule ID 14791 //
     /* 1887055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1887066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1887069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1887072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1887078 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887101 */     // MIs[0] policy
     /* 1887101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887111 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1887114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1887132 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887134 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887138 */     // GIR_Coverage, 14791,
     /* 1887138 */     GIR_EraseRootFromParent_Done,
     /* 1887139 */   // Label 25417: @1887139
     /* 1887139 */   GIM_Try, /*On fail goto*//*Label 25418*/ GIMT_Encode4(1887228), // Rule ID 14794 //
     /* 1887144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1887155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1887158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1887161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887190 */     // MIs[0] policy
     /* 1887190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1887203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887223 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887226 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887227 */     // GIR_Coverage, 14794,
     /* 1887227 */     GIR_EraseRootFromParent_Done,
     /* 1887228 */   // Label 25418: @1887228
     /* 1887228 */   GIM_Try, /*On fail goto*//*Label 25419*/ GIMT_Encode4(1887317), // Rule ID 14795 //
     /* 1887233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1887244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1887247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1887250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887256 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887279 */     // MIs[0] policy
     /* 1887279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887289 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1887292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887310 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887312 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887316 */     // GIR_Coverage, 14795,
     /* 1887316 */     GIR_EraseRootFromParent_Done,
     /* 1887317 */   // Label 25419: @1887317
     /* 1887317 */   GIM_Try, /*On fail goto*//*Label 25420*/ GIMT_Encode4(1887406), // Rule ID 14798 //
     /* 1887322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1887333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1887336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1887339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887368 */     // MIs[0] policy
     /* 1887368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887378 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1887381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887401 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887404 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887405 */     // GIR_Coverage, 14798,
     /* 1887405 */     GIR_EraseRootFromParent_Done,
     /* 1887406 */   // Label 25420: @1887406
     /* 1887406 */   GIM_Try, /*On fail goto*//*Label 25421*/ GIMT_Encode4(1887495), // Rule ID 14799 //
     /* 1887411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1887422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1887425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1887428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1887434 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887457 */     // MIs[0] policy
     /* 1887457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887467 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1887470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887488 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887494 */     // GIR_Coverage, 14799,
     /* 1887494 */     GIR_EraseRootFromParent_Done,
     /* 1887495 */   // Label 25421: @1887495
     /* 1887495 */   GIM_Try, /*On fail goto*//*Label 25422*/ GIMT_Encode4(1887584), // Rule ID 14802 //
     /* 1887500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1887503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1887511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1887514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1887517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1887523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887546 */     // MIs[0] policy
     /* 1887546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887556 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1887559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887582 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887583 */     // GIR_Coverage, 14802,
     /* 1887583 */     GIR_EraseRootFromParent_Done,
     /* 1887584 */   // Label 25422: @1887584
     /* 1887584 */   GIM_Try, /*On fail goto*//*Label 25423*/ GIMT_Encode4(1887673), // Rule ID 14803 //
     /* 1887589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1887592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1887600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1887603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1887606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1887612 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1887619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1887627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887635 */     // MIs[0] policy
     /* 1887635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887645 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1887648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1887666 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887672 */     // GIR_Coverage, 14803,
     /* 1887672 */     GIR_EraseRootFromParent_Done,
     /* 1887673 */   // Label 25423: @1887673
     /* 1887673 */   GIM_Try, /*On fail goto*//*Label 25424*/ GIMT_Encode4(1887762), // Rule ID 14806 //
     /* 1887678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1887689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887724 */     // MIs[0] policy
     /* 1887724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887734 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1887737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887760 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887761 */     // GIR_Coverage, 14806,
     /* 1887761 */     GIR_EraseRootFromParent_Done,
     /* 1887762 */   // Label 25424: @1887762
     /* 1887762 */   GIM_Try, /*On fail goto*//*Label 25425*/ GIMT_Encode4(1887851), // Rule ID 14807 //
     /* 1887767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1887778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1887781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1887784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1887790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1887797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1887805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887813 */     // MIs[0] policy
     /* 1887813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887823 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11549:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1887823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M2_MASK),
     /* 1887826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887844 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887846 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887850 */     // GIR_Coverage, 14807,
     /* 1887850 */     GIR_EraseRootFromParent_Done,
     /* 1887851 */   // Label 25425: @1887851
     /* 1887851 */   GIM_Try, /*On fail goto*//*Label 25426*/ GIMT_Encode4(1887940), // Rule ID 14810 //
     /* 1887856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1887859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1887876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1887882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887902 */     // MIs[0] policy
     /* 1887902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1887912 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1887912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1887915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1887917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1887919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1887921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1887923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1887925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1887930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1887933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1887935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1887938 */     GIR_RootConstrainSelectedInstOperands,
     /* 1887939 */     // GIR_Coverage, 14810,
     /* 1887939 */     GIR_EraseRootFromParent_Done,
     /* 1887940 */   // Label 25426: @1887940
     /* 1887940 */   GIM_Try, /*On fail goto*//*Label 25427*/ GIMT_Encode4(1888029), // Rule ID 14811 //
     /* 1887945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1887948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1887953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1887956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1887959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1887962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1887965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1887968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1887971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1887975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1887983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1887987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1887991 */     // MIs[0] policy
     /* 1887991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1887994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888001 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11549:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M4_MASK),
     /* 1888004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888022 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888024 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888028 */     // GIR_Coverage, 14811,
     /* 1888028 */     GIR_EraseRootFromParent_Done,
     /* 1888029 */   // Label 25427: @1888029
     /* 1888029 */   GIM_Try, /*On fail goto*//*Label 25428*/ GIMT_Encode4(1888118), // Rule ID 14814 //
     /* 1888034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1888037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1888045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1888048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1888051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1888054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1888064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888080 */     // MIs[0] policy
     /* 1888080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888090 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1888093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888116 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888117 */     // GIR_Coverage, 14814,
     /* 1888117 */     GIR_EraseRootFromParent_Done,
     /* 1888118 */   // Label 25428: @1888118
     /* 1888118 */   GIM_Try, /*On fail goto*//*Label 25429*/ GIMT_Encode4(1888207), // Rule ID 14815 //
     /* 1888123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1888126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssub_mask),
     /* 1888131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1888134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1888137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1888140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1888143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1888146 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1888153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1888161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1888165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888169 */     // MIs[0] policy
     /* 1888169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888179 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11549:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VX_M8_MASK),
     /* 1888182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1888200 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 1888205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888206 */     // GIR_Coverage, 14815,
     /* 1888206 */     GIR_EraseRootFromParent_Done,
     /* 1888207 */   // Label 25429: @1888207
     /* 1888207 */   GIM_Try, /*On fail goto*//*Label 25430*/ GIMT_Encode4(1888293), // Rule ID 19056 //
     /* 1888212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1888215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888258 */     // MIs[0] policy
     /* 1888258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888268 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1888271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888292 */     // GIR_Coverage, 19056,
     /* 1888292 */     GIR_EraseRootFromParent_Done,
     /* 1888293 */   // Label 25430: @1888293
     /* 1888293 */   GIM_Try, /*On fail goto*//*Label 25431*/ GIMT_Encode4(1888379), // Rule ID 19057 //
     /* 1888298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1888301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1888309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1888312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1888315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1888318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888344 */     // MIs[0] policy
     /* 1888344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888354 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16_MASK),
     /* 1888357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888378 */     // GIR_Coverage, 19057,
     /* 1888378 */     GIR_EraseRootFromParent_Done,
     /* 1888379 */   // Label 25431: @1888379
     /* 1888379 */   GIM_Try, /*On fail goto*//*Label 25432*/ GIMT_Encode4(1888465), // Rule ID 19060 //
     /* 1888384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1888387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888430 */     // MIs[0] policy
     /* 1888430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888440 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1888443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888464 */     // GIR_Coverage, 19060,
     /* 1888464 */     GIR_EraseRootFromParent_Done,
     /* 1888465 */   // Label 25432: @1888465
     /* 1888465 */   GIM_Try, /*On fail goto*//*Label 25433*/ GIMT_Encode4(1888551), // Rule ID 19061 //
     /* 1888470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1888473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1888481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1888484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1888487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1888490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888516 */     // MIs[0] policy
     /* 1888516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888526 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16_MASK),
     /* 1888529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888550 */     // GIR_Coverage, 19061,
     /* 1888550 */     GIR_EraseRootFromParent_Done,
     /* 1888551 */   // Label 25433: @1888551
     /* 1888551 */   GIM_Try, /*On fail goto*//*Label 25434*/ GIMT_Encode4(1888637), // Rule ID 19064 //
     /* 1888556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1888559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888602 */     // MIs[0] policy
     /* 1888602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888612 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1888615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888636 */     // GIR_Coverage, 19064,
     /* 1888636 */     GIR_EraseRootFromParent_Done,
     /* 1888637 */   // Label 25434: @1888637
     /* 1888637 */   GIM_Try, /*On fail goto*//*Label 25435*/ GIMT_Encode4(1888723), // Rule ID 19065 //
     /* 1888642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1888645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1888653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1888656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1888659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1888662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1888665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888688 */     // MIs[0] policy
     /* 1888688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888698 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32_MASK),
     /* 1888701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888722 */     // GIR_Coverage, 19065,
     /* 1888722 */     GIR_EraseRootFromParent_Done,
     /* 1888723 */   // Label 25435: @1888723
     /* 1888723 */   GIM_Try, /*On fail goto*//*Label 25436*/ GIMT_Encode4(1888809), // Rule ID 19068 //
     /* 1888728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1888731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888774 */     // MIs[0] policy
     /* 1888774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888784 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1888787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888808 */     // GIR_Coverage, 19068,
     /* 1888808 */     GIR_EraseRootFromParent_Done,
     /* 1888809 */   // Label 25436: @1888809
     /* 1888809 */   GIM_Try, /*On fail goto*//*Label 25437*/ GIMT_Encode4(1888895), // Rule ID 19069 //
     /* 1888814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1888817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1888825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1888828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1888831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1888834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1888837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1888840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888860 */     // MIs[0] policy
     /* 1888860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888870 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1888870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16_MASK),
     /* 1888873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1888891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888894 */     // GIR_Coverage, 19069,
     /* 1888894 */     GIR_EraseRootFromParent_Done,
     /* 1888895 */   // Label 25437: @1888895
     /* 1888895 */   GIM_Try, /*On fail goto*//*Label 25438*/ GIMT_Encode4(1888981), // Rule ID 19072 //
     /* 1888900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1888903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1888914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1888917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1888920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1888923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1888926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1888930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1888942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1888946 */     // MIs[0] policy
     /* 1888946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1888949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1888956 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1888956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1888959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1888961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1888963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1888965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1888967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1888969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1888974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1888977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1888979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1888980 */     // GIR_Coverage, 19072,
     /* 1888980 */     GIR_EraseRootFromParent_Done,
     /* 1888981 */   // Label 25438: @1888981
     /* 1888981 */   GIM_Try, /*On fail goto*//*Label 25439*/ GIMT_Encode4(1889067), // Rule ID 19073 //
     /* 1888986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1888989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1888994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1888997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1889000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1889003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1889006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1889009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889032 */     // MIs[0] policy
     /* 1889032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889042 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32_MASK),
     /* 1889045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889066 */     // GIR_Coverage, 19073,
     /* 1889066 */     GIR_EraseRootFromParent_Done,
     /* 1889067 */   // Label 25439: @1889067
     /* 1889067 */   GIM_Try, /*On fail goto*//*Label 25440*/ GIMT_Encode4(1889153), // Rule ID 19076 //
     /* 1889072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1889075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889118 */     // MIs[0] policy
     /* 1889118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889128 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1889131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889152 */     // GIR_Coverage, 19076,
     /* 1889152 */     GIR_EraseRootFromParent_Done,
     /* 1889153 */   // Label 25440: @1889153
     /* 1889153 */   GIM_Try, /*On fail goto*//*Label 25441*/ GIMT_Encode4(1889239), // Rule ID 19077 //
     /* 1889158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1889161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1889169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1889172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1889175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1889178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1889181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1889188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1889200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889204 */     // MIs[0] policy
     /* 1889204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889214 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64_MASK),
     /* 1889217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1889235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889238 */     // GIR_Coverage, 19077,
     /* 1889238 */     GIR_EraseRootFromParent_Done,
     /* 1889239 */   // Label 25441: @1889239
     /* 1889239 */   GIM_Try, /*On fail goto*//*Label 25442*/ GIMT_Encode4(1889325), // Rule ID 19080 //
     /* 1889244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1889247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889290 */     // MIs[0] policy
     /* 1889290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889300 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1889303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889324 */     // GIR_Coverage, 19080,
     /* 1889324 */     GIR_EraseRootFromParent_Done,
     /* 1889325 */   // Label 25442: @1889325
     /* 1889325 */   GIM_Try, /*On fail goto*//*Label 25443*/ GIMT_Encode4(1889411), // Rule ID 19081 //
     /* 1889330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1889333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1889341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1889344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1889347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1889350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889376 */     // MIs[0] policy
     /* 1889376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889386 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16_MASK),
     /* 1889389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889410 */     // GIR_Coverage, 19081,
     /* 1889410 */     GIR_EraseRootFromParent_Done,
     /* 1889411 */   // Label 25443: @1889411
     /* 1889411 */   GIM_Try, /*On fail goto*//*Label 25444*/ GIMT_Encode4(1889497), // Rule ID 19084 //
     /* 1889416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1889419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889462 */     // MIs[0] policy
     /* 1889462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889472 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1889475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889496 */     // GIR_Coverage, 19084,
     /* 1889496 */     GIR_EraseRootFromParent_Done,
     /* 1889497 */   // Label 25444: @1889497
     /* 1889497 */   GIM_Try, /*On fail goto*//*Label 25445*/ GIMT_Encode4(1889583), // Rule ID 19085 //
     /* 1889502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1889505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1889513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1889516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1889519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1889522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1889525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889548 */     // MIs[0] policy
     /* 1889548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889558 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16_MASK),
     /* 1889561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889582 */     // GIR_Coverage, 19085,
     /* 1889582 */     GIR_EraseRootFromParent_Done,
     /* 1889583 */   // Label 25445: @1889583
     /* 1889583 */   GIM_Try, /*On fail goto*//*Label 25446*/ GIMT_Encode4(1889669), // Rule ID 19088 //
     /* 1889588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1889591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889634 */     // MIs[0] policy
     /* 1889634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889644 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1889647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889668 */     // GIR_Coverage, 19088,
     /* 1889668 */     GIR_EraseRootFromParent_Done,
     /* 1889669 */   // Label 25446: @1889669
     /* 1889669 */   GIM_Try, /*On fail goto*//*Label 25447*/ GIMT_Encode4(1889755), // Rule ID 19089 //
     /* 1889674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1889677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1889685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1889688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1889691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1889694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1889697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1889704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1889716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889720 */     // MIs[0] policy
     /* 1889720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889730 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16_MASK),
     /* 1889733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1889751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889754 */     // GIR_Coverage, 19089,
     /* 1889754 */     GIR_EraseRootFromParent_Done,
     /* 1889755 */   // Label 25447: @1889755
     /* 1889755 */   GIM_Try, /*On fail goto*//*Label 25448*/ GIMT_Encode4(1889841), // Rule ID 19092 //
     /* 1889760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1889763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889806 */     // MIs[0] policy
     /* 1889806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889816 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1889819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889840 */     // GIR_Coverage, 19092,
     /* 1889840 */     GIR_EraseRootFromParent_Done,
     /* 1889841 */   // Label 25448: @1889841
     /* 1889841 */   GIM_Try, /*On fail goto*//*Label 25449*/ GIMT_Encode4(1889927), // Rule ID 19093 //
     /* 1889846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1889849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1889857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1889860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1889863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1889866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1889869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1889872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1889876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1889888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889892 */     // MIs[0] policy
     /* 1889892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889902 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1889902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32_MASK),
     /* 1889905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1889915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1889920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1889923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1889925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1889926 */     // GIR_Coverage, 19093,
     /* 1889926 */     GIR_EraseRootFromParent_Done,
     /* 1889927 */   // Label 25449: @1889927
     /* 1889927 */   GIM_Try, /*On fail goto*//*Label 25450*/ GIMT_Encode4(1890013), // Rule ID 19096 //
     /* 1889932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1889935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1889940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1889943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1889946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1889949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1889952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1889955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1889958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1889962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1889974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1889978 */     // MIs[0] policy
     /* 1889978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1889981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1889988 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1889988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1889991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1889993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1889995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1889997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1889999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890012 */     // GIR_Coverage, 19096,
     /* 1890012 */     GIR_EraseRootFromParent_Done,
     /* 1890013 */   // Label 25450: @1890013
     /* 1890013 */   GIM_Try, /*On fail goto*//*Label 25451*/ GIMT_Encode4(1890099), // Rule ID 19097 //
     /* 1890018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1890021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1890029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1890032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1890035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1890038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890064 */     // MIs[0] policy
     /* 1890064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890074 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32_MASK),
     /* 1890077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890098 */     // GIR_Coverage, 19097,
     /* 1890098 */     GIR_EraseRootFromParent_Done,
     /* 1890099 */   // Label 25451: @1890099
     /* 1890099 */   GIM_Try, /*On fail goto*//*Label 25452*/ GIMT_Encode4(1890185), // Rule ID 19100 //
     /* 1890104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1890107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890150 */     // MIs[0] policy
     /* 1890150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890160 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1890163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890184 */     // GIR_Coverage, 19100,
     /* 1890184 */     GIR_EraseRootFromParent_Done,
     /* 1890185 */   // Label 25452: @1890185
     /* 1890185 */   GIM_Try, /*On fail goto*//*Label 25453*/ GIMT_Encode4(1890271), // Rule ID 19101 //
     /* 1890190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1890193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1890201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1890204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1890207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1890210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1890213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890236 */     // MIs[0] policy
     /* 1890236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890246 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32_MASK),
     /* 1890249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1890267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890270 */     // GIR_Coverage, 19101,
     /* 1890270 */     GIR_EraseRootFromParent_Done,
     /* 1890271 */   // Label 25453: @1890271
     /* 1890271 */   GIM_Try, /*On fail goto*//*Label 25454*/ GIMT_Encode4(1890357), // Rule ID 19104 //
     /* 1890276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1890279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890322 */     // MIs[0] policy
     /* 1890322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890332 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1890335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890356 */     // GIR_Coverage, 19104,
     /* 1890356 */     GIR_EraseRootFromParent_Done,
     /* 1890357 */   // Label 25454: @1890357
     /* 1890357 */   GIM_Try, /*On fail goto*//*Label 25455*/ GIMT_Encode4(1890443), // Rule ID 19105 //
     /* 1890362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1890365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1890373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1890376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1890379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1890382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1890392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1890404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890408 */     // MIs[0] policy
     /* 1890408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890418 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64_MASK),
     /* 1890421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890442 */     // GIR_Coverage, 19105,
     /* 1890442 */     GIR_EraseRootFromParent_Done,
     /* 1890443 */   // Label 25455: @1890443
     /* 1890443 */   GIM_Try, /*On fail goto*//*Label 25456*/ GIMT_Encode4(1890529), // Rule ID 19108 //
     /* 1890448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1890451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890494 */     // MIs[0] policy
     /* 1890494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890504 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1890507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890528 */     // GIR_Coverage, 19108,
     /* 1890528 */     GIR_EraseRootFromParent_Done,
     /* 1890529 */   // Label 25456: @1890529
     /* 1890529 */   GIM_Try, /*On fail goto*//*Label 25457*/ GIMT_Encode4(1890615), // Rule ID 19109 //
     /* 1890534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1890537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1890545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1890548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1890551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1890554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1890557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1890564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1890576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890580 */     // MIs[0] policy
     /* 1890580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890590 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64_MASK),
     /* 1890593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890614 */     // GIR_Coverage, 19109,
     /* 1890614 */     GIR_EraseRootFromParent_Done,
     /* 1890615 */   // Label 25457: @1890615
     /* 1890615 */   GIM_Try, /*On fail goto*//*Label 25458*/ GIMT_Encode4(1890701), // Rule ID 19112 //
     /* 1890620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1890623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890666 */     // MIs[0] policy
     /* 1890666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890676 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1890679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890700 */     // GIR_Coverage, 19112,
     /* 1890700 */     GIR_EraseRootFromParent_Done,
     /* 1890701 */   // Label 25458: @1890701
     /* 1890701 */   GIM_Try, /*On fail goto*//*Label 25459*/ GIMT_Encode4(1890787), // Rule ID 19113 //
     /* 1890706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1890709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1890717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1890720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1890723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1890726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1890729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1890736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1890748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890752 */     // MIs[0] policy
     /* 1890752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890762 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64_MASK),
     /* 1890765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1890783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890786 */     // GIR_Coverage, 19113,
     /* 1890786 */     GIR_EraseRootFromParent_Done,
     /* 1890787 */   // Label 25459: @1890787
     /* 1890787 */   GIM_Try, /*On fail goto*//*Label 25460*/ GIMT_Encode4(1890873), // Rule ID 19116 //
     /* 1890792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1890795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1890803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1890806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1890809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1890812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1890834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890838 */     // MIs[0] policy
     /* 1890838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890848 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1890848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1890851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890872 */     // GIR_Coverage, 19116,
     /* 1890872 */     GIR_EraseRootFromParent_Done,
     /* 1890873 */   // Label 25460: @1890873
     /* 1890873 */   GIM_Try, /*On fail goto*//*Label 25461*/ GIMT_Encode4(1890959), // Rule ID 19117 //
     /* 1890878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1890881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1890889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1890892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1890895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1890898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1890901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1890904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1890920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1890924 */     // MIs[0] policy
     /* 1890924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1890927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1890934 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1890934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF4_E16_MASK),
     /* 1890937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1890939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1890941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1890943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1890945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1890947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1890952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1890955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1890957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1890958 */     // GIR_Coverage, 19117,
     /* 1890958 */     GIR_EraseRootFromParent_Done,
     /* 1890959 */   // Label 25461: @1890959
     /* 1890959 */   GIM_Try, /*On fail goto*//*Label 25462*/ GIMT_Encode4(1891045), // Rule ID 19120 //
     /* 1890964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1890967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1890972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1890975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1890978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1890981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1890984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1890987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1890990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1890994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1890998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891010 */     // MIs[0] policy
     /* 1891010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891020 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1891023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891044 */     // GIR_Coverage, 19120,
     /* 1891044 */     GIR_EraseRootFromParent_Done,
     /* 1891045 */   // Label 25462: @1891045
     /* 1891045 */   GIM_Try, /*On fail goto*//*Label 25463*/ GIMT_Encode4(1891131), // Rule ID 19121 //
     /* 1891050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1891053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1891061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1891064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1891067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1891070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891096 */     // MIs[0] policy
     /* 1891096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891106 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_MF2_E16_MASK),
     /* 1891109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891130 */     // GIR_Coverage, 19121,
     /* 1891130 */     GIR_EraseRootFromParent_Done,
     /* 1891131 */   // Label 25463: @1891131
     /* 1891131 */   GIM_Try, /*On fail goto*//*Label 25464*/ GIMT_Encode4(1891217), // Rule ID 19124 //
     /* 1891136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1891139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1891178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891182 */     // MIs[0] policy
     /* 1891182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891192 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1891195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891216 */     // GIR_Coverage, 19124,
     /* 1891216 */     GIR_EraseRootFromParent_Done,
     /* 1891217 */   // Label 25464: @1891217
     /* 1891217 */   GIM_Try, /*On fail goto*//*Label 25465*/ GIMT_Encode4(1891303), // Rule ID 19125 //
     /* 1891222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1891225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1891233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1891236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1891239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1891264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891268 */     // MIs[0] policy
     /* 1891268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891278 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_MF2_E32_MASK),
     /* 1891281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891302 */     // GIR_Coverage, 19125,
     /* 1891302 */     GIR_EraseRootFromParent_Done,
     /* 1891303 */   // Label 25465: @1891303
     /* 1891303 */   GIM_Try, /*On fail goto*//*Label 25466*/ GIMT_Encode4(1891389), // Rule ID 19128 //
     /* 1891308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1891311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1891319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1891322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1891325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1891328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891354 */     // MIs[0] policy
     /* 1891354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891364 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1891367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891388 */     // GIR_Coverage, 19128,
     /* 1891388 */     GIR_EraseRootFromParent_Done,
     /* 1891389 */   // Label 25466: @1891389
     /* 1891389 */   GIM_Try, /*On fail goto*//*Label 25467*/ GIMT_Encode4(1891475), // Rule ID 19129 //
     /* 1891394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1891397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1891405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1891408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1891411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1891414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1891417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891440 */     // MIs[0] policy
     /* 1891440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891450 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11144:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M1_E16_MASK),
     /* 1891453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891474 */     // GIR_Coverage, 19129,
     /* 1891474 */     GIR_EraseRootFromParent_Done,
     /* 1891475 */   // Label 25467: @1891475
     /* 1891475 */   GIM_Try, /*On fail goto*//*Label 25468*/ GIMT_Encode4(1891561), // Rule ID 19132 //
     /* 1891480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1891483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1891491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1891494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1891497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1891522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891526 */     // MIs[0] policy
     /* 1891526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1891539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891560 */     // GIR_Coverage, 19132,
     /* 1891560 */     GIR_EraseRootFromParent_Done,
     /* 1891561 */   // Label 25468: @1891561
     /* 1891561 */   GIM_Try, /*On fail goto*//*Label 25469*/ GIMT_Encode4(1891647), // Rule ID 19133 //
     /* 1891566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1891569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1891577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1891580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1891583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1891586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1891589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1891608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891612 */     // MIs[0] policy
     /* 1891612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891622 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11144:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M1_E32_MASK),
     /* 1891625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1891643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891646 */     // GIR_Coverage, 19133,
     /* 1891646 */     GIR_EraseRootFromParent_Done,
     /* 1891647 */   // Label 25469: @1891647
     /* 1891647 */   GIM_Try, /*On fail goto*//*Label 25470*/ GIMT_Encode4(1891733), // Rule ID 19136 //
     /* 1891652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1891655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1891663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1891666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1891669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1891694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891698 */     // MIs[0] policy
     /* 1891698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891708 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1891711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891732 */     // GIR_Coverage, 19136,
     /* 1891732 */     GIR_EraseRootFromParent_Done,
     /* 1891733 */   // Label 25470: @1891733
     /* 1891733 */   GIM_Try, /*On fail goto*//*Label 25471*/ GIMT_Encode4(1891819), // Rule ID 19137 //
     /* 1891738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1891741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1891749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1891752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1891755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1891758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1891761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1891768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1891776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1891780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891784 */     // MIs[0] policy
     /* 1891784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891794 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11144:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M1_E64_MASK),
     /* 1891797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1891815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891818 */     // GIR_Coverage, 19137,
     /* 1891818 */     GIR_EraseRootFromParent_Done,
     /* 1891819 */   // Label 25471: @1891819
     /* 1891819 */   GIM_Try, /*On fail goto*//*Label 25472*/ GIMT_Encode4(1891905), // Rule ID 19140 //
     /* 1891824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1891827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1891835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1891838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1891841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1891844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1891850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1891854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891870 */     // MIs[0] policy
     /* 1891870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891880 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1891880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1891883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891904 */     // GIR_Coverage, 19140,
     /* 1891904 */     GIR_EraseRootFromParent_Done,
     /* 1891905 */   // Label 25472: @1891905
     /* 1891905 */   GIM_Try, /*On fail goto*//*Label 25473*/ GIMT_Encode4(1891991), // Rule ID 19141 //
     /* 1891910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1891913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1891918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1891921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1891924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1891927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1891930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1891933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1891936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1891940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1891948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1891952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1891956 */     // MIs[0] policy
     /* 1891956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1891959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1891966 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1891966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M2_E16_MASK),
     /* 1891969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1891971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1891973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1891975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1891977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1891979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1891984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1891987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1891989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1891990 */     // GIR_Coverage, 19141,
     /* 1891990 */     GIR_EraseRootFromParent_Done,
     /* 1891991 */   // Label 25473: @1891991
     /* 1891991 */   GIM_Try, /*On fail goto*//*Label 25474*/ GIMT_Encode4(1892077), // Rule ID 19144 //
     /* 1891996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1891999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1892007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1892010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1892013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1892016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1892038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892042 */     // MIs[0] policy
     /* 1892042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892052 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1892055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892076 */     // GIR_Coverage, 19144,
     /* 1892076 */     GIR_EraseRootFromParent_Done,
     /* 1892077 */   // Label 25474: @1892077
     /* 1892077 */   GIM_Try, /*On fail goto*//*Label 25475*/ GIMT_Encode4(1892163), // Rule ID 19145 //
     /* 1892082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1892085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1892093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1892096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1892099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1892102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1892124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892128 */     // MIs[0] policy
     /* 1892128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892138 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M4_E16_MASK),
     /* 1892141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892162 */     // GIR_Coverage, 19145,
     /* 1892162 */     GIR_EraseRootFromParent_Done,
     /* 1892163 */   // Label 25475: @1892163
     /* 1892163 */   GIM_Try, /*On fail goto*//*Label 25476*/ GIMT_Encode4(1892249), // Rule ID 19148 //
     /* 1892168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1892171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1892179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1892182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1892185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1892188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1892210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892214 */     // MIs[0] policy
     /* 1892214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892224 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1892227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892248 */     // GIR_Coverage, 19148,
     /* 1892248 */     GIR_EraseRootFromParent_Done,
     /* 1892249 */   // Label 25476: @1892249
     /* 1892249 */   GIM_Try, /*On fail goto*//*Label 25477*/ GIMT_Encode4(1892335), // Rule ID 19149 //
     /* 1892254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1892257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1892265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1892268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1892271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1892274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1892277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1892296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892300 */     // MIs[0] policy
     /* 1892300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892310 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR16_M8_E16_MASK),
     /* 1892313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1892331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892334 */     // GIR_Coverage, 19149,
     /* 1892334 */     GIR_EraseRootFromParent_Done,
     /* 1892335 */   // Label 25477: @1892335
     /* 1892335 */   GIM_Try, /*On fail goto*//*Label 25478*/ GIMT_Encode4(1892421), // Rule ID 19152 //
     /* 1892340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1892343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1892351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1892354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1892357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892386 */     // MIs[0] policy
     /* 1892386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1892399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892420 */     // GIR_Coverage, 19152,
     /* 1892420 */     GIR_EraseRootFromParent_Done,
     /* 1892421 */   // Label 25478: @1892421
     /* 1892421 */   GIM_Try, /*On fail goto*//*Label 25479*/ GIMT_Encode4(1892507), // Rule ID 19153 //
     /* 1892426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1892429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1892437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1892440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1892443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1892449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892472 */     // MIs[0] policy
     /* 1892472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M2_E32_MASK),
     /* 1892485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892506 */     // GIR_Coverage, 19153,
     /* 1892506 */     GIR_EraseRootFromParent_Done,
     /* 1892507 */   // Label 25479: @1892507
     /* 1892507 */   GIM_Try, /*On fail goto*//*Label 25480*/ GIMT_Encode4(1892593), // Rule ID 19156 //
     /* 1892512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1892515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1892523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1892526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1892529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892558 */     // MIs[0] policy
     /* 1892558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892568 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1892571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892592 */     // GIR_Coverage, 19156,
     /* 1892592 */     GIR_EraseRootFromParent_Done,
     /* 1892593 */   // Label 25480: @1892593
     /* 1892593 */   GIM_Try, /*On fail goto*//*Label 25481*/ GIMT_Encode4(1892679), // Rule ID 19157 //
     /* 1892598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1892601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1892609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1892612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1892615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1892621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1892628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1892636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892644 */     // MIs[0] policy
     /* 1892644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892654 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M4_E32_MASK),
     /* 1892657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892678 */     // GIR_Coverage, 19157,
     /* 1892678 */     GIR_EraseRootFromParent_Done,
     /* 1892679 */   // Label 25481: @1892679
     /* 1892679 */   GIM_Try, /*On fail goto*//*Label 25482*/ GIMT_Encode4(1892765), // Rule ID 19160 //
     /* 1892684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1892687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1892695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1892698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1892701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892730 */     // MIs[0] policy
     /* 1892730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892740 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1892743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892764 */     // GIR_Coverage, 19160,
     /* 1892764 */     GIR_EraseRootFromParent_Done,
     /* 1892765 */   // Label 25482: @1892765
     /* 1892765 */   GIM_Try, /*On fail goto*//*Label 25483*/ GIMT_Encode4(1892851), // Rule ID 19161 //
     /* 1892770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1892773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1892781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1892784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1892787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1892790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1892793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1892800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1892808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1892812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892816 */     // MIs[0] policy
     /* 1892816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892826 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR32_M8_E32_MASK),
     /* 1892829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1892847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892850 */     // GIR_Coverage, 19161,
     /* 1892850 */     GIR_EraseRootFromParent_Done,
     /* 1892851 */   // Label 25483: @1892851
     /* 1892851 */   GIM_Try, /*On fail goto*//*Label 25484*/ GIMT_Encode4(1892937), // Rule ID 19164 //
     /* 1892856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1892859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1892867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1892870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1892873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1892882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1892898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892902 */     // MIs[0] policy
     /* 1892902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892912 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1892912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1892915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1892917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1892919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1892921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1892923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1892925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1892930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1892933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1892935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1892936 */     // GIR_Coverage, 19164,
     /* 1892936 */     GIR_EraseRootFromParent_Done,
     /* 1892937 */   // Label 25484: @1892937
     /* 1892937 */   GIM_Try, /*On fail goto*//*Label 25485*/ GIMT_Encode4(1893023), // Rule ID 19165 //
     /* 1892942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1892945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1892950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1892953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1892956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1892959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1892962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1892965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1892968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1892972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1892980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1892984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1892988 */     // MIs[0] policy
     /* 1892988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1892991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1892998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11144:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1892998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M2_E64_MASK),
     /* 1893001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893022 */     // GIR_Coverage, 19165,
     /* 1893022 */     GIR_EraseRootFromParent_Done,
     /* 1893023 */   // Label 25485: @1893023
     /* 1893023 */   GIM_Try, /*On fail goto*//*Label 25486*/ GIMT_Encode4(1893109), // Rule ID 19168 //
     /* 1893028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1893031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1893039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1893042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1893045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1893070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893074 */     // MIs[0] policy
     /* 1893074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893084 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1893087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893108 */     // GIR_Coverage, 19168,
     /* 1893108 */     GIR_EraseRootFromParent_Done,
     /* 1893109 */   // Label 25486: @1893109
     /* 1893109 */   GIM_Try, /*On fail goto*//*Label 25487*/ GIMT_Encode4(1893195), // Rule ID 19169 //
     /* 1893114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1893117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1893125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1893128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1893131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1893144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1893152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1893156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893160 */     // MIs[0] policy
     /* 1893160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893170 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11144:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M4_E64_MASK),
     /* 1893173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893194 */     // GIR_Coverage, 19169,
     /* 1893194 */     GIR_EraseRootFromParent_Done,
     /* 1893195 */   // Label 25487: @1893195
     /* 1893195 */   GIM_Try, /*On fail goto*//*Label 25488*/ GIMT_Encode4(1893281), // Rule ID 19172 //
     /* 1893200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1893203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1893211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1893214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1893217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1893242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893246 */     // MIs[0] policy
     /* 1893246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893256 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1893259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893280 */     // GIR_Coverage, 19172,
     /* 1893280 */     GIR_EraseRootFromParent_Done,
     /* 1893281 */   // Label 25488: @1893281
     /* 1893281 */   GIM_Try, /*On fail goto*//*Label 25489*/ GIMT_Encode4(1893367), // Rule ID 19173 //
     /* 1893286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1893289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmin_mask),
     /* 1893294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1893297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1893300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1893303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1893306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1893309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1893316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1893324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1893328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893332 */     // MIs[0] policy
     /* 1893332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893342 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11144:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMIN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VFPR64_M8_E64_MASK),
     /* 1893345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1893363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893366 */     // GIR_Coverage, 19173,
     /* 1893366 */     GIR_EraseRootFromParent_Done,
     /* 1893367 */   // Label 25489: @1893367
     /* 1893367 */   GIM_Try, /*On fail goto*//*Label 25490*/ GIMT_Encode4(1893453), // Rule ID 19176 //
     /* 1893372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1893383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1893386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1893389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1893392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893418 */     // MIs[0] policy
     /* 1893418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893428 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1893431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893452 */     // GIR_Coverage, 19176,
     /* 1893452 */     GIR_EraseRootFromParent_Done,
     /* 1893453 */   // Label 25490: @1893453
     /* 1893453 */   GIM_Try, /*On fail goto*//*Label 25491*/ GIMT_Encode4(1893539), // Rule ID 19177 //
     /* 1893458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1893469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1893472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1893475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1893478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893504 */     // MIs[0] policy
     /* 1893504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893514 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16_MASK),
     /* 1893517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893538 */     // GIR_Coverage, 19177,
     /* 1893538 */     GIR_EraseRootFromParent_Done,
     /* 1893539 */   // Label 25491: @1893539
     /* 1893539 */   GIM_Try, /*On fail goto*//*Label 25492*/ GIMT_Encode4(1893625), // Rule ID 19180 //
     /* 1893544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1893555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1893558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1893561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1893564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1893567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893590 */     // MIs[0] policy
     /* 1893590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893600 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1893603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893624 */     // GIR_Coverage, 19180,
     /* 1893624 */     GIR_EraseRootFromParent_Done,
     /* 1893625 */   // Label 25492: @1893625
     /* 1893625 */   GIM_Try, /*On fail goto*//*Label 25493*/ GIMT_Encode4(1893711), // Rule ID 19181 //
     /* 1893630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1893641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1893644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1893647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1893650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1893653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893676 */     // MIs[0] policy
     /* 1893676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893686 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16_MASK),
     /* 1893689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893710 */     // GIR_Coverage, 19181,
     /* 1893710 */     GIR_EraseRootFromParent_Done,
     /* 1893711 */   // Label 25493: @1893711
     /* 1893711 */   GIM_Try, /*On fail goto*//*Label 25494*/ GIMT_Encode4(1893797), // Rule ID 19184 //
     /* 1893716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1893719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1893727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1893730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1893733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1893736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893762 */     // MIs[0] policy
     /* 1893762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893772 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1893775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893796 */     // GIR_Coverage, 19184,
     /* 1893796 */     GIR_EraseRootFromParent_Done,
     /* 1893797 */   // Label 25494: @1893797
     /* 1893797 */   GIM_Try, /*On fail goto*//*Label 25495*/ GIMT_Encode4(1893883), // Rule ID 19185 //
     /* 1893802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1893805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1893813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1893816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1893819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1893822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1893825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1893828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893848 */     // MIs[0] policy
     /* 1893848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893858 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1893858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32_MASK),
     /* 1893861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1893879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893882 */     // GIR_Coverage, 19185,
     /* 1893882 */     GIR_EraseRootFromParent_Done,
     /* 1893883 */   // Label 25495: @1893883
     /* 1893883 */   GIM_Try, /*On fail goto*//*Label 25496*/ GIMT_Encode4(1893969), // Rule ID 19188 //
     /* 1893888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1893891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1893899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1893902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1893905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1893908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1893914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1893918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1893930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1893934 */     // MIs[0] policy
     /* 1893934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1893937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1893944 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1893944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1893947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1893949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1893951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1893953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1893955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1893957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1893962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1893965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1893967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1893968 */     // GIR_Coverage, 19188,
     /* 1893968 */     GIR_EraseRootFromParent_Done,
     /* 1893969 */   // Label 25496: @1893969
     /* 1893969 */   GIM_Try, /*On fail goto*//*Label 25497*/ GIMT_Encode4(1894055), // Rule ID 19189 //
     /* 1893974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1893977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1893982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1893985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1893988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1893991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1893994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1893997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894020 */     // MIs[0] policy
     /* 1894020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894030 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16_MASK),
     /* 1894033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894054 */     // GIR_Coverage, 19189,
     /* 1894054 */     GIR_EraseRootFromParent_Done,
     /* 1894055 */   // Label 25497: @1894055
     /* 1894055 */   GIM_Try, /*On fail goto*//*Label 25498*/ GIMT_Encode4(1894141), // Rule ID 19192 //
     /* 1894060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1894063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1894071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1894074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1894077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1894080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894106 */     // MIs[0] policy
     /* 1894106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894116 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1894119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894140 */     // GIR_Coverage, 19192,
     /* 1894140 */     GIR_EraseRootFromParent_Done,
     /* 1894141 */   // Label 25498: @1894141
     /* 1894141 */   GIM_Try, /*On fail goto*//*Label 25499*/ GIMT_Encode4(1894227), // Rule ID 19193 //
     /* 1894146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1894149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1894157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1894160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1894163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1894166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1894169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894192 */     // MIs[0] policy
     /* 1894192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894202 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32_MASK),
     /* 1894205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894226 */     // GIR_Coverage, 19193,
     /* 1894226 */     GIR_EraseRootFromParent_Done,
     /* 1894227 */   // Label 25499: @1894227
     /* 1894227 */   GIM_Try, /*On fail goto*//*Label 25500*/ GIMT_Encode4(1894313), // Rule ID 19196 //
     /* 1894232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1894235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1894243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1894246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1894249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1894252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894278 */     // MIs[0] policy
     /* 1894278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1894291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894312 */     // GIR_Coverage, 19196,
     /* 1894312 */     GIR_EraseRootFromParent_Done,
     /* 1894313 */   // Label 25500: @1894313
     /* 1894313 */   GIM_Try, /*On fail goto*//*Label 25501*/ GIMT_Encode4(1894399), // Rule ID 19197 //
     /* 1894318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1894321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1894329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1894332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1894335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1894338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1894341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1894348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1894360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894364 */     // MIs[0] policy
     /* 1894364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894374 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64_MASK),
     /* 1894377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1894395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894398 */     // GIR_Coverage, 19197,
     /* 1894398 */     GIR_EraseRootFromParent_Done,
     /* 1894399 */   // Label 25501: @1894399
     /* 1894399 */   GIM_Try, /*On fail goto*//*Label 25502*/ GIMT_Encode4(1894485), // Rule ID 19200 //
     /* 1894404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1894415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1894418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1894421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1894424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894450 */     // MIs[0] policy
     /* 1894450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894460 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1894463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894484 */     // GIR_Coverage, 19200,
     /* 1894484 */     GIR_EraseRootFromParent_Done,
     /* 1894485 */   // Label 25502: @1894485
     /* 1894485 */   GIM_Try, /*On fail goto*//*Label 25503*/ GIMT_Encode4(1894571), // Rule ID 19201 //
     /* 1894490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1894501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1894504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1894507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1894510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1894513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894536 */     // MIs[0] policy
     /* 1894536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894546 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16_MASK),
     /* 1894549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894570 */     // GIR_Coverage, 19201,
     /* 1894570 */     GIR_EraseRootFromParent_Done,
     /* 1894571 */   // Label 25503: @1894571
     /* 1894571 */   GIM_Try, /*On fail goto*//*Label 25504*/ GIMT_Encode4(1894657), // Rule ID 19204 //
     /* 1894576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1894587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1894590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1894593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1894596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894622 */     // MIs[0] policy
     /* 1894622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894632 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1894635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894656 */     // GIR_Coverage, 19204,
     /* 1894656 */     GIR_EraseRootFromParent_Done,
     /* 1894657 */   // Label 25504: @1894657
     /* 1894657 */   GIM_Try, /*On fail goto*//*Label 25505*/ GIMT_Encode4(1894743), // Rule ID 19205 //
     /* 1894662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1894673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1894676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1894679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1894682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1894685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1894692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1894704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894708 */     // MIs[0] policy
     /* 1894708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894718 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16_MASK),
     /* 1894721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894742 */     // GIR_Coverage, 19205,
     /* 1894742 */     GIR_EraseRootFromParent_Done,
     /* 1894743 */   // Label 25505: @1894743
     /* 1894743 */   GIM_Try, /*On fail goto*//*Label 25506*/ GIMT_Encode4(1894829), // Rule ID 19208 //
     /* 1894748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1894751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1894768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894794 */     // MIs[0] policy
     /* 1894794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894804 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1894807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894828 */     // GIR_Coverage, 19208,
     /* 1894828 */     GIR_EraseRootFromParent_Done,
     /* 1894829 */   // Label 25506: @1894829
     /* 1894829 */   GIM_Try, /*On fail goto*//*Label 25507*/ GIMT_Encode4(1894915), // Rule ID 19209 //
     /* 1894834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1894837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1894845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1894848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1894851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1894854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1894857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1894860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1894864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1894876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894880 */     // MIs[0] policy
     /* 1894880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894890 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1894890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16_MASK),
     /* 1894893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1894911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1894914 */     // GIR_Coverage, 19209,
     /* 1894914 */     GIR_EraseRootFromParent_Done,
     /* 1894915 */   // Label 25507: @1894915
     /* 1894915 */   GIM_Try, /*On fail goto*//*Label 25508*/ GIMT_Encode4(1895001), // Rule ID 19212 //
     /* 1894920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1894923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1894928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1894931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1894934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1894937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1894940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1894943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1894946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1894950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1894962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1894966 */     // MIs[0] policy
     /* 1894966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1894969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1894976 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1894976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1894979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1894981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1894983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1894985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1894987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1894989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1894994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1894997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1894999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895000 */     // GIR_Coverage, 19212,
     /* 1895000 */     GIR_EraseRootFromParent_Done,
     /* 1895001 */   // Label 25508: @1895001
     /* 1895001 */   GIM_Try, /*On fail goto*//*Label 25509*/ GIMT_Encode4(1895087), // Rule ID 19213 //
     /* 1895006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1895017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1895020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1895023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1895026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895052 */     // MIs[0] policy
     /* 1895052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895062 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32_MASK),
     /* 1895065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895086 */     // GIR_Coverage, 19213,
     /* 1895086 */     GIR_EraseRootFromParent_Done,
     /* 1895087 */   // Label 25509: @1895087
     /* 1895087 */   GIM_Try, /*On fail goto*//*Label 25510*/ GIMT_Encode4(1895173), // Rule ID 19216 //
     /* 1895092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1895103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1895106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1895109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1895112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895138 */     // MIs[0] policy
     /* 1895138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895148 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1895151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895172 */     // GIR_Coverage, 19216,
     /* 1895172 */     GIR_EraseRootFromParent_Done,
     /* 1895173 */   // Label 25510: @1895173
     /* 1895173 */   GIM_Try, /*On fail goto*//*Label 25511*/ GIMT_Encode4(1895259), // Rule ID 19217 //
     /* 1895178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1895189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1895192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1895195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1895198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895224 */     // MIs[0] policy
     /* 1895224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895234 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32_MASK),
     /* 1895237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895258 */     // GIR_Coverage, 19217,
     /* 1895258 */     GIR_EraseRootFromParent_Done,
     /* 1895259 */   // Label 25511: @1895259
     /* 1895259 */   GIM_Try, /*On fail goto*//*Label 25512*/ GIMT_Encode4(1895345), // Rule ID 19220 //
     /* 1895264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1895267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1895275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1895278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1895281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1895284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1895287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895310 */     // MIs[0] policy
     /* 1895310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895320 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1895323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895344 */     // GIR_Coverage, 19220,
     /* 1895344 */     GIR_EraseRootFromParent_Done,
     /* 1895345 */   // Label 25512: @1895345
     /* 1895345 */   GIM_Try, /*On fail goto*//*Label 25513*/ GIMT_Encode4(1895431), // Rule ID 19221 //
     /* 1895350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1895353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1895361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1895364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1895367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1895370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1895373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895396 */     // MIs[0] policy
     /* 1895396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895406 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32_MASK),
     /* 1895409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1895427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895430 */     // GIR_Coverage, 19221,
     /* 1895430 */     GIR_EraseRootFromParent_Done,
     /* 1895431 */   // Label 25513: @1895431
     /* 1895431 */   GIM_Try, /*On fail goto*//*Label 25514*/ GIMT_Encode4(1895517), // Rule ID 19224 //
     /* 1895436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1895439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1895447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1895450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1895453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1895456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895482 */     // MIs[0] policy
     /* 1895482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895492 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1895495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895516 */     // GIR_Coverage, 19224,
     /* 1895516 */     GIR_EraseRootFromParent_Done,
     /* 1895517 */   // Label 25514: @1895517
     /* 1895517 */   GIM_Try, /*On fail goto*//*Label 25515*/ GIMT_Encode4(1895603), // Rule ID 19225 //
     /* 1895522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1895533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1895536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1895539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1895542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1895545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1895552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1895564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895568 */     // MIs[0] policy
     /* 1895568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895578 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64_MASK),
     /* 1895581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895602 */     // GIR_Coverage, 19225,
     /* 1895602 */     GIR_EraseRootFromParent_Done,
     /* 1895603 */   // Label 25515: @1895603
     /* 1895603 */   GIM_Try, /*On fail goto*//*Label 25516*/ GIMT_Encode4(1895689), // Rule ID 19228 //
     /* 1895608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1895611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1895619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1895622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1895625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1895628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895654 */     // MIs[0] policy
     /* 1895654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895664 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1895667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895688 */     // GIR_Coverage, 19228,
     /* 1895688 */     GIR_EraseRootFromParent_Done,
     /* 1895689 */   // Label 25516: @1895689
     /* 1895689 */   GIM_Try, /*On fail goto*//*Label 25517*/ GIMT_Encode4(1895775), // Rule ID 19229 //
     /* 1895694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1895705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1895708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1895711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1895714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1895717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1895724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1895736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895740 */     // MIs[0] policy
     /* 1895740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895750 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64_MASK),
     /* 1895753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895774 */     // GIR_Coverage, 19229,
     /* 1895774 */     GIR_EraseRootFromParent_Done,
     /* 1895775 */   // Label 25517: @1895775
     /* 1895775 */   GIM_Try, /*On fail goto*//*Label 25518*/ GIMT_Encode4(1895861), // Rule ID 19232 //
     /* 1895780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1895783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1895800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895826 */     // MIs[0] policy
     /* 1895826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895836 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1895836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1895839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895860 */     // GIR_Coverage, 19232,
     /* 1895860 */     GIR_EraseRootFromParent_Done,
     /* 1895861 */   // Label 25518: @1895861
     /* 1895861 */   GIM_Try, /*On fail goto*//*Label 25519*/ GIMT_Encode4(1895947), // Rule ID 19233 //
     /* 1895866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1895869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1895877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1895880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1895883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1895886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1895889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1895892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1895896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1895908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895912 */     // MIs[0] policy
     /* 1895912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1895915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1895922 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1895922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64_MASK),
     /* 1895925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1895927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1895929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1895931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1895933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1895935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1895940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1895943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1895945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1895946 */     // GIR_Coverage, 19233,
     /* 1895946 */     GIR_EraseRootFromParent_Done,
     /* 1895947 */   // Label 25519: @1895947
     /* 1895947 */   GIM_Try, /*On fail goto*//*Label 25520*/ GIMT_Encode4(1896033), // Rule ID 19236 //
     /* 1895952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1895955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1895960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1895963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1895966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1895969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1895972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1895975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1895978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1895982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1895990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1895994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1895998 */     // MIs[0] policy
     /* 1895998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896008 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1896011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896032 */     // GIR_Coverage, 19236,
     /* 1896032 */     GIR_EraseRootFromParent_Done,
     /* 1896033 */   // Label 25520: @1896033
     /* 1896033 */   GIM_Try, /*On fail goto*//*Label 25521*/ GIMT_Encode4(1896119), // Rule ID 19237 //
     /* 1896038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1896049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1896052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1896055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896084 */     // MIs[0] policy
     /* 1896084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896094 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF4_E16_MASK),
     /* 1896097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896118 */     // GIR_Coverage, 19237,
     /* 1896118 */     GIR_EraseRootFromParent_Done,
     /* 1896119 */   // Label 25521: @1896119
     /* 1896119 */   GIM_Try, /*On fail goto*//*Label 25522*/ GIMT_Encode4(1896205), // Rule ID 19240 //
     /* 1896124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1896135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1896138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1896141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896170 */     // MIs[0] policy
     /* 1896170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896180 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1896183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896204 */     // GIR_Coverage, 19240,
     /* 1896204 */     GIR_EraseRootFromParent_Done,
     /* 1896205 */   // Label 25522: @1896205
     /* 1896205 */   GIM_Try, /*On fail goto*//*Label 25523*/ GIMT_Encode4(1896291), // Rule ID 19241 //
     /* 1896210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1896221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1896224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1896227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896256 */     // MIs[0] policy
     /* 1896256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896266 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_MF2_E16_MASK),
     /* 1896269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896290 */     // GIR_Coverage, 19241,
     /* 1896290 */     GIR_EraseRootFromParent_Done,
     /* 1896291 */   // Label 25523: @1896291
     /* 1896291 */   GIM_Try, /*On fail goto*//*Label 25524*/ GIMT_Encode4(1896377), // Rule ID 19244 //
     /* 1896296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1896307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1896310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1896313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896342 */     // MIs[0] policy
     /* 1896342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896352 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1896355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896376 */     // GIR_Coverage, 19244,
     /* 1896376 */     GIR_EraseRootFromParent_Done,
     /* 1896377 */   // Label 25524: @1896377
     /* 1896377 */   GIM_Try, /*On fail goto*//*Label 25525*/ GIMT_Encode4(1896463), // Rule ID 19245 //
     /* 1896382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1896393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1896396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1896399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896428 */     // MIs[0] policy
     /* 1896428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896438 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_MF2_E32_MASK),
     /* 1896441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896462 */     // GIR_Coverage, 19245,
     /* 1896462 */     GIR_EraseRootFromParent_Done,
     /* 1896463 */   // Label 25525: @1896463
     /* 1896463 */   GIM_Try, /*On fail goto*//*Label 25526*/ GIMT_Encode4(1896549), // Rule ID 19248 //
     /* 1896468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1896479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1896482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1896485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896514 */     // MIs[0] policy
     /* 1896514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896524 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1896527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896548 */     // GIR_Coverage, 19248,
     /* 1896548 */     GIR_EraseRootFromParent_Done,
     /* 1896549 */   // Label 25526: @1896549
     /* 1896549 */   GIM_Try, /*On fail goto*//*Label 25527*/ GIMT_Encode4(1896635), // Rule ID 19249 //
     /* 1896554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1896557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1896565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1896568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1896571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1896574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1896577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1896596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896600 */     // MIs[0] policy
     /* 1896600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896610 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11141:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M1_E16_MASK),
     /* 1896613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1896631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896634 */     // GIR_Coverage, 19249,
     /* 1896634 */     GIR_EraseRootFromParent_Done,
     /* 1896635 */   // Label 25527: @1896635
     /* 1896635 */   GIM_Try, /*On fail goto*//*Label 25528*/ GIMT_Encode4(1896721), // Rule ID 19252 //
     /* 1896640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1896643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896686 */     // MIs[0] policy
     /* 1896686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896696 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1896699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896720 */     // GIR_Coverage, 19252,
     /* 1896720 */     GIR_EraseRootFromParent_Done,
     /* 1896721 */   // Label 25528: @1896721
     /* 1896721 */   GIM_Try, /*On fail goto*//*Label 25529*/ GIMT_Encode4(1896807), // Rule ID 19253 //
     /* 1896726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1896729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1896737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1896740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1896743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1896746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1896749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1896768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896772 */     // MIs[0] policy
     /* 1896772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896782 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11141:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M1_E32_MASK),
     /* 1896785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1896803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896806 */     // GIR_Coverage, 19253,
     /* 1896806 */     GIR_EraseRootFromParent_Done,
     /* 1896807 */   // Label 25529: @1896807
     /* 1896807 */   GIM_Try, /*On fail goto*//*Label 25530*/ GIMT_Encode4(1896893), // Rule ID 19256 //
     /* 1896812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1896815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1896838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1896854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896858 */     // MIs[0] policy
     /* 1896858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896868 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1896868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1896871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896892 */     // GIR_Coverage, 19256,
     /* 1896892 */     GIR_EraseRootFromParent_Done,
     /* 1896893 */   // Label 25530: @1896893
     /* 1896893 */   GIM_Try, /*On fail goto*//*Label 25531*/ GIMT_Encode4(1896979), // Rule ID 19257 //
     /* 1896898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1896901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1896909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1896912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1896915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1896918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1896921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1896924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1896928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1896936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1896940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1896944 */     // MIs[0] policy
     /* 1896944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1896947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1896954 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11141:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1896954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M1_E64_MASK),
     /* 1896957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1896959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1896961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1896963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1896965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1896967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1896972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1896975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1896977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1896978 */     // GIR_Coverage, 19257,
     /* 1896978 */     GIR_EraseRootFromParent_Done,
     /* 1896979 */   // Label 25531: @1896979
     /* 1896979 */   GIM_Try, /*On fail goto*//*Label 25532*/ GIMT_Encode4(1897065), // Rule ID 19260 //
     /* 1896984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1896987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1896992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1896995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1896998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1897001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897030 */     // MIs[0] policy
     /* 1897030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897040 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1897043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897064 */     // GIR_Coverage, 19260,
     /* 1897064 */     GIR_EraseRootFromParent_Done,
     /* 1897065 */   // Label 25532: @1897065
     /* 1897065 */   GIM_Try, /*On fail goto*//*Label 25533*/ GIMT_Encode4(1897151), // Rule ID 19261 //
     /* 1897070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1897081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1897084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1897087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897116 */     // MIs[0] policy
     /* 1897116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897126 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M2_E16_MASK),
     /* 1897129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897150 */     // GIR_Coverage, 19261,
     /* 1897150 */     GIR_EraseRootFromParent_Done,
     /* 1897151 */   // Label 25533: @1897151
     /* 1897151 */   GIM_Try, /*On fail goto*//*Label 25534*/ GIMT_Encode4(1897237), // Rule ID 19264 //
     /* 1897156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1897167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1897170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1897173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897202 */     // MIs[0] policy
     /* 1897202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897212 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1897215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897236 */     // GIR_Coverage, 19264,
     /* 1897236 */     GIR_EraseRootFromParent_Done,
     /* 1897237 */   // Label 25534: @1897237
     /* 1897237 */   GIM_Try, /*On fail goto*//*Label 25535*/ GIMT_Encode4(1897323), // Rule ID 19265 //
     /* 1897242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1897253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1897256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1897259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897288 */     // MIs[0] policy
     /* 1897288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897298 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M4_E16_MASK),
     /* 1897301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897322 */     // GIR_Coverage, 19265,
     /* 1897322 */     GIR_EraseRootFromParent_Done,
     /* 1897323 */   // Label 25535: @1897323
     /* 1897323 */   GIM_Try, /*On fail goto*//*Label 25536*/ GIMT_Encode4(1897409), // Rule ID 19268 //
     /* 1897328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1897331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1897339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1897342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1897345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897374 */     // MIs[0] policy
     /* 1897374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897384 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1897387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897408 */     // GIR_Coverage, 19268,
     /* 1897408 */     GIR_EraseRootFromParent_Done,
     /* 1897409 */   // Label 25536: @1897409
     /* 1897409 */   GIM_Try, /*On fail goto*//*Label 25537*/ GIMT_Encode4(1897495), // Rule ID 19269 //
     /* 1897414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1897417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1897425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1897428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1897431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1897434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1897437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1897456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897460 */     // MIs[0] policy
     /* 1897460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897470 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR16_M8_E16_MASK),
     /* 1897473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1897491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897494 */     // GIR_Coverage, 19269,
     /* 1897494 */     GIR_EraseRootFromParent_Done,
     /* 1897495 */   // Label 25537: @1897495
     /* 1897495 */   GIM_Try, /*On fail goto*//*Label 25538*/ GIMT_Encode4(1897581), // Rule ID 19272 //
     /* 1897500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1897517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897546 */     // MIs[0] policy
     /* 1897546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897556 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1897559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897580 */     // GIR_Coverage, 19272,
     /* 1897580 */     GIR_EraseRootFromParent_Done,
     /* 1897581 */   // Label 25538: @1897581
     /* 1897581 */   GIM_Try, /*On fail goto*//*Label 25539*/ GIMT_Encode4(1897667), // Rule ID 19273 //
     /* 1897586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1897597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1897600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1897603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1897609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1897616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1897624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897632 */     // MIs[0] policy
     /* 1897632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897642 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M2_E32_MASK),
     /* 1897645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897666 */     // GIR_Coverage, 19273,
     /* 1897666 */     GIR_EraseRootFromParent_Done,
     /* 1897667 */   // Label 25539: @1897667
     /* 1897667 */   GIM_Try, /*On fail goto*//*Label 25540*/ GIMT_Encode4(1897753), // Rule ID 19276 //
     /* 1897672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897718 */     // MIs[0] policy
     /* 1897718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897728 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1897731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897752 */     // GIR_Coverage, 19276,
     /* 1897752 */     GIR_EraseRootFromParent_Done,
     /* 1897753 */   // Label 25540: @1897753
     /* 1897753 */   GIM_Try, /*On fail goto*//*Label 25541*/ GIMT_Encode4(1897839), // Rule ID 19277 //
     /* 1897758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1897769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1897772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1897775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1897781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1897788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1897796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897804 */     // MIs[0] policy
     /* 1897804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M4_E32_MASK),
     /* 1897817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897838 */     // GIR_Coverage, 19277,
     /* 1897838 */     GIR_EraseRootFromParent_Done,
     /* 1897839 */   // Label 25541: @1897839
     /* 1897839 */   GIM_Try, /*On fail goto*//*Label 25542*/ GIMT_Encode4(1897925), // Rule ID 19280 //
     /* 1897844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1897847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1897870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897890 */     // MIs[0] policy
     /* 1897890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897900 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1897900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1897903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1897918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1897921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1897923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1897924 */     // GIR_Coverage, 19280,
     /* 1897924 */     GIR_EraseRootFromParent_Done,
     /* 1897925 */   // Label 25542: @1897925
     /* 1897925 */   GIM_Try, /*On fail goto*//*Label 25543*/ GIMT_Encode4(1898011), // Rule ID 19281 //
     /* 1897930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1897933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1897938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1897941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1897944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1897947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1897950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1897953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1897956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1897960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1897968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1897972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1897976 */     // MIs[0] policy
     /* 1897976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1897979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1897986 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1897986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR32_M8_E32_MASK),
     /* 1897989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1897991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1897993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1897995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1897997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1897999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898010 */     // GIR_Coverage, 19281,
     /* 1898010 */     GIR_EraseRootFromParent_Done,
     /* 1898011 */   // Label 25543: @1898011
     /* 1898011 */   GIM_Try, /*On fail goto*//*Label 25544*/ GIMT_Encode4(1898097), // Rule ID 19284 //
     /* 1898016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1898027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1898030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1898033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898062 */     // MIs[0] policy
     /* 1898062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1898075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898096 */     // GIR_Coverage, 19284,
     /* 1898096 */     GIR_EraseRootFromParent_Done,
     /* 1898097 */   // Label 25544: @1898097
     /* 1898097 */   GIM_Try, /*On fail goto*//*Label 25545*/ GIMT_Encode4(1898183), // Rule ID 19285 //
     /* 1898102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1898113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1898116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1898119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1898132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1898140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898148 */     // MIs[0] policy
     /* 1898148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898158 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11141:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M2_E64_MASK),
     /* 1898161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898182 */     // GIR_Coverage, 19285,
     /* 1898182 */     GIR_EraseRootFromParent_Done,
     /* 1898183 */   // Label 25545: @1898183
     /* 1898183 */   GIM_Try, /*On fail goto*//*Label 25546*/ GIMT_Encode4(1898269), // Rule ID 19288 //
     /* 1898188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1898199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1898202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1898205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898234 */     // MIs[0] policy
     /* 1898234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898244 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1898247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898268 */     // GIR_Coverage, 19288,
     /* 1898268 */     GIR_EraseRootFromParent_Done,
     /* 1898269 */   // Label 25546: @1898269
     /* 1898269 */   GIM_Try, /*On fail goto*//*Label 25547*/ GIMT_Encode4(1898355), // Rule ID 19289 //
     /* 1898274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1898285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1898288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1898291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1898297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1898304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1898312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898320 */     // MIs[0] policy
     /* 1898320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898330 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11141:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M4_E64_MASK),
     /* 1898333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898354 */     // GIR_Coverage, 19289,
     /* 1898354 */     GIR_EraseRootFromParent_Done,
     /* 1898355 */   // Label 25547: @1898355
     /* 1898355 */   GIM_Try, /*On fail goto*//*Label 25548*/ GIMT_Encode4(1898441), // Rule ID 19292 //
     /* 1898360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1898363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1898371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1898374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1898377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898406 */     // MIs[0] policy
     /* 1898406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898416 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1898419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898440 */     // GIR_Coverage, 19292,
     /* 1898440 */     GIR_EraseRootFromParent_Done,
     /* 1898441 */   // Label 25548: @1898441
     /* 1898441 */   GIM_Try, /*On fail goto*//*Label 25549*/ GIMT_Encode4(1898527), // Rule ID 19293 //
     /* 1898446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1898449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmax_mask),
     /* 1898454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1898457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1898460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1898463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1898466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1898469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1898476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1898484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1898488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898492 */     // MIs[0] policy
     /* 1898492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898502 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11141:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMAX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VFPR64_M8_E64_MASK),
     /* 1898505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1898523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898526 */     // GIR_Coverage, 19293,
     /* 1898526 */     GIR_EraseRootFromParent_Done,
     /* 1898527 */   // Label 25549: @1898527
     /* 1898527 */   GIM_Try, /*On fail goto*//*Label 25550*/ GIMT_Encode4(1898613), // Rule ID 19296 //
     /* 1898532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1898543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1898546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1898549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1898552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898578 */     // MIs[0] policy
     /* 1898578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898588 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1898591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898612 */     // GIR_Coverage, 19296,
     /* 1898612 */     GIR_EraseRootFromParent_Done,
     /* 1898613 */   // Label 25550: @1898613
     /* 1898613 */   GIM_Try, /*On fail goto*//*Label 25551*/ GIMT_Encode4(1898699), // Rule ID 19297 //
     /* 1898618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1898629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1898632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1898635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1898638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898664 */     // MIs[0] policy
     /* 1898664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898674 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16_MASK),
     /* 1898677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898698 */     // GIR_Coverage, 19297,
     /* 1898698 */     GIR_EraseRootFromParent_Done,
     /* 1898699 */   // Label 25551: @1898699
     /* 1898699 */   GIM_Try, /*On fail goto*//*Label 25552*/ GIMT_Encode4(1898785), // Rule ID 19300 //
     /* 1898704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1898707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1898724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898750 */     // MIs[0] policy
     /* 1898750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898760 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1898763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898784 */     // GIR_Coverage, 19300,
     /* 1898784 */     GIR_EraseRootFromParent_Done,
     /* 1898785 */   // Label 25552: @1898785
     /* 1898785 */   GIM_Try, /*On fail goto*//*Label 25553*/ GIMT_Encode4(1898871), // Rule ID 19301 //
     /* 1898790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1898793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1898801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1898804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1898807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1898810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1898813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898836 */     // MIs[0] policy
     /* 1898836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898846 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1898846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16_MASK),
     /* 1898849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1898867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898870 */     // GIR_Coverage, 19301,
     /* 1898870 */     GIR_EraseRootFromParent_Done,
     /* 1898871 */   // Label 25553: @1898871
     /* 1898871 */   GIM_Try, /*On fail goto*//*Label 25554*/ GIMT_Encode4(1898957), // Rule ID 19304 //
     /* 1898876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1898879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1898896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1898902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1898922 */     // MIs[0] policy
     /* 1898922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1898925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1898932 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1898932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1898935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1898937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1898939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1898941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1898943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1898945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1898950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1898953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1898955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1898956 */     // GIR_Coverage, 19304,
     /* 1898956 */     GIR_EraseRootFromParent_Done,
     /* 1898957 */   // Label 25554: @1898957
     /* 1898957 */   GIM_Try, /*On fail goto*//*Label 25555*/ GIMT_Encode4(1899043), // Rule ID 19305 //
     /* 1898962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1898965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1898970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1898973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1898976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1898979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1898982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1898985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1898988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1898992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1898996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899008 */     // MIs[0] policy
     /* 1899008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899018 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32_MASK),
     /* 1899021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899042 */     // GIR_Coverage, 19305,
     /* 1899042 */     GIR_EraseRootFromParent_Done,
     /* 1899043 */   // Label 25555: @1899043
     /* 1899043 */   GIM_Try, /*On fail goto*//*Label 25556*/ GIMT_Encode4(1899129), // Rule ID 19308 //
     /* 1899048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1899059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1899062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1899065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1899068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899094 */     // MIs[0] policy
     /* 1899094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899104 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1899107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899128 */     // GIR_Coverage, 19308,
     /* 1899128 */     GIR_EraseRootFromParent_Done,
     /* 1899129 */   // Label 25556: @1899129
     /* 1899129 */   GIM_Try, /*On fail goto*//*Label 25557*/ GIMT_Encode4(1899215), // Rule ID 19309 //
     /* 1899134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1899145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1899148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1899151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1899154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1899157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899180 */     // MIs[0] policy
     /* 1899180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899190 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16_MASK),
     /* 1899193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899214 */     // GIR_Coverage, 19309,
     /* 1899214 */     GIR_EraseRootFromParent_Done,
     /* 1899215 */   // Label 25557: @1899215
     /* 1899215 */   GIM_Try, /*On fail goto*//*Label 25558*/ GIMT_Encode4(1899301), // Rule ID 19312 //
     /* 1899220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1899223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1899237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1899240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899266 */     // MIs[0] policy
     /* 1899266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899276 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1899279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899300 */     // GIR_Coverage, 19312,
     /* 1899300 */     GIR_EraseRootFromParent_Done,
     /* 1899301 */   // Label 25558: @1899301
     /* 1899301 */   GIM_Try, /*On fail goto*//*Label 25559*/ GIMT_Encode4(1899387), // Rule ID 19313 //
     /* 1899306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1899309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1899317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1899320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1899323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1899326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1899329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899352 */     // MIs[0] policy
     /* 1899352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899362 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32_MASK),
     /* 1899365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1899383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899386 */     // GIR_Coverage, 19313,
     /* 1899386 */     GIR_EraseRootFromParent_Done,
     /* 1899387 */   // Label 25559: @1899387
     /* 1899387 */   GIM_Try, /*On fail goto*//*Label 25560*/ GIMT_Encode4(1899473), // Rule ID 19316 //
     /* 1899392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1899395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1899403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1899406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1899409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1899412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899438 */     // MIs[0] policy
     /* 1899438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899448 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1899451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899472 */     // GIR_Coverage, 19316,
     /* 1899472 */     GIR_EraseRootFromParent_Done,
     /* 1899473 */   // Label 25560: @1899473
     /* 1899473 */   GIM_Try, /*On fail goto*//*Label 25561*/ GIMT_Encode4(1899559), // Rule ID 19317 //
     /* 1899478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1899481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1899489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1899492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1899495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1899498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1899501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1899508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1899520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899524 */     // MIs[0] policy
     /* 1899524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899534 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64_MASK),
     /* 1899537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1899555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899558 */     // GIR_Coverage, 19317,
     /* 1899558 */     GIR_EraseRootFromParent_Done,
     /* 1899559 */   // Label 25561: @1899559
     /* 1899559 */   GIM_Try, /*On fail goto*//*Label 25562*/ GIMT_Encode4(1899645), // Rule ID 19320 //
     /* 1899564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1899575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1899578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1899581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1899584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899610 */     // MIs[0] policy
     /* 1899610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899620 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1899623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899644 */     // GIR_Coverage, 19320,
     /* 1899644 */     GIR_EraseRootFromParent_Done,
     /* 1899645 */   // Label 25562: @1899645
     /* 1899645 */   GIM_Try, /*On fail goto*//*Label 25563*/ GIMT_Encode4(1899731), // Rule ID 19321 //
     /* 1899650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1899661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1899664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1899667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1899670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1899673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1899680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1899692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899696 */     // MIs[0] policy
     /* 1899696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899706 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16_MASK),
     /* 1899709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899730 */     // GIR_Coverage, 19321,
     /* 1899730 */     GIR_EraseRootFromParent_Done,
     /* 1899731 */   // Label 25563: @1899731
     /* 1899731 */   GIM_Try, /*On fail goto*//*Label 25564*/ GIMT_Encode4(1899817), // Rule ID 19324 //
     /* 1899736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1899756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899782 */     // MIs[0] policy
     /* 1899782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899792 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1899795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899816 */     // GIR_Coverage, 19324,
     /* 1899816 */     GIR_EraseRootFromParent_Done,
     /* 1899817 */   // Label 25564: @1899817
     /* 1899817 */   GIM_Try, /*On fail goto*//*Label 25565*/ GIMT_Encode4(1899903), // Rule ID 19325 //
     /* 1899822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1899833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1899836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1899839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1899842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1899845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1899848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1899852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1899864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899868 */     // MIs[0] policy
     /* 1899868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899878 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1899878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16_MASK),
     /* 1899881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899902 */     // GIR_Coverage, 19325,
     /* 1899902 */     GIR_EraseRootFromParent_Done,
     /* 1899903 */   // Label 25565: @1899903
     /* 1899903 */   GIM_Try, /*On fail goto*//*Label 25566*/ GIMT_Encode4(1899989), // Rule ID 19328 //
     /* 1899908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1899911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1899916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1899919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1899922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1899925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1899928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1899931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1899934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1899938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1899950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1899954 */     // MIs[0] policy
     /* 1899954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1899957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1899964 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1899964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1899967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1899969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1899971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1899973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1899975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1899977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1899982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1899985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1899987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1899988 */     // GIR_Coverage, 19328,
     /* 1899988 */     GIR_EraseRootFromParent_Done,
     /* 1899989 */   // Label 25566: @1899989
     /* 1899989 */   GIM_Try, /*On fail goto*//*Label 25567*/ GIMT_Encode4(1900075), // Rule ID 19329 //
     /* 1899994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1899997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1900005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1900008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1900011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1900014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1900017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900040 */     // MIs[0] policy
     /* 1900040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900050 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16_MASK),
     /* 1900053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1900071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900074 */     // GIR_Coverage, 19329,
     /* 1900074 */     GIR_EraseRootFromParent_Done,
     /* 1900075 */   // Label 25567: @1900075
     /* 1900075 */   GIM_Try, /*On fail goto*//*Label 25568*/ GIMT_Encode4(1900161), // Rule ID 19332 //
     /* 1900080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1900097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1900100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900126 */     // MIs[0] policy
     /* 1900126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900136 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1900139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900160 */     // GIR_Coverage, 19332,
     /* 1900160 */     GIR_EraseRootFromParent_Done,
     /* 1900161 */   // Label 25568: @1900161
     /* 1900161 */   GIM_Try, /*On fail goto*//*Label 25569*/ GIMT_Encode4(1900247), // Rule ID 19333 //
     /* 1900166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1900177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1900180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1900183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1900186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900212 */     // MIs[0] policy
     /* 1900212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900222 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32_MASK),
     /* 1900225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900246 */     // GIR_Coverage, 19333,
     /* 1900246 */     GIR_EraseRootFromParent_Done,
     /* 1900247 */   // Label 25569: @1900247
     /* 1900247 */   GIM_Try, /*On fail goto*//*Label 25570*/ GIMT_Encode4(1900333), // Rule ID 19336 //
     /* 1900252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1900269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1900272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900298 */     // MIs[0] policy
     /* 1900298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900308 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1900311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900332 */     // GIR_Coverage, 19336,
     /* 1900332 */     GIR_EraseRootFromParent_Done,
     /* 1900333 */   // Label 25570: @1900333
     /* 1900333 */   GIM_Try, /*On fail goto*//*Label 25571*/ GIMT_Encode4(1900419), // Rule ID 19337 //
     /* 1900338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1900349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1900352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1900355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1900358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900384 */     // MIs[0] policy
     /* 1900384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900394 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32_MASK),
     /* 1900397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900418 */     // GIR_Coverage, 19337,
     /* 1900418 */     GIR_EraseRootFromParent_Done,
     /* 1900419 */   // Label 25571: @1900419
     /* 1900419 */   GIM_Try, /*On fail goto*//*Label 25572*/ GIMT_Encode4(1900505), // Rule ID 19340 //
     /* 1900424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1900427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1900441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1900444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900470 */     // MIs[0] policy
     /* 1900470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900480 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1900483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900504 */     // GIR_Coverage, 19340,
     /* 1900504 */     GIR_EraseRootFromParent_Done,
     /* 1900505 */   // Label 25572: @1900505
     /* 1900505 */   GIM_Try, /*On fail goto*//*Label 25573*/ GIMT_Encode4(1900591), // Rule ID 19341 //
     /* 1900510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1900513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1900521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1900524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1900527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1900530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1900533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900556 */     // MIs[0] policy
     /* 1900556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900566 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32_MASK),
     /* 1900569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1900587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900590 */     // GIR_Coverage, 19341,
     /* 1900590 */     GIR_EraseRootFromParent_Done,
     /* 1900591 */   // Label 25573: @1900591
     /* 1900591 */   GIM_Try, /*On fail goto*//*Label 25574*/ GIMT_Encode4(1900677), // Rule ID 19344 //
     /* 1900596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1900616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900642 */     // MIs[0] policy
     /* 1900642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900652 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1900655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900676 */     // GIR_Coverage, 19344,
     /* 1900676 */     GIR_EraseRootFromParent_Done,
     /* 1900677 */   // Label 25574: @1900677
     /* 1900677 */   GIM_Try, /*On fail goto*//*Label 25575*/ GIMT_Encode4(1900763), // Rule ID 19345 //
     /* 1900682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1900693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1900696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1900699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1900702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1900705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1900712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1900724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900728 */     // MIs[0] policy
     /* 1900728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64_MASK),
     /* 1900741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900762 */     // GIR_Coverage, 19345,
     /* 1900762 */     GIR_EraseRootFromParent_Done,
     /* 1900763 */   // Label 25575: @1900763
     /* 1900763 */   GIM_Try, /*On fail goto*//*Label 25576*/ GIMT_Encode4(1900849), // Rule ID 19348 //
     /* 1900768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1900788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900814 */     // MIs[0] policy
     /* 1900814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900824 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1900827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900848 */     // GIR_Coverage, 19348,
     /* 1900848 */     GIR_EraseRootFromParent_Done,
     /* 1900849 */   // Label 25576: @1900849
     /* 1900849 */   GIM_Try, /*On fail goto*//*Label 25577*/ GIMT_Encode4(1900935), // Rule ID 19349 //
     /* 1900854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1900857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1900865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1900868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1900871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1900874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1900877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1900880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1900884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1900896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900900 */     // MIs[0] policy
     /* 1900900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900910 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1900910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64_MASK),
     /* 1900913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1900915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1900917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1900919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1900921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1900923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1900928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1900931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1900933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1900934 */     // GIR_Coverage, 19349,
     /* 1900934 */     GIR_EraseRootFromParent_Done,
     /* 1900935 */   // Label 25577: @1900935
     /* 1900935 */   GIM_Try, /*On fail goto*//*Label 25578*/ GIMT_Encode4(1901021), // Rule ID 19352 //
     /* 1900940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1900943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1900948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1900951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1900954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1900957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1900960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1900963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1900966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1900970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1900982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1900986 */     // MIs[0] policy
     /* 1900986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1900989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1900996 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1900996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1900999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901020 */     // GIR_Coverage, 19352,
     /* 1901020 */     GIR_EraseRootFromParent_Done,
     /* 1901021 */   // Label 25578: @1901021
     /* 1901021 */   GIM_Try, /*On fail goto*//*Label 25579*/ GIMT_Encode4(1901107), // Rule ID 19353 //
     /* 1901026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1901029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1901037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1901040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1901043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1901046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1901049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1901056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1901068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901072 */     // MIs[0] policy
     /* 1901072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901082 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64_MASK),
     /* 1901085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1901103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901106 */     // GIR_Coverage, 19353,
     /* 1901106 */     GIR_EraseRootFromParent_Done,
     /* 1901107 */   // Label 25579: @1901107
     /* 1901107 */   GIM_Try, /*On fail goto*//*Label 25580*/ GIMT_Encode4(1901193), // Rule ID 19356 //
     /* 1901112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1901123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1901126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901158 */     // MIs[0] policy
     /* 1901158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901168 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1901171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901192 */     // GIR_Coverage, 19356,
     /* 1901192 */     GIR_EraseRootFromParent_Done,
     /* 1901193 */   // Label 25580: @1901193
     /* 1901193 */   GIM_Try, /*On fail goto*//*Label 25581*/ GIMT_Encode4(1901279), // Rule ID 19357 //
     /* 1901198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1901209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1901212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1901215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901244 */     // MIs[0] policy
     /* 1901244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901254 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF4_E16_MASK),
     /* 1901257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901278 */     // GIR_Coverage, 19357,
     /* 1901278 */     GIR_EraseRootFromParent_Done,
     /* 1901279 */   // Label 25581: @1901279
     /* 1901279 */   GIM_Try, /*On fail goto*//*Label 25582*/ GIMT_Encode4(1901365), // Rule ID 19360 //
     /* 1901284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1901295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1901298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901330 */     // MIs[0] policy
     /* 1901330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901340 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1901343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901364 */     // GIR_Coverage, 19360,
     /* 1901364 */     GIR_EraseRootFromParent_Done,
     /* 1901365 */   // Label 25582: @1901365
     /* 1901365 */   GIM_Try, /*On fail goto*//*Label 25583*/ GIMT_Encode4(1901451), // Rule ID 19361 //
     /* 1901370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1901381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1901384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1901387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901416 */     // MIs[0] policy
     /* 1901416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901426 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_MF2_E16_MASK),
     /* 1901429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901450 */     // GIR_Coverage, 19361,
     /* 1901450 */     GIR_EraseRootFromParent_Done,
     /* 1901451 */   // Label 25583: @1901451
     /* 1901451 */   GIM_Try, /*On fail goto*//*Label 25584*/ GIMT_Encode4(1901537), // Rule ID 19364 //
     /* 1901456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1901467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1901470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901502 */     // MIs[0] policy
     /* 1901502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901512 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1901515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901536 */     // GIR_Coverage, 19364,
     /* 1901536 */     GIR_EraseRootFromParent_Done,
     /* 1901537 */   // Label 25584: @1901537
     /* 1901537 */   GIM_Try, /*On fail goto*//*Label 25585*/ GIMT_Encode4(1901623), // Rule ID 19365 //
     /* 1901542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1901553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1901556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1901559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901588 */     // MIs[0] policy
     /* 1901588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901598 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_MF2_E32_MASK),
     /* 1901601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901622 */     // GIR_Coverage, 19365,
     /* 1901622 */     GIR_EraseRootFromParent_Done,
     /* 1901623 */   // Label 25585: @1901623
     /* 1901623 */   GIM_Try, /*On fail goto*//*Label 25586*/ GIMT_Encode4(1901709), // Rule ID 19368 //
     /* 1901628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1901631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901674 */     // MIs[0] policy
     /* 1901674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901684 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1901687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901708 */     // GIR_Coverage, 19368,
     /* 1901708 */     GIR_EraseRootFromParent_Done,
     /* 1901709 */   // Label 25586: @1901709
     /* 1901709 */   GIM_Try, /*On fail goto*//*Label 25587*/ GIMT_Encode4(1901795), // Rule ID 19369 //
     /* 1901714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1901717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1901725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1901728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1901731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1901734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1901737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1901756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901760 */     // MIs[0] policy
     /* 1901760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901770 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11197:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M1_E16_MASK),
     /* 1901773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1901791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901794 */     // GIR_Coverage, 19369,
     /* 1901794 */     GIR_EraseRootFromParent_Done,
     /* 1901795 */   // Label 25587: @1901795
     /* 1901795 */   GIM_Try, /*On fail goto*//*Label 25588*/ GIMT_Encode4(1901881), // Rule ID 19372 //
     /* 1901800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1901803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901846 */     // MIs[0] policy
     /* 1901846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901856 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1901856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1901859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901880 */     // GIR_Coverage, 19372,
     /* 1901880 */     GIR_EraseRootFromParent_Done,
     /* 1901881 */   // Label 25588: @1901881
     /* 1901881 */   GIM_Try, /*On fail goto*//*Label 25589*/ GIMT_Encode4(1901967), // Rule ID 19373 //
     /* 1901886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1901889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1901897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1901900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1901903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1901906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1901909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1901912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1901916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1901924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1901928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1901932 */     // MIs[0] policy
     /* 1901932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1901935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1901942 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11197:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1901942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M1_E32_MASK),
     /* 1901945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1901947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1901949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1901951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1901953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1901955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1901960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1901963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1901965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1901966 */     // GIR_Coverage, 19373,
     /* 1901966 */     GIR_EraseRootFromParent_Done,
     /* 1901967 */   // Label 25589: @1901967
     /* 1901967 */   GIM_Try, /*On fail goto*//*Label 25590*/ GIMT_Encode4(1902053), // Rule ID 19376 //
     /* 1901972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1901975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1901980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1901983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1901986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1901989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1901992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1901995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1901998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902018 */     // MIs[0] policy
     /* 1902018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902028 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1902031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902052 */     // GIR_Coverage, 19376,
     /* 1902052 */     GIR_EraseRootFromParent_Done,
     /* 1902053 */   // Label 25590: @1902053
     /* 1902053 */   GIM_Try, /*On fail goto*//*Label 25591*/ GIMT_Encode4(1902139), // Rule ID 19377 //
     /* 1902058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1902061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1902069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1902072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1902075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1902078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1902081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1902088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1902096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1902100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902104 */     // MIs[0] policy
     /* 1902104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902114 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11197:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M1_E64_MASK),
     /* 1902117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1902135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902138 */     // GIR_Coverage, 19377,
     /* 1902138 */     GIR_EraseRootFromParent_Done,
     /* 1902139 */   // Label 25591: @1902139
     /* 1902139 */   GIM_Try, /*On fail goto*//*Label 25592*/ GIMT_Encode4(1902225), // Rule ID 19380 //
     /* 1902144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1902155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1902158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902190 */     // MIs[0] policy
     /* 1902190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902200 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1902203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902224 */     // GIR_Coverage, 19380,
     /* 1902224 */     GIR_EraseRootFromParent_Done,
     /* 1902225 */   // Label 25592: @1902225
     /* 1902225 */   GIM_Try, /*On fail goto*//*Label 25593*/ GIMT_Encode4(1902311), // Rule ID 19381 //
     /* 1902230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1902241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1902244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1902247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902276 */     // MIs[0] policy
     /* 1902276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902286 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M2_E16_MASK),
     /* 1902289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902310 */     // GIR_Coverage, 19381,
     /* 1902310 */     GIR_EraseRootFromParent_Done,
     /* 1902311 */   // Label 25593: @1902311
     /* 1902311 */   GIM_Try, /*On fail goto*//*Label 25594*/ GIMT_Encode4(1902397), // Rule ID 19384 //
     /* 1902316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1902327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1902330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902362 */     // MIs[0] policy
     /* 1902362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902372 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1902375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902396 */     // GIR_Coverage, 19384,
     /* 1902396 */     GIR_EraseRootFromParent_Done,
     /* 1902397 */   // Label 25594: @1902397
     /* 1902397 */   GIM_Try, /*On fail goto*//*Label 25595*/ GIMT_Encode4(1902483), // Rule ID 19385 //
     /* 1902402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1902413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1902416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1902419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1902425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902448 */     // MIs[0] policy
     /* 1902448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902458 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M4_E16_MASK),
     /* 1902461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902482 */     // GIR_Coverage, 19385,
     /* 1902482 */     GIR_EraseRootFromParent_Done,
     /* 1902483 */   // Label 25595: @1902483
     /* 1902483 */   GIM_Try, /*On fail goto*//*Label 25596*/ GIMT_Encode4(1902569), // Rule ID 19388 //
     /* 1902488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1902491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1902499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1902502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902534 */     // MIs[0] policy
     /* 1902534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902544 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1902547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902568 */     // GIR_Coverage, 19388,
     /* 1902568 */     GIR_EraseRootFromParent_Done,
     /* 1902569 */   // Label 25596: @1902569
     /* 1902569 */   GIM_Try, /*On fail goto*//*Label 25597*/ GIMT_Encode4(1902655), // Rule ID 19389 //
     /* 1902574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1902577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1902585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1902588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1902591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1902594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1902597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1902604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1902612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1902616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902620 */     // MIs[0] policy
     /* 1902620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902630 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR16_M8_E16_MASK),
     /* 1902633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1902651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902654 */     // GIR_Coverage, 19389,
     /* 1902654 */     GIR_EraseRootFromParent_Done,
     /* 1902655 */   // Label 25597: @1902655
     /* 1902655 */   GIM_Try, /*On fail goto*//*Label 25598*/ GIMT_Encode4(1902741), // Rule ID 19392 //
     /* 1902660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902706 */     // MIs[0] policy
     /* 1902706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902716 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1902719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902740 */     // GIR_Coverage, 19392,
     /* 1902740 */     GIR_EraseRootFromParent_Done,
     /* 1902741 */   // Label 25598: @1902741
     /* 1902741 */   GIM_Try, /*On fail goto*//*Label 25599*/ GIMT_Encode4(1902827), // Rule ID 19393 //
     /* 1902746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1902757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1902760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1902763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1902769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1902776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1902784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902792 */     // MIs[0] policy
     /* 1902792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902802 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M2_E32_MASK),
     /* 1902805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902826 */     // GIR_Coverage, 19393,
     /* 1902826 */     GIR_EraseRootFromParent_Done,
     /* 1902827 */   // Label 25599: @1902827
     /* 1902827 */   GIM_Try, /*On fail goto*//*Label 25600*/ GIMT_Encode4(1902913), // Rule ID 19396 //
     /* 1902832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1902835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1902858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902878 */     // MIs[0] policy
     /* 1902878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902888 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1902888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1902891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902912 */     // GIR_Coverage, 19396,
     /* 1902912 */     GIR_EraseRootFromParent_Done,
     /* 1902913 */   // Label 25600: @1902913
     /* 1902913 */   GIM_Try, /*On fail goto*//*Label 25601*/ GIMT_Encode4(1902999), // Rule ID 19397 //
     /* 1902918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1902921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1902926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1902929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1902932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1902935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1902938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1902941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1902944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1902948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1902956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1902960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1902964 */     // MIs[0] policy
     /* 1902964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1902967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1902974 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1902974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M4_E32_MASK),
     /* 1902977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1902979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1902981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1902983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1902985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1902987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1902992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1902995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1902997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1902998 */     // GIR_Coverage, 19397,
     /* 1902998 */     GIR_EraseRootFromParent_Done,
     /* 1902999 */   // Label 25601: @1902999
     /* 1902999 */   GIM_Try, /*On fail goto*//*Label 25602*/ GIMT_Encode4(1903085), // Rule ID 19400 //
     /* 1903004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1903007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1903015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1903018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903050 */     // MIs[0] policy
     /* 1903050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903060 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1903063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903084 */     // GIR_Coverage, 19400,
     /* 1903084 */     GIR_EraseRootFromParent_Done,
     /* 1903085 */   // Label 25602: @1903085
     /* 1903085 */   GIM_Try, /*On fail goto*//*Label 25603*/ GIMT_Encode4(1903171), // Rule ID 19401 //
     /* 1903090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1903093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1903101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1903104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1903107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1903110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1903113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1903132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903136 */     // MIs[0] policy
     /* 1903136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903146 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR32_M8_E32_MASK),
     /* 1903149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1903167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903170 */     // GIR_Coverage, 19401,
     /* 1903170 */     GIR_EraseRootFromParent_Done,
     /* 1903171 */   // Label 25603: @1903171
     /* 1903171 */   GIM_Try, /*On fail goto*//*Label 25604*/ GIMT_Encode4(1903257), // Rule ID 19404 //
     /* 1903176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1903187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1903190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903222 */     // MIs[0] policy
     /* 1903222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903232 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1903235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903256 */     // GIR_Coverage, 19404,
     /* 1903256 */     GIR_EraseRootFromParent_Done,
     /* 1903257 */   // Label 25604: @1903257
     /* 1903257 */   GIM_Try, /*On fail goto*//*Label 25605*/ GIMT_Encode4(1903343), // Rule ID 19405 //
     /* 1903262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1903273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1903276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1903279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1903292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1903300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903308 */     // MIs[0] policy
     /* 1903308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903318 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11197:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M2_E64_MASK),
     /* 1903321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903342 */     // GIR_Coverage, 19405,
     /* 1903342 */     GIR_EraseRootFromParent_Done,
     /* 1903343 */   // Label 25605: @1903343
     /* 1903343 */   GIM_Try, /*On fail goto*//*Label 25606*/ GIMT_Encode4(1903429), // Rule ID 19408 //
     /* 1903348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1903359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1903362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903394 */     // MIs[0] policy
     /* 1903394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903404 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1903407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903428 */     // GIR_Coverage, 19408,
     /* 1903428 */     GIR_EraseRootFromParent_Done,
     /* 1903429 */   // Label 25606: @1903429
     /* 1903429 */   GIM_Try, /*On fail goto*//*Label 25607*/ GIMT_Encode4(1903515), // Rule ID 19409 //
     /* 1903434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1903445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1903448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1903451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1903457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1903464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1903472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903480 */     // MIs[0] policy
     /* 1903480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903490 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11197:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M4_E64_MASK),
     /* 1903493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903514 */     // GIR_Coverage, 19409,
     /* 1903514 */     GIR_EraseRootFromParent_Done,
     /* 1903515 */   // Label 25607: @1903515
     /* 1903515 */   GIM_Try, /*On fail goto*//*Label 25608*/ GIMT_Encode4(1903601), // Rule ID 19412 //
     /* 1903520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1903523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1903531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1903534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903566 */     // MIs[0] policy
     /* 1903566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903576 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1903579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903600 */     // GIR_Coverage, 19412,
     /* 1903600 */     GIR_EraseRootFromParent_Done,
     /* 1903601 */   // Label 25608: @1903601
     /* 1903601 */   GIM_Try, /*On fail goto*//*Label 25609*/ GIMT_Encode4(1903687), // Rule ID 19413 //
     /* 1903606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1903609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnj_mask),
     /* 1903614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1903617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1903620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1903623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1903626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1903629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1903636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1903644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1903648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903652 */     // MIs[0] policy
     /* 1903652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903662 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11197:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJ_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VFPR64_M8_E64_MASK),
     /* 1903665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1903683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903686 */     // GIR_Coverage, 19413,
     /* 1903686 */     GIR_EraseRootFromParent_Done,
     /* 1903687 */   // Label 25609: @1903687
     /* 1903687 */   GIM_Try, /*On fail goto*//*Label 25610*/ GIMT_Encode4(1903773), // Rule ID 19416 //
     /* 1903692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1903700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1903712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903738 */     // MIs[0] policy
     /* 1903738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903748 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1903751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903772 */     // GIR_Coverage, 19416,
     /* 1903772 */     GIR_EraseRootFromParent_Done,
     /* 1903773 */   // Label 25610: @1903773
     /* 1903773 */   GIM_Try, /*On fail goto*//*Label 25611*/ GIMT_Encode4(1903859), // Rule ID 19417 //
     /* 1903778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1903786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1903789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1903792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1903795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1903798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1903801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903824 */     // MIs[0] policy
     /* 1903824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903834 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1903834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16_MASK),
     /* 1903837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903858 */     // GIR_Coverage, 19417,
     /* 1903858 */     GIR_EraseRootFromParent_Done,
     /* 1903859 */   // Label 25611: @1903859
     /* 1903859 */   GIM_Try, /*On fail goto*//*Label 25612*/ GIMT_Encode4(1903945), // Rule ID 19420 //
     /* 1903864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1903867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1903872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1903884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1903890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903910 */     // MIs[0] policy
     /* 1903910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1903920 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1903920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1903923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1903925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1903927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1903929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1903931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1903933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1903938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1903941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1903943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1903944 */     // GIR_Coverage, 19420,
     /* 1903944 */     GIR_EraseRootFromParent_Done,
     /* 1903945 */   // Label 25612: @1903945
     /* 1903945 */   GIM_Try, /*On fail goto*//*Label 25613*/ GIMT_Encode4(1904031), // Rule ID 19421 //
     /* 1903950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1903953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1903958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1903961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1903964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1903967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1903970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1903973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1903976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1903980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1903992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1903996 */     // MIs[0] policy
     /* 1903996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1903999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904006 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16_MASK),
     /* 1904009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904030 */     // GIR_Coverage, 19421,
     /* 1904030 */     GIR_EraseRootFromParent_Done,
     /* 1904031 */   // Label 25613: @1904031
     /* 1904031 */   GIM_Try, /*On fail goto*//*Label 25614*/ GIMT_Encode4(1904117), // Rule ID 19424 //
     /* 1904036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1904047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1904050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1904056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904082 */     // MIs[0] policy
     /* 1904082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904092 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1904095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904116 */     // GIR_Coverage, 19424,
     /* 1904116 */     GIR_EraseRootFromParent_Done,
     /* 1904117 */   // Label 25614: @1904117
     /* 1904117 */   GIM_Try, /*On fail goto*//*Label 25615*/ GIMT_Encode4(1904203), // Rule ID 19425 //
     /* 1904122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1904133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1904136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1904139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1904142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904168 */     // MIs[0] policy
     /* 1904168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904178 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32_MASK),
     /* 1904181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904202 */     // GIR_Coverage, 19425,
     /* 1904202 */     GIR_EraseRootFromParent_Done,
     /* 1904203 */   // Label 25615: @1904203
     /* 1904203 */   GIM_Try, /*On fail goto*//*Label 25616*/ GIMT_Encode4(1904289), // Rule ID 19428 //
     /* 1904208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904254 */     // MIs[0] policy
     /* 1904254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904264 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1904267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904288 */     // GIR_Coverage, 19428,
     /* 1904288 */     GIR_EraseRootFromParent_Done,
     /* 1904289 */   // Label 25616: @1904289
     /* 1904289 */   GIM_Try, /*On fail goto*//*Label 25617*/ GIMT_Encode4(1904375), // Rule ID 19429 //
     /* 1904294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1904305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1904308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1904311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1904314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1904317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904340 */     // MIs[0] policy
     /* 1904340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904350 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16_MASK),
     /* 1904353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904374 */     // GIR_Coverage, 19429,
     /* 1904374 */     GIR_EraseRootFromParent_Done,
     /* 1904375 */   // Label 25617: @1904375
     /* 1904375 */   GIM_Try, /*On fail goto*//*Label 25618*/ GIMT_Encode4(1904461), // Rule ID 19432 //
     /* 1904380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1904383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904426 */     // MIs[0] policy
     /* 1904426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1904439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904460 */     // GIR_Coverage, 19432,
     /* 1904460 */     GIR_EraseRootFromParent_Done,
     /* 1904461 */   // Label 25618: @1904461
     /* 1904461 */   GIM_Try, /*On fail goto*//*Label 25619*/ GIMT_Encode4(1904547), // Rule ID 19433 //
     /* 1904466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1904469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1904477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1904480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1904483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1904486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1904489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904512 */     // MIs[0] policy
     /* 1904512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904522 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32_MASK),
     /* 1904525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1904543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904546 */     // GIR_Coverage, 19433,
     /* 1904546 */     GIR_EraseRootFromParent_Done,
     /* 1904547 */   // Label 25619: @1904547
     /* 1904547 */   GIM_Try, /*On fail goto*//*Label 25620*/ GIMT_Encode4(1904633), // Rule ID 19436 //
     /* 1904552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1904555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904598 */     // MIs[0] policy
     /* 1904598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904608 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1904611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904632 */     // GIR_Coverage, 19436,
     /* 1904632 */     GIR_EraseRootFromParent_Done,
     /* 1904633 */   // Label 25620: @1904633
     /* 1904633 */   GIM_Try, /*On fail goto*//*Label 25621*/ GIMT_Encode4(1904719), // Rule ID 19437 //
     /* 1904638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1904641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1904649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1904652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1904655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1904658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1904661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1904668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1904680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904684 */     // MIs[0] policy
     /* 1904684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904694 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64_MASK),
     /* 1904697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1904715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904718 */     // GIR_Coverage, 19437,
     /* 1904718 */     GIR_EraseRootFromParent_Done,
     /* 1904719 */   // Label 25621: @1904719
     /* 1904719 */   GIM_Try, /*On fail goto*//*Label 25622*/ GIMT_Encode4(1904805), // Rule ID 19440 //
     /* 1904724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1904744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904770 */     // MIs[0] policy
     /* 1904770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904780 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1904783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904804 */     // GIR_Coverage, 19440,
     /* 1904804 */     GIR_EraseRootFromParent_Done,
     /* 1904805 */   // Label 25622: @1904805
     /* 1904805 */   GIM_Try, /*On fail goto*//*Label 25623*/ GIMT_Encode4(1904891), // Rule ID 19441 //
     /* 1904810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1904821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1904824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1904827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1904830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1904833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1904836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1904840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1904852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904856 */     // MIs[0] policy
     /* 1904856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904866 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1904866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16_MASK),
     /* 1904869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904890 */     // GIR_Coverage, 19441,
     /* 1904890 */     GIR_EraseRootFromParent_Done,
     /* 1904891 */   // Label 25623: @1904891
     /* 1904891 */   GIM_Try, /*On fail goto*//*Label 25624*/ GIMT_Encode4(1904977), // Rule ID 19444 //
     /* 1904896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1904899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1904916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1904919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1904922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1904926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1904938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1904942 */     // MIs[0] policy
     /* 1904942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1904945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1904952 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1904952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1904955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1904957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1904959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1904961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1904963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1904965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1904970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1904973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1904975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1904976 */     // GIR_Coverage, 19444,
     /* 1904976 */     GIR_EraseRootFromParent_Done,
     /* 1904977 */   // Label 25624: @1904977
     /* 1904977 */   GIM_Try, /*On fail goto*//*Label 25625*/ GIMT_Encode4(1905063), // Rule ID 19445 //
     /* 1904982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1904985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1904990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1904993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1904996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1904999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1905002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905028 */     // MIs[0] policy
     /* 1905028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905038 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16_MASK),
     /* 1905041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905062 */     // GIR_Coverage, 19445,
     /* 1905062 */     GIR_EraseRootFromParent_Done,
     /* 1905063 */   // Label 25625: @1905063
     /* 1905063 */   GIM_Try, /*On fail goto*//*Label 25626*/ GIMT_Encode4(1905149), // Rule ID 19448 //
     /* 1905068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1905071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1905079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1905082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1905088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905114 */     // MIs[0] policy
     /* 1905114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905124 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1905127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905148 */     // GIR_Coverage, 19448,
     /* 1905148 */     GIR_EraseRootFromParent_Done,
     /* 1905149 */   // Label 25626: @1905149
     /* 1905149 */   GIM_Try, /*On fail goto*//*Label 25627*/ GIMT_Encode4(1905235), // Rule ID 19449 //
     /* 1905154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1905157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1905165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1905168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1905171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1905174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1905177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905200 */     // MIs[0] policy
     /* 1905200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905210 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16_MASK),
     /* 1905213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1905231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905234 */     // GIR_Coverage, 19449,
     /* 1905234 */     GIR_EraseRootFromParent_Done,
     /* 1905235 */   // Label 25627: @1905235
     /* 1905235 */   GIM_Try, /*On fail goto*//*Label 25628*/ GIMT_Encode4(1905321), // Rule ID 19452 //
     /* 1905240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1905251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1905254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1905260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905286 */     // MIs[0] policy
     /* 1905286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905296 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1905299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905320 */     // GIR_Coverage, 19452,
     /* 1905320 */     GIR_EraseRootFromParent_Done,
     /* 1905321 */   // Label 25628: @1905321
     /* 1905321 */   GIM_Try, /*On fail goto*//*Label 25629*/ GIMT_Encode4(1905407), // Rule ID 19453 //
     /* 1905326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1905337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1905340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1905343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1905346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905372 */     // MIs[0] policy
     /* 1905372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905382 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32_MASK),
     /* 1905385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905406 */     // GIR_Coverage, 19453,
     /* 1905406 */     GIR_EraseRootFromParent_Done,
     /* 1905407 */   // Label 25629: @1905407
     /* 1905407 */   GIM_Try, /*On fail goto*//*Label 25630*/ GIMT_Encode4(1905493), // Rule ID 19456 //
     /* 1905412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1905423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1905426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1905432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905458 */     // MIs[0] policy
     /* 1905458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905468 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1905471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905492 */     // GIR_Coverage, 19456,
     /* 1905492 */     GIR_EraseRootFromParent_Done,
     /* 1905493 */   // Label 25630: @1905493
     /* 1905493 */   GIM_Try, /*On fail goto*//*Label 25631*/ GIMT_Encode4(1905579), // Rule ID 19457 //
     /* 1905498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1905509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1905512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1905515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1905518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1905521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905544 */     // MIs[0] policy
     /* 1905544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905554 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32_MASK),
     /* 1905557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905578 */     // GIR_Coverage, 19457,
     /* 1905578 */     GIR_EraseRootFromParent_Done,
     /* 1905579 */   // Label 25631: @1905579
     /* 1905579 */   GIM_Try, /*On fail goto*//*Label 25632*/ GIMT_Encode4(1905665), // Rule ID 19460 //
     /* 1905584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1905587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1905595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1905598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1905604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905630 */     // MIs[0] policy
     /* 1905630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905640 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1905643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905664 */     // GIR_Coverage, 19460,
     /* 1905664 */     GIR_EraseRootFromParent_Done,
     /* 1905665 */   // Label 25632: @1905665
     /* 1905665 */   GIM_Try, /*On fail goto*//*Label 25633*/ GIMT_Encode4(1905751), // Rule ID 19461 //
     /* 1905670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1905673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1905681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1905684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1905687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1905690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1905693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1905700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1905712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905716 */     // MIs[0] policy
     /* 1905716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905726 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32_MASK),
     /* 1905729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1905747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905750 */     // GIR_Coverage, 19461,
     /* 1905750 */     GIR_EraseRootFromParent_Done,
     /* 1905751 */   // Label 25633: @1905751
     /* 1905751 */   GIM_Try, /*On fail goto*//*Label 25634*/ GIMT_Encode4(1905837), // Rule ID 19464 //
     /* 1905756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1905776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905802 */     // MIs[0] policy
     /* 1905802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905812 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1905815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905836 */     // GIR_Coverage, 19464,
     /* 1905836 */     GIR_EraseRootFromParent_Done,
     /* 1905837 */   // Label 25634: @1905837
     /* 1905837 */   GIM_Try, /*On fail goto*//*Label 25635*/ GIMT_Encode4(1905923), // Rule ID 19465 //
     /* 1905842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1905845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1905853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1905856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1905859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1905862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1905865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1905868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1905872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1905884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905888 */     // MIs[0] policy
     /* 1905888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905898 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1905898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64_MASK),
     /* 1905901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1905916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1905919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1905921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1905922 */     // GIR_Coverage, 19465,
     /* 1905922 */     GIR_EraseRootFromParent_Done,
     /* 1905923 */   // Label 25635: @1905923
     /* 1905923 */   GIM_Try, /*On fail goto*//*Label 25636*/ GIMT_Encode4(1906009), // Rule ID 19468 //
     /* 1905928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1905931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1905936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1905939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1905942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1905945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1905948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1905951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1905954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1905958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1905970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1905974 */     // MIs[0] policy
     /* 1905974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1905977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1905984 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1905984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1905987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1905989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1905991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1905993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1905995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1905997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906008 */     // GIR_Coverage, 19468,
     /* 1906008 */     GIR_EraseRootFromParent_Done,
     /* 1906009 */   // Label 25636: @1906009
     /* 1906009 */   GIM_Try, /*On fail goto*//*Label 25637*/ GIMT_Encode4(1906095), // Rule ID 19469 //
     /* 1906014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1906025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1906028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1906031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1906034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1906044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1906056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906060 */     // MIs[0] policy
     /* 1906060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906070 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64_MASK),
     /* 1906073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906094 */     // GIR_Coverage, 19469,
     /* 1906094 */     GIR_EraseRootFromParent_Done,
     /* 1906095 */   // Label 25637: @1906095
     /* 1906095 */   GIM_Try, /*On fail goto*//*Label 25638*/ GIMT_Encode4(1906181), // Rule ID 19472 //
     /* 1906100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1906103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1906111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1906114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1906120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906146 */     // MIs[0] policy
     /* 1906146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906156 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1906159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906180 */     // GIR_Coverage, 19472,
     /* 1906180 */     GIR_EraseRootFromParent_Done,
     /* 1906181 */   // Label 25638: @1906181
     /* 1906181 */   GIM_Try, /*On fail goto*//*Label 25639*/ GIMT_Encode4(1906267), // Rule ID 19473 //
     /* 1906186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1906189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1906197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1906200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1906203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1906206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1906209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1906216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1906228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906232 */     // MIs[0] policy
     /* 1906232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906242 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64_MASK),
     /* 1906245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1906263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906266 */     // GIR_Coverage, 19473,
     /* 1906266 */     GIR_EraseRootFromParent_Done,
     /* 1906267 */   // Label 25639: @1906267
     /* 1906267 */   GIM_Try, /*On fail goto*//*Label 25640*/ GIMT_Encode4(1906353), // Rule ID 19476 //
     /* 1906272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1906283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1906286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906318 */     // MIs[0] policy
     /* 1906318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906328 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1906331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906352 */     // GIR_Coverage, 19476,
     /* 1906352 */     GIR_EraseRootFromParent_Done,
     /* 1906353 */   // Label 25640: @1906353
     /* 1906353 */   GIM_Try, /*On fail goto*//*Label 25641*/ GIMT_Encode4(1906439), // Rule ID 19477 //
     /* 1906358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1906369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1906372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1906375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906404 */     // MIs[0] policy
     /* 1906404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906414 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF4_E16_MASK),
     /* 1906417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906438 */     // GIR_Coverage, 19477,
     /* 1906438 */     GIR_EraseRootFromParent_Done,
     /* 1906439 */   // Label 25641: @1906439
     /* 1906439 */   GIM_Try, /*On fail goto*//*Label 25642*/ GIMT_Encode4(1906525), // Rule ID 19480 //
     /* 1906444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1906455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1906458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906490 */     // MIs[0] policy
     /* 1906490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906500 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1906503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906524 */     // GIR_Coverage, 19480,
     /* 1906524 */     GIR_EraseRootFromParent_Done,
     /* 1906525 */   // Label 25642: @1906525
     /* 1906525 */   GIM_Try, /*On fail goto*//*Label 25643*/ GIMT_Encode4(1906611), // Rule ID 19481 //
     /* 1906530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1906541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1906544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1906547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906576 */     // MIs[0] policy
     /* 1906576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906586 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_MF2_E16_MASK),
     /* 1906589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906610 */     // GIR_Coverage, 19481,
     /* 1906610 */     GIR_EraseRootFromParent_Done,
     /* 1906611 */   // Label 25643: @1906611
     /* 1906611 */   GIM_Try, /*On fail goto*//*Label 25644*/ GIMT_Encode4(1906697), // Rule ID 19484 //
     /* 1906616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906662 */     // MIs[0] policy
     /* 1906662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906672 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1906675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906696 */     // GIR_Coverage, 19484,
     /* 1906696 */     GIR_EraseRootFromParent_Done,
     /* 1906697 */   // Label 25644: @1906697
     /* 1906697 */   GIM_Try, /*On fail goto*//*Label 25645*/ GIMT_Encode4(1906783), // Rule ID 19485 //
     /* 1906702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1906705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1906713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1906716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1906719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1906725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1906744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906748 */     // MIs[0] policy
     /* 1906748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906758 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_MF2_E32_MASK),
     /* 1906761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1906779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906782 */     // GIR_Coverage, 19485,
     /* 1906782 */     GIR_EraseRootFromParent_Done,
     /* 1906783 */   // Label 25645: @1906783
     /* 1906783 */   GIM_Try, /*On fail goto*//*Label 25646*/ GIMT_Encode4(1906869), // Rule ID 19488 //
     /* 1906788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1906791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906834 */     // MIs[0] policy
     /* 1906834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906844 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1906844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1906847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906868 */     // GIR_Coverage, 19488,
     /* 1906868 */     GIR_EraseRootFromParent_Done,
     /* 1906869 */   // Label 25646: @1906869
     /* 1906869 */   GIM_Try, /*On fail goto*//*Label 25647*/ GIMT_Encode4(1906955), // Rule ID 19489 //
     /* 1906874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1906877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1906885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1906888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1906891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1906894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1906897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1906900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1906916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1906920 */     // MIs[0] policy
     /* 1906920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1906923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1906930 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11199:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1906930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M1_E16_MASK),
     /* 1906933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1906935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1906937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1906939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1906941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1906943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1906948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1906951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1906953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1906954 */     // GIR_Coverage, 19489,
     /* 1906954 */     GIR_EraseRootFromParent_Done,
     /* 1906955 */   // Label 25647: @1906955
     /* 1906955 */   GIM_Try, /*On fail goto*//*Label 25648*/ GIMT_Encode4(1907041), // Rule ID 19492 //
     /* 1906960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1906963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1906968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1906971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1906974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1906977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1906980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1906983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1906986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1906990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1906998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907006 */     // MIs[0] policy
     /* 1907006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907016 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1907019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907040 */     // GIR_Coverage, 19492,
     /* 1907040 */     GIR_EraseRootFromParent_Done,
     /* 1907041 */   // Label 25648: @1907041
     /* 1907041 */   GIM_Try, /*On fail goto*//*Label 25649*/ GIMT_Encode4(1907127), // Rule ID 19493 //
     /* 1907046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1907057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1907060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1907063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1907069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907092 */     // MIs[0] policy
     /* 1907092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907102 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11199:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M1_E32_MASK),
     /* 1907105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907126 */     // GIR_Coverage, 19493,
     /* 1907126 */     GIR_EraseRootFromParent_Done,
     /* 1907127 */   // Label 25649: @1907127
     /* 1907127 */   GIM_Try, /*On fail goto*//*Label 25650*/ GIMT_Encode4(1907213), // Rule ID 19496 //
     /* 1907132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1907135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1907149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907178 */     // MIs[0] policy
     /* 1907178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907188 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1907191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907212 */     // GIR_Coverage, 19496,
     /* 1907212 */     GIR_EraseRootFromParent_Done,
     /* 1907213 */   // Label 25650: @1907213
     /* 1907213 */   GIM_Try, /*On fail goto*//*Label 25651*/ GIMT_Encode4(1907299), // Rule ID 19497 //
     /* 1907218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1907221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1907229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1907232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1907235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1907238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1907241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1907248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1907256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1907260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907264 */     // MIs[0] policy
     /* 1907264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907274 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11199:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M1_E64_MASK),
     /* 1907277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1907295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907298 */     // GIR_Coverage, 19497,
     /* 1907298 */     GIR_EraseRootFromParent_Done,
     /* 1907299 */   // Label 25651: @1907299
     /* 1907299 */   GIM_Try, /*On fail goto*//*Label 25652*/ GIMT_Encode4(1907385), // Rule ID 19500 //
     /* 1907304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1907315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1907318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907350 */     // MIs[0] policy
     /* 1907350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907360 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1907363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907384 */     // GIR_Coverage, 19500,
     /* 1907384 */     GIR_EraseRootFromParent_Done,
     /* 1907385 */   // Label 25652: @1907385
     /* 1907385 */   GIM_Try, /*On fail goto*//*Label 25653*/ GIMT_Encode4(1907471), // Rule ID 19501 //
     /* 1907390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1907401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1907404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1907407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1907413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907436 */     // MIs[0] policy
     /* 1907436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907446 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M2_E16_MASK),
     /* 1907449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907470 */     // GIR_Coverage, 19501,
     /* 1907470 */     GIR_EraseRootFromParent_Done,
     /* 1907471 */   // Label 25653: @1907471
     /* 1907471 */   GIM_Try, /*On fail goto*//*Label 25654*/ GIMT_Encode4(1907557), // Rule ID 19504 //
     /* 1907476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1907487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1907490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907522 */     // MIs[0] policy
     /* 1907522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907532 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1907535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907556 */     // GIR_Coverage, 19504,
     /* 1907556 */     GIR_EraseRootFromParent_Done,
     /* 1907557 */   // Label 25654: @1907557
     /* 1907557 */   GIM_Try, /*On fail goto*//*Label 25655*/ GIMT_Encode4(1907643), // Rule ID 19505 //
     /* 1907562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1907573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1907576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1907579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1907585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1907592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1907600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907608 */     // MIs[0] policy
     /* 1907608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907618 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M4_E16_MASK),
     /* 1907621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907642 */     // GIR_Coverage, 19505,
     /* 1907642 */     GIR_EraseRootFromParent_Done,
     /* 1907643 */   // Label 25655: @1907643
     /* 1907643 */   GIM_Try, /*On fail goto*//*Label 25656*/ GIMT_Encode4(1907729), // Rule ID 19508 //
     /* 1907648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1907651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907694 */     // MIs[0] policy
     /* 1907694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907704 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1907707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907728 */     // GIR_Coverage, 19508,
     /* 1907728 */     GIR_EraseRootFromParent_Done,
     /* 1907729 */   // Label 25656: @1907729
     /* 1907729 */   GIM_Try, /*On fail goto*//*Label 25657*/ GIMT_Encode4(1907815), // Rule ID 19509 //
     /* 1907734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1907737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1907745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1907748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1907751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1907754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1907757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1907764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1907772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1907776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907780 */     // MIs[0] policy
     /* 1907780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907790 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR16_M8_E16_MASK),
     /* 1907793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1907811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907814 */     // GIR_Coverage, 19509,
     /* 1907814 */     GIR_EraseRootFromParent_Done,
     /* 1907815 */   // Label 25657: @1907815
     /* 1907815 */   GIM_Try, /*On fail goto*//*Label 25658*/ GIMT_Encode4(1907901), // Rule ID 19512 //
     /* 1907820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1907846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907866 */     // MIs[0] policy
     /* 1907866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907876 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1907876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1907879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907900 */     // GIR_Coverage, 19512,
     /* 1907900 */     GIR_EraseRootFromParent_Done,
     /* 1907901 */   // Label 25658: @1907901
     /* 1907901 */   GIM_Try, /*On fail goto*//*Label 25659*/ GIMT_Encode4(1907987), // Rule ID 19513 //
     /* 1907906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1907909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1907914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1907917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1907920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1907923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1907926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1907929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1907932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1907936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1907944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1907948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1907952 */     // MIs[0] policy
     /* 1907952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1907955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1907962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1907962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M2_E32_MASK),
     /* 1907965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1907967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1907969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1907971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1907973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1907975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1907980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1907983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1907985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1907986 */     // GIR_Coverage, 19513,
     /* 1907986 */     GIR_EraseRootFromParent_Done,
     /* 1907987 */   // Label 25659: @1907987
     /* 1907987 */   GIM_Try, /*On fail goto*//*Label 25660*/ GIMT_Encode4(1908073), // Rule ID 19516 //
     /* 1907992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1907995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1908003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1908006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908038 */     // MIs[0] policy
     /* 1908038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908048 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1908051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908072 */     // GIR_Coverage, 19516,
     /* 1908072 */     GIR_EraseRootFromParent_Done,
     /* 1908073 */   // Label 25660: @1908073
     /* 1908073 */   GIM_Try, /*On fail goto*//*Label 25661*/ GIMT_Encode4(1908159), // Rule ID 19517 //
     /* 1908078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1908089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1908092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1908095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908124 */     // MIs[0] policy
     /* 1908124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908134 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M4_E32_MASK),
     /* 1908137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908158 */     // GIR_Coverage, 19517,
     /* 1908158 */     GIR_EraseRootFromParent_Done,
     /* 1908159 */   // Label 25661: @1908159
     /* 1908159 */   GIM_Try, /*On fail goto*//*Label 25662*/ GIMT_Encode4(1908245), // Rule ID 19520 //
     /* 1908164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1908167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1908175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1908178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908210 */     // MIs[0] policy
     /* 1908210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908220 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1908223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908244 */     // GIR_Coverage, 19520,
     /* 1908244 */     GIR_EraseRootFromParent_Done,
     /* 1908245 */   // Label 25662: @1908245
     /* 1908245 */   GIM_Try, /*On fail goto*//*Label 25663*/ GIMT_Encode4(1908331), // Rule ID 19521 //
     /* 1908250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1908253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1908261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1908264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1908267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1908270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1908273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1908292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908296 */     // MIs[0] policy
     /* 1908296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908306 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR32_M8_E32_MASK),
     /* 1908309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1908327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908330 */     // GIR_Coverage, 19521,
     /* 1908330 */     GIR_EraseRootFromParent_Done,
     /* 1908331 */   // Label 25663: @1908331
     /* 1908331 */   GIM_Try, /*On fail goto*//*Label 25664*/ GIMT_Encode4(1908417), // Rule ID 19524 //
     /* 1908336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1908347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1908350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1908353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908382 */     // MIs[0] policy
     /* 1908382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908392 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1908395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908416 */     // GIR_Coverage, 19524,
     /* 1908416 */     GIR_EraseRootFromParent_Done,
     /* 1908417 */   // Label 25664: @1908417
     /* 1908417 */   GIM_Try, /*On fail goto*//*Label 25665*/ GIMT_Encode4(1908503), // Rule ID 19525 //
     /* 1908422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1908433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1908436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1908439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1908445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1908452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1908460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908468 */     // MIs[0] policy
     /* 1908468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908478 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11199:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M2_E64_MASK),
     /* 1908481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908502 */     // GIR_Coverage, 19525,
     /* 1908502 */     GIR_EraseRootFromParent_Done,
     /* 1908503 */   // Label 25665: @1908503
     /* 1908503 */   GIM_Try, /*On fail goto*//*Label 25666*/ GIMT_Encode4(1908589), // Rule ID 19528 //
     /* 1908508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1908519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1908522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1908525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908554 */     // MIs[0] policy
     /* 1908554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908564 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1908567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908588 */     // GIR_Coverage, 19528,
     /* 1908588 */     GIR_EraseRootFromParent_Done,
     /* 1908589 */   // Label 25666: @1908589
     /* 1908589 */   GIM_Try, /*On fail goto*//*Label 25667*/ GIMT_Encode4(1908675), // Rule ID 19529 //
     /* 1908594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1908605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1908608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1908611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1908617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1908624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1908632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908640 */     // MIs[0] policy
     /* 1908640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908650 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11199:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M4_E64_MASK),
     /* 1908653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908674 */     // GIR_Coverage, 19529,
     /* 1908674 */     GIR_EraseRootFromParent_Done,
     /* 1908675 */   // Label 25667: @1908675
     /* 1908675 */   GIM_Try, /*On fail goto*//*Label 25668*/ GIMT_Encode4(1908761), // Rule ID 19532 //
     /* 1908680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1908683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908726 */     // MIs[0] policy
     /* 1908726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908736 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1908739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908760 */     // GIR_Coverage, 19532,
     /* 1908760 */     GIR_EraseRootFromParent_Done,
     /* 1908761 */   // Label 25668: @1908761
     /* 1908761 */   GIM_Try, /*On fail goto*//*Label 25669*/ GIMT_Encode4(1908847), // Rule ID 19533 //
     /* 1908766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1908769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjn_mask),
     /* 1908774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1908777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1908780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1908783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1908786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1908789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1908796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1908804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1908808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908812 */     // MIs[0] policy
     /* 1908812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908822 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11199:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJN_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VFPR64_M8_E64_MASK),
     /* 1908825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1908843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908846 */     // GIR_Coverage, 19533,
     /* 1908846 */     GIR_EraseRootFromParent_Done,
     /* 1908847 */   // Label 25669: @1908847
     /* 1908847 */   GIM_Try, /*On fail goto*//*Label 25670*/ GIMT_Encode4(1908933), // Rule ID 19536 //
     /* 1908852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1908855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1908860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1908872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1908878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908898 */     // MIs[0] policy
     /* 1908898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908908 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1908908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1908911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1908915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1908917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1908919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1908921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1908926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1908929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1908931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1908932 */     // GIR_Coverage, 19536,
     /* 1908932 */     GIR_EraseRootFromParent_Done,
     /* 1908933 */   // Label 25670: @1908933
     /* 1908933 */   GIM_Try, /*On fail goto*//*Label 25671*/ GIMT_Encode4(1909019), // Rule ID 19537 //
     /* 1908938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1908941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1908946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1908949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1908952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1908955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1908958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1908961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1908964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1908968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1908980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1908984 */     // MIs[0] policy
     /* 1908984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1908987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1908994 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1908994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16_MASK),
     /* 1908997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1908999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909018 */     // GIR_Coverage, 19537,
     /* 1909018 */     GIR_EraseRootFromParent_Done,
     /* 1909019 */   // Label 25671: @1909019
     /* 1909019 */   GIM_Try, /*On fail goto*//*Label 25672*/ GIMT_Encode4(1909105), // Rule ID 19540 //
     /* 1909024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1909035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1909038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1909041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1909044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909070 */     // MIs[0] policy
     /* 1909070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909080 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1909083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909104 */     // GIR_Coverage, 19540,
     /* 1909104 */     GIR_EraseRootFromParent_Done,
     /* 1909105 */   // Label 25672: @1909105
     /* 1909105 */   GIM_Try, /*On fail goto*//*Label 25673*/ GIMT_Encode4(1909191), // Rule ID 19541 //
     /* 1909110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1909121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1909124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1909127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1909130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909156 */     // MIs[0] policy
     /* 1909156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909166 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16_MASK),
     /* 1909169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909190 */     // GIR_Coverage, 19541,
     /* 1909190 */     GIR_EraseRootFromParent_Done,
     /* 1909191 */   // Label 25673: @1909191
     /* 1909191 */   GIM_Try, /*On fail goto*//*Label 25674*/ GIMT_Encode4(1909277), // Rule ID 19544 //
     /* 1909196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1909207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1909210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1909213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1909216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909242 */     // MIs[0] policy
     /* 1909242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909252 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1909255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909276 */     // GIR_Coverage, 19544,
     /* 1909276 */     GIR_EraseRootFromParent_Done,
     /* 1909277 */   // Label 25674: @1909277
     /* 1909277 */   GIM_Try, /*On fail goto*//*Label 25675*/ GIMT_Encode4(1909363), // Rule ID 19545 //
     /* 1909282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1909293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1909296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1909299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1909302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909328 */     // MIs[0] policy
     /* 1909328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909338 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32_MASK),
     /* 1909341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909362 */     // GIR_Coverage, 19545,
     /* 1909362 */     GIR_EraseRootFromParent_Done,
     /* 1909363 */   // Label 25675: @1909363
     /* 1909363 */   GIM_Try, /*On fail goto*//*Label 25676*/ GIMT_Encode4(1909449), // Rule ID 19548 //
     /* 1909368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1909379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1909382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1909385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1909388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909414 */     // MIs[0] policy
     /* 1909414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909424 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1909427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909448 */     // GIR_Coverage, 19548,
     /* 1909448 */     GIR_EraseRootFromParent_Done,
     /* 1909449 */   // Label 25676: @1909449
     /* 1909449 */   GIM_Try, /*On fail goto*//*Label 25677*/ GIMT_Encode4(1909535), // Rule ID 19549 //
     /* 1909454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1909465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1909468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1909471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1909474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1909477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909500 */     // MIs[0] policy
     /* 1909500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909510 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16_MASK),
     /* 1909513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909534 */     // GIR_Coverage, 19549,
     /* 1909534 */     GIR_EraseRootFromParent_Done,
     /* 1909535 */   // Label 25677: @1909535
     /* 1909535 */   GIM_Try, /*On fail goto*//*Label 25678*/ GIMT_Encode4(1909621), // Rule ID 19552 //
     /* 1909540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1909543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909586 */     // MIs[0] policy
     /* 1909586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909596 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1909599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909620 */     // GIR_Coverage, 19552,
     /* 1909620 */     GIR_EraseRootFromParent_Done,
     /* 1909621 */   // Label 25678: @1909621
     /* 1909621 */   GIM_Try, /*On fail goto*//*Label 25679*/ GIMT_Encode4(1909707), // Rule ID 19553 //
     /* 1909626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1909629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1909637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1909640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1909643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1909646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1909649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909672 */     // MIs[0] policy
     /* 1909672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32_MASK),
     /* 1909685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1909703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909706 */     // GIR_Coverage, 19553,
     /* 1909706 */     GIR_EraseRootFromParent_Done,
     /* 1909707 */   // Label 25679: @1909707
     /* 1909707 */   GIM_Try, /*On fail goto*//*Label 25680*/ GIMT_Encode4(1909793), // Rule ID 19556 //
     /* 1909712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1909715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909758 */     // MIs[0] policy
     /* 1909758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909768 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1909771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909792 */     // GIR_Coverage, 19556,
     /* 1909792 */     GIR_EraseRootFromParent_Done,
     /* 1909793 */   // Label 25680: @1909793
     /* 1909793 */   GIM_Try, /*On fail goto*//*Label 25681*/ GIMT_Encode4(1909879), // Rule ID 19557 //
     /* 1909798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1909801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1909809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1909812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1909815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1909818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1909821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1909828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1909840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909844 */     // MIs[0] policy
     /* 1909844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909854 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1909854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64_MASK),
     /* 1909857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1909875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909878 */     // GIR_Coverage, 19557,
     /* 1909878 */     GIR_EraseRootFromParent_Done,
     /* 1909879 */   // Label 25681: @1909879
     /* 1909879 */   GIM_Try, /*On fail goto*//*Label 25682*/ GIMT_Encode4(1909965), // Rule ID 19560 //
     /* 1909884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1909887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1909904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1909910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1909914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1909926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1909930 */     // MIs[0] policy
     /* 1909930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1909933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1909940 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1909940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1909943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1909945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1909947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1909949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1909951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1909953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1909958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1909961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1909963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1909964 */     // GIR_Coverage, 19560,
     /* 1909964 */     GIR_EraseRootFromParent_Done,
     /* 1909965 */   // Label 25682: @1909965
     /* 1909965 */   GIM_Try, /*On fail goto*//*Label 25683*/ GIMT_Encode4(1910051), // Rule ID 19561 //
     /* 1909970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1909973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1909978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1909981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1909984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1909987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1909990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1909993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1909996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910016 */     // MIs[0] policy
     /* 1910016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910026 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16_MASK),
     /* 1910029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910050 */     // GIR_Coverage, 19561,
     /* 1910050 */     GIR_EraseRootFromParent_Done,
     /* 1910051 */   // Label 25683: @1910051
     /* 1910051 */   GIM_Try, /*On fail goto*//*Label 25684*/ GIMT_Encode4(1910137), // Rule ID 19564 //
     /* 1910056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1910067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1910070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1910073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1910076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910102 */     // MIs[0] policy
     /* 1910102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910112 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1910115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910136 */     // GIR_Coverage, 19564,
     /* 1910136 */     GIR_EraseRootFromParent_Done,
     /* 1910137 */   // Label 25684: @1910137
     /* 1910137 */   GIM_Try, /*On fail goto*//*Label 25685*/ GIMT_Encode4(1910223), // Rule ID 19565 //
     /* 1910142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1910153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1910156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1910159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1910162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910188 */     // MIs[0] policy
     /* 1910188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910198 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16_MASK),
     /* 1910201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910222 */     // GIR_Coverage, 19565,
     /* 1910222 */     GIR_EraseRootFromParent_Done,
     /* 1910223 */   // Label 25685: @1910223
     /* 1910223 */   GIM_Try, /*On fail goto*//*Label 25686*/ GIMT_Encode4(1910309), // Rule ID 19568 //
     /* 1910228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1910231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1910239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1910242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1910245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1910248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1910251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910274 */     // MIs[0] policy
     /* 1910274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910284 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1910287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910308 */     // GIR_Coverage, 19568,
     /* 1910308 */     GIR_EraseRootFromParent_Done,
     /* 1910309 */   // Label 25686: @1910309
     /* 1910309 */   GIM_Try, /*On fail goto*//*Label 25687*/ GIMT_Encode4(1910395), // Rule ID 19569 //
     /* 1910314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1910317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1910325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1910328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1910331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1910334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1910337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910360 */     // MIs[0] policy
     /* 1910360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910370 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16_MASK),
     /* 1910373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1910391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910394 */     // GIR_Coverage, 19569,
     /* 1910394 */     GIR_EraseRootFromParent_Done,
     /* 1910395 */   // Label 25687: @1910395
     /* 1910395 */   GIM_Try, /*On fail goto*//*Label 25688*/ GIMT_Encode4(1910481), // Rule ID 19572 //
     /* 1910400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1910411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1910414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1910417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1910420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910446 */     // MIs[0] policy
     /* 1910446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910456 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1910459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910480 */     // GIR_Coverage, 19572,
     /* 1910480 */     GIR_EraseRootFromParent_Done,
     /* 1910481 */   // Label 25688: @1910481
     /* 1910481 */   GIM_Try, /*On fail goto*//*Label 25689*/ GIMT_Encode4(1910567), // Rule ID 19573 //
     /* 1910486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1910497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1910500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1910503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1910506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1910509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910532 */     // MIs[0] policy
     /* 1910532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910542 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32_MASK),
     /* 1910545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910566 */     // GIR_Coverage, 19573,
     /* 1910566 */     GIR_EraseRootFromParent_Done,
     /* 1910567 */   // Label 25689: @1910567
     /* 1910567 */   GIM_Try, /*On fail goto*//*Label 25690*/ GIMT_Encode4(1910653), // Rule ID 19576 //
     /* 1910572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1910583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1910586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1910592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910618 */     // MIs[0] policy
     /* 1910618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910628 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1910631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910652 */     // GIR_Coverage, 19576,
     /* 1910652 */     GIR_EraseRootFromParent_Done,
     /* 1910653 */   // Label 25690: @1910653
     /* 1910653 */   GIM_Try, /*On fail goto*//*Label 25691*/ GIMT_Encode4(1910739), // Rule ID 19577 //
     /* 1910658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1910669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1910672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1910675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1910678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1910681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1910688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1910700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910704 */     // MIs[0] policy
     /* 1910704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910714 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32_MASK),
     /* 1910717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910738 */     // GIR_Coverage, 19577,
     /* 1910738 */     GIR_EraseRootFromParent_Done,
     /* 1910739 */   // Label 25691: @1910739
     /* 1910739 */   GIM_Try, /*On fail goto*//*Label 25692*/ GIMT_Encode4(1910825), // Rule ID 19580 //
     /* 1910744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1910747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1910764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910790 */     // MIs[0] policy
     /* 1910790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910800 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1910803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910824 */     // GIR_Coverage, 19580,
     /* 1910824 */     GIR_EraseRootFromParent_Done,
     /* 1910825 */   // Label 25692: @1910825
     /* 1910825 */   GIM_Try, /*On fail goto*//*Label 25693*/ GIMT_Encode4(1910911), // Rule ID 19581 //
     /* 1910830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1910833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1910841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1910844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1910847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1910850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1910853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1910856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1910860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1910872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910876 */     // MIs[0] policy
     /* 1910876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910886 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1910886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32_MASK),
     /* 1910889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1910907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910910 */     // GIR_Coverage, 19581,
     /* 1910910 */     GIR_EraseRootFromParent_Done,
     /* 1910911 */   // Label 25693: @1910911
     /* 1910911 */   GIM_Try, /*On fail goto*//*Label 25694*/ GIMT_Encode4(1910997), // Rule ID 19584 //
     /* 1910916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1910919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1910924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1910927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1910930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1910933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1910936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1910939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1910942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1910946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1910958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1910962 */     // MIs[0] policy
     /* 1910962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1910965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1910972 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1910972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1910975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1910977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1910979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1910981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1910983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1910985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1910990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1910993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1910995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1910996 */     // GIR_Coverage, 19584,
     /* 1910996 */     GIR_EraseRootFromParent_Done,
     /* 1910997 */   // Label 25694: @1910997
     /* 1910997 */   GIM_Try, /*On fail goto*//*Label 25695*/ GIMT_Encode4(1911083), // Rule ID 19585 //
     /* 1911002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1911013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1911016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1911019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1911022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1911032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1911044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911048 */     // MIs[0] policy
     /* 1911048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911058 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64_MASK),
     /* 1911061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911082 */     // GIR_Coverage, 19585,
     /* 1911082 */     GIR_EraseRootFromParent_Done,
     /* 1911083 */   // Label 25695: @1911083
     /* 1911083 */   GIM_Try, /*On fail goto*//*Label 25696*/ GIMT_Encode4(1911169), // Rule ID 19588 //
     /* 1911088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1911099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1911102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1911105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1911108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911134 */     // MIs[0] policy
     /* 1911134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911144 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1911147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911168 */     // GIR_Coverage, 19588,
     /* 1911168 */     GIR_EraseRootFromParent_Done,
     /* 1911169 */   // Label 25696: @1911169
     /* 1911169 */   GIM_Try, /*On fail goto*//*Label 25697*/ GIMT_Encode4(1911255), // Rule ID 19589 //
     /* 1911174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1911185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1911188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1911191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1911194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1911204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1911216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911220 */     // MIs[0] policy
     /* 1911220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911230 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64_MASK),
     /* 1911233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911254 */     // GIR_Coverage, 19589,
     /* 1911254 */     GIR_EraseRootFromParent_Done,
     /* 1911255 */   // Label 25697: @1911255
     /* 1911255 */   GIM_Try, /*On fail goto*//*Label 25698*/ GIMT_Encode4(1911341), // Rule ID 19592 //
     /* 1911260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1911263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1911271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1911274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1911277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1911280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911306 */     // MIs[0] policy
     /* 1911306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911316 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1911319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911340 */     // GIR_Coverage, 19592,
     /* 1911340 */     GIR_EraseRootFromParent_Done,
     /* 1911341 */   // Label 25698: @1911341
     /* 1911341 */   GIM_Try, /*On fail goto*//*Label 25699*/ GIMT_Encode4(1911427), // Rule ID 19593 //
     /* 1911346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1911349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1911357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1911360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1911363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1911366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1911369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1911376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1911388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911392 */     // MIs[0] policy
     /* 1911392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911402 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64_MASK),
     /* 1911405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1911423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911426 */     // GIR_Coverage, 19593,
     /* 1911426 */     GIR_EraseRootFromParent_Done,
     /* 1911427 */   // Label 25699: @1911427
     /* 1911427 */   GIM_Try, /*On fail goto*//*Label 25700*/ GIMT_Encode4(1911513), // Rule ID 19596 //
     /* 1911432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911478 */     // MIs[0] policy
     /* 1911478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911488 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1911491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911512 */     // GIR_Coverage, 19596,
     /* 1911512 */     GIR_EraseRootFromParent_Done,
     /* 1911513 */   // Label 25700: @1911513
     /* 1911513 */   GIM_Try, /*On fail goto*//*Label 25701*/ GIMT_Encode4(1911599), // Rule ID 19597 //
     /* 1911518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1911529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1911532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1911535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911564 */     // MIs[0] policy
     /* 1911564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911574 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF4_E16_MASK),
     /* 1911577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911598 */     // GIR_Coverage, 19597,
     /* 1911598 */     GIR_EraseRootFromParent_Done,
     /* 1911599 */   // Label 25701: @1911599
     /* 1911599 */   GIM_Try, /*On fail goto*//*Label 25702*/ GIMT_Encode4(1911685), // Rule ID 19600 //
     /* 1911604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911650 */     // MIs[0] policy
     /* 1911650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911660 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1911663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911684 */     // GIR_Coverage, 19600,
     /* 1911684 */     GIR_EraseRootFromParent_Done,
     /* 1911685 */   // Label 25702: @1911685
     /* 1911685 */   GIM_Try, /*On fail goto*//*Label 25703*/ GIMT_Encode4(1911771), // Rule ID 19601 //
     /* 1911690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1911693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1911701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1911704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1911707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1911713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911736 */     // MIs[0] policy
     /* 1911736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911746 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_MF2_E16_MASK),
     /* 1911749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1911767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911770 */     // GIR_Coverage, 19601,
     /* 1911770 */     GIR_EraseRootFromParent_Done,
     /* 1911771 */   // Label 25703: @1911771
     /* 1911771 */   GIM_Try, /*On fail goto*//*Label 25704*/ GIMT_Encode4(1911857), // Rule ID 19604 //
     /* 1911776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1911779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911822 */     // MIs[0] policy
     /* 1911822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911832 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1911832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1911835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911856 */     // GIR_Coverage, 19604,
     /* 1911856 */     GIR_EraseRootFromParent_Done,
     /* 1911857 */   // Label 25704: @1911857
     /* 1911857 */   GIM_Try, /*On fail goto*//*Label 25705*/ GIMT_Encode4(1911943), // Rule ID 19605 //
     /* 1911862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1911865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1911873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1911876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1911879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1911882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1911885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1911888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1911904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911908 */     // MIs[0] policy
     /* 1911908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1911918 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1911918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_MF2_E32_MASK),
     /* 1911921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1911923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1911925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1911927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1911929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1911931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1911936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1911939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1911941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1911942 */     // GIR_Coverage, 19605,
     /* 1911942 */     GIR_EraseRootFromParent_Done,
     /* 1911943 */   // Label 25705: @1911943
     /* 1911943 */   GIM_Try, /*On fail goto*//*Label 25706*/ GIMT_Encode4(1912029), // Rule ID 19608 //
     /* 1911948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1911951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1911956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1911959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1911962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1911965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1911968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1911971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1911974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1911978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1911986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1911990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1911994 */     // MIs[0] policy
     /* 1911994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1911997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912004 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1912007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912028 */     // GIR_Coverage, 19608,
     /* 1912028 */     GIR_EraseRootFromParent_Done,
     /* 1912029 */   // Label 25706: @1912029
     /* 1912029 */   GIM_Try, /*On fail goto*//*Label 25707*/ GIMT_Encode4(1912115), // Rule ID 19609 //
     /* 1912034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1912045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1912048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1912051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1912057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912080 */     // MIs[0] policy
     /* 1912080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912090 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11201:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M1_E16_MASK),
     /* 1912093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912114 */     // GIR_Coverage, 19609,
     /* 1912114 */     GIR_EraseRootFromParent_Done,
     /* 1912115 */   // Label 25707: @1912115
     /* 1912115 */   GIM_Try, /*On fail goto*//*Label 25708*/ GIMT_Encode4(1912201), // Rule ID 19612 //
     /* 1912120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912166 */     // MIs[0] policy
     /* 1912166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912176 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1912179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912200 */     // GIR_Coverage, 19612,
     /* 1912200 */     GIR_EraseRootFromParent_Done,
     /* 1912201 */   // Label 25708: @1912201
     /* 1912201 */   GIM_Try, /*On fail goto*//*Label 25709*/ GIMT_Encode4(1912287), // Rule ID 19613 //
     /* 1912206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1912209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1912217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1912220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1912223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1912226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1912229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1912248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912252 */     // MIs[0] policy
     /* 1912252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912262 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11201:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M1_E32_MASK),
     /* 1912265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1912283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912286 */     // GIR_Coverage, 19613,
     /* 1912286 */     GIR_EraseRootFromParent_Done,
     /* 1912287 */   // Label 25709: @1912287
     /* 1912287 */   GIM_Try, /*On fail goto*//*Label 25710*/ GIMT_Encode4(1912373), // Rule ID 19616 //
     /* 1912292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1912295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912338 */     // MIs[0] policy
     /* 1912338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912348 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1912351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912372 */     // GIR_Coverage, 19616,
     /* 1912372 */     GIR_EraseRootFromParent_Done,
     /* 1912373 */   // Label 25710: @1912373
     /* 1912373 */   GIM_Try, /*On fail goto*//*Label 25711*/ GIMT_Encode4(1912459), // Rule ID 19617 //
     /* 1912378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1912381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1912389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1912392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1912395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1912398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1912401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1912408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1912416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1912420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912424 */     // MIs[0] policy
     /* 1912424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912434 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11201:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M1_E64_MASK),
     /* 1912437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1912455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912458 */     // GIR_Coverage, 19617,
     /* 1912458 */     GIR_EraseRootFromParent_Done,
     /* 1912459 */   // Label 25711: @1912459
     /* 1912459 */   GIM_Try, /*On fail goto*//*Label 25712*/ GIMT_Encode4(1912545), // Rule ID 19620 //
     /* 1912464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1912475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1912478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1912481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912510 */     // MIs[0] policy
     /* 1912510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1912523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912544 */     // GIR_Coverage, 19620,
     /* 1912544 */     GIR_EraseRootFromParent_Done,
     /* 1912545 */   // Label 25712: @1912545
     /* 1912545 */   GIM_Try, /*On fail goto*//*Label 25713*/ GIMT_Encode4(1912631), // Rule ID 19621 //
     /* 1912550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1912561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1912564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1912567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1912573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1912580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1912588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912596 */     // MIs[0] policy
     /* 1912596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912606 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M2_E16_MASK),
     /* 1912609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912630 */     // GIR_Coverage, 19621,
     /* 1912630 */     GIR_EraseRootFromParent_Done,
     /* 1912631 */   // Label 25713: @1912631
     /* 1912631 */   GIM_Try, /*On fail goto*//*Label 25714*/ GIMT_Encode4(1912717), // Rule ID 19624 //
     /* 1912636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912682 */     // MIs[0] policy
     /* 1912682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912692 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1912695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912716 */     // GIR_Coverage, 19624,
     /* 1912716 */     GIR_EraseRootFromParent_Done,
     /* 1912717 */   // Label 25714: @1912717
     /* 1912717 */   GIM_Try, /*On fail goto*//*Label 25715*/ GIMT_Encode4(1912803), // Rule ID 19625 //
     /* 1912722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1912733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1912736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1912739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1912745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1912752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1912760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912768 */     // MIs[0] policy
     /* 1912768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912778 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M4_E16_MASK),
     /* 1912781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912802 */     // GIR_Coverage, 19625,
     /* 1912802 */     GIR_EraseRootFromParent_Done,
     /* 1912803 */   // Label 25715: @1912803
     /* 1912803 */   GIM_Try, /*On fail goto*//*Label 25716*/ GIMT_Encode4(1912889), // Rule ID 19628 //
     /* 1912808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1912811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1912834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912854 */     // MIs[0] policy
     /* 1912854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912864 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1912864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1912867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912888 */     // GIR_Coverage, 19628,
     /* 1912888 */     GIR_EraseRootFromParent_Done,
     /* 1912889 */   // Label 25716: @1912889
     /* 1912889 */   GIM_Try, /*On fail goto*//*Label 25717*/ GIMT_Encode4(1912975), // Rule ID 19629 //
     /* 1912894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1912897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1912905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1912908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1912911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1912914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1912917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1912920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1912924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1912932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1912936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1912940 */     // MIs[0] policy
     /* 1912940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1912943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1912950 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1912950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR16_M8_E16_MASK),
     /* 1912953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1912955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1912957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1912959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1912961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1912963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1912968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1912971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1912973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1912974 */     // GIR_Coverage, 19629,
     /* 1912974 */     GIR_EraseRootFromParent_Done,
     /* 1912975 */   // Label 25717: @1912975
     /* 1912975 */   GIM_Try, /*On fail goto*//*Label 25718*/ GIMT_Encode4(1913061), // Rule ID 19632 //
     /* 1912980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1912983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1912988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1912991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1912994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1912997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913026 */     // MIs[0] policy
     /* 1913026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913036 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1913039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913060 */     // GIR_Coverage, 19632,
     /* 1913060 */     GIR_EraseRootFromParent_Done,
     /* 1913061 */   // Label 25718: @1913061
     /* 1913061 */   GIM_Try, /*On fail goto*//*Label 25719*/ GIMT_Encode4(1913147), // Rule ID 19633 //
     /* 1913066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1913077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1913080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1913083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913112 */     // MIs[0] policy
     /* 1913112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913122 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M2_E32_MASK),
     /* 1913125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913146 */     // GIR_Coverage, 19633,
     /* 1913146 */     GIR_EraseRootFromParent_Done,
     /* 1913147 */   // Label 25719: @1913147
     /* 1913147 */   GIM_Try, /*On fail goto*//*Label 25720*/ GIMT_Encode4(1913233), // Rule ID 19636 //
     /* 1913152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913198 */     // MIs[0] policy
     /* 1913198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913208 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1913211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913232 */     // GIR_Coverage, 19636,
     /* 1913232 */     GIR_EraseRootFromParent_Done,
     /* 1913233 */   // Label 25720: @1913233
     /* 1913233 */   GIM_Try, /*On fail goto*//*Label 25721*/ GIMT_Encode4(1913319), // Rule ID 19637 //
     /* 1913238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1913249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1913252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1913255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913284 */     // MIs[0] policy
     /* 1913284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913294 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M4_E32_MASK),
     /* 1913297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913318 */     // GIR_Coverage, 19637,
     /* 1913318 */     GIR_EraseRootFromParent_Done,
     /* 1913319 */   // Label 25721: @1913319
     /* 1913319 */   GIM_Try, /*On fail goto*//*Label 25722*/ GIMT_Encode4(1913405), // Rule ID 19640 //
     /* 1913324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1913327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1913335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1913338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1913341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913370 */     // MIs[0] policy
     /* 1913370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913380 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1913383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913404 */     // GIR_Coverage, 19640,
     /* 1913404 */     GIR_EraseRootFromParent_Done,
     /* 1913405 */   // Label 25722: @1913405
     /* 1913405 */   GIM_Try, /*On fail goto*//*Label 25723*/ GIMT_Encode4(1913491), // Rule ID 19641 //
     /* 1913410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1913413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1913421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1913424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1913427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1913430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1913433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1913452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913456 */     // MIs[0] policy
     /* 1913456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913466 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR32_M8_E32_MASK),
     /* 1913469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1913487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913490 */     // GIR_Coverage, 19641,
     /* 1913490 */     GIR_EraseRootFromParent_Done,
     /* 1913491 */   // Label 25723: @1913491
     /* 1913491 */   GIM_Try, /*On fail goto*//*Label 25724*/ GIMT_Encode4(1913577), // Rule ID 19644 //
     /* 1913496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1913507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1913510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1913513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913542 */     // MIs[0] policy
     /* 1913542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913552 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1913555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913576 */     // GIR_Coverage, 19644,
     /* 1913576 */     GIR_EraseRootFromParent_Done,
     /* 1913577 */   // Label 25724: @1913577
     /* 1913577 */   GIM_Try, /*On fail goto*//*Label 25725*/ GIMT_Encode4(1913663), // Rule ID 19645 //
     /* 1913582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1913593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1913596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1913599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1913605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1913612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1913620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913628 */     // MIs[0] policy
     /* 1913628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913638 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11201:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M2_E64_MASK),
     /* 1913641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913662 */     // GIR_Coverage, 19645,
     /* 1913662 */     GIR_EraseRootFromParent_Done,
     /* 1913663 */   // Label 25725: @1913663
     /* 1913663 */   GIM_Try, /*On fail goto*//*Label 25726*/ GIMT_Encode4(1913749), // Rule ID 19648 //
     /* 1913668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913714 */     // MIs[0] policy
     /* 1913714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913724 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1913727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913748 */     // GIR_Coverage, 19648,
     /* 1913748 */     GIR_EraseRootFromParent_Done,
     /* 1913749 */   // Label 25726: @1913749
     /* 1913749 */   GIM_Try, /*On fail goto*//*Label 25727*/ GIMT_Encode4(1913835), // Rule ID 19649 //
     /* 1913754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1913765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1913768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1913771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1913777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1913784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1913792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913800 */     // MIs[0] policy
     /* 1913800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913810 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11201:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M4_E64_MASK),
     /* 1913813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913834 */     // GIR_Coverage, 19649,
     /* 1913834 */     GIR_EraseRootFromParent_Done,
     /* 1913835 */   // Label 25727: @1913835
     /* 1913835 */   GIM_Try, /*On fail goto*//*Label 25728*/ GIMT_Encode4(1913921), // Rule ID 19652 //
     /* 1913840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1913843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1913866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913886 */     // MIs[0] policy
     /* 1913886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913896 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1913896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1913899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1913914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1913917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1913919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1913920 */     // GIR_Coverage, 19652,
     /* 1913920 */     GIR_EraseRootFromParent_Done,
     /* 1913921 */   // Label 25728: @1913921
     /* 1913921 */   GIM_Try, /*On fail goto*//*Label 25729*/ GIMT_Encode4(1914007), // Rule ID 19653 //
     /* 1913926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1913929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsgnjx_mask),
     /* 1913934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1913937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1913940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1913943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1913946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1913949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1913952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1913956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1913964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1913968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1913972 */     // MIs[0] policy
     /* 1913972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1913975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1913982 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11201:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSGNJX_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1913982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VFPR64_M8_E64_MASK),
     /* 1913985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1913987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1913989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1913991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1913993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1913995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1914003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914006 */     // GIR_Coverage, 19653,
     /* 1914006 */     GIR_EraseRootFromParent_Done,
     /* 1914007 */   // Label 25729: @1914007
     /* 1914007 */   GIM_Try, /*On fail goto*//*Label 25730*/ GIMT_Encode4(1914093), // Rule ID 23494 //
     /* 1914012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1914023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1914026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1914029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914058 */     // MIs[0] policy
     /* 1914058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914068 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1914071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914092 */     // GIR_Coverage, 23494,
     /* 1914092 */     GIR_EraseRootFromParent_Done,
     /* 1914093 */   // Label 25730: @1914093
     /* 1914093 */   GIM_Try, /*On fail goto*//*Label 25731*/ GIMT_Encode4(1914179), // Rule ID 23495 //
     /* 1914098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1914109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1914112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1914115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914144 */     // MIs[0] policy
     /* 1914144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914154 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 1914157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914178 */     // GIR_Coverage, 23495,
     /* 1914178 */     GIR_EraseRootFromParent_Done,
     /* 1914179 */   // Label 25731: @1914179
     /* 1914179 */   GIM_Try, /*On fail goto*//*Label 25732*/ GIMT_Encode4(1914265), // Rule ID 23498 //
     /* 1914184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1914195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1914198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1914201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914230 */     // MIs[0] policy
     /* 1914230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914240 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1914243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914264 */     // GIR_Coverage, 23498,
     /* 1914264 */     GIR_EraseRootFromParent_Done,
     /* 1914265 */   // Label 25732: @1914265
     /* 1914265 */   GIM_Try, /*On fail goto*//*Label 25733*/ GIMT_Encode4(1914351), // Rule ID 23499 //
     /* 1914270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1914281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1914284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1914287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914316 */     // MIs[0] policy
     /* 1914316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914326 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1914329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914350 */     // GIR_Coverage, 23499,
     /* 1914350 */     GIR_EraseRootFromParent_Done,
     /* 1914351 */   // Label 25733: @1914351
     /* 1914351 */   GIM_Try, /*On fail goto*//*Label 25734*/ GIMT_Encode4(1914437), // Rule ID 23502 //
     /* 1914356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1914367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1914370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1914373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914402 */     // MIs[0] policy
     /* 1914402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914412 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1914415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914436 */     // GIR_Coverage, 23502,
     /* 1914436 */     GIR_EraseRootFromParent_Done,
     /* 1914437 */   // Label 25734: @1914437
     /* 1914437 */   GIM_Try, /*On fail goto*//*Label 25735*/ GIMT_Encode4(1914523), // Rule ID 23503 //
     /* 1914442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1914453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1914456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1914459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1914465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914488 */     // MIs[0] policy
     /* 1914488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914498 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1914501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1914519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914522 */     // GIR_Coverage, 23503,
     /* 1914522 */     GIR_EraseRootFromParent_Done,
     /* 1914523 */   // Label 25735: @1914523
     /* 1914523 */   GIM_Try, /*On fail goto*//*Label 25736*/ GIMT_Encode4(1914609), // Rule ID 23506 //
     /* 1914528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1914539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1914542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1914545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914574 */     // MIs[0] policy
     /* 1914574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914584 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1914587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914608 */     // GIR_Coverage, 23506,
     /* 1914608 */     GIR_EraseRootFromParent_Done,
     /* 1914609 */   // Label 25736: @1914609
     /* 1914609 */   GIM_Try, /*On fail goto*//*Label 25737*/ GIMT_Encode4(1914695), // Rule ID 23507 //
     /* 1914614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1914625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1914628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1914631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914660 */     // MIs[0] policy
     /* 1914660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914670 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1914673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914675 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914694 */     // GIR_Coverage, 23507,
     /* 1914694 */     GIR_EraseRootFromParent_Done,
     /* 1914695 */   // Label 25737: @1914695
     /* 1914695 */   GIM_Try, /*On fail goto*//*Label 25738*/ GIMT_Encode4(1914781), // Rule ID 23510 //
     /* 1914700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1914711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1914714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1914717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914746 */     // MIs[0] policy
     /* 1914746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1914759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914780 */     // GIR_Coverage, 23510,
     /* 1914780 */     GIR_EraseRootFromParent_Done,
     /* 1914781 */   // Label 25738: @1914781
     /* 1914781 */   GIM_Try, /*On fail goto*//*Label 25739*/ GIMT_Encode4(1914867), // Rule ID 23511 //
     /* 1914786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1914797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1914800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1914803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1914809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914832 */     // MIs[0] policy
     /* 1914832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914842 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1914842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1914845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1914863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914866 */     // GIR_Coverage, 23511,
     /* 1914866 */     GIR_EraseRootFromParent_Done,
     /* 1914867 */   // Label 25739: @1914867
     /* 1914867 */   GIM_Try, /*On fail goto*//*Label 25740*/ GIMT_Encode4(1914953), // Rule ID 23514 //
     /* 1914872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1914875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1914883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1914886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1914889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1914892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1914898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1914914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1914918 */     // MIs[0] policy
     /* 1914918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1914921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1914928 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1914928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1914931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1914933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1914935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1914937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1914939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1914941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1914946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1914949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1914951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1914952 */     // GIR_Coverage, 23514,
     /* 1914952 */     GIR_EraseRootFromParent_Done,
     /* 1914953 */   // Label 25740: @1914953
     /* 1914953 */   GIM_Try, /*On fail goto*//*Label 25741*/ GIMT_Encode4(1915039), // Rule ID 23515 //
     /* 1914958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1914961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1914966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1914969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1914972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1914975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1914978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1914981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1914984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1914988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1914996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915004 */     // MIs[0] policy
     /* 1915004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915014 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1915017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915038 */     // GIR_Coverage, 23515,
     /* 1915038 */     GIR_EraseRootFromParent_Done,
     /* 1915039 */   // Label 25741: @1915039
     /* 1915039 */   GIM_Try, /*On fail goto*//*Label 25742*/ GIMT_Encode4(1915125), // Rule ID 23518 //
     /* 1915044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1915055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1915058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1915061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915090 */     // MIs[0] policy
     /* 1915090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915100 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915124 */     // GIR_Coverage, 23518,
     /* 1915124 */     GIR_EraseRootFromParent_Done,
     /* 1915125 */   // Label 25742: @1915125
     /* 1915125 */   GIM_Try, /*On fail goto*//*Label 25743*/ GIMT_Encode4(1915211), // Rule ID 23519 //
     /* 1915130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1915141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1915144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1915147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1915153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915176 */     // MIs[0] policy
     /* 1915176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915186 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11483:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915210 */     // GIR_Coverage, 23519,
     /* 1915210 */     GIR_EraseRootFromParent_Done,
     /* 1915211 */   // Label 25743: @1915211
     /* 1915211 */   GIM_Try, /*On fail goto*//*Label 25744*/ GIMT_Encode4(1915297), // Rule ID 23522 //
     /* 1915216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1915227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1915230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1915233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915262 */     // MIs[0] policy
     /* 1915262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915272 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915296 */     // GIR_Coverage, 23522,
     /* 1915296 */     GIR_EraseRootFromParent_Done,
     /* 1915297 */   // Label 25744: @1915297
     /* 1915297 */   GIM_Try, /*On fail goto*//*Label 25745*/ GIMT_Encode4(1915383), // Rule ID 23523 //
     /* 1915302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1915313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1915316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1915319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1915325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915348 */     // MIs[0] policy
     /* 1915348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915358 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1915379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915382 */     // GIR_Coverage, 23523,
     /* 1915382 */     GIR_EraseRootFromParent_Done,
     /* 1915383 */   // Label 25745: @1915383
     /* 1915383 */   GIM_Try, /*On fail goto*//*Label 25746*/ GIMT_Encode4(1915469), // Rule ID 23526 //
     /* 1915388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1915399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1915402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1915405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915434 */     // MIs[0] policy
     /* 1915434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915444 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915468 */     // GIR_Coverage, 23526,
     /* 1915468 */     GIR_EraseRootFromParent_Done,
     /* 1915469 */   // Label 25746: @1915469
     /* 1915469 */   GIM_Try, /*On fail goto*//*Label 25747*/ GIMT_Encode4(1915555), // Rule ID 23527 //
     /* 1915474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1915485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1915488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1915491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1915497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915520 */     // MIs[0] policy
     /* 1915520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915530 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1915551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915554 */     // GIR_Coverage, 23527,
     /* 1915554 */     GIR_EraseRootFromParent_Done,
     /* 1915555 */   // Label 25747: @1915555
     /* 1915555 */   GIM_Try, /*On fail goto*//*Label 25748*/ GIMT_Encode4(1915641), // Rule ID 23530 //
     /* 1915560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1915563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1915571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1915574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1915577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915606 */     // MIs[0] policy
     /* 1915606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915616 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915640 */     // GIR_Coverage, 23530,
     /* 1915640 */     GIR_EraseRootFromParent_Done,
     /* 1915641 */   // Label 25748: @1915641
     /* 1915641 */   GIM_Try, /*On fail goto*//*Label 25749*/ GIMT_Encode4(1915727), // Rule ID 23531 //
     /* 1915646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1915649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1915657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1915660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1915663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1915669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1915676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1915684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915692 */     // MIs[0] policy
     /* 1915692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915702 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1915705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1915723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915726 */     // GIR_Coverage, 23531,
     /* 1915726 */     GIR_EraseRootFromParent_Done,
     /* 1915727 */   // Label 25749: @1915727
     /* 1915727 */   GIM_Try, /*On fail goto*//*Label 25750*/ GIMT_Encode4(1915813), // Rule ID 23534 //
     /* 1915732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1915743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1915746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1915749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915778 */     // MIs[0] policy
     /* 1915778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1915791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915812 */     // GIR_Coverage, 23534,
     /* 1915812 */     GIR_EraseRootFromParent_Done,
     /* 1915813 */   // Label 25750: @1915813
     /* 1915813 */   GIM_Try, /*On fail goto*//*Label 25751*/ GIMT_Encode4(1915899), // Rule ID 23535 //
     /* 1915818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1915829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1915832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1915835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1915838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1915841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1915844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1915848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1915856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915864 */     // MIs[0] policy
     /* 1915864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915874 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1915874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1915877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915898 */     // GIR_Coverage, 23535,
     /* 1915898 */     GIR_EraseRootFromParent_Done,
     /* 1915899 */   // Label 25751: @1915899
     /* 1915899 */   GIM_Try, /*On fail goto*//*Label 25752*/ GIMT_Encode4(1915985), // Rule ID 23538 //
     /* 1915904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1915907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1915915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1915918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1915921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1915924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1915927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1915930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1915934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1915942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1915946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1915950 */     // MIs[0] policy
     /* 1915950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1915953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1915960 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1915960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1915963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1915965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1915967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1915969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1915971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1915973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1915978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1915981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1915983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1915984 */     // GIR_Coverage, 23538,
     /* 1915984 */     GIR_EraseRootFromParent_Done,
     /* 1915985 */   // Label 25752: @1915985
     /* 1915985 */   GIM_Try, /*On fail goto*//*Label 25753*/ GIMT_Encode4(1916071), // Rule ID 23539 //
     /* 1915990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1915993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1915998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1916001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1916004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1916007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916036 */     // MIs[0] policy
     /* 1916036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916046 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1916049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1916067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916070 */     // GIR_Coverage, 23539,
     /* 1916070 */     GIR_EraseRootFromParent_Done,
     /* 1916071 */   // Label 25753: @1916071
     /* 1916071 */   GIM_Try, /*On fail goto*//*Label 25754*/ GIMT_Encode4(1916157), // Rule ID 23542 //
     /* 1916076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1916087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1916090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1916093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1916099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916122 */     // MIs[0] policy
     /* 1916122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916132 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1916135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1916153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916156 */     // GIR_Coverage, 23542,
     /* 1916156 */     GIR_EraseRootFromParent_Done,
     /* 1916157 */   // Label 25754: @1916157
     /* 1916157 */   GIM_Try, /*On fail goto*//*Label 25755*/ GIMT_Encode4(1916243), // Rule ID 23543 //
     /* 1916162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1916173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1916176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1916179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1916185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916208 */     // MIs[0] policy
     /* 1916208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916218 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1916221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1916239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916242 */     // GIR_Coverage, 23543,
     /* 1916242 */     GIR_EraseRootFromParent_Done,
     /* 1916243 */   // Label 25755: @1916243
     /* 1916243 */   GIM_Try, /*On fail goto*//*Label 25756*/ GIMT_Encode4(1916329), // Rule ID 23546 //
     /* 1916248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916294 */     // MIs[0] policy
     /* 1916294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916304 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1916307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916328 */     // GIR_Coverage, 23546,
     /* 1916328 */     GIR_EraseRootFromParent_Done,
     /* 1916329 */   // Label 25756: @1916329
     /* 1916329 */   GIM_Try, /*On fail goto*//*Label 25757*/ GIMT_Encode4(1916415), // Rule ID 23547 //
     /* 1916334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1916345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1916348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1916351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916380 */     // MIs[0] policy
     /* 1916380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916390 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1916393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916414 */     // GIR_Coverage, 23547,
     /* 1916414 */     GIR_EraseRootFromParent_Done,
     /* 1916415 */   // Label 25757: @1916415
     /* 1916415 */   GIM_Try, /*On fail goto*//*Label 25758*/ GIMT_Encode4(1916501), // Rule ID 23550 //
     /* 1916420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916466 */     // MIs[0] policy
     /* 1916466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916476 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1916479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916500 */     // GIR_Coverage, 23550,
     /* 1916500 */     GIR_EraseRootFromParent_Done,
     /* 1916501 */   // Label 25758: @1916501
     /* 1916501 */   GIM_Try, /*On fail goto*//*Label 25759*/ GIMT_Encode4(1916587), // Rule ID 23551 //
     /* 1916506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1916517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1916520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1916523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1916529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916552 */     // MIs[0] policy
     /* 1916552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916562 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1916565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916586 */     // GIR_Coverage, 23551,
     /* 1916586 */     GIR_EraseRootFromParent_Done,
     /* 1916587 */   // Label 25759: @1916587
     /* 1916587 */   GIM_Try, /*On fail goto*//*Label 25760*/ GIMT_Encode4(1916673), // Rule ID 23554 //
     /* 1916592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916638 */     // MIs[0] policy
     /* 1916638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916648 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1916651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916653 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916672 */     // GIR_Coverage, 23554,
     /* 1916672 */     GIR_EraseRootFromParent_Done,
     /* 1916673 */   // Label 25760: @1916673
     /* 1916673 */   GIM_Try, /*On fail goto*//*Label 25761*/ GIMT_Encode4(1916759), // Rule ID 23555 //
     /* 1916678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1916689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1916692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1916695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1916701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1916708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1916716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916724 */     // MIs[0] policy
     /* 1916724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916734 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1916737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1916755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916758 */     // GIR_Coverage, 23555,
     /* 1916758 */     GIR_EraseRootFromParent_Done,
     /* 1916759 */   // Label 25761: @1916759
     /* 1916759 */   GIM_Try, /*On fail goto*//*Label 25762*/ GIMT_Encode4(1916845), // Rule ID 23558 //
     /* 1916764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1916775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1916778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1916781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916810 */     // MIs[0] policy
     /* 1916810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1916823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916844 */     // GIR_Coverage, 23558,
     /* 1916844 */     GIR_EraseRootFromParent_Done,
     /* 1916845 */   // Label 25762: @1916845
     /* 1916845 */   GIM_Try, /*On fail goto*//*Label 25763*/ GIMT_Encode4(1916931), // Rule ID 23559 //
     /* 1916850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1916853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1916861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1916864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1916867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1916870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1916873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1916876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1916880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1916888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916896 */     // MIs[0] policy
     /* 1916896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1916906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1916909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1916915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1916917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1916919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1916924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1916927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1916929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1916930 */     // GIR_Coverage, 23559,
     /* 1916930 */     GIR_EraseRootFromParent_Done,
     /* 1916931 */   // Label 25763: @1916931
     /* 1916931 */   GIM_Try, /*On fail goto*//*Label 25764*/ GIMT_Encode4(1917017), // Rule ID 23562 //
     /* 1916936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1916939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1916944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1916947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1916950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1916953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1916956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1916959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1916962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1916966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1916974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1916978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1916982 */     // MIs[0] policy
     /* 1916982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1916985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1916992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1916992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1916995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1916997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1916999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917016 */     // GIR_Coverage, 23562,
     /* 1917016 */     GIR_EraseRootFromParent_Done,
     /* 1917017 */   // Label 25764: @1917017
     /* 1917017 */   GIM_Try, /*On fail goto*//*Label 25765*/ GIMT_Encode4(1917103), // Rule ID 23563 //
     /* 1917022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1917033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1917036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1917039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917068 */     // MIs[0] policy
     /* 1917068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1917081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917102 */     // GIR_Coverage, 23563,
     /* 1917102 */     GIR_EraseRootFromParent_Done,
     /* 1917103 */   // Label 25765: @1917103
     /* 1917103 */   GIM_Try, /*On fail goto*//*Label 25766*/ GIMT_Encode4(1917189), // Rule ID 23566 //
     /* 1917108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917154 */     // MIs[0] policy
     /* 1917154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1917167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917188 */     // GIR_Coverage, 23566,
     /* 1917188 */     GIR_EraseRootFromParent_Done,
     /* 1917189 */   // Label 25766: @1917189
     /* 1917189 */   GIM_Try, /*On fail goto*//*Label 25767*/ GIMT_Encode4(1917275), // Rule ID 23567 //
     /* 1917194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1917205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1917208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1917211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1917217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917240 */     // MIs[0] policy
     /* 1917240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1917253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1917271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917274 */     // GIR_Coverage, 23567,
     /* 1917274 */     GIR_EraseRootFromParent_Done,
     /* 1917275 */   // Label 25767: @1917275
     /* 1917275 */   GIM_Try, /*On fail goto*//*Label 25768*/ GIMT_Encode4(1917361), // Rule ID 23570 //
     /* 1917280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1917283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917326 */     // MIs[0] policy
     /* 1917326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1917339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917360 */     // GIR_Coverage, 23570,
     /* 1917360 */     GIR_EraseRootFromParent_Done,
     /* 1917361 */   // Label 25768: @1917361
     /* 1917361 */   GIM_Try, /*On fail goto*//*Label 25769*/ GIMT_Encode4(1917447), // Rule ID 23571 //
     /* 1917366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1917369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1917377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1917380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1917383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1917396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1917404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917412 */     // MIs[0] policy
     /* 1917412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917422 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1917425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917446 */     // GIR_Coverage, 23571,
     /* 1917446 */     GIR_EraseRootFromParent_Done,
     /* 1917447 */   // Label 25769: @1917447
     /* 1917447 */   GIM_Try, /*On fail goto*//*Label 25770*/ GIMT_Encode4(1917533), // Rule ID 23574 //
     /* 1917452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1917455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917498 */     // MIs[0] policy
     /* 1917498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917508 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1917511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917532 */     // GIR_Coverage, 23574,
     /* 1917532 */     GIR_EraseRootFromParent_Done,
     /* 1917533 */   // Label 25770: @1917533
     /* 1917533 */   GIM_Try, /*On fail goto*//*Label 25771*/ GIMT_Encode4(1917619), // Rule ID 23575 //
     /* 1917538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1917541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1917549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1917552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1917555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1917561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1917568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1917576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917584 */     // MIs[0] policy
     /* 1917584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917594 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1917597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917618 */     // GIR_Coverage, 23575,
     /* 1917618 */     GIR_EraseRootFromParent_Done,
     /* 1917619 */   // Label 25771: @1917619
     /* 1917619 */   GIM_Try, /*On fail goto*//*Label 25772*/ GIMT_Encode4(1917705), // Rule ID 23578 //
     /* 1917624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1917627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917670 */     // MIs[0] policy
     /* 1917670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917680 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1917683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917704 */     // GIR_Coverage, 23578,
     /* 1917704 */     GIR_EraseRootFromParent_Done,
     /* 1917705 */   // Label 25772: @1917705
     /* 1917705 */   GIM_Try, /*On fail goto*//*Label 25773*/ GIMT_Encode4(1917791), // Rule ID 23579 //
     /* 1917710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1917713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1917718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1917721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1917724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1917727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1917733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1917740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1917748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917756 */     // MIs[0] policy
     /* 1917756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917766 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1917769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1917787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917790 */     // GIR_Coverage, 23579,
     /* 1917790 */     GIR_EraseRootFromParent_Done,
     /* 1917791 */   // Label 25773: @1917791
     /* 1917791 */   GIM_Try, /*On fail goto*//*Label 25774*/ GIMT_Encode4(1917877), // Rule ID 23670 //
     /* 1917796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1917804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1917807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1917810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1917813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917842 */     // MIs[0] policy
     /* 1917842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917852 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1917852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1917855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917876 */     // GIR_Coverage, 23670,
     /* 1917876 */     GIR_EraseRootFromParent_Done,
     /* 1917877 */   // Label 25774: @1917877
     /* 1917877 */   GIM_Try, /*On fail goto*//*Label 25775*/ GIMT_Encode4(1917963), // Rule ID 23671 //
     /* 1917882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1917885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1917890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1917893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1917896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1917899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1917902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1917905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1917908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1917920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1917924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1917928 */     // MIs[0] policy
     /* 1917928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1917931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1917938 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs3, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1917938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 1917941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1917943 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1917945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1917947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1917949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1917951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1917956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1917959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1917961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1917962 */     // GIR_Coverage, 23671,
     /* 1917962 */     GIR_EraseRootFromParent_Done,
     /* 1917963 */   // Label 25775: @1917963
     /* 1917963 */   GIM_Try, /*On fail goto*//*Label 25776*/ GIMT_Encode4(1918049), // Rule ID 23674 //
     /* 1917968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1917971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1917976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1917979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1917982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1917985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1917988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1917991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1917994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1917998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918014 */     // MIs[0] policy
     /* 1918014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918024 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1918027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918048 */     // GIR_Coverage, 23674,
     /* 1918048 */     GIR_EraseRootFromParent_Done,
     /* 1918049 */   // Label 25776: @1918049
     /* 1918049 */   GIM_Try, /*On fail goto*//*Label 25777*/ GIMT_Encode4(1918135), // Rule ID 23675 //
     /* 1918054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1918065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1918068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1918071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918100 */     // MIs[0] policy
     /* 1918100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918110 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs3, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1918113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918134 */     // GIR_Coverage, 23675,
     /* 1918134 */     GIR_EraseRootFromParent_Done,
     /* 1918135 */   // Label 25777: @1918135
     /* 1918135 */   GIM_Try, /*On fail goto*//*Label 25778*/ GIMT_Encode4(1918221), // Rule ID 23678 //
     /* 1918140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1918151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1918154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1918157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918186 */     // MIs[0] policy
     /* 1918186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918196 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918220 */     // GIR_Coverage, 23678,
     /* 1918220 */     GIR_EraseRootFromParent_Done,
     /* 1918221 */   // Label 25778: @1918221
     /* 1918221 */   GIM_Try, /*On fail goto*//*Label 25779*/ GIMT_Encode4(1918307), // Rule ID 23679 //
     /* 1918226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1918237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1918240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1918243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1918249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918272 */     // MIs[0] policy
     /* 1918272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918282 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918306 */     // GIR_Coverage, 23679,
     /* 1918306 */     GIR_EraseRootFromParent_Done,
     /* 1918307 */   // Label 25779: @1918307
     /* 1918307 */   GIM_Try, /*On fail goto*//*Label 25780*/ GIMT_Encode4(1918393), // Rule ID 23682 //
     /* 1918312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918358 */     // MIs[0] policy
     /* 1918358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918368 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1918371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918392 */     // GIR_Coverage, 23682,
     /* 1918392 */     GIR_EraseRootFromParent_Done,
     /* 1918393 */   // Label 25780: @1918393
     /* 1918393 */   GIM_Try, /*On fail goto*//*Label 25781*/ GIMT_Encode4(1918479), // Rule ID 23683 //
     /* 1918398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1918409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1918412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1918415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918444 */     // MIs[0] policy
     /* 1918444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918454 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs3, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1918457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918478 */     // GIR_Coverage, 23683,
     /* 1918478 */     GIR_EraseRootFromParent_Done,
     /* 1918479 */   // Label 25781: @1918479
     /* 1918479 */   GIM_Try, /*On fail goto*//*Label 25782*/ GIMT_Encode4(1918565), // Rule ID 23686 //
     /* 1918484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918530 */     // MIs[0] policy
     /* 1918530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918540 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918564 */     // GIR_Coverage, 23686,
     /* 1918564 */     GIR_EraseRootFromParent_Done,
     /* 1918565 */   // Label 25782: @1918565
     /* 1918565 */   GIM_Try, /*On fail goto*//*Label 25783*/ GIMT_Encode4(1918651), // Rule ID 23687 //
     /* 1918570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1918581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1918584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1918587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1918593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918616 */     // MIs[0] policy
     /* 1918616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918626 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs3, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1918647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918650 */     // GIR_Coverage, 23687,
     /* 1918650 */     GIR_EraseRootFromParent_Done,
     /* 1918651 */   // Label 25783: @1918651
     /* 1918651 */   GIM_Try, /*On fail goto*//*Label 25784*/ GIMT_Encode4(1918737), // Rule ID 23690 //
     /* 1918656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918702 */     // MIs[0] policy
     /* 1918702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918712 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918736 */     // GIR_Coverage, 23690,
     /* 1918736 */     GIR_EraseRootFromParent_Done,
     /* 1918737 */   // Label 25784: @1918737
     /* 1918737 */   GIM_Try, /*On fail goto*//*Label 25785*/ GIMT_Encode4(1918823), // Rule ID 23691 //
     /* 1918742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1918753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1918756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1918759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1918765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918788 */     // MIs[0] policy
     /* 1918788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918798 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1918801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1918819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918822 */     // GIR_Coverage, 23691,
     /* 1918822 */     GIR_EraseRootFromParent_Done,
     /* 1918823 */   // Label 25785: @1918823
     /* 1918823 */   GIM_Try, /*On fail goto*//*Label 25786*/ GIMT_Encode4(1918909), // Rule ID 23694 //
     /* 1918828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1918831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1918839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1918842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1918845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1918848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1918854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918874 */     // MIs[0] policy
     /* 1918874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918884 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1918884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1918887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918908 */     // GIR_Coverage, 23694,
     /* 1918908 */     GIR_EraseRootFromParent_Done,
     /* 1918909 */   // Label 25786: @1918909
     /* 1918909 */   GIM_Try, /*On fail goto*//*Label 25787*/ GIMT_Encode4(1918995), // Rule ID 23695 //
     /* 1918914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1918917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1918922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1918925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1918928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1918931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1918934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1918937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1918940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1918944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1918952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1918956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1918960 */     // MIs[0] policy
     /* 1918960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1918963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1918970 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11481:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1918970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1918973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1918975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1918977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1918979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1918981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1918983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1918988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1918991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1918993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1918994 */     // GIR_Coverage, 23695,
     /* 1918994 */     GIR_EraseRootFromParent_Done,
     /* 1918995 */   // Label 25787: @1918995
     /* 1918995 */   GIM_Try, /*On fail goto*//*Label 25788*/ GIMT_Encode4(1919081), // Rule ID 23698 //
     /* 1919000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919046 */     // MIs[0] policy
     /* 1919046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919056 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919080 */     // GIR_Coverage, 23698,
     /* 1919080 */     GIR_EraseRootFromParent_Done,
     /* 1919081 */   // Label 25788: @1919081
     /* 1919081 */   GIM_Try, /*On fail goto*//*Label 25789*/ GIMT_Encode4(1919167), // Rule ID 23699 //
     /* 1919086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1919097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1919100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1919103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1919109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919132 */     // MIs[0] policy
     /* 1919132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919142 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs3, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1919163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919166 */     // GIR_Coverage, 23699,
     /* 1919166 */     GIR_EraseRootFromParent_Done,
     /* 1919167 */   // Label 25789: @1919167
     /* 1919167 */   GIM_Try, /*On fail goto*//*Label 25790*/ GIMT_Encode4(1919253), // Rule ID 23702 //
     /* 1919172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919218 */     // MIs[0] policy
     /* 1919218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919252 */     // GIR_Coverage, 23702,
     /* 1919252 */     GIR_EraseRootFromParent_Done,
     /* 1919253 */   // Label 25790: @1919253
     /* 1919253 */   GIM_Try, /*On fail goto*//*Label 25791*/ GIMT_Encode4(1919339), // Rule ID 23703 //
     /* 1919258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1919269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1919272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1919275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1919281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919304 */     // MIs[0] policy
     /* 1919304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1919335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919338 */     // GIR_Coverage, 23703,
     /* 1919338 */     GIR_EraseRootFromParent_Done,
     /* 1919339 */   // Label 25791: @1919339
     /* 1919339 */   GIM_Try, /*On fail goto*//*Label 25792*/ GIMT_Encode4(1919425), // Rule ID 23706 //
     /* 1919344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1919347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919390 */     // MIs[0] policy
     /* 1919390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919400 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919424 */     // GIR_Coverage, 23706,
     /* 1919424 */     GIR_EraseRootFromParent_Done,
     /* 1919425 */   // Label 25792: @1919425
     /* 1919425 */   GIM_Try, /*On fail goto*//*Label 25793*/ GIMT_Encode4(1919511), // Rule ID 23707 //
     /* 1919430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1919433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1919441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1919444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1919447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1919453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1919460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1919468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919476 */     // MIs[0] policy
     /* 1919476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919486 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs3, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1919489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1919507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919510 */     // GIR_Coverage, 23707,
     /* 1919510 */     GIR_EraseRootFromParent_Done,
     /* 1919511 */   // Label 25793: @1919511
     /* 1919511 */   GIM_Try, /*On fail goto*//*Label 25794*/ GIMT_Encode4(1919597), // Rule ID 23710 //
     /* 1919516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1919527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1919530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1919533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919562 */     // MIs[0] policy
     /* 1919562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919572 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1919575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919596 */     // GIR_Coverage, 23710,
     /* 1919596 */     GIR_EraseRootFromParent_Done,
     /* 1919597 */   // Label 25794: @1919597
     /* 1919597 */   GIM_Try, /*On fail goto*//*Label 25795*/ GIMT_Encode4(1919683), // Rule ID 23711 //
     /* 1919602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1919613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1919616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1919619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1919625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1919632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1919640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919648 */     // MIs[0] policy
     /* 1919648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919658 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1919661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919682 */     // GIR_Coverage, 23711,
     /* 1919682 */     GIR_EraseRootFromParent_Done,
     /* 1919683 */   // Label 25795: @1919683
     /* 1919683 */   GIM_Try, /*On fail goto*//*Label 25796*/ GIMT_Encode4(1919769), // Rule ID 23714 //
     /* 1919688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1919699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1919702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1919705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919734 */     // MIs[0] policy
     /* 1919734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919744 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1919747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919768 */     // GIR_Coverage, 23714,
     /* 1919768 */     GIR_EraseRootFromParent_Done,
     /* 1919769 */   // Label 25796: @1919769
     /* 1919769 */   GIM_Try, /*On fail goto*//*Label 25797*/ GIMT_Encode4(1919855), // Rule ID 23715 //
     /* 1919774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1919785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1919788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1919791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1919797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1919804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1919812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919820 */     // MIs[0] policy
     /* 1919820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919830 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1919830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1919833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919835 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919854 */     // GIR_Coverage, 23715,
     /* 1919854 */     GIR_EraseRootFromParent_Done,
     /* 1919855 */   // Label 25797: @1919855
     /* 1919855 */   GIM_Try, /*On fail goto*//*Label 25798*/ GIMT_Encode4(1919941), // Rule ID 23718 //
     /* 1919860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1919863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1919871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1919874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1919877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1919880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1919883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1919886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919906 */     // MIs[0] policy
     /* 1919906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1919916 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1919916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1919919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1919921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1919923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1919925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1919927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1919929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1919934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1919937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1919939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1919940 */     // GIR_Coverage, 23718,
     /* 1919940 */     GIR_EraseRootFromParent_Done,
     /* 1919941 */   // Label 25798: @1919941
     /* 1919941 */   GIM_Try, /*On fail goto*//*Label 25799*/ GIMT_Encode4(1920027), // Rule ID 23719 //
     /* 1919946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1919949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1919954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1919957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1919960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1919963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1919966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1919969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1919972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1919976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1919984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1919988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1919992 */     // MIs[0] policy
     /* 1919992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1919995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920002 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1920005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920007 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1920023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920026 */     // GIR_Coverage, 23719,
     /* 1920026 */     GIR_EraseRootFromParent_Done,
     /* 1920027 */   // Label 25799: @1920027
     /* 1920027 */   GIM_Try, /*On fail goto*//*Label 25800*/ GIMT_Encode4(1920113), // Rule ID 23722 //
     /* 1920032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920078 */     // MIs[0] policy
     /* 1920078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920088 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1920091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920112 */     // GIR_Coverage, 23722,
     /* 1920112 */     GIR_EraseRootFromParent_Done,
     /* 1920113 */   // Label 25800: @1920113
     /* 1920113 */   GIM_Try, /*On fail goto*//*Label 25801*/ GIMT_Encode4(1920199), // Rule ID 23723 //
     /* 1920118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1920129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1920132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1920135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920164 */     // MIs[0] policy
     /* 1920164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs3, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1920177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920198 */     // GIR_Coverage, 23723,
     /* 1920198 */     GIR_EraseRootFromParent_Done,
     /* 1920199 */   // Label 25801: @1920199
     /* 1920199 */   GIM_Try, /*On fail goto*//*Label 25802*/ GIMT_Encode4(1920285), // Rule ID 23726 //
     /* 1920204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920250 */     // MIs[0] policy
     /* 1920250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920260 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1920263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920284 */     // GIR_Coverage, 23726,
     /* 1920284 */     GIR_EraseRootFromParent_Done,
     /* 1920285 */   // Label 25802: @1920285
     /* 1920285 */   GIM_Try, /*On fail goto*//*Label 25803*/ GIMT_Encode4(1920371), // Rule ID 23727 //
     /* 1920290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1920301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1920304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1920307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920336 */     // MIs[0] policy
     /* 1920336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920346 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs3, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1920349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920370 */     // GIR_Coverage, 23727,
     /* 1920370 */     GIR_EraseRootFromParent_Done,
     /* 1920371 */   // Label 25803: @1920371
     /* 1920371 */   GIM_Try, /*On fail goto*//*Label 25804*/ GIMT_Encode4(1920457), // Rule ID 23730 //
     /* 1920376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1920387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1920390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920422 */     // MIs[0] policy
     /* 1920422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920432 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1920435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920456 */     // GIR_Coverage, 23730,
     /* 1920456 */     GIR_EraseRootFromParent_Done,
     /* 1920457 */   // Label 25804: @1920457
     /* 1920457 */   GIM_Try, /*On fail goto*//*Label 25805*/ GIMT_Encode4(1920543), // Rule ID 23731 //
     /* 1920462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1920473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1920476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1920479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1920485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920508 */     // MIs[0] policy
     /* 1920508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920518 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs3, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1920521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1920539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920542 */     // GIR_Coverage, 23731,
     /* 1920542 */     GIR_EraseRootFromParent_Done,
     /* 1920543 */   // Label 25805: @1920543
     /* 1920543 */   GIM_Try, /*On fail goto*//*Label 25806*/ GIMT_Encode4(1920629), // Rule ID 23734 //
     /* 1920548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920594 */     // MIs[0] policy
     /* 1920594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920604 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1920607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920628 */     // GIR_Coverage, 23734,
     /* 1920628 */     GIR_EraseRootFromParent_Done,
     /* 1920629 */   // Label 25806: @1920629
     /* 1920629 */   GIM_Try, /*On fail goto*//*Label 25807*/ GIMT_Encode4(1920715), // Rule ID 23735 //
     /* 1920634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1920645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1920648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1920651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1920657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1920664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1920672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920680 */     // MIs[0] policy
     /* 1920680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1920693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920714 */     // GIR_Coverage, 23735,
     /* 1920714 */     GIR_EraseRootFromParent_Done,
     /* 1920715 */   // Label 25807: @1920715
     /* 1920715 */   GIM_Try, /*On fail goto*//*Label 25808*/ GIMT_Encode4(1920801), // Rule ID 23738 //
     /* 1920720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920766 */     // MIs[0] policy
     /* 1920766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920776 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1920779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920800 */     // GIR_Coverage, 23738,
     /* 1920800 */     GIR_EraseRootFromParent_Done,
     /* 1920801 */   // Label 25808: @1920801
     /* 1920801 */   GIM_Try, /*On fail goto*//*Label 25809*/ GIMT_Encode4(1920887), // Rule ID 23739 //
     /* 1920806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1920817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1920820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1920823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1920829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1920832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1920836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1920844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920852 */     // MIs[0] policy
     /* 1920852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920862 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1920862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1920865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920886 */     // GIR_Coverage, 23739,
     /* 1920886 */     GIR_EraseRootFromParent_Done,
     /* 1920887 */   // Label 25809: @1920887
     /* 1920887 */   GIM_Try, /*On fail goto*//*Label 25810*/ GIMT_Encode4(1920973), // Rule ID 23742 //
     /* 1920892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1920895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1920912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1920915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1920918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1920922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1920930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1920934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1920938 */     // MIs[0] policy
     /* 1920938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1920941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1920948 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1920948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1920951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1920953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1920955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1920957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1920959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1920961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1920966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1920969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1920971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1920972 */     // GIR_Coverage, 23742,
     /* 1920972 */     GIR_EraseRootFromParent_Done,
     /* 1920973 */   // Label 25810: @1920973
     /* 1920973 */   GIM_Try, /*On fail goto*//*Label 25811*/ GIMT_Encode4(1921059), // Rule ID 23743 //
     /* 1920978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1920981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1920986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1920989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1920992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1920995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1920998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1921001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921024 */     // MIs[0] policy
     /* 1921024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921034 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1921037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1921055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921058 */     // GIR_Coverage, 23743,
     /* 1921058 */     GIR_EraseRootFromParent_Done,
     /* 1921059 */   // Label 25811: @1921059
     /* 1921059 */   GIM_Try, /*On fail goto*//*Label 25812*/ GIMT_Encode4(1921145), // Rule ID 23746 //
     /* 1921064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921110 */     // MIs[0] policy
     /* 1921110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921120 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1921123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921144 */     // GIR_Coverage, 23746,
     /* 1921144 */     GIR_EraseRootFromParent_Done,
     /* 1921145 */   // Label 25812: @1921145
     /* 1921145 */   GIM_Try, /*On fail goto*//*Label 25813*/ GIMT_Encode4(1921231), // Rule ID 23747 //
     /* 1921150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1921153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1921161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1921164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1921167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1921180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1921188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921196 */     // MIs[0] policy
     /* 1921196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs3, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1921209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921230 */     // GIR_Coverage, 23747,
     /* 1921230 */     GIR_EraseRootFromParent_Done,
     /* 1921231 */   // Label 25813: @1921231
     /* 1921231 */   GIM_Try, /*On fail goto*//*Label 25814*/ GIMT_Encode4(1921317), // Rule ID 23750 //
     /* 1921236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921282 */     // MIs[0] policy
     /* 1921282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921292 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1921295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921297 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921316 */     // GIR_Coverage, 23750,
     /* 1921316 */     GIR_EraseRootFromParent_Done,
     /* 1921317 */   // Label 25814: @1921317
     /* 1921317 */   GIM_Try, /*On fail goto*//*Label 25815*/ GIMT_Encode4(1921403), // Rule ID 23751 //
     /* 1921322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1921325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1921333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1921336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1921339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1921352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1921360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921368 */     // MIs[0] policy
     /* 1921368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921378 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs3, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1921381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921402 */     // GIR_Coverage, 23751,
     /* 1921402 */     GIR_EraseRootFromParent_Done,
     /* 1921403 */   // Label 25815: @1921403
     /* 1921403 */   GIM_Try, /*On fail goto*//*Label 25816*/ GIMT_Encode4(1921489), // Rule ID 23754 //
     /* 1921408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1921411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1921419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921454 */     // MIs[0] policy
     /* 1921454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921464 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1921467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921488 */     // GIR_Coverage, 23754,
     /* 1921488 */     GIR_EraseRootFromParent_Done,
     /* 1921489 */   // Label 25816: @1921489
     /* 1921489 */   GIM_Try, /*On fail goto*//*Label 25817*/ GIMT_Encode4(1921575), // Rule ID 23755 //
     /* 1921494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1921497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1921502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1921505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1921508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1921511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1921517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1921524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1921532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921540 */     // MIs[0] policy
     /* 1921540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921550 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs3, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1921553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1921557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1921571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921574 */     // GIR_Coverage, 23755,
     /* 1921574 */     GIR_EraseRootFromParent_Done,
     /* 1921575 */   // Label 25817: @1921575
     /* 1921575 */   GIM_Try, /*On fail goto*//*Label 25818*/ GIMT_Encode4(1921661), // Rule ID 23846 //
     /* 1921580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1921588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921626 */     // MIs[0] policy
     /* 1921626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921636 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1921639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921660 */     // GIR_Coverage, 23846,
     /* 1921660 */     GIR_EraseRootFromParent_Done,
     /* 1921661 */   // Label 25818: @1921661
     /* 1921661 */   GIM_Try, /*On fail goto*//*Label 25819*/ GIMT_Encode4(1921747), // Rule ID 23847 //
     /* 1921666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1921674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1921677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1921680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1921683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1921689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921712 */     // MIs[0] policy
     /* 1921712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921722 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF8_MASK),
     /* 1921725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921746 */     // GIR_Coverage, 23847,
     /* 1921746 */     GIR_EraseRootFromParent_Done,
     /* 1921747 */   // Label 25819: @1921747
     /* 1921747 */   GIM_Try, /*On fail goto*//*Label 25820*/ GIMT_Encode4(1921833), // Rule ID 23850 //
     /* 1921752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1921760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921798 */     // MIs[0] policy
     /* 1921798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921808 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1921811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921832 */     // GIR_Coverage, 23850,
     /* 1921832 */     GIR_EraseRootFromParent_Done,
     /* 1921833 */   // Label 25820: @1921833
     /* 1921833 */   GIM_Try, /*On fail goto*//*Label 25821*/ GIMT_Encode4(1921919), // Rule ID 23851 //
     /* 1921838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1921841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1921846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1921849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1921852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1921855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1921858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1921861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1921864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921884 */     // MIs[0] policy
     /* 1921884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921894 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1921894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1921897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1921915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1921917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1921918 */     // GIR_Coverage, 23851,
     /* 1921918 */     GIR_EraseRootFromParent_Done,
     /* 1921919 */   // Label 25821: @1921919
     /* 1921919 */   GIM_Try, /*On fail goto*//*Label 25822*/ GIMT_Encode4(1922005), // Rule ID 23854 //
     /* 1921924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1921927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1921932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1921935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1921938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1921941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1921944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1921947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1921950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1921954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1921962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1921966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1921970 */     // MIs[0] policy
     /* 1921970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1921973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1921980 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1921980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1921983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1921985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1921987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1921989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1921991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1921993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1921998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922004 */     // GIR_Coverage, 23854,
     /* 1922004 */     GIR_EraseRootFromParent_Done,
     /* 1922005 */   // Label 25822: @1922005
     /* 1922005 */   GIM_Try, /*On fail goto*//*Label 25823*/ GIMT_Encode4(1922091), // Rule ID 23855 //
     /* 1922010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1922021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1922024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1922027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922056 */     // MIs[0] policy
     /* 1922056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922066 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1922069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922090 */     // GIR_Coverage, 23855,
     /* 1922090 */     GIR_EraseRootFromParent_Done,
     /* 1922091 */   // Label 25823: @1922091
     /* 1922091 */   GIM_Try, /*On fail goto*//*Label 25824*/ GIMT_Encode4(1922177), // Rule ID 23858 //
     /* 1922096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1922107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1922110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922142 */     // MIs[0] policy
     /* 1922142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922152 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1922155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922176 */     // GIR_Coverage, 23858,
     /* 1922176 */     GIR_EraseRootFromParent_Done,
     /* 1922177 */   // Label 25824: @1922177
     /* 1922177 */   GIM_Try, /*On fail goto*//*Label 25825*/ GIMT_Encode4(1922263), // Rule ID 23859 //
     /* 1922182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1922193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1922196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1922199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922228 */     // MIs[0] policy
     /* 1922228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922238 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF4_MASK),
     /* 1922241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922262 */     // GIR_Coverage, 23859,
     /* 1922262 */     GIR_EraseRootFromParent_Done,
     /* 1922263 */   // Label 25825: @1922263
     /* 1922263 */   GIM_Try, /*On fail goto*//*Label 25826*/ GIMT_Encode4(1922349), // Rule ID 23862 //
     /* 1922268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922314 */     // MIs[0] policy
     /* 1922314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922324 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1922327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922348 */     // GIR_Coverage, 23862,
     /* 1922348 */     GIR_EraseRootFromParent_Done,
     /* 1922349 */   // Label 25826: @1922349
     /* 1922349 */   GIM_Try, /*On fail goto*//*Label 25827*/ GIMT_Encode4(1922435), // Rule ID 23863 //
     /* 1922354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1922365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1922368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1922371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922400 */     // MIs[0] policy
     /* 1922400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922410 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1922413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922434 */     // GIR_Coverage, 23863,
     /* 1922434 */     GIR_EraseRootFromParent_Done,
     /* 1922435 */   // Label 25827: @1922435
     /* 1922435 */   GIM_Try, /*On fail goto*//*Label 25828*/ GIMT_Encode4(1922521), // Rule ID 23866 //
     /* 1922440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922486 */     // MIs[0] policy
     /* 1922486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922496 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1922499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922520 */     // GIR_Coverage, 23866,
     /* 1922520 */     GIR_EraseRootFromParent_Done,
     /* 1922521 */   // Label 25828: @1922521
     /* 1922521 */   GIM_Try, /*On fail goto*//*Label 25829*/ GIMT_Encode4(1922607), // Rule ID 23867 //
     /* 1922526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1922537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1922540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1922543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1922549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922572 */     // MIs[0] policy
     /* 1922572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922582 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_MF2_MASK),
     /* 1922585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1922603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922606 */     // GIR_Coverage, 23867,
     /* 1922606 */     GIR_EraseRootFromParent_Done,
     /* 1922607 */   // Label 25829: @1922607
     /* 1922607 */   GIM_Try, /*On fail goto*//*Label 25830*/ GIMT_Encode4(1922693), // Rule ID 23870 //
     /* 1922612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922658 */     // MIs[0] policy
     /* 1922658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922668 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1922671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922692 */     // GIR_Coverage, 23870,
     /* 1922692 */     GIR_EraseRootFromParent_Done,
     /* 1922693 */   // Label 25830: @1922693
     /* 1922693 */   GIM_Try, /*On fail goto*//*Label 25831*/ GIMT_Encode4(1922779), // Rule ID 23871 //
     /* 1922698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1922709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1922712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1922715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1922721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922744 */     // MIs[0] policy
     /* 1922744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922754 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11479:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1922757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1922775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922778 */     // GIR_Coverage, 23871,
     /* 1922778 */     GIR_EraseRootFromParent_Done,
     /* 1922779 */   // Label 25831: @1922779
     /* 1922779 */   GIM_Try, /*On fail goto*//*Label 25832*/ GIMT_Encode4(1922865), // Rule ID 23874 //
     /* 1922784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922830 */     // MIs[0] policy
     /* 1922830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922840 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1922840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1922843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922864 */     // GIR_Coverage, 23874,
     /* 1922864 */     GIR_EraseRootFromParent_Done,
     /* 1922865 */   // Label 25832: @1922865
     /* 1922865 */   GIM_Try, /*On fail goto*//*Label 25833*/ GIMT_Encode4(1922951), // Rule ID 23875 //
     /* 1922870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1922873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1922881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1922884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1922887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1922890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1922893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1922896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1922916 */     // MIs[0] policy
     /* 1922916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1922919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1922926 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11479:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1922926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1922929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1922931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1922933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1922935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1922937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1922939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1922944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1922947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1922949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1922950 */     // GIR_Coverage, 23875,
     /* 1922950 */     GIR_EraseRootFromParent_Done,
     /* 1922951 */   // Label 25833: @1922951
     /* 1922951 */   GIM_Try, /*On fail goto*//*Label 25834*/ GIMT_Encode4(1923037), // Rule ID 23878 //
     /* 1922956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1922959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1922964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1922967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1922970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1922973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1922976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1922979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1922982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1922986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1922994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1922998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923002 */     // MIs[0] policy
     /* 1923002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923012 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1923015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923036 */     // GIR_Coverage, 23878,
     /* 1923036 */     GIR_EraseRootFromParent_Done,
     /* 1923037 */   // Label 25834: @1923037
     /* 1923037 */   GIM_Try, /*On fail goto*//*Label 25835*/ GIMT_Encode4(1923123), // Rule ID 23879 //
     /* 1923042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1923053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1923056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1923059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1923065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923088 */     // MIs[0] policy
     /* 1923088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923098 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11479:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1923101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1923119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923122 */     // GIR_Coverage, 23879,
     /* 1923122 */     GIR_EraseRootFromParent_Done,
     /* 1923123 */   // Label 25835: @1923123
     /* 1923123 */   GIM_Try, /*On fail goto*//*Label 25836*/ GIMT_Encode4(1923209), // Rule ID 23882 //
     /* 1923128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1923131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1923139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1923142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1923145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923174 */     // MIs[0] policy
     /* 1923174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923184 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1923187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923208 */     // GIR_Coverage, 23882,
     /* 1923208 */     GIR_EraseRootFromParent_Done,
     /* 1923209 */   // Label 25836: @1923209
     /* 1923209 */   GIM_Try, /*On fail goto*//*Label 25837*/ GIMT_Encode4(1923295), // Rule ID 23883 //
     /* 1923214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1923217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1923225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1923228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1923231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1923237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1923244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1923252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923260 */     // MIs[0] policy
     /* 1923260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923270 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11479:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M1_MASK),
     /* 1923273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1923291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923294 */     // GIR_Coverage, 23883,
     /* 1923294 */     GIR_EraseRootFromParent_Done,
     /* 1923295 */   // Label 25837: @1923295
     /* 1923295 */   GIM_Try, /*On fail goto*//*Label 25838*/ GIMT_Encode4(1923381), // Rule ID 23886 //
     /* 1923300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1923317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923346 */     // MIs[0] policy
     /* 1923346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923356 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1923359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923380 */     // GIR_Coverage, 23886,
     /* 1923380 */     GIR_EraseRootFromParent_Done,
     /* 1923381 */   // Label 25838: @1923381
     /* 1923381 */   GIM_Try, /*On fail goto*//*Label 25839*/ GIMT_Encode4(1923467), // Rule ID 23887 //
     /* 1923386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1923397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1923400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1923403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1923409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923432 */     // MIs[0] policy
     /* 1923432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923442 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1923445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923466 */     // GIR_Coverage, 23887,
     /* 1923466 */     GIR_EraseRootFromParent_Done,
     /* 1923467 */   // Label 25839: @1923467
     /* 1923467 */   GIM_Try, /*On fail goto*//*Label 25840*/ GIMT_Encode4(1923553), // Rule ID 23890 //
     /* 1923472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1923489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923518 */     // MIs[0] policy
     /* 1923518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923528 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1923531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923552 */     // GIR_Coverage, 23890,
     /* 1923552 */     GIR_EraseRootFromParent_Done,
     /* 1923553 */   // Label 25840: @1923553
     /* 1923553 */   GIM_Try, /*On fail goto*//*Label 25841*/ GIMT_Encode4(1923639), // Rule ID 23891 //
     /* 1923558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1923569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1923572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1923575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1923581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1923588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1923596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923604 */     // MIs[0] policy
     /* 1923604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923614 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1923617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923638 */     // GIR_Coverage, 23891,
     /* 1923638 */     GIR_EraseRootFromParent_Done,
     /* 1923639 */   // Label 25841: @1923639
     /* 1923639 */   GIM_Try, /*On fail goto*//*Label 25842*/ GIMT_Encode4(1923725), // Rule ID 23894 //
     /* 1923644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923690 */     // MIs[0] policy
     /* 1923690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923700 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1923703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923724 */     // GIR_Coverage, 23894,
     /* 1923724 */     GIR_EraseRootFromParent_Done,
     /* 1923725 */   // Label 25842: @1923725
     /* 1923725 */   GIM_Try, /*On fail goto*//*Label 25843*/ GIMT_Encode4(1923811), // Rule ID 23895 //
     /* 1923730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1923741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1923744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1923747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1923753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1923760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1923768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923776 */     // MIs[0] policy
     /* 1923776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923786 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1923789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1923807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923810 */     // GIR_Coverage, 23895,
     /* 1923810 */     GIR_EraseRootFromParent_Done,
     /* 1923811 */   // Label 25843: @1923811
     /* 1923811 */   GIM_Try, /*On fail goto*//*Label 25844*/ GIMT_Encode4(1923897), // Rule ID 23898 //
     /* 1923816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1923836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1923842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923862 */     // MIs[0] policy
     /* 1923862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923872 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1923872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1923875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923896 */     // GIR_Coverage, 23898,
     /* 1923896 */     GIR_EraseRootFromParent_Done,
     /* 1923897 */   // Label 25844: @1923897
     /* 1923897 */   GIM_Try, /*On fail goto*//*Label 25845*/ GIMT_Encode4(1923983), // Rule ID 23899 //
     /* 1923902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1923905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1923913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1923916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1923919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1923922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1923925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1923928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1923932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1923940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1923944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1923948 */     // MIs[0] policy
     /* 1923948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1923951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1923958 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1923958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1923961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1923963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1923965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1923967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1923969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1923971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1923976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1923979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1923981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1923982 */     // GIR_Coverage, 23899,
     /* 1923982 */     GIR_EraseRootFromParent_Done,
     /* 1923983 */   // Label 25845: @1923983
     /* 1923983 */   GIM_Try, /*On fail goto*//*Label 25846*/ GIMT_Encode4(1924069), // Rule ID 23902 //
     /* 1923988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1923991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1923996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1923999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1924005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924034 */     // MIs[0] policy
     /* 1924034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924044 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1924047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924068 */     // GIR_Coverage, 23902,
     /* 1924068 */     GIR_EraseRootFromParent_Done,
     /* 1924069 */   // Label 25846: @1924069
     /* 1924069 */   GIM_Try, /*On fail goto*//*Label 25847*/ GIMT_Encode4(1924155), // Rule ID 23903 //
     /* 1924074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1924085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1924088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1924091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924120 */     // MIs[0] policy
     /* 1924120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924130 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1924133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924154 */     // GIR_Coverage, 23903,
     /* 1924154 */     GIR_EraseRootFromParent_Done,
     /* 1924155 */   // Label 25847: @1924155
     /* 1924155 */   GIM_Try, /*On fail goto*//*Label 25848*/ GIMT_Encode4(1924241), // Rule ID 23906 //
     /* 1924160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1924171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1924174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1924177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924206 */     // MIs[0] policy
     /* 1924206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924216 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1924219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924240 */     // GIR_Coverage, 23906,
     /* 1924240 */     GIR_EraseRootFromParent_Done,
     /* 1924241 */   // Label 25848: @1924241
     /* 1924241 */   GIM_Try, /*On fail goto*//*Label 25849*/ GIMT_Encode4(1924327), // Rule ID 23907 //
     /* 1924246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1924257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1924260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1924263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1924269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924292 */     // MIs[0] policy
     /* 1924292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924302 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1924305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1924323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924326 */     // GIR_Coverage, 23907,
     /* 1924326 */     GIR_EraseRootFromParent_Done,
     /* 1924327 */   // Label 25849: @1924327
     /* 1924327 */   GIM_Try, /*On fail goto*//*Label 25850*/ GIMT_Encode4(1924413), // Rule ID 23910 //
     /* 1924332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1924343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1924346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1924349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924378 */     // MIs[0] policy
     /* 1924378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1924391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924412 */     // GIR_Coverage, 23910,
     /* 1924412 */     GIR_EraseRootFromParent_Done,
     /* 1924413 */   // Label 25850: @1924413
     /* 1924413 */   GIM_Try, /*On fail goto*//*Label 25851*/ GIMT_Encode4(1924499), // Rule ID 23911 //
     /* 1924418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1924429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1924432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1924435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1924441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924464 */     // MIs[0] policy
     /* 1924464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924474 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1924477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924498 */     // GIR_Coverage, 23911,
     /* 1924498 */     GIR_EraseRootFromParent_Done,
     /* 1924499 */   // Label 25851: @1924499
     /* 1924499 */   GIM_Try, /*On fail goto*//*Label 25852*/ GIMT_Encode4(1924585), // Rule ID 23914 //
     /* 1924504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1924515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924550 */     // MIs[0] policy
     /* 1924550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924560 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1924563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924584 */     // GIR_Coverage, 23914,
     /* 1924584 */     GIR_EraseRootFromParent_Done,
     /* 1924585 */   // Label 25852: @1924585
     /* 1924585 */   GIM_Try, /*On fail goto*//*Label 25853*/ GIMT_Encode4(1924671), // Rule ID 23915 //
     /* 1924590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1924601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1924604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1924607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1924613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1924620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1924628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924636 */     // MIs[0] policy
     /* 1924636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924646 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1924649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924670 */     // GIR_Coverage, 23915,
     /* 1924670 */     GIR_EraseRootFromParent_Done,
     /* 1924671 */   // Label 25853: @1924671
     /* 1924671 */   GIM_Try, /*On fail goto*//*Label 25854*/ GIMT_Encode4(1924757), // Rule ID 23918 //
     /* 1924676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1924679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924722 */     // MIs[0] policy
     /* 1924722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1924735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924756 */     // GIR_Coverage, 23918,
     /* 1924756 */     GIR_EraseRootFromParent_Done,
     /* 1924757 */   // Label 25854: @1924757
     /* 1924757 */   GIM_Try, /*On fail goto*//*Label 25855*/ GIMT_Encode4(1924843), // Rule ID 23919 //
     /* 1924762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1924765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1924773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1924776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1924779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1924785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1924792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1924800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924808 */     // MIs[0] policy
     /* 1924808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924818 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1924821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1924839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924842 */     // GIR_Coverage, 23919,
     /* 1924842 */     GIR_EraseRootFromParent_Done,
     /* 1924843 */   // Label 25855: @1924843
     /* 1924843 */   GIM_Try, /*On fail goto*//*Label 25856*/ GIMT_Encode4(1924929), // Rule ID 23922 //
     /* 1924848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1924851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1924868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1924874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924894 */     // MIs[0] policy
     /* 1924894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924904 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1924904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1924907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1924915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1924917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1924922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1924925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1924927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1924928 */     // GIR_Coverage, 23922,
     /* 1924928 */     GIR_EraseRootFromParent_Done,
     /* 1924929 */   // Label 25856: @1924929
     /* 1924929 */   GIM_Try, /*On fail goto*//*Label 25857*/ GIMT_Encode4(1925015), // Rule ID 23923 //
     /* 1924934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1924937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1924942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1924945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1924948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1924951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1924954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1924957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1924960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1924964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1924972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1924976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1924980 */     // MIs[0] policy
     /* 1924980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1924983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1924990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11479:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1924990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M2_MASK),
     /* 1924993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1924995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1924997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1924999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925014 */     // GIR_Coverage, 23923,
     /* 1925014 */     GIR_EraseRootFromParent_Done,
     /* 1925015 */   // Label 25857: @1925015
     /* 1925015 */   GIM_Try, /*On fail goto*//*Label 25858*/ GIMT_Encode4(1925101), // Rule ID 23926 //
     /* 1925020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1925028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1925031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1925034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925066 */     // MIs[0] policy
     /* 1925066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1925079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925100 */     // GIR_Coverage, 23926,
     /* 1925100 */     GIR_EraseRootFromParent_Done,
     /* 1925101 */   // Label 25858: @1925101
     /* 1925101 */   GIM_Try, /*On fail goto*//*Label 25859*/ GIMT_Encode4(1925187), // Rule ID 23927 //
     /* 1925106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1925109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1925114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1925117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1925120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1925123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1925136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1925144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925152 */     // MIs[0] policy
     /* 1925152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925162 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11479:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M4_MASK),
     /* 1925165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925186 */     // GIR_Coverage, 23927,
     /* 1925186 */     GIR_EraseRootFromParent_Done,
     /* 1925187 */   // Label 25859: @1925187
     /* 1925187 */   GIM_Try, /*On fail goto*//*Label 25860*/ GIMT_Encode4(1925273), // Rule ID 23930 //
     /* 1925192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1925195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1925200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1925203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1925206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925238 */     // MIs[0] policy
     /* 1925238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925248 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1925251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925272 */     // GIR_Coverage, 23930,
     /* 1925272 */     GIR_EraseRootFromParent_Done,
     /* 1925273 */   // Label 25860: @1925273
     /* 1925273 */   GIM_Try, /*On fail goto*//*Label 25861*/ GIMT_Encode4(1925359), // Rule ID 23931 //
     /* 1925278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1925281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1up_mask),
     /* 1925286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1925289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1925292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1925295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1925301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1925308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1925316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925324 */     // MIs[0] policy
     /* 1925324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925334 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11479:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1UP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1UP_VX_M8_MASK),
     /* 1925337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1925355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925358 */     // GIR_Coverage, 23931,
     /* 1925358 */     GIR_EraseRootFromParent_Done,
     /* 1925359 */   // Label 25861: @1925359
     /* 1925359 */   GIM_Try, /*On fail goto*//*Label 25862*/ GIMT_Encode4(1925445), // Rule ID 23934 //
     /* 1925364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1925375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1925378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1925381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925410 */     // MIs[0] policy
     /* 1925410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925420 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1925423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925444 */     // GIR_Coverage, 23934,
     /* 1925444 */     GIR_EraseRootFromParent_Done,
     /* 1925445 */   // Label 25862: @1925445
     /* 1925445 */   GIM_Try, /*On fail goto*//*Label 25863*/ GIMT_Encode4(1925531), // Rule ID 23935 //
     /* 1925450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1925461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1925464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1925467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925496 */     // MIs[0] policy
     /* 1925496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925506 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF8_MASK),
     /* 1925509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925530 */     // GIR_Coverage, 23935,
     /* 1925530 */     GIR_EraseRootFromParent_Done,
     /* 1925531 */   // Label 25863: @1925531
     /* 1925531 */   GIM_Try, /*On fail goto*//*Label 25864*/ GIMT_Encode4(1925617), // Rule ID 23938 //
     /* 1925536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925582 */     // MIs[0] policy
     /* 1925582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925592 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1925595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925616 */     // GIR_Coverage, 23938,
     /* 1925616 */     GIR_EraseRootFromParent_Done,
     /* 1925617 */   // Label 25864: @1925617
     /* 1925617 */   GIM_Try, /*On fail goto*//*Label 25865*/ GIMT_Encode4(1925703), // Rule ID 23939 //
     /* 1925622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1925633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1925636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1925639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1925645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925668 */     // MIs[0] policy
     /* 1925668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925678 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1925681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925702 */     // GIR_Coverage, 23939,
     /* 1925702 */     GIR_EraseRootFromParent_Done,
     /* 1925703 */   // Label 25865: @1925703
     /* 1925703 */   GIM_Try, /*On fail goto*//*Label 25866*/ GIMT_Encode4(1925789), // Rule ID 23942 //
     /* 1925708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925754 */     // MIs[0] policy
     /* 1925754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925764 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1925767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925788 */     // GIR_Coverage, 23942,
     /* 1925788 */     GIR_EraseRootFromParent_Done,
     /* 1925789 */   // Label 25866: @1925789
     /* 1925789 */   GIM_Try, /*On fail goto*//*Label 25867*/ GIMT_Encode4(1925875), // Rule ID 23943 //
     /* 1925794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1925805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1925808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1925811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1925817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925840 */     // MIs[0] policy
     /* 1925840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925850 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1925850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1925853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1925871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925874 */     // GIR_Coverage, 23943,
     /* 1925874 */     GIR_EraseRootFromParent_Done,
     /* 1925875 */   // Label 25867: @1925875
     /* 1925875 */   GIM_Try, /*On fail goto*//*Label 25868*/ GIMT_Encode4(1925961), // Rule ID 23946 //
     /* 1925880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1925883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1925900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1925906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1925918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1925922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1925926 */     // MIs[0] policy
     /* 1925926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1925929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1925936 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1925936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1925939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1925941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1925943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1925945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1925947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1925949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1925954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1925957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1925959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1925960 */     // GIR_Coverage, 23946,
     /* 1925960 */     GIR_EraseRootFromParent_Done,
     /* 1925961 */   // Label 25868: @1925961
     /* 1925961 */   GIM_Try, /*On fail goto*//*Label 25869*/ GIMT_Encode4(1926047), // Rule ID 23947 //
     /* 1925966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1925969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1925974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1925977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1925980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1925983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1925986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1925989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1925992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1925996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926012 */     // MIs[0] policy
     /* 1926012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926022 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF4_MASK),
     /* 1926025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926046 */     // GIR_Coverage, 23947,
     /* 1926046 */     GIR_EraseRootFromParent_Done,
     /* 1926047 */   // Label 25869: @1926047
     /* 1926047 */   GIM_Try, /*On fail goto*//*Label 25870*/ GIMT_Encode4(1926133), // Rule ID 23950 //
     /* 1926052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1926063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1926066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1926069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926098 */     // MIs[0] policy
     /* 1926098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926108 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1926111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926132 */     // GIR_Coverage, 23950,
     /* 1926132 */     GIR_EraseRootFromParent_Done,
     /* 1926133 */   // Label 25870: @1926133
     /* 1926133 */   GIM_Try, /*On fail goto*//*Label 25871*/ GIMT_Encode4(1926219), // Rule ID 23951 //
     /* 1926138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1926149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1926152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1926155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926184 */     // MIs[0] policy
     /* 1926184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926194 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1926197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926218 */     // GIR_Coverage, 23951,
     /* 1926218 */     GIR_EraseRootFromParent_Done,
     /* 1926219 */   // Label 25871: @1926219
     /* 1926219 */   GIM_Try, /*On fail goto*//*Label 25872*/ GIMT_Encode4(1926305), // Rule ID 23954 //
     /* 1926224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1926235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1926238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1926241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926270 */     // MIs[0] policy
     /* 1926270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926280 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1926283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926304 */     // GIR_Coverage, 23954,
     /* 1926304 */     GIR_EraseRootFromParent_Done,
     /* 1926305 */   // Label 25872: @1926305
     /* 1926305 */   GIM_Try, /*On fail goto*//*Label 25873*/ GIMT_Encode4(1926391), // Rule ID 23955 //
     /* 1926310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1926321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1926324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1926327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926356 */     // MIs[0] policy
     /* 1926356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926366 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_MF2_MASK),
     /* 1926369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926390 */     // GIR_Coverage, 23955,
     /* 1926390 */     GIR_EraseRootFromParent_Done,
     /* 1926391 */   // Label 25873: @1926391
     /* 1926391 */   GIM_Try, /*On fail goto*//*Label 25874*/ GIMT_Encode4(1926477), // Rule ID 23958 //
     /* 1926396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1926407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1926410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1926413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926442 */     // MIs[0] policy
     /* 1926442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926452 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926476 */     // GIR_Coverage, 23958,
     /* 1926476 */     GIR_EraseRootFromParent_Done,
     /* 1926477 */   // Label 25874: @1926477
     /* 1926477 */   GIM_Try, /*On fail goto*//*Label 25875*/ GIMT_Encode4(1926563), // Rule ID 23959 //
     /* 1926482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1926493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1926496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1926499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1926505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926528 */     // MIs[0] policy
     /* 1926528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926538 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11477:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1926559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926562 */     // GIR_Coverage, 23959,
     /* 1926562 */     GIR_EraseRootFromParent_Done,
     /* 1926563 */   // Label 25875: @1926563
     /* 1926563 */   GIM_Try, /*On fail goto*//*Label 25876*/ GIMT_Encode4(1926649), // Rule ID 23962 //
     /* 1926568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926614 */     // MIs[0] policy
     /* 1926614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926624 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926648 */     // GIR_Coverage, 23962,
     /* 1926648 */     GIR_EraseRootFromParent_Done,
     /* 1926649 */   // Label 25876: @1926649
     /* 1926649 */   GIM_Try, /*On fail goto*//*Label 25877*/ GIMT_Encode4(1926735), // Rule ID 23963 //
     /* 1926654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1926665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1926668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1926671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1926677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926700 */     // MIs[0] policy
     /* 1926700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11477:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1926731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926734 */     // GIR_Coverage, 23963,
     /* 1926734 */     GIR_EraseRootFromParent_Done,
     /* 1926735 */   // Label 25877: @1926735
     /* 1926735 */   GIM_Try, /*On fail goto*//*Label 25878*/ GIMT_Encode4(1926821), // Rule ID 23966 //
     /* 1926740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1926743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926786 */     // MIs[0] policy
     /* 1926786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926796 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926820 */     // GIR_Coverage, 23966,
     /* 1926820 */     GIR_EraseRootFromParent_Done,
     /* 1926821 */   // Label 25878: @1926821
     /* 1926821 */   GIM_Try, /*On fail goto*//*Label 25879*/ GIMT_Encode4(1926907), // Rule ID 23967 //
     /* 1926826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1926829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1926837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1926840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1926843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1926846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1926849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1926852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926872 */     // MIs[0] policy
     /* 1926872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926882 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11477:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1926882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1926903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926906 */     // GIR_Coverage, 23967,
     /* 1926906 */     GIR_EraseRootFromParent_Done,
     /* 1926907 */   // Label 25879: @1926907
     /* 1926907 */   GIM_Try, /*On fail goto*//*Label 25880*/ GIMT_Encode4(1926993), // Rule ID 23970 //
     /* 1926912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1926915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1926920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1926923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1926926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1926929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1926932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1926935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1926938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1926942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1926950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1926954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1926958 */     // MIs[0] policy
     /* 1926958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1926961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1926968 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1926968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1926971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1926973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1926975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1926977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1926979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1926981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1926986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1926989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1926991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1926992 */     // GIR_Coverage, 23970,
     /* 1926992 */     GIR_EraseRootFromParent_Done,
     /* 1926993 */   // Label 25880: @1926993
     /* 1926993 */   GIM_Try, /*On fail goto*//*Label 25881*/ GIMT_Encode4(1927079), // Rule ID 23971 //
     /* 1926998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1927001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1927009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1927012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1927015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1927021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1927028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1927036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927044 */     // MIs[0] policy
     /* 1927044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927054 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11477:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M1_MASK),
     /* 1927057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1927075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927078 */     // GIR_Coverage, 23971,
     /* 1927078 */     GIR_EraseRootFromParent_Done,
     /* 1927079 */   // Label 25881: @1927079
     /* 1927079 */   GIM_Try, /*On fail goto*//*Label 25882*/ GIMT_Encode4(1927165), // Rule ID 23974 //
     /* 1927084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1927095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1927098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1927101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927130 */     // MIs[0] policy
     /* 1927130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1927143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927164 */     // GIR_Coverage, 23974,
     /* 1927164 */     GIR_EraseRootFromParent_Done,
     /* 1927165 */   // Label 25882: @1927165
     /* 1927165 */   GIM_Try, /*On fail goto*//*Label 25883*/ GIMT_Encode4(1927251), // Rule ID 23975 //
     /* 1927170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1927181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1927184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1927187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927216 */     // MIs[0] policy
     /* 1927216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927226 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1927229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927250 */     // GIR_Coverage, 23975,
     /* 1927250 */     GIR_EraseRootFromParent_Done,
     /* 1927251 */   // Label 25883: @1927251
     /* 1927251 */   GIM_Try, /*On fail goto*//*Label 25884*/ GIMT_Encode4(1927337), // Rule ID 23978 //
     /* 1927256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1927267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1927270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1927273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927302 */     // MIs[0] policy
     /* 1927302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927312 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1927315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927336 */     // GIR_Coverage, 23978,
     /* 1927336 */     GIR_EraseRootFromParent_Done,
     /* 1927337 */   // Label 25884: @1927337
     /* 1927337 */   GIM_Try, /*On fail goto*//*Label 25885*/ GIMT_Encode4(1927423), // Rule ID 23979 //
     /* 1927342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1927353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1927356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1927359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927388 */     // MIs[0] policy
     /* 1927388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927398 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1927401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927422 */     // GIR_Coverage, 23979,
     /* 1927422 */     GIR_EraseRootFromParent_Done,
     /* 1927423 */   // Label 25885: @1927423
     /* 1927423 */   GIM_Try, /*On fail goto*//*Label 25886*/ GIMT_Encode4(1927509), // Rule ID 23982 //
     /* 1927428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1927439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1927442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1927445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1927451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927474 */     // MIs[0] policy
     /* 1927474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927484 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1927487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927508 */     // GIR_Coverage, 23982,
     /* 1927508 */     GIR_EraseRootFromParent_Done,
     /* 1927509 */   // Label 25886: @1927509
     /* 1927509 */   GIM_Try, /*On fail goto*//*Label 25887*/ GIMT_Encode4(1927595), // Rule ID 23983 //
     /* 1927514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1927525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1927528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1927531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1927537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927560 */     // MIs[0] policy
     /* 1927560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927570 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1927573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1927591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927594 */     // GIR_Coverage, 23983,
     /* 1927594 */     GIR_EraseRootFromParent_Done,
     /* 1927595 */   // Label 25887: @1927595
     /* 1927595 */   GIM_Try, /*On fail goto*//*Label 25888*/ GIMT_Encode4(1927681), // Rule ID 23986 //
     /* 1927600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927646 */     // MIs[0] policy
     /* 1927646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927656 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1927659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927680 */     // GIR_Coverage, 23986,
     /* 1927680 */     GIR_EraseRootFromParent_Done,
     /* 1927681 */   // Label 25888: @1927681
     /* 1927681 */   GIM_Try, /*On fail goto*//*Label 25889*/ GIMT_Encode4(1927767), // Rule ID 23987 //
     /* 1927686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1927697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1927700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1927703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1927709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1927716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1927724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927732 */     // MIs[0] policy
     /* 1927732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1927745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927766 */     // GIR_Coverage, 23987,
     /* 1927766 */     GIR_EraseRootFromParent_Done,
     /* 1927767 */   // Label 25889: @1927767
     /* 1927767 */   GIM_Try, /*On fail goto*//*Label 25890*/ GIMT_Encode4(1927853), // Rule ID 23990 //
     /* 1927772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927818 */     // MIs[0] policy
     /* 1927818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927828 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1927828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1927831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927852 */     // GIR_Coverage, 23990,
     /* 1927852 */     GIR_EraseRootFromParent_Done,
     /* 1927853 */   // Label 25890: @1927853
     /* 1927853 */   GIM_Try, /*On fail goto*//*Label 25891*/ GIMT_Encode4(1927939), // Rule ID 23991 //
     /* 1927858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1927861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1927869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1927872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1927875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1927878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1927881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1927884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1927888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1927896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927904 */     // MIs[0] policy
     /* 1927904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1927914 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1927914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1927917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1927919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1927921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1927923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1927925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1927927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1927932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1927935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1927937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1927938 */     // GIR_Coverage, 23991,
     /* 1927938 */     GIR_EraseRootFromParent_Done,
     /* 1927939 */   // Label 25891: @1927939
     /* 1927939 */   GIM_Try, /*On fail goto*//*Label 25892*/ GIMT_Encode4(1928025), // Rule ID 23994 //
     /* 1927944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1927947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1927952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1927955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1927958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1927961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1927964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1927967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1927970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1927974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1927982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1927986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1927990 */     // MIs[0] policy
     /* 1927990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1927993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928000 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1928003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928024 */     // GIR_Coverage, 23994,
     /* 1928024 */     GIR_EraseRootFromParent_Done,
     /* 1928025 */   // Label 25892: @1928025
     /* 1928025 */   GIM_Try, /*On fail goto*//*Label 25893*/ GIMT_Encode4(1928111), // Rule ID 23995 //
     /* 1928030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1928041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1928044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1928047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1928053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928076 */     // MIs[0] policy
     /* 1928076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928086 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1928089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1928107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928110 */     // GIR_Coverage, 23995,
     /* 1928110 */     GIR_EraseRootFromParent_Done,
     /* 1928111 */   // Label 25893: @1928111
     /* 1928111 */   GIM_Try, /*On fail goto*//*Label 25894*/ GIMT_Encode4(1928197), // Rule ID 23998 //
     /* 1928116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1928127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1928130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1928133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928162 */     // MIs[0] policy
     /* 1928162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1928175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928196 */     // GIR_Coverage, 23998,
     /* 1928196 */     GIR_EraseRootFromParent_Done,
     /* 1928197 */   // Label 25894: @1928197
     /* 1928197 */   GIM_Try, /*On fail goto*//*Label 25895*/ GIMT_Encode4(1928283), // Rule ID 23999 //
     /* 1928202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1928213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1928216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1928219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928248 */     // MIs[0] policy
     /* 1928248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928258 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1928261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928282 */     // GIR_Coverage, 23999,
     /* 1928282 */     GIR_EraseRootFromParent_Done,
     /* 1928283 */   // Label 25895: @1928283
     /* 1928283 */   GIM_Try, /*On fail goto*//*Label 25896*/ GIMT_Encode4(1928369), // Rule ID 24002 //
     /* 1928288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1928299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1928302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1928305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928334 */     // MIs[0] policy
     /* 1928334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928344 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1928347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928368 */     // GIR_Coverage, 24002,
     /* 1928368 */     GIR_EraseRootFromParent_Done,
     /* 1928369 */   // Label 25896: @1928369
     /* 1928369 */   GIM_Try, /*On fail goto*//*Label 25897*/ GIMT_Encode4(1928455), // Rule ID 24003 //
     /* 1928374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1928385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1928388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1928391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928420 */     // MIs[0] policy
     /* 1928420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928430 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1928433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928454 */     // GIR_Coverage, 24003,
     /* 1928454 */     GIR_EraseRootFromParent_Done,
     /* 1928455 */   // Label 25897: @1928455
     /* 1928455 */   GIM_Try, /*On fail goto*//*Label 25898*/ GIMT_Encode4(1928541), // Rule ID 24006 //
     /* 1928460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1928463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1928471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1928474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1928477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928506 */     // MIs[0] policy
     /* 1928506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928516 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1928519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928540 */     // GIR_Coverage, 24006,
     /* 1928540 */     GIR_EraseRootFromParent_Done,
     /* 1928541 */   // Label 25898: @1928541
     /* 1928541 */   GIM_Try, /*On fail goto*//*Label 25899*/ GIMT_Encode4(1928627), // Rule ID 24007 //
     /* 1928546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1928549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1928557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1928560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1928563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1928569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1928576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1928584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928592 */     // MIs[0] policy
     /* 1928592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928602 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1928605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1928623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928626 */     // GIR_Coverage, 24007,
     /* 1928626 */     GIR_EraseRootFromParent_Done,
     /* 1928627 */   // Label 25899: @1928627
     /* 1928627 */   GIM_Try, /*On fail goto*//*Label 25900*/ GIMT_Encode4(1928713), // Rule ID 24010 //
     /* 1928632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928678 */     // MIs[0] policy
     /* 1928678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928688 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1928691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928712 */     // GIR_Coverage, 24010,
     /* 1928712 */     GIR_EraseRootFromParent_Done,
     /* 1928713 */   // Label 25900: @1928713
     /* 1928713 */   GIM_Try, /*On fail goto*//*Label 25901*/ GIMT_Encode4(1928799), // Rule ID 24011 //
     /* 1928718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1928729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1928732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1928735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1928741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1928748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1928756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928764 */     // MIs[0] policy
     /* 1928764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11477:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M2_MASK),
     /* 1928777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928798 */     // GIR_Coverage, 24011,
     /* 1928798 */     GIR_EraseRootFromParent_Done,
     /* 1928799 */   // Label 25901: @1928799
     /* 1928799 */   GIM_Try, /*On fail goto*//*Label 25902*/ GIMT_Encode4(1928885), // Rule ID 24014 //
     /* 1928804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1928830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928850 */     // MIs[0] policy
     /* 1928850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928860 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1928860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1928863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928884 */     // GIR_Coverage, 24014,
     /* 1928884 */     GIR_EraseRootFromParent_Done,
     /* 1928885 */   // Label 25902: @1928885
     /* 1928885 */   GIM_Try, /*On fail goto*//*Label 25903*/ GIMT_Encode4(1928971), // Rule ID 24015 //
     /* 1928890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1928893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1928901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1928904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1928907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1928910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1928913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1928916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1928920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1928928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1928932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1928936 */     // MIs[0] policy
     /* 1928936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1928939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1928946 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11477:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1928946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M4_MASK),
     /* 1928949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1928951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1928953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1928955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1928957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1928959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1928964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1928967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1928969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1928970 */     // GIR_Coverage, 24015,
     /* 1928970 */     GIR_EraseRootFromParent_Done,
     /* 1928971 */   // Label 25903: @1928971
     /* 1928971 */   GIM_Try, /*On fail goto*//*Label 25904*/ GIMT_Encode4(1929057), // Rule ID 24018 //
     /* 1928976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1928979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1928984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1928987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1928990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1928993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1928996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1928999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929022 */     // MIs[0] policy
     /* 1929022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929032 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1929035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929056 */     // GIR_Coverage, 24018,
     /* 1929056 */     GIR_EraseRootFromParent_Done,
     /* 1929057 */   // Label 25904: @1929057
     /* 1929057 */   GIM_Try, /*On fail goto*//*Label 25905*/ GIMT_Encode4(1929143), // Rule ID 24019 //
     /* 1929062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1929065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslide1down_mask),
     /* 1929070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1929073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1929076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1929079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1929085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1929092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1929100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929108 */     // MIs[0] policy
     /* 1929108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929118 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11477:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDE1DOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDE1DOWN_VX_M8_MASK),
     /* 1929121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1929125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1929139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929142 */     // GIR_Coverage, 24019,
     /* 1929142 */     GIR_EraseRootFromParent_Done,
     /* 1929143 */   // Label 25905: @1929143
     /* 1929143 */   GIM_Try, /*On fail goto*//*Label 25906*/ GIMT_Encode4(1929229), // Rule ID 24022 //
     /* 1929148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1929151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929194 */     // MIs[0] policy
     /* 1929194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929204 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1929207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929209 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929228 */     // GIR_Coverage, 24022,
     /* 1929228 */     GIR_EraseRootFromParent_Done,
     /* 1929229 */   // Label 25906: @1929229
     /* 1929229 */   GIM_Try, /*On fail goto*//*Label 25907*/ GIMT_Encode4(1929315), // Rule ID 24023 //
     /* 1929234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1929237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1929245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1929248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1929251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929280 */     // MIs[0] policy
     /* 1929280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929290 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 1929293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929295 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929314 */     // GIR_Coverage, 24023,
     /* 1929314 */     GIR_EraseRootFromParent_Done,
     /* 1929315 */   // Label 25907: @1929315
     /* 1929315 */   GIM_Try, /*On fail goto*//*Label 25908*/ GIMT_Encode4(1929401), // Rule ID 24026 //
     /* 1929320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1929323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929366 */     // MIs[0] policy
     /* 1929366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929376 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1929379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929400 */     // GIR_Coverage, 24026,
     /* 1929400 */     GIR_EraseRootFromParent_Done,
     /* 1929401 */   // Label 25908: @1929401
     /* 1929401 */   GIM_Try, /*On fail goto*//*Label 25909*/ GIMT_Encode4(1929487), // Rule ID 24027 //
     /* 1929406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1929409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1929417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1929420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1929423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929452 */     // MIs[0] policy
     /* 1929452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929462 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1929465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929486 */     // GIR_Coverage, 24027,
     /* 1929486 */     GIR_EraseRootFromParent_Done,
     /* 1929487 */   // Label 25909: @1929487
     /* 1929487 */   GIM_Try, /*On fail goto*//*Label 25910*/ GIMT_Encode4(1929573), // Rule ID 24030 //
     /* 1929492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1929495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929538 */     // MIs[0] policy
     /* 1929538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929548 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1929551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929572 */     // GIR_Coverage, 24030,
     /* 1929572 */     GIR_EraseRootFromParent_Done,
     /* 1929573 */   // Label 25910: @1929573
     /* 1929573 */   GIM_Try, /*On fail goto*//*Label 25911*/ GIMT_Encode4(1929659), // Rule ID 24031 //
     /* 1929578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1929581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1929589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1929592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1929595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1929601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929624 */     // MIs[0] policy
     /* 1929624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929634 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 1929637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929658 */     // GIR_Coverage, 24031,
     /* 1929658 */     GIR_EraseRootFromParent_Done,
     /* 1929659 */   // Label 25911: @1929659
     /* 1929659 */   GIM_Try, /*On fail goto*//*Label 25912*/ GIMT_Encode4(1929745), // Rule ID 24034 //
     /* 1929664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1929667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929710 */     // MIs[0] policy
     /* 1929710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929720 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1929723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929744 */     // GIR_Coverage, 24034,
     /* 1929744 */     GIR_EraseRootFromParent_Done,
     /* 1929745 */   // Label 25912: @1929745
     /* 1929745 */   GIM_Try, /*On fail goto*//*Label 25913*/ GIMT_Encode4(1929831), // Rule ID 24035 //
     /* 1929750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1929753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1929761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1929764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1929767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1929773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929796 */     // MIs[0] policy
     /* 1929796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929806 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11483:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1929809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1929827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929830 */     // GIR_Coverage, 24035,
     /* 1929830 */     GIR_EraseRootFromParent_Done,
     /* 1929831 */   // Label 25913: @1929831
     /* 1929831 */   GIM_Try, /*On fail goto*//*Label 25914*/ GIMT_Encode4(1929917), // Rule ID 24038 //
     /* 1929836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1929839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1929856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1929862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929882 */     // MIs[0] policy
     /* 1929882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929892 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1929892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1929895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1929915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1929916 */     // GIR_Coverage, 24038,
     /* 1929916 */     GIR_EraseRootFromParent_Done,
     /* 1929917 */   // Label 25914: @1929917
     /* 1929917 */   GIM_Try, /*On fail goto*//*Label 25915*/ GIMT_Encode4(1930003), // Rule ID 24039 //
     /* 1929922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1929925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1929930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1929933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1929936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1929939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1929942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1929945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1929948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1929952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1929960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1929964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1929968 */     // MIs[0] policy
     /* 1929968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1929971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1929978 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11483:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1929978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1929981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1929983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1929985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1929987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1929989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1929991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1929996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1929999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930002 */     // GIR_Coverage, 24039,
     /* 1930002 */     GIR_EraseRootFromParent_Done,
     /* 1930003 */   // Label 25915: @1930003
     /* 1930003 */   GIM_Try, /*On fail goto*//*Label 25916*/ GIMT_Encode4(1930089), // Rule ID 24042 //
     /* 1930008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1930011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930054 */     // MIs[0] policy
     /* 1930054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1930067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930088 */     // GIR_Coverage, 24042,
     /* 1930088 */     GIR_EraseRootFromParent_Done,
     /* 1930089 */   // Label 25916: @1930089
     /* 1930089 */   GIM_Try, /*On fail goto*//*Label 25917*/ GIMT_Encode4(1930175), // Rule ID 24043 //
     /* 1930094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1930097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1930105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1930108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1930111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1930117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1930124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1930132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930140 */     // MIs[0] policy
     /* 1930140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930150 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11483:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 1930153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1930171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930174 */     // GIR_Coverage, 24043,
     /* 1930174 */     GIR_EraseRootFromParent_Done,
     /* 1930175 */   // Label 25917: @1930175
     /* 1930175 */   GIM_Try, /*On fail goto*//*Label 25918*/ GIMT_Encode4(1930261), // Rule ID 24046 //
     /* 1930180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1930183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930226 */     // MIs[0] policy
     /* 1930226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930236 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1930239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930260 */     // GIR_Coverage, 24046,
     /* 1930260 */     GIR_EraseRootFromParent_Done,
     /* 1930261 */   // Label 25918: @1930261
     /* 1930261 */   GIM_Try, /*On fail goto*//*Label 25919*/ GIMT_Encode4(1930347), // Rule ID 24047 //
     /* 1930266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1930269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1930277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1930280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1930283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930312 */     // MIs[0] policy
     /* 1930312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930322 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1930325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930346 */     // GIR_Coverage, 24047,
     /* 1930346 */     GIR_EraseRootFromParent_Done,
     /* 1930347 */   // Label 25919: @1930347
     /* 1930347 */   GIM_Try, /*On fail goto*//*Label 25920*/ GIMT_Encode4(1930433), // Rule ID 24050 //
     /* 1930352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1930355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930398 */     // MIs[0] policy
     /* 1930398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930408 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1930411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930432 */     // GIR_Coverage, 24050,
     /* 1930432 */     GIR_EraseRootFromParent_Done,
     /* 1930433 */   // Label 25920: @1930433
     /* 1930433 */   GIM_Try, /*On fail goto*//*Label 25921*/ GIMT_Encode4(1930519), // Rule ID 24051 //
     /* 1930438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1930441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1930449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1930452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1930455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1930461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930484 */     // MIs[0] policy
     /* 1930484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930494 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1930497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930518 */     // GIR_Coverage, 24051,
     /* 1930518 */     GIR_EraseRootFromParent_Done,
     /* 1930519 */   // Label 25921: @1930519
     /* 1930519 */   GIM_Try, /*On fail goto*//*Label 25922*/ GIMT_Encode4(1930605), // Rule ID 24054 //
     /* 1930524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1930527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930570 */     // MIs[0] policy
     /* 1930570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930580 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1930583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930585 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930604 */     // GIR_Coverage, 24054,
     /* 1930604 */     GIR_EraseRootFromParent_Done,
     /* 1930605 */   // Label 25922: @1930605
     /* 1930605 */   GIM_Try, /*On fail goto*//*Label 25923*/ GIMT_Encode4(1930691), // Rule ID 24055 //
     /* 1930610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1930613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1930621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1930624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1930627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1930633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1930640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1930648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930656 */     // MIs[0] policy
     /* 1930656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930666 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1930669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1930687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930690 */     // GIR_Coverage, 24055,
     /* 1930690 */     GIR_EraseRootFromParent_Done,
     /* 1930691 */   // Label 25923: @1930691
     /* 1930691 */   GIM_Try, /*On fail goto*//*Label 25924*/ GIMT_Encode4(1930777), // Rule ID 24058 //
     /* 1930696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1930699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1930707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1930710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1930713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930742 */     // MIs[0] policy
     /* 1930742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1930755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930776 */     // GIR_Coverage, 24058,
     /* 1930776 */     GIR_EraseRootFromParent_Done,
     /* 1930777 */   // Label 25924: @1930777
     /* 1930777 */   GIM_Try, /*On fail goto*//*Label 25925*/ GIMT_Encode4(1930863), // Rule ID 24059 //
     /* 1930782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1930785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1930793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1930796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1930799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1930805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1930812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1930820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930828 */     // MIs[0] policy
     /* 1930828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930838 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1930838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1930841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930862 */     // GIR_Coverage, 24059,
     /* 1930862 */     GIR_EraseRootFromParent_Done,
     /* 1930863 */   // Label 25925: @1930863
     /* 1930863 */   GIM_Try, /*On fail goto*//*Label 25926*/ GIMT_Encode4(1930949), // Rule ID 24062 //
     /* 1930868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1930871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1930879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1930882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1930885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1930888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1930894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1930914 */     // MIs[0] policy
     /* 1930914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1930917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1930924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1930924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1930927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1930929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1930931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1930933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1930935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1930937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1930942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1930945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1930947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1930948 */     // GIR_Coverage, 24062,
     /* 1930948 */     GIR_EraseRootFromParent_Done,
     /* 1930949 */   // Label 25926: @1930949
     /* 1930949 */   GIM_Try, /*On fail goto*//*Label 25927*/ GIMT_Encode4(1931035), // Rule ID 24063 //
     /* 1930954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1930957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1930962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1930965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1930968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1930971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1930974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1930977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1930980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1930984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1930992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1930996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931000 */     // MIs[0] policy
     /* 1931000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931010 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1931013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931034 */     // GIR_Coverage, 24063,
     /* 1931034 */     GIR_EraseRootFromParent_Done,
     /* 1931035 */   // Label 25927: @1931035
     /* 1931035 */   GIM_Try, /*On fail goto*//*Label 25928*/ GIMT_Encode4(1931121), // Rule ID 24066 //
     /* 1931040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1931043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931086 */     // MIs[0] policy
     /* 1931086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931096 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1931099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931120 */     // GIR_Coverage, 24066,
     /* 1931120 */     GIR_EraseRootFromParent_Done,
     /* 1931121 */   // Label 25928: @1931121
     /* 1931121 */   GIM_Try, /*On fail goto*//*Label 25929*/ GIMT_Encode4(1931207), // Rule ID 24067 //
     /* 1931126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1931129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1931137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1931140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1931143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1931149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931172 */     // MIs[0] policy
     /* 1931172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1931185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1931203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931206 */     // GIR_Coverage, 24067,
     /* 1931206 */     GIR_EraseRootFromParent_Done,
     /* 1931207 */   // Label 25929: @1931207
     /* 1931207 */   GIM_Try, /*On fail goto*//*Label 25930*/ GIMT_Encode4(1931293), // Rule ID 24070 //
     /* 1931212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1931215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931258 */     // MIs[0] policy
     /* 1931258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931268 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1931271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931292 */     // GIR_Coverage, 24070,
     /* 1931292 */     GIR_EraseRootFromParent_Done,
     /* 1931293 */   // Label 25930: @1931293
     /* 1931293 */   GIM_Try, /*On fail goto*//*Label 25931*/ GIMT_Encode4(1931379), // Rule ID 24071 //
     /* 1931298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1931301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1931309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1931312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1931315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1931328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1931336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931344 */     // MIs[0] policy
     /* 1931344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931354 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11483:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 1931357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931378 */     // GIR_Coverage, 24071,
     /* 1931378 */     GIR_EraseRootFromParent_Done,
     /* 1931379 */   // Label 25931: @1931379
     /* 1931379 */   GIM_Try, /*On fail goto*//*Label 25932*/ GIMT_Encode4(1931465), // Rule ID 24074 //
     /* 1931384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1931387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931430 */     // MIs[0] policy
     /* 1931430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931440 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1931443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931464 */     // GIR_Coverage, 24074,
     /* 1931464 */     GIR_EraseRootFromParent_Done,
     /* 1931465 */   // Label 25932: @1931465
     /* 1931465 */   GIM_Try, /*On fail goto*//*Label 25933*/ GIMT_Encode4(1931551), // Rule ID 24075 //
     /* 1931470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1931473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1931481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1931484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1931487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1931493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1931500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1931508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931516 */     // MIs[0] policy
     /* 1931516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931526 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11483:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 1931529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931550 */     // GIR_Coverage, 24075,
     /* 1931550 */     GIR_EraseRootFromParent_Done,
     /* 1931551 */   // Label 25933: @1931551
     /* 1931551 */   GIM_Try, /*On fail goto*//*Label 25934*/ GIMT_Encode4(1931637), // Rule ID 24078 //
     /* 1931556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1931559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931602 */     // MIs[0] policy
     /* 1931602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931612 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1931615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931636 */     // GIR_Coverage, 24078,
     /* 1931636 */     GIR_EraseRootFromParent_Done,
     /* 1931637 */   // Label 25934: @1931637
     /* 1931637 */   GIM_Try, /*On fail goto*//*Label 25935*/ GIMT_Encode4(1931723), // Rule ID 24079 //
     /* 1931642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1931645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslideup_mask),
     /* 1931650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1931653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1931656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1931659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1931665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1931672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1931680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931688 */     // MIs[0] policy
     /* 1931688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931698 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11483:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 1931701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1931719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931722 */     // GIR_Coverage, 24079,
     /* 1931722 */     GIR_EraseRootFromParent_Done,
     /* 1931723 */   // Label 25935: @1931723
     /* 1931723 */   GIM_Try, /*On fail goto*//*Label 25936*/ GIMT_Encode4(1931809), // Rule ID 24142 //
     /* 1931728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1931731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1931739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1931742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1931745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931774 */     // MIs[0] policy
     /* 1931774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931784 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1931787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931808 */     // GIR_Coverage, 24142,
     /* 1931808 */     GIR_EraseRootFromParent_Done,
     /* 1931809 */   // Label 25936: @1931809
     /* 1931809 */   GIM_Try, /*On fail goto*//*Label 25937*/ GIMT_Encode4(1931895), // Rule ID 24143 //
     /* 1931814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1931817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1931825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1931828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1931831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1931834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1931837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1931840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931860 */     // MIs[0] policy
     /* 1931860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931870 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1931870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 1931873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931894 */     // GIR_Coverage, 24143,
     /* 1931894 */     GIR_EraseRootFromParent_Done,
     /* 1931895 */   // Label 25937: @1931895
     /* 1931895 */   GIM_Try, /*On fail goto*//*Label 25938*/ GIMT_Encode4(1931981), // Rule ID 24146 //
     /* 1931900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1931903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1931911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1931914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1931917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1931920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1931923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1931926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1931930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1931938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1931942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1931946 */     // MIs[0] policy
     /* 1931946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1931949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1931956 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1931956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1931959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1931961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1931963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1931965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1931967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1931969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1931974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1931977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1931979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1931980 */     // GIR_Coverage, 24146,
     /* 1931980 */     GIR_EraseRootFromParent_Done,
     /* 1931981 */   // Label 25938: @1931981
     /* 1931981 */   GIM_Try, /*On fail goto*//*Label 25939*/ GIMT_Encode4(1932067), // Rule ID 24147 //
     /* 1931986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1931989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1931994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1931997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1932000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1932003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932032 */     // MIs[0] policy
     /* 1932032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932042 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1932045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932066 */     // GIR_Coverage, 24147,
     /* 1932066 */     GIR_EraseRootFromParent_Done,
     /* 1932067 */   // Label 25939: @1932067
     /* 1932067 */   GIM_Try, /*On fail goto*//*Label 25940*/ GIMT_Encode4(1932153), // Rule ID 24150 //
     /* 1932072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1932075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932118 */     // MIs[0] policy
     /* 1932118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932128 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1932131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932152 */     // GIR_Coverage, 24150,
     /* 1932152 */     GIR_EraseRootFromParent_Done,
     /* 1932153 */   // Label 25940: @1932153
     /* 1932153 */   GIM_Try, /*On fail goto*//*Label 25941*/ GIMT_Encode4(1932239), // Rule ID 24151 //
     /* 1932158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1932161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1932169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1932172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1932175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932204 */     // MIs[0] policy
     /* 1932204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932214 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 1932217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932238 */     // GIR_Coverage, 24151,
     /* 1932238 */     GIR_EraseRootFromParent_Done,
     /* 1932239 */   // Label 25941: @1932239
     /* 1932239 */   GIM_Try, /*On fail goto*//*Label 25942*/ GIMT_Encode4(1932325), // Rule ID 24154 //
     /* 1932244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1932247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1932255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1932258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1932261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932290 */     // MIs[0] policy
     /* 1932290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932300 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932324 */     // GIR_Coverage, 24154,
     /* 1932324 */     GIR_EraseRootFromParent_Done,
     /* 1932325 */   // Label 25942: @1932325
     /* 1932325 */   GIM_Try, /*On fail goto*//*Label 25943*/ GIMT_Encode4(1932411), // Rule ID 24155 //
     /* 1932330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1932333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1932341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1932344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1932347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1932353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932376 */     // MIs[0] policy
     /* 1932376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932386 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11481:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932410 */     // GIR_Coverage, 24155,
     /* 1932410 */     GIR_EraseRootFromParent_Done,
     /* 1932411 */   // Label 25943: @1932411
     /* 1932411 */   GIM_Try, /*On fail goto*//*Label 25944*/ GIMT_Encode4(1932497), // Rule ID 24158 //
     /* 1932416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1932419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1932427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1932430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1932433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932462 */     // MIs[0] policy
     /* 1932462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932472 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932496 */     // GIR_Coverage, 24158,
     /* 1932496 */     GIR_EraseRootFromParent_Done,
     /* 1932497 */   // Label 25944: @1932497
     /* 1932497 */   GIM_Try, /*On fail goto*//*Label 25945*/ GIMT_Encode4(1932583), // Rule ID 24159 //
     /* 1932502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1932505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1932513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1932516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1932519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1932525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932548 */     // MIs[0] policy
     /* 1932548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932558 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11481:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1932579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932582 */     // GIR_Coverage, 24159,
     /* 1932582 */     GIR_EraseRootFromParent_Done,
     /* 1932583 */   // Label 25945: @1932583
     /* 1932583 */   GIM_Try, /*On fail goto*//*Label 25946*/ GIMT_Encode4(1932669), // Rule ID 24162 //
     /* 1932588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1932591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1932599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1932602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1932605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932634 */     // MIs[0] policy
     /* 1932634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932644 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932668 */     // GIR_Coverage, 24162,
     /* 1932668 */     GIR_EraseRootFromParent_Done,
     /* 1932669 */   // Label 25946: @1932669
     /* 1932669 */   GIM_Try, /*On fail goto*//*Label 25947*/ GIMT_Encode4(1932755), // Rule ID 24163 //
     /* 1932674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1932677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1932685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1932688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1932691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1932697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1932704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1932712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932720 */     // MIs[0] policy
     /* 1932720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932730 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11481:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 1932733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1932751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932754 */     // GIR_Coverage, 24163,
     /* 1932754 */     GIR_EraseRootFromParent_Done,
     /* 1932755 */   // Label 25947: @1932755
     /* 1932755 */   GIM_Try, /*On fail goto*//*Label 25948*/ GIMT_Encode4(1932841), // Rule ID 24166 //
     /* 1932760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1932763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1932771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1932774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1932777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932806 */     // MIs[0] policy
     /* 1932806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932816 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1932819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932840 */     // GIR_Coverage, 24166,
     /* 1932840 */     GIR_EraseRootFromParent_Done,
     /* 1932841 */   // Label 25948: @1932841
     /* 1932841 */   GIM_Try, /*On fail goto*//*Label 25949*/ GIMT_Encode4(1932927), // Rule ID 24167 //
     /* 1932846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1932849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1932857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1932860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1932863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1932866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1932869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1932872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1932876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1932884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932892 */     // MIs[0] policy
     /* 1932892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932902 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1932902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1932905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1932915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1932920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1932923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1932925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1932926 */     // GIR_Coverage, 24167,
     /* 1932926 */     GIR_EraseRootFromParent_Done,
     /* 1932927 */   // Label 25949: @1932927
     /* 1932927 */   GIM_Try, /*On fail goto*//*Label 25950*/ GIMT_Encode4(1933013), // Rule ID 24170 //
     /* 1932932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1932935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1932940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1932943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1932946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1932949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1932952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1932955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1932958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1932962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1932970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1932974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1932978 */     // MIs[0] policy
     /* 1932978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1932981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1932988 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1932988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1932991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1932993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1932995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1932997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1932999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933012 */     // GIR_Coverage, 24170,
     /* 1933012 */     GIR_EraseRootFromParent_Done,
     /* 1933013 */   // Label 25950: @1933013
     /* 1933013 */   GIM_Try, /*On fail goto*//*Label 25951*/ GIMT_Encode4(1933099), // Rule ID 24171 //
     /* 1933018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1933021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1933029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1933032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1933035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933064 */     // MIs[0] policy
     /* 1933064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933074 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1933077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933098 */     // GIR_Coverage, 24171,
     /* 1933098 */     GIR_EraseRootFromParent_Done,
     /* 1933099 */   // Label 25951: @1933099
     /* 1933099 */   GIM_Try, /*On fail goto*//*Label 25952*/ GIMT_Encode4(1933185), // Rule ID 24174 //
     /* 1933104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1933107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1933115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1933118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1933121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933150 */     // MIs[0] policy
     /* 1933150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933160 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1933163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933184 */     // GIR_Coverage, 24174,
     /* 1933184 */     GIR_EraseRootFromParent_Done,
     /* 1933185 */   // Label 25952: @1933185
     /* 1933185 */   GIM_Try, /*On fail goto*//*Label 25953*/ GIMT_Encode4(1933271), // Rule ID 24175 //
     /* 1933190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1933193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1933201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1933204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1933207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1933213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933236 */     // MIs[0] policy
     /* 1933236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933246 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1933249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1933267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933270 */     // GIR_Coverage, 24175,
     /* 1933270 */     GIR_EraseRootFromParent_Done,
     /* 1933271 */   // Label 25953: @1933271
     /* 1933271 */   GIM_Try, /*On fail goto*//*Label 25954*/ GIMT_Encode4(1933357), // Rule ID 24178 //
     /* 1933276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1933279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1933287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1933290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1933293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933322 */     // MIs[0] policy
     /* 1933322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933332 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1933335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933356 */     // GIR_Coverage, 24178,
     /* 1933356 */     GIR_EraseRootFromParent_Done,
     /* 1933357 */   // Label 25954: @1933357
     /* 1933357 */   GIM_Try, /*On fail goto*//*Label 25955*/ GIMT_Encode4(1933443), // Rule ID 24179 //
     /* 1933362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1933365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1933373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1933376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1933379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933408 */     // MIs[0] policy
     /* 1933408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933418 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1933421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933442 */     // GIR_Coverage, 24179,
     /* 1933442 */     GIR_EraseRootFromParent_Done,
     /* 1933443 */   // Label 25955: @1933443
     /* 1933443 */   GIM_Try, /*On fail goto*//*Label 25956*/ GIMT_Encode4(1933529), // Rule ID 24182 //
     /* 1933448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1933451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1933459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1933462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1933465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933494 */     // MIs[0] policy
     /* 1933494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933504 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1933507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933528 */     // GIR_Coverage, 24182,
     /* 1933528 */     GIR_EraseRootFromParent_Done,
     /* 1933529 */   // Label 25956: @1933529
     /* 1933529 */   GIM_Try, /*On fail goto*//*Label 25957*/ GIMT_Encode4(1933615), // Rule ID 24183 //
     /* 1933534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1933537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1933545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1933548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1933551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1933557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933580 */     // MIs[0] policy
     /* 1933580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933590 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1933593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933614 */     // GIR_Coverage, 24183,
     /* 1933614 */     GIR_EraseRootFromParent_Done,
     /* 1933615 */   // Label 25957: @1933615
     /* 1933615 */   GIM_Try, /*On fail goto*//*Label 25958*/ GIMT_Encode4(1933701), // Rule ID 24186 //
     /* 1933620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1933623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1933631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1933634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1933637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933666 */     // MIs[0] policy
     /* 1933666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933676 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1933679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933700 */     // GIR_Coverage, 24186,
     /* 1933700 */     GIR_EraseRootFromParent_Done,
     /* 1933701 */   // Label 25958: @1933701
     /* 1933701 */   GIM_Try, /*On fail goto*//*Label 25959*/ GIMT_Encode4(1933787), // Rule ID 24187 //
     /* 1933706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1933709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1933717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1933720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1933723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1933729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1933736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1933744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933752 */     // MIs[0] policy
     /* 1933752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933762 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1933765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1933783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933786 */     // GIR_Coverage, 24187,
     /* 1933786 */     GIR_EraseRootFromParent_Done,
     /* 1933787 */   // Label 25959: @1933787
     /* 1933787 */   GIM_Try, /*On fail goto*//*Label 25960*/ GIMT_Encode4(1933873), // Rule ID 24190 //
     /* 1933792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1933795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1933803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1933806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1933809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933838 */     // MIs[0] policy
     /* 1933838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933848 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1933848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1933851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933872 */     // GIR_Coverage, 24190,
     /* 1933872 */     GIR_EraseRootFromParent_Done,
     /* 1933873 */   // Label 25960: @1933873
     /* 1933873 */   GIM_Try, /*On fail goto*//*Label 25961*/ GIMT_Encode4(1933959), // Rule ID 24191 //
     /* 1933878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1933881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1933889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1933892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1933895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1933898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1933901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1933904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1933908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1933916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1933920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1933924 */     // MIs[0] policy
     /* 1933924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1933927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1933934 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11481:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1933934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 1933937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1933939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1933941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1933943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1933945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1933947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1933952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1933955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1933957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1933958 */     // GIR_Coverage, 24191,
     /* 1933958 */     GIR_EraseRootFromParent_Done,
     /* 1933959 */   // Label 25961: @1933959
     /* 1933959 */   GIM_Try, /*On fail goto*//*Label 25962*/ GIMT_Encode4(1934045), // Rule ID 24194 //
     /* 1933964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1933967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1933972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1933975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1933978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1933981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1933984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1933987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1933990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1933994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1933998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934010 */     // MIs[0] policy
     /* 1934010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934020 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1934023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934025 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934044 */     // GIR_Coverage, 24194,
     /* 1934044 */     GIR_EraseRootFromParent_Done,
     /* 1934045 */   // Label 25962: @1934045
     /* 1934045 */   GIM_Try, /*On fail goto*//*Label 25963*/ GIMT_Encode4(1934131), // Rule ID 24195 //
     /* 1934050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1934053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1934058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1934061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1934064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1934067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1934080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1934088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934096 */     // MIs[0] policy
     /* 1934096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934106 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11481:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 1934109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934130 */     // GIR_Coverage, 24195,
     /* 1934130 */     GIR_EraseRootFromParent_Done,
     /* 1934131 */   // Label 25963: @1934131
     /* 1934131 */   GIM_Try, /*On fail goto*//*Label 25964*/ GIMT_Encode4(1934217), // Rule ID 24198 //
     /* 1934136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1934139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1934144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1934147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1934150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1934153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1934156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934182 */     // MIs[0] policy
     /* 1934182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934192 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1934195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934216 */     // GIR_Coverage, 24198,
     /* 1934216 */     GIR_EraseRootFromParent_Done,
     /* 1934217 */   // Label 25964: @1934217
     /* 1934217 */   GIM_Try, /*On fail goto*//*Label 25965*/ GIMT_Encode4(1934303), // Rule ID 24199 //
     /* 1934222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1934225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vslidedown_mask),
     /* 1934230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1934233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1934236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1934239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1934245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1934252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1934260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1934264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934268 */     // MIs[0] policy
     /* 1934268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934278 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11481:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 1934281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1934285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1934299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934302 */     // GIR_Coverage, 24199,
     /* 1934302 */     GIR_EraseRootFromParent_Done,
     /* 1934303 */   // Label 25965: @1934303
     /* 1934303 */   GIM_Try, /*On fail goto*//*Label 25966*/ GIMT_Encode4(1934389), // Rule ID 24262 //
     /* 1934308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1934319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1934322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1934325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934354 */     // MIs[0] policy
     /* 1934354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934364 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1934367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934388 */     // GIR_Coverage, 24262,
     /* 1934388 */     GIR_EraseRootFromParent_Done,
     /* 1934389 */   // Label 25966: @1934389
     /* 1934389 */   GIM_Try, /*On fail goto*//*Label 25967*/ GIMT_Encode4(1934475), // Rule ID 24263 //
     /* 1934394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1934405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1934408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1934411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934440 */     // MIs[0] policy
     /* 1934440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934450 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF4_MASK),
     /* 1934453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934474 */     // GIR_Coverage, 24263,
     /* 1934474 */     GIR_EraseRootFromParent_Done,
     /* 1934475 */   // Label 25967: @1934475
     /* 1934475 */   GIM_Try, /*On fail goto*//*Label 25968*/ GIMT_Encode4(1934561), // Rule ID 24266 //
     /* 1934480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1934491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1934494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1934497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934526 */     // MIs[0] policy
     /* 1934526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934536 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1934539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934560 */     // GIR_Coverage, 24266,
     /* 1934560 */     GIR_EraseRootFromParent_Done,
     /* 1934561 */   // Label 25968: @1934561
     /* 1934561 */   GIM_Try, /*On fail goto*//*Label 25969*/ GIMT_Encode4(1934647), // Rule ID 24267 //
     /* 1934566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1934577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1934580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1934583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1934589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934612 */     // MIs[0] policy
     /* 1934612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934622 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_MF2_MASK),
     /* 1934625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934646 */     // GIR_Coverage, 24267,
     /* 1934646 */     GIR_EraseRootFromParent_Done,
     /* 1934647 */   // Label 25969: @1934647
     /* 1934647 */   GIM_Try, /*On fail goto*//*Label 25970*/ GIMT_Encode4(1934733), // Rule ID 24270 //
     /* 1934652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1934655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1934663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1934666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1934669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1934694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934698 */     // MIs[0] policy
     /* 1934698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934708 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1934711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934732 */     // GIR_Coverage, 24270,
     /* 1934732 */     GIR_EraseRootFromParent_Done,
     /* 1934733 */   // Label 25970: @1934733
     /* 1934733 */   GIM_Try, /*On fail goto*//*Label 25971*/ GIMT_Encode4(1934819), // Rule ID 24271 //
     /* 1934738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1934741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1934749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1934752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1934755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1934758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1934761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1934780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934784 */     // MIs[0] policy
     /* 1934784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934794 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_MF2_MASK),
     /* 1934797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1934815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934818 */     // GIR_Coverage, 24271,
     /* 1934818 */     GIR_EraseRootFromParent_Done,
     /* 1934819 */   // Label 25971: @1934819
     /* 1934819 */   GIM_Try, /*On fail goto*//*Label 25972*/ GIMT_Encode4(1934905), // Rule ID 24274 //
     /* 1934824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1934827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1934850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934870 */     // MIs[0] policy
     /* 1934870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934880 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1934880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1934883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934904 */     // GIR_Coverage, 24274,
     /* 1934904 */     GIR_EraseRootFromParent_Done,
     /* 1934905 */   // Label 25972: @1934905
     /* 1934905 */   GIM_Try, /*On fail goto*//*Label 25973*/ GIMT_Encode4(1934991), // Rule ID 24275 //
     /* 1934910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1934913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1934918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1934921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1934924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1934927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1934930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1934933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1934936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1934940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1934948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1934952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1934956 */     // MIs[0] policy
     /* 1934956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1934959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1934966 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11205:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1934966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M1_MASK),
     /* 1934969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1934971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1934973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1934975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1934977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1934979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1934984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1934987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1934989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1934990 */     // GIR_Coverage, 24275,
     /* 1934990 */     GIR_EraseRootFromParent_Done,
     /* 1934991 */   // Label 25973: @1934991
     /* 1934991 */   GIM_Try, /*On fail goto*//*Label 25974*/ GIMT_Encode4(1935077), // Rule ID 24278 //
     /* 1934996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1934999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1935007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1935010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1935013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1935038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935042 */     // MIs[0] policy
     /* 1935042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935052 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1935055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935076 */     // GIR_Coverage, 24278,
     /* 1935076 */     GIR_EraseRootFromParent_Done,
     /* 1935077 */   // Label 25974: @1935077
     /* 1935077 */   GIM_Try, /*On fail goto*//*Label 25975*/ GIMT_Encode4(1935163), // Rule ID 24279 //
     /* 1935082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1935085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1935093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1935096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1935099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1935105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1935124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935128 */     // MIs[0] policy
     /* 1935128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935138 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11205:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M1_MASK),
     /* 1935141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935162 */     // GIR_Coverage, 24279,
     /* 1935162 */     GIR_EraseRootFromParent_Done,
     /* 1935163 */   // Label 25975: @1935163
     /* 1935163 */   GIM_Try, /*On fail goto*//*Label 25976*/ GIMT_Encode4(1935249), // Rule ID 24282 //
     /* 1935168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1935171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1935179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1935182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1935185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1935210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935214 */     // MIs[0] policy
     /* 1935214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935224 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1935227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935248 */     // GIR_Coverage, 24282,
     /* 1935248 */     GIR_EraseRootFromParent_Done,
     /* 1935249 */   // Label 25976: @1935249
     /* 1935249 */   GIM_Try, /*On fail goto*//*Label 25977*/ GIMT_Encode4(1935335), // Rule ID 24283 //
     /* 1935254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1935257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1935265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1935268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1935271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1935274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1935277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1935284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1935292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1935296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935300 */     // MIs[0] policy
     /* 1935300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935310 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11205:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M1_MASK),
     /* 1935313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1935331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935334 */     // GIR_Coverage, 24283,
     /* 1935334 */     GIR_EraseRootFromParent_Done,
     /* 1935335 */   // Label 25977: @1935335
     /* 1935335 */   GIM_Try, /*On fail goto*//*Label 25978*/ GIMT_Encode4(1935421), // Rule ID 24286 //
     /* 1935340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1935343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1935351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1935354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1935357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935386 */     // MIs[0] policy
     /* 1935386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935396 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1935399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935420 */     // GIR_Coverage, 24286,
     /* 1935420 */     GIR_EraseRootFromParent_Done,
     /* 1935421 */   // Label 25978: @1935421
     /* 1935421 */   GIM_Try, /*On fail goto*//*Label 25979*/ GIMT_Encode4(1935507), // Rule ID 24287 //
     /* 1935426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1935429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1935437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1935440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1935443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1935449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935472 */     // MIs[0] policy
     /* 1935472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935482 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M2_MASK),
     /* 1935485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935506 */     // GIR_Coverage, 24287,
     /* 1935506 */     GIR_EraseRootFromParent_Done,
     /* 1935507 */   // Label 25979: @1935507
     /* 1935507 */   GIM_Try, /*On fail goto*//*Label 25980*/ GIMT_Encode4(1935593), // Rule ID 24290 //
     /* 1935512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1935515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1935523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1935526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1935529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935558 */     // MIs[0] policy
     /* 1935558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935568 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1935571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935592 */     // GIR_Coverage, 24290,
     /* 1935592 */     GIR_EraseRootFromParent_Done,
     /* 1935593 */   // Label 25980: @1935593
     /* 1935593 */   GIM_Try, /*On fail goto*//*Label 25981*/ GIMT_Encode4(1935679), // Rule ID 24291 //
     /* 1935598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1935601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1935609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1935612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1935615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1935621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1935628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1935636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935644 */     // MIs[0] policy
     /* 1935644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935654 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M4_MASK),
     /* 1935657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935678 */     // GIR_Coverage, 24291,
     /* 1935678 */     GIR_EraseRootFromParent_Done,
     /* 1935679 */   // Label 25981: @1935679
     /* 1935679 */   GIM_Try, /*On fail goto*//*Label 25982*/ GIMT_Encode4(1935765), // Rule ID 24294 //
     /* 1935684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1935687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935730 */     // MIs[0] policy
     /* 1935730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935740 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1935743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935764 */     // GIR_Coverage, 24294,
     /* 1935764 */     GIR_EraseRootFromParent_Done,
     /* 1935765 */   // Label 25982: @1935765
     /* 1935765 */   GIM_Try, /*On fail goto*//*Label 25983*/ GIMT_Encode4(1935851), // Rule ID 24295 //
     /* 1935770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1935773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1935781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1935784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1935787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1935790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1935793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1935800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1935808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1935812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935816 */     // MIs[0] policy
     /* 1935816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935826 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR16_M8_MASK),
     /* 1935829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1935847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935850 */     // GIR_Coverage, 24295,
     /* 1935850 */     GIR_EraseRootFromParent_Done,
     /* 1935851 */   // Label 25983: @1935851
     /* 1935851 */   GIM_Try, /*On fail goto*//*Label 25984*/ GIMT_Encode4(1935937), // Rule ID 24298 //
     /* 1935856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1935859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1935882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1935898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935902 */     // MIs[0] policy
     /* 1935902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935912 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1935912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1935915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1935917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1935919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1935921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1935923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1935925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1935930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1935933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1935935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1935936 */     // GIR_Coverage, 24298,
     /* 1935936 */     GIR_EraseRootFromParent_Done,
     /* 1935937 */   // Label 25984: @1935937
     /* 1935937 */   GIM_Try, /*On fail goto*//*Label 25985*/ GIMT_Encode4(1936023), // Rule ID 24299 //
     /* 1935942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1935945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1935950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1935953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1935956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1935959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1935962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1935965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1935968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1935972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1935980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1935984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1935988 */     // MIs[0] policy
     /* 1935988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1935991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1935998 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1935998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M2_MASK),
     /* 1936001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936022 */     // GIR_Coverage, 24299,
     /* 1936022 */     GIR_EraseRootFromParent_Done,
     /* 1936023 */   // Label 25985: @1936023
     /* 1936023 */   GIM_Try, /*On fail goto*//*Label 25986*/ GIMT_Encode4(1936109), // Rule ID 24302 //
     /* 1936028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1936039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1936042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1936045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1936070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936074 */     // MIs[0] policy
     /* 1936074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936084 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1936087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936108 */     // GIR_Coverage, 24302,
     /* 1936108 */     GIR_EraseRootFromParent_Done,
     /* 1936109 */   // Label 25986: @1936109
     /* 1936109 */   GIM_Try, /*On fail goto*//*Label 25987*/ GIMT_Encode4(1936195), // Rule ID 24303 //
     /* 1936114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1936125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1936128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1936131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1936156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936160 */     // MIs[0] policy
     /* 1936160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936170 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M4_MASK),
     /* 1936173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936194 */     // GIR_Coverage, 24303,
     /* 1936194 */     GIR_EraseRootFromParent_Done,
     /* 1936195 */   // Label 25987: @1936195
     /* 1936195 */   GIM_Try, /*On fail goto*//*Label 25988*/ GIMT_Encode4(1936281), // Rule ID 24306 //
     /* 1936200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1936203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1936211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1936214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1936217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1936242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936246 */     // MIs[0] policy
     /* 1936246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936256 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1936259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936280 */     // GIR_Coverage, 24306,
     /* 1936280 */     GIR_EraseRootFromParent_Done,
     /* 1936281 */   // Label 25988: @1936281
     /* 1936281 */   GIM_Try, /*On fail goto*//*Label 25989*/ GIMT_Encode4(1936367), // Rule ID 24307 //
     /* 1936286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1936289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1936297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1936300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1936303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1936306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1936309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1936328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936332 */     // MIs[0] policy
     /* 1936332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936342 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR32_M8_MASK),
     /* 1936345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1936363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936366 */     // GIR_Coverage, 24307,
     /* 1936366 */     GIR_EraseRootFromParent_Done,
     /* 1936367 */   // Label 25989: @1936367
     /* 1936367 */   GIM_Try, /*On fail goto*//*Label 25990*/ GIMT_Encode4(1936453), // Rule ID 24310 //
     /* 1936372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1936375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1936383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1936386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1936389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936418 */     // MIs[0] policy
     /* 1936418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936428 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1936431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936452 */     // GIR_Coverage, 24310,
     /* 1936452 */     GIR_EraseRootFromParent_Done,
     /* 1936453 */   // Label 25990: @1936453
     /* 1936453 */   GIM_Try, /*On fail goto*//*Label 25991*/ GIMT_Encode4(1936539), // Rule ID 24311 //
     /* 1936458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1936461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1936469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1936472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1936475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1936481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1936488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1936496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936504 */     // MIs[0] policy
     /* 1936504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936514 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11205:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M2_MASK),
     /* 1936517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936538 */     // GIR_Coverage, 24311,
     /* 1936538 */     GIR_EraseRootFromParent_Done,
     /* 1936539 */   // Label 25991: @1936539
     /* 1936539 */   GIM_Try, /*On fail goto*//*Label 25992*/ GIMT_Encode4(1936625), // Rule ID 24314 //
     /* 1936544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1936547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1936555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1936558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1936561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936590 */     // MIs[0] policy
     /* 1936590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936600 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1936603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936624 */     // GIR_Coverage, 24314,
     /* 1936624 */     GIR_EraseRootFromParent_Done,
     /* 1936625 */   // Label 25992: @1936625
     /* 1936625 */   GIM_Try, /*On fail goto*//*Label 25993*/ GIMT_Encode4(1936711), // Rule ID 24315 //
     /* 1936630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1936633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1936641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1936644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1936647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1936653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1936660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1936668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936676 */     // MIs[0] policy
     /* 1936676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936686 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11205:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M4_MASK),
     /* 1936689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936710 */     // GIR_Coverage, 24315,
     /* 1936710 */     GIR_EraseRootFromParent_Done,
     /* 1936711 */   // Label 25993: @1936711
     /* 1936711 */   GIM_Try, /*On fail goto*//*Label 25994*/ GIMT_Encode4(1936797), // Rule ID 24318 //
     /* 1936716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1936719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936762 */     // MIs[0] policy
     /* 1936762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936772 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1936775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936796 */     // GIR_Coverage, 24318,
     /* 1936796 */     GIR_EraseRootFromParent_Done,
     /* 1936797 */   // Label 25994: @1936797
     /* 1936797 */   GIM_Try, /*On fail goto*//*Label 25995*/ GIMT_Encode4(1936883), // Rule ID 24319 //
     /* 1936802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1936805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1up_mask),
     /* 1936810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1936813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1936816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1936819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1936822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1936825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1936828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1936832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1936840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1936844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936848 */     // MIs[0] policy
     /* 1936848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936858 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11205:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1UP_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1936858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1UP_VFPR64_M8_MASK),
     /* 1936861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1936879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936882 */     // GIR_Coverage, 24319,
     /* 1936882 */     GIR_EraseRootFromParent_Done,
     /* 1936883 */   // Label 25995: @1936883
     /* 1936883 */   GIM_Try, /*On fail goto*//*Label 25996*/ GIMT_Encode4(1936969), // Rule ID 24322 //
     /* 1936888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1936891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1936896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1936908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1936914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1936918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1936926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1936930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1936934 */     // MIs[0] policy
     /* 1936934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1936937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1936944 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1936944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1936947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1936949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1936951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1936953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1936955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1936957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1936962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1936965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1936967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1936968 */     // GIR_Coverage, 24322,
     /* 1936968 */     GIR_EraseRootFromParent_Done,
     /* 1936969 */   // Label 25996: @1936969
     /* 1936969 */   GIM_Try, /*On fail goto*//*Label 25997*/ GIMT_Encode4(1937055), // Rule ID 24323 //
     /* 1936974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1936977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1936982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1936985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1936988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1936991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1936994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1936997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937020 */     // MIs[0] policy
     /* 1937020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937030 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF4_MASK),
     /* 1937033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937054 */     // GIR_Coverage, 24323,
     /* 1937054 */     GIR_EraseRootFromParent_Done,
     /* 1937055 */   // Label 25997: @1937055
     /* 1937055 */   GIM_Try, /*On fail goto*//*Label 25998*/ GIMT_Encode4(1937141), // Rule ID 24326 //
     /* 1937060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1937071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1937074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1937077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1937080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937106 */     // MIs[0] policy
     /* 1937106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937116 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1937119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937140 */     // GIR_Coverage, 24326,
     /* 1937140 */     GIR_EraseRootFromParent_Done,
     /* 1937141 */   // Label 25998: @1937141
     /* 1937141 */   GIM_Try, /*On fail goto*//*Label 25999*/ GIMT_Encode4(1937227), // Rule ID 24327 //
     /* 1937146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1937149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1937157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1937160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1937163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1937166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937192 */     // MIs[0] policy
     /* 1937192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937202 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_MF2_MASK),
     /* 1937205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937226 */     // GIR_Coverage, 24327,
     /* 1937226 */     GIR_EraseRootFromParent_Done,
     /* 1937227 */   // Label 25999: @1937227
     /* 1937227 */   GIM_Try, /*On fail goto*//*Label 26000*/ GIMT_Encode4(1937313), // Rule ID 24330 //
     /* 1937232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1937243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1937246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1937249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1937274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937278 */     // MIs[0] policy
     /* 1937278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937288 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1937291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937312 */     // GIR_Coverage, 24330,
     /* 1937312 */     GIR_EraseRootFromParent_Done,
     /* 1937313 */   // Label 26000: @1937313
     /* 1937313 */   GIM_Try, /*On fail goto*//*Label 26001*/ GIMT_Encode4(1937399), // Rule ID 24331 //
     /* 1937318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1937329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1937332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1937335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1937360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937364 */     // MIs[0] policy
     /* 1937364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937374 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_MF2_MASK),
     /* 1937377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937398 */     // GIR_Coverage, 24331,
     /* 1937398 */     GIR_EraseRootFromParent_Done,
     /* 1937399 */   // Label 26001: @1937399
     /* 1937399 */   GIM_Try, /*On fail goto*//*Label 26002*/ GIMT_Encode4(1937485), // Rule ID 24334 //
     /* 1937404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1937415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1937418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1937421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1937424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937450 */     // MIs[0] policy
     /* 1937450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937460 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1937463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937484 */     // GIR_Coverage, 24334,
     /* 1937484 */     GIR_EraseRootFromParent_Done,
     /* 1937485 */   // Label 26002: @1937485
     /* 1937485 */   GIM_Try, /*On fail goto*//*Label 26003*/ GIMT_Encode4(1937571), // Rule ID 24335 //
     /* 1937490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1937493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1937501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1937504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1937507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1937510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1937513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937536 */     // MIs[0] policy
     /* 1937536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937546 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11203:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M1_MASK),
     /* 1937549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937570 */     // GIR_Coverage, 24335,
     /* 1937570 */     GIR_EraseRootFromParent_Done,
     /* 1937571 */   // Label 26003: @1937571
     /* 1937571 */   GIM_Try, /*On fail goto*//*Label 26004*/ GIMT_Encode4(1937657), // Rule ID 24338 //
     /* 1937576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1937579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1937587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1937590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1937593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1937618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937622 */     // MIs[0] policy
     /* 1937622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937632 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1937635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937656 */     // GIR_Coverage, 24338,
     /* 1937656 */     GIR_EraseRootFromParent_Done,
     /* 1937657 */   // Label 26004: @1937657
     /* 1937657 */   GIM_Try, /*On fail goto*//*Label 26005*/ GIMT_Encode4(1937743), // Rule ID 24339 //
     /* 1937662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1937665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1937673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1937676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1937679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1937682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1937685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1937704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937708 */     // MIs[0] policy
     /* 1937708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937718 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11203:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M1_MASK),
     /* 1937721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1937739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937742 */     // GIR_Coverage, 24339,
     /* 1937742 */     GIR_EraseRootFromParent_Done,
     /* 1937743 */   // Label 26005: @1937743
     /* 1937743 */   GIM_Try, /*On fail goto*//*Label 26006*/ GIMT_Encode4(1937829), // Rule ID 24342 //
     /* 1937748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1937751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1937790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937794 */     // MIs[0] policy
     /* 1937794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937804 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1937807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937828 */     // GIR_Coverage, 24342,
     /* 1937828 */     GIR_EraseRootFromParent_Done,
     /* 1937829 */   // Label 26006: @1937829
     /* 1937829 */   GIM_Try, /*On fail goto*//*Label 26007*/ GIMT_Encode4(1937915), // Rule ID 24343 //
     /* 1937834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1937837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1937845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1937848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1937851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1937854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1937857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1937860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1937864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1937872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1937876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937880 */     // MIs[0] policy
     /* 1937880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937890 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11203:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1937890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M1_MASK),
     /* 1937893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1937911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1937914 */     // GIR_Coverage, 24343,
     /* 1937914 */     GIR_EraseRootFromParent_Done,
     /* 1937915 */   // Label 26007: @1937915
     /* 1937915 */   GIM_Try, /*On fail goto*//*Label 26008*/ GIMT_Encode4(1938001), // Rule ID 24346 //
     /* 1937920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1937923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1937928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1937931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1937934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1937937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1937940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1937943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1937946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1937950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1937958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1937962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1937966 */     // MIs[0] policy
     /* 1937966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1937969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1937976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1937976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1937979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1937981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1937983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1937985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1937987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1937989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1937994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1937997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1937999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938000 */     // GIR_Coverage, 24346,
     /* 1938000 */     GIR_EraseRootFromParent_Done,
     /* 1938001 */   // Label 26008: @1938001
     /* 1938001 */   GIM_Try, /*On fail goto*//*Label 26009*/ GIMT_Encode4(1938087), // Rule ID 24347 //
     /* 1938006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1938009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1938017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1938020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1938023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938052 */     // MIs[0] policy
     /* 1938052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938062 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M2_MASK),
     /* 1938065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938086 */     // GIR_Coverage, 24347,
     /* 1938086 */     GIR_EraseRootFromParent_Done,
     /* 1938087 */   // Label 26009: @1938087
     /* 1938087 */   GIM_Try, /*On fail goto*//*Label 26010*/ GIMT_Encode4(1938173), // Rule ID 24350 //
     /* 1938092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1938095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1938103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1938106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1938109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938138 */     // MIs[0] policy
     /* 1938138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938148 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1938151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938172 */     // GIR_Coverage, 24350,
     /* 1938172 */     GIR_EraseRootFromParent_Done,
     /* 1938173 */   // Label 26010: @1938173
     /* 1938173 */   GIM_Try, /*On fail goto*//*Label 26011*/ GIMT_Encode4(1938259), // Rule ID 24351 //
     /* 1938178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1938181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1938189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1938192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1938195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938224 */     // MIs[0] policy
     /* 1938224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938234 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M4_MASK),
     /* 1938237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938258 */     // GIR_Coverage, 24351,
     /* 1938258 */     GIR_EraseRootFromParent_Done,
     /* 1938259 */   // Label 26011: @1938259
     /* 1938259 */   GIM_Try, /*On fail goto*//*Label 26012*/ GIMT_Encode4(1938345), // Rule ID 24354 //
     /* 1938264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1938267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1938275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1938278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1938281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1938287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938310 */     // MIs[0] policy
     /* 1938310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938320 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1938323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938344 */     // GIR_Coverage, 24354,
     /* 1938344 */     GIR_EraseRootFromParent_Done,
     /* 1938345 */   // Label 26012: @1938345
     /* 1938345 */   GIM_Try, /*On fail goto*//*Label 26013*/ GIMT_Encode4(1938431), // Rule ID 24355 //
     /* 1938350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1938353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1938361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1938364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1938367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 1938370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1938373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 1938392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938396 */     // MIs[0] policy
     /* 1938396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938406 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR16_M8_MASK),
     /* 1938409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1938427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938430 */     // GIR_Coverage, 24355,
     /* 1938430 */     GIR_EraseRootFromParent_Done,
     /* 1938431 */   // Label 26013: @1938431
     /* 1938431 */   GIM_Try, /*On fail goto*//*Label 26014*/ GIMT_Encode4(1938517), // Rule ID 24358 //
     /* 1938436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1938439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1938447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1938450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1938453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938482 */     // MIs[0] policy
     /* 1938482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938492 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1938495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938516 */     // GIR_Coverage, 24358,
     /* 1938516 */     GIR_EraseRootFromParent_Done,
     /* 1938517 */   // Label 26014: @1938517
     /* 1938517 */   GIM_Try, /*On fail goto*//*Label 26015*/ GIMT_Encode4(1938603), // Rule ID 24359 //
     /* 1938522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1938525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1938533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1938536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1938539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1938545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938568 */     // MIs[0] policy
     /* 1938568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938578 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M2_MASK),
     /* 1938581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938602 */     // GIR_Coverage, 24359,
     /* 1938602 */     GIR_EraseRootFromParent_Done,
     /* 1938603 */   // Label 26015: @1938603
     /* 1938603 */   GIM_Try, /*On fail goto*//*Label 26016*/ GIMT_Encode4(1938689), // Rule ID 24362 //
     /* 1938608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1938611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938654 */     // MIs[0] policy
     /* 1938654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938664 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1938667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938688 */     // GIR_Coverage, 24362,
     /* 1938688 */     GIR_EraseRootFromParent_Done,
     /* 1938689 */   // Label 26016: @1938689
     /* 1938689 */   GIM_Try, /*On fail goto*//*Label 26017*/ GIMT_Encode4(1938775), // Rule ID 24363 //
     /* 1938694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1938697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1938705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1938708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1938711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1938717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1938724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1938732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938740 */     // MIs[0] policy
     /* 1938740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938750 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M4_MASK),
     /* 1938753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938774 */     // GIR_Coverage, 24363,
     /* 1938774 */     GIR_EraseRootFromParent_Done,
     /* 1938775 */   // Label 26017: @1938775
     /* 1938775 */   GIM_Try, /*On fail goto*//*Label 26018*/ GIMT_Encode4(1938861), // Rule ID 24366 //
     /* 1938780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1938783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938826 */     // MIs[0] policy
     /* 1938826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938836 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1938836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1938839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938860 */     // GIR_Coverage, 24366,
     /* 1938860 */     GIR_EraseRootFromParent_Done,
     /* 1938861 */   // Label 26018: @1938861
     /* 1938861 */   GIM_Try, /*On fail goto*//*Label 26019*/ GIMT_Encode4(1938947), // Rule ID 24367 //
     /* 1938866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1938869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1938877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1938880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1938883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1938886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1938889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1938892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1938896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1938904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 1938908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938912 */     // MIs[0] policy
     /* 1938912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1938915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1938922 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR32_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1938922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR32_M8_MASK),
     /* 1938925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1938927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1938929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1938931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1938933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1938935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1938940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1938943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1938945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1938946 */     // GIR_Coverage, 24367,
     /* 1938946 */     GIR_EraseRootFromParent_Done,
     /* 1938947 */   // Label 26019: @1938947
     /* 1938947 */   GIM_Try, /*On fail goto*//*Label 26020*/ GIMT_Encode4(1939033), // Rule ID 24370 //
     /* 1938952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1938955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1938960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1938963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1938966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1938969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1938972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1938975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1938978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1938982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1938990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1938994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1938998 */     // MIs[0] policy
     /* 1938998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939008 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1939011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939032 */     // GIR_Coverage, 24370,
     /* 1939032 */     GIR_EraseRootFromParent_Done,
     /* 1939033 */   // Label 26020: @1939033
     /* 1939033 */   GIM_Try, /*On fail goto*//*Label 26021*/ GIMT_Encode4(1939119), // Rule ID 24371 //
     /* 1939038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1939041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1939046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1939049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1939052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1939055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1939068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1939076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939084 */     // MIs[0] policy
     /* 1939084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939094 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11203:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M2_MASK),
     /* 1939097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939118 */     // GIR_Coverage, 24371,
     /* 1939118 */     GIR_EraseRootFromParent_Done,
     /* 1939119 */   // Label 26021: @1939119
     /* 1939119 */   GIM_Try, /*On fail goto*//*Label 26022*/ GIMT_Encode4(1939205), // Rule ID 24374 //
     /* 1939124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1939127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1939132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1939135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1939138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1939141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939170 */     // MIs[0] policy
     /* 1939170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1939183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939204 */     // GIR_Coverage, 24374,
     /* 1939204 */     GIR_EraseRootFromParent_Done,
     /* 1939205 */   // Label 26022: @1939205
     /* 1939205 */   GIM_Try, /*On fail goto*//*Label 26023*/ GIMT_Encode4(1939291), // Rule ID 24375 //
     /* 1939210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1939213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1939218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1939221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1939224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1939227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1939240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1939248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939256 */     // MIs[0] policy
     /* 1939256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939266 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11203:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M4_MASK),
     /* 1939269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939290 */     // GIR_Coverage, 24375,
     /* 1939290 */     GIR_EraseRootFromParent_Done,
     /* 1939291 */   // Label 26023: @1939291
     /* 1939291 */   GIM_Try, /*On fail goto*//*Label 26024*/ GIMT_Encode4(1939377), // Rule ID 24378 //
     /* 1939296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1939299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1939304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1939307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1939310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1939313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939342 */     // MIs[0] policy
     /* 1939342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939352 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1939355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939376 */     // GIR_Coverage, 24378,
     /* 1939376 */     GIR_EraseRootFromParent_Done,
     /* 1939377 */   // Label 26024: @1939377
     /* 1939377 */   GIM_Try, /*On fail goto*//*Label 26025*/ GIMT_Encode4(1939463), // Rule ID 24379 //
     /* 1939382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1939385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfslide1down_mask),
     /* 1939390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1939393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1939396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1939399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1939402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1939405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1939412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1939420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 1939424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939428 */     // MIs[0] policy
     /* 1939428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939438 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11203:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSLIDE1DOWN_VFPR64_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSLIDE1DOWN_VFPR64_M8_MASK),
     /* 1939441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1939459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939462 */     // GIR_Coverage, 24379,
     /* 1939462 */     GIR_EraseRootFromParent_Done,
     /* 1939463 */   // Label 26025: @1939463
     /* 1939463 */   GIM_Try, /*On fail goto*//*Label 26026*/ GIMT_Encode4(1939549), // Rule ID 24382 //
     /* 1939468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1939479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1939482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1939485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1939488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939514 */     // MIs[0] policy
     /* 1939514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939524 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1939527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939548 */     // GIR_Coverage, 24382,
     /* 1939548 */     GIR_EraseRootFromParent_Done,
     /* 1939549 */   // Label 26026: @1939549
     /* 1939549 */   GIM_Try, /*On fail goto*//*Label 26027*/ GIMT_Encode4(1939635), // Rule ID 24383 //
     /* 1939554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1939565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1939568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1939571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1939574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1939577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939600 */     // MIs[0] policy
     /* 1939600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939610 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF8_E8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF8_E8_MASK),
     /* 1939613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939634 */     // GIR_Coverage, 24383,
     /* 1939634 */     GIR_EraseRootFromParent_Done,
     /* 1939635 */   // Label 26027: @1939635
     /* 1939635 */   GIM_Try, /*On fail goto*//*Label 26028*/ GIMT_Encode4(1939721), // Rule ID 24386 //
     /* 1939640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1939651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1939654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1939657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1939660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939686 */     // MIs[0] policy
     /* 1939686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939696 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1939699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939720 */     // GIR_Coverage, 24386,
     /* 1939720 */     GIR_EraseRootFromParent_Done,
     /* 1939721 */   // Label 26028: @1939721
     /* 1939721 */   GIM_Try, /*On fail goto*//*Label 26029*/ GIMT_Encode4(1939807), // Rule ID 24387 //
     /* 1939726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1939737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1939740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1939743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1939746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1939749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939772 */     // MIs[0] policy
     /* 1939772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939782 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E8_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E8_MASK),
     /* 1939785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939806 */     // GIR_Coverage, 24387,
     /* 1939806 */     GIR_EraseRootFromParent_Done,
     /* 1939807 */   // Label 26029: @1939807
     /* 1939807 */   GIM_Try, /*On fail goto*//*Label 26030*/ GIMT_Encode4(1939893), // Rule ID 24390 //
     /* 1939812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1939823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1939826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1939829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1939832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1939838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939858 */     // MIs[0] policy
     /* 1939858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939868 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1939868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1939871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939892 */     // GIR_Coverage, 24390,
     /* 1939892 */     GIR_EraseRootFromParent_Done,
     /* 1939893 */   // Label 26030: @1939893
     /* 1939893 */   GIM_Try, /*On fail goto*//*Label 26031*/ GIMT_Encode4(1939979), // Rule ID 24391 //
     /* 1939898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1939901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1939909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1939912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1939915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1939918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1939921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1939924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1939928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1939940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1939944 */     // MIs[0] policy
     /* 1939944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1939947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1939954 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E8_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1939954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E8_MASK),
     /* 1939957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1939959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1939961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1939963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1939965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1939967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1939972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1939975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1939977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1939978 */     // GIR_Coverage, 24391,
     /* 1939978 */     GIR_EraseRootFromParent_Done,
     /* 1939979 */   // Label 26031: @1939979
     /* 1939979 */   GIM_Try, /*On fail goto*//*Label 26032*/ GIMT_Encode4(1940065), // Rule ID 24394 //
     /* 1939984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1939987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1939992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1939995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1939998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1940001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1940004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940030 */     // MIs[0] policy
     /* 1940030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940040 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1940043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940064 */     // GIR_Coverage, 24394,
     /* 1940064 */     GIR_EraseRootFromParent_Done,
     /* 1940065 */   // Label 26032: @1940065
     /* 1940065 */   GIM_Try, /*On fail goto*//*Label 26033*/ GIMT_Encode4(1940151), // Rule ID 24395 //
     /* 1940070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1940081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1940084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1940087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1940090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940116 */     // MIs[0] policy
     /* 1940116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940126 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1940129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940150 */     // GIR_Coverage, 24395,
     /* 1940150 */     GIR_EraseRootFromParent_Done,
     /* 1940151 */   // Label 26033: @1940151
     /* 1940151 */   GIM_Try, /*On fail goto*//*Label 26034*/ GIMT_Encode4(1940237), // Rule ID 24398 //
     /* 1940156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1940167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1940170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1940173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1940176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940202 */     // MIs[0] policy
     /* 1940202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940212 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1940215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940236 */     // GIR_Coverage, 24398,
     /* 1940236 */     GIR_EraseRootFromParent_Done,
     /* 1940237 */   // Label 26034: @1940237
     /* 1940237 */   GIM_Try, /*On fail goto*//*Label 26035*/ GIMT_Encode4(1940323), // Rule ID 24399 //
     /* 1940242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1940253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1940256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1940259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1940262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940288 */     // MIs[0] policy
     /* 1940288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940298 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1940301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940322 */     // GIR_Coverage, 24399,
     /* 1940322 */     GIR_EraseRootFromParent_Done,
     /* 1940323 */   // Label 26035: @1940323
     /* 1940323 */   GIM_Try, /*On fail goto*//*Label 26036*/ GIMT_Encode4(1940409), // Rule ID 24402 //
     /* 1940328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1940339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1940342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1940345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1940348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940374 */     // MIs[0] policy
     /* 1940374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940384 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1940387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940408 */     // GIR_Coverage, 24402,
     /* 1940408 */     GIR_EraseRootFromParent_Done,
     /* 1940409 */   // Label 26036: @1940409
     /* 1940409 */   GIM_Try, /*On fail goto*//*Label 26037*/ GIMT_Encode4(1940495), // Rule ID 24403 //
     /* 1940414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1940425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1940428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1940431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1940434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1940437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940460 */     // MIs[0] policy
     /* 1940460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940470 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1940473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940494 */     // GIR_Coverage, 24403,
     /* 1940494 */     GIR_EraseRootFromParent_Done,
     /* 1940495 */   // Label 26037: @1940495
     /* 1940495 */   GIM_Try, /*On fail goto*//*Label 26038*/ GIMT_Encode4(1940581), // Rule ID 24406 //
     /* 1940500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1940511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1940514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1940517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1940520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940546 */     // MIs[0] policy
     /* 1940546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940556 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1940559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1940577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940580 */     // GIR_Coverage, 24406,
     /* 1940580 */     GIR_EraseRootFromParent_Done,
     /* 1940581 */   // Label 26038: @1940581
     /* 1940581 */   GIM_Try, /*On fail goto*//*Label 26039*/ GIMT_Encode4(1940667), // Rule ID 24407 //
     /* 1940586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1940597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1940600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1940603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1940606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1940609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940632 */     // MIs[0] policy
     /* 1940632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940642 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11451:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E8_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E8_MASK),
     /* 1940645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1940663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940666 */     // GIR_Coverage, 24407,
     /* 1940666 */     GIR_EraseRootFromParent_Done,
     /* 1940667 */   // Label 26039: @1940667
     /* 1940667 */   GIM_Try, /*On fail goto*//*Label 26040*/ GIMT_Encode4(1940753), // Rule ID 24410 //
     /* 1940672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1940683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1940686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1940689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1940692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940718 */     // MIs[0] policy
     /* 1940718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940728 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1940731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940752 */     // GIR_Coverage, 24410,
     /* 1940752 */     GIR_EraseRootFromParent_Done,
     /* 1940753 */   // Label 26040: @1940753
     /* 1940753 */   GIM_Try, /*On fail goto*//*Label 26041*/ GIMT_Encode4(1940839), // Rule ID 24411 //
     /* 1940758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1940769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1940772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1940775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1940778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1940781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940804 */     // MIs[0] policy
     /* 1940804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940814 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1940817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1940835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940838 */     // GIR_Coverage, 24411,
     /* 1940838 */     GIR_EraseRootFromParent_Done,
     /* 1940839 */   // Label 26041: @1940839
     /* 1940839 */   GIM_Try, /*On fail goto*//*Label 26042*/ GIMT_Encode4(1940925), // Rule ID 24414 //
     /* 1940844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1940847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1940855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1940858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1940861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1940864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1940870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940890 */     // MIs[0] policy
     /* 1940890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940900 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1940900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1940903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1940918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1940921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1940923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940924 */     // GIR_Coverage, 24414,
     /* 1940924 */     GIR_EraseRootFromParent_Done,
     /* 1940925 */   // Label 26042: @1940925
     /* 1940925 */   GIM_Try, /*On fail goto*//*Label 26043*/ GIMT_Encode4(1941011), // Rule ID 24415 //
     /* 1940930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1940933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1940938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1940941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1940944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1940947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1940950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1940953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1940956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1940960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1940972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1940976 */     // MIs[0] policy
     /* 1940976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1940979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1940986 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1940986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1940989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1940991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1940993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1940995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1940997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1940999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1941007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941010 */     // GIR_Coverage, 24415,
     /* 1941010 */     GIR_EraseRootFromParent_Done,
     /* 1941011 */   // Label 26043: @1941011
     /* 1941011 */   GIM_Try, /*On fail goto*//*Label 26044*/ GIMT_Encode4(1941097), // Rule ID 24418 //
     /* 1941016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1941019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1941036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941062 */     // MIs[0] policy
     /* 1941062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941072 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1941075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941096 */     // GIR_Coverage, 24418,
     /* 1941096 */     GIR_EraseRootFromParent_Done,
     /* 1941097 */   // Label 26044: @1941097
     /* 1941097 */   GIM_Try, /*On fail goto*//*Label 26045*/ GIMT_Encode4(1941183), // Rule ID 24419 //
     /* 1941102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1941105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1941113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1941116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1941119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1941122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1941125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1941132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1941144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941148 */     // MIs[0] policy
     /* 1941148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941158 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1941161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1941179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941182 */     // GIR_Coverage, 24419,
     /* 1941182 */     GIR_EraseRootFromParent_Done,
     /* 1941183 */   // Label 26045: @1941183
     /* 1941183 */   GIM_Try, /*On fail goto*//*Label 26046*/ GIMT_Encode4(1941269), // Rule ID 24422 //
     /* 1941188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1941199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1941202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1941205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1941208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941234 */     // MIs[0] policy
     /* 1941234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1941247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941268 */     // GIR_Coverage, 24422,
     /* 1941268 */     GIR_EraseRootFromParent_Done,
     /* 1941269 */   // Label 26046: @1941269
     /* 1941269 */   GIM_Try, /*On fail goto*//*Label 26047*/ GIMT_Encode4(1941355), // Rule ID 24423 //
     /* 1941274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1941285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1941288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1941291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1941294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941320 */     // MIs[0] policy
     /* 1941320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941330 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E8_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E8_MASK),
     /* 1941333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941354 */     // GIR_Coverage, 24423,
     /* 1941354 */     GIR_EraseRootFromParent_Done,
     /* 1941355 */   // Label 26047: @1941355
     /* 1941355 */   GIM_Try, /*On fail goto*//*Label 26048*/ GIMT_Encode4(1941441), // Rule ID 24426 //
     /* 1941360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1941371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1941374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1941377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1941380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1941383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941406 */     // MIs[0] policy
     /* 1941406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941416 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1941419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941440 */     // GIR_Coverage, 24426,
     /* 1941440 */     GIR_EraseRootFromParent_Done,
     /* 1941441 */   // Label 26048: @1941441
     /* 1941441 */   GIM_Try, /*On fail goto*//*Label 26049*/ GIMT_Encode4(1941527), // Rule ID 24427 //
     /* 1941446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1941457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1941460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1941463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1941466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1941469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941492 */     // MIs[0] policy
     /* 1941492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941502 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E8_MASK),
     /* 1941505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941526 */     // GIR_Coverage, 24427,
     /* 1941526 */     GIR_EraseRootFromParent_Done,
     /* 1941527 */   // Label 26049: @1941527
     /* 1941527 */   GIM_Try, /*On fail goto*//*Label 26050*/ GIMT_Encode4(1941613), // Rule ID 24430 //
     /* 1941532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1941543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1941546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1941549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1941552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1941555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941578 */     // MIs[0] policy
     /* 1941578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941588 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1941591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941612 */     // GIR_Coverage, 24430,
     /* 1941612 */     GIR_EraseRootFromParent_Done,
     /* 1941613 */   // Label 26050: @1941613
     /* 1941613 */   GIM_Try, /*On fail goto*//*Label 26051*/ GIMT_Encode4(1941699), // Rule ID 24431 //
     /* 1941618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1941629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1941632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1941635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1941638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1941641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1941648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1941660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941664 */     // MIs[0] policy
     /* 1941664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941674 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E8_MASK),
     /* 1941677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1941695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941698 */     // GIR_Coverage, 24431,
     /* 1941698 */     GIR_EraseRootFromParent_Done,
     /* 1941699 */   // Label 26051: @1941699
     /* 1941699 */   GIM_Try, /*On fail goto*//*Label 26052*/ GIMT_Encode4(1941785), // Rule ID 24434 //
     /* 1941704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1941715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1941718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1941721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1941724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941750 */     // MIs[0] policy
     /* 1941750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941760 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1941763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941784 */     // GIR_Coverage, 24434,
     /* 1941784 */     GIR_EraseRootFromParent_Done,
     /* 1941785 */   // Label 26052: @1941785
     /* 1941785 */   GIM_Try, /*On fail goto*//*Label 26053*/ GIMT_Encode4(1941871), // Rule ID 24435 //
     /* 1941790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1941801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1941804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1941807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1941810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1941813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1941820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1941832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941836 */     // MIs[0] policy
     /* 1941836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941846 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1941846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1941849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941870 */     // GIR_Coverage, 24435,
     /* 1941870 */     GIR_EraseRootFromParent_Done,
     /* 1941871 */   // Label 26053: @1941871
     /* 1941871 */   GIM_Try, /*On fail goto*//*Label 26054*/ GIMT_Encode4(1941957), // Rule ID 24438 //
     /* 1941876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1941879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1941887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1941890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1941893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1941896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1941902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1941922 */     // MIs[0] policy
     /* 1941922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1941925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1941932 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1941932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1941935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1941937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1941939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1941941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1941943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1941945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1941950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1941953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1941955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1941956 */     // GIR_Coverage, 24438,
     /* 1941956 */     GIR_EraseRootFromParent_Done,
     /* 1941957 */   // Label 26054: @1941957
     /* 1941957 */   GIM_Try, /*On fail goto*//*Label 26055*/ GIMT_Encode4(1942043), // Rule ID 24439 //
     /* 1941962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1941965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1941970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1941973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1941976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1941979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1941982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1941985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1941988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1941992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1941996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942008 */     // MIs[0] policy
     /* 1942008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942018 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1942021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942042 */     // GIR_Coverage, 24439,
     /* 1942042 */     GIR_EraseRootFromParent_Done,
     /* 1942043 */   // Label 26055: @1942043
     /* 1942043 */   GIM_Try, /*On fail goto*//*Label 26056*/ GIMT_Encode4(1942129), // Rule ID 24442 //
     /* 1942048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1942068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942094 */     // MIs[0] policy
     /* 1942094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942104 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1942107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942128 */     // GIR_Coverage, 24442,
     /* 1942128 */     GIR_EraseRootFromParent_Done,
     /* 1942129 */   // Label 26056: @1942129
     /* 1942129 */   GIM_Try, /*On fail goto*//*Label 26057*/ GIMT_Encode4(1942215), // Rule ID 24443 //
     /* 1942134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1942145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1942148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1942151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1942154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1942157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942180 */     // MIs[0] policy
     /* 1942180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942190 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1942193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1942211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942214 */     // GIR_Coverage, 24443,
     /* 1942214 */     GIR_EraseRootFromParent_Done,
     /* 1942215 */   // Label 26057: @1942215
     /* 1942215 */   GIM_Try, /*On fail goto*//*Label 26058*/ GIMT_Encode4(1942301), // Rule ID 24446 //
     /* 1942220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1942240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942266 */     // MIs[0] policy
     /* 1942266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1942279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942300 */     // GIR_Coverage, 24446,
     /* 1942300 */     GIR_EraseRootFromParent_Done,
     /* 1942301 */   // Label 26058: @1942301
     /* 1942301 */   GIM_Try, /*On fail goto*//*Label 26059*/ GIMT_Encode4(1942387), // Rule ID 24447 //
     /* 1942306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1942317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1942320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1942323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1942326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942352 */     // MIs[0] policy
     /* 1942352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942362 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1942365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942386 */     // GIR_Coverage, 24447,
     /* 1942386 */     GIR_EraseRootFromParent_Done,
     /* 1942387 */   // Label 26059: @1942387
     /* 1942387 */   GIM_Try, /*On fail goto*//*Label 26060*/ GIMT_Encode4(1942473), // Rule ID 24450 //
     /* 1942392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1942412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942438 */     // MIs[0] policy
     /* 1942438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942448 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1942451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942472 */     // GIR_Coverage, 24450,
     /* 1942472 */     GIR_EraseRootFromParent_Done,
     /* 1942473 */   // Label 26060: @1942473
     /* 1942473 */   GIM_Try, /*On fail goto*//*Label 26061*/ GIMT_Encode4(1942559), // Rule ID 24451 //
     /* 1942478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1942489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1942492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1942495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1942498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1942501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942524 */     // MIs[0] policy
     /* 1942524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942534 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1942537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942558 */     // GIR_Coverage, 24451,
     /* 1942558 */     GIR_EraseRootFromParent_Done,
     /* 1942559 */   // Label 26061: @1942559
     /* 1942559 */   GIM_Try, /*On fail goto*//*Label 26062*/ GIMT_Encode4(1942645), // Rule ID 24454 //
     /* 1942564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1942567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1942584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942610 */     // MIs[0] policy
     /* 1942610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1942623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942644 */     // GIR_Coverage, 24454,
     /* 1942644 */     GIR_EraseRootFromParent_Done,
     /* 1942645 */   // Label 26062: @1942645
     /* 1942645 */   GIM_Try, /*On fail goto*//*Label 26063*/ GIMT_Encode4(1942731), // Rule ID 24455 //
     /* 1942650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1942653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1942661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1942664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1942667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1942670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1942673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1942680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1942692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942696 */     // MIs[0] policy
     /* 1942696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942706 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1942709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1942727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942730 */     // GIR_Coverage, 24455,
     /* 1942730 */     GIR_EraseRootFromParent_Done,
     /* 1942731 */   // Label 26063: @1942731
     /* 1942731 */   GIM_Try, /*On fail goto*//*Label 26064*/ GIMT_Encode4(1942817), // Rule ID 24458 //
     /* 1942736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1942739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1942747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1942750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1942753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1942756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942782 */     // MIs[0] policy
     /* 1942782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1942795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942816 */     // GIR_Coverage, 24458,
     /* 1942816 */     GIR_EraseRootFromParent_Done,
     /* 1942817 */   // Label 26064: @1942817
     /* 1942817 */   GIM_Try, /*On fail goto*//*Label 26065*/ GIMT_Encode4(1942903), // Rule ID 24459 //
     /* 1942822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1942825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1942833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1942836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1942839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1942842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1942845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1942848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1942852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1942864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942868 */     // MIs[0] policy
     /* 1942868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942878 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1942878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1942881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942902 */     // GIR_Coverage, 24459,
     /* 1942902 */     GIR_EraseRootFromParent_Done,
     /* 1942903 */   // Label 26065: @1942903
     /* 1942903 */   GIM_Try, /*On fail goto*//*Label 26066*/ GIMT_Encode4(1942989), // Rule ID 24462 //
     /* 1942908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1942911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1942916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1942919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1942922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1942925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1942928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1942931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1942934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1942938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1942950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1942954 */     // MIs[0] policy
     /* 1942954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1942957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1942964 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1942964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1942967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1942969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1942971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1942973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1942975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1942977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1942982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1942985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1942987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1942988 */     // GIR_Coverage, 24462,
     /* 1942988 */     GIR_EraseRootFromParent_Done,
     /* 1942989 */   // Label 26066: @1942989
     /* 1942989 */   GIM_Try, /*On fail goto*//*Label 26067*/ GIMT_Encode4(1943075), // Rule ID 24463 //
     /* 1942994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1942997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1943002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1943005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1943008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1943011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1943014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1943024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1943036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943040 */     // MIs[0] policy
     /* 1943040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943050 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1943053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943074 */     // GIR_Coverage, 24463,
     /* 1943074 */     GIR_EraseRootFromParent_Done,
     /* 1943075 */   // Label 26067: @1943075
     /* 1943075 */   GIM_Try, /*On fail goto*//*Label 26068*/ GIMT_Encode4(1943161), // Rule ID 24466 //
     /* 1943080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1943083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1943088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1943100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943126 */     // MIs[0] policy
     /* 1943126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943136 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1943139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943160 */     // GIR_Coverage, 24466,
     /* 1943160 */     GIR_EraseRootFromParent_Done,
     /* 1943161 */   // Label 26068: @1943161
     /* 1943161 */   GIM_Try, /*On fail goto*//*Label 26069*/ GIMT_Encode4(1943247), // Rule ID 24467 //
     /* 1943166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1943169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1943174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1943177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1943180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1943183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1943186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1943189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1943196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1943208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943212 */     // MIs[0] policy
     /* 1943212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943222 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1943225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1943243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943246 */     // GIR_Coverage, 24467,
     /* 1943246 */     GIR_EraseRootFromParent_Done,
     /* 1943247 */   // Label 26069: @1943247
     /* 1943247 */   GIM_Try, /*On fail goto*//*Label 26070*/ GIMT_Encode4(1943333), // Rule ID 24470 //
     /* 1943252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1943263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1943266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1943269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943298 */     // MIs[0] policy
     /* 1943298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943308 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1943311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943332 */     // GIR_Coverage, 24470,
     /* 1943332 */     GIR_EraseRootFromParent_Done,
     /* 1943333 */   // Label 26070: @1943333
     /* 1943333 */   GIM_Try, /*On fail goto*//*Label 26071*/ GIMT_Encode4(1943419), // Rule ID 24471 //
     /* 1943338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1943349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1943352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1943355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943384 */     // MIs[0] policy
     /* 1943384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943394 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF8_MASK),
     /* 1943397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943418 */     // GIR_Coverage, 24471,
     /* 1943418 */     GIR_EraseRootFromParent_Done,
     /* 1943419 */   // Label 26071: @1943419
     /* 1943419 */   GIM_Try, /*On fail goto*//*Label 26072*/ GIMT_Encode4(1943505), // Rule ID 24474 //
     /* 1943424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1943435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1943438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1943441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943470 */     // MIs[0] policy
     /* 1943470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943480 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1943483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943504 */     // GIR_Coverage, 24474,
     /* 1943504 */     GIR_EraseRootFromParent_Done,
     /* 1943505 */   // Label 26072: @1943505
     /* 1943505 */   GIM_Try, /*On fail goto*//*Label 26073*/ GIMT_Encode4(1943591), // Rule ID 24475 //
     /* 1943510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1943521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1943524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1943527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943556 */     // MIs[0] policy
     /* 1943556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943566 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1943569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943590 */     // GIR_Coverage, 24475,
     /* 1943590 */     GIR_EraseRootFromParent_Done,
     /* 1943591 */   // Label 26073: @1943591
     /* 1943591 */   GIM_Try, /*On fail goto*//*Label 26074*/ GIMT_Encode4(1943677), // Rule ID 24478 //
     /* 1943596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1943607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1943610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1943613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943642 */     // MIs[0] policy
     /* 1943642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943652 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1943655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943676 */     // GIR_Coverage, 24478,
     /* 1943676 */     GIR_EraseRootFromParent_Done,
     /* 1943677 */   // Label 26074: @1943677
     /* 1943677 */   GIM_Try, /*On fail goto*//*Label 26075*/ GIMT_Encode4(1943763), // Rule ID 24479 //
     /* 1943682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1943693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1943696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1943699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1943705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943728 */     // MIs[0] policy
     /* 1943728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943738 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1943741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1943759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943762 */     // GIR_Coverage, 24479,
     /* 1943762 */     GIR_EraseRootFromParent_Done,
     /* 1943763 */   // Label 26075: @1943763
     /* 1943763 */   GIM_Try, /*On fail goto*//*Label 26076*/ GIMT_Encode4(1943849), // Rule ID 24482 //
     /* 1943768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943814 */     // MIs[0] policy
     /* 1943814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943824 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1943827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943848 */     // GIR_Coverage, 24482,
     /* 1943848 */     GIR_EraseRootFromParent_Done,
     /* 1943849 */   // Label 26076: @1943849
     /* 1943849 */   GIM_Try, /*On fail goto*//*Label 26077*/ GIMT_Encode4(1943935), // Rule ID 24483 //
     /* 1943854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1943857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1943865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1943868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1943871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1943874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1943877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1943880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943900 */     // MIs[0] policy
     /* 1943900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943910 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1943910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1943913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1943915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1943917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1943919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1943921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1943923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1943928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1943931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1943933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1943934 */     // GIR_Coverage, 24483,
     /* 1943934 */     GIR_EraseRootFromParent_Done,
     /* 1943935 */   // Label 26077: @1943935
     /* 1943935 */   GIM_Try, /*On fail goto*//*Label 26078*/ GIMT_Encode4(1944021), // Rule ID 24486 //
     /* 1943940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1943943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1943948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1943951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1943954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1943957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1943960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1943963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1943966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1943970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1943978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1943982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1943986 */     // MIs[0] policy
     /* 1943986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1943989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1943996 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1943996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1943999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944020 */     // GIR_Coverage, 24486,
     /* 1944020 */     GIR_EraseRootFromParent_Done,
     /* 1944021 */   // Label 26078: @1944021
     /* 1944021 */   GIM_Try, /*On fail goto*//*Label 26079*/ GIMT_Encode4(1944107), // Rule ID 24487 //
     /* 1944026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1944037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1944040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1944043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944072 */     // MIs[0] policy
     /* 1944072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944082 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1944085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944106 */     // GIR_Coverage, 24487,
     /* 1944106 */     GIR_EraseRootFromParent_Done,
     /* 1944107 */   // Label 26079: @1944107
     /* 1944107 */   GIM_Try, /*On fail goto*//*Label 26080*/ GIMT_Encode4(1944193), // Rule ID 24490 //
     /* 1944112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944158 */     // MIs[0] policy
     /* 1944158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944168 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1944171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944192 */     // GIR_Coverage, 24490,
     /* 1944192 */     GIR_EraseRootFromParent_Done,
     /* 1944193 */   // Label 26080: @1944193
     /* 1944193 */   GIM_Try, /*On fail goto*//*Label 26081*/ GIMT_Encode4(1944279), // Rule ID 24491 //
     /* 1944198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1944209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1944212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1944215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944244 */     // MIs[0] policy
     /* 1944244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944254 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1944257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944278 */     // GIR_Coverage, 24491,
     /* 1944278 */     GIR_EraseRootFromParent_Done,
     /* 1944279 */   // Label 26081: @1944279
     /* 1944279 */   GIM_Try, /*On fail goto*//*Label 26082*/ GIMT_Encode4(1944365), // Rule ID 24494 //
     /* 1944284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1944295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1944298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1944301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944330 */     // MIs[0] policy
     /* 1944330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944340 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944364 */     // GIR_Coverage, 24494,
     /* 1944364 */     GIR_EraseRootFromParent_Done,
     /* 1944365 */   // Label 26082: @1944365
     /* 1944365 */   GIM_Try, /*On fail goto*//*Label 26083*/ GIMT_Encode4(1944451), // Rule ID 24495 //
     /* 1944370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1944381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1944384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1944387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1944393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944416 */     // MIs[0] policy
     /* 1944416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944426 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11453:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1944447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944450 */     // GIR_Coverage, 24495,
     /* 1944450 */     GIR_EraseRootFromParent_Done,
     /* 1944451 */   // Label 26083: @1944451
     /* 1944451 */   GIM_Try, /*On fail goto*//*Label 26084*/ GIMT_Encode4(1944537), // Rule ID 24498 //
     /* 1944456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944502 */     // MIs[0] policy
     /* 1944502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944512 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944536 */     // GIR_Coverage, 24498,
     /* 1944536 */     GIR_EraseRootFromParent_Done,
     /* 1944537 */   // Label 26084: @1944537
     /* 1944537 */   GIM_Try, /*On fail goto*//*Label 26085*/ GIMT_Encode4(1944623), // Rule ID 24499 //
     /* 1944542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1944553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1944556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1944559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1944565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944588 */     // MIs[0] policy
     /* 1944588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944598 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1944619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944622 */     // GIR_Coverage, 24499,
     /* 1944622 */     GIR_EraseRootFromParent_Done,
     /* 1944623 */   // Label 26085: @1944623
     /* 1944623 */   GIM_Try, /*On fail goto*//*Label 26086*/ GIMT_Encode4(1944709), // Rule ID 24502 //
     /* 1944628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944674 */     // MIs[0] policy
     /* 1944674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944684 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944708 */     // GIR_Coverage, 24502,
     /* 1944708 */     GIR_EraseRootFromParent_Done,
     /* 1944709 */   // Label 26086: @1944709
     /* 1944709 */   GIM_Try, /*On fail goto*//*Label 26087*/ GIMT_Encode4(1944795), // Rule ID 24503 //
     /* 1944714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1944717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1944725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1944728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1944731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1944737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944760 */     // MIs[0] policy
     /* 1944760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944770 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1944791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944794 */     // GIR_Coverage, 24503,
     /* 1944794 */     GIR_EraseRootFromParent_Done,
     /* 1944795 */   // Label 26087: @1944795
     /* 1944795 */   GIM_Try, /*On fail goto*//*Label 26088*/ GIMT_Encode4(1944881), // Rule ID 24506 //
     /* 1944800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1944803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944846 */     // MIs[0] policy
     /* 1944846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944856 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1944856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944880 */     // GIR_Coverage, 24506,
     /* 1944880 */     GIR_EraseRootFromParent_Done,
     /* 1944881 */   // Label 26088: @1944881
     /* 1944881 */   GIM_Try, /*On fail goto*//*Label 26089*/ GIMT_Encode4(1944967), // Rule ID 24507 //
     /* 1944886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1944889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1944897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1944900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1944903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1944906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1944909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1944912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1944916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1944924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1944928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1944932 */     // MIs[0] policy
     /* 1944932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1944935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1944942 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1944942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1944945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1944947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1944949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1944951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1944953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1944955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1944960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1944963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1944965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1944966 */     // GIR_Coverage, 24507,
     /* 1944966 */     GIR_EraseRootFromParent_Done,
     /* 1944967 */   // Label 26089: @1944967
     /* 1944967 */   GIM_Try, /*On fail goto*//*Label 26090*/ GIMT_Encode4(1945053), // Rule ID 24510 //
     /* 1944972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1944975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1944980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1944983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1944986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1944989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1944992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1944995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1944998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945018 */     // MIs[0] policy
     /* 1945018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1945031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945052 */     // GIR_Coverage, 24510,
     /* 1945052 */     GIR_EraseRootFromParent_Done,
     /* 1945053 */   // Label 26090: @1945053
     /* 1945053 */   GIM_Try, /*On fail goto*//*Label 26091*/ GIMT_Encode4(1945139), // Rule ID 24511 //
     /* 1945058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1945069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1945072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1945075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945104 */     // MIs[0] policy
     /* 1945104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1945117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945138 */     // GIR_Coverage, 24511,
     /* 1945138 */     GIR_EraseRootFromParent_Done,
     /* 1945139 */   // Label 26091: @1945139
     /* 1945139 */   GIM_Try, /*On fail goto*//*Label 26092*/ GIMT_Encode4(1945225), // Rule ID 24514 //
     /* 1945144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1945155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1945158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1945161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945190 */     // MIs[0] policy
     /* 1945190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1945203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945224 */     // GIR_Coverage, 24514,
     /* 1945224 */     GIR_EraseRootFromParent_Done,
     /* 1945225 */   // Label 26092: @1945225
     /* 1945225 */   GIM_Try, /*On fail goto*//*Label 26093*/ GIMT_Encode4(1945311), // Rule ID 24515 //
     /* 1945230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1945241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1945244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1945247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945276 */     // MIs[0] policy
     /* 1945276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945286 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1945289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945310 */     // GIR_Coverage, 24515,
     /* 1945310 */     GIR_EraseRootFromParent_Done,
     /* 1945311 */   // Label 26093: @1945311
     /* 1945311 */   GIM_Try, /*On fail goto*//*Label 26094*/ GIMT_Encode4(1945397), // Rule ID 24518 //
     /* 1945316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1945327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1945330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1945333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1945339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945362 */     // MIs[0] policy
     /* 1945362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945372 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1945375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945396 */     // GIR_Coverage, 24518,
     /* 1945396 */     GIR_EraseRootFromParent_Done,
     /* 1945397 */   // Label 26094: @1945397
     /* 1945397 */   GIM_Try, /*On fail goto*//*Label 26095*/ GIMT_Encode4(1945483), // Rule ID 24519 //
     /* 1945402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1945413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1945416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1945419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1945425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945448 */     // MIs[0] policy
     /* 1945448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945458 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1945461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1945479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945482 */     // GIR_Coverage, 24519,
     /* 1945482 */     GIR_EraseRootFromParent_Done,
     /* 1945483 */   // Label 26095: @1945483
     /* 1945483 */   GIM_Try, /*On fail goto*//*Label 26096*/ GIMT_Encode4(1945569), // Rule ID 24522 //
     /* 1945488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945534 */     // MIs[0] policy
     /* 1945534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1945547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945568 */     // GIR_Coverage, 24522,
     /* 1945568 */     GIR_EraseRootFromParent_Done,
     /* 1945569 */   // Label 26096: @1945569
     /* 1945569 */   GIM_Try, /*On fail goto*//*Label 26097*/ GIMT_Encode4(1945655), // Rule ID 24523 //
     /* 1945574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1945585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1945588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1945591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1945597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1945604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1945612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945620 */     // MIs[0] policy
     /* 1945620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945630 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1945633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945654 */     // GIR_Coverage, 24523,
     /* 1945654 */     GIR_EraseRootFromParent_Done,
     /* 1945655 */   // Label 26097: @1945655
     /* 1945655 */   GIM_Try, /*On fail goto*//*Label 26098*/ GIMT_Encode4(1945741), // Rule ID 24526 //
     /* 1945660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945706 */     // MIs[0] policy
     /* 1945706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945716 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1945719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945740 */     // GIR_Coverage, 24526,
     /* 1945740 */     GIR_EraseRootFromParent_Done,
     /* 1945741 */   // Label 26098: @1945741
     /* 1945741 */   GIM_Try, /*On fail goto*//*Label 26099*/ GIMT_Encode4(1945827), // Rule ID 24527 //
     /* 1945746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1945757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1945760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1945763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1945769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1945776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1945784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945792 */     // MIs[0] policy
     /* 1945792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945802 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1945805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945826 */     // GIR_Coverage, 24527,
     /* 1945826 */     GIR_EraseRootFromParent_Done,
     /* 1945827 */   // Label 26099: @1945827
     /* 1945827 */   GIM_Try, /*On fail goto*//*Label 26100*/ GIMT_Encode4(1945913), // Rule ID 24530 //
     /* 1945832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1945835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1945852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1945858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945878 */     // MIs[0] policy
     /* 1945878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945888 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1945888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1945891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945912 */     // GIR_Coverage, 24530,
     /* 1945912 */     GIR_EraseRootFromParent_Done,
     /* 1945913 */   // Label 26100: @1945913
     /* 1945913 */   GIM_Try, /*On fail goto*//*Label 26101*/ GIMT_Encode4(1945999), // Rule ID 24531 //
     /* 1945918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1945921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1945926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1945929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1945932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1945935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1945938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1945941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1945944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1945948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1945956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1945960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1945964 */     // MIs[0] policy
     /* 1945964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1945967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1945974 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1945974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1945977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1945979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1945981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1945983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1945985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1945987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1945992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1945995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1945997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1945998 */     // GIR_Coverage, 24531,
     /* 1945998 */     GIR_EraseRootFromParent_Done,
     /* 1945999 */   // Label 26101: @1945999
     /* 1945999 */   GIM_Try, /*On fail goto*//*Label 26102*/ GIMT_Encode4(1946085), // Rule ID 24534 //
     /* 1946004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946050 */     // MIs[0] policy
     /* 1946050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1946063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946084 */     // GIR_Coverage, 24534,
     /* 1946084 */     GIR_EraseRootFromParent_Done,
     /* 1946085 */   // Label 26102: @1946085
     /* 1946085 */   GIM_Try, /*On fail goto*//*Label 26103*/ GIMT_Encode4(1946171), // Rule ID 24535 //
     /* 1946090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1946101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1946104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1946107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946136 */     // MIs[0] policy
     /* 1946136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1946149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946170 */     // GIR_Coverage, 24535,
     /* 1946170 */     GIR_EraseRootFromParent_Done,
     /* 1946171 */   // Label 26103: @1946171
     /* 1946171 */   GIM_Try, /*On fail goto*//*Label 26104*/ GIMT_Encode4(1946257), // Rule ID 24538 //
     /* 1946176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946222 */     // MIs[0] policy
     /* 1946222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946232 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1946235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946256 */     // GIR_Coverage, 24538,
     /* 1946256 */     GIR_EraseRootFromParent_Done,
     /* 1946257 */   // Label 26104: @1946257
     /* 1946257 */   GIM_Try, /*On fail goto*//*Label 26105*/ GIMT_Encode4(1946343), // Rule ID 24539 //
     /* 1946262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1946273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1946276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1946279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946308 */     // MIs[0] policy
     /* 1946308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946318 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1946321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946342 */     // GIR_Coverage, 24539,
     /* 1946342 */     GIR_EraseRootFromParent_Done,
     /* 1946343 */   // Label 26105: @1946343
     /* 1946343 */   GIM_Try, /*On fail goto*//*Label 26106*/ GIMT_Encode4(1946429), // Rule ID 24542 //
     /* 1946348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1946351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1946359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1946362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1946365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946394 */     // MIs[0] policy
     /* 1946394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1946407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946428 */     // GIR_Coverage, 24542,
     /* 1946428 */     GIR_EraseRootFromParent_Done,
     /* 1946429 */   // Label 26106: @1946429
     /* 1946429 */   GIM_Try, /*On fail goto*//*Label 26107*/ GIMT_Encode4(1946515), // Rule ID 24543 //
     /* 1946434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1946437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1946445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1946448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1946451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1946457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946480 */     // MIs[0] policy
     /* 1946480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946490 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1946493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1946511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946514 */     // GIR_Coverage, 24543,
     /* 1946514 */     GIR_EraseRootFromParent_Done,
     /* 1946515 */   // Label 26107: @1946515
     /* 1946515 */   GIM_Try, /*On fail goto*//*Label 26108*/ GIMT_Encode4(1946601), // Rule ID 24546 //
     /* 1946520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1946523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946566 */     // MIs[0] policy
     /* 1946566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946576 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1946579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946600 */     // GIR_Coverage, 24546,
     /* 1946600 */     GIR_EraseRootFromParent_Done,
     /* 1946601 */   // Label 26108: @1946601
     /* 1946601 */   GIM_Try, /*On fail goto*//*Label 26109*/ GIMT_Encode4(1946687), // Rule ID 24547 //
     /* 1946606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1946609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1946617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1946620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1946623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1946629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1946636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1946644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946652 */     // MIs[0] policy
     /* 1946652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946662 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1946665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946686 */     // GIR_Coverage, 24547,
     /* 1946686 */     GIR_EraseRootFromParent_Done,
     /* 1946687 */   // Label 26109: @1946687
     /* 1946687 */   GIM_Try, /*On fail goto*//*Label 26110*/ GIMT_Encode4(1946773), // Rule ID 24550 //
     /* 1946692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1946695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946738 */     // MIs[0] policy
     /* 1946738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946748 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1946751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946772 */     // GIR_Coverage, 24550,
     /* 1946772 */     GIR_EraseRootFromParent_Done,
     /* 1946773 */   // Label 26110: @1946773
     /* 1946773 */   GIM_Try, /*On fail goto*//*Label 26111*/ GIMT_Encode4(1946859), // Rule ID 24551 //
     /* 1946778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1946781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1946789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1946792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1946795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1946801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1946808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1946816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946824 */     // MIs[0] policy
     /* 1946824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946834 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1946834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1946837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946858 */     // GIR_Coverage, 24551,
     /* 1946858 */     GIR_EraseRootFromParent_Done,
     /* 1946859 */   // Label 26111: @1946859
     /* 1946859 */   GIM_Try, /*On fail goto*//*Label 26112*/ GIMT_Encode4(1946945), // Rule ID 24554 //
     /* 1946864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 1946867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1946884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1946890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946910 */     // MIs[0] policy
     /* 1946910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1946920 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1946920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1946923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1946925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1946927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1946929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1946931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1946933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1946938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1946941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1946943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1946944 */     // GIR_Coverage, 24554,
     /* 1946944 */     GIR_EraseRootFromParent_Done,
     /* 1946945 */   // Label 26112: @1946945
     /* 1946945 */   GIM_Try, /*On fail goto*//*Label 26113*/ GIMT_Encode4(1947031), // Rule ID 24555 //
     /* 1946950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 1946953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1946958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1946961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1946964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1946967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1946970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1946973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1946976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1946980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1946988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1946992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1946996 */     // MIs[0] policy
     /* 1946996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1946999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947006 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1947009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1947027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947030 */     // GIR_Coverage, 24555,
     /* 1947030 */     GIR_EraseRootFromParent_Done,
     /* 1947031 */   // Label 26113: @1947031
     /* 1947031 */   GIM_Try, /*On fail goto*//*Label 26114*/ GIMT_Encode4(1947117), // Rule ID 24646 //
     /* 1947036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1947047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1947050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1947053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947082 */     // MIs[0] policy
     /* 1947082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947092 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1947095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947116 */     // GIR_Coverage, 24646,
     /* 1947116 */     GIR_EraseRootFromParent_Done,
     /* 1947117 */   // Label 26114: @1947117
     /* 1947117 */   GIM_Try, /*On fail goto*//*Label 26115*/ GIMT_Encode4(1947203), // Rule ID 24647 //
     /* 1947122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1947133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1947136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1947139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947168 */     // MIs[0] policy
     /* 1947168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947178 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF8_E8_MF4_MASK),
     /* 1947181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947202 */     // GIR_Coverage, 24647,
     /* 1947202 */     GIR_EraseRootFromParent_Done,
     /* 1947203 */   // Label 26115: @1947203
     /* 1947203 */   GIM_Try, /*On fail goto*//*Label 26116*/ GIMT_Encode4(1947289), // Rule ID 24650 //
     /* 1947208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1947219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1947222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1947225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947254 */     // MIs[0] policy
     /* 1947254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947264 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1947267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947269 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947288 */     // GIR_Coverage, 24650,
     /* 1947288 */     GIR_EraseRootFromParent_Done,
     /* 1947289 */   // Label 26116: @1947289
     /* 1947289 */   GIM_Try, /*On fail goto*//*Label 26117*/ GIMT_Encode4(1947375), // Rule ID 24651 //
     /* 1947294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1947305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1947308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1947311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947340 */     // MIs[0] policy
     /* 1947340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947350 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E8_MF2_MASK),
     /* 1947353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947355 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947374 */     // GIR_Coverage, 24651,
     /* 1947374 */     GIR_EraseRootFromParent_Done,
     /* 1947375 */   // Label 26117: @1947375
     /* 1947375 */   GIM_Try, /*On fail goto*//*Label 26118*/ GIMT_Encode4(1947461), // Rule ID 24654 //
     /* 1947380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1947391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1947394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1947397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947426 */     // MIs[0] policy
     /* 1947426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947436 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1947439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947460 */     // GIR_Coverage, 24654,
     /* 1947460 */     GIR_EraseRootFromParent_Done,
     /* 1947461 */   // Label 26118: @1947461
     /* 1947461 */   GIM_Try, /*On fail goto*//*Label 26119*/ GIMT_Encode4(1947547), // Rule ID 24655 //
     /* 1947466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1947477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1947480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1947483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1947486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1947489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947512 */     // MIs[0] policy
     /* 1947512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947522 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E8_M1_MASK),
     /* 1947525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1947543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947546 */     // GIR_Coverage, 24655,
     /* 1947546 */     GIR_EraseRootFromParent_Done,
     /* 1947547 */   // Label 26119: @1947547
     /* 1947547 */   GIM_Try, /*On fail goto*//*Label 26120*/ GIMT_Encode4(1947633), // Rule ID 24658 //
     /* 1947552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947598 */     // MIs[0] policy
     /* 1947598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947608 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1947611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947632 */     // GIR_Coverage, 24658,
     /* 1947632 */     GIR_EraseRootFromParent_Done,
     /* 1947633 */   // Label 26120: @1947633
     /* 1947633 */   GIM_Try, /*On fail goto*//*Label 26121*/ GIMT_Encode4(1947719), // Rule ID 24659 //
     /* 1947638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1947649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1947652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1947655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947684 */     // MIs[0] policy
     /* 1947684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1947697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947718 */     // GIR_Coverage, 24659,
     /* 1947718 */     GIR_EraseRootFromParent_Done,
     /* 1947719 */   // Label 26121: @1947719
     /* 1947719 */   GIM_Try, /*On fail goto*//*Label 26122*/ GIMT_Encode4(1947805), // Rule ID 24662 //
     /* 1947724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947770 */     // MIs[0] policy
     /* 1947770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947780 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1947783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947804 */     // GIR_Coverage, 24662,
     /* 1947804 */     GIR_EraseRootFromParent_Done,
     /* 1947805 */   // Label 26122: @1947805
     /* 1947805 */   GIM_Try, /*On fail goto*//*Label 26123*/ GIMT_Encode4(1947891), // Rule ID 24663 //
     /* 1947810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1947821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1947824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1947827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1947830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1947833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1947836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947856 */     // MIs[0] policy
     /* 1947856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947866 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1947866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1947869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1947887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947890 */     // GIR_Coverage, 24663,
     /* 1947890 */     GIR_EraseRootFromParent_Done,
     /* 1947891 */   // Label 26123: @1947891
     /* 1947891 */   GIM_Try, /*On fail goto*//*Label 26124*/ GIMT_Encode4(1947977), // Rule ID 24666 //
     /* 1947896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1947899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1947916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1947919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1947922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1947926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1947938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1947942 */     // MIs[0] policy
     /* 1947942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1947945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1947952 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1947952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1947955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1947957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1947959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1947961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1947963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1947965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1947970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1947973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1947975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1947976 */     // GIR_Coverage, 24666,
     /* 1947976 */     GIR_EraseRootFromParent_Done,
     /* 1947977 */   // Label 26124: @1947977
     /* 1947977 */   GIM_Try, /*On fail goto*//*Label 26125*/ GIMT_Encode4(1948063), // Rule ID 24667 //
     /* 1947982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1947985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1947990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1947993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1947996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1947999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1948002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948028 */     // MIs[0] policy
     /* 1948028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1948041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948062 */     // GIR_Coverage, 24667,
     /* 1948062 */     GIR_EraseRootFromParent_Done,
     /* 1948063 */   // Label 26125: @1948063
     /* 1948063 */   GIM_Try, /*On fail goto*//*Label 26126*/ GIMT_Encode4(1948149), // Rule ID 24670 //
     /* 1948068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1948079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1948082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1948085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948114 */     // MIs[0] policy
     /* 1948114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948124 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1948127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948148 */     // GIR_Coverage, 24670,
     /* 1948148 */     GIR_EraseRootFromParent_Done,
     /* 1948149 */   // Label 26126: @1948149
     /* 1948149 */   GIM_Try, /*On fail goto*//*Label 26127*/ GIMT_Encode4(1948235), // Rule ID 24671 //
     /* 1948154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1948165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1948168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1948171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1948174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1948177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948200 */     // MIs[0] policy
     /* 1948200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948210 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11455:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E8_M2_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E8_M2_MASK),
     /* 1948213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948234 */     // GIR_Coverage, 24671,
     /* 1948234 */     GIR_EraseRootFromParent_Done,
     /* 1948235 */   // Label 26127: @1948235
     /* 1948235 */   GIM_Try, /*On fail goto*//*Label 26128*/ GIMT_Encode4(1948321), // Rule ID 24674 //
     /* 1948240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1948251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1948254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1948257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1948260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948286 */     // MIs[0] policy
     /* 1948286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948296 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1948299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948320 */     // GIR_Coverage, 24674,
     /* 1948320 */     GIR_EraseRootFromParent_Done,
     /* 1948321 */   // Label 26128: @1948321
     /* 1948321 */   GIM_Try, /*On fail goto*//*Label 26129*/ GIMT_Encode4(1948407), // Rule ID 24675 //
     /* 1948326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1948337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1948340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1948343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1948346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1948349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948372 */     // MIs[0] policy
     /* 1948372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948382 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1948385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1948403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948406 */     // GIR_Coverage, 24675,
     /* 1948406 */     GIR_EraseRootFromParent_Done,
     /* 1948407 */   // Label 26129: @1948407
     /* 1948407 */   GIM_Try, /*On fail goto*//*Label 26130*/ GIMT_Encode4(1948493), // Rule ID 24678 //
     /* 1948412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1948432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948458 */     // MIs[0] policy
     /* 1948458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948468 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1948471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948492 */     // GIR_Coverage, 24678,
     /* 1948492 */     GIR_EraseRootFromParent_Done,
     /* 1948493 */   // Label 26130: @1948493
     /* 1948493 */   GIM_Try, /*On fail goto*//*Label 26131*/ GIMT_Encode4(1948579), // Rule ID 24679 //
     /* 1948498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1948509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1948512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1948515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1948518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1948521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948544 */     // MIs[0] policy
     /* 1948544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948554 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1948557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1948575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948578 */     // GIR_Coverage, 24679,
     /* 1948578 */     GIR_EraseRootFromParent_Done,
     /* 1948579 */   // Label 26131: @1948579
     /* 1948579 */   GIM_Try, /*On fail goto*//*Label 26132*/ GIMT_Encode4(1948665), // Rule ID 24682 //
     /* 1948584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1948587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1948604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948630 */     // MIs[0] policy
     /* 1948630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948640 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1948643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948664 */     // GIR_Coverage, 24682,
     /* 1948664 */     GIR_EraseRootFromParent_Done,
     /* 1948665 */   // Label 26132: @1948665
     /* 1948665 */   GIM_Try, /*On fail goto*//*Label 26133*/ GIMT_Encode4(1948751), // Rule ID 24683 //
     /* 1948670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1948673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1948681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1948684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1948687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1948690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1948693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1948700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1948712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948716 */     // MIs[0] policy
     /* 1948716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948726 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1948729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1948747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948750 */     // GIR_Coverage, 24683,
     /* 1948750 */     GIR_EraseRootFromParent_Done,
     /* 1948751 */   // Label 26133: @1948751
     /* 1948751 */   GIM_Try, /*On fail goto*//*Label 26134*/ GIMT_Encode4(1948837), // Rule ID 24686 //
     /* 1948756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948802 */     // MIs[0] policy
     /* 1948802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948812 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1948815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948836 */     // GIR_Coverage, 24686,
     /* 1948836 */     GIR_EraseRootFromParent_Done,
     /* 1948837 */   // Label 26134: @1948837
     /* 1948837 */   GIM_Try, /*On fail goto*//*Label 26135*/ GIMT_Encode4(1948923), // Rule ID 24687 //
     /* 1948842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1948845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1948853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1948856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1948859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1948862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1948865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1948868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1948872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1948880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948888 */     // MIs[0] policy
     /* 1948888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948898 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E8_M4_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1948898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E8_M4_MASK),
     /* 1948901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948903 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1948916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1948919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1948921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1948922 */     // GIR_Coverage, 24687,
     /* 1948922 */     GIR_EraseRootFromParent_Done,
     /* 1948923 */   // Label 26135: @1948923
     /* 1948923 */   GIM_Try, /*On fail goto*//*Label 26136*/ GIMT_Encode4(1949009), // Rule ID 24690 //
     /* 1948928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1948931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1948936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1948939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1948942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1948945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1948948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1948951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1948954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1948958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1948966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1948970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1948974 */     // MIs[0] policy
     /* 1948974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1948977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1948984 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1948984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1948987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1948989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1948991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1948993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1948995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1948997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949008 */     // GIR_Coverage, 24690,
     /* 1949008 */     GIR_EraseRootFromParent_Done,
     /* 1949009 */   // Label 26136: @1949009
     /* 1949009 */   GIM_Try, /*On fail goto*//*Label 26137*/ GIMT_Encode4(1949095), // Rule ID 24691 //
     /* 1949014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1949025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1949028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1949031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949060 */     // MIs[0] policy
     /* 1949060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949070 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E8_M8_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E8_M8_MASK),
     /* 1949073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1949091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949094 */     // GIR_Coverage, 24691,
     /* 1949094 */     GIR_EraseRootFromParent_Done,
     /* 1949095 */   // Label 26137: @1949095
     /* 1949095 */   GIM_Try, /*On fail goto*//*Label 26138*/ GIMT_Encode4(1949181), // Rule ID 24694 //
     /* 1949100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1949111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1949114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1949117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1949120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949146 */     // MIs[0] policy
     /* 1949146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1949159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949180 */     // GIR_Coverage, 24694,
     /* 1949180 */     GIR_EraseRootFromParent_Done,
     /* 1949181 */   // Label 26138: @1949181
     /* 1949181 */   GIM_Try, /*On fail goto*//*Label 26139*/ GIMT_Encode4(1949267), // Rule ID 24695 //
     /* 1949186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1949197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1949200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1949203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1949206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949232 */     // MIs[0] policy
     /* 1949232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1949245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949266 */     // GIR_Coverage, 24695,
     /* 1949266 */     GIR_EraseRootFromParent_Done,
     /* 1949267 */   // Label 26139: @1949267
     /* 1949267 */   GIM_Try, /*On fail goto*//*Label 26140*/ GIMT_Encode4(1949353), // Rule ID 24698 //
     /* 1949272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1949283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1949286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1949289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1949292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949318 */     // MIs[0] policy
     /* 1949318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949328 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1949331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949352 */     // GIR_Coverage, 24698,
     /* 1949352 */     GIR_EraseRootFromParent_Done,
     /* 1949353 */   // Label 26140: @1949353
     /* 1949353 */   GIM_Try, /*On fail goto*//*Label 26141*/ GIMT_Encode4(1949439), // Rule ID 24699 //
     /* 1949358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1949369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1949372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1949375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1949378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949404 */     // MIs[0] policy
     /* 1949404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1949417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949438 */     // GIR_Coverage, 24699,
     /* 1949438 */     GIR_EraseRootFromParent_Done,
     /* 1949439 */   // Label 26141: @1949439
     /* 1949439 */   GIM_Try, /*On fail goto*//*Label 26142*/ GIMT_Encode4(1949525), // Rule ID 24702 //
     /* 1949444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949490 */     // MIs[0] policy
     /* 1949490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949500 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1949503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949524 */     // GIR_Coverage, 24702,
     /* 1949524 */     GIR_EraseRootFromParent_Done,
     /* 1949525 */   // Label 26142: @1949525
     /* 1949525 */   GIM_Try, /*On fail goto*//*Label 26143*/ GIMT_Encode4(1949611), // Rule ID 24703 //
     /* 1949530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1949541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1949544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1949547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1949550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1949553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949576 */     // MIs[0] policy
     /* 1949576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949586 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1949589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1949607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949610 */     // GIR_Coverage, 24703,
     /* 1949610 */     GIR_EraseRootFromParent_Done,
     /* 1949611 */   // Label 26143: @1949611
     /* 1949611 */   GIM_Try, /*On fail goto*//*Label 26144*/ GIMT_Encode4(1949697), // Rule ID 24706 //
     /* 1949616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1949636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949662 */     // MIs[0] policy
     /* 1949662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1949675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949696 */     // GIR_Coverage, 24706,
     /* 1949696 */     GIR_EraseRootFromParent_Done,
     /* 1949697 */   // Label 26144: @1949697
     /* 1949697 */   GIM_Try, /*On fail goto*//*Label 26145*/ GIMT_Encode4(1949783), // Rule ID 24707 //
     /* 1949702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1949713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1949716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1949719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1949722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1949725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1949732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1949744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949748 */     // MIs[0] policy
     /* 1949748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1949761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949782 */     // GIR_Coverage, 24707,
     /* 1949782 */     GIR_EraseRootFromParent_Done,
     /* 1949783 */   // Label 26145: @1949783
     /* 1949783 */   GIM_Try, /*On fail goto*//*Label 26146*/ GIMT_Encode4(1949869), // Rule ID 24710 //
     /* 1949788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1949808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949834 */     // MIs[0] policy
     /* 1949834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949844 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1949844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1949847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949868 */     // GIR_Coverage, 24710,
     /* 1949868 */     GIR_EraseRootFromParent_Done,
     /* 1949869 */   // Label 26146: @1949869
     /* 1949869 */   GIM_Try, /*On fail goto*//*Label 26147*/ GIMT_Encode4(1949955), // Rule ID 24711 //
     /* 1949874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1949877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1949885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1949888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1949891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1949894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1949897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1949900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1949904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1949912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1949916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1949920 */     // MIs[0] policy
     /* 1949920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1949923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1949930 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1949930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1949933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1949935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1949937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1949939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1949941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1949943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1949948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1949951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1949953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1949954 */     // GIR_Coverage, 24711,
     /* 1949954 */     GIR_EraseRootFromParent_Done,
     /* 1949955 */   // Label 26147: @1949955
     /* 1949955 */   GIM_Try, /*On fail goto*//*Label 26148*/ GIMT_Encode4(1950041), // Rule ID 24714 //
     /* 1949960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 1949963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1949968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1949971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1949974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1949977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1949980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1949983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1949986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1949990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1949998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950006 */     // MIs[0] policy
     /* 1950006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950016 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1950019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950040 */     // GIR_Coverage, 24714,
     /* 1950040 */     GIR_EraseRootFromParent_Done,
     /* 1950041 */   // Label 26148: @1950041
     /* 1950041 */   GIM_Try, /*On fail goto*//*Label 26149*/ GIMT_Encode4(1950127), // Rule ID 24715 //
     /* 1950046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 1950049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1950057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1950060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1950063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1950066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1950069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950092 */     // MIs[0] policy
     /* 1950092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950102 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1950105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950126 */     // GIR_Coverage, 24715,
     /* 1950126 */     GIR_EraseRootFromParent_Done,
     /* 1950127 */   // Label 26149: @1950127
     /* 1950127 */   GIM_Try, /*On fail goto*//*Label 26150*/ GIMT_Encode4(1950213), // Rule ID 24718 //
     /* 1950132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1950135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1950143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1950146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1950149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1950152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950178 */     // MIs[0] policy
     /* 1950178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1950191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950212 */     // GIR_Coverage, 24718,
     /* 1950212 */     GIR_EraseRootFromParent_Done,
     /* 1950213 */   // Label 26150: @1950213
     /* 1950213 */   GIM_Try, /*On fail goto*//*Label 26151*/ GIMT_Encode4(1950299), // Rule ID 24719 //
     /* 1950218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1950221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1950229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1950232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1950235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1950238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1950248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950264 */     // MIs[0] policy
     /* 1950264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950274 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1950277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950298 */     // GIR_Coverage, 24719,
     /* 1950298 */     GIR_EraseRootFromParent_Done,
     /* 1950299 */   // Label 26151: @1950299
     /* 1950299 */   GIM_Try, /*On fail goto*//*Label 26152*/ GIMT_Encode4(1950385), // Rule ID 24722 //
     /* 1950304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1950307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1950315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1950318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1950321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1950324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950350 */     // MIs[0] policy
     /* 1950350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950360 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1950363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950384 */     // GIR_Coverage, 24722,
     /* 1950384 */     GIR_EraseRootFromParent_Done,
     /* 1950385 */   // Label 26152: @1950385
     /* 1950385 */   GIM_Try, /*On fail goto*//*Label 26153*/ GIMT_Encode4(1950471), // Rule ID 24723 //
     /* 1950390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1950393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1950401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1950404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1950407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1950410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1950413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1950420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1950428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950436 */     // MIs[0] policy
     /* 1950436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950446 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1950449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950451 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950470 */     // GIR_Coverage, 24723,
     /* 1950470 */     GIR_EraseRootFromParent_Done,
     /* 1950471 */   // Label 26153: @1950471
     /* 1950471 */   GIM_Try, /*On fail goto*//*Label 26154*/ GIMT_Encode4(1950557), // Rule ID 24726 //
     /* 1950476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 1950479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1950496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950522 */     // MIs[0] policy
     /* 1950522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950532 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1950535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950556 */     // GIR_Coverage, 24726,
     /* 1950556 */     GIR_EraseRootFromParent_Done,
     /* 1950557 */   // Label 26154: @1950557
     /* 1950557 */   GIM_Try, /*On fail goto*//*Label 26155*/ GIMT_Encode4(1950643), // Rule ID 24727 //
     /* 1950562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 1950565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1950570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1950573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1950576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1950579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1950582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1950585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1950592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1950600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1950604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950608 */     // MIs[0] policy
     /* 1950608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950618 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1950621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1950639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950642 */     // GIR_Coverage, 24727,
     /* 1950642 */     GIR_EraseRootFromParent_Done,
     /* 1950643 */   // Label 26155: @1950643
     /* 1950643 */   GIM_Try, /*On fail goto*//*Label 26156*/ GIMT_Encode4(1950729), // Rule ID 24730 //
     /* 1950648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1950651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1950668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950694 */     // MIs[0] policy
     /* 1950694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950704 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1950707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950728 */     // GIR_Coverage, 24730,
     /* 1950728 */     GIR_EraseRootFromParent_Done,
     /* 1950729 */   // Label 26156: @1950729
     /* 1950729 */   GIM_Try, /*On fail goto*//*Label 26157*/ GIMT_Encode4(1950815), // Rule ID 24731 //
     /* 1950734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1950737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1950745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1950748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1950751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1950754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1950757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950780 */     // MIs[0] policy
     /* 1950780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950790 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E32_MASK),
     /* 1950793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950814 */     // GIR_Coverage, 24731,
     /* 1950814 */     GIR_EraseRootFromParent_Done,
     /* 1950815 */   // Label 26157: @1950815
     /* 1950815 */   GIM_Try, /*On fail goto*//*Label 26158*/ GIMT_Encode4(1950901), // Rule ID 24734 //
     /* 1950820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1950823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1950831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1950834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1950837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1950840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1950846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950866 */     // MIs[0] policy
     /* 1950866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950876 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1950876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1950879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950900 */     // GIR_Coverage, 24734,
     /* 1950900 */     GIR_EraseRootFromParent_Done,
     /* 1950901 */   // Label 26158: @1950901
     /* 1950901 */   GIM_Try, /*On fail goto*//*Label 26159*/ GIMT_Encode4(1950987), // Rule ID 24735 //
     /* 1950906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1950909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1950914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1950917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1950920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1950923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1950926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1950929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1950932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1950936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1950948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1950952 */     // MIs[0] policy
     /* 1950952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1950955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1950962 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1950962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E32_MASK),
     /* 1950965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1950967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1950969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1950971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1950973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1950975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1950980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1950983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1950985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1950986 */     // GIR_Coverage, 24735,
     /* 1950986 */     GIR_EraseRootFromParent_Done,
     /* 1950987 */   // Label 26159: @1950987
     /* 1950987 */   GIM_Try, /*On fail goto*//*Label 26160*/ GIMT_Encode4(1951073), // Rule ID 24738 //
     /* 1950992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1950995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1951012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951038 */     // MIs[0] policy
     /* 1951038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951048 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1951051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951072 */     // GIR_Coverage, 24738,
     /* 1951072 */     GIR_EraseRootFromParent_Done,
     /* 1951073 */   // Label 26160: @1951073
     /* 1951073 */   GIM_Try, /*On fail goto*//*Label 26161*/ GIMT_Encode4(1951159), // Rule ID 24739 //
     /* 1951078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1951081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1951089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1951092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1951095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1951098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1951101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1951108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1951120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951124 */     // MIs[0] policy
     /* 1951124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951134 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E64_MASK),
     /* 1951137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951158 */     // GIR_Coverage, 24739,
     /* 1951158 */     GIR_EraseRootFromParent_Done,
     /* 1951159 */   // Label 26161: @1951159
     /* 1951159 */   GIM_Try, /*On fail goto*//*Label 26162*/ GIMT_Encode4(1951245), // Rule ID 24742 //
     /* 1951164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1951167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1951175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1951178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1951181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1951184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951210 */     // MIs[0] policy
     /* 1951210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951220 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1951223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951244 */     // GIR_Coverage, 24742,
     /* 1951244 */     GIR_EraseRootFromParent_Done,
     /* 1951245 */   // Label 26162: @1951245
     /* 1951245 */   GIM_Try, /*On fail goto*//*Label 26163*/ GIMT_Encode4(1951331), // Rule ID 24743 //
     /* 1951250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1951253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1951261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1951264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1951267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1951270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951296 */     // MIs[0] policy
     /* 1951296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E32_MASK),
     /* 1951309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951330 */     // GIR_Coverage, 24743,
     /* 1951330 */     GIR_EraseRootFromParent_Done,
     /* 1951331 */   // Label 26163: @1951331
     /* 1951331 */   GIM_Try, /*On fail goto*//*Label 26164*/ GIMT_Encode4(1951417), // Rule ID 24746 //
     /* 1951336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1951339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1951347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1951350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1951353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1951356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951382 */     // MIs[0] policy
     /* 1951382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951392 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1951395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951416 */     // GIR_Coverage, 24746,
     /* 1951416 */     GIR_EraseRootFromParent_Done,
     /* 1951417 */   // Label 26164: @1951417
     /* 1951417 */   GIM_Try, /*On fail goto*//*Label 26165*/ GIMT_Encode4(1951503), // Rule ID 24747 //
     /* 1951422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1951425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1951433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1951436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1951439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1951442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1951445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951468 */     // MIs[0] policy
     /* 1951468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951478 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E32_MASK),
     /* 1951481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951502 */     // GIR_Coverage, 24747,
     /* 1951502 */     GIR_EraseRootFromParent_Done,
     /* 1951503 */   // Label 26165: @1951503
     /* 1951503 */   GIM_Try, /*On fail goto*//*Label 26166*/ GIMT_Encode4(1951589), // Rule ID 24750 //
     /* 1951508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1951511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1951519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1951522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1951525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1951528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951554 */     // MIs[0] policy
     /* 1951554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951564 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1951567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951588 */     // GIR_Coverage, 24750,
     /* 1951588 */     GIR_EraseRootFromParent_Done,
     /* 1951589 */   // Label 26166: @1951589
     /* 1951589 */   GIM_Try, /*On fail goto*//*Label 26167*/ GIMT_Encode4(1951675), // Rule ID 24751 //
     /* 1951594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1951597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1951605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1951608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1951611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1951614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1951617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1951624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1951636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951640 */     // MIs[0] policy
     /* 1951640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951650 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E32_MASK),
     /* 1951653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1951671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951674 */     // GIR_Coverage, 24751,
     /* 1951674 */     GIR_EraseRootFromParent_Done,
     /* 1951675 */   // Label 26167: @1951675
     /* 1951675 */   GIM_Try, /*On fail goto*//*Label 26168*/ GIMT_Encode4(1951761), // Rule ID 24754 //
     /* 1951680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1951683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1951691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1951694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1951697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1951700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951726 */     // MIs[0] policy
     /* 1951726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1951739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951760 */     // GIR_Coverage, 24754,
     /* 1951760 */     GIR_EraseRootFromParent_Done,
     /* 1951761 */   // Label 26168: @1951761
     /* 1951761 */   GIM_Try, /*On fail goto*//*Label 26169*/ GIMT_Encode4(1951847), // Rule ID 24755 //
     /* 1951766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1951769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1951777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1951780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1951783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1951786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1951789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1951796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1951808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951812 */     // MIs[0] policy
     /* 1951812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951822 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E64_MASK),
     /* 1951825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951846 */     // GIR_Coverage, 24755,
     /* 1951846 */     GIR_EraseRootFromParent_Done,
     /* 1951847 */   // Label 26169: @1951847
     /* 1951847 */   GIM_Try, /*On fail goto*//*Label 26170*/ GIMT_Encode4(1951933), // Rule ID 24758 //
     /* 1951852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1951855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1951863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1951866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1951869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1951872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1951878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951898 */     // MIs[0] policy
     /* 1951898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951908 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1951908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1951911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1951915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1951917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1951919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1951921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1951926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1951929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1951931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1951932 */     // GIR_Coverage, 24758,
     /* 1951932 */     GIR_EraseRootFromParent_Done,
     /* 1951933 */   // Label 26170: @1951933
     /* 1951933 */   GIM_Try, /*On fail goto*//*Label 26171*/ GIMT_Encode4(1952019), // Rule ID 24759 //
     /* 1951938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1951941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1951946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1951949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1951952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1951955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1951958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1951961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1951964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1951968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1951980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1951984 */     // MIs[0] policy
     /* 1951984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1951987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1951994 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1951994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E64_MASK),
     /* 1951997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1951999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952018 */     // GIR_Coverage, 24759,
     /* 1952018 */     GIR_EraseRootFromParent_Done,
     /* 1952019 */   // Label 26171: @1952019
     /* 1952019 */   GIM_Try, /*On fail goto*//*Label 26172*/ GIMT_Encode4(1952105), // Rule ID 24762 //
     /* 1952024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1952027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1952035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1952038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1952041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1952044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952070 */     // MIs[0] policy
     /* 1952070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952080 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1952083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952101 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952103 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952104 */     // GIR_Coverage, 24762,
     /* 1952104 */     GIR_EraseRootFromParent_Done,
     /* 1952105 */   // Label 26172: @1952105
     /* 1952105 */   GIM_Try, /*On fail goto*//*Label 26173*/ GIMT_Encode4(1952191), // Rule ID 24763 //
     /* 1952110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1952113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1952118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1952121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1952124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1952127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1952130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952133 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1952140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1952152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952156 */     // MIs[0] policy
     /* 1952156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952166 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E64_MASK),
     /* 1952169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952187 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952189 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952190 */     // GIR_Coverage, 24763,
     /* 1952190 */     GIR_EraseRootFromParent_Done,
     /* 1952191 */   // Label 26173: @1952191
     /* 1952191 */   GIM_Try, /*On fail goto*//*Label 26174*/ GIMT_Encode4(1952277), // Rule ID 24766 //
     /* 1952196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1952199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1952207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1952210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1952213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952219 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952242 */     // MIs[0] policy
     /* 1952242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952252 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1952255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952273 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952275 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952276 */     // GIR_Coverage, 24766,
     /* 1952276 */     GIR_EraseRootFromParent_Done,
     /* 1952277 */   // Label 26174: @1952277
     /* 1952277 */   GIM_Try, /*On fail goto*//*Label 26175*/ GIMT_Encode4(1952363), // Rule ID 24767 //
     /* 1952282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1952285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1952293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1952296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1952299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952305 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952328 */     // MIs[0] policy
     /* 1952328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952338 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1952341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952359 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952361 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952362 */     // GIR_Coverage, 24767,
     /* 1952362 */     GIR_EraseRootFromParent_Done,
     /* 1952363 */   // Label 26175: @1952363
     /* 1952363 */   GIM_Try, /*On fail goto*//*Label 26176*/ GIMT_Encode4(1952449), // Rule ID 24770 //
     /* 1952368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1952371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1952379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1952382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1952385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952391 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952414 */     // MIs[0] policy
     /* 1952414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952424 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1952427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952445 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952447 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952448 */     // GIR_Coverage, 24770,
     /* 1952448 */     GIR_EraseRootFromParent_Done,
     /* 1952449 */   // Label 26176: @1952449
     /* 1952449 */   GIM_Try, /*On fail goto*//*Label 26177*/ GIMT_Encode4(1952535), // Rule ID 24771 //
     /* 1952454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1952457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1952465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1952468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1952471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1952477 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952500 */     // MIs[0] policy
     /* 1952500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952510 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1952513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952531 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952533 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952534 */     // GIR_Coverage, 24771,
     /* 1952534 */     GIR_EraseRootFromParent_Done,
     /* 1952535 */   // Label 26177: @1952535
     /* 1952535 */   GIM_Try, /*On fail goto*//*Label 26178*/ GIMT_Encode4(1952621), // Rule ID 24774 //
     /* 1952540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1952543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1952551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1952554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1952557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952586 */     // MIs[0] policy
     /* 1952586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1952599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952617 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952620 */     // GIR_Coverage, 24774,
     /* 1952620 */     GIR_EraseRootFromParent_Done,
     /* 1952621 */   // Label 26178: @1952621
     /* 1952621 */   GIM_Try, /*On fail goto*//*Label 26179*/ GIMT_Encode4(1952707), // Rule ID 24775 //
     /* 1952626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1952629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1952637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1952640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1952643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1952649 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1952656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1952664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952672 */     // MIs[0] policy
     /* 1952672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952682 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1952685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1952703 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952705 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952706 */     // GIR_Coverage, 24775,
     /* 1952706 */     GIR_EraseRootFromParent_Done,
     /* 1952707 */   // Label 26179: @1952707
     /* 1952707 */   GIM_Try, /*On fail goto*//*Label 26180*/ GIMT_Encode4(1952793), // Rule ID 24778 //
     /* 1952712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1952715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952735 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952758 */     // MIs[0] policy
     /* 1952758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952768 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952789 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952791 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952792 */     // GIR_Coverage, 24778,
     /* 1952792 */     GIR_EraseRootFromParent_Done,
     /* 1952793 */   // Label 26180: @1952793
     /* 1952793 */   GIM_Try, /*On fail goto*//*Label 26181*/ GIMT_Encode4(1952879), // Rule ID 24779 //
     /* 1952798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1952801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1952809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1952812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1952815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1952821 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1952828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1952836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952844 */     // MIs[0] policy
     /* 1952844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952854 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1952854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1952857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952875 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952877 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952878 */     // GIR_Coverage, 24779,
     /* 1952878 */     GIR_EraseRootFromParent_Done,
     /* 1952879 */   // Label 26181: @1952879
     /* 1952879 */   GIM_Try, /*On fail goto*//*Label 26182*/ GIMT_Encode4(1952965), // Rule ID 24782 //
     /* 1952884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1952887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1952904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952907 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1952910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1952914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1952922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1952926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1952930 */     // MIs[0] policy
     /* 1952930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1952933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1952940 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1952940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1952943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1952945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1952947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1952949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1952951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1952953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1952958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1952961 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1952963 */     GIR_RootConstrainSelectedInstOperands,
     /* 1952964 */     // GIR_Coverage, 24782,
     /* 1952964 */     GIR_EraseRootFromParent_Done,
     /* 1952965 */   // Label 26182: @1952965
     /* 1952965 */   GIM_Try, /*On fail goto*//*Label 26183*/ GIMT_Encode4(1953051), // Rule ID 24783 //
     /* 1952970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1952973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1952978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1952981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1952984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1952987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1952990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1952993 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1952996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953016 */     // MIs[0] policy
     /* 1953016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953026 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953047 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953049 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953050 */     // GIR_Coverage, 24783,
     /* 1953050 */     GIR_EraseRootFromParent_Done,
     /* 1953051 */   // Label 26183: @1953051
     /* 1953051 */   GIM_Try, /*On fail goto*//*Label 26184*/ GIMT_Encode4(1953137), // Rule ID 24786 //
     /* 1953056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1953059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953079 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953102 */     // MIs[0] policy
     /* 1953102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953112 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953133 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953135 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953136 */     // GIR_Coverage, 24786,
     /* 1953136 */     GIR_EraseRootFromParent_Done,
     /* 1953137 */   // Label 26184: @1953137
     /* 1953137 */   GIM_Try, /*On fail goto*//*Label 26185*/ GIMT_Encode4(1953223), // Rule ID 24787 //
     /* 1953142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1953145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1953153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1953156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1953159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1953165 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953188 */     // MIs[0] policy
     /* 1953188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953198 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1953219 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953222 */     // GIR_Coverage, 24787,
     /* 1953222 */     GIR_EraseRootFromParent_Done,
     /* 1953223 */   // Label 26185: @1953223
     /* 1953223 */   GIM_Try, /*On fail goto*//*Label 26186*/ GIMT_Encode4(1953309), // Rule ID 24790 //
     /* 1953228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1953231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953251 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953274 */     // MIs[0] policy
     /* 1953274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953284 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953305 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953307 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953308 */     // GIR_Coverage, 24790,
     /* 1953308 */     GIR_EraseRootFromParent_Done,
     /* 1953309 */   // Label 26186: @1953309
     /* 1953309 */   GIM_Try, /*On fail goto*//*Label 26187*/ GIMT_Encode4(1953395), // Rule ID 24791 //
     /* 1953314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1953317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1953325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1953328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1953331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953337 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1953344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1953352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953360 */     // MIs[0] policy
     /* 1953360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953370 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1953373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953391 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953393 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953394 */     // GIR_Coverage, 24791,
     /* 1953394 */     GIR_EraseRootFromParent_Done,
     /* 1953395 */   // Label 26187: @1953395
     /* 1953395 */   GIM_Try, /*On fail goto*//*Label 26188*/ GIMT_Encode4(1953481), // Rule ID 24794 //
     /* 1953400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1953403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953423 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953446 */     // MIs[0] policy
     /* 1953446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953456 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953477 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953479 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953480 */     // GIR_Coverage, 24794,
     /* 1953480 */     GIR_EraseRootFromParent_Done,
     /* 1953481 */   // Label 26188: @1953481
     /* 1953481 */   GIM_Try, /*On fail goto*//*Label 26189*/ GIMT_Encode4(1953567), // Rule ID 24795 //
     /* 1953486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1953489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1953497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1953500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1953503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1953509 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1953516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1953524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953532 */     // MIs[0] policy
     /* 1953532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953542 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1953545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953563 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953565 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953566 */     // GIR_Coverage, 24795,
     /* 1953566 */     GIR_EraseRootFromParent_Done,
     /* 1953567 */   // Label 26189: @1953567
     /* 1953567 */   GIM_Try, /*On fail goto*//*Label 26190*/ GIMT_Encode4(1953653), // Rule ID 24798 //
     /* 1953572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1953575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1953592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953595 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953618 */     // MIs[0] policy
     /* 1953618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953628 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953649 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953651 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953652 */     // GIR_Coverage, 24798,
     /* 1953652 */     GIR_EraseRootFromParent_Done,
     /* 1953653 */   // Label 26190: @1953653
     /* 1953653 */   GIM_Try, /*On fail goto*//*Label 26191*/ GIMT_Encode4(1953739), // Rule ID 24799 //
     /* 1953658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1953661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1953666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1953669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1953672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1953675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1953678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1953681 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1953688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1953696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1953700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953704 */     // MIs[0] policy
     /* 1953704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953714 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1953717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953719 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1953735 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953737 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953738 */     // GIR_Coverage, 24799,
     /* 1953738 */     GIR_EraseRootFromParent_Done,
     /* 1953739 */   // Label 26191: @1953739
     /* 1953739 */   GIM_Try, /*On fail goto*//*Label 26192*/ GIMT_Encode4(1953825), // Rule ID 24838 //
     /* 1953744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1953747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1953755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1953758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1953761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953767 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953790 */     // MIs[0] policy
     /* 1953790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953800 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1953803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953821 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953824 */     // GIR_Coverage, 24838,
     /* 1953824 */     GIR_EraseRootFromParent_Done,
     /* 1953825 */   // Label 26192: @1953825
     /* 1953825 */   GIM_Try, /*On fail goto*//*Label 26193*/ GIMT_Encode4(1953911), // Rule ID 24839 //
     /* 1953830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1953833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1953841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1953844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1953847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1953850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1953853 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1953856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953876 */     // MIs[0] policy
     /* 1953876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953886 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1953886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF4_E16_MASK),
     /* 1953889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953907 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953909 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953910 */     // GIR_Coverage, 24839,
     /* 1953910 */     GIR_EraseRootFromParent_Done,
     /* 1953911 */   // Label 26193: @1953911
     /* 1953911 */   GIM_Try, /*On fail goto*//*Label 26194*/ GIMT_Encode4(1953997), // Rule ID 24842 //
     /* 1953916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1953919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1953924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1953927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1953930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1953933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1953936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1953939 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1953942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1953946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1953958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1953962 */     // MIs[0] policy
     /* 1953962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1953965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1953972 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1953972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1953975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1953977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1953979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1953981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1953983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1953985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1953990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1953993 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1953995 */     GIR_RootConstrainSelectedInstOperands,
     /* 1953996 */     // GIR_Coverage, 24842,
     /* 1953996 */     GIR_EraseRootFromParent_Done,
     /* 1953997 */   // Label 26194: @1953997
     /* 1953997 */   GIM_Try, /*On fail goto*//*Label 26195*/ GIMT_Encode4(1954083), // Rule ID 24843 //
     /* 1954002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1954022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954025 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954048 */     // MIs[0] policy
     /* 1954048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954058 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_MF2_E16_MASK),
     /* 1954061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954079 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954081 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954082 */     // GIR_Coverage, 24843,
     /* 1954082 */     GIR_EraseRootFromParent_Done,
     /* 1954083 */   // Label 26195: @1954083
     /* 1954083 */   GIM_Try, /*On fail goto*//*Label 26196*/ GIMT_Encode4(1954169), // Rule ID 24846 //
     /* 1954088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954111 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954134 */     // MIs[0] policy
     /* 1954134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954144 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1954147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954165 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954167 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954168 */     // GIR_Coverage, 24846,
     /* 1954168 */     GIR_EraseRootFromParent_Done,
     /* 1954169 */   // Label 26196: @1954169
     /* 1954169 */   GIM_Try, /*On fail goto*//*Label 26197*/ GIMT_Encode4(1954255), // Rule ID 24847 //
     /* 1954174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1954185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1954188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1954191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1954194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1954197 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954220 */     // MIs[0] policy
     /* 1954220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954230 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11451:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M1_E16_MASK),
     /* 1954233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954251 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954253 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954254 */     // GIR_Coverage, 24847,
     /* 1954254 */     GIR_EraseRootFromParent_Done,
     /* 1954255 */   // Label 26197: @1954255
     /* 1954255 */   GIM_Try, /*On fail goto*//*Label 26198*/ GIMT_Encode4(1954341), // Rule ID 24850 //
     /* 1954260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1954271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1954274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1954277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954283 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1954290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954306 */     // MIs[0] policy
     /* 1954306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954316 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1954319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954337 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954339 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954340 */     // GIR_Coverage, 24850,
     /* 1954340 */     GIR_EraseRootFromParent_Done,
     /* 1954341 */   // Label 26198: @1954341
     /* 1954341 */   GIM_Try, /*On fail goto*//*Label 26199*/ GIMT_Encode4(1954427), // Rule ID 24851 //
     /* 1954346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1954357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1954360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1954363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1954366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1954369 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1954376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1954388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954392 */     // MIs[0] policy
     /* 1954392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954402 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11451:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M2_E16_MASK),
     /* 1954405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954423 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954425 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954426 */     // GIR_Coverage, 24851,
     /* 1954426 */     GIR_EraseRootFromParent_Done,
     /* 1954427 */   // Label 26199: @1954427
     /* 1954427 */   GIM_Try, /*On fail goto*//*Label 26200*/ GIMT_Encode4(1954513), // Rule ID 24854 //
     /* 1954432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1954443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1954446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1954449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1954452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1954455 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954478 */     // MIs[0] policy
     /* 1954478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954488 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1954491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954509 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954511 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954512 */     // GIR_Coverage, 24854,
     /* 1954512 */     GIR_EraseRootFromParent_Done,
     /* 1954513 */   // Label 26200: @1954513
     /* 1954513 */   GIM_Try, /*On fail goto*//*Label 26201*/ GIMT_Encode4(1954599), // Rule ID 24855 //
     /* 1954518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1954529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1954532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1954535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1954538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1954541 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1954548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1954560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954564 */     // MIs[0] policy
     /* 1954564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954574 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11451:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M4_E16_MASK),
     /* 1954577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954595 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954597 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954598 */     // GIR_Coverage, 24855,
     /* 1954598 */     GIR_EraseRootFromParent_Done,
     /* 1954599 */   // Label 26201: @1954599
     /* 1954599 */   GIM_Try, /*On fail goto*//*Label 26202*/ GIMT_Encode4(1954685), // Rule ID 24858 //
     /* 1954604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1954615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1954618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1954621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1954624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1954627 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954650 */     // MIs[0] policy
     /* 1954650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954660 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1954663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954681 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954683 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954684 */     // GIR_Coverage, 24858,
     /* 1954684 */     GIR_EraseRootFromParent_Done,
     /* 1954685 */   // Label 26202: @1954685
     /* 1954685 */   GIM_Try, /*On fail goto*//*Label 26203*/ GIMT_Encode4(1954771), // Rule ID 24859 //
     /* 1954690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vv_mask),
     /* 1954698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1954701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1954704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1954707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1954710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1954713 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1954720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1954732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954736 */     // MIs[0] policy
     /* 1954736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954746 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11451:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VV_M8_E16_MASK),
     /* 1954749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954767 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954769 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954770 */     // GIR_Coverage, 24859,
     /* 1954770 */     GIR_EraseRootFromParent_Done,
     /* 1954771 */   // Label 26203: @1954771
     /* 1954771 */   GIM_Try, /*On fail goto*//*Label 26204*/ GIMT_Encode4(1954857), // Rule ID 24862 //
     /* 1954776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954799 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954822 */     // MIs[0] policy
     /* 1954822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954832 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1954832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1954835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954853 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954855 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954856 */     // GIR_Coverage, 24862,
     /* 1954856 */     GIR_EraseRootFromParent_Done,
     /* 1954857 */   // Label 26204: @1954857
     /* 1954857 */   GIM_Try, /*On fail goto*//*Label 26205*/ GIMT_Encode4(1954943), // Rule ID 24863 //
     /* 1954862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1954865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1954873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1954876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1954879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1954882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1954885 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1954888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954908 */     // MIs[0] policy
     /* 1954908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1954918 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1954918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF4_MASK),
     /* 1954921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1954923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1954925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1954927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1954929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1954931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1954936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1954939 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1954941 */     GIR_RootConstrainSelectedInstOperands,
     /* 1954942 */     // GIR_Coverage, 24863,
     /* 1954942 */     GIR_EraseRootFromParent_Done,
     /* 1954943 */   // Label 26205: @1954943
     /* 1954943 */   GIM_Try, /*On fail goto*//*Label 26206*/ GIMT_Encode4(1955029), // Rule ID 24866 //
     /* 1954948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1954951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1954956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1954959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1954962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1954965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1954968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1954971 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1954974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1954978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1954986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1954990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1954994 */     // MIs[0] policy
     /* 1954994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1954997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955004 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1955007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955025 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955027 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955028 */     // GIR_Coverage, 24866,
     /* 1955028 */     GIR_EraseRootFromParent_Done,
     /* 1955029 */   // Label 26206: @1955029
     /* 1955029 */   GIM_Try, /*On fail goto*//*Label 26207*/ GIMT_Encode4(1955115), // Rule ID 24867 //
     /* 1955034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1955037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1955045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1955048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1955051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1955057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955080 */     // MIs[0] policy
     /* 1955080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955090 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_MF2_MASK),
     /* 1955093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955111 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955113 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955114 */     // GIR_Coverage, 24867,
     /* 1955114 */     GIR_EraseRootFromParent_Done,
     /* 1955115 */   // Label 26207: @1955115
     /* 1955115 */   GIM_Try, /*On fail goto*//*Label 26208*/ GIMT_Encode4(1955201), // Rule ID 24870 //
     /* 1955120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1955123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955143 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955166 */     // MIs[0] policy
     /* 1955166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955176 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955197 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955199 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955200 */     // GIR_Coverage, 24870,
     /* 1955200 */     GIR_EraseRootFromParent_Done,
     /* 1955201 */   // Label 26208: @1955201
     /* 1955201 */   GIM_Try, /*On fail goto*//*Label 26209*/ GIMT_Encode4(1955287), // Rule ID 24871 //
     /* 1955206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1955209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1955217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1955220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1955223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1955229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955252 */     // MIs[0] policy
     /* 1955252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955262 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11453:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M1_MASK),
     /* 1955265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955283 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955285 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955286 */     // GIR_Coverage, 24871,
     /* 1955286 */     GIR_EraseRootFromParent_Done,
     /* 1955287 */   // Label 26209: @1955287
     /* 1955287 */   GIM_Try, /*On fail goto*//*Label 26210*/ GIMT_Encode4(1955373), // Rule ID 24874 //
     /* 1955292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1955295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955338 */     // MIs[0] policy
     /* 1955338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955348 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1955351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955369 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955371 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955372 */     // GIR_Coverage, 24874,
     /* 1955372 */     GIR_EraseRootFromParent_Done,
     /* 1955373 */   // Label 26210: @1955373
     /* 1955373 */   GIM_Try, /*On fail goto*//*Label 26211*/ GIMT_Encode4(1955459), // Rule ID 24875 //
     /* 1955378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1955381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1955389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1955392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1955395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1955401 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1955408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1955416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955424 */     // MIs[0] policy
     /* 1955424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955434 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11453:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M2_MASK),
     /* 1955437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955455 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955457 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955458 */     // GIR_Coverage, 24875,
     /* 1955458 */     GIR_EraseRootFromParent_Done,
     /* 1955459 */   // Label 26211: @1955459
     /* 1955459 */   GIM_Try, /*On fail goto*//*Label 26212*/ GIMT_Encode4(1955545), // Rule ID 24878 //
     /* 1955464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1955467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955510 */     // MIs[0] policy
     /* 1955510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955520 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1955523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955541 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955543 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955544 */     // GIR_Coverage, 24878,
     /* 1955544 */     GIR_EraseRootFromParent_Done,
     /* 1955545 */   // Label 26212: @1955545
     /* 1955545 */   GIM_Try, /*On fail goto*//*Label 26213*/ GIMT_Encode4(1955631), // Rule ID 24879 //
     /* 1955550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1955553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1955561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1955564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1955567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1955573 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1955580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1955588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955596 */     // MIs[0] policy
     /* 1955596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955606 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11453:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M4_MASK),
     /* 1955609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955627 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955629 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955630 */     // GIR_Coverage, 24879,
     /* 1955630 */     GIR_EraseRootFromParent_Done,
     /* 1955631 */   // Label 26213: @1955631
     /* 1955631 */   GIM_Try, /*On fail goto*//*Label 26214*/ GIMT_Encode4(1955717), // Rule ID 24882 //
     /* 1955636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 1955639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1955647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1955650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1955653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1955656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955659 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955682 */     // MIs[0] policy
     /* 1955682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955692 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1955695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955713 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955715 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955716 */     // GIR_Coverage, 24882,
     /* 1955716 */     GIR_EraseRootFromParent_Done,
     /* 1955717 */   // Label 26214: @1955717
     /* 1955717 */   GIM_Try, /*On fail goto*//*Label 26215*/ GIMT_Encode4(1955803), // Rule ID 24883 //
     /* 1955722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 1955725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgather_vx_mask),
     /* 1955730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1955733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1955736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1955739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1955742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1955745 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1955752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1955760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1955764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955768 */     // MIs[0] policy
     /* 1955768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955778 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11453:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHER_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHER_VX_M8_MASK),
     /* 1955781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955799 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955801 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955802 */     // GIR_Coverage, 24883,
     /* 1955802 */     GIR_EraseRootFromParent_Done,
     /* 1955803 */   // Label 26215: @1955803
     /* 1955803 */   GIM_Try, /*On fail goto*//*Label 26216*/ GIMT_Encode4(1955889), // Rule ID 24910 //
     /* 1955808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1955811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1955819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1955822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1955825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955831 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1955834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955854 */     // MIs[0] policy
     /* 1955854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955864 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1955864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1955867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955885 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955887 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955888 */     // GIR_Coverage, 24910,
     /* 1955888 */     GIR_EraseRootFromParent_Done,
     /* 1955889 */   // Label 26216: @1955889
     /* 1955889 */   GIM_Try, /*On fail goto*//*Label 26217*/ GIMT_Encode4(1955975), // Rule ID 24911 //
     /* 1955894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1955897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1955905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1955908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1955911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1955914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1955917 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1955920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1955924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1955936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1955940 */     // MIs[0] policy
     /* 1955940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1955943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1955950 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1955950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF4_E16_MF4_MASK),
     /* 1955953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1955955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1955957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1955959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1955961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1955963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1955968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1955971 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1955973 */     GIR_RootConstrainSelectedInstOperands,
     /* 1955974 */     // GIR_Coverage, 24911,
     /* 1955974 */     GIR_EraseRootFromParent_Done,
     /* 1955975 */   // Label 26217: @1955975
     /* 1955975 */   GIM_Try, /*On fail goto*//*Label 26218*/ GIMT_Encode4(1956061), // Rule ID 24914 //
     /* 1955980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1955983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1955988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1955991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1955994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1955997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956003 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956026 */     // MIs[0] policy
     /* 1956026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956036 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1956039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956057 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956059 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956060 */     // GIR_Coverage, 24914,
     /* 1956060 */     GIR_EraseRootFromParent_Done,
     /* 1956061 */   // Label 26218: @1956061
     /* 1956061 */   GIM_Try, /*On fail goto*//*Label 26219*/ GIMT_Encode4(1956147), // Rule ID 24915 //
     /* 1956066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1956069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1956077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1956080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1956083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956112 */     // MIs[0] policy
     /* 1956112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956122 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E16_MF2_MASK),
     /* 1956125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956143 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956145 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956146 */     // GIR_Coverage, 24915,
     /* 1956146 */     GIR_EraseRootFromParent_Done,
     /* 1956147 */   // Label 26219: @1956147
     /* 1956147 */   GIM_Try, /*On fail goto*//*Label 26220*/ GIMT_Encode4(1956233), // Rule ID 24918 //
     /* 1956152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1956155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1956163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1956166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1956169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1956172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956175 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956198 */     // MIs[0] policy
     /* 1956198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956208 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1956211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956229 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956231 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956232 */     // GIR_Coverage, 24918,
     /* 1956232 */     GIR_EraseRootFromParent_Done,
     /* 1956233 */   // Label 26220: @1956233
     /* 1956233 */   GIM_Try, /*On fail goto*//*Label 26221*/ GIMT_Encode4(1956319), // Rule ID 24919 //
     /* 1956238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1956241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1956249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1956252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1956255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1956258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956261 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956284 */     // MIs[0] policy
     /* 1956284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956294 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_MF2_E32_MF4_MASK),
     /* 1956297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956315 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956317 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956318 */     // GIR_Coverage, 24919,
     /* 1956318 */     GIR_EraseRootFromParent_Done,
     /* 1956319 */   // Label 26221: @1956319
     /* 1956319 */   GIM_Try, /*On fail goto*//*Label 26222*/ GIMT_Encode4(1956405), // Rule ID 24922 //
     /* 1956324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1956327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1956335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1956338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1956341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956347 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956370 */     // MIs[0] policy
     /* 1956370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956380 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1956383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956401 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956403 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956404 */     // GIR_Coverage, 24922,
     /* 1956404 */     GIR_EraseRootFromParent_Done,
     /* 1956405 */   // Label 26222: @1956405
     /* 1956405 */   GIM_Try, /*On fail goto*//*Label 26223*/ GIMT_Encode4(1956491), // Rule ID 24923 //
     /* 1956410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1956413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1956421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1956424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1956427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1956430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1956433 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956456 */     // MIs[0] policy
     /* 1956456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956466 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11455:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E16_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E16_M1_MASK),
     /* 1956469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956487 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956489 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956490 */     // GIR_Coverage, 24923,
     /* 1956490 */     GIR_EraseRootFromParent_Done,
     /* 1956491 */   // Label 26223: @1956491
     /* 1956491 */   GIM_Try, /*On fail goto*//*Label 26224*/ GIMT_Encode4(1956577), // Rule ID 24926 //
     /* 1956496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1956499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1956507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1956510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1956513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956542 */     // MIs[0] policy
     /* 1956542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1956555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956573 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956575 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956576 */     // GIR_Coverage, 24926,
     /* 1956576 */     GIR_EraseRootFromParent_Done,
     /* 1956577 */   // Label 26224: @1956577
     /* 1956577 */   GIM_Try, /*On fail goto*//*Label 26225*/ GIMT_Encode4(1956663), // Rule ID 24927 //
     /* 1956582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1956585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1956593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1956596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1956599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1956602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1956605 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956628 */     // MIs[0] policy
     /* 1956628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956638 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11455:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E32_MF2_MASK),
     /* 1956641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1956659 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956661 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956662 */     // GIR_Coverage, 24927,
     /* 1956662 */     GIR_EraseRootFromParent_Done,
     /* 1956663 */   // Label 26225: @1956663
     /* 1956663 */   GIM_Try, /*On fail goto*//*Label 26226*/ GIMT_Encode4(1956749), // Rule ID 24930 //
     /* 1956668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1956671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1956679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1956682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1956685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1956688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956691 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956714 */     // MIs[0] policy
     /* 1956714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956724 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1956727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956745 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956747 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956748 */     // GIR_Coverage, 24930,
     /* 1956748 */     GIR_EraseRootFromParent_Done,
     /* 1956749 */   // Label 26226: @1956749
     /* 1956749 */   GIM_Try, /*On fail goto*//*Label 26227*/ GIMT_Encode4(1956835), // Rule ID 24931 //
     /* 1956754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1956757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1956765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1956768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1956771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1956774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1956777 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1956784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1956796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956800 */     // MIs[0] policy
     /* 1956800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956810 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11455:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M1_E64_MF4_MASK),
     /* 1956813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1956831 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956833 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956834 */     // GIR_Coverage, 24931,
     /* 1956834 */     GIR_EraseRootFromParent_Done,
     /* 1956835 */   // Label 26227: @1956835
     /* 1956835 */   GIM_Try, /*On fail goto*//*Label 26228*/ GIMT_Encode4(1956921), // Rule ID 24934 //
     /* 1956840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1956843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956863 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1956866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956886 */     // MIs[0] policy
     /* 1956886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956896 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1956896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956901 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1956914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1956917 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1956919 */     GIR_RootConstrainSelectedInstOperands,
     /* 1956920 */     // GIR_Coverage, 24934,
     /* 1956920 */     GIR_EraseRootFromParent_Done,
     /* 1956921 */   // Label 26228: @1956921
     /* 1956921 */   GIM_Try, /*On fail goto*//*Label 26229*/ GIMT_Encode4(1957007), // Rule ID 24935 //
     /* 1956926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1956929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1956934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1956937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1956940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1956943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1956946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1956949 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1956952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1956956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1956968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1956972 */     // MIs[0] policy
     /* 1956972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1956975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1956982 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E16_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1956982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E16_M2_MASK),
     /* 1956985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1956987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1956989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1956991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1956993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1956995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957003 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957005 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957006 */     // GIR_Coverage, 24935,
     /* 1957006 */     GIR_EraseRootFromParent_Done,
     /* 1957007 */   // Label 26229: @1957007
     /* 1957007 */   GIM_Try, /*On fail goto*//*Label 26230*/ GIMT_Encode4(1957093), // Rule ID 24938 //
     /* 1957012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1957015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1957023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1957026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1957029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957035 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957058 */     // MIs[0] policy
     /* 1957058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957068 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1957071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957089 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957091 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957092 */     // GIR_Coverage, 24938,
     /* 1957092 */     GIR_EraseRootFromParent_Done,
     /* 1957093 */   // Label 26230: @1957093
     /* 1957093 */   GIM_Try, /*On fail goto*//*Label 26231*/ GIMT_Encode4(1957179), // Rule ID 24939 //
     /* 1957098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1957101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1957109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1957112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1957115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957121 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957144 */     // MIs[0] policy
     /* 1957144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957154 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E16_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E16_M4_MASK),
     /* 1957157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957175 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957177 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957178 */     // GIR_Coverage, 24939,
     /* 1957178 */     GIR_EraseRootFromParent_Done,
     /* 1957179 */   // Label 26231: @1957179
     /* 1957179 */   GIM_Try, /*On fail goto*//*Label 26232*/ GIMT_Encode4(1957265), // Rule ID 24942 //
     /* 1957184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 1957187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1957195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1957198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1957201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1957204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1957207 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957230 */     // MIs[0] policy
     /* 1957230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957240 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1957243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957261 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957264 */     // GIR_Coverage, 24942,
     /* 1957264 */     GIR_EraseRootFromParent_Done,
     /* 1957265 */   // Label 26232: @1957265
     /* 1957265 */   GIM_Try, /*On fail goto*//*Label 26233*/ GIMT_Encode4(1957351), // Rule ID 24943 //
     /* 1957270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 1957273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1957281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1957284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1957287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1957290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1957293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957316 */     // MIs[0] policy
     /* 1957316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957326 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E16_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E16_M8_MASK),
     /* 1957329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1957347 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957349 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957350 */     // GIR_Coverage, 24943,
     /* 1957350 */     GIR_EraseRootFromParent_Done,
     /* 1957351 */   // Label 26233: @1957351
     /* 1957351 */   GIM_Try, /*On fail goto*//*Label 26234*/ GIMT_Encode4(1957437), // Rule ID 24946 //
     /* 1957356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1957359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1957367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1957370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1957373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957379 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957402 */     // MIs[0] policy
     /* 1957402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957412 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1957415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957433 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957435 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957436 */     // GIR_Coverage, 24946,
     /* 1957436 */     GIR_EraseRootFromParent_Done,
     /* 1957437 */   // Label 26234: @1957437
     /* 1957437 */   GIM_Try, /*On fail goto*//*Label 26235*/ GIMT_Encode4(1957523), // Rule ID 24947 //
     /* 1957442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1957445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1957453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1957456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1957459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1957462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1957465 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957488 */     // MIs[0] policy
     /* 1957488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957498 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E32_M1_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E32_M1_MASK),
     /* 1957501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957519 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957521 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957522 */     // GIR_Coverage, 24947,
     /* 1957522 */     GIR_EraseRootFromParent_Done,
     /* 1957523 */   // Label 26235: @1957523
     /* 1957523 */   GIM_Try, /*On fail goto*//*Label 26236*/ GIMT_Encode4(1957609), // Rule ID 24950 //
     /* 1957528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1957531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1957539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1957542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1957545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957551 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957574 */     // MIs[0] policy
     /* 1957574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957584 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1957587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957605 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957607 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957608 */     // GIR_Coverage, 24950,
     /* 1957608 */     GIR_EraseRootFromParent_Done,
     /* 1957609 */   // Label 26236: @1957609
     /* 1957609 */   GIM_Try, /*On fail goto*//*Label 26237*/ GIMT_Encode4(1957695), // Rule ID 24951 //
     /* 1957614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1957617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1957625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1957628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1957631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1957634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1957637 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1957644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957660 */     // MIs[0] policy
     /* 1957660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957670 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E32_M2_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E32_M2_MASK),
     /* 1957673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957691 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957693 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957694 */     // GIR_Coverage, 24951,
     /* 1957694 */     GIR_EraseRootFromParent_Done,
     /* 1957695 */   // Label 26237: @1957695
     /* 1957695 */   GIM_Try, /*On fail goto*//*Label 26238*/ GIMT_Encode4(1957781), // Rule ID 24954 //
     /* 1957700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 1957703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957723 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957746 */     // MIs[0] policy
     /* 1957746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957756 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957777 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957779 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957780 */     // GIR_Coverage, 24954,
     /* 1957780 */     GIR_EraseRootFromParent_Done,
     /* 1957781 */   // Label 26238: @1957781
     /* 1957781 */   GIM_Try, /*On fail goto*//*Label 26239*/ GIMT_Encode4(1957867), // Rule ID 24955 //
     /* 1957786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 1957789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1957797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1957800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1957803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1957806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1957809 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1957816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1957824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1957828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957832 */     // MIs[0] policy
     /* 1957832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957842 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E32_M4_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1957842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E32_M4_MASK),
     /* 1957845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1957863 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957866 */     // GIR_Coverage, 24955,
     /* 1957866 */     GIR_EraseRootFromParent_Done,
     /* 1957867 */   // Label 26239: @1957867
     /* 1957867 */   GIM_Try, /*On fail goto*//*Label 26240*/ GIMT_Encode4(1957953), // Rule ID 24958 //
     /* 1957872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1957875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957895 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1957898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1957914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1957918 */     // MIs[0] policy
     /* 1957918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1957921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1957928 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1957928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1957931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1957933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1957935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1957937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1957939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1957941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1957946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1957949 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1957951 */     GIR_RootConstrainSelectedInstOperands,
     /* 1957952 */     // GIR_Coverage, 24958,
     /* 1957952 */     GIR_EraseRootFromParent_Done,
     /* 1957953 */   // Label 26240: @1957953
     /* 1957953 */   GIM_Try, /*On fail goto*//*Label 26241*/ GIMT_Encode4(1958039), // Rule ID 24959 //
     /* 1957958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1957961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1957966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1957969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1957972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1957975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1957978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1957981 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1957984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1957988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1957996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958004 */     // MIs[0] policy
     /* 1958004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958014 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11455:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M2_E64_MF2_MASK),
     /* 1958017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958035 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958037 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958038 */     // GIR_Coverage, 24959,
     /* 1958038 */     GIR_EraseRootFromParent_Done,
     /* 1958039 */   // Label 26241: @1958039
     /* 1958039 */   GIM_Try, /*On fail goto*//*Label 26242*/ GIMT_Encode4(1958125), // Rule ID 24962 //
     /* 1958044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1958047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1958055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1958058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1958061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958067 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958090 */     // MIs[0] policy
     /* 1958090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958100 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1958103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958121 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958123 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958124 */     // GIR_Coverage, 24962,
     /* 1958124 */     GIR_EraseRootFromParent_Done,
     /* 1958125 */   // Label 26242: @1958125
     /* 1958125 */   GIM_Try, /*On fail goto*//*Label 26243*/ GIMT_Encode4(1958211), // Rule ID 24963 //
     /* 1958130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1958133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1958141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1958144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1958147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1958150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958153 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1958160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1958168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958176 */     // MIs[0] policy
     /* 1958176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958186 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11455:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M4_E64_M1_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M4_E64_M1_MASK),
     /* 1958189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958207 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958209 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958210 */     // GIR_Coverage, 24963,
     /* 1958210 */     GIR_EraseRootFromParent_Done,
     /* 1958211 */   // Label 26243: @1958211
     /* 1958211 */   GIM_Try, /*On fail goto*//*Label 26244*/ GIMT_Encode4(1958297), // Rule ID 24966 //
     /* 1958216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 1958219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1958227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1958230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1958233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958239 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958262 */     // MIs[0] policy
     /* 1958262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958272 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1958275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958293 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958295 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958296 */     // GIR_Coverage, 24966,
     /* 1958296 */     GIR_EraseRootFromParent_Done,
     /* 1958297 */   // Label 26244: @1958297
     /* 1958297 */   GIM_Try, /*On fail goto*//*Label 26245*/ GIMT_Encode4(1958383), // Rule ID 24967 //
     /* 1958302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 1958305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrgatherei16_vv_mask),
     /* 1958310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1958313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1958316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1958319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1958322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958325 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1958332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1958340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958348 */     // MIs[0] policy
     /* 1958348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958358 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11455:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVRGATHEREI16_VV_M8_E64_M2_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVRGATHEREI16_VV_M8_E64_M2_MASK),
     /* 1958361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1958379 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958381 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958382 */     // GIR_Coverage, 24967,
     /* 1958382 */     GIR_EraseRootFromParent_Done,
     /* 1958383 */   // Label 26245: @1958383
     /* 1958383 */   GIM_Try, /*On fail goto*//*Label 26246*/ GIMT_Encode4(1958469), // Rule ID 60846 //
     /* 1958388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1958391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1958399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1958402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1958405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1958408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958411 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958434 */     // MIs[0] policy
     /* 1958434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958444 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1958447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958449 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958465 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958468 */     // GIR_Coverage, 60846,
     /* 1958468 */     GIR_EraseRootFromParent_Done,
     /* 1958469 */   // Label 26246: @1958469
     /* 1958469 */   GIM_Try, /*On fail goto*//*Label 26247*/ GIMT_Encode4(1958555), // Rule ID 60847 //
     /* 1958474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1958477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1958485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1958488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1958491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1958494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1958497 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958520 */     // MIs[0] policy
     /* 1958520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958530 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8_MASK),
     /* 1958533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958551 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958553 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958554 */     // GIR_Coverage, 60847,
     /* 1958554 */     GIR_EraseRootFromParent_Done,
     /* 1958555 */   // Label 26247: @1958555
     /* 1958555 */   GIM_Try, /*On fail goto*//*Label 26248*/ GIMT_Encode4(1958641), // Rule ID 60850 //
     /* 1958560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1958563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1958577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1958580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958583 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958606 */     // MIs[0] policy
     /* 1958606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958616 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1958619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958637 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958639 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958640 */     // GIR_Coverage, 60850,
     /* 1958640 */     GIR_EraseRootFromParent_Done,
     /* 1958641 */   // Label 26248: @1958641
     /* 1958641 */   GIM_Try, /*On fail goto*//*Label 26249*/ GIMT_Encode4(1958727), // Rule ID 60851 //
     /* 1958646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1958649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1958657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1958660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1958663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1958666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1958669 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958692 */     // MIs[0] policy
     /* 1958692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958702 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1958705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958723 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958725 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958726 */     // GIR_Coverage, 60851,
     /* 1958726 */     GIR_EraseRootFromParent_Done,
     /* 1958727 */   // Label 26249: @1958727
     /* 1958727 */   GIM_Try, /*On fail goto*//*Label 26250*/ GIMT_Encode4(1958813), // Rule ID 60854 //
     /* 1958732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1958735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1958749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1958752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958755 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958778 */     // MIs[0] policy
     /* 1958778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958788 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1958791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958809 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958811 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958812 */     // GIR_Coverage, 60854,
     /* 1958812 */     GIR_EraseRootFromParent_Done,
     /* 1958813 */   // Label 26250: @1958813
     /* 1958813 */   GIM_Try, /*On fail goto*//*Label 26251*/ GIMT_Encode4(1958899), // Rule ID 60855 //
     /* 1958818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1958821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1958829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1958832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1958835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1958838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1958841 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1958844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1958848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958864 */     // MIs[0] policy
     /* 1958864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958874 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1958874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1958877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958895 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958897 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958898 */     // GIR_Coverage, 60855,
     /* 1958898 */     GIR_EraseRootFromParent_Done,
     /* 1958899 */   // Label 26251: @1958899
     /* 1958899 */   GIM_Try, /*On fail goto*//*Label 26252*/ GIMT_Encode4(1958985), // Rule ID 60858 //
     /* 1958904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1958907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1958915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1958918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1958921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1958924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1958927 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1958930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1958934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1958938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1958946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1958950 */     // MIs[0] policy
     /* 1958950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1958953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1958960 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1958960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1958963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1958965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1958967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1958969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1958971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1958973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1958978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1958981 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1958983 */     GIR_RootConstrainSelectedInstOperands,
     /* 1958984 */     // GIR_Coverage, 60858,
     /* 1958984 */     GIR_EraseRootFromParent_Done,
     /* 1958985 */   // Label 26252: @1958985
     /* 1958985 */   GIM_Try, /*On fail goto*//*Label 26253*/ GIMT_Encode4(1959071), // Rule ID 60859 //
     /* 1958990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1958993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1958998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1959001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1959004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1959007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1959010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959013 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959036 */     // MIs[0] policy
     /* 1959036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1959049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959067 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959069 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959070 */     // GIR_Coverage, 60859,
     /* 1959070 */     GIR_EraseRootFromParent_Done,
     /* 1959071 */   // Label 26253: @1959071
     /* 1959071 */   GIM_Try, /*On fail goto*//*Label 26254*/ GIMT_Encode4(1959157), // Rule ID 60862 //
     /* 1959076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1959096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959099 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959122 */     // MIs[0] policy
     /* 1959122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959132 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1959135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959153 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959155 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959156 */     // GIR_Coverage, 60862,
     /* 1959156 */     GIR_EraseRootFromParent_Done,
     /* 1959157 */   // Label 26254: @1959157
     /* 1959157 */   GIM_Try, /*On fail goto*//*Label 26255*/ GIMT_Encode4(1959243), // Rule ID 60863 //
     /* 1959162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1959165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1959173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1959176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1959179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1959182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1959185 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959208 */     // MIs[0] policy
     /* 1959208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959218 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1959221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959239 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959241 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959242 */     // GIR_Coverage, 60863,
     /* 1959242 */     GIR_EraseRootFromParent_Done,
     /* 1959243 */   // Label 26255: @1959243
     /* 1959243 */   GIM_Try, /*On fail goto*//*Label 26256*/ GIMT_Encode4(1959329), // Rule ID 60866 //
     /* 1959248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1959268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959294 */     // MIs[0] policy
     /* 1959294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959304 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1959307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959325 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959327 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959328 */     // GIR_Coverage, 60866,
     /* 1959328 */     GIR_EraseRootFromParent_Done,
     /* 1959329 */   // Label 26256: @1959329
     /* 1959329 */   GIM_Try, /*On fail goto*//*Label 26257*/ GIMT_Encode4(1959415), // Rule ID 60867 //
     /* 1959334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1959337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1959345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1959348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1959351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1959354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1959357 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1959364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1959368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959380 */     // MIs[0] policy
     /* 1959380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959390 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1959393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1959411 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959413 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959414 */     // GIR_Coverage, 60867,
     /* 1959414 */     GIR_EraseRootFromParent_Done,
     /* 1959415 */   // Label 26257: @1959415
     /* 1959415 */   GIM_Try, /*On fail goto*//*Label 26258*/ GIMT_Encode4(1959501), // Rule ID 60870 //
     /* 1959420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1959431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1959434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1959440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959466 */     // MIs[0] policy
     /* 1959466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1959479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959497 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959499 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959500 */     // GIR_Coverage, 60870,
     /* 1959500 */     GIR_EraseRootFromParent_Done,
     /* 1959501 */   // Label 26258: @1959501
     /* 1959501 */   GIM_Try, /*On fail goto*//*Label 26259*/ GIMT_Encode4(1959587), // Rule ID 60871 //
     /* 1959506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1959509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1959517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1959520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1959523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1959526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1959529 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959552 */     // MIs[0] policy
     /* 1959552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959562 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4_MASK),
     /* 1959565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959583 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959585 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959586 */     // GIR_Coverage, 60871,
     /* 1959586 */     GIR_EraseRootFromParent_Done,
     /* 1959587 */   // Label 26259: @1959587
     /* 1959587 */   GIM_Try, /*On fail goto*//*Label 26260*/ GIMT_Encode4(1959673), // Rule ID 60874 //
     /* 1959592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1959603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1959606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1959609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1959612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959638 */     // MIs[0] policy
     /* 1959638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959648 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1959651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959669 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959671 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959672 */     // GIR_Coverage, 60874,
     /* 1959672 */     GIR_EraseRootFromParent_Done,
     /* 1959673 */   // Label 26260: @1959673
     /* 1959673 */   GIM_Try, /*On fail goto*//*Label 26261*/ GIMT_Encode4(1959759), // Rule ID 60875 //
     /* 1959678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1959681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1959689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1959692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1959695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1959698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1959701 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1959708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959724 */     // MIs[0] policy
     /* 1959724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959734 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1959737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959755 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959757 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959758 */     // GIR_Coverage, 60875,
     /* 1959758 */     GIR_EraseRootFromParent_Done,
     /* 1959759 */   // Label 26261: @1959759
     /* 1959759 */   GIM_Try, /*On fail goto*//*Label 26262*/ GIMT_Encode4(1959845), // Rule ID 60878 //
     /* 1959764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1959781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1959784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959787 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959810 */     // MIs[0] policy
     /* 1959810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959820 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1959823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959841 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959843 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959844 */     // GIR_Coverage, 60878,
     /* 1959844 */     GIR_EraseRootFromParent_Done,
     /* 1959845 */   // Label 26262: @1959845
     /* 1959845 */   GIM_Try, /*On fail goto*//*Label 26263*/ GIMT_Encode4(1959931), // Rule ID 60879 //
     /* 1959850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1959853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1959861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1959864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1959867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1959870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1959873 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1959876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1959880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1959892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959896 */     // MIs[0] policy
     /* 1959896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959906 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1959906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1959909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1959915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1959917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1959919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1959924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1959927 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1959929 */     GIR_RootConstrainSelectedInstOperands,
     /* 1959930 */     // GIR_Coverage, 60879,
     /* 1959930 */     GIR_EraseRootFromParent_Done,
     /* 1959931 */   // Label 26263: @1959931
     /* 1959931 */   GIM_Try, /*On fail goto*//*Label 26264*/ GIMT_Encode4(1960017), // Rule ID 60882 //
     /* 1959936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1959939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1959944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1959947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1959950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1959953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1959956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1959959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1959962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1959966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1959970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1959978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1959982 */     // MIs[0] policy
     /* 1959982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1959985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1959992 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1959992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1959995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1959997 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1959999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960013 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960015 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960016 */     // GIR_Coverage, 60882,
     /* 1960016 */     GIR_EraseRootFromParent_Done,
     /* 1960017 */   // Label 26264: @1960017
     /* 1960017 */   GIM_Try, /*On fail goto*//*Label 26265*/ GIMT_Encode4(1960103), // Rule ID 60883 //
     /* 1960022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1960033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1960036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1960039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1960042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960045 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960068 */     // MIs[0] policy
     /* 1960068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960078 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1960081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960083 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960099 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960101 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960102 */     // GIR_Coverage, 60883,
     /* 1960102 */     GIR_EraseRootFromParent_Done,
     /* 1960103 */   // Label 26265: @1960103
     /* 1960103 */   GIM_Try, /*On fail goto*//*Label 26266*/ GIMT_Encode4(1960189), // Rule ID 60886 //
     /* 1960108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1960125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1960128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960131 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960154 */     // MIs[0] policy
     /* 1960154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960164 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1960167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960185 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960187 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960188 */     // GIR_Coverage, 60886,
     /* 1960188 */     GIR_EraseRootFromParent_Done,
     /* 1960189 */   // Label 26266: @1960189
     /* 1960189 */   GIM_Try, /*On fail goto*//*Label 26267*/ GIMT_Encode4(1960275), // Rule ID 60887 //
     /* 1960194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1960205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1960208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1960211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1960214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1960217 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960240 */     // MIs[0] policy
     /* 1960240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960250 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1960253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1960271 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960273 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960274 */     // GIR_Coverage, 60887,
     /* 1960274 */     GIR_EraseRootFromParent_Done,
     /* 1960275 */   // Label 26267: @1960275
     /* 1960275 */   GIM_Try, /*On fail goto*//*Label 26268*/ GIMT_Encode4(1960361), // Rule ID 60890 //
     /* 1960280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1960300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960326 */     // MIs[0] policy
     /* 1960326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960336 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1960339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960357 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960359 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960360 */     // GIR_Coverage, 60890,
     /* 1960360 */     GIR_EraseRootFromParent_Done,
     /* 1960361 */   // Label 26268: @1960361
     /* 1960361 */   GIM_Try, /*On fail goto*//*Label 26269*/ GIMT_Encode4(1960447), // Rule ID 60891 //
     /* 1960366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1960377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1960380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1960383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1960386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960389 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960412 */     // MIs[0] policy
     /* 1960412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960422 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2_MASK),
     /* 1960425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960443 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960445 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960446 */     // GIR_Coverage, 60891,
     /* 1960446 */     GIR_EraseRootFromParent_Done,
     /* 1960447 */   // Label 26269: @1960447
     /* 1960447 */   GIM_Try, /*On fail goto*//*Label 26270*/ GIMT_Encode4(1960533), // Rule ID 60894 //
     /* 1960452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1960472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960475 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960498 */     // MIs[0] policy
     /* 1960498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1960511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960529 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960531 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960532 */     // GIR_Coverage, 60894,
     /* 1960532 */     GIR_EraseRootFromParent_Done,
     /* 1960533 */   // Label 26270: @1960533
     /* 1960533 */   GIM_Try, /*On fail goto*//*Label 26271*/ GIMT_Encode4(1960619), // Rule ID 60895 //
     /* 1960538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1960549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1960552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1960555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1960558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1960561 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1960568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1960580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960584 */     // MIs[0] policy
     /* 1960584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1_MASK),
     /* 1960597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960615 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960617 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960618 */     // GIR_Coverage, 60895,
     /* 1960618 */     GIR_EraseRootFromParent_Done,
     /* 1960619 */   // Label 26271: @1960619
     /* 1960619 */   GIM_Try, /*On fail goto*//*Label 26272*/ GIMT_Encode4(1960705), // Rule ID 60898 //
     /* 1960624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1960644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960647 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960670 */     // MIs[0] policy
     /* 1960670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960680 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1960683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960701 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960703 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960704 */     // GIR_Coverage, 60898,
     /* 1960704 */     GIR_EraseRootFromParent_Done,
     /* 1960705 */   // Label 26272: @1960705
     /* 1960705 */   GIM_Try, /*On fail goto*//*Label 26273*/ GIMT_Encode4(1960791), // Rule ID 60899 //
     /* 1960710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1960721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1960724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1960727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1960730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1960733 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1960740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1960752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960756 */     // MIs[0] policy
     /* 1960756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960766 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2_MASK),
     /* 1960769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960787 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960789 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960790 */     // GIR_Coverage, 60899,
     /* 1960790 */     GIR_EraseRootFromParent_Done,
     /* 1960791 */   // Label 26273: @1960791
     /* 1960791 */   GIM_Try, /*On fail goto*//*Label 26274*/ GIMT_Encode4(1960877), // Rule ID 60902 //
     /* 1960796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1960816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960819 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960842 */     // MIs[0] policy
     /* 1960842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960852 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1960852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1960855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960873 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960875 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960876 */     // GIR_Coverage, 60902,
     /* 1960876 */     GIR_EraseRootFromParent_Done,
     /* 1960877 */   // Label 26274: @1960877
     /* 1960877 */   GIM_Try, /*On fail goto*//*Label 26275*/ GIMT_Encode4(1960963), // Rule ID 60903 //
     /* 1960882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1960885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1960893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1960896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1960899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1960902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1960905 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1960908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1960912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1960916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1960924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1960928 */     // MIs[0] policy
     /* 1960928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1960931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1960938 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VV_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1960938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4_MASK),
     /* 1960941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1960943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1960945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1960947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1960949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1960951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1960956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1960959 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1960961 */     GIR_RootConstrainSelectedInstOperands,
     /* 1960962 */     // GIR_Coverage, 60903,
     /* 1960962 */     GIR_EraseRootFromParent_Done,
     /* 1960963 */   // Label 26275: @1960963
     /* 1960963 */   GIM_Try, /*On fail goto*//*Label 26276*/ GIMT_Encode4(1961049), // Rule ID 60906 //
     /* 1960968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1960971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1960976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1960979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1960982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1960985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1960988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1960991 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1960994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1960998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961014 */     // MIs[0] policy
     /* 1961014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961024 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1961027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961045 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961047 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961048 */     // GIR_Coverage, 60906,
     /* 1961048 */     GIR_EraseRootFromParent_Done,
     /* 1961049 */   // Label 26276: @1961049
     /* 1961049 */   GIM_Try, /*On fail goto*//*Label 26277*/ GIMT_Encode4(1961135), // Rule ID 60907 //
     /* 1961054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1961065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1961068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1961071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1961077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961100 */     // MIs[0] policy
     /* 1961100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961110 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF8_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF8_MASK),
     /* 1961113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961131 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961133 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961134 */     // GIR_Coverage, 60907,
     /* 1961134 */     GIR_EraseRootFromParent_Done,
     /* 1961135 */   // Label 26277: @1961135
     /* 1961135 */   GIM_Try, /*On fail goto*//*Label 26278*/ GIMT_Encode4(1961221), // Rule ID 60914 //
     /* 1961140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1961143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1961151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1961154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1961157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961163 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961186 */     // MIs[0] policy
     /* 1961186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961196 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1961199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961217 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961219 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961220 */     // GIR_Coverage, 60914,
     /* 1961220 */     GIR_EraseRootFromParent_Done,
     /* 1961221 */   // Label 26278: @1961221
     /* 1961221 */   GIM_Try, /*On fail goto*//*Label 26279*/ GIMT_Encode4(1961307), // Rule ID 60915 //
     /* 1961226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1961237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1961240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1961243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1961249 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961272 */     // MIs[0] policy
     /* 1961272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961282 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1961285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961303 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961305 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961306 */     // GIR_Coverage, 60915,
     /* 1961306 */     GIR_EraseRootFromParent_Done,
     /* 1961307 */   // Label 26279: @1961307
     /* 1961307 */   GIM_Try, /*On fail goto*//*Label 26280*/ GIMT_Encode4(1961393), // Rule ID 60922 //
     /* 1961312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1961315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1961323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1961326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1961329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961335 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961358 */     // MIs[0] policy
     /* 1961358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961368 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1961371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961389 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961391 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961392 */     // GIR_Coverage, 60922,
     /* 1961392 */     GIR_EraseRootFromParent_Done,
     /* 1961393 */   // Label 26280: @1961393
     /* 1961393 */   GIM_Try, /*On fail goto*//*Label 26281*/ GIMT_Encode4(1961479), // Rule ID 60923 //
     /* 1961398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1961409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1961412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1961415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1961421 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1961428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961444 */     // MIs[0] policy
     /* 1961444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961454 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11597:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1961457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961475 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961477 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961478 */     // GIR_Coverage, 60923,
     /* 1961478 */     GIR_EraseRootFromParent_Done,
     /* 1961479 */   // Label 26281: @1961479
     /* 1961479 */   GIM_Try, /*On fail goto*//*Label 26282*/ GIMT_Encode4(1961565), // Rule ID 60930 //
     /* 1961484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1961487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1961501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961507 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961530 */     // MIs[0] policy
     /* 1961530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1961543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961561 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961563 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961564 */     // GIR_Coverage, 60930,
     /* 1961564 */     GIR_EraseRootFromParent_Done,
     /* 1961565 */   // Label 26282: @1961565
     /* 1961565 */   GIM_Try, /*On fail goto*//*Label 26283*/ GIMT_Encode4(1961651), // Rule ID 60931 //
     /* 1961570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1961581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1961584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1961587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1961593 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1961600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1961608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961616 */     // MIs[0] policy
     /* 1961616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961626 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1961629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961647 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961649 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961650 */     // GIR_Coverage, 60931,
     /* 1961650 */     GIR_EraseRootFromParent_Done,
     /* 1961651 */   // Label 26283: @1961651
     /* 1961651 */   GIM_Try, /*On fail goto*//*Label 26284*/ GIMT_Encode4(1961737), // Rule ID 60938 //
     /* 1961656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1961659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1961673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961679 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961702 */     // MIs[0] policy
     /* 1961702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961712 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1961715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961733 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961735 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961736 */     // GIR_Coverage, 60938,
     /* 1961736 */     GIR_EraseRootFromParent_Done,
     /* 1961737 */   // Label 26284: @1961737
     /* 1961737 */   GIM_Try, /*On fail goto*//*Label 26285*/ GIMT_Encode4(1961823), // Rule ID 60939 //
     /* 1961742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1961753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1961756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1961759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1961765 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1961772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1961780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961788 */     // MIs[0] policy
     /* 1961788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961798 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1961801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961819 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961821 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961822 */     // GIR_Coverage, 60939,
     /* 1961822 */     GIR_EraseRootFromParent_Done,
     /* 1961823 */   // Label 26285: @1961823
     /* 1961823 */   GIM_Try, /*On fail goto*//*Label 26286*/ GIMT_Encode4(1961909), // Rule ID 60946 //
     /* 1961828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1961831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1961845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1961848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961851 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1961854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961874 */     // MIs[0] policy
     /* 1961874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961884 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1961884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1961887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961905 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961908 */     // GIR_Coverage, 60946,
     /* 1961908 */     GIR_EraseRootFromParent_Done,
     /* 1961909 */   // Label 26286: @1961909
     /* 1961909 */   GIM_Try, /*On fail goto*//*Label 26287*/ GIMT_Encode4(1961995), // Rule ID 60947 //
     /* 1961914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1961917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1961922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1961925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1961928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1961931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1961934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1961937 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1961940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1961944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1961948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1961952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1961956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1961960 */     // MIs[0] policy
     /* 1961960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1961963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1961970 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1961970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1961973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1961975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1961977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1961979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1961981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1961983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1961988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1961991 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1961993 */     GIR_RootConstrainSelectedInstOperands,
     /* 1961994 */     // GIR_Coverage, 60947,
     /* 1961994 */     GIR_EraseRootFromParent_Done,
     /* 1961995 */   // Label 26287: @1961995
     /* 1961995 */   GIM_Try, /*On fail goto*//*Label 26288*/ GIMT_Encode4(1962081), // Rule ID 60954 //
     /* 1962000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962046 */     // MIs[0] policy
     /* 1962046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962056 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1962059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962077 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962079 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962080 */     // GIR_Coverage, 60954,
     /* 1962080 */     GIR_EraseRootFromParent_Done,
     /* 1962081 */   // Label 26288: @1962081
     /* 1962081 */   GIM_Try, /*On fail goto*//*Label 26289*/ GIMT_Encode4(1962167), // Rule ID 60955 //
     /* 1962086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1962097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1962100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1962103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962109 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962132 */     // MIs[0] policy
     /* 1962132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962142 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF4_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF4_MASK),
     /* 1962145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962163 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962165 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962166 */     // GIR_Coverage, 60955,
     /* 1962166 */     GIR_EraseRootFromParent_Done,
     /* 1962167 */   // Label 26289: @1962167
     /* 1962167 */   GIM_Try, /*On fail goto*//*Label 26290*/ GIMT_Encode4(1962253), // Rule ID 60962 //
     /* 1962172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962195 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962218 */     // MIs[0] policy
     /* 1962218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962228 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1962231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962249 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962251 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962252 */     // GIR_Coverage, 60962,
     /* 1962252 */     GIR_EraseRootFromParent_Done,
     /* 1962253 */   // Label 26290: @1962253
     /* 1962253 */   GIM_Try, /*On fail goto*//*Label 26291*/ GIMT_Encode4(1962339), // Rule ID 60963 //
     /* 1962258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1962269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1962272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1962275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1962281 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962304 */     // MIs[0] policy
     /* 1962304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962314 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11597:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1962317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962335 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962337 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962338 */     // GIR_Coverage, 60963,
     /* 1962338 */     GIR_EraseRootFromParent_Done,
     /* 1962339 */   // Label 26291: @1962339
     /* 1962339 */   GIM_Try, /*On fail goto*//*Label 26292*/ GIMT_Encode4(1962425), // Rule ID 60970 //
     /* 1962344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1962355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1962358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962367 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962390 */     // MIs[0] policy
     /* 1962390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962400 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1962403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962421 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962423 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962424 */     // GIR_Coverage, 60970,
     /* 1962424 */     GIR_EraseRootFromParent_Done,
     /* 1962425 */   // Label 26292: @1962425
     /* 1962425 */   GIM_Try, /*On fail goto*//*Label 26293*/ GIMT_Encode4(1962511), // Rule ID 60971 //
     /* 1962430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1962441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1962444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1962447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1962453 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1962460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962476 */     // MIs[0] policy
     /* 1962476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962486 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1962489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962507 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962510 */     // GIR_Coverage, 60971,
     /* 1962510 */     GIR_EraseRootFromParent_Done,
     /* 1962511 */   // Label 26293: @1962511
     /* 1962511 */   GIM_Try, /*On fail goto*//*Label 26294*/ GIMT_Encode4(1962597), // Rule ID 60978 //
     /* 1962516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1962533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962539 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962562 */     // MIs[0] policy
     /* 1962562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962572 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1962575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962593 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962595 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962596 */     // GIR_Coverage, 60978,
     /* 1962596 */     GIR_EraseRootFromParent_Done,
     /* 1962597 */   // Label 26294: @1962597
     /* 1962597 */   GIM_Try, /*On fail goto*//*Label 26295*/ GIMT_Encode4(1962683), // Rule ID 60979 //
     /* 1962602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1962613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1962616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1962619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1962625 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1962632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1962640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962648 */     // MIs[0] policy
     /* 1962648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962658 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1962661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962679 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962681 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962682 */     // GIR_Coverage, 60979,
     /* 1962682 */     GIR_EraseRootFromParent_Done,
     /* 1962683 */   // Label 26295: @1962683
     /* 1962683 */   GIM_Try, /*On fail goto*//*Label 26296*/ GIMT_Encode4(1962769), // Rule ID 60986 //
     /* 1962688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1962705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962711 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962734 */     // MIs[0] policy
     /* 1962734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962744 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1962747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962765 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962767 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962768 */     // GIR_Coverage, 60986,
     /* 1962768 */     GIR_EraseRootFromParent_Done,
     /* 1962769 */   // Label 26296: @1962769
     /* 1962769 */   GIM_Try, /*On fail goto*//*Label 26297*/ GIMT_Encode4(1962855), // Rule ID 60987 //
     /* 1962774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1962785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1962788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1962791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1962797 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1962804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1962808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1962812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962820 */     // MIs[0] policy
     /* 1962820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962830 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1962830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1962833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1962851 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962853 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962854 */     // GIR_Coverage, 60987,
     /* 1962854 */     GIR_EraseRootFromParent_Done,
     /* 1962855 */   // Label 26297: @1962855
     /* 1962855 */   GIM_Try, /*On fail goto*//*Label 26298*/ GIMT_Encode4(1962941), // Rule ID 60994 //
     /* 1962860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1962863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1962871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1962874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1962880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962883 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1962886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962906 */     // MIs[0] policy
     /* 1962906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1962916 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1962916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1962919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1962921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1962923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1962925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1962927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1962929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1962934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1962937 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1962939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1962940 */     // GIR_Coverage, 60994,
     /* 1962940 */     GIR_EraseRootFromParent_Done,
     /* 1962941 */   // Label 26298: @1962941
     /* 1962941 */   GIM_Try, /*On fail goto*//*Label 26299*/ GIMT_Encode4(1963027), // Rule ID 60995 //
     /* 1962946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1962949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1962954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1962957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1962960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1962963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1962966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1962969 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1962972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1962976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1962984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1962988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1962992 */     // MIs[0] policy
     /* 1962992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1962995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963002 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11597:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_MF2_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_MF2_MASK),
     /* 1963005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963023 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963025 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963026 */     // GIR_Coverage, 60995,
     /* 1963026 */     GIR_EraseRootFromParent_Done,
     /* 1963027 */   // Label 26299: @1963027
     /* 1963027 */   GIM_Try, /*On fail goto*//*Label 26300*/ GIMT_Encode4(1963113), // Rule ID 61002 //
     /* 1963032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963055 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963078 */     // MIs[0] policy
     /* 1963078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1963091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963109 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963112 */     // GIR_Coverage, 61002,
     /* 1963112 */     GIR_EraseRootFromParent_Done,
     /* 1963113 */   // Label 26300: @1963113
     /* 1963113 */   GIM_Try, /*On fail goto*//*Label 26301*/ GIMT_Encode4(1963199), // Rule ID 61003 //
     /* 1963118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1963135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963164 */     // MIs[0] policy
     /* 1963164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963174 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11597:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M1_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M1_MASK),
     /* 1963177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963195 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963197 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963198 */     // GIR_Coverage, 61003,
     /* 1963198 */     GIR_EraseRootFromParent_Done,
     /* 1963199 */   // Label 26301: @1963199
     /* 1963199 */   GIM_Try, /*On fail goto*//*Label 26302*/ GIMT_Encode4(1963285), // Rule ID 61010 //
     /* 1963204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963227 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963250 */     // MIs[0] policy
     /* 1963250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963260 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1963263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963281 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963283 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963284 */     // GIR_Coverage, 61010,
     /* 1963284 */     GIR_EraseRootFromParent_Done,
     /* 1963285 */   // Label 26302: @1963285
     /* 1963285 */   GIM_Try, /*On fail goto*//*Label 26303*/ GIMT_Encode4(1963371), // Rule ID 61011 //
     /* 1963290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1963307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963336 */     // MIs[0] policy
     /* 1963336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963346 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11597:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M2_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M2_MASK),
     /* 1963349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963367 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963369 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963370 */     // GIR_Coverage, 61011,
     /* 1963370 */     GIR_EraseRootFromParent_Done,
     /* 1963371 */   // Label 26303: @1963371
     /* 1963371 */   GIM_Try, /*On fail goto*//*Label 26304*/ GIMT_Encode4(1963457), // Rule ID 61018 //
     /* 1963376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode0),
     /* 1963379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1963387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1963390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1963393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1963396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963422 */     // MIs[0] policy
     /* 1963422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963432 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1963435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963453 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963455 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963456 */     // GIR_Coverage, 61018,
     /* 1963456 */     GIR_EraseRootFromParent_Done,
     /* 1963457 */   // Label 26304: @1963457
     /* 1963457 */   GIM_Try, /*On fail goto*//*Label 26305*/ GIMT_Encode4(1963543), // Rule ID 61019 //
     /* 1963462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HwMode1),
     /* 1963465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vwsll_mask),
     /* 1963470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1963473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1963476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1963479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1963482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1963485 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1963492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1963496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1963504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963508 */     // MIs[0] policy
     /* 1963508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963518 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11597:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVWSLL_VX_M4_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VX_M4_MASK),
     /* 1963521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1963539 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963541 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963542 */     // GIR_Coverage, 61019,
     /* 1963542 */     GIR_EraseRootFromParent_Done,
     /* 1963543 */   // Label 26305: @1963543
     /* 1963543 */   GIM_Try, /*On fail goto*//*Label 26306*/ GIMT_Encode4(1963629), // Rule ID 61026 //
     /* 1963548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1963551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1963568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963571 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963594 */     // MIs[0] policy
     /* 1963594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963604 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1963607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963625 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963627 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963628 */     // GIR_Coverage, 61026,
     /* 1963628 */     GIR_EraseRootFromParent_Done,
     /* 1963629 */   // Label 26306: @1963629
     /* 1963629 */   GIM_Try, /*On fail goto*//*Label 26307*/ GIMT_Encode4(1963715), // Rule ID 61027 //
     /* 1963634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1963637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1963645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1963648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1963651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1963654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1963657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1963664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1963676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963680 */     // MIs[0] policy
     /* 1963680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963690 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M1_MASK),
     /* 1963693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963711 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963713 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963714 */     // GIR_Coverage, 61027,
     /* 1963714 */     GIR_EraseRootFromParent_Done,
     /* 1963715 */   // Label 26307: @1963715
     /* 1963715 */   GIM_Try, /*On fail goto*//*Label 26308*/ GIMT_Encode4(1963801), // Rule ID 61030 //
     /* 1963720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1963723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1963737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1963740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963766 */     // MIs[0] policy
     /* 1963766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1963779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963797 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963799 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963800 */     // GIR_Coverage, 61030,
     /* 1963800 */     GIR_EraseRootFromParent_Done,
     /* 1963801 */   // Label 26308: @1963801
     /* 1963801 */   GIM_Try, /*On fail goto*//*Label 26309*/ GIMT_Encode4(1963887), // Rule ID 61031 //
     /* 1963806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1963809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1963817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1963820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1963823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1963826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1963829 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1963832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1963836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1963848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963852 */     // MIs[0] policy
     /* 1963852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963862 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1963862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M2_MASK),
     /* 1963865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963883 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963885 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963886 */     // GIR_Coverage, 61031,
     /* 1963886 */     GIR_EraseRootFromParent_Done,
     /* 1963887 */   // Label 26309: @1963887
     /* 1963887 */   GIM_Try, /*On fail goto*//*Label 26310*/ GIMT_Encode4(1963973), // Rule ID 61034 //
     /* 1963892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1963895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1963909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1963912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1963915 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1963918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1963922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1963934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1963938 */     // MIs[0] policy
     /* 1963938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1963941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1963948 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1963948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1963951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1963953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1963955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1963957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1963959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1963961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1963966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1963969 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1963971 */     GIR_RootConstrainSelectedInstOperands,
     /* 1963972 */     // GIR_Coverage, 61034,
     /* 1963972 */     GIR_EraseRootFromParent_Done,
     /* 1963973 */   // Label 26310: @1963973
     /* 1963973 */   GIM_Try, /*On fail goto*//*Label 26311*/ GIMT_Encode4(1964059), // Rule ID 61035 //
     /* 1963978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1963981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1963986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1963989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1963992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1963995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1963998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964001 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964024 */     // MIs[0] policy
     /* 1964024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964034 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M4_MASK),
     /* 1964037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964055 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964057 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964058 */     // GIR_Coverage, 61035,
     /* 1964058 */     GIR_EraseRootFromParent_Done,
     /* 1964059 */   // Label 26311: @1964059
     /* 1964059 */   GIM_Try, /*On fail goto*//*Label 26312*/ GIMT_Encode4(1964145), // Rule ID 61038 //
     /* 1964064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1964084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964087 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964110 */     // MIs[0] policy
     /* 1964110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964120 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1964123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964141 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964143 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964144 */     // GIR_Coverage, 61038,
     /* 1964144 */     GIR_EraseRootFromParent_Done,
     /* 1964145 */   // Label 26312: @1964145
     /* 1964145 */   GIM_Try, /*On fail goto*//*Label 26313*/ GIMT_Encode4(1964231), // Rule ID 61039 //
     /* 1964150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1964153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1964170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964196 */     // MIs[0] policy
     /* 1964196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964206 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VV_M8_MASK),
     /* 1964209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964227 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964229 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964230 */     // GIR_Coverage, 61039,
     /* 1964230 */     GIR_EraseRootFromParent_Done,
     /* 1964231 */   // Label 26313: @1964231
     /* 1964231 */   GIM_Try, /*On fail goto*//*Label 26314*/ GIMT_Encode4(1964317), // Rule ID 61042 //
     /* 1964236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1964247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1964250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1964253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964259 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964282 */     // MIs[0] policy
     /* 1964282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964292 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1964295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964313 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964315 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964316 */     // GIR_Coverage, 61042,
     /* 1964316 */     GIR_EraseRootFromParent_Done,
     /* 1964317 */   // Label 26314: @1964317
     /* 1964317 */   GIM_Try, /*On fail goto*//*Label 26315*/ GIMT_Encode4(1964403), // Rule ID 61043 //
     /* 1964322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1964325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1964333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1964336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1964339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964345 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964368 */     // MIs[0] policy
     /* 1964368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964378 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11100:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M1_MASK),
     /* 1964381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964399 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964401 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964402 */     // GIR_Coverage, 61043,
     /* 1964402 */     GIR_EraseRootFromParent_Done,
     /* 1964403 */   // Label 26315: @1964403
     /* 1964403 */   GIM_Try, /*On fail goto*//*Label 26316*/ GIMT_Encode4(1964489), // Rule ID 61046 //
     /* 1964408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964454 */     // MIs[0] policy
     /* 1964454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1964467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964485 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964487 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964488 */     // GIR_Coverage, 61046,
     /* 1964488 */     GIR_EraseRootFromParent_Done,
     /* 1964489 */   // Label 26316: @1964489
     /* 1964489 */   GIM_Try, /*On fail goto*//*Label 26317*/ GIMT_Encode4(1964575), // Rule ID 61047 //
     /* 1964494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1964497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1964505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1964508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1964511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1964517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1964524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1964532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964540 */     // MIs[0] policy
     /* 1964540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964550 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11100:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M2_MASK),
     /* 1964553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964571 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964573 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964574 */     // GIR_Coverage, 61047,
     /* 1964574 */     GIR_EraseRootFromParent_Done,
     /* 1964575 */   // Label 26317: @1964575
     /* 1964575 */   GIM_Try, /*On fail goto*//*Label 26318*/ GIMT_Encode4(1964661), // Rule ID 61050 //
     /* 1964580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964603 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964626 */     // MIs[0] policy
     /* 1964626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964636 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1964639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964657 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964659 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964660 */     // GIR_Coverage, 61050,
     /* 1964660 */     GIR_EraseRootFromParent_Done,
     /* 1964661 */   // Label 26318: @1964661
     /* 1964661 */   GIM_Try, /*On fail goto*//*Label 26319*/ GIMT_Encode4(1964747), // Rule ID 61051 //
     /* 1964666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1964669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1964677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1964680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1964683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1964689 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1964696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1964704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964712 */     // MIs[0] policy
     /* 1964712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964722 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11100:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M4_MASK),
     /* 1964725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964743 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964745 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964746 */     // GIR_Coverage, 61051,
     /* 1964746 */     GIR_EraseRootFromParent_Done,
     /* 1964747 */   // Label 26319: @1964747
     /* 1964747 */   GIM_Try, /*On fail goto*//*Label 26320*/ GIMT_Encode4(1964833), // Rule ID 61054 //
     /* 1964752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1964772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964775 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964798 */     // MIs[0] policy
     /* 1964798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964808 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1964811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964813 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964829 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964831 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964832 */     // GIR_Coverage, 61054,
     /* 1964832 */     GIR_EraseRootFromParent_Done,
     /* 1964833 */   // Label 26320: @1964833
     /* 1964833 */   GIM_Try, /*On fail goto*//*Label 26321*/ GIMT_Encode4(1964919), // Rule ID 61055 //
     /* 1964838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1964841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmul_mask),
     /* 1964846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1964849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1964852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1964855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1964858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1964861 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1964864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1964868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1964876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1964880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964884 */     // MIs[0] policy
     /* 1964884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964894 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11100:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1964894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMUL_VX_M8_MASK),
     /* 1964897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1964915 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1964917 */     GIR_RootConstrainSelectedInstOperands,
     /* 1964918 */     // GIR_Coverage, 61055,
     /* 1964918 */     GIR_EraseRootFromParent_Done,
     /* 1964919 */   // Label 26321: @1964919
     /* 1964919 */   GIM_Try, /*On fail goto*//*Label 26322*/ GIMT_Encode4(1965005), // Rule ID 61058 //
     /* 1964924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1964927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1964932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1964935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1964938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1964941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1964944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1964947 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1964950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1964954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1964966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1964970 */     // MIs[0] policy
     /* 1964970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1964973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1964980 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1964980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1964983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1964985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1964987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1964989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1964991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1964993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1964998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965001 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965003 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965004 */     // GIR_Coverage, 61058,
     /* 1965004 */     GIR_EraseRootFromParent_Done,
     /* 1965005 */   // Label 26322: @1965005
     /* 1965005 */   GIM_Try, /*On fail goto*//*Label 26323*/ GIMT_Encode4(1965091), // Rule ID 61059 //
     /* 1965010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1965021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1965024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1965027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1965030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965033 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965056 */     // MIs[0] policy
     /* 1965056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M1_MASK),
     /* 1965069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965087 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965089 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965090 */     // GIR_Coverage, 61059,
     /* 1965090 */     GIR_EraseRootFromParent_Done,
     /* 1965091 */   // Label 26323: @1965091
     /* 1965091 */   GIM_Try, /*On fail goto*//*Label 26324*/ GIMT_Encode4(1965177), // Rule ID 61062 //
     /* 1965096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1965116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965119 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965142 */     // MIs[0] policy
     /* 1965142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965152 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1965155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965173 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965175 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965176 */     // GIR_Coverage, 61062,
     /* 1965176 */     GIR_EraseRootFromParent_Done,
     /* 1965177 */   // Label 26324: @1965177
     /* 1965177 */   GIM_Try, /*On fail goto*//*Label 26325*/ GIMT_Encode4(1965263), // Rule ID 61063 //
     /* 1965182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1965202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965205 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965228 */     // MIs[0] policy
     /* 1965228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965238 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M2_MASK),
     /* 1965241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965259 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965261 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965262 */     // GIR_Coverage, 61063,
     /* 1965262 */     GIR_EraseRootFromParent_Done,
     /* 1965263 */   // Label 26325: @1965263
     /* 1965263 */   GIM_Try, /*On fail goto*//*Label 26326*/ GIMT_Encode4(1965349), // Rule ID 61066 //
     /* 1965268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1965288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965291 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965314 */     // MIs[0] policy
     /* 1965314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965324 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1965327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965345 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965347 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965348 */     // GIR_Coverage, 61066,
     /* 1965348 */     GIR_EraseRootFromParent_Done,
     /* 1965349 */   // Label 26326: @1965349
     /* 1965349 */   GIM_Try, /*On fail goto*//*Label 26327*/ GIMT_Encode4(1965435), // Rule ID 61067 //
     /* 1965354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1965374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965377 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965400 */     // MIs[0] policy
     /* 1965400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965410 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M4_MASK),
     /* 1965413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965431 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965434 */     // GIR_Coverage, 61067,
     /* 1965434 */     GIR_EraseRootFromParent_Done,
     /* 1965435 */   // Label 26327: @1965435
     /* 1965435 */   GIM_Try, /*On fail goto*//*Label 26328*/ GIMT_Encode4(1965521), // Rule ID 61070 //
     /* 1965440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1965460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965463 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965486 */     // MIs[0] policy
     /* 1965486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965496 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1965499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965517 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965519 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965520 */     // GIR_Coverage, 61070,
     /* 1965520 */     GIR_EraseRootFromParent_Done,
     /* 1965521 */   // Label 26328: @1965521
     /* 1965521 */   GIM_Try, /*On fail goto*//*Label 26329*/ GIMT_Encode4(1965607), // Rule ID 61071 //
     /* 1965526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1965537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1965540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1965543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1965546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1965549 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1965556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1965568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965572 */     // MIs[0] policy
     /* 1965572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965582 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VV_M8_MASK),
     /* 1965585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965603 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965605 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965606 */     // GIR_Coverage, 61071,
     /* 1965606 */     GIR_EraseRootFromParent_Done,
     /* 1965607 */   // Label 26329: @1965607
     /* 1965607 */   GIM_Try, /*On fail goto*//*Label 26330*/ GIMT_Encode4(1965693), // Rule ID 61074 //
     /* 1965612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1965623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1965626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1965629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965635 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965658 */     // MIs[0] policy
     /* 1965658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965668 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1965671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965689 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965691 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965692 */     // GIR_Coverage, 61074,
     /* 1965692 */     GIR_EraseRootFromParent_Done,
     /* 1965693 */   // Label 26330: @1965693
     /* 1965693 */   GIM_Try, /*On fail goto*//*Label 26331*/ GIMT_Encode4(1965779), // Rule ID 61075 //
     /* 1965698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1965709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1965712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1965715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1965721 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1965728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1965736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965744 */     // MIs[0] policy
     /* 1965744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965754 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11102:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M1_MASK),
     /* 1965757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965775 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965777 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965778 */     // GIR_Coverage, 61075,
     /* 1965778 */     GIR_EraseRootFromParent_Done,
     /* 1965779 */   // Label 26331: @1965779
     /* 1965779 */   GIM_Try, /*On fail goto*//*Label 26332*/ GIMT_Encode4(1965865), // Rule ID 61078 //
     /* 1965784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965807 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965830 */     // MIs[0] policy
     /* 1965830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965840 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1965840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1965843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965861 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965863 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965864 */     // GIR_Coverage, 61078,
     /* 1965864 */     GIR_EraseRootFromParent_Done,
     /* 1965865 */   // Label 26332: @1965865
     /* 1965865 */   GIM_Try, /*On fail goto*//*Label 26333*/ GIMT_Encode4(1965951), // Rule ID 61079 //
     /* 1965870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1965873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1965881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1965884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1965887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1965890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1965893 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1965896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1965900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1965908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1965916 */     // MIs[0] policy
     /* 1965916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1965919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1965926 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11102:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1965926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M2_MASK),
     /* 1965929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1965931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1965933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1965935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1965937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1965939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1965944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1965947 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1965949 */     GIR_RootConstrainSelectedInstOperands,
     /* 1965950 */     // GIR_Coverage, 61079,
     /* 1965950 */     GIR_EraseRootFromParent_Done,
     /* 1965951 */   // Label 26333: @1965951
     /* 1965951 */   GIM_Try, /*On fail goto*//*Label 26334*/ GIMT_Encode4(1966037), // Rule ID 61082 //
     /* 1965956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1965959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1965964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1965967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1965970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1965973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1965976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1965979 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1965982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1965986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1965994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1965998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966002 */     // MIs[0] policy
     /* 1966002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966012 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1966015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1966033 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966035 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966036 */     // GIR_Coverage, 61082,
     /* 1966036 */     GIR_EraseRootFromParent_Done,
     /* 1966037 */   // Label 26334: @1966037
     /* 1966037 */   GIM_Try, /*On fail goto*//*Label 26335*/ GIMT_Encode4(1966123), // Rule ID 61083 //
     /* 1966042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1966045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1966050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1966053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1966056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1966059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966065 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1966072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1966080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966088 */     // MIs[0] policy
     /* 1966088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966098 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11102:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M4_MASK),
     /* 1966101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1966119 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966121 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966122 */     // GIR_Coverage, 61083,
     /* 1966122 */     GIR_EraseRootFromParent_Done,
     /* 1966123 */   // Label 26335: @1966123
     /* 1966123 */   GIM_Try, /*On fail goto*//*Label 26336*/ GIMT_Encode4(1966209), // Rule ID 61086 //
     /* 1966128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode0),
     /* 1966131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1966136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1966139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1966142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1966145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1966148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966151 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966174 */     // MIs[0] policy
     /* 1966174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966184 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1966187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1966205 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966207 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966208 */     // GIR_Coverage, 61086,
     /* 1966208 */     GIR_EraseRootFromParent_Done,
     /* 1966209 */   // Label 26336: @1966209
     /* 1966209 */   GIM_Try, /*On fail goto*//*Label 26337*/ GIMT_Encode4(1966295), // Rule ID 61087 //
     /* 1966214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbc_HwMode1),
     /* 1966217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vclmulh_mask),
     /* 1966222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1966225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1966228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1966231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1966234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1966237 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1966244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1966252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1966256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966260 */     // MIs[0] policy
     /* 1966260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966270 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11102:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVCLMULH_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLMULH_VX_M8_MASK),
     /* 1966273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1966291 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966293 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966294 */     // GIR_Coverage, 61087,
     /* 1966294 */     GIR_EraseRootFromParent_Done,
     /* 1966295 */   // Label 26337: @1966295
     /* 1966295 */   GIM_Try, /*On fail goto*//*Label 26338*/ GIMT_Encode4(1966381), // Rule ID 61090 //
     /* 1966300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1966303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1966311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1966314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1966317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1966320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966323 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966346 */     // MIs[0] policy
     /* 1966346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966356 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1966359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966377 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966379 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966380 */     // GIR_Coverage, 61090,
     /* 1966380 */     GIR_EraseRootFromParent_Done,
     /* 1966381 */   // Label 26338: @1966381
     /* 1966381 */   GIM_Try, /*On fail goto*//*Label 26339*/ GIMT_Encode4(1966467), // Rule ID 61091 //
     /* 1966386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1966389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1966397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1966400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1966403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1966406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966409 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966432 */     // MIs[0] policy
     /* 1966432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966442 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF8_MASK),
     /* 1966445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966463 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966465 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966466 */     // GIR_Coverage, 61091,
     /* 1966466 */     GIR_EraseRootFromParent_Done,
     /* 1966467 */   // Label 26339: @1966467
     /* 1966467 */   GIM_Try, /*On fail goto*//*Label 26340*/ GIMT_Encode4(1966553), // Rule ID 61094 //
     /* 1966472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1966475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1966483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1966486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1966489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1966492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966495 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966518 */     // MIs[0] policy
     /* 1966518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966528 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1966531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966549 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966552 */     // GIR_Coverage, 61094,
     /* 1966552 */     GIR_EraseRootFromParent_Done,
     /* 1966553 */   // Label 26340: @1966553
     /* 1966553 */   GIM_Try, /*On fail goto*//*Label 26341*/ GIMT_Encode4(1966639), // Rule ID 61095 //
     /* 1966558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1966561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1966569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1966572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1966575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1966578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1966581 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966604 */     // MIs[0] policy
     /* 1966604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1966617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966635 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966637 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966638 */     // GIR_Coverage, 61095,
     /* 1966638 */     GIR_EraseRootFromParent_Done,
     /* 1966639 */   // Label 26341: @1966639
     /* 1966639 */   GIM_Try, /*On fail goto*//*Label 26342*/ GIMT_Encode4(1966725), // Rule ID 61098 //
     /* 1966644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1966647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1966655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1966658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1966661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1966664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966667 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966690 */     // MIs[0] policy
     /* 1966690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966700 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1966703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966721 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966723 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966724 */     // GIR_Coverage, 61098,
     /* 1966724 */     GIR_EraseRootFromParent_Done,
     /* 1966725 */   // Label 26342: @1966725
     /* 1966725 */   GIM_Try, /*On fail goto*//*Label 26343*/ GIMT_Encode4(1966811), // Rule ID 61099 //
     /* 1966730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1966733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1966741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1966744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1966747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1966750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1966753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966776 */     // MIs[0] policy
     /* 1966776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966786 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1966789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1966807 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966809 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966810 */     // GIR_Coverage, 61099,
     /* 1966810 */     GIR_EraseRootFromParent_Done,
     /* 1966811 */   // Label 26343: @1966811
     /* 1966811 */   GIM_Try, /*On fail goto*//*Label 26344*/ GIMT_Encode4(1966897), // Rule ID 61102 //
     /* 1966816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1966819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1966827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1966830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966839 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1966842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966862 */     // MIs[0] policy
     /* 1966862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966872 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1966872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1966875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966893 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966895 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966896 */     // GIR_Coverage, 61102,
     /* 1966896 */     GIR_EraseRootFromParent_Done,
     /* 1966897 */   // Label 26344: @1966897
     /* 1966897 */   GIM_Try, /*On fail goto*//*Label 26345*/ GIMT_Encode4(1966983), // Rule ID 61103 //
     /* 1966902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1966905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1966913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1966916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1966919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1966922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1966925 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1966928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1966932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1966944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1966948 */     // MIs[0] policy
     /* 1966948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1966951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1966958 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1966958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF4_MASK),
     /* 1966961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1966963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1966965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1966967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1966969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1966971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1966976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1966979 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1966981 */     GIR_RootConstrainSelectedInstOperands,
     /* 1966982 */     // GIR_Coverage, 61103,
     /* 1966982 */     GIR_EraseRootFromParent_Done,
     /* 1966983 */   // Label 26345: @1966983
     /* 1966983 */   GIM_Try, /*On fail goto*//*Label 26346*/ GIMT_Encode4(1967069), // Rule ID 61106 //
     /* 1966988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1966991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1966996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1966999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1967005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1967008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967034 */     // MIs[0] policy
     /* 1967034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967044 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1967047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967065 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967067 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967068 */     // GIR_Coverage, 61106,
     /* 1967068 */     GIR_EraseRootFromParent_Done,
     /* 1967069 */   // Label 26346: @1967069
     /* 1967069 */   GIM_Try, /*On fail goto*//*Label 26347*/ GIMT_Encode4(1967155), // Rule ID 61107 //
     /* 1967074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1967085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1967088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1967091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1967094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967120 */     // MIs[0] policy
     /* 1967120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967130 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1967133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967151 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967154 */     // GIR_Coverage, 61107,
     /* 1967154 */     GIR_EraseRootFromParent_Done,
     /* 1967155 */   // Label 26347: @1967155
     /* 1967155 */   GIM_Try, /*On fail goto*//*Label 26348*/ GIMT_Encode4(1967241), // Rule ID 61110 //
     /* 1967160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1967163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1967171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1967174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967183 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967206 */     // MIs[0] policy
     /* 1967206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967216 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1967219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967237 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967239 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967240 */     // GIR_Coverage, 61110,
     /* 1967240 */     GIR_EraseRootFromParent_Done,
     /* 1967241 */   // Label 26348: @1967241
     /* 1967241 */   GIM_Try, /*On fail goto*//*Label 26349*/ GIMT_Encode4(1967327), // Rule ID 61111 //
     /* 1967246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1967257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1967260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1967263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1967266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967269 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967292 */     // MIs[0] policy
     /* 1967292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967302 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_MF2_MASK),
     /* 1967305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967323 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967325 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967326 */     // GIR_Coverage, 61111,
     /* 1967326 */     GIR_EraseRootFromParent_Done,
     /* 1967327 */   // Label 26349: @1967327
     /* 1967327 */   GIM_Try, /*On fail goto*//*Label 26350*/ GIMT_Encode4(1967413), // Rule ID 61114 //
     /* 1967332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1967335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1967343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1967346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1967349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1967352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967355 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967378 */     // MIs[0] policy
     /* 1967378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967388 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967409 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967411 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967412 */     // GIR_Coverage, 61114,
     /* 1967412 */     GIR_EraseRootFromParent_Done,
     /* 1967413 */   // Label 26350: @1967413
     /* 1967413 */   GIM_Try, /*On fail goto*//*Label 26351*/ GIMT_Encode4(1967499), // Rule ID 61115 //
     /* 1967418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1967429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1967432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1967435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1967438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1967441 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967464 */     // MIs[0] policy
     /* 1967464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967474 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1967495 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967497 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967498 */     // GIR_Coverage, 61115,
     /* 1967498 */     GIR_EraseRootFromParent_Done,
     /* 1967499 */   // Label 26351: @1967499
     /* 1967499 */   GIM_Try, /*On fail goto*//*Label 26352*/ GIMT_Encode4(1967585), // Rule ID 61118 //
     /* 1967504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1967507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1967515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1967518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1967521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1967524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967527 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967550 */     // MIs[0] policy
     /* 1967550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967560 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967581 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967583 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967584 */     // GIR_Coverage, 61118,
     /* 1967584 */     GIR_EraseRootFromParent_Done,
     /* 1967585 */   // Label 26352: @1967585
     /* 1967585 */   GIM_Try, /*On fail goto*//*Label 26353*/ GIMT_Encode4(1967671), // Rule ID 61119 //
     /* 1967590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1967601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1967604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1967607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1967610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1967613 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967636 */     // MIs[0] policy
     /* 1967636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967646 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1967667 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967669 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967670 */     // GIR_Coverage, 61119,
     /* 1967670 */     GIR_EraseRootFromParent_Done,
     /* 1967671 */   // Label 26353: @1967671
     /* 1967671 */   GIM_Try, /*On fail goto*//*Label 26354*/ GIMT_Encode4(1967757), // Rule ID 61122 //
     /* 1967676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1967679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1967687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1967690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967699 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967722 */     // MIs[0] policy
     /* 1967722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967732 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967753 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967756 */     // GIR_Coverage, 61122,
     /* 1967756 */     GIR_EraseRootFromParent_Done,
     /* 1967757 */   // Label 26354: @1967757
     /* 1967757 */   GIM_Try, /*On fail goto*//*Label 26355*/ GIMT_Encode4(1967843), // Rule ID 61123 //
     /* 1967762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1967773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1967776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1967779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1967782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1967785 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967808 */     // MIs[0] policy
     /* 1967808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967818 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1967839 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967841 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967842 */     // GIR_Coverage, 61123,
     /* 1967842 */     GIR_EraseRootFromParent_Done,
     /* 1967843 */   // Label 26355: @1967843
     /* 1967843 */   GIM_Try, /*On fail goto*//*Label 26356*/ GIMT_Encode4(1967929), // Rule ID 61126 //
     /* 1967848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1967851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1967868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1967874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967894 */     // MIs[0] policy
     /* 1967894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967904 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1967904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1967915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1967917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1967922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1967925 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1967927 */     GIR_RootConstrainSelectedInstOperands,
     /* 1967928 */     // GIR_Coverage, 61126,
     /* 1967928 */     GIR_EraseRootFromParent_Done,
     /* 1967929 */   // Label 26356: @1967929
     /* 1967929 */   GIM_Try, /*On fail goto*//*Label 26357*/ GIMT_Encode4(1968015), // Rule ID 61127 //
     /* 1967934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1967937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1967942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1967945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1967948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1967951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1967954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1967957 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1967960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1967964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1967976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1967980 */     // MIs[0] policy
     /* 1967980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1967983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1967990 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1967990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M1_MASK),
     /* 1967993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1967995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1967997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1967999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1968011 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968013 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968014 */     // GIR_Coverage, 61127,
     /* 1968014 */     GIR_EraseRootFromParent_Done,
     /* 1968015 */   // Label 26357: @1968015
     /* 1968015 */   GIM_Try, /*On fail goto*//*Label 26358*/ GIMT_Encode4(1968101), // Rule ID 61130 //
     /* 1968020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1968031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1968034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1968040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968043 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968066 */     // MIs[0] policy
     /* 1968066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968076 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1968079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968097 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968099 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968100 */     // GIR_Coverage, 61130,
     /* 1968100 */     GIR_EraseRootFromParent_Done,
     /* 1968101 */   // Label 26358: @1968101
     /* 1968101 */   GIM_Try, /*On fail goto*//*Label 26359*/ GIMT_Encode4(1968187), // Rule ID 61131 //
     /* 1968106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1968117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1968120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1968123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1968126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968129 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968152 */     // MIs[0] policy
     /* 1968152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968162 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1968165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968183 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968185 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968186 */     // GIR_Coverage, 61131,
     /* 1968186 */     GIR_EraseRootFromParent_Done,
     /* 1968187 */   // Label 26359: @1968187
     /* 1968187 */   GIM_Try, /*On fail goto*//*Label 26360*/ GIMT_Encode4(1968273), // Rule ID 61134 //
     /* 1968192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1968203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1968206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1968212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968215 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968238 */     // MIs[0] policy
     /* 1968238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968248 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1968251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968269 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968271 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968272 */     // GIR_Coverage, 61134,
     /* 1968272 */     GIR_EraseRootFromParent_Done,
     /* 1968273 */   // Label 26360: @1968273
     /* 1968273 */   GIM_Try, /*On fail goto*//*Label 26361*/ GIMT_Encode4(1968359), // Rule ID 61135 //
     /* 1968278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1968289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1968292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1968295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1968298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968301 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968324 */     // MIs[0] policy
     /* 1968324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968334 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1968337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968355 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968357 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968358 */     // GIR_Coverage, 61135,
     /* 1968358 */     GIR_EraseRootFromParent_Done,
     /* 1968359 */   // Label 26361: @1968359
     /* 1968359 */   GIM_Try, /*On fail goto*//*Label 26362*/ GIMT_Encode4(1968445), // Rule ID 61138 //
     /* 1968364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1968375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1968378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1968381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1968384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1968387 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968410 */     // MIs[0] policy
     /* 1968410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968420 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1968423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968441 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968443 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968444 */     // GIR_Coverage, 61138,
     /* 1968444 */     GIR_EraseRootFromParent_Done,
     /* 1968445 */   // Label 26362: @1968445
     /* 1968445 */   GIM_Try, /*On fail goto*//*Label 26363*/ GIMT_Encode4(1968531), // Rule ID 61139 //
     /* 1968450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1968461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1968464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1968467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1968470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1968473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968496 */     // MIs[0] policy
     /* 1968496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968506 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1968509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1968527 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968529 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968530 */     // GIR_Coverage, 61139,
     /* 1968530 */     GIR_EraseRootFromParent_Done,
     /* 1968531 */   // Label 26363: @1968531
     /* 1968531 */   GIM_Try, /*On fail goto*//*Label 26364*/ GIMT_Encode4(1968617), // Rule ID 61142 //
     /* 1968536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1968553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1968556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968559 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968582 */     // MIs[0] policy
     /* 1968582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1968595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968613 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968615 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968616 */     // GIR_Coverage, 61142,
     /* 1968616 */     GIR_EraseRootFromParent_Done,
     /* 1968617 */   // Label 26364: @1968617
     /* 1968617 */   GIM_Try, /*On fail goto*//*Label 26365*/ GIMT_Encode4(1968703), // Rule ID 61143 //
     /* 1968622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1968633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1968636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1968639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1968642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1968645 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1968652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1968664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968668 */     // MIs[0] policy
     /* 1968668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968678 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1968681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968699 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968701 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968702 */     // GIR_Coverage, 61143,
     /* 1968702 */     GIR_EraseRootFromParent_Done,
     /* 1968703 */   // Label 26365: @1968703
     /* 1968703 */   GIM_Try, /*On fail goto*//*Label 26366*/ GIMT_Encode4(1968789), // Rule ID 61146 //
     /* 1968708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1968725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1968728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968754 */     // MIs[0] policy
     /* 1968754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968764 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1968767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968785 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968787 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968788 */     // GIR_Coverage, 61146,
     /* 1968788 */     GIR_EraseRootFromParent_Done,
     /* 1968789 */   // Label 26366: @1968789
     /* 1968789 */   GIM_Try, /*On fail goto*//*Label 26367*/ GIMT_Encode4(1968875), // Rule ID 61147 //
     /* 1968794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1968805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1968808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1968811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1968814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1968817 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1968824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1968836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968840 */     // MIs[0] policy
     /* 1968840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968850 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1968850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1968853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968871 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968873 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968874 */     // GIR_Coverage, 61147,
     /* 1968874 */     GIR_EraseRootFromParent_Done,
     /* 1968875 */   // Label 26367: @1968875
     /* 1968875 */   GIM_Try, /*On fail goto*//*Label 26368*/ GIMT_Encode4(1968961), // Rule ID 61150 //
     /* 1968880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1968883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1968897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1968900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968903 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1968906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1968922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1968926 */     // MIs[0] policy
     /* 1968926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1968929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1968936 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1968936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1968939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1968941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1968943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1968945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1968947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1968949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1968954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1968957 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1968959 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968960 */     // GIR_Coverage, 61150,
     /* 1968960 */     GIR_EraseRootFromParent_Done,
     /* 1968961 */   // Label 26368: @1968961
     /* 1968961 */   GIM_Try, /*On fail goto*//*Label 26369*/ GIMT_Encode4(1969047), // Rule ID 61151 //
     /* 1968966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1968969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1968974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1968977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1968980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1968983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1968986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1968989 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1968992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1968996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969012 */     // MIs[0] policy
     /* 1969012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969022 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1969025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1969043 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969045 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969046 */     // GIR_Coverage, 61151,
     /* 1969046 */     GIR_EraseRootFromParent_Done,
     /* 1969047 */   // Label 26369: @1969047
     /* 1969047 */   GIM_Try, /*On fail goto*//*Label 26370*/ GIMT_Encode4(1969133), // Rule ID 61154 //
     /* 1969052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1969072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969075 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969098 */     // MIs[0] policy
     /* 1969098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969108 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1969111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969129 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969131 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969132 */     // GIR_Coverage, 61154,
     /* 1969132 */     GIR_EraseRootFromParent_Done,
     /* 1969133 */   // Label 26370: @1969133
     /* 1969133 */   GIM_Try, /*On fail goto*//*Label 26371*/ GIMT_Encode4(1969219), // Rule ID 61155 //
     /* 1969138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1969141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1969149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1969152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1969155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1969158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969161 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969184 */     // MIs[0] policy
     /* 1969184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1969197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969215 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969217 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969218 */     // GIR_Coverage, 61155,
     /* 1969218 */     GIR_EraseRootFromParent_Done,
     /* 1969219 */   // Label 26371: @1969219
     /* 1969219 */   GIM_Try, /*On fail goto*//*Label 26372*/ GIMT_Encode4(1969305), // Rule ID 61158 //
     /* 1969224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1969241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1969244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969247 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969270 */     // MIs[0] policy
     /* 1969270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969280 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1969283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969301 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969303 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969304 */     // GIR_Coverage, 61158,
     /* 1969304 */     GIR_EraseRootFromParent_Done,
     /* 1969305 */   // Label 26372: @1969305
     /* 1969305 */   GIM_Try, /*On fail goto*//*Label 26373*/ GIMT_Encode4(1969391), // Rule ID 61159 //
     /* 1969310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1969313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1969321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1969324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1969327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1969330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969333 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969356 */     // MIs[0] policy
     /* 1969356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969366 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1969369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969387 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969389 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969390 */     // GIR_Coverage, 61159,
     /* 1969390 */     GIR_EraseRootFromParent_Done,
     /* 1969391 */   // Label 26373: @1969391
     /* 1969391 */   GIM_Try, /*On fail goto*//*Label 26374*/ GIMT_Encode4(1969477), // Rule ID 61162 //
     /* 1969396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1969413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1969416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969419 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969442 */     // MIs[0] policy
     /* 1969442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969452 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1969455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969473 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969475 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969476 */     // GIR_Coverage, 61162,
     /* 1969476 */     GIR_EraseRootFromParent_Done,
     /* 1969477 */   // Label 26374: @1969477
     /* 1969477 */   GIM_Try, /*On fail goto*//*Label 26375*/ GIMT_Encode4(1969563), // Rule ID 61163 //
     /* 1969482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1969485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1969493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1969496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1969499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1969502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1969505 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969528 */     // MIs[0] policy
     /* 1969528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969538 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1969541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969543 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1969559 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969561 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969562 */     // GIR_Coverage, 61163,
     /* 1969562 */     GIR_EraseRootFromParent_Done,
     /* 1969563 */   // Label 26375: @1969563
     /* 1969563 */   GIM_Try, /*On fail goto*//*Label 26376*/ GIMT_Encode4(1969649), // Rule ID 61166 //
     /* 1969568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1969585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1969588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969591 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969614 */     // MIs[0] policy
     /* 1969614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969624 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1969627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969629 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969645 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969647 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969648 */     // GIR_Coverage, 61166,
     /* 1969648 */     GIR_EraseRootFromParent_Done,
     /* 1969649 */   // Label 26376: @1969649
     /* 1969649 */   GIM_Try, /*On fail goto*//*Label 26377*/ GIMT_Encode4(1969735), // Rule ID 61167 //
     /* 1969654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1969657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1969665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1969668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1969671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1969674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1969677 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1969684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1969696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969700 */     // MIs[0] policy
     /* 1969700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969710 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M2_MASK),
     /* 1969713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969731 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969733 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969734 */     // GIR_Coverage, 61167,
     /* 1969734 */     GIR_EraseRootFromParent_Done,
     /* 1969735 */   // Label 26377: @1969735
     /* 1969735 */   GIM_Try, /*On fail goto*//*Label 26378*/ GIMT_Encode4(1969821), // Rule ID 61170 //
     /* 1969740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1969760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969763 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969786 */     // MIs[0] policy
     /* 1969786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969796 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1969799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969817 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969819 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969820 */     // GIR_Coverage, 61170,
     /* 1969820 */     GIR_EraseRootFromParent_Done,
     /* 1969821 */   // Label 26378: @1969821
     /* 1969821 */   GIM_Try, /*On fail goto*//*Label 26379*/ GIMT_Encode4(1969907), // Rule ID 61171 //
     /* 1969826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1969829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1969837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1969840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1969843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1969846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1969849 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1969852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1969856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1969868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969872 */     // MIs[0] policy
     /* 1969872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969882 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1969882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M4_MASK),
     /* 1969885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969903 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969905 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969906 */     // GIR_Coverage, 61171,
     /* 1969906 */     GIR_EraseRootFromParent_Done,
     /* 1969907 */   // Label 26379: @1969907
     /* 1969907 */   GIM_Try, /*On fail goto*//*Label 26380*/ GIMT_Encode4(1969993), // Rule ID 61174 //
     /* 1969912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1969915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1969920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1969923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1969926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1969929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1969932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1969935 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1969938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1969942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1969954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1969958 */     // MIs[0] policy
     /* 1969958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1969961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1969968 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1969968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1969971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1969973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1969975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1969977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1969979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1969981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1969986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1969989 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1969991 */     GIR_RootConstrainSelectedInstOperands,
     /* 1969992 */     // GIR_Coverage, 61174,
     /* 1969992 */     GIR_EraseRootFromParent_Done,
     /* 1969993 */   // Label 26380: @1969993
     /* 1969993 */   GIM_Try, /*On fail goto*//*Label 26381*/ GIMT_Encode4(1970079), // Rule ID 61175 //
     /* 1969998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1970009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1970012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1970015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1970018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1970021 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1970028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1970040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970044 */     // MIs[0] policy
     /* 1970044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970054 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VV_M8_MASK),
     /* 1970057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1970075 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970077 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970078 */     // GIR_Coverage, 61175,
     /* 1970078 */     GIR_EraseRootFromParent_Done,
     /* 1970079 */   // Label 26381: @1970079
     /* 1970079 */   GIM_Try, /*On fail goto*//*Label 26382*/ GIMT_Encode4(1970165), // Rule ID 61178 //
     /* 1970084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1970095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1970098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1970101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970107 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970130 */     // MIs[0] policy
     /* 1970130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1970143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970161 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970163 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970164 */     // GIR_Coverage, 61178,
     /* 1970164 */     GIR_EraseRootFromParent_Done,
     /* 1970165 */   // Label 26382: @1970165
     /* 1970165 */   GIM_Try, /*On fail goto*//*Label 26383*/ GIMT_Encode4(1970251), // Rule ID 61179 //
     /* 1970170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1970181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1970184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1970187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970193 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970216 */     // MIs[0] policy
     /* 1970216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970226 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF8_MASK),
     /* 1970229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970247 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970249 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970250 */     // GIR_Coverage, 61179,
     /* 1970250 */     GIR_EraseRootFromParent_Done,
     /* 1970251 */   // Label 26383: @1970251
     /* 1970251 */   GIM_Try, /*On fail goto*//*Label 26384*/ GIMT_Encode4(1970337), // Rule ID 61182 //
     /* 1970256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1970267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1970270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1970273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970279 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970302 */     // MIs[0] policy
     /* 1970302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970312 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1970315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970333 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970335 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970336 */     // GIR_Coverage, 61182,
     /* 1970336 */     GIR_EraseRootFromParent_Done,
     /* 1970337 */   // Label 26384: @1970337
     /* 1970337 */   GIM_Try, /*On fail goto*//*Label 26385*/ GIMT_Encode4(1970423), // Rule ID 61183 //
     /* 1970342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1970353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1970356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1970359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970365 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970388 */     // MIs[0] policy
     /* 1970388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970398 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1970401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970419 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970422 */     // GIR_Coverage, 61183,
     /* 1970422 */     GIR_EraseRootFromParent_Done,
     /* 1970423 */   // Label 26385: @1970423
     /* 1970423 */   GIM_Try, /*On fail goto*//*Label 26386*/ GIMT_Encode4(1970509), // Rule ID 61186 //
     /* 1970428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1970439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1970442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1970445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970451 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970474 */     // MIs[0] policy
     /* 1970474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1970487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970505 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970507 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970508 */     // GIR_Coverage, 61186,
     /* 1970508 */     GIR_EraseRootFromParent_Done,
     /* 1970509 */   // Label 26386: @1970509
     /* 1970509 */   GIM_Try, /*On fail goto*//*Label 26387*/ GIMT_Encode4(1970595), // Rule ID 61187 //
     /* 1970514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1970525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1970528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1970531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1970537 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970560 */     // MIs[0] policy
     /* 1970560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970570 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1970573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1970591 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970593 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970594 */     // GIR_Coverage, 61187,
     /* 1970594 */     GIR_EraseRootFromParent_Done,
     /* 1970595 */   // Label 26387: @1970595
     /* 1970595 */   GIM_Try, /*On fail goto*//*Label 26388*/ GIMT_Encode4(1970681), // Rule ID 61190 //
     /* 1970600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1970611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1970614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1970617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970623 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970646 */     // MIs[0] policy
     /* 1970646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970656 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1970659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970677 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970679 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970680 */     // GIR_Coverage, 61190,
     /* 1970680 */     GIR_EraseRootFromParent_Done,
     /* 1970681 */   // Label 26388: @1970681
     /* 1970681 */   GIM_Try, /*On fail goto*//*Label 26389*/ GIMT_Encode4(1970767), // Rule ID 61191 //
     /* 1970686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1970697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1970700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1970703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970709 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970732 */     // MIs[0] policy
     /* 1970732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970742 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF4_MASK),
     /* 1970745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970763 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970765 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970766 */     // GIR_Coverage, 61191,
     /* 1970766 */     GIR_EraseRootFromParent_Done,
     /* 1970767 */   // Label 26389: @1970767
     /* 1970767 */   GIM_Try, /*On fail goto*//*Label 26390*/ GIMT_Encode4(1970853), // Rule ID 61194 //
     /* 1970772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1970783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1970786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970795 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970818 */     // MIs[0] policy
     /* 1970818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970828 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1970828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1970831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970849 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970851 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970852 */     // GIR_Coverage, 61194,
     /* 1970852 */     GIR_EraseRootFromParent_Done,
     /* 1970853 */   // Label 26390: @1970853
     /* 1970853 */   GIM_Try, /*On fail goto*//*Label 26391*/ GIMT_Encode4(1970939), // Rule ID 61195 //
     /* 1970858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1970861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1970869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1970872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1970875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1970878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1970881 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1970884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970904 */     // MIs[0] policy
     /* 1970904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1970914 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1970914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1970917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1970919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1970921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1970923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1970925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1970927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1970932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1970935 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1970937 */     GIR_RootConstrainSelectedInstOperands,
     /* 1970938 */     // GIR_Coverage, 61195,
     /* 1970938 */     GIR_EraseRootFromParent_Done,
     /* 1970939 */   // Label 26391: @1970939
     /* 1970939 */   GIM_Try, /*On fail goto*//*Label 26392*/ GIMT_Encode4(1971025), // Rule ID 61198 //
     /* 1970944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1970947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1970952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1970955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1970958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1970961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1970964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1970967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1970970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1970974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1970982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1970986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1970990 */     // MIs[0] policy
     /* 1970990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1970993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971000 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1971003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971021 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971023 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971024 */     // GIR_Coverage, 61198,
     /* 1971024 */     GIR_EraseRootFromParent_Done,
     /* 1971025 */   // Label 26392: @1971025
     /* 1971025 */   GIM_Try, /*On fail goto*//*Label 26393*/ GIMT_Encode4(1971111), // Rule ID 61199 //
     /* 1971030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1971041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1971044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1971047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971053 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971076 */     // MIs[0] policy
     /* 1971076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971086 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_MF2_MASK),
     /* 1971089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971107 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971109 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971110 */     // GIR_Coverage, 61199,
     /* 1971110 */     GIR_EraseRootFromParent_Done,
     /* 1971111 */   // Label 26393: @1971111
     /* 1971111 */   GIM_Try, /*On fail goto*//*Label 26394*/ GIMT_Encode4(1971197), // Rule ID 61202 //
     /* 1971116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1971127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1971130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1971133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971139 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971162 */     // MIs[0] policy
     /* 1971162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971193 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971196 */     // GIR_Coverage, 61202,
     /* 1971196 */     GIR_EraseRootFromParent_Done,
     /* 1971197 */   // Label 26394: @1971197
     /* 1971197 */   GIM_Try, /*On fail goto*//*Label 26395*/ GIMT_Encode4(1971283), // Rule ID 61203 //
     /* 1971202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1971213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1971216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1971219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1971225 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971248 */     // MIs[0] policy
     /* 1971248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971258 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11090:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971279 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971281 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971282 */     // GIR_Coverage, 61203,
     /* 1971282 */     GIR_EraseRootFromParent_Done,
     /* 1971283 */   // Label 26395: @1971283
     /* 1971283 */   GIM_Try, /*On fail goto*//*Label 26396*/ GIMT_Encode4(1971369), // Rule ID 61206 //
     /* 1971288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1971305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971334 */     // MIs[0] policy
     /* 1971334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971344 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971365 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971367 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971368 */     // GIR_Coverage, 61206,
     /* 1971368 */     GIR_EraseRootFromParent_Done,
     /* 1971369 */   // Label 26396: @1971369
     /* 1971369 */   GIM_Try, /*On fail goto*//*Label 26397*/ GIMT_Encode4(1971455), // Rule ID 61207 //
     /* 1971374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1971385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1971388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1971391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1971397 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971420 */     // MIs[0] policy
     /* 1971420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971430 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11090:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1971451 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971453 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971454 */     // GIR_Coverage, 61207,
     /* 1971454 */     GIR_EraseRootFromParent_Done,
     /* 1971455 */   // Label 26397: @1971455
     /* 1971455 */   GIM_Try, /*On fail goto*//*Label 26398*/ GIMT_Encode4(1971541), // Rule ID 61210 //
     /* 1971460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1971471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1971474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1971477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971483 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971506 */     // MIs[0] policy
     /* 1971506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971537 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971539 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971540 */     // GIR_Coverage, 61210,
     /* 1971540 */     GIR_EraseRootFromParent_Done,
     /* 1971541 */   // Label 26398: @1971541
     /* 1971541 */   GIM_Try, /*On fail goto*//*Label 26399*/ GIMT_Encode4(1971627), // Rule ID 61211 //
     /* 1971546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1971557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1971560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1971563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1971569 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971592 */     // MIs[0] policy
     /* 1971592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971602 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11090:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1971623 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971625 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971626 */     // GIR_Coverage, 61211,
     /* 1971626 */     GIR_EraseRootFromParent_Done,
     /* 1971627 */   // Label 26399: @1971627
     /* 1971627 */   GIM_Try, /*On fail goto*//*Label 26400*/ GIMT_Encode4(1971713), // Rule ID 61214 //
     /* 1971632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971655 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971678 */     // MIs[0] policy
     /* 1971678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971688 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971709 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971711 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971712 */     // GIR_Coverage, 61214,
     /* 1971712 */     GIR_EraseRootFromParent_Done,
     /* 1971713 */   // Label 26400: @1971713
     /* 1971713 */   GIM_Try, /*On fail goto*//*Label 26401*/ GIMT_Encode4(1971799), // Rule ID 61215 //
     /* 1971718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1971729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1971732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1971735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1971741 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1971748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1971756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971764 */     // MIs[0] policy
     /* 1971764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11090:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M1_MASK),
     /* 1971777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1971795 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971798 */     // GIR_Coverage, 61215,
     /* 1971798 */     GIR_EraseRootFromParent_Done,
     /* 1971799 */   // Label 26401: @1971799
     /* 1971799 */   GIM_Try, /*On fail goto*//*Label 26402*/ GIMT_Encode4(1971885), // Rule ID 61218 //
     /* 1971804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1971815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1971818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1971821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1971827 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1971830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971850 */     // MIs[0] policy
     /* 1971850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971860 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1971860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1971863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971881 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971883 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971884 */     // GIR_Coverage, 61218,
     /* 1971884 */     GIR_EraseRootFromParent_Done,
     /* 1971885 */   // Label 26402: @1971885
     /* 1971885 */   GIM_Try, /*On fail goto*//*Label 26403*/ GIMT_Encode4(1971971), // Rule ID 61219 //
     /* 1971890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1971893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1971901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1971904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1971907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1971910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1971913 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1971916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1971920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1971928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1971932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1971936 */     // MIs[0] policy
     /* 1971936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1971939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1971946 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1971946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1971949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1971951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1971953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1971955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1971957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1971959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1971964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1971967 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1971969 */     GIR_RootConstrainSelectedInstOperands,
     /* 1971970 */     // GIR_Coverage, 61219,
     /* 1971970 */     GIR_EraseRootFromParent_Done,
     /* 1971971 */   // Label 26403: @1971971
     /* 1971971 */   GIM_Try, /*On fail goto*//*Label 26404*/ GIMT_Encode4(1972057), // Rule ID 61222 //
     /* 1971976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1971979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1971984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1971987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1971990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1971993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1971996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1971999 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972022 */     // MIs[0] policy
     /* 1972022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1972035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972053 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972055 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972056 */     // GIR_Coverage, 61222,
     /* 1972056 */     GIR_EraseRootFromParent_Done,
     /* 1972057 */   // Label 26404: @1972057
     /* 1972057 */   GIM_Try, /*On fail goto*//*Label 26405*/ GIMT_Encode4(1972143), // Rule ID 61223 //
     /* 1972062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1972073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1972076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1972079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972108 */     // MIs[0] policy
     /* 1972108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972118 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1972121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972139 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972141 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972142 */     // GIR_Coverage, 61223,
     /* 1972142 */     GIR_EraseRootFromParent_Done,
     /* 1972143 */   // Label 26405: @1972143
     /* 1972143 */   GIM_Try, /*On fail goto*//*Label 26406*/ GIMT_Encode4(1972229), // Rule ID 61226 //
     /* 1972148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1972159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1972162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1972165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1972171 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972194 */     // MIs[0] policy
     /* 1972194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972204 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1972207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972225 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972227 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972228 */     // GIR_Coverage, 61226,
     /* 1972228 */     GIR_EraseRootFromParent_Done,
     /* 1972229 */   // Label 26406: @1972229
     /* 1972229 */   GIM_Try, /*On fail goto*//*Label 26407*/ GIMT_Encode4(1972315), // Rule ID 61227 //
     /* 1972234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1972245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1972248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1972251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1972257 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972280 */     // MIs[0] policy
     /* 1972280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972290 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1972293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1972311 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972313 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972314 */     // GIR_Coverage, 61227,
     /* 1972314 */     GIR_EraseRootFromParent_Done,
     /* 1972315 */   // Label 26407: @1972315
     /* 1972315 */   GIM_Try, /*On fail goto*//*Label 26408*/ GIMT_Encode4(1972401), // Rule ID 61230 //
     /* 1972320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1972331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1972334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1972337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972366 */     // MIs[0] policy
     /* 1972366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972376 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1972379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972397 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972400 */     // GIR_Coverage, 61230,
     /* 1972400 */     GIR_EraseRootFromParent_Done,
     /* 1972401 */   // Label 26408: @1972401
     /* 1972401 */   GIM_Try, /*On fail goto*//*Label 26409*/ GIMT_Encode4(1972487), // Rule ID 61231 //
     /* 1972406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1972417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1972420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1972423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1972429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972452 */     // MIs[0] policy
     /* 1972452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1972465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972483 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972485 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972486 */     // GIR_Coverage, 61231,
     /* 1972486 */     GIR_EraseRootFromParent_Done,
     /* 1972487 */   // Label 26409: @1972487
     /* 1972487 */   GIM_Try, /*On fail goto*//*Label 26410*/ GIMT_Encode4(1972573), // Rule ID 61234 //
     /* 1972492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1972509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972515 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972538 */     // MIs[0] policy
     /* 1972538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972548 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1972551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972569 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972571 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972572 */     // GIR_Coverage, 61234,
     /* 1972572 */     GIR_EraseRootFromParent_Done,
     /* 1972573 */   // Label 26410: @1972573
     /* 1972573 */   GIM_Try, /*On fail goto*//*Label 26411*/ GIMT_Encode4(1972659), // Rule ID 61235 //
     /* 1972578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1972589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1972592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1972595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1972601 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1972608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1972616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972624 */     // MIs[0] policy
     /* 1972624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972634 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1972637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972655 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972657 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972658 */     // GIR_Coverage, 61235,
     /* 1972658 */     GIR_EraseRootFromParent_Done,
     /* 1972659 */   // Label 26411: @1972659
     /* 1972659 */   GIM_Try, /*On fail goto*//*Label 26412*/ GIMT_Encode4(1972745), // Rule ID 61238 //
     /* 1972664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1972681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972687 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972710 */     // MIs[0] policy
     /* 1972710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972720 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1972723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972741 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972743 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972744 */     // GIR_Coverage, 61238,
     /* 1972744 */     GIR_EraseRootFromParent_Done,
     /* 1972745 */   // Label 26412: @1972745
     /* 1972745 */   GIM_Try, /*On fail goto*//*Label 26413*/ GIMT_Encode4(1972831), // Rule ID 61239 //
     /* 1972750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1972761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1972764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1972767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1972773 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1972780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1972788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972796 */     // MIs[0] policy
     /* 1972796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972806 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1972809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1972827 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972829 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972830 */     // GIR_Coverage, 61239,
     /* 1972830 */     GIR_EraseRootFromParent_Done,
     /* 1972831 */   // Label 26413: @1972831
     /* 1972831 */   GIM_Try, /*On fail goto*//*Label 26414*/ GIMT_Encode4(1972917), // Rule ID 61242 //
     /* 1972836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1972839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1972853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1972856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972859 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1972862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972882 */     // MIs[0] policy
     /* 1972882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1972892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1972895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972913 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1972915 */     GIR_RootConstrainSelectedInstOperands,
     /* 1972916 */     // GIR_Coverage, 61242,
     /* 1972916 */     GIR_EraseRootFromParent_Done,
     /* 1972917 */   // Label 26414: @1972917
     /* 1972917 */   GIM_Try, /*On fail goto*//*Label 26415*/ GIMT_Encode4(1973003), // Rule ID 61243 //
     /* 1972922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1972925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1972930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1972933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1972936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1972939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1972942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1972945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1972948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1972952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1972960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1972964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1972968 */     // MIs[0] policy
     /* 1972968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1972971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1972978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1972978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1972981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1972983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1972985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1972987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1972989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1972991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1972996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1972999 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973001 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973002 */     // GIR_Coverage, 61243,
     /* 1973002 */     GIR_EraseRootFromParent_Done,
     /* 1973003 */   // Label 26415: @1973003
     /* 1973003 */   GIM_Try, /*On fail goto*//*Label 26416*/ GIMT_Encode4(1973089), // Rule ID 61246 //
     /* 1973008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1973019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1973022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973031 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973054 */     // MIs[0] policy
     /* 1973054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973064 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1973067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973085 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973087 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973088 */     // GIR_Coverage, 61246,
     /* 1973088 */     GIR_EraseRootFromParent_Done,
     /* 1973089 */   // Label 26416: @1973089
     /* 1973089 */   GIM_Try, /*On fail goto*//*Label 26417*/ GIMT_Encode4(1973175), // Rule ID 61247 //
     /* 1973094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1973105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1973108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1973111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973117 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973140 */     // MIs[0] policy
     /* 1973140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973150 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1973153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973171 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973173 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973174 */     // GIR_Coverage, 61247,
     /* 1973174 */     GIR_EraseRootFromParent_Done,
     /* 1973175 */   // Label 26417: @1973175
     /* 1973175 */   GIM_Try, /*On fail goto*//*Label 26418*/ GIMT_Encode4(1973261), // Rule ID 61250 //
     /* 1973180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1973197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973226 */     // MIs[0] policy
     /* 1973226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973236 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1973239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973257 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973259 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973260 */     // GIR_Coverage, 61250,
     /* 1973260 */     GIR_EraseRootFromParent_Done,
     /* 1973261 */   // Label 26418: @1973261
     /* 1973261 */   GIM_Try, /*On fail goto*//*Label 26419*/ GIMT_Encode4(1973347), // Rule ID 61251 //
     /* 1973266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1973277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1973280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1973283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1973289 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973312 */     // MIs[0] policy
     /* 1973312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973322 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1973325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1973343 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973345 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973346 */     // GIR_Coverage, 61251,
     /* 1973346 */     GIR_EraseRootFromParent_Done,
     /* 1973347 */   // Label 26419: @1973347
     /* 1973347 */   GIM_Try, /*On fail goto*//*Label 26420*/ GIMT_Encode4(1973433), // Rule ID 61254 //
     /* 1973352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1973369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973375 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973398 */     // MIs[0] policy
     /* 1973398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973408 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1973411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973429 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973431 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973432 */     // GIR_Coverage, 61254,
     /* 1973432 */     GIR_EraseRootFromParent_Done,
     /* 1973433 */   // Label 26420: @1973433
     /* 1973433 */   GIM_Try, /*On fail goto*//*Label 26421*/ GIMT_Encode4(1973519), // Rule ID 61255 //
     /* 1973438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1973449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1973452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1973455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1973461 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1973468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1973476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973484 */     // MIs[0] policy
     /* 1973484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973494 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11090:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M2_MASK),
     /* 1973497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973515 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973517 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973518 */     // GIR_Coverage, 61255,
     /* 1973518 */     GIR_EraseRootFromParent_Done,
     /* 1973519 */   // Label 26421: @1973519
     /* 1973519 */   GIM_Try, /*On fail goto*//*Label 26422*/ GIMT_Encode4(1973605), // Rule ID 61258 //
     /* 1973524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973547 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973570 */     // MIs[0] policy
     /* 1973570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973580 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1973583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973601 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973603 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973604 */     // GIR_Coverage, 61258,
     /* 1973604 */     GIR_EraseRootFromParent_Done,
     /* 1973605 */   // Label 26422: @1973605
     /* 1973605 */   GIM_Try, /*On fail goto*//*Label 26423*/ GIMT_Encode4(1973691), // Rule ID 61259 //
     /* 1973610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1973621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1973624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1973627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1973633 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1973640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1973648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973656 */     // MIs[0] policy
     /* 1973656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973666 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11090:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M4_MASK),
     /* 1973669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973687 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973689 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973690 */     // GIR_Coverage, 61259,
     /* 1973690 */     GIR_EraseRootFromParent_Done,
     /* 1973691 */   // Label 26423: @1973691
     /* 1973691 */   GIM_Try, /*On fail goto*//*Label 26424*/ GIMT_Encode4(1973777), // Rule ID 61262 //
     /* 1973696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1973716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973719 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973742 */     // MIs[0] policy
     /* 1973742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973752 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1973755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973773 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973775 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973776 */     // GIR_Coverage, 61262,
     /* 1973776 */     GIR_EraseRootFromParent_Done,
     /* 1973777 */   // Label 26424: @1973777
     /* 1973777 */   GIM_Try, /*On fail goto*//*Label 26425*/ GIMT_Encode4(1973863), // Rule ID 61263 //
     /* 1973782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vandn_mask),
     /* 1973790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1973793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1973796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1973799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1973802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1973805 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1973812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1973820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1973824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973828 */     // MIs[0] policy
     /* 1973828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973838 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11090:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVANDN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1973838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVANDN_VX_M8_MASK),
     /* 1973841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1973859 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973861 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973862 */     // GIR_Coverage, 61263,
     /* 1973862 */     GIR_EraseRootFromParent_Done,
     /* 1973863 */   // Label 26425: @1973863
     /* 1973863 */   GIM_Try, /*On fail goto*//*Label 26426*/ GIMT_Encode4(1973949), // Rule ID 61442 //
     /* 1973868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1973871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1973876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973891 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1973894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1973914 */     // MIs[0] policy
     /* 1973914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1973917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1973924 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1973924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1973927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1973929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1973931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1973933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1973935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1973937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1973942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1973945 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1973947 */     GIR_RootConstrainSelectedInstOperands,
     /* 1973948 */     // GIR_Coverage, 61442,
     /* 1973948 */     GIR_EraseRootFromParent_Done,
     /* 1973949 */   // Label 26426: @1973949
     /* 1973949 */   GIM_Try, /*On fail goto*//*Label 26427*/ GIMT_Encode4(1974035), // Rule ID 61443 //
     /* 1973954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1973957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1973962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1973965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1973968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1973971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1973974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1973977 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1973980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1973984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1973996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974000 */     // MIs[0] policy
     /* 1974000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974010 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8_MASK),
     /* 1974013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974031 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974033 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974034 */     // GIR_Coverage, 61443,
     /* 1974034 */     GIR_EraseRootFromParent_Done,
     /* 1974035 */   // Label 26427: @1974035
     /* 1974035 */   GIM_Try, /*On fail goto*//*Label 26428*/ GIMT_Encode4(1974121), // Rule ID 61446 //
     /* 1974040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1974051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1974054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1974057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1974060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974063 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974086 */     // MIs[0] policy
     /* 1974086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974096 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1974099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974117 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974119 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974120 */     // GIR_Coverage, 61446,
     /* 1974120 */     GIR_EraseRootFromParent_Done,
     /* 1974121 */   // Label 26428: @1974121
     /* 1974121 */   GIM_Try, /*On fail goto*//*Label 26429*/ GIMT_Encode4(1974207), // Rule ID 61447 //
     /* 1974126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1974137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1974140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1974143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1974146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974149 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974172 */     // MIs[0] policy
     /* 1974172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1974185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974203 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974205 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974206 */     // GIR_Coverage, 61447,
     /* 1974206 */     GIR_EraseRootFromParent_Done,
     /* 1974207 */   // Label 26429: @1974207
     /* 1974207 */   GIM_Try, /*On fail goto*//*Label 26430*/ GIMT_Encode4(1974293), // Rule ID 61450 //
     /* 1974212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1974223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1974226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1974229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1974232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974235 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974258 */     // MIs[0] policy
     /* 1974258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974268 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974289 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974291 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974292 */     // GIR_Coverage, 61450,
     /* 1974292 */     GIR_EraseRootFromParent_Done,
     /* 1974293 */   // Label 26430: @1974293
     /* 1974293 */   GIM_Try, /*On fail goto*//*Label 26431*/ GIMT_Encode4(1974379), // Rule ID 61451 //
     /* 1974298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1974309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1974312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1974315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1974318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1974321 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974344 */     // MIs[0] policy
     /* 1974344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974354 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974375 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974377 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974378 */     // GIR_Coverage, 61451,
     /* 1974378 */     GIR_EraseRootFromParent_Done,
     /* 1974379 */   // Label 26431: @1974379
     /* 1974379 */   GIM_Try, /*On fail goto*//*Label 26432*/ GIMT_Encode4(1974465), // Rule ID 61454 //
     /* 1974384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1974395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1974398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1974401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1974404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974407 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974430 */     // MIs[0] policy
     /* 1974430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974440 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1974443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974461 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974463 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974464 */     // GIR_Coverage, 61454,
     /* 1974464 */     GIR_EraseRootFromParent_Done,
     /* 1974465 */   // Label 26432: @1974465
     /* 1974465 */   GIM_Try, /*On fail goto*//*Label 26433*/ GIMT_Encode4(1974551), // Rule ID 61455 //
     /* 1974470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1974481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1974484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1974487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1974490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974493 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974516 */     // MIs[0] policy
     /* 1974516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974526 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4_MASK),
     /* 1974529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974547 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974549 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974550 */     // GIR_Coverage, 61455,
     /* 1974550 */     GIR_EraseRootFromParent_Done,
     /* 1974551 */   // Label 26433: @1974551
     /* 1974551 */   GIM_Try, /*On fail goto*//*Label 26434*/ GIMT_Encode4(1974637), // Rule ID 61458 //
     /* 1974556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974579 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974602 */     // MIs[0] policy
     /* 1974602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974612 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974633 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974635 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974636 */     // GIR_Coverage, 61458,
     /* 1974636 */     GIR_EraseRootFromParent_Done,
     /* 1974637 */   // Label 26434: @1974637
     /* 1974637 */   GIM_Try, /*On fail goto*//*Label 26435*/ GIMT_Encode4(1974723), // Rule ID 61459 //
     /* 1974642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1974653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1974656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1974659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1974662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1974665 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974688 */     // MIs[0] policy
     /* 1974688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974698 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1974719 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974721 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974722 */     // GIR_Coverage, 61459,
     /* 1974722 */     GIR_EraseRootFromParent_Done,
     /* 1974723 */   // Label 26435: @1974723
     /* 1974723 */   GIM_Try, /*On fail goto*//*Label 26436*/ GIMT_Encode4(1974809), // Rule ID 61462 //
     /* 1974728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974751 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974774 */     // MIs[0] policy
     /* 1974774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974784 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974805 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974807 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974808 */     // GIR_Coverage, 61462,
     /* 1974808 */     GIR_EraseRootFromParent_Done,
     /* 1974809 */   // Label 26436: @1974809
     /* 1974809 */   GIM_Try, /*On fail goto*//*Label 26437*/ GIMT_Encode4(1974895), // Rule ID 61463 //
     /* 1974814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1974825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1974828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1974831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1974834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1974837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1974840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974860 */     // MIs[0] policy
     /* 1974860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974870 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1974870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2_MASK),
     /* 1974873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1974891 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974893 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974894 */     // GIR_Coverage, 61463,
     /* 1974894 */     GIR_EraseRootFromParent_Done,
     /* 1974895 */   // Label 26437: @1974895
     /* 1974895 */   GIM_Try, /*On fail goto*//*Label 26438*/ GIMT_Encode4(1974981), // Rule ID 61466 //
     /* 1974900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1974903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1974914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1974917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1974920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1974923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1974926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1974930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1974942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1974946 */     // MIs[0] policy
     /* 1974946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1974949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1974956 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1974956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1974959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1974961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1974963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1974965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1974967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1974969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1974974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1974977 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1974979 */     GIR_RootConstrainSelectedInstOperands,
     /* 1974980 */     // GIR_Coverage, 61466,
     /* 1974980 */     GIR_EraseRootFromParent_Done,
     /* 1974981 */   // Label 26438: @1974981
     /* 1974981 */   GIM_Try, /*On fail goto*//*Label 26439*/ GIMT_Encode4(1975067), // Rule ID 61467 //
     /* 1974986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1974989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1974994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1974997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1975000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1975003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1975006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1975009 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975032 */     // MIs[0] policy
     /* 1975032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975042 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975063 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975065 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975066 */     // GIR_Coverage, 61467,
     /* 1975066 */     GIR_EraseRootFromParent_Done,
     /* 1975067 */   // Label 26439: @1975067
     /* 1975067 */   GIM_Try, /*On fail goto*//*Label 26440*/ GIMT_Encode4(1975153), // Rule ID 61470 //
     /* 1975072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1975083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1975086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1975089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1975092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975095 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975118 */     // MIs[0] policy
     /* 1975118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975128 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975149 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975151 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975152 */     // GIR_Coverage, 61470,
     /* 1975152 */     GIR_EraseRootFromParent_Done,
     /* 1975153 */   // Label 26440: @1975153
     /* 1975153 */   GIM_Try, /*On fail goto*//*Label 26441*/ GIMT_Encode4(1975239), // Rule ID 61471 //
     /* 1975158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1975169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1975172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1975175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1975178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1975181 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975204 */     // MIs[0] policy
     /* 1975204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975214 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1975235 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975237 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975238 */     // GIR_Coverage, 61471,
     /* 1975238 */     GIR_EraseRootFromParent_Done,
     /* 1975239 */   // Label 26441: @1975239
     /* 1975239 */   GIM_Try, /*On fail goto*//*Label 26442*/ GIMT_Encode4(1975325), // Rule ID 61474 //
     /* 1975244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1975255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1975258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1975261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1975264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975267 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975290 */     // MIs[0] policy
     /* 1975290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975300 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975321 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975323 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975324 */     // GIR_Coverage, 61474,
     /* 1975324 */     GIR_EraseRootFromParent_Done,
     /* 1975325 */   // Label 26442: @1975325
     /* 1975325 */   GIM_Try, /*On fail goto*//*Label 26443*/ GIMT_Encode4(1975411), // Rule ID 61475 //
     /* 1975330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1975341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1975344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1975347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1975350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1975353 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975376 */     // MIs[0] policy
     /* 1975376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975386 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1975407 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975409 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975410 */     // GIR_Coverage, 61475,
     /* 1975410 */     GIR_EraseRootFromParent_Done,
     /* 1975411 */   // Label 26443: @1975411
     /* 1975411 */   GIM_Try, /*On fail goto*//*Label 26444*/ GIMT_Encode4(1975497), // Rule ID 61478 //
     /* 1975416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975439 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975462 */     // MIs[0] policy
     /* 1975462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975472 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975493 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975495 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975496 */     // GIR_Coverage, 61478,
     /* 1975496 */     GIR_EraseRootFromParent_Done,
     /* 1975497 */   // Label 26444: @1975497
     /* 1975497 */   GIM_Try, /*On fail goto*//*Label 26445*/ GIMT_Encode4(1975583), // Rule ID 61479 //
     /* 1975502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1975513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1975516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1975519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1975522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1975525 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1975532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1975544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975548 */     // MIs[0] policy
     /* 1975548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975558 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1_MASK),
     /* 1975561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1975579 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975581 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975582 */     // GIR_Coverage, 61479,
     /* 1975582 */     GIR_EraseRootFromParent_Done,
     /* 1975583 */   // Label 26445: @1975583
     /* 1975583 */   GIM_Try, /*On fail goto*//*Label 26446*/ GIMT_Encode4(1975669), // Rule ID 61482 //
     /* 1975588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975611 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975634 */     // MIs[0] policy
     /* 1975634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1975647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975665 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975667 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975668 */     // GIR_Coverage, 61482,
     /* 1975668 */     GIR_EraseRootFromParent_Done,
     /* 1975669 */   // Label 26446: @1975669
     /* 1975669 */   GIM_Try, /*On fail goto*//*Label 26447*/ GIMT_Encode4(1975755), // Rule ID 61483 //
     /* 1975674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1975685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1975688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1975691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1975694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1975697 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1975704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1975716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975720 */     // MIs[0] policy
     /* 1975720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1975733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975751 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975753 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975754 */     // GIR_Coverage, 61483,
     /* 1975754 */     GIR_EraseRootFromParent_Done,
     /* 1975755 */   // Label 26447: @1975755
     /* 1975755 */   GIM_Try, /*On fail goto*//*Label 26448*/ GIMT_Encode4(1975841), // Rule ID 61486 //
     /* 1975760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975806 */     // MIs[0] policy
     /* 1975806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975816 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1975819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975837 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975839 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975840 */     // GIR_Coverage, 61486,
     /* 1975840 */     GIR_EraseRootFromParent_Done,
     /* 1975841 */   // Label 26448: @1975841
     /* 1975841 */   GIM_Try, /*On fail goto*//*Label 26449*/ GIMT_Encode4(1975927), // Rule ID 61487 //
     /* 1975846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1975849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1975857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1975860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1975863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1975866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1975869 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1975872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1975876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1975888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975892 */     // MIs[0] policy
     /* 1975892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975902 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1975902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1975905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1975915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1975920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1975923 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1975925 */     GIR_RootConstrainSelectedInstOperands,
     /* 1975926 */     // GIR_Coverage, 61487,
     /* 1975926 */     GIR_EraseRootFromParent_Done,
     /* 1975927 */   // Label 26449: @1975927
     /* 1975927 */   GIM_Try, /*On fail goto*//*Label 26450*/ GIMT_Encode4(1976013), // Rule ID 61490 //
     /* 1975932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1975935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1975940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1975943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1975946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1975949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1975952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1975955 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1975958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1975962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1975974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1975978 */     // MIs[0] policy
     /* 1975978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1975981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1975988 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1975988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1975991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1975993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1975995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1975997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1975999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976009 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976011 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976012 */     // GIR_Coverage, 61490,
     /* 1976012 */     GIR_EraseRootFromParent_Done,
     /* 1976013 */   // Label 26450: @1976013
     /* 1976013 */   GIM_Try, /*On fail goto*//*Label 26451*/ GIMT_Encode4(1976099), // Rule ID 61491 //
     /* 1976018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1976029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1976032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1976035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1976038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1976041 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976064 */     // MIs[0] policy
     /* 1976064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976074 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1976077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1976095 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976097 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976098 */     // GIR_Coverage, 61491,
     /* 1976098 */     GIR_EraseRootFromParent_Done,
     /* 1976099 */   // Label 26451: @1976099
     /* 1976099 */   GIM_Try, /*On fail goto*//*Label 26452*/ GIMT_Encode4(1976185), // Rule ID 61494 //
     /* 1976104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1976115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1976118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1976121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1976124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976150 */     // MIs[0] policy
     /* 1976150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976160 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1976163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976181 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976183 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976184 */     // GIR_Coverage, 61494,
     /* 1976184 */     GIR_EraseRootFromParent_Done,
     /* 1976185 */   // Label 26452: @1976185
     /* 1976185 */   GIM_Try, /*On fail goto*//*Label 26453*/ GIMT_Encode4(1976271), // Rule ID 61495 //
     /* 1976190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1976201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1976204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1976207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1976210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976236 */     // MIs[0] policy
     /* 1976236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976246 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1976249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976267 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976269 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976270 */     // GIR_Coverage, 61495,
     /* 1976270 */     GIR_EraseRootFromParent_Done,
     /* 1976271 */   // Label 26453: @1976271
     /* 1976271 */   GIM_Try, /*On fail goto*//*Label 26454*/ GIMT_Encode4(1976357), // Rule ID 61498 //
     /* 1976276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1976296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976322 */     // MIs[0] policy
     /* 1976322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976332 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1976335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976353 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976355 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976356 */     // GIR_Coverage, 61498,
     /* 1976356 */     GIR_EraseRootFromParent_Done,
     /* 1976357 */   // Label 26454: @1976357
     /* 1976357 */   GIM_Try, /*On fail goto*//*Label 26455*/ GIMT_Encode4(1976443), // Rule ID 61499 //
     /* 1976362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1976373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1976376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1976379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1976382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976385 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976408 */     // MIs[0] policy
     /* 1976408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976418 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1976421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976439 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976442 */     // GIR_Coverage, 61499,
     /* 1976442 */     GIR_EraseRootFromParent_Done,
     /* 1976443 */   // Label 26455: @1976443
     /* 1976443 */   GIM_Try, /*On fail goto*//*Label 26456*/ GIMT_Encode4(1976529), // Rule ID 61502 //
     /* 1976448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1976468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976471 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976494 */     // MIs[0] policy
     /* 1976494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976504 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1976507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976525 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976527 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976528 */     // GIR_Coverage, 61502,
     /* 1976528 */     GIR_EraseRootFromParent_Done,
     /* 1976529 */   // Label 26456: @1976529
     /* 1976529 */   GIM_Try, /*On fail goto*//*Label 26457*/ GIMT_Encode4(1976615), // Rule ID 61503 //
     /* 1976534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1976545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1976548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1976551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1976554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1976557 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976580 */     // MIs[0] policy
     /* 1976580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976590 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1976593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1976611 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976613 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976614 */     // GIR_Coverage, 61503,
     /* 1976614 */     GIR_EraseRootFromParent_Done,
     /* 1976615 */   // Label 26457: @1976615
     /* 1976615 */   GIM_Try, /*On fail goto*//*Label 26458*/ GIMT_Encode4(1976701), // Rule ID 61506 //
     /* 1976620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976643 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976666 */     // MIs[0] policy
     /* 1976666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976676 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1976679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976697 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976699 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976700 */     // GIR_Coverage, 61506,
     /* 1976700 */     GIR_EraseRootFromParent_Done,
     /* 1976701 */   // Label 26458: @1976701
     /* 1976701 */   GIM_Try, /*On fail goto*//*Label 26459*/ GIMT_Encode4(1976787), // Rule ID 61507 //
     /* 1976706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1976717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1976720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1976723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1976726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1976729 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1976736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1976748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976752 */     // MIs[0] policy
     /* 1976752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1976765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976783 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976785 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976786 */     // GIR_Coverage, 61507,
     /* 1976786 */     GIR_EraseRootFromParent_Done,
     /* 1976787 */   // Label 26459: @1976787
     /* 1976787 */   GIM_Try, /*On fail goto*//*Label 26460*/ GIMT_Encode4(1976873), // Rule ID 61510 //
     /* 1976792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976815 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976838 */     // MIs[0] policy
     /* 1976838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976848 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1976848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1976851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976869 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976871 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976872 */     // GIR_Coverage, 61510,
     /* 1976872 */     GIR_EraseRootFromParent_Done,
     /* 1976873 */   // Label 26460: @1976873
     /* 1976873 */   GIM_Try, /*On fail goto*//*Label 26461*/ GIMT_Encode4(1976959), // Rule ID 61511 //
     /* 1976878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1976881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1976889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1976892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1976895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1976898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1976901 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1976904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1976908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1976920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1976924 */     // MIs[0] policy
     /* 1976924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1976927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1976934 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1976934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1976937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1976939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1976941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1976943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1976945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1976947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1976952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1976955 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1976957 */     GIR_RootConstrainSelectedInstOperands,
     /* 1976958 */     // GIR_Coverage, 61511,
     /* 1976958 */     GIR_EraseRootFromParent_Done,
     /* 1976959 */   // Label 26461: @1976959
     /* 1976959 */   GIM_Try, /*On fail goto*//*Label 26462*/ GIMT_Encode4(1977045), // Rule ID 61514 //
     /* 1976964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1976967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1976972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1976975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1976978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1976981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1976984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1976987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1976990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1976994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1976998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977010 */     // MIs[0] policy
     /* 1977010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977020 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1977023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977041 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977044 */     // GIR_Coverage, 61514,
     /* 1977044 */     GIR_EraseRootFromParent_Done,
     /* 1977045 */   // Label 26462: @1977045
     /* 1977045 */   GIM_Try, /*On fail goto*//*Label 26463*/ GIMT_Encode4(1977131), // Rule ID 61515 //
     /* 1977050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1977061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1977064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1977067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1977070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1977073 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977096 */     // MIs[0] policy
     /* 1977096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977106 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1977109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1977127 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977129 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977130 */     // GIR_Coverage, 61515,
     /* 1977130 */     GIR_EraseRootFromParent_Done,
     /* 1977131 */   // Label 26463: @1977131
     /* 1977131 */   GIM_Try, /*On fail goto*//*Label 26464*/ GIMT_Encode4(1977217), // Rule ID 61518 //
     /* 1977136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1977147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1977150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1977153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1977156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977182 */     // MIs[0] policy
     /* 1977182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1977195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977213 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977215 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977216 */     // GIR_Coverage, 61518,
     /* 1977216 */     GIR_EraseRootFromParent_Done,
     /* 1977217 */   // Label 26464: @1977217
     /* 1977217 */   GIM_Try, /*On fail goto*//*Label 26465*/ GIMT_Encode4(1977303), // Rule ID 61519 //
     /* 1977222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1977233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1977236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1977239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1977242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977245 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1977252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1977264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977268 */     // MIs[0] policy
     /* 1977268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977278 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2_MASK),
     /* 1977281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977299 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977301 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977302 */     // GIR_Coverage, 61519,
     /* 1977302 */     GIR_EraseRootFromParent_Done,
     /* 1977303 */   // Label 26465: @1977303
     /* 1977303 */   GIM_Try, /*On fail goto*//*Label 26466*/ GIMT_Encode4(1977389), // Rule ID 61522 //
     /* 1977308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1977328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977331 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977354 */     // MIs[0] policy
     /* 1977354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977364 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1977367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977385 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977387 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977388 */     // GIR_Coverage, 61522,
     /* 1977388 */     GIR_EraseRootFromParent_Done,
     /* 1977389 */   // Label 26466: @1977389
     /* 1977389 */   GIM_Try, /*On fail goto*//*Label 26467*/ GIMT_Encode4(1977475), // Rule ID 61523 //
     /* 1977394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1977405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1977408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1977411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1977414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1977417 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1977424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1977436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977440 */     // MIs[0] policy
     /* 1977440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977450 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4_MASK),
     /* 1977453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977471 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977473 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977474 */     // GIR_Coverage, 61523,
     /* 1977474 */     GIR_EraseRootFromParent_Done,
     /* 1977475 */   // Label 26467: @1977475
     /* 1977475 */   GIM_Try, /*On fail goto*//*Label 26468*/ GIMT_Encode4(1977561), // Rule ID 61526 //
     /* 1977480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1977500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977503 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977526 */     // MIs[0] policy
     /* 1977526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977536 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1977539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977557 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977559 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977560 */     // GIR_Coverage, 61526,
     /* 1977560 */     GIR_EraseRootFromParent_Done,
     /* 1977561 */   // Label 26468: @1977561
     /* 1977561 */   GIM_Try, /*On fail goto*//*Label 26469*/ GIMT_Encode4(1977647), // Rule ID 61527 //
     /* 1977566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1977577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1977580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1977583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1977586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1977589 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1977596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1977608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977612 */     // MIs[0] policy
     /* 1977612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977622 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8_MASK),
     /* 1977625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1977643 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977646 */     // GIR_Coverage, 61527,
     /* 1977646 */     GIR_EraseRootFromParent_Done,
     /* 1977647 */   // Label 26469: @1977647
     /* 1977647 */   GIM_Try, /*On fail goto*//*Label 26470*/ GIMT_Encode4(1977733), // Rule ID 61530 //
     /* 1977652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977675 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977698 */     // MIs[0] policy
     /* 1977698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977708 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1977711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977729 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977731 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977732 */     // GIR_Coverage, 61530,
     /* 1977732 */     GIR_EraseRootFromParent_Done,
     /* 1977733 */   // Label 26470: @1977733
     /* 1977733 */   GIM_Try, /*On fail goto*//*Label 26471*/ GIMT_Encode4(1977819), // Rule ID 61531 //
     /* 1977738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1977749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1977752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1977755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1977761 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977784 */     // MIs[0] policy
     /* 1977784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977794 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF8_MASK),
     /* 1977797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977815 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977817 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977818 */     // GIR_Coverage, 61531,
     /* 1977818 */     GIR_EraseRootFromParent_Done,
     /* 1977819 */   // Label 26471: @1977819
     /* 1977819 */   GIM_Try, /*On fail goto*//*Label 26472*/ GIMT_Encode4(1977905), // Rule ID 61534 //
     /* 1977824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1977844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977847 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1977850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977870 */     // MIs[0] policy
     /* 1977870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977880 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1977880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1977883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977901 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977903 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977904 */     // GIR_Coverage, 61534,
     /* 1977904 */     GIR_EraseRootFromParent_Done,
     /* 1977905 */   // Label 26472: @1977905
     /* 1977905 */   GIM_Try, /*On fail goto*//*Label 26473*/ GIMT_Encode4(1977991), // Rule ID 61535 //
     /* 1977910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1977913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1977918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1977921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1977924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1977927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1977930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1977933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1977936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1977940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1977948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1977952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1977956 */     // MIs[0] policy
     /* 1977956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1977959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1977966 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1977966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1977969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1977971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1977973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1977975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1977977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1977979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1977984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1977987 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1977989 */     GIR_RootConstrainSelectedInstOperands,
     /* 1977990 */     // GIR_Coverage, 61535,
     /* 1977990 */     GIR_EraseRootFromParent_Done,
     /* 1977991 */   // Label 26473: @1977991
     /* 1977991 */   GIM_Try, /*On fail goto*//*Label 26474*/ GIMT_Encode4(1978077), // Rule ID 61538 //
     /* 1977996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1977999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1978007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1978010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1978013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978019 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978042 */     // MIs[0] policy
     /* 1978042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978052 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978073 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978075 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978076 */     // GIR_Coverage, 61538,
     /* 1978076 */     GIR_EraseRootFromParent_Done,
     /* 1978077 */   // Label 26474: @1978077
     /* 1978077 */   GIM_Try, /*On fail goto*//*Label 26475*/ GIMT_Encode4(1978163), // Rule ID 61539 //
     /* 1978082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1978093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1978096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1978099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978105 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978128 */     // MIs[0] policy
     /* 1978128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978138 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978159 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978161 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978162 */     // GIR_Coverage, 61539,
     /* 1978162 */     GIR_EraseRootFromParent_Done,
     /* 1978163 */   // Label 26475: @1978163
     /* 1978163 */   GIM_Try, /*On fail goto*//*Label 26476*/ GIMT_Encode4(1978249), // Rule ID 61542 //
     /* 1978168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978191 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978214 */     // MIs[0] policy
     /* 1978214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978224 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1978227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978245 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978247 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978248 */     // GIR_Coverage, 61542,
     /* 1978248 */     GIR_EraseRootFromParent_Done,
     /* 1978249 */   // Label 26476: @1978249
     /* 1978249 */   GIM_Try, /*On fail goto*//*Label 26477*/ GIMT_Encode4(1978335), // Rule ID 61543 //
     /* 1978254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1978265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1978268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1978271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978277 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978300 */     // MIs[0] policy
     /* 1978300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978310 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF4_MASK),
     /* 1978313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978331 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978333 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978334 */     // GIR_Coverage, 61543,
     /* 1978334 */     GIR_EraseRootFromParent_Done,
     /* 1978335 */   // Label 26477: @1978335
     /* 1978335 */   GIM_Try, /*On fail goto*//*Label 26478*/ GIMT_Encode4(1978421), // Rule ID 61546 //
     /* 1978340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1978351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1978354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1978357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978363 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978386 */     // MIs[0] policy
     /* 1978386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978417 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978419 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978420 */     // GIR_Coverage, 61546,
     /* 1978420 */     GIR_EraseRootFromParent_Done,
     /* 1978421 */   // Label 26478: @1978421
     /* 1978421 */   GIM_Try, /*On fail goto*//*Label 26479*/ GIMT_Encode4(1978507), // Rule ID 61547 //
     /* 1978426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1978437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1978440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1978443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1978449 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978472 */     // MIs[0] policy
     /* 1978472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978482 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978503 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978505 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978506 */     // GIR_Coverage, 61547,
     /* 1978506 */     GIR_EraseRootFromParent_Done,
     /* 1978507 */   // Label 26479: @1978507
     /* 1978507 */   GIM_Try, /*On fail goto*//*Label 26480*/ GIMT_Encode4(1978593), // Rule ID 61550 //
     /* 1978512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978535 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978558 */     // MIs[0] policy
     /* 1978558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978568 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978589 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978591 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978592 */     // GIR_Coverage, 61550,
     /* 1978592 */     GIR_EraseRootFromParent_Done,
     /* 1978593 */   // Label 26480: @1978593
     /* 1978593 */   GIM_Try, /*On fail goto*//*Label 26481*/ GIMT_Encode4(1978679), // Rule ID 61551 //
     /* 1978598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1978609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1978612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1978615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1978621 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978644 */     // MIs[0] policy
     /* 1978644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978654 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_MF2_MASK),
     /* 1978657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1978675 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978677 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978678 */     // GIR_Coverage, 61551,
     /* 1978678 */     GIR_EraseRootFromParent_Done,
     /* 1978679 */   // Label 26481: @1978679
     /* 1978679 */   GIM_Try, /*On fail goto*//*Label 26482*/ GIMT_Encode4(1978765), // Rule ID 61554 //
     /* 1978684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978707 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978730 */     // MIs[0] policy
     /* 1978730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978740 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1978743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978761 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978763 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978764 */     // GIR_Coverage, 61554,
     /* 1978764 */     GIR_EraseRootFromParent_Done,
     /* 1978765 */   // Label 26482: @1978765
     /* 1978765 */   GIM_Try, /*On fail goto*//*Label 26483*/ GIMT_Encode4(1978851), // Rule ID 61555 //
     /* 1978770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1978781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1978784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1978787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1978793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978816 */     // MIs[0] policy
     /* 1978816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978826 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11457:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1978829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1978847 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978849 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978850 */     // GIR_Coverage, 61555,
     /* 1978850 */     GIR_EraseRootFromParent_Done,
     /* 1978851 */   // Label 26483: @1978851
     /* 1978851 */   GIM_Try, /*On fail goto*//*Label 26484*/ GIMT_Encode4(1978937), // Rule ID 61558 //
     /* 1978856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1978859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1978876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978879 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1978882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978902 */     // MIs[0] policy
     /* 1978902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978912 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1978912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1978915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1978917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1978919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1978921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1978923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1978925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1978930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1978933 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1978935 */     GIR_RootConstrainSelectedInstOperands,
     /* 1978936 */     // GIR_Coverage, 61558,
     /* 1978936 */     GIR_EraseRootFromParent_Done,
     /* 1978937 */   // Label 26484: @1978937
     /* 1978937 */   GIM_Try, /*On fail goto*//*Label 26485*/ GIMT_Encode4(1979023), // Rule ID 61559 //
     /* 1978942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1978945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1978950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1978953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1978956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1978959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1978962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1978965 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1978968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1978972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1978980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1978984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1978988 */     // MIs[0] policy
     /* 1978988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1978991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1978998 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11457:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1978998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1979001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979019 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979021 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979022 */     // GIR_Coverage, 61559,
     /* 1979022 */     GIR_EraseRootFromParent_Done,
     /* 1979023 */   // Label 26485: @1979023
     /* 1979023 */   GIM_Try, /*On fail goto*//*Label 26486*/ GIMT_Encode4(1979109), // Rule ID 61562 //
     /* 1979028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1979039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1979042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1979045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979051 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979074 */     // MIs[0] policy
     /* 1979074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979084 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1979087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979105 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979107 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979108 */     // GIR_Coverage, 61562,
     /* 1979108 */     GIR_EraseRootFromParent_Done,
     /* 1979109 */   // Label 26486: @1979109
     /* 1979109 */   GIM_Try, /*On fail goto*//*Label 26487*/ GIMT_Encode4(1979195), // Rule ID 61563 //
     /* 1979114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1979125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1979128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1979131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1979137 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979160 */     // MIs[0] policy
     /* 1979160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979170 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11457:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1979173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979175 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1979191 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979193 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979194 */     // GIR_Coverage, 61563,
     /* 1979194 */     GIR_EraseRootFromParent_Done,
     /* 1979195 */   // Label 26487: @1979195
     /* 1979195 */   GIM_Try, /*On fail goto*//*Label 26488*/ GIMT_Encode4(1979281), // Rule ID 61566 //
     /* 1979200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979246 */     // MIs[0] policy
     /* 1979246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979256 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1979259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979277 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979279 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979280 */     // GIR_Coverage, 61566,
     /* 1979280 */     GIR_EraseRootFromParent_Done,
     /* 1979281 */   // Label 26488: @1979281
     /* 1979281 */   GIM_Try, /*On fail goto*//*Label 26489*/ GIMT_Encode4(1979367), // Rule ID 61567 //
     /* 1979286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1979297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1979300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1979303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1979309 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1979316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1979324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979332 */     // MIs[0] policy
     /* 1979332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979342 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11457:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M1_MASK),
     /* 1979345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1979363 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979365 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979366 */     // GIR_Coverage, 61567,
     /* 1979366 */     GIR_EraseRootFromParent_Done,
     /* 1979367 */   // Label 26489: @1979367
     /* 1979367 */   GIM_Try, /*On fail goto*//*Label 26490*/ GIMT_Encode4(1979453), // Rule ID 61570 //
     /* 1979372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1979383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1979386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1979389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979395 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979418 */     // MIs[0] policy
     /* 1979418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1979431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979449 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979451 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979452 */     // GIR_Coverage, 61570,
     /* 1979452 */     GIR_EraseRootFromParent_Done,
     /* 1979453 */   // Label 26490: @1979453
     /* 1979453 */   GIM_Try, /*On fail goto*//*Label 26491*/ GIMT_Encode4(1979539), // Rule ID 61571 //
     /* 1979458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1979469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1979472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1979475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1979481 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979504 */     // MIs[0] policy
     /* 1979504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1979517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979535 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979537 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979538 */     // GIR_Coverage, 61571,
     /* 1979538 */     GIR_EraseRootFromParent_Done,
     /* 1979539 */   // Label 26491: @1979539
     /* 1979539 */   GIM_Try, /*On fail goto*//*Label 26492*/ GIMT_Encode4(1979625), // Rule ID 61574 //
     /* 1979544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979567 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979590 */     // MIs[0] policy
     /* 1979590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979600 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1979603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979621 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979623 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979624 */     // GIR_Coverage, 61574,
     /* 1979624 */     GIR_EraseRootFromParent_Done,
     /* 1979625 */   // Label 26492: @1979625
     /* 1979625 */   GIM_Try, /*On fail goto*//*Label 26493*/ GIMT_Encode4(1979711), // Rule ID 61575 //
     /* 1979630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1979641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1979644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1979647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1979653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1979660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1979668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979676 */     // MIs[0] policy
     /* 1979676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979686 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1979689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979707 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979709 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979710 */     // GIR_Coverage, 61575,
     /* 1979710 */     GIR_EraseRootFromParent_Done,
     /* 1979711 */   // Label 26493: @1979711
     /* 1979711 */   GIM_Try, /*On fail goto*//*Label 26494*/ GIMT_Encode4(1979797), // Rule ID 61578 //
     /* 1979716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979739 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979762 */     // MIs[0] policy
     /* 1979762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979772 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1979775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979793 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979795 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979796 */     // GIR_Coverage, 61578,
     /* 1979796 */     GIR_EraseRootFromParent_Done,
     /* 1979797 */   // Label 26494: @1979797
     /* 1979797 */   GIM_Try, /*On fail goto*//*Label 26495*/ GIMT_Encode4(1979883), // Rule ID 61579 //
     /* 1979802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1979813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1979816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1979819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1979825 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1979828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1979832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1979840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979848 */     // MIs[0] policy
     /* 1979848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979858 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1979858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1979861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1979879 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979881 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979882 */     // GIR_Coverage, 61579,
     /* 1979882 */     GIR_EraseRootFromParent_Done,
     /* 1979883 */   // Label 26495: @1979883
     /* 1979883 */   GIM_Try, /*On fail goto*//*Label 26496*/ GIMT_Encode4(1979969), // Rule ID 61582 //
     /* 1979888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1979891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1979908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979911 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1979914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1979918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1979926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1979930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1979934 */     // MIs[0] policy
     /* 1979934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1979937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1979944 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1979944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1979947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1979949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1979951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1979953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1979955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1979957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1979962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1979965 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1979967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1979968 */     // GIR_Coverage, 61582,
     /* 1979968 */     GIR_EraseRootFromParent_Done,
     /* 1979969 */   // Label 26496: @1979969
     /* 1979969 */   GIM_Try, /*On fail goto*//*Label 26497*/ GIMT_Encode4(1980055), // Rule ID 61583 //
     /* 1979974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1979977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1979982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1979985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1979988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1979991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1979994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1979997 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980020 */     // MIs[0] policy
     /* 1980020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980030 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1980033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980051 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980053 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980054 */     // GIR_Coverage, 61583,
     /* 1980054 */     GIR_EraseRootFromParent_Done,
     /* 1980055 */   // Label 26497: @1980055
     /* 1980055 */   GIM_Try, /*On fail goto*//*Label 26498*/ GIMT_Encode4(1980141), // Rule ID 61586 //
     /* 1980060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980083 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980106 */     // MIs[0] policy
     /* 1980106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980116 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1980119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980137 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980139 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980140 */     // GIR_Coverage, 61586,
     /* 1980140 */     GIR_EraseRootFromParent_Done,
     /* 1980141 */   // Label 26498: @1980141
     /* 1980141 */   GIM_Try, /*On fail goto*//*Label 26499*/ GIMT_Encode4(1980227), // Rule ID 61587 //
     /* 1980146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1980157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1980160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1980163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980169 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980192 */     // MIs[0] policy
     /* 1980192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980202 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1980205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980223 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980225 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980226 */     // GIR_Coverage, 61587,
     /* 1980226 */     GIR_EraseRootFromParent_Done,
     /* 1980227 */   // Label 26499: @1980227
     /* 1980227 */   GIM_Try, /*On fail goto*//*Label 26500*/ GIMT_Encode4(1980313), // Rule ID 61590 //
     /* 1980232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980255 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980278 */     // MIs[0] policy
     /* 1980278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980288 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1980291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980309 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980311 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980312 */     // GIR_Coverage, 61590,
     /* 1980312 */     GIR_EraseRootFromParent_Done,
     /* 1980313 */   // Label 26500: @1980313
     /* 1980313 */   GIM_Try, /*On fail goto*//*Label 26501*/ GIMT_Encode4(1980399), // Rule ID 61591 //
     /* 1980318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1980329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1980332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1980335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1980341 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980364 */     // MIs[0] policy
     /* 1980364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980374 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1980377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1980395 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980397 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980398 */     // GIR_Coverage, 61591,
     /* 1980398 */     GIR_EraseRootFromParent_Done,
     /* 1980399 */   // Label 26501: @1980399
     /* 1980399 */   GIM_Try, /*On fail goto*//*Label 26502*/ GIMT_Encode4(1980485), // Rule ID 61594 //
     /* 1980404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1980415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1980418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1980421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980427 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980450 */     // MIs[0] policy
     /* 1980450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980460 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1980463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980481 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980483 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980484 */     // GIR_Coverage, 61594,
     /* 1980484 */     GIR_EraseRootFromParent_Done,
     /* 1980485 */   // Label 26502: @1980485
     /* 1980485 */   GIM_Try, /*On fail goto*//*Label 26503*/ GIMT_Encode4(1980571), // Rule ID 61595 //
     /* 1980490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1980501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1980504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1980507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1980513 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980536 */     // MIs[0] policy
     /* 1980536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980546 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1980549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980567 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980569 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980570 */     // GIR_Coverage, 61595,
     /* 1980570 */     GIR_EraseRootFromParent_Done,
     /* 1980571 */   // Label 26503: @1980571
     /* 1980571 */   GIM_Try, /*On fail goto*//*Label 26504*/ GIMT_Encode4(1980657), // Rule ID 61598 //
     /* 1980576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980599 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980622 */     // MIs[0] policy
     /* 1980622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980632 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1980635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980653 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980655 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980656 */     // GIR_Coverage, 61598,
     /* 1980656 */     GIR_EraseRootFromParent_Done,
     /* 1980657 */   // Label 26504: @1980657
     /* 1980657 */   GIM_Try, /*On fail goto*//*Label 26505*/ GIMT_Encode4(1980743), // Rule ID 61599 //
     /* 1980662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1980673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1980676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1980679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1980685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1980692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1980700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980708 */     // MIs[0] policy
     /* 1980708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980718 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1980721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980723 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980739 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980741 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980742 */     // GIR_Coverage, 61599,
     /* 1980742 */     GIR_EraseRootFromParent_Done,
     /* 1980743 */   // Label 26505: @1980743
     /* 1980743 */   GIM_Try, /*On fail goto*//*Label 26506*/ GIMT_Encode4(1980829), // Rule ID 61602 //
     /* 1980748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980771 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980794 */     // MIs[0] policy
     /* 1980794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980804 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1980807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980825 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980827 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980828 */     // GIR_Coverage, 61602,
     /* 1980828 */     GIR_EraseRootFromParent_Done,
     /* 1980829 */   // Label 26506: @1980829
     /* 1980829 */   GIM_Try, /*On fail goto*//*Label 26507*/ GIMT_Encode4(1980915), // Rule ID 61603 //
     /* 1980834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1980837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1980845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1980848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1980851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1980854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1980857 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1980860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1980864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1980872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980880 */     // MIs[0] policy
     /* 1980880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980890 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1980890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1980893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1980911 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980913 */     GIR_RootConstrainSelectedInstOperands,
     /* 1980914 */     // GIR_Coverage, 61603,
     /* 1980914 */     GIR_EraseRootFromParent_Done,
     /* 1980915 */   // Label 26507: @1980915
     /* 1980915 */   GIM_Try, /*On fail goto*//*Label 26508*/ GIMT_Encode4(1981001), // Rule ID 61606 //
     /* 1980920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1980923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1980928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1980931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1980934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1980937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1980940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1980943 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1980946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1980950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1980958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1980962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1980966 */     // MIs[0] policy
     /* 1980966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1980969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1980976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1980976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1980979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1980981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1980983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1980985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1980987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1980989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1980994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1980997 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1980999 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981000 */     // GIR_Coverage, 61606,
     /* 1981000 */     GIR_EraseRootFromParent_Done,
     /* 1981001 */   // Label 26508: @1981001
     /* 1981001 */   GIM_Try, /*On fail goto*//*Label 26509*/ GIMT_Encode4(1981087), // Rule ID 61607 //
     /* 1981006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1981017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1981020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1981023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981029 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1981036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1981044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981052 */     // MIs[0] policy
     /* 1981052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11457:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M2_MASK),
     /* 1981065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981083 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981086 */     // GIR_Coverage, 61607,
     /* 1981086 */     GIR_EraseRootFromParent_Done,
     /* 1981087 */   // Label 26509: @1981087
     /* 1981087 */   GIM_Try, /*On fail goto*//*Label 26510*/ GIMT_Encode4(1981173), // Rule ID 61610 //
     /* 1981092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981115 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981138 */     // MIs[0] policy
     /* 1981138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981148 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1981151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981169 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981171 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981172 */     // GIR_Coverage, 61610,
     /* 1981172 */     GIR_EraseRootFromParent_Done,
     /* 1981173 */   // Label 26510: @1981173
     /* 1981173 */   GIM_Try, /*On fail goto*//*Label 26511*/ GIMT_Encode4(1981259), // Rule ID 61611 //
     /* 1981178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1981189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1981192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1981195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981201 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1981208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1981216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981224 */     // MIs[0] policy
     /* 1981224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981234 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11457:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M4_MASK),
     /* 1981237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981255 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981257 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981258 */     // GIR_Coverage, 61611,
     /* 1981258 */     GIR_EraseRootFromParent_Done,
     /* 1981259 */   // Label 26511: @1981259
     /* 1981259 */   GIM_Try, /*On fail goto*//*Label 26512*/ GIMT_Encode4(1981345), // Rule ID 61614 //
     /* 1981264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1981284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981287 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981310 */     // MIs[0] policy
     /* 1981310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981320 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1981323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981341 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981343 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981344 */     // GIR_Coverage, 61614,
     /* 1981344 */     GIR_EraseRootFromParent_Done,
     /* 1981345 */   // Label 26512: @1981345
     /* 1981345 */   GIM_Try, /*On fail goto*//*Label 26513*/ GIMT_Encode4(1981431), // Rule ID 61615 //
     /* 1981350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vrol_mask),
     /* 1981358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1981361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1981364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1981367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1981370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1981373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1981380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1981388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1981392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981396 */     // MIs[0] policy
     /* 1981396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981406 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11457:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VX_M8_MASK),
     /* 1981409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1981427 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981429 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981430 */     // GIR_Coverage, 61615,
     /* 1981430 */     GIR_EraseRootFromParent_Done,
     /* 1981431 */   // Label 26513: @1981431
     /* 1981431 */   GIM_Try, /*On fail goto*//*Label 26514*/ GIMT_Encode4(1981517), // Rule ID 61702 //
     /* 1981436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1981456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981459 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981482 */     // MIs[0] policy
     /* 1981482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981492 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1981495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981513 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981515 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981516 */     // GIR_Coverage, 61702,
     /* 1981516 */     GIR_EraseRootFromParent_Done,
     /* 1981517 */   // Label 26514: @1981517
     /* 1981517 */   GIM_Try, /*On fail goto*//*Label 26515*/ GIMT_Encode4(1981603), // Rule ID 61703 //
     /* 1981522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1981533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1981536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1981539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 1981542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981545 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981568 */     // MIs[0] policy
     /* 1981568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981578 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8_MASK),
     /* 1981581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981599 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981601 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981602 */     // GIR_Coverage, 61703,
     /* 1981602 */     GIR_EraseRootFromParent_Done,
     /* 1981603 */   // Label 26515: @1981603
     /* 1981603 */   GIM_Try, /*On fail goto*//*Label 26516*/ GIMT_Encode4(1981689), // Rule ID 61706 //
     /* 1981608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981631 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981654 */     // MIs[0] policy
     /* 1981654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1981667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981685 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981688 */     // GIR_Coverage, 61706,
     /* 1981688 */     GIR_EraseRootFromParent_Done,
     /* 1981689 */   // Label 26516: @1981689
     /* 1981689 */   GIM_Try, /*On fail goto*//*Label 26517*/ GIMT_Encode4(1981775), // Rule ID 61707 //
     /* 1981694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1981705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1981708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1981711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 1981714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1981717 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981740 */     // MIs[0] policy
     /* 1981740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981750 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1981753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981771 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981773 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981774 */     // GIR_Coverage, 61707,
     /* 1981774 */     GIR_EraseRootFromParent_Done,
     /* 1981775 */   // Label 26517: @1981775
     /* 1981775 */   GIM_Try, /*On fail goto*//*Label 26518*/ GIMT_Encode4(1981861), // Rule ID 61710 //
     /* 1981780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981803 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981826 */     // MIs[0] policy
     /* 1981826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981836 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1981836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1981839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981857 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981859 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981860 */     // GIR_Coverage, 61710,
     /* 1981860 */     GIR_EraseRootFromParent_Done,
     /* 1981861 */   // Label 26518: @1981861
     /* 1981861 */   GIM_Try, /*On fail goto*//*Label 26519*/ GIMT_Encode4(1981947), // Rule ID 61711 //
     /* 1981866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1981869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1981877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1981880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1981883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1981886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1981889 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1981892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981912 */     // MIs[0] policy
     /* 1981912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1981915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1981922 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1981922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1981925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1981927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1981929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1981931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1981933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1981935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1981940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1981943 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1981945 */     GIR_RootConstrainSelectedInstOperands,
     /* 1981946 */     // GIR_Coverage, 61711,
     /* 1981946 */     GIR_EraseRootFromParent_Done,
     /* 1981947 */   // Label 26519: @1981947
     /* 1981947 */   GIM_Try, /*On fail goto*//*Label 26520*/ GIMT_Encode4(1982033), // Rule ID 61714 //
     /* 1981952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1981955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1981960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1981963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1981966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1981969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1981972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1981975 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1981978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1981982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1981994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1981998 */     // MIs[0] policy
     /* 1981998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982008 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1982011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982029 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982031 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982032 */     // GIR_Coverage, 61714,
     /* 1982032 */     GIR_EraseRootFromParent_Done,
     /* 1982033 */   // Label 26520: @1982033
     /* 1982033 */   GIM_Try, /*On fail goto*//*Label 26521*/ GIMT_Encode4(1982119), // Rule ID 61715 //
     /* 1982038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1982049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1982052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1982055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 1982058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982061 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982084 */     // MIs[0] policy
     /* 1982084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982094 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4_MASK),
     /* 1982097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982115 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982117 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982118 */     // GIR_Coverage, 61715,
     /* 1982118 */     GIR_EraseRootFromParent_Done,
     /* 1982119 */   // Label 26521: @1982119
     /* 1982119 */   GIM_Try, /*On fail goto*//*Label 26522*/ GIMT_Encode4(1982205), // Rule ID 61718 //
     /* 1982124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1982144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982147 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982170 */     // MIs[0] policy
     /* 1982170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982180 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1982183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982201 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982203 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982204 */     // GIR_Coverage, 61718,
     /* 1982204 */     GIR_EraseRootFromParent_Done,
     /* 1982205 */   // Label 26522: @1982205
     /* 1982205 */   GIM_Try, /*On fail goto*//*Label 26523*/ GIMT_Encode4(1982291), // Rule ID 61719 //
     /* 1982210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1982221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1982224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1982227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 1982230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982256 */     // MIs[0] policy
     /* 1982256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982266 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1982269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982287 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982290 */     // GIR_Coverage, 61719,
     /* 1982290 */     GIR_EraseRootFromParent_Done,
     /* 1982291 */   // Label 26523: @1982291
     /* 1982291 */   GIM_Try, /*On fail goto*//*Label 26524*/ GIMT_Encode4(1982377), // Rule ID 61722 //
     /* 1982296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1982316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982319 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982342 */     // MIs[0] policy
     /* 1982342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982352 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1982355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982357 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982373 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982375 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982376 */     // GIR_Coverage, 61722,
     /* 1982376 */     GIR_EraseRootFromParent_Done,
     /* 1982377 */   // Label 26524: @1982377
     /* 1982377 */   GIM_Try, /*On fail goto*//*Label 26525*/ GIMT_Encode4(1982463), // Rule ID 61723 //
     /* 1982382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1982393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1982396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1982399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 1982402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1982405 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982428 */     // MIs[0] policy
     /* 1982428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982438 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2_MASK),
     /* 1982441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982459 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982461 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982462 */     // GIR_Coverage, 61723,
     /* 1982462 */     GIR_EraseRootFromParent_Done,
     /* 1982463 */   // Label 26525: @1982463
     /* 1982463 */   GIM_Try, /*On fail goto*//*Label 26526*/ GIMT_Encode4(1982549), // Rule ID 61726 //
     /* 1982468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1982488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982491 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982514 */     // MIs[0] policy
     /* 1982514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982545 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982547 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982548 */     // GIR_Coverage, 61726,
     /* 1982548 */     GIR_EraseRootFromParent_Done,
     /* 1982549 */   // Label 26526: @1982549
     /* 1982549 */   GIM_Try, /*On fail goto*//*Label 26527*/ GIMT_Encode4(1982635), // Rule ID 61727 //
     /* 1982554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1982565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1982568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1982571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1982574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1982577 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982600 */     // MIs[0] policy
     /* 1982600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982610 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1982631 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982633 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982634 */     // GIR_Coverage, 61727,
     /* 1982634 */     GIR_EraseRootFromParent_Done,
     /* 1982635 */   // Label 26527: @1982635
     /* 1982635 */   GIM_Try, /*On fail goto*//*Label 26528*/ GIMT_Encode4(1982721), // Rule ID 61730 //
     /* 1982640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982686 */     // MIs[0] policy
     /* 1982686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982696 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982717 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982719 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982720 */     // GIR_Coverage, 61730,
     /* 1982720 */     GIR_EraseRootFromParent_Done,
     /* 1982721 */   // Label 26528: @1982721
     /* 1982721 */   GIM_Try, /*On fail goto*//*Label 26529*/ GIMT_Encode4(1982807), // Rule ID 61731 //
     /* 1982726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1982737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1982740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1982743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1982746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1982749 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982772 */     // MIs[0] policy
     /* 1982772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982782 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1982803 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982805 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982806 */     // GIR_Coverage, 61731,
     /* 1982806 */     GIR_EraseRootFromParent_Done,
     /* 1982807 */   // Label 26529: @1982807
     /* 1982807 */   GIM_Try, /*On fail goto*//*Label 26530*/ GIMT_Encode4(1982893), // Rule ID 61734 //
     /* 1982812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982835 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1982838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982858 */     // MIs[0] policy
     /* 1982858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982868 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1982868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982889 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982891 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982892 */     // GIR_Coverage, 61734,
     /* 1982892 */     GIR_EraseRootFromParent_Done,
     /* 1982893 */   // Label 26530: @1982893
     /* 1982893 */   GIM_Try, /*On fail goto*//*Label 26531*/ GIMT_Encode4(1982979), // Rule ID 61735 //
     /* 1982898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1982901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1982909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1982912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1982915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1982918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1982921 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1982924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1982928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1982940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1982944 */     // MIs[0] policy
     /* 1982944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1982947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1982954 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1982954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1982957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1982959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1982961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1982963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1982965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1982967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1982972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1982975 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1982977 */     GIR_RootConstrainSelectedInstOperands,
     /* 1982978 */     // GIR_Coverage, 61735,
     /* 1982978 */     GIR_EraseRootFromParent_Done,
     /* 1982979 */   // Label 26531: @1982979
     /* 1982979 */   GIM_Try, /*On fail goto*//*Label 26532*/ GIMT_Encode4(1983065), // Rule ID 61738 //
     /* 1982984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1982987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1982992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1982995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1982998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1983004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983007 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983030 */     // MIs[0] policy
     /* 1983030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983040 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1983043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983061 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983063 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983064 */     // GIR_Coverage, 61738,
     /* 1983064 */     GIR_EraseRootFromParent_Done,
     /* 1983065 */   // Label 26532: @1983065
     /* 1983065 */   GIM_Try, /*On fail goto*//*Label 26533*/ GIMT_Encode4(1983151), // Rule ID 61739 //
     /* 1983070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1983081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1983084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1983087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1983090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1983093 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1983100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1983112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983116 */     // MIs[0] policy
     /* 1983116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983126 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1_MASK),
     /* 1983129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1983147 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983149 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983150 */     // GIR_Coverage, 61739,
     /* 1983150 */     GIR_EraseRootFromParent_Done,
     /* 1983151 */   // Label 26533: @1983151
     /* 1983151 */   GIM_Try, /*On fail goto*//*Label 26534*/ GIMT_Encode4(1983237), // Rule ID 61742 //
     /* 1983156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1983176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983179 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983202 */     // MIs[0] policy
     /* 1983202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1983215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983233 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983235 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983236 */     // GIR_Coverage, 61742,
     /* 1983236 */     GIR_EraseRootFromParent_Done,
     /* 1983237 */   // Label 26534: @1983237
     /* 1983237 */   GIM_Try, /*On fail goto*//*Label 26535*/ GIMT_Encode4(1983323), // Rule ID 61743 //
     /* 1983242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1983253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1983256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1983259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1983262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983265 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983288 */     // MIs[0] policy
     /* 1983288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983298 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1983301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983319 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983321 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983322 */     // GIR_Coverage, 61743,
     /* 1983322 */     GIR_EraseRootFromParent_Done,
     /* 1983323 */   // Label 26535: @1983323
     /* 1983323 */   GIM_Try, /*On fail goto*//*Label 26536*/ GIMT_Encode4(1983409), // Rule ID 61746 //
     /* 1983328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1983348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983351 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983374 */     // MIs[0] policy
     /* 1983374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1983387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983405 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983407 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983408 */     // GIR_Coverage, 61746,
     /* 1983408 */     GIR_EraseRootFromParent_Done,
     /* 1983409 */   // Label 26536: @1983409
     /* 1983409 */   GIM_Try, /*On fail goto*//*Label 26537*/ GIMT_Encode4(1983495), // Rule ID 61747 //
     /* 1983414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1983425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1983428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1983431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1983434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1983437 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983460 */     // MIs[0] policy
     /* 1983460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983470 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1983473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983491 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983493 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983494 */     // GIR_Coverage, 61747,
     /* 1983494 */     GIR_EraseRootFromParent_Done,
     /* 1983495 */   // Label 26537: @1983495
     /* 1983495 */   GIM_Try, /*On fail goto*//*Label 26538*/ GIMT_Encode4(1983581), // Rule ID 61750 //
     /* 1983500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983523 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983546 */     // MIs[0] policy
     /* 1983546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983556 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1983559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983577 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983579 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983580 */     // GIR_Coverage, 61750,
     /* 1983580 */     GIR_EraseRootFromParent_Done,
     /* 1983581 */   // Label 26538: @1983581
     /* 1983581 */   GIM_Try, /*On fail goto*//*Label 26539*/ GIMT_Encode4(1983667), // Rule ID 61751 //
     /* 1983586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1983597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1983600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1983603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1983606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1983609 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1983616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1983628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983632 */     // MIs[0] policy
     /* 1983632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983642 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1983645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1983663 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983665 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983666 */     // GIR_Coverage, 61751,
     /* 1983666 */     GIR_EraseRootFromParent_Done,
     /* 1983667 */   // Label 26539: @1983667
     /* 1983667 */   GIM_Try, /*On fail goto*//*Label 26540*/ GIMT_Encode4(1983753), // Rule ID 61754 //
     /* 1983672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983718 */     // MIs[0] policy
     /* 1983718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1983731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983749 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983751 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983752 */     // GIR_Coverage, 61754,
     /* 1983752 */     GIR_EraseRootFromParent_Done,
     /* 1983753 */   // Label 26540: @1983753
     /* 1983753 */   GIM_Try, /*On fail goto*//*Label 26541*/ GIMT_Encode4(1983839), // Rule ID 61755 //
     /* 1983758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1983769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1983772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1983775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 1983778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1983781 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1983788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1983800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983804 */     // MIs[0] policy
     /* 1983804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1983817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983835 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983837 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983838 */     // GIR_Coverage, 61755,
     /* 1983838 */     GIR_EraseRootFromParent_Done,
     /* 1983839 */   // Label 26541: @1983839
     /* 1983839 */   GIM_Try, /*On fail goto*//*Label 26542*/ GIMT_Encode4(1983925), // Rule ID 61758 //
     /* 1983844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1983847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983867 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1983870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983890 */     // MIs[0] policy
     /* 1983890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983900 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1983900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1983903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1983918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1983921 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1983923 */     GIR_RootConstrainSelectedInstOperands,
     /* 1983924 */     // GIR_Coverage, 61758,
     /* 1983924 */     GIR_EraseRootFromParent_Done,
     /* 1983925 */   // Label 26542: @1983925
     /* 1983925 */   GIM_Try, /*On fail goto*//*Label 26543*/ GIMT_Encode4(1984011), // Rule ID 61759 //
     /* 1983930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1983933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1983938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1983941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1983944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1983947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 1983950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1983953 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1983956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1983960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1983972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1983976 */     // MIs[0] policy
     /* 1983976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1983979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1983986 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1983986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1983989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1983991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1983993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1983995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1983997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1983999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984007 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984009 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984010 */     // GIR_Coverage, 61759,
     /* 1984010 */     GIR_EraseRootFromParent_Done,
     /* 1984011 */   // Label 26543: @1984011
     /* 1984011 */   GIM_Try, /*On fail goto*//*Label 26544*/ GIMT_Encode4(1984097), // Rule ID 61762 //
     /* 1984016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1984036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984039 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984062 */     // MIs[0] policy
     /* 1984062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984072 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1984075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984093 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984095 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984096 */     // GIR_Coverage, 61762,
     /* 1984096 */     GIR_EraseRootFromParent_Done,
     /* 1984097 */   // Label 26544: @1984097
     /* 1984097 */   GIM_Try, /*On fail goto*//*Label 26545*/ GIMT_Encode4(1984183), // Rule ID 61763 //
     /* 1984102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1984113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1984116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1984119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 1984122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1984125 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984148 */     // MIs[0] policy
     /* 1984148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1984161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1984179 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984181 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984182 */     // GIR_Coverage, 61763,
     /* 1984182 */     GIR_EraseRootFromParent_Done,
     /* 1984183 */   // Label 26545: @1984183
     /* 1984183 */   GIM_Try, /*On fail goto*//*Label 26546*/ GIMT_Encode4(1984269), // Rule ID 61766 //
     /* 1984188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1984208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984211 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984234 */     // MIs[0] policy
     /* 1984234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1984247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984265 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984267 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984268 */     // GIR_Coverage, 61766,
     /* 1984268 */     GIR_EraseRootFromParent_Done,
     /* 1984269 */   // Label 26546: @1984269
     /* 1984269 */   GIM_Try, /*On fail goto*//*Label 26547*/ GIMT_Encode4(1984355), // Rule ID 61767 //
     /* 1984274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1984285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1984288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1984291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 1984294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984297 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984320 */     // MIs[0] policy
     /* 1984320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1984333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984351 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984353 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984354 */     // GIR_Coverage, 61767,
     /* 1984354 */     GIR_EraseRootFromParent_Done,
     /* 1984355 */   // Label 26547: @1984355
     /* 1984355 */   GIM_Try, /*On fail goto*//*Label 26548*/ GIMT_Encode4(1984441), // Rule ID 61770 //
     /* 1984360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1984371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1984374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1984377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1984380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984406 */     // MIs[0] policy
     /* 1984406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1984419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984437 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984439 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984440 */     // GIR_Coverage, 61770,
     /* 1984440 */     GIR_EraseRootFromParent_Done,
     /* 1984441 */   // Label 26548: @1984441
     /* 1984441 */   GIM_Try, /*On fail goto*//*Label 26549*/ GIMT_Encode4(1984527), // Rule ID 61771 //
     /* 1984446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1984457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1984460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1984463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 1984466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1984469 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984492 */     // MIs[0] policy
     /* 1984492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984502 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1984505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984523 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984525 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984526 */     // GIR_Coverage, 61771,
     /* 1984526 */     GIR_EraseRootFromParent_Done,
     /* 1984527 */   // Label 26549: @1984527
     /* 1984527 */   GIM_Try, /*On fail goto*//*Label 26550*/ GIMT_Encode4(1984613), // Rule ID 61774 //
     /* 1984532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984555 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984578 */     // MIs[0] policy
     /* 1984578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984588 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1984591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984609 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984611 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984612 */     // GIR_Coverage, 61774,
     /* 1984612 */     GIR_EraseRootFromParent_Done,
     /* 1984613 */   // Label 26550: @1984613
     /* 1984613 */   GIM_Try, /*On fail goto*//*Label 26551*/ GIMT_Encode4(1984699), // Rule ID 61775 //
     /* 1984618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1984629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1984632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1984635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 1984638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1984641 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1984648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1984660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984664 */     // MIs[0] policy
     /* 1984664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984674 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1984677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1984695 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984697 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984698 */     // GIR_Coverage, 61775,
     /* 1984698 */     GIR_EraseRootFromParent_Done,
     /* 1984699 */   // Label 26551: @1984699
     /* 1984699 */   GIM_Try, /*On fail goto*//*Label 26552*/ GIMT_Encode4(1984785), // Rule ID 61778 //
     /* 1984704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984727 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984750 */     // MIs[0] policy
     /* 1984750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1984763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984781 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984783 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984784 */     // GIR_Coverage, 61778,
     /* 1984784 */     GIR_EraseRootFromParent_Done,
     /* 1984785 */   // Label 26552: @1984785
     /* 1984785 */   GIM_Try, /*On fail goto*//*Label 26553*/ GIMT_Encode4(1984871), // Rule ID 61779 //
     /* 1984790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1984801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1984804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1984807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 1984810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1984813 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1984820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1984832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984836 */     // MIs[0] policy
     /* 1984836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984846 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1984846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2_MASK),
     /* 1984849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984867 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984869 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984870 */     // GIR_Coverage, 61779,
     /* 1984870 */     GIR_EraseRootFromParent_Done,
     /* 1984871 */   // Label 26553: @1984871
     /* 1984871 */   GIM_Try, /*On fail goto*//*Label 26554*/ GIMT_Encode4(1984957), // Rule ID 61782 //
     /* 1984876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1984879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984899 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1984902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1984922 */     // MIs[0] policy
     /* 1984922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1984925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1984932 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1984932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1984935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1984937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1984939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1984941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1984943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1984945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1984950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1984953 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1984955 */     GIR_RootConstrainSelectedInstOperands,
     /* 1984956 */     // GIR_Coverage, 61782,
     /* 1984956 */     GIR_EraseRootFromParent_Done,
     /* 1984957 */   // Label 26554: @1984957
     /* 1984957 */   GIM_Try, /*On fail goto*//*Label 26555*/ GIMT_Encode4(1985043), // Rule ID 61783 //
     /* 1984962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1984965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1984970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1984973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1984976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1984979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 1984982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1984985 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1984988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1984992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1984996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1985004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985008 */     // MIs[0] policy
     /* 1985008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985018 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4_MASK),
     /* 1985021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985039 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985041 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985042 */     // GIR_Coverage, 61783,
     /* 1985042 */     GIR_EraseRootFromParent_Done,
     /* 1985043 */   // Label 26555: @1985043
     /* 1985043 */   GIM_Try, /*On fail goto*//*Label 26556*/ GIMT_Encode4(1985129), // Rule ID 61786 //
     /* 1985048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1985068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985071 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985094 */     // MIs[0] policy
     /* 1985094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985104 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1985107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985125 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985127 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985128 */     // GIR_Coverage, 61786,
     /* 1985128 */     GIR_EraseRootFromParent_Done,
     /* 1985129 */   // Label 26556: @1985129
     /* 1985129 */   GIM_Try, /*On fail goto*//*Label 26557*/ GIMT_Encode4(1985215), // Rule ID 61787 //
     /* 1985134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1985145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1985148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1985151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 1985154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1985157 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1985164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1985176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985180 */     // MIs[0] policy
     /* 1985180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985190 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8_MASK),
     /* 1985193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1985211 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985213 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985214 */     // GIR_Coverage, 61787,
     /* 1985214 */     GIR_EraseRootFromParent_Done,
     /* 1985215 */   // Label 26557: @1985215
     /* 1985215 */   GIM_Try, /*On fail goto*//*Label 26558*/ GIMT_Encode4(1985301), // Rule ID 61790 //
     /* 1985220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1985237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985266 */     // MIs[0] policy
     /* 1985266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985276 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1985279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985297 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985299 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985300 */     // GIR_Coverage, 61790,
     /* 1985300 */     GIR_EraseRootFromParent_Done,
     /* 1985301 */   // Label 26558: @1985301
     /* 1985301 */   GIM_Try, /*On fail goto*//*Label 26559*/ GIMT_Encode4(1985387), // Rule ID 61791 //
     /* 1985306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 1985317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 1985320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 1985323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985329 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985352 */     // MIs[0] policy
     /* 1985352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985362 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF8_MASK),
     /* 1985365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985383 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985385 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985386 */     // GIR_Coverage, 61791,
     /* 1985386 */     GIR_EraseRootFromParent_Done,
     /* 1985387 */   // Label 26559: @1985387
     /* 1985387 */   GIM_Try, /*On fail goto*//*Label 26560*/ GIMT_Encode4(1985473), // Rule ID 61794 //
     /* 1985392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1985403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1985406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1985409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985415 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985438 */     // MIs[0] policy
     /* 1985438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985448 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1985451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985469 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985471 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985472 */     // GIR_Coverage, 61794,
     /* 1985472 */     GIR_EraseRootFromParent_Done,
     /* 1985473 */   // Label 26560: @1985473
     /* 1985473 */   GIM_Try, /*On fail goto*//*Label 26561*/ GIMT_Encode4(1985559), // Rule ID 61795 //
     /* 1985478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 1985489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 1985492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 1985495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985501 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985524 */     // MIs[0] policy
     /* 1985524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985534 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1985537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985555 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985557 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985558 */     // GIR_Coverage, 61795,
     /* 1985558 */     GIR_EraseRootFromParent_Done,
     /* 1985559 */   // Label 26561: @1985559
     /* 1985559 */   GIM_Try, /*On fail goto*//*Label 26562*/ GIMT_Encode4(1985645), // Rule ID 61798 //
     /* 1985564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985610 */     // MIs[0] policy
     /* 1985610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985620 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1985623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985641 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985643 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985644 */     // GIR_Coverage, 61798,
     /* 1985644 */     GIR_EraseRootFromParent_Done,
     /* 1985645 */   // Label 26562: @1985645
     /* 1985645 */   GIM_Try, /*On fail goto*//*Label 26563*/ GIMT_Encode4(1985731), // Rule ID 61799 //
     /* 1985650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 1985661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 1985664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1985667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1985673 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985696 */     // MIs[0] policy
     /* 1985696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985706 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1985709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1985727 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985730 */     // GIR_Coverage, 61799,
     /* 1985730 */     GIR_EraseRootFromParent_Done,
     /* 1985731 */   // Label 26563: @1985731
     /* 1985731 */   GIM_Try, /*On fail goto*//*Label 26564*/ GIMT_Encode4(1985817), // Rule ID 61802 //
     /* 1985736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985759 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985782 */     // MIs[0] policy
     /* 1985782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985792 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1985795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985813 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985815 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985816 */     // GIR_Coverage, 61802,
     /* 1985816 */     GIR_EraseRootFromParent_Done,
     /* 1985817 */   // Label 26564: @1985817
     /* 1985817 */   GIM_Try, /*On fail goto*//*Label 26565*/ GIMT_Encode4(1985903), // Rule ID 61803 //
     /* 1985822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 1985833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 1985836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1985839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1985842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1985845 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1985848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985868 */     // MIs[0] policy
     /* 1985868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985878 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1985878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF4_MASK),
     /* 1985881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985899 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985901 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985902 */     // GIR_Coverage, 61803,
     /* 1985902 */     GIR_EraseRootFromParent_Done,
     /* 1985903 */   // Label 26565: @1985903
     /* 1985903 */   GIM_Try, /*On fail goto*//*Label 26566*/ GIMT_Encode4(1985989), // Rule ID 61806 //
     /* 1985908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1985911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1985916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1985919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1985922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1985925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1985928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1985931 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1985934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1985938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1985946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1985950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1985954 */     // MIs[0] policy
     /* 1985954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1985957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1985964 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1985964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1985967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1985969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1985971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1985973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1985975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1985977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1985982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1985985 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1985987 */     GIR_RootConstrainSelectedInstOperands,
     /* 1985988 */     // GIR_Coverage, 61806,
     /* 1985988 */     GIR_EraseRootFromParent_Done,
     /* 1985989 */   // Label 26566: @1985989
     /* 1985989 */   GIM_Try, /*On fail goto*//*Label 26567*/ GIMT_Encode4(1986075), // Rule ID 61807 //
     /* 1985994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1985997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 1986005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 1986008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1986011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986017 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986040 */     // MIs[0] policy
     /* 1986040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986050 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1986053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986071 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986073 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986074 */     // GIR_Coverage, 61807,
     /* 1986074 */     GIR_EraseRootFromParent_Done,
     /* 1986075 */   // Label 26567: @1986075
     /* 1986075 */   GIM_Try, /*On fail goto*//*Label 26568*/ GIMT_Encode4(1986161), // Rule ID 61810 //
     /* 1986080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1986091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1986094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986103 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986126 */     // MIs[0] policy
     /* 1986126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986136 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1986139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986157 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986159 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986160 */     // GIR_Coverage, 61810,
     /* 1986160 */     GIR_EraseRootFromParent_Done,
     /* 1986161 */   // Label 26568: @1986161
     /* 1986161 */   GIM_Try, /*On fail goto*//*Label 26569*/ GIMT_Encode4(1986247), // Rule ID 61811 //
     /* 1986166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1986177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1986180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1986183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986189 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986212 */     // MIs[0] policy
     /* 1986212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986222 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_MF2_MASK),
     /* 1986225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986243 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986245 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986246 */     // GIR_Coverage, 61811,
     /* 1986246 */     GIR_EraseRootFromParent_Done,
     /* 1986247 */   // Label 26569: @1986247
     /* 1986247 */   GIM_Try, /*On fail goto*//*Label 26570*/ GIMT_Encode4(1986333), // Rule ID 61814 //
     /* 1986252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1986269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986275 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986298 */     // MIs[0] policy
     /* 1986298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986308 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986329 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986332 */     // GIR_Coverage, 61814,
     /* 1986332 */     GIR_EraseRootFromParent_Done,
     /* 1986333 */   // Label 26570: @1986333
     /* 1986333 */   GIM_Try, /*On fail goto*//*Label 26571*/ GIMT_Encode4(1986419), // Rule ID 61815 //
     /* 1986338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 1986349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 1986352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1986355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1986361 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986384 */     // MIs[0] policy
     /* 1986384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986394 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11459:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1986415 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986417 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986418 */     // GIR_Coverage, 61815,
     /* 1986418 */     GIR_EraseRootFromParent_Done,
     /* 1986419 */   // Label 26571: @1986419
     /* 1986419 */   GIM_Try, /*On fail goto*//*Label 26572*/ GIMT_Encode4(1986505), // Rule ID 61818 //
     /* 1986424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1986435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1986438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1986441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986470 */     // MIs[0] policy
     /* 1986470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986480 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986501 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986503 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986504 */     // GIR_Coverage, 61818,
     /* 1986504 */     GIR_EraseRootFromParent_Done,
     /* 1986505 */   // Label 26572: @1986505
     /* 1986505 */   GIM_Try, /*On fail goto*//*Label 26573*/ GIMT_Encode4(1986591), // Rule ID 61819 //
     /* 1986510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1986521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1986524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1986527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1986533 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986556 */     // MIs[0] policy
     /* 1986556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986566 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11459:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1986587 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986589 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986590 */     // GIR_Coverage, 61819,
     /* 1986590 */     GIR_EraseRootFromParent_Done,
     /* 1986591 */   // Label 26573: @1986591
     /* 1986591 */   GIM_Try, /*On fail goto*//*Label 26574*/ GIMT_Encode4(1986677), // Rule ID 61822 //
     /* 1986596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986642 */     // MIs[0] policy
     /* 1986642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986652 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986673 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986675 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986676 */     // GIR_Coverage, 61822,
     /* 1986676 */     GIR_EraseRootFromParent_Done,
     /* 1986677 */   // Label 26574: @1986677
     /* 1986677 */   GIM_Try, /*On fail goto*//*Label 26575*/ GIMT_Encode4(1986763), // Rule ID 61823 //
     /* 1986682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1986693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1986696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1986699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1986705 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986728 */     // MIs[0] policy
     /* 1986728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986738 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11459:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1986759 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986761 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986762 */     // GIR_Coverage, 61823,
     /* 1986762 */     GIR_EraseRootFromParent_Done,
     /* 1986763 */   // Label 26575: @1986763
     /* 1986763 */   GIM_Try, /*On fail goto*//*Label 26576*/ GIMT_Encode4(1986849), // Rule ID 61826 //
     /* 1986768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986791 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986814 */     // MIs[0] policy
     /* 1986814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986824 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986845 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986847 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986848 */     // GIR_Coverage, 61826,
     /* 1986848 */     GIR_EraseRootFromParent_Done,
     /* 1986849 */   // Label 26576: @1986849
     /* 1986849 */   GIM_Try, /*On fail goto*//*Label 26577*/ GIMT_Encode4(1986935), // Rule ID 61827 //
     /* 1986854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1986857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1986865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1986868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1986871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1986874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1986877 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1986880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1986884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1986892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986900 */     // MIs[0] policy
     /* 1986900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986910 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11459:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1986910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M1_MASK),
     /* 1986913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1986915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1986917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1986919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1986921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1986923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1986928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1986931 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1986933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1986934 */     // GIR_Coverage, 61827,
     /* 1986934 */     GIR_EraseRootFromParent_Done,
     /* 1986935 */   // Label 26577: @1986935
     /* 1986935 */   GIM_Try, /*On fail goto*//*Label 26578*/ GIMT_Encode4(1987021), // Rule ID 61830 //
     /* 1986940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1986943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1986948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1986951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1986954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1986957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1986960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1986963 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1986966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1986970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1986978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1986982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1986986 */     // MIs[0] policy
     /* 1986986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1986989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1986996 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1986996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1986999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987017 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987019 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987020 */     // GIR_Coverage, 61830,
     /* 1987020 */     GIR_EraseRootFromParent_Done,
     /* 1987021 */   // Label 26578: @1987021
     /* 1987021 */   GIM_Try, /*On fail goto*//*Label 26579*/ GIMT_Encode4(1987107), // Rule ID 61831 //
     /* 1987026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 1987037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 1987040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1987043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987049 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987072 */     // MIs[0] policy
     /* 1987072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987082 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1987085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987087 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987103 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987105 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987106 */     // GIR_Coverage, 61831,
     /* 1987106 */     GIR_EraseRootFromParent_Done,
     /* 1987107 */   // Label 26579: @1987107
     /* 1987107 */   GIM_Try, /*On fail goto*//*Label 26580*/ GIMT_Encode4(1987193), // Rule ID 61834 //
     /* 1987112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1987123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1987126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1987129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987158 */     // MIs[0] policy
     /* 1987158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987168 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1987171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987189 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987191 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987192 */     // GIR_Coverage, 61834,
     /* 1987192 */     GIR_EraseRootFromParent_Done,
     /* 1987193 */   // Label 26580: @1987193
     /* 1987193 */   GIM_Try, /*On fail goto*//*Label 26581*/ GIMT_Encode4(1987279), // Rule ID 61835 //
     /* 1987198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 1987209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 1987212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1987215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987221 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987244 */     // MIs[0] policy
     /* 1987244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987254 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1987257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987275 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987277 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987278 */     // GIR_Coverage, 61835,
     /* 1987278 */     GIR_EraseRootFromParent_Done,
     /* 1987279 */   // Label 26581: @1987279
     /* 1987279 */   GIM_Try, /*On fail goto*//*Label 26582*/ GIMT_Encode4(1987365), // Rule ID 61838 //
     /* 1987284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1987295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1987298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1987301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1987307 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987330 */     // MIs[0] policy
     /* 1987330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987340 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1987343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987361 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987363 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987364 */     // GIR_Coverage, 61838,
     /* 1987364 */     GIR_EraseRootFromParent_Done,
     /* 1987365 */   // Label 26582: @1987365
     /* 1987365 */   GIM_Try, /*On fail goto*//*Label 26583*/ GIMT_Encode4(1987451), // Rule ID 61839 //
     /* 1987370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 1987381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 1987384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1987387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1987393 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987416 */     // MIs[0] policy
     /* 1987416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987426 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1987429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 1987447 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987449 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987450 */     // GIR_Coverage, 61839,
     /* 1987450 */     GIR_EraseRootFromParent_Done,
     /* 1987451 */   // Label 26583: @1987451
     /* 1987451 */   GIM_Try, /*On fail goto*//*Label 26584*/ GIMT_Encode4(1987537), // Rule ID 61842 //
     /* 1987456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1987473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987479 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987502 */     // MIs[0] policy
     /* 1987502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987512 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1987515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987533 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987535 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987536 */     // GIR_Coverage, 61842,
     /* 1987536 */     GIR_EraseRootFromParent_Done,
     /* 1987537 */   // Label 26584: @1987537
     /* 1987537 */   GIM_Try, /*On fail goto*//*Label 26585*/ GIMT_Encode4(1987623), // Rule ID 61843 //
     /* 1987542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 1987553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 1987556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1987559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1987565 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1987572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1987580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987588 */     // MIs[0] policy
     /* 1987588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987598 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1987601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987619 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987621 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987622 */     // GIR_Coverage, 61843,
     /* 1987622 */     GIR_EraseRootFromParent_Done,
     /* 1987623 */   // Label 26585: @1987623
     /* 1987623 */   GIM_Try, /*On fail goto*//*Label 26586*/ GIMT_Encode4(1987709), // Rule ID 61846 //
     /* 1987628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987651 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987674 */     // MIs[0] policy
     /* 1987674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1987687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987705 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987707 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987708 */     // GIR_Coverage, 61846,
     /* 1987708 */     GIR_EraseRootFromParent_Done,
     /* 1987709 */   // Label 26586: @1987709
     /* 1987709 */   GIM_Try, /*On fail goto*//*Label 26587*/ GIMT_Encode4(1987795), // Rule ID 61847 //
     /* 1987714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 1987725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 1987728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1987731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1987737 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1987744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1987752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987760 */     // MIs[0] policy
     /* 1987760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987770 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1987773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987791 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987793 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987794 */     // GIR_Coverage, 61847,
     /* 1987794 */     GIR_EraseRootFromParent_Done,
     /* 1987795 */   // Label 26587: @1987795
     /* 1987795 */   GIM_Try, /*On fail goto*//*Label 26588*/ GIMT_Encode4(1987881), // Rule ID 61850 //
     /* 1987800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987823 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987846 */     // MIs[0] policy
     /* 1987846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987856 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1987856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1987859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987877 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987879 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987880 */     // GIR_Coverage, 61850,
     /* 1987880 */     GIR_EraseRootFromParent_Done,
     /* 1987881 */   // Label 26588: @1987881
     /* 1987881 */   GIM_Try, /*On fail goto*//*Label 26589*/ GIMT_Encode4(1987967), // Rule ID 61851 //
     /* 1987886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1987889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 1987897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 1987900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1987903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1987906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1987909 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1987912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1987916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1987924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1987928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1987932 */     // MIs[0] policy
     /* 1987932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1987935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1987942 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1987942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1987945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1987947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1987949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1987951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1987953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1987955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1987960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1987963 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1987965 */     GIR_RootConstrainSelectedInstOperands,
     /* 1987966 */     // GIR_Coverage, 61851,
     /* 1987966 */     GIR_EraseRootFromParent_Done,
     /* 1987967 */   // Label 26589: @1987967
     /* 1987967 */   GIM_Try, /*On fail goto*//*Label 26590*/ GIMT_Encode4(1988053), // Rule ID 61854 //
     /* 1987972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1987975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1987980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1987983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1987986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1987989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1987992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1987995 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1987998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988018 */     // MIs[0] policy
     /* 1988018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988028 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1988031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988049 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988051 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988052 */     // GIR_Coverage, 61854,
     /* 1988052 */     GIR_EraseRootFromParent_Done,
     /* 1988053 */   // Label 26590: @1988053
     /* 1988053 */   GIM_Try, /*On fail goto*//*Label 26591*/ GIMT_Encode4(1988139), // Rule ID 61855 //
     /* 1988058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1988069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1988072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1988075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988081 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988104 */     // MIs[0] policy
     /* 1988104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988114 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1988117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988135 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988137 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988138 */     // GIR_Coverage, 61855,
     /* 1988138 */     GIR_EraseRootFromParent_Done,
     /* 1988139 */   // Label 26591: @1988139
     /* 1988139 */   GIM_Try, /*On fail goto*//*Label 26592*/ GIMT_Encode4(1988225), // Rule ID 61858 //
     /* 1988144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1988161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988167 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988190 */     // MIs[0] policy
     /* 1988190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988200 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1988203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988221 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988223 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988224 */     // GIR_Coverage, 61858,
     /* 1988224 */     GIR_EraseRootFromParent_Done,
     /* 1988225 */   // Label 26592: @1988225
     /* 1988225 */   GIM_Try, /*On fail goto*//*Label 26593*/ GIMT_Encode4(1988311), // Rule ID 61859 //
     /* 1988230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1988241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1988244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1988247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988253 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988276 */     // MIs[0] policy
     /* 1988276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988286 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1988289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988307 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988309 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988310 */     // GIR_Coverage, 61859,
     /* 1988310 */     GIR_EraseRootFromParent_Done,
     /* 1988311 */   // Label 26593: @1988311
     /* 1988311 */   GIM_Try, /*On fail goto*//*Label 26594*/ GIMT_Encode4(1988397), // Rule ID 61862 //
     /* 1988316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1988327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1988330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1988333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988339 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988362 */     // MIs[0] policy
     /* 1988362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988372 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1988375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988393 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988395 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988396 */     // GIR_Coverage, 61862,
     /* 1988396 */     GIR_EraseRootFromParent_Done,
     /* 1988397 */   // Label 26594: @1988397
     /* 1988397 */   GIM_Try, /*On fail goto*//*Label 26595*/ GIMT_Encode4(1988483), // Rule ID 61863 //
     /* 1988402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1988413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1988416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1988419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1988425 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988448 */     // MIs[0] policy
     /* 1988448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988458 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1988461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1988479 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988481 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988482 */     // GIR_Coverage, 61863,
     /* 1988482 */     GIR_EraseRootFromParent_Done,
     /* 1988483 */   // Label 26595: @1988483
     /* 1988483 */   GIM_Try, /*On fail goto*//*Label 26596*/ GIMT_Encode4(1988569), // Rule ID 61866 //
     /* 1988488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1988499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1988502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1988505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988511 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988534 */     // MIs[0] policy
     /* 1988534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988544 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1988547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988565 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988567 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988568 */     // GIR_Coverage, 61866,
     /* 1988568 */     GIR_EraseRootFromParent_Done,
     /* 1988569 */   // Label 26596: @1988569
     /* 1988569 */   GIM_Try, /*On fail goto*//*Label 26597*/ GIMT_Encode4(1988655), // Rule ID 61867 //
     /* 1988574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 1988585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 1988588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1988591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1988597 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1988604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1988612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988620 */     // MIs[0] policy
     /* 1988620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988630 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11459:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M2_MASK),
     /* 1988633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988651 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988653 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988654 */     // GIR_Coverage, 61867,
     /* 1988654 */     GIR_EraseRootFromParent_Done,
     /* 1988655 */   // Label 26597: @1988655
     /* 1988655 */   GIM_Try, /*On fail goto*//*Label 26598*/ GIMT_Encode4(1988741), // Rule ID 61870 //
     /* 1988660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988683 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988706 */     // MIs[0] policy
     /* 1988706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988716 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1988719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988737 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988739 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988740 */     // GIR_Coverage, 61870,
     /* 1988740 */     GIR_EraseRootFromParent_Done,
     /* 1988741 */   // Label 26598: @1988741
     /* 1988741 */   GIM_Try, /*On fail goto*//*Label 26599*/ GIMT_Encode4(1988827), // Rule ID 61871 //
     /* 1988746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 1988757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 1988760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1988763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1988769 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1988776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1988784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988792 */     // MIs[0] policy
     /* 1988792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988802 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11459:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M4_MASK),
     /* 1988805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988823 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988825 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988826 */     // GIR_Coverage, 61871,
     /* 1988826 */     GIR_EraseRootFromParent_Done,
     /* 1988827 */   // Label 26599: @1988827
     /* 1988827 */   GIM_Try, /*On fail goto*//*Label 26600*/ GIMT_Encode4(1988913), // Rule ID 61874 //
     /* 1988832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode0),
     /* 1988835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 1988852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988855 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1988858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988878 */     // MIs[0] policy
     /* 1988878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988888 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1988888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1988891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988909 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988911 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988912 */     // GIR_Coverage, 61874,
     /* 1988912 */     GIR_EraseRootFromParent_Done,
     /* 1988913 */   // Label 26600: @1988913
     /* 1988913 */   GIM_Try, /*On fail goto*//*Label 26601*/ GIMT_Encode4(1988999), // Rule ID 61875 //
     /* 1988918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HwMode1),
     /* 1988921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vror_mask),
     /* 1988926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 1988929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 1988932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1988935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 1988938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1988941 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1988944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1988948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1988956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1988960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1988964 */     // MIs[0] policy
     /* 1988964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1988967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1988974 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11459:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVROR_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1988974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VX_M8_MASK),
     /* 1988977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1988979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 1988981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1988983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1988985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1988987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1988992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1988995 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1988997 */     GIR_RootConstrainSelectedInstOperands,
     /* 1988998 */     // GIR_Coverage, 61875,
     /* 1988998 */     GIR_EraseRootFromParent_Done,
     /* 1988999 */   // Label 26601: @1988999
     /* 1988999 */   GIM_Try, /*On fail goto*//*Label 26602*/ GIMT_Encode4(1989085), // Rule ID 62579 //
     /* 1989004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1989021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1989024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989027 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989050 */     // MIs[0] policy
     /* 1989050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989060 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1989063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989081 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989083 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989084 */     // GIR_Coverage, 62579,
     /* 1989084 */     GIR_EraseRootFromParent_Done,
     /* 1989085 */   // Label 26602: @1989085
     /* 1989085 */   GIM_Try, /*On fail goto*//*Label 26603*/ GIMT_Encode4(1989171), // Rule ID 62580 //
     /* 1989090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1989107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1989110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989136 */     // MIs[0] policy
     /* 1989136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989146 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_MF2_MASK),
     /* 1989149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989167 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989169 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989170 */     // GIR_Coverage, 62580,
     /* 1989170 */     GIR_EraseRootFromParent_Done,
     /* 1989171 */   // Label 26603: @1989171
     /* 1989171 */   GIM_Try, /*On fail goto*//*Label 26604*/ GIMT_Encode4(1989257), // Rule ID 62583 //
     /* 1989176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989199 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989222 */     // MIs[0] policy
     /* 1989222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989232 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1989235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989253 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989255 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989256 */     // GIR_Coverage, 62583,
     /* 1989256 */     GIR_EraseRootFromParent_Done,
     /* 1989257 */   // Label 26604: @1989257
     /* 1989257 */   GIM_Try, /*On fail goto*//*Label 26605*/ GIMT_Encode4(1989343), // Rule ID 62584 //
     /* 1989262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1989273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1989276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1989279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1989282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1989285 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989308 */     // MIs[0] policy
     /* 1989308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989318 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M1_MASK),
     /* 1989321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989339 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989341 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989342 */     // GIR_Coverage, 62584,
     /* 1989342 */     GIR_EraseRootFromParent_Done,
     /* 1989343 */   // Label 26605: @1989343
     /* 1989343 */   GIM_Try, /*On fail goto*//*Label 26606*/ GIMT_Encode4(1989429), // Rule ID 62587 //
     /* 1989348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1989359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1989362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989371 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989394 */     // MIs[0] policy
     /* 1989394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11059:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1989407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989425 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989427 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989428 */     // GIR_Coverage, 62587,
     /* 1989428 */     GIR_EraseRootFromParent_Done,
     /* 1989429 */   // Label 26606: @1989429
     /* 1989429 */   GIM_Try, /*On fail goto*//*Label 26607*/ GIMT_Encode4(1989515), // Rule ID 62588 //
     /* 1989434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1989445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1989448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1989451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1989454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1989457 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1989464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1989476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989480 */     // MIs[0] policy
     /* 1989480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989490 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11059:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M2_MASK),
     /* 1989493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989511 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989513 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989514 */     // GIR_Coverage, 62588,
     /* 1989514 */     GIR_EraseRootFromParent_Done,
     /* 1989515 */   // Label 26607: @1989515
     /* 1989515 */   GIM_Try, /*On fail goto*//*Label 26608*/ GIMT_Encode4(1989601), // Rule ID 62591 //
     /* 1989520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1989531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1989534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1989537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1989540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989543 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989566 */     // MIs[0] policy
     /* 1989566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989576 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11059:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1989579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989581 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989597 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989599 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989600 */     // GIR_Coverage, 62591,
     /* 1989600 */     GIR_EraseRootFromParent_Done,
     /* 1989601 */   // Label 26608: @1989601
     /* 1989601 */   GIM_Try, /*On fail goto*//*Label 26609*/ GIMT_Encode4(1989687), // Rule ID 62592 //
     /* 1989606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1989617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1989620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1989623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1989626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1989629 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1989636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1989648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989652 */     // MIs[0] policy
     /* 1989652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989662 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11059:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M4_MASK),
     /* 1989665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989683 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989685 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989686 */     // GIR_Coverage, 62592,
     /* 1989686 */     GIR_EraseRootFromParent_Done,
     /* 1989687 */   // Label 26609: @1989687
     /* 1989687 */   GIM_Try, /*On fail goto*//*Label 26610*/ GIMT_Encode4(1989773), // Rule ID 62595 //
     /* 1989692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1989703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1989706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1989709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1989712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1989715 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1989722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989738 */     // MIs[0] policy
     /* 1989738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989748 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11059:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1989751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989753 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989769 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989771 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989772 */     // GIR_Coverage, 62595,
     /* 1989772 */     GIR_EraseRootFromParent_Done,
     /* 1989773 */   // Label 26610: @1989773
     /* 1989773 */   GIM_Try, /*On fail goto*//*Label 26611*/ GIMT_Encode4(1989859), // Rule ID 62596 //
     /* 1989778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1989789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1989792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1989795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1989798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1989801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1989808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1989820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989824 */     // MIs[0] policy
     /* 1989824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989834 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11059:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1989834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VV_M8_MASK),
     /* 1989837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989855 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989857 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989858 */     // GIR_Coverage, 62596,
     /* 1989858 */     GIR_EraseRootFromParent_Done,
     /* 1989859 */   // Label 26611: @1989859
     /* 1989859 */   GIM_Try, /*On fail goto*//*Label 26612*/ GIMT_Encode4(1989945), // Rule ID 62599 //
     /* 1989864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1989867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1989881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1989884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989887 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1989890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989910 */     // MIs[0] policy
     /* 1989910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1989920 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1989920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1989923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1989925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1989927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1989929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1989931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1989933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1989938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1989941 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1989943 */     GIR_RootConstrainSelectedInstOperands,
     /* 1989944 */     // GIR_Coverage, 62599,
     /* 1989944 */     GIR_EraseRootFromParent_Done,
     /* 1989945 */   // Label 26612: @1989945
     /* 1989945 */   GIM_Try, /*On fail goto*//*Label 26613*/ GIMT_Encode4(1990031), // Rule ID 62600 //
     /* 1989950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1989953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1989958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1989961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1989964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1989967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1989970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1989973 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1989976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1989980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1989988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1989992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1989996 */     // MIs[0] policy
     /* 1989996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1989999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990006 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_MF2_MASK),
     /* 1990009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990027 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990029 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990030 */     // GIR_Coverage, 62600,
     /* 1990030 */     GIR_EraseRootFromParent_Done,
     /* 1990031 */   // Label 26613: @1990031
     /* 1990031 */   GIM_Try, /*On fail goto*//*Label 26614*/ GIMT_Encode4(1990117), // Rule ID 62603 //
     /* 1990036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1990053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1990056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990059 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990082 */     // MIs[0] policy
     /* 1990082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1990095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990113 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990115 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990116 */     // GIR_Coverage, 62603,
     /* 1990116 */     GIR_EraseRootFromParent_Done,
     /* 1990117 */   // Label 26614: @1990117
     /* 1990117 */   GIM_Try, /*On fail goto*//*Label 26615*/ GIMT_Encode4(1990203), // Rule ID 62604 //
     /* 1990122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1990139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1990142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990145 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990168 */     // MIs[0] policy
     /* 1990168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990178 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11059:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M1_MASK),
     /* 1990181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990199 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990201 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990202 */     // GIR_Coverage, 62604,
     /* 1990202 */     GIR_EraseRootFromParent_Done,
     /* 1990203 */   // Label 26615: @1990203
     /* 1990203 */   GIM_Try, /*On fail goto*//*Label 26616*/ GIMT_Encode4(1990289), // Rule ID 62607 //
     /* 1990208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1990225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990231 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990254 */     // MIs[0] policy
     /* 1990254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11059:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1990267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990285 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990287 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990288 */     // GIR_Coverage, 62607,
     /* 1990288 */     GIR_EraseRootFromParent_Done,
     /* 1990289 */   // Label 26616: @1990289
     /* 1990289 */   GIM_Try, /*On fail goto*//*Label 26617*/ GIMT_Encode4(1990375), // Rule ID 62608 //
     /* 1990294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1990305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1990308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1990311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1990314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1990317 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1990324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1990336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990340 */     // MIs[0] policy
     /* 1990340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990350 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11059:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M2_MASK),
     /* 1990353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990371 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990374 */     // GIR_Coverage, 62608,
     /* 1990374 */     GIR_EraseRootFromParent_Done,
     /* 1990375 */   // Label 26617: @1990375
     /* 1990375 */   GIM_Try, /*On fail goto*//*Label 26618*/ GIMT_Encode4(1990461), // Rule ID 62611 //
     /* 1990380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1990391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1990394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1990397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990403 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990426 */     // MIs[0] policy
     /* 1990426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990436 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11059:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1990439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990457 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990459 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990460 */     // GIR_Coverage, 62611,
     /* 1990460 */     GIR_EraseRootFromParent_Done,
     /* 1990461 */   // Label 26618: @1990461
     /* 1990461 */   GIM_Try, /*On fail goto*//*Label 26619*/ GIMT_Encode4(1990547), // Rule ID 62612 //
     /* 1990466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1990477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1990480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1990483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1990486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1990489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1990496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1990508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990512 */     // MIs[0] policy
     /* 1990512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11059:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M4_MASK),
     /* 1990525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990543 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990545 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990546 */     // GIR_Coverage, 62612,
     /* 1990546 */     GIR_EraseRootFromParent_Done,
     /* 1990547 */   // Label 26619: @1990547
     /* 1990547 */   GIM_Try, /*On fail goto*//*Label 26620*/ GIMT_Encode4(1990633), // Rule ID 62615 //
     /* 1990552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1990563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1990566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1990569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990598 */     // MIs[0] policy
     /* 1990598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990608 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11059:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1990611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990629 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990631 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990632 */     // GIR_Coverage, 62615,
     /* 1990632 */     GIR_EraseRootFromParent_Done,
     /* 1990633 */   // Label 26620: @1990633
     /* 1990633 */   GIM_Try, /*On fail goto*//*Label 26621*/ GIMT_Encode4(1990719), // Rule ID 62616 //
     /* 1990638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqa_mask),
     /* 1990646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1990649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1990652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1990655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1990658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1990661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1990668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1990676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1990680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990684 */     // MIs[0] policy
     /* 1990684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990694 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11059:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQA_VX_M8_MASK),
     /* 1990697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990715 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990717 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990718 */     // GIR_Coverage, 62616,
     /* 1990718 */     GIR_EraseRootFromParent_Done,
     /* 1990719 */   // Label 26621: @1990719
     /* 1990719 */   GIM_Try, /*On fail goto*//*Label 26622*/ GIMT_Encode4(1990805), // Rule ID 62619 //
     /* 1990724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1990732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1990741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1990744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990747 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990770 */     // MIs[0] policy
     /* 1990770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990780 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1990783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990801 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990803 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990804 */     // GIR_Coverage, 62619,
     /* 1990804 */     GIR_EraseRootFromParent_Done,
     /* 1990805 */   // Label 26622: @1990805
     /* 1990805 */   GIM_Try, /*On fail goto*//*Label 26623*/ GIMT_Encode4(1990891), // Rule ID 62620 //
     /* 1990810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1990818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1990821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1990824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1990827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1990830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1990833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1990836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990856 */     // MIs[0] policy
     /* 1990856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1990866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_MF2_MASK),
     /* 1990869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990887 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990889 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990890 */     // GIR_Coverage, 62620,
     /* 1990890 */     GIR_EraseRootFromParent_Done,
     /* 1990891 */   // Label 26623: @1990891
     /* 1990891 */   GIM_Try, /*On fail goto*//*Label 26624*/ GIMT_Encode4(1990977), // Rule ID 62623 //
     /* 1990896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1990899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1990904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1990913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1990916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1990919 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1990922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1990926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1990938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1990942 */     // MIs[0] policy
     /* 1990942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1990945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1990952 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1990952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1990955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1990957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1990959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1990961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1990963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1990965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1990970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1990973 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1990975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1990976 */     // GIR_Coverage, 62623,
     /* 1990976 */     GIR_EraseRootFromParent_Done,
     /* 1990977 */   // Label 26624: @1990977
     /* 1990977 */   GIM_Try, /*On fail goto*//*Label 26625*/ GIMT_Encode4(1991063), // Rule ID 62624 //
     /* 1990982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1990985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1990990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1990993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1990996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1990999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1991002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991005 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991028 */     // MIs[0] policy
     /* 1991028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991038 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M1_MASK),
     /* 1991041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991059 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991061 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991062 */     // GIR_Coverage, 62624,
     /* 1991062 */     GIR_EraseRootFromParent_Done,
     /* 1991063 */   // Label 26625: @1991063
     /* 1991063 */   GIM_Try, /*On fail goto*//*Label 26626*/ GIMT_Encode4(1991149), // Rule ID 62627 //
     /* 1991068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1991085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1991088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991091 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991114 */     // MIs[0] policy
     /* 1991114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991124 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1991127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991129 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991145 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991147 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991148 */     // GIR_Coverage, 62627,
     /* 1991148 */     GIR_EraseRootFromParent_Done,
     /* 1991149 */   // Label 26626: @1991149
     /* 1991149 */   GIM_Try, /*On fail goto*//*Label 26627*/ GIMT_Encode4(1991235), // Rule ID 62628 //
     /* 1991154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1991157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1991171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1991174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991177 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991200 */     // MIs[0] policy
     /* 1991200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991210 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M2_MASK),
     /* 1991213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991231 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991233 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991234 */     // GIR_Coverage, 62628,
     /* 1991234 */     GIR_EraseRootFromParent_Done,
     /* 1991235 */   // Label 26627: @1991235
     /* 1991235 */   GIM_Try, /*On fail goto*//*Label 26628*/ GIMT_Encode4(1991321), // Rule ID 62631 //
     /* 1991240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1991257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1991260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991263 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991286 */     // MIs[0] policy
     /* 1991286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991296 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1991299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991317 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991319 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991320 */     // GIR_Coverage, 62631,
     /* 1991320 */     GIR_EraseRootFromParent_Done,
     /* 1991321 */   // Label 26628: @1991321
     /* 1991321 */   GIM_Try, /*On fail goto*//*Label 26629*/ GIMT_Encode4(1991407), // Rule ID 62632 //
     /* 1991326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1991329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1991337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1991340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1991343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1991346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1991349 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1991356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1991368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991372 */     // MIs[0] policy
     /* 1991372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991382 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M4_MASK),
     /* 1991385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991403 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991405 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991406 */     // GIR_Coverage, 62632,
     /* 1991406 */     GIR_EraseRootFromParent_Done,
     /* 1991407 */   // Label 26629: @1991407
     /* 1991407 */   GIM_Try, /*On fail goto*//*Label 26630*/ GIMT_Encode4(1991493), // Rule ID 62635 //
     /* 1991412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1991429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1991432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1991435 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991458 */     // MIs[0] policy
     /* 1991458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991468 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1991471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991489 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991491 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991492 */     // GIR_Coverage, 62635,
     /* 1991492 */     GIR_EraseRootFromParent_Done,
     /* 1991493 */   // Label 26630: @1991493
     /* 1991493 */   GIM_Try, /*On fail goto*//*Label 26631*/ GIMT_Encode4(1991579), // Rule ID 62636 //
     /* 1991498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1991501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1991509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1991512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1991515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1991518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1991521 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1991528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1991540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991544 */     // MIs[0] policy
     /* 1991544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991554 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VV_M8_MASK),
     /* 1991557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991575 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991578 */     // GIR_Coverage, 62636,
     /* 1991578 */     GIR_EraseRootFromParent_Done,
     /* 1991579 */   // Label 26631: @1991579
     /* 1991579 */   GIM_Try, /*On fail goto*//*Label 26632*/ GIMT_Encode4(1991665), // Rule ID 62639 //
     /* 1991584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1991595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1991598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1991601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1991604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991630 */     // MIs[0] policy
     /* 1991630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991640 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1991643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991661 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991663 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991664 */     // GIR_Coverage, 62639,
     /* 1991664 */     GIR_EraseRootFromParent_Done,
     /* 1991665 */   // Label 26632: @1991665
     /* 1991665 */   GIM_Try, /*On fail goto*//*Label 26633*/ GIMT_Encode4(1991751), // Rule ID 62640 //
     /* 1991670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1991673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1991681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1991684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1991687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1991690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1991693 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991716 */     // MIs[0] policy
     /* 1991716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991726 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_MF2_MASK),
     /* 1991729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991747 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991749 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991750 */     // GIR_Coverage, 62640,
     /* 1991750 */     GIR_EraseRootFromParent_Done,
     /* 1991751 */   // Label 26633: @1991751
     /* 1991751 */   GIM_Try, /*On fail goto*//*Label 26634*/ GIMT_Encode4(1991837), // Rule ID 62643 //
     /* 1991756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1991767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1991770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1991773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1991776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991779 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991802 */     // MIs[0] policy
     /* 1991802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991812 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1991815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991833 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991835 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991836 */     // GIR_Coverage, 62643,
     /* 1991836 */     GIR_EraseRootFromParent_Done,
     /* 1991837 */   // Label 26634: @1991837
     /* 1991837 */   GIM_Try, /*On fail goto*//*Label 26635*/ GIMT_Encode4(1991923), // Rule ID 62644 //
     /* 1991842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1991845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1991853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1991856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1991859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1991862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1991865 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1991868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1991872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1991884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991888 */     // MIs[0] policy
     /* 1991888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991898 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11063:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1991898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M1_MASK),
     /* 1991901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1991916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1991919 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1991921 */     GIR_RootConstrainSelectedInstOperands,
     /* 1991922 */     // GIR_Coverage, 62644,
     /* 1991922 */     GIR_EraseRootFromParent_Done,
     /* 1991923 */   // Label 26635: @1991923
     /* 1991923 */   GIM_Try, /*On fail goto*//*Label 26636*/ GIMT_Encode4(1992009), // Rule ID 62647 //
     /* 1991928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1991931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1991936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1991939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1991942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1991945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1991948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1991951 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1991954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1991958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1991966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1991970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1991974 */     // MIs[0] policy
     /* 1991974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1991977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1991984 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1991984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1991987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1991989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1991991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1991993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1991995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1991997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992005 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992007 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992008 */     // GIR_Coverage, 62647,
     /* 1992008 */     GIR_EraseRootFromParent_Done,
     /* 1992009 */   // Label 26636: @1992009
     /* 1992009 */   GIM_Try, /*On fail goto*//*Label 26637*/ GIMT_Encode4(1992095), // Rule ID 62648 //
     /* 1992014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1992022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1992025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1992028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1992031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1992034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992037 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992060 */     // MIs[0] policy
     /* 1992060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11063:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M2_MASK),
     /* 1992073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992091 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992093 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992094 */     // GIR_Coverage, 62648,
     /* 1992094 */     GIR_EraseRootFromParent_Done,
     /* 1992095 */   // Label 26637: @1992095
     /* 1992095 */   GIM_Try, /*On fail goto*//*Label 26638*/ GIMT_Encode4(1992181), // Rule ID 62651 //
     /* 1992100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1992108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1992111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1992114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1992117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1992120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992123 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992146 */     // MIs[0] policy
     /* 1992146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992156 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1992159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992177 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992179 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992180 */     // GIR_Coverage, 62651,
     /* 1992180 */     GIR_EraseRootFromParent_Done,
     /* 1992181 */   // Label 26638: @1992181
     /* 1992181 */   GIM_Try, /*On fail goto*//*Label 26639*/ GIMT_Encode4(1992267), // Rule ID 62652 //
     /* 1992186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1992194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1992197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1992200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1992203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1992206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992209 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992232 */     // MIs[0] policy
     /* 1992232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11063:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M4_MASK),
     /* 1992245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992263 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992265 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992266 */     // GIR_Coverage, 62652,
     /* 1992266 */     GIR_EraseRootFromParent_Done,
     /* 1992267 */   // Label 26639: @1992267
     /* 1992267 */   GIM_Try, /*On fail goto*//*Label 26640*/ GIMT_Encode4(1992353), // Rule ID 62655 //
     /* 1992272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1992280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1992283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1992286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1992289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1992292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1992295 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992318 */     // MIs[0] policy
     /* 1992318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992328 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1992331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992349 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992351 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992352 */     // GIR_Coverage, 62655,
     /* 1992352 */     GIR_EraseRootFromParent_Done,
     /* 1992353 */   // Label 26640: @1992353
     /* 1992353 */   GIM_Try, /*On fail goto*//*Label 26641*/ GIMT_Encode4(1992439), // Rule ID 62656 //
     /* 1992358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqau_mask),
     /* 1992366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1992369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1992372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1992375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1992378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1992381 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1992388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1992396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1992400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992404 */     // MIs[0] policy
     /* 1992404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992414 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11063:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAU_VX_M8_MASK),
     /* 1992417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992435 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992437 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992438 */     // GIR_Coverage, 62656,
     /* 1992438 */     GIR_EraseRootFromParent_Done,
     /* 1992439 */   // Label 26641: @1992439
     /* 1992439 */   GIM_Try, /*On fail goto*//*Label 26642*/ GIMT_Encode4(1992525), // Rule ID 62659 //
     /* 1992444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1992464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992467 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992490 */     // MIs[0] policy
     /* 1992490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992500 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1992503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992521 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992523 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992524 */     // GIR_Coverage, 62659,
     /* 1992524 */     GIR_EraseRootFromParent_Done,
     /* 1992525 */   // Label 26642: @1992525
     /* 1992525 */   GIM_Try, /*On fail goto*//*Label 26643*/ GIMT_Encode4(1992611), // Rule ID 62660 //
     /* 1992530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1992541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1992544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 1992547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1992550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1992553 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992576 */     // MIs[0] policy
     /* 1992576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992586 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_MF2_MASK),
     /* 1992589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992607 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992609 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992610 */     // GIR_Coverage, 62660,
     /* 1992610 */     GIR_EraseRootFromParent_Done,
     /* 1992611 */   // Label 26643: @1992611
     /* 1992611 */   GIM_Try, /*On fail goto*//*Label 26644*/ GIMT_Encode4(1992697), // Rule ID 62663 //
     /* 1992616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1992627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1992630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1992636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992639 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992662 */     // MIs[0] policy
     /* 1992662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992672 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1992675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992693 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992695 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992696 */     // GIR_Coverage, 62663,
     /* 1992696 */     GIR_EraseRootFromParent_Done,
     /* 1992697 */   // Label 26644: @1992697
     /* 1992697 */   GIM_Try, /*On fail goto*//*Label 26645*/ GIMT_Encode4(1992783), // Rule ID 62664 //
     /* 1992702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1992713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1992716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 1992719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1992722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1992725 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1992732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1992744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992748 */     // MIs[0] policy
     /* 1992748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992758 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M1_MASK),
     /* 1992761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992779 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992781 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992782 */     // GIR_Coverage, 62664,
     /* 1992782 */     GIR_EraseRootFromParent_Done,
     /* 1992783 */   // Label 26645: @1992783
     /* 1992783 */   GIM_Try, /*On fail goto*//*Label 26646*/ GIMT_Encode4(1992869), // Rule ID 62667 //
     /* 1992788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1992799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1992802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1992805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1992808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992811 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992834 */     // MIs[0] policy
     /* 1992834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992844 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1992844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1992847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992865 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992867 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992868 */     // GIR_Coverage, 62667,
     /* 1992868 */     GIR_EraseRootFromParent_Done,
     /* 1992869 */   // Label 26646: @1992869
     /* 1992869 */   GIM_Try, /*On fail goto*//*Label 26647*/ GIMT_Encode4(1992955), // Rule ID 62668 //
     /* 1992874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1992877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1992885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1992888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 1992891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1992894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1992897 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1992900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1992904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1992916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1992920 */     // MIs[0] policy
     /* 1992920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1992923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1992930 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1992930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M2_MASK),
     /* 1992933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1992935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1992937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1992939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1992941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1992943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1992948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1992951 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1992953 */     GIR_RootConstrainSelectedInstOperands,
     /* 1992954 */     // GIR_Coverage, 62668,
     /* 1992954 */     GIR_EraseRootFromParent_Done,
     /* 1992955 */   // Label 26647: @1992955
     /* 1992955 */   GIM_Try, /*On fail goto*//*Label 26648*/ GIMT_Encode4(1993041), // Rule ID 62671 //
     /* 1992960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1992963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1992968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1992971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1992974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1992977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1992980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1992983 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1992986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1992990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1992998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993006 */     // MIs[0] policy
     /* 1993006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993016 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1993019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993037 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993039 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993040 */     // GIR_Coverage, 62671,
     /* 1993040 */     GIR_EraseRootFromParent_Done,
     /* 1993041 */   // Label 26648: @1993041
     /* 1993041 */   GIM_Try, /*On fail goto*//*Label 26649*/ GIMT_Encode4(1993127), // Rule ID 62672 //
     /* 1993046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 1993063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993069 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993092 */     // MIs[0] policy
     /* 1993092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993102 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M4_MASK),
     /* 1993105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993123 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993125 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993126 */     // GIR_Coverage, 62672,
     /* 1993126 */     GIR_EraseRootFromParent_Done,
     /* 1993127 */   // Label 26649: @1993127
     /* 1993127 */   GIM_Try, /*On fail goto*//*Label 26650*/ GIMT_Encode4(1993213), // Rule ID 62675 //
     /* 1993132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1993143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1993146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1993152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993155 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993178 */     // MIs[0] policy
     /* 1993178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993188 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1993191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993209 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993211 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993212 */     // GIR_Coverage, 62675,
     /* 1993212 */     GIR_EraseRootFromParent_Done,
     /* 1993213 */   // Label 26650: @1993213
     /* 1993213 */   GIM_Try, /*On fail goto*//*Label 26651*/ GIMT_Encode4(1993299), // Rule ID 62676 //
     /* 1993218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1993229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1993232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 1993235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1993238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1993241 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1993248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1993260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993264 */     // MIs[0] policy
     /* 1993264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993274 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VV_M8_MASK),
     /* 1993277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993295 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993297 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993298 */     // GIR_Coverage, 62676,
     /* 1993298 */     GIR_EraseRootFromParent_Done,
     /* 1993299 */   // Label 26651: @1993299
     /* 1993299 */   GIM_Try, /*On fail goto*//*Label 26652*/ GIMT_Encode4(1993385), // Rule ID 62679 //
     /* 1993304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1993321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1993324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993327 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993350 */     // MIs[0] policy
     /* 1993350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993360 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1993363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993381 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993383 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993384 */     // GIR_Coverage, 62679,
     /* 1993384 */     GIR_EraseRootFromParent_Done,
     /* 1993385 */   // Label 26652: @1993385
     /* 1993385 */   GIM_Try, /*On fail goto*//*Label 26653*/ GIMT_Encode4(1993471), // Rule ID 62680 //
     /* 1993390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1993401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1993404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1993407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1993410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1993413 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993436 */     // MIs[0] policy
     /* 1993436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993446 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_MF2_MASK),
     /* 1993449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993467 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993469 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993470 */     // GIR_Coverage, 62680,
     /* 1993470 */     GIR_EraseRootFromParent_Done,
     /* 1993471 */   // Label 26653: @1993471
     /* 1993471 */   GIM_Try, /*On fail goto*//*Label 26654*/ GIMT_Encode4(1993557), // Rule ID 62683 //
     /* 1993476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1993493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1993496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993522 */     // MIs[0] policy
     /* 1993522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993532 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1993535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993553 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993555 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993556 */     // GIR_Coverage, 62683,
     /* 1993556 */     GIR_EraseRootFromParent_Done,
     /* 1993557 */   // Label 26654: @1993557
     /* 1993557 */   GIM_Try, /*On fail goto*//*Label 26655*/ GIMT_Encode4(1993643), // Rule ID 62684 //
     /* 1993562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1993573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1993576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1993579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1993582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1993585 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1993592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1993604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993608 */     // MIs[0] policy
     /* 1993608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993618 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11061:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M1_MASK),
     /* 1993621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993639 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993641 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993642 */     // GIR_Coverage, 62684,
     /* 1993642 */     GIR_EraseRootFromParent_Done,
     /* 1993643 */   // Label 26655: @1993643
     /* 1993643 */   GIM_Try, /*On fail goto*//*Label 26656*/ GIMT_Encode4(1993729), // Rule ID 62687 //
     /* 1993648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1993665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993671 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993694 */     // MIs[0] policy
     /* 1993694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1993707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993725 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993727 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993728 */     // GIR_Coverage, 62687,
     /* 1993728 */     GIR_EraseRootFromParent_Done,
     /* 1993729 */   // Label 26656: @1993729
     /* 1993729 */   GIM_Try, /*On fail goto*//*Label 26657*/ GIMT_Encode4(1993815), // Rule ID 62688 //
     /* 1993734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1993745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1993748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1993751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1993754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1993757 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1993764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1993776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993780 */     // MIs[0] policy
     /* 1993780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993790 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11061:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M2_MASK),
     /* 1993793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993811 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993813 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993814 */     // GIR_Coverage, 62688,
     /* 1993814 */     GIR_EraseRootFromParent_Done,
     /* 1993815 */   // Label 26657: @1993815
     /* 1993815 */   GIM_Try, /*On fail goto*//*Label 26658*/ GIMT_Encode4(1993901), // Rule ID 62691 //
     /* 1993820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1993837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1993846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993866 */     // MIs[0] policy
     /* 1993866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993876 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1993876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1993879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993897 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993899 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993900 */     // GIR_Coverage, 62691,
     /* 1993900 */     GIR_EraseRootFromParent_Done,
     /* 1993901 */   // Label 26658: @1993901
     /* 1993901 */   GIM_Try, /*On fail goto*//*Label 26659*/ GIMT_Encode4(1993987), // Rule ID 62692 //
     /* 1993906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1993909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1993914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1993917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1993920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1993923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1993926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1993929 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1993932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1993936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1993944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1993948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1993952 */     // MIs[0] policy
     /* 1993952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1993955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1993962 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11061:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1993962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M4_MASK),
     /* 1993965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1993967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1993969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1993971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1993973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1993975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1993980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1993983 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1993985 */     GIR_RootConstrainSelectedInstOperands,
     /* 1993986 */     // GIR_Coverage, 62692,
     /* 1993986 */     GIR_EraseRootFromParent_Done,
     /* 1993987 */   // Label 26659: @1993987
     /* 1993987 */   GIM_Try, /*On fail goto*//*Label 26660*/ GIMT_Encode4(1994073), // Rule ID 62695 //
     /* 1993992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1993995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1994000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994038 */     // MIs[0] policy
     /* 1994038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994048 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1994051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994069 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994071 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994072 */     // GIR_Coverage, 62695,
     /* 1994072 */     GIR_EraseRootFromParent_Done,
     /* 1994073 */   // Label 26660: @1994073
     /* 1994073 */   GIM_Try, /*On fail goto*//*Label 26661*/ GIMT_Encode4(1994159), // Rule ID 62696 //
     /* 1994078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqasu_mask),
     /* 1994086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994124 */     // MIs[0] policy
     /* 1994124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994134 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11061:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQASU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQASU_VX_M8_MASK),
     /* 1994137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994155 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994157 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994158 */     // GIR_Coverage, 62696,
     /* 1994158 */     GIR_EraseRootFromParent_Done,
     /* 1994159 */   // Label 26661: @1994159
     /* 1994159 */   GIM_Try, /*On fail goto*//*Label 26662*/ GIMT_Encode4(1994245), // Rule ID 62699 //
     /* 1994164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1994175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1994178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1994184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994187 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994210 */     // MIs[0] policy
     /* 1994210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994220 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1994223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994241 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994243 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994244 */     // GIR_Coverage, 62699,
     /* 1994244 */     GIR_EraseRootFromParent_Done,
     /* 1994245 */   // Label 26662: @1994245
     /* 1994245 */   GIM_Try, /*On fail goto*//*Label 26663*/ GIMT_Encode4(1994331), // Rule ID 62700 //
     /* 1994250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 1994261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 1994264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 1994270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1994273 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994296 */     // MIs[0] policy
     /* 1994296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994306 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11065:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_MF2_MASK),
     /* 1994309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994327 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994329 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994330 */     // GIR_Coverage, 62700,
     /* 1994330 */     GIR_EraseRootFromParent_Done,
     /* 1994331 */   // Label 26663: @1994331
     /* 1994331 */   GIM_Try, /*On fail goto*//*Label 26664*/ GIMT_Encode4(1994417), // Rule ID 62703 //
     /* 1994336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1994347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1994350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1994356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994359 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994382 */     // MIs[0] policy
     /* 1994382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994392 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1994395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994413 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994415 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994416 */     // GIR_Coverage, 62703,
     /* 1994416 */     GIR_EraseRootFromParent_Done,
     /* 1994417 */   // Label 26664: @1994417
     /* 1994417 */   GIM_Try, /*On fail goto*//*Label 26665*/ GIMT_Encode4(1994503), // Rule ID 62704 //
     /* 1994422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1994433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1994436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 1994442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1994445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1994452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1994464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994468 */     // MIs[0] policy
     /* 1994468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11065:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M1_MASK),
     /* 1994481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994499 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994501 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994502 */     // GIR_Coverage, 62704,
     /* 1994502 */     GIR_EraseRootFromParent_Done,
     /* 1994503 */   // Label 26665: @1994503
     /* 1994503 */   GIM_Try, /*On fail goto*//*Label 26666*/ GIMT_Encode4(1994589), // Rule ID 62707 //
     /* 1994508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1994528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994531 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994554 */     // MIs[0] policy
     /* 1994554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11065:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1994567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994585 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994587 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994588 */     // GIR_Coverage, 62707,
     /* 1994588 */     GIR_EraseRootFromParent_Done,
     /* 1994589 */   // Label 26666: @1994589
     /* 1994589 */   GIM_Try, /*On fail goto*//*Label 26667*/ GIMT_Encode4(1994675), // Rule ID 62708 //
     /* 1994594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 1994605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 1994608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 1994614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1994617 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 1994624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1994636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994640 */     // MIs[0] policy
     /* 1994640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994650 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11065:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M2_MASK),
     /* 1994653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994671 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994673 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994674 */     // GIR_Coverage, 62708,
     /* 1994674 */     GIR_EraseRootFromParent_Done,
     /* 1994675 */   // Label 26667: @1994675
     /* 1994675 */   GIM_Try, /*On fail goto*//*Label 26668*/ GIMT_Encode4(1994761), // Rule ID 62711 //
     /* 1994680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1994700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994703 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994726 */     // MIs[0] policy
     /* 1994726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994736 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11065:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1994739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994757 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994759 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994760 */     // GIR_Coverage, 62711,
     /* 1994760 */     GIR_EraseRootFromParent_Done,
     /* 1994761 */   // Label 26668: @1994761
     /* 1994761 */   GIM_Try, /*On fail goto*//*Label 26669*/ GIMT_Encode4(1994847), // Rule ID 62712 //
     /* 1994766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 1994777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 1994780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 1994786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1994789 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 1994796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1994808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994812 */     // MIs[0] policy
     /* 1994812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994822 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11065:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M4_MASK),
     /* 1994825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994827 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994843 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994845 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994846 */     // GIR_Coverage, 62712,
     /* 1994846 */     GIR_EraseRootFromParent_Done,
     /* 1994847 */   // Label 26669: @1994847
     /* 1994847 */   GIM_Try, /*On fail goto*//*Label 26670*/ GIMT_Encode4(1994933), // Rule ID 62715 //
     /* 1994852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode0),
     /* 1994855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1994869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s64,
     /* 1994878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994898 */     // MIs[0] policy
     /* 1994898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994908 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11065:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i64] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 1994908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1994911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1994915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1994917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1994919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1994921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1994926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1994929 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1994931 */     GIR_RootConstrainSelectedInstOperands,
     /* 1994932 */     // GIR_Coverage, 62715,
     /* 1994932 */     GIR_EraseRootFromParent_Done,
     /* 1994933 */   // Label 26670: @1994933
     /* 1994933 */   GIM_Try, /*On fail goto*//*Label 26671*/ GIMT_Encode4(1995019), // Rule ID 62716 //
     /* 1994938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadVdot_HwMode1),
     /* 1994941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_th_vmaqaus_mask),
     /* 1994946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 1994949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 1994952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 1994955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 1994958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 1994961 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /* 1994964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 1994968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 1994976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1994980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1994984 */     // MIs[0] policy
     /* 1994984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/7,
     /* 1994987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/6, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1994994 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11065:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoTHVdotVMAQAUS_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs3, GPR:{ *:[i32] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 1994994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoTHVdotVMAQAUS_VX_M8_MASK),
     /* 1994997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1994999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995015 */     GIR_RootToRootCopy, /*OpIdx*/7, // policy
     /* 1995017 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995018 */     // GIR_Coverage, 62716,
     /* 1995018 */     GIR_EraseRootFromParent_Done,
     /* 1995019 */   // Label 26671: @1995019
     /* 1995019 */   GIM_Try, /*On fail goto*//*Label 26672*/ GIMT_Encode4(1995108), // Rule ID 2676 //
     /* 1995024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1995027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1995041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995070 */     // MIs[0] round
     /* 1995070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995080 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1995083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995106 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995107 */     // GIR_Coverage, 2676,
     /* 1995107 */     GIR_EraseRootFromParent_Done,
     /* 1995108 */   // Label 26672: @1995108
     /* 1995108 */   GIM_Try, /*On fail goto*//*Label 26673*/ GIMT_Encode4(1995197), // Rule ID 2677 //
     /* 1995113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1995116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1995130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995159 */     // MIs[0] round
     /* 1995159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995169 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1995169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF4_E16_MASK),
     /* 1995172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995195 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995196 */     // GIR_Coverage, 2677,
     /* 1995196 */     GIR_EraseRootFromParent_Done,
     /* 1995197 */   // Label 26673: @1995197
     /* 1995197 */   GIM_Try, /*On fail goto*//*Label 26674*/ GIMT_Encode4(1995286), // Rule ID 22714 //
     /* 1995202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1995205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1995219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995248 */     // MIs[0] round
     /* 1995248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995258 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1995261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995284 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995285 */     // GIR_Coverage, 22714,
     /* 1995285 */     GIR_EraseRootFromParent_Done,
     /* 1995286 */   // Label 26674: @1995286
     /* 1995286 */   GIM_Try, /*On fail goto*//*Label 26675*/ GIMT_Encode4(1995375), // Rule ID 22715 //
     /* 1995291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1995294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1995308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995337 */     // MIs[0] round
     /* 1995337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995347 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1995347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E16_MASK),
     /* 1995350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995373 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995374 */     // GIR_Coverage, 22715,
     /* 1995374 */     GIR_EraseRootFromParent_Done,
     /* 1995375 */   // Label 26675: @1995375
     /* 1995375 */   GIM_Try, /*On fail goto*//*Label 26676*/ GIMT_Encode4(1995464), // Rule ID 22718 //
     /* 1995380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1995383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1995397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1995400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995426 */     // MIs[0] round
     /* 1995426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995436 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1995439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995462 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995463 */     // GIR_Coverage, 22718,
     /* 1995463 */     GIR_EraseRootFromParent_Done,
     /* 1995464 */   // Label 26676: @1995464
     /* 1995464 */   GIM_Try, /*On fail goto*//*Label 26677*/ GIMT_Encode4(1995553), // Rule ID 22719 //
     /* 1995469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1995472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1995486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1995489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995515 */     // MIs[0] round
     /* 1995515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995525 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1995525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_MF2_E32_MASK),
     /* 1995528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995551 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995552 */     // GIR_Coverage, 22719,
     /* 1995552 */     GIR_EraseRootFromParent_Done,
     /* 1995553 */   // Label 26677: @1995553
     /* 1995553 */   GIM_Try, /*On fail goto*//*Label 26678*/ GIMT_Encode4(1995642), // Rule ID 22722 //
     /* 1995558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1995561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1995575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995604 */     // MIs[0] round
     /* 1995604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995614 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 1995617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995640 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995641 */     // GIR_Coverage, 22722,
     /* 1995641 */     GIR_EraseRootFromParent_Done,
     /* 1995642 */   // Label 26678: @1995642
     /* 1995642 */   GIM_Try, /*On fail goto*//*Label 26679*/ GIMT_Encode4(1995731), // Rule ID 22723 //
     /* 1995647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1995650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1995658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1995661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1995664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1995667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1995670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995693 */     // MIs[0] round
     /* 1995693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995703 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1995703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E16_MASK),
     /* 1995706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1995726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995729 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995730 */     // GIR_Coverage, 22723,
     /* 1995730 */     GIR_EraseRootFromParent_Done,
     /* 1995731 */   // Label 26679: @1995731
     /* 1995731 */   GIM_Try, /*On fail goto*//*Label 26680*/ GIMT_Encode4(1995820), // Rule ID 22726 //
     /* 1995736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1995739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1995753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1995756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995782 */     // MIs[0] round
     /* 1995782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995792 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 1995795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995818 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995819 */     // GIR_Coverage, 22726,
     /* 1995819 */     GIR_EraseRootFromParent_Done,
     /* 1995820 */   // Label 26680: @1995820
     /* 1995820 */   GIM_Try, /*On fail goto*//*Label 26681*/ GIMT_Encode4(1995909), // Rule ID 22727 //
     /* 1995825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1995828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1995836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1995839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1995842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1995845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1995848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1995851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995871 */     // MIs[0] round
     /* 1995871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995881 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1995881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E32_MASK),
     /* 1995884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1995904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995907 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995908 */     // GIR_Coverage, 22727,
     /* 1995908 */     GIR_EraseRootFromParent_Done,
     /* 1995909 */   // Label 26681: @1995909
     /* 1995909 */   GIM_Try, /*On fail goto*//*Label 26682*/ GIMT_Encode4(1995998), // Rule ID 22730 //
     /* 1995914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1995917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1995922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1995925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1995928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1995931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1995934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1995937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1995940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1995944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1995956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1995960 */     // MIs[0] round
     /* 1995960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1995963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1995970 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1995970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 1995973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1995975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1995977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1995979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1995981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1995983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1995985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1995990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1995993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1995996 */     GIR_RootConstrainSelectedInstOperands,
     /* 1995997 */     // GIR_Coverage, 22730,
     /* 1995997 */     GIR_EraseRootFromParent_Done,
     /* 1995998 */   // Label 26682: @1995998
     /* 1995998 */   GIM_Try, /*On fail goto*//*Label 26683*/ GIMT_Encode4(1996087), // Rule ID 22731 //
     /* 1996003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1996006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1996014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1996017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1996020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1996023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1996026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996049 */     // MIs[0] round
     /* 1996049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996059 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M1_E64_MASK),
     /* 1996062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1996082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996085 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996086 */     // GIR_Coverage, 22731,
     /* 1996086 */     GIR_EraseRootFromParent_Done,
     /* 1996087 */   // Label 26683: @1996087
     /* 1996087 */   GIM_Try, /*On fail goto*//*Label 26684*/ GIMT_Encode4(1996176), // Rule ID 22734 //
     /* 1996092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1996095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1996109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996138 */     // MIs[0] round
     /* 1996138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996148 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1996148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 1996151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996174 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996175 */     // GIR_Coverage, 22734,
     /* 1996175 */     GIR_EraseRootFromParent_Done,
     /* 1996176 */   // Label 26684: @1996176
     /* 1996176 */   GIM_Try, /*On fail goto*//*Label 26685*/ GIMT_Encode4(1996265), // Rule ID 22735 //
     /* 1996181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1996184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1996198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996227 */     // MIs[0] round
     /* 1996227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996237 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E16_MASK),
     /* 1996240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996263 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996264 */     // GIR_Coverage, 22735,
     /* 1996264 */     GIR_EraseRootFromParent_Done,
     /* 1996265 */   // Label 26685: @1996265
     /* 1996265 */   GIM_Try, /*On fail goto*//*Label 26686*/ GIMT_Encode4(1996354), // Rule ID 22738 //
     /* 1996270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1996273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1996287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996316 */     // MIs[0] round
     /* 1996316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996326 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1996326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 1996329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996352 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996353 */     // GIR_Coverage, 22738,
     /* 1996353 */     GIR_EraseRootFromParent_Done,
     /* 1996354 */   // Label 26686: @1996354
     /* 1996354 */   GIM_Try, /*On fail goto*//*Label 26687*/ GIMT_Encode4(1996443), // Rule ID 22739 //
     /* 1996359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1996362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1996376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1996382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996405 */     // MIs[0] round
     /* 1996405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996415 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E16_MASK),
     /* 1996418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996441 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996442 */     // GIR_Coverage, 22739,
     /* 1996442 */     GIR_EraseRootFromParent_Done,
     /* 1996443 */   // Label 26687: @1996443
     /* 1996443 */   GIM_Try, /*On fail goto*//*Label 26688*/ GIMT_Encode4(1996532), // Rule ID 22742 //
     /* 1996448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1996451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1996465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996494 */     // MIs[0] round
     /* 1996494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996504 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1996504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 1996507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996530 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996531 */     // GIR_Coverage, 22742,
     /* 1996531 */     GIR_EraseRootFromParent_Done,
     /* 1996532 */   // Label 26688: @1996532
     /* 1996532 */   GIM_Try, /*On fail goto*//*Label 26689*/ GIMT_Encode4(1996621), // Rule ID 22743 //
     /* 1996537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1996540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1996548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1996551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1996554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1996557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1996560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1996575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996583 */     // MIs[0] round
     /* 1996583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996593 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11189:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E16_MASK),
     /* 1996596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1996616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996619 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996620 */     // GIR_Coverage, 22743,
     /* 1996620 */     GIR_EraseRootFromParent_Done,
     /* 1996621 */   // Label 26689: @1996621
     /* 1996621 */   GIM_Try, /*On fail goto*//*Label 26690*/ GIMT_Encode4(1996710), // Rule ID 22746 //
     /* 1996626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1996629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1996643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1996646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996672 */     // MIs[0] round
     /* 1996672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996682 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1996682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 1996685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996708 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996709 */     // GIR_Coverage, 22746,
     /* 1996709 */     GIR_EraseRootFromParent_Done,
     /* 1996710 */   // Label 26690: @1996710
     /* 1996710 */   GIM_Try, /*On fail goto*//*Label 26691*/ GIMT_Encode4(1996799), // Rule ID 22747 //
     /* 1996715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1996718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1996732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1996735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1996738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1996753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996761 */     // MIs[0] round
     /* 1996761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996771 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E32_MASK),
     /* 1996774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996797 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996798 */     // GIR_Coverage, 22747,
     /* 1996798 */     GIR_EraseRootFromParent_Done,
     /* 1996799 */   // Label 26691: @1996799
     /* 1996799 */   GIM_Try, /*On fail goto*//*Label 26692*/ GIMT_Encode4(1996888), // Rule ID 22750 //
     /* 1996804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1996807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1996821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1996824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1996830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996850 */     // MIs[0] round
     /* 1996850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996860 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1996860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 1996863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996886 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996887 */     // GIR_Coverage, 22750,
     /* 1996887 */     GIR_EraseRootFromParent_Done,
     /* 1996888 */   // Label 26692: @1996888
     /* 1996888 */   GIM_Try, /*On fail goto*//*Label 26693*/ GIMT_Encode4(1996977), // Rule ID 22751 //
     /* 1996893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1996896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1996910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1996913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1996916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1996919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1996923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1996931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1996935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1996939 */     // MIs[0] round
     /* 1996939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1996942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1996949 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1996949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E32_MASK),
     /* 1996952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1996954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1996956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1996958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1996960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1996962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1996964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1996969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1996972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1996975 */     GIR_RootConstrainSelectedInstOperands,
     /* 1996976 */     // GIR_Coverage, 22751,
     /* 1996976 */     GIR_EraseRootFromParent_Done,
     /* 1996977 */   // Label 26693: @1996977
     /* 1996977 */   GIM_Try, /*On fail goto*//*Label 26694*/ GIMT_Encode4(1997066), // Rule ID 22754 //
     /* 1996982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1996985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1996990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1996993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1996996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1996999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1997002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997028 */     // MIs[0] round
     /* 1997028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997038 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 1997041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997064 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997065 */     // GIR_Coverage, 22754,
     /* 1997065 */     GIR_EraseRootFromParent_Done,
     /* 1997066 */   // Label 26694: @1997066
     /* 1997066 */   GIM_Try, /*On fail goto*//*Label 26695*/ GIMT_Encode4(1997155), // Rule ID 22755 //
     /* 1997071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1997074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1997082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1997085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1997088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1997091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1997094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997117 */     // MIs[0] round
     /* 1997117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997127 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11189:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1997127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E32_MASK),
     /* 1997130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1997150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997153 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997154 */     // GIR_Coverage, 22755,
     /* 1997154 */     GIR_EraseRootFromParent_Done,
     /* 1997155 */   // Label 26695: @1997155
     /* 1997155 */   GIM_Try, /*On fail goto*//*Label 26696*/ GIMT_Encode4(1997244), // Rule ID 22758 //
     /* 1997160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1997163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1997177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997206 */     // MIs[0] round
     /* 1997206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997216 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 1997219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997242 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997243 */     // GIR_Coverage, 22758,
     /* 1997243 */     GIR_EraseRootFromParent_Done,
     /* 1997244 */   // Label 26696: @1997244
     /* 1997244 */   GIM_Try, /*On fail goto*//*Label 26697*/ GIMT_Encode4(1997333), // Rule ID 22759 //
     /* 1997249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1997252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1997266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1997287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997295 */     // MIs[0] round
     /* 1997295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997305 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1997305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M2_E64_MASK),
     /* 1997308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997331 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997332 */     // GIR_Coverage, 22759,
     /* 1997332 */     GIR_EraseRootFromParent_Done,
     /* 1997333 */   // Label 26697: @1997333
     /* 1997333 */   GIM_Try, /*On fail goto*//*Label 26698*/ GIMT_Encode4(1997422), // Rule ID 22762 //
     /* 1997338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1997341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1997355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997384 */     // MIs[0] round
     /* 1997384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997394 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 1997397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997420 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997421 */     // GIR_Coverage, 22762,
     /* 1997421 */     GIR_EraseRootFromParent_Done,
     /* 1997422 */   // Label 26698: @1997422
     /* 1997422 */   GIM_Try, /*On fail goto*//*Label 26699*/ GIMT_Encode4(1997511), // Rule ID 22763 //
     /* 1997427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1997430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 1997444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1997450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1997465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997473 */     // MIs[0] round
     /* 1997473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997483 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1997483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M4_E64_MASK),
     /* 1997486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997509 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997510 */     // GIR_Coverage, 22763,
     /* 1997510 */     GIR_EraseRootFromParent_Done,
     /* 1997511 */   // Label 26699: @1997511
     /* 1997511 */   GIM_Try, /*On fail goto*//*Label 26700*/ GIMT_Encode4(1997600), // Rule ID 22766 //
     /* 1997516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1997519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1997533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997562 */     // MIs[0] round
     /* 1997562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997572 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 1997575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997598 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997599 */     // GIR_Coverage, 22766,
     /* 1997599 */     GIR_EraseRootFromParent_Done,
     /* 1997600 */   // Label 26700: @1997600
     /* 1997600 */   GIM_Try, /*On fail goto*//*Label 26701*/ GIMT_Encode4(1997689), // Rule ID 22767 //
     /* 1997605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1997608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredosum_mask),
     /* 1997613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1997616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1997619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 1997622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1997625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1997628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1997643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997651 */     // MIs[0] round
     /* 1997651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997661 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11189:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDOSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1997661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDOSUM_VS_M8_E64_MASK),
     /* 1997664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1997684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997687 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997688 */     // GIR_Coverage, 22767,
     /* 1997688 */     GIR_EraseRootFromParent_Done,
     /* 1997689 */   // Label 26701: @1997689
     /* 1997689 */   GIM_Try, /*On fail goto*//*Label 26702*/ GIMT_Encode4(1997778), // Rule ID 22770 //
     /* 1997694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1997697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1997702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1997711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997740 */     // MIs[0] round
     /* 1997740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997750 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 1997753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997755 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997776 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997777 */     // GIR_Coverage, 22770,
     /* 1997777 */     GIR_EraseRootFromParent_Done,
     /* 1997778 */   // Label 26702: @1997778
     /* 1997778 */   GIM_Try, /*On fail goto*//*Label 26703*/ GIMT_Encode4(1997867), // Rule ID 22771 //
     /* 1997783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1997786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1997791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 1997800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1997806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997829 */     // MIs[0] round
     /* 1997829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997839 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1997839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF4_E16_MASK),
     /* 1997842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997865 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997866 */     // GIR_Coverage, 22771,
     /* 1997866 */     GIR_EraseRootFromParent_Done,
     /* 1997867 */   // Label 26703: @1997867
     /* 1997867 */   GIM_Try, /*On fail goto*//*Label 26704*/ GIMT_Encode4(1997956), // Rule ID 22774 //
     /* 1997872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1997875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1997880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1997889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1997898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1997918 */     // MIs[0] round
     /* 1997918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1997921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1997928 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1997928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 1997931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1997933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1997935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1997937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1997939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1997941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1997943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1997948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1997951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1997954 */     GIR_RootConstrainSelectedInstOperands,
     /* 1997955 */     // GIR_Coverage, 22774,
     /* 1997955 */     GIR_EraseRootFromParent_Done,
     /* 1997956 */   // Label 26704: @1997956
     /* 1997956 */   GIM_Try, /*On fail goto*//*Label 26705*/ GIMT_Encode4(1998045), // Rule ID 22775 //
     /* 1997961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1997964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1997969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1997972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1997975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 1997978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1997981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1997984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1997987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1997991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1997999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998007 */     // MIs[0] round
     /* 1998007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998017 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E16_MASK),
     /* 1998020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998043 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998044 */     // GIR_Coverage, 22775,
     /* 1998044 */     GIR_EraseRootFromParent_Done,
     /* 1998045 */   // Label 26705: @1998045
     /* 1998045 */   GIM_Try, /*On fail goto*//*Label 26706*/ GIMT_Encode4(1998134), // Rule ID 22778 //
     /* 1998050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1998053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1998067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1998070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1998073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998096 */     // MIs[0] round
     /* 1998096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998106 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 1998109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998111 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998132 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998133 */     // GIR_Coverage, 22778,
     /* 1998133 */     GIR_EraseRootFromParent_Done,
     /* 1998134 */   // Label 26706: @1998134
     /* 1998134 */   GIM_Try, /*On fail goto*//*Label 26707*/ GIMT_Encode4(1998223), // Rule ID 22779 //
     /* 1998139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1998142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 1998156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1998159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1998162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998185 */     // MIs[0] round
     /* 1998185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998195 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_MF2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_MF2_E32_MASK),
     /* 1998198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998221 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998222 */     // GIR_Coverage, 22779,
     /* 1998222 */     GIR_EraseRootFromParent_Done,
     /* 1998223 */   // Label 26707: @1998223
     /* 1998223 */   GIM_Try, /*On fail goto*//*Label 26708*/ GIMT_Encode4(1998312), // Rule ID 22782 //
     /* 1998228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1998231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1998239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1998242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1998245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1998248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998274 */     // MIs[0] round
     /* 1998274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998284 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 1998287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998310 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998311 */     // GIR_Coverage, 22782,
     /* 1998311 */     GIR_EraseRootFromParent_Done,
     /* 1998312 */   // Label 26708: @1998312
     /* 1998312 */   GIM_Try, /*On fail goto*//*Label 26709*/ GIMT_Encode4(1998401), // Rule ID 22783 //
     /* 1998317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1998320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1998328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1998331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 1998334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1998337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1998340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998363 */     // MIs[0] round
     /* 1998363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998373 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E16_MASK),
     /* 1998376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998399 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998400 */     // GIR_Coverage, 22783,
     /* 1998400 */     GIR_EraseRootFromParent_Done,
     /* 1998401 */   // Label 26709: @1998401
     /* 1998401 */   GIM_Try, /*On fail goto*//*Label 26710*/ GIMT_Encode4(1998490), // Rule ID 22786 //
     /* 1998406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1998409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1998423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1998426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1998429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998452 */     // MIs[0] round
     /* 1998452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998462 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 1998465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998488 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998489 */     // GIR_Coverage, 22786,
     /* 1998489 */     GIR_EraseRootFromParent_Done,
     /* 1998490 */   // Label 26710: @1998490
     /* 1998490 */   GIM_Try, /*On fail goto*//*Label 26711*/ GIMT_Encode4(1998579), // Rule ID 22787 //
     /* 1998495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1998498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1998506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1998509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 1998512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1998515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1998518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998541 */     // MIs[0] round
     /* 1998541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998551 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E32_MASK),
     /* 1998554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1998574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998577 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998578 */     // GIR_Coverage, 22787,
     /* 1998578 */     GIR_EraseRootFromParent_Done,
     /* 1998579 */   // Label 26711: @1998579
     /* 1998579 */   GIM_Try, /*On fail goto*//*Label 26712*/ GIMT_Encode4(1998668), // Rule ID 22790 //
     /* 1998584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1998587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1998595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1998598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1998601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1998604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1998607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998630 */     // MIs[0] round
     /* 1998630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998640 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 1998643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1998663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998666 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998667 */     // GIR_Coverage, 22790,
     /* 1998667 */     GIR_EraseRootFromParent_Done,
     /* 1998668 */   // Label 26712: @1998668
     /* 1998668 */   GIM_Try, /*On fail goto*//*Label 26713*/ GIMT_Encode4(1998757), // Rule ID 22791 //
     /* 1998673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1998676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1998684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1998687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 1998690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1998693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 1998696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998719 */     // MIs[0] round
     /* 1998719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998729 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M1_E64_MASK),
     /* 1998732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1998752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998755 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998756 */     // GIR_Coverage, 22791,
     /* 1998756 */     GIR_EraseRootFromParent_Done,
     /* 1998757 */   // Label 26713: @1998757
     /* 1998757 */   GIM_Try, /*On fail goto*//*Label 26714*/ GIMT_Encode4(1998846), // Rule ID 22794 //
     /* 1998762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1998765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1998773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1998776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1998779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1998782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998808 */     // MIs[0] round
     /* 1998808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998818 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 1998821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998844 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998845 */     // GIR_Coverage, 22794,
     /* 1998845 */     GIR_EraseRootFromParent_Done,
     /* 1998846 */   // Label 26714: @1998846
     /* 1998846 */   GIM_Try, /*On fail goto*//*Label 26715*/ GIMT_Encode4(1998935), // Rule ID 22795 //
     /* 1998851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1998854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1998862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1998865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 1998868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1998871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1998874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1998877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1998889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998897 */     // MIs[0] round
     /* 1998897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998907 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1998907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E16_MASK),
     /* 1998910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1998912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1998914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1998916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1998918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1998920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1998922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1998927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1998930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1998933 */     GIR_RootConstrainSelectedInstOperands,
     /* 1998934 */     // GIR_Coverage, 22795,
     /* 1998934 */     GIR_EraseRootFromParent_Done,
     /* 1998935 */   // Label 26715: @1998935
     /* 1998935 */   GIM_Try, /*On fail goto*//*Label 26716*/ GIMT_Encode4(1999024), // Rule ID 22798 //
     /* 1998940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1998943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1998948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1998951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1998954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1998957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1998960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1998963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1998966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1998970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1998978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1998982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1998986 */     // MIs[0] round
     /* 1998986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1998989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1998996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1998996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 1998999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999022 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999023 */     // GIR_Coverage, 22798,
     /* 1999023 */     GIR_EraseRootFromParent_Done,
     /* 1999024 */   // Label 26716: @1999024
     /* 1999024 */   GIM_Try, /*On fail goto*//*Label 26717*/ GIMT_Encode4(1999113), // Rule ID 22799 //
     /* 1999029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 1999046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999075 */     // MIs[0] round
     /* 1999075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999085 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E16_MASK),
     /* 1999088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999111 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999112 */     // GIR_Coverage, 22799,
     /* 1999112 */     GIR_EraseRootFromParent_Done,
     /* 1999113 */   // Label 26717: @1999113
     /* 1999113 */   GIM_Try, /*On fail goto*//*Label 26718*/ GIMT_Encode4(1999202), // Rule ID 22802 //
     /* 1999118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 1999121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1999135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999164 */     // MIs[0] round
     /* 1999164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999174 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 1999177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999200 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999201 */     // GIR_Coverage, 22802,
     /* 1999201 */     GIR_EraseRootFromParent_Done,
     /* 1999202 */   // Label 26718: @1999202
     /* 1999202 */   GIM_Try, /*On fail goto*//*Label 26719*/ GIMT_Encode4(1999291), // Rule ID 22803 //
     /* 1999207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 1999210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 1999218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 1999221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 1999224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 1999227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 1999230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999253 */     // MIs[0] round
     /* 1999253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999263 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11191:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E16_MASK),
     /* 1999266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 1999286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999289 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999290 */     // GIR_Coverage, 22803,
     /* 1999290 */     GIR_EraseRootFromParent_Done,
     /* 1999291 */   // Label 26719: @1999291
     /* 1999291 */   GIM_Try, /*On fail goto*//*Label 26720*/ GIMT_Encode4(1999380), // Rule ID 22806 //
     /* 1999296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1999299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1999313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999342 */     // MIs[0] round
     /* 1999342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999352 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 1999355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999378 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999379 */     // GIR_Coverage, 22806,
     /* 1999379 */     GIR_EraseRootFromParent_Done,
     /* 1999380 */   // Label 26720: @1999380
     /* 1999380 */   GIM_Try, /*On fail goto*//*Label 26721*/ GIMT_Encode4(1999469), // Rule ID 22807 //
     /* 1999385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1999388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 1999402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 1999408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999431 */     // MIs[0] round
     /* 1999431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999441 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E32_MASK),
     /* 1999444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999467 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999468 */     // GIR_Coverage, 22807,
     /* 1999468 */     GIR_EraseRootFromParent_Done,
     /* 1999469 */   // Label 26721: @1999469
     /* 1999469 */   GIM_Try, /*On fail goto*//*Label 26722*/ GIMT_Encode4(1999558), // Rule ID 22810 //
     /* 1999474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1999477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1999491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999520 */     // MIs[0] round
     /* 1999520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999530 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 1999533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999556 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999557 */     // GIR_Coverage, 22810,
     /* 1999557 */     GIR_EraseRootFromParent_Done,
     /* 1999558 */   // Label 26722: @1999558
     /* 1999558 */   GIM_Try, /*On fail goto*//*Label 26723*/ GIMT_Encode4(1999647), // Rule ID 22811 //
     /* 1999563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1999566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 1999580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 1999586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 1999601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999609 */     // MIs[0] round
     /* 1999609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999619 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E32_MASK),
     /* 1999622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999645 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999646 */     // GIR_Coverage, 22811,
     /* 1999646 */     GIR_EraseRootFromParent_Done,
     /* 1999647 */   // Label 26723: @1999647
     /* 1999647 */   GIM_Try, /*On fail goto*//*Label 26724*/ GIMT_Encode4(1999736), // Rule ID 22814 //
     /* 1999652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 1999655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1999669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999698 */     // MIs[0] round
     /* 1999698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999708 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 1999711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999734 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999735 */     // GIR_Coverage, 22814,
     /* 1999735 */     GIR_EraseRootFromParent_Done,
     /* 1999736 */   // Label 26724: @1999736
     /* 1999736 */   GIM_Try, /*On fail goto*//*Label 26725*/ GIMT_Encode4(1999825), // Rule ID 22815 //
     /* 1999741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 1999744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 1999752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 1999755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 1999758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 1999761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 1999764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 1999779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999787 */     // MIs[0] round
     /* 1999787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999797 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11191:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E32_MASK),
     /* 1999800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 1999820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999823 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999824 */     // GIR_Coverage, 22815,
     /* 1999824 */     GIR_EraseRootFromParent_Done,
     /* 1999825 */   // Label 26725: @1999825
     /* 1999825 */   GIM_Try, /*On fail goto*//*Label 26726*/ GIMT_Encode4(1999914), // Rule ID 22818 //
     /* 1999830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 1999833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1999841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1999844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1999847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1999850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 1999856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999876 */     // MIs[0] round
     /* 1999876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999886 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 1999886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 1999889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 1999912 */     GIR_RootConstrainSelectedInstOperands,
     /* 1999913 */     // GIR_Coverage, 22818,
     /* 1999913 */     GIR_EraseRootFromParent_Done,
     /* 1999914 */   // Label 26726: @1999914
     /* 1999914 */   GIM_Try, /*On fail goto*//*Label 26727*/ GIMT_Encode4(2000003), // Rule ID 22819 //
     /* 1999919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 1999922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 1999927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 1999930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 1999933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 1999936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 1999939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 1999942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 1999945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 1999949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 1999957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 1999961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 1999965 */     // MIs[0] round
     /* 1999965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 1999968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 1999975 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M2_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 1999975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M2_E64_MASK),
     /* 1999978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 1999980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 1999982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 1999984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 1999986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 1999988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 1999990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 1999995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 1999998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000002 */     // GIR_Coverage, 22819,
     /* 2000002 */     GIR_EraseRootFromParent_Done,
     /* 2000003 */   // Label 26727: @2000003
     /* 2000003 */   GIM_Try, /*On fail goto*//*Label 26728*/ GIMT_Encode4(2000092), // Rule ID 22822 //
     /* 2000008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2000011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2000016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2000025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000054 */     // MIs[0] round
     /* 2000054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000064 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2000067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000091 */     // GIR_Coverage, 22822,
     /* 2000091 */     GIR_EraseRootFromParent_Done,
     /* 2000092 */   // Label 26728: @2000092
     /* 2000092 */   GIM_Try, /*On fail goto*//*Label 26729*/ GIMT_Encode4(2000181), // Rule ID 22823 //
     /* 2000097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2000100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2000105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2000114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2000135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000143 */     // MIs[0] round
     /* 2000143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000153 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M4_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M4_E64_MASK),
     /* 2000156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000180 */     // GIR_Coverage, 22823,
     /* 2000180 */     GIR_EraseRootFromParent_Done,
     /* 2000181 */   // Label 26729: @2000181
     /* 2000181 */   GIM_Try, /*On fail goto*//*Label 26730*/ GIMT_Encode4(2000270), // Rule ID 22826 //
     /* 2000186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2000189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2000194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2000203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000232 */     // MIs[0] round
     /* 2000232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000242 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2000245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000269 */     // GIR_Coverage, 22826,
     /* 2000269 */     GIR_EraseRootFromParent_Done,
     /* 2000270 */   // Label 26730: @2000270
     /* 2000270 */   GIM_Try, /*On fail goto*//*Label 26731*/ GIMT_Encode4(2000359), // Rule ID 22827 //
     /* 2000275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2000278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfredusum_mask),
     /* 2000283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2000292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2000298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2000313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000321 */     // MIs[0] round
     /* 2000321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000331 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11191:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFREDUSUM_VS_M8_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFREDUSUM_VS_M8_E64_MASK),
     /* 2000334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2000354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000358 */     // GIR_Coverage, 22827,
     /* 2000358 */     GIR_EraseRootFromParent_Done,
     /* 2000359 */   // Label 26731: @2000359
     /* 2000359 */   GIM_Try, /*On fail goto*//*Label 26732*/ GIMT_Encode4(2000448), // Rule ID 22950 //
     /* 2000364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2000381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000410 */     // MIs[0] round
     /* 2000410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000420 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2000423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000447 */     // GIR_Coverage, 22950,
     /* 2000447 */     GIR_EraseRootFromParent_Done,
     /* 2000448 */   // Label 26732: @2000448
     /* 2000448 */   GIM_Try, /*On fail goto*//*Label 26733*/ GIMT_Encode4(2000537), // Rule ID 22951 //
     /* 2000453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2000470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000499 */     // MIs[0] round
     /* 2000499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000509 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF4_E16_MASK),
     /* 2000512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000536 */     // GIR_Coverage, 22951,
     /* 2000536 */     GIR_EraseRootFromParent_Done,
     /* 2000537 */   // Label 26733: @2000537
     /* 2000537 */   GIM_Try, /*On fail goto*//*Label 26734*/ GIMT_Encode4(2000626), // Rule ID 22954 //
     /* 2000542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2000559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000588 */     // MIs[0] round
     /* 2000588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000598 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2000601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000625 */     // GIR_Coverage, 22954,
     /* 2000625 */     GIR_EraseRootFromParent_Done,
     /* 2000626 */   // Label 26734: @2000626
     /* 2000626 */   GIM_Try, /*On fail goto*//*Label 26735*/ GIMT_Encode4(2000715), // Rule ID 22955 //
     /* 2000631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2000648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2000654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000677 */     // MIs[0] round
     /* 2000677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000687 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E16_MASK),
     /* 2000690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000714 */     // GIR_Coverage, 22955,
     /* 2000714 */     GIR_EraseRootFromParent_Done,
     /* 2000715 */   // Label 26735: @2000715
     /* 2000715 */   GIM_Try, /*On fail goto*//*Label 26736*/ GIMT_Encode4(2000804), // Rule ID 22958 //
     /* 2000720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2000723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2000737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000766 */     // MIs[0] round
     /* 2000766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000776 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2000779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000803 */     // GIR_Coverage, 22958,
     /* 2000803 */     GIR_EraseRootFromParent_Done,
     /* 2000804 */   // Label 26736: @2000804
     /* 2000804 */   GIM_Try, /*On fail goto*//*Label 26737*/ GIMT_Encode4(2000893), // Rule ID 22959 //
     /* 2000809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2000812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2000820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2000823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2000826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2000829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2000832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2000835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000855 */     // MIs[0] round
     /* 2000855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000865 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2000865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_MF2_E32_MASK),
     /* 2000868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2000888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000892 */     // GIR_Coverage, 22959,
     /* 2000892 */     GIR_EraseRootFromParent_Done,
     /* 2000893 */   // Label 26737: @2000893
     /* 2000893 */   GIM_Try, /*On fail goto*//*Label 26738*/ GIMT_Encode4(2000982), // Rule ID 22962 //
     /* 2000898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2000901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2000912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2000915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2000918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2000921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2000924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2000928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2000940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2000944 */     // MIs[0] round
     /* 2000944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2000947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2000954 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2000954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2000957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2000959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2000961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2000963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2000965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2000967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2000969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2000974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2000977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2000980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2000981 */     // GIR_Coverage, 22962,
     /* 2000981 */     GIR_EraseRootFromParent_Done,
     /* 2000982 */   // Label 26738: @2000982
     /* 2000982 */   GIM_Try, /*On fail goto*//*Label 26739*/ GIMT_Encode4(2001071), // Rule ID 22963 //
     /* 2000987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2000990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2000995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2000998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2001004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001033 */     // MIs[0] round
     /* 2001033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001043 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E16_MASK),
     /* 2001046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001070 */     // GIR_Coverage, 22963,
     /* 2001070 */     GIR_EraseRootFromParent_Done,
     /* 2001071 */   // Label 26739: @2001071
     /* 2001071 */   GIM_Try, /*On fail goto*//*Label 26740*/ GIMT_Encode4(2001160), // Rule ID 22966 //
     /* 2001076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2001093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001122 */     // MIs[0] round
     /* 2001122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001132 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2001135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001159 */     // GIR_Coverage, 22966,
     /* 2001159 */     GIR_EraseRootFromParent_Done,
     /* 2001160 */   // Label 26740: @2001160
     /* 2001160 */   GIM_Try, /*On fail goto*//*Label 26741*/ GIMT_Encode4(2001249), // Rule ID 22967 //
     /* 2001165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2001182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2001188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001211 */     // MIs[0] round
     /* 2001211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001221 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M1_E32_MASK),
     /* 2001224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001248 */     // GIR_Coverage, 22967,
     /* 2001248 */     GIR_EraseRootFromParent_Done,
     /* 2001249 */   // Label 26741: @2001249
     /* 2001249 */   GIM_Try, /*On fail goto*//*Label 26742*/ GIMT_Encode4(2001338), // Rule ID 22970 //
     /* 2001254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2001257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2001271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001300 */     // MIs[0] round
     /* 2001300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001310 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2001313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001337 */     // GIR_Coverage, 22970,
     /* 2001337 */     GIR_EraseRootFromParent_Done,
     /* 2001338 */   // Label 26742: @2001338
     /* 2001338 */   GIM_Try, /*On fail goto*//*Label 26743*/ GIMT_Encode4(2001427), // Rule ID 22971 //
     /* 2001343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2001346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2001360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001389 */     // MIs[0] round
     /* 2001389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001399 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E16_MASK),
     /* 2001402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001426 */     // GIR_Coverage, 22971,
     /* 2001426 */     GIR_EraseRootFromParent_Done,
     /* 2001427 */   // Label 26743: @2001427
     /* 2001427 */   GIM_Try, /*On fail goto*//*Label 26744*/ GIMT_Encode4(2001516), // Rule ID 22974 //
     /* 2001432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2001435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2001449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001478 */     // MIs[0] round
     /* 2001478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001488 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2001491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001515 */     // GIR_Coverage, 22974,
     /* 2001515 */     GIR_EraseRootFromParent_Done,
     /* 2001516 */   // Label 26744: @2001516
     /* 2001516 */   GIM_Try, /*On fail goto*//*Label 26745*/ GIMT_Encode4(2001605), // Rule ID 22975 //
     /* 2001521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2001524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2001538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2001544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2001559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001567 */     // MIs[0] round
     /* 2001567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001577 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E16_MASK),
     /* 2001580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001604 */     // GIR_Coverage, 22975,
     /* 2001604 */     GIR_EraseRootFromParent_Done,
     /* 2001605 */   // Label 26745: @2001605
     /* 2001605 */   GIM_Try, /*On fail goto*//*Label 26746*/ GIMT_Encode4(2001694), // Rule ID 22978 //
     /* 2001610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2001613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2001627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001656 */     // MIs[0] round
     /* 2001656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001666 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2001669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001693 */     // GIR_Coverage, 22978,
     /* 2001693 */     GIR_EraseRootFromParent_Done,
     /* 2001694 */   // Label 26746: @2001694
     /* 2001694 */   GIM_Try, /*On fail goto*//*Label 26747*/ GIMT_Encode4(2001783), // Rule ID 22979 //
     /* 2001699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2001702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2001710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2001713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2001716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2001719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2001722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2001737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001745 */     // MIs[0] round
     /* 2001745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001755 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11245:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E16_MASK),
     /* 2001758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2001778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001782 */     // GIR_Coverage, 22979,
     /* 2001782 */     GIR_EraseRootFromParent_Done,
     /* 2001783 */   // Label 26747: @2001783
     /* 2001783 */   GIM_Try, /*On fail goto*//*Label 26748*/ GIMT_Encode4(2001872), // Rule ID 22982 //
     /* 2001788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2001805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001834 */     // MIs[0] round
     /* 2001834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001844 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2001844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2001847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001871 */     // GIR_Coverage, 22982,
     /* 2001871 */     GIR_EraseRootFromParent_Done,
     /* 2001872 */   // Label 26748: @2001872
     /* 2001872 */   GIM_Try, /*On fail goto*//*Label 26749*/ GIMT_Encode4(2001961), // Rule ID 22983 //
     /* 2001877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2001880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2001894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2001900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2001903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2001915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2001919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2001923 */     // MIs[0] round
     /* 2001923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2001926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2001933 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2001933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M2_E32_MASK),
     /* 2001936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2001938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2001940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2001942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2001944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2001946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2001948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2001953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2001956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2001959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2001960 */     // GIR_Coverage, 22983,
     /* 2001960 */     GIR_EraseRootFromParent_Done,
     /* 2001961 */   // Label 26749: @2001961
     /* 2001961 */   GIM_Try, /*On fail goto*//*Label 26750*/ GIMT_Encode4(2002050), // Rule ID 22986 //
     /* 2001966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2001969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2001974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2001977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2001980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2001983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2001986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2001989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2001992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2001996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002012 */     // MIs[0] round
     /* 2002012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002022 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2002025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002049 */     // GIR_Coverage, 22986,
     /* 2002049 */     GIR_EraseRootFromParent_Done,
     /* 2002050 */   // Label 26750: @2002050
     /* 2002050 */   GIM_Try, /*On fail goto*//*Label 26751*/ GIMT_Encode4(2002139), // Rule ID 22987 //
     /* 2002055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2002063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2002072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2002078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2002093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002101 */     // MIs[0] round
     /* 2002101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002111 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M4_E32_MASK),
     /* 2002114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002138 */     // GIR_Coverage, 22987,
     /* 2002138 */     GIR_EraseRootFromParent_Done,
     /* 2002139 */   // Label 26751: @2002139
     /* 2002139 */   GIM_Try, /*On fail goto*//*Label 26752*/ GIMT_Encode4(2002228), // Rule ID 22990 //
     /* 2002144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2002152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2002161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002190 */     // MIs[0] round
     /* 2002190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002200 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2002203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002227 */     // GIR_Coverage, 22990,
     /* 2002227 */     GIR_EraseRootFromParent_Done,
     /* 2002228 */   // Label 26752: @2002228
     /* 2002228 */   GIM_Try, /*On fail goto*//*Label 26753*/ GIMT_Encode4(2002317), // Rule ID 22991 //
     /* 2002233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredusum_mask),
     /* 2002241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2002250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2002256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2002271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002279 */     // MIs[0] round
     /* 2002279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002289 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11245:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDUSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDUSUM_VS_M8_E32_MASK),
     /* 2002292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002316 */     // GIR_Coverage, 22991,
     /* 2002316 */     GIR_EraseRootFromParent_Done,
     /* 2002317 */   // Label 26753: @2002317
     /* 2002317 */   GIM_Try, /*On fail goto*//*Label 26754*/ GIMT_Encode4(2002406), // Rule ID 22994 //
     /* 2002322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002368 */     // MIs[0] round
     /* 2002368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002378 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2002381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002405 */     // GIR_Coverage, 22994,
     /* 2002405 */     GIR_EraseRootFromParent_Done,
     /* 2002406 */   // Label 26754: @2002406
     /* 2002406 */   GIM_Try, /*On fail goto*//*Label 26755*/ GIMT_Encode4(2002495), // Rule ID 22995 //
     /* 2002411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2002428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002457 */     // MIs[0] round
     /* 2002457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002467 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF4_E16_MASK),
     /* 2002470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002494 */     // GIR_Coverage, 22995,
     /* 2002494 */     GIR_EraseRootFromParent_Done,
     /* 2002495 */   // Label 26755: @2002495
     /* 2002495 */   GIM_Try, /*On fail goto*//*Label 26756*/ GIMT_Encode4(2002584), // Rule ID 22998 //
     /* 2002500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002546 */     // MIs[0] round
     /* 2002546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002556 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2002559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002583 */     // GIR_Coverage, 22998,
     /* 2002583 */     GIR_EraseRootFromParent_Done,
     /* 2002584 */   // Label 26756: @2002584
     /* 2002584 */   GIM_Try, /*On fail goto*//*Label 26757*/ GIMT_Encode4(2002673), // Rule ID 22999 //
     /* 2002589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2002606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2002612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002635 */     // MIs[0] round
     /* 2002635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002645 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E16_MASK),
     /* 2002648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002672 */     // GIR_Coverage, 22999,
     /* 2002672 */     GIR_EraseRootFromParent_Done,
     /* 2002673 */   // Label 26757: @2002673
     /* 2002673 */   GIM_Try, /*On fail goto*//*Label 26758*/ GIMT_Encode4(2002762), // Rule ID 23002 //
     /* 2002678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2002681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002724 */     // MIs[0] round
     /* 2002724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002734 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2002737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002739 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002761 */     // GIR_Coverage, 23002,
     /* 2002761 */     GIR_EraseRootFromParent_Done,
     /* 2002762 */   // Label 26758: @2002762
     /* 2002762 */   GIM_Try, /*On fail goto*//*Label 26759*/ GIMT_Encode4(2002851), // Rule ID 23003 //
     /* 2002767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2002770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2002778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2002781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2002784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2002787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2002790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002813 */     // MIs[0] round
     /* 2002813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002823 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2002823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_MF2_E32_MASK),
     /* 2002826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002828 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2002846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002850 */     // GIR_Coverage, 23003,
     /* 2002850 */     GIR_EraseRootFromParent_Done,
     /* 2002851 */   // Label 26759: @2002851
     /* 2002851 */   GIM_Try, /*On fail goto*//*Label 26760*/ GIMT_Encode4(2002940), // Rule ID 23006 //
     /* 2002856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2002859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2002882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002902 */     // MIs[0] round
     /* 2002902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2002912 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2002912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2002915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2002917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2002919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2002921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2002923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2002925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2002927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2002932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2002935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2002938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2002939 */     // GIR_Coverage, 23006,
     /* 2002939 */     GIR_EraseRootFromParent_Done,
     /* 2002940 */   // Label 26760: @2002940
     /* 2002940 */   GIM_Try, /*On fail goto*//*Label 26761*/ GIMT_Encode4(2003029), // Rule ID 23007 //
     /* 2002945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2002948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2002953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2002956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2002959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2002962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2002965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2002968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2002971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2002975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2002987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2002991 */     // MIs[0] round
     /* 2002991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2002994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003001 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E16_MASK),
     /* 2003004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003028 */     // GIR_Coverage, 23007,
     /* 2003028 */     GIR_EraseRootFromParent_Done,
     /* 2003029 */   // Label 26761: @2003029
     /* 2003029 */   GIM_Try, /*On fail goto*//*Label 26762*/ GIMT_Encode4(2003118), // Rule ID 23010 //
     /* 2003034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2003051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003080 */     // MIs[0] round
     /* 2003080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2003093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003117 */     // GIR_Coverage, 23010,
     /* 2003117 */     GIR_EraseRootFromParent_Done,
     /* 2003118 */   // Label 26762: @2003118
     /* 2003118 */   GIM_Try, /*On fail goto*//*Label 26763*/ GIMT_Encode4(2003207), // Rule ID 23011 //
     /* 2003123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2003140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2003146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003169 */     // MIs[0] round
     /* 2003169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003179 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M1_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M1_E32_MASK),
     /* 2003182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003206 */     // GIR_Coverage, 23011,
     /* 2003206 */     GIR_EraseRootFromParent_Done,
     /* 2003207 */   // Label 26763: @2003207
     /* 2003207 */   GIM_Try, /*On fail goto*//*Label 26764*/ GIMT_Encode4(2003296), // Rule ID 23014 //
     /* 2003212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003258 */     // MIs[0] round
     /* 2003258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003268 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2003271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003295 */     // GIR_Coverage, 23014,
     /* 2003295 */     GIR_EraseRootFromParent_Done,
     /* 2003296 */   // Label 26764: @2003296
     /* 2003296 */   GIM_Try, /*On fail goto*//*Label 26765*/ GIMT_Encode4(2003385), // Rule ID 23015 //
     /* 2003301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2003318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003347 */     // MIs[0] round
     /* 2003347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003357 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E16_MASK),
     /* 2003360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003384 */     // GIR_Coverage, 23015,
     /* 2003384 */     GIR_EraseRootFromParent_Done,
     /* 2003385 */   // Label 26765: @2003385
     /* 2003385 */   GIM_Try, /*On fail goto*//*Label 26766*/ GIMT_Encode4(2003474), // Rule ID 23018 //
     /* 2003390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003436 */     // MIs[0] round
     /* 2003436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003446 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2003449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003473 */     // GIR_Coverage, 23018,
     /* 2003473 */     GIR_EraseRootFromParent_Done,
     /* 2003474 */   // Label 26766: @2003474
     /* 2003474 */   GIM_Try, /*On fail goto*//*Label 26767*/ GIMT_Encode4(2003563), // Rule ID 23019 //
     /* 2003479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2003496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2003502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003525 */     // MIs[0] round
     /* 2003525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003535 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E16_MASK),
     /* 2003538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003562 */     // GIR_Coverage, 23019,
     /* 2003562 */     GIR_EraseRootFromParent_Done,
     /* 2003563 */   // Label 26767: @2003563
     /* 2003563 */   GIM_Try, /*On fail goto*//*Label 26768*/ GIMT_Encode4(2003652), // Rule ID 23022 //
     /* 2003568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2003571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003614 */     // MIs[0] round
     /* 2003614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003624 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2003627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003651 */     // GIR_Coverage, 23022,
     /* 2003651 */     GIR_EraseRootFromParent_Done,
     /* 2003652 */   // Label 26768: @2003652
     /* 2003652 */   GIM_Try, /*On fail goto*//*Label 26769*/ GIMT_Encode4(2003741), // Rule ID 23023 //
     /* 2003657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2003660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2003668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2003671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2003674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2003677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2003680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2003695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003703 */     // MIs[0] round
     /* 2003703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003713 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11243:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E16_MASK),
     /* 2003716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2003736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003740 */     // GIR_Coverage, 23023,
     /* 2003740 */     GIR_EraseRootFromParent_Done,
     /* 2003741 */   // Label 26769: @2003741
     /* 2003741 */   GIM_Try, /*On fail goto*//*Label 26770*/ GIMT_Encode4(2003830), // Rule ID 23026 //
     /* 2003746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003792 */     // MIs[0] round
     /* 2003792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003802 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2003805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003829 */     // GIR_Coverage, 23026,
     /* 2003829 */     GIR_EraseRootFromParent_Done,
     /* 2003830 */   // Label 26770: @2003830
     /* 2003830 */   GIM_Try, /*On fail goto*//*Label 26771*/ GIMT_Encode4(2003919), // Rule ID 23027 //
     /* 2003835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2003838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2003852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2003858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2003861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2003873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003881 */     // MIs[0] round
     /* 2003881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003891 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2003891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M2_E32_MASK),
     /* 2003894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2003911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2003914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2003917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2003918 */     // GIR_Coverage, 23027,
     /* 2003918 */     GIR_EraseRootFromParent_Done,
     /* 2003919 */   // Label 26771: @2003919
     /* 2003919 */   GIM_Try, /*On fail goto*//*Label 26772*/ GIMT_Encode4(2004008), // Rule ID 23030 //
     /* 2003924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2003927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2003932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2003935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2003938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2003941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2003944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2003947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2003950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2003954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2003962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2003966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2003970 */     // MIs[0] round
     /* 2003970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2003973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2003980 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2003980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2003983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2003985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2003987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2003989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2003991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2003993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2003995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004007 */     // GIR_Coverage, 23030,
     /* 2004007 */     GIR_EraseRootFromParent_Done,
     /* 2004008 */   // Label 26772: @2004008
     /* 2004008 */   GIM_Try, /*On fail goto*//*Label 26773*/ GIMT_Encode4(2004097), // Rule ID 23031 //
     /* 2004013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2004016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2004021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2004030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2004036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2004051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004059 */     // MIs[0] round
     /* 2004059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004069 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M4_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M4_E32_MASK),
     /* 2004072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004096 */     // GIR_Coverage, 23031,
     /* 2004096 */     GIR_EraseRootFromParent_Done,
     /* 2004097 */   // Label 26773: @2004097
     /* 2004097 */   GIM_Try, /*On fail goto*//*Label 26774*/ GIMT_Encode4(2004186), // Rule ID 23034 //
     /* 2004102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2004105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2004110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004148 */     // MIs[0] round
     /* 2004148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004158 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2004158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2004161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004185 */     // GIR_Coverage, 23034,
     /* 2004185 */     GIR_EraseRootFromParent_Done,
     /* 2004186 */   // Label 26774: @2004186
     /* 2004186 */   GIM_Try, /*On fail goto*//*Label 26775*/ GIMT_Encode4(2004275), // Rule ID 23035 //
     /* 2004191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2004194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwredosum_mask),
     /* 2004199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2004202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2004205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2004208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2004211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2004214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2004229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004237 */     // MIs[0] round
     /* 2004237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004247 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11243:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVFWREDOSUM_VS_M8_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2004247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWREDOSUM_VS_M8_E32_MASK),
     /* 2004250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2004254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2004258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2004270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2004273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004274 */     // GIR_Coverage, 23035,
     /* 2004274 */     GIR_EraseRootFromParent_Done,
     /* 2004275 */   // Label 26775: @2004275
     /* 2004275 */   GIM_Reject,
     /* 2004276 */ // Label 19773: @2004276
     /* 2004276 */ GIM_Try, /*On fail goto*//*Label 26776*/ GIMT_Encode4(2192577),
     /* 2004281 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/9,
     /* 2004284 */   GIM_Try, /*On fail goto*//*Label 26777*/ GIMT_Encode4(2004386), // Rule ID 15870 //
     /* 2004289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2004300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2004303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2004306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2004309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004339 */     // MIs[1] Operand 1
     /* 2004339 */     // No operand predicates
     /* 2004339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004343 */     // MIs[0] round
     /* 2004343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004346 */     // MIs[0] policy
     /* 2004346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004349 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004358 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2004361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004385 */     // GIR_Coverage, 15870,
     /* 2004385 */     GIR_EraseRootFromParent_Done,
     /* 2004386 */   // Label 26777: @2004386
     /* 2004386 */   GIM_Try, /*On fail goto*//*Label 26778*/ GIMT_Encode4(2004488), // Rule ID 15871 //
     /* 2004391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2004402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2004405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2004408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2004411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004437 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004441 */     // MIs[1] Operand 1
     /* 2004441 */     // No operand predicates
     /* 2004441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004445 */     // MIs[0] round
     /* 2004445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004448 */     // MIs[0] policy
     /* 2004448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004460 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF8_MASK),
     /* 2004463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004487 */     // GIR_Coverage, 15871,
     /* 2004487 */     GIR_EraseRootFromParent_Done,
     /* 2004488 */   // Label 26778: @2004488
     /* 2004488 */   GIM_Try, /*On fail goto*//*Label 26779*/ GIMT_Encode4(2004590), // Rule ID 15874 //
     /* 2004493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2004504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2004507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2004510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2004513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004543 */     // MIs[1] Operand 1
     /* 2004543 */     // No operand predicates
     /* 2004543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004547 */     // MIs[0] round
     /* 2004547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004550 */     // MIs[0] policy
     /* 2004550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004562 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2004565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004589 */     // GIR_Coverage, 15874,
     /* 2004589 */     GIR_EraseRootFromParent_Done,
     /* 2004590 */   // Label 26779: @2004590
     /* 2004590 */   GIM_Try, /*On fail goto*//*Label 26780*/ GIMT_Encode4(2004692), // Rule ID 15875 //
     /* 2004595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2004606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2004609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2004612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2004615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2004618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004641 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004645 */     // MIs[1] Operand 1
     /* 2004645 */     // No operand predicates
     /* 2004645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004649 */     // MIs[0] round
     /* 2004649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004652 */     // MIs[0] policy
     /* 2004652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004664 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2004667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004691 */     // GIR_Coverage, 15875,
     /* 2004691 */     GIR_EraseRootFromParent_Done,
     /* 2004692 */   // Label 26780: @2004692
     /* 2004692 */   GIM_Try, /*On fail goto*//*Label 26781*/ GIMT_Encode4(2004794), // Rule ID 15878 //
     /* 2004697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2004708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2004711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2004717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004743 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004747 */     // MIs[1] Operand 1
     /* 2004747 */     // No operand predicates
     /* 2004747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004751 */     // MIs[0] round
     /* 2004751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004754 */     // MIs[0] policy
     /* 2004754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004766 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2004769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004793 */     // GIR_Coverage, 15878,
     /* 2004793 */     GIR_EraseRootFromParent_Done,
     /* 2004794 */   // Label 26781: @2004794
     /* 2004794 */   GIM_Try, /*On fail goto*//*Label 26782*/ GIMT_Encode4(2004896), // Rule ID 15879 //
     /* 2004799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2004802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2004810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2004813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2004816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2004819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2004822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2004825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004845 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004849 */     // MIs[1] Operand 1
     /* 2004849 */     // No operand predicates
     /* 2004849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004853 */     // MIs[0] round
     /* 2004853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004856 */     // MIs[0] policy
     /* 2004856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004868 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2004868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2004871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2004892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004895 */     // GIR_Coverage, 15879,
     /* 2004895 */     GIR_EraseRootFromParent_Done,
     /* 2004896 */   // Label 26782: @2004896
     /* 2004896 */   GIM_Try, /*On fail goto*//*Label 26783*/ GIMT_Encode4(2004998), // Rule ID 15882 //
     /* 2004901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2004904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2004909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2004912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2004915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2004918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2004921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2004924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2004927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2004931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2004939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2004943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2004947 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2004951 */     // MIs[1] Operand 1
     /* 2004951 */     // No operand predicates
     /* 2004951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2004955 */     // MIs[0] round
     /* 2004955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2004958 */     // MIs[0] policy
     /* 2004958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2004961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2004963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2004970 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2004970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2004973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2004975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2004977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2004979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2004982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2004984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2004986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2004991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2004994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2004996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2004997 */     // GIR_Coverage, 15882,
     /* 2004997 */     GIR_EraseRootFromParent_Done,
     /* 2004998 */   // Label 26783: @2004998
     /* 2004998 */   GIM_Try, /*On fail goto*//*Label 26784*/ GIMT_Encode4(2005100), // Rule ID 15883 //
     /* 2005003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2005014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2005017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2005020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005053 */     // MIs[1] Operand 1
     /* 2005053 */     // No operand predicates
     /* 2005053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005057 */     // MIs[0] round
     /* 2005057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005060 */     // MIs[0] policy
     /* 2005060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005072 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF4_MASK),
     /* 2005075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005099 */     // GIR_Coverage, 15883,
     /* 2005099 */     GIR_EraseRootFromParent_Done,
     /* 2005100 */   // Label 26784: @2005100
     /* 2005100 */   GIM_Try, /*On fail goto*//*Label 26785*/ GIMT_Encode4(2005202), // Rule ID 15886 //
     /* 2005105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2005116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2005119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2005122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005155 */     // MIs[1] Operand 1
     /* 2005155 */     // No operand predicates
     /* 2005155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005159 */     // MIs[0] round
     /* 2005159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005162 */     // MIs[0] policy
     /* 2005162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005174 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2005177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005201 */     // GIR_Coverage, 15886,
     /* 2005201 */     GIR_EraseRootFromParent_Done,
     /* 2005202 */   // Label 26785: @2005202
     /* 2005202 */   GIM_Try, /*On fail goto*//*Label 26786*/ GIMT_Encode4(2005304), // Rule ID 15887 //
     /* 2005207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2005218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2005221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2005224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005253 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005257 */     // MIs[1] Operand 1
     /* 2005257 */     // No operand predicates
     /* 2005257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005261 */     // MIs[0] round
     /* 2005261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005264 */     // MIs[0] policy
     /* 2005264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005276 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2005279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005303 */     // GIR_Coverage, 15887,
     /* 2005303 */     GIR_EraseRootFromParent_Done,
     /* 2005304 */   // Label 26786: @2005304
     /* 2005304 */   GIM_Try, /*On fail goto*//*Label 26787*/ GIMT_Encode4(2005406), // Rule ID 15890 //
     /* 2005309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005355 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005359 */     // MIs[1] Operand 1
     /* 2005359 */     // No operand predicates
     /* 2005359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005363 */     // MIs[0] round
     /* 2005363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005366 */     // MIs[0] policy
     /* 2005366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005378 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2005381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005405 */     // GIR_Coverage, 15890,
     /* 2005405 */     GIR_EraseRootFromParent_Done,
     /* 2005406 */   // Label 26787: @2005406
     /* 2005406 */   GIM_Try, /*On fail goto*//*Label 26788*/ GIMT_Encode4(2005508), // Rule ID 15891 //
     /* 2005411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2005422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2005425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2005428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2005434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005457 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005461 */     // MIs[1] Operand 1
     /* 2005461 */     // No operand predicates
     /* 2005461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005465 */     // MIs[0] round
     /* 2005465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005468 */     // MIs[0] policy
     /* 2005468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005471 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005480 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_MF2_MASK),
     /* 2005483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2005504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005507 */     // GIR_Coverage, 15891,
     /* 2005507 */     GIR_EraseRootFromParent_Done,
     /* 2005508 */   // Label 26788: @2005508
     /* 2005508 */   GIM_Try, /*On fail goto*//*Label 26789*/ GIMT_Encode4(2005610), // Rule ID 15894 //
     /* 2005513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2005524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2005527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005563 */     // MIs[1] Operand 1
     /* 2005563 */     // No operand predicates
     /* 2005563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005567 */     // MIs[0] round
     /* 2005567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005570 */     // MIs[0] policy
     /* 2005570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005582 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2005585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005591 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2005606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005609 */     // GIR_Coverage, 15894,
     /* 2005609 */     GIR_EraseRootFromParent_Done,
     /* 2005610 */   // Label 26789: @2005610
     /* 2005610 */   GIM_Try, /*On fail goto*//*Label 26790*/ GIMT_Encode4(2005712), // Rule ID 15895 //
     /* 2005615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2005626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2005629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2005632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2005638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005665 */     // MIs[1] Operand 1
     /* 2005665 */     // No operand predicates
     /* 2005665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005669 */     // MIs[0] round
     /* 2005669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005672 */     // MIs[0] policy
     /* 2005672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005684 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2005687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2005708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005711 */     // GIR_Coverage, 15895,
     /* 2005711 */     GIR_EraseRootFromParent_Done,
     /* 2005712 */   // Label 26790: @2005712
     /* 2005712 */   GIM_Try, /*On fail goto*//*Label 26791*/ GIMT_Encode4(2005814), // Rule ID 15898 //
     /* 2005717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2005728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2005731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005767 */     // MIs[1] Operand 1
     /* 2005767 */     // No operand predicates
     /* 2005767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005771 */     // MIs[0] round
     /* 2005771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005774 */     // MIs[0] policy
     /* 2005774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005786 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2005789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005795 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005813 */     // GIR_Coverage, 15898,
     /* 2005813 */     GIR_EraseRootFromParent_Done,
     /* 2005814 */   // Label 26791: @2005814
     /* 2005814 */   GIM_Try, /*On fail goto*//*Label 26792*/ GIMT_Encode4(2005916), // Rule ID 15899 //
     /* 2005819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2005822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2005830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2005833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2005836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2005839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2005842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2005845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005865 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005869 */     // MIs[1] Operand 1
     /* 2005869 */     // No operand predicates
     /* 2005869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005873 */     // MIs[0] round
     /* 2005873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005876 */     // MIs[0] policy
     /* 2005876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005888 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2005888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2005891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2005900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2005902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2005904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2005909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2005912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2005914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2005915 */     // GIR_Coverage, 15899,
     /* 2005915 */     GIR_EraseRootFromParent_Done,
     /* 2005916 */   // Label 26792: @2005916
     /* 2005916 */   GIM_Try, /*On fail goto*//*Label 26793*/ GIMT_Encode4(2006018), // Rule ID 15902 //
     /* 2005921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2005924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2005929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2005932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2005935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2005938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2005941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2005944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2005947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2005951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2005959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2005963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2005967 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2005971 */     // MIs[1] Operand 1
     /* 2005971 */     // No operand predicates
     /* 2005971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2005975 */     // MIs[0] round
     /* 2005975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2005978 */     // MIs[0] policy
     /* 2005978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2005981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2005983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2005990 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2005990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2005993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2005995 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2005997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2005999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006017 */     // GIR_Coverage, 15902,
     /* 2006017 */     GIR_EraseRootFromParent_Done,
     /* 2006018 */   // Label 26793: @2006018
     /* 2006018 */   GIM_Try, /*On fail goto*//*Label 26794*/ GIMT_Encode4(2006120), // Rule ID 15903 //
     /* 2006023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2006034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2006037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2006040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2006046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006069 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006073 */     // MIs[1] Operand 1
     /* 2006073 */     // No operand predicates
     /* 2006073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006077 */     // MIs[0] round
     /* 2006077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006080 */     // MIs[0] policy
     /* 2006080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006092 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2006095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2006116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006119 */     // GIR_Coverage, 15903,
     /* 2006119 */     GIR_EraseRootFromParent_Done,
     /* 2006120 */   // Label 26794: @2006120
     /* 2006120 */   GIM_Try, /*On fail goto*//*Label 26795*/ GIMT_Encode4(2006222), // Rule ID 15906 //
     /* 2006125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2006128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2006142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2006145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006171 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006175 */     // MIs[1] Operand 1
     /* 2006175 */     // No operand predicates
     /* 2006175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006179 */     // MIs[0] round
     /* 2006179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006182 */     // MIs[0] policy
     /* 2006182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006194 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2006197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006221 */     // GIR_Coverage, 15906,
     /* 2006221 */     GIR_EraseRootFromParent_Done,
     /* 2006222 */   // Label 26795: @2006222
     /* 2006222 */   GIM_Try, /*On fail goto*//*Label 26796*/ GIMT_Encode4(2006324), // Rule ID 15907 //
     /* 2006227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2006230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2006238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2006241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2006244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2006250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2006257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2006265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006273 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006277 */     // MIs[1] Operand 1
     /* 2006277 */     // No operand predicates
     /* 2006277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006281 */     // MIs[0] round
     /* 2006281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006284 */     // MIs[0] policy
     /* 2006284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006296 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M1_MASK),
     /* 2006299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2006320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006323 */     // GIR_Coverage, 15907,
     /* 2006323 */     GIR_EraseRootFromParent_Done,
     /* 2006324 */   // Label 26796: @2006324
     /* 2006324 */   GIM_Try, /*On fail goto*//*Label 26797*/ GIMT_Encode4(2006426), // Rule ID 15910 //
     /* 2006329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2006332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2006340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2006343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2006346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2006349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006379 */     // MIs[1] Operand 1
     /* 2006379 */     // No operand predicates
     /* 2006379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006383 */     // MIs[0] round
     /* 2006383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006386 */     // MIs[0] policy
     /* 2006386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006398 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2006401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006425 */     // GIR_Coverage, 15910,
     /* 2006425 */     GIR_EraseRootFromParent_Done,
     /* 2006426 */   // Label 26797: @2006426
     /* 2006426 */   GIM_Try, /*On fail goto*//*Label 26798*/ GIMT_Encode4(2006528), // Rule ID 15911 //
     /* 2006431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2006442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2006445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2006448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2006454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006477 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006481 */     // MIs[1] Operand 1
     /* 2006481 */     // No operand predicates
     /* 2006481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006485 */     // MIs[0] round
     /* 2006485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006488 */     // MIs[0] policy
     /* 2006488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006500 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2006503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006509 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006527 */     // GIR_Coverage, 15911,
     /* 2006527 */     GIR_EraseRootFromParent_Done,
     /* 2006528 */   // Label 26798: @2006528
     /* 2006528 */   GIM_Try, /*On fail goto*//*Label 26799*/ GIMT_Encode4(2006630), // Rule ID 15914 //
     /* 2006533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2006536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2006544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2006547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2006550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2006553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2006556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006579 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006583 */     // MIs[1] Operand 1
     /* 2006583 */     // No operand predicates
     /* 2006583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006587 */     // MIs[0] round
     /* 2006587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006590 */     // MIs[0] policy
     /* 2006590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006602 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2006605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006629 */     // GIR_Coverage, 15914,
     /* 2006629 */     GIR_EraseRootFromParent_Done,
     /* 2006630 */   // Label 26799: @2006630
     /* 2006630 */   GIM_Try, /*On fail goto*//*Label 26800*/ GIMT_Encode4(2006732), // Rule ID 15915 //
     /* 2006635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2006646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2006649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2006652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2006658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2006665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2006673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006681 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006685 */     // MIs[1] Operand 1
     /* 2006685 */     // No operand predicates
     /* 2006685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006689 */     // MIs[0] round
     /* 2006689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006692 */     // MIs[0] policy
     /* 2006692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006695 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006704 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2006707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006731 */     // GIR_Coverage, 15915,
     /* 2006731 */     GIR_EraseRootFromParent_Done,
     /* 2006732 */   // Label 26800: @2006732
     /* 2006732 */   GIM_Try, /*On fail goto*//*Label 26801*/ GIMT_Encode4(2006834), // Rule ID 15918 //
     /* 2006737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2006740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2006748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2006751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2006754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2006757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2006760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006787 */     // MIs[1] Operand 1
     /* 2006787 */     // No operand predicates
     /* 2006787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006791 */     // MIs[0] round
     /* 2006791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006794 */     // MIs[0] policy
     /* 2006794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006806 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2006806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2006809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006833 */     // GIR_Coverage, 15918,
     /* 2006833 */     GIR_EraseRootFromParent_Done,
     /* 2006834 */   // Label 26801: @2006834
     /* 2006834 */   GIM_Try, /*On fail goto*//*Label 26802*/ GIMT_Encode4(2006936), // Rule ID 15919 //
     /* 2006839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2006842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2006850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2006853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2006856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2006859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2006862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2006865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2006869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2006877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006889 */     // MIs[1] Operand 1
     /* 2006889 */     // No operand predicates
     /* 2006889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006893 */     // MIs[0] round
     /* 2006893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006896 */     // MIs[0] policy
     /* 2006896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2006899 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2006901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2006908 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2006908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2006911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2006913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2006915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2006917 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2006920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2006922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2006924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2006929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2006932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2006934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2006935 */     // GIR_Coverage, 15919,
     /* 2006935 */     GIR_EraseRootFromParent_Done,
     /* 2006936 */   // Label 26802: @2006936
     /* 2006936 */   GIM_Try, /*On fail goto*//*Label 26803*/ GIMT_Encode4(2007038), // Rule ID 15922 //
     /* 2006941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2006944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2006949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2006952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2006955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2006958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2006961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2006964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2006967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2006971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2006979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2006983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2006987 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2006991 */     // MIs[1] Operand 1
     /* 2006991 */     // No operand predicates
     /* 2006991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2006995 */     // MIs[0] round
     /* 2006995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2006998 */     // MIs[0] policy
     /* 2006998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007010 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2007013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007037 */     // GIR_Coverage, 15922,
     /* 2007037 */     GIR_EraseRootFromParent_Done,
     /* 2007038 */   // Label 26803: @2007038
     /* 2007038 */   GIM_Try, /*On fail goto*//*Label 26804*/ GIMT_Encode4(2007140), // Rule ID 15923 //
     /* 2007043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2007054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2007057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2007060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007089 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007093 */     // MIs[1] Operand 1
     /* 2007093 */     // No operand predicates
     /* 2007093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007097 */     // MIs[0] round
     /* 2007097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007100 */     // MIs[0] policy
     /* 2007100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007112 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2007115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007121 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007139 */     // GIR_Coverage, 15923,
     /* 2007139 */     GIR_EraseRootFromParent_Done,
     /* 2007140 */   // Label 26804: @2007140
     /* 2007140 */   GIM_Try, /*On fail goto*//*Label 26805*/ GIMT_Encode4(2007242), // Rule ID 15926 //
     /* 2007145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2007156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2007159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007195 */     // MIs[1] Operand 1
     /* 2007195 */     // No operand predicates
     /* 2007195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007199 */     // MIs[0] round
     /* 2007199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007202 */     // MIs[0] policy
     /* 2007202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007214 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2007217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007241 */     // GIR_Coverage, 15926,
     /* 2007241 */     GIR_EraseRootFromParent_Done,
     /* 2007242 */   // Label 26805: @2007242
     /* 2007242 */   GIM_Try, /*On fail goto*//*Label 26806*/ GIMT_Encode4(2007344), // Rule ID 15927 //
     /* 2007247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2007258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2007261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2007264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007297 */     // MIs[1] Operand 1
     /* 2007297 */     // No operand predicates
     /* 2007297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007301 */     // MIs[0] round
     /* 2007301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007304 */     // MIs[0] policy
     /* 2007304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007316 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2007319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007343 */     // GIR_Coverage, 15927,
     /* 2007343 */     GIR_EraseRootFromParent_Done,
     /* 2007344 */   // Label 26806: @2007344
     /* 2007344 */   GIM_Try, /*On fail goto*//*Label 26807*/ GIMT_Encode4(2007446), // Rule ID 15930 //
     /* 2007349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2007360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2007363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007399 */     // MIs[1] Operand 1
     /* 2007399 */     // No operand predicates
     /* 2007399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007403 */     // MIs[0] round
     /* 2007403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007406 */     // MIs[0] policy
     /* 2007406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007418 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2007421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007445 */     // GIR_Coverage, 15930,
     /* 2007445 */     GIR_EraseRootFromParent_Done,
     /* 2007446 */   // Label 26807: @2007446
     /* 2007446 */   GIM_Try, /*On fail goto*//*Label 26808*/ GIMT_Encode4(2007548), // Rule ID 15931 //
     /* 2007451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2007462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2007465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2007468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2007474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007501 */     // MIs[1] Operand 1
     /* 2007501 */     // No operand predicates
     /* 2007501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007505 */     // MIs[0] round
     /* 2007505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007508 */     // MIs[0] policy
     /* 2007508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007520 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2007523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2007544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007547 */     // GIR_Coverage, 15931,
     /* 2007547 */     GIR_EraseRootFromParent_Done,
     /* 2007548 */   // Label 26808: @2007548
     /* 2007548 */   GIM_Try, /*On fail goto*//*Label 26809*/ GIMT_Encode4(2007650), // Rule ID 15934 //
     /* 2007553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2007564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2007567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007603 */     // MIs[1] Operand 1
     /* 2007603 */     // No operand predicates
     /* 2007603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007607 */     // MIs[0] round
     /* 2007607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007610 */     // MIs[0] policy
     /* 2007610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007622 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2007625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007649 */     // GIR_Coverage, 15934,
     /* 2007649 */     GIR_EraseRootFromParent_Done,
     /* 2007650 */   // Label 26809: @2007650
     /* 2007650 */   GIM_Try, /*On fail goto*//*Label 26810*/ GIMT_Encode4(2007752), // Rule ID 15935 //
     /* 2007655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2007666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2007669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2007672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2007678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2007685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2007693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007705 */     // MIs[1] Operand 1
     /* 2007705 */     // No operand predicates
     /* 2007705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007709 */     // MIs[0] round
     /* 2007709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007712 */     // MIs[0] policy
     /* 2007712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007715 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2007727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007751 */     // GIR_Coverage, 15935,
     /* 2007751 */     GIR_EraseRootFromParent_Done,
     /* 2007752 */   // Label 26810: @2007752
     /* 2007752 */   GIM_Try, /*On fail goto*//*Label 26811*/ GIMT_Encode4(2007854), // Rule ID 15938 //
     /* 2007757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2007768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2007771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2007774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007803 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007807 */     // MIs[1] Operand 1
     /* 2007807 */     // No operand predicates
     /* 2007807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007811 */     // MIs[0] round
     /* 2007811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007814 */     // MIs[0] policy
     /* 2007814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007826 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2007826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2007829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007853 */     // GIR_Coverage, 15938,
     /* 2007853 */     GIR_EraseRootFromParent_Done,
     /* 2007854 */   // Label 26811: @2007854
     /* 2007854 */   GIM_Try, /*On fail goto*//*Label 26812*/ GIMT_Encode4(2007956), // Rule ID 15939 //
     /* 2007859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2007862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2007870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2007873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2007876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2007879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2007882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2007885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2007889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2007897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2007901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2007905 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2007909 */     // MIs[1] Operand 1
     /* 2007909 */     // No operand predicates
     /* 2007909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2007913 */     // MIs[0] round
     /* 2007913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2007916 */     // MIs[0] policy
     /* 2007916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2007919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2007921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2007928 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2007928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2007931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2007933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2007935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2007937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2007940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2007942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2007944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2007949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2007952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2007954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2007955 */     // GIR_Coverage, 15939,
     /* 2007955 */     GIR_EraseRootFromParent_Done,
     /* 2007956 */   // Label 26812: @2007956
     /* 2007956 */   GIM_Try, /*On fail goto*//*Label 26813*/ GIMT_Encode4(2008058), // Rule ID 15942 //
     /* 2007961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2007964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2007969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2007972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2007975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2007978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2007981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2007984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2007987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2007991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2007999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008007 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008011 */     // MIs[1] Operand 1
     /* 2008011 */     // No operand predicates
     /* 2008011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008015 */     // MIs[0] round
     /* 2008015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008018 */     // MIs[0] policy
     /* 2008018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008021 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008030 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2008033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008057 */     // GIR_Coverage, 15942,
     /* 2008057 */     GIR_EraseRootFromParent_Done,
     /* 2008058 */   // Label 26813: @2008058
     /* 2008058 */   GIM_Try, /*On fail goto*//*Label 26814*/ GIMT_Encode4(2008160), // Rule ID 15943 //
     /* 2008063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2008074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2008077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2008080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2008086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2008093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008109 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008113 */     // MIs[1] Operand 1
     /* 2008113 */     // No operand predicates
     /* 2008113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008117 */     // MIs[0] round
     /* 2008117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008120 */     // MIs[0] policy
     /* 2008120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008123 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008132 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2008135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2008156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008159 */     // GIR_Coverage, 15943,
     /* 2008159 */     GIR_EraseRootFromParent_Done,
     /* 2008160 */   // Label 26814: @2008160
     /* 2008160 */   GIM_Try, /*On fail goto*//*Label 26815*/ GIMT_Encode4(2008262), // Rule ID 15946 //
     /* 2008165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2008176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2008179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008211 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008215 */     // MIs[1] Operand 1
     /* 2008215 */     // No operand predicates
     /* 2008215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008219 */     // MIs[0] round
     /* 2008219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008222 */     // MIs[0] policy
     /* 2008222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008234 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2008237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008261 */     // GIR_Coverage, 15946,
     /* 2008261 */     GIR_EraseRootFromParent_Done,
     /* 2008262 */   // Label 26815: @2008262
     /* 2008262 */   GIM_Try, /*On fail goto*//*Label 26816*/ GIMT_Encode4(2008364), // Rule ID 15947 //
     /* 2008267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2008278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2008281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2008284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2008290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2008297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2008305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008317 */     // MIs[1] Operand 1
     /* 2008317 */     // No operand predicates
     /* 2008317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008321 */     // MIs[0] round
     /* 2008321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008324 */     // MIs[0] policy
     /* 2008324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008336 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M2_MASK),
     /* 2008339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008363 */     // GIR_Coverage, 15947,
     /* 2008363 */     GIR_EraseRootFromParent_Done,
     /* 2008364 */   // Label 26816: @2008364
     /* 2008364 */   GIM_Try, /*On fail goto*//*Label 26817*/ GIMT_Encode4(2008466), // Rule ID 15950 //
     /* 2008369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2008380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2008383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2008399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008415 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008419 */     // MIs[1] Operand 1
     /* 2008419 */     // No operand predicates
     /* 2008419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008423 */     // MIs[0] round
     /* 2008423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008426 */     // MIs[0] policy
     /* 2008426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008438 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2008441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008465 */     // GIR_Coverage, 15950,
     /* 2008465 */     GIR_EraseRootFromParent_Done,
     /* 2008466 */   // Label 26817: @2008466
     /* 2008466 */   GIM_Try, /*On fail goto*//*Label 26818*/ GIMT_Encode4(2008568), // Rule ID 15951 //
     /* 2008471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2008482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2008485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2008488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2008494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2008501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2008509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008517 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008521 */     // MIs[1] Operand 1
     /* 2008521 */     // No operand predicates
     /* 2008521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008525 */     // MIs[0] round
     /* 2008525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008528 */     // MIs[0] policy
     /* 2008528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008540 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M4_MASK),
     /* 2008543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008549 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008567 */     // GIR_Coverage, 15951,
     /* 2008567 */     GIR_EraseRootFromParent_Done,
     /* 2008568 */   // Label 26818: @2008568
     /* 2008568 */   GIM_Try, /*On fail goto*//*Label 26819*/ GIMT_Encode4(2008670), // Rule ID 15954 //
     /* 2008573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2008576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2008584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2008587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2008603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008623 */     // MIs[1] Operand 1
     /* 2008623 */     // No operand predicates
     /* 2008623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008627 */     // MIs[0] round
     /* 2008627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008630 */     // MIs[0] policy
     /* 2008630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008642 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2008645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008669 */     // GIR_Coverage, 15954,
     /* 2008669 */     GIR_EraseRootFromParent_Done,
     /* 2008670 */   // Label 26819: @2008670
     /* 2008670 */   GIM_Try, /*On fail goto*//*Label 26820*/ GIMT_Encode4(2008772), // Rule ID 15955 //
     /* 2008675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2008678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2008683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2008686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2008689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2008692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2008698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2008705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2008713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008725 */     // MIs[1] Operand 1
     /* 2008725 */     // No operand predicates
     /* 2008725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008729 */     // MIs[0] round
     /* 2008729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008732 */     // MIs[0] policy
     /* 2008732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008744 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VI_M8_MASK),
     /* 2008747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2008768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008771 */     // GIR_Coverage, 15955,
     /* 2008771 */     GIR_EraseRootFromParent_Done,
     /* 2008772 */   // Label 26820: @2008772
     /* 2008772 */   GIM_Try, /*On fail goto*//*Label 26821*/ GIMT_Encode4(2008874), // Rule ID 16134 //
     /* 2008777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2008785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2008788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2008791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2008794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2008797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2008803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008827 */     // MIs[1] Operand 1
     /* 2008827 */     // No operand predicates
     /* 2008827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008831 */     // MIs[0] round
     /* 2008831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008834 */     // MIs[0] policy
     /* 2008834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008846 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2008846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2008849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2008870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008873 */     // GIR_Coverage, 16134,
     /* 2008873 */     GIR_EraseRootFromParent_Done,
     /* 2008874 */   // Label 26821: @2008874
     /* 2008874 */   GIM_Try, /*On fail goto*//*Label 26822*/ GIMT_Encode4(2008976), // Rule ID 16135 //
     /* 2008879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2008882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2008887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2008890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2008893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2008896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2008899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2008902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2008905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2008909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2008917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2008921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2008925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2008929 */     // MIs[1] Operand 1
     /* 2008929 */     // No operand predicates
     /* 2008929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2008933 */     // MIs[0] round
     /* 2008933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2008936 */     // MIs[0] policy
     /* 2008936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2008939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2008941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2008948 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2008948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF8_MASK),
     /* 2008951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2008953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2008955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2008957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2008960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2008962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2008964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2008969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2008972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2008974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2008975 */     // GIR_Coverage, 16135,
     /* 2008975 */     GIR_EraseRootFromParent_Done,
     /* 2008976 */   // Label 26822: @2008976
     /* 2008976 */   GIM_Try, /*On fail goto*//*Label 26823*/ GIMT_Encode4(2009078), // Rule ID 16138 //
     /* 2008981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2008984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2008989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2008992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2008995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2008998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009027 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009031 */     // MIs[1] Operand 1
     /* 2009031 */     // No operand predicates
     /* 2009031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009035 */     // MIs[0] round
     /* 2009035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009038 */     // MIs[0] policy
     /* 2009038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009050 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2009053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009059 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009077 */     // GIR_Coverage, 16138,
     /* 2009077 */     GIR_EraseRootFromParent_Done,
     /* 2009078 */   // Label 26823: @2009078
     /* 2009078 */   GIM_Try, /*On fail goto*//*Label 26824*/ GIMT_Encode4(2009180), // Rule ID 16139 //
     /* 2009083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2009094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2009097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2009100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009129 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009133 */     // MIs[1] Operand 1
     /* 2009133 */     // No operand predicates
     /* 2009133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009137 */     // MIs[0] round
     /* 2009137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009140 */     // MIs[0] policy
     /* 2009140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009152 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2009155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009179 */     // GIR_Coverage, 16139,
     /* 2009179 */     GIR_EraseRootFromParent_Done,
     /* 2009180 */   // Label 26824: @2009180
     /* 2009180 */   GIM_Try, /*On fail goto*//*Label 26825*/ GIMT_Encode4(2009282), // Rule ID 16142 //
     /* 2009185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2009196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2009199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2009202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009231 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009235 */     // MIs[1] Operand 1
     /* 2009235 */     // No operand predicates
     /* 2009235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009239 */     // MIs[0] round
     /* 2009239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009242 */     // MIs[0] policy
     /* 2009242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009254 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009281 */     // GIR_Coverage, 16142,
     /* 2009281 */     GIR_EraseRootFromParent_Done,
     /* 2009282 */   // Label 26825: @2009282
     /* 2009282 */   GIM_Try, /*On fail goto*//*Label 26826*/ GIMT_Encode4(2009384), // Rule ID 16143 //
     /* 2009287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2009298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2009301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2009304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2009310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009337 */     // MIs[1] Operand 1
     /* 2009337 */     // No operand predicates
     /* 2009337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009341 */     // MIs[0] round
     /* 2009341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009344 */     // MIs[0] policy
     /* 2009344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009356 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009365 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2009380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009383 */     // GIR_Coverage, 16143,
     /* 2009383 */     GIR_EraseRootFromParent_Done,
     /* 2009384 */   // Label 26826: @2009384
     /* 2009384 */   GIM_Try, /*On fail goto*//*Label 26827*/ GIMT_Encode4(2009486), // Rule ID 16146 //
     /* 2009389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2009400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2009403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009439 */     // MIs[1] Operand 1
     /* 2009439 */     // No operand predicates
     /* 2009439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009443 */     // MIs[0] round
     /* 2009443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009446 */     // MIs[0] policy
     /* 2009446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009458 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2009461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009485 */     // GIR_Coverage, 16146,
     /* 2009485 */     GIR_EraseRootFromParent_Done,
     /* 2009486 */   // Label 26827: @2009486
     /* 2009486 */   GIM_Try, /*On fail goto*//*Label 26828*/ GIMT_Encode4(2009588), // Rule ID 16147 //
     /* 2009491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2009502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2009505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2009508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009537 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009541 */     // MIs[1] Operand 1
     /* 2009541 */     // No operand predicates
     /* 2009541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009545 */     // MIs[0] round
     /* 2009545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009548 */     // MIs[0] policy
     /* 2009548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009560 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF4_MASK),
     /* 2009563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009587 */     // GIR_Coverage, 16147,
     /* 2009587 */     GIR_EraseRootFromParent_Done,
     /* 2009588 */   // Label 26828: @2009588
     /* 2009588 */   GIM_Try, /*On fail goto*//*Label 26829*/ GIMT_Encode4(2009690), // Rule ID 16150 //
     /* 2009593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2009604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2009607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009631 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009635 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009639 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009643 */     // MIs[1] Operand 1
     /* 2009643 */     // No operand predicates
     /* 2009643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009647 */     // MIs[0] round
     /* 2009647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009650 */     // MIs[0] policy
     /* 2009650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009662 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009689 */     // GIR_Coverage, 16150,
     /* 2009689 */     GIR_EraseRootFromParent_Done,
     /* 2009690 */   // Label 26829: @2009690
     /* 2009690 */   GIM_Try, /*On fail goto*//*Label 26830*/ GIMT_Encode4(2009792), // Rule ID 16151 //
     /* 2009695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2009706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2009709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2009712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2009718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009741 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009745 */     // MIs[1] Operand 1
     /* 2009745 */     // No operand predicates
     /* 2009745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009749 */     // MIs[0] round
     /* 2009749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009752 */     // MIs[0] policy
     /* 2009752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009764 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2009788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009791 */     // GIR_Coverage, 16151,
     /* 2009791 */     GIR_EraseRootFromParent_Done,
     /* 2009792 */   // Label 26830: @2009792
     /* 2009792 */   GIM_Try, /*On fail goto*//*Label 26831*/ GIMT_Encode4(2009894), // Rule ID 16154 //
     /* 2009797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2009800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2009808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2009811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2009817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2009823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009843 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009847 */     // MIs[1] Operand 1
     /* 2009847 */     // No operand predicates
     /* 2009847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009851 */     // MIs[0] round
     /* 2009851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009854 */     // MIs[0] policy
     /* 2009854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009866 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2009866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009893 */     // GIR_Coverage, 16154,
     /* 2009893 */     GIR_EraseRootFromParent_Done,
     /* 2009894 */   // Label 26831: @2009894
     /* 2009894 */   GIM_Try, /*On fail goto*//*Label 26832*/ GIMT_Encode4(2009996), // Rule ID 16155 //
     /* 2009899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2009902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2009907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2009910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2009913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2009916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2009919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2009922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2009925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2009929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2009937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2009941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2009945 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2009949 */     // MIs[1] Operand 1
     /* 2009949 */     // No operand predicates
     /* 2009949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2009953 */     // MIs[0] round
     /* 2009953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2009956 */     // MIs[0] policy
     /* 2009956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2009959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2009961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2009968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2009968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_MF2_MASK),
     /* 2009971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2009973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2009975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2009977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2009980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2009982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2009984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2009989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2009992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2009994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2009995 */     // GIR_Coverage, 16155,
     /* 2009995 */     GIR_EraseRootFromParent_Done,
     /* 2009996 */   // Label 26832: @2009996
     /* 2009996 */   GIM_Try, /*On fail goto*//*Label 26833*/ GIMT_Encode4(2010098), // Rule ID 16158 //
     /* 2010001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2010012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2010015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2010018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010051 */     // MIs[1] Operand 1
     /* 2010051 */     // No operand predicates
     /* 2010051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010055 */     // MIs[0] round
     /* 2010055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010058 */     // MIs[0] policy
     /* 2010058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010070 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010097 */     // GIR_Coverage, 16158,
     /* 2010097 */     GIR_EraseRootFromParent_Done,
     /* 2010098 */   // Label 26833: @2010098
     /* 2010098 */   GIM_Try, /*On fail goto*//*Label 26834*/ GIMT_Encode4(2010200), // Rule ID 16159 //
     /* 2010103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2010114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2010117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2010120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2010126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010149 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010153 */     // MIs[1] Operand 1
     /* 2010153 */     // No operand predicates
     /* 2010153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010157 */     // MIs[0] round
     /* 2010157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010160 */     // MIs[0] policy
     /* 2010160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010172 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010177 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010199 */     // GIR_Coverage, 16159,
     /* 2010199 */     GIR_EraseRootFromParent_Done,
     /* 2010200 */   // Label 26834: @2010200
     /* 2010200 */   GIM_Try, /*On fail goto*//*Label 26835*/ GIMT_Encode4(2010302), // Rule ID 16162 //
     /* 2010205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010255 */     // MIs[1] Operand 1
     /* 2010255 */     // No operand predicates
     /* 2010255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010259 */     // MIs[0] round
     /* 2010259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010262 */     // MIs[0] policy
     /* 2010262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010274 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010301 */     // GIR_Coverage, 16162,
     /* 2010301 */     GIR_EraseRootFromParent_Done,
     /* 2010302 */   // Label 26835: @2010302
     /* 2010302 */   GIM_Try, /*On fail goto*//*Label 26836*/ GIMT_Encode4(2010404), // Rule ID 16163 //
     /* 2010307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2010318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2010321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2010324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2010330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010353 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010357 */     // MIs[1] Operand 1
     /* 2010357 */     // No operand predicates
     /* 2010357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010361 */     // MIs[0] round
     /* 2010361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010364 */     // MIs[0] policy
     /* 2010364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010376 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010385 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2010400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010403 */     // GIR_Coverage, 16163,
     /* 2010403 */     GIR_EraseRootFromParent_Done,
     /* 2010404 */   // Label 26836: @2010404
     /* 2010404 */   GIM_Try, /*On fail goto*//*Label 26837*/ GIMT_Encode4(2010506), // Rule ID 16166 //
     /* 2010409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010459 */     // MIs[1] Operand 1
     /* 2010459 */     // No operand predicates
     /* 2010459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010463 */     // MIs[0] round
     /* 2010463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010466 */     // MIs[0] policy
     /* 2010466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010478 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010505 */     // GIR_Coverage, 16166,
     /* 2010505 */     GIR_EraseRootFromParent_Done,
     /* 2010506 */   // Label 26837: @2010506
     /* 2010506 */   GIM_Try, /*On fail goto*//*Label 26838*/ GIMT_Encode4(2010608), // Rule ID 16167 //
     /* 2010511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2010522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2010525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2010528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2010534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010557 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010561 */     // MIs[1] Operand 1
     /* 2010561 */     // No operand predicates
     /* 2010561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010565 */     // MIs[0] round
     /* 2010565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010568 */     // MIs[0] policy
     /* 2010568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2010604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010607 */     // GIR_Coverage, 16167,
     /* 2010607 */     GIR_EraseRootFromParent_Done,
     /* 2010608 */   // Label 26838: @2010608
     /* 2010608 */   GIM_Try, /*On fail goto*//*Label 26839*/ GIMT_Encode4(2010710), // Rule ID 16170 //
     /* 2010613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2010616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010659 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010663 */     // MIs[1] Operand 1
     /* 2010663 */     // No operand predicates
     /* 2010663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010667 */     // MIs[0] round
     /* 2010667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010670 */     // MIs[0] policy
     /* 2010670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010682 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010709 */     // GIR_Coverage, 16170,
     /* 2010709 */     GIR_EraseRootFromParent_Done,
     /* 2010710 */   // Label 26839: @2010710
     /* 2010710 */   GIM_Try, /*On fail goto*//*Label 26840*/ GIMT_Encode4(2010812), // Rule ID 16171 //
     /* 2010715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2010718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2010726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2010729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2010732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2010738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2010745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2010753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010761 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010765 */     // MIs[1] Operand 1
     /* 2010765 */     // No operand predicates
     /* 2010765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010769 */     // MIs[0] round
     /* 2010769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010772 */     // MIs[0] policy
     /* 2010772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010784 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M1_MASK),
     /* 2010787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010793 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2010808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010811 */     // GIR_Coverage, 16171,
     /* 2010811 */     GIR_EraseRootFromParent_Done,
     /* 2010812 */   // Label 26840: @2010812
     /* 2010812 */   GIM_Try, /*On fail goto*//*Label 26841*/ GIMT_Encode4(2010914), // Rule ID 16174 //
     /* 2010817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2010820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2010828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2010831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2010834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2010837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2010843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010863 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010867 */     // MIs[1] Operand 1
     /* 2010867 */     // No operand predicates
     /* 2010867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010871 */     // MIs[0] round
     /* 2010871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010874 */     // MIs[0] policy
     /* 2010874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010886 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2010886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2010889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2010898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2010900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2010902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2010907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2010910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2010912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2010913 */     // GIR_Coverage, 16174,
     /* 2010913 */     GIR_EraseRootFromParent_Done,
     /* 2010914 */   // Label 26841: @2010914
     /* 2010914 */   GIM_Try, /*On fail goto*//*Label 26842*/ GIMT_Encode4(2011016), // Rule ID 16175 //
     /* 2010919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2010922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2010927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2010930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2010933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2010936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2010939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2010942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2010945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2010949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2010957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2010961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2010965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2010969 */     // MIs[1] Operand 1
     /* 2010969 */     // No operand predicates
     /* 2010969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2010973 */     // MIs[0] round
     /* 2010973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2010976 */     // MIs[0] policy
     /* 2010976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2010979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2010981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2010988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2010988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2010991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2010993 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2010995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2010997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011015 */     // GIR_Coverage, 16175,
     /* 2011015 */     GIR_EraseRootFromParent_Done,
     /* 2011016 */   // Label 26842: @2011016
     /* 2011016 */   GIM_Try, /*On fail goto*//*Label 26843*/ GIMT_Encode4(2011118), // Rule ID 16178 //
     /* 2011021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2011032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2011035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2011038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011071 */     // MIs[1] Operand 1
     /* 2011071 */     // No operand predicates
     /* 2011071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011075 */     // MIs[0] round
     /* 2011075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011078 */     // MIs[0] policy
     /* 2011078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011081 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011090 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2011093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011117 */     // GIR_Coverage, 16178,
     /* 2011117 */     GIR_EraseRootFromParent_Done,
     /* 2011118 */   // Label 26843: @2011118
     /* 2011118 */   GIM_Try, /*On fail goto*//*Label 26844*/ GIMT_Encode4(2011220), // Rule ID 16179 //
     /* 2011123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2011134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2011137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2011140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011173 */     // MIs[1] Operand 1
     /* 2011173 */     // No operand predicates
     /* 2011173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011177 */     // MIs[0] round
     /* 2011177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011180 */     // MIs[0] policy
     /* 2011180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011192 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2011195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011219 */     // GIR_Coverage, 16179,
     /* 2011219 */     GIR_EraseRootFromParent_Done,
     /* 2011220 */   // Label 26844: @2011220
     /* 2011220 */   GIM_Try, /*On fail goto*//*Label 26845*/ GIMT_Encode4(2011322), // Rule ID 16182 //
     /* 2011225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2011236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2011239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2011242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2011248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011275 */     // MIs[1] Operand 1
     /* 2011275 */     // No operand predicates
     /* 2011275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011279 */     // MIs[0] round
     /* 2011279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011282 */     // MIs[0] policy
     /* 2011282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011294 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2011297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011321 */     // GIR_Coverage, 16182,
     /* 2011321 */     GIR_EraseRootFromParent_Done,
     /* 2011322 */   // Label 26845: @2011322
     /* 2011322 */   GIM_Try, /*On fail goto*//*Label 26846*/ GIMT_Encode4(2011424), // Rule ID 16183 //
     /* 2011327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2011338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2011341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2011344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2011350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011373 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011377 */     // MIs[1] Operand 1
     /* 2011377 */     // No operand predicates
     /* 2011377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011381 */     // MIs[0] round
     /* 2011381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011384 */     // MIs[0] policy
     /* 2011384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011396 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2011399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2011420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011423 */     // GIR_Coverage, 16183,
     /* 2011423 */     GIR_EraseRootFromParent_Done,
     /* 2011424 */   // Label 26846: @2011424
     /* 2011424 */   GIM_Try, /*On fail goto*//*Label 26847*/ GIMT_Encode4(2011526), // Rule ID 16186 //
     /* 2011429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2011440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2011443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011479 */     // MIs[1] Operand 1
     /* 2011479 */     // No operand predicates
     /* 2011479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011483 */     // MIs[0] round
     /* 2011483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011486 */     // MIs[0] policy
     /* 2011486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2011501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011525 */     // GIR_Coverage, 16186,
     /* 2011525 */     GIR_EraseRootFromParent_Done,
     /* 2011526 */   // Label 26847: @2011526
     /* 2011526 */   GIM_Try, /*On fail goto*//*Label 26848*/ GIMT_Encode4(2011628), // Rule ID 16187 //
     /* 2011531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2011542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2011545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2011548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2011554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2011561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2011569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011581 */     // MIs[1] Operand 1
     /* 2011581 */     // No operand predicates
     /* 2011581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011585 */     // MIs[0] round
     /* 2011585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011588 */     // MIs[0] policy
     /* 2011588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2011603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011627 */     // GIR_Coverage, 16187,
     /* 2011627 */     GIR_EraseRootFromParent_Done,
     /* 2011628 */   // Label 26848: @2011628
     /* 2011628 */   GIM_Try, /*On fail goto*//*Label 26849*/ GIMT_Encode4(2011730), // Rule ID 16190 //
     /* 2011633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2011644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2011647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011679 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011683 */     // MIs[1] Operand 1
     /* 2011683 */     // No operand predicates
     /* 2011683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011687 */     // MIs[0] round
     /* 2011687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011690 */     // MIs[0] policy
     /* 2011690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011702 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2011705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011729 */     // GIR_Coverage, 16190,
     /* 2011729 */     GIR_EraseRootFromParent_Done,
     /* 2011730 */   // Label 26849: @2011730
     /* 2011730 */   GIM_Try, /*On fail goto*//*Label 26850*/ GIMT_Encode4(2011832), // Rule ID 16191 //
     /* 2011735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2011746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2011749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2011752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2011758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2011765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2011773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011785 */     // MIs[1] Operand 1
     /* 2011785 */     // No operand predicates
     /* 2011785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011789 */     // MIs[0] round
     /* 2011789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011792 */     // MIs[0] policy
     /* 2011792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011804 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2011804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2011807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011831 */     // GIR_Coverage, 16191,
     /* 2011831 */     GIR_EraseRootFromParent_Done,
     /* 2011832 */   // Label 26850: @2011832
     /* 2011832 */   GIM_Try, /*On fail goto*//*Label 26851*/ GIMT_Encode4(2011934), // Rule ID 16194 //
     /* 2011837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2011840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2011848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2011851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2011857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2011863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011887 */     // MIs[1] Operand 1
     /* 2011887 */     // No operand predicates
     /* 2011887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011891 */     // MIs[0] round
     /* 2011891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011894 */     // MIs[0] policy
     /* 2011894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2011899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2011906 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2011906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2011909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2011911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2011913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2011915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2011918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2011920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2011922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2011927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2011930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2011932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2011933 */     // GIR_Coverage, 16194,
     /* 2011933 */     GIR_EraseRootFromParent_Done,
     /* 2011934 */   // Label 26851: @2011934
     /* 2011934 */   GIM_Try, /*On fail goto*//*Label 26852*/ GIMT_Encode4(2012036), // Rule ID 16195 //
     /* 2011939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2011942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2011947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2011950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2011953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2011956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2011959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2011962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2011965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2011969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2011977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2011981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2011985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2011989 */     // MIs[1] Operand 1
     /* 2011989 */     // No operand predicates
     /* 2011989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2011993 */     // MIs[0] round
     /* 2011993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2011996 */     // MIs[0] policy
     /* 2011996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2011999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012008 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2012011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2012032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012035 */     // GIR_Coverage, 16195,
     /* 2012035 */     GIR_EraseRootFromParent_Done,
     /* 2012036 */   // Label 26852: @2012036
     /* 2012036 */   GIM_Try, /*On fail goto*//*Label 26853*/ GIMT_Encode4(2012138), // Rule ID 16198 //
     /* 2012041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2012044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2012052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2012055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2012058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012087 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012091 */     // MIs[1] Operand 1
     /* 2012091 */     // No operand predicates
     /* 2012091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012095 */     // MIs[0] round
     /* 2012095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012098 */     // MIs[0] policy
     /* 2012098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012110 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2012113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012137 */     // GIR_Coverage, 16198,
     /* 2012137 */     GIR_EraseRootFromParent_Done,
     /* 2012138 */   // Label 26853: @2012138
     /* 2012138 */   GIM_Try, /*On fail goto*//*Label 26854*/ GIMT_Encode4(2012240), // Rule ID 16199 //
     /* 2012143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2012154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2012157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2012160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012189 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012193 */     // MIs[1] Operand 1
     /* 2012193 */     // No operand predicates
     /* 2012193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012197 */     // MIs[0] round
     /* 2012197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012200 */     // MIs[0] policy
     /* 2012200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012212 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2012215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012239 */     // GIR_Coverage, 16199,
     /* 2012239 */     GIR_EraseRootFromParent_Done,
     /* 2012240 */   // Label 26854: @2012240
     /* 2012240 */   GIM_Try, /*On fail goto*//*Label 26855*/ GIMT_Encode4(2012342), // Rule ID 16202 //
     /* 2012245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2012248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2012262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012291 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012295 */     // MIs[1] Operand 1
     /* 2012295 */     // No operand predicates
     /* 2012295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012299 */     // MIs[0] round
     /* 2012299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012302 */     // MIs[0] policy
     /* 2012302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012314 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2012317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012341 */     // GIR_Coverage, 16202,
     /* 2012341 */     GIR_EraseRootFromParent_Done,
     /* 2012342 */   // Label 26855: @2012342
     /* 2012342 */   GIM_Try, /*On fail goto*//*Label 26856*/ GIMT_Encode4(2012444), // Rule ID 16203 //
     /* 2012347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2012358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2012361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2012364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2012370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012393 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012397 */     // MIs[1] Operand 1
     /* 2012397 */     // No operand predicates
     /* 2012397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012401 */     // MIs[0] round
     /* 2012401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012404 */     // MIs[0] policy
     /* 2012404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012416 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2012419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012443 */     // GIR_Coverage, 16203,
     /* 2012443 */     GIR_EraseRootFromParent_Done,
     /* 2012444 */   // Label 26856: @2012444
     /* 2012444 */   GIM_Try, /*On fail goto*//*Label 26857*/ GIMT_Encode4(2012546), // Rule ID 16206 //
     /* 2012449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2012452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012495 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012499 */     // MIs[1] Operand 1
     /* 2012499 */     // No operand predicates
     /* 2012499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012503 */     // MIs[0] round
     /* 2012503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012506 */     // MIs[0] policy
     /* 2012506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012518 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2012521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012527 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012545 */     // GIR_Coverage, 16206,
     /* 2012545 */     GIR_EraseRootFromParent_Done,
     /* 2012546 */   // Label 26857: @2012546
     /* 2012546 */   GIM_Try, /*On fail goto*//*Label 26858*/ GIMT_Encode4(2012648), // Rule ID 16207 //
     /* 2012551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2012554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2012562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2012565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2012568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2012574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2012581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2012589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012597 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012601 */     // MIs[1] Operand 1
     /* 2012601 */     // No operand predicates
     /* 2012601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012605 */     // MIs[0] round
     /* 2012605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012608 */     // MIs[0] policy
     /* 2012608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012620 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2012623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2012644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012647 */     // GIR_Coverage, 16207,
     /* 2012647 */     GIR_EraseRootFromParent_Done,
     /* 2012648 */   // Label 26858: @2012648
     /* 2012648 */   GIM_Try, /*On fail goto*//*Label 26859*/ GIMT_Encode4(2012750), // Rule ID 16210 //
     /* 2012653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2012656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2012664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2012667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012699 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012703 */     // MIs[1] Operand 1
     /* 2012703 */     // No operand predicates
     /* 2012703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012707 */     // MIs[0] round
     /* 2012707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012710 */     // MIs[0] policy
     /* 2012710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012722 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2012725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012749 */     // GIR_Coverage, 16210,
     /* 2012749 */     GIR_EraseRootFromParent_Done,
     /* 2012750 */   // Label 26859: @2012750
     /* 2012750 */   GIM_Try, /*On fail goto*//*Label 26860*/ GIMT_Encode4(2012852), // Rule ID 16211 //
     /* 2012755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2012758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2012766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2012769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2012772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2012778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2012785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2012793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012801 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012805 */     // MIs[1] Operand 1
     /* 2012805 */     // No operand predicates
     /* 2012805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012809 */     // MIs[0] round
     /* 2012809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012812 */     // MIs[0] policy
     /* 2012812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012824 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2012824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M2_MASK),
     /* 2012827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012851 */     // GIR_Coverage, 16211,
     /* 2012851 */     GIR_EraseRootFromParent_Done,
     /* 2012852 */   // Label 26860: @2012852
     /* 2012852 */   GIM_Try, /*On fail goto*//*Label 26861*/ GIMT_Encode4(2012954), // Rule ID 16214 //
     /* 2012857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2012860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2012868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2012871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2012877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2012883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2012899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2012903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2012907 */     // MIs[1] Operand 1
     /* 2012907 */     // No operand predicates
     /* 2012907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2012911 */     // MIs[0] round
     /* 2012911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2012914 */     // MIs[0] policy
     /* 2012914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2012917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2012919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2012926 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2012926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2012929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2012931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2012933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2012935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2012938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2012940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2012942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2012947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2012950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2012952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2012953 */     // GIR_Coverage, 16214,
     /* 2012953 */     GIR_EraseRootFromParent_Done,
     /* 2012954 */   // Label 26861: @2012954
     /* 2012954 */   GIM_Try, /*On fail goto*//*Label 26862*/ GIMT_Encode4(2013056), // Rule ID 16215 //
     /* 2012959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2012962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2012967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2012970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2012973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2012976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2012979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2012982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2012985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2012989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2012997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013009 */     // MIs[1] Operand 1
     /* 2013009 */     // No operand predicates
     /* 2013009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013013 */     // MIs[0] round
     /* 2013013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013016 */     // MIs[0] policy
     /* 2013016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013019 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013028 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M4_MASK),
     /* 2013031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013055 */     // GIR_Coverage, 16215,
     /* 2013055 */     GIR_EraseRootFromParent_Done,
     /* 2013056 */   // Label 26862: @2013056
     /* 2013056 */   GIM_Try, /*On fail goto*//*Label 26863*/ GIMT_Encode4(2013158), // Rule ID 16218 //
     /* 2013061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2013064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2013072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2013075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2013078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2013091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013111 */     // MIs[1] Operand 1
     /* 2013111 */     // No operand predicates
     /* 2013111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013115 */     // MIs[0] round
     /* 2013115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013118 */     // MIs[0] policy
     /* 2013118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013130 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2013133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013157 */     // GIR_Coverage, 16218,
     /* 2013157 */     GIR_EraseRootFromParent_Done,
     /* 2013158 */   // Label 26863: @2013158
     /* 2013158 */   GIM_Try, /*On fail goto*//*Label 26864*/ GIMT_Encode4(2013260), // Rule ID 16219 //
     /* 2013163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2013166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2013171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2013174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2013177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2013180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2013193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2013201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013209 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013213 */     // MIs[1] Operand 1
     /* 2013213 */     // No operand predicates
     /* 2013213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013217 */     // MIs[0] round
     /* 2013217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013220 */     // MIs[0] policy
     /* 2013220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013232 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VI_M8_MASK),
     /* 2013235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2013256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013259 */     // GIR_Coverage, 16219,
     /* 2013259 */     GIR_EraseRootFromParent_Done,
     /* 2013260 */   // Label 26864: @2013260
     /* 2013260 */   GIM_Try, /*On fail goto*//*Label 26865*/ GIMT_Encode4(2013365), // Rule ID 16342 //
     /* 2013265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2013276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2013279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013311 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013315 */     // MIs[1] Operand 1
     /* 2013315 */     // No operand predicates
     /* 2013315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013319 */     // MIs[0] round
     /* 2013319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013322 */     // MIs[0] policy
     /* 2013322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013334 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2013337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013364 */     // GIR_Coverage, 16342,
     /* 2013364 */     GIR_EraseRootFromParent_Done,
     /* 2013365 */   // Label 26865: @2013365
     /* 2013365 */   GIM_Try, /*On fail goto*//*Label 26866*/ GIMT_Encode4(2013470), // Rule ID 16343 //
     /* 2013370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2013381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2013384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2013387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2013393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013420 */     // MIs[1] Operand 1
     /* 2013420 */     // No operand predicates
     /* 2013420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013424 */     // MIs[0] round
     /* 2013424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013427 */     // MIs[0] policy
     /* 2013427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013439 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF8_MASK),
     /* 2013442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013448 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013469 */     // GIR_Coverage, 16343,
     /* 2013469 */     GIR_EraseRootFromParent_Done,
     /* 2013470 */   // Label 26866: @2013470
     /* 2013470 */   GIM_Try, /*On fail goto*//*Label 26867*/ GIMT_Encode4(2013575), // Rule ID 16346 //
     /* 2013475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2013486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2013489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013521 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013525 */     // MIs[1] Operand 1
     /* 2013525 */     // No operand predicates
     /* 2013525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013529 */     // MIs[0] round
     /* 2013529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013532 */     // MIs[0] policy
     /* 2013532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013544 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2013547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013570 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013574 */     // GIR_Coverage, 16346,
     /* 2013574 */     GIR_EraseRootFromParent_Done,
     /* 2013575 */   // Label 26867: @2013575
     /* 2013575 */   GIM_Try, /*On fail goto*//*Label 26868*/ GIMT_Encode4(2013680), // Rule ID 16347 //
     /* 2013580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2013591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2013594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2013597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2013603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013626 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013630 */     // MIs[1] Operand 1
     /* 2013630 */     // No operand predicates
     /* 2013630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013634 */     // MIs[0] round
     /* 2013634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013637 */     // MIs[0] policy
     /* 2013637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013649 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2013652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013675 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013679 */     // GIR_Coverage, 16347,
     /* 2013679 */     GIR_EraseRootFromParent_Done,
     /* 2013680 */   // Label 26868: @2013680
     /* 2013680 */   GIM_Try, /*On fail goto*//*Label 26869*/ GIMT_Encode4(2013785), // Rule ID 16350 //
     /* 2013685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2013696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2013699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2013702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013731 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013735 */     // MIs[1] Operand 1
     /* 2013735 */     // No operand predicates
     /* 2013735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013739 */     // MIs[0] round
     /* 2013739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013742 */     // MIs[0] policy
     /* 2013742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013754 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2013757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013780 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013784 */     // GIR_Coverage, 16350,
     /* 2013784 */     GIR_EraseRootFromParent_Done,
     /* 2013785 */   // Label 26869: @2013785
     /* 2013785 */   GIM_Try, /*On fail goto*//*Label 26870*/ GIMT_Encode4(2013890), // Rule ID 16351 //
     /* 2013790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2013793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2013801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2013804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2013807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2013810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2013813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2013816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013836 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013840 */     // MIs[1] Operand 1
     /* 2013840 */     // No operand predicates
     /* 2013840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013844 */     // MIs[0] round
     /* 2013844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013847 */     // MIs[0] policy
     /* 2013847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013859 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2013859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2013862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013889 */     // GIR_Coverage, 16351,
     /* 2013889 */     GIR_EraseRootFromParent_Done,
     /* 2013890 */   // Label 26870: @2013890
     /* 2013890 */   GIM_Try, /*On fail goto*//*Label 26871*/ GIMT_Encode4(2013995), // Rule ID 16354 //
     /* 2013895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2013898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2013903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2013906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2013909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2013912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2013915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2013918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2013921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2013925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2013929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2013933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2013937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2013941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2013945 */     // MIs[1] Operand 1
     /* 2013945 */     // No operand predicates
     /* 2013945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2013949 */     // MIs[0] round
     /* 2013949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2013952 */     // MIs[0] policy
     /* 2013952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2013955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2013957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2013964 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2013964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2013967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2013969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2013971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2013973 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2013976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2013978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2013980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2013985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2013988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2013990 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2013993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2013994 */     // GIR_Coverage, 16354,
     /* 2013994 */     GIR_EraseRootFromParent_Done,
     /* 2013995 */   // Label 26871: @2013995
     /* 2013995 */   GIM_Try, /*On fail goto*//*Label 26872*/ GIMT_Encode4(2014100), // Rule ID 16355 //
     /* 2014000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2014011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2014014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2014017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2014023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014046 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014050 */     // MIs[1] Operand 1
     /* 2014050 */     // No operand predicates
     /* 2014050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014054 */     // MIs[0] round
     /* 2014054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014057 */     // MIs[0] policy
     /* 2014057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014069 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2014072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014095 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014099 */     // GIR_Coverage, 16355,
     /* 2014099 */     GIR_EraseRootFromParent_Done,
     /* 2014100 */   // Label 26872: @2014100
     /* 2014100 */   GIM_Try, /*On fail goto*//*Label 26873*/ GIMT_Encode4(2014205), // Rule ID 16358 //
     /* 2014105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2014116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2014119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014155 */     // MIs[1] Operand 1
     /* 2014155 */     // No operand predicates
     /* 2014155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014159 */     // MIs[0] round
     /* 2014159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014162 */     // MIs[0] policy
     /* 2014162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014174 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2014177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014204 */     // GIR_Coverage, 16358,
     /* 2014204 */     GIR_EraseRootFromParent_Done,
     /* 2014205 */   // Label 26873: @2014205
     /* 2014205 */   GIM_Try, /*On fail goto*//*Label 26874*/ GIMT_Encode4(2014310), // Rule ID 16359 //
     /* 2014210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2014221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2014224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2014227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2014233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2014240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014260 */     // MIs[1] Operand 1
     /* 2014260 */     // No operand predicates
     /* 2014260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014264 */     // MIs[0] round
     /* 2014264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014267 */     // MIs[0] policy
     /* 2014267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2014282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014309 */     // GIR_Coverage, 16359,
     /* 2014309 */     GIR_EraseRootFromParent_Done,
     /* 2014310 */   // Label 26874: @2014310
     /* 2014310 */   GIM_Try, /*On fail goto*//*Label 26875*/ GIMT_Encode4(2014415), // Rule ID 16362 //
     /* 2014315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2014326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2014329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2014345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014361 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014365 */     // MIs[1] Operand 1
     /* 2014365 */     // No operand predicates
     /* 2014365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014369 */     // MIs[0] round
     /* 2014369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014372 */     // MIs[0] policy
     /* 2014372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014384 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2014387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014414 */     // GIR_Coverage, 16362,
     /* 2014414 */     GIR_EraseRootFromParent_Done,
     /* 2014415 */   // Label 26875: @2014415
     /* 2014415 */   GIM_Try, /*On fail goto*//*Label 26876*/ GIMT_Encode4(2014520), // Rule ID 16363 //
     /* 2014420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2014431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2014434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2014437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2014443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2014450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2014454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2014458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014466 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014470 */     // MIs[1] Operand 1
     /* 2014470 */     // No operand predicates
     /* 2014470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014474 */     // MIs[0] round
     /* 2014474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014477 */     // MIs[0] policy
     /* 2014477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014489 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2014492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2014513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014519 */     // GIR_Coverage, 16363,
     /* 2014519 */     GIR_EraseRootFromParent_Done,
     /* 2014520 */   // Label 26876: @2014520
     /* 2014520 */   GIM_Try, /*On fail goto*//*Label 26877*/ GIMT_Encode4(2014625), // Rule ID 16366 //
     /* 2014525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2014536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2014539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014571 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014575 */     // MIs[1] Operand 1
     /* 2014575 */     // No operand predicates
     /* 2014575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014579 */     // MIs[0] round
     /* 2014579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014582 */     // MIs[0] policy
     /* 2014582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014594 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2014597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014624 */     // GIR_Coverage, 16366,
     /* 2014624 */     GIR_EraseRootFromParent_Done,
     /* 2014625 */   // Label 26877: @2014625
     /* 2014625 */   GIM_Try, /*On fail goto*//*Label 26878*/ GIMT_Encode4(2014730), // Rule ID 16367 //
     /* 2014630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2014641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2014644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2014647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2014653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014676 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014680 */     // MIs[1] Operand 1
     /* 2014680 */     // No operand predicates
     /* 2014680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014684 */     // MIs[0] round
     /* 2014684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014687 */     // MIs[0] policy
     /* 2014687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014699 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF4_MASK),
     /* 2014702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014725 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014729 */     // GIR_Coverage, 16367,
     /* 2014729 */     GIR_EraseRootFromParent_Done,
     /* 2014730 */   // Label 26878: @2014730
     /* 2014730 */   GIM_Try, /*On fail goto*//*Label 26879*/ GIMT_Encode4(2014835), // Rule ID 16370 //
     /* 2014735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2014746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2014749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014781 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014785 */     // MIs[1] Operand 1
     /* 2014785 */     // No operand predicates
     /* 2014785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014789 */     // MIs[0] round
     /* 2014789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014792 */     // MIs[0] policy
     /* 2014792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014804 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2014804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2014807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014809 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014813 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014834 */     // GIR_Coverage, 16370,
     /* 2014834 */     GIR_EraseRootFromParent_Done,
     /* 2014835 */   // Label 26879: @2014835
     /* 2014835 */   GIM_Try, /*On fail goto*//*Label 26880*/ GIMT_Encode4(2014940), // Rule ID 16371 //
     /* 2014840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2014843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2014851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2014854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2014857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2014860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2014863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2014866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014886 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014890 */     // MIs[1] Operand 1
     /* 2014890 */     // No operand predicates
     /* 2014890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014894 */     // MIs[0] round
     /* 2014894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2014897 */     // MIs[0] policy
     /* 2014897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2014900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2014902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2014909 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2014909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2014912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2014914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2014916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2014918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2014921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2014923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2014925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2014930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2014933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2014935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2014938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014939 */     // GIR_Coverage, 16371,
     /* 2014939 */     GIR_EraseRootFromParent_Done,
     /* 2014940 */   // Label 26880: @2014940
     /* 2014940 */   GIM_Try, /*On fail goto*//*Label 26881*/ GIMT_Encode4(2015045), // Rule ID 16374 //
     /* 2014945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2014948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2014953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2014956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2014959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2014962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2014965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2014968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2014971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2014975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2014979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2014983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2014987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2014991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2014995 */     // MIs[1] Operand 1
     /* 2014995 */     // No operand predicates
     /* 2014995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2014999 */     // MIs[0] round
     /* 2014999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015002 */     // MIs[0] policy
     /* 2015002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015014 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2015017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015040 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015044 */     // GIR_Coverage, 16374,
     /* 2015044 */     GIR_EraseRootFromParent_Done,
     /* 2015045 */   // Label 26881: @2015045
     /* 2015045 */   GIM_Try, /*On fail goto*//*Label 26882*/ GIMT_Encode4(2015150), // Rule ID 16375 //
     /* 2015050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2015061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2015064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2015067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2015073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015096 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015100 */     // MIs[1] Operand 1
     /* 2015100 */     // No operand predicates
     /* 2015100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015104 */     // MIs[0] round
     /* 2015104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015107 */     // MIs[0] policy
     /* 2015107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015119 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2015122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015145 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015149 */     // GIR_Coverage, 16375,
     /* 2015149 */     GIR_EraseRootFromParent_Done,
     /* 2015150 */   // Label 26882: @2015150
     /* 2015150 */   GIM_Try, /*On fail goto*//*Label 26883*/ GIMT_Encode4(2015255), // Rule ID 16378 //
     /* 2015155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2015166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2015169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015205 */     // MIs[1] Operand 1
     /* 2015205 */     // No operand predicates
     /* 2015205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015209 */     // MIs[0] round
     /* 2015209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015212 */     // MIs[0] policy
     /* 2015212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2015227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015250 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015254 */     // GIR_Coverage, 16378,
     /* 2015254 */     GIR_EraseRootFromParent_Done,
     /* 2015255 */   // Label 26883: @2015255
     /* 2015255 */   GIM_Try, /*On fail goto*//*Label 26884*/ GIMT_Encode4(2015360), // Rule ID 16379 //
     /* 2015260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2015271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2015274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2015277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2015283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2015290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015306 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015310 */     // MIs[1] Operand 1
     /* 2015310 */     // No operand predicates
     /* 2015310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015314 */     // MIs[0] round
     /* 2015314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015317 */     // MIs[0] policy
     /* 2015317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015320 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2015332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015338 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015359 */     // GIR_Coverage, 16379,
     /* 2015359 */     GIR_EraseRootFromParent_Done,
     /* 2015360 */   // Label 26884: @2015360
     /* 2015360 */   GIM_Try, /*On fail goto*//*Label 26885*/ GIMT_Encode4(2015465), // Rule ID 16382 //
     /* 2015365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2015368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2015376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2015379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015411 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015415 */     // MIs[1] Operand 1
     /* 2015415 */     // No operand predicates
     /* 2015415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015419 */     // MIs[0] round
     /* 2015419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015422 */     // MIs[0] policy
     /* 2015422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015434 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2015437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015443 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015464 */     // GIR_Coverage, 16382,
     /* 2015464 */     GIR_EraseRootFromParent_Done,
     /* 2015465 */   // Label 26885: @2015465
     /* 2015465 */   GIM_Try, /*On fail goto*//*Label 26886*/ GIMT_Encode4(2015570), // Rule ID 16383 //
     /* 2015470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2015473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2015481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2015484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2015487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2015493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2015500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2015504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2015508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015520 */     // MIs[1] Operand 1
     /* 2015520 */     // No operand predicates
     /* 2015520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015524 */     // MIs[0] round
     /* 2015524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015527 */     // MIs[0] policy
     /* 2015527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015530 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015539 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2015542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2015563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015565 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015569 */     // GIR_Coverage, 16383,
     /* 2015569 */     GIR_EraseRootFromParent_Done,
     /* 2015570 */   // Label 26886: @2015570
     /* 2015570 */   GIM_Try, /*On fail goto*//*Label 26887*/ GIMT_Encode4(2015675), // Rule ID 16386 //
     /* 2015575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2015578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2015586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2015589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2015592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015625 */     // MIs[1] Operand 1
     /* 2015625 */     // No operand predicates
     /* 2015625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015629 */     // MIs[0] round
     /* 2015629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015632 */     // MIs[0] policy
     /* 2015632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015644 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2015647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015670 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015674 */     // GIR_Coverage, 16386,
     /* 2015674 */     GIR_EraseRootFromParent_Done,
     /* 2015675 */   // Label 26887: @2015675
     /* 2015675 */   GIM_Try, /*On fail goto*//*Label 26888*/ GIMT_Encode4(2015780), // Rule ID 16387 //
     /* 2015680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2015683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2015691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2015694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2015697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2015703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015730 */     // MIs[1] Operand 1
     /* 2015730 */     // No operand predicates
     /* 2015730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015734 */     // MIs[0] round
     /* 2015734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015737 */     // MIs[0] policy
     /* 2015737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015749 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_MF2_MASK),
     /* 2015752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015779 */     // GIR_Coverage, 16387,
     /* 2015779 */     GIR_EraseRootFromParent_Done,
     /* 2015780 */   // Label 26888: @2015780
     /* 2015780 */   GIM_Try, /*On fail goto*//*Label 26889*/ GIMT_Encode4(2015885), // Rule ID 16390 //
     /* 2015785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2015788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2015802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2015805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2015811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015835 */     // MIs[1] Operand 1
     /* 2015835 */     // No operand predicates
     /* 2015835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015839 */     // MIs[0] round
     /* 2015839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015842 */     // MIs[0] policy
     /* 2015842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015854 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2015854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2015857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015880 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015884 */     // GIR_Coverage, 16390,
     /* 2015884 */     GIR_EraseRootFromParent_Done,
     /* 2015885 */   // Label 26889: @2015885
     /* 2015885 */   GIM_Try, /*On fail goto*//*Label 26890*/ GIMT_Encode4(2015990), // Rule ID 16391 //
     /* 2015890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2015893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2015898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2015901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2015904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2015907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2015910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2015913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2015916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2015920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2015924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2015928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2015932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2015936 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2015940 */     // MIs[1] Operand 1
     /* 2015940 */     // No operand predicates
     /* 2015940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2015944 */     // MIs[0] round
     /* 2015944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2015947 */     // MIs[0] policy
     /* 2015947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2015950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2015952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2015959 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2015959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M1_MASK),
     /* 2015962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2015964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2015966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2015968 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2015971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2015973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2015975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2015980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2015983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2015985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2015988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2015989 */     // GIR_Coverage, 16391,
     /* 2015989 */     GIR_EraseRootFromParent_Done,
     /* 2015990 */   // Label 26890: @2015990
     /* 2015990 */   GIM_Try, /*On fail goto*//*Label 26891*/ GIMT_Encode4(2016095), // Rule ID 16394 //
     /* 2015995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2015998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2016003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2016006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2016009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2016012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016045 */     // MIs[1] Operand 1
     /* 2016045 */     // No operand predicates
     /* 2016045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016049 */     // MIs[0] round
     /* 2016049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016052 */     // MIs[0] policy
     /* 2016052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2016067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016073 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016094 */     // GIR_Coverage, 16394,
     /* 2016094 */     GIR_EraseRootFromParent_Done,
     /* 2016095 */   // Label 26891: @2016095
     /* 2016095 */   GIM_Try, /*On fail goto*//*Label 26892*/ GIMT_Encode4(2016200), // Rule ID 16395 //
     /* 2016100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2016103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2016108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2016111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2016114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2016117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2016130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2016134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016150 */     // MIs[1] Operand 1
     /* 2016150 */     // No operand predicates
     /* 2016150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016154 */     // MIs[0] round
     /* 2016154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016157 */     // MIs[0] policy
     /* 2016157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M2_MASK),
     /* 2016172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016174 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016195 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016199 */     // GIR_Coverage, 16395,
     /* 2016199 */     GIR_EraseRootFromParent_Done,
     /* 2016200 */   // Label 26892: @2016200
     /* 2016200 */   GIM_Try, /*On fail goto*//*Label 26893*/ GIMT_Encode4(2016305), // Rule ID 16398 //
     /* 2016205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2016208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2016213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2016216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2016219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2016222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016251 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016255 */     // MIs[1] Operand 1
     /* 2016255 */     // No operand predicates
     /* 2016255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016259 */     // MIs[0] round
     /* 2016259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016262 */     // MIs[0] policy
     /* 2016262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016274 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2016277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016300 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016304 */     // GIR_Coverage, 16398,
     /* 2016304 */     GIR_EraseRootFromParent_Done,
     /* 2016305 */   // Label 26893: @2016305
     /* 2016305 */   GIM_Try, /*On fail goto*//*Label 26894*/ GIMT_Encode4(2016410), // Rule ID 16399 //
     /* 2016310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2016313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2016318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2016321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2016324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2016327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2016333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2016340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2016344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2016348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016356 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016360 */     // MIs[1] Operand 1
     /* 2016360 */     // No operand predicates
     /* 2016360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016364 */     // MIs[0] round
     /* 2016364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016367 */     // MIs[0] policy
     /* 2016367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016379 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WI_M4_MASK),
     /* 2016382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2016403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016409 */     // GIR_Coverage, 16399,
     /* 2016409 */     GIR_EraseRootFromParent_Done,
     /* 2016410 */   // Label 26894: @2016410
     /* 2016410 */   GIM_Try, /*On fail goto*//*Label 26895*/ GIMT_Encode4(2016515), // Rule ID 16522 //
     /* 2016415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2016426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2016429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016461 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016465 */     // MIs[1] Operand 1
     /* 2016465 */     // No operand predicates
     /* 2016465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016469 */     // MIs[0] round
     /* 2016469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016472 */     // MIs[0] policy
     /* 2016472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016484 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2016487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016493 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016510 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016514 */     // GIR_Coverage, 16522,
     /* 2016514 */     GIR_EraseRootFromParent_Done,
     /* 2016515 */   // Label 26895: @2016515
     /* 2016515 */   GIM_Try, /*On fail goto*//*Label 26896*/ GIMT_Encode4(2016620), // Rule ID 16523 //
     /* 2016520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2016531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2016534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2016537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2016543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016566 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016570 */     // MIs[1] Operand 1
     /* 2016570 */     // No operand predicates
     /* 2016570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016574 */     // MIs[0] round
     /* 2016574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016577 */     // MIs[0] policy
     /* 2016577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016589 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF8_MASK),
     /* 2016592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016615 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016619 */     // GIR_Coverage, 16523,
     /* 2016619 */     GIR_EraseRootFromParent_Done,
     /* 2016620 */   // Label 26896: @2016620
     /* 2016620 */   GIM_Try, /*On fail goto*//*Label 26897*/ GIMT_Encode4(2016725), // Rule ID 16526 //
     /* 2016625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016671 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016675 */     // MIs[1] Operand 1
     /* 2016675 */     // No operand predicates
     /* 2016675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016679 */     // MIs[0] round
     /* 2016679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016682 */     // MIs[0] policy
     /* 2016682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016694 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2016697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016724 */     // GIR_Coverage, 16526,
     /* 2016724 */     GIR_EraseRootFromParent_Done,
     /* 2016725 */   // Label 26897: @2016725
     /* 2016725 */   GIM_Try, /*On fail goto*//*Label 26898*/ GIMT_Encode4(2016830), // Rule ID 16527 //
     /* 2016730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2016741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2016744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2016747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2016753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016776 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016780 */     // MIs[1] Operand 1
     /* 2016780 */     // No operand predicates
     /* 2016780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016784 */     // MIs[0] round
     /* 2016784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016787 */     // MIs[0] policy
     /* 2016787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016799 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2016799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2016802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016829 */     // GIR_Coverage, 16527,
     /* 2016829 */     GIR_EraseRootFromParent_Done,
     /* 2016830 */   // Label 26898: @2016830
     /* 2016830 */   GIM_Try, /*On fail goto*//*Label 26899*/ GIMT_Encode4(2016935), // Rule ID 16530 //
     /* 2016835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2016838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2016852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2016855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2016861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016881 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016885 */     // MIs[1] Operand 1
     /* 2016885 */     // No operand predicates
     /* 2016885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016889 */     // MIs[0] round
     /* 2016889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016892 */     // MIs[0] policy
     /* 2016892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2016895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2016897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2016904 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2016904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2016907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2016909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2016911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2016913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2016916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2016918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2016920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2016925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2016928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2016930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2016933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2016934 */     // GIR_Coverage, 16530,
     /* 2016934 */     GIR_EraseRootFromParent_Done,
     /* 2016935 */   // Label 26899: @2016935
     /* 2016935 */   GIM_Try, /*On fail goto*//*Label 26900*/ GIMT_Encode4(2017040), // Rule ID 16531 //
     /* 2016940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2016943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2016948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2016951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2016954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2016957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2016960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2016963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2016966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2016970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2016978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2016982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2016986 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2016990 */     // MIs[1] Operand 1
     /* 2016990 */     // No operand predicates
     /* 2016990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2016994 */     // MIs[0] round
     /* 2016994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2016997 */     // MIs[0] policy
     /* 2016997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017009 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2017012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017039 */     // GIR_Coverage, 16531,
     /* 2017039 */     GIR_EraseRootFromParent_Done,
     /* 2017040 */   // Label 26900: @2017040
     /* 2017040 */   GIM_Try, /*On fail goto*//*Label 26901*/ GIMT_Encode4(2017145), // Rule ID 16534 //
     /* 2017045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2017062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017091 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017095 */     // MIs[1] Operand 1
     /* 2017095 */     // No operand predicates
     /* 2017095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017099 */     // MIs[0] round
     /* 2017099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017102 */     // MIs[0] policy
     /* 2017102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017114 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2017117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017140 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017144 */     // GIR_Coverage, 16534,
     /* 2017144 */     GIR_EraseRootFromParent_Done,
     /* 2017145 */   // Label 26901: @2017145
     /* 2017145 */   GIM_Try, /*On fail goto*//*Label 26902*/ GIMT_Encode4(2017250), // Rule ID 16535 //
     /* 2017150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2017161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2017164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2017167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2017173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017200 */     // MIs[1] Operand 1
     /* 2017200 */     // No operand predicates
     /* 2017200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017204 */     // MIs[0] round
     /* 2017204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017207 */     // MIs[0] policy
     /* 2017207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017219 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2017222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017228 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017249 */     // GIR_Coverage, 16535,
     /* 2017249 */     GIR_EraseRootFromParent_Done,
     /* 2017250 */   // Label 26902: @2017250
     /* 2017250 */   GIM_Try, /*On fail goto*//*Label 26903*/ GIMT_Encode4(2017355), // Rule ID 16538 //
     /* 2017255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2017272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017301 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017305 */     // MIs[1] Operand 1
     /* 2017305 */     // No operand predicates
     /* 2017305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017309 */     // MIs[0] round
     /* 2017309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017312 */     // MIs[0] policy
     /* 2017312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017324 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2017327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017350 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017354 */     // GIR_Coverage, 16538,
     /* 2017354 */     GIR_EraseRootFromParent_Done,
     /* 2017355 */   // Label 26903: @2017355
     /* 2017355 */   GIM_Try, /*On fail goto*//*Label 26904*/ GIMT_Encode4(2017460), // Rule ID 16539 //
     /* 2017360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2017371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2017374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2017377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2017383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2017390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2017394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017406 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017410 */     // MIs[1] Operand 1
     /* 2017410 */     // No operand predicates
     /* 2017410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017414 */     // MIs[0] round
     /* 2017414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017417 */     // MIs[0] policy
     /* 2017417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017429 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2017432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017459 */     // GIR_Coverage, 16539,
     /* 2017459 */     GIR_EraseRootFromParent_Done,
     /* 2017460 */   // Label 26904: @2017460
     /* 2017460 */   GIM_Try, /*On fail goto*//*Label 26905*/ GIMT_Encode4(2017565), // Rule ID 16542 //
     /* 2017465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2017482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017511 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017515 */     // MIs[1] Operand 1
     /* 2017515 */     // No operand predicates
     /* 2017515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017519 */     // MIs[0] round
     /* 2017519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017522 */     // MIs[0] policy
     /* 2017522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017525 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017534 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2017537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017564 */     // GIR_Coverage, 16542,
     /* 2017564 */     GIR_EraseRootFromParent_Done,
     /* 2017565 */   // Label 26905: @2017565
     /* 2017565 */   GIM_Try, /*On fail goto*//*Label 26906*/ GIMT_Encode4(2017670), // Rule ID 16543 //
     /* 2017570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2017581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2017584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2017587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2017593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2017600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2017604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2017608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017616 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017620 */     // MIs[1] Operand 1
     /* 2017620 */     // No operand predicates
     /* 2017620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017624 */     // MIs[0] round
     /* 2017624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017627 */     // MIs[0] policy
     /* 2017627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017630 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017639 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2017642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2017663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017669 */     // GIR_Coverage, 16543,
     /* 2017669 */     GIR_EraseRootFromParent_Done,
     /* 2017670 */   // Label 26906: @2017670
     /* 2017670 */   GIM_Try, /*On fail goto*//*Label 26907*/ GIMT_Encode4(2017775), // Rule ID 16546 //
     /* 2017675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2017686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2017689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017725 */     // MIs[1] Operand 1
     /* 2017725 */     // No operand predicates
     /* 2017725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017729 */     // MIs[0] round
     /* 2017729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017732 */     // MIs[0] policy
     /* 2017732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017744 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2017747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017770 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017774 */     // GIR_Coverage, 16546,
     /* 2017774 */     GIR_EraseRootFromParent_Done,
     /* 2017775 */   // Label 26907: @2017775
     /* 2017775 */   GIM_Try, /*On fail goto*//*Label 26908*/ GIMT_Encode4(2017880), // Rule ID 16547 //
     /* 2017780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2017791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2017794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2017797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2017800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2017803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2017806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017830 */     // MIs[1] Operand 1
     /* 2017830 */     // No operand predicates
     /* 2017830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017834 */     // MIs[0] round
     /* 2017834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017837 */     // MIs[0] policy
     /* 2017837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017849 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2017849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF4_MASK),
     /* 2017852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017879 */     // GIR_Coverage, 16547,
     /* 2017879 */     GIR_EraseRootFromParent_Done,
     /* 2017880 */   // Label 26908: @2017880
     /* 2017880 */   GIM_Try, /*On fail goto*//*Label 26909*/ GIMT_Encode4(2017985), // Rule ID 16550 //
     /* 2017885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2017888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2017896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2017899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2017902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2017905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2017908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2017911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2017915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2017923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2017927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2017931 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2017935 */     // MIs[1] Operand 1
     /* 2017935 */     // No operand predicates
     /* 2017935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2017939 */     // MIs[0] round
     /* 2017939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2017942 */     // MIs[0] policy
     /* 2017942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2017945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2017947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2017954 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2017954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2017957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2017959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2017961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2017963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2017966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2017968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2017970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2017975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2017978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2017980 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2017983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2017984 */     // GIR_Coverage, 16550,
     /* 2017984 */     GIR_EraseRootFromParent_Done,
     /* 2017985 */   // Label 26909: @2017985
     /* 2017985 */   GIM_Try, /*On fail goto*//*Label 26910*/ GIMT_Encode4(2018090), // Rule ID 16551 //
     /* 2017990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2017993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2017998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2018001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2018004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2018007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018040 */     // MIs[1] Operand 1
     /* 2018040 */     // No operand predicates
     /* 2018040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018044 */     // MIs[0] round
     /* 2018044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018047 */     // MIs[0] policy
     /* 2018047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018059 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2018062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018085 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018089 */     // GIR_Coverage, 16551,
     /* 2018089 */     GIR_EraseRootFromParent_Done,
     /* 2018090 */   // Label 26910: @2018090
     /* 2018090 */   GIM_Try, /*On fail goto*//*Label 26911*/ GIMT_Encode4(2018195), // Rule ID 16554 //
     /* 2018095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2018106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2018109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018141 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018145 */     // MIs[1] Operand 1
     /* 2018145 */     // No operand predicates
     /* 2018145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018149 */     // MIs[0] round
     /* 2018149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018152 */     // MIs[0] policy
     /* 2018152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018164 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2018167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018194 */     // GIR_Coverage, 16554,
     /* 2018194 */     GIR_EraseRootFromParent_Done,
     /* 2018195 */   // Label 26911: @2018195
     /* 2018195 */   GIM_Try, /*On fail goto*//*Label 26912*/ GIMT_Encode4(2018300), // Rule ID 16555 //
     /* 2018200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2018211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2018214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2018217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2018223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018250 */     // MIs[1] Operand 1
     /* 2018250 */     // No operand predicates
     /* 2018250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018254 */     // MIs[0] round
     /* 2018254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018257 */     // MIs[0] policy
     /* 2018257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018269 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2018272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018278 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018295 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018299 */     // GIR_Coverage, 16555,
     /* 2018299 */     GIR_EraseRootFromParent_Done,
     /* 2018300 */   // Label 26912: @2018300
     /* 2018300 */   GIM_Try, /*On fail goto*//*Label 26913*/ GIMT_Encode4(2018405), // Rule ID 16558 //
     /* 2018305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2018322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018355 */     // MIs[1] Operand 1
     /* 2018355 */     // No operand predicates
     /* 2018355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018359 */     // MIs[0] round
     /* 2018359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018362 */     // MIs[0] policy
     /* 2018362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2018377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018404 */     // GIR_Coverage, 16558,
     /* 2018404 */     GIR_EraseRootFromParent_Done,
     /* 2018405 */   // Label 26913: @2018405
     /* 2018405 */   GIM_Try, /*On fail goto*//*Label 26914*/ GIMT_Encode4(2018510), // Rule ID 16559 //
     /* 2018410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2018421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2018424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2018427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2018433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2018440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018456 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018460 */     // MIs[1] Operand 1
     /* 2018460 */     // No operand predicates
     /* 2018460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018464 */     // MIs[0] round
     /* 2018464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018467 */     // MIs[0] policy
     /* 2018467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018479 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2018482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018509 */     // GIR_Coverage, 16559,
     /* 2018509 */     GIR_EraseRootFromParent_Done,
     /* 2018510 */   // Label 26914: @2018510
     /* 2018510 */   GIM_Try, /*On fail goto*//*Label 26915*/ GIMT_Encode4(2018615), // Rule ID 16562 //
     /* 2018515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2018518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2018532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018565 */     // MIs[1] Operand 1
     /* 2018565 */     // No operand predicates
     /* 2018565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018569 */     // MIs[0] round
     /* 2018569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018572 */     // MIs[0] policy
     /* 2018572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018584 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2018587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018593 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018614 */     // GIR_Coverage, 16562,
     /* 2018614 */     GIR_EraseRootFromParent_Done,
     /* 2018615 */   // Label 26915: @2018615
     /* 2018615 */   GIM_Try, /*On fail goto*//*Label 26916*/ GIMT_Encode4(2018720), // Rule ID 16563 //
     /* 2018620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2018623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2018631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2018634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2018637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2018643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2018650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2018654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2018658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018666 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018670 */     // MIs[1] Operand 1
     /* 2018670 */     // No operand predicates
     /* 2018670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018674 */     // MIs[0] round
     /* 2018674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018677 */     // MIs[0] policy
     /* 2018677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018689 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2018692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2018713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018719 */     // GIR_Coverage, 16563,
     /* 2018719 */     GIR_EraseRootFromParent_Done,
     /* 2018720 */   // Label 26916: @2018720
     /* 2018720 */   GIM_Try, /*On fail goto*//*Label 26917*/ GIMT_Encode4(2018825), // Rule ID 16566 //
     /* 2018725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2018728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2018736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2018739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2018742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2018748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018771 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018775 */     // MIs[1] Operand 1
     /* 2018775 */     // No operand predicates
     /* 2018775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018779 */     // MIs[0] round
     /* 2018779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018782 */     // MIs[0] policy
     /* 2018782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018785 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018794 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2018794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2018797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018824 */     // GIR_Coverage, 16566,
     /* 2018824 */     GIR_EraseRootFromParent_Done,
     /* 2018825 */   // Label 26917: @2018825
     /* 2018825 */   GIM_Try, /*On fail goto*//*Label 26918*/ GIMT_Encode4(2018930), // Rule ID 16567 //
     /* 2018830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2018833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2018841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2018844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2018847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2018850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2018853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2018856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018876 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018880 */     // MIs[1] Operand 1
     /* 2018880 */     // No operand predicates
     /* 2018880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018884 */     // MIs[0] round
     /* 2018884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018887 */     // MIs[0] policy
     /* 2018887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2018899 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2018899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_MF2_MASK),
     /* 2018902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2018904 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2018906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2018908 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2018911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2018913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2018915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2018920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2018923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2018925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2018928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2018929 */     // GIR_Coverage, 16567,
     /* 2018929 */     GIR_EraseRootFromParent_Done,
     /* 2018930 */   // Label 26918: @2018930
     /* 2018930 */   GIM_Try, /*On fail goto*//*Label 26919*/ GIMT_Encode4(2019035), // Rule ID 16570 //
     /* 2018935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2018938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2018943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2018946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2018949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2018952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2018955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2018958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2018961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2018965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2018969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2018973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2018977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2018981 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2018985 */     // MIs[1] Operand 1
     /* 2018985 */     // No operand predicates
     /* 2018985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2018989 */     // MIs[0] round
     /* 2018989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2018992 */     // MIs[0] policy
     /* 2018992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2018995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2018997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019004 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2019007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019030 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019034 */     // GIR_Coverage, 16570,
     /* 2019034 */     GIR_EraseRootFromParent_Done,
     /* 2019035 */   // Label 26919: @2019035
     /* 2019035 */   GIM_Try, /*On fail goto*//*Label 26920*/ GIMT_Encode4(2019140), // Rule ID 16571 //
     /* 2019040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2019043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2019048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2019051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2019054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2019057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019090 */     // MIs[1] Operand 1
     /* 2019090 */     // No operand predicates
     /* 2019090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019094 */     // MIs[0] round
     /* 2019094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019097 */     // MIs[0] policy
     /* 2019097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019109 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M1_MASK),
     /* 2019112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019139 */     // GIR_Coverage, 16571,
     /* 2019139 */     GIR_EraseRootFromParent_Done,
     /* 2019140 */   // Label 26920: @2019140
     /* 2019140 */   GIM_Try, /*On fail goto*//*Label 26921*/ GIMT_Encode4(2019245), // Rule ID 16574 //
     /* 2019145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2019148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2019153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019195 */     // MIs[1] Operand 1
     /* 2019195 */     // No operand predicates
     /* 2019195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019199 */     // MIs[0] round
     /* 2019199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019202 */     // MIs[0] policy
     /* 2019202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2019217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019240 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019244 */     // GIR_Coverage, 16574,
     /* 2019244 */     GIR_EraseRootFromParent_Done,
     /* 2019245 */   // Label 26921: @2019245
     /* 2019245 */   GIM_Try, /*On fail goto*//*Label 26922*/ GIMT_Encode4(2019350), // Rule ID 16575 //
     /* 2019250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2019253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2019258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2019267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019300 */     // MIs[1] Operand 1
     /* 2019300 */     // No operand predicates
     /* 2019300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019304 */     // MIs[0] round
     /* 2019304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019307 */     // MIs[0] policy
     /* 2019307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M2_MASK),
     /* 2019322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019328 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019349 */     // GIR_Coverage, 16575,
     /* 2019349 */     GIR_EraseRootFromParent_Done,
     /* 2019350 */   // Label 26922: @2019350
     /* 2019350 */   GIM_Try, /*On fail goto*//*Label 26923*/ GIMT_Encode4(2019455), // Rule ID 16578 //
     /* 2019355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2019358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2019363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2019375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019401 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019405 */     // MIs[1] Operand 1
     /* 2019405 */     // No operand predicates
     /* 2019405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019409 */     // MIs[0] round
     /* 2019409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019412 */     // MIs[0] policy
     /* 2019412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019424 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2019427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019454 */     // GIR_Coverage, 16578,
     /* 2019454 */     GIR_EraseRootFromParent_Done,
     /* 2019455 */   // Label 26923: @2019455
     /* 2019455 */   GIM_Try, /*On fail goto*//*Label 26924*/ GIMT_Encode4(2019560), // Rule ID 16579 //
     /* 2019460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2019463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2019468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2019471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2019474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2019477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2019480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2019483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2019490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2019494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2019498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 2019502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2019506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2019510 */     // MIs[1] Operand 1
     /* 2019510 */     // No operand predicates
     /* 2019510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019514 */     // MIs[0] round
     /* 2019514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019517 */     // MIs[0] policy
     /* 2019517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2019522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019529 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WI_M4_MASK),
     /* 2019532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2019538 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2019541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2019553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019555 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2019558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019559 */     // GIR_Coverage, 16579,
     /* 2019559 */     GIR_EraseRootFromParent_Done,
     /* 2019560 */   // Label 26924: @2019560
     /* 2019560 */   GIM_Try, /*On fail goto*//*Label 26925*/ GIMT_Encode4(2019647), // Rule ID 2658 //
     /* 2019565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2019568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2019576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2019579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2019582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019596 */     // MIs[0] passthru
     /* 2019596 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2019601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019609 */     // MIs[0] round
     /* 2019609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019612 */     // MIs[0] policy
     /* 2019612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019622 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2019625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019646 */     // GIR_Coverage, 2658,
     /* 2019646 */     GIR_EraseRootFromParent_Done,
     /* 2019647 */   // Label 26925: @2019647
     /* 2019647 */   GIM_Try, /*On fail goto*//*Label 26926*/ GIMT_Encode4(2019734), // Rule ID 2659 //
     /* 2019652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2019655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2019663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2019666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2019669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2019672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019683 */     // MIs[0] passthru
     /* 2019683 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2019688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019696 */     // MIs[0] round
     /* 2019696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019699 */     // MIs[0] policy
     /* 2019699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019709 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK_TIED),
     /* 2019712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019733 */     // GIR_Coverage, 2659,
     /* 2019733 */     GIR_EraseRootFromParent_Done,
     /* 2019734 */   // Label 26926: @2019734
     /* 2019734 */   GIM_Try, /*On fail goto*//*Label 26927*/ GIMT_Encode4(2019821), // Rule ID 17030 //
     /* 2019739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2019742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2019750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2019753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2019756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019770 */     // MIs[0] passthru
     /* 2019770 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2019775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019783 */     // MIs[0] round
     /* 2019783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019786 */     // MIs[0] policy
     /* 2019786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019796 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2019799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019820 */     // GIR_Coverage, 17030,
     /* 2019820 */     GIR_EraseRootFromParent_Done,
     /* 2019821 */   // Label 26927: @2019821
     /* 2019821 */   GIM_Try, /*On fail goto*//*Label 26928*/ GIMT_Encode4(2019908), // Rule ID 17031 //
     /* 2019826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2019829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2019837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2019840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2019843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2019846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2019849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2019853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019857 */     // MIs[0] passthru
     /* 2019857 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2019862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019870 */     // MIs[0] round
     /* 2019870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019873 */     // MIs[0] policy
     /* 2019873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019883 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2019883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK_TIED),
     /* 2019886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019907 */     // GIR_Coverage, 17031,
     /* 2019907 */     GIR_EraseRootFromParent_Done,
     /* 2019908 */   // Label 26928: @2019908
     /* 2019908 */   GIM_Try, /*On fail goto*//*Label 26929*/ GIMT_Encode4(2019995), // Rule ID 17040 //
     /* 2019913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2019916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2019921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2019924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2019927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2019930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2019933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2019936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2019940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2019944 */     // MIs[0] passthru
     /* 2019944 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2019949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2019953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2019957 */     // MIs[0] round
     /* 2019957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2019960 */     // MIs[0] policy
     /* 2019960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2019963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2019970 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2019970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2019973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2019975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2019977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2019979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2019981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2019983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2019988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2019991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2019993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2019994 */     // GIR_Coverage, 17040,
     /* 2019994 */     GIR_EraseRootFromParent_Done,
     /* 2019995 */   // Label 26929: @2019995
     /* 2019995 */   GIM_Try, /*On fail goto*//*Label 26930*/ GIMT_Encode4(2020082), // Rule ID 17041 //
     /* 2020000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2020011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2020014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2020017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020031 */     // MIs[0] passthru
     /* 2020031 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020044 */     // MIs[0] round
     /* 2020044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020047 */     // MIs[0] policy
     /* 2020047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020057 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK_TIED),
     /* 2020060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020081 */     // GIR_Coverage, 17041,
     /* 2020081 */     GIR_EraseRootFromParent_Done,
     /* 2020082 */   // Label 26930: @2020082
     /* 2020082 */   GIM_Try, /*On fail goto*//*Label 26931*/ GIMT_Encode4(2020169), // Rule ID 17050 //
     /* 2020087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2020104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020118 */     // MIs[0] passthru
     /* 2020118 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020131 */     // MIs[0] round
     /* 2020131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020134 */     // MIs[0] policy
     /* 2020134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020144 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2020147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020168 */     // GIR_Coverage, 17050,
     /* 2020168 */     GIR_EraseRootFromParent_Done,
     /* 2020169 */   // Label 26931: @2020169
     /* 2020169 */   GIM_Try, /*On fail goto*//*Label 26932*/ GIMT_Encode4(2020256), // Rule ID 17051 //
     /* 2020174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2020185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2020188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2020191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020205 */     // MIs[0] passthru
     /* 2020205 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020218 */     // MIs[0] round
     /* 2020218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020221 */     // MIs[0] policy
     /* 2020221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020231 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK_TIED),
     /* 2020234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020255 */     // GIR_Coverage, 17051,
     /* 2020255 */     GIR_EraseRootFromParent_Done,
     /* 2020256 */   // Label 26932: @2020256
     /* 2020256 */   GIM_Try, /*On fail goto*//*Label 26933*/ GIMT_Encode4(2020343), // Rule ID 17060 //
     /* 2020261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2020264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2020272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2020275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2020278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2020281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020292 */     // MIs[0] passthru
     /* 2020292 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020305 */     // MIs[0] round
     /* 2020305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020308 */     // MIs[0] policy
     /* 2020308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020318 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2020321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020342 */     // GIR_Coverage, 17060,
     /* 2020342 */     GIR_EraseRootFromParent_Done,
     /* 2020343 */   // Label 26933: @2020343
     /* 2020343 */   GIM_Try, /*On fail goto*//*Label 26934*/ GIMT_Encode4(2020430), // Rule ID 17061 //
     /* 2020348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2020351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2020359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2020362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2020365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2020368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020379 */     // MIs[0] passthru
     /* 2020379 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020392 */     // MIs[0] round
     /* 2020392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020395 */     // MIs[0] policy
     /* 2020395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020405 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK_TIED),
     /* 2020408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2020426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020429 */     // GIR_Coverage, 17061,
     /* 2020429 */     GIR_EraseRootFromParent_Done,
     /* 2020430 */   // Label 26934: @2020430
     /* 2020430 */   GIM_Try, /*On fail goto*//*Label 26935*/ GIMT_Encode4(2020517), // Rule ID 17070 //
     /* 2020435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2020438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2020446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2020449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2020452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020466 */     // MIs[0] passthru
     /* 2020466 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020479 */     // MIs[0] round
     /* 2020479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020482 */     // MIs[0] policy
     /* 2020482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020492 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2020495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020516 */     // GIR_Coverage, 17070,
     /* 2020516 */     GIR_EraseRootFromParent_Done,
     /* 2020517 */   // Label 26935: @2020517
     /* 2020517 */   GIM_Try, /*On fail goto*//*Label 26936*/ GIMT_Encode4(2020604), // Rule ID 17071 //
     /* 2020522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2020525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2020533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2020536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2020539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2020542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2020549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020553 */     // MIs[0] passthru
     /* 2020553 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020566 */     // MIs[0] round
     /* 2020566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020569 */     // MIs[0] policy
     /* 2020569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020579 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK_TIED),
     /* 2020582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020603 */     // GIR_Coverage, 17071,
     /* 2020603 */     GIR_EraseRootFromParent_Done,
     /* 2020604 */   // Label 26936: @2020604
     /* 2020604 */   GIM_Try, /*On fail goto*//*Label 26937*/ GIMT_Encode4(2020691), // Rule ID 17080 //
     /* 2020609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2020612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2020620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2020623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2020626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020640 */     // MIs[0] passthru
     /* 2020640 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020653 */     // MIs[0] round
     /* 2020653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020656 */     // MIs[0] policy
     /* 2020656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2020669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020690 */     // GIR_Coverage, 17080,
     /* 2020690 */     GIR_EraseRootFromParent_Done,
     /* 2020691 */   // Label 26937: @2020691
     /* 2020691 */   GIM_Try, /*On fail goto*//*Label 26938*/ GIMT_Encode4(2020778), // Rule ID 17081 //
     /* 2020696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2020699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2020707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2020710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2020713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2020716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2020723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020727 */     // MIs[0] passthru
     /* 2020727 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2020736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020740 */     // MIs[0] round
     /* 2020740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020743 */     // MIs[0] policy
     /* 2020743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020753 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK_TIED),
     /* 2020756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020777 */     // GIR_Coverage, 17081,
     /* 2020777 */     GIR_EraseRootFromParent_Done,
     /* 2020778 */   // Label 26938: @2020778
     /* 2020778 */   GIM_Try, /*On fail goto*//*Label 26939*/ GIMT_Encode4(2020865), // Rule ID 17090 //
     /* 2020783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2020786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2020800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020814 */     // MIs[0] passthru
     /* 2020814 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020827 */     // MIs[0] round
     /* 2020827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020830 */     // MIs[0] policy
     /* 2020830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020840 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2020840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2020843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020864 */     // GIR_Coverage, 17090,
     /* 2020864 */     GIR_EraseRootFromParent_Done,
     /* 2020865 */   // Label 26939: @2020865
     /* 2020865 */   GIM_Try, /*On fail goto*//*Label 26940*/ GIMT_Encode4(2020952), // Rule ID 17091 //
     /* 2020870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2020873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2020881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2020884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2020887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2020890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2020893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2020897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020901 */     // MIs[0] passthru
     /* 2020901 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2020910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2020914 */     // MIs[0] round
     /* 2020914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2020917 */     // MIs[0] policy
     /* 2020917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2020920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2020927 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2020927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK_TIED),
     /* 2020930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2020932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2020934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2020936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2020938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2020940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2020945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2020948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2020950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2020951 */     // GIR_Coverage, 17091,
     /* 2020951 */     GIR_EraseRootFromParent_Done,
     /* 2020952 */   // Label 26940: @2020952
     /* 2020952 */   GIM_Try, /*On fail goto*//*Label 26941*/ GIMT_Encode4(2021039), // Rule ID 17100 //
     /* 2020957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2020960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2020965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2020968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2020971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2020974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2020977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2020980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2020984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2020988 */     // MIs[0] passthru
     /* 2020988 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2020993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2020997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021001 */     // MIs[0] round
     /* 2021001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021004 */     // MIs[0] policy
     /* 2021004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021014 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2021017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021038 */     // GIR_Coverage, 17100,
     /* 2021038 */     GIR_EraseRootFromParent_Done,
     /* 2021039 */   // Label 26941: @2021039
     /* 2021039 */   GIM_Try, /*On fail goto*//*Label 26942*/ GIMT_Encode4(2021126), // Rule ID 17101 //
     /* 2021044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2021047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2021052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2021055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2021058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2021061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021075 */     // MIs[0] passthru
     /* 2021075 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021088 */     // MIs[0] round
     /* 2021088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021091 */     // MIs[0] policy
     /* 2021091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021101 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK_TIED),
     /* 2021104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2021122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021125 */     // GIR_Coverage, 17101,
     /* 2021125 */     GIR_EraseRootFromParent_Done,
     /* 2021126 */   // Label 26942: @2021126
     /* 2021126 */   GIM_Try, /*On fail goto*//*Label 26943*/ GIMT_Encode4(2021213), // Rule ID 17146 //
     /* 2021131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2021148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021162 */     // MIs[0] passthru
     /* 2021162 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021175 */     // MIs[0] round
     /* 2021175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021178 */     // MIs[0] policy
     /* 2021178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021188 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2021191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021212 */     // GIR_Coverage, 17146,
     /* 2021212 */     GIR_EraseRootFromParent_Done,
     /* 2021213 */   // Label 26943: @2021213
     /* 2021213 */   GIM_Try, /*On fail goto*//*Label 26944*/ GIMT_Encode4(2021300), // Rule ID 17147 //
     /* 2021218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2021229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2021232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2021235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2021238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021249 */     // MIs[0] passthru
     /* 2021249 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021262 */     // MIs[0] round
     /* 2021262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021265 */     // MIs[0] policy
     /* 2021265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021275 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK_TIED:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK_TIED),
     /* 2021278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021299 */     // GIR_Coverage, 17147,
     /* 2021299 */     GIR_EraseRootFromParent_Done,
     /* 2021300 */   // Label 26944: @2021300
     /* 2021300 */   GIM_Try, /*On fail goto*//*Label 26945*/ GIMT_Encode4(2021387), // Rule ID 17156 //
     /* 2021305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2021322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021336 */     // MIs[0] passthru
     /* 2021336 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021349 */     // MIs[0] round
     /* 2021349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021352 */     // MIs[0] policy
     /* 2021352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021362 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2021365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021386 */     // GIR_Coverage, 17156,
     /* 2021386 */     GIR_EraseRootFromParent_Done,
     /* 2021387 */   // Label 26945: @2021387
     /* 2021387 */   GIM_Try, /*On fail goto*//*Label 26946*/ GIMT_Encode4(2021474), // Rule ID 17157 //
     /* 2021392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2021403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2021406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2021409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2021412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2021419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021423 */     // MIs[0] passthru
     /* 2021423 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021436 */     // MIs[0] round
     /* 2021436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021439 */     // MIs[0] policy
     /* 2021439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021449 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK_TIED:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK_TIED),
     /* 2021452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021473 */     // GIR_Coverage, 17157,
     /* 2021473 */     GIR_EraseRootFromParent_Done,
     /* 2021474 */   // Label 26946: @2021474
     /* 2021474 */   GIM_Try, /*On fail goto*//*Label 26947*/ GIMT_Encode4(2021561), // Rule ID 17166 //
     /* 2021479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2021490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2021493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2021496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021510 */     // MIs[0] passthru
     /* 2021510 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021523 */     // MIs[0] round
     /* 2021523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021526 */     // MIs[0] policy
     /* 2021526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021536 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2021539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021560 */     // GIR_Coverage, 17166,
     /* 2021560 */     GIR_EraseRootFromParent_Done,
     /* 2021561 */   // Label 26947: @2021561
     /* 2021561 */   GIM_Try, /*On fail goto*//*Label 26948*/ GIMT_Encode4(2021648), // Rule ID 17167 //
     /* 2021566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2021577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2021580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2021583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2021586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2021593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021597 */     // MIs[0] passthru
     /* 2021597 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2021606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021610 */     // MIs[0] round
     /* 2021610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021613 */     // MIs[0] policy
     /* 2021613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021623 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK_TIED:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK_TIED),
     /* 2021626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021628 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021647 */     // GIR_Coverage, 17167,
     /* 2021647 */     GIR_EraseRootFromParent_Done,
     /* 2021648 */   // Label 26948: @2021648
     /* 2021648 */   GIM_Try, /*On fail goto*//*Label 26949*/ GIMT_Encode4(2021735), // Rule ID 17176 //
     /* 2021653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2021664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2021667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2021670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021684 */     // MIs[0] passthru
     /* 2021684 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021697 */     // MIs[0] round
     /* 2021697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021700 */     // MIs[0] policy
     /* 2021700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021710 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2021713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021734 */     // GIR_Coverage, 17176,
     /* 2021734 */     GIR_EraseRootFromParent_Done,
     /* 2021735 */   // Label 26949: @2021735
     /* 2021735 */   GIM_Try, /*On fail goto*//*Label 26950*/ GIMT_Encode4(2021822), // Rule ID 17177 //
     /* 2021740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2021751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2021754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2021757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2021760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2021767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021771 */     // MIs[0] passthru
     /* 2021771 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2021780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021784 */     // MIs[0] round
     /* 2021784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021787 */     // MIs[0] policy
     /* 2021787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021797 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK_TIED:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK_TIED),
     /* 2021800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021821 */     // GIR_Coverage, 17177,
     /* 2021821 */     GIR_EraseRootFromParent_Done,
     /* 2021822 */   // Label 26950: @2021822
     /* 2021822 */   GIM_Try, /*On fail goto*//*Label 26951*/ GIMT_Encode4(2021909), // Rule ID 17186 //
     /* 2021827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2021830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2021838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2021841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2021844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2021850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021858 */     // MIs[0] passthru
     /* 2021858 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021871 */     // MIs[0] round
     /* 2021871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021874 */     // MIs[0] policy
     /* 2021874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021884 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2021884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2021887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021908 */     // GIR_Coverage, 17186,
     /* 2021908 */     GIR_EraseRootFromParent_Done,
     /* 2021909 */   // Label 26951: @2021909
     /* 2021909 */   GIM_Try, /*On fail goto*//*Label 26952*/ GIMT_Encode4(2021996), // Rule ID 17187 //
     /* 2021914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2021917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2021922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2021925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2021928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2021931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2021934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2021937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2021941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2021945 */     // MIs[0] passthru
     /* 2021945 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2021950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2021954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2021958 */     // MIs[0] round
     /* 2021958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2021961 */     // MIs[0] policy
     /* 2021961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2021964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2021971 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK_TIED:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2021971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK_TIED),
     /* 2021974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2021976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2021978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2021980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2021982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2021984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2021989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2021992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2021994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2021995 */     // GIR_Coverage, 17187,
     /* 2021995 */     GIR_EraseRootFromParent_Done,
     /* 2021996 */   // Label 26952: @2021996
     /* 2021996 */   GIM_Try, /*On fail goto*//*Label 26953*/ GIMT_Encode4(2022083), // Rule ID 17196 //
     /* 2022001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2022018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022032 */     // MIs[0] passthru
     /* 2022032 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022045 */     // MIs[0] round
     /* 2022045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022048 */     // MIs[0] policy
     /* 2022048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022058 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2022061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022082 */     // GIR_Coverage, 17196,
     /* 2022082 */     GIR_EraseRootFromParent_Done,
     /* 2022083 */   // Label 26953: @2022083
     /* 2022083 */   GIM_Try, /*On fail goto*//*Label 26954*/ GIMT_Encode4(2022170), // Rule ID 17197 //
     /* 2022088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2022099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2022102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2022105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022119 */     // MIs[0] passthru
     /* 2022119 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022132 */     // MIs[0] round
     /* 2022132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022135 */     // MIs[0] policy
     /* 2022135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022145 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK_TIED:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK_TIED),
     /* 2022148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022169 */     // GIR_Coverage, 17197,
     /* 2022169 */     GIR_EraseRootFromParent_Done,
     /* 2022170 */   // Label 26954: @2022170
     /* 2022170 */   GIM_Try, /*On fail goto*//*Label 26955*/ GIMT_Encode4(2022257), // Rule ID 17206 //
     /* 2022175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2022186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2022189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2022192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022206 */     // MIs[0] passthru
     /* 2022206 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022219 */     // MIs[0] round
     /* 2022219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022222 */     // MIs[0] policy
     /* 2022222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022232 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2022235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022256 */     // GIR_Coverage, 17206,
     /* 2022256 */     GIR_EraseRootFromParent_Done,
     /* 2022257 */   // Label 26955: @2022257
     /* 2022257 */   GIM_Try, /*On fail goto*//*Label 26956*/ GIMT_Encode4(2022344), // Rule ID 17207 //
     /* 2022262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2022273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2022276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2022279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2022282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2022289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022293 */     // MIs[0] passthru
     /* 2022293 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022306 */     // MIs[0] round
     /* 2022306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022309 */     // MIs[0] policy
     /* 2022309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022319 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK_TIED:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK_TIED),
     /* 2022322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022343 */     // GIR_Coverage, 17207,
     /* 2022343 */     GIR_EraseRootFromParent_Done,
     /* 2022344 */   // Label 26956: @2022344
     /* 2022344 */   GIM_Try, /*On fail goto*//*Label 26957*/ GIMT_Encode4(2022431), // Rule ID 17216 //
     /* 2022349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2022360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2022363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2022366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022380 */     // MIs[0] passthru
     /* 2022380 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022393 */     // MIs[0] round
     /* 2022393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022396 */     // MIs[0] policy
     /* 2022396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022406 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2022409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022430 */     // GIR_Coverage, 17216,
     /* 2022430 */     GIR_EraseRootFromParent_Done,
     /* 2022431 */   // Label 26957: @2022431
     /* 2022431 */   GIM_Try, /*On fail goto*//*Label 26958*/ GIMT_Encode4(2022518), // Rule ID 17217 //
     /* 2022436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2022447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2022450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2022453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2022456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2022463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022467 */     // MIs[0] passthru
     /* 2022467 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2022476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022480 */     // MIs[0] round
     /* 2022480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022483 */     // MIs[0] policy
     /* 2022483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022493 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK_TIED:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK_TIED),
     /* 2022496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022517 */     // GIR_Coverage, 17217,
     /* 2022517 */     GIR_EraseRootFromParent_Done,
     /* 2022518 */   // Label 26958: @2022518
     /* 2022518 */   GIM_Try, /*On fail goto*//*Label 26959*/ GIMT_Encode4(2022605), // Rule ID 17226 //
     /* 2022523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2022526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2022534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2022537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2022540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022554 */     // MIs[0] passthru
     /* 2022554 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022567 */     // MIs[0] round
     /* 2022567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022570 */     // MIs[0] policy
     /* 2022570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022580 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2022583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022604 */     // GIR_Coverage, 17226,
     /* 2022604 */     GIR_EraseRootFromParent_Done,
     /* 2022605 */   // Label 26959: @2022605
     /* 2022605 */   GIM_Try, /*On fail goto*//*Label 26960*/ GIMT_Encode4(2022692), // Rule ID 17227 //
     /* 2022610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2022613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2022618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2022621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2022624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2022627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2022630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2022637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2022641 */     // MIs[0] passthru
     /* 2022641 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/0, /*OtherOpIdx*/2,
     /* 2022646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2022650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022654 */     // MIs[0] round
     /* 2022654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022657 */     // MIs[0] policy
     /* 2022657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022667 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK_TIED:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK_TIED),
     /* 2022670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2022688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022691 */     // GIR_Coverage, 17227,
     /* 2022691 */     GIR_EraseRootFromParent_Done,
     /* 2022692 */   // Label 26960: @2022692
     /* 2022692 */   GIM_Try, /*On fail goto*//*Label 26961*/ GIMT_Encode4(2022783), // Rule ID 2616 //
     /* 2022697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2022700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2022705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2022708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2022711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2022714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2022717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022743 */     // MIs[0] round
     /* 2022743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022746 */     // MIs[0] policy
     /* 2022746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022756 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2022759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022782 */     // GIR_Coverage, 2616,
     /* 2022782 */     GIR_EraseRootFromParent_Done,
     /* 2022783 */   // Label 26961: @2022783
     /* 2022783 */   GIM_Try, /*On fail goto*//*Label 26962*/ GIMT_Encode4(2022874), // Rule ID 2617 //
     /* 2022788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2022791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2022796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2022799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2022802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2022805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2022808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022834 */     // MIs[0] round
     /* 2022834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022837 */     // MIs[0] policy
     /* 2022837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022847 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2022847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF8_MASK),
     /* 2022850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2022870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022873 */     // GIR_Coverage, 2617,
     /* 2022873 */     GIR_EraseRootFromParent_Done,
     /* 2022874 */   // Label 26962: @2022874
     /* 2022874 */   GIM_Try, /*On fail goto*//*Label 26963*/ GIMT_Encode4(2022965), // Rule ID 2660 //
     /* 2022879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2022882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2022887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2022890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2022893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2022896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2022899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2022905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2022909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2022921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2022925 */     // MIs[0] round
     /* 2022925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2022928 */     // MIs[0] policy
     /* 2022928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2022931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2022938 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2022938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2022941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2022943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2022945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2022947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2022949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2022951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2022953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2022958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2022961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2022963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2022964 */     // GIR_Coverage, 2660,
     /* 2022964 */     GIR_EraseRootFromParent_Done,
     /* 2022965 */   // Label 26963: @2022965
     /* 2022965 */   GIM_Try, /*On fail goto*//*Label 26964*/ GIMT_Encode4(2023056), // Rule ID 2661 //
     /* 2022970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2022973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2022978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2022981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2022984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2022987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2022990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2022993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2022996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023016 */     // MIs[0] round
     /* 2023016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023019 */     // MIs[0] policy
     /* 2023019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023029 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF4_E16_MASK),
     /* 2023032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023055 */     // GIR_Coverage, 2661,
     /* 2023055 */     GIR_EraseRootFromParent_Done,
     /* 2023056 */   // Label 26964: @2023056
     /* 2023056 */   GIM_Try, /*On fail goto*//*Label 26965*/ GIMT_Encode4(2023147), // Rule ID 2668 //
     /* 2023061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2023064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2023069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023107 */     // MIs[0] round
     /* 2023107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023110 */     // MIs[0] policy
     /* 2023110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023120 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2023123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2023127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023146 */     // GIR_Coverage, 2668,
     /* 2023146 */     GIR_EraseRootFromParent_Done,
     /* 2023147 */   // Label 26965: @2023147
     /* 2023147 */   GIM_Try, /*On fail goto*//*Label 26966*/ GIMT_Encode4(2023238), // Rule ID 2669 //
     /* 2023152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2023155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2023160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023198 */     // MIs[0] round
     /* 2023198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023201 */     // MIs[0] policy
     /* 2023201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023211 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF4_E16_MASK),
     /* 2023214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2023218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023237 */     // GIR_Coverage, 2669,
     /* 2023237 */     GIR_EraseRootFromParent_Done,
     /* 2023238 */   // Label 26966: @2023238
     /* 2023238 */   GIM_Try, /*On fail goto*//*Label 26967*/ GIMT_Encode4(2023329), // Rule ID 14818 //
     /* 2023243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2023254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2023257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2023260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2023263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023289 */     // MIs[0] round
     /* 2023289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023292 */     // MIs[0] policy
     /* 2023292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023302 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2023305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023328 */     // GIR_Coverage, 14818,
     /* 2023328 */     GIR_EraseRootFromParent_Done,
     /* 2023329 */   // Label 26967: @2023329
     /* 2023329 */   GIM_Try, /*On fail goto*//*Label 26968*/ GIMT_Encode4(2023420), // Rule ID 14819 //
     /* 2023334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2023345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2023348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2023351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2023354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023380 */     // MIs[0] round
     /* 2023380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023383 */     // MIs[0] policy
     /* 2023383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023393 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2023396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023419 */     // GIR_Coverage, 14819,
     /* 2023419 */     GIR_EraseRootFromParent_Done,
     /* 2023420 */   // Label 26968: @2023420
     /* 2023420 */   GIM_Try, /*On fail goto*//*Label 26969*/ GIMT_Encode4(2023511), // Rule ID 14822 //
     /* 2023425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2023436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2023439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2023442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2023445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023471 */     // MIs[0] round
     /* 2023471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023474 */     // MIs[0] policy
     /* 2023474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023484 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2023487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023510 */     // GIR_Coverage, 14822,
     /* 2023510 */     GIR_EraseRootFromParent_Done,
     /* 2023511 */   // Label 26969: @2023511
     /* 2023511 */   GIM_Try, /*On fail goto*//*Label 26970*/ GIMT_Encode4(2023602), // Rule ID 14823 //
     /* 2023516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2023527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2023530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2023533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2023536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2023539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023562 */     // MIs[0] round
     /* 2023562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023565 */     // MIs[0] policy
     /* 2023565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023575 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2023578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2023598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023601 */     // GIR_Coverage, 14823,
     /* 2023601 */     GIR_EraseRootFromParent_Done,
     /* 2023602 */   // Label 26970: @2023602
     /* 2023602 */   GIM_Try, /*On fail goto*//*Label 26971*/ GIMT_Encode4(2023693), // Rule ID 14826 //
     /* 2023607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023653 */     // MIs[0] round
     /* 2023653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023656 */     // MIs[0] policy
     /* 2023656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023666 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2023669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023692 */     // GIR_Coverage, 14826,
     /* 2023692 */     GIR_EraseRootFromParent_Done,
     /* 2023693 */   // Label 26971: @2023693
     /* 2023693 */   GIM_Try, /*On fail goto*//*Label 26972*/ GIMT_Encode4(2023784), // Rule ID 14827 //
     /* 2023698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2023709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2023712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2023715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2023718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023744 */     // MIs[0] round
     /* 2023744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023747 */     // MIs[0] policy
     /* 2023747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023757 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF4_MASK),
     /* 2023760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023783 */     // GIR_Coverage, 14827,
     /* 2023783 */     GIR_EraseRootFromParent_Done,
     /* 2023784 */   // Label 26972: @2023784
     /* 2023784 */   GIM_Try, /*On fail goto*//*Label 26973*/ GIMT_Encode4(2023875), // Rule ID 14830 //
     /* 2023789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2023800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2023803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2023806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2023809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023835 */     // MIs[0] round
     /* 2023835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023838 */     // MIs[0] policy
     /* 2023838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023848 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2023848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2023851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023874 */     // GIR_Coverage, 14830,
     /* 2023874 */     GIR_EraseRootFromParent_Done,
     /* 2023875 */   // Label 26973: @2023875
     /* 2023875 */   GIM_Try, /*On fail goto*//*Label 26974*/ GIMT_Encode4(2023966), // Rule ID 14831 //
     /* 2023880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2023883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2023891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2023894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2023897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2023900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2023903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2023906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2023910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2023922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2023926 */     // MIs[0] round
     /* 2023926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2023929 */     // MIs[0] policy
     /* 2023929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2023932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2023939 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2023939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2023942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2023944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2023946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2023948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2023950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2023952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2023954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2023959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2023962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2023964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2023965 */     // GIR_Coverage, 14831,
     /* 2023965 */     GIR_EraseRootFromParent_Done,
     /* 2023966 */   // Label 26974: @2023966
     /* 2023966 */   GIM_Try, /*On fail goto*//*Label 26975*/ GIMT_Encode4(2024057), // Rule ID 14834 //
     /* 2023971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2023974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2023979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2023982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2023985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2023988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2023991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2023994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2023997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024017 */     // MIs[0] round
     /* 2024017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024020 */     // MIs[0] policy
     /* 2024020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024030 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2024033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024056 */     // GIR_Coverage, 14834,
     /* 2024056 */     GIR_EraseRootFromParent_Done,
     /* 2024057 */   // Label 26975: @2024057
     /* 2024057 */   GIM_Try, /*On fail goto*//*Label 26976*/ GIMT_Encode4(2024148), // Rule ID 14835 //
     /* 2024062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2024073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2024076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2024079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2024082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024108 */     // MIs[0] round
     /* 2024108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024111 */     // MIs[0] policy
     /* 2024111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024121 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_MF2_MASK),
     /* 2024124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024147 */     // GIR_Coverage, 14835,
     /* 2024147 */     GIR_EraseRootFromParent_Done,
     /* 2024148 */   // Label 26976: @2024148
     /* 2024148 */   GIM_Try, /*On fail goto*//*Label 26977*/ GIMT_Encode4(2024239), // Rule ID 14838 //
     /* 2024153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2024164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2024167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2024170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2024173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024199 */     // MIs[0] round
     /* 2024199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024202 */     // MIs[0] policy
     /* 2024202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024212 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024238 */     // GIR_Coverage, 14838,
     /* 2024238 */     GIR_EraseRootFromParent_Done,
     /* 2024239 */   // Label 26977: @2024239
     /* 2024239 */   GIM_Try, /*On fail goto*//*Label 26978*/ GIMT_Encode4(2024330), // Rule ID 14839 //
     /* 2024244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2024255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2024258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2024261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2024264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2024267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024290 */     // MIs[0] round
     /* 2024290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024293 */     // MIs[0] policy
     /* 2024293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024303 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024329 */     // GIR_Coverage, 14839,
     /* 2024329 */     GIR_EraseRootFromParent_Done,
     /* 2024330 */   // Label 26978: @2024330
     /* 2024330 */   GIM_Try, /*On fail goto*//*Label 26979*/ GIMT_Encode4(2024421), // Rule ID 14842 //
     /* 2024335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2024346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2024349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2024352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2024355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024381 */     // MIs[0] round
     /* 2024381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024384 */     // MIs[0] policy
     /* 2024384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024394 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024420 */     // GIR_Coverage, 14842,
     /* 2024420 */     GIR_EraseRootFromParent_Done,
     /* 2024421 */   // Label 26979: @2024421
     /* 2024421 */   GIM_Try, /*On fail goto*//*Label 26980*/ GIMT_Encode4(2024512), // Rule ID 14843 //
     /* 2024426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2024437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2024440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2024443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2024446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2024449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024472 */     // MIs[0] round
     /* 2024472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024475 */     // MIs[0] policy
     /* 2024475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024485 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2024508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024511 */     // GIR_Coverage, 14843,
     /* 2024511 */     GIR_EraseRootFromParent_Done,
     /* 2024512 */   // Label 26980: @2024512
     /* 2024512 */   GIM_Try, /*On fail goto*//*Label 26981*/ GIMT_Encode4(2024603), // Rule ID 14846 //
     /* 2024517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2024534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2024537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024563 */     // MIs[0] round
     /* 2024563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024566 */     // MIs[0] policy
     /* 2024566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024576 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024602 */     // GIR_Coverage, 14846,
     /* 2024602 */     GIR_EraseRootFromParent_Done,
     /* 2024603 */   // Label 26981: @2024603
     /* 2024603 */   GIM_Try, /*On fail goto*//*Label 26982*/ GIMT_Encode4(2024694), // Rule ID 14847 //
     /* 2024608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2024619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2024622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2024625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2024628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2024631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024654 */     // MIs[0] round
     /* 2024654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024657 */     // MIs[0] policy
     /* 2024657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024667 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2024690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024693 */     // GIR_Coverage, 14847,
     /* 2024693 */     GIR_EraseRootFromParent_Done,
     /* 2024694 */   // Label 26982: @2024694
     /* 2024694 */   GIM_Try, /*On fail goto*//*Label 26983*/ GIMT_Encode4(2024785), // Rule ID 14850 //
     /* 2024699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2024702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2024716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2024719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024745 */     // MIs[0] round
     /* 2024745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024748 */     // MIs[0] policy
     /* 2024748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024758 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024784 */     // GIR_Coverage, 14850,
     /* 2024784 */     GIR_EraseRootFromParent_Done,
     /* 2024785 */   // Label 26983: @2024785
     /* 2024785 */   GIM_Try, /*On fail goto*//*Label 26984*/ GIMT_Encode4(2024876), // Rule ID 14851 //
     /* 2024790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2024793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2024801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2024804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2024807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2024810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2024813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2024820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2024832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024836 */     // MIs[0] round
     /* 2024836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024839 */     // MIs[0] policy
     /* 2024839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024849 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2024849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M1_MASK),
     /* 2024852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2024872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024875 */     // GIR_Coverage, 14851,
     /* 2024875 */     GIR_EraseRootFromParent_Done,
     /* 2024876 */   // Label 26984: @2024876
     /* 2024876 */   GIM_Try, /*On fail goto*//*Label 26985*/ GIMT_Encode4(2024967), // Rule ID 14854 //
     /* 2024881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2024884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2024892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2024895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2024898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2024901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2024907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2024911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2024923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2024927 */     // MIs[0] round
     /* 2024927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2024930 */     // MIs[0] policy
     /* 2024930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2024933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2024940 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2024940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2024943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2024945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2024947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2024949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2024951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2024953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2024955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2024960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2024963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2024965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2024966 */     // GIR_Coverage, 14854,
     /* 2024966 */     GIR_EraseRootFromParent_Done,
     /* 2024967 */   // Label 26985: @2024967
     /* 2024967 */   GIM_Try, /*On fail goto*//*Label 26986*/ GIMT_Encode4(2025058), // Rule ID 14855 //
     /* 2024972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2024975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2024980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2024983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2024986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2024989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2024992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2024995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2024998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025018 */     // MIs[0] round
     /* 2025018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025021 */     // MIs[0] policy
     /* 2025021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2025034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025057 */     // GIR_Coverage, 14855,
     /* 2025057 */     GIR_EraseRootFromParent_Done,
     /* 2025058 */   // Label 26986: @2025058
     /* 2025058 */   GIM_Try, /*On fail goto*//*Label 26987*/ GIMT_Encode4(2025149), // Rule ID 14858 //
     /* 2025063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2025080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2025083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025109 */     // MIs[0] round
     /* 2025109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025112 */     // MIs[0] policy
     /* 2025112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025122 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2025125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025148 */     // GIR_Coverage, 14858,
     /* 2025148 */     GIR_EraseRootFromParent_Done,
     /* 2025149 */   // Label 26987: @2025149
     /* 2025149 */   GIM_Try, /*On fail goto*//*Label 26988*/ GIMT_Encode4(2025240), // Rule ID 14859 //
     /* 2025154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2025165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2025168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2025171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2025174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025200 */     // MIs[0] round
     /* 2025200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025203 */     // MIs[0] policy
     /* 2025203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025213 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2025216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025239 */     // GIR_Coverage, 14859,
     /* 2025239 */     GIR_EraseRootFromParent_Done,
     /* 2025240 */   // Label 26988: @2025240
     /* 2025240 */   GIM_Try, /*On fail goto*//*Label 26989*/ GIMT_Encode4(2025331), // Rule ID 14862 //
     /* 2025245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2025256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2025259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2025262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2025265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2025268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025291 */     // MIs[0] round
     /* 2025291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025294 */     // MIs[0] policy
     /* 2025294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025304 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2025307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025330 */     // GIR_Coverage, 14862,
     /* 2025330 */     GIR_EraseRootFromParent_Done,
     /* 2025331 */   // Label 26989: @2025331
     /* 2025331 */   GIM_Try, /*On fail goto*//*Label 26990*/ GIMT_Encode4(2025422), // Rule ID 14863 //
     /* 2025336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2025347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2025350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2025353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2025356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2025359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025382 */     // MIs[0] round
     /* 2025382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025385 */     // MIs[0] policy
     /* 2025385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025395 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2025398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2025418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025421 */     // GIR_Coverage, 14863,
     /* 2025421 */     GIR_EraseRootFromParent_Done,
     /* 2025422 */   // Label 26990: @2025422
     /* 2025422 */   GIM_Try, /*On fail goto*//*Label 26991*/ GIMT_Encode4(2025513), // Rule ID 14866 //
     /* 2025427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2025438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2025441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2025447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025473 */     // MIs[0] round
     /* 2025473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025476 */     // MIs[0] policy
     /* 2025476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025486 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2025489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025512 */     // GIR_Coverage, 14866,
     /* 2025512 */     GIR_EraseRootFromParent_Done,
     /* 2025513 */   // Label 26991: @2025513
     /* 2025513 */   GIM_Try, /*On fail goto*//*Label 26992*/ GIMT_Encode4(2025604), // Rule ID 14867 //
     /* 2025518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2025529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2025532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2025535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2025538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2025541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2025548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2025560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025564 */     // MIs[0] round
     /* 2025564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025567 */     // MIs[0] policy
     /* 2025567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025577 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2025580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025603 */     // GIR_Coverage, 14867,
     /* 2025603 */     GIR_EraseRootFromParent_Done,
     /* 2025604 */   // Label 26992: @2025604
     /* 2025604 */   GIM_Try, /*On fail goto*//*Label 26993*/ GIMT_Encode4(2025695), // Rule ID 14870 //
     /* 2025609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2025620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2025623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2025629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025655 */     // MIs[0] round
     /* 2025655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025658 */     // MIs[0] policy
     /* 2025658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025668 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2025671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025694 */     // GIR_Coverage, 14870,
     /* 2025694 */     GIR_EraseRootFromParent_Done,
     /* 2025695 */   // Label 26993: @2025695
     /* 2025695 */   GIM_Try, /*On fail goto*//*Label 26994*/ GIMT_Encode4(2025786), // Rule ID 14871 //
     /* 2025700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2025711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2025714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2025717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2025720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2025723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2025730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2025742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025746 */     // MIs[0] round
     /* 2025746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025749 */     // MIs[0] policy
     /* 2025749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025759 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2025762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025785 */     // GIR_Coverage, 14871,
     /* 2025785 */     GIR_EraseRootFromParent_Done,
     /* 2025786 */   // Label 26994: @2025786
     /* 2025786 */   GIM_Try, /*On fail goto*//*Label 26995*/ GIMT_Encode4(2025877), // Rule ID 14874 //
     /* 2025791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2025802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2025805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2025811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025837 */     // MIs[0] round
     /* 2025837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025840 */     // MIs[0] policy
     /* 2025840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025850 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2025850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2025853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025876 */     // GIR_Coverage, 14874,
     /* 2025876 */     GIR_EraseRootFromParent_Done,
     /* 2025877 */   // Label 26995: @2025877
     /* 2025877 */   GIM_Try, /*On fail goto*//*Label 26996*/ GIMT_Encode4(2025968), // Rule ID 14875 //
     /* 2025882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2025885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2025893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2025896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2025899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2025902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2025905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2025908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2025912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2025924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2025928 */     // MIs[0] round
     /* 2025928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2025931 */     // MIs[0] policy
     /* 2025931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2025934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2025941 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2025941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2025944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2025946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2025948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2025950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2025952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2025954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2025956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2025961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2025964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2025966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2025967 */     // GIR_Coverage, 14875,
     /* 2025967 */     GIR_EraseRootFromParent_Done,
     /* 2025968 */   // Label 26996: @2025968
     /* 2025968 */   GIM_Try, /*On fail goto*//*Label 26997*/ GIMT_Encode4(2026059), // Rule ID 14878 //
     /* 2025973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2025976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2025981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2025984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2025987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2025990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2025993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2025996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2025999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026019 */     // MIs[0] round
     /* 2026019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026022 */     // MIs[0] policy
     /* 2026022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026032 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2026035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026058 */     // GIR_Coverage, 14878,
     /* 2026058 */     GIR_EraseRootFromParent_Done,
     /* 2026059 */   // Label 26997: @2026059
     /* 2026059 */   GIM_Try, /*On fail goto*//*Label 26998*/ GIMT_Encode4(2026150), // Rule ID 14879 //
     /* 2026064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2026075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2026078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2026081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2026084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026110 */     // MIs[0] round
     /* 2026110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026113 */     // MIs[0] policy
     /* 2026113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026123 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2026126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026149 */     // GIR_Coverage, 14879,
     /* 2026149 */     GIR_EraseRootFromParent_Done,
     /* 2026150 */   // Label 26998: @2026150
     /* 2026150 */   GIM_Try, /*On fail goto*//*Label 26999*/ GIMT_Encode4(2026241), // Rule ID 14882 //
     /* 2026155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2026166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2026169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2026175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026201 */     // MIs[0] round
     /* 2026201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026204 */     // MIs[0] policy
     /* 2026204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026214 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2026217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026240 */     // GIR_Coverage, 14882,
     /* 2026240 */     GIR_EraseRootFromParent_Done,
     /* 2026241 */   // Label 26999: @2026241
     /* 2026241 */   GIM_Try, /*On fail goto*//*Label 27000*/ GIMT_Encode4(2026332), // Rule ID 14883 //
     /* 2026246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2026257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2026260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2026263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2026266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026292 */     // MIs[0] round
     /* 2026292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026295 */     // MIs[0] policy
     /* 2026295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026305 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2026308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026331 */     // GIR_Coverage, 14883,
     /* 2026331 */     GIR_EraseRootFromParent_Done,
     /* 2026332 */   // Label 27000: @2026332
     /* 2026332 */   GIM_Try, /*On fail goto*//*Label 27001*/ GIMT_Encode4(2026423), // Rule ID 14886 //
     /* 2026337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2026340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2026348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2026351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2026357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026383 */     // MIs[0] round
     /* 2026383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026386 */     // MIs[0] policy
     /* 2026386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026396 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2026399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026422 */     // GIR_Coverage, 14886,
     /* 2026422 */     GIR_EraseRootFromParent_Done,
     /* 2026423 */   // Label 27001: @2026423
     /* 2026423 */   GIM_Try, /*On fail goto*//*Label 27002*/ GIMT_Encode4(2026514), // Rule ID 14887 //
     /* 2026428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2026431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2026439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2026442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2026445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2026448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2026451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026474 */     // MIs[0] round
     /* 2026474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026477 */     // MIs[0] policy
     /* 2026477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026487 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2026490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2026510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026513 */     // GIR_Coverage, 14887,
     /* 2026513 */     GIR_EraseRootFromParent_Done,
     /* 2026514 */   // Label 27002: @2026514
     /* 2026514 */   GIM_Try, /*On fail goto*//*Label 27003*/ GIMT_Encode4(2026605), // Rule ID 14890 //
     /* 2026519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2026522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2026530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2026533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2026536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2026539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026565 */     // MIs[0] round
     /* 2026565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026568 */     // MIs[0] policy
     /* 2026568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2026581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026604 */     // GIR_Coverage, 14890,
     /* 2026604 */     GIR_EraseRootFromParent_Done,
     /* 2026605 */   // Label 27003: @2026605
     /* 2026605 */   GIM_Try, /*On fail goto*//*Label 27004*/ GIMT_Encode4(2026696), // Rule ID 14891 //
     /* 2026610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2026613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2026621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2026624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2026627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2026630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2026633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2026640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2026652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026656 */     // MIs[0] round
     /* 2026656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026659 */     // MIs[0] policy
     /* 2026659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M2_MASK),
     /* 2026672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026695 */     // GIR_Coverage, 14891,
     /* 2026695 */     GIR_EraseRootFromParent_Done,
     /* 2026696 */   // Label 27004: @2026696
     /* 2026696 */   GIM_Try, /*On fail goto*//*Label 27005*/ GIMT_Encode4(2026787), // Rule ID 14894 //
     /* 2026701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2026704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2026712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2026715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2026718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2026721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026747 */     // MIs[0] round
     /* 2026747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026750 */     // MIs[0] policy
     /* 2026750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026760 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2026763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026786 */     // GIR_Coverage, 14894,
     /* 2026786 */     GIR_EraseRootFromParent_Done,
     /* 2026787 */   // Label 27005: @2026787
     /* 2026787 */   GIM_Try, /*On fail goto*//*Label 27006*/ GIMT_Encode4(2026878), // Rule ID 14895 //
     /* 2026792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2026795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2026803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2026806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2026809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2026812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2026815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2026818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2026822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2026834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026838 */     // MIs[0] round
     /* 2026838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026841 */     // MIs[0] policy
     /* 2026841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026851 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2026851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M4_MASK),
     /* 2026854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026877 */     // GIR_Coverage, 14895,
     /* 2026877 */     GIR_EraseRootFromParent_Done,
     /* 2026878 */   // Label 27006: @2026878
     /* 2026878 */   GIM_Try, /*On fail goto*//*Label 27007*/ GIMT_Encode4(2026969), // Rule ID 14898 //
     /* 2026883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2026886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2026894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2026897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2026900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2026903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2026909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2026913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2026925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2026929 */     // MIs[0] round
     /* 2026929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2026932 */     // MIs[0] policy
     /* 2026932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2026935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2026942 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2026942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2026945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2026947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2026949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2026951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2026953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2026955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2026957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2026962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2026965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2026967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2026968 */     // GIR_Coverage, 14898,
     /* 2026968 */     GIR_EraseRootFromParent_Done,
     /* 2026969 */   // Label 27007: @2026969
     /* 2026969 */   GIM_Try, /*On fail goto*//*Label 27008*/ GIMT_Encode4(2027060), // Rule ID 14899 //
     /* 2026974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2026977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2026982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2026985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2026988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2026991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2026994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2026997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2027004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2027016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027020 */     // MIs[0] round
     /* 2027020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027023 */     // MIs[0] policy
     /* 2027023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027033 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VV_M8_MASK),
     /* 2027036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2027056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027059 */     // GIR_Coverage, 14899,
     /* 2027059 */     GIR_EraseRootFromParent_Done,
     /* 2027060 */   // Label 27008: @2027060
     /* 2027060 */   GIM_Try, /*On fail goto*//*Label 27009*/ GIMT_Encode4(2027151), // Rule ID 14902 //
     /* 2027065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2027082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027111 */     // MIs[0] round
     /* 2027111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027114 */     // MIs[0] policy
     /* 2027114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027124 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2027127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027150 */     // GIR_Coverage, 14902,
     /* 2027150 */     GIR_EraseRootFromParent_Done,
     /* 2027151 */   // Label 27009: @2027151
     /* 2027151 */   GIM_Try, /*On fail goto*//*Label 27010*/ GIMT_Encode4(2027242), // Rule ID 14903 //
     /* 2027156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2027167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2027170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2027173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027202 */     // MIs[0] round
     /* 2027202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027205 */     // MIs[0] policy
     /* 2027205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027215 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF8_MASK),
     /* 2027218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027241 */     // GIR_Coverage, 14903,
     /* 2027241 */     GIR_EraseRootFromParent_Done,
     /* 2027242 */   // Label 27010: @2027242
     /* 2027242 */   GIM_Try, /*On fail goto*//*Label 27011*/ GIMT_Encode4(2027333), // Rule ID 14906 //
     /* 2027247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2027264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027293 */     // MIs[0] round
     /* 2027293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027296 */     // MIs[0] policy
     /* 2027296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027306 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2027309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027332 */     // GIR_Coverage, 14906,
     /* 2027332 */     GIR_EraseRootFromParent_Done,
     /* 2027333 */   // Label 27011: @2027333
     /* 2027333 */   GIM_Try, /*On fail goto*//*Label 27012*/ GIMT_Encode4(2027424), // Rule ID 14907 //
     /* 2027338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2027349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2027352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2027355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027384 */     // MIs[0] round
     /* 2027384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027387 */     // MIs[0] policy
     /* 2027387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027397 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2027400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027423 */     // GIR_Coverage, 14907,
     /* 2027423 */     GIR_EraseRootFromParent_Done,
     /* 2027424 */   // Label 27012: @2027424
     /* 2027424 */   GIM_Try, /*On fail goto*//*Label 27013*/ GIMT_Encode4(2027515), // Rule ID 14910 //
     /* 2027429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2027440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2027443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2027446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027475 */     // MIs[0] round
     /* 2027475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027478 */     // MIs[0] policy
     /* 2027478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027488 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2027491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027514 */     // GIR_Coverage, 14910,
     /* 2027514 */     GIR_EraseRootFromParent_Done,
     /* 2027515 */   // Label 27013: @2027515
     /* 2027515 */   GIM_Try, /*On fail goto*//*Label 27014*/ GIMT_Encode4(2027606), // Rule ID 14911 //
     /* 2027520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2027531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2027534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2027537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2027543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027566 */     // MIs[0] round
     /* 2027566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027569 */     // MIs[0] policy
     /* 2027569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027579 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2027582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2027602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027605 */     // GIR_Coverage, 14911,
     /* 2027605 */     GIR_EraseRootFromParent_Done,
     /* 2027606 */   // Label 27014: @2027606
     /* 2027606 */   GIM_Try, /*On fail goto*//*Label 27015*/ GIMT_Encode4(2027697), // Rule ID 14914 //
     /* 2027611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2027622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2027625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027657 */     // MIs[0] round
     /* 2027657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027660 */     // MIs[0] policy
     /* 2027660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027670 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2027673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027696 */     // GIR_Coverage, 14914,
     /* 2027696 */     GIR_EraseRootFromParent_Done,
     /* 2027697 */   // Label 27015: @2027697
     /* 2027697 */   GIM_Try, /*On fail goto*//*Label 27016*/ GIMT_Encode4(2027788), // Rule ID 14915 //
     /* 2027702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2027713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2027716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2027719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027748 */     // MIs[0] round
     /* 2027748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027751 */     // MIs[0] policy
     /* 2027751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027761 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF4_MASK),
     /* 2027764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027787 */     // GIR_Coverage, 14915,
     /* 2027787 */     GIR_EraseRootFromParent_Done,
     /* 2027788 */   // Label 27016: @2027788
     /* 2027788 */   GIM_Try, /*On fail goto*//*Label 27017*/ GIMT_Encode4(2027879), // Rule ID 14918 //
     /* 2027793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2027804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2027807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2027819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027839 */     // MIs[0] round
     /* 2027839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027842 */     // MIs[0] policy
     /* 2027842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027852 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2027852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2027855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027878 */     // GIR_Coverage, 14918,
     /* 2027878 */     GIR_EraseRootFromParent_Done,
     /* 2027879 */   // Label 27017: @2027879
     /* 2027879 */   GIM_Try, /*On fail goto*//*Label 27018*/ GIMT_Encode4(2027970), // Rule ID 14919 //
     /* 2027884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2027887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2027895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2027898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2027901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2027904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2027907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2027910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2027914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2027922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2027926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2027930 */     // MIs[0] round
     /* 2027930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2027933 */     // MIs[0] policy
     /* 2027933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2027936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2027943 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2027943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2027946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2027948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2027950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2027952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2027954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2027956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2027958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2027963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2027966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2027968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2027969 */     // GIR_Coverage, 14919,
     /* 2027969 */     GIR_EraseRootFromParent_Done,
     /* 2027970 */   // Label 27018: @2027970
     /* 2027970 */   GIM_Try, /*On fail goto*//*Label 27019*/ GIMT_Encode4(2028061), // Rule ID 14922 //
     /* 2027975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2027978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2027983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2027986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2027989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2027992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2027995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2027998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028021 */     // MIs[0] round
     /* 2028021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028024 */     // MIs[0] policy
     /* 2028024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028034 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2028037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028060 */     // GIR_Coverage, 14922,
     /* 2028060 */     GIR_EraseRootFromParent_Done,
     /* 2028061 */   // Label 27019: @2028061
     /* 2028061 */   GIM_Try, /*On fail goto*//*Label 27020*/ GIMT_Encode4(2028152), // Rule ID 14923 //
     /* 2028066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2028077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2028080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2028083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028112 */     // MIs[0] round
     /* 2028112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028115 */     // MIs[0] policy
     /* 2028115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028125 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_MF2_MASK),
     /* 2028128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028151 */     // GIR_Coverage, 14923,
     /* 2028151 */     GIR_EraseRootFromParent_Done,
     /* 2028152 */   // Label 27020: @2028152
     /* 2028152 */   GIM_Try, /*On fail goto*//*Label 27021*/ GIMT_Encode4(2028243), // Rule ID 14926 //
     /* 2028157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2028174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028203 */     // MIs[0] round
     /* 2028203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028206 */     // MIs[0] policy
     /* 2028206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028216 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028242 */     // GIR_Coverage, 14926,
     /* 2028242 */     GIR_EraseRootFromParent_Done,
     /* 2028243 */   // Label 27021: @2028243
     /* 2028243 */   GIM_Try, /*On fail goto*//*Label 27022*/ GIMT_Encode4(2028334), // Rule ID 14927 //
     /* 2028248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2028259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2028262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2028265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2028271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028294 */     // MIs[0] round
     /* 2028294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028297 */     // MIs[0] policy
     /* 2028297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028307 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11072:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028333 */     // GIR_Coverage, 14927,
     /* 2028333 */     GIR_EraseRootFromParent_Done,
     /* 2028334 */   // Label 27022: @2028334
     /* 2028334 */   GIM_Try, /*On fail goto*//*Label 27023*/ GIMT_Encode4(2028425), // Rule ID 14930 //
     /* 2028339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2028350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2028353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028385 */     // MIs[0] round
     /* 2028385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028388 */     // MIs[0] policy
     /* 2028388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028398 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028424 */     // GIR_Coverage, 14930,
     /* 2028424 */     GIR_EraseRootFromParent_Done,
     /* 2028425 */   // Label 27023: @2028425
     /* 2028425 */   GIM_Try, /*On fail goto*//*Label 27024*/ GIMT_Encode4(2028516), // Rule ID 14931 //
     /* 2028430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2028441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2028444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2028447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2028453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028476 */     // MIs[0] round
     /* 2028476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028479 */     // MIs[0] policy
     /* 2028479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028489 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11072:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2028512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028515 */     // GIR_Coverage, 14931,
     /* 2028515 */     GIR_EraseRootFromParent_Done,
     /* 2028516 */   // Label 27024: @2028516
     /* 2028516 */   GIM_Try, /*On fail goto*//*Label 27025*/ GIMT_Encode4(2028607), // Rule ID 14934 //
     /* 2028521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2028532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2028535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2028538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028567 */     // MIs[0] round
     /* 2028567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028570 */     // MIs[0] policy
     /* 2028570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028580 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028606 */     // GIR_Coverage, 14934,
     /* 2028606 */     GIR_EraseRootFromParent_Done,
     /* 2028607 */   // Label 27025: @2028607
     /* 2028607 */   GIM_Try, /*On fail goto*//*Label 27026*/ GIMT_Encode4(2028698), // Rule ID 14935 //
     /* 2028612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2028623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2028626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2028629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2028635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028658 */     // MIs[0] round
     /* 2028658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028661 */     // MIs[0] policy
     /* 2028661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028671 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11072:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2028694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028697 */     // GIR_Coverage, 14935,
     /* 2028697 */     GIR_EraseRootFromParent_Done,
     /* 2028698 */   // Label 27026: @2028698
     /* 2028698 */   GIM_Try, /*On fail goto*//*Label 27027*/ GIMT_Encode4(2028789), // Rule ID 14938 //
     /* 2028703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2028706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2028714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2028717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2028720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028749 */     // MIs[0] round
     /* 2028749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028752 */     // MIs[0] policy
     /* 2028752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028762 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028788 */     // GIR_Coverage, 14938,
     /* 2028788 */     GIR_EraseRootFromParent_Done,
     /* 2028789 */   // Label 27027: @2028789
     /* 2028789 */   GIM_Try, /*On fail goto*//*Label 27028*/ GIMT_Encode4(2028880), // Rule ID 14939 //
     /* 2028794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2028797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2028805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2028808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2028811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2028817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2028820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2028824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2028832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028840 */     // MIs[0] round
     /* 2028840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028843 */     // MIs[0] policy
     /* 2028843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028853 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11072:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2028853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M1_MASK),
     /* 2028856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2028876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028879 */     // GIR_Coverage, 14939,
     /* 2028879 */     GIR_EraseRootFromParent_Done,
     /* 2028880 */   // Label 27028: @2028880
     /* 2028880 */   GIM_Try, /*On fail goto*//*Label 27029*/ GIMT_Encode4(2028971), // Rule ID 14942 //
     /* 2028885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2028888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2028902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2028905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2028911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2028915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2028923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2028927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2028931 */     // MIs[0] round
     /* 2028931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2028934 */     // MIs[0] policy
     /* 2028934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2028937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2028944 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2028944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2028947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2028949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2028951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2028953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2028955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2028957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2028959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2028964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2028967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2028969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2028970 */     // GIR_Coverage, 14942,
     /* 2028970 */     GIR_EraseRootFromParent_Done,
     /* 2028971 */   // Label 27029: @2028971
     /* 2028971 */   GIM_Try, /*On fail goto*//*Label 27030*/ GIMT_Encode4(2029062), // Rule ID 14943 //
     /* 2028976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2028979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2028984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2028987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2028990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2028993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2028996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2028999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029022 */     // MIs[0] round
     /* 2029022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029025 */     // MIs[0] policy
     /* 2029025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2029038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029061 */     // GIR_Coverage, 14943,
     /* 2029061 */     GIR_EraseRootFromParent_Done,
     /* 2029062 */   // Label 27030: @2029062
     /* 2029062 */   GIM_Try, /*On fail goto*//*Label 27031*/ GIMT_Encode4(2029153), // Rule ID 14946 //
     /* 2029067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2029084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029113 */     // MIs[0] round
     /* 2029113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029116 */     // MIs[0] policy
     /* 2029116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2029129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029152 */     // GIR_Coverage, 14946,
     /* 2029152 */     GIR_EraseRootFromParent_Done,
     /* 2029153 */   // Label 27031: @2029153
     /* 2029153 */   GIM_Try, /*On fail goto*//*Label 27032*/ GIMT_Encode4(2029244), // Rule ID 14947 //
     /* 2029158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2029169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2029172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2029175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029204 */     // MIs[0] round
     /* 2029204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029207 */     // MIs[0] policy
     /* 2029207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029217 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2029220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029243 */     // GIR_Coverage, 14947,
     /* 2029243 */     GIR_EraseRootFromParent_Done,
     /* 2029244 */   // Label 27032: @2029244
     /* 2029244 */   GIM_Try, /*On fail goto*//*Label 27033*/ GIMT_Encode4(2029335), // Rule ID 14950 //
     /* 2029249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2029260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2029263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2029266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2029272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029295 */     // MIs[0] round
     /* 2029295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029298 */     // MIs[0] policy
     /* 2029298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029308 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2029311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029334 */     // GIR_Coverage, 14950,
     /* 2029334 */     GIR_EraseRootFromParent_Done,
     /* 2029335 */   // Label 27033: @2029335
     /* 2029335 */   GIM_Try, /*On fail goto*//*Label 27034*/ GIMT_Encode4(2029426), // Rule ID 14951 //
     /* 2029340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2029351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2029354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2029357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2029363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029386 */     // MIs[0] round
     /* 2029386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029389 */     // MIs[0] policy
     /* 2029389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029399 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2029402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2029422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029425 */     // GIR_Coverage, 14951,
     /* 2029425 */     GIR_EraseRootFromParent_Done,
     /* 2029426 */   // Label 27034: @2029426
     /* 2029426 */   GIM_Try, /*On fail goto*//*Label 27035*/ GIMT_Encode4(2029517), // Rule ID 14954 //
     /* 2029431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029477 */     // MIs[0] round
     /* 2029477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029480 */     // MIs[0] policy
     /* 2029480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029490 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2029493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029516 */     // GIR_Coverage, 14954,
     /* 2029516 */     GIR_EraseRootFromParent_Done,
     /* 2029517 */   // Label 27035: @2029517
     /* 2029517 */   GIM_Try, /*On fail goto*//*Label 27036*/ GIMT_Encode4(2029608), // Rule ID 14955 //
     /* 2029522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2029533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2029536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2029539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2029545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2029552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2029560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029568 */     // MIs[0] round
     /* 2029568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029571 */     // MIs[0] policy
     /* 2029571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2029584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029607 */     // GIR_Coverage, 14955,
     /* 2029607 */     GIR_EraseRootFromParent_Done,
     /* 2029608 */   // Label 27036: @2029608
     /* 2029608 */   GIM_Try, /*On fail goto*//*Label 27037*/ GIMT_Encode4(2029699), // Rule ID 14958 //
     /* 2029613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029659 */     // MIs[0] round
     /* 2029659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029662 */     // MIs[0] policy
     /* 2029662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029672 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2029675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029698 */     // GIR_Coverage, 14958,
     /* 2029698 */     GIR_EraseRootFromParent_Done,
     /* 2029699 */   // Label 27037: @2029699
     /* 2029699 */   GIM_Try, /*On fail goto*//*Label 27038*/ GIMT_Encode4(2029790), // Rule ID 14959 //
     /* 2029704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2029715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2029718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2029721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2029727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2029734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2029742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029750 */     // MIs[0] round
     /* 2029750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029753 */     // MIs[0] policy
     /* 2029753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029763 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2029766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029789 */     // GIR_Coverage, 14959,
     /* 2029789 */     GIR_EraseRootFromParent_Done,
     /* 2029790 */   // Label 27038: @2029790
     /* 2029790 */   GIM_Try, /*On fail goto*//*Label 27039*/ GIMT_Encode4(2029881), // Rule ID 14962 //
     /* 2029795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2029806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2029809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2029821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029841 */     // MIs[0] round
     /* 2029841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029844 */     // MIs[0] policy
     /* 2029844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029854 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2029854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2029857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029880 */     // GIR_Coverage, 14962,
     /* 2029880 */     GIR_EraseRootFromParent_Done,
     /* 2029881 */   // Label 27039: @2029881
     /* 2029881 */   GIM_Try, /*On fail goto*//*Label 27040*/ GIMT_Encode4(2029972), // Rule ID 14963 //
     /* 2029886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2029889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2029897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2029900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2029903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2029906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2029909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2029912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2029916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2029924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2029928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2029932 */     // MIs[0] round
     /* 2029932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2029935 */     // MIs[0] policy
     /* 2029935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2029938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2029945 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2029945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2029948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2029950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2029952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2029954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2029956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2029958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2029960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2029965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2029968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2029970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2029971 */     // GIR_Coverage, 14963,
     /* 2029971 */     GIR_EraseRootFromParent_Done,
     /* 2029972 */   // Label 27040: @2029972
     /* 2029972 */   GIM_Try, /*On fail goto*//*Label 27041*/ GIMT_Encode4(2030063), // Rule ID 14966 //
     /* 2029977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2029980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2029985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2029988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2029991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2029994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2029997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030023 */     // MIs[0] round
     /* 2030023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030026 */     // MIs[0] policy
     /* 2030026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2030039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030062 */     // GIR_Coverage, 14966,
     /* 2030062 */     GIR_EraseRootFromParent_Done,
     /* 2030063 */   // Label 27041: @2030063
     /* 2030063 */   GIM_Try, /*On fail goto*//*Label 27042*/ GIMT_Encode4(2030154), // Rule ID 14967 //
     /* 2030068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2030079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2030082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2030085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030114 */     // MIs[0] round
     /* 2030114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030117 */     // MIs[0] policy
     /* 2030117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2030130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030153 */     // GIR_Coverage, 14967,
     /* 2030153 */     GIR_EraseRootFromParent_Done,
     /* 2030154 */   // Label 27042: @2030154
     /* 2030154 */   GIM_Try, /*On fail goto*//*Label 27043*/ GIMT_Encode4(2030245), // Rule ID 14970 //
     /* 2030159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030205 */     // MIs[0] round
     /* 2030205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030208 */     // MIs[0] policy
     /* 2030208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030218 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2030221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030223 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030244 */     // GIR_Coverage, 14970,
     /* 2030244 */     GIR_EraseRootFromParent_Done,
     /* 2030245 */   // Label 27043: @2030245
     /* 2030245 */   GIM_Try, /*On fail goto*//*Label 27044*/ GIMT_Encode4(2030336), // Rule ID 14971 //
     /* 2030250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2030261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2030264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2030267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030296 */     // MIs[0] round
     /* 2030296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030299 */     // MIs[0] policy
     /* 2030299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030309 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2030312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030314 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030335 */     // GIR_Coverage, 14971,
     /* 2030335 */     GIR_EraseRootFromParent_Done,
     /* 2030336 */   // Label 27044: @2030336
     /* 2030336 */   GIM_Try, /*On fail goto*//*Label 27045*/ GIMT_Encode4(2030427), // Rule ID 14974 //
     /* 2030341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2030344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030387 */     // MIs[0] round
     /* 2030387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030390 */     // MIs[0] policy
     /* 2030390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030400 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2030403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030405 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030426 */     // GIR_Coverage, 14974,
     /* 2030426 */     GIR_EraseRootFromParent_Done,
     /* 2030427 */   // Label 27045: @2030427
     /* 2030427 */   GIM_Try, /*On fail goto*//*Label 27046*/ GIMT_Encode4(2030518), // Rule ID 14975 //
     /* 2030432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2030435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2030443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2030446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2030449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2030455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030478 */     // MIs[0] round
     /* 2030478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030481 */     // MIs[0] policy
     /* 2030481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030491 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2030494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030496 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2030514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030517 */     // GIR_Coverage, 14975,
     /* 2030517 */     GIR_EraseRootFromParent_Done,
     /* 2030518 */   // Label 27046: @2030518
     /* 2030518 */   GIM_Try, /*On fail goto*//*Label 27047*/ GIMT_Encode4(2030609), // Rule ID 14978 //
     /* 2030523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2030526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2030534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2030537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030569 */     // MIs[0] round
     /* 2030569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030572 */     // MIs[0] policy
     /* 2030572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2030585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030587 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030608 */     // GIR_Coverage, 14978,
     /* 2030608 */     GIR_EraseRootFromParent_Done,
     /* 2030609 */   // Label 27047: @2030609
     /* 2030609 */   GIM_Try, /*On fail goto*//*Label 27048*/ GIMT_Encode4(2030700), // Rule ID 14979 //
     /* 2030614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2030617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2030625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2030628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2030631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2030637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2030644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2030652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030660 */     // MIs[0] round
     /* 2030660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030663 */     // MIs[0] policy
     /* 2030663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030673 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11072:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M2_MASK),
     /* 2030676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030678 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030699 */     // GIR_Coverage, 14979,
     /* 2030699 */     GIR_EraseRootFromParent_Done,
     /* 2030700 */   // Label 27048: @2030700
     /* 2030700 */   GIM_Try, /*On fail goto*//*Label 27049*/ GIMT_Encode4(2030791), // Rule ID 14982 //
     /* 2030705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2030708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2030716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2030719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030751 */     // MIs[0] round
     /* 2030751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030754 */     // MIs[0] policy
     /* 2030754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030764 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2030767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030790 */     // GIR_Coverage, 14982,
     /* 2030790 */     GIR_EraseRootFromParent_Done,
     /* 2030791 */   // Label 27049: @2030791
     /* 2030791 */   GIM_Try, /*On fail goto*//*Label 27050*/ GIMT_Encode4(2030882), // Rule ID 14983 //
     /* 2030796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2030799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2030807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2030810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2030813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2030819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2030822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2030826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2030834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030842 */     // MIs[0] round
     /* 2030842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030845 */     // MIs[0] policy
     /* 2030845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030855 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11072:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2030855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M4_MASK),
     /* 2030858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030860 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030881 */     // GIR_Coverage, 14983,
     /* 2030881 */     GIR_EraseRootFromParent_Done,
     /* 2030882 */   // Label 27050: @2030882
     /* 2030882 */   GIM_Try, /*On fail goto*//*Label 27051*/ GIMT_Encode4(2030973), // Rule ID 14986 //
     /* 2030887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2030890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2030898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2030901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2030907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2030910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2030913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2030917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2030925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2030929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2030933 */     // MIs[0] round
     /* 2030933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2030936 */     // MIs[0] policy
     /* 2030936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2030939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2030946 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2030946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2030949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2030951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2030953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2030955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2030957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2030959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2030961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2030966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2030969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2030971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2030972 */     // GIR_Coverage, 14986,
     /* 2030972 */     GIR_EraseRootFromParent_Done,
     /* 2030973 */   // Label 27051: @2030973
     /* 2030973 */   GIM_Try, /*On fail goto*//*Label 27052*/ GIMT_Encode4(2031064), // Rule ID 14987 //
     /* 2030978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2030981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaaddu_mask),
     /* 2030986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2030989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2030992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2030995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2030998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2031001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2031008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2031016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2031020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031024 */     // MIs[0] round
     /* 2031024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031027 */     // MIs[0] policy
     /* 2031027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031037 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11072:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADDU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADDU_VX_M8_MASK),
     /* 2031040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031042 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2031060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031063 */     // GIR_Coverage, 14987,
     /* 2031063 */     GIR_EraseRootFromParent_Done,
     /* 2031064 */   // Label 27052: @2031064
     /* 2031064 */   GIM_Try, /*On fail goto*//*Label 27053*/ GIMT_Encode4(2031155), // Rule ID 14990 //
     /* 2031069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2031086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2031089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031115 */     // MIs[0] round
     /* 2031115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031118 */     // MIs[0] policy
     /* 2031118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031128 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2031131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031133 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031154 */     // GIR_Coverage, 14990,
     /* 2031154 */     GIR_EraseRootFromParent_Done,
     /* 2031155 */   // Label 27053: @2031155
     /* 2031155 */   GIM_Try, /*On fail goto*//*Label 27054*/ GIMT_Encode4(2031246), // Rule ID 14991 //
     /* 2031160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2031171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2031174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2031177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2031180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031206 */     // MIs[0] round
     /* 2031206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031209 */     // MIs[0] policy
     /* 2031209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031219 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF8_MASK),
     /* 2031222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031224 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031245 */     // GIR_Coverage, 14991,
     /* 2031245 */     GIR_EraseRootFromParent_Done,
     /* 2031246 */   // Label 27054: @2031246
     /* 2031246 */   GIM_Try, /*On fail goto*//*Label 27055*/ GIMT_Encode4(2031337), // Rule ID 14994 //
     /* 2031251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2031268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2031271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031297 */     // MIs[0] round
     /* 2031297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031300 */     // MIs[0] policy
     /* 2031300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031310 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2031313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031336 */     // GIR_Coverage, 14994,
     /* 2031336 */     GIR_EraseRootFromParent_Done,
     /* 2031337 */   // Label 27055: @2031337
     /* 2031337 */   GIM_Try, /*On fail goto*//*Label 27056*/ GIMT_Encode4(2031428), // Rule ID 14995 //
     /* 2031342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2031353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2031356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2031359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2031362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031388 */     // MIs[0] round
     /* 2031388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031391 */     // MIs[0] policy
     /* 2031391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031401 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2031404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031406 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031427 */     // GIR_Coverage, 14995,
     /* 2031427 */     GIR_EraseRootFromParent_Done,
     /* 2031428 */   // Label 27056: @2031428
     /* 2031428 */   GIM_Try, /*On fail goto*//*Label 27057*/ GIMT_Encode4(2031519), // Rule ID 14998 //
     /* 2031433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2031444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2031447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2031450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2031453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031479 */     // MIs[0] round
     /* 2031479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031482 */     // MIs[0] policy
     /* 2031482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031492 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2031495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031497 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031518 */     // GIR_Coverage, 14998,
     /* 2031518 */     GIR_EraseRootFromParent_Done,
     /* 2031519 */   // Label 27057: @2031519
     /* 2031519 */   GIM_Try, /*On fail goto*//*Label 27058*/ GIMT_Encode4(2031610), // Rule ID 14999 //
     /* 2031524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2031535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2031538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2031541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2031544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2031547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031570 */     // MIs[0] round
     /* 2031570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031573 */     // MIs[0] policy
     /* 2031573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031583 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2031586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031588 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2031606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031609 */     // GIR_Coverage, 14999,
     /* 2031609 */     GIR_EraseRootFromParent_Done,
     /* 2031610 */   // Label 27058: @2031610
     /* 2031610 */   GIM_Try, /*On fail goto*//*Label 27059*/ GIMT_Encode4(2031701), // Rule ID 15002 //
     /* 2031615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2031626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2031629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031661 */     // MIs[0] round
     /* 2031661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031664 */     // MIs[0] policy
     /* 2031664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031674 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2031677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031679 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031700 */     // GIR_Coverage, 15002,
     /* 2031700 */     GIR_EraseRootFromParent_Done,
     /* 2031701 */   // Label 27059: @2031701
     /* 2031701 */   GIM_Try, /*On fail goto*//*Label 27060*/ GIMT_Encode4(2031792), // Rule ID 15003 //
     /* 2031706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2031717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2031720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2031723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2031726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2031729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031752 */     // MIs[0] round
     /* 2031752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031755 */     // MIs[0] policy
     /* 2031755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031765 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF4_MASK),
     /* 2031768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031770 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031791 */     // GIR_Coverage, 15003,
     /* 2031791 */     GIR_EraseRootFromParent_Done,
     /* 2031792 */   // Label 27060: @2031792
     /* 2031792 */   GIM_Try, /*On fail goto*//*Label 27061*/ GIMT_Encode4(2031883), // Rule ID 15006 //
     /* 2031797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2031808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2031811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2031823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031843 */     // MIs[0] round
     /* 2031843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031846 */     // MIs[0] policy
     /* 2031846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031856 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2031856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2031859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031861 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031882 */     // GIR_Coverage, 15006,
     /* 2031882 */     GIR_EraseRootFromParent_Done,
     /* 2031883 */   // Label 27061: @2031883
     /* 2031883 */   GIM_Try, /*On fail goto*//*Label 27062*/ GIMT_Encode4(2031974), // Rule ID 15007 //
     /* 2031888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2031891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2031899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2031902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2031905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2031908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2031911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2031914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2031918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2031930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2031934 */     // MIs[0] round
     /* 2031934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2031937 */     // MIs[0] policy
     /* 2031937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2031940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2031947 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2031947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2031950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2031952 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2031954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2031956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2031958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2031960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2031962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2031967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2031970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2031972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2031973 */     // GIR_Coverage, 15007,
     /* 2031973 */     GIR_EraseRootFromParent_Done,
     /* 2031974 */   // Label 27062: @2031974
     /* 2031974 */   GIM_Try, /*On fail goto*//*Label 27063*/ GIMT_Encode4(2032065), // Rule ID 15010 //
     /* 2031979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2031982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2031987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2031990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2031993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2031996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2031999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032025 */     // MIs[0] round
     /* 2032025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032028 */     // MIs[0] policy
     /* 2032028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032038 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2032041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032064 */     // GIR_Coverage, 15010,
     /* 2032064 */     GIR_EraseRootFromParent_Done,
     /* 2032065 */   // Label 27063: @2032065
     /* 2032065 */   GIM_Try, /*On fail goto*//*Label 27064*/ GIMT_Encode4(2032156), // Rule ID 15011 //
     /* 2032070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2032081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2032084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2032087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2032090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032116 */     // MIs[0] round
     /* 2032116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032119 */     // MIs[0] policy
     /* 2032119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032129 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_MF2_MASK),
     /* 2032132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032134 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032155 */     // GIR_Coverage, 15011,
     /* 2032155 */     GIR_EraseRootFromParent_Done,
     /* 2032156 */   // Label 27064: @2032156
     /* 2032156 */   GIM_Try, /*On fail goto*//*Label 27065*/ GIMT_Encode4(2032247), // Rule ID 15014 //
     /* 2032161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2032178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2032181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032207 */     // MIs[0] round
     /* 2032207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032210 */     // MIs[0] policy
     /* 2032210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032220 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032246 */     // GIR_Coverage, 15014,
     /* 2032246 */     GIR_EraseRootFromParent_Done,
     /* 2032247 */   // Label 27065: @2032247
     /* 2032247 */   GIM_Try, /*On fail goto*//*Label 27066*/ GIMT_Encode4(2032338), // Rule ID 15015 //
     /* 2032252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2032263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2032266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2032269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2032272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2032275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032298 */     // MIs[0] round
     /* 2032298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032301 */     // MIs[0] policy
     /* 2032301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032311 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032316 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032337 */     // GIR_Coverage, 15015,
     /* 2032337 */     GIR_EraseRootFromParent_Done,
     /* 2032338 */   // Label 27066: @2032338
     /* 2032338 */   GIM_Try, /*On fail goto*//*Label 27067*/ GIMT_Encode4(2032429), // Rule ID 15018 //
     /* 2032343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032389 */     // MIs[0] round
     /* 2032389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032392 */     // MIs[0] policy
     /* 2032392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032402 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032407 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032428 */     // GIR_Coverage, 15018,
     /* 2032428 */     GIR_EraseRootFromParent_Done,
     /* 2032429 */   // Label 27067: @2032429
     /* 2032429 */   GIM_Try, /*On fail goto*//*Label 27068*/ GIMT_Encode4(2032520), // Rule ID 15019 //
     /* 2032434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2032445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2032448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2032451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2032454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2032457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032480 */     // MIs[0] round
     /* 2032480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032483 */     // MIs[0] policy
     /* 2032483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032493 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032498 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2032516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032519 */     // GIR_Coverage, 15019,
     /* 2032519 */     GIR_EraseRootFromParent_Done,
     /* 2032520 */   // Label 27068: @2032520
     /* 2032520 */   GIM_Try, /*On fail goto*//*Label 27069*/ GIMT_Encode4(2032611), // Rule ID 15022 //
     /* 2032525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032571 */     // MIs[0] round
     /* 2032571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032574 */     // MIs[0] policy
     /* 2032574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032584 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032610 */     // GIR_Coverage, 15022,
     /* 2032610 */     GIR_EraseRootFromParent_Done,
     /* 2032611 */   // Label 27069: @2032611
     /* 2032611 */   GIM_Try, /*On fail goto*//*Label 27070*/ GIMT_Encode4(2032702), // Rule ID 15023 //
     /* 2032616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2032627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2032630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2032633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2032636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2032639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032662 */     // MIs[0] round
     /* 2032662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032665 */     // MIs[0] policy
     /* 2032665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032675 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032680 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2032698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032701 */     // GIR_Coverage, 15023,
     /* 2032701 */     GIR_EraseRootFromParent_Done,
     /* 2032702 */   // Label 27070: @2032702
     /* 2032702 */   GIM_Try, /*On fail goto*//*Label 27071*/ GIMT_Encode4(2032793), // Rule ID 15026 //
     /* 2032707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2032710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2032724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2032727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032753 */     // MIs[0] round
     /* 2032753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032756 */     // MIs[0] policy
     /* 2032756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2032789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032792 */     // GIR_Coverage, 15026,
     /* 2032792 */     GIR_EraseRootFromParent_Done,
     /* 2032793 */   // Label 27071: @2032793
     /* 2032793 */   GIM_Try, /*On fail goto*//*Label 27072*/ GIMT_Encode4(2032884), // Rule ID 15027 //
     /* 2032798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2032801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2032809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2032812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2032815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2032818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2032821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2032824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2032828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2032840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032844 */     // MIs[0] round
     /* 2032844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032847 */     // MIs[0] policy
     /* 2032847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032857 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2032857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M1_MASK),
     /* 2032860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032862 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2032880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032883 */     // GIR_Coverage, 15027,
     /* 2032883 */     GIR_EraseRootFromParent_Done,
     /* 2032884 */   // Label 27072: @2032884
     /* 2032884 */   GIM_Try, /*On fail goto*//*Label 27073*/ GIMT_Encode4(2032975), // Rule ID 15030 //
     /* 2032889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2032892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2032900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2032903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2032906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2032909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2032912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2032915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2032919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2032931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2032935 */     // MIs[0] round
     /* 2032935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2032938 */     // MIs[0] policy
     /* 2032938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2032941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2032948 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2032948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2032951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2032953 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2032955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2032957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2032959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2032961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2032963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2032968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2032971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2032973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2032974 */     // GIR_Coverage, 15030,
     /* 2032974 */     GIR_EraseRootFromParent_Done,
     /* 2032975 */   // Label 27073: @2032975
     /* 2032975 */   GIM_Try, /*On fail goto*//*Label 27074*/ GIMT_Encode4(2033066), // Rule ID 15031 //
     /* 2032980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2032983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2032988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2032991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2032994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2032997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2033000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033026 */     // MIs[0] round
     /* 2033026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033029 */     // MIs[0] policy
     /* 2033029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033039 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2033042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033044 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033065 */     // GIR_Coverage, 15031,
     /* 2033065 */     GIR_EraseRootFromParent_Done,
     /* 2033066 */   // Label 27074: @2033066
     /* 2033066 */   GIM_Try, /*On fail goto*//*Label 27075*/ GIMT_Encode4(2033157), // Rule ID 15034 //
     /* 2033071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2033082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2033085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2033088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2033091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033117 */     // MIs[0] round
     /* 2033117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033120 */     // MIs[0] policy
     /* 2033120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033130 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2033133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033135 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033156 */     // GIR_Coverage, 15034,
     /* 2033156 */     GIR_EraseRootFromParent_Done,
     /* 2033157 */   // Label 27075: @2033157
     /* 2033157 */   GIM_Try, /*On fail goto*//*Label 27076*/ GIMT_Encode4(2033248), // Rule ID 15035 //
     /* 2033162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2033173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2033176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2033179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2033182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033208 */     // MIs[0] round
     /* 2033208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033211 */     // MIs[0] policy
     /* 2033211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033221 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2033224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033226 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033247 */     // GIR_Coverage, 15035,
     /* 2033247 */     GIR_EraseRootFromParent_Done,
     /* 2033248 */   // Label 27076: @2033248
     /* 2033248 */   GIM_Try, /*On fail goto*//*Label 27077*/ GIMT_Encode4(2033339), // Rule ID 15038 //
     /* 2033253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2033264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2033267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2033270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2033273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2033276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033299 */     // MIs[0] round
     /* 2033299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033302 */     // MIs[0] policy
     /* 2033302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033312 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2033315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033317 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033338 */     // GIR_Coverage, 15038,
     /* 2033338 */     GIR_EraseRootFromParent_Done,
     /* 2033339 */   // Label 27077: @2033339
     /* 2033339 */   GIM_Try, /*On fail goto*//*Label 27078*/ GIMT_Encode4(2033430), // Rule ID 15039 //
     /* 2033344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2033355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2033358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2033361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2033364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2033367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033390 */     // MIs[0] round
     /* 2033390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033393 */     // MIs[0] policy
     /* 2033393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033403 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2033406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033408 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2033426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033429 */     // GIR_Coverage, 15039,
     /* 2033429 */     GIR_EraseRootFromParent_Done,
     /* 2033430 */   // Label 27078: @2033430
     /* 2033430 */   GIM_Try, /*On fail goto*//*Label 27079*/ GIMT_Encode4(2033521), // Rule ID 15042 //
     /* 2033435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2033452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033481 */     // MIs[0] round
     /* 2033481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033484 */     // MIs[0] policy
     /* 2033484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2033497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033499 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033520 */     // GIR_Coverage, 15042,
     /* 2033520 */     GIR_EraseRootFromParent_Done,
     /* 2033521 */   // Label 27079: @2033521
     /* 2033521 */   GIM_Try, /*On fail goto*//*Label 27080*/ GIMT_Encode4(2033612), // Rule ID 15043 //
     /* 2033526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2033537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2033540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2033543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2033546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2033549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2033556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2033568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033572 */     // MIs[0] round
     /* 2033572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033575 */     // MIs[0] policy
     /* 2033575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033585 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2033588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033590 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033611 */     // GIR_Coverage, 15043,
     /* 2033611 */     GIR_EraseRootFromParent_Done,
     /* 2033612 */   // Label 27080: @2033612
     /* 2033612 */   GIM_Try, /*On fail goto*//*Label 27081*/ GIMT_Encode4(2033703), // Rule ID 15046 //
     /* 2033617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2033628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2033631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2033634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033663 */     // MIs[0] round
     /* 2033663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033666 */     // MIs[0] policy
     /* 2033666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033676 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2033679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033681 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033702 */     // GIR_Coverage, 15046,
     /* 2033702 */     GIR_EraseRootFromParent_Done,
     /* 2033703 */   // Label 27081: @2033703
     /* 2033703 */   GIM_Try, /*On fail goto*//*Label 27082*/ GIMT_Encode4(2033794), // Rule ID 15047 //
     /* 2033708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2033719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2033722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2033725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2033728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2033731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2033738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2033750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033754 */     // MIs[0] round
     /* 2033754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033757 */     // MIs[0] policy
     /* 2033757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033767 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2033770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033772 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033793 */     // GIR_Coverage, 15047,
     /* 2033793 */     GIR_EraseRootFromParent_Done,
     /* 2033794 */   // Label 27082: @2033794
     /* 2033794 */   GIM_Try, /*On fail goto*//*Label 27083*/ GIMT_Encode4(2033885), // Rule ID 15050 //
     /* 2033799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2033810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2033813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2033816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2033819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2033825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033845 */     // MIs[0] round
     /* 2033845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033848 */     // MIs[0] policy
     /* 2033848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033858 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2033858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2033861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033884 */     // GIR_Coverage, 15050,
     /* 2033884 */     GIR_EraseRootFromParent_Done,
     /* 2033885 */   // Label 27083: @2033885
     /* 2033885 */   GIM_Try, /*On fail goto*//*Label 27084*/ GIMT_Encode4(2033976), // Rule ID 15051 //
     /* 2033890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2033893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2033901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2033904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2033907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2033910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2033913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2033916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2033920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2033932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2033936 */     // MIs[0] round
     /* 2033936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2033939 */     // MIs[0] policy
     /* 2033939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2033942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2033949 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2033949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2033952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2033954 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2033956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2033958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2033960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2033962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2033964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2033969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2033972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2033974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2033975 */     // GIR_Coverage, 15051,
     /* 2033975 */     GIR_EraseRootFromParent_Done,
     /* 2033976 */   // Label 27084: @2033976
     /* 2033976 */   GIM_Try, /*On fail goto*//*Label 27085*/ GIMT_Encode4(2034067), // Rule ID 15054 //
     /* 2033981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2033984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2033989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2033992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2033995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2033998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034027 */     // MIs[0] round
     /* 2034027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034030 */     // MIs[0] policy
     /* 2034030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034040 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2034043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034066 */     // GIR_Coverage, 15054,
     /* 2034066 */     GIR_EraseRootFromParent_Done,
     /* 2034067 */   // Label 27085: @2034067
     /* 2034067 */   GIM_Try, /*On fail goto*//*Label 27086*/ GIMT_Encode4(2034158), // Rule ID 15055 //
     /* 2034072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2034083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2034086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2034089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2034092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034118 */     // MIs[0] round
     /* 2034118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034121 */     // MIs[0] policy
     /* 2034121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2034134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034136 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034157 */     // GIR_Coverage, 15055,
     /* 2034157 */     GIR_EraseRootFromParent_Done,
     /* 2034158 */   // Label 27086: @2034158
     /* 2034158 */   GIM_Try, /*On fail goto*//*Label 27087*/ GIMT_Encode4(2034249), // Rule ID 15058 //
     /* 2034163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2034180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034209 */     // MIs[0] round
     /* 2034209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034212 */     // MIs[0] policy
     /* 2034212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034222 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2034225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034227 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034248 */     // GIR_Coverage, 15058,
     /* 2034248 */     GIR_EraseRootFromParent_Done,
     /* 2034249 */   // Label 27087: @2034249
     /* 2034249 */   GIM_Try, /*On fail goto*//*Label 27088*/ GIMT_Encode4(2034340), // Rule ID 15059 //
     /* 2034254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2034265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2034268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2034271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2034274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034300 */     // MIs[0] round
     /* 2034300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034303 */     // MIs[0] policy
     /* 2034303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034313 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2034316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034318 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034339 */     // GIR_Coverage, 15059,
     /* 2034339 */     GIR_EraseRootFromParent_Done,
     /* 2034340 */   // Label 27088: @2034340
     /* 2034340 */   GIM_Try, /*On fail goto*//*Label 27089*/ GIMT_Encode4(2034431), // Rule ID 15062 //
     /* 2034345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2034348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2034356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2034359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2034362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2034365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2034368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034391 */     // MIs[0] round
     /* 2034391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034394 */     // MIs[0] policy
     /* 2034394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034404 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2034407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034430 */     // GIR_Coverage, 15062,
     /* 2034430 */     GIR_EraseRootFromParent_Done,
     /* 2034431 */   // Label 27089: @2034431
     /* 2034431 */   GIM_Try, /*On fail goto*//*Label 27090*/ GIMT_Encode4(2034522), // Rule ID 15063 //
     /* 2034436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2034439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2034447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2034450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2034453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2034456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2034459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034482 */     // MIs[0] round
     /* 2034482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034485 */     // MIs[0] policy
     /* 2034485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034495 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2034498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034500 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2034518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034521 */     // GIR_Coverage, 15063,
     /* 2034521 */     GIR_EraseRootFromParent_Done,
     /* 2034522 */   // Label 27090: @2034522
     /* 2034522 */   GIM_Try, /*On fail goto*//*Label 27091*/ GIMT_Encode4(2034613), // Rule ID 15066 //
     /* 2034527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2034530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2034538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2034541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2034547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034573 */     // MIs[0] round
     /* 2034573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034576 */     // MIs[0] policy
     /* 2034576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2034589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034591 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034612 */     // GIR_Coverage, 15066,
     /* 2034612 */     GIR_EraseRootFromParent_Done,
     /* 2034613 */   // Label 27091: @2034613
     /* 2034613 */   GIM_Try, /*On fail goto*//*Label 27092*/ GIMT_Encode4(2034704), // Rule ID 15067 //
     /* 2034618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2034621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2034629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2034632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2034635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2034638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2034641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2034648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2034660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034664 */     // MIs[0] round
     /* 2034664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034667 */     // MIs[0] policy
     /* 2034667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034677 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M2_MASK),
     /* 2034680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034682 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034703 */     // GIR_Coverage, 15067,
     /* 2034703 */     GIR_EraseRootFromParent_Done,
     /* 2034704 */   // Label 27092: @2034704
     /* 2034704 */   GIM_Try, /*On fail goto*//*Label 27093*/ GIMT_Encode4(2034795), // Rule ID 15070 //
     /* 2034709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2034712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2034726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2034729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034755 */     // MIs[0] round
     /* 2034755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034758 */     // MIs[0] policy
     /* 2034758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034768 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2034771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034773 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034794 */     // GIR_Coverage, 15070,
     /* 2034794 */     GIR_EraseRootFromParent_Done,
     /* 2034795 */   // Label 27093: @2034795
     /* 2034795 */   GIM_Try, /*On fail goto*//*Label 27094*/ GIMT_Encode4(2034886), // Rule ID 15071 //
     /* 2034800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2034803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2034811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2034814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2034817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2034820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2034823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2034826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2034830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2034842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034846 */     // MIs[0] round
     /* 2034846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034849 */     // MIs[0] policy
     /* 2034849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034859 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2034859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M4_MASK),
     /* 2034862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034864 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034885 */     // GIR_Coverage, 15071,
     /* 2034885 */     GIR_EraseRootFromParent_Done,
     /* 2034886 */   // Label 27094: @2034886
     /* 2034886 */   GIM_Try, /*On fail goto*//*Label 27095*/ GIMT_Encode4(2034977), // Rule ID 15074 //
     /* 2034891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2034894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2034911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2034914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2034917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2034921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2034933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2034937 */     // MIs[0] round
     /* 2034937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2034940 */     // MIs[0] policy
     /* 2034940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2034943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2034950 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2034950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2034953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2034955 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2034957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2034959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2034961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2034963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2034965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2034970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2034973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2034975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2034976 */     // GIR_Coverage, 15074,
     /* 2034976 */     GIR_EraseRootFromParent_Done,
     /* 2034977 */   // Label 27095: @2034977
     /* 2034977 */   GIM_Try, /*On fail goto*//*Label 27096*/ GIMT_Encode4(2035068), // Rule ID 15075 //
     /* 2034982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2034985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2034990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2034993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2034996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2034999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2035002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2035005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2035012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2035024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035028 */     // MIs[0] round
     /* 2035028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035031 */     // MIs[0] policy
     /* 2035031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035041 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VV_M8_MASK),
     /* 2035044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035046 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2035064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035067 */     // GIR_Coverage, 15075,
     /* 2035067 */     GIR_EraseRootFromParent_Done,
     /* 2035068 */   // Label 27096: @2035068
     /* 2035068 */   GIM_Try, /*On fail goto*//*Label 27097*/ GIMT_Encode4(2035159), // Rule ID 15078 //
     /* 2035073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2035084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2035087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2035090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035119 */     // MIs[0] round
     /* 2035119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035122 */     // MIs[0] policy
     /* 2035122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035132 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2035135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035158 */     // GIR_Coverage, 15078,
     /* 2035158 */     GIR_EraseRootFromParent_Done,
     /* 2035159 */   // Label 27097: @2035159
     /* 2035159 */   GIM_Try, /*On fail goto*//*Label 27098*/ GIMT_Encode4(2035250), // Rule ID 15079 //
     /* 2035164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2035175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2035178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2035181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035210 */     // MIs[0] round
     /* 2035210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035213 */     // MIs[0] policy
     /* 2035213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035223 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF8_MASK),
     /* 2035226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035228 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035249 */     // GIR_Coverage, 15079,
     /* 2035249 */     GIR_EraseRootFromParent_Done,
     /* 2035250 */   // Label 27098: @2035250
     /* 2035250 */   GIM_Try, /*On fail goto*//*Label 27099*/ GIMT_Encode4(2035341), // Rule ID 15082 //
     /* 2035255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035301 */     // MIs[0] round
     /* 2035301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035304 */     // MIs[0] policy
     /* 2035304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035314 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2035317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035340 */     // GIR_Coverage, 15082,
     /* 2035340 */     GIR_EraseRootFromParent_Done,
     /* 2035341 */   // Label 27099: @2035341
     /* 2035341 */   GIM_Try, /*On fail goto*//*Label 27100*/ GIMT_Encode4(2035432), // Rule ID 15083 //
     /* 2035346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2035357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2035360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2035363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035392 */     // MIs[0] round
     /* 2035392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035395 */     // MIs[0] policy
     /* 2035395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035405 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2035408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035410 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035431 */     // GIR_Coverage, 15083,
     /* 2035431 */     GIR_EraseRootFromParent_Done,
     /* 2035432 */   // Label 27100: @2035432
     /* 2035432 */   GIM_Try, /*On fail goto*//*Label 27101*/ GIMT_Encode4(2035523), // Rule ID 15086 //
     /* 2035437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035483 */     // MIs[0] round
     /* 2035483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035486 */     // MIs[0] policy
     /* 2035486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035496 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2035499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035501 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035522 */     // GIR_Coverage, 15086,
     /* 2035522 */     GIR_EraseRootFromParent_Done,
     /* 2035523 */   // Label 27101: @2035523
     /* 2035523 */   GIM_Try, /*On fail goto*//*Label 27102*/ GIMT_Encode4(2035614), // Rule ID 15087 //
     /* 2035528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2035539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2035542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2035545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2035551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035574 */     // MIs[0] round
     /* 2035574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035577 */     // MIs[0] policy
     /* 2035577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035587 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2035590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035592 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2035610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035613 */     // GIR_Coverage, 15087,
     /* 2035613 */     GIR_EraseRootFromParent_Done,
     /* 2035614 */   // Label 27102: @2035614
     /* 2035614 */   GIM_Try, /*On fail goto*//*Label 27103*/ GIMT_Encode4(2035705), // Rule ID 15090 //
     /* 2035619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035665 */     // MIs[0] round
     /* 2035665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035668 */     // MIs[0] policy
     /* 2035668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035678 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2035681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035704 */     // GIR_Coverage, 15090,
     /* 2035704 */     GIR_EraseRootFromParent_Done,
     /* 2035705 */   // Label 27103: @2035705
     /* 2035705 */   GIM_Try, /*On fail goto*//*Label 27104*/ GIMT_Encode4(2035796), // Rule ID 15091 //
     /* 2035710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2035721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2035724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2035727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2035733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035756 */     // MIs[0] round
     /* 2035756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035759 */     // MIs[0] policy
     /* 2035759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035769 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF4_MASK),
     /* 2035772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035774 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035795 */     // GIR_Coverage, 15091,
     /* 2035795 */     GIR_EraseRootFromParent_Done,
     /* 2035796 */   // Label 27104: @2035796
     /* 2035796 */   GIM_Try, /*On fail goto*//*Label 27105*/ GIMT_Encode4(2035887), // Rule ID 15094 //
     /* 2035801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2035821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2035827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035847 */     // MIs[0] round
     /* 2035847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035850 */     // MIs[0] policy
     /* 2035850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035860 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2035860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2035863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035886 */     // GIR_Coverage, 15094,
     /* 2035886 */     GIR_EraseRootFromParent_Done,
     /* 2035887 */   // Label 27105: @2035887
     /* 2035887 */   GIM_Try, /*On fail goto*//*Label 27106*/ GIMT_Encode4(2035978), // Rule ID 15095 //
     /* 2035892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2035895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2035903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2035906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2035909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2035912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2035915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2035918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2035922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2035930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2035934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2035938 */     // MIs[0] round
     /* 2035938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2035941 */     // MIs[0] policy
     /* 2035941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2035944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2035951 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2035951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2035954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2035956 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2035958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2035960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2035962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2035964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2035966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2035971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2035974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2035976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2035977 */     // GIR_Coverage, 15095,
     /* 2035977 */     GIR_EraseRootFromParent_Done,
     /* 2035978 */   // Label 27106: @2035978
     /* 2035978 */   GIM_Try, /*On fail goto*//*Label 27107*/ GIMT_Encode4(2036069), // Rule ID 15098 //
     /* 2035983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2035986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2035991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2035994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2035997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2036000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036029 */     // MIs[0] round
     /* 2036029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036032 */     // MIs[0] policy
     /* 2036032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036042 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2036045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036047 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036068 */     // GIR_Coverage, 15098,
     /* 2036068 */     GIR_EraseRootFromParent_Done,
     /* 2036069 */   // Label 27107: @2036069
     /* 2036069 */   GIM_Try, /*On fail goto*//*Label 27108*/ GIMT_Encode4(2036160), // Rule ID 15099 //
     /* 2036074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2036085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2036088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2036091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036120 */     // MIs[0] round
     /* 2036120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036123 */     // MIs[0] policy
     /* 2036123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036133 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_MF2_MASK),
     /* 2036136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036138 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036159 */     // GIR_Coverage, 15099,
     /* 2036159 */     GIR_EraseRootFromParent_Done,
     /* 2036160 */   // Label 27108: @2036160
     /* 2036160 */   GIM_Try, /*On fail goto*//*Label 27109*/ GIMT_Encode4(2036251), // Rule ID 15102 //
     /* 2036165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2036176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2036179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2036182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036211 */     // MIs[0] round
     /* 2036211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036214 */     // MIs[0] policy
     /* 2036214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036224 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036229 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036250 */     // GIR_Coverage, 15102,
     /* 2036250 */     GIR_EraseRootFromParent_Done,
     /* 2036251 */   // Label 27109: @2036251
     /* 2036251 */   GIM_Try, /*On fail goto*//*Label 27110*/ GIMT_Encode4(2036342), // Rule ID 15103 //
     /* 2036256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2036267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2036270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2036273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2036279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036302 */     // MIs[0] round
     /* 2036302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036305 */     // MIs[0] policy
     /* 2036305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036315 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11094:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036320 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036341 */     // GIR_Coverage, 15103,
     /* 2036341 */     GIR_EraseRootFromParent_Done,
     /* 2036342 */   // Label 27110: @2036342
     /* 2036342 */   GIM_Try, /*On fail goto*//*Label 27111*/ GIMT_Encode4(2036433), // Rule ID 15106 //
     /* 2036347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036393 */     // MIs[0] round
     /* 2036393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036396 */     // MIs[0] policy
     /* 2036396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036406 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036411 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036432 */     // GIR_Coverage, 15106,
     /* 2036432 */     GIR_EraseRootFromParent_Done,
     /* 2036433 */   // Label 27111: @2036433
     /* 2036433 */   GIM_Try, /*On fail goto*//*Label 27112*/ GIMT_Encode4(2036524), // Rule ID 15107 //
     /* 2036438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2036449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2036452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2036455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2036461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036484 */     // MIs[0] round
     /* 2036484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036487 */     // MIs[0] policy
     /* 2036487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036497 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11094:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036502 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2036520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036523 */     // GIR_Coverage, 15107,
     /* 2036523 */     GIR_EraseRootFromParent_Done,
     /* 2036524 */   // Label 27112: @2036524
     /* 2036524 */   GIM_Try, /*On fail goto*//*Label 27113*/ GIMT_Encode4(2036615), // Rule ID 15110 //
     /* 2036529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036575 */     // MIs[0] round
     /* 2036575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036578 */     // MIs[0] policy
     /* 2036578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036588 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036593 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036614 */     // GIR_Coverage, 15110,
     /* 2036614 */     GIR_EraseRootFromParent_Done,
     /* 2036615 */   // Label 27113: @2036615
     /* 2036615 */   GIM_Try, /*On fail goto*//*Label 27114*/ GIMT_Encode4(2036706), // Rule ID 15111 //
     /* 2036620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2036631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2036634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2036637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2036643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036666 */     // MIs[0] round
     /* 2036666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036669 */     // MIs[0] policy
     /* 2036669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036679 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11094:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036684 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2036702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036705 */     // GIR_Coverage, 15111,
     /* 2036705 */     GIR_EraseRootFromParent_Done,
     /* 2036706 */   // Label 27114: @2036706
     /* 2036706 */   GIM_Try, /*On fail goto*//*Label 27115*/ GIMT_Encode4(2036797), // Rule ID 15114 //
     /* 2036711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2036714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036757 */     // MIs[0] round
     /* 2036757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036760 */     // MIs[0] policy
     /* 2036760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036770 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036775 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036796 */     // GIR_Coverage, 15114,
     /* 2036796 */     GIR_EraseRootFromParent_Done,
     /* 2036797 */   // Label 27115: @2036797
     /* 2036797 */   GIM_Try, /*On fail goto*//*Label 27116*/ GIMT_Encode4(2036888), // Rule ID 15115 //
     /* 2036802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2036805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2036813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2036816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2036819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2036822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2036825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2036828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2036832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2036840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036848 */     // MIs[0] round
     /* 2036848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036851 */     // MIs[0] policy
     /* 2036851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036861 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11094:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2036861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M1_MASK),
     /* 2036864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036866 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2036884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036887 */     // GIR_Coverage, 15115,
     /* 2036887 */     GIR_EraseRootFromParent_Done,
     /* 2036888 */   // Label 27116: @2036888
     /* 2036888 */   GIM_Try, /*On fail goto*//*Label 27117*/ GIMT_Encode4(2036979), // Rule ID 15118 //
     /* 2036893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2036896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2036910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2036913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2036916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2036919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2036923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2036931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2036935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2036939 */     // MIs[0] round
     /* 2036939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2036942 */     // MIs[0] policy
     /* 2036942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2036945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2036952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2036952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2036955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2036957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2036959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2036961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2036963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2036965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2036967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2036972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2036975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2036977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2036978 */     // GIR_Coverage, 15118,
     /* 2036978 */     GIR_EraseRootFromParent_Done,
     /* 2036979 */   // Label 27117: @2036979
     /* 2036979 */   GIM_Try, /*On fail goto*//*Label 27118*/ GIMT_Encode4(2037070), // Rule ID 15119 //
     /* 2036984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2036987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2036992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2036995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2036998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2037001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037030 */     // MIs[0] round
     /* 2037030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037033 */     // MIs[0] policy
     /* 2037033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2037046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037048 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037069 */     // GIR_Coverage, 15119,
     /* 2037069 */     GIR_EraseRootFromParent_Done,
     /* 2037070 */   // Label 27118: @2037070
     /* 2037070 */   GIM_Try, /*On fail goto*//*Label 27119*/ GIMT_Encode4(2037161), // Rule ID 15122 //
     /* 2037075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2037086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2037089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2037092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2037095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037121 */     // MIs[0] round
     /* 2037121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037124 */     // MIs[0] policy
     /* 2037124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037134 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2037137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037160 */     // GIR_Coverage, 15122,
     /* 2037160 */     GIR_EraseRootFromParent_Done,
     /* 2037161 */   // Label 27119: @2037161
     /* 2037161 */   GIM_Try, /*On fail goto*//*Label 27120*/ GIMT_Encode4(2037252), // Rule ID 15123 //
     /* 2037166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2037177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2037180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2037183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037212 */     // MIs[0] round
     /* 2037212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037215 */     // MIs[0] policy
     /* 2037215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037225 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2037228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037230 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037251 */     // GIR_Coverage, 15123,
     /* 2037251 */     GIR_EraseRootFromParent_Done,
     /* 2037252 */   // Label 27120: @2037252
     /* 2037252 */   GIM_Try, /*On fail goto*//*Label 27121*/ GIMT_Encode4(2037343), // Rule ID 15126 //
     /* 2037257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2037277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037303 */     // MIs[0] round
     /* 2037303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037306 */     // MIs[0] policy
     /* 2037306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037316 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2037319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037321 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037342 */     // GIR_Coverage, 15126,
     /* 2037342 */     GIR_EraseRootFromParent_Done,
     /* 2037343 */   // Label 27121: @2037343
     /* 2037343 */   GIM_Try, /*On fail goto*//*Label 27122*/ GIMT_Encode4(2037434), // Rule ID 15127 //
     /* 2037348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2037359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2037362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2037365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2037371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037394 */     // MIs[0] round
     /* 2037394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037397 */     // MIs[0] policy
     /* 2037397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037407 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2037410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037412 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2037430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037433 */     // GIR_Coverage, 15127,
     /* 2037433 */     GIR_EraseRootFromParent_Done,
     /* 2037434 */   // Label 27122: @2037434
     /* 2037434 */   GIM_Try, /*On fail goto*//*Label 27123*/ GIMT_Encode4(2037525), // Rule ID 15130 //
     /* 2037439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2037459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037485 */     // MIs[0] round
     /* 2037485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037488 */     // MIs[0] policy
     /* 2037488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2037501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037524 */     // GIR_Coverage, 15130,
     /* 2037524 */     GIR_EraseRootFromParent_Done,
     /* 2037525 */   // Label 27123: @2037525
     /* 2037525 */   GIM_Try, /*On fail goto*//*Label 27124*/ GIMT_Encode4(2037616), // Rule ID 15131 //
     /* 2037530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2037541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2037544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2037547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2037553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2037560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2037568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037576 */     // MIs[0] round
     /* 2037576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037579 */     // MIs[0] policy
     /* 2037579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037589 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2037592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037594 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037615 */     // GIR_Coverage, 15131,
     /* 2037615 */     GIR_EraseRootFromParent_Done,
     /* 2037616 */   // Label 27124: @2037616
     /* 2037616 */   GIM_Try, /*On fail goto*//*Label 27125*/ GIMT_Encode4(2037707), // Rule ID 15134 //
     /* 2037621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2037641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037667 */     // MIs[0] round
     /* 2037667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037670 */     // MIs[0] policy
     /* 2037670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037680 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2037683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037685 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037706 */     // GIR_Coverage, 15134,
     /* 2037706 */     GIR_EraseRootFromParent_Done,
     /* 2037707 */   // Label 27125: @2037707
     /* 2037707 */   GIM_Try, /*On fail goto*//*Label 27126*/ GIMT_Encode4(2037798), // Rule ID 15135 //
     /* 2037712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2037723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2037726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2037729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2037735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2037742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2037750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037758 */     // MIs[0] round
     /* 2037758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037761 */     // MIs[0] policy
     /* 2037761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037771 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2037774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037776 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037797 */     // GIR_Coverage, 15135,
     /* 2037797 */     GIR_EraseRootFromParent_Done,
     /* 2037798 */   // Label 27126: @2037798
     /* 2037798 */   GIM_Try, /*On fail goto*//*Label 27127*/ GIMT_Encode4(2037889), // Rule ID 15138 //
     /* 2037803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2037823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2037829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037849 */     // MIs[0] round
     /* 2037849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037852 */     // MIs[0] policy
     /* 2037852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037862 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2037862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2037865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037867 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037888 */     // GIR_Coverage, 15138,
     /* 2037888 */     GIR_EraseRootFromParent_Done,
     /* 2037889 */   // Label 27127: @2037889
     /* 2037889 */   GIM_Try, /*On fail goto*//*Label 27128*/ GIMT_Encode4(2037980), // Rule ID 15139 //
     /* 2037894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2037897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2037905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2037908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2037911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2037914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2037917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2037920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2037924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2037932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2037936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2037940 */     // MIs[0] round
     /* 2037940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2037943 */     // MIs[0] policy
     /* 2037943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2037946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2037953 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2037953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2037956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2037958 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2037960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2037962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2037964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2037966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2037968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2037973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2037976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2037978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2037979 */     // GIR_Coverage, 15139,
     /* 2037979 */     GIR_EraseRootFromParent_Done,
     /* 2037980 */   // Label 27128: @2037980
     /* 2037980 */   GIM_Try, /*On fail goto*//*Label 27129*/ GIMT_Encode4(2038071), // Rule ID 15142 //
     /* 2037985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2037988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2037993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2037996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2037999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038031 */     // MIs[0] round
     /* 2038031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038034 */     // MIs[0] policy
     /* 2038034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038044 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2038047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038049 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038070 */     // GIR_Coverage, 15142,
     /* 2038070 */     GIR_EraseRootFromParent_Done,
     /* 2038071 */   // Label 27129: @2038071
     /* 2038071 */   GIM_Try, /*On fail goto*//*Label 27130*/ GIMT_Encode4(2038162), // Rule ID 15143 //
     /* 2038076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2038087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2038090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2038093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038122 */     // MIs[0] round
     /* 2038122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038125 */     // MIs[0] policy
     /* 2038125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2038138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038140 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038161 */     // GIR_Coverage, 15143,
     /* 2038161 */     GIR_EraseRootFromParent_Done,
     /* 2038162 */   // Label 27130: @2038162
     /* 2038162 */   GIM_Try, /*On fail goto*//*Label 27131*/ GIMT_Encode4(2038253), // Rule ID 15146 //
     /* 2038167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2038178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2038181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038213 */     // MIs[0] round
     /* 2038213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038216 */     // MIs[0] policy
     /* 2038216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038226 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2038229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038252 */     // GIR_Coverage, 15146,
     /* 2038252 */     GIR_EraseRootFromParent_Done,
     /* 2038253 */   // Label 27131: @2038253
     /* 2038253 */   GIM_Try, /*On fail goto*//*Label 27132*/ GIMT_Encode4(2038344), // Rule ID 15147 //
     /* 2038258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2038269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2038272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2038275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038304 */     // MIs[0] round
     /* 2038304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038307 */     // MIs[0] policy
     /* 2038307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038317 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2038320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038322 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038343 */     // GIR_Coverage, 15147,
     /* 2038343 */     GIR_EraseRootFromParent_Done,
     /* 2038344 */   // Label 27132: @2038344
     /* 2038344 */   GIM_Try, /*On fail goto*//*Label 27133*/ GIMT_Encode4(2038435), // Rule ID 15150 //
     /* 2038349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2038352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038395 */     // MIs[0] round
     /* 2038395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038398 */     // MIs[0] policy
     /* 2038398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038408 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2038411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038434 */     // GIR_Coverage, 15150,
     /* 2038434 */     GIR_EraseRootFromParent_Done,
     /* 2038435 */   // Label 27133: @2038435
     /* 2038435 */   GIM_Try, /*On fail goto*//*Label 27134*/ GIMT_Encode4(2038526), // Rule ID 15151 //
     /* 2038440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2038443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2038451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2038454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2038457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2038463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038486 */     // MIs[0] round
     /* 2038486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038489 */     // MIs[0] policy
     /* 2038489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038499 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2038502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038504 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2038522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038525 */     // GIR_Coverage, 15151,
     /* 2038525 */     GIR_EraseRootFromParent_Done,
     /* 2038526 */   // Label 27134: @2038526
     /* 2038526 */   GIM_Try, /*On fail goto*//*Label 27135*/ GIMT_Encode4(2038617), // Rule ID 15154 //
     /* 2038531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038577 */     // MIs[0] round
     /* 2038577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038580 */     // MIs[0] policy
     /* 2038580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038590 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2038593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038595 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038616 */     // GIR_Coverage, 15154,
     /* 2038616 */     GIR_EraseRootFromParent_Done,
     /* 2038617 */   // Label 27135: @2038617
     /* 2038617 */   GIM_Try, /*On fail goto*//*Label 27136*/ GIMT_Encode4(2038708), // Rule ID 15155 //
     /* 2038622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2038633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2038636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2038639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2038645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2038652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2038660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038668 */     // MIs[0] round
     /* 2038668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038671 */     // MIs[0] policy
     /* 2038671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038681 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11094:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M2_MASK),
     /* 2038684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038686 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038707 */     // GIR_Coverage, 15155,
     /* 2038707 */     GIR_EraseRootFromParent_Done,
     /* 2038708 */   // Label 27136: @2038708
     /* 2038708 */   GIM_Try, /*On fail goto*//*Label 27137*/ GIMT_Encode4(2038799), // Rule ID 15158 //
     /* 2038713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038759 */     // MIs[0] round
     /* 2038759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038762 */     // MIs[0] policy
     /* 2038762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038772 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2038775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038798 */     // GIR_Coverage, 15158,
     /* 2038798 */     GIR_EraseRootFromParent_Done,
     /* 2038799 */   // Label 27137: @2038799
     /* 2038799 */   GIM_Try, /*On fail goto*//*Label 27138*/ GIMT_Encode4(2038890), // Rule ID 15159 //
     /* 2038804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2038815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2038818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2038821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2038824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2038827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2038830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2038834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2038842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038850 */     // MIs[0] round
     /* 2038850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038853 */     // MIs[0] policy
     /* 2038853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038863 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11094:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2038863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M4_MASK),
     /* 2038866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038868 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038889 */     // GIR_Coverage, 15159,
     /* 2038889 */     GIR_EraseRootFromParent_Done,
     /* 2038890 */   // Label 27138: @2038890
     /* 2038890 */   GIM_Try, /*On fail goto*//*Label 27139*/ GIMT_Encode4(2038981), // Rule ID 15162 //
     /* 2038895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2038898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2038909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2038912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2038915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2038918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2038921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2038925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2038933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2038937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2038941 */     // MIs[0] round
     /* 2038941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2038944 */     // MIs[0] policy
     /* 2038944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2038947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2038954 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2038954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2038957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2038959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2038961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2038963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2038965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2038967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2038969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2038974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2038977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2038979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2038980 */     // GIR_Coverage, 15162,
     /* 2038980 */     GIR_EraseRootFromParent_Done,
     /* 2038981 */   // Label 27139: @2038981
     /* 2038981 */   GIM_Try, /*On fail goto*//*Label 27140*/ GIMT_Encode4(2039072), // Rule ID 15163 //
     /* 2038986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2038989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasubu_mask),
     /* 2038994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2038997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2039000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2039003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2039006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2039009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2039016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2039024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2039028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039032 */     // MIs[0] round
     /* 2039032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039035 */     // MIs[0] policy
     /* 2039035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039045 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11094:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUBU_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUBU_VX_M8_MASK),
     /* 2039048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039050 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2039068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039071 */     // GIR_Coverage, 15163,
     /* 2039071 */     GIR_EraseRootFromParent_Done,
     /* 2039072 */   // Label 27140: @2039072
     /* 2039072 */   GIM_Try, /*On fail goto*//*Label 27141*/ GIMT_Encode4(2039163), // Rule ID 15166 //
     /* 2039077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2039088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2039091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2039094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2039097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039123 */     // MIs[0] round
     /* 2039123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039126 */     // MIs[0] policy
     /* 2039126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039136 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2039139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039141 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039162 */     // GIR_Coverage, 15166,
     /* 2039162 */     GIR_EraseRootFromParent_Done,
     /* 2039163 */   // Label 27141: @2039163
     /* 2039163 */   GIM_Try, /*On fail goto*//*Label 27142*/ GIMT_Encode4(2039254), // Rule ID 15167 //
     /* 2039168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2039179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2039182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2039185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2039188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039214 */     // MIs[0] round
     /* 2039214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039217 */     // MIs[0] policy
     /* 2039217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039227 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF8_MASK),
     /* 2039230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039232 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039253 */     // GIR_Coverage, 15167,
     /* 2039253 */     GIR_EraseRootFromParent_Done,
     /* 2039254 */   // Label 27142: @2039254
     /* 2039254 */   GIM_Try, /*On fail goto*//*Label 27143*/ GIMT_Encode4(2039345), // Rule ID 15170 //
     /* 2039259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2039279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039305 */     // MIs[0] round
     /* 2039305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039308 */     // MIs[0] policy
     /* 2039308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039318 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2039321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039323 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039344 */     // GIR_Coverage, 15170,
     /* 2039344 */     GIR_EraseRootFromParent_Done,
     /* 2039345 */   // Label 27143: @2039345
     /* 2039345 */   GIM_Try, /*On fail goto*//*Label 27144*/ GIMT_Encode4(2039436), // Rule ID 15171 //
     /* 2039350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2039361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2039364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2039367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2039370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039396 */     // MIs[0] round
     /* 2039396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039399 */     // MIs[0] policy
     /* 2039399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039409 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2039412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039414 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039435 */     // GIR_Coverage, 15171,
     /* 2039435 */     GIR_EraseRootFromParent_Done,
     /* 2039436 */   // Label 27144: @2039436
     /* 2039436 */   GIM_Try, /*On fail goto*//*Label 27145*/ GIMT_Encode4(2039527), // Rule ID 15174 //
     /* 2039441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2039461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039487 */     // MIs[0] round
     /* 2039487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039490 */     // MIs[0] policy
     /* 2039490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039500 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2039503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039505 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039526 */     // GIR_Coverage, 15174,
     /* 2039526 */     GIR_EraseRootFromParent_Done,
     /* 2039527 */   // Label 27145: @2039527
     /* 2039527 */   GIM_Try, /*On fail goto*//*Label 27146*/ GIMT_Encode4(2039618), // Rule ID 15175 //
     /* 2039532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2039543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2039546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2039549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2039552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2039555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039578 */     // MIs[0] round
     /* 2039578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039581 */     // MIs[0] policy
     /* 2039581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039591 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2039594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039596 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2039614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039617 */     // GIR_Coverage, 15175,
     /* 2039617 */     GIR_EraseRootFromParent_Done,
     /* 2039618 */   // Label 27146: @2039618
     /* 2039618 */   GIM_Try, /*On fail goto*//*Label 27147*/ GIMT_Encode4(2039709), // Rule ID 15178 //
     /* 2039623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2039643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039669 */     // MIs[0] round
     /* 2039669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039672 */     // MIs[0] policy
     /* 2039672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039682 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2039685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039687 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039708 */     // GIR_Coverage, 15178,
     /* 2039708 */     GIR_EraseRootFromParent_Done,
     /* 2039709 */   // Label 27147: @2039709
     /* 2039709 */   GIM_Try, /*On fail goto*//*Label 27148*/ GIMT_Encode4(2039800), // Rule ID 15179 //
     /* 2039714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2039725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2039728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2039731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2039734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2039737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039760 */     // MIs[0] round
     /* 2039760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039763 */     // MIs[0] policy
     /* 2039763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039773 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF4_MASK),
     /* 2039776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039778 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039799 */     // GIR_Coverage, 15179,
     /* 2039799 */     GIR_EraseRootFromParent_Done,
     /* 2039800 */   // Label 27148: @2039800
     /* 2039800 */   GIM_Try, /*On fail goto*//*Label 27149*/ GIMT_Encode4(2039891), // Rule ID 15182 //
     /* 2039805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2039825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2039831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039851 */     // MIs[0] round
     /* 2039851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039854 */     // MIs[0] policy
     /* 2039854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039864 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2039864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2039867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039869 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039890 */     // GIR_Coverage, 15182,
     /* 2039890 */     GIR_EraseRootFromParent_Done,
     /* 2039891 */   // Label 27149: @2039891
     /* 2039891 */   GIM_Try, /*On fail goto*//*Label 27150*/ GIMT_Encode4(2039982), // Rule ID 15183 //
     /* 2039896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2039899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2039907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2039910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2039913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2039916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2039919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2039922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2039926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2039938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2039942 */     // MIs[0] round
     /* 2039942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2039945 */     // MIs[0] policy
     /* 2039945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2039948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2039955 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2039955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2039958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2039960 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2039962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2039964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2039966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2039968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2039970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2039975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2039978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2039980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2039981 */     // GIR_Coverage, 15183,
     /* 2039981 */     GIR_EraseRootFromParent_Done,
     /* 2039982 */   // Label 27150: @2039982
     /* 2039982 */   GIM_Try, /*On fail goto*//*Label 27151*/ GIMT_Encode4(2040073), // Rule ID 15186 //
     /* 2039987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2039990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2039995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2039998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2040007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040033 */     // MIs[0] round
     /* 2040033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040036 */     // MIs[0] policy
     /* 2040036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040046 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2040049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040072 */     // GIR_Coverage, 15186,
     /* 2040072 */     GIR_EraseRootFromParent_Done,
     /* 2040073 */   // Label 27151: @2040073
     /* 2040073 */   GIM_Try, /*On fail goto*//*Label 27152*/ GIMT_Encode4(2040164), // Rule ID 15187 //
     /* 2040078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2040089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2040092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2040095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2040098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040124 */     // MIs[0] round
     /* 2040124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040127 */     // MIs[0] policy
     /* 2040127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040137 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_MF2_MASK),
     /* 2040140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040142 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040163 */     // GIR_Coverage, 15187,
     /* 2040163 */     GIR_EraseRootFromParent_Done,
     /* 2040164 */   // Label 27152: @2040164
     /* 2040164 */   GIM_Try, /*On fail goto*//*Label 27153*/ GIMT_Encode4(2040255), // Rule ID 15190 //
     /* 2040169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2040180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2040183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2040186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2040189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040215 */     // MIs[0] round
     /* 2040215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040218 */     // MIs[0] policy
     /* 2040218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040228 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040254 */     // GIR_Coverage, 15190,
     /* 2040254 */     GIR_EraseRootFromParent_Done,
     /* 2040255 */   // Label 27153: @2040255
     /* 2040255 */   GIM_Try, /*On fail goto*//*Label 27154*/ GIMT_Encode4(2040346), // Rule ID 15191 //
     /* 2040260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2040271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2040274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2040277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2040280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2040283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040306 */     // MIs[0] round
     /* 2040306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040309 */     // MIs[0] policy
     /* 2040309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040319 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040324 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040345 */     // GIR_Coverage, 15191,
     /* 2040345 */     GIR_EraseRootFromParent_Done,
     /* 2040346 */   // Label 27154: @2040346
     /* 2040346 */   GIM_Try, /*On fail goto*//*Label 27155*/ GIMT_Encode4(2040437), // Rule ID 15194 //
     /* 2040351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2040371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040397 */     // MIs[0] round
     /* 2040397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040400 */     // MIs[0] policy
     /* 2040400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040410 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040415 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040436 */     // GIR_Coverage, 15194,
     /* 2040436 */     GIR_EraseRootFromParent_Done,
     /* 2040437 */   // Label 27155: @2040437
     /* 2040437 */   GIM_Try, /*On fail goto*//*Label 27156*/ GIMT_Encode4(2040528), // Rule ID 15195 //
     /* 2040442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2040453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2040456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2040459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2040462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2040465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040488 */     // MIs[0] round
     /* 2040488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040491 */     // MIs[0] policy
     /* 2040491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040501 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040506 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2040524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040527 */     // GIR_Coverage, 15195,
     /* 2040527 */     GIR_EraseRootFromParent_Done,
     /* 2040528 */   // Label 27156: @2040528
     /* 2040528 */   GIM_Try, /*On fail goto*//*Label 27157*/ GIMT_Encode4(2040619), // Rule ID 15198 //
     /* 2040533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2040553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040579 */     // MIs[0] round
     /* 2040579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040582 */     // MIs[0] policy
     /* 2040582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040592 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040618 */     // GIR_Coverage, 15198,
     /* 2040618 */     GIR_EraseRootFromParent_Done,
     /* 2040619 */   // Label 27157: @2040619
     /* 2040619 */   GIM_Try, /*On fail goto*//*Label 27158*/ GIMT_Encode4(2040710), // Rule ID 15199 //
     /* 2040624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2040635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2040638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2040641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2040644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2040647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040670 */     // MIs[0] round
     /* 2040670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040673 */     // MIs[0] policy
     /* 2040673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040683 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040688 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2040706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040709 */     // GIR_Coverage, 15199,
     /* 2040709 */     GIR_EraseRootFromParent_Done,
     /* 2040710 */   // Label 27158: @2040710
     /* 2040710 */   GIM_Try, /*On fail goto*//*Label 27159*/ GIMT_Encode4(2040801), // Rule ID 15202 //
     /* 2040715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2040718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2040735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040761 */     // MIs[0] round
     /* 2040761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040764 */     // MIs[0] policy
     /* 2040764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040774 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040779 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040800 */     // GIR_Coverage, 15202,
     /* 2040800 */     GIR_EraseRootFromParent_Done,
     /* 2040801 */   // Label 27159: @2040801
     /* 2040801 */   GIM_Try, /*On fail goto*//*Label 27160*/ GIMT_Encode4(2040892), // Rule ID 15203 //
     /* 2040806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2040809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2040817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2040820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2040823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2040826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2040829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2040832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2040836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2040848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040852 */     // MIs[0] round
     /* 2040852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040855 */     // MIs[0] policy
     /* 2040855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040865 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2040865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M1_MASK),
     /* 2040868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040870 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2040888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040891 */     // GIR_Coverage, 15203,
     /* 2040891 */     GIR_EraseRootFromParent_Done,
     /* 2040892 */   // Label 27160: @2040892
     /* 2040892 */   GIM_Try, /*On fail goto*//*Label 27161*/ GIMT_Encode4(2040983), // Rule ID 15206 //
     /* 2040897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2040900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2040911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2040914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2040917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2040920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2040923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2040927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2040939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2040943 */     // MIs[0] round
     /* 2040943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2040946 */     // MIs[0] policy
     /* 2040946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2040949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2040956 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2040956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2040959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2040961 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2040963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2040965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2040967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2040969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2040971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2040976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2040979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2040981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2040982 */     // GIR_Coverage, 15206,
     /* 2040982 */     GIR_EraseRootFromParent_Done,
     /* 2040983 */   // Label 27161: @2040983
     /* 2040983 */   GIM_Try, /*On fail goto*//*Label 27162*/ GIMT_Encode4(2041074), // Rule ID 15207 //
     /* 2040988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2040991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2040996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2040999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2041002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2041005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2041008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041034 */     // MIs[0] round
     /* 2041034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041037 */     // MIs[0] policy
     /* 2041037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2041050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041052 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041073 */     // GIR_Coverage, 15207,
     /* 2041073 */     GIR_EraseRootFromParent_Done,
     /* 2041074 */   // Label 27162: @2041074
     /* 2041074 */   GIM_Try, /*On fail goto*//*Label 27163*/ GIMT_Encode4(2041165), // Rule ID 15210 //
     /* 2041079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2041090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2041093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2041096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2041099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041125 */     // MIs[0] round
     /* 2041125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041128 */     // MIs[0] policy
     /* 2041128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041138 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2041141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041143 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041164 */     // GIR_Coverage, 15210,
     /* 2041164 */     GIR_EraseRootFromParent_Done,
     /* 2041165 */   // Label 27163: @2041165
     /* 2041165 */   GIM_Try, /*On fail goto*//*Label 27164*/ GIMT_Encode4(2041256), // Rule ID 15211 //
     /* 2041170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2041181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2041184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2041187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2041190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041216 */     // MIs[0] round
     /* 2041216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041219 */     // MIs[0] policy
     /* 2041219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041229 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2041232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041234 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041255 */     // GIR_Coverage, 15211,
     /* 2041255 */     GIR_EraseRootFromParent_Done,
     /* 2041256 */   // Label 27164: @2041256
     /* 2041256 */   GIM_Try, /*On fail goto*//*Label 27165*/ GIMT_Encode4(2041347), // Rule ID 15214 //
     /* 2041261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2041281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041307 */     // MIs[0] round
     /* 2041307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041310 */     // MIs[0] policy
     /* 2041310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041320 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2041323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041346 */     // GIR_Coverage, 15214,
     /* 2041346 */     GIR_EraseRootFromParent_Done,
     /* 2041347 */   // Label 27165: @2041347
     /* 2041347 */   GIM_Try, /*On fail goto*//*Label 27166*/ GIMT_Encode4(2041438), // Rule ID 15215 //
     /* 2041352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2041363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2041366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2041369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2041372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2041375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041398 */     // MIs[0] round
     /* 2041398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041401 */     // MIs[0] policy
     /* 2041401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041411 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2041414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041416 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2041434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041437 */     // GIR_Coverage, 15215,
     /* 2041437 */     GIR_EraseRootFromParent_Done,
     /* 2041438 */   // Label 27166: @2041438
     /* 2041438 */   GIM_Try, /*On fail goto*//*Label 27167*/ GIMT_Encode4(2041529), // Rule ID 15218 //
     /* 2041443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2041463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041489 */     // MIs[0] round
     /* 2041489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041492 */     // MIs[0] policy
     /* 2041492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2041505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041528 */     // GIR_Coverage, 15218,
     /* 2041528 */     GIR_EraseRootFromParent_Done,
     /* 2041529 */   // Label 27167: @2041529
     /* 2041529 */   GIM_Try, /*On fail goto*//*Label 27168*/ GIMT_Encode4(2041620), // Rule ID 15219 //
     /* 2041534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2041545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2041548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2041551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2041554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2041557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2041564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2041576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041580 */     // MIs[0] round
     /* 2041580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041583 */     // MIs[0] policy
     /* 2041583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2041596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041598 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041619 */     // GIR_Coverage, 15219,
     /* 2041619 */     GIR_EraseRootFromParent_Done,
     /* 2041620 */   // Label 27168: @2041620
     /* 2041620 */   GIM_Try, /*On fail goto*//*Label 27169*/ GIMT_Encode4(2041711), // Rule ID 15222 //
     /* 2041625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2041645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041671 */     // MIs[0] round
     /* 2041671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041674 */     // MIs[0] policy
     /* 2041674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041684 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2041687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041689 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041710 */     // GIR_Coverage, 15222,
     /* 2041710 */     GIR_EraseRootFromParent_Done,
     /* 2041711 */   // Label 27169: @2041711
     /* 2041711 */   GIM_Try, /*On fail goto*//*Label 27170*/ GIMT_Encode4(2041802), // Rule ID 15223 //
     /* 2041716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2041727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2041730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2041733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2041736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2041739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2041746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2041758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041762 */     // MIs[0] round
     /* 2041762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041765 */     // MIs[0] policy
     /* 2041765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041775 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2041778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041780 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041801 */     // GIR_Coverage, 15223,
     /* 2041801 */     GIR_EraseRootFromParent_Done,
     /* 2041802 */   // Label 27170: @2041802
     /* 2041802 */   GIM_Try, /*On fail goto*//*Label 27171*/ GIMT_Encode4(2041893), // Rule ID 15226 //
     /* 2041807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2041827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2041833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041853 */     // MIs[0] round
     /* 2041853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041856 */     // MIs[0] policy
     /* 2041856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041866 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2041866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2041869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041892 */     // GIR_Coverage, 15226,
     /* 2041892 */     GIR_EraseRootFromParent_Done,
     /* 2041893 */   // Label 27171: @2041893
     /* 2041893 */   GIM_Try, /*On fail goto*//*Label 27172*/ GIMT_Encode4(2041984), // Rule ID 15227 //
     /* 2041898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2041901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2041909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2041912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2041915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2041918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2041921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2041924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2041928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2041940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2041944 */     // MIs[0] round
     /* 2041944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2041947 */     // MIs[0] policy
     /* 2041947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2041950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2041957 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2041957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2041960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2041962 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2041964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2041966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2041968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2041970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2041972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2041977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2041980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2041982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2041983 */     // GIR_Coverage, 15227,
     /* 2041983 */     GIR_EraseRootFromParent_Done,
     /* 2041984 */   // Label 27172: @2041984
     /* 2041984 */   GIM_Try, /*On fail goto*//*Label 27173*/ GIMT_Encode4(2042075), // Rule ID 15230 //
     /* 2041989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2041992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2041997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2042000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2042003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2042006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2042009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042035 */     // MIs[0] round
     /* 2042035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042038 */     // MIs[0] policy
     /* 2042038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2042051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042074 */     // GIR_Coverage, 15230,
     /* 2042074 */     GIR_EraseRootFromParent_Done,
     /* 2042075 */   // Label 27173: @2042075
     /* 2042075 */   GIM_Try, /*On fail goto*//*Label 27174*/ GIMT_Encode4(2042166), // Rule ID 15231 //
     /* 2042080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2042091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2042094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2042097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2042100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042126 */     // MIs[0] round
     /* 2042126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042129 */     // MIs[0] policy
     /* 2042129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042139 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2042142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042144 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042165 */     // GIR_Coverage, 15231,
     /* 2042165 */     GIR_EraseRootFromParent_Done,
     /* 2042166 */   // Label 27174: @2042166
     /* 2042166 */   GIM_Try, /*On fail goto*//*Label 27175*/ GIMT_Encode4(2042257), // Rule ID 15234 //
     /* 2042171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2042182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2042185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2042188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2042191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042217 */     // MIs[0] round
     /* 2042217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042220 */     // MIs[0] policy
     /* 2042220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042230 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2042233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042235 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042256 */     // GIR_Coverage, 15234,
     /* 2042256 */     GIR_EraseRootFromParent_Done,
     /* 2042257 */   // Label 27175: @2042257
     /* 2042257 */   GIM_Try, /*On fail goto*//*Label 27176*/ GIMT_Encode4(2042348), // Rule ID 15235 //
     /* 2042262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2042273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2042276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2042279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2042282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042308 */     // MIs[0] round
     /* 2042308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042311 */     // MIs[0] policy
     /* 2042311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042321 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2042324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042326 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042347 */     // GIR_Coverage, 15235,
     /* 2042347 */     GIR_EraseRootFromParent_Done,
     /* 2042348 */   // Label 27176: @2042348
     /* 2042348 */   GIM_Try, /*On fail goto*//*Label 27177*/ GIMT_Encode4(2042439), // Rule ID 15238 //
     /* 2042353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2042356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2042373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042399 */     // MIs[0] round
     /* 2042399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042402 */     // MIs[0] policy
     /* 2042402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042412 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2042415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042417 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042438 */     // GIR_Coverage, 15238,
     /* 2042438 */     GIR_EraseRootFromParent_Done,
     /* 2042439 */   // Label 27177: @2042439
     /* 2042439 */   GIM_Try, /*On fail goto*//*Label 27178*/ GIMT_Encode4(2042530), // Rule ID 15239 //
     /* 2042444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2042447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2042455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2042458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2042461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2042464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2042467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042490 */     // MIs[0] round
     /* 2042490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042493 */     // MIs[0] policy
     /* 2042493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042503 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2042506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042508 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2042526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042529 */     // GIR_Coverage, 15239,
     /* 2042529 */     GIR_EraseRootFromParent_Done,
     /* 2042530 */   // Label 27178: @2042530
     /* 2042530 */   GIM_Try, /*On fail goto*//*Label 27179*/ GIMT_Encode4(2042621), // Rule ID 15242 //
     /* 2042535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2042555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042581 */     // MIs[0] round
     /* 2042581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042584 */     // MIs[0] policy
     /* 2042584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042594 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2042597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042599 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042620 */     // GIR_Coverage, 15242,
     /* 2042620 */     GIR_EraseRootFromParent_Done,
     /* 2042621 */   // Label 27179: @2042621
     /* 2042621 */   GIM_Try, /*On fail goto*//*Label 27180*/ GIMT_Encode4(2042712), // Rule ID 15243 //
     /* 2042626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2042637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2042640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2042643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2042646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2042649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2042656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2042668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042672 */     // MIs[0] round
     /* 2042672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042675 */     // MIs[0] policy
     /* 2042675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042685 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M2_MASK),
     /* 2042688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042690 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042711 */     // GIR_Coverage, 15243,
     /* 2042711 */     GIR_EraseRootFromParent_Done,
     /* 2042712 */   // Label 27180: @2042712
     /* 2042712 */   GIM_Try, /*On fail goto*//*Label 27181*/ GIMT_Encode4(2042803), // Rule ID 15246 //
     /* 2042717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2042737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042763 */     // MIs[0] round
     /* 2042763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042766 */     // MIs[0] policy
     /* 2042766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042776 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2042779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042781 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042802 */     // GIR_Coverage, 15246,
     /* 2042802 */     GIR_EraseRootFromParent_Done,
     /* 2042803 */   // Label 27181: @2042803
     /* 2042803 */   GIM_Try, /*On fail goto*//*Label 27182*/ GIMT_Encode4(2042894), // Rule ID 15247 //
     /* 2042808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2042819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2042822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2042825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2042828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2042831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2042834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2042838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2042850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042854 */     // MIs[0] round
     /* 2042854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042857 */     // MIs[0] policy
     /* 2042857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042867 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2042867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M4_MASK),
     /* 2042870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042872 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042893 */     // GIR_Coverage, 15247,
     /* 2042893 */     GIR_EraseRootFromParent_Done,
     /* 2042894 */   // Label 27182: @2042894
     /* 2042894 */   GIM_Try, /*On fail goto*//*Label 27183*/ GIMT_Encode4(2042985), // Rule ID 15250 //
     /* 2042899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2042902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2042910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2042913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2042916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2042919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2042922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2042925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2042929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2042941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2042945 */     // MIs[0] round
     /* 2042945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2042948 */     // MIs[0] policy
     /* 2042948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2042951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2042958 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2042958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2042961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2042963 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2042965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2042967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2042969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2042971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2042973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2042978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2042981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2042983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042984 */     // GIR_Coverage, 15250,
     /* 2042984 */     GIR_EraseRootFromParent_Done,
     /* 2042985 */   // Label 27183: @2042985
     /* 2042985 */   GIM_Try, /*On fail goto*//*Label 27184*/ GIMT_Encode4(2043076), // Rule ID 15251 //
     /* 2042990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2042993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2042998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2043001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2043004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2043007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2043010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2043013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2043020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2043032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043036 */     // MIs[0] round
     /* 2043036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043039 */     // MIs[0] policy
     /* 2043039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043049 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VV_M8_MASK),
     /* 2043052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043054 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2043072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043075 */     // GIR_Coverage, 15251,
     /* 2043075 */     GIR_EraseRootFromParent_Done,
     /* 2043076 */   // Label 27184: @2043076
     /* 2043076 */   GIM_Try, /*On fail goto*//*Label 27185*/ GIMT_Encode4(2043167), // Rule ID 15254 //
     /* 2043081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2043092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2043095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2043098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043127 */     // MIs[0] round
     /* 2043127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043130 */     // MIs[0] policy
     /* 2043130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043140 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2043143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043166 */     // GIR_Coverage, 15254,
     /* 2043166 */     GIR_EraseRootFromParent_Done,
     /* 2043167 */   // Label 27185: @2043167
     /* 2043167 */   GIM_Try, /*On fail goto*//*Label 27186*/ GIMT_Encode4(2043258), // Rule ID 15255 //
     /* 2043172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2043183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2043186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2043189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043218 */     // MIs[0] round
     /* 2043218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043221 */     // MIs[0] policy
     /* 2043221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043231 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF8_MASK),
     /* 2043234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043236 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043257 */     // GIR_Coverage, 15255,
     /* 2043257 */     GIR_EraseRootFromParent_Done,
     /* 2043258 */   // Label 27186: @2043258
     /* 2043258 */   GIM_Try, /*On fail goto*//*Label 27187*/ GIMT_Encode4(2043349), // Rule ID 15258 //
     /* 2043263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043309 */     // MIs[0] round
     /* 2043309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043312 */     // MIs[0] policy
     /* 2043312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043322 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2043325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043348 */     // GIR_Coverage, 15258,
     /* 2043348 */     GIR_EraseRootFromParent_Done,
     /* 2043349 */   // Label 27187: @2043349
     /* 2043349 */   GIM_Try, /*On fail goto*//*Label 27188*/ GIMT_Encode4(2043440), // Rule ID 15259 //
     /* 2043354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2043365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2043368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2043371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043400 */     // MIs[0] round
     /* 2043400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043403 */     // MIs[0] policy
     /* 2043403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043413 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2043416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043418 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043439 */     // GIR_Coverage, 15259,
     /* 2043439 */     GIR_EraseRootFromParent_Done,
     /* 2043440 */   // Label 27188: @2043440
     /* 2043440 */   GIM_Try, /*On fail goto*//*Label 27189*/ GIMT_Encode4(2043531), // Rule ID 15262 //
     /* 2043445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043491 */     // MIs[0] round
     /* 2043491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043494 */     // MIs[0] policy
     /* 2043494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043504 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2043507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043509 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043530 */     // GIR_Coverage, 15262,
     /* 2043530 */     GIR_EraseRootFromParent_Done,
     /* 2043531 */   // Label 27189: @2043531
     /* 2043531 */   GIM_Try, /*On fail goto*//*Label 27190*/ GIMT_Encode4(2043622), // Rule ID 15263 //
     /* 2043536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2043547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2043550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2043553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2043559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043582 */     // MIs[0] round
     /* 2043582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043585 */     // MIs[0] policy
     /* 2043585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043595 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2043598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043600 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2043618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043621 */     // GIR_Coverage, 15263,
     /* 2043621 */     GIR_EraseRootFromParent_Done,
     /* 2043622 */   // Label 27190: @2043622
     /* 2043622 */   GIM_Try, /*On fail goto*//*Label 27191*/ GIMT_Encode4(2043713), // Rule ID 15266 //
     /* 2043627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043673 */     // MIs[0] round
     /* 2043673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043676 */     // MIs[0] policy
     /* 2043676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043686 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2043689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043712 */     // GIR_Coverage, 15266,
     /* 2043712 */     GIR_EraseRootFromParent_Done,
     /* 2043713 */   // Label 27191: @2043713
     /* 2043713 */   GIM_Try, /*On fail goto*//*Label 27192*/ GIMT_Encode4(2043804), // Rule ID 15267 //
     /* 2043718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2043729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2043732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2043735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2043741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043764 */     // MIs[0] round
     /* 2043764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043767 */     // MIs[0] policy
     /* 2043767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043777 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF4_MASK),
     /* 2043780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043782 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043803 */     // GIR_Coverage, 15267,
     /* 2043803 */     GIR_EraseRootFromParent_Done,
     /* 2043804 */   // Label 27192: @2043804
     /* 2043804 */   GIM_Try, /*On fail goto*//*Label 27193*/ GIMT_Encode4(2043895), // Rule ID 15270 //
     /* 2043809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2043829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2043835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043855 */     // MIs[0] round
     /* 2043855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043858 */     // MIs[0] policy
     /* 2043858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043868 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2043868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2043871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043873 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043894 */     // GIR_Coverage, 15270,
     /* 2043894 */     GIR_EraseRootFromParent_Done,
     /* 2043895 */   // Label 27193: @2043895
     /* 2043895 */   GIM_Try, /*On fail goto*//*Label 27194*/ GIMT_Encode4(2043986), // Rule ID 15271 //
     /* 2043900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2043903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2043911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2043914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2043917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2043920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2043923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2043926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2043930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2043938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2043942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2043946 */     // MIs[0] round
     /* 2043946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2043949 */     // MIs[0] policy
     /* 2043949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2043952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2043959 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2043959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2043962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2043964 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2043966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2043968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2043970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2043972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2043974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2043979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2043982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2043984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2043985 */     // GIR_Coverage, 15271,
     /* 2043985 */     GIR_EraseRootFromParent_Done,
     /* 2043986 */   // Label 27194: @2043986
     /* 2043986 */   GIM_Try, /*On fail goto*//*Label 27195*/ GIMT_Encode4(2044077), // Rule ID 15274 //
     /* 2043991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2043994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2043999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2044002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2044005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2044008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044037 */     // MIs[0] round
     /* 2044037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044040 */     // MIs[0] policy
     /* 2044040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044050 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2044053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044055 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044076 */     // GIR_Coverage, 15274,
     /* 2044076 */     GIR_EraseRootFromParent_Done,
     /* 2044077 */   // Label 27195: @2044077
     /* 2044077 */   GIM_Try, /*On fail goto*//*Label 27196*/ GIMT_Encode4(2044168), // Rule ID 15275 //
     /* 2044082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2044093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2044096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2044099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044128 */     // MIs[0] round
     /* 2044128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044131 */     // MIs[0] policy
     /* 2044131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044141 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_MF2_MASK),
     /* 2044144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044146 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044167 */     // GIR_Coverage, 15275,
     /* 2044167 */     GIR_EraseRootFromParent_Done,
     /* 2044168 */   // Label 27196: @2044168
     /* 2044168 */   GIM_Try, /*On fail goto*//*Label 27197*/ GIMT_Encode4(2044259), // Rule ID 15278 //
     /* 2044173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2044184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2044187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2044190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044219 */     // MIs[0] round
     /* 2044219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044222 */     // MIs[0] policy
     /* 2044222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044232 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044237 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044258 */     // GIR_Coverage, 15278,
     /* 2044258 */     GIR_EraseRootFromParent_Done,
     /* 2044259 */   // Label 27197: @2044259
     /* 2044259 */   GIM_Try, /*On fail goto*//*Label 27198*/ GIMT_Encode4(2044350), // Rule ID 15279 //
     /* 2044264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2044275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2044278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2044281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2044287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044310 */     // MIs[0] round
     /* 2044310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044313 */     // MIs[0] policy
     /* 2044313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044323 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11092:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044328 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044349 */     // GIR_Coverage, 15279,
     /* 2044349 */     GIR_EraseRootFromParent_Done,
     /* 2044350 */   // Label 27198: @2044350
     /* 2044350 */   GIM_Try, /*On fail goto*//*Label 27199*/ GIMT_Encode4(2044441), // Rule ID 15282 //
     /* 2044355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044401 */     // MIs[0] round
     /* 2044401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044404 */     // MIs[0] policy
     /* 2044404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044414 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044440 */     // GIR_Coverage, 15282,
     /* 2044440 */     GIR_EraseRootFromParent_Done,
     /* 2044441 */   // Label 27199: @2044441
     /* 2044441 */   GIM_Try, /*On fail goto*//*Label 27200*/ GIMT_Encode4(2044532), // Rule ID 15283 //
     /* 2044446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2044457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2044460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2044463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2044469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044492 */     // MIs[0] round
     /* 2044492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044495 */     // MIs[0] policy
     /* 2044495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044505 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11092:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044510 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2044528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044531 */     // GIR_Coverage, 15283,
     /* 2044531 */     GIR_EraseRootFromParent_Done,
     /* 2044532 */   // Label 27200: @2044532
     /* 2044532 */   GIM_Try, /*On fail goto*//*Label 27201*/ GIMT_Encode4(2044623), // Rule ID 15286 //
     /* 2044537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044583 */     // MIs[0] round
     /* 2044583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044586 */     // MIs[0] policy
     /* 2044586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044596 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044622 */     // GIR_Coverage, 15286,
     /* 2044622 */     GIR_EraseRootFromParent_Done,
     /* 2044623 */   // Label 27201: @2044623
     /* 2044623 */   GIM_Try, /*On fail goto*//*Label 27202*/ GIMT_Encode4(2044714), // Rule ID 15287 //
     /* 2044628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2044639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2044642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2044645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2044651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044674 */     // MIs[0] round
     /* 2044674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044677 */     // MIs[0] policy
     /* 2044677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044687 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11092:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044692 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2044710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044713 */     // GIR_Coverage, 15287,
     /* 2044713 */     GIR_EraseRootFromParent_Done,
     /* 2044714 */   // Label 27202: @2044714
     /* 2044714 */   GIM_Try, /*On fail goto*//*Label 27203*/ GIMT_Encode4(2044805), // Rule ID 15290 //
     /* 2044719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2044722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044765 */     // MIs[0] round
     /* 2044765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044768 */     // MIs[0] policy
     /* 2044768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044778 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044783 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044804 */     // GIR_Coverage, 15290,
     /* 2044804 */     GIR_EraseRootFromParent_Done,
     /* 2044805 */   // Label 27203: @2044805
     /* 2044805 */   GIM_Try, /*On fail goto*//*Label 27204*/ GIMT_Encode4(2044896), // Rule ID 15291 //
     /* 2044810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2044813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2044821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2044824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2044827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2044830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2044833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2044836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2044840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2044848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044856 */     // MIs[0] round
     /* 2044856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044859 */     // MIs[0] policy
     /* 2044859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044869 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11092:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2044869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M1_MASK),
     /* 2044872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044874 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2044892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044895 */     // GIR_Coverage, 15291,
     /* 2044895 */     GIR_EraseRootFromParent_Done,
     /* 2044896 */   // Label 27204: @2044896
     /* 2044896 */   GIM_Try, /*On fail goto*//*Label 27205*/ GIMT_Encode4(2044987), // Rule ID 15294 //
     /* 2044901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2044904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2044909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2044912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2044915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2044918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2044921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2044924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2044927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2044931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2044939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2044943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2044947 */     // MIs[0] round
     /* 2044947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2044950 */     // MIs[0] policy
     /* 2044950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2044953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2044960 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2044960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2044963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2044965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2044967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2044969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2044971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2044973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2044975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2044980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2044983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2044985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2044986 */     // GIR_Coverage, 15294,
     /* 2044986 */     GIR_EraseRootFromParent_Done,
     /* 2044987 */   // Label 27205: @2044987
     /* 2044987 */   GIM_Try, /*On fail goto*//*Label 27206*/ GIMT_Encode4(2045078), // Rule ID 15295 //
     /* 2044992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2044995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2045003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2045006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2045009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045038 */     // MIs[0] round
     /* 2045038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045041 */     // MIs[0] policy
     /* 2045041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045051 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2045054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045056 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045077 */     // GIR_Coverage, 15295,
     /* 2045077 */     GIR_EraseRootFromParent_Done,
     /* 2045078 */   // Label 27206: @2045078
     /* 2045078 */   GIM_Try, /*On fail goto*//*Label 27207*/ GIMT_Encode4(2045169), // Rule ID 15298 //
     /* 2045083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2045094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2045097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2045100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045129 */     // MIs[0] round
     /* 2045129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045132 */     // MIs[0] policy
     /* 2045132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045142 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2045145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045168 */     // GIR_Coverage, 15298,
     /* 2045168 */     GIR_EraseRootFromParent_Done,
     /* 2045169 */   // Label 27207: @2045169
     /* 2045169 */   GIM_Try, /*On fail goto*//*Label 27208*/ GIMT_Encode4(2045260), // Rule ID 15299 //
     /* 2045174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2045185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2045188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2045191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045220 */     // MIs[0] round
     /* 2045220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045223 */     // MIs[0] policy
     /* 2045223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045233 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2045236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045238 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045259 */     // GIR_Coverage, 15299,
     /* 2045259 */     GIR_EraseRootFromParent_Done,
     /* 2045260 */   // Label 27208: @2045260
     /* 2045260 */   GIM_Try, /*On fail goto*//*Label 27209*/ GIMT_Encode4(2045351), // Rule ID 15302 //
     /* 2045265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045311 */     // MIs[0] round
     /* 2045311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045314 */     // MIs[0] policy
     /* 2045314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045324 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2045327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045329 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045350 */     // GIR_Coverage, 15302,
     /* 2045350 */     GIR_EraseRootFromParent_Done,
     /* 2045351 */   // Label 27209: @2045351
     /* 2045351 */   GIM_Try, /*On fail goto*//*Label 27210*/ GIMT_Encode4(2045442), // Rule ID 15303 //
     /* 2045356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2045367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2045370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2045373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2045379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045402 */     // MIs[0] round
     /* 2045402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045405 */     // MIs[0] policy
     /* 2045405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045415 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2045418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045420 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2045438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045441 */     // GIR_Coverage, 15303,
     /* 2045441 */     GIR_EraseRootFromParent_Done,
     /* 2045442 */   // Label 27210: @2045442
     /* 2045442 */   GIM_Try, /*On fail goto*//*Label 27211*/ GIMT_Encode4(2045533), // Rule ID 15306 //
     /* 2045447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045493 */     // MIs[0] round
     /* 2045493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045496 */     // MIs[0] policy
     /* 2045496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045506 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2045509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045511 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045532 */     // GIR_Coverage, 15306,
     /* 2045532 */     GIR_EraseRootFromParent_Done,
     /* 2045533 */   // Label 27211: @2045533
     /* 2045533 */   GIM_Try, /*On fail goto*//*Label 27212*/ GIMT_Encode4(2045624), // Rule ID 15307 //
     /* 2045538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2045549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2045552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2045555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2045561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2045568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2045576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045584 */     // MIs[0] round
     /* 2045584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045587 */     // MIs[0] policy
     /* 2045587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045597 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2045600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045602 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045623 */     // GIR_Coverage, 15307,
     /* 2045623 */     GIR_EraseRootFromParent_Done,
     /* 2045624 */   // Label 27212: @2045624
     /* 2045624 */   GIM_Try, /*On fail goto*//*Label 27213*/ GIMT_Encode4(2045715), // Rule ID 15310 //
     /* 2045629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045675 */     // MIs[0] round
     /* 2045675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045678 */     // MIs[0] policy
     /* 2045678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045688 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2045691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045693 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045714 */     // GIR_Coverage, 15310,
     /* 2045714 */     GIR_EraseRootFromParent_Done,
     /* 2045715 */   // Label 27213: @2045715
     /* 2045715 */   GIM_Try, /*On fail goto*//*Label 27214*/ GIMT_Encode4(2045806), // Rule ID 15311 //
     /* 2045720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2045731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2045734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2045737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2045743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2045750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2045758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045766 */     // MIs[0] round
     /* 2045766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045769 */     // MIs[0] policy
     /* 2045769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045779 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2045782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045784 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045805 */     // GIR_Coverage, 15311,
     /* 2045805 */     GIR_EraseRootFromParent_Done,
     /* 2045806 */   // Label 27214: @2045806
     /* 2045806 */   GIM_Try, /*On fail goto*//*Label 27215*/ GIMT_Encode4(2045897), // Rule ID 15314 //
     /* 2045811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2045831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2045837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045857 */     // MIs[0] round
     /* 2045857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045860 */     // MIs[0] policy
     /* 2045860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045870 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2045870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2045873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045875 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045896 */     // GIR_Coverage, 15314,
     /* 2045896 */     GIR_EraseRootFromParent_Done,
     /* 2045897 */   // Label 27215: @2045897
     /* 2045897 */   GIM_Try, /*On fail goto*//*Label 27216*/ GIMT_Encode4(2045988), // Rule ID 15315 //
     /* 2045902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2045905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2045910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2045913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2045916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2045919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2045922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2045925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2045928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2045932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2045940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2045944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2045948 */     // MIs[0] round
     /* 2045948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2045951 */     // MIs[0] policy
     /* 2045951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2045954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2045961 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2045961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2045964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2045966 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2045968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2045970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2045972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2045974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2045976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2045981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2045984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2045986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2045987 */     // GIR_Coverage, 15315,
     /* 2045987 */     GIR_EraseRootFromParent_Done,
     /* 2045988 */   // Label 27216: @2045988
     /* 2045988 */   GIM_Try, /*On fail goto*//*Label 27217*/ GIMT_Encode4(2046079), // Rule ID 15318 //
     /* 2045993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2045996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2046004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2046007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2046010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046039 */     // MIs[0] round
     /* 2046039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046042 */     // MIs[0] policy
     /* 2046042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2046055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046057 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046078 */     // GIR_Coverage, 15318,
     /* 2046078 */     GIR_EraseRootFromParent_Done,
     /* 2046079 */   // Label 27217: @2046079
     /* 2046079 */   GIM_Try, /*On fail goto*//*Label 27218*/ GIMT_Encode4(2046170), // Rule ID 15319 //
     /* 2046084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2046095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2046098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2046101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046130 */     // MIs[0] round
     /* 2046130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046133 */     // MIs[0] policy
     /* 2046133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2046146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046148 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046169 */     // GIR_Coverage, 15319,
     /* 2046169 */     GIR_EraseRootFromParent_Done,
     /* 2046170 */   // Label 27218: @2046170
     /* 2046170 */   GIM_Try, /*On fail goto*//*Label 27219*/ GIMT_Encode4(2046261), // Rule ID 15322 //
     /* 2046175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2046186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2046189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2046192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046221 */     // MIs[0] round
     /* 2046221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046224 */     // MIs[0] policy
     /* 2046224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046234 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2046237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046260 */     // GIR_Coverage, 15322,
     /* 2046260 */     GIR_EraseRootFromParent_Done,
     /* 2046261 */   // Label 27219: @2046261
     /* 2046261 */   GIM_Try, /*On fail goto*//*Label 27220*/ GIMT_Encode4(2046352), // Rule ID 15323 //
     /* 2046266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2046277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2046280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2046283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046312 */     // MIs[0] round
     /* 2046312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046315 */     // MIs[0] policy
     /* 2046315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046325 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2046328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046330 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046351 */     // GIR_Coverage, 15323,
     /* 2046351 */     GIR_EraseRootFromParent_Done,
     /* 2046352 */   // Label 27220: @2046352
     /* 2046352 */   GIM_Try, /*On fail goto*//*Label 27221*/ GIMT_Encode4(2046443), // Rule ID 15326 //
     /* 2046357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2046360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046403 */     // MIs[0] round
     /* 2046403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046406 */     // MIs[0] policy
     /* 2046406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046416 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2046419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046442 */     // GIR_Coverage, 15326,
     /* 2046442 */     GIR_EraseRootFromParent_Done,
     /* 2046443 */   // Label 27221: @2046443
     /* 2046443 */   GIM_Try, /*On fail goto*//*Label 27222*/ GIMT_Encode4(2046534), // Rule ID 15327 //
     /* 2046448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2046451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2046459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2046462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2046465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2046471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046494 */     // MIs[0] round
     /* 2046494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046497 */     // MIs[0] policy
     /* 2046497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046507 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2046510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046512 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2046530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046533 */     // GIR_Coverage, 15327,
     /* 2046533 */     GIR_EraseRootFromParent_Done,
     /* 2046534 */   // Label 27222: @2046534
     /* 2046534 */   GIM_Try, /*On fail goto*//*Label 27223*/ GIMT_Encode4(2046625), // Rule ID 15330 //
     /* 2046539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046585 */     // MIs[0] round
     /* 2046585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046588 */     // MIs[0] policy
     /* 2046588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2046601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046603 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046624 */     // GIR_Coverage, 15330,
     /* 2046624 */     GIR_EraseRootFromParent_Done,
     /* 2046625 */   // Label 27223: @2046625
     /* 2046625 */   GIM_Try, /*On fail goto*//*Label 27224*/ GIMT_Encode4(2046716), // Rule ID 15331 //
     /* 2046630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2046641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2046644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2046647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2046653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2046660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2046668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046676 */     // MIs[0] round
     /* 2046676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046679 */     // MIs[0] policy
     /* 2046679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046689 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11092:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M2_MASK),
     /* 2046692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046694 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046715 */     // GIR_Coverage, 15331,
     /* 2046715 */     GIR_EraseRootFromParent_Done,
     /* 2046716 */   // Label 27224: @2046716
     /* 2046716 */   GIM_Try, /*On fail goto*//*Label 27225*/ GIMT_Encode4(2046807), // Rule ID 15334 //
     /* 2046721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046767 */     // MIs[0] round
     /* 2046767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046770 */     // MIs[0] policy
     /* 2046770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046780 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2046783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046806 */     // GIR_Coverage, 15334,
     /* 2046806 */     GIR_EraseRootFromParent_Done,
     /* 2046807 */   // Label 27225: @2046807
     /* 2046807 */   GIM_Try, /*On fail goto*//*Label 27226*/ GIMT_Encode4(2046898), // Rule ID 15335 //
     /* 2046812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2046823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2046826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2046829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2046832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2046835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2046838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2046842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2046850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046858 */     // MIs[0] round
     /* 2046858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046861 */     // MIs[0] policy
     /* 2046861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046871 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11092:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2046871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M4_MASK),
     /* 2046874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046876 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046897 */     // GIR_Coverage, 15335,
     /* 2046897 */     GIR_EraseRootFromParent_Done,
     /* 2046898 */   // Label 27226: @2046898
     /* 2046898 */   GIM_Try, /*On fail goto*//*Label 27227*/ GIMT_Encode4(2046989), // Rule ID 15338 //
     /* 2046903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2046906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2046911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2046914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2046917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2046920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2046923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2046926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2046929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2046933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2046941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2046945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2046949 */     // MIs[0] round
     /* 2046949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2046952 */     // MIs[0] policy
     /* 2046952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2046955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2046962 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2046962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2046965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2046967 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2046969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2046971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2046973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2046975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2046977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2046982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2046985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2046987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2046988 */     // GIR_Coverage, 15338,
     /* 2046988 */     GIR_EraseRootFromParent_Done,
     /* 2046989 */   // Label 27227: @2046989
     /* 2046989 */   GIM_Try, /*On fail goto*//*Label 27228*/ GIMT_Encode4(2047080), // Rule ID 15339 //
     /* 2046994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2046997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vasub_mask),
     /* 2047002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2047005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2047008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2047011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2047014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2047017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2047024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2047032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2047036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047040 */     // MIs[0] round
     /* 2047040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047043 */     // MIs[0] policy
     /* 2047043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047053 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11092:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVASUB_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVASUB_VX_M8_MASK),
     /* 2047056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047058 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2047076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047079 */     // GIR_Coverage, 15339,
     /* 2047079 */     GIR_EraseRootFromParent_Done,
     /* 2047080 */   // Label 27228: @2047080
     /* 2047080 */   GIM_Try, /*On fail goto*//*Label 27229*/ GIMT_Encode4(2047171), // Rule ID 15342 //
     /* 2047085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2047096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2047099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2047102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2047105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047131 */     // MIs[0] round
     /* 2047131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047134 */     // MIs[0] policy
     /* 2047134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047144 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2047147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047149 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047170 */     // GIR_Coverage, 15342,
     /* 2047170 */     GIR_EraseRootFromParent_Done,
     /* 2047171 */   // Label 27229: @2047171
     /* 2047171 */   GIM_Try, /*On fail goto*//*Label 27230*/ GIMT_Encode4(2047262), // Rule ID 15343 //
     /* 2047176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2047187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2047190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2047193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2047196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047222 */     // MIs[0] round
     /* 2047222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047225 */     // MIs[0] policy
     /* 2047225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047235 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF8_MASK),
     /* 2047238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047240 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047261 */     // GIR_Coverage, 15343,
     /* 2047261 */     GIR_EraseRootFromParent_Done,
     /* 2047262 */   // Label 27230: @2047262
     /* 2047262 */   GIM_Try, /*On fail goto*//*Label 27231*/ GIMT_Encode4(2047353), // Rule ID 15346 //
     /* 2047267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2047287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047313 */     // MIs[0] round
     /* 2047313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047316 */     // MIs[0] policy
     /* 2047316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047326 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2047329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047331 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047352 */     // GIR_Coverage, 15346,
     /* 2047352 */     GIR_EraseRootFromParent_Done,
     /* 2047353 */   // Label 27231: @2047353
     /* 2047353 */   GIM_Try, /*On fail goto*//*Label 27232*/ GIMT_Encode4(2047444), // Rule ID 15347 //
     /* 2047358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2047369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2047372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2047375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2047378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047404 */     // MIs[0] round
     /* 2047404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047407 */     // MIs[0] policy
     /* 2047407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047417 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2047420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047422 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047443 */     // GIR_Coverage, 15347,
     /* 2047443 */     GIR_EraseRootFromParent_Done,
     /* 2047444 */   // Label 27232: @2047444
     /* 2047444 */   GIM_Try, /*On fail goto*//*Label 27233*/ GIMT_Encode4(2047535), // Rule ID 15350 //
     /* 2047449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2047469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047495 */     // MIs[0] round
     /* 2047495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047498 */     // MIs[0] policy
     /* 2047498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047508 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2047511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047534 */     // GIR_Coverage, 15350,
     /* 2047534 */     GIR_EraseRootFromParent_Done,
     /* 2047535 */   // Label 27233: @2047535
     /* 2047535 */   GIM_Try, /*On fail goto*//*Label 27234*/ GIMT_Encode4(2047626), // Rule ID 15351 //
     /* 2047540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2047551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2047554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2047557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2047560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2047563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047586 */     // MIs[0] round
     /* 2047586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047589 */     // MIs[0] policy
     /* 2047589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047599 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2047602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047604 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2047622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047625 */     // GIR_Coverage, 15351,
     /* 2047625 */     GIR_EraseRootFromParent_Done,
     /* 2047626 */   // Label 27234: @2047626
     /* 2047626 */   GIM_Try, /*On fail goto*//*Label 27235*/ GIMT_Encode4(2047717), // Rule ID 15354 //
     /* 2047631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2047651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047677 */     // MIs[0] round
     /* 2047677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047680 */     // MIs[0] policy
     /* 2047680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047690 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2047693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047716 */     // GIR_Coverage, 15354,
     /* 2047716 */     GIR_EraseRootFromParent_Done,
     /* 2047717 */   // Label 27235: @2047717
     /* 2047717 */   GIM_Try, /*On fail goto*//*Label 27236*/ GIMT_Encode4(2047808), // Rule ID 15355 //
     /* 2047722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2047733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2047736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2047739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2047742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2047745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047768 */     // MIs[0] round
     /* 2047768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047771 */     // MIs[0] policy
     /* 2047771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047781 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF4_MASK),
     /* 2047784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047786 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047807 */     // GIR_Coverage, 15355,
     /* 2047807 */     GIR_EraseRootFromParent_Done,
     /* 2047808 */   // Label 27236: @2047808
     /* 2047808 */   GIM_Try, /*On fail goto*//*Label 27237*/ GIMT_Encode4(2047899), // Rule ID 15358 //
     /* 2047813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2047833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2047839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047859 */     // MIs[0] round
     /* 2047859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047862 */     // MIs[0] policy
     /* 2047862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047872 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2047872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2047875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047877 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047898 */     // GIR_Coverage, 15358,
     /* 2047898 */     GIR_EraseRootFromParent_Done,
     /* 2047899 */   // Label 27237: @2047899
     /* 2047899 */   GIM_Try, /*On fail goto*//*Label 27238*/ GIMT_Encode4(2047990), // Rule ID 15359 //
     /* 2047904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2047907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2047912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2047915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2047918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2047921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2047924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2047927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2047930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2047934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2047946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2047950 */     // MIs[0] round
     /* 2047950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2047953 */     // MIs[0] policy
     /* 2047953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2047956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2047963 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2047963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2047966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2047968 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2047970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2047972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2047974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2047976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2047978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2047983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2047986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2047988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2047989 */     // GIR_Coverage, 15359,
     /* 2047989 */     GIR_EraseRootFromParent_Done,
     /* 2047990 */   // Label 27238: @2047990
     /* 2047990 */   GIM_Try, /*On fail goto*//*Label 27239*/ GIMT_Encode4(2048081), // Rule ID 15362 //
     /* 2047995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2047998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2048012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2048015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048041 */     // MIs[0] round
     /* 2048041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048044 */     // MIs[0] policy
     /* 2048044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048054 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2048057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048080 */     // GIR_Coverage, 15362,
     /* 2048080 */     GIR_EraseRootFromParent_Done,
     /* 2048081 */   // Label 27239: @2048081
     /* 2048081 */   GIM_Try, /*On fail goto*//*Label 27240*/ GIMT_Encode4(2048172), // Rule ID 15363 //
     /* 2048086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2048097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2048100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2048103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2048106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048132 */     // MIs[0] round
     /* 2048132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048135 */     // MIs[0] policy
     /* 2048135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048145 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_MF2_MASK),
     /* 2048148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048150 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048171 */     // GIR_Coverage, 15363,
     /* 2048171 */     GIR_EraseRootFromParent_Done,
     /* 2048172 */   // Label 27240: @2048172
     /* 2048172 */   GIM_Try, /*On fail goto*//*Label 27241*/ GIMT_Encode4(2048263), // Rule ID 15366 //
     /* 2048177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2048188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2048191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2048194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2048197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048223 */     // MIs[0] round
     /* 2048223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048226 */     // MIs[0] policy
     /* 2048226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048236 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048262 */     // GIR_Coverage, 15366,
     /* 2048262 */     GIR_EraseRootFromParent_Done,
     /* 2048263 */   // Label 27241: @2048263
     /* 2048263 */   GIM_Try, /*On fail goto*//*Label 27242*/ GIMT_Encode4(2048354), // Rule ID 15367 //
     /* 2048268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2048279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2048282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2048285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2048288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2048291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048314 */     // MIs[0] round
     /* 2048314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048317 */     // MIs[0] policy
     /* 2048317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048327 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048332 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048353 */     // GIR_Coverage, 15367,
     /* 2048353 */     GIR_EraseRootFromParent_Done,
     /* 2048354 */   // Label 27242: @2048354
     /* 2048354 */   GIM_Try, /*On fail goto*//*Label 27243*/ GIMT_Encode4(2048445), // Rule ID 15370 //
     /* 2048359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2048379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048405 */     // MIs[0] round
     /* 2048405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048408 */     // MIs[0] policy
     /* 2048408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048418 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048423 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048444 */     // GIR_Coverage, 15370,
     /* 2048444 */     GIR_EraseRootFromParent_Done,
     /* 2048445 */   // Label 27243: @2048445
     /* 2048445 */   GIM_Try, /*On fail goto*//*Label 27244*/ GIMT_Encode4(2048536), // Rule ID 15371 //
     /* 2048450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2048461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2048464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2048467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2048470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2048473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048496 */     // MIs[0] round
     /* 2048496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048499 */     // MIs[0] policy
     /* 2048499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048509 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048514 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2048532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048535 */     // GIR_Coverage, 15371,
     /* 2048535 */     GIR_EraseRootFromParent_Done,
     /* 2048536 */   // Label 27244: @2048536
     /* 2048536 */   GIM_Try, /*On fail goto*//*Label 27245*/ GIMT_Encode4(2048627), // Rule ID 15374 //
     /* 2048541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2048561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048587 */     // MIs[0] round
     /* 2048587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048590 */     // MIs[0] policy
     /* 2048590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048600 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048605 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048626 */     // GIR_Coverage, 15374,
     /* 2048626 */     GIR_EraseRootFromParent_Done,
     /* 2048627 */   // Label 27245: @2048627
     /* 2048627 */   GIM_Try, /*On fail goto*//*Label 27246*/ GIMT_Encode4(2048718), // Rule ID 15375 //
     /* 2048632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2048643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2048646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2048649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2048652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2048655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048678 */     // MIs[0] round
     /* 2048678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048681 */     // MIs[0] policy
     /* 2048681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048691 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048696 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2048714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048717 */     // GIR_Coverage, 15375,
     /* 2048717 */     GIR_EraseRootFromParent_Done,
     /* 2048718 */   // Label 27246: @2048718
     /* 2048718 */   GIM_Try, /*On fail goto*//*Label 27247*/ GIMT_Encode4(2048809), // Rule ID 15378 //
     /* 2048723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2048726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2048743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048769 */     // MIs[0] round
     /* 2048769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048772 */     // MIs[0] policy
     /* 2048772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048782 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048787 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048808 */     // GIR_Coverage, 15378,
     /* 2048808 */     GIR_EraseRootFromParent_Done,
     /* 2048809 */   // Label 27247: @2048809
     /* 2048809 */   GIM_Try, /*On fail goto*//*Label 27248*/ GIMT_Encode4(2048900), // Rule ID 15379 //
     /* 2048814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2048817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2048825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2048828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2048831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2048834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2048837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2048840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2048844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2048856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048860 */     // MIs[0] round
     /* 2048860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048863 */     // MIs[0] policy
     /* 2048863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048873 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2048873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M1_MASK),
     /* 2048876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048878 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2048896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048899 */     // GIR_Coverage, 15379,
     /* 2048899 */     GIR_EraseRootFromParent_Done,
     /* 2048900 */   // Label 27248: @2048900
     /* 2048900 */   GIM_Try, /*On fail goto*//*Label 27249*/ GIMT_Encode4(2048991), // Rule ID 15382 //
     /* 2048905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2048908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2048913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2048916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2048919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2048922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2048925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2048928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2048931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2048935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2048947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2048951 */     // MIs[0] round
     /* 2048951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2048954 */     // MIs[0] policy
     /* 2048954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2048957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2048964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2048964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2048967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2048969 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2048971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2048973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2048975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2048977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2048979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2048984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2048987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2048989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2048990 */     // GIR_Coverage, 15382,
     /* 2048990 */     GIR_EraseRootFromParent_Done,
     /* 2048991 */   // Label 27249: @2048991
     /* 2048991 */   GIM_Try, /*On fail goto*//*Label 27250*/ GIMT_Encode4(2049082), // Rule ID 15383 //
     /* 2048996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2048999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2049007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2049010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2049013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2049016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049042 */     // MIs[0] round
     /* 2049042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049045 */     // MIs[0] policy
     /* 2049045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049055 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2049058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049060 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049081 */     // GIR_Coverage, 15383,
     /* 2049081 */     GIR_EraseRootFromParent_Done,
     /* 2049082 */   // Label 27250: @2049082
     /* 2049082 */   GIM_Try, /*On fail goto*//*Label 27251*/ GIMT_Encode4(2049173), // Rule ID 15386 //
     /* 2049087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2049098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2049101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2049104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2049107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049133 */     // MIs[0] round
     /* 2049133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049136 */     // MIs[0] policy
     /* 2049136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049146 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2049149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049151 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049172 */     // GIR_Coverage, 15386,
     /* 2049172 */     GIR_EraseRootFromParent_Done,
     /* 2049173 */   // Label 27251: @2049173
     /* 2049173 */   GIM_Try, /*On fail goto*//*Label 27252*/ GIMT_Encode4(2049264), // Rule ID 15387 //
     /* 2049178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2049189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2049192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2049195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2049198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049224 */     // MIs[0] round
     /* 2049224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049227 */     // MIs[0] policy
     /* 2049227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049237 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2049240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049242 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049263 */     // GIR_Coverage, 15387,
     /* 2049263 */     GIR_EraseRootFromParent_Done,
     /* 2049264 */   // Label 27252: @2049264
     /* 2049264 */   GIM_Try, /*On fail goto*//*Label 27253*/ GIMT_Encode4(2049355), // Rule ID 15390 //
     /* 2049269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2049289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049315 */     // MIs[0] round
     /* 2049315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049318 */     // MIs[0] policy
     /* 2049318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049328 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2049331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049354 */     // GIR_Coverage, 15390,
     /* 2049354 */     GIR_EraseRootFromParent_Done,
     /* 2049355 */   // Label 27253: @2049355
     /* 2049355 */   GIM_Try, /*On fail goto*//*Label 27254*/ GIMT_Encode4(2049446), // Rule ID 15391 //
     /* 2049360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2049371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2049374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2049377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2049380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2049383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049406 */     // MIs[0] round
     /* 2049406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049409 */     // MIs[0] policy
     /* 2049409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049419 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2049422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049424 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2049442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049445 */     // GIR_Coverage, 15391,
     /* 2049445 */     GIR_EraseRootFromParent_Done,
     /* 2049446 */   // Label 27254: @2049446
     /* 2049446 */   GIM_Try, /*On fail goto*//*Label 27255*/ GIMT_Encode4(2049537), // Rule ID 15394 //
     /* 2049451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2049471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049497 */     // MIs[0] round
     /* 2049497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049500 */     // MIs[0] policy
     /* 2049500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049510 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2049513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049536 */     // GIR_Coverage, 15394,
     /* 2049536 */     GIR_EraseRootFromParent_Done,
     /* 2049537 */   // Label 27255: @2049537
     /* 2049537 */   GIM_Try, /*On fail goto*//*Label 27256*/ GIMT_Encode4(2049628), // Rule ID 15395 //
     /* 2049542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2049553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2049556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2049559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2049562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2049565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2049572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2049584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049588 */     // MIs[0] round
     /* 2049588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049591 */     // MIs[0] policy
     /* 2049591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2049604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049606 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049627 */     // GIR_Coverage, 15395,
     /* 2049627 */     GIR_EraseRootFromParent_Done,
     /* 2049628 */   // Label 27256: @2049628
     /* 2049628 */   GIM_Try, /*On fail goto*//*Label 27257*/ GIMT_Encode4(2049719), // Rule ID 15398 //
     /* 2049633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2049653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049679 */     // MIs[0] round
     /* 2049679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049682 */     // MIs[0] policy
     /* 2049682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049692 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2049695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049697 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049718 */     // GIR_Coverage, 15398,
     /* 2049718 */     GIR_EraseRootFromParent_Done,
     /* 2049719 */   // Label 27257: @2049719
     /* 2049719 */   GIM_Try, /*On fail goto*//*Label 27258*/ GIMT_Encode4(2049810), // Rule ID 15399 //
     /* 2049724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2049735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2049738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2049741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2049744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2049747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2049754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2049766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049770 */     // MIs[0] round
     /* 2049770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049773 */     // MIs[0] policy
     /* 2049773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049783 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2049786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049788 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049809 */     // GIR_Coverage, 15399,
     /* 2049809 */     GIR_EraseRootFromParent_Done,
     /* 2049810 */   // Label 27258: @2049810
     /* 2049810 */   GIM_Try, /*On fail goto*//*Label 27259*/ GIMT_Encode4(2049901), // Rule ID 15402 //
     /* 2049815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2049818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2049835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2049841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049861 */     // MIs[0] round
     /* 2049861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049864 */     // MIs[0] policy
     /* 2049864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049874 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2049874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2049877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049900 */     // GIR_Coverage, 15402,
     /* 2049900 */     GIR_EraseRootFromParent_Done,
     /* 2049901 */   // Label 27259: @2049901
     /* 2049901 */   GIM_Try, /*On fail goto*//*Label 27260*/ GIMT_Encode4(2049992), // Rule ID 15403 //
     /* 2049906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2049909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2049914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2049917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2049920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2049923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2049926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2049929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2049932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2049936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2049948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2049952 */     // MIs[0] round
     /* 2049952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2049955 */     // MIs[0] policy
     /* 2049955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2049958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2049965 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2049965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2049968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2049970 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2049972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2049974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2049976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2049978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2049980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2049985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2049988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2049990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2049991 */     // GIR_Coverage, 15403,
     /* 2049991 */     GIR_EraseRootFromParent_Done,
     /* 2049992 */   // Label 27260: @2049992
     /* 2049992 */   GIM_Try, /*On fail goto*//*Label 27261*/ GIMT_Encode4(2050083), // Rule ID 15406 //
     /* 2049997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2050008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2050011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2050014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2050017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050043 */     // MIs[0] round
     /* 2050043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050046 */     // MIs[0] policy
     /* 2050046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2050059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050061 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050082 */     // GIR_Coverage, 15406,
     /* 2050082 */     GIR_EraseRootFromParent_Done,
     /* 2050083 */   // Label 27261: @2050083
     /* 2050083 */   GIM_Try, /*On fail goto*//*Label 27262*/ GIMT_Encode4(2050174), // Rule ID 15407 //
     /* 2050088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2050099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2050102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2050105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2050108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050134 */     // MIs[0] round
     /* 2050134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050137 */     // MIs[0] policy
     /* 2050137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050147 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2050150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050152 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050173 */     // GIR_Coverage, 15407,
     /* 2050173 */     GIR_EraseRootFromParent_Done,
     /* 2050174 */   // Label 27262: @2050174
     /* 2050174 */   GIM_Try, /*On fail goto*//*Label 27263*/ GIMT_Encode4(2050265), // Rule ID 15410 //
     /* 2050179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2050196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2050199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050225 */     // MIs[0] round
     /* 2050225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050228 */     // MIs[0] policy
     /* 2050228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050238 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2050241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050243 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050264 */     // GIR_Coverage, 15410,
     /* 2050264 */     GIR_EraseRootFromParent_Done,
     /* 2050265 */   // Label 27263: @2050265
     /* 2050265 */   GIM_Try, /*On fail goto*//*Label 27264*/ GIMT_Encode4(2050356), // Rule ID 15411 //
     /* 2050270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2050281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2050284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2050287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2050290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050316 */     // MIs[0] round
     /* 2050316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050319 */     // MIs[0] policy
     /* 2050319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050329 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2050332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050334 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050355 */     // GIR_Coverage, 15411,
     /* 2050355 */     GIR_EraseRootFromParent_Done,
     /* 2050356 */   // Label 27264: @2050356
     /* 2050356 */   GIM_Try, /*On fail goto*//*Label 27265*/ GIMT_Encode4(2050447), // Rule ID 15414 //
     /* 2050361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2050364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2050381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050407 */     // MIs[0] round
     /* 2050407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050410 */     // MIs[0] policy
     /* 2050410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050420 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2050423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050425 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050446 */     // GIR_Coverage, 15414,
     /* 2050446 */     GIR_EraseRootFromParent_Done,
     /* 2050447 */   // Label 27265: @2050447
     /* 2050447 */   GIM_Try, /*On fail goto*//*Label 27266*/ GIMT_Encode4(2050538), // Rule ID 15415 //
     /* 2050452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2050455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2050463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2050466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2050469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2050472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2050475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050498 */     // MIs[0] round
     /* 2050498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050501 */     // MIs[0] policy
     /* 2050501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050511 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2050514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050516 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2050534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050537 */     // GIR_Coverage, 15415,
     /* 2050537 */     GIR_EraseRootFromParent_Done,
     /* 2050538 */   // Label 27266: @2050538
     /* 2050538 */   GIM_Try, /*On fail goto*//*Label 27267*/ GIMT_Encode4(2050629), // Rule ID 15418 //
     /* 2050543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2050563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050589 */     // MIs[0] round
     /* 2050589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050592 */     // MIs[0] policy
     /* 2050592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2050605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050628 */     // GIR_Coverage, 15418,
     /* 2050628 */     GIR_EraseRootFromParent_Done,
     /* 2050629 */   // Label 27267: @2050629
     /* 2050629 */   GIM_Try, /*On fail goto*//*Label 27268*/ GIMT_Encode4(2050720), // Rule ID 15419 //
     /* 2050634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2050645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2050648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2050651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2050654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2050657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2050664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2050676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050680 */     // MIs[0] round
     /* 2050680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050683 */     // MIs[0] policy
     /* 2050683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M2_MASK),
     /* 2050696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050698 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050719 */     // GIR_Coverage, 15419,
     /* 2050719 */     GIR_EraseRootFromParent_Done,
     /* 2050720 */   // Label 27268: @2050720
     /* 2050720 */   GIM_Try, /*On fail goto*//*Label 27269*/ GIMT_Encode4(2050811), // Rule ID 15422 //
     /* 2050725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2050745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050771 */     // MIs[0] round
     /* 2050771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050774 */     // MIs[0] policy
     /* 2050774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050784 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2050787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050810 */     // GIR_Coverage, 15422,
     /* 2050810 */     GIR_EraseRootFromParent_Done,
     /* 2050811 */   // Label 27269: @2050811
     /* 2050811 */   GIM_Try, /*On fail goto*//*Label 27270*/ GIMT_Encode4(2050902), // Rule ID 15423 //
     /* 2050816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2050819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2050827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2050830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2050833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2050836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2050839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2050842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2050846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2050858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050862 */     // MIs[0] round
     /* 2050862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050865 */     // MIs[0] policy
     /* 2050865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050875 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2050875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M4_MASK),
     /* 2050878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050880 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050901 */     // GIR_Coverage, 15423,
     /* 2050901 */     GIR_EraseRootFromParent_Done,
     /* 2050902 */   // Label 27270: @2050902
     /* 2050902 */   GIM_Try, /*On fail goto*//*Label 27271*/ GIMT_Encode4(2050993), // Rule ID 15426 //
     /* 2050907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2050910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2050915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2050918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2050921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2050924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2050927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2050930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2050933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2050937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2050949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2050953 */     // MIs[0] round
     /* 2050953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2050956 */     // MIs[0] policy
     /* 2050956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2050959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2050966 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2050966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2050969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2050971 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2050973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2050975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2050977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2050979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2050981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2050986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2050989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2050991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2050992 */     // GIR_Coverage, 15426,
     /* 2050992 */     GIR_EraseRootFromParent_Done,
     /* 2050993 */   // Label 27271: @2050993
     /* 2050993 */   GIM_Try, /*On fail goto*//*Label 27272*/ GIMT_Encode4(2051084), // Rule ID 15427 //
     /* 2050998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2051001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2051009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2051012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2051015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2051018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2051021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2051028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2051040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051044 */     // MIs[0] round
     /* 2051044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051047 */     // MIs[0] policy
     /* 2051047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051057 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VV_M8_MASK),
     /* 2051060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051062 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2051080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051083 */     // GIR_Coverage, 15427,
     /* 2051083 */     GIR_EraseRootFromParent_Done,
     /* 2051084 */   // Label 27272: @2051084
     /* 2051084 */   GIM_Try, /*On fail goto*//*Label 27273*/ GIMT_Encode4(2051175), // Rule ID 15430 //
     /* 2051089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2051100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2051103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2051106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051135 */     // MIs[0] round
     /* 2051135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051138 */     // MIs[0] policy
     /* 2051138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051148 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2051151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051174 */     // GIR_Coverage, 15430,
     /* 2051174 */     GIR_EraseRootFromParent_Done,
     /* 2051175 */   // Label 27273: @2051175
     /* 2051175 */   GIM_Try, /*On fail goto*//*Label 27274*/ GIMT_Encode4(2051266), // Rule ID 15431 //
     /* 2051180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2051191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2051194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2051197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051226 */     // MIs[0] round
     /* 2051226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051229 */     // MIs[0] policy
     /* 2051229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051239 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF8_MASK),
     /* 2051242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051244 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051265 */     // GIR_Coverage, 15431,
     /* 2051265 */     GIR_EraseRootFromParent_Done,
     /* 2051266 */   // Label 27274: @2051266
     /* 2051266 */   GIM_Try, /*On fail goto*//*Label 27275*/ GIMT_Encode4(2051357), // Rule ID 15434 //
     /* 2051271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051317 */     // MIs[0] round
     /* 2051317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051320 */     // MIs[0] policy
     /* 2051320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051330 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2051333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051356 */     // GIR_Coverage, 15434,
     /* 2051356 */     GIR_EraseRootFromParent_Done,
     /* 2051357 */   // Label 27275: @2051357
     /* 2051357 */   GIM_Try, /*On fail goto*//*Label 27276*/ GIMT_Encode4(2051448), // Rule ID 15435 //
     /* 2051362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2051373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2051376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2051379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051408 */     // MIs[0] round
     /* 2051408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051411 */     // MIs[0] policy
     /* 2051411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051421 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2051424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051426 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051447 */     // GIR_Coverage, 15435,
     /* 2051447 */     GIR_EraseRootFromParent_Done,
     /* 2051448 */   // Label 27276: @2051448
     /* 2051448 */   GIM_Try, /*On fail goto*//*Label 27277*/ GIMT_Encode4(2051539), // Rule ID 15438 //
     /* 2051453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051499 */     // MIs[0] round
     /* 2051499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051502 */     // MIs[0] policy
     /* 2051502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051512 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2051515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051517 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051538 */     // GIR_Coverage, 15438,
     /* 2051538 */     GIR_EraseRootFromParent_Done,
     /* 2051539 */   // Label 27277: @2051539
     /* 2051539 */   GIM_Try, /*On fail goto*//*Label 27278*/ GIMT_Encode4(2051630), // Rule ID 15439 //
     /* 2051544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2051555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2051558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2051561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2051567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051590 */     // MIs[0] round
     /* 2051590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051593 */     // MIs[0] policy
     /* 2051593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051603 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2051606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051608 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2051626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051629 */     // GIR_Coverage, 15439,
     /* 2051629 */     GIR_EraseRootFromParent_Done,
     /* 2051630 */   // Label 27278: @2051630
     /* 2051630 */   GIM_Try, /*On fail goto*//*Label 27279*/ GIMT_Encode4(2051721), // Rule ID 15442 //
     /* 2051635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051681 */     // MIs[0] round
     /* 2051681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051684 */     // MIs[0] policy
     /* 2051684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051694 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2051697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051699 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051720 */     // GIR_Coverage, 15442,
     /* 2051720 */     GIR_EraseRootFromParent_Done,
     /* 2051721 */   // Label 27279: @2051721
     /* 2051721 */   GIM_Try, /*On fail goto*//*Label 27280*/ GIMT_Encode4(2051812), // Rule ID 15443 //
     /* 2051726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2051737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2051740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2051743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2051749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051772 */     // MIs[0] round
     /* 2051772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051775 */     // MIs[0] policy
     /* 2051775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051785 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF4_MASK),
     /* 2051788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051790 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051811 */     // GIR_Coverage, 15443,
     /* 2051811 */     GIR_EraseRootFromParent_Done,
     /* 2051812 */   // Label 27280: @2051812
     /* 2051812 */   GIM_Try, /*On fail goto*//*Label 27281*/ GIMT_Encode4(2051903), // Rule ID 15446 //
     /* 2051817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2051820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2051837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2051843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051863 */     // MIs[0] round
     /* 2051863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051866 */     // MIs[0] policy
     /* 2051866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051876 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2051876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2051879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051881 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051902 */     // GIR_Coverage, 15446,
     /* 2051902 */     GIR_EraseRootFromParent_Done,
     /* 2051903 */   // Label 27281: @2051903
     /* 2051903 */   GIM_Try, /*On fail goto*//*Label 27282*/ GIMT_Encode4(2051994), // Rule ID 15447 //
     /* 2051908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2051911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2051916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2051919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2051922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2051925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2051928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2051931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2051934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2051938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2051946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2051950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2051954 */     // MIs[0] round
     /* 2051954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2051957 */     // MIs[0] policy
     /* 2051957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2051960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2051967 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2051967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2051970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2051972 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2051974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2051976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2051978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2051980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2051982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2051987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2051990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2051992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2051993 */     // GIR_Coverage, 15447,
     /* 2051993 */     GIR_EraseRootFromParent_Done,
     /* 2051994 */   // Label 27282: @2051994
     /* 2051994 */   GIM_Try, /*On fail goto*//*Label 27283*/ GIMT_Encode4(2052085), // Rule ID 15450 //
     /* 2051999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2052010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2052013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2052016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052045 */     // MIs[0] round
     /* 2052045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052048 */     // MIs[0] policy
     /* 2052048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052058 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2052061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052063 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052084 */     // GIR_Coverage, 15450,
     /* 2052084 */     GIR_EraseRootFromParent_Done,
     /* 2052085 */   // Label 27283: @2052085
     /* 2052085 */   GIM_Try, /*On fail goto*//*Label 27284*/ GIMT_Encode4(2052176), // Rule ID 15451 //
     /* 2052090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2052101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2052104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2052107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052136 */     // MIs[0] round
     /* 2052136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052139 */     // MIs[0] policy
     /* 2052139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052149 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_MF2_MASK),
     /* 2052152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052154 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052175 */     // GIR_Coverage, 15451,
     /* 2052175 */     GIR_EraseRootFromParent_Done,
     /* 2052176 */   // Label 27284: @2052176
     /* 2052176 */   GIM_Try, /*On fail goto*//*Label 27285*/ GIMT_Encode4(2052267), // Rule ID 15454 //
     /* 2052181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2052192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2052195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2052198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052227 */     // MIs[0] round
     /* 2052227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052230 */     // MIs[0] policy
     /* 2052230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052240 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052245 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052266 */     // GIR_Coverage, 15454,
     /* 2052266 */     GIR_EraseRootFromParent_Done,
     /* 2052267 */   // Label 27285: @2052267
     /* 2052267 */   GIM_Try, /*On fail goto*//*Label 27286*/ GIMT_Encode4(2052358), // Rule ID 15455 //
     /* 2052272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2052283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2052286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2052289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2052295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052318 */     // MIs[0] round
     /* 2052318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052321 */     // MIs[0] policy
     /* 2052321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052331 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11070:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052336 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052357 */     // GIR_Coverage, 15455,
     /* 2052357 */     GIR_EraseRootFromParent_Done,
     /* 2052358 */   // Label 27286: @2052358
     /* 2052358 */   GIM_Try, /*On fail goto*//*Label 27287*/ GIMT_Encode4(2052449), // Rule ID 15458 //
     /* 2052363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052409 */     // MIs[0] round
     /* 2052409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052412 */     // MIs[0] policy
     /* 2052412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052422 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052448 */     // GIR_Coverage, 15458,
     /* 2052448 */     GIR_EraseRootFromParent_Done,
     /* 2052449 */   // Label 27287: @2052449
     /* 2052449 */   GIM_Try, /*On fail goto*//*Label 27288*/ GIMT_Encode4(2052540), // Rule ID 15459 //
     /* 2052454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2052465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2052468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2052471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2052477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052500 */     // MIs[0] round
     /* 2052500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052503 */     // MIs[0] policy
     /* 2052503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052513 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11070:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052518 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2052536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052539 */     // GIR_Coverage, 15459,
     /* 2052539 */     GIR_EraseRootFromParent_Done,
     /* 2052540 */   // Label 27288: @2052540
     /* 2052540 */   GIM_Try, /*On fail goto*//*Label 27289*/ GIMT_Encode4(2052631), // Rule ID 15462 //
     /* 2052545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052591 */     // MIs[0] round
     /* 2052591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052594 */     // MIs[0] policy
     /* 2052594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052604 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052630 */     // GIR_Coverage, 15462,
     /* 2052630 */     GIR_EraseRootFromParent_Done,
     /* 2052631 */   // Label 27289: @2052631
     /* 2052631 */   GIM_Try, /*On fail goto*//*Label 27290*/ GIMT_Encode4(2052722), // Rule ID 15463 //
     /* 2052636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2052639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2052647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2052650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2052653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2052659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052682 */     // MIs[0] round
     /* 2052682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052685 */     // MIs[0] policy
     /* 2052685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052695 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11070:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052700 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2052718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052721 */     // GIR_Coverage, 15463,
     /* 2052721 */     GIR_EraseRootFromParent_Done,
     /* 2052722 */   // Label 27290: @2052722
     /* 2052722 */   GIM_Try, /*On fail goto*//*Label 27291*/ GIMT_Encode4(2052813), // Rule ID 15466 //
     /* 2052727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2052730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052773 */     // MIs[0] round
     /* 2052773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052776 */     // MIs[0] policy
     /* 2052776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052786 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052791 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052812 */     // GIR_Coverage, 15466,
     /* 2052812 */     GIR_EraseRootFromParent_Done,
     /* 2052813 */   // Label 27291: @2052813
     /* 2052813 */   GIM_Try, /*On fail goto*//*Label 27292*/ GIMT_Encode4(2052904), // Rule ID 15467 //
     /* 2052818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2052821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2052829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2052832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2052835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2052838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2052841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2052844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2052848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2052856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052864 */     // MIs[0] round
     /* 2052864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052867 */     // MIs[0] policy
     /* 2052867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052877 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11070:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2052877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M1_MASK),
     /* 2052880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052882 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2052900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052903 */     // GIR_Coverage, 15467,
     /* 2052903 */     GIR_EraseRootFromParent_Done,
     /* 2052904 */   // Label 27292: @2052904
     /* 2052904 */   GIM_Try, /*On fail goto*//*Label 27293*/ GIMT_Encode4(2052995), // Rule ID 15470 //
     /* 2052909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2052912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2052917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2052920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2052923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2052926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2052929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2052932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2052935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2052939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2052947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2052951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2052955 */     // MIs[0] round
     /* 2052955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2052958 */     // MIs[0] policy
     /* 2052958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2052961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2052968 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2052968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2052971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2052973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2052975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2052977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2052979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2052981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2052983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2052988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2052991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2052993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2052994 */     // GIR_Coverage, 15470,
     /* 2052994 */     GIR_EraseRootFromParent_Done,
     /* 2052995 */   // Label 27293: @2052995
     /* 2052995 */   GIM_Try, /*On fail goto*//*Label 27294*/ GIMT_Encode4(2053086), // Rule ID 15471 //
     /* 2053000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2053011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2053014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2053017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053046 */     // MIs[0] round
     /* 2053046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053049 */     // MIs[0] policy
     /* 2053049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2053062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053064 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053085 */     // GIR_Coverage, 15471,
     /* 2053085 */     GIR_EraseRootFromParent_Done,
     /* 2053086 */   // Label 27294: @2053086
     /* 2053086 */   GIM_Try, /*On fail goto*//*Label 27295*/ GIMT_Encode4(2053177), // Rule ID 15474 //
     /* 2053091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2053102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2053105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2053108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053137 */     // MIs[0] round
     /* 2053137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053140 */     // MIs[0] policy
     /* 2053140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053150 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2053153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053155 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053176 */     // GIR_Coverage, 15474,
     /* 2053176 */     GIR_EraseRootFromParent_Done,
     /* 2053177 */   // Label 27295: @2053177
     /* 2053177 */   GIM_Try, /*On fail goto*//*Label 27296*/ GIMT_Encode4(2053268), // Rule ID 15475 //
     /* 2053182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2053193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2053196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2053199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053228 */     // MIs[0] round
     /* 2053228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053231 */     // MIs[0] policy
     /* 2053231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053241 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2053244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053246 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053267 */     // GIR_Coverage, 15475,
     /* 2053267 */     GIR_EraseRootFromParent_Done,
     /* 2053268 */   // Label 27296: @2053268
     /* 2053268 */   GIM_Try, /*On fail goto*//*Label 27297*/ GIMT_Encode4(2053359), // Rule ID 15478 //
     /* 2053273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053319 */     // MIs[0] round
     /* 2053319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053322 */     // MIs[0] policy
     /* 2053322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053332 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2053335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053337 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053358 */     // GIR_Coverage, 15478,
     /* 2053358 */     GIR_EraseRootFromParent_Done,
     /* 2053359 */   // Label 27297: @2053359
     /* 2053359 */   GIM_Try, /*On fail goto*//*Label 27298*/ GIMT_Encode4(2053450), // Rule ID 15479 //
     /* 2053364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2053375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2053378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2053381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2053387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053410 */     // MIs[0] round
     /* 2053410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053413 */     // MIs[0] policy
     /* 2053413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053423 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2053426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053428 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2053446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053449 */     // GIR_Coverage, 15479,
     /* 2053449 */     GIR_EraseRootFromParent_Done,
     /* 2053450 */   // Label 27298: @2053450
     /* 2053450 */   GIM_Try, /*On fail goto*//*Label 27299*/ GIMT_Encode4(2053541), // Rule ID 15482 //
     /* 2053455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053501 */     // MIs[0] round
     /* 2053501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053504 */     // MIs[0] policy
     /* 2053504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2053517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053519 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053540 */     // GIR_Coverage, 15482,
     /* 2053540 */     GIR_EraseRootFromParent_Done,
     /* 2053541 */   // Label 27299: @2053541
     /* 2053541 */   GIM_Try, /*On fail goto*//*Label 27300*/ GIMT_Encode4(2053632), // Rule ID 15483 //
     /* 2053546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2053557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2053560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2053563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2053569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2053576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2053584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053592 */     // MIs[0] round
     /* 2053592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053595 */     // MIs[0] policy
     /* 2053595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053605 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2053608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053610 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053631 */     // GIR_Coverage, 15483,
     /* 2053631 */     GIR_EraseRootFromParent_Done,
     /* 2053632 */   // Label 27300: @2053632
     /* 2053632 */   GIM_Try, /*On fail goto*//*Label 27301*/ GIMT_Encode4(2053723), // Rule ID 15486 //
     /* 2053637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053683 */     // MIs[0] round
     /* 2053683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053686 */     // MIs[0] policy
     /* 2053686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053696 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2053699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053722 */     // GIR_Coverage, 15486,
     /* 2053722 */     GIR_EraseRootFromParent_Done,
     /* 2053723 */   // Label 27301: @2053723
     /* 2053723 */   GIM_Try, /*On fail goto*//*Label 27302*/ GIMT_Encode4(2053814), // Rule ID 15487 //
     /* 2053728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2053739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2053742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2053745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2053751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2053758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2053766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053774 */     // MIs[0] round
     /* 2053774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053777 */     // MIs[0] policy
     /* 2053777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053787 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2053790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053792 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053813 */     // GIR_Coverage, 15487,
     /* 2053813 */     GIR_EraseRootFromParent_Done,
     /* 2053814 */   // Label 27302: @2053814
     /* 2053814 */   GIM_Try, /*On fail goto*//*Label 27303*/ GIMT_Encode4(2053905), // Rule ID 15490 //
     /* 2053819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2053822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2053839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2053845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053865 */     // MIs[0] round
     /* 2053865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053868 */     // MIs[0] policy
     /* 2053868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2053878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2053881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053904 */     // GIR_Coverage, 15490,
     /* 2053904 */     GIR_EraseRootFromParent_Done,
     /* 2053905 */   // Label 27303: @2053905
     /* 2053905 */   GIM_Try, /*On fail goto*//*Label 27304*/ GIMT_Encode4(2053996), // Rule ID 15491 //
     /* 2053910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2053913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2053918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2053921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2053924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2053927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2053930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2053933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2053936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2053940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2053948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2053952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2053956 */     // MIs[0] round
     /* 2053956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2053959 */     // MIs[0] policy
     /* 2053959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2053962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2053969 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2053969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2053972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2053974 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2053976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2053978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2053980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2053982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2053984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2053989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2053992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2053994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2053995 */     // GIR_Coverage, 15491,
     /* 2053995 */     GIR_EraseRootFromParent_Done,
     /* 2053996 */   // Label 27304: @2053996
     /* 2053996 */   GIM_Try, /*On fail goto*//*Label 27305*/ GIMT_Encode4(2054087), // Rule ID 15494 //
     /* 2054001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2054012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2054015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2054018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054047 */     // MIs[0] round
     /* 2054047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054050 */     // MIs[0] policy
     /* 2054050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054060 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2054063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054065 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054086 */     // GIR_Coverage, 15494,
     /* 2054086 */     GIR_EraseRootFromParent_Done,
     /* 2054087 */   // Label 27305: @2054087
     /* 2054087 */   GIM_Try, /*On fail goto*//*Label 27306*/ GIMT_Encode4(2054178), // Rule ID 15495 //
     /* 2054092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2054103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2054106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2054109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054138 */     // MIs[0] round
     /* 2054138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054141 */     // MIs[0] policy
     /* 2054141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2054154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054156 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054177 */     // GIR_Coverage, 15495,
     /* 2054177 */     GIR_EraseRootFromParent_Done,
     /* 2054178 */   // Label 27306: @2054178
     /* 2054178 */   GIM_Try, /*On fail goto*//*Label 27307*/ GIMT_Encode4(2054269), // Rule ID 15498 //
     /* 2054183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2054194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2054197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2054200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054229 */     // MIs[0] round
     /* 2054229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054232 */     // MIs[0] policy
     /* 2054232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054242 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2054245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054268 */     // GIR_Coverage, 15498,
     /* 2054268 */     GIR_EraseRootFromParent_Done,
     /* 2054269 */   // Label 27307: @2054269
     /* 2054269 */   GIM_Try, /*On fail goto*//*Label 27308*/ GIMT_Encode4(2054360), // Rule ID 15499 //
     /* 2054274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2054285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2054288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2054291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054320 */     // MIs[0] round
     /* 2054320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054323 */     // MIs[0] policy
     /* 2054323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054333 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2054336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054338 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054359 */     // GIR_Coverage, 15499,
     /* 2054359 */     GIR_EraseRootFromParent_Done,
     /* 2054360 */   // Label 27308: @2054360
     /* 2054360 */   GIM_Try, /*On fail goto*//*Label 27309*/ GIMT_Encode4(2054451), // Rule ID 15502 //
     /* 2054365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2054368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054411 */     // MIs[0] round
     /* 2054411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054414 */     // MIs[0] policy
     /* 2054414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054424 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2054427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054450 */     // GIR_Coverage, 15502,
     /* 2054450 */     GIR_EraseRootFromParent_Done,
     /* 2054451 */   // Label 27309: @2054451
     /* 2054451 */   GIM_Try, /*On fail goto*//*Label 27310*/ GIMT_Encode4(2054542), // Rule ID 15503 //
     /* 2054456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2054459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2054467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2054470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2054473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2054479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054502 */     // MIs[0] round
     /* 2054502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054505 */     // MIs[0] policy
     /* 2054505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054515 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2054518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2054538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054541 */     // GIR_Coverage, 15503,
     /* 2054541 */     GIR_EraseRootFromParent_Done,
     /* 2054542 */   // Label 27310: @2054542
     /* 2054542 */   GIM_Try, /*On fail goto*//*Label 27311*/ GIMT_Encode4(2054633), // Rule ID 15506 //
     /* 2054547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054593 */     // MIs[0] round
     /* 2054593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054596 */     // MIs[0] policy
     /* 2054596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054606 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2054609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054632 */     // GIR_Coverage, 15506,
     /* 2054632 */     GIR_EraseRootFromParent_Done,
     /* 2054633 */   // Label 27311: @2054633
     /* 2054633 */   GIM_Try, /*On fail goto*//*Label 27312*/ GIMT_Encode4(2054724), // Rule ID 15507 //
     /* 2054638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2054649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2054652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2054655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2054661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2054668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2054676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054684 */     // MIs[0] round
     /* 2054684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054687 */     // MIs[0] policy
     /* 2054687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054697 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11070:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M2_MASK),
     /* 2054700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054723 */     // GIR_Coverage, 15507,
     /* 2054723 */     GIR_EraseRootFromParent_Done,
     /* 2054724 */   // Label 27312: @2054724
     /* 2054724 */   GIM_Try, /*On fail goto*//*Label 27313*/ GIMT_Encode4(2054815), // Rule ID 15510 //
     /* 2054729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054775 */     // MIs[0] round
     /* 2054775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054778 */     // MIs[0] policy
     /* 2054778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054788 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2054791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054814 */     // GIR_Coverage, 15510,
     /* 2054814 */     GIR_EraseRootFromParent_Done,
     /* 2054815 */   // Label 27313: @2054815
     /* 2054815 */   GIM_Try, /*On fail goto*//*Label 27314*/ GIMT_Encode4(2054906), // Rule ID 15511 //
     /* 2054820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2054823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2054831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2054834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2054837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2054840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2054843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2054846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2054850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2054858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054866 */     // MIs[0] round
     /* 2054866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054869 */     // MIs[0] policy
     /* 2054869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054879 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11070:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2054879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M4_MASK),
     /* 2054882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054905 */     // GIR_Coverage, 15511,
     /* 2054905 */     GIR_EraseRootFromParent_Done,
     /* 2054906 */   // Label 27314: @2054906
     /* 2054906 */   GIM_Try, /*On fail goto*//*Label 27315*/ GIMT_Encode4(2054997), // Rule ID 15514 //
     /* 2054911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2054914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2054919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2054922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2054925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2054928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2054931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2054934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2054937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2054941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2054949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2054953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2054957 */     // MIs[0] round
     /* 2054957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2054960 */     // MIs[0] policy
     /* 2054960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2054963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2054970 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2054970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2054973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2054975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2054977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2054979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2054981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2054983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2054985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2054990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2054993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2054995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2054996 */     // GIR_Coverage, 15514,
     /* 2054996 */     GIR_EraseRootFromParent_Done,
     /* 2054997 */   // Label 27315: @2054997
     /* 2054997 */   GIM_Try, /*On fail goto*//*Label 27316*/ GIMT_Encode4(2055088), // Rule ID 15515 //
     /* 2055002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2055005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vaadd_mask),
     /* 2055010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2055013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2055016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2055019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2055022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2055025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2055032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2055040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2055044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055048 */     // MIs[0] round
     /* 2055048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055051 */     // MIs[0] policy
     /* 2055051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055061 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11070:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVAADD_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVAADD_VX_M8_MASK),
     /* 2055064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2055084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055087 */     // GIR_Coverage, 15515,
     /* 2055087 */     GIR_EraseRootFromParent_Done,
     /* 2055088 */   // Label 27316: @2055088
     /* 2055088 */   GIM_Try, /*On fail goto*//*Label 27317*/ GIMT_Encode4(2055182), // Rule ID 15518 //
     /* 2055093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2055104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2055107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2055110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2055113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055139 */     // MIs[0] round
     /* 2055139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055142 */     // MIs[0] policy
     /* 2055142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055152 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2055155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055181 */     // GIR_Coverage, 15518,
     /* 2055181 */     GIR_EraseRootFromParent_Done,
     /* 2055182 */   // Label 27317: @2055182
     /* 2055182 */   GIM_Try, /*On fail goto*//*Label 27318*/ GIMT_Encode4(2055276), // Rule ID 15519 //
     /* 2055187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2055198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2055201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2055204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2055207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055233 */     // MIs[0] round
     /* 2055233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055236 */     // MIs[0] policy
     /* 2055236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055246 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF8_MASK),
     /* 2055249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055271 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055275 */     // GIR_Coverage, 15519,
     /* 2055275 */     GIR_EraseRootFromParent_Done,
     /* 2055276 */   // Label 27318: @2055276
     /* 2055276 */   GIM_Try, /*On fail goto*//*Label 27319*/ GIMT_Encode4(2055370), // Rule ID 15522 //
     /* 2055281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2055301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055327 */     // MIs[0] round
     /* 2055327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055330 */     // MIs[0] policy
     /* 2055330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055340 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2055343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055365 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055369 */     // GIR_Coverage, 15522,
     /* 2055369 */     GIR_EraseRootFromParent_Done,
     /* 2055370 */   // Label 27319: @2055370
     /* 2055370 */   GIM_Try, /*On fail goto*//*Label 27320*/ GIMT_Encode4(2055464), // Rule ID 15523 //
     /* 2055375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2055386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2055389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2055392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2055395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055421 */     // MIs[0] round
     /* 2055421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055424 */     // MIs[0] policy
     /* 2055424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055434 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2055437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055463 */     // GIR_Coverage, 15523,
     /* 2055463 */     GIR_EraseRootFromParent_Done,
     /* 2055464 */   // Label 27320: @2055464
     /* 2055464 */   GIM_Try, /*On fail goto*//*Label 27321*/ GIMT_Encode4(2055558), // Rule ID 15526 //
     /* 2055469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2055489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055515 */     // MIs[0] round
     /* 2055515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055518 */     // MIs[0] policy
     /* 2055518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055528 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2055531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055557 */     // GIR_Coverage, 15526,
     /* 2055557 */     GIR_EraseRootFromParent_Done,
     /* 2055558 */   // Label 27321: @2055558
     /* 2055558 */   GIM_Try, /*On fail goto*//*Label 27322*/ GIMT_Encode4(2055652), // Rule ID 15527 //
     /* 2055563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2055574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2055577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2055580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2055583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2055586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055609 */     // MIs[0] round
     /* 2055609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055612 */     // MIs[0] policy
     /* 2055612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055622 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2055625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055627 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2055645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055647 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055651 */     // GIR_Coverage, 15527,
     /* 2055651 */     GIR_EraseRootFromParent_Done,
     /* 2055652 */   // Label 27322: @2055652
     /* 2055652 */   GIM_Try, /*On fail goto*//*Label 27323*/ GIMT_Encode4(2055746), // Rule ID 15530 //
     /* 2055657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2055677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055703 */     // MIs[0] round
     /* 2055703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055706 */     // MIs[0] policy
     /* 2055706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055716 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2055719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055721 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055745 */     // GIR_Coverage, 15530,
     /* 2055745 */     GIR_EraseRootFromParent_Done,
     /* 2055746 */   // Label 27323: @2055746
     /* 2055746 */   GIM_Try, /*On fail goto*//*Label 27324*/ GIMT_Encode4(2055840), // Rule ID 15531 //
     /* 2055751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2055762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2055765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2055768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2055771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2055774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055797 */     // MIs[0] round
     /* 2055797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055800 */     // MIs[0] policy
     /* 2055800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055810 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF4_MASK),
     /* 2055813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055815 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055835 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055839 */     // GIR_Coverage, 15531,
     /* 2055839 */     GIR_EraseRootFromParent_Done,
     /* 2055840 */   // Label 27324: @2055840
     /* 2055840 */   GIM_Try, /*On fail goto*//*Label 27325*/ GIMT_Encode4(2055934), // Rule ID 15534 //
     /* 2055845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2055848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2055865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2055871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055891 */     // MIs[0] round
     /* 2055891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055894 */     // MIs[0] policy
     /* 2055894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055904 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2055904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2055907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2055909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2055911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2055913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2055915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2055917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2055919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2055924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2055927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2055929 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2055932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2055933 */     // GIR_Coverage, 15534,
     /* 2055933 */     GIR_EraseRootFromParent_Done,
     /* 2055934 */   // Label 27325: @2055934
     /* 2055934 */   GIM_Try, /*On fail goto*//*Label 27326*/ GIMT_Encode4(2056028), // Rule ID 15535 //
     /* 2055939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2055942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2055947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2055950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2055953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2055956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2055959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2055962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2055965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2055969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2055981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2055985 */     // MIs[0] round
     /* 2055985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2055988 */     // MIs[0] policy
     /* 2055988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2055991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2055998 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2055998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2056001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056023 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056027 */     // GIR_Coverage, 15535,
     /* 2056027 */     GIR_EraseRootFromParent_Done,
     /* 2056028 */   // Label 27326: @2056028
     /* 2056028 */   GIM_Try, /*On fail goto*//*Label 27327*/ GIMT_Encode4(2056122), // Rule ID 15538 //
     /* 2056033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2056053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056079 */     // MIs[0] round
     /* 2056079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056082 */     // MIs[0] policy
     /* 2056082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056092 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2056095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056117 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056121 */     // GIR_Coverage, 15538,
     /* 2056121 */     GIR_EraseRootFromParent_Done,
     /* 2056122 */   // Label 27327: @2056122
     /* 2056122 */   GIM_Try, /*On fail goto*//*Label 27328*/ GIMT_Encode4(2056216), // Rule ID 15539 //
     /* 2056127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2056138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2056141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2056144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2056147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2056150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056173 */     // MIs[0] round
     /* 2056173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056176 */     // MIs[0] policy
     /* 2056176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056186 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_MF2_MASK),
     /* 2056189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056215 */     // GIR_Coverage, 15539,
     /* 2056215 */     GIR_EraseRootFromParent_Done,
     /* 2056216 */   // Label 27328: @2056216
     /* 2056216 */   GIM_Try, /*On fail goto*//*Label 27329*/ GIMT_Encode4(2056310), // Rule ID 15542 //
     /* 2056221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2056232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2056235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2056238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2056241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056267 */     // MIs[0] round
     /* 2056267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056270 */     // MIs[0] policy
     /* 2056270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056280 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056309 */     // GIR_Coverage, 15542,
     /* 2056309 */     GIR_EraseRootFromParent_Done,
     /* 2056310 */   // Label 27329: @2056310
     /* 2056310 */   GIM_Try, /*On fail goto*//*Label 27330*/ GIMT_Encode4(2056404), // Rule ID 15543 //
     /* 2056315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2056326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2056329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2056332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2056335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2056338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056361 */     // MIs[0] round
     /* 2056361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056364 */     // MIs[0] policy
     /* 2056364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056374 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056399 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056403 */     // GIR_Coverage, 15543,
     /* 2056403 */     GIR_EraseRootFromParent_Done,
     /* 2056404 */   // Label 27330: @2056404
     /* 2056404 */   GIM_Try, /*On fail goto*//*Label 27331*/ GIMT_Encode4(2056498), // Rule ID 15546 //
     /* 2056409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2056429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056455 */     // MIs[0] round
     /* 2056455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056458 */     // MIs[0] policy
     /* 2056458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056468 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056497 */     // GIR_Coverage, 15546,
     /* 2056497 */     GIR_EraseRootFromParent_Done,
     /* 2056498 */   // Label 27331: @2056498
     /* 2056498 */   GIM_Try, /*On fail goto*//*Label 27332*/ GIMT_Encode4(2056592), // Rule ID 15547 //
     /* 2056503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2056514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2056517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2056520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2056523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2056526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056549 */     // MIs[0] round
     /* 2056549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056552 */     // MIs[0] policy
     /* 2056552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056562 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2056585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056591 */     // GIR_Coverage, 15547,
     /* 2056591 */     GIR_EraseRootFromParent_Done,
     /* 2056592 */   // Label 27332: @2056592
     /* 2056592 */   GIM_Try, /*On fail goto*//*Label 27333*/ GIMT_Encode4(2056686), // Rule ID 15550 //
     /* 2056597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2056617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056643 */     // MIs[0] round
     /* 2056643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056646 */     // MIs[0] policy
     /* 2056646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056656 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056681 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056685 */     // GIR_Coverage, 15550,
     /* 2056685 */     GIR_EraseRootFromParent_Done,
     /* 2056686 */   // Label 27333: @2056686
     /* 2056686 */   GIM_Try, /*On fail goto*//*Label 27334*/ GIMT_Encode4(2056780), // Rule ID 15551 //
     /* 2056691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2056702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2056705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2056708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2056711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2056714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2056721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2056733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056737 */     // MIs[0] round
     /* 2056737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056740 */     // MIs[0] policy
     /* 2056740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056750 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2056753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2056773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056779 */     // GIR_Coverage, 15551,
     /* 2056779 */     GIR_EraseRootFromParent_Done,
     /* 2056780 */   // Label 27334: @2056780
     /* 2056780 */   GIM_Try, /*On fail goto*//*Label 27335*/ GIMT_Encode4(2056874), // Rule ID 15554 //
     /* 2056785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2056805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056831 */     // MIs[0] round
     /* 2056831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056834 */     // MIs[0] policy
     /* 2056834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056844 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2056844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2056847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056869 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056873 */     // GIR_Coverage, 15554,
     /* 2056873 */     GIR_EraseRootFromParent_Done,
     /* 2056874 */   // Label 27335: @2056874
     /* 2056874 */   GIM_Try, /*On fail goto*//*Label 27336*/ GIMT_Encode4(2056968), // Rule ID 15555 //
     /* 2056879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2056882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2056890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2056893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2056896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2056899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2056902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2056905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2056909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2056921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2056925 */     // MIs[0] round
     /* 2056925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2056928 */     // MIs[0] policy
     /* 2056928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2056931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2056938 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2056938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2056941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2056943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2056945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2056947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2056949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2056951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2056953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2056958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2056961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2056963 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2056966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2056967 */     // GIR_Coverage, 15555,
     /* 2056967 */     GIR_EraseRootFromParent_Done,
     /* 2056968 */   // Label 27336: @2056968
     /* 2056968 */   GIM_Try, /*On fail goto*//*Label 27337*/ GIMT_Encode4(2057062), // Rule ID 15558 //
     /* 2056973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2056976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2056981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2056984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2056987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2056990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2056993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2056996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2056999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057019 */     // MIs[0] round
     /* 2057019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057022 */     // MIs[0] policy
     /* 2057022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057032 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2057035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057061 */     // GIR_Coverage, 15558,
     /* 2057061 */     GIR_EraseRootFromParent_Done,
     /* 2057062 */   // Label 27337: @2057062
     /* 2057062 */   GIM_Try, /*On fail goto*//*Label 27338*/ GIMT_Encode4(2057156), // Rule ID 15559 //
     /* 2057067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2057078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2057081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2057084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2057087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057113 */     // MIs[0] round
     /* 2057113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057116 */     // MIs[0] policy
     /* 2057116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057126 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2057129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057151 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057155 */     // GIR_Coverage, 15559,
     /* 2057155 */     GIR_EraseRootFromParent_Done,
     /* 2057156 */   // Label 27338: @2057156
     /* 2057156 */   GIM_Try, /*On fail goto*//*Label 27339*/ GIMT_Encode4(2057250), // Rule ID 15562 //
     /* 2057161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2057181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057207 */     // MIs[0] round
     /* 2057207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057210 */     // MIs[0] policy
     /* 2057210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057220 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2057223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057225 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057249 */     // GIR_Coverage, 15562,
     /* 2057249 */     GIR_EraseRootFromParent_Done,
     /* 2057250 */   // Label 27339: @2057250
     /* 2057250 */   GIM_Try, /*On fail goto*//*Label 27340*/ GIMT_Encode4(2057344), // Rule ID 15563 //
     /* 2057255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2057266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2057269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2057272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2057275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2057278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057301 */     // MIs[0] round
     /* 2057301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057304 */     // MIs[0] policy
     /* 2057304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057314 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2057317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057319 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2057337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057339 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057343 */     // GIR_Coverage, 15563,
     /* 2057343 */     GIR_EraseRootFromParent_Done,
     /* 2057344 */   // Label 27340: @2057344
     /* 2057344 */   GIM_Try, /*On fail goto*//*Label 27341*/ GIMT_Encode4(2057438), // Rule ID 15566 //
     /* 2057349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2057369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057395 */     // MIs[0] round
     /* 2057395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057398 */     // MIs[0] policy
     /* 2057398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057408 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2057411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057413 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057433 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057437 */     // GIR_Coverage, 15566,
     /* 2057437 */     GIR_EraseRootFromParent_Done,
     /* 2057438 */   // Label 27341: @2057438
     /* 2057438 */   GIM_Try, /*On fail goto*//*Label 27342*/ GIMT_Encode4(2057532), // Rule ID 15567 //
     /* 2057443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2057454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2057457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2057460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2057463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2057466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057489 */     // MIs[0] round
     /* 2057489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057492 */     // MIs[0] policy
     /* 2057492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2057505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057507 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057527 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057531 */     // GIR_Coverage, 15567,
     /* 2057531 */     GIR_EraseRootFromParent_Done,
     /* 2057532 */   // Label 27342: @2057532
     /* 2057532 */   GIM_Try, /*On fail goto*//*Label 27343*/ GIMT_Encode4(2057626), // Rule ID 15570 //
     /* 2057537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2057557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057583 */     // MIs[0] round
     /* 2057583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057586 */     // MIs[0] policy
     /* 2057586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057596 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2057599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057601 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057621 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057625 */     // GIR_Coverage, 15570,
     /* 2057625 */     GIR_EraseRootFromParent_Done,
     /* 2057626 */   // Label 27343: @2057626
     /* 2057626 */   GIM_Try, /*On fail goto*//*Label 27344*/ GIMT_Encode4(2057720), // Rule ID 15571 //
     /* 2057631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2057642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2057645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2057648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2057651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2057654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2057661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2057673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057677 */     // MIs[0] round
     /* 2057677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057680 */     // MIs[0] policy
     /* 2057680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057690 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2057693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057695 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057719 */     // GIR_Coverage, 15571,
     /* 2057719 */     GIR_EraseRootFromParent_Done,
     /* 2057720 */   // Label 27344: @2057720
     /* 2057720 */   GIM_Try, /*On fail goto*//*Label 27345*/ GIMT_Encode4(2057814), // Rule ID 15574 //
     /* 2057725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2057745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057771 */     // MIs[0] round
     /* 2057771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057774 */     // MIs[0] policy
     /* 2057774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057784 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2057787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057789 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057813 */     // GIR_Coverage, 15574,
     /* 2057813 */     GIR_EraseRootFromParent_Done,
     /* 2057814 */   // Label 27345: @2057814
     /* 2057814 */   GIM_Try, /*On fail goto*//*Label 27346*/ GIMT_Encode4(2057908), // Rule ID 15575 //
     /* 2057819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2057822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2057830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2057833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2057836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2057839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2057842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2057845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2057849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2057861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057865 */     // MIs[0] round
     /* 2057865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057868 */     // MIs[0] policy
     /* 2057868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057878 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2057878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2057881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057883 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2057901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057903 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2057906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2057907 */     // GIR_Coverage, 15575,
     /* 2057907 */     GIR_EraseRootFromParent_Done,
     /* 2057908 */   // Label 27346: @2057908
     /* 2057908 */   GIM_Try, /*On fail goto*//*Label 27347*/ GIMT_Encode4(2058002), // Rule ID 15578 //
     /* 2057913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2057916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2057921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2057924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2057927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2057930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2057933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2057936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2057939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2057943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2057955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2057959 */     // MIs[0] round
     /* 2057959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2057962 */     // MIs[0] policy
     /* 2057962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2057965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2057972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2057972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2057975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2057977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2057979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2057981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2057983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2057985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2057987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2057992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2057995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2057997 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058001 */     // GIR_Coverage, 15578,
     /* 2058001 */     GIR_EraseRootFromParent_Done,
     /* 2058002 */   // Label 27347: @2058002
     /* 2058002 */   GIM_Try, /*On fail goto*//*Label 27348*/ GIMT_Encode4(2058096), // Rule ID 15579 //
     /* 2058007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2058018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2058021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2058024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2058027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2058037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2058049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058053 */     // MIs[0] round
     /* 2058053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058056 */     // MIs[0] policy
     /* 2058056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058066 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2058069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058095 */     // GIR_Coverage, 15579,
     /* 2058095 */     GIR_EraseRootFromParent_Done,
     /* 2058096 */   // Label 27348: @2058096
     /* 2058096 */   GIM_Try, /*On fail goto*//*Label 27349*/ GIMT_Encode4(2058190), // Rule ID 15582 //
     /* 2058101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2058121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058147 */     // MIs[0] round
     /* 2058147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058150 */     // MIs[0] policy
     /* 2058150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058160 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2058163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058185 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058189 */     // GIR_Coverage, 15582,
     /* 2058189 */     GIR_EraseRootFromParent_Done,
     /* 2058190 */   // Label 27349: @2058190
     /* 2058190 */   GIM_Try, /*On fail goto*//*Label 27350*/ GIMT_Encode4(2058284), // Rule ID 15583 //
     /* 2058195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2058206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2058209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2058212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2058215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2058218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2058225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2058237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058241 */     // MIs[0] round
     /* 2058241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058244 */     // MIs[0] policy
     /* 2058244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058254 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2058257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058283 */     // GIR_Coverage, 15583,
     /* 2058283 */     GIR_EraseRootFromParent_Done,
     /* 2058284 */   // Label 27350: @2058284
     /* 2058284 */   GIM_Try, /*On fail goto*//*Label 27351*/ GIMT_Encode4(2058378), // Rule ID 15586 //
     /* 2058289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2058309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058335 */     // MIs[0] round
     /* 2058335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058338 */     // MIs[0] policy
     /* 2058338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058348 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2058351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058377 */     // GIR_Coverage, 15586,
     /* 2058377 */     GIR_EraseRootFromParent_Done,
     /* 2058378 */   // Label 27351: @2058378
     /* 2058378 */   GIM_Try, /*On fail goto*//*Label 27352*/ GIMT_Encode4(2058472), // Rule ID 15587 //
     /* 2058383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2058394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2058397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2058400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2058403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2058406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2058413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2058425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058429 */     // MIs[0] round
     /* 2058429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058432 */     // MIs[0] policy
     /* 2058432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058442 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2058445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058447 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2058465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058471 */     // GIR_Coverage, 15587,
     /* 2058471 */     GIR_EraseRootFromParent_Done,
     /* 2058472 */   // Label 27352: @2058472
     /* 2058472 */   GIM_Try, /*On fail goto*//*Label 27353*/ GIMT_Encode4(2058566), // Rule ID 15590 //
     /* 2058477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058523 */     // MIs[0] round
     /* 2058523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058526 */     // MIs[0] policy
     /* 2058526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058536 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2058539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058541 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058565 */     // GIR_Coverage, 15590,
     /* 2058565 */     GIR_EraseRootFromParent_Done,
     /* 2058566 */   // Label 27353: @2058566
     /* 2058566 */   GIM_Try, /*On fail goto*//*Label 27354*/ GIMT_Encode4(2058660), // Rule ID 15591 //
     /* 2058571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2058582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2058585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2058588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2058594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058617 */     // MIs[0] round
     /* 2058617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058620 */     // MIs[0] policy
     /* 2058620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058630 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF8_MASK),
     /* 2058633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058655 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058659 */     // GIR_Coverage, 15591,
     /* 2058659 */     GIR_EraseRootFromParent_Done,
     /* 2058660 */   // Label 27354: @2058660
     /* 2058660 */   GIM_Try, /*On fail goto*//*Label 27355*/ GIMT_Encode4(2058754), // Rule ID 15594 //
     /* 2058665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058711 */     // MIs[0] round
     /* 2058711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058714 */     // MIs[0] policy
     /* 2058714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058724 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2058727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058749 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058753 */     // GIR_Coverage, 15594,
     /* 2058753 */     GIR_EraseRootFromParent_Done,
     /* 2058754 */   // Label 27355: @2058754
     /* 2058754 */   GIM_Try, /*On fail goto*//*Label 27356*/ GIMT_Encode4(2058848), // Rule ID 15595 //
     /* 2058759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2058770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2058773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2058776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2058782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058805 */     // MIs[0] round
     /* 2058805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058808 */     // MIs[0] policy
     /* 2058808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058818 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2058818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2058821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058843 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058847 */     // GIR_Coverage, 15595,
     /* 2058847 */     GIR_EraseRootFromParent_Done,
     /* 2058848 */   // Label 27356: @2058848
     /* 2058848 */   GIM_Try, /*On fail goto*//*Label 27357*/ GIMT_Encode4(2058942), // Rule ID 15598 //
     /* 2058853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2058856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2058873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2058879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058899 */     // MIs[0] round
     /* 2058899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058902 */     // MIs[0] policy
     /* 2058902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2058912 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2058912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2058915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2058917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2058919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2058921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2058923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2058925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2058927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2058932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2058935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2058937 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2058940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2058941 */     // GIR_Coverage, 15598,
     /* 2058941 */     GIR_EraseRootFromParent_Done,
     /* 2058942 */   // Label 27357: @2058942
     /* 2058942 */   GIM_Try, /*On fail goto*//*Label 27358*/ GIMT_Encode4(2059036), // Rule ID 15599 //
     /* 2058947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2058950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2058955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2058958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2058961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2058964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2058967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2058970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2058973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2058977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2058985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2058989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2058993 */     // MIs[0] round
     /* 2058993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2058996 */     // MIs[0] policy
     /* 2058996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2058999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059006 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2059009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059035 */     // GIR_Coverage, 15599,
     /* 2059035 */     GIR_EraseRootFromParent_Done,
     /* 2059036 */   // Label 27358: @2059036
     /* 2059036 */   GIM_Try, /*On fail goto*//*Label 27359*/ GIMT_Encode4(2059130), // Rule ID 15602 //
     /* 2059041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059087 */     // MIs[0] round
     /* 2059087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059090 */     // MIs[0] policy
     /* 2059090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059100 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2059103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059129 */     // GIR_Coverage, 15602,
     /* 2059129 */     GIR_EraseRootFromParent_Done,
     /* 2059130 */   // Label 27359: @2059130
     /* 2059130 */   GIM_Try, /*On fail goto*//*Label 27360*/ GIMT_Encode4(2059224), // Rule ID 15603 //
     /* 2059135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2059146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2059149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2059152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059181 */     // MIs[0] round
     /* 2059181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059184 */     // MIs[0] policy
     /* 2059184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059194 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF4_MASK),
     /* 2059197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059219 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059223 */     // GIR_Coverage, 15603,
     /* 2059223 */     GIR_EraseRootFromParent_Done,
     /* 2059224 */   // Label 27360: @2059224
     /* 2059224 */   GIM_Try, /*On fail goto*//*Label 27361*/ GIMT_Encode4(2059318), // Rule ID 15606 //
     /* 2059229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059275 */     // MIs[0] round
     /* 2059275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059278 */     // MIs[0] policy
     /* 2059278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059288 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2059291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059313 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059317 */     // GIR_Coverage, 15606,
     /* 2059317 */     GIR_EraseRootFromParent_Done,
     /* 2059318 */   // Label 27361: @2059318
     /* 2059318 */   GIM_Try, /*On fail goto*//*Label 27362*/ GIMT_Encode4(2059412), // Rule ID 15607 //
     /* 2059323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2059334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2059337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2059340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2059346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059369 */     // MIs[0] round
     /* 2059369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059372 */     // MIs[0] policy
     /* 2059372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059382 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2059385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059407 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059411 */     // GIR_Coverage, 15607,
     /* 2059411 */     GIR_EraseRootFromParent_Done,
     /* 2059412 */   // Label 27362: @2059412
     /* 2059412 */   GIM_Try, /*On fail goto*//*Label 27363*/ GIMT_Encode4(2059506), // Rule ID 15610 //
     /* 2059417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059463 */     // MIs[0] round
     /* 2059463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059466 */     // MIs[0] policy
     /* 2059466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059476 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2059479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059501 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059505 */     // GIR_Coverage, 15610,
     /* 2059505 */     GIR_EraseRootFromParent_Done,
     /* 2059506 */   // Label 27363: @2059506
     /* 2059506 */   GIM_Try, /*On fail goto*//*Label 27364*/ GIMT_Encode4(2059600), // Rule ID 15611 //
     /* 2059511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2059522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2059525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2059528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2059534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059557 */     // MIs[0] round
     /* 2059557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059560 */     // MIs[0] policy
     /* 2059560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059570 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_MF2_MASK),
     /* 2059573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2059593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059599 */     // GIR_Coverage, 15611,
     /* 2059599 */     GIR_EraseRootFromParent_Done,
     /* 2059600 */   // Label 27364: @2059600
     /* 2059600 */   GIM_Try, /*On fail goto*//*Label 27365*/ GIMT_Encode4(2059694), // Rule ID 15614 //
     /* 2059605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059651 */     // MIs[0] round
     /* 2059651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059654 */     // MIs[0] policy
     /* 2059654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059664 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2059667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059693 */     // GIR_Coverage, 15614,
     /* 2059693 */     GIR_EraseRootFromParent_Done,
     /* 2059694 */   // Label 27365: @2059694
     /* 2059694 */   GIM_Try, /*On fail goto*//*Label 27366*/ GIMT_Encode4(2059788), // Rule ID 15615 //
     /* 2059699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2059710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2059713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2059716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2059722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059745 */     // MIs[0] round
     /* 2059745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059748 */     // MIs[0] policy
     /* 2059748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059758 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11493:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2059761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2059781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059787 */     // GIR_Coverage, 15615,
     /* 2059787 */     GIR_EraseRootFromParent_Done,
     /* 2059788 */   // Label 27366: @2059788
     /* 2059788 */   GIM_Try, /*On fail goto*//*Label 27367*/ GIMT_Encode4(2059882), // Rule ID 15618 //
     /* 2059793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2059813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2059819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059839 */     // MIs[0] round
     /* 2059839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059842 */     // MIs[0] policy
     /* 2059842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059852 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2059852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2059855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059877 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059881 */     // GIR_Coverage, 15618,
     /* 2059881 */     GIR_EraseRootFromParent_Done,
     /* 2059882 */   // Label 27367: @2059882
     /* 2059882 */   GIM_Try, /*On fail goto*//*Label 27368*/ GIMT_Encode4(2059976), // Rule ID 15619 //
     /* 2059887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2059890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2059898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2059901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2059904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2059907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2059910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2059913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2059917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2059925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2059929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2059933 */     // MIs[0] round
     /* 2059933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2059936 */     // MIs[0] policy
     /* 2059936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2059939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2059946 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11493:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2059946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2059949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2059951 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2059953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2059955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2059957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2059959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2059961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2059966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2059969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2059971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2059974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2059975 */     // GIR_Coverage, 15619,
     /* 2059975 */     GIR_EraseRootFromParent_Done,
     /* 2059976 */   // Label 27368: @2059976
     /* 2059976 */   GIM_Try, /*On fail goto*//*Label 27369*/ GIMT_Encode4(2060070), // Rule ID 15622 //
     /* 2059981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2059984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2059989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2059992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2059995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2059998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060027 */     // MIs[0] round
     /* 2060027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060030 */     // MIs[0] policy
     /* 2060030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060040 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2060043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060045 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060069 */     // GIR_Coverage, 15622,
     /* 2060069 */     GIR_EraseRootFromParent_Done,
     /* 2060070 */   // Label 27369: @2060070
     /* 2060070 */   GIM_Try, /*On fail goto*//*Label 27370*/ GIMT_Encode4(2060164), // Rule ID 15623 //
     /* 2060075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2060086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2060089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2060092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2060098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2060105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2060113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060121 */     // MIs[0] round
     /* 2060121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060124 */     // MIs[0] policy
     /* 2060124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060134 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11493:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2060137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060139 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2060157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060159 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060163 */     // GIR_Coverage, 15623,
     /* 2060163 */     GIR_EraseRootFromParent_Done,
     /* 2060164 */   // Label 27370: @2060164
     /* 2060164 */   GIM_Try, /*On fail goto*//*Label 27371*/ GIMT_Encode4(2060258), // Rule ID 15626 //
     /* 2060169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060215 */     // MIs[0] round
     /* 2060215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060218 */     // MIs[0] policy
     /* 2060218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2060231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060233 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060257 */     // GIR_Coverage, 15626,
     /* 2060257 */     GIR_EraseRootFromParent_Done,
     /* 2060258 */   // Label 27371: @2060258
     /* 2060258 */   GIM_Try, /*On fail goto*//*Label 27372*/ GIMT_Encode4(2060352), // Rule ID 15627 //
     /* 2060263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2060274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2060277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2060280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060309 */     // MIs[0] round
     /* 2060309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060312 */     // MIs[0] policy
     /* 2060312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2060325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060327 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060347 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060351 */     // GIR_Coverage, 15627,
     /* 2060351 */     GIR_EraseRootFromParent_Done,
     /* 2060352 */   // Label 27372: @2060352
     /* 2060352 */   GIM_Try, /*On fail goto*//*Label 27373*/ GIMT_Encode4(2060446), // Rule ID 15630 //
     /* 2060357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060403 */     // MIs[0] round
     /* 2060403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060406 */     // MIs[0] policy
     /* 2060406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060416 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2060419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060421 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060445 */     // GIR_Coverage, 15630,
     /* 2060445 */     GIR_EraseRootFromParent_Done,
     /* 2060446 */   // Label 27373: @2060446
     /* 2060446 */   GIM_Try, /*On fail goto*//*Label 27374*/ GIMT_Encode4(2060540), // Rule ID 15631 //
     /* 2060451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2060462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2060465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2060468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2060474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060497 */     // MIs[0] round
     /* 2060497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060500 */     // MIs[0] policy
     /* 2060500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060510 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2060513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060515 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060539 */     // GIR_Coverage, 15631,
     /* 2060539 */     GIR_EraseRootFromParent_Done,
     /* 2060540 */   // Label 27374: @2060540
     /* 2060540 */   GIM_Try, /*On fail goto*//*Label 27375*/ GIMT_Encode4(2060634), // Rule ID 15634 //
     /* 2060545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060591 */     // MIs[0] round
     /* 2060591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060594 */     // MIs[0] policy
     /* 2060594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060604 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2060607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060609 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060633 */     // GIR_Coverage, 15634,
     /* 2060633 */     GIR_EraseRootFromParent_Done,
     /* 2060634 */   // Label 27375: @2060634
     /* 2060634 */   GIM_Try, /*On fail goto*//*Label 27376*/ GIMT_Encode4(2060728), // Rule ID 15635 //
     /* 2060639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2060650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2060653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2060656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2060662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2060669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2060677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060685 */     // MIs[0] round
     /* 2060685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060688 */     // MIs[0] policy
     /* 2060688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060698 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2060701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2060721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060723 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060727 */     // GIR_Coverage, 15635,
     /* 2060727 */     GIR_EraseRootFromParent_Done,
     /* 2060728 */   // Label 27376: @2060728
     /* 2060728 */   GIM_Try, /*On fail goto*//*Label 27377*/ GIMT_Encode4(2060822), // Rule ID 15638 //
     /* 2060733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060779 */     // MIs[0] round
     /* 2060779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060782 */     // MIs[0] policy
     /* 2060782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060792 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2060795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060817 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060821 */     // GIR_Coverage, 15638,
     /* 2060821 */     GIR_EraseRootFromParent_Done,
     /* 2060822 */   // Label 27377: @2060822
     /* 2060822 */   GIM_Try, /*On fail goto*//*Label 27378*/ GIMT_Encode4(2060916), // Rule ID 15639 //
     /* 2060827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2060830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2060838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2060841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2060844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2060847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2060850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2060853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2060857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2060865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060873 */     // MIs[0] round
     /* 2060873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060876 */     // MIs[0] policy
     /* 2060876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060886 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2060886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2060889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2060906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2060909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2060911 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2060914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2060915 */     // GIR_Coverage, 15639,
     /* 2060915 */     GIR_EraseRootFromParent_Done,
     /* 2060916 */   // Label 27378: @2060916
     /* 2060916 */   GIM_Try, /*On fail goto*//*Label 27379*/ GIMT_Encode4(2061010), // Rule ID 15642 //
     /* 2060921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2060924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2060929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2060932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2060935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2060938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2060941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2060944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2060947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2060951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2060959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2060963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2060967 */     // MIs[0] round
     /* 2060967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2060970 */     // MIs[0] policy
     /* 2060970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2060973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2060980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2060980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2060983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2060985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2060987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2060989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2060991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2060993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2060995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061009 */     // GIR_Coverage, 15642,
     /* 2061009 */     GIR_EraseRootFromParent_Done,
     /* 2061010 */   // Label 27379: @2061010
     /* 2061010 */   GIM_Try, /*On fail goto*//*Label 27380*/ GIMT_Encode4(2061104), // Rule ID 15643 //
     /* 2061015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2061026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2061029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2061032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061061 */     // MIs[0] round
     /* 2061061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061064 */     // MIs[0] policy
     /* 2061064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061074 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2061077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061099 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061103 */     // GIR_Coverage, 15643,
     /* 2061103 */     GIR_EraseRootFromParent_Done,
     /* 2061104 */   // Label 27380: @2061104
     /* 2061104 */   GIM_Try, /*On fail goto*//*Label 27381*/ GIMT_Encode4(2061198), // Rule ID 15646 //
     /* 2061109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061155 */     // MIs[0] round
     /* 2061155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061158 */     // MIs[0] policy
     /* 2061158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061168 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2061171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061173 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061193 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061197 */     // GIR_Coverage, 15646,
     /* 2061197 */     GIR_EraseRootFromParent_Done,
     /* 2061198 */   // Label 27381: @2061198
     /* 2061198 */   GIM_Try, /*On fail goto*//*Label 27382*/ GIMT_Encode4(2061292), // Rule ID 15647 //
     /* 2061203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2061214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2061217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2061220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2061226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061249 */     // MIs[0] round
     /* 2061249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061252 */     // MIs[0] policy
     /* 2061252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061262 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2061265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061267 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2061285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061291 */     // GIR_Coverage, 15647,
     /* 2061291 */     GIR_EraseRootFromParent_Done,
     /* 2061292 */   // Label 27382: @2061292
     /* 2061292 */   GIM_Try, /*On fail goto*//*Label 27383*/ GIMT_Encode4(2061386), // Rule ID 15650 //
     /* 2061297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061343 */     // MIs[0] round
     /* 2061343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061346 */     // MIs[0] policy
     /* 2061346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061356 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2061359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061361 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061381 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061385 */     // GIR_Coverage, 15650,
     /* 2061385 */     GIR_EraseRootFromParent_Done,
     /* 2061386 */   // Label 27383: @2061386
     /* 2061386 */   GIM_Try, /*On fail goto*//*Label 27384*/ GIMT_Encode4(2061480), // Rule ID 15651 //
     /* 2061391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2061402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2061405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2061408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2061414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2061421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2061429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061437 */     // MIs[0] round
     /* 2061437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061440 */     // MIs[0] policy
     /* 2061440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2061453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061475 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061479 */     // GIR_Coverage, 15651,
     /* 2061479 */     GIR_EraseRootFromParent_Done,
     /* 2061480 */   // Label 27384: @2061480
     /* 2061480 */   GIM_Try, /*On fail goto*//*Label 27385*/ GIMT_Encode4(2061574), // Rule ID 15654 //
     /* 2061485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061531 */     // MIs[0] round
     /* 2061531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061534 */     // MIs[0] policy
     /* 2061534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061544 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2061547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061569 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061573 */     // GIR_Coverage, 15654,
     /* 2061573 */     GIR_EraseRootFromParent_Done,
     /* 2061574 */   // Label 27385: @2061574
     /* 2061574 */   GIM_Try, /*On fail goto*//*Label 27386*/ GIMT_Encode4(2061668), // Rule ID 15655 //
     /* 2061579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2061590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2061593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2061596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2061602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2061609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2061617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061625 */     // MIs[0] round
     /* 2061625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061628 */     // MIs[0] policy
     /* 2061628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061638 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2061641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061663 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061667 */     // GIR_Coverage, 15655,
     /* 2061667 */     GIR_EraseRootFromParent_Done,
     /* 2061668 */   // Label 27386: @2061668
     /* 2061668 */   GIM_Try, /*On fail goto*//*Label 27387*/ GIMT_Encode4(2061762), // Rule ID 15658 //
     /* 2061673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2061676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2061693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061719 */     // MIs[0] round
     /* 2061719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061722 */     // MIs[0] policy
     /* 2061722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061732 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2061735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061761 */     // GIR_Coverage, 15658,
     /* 2061761 */     GIR_EraseRootFromParent_Done,
     /* 2061762 */   // Label 27387: @2061762
     /* 2061762 */   GIM_Try, /*On fail goto*//*Label 27388*/ GIMT_Encode4(2061856), // Rule ID 15659 //
     /* 2061767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2061770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2061778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2061781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2061784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2061787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2061790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2061797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2061805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2061809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061813 */     // MIs[0] round
     /* 2061813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061816 */     // MIs[0] policy
     /* 2061816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061826 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2061826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2061829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2061849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061855 */     // GIR_Coverage, 15659,
     /* 2061855 */     GIR_EraseRootFromParent_Done,
     /* 2061856 */   // Label 27388: @2061856
     /* 2061856 */   GIM_Try, /*On fail goto*//*Label 27389*/ GIMT_Encode4(2061950), // Rule ID 15662 //
     /* 2061861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2061864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2061872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2061875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2061878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2061881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2061884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2061887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2061891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2061907 */     // MIs[0] round
     /* 2061907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2061910 */     // MIs[0] policy
     /* 2061910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2061913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2061920 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2061920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2061923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2061925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2061927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2061929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2061931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2061933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2061935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2061940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2061943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2061945 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2061948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2061949 */     // GIR_Coverage, 15662,
     /* 2061949 */     GIR_EraseRootFromParent_Done,
     /* 2061950 */   // Label 27389: @2061950
     /* 2061950 */   GIM_Try, /*On fail goto*//*Label 27390*/ GIMT_Encode4(2062044), // Rule ID 15663 //
     /* 2061955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2061958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2061963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2061966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2061969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2061972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2061975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2061978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2061981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2061985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2061997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062001 */     // MIs[0] round
     /* 2062001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062004 */     // MIs[0] policy
     /* 2062004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062014 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M1_MASK),
     /* 2062017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062039 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062043 */     // GIR_Coverage, 15663,
     /* 2062043 */     GIR_EraseRootFromParent_Done,
     /* 2062044 */   // Label 27390: @2062044
     /* 2062044 */   GIM_Try, /*On fail goto*//*Label 27391*/ GIMT_Encode4(2062138), // Rule ID 15666 //
     /* 2062049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062095 */     // MIs[0] round
     /* 2062095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062098 */     // MIs[0] policy
     /* 2062098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062108 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2062111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062137 */     // GIR_Coverage, 15666,
     /* 2062137 */     GIR_EraseRootFromParent_Done,
     /* 2062138 */   // Label 27391: @2062138
     /* 2062138 */   GIM_Try, /*On fail goto*//*Label 27392*/ GIMT_Encode4(2062232), // Rule ID 15667 //
     /* 2062143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2062146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2062163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062189 */     // MIs[0] round
     /* 2062189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062192 */     // MIs[0] policy
     /* 2062192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062202 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M2_MASK),
     /* 2062205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062227 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062231 */     // GIR_Coverage, 15667,
     /* 2062231 */     GIR_EraseRootFromParent_Done,
     /* 2062232 */   // Label 27392: @2062232
     /* 2062232 */   GIM_Try, /*On fail goto*//*Label 27393*/ GIMT_Encode4(2062326), // Rule ID 15670 //
     /* 2062237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062283 */     // MIs[0] round
     /* 2062283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062286 */     // MIs[0] policy
     /* 2062286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062296 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2062299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062321 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062325 */     // GIR_Coverage, 15670,
     /* 2062325 */     GIR_EraseRootFromParent_Done,
     /* 2062326 */   // Label 27393: @2062326
     /* 2062326 */   GIM_Try, /*On fail goto*//*Label 27394*/ GIMT_Encode4(2062420), // Rule ID 15671 //
     /* 2062331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2062334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2062342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2062345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2062348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2062351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2062354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2062361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2062373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062377 */     // MIs[0] round
     /* 2062377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062380 */     // MIs[0] policy
     /* 2062380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062390 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M4_MASK),
     /* 2062393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062415 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062419 */     // GIR_Coverage, 15671,
     /* 2062419 */     GIR_EraseRootFromParent_Done,
     /* 2062420 */   // Label 27394: @2062420
     /* 2062420 */   GIM_Try, /*On fail goto*//*Label 27395*/ GIMT_Encode4(2062514), // Rule ID 15674 //
     /* 2062425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062471 */     // MIs[0] round
     /* 2062471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062474 */     // MIs[0] policy
     /* 2062474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062484 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062509 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062513 */     // GIR_Coverage, 15674,
     /* 2062513 */     GIR_EraseRootFromParent_Done,
     /* 2062514 */   // Label 27395: @2062514
     /* 2062514 */   GIM_Try, /*On fail goto*//*Label 27396*/ GIMT_Encode4(2062608), // Rule ID 15675 //
     /* 2062519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2062522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2062530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2062533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2062536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2062539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2062542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2062549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2062561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062565 */     // MIs[0] round
     /* 2062565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062568 */     // MIs[0] policy
     /* 2062568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062578 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VV_M8_MASK),
     /* 2062581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062603 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062607 */     // GIR_Coverage, 15675,
     /* 2062607 */     GIR_EraseRootFromParent_Done,
     /* 2062608 */   // Label 27396: @2062608
     /* 2062608 */   GIM_Try, /*On fail goto*//*Label 27397*/ GIMT_Encode4(2062702), // Rule ID 15678 //
     /* 2062613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2062624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2062627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2062630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062659 */     // MIs[0] round
     /* 2062659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062662 */     // MIs[0] policy
     /* 2062662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062672 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2062675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062697 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062701 */     // GIR_Coverage, 15678,
     /* 2062701 */     GIR_EraseRootFromParent_Done,
     /* 2062702 */   // Label 27397: @2062702
     /* 2062702 */   GIM_Try, /*On fail goto*//*Label 27398*/ GIMT_Encode4(2062796), // Rule ID 15679 //
     /* 2062707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2062710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2062718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2062721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2062724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2062730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2062737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2062745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062753 */     // MIs[0] round
     /* 2062753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062756 */     // MIs[0] policy
     /* 2062756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062766 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11493:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M1_MASK),
     /* 2062769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062771 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062795 */     // GIR_Coverage, 15679,
     /* 2062795 */     GIR_EraseRootFromParent_Done,
     /* 2062796 */   // Label 27398: @2062796
     /* 2062796 */   GIM_Try, /*On fail goto*//*Label 27399*/ GIMT_Encode4(2062890), // Rule ID 15682 //
     /* 2062801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2062821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2062827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062847 */     // MIs[0] round
     /* 2062847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062850 */     // MIs[0] policy
     /* 2062850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062860 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2062860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2062863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062865 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062889 */     // GIR_Coverage, 15682,
     /* 2062889 */     GIR_EraseRootFromParent_Done,
     /* 2062890 */   // Label 27399: @2062890
     /* 2062890 */   GIM_Try, /*On fail goto*//*Label 27400*/ GIMT_Encode4(2062984), // Rule ID 15683 //
     /* 2062895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2062898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2062906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2062909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2062912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2062915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2062918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2062921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2062925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2062933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2062937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2062941 */     // MIs[0] round
     /* 2062941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2062944 */     // MIs[0] policy
     /* 2062944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2062947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2062954 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11493:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2062954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M2_MASK),
     /* 2062957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2062959 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2062961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2062963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2062965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2062967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2062969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2062974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2062977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2062979 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2062982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2062983 */     // GIR_Coverage, 15683,
     /* 2062983 */     GIR_EraseRootFromParent_Done,
     /* 2062984 */   // Label 27400: @2062984
     /* 2062984 */   GIM_Try, /*On fail goto*//*Label 27401*/ GIMT_Encode4(2063078), // Rule ID 15686 //
     /* 2062989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2062992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2062997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2063000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2063003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2063006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063035 */     // MIs[0] round
     /* 2063035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063038 */     // MIs[0] policy
     /* 2063038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063048 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2063051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063053 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063073 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063077 */     // GIR_Coverage, 15686,
     /* 2063077 */     GIR_EraseRootFromParent_Done,
     /* 2063078 */   // Label 27401: @2063078
     /* 2063078 */   GIM_Try, /*On fail goto*//*Label 27402*/ GIMT_Encode4(2063172), // Rule ID 15687 //
     /* 2063083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2063086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2063094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2063097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2063100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2063113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2063121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063129 */     // MIs[0] round
     /* 2063129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063132 */     // MIs[0] policy
     /* 2063132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063142 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11493:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M4_MASK),
     /* 2063145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063147 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063171 */     // GIR_Coverage, 15687,
     /* 2063171 */     GIR_EraseRootFromParent_Done,
     /* 2063172 */   // Label 27402: @2063172
     /* 2063172 */   GIM_Try, /*On fail goto*//*Label 27403*/ GIMT_Encode4(2063266), // Rule ID 15690 //
     /* 2063177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2063180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2063188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2063191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2063194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2063197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2063207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063223 */     // MIs[0] round
     /* 2063223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063226 */     // MIs[0] policy
     /* 2063226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063236 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2063239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063241 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063261 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063265 */     // GIR_Coverage, 15690,
     /* 2063265 */     GIR_EraseRootFromParent_Done,
     /* 2063266 */   // Label 27403: @2063266
     /* 2063266 */   GIM_Try, /*On fail goto*//*Label 27404*/ GIMT_Encode4(2063360), // Rule ID 15691 //
     /* 2063271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2063274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vsmul_mask),
     /* 2063279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2063282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2063285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2063288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2063291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2063294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2063301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2063309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2063313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063317 */     // MIs[0] round
     /* 2063317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063320 */     // MIs[0] policy
     /* 2063320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063330 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11493:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSMUL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSMUL_VX_M8_MASK),
     /* 2063333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063335 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2063353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063355 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2063358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063359 */     // GIR_Coverage, 15691,
     /* 2063359 */     GIR_EraseRootFromParent_Done,
     /* 2063360 */   // Label 27404: @2063360
     /* 2063360 */   GIM_Try, /*On fail goto*//*Label 27405*/ GIMT_Encode4(2063451), // Rule ID 15694 //
     /* 2063365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2063376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2063379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2063382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2063385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063411 */     // MIs[0] round
     /* 2063411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063414 */     // MIs[0] policy
     /* 2063414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063424 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2063427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063429 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063450 */     // GIR_Coverage, 15694,
     /* 2063450 */     GIR_EraseRootFromParent_Done,
     /* 2063451 */   // Label 27405: @2063451
     /* 2063451 */   GIM_Try, /*On fail goto*//*Label 27406*/ GIMT_Encode4(2063542), // Rule ID 15695 //
     /* 2063456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2063467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2063470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2063473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2063476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063502 */     // MIs[0] round
     /* 2063502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063505 */     // MIs[0] policy
     /* 2063505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063515 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF8_MASK),
     /* 2063518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063520 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063541 */     // GIR_Coverage, 15695,
     /* 2063541 */     GIR_EraseRootFromParent_Done,
     /* 2063542 */   // Label 27406: @2063542
     /* 2063542 */   GIM_Try, /*On fail goto*//*Label 27407*/ GIMT_Encode4(2063633), // Rule ID 15698 //
     /* 2063547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2063567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063593 */     // MIs[0] round
     /* 2063593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063596 */     // MIs[0] policy
     /* 2063596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063606 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2063609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063611 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063632 */     // GIR_Coverage, 15698,
     /* 2063632 */     GIR_EraseRootFromParent_Done,
     /* 2063633 */   // Label 27407: @2063633
     /* 2063633 */   GIM_Try, /*On fail goto*//*Label 27408*/ GIMT_Encode4(2063724), // Rule ID 15699 //
     /* 2063638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2063649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2063652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2063655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2063658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2063661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063684 */     // MIs[0] round
     /* 2063684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063687 */     // MIs[0] policy
     /* 2063687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063697 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2063700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063702 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063723 */     // GIR_Coverage, 15699,
     /* 2063723 */     GIR_EraseRootFromParent_Done,
     /* 2063724 */   // Label 27408: @2063724
     /* 2063724 */   GIM_Try, /*On fail goto*//*Label 27409*/ GIMT_Encode4(2063815), // Rule ID 15702 //
     /* 2063729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2063749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063775 */     // MIs[0] round
     /* 2063775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063778 */     // MIs[0] policy
     /* 2063778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063788 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2063791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063793 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063814 */     // GIR_Coverage, 15702,
     /* 2063814 */     GIR_EraseRootFromParent_Done,
     /* 2063815 */   // Label 27409: @2063815
     /* 2063815 */   GIM_Try, /*On fail goto*//*Label 27410*/ GIMT_Encode4(2063906), // Rule ID 15703 //
     /* 2063820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2063823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2063831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2063834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2063837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2063840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2063843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2063846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063866 */     // MIs[0] round
     /* 2063866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063869 */     // MIs[0] policy
     /* 2063869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063879 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2063879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2063882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063884 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2063902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063905 */     // GIR_Coverage, 15703,
     /* 2063905 */     GIR_EraseRootFromParent_Done,
     /* 2063906 */   // Label 27410: @2063906
     /* 2063906 */   GIM_Try, /*On fail goto*//*Label 27411*/ GIMT_Encode4(2063997), // Rule ID 15706 //
     /* 2063911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2063914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2063919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2063922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2063925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2063928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2063931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2063934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2063937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2063941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2063953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2063957 */     // MIs[0] round
     /* 2063957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2063960 */     // MIs[0] policy
     /* 2063960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2063963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2063970 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2063970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2063973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2063975 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2063977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2063979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2063981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2063983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2063985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2063990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2063993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2063995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2063996 */     // GIR_Coverage, 15706,
     /* 2063996 */     GIR_EraseRootFromParent_Done,
     /* 2063997 */   // Label 27411: @2063997
     /* 2063997 */   GIM_Try, /*On fail goto*//*Label 27412*/ GIMT_Encode4(2064088), // Rule ID 15707 //
     /* 2064002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2064013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2064016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2064019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2064022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064048 */     // MIs[0] round
     /* 2064048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064051 */     // MIs[0] policy
     /* 2064051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064061 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF4_MASK),
     /* 2064064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064066 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064087 */     // GIR_Coverage, 15707,
     /* 2064087 */     GIR_EraseRootFromParent_Done,
     /* 2064088 */   // Label 27412: @2064088
     /* 2064088 */   GIM_Try, /*On fail goto*//*Label 27413*/ GIMT_Encode4(2064179), // Rule ID 15710 //
     /* 2064093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2064104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2064107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2064110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2064113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064139 */     // MIs[0] round
     /* 2064139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064142 */     // MIs[0] policy
     /* 2064142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064152 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2064155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064157 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064178 */     // GIR_Coverage, 15710,
     /* 2064178 */     GIR_EraseRootFromParent_Done,
     /* 2064179 */   // Label 27413: @2064179
     /* 2064179 */   GIM_Try, /*On fail goto*//*Label 27414*/ GIMT_Encode4(2064270), // Rule ID 15711 //
     /* 2064184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2064195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2064198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2064201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2064204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064230 */     // MIs[0] round
     /* 2064230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064233 */     // MIs[0] policy
     /* 2064233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064243 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2064246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064248 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064269 */     // GIR_Coverage, 15711,
     /* 2064269 */     GIR_EraseRootFromParent_Done,
     /* 2064270 */   // Label 27414: @2064270
     /* 2064270 */   GIM_Try, /*On fail goto*//*Label 27415*/ GIMT_Encode4(2064361), // Rule ID 15714 //
     /* 2064275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2064286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2064289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2064292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2064295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064321 */     // MIs[0] round
     /* 2064321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064324 */     // MIs[0] policy
     /* 2064324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064334 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2064337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064339 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064360 */     // GIR_Coverage, 15714,
     /* 2064360 */     GIR_EraseRootFromParent_Done,
     /* 2064361 */   // Label 27415: @2064361
     /* 2064361 */   GIM_Try, /*On fail goto*//*Label 27416*/ GIMT_Encode4(2064452), // Rule ID 15715 //
     /* 2064366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2064377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2064380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2064383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2064386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2064389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064412 */     // MIs[0] round
     /* 2064412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064415 */     // MIs[0] policy
     /* 2064415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064425 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_MF2_MASK),
     /* 2064428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064430 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064451 */     // GIR_Coverage, 15715,
     /* 2064451 */     GIR_EraseRootFromParent_Done,
     /* 2064452 */   // Label 27416: @2064452
     /* 2064452 */   GIM_Try, /*On fail goto*//*Label 27417*/ GIMT_Encode4(2064543), // Rule ID 15718 //
     /* 2064457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2064468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2064471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2064474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2064477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064503 */     // MIs[0] round
     /* 2064503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064506 */     // MIs[0] policy
     /* 2064506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064516 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064542 */     // GIR_Coverage, 15718,
     /* 2064542 */     GIR_EraseRootFromParent_Done,
     /* 2064543 */   // Label 27417: @2064543
     /* 2064543 */   GIM_Try, /*On fail goto*//*Label 27418*/ GIMT_Encode4(2064634), // Rule ID 15719 //
     /* 2064548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2064559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2064562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2064565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2064568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2064571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064594 */     // MIs[0] round
     /* 2064594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064597 */     // MIs[0] policy
     /* 2064597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064607 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064612 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2064630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064633 */     // GIR_Coverage, 15719,
     /* 2064633 */     GIR_EraseRootFromParent_Done,
     /* 2064634 */   // Label 27418: @2064634
     /* 2064634 */   GIM_Try, /*On fail goto*//*Label 27419*/ GIMT_Encode4(2064725), // Rule ID 15722 //
     /* 2064639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2064659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064685 */     // MIs[0] round
     /* 2064685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064688 */     // MIs[0] policy
     /* 2064688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064698 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064703 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064724 */     // GIR_Coverage, 15722,
     /* 2064724 */     GIR_EraseRootFromParent_Done,
     /* 2064725 */   // Label 27419: @2064725
     /* 2064725 */   GIM_Try, /*On fail goto*//*Label 27420*/ GIMT_Encode4(2064816), // Rule ID 15723 //
     /* 2064730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2064741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2064744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2064747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2064750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2064753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064776 */     // MIs[0] round
     /* 2064776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064779 */     // MIs[0] policy
     /* 2064779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064789 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064794 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2064812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064815 */     // GIR_Coverage, 15723,
     /* 2064815 */     GIR_EraseRootFromParent_Done,
     /* 2064816 */   // Label 27420: @2064816
     /* 2064816 */   GIM_Try, /*On fail goto*//*Label 27421*/ GIMT_Encode4(2064907), // Rule ID 15726 //
     /* 2064821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2064824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2064841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2064847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064867 */     // MIs[0] round
     /* 2064867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064870 */     // MIs[0] policy
     /* 2064870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064880 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2064880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064885 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064906 */     // GIR_Coverage, 15726,
     /* 2064906 */     GIR_EraseRootFromParent_Done,
     /* 2064907 */   // Label 27421: @2064907
     /* 2064907 */   GIM_Try, /*On fail goto*//*Label 27422*/ GIMT_Encode4(2064998), // Rule ID 15727 //
     /* 2064912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2064915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2064920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2064923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2064926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2064929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2064932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2064935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2064938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2064942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2064954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2064958 */     // MIs[0] round
     /* 2064958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2064961 */     // MIs[0] policy
     /* 2064961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2064964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2064971 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2064971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2064974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2064976 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2064978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2064980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2064982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2064984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2064986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2064991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2064994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2064996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2064997 */     // GIR_Coverage, 15727,
     /* 2064997 */     GIR_EraseRootFromParent_Done,
     /* 2064998 */   // Label 27422: @2064998
     /* 2064998 */   GIM_Try, /*On fail goto*//*Label 27423*/ GIMT_Encode4(2065089), // Rule ID 15730 //
     /* 2065003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2065006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2065014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2065017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2065020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2065023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065049 */     // MIs[0] round
     /* 2065049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065052 */     // MIs[0] policy
     /* 2065052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065062 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2065065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065088 */     // GIR_Coverage, 15730,
     /* 2065088 */     GIR_EraseRootFromParent_Done,
     /* 2065089 */   // Label 27423: @2065089
     /* 2065089 */   GIM_Try, /*On fail goto*//*Label 27424*/ GIMT_Encode4(2065180), // Rule ID 15731 //
     /* 2065094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2065097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2065105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2065108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2065111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2065114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2065117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2065124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2065136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065140 */     // MIs[0] round
     /* 2065140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065143 */     // MIs[0] policy
     /* 2065143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065153 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M1_MASK),
     /* 2065156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065158 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2065176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065179 */     // GIR_Coverage, 15731,
     /* 2065179 */     GIR_EraseRootFromParent_Done,
     /* 2065180 */   // Label 27424: @2065180
     /* 2065180 */   GIM_Try, /*On fail goto*//*Label 27425*/ GIMT_Encode4(2065271), // Rule ID 15734 //
     /* 2065185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2065196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2065199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2065202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2065205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065231 */     // MIs[0] round
     /* 2065231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065234 */     // MIs[0] policy
     /* 2065234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065244 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2065247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065249 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065270 */     // GIR_Coverage, 15734,
     /* 2065270 */     GIR_EraseRootFromParent_Done,
     /* 2065271 */   // Label 27425: @2065271
     /* 2065271 */   GIM_Try, /*On fail goto*//*Label 27426*/ GIMT_Encode4(2065362), // Rule ID 15735 //
     /* 2065276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2065287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2065290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2065293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2065296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065322 */     // MIs[0] round
     /* 2065322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065325 */     // MIs[0] policy
     /* 2065325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065335 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2065338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065340 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065361 */     // GIR_Coverage, 15735,
     /* 2065361 */     GIR_EraseRootFromParent_Done,
     /* 2065362 */   // Label 27426: @2065362
     /* 2065362 */   GIM_Try, /*On fail goto*//*Label 27427*/ GIMT_Encode4(2065453), // Rule ID 15738 //
     /* 2065367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2065378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2065381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2065384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2065387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065413 */     // MIs[0] round
     /* 2065413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065416 */     // MIs[0] policy
     /* 2065416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065426 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2065429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065431 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065452 */     // GIR_Coverage, 15738,
     /* 2065452 */     GIR_EraseRootFromParent_Done,
     /* 2065453 */   // Label 27427: @2065453
     /* 2065453 */   GIM_Try, /*On fail goto*//*Label 27428*/ GIMT_Encode4(2065544), // Rule ID 15739 //
     /* 2065458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2065469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2065472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2065475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2065478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2065481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065504 */     // MIs[0] round
     /* 2065504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065507 */     // MIs[0] policy
     /* 2065507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065517 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2065520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065522 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065543 */     // GIR_Coverage, 15739,
     /* 2065543 */     GIR_EraseRootFromParent_Done,
     /* 2065544 */   // Label 27428: @2065544
     /* 2065544 */   GIM_Try, /*On fail goto*//*Label 27429*/ GIMT_Encode4(2065635), // Rule ID 15742 //
     /* 2065549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2065560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2065563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2065566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2065569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065595 */     // MIs[0] round
     /* 2065595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065598 */     // MIs[0] policy
     /* 2065598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065608 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2065611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065613 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065634 */     // GIR_Coverage, 15742,
     /* 2065634 */     GIR_EraseRootFromParent_Done,
     /* 2065635 */   // Label 27429: @2065635
     /* 2065635 */   GIM_Try, /*On fail goto*//*Label 27430*/ GIMT_Encode4(2065726), // Rule ID 15743 //
     /* 2065640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2065651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2065654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2065657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2065660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2065663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2065670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2065682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065686 */     // MIs[0] round
     /* 2065686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065689 */     // MIs[0] policy
     /* 2065689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065699 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2065702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065704 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2065722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065725 */     // GIR_Coverage, 15743,
     /* 2065725 */     GIR_EraseRootFromParent_Done,
     /* 2065726 */   // Label 27430: @2065726
     /* 2065726 */   GIM_Try, /*On fail goto*//*Label 27431*/ GIMT_Encode4(2065817), // Rule ID 15746 //
     /* 2065731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2065751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065777 */     // MIs[0] round
     /* 2065777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065780 */     // MIs[0] policy
     /* 2065780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2065793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065816 */     // GIR_Coverage, 15746,
     /* 2065816 */     GIR_EraseRootFromParent_Done,
     /* 2065817 */   // Label 27431: @2065817
     /* 2065817 */   GIM_Try, /*On fail goto*//*Label 27432*/ GIMT_Encode4(2065908), // Rule ID 15747 //
     /* 2065822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2065825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2065833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2065836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2065839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2065842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2065845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2065848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2065852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2065864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065868 */     // MIs[0] round
     /* 2065868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065871 */     // MIs[0] policy
     /* 2065871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065881 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2065881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2065884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065886 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065907 */     // GIR_Coverage, 15747,
     /* 2065907 */     GIR_EraseRootFromParent_Done,
     /* 2065908 */   // Label 27432: @2065908
     /* 2065908 */   GIM_Try, /*On fail goto*//*Label 27433*/ GIMT_Encode4(2065999), // Rule ID 15750 //
     /* 2065913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2065916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2065921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2065924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2065927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2065930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2065933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2065936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2065939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2065943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2065955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2065959 */     // MIs[0] round
     /* 2065959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2065962 */     // MIs[0] policy
     /* 2065962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2065965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2065972 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2065972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2065975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2065977 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2065979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2065981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2065983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2065985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2065987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2065992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2065995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2065997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2065998 */     // GIR_Coverage, 15750,
     /* 2065998 */     GIR_EraseRootFromParent_Done,
     /* 2065999 */   // Label 27433: @2065999
     /* 2065999 */   GIM_Try, /*On fail goto*//*Label 27434*/ GIMT_Encode4(2066090), // Rule ID 15751 //
     /* 2066004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2066015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2066018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2066021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2066024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066050 */     // MIs[0] round
     /* 2066050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066053 */     // MIs[0] policy
     /* 2066053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066063 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2066066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066068 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066089 */     // GIR_Coverage, 15751,
     /* 2066089 */     GIR_EraseRootFromParent_Done,
     /* 2066090 */   // Label 27434: @2066090
     /* 2066090 */   GIM_Try, /*On fail goto*//*Label 27435*/ GIMT_Encode4(2066181), // Rule ID 15754 //
     /* 2066095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2066106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2066109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2066112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2066115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2066118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066141 */     // MIs[0] round
     /* 2066141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066144 */     // MIs[0] policy
     /* 2066144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066154 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2066157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066159 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066180 */     // GIR_Coverage, 15754,
     /* 2066180 */     GIR_EraseRootFromParent_Done,
     /* 2066181 */   // Label 27435: @2066181
     /* 2066181 */   GIM_Try, /*On fail goto*//*Label 27436*/ GIMT_Encode4(2066272), // Rule ID 15755 //
     /* 2066186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2066197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2066200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2066203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2066206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2066209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066232 */     // MIs[0] round
     /* 2066232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066235 */     // MIs[0] policy
     /* 2066235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066245 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2066248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066250 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2066268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066271 */     // GIR_Coverage, 15755,
     /* 2066271 */     GIR_EraseRootFromParent_Done,
     /* 2066272 */   // Label 27436: @2066272
     /* 2066272 */   GIM_Try, /*On fail goto*//*Label 27437*/ GIMT_Encode4(2066363), // Rule ID 15758 //
     /* 2066277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2066288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2066291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2066294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2066297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066323 */     // MIs[0] round
     /* 2066323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066326 */     // MIs[0] policy
     /* 2066326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2066339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066362 */     // GIR_Coverage, 15758,
     /* 2066362 */     GIR_EraseRootFromParent_Done,
     /* 2066363 */   // Label 27437: @2066363
     /* 2066363 */   GIM_Try, /*On fail goto*//*Label 27438*/ GIMT_Encode4(2066454), // Rule ID 15759 //
     /* 2066368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2066379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2066382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2066385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2066388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2066391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066414 */     // MIs[0] round
     /* 2066414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066417 */     // MIs[0] policy
     /* 2066417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066427 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2066430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066432 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066453 */     // GIR_Coverage, 15759,
     /* 2066453 */     GIR_EraseRootFromParent_Done,
     /* 2066454 */   // Label 27438: @2066454
     /* 2066454 */   GIM_Try, /*On fail goto*//*Label 27439*/ GIMT_Encode4(2066545), // Rule ID 15762 //
     /* 2066459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2066470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2066473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2066476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2066479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066505 */     // MIs[0] round
     /* 2066505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066508 */     // MIs[0] policy
     /* 2066508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066518 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2066521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066523 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066544 */     // GIR_Coverage, 15762,
     /* 2066544 */     GIR_EraseRootFromParent_Done,
     /* 2066545 */   // Label 27439: @2066545
     /* 2066545 */   GIM_Try, /*On fail goto*//*Label 27440*/ GIMT_Encode4(2066636), // Rule ID 15763 //
     /* 2066550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2066561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2066564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2066567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2066570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2066573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2066580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2066592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066596 */     // MIs[0] round
     /* 2066596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066599 */     // MIs[0] policy
     /* 2066599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066609 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2066612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066614 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066635 */     // GIR_Coverage, 15763,
     /* 2066635 */     GIR_EraseRootFromParent_Done,
     /* 2066636 */   // Label 27440: @2066636
     /* 2066636 */   GIM_Try, /*On fail goto*//*Label 27441*/ GIMT_Encode4(2066727), // Rule ID 15766 //
     /* 2066641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2066644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2066661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066687 */     // MIs[0] round
     /* 2066687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066690 */     // MIs[0] policy
     /* 2066690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066700 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2066703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066705 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066726 */     // GIR_Coverage, 15766,
     /* 2066726 */     GIR_EraseRootFromParent_Done,
     /* 2066727 */   // Label 27441: @2066727
     /* 2066727 */   GIM_Try, /*On fail goto*//*Label 27442*/ GIMT_Encode4(2066818), // Rule ID 15767 //
     /* 2066732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2066735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2066743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2066746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2066749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2066752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2066755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2066762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2066774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066778 */     // MIs[0] round
     /* 2066778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066781 */     // MIs[0] policy
     /* 2066781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066791 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2066794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066796 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2066814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066817 */     // GIR_Coverage, 15767,
     /* 2066817 */     GIR_EraseRootFromParent_Done,
     /* 2066818 */   // Label 27442: @2066818
     /* 2066818 */   GIM_Try, /*On fail goto*//*Label 27443*/ GIMT_Encode4(2066909), // Rule ID 15770 //
     /* 2066823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2066826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2066849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066869 */     // MIs[0] round
     /* 2066869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066872 */     // MIs[0] policy
     /* 2066872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2066882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2066885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066887 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066908 */     // GIR_Coverage, 15770,
     /* 2066908 */     GIR_EraseRootFromParent_Done,
     /* 2066909 */   // Label 27443: @2066909
     /* 2066909 */   GIM_Try, /*On fail goto*//*Label 27444*/ GIMT_Encode4(2067000), // Rule ID 15771 //
     /* 2066914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2066917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2066922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2066925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2066928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2066931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2066934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2066937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2066940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2066944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2066956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2066960 */     // MIs[0] round
     /* 2066960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2066963 */     // MIs[0] policy
     /* 2066963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2066966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2066973 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2066973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M2_MASK),
     /* 2066976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2066978 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2066980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2066982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2066984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2066986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2066988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2066993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2066996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2066998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2066999 */     // GIR_Coverage, 15771,
     /* 2066999 */     GIR_EraseRootFromParent_Done,
     /* 2067000 */   // Label 27444: @2067000
     /* 2067000 */   GIM_Try, /*On fail goto*//*Label 27445*/ GIMT_Encode4(2067091), // Rule ID 15774 //
     /* 2067005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2067008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2067022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2067025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067051 */     // MIs[0] round
     /* 2067051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067054 */     // MIs[0] policy
     /* 2067054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067064 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2067067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067069 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067090 */     // GIR_Coverage, 15774,
     /* 2067090 */     GIR_EraseRootFromParent_Done,
     /* 2067091 */   // Label 27445: @2067091
     /* 2067091 */   GIM_Try, /*On fail goto*//*Label 27446*/ GIMT_Encode4(2067182), // Rule ID 15775 //
     /* 2067096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2067099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2067107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2067110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2067113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2067116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2067126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2067138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067142 */     // MIs[0] round
     /* 2067142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067145 */     // MIs[0] policy
     /* 2067145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067155 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M4_MASK),
     /* 2067158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067160 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067181 */     // GIR_Coverage, 15775,
     /* 2067181 */     GIR_EraseRootFromParent_Done,
     /* 2067182 */   // Label 27446: @2067182
     /* 2067182 */   GIM_Try, /*On fail goto*//*Label 27447*/ GIMT_Encode4(2067273), // Rule ID 15778 //
     /* 2067187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2067190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2067204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2067207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067233 */     // MIs[0] round
     /* 2067233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067236 */     // MIs[0] policy
     /* 2067236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067246 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2067249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067251 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067272 */     // GIR_Coverage, 15778,
     /* 2067272 */     GIR_EraseRootFromParent_Done,
     /* 2067273 */   // Label 27447: @2067273
     /* 2067273 */   GIM_Try, /*On fail goto*//*Label 27448*/ GIMT_Encode4(2067364), // Rule ID 15779 //
     /* 2067278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2067281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2067289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2067292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2067295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2067298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2067301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2067308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2067320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067324 */     // MIs[0] round
     /* 2067324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067327 */     // MIs[0] policy
     /* 2067327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067337 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VV_M8_MASK),
     /* 2067340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067342 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2067360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067363 */     // GIR_Coverage, 15779,
     /* 2067363 */     GIR_EraseRootFromParent_Done,
     /* 2067364 */   // Label 27448: @2067364
     /* 2067364 */   GIM_Try, /*On fail goto*//*Label 27449*/ GIMT_Encode4(2067455), // Rule ID 15782 //
     /* 2067369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2067380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2067383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2067386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067415 */     // MIs[0] round
     /* 2067415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067418 */     // MIs[0] policy
     /* 2067418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067428 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2067431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067433 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067454 */     // GIR_Coverage, 15782,
     /* 2067454 */     GIR_EraseRootFromParent_Done,
     /* 2067455 */   // Label 27449: @2067455
     /* 2067455 */   GIM_Try, /*On fail goto*//*Label 27450*/ GIMT_Encode4(2067546), // Rule ID 15783 //
     /* 2067460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2067471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2067474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2067477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067506 */     // MIs[0] round
     /* 2067506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067509 */     // MIs[0] policy
     /* 2067509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067519 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF8_MASK),
     /* 2067522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067524 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067545 */     // GIR_Coverage, 15783,
     /* 2067545 */     GIR_EraseRootFromParent_Done,
     /* 2067546 */   // Label 27450: @2067546
     /* 2067546 */   GIM_Try, /*On fail goto*//*Label 27451*/ GIMT_Encode4(2067637), // Rule ID 15786 //
     /* 2067551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2067562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2067565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067597 */     // MIs[0] round
     /* 2067597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067600 */     // MIs[0] policy
     /* 2067600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067610 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2067613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067636 */     // GIR_Coverage, 15786,
     /* 2067636 */     GIR_EraseRootFromParent_Done,
     /* 2067637 */   // Label 27451: @2067637
     /* 2067637 */   GIM_Try, /*On fail goto*//*Label 27452*/ GIMT_Encode4(2067728), // Rule ID 15787 //
     /* 2067642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2067653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2067656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2067659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2067665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067688 */     // MIs[0] round
     /* 2067688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067691 */     // MIs[0] policy
     /* 2067691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067701 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2067704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067706 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067727 */     // GIR_Coverage, 15787,
     /* 2067727 */     GIR_EraseRootFromParent_Done,
     /* 2067728 */   // Label 27452: @2067728
     /* 2067728 */   GIM_Try, /*On fail goto*//*Label 27453*/ GIMT_Encode4(2067819), // Rule ID 15790 //
     /* 2067733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067779 */     // MIs[0] round
     /* 2067779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067782 */     // MIs[0] policy
     /* 2067782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067792 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2067795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067797 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067818 */     // GIR_Coverage, 15790,
     /* 2067818 */     GIR_EraseRootFromParent_Done,
     /* 2067819 */   // Label 27453: @2067819
     /* 2067819 */   GIM_Try, /*On fail goto*//*Label 27454*/ GIMT_Encode4(2067910), // Rule ID 15791 //
     /* 2067824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2067827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2067835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2067838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2067841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2067844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2067847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2067850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067870 */     // MIs[0] round
     /* 2067870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067873 */     // MIs[0] policy
     /* 2067873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067883 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2067883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2067886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067888 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2067906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2067909 */     // GIR_Coverage, 15791,
     /* 2067909 */     GIR_EraseRootFromParent_Done,
     /* 2067910 */   // Label 27454: @2067910
     /* 2067910 */   GIM_Try, /*On fail goto*//*Label 27455*/ GIMT_Encode4(2068001), // Rule ID 15794 //
     /* 2067915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2067918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2067923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2067926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2067929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2067932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2067935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2067938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2067941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2067945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2067953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2067957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2067961 */     // MIs[0] round
     /* 2067961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2067964 */     // MIs[0] policy
     /* 2067964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2067967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2067974 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2067974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2067977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2067979 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2067981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2067983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2067985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2067987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2067989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2067994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2067997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2067999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068000 */     // GIR_Coverage, 15794,
     /* 2068000 */     GIR_EraseRootFromParent_Done,
     /* 2068001 */   // Label 27455: @2068001
     /* 2068001 */   GIM_Try, /*On fail goto*//*Label 27456*/ GIMT_Encode4(2068092), // Rule ID 15795 //
     /* 2068006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2068017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2068020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2068023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068052 */     // MIs[0] round
     /* 2068052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068055 */     // MIs[0] policy
     /* 2068055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068065 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF4_MASK),
     /* 2068068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068070 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068091 */     // GIR_Coverage, 15795,
     /* 2068091 */     GIR_EraseRootFromParent_Done,
     /* 2068092 */   // Label 27456: @2068092
     /* 2068092 */   GIM_Try, /*On fail goto*//*Label 27457*/ GIMT_Encode4(2068183), // Rule ID 15798 //
     /* 2068097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2068108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2068111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2068114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068143 */     // MIs[0] round
     /* 2068143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068146 */     // MIs[0] policy
     /* 2068146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068156 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2068159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068182 */     // GIR_Coverage, 15798,
     /* 2068182 */     GIR_EraseRootFromParent_Done,
     /* 2068183 */   // Label 27457: @2068183
     /* 2068183 */   GIM_Try, /*On fail goto*//*Label 27458*/ GIMT_Encode4(2068274), // Rule ID 15799 //
     /* 2068188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2068199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2068202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2068205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068234 */     // MIs[0] round
     /* 2068234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068237 */     // MIs[0] policy
     /* 2068237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068247 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2068250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068252 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068273 */     // GIR_Coverage, 15799,
     /* 2068273 */     GIR_EraseRootFromParent_Done,
     /* 2068274 */   // Label 27458: @2068274
     /* 2068274 */   GIM_Try, /*On fail goto*//*Label 27459*/ GIMT_Encode4(2068365), // Rule ID 15802 //
     /* 2068279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2068290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2068293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2068296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068325 */     // MIs[0] round
     /* 2068325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068328 */     // MIs[0] policy
     /* 2068328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068338 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2068341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068343 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068364 */     // GIR_Coverage, 15802,
     /* 2068364 */     GIR_EraseRootFromParent_Done,
     /* 2068365 */   // Label 27459: @2068365
     /* 2068365 */   GIM_Try, /*On fail goto*//*Label 27460*/ GIMT_Encode4(2068456), // Rule ID 15803 //
     /* 2068370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2068381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2068384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2068387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2068393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068416 */     // MIs[0] round
     /* 2068416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068419 */     // MIs[0] policy
     /* 2068419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068429 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_MF2_MASK),
     /* 2068432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068434 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068455 */     // GIR_Coverage, 15803,
     /* 2068455 */     GIR_EraseRootFromParent_Done,
     /* 2068456 */   // Label 27460: @2068456
     /* 2068456 */   GIM_Try, /*On fail goto*//*Label 27461*/ GIMT_Encode4(2068547), // Rule ID 15806 //
     /* 2068461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068507 */     // MIs[0] round
     /* 2068507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068510 */     // MIs[0] policy
     /* 2068510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068520 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068525 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068546 */     // GIR_Coverage, 15806,
     /* 2068546 */     GIR_EraseRootFromParent_Done,
     /* 2068547 */   // Label 27461: @2068547
     /* 2068547 */   GIM_Try, /*On fail goto*//*Label 27462*/ GIMT_Encode4(2068638), // Rule ID 15807 //
     /* 2068552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2068563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2068566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2068569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2068575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068598 */     // MIs[0] round
     /* 2068598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068601 */     // MIs[0] policy
     /* 2068601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068611 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11533:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068616 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2068634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068637 */     // GIR_Coverage, 15807,
     /* 2068637 */     GIR_EraseRootFromParent_Done,
     /* 2068638 */   // Label 27462: @2068638
     /* 2068638 */   GIM_Try, /*On fail goto*//*Label 27463*/ GIMT_Encode4(2068729), // Rule ID 15810 //
     /* 2068643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068689 */     // MIs[0] round
     /* 2068689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068692 */     // MIs[0] policy
     /* 2068692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068702 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068707 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068728 */     // GIR_Coverage, 15810,
     /* 2068728 */     GIR_EraseRootFromParent_Done,
     /* 2068729 */   // Label 27463: @2068729
     /* 2068729 */   GIM_Try, /*On fail goto*//*Label 27464*/ GIMT_Encode4(2068820), // Rule ID 15811 //
     /* 2068734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2068745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2068748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2068751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2068757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068780 */     // MIs[0] round
     /* 2068780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068783 */     // MIs[0] policy
     /* 2068783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068793 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11533:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068798 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2068816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068819 */     // GIR_Coverage, 15811,
     /* 2068819 */     GIR_EraseRootFromParent_Done,
     /* 2068820 */   // Label 27464: @2068820
     /* 2068820 */   GIM_Try, /*On fail goto*//*Label 27465*/ GIMT_Encode4(2068911), // Rule ID 15814 //
     /* 2068825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2068828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2068845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2068851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068871 */     // MIs[0] round
     /* 2068871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068874 */     // MIs[0] policy
     /* 2068874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068884 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2068884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2068909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2068910 */     // GIR_Coverage, 15814,
     /* 2068910 */     GIR_EraseRootFromParent_Done,
     /* 2068911 */   // Label 27465: @2068911
     /* 2068911 */   GIM_Try, /*On fail goto*//*Label 27466*/ GIMT_Encode4(2069002), // Rule ID 15815 //
     /* 2068916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2068919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2068924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2068927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2068930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2068933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2068936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2068939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2068942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2068946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2068954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2068958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2068962 */     // MIs[0] round
     /* 2068962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2068965 */     // MIs[0] policy
     /* 2068965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2068968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2068975 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11533:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2068975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2068978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2068980 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2068982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2068984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2068986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2068988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2068990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2068995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2068998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069001 */     // GIR_Coverage, 15815,
     /* 2069001 */     GIR_EraseRootFromParent_Done,
     /* 2069002 */   // Label 27466: @2069002
     /* 2069002 */   GIM_Try, /*On fail goto*//*Label 27467*/ GIMT_Encode4(2069093), // Rule ID 15818 //
     /* 2069007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2069010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2069018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2069021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2069024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069053 */     // MIs[0] round
     /* 2069053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069056 */     // MIs[0] policy
     /* 2069056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069066 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2069069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069071 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069092 */     // GIR_Coverage, 15818,
     /* 2069092 */     GIR_EraseRootFromParent_Done,
     /* 2069093 */   // Label 27467: @2069093
     /* 2069093 */   GIM_Try, /*On fail goto*//*Label 27468*/ GIMT_Encode4(2069184), // Rule ID 15819 //
     /* 2069098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2069101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2069109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2069112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2069115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2069121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2069128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2069136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069144 */     // MIs[0] round
     /* 2069144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069147 */     // MIs[0] policy
     /* 2069147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069157 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11533:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M1_MASK),
     /* 2069160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069162 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2069180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069183 */     // GIR_Coverage, 15819,
     /* 2069183 */     GIR_EraseRootFromParent_Done,
     /* 2069184 */   // Label 27468: @2069184
     /* 2069184 */   GIM_Try, /*On fail goto*//*Label 27469*/ GIMT_Encode4(2069275), // Rule ID 15822 //
     /* 2069189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2069200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2069203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2069206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069235 */     // MIs[0] round
     /* 2069235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069238 */     // MIs[0] policy
     /* 2069238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2069251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069253 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069274 */     // GIR_Coverage, 15822,
     /* 2069274 */     GIR_EraseRootFromParent_Done,
     /* 2069275 */   // Label 27469: @2069275
     /* 2069275 */   GIM_Try, /*On fail goto*//*Label 27470*/ GIMT_Encode4(2069366), // Rule ID 15823 //
     /* 2069280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2069291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2069294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2069297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069326 */     // MIs[0] round
     /* 2069326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069329 */     // MIs[0] policy
     /* 2069329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069339 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2069342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069344 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069365 */     // GIR_Coverage, 15823,
     /* 2069365 */     GIR_EraseRootFromParent_Done,
     /* 2069366 */   // Label 27470: @2069366
     /* 2069366 */   GIM_Try, /*On fail goto*//*Label 27471*/ GIMT_Encode4(2069457), // Rule ID 15826 //
     /* 2069371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2069382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2069385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2069388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069417 */     // MIs[0] round
     /* 2069417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069420 */     // MIs[0] policy
     /* 2069420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069430 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2069433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069456 */     // GIR_Coverage, 15826,
     /* 2069456 */     GIR_EraseRootFromParent_Done,
     /* 2069457 */   // Label 27471: @2069457
     /* 2069457 */   GIM_Try, /*On fail goto*//*Label 27472*/ GIMT_Encode4(2069548), // Rule ID 15827 //
     /* 2069462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2069473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2069476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2069479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2069485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069508 */     // MIs[0] round
     /* 2069508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069511 */     // MIs[0] policy
     /* 2069511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069521 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2069524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069526 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069547 */     // GIR_Coverage, 15827,
     /* 2069547 */     GIR_EraseRootFromParent_Done,
     /* 2069548 */   // Label 27472: @2069548
     /* 2069548 */   GIM_Try, /*On fail goto*//*Label 27473*/ GIMT_Encode4(2069639), // Rule ID 15830 //
     /* 2069553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2069564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2069567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2069570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2069576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069599 */     // MIs[0] round
     /* 2069599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069602 */     // MIs[0] policy
     /* 2069602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069612 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2069615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069617 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069638 */     // GIR_Coverage, 15830,
     /* 2069638 */     GIR_EraseRootFromParent_Done,
     /* 2069639 */   // Label 27473: @2069639
     /* 2069639 */   GIM_Try, /*On fail goto*//*Label 27474*/ GIMT_Encode4(2069730), // Rule ID 15831 //
     /* 2069644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2069655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2069658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2069661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2069667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2069674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2069682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069690 */     // MIs[0] round
     /* 2069690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069693 */     // MIs[0] policy
     /* 2069693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069703 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2069706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069708 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2069726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069729 */     // GIR_Coverage, 15831,
     /* 2069729 */     GIR_EraseRootFromParent_Done,
     /* 2069730 */   // Label 27474: @2069730
     /* 2069730 */   GIM_Try, /*On fail goto*//*Label 27475*/ GIMT_Encode4(2069821), // Rule ID 15834 //
     /* 2069735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069781 */     // MIs[0] round
     /* 2069781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069784 */     // MIs[0] policy
     /* 2069784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2069797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069799 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069820 */     // GIR_Coverage, 15834,
     /* 2069820 */     GIR_EraseRootFromParent_Done,
     /* 2069821 */   // Label 27475: @2069821
     /* 2069821 */   GIM_Try, /*On fail goto*//*Label 27476*/ GIMT_Encode4(2069912), // Rule ID 15835 //
     /* 2069826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2069829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2069837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2069840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2069843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2069846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2069849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2069852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2069856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2069864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069872 */     // MIs[0] round
     /* 2069872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069875 */     // MIs[0] policy
     /* 2069875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069885 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2069885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2069888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069890 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2069910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2069911 */     // GIR_Coverage, 15835,
     /* 2069911 */     GIR_EraseRootFromParent_Done,
     /* 2069912 */   // Label 27476: @2069912
     /* 2069912 */   GIM_Try, /*On fail goto*//*Label 27477*/ GIMT_Encode4(2070003), // Rule ID 15838 //
     /* 2069917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2069920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2069925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2069928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2069931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2069934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2069937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2069940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2069943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2069947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2069955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2069959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2069963 */     // MIs[0] round
     /* 2069963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2069966 */     // MIs[0] policy
     /* 2069966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2069969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2069976 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2069976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2069979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2069981 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2069983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2069985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2069987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2069989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2069991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2069996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2069999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070002 */     // GIR_Coverage, 15838,
     /* 2070002 */     GIR_EraseRootFromParent_Done,
     /* 2070003 */   // Label 27477: @2070003
     /* 2070003 */   GIM_Try, /*On fail goto*//*Label 27478*/ GIMT_Encode4(2070094), // Rule ID 15839 //
     /* 2070008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2070019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2070022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2070025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070054 */     // MIs[0] round
     /* 2070054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070057 */     // MIs[0] policy
     /* 2070057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070067 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2070070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070072 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070093 */     // GIR_Coverage, 15839,
     /* 2070093 */     GIR_EraseRootFromParent_Done,
     /* 2070094 */   // Label 27478: @2070094
     /* 2070094 */   GIM_Try, /*On fail goto*//*Label 27479*/ GIMT_Encode4(2070185), // Rule ID 15842 //
     /* 2070099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2070110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2070113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2070116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2070122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070145 */     // MIs[0] round
     /* 2070145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070148 */     // MIs[0] policy
     /* 2070148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070158 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2070161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070163 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070184 */     // GIR_Coverage, 15842,
     /* 2070184 */     GIR_EraseRootFromParent_Done,
     /* 2070185 */   // Label 27479: @2070185
     /* 2070185 */   GIM_Try, /*On fail goto*//*Label 27480*/ GIMT_Encode4(2070276), // Rule ID 15843 //
     /* 2070190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2070201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2070204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2070207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2070213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070236 */     // MIs[0] round
     /* 2070236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070239 */     // MIs[0] policy
     /* 2070239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070249 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2070252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070254 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2070272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070275 */     // GIR_Coverage, 15843,
     /* 2070275 */     GIR_EraseRootFromParent_Done,
     /* 2070276 */   // Label 27480: @2070276
     /* 2070276 */   GIM_Try, /*On fail goto*//*Label 27481*/ GIMT_Encode4(2070367), // Rule ID 15846 //
     /* 2070281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2070292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2070295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2070298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070327 */     // MIs[0] round
     /* 2070327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070330 */     // MIs[0] policy
     /* 2070330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2070343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070345 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070366 */     // GIR_Coverage, 15846,
     /* 2070366 */     GIR_EraseRootFromParent_Done,
     /* 2070367 */   // Label 27481: @2070367
     /* 2070367 */   GIM_Try, /*On fail goto*//*Label 27482*/ GIMT_Encode4(2070458), // Rule ID 15847 //
     /* 2070372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2070383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2070386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2070389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2070395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070418 */     // MIs[0] round
     /* 2070418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070421 */     // MIs[0] policy
     /* 2070421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070431 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2070434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070436 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070457 */     // GIR_Coverage, 15847,
     /* 2070457 */     GIR_EraseRootFromParent_Done,
     /* 2070458 */   // Label 27482: @2070458
     /* 2070458 */   GIM_Try, /*On fail goto*//*Label 27483*/ GIMT_Encode4(2070549), // Rule ID 15850 //
     /* 2070463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2070474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2070477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2070480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070509 */     // MIs[0] round
     /* 2070509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070512 */     // MIs[0] policy
     /* 2070512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070522 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2070525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070527 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070548 */     // GIR_Coverage, 15850,
     /* 2070548 */     GIR_EraseRootFromParent_Done,
     /* 2070549 */   // Label 27483: @2070549
     /* 2070549 */   GIM_Try, /*On fail goto*//*Label 27484*/ GIMT_Encode4(2070640), // Rule ID 15851 //
     /* 2070554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2070565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2070568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2070571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2070577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2070584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2070592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070600 */     // MIs[0] round
     /* 2070600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070603 */     // MIs[0] policy
     /* 2070603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070613 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2070616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070618 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070639 */     // GIR_Coverage, 15851,
     /* 2070639 */     GIR_EraseRootFromParent_Done,
     /* 2070640 */   // Label 27484: @2070640
     /* 2070640 */   GIM_Try, /*On fail goto*//*Label 27485*/ GIMT_Encode4(2070731), // Rule ID 15854 //
     /* 2070645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2070648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2070656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2070659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070691 */     // MIs[0] round
     /* 2070691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070694 */     // MIs[0] policy
     /* 2070694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070704 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2070707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070730 */     // GIR_Coverage, 15854,
     /* 2070730 */     GIR_EraseRootFromParent_Done,
     /* 2070731 */   // Label 27485: @2070731
     /* 2070731 */   GIM_Try, /*On fail goto*//*Label 27486*/ GIMT_Encode4(2070822), // Rule ID 15855 //
     /* 2070736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2070739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2070747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2070750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2070753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2070759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2070766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2070774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070782 */     // MIs[0] round
     /* 2070782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070785 */     // MIs[0] policy
     /* 2070785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070795 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2070798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070800 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2070818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070821 */     // GIR_Coverage, 15855,
     /* 2070821 */     GIR_EraseRootFromParent_Done,
     /* 2070822 */   // Label 27486: @2070822
     /* 2070822 */   GIM_Try, /*On fail goto*//*Label 27487*/ GIMT_Encode4(2070913), // Rule ID 15858 //
     /* 2070827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2070830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2070838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2070841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2070844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2070847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2070853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070873 */     // MIs[0] round
     /* 2070873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070876 */     // MIs[0] policy
     /* 2070876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070886 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2070886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2070889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070891 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2070909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2070911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070912 */     // GIR_Coverage, 15858,
     /* 2070912 */     GIR_EraseRootFromParent_Done,
     /* 2070913 */   // Label 27487: @2070913
     /* 2070913 */   GIM_Try, /*On fail goto*//*Label 27488*/ GIMT_Encode4(2071004), // Rule ID 15859 //
     /* 2070918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2070921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2070926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2070929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2070932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2070935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2070938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2070941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2070944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2070948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2070956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2070960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2070964 */     // MIs[0] round
     /* 2070964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2070967 */     // MIs[0] policy
     /* 2070967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2070970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2070977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11533:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2070977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M2_MASK),
     /* 2070980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2070982 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2070984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2070986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2070988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2070990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2070992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2070997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071003 */     // GIR_Coverage, 15859,
     /* 2071003 */     GIR_EraseRootFromParent_Done,
     /* 2071004 */   // Label 27488: @2071004
     /* 2071004 */   GIM_Try, /*On fail goto*//*Label 27489*/ GIMT_Encode4(2071095), // Rule ID 15862 //
     /* 2071009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2071012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2071020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2071023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2071026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071055 */     // MIs[0] round
     /* 2071055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071058 */     // MIs[0] policy
     /* 2071058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071068 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2071071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071073 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071094 */     // GIR_Coverage, 15862,
     /* 2071094 */     GIR_EraseRootFromParent_Done,
     /* 2071095 */   // Label 27489: @2071095
     /* 2071095 */   GIM_Try, /*On fail goto*//*Label 27490*/ GIMT_Encode4(2071186), // Rule ID 15863 //
     /* 2071100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2071103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2071111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2071114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2071117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2071130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2071138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071146 */     // MIs[0] round
     /* 2071146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071149 */     // MIs[0] policy
     /* 2071149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071159 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11533:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M4_MASK),
     /* 2071162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071164 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071185 */     // GIR_Coverage, 15863,
     /* 2071185 */     GIR_EraseRootFromParent_Done,
     /* 2071186 */   // Label 27490: @2071186
     /* 2071186 */   GIM_Try, /*On fail goto*//*Label 27491*/ GIMT_Encode4(2071277), // Rule ID 15866 //
     /* 2071191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2071194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2071202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2071205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2071208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2071211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071237 */     // MIs[0] round
     /* 2071237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071240 */     // MIs[0] policy
     /* 2071240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071250 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2071253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071276 */     // GIR_Coverage, 15866,
     /* 2071276 */     GIR_EraseRootFromParent_Done,
     /* 2071277 */   // Label 27491: @2071277
     /* 2071277 */   GIM_Try, /*On fail goto*//*Label 27492*/ GIMT_Encode4(2071368), // Rule ID 15867 //
     /* 2071282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2071285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssrl_mask),
     /* 2071290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2071293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2071296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2071299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2071302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2071305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2071312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2071320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2071324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071328 */     // MIs[0] round
     /* 2071328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071331 */     // MIs[0] policy
     /* 2071331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071341 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11533:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRL_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRL_VX_M8_MASK),
     /* 2071344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071346 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2071364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071367 */     // GIR_Coverage, 15867,
     /* 2071367 */     GIR_EraseRootFromParent_Done,
     /* 2071368 */   // Label 27492: @2071368
     /* 2071368 */   GIM_Try, /*On fail goto*//*Label 27493*/ GIMT_Encode4(2071459), // Rule ID 15958 //
     /* 2071373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2071384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2071387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2071390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2071393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071419 */     // MIs[0] round
     /* 2071419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071422 */     // MIs[0] policy
     /* 2071422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071432 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2071435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071437 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071458 */     // GIR_Coverage, 15958,
     /* 2071458 */     GIR_EraseRootFromParent_Done,
     /* 2071459 */   // Label 27493: @2071459
     /* 2071459 */   GIM_Try, /*On fail goto*//*Label 27494*/ GIMT_Encode4(2071550), // Rule ID 15959 //
     /* 2071464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2071475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2071478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2071481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2071484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071510 */     // MIs[0] round
     /* 2071510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071513 */     // MIs[0] policy
     /* 2071513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071523 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF8_MASK),
     /* 2071526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071528 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071549 */     // GIR_Coverage, 15959,
     /* 2071549 */     GIR_EraseRootFromParent_Done,
     /* 2071550 */   // Label 27494: @2071550
     /* 2071550 */   GIM_Try, /*On fail goto*//*Label 27495*/ GIMT_Encode4(2071641), // Rule ID 15962 //
     /* 2071555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2071566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2071569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2071572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2071575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071601 */     // MIs[0] round
     /* 2071601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071604 */     // MIs[0] policy
     /* 2071604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071614 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2071617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071619 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071640 */     // GIR_Coverage, 15962,
     /* 2071640 */     GIR_EraseRootFromParent_Done,
     /* 2071641 */   // Label 27495: @2071641
     /* 2071641 */   GIM_Try, /*On fail goto*//*Label 27496*/ GIMT_Encode4(2071732), // Rule ID 15963 //
     /* 2071646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2071657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2071660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2071663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2071666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2071669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071692 */     // MIs[0] round
     /* 2071692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071695 */     // MIs[0] policy
     /* 2071695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071705 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2071708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071710 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071731 */     // GIR_Coverage, 15963,
     /* 2071731 */     GIR_EraseRootFromParent_Done,
     /* 2071732 */   // Label 27496: @2071732
     /* 2071732 */   GIM_Try, /*On fail goto*//*Label 27497*/ GIMT_Encode4(2071823), // Rule ID 15966 //
     /* 2071737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2071748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2071751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2071754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2071757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071783 */     // MIs[0] round
     /* 2071783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071786 */     // MIs[0] policy
     /* 2071786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071796 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2071799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071801 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071822 */     // GIR_Coverage, 15966,
     /* 2071822 */     GIR_EraseRootFromParent_Done,
     /* 2071823 */   // Label 27497: @2071823
     /* 2071823 */   GIM_Try, /*On fail goto*//*Label 27498*/ GIMT_Encode4(2071914), // Rule ID 15967 //
     /* 2071828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2071831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2071839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2071842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2071845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2071848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2071851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2071854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071874 */     // MIs[0] round
     /* 2071874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071877 */     // MIs[0] policy
     /* 2071877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071887 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2071887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2071890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071892 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2071910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2071912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2071913 */     // GIR_Coverage, 15967,
     /* 2071913 */     GIR_EraseRootFromParent_Done,
     /* 2071914 */   // Label 27498: @2071914
     /* 2071914 */   GIM_Try, /*On fail goto*//*Label 27499*/ GIMT_Encode4(2072005), // Rule ID 15970 //
     /* 2071919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2071922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2071927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2071930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2071933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2071936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2071939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2071942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2071945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2071949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2071961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2071965 */     // MIs[0] round
     /* 2071965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2071968 */     // MIs[0] policy
     /* 2071968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2071971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2071978 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2071978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2071981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2071983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2071985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2071987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2071989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2071991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2071993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2071998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072004 */     // GIR_Coverage, 15970,
     /* 2072004 */     GIR_EraseRootFromParent_Done,
     /* 2072005 */   // Label 27499: @2072005
     /* 2072005 */   GIM_Try, /*On fail goto*//*Label 27500*/ GIMT_Encode4(2072096), // Rule ID 15971 //
     /* 2072010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2072021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2072024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2072027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2072030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072056 */     // MIs[0] round
     /* 2072056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072059 */     // MIs[0] policy
     /* 2072059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072069 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF4_MASK),
     /* 2072072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072074 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072095 */     // GIR_Coverage, 15971,
     /* 2072095 */     GIR_EraseRootFromParent_Done,
     /* 2072096 */   // Label 27500: @2072096
     /* 2072096 */   GIM_Try, /*On fail goto*//*Label 27501*/ GIMT_Encode4(2072187), // Rule ID 15974 //
     /* 2072101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2072112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2072115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2072118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2072121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072147 */     // MIs[0] round
     /* 2072147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072150 */     // MIs[0] policy
     /* 2072150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072160 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2072163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072165 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072186 */     // GIR_Coverage, 15974,
     /* 2072186 */     GIR_EraseRootFromParent_Done,
     /* 2072187 */   // Label 27501: @2072187
     /* 2072187 */   GIM_Try, /*On fail goto*//*Label 27502*/ GIMT_Encode4(2072278), // Rule ID 15975 //
     /* 2072192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2072203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2072206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2072209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2072212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072238 */     // MIs[0] round
     /* 2072238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072241 */     // MIs[0] policy
     /* 2072241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072251 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2072254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072256 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072277 */     // GIR_Coverage, 15975,
     /* 2072277 */     GIR_EraseRootFromParent_Done,
     /* 2072278 */   // Label 27502: @2072278
     /* 2072278 */   GIM_Try, /*On fail goto*//*Label 27503*/ GIMT_Encode4(2072369), // Rule ID 15978 //
     /* 2072283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2072294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2072297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2072300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2072303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072329 */     // MIs[0] round
     /* 2072329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072332 */     // MIs[0] policy
     /* 2072332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072342 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2072345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072347 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072368 */     // GIR_Coverage, 15978,
     /* 2072368 */     GIR_EraseRootFromParent_Done,
     /* 2072369 */   // Label 27503: @2072369
     /* 2072369 */   GIM_Try, /*On fail goto*//*Label 27504*/ GIMT_Encode4(2072460), // Rule ID 15979 //
     /* 2072374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2072385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2072388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2072391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2072394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2072397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072420 */     // MIs[0] round
     /* 2072420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072423 */     // MIs[0] policy
     /* 2072423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072433 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_MF2_MASK),
     /* 2072436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072438 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072459 */     // GIR_Coverage, 15979,
     /* 2072459 */     GIR_EraseRootFromParent_Done,
     /* 2072460 */   // Label 27504: @2072460
     /* 2072460 */   GIM_Try, /*On fail goto*//*Label 27505*/ GIMT_Encode4(2072551), // Rule ID 15982 //
     /* 2072465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2072476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2072479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2072482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2072485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072511 */     // MIs[0] round
     /* 2072511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072514 */     // MIs[0] policy
     /* 2072514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072524 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072550 */     // GIR_Coverage, 15982,
     /* 2072550 */     GIR_EraseRootFromParent_Done,
     /* 2072551 */   // Label 27505: @2072551
     /* 2072551 */   GIM_Try, /*On fail goto*//*Label 27506*/ GIMT_Encode4(2072642), // Rule ID 15983 //
     /* 2072556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2072567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2072570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2072573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2072576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2072579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072602 */     // MIs[0] round
     /* 2072602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072605 */     // MIs[0] policy
     /* 2072605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072615 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072620 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2072638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072641 */     // GIR_Coverage, 15983,
     /* 2072641 */     GIR_EraseRootFromParent_Done,
     /* 2072642 */   // Label 27506: @2072642
     /* 2072642 */   GIM_Try, /*On fail goto*//*Label 27507*/ GIMT_Encode4(2072733), // Rule ID 15986 //
     /* 2072647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2072658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2072661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2072664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2072667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072693 */     // MIs[0] round
     /* 2072693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072696 */     // MIs[0] policy
     /* 2072696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072706 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072711 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072732 */     // GIR_Coverage, 15986,
     /* 2072732 */     GIR_EraseRootFromParent_Done,
     /* 2072733 */   // Label 27507: @2072733
     /* 2072733 */   GIM_Try, /*On fail goto*//*Label 27508*/ GIMT_Encode4(2072824), // Rule ID 15987 //
     /* 2072738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2072749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2072752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2072755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2072758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2072761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072784 */     // MIs[0] round
     /* 2072784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072787 */     // MIs[0] policy
     /* 2072787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072797 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072802 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2072820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072823 */     // GIR_Coverage, 15987,
     /* 2072823 */     GIR_EraseRootFromParent_Done,
     /* 2072824 */   // Label 27508: @2072824
     /* 2072824 */   GIM_Try, /*On fail goto*//*Label 27509*/ GIMT_Encode4(2072915), // Rule ID 15990 //
     /* 2072829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2072832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2072840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2072843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2072846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2072849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2072855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072875 */     // MIs[0] round
     /* 2072875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072878 */     // MIs[0] policy
     /* 2072878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072888 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2072888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072893 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2072911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2072913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2072914 */     // GIR_Coverage, 15990,
     /* 2072914 */     GIR_EraseRootFromParent_Done,
     /* 2072915 */   // Label 27509: @2072915
     /* 2072915 */   GIM_Try, /*On fail goto*//*Label 27510*/ GIMT_Encode4(2073006), // Rule ID 15991 //
     /* 2072920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2072923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2072928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2072931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2072934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2072937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2072940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2072943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2072946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2072950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2072962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2072966 */     // MIs[0] round
     /* 2072966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2072969 */     // MIs[0] policy
     /* 2072969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2072972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2072979 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2072979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2072982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2072984 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2072986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2072988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2072990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2072992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2072994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2072999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2073002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073005 */     // GIR_Coverage, 15991,
     /* 2073005 */     GIR_EraseRootFromParent_Done,
     /* 2073006 */   // Label 27510: @2073006
     /* 2073006 */   GIM_Try, /*On fail goto*//*Label 27511*/ GIMT_Encode4(2073097), // Rule ID 15994 //
     /* 2073011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2073014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073057 */     // MIs[0] round
     /* 2073057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073060 */     // MIs[0] policy
     /* 2073060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073070 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2073073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073075 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073096 */     // GIR_Coverage, 15994,
     /* 2073096 */     GIR_EraseRootFromParent_Done,
     /* 2073097 */   // Label 27511: @2073097
     /* 2073097 */   GIM_Try, /*On fail goto*//*Label 27512*/ GIMT_Encode4(2073188), // Rule ID 15995 //
     /* 2073102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2073105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2073113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2073116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2073119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2073122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2073125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2073132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2073144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073148 */     // MIs[0] round
     /* 2073148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073151 */     // MIs[0] policy
     /* 2073151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073161 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M1_MASK),
     /* 2073164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073166 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2073184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073187 */     // GIR_Coverage, 15995,
     /* 2073187 */     GIR_EraseRootFromParent_Done,
     /* 2073188 */   // Label 27512: @2073188
     /* 2073188 */   GIM_Try, /*On fail goto*//*Label 27513*/ GIMT_Encode4(2073279), // Rule ID 15998 //
     /* 2073193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2073204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2073207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2073210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2073213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073239 */     // MIs[0] round
     /* 2073239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073242 */     // MIs[0] policy
     /* 2073242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073252 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2073255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073257 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073278 */     // GIR_Coverage, 15998,
     /* 2073278 */     GIR_EraseRootFromParent_Done,
     /* 2073279 */   // Label 27513: @2073279
     /* 2073279 */   GIM_Try, /*On fail goto*//*Label 27514*/ GIMT_Encode4(2073370), // Rule ID 15999 //
     /* 2073284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2073295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2073298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2073301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2073304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073330 */     // MIs[0] round
     /* 2073330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073333 */     // MIs[0] policy
     /* 2073333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073343 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2073346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073348 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073369 */     // GIR_Coverage, 15999,
     /* 2073369 */     GIR_EraseRootFromParent_Done,
     /* 2073370 */   // Label 27514: @2073370
     /* 2073370 */   GIM_Try, /*On fail goto*//*Label 27515*/ GIMT_Encode4(2073461), // Rule ID 16002 //
     /* 2073375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2073386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2073389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2073392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2073395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2073398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073421 */     // MIs[0] round
     /* 2073421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073424 */     // MIs[0] policy
     /* 2073424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073434 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2073437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073439 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073460 */     // GIR_Coverage, 16002,
     /* 2073460 */     GIR_EraseRootFromParent_Done,
     /* 2073461 */   // Label 27515: @2073461
     /* 2073461 */   GIM_Try, /*On fail goto*//*Label 27516*/ GIMT_Encode4(2073552), // Rule ID 16003 //
     /* 2073466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2073477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2073480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2073483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2073486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2073489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073512 */     // MIs[0] round
     /* 2073512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073515 */     // MIs[0] policy
     /* 2073515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073525 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2073528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073530 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073551 */     // GIR_Coverage, 16003,
     /* 2073551 */     GIR_EraseRootFromParent_Done,
     /* 2073552 */   // Label 27516: @2073552
     /* 2073552 */   GIM_Try, /*On fail goto*//*Label 27517*/ GIMT_Encode4(2073643), // Rule ID 16006 //
     /* 2073557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2073568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2073571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2073574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2073577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2073580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073603 */     // MIs[0] round
     /* 2073603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073606 */     // MIs[0] policy
     /* 2073606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073616 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2073619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073621 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073642 */     // GIR_Coverage, 16006,
     /* 2073642 */     GIR_EraseRootFromParent_Done,
     /* 2073643 */   // Label 27517: @2073643
     /* 2073643 */   GIM_Try, /*On fail goto*//*Label 27518*/ GIMT_Encode4(2073734), // Rule ID 16007 //
     /* 2073648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2073659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2073662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2073665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s8,
     /* 2073668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2073671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2073678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2073690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073694 */     // MIs[0] round
     /* 2073694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073697 */     // MIs[0] policy
     /* 2073697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073707 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2073710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073712 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2073730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073733 */     // GIR_Coverage, 16007,
     /* 2073733 */     GIR_EraseRootFromParent_Done,
     /* 2073734 */   // Label 27518: @2073734
     /* 2073734 */   GIM_Try, /*On fail goto*//*Label 27519*/ GIMT_Encode4(2073825), // Rule ID 16010 //
     /* 2073739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2073750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2073753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2073756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2073759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073785 */     // MIs[0] round
     /* 2073785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073788 */     // MIs[0] policy
     /* 2073788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073798 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2073801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073824 */     // GIR_Coverage, 16010,
     /* 2073824 */     GIR_EraseRootFromParent_Done,
     /* 2073825 */   // Label 27519: @2073825
     /* 2073825 */   GIM_Try, /*On fail goto*//*Label 27520*/ GIMT_Encode4(2073916), // Rule ID 16011 //
     /* 2073830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2073833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2073841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2073844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2073847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2073850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2073853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2073856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2073860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2073872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073876 */     // MIs[0] round
     /* 2073876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073879 */     // MIs[0] policy
     /* 2073879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073889 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2073889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2073892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073894 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2073909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2073912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2073914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2073915 */     // GIR_Coverage, 16011,
     /* 2073915 */     GIR_EraseRootFromParent_Done,
     /* 2073916 */   // Label 27520: @2073916
     /* 2073916 */   GIM_Try, /*On fail goto*//*Label 27521*/ GIMT_Encode4(2074007), // Rule ID 16014 //
     /* 2073921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2073924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2073929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2073932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2073935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2073938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2073941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2073944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2073947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2073951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2073963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2073967 */     // MIs[0] round
     /* 2073967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2073970 */     // MIs[0] policy
     /* 2073970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2073973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2073980 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2073980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2073983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2073985 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2073987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2073989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2073991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2073993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2073995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074006 */     // GIR_Coverage, 16014,
     /* 2074006 */     GIR_EraseRootFromParent_Done,
     /* 2074007 */   // Label 27521: @2074007
     /* 2074007 */   GIM_Try, /*On fail goto*//*Label 27522*/ GIMT_Encode4(2074098), // Rule ID 16015 //
     /* 2074012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2074023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2074026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2074029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2074032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074058 */     // MIs[0] round
     /* 2074058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074061 */     // MIs[0] policy
     /* 2074061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074071 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2074074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074076 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074097 */     // GIR_Coverage, 16015,
     /* 2074097 */     GIR_EraseRootFromParent_Done,
     /* 2074098 */   // Label 27522: @2074098
     /* 2074098 */   GIM_Try, /*On fail goto*//*Label 27523*/ GIMT_Encode4(2074189), // Rule ID 16018 //
     /* 2074103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2074123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074149 */     // MIs[0] round
     /* 2074149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074152 */     // MIs[0] policy
     /* 2074152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074162 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2074165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074167 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074188 */     // GIR_Coverage, 16018,
     /* 2074188 */     GIR_EraseRootFromParent_Done,
     /* 2074189 */   // Label 27523: @2074189
     /* 2074189 */   GIM_Try, /*On fail goto*//*Label 27524*/ GIMT_Encode4(2074280), // Rule ID 16019 //
     /* 2074194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2074205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2074208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2074211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2074214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2074217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074240 */     // MIs[0] round
     /* 2074240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074243 */     // MIs[0] policy
     /* 2074243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074253 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2074256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074258 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2074276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074279 */     // GIR_Coverage, 16019,
     /* 2074279 */     GIR_EraseRootFromParent_Done,
     /* 2074280 */   // Label 27524: @2074280
     /* 2074280 */   GIM_Try, /*On fail goto*//*Label 27525*/ GIMT_Encode4(2074371), // Rule ID 16022 //
     /* 2074285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2074305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074331 */     // MIs[0] round
     /* 2074331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074334 */     // MIs[0] policy
     /* 2074334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2074347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074370 */     // GIR_Coverage, 16022,
     /* 2074370 */     GIR_EraseRootFromParent_Done,
     /* 2074371 */   // Label 27525: @2074371
     /* 2074371 */   GIM_Try, /*On fail goto*//*Label 27526*/ GIMT_Encode4(2074462), // Rule ID 16023 //
     /* 2074376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2074387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2074390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2074393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2074396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2074399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074422 */     // MIs[0] round
     /* 2074422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074425 */     // MIs[0] policy
     /* 2074425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074435 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2074438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074440 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074461 */     // GIR_Coverage, 16023,
     /* 2074461 */     GIR_EraseRootFromParent_Done,
     /* 2074462 */   // Label 27526: @2074462
     /* 2074462 */   GIM_Try, /*On fail goto*//*Label 27527*/ GIMT_Encode4(2074553), // Rule ID 16026 //
     /* 2074467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2074487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074513 */     // MIs[0] round
     /* 2074513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074516 */     // MIs[0] policy
     /* 2074516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074526 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2074529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074531 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074552 */     // GIR_Coverage, 16026,
     /* 2074552 */     GIR_EraseRootFromParent_Done,
     /* 2074553 */   // Label 27527: @2074553
     /* 2074553 */   GIM_Try, /*On fail goto*//*Label 27528*/ GIMT_Encode4(2074644), // Rule ID 16027 //
     /* 2074558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2074569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2074572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2074575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2074578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2074581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2074588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2074600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074604 */     // MIs[0] round
     /* 2074604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074607 */     // MIs[0] policy
     /* 2074607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074617 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2074620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074622 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074643 */     // GIR_Coverage, 16027,
     /* 2074643 */     GIR_EraseRootFromParent_Done,
     /* 2074644 */   // Label 27528: @2074644
     /* 2074644 */   GIM_Try, /*On fail goto*//*Label 27529*/ GIMT_Encode4(2074735), // Rule ID 16030 //
     /* 2074649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2074652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2074660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2074663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2074666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2074669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074695 */     // MIs[0] round
     /* 2074695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074698 */     // MIs[0] policy
     /* 2074698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074708 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2074711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074713 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074734 */     // GIR_Coverage, 16030,
     /* 2074734 */     GIR_EraseRootFromParent_Done,
     /* 2074735 */   // Label 27529: @2074735
     /* 2074735 */   GIM_Try, /*On fail goto*//*Label 27530*/ GIMT_Encode4(2074826), // Rule ID 16031 //
     /* 2074740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2074743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2074751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2074754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2074757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2074760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2074763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2074770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2074782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074786 */     // MIs[0] round
     /* 2074786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074789 */     // MIs[0] policy
     /* 2074789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074799 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2074802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074804 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2074822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074825 */     // GIR_Coverage, 16031,
     /* 2074825 */     GIR_EraseRootFromParent_Done,
     /* 2074826 */   // Label 27530: @2074826
     /* 2074826 */   GIM_Try, /*On fail goto*//*Label 27531*/ GIMT_Encode4(2074917), // Rule ID 16034 //
     /* 2074831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2074834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2074851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2074857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074877 */     // MIs[0] round
     /* 2074877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074880 */     // MIs[0] policy
     /* 2074880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2074890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2074893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074895 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2074910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2074913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2074915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2074916 */     // GIR_Coverage, 16034,
     /* 2074916 */     GIR_EraseRootFromParent_Done,
     /* 2074917 */   // Label 27531: @2074917
     /* 2074917 */   GIM_Try, /*On fail goto*//*Label 27532*/ GIMT_Encode4(2075008), // Rule ID 16035 //
     /* 2074922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2074925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2074930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2074933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2074936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2074939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2074942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2074945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2074948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2074952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2074964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2074968 */     // MIs[0] round
     /* 2074968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2074971 */     // MIs[0] policy
     /* 2074971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2074974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2074981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2074981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M2_MASK),
     /* 2074984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2074986 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2074988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2074990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2074992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2074994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2074996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075007 */     // GIR_Coverage, 16035,
     /* 2075007 */     GIR_EraseRootFromParent_Done,
     /* 2075008 */   // Label 27532: @2075008
     /* 2075008 */   GIM_Try, /*On fail goto*//*Label 27533*/ GIMT_Encode4(2075099), // Rule ID 16038 //
     /* 2075013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2075016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2075033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075059 */     // MIs[0] round
     /* 2075059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075062 */     // MIs[0] policy
     /* 2075062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075072 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2075075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075098 */     // GIR_Coverage, 16038,
     /* 2075098 */     GIR_EraseRootFromParent_Done,
     /* 2075099 */   // Label 27533: @2075099
     /* 2075099 */   GIM_Try, /*On fail goto*//*Label 27534*/ GIMT_Encode4(2075190), // Rule ID 16039 //
     /* 2075104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2075107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2075115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2075118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2075121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2075124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2075134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2075146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075150 */     // MIs[0] round
     /* 2075150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075153 */     // MIs[0] policy
     /* 2075153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075163 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M4_MASK),
     /* 2075166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075168 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075189 */     // GIR_Coverage, 16039,
     /* 2075189 */     GIR_EraseRootFromParent_Done,
     /* 2075190 */   // Label 27534: @2075190
     /* 2075190 */   GIM_Try, /*On fail goto*//*Label 27535*/ GIMT_Encode4(2075281), // Rule ID 16042 //
     /* 2075195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2075198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2075215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075241 */     // MIs[0] round
     /* 2075241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075244 */     // MIs[0] policy
     /* 2075244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075254 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2075257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075259 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075280 */     // GIR_Coverage, 16042,
     /* 2075280 */     GIR_EraseRootFromParent_Done,
     /* 2075281 */   // Label 27535: @2075281
     /* 2075281 */   GIM_Try, /*On fail goto*//*Label 27536*/ GIMT_Encode4(2075372), // Rule ID 16043 //
     /* 2075286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2075289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2075297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2075300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2075303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2075306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2075309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2075316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2075328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075332 */     // MIs[0] round
     /* 2075332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075335 */     // MIs[0] policy
     /* 2075335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075345 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VV_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VV_M8_MASK),
     /* 2075348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075350 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2075368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075371 */     // GIR_Coverage, 16043,
     /* 2075371 */     GIR_EraseRootFromParent_Done,
     /* 2075372 */   // Label 27536: @2075372
     /* 2075372 */   GIM_Try, /*On fail goto*//*Label 27537*/ GIMT_Encode4(2075463), // Rule ID 16046 //
     /* 2075377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075423 */     // MIs[0] round
     /* 2075423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075426 */     // MIs[0] policy
     /* 2075426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075436 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2075439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075441 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075462 */     // GIR_Coverage, 16046,
     /* 2075462 */     GIR_EraseRootFromParent_Done,
     /* 2075463 */   // Label 27537: @2075463
     /* 2075463 */   GIM_Try, /*On fail goto*//*Label 27538*/ GIMT_Encode4(2075554), // Rule ID 16047 //
     /* 2075468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2075479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2075482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2075485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075514 */     // MIs[0] round
     /* 2075514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075517 */     // MIs[0] policy
     /* 2075517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075527 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF8_MASK),
     /* 2075530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075532 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075553 */     // GIR_Coverage, 16047,
     /* 2075553 */     GIR_EraseRootFromParent_Done,
     /* 2075554 */   // Label 27538: @2075554
     /* 2075554 */   GIM_Try, /*On fail goto*//*Label 27539*/ GIMT_Encode4(2075645), // Rule ID 16050 //
     /* 2075559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075605 */     // MIs[0] round
     /* 2075605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075608 */     // MIs[0] policy
     /* 2075608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075618 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2075621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075644 */     // GIR_Coverage, 16050,
     /* 2075644 */     GIR_EraseRootFromParent_Done,
     /* 2075645 */   // Label 27539: @2075645
     /* 2075645 */   GIM_Try, /*On fail goto*//*Label 27540*/ GIMT_Encode4(2075736), // Rule ID 16051 //
     /* 2075650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2075661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2075664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2075667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2075673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075696 */     // MIs[0] round
     /* 2075696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075699 */     // MIs[0] policy
     /* 2075699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075709 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2075712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075714 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075735 */     // GIR_Coverage, 16051,
     /* 2075735 */     GIR_EraseRootFromParent_Done,
     /* 2075736 */   // Label 27540: @2075736
     /* 2075736 */   GIM_Try, /*On fail goto*//*Label 27541*/ GIMT_Encode4(2075827), // Rule ID 16054 //
     /* 2075741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075787 */     // MIs[0] round
     /* 2075787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075790 */     // MIs[0] policy
     /* 2075790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075800 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2075803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075805 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075826 */     // GIR_Coverage, 16054,
     /* 2075826 */     GIR_EraseRootFromParent_Done,
     /* 2075827 */   // Label 27541: @2075827
     /* 2075827 */   GIM_Try, /*On fail goto*//*Label 27542*/ GIMT_Encode4(2075918), // Rule ID 16055 //
     /* 2075832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2075835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2075843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2075846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2075849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2075852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2075855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2075858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075878 */     // MIs[0] round
     /* 2075878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075881 */     // MIs[0] policy
     /* 2075881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075891 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2075891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2075894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075896 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2075911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2075914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2075916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2075917 */     // GIR_Coverage, 16055,
     /* 2075917 */     GIR_EraseRootFromParent_Done,
     /* 2075918 */   // Label 27542: @2075918
     /* 2075918 */   GIM_Try, /*On fail goto*//*Label 27543*/ GIMT_Encode4(2076009), // Rule ID 16058 //
     /* 2075923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2075926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2075931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2075934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2075937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2075940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2075943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2075946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2075949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2075953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2075961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2075965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2075969 */     // MIs[0] round
     /* 2075969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2075972 */     // MIs[0] policy
     /* 2075972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2075975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2075982 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2075982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2075985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2075987 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2075989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2075991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2075993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2075995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2075997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076008 */     // GIR_Coverage, 16058,
     /* 2076008 */     GIR_EraseRootFromParent_Done,
     /* 2076009 */   // Label 27543: @2076009
     /* 2076009 */   GIM_Try, /*On fail goto*//*Label 27544*/ GIMT_Encode4(2076100), // Rule ID 16059 //
     /* 2076014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2076025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2076028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2076031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076060 */     // MIs[0] round
     /* 2076060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076063 */     // MIs[0] policy
     /* 2076063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076073 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF4_MASK),
     /* 2076076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076078 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076099 */     // GIR_Coverage, 16059,
     /* 2076099 */     GIR_EraseRootFromParent_Done,
     /* 2076100 */   // Label 27544: @2076100
     /* 2076100 */   GIM_Try, /*On fail goto*//*Label 27545*/ GIMT_Encode4(2076191), // Rule ID 16062 //
     /* 2076105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2076116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2076119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2076122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076151 */     // MIs[0] round
     /* 2076151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076154 */     // MIs[0] policy
     /* 2076154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076164 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2076167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076169 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076190 */     // GIR_Coverage, 16062,
     /* 2076190 */     GIR_EraseRootFromParent_Done,
     /* 2076191 */   // Label 27545: @2076191
     /* 2076191 */   GIM_Try, /*On fail goto*//*Label 27546*/ GIMT_Encode4(2076282), // Rule ID 16063 //
     /* 2076196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2076207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2076210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2076213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076242 */     // MIs[0] round
     /* 2076242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076245 */     // MIs[0] policy
     /* 2076245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076255 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2076258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076260 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076281 */     // GIR_Coverage, 16063,
     /* 2076281 */     GIR_EraseRootFromParent_Done,
     /* 2076282 */   // Label 27546: @2076282
     /* 2076282 */   GIM_Try, /*On fail goto*//*Label 27547*/ GIMT_Encode4(2076373), // Rule ID 16066 //
     /* 2076287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076333 */     // MIs[0] round
     /* 2076333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076336 */     // MIs[0] policy
     /* 2076336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076346 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2076349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076351 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076372 */     // GIR_Coverage, 16066,
     /* 2076372 */     GIR_EraseRootFromParent_Done,
     /* 2076373 */   // Label 27547: @2076373
     /* 2076373 */   GIM_Try, /*On fail goto*//*Label 27548*/ GIMT_Encode4(2076464), // Rule ID 16067 //
     /* 2076378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2076389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2076392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2076395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2076401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076424 */     // MIs[0] round
     /* 2076424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076427 */     // MIs[0] policy
     /* 2076427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076437 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_MF2_MASK),
     /* 2076440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076442 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076463 */     // GIR_Coverage, 16067,
     /* 2076463 */     GIR_EraseRootFromParent_Done,
     /* 2076464 */   // Label 27548: @2076464
     /* 2076464 */   GIM_Try, /*On fail goto*//*Label 27549*/ GIMT_Encode4(2076555), // Rule ID 16070 //
     /* 2076469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076515 */     // MIs[0] round
     /* 2076515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076518 */     // MIs[0] policy
     /* 2076518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076528 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076533 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076554 */     // GIR_Coverage, 16070,
     /* 2076554 */     GIR_EraseRootFromParent_Done,
     /* 2076555 */   // Label 27549: @2076555
     /* 2076555 */   GIM_Try, /*On fail goto*//*Label 27550*/ GIMT_Encode4(2076646), // Rule ID 16071 //
     /* 2076560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2076571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2076574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2076577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2076583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076606 */     // MIs[0] round
     /* 2076606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076609 */     // MIs[0] policy
     /* 2076609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076619 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11531:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076624 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2076642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076645 */     // GIR_Coverage, 16071,
     /* 2076645 */     GIR_EraseRootFromParent_Done,
     /* 2076646 */   // Label 27550: @2076646
     /* 2076646 */   GIM_Try, /*On fail goto*//*Label 27551*/ GIMT_Encode4(2076737), // Rule ID 16074 //
     /* 2076651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076697 */     // MIs[0] round
     /* 2076697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076700 */     // MIs[0] policy
     /* 2076700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076710 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076715 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076736 */     // GIR_Coverage, 16074,
     /* 2076736 */     GIR_EraseRootFromParent_Done,
     /* 2076737 */   // Label 27551: @2076737
     /* 2076737 */   GIM_Try, /*On fail goto*//*Label 27552*/ GIMT_Encode4(2076828), // Rule ID 16075 //
     /* 2076742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2076753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2076756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2076759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2076765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076788 */     // MIs[0] round
     /* 2076788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076791 */     // MIs[0] policy
     /* 2076791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076801 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11531:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076806 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2076824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076827 */     // GIR_Coverage, 16075,
     /* 2076827 */     GIR_EraseRootFromParent_Done,
     /* 2076828 */   // Label 27552: @2076828
     /* 2076828 */   GIM_Try, /*On fail goto*//*Label 27553*/ GIMT_Encode4(2076919), // Rule ID 16078 //
     /* 2076833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2076836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2076853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2076859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076879 */     // MIs[0] round
     /* 2076879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076882 */     // MIs[0] policy
     /* 2076882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076892 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2076892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2076912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2076915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2076917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2076918 */     // GIR_Coverage, 16078,
     /* 2076918 */     GIR_EraseRootFromParent_Done,
     /* 2076919 */   // Label 27553: @2076919
     /* 2076919 */   GIM_Try, /*On fail goto*//*Label 27554*/ GIMT_Encode4(2077010), // Rule ID 16079 //
     /* 2076924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2076927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2076932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2076935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2076938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2076941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2076944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2076947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2076950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2076954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2076962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2076966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2076970 */     // MIs[0] round
     /* 2076970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2076973 */     // MIs[0] policy
     /* 2076973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2076976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2076983 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11531:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2076983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2076986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2076988 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2076990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2076992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2076994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2076996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2076998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2077006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077009 */     // GIR_Coverage, 16079,
     /* 2077009 */     GIR_EraseRootFromParent_Done,
     /* 2077010 */   // Label 27554: @2077010
     /* 2077010 */   GIM_Try, /*On fail goto*//*Label 27555*/ GIMT_Encode4(2077101), // Rule ID 16082 //
     /* 2077015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2077018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077061 */     // MIs[0] round
     /* 2077061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077064 */     // MIs[0] policy
     /* 2077064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077074 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2077077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077079 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077100 */     // GIR_Coverage, 16082,
     /* 2077100 */     GIR_EraseRootFromParent_Done,
     /* 2077101 */   // Label 27555: @2077101
     /* 2077101 */   GIM_Try, /*On fail goto*//*Label 27556*/ GIMT_Encode4(2077192), // Rule ID 16083 //
     /* 2077106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2077109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2077117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2077120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2077123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2077129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2077136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2077144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077152 */     // MIs[0] round
     /* 2077152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077155 */     // MIs[0] policy
     /* 2077155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077165 */     // (intrinsic_wo_chain:{ *:[nxv1i64] } 11531:{ *:[iPTR] }, VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M1_MASK),
     /* 2077168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077170 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2077188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077191 */     // GIR_Coverage, 16083,
     /* 2077191 */     GIR_EraseRootFromParent_Done,
     /* 2077192 */   // Label 27556: @2077192
     /* 2077192 */   GIM_Try, /*On fail goto*//*Label 27557*/ GIMT_Encode4(2077283), // Rule ID 16086 //
     /* 2077197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2077208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2077211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2077214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077243 */     // MIs[0] round
     /* 2077243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077246 */     // MIs[0] policy
     /* 2077246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2077259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077261 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077282 */     // GIR_Coverage, 16086,
     /* 2077282 */     GIR_EraseRootFromParent_Done,
     /* 2077283 */   // Label 27557: @2077283
     /* 2077283 */   GIM_Try, /*On fail goto*//*Label 27558*/ GIMT_Encode4(2077374), // Rule ID 16087 //
     /* 2077288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2077299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2077302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2077305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077334 */     // MIs[0] round
     /* 2077334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077337 */     // MIs[0] policy
     /* 2077337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077347 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2077350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077352 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077373 */     // GIR_Coverage, 16087,
     /* 2077373 */     GIR_EraseRootFromParent_Done,
     /* 2077374 */   // Label 27558: @2077374
     /* 2077374 */   GIM_Try, /*On fail goto*//*Label 27559*/ GIMT_Encode4(2077465), // Rule ID 16090 //
     /* 2077379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077425 */     // MIs[0] round
     /* 2077425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077428 */     // MIs[0] policy
     /* 2077428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077438 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2077441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077464 */     // GIR_Coverage, 16090,
     /* 2077464 */     GIR_EraseRootFromParent_Done,
     /* 2077465 */   // Label 27559: @2077465
     /* 2077465 */   GIM_Try, /*On fail goto*//*Label 27560*/ GIMT_Encode4(2077556), // Rule ID 16091 //
     /* 2077470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2077481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2077484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2077487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2077493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077516 */     // MIs[0] round
     /* 2077516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077519 */     // MIs[0] policy
     /* 2077519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077529 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2077532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077534 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077555 */     // GIR_Coverage, 16091,
     /* 2077555 */     GIR_EraseRootFromParent_Done,
     /* 2077556 */   // Label 27560: @2077556
     /* 2077556 */   GIM_Try, /*On fail goto*//*Label 27561*/ GIMT_Encode4(2077647), // Rule ID 16094 //
     /* 2077561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077607 */     // MIs[0] round
     /* 2077607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077610 */     // MIs[0] policy
     /* 2077610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077620 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2077623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077625 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077646 */     // GIR_Coverage, 16094,
     /* 2077646 */     GIR_EraseRootFromParent_Done,
     /* 2077647 */   // Label 27561: @2077647
     /* 2077647 */   GIM_Try, /*On fail goto*//*Label 27562*/ GIMT_Encode4(2077738), // Rule ID 16095 //
     /* 2077652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv64s8,
     /* 2077663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2077666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2077669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv64s1,
     /* 2077675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2077682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2077690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077698 */     // MIs[0] round
     /* 2077698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077701 */     // MIs[0] policy
     /* 2077701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077711 */     // (intrinsic_wo_chain:{ *:[nxv64i8] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2077714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077716 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2077734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077737 */     // GIR_Coverage, 16095,
     /* 2077737 */     GIR_EraseRootFromParent_Done,
     /* 2077738 */   // Label 27562: @2077738
     /* 2077738 */   GIM_Try, /*On fail goto*//*Label 27563*/ GIMT_Encode4(2077829), // Rule ID 16098 //
     /* 2077743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077789 */     // MIs[0] round
     /* 2077789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077792 */     // MIs[0] policy
     /* 2077792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077802 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2077805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077807 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077828 */     // GIR_Coverage, 16098,
     /* 2077828 */     GIR_EraseRootFromParent_Done,
     /* 2077829 */   // Label 27563: @2077829
     /* 2077829 */   GIM_Try, /*On fail goto*//*Label 27564*/ GIMT_Encode4(2077920), // Rule ID 16099 //
     /* 2077834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2077837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2077845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2077848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2077851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2077854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2077857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2077860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2077864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2077872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077880 */     // MIs[0] round
     /* 2077880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077883 */     // MIs[0] policy
     /* 2077883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077893 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2077893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2077896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077898 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2077913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2077916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2077918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2077919 */     // GIR_Coverage, 16099,
     /* 2077919 */     GIR_EraseRootFromParent_Done,
     /* 2077920 */   // Label 27564: @2077920
     /* 2077920 */   GIM_Try, /*On fail goto*//*Label 27565*/ GIMT_Encode4(2078011), // Rule ID 16102 //
     /* 2077925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2077928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2077933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2077936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2077939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2077942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2077945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2077948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2077951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2077955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2077963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2077967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2077971 */     // MIs[0] round
     /* 2077971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2077974 */     // MIs[0] policy
     /* 2077974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2077977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2077984 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2077984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2077987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2077989 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2077991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2077993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2077995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2077997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2077999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078010 */     // GIR_Coverage, 16102,
     /* 2078010 */     GIR_EraseRootFromParent_Done,
     /* 2078011 */   // Label 27565: @2078011
     /* 2078011 */   GIM_Try, /*On fail goto*//*Label 27566*/ GIMT_Encode4(2078102), // Rule ID 16103 //
     /* 2078016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2078027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2078030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2078033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078062 */     // MIs[0] round
     /* 2078062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078065 */     // MIs[0] policy
     /* 2078065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078075 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2078078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078080 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078101 */     // GIR_Coverage, 16103,
     /* 2078101 */     GIR_EraseRootFromParent_Done,
     /* 2078102 */   // Label 27566: @2078102
     /* 2078102 */   GIM_Try, /*On fail goto*//*Label 27567*/ GIMT_Encode4(2078193), // Rule ID 16106 //
     /* 2078107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2078118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2078121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2078124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2078130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078153 */     // MIs[0] round
     /* 2078153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078156 */     // MIs[0] policy
     /* 2078156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078166 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2078169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078192 */     // GIR_Coverage, 16106,
     /* 2078192 */     GIR_EraseRootFromParent_Done,
     /* 2078193 */   // Label 27567: @2078193
     /* 2078193 */   GIM_Try, /*On fail goto*//*Label 27568*/ GIMT_Encode4(2078284), // Rule ID 16107 //
     /* 2078198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2078209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2078212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2078215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2078221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078244 */     // MIs[0] round
     /* 2078244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078247 */     // MIs[0] policy
     /* 2078247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078257 */     // (intrinsic_wo_chain:{ *:[nxv32i16] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2078260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078262 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2078280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078283 */     // GIR_Coverage, 16107,
     /* 2078283 */     GIR_EraseRootFromParent_Done,
     /* 2078284 */   // Label 27568: @2078284
     /* 2078284 */   GIM_Try, /*On fail goto*//*Label 27569*/ GIMT_Encode4(2078375), // Rule ID 16110 //
     /* 2078289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078335 */     // MIs[0] round
     /* 2078335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078338 */     // MIs[0] policy
     /* 2078338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2078351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078353 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078374 */     // GIR_Coverage, 16110,
     /* 2078374 */     GIR_EraseRootFromParent_Done,
     /* 2078375 */   // Label 27569: @2078375
     /* 2078375 */   GIM_Try, /*On fail goto*//*Label 27570*/ GIMT_Encode4(2078466), // Rule ID 16111 //
     /* 2078380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2078391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2078394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2078397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2078403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078426 */     // MIs[0] round
     /* 2078426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078429 */     // MIs[0] policy
     /* 2078429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078439 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2078442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078444 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078465 */     // GIR_Coverage, 16111,
     /* 2078465 */     GIR_EraseRootFromParent_Done,
     /* 2078466 */   // Label 27570: @2078466
     /* 2078466 */   GIM_Try, /*On fail goto*//*Label 27571*/ GIMT_Encode4(2078557), // Rule ID 16114 //
     /* 2078471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078517 */     // MIs[0] round
     /* 2078517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078520 */     // MIs[0] policy
     /* 2078520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078530 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2078533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078535 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078556 */     // GIR_Coverage, 16114,
     /* 2078556 */     GIR_EraseRootFromParent_Done,
     /* 2078557 */   // Label 27571: @2078557
     /* 2078557 */   GIM_Try, /*On fail goto*//*Label 27572*/ GIMT_Encode4(2078648), // Rule ID 16115 //
     /* 2078562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2078573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2078576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2078579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2078585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2078592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2078600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078608 */     // MIs[0] round
     /* 2078608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078611 */     // MIs[0] policy
     /* 2078611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078621 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2078624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078626 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078647 */     // GIR_Coverage, 16115,
     /* 2078647 */     GIR_EraseRootFromParent_Done,
     /* 2078648 */   // Label 27572: @2078648
     /* 2078648 */   GIM_Try, /*On fail goto*//*Label 27573*/ GIMT_Encode4(2078739), // Rule ID 16118 //
     /* 2078653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2078656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078699 */     // MIs[0] round
     /* 2078699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078702 */     // MIs[0] policy
     /* 2078702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078712 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2078715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078738 */     // GIR_Coverage, 16118,
     /* 2078738 */     GIR_EraseRootFromParent_Done,
     /* 2078739 */   // Label 27573: @2078739
     /* 2078739 */   GIM_Try, /*On fail goto*//*Label 27574*/ GIMT_Encode4(2078830), // Rule ID 16119 //
     /* 2078744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2078747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2078755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2078758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2078761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2078767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2078774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2078782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078790 */     // MIs[0] round
     /* 2078790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078793 */     // MIs[0] policy
     /* 2078793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078803 */     // (intrinsic_wo_chain:{ *:[nxv16i32] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2078806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078808 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2078826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078829 */     // GIR_Coverage, 16119,
     /* 2078829 */     GIR_EraseRootFromParent_Done,
     /* 2078830 */   // Label 27574: @2078830
     /* 2078830 */   GIM_Try, /*On fail goto*//*Label 27575*/ GIMT_Encode4(2078921), // Rule ID 16122 //
     /* 2078835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2078838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2078855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2078861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078881 */     // MIs[0] round
     /* 2078881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078884 */     // MIs[0] policy
     /* 2078884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078894 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2078894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2078897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078899 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2078909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2078914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2078917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2078919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2078920 */     // GIR_Coverage, 16122,
     /* 2078920 */     GIR_EraseRootFromParent_Done,
     /* 2078921 */   // Label 27575: @2078921
     /* 2078921 */   GIM_Try, /*On fail goto*//*Label 27576*/ GIMT_Encode4(2079012), // Rule ID 16123 //
     /* 2078926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2078929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2078934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2078937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2078940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2078943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2078946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2078949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2078952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2078956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2078964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2078968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2078972 */     // MIs[0] round
     /* 2078972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2078975 */     // MIs[0] policy
     /* 2078975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2078978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2078985 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 11531:{ *:[iPTR] }, VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2078985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M2_MASK),
     /* 2078988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2078990 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2078992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2078994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2078996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2078998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079011 */     // GIR_Coverage, 16123,
     /* 2079011 */     GIR_EraseRootFromParent_Done,
     /* 2079012 */   // Label 27576: @2079012
     /* 2079012 */   GIM_Try, /*On fail goto*//*Label 27577*/ GIMT_Encode4(2079103), // Rule ID 16126 //
     /* 2079017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2079020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2079028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2079031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2079034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079063 */     // MIs[0] round
     /* 2079063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079066 */     // MIs[0] policy
     /* 2079066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079076 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2079079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079081 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079102 */     // GIR_Coverage, 16126,
     /* 2079102 */     GIR_EraseRootFromParent_Done,
     /* 2079103 */   // Label 27577: @2079103
     /* 2079103 */   GIM_Try, /*On fail goto*//*Label 27578*/ GIMT_Encode4(2079194), // Rule ID 16127 //
     /* 2079108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2079111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2079119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2079122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2079125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2079138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2079146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079154 */     // MIs[0] round
     /* 2079154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079157 */     // MIs[0] policy
     /* 2079157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079167 */     // (intrinsic_wo_chain:{ *:[nxv4i64] } 11531:{ *:[iPTR] }, VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M4_MASK),
     /* 2079170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079172 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079193 */     // GIR_Coverage, 16127,
     /* 2079193 */     GIR_EraseRootFromParent_Done,
     /* 2079194 */   // Label 27578: @2079194
     /* 2079194 */   GIM_Try, /*On fail goto*//*Label 27579*/ GIMT_Encode4(2079285), // Rule ID 16130 //
     /* 2079199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2079202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2079210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2079213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2079216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2079219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079245 */     // MIs[0] round
     /* 2079245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079248 */     // MIs[0] policy
     /* 2079248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079258 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2079261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079263 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079284 */     // GIR_Coverage, 16130,
     /* 2079284 */     GIR_EraseRootFromParent_Done,
     /* 2079285 */   // Label 27579: @2079285
     /* 2079285 */   GIM_Try, /*On fail goto*//*Label 27580*/ GIMT_Encode4(2079376), // Rule ID 16131 //
     /* 2079290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2079293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vssra_mask),
     /* 2079298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2079301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2079304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2079307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2079310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2079320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2079328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2079332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079336 */     // MIs[0] round
     /* 2079336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079339 */     // MIs[0] policy
     /* 2079339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079349 */     // (intrinsic_wo_chain:{ *:[nxv8i64] } 11531:{ *:[iPTR] }, VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSSRA_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSRA_VX_M8_MASK),
     /* 2079352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079354 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2079372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079375 */     // GIR_Coverage, 16131,
     /* 2079375 */     GIR_EraseRootFromParent_Done,
     /* 2079376 */   // Label 27580: @2079376
     /* 2079376 */   GIM_Try, /*On fail goto*//*Label 27581*/ GIMT_Encode4(2079470), // Rule ID 16222 //
     /* 2079381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2079401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079427 */     // MIs[0] round
     /* 2079427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079430 */     // MIs[0] policy
     /* 2079430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079440 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2079443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079445 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079465 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079469 */     // GIR_Coverage, 16222,
     /* 2079469 */     GIR_EraseRootFromParent_Done,
     /* 2079470 */   // Label 27581: @2079470
     /* 2079470 */   GIM_Try, /*On fail goto*//*Label 27582*/ GIMT_Encode4(2079564), // Rule ID 16223 //
     /* 2079475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2079486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2079489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2079492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2079495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2079498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079521 */     // MIs[0] round
     /* 2079521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079524 */     // MIs[0] policy
     /* 2079524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079534 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF8_MASK),
     /* 2079537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079539 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079559 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079563 */     // GIR_Coverage, 16223,
     /* 2079563 */     GIR_EraseRootFromParent_Done,
     /* 2079564 */   // Label 27582: @2079564
     /* 2079564 */   GIM_Try, /*On fail goto*//*Label 27583*/ GIMT_Encode4(2079658), // Rule ID 16226 //
     /* 2079569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2079589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079615 */     // MIs[0] round
     /* 2079615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079618 */     // MIs[0] policy
     /* 2079618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079628 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2079631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079633 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079657 */     // GIR_Coverage, 16226,
     /* 2079657 */     GIR_EraseRootFromParent_Done,
     /* 2079658 */   // Label 27583: @2079658
     /* 2079658 */   GIM_Try, /*On fail goto*//*Label 27584*/ GIMT_Encode4(2079752), // Rule ID 16227 //
     /* 2079663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2079674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2079677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2079680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2079683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2079686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079709 */     // MIs[0] round
     /* 2079709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079712 */     // MIs[0] policy
     /* 2079712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079722 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2079725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079751 */     // GIR_Coverage, 16227,
     /* 2079751 */     GIR_EraseRootFromParent_Done,
     /* 2079752 */   // Label 27584: @2079752
     /* 2079752 */   GIM_Try, /*On fail goto*//*Label 27585*/ GIMT_Encode4(2079846), // Rule ID 16230 //
     /* 2079757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2079777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079803 */     // MIs[0] round
     /* 2079803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079806 */     // MIs[0] policy
     /* 2079806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079816 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2079816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2079819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079845 */     // GIR_Coverage, 16230,
     /* 2079845 */     GIR_EraseRootFromParent_Done,
     /* 2079846 */   // Label 27585: @2079846
     /* 2079846 */   GIM_Try, /*On fail goto*//*Label 27586*/ GIMT_Encode4(2079940), // Rule ID 16231 //
     /* 2079851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2079854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2079862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2079865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2079868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2079871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2079874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2079877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079897 */     // MIs[0] round
     /* 2079897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079900 */     // MIs[0] policy
     /* 2079900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2079910 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2079910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2079913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2079915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2079917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2079919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2079921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2079923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2079925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2079930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2079933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2079935 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2079938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2079939 */     // GIR_Coverage, 16231,
     /* 2079939 */     GIR_EraseRootFromParent_Done,
     /* 2079940 */   // Label 27586: @2079940
     /* 2079940 */   GIM_Try, /*On fail goto*//*Label 27587*/ GIMT_Encode4(2080034), // Rule ID 16234 //
     /* 2079945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2079948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2079953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2079956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2079959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2079962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2079965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2079968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2079971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2079975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2079983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2079987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2079991 */     // MIs[0] round
     /* 2079991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2079994 */     // MIs[0] policy
     /* 2079994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2079997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080004 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2080007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080029 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080033 */     // GIR_Coverage, 16234,
     /* 2080033 */     GIR_EraseRootFromParent_Done,
     /* 2080034 */   // Label 27587: @2080034
     /* 2080034 */   GIM_Try, /*On fail goto*//*Label 27588*/ GIMT_Encode4(2080128), // Rule ID 16235 //
     /* 2080039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2080050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2080053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2080056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2080059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2080062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080085 */     // MIs[0] round
     /* 2080085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080088 */     // MIs[0] policy
     /* 2080088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080098 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2080101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080123 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080127 */     // GIR_Coverage, 16235,
     /* 2080127 */     GIR_EraseRootFromParent_Done,
     /* 2080128 */   // Label 27588: @2080128
     /* 2080128 */   GIM_Try, /*On fail goto*//*Label 27589*/ GIMT_Encode4(2080222), // Rule ID 16238 //
     /* 2080133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2080150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2080153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080179 */     // MIs[0] round
     /* 2080179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080182 */     // MIs[0] policy
     /* 2080182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080192 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2080195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080217 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080221 */     // GIR_Coverage, 16238,
     /* 2080221 */     GIR_EraseRootFromParent_Done,
     /* 2080222 */   // Label 27589: @2080222
     /* 2080222 */   GIM_Try, /*On fail goto*//*Label 27590*/ GIMT_Encode4(2080316), // Rule ID 16239 //
     /* 2080227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2080238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2080241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2080244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2080247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2080250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2080257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080273 */     // MIs[0] round
     /* 2080273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080276 */     // MIs[0] policy
     /* 2080276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080286 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2080289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080315 */     // GIR_Coverage, 16239,
     /* 2080315 */     GIR_EraseRootFromParent_Done,
     /* 2080316 */   // Label 27590: @2080316
     /* 2080316 */   GIM_Try, /*On fail goto*//*Label 27591*/ GIMT_Encode4(2080410), // Rule ID 16242 //
     /* 2080321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2080338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2080341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080367 */     // MIs[0] round
     /* 2080367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080370 */     // MIs[0] policy
     /* 2080370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080380 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2080383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080409 */     // GIR_Coverage, 16242,
     /* 2080409 */     GIR_EraseRootFromParent_Done,
     /* 2080410 */   // Label 27591: @2080410
     /* 2080410 */   GIM_Try, /*On fail goto*//*Label 27592*/ GIMT_Encode4(2080504), // Rule ID 16243 //
     /* 2080415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2080426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2080429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2080432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2080435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2080438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2080445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2080453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2080457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080461 */     // MIs[0] round
     /* 2080461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080464 */     // MIs[0] policy
     /* 2080464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080474 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2080477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2080497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080503 */     // GIR_Coverage, 16243,
     /* 2080503 */     GIR_EraseRootFromParent_Done,
     /* 2080504 */   // Label 27592: @2080504
     /* 2080504 */   GIM_Try, /*On fail goto*//*Label 27593*/ GIMT_Encode4(2080598), // Rule ID 16246 //
     /* 2080509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2080520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2080523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2080529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080555 */     // MIs[0] round
     /* 2080555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080558 */     // MIs[0] policy
     /* 2080558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080568 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2080571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080593 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080597 */     // GIR_Coverage, 16246,
     /* 2080597 */     GIR_EraseRootFromParent_Done,
     /* 2080598 */   // Label 27593: @2080598
     /* 2080598 */   GIM_Try, /*On fail goto*//*Label 27594*/ GIMT_Encode4(2080692), // Rule ID 16247 //
     /* 2080603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2080614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2080617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2080620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2080623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2080626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080649 */     // MIs[0] round
     /* 2080649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080652 */     // MIs[0] policy
     /* 2080652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080662 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF4_MASK),
     /* 2080665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080687 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080691 */     // GIR_Coverage, 16247,
     /* 2080691 */     GIR_EraseRootFromParent_Done,
     /* 2080692 */   // Label 27594: @2080692
     /* 2080692 */   GIM_Try, /*On fail goto*//*Label 27595*/ GIMT_Encode4(2080786), // Rule ID 16250 //
     /* 2080697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2080708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2080711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2080717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080743 */     // MIs[0] round
     /* 2080743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080746 */     // MIs[0] policy
     /* 2080746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080756 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2080759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080781 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080785 */     // GIR_Coverage, 16250,
     /* 2080785 */     GIR_EraseRootFromParent_Done,
     /* 2080786 */   // Label 27595: @2080786
     /* 2080786 */   GIM_Try, /*On fail goto*//*Label 27596*/ GIMT_Encode4(2080880), // Rule ID 16251 //
     /* 2080791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2080802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2080805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2080808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2080811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2080814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2080817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080837 */     // MIs[0] round
     /* 2080837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080840 */     // MIs[0] policy
     /* 2080840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080850 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2080850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2080853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080879 */     // GIR_Coverage, 16251,
     /* 2080879 */     GIR_EraseRootFromParent_Done,
     /* 2080880 */   // Label 27596: @2080880
     /* 2080880 */   GIM_Try, /*On fail goto*//*Label 27597*/ GIMT_Encode4(2080974), // Rule ID 16254 //
     /* 2080885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2080888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2080902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2080905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2080908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2080911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2080915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2080923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2080927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2080931 */     // MIs[0] round
     /* 2080931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2080934 */     // MIs[0] policy
     /* 2080934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2080937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2080944 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2080944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2080947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2080949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2080951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2080953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2080955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2080957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2080959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2080964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2080967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2080969 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2080972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2080973 */     // GIR_Coverage, 16254,
     /* 2080973 */     GIR_EraseRootFromParent_Done,
     /* 2080974 */   // Label 27597: @2080974
     /* 2080974 */   GIM_Try, /*On fail goto*//*Label 27598*/ GIMT_Encode4(2081068), // Rule ID 16255 //
     /* 2080979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2080982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2080987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2080990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2080993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2080996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2080999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081025 */     // MIs[0] round
     /* 2081025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081028 */     // MIs[0] policy
     /* 2081028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081038 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2081041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081043 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081067 */     // GIR_Coverage, 16255,
     /* 2081067 */     GIR_EraseRootFromParent_Done,
     /* 2081068 */   // Label 27598: @2081068
     /* 2081068 */   GIM_Try, /*On fail goto*//*Label 27599*/ GIMT_Encode4(2081162), // Rule ID 16258 //
     /* 2081073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2081093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081119 */     // MIs[0] round
     /* 2081119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081122 */     // MIs[0] policy
     /* 2081122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2081135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081137 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081157 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081161 */     // GIR_Coverage, 16258,
     /* 2081161 */     GIR_EraseRootFromParent_Done,
     /* 2081162 */   // Label 27599: @2081162
     /* 2081162 */   GIM_Try, /*On fail goto*//*Label 27600*/ GIMT_Encode4(2081256), // Rule ID 16259 //
     /* 2081167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2081178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2081181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2081184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2081187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2081190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081213 */     // MIs[0] round
     /* 2081213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081216 */     // MIs[0] policy
     /* 2081216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081226 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2081229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081231 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081255 */     // GIR_Coverage, 16259,
     /* 2081255 */     GIR_EraseRootFromParent_Done,
     /* 2081256 */   // Label 27600: @2081256
     /* 2081256 */   GIM_Try, /*On fail goto*//*Label 27601*/ GIMT_Encode4(2081350), // Rule ID 16262 //
     /* 2081261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2081264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2081281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081307 */     // MIs[0] round
     /* 2081307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081310 */     // MIs[0] policy
     /* 2081310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081320 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2081323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081325 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081345 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081349 */     // GIR_Coverage, 16262,
     /* 2081349 */     GIR_EraseRootFromParent_Done,
     /* 2081350 */   // Label 27601: @2081350
     /* 2081350 */   GIM_Try, /*On fail goto*//*Label 27602*/ GIMT_Encode4(2081444), // Rule ID 16263 //
     /* 2081355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2081358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2081366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2081369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2081372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2081375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2081378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2081385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2081393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081401 */     // MIs[0] round
     /* 2081401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081404 */     // MIs[0] policy
     /* 2081404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081414 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2081417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081419 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2081437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081443 */     // GIR_Coverage, 16263,
     /* 2081443 */     GIR_EraseRootFromParent_Done,
     /* 2081444 */   // Label 27602: @2081444
     /* 2081444 */   GIM_Try, /*On fail goto*//*Label 27603*/ GIMT_Encode4(2081538), // Rule ID 16266 //
     /* 2081449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2081452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2081460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2081463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2081466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2081469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081495 */     // MIs[0] round
     /* 2081495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081498 */     // MIs[0] policy
     /* 2081498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081508 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2081511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081513 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081533 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081537 */     // GIR_Coverage, 16266,
     /* 2081537 */     GIR_EraseRootFromParent_Done,
     /* 2081538 */   // Label 27603: @2081538
     /* 2081538 */   GIM_Try, /*On fail goto*//*Label 27604*/ GIMT_Encode4(2081632), // Rule ID 16267 //
     /* 2081543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2081546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2081554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2081557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2081560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2081563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2081566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081589 */     // MIs[0] round
     /* 2081589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081592 */     // MIs[0] policy
     /* 2081592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081602 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_MF2_MASK),
     /* 2081605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081607 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081627 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081631 */     // GIR_Coverage, 16267,
     /* 2081631 */     GIR_EraseRootFromParent_Done,
     /* 2081632 */   // Label 27604: @2081632
     /* 2081632 */   GIM_Try, /*On fail goto*//*Label 27605*/ GIMT_Encode4(2081726), // Rule ID 16270 //
     /* 2081637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2081640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2081654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2081657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081683 */     // MIs[0] round
     /* 2081683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081686 */     // MIs[0] policy
     /* 2081686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081696 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2081699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081701 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081721 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081725 */     // GIR_Coverage, 16270,
     /* 2081725 */     GIR_EraseRootFromParent_Done,
     /* 2081726 */   // Label 27605: @2081726
     /* 2081726 */   GIM_Try, /*On fail goto*//*Label 27606*/ GIMT_Encode4(2081820), // Rule ID 16271 //
     /* 2081731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2081734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2081742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2081745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2081748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2081751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2081754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2081761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2081773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081777 */     // MIs[0] round
     /* 2081777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081780 */     // MIs[0] policy
     /* 2081780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081790 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M1_MASK),
     /* 2081793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081795 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081819 */     // GIR_Coverage, 16271,
     /* 2081819 */     GIR_EraseRootFromParent_Done,
     /* 2081820 */   // Label 27606: @2081820
     /* 2081820 */   GIM_Try, /*On fail goto*//*Label 27607*/ GIMT_Encode4(2081914), // Rule ID 16274 //
     /* 2081825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2081828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2081842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2081845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2081851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081871 */     // MIs[0] round
     /* 2081871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081874 */     // MIs[0] policy
     /* 2081874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081884 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2081884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2081887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081889 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2081907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2081909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2081912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2081913 */     // GIR_Coverage, 16274,
     /* 2081913 */     GIR_EraseRootFromParent_Done,
     /* 2081914 */   // Label 27607: @2081914
     /* 2081914 */   GIM_Try, /*On fail goto*//*Label 27608*/ GIMT_Encode4(2082008), // Rule ID 16275 //
     /* 2081919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2081922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2081927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2081930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2081933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2081936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2081939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2081942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2081945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2081949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2081957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2081961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2081965 */     // MIs[0] round
     /* 2081965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2081968 */     // MIs[0] policy
     /* 2081968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2081971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2081978 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2081978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M2_MASK),
     /* 2081981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2081983 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2081985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2081987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2081989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2081991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2081993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2081998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082007 */     // GIR_Coverage, 16275,
     /* 2082007 */     GIR_EraseRootFromParent_Done,
     /* 2082008 */   // Label 27608: @2082008
     /* 2082008 */   GIM_Try, /*On fail goto*//*Label 27609*/ GIMT_Encode4(2082102), // Rule ID 16278 //
     /* 2082013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2082016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2082033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082059 */     // MIs[0] round
     /* 2082059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082062 */     // MIs[0] policy
     /* 2082062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082072 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2082075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082077 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082097 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082101 */     // GIR_Coverage, 16278,
     /* 2082101 */     GIR_EraseRootFromParent_Done,
     /* 2082102 */   // Label 27609: @2082102
     /* 2082102 */   GIM_Try, /*On fail goto*//*Label 27610*/ GIMT_Encode4(2082196), // Rule ID 16279 //
     /* 2082107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2082110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2082118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2082121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2082124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2082127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2082137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2082145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082153 */     // MIs[0] round
     /* 2082153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082156 */     // MIs[0] policy
     /* 2082156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082166 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WV_M4_MASK),
     /* 2082169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082171 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2082189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082195 */     // GIR_Coverage, 16279,
     /* 2082195 */     GIR_EraseRootFromParent_Done,
     /* 2082196 */   // Label 27610: @2082196
     /* 2082196 */   GIM_Try, /*On fail goto*//*Label 27611*/ GIMT_Encode4(2082290), // Rule ID 16282 //
     /* 2082201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2082218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082247 */     // MIs[0] round
     /* 2082247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082250 */     // MIs[0] policy
     /* 2082250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082260 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2082263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082265 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082285 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082289 */     // GIR_Coverage, 16282,
     /* 2082289 */     GIR_EraseRootFromParent_Done,
     /* 2082290 */   // Label 27611: @2082290
     /* 2082290 */   GIM_Try, /*On fail goto*//*Label 27612*/ GIMT_Encode4(2082384), // Rule ID 16283 //
     /* 2082295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2082306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2082309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2082312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2082318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082341 */     // MIs[0] round
     /* 2082341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082344 */     // MIs[0] policy
     /* 2082344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082354 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF8_MASK),
     /* 2082357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082359 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082379 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082383 */     // GIR_Coverage, 16283,
     /* 2082383 */     GIR_EraseRootFromParent_Done,
     /* 2082384 */   // Label 27612: @2082384
     /* 2082384 */   GIM_Try, /*On fail goto*//*Label 27613*/ GIMT_Encode4(2082478), // Rule ID 16286 //
     /* 2082389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2082406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082435 */     // MIs[0] round
     /* 2082435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082438 */     // MIs[0] policy
     /* 2082438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082448 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2082451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082477 */     // GIR_Coverage, 16286,
     /* 2082477 */     GIR_EraseRootFromParent_Done,
     /* 2082478 */   // Label 27613: @2082478
     /* 2082478 */   GIM_Try, /*On fail goto*//*Label 27614*/ GIMT_Encode4(2082572), // Rule ID 16287 //
     /* 2082483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2082494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2082497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2082500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2082506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082529 */     // MIs[0] round
     /* 2082529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082532 */     // MIs[0] policy
     /* 2082532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082542 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2082545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082571 */     // GIR_Coverage, 16287,
     /* 2082571 */     GIR_EraseRootFromParent_Done,
     /* 2082572 */   // Label 27614: @2082572
     /* 2082572 */   GIM_Try, /*On fail goto*//*Label 27615*/ GIMT_Encode4(2082666), // Rule ID 16290 //
     /* 2082577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2082594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082623 */     // MIs[0] round
     /* 2082623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082626 */     // MIs[0] policy
     /* 2082626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082636 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2082639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082661 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082665 */     // GIR_Coverage, 16290,
     /* 2082665 */     GIR_EraseRootFromParent_Done,
     /* 2082666 */   // Label 27615: @2082666
     /* 2082666 */   GIM_Try, /*On fail goto*//*Label 27616*/ GIMT_Encode4(2082760), // Rule ID 16291 //
     /* 2082671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2082682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2082685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2082688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2082694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082717 */     // MIs[0] round
     /* 2082717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082720 */     // MIs[0] policy
     /* 2082720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082730 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2082733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082759 */     // GIR_Coverage, 16291,
     /* 2082759 */     GIR_EraseRootFromParent_Done,
     /* 2082760 */   // Label 27616: @2082760
     /* 2082760 */   GIM_Try, /*On fail goto*//*Label 27617*/ GIMT_Encode4(2082854), // Rule ID 16294 //
     /* 2082765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2082776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2082779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2082782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082811 */     // MIs[0] round
     /* 2082811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082814 */     // MIs[0] policy
     /* 2082814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082824 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2082824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2082827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082849 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082853 */     // GIR_Coverage, 16294,
     /* 2082853 */     GIR_EraseRootFromParent_Done,
     /* 2082854 */   // Label 27617: @2082854
     /* 2082854 */   GIM_Try, /*On fail goto*//*Label 27618*/ GIMT_Encode4(2082948), // Rule ID 16295 //
     /* 2082859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2082862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2082870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2082873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2082876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2082879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2082882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2082885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2082889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2082893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082905 */     // MIs[0] round
     /* 2082905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2082908 */     // MIs[0] policy
     /* 2082908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2082911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2082918 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11417:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2082918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2082921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2082923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2082925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2082927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2082929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2082931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2082933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2082938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2082941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2082943 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2082946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2082947 */     // GIR_Coverage, 16295,
     /* 2082947 */     GIR_EraseRootFromParent_Done,
     /* 2082948 */   // Label 27618: @2082948
     /* 2082948 */   GIM_Try, /*On fail goto*//*Label 27619*/ GIMT_Encode4(2083042), // Rule ID 16298 //
     /* 2082953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2082956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2082961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2082964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2082967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2082970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2082973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2082976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2082979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2082983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2082987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2082991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2082995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2082999 */     // MIs[0] round
     /* 2082999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083002 */     // MIs[0] policy
     /* 2083002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2083015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083041 */     // GIR_Coverage, 16298,
     /* 2083041 */     GIR_EraseRootFromParent_Done,
     /* 2083042 */   // Label 27619: @2083042
     /* 2083042 */   GIM_Try, /*On fail goto*//*Label 27620*/ GIMT_Encode4(2083136), // Rule ID 16299 //
     /* 2083047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2083058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2083061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2083064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2083070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083093 */     // MIs[0] round
     /* 2083093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083096 */     // MIs[0] policy
     /* 2083096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2083109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083135 */     // GIR_Coverage, 16299,
     /* 2083135 */     GIR_EraseRootFromParent_Done,
     /* 2083136 */   // Label 27620: @2083136
     /* 2083136 */   GIM_Try, /*On fail goto*//*Label 27621*/ GIMT_Encode4(2083230), // Rule ID 16302 //
     /* 2083141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2083152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2083155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2083158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2083164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083187 */     // MIs[0] round
     /* 2083187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083190 */     // MIs[0] policy
     /* 2083190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083200 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2083203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083229 */     // GIR_Coverage, 16302,
     /* 2083229 */     GIR_EraseRootFromParent_Done,
     /* 2083230 */   // Label 27621: @2083230
     /* 2083230 */   GIM_Try, /*On fail goto*//*Label 27622*/ GIMT_Encode4(2083324), // Rule ID 16303 //
     /* 2083235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2083246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2083249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2083252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2083258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2083265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2083273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083281 */     // MIs[0] round
     /* 2083281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083284 */     // MIs[0] policy
     /* 2083284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083294 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2083297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2083317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083319 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083323 */     // GIR_Coverage, 16303,
     /* 2083323 */     GIR_EraseRootFromParent_Done,
     /* 2083324 */   // Label 27622: @2083324
     /* 2083324 */   GIM_Try, /*On fail goto*//*Label 27623*/ GIMT_Encode4(2083418), // Rule ID 16306 //
     /* 2083329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083375 */     // MIs[0] round
     /* 2083375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083378 */     // MIs[0] policy
     /* 2083378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083388 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2083391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083413 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083417 */     // GIR_Coverage, 16306,
     /* 2083417 */     GIR_EraseRootFromParent_Done,
     /* 2083418 */   // Label 27623: @2083418
     /* 2083418 */   GIM_Try, /*On fail goto*//*Label 27624*/ GIMT_Encode4(2083512), // Rule ID 16307 //
     /* 2083423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2083434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2083437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2083440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2083446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083469 */     // MIs[0] round
     /* 2083469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083472 */     // MIs[0] policy
     /* 2083472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083482 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF4_MASK),
     /* 2083485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083507 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083511 */     // GIR_Coverage, 16307,
     /* 2083511 */     GIR_EraseRootFromParent_Done,
     /* 2083512 */   // Label 27624: @2083512
     /* 2083512 */   GIM_Try, /*On fail goto*//*Label 27625*/ GIMT_Encode4(2083606), // Rule ID 16310 //
     /* 2083517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2083534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083563 */     // MIs[0] round
     /* 2083563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083566 */     // MIs[0] policy
     /* 2083566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083576 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2083579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083601 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083605 */     // GIR_Coverage, 16310,
     /* 2083605 */     GIR_EraseRootFromParent_Done,
     /* 2083606 */   // Label 27625: @2083606
     /* 2083606 */   GIM_Try, /*On fail goto*//*Label 27626*/ GIMT_Encode4(2083700), // Rule ID 16311 //
     /* 2083611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2083622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2083625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2083628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2083634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083657 */     // MIs[0] round
     /* 2083657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083660 */     // MIs[0] policy
     /* 2083660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083670 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2083673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083699 */     // GIR_Coverage, 16311,
     /* 2083699 */     GIR_EraseRootFromParent_Done,
     /* 2083700 */   // Label 27626: @2083700
     /* 2083700 */   GIM_Try, /*On fail goto*//*Label 27627*/ GIMT_Encode4(2083794), // Rule ID 16314 //
     /* 2083705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2083722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083751 */     // MIs[0] round
     /* 2083751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083754 */     // MIs[0] policy
     /* 2083754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083764 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2083767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083769 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083793 */     // GIR_Coverage, 16314,
     /* 2083793 */     GIR_EraseRootFromParent_Done,
     /* 2083794 */   // Label 27627: @2083794
     /* 2083794 */   GIM_Try, /*On fail goto*//*Label 27628*/ GIMT_Encode4(2083888), // Rule ID 16315 //
     /* 2083799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2083810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2083813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2083816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2083819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2083822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2083825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2083829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2083833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083845 */     // MIs[0] round
     /* 2083845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083848 */     // MIs[0] policy
     /* 2083848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083858 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11417:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2083858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2083861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083863 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083883 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083887 */     // GIR_Coverage, 16315,
     /* 2083887 */     GIR_EraseRootFromParent_Done,
     /* 2083888 */   // Label 27628: @2083888
     /* 2083888 */   GIM_Try, /*On fail goto*//*Label 27629*/ GIMT_Encode4(2083982), // Rule ID 16318 //
     /* 2083893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2083896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2083904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2083907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2083910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2083913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2083916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2083919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2083923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2083927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2083931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2083935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2083939 */     // MIs[0] round
     /* 2083939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2083942 */     // MIs[0] policy
     /* 2083942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2083945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2083952 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2083952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2083955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2083957 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2083959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2083961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2083963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2083965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2083967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2083972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2083975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2083977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2083980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2083981 */     // GIR_Coverage, 16318,
     /* 2083981 */     GIR_EraseRootFromParent_Done,
     /* 2083982 */   // Label 27629: @2083982
     /* 2083982 */   GIM_Try, /*On fail goto*//*Label 27630*/ GIMT_Encode4(2084076), // Rule ID 16319 //
     /* 2083987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2083990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2083995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2083998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2084001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2084004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084033 */     // MIs[0] round
     /* 2084033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084036 */     // MIs[0] policy
     /* 2084036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2084049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084051 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084071 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084075 */     // GIR_Coverage, 16319,
     /* 2084075 */     GIR_EraseRootFromParent_Done,
     /* 2084076 */   // Label 27630: @2084076
     /* 2084076 */   GIM_Try, /*On fail goto*//*Label 27631*/ GIMT_Encode4(2084170), // Rule ID 16322 //
     /* 2084081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2084084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2084092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2084095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2084098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084127 */     // MIs[0] round
     /* 2084127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084130 */     // MIs[0] policy
     /* 2084130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084140 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2084143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084145 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084165 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084169 */     // GIR_Coverage, 16322,
     /* 2084169 */     GIR_EraseRootFromParent_Done,
     /* 2084170 */   // Label 27631: @2084170
     /* 2084170 */   GIM_Try, /*On fail goto*//*Label 27632*/ GIMT_Encode4(2084264), // Rule ID 16323 //
     /* 2084175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2084178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2084186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2084189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2084192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2084198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084221 */     // MIs[0] round
     /* 2084221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084224 */     // MIs[0] policy
     /* 2084224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084234 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2084237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084239 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2084257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084259 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084263 */     // GIR_Coverage, 16323,
     /* 2084263 */     GIR_EraseRootFromParent_Done,
     /* 2084264 */   // Label 27632: @2084264
     /* 2084264 */   GIM_Try, /*On fail goto*//*Label 27633*/ GIMT_Encode4(2084358), // Rule ID 16326 //
     /* 2084269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2084272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2084280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2084283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084315 */     // MIs[0] round
     /* 2084315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084318 */     // MIs[0] policy
     /* 2084318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084328 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2084331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084333 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084353 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084357 */     // GIR_Coverage, 16326,
     /* 2084357 */     GIR_EraseRootFromParent_Done,
     /* 2084358 */   // Label 27633: @2084358
     /* 2084358 */   GIM_Try, /*On fail goto*//*Label 27634*/ GIMT_Encode4(2084452), // Rule ID 16327 //
     /* 2084363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2084366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2084374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2084377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2084380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2084386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084409 */     // MIs[0] round
     /* 2084409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084412 */     // MIs[0] policy
     /* 2084412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084422 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_MF2_MASK),
     /* 2084425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084427 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084451 */     // GIR_Coverage, 16327,
     /* 2084451 */     GIR_EraseRootFromParent_Done,
     /* 2084452 */   // Label 27634: @2084452
     /* 2084452 */   GIM_Try, /*On fail goto*//*Label 27635*/ GIMT_Encode4(2084546), // Rule ID 16330 //
     /* 2084457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2084460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2084474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084503 */     // MIs[0] round
     /* 2084503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084506 */     // MIs[0] policy
     /* 2084506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084516 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2084519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084521 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084545 */     // GIR_Coverage, 16330,
     /* 2084545 */     GIR_EraseRootFromParent_Done,
     /* 2084546 */   // Label 27635: @2084546
     /* 2084546 */   GIM_Try, /*On fail goto*//*Label 27636*/ GIMT_Encode4(2084640), // Rule ID 16331 //
     /* 2084551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2084554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2084562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2084565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2084568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2084574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2084581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2084585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084597 */     // MIs[0] round
     /* 2084597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084600 */     // MIs[0] policy
     /* 2084600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084610 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11417:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M1_MASK),
     /* 2084613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084615 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084635 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084639 */     // GIR_Coverage, 16331,
     /* 2084639 */     GIR_EraseRootFromParent_Done,
     /* 2084640 */   // Label 27636: @2084640
     /* 2084640 */   GIM_Try, /*On fail goto*//*Label 27637*/ GIMT_Encode4(2084734), // Rule ID 16334 //
     /* 2084645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2084648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2084656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2084659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2084662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084691 */     // MIs[0] round
     /* 2084691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084694 */     // MIs[0] policy
     /* 2084694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084704 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2084707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084709 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084733 */     // GIR_Coverage, 16334,
     /* 2084733 */     GIR_EraseRootFromParent_Done,
     /* 2084734 */   // Label 27637: @2084734
     /* 2084734 */   GIM_Try, /*On fail goto*//*Label 27638*/ GIMT_Encode4(2084828), // Rule ID 16335 //
     /* 2084739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2084742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2084750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2084753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2084756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2084762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2084769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2084773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084785 */     // MIs[0] round
     /* 2084785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084788 */     // MIs[0] policy
     /* 2084788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11417:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M2_MASK),
     /* 2084801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084803 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084823 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084827 */     // GIR_Coverage, 16335,
     /* 2084827 */     GIR_EraseRootFromParent_Done,
     /* 2084828 */   // Label 27638: @2084828
     /* 2084828 */   GIM_Try, /*On fail goto*//*Label 27639*/ GIMT_Encode4(2084922), // Rule ID 16338 //
     /* 2084833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2084836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2084844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2084847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2084850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2084853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2084859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084879 */     // MIs[0] round
     /* 2084879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084882 */     // MIs[0] policy
     /* 2084882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084892 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2084892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2084895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084897 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2084907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2084912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2084915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2084917 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2084920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2084921 */     // GIR_Coverage, 16338,
     /* 2084921 */     GIR_EraseRootFromParent_Done,
     /* 2084922 */   // Label 27639: @2084922
     /* 2084922 */   GIM_Try, /*On fail goto*//*Label 27640*/ GIMT_Encode4(2085016), // Rule ID 16339 //
     /* 2084927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2084930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclipu_mask),
     /* 2084935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2084938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2084941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2084944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2084947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2084950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2084953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2084957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2084961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2084965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2084969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2084973 */     // MIs[0] round
     /* 2084973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2084976 */     // MIs[0] policy
     /* 2084976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2084979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2084986 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11417:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIPU_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2084986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIPU_WX_M4_MASK),
     /* 2084989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2084991 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2084993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2084995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2084997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2084999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2085009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085015 */     // GIR_Coverage, 16339,
     /* 2085015 */     GIR_EraseRootFromParent_Done,
     /* 2085016 */   // Label 27640: @2085016
     /* 2085016 */   GIM_Try, /*On fail goto*//*Label 27641*/ GIMT_Encode4(2085110), // Rule ID 16402 //
     /* 2085021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2085032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2085035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2085038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2085041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085067 */     // MIs[0] round
     /* 2085067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085070 */     // MIs[0] policy
     /* 2085070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085080 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2085083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085085 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085105 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085109 */     // GIR_Coverage, 16402,
     /* 2085109 */     GIR_EraseRootFromParent_Done,
     /* 2085110 */   // Label 27641: @2085110
     /* 2085110 */   GIM_Try, /*On fail goto*//*Label 27642*/ GIMT_Encode4(2085204), // Rule ID 16403 //
     /* 2085115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2085126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2085129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2085132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s8,
     /* 2085135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2085138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085161 */     // MIs[0] round
     /* 2085161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085164 */     // MIs[0] policy
     /* 2085164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085174 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF8_MASK),
     /* 2085177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085179 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085203 */     // GIR_Coverage, 16403,
     /* 2085203 */     GIR_EraseRootFromParent_Done,
     /* 2085204 */   // Label 27642: @2085204
     /* 2085204 */   GIM_Try, /*On fail goto*//*Label 27643*/ GIMT_Encode4(2085298), // Rule ID 16406 //
     /* 2085209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2085220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2085223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2085226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2085229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085255 */     // MIs[0] round
     /* 2085255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085258 */     // MIs[0] policy
     /* 2085258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085268 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2085271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085297 */     // GIR_Coverage, 16406,
     /* 2085297 */     GIR_EraseRootFromParent_Done,
     /* 2085298 */   // Label 27643: @2085298
     /* 2085298 */   GIM_Try, /*On fail goto*//*Label 27644*/ GIMT_Encode4(2085392), // Rule ID 16407 //
     /* 2085303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2085314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2085317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2085320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s8,
     /* 2085323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2085326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085349 */     // MIs[0] round
     /* 2085349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085352 */     // MIs[0] policy
     /* 2085352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085362 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2085365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085391 */     // GIR_Coverage, 16407,
     /* 2085391 */     GIR_EraseRootFromParent_Done,
     /* 2085392 */   // Label 27644: @2085392
     /* 2085392 */   GIM_Try, /*On fail goto*//*Label 27645*/ GIMT_Encode4(2085486), // Rule ID 16410 //
     /* 2085397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2085408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2085411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2085414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2085417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085443 */     // MIs[0] round
     /* 2085443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085446 */     // MIs[0] policy
     /* 2085446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085456 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2085459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085481 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085485 */     // GIR_Coverage, 16410,
     /* 2085485 */     GIR_EraseRootFromParent_Done,
     /* 2085486 */   // Label 27645: @2085486
     /* 2085486 */   GIM_Try, /*On fail goto*//*Label 27646*/ GIMT_Encode4(2085580), // Rule ID 16411 //
     /* 2085491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2085502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2085505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2085508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s8,
     /* 2085511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2085514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085537 */     // MIs[0] round
     /* 2085537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085540 */     // MIs[0] policy
     /* 2085540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085550 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2085553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085575 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085579 */     // GIR_Coverage, 16411,
     /* 2085579 */     GIR_EraseRootFromParent_Done,
     /* 2085580 */   // Label 27646: @2085580
     /* 2085580 */   GIM_Try, /*On fail goto*//*Label 27647*/ GIMT_Encode4(2085674), // Rule ID 16414 //
     /* 2085585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2085596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2085599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2085605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085631 */     // MIs[0] round
     /* 2085631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085634 */     // MIs[0] policy
     /* 2085634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085644 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2085647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085669 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085673 */     // GIR_Coverage, 16414,
     /* 2085673 */     GIR_EraseRootFromParent_Done,
     /* 2085674 */   // Label 27647: @2085674
     /* 2085674 */   GIM_Try, /*On fail goto*//*Label 27648*/ GIMT_Encode4(2085768), // Rule ID 16415 //
     /* 2085679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2085690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2085693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2085696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s8,
     /* 2085699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2085702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2085709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2085721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085725 */     // MIs[0] round
     /* 2085725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085728 */     // MIs[0] policy
     /* 2085728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085738 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2085741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085767 */     // GIR_Coverage, 16415,
     /* 2085767 */     GIR_EraseRootFromParent_Done,
     /* 2085768 */   // Label 27648: @2085768
     /* 2085768 */   GIM_Try, /*On fail goto*//*Label 27649*/ GIMT_Encode4(2085862), // Rule ID 16418 //
     /* 2085773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2085784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2085787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2085793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085819 */     // MIs[0] round
     /* 2085819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085822 */     // MIs[0] policy
     /* 2085822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085832 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2085832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2085835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085857 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085861 */     // GIR_Coverage, 16418,
     /* 2085861 */     GIR_EraseRootFromParent_Done,
     /* 2085862 */   // Label 27649: @2085862
     /* 2085862 */   GIM_Try, /*On fail goto*//*Label 27650*/ GIMT_Encode4(2085956), // Rule ID 16419 //
     /* 2085867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2085870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2085878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2085881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2085884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 2085887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2085890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2085893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2085897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2085909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2085913 */     // MIs[0] round
     /* 2085913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2085916 */     // MIs[0] policy
     /* 2085916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2085919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2085926 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2085926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2085929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2085931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2085933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2085935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2085937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2085939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2085941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2085946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2085949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2085951 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2085954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2085955 */     // GIR_Coverage, 16419,
     /* 2085955 */     GIR_EraseRootFromParent_Done,
     /* 2085956 */   // Label 27650: @2085956
     /* 2085956 */   GIM_Try, /*On fail goto*//*Label 27651*/ GIMT_Encode4(2086050), // Rule ID 16422 //
     /* 2085961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2085964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2085969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2085972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2085975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2085978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2085981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2085984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2085987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2085991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2085995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2085999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086007 */     // MIs[0] round
     /* 2086007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086010 */     // MIs[0] policy
     /* 2086010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086020 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2086023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086049 */     // GIR_Coverage, 16422,
     /* 2086049 */     GIR_EraseRootFromParent_Done,
     /* 2086050 */   // Label 27651: @2086050
     /* 2086050 */   GIM_Try, /*On fail goto*//*Label 27652*/ GIMT_Encode4(2086144), // Rule ID 16423 //
     /* 2086055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2086066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2086069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2086072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s8,
     /* 2086075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2086078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086101 */     // MIs[0] round
     /* 2086101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086104 */     // MIs[0] policy
     /* 2086104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086114 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2086117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2086137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086139 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086143 */     // GIR_Coverage, 16423,
     /* 2086143 */     GIR_EraseRootFromParent_Done,
     /* 2086144 */   // Label 27652: @2086144
     /* 2086144 */   GIM_Try, /*On fail goto*//*Label 27653*/ GIMT_Encode4(2086238), // Rule ID 16426 //
     /* 2086149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2086160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2086163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2086166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2086169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086195 */     // MIs[0] round
     /* 2086195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086198 */     // MIs[0] policy
     /* 2086198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086208 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2086211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086233 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086237 */     // GIR_Coverage, 16426,
     /* 2086237 */     GIR_EraseRootFromParent_Done,
     /* 2086238 */   // Label 27653: @2086238
     /* 2086238 */   GIM_Try, /*On fail goto*//*Label 27654*/ GIMT_Encode4(2086332), // Rule ID 16427 //
     /* 2086243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2086254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2086257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2086260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2086263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2086266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086289 */     // MIs[0] round
     /* 2086289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086292 */     // MIs[0] policy
     /* 2086292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086302 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF4_MASK),
     /* 2086305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086327 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086331 */     // GIR_Coverage, 16427,
     /* 2086331 */     GIR_EraseRootFromParent_Done,
     /* 2086332 */   // Label 27654: @2086332
     /* 2086332 */   GIM_Try, /*On fail goto*//*Label 27655*/ GIMT_Encode4(2086426), // Rule ID 16430 //
     /* 2086337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2086348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2086351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2086354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2086357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086383 */     // MIs[0] round
     /* 2086383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086386 */     // MIs[0] policy
     /* 2086386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086396 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2086399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086421 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086425 */     // GIR_Coverage, 16430,
     /* 2086425 */     GIR_EraseRootFromParent_Done,
     /* 2086426 */   // Label 27655: @2086426
     /* 2086426 */   GIM_Try, /*On fail goto*//*Label 27656*/ GIMT_Encode4(2086520), // Rule ID 16431 //
     /* 2086431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2086442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2086445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2086448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2086451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2086454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086477 */     // MIs[0] round
     /* 2086477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086480 */     // MIs[0] policy
     /* 2086480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086490 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2086493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086519 */     // GIR_Coverage, 16431,
     /* 2086519 */     GIR_EraseRootFromParent_Done,
     /* 2086520 */   // Label 27656: @2086520
     /* 2086520 */   GIM_Try, /*On fail goto*//*Label 27657*/ GIMT_Encode4(2086614), // Rule ID 16434 //
     /* 2086525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2086536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2086539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2086542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2086545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086571 */     // MIs[0] round
     /* 2086571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086574 */     // MIs[0] policy
     /* 2086574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086584 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2086587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086589 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086609 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086613 */     // GIR_Coverage, 16434,
     /* 2086613 */     GIR_EraseRootFromParent_Done,
     /* 2086614 */   // Label 27657: @2086614
     /* 2086614 */   GIM_Try, /*On fail goto*//*Label 27658*/ GIMT_Encode4(2086708), // Rule ID 16435 //
     /* 2086619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2086630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2086633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2086636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2086639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2086642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2086649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2086661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086665 */     // MIs[0] round
     /* 2086665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086668 */     // MIs[0] policy
     /* 2086668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086678 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2086681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086683 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086703 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086707 */     // GIR_Coverage, 16435,
     /* 2086707 */     GIR_EraseRootFromParent_Done,
     /* 2086708 */   // Label 27658: @2086708
     /* 2086708 */   GIM_Try, /*On fail goto*//*Label 27659*/ GIMT_Encode4(2086802), // Rule ID 16438 //
     /* 2086713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2086724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2086727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2086733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086759 */     // MIs[0] round
     /* 2086759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086762 */     // MIs[0] policy
     /* 2086762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086772 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2086775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086777 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086801 */     // GIR_Coverage, 16438,
     /* 2086801 */     GIR_EraseRootFromParent_Done,
     /* 2086802 */   // Label 27659: @2086802
     /* 2086802 */   GIM_Try, /*On fail goto*//*Label 27660*/ GIMT_Encode4(2086896), // Rule ID 16439 //
     /* 2086807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2086818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2086821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2086824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2086827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2086830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2086833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2086837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2086849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086853 */     // MIs[0] round
     /* 2086853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086856 */     // MIs[0] policy
     /* 2086856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086866 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2086866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2086869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086871 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086895 */     // GIR_Coverage, 16439,
     /* 2086895 */     GIR_EraseRootFromParent_Done,
     /* 2086896 */   // Label 27660: @2086896
     /* 2086896 */   GIM_Try, /*On fail goto*//*Label 27661*/ GIMT_Encode4(2086990), // Rule ID 16442 //
     /* 2086901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2086904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2086909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2086912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2086915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2086918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2086921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2086924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2086927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2086931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2086939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2086943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2086947 */     // MIs[0] round
     /* 2086947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2086950 */     // MIs[0] policy
     /* 2086950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2086953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2086960 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2086960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2086963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2086965 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2086967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2086969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2086971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2086973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2086975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2086980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2086983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2086985 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2086988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2086989 */     // GIR_Coverage, 16442,
     /* 2086989 */     GIR_EraseRootFromParent_Done,
     /* 2086990 */   // Label 27661: @2086990
     /* 2086990 */   GIM_Try, /*On fail goto*//*Label 27662*/ GIMT_Encode4(2087084), // Rule ID 16443 //
     /* 2086995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2086998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2087006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2087009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2087012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2087015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2087018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087041 */     // MIs[0] round
     /* 2087041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087044 */     // MIs[0] policy
     /* 2087044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087054 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2087057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087059 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2087077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087079 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087083 */     // GIR_Coverage, 16443,
     /* 2087083 */     GIR_EraseRootFromParent_Done,
     /* 2087084 */   // Label 27662: @2087084
     /* 2087084 */   GIM_Try, /*On fail goto*//*Label 27663*/ GIMT_Encode4(2087178), // Rule ID 16446 //
     /* 2087089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2087092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2087106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2087109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087135 */     // MIs[0] round
     /* 2087135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087138 */     // MIs[0] policy
     /* 2087138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087148 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2087151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087153 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087177 */     // GIR_Coverage, 16446,
     /* 2087177 */     GIR_EraseRootFromParent_Done,
     /* 2087178 */   // Label 27663: @2087178
     /* 2087178 */   GIM_Try, /*On fail goto*//*Label 27664*/ GIMT_Encode4(2087272), // Rule ID 16447 //
     /* 2087183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2087186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2087194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2087197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2087200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2087203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087229 */     // MIs[0] round
     /* 2087229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087232 */     // MIs[0] policy
     /* 2087232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087242 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_MF2_MASK),
     /* 2087245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087247 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087267 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087271 */     // GIR_Coverage, 16447,
     /* 2087271 */     GIR_EraseRootFromParent_Done,
     /* 2087272 */   // Label 27664: @2087272
     /* 2087272 */   GIM_Try, /*On fail goto*//*Label 27665*/ GIMT_Encode4(2087366), // Rule ID 16450 //
     /* 2087277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2087280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2087288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2087291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2087294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2087297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087323 */     // MIs[0] round
     /* 2087323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087326 */     // MIs[0] policy
     /* 2087326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087336 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2087339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087341 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087361 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087365 */     // GIR_Coverage, 16450,
     /* 2087365 */     GIR_EraseRootFromParent_Done,
     /* 2087366 */   // Label 27665: @2087366
     /* 2087366 */   GIM_Try, /*On fail goto*//*Label 27666*/ GIMT_Encode4(2087460), // Rule ID 16451 //
     /* 2087371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2087374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2087382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2087385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2087388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2087391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2087394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087417 */     // MIs[0] round
     /* 2087417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087420 */     // MIs[0] policy
     /* 2087420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087430 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M1_MASK),
     /* 2087433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087435 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087455 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087459 */     // GIR_Coverage, 16451,
     /* 2087459 */     GIR_EraseRootFromParent_Done,
     /* 2087460 */   // Label 27666: @2087460
     /* 2087460 */   GIM_Try, /*On fail goto*//*Label 27667*/ GIMT_Encode4(2087554), // Rule ID 16454 //
     /* 2087465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2087468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2087476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2087479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2087482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2087485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087511 */     // MIs[0] round
     /* 2087511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087514 */     // MIs[0] policy
     /* 2087514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087524 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2087527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087529 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087549 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087553 */     // GIR_Coverage, 16454,
     /* 2087553 */     GIR_EraseRootFromParent_Done,
     /* 2087554 */   // Label 27667: @2087554
     /* 2087554 */   GIM_Try, /*On fail goto*//*Label 27668*/ GIMT_Encode4(2087648), // Rule ID 16455 //
     /* 2087559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2087562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2087570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2087573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2087576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2087579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2087582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2087589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2087601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087605 */     // MIs[0] round
     /* 2087605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087608 */     // MIs[0] policy
     /* 2087608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087618 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M2_MASK),
     /* 2087621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087623 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087643 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087647 */     // GIR_Coverage, 16455,
     /* 2087647 */     GIR_EraseRootFromParent_Done,
     /* 2087648 */   // Label 27668: @2087648
     /* 2087648 */   GIM_Try, /*On fail goto*//*Label 27669*/ GIMT_Encode4(2087742), // Rule ID 16458 //
     /* 2087653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2087656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2087664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2087667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2087670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2087673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087699 */     // MIs[0] round
     /* 2087699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087702 */     // MIs[0] policy
     /* 2087702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087712 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2087715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087717 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087737 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087741 */     // GIR_Coverage, 16458,
     /* 2087741 */     GIR_EraseRootFromParent_Done,
     /* 2087742 */   // Label 27669: @2087742
     /* 2087742 */   GIM_Try, /*On fail goto*//*Label 27670*/ GIMT_Encode4(2087836), // Rule ID 16459 //
     /* 2087747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2087750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2087758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2087761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2087764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2087767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2087770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2087777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2087785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2087789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087793 */     // MIs[0] round
     /* 2087793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087796 */     // MIs[0] policy
     /* 2087796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087806 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WV_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WV_M4_MASK),
     /* 2087809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087811 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2087829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087835 */     // GIR_Coverage, 16459,
     /* 2087835 */     GIR_EraseRootFromParent_Done,
     /* 2087836 */   // Label 27670: @2087836
     /* 2087836 */   GIM_Try, /*On fail goto*//*Label 27671*/ GIMT_Encode4(2087930), // Rule ID 16462 //
     /* 2087841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2087844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2087861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2087867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087887 */     // MIs[0] round
     /* 2087887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087890 */     // MIs[0] policy
     /* 2087890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087900 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2087900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2087903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087905 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2087907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2087909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2087911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2087913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2087915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2087920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2087923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2087925 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2087928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2087929 */     // GIR_Coverage, 16462,
     /* 2087929 */     GIR_EraseRootFromParent_Done,
     /* 2087930 */   // Label 27671: @2087930
     /* 2087930 */   GIM_Try, /*On fail goto*//*Label 27672*/ GIMT_Encode4(2088024), // Rule ID 16463 //
     /* 2087935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2087938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2087943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2087946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2087949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2087952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2087955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2087958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2087961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2087965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2087973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2087977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2087981 */     // MIs[0] round
     /* 2087981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2087984 */     // MIs[0] policy
     /* 2087984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2087987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2087994 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2087994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF8_MASK),
     /* 2087997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2087999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088019 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088023 */     // GIR_Coverage, 16463,
     /* 2088023 */     GIR_EraseRootFromParent_Done,
     /* 2088024 */   // Label 27672: @2088024
     /* 2088024 */   GIM_Try, /*On fail goto*//*Label 27673*/ GIMT_Encode4(2088118), // Rule ID 16466 //
     /* 2088029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2088040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2088043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2088046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088075 */     // MIs[0] round
     /* 2088075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088078 */     // MIs[0] policy
     /* 2088078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088088 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2088091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088117 */     // GIR_Coverage, 16466,
     /* 2088117 */     GIR_EraseRootFromParent_Done,
     /* 2088118 */   // Label 27673: @2088118
     /* 2088118 */   GIM_Try, /*On fail goto*//*Label 27674*/ GIMT_Encode4(2088212), // Rule ID 16467 //
     /* 2088123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2088134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2088137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2088140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2088146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088169 */     // MIs[0] round
     /* 2088169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088172 */     // MIs[0] policy
     /* 2088172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088182 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2088185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088211 */     // GIR_Coverage, 16467,
     /* 2088211 */     GIR_EraseRootFromParent_Done,
     /* 2088212 */   // Label 27674: @2088212
     /* 2088212 */   GIM_Try, /*On fail goto*//*Label 27675*/ GIMT_Encode4(2088306), // Rule ID 16470 //
     /* 2088217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2088228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2088231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088263 */     // MIs[0] round
     /* 2088263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088266 */     // MIs[0] policy
     /* 2088266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088276 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2088279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088301 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088305 */     // GIR_Coverage, 16470,
     /* 2088305 */     GIR_EraseRootFromParent_Done,
     /* 2088306 */   // Label 27675: @2088306
     /* 2088306 */   GIM_Try, /*On fail goto*//*Label 27676*/ GIMT_Encode4(2088400), // Rule ID 16471 //
     /* 2088311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2088322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2088325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2088328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2088334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088357 */     // MIs[0] round
     /* 2088357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088360 */     // MIs[0] policy
     /* 2088360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088370 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2088373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088395 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088399 */     // GIR_Coverage, 16471,
     /* 2088399 */     GIR_EraseRootFromParent_Done,
     /* 2088400 */   // Label 27676: @2088400
     /* 2088400 */   GIM_Try, /*On fail goto*//*Label 27677*/ GIMT_Encode4(2088494), // Rule ID 16474 //
     /* 2088405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2088422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088451 */     // MIs[0] round
     /* 2088451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088454 */     // MIs[0] policy
     /* 2088454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088464 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2088467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088493 */     // GIR_Coverage, 16474,
     /* 2088493 */     GIR_EraseRootFromParent_Done,
     /* 2088494 */   // Label 27677: @2088494
     /* 2088494 */   GIM_Try, /*On fail goto*//*Label 27678*/ GIMT_Encode4(2088588), // Rule ID 16475 //
     /* 2088499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2088510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2088513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2088516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2088522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2088533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088545 */     // MIs[0] round
     /* 2088545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088548 */     // MIs[0] policy
     /* 2088548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088558 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11415:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2088561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088587 */     // GIR_Coverage, 16475,
     /* 2088587 */     GIR_EraseRootFromParent_Done,
     /* 2088588 */   // Label 27678: @2088588
     /* 2088588 */   GIM_Try, /*On fail goto*//*Label 27679*/ GIMT_Encode4(2088682), // Rule ID 16478 //
     /* 2088593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2088610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088639 */     // MIs[0] round
     /* 2088639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088642 */     // MIs[0] policy
     /* 2088642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088652 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2088655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088677 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088681 */     // GIR_Coverage, 16478,
     /* 2088681 */     GIR_EraseRootFromParent_Done,
     /* 2088682 */   // Label 27679: @2088682
     /* 2088682 */   GIM_Try, /*On fail goto*//*Label 27680*/ GIMT_Encode4(2088776), // Rule ID 16479 //
     /* 2088687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2088698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2088701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2088704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2088710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2088717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2088721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088733 */     // MIs[0] round
     /* 2088733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088736 */     // MIs[0] policy
     /* 2088736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088746 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2088749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088775 */     // GIR_Coverage, 16479,
     /* 2088775 */     GIR_EraseRootFromParent_Done,
     /* 2088776 */   // Label 27680: @2088776
     /* 2088776 */   GIM_Try, /*On fail goto*//*Label 27681*/ GIMT_Encode4(2088870), // Rule ID 16482 //
     /* 2088781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2088798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088827 */     // MIs[0] round
     /* 2088827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088830 */     // MIs[0] policy
     /* 2088830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088840 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2088840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2088843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088869 */     // GIR_Coverage, 16482,
     /* 2088869 */     GIR_EraseRootFromParent_Done,
     /* 2088870 */   // Label 27681: @2088870
     /* 2088870 */   GIM_Try, /*On fail goto*//*Label 27682*/ GIMT_Encode4(2088964), // Rule ID 16483 //
     /* 2088875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2088878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s8,
     /* 2088886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2088889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2088892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2088895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2088898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2088901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2088905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2088909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2088913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2088917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2088921 */     // MIs[0] round
     /* 2088921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2088924 */     // MIs[0] policy
     /* 2088924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2088927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2088934 */     // (intrinsic_wo_chain:{ *:[nxv32i8] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2088934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2088937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2088939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2088941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2088943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2088945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2088947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2088949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2088954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2088957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2088959 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2088962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2088963 */     // GIR_Coverage, 16483,
     /* 2088963 */     GIR_EraseRootFromParent_Done,
     /* 2088964 */   // Label 27682: @2088964
     /* 2088964 */   GIM_Try, /*On fail goto*//*Label 27683*/ GIMT_Encode4(2089058), // Rule ID 16486 //
     /* 2088969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2088972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2088977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2088980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2088983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2088986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2088989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2088992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2088995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2088999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089015 */     // MIs[0] round
     /* 2089015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089018 */     // MIs[0] policy
     /* 2089018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089028 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2089031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089057 */     // GIR_Coverage, 16486,
     /* 2089057 */     GIR_EraseRootFromParent_Done,
     /* 2089058 */   // Label 27683: @2089058
     /* 2089058 */   GIM_Try, /*On fail goto*//*Label 27684*/ GIMT_Encode4(2089152), // Rule ID 16487 //
     /* 2089063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2089074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2089077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2089080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089109 */     // MIs[0] round
     /* 2089109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089112 */     // MIs[0] policy
     /* 2089112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089122 */     // (intrinsic_wo_chain:{ *:[nxv1i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF4_MASK),
     /* 2089125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089147 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089151 */     // GIR_Coverage, 16487,
     /* 2089151 */     GIR_EraseRootFromParent_Done,
     /* 2089152 */   // Label 27684: @2089152
     /* 2089152 */   GIM_Try, /*On fail goto*//*Label 27685*/ GIMT_Encode4(2089246), // Rule ID 16490 //
     /* 2089157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2089168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2089171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2089174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089203 */     // MIs[0] round
     /* 2089203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089206 */     // MIs[0] policy
     /* 2089206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089216 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2089219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089241 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089245 */     // GIR_Coverage, 16490,
     /* 2089245 */     GIR_EraseRootFromParent_Done,
     /* 2089246 */   // Label 27685: @2089246
     /* 2089246 */   GIM_Try, /*On fail goto*//*Label 27686*/ GIMT_Encode4(2089340), // Rule ID 16491 //
     /* 2089251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2089262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2089265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2089268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2089274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089297 */     // MIs[0] round
     /* 2089297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089300 */     // MIs[0] policy
     /* 2089300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089310 */     // (intrinsic_wo_chain:{ *:[nxv2i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2089313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089315 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089339 */     // GIR_Coverage, 16491,
     /* 2089339 */     GIR_EraseRootFromParent_Done,
     /* 2089340 */   // Label 27686: @2089340
     /* 2089340 */   GIM_Try, /*On fail goto*//*Label 27687*/ GIMT_Encode4(2089434), // Rule ID 16494 //
     /* 2089345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2089356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2089359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089391 */     // MIs[0] round
     /* 2089391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089394 */     // MIs[0] policy
     /* 2089394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089404 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2089407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089409 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089429 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089433 */     // GIR_Coverage, 16494,
     /* 2089433 */     GIR_EraseRootFromParent_Done,
     /* 2089434 */   // Label 27687: @2089434
     /* 2089434 */   GIM_Try, /*On fail goto*//*Label 27688*/ GIMT_Encode4(2089528), // Rule ID 16495 //
     /* 2089439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2089450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2089453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2089456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2089462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089485 */     // MIs[0] round
     /* 2089485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089488 */     // MIs[0] policy
     /* 2089488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089498 */     // (intrinsic_wo_chain:{ *:[nxv4i16] } 11415:{ *:[iPTR] }, VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2089501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089503 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089523 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089527 */     // GIR_Coverage, 16495,
     /* 2089527 */     GIR_EraseRootFromParent_Done,
     /* 2089528 */   // Label 27688: @2089528
     /* 2089528 */   GIM_Try, /*On fail goto*//*Label 27689*/ GIMT_Encode4(2089622), // Rule ID 16498 //
     /* 2089533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089579 */     // MIs[0] round
     /* 2089579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089582 */     // MIs[0] policy
     /* 2089582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2089595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089597 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089617 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089621 */     // GIR_Coverage, 16498,
     /* 2089621 */     GIR_EraseRootFromParent_Done,
     /* 2089622 */   // Label 27689: @2089622
     /* 2089622 */   GIM_Try, /*On fail goto*//*Label 27690*/ GIMT_Encode4(2089716), // Rule ID 16499 //
     /* 2089627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2089638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2089641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2089644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2089650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2089657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2089661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089673 */     // MIs[0] round
     /* 2089673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089676 */     // MIs[0] policy
     /* 2089676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2089689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089691 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089715 */     // GIR_Coverage, 16499,
     /* 2089715 */     GIR_EraseRootFromParent_Done,
     /* 2089716 */   // Label 27690: @2089716
     /* 2089716 */   GIM_Try, /*On fail goto*//*Label 27691*/ GIMT_Encode4(2089810), // Rule ID 16502 //
     /* 2089721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2089724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089767 */     // MIs[0] round
     /* 2089767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089770 */     // MIs[0] policy
     /* 2089770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089780 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2089783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089785 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089805 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089809 */     // GIR_Coverage, 16502,
     /* 2089809 */     GIR_EraseRootFromParent_Done,
     /* 2089810 */   // Label 27691: @2089810
     /* 2089810 */   GIM_Try, /*On fail goto*//*Label 27692*/ GIMT_Encode4(2089904), // Rule ID 16503 //
     /* 2089815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2089818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2089826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2089829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2089832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2089835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2089838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2089841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2089845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2089849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2089853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089861 */     // MIs[0] round
     /* 2089861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089864 */     // MIs[0] policy
     /* 2089864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089874 */     // (intrinsic_wo_chain:{ *:[nxv16i16] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2089874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2089877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089879 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2089897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089899 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089903 */     // GIR_Coverage, 16503,
     /* 2089903 */     GIR_EraseRootFromParent_Done,
     /* 2089904 */   // Label 27692: @2089904
     /* 2089904 */   GIM_Try, /*On fail goto*//*Label 27693*/ GIMT_Encode4(2089998), // Rule ID 16506 //
     /* 2089909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2089912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2089917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2089920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2089923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2089926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2089929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2089932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2089935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2089939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2089947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2089951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2089955 */     // MIs[0] round
     /* 2089955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2089958 */     // MIs[0] policy
     /* 2089958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2089961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2089968 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2089968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2089971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2089973 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2089975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2089977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2089979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2089981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2089983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2089988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2089991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2089993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2089996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2089997 */     // GIR_Coverage, 16506,
     /* 2089997 */     GIR_EraseRootFromParent_Done,
     /* 2089998 */   // Label 27693: @2089998
     /* 2089998 */   GIM_Try, /*On fail goto*//*Label 27694*/ GIMT_Encode4(2090092), // Rule ID 16507 //
     /* 2090003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2090006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2090014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2090017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2090020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090049 */     // MIs[0] round
     /* 2090049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090052 */     // MIs[0] policy
     /* 2090052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090062 */     // (intrinsic_wo_chain:{ *:[nxv1i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_MF2_MASK),
     /* 2090065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090067 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090087 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090091 */     // GIR_Coverage, 16507,
     /* 2090091 */     GIR_EraseRootFromParent_Done,
     /* 2090092 */   // Label 27694: @2090092
     /* 2090092 */   GIM_Try, /*On fail goto*//*Label 27695*/ GIMT_Encode4(2090186), // Rule ID 16510 //
     /* 2090097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2090100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2090108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2090111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090143 */     // MIs[0] round
     /* 2090143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090146 */     // MIs[0] policy
     /* 2090146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090156 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2090159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090161 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090181 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090185 */     // GIR_Coverage, 16510,
     /* 2090185 */     GIR_EraseRootFromParent_Done,
     /* 2090186 */   // Label 27695: @2090186
     /* 2090186 */   GIM_Try, /*On fail goto*//*Label 27696*/ GIMT_Encode4(2090280), // Rule ID 16511 //
     /* 2090191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2090194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2090202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2090205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2090208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090237 */     // MIs[0] round
     /* 2090237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090240 */     // MIs[0] policy
     /* 2090240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090250 */     // (intrinsic_wo_chain:{ *:[nxv2i32] } 11415:{ *:[iPTR] }, VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M1_MASK),
     /* 2090253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090255 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090275 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090279 */     // GIR_Coverage, 16511,
     /* 2090279 */     GIR_EraseRootFromParent_Done,
     /* 2090280 */   // Label 27696: @2090280
     /* 2090280 */   GIM_Try, /*On fail goto*//*Label 27697*/ GIMT_Encode4(2090374), // Rule ID 16514 //
     /* 2090285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2090288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090331 */     // MIs[0] round
     /* 2090331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090334 */     // MIs[0] policy
     /* 2090334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090344 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2090347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090349 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090369 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090373 */     // GIR_Coverage, 16514,
     /* 2090373 */     GIR_EraseRootFromParent_Done,
     /* 2090374 */   // Label 27697: @2090374
     /* 2090374 */   GIM_Try, /*On fail goto*//*Label 27698*/ GIMT_Encode4(2090468), // Rule ID 16515 //
     /* 2090379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2090382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2090390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2090393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2090396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2090402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2090409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2090413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090425 */     // MIs[0] round
     /* 2090425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090428 */     // MIs[0] policy
     /* 2090428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 11415:{ *:[iPTR] }, VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M2_MASK),
     /* 2090441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090443 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090463 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090467 */     // GIR_Coverage, 16515,
     /* 2090467 */     GIR_EraseRootFromParent_Done,
     /* 2090468 */   // Label 27698: @2090468
     /* 2090468 */   GIM_Try, /*On fail goto*//*Label 27699*/ GIMT_Encode4(2090562), // Rule ID 16518 //
     /* 2090473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2090476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2090493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090519 */     // MIs[0] round
     /* 2090519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090522 */     // MIs[0] policy
     /* 2090522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090532 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2090535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090537 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090561 */     // GIR_Coverage, 16518,
     /* 2090561 */     GIR_EraseRootFromParent_Done,
     /* 2090562 */   // Label 27699: @2090562
     /* 2090562 */   GIM_Try, /*On fail goto*//*Label 27700*/ GIMT_Encode4(2090656), // Rule ID 16519 //
     /* 2090567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2090570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vnclip_mask),
     /* 2090575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2090578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2090581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2090584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2090587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2090590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2090597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2090601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2090605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2090609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090613 */     // MIs[0] round
     /* 2090613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090616 */     // MIs[0] policy
     /* 2090616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090626 */     // (intrinsic_wo_chain:{ *:[nxv8i32] } 11415:{ *:[iPTR] }, VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVNCLIP_WX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVNCLIP_WX_M4_MASK),
     /* 2090629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090631 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2090649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2090654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090655 */     // GIR_Coverage, 16519,
     /* 2090655 */     GIR_EraseRootFromParent_Done,
     /* 2090656 */   // Label 27700: @2090656
     /* 2090656 */   GIM_Try, /*On fail goto*//*Label 27701*/ GIMT_Encode4(2090747), // Rule ID 16582 //
     /* 2090661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2090664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2090669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2090672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2090675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090707 */     // MIs[0] round
     /* 2090707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090710 */     // MIs[0] policy
     /* 2090710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090720 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2090723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090725 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090746 */     // GIR_Coverage, 16582,
     /* 2090746 */     GIR_EraseRootFromParent_Done,
     /* 2090747 */   // Label 27701: @2090747
     /* 2090747 */   GIM_Try, /*On fail goto*//*Label 27702*/ GIMT_Encode4(2090838), // Rule ID 16583 //
     /* 2090752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2090755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2090760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2090763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2090766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2090769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2090772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2090775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090798 */     // MIs[0] round
     /* 2090798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090801 */     // MIs[0] policy
     /* 2090801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090811 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16_MASK),
     /* 2090814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090816 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090837 */     // GIR_Coverage, 16583,
     /* 2090837 */     GIR_EraseRootFromParent_Done,
     /* 2090838 */   // Label 27702: @2090838
     /* 2090838 */   GIM_Try, /*On fail goto*//*Label 27703*/ GIMT_Encode4(2090929), // Rule ID 16586 //
     /* 2090843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2090846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2090851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2090854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2090857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2090869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090889 */     // MIs[0] round
     /* 2090889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090892 */     // MIs[0] policy
     /* 2090892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090902 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2090902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2090905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090907 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2090909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2090911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2090913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2090915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2090917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2090922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2090925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2090927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2090928 */     // GIR_Coverage, 16586,
     /* 2090928 */     GIR_EraseRootFromParent_Done,
     /* 2090929 */   // Label 27703: @2090929
     /* 2090929 */   GIM_Try, /*On fail goto*//*Label 27704*/ GIMT_Encode4(2091020), // Rule ID 16587 //
     /* 2090934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2090937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2090942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2090945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2090948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2090951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2090954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2090957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2090960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2090964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2090976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2090980 */     // MIs[0] round
     /* 2090980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2090983 */     // MIs[0] policy
     /* 2090983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2090986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2090993 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2090993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16_MASK),
     /* 2090996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2090998 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091019 */     // GIR_Coverage, 16587,
     /* 2091019 */     GIR_EraseRootFromParent_Done,
     /* 2091020 */   // Label 27704: @2091020
     /* 2091020 */   GIM_Try, /*On fail goto*//*Label 27705*/ GIMT_Encode4(2091111), // Rule ID 16590 //
     /* 2091025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2091028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091071 */     // MIs[0] round
     /* 2091071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091074 */     // MIs[0] policy
     /* 2091074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091084 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2091087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091089 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091110 */     // GIR_Coverage, 16590,
     /* 2091110 */     GIR_EraseRootFromParent_Done,
     /* 2091111 */   // Label 27705: @2091111
     /* 2091111 */   GIM_Try, /*On fail goto*//*Label 27706*/ GIMT_Encode4(2091202), // Rule ID 16591 //
     /* 2091116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2091119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2091127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2091130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2091133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2091136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091162 */     // MIs[0] round
     /* 2091162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091165 */     // MIs[0] policy
     /* 2091165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091175 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32_MASK),
     /* 2091178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091180 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091201 */     // GIR_Coverage, 16591,
     /* 2091201 */     GIR_EraseRootFromParent_Done,
     /* 2091202 */   // Label 27706: @2091202
     /* 2091202 */   GIM_Try, /*On fail goto*//*Label 27707*/ GIMT_Encode4(2091293), // Rule ID 16594 //
     /* 2091207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2091210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2091218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2091221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2091227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091253 */     // MIs[0] round
     /* 2091253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091256 */     // MIs[0] policy
     /* 2091256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091266 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2091269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091271 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091292 */     // GIR_Coverage, 16594,
     /* 2091292 */     GIR_EraseRootFromParent_Done,
     /* 2091293 */   // Label 27707: @2091293
     /* 2091293 */   GIM_Try, /*On fail goto*//*Label 27708*/ GIMT_Encode4(2091384), // Rule ID 16595 //
     /* 2091298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2091301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2091309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2091312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2091315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2091318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2091321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091344 */     // MIs[0] round
     /* 2091344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091347 */     // MIs[0] policy
     /* 2091347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091357 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16_MASK),
     /* 2091360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091362 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091383 */     // GIR_Coverage, 16595,
     /* 2091383 */     GIR_EraseRootFromParent_Done,
     /* 2091384 */   // Label 27708: @2091384
     /* 2091384 */   GIM_Try, /*On fail goto*//*Label 27709*/ GIMT_Encode4(2091475), // Rule ID 16598 //
     /* 2091389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2091392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2091400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2091403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091435 */     // MIs[0] round
     /* 2091435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091438 */     // MIs[0] policy
     /* 2091438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091448 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2091451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091453 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091474 */     // GIR_Coverage, 16598,
     /* 2091474 */     GIR_EraseRootFromParent_Done,
     /* 2091475 */   // Label 27709: @2091475
     /* 2091475 */   GIM_Try, /*On fail goto*//*Label 27710*/ GIMT_Encode4(2091566), // Rule ID 16599 //
     /* 2091480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2091483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2091491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2091494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2091497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2091500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2091503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091526 */     // MIs[0] round
     /* 2091526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091529 */     // MIs[0] policy
     /* 2091529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091539 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32_MASK),
     /* 2091542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091544 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2091562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091565 */     // GIR_Coverage, 16599,
     /* 2091565 */     GIR_EraseRootFromParent_Done,
     /* 2091566 */   // Label 27710: @2091566
     /* 2091566 */   GIM_Try, /*On fail goto*//*Label 27711*/ GIMT_Encode4(2091657), // Rule ID 16602 //
     /* 2091571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2091574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2091582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2091585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2091588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2091591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091617 */     // MIs[0] round
     /* 2091617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091620 */     // MIs[0] policy
     /* 2091620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091630 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2091633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091635 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2091653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091656 */     // GIR_Coverage, 16602,
     /* 2091656 */     GIR_EraseRootFromParent_Done,
     /* 2091657 */   // Label 27711: @2091657
     /* 2091657 */   GIM_Try, /*On fail goto*//*Label 27712*/ GIMT_Encode4(2091748), // Rule ID 16603 //
     /* 2091662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2091665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2091673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2091676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2091679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2091682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2091685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2091692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2091704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091708 */     // MIs[0] round
     /* 2091708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091711 */     // MIs[0] policy
     /* 2091711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091721 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64_MASK),
     /* 2091724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091726 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2091744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091747 */     // GIR_Coverage, 16603,
     /* 2091747 */     GIR_EraseRootFromParent_Done,
     /* 2091748 */   // Label 27712: @2091748
     /* 2091748 */   GIM_Try, /*On fail goto*//*Label 27713*/ GIMT_Encode4(2091839), // Rule ID 16606 //
     /* 2091753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2091756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2091764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2091767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2091773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091799 */     // MIs[0] round
     /* 2091799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091802 */     // MIs[0] policy
     /* 2091802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091812 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2091815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091817 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091838 */     // GIR_Coverage, 16606,
     /* 2091838 */     GIR_EraseRootFromParent_Done,
     /* 2091839 */   // Label 27713: @2091839
     /* 2091839 */   GIM_Try, /*On fail goto*//*Label 27714*/ GIMT_Encode4(2091930), // Rule ID 16607 //
     /* 2091844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2091847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2091855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2091858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2091861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2091864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2091867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2091870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2091874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2091886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091890 */     // MIs[0] round
     /* 2091890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091893 */     // MIs[0] policy
     /* 2091893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2091903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16_MASK),
     /* 2091906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091908 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2091910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2091912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2091914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2091916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2091918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2091923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2091926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2091928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2091929 */     // GIR_Coverage, 16607,
     /* 2091929 */     GIR_EraseRootFromParent_Done,
     /* 2091930 */   // Label 27714: @2091930
     /* 2091930 */   GIM_Try, /*On fail goto*//*Label 27715*/ GIMT_Encode4(2092021), // Rule ID 16610 //
     /* 2091935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2091938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2091943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2091946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2091949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2091952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2091955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2091958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2091961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2091965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2091977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2091981 */     // MIs[0] round
     /* 2091981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2091984 */     // MIs[0] policy
     /* 2091984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2091987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2091994 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2091994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2091997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2091999 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092020 */     // GIR_Coverage, 16610,
     /* 2092020 */     GIR_EraseRootFromParent_Done,
     /* 2092021 */   // Label 27715: @2092021
     /* 2092021 */   GIM_Try, /*On fail goto*//*Label 27716*/ GIMT_Encode4(2092112), // Rule ID 16611 //
     /* 2092026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2092029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2092037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2092040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2092043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2092046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092072 */     // MIs[0] round
     /* 2092072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092075 */     // MIs[0] policy
     /* 2092075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092085 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16_MASK),
     /* 2092088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092090 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092111 */     // GIR_Coverage, 16611,
     /* 2092111 */     GIR_EraseRootFromParent_Done,
     /* 2092112 */   // Label 27716: @2092112
     /* 2092112 */   GIM_Try, /*On fail goto*//*Label 27717*/ GIMT_Encode4(2092203), // Rule ID 16614 //
     /* 2092117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2092120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2092128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2092131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2092137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092163 */     // MIs[0] round
     /* 2092163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092166 */     // MIs[0] policy
     /* 2092166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092176 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2092179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092181 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092202 */     // GIR_Coverage, 16614,
     /* 2092202 */     GIR_EraseRootFromParent_Done,
     /* 2092203 */   // Label 27717: @2092203
     /* 2092203 */   GIM_Try, /*On fail goto*//*Label 27718*/ GIMT_Encode4(2092294), // Rule ID 16615 //
     /* 2092208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2092211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2092219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2092222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2092225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2092228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2092231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092254 */     // MIs[0] round
     /* 2092254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092257 */     // MIs[0] policy
     /* 2092257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092267 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16_MASK),
     /* 2092270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092272 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2092290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092293 */     // GIR_Coverage, 16615,
     /* 2092293 */     GIR_EraseRootFromParent_Done,
     /* 2092294 */   // Label 27718: @2092294
     /* 2092294 */   GIM_Try, /*On fail goto*//*Label 27719*/ GIMT_Encode4(2092385), // Rule ID 16618 //
     /* 2092299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2092302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2092310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2092313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2092319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092345 */     // MIs[0] round
     /* 2092345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092348 */     // MIs[0] policy
     /* 2092348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092358 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2092361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092363 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092384 */     // GIR_Coverage, 16618,
     /* 2092384 */     GIR_EraseRootFromParent_Done,
     /* 2092385 */   // Label 27719: @2092385
     /* 2092385 */   GIM_Try, /*On fail goto*//*Label 27720*/ GIMT_Encode4(2092476), // Rule ID 16619 //
     /* 2092390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2092393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2092401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2092404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2092407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2092410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2092413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092436 */     // MIs[0] round
     /* 2092436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092439 */     // MIs[0] policy
     /* 2092439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092449 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32_MASK),
     /* 2092452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092454 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092475 */     // GIR_Coverage, 16619,
     /* 2092475 */     GIR_EraseRootFromParent_Done,
     /* 2092476 */   // Label 27720: @2092476
     /* 2092476 */   GIM_Try, /*On fail goto*//*Label 27721*/ GIMT_Encode4(2092567), // Rule ID 16622 //
     /* 2092481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2092484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2092501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092527 */     // MIs[0] round
     /* 2092527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092530 */     // MIs[0] policy
     /* 2092530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092540 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2092543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092545 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092566 */     // GIR_Coverage, 16622,
     /* 2092566 */     GIR_EraseRootFromParent_Done,
     /* 2092567 */   // Label 27721: @2092567
     /* 2092567 */   GIM_Try, /*On fail goto*//*Label 27722*/ GIMT_Encode4(2092658), // Rule ID 16623 //
     /* 2092572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2092575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2092583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2092586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2092589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2092592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2092595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2092602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2092614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092618 */     // MIs[0] round
     /* 2092618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092621 */     // MIs[0] policy
     /* 2092621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092631 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32_MASK),
     /* 2092634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092636 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092657 */     // GIR_Coverage, 16623,
     /* 2092657 */     GIR_EraseRootFromParent_Done,
     /* 2092658 */   // Label 27722: @2092658
     /* 2092658 */   GIM_Try, /*On fail goto*//*Label 27723*/ GIMT_Encode4(2092749), // Rule ID 16626 //
     /* 2092663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2092666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2092674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2092677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2092683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092709 */     // MIs[0] round
     /* 2092709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092712 */     // MIs[0] policy
     /* 2092712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092722 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2092725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092727 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092748 */     // GIR_Coverage, 16626,
     /* 2092748 */     GIR_EraseRootFromParent_Done,
     /* 2092749 */   // Label 27723: @2092749
     /* 2092749 */   GIM_Try, /*On fail goto*//*Label 27724*/ GIMT_Encode4(2092840), // Rule ID 16627 //
     /* 2092754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2092757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2092765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2092768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2092771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2092774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2092777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2092784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2092796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092800 */     // MIs[0] round
     /* 2092800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092803 */     // MIs[0] policy
     /* 2092803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092813 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32_MASK),
     /* 2092816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092818 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2092836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092839 */     // GIR_Coverage, 16627,
     /* 2092839 */     GIR_EraseRootFromParent_Done,
     /* 2092840 */   // Label 27724: @2092840
     /* 2092840 */   GIM_Try, /*On fail goto*//*Label 27725*/ GIMT_Encode4(2092931), // Rule ID 16630 //
     /* 2092845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2092848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2092856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2092859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2092865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2092871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092891 */     // MIs[0] round
     /* 2092891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092894 */     // MIs[0] policy
     /* 2092894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092904 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2092904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2092907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2092909 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2092911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2092913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2092915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2092917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2092919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2092924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2092927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2092929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2092930 */     // GIR_Coverage, 16630,
     /* 2092930 */     GIR_EraseRootFromParent_Done,
     /* 2092931 */   // Label 27725: @2092931
     /* 2092931 */   GIM_Try, /*On fail goto*//*Label 27726*/ GIMT_Encode4(2093022), // Rule ID 16631 //
     /* 2092936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2092939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2092944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2092947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2092950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2092953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2092956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2092959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2092962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2092966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2092978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2092982 */     // MIs[0] round
     /* 2092982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2092985 */     // MIs[0] policy
     /* 2092985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2092988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2092995 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2092995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64_MASK),
     /* 2092998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093000 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093021 */     // GIR_Coverage, 16631,
     /* 2093021 */     GIR_EraseRootFromParent_Done,
     /* 2093022 */   // Label 27726: @2093022
     /* 2093022 */   GIM_Try, /*On fail goto*//*Label 27727*/ GIMT_Encode4(2093113), // Rule ID 16634 //
     /* 2093027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2093030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2093038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2093041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2093047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093073 */     // MIs[0] round
     /* 2093073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093076 */     // MIs[0] policy
     /* 2093076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093086 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2093089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093091 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093112 */     // GIR_Coverage, 16634,
     /* 2093112 */     GIR_EraseRootFromParent_Done,
     /* 2093113 */   // Label 27727: @2093113
     /* 2093113 */   GIM_Try, /*On fail goto*//*Label 27728*/ GIMT_Encode4(2093204), // Rule ID 16635 //
     /* 2093118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2093121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2093129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2093132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2093135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2093138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2093148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2093160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093164 */     // MIs[0] round
     /* 2093164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093167 */     // MIs[0] policy
     /* 2093167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093177 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64_MASK),
     /* 2093180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093182 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093203 */     // GIR_Coverage, 16635,
     /* 2093203 */     GIR_EraseRootFromParent_Done,
     /* 2093204 */   // Label 27728: @2093204
     /* 2093204 */   GIM_Try, /*On fail goto*//*Label 27729*/ GIMT_Encode4(2093295), // Rule ID 16638 //
     /* 2093209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2093212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2093220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2093223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2093229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093255 */     // MIs[0] round
     /* 2093255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093258 */     // MIs[0] policy
     /* 2093258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093268 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2093271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093273 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093294 */     // GIR_Coverage, 16638,
     /* 2093294 */     GIR_EraseRootFromParent_Done,
     /* 2093295 */   // Label 27729: @2093295
     /* 2093295 */   GIM_Try, /*On fail goto*//*Label 27730*/ GIMT_Encode4(2093386), // Rule ID 16639 //
     /* 2093300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2093303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2093311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2093314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2093317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2093320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2093323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2093330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2093342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093346 */     // MIs[0] round
     /* 2093346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093349 */     // MIs[0] policy
     /* 2093349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093359 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64_MASK),
     /* 2093362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093364 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2093382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093385 */     // GIR_Coverage, 16639,
     /* 2093385 */     GIR_EraseRootFromParent_Done,
     /* 2093386 */   // Label 27730: @2093386
     /* 2093386 */   GIM_Try, /*On fail goto*//*Label 27731*/ GIMT_Encode4(2093477), // Rule ID 16642 //
     /* 2093391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2093394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2093402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2093405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2093411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2093433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093437 */     // MIs[0] round
     /* 2093437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093440 */     // MIs[0] policy
     /* 2093440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093450 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2093453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093455 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093476 */     // GIR_Coverage, 16642,
     /* 2093476 */     GIR_EraseRootFromParent_Done,
     /* 2093477 */   // Label 27731: @2093477
     /* 2093477 */   GIM_Try, /*On fail goto*//*Label 27732*/ GIMT_Encode4(2093568), // Rule ID 16643 //
     /* 2093482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2093485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2093493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2093496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2093499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2093502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2093524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093528 */     // MIs[0] round
     /* 2093528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093531 */     // MIs[0] policy
     /* 2093531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093541 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF4_E16_MASK),
     /* 2093544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093546 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093567 */     // GIR_Coverage, 16643,
     /* 2093567 */     GIR_EraseRootFromParent_Done,
     /* 2093568 */   // Label 27732: @2093568
     /* 2093568 */   GIM_Try, /*On fail goto*//*Label 27733*/ GIMT_Encode4(2093659), // Rule ID 16646 //
     /* 2093573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2093576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2093584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2093587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2093593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2093615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093619 */     // MIs[0] round
     /* 2093619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093622 */     // MIs[0] policy
     /* 2093622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093632 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2093635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093637 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093658 */     // GIR_Coverage, 16646,
     /* 2093658 */     GIR_EraseRootFromParent_Done,
     /* 2093659 */   // Label 27733: @2093659
     /* 2093659 */   GIM_Try, /*On fail goto*//*Label 27734*/ GIMT_Encode4(2093750), // Rule ID 16647 //
     /* 2093664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2093667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2093675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2093678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2093681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2093684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2093687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2093706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093710 */     // MIs[0] round
     /* 2093710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093713 */     // MIs[0] policy
     /* 2093713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093723 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_MF2_E16_MASK),
     /* 2093726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093728 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2093746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093749 */     // GIR_Coverage, 16647,
     /* 2093749 */     GIR_EraseRootFromParent_Done,
     /* 2093750 */   // Label 27734: @2093750
     /* 2093750 */   GIM_Try, /*On fail goto*//*Label 27735*/ GIMT_Encode4(2093841), // Rule ID 16650 //
     /* 2093755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2093758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2093772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093801 */     // MIs[0] round
     /* 2093801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093804 */     // MIs[0] policy
     /* 2093804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093814 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2093817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093819 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093840 */     // GIR_Coverage, 16650,
     /* 2093840 */     GIR_EraseRootFromParent_Done,
     /* 2093841 */   // Label 27735: @2093841
     /* 2093841 */   GIM_Try, /*On fail goto*//*Label 27736*/ GIMT_Encode4(2093932), // Rule ID 16651 //
     /* 2093846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2093849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2093857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2093860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2093863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2093866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2093869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2093872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2093888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093892 */     // MIs[0] round
     /* 2093892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093895 */     // MIs[0] policy
     /* 2093895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093905 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2093905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_MF2_E32_MASK),
     /* 2093908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2093910 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2093912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2093914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2093916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2093918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2093920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2093925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2093928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2093930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2093931 */     // GIR_Coverage, 16651,
     /* 2093931 */     GIR_EraseRootFromParent_Done,
     /* 2093932 */   // Label 27736: @2093932
     /* 2093932 */   GIM_Try, /*On fail goto*//*Label 27737*/ GIMT_Encode4(2094023), // Rule ID 16654 //
     /* 2093937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2093940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2093945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2093948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2093951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2093954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2093957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2093960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2093963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2093967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2093975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2093979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2093983 */     // MIs[0] round
     /* 2093983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2093986 */     // MIs[0] policy
     /* 2093986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2093989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2093996 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2093996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2093999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094001 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094022 */     // GIR_Coverage, 16654,
     /* 2094022 */     GIR_EraseRootFromParent_Done,
     /* 2094023 */   // Label 27737: @2094023
     /* 2094023 */   GIM_Try, /*On fail goto*//*Label 27738*/ GIMT_Encode4(2094114), // Rule ID 16655 //
     /* 2094028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2094031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2094039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2094042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2094045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2094051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094074 */     // MIs[0] round
     /* 2094074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094077 */     // MIs[0] policy
     /* 2094077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094087 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11117:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M1_E16_MASK),
     /* 2094090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094092 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094113 */     // GIR_Coverage, 16655,
     /* 2094113 */     GIR_EraseRootFromParent_Done,
     /* 2094114 */   // Label 27738: @2094114
     /* 2094114 */   GIM_Try, /*On fail goto*//*Label 27739*/ GIMT_Encode4(2094205), // Rule ID 16658 //
     /* 2094119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2094122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2094130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2094133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2094161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094165 */     // MIs[0] round
     /* 2094165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094168 */     // MIs[0] policy
     /* 2094168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094178 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2094181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094183 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094204 */     // GIR_Coverage, 16658,
     /* 2094204 */     GIR_EraseRootFromParent_Done,
     /* 2094205 */   // Label 27739: @2094205
     /* 2094205 */   GIM_Try, /*On fail goto*//*Label 27740*/ GIMT_Encode4(2094296), // Rule ID 16659 //
     /* 2094210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2094213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2094221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2094224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2094227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2094230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2094233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2094252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094256 */     // MIs[0] round
     /* 2094256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094259 */     // MIs[0] policy
     /* 2094259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094269 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11117:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M1_E32_MASK),
     /* 2094272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094274 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2094292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094295 */     // GIR_Coverage, 16659,
     /* 2094295 */     GIR_EraseRootFromParent_Done,
     /* 2094296 */   // Label 27740: @2094296
     /* 2094296 */   GIM_Try, /*On fail goto*//*Label 27741*/ GIMT_Encode4(2094387), // Rule ID 16662 //
     /* 2094301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2094304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2094312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2094315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2094318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2094343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094347 */     // MIs[0] round
     /* 2094347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094350 */     // MIs[0] policy
     /* 2094350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094360 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2094363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094365 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094386 */     // GIR_Coverage, 16662,
     /* 2094386 */     GIR_EraseRootFromParent_Done,
     /* 2094387 */   // Label 27741: @2094387
     /* 2094387 */   GIM_Try, /*On fail goto*//*Label 27742*/ GIMT_Encode4(2094478), // Rule ID 16663 //
     /* 2094392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2094395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2094403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2094406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2094409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2094412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2094415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2094422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2094430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2094434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094438 */     // MIs[0] round
     /* 2094438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094441 */     // MIs[0] policy
     /* 2094441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094451 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11117:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M1_E64_MASK),
     /* 2094454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094456 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2094474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094477 */     // GIR_Coverage, 16663,
     /* 2094477 */     GIR_EraseRootFromParent_Done,
     /* 2094478 */   // Label 27742: @2094478
     /* 2094478 */   GIM_Try, /*On fail goto*//*Label 27743*/ GIMT_Encode4(2094569), // Rule ID 16666 //
     /* 2094483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2094486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2094494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2094497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094529 */     // MIs[0] round
     /* 2094529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094532 */     // MIs[0] policy
     /* 2094532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094542 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2094545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094547 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094568 */     // GIR_Coverage, 16666,
     /* 2094568 */     GIR_EraseRootFromParent_Done,
     /* 2094569 */   // Label 27743: @2094569
     /* 2094569 */   GIM_Try, /*On fail goto*//*Label 27744*/ GIMT_Encode4(2094660), // Rule ID 16667 //
     /* 2094574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2094577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2094585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2094588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2094591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2094597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2094604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2094612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094620 */     // MIs[0] round
     /* 2094620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094623 */     // MIs[0] policy
     /* 2094623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094633 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M2_E16_MASK),
     /* 2094636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094638 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094659 */     // GIR_Coverage, 16667,
     /* 2094659 */     GIR_EraseRootFromParent_Done,
     /* 2094660 */   // Label 27744: @2094660
     /* 2094660 */   GIM_Try, /*On fail goto*//*Label 27745*/ GIMT_Encode4(2094751), // Rule ID 16670 //
     /* 2094665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2094668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2094676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2094679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094711 */     // MIs[0] round
     /* 2094711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094714 */     // MIs[0] policy
     /* 2094714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094724 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2094727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094729 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094750 */     // GIR_Coverage, 16670,
     /* 2094750 */     GIR_EraseRootFromParent_Done,
     /* 2094751 */   // Label 27745: @2094751
     /* 2094751 */   GIM_Try, /*On fail goto*//*Label 27746*/ GIMT_Encode4(2094842), // Rule ID 16671 //
     /* 2094756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2094759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2094767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2094770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2094773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2094779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2094786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2094794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094802 */     // MIs[0] round
     /* 2094802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094805 */     // MIs[0] policy
     /* 2094805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094815 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M4_E16_MASK),
     /* 2094818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094820 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094841 */     // GIR_Coverage, 16671,
     /* 2094841 */     GIR_EraseRootFromParent_Done,
     /* 2094842 */   // Label 27746: @2094842
     /* 2094842 */   GIM_Try, /*On fail goto*//*Label 27747*/ GIMT_Encode4(2094933), // Rule ID 16674 //
     /* 2094847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2094850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2094858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2094861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2094873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094893 */     // MIs[0] round
     /* 2094893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094896 */     // MIs[0] policy
     /* 2094896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094906 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2094906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2094909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2094911 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2094913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2094915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2094917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2094919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2094921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2094926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2094929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2094931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2094932 */     // GIR_Coverage, 16674,
     /* 2094932 */     GIR_EraseRootFromParent_Done,
     /* 2094933 */   // Label 27747: @2094933
     /* 2094933 */   GIM_Try, /*On fail goto*//*Label 27748*/ GIMT_Encode4(2095024), // Rule ID 16675 //
     /* 2094938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2094941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2094946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2094949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2094952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2094955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2094958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2094961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2094964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2094968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2094976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2094980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2094984 */     // MIs[0] round
     /* 2094984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2094987 */     // MIs[0] policy
     /* 2094987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2094990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2094997 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2094997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR16_M8_E16_MASK),
     /* 2095000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095002 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2095020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095023 */     // GIR_Coverage, 16675,
     /* 2095023 */     GIR_EraseRootFromParent_Done,
     /* 2095024 */   // Label 27748: @2095024
     /* 2095024 */   GIM_Try, /*On fail goto*//*Label 27749*/ GIMT_Encode4(2095115), // Rule ID 16678 //
     /* 2095029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2095032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095075 */     // MIs[0] round
     /* 2095075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095078 */     // MIs[0] policy
     /* 2095078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2095091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095093 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095114 */     // GIR_Coverage, 16678,
     /* 2095114 */     GIR_EraseRootFromParent_Done,
     /* 2095115 */   // Label 27749: @2095115
     /* 2095115 */   GIM_Try, /*On fail goto*//*Label 27750*/ GIMT_Encode4(2095206), // Rule ID 16679 //
     /* 2095120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2095123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2095131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2095134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2095137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095166 */     // MIs[0] round
     /* 2095166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095169 */     // MIs[0] policy
     /* 2095169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095179 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M2_E32_MASK),
     /* 2095182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095184 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095205 */     // GIR_Coverage, 16679,
     /* 2095205 */     GIR_EraseRootFromParent_Done,
     /* 2095206 */   // Label 27750: @2095206
     /* 2095206 */   GIM_Try, /*On fail goto*//*Label 27751*/ GIMT_Encode4(2095297), // Rule ID 16682 //
     /* 2095211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2095214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2095222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2095225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095257 */     // MIs[0] round
     /* 2095257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095260 */     // MIs[0] policy
     /* 2095260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095270 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2095273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095275 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095296 */     // GIR_Coverage, 16682,
     /* 2095296 */     GIR_EraseRootFromParent_Done,
     /* 2095297 */   // Label 27751: @2095297
     /* 2095297 */   GIM_Try, /*On fail goto*//*Label 27752*/ GIMT_Encode4(2095388), // Rule ID 16683 //
     /* 2095302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2095305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2095313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2095316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2095319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095348 */     // MIs[0] round
     /* 2095348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095351 */     // MIs[0] policy
     /* 2095351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095361 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M4_E32_MASK),
     /* 2095364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095366 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095387 */     // GIR_Coverage, 16683,
     /* 2095387 */     GIR_EraseRootFromParent_Done,
     /* 2095388 */   // Label 27752: @2095388
     /* 2095388 */   GIM_Try, /*On fail goto*//*Label 27753*/ GIMT_Encode4(2095479), // Rule ID 16686 //
     /* 2095393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2095396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2095404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2095407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095439 */     // MIs[0] round
     /* 2095439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095442 */     // MIs[0] policy
     /* 2095442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095452 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2095455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095457 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095478 */     // GIR_Coverage, 16686,
     /* 2095478 */     GIR_EraseRootFromParent_Done,
     /* 2095479 */   // Label 27753: @2095479
     /* 2095479 */   GIM_Try, /*On fail goto*//*Label 27754*/ GIMT_Encode4(2095570), // Rule ID 16687 //
     /* 2095484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2095487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2095495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2095498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2095501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2095504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2095507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2095526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095530 */     // MIs[0] round
     /* 2095530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095533 */     // MIs[0] policy
     /* 2095533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095543 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR32_M8_E32_MASK),
     /* 2095546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095548 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2095566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095569 */     // GIR_Coverage, 16687,
     /* 2095569 */     GIR_EraseRootFromParent_Done,
     /* 2095570 */   // Label 27754: @2095570
     /* 2095570 */   GIM_Try, /*On fail goto*//*Label 27755*/ GIMT_Encode4(2095661), // Rule ID 16690 //
     /* 2095575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2095578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2095586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2095589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2095617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095621 */     // MIs[0] round
     /* 2095621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095624 */     // MIs[0] policy
     /* 2095624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2095637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095639 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2095657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095660 */     // GIR_Coverage, 16690,
     /* 2095660 */     GIR_EraseRootFromParent_Done,
     /* 2095661 */   // Label 27755: @2095661
     /* 2095661 */   GIM_Try, /*On fail goto*//*Label 27756*/ GIMT_Encode4(2095752), // Rule ID 16691 //
     /* 2095666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2095669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2095677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2095680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2095683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2095689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2095696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2095704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2095708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095712 */     // MIs[0] round
     /* 2095712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095715 */     // MIs[0] policy
     /* 2095715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095725 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11117:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M2_E64_MASK),
     /* 2095728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095730 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2095748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095751 */     // GIR_Coverage, 16691,
     /* 2095751 */     GIR_EraseRootFromParent_Done,
     /* 2095752 */   // Label 27756: @2095752
     /* 2095752 */   GIM_Try, /*On fail goto*//*Label 27757*/ GIMT_Encode4(2095843), // Rule ID 16694 //
     /* 2095757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2095760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2095768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2095771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2095799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095803 */     // MIs[0] round
     /* 2095803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095806 */     // MIs[0] policy
     /* 2095806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095816 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2095819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095821 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2095839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095842 */     // GIR_Coverage, 16694,
     /* 2095842 */     GIR_EraseRootFromParent_Done,
     /* 2095843 */   // Label 27757: @2095843
     /* 2095843 */   GIM_Try, /*On fail goto*//*Label 27758*/ GIMT_Encode4(2095934), // Rule ID 16695 //
     /* 2095848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2095851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2095859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2095862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2095865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2095871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2095874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2095878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2095886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2095890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095894 */     // MIs[0] round
     /* 2095894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095897 */     // MIs[0] policy
     /* 2095897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095907 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11117:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2095907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M4_E64_MASK),
     /* 2095910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2095912 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2095914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2095916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2095918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2095920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2095922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2095927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2095930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2095932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2095933 */     // GIR_Coverage, 16695,
     /* 2095933 */     GIR_EraseRootFromParent_Done,
     /* 2095934 */   // Label 27758: @2095934
     /* 2095934 */   GIM_Try, /*On fail goto*//*Label 27759*/ GIMT_Encode4(2096025), // Rule ID 16698 //
     /* 2095939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2095942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2095947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2095950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2095953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2095956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2095959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2095962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2095965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2095969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2095977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2095981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2095985 */     // MIs[0] round
     /* 2095985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2095988 */     // MIs[0] policy
     /* 2095988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2095991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2095998 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2095998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2096001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096003 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2096021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096024 */     // GIR_Coverage, 16698,
     /* 2096024 */     GIR_EraseRootFromParent_Done,
     /* 2096025 */   // Label 27759: @2096025
     /* 2096025 */   GIM_Try, /*On fail goto*//*Label 27760*/ GIMT_Encode4(2096116), // Rule ID 16699 //
     /* 2096030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2096033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfadd_mask),
     /* 2096038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2096041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2096044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2096047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2096050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2096053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2096060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2096068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2096072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096076 */     // MIs[0] round
     /* 2096076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096079 */     // MIs[0] policy
     /* 2096079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096089 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11117:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VFPR64_M8_E64_MASK),
     /* 2096092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096094 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2096112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096115 */     // GIR_Coverage, 16699,
     /* 2096115 */     GIR_EraseRootFromParent_Done,
     /* 2096116 */   // Label 27760: @2096116
     /* 2096116 */   GIM_Try, /*On fail goto*//*Label 27761*/ GIMT_Encode4(2096207), // Rule ID 16702 //
     /* 2096121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2096132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2096135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2096141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096167 */     // MIs[0] round
     /* 2096167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096170 */     // MIs[0] policy
     /* 2096170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096180 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2096183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096185 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096206 */     // GIR_Coverage, 16702,
     /* 2096206 */     GIR_EraseRootFromParent_Done,
     /* 2096207 */   // Label 27761: @2096207
     /* 2096207 */   GIM_Try, /*On fail goto*//*Label 27762*/ GIMT_Encode4(2096298), // Rule ID 16703 //
     /* 2096212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2096223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2096226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2096229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2096232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096258 */     // MIs[0] round
     /* 2096258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096261 */     // MIs[0] policy
     /* 2096261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096271 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16_MASK),
     /* 2096274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096276 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096297 */     // GIR_Coverage, 16703,
     /* 2096297 */     GIR_EraseRootFromParent_Done,
     /* 2096298 */   // Label 27762: @2096298
     /* 2096298 */   GIM_Try, /*On fail goto*//*Label 27763*/ GIMT_Encode4(2096389), // Rule ID 16706 //
     /* 2096303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2096314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2096317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2096323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096349 */     // MIs[0] round
     /* 2096349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096352 */     // MIs[0] policy
     /* 2096352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096362 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2096365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096367 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096388 */     // GIR_Coverage, 16706,
     /* 2096388 */     GIR_EraseRootFromParent_Done,
     /* 2096389 */   // Label 27763: @2096389
     /* 2096389 */   GIM_Try, /*On fail goto*//*Label 27764*/ GIMT_Encode4(2096480), // Rule ID 16707 //
     /* 2096394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2096405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2096408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2096411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2096414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096440 */     // MIs[0] round
     /* 2096440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096443 */     // MIs[0] policy
     /* 2096443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096453 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16_MASK),
     /* 2096456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096458 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096479 */     // GIR_Coverage, 16707,
     /* 2096479 */     GIR_EraseRootFromParent_Done,
     /* 2096480 */   // Label 27764: @2096480
     /* 2096480 */   GIM_Try, /*On fail goto*//*Label 27765*/ GIMT_Encode4(2096571), // Rule ID 16710 //
     /* 2096485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2096488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2096502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096531 */     // MIs[0] round
     /* 2096531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096534 */     // MIs[0] policy
     /* 2096534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2096547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096549 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096570 */     // GIR_Coverage, 16710,
     /* 2096570 */     GIR_EraseRootFromParent_Done,
     /* 2096571 */   // Label 27765: @2096571
     /* 2096571 */   GIM_Try, /*On fail goto*//*Label 27766*/ GIMT_Encode4(2096662), // Rule ID 16711 //
     /* 2096576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2096579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2096587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2096590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2096593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2096596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2096599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096622 */     // MIs[0] round
     /* 2096622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096625 */     // MIs[0] policy
     /* 2096625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096635 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32_MASK),
     /* 2096638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096640 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096661 */     // GIR_Coverage, 16711,
     /* 2096661 */     GIR_EraseRootFromParent_Done,
     /* 2096662 */   // Label 27766: @2096662
     /* 2096662 */   GIM_Try, /*On fail goto*//*Label 27767*/ GIMT_Encode4(2096753), // Rule ID 16714 //
     /* 2096667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2096670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2096678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2096681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2096687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096713 */     // MIs[0] round
     /* 2096713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096716 */     // MIs[0] policy
     /* 2096716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096726 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2096729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096731 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096752 */     // GIR_Coverage, 16714,
     /* 2096752 */     GIR_EraseRootFromParent_Done,
     /* 2096753 */   // Label 27767: @2096753
     /* 2096753 */   GIM_Try, /*On fail goto*//*Label 27768*/ GIMT_Encode4(2096844), // Rule ID 16715 //
     /* 2096758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2096761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2096769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2096772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2096775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2096778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2096781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096804 */     // MIs[0] round
     /* 2096804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096807 */     // MIs[0] policy
     /* 2096807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096817 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16_MASK),
     /* 2096820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096822 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2096840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096843 */     // GIR_Coverage, 16715,
     /* 2096843 */     GIR_EraseRootFromParent_Done,
     /* 2096844 */   // Label 27768: @2096844
     /* 2096844 */   GIM_Try, /*On fail goto*//*Label 27769*/ GIMT_Encode4(2096935), // Rule ID 16718 //
     /* 2096849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2096852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2096866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2096875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096895 */     // MIs[0] round
     /* 2096895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096898 */     // MIs[0] policy
     /* 2096898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096908 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2096908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2096911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2096913 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2096915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2096917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2096919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2096921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2096923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2096928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2096931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2096933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2096934 */     // GIR_Coverage, 16718,
     /* 2096934 */     GIR_EraseRootFromParent_Done,
     /* 2096935 */   // Label 27769: @2096935
     /* 2096935 */   GIM_Try, /*On fail goto*//*Label 27770*/ GIMT_Encode4(2097026), // Rule ID 16719 //
     /* 2096940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2096943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2096948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2096951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2096954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2096957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2096960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2096963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2096966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2096970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2096982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2096986 */     // MIs[0] round
     /* 2096986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2096989 */     // MIs[0] policy
     /* 2096989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2096992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2096999 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2096999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32_MASK),
     /* 2097002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097004 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097025 */     // GIR_Coverage, 16719,
     /* 2097025 */     GIR_EraseRootFromParent_Done,
     /* 2097026 */   // Label 27770: @2097026
     /* 2097026 */   GIM_Try, /*On fail goto*//*Label 27771*/ GIMT_Encode4(2097117), // Rule ID 16722 //
     /* 2097031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2097034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2097042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2097045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2097048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2097051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097077 */     // MIs[0] round
     /* 2097077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097080 */     // MIs[0] policy
     /* 2097080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097090 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2097093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097095 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097116 */     // GIR_Coverage, 16722,
     /* 2097116 */     GIR_EraseRootFromParent_Done,
     /* 2097117 */   // Label 27771: @2097117
     /* 2097117 */   GIM_Try, /*On fail goto*//*Label 27772*/ GIMT_Encode4(2097208), // Rule ID 16723 //
     /* 2097122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2097125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2097133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2097136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2097139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2097142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2097145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2097152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2097164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097168 */     // MIs[0] round
     /* 2097168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097171 */     // MIs[0] policy
     /* 2097171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097181 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64_MASK),
     /* 2097184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097186 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2097204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097207 */     // GIR_Coverage, 16723,
     /* 2097207 */     GIR_EraseRootFromParent_Done,
     /* 2097208 */   // Label 27772: @2097208
     /* 2097208 */   GIM_Try, /*On fail goto*//*Label 27773*/ GIMT_Encode4(2097299), // Rule ID 16726 //
     /* 2097213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2097216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2097224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2097227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2097233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097259 */     // MIs[0] round
     /* 2097259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097262 */     // MIs[0] policy
     /* 2097262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097272 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2097275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097277 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097298 */     // GIR_Coverage, 16726,
     /* 2097298 */     GIR_EraseRootFromParent_Done,
     /* 2097299 */   // Label 27773: @2097299
     /* 2097299 */   GIM_Try, /*On fail goto*//*Label 27774*/ GIMT_Encode4(2097390), // Rule ID 16727 //
     /* 2097304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2097307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2097315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2097318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2097321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2097324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097350 */     // MIs[0] round
     /* 2097350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097353 */     // MIs[0] policy
     /* 2097353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097363 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16_MASK),
     /* 2097366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097368 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097389 */     // GIR_Coverage, 16727,
     /* 2097389 */     GIR_EraseRootFromParent_Done,
     /* 2097390 */   // Label 27774: @2097390
     /* 2097390 */   GIM_Try, /*On fail goto*//*Label 27775*/ GIMT_Encode4(2097481), // Rule ID 16730 //
     /* 2097395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2097398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2097406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2097409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2097415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097441 */     // MIs[0] round
     /* 2097441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097444 */     // MIs[0] policy
     /* 2097444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097454 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2097457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097459 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097480 */     // GIR_Coverage, 16730,
     /* 2097480 */     GIR_EraseRootFromParent_Done,
     /* 2097481 */   // Label 27775: @2097481
     /* 2097481 */   GIM_Try, /*On fail goto*//*Label 27776*/ GIMT_Encode4(2097572), // Rule ID 16731 //
     /* 2097486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2097489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2097497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2097500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2097503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2097506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2097509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097532 */     // MIs[0] round
     /* 2097532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097535 */     // MIs[0] policy
     /* 2097535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097545 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16_MASK),
     /* 2097548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097550 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097571 */     // GIR_Coverage, 16731,
     /* 2097571 */     GIR_EraseRootFromParent_Done,
     /* 2097572 */   // Label 27776: @2097572
     /* 2097572 */   GIM_Try, /*On fail goto*//*Label 27777*/ GIMT_Encode4(2097663), // Rule ID 16734 //
     /* 2097577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2097580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2097588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2097591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2097597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097623 */     // MIs[0] round
     /* 2097623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097626 */     // MIs[0] policy
     /* 2097626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097636 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2097639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097641 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097662 */     // GIR_Coverage, 16734,
     /* 2097662 */     GIR_EraseRootFromParent_Done,
     /* 2097663 */   // Label 27777: @2097663
     /* 2097663 */   GIM_Try, /*On fail goto*//*Label 27778*/ GIMT_Encode4(2097754), // Rule ID 16735 //
     /* 2097668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2097671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2097679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2097682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2097685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2097688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2097691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2097698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2097710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097714 */     // MIs[0] round
     /* 2097714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097717 */     // MIs[0] policy
     /* 2097717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097727 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16_MASK),
     /* 2097730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097732 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2097750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097753 */     // GIR_Coverage, 16735,
     /* 2097753 */     GIR_EraseRootFromParent_Done,
     /* 2097754 */   // Label 27778: @2097754
     /* 2097754 */   GIM_Try, /*On fail goto*//*Label 27779*/ GIMT_Encode4(2097845), // Rule ID 16738 //
     /* 2097759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2097762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2097770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2097773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2097779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097805 */     // MIs[0] round
     /* 2097805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097808 */     // MIs[0] policy
     /* 2097808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097818 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2097818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2097821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097823 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097844 */     // GIR_Coverage, 16738,
     /* 2097844 */     GIR_EraseRootFromParent_Done,
     /* 2097845 */   // Label 27779: @2097845
     /* 2097845 */   GIM_Try, /*On fail goto*//*Label 27780*/ GIMT_Encode4(2097936), // Rule ID 16739 //
     /* 2097850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2097853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2097861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2097864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2097867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2097870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2097873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2097876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2097880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2097892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097896 */     // MIs[0] round
     /* 2097896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097899 */     // MIs[0] policy
     /* 2097899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2097909 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2097909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32_MASK),
     /* 2097912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2097914 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2097916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2097918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2097920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2097922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2097924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2097929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2097932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2097934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2097935 */     // GIR_Coverage, 16739,
     /* 2097935 */     GIR_EraseRootFromParent_Done,
     /* 2097936 */   // Label 27780: @2097936
     /* 2097936 */   GIM_Try, /*On fail goto*//*Label 27781*/ GIMT_Encode4(2098027), // Rule ID 16742 //
     /* 2097941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2097944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2097949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2097952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2097955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2097958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2097961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2097964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2097967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2097971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2097983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2097987 */     // MIs[0] round
     /* 2097987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2097990 */     // MIs[0] policy
     /* 2097990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2097993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098000 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2098003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098005 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098026 */     // GIR_Coverage, 16742,
     /* 2098026 */     GIR_EraseRootFromParent_Done,
     /* 2098027 */   // Label 27781: @2098027
     /* 2098027 */   GIM_Try, /*On fail goto*//*Label 27782*/ GIMT_Encode4(2098118), // Rule ID 16743 //
     /* 2098032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2098035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2098043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2098046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2098049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2098052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098078 */     // MIs[0] round
     /* 2098078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098081 */     // MIs[0] policy
     /* 2098081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098091 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32_MASK),
     /* 2098094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098096 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098117 */     // GIR_Coverage, 16743,
     /* 2098117 */     GIR_EraseRootFromParent_Done,
     /* 2098118 */   // Label 27782: @2098118
     /* 2098118 */   GIM_Try, /*On fail goto*//*Label 27783*/ GIMT_Encode4(2098209), // Rule ID 16746 //
     /* 2098123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2098126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2098134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2098137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2098143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2098153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098169 */     // MIs[0] round
     /* 2098169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098172 */     // MIs[0] policy
     /* 2098172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098182 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2098185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098187 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098208 */     // GIR_Coverage, 16746,
     /* 2098208 */     GIR_EraseRootFromParent_Done,
     /* 2098209 */   // Label 27783: @2098209
     /* 2098209 */   GIM_Try, /*On fail goto*//*Label 27784*/ GIMT_Encode4(2098300), // Rule ID 16747 //
     /* 2098214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2098217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2098225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2098228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2098231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2098234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2098237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2098244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098260 */     // MIs[0] round
     /* 2098260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098263 */     // MIs[0] policy
     /* 2098263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098273 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32_MASK),
     /* 2098276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098278 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2098296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098299 */     // GIR_Coverage, 16747,
     /* 2098299 */     GIR_EraseRootFromParent_Done,
     /* 2098300 */   // Label 27784: @2098300
     /* 2098300 */   GIM_Try, /*On fail goto*//*Label 27785*/ GIMT_Encode4(2098391), // Rule ID 16750 //
     /* 2098305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2098308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2098316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2098319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2098325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098351 */     // MIs[0] round
     /* 2098351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098354 */     // MIs[0] policy
     /* 2098354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2098367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098369 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098390 */     // GIR_Coverage, 16750,
     /* 2098390 */     GIR_EraseRootFromParent_Done,
     /* 2098391 */   // Label 27785: @2098391
     /* 2098391 */   GIM_Try, /*On fail goto*//*Label 27786*/ GIMT_Encode4(2098482), // Rule ID 16751 //
     /* 2098396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2098399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2098407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2098410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2098413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2098416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2098419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2098426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2098438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098442 */     // MIs[0] round
     /* 2098442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098445 */     // MIs[0] policy
     /* 2098445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098455 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64_MASK),
     /* 2098458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098460 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098481 */     // GIR_Coverage, 16751,
     /* 2098481 */     GIR_EraseRootFromParent_Done,
     /* 2098482 */   // Label 27786: @2098482
     /* 2098482 */   GIM_Try, /*On fail goto*//*Label 27787*/ GIMT_Encode4(2098573), // Rule ID 16754 //
     /* 2098487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2098490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2098498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2098501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2098507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098533 */     // MIs[0] round
     /* 2098533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098536 */     // MIs[0] policy
     /* 2098536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098546 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2098549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098551 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098572 */     // GIR_Coverage, 16754,
     /* 2098572 */     GIR_EraseRootFromParent_Done,
     /* 2098573 */   // Label 27787: @2098573
     /* 2098573 */   GIM_Try, /*On fail goto*//*Label 27788*/ GIMT_Encode4(2098664), // Rule ID 16755 //
     /* 2098578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2098581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2098589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2098592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2098595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2098598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2098601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2098608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2098620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098624 */     // MIs[0] round
     /* 2098624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098627 */     // MIs[0] policy
     /* 2098627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098637 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64_MASK),
     /* 2098640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098642 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098663 */     // GIR_Coverage, 16755,
     /* 2098663 */     GIR_EraseRootFromParent_Done,
     /* 2098664 */   // Label 27788: @2098664
     /* 2098664 */   GIM_Try, /*On fail goto*//*Label 27789*/ GIMT_Encode4(2098755), // Rule ID 16758 //
     /* 2098669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2098672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2098680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2098683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2098686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2098689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2098699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098715 */     // MIs[0] round
     /* 2098715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098718 */     // MIs[0] policy
     /* 2098718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098728 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2098731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098733 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098754 */     // GIR_Coverage, 16758,
     /* 2098754 */     GIR_EraseRootFromParent_Done,
     /* 2098755 */   // Label 27789: @2098755
     /* 2098755 */   GIM_Try, /*On fail goto*//*Label 27790*/ GIMT_Encode4(2098846), // Rule ID 16759 //
     /* 2098760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2098763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2098771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2098774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2098777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2098780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2098783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2098790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2098802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098806 */     // MIs[0] round
     /* 2098806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098809 */     // MIs[0] policy
     /* 2098809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098819 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2098819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64_MASK),
     /* 2098822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098824 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2098842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098845 */     // GIR_Coverage, 16759,
     /* 2098845 */     GIR_EraseRootFromParent_Done,
     /* 2098846 */   // Label 27790: @2098846
     /* 2098846 */   GIM_Try, /*On fail goto*//*Label 27791*/ GIMT_Encode4(2098937), // Rule ID 16762 //
     /* 2098851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2098854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2098862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2098865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2098868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2098877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098897 */     // MIs[0] round
     /* 2098897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098900 */     // MIs[0] policy
     /* 2098900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2098910 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2098910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2098913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2098915 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2098917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2098919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2098921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2098923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2098925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2098930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2098933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2098935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2098936 */     // GIR_Coverage, 16762,
     /* 2098936 */     GIR_EraseRootFromParent_Done,
     /* 2098937 */   // Label 27791: @2098937
     /* 2098937 */   GIM_Try, /*On fail goto*//*Label 27792*/ GIMT_Encode4(2099028), // Rule ID 16763 //
     /* 2098942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2098945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2098950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2098953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2098956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2098959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2098962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2098965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2098968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2098972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2098980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2098984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2098988 */     // MIs[0] round
     /* 2098988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2098991 */     // MIs[0] policy
     /* 2098991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2098994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099001 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF4_E16_MASK),
     /* 2099004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099006 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099027 */     // GIR_Coverage, 16763,
     /* 2099027 */     GIR_EraseRootFromParent_Done,
     /* 2099028 */   // Label 27792: @2099028
     /* 2099028 */   GIM_Try, /*On fail goto*//*Label 27793*/ GIMT_Encode4(2099119), // Rule ID 16766 //
     /* 2099033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2099036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2099044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2099047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099079 */     // MIs[0] round
     /* 2099079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099082 */     // MIs[0] policy
     /* 2099082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099092 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2099095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099097 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099118 */     // GIR_Coverage, 16766,
     /* 2099118 */     GIR_EraseRootFromParent_Done,
     /* 2099119 */   // Label 27793: @2099119
     /* 2099119 */   GIM_Try, /*On fail goto*//*Label 27794*/ GIMT_Encode4(2099210), // Rule ID 16767 //
     /* 2099124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2099127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2099135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2099138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2099141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099170 */     // MIs[0] round
     /* 2099170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099173 */     // MIs[0] policy
     /* 2099173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099183 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_MF2_E16_MASK),
     /* 2099186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099188 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099209 */     // GIR_Coverage, 16767,
     /* 2099209 */     GIR_EraseRootFromParent_Done,
     /* 2099210 */   // Label 27794: @2099210
     /* 2099210 */   GIM_Try, /*On fail goto*//*Label 27795*/ GIMT_Encode4(2099301), // Rule ID 16770 //
     /* 2099215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2099218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2099226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2099229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2099232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099261 */     // MIs[0] round
     /* 2099261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099264 */     // MIs[0] policy
     /* 2099264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099274 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2099277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099279 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099300 */     // GIR_Coverage, 16770,
     /* 2099300 */     GIR_EraseRootFromParent_Done,
     /* 2099301 */   // Label 27795: @2099301
     /* 2099301 */   GIM_Try, /*On fail goto*//*Label 27796*/ GIMT_Encode4(2099392), // Rule ID 16771 //
     /* 2099306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2099309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2099317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2099320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2099323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099352 */     // MIs[0] round
     /* 2099352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099355 */     // MIs[0] policy
     /* 2099355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099365 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_MF2_E32_MASK),
     /* 2099368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099370 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099391 */     // GIR_Coverage, 16771,
     /* 2099391 */     GIR_EraseRootFromParent_Done,
     /* 2099392 */   // Label 27796: @2099392
     /* 2099392 */   GIM_Try, /*On fail goto*//*Label 27797*/ GIMT_Encode4(2099483), // Rule ID 16774 //
     /* 2099397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2099400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2099408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2099411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099443 */     // MIs[0] round
     /* 2099443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099446 */     // MIs[0] policy
     /* 2099446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099456 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2099459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099461 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099482 */     // GIR_Coverage, 16774,
     /* 2099482 */     GIR_EraseRootFromParent_Done,
     /* 2099483 */   // Label 27797: @2099483
     /* 2099483 */   GIM_Try, /*On fail goto*//*Label 27798*/ GIMT_Encode4(2099574), // Rule ID 16775 //
     /* 2099488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2099491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2099499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2099502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2099505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2099511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099534 */     // MIs[0] round
     /* 2099534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099537 */     // MIs[0] policy
     /* 2099537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099547 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11209:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M1_E16_MASK),
     /* 2099550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099552 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2099570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099573 */     // GIR_Coverage, 16775,
     /* 2099573 */     GIR_EraseRootFromParent_Done,
     /* 2099574 */   // Label 27798: @2099574
     /* 2099574 */   GIM_Try, /*On fail goto*//*Label 27799*/ GIMT_Encode4(2099665), // Rule ID 16778 //
     /* 2099579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2099582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2099596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099625 */     // MIs[0] round
     /* 2099625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099628 */     // MIs[0] policy
     /* 2099628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099638 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2099641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099643 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099664 */     // GIR_Coverage, 16778,
     /* 2099664 */     GIR_EraseRootFromParent_Done,
     /* 2099665 */   // Label 27799: @2099665
     /* 2099665 */   GIM_Try, /*On fail goto*//*Label 27800*/ GIMT_Encode4(2099756), // Rule ID 16779 //
     /* 2099670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2099673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2099681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2099684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2099687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2099690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2099693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2099712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099716 */     // MIs[0] round
     /* 2099716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099719 */     // MIs[0] policy
     /* 2099719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099729 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11209:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M1_E32_MASK),
     /* 2099732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099734 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2099752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099755 */     // GIR_Coverage, 16779,
     /* 2099755 */     GIR_EraseRootFromParent_Done,
     /* 2099756 */   // Label 27800: @2099756
     /* 2099756 */   GIM_Try, /*On fail goto*//*Label 27801*/ GIMT_Encode4(2099847), // Rule ID 16782 //
     /* 2099761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2099764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2099772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2099775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2099778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2099803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099807 */     // MIs[0] round
     /* 2099807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099810 */     // MIs[0] policy
     /* 2099810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099820 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2099820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2099823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2099843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099846 */     // GIR_Coverage, 16782,
     /* 2099846 */     GIR_EraseRootFromParent_Done,
     /* 2099847 */   // Label 27801: @2099847
     /* 2099847 */   GIM_Try, /*On fail goto*//*Label 27802*/ GIMT_Encode4(2099938), // Rule ID 16783 //
     /* 2099852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2099855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2099863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2099866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2099869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2099872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2099875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2099878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2099882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2099890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2099894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099898 */     // MIs[0] round
     /* 2099898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099901 */     // MIs[0] policy
     /* 2099901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2099911 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11209:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2099911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M1_E64_MASK),
     /* 2099914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2099916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2099918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2099920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2099922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2099924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2099926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2099931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2099934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2099936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2099937 */     // GIR_Coverage, 16783,
     /* 2099937 */     GIR_EraseRootFromParent_Done,
     /* 2099938 */   // Label 27802: @2099938
     /* 2099938 */   GIM_Try, /*On fail goto*//*Label 27803*/ GIMT_Encode4(2100029), // Rule ID 16786 //
     /* 2099943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2099946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2099951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2099954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2099957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2099960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2099963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2099966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2099969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2099973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2099981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2099985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2099989 */     // MIs[0] round
     /* 2099989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2099992 */     // MIs[0] policy
     /* 2099992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2099995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100002 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2100005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100028 */     // GIR_Coverage, 16786,
     /* 2100028 */     GIR_EraseRootFromParent_Done,
     /* 2100029 */   // Label 27803: @2100029
     /* 2100029 */   GIM_Try, /*On fail goto*//*Label 27804*/ GIMT_Encode4(2100120), // Rule ID 16787 //
     /* 2100034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2100037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2100045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2100048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2100051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2100054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2100076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100080 */     // MIs[0] round
     /* 2100080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100083 */     // MIs[0] policy
     /* 2100083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100093 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M2_E16_MASK),
     /* 2100096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100119 */     // GIR_Coverage, 16787,
     /* 2100119 */     GIR_EraseRootFromParent_Done,
     /* 2100120 */   // Label 27804: @2100120
     /* 2100120 */   GIM_Try, /*On fail goto*//*Label 27805*/ GIMT_Encode4(2100211), // Rule ID 16790 //
     /* 2100125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2100128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2100136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2100139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2100145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2100167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100171 */     // MIs[0] round
     /* 2100171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100174 */     // MIs[0] policy
     /* 2100174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100184 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2100187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100210 */     // GIR_Coverage, 16790,
     /* 2100210 */     GIR_EraseRootFromParent_Done,
     /* 2100211 */   // Label 27805: @2100211
     /* 2100211 */   GIM_Try, /*On fail goto*//*Label 27806*/ GIMT_Encode4(2100302), // Rule ID 16791 //
     /* 2100216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2100219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2100227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2100230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2100233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2100236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2100258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100262 */     // MIs[0] round
     /* 2100262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100265 */     // MIs[0] policy
     /* 2100265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100275 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M4_E16_MASK),
     /* 2100278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100301 */     // GIR_Coverage, 16791,
     /* 2100301 */     GIR_EraseRootFromParent_Done,
     /* 2100302 */   // Label 27806: @2100302
     /* 2100302 */   GIM_Try, /*On fail goto*//*Label 27807*/ GIMT_Encode4(2100393), // Rule ID 16794 //
     /* 2100307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2100310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2100318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2100321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2100327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2100349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100353 */     // MIs[0] round
     /* 2100353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100356 */     // MIs[0] policy
     /* 2100356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100366 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2100369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100392 */     // GIR_Coverage, 16794,
     /* 2100392 */     GIR_EraseRootFromParent_Done,
     /* 2100393 */   // Label 27807: @2100393
     /* 2100393 */   GIM_Try, /*On fail goto*//*Label 27808*/ GIMT_Encode4(2100484), // Rule ID 16795 //
     /* 2100398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2100401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2100409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2100412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2100415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2100418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2100421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2100440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100444 */     // MIs[0] round
     /* 2100444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100447 */     // MIs[0] policy
     /* 2100447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100457 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR16_M8_E16_MASK),
     /* 2100460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2100480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100483 */     // GIR_Coverage, 16795,
     /* 2100483 */     GIR_EraseRootFromParent_Done,
     /* 2100484 */   // Label 27808: @2100484
     /* 2100484 */   GIM_Try, /*On fail goto*//*Label 27809*/ GIMT_Encode4(2100575), // Rule ID 16798 //
     /* 2100489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2100492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2100500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2100503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100535 */     // MIs[0] round
     /* 2100535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100538 */     // MIs[0] policy
     /* 2100538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100548 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2100551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100574 */     // GIR_Coverage, 16798,
     /* 2100574 */     GIR_EraseRootFromParent_Done,
     /* 2100575 */   // Label 27809: @2100575
     /* 2100575 */   GIM_Try, /*On fail goto*//*Label 27810*/ GIMT_Encode4(2100666), // Rule ID 16799 //
     /* 2100580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2100583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2100591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2100594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2100597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2100603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2100610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2100618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100626 */     // MIs[0] round
     /* 2100626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100629 */     // MIs[0] policy
     /* 2100629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100639 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M2_E32_MASK),
     /* 2100642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100665 */     // GIR_Coverage, 16799,
     /* 2100665 */     GIR_EraseRootFromParent_Done,
     /* 2100666 */   // Label 27810: @2100666
     /* 2100666 */   GIM_Try, /*On fail goto*//*Label 27811*/ GIMT_Encode4(2100757), // Rule ID 16802 //
     /* 2100671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2100674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2100682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2100685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100717 */     // MIs[0] round
     /* 2100717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100720 */     // MIs[0] policy
     /* 2100720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100730 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2100733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100756 */     // GIR_Coverage, 16802,
     /* 2100756 */     GIR_EraseRootFromParent_Done,
     /* 2100757 */   // Label 27811: @2100757
     /* 2100757 */   GIM_Try, /*On fail goto*//*Label 27812*/ GIMT_Encode4(2100848), // Rule ID 16803 //
     /* 2100762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2100765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2100773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2100776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2100779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2100785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2100792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2100800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100808 */     // MIs[0] round
     /* 2100808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100811 */     // MIs[0] policy
     /* 2100811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100821 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2100821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M4_E32_MASK),
     /* 2100824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100847 */     // GIR_Coverage, 16803,
     /* 2100847 */     GIR_EraseRootFromParent_Done,
     /* 2100848 */   // Label 27812: @2100848
     /* 2100848 */   GIM_Try, /*On fail goto*//*Label 27813*/ GIMT_Encode4(2100939), // Rule ID 16806 //
     /* 2100853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2100856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2100864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2100867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2100870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2100879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100899 */     // MIs[0] round
     /* 2100899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100902 */     // MIs[0] policy
     /* 2100902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2100912 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2100912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2100915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2100917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2100919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2100921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2100923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2100925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2100927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2100932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2100935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2100937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2100938 */     // GIR_Coverage, 16806,
     /* 2100938 */     GIR_EraseRootFromParent_Done,
     /* 2100939 */   // Label 27813: @2100939
     /* 2100939 */   GIM_Try, /*On fail goto*//*Label 27814*/ GIMT_Encode4(2101030), // Rule ID 16807 //
     /* 2100944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2100947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2100952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2100955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2100958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2100961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2100964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2100967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2100970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2100974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2100982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2100986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2100990 */     // MIs[0] round
     /* 2100990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2100993 */     // MIs[0] policy
     /* 2100993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2100996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101003 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR32_M8_E32_MASK),
     /* 2101006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2101026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101029 */     // GIR_Coverage, 16807,
     /* 2101029 */     GIR_EraseRootFromParent_Done,
     /* 2101030 */   // Label 27814: @2101030
     /* 2101030 */   GIM_Try, /*On fail goto*//*Label 27815*/ GIMT_Encode4(2101121), // Rule ID 16810 //
     /* 2101035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2101038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2101046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2101049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101081 */     // MIs[0] round
     /* 2101081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101084 */     // MIs[0] policy
     /* 2101084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101094 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2101097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101120 */     // GIR_Coverage, 16810,
     /* 2101120 */     GIR_EraseRootFromParent_Done,
     /* 2101121 */   // Label 27815: @2101121
     /* 2101121 */   GIM_Try, /*On fail goto*//*Label 27816*/ GIMT_Encode4(2101212), // Rule ID 16811 //
     /* 2101126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2101129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2101137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2101140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2101143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2101156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2101164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101172 */     // MIs[0] round
     /* 2101172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101175 */     // MIs[0] policy
     /* 2101175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101185 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11209:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M2_E64_MASK),
     /* 2101188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101211 */     // GIR_Coverage, 16811,
     /* 2101211 */     GIR_EraseRootFromParent_Done,
     /* 2101212 */   // Label 27816: @2101212
     /* 2101212 */   GIM_Try, /*On fail goto*//*Label 27817*/ GIMT_Encode4(2101303), // Rule ID 16814 //
     /* 2101217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2101220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2101228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2101231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101263 */     // MIs[0] round
     /* 2101263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101266 */     // MIs[0] policy
     /* 2101266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101276 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2101279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101302 */     // GIR_Coverage, 16814,
     /* 2101302 */     GIR_EraseRootFromParent_Done,
     /* 2101303 */   // Label 27817: @2101303
     /* 2101303 */   GIM_Try, /*On fail goto*//*Label 27818*/ GIMT_Encode4(2101394), // Rule ID 16815 //
     /* 2101308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2101311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2101319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2101322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2101325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2101331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2101338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2101346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101354 */     // MIs[0] round
     /* 2101354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101357 */     // MIs[0] policy
     /* 2101357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101367 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11209:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M4_E64_MASK),
     /* 2101370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101393 */     // GIR_Coverage, 16815,
     /* 2101393 */     GIR_EraseRootFromParent_Done,
     /* 2101394 */   // Label 27818: @2101394
     /* 2101394 */   GIM_Try, /*On fail goto*//*Label 27819*/ GIMT_Encode4(2101485), // Rule ID 16818 //
     /* 2101399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2101402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2101410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2101413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2101429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101445 */     // MIs[0] round
     /* 2101445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101448 */     // MIs[0] policy
     /* 2101448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101458 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2101461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101484 */     // GIR_Coverage, 16818,
     /* 2101484 */     GIR_EraseRootFromParent_Done,
     /* 2101485 */   // Label 27819: @2101485
     /* 2101485 */   GIM_Try, /*On fail goto*//*Label 27820*/ GIMT_Encode4(2101576), // Rule ID 16819 //
     /* 2101490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2101493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfsub_mask),
     /* 2101498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2101501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2101504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2101507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2101510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2101513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2101520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2101528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2101532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101536 */     // MIs[0] round
     /* 2101536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101539 */     // MIs[0] policy
     /* 2101539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101549 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11209:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VFPR64_M8_E64_MASK),
     /* 2101552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2101572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101575 */     // GIR_Coverage, 16819,
     /* 2101575 */     GIR_EraseRootFromParent_Done,
     /* 2101576 */   // Label 27820: @2101576
     /* 2101576 */   GIM_Try, /*On fail goto*//*Label 27821*/ GIMT_Encode4(2101667), // Rule ID 16822 //
     /* 2101581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2101589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2101598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2101601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101604 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101619 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2101623 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101627 */     // MIs[0] round
     /* 2101627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101630 */     // MIs[0] policy
     /* 2101630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101640 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2101643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101645 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101647 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101649 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101651 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101653 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101663 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101666 */     // GIR_Coverage, 16822,
     /* 2101666 */     GIR_EraseRootFromParent_Done,
     /* 2101667 */   // Label 27821: @2101667
     /* 2101667 */   GIM_Try, /*On fail goto*//*Label 27822*/ GIMT_Encode4(2101758), // Rule ID 16823 //
     /* 2101672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2101680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2101683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2101686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2101689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2101692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101695 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2101714 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101718 */     // MIs[0] round
     /* 2101718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101721 */     // MIs[0] policy
     /* 2101721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101731 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF4_E16_MASK),
     /* 2101734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101736 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101740 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101742 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101744 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101754 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101757 */     // GIR_Coverage, 16823,
     /* 2101757 */     GIR_EraseRootFromParent_Done,
     /* 2101758 */   // Label 27822: @2101758
     /* 2101758 */   GIM_Try, /*On fail goto*//*Label 27823*/ GIMT_Encode4(2101849), // Rule ID 16826 //
     /* 2101763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2101766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2101771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2101774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2101777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2101780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2101783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101801 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2101805 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101809 */     // MIs[0] round
     /* 2101809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101812 */     // MIs[0] policy
     /* 2101812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101822 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2101822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2101825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101827 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101829 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101831 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101833 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101835 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101845 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101848 */     // GIR_Coverage, 16826,
     /* 2101848 */     GIR_EraseRootFromParent_Done,
     /* 2101849 */   // Label 27823: @2101849
     /* 2101849 */   GIM_Try, /*On fail goto*//*Label 27824*/ GIMT_Encode4(2101940), // Rule ID 16827 //
     /* 2101854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2101857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2101862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2101865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2101868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2101871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2101874 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2101877 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2101880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2101896 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101900 */     // MIs[0] round
     /* 2101900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101903 */     // MIs[0] policy
     /* 2101903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2101913 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2101913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_MF2_E16_MASK),
     /* 2101916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2101918 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2101920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2101922 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2101924 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2101926 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2101928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2101933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2101936 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2101938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2101939 */     // GIR_Coverage, 16827,
     /* 2101939 */     GIR_EraseRootFromParent_Done,
     /* 2101940 */   // Label 27824: @2101940
     /* 2101940 */   GIM_Try, /*On fail goto*//*Label 27825*/ GIMT_Encode4(2102031), // Rule ID 16830 //
     /* 2101945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2101948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2101953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2101956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2101959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2101962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2101965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2101968 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2101971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2101975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2101983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2101987 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2101991 */     // MIs[0] round
     /* 2101991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2101994 */     // MIs[0] policy
     /* 2101994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2101997 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102004 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2102007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102009 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102011 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102013 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102015 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102017 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102027 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102030 */     // GIR_Coverage, 16830,
     /* 2102030 */     GIR_EraseRootFromParent_Done,
     /* 2102031 */   // Label 27825: @2102031
     /* 2102031 */   GIM_Try, /*On fail goto*//*Label 27826*/ GIMT_Encode4(2102122), // Rule ID 16831 //
     /* 2102036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2102047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2102050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2102053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102056 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102059 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2102078 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102082 */     // MIs[0] round
     /* 2102082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102085 */     // MIs[0] policy
     /* 2102085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102095 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_MF2_E32_MASK),
     /* 2102098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102100 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102102 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102104 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102106 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102108 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102118 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102121 */     // GIR_Coverage, 16831,
     /* 2102121 */     GIR_EraseRootFromParent_Done,
     /* 2102122 */   // Label 27826: @2102122
     /* 2102122 */   GIM_Try, /*On fail goto*//*Label 27827*/ GIMT_Encode4(2102213), // Rule ID 16834 //
     /* 2102127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102150 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102165 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102169 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102173 */     // MIs[0] round
     /* 2102173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102176 */     // MIs[0] policy
     /* 2102176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102179 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102186 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2102189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102191 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102195 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102197 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102199 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102209 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102212 */     // GIR_Coverage, 16834,
     /* 2102212 */     GIR_EraseRootFromParent_Done,
     /* 2102213 */   // Label 27827: @2102213
     /* 2102213 */   GIM_Try, /*On fail goto*//*Label 27828*/ GIMT_Encode4(2102304), // Rule ID 16835 //
     /* 2102218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2102229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2102232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2102235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102238 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2102241 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102260 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102264 */     // MIs[0] round
     /* 2102264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102267 */     // MIs[0] policy
     /* 2102267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102277 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11195:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M1_E16_MASK),
     /* 2102280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102282 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102284 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102286 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102288 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102290 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102292 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102300 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102303 */     // GIR_Coverage, 16835,
     /* 2102303 */     GIR_EraseRootFromParent_Done,
     /* 2102304 */   // Label 27828: @2102304
     /* 2102304 */   GIM_Try, /*On fail goto*//*Label 27829*/ GIMT_Encode4(2102395), // Rule ID 16838 //
     /* 2102309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2102312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102332 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102347 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2102351 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102355 */     // MIs[0] round
     /* 2102355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102358 */     // MIs[0] policy
     /* 2102358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102361 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102368 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2102371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102373 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102375 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102377 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102379 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102381 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102391 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102394 */     // GIR_Coverage, 16838,
     /* 2102394 */     GIR_EraseRootFromParent_Done,
     /* 2102395 */   // Label 27829: @2102395
     /* 2102395 */   GIM_Try, /*On fail goto*//*Label 27830*/ GIMT_Encode4(2102486), // Rule ID 16839 //
     /* 2102400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2102403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2102411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2102414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2102417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2102420 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2102423 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2102442 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102446 */     // MIs[0] round
     /* 2102446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102449 */     // MIs[0] policy
     /* 2102449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102459 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11195:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M1_E32_MASK),
     /* 2102462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102464 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102466 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102468 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102470 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102472 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2102482 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102485 */     // GIR_Coverage, 16839,
     /* 2102485 */     GIR_EraseRootFromParent_Done,
     /* 2102486 */   // Label 27830: @2102486
     /* 2102486 */   GIM_Try, /*On fail goto*//*Label 27831*/ GIMT_Encode4(2102577), // Rule ID 16842 //
     /* 2102491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2102494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102514 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2102533 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102537 */     // MIs[0] round
     /* 2102537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102540 */     // MIs[0] policy
     /* 2102540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102550 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2102553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102555 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102557 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102559 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102561 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102563 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102573 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102576 */     // GIR_Coverage, 16842,
     /* 2102576 */     GIR_EraseRootFromParent_Done,
     /* 2102577 */   // Label 27831: @2102577
     /* 2102577 */   GIM_Try, /*On fail goto*//*Label 27832*/ GIMT_Encode4(2102668), // Rule ID 16843 //
     /* 2102582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2102585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2102593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2102596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2102599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2102602 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2102605 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2102612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2102620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2102624 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102628 */     // MIs[0] round
     /* 2102628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102631 */     // MIs[0] policy
     /* 2102631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102634 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102641 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11195:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M1_E64_MASK),
     /* 2102644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102646 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102650 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102652 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102654 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2102664 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102667 */     // GIR_Coverage, 16843,
     /* 2102667 */     GIR_EraseRootFromParent_Done,
     /* 2102668 */   // Label 27832: @2102668
     /* 2102668 */   GIM_Try, /*On fail goto*//*Label 27833*/ GIMT_Encode4(2102759), // Rule ID 16846 //
     /* 2102673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2102684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2102687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2102690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102693 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102696 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102715 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102719 */     // MIs[0] round
     /* 2102719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102722 */     // MIs[0] policy
     /* 2102722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2102735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102737 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102739 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102741 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102743 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102745 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102755 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102758 */     // GIR_Coverage, 16846,
     /* 2102758 */     GIR_EraseRootFromParent_Done,
     /* 2102759 */   // Label 27833: @2102759
     /* 2102759 */   GIM_Try, /*On fail goto*//*Label 27834*/ GIMT_Encode4(2102850), // Rule ID 16847 //
     /* 2102764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2102775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2102778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2102781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102784 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2102787 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2102794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2102802 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102806 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102810 */     // MIs[0] round
     /* 2102810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102813 */     // MIs[0] policy
     /* 2102813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102823 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2102823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M2_E16_MASK),
     /* 2102826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102828 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102830 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102832 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102834 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102836 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102846 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102849 */     // GIR_Coverage, 16847,
     /* 2102849 */     GIR_EraseRootFromParent_Done,
     /* 2102850 */   // Label 27834: @2102850
     /* 2102850 */   GIM_Try, /*On fail goto*//*Label 27835*/ GIMT_Encode4(2102941), // Rule ID 16850 //
     /* 2102855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2102858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2102866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2102869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2102872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2102878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2102881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102897 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102901 */     // MIs[0] round
     /* 2102901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102904 */     // MIs[0] policy
     /* 2102904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2102914 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2102914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2102917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2102919 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2102921 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2102923 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2102925 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2102927 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2102929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2102934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2102937 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2102939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2102940 */     // GIR_Coverage, 16850,
     /* 2102940 */     GIR_EraseRootFromParent_Done,
     /* 2102941 */   // Label 27835: @2102941
     /* 2102941 */   GIM_Try, /*On fail goto*//*Label 27836*/ GIMT_Encode4(2103032), // Rule ID 16851 //
     /* 2102946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2102949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2102954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2102957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2102960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2102963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2102966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2102969 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2102972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2102976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2102984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2102988 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2102992 */     // MIs[0] round
     /* 2102992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2102995 */     // MIs[0] policy
     /* 2102995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2102998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103005 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M4_E16_MASK),
     /* 2103008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103010 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103014 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103016 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103018 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103020 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103028 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103031 */     // GIR_Coverage, 16851,
     /* 2103031 */     GIR_EraseRootFromParent_Done,
     /* 2103032 */   // Label 27836: @2103032
     /* 2103032 */   GIM_Try, /*On fail goto*//*Label 27837*/ GIMT_Encode4(2103123), // Rule ID 16854 //
     /* 2103037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2103040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103060 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103079 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103083 */     // MIs[0] round
     /* 2103083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103086 */     // MIs[0] policy
     /* 2103086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103089 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103096 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2103099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103101 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103103 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103105 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103107 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103109 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103119 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103122 */     // GIR_Coverage, 16854,
     /* 2103122 */     GIR_EraseRootFromParent_Done,
     /* 2103123 */   // Label 27837: @2103123
     /* 2103123 */   GIM_Try, /*On fail goto*//*Label 27838*/ GIMT_Encode4(2103214), // Rule ID 16855 //
     /* 2103128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2103131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2103139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2103142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2103145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2103148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2103151 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2103170 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103174 */     // MIs[0] round
     /* 2103174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103177 */     // MIs[0] policy
     /* 2103177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103187 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR16_M8_E16_MASK),
     /* 2103190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103192 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103194 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103196 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103198 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103200 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2103210 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103213 */     // GIR_Coverage, 16855,
     /* 2103213 */     GIR_EraseRootFromParent_Done,
     /* 2103214 */   // Label 27838: @2103214
     /* 2103214 */   GIM_Try, /*On fail goto*//*Label 27839*/ GIMT_Encode4(2103305), // Rule ID 16858 //
     /* 2103219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103239 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103242 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103261 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103265 */     // MIs[0] round
     /* 2103265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103268 */     // MIs[0] policy
     /* 2103268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103271 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103278 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2103281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103283 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103287 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103289 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103291 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103293 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103301 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103304 */     // GIR_Coverage, 16858,
     /* 2103304 */     GIR_EraseRootFromParent_Done,
     /* 2103305 */   // Label 27839: @2103305
     /* 2103305 */   GIM_Try, /*On fail goto*//*Label 27840*/ GIMT_Encode4(2103396), // Rule ID 16859 //
     /* 2103310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2103321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2103324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2103327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103330 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103333 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103352 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103356 */     // MIs[0] round
     /* 2103356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103359 */     // MIs[0] policy
     /* 2103359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103369 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M2_E32_MASK),
     /* 2103372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103374 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103376 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103378 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103380 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103382 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103392 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103395 */     // GIR_Coverage, 16859,
     /* 2103395 */     GIR_EraseRootFromParent_Done,
     /* 2103396 */   // Label 27840: @2103396
     /* 2103396 */   GIM_Try, /*On fail goto*//*Label 27841*/ GIMT_Encode4(2103487), // Rule ID 16862 //
     /* 2103401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103421 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103424 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103443 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103447 */     // MIs[0] round
     /* 2103447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103450 */     // MIs[0] policy
     /* 2103450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103453 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103460 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2103463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103465 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103467 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103469 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103471 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103473 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103483 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103486 */     // GIR_Coverage, 16862,
     /* 2103486 */     GIR_EraseRootFromParent_Done,
     /* 2103487 */   // Label 27841: @2103487
     /* 2103487 */   GIM_Try, /*On fail goto*//*Label 27842*/ GIMT_Encode4(2103578), // Rule ID 16863 //
     /* 2103492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2103503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2103506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2103509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103512 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2103515 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103534 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103538 */     // MIs[0] round
     /* 2103538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103541 */     // MIs[0] policy
     /* 2103541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103544 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103551 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M4_E32_MASK),
     /* 2103554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103556 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103558 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103560 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103562 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103564 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103574 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103577 */     // GIR_Coverage, 16863,
     /* 2103577 */     GIR_EraseRootFromParent_Done,
     /* 2103578 */   // Label 27842: @2103578
     /* 2103578 */   GIM_Try, /*On fail goto*//*Label 27843*/ GIMT_Encode4(2103669), // Rule ID 16866 //
     /* 2103583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2103586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2103594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2103597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2103600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103606 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103625 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103629 */     // MIs[0] round
     /* 2103629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103632 */     // MIs[0] policy
     /* 2103632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103642 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2103645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103647 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103649 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103651 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103653 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103655 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103665 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103668 */     // GIR_Coverage, 16866,
     /* 2103668 */     GIR_EraseRootFromParent_Done,
     /* 2103669 */   // Label 27843: @2103669
     /* 2103669 */   GIM_Try, /*On fail goto*//*Label 27844*/ GIMT_Encode4(2103760), // Rule ID 16867 //
     /* 2103674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2103677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2103685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2103688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2103691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2103694 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2103697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2103704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2103712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2103716 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103720 */     // MIs[0] round
     /* 2103720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103723 */     // MIs[0] policy
     /* 2103723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103733 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR32_M8_E32_MASK),
     /* 2103736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103738 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103742 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103744 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103746 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2103756 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103759 */     // GIR_Coverage, 16867,
     /* 2103759 */     GIR_EraseRootFromParent_Done,
     /* 2103760 */   // Label 27844: @2103760
     /* 2103760 */   GIM_Try, /*On fail goto*//*Label 27845*/ GIMT_Encode4(2103851), // Rule ID 16870 //
     /* 2103765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2103768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2103776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2103779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2103782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103785 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103788 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103803 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2103807 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103811 */     // MIs[0] round
     /* 2103811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103814 */     // MIs[0] policy
     /* 2103814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103817 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103824 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2103824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2103827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103829 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103833 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103835 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103837 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103839 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103847 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103850 */     // GIR_Coverage, 16870,
     /* 2103850 */     GIR_EraseRootFromParent_Done,
     /* 2103851 */   // Label 27845: @2103851
     /* 2103851 */   GIM_Try, /*On fail goto*//*Label 27846*/ GIMT_Encode4(2103942), // Rule ID 16871 //
     /* 2103856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2103859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2103867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2103870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2103873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2103879 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2103882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2103886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2103894 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2103898 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103902 */     // MIs[0] round
     /* 2103902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103905 */     // MIs[0] policy
     /* 2103905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103908 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2103915 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11195:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2103915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M2_E64_MASK),
     /* 2103918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2103920 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2103922 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2103924 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2103926 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2103928 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2103930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2103935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2103938 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2103940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2103941 */     // GIR_Coverage, 16871,
     /* 2103941 */     GIR_EraseRootFromParent_Done,
     /* 2103942 */   // Label 27846: @2103942
     /* 2103942 */   GIM_Try, /*On fail goto*//*Label 27847*/ GIMT_Encode4(2104033), // Rule ID 16874 //
     /* 2103947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2103950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2103955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2103958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2103961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2103964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2103967 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2103970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2103973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2103977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2103985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2103989 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2103993 */     // MIs[0] round
     /* 2103993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2103996 */     // MIs[0] policy
     /* 2103996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2103999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104006 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2104009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104011 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104015 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104017 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104019 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104021 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104029 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104031 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104032 */     // GIR_Coverage, 16874,
     /* 2104032 */     GIR_EraseRootFromParent_Done,
     /* 2104033 */   // Label 27847: @2104033
     /* 2104033 */   GIM_Try, /*On fail goto*//*Label 27848*/ GIMT_Encode4(2104124), // Rule ID 16875 //
     /* 2104038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2104046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2104049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2104052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2104055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104061 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2104080 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104084 */     // MIs[0] round
     /* 2104084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104087 */     // MIs[0] policy
     /* 2104087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104097 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11195:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M4_E64_MASK),
     /* 2104100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104102 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104104 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104106 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104108 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104110 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104120 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104123 */     // GIR_Coverage, 16875,
     /* 2104123 */     GIR_EraseRootFromParent_Done,
     /* 2104124 */   // Label 27848: @2104124
     /* 2104124 */   GIM_Try, /*On fail goto*//*Label 27849*/ GIMT_Encode4(2104215), // Rule ID 16878 //
     /* 2104129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2104132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2104137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104152 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2104171 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104175 */     // MIs[0] round
     /* 2104175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104178 */     // MIs[0] policy
     /* 2104178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104181 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104188 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2104191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104193 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104197 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104199 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104201 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104211 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104214 */     // GIR_Coverage, 16878,
     /* 2104214 */     GIR_EraseRootFromParent_Done,
     /* 2104215 */   // Label 27849: @2104215
     /* 2104215 */   GIM_Try, /*On fail goto*//*Label 27850*/ GIMT_Encode4(2104306), // Rule ID 16879 //
     /* 2104220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2104223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrsub_mask),
     /* 2104228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2104231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2104234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2104237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2104240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104243 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2104250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2104258 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2104262 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104266 */     // MIs[0] round
     /* 2104266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104269 */     // MIs[0] policy
     /* 2104269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104272 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104279 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11195:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRSUB_VFPR64_M8_E64_MASK),
     /* 2104282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104284 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104288 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104290 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104292 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104294 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2104302 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104305 */     // GIR_Coverage, 16879,
     /* 2104305 */     GIR_EraseRootFromParent_Done,
     /* 2104306 */   // Label 27850: @2104306
     /* 2104306 */   GIM_Try, /*On fail goto*//*Label 27851*/ GIMT_Encode4(2104397), // Rule ID 16882 //
     /* 2104311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2104314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2104322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2104325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2104331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104334 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104353 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104357 */     // MIs[0] round
     /* 2104357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104360 */     // MIs[0] policy
     /* 2104360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104370 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2104373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104375 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104377 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104379 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104381 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104383 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104393 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104396 */     // GIR_Coverage, 16882,
     /* 2104396 */     GIR_EraseRootFromParent_Done,
     /* 2104397 */   // Label 27851: @2104397
     /* 2104397 */   GIM_Try, /*On fail goto*//*Label 27852*/ GIMT_Encode4(2104488), // Rule ID 16883 //
     /* 2104402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2104405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2104413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2104416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2104419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2104422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2104425 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104444 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104448 */     // MIs[0] round
     /* 2104448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104451 */     // MIs[0] policy
     /* 2104451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104461 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF4_E16_MASK),
     /* 2104464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104466 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104470 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104472 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104474 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104484 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104487 */     // GIR_Coverage, 16883,
     /* 2104487 */     GIR_EraseRootFromParent_Done,
     /* 2104488 */   // Label 27852: @2104488
     /* 2104488 */   GIM_Try, /*On fail goto*//*Label 27853*/ GIMT_Encode4(2104579), // Rule ID 16886 //
     /* 2104493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2104496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2104504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2104507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2104513 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104516 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104535 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104539 */     // MIs[0] round
     /* 2104539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104542 */     // MIs[0] policy
     /* 2104542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104552 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2104555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104557 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104561 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104563 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104565 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104575 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104578 */     // GIR_Coverage, 16886,
     /* 2104578 */     GIR_EraseRootFromParent_Done,
     /* 2104579 */   // Label 27853: @2104579
     /* 2104579 */   GIM_Try, /*On fail goto*//*Label 27854*/ GIMT_Encode4(2104670), // Rule ID 16887 //
     /* 2104584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2104587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2104595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2104598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2104601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2104604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2104607 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2104614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104626 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104630 */     // MIs[0] round
     /* 2104630 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104633 */     // MIs[0] policy
     /* 2104633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104643 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E16_MASK),
     /* 2104646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104648 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104652 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104654 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104656 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104666 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104669 */     // GIR_Coverage, 16887,
     /* 2104669 */     GIR_EraseRootFromParent_Done,
     /* 2104670 */   // Label 27854: @2104670
     /* 2104670 */   GIM_Try, /*On fail goto*//*Label 27855*/ GIMT_Encode4(2104761), // Rule ID 16890 //
     /* 2104675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2104678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2104692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2104695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104713 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104717 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104721 */     // MIs[0] round
     /* 2104721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104724 */     // MIs[0] policy
     /* 2104724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104727 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104734 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2104737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104739 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104741 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104743 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104745 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104747 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104757 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104760 */     // GIR_Coverage, 16890,
     /* 2104760 */     GIR_EraseRootFromParent_Done,
     /* 2104761 */   // Label 27855: @2104761
     /* 2104761 */   GIM_Try, /*On fail goto*//*Label 27856*/ GIMT_Encode4(2104852), // Rule ID 16891 //
     /* 2104766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2104769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2104777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2104780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2104783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2104786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2104789 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2104796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104804 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2104808 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104812 */     // MIs[0] round
     /* 2104812 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104815 */     // MIs[0] policy
     /* 2104815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2104825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E16_MASK),
     /* 2104828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104830 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104832 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104834 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104836 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104838 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104848 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104851 */     // GIR_Coverage, 16891,
     /* 2104851 */     GIR_EraseRootFromParent_Done,
     /* 2104852 */   // Label 27856: @2104852
     /* 2104852 */   GIM_Try, /*On fail goto*//*Label 27857*/ GIMT_Encode4(2104943), // Rule ID 16894 //
     /* 2104857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2104860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2104874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2104877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104880 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2104883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104895 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104899 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104903 */     // MIs[0] round
     /* 2104903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104906 */     // MIs[0] policy
     /* 2104906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2104909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2104916 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2104916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2104919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2104921 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2104923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2104925 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2104927 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2104929 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2104931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2104936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2104939 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2104941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2104942 */     // GIR_Coverage, 16894,
     /* 2104942 */     GIR_EraseRootFromParent_Done,
     /* 2104943 */   // Label 27857: @2104943
     /* 2104943 */   GIM_Try, /*On fail goto*//*Label 27858*/ GIMT_Encode4(2105034), // Rule ID 16895 //
     /* 2104948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2104951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2104956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2104959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2104962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2104965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2104968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2104971 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2104974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2104978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2104982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104986 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2104990 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2104994 */     // MIs[0] round
     /* 2104994 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2104997 */     // MIs[0] policy
     /* 2104997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105007 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E16_MASK),
     /* 2105010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105012 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105014 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105016 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105018 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105020 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105030 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105033 */     // GIR_Coverage, 16895,
     /* 2105033 */     GIR_EraseRootFromParent_Done,
     /* 2105034 */   // Label 27858: @2105034
     /* 2105034 */   GIM_Try, /*On fail goto*//*Label 27859*/ GIMT_Encode4(2105125), // Rule ID 16898 //
     /* 2105039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2105042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2105050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2105053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2105056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2105059 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105062 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105077 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105081 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105085 */     // MIs[0] round
     /* 2105085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105088 */     // MIs[0] policy
     /* 2105088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105098 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2105101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105103 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105105 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105107 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105109 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105111 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105121 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105124 */     // GIR_Coverage, 16898,
     /* 2105124 */     GIR_EraseRootFromParent_Done,
     /* 2105125 */   // Label 27859: @2105125
     /* 2105125 */   GIM_Try, /*On fail goto*//*Label 27860*/ GIMT_Encode4(2105216), // Rule ID 16899 //
     /* 2105130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2105133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2105141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2105144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2105147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2105150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2105153 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105172 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105176 */     // MIs[0] round
     /* 2105176 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105179 */     // MIs[0] policy
     /* 2105179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105182 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105189 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E16_MASK),
     /* 2105192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105194 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105196 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105198 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105200 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105202 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2105212 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105215 */     // GIR_Coverage, 16899,
     /* 2105215 */     GIR_EraseRootFromParent_Done,
     /* 2105216 */   // Label 27860: @2105216
     /* 2105216 */   GIM_Try, /*On fail goto*//*Label 27861*/ GIMT_Encode4(2105307), // Rule ID 16902 //
     /* 2105221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2105224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2105241 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105244 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105259 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105263 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105267 */     // MIs[0] round
     /* 2105267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105270 */     // MIs[0] policy
     /* 2105270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105273 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105280 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2105283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105285 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105289 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105291 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105293 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105303 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105306 */     // GIR_Coverage, 16902,
     /* 2105306 */     GIR_EraseRootFromParent_Done,
     /* 2105307 */   // Label 27861: @2105307
     /* 2105307 */   GIM_Try, /*On fail goto*//*Label 27862*/ GIMT_Encode4(2105398), // Rule ID 16903 //
     /* 2105312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2105315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2105323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2105326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2105329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2105332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105335 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105354 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105358 */     // MIs[0] round
     /* 2105358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105361 */     // MIs[0] policy
     /* 2105361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105364 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105371 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_MF2_E32_MASK),
     /* 2105374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105376 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105380 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105382 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105384 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105394 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105397 */     // GIR_Coverage, 16903,
     /* 2105397 */     GIR_EraseRootFromParent_Done,
     /* 2105398 */   // Label 27862: @2105398
     /* 2105398 */   GIM_Try, /*On fail goto*//*Label 27863*/ GIMT_Encode4(2105489), // Rule ID 16906 //
     /* 2105403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2105406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2105414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2105417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2105423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105426 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105445 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105449 */     // MIs[0] round
     /* 2105449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105452 */     // MIs[0] policy
     /* 2105452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105455 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105462 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2105465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105467 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105469 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105471 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105473 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105475 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105477 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105485 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105488 */     // GIR_Coverage, 16906,
     /* 2105488 */     GIR_EraseRootFromParent_Done,
     /* 2105489 */   // Label 27863: @2105489
     /* 2105489 */   GIM_Try, /*On fail goto*//*Label 27864*/ GIMT_Encode4(2105580), // Rule ID 16907 //
     /* 2105494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2105497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2105505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2105508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2105511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2105514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2105517 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2105524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105532 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105536 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105540 */     // MIs[0] round
     /* 2105540 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105543 */     // MIs[0] policy
     /* 2105543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105546 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105553 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M1_E32_MASK),
     /* 2105556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105558 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105562 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105564 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105566 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105576 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105579 */     // GIR_Coverage, 16907,
     /* 2105579 */     GIR_EraseRootFromParent_Done,
     /* 2105580 */   // Label 27864: @2105580
     /* 2105580 */   GIM_Try, /*On fail goto*//*Label 27865*/ GIMT_Encode4(2105671), // Rule ID 16910 //
     /* 2105585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2105588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2105596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2105599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2105602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2105605 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105608 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105623 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105627 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105631 */     // MIs[0] round
     /* 2105631 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105634 */     // MIs[0] policy
     /* 2105634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105644 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2105647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105649 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105653 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105655 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105657 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105667 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105670 */     // GIR_Coverage, 16910,
     /* 2105670 */     GIR_EraseRootFromParent_Done,
     /* 2105671 */   // Label 27865: @2105671
     /* 2105671 */   GIM_Try, /*On fail goto*//*Label 27866*/ GIMT_Encode4(2105762), // Rule ID 16911 //
     /* 2105676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2105679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2105687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2105690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2105693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2105696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2105699 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2105706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105714 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2105718 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105722 */     // MIs[0] round
     /* 2105722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105725 */     // MIs[0] policy
     /* 2105725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105735 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M2_E32_MASK),
     /* 2105738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105740 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105744 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105746 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105748 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105758 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105761 */     // GIR_Coverage, 16911,
     /* 2105761 */     GIR_EraseRootFromParent_Done,
     /* 2105762 */   // Label 27866: @2105762
     /* 2105762 */   GIM_Try, /*On fail goto*//*Label 27867*/ GIMT_Encode4(2105853), // Rule ID 16914 //
     /* 2105767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2105770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2105784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2105787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105790 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105805 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105809 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105813 */     // MIs[0] round
     /* 2105813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105816 */     // MIs[0] policy
     /* 2105816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105826 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2105826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2105829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105831 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105833 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105835 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105837 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105839 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105849 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105852 */     // GIR_Coverage, 16914,
     /* 2105852 */     GIR_EraseRootFromParent_Done,
     /* 2105853 */   // Label 27867: @2105853
     /* 2105853 */   GIM_Try, /*On fail goto*//*Label 27868*/ GIMT_Encode4(2105944), // Rule ID 16915 //
     /* 2105858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2105861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2105869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2105872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2105875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2105878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2105881 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2105884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2105888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2105892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2105900 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105904 */     // MIs[0] round
     /* 2105904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105907 */     // MIs[0] policy
     /* 2105907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2105910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2105917 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2105917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VV_M4_E32_MASK),
     /* 2105920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2105922 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2105924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2105926 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2105928 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2105930 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2105932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2105937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2105940 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2105942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2105943 */     // GIR_Coverage, 16915,
     /* 2105943 */     GIR_EraseRootFromParent_Done,
     /* 2105944 */   // Label 27868: @2105944
     /* 2105944 */   GIM_Try, /*On fail goto*//*Label 27869*/ GIMT_Encode4(2106035), // Rule ID 16918 //
     /* 2105949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2105952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2105957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2105960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2105963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2105966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2105969 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2105972 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2105975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2105979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2105987 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2105991 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2105995 */     // MIs[0] round
     /* 2105995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2105998 */     // MIs[0] policy
     /* 2105998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106001 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106008 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2106011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106013 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106017 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106019 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106021 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106031 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106034 */     // GIR_Coverage, 16918,
     /* 2106034 */     GIR_EraseRootFromParent_Done,
     /* 2106035 */   // Label 27869: @2106035
     /* 2106035 */   GIM_Try, /*On fail goto*//*Label 27870*/ GIMT_Encode4(2106126), // Rule ID 16919 //
     /* 2106040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2106043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2106051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2106054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2106057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106060 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106063 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106082 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106086 */     // MIs[0] round
     /* 2106086 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106089 */     // MIs[0] policy
     /* 2106089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106099 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF4_E16_MASK),
     /* 2106102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106104 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106106 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106108 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106110 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106112 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106122 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106125 */     // GIR_Coverage, 16919,
     /* 2106125 */     GIR_EraseRootFromParent_Done,
     /* 2106126 */   // Label 27870: @2106126
     /* 2106126 */   GIM_Try, /*On fail goto*//*Label 27871*/ GIMT_Encode4(2106217), // Rule ID 16922 //
     /* 2106131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2106134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2106148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106154 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106169 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106173 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106177 */     // MIs[0] round
     /* 2106177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106180 */     // MIs[0] policy
     /* 2106180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106190 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2106193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106195 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106197 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106199 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106201 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106203 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106213 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106216 */     // GIR_Coverage, 16922,
     /* 2106216 */     GIR_EraseRootFromParent_Done,
     /* 2106217 */   // Label 27871: @2106217
     /* 2106217 */   GIM_Try, /*On fail goto*//*Label 27872*/ GIMT_Encode4(2106308), // Rule ID 16923 //
     /* 2106222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2106225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2106233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2106236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2106239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106242 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2106245 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106264 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106268 */     // MIs[0] round
     /* 2106268 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106271 */     // MIs[0] policy
     /* 2106271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106281 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11211:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_MF2_E16_MASK),
     /* 2106284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106286 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106288 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106290 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106292 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106294 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106304 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106307 */     // GIR_Coverage, 16923,
     /* 2106307 */     GIR_EraseRootFromParent_Done,
     /* 2106308 */   // Label 27872: @2106308
     /* 2106308 */   GIM_Try, /*On fail goto*//*Label 27873*/ GIMT_Encode4(2106399), // Rule ID 16926 //
     /* 2106313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2106316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106336 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106351 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106355 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106359 */     // MIs[0] round
     /* 2106359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106362 */     // MIs[0] policy
     /* 2106362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106372 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2106375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106377 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106381 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106383 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106385 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106387 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106395 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106398 */     // GIR_Coverage, 16926,
     /* 2106398 */     GIR_EraseRootFromParent_Done,
     /* 2106399 */   // Label 27873: @2106399
     /* 2106399 */   GIM_Try, /*On fail goto*//*Label 27874*/ GIMT_Encode4(2106490), // Rule ID 16927 //
     /* 2106404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2106407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2106415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2106418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2106421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106424 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2106427 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2106434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106442 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106446 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106450 */     // MIs[0] round
     /* 2106450 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106453 */     // MIs[0] policy
     /* 2106453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106456 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106463 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M1_E16_MASK),
     /* 2106466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106468 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106472 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106474 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106476 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106486 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106489 */     // GIR_Coverage, 16927,
     /* 2106489 */     GIR_EraseRootFromParent_Done,
     /* 2106490 */   // Label 27874: @2106490
     /* 2106490 */   GIM_Try, /*On fail goto*//*Label 27875*/ GIMT_Encode4(2106581), // Rule ID 16930 //
     /* 2106495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2106498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106518 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106537 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106541 */     // MIs[0] round
     /* 2106541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106544 */     // MIs[0] policy
     /* 2106544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106547 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106554 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2106557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106559 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106561 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106563 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106565 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106567 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106577 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106580 */     // GIR_Coverage, 16930,
     /* 2106580 */     GIR_EraseRootFromParent_Done,
     /* 2106581 */   // Label 27875: @2106581
     /* 2106581 */   GIM_Try, /*On fail goto*//*Label 27876*/ GIMT_Encode4(2106672), // Rule ID 16931 //
     /* 2106586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2106589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2106597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2106600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2106603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106606 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2106609 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2106616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2106624 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106628 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106632 */     // MIs[0] round
     /* 2106632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106635 */     // MIs[0] policy
     /* 2106635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106645 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M2_E16_MASK),
     /* 2106648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106650 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106652 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106654 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106656 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106658 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106668 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106671 */     // GIR_Coverage, 16931,
     /* 2106671 */     GIR_EraseRootFromParent_Done,
     /* 2106672 */   // Label 27876: @2106672
     /* 2106672 */   GIM_Try, /*On fail goto*//*Label 27877*/ GIMT_Encode4(2106763), // Rule ID 16934 //
     /* 2106677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2106680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106694 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106697 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106700 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106715 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106719 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106723 */     // MIs[0] round
     /* 2106723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106726 */     // MIs[0] policy
     /* 2106726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106736 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2106739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106741 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106745 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106747 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106749 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106759 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106762 */     // GIR_Coverage, 16934,
     /* 2106762 */     GIR_EraseRootFromParent_Done,
     /* 2106763 */   // Label 27877: @2106763
     /* 2106763 */   GIM_Try, /*On fail goto*//*Label 27878*/ GIMT_Encode4(2106854), // Rule ID 16935 //
     /* 2106768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2106771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2106779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2106782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2106785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2106788 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2106791 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2106798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2106802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2106806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2106810 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106814 */     // MIs[0] round
     /* 2106814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106817 */     // MIs[0] policy
     /* 2106817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106827 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2106827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR16_M4_E16_MASK),
     /* 2106830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106832 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106834 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106836 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106838 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106840 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2106850 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106853 */     // GIR_Coverage, 16935,
     /* 2106853 */     GIR_EraseRootFromParent_Done,
     /* 2106854 */   // Label 27878: @2106854
     /* 2106854 */   GIM_Try, /*On fail goto*//*Label 27879*/ GIMT_Encode4(2106945), // Rule ID 16938 //
     /* 2106859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2106862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106879 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106882 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2106885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106905 */     // MIs[0] round
     /* 2106905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106908 */     // MIs[0] policy
     /* 2106908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2106911 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2106918 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2106918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2106921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2106923 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2106925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2106927 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2106929 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2106931 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2106933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2106938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2106941 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2106943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2106944 */     // GIR_Coverage, 16938,
     /* 2106944 */     GIR_EraseRootFromParent_Done,
     /* 2106945 */   // Label 27879: @2106945
     /* 2106945 */   GIM_Try, /*On fail goto*//*Label 27880*/ GIMT_Encode4(2107036), // Rule ID 16939 //
     /* 2106950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2106953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2106958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2106961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2106964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2106967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2106970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2106973 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2106976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2106980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2106988 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2106992 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2106996 */     // MIs[0] round
     /* 2106996 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2106999 */     // MIs[0] policy
     /* 2106999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107009 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11211:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_MF2_E32_MASK),
     /* 2107012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107014 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107016 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107018 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107020 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107022 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107032 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107035 */     // GIR_Coverage, 16939,
     /* 2107035 */     GIR_EraseRootFromParent_Done,
     /* 2107036 */   // Label 27880: @2107036
     /* 2107036 */   GIM_Try, /*On fail goto*//*Label 27881*/ GIMT_Encode4(2107127), // Rule ID 16942 //
     /* 2107041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2107044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2107058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107061 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107064 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107079 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107083 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107087 */     // MIs[0] round
     /* 2107087 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107090 */     // MIs[0] policy
     /* 2107090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107100 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2107103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107105 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107109 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107111 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107113 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107123 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107126 */     // GIR_Coverage, 16942,
     /* 2107126 */     GIR_EraseRootFromParent_Done,
     /* 2107127 */   // Label 27881: @2107127
     /* 2107127 */   GIM_Try, /*On fail goto*//*Label 27882*/ GIMT_Encode4(2107218), // Rule ID 16943 //
     /* 2107132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2107135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2107143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2107146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2107149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107155 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107174 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107178 */     // MIs[0] round
     /* 2107178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107181 */     // MIs[0] policy
     /* 2107181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107191 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11211:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M1_E32_MASK),
     /* 2107194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107196 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107198 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107200 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107202 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107204 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107214 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107217 */     // GIR_Coverage, 16943,
     /* 2107217 */     GIR_EraseRootFromParent_Done,
     /* 2107218 */   // Label 27882: @2107218
     /* 2107218 */   GIM_Try, /*On fail goto*//*Label 27883*/ GIMT_Encode4(2107309), // Rule ID 16946 //
     /* 2107223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2107226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107246 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107265 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107269 */     // MIs[0] round
     /* 2107269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107272 */     // MIs[0] policy
     /* 2107272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107275 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107282 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2107285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107287 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107289 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107291 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107293 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107295 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107297 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107305 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107308 */     // GIR_Coverage, 16946,
     /* 2107308 */     GIR_EraseRootFromParent_Done,
     /* 2107309 */   // Label 27883: @2107309
     /* 2107309 */   GIM_Try, /*On fail goto*//*Label 27884*/ GIMT_Encode4(2107400), // Rule ID 16947 //
     /* 2107314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2107317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2107325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2107328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2107331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107334 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107337 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2107344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107352 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107356 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107360 */     // MIs[0] round
     /* 2107360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107363 */     // MIs[0] policy
     /* 2107363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107366 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107373 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11211:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M2_E32_MASK),
     /* 2107376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107378 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107380 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107382 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107384 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107386 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107396 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107399 */     // GIR_Coverage, 16947,
     /* 2107399 */     GIR_EraseRootFromParent_Done,
     /* 2107400 */   // Label 27884: @2107400
     /* 2107400 */   GIM_Try, /*On fail goto*//*Label 27885*/ GIMT_Encode4(2107491), // Rule ID 16950 //
     /* 2107405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2107408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107425 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107428 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107447 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107451 */     // MIs[0] round
     /* 2107451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107454 */     // MIs[0] policy
     /* 2107454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107464 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2107467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107469 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107471 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107473 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107475 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107477 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107487 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107490 */     // GIR_Coverage, 16950,
     /* 2107490 */     GIR_EraseRootFromParent_Done,
     /* 2107491 */   // Label 27885: @2107491
     /* 2107491 */   GIM_Try, /*On fail goto*//*Label 27886*/ GIMT_Encode4(2107582), // Rule ID 16951 //
     /* 2107496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2107499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_mask),
     /* 2107504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2107507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2107510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2107513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2107516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2107519 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2107526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2107530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2107534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2107538 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107542 */     // MIs[0] round
     /* 2107542 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107545 */     // MIs[0] policy
     /* 2107545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107548 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107555 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11211:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_VFPR32_M4_E32_MASK),
     /* 2107558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107560 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107564 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107566 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107568 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2107578 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107581 */     // GIR_Coverage, 16951,
     /* 2107581 */     GIR_EraseRootFromParent_Done,
     /* 2107582 */   // Label 27886: @2107582
     /* 2107582 */   GIM_Try, /*On fail goto*//*Label 27887*/ GIMT_Encode4(2107673), // Rule ID 16954 //
     /* 2107587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2107590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2107595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107607 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107625 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107629 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107633 */     // MIs[0] round
     /* 2107633 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107636 */     // MIs[0] policy
     /* 2107636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107639 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107646 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2107649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107651 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107655 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107657 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107659 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107669 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107672 */     // GIR_Coverage, 16954,
     /* 2107672 */     GIR_EraseRootFromParent_Done,
     /* 2107673 */   // Label 27887: @2107673
     /* 2107673 */   GIM_Try, /*On fail goto*//*Label 27888*/ GIMT_Encode4(2107764), // Rule ID 16955 //
     /* 2107678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2107681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2107686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2107689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2107692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2107695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2107698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2107701 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107716 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107720 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107724 */     // MIs[0] round
     /* 2107724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107727 */     // MIs[0] policy
     /* 2107727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107737 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF4_E16_MASK),
     /* 2107740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107742 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107746 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107748 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107750 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107752 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107760 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107763 */     // GIR_Coverage, 16955,
     /* 2107763 */     GIR_EraseRootFromParent_Done,
     /* 2107764 */   // Label 27888: @2107764
     /* 2107764 */   GIM_Try, /*On fail goto*//*Label 27889*/ GIMT_Encode4(2107855), // Rule ID 16958 //
     /* 2107769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2107772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2107777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2107780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2107783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107792 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107807 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107811 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107815 */     // MIs[0] round
     /* 2107815 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107818 */     // MIs[0] policy
     /* 2107818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107828 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2107828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2107831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107833 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107837 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107839 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107841 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107851 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107854 */     // GIR_Coverage, 16958,
     /* 2107854 */     GIR_EraseRootFromParent_Done,
     /* 2107855 */   // Label 27889: @2107855
     /* 2107855 */   GIM_Try, /*On fail goto*//*Label 27890*/ GIMT_Encode4(2107946), // Rule ID 16959 //
     /* 2107860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2107863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2107868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2107871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2107874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2107877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2107880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2107883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2107886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2107890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107902 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107906 */     // MIs[0] round
     /* 2107906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2107909 */     // MIs[0] policy
     /* 2107909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2107912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2107919 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2107919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E16_MASK),
     /* 2107922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2107924 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2107926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2107928 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2107930 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2107932 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2107934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2107939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2107942 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2107944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2107945 */     // GIR_Coverage, 16959,
     /* 2107945 */     GIR_EraseRootFromParent_Done,
     /* 2107946 */   // Label 27890: @2107946
     /* 2107946 */   GIM_Try, /*On fail goto*//*Label 27891*/ GIMT_Encode4(2108037), // Rule ID 16962 //
     /* 2107951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2107954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2107959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2107962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2107965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2107968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2107971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2107974 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2107977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2107981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2107985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2107993 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2107997 */     // MIs[0] round
     /* 2107997 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108000 */     // MIs[0] policy
     /* 2108000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108003 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108010 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2108013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108015 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108017 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108019 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108021 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108023 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108033 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108036 */     // GIR_Coverage, 16962,
     /* 2108036 */     GIR_EraseRootFromParent_Done,
     /* 2108037 */   // Label 27891: @2108037
     /* 2108037 */   GIM_Try, /*On fail goto*//*Label 27892*/ GIMT_Encode4(2108128), // Rule ID 16963 //
     /* 2108042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2108045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2108053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2108056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2108059 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2108062 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108065 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108076 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108080 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108084 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108088 */     // MIs[0] round
     /* 2108088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108091 */     // MIs[0] policy
     /* 2108091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108101 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E16_MASK),
     /* 2108104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108106 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108110 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108112 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108114 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108124 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108127 */     // GIR_Coverage, 16963,
     /* 2108127 */     GIR_EraseRootFromParent_Done,
     /* 2108128 */   // Label 27892: @2108128
     /* 2108128 */   GIM_Try, /*On fail goto*//*Label 27893*/ GIMT_Encode4(2108219), // Rule ID 16966 //
     /* 2108133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2108136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2108144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2108147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108153 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108156 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108171 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108175 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108179 */     // MIs[0] round
     /* 2108179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108182 */     // MIs[0] policy
     /* 2108182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108185 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108192 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2108195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108197 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108199 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108201 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108203 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108205 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108215 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108218 */     // GIR_Coverage, 16966,
     /* 2108218 */     GIR_EraseRootFromParent_Done,
     /* 2108219 */   // Label 27893: @2108219
     /* 2108219 */   GIM_Try, /*On fail goto*//*Label 27894*/ GIMT_Encode4(2108310), // Rule ID 16967 //
     /* 2108224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2108227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2108235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2108238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2108241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2108244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2108247 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108262 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108266 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108270 */     // MIs[0] round
     /* 2108270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108273 */     // MIs[0] policy
     /* 2108273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108283 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E16_MASK),
     /* 2108286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108288 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108290 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108292 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108294 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108296 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108306 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108309 */     // GIR_Coverage, 16967,
     /* 2108309 */     GIR_EraseRootFromParent_Done,
     /* 2108310 */   // Label 27894: @2108310
     /* 2108310 */   GIM_Try, /*On fail goto*//*Label 27895*/ GIMT_Encode4(2108401), // Rule ID 16970 //
     /* 2108315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2108318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108323 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2108326 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2108329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108338 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108353 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108357 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108361 */     // MIs[0] round
     /* 2108361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108364 */     // MIs[0] policy
     /* 2108364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108374 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2108377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108379 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108381 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108383 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108385 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108387 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108397 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108400 */     // GIR_Coverage, 16970,
     /* 2108400 */     GIR_EraseRootFromParent_Done,
     /* 2108401 */   // Label 27895: @2108401
     /* 2108401 */   GIM_Try, /*On fail goto*//*Label 27896*/ GIMT_Encode4(2108492), // Rule ID 16971 //
     /* 2108406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2108409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2108417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2108420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2108423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2108426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2108429 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2108436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2108440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108444 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108448 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108452 */     // MIs[0] round
     /* 2108452 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108455 */     // MIs[0] policy
     /* 2108455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108458 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108465 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E16_MASK),
     /* 2108468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108470 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108472 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108474 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108476 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108478 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2108488 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108491 */     // GIR_Coverage, 16971,
     /* 2108491 */     GIR_EraseRootFromParent_Done,
     /* 2108492 */   // Label 27896: @2108492
     /* 2108492 */   GIM_Try, /*On fail goto*//*Label 27897*/ GIMT_Encode4(2108583), // Rule ID 16974 //
     /* 2108497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2108500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108535 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108539 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108543 */     // MIs[0] round
     /* 2108543 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108546 */     // MIs[0] policy
     /* 2108546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108556 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2108559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108561 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108565 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108567 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108569 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108579 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108581 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108582 */     // GIR_Coverage, 16974,
     /* 2108582 */     GIR_EraseRootFromParent_Done,
     /* 2108583 */   // Label 27897: @2108583
     /* 2108583 */   GIM_Try, /*On fail goto*//*Label 27898*/ GIMT_Encode4(2108674), // Rule ID 16975 //
     /* 2108588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2108591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2108599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2108602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2108605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2108608 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2108611 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2108618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108626 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108630 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108634 */     // MIs[0] round
     /* 2108634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108637 */     // MIs[0] policy
     /* 2108637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108640 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108647 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_MF2_E32_MASK),
     /* 2108650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108652 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108656 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108658 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108660 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108670 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108673 */     // GIR_Coverage, 16975,
     /* 2108673 */     GIR_EraseRootFromParent_Done,
     /* 2108674 */   // Label 27898: @2108674
     /* 2108674 */   GIM_Try, /*On fail goto*//*Label 27899*/ GIMT_Encode4(2108765), // Rule ID 16978 //
     /* 2108679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2108682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2108690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2108693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108702 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108721 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108725 */     // MIs[0] round
     /* 2108725 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108728 */     // MIs[0] policy
     /* 2108728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108738 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2108741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108743 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108747 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108749 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108751 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108761 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108764 */     // GIR_Coverage, 16978,
     /* 2108764 */     GIR_EraseRootFromParent_Done,
     /* 2108765 */   // Label 27899: @2108765
     /* 2108765 */   GIM_Try, /*On fail goto*//*Label 27900*/ GIMT_Encode4(2108856), // Rule ID 16979 //
     /* 2108770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2108773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2108781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2108784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2108787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2108790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2108793 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2108800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2108812 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108816 */     // MIs[0] round
     /* 2108816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108819 */     // MIs[0] policy
     /* 2108819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108822 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108829 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2108829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M1_E32_MASK),
     /* 2108832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108834 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108838 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108840 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108842 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108852 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108855 */     // GIR_Coverage, 16979,
     /* 2108855 */     GIR_EraseRootFromParent_Done,
     /* 2108856 */   // Label 27900: @2108856
     /* 2108856 */   GIM_Try, /*On fail goto*//*Label 27901*/ GIMT_Encode4(2108947), // Rule ID 16982 //
     /* 2108861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2108864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2108878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2108881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108884 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2108887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108899 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108903 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108907 */     // MIs[0] round
     /* 2108907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2108910 */     // MIs[0] policy
     /* 2108910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2108913 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2108920 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2108920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2108923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2108925 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2108927 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2108929 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2108931 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2108933 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2108935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2108940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2108943 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2108945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2108946 */     // GIR_Coverage, 16982,
     /* 2108946 */     GIR_EraseRootFromParent_Done,
     /* 2108947 */   // Label 27901: @2108947
     /* 2108947 */   GIM_Try, /*On fail goto*//*Label 27902*/ GIMT_Encode4(2109038), // Rule ID 16983 //
     /* 2108952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2108955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2108960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2108963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2108966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2108969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2108972 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2108975 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2108978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2108982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2108986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108990 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2108994 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2108998 */     // MIs[0] round
     /* 2108998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109001 */     // MIs[0] policy
     /* 2109001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109011 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M2_E32_MASK),
     /* 2109014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109016 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109018 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109020 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109022 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109024 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109026 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109034 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109037 */     // GIR_Coverage, 16983,
     /* 2109037 */     GIR_EraseRootFromParent_Done,
     /* 2109038 */   // Label 27902: @2109038
     /* 2109038 */   GIM_Try, /*On fail goto*//*Label 27903*/ GIMT_Encode4(2109129), // Rule ID 16986 //
     /* 2109043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2109046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2109054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2109057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109063 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109066 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109081 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109085 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109089 */     // MIs[0] round
     /* 2109089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109092 */     // MIs[0] policy
     /* 2109092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109102 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2109105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109107 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109111 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109113 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109115 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109125 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109128 */     // GIR_Coverage, 16986,
     /* 2109128 */     GIR_EraseRootFromParent_Done,
     /* 2109129 */   // Label 27903: @2109129
     /* 2109129 */   GIM_Try, /*On fail goto*//*Label 27904*/ GIMT_Encode4(2109220), // Rule ID 16987 //
     /* 2109134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2109137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2109145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2109148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2109151 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2109154 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109157 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109172 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109176 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109180 */     // MIs[0] round
     /* 2109180 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109183 */     // MIs[0] policy
     /* 2109183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109193 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VV_M4_E32_MASK),
     /* 2109196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109198 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109200 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109202 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109204 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109206 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2109216 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109219 */     // GIR_Coverage, 16987,
     /* 2109219 */     GIR_EraseRootFromParent_Done,
     /* 2109220 */   // Label 27904: @2109220
     /* 2109220 */   GIM_Try, /*On fail goto*//*Label 27905*/ GIMT_Encode4(2109311), // Rule ID 16990 //
     /* 2109225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2109236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2109239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2109242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109245 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109248 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109271 */     // MIs[0] round
     /* 2109271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109274 */     // MIs[0] policy
     /* 2109274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109277 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109284 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2109287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109289 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109291 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109293 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109295 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109297 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109307 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109310 */     // GIR_Coverage, 16990,
     /* 2109310 */     GIR_EraseRootFromParent_Done,
     /* 2109311 */   // Label 27905: @2109311
     /* 2109311 */   GIM_Try, /*On fail goto*//*Label 27906*/ GIMT_Encode4(2109402), // Rule ID 16991 //
     /* 2109316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2109327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2109330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2109333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2109339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109354 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109358 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109362 */     // MIs[0] round
     /* 2109362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109365 */     // MIs[0] policy
     /* 2109365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109368 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109375 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF4_E16_MASK),
     /* 2109378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109380 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109384 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109386 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109388 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109398 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109401 */     // GIR_Coverage, 16991,
     /* 2109401 */     GIR_EraseRootFromParent_Done,
     /* 2109402 */   // Label 27906: @2109402
     /* 2109402 */   GIM_Try, /*On fail goto*//*Label 27907*/ GIMT_Encode4(2109493), // Rule ID 16994 //
     /* 2109407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2109418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2109421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2109424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109430 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109449 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109453 */     // MIs[0] round
     /* 2109453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109456 */     // MIs[0] policy
     /* 2109456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109466 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2109469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109471 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109473 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109475 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109477 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109479 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109481 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109489 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109492 */     // GIR_Coverage, 16994,
     /* 2109492 */     GIR_EraseRootFromParent_Done,
     /* 2109493 */   // Label 27907: @2109493
     /* 2109493 */   GIM_Try, /*On fail goto*//*Label 27908*/ GIMT_Encode4(2109584), // Rule ID 16995 //
     /* 2109498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2109509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2109512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2109515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2109521 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2109528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109536 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109540 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109544 */     // MIs[0] round
     /* 2109544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109547 */     // MIs[0] policy
     /* 2109547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109557 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11247:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_MF2_E16_MASK),
     /* 2109560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109562 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109564 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109566 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109568 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109570 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109580 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109583 */     // GIR_Coverage, 16995,
     /* 2109583 */     GIR_EraseRootFromParent_Done,
     /* 2109584 */   // Label 27908: @2109584
     /* 2109584 */   GIM_Try, /*On fail goto*//*Label 27909*/ GIMT_Encode4(2109675), // Rule ID 16998 //
     /* 2109589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109609 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109612 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109627 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109631 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109635 */     // MIs[0] round
     /* 2109635 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109638 */     // MIs[0] policy
     /* 2109638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109641 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2109651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109653 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109657 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109659 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109661 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109671 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109674 */     // GIR_Coverage, 16998,
     /* 2109674 */     GIR_EraseRootFromParent_Done,
     /* 2109675 */   // Label 27909: @2109675
     /* 2109675 */   GIM_Try, /*On fail goto*//*Label 27910*/ GIMT_Encode4(2109766), // Rule ID 16999 //
     /* 2109680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2109691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2109694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2109697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2109703 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2109710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2109718 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109722 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109726 */     // MIs[0] round
     /* 2109726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109729 */     // MIs[0] policy
     /* 2109729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109739 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M1_E16_MASK),
     /* 2109742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109744 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109748 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109750 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109752 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109762 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109765 */     // GIR_Coverage, 16999,
     /* 2109765 */     GIR_EraseRootFromParent_Done,
     /* 2109766 */   // Label 27910: @2109766
     /* 2109766 */   GIM_Try, /*On fail goto*//*Label 27911*/ GIMT_Encode4(2109857), // Rule ID 17002 //
     /* 2109771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109791 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109794 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109809 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109813 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109817 */     // MIs[0] round
     /* 2109817 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109820 */     // MIs[0] policy
     /* 2109820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109823 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109830 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2109830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2109833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109835 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109837 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109839 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109841 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109843 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109853 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109856 */     // GIR_Coverage, 17002,
     /* 2109856 */     GIR_EraseRootFromParent_Done,
     /* 2109857 */   // Label 27911: @2109857
     /* 2109857 */   GIM_Try, /*On fail goto*//*Label 27912*/ GIMT_Encode4(2109948), // Rule ID 17003 //
     /* 2109862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2109865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2109873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2109876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2109879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109882 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2109885 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2109888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2109892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2109900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109904 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109908 */     // MIs[0] round
     /* 2109908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2109911 */     // MIs[0] policy
     /* 2109911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2109914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2109921 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2109921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M2_E16_MASK),
     /* 2109924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2109926 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2109928 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2109930 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2109932 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2109934 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2109936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2109941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2109944 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2109946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2109947 */     // GIR_Coverage, 17003,
     /* 2109947 */     GIR_EraseRootFromParent_Done,
     /* 2109948 */   // Label 27912: @2109948
     /* 2109948 */   GIM_Try, /*On fail goto*//*Label 27913*/ GIMT_Encode4(2110039), // Rule ID 17006 //
     /* 2109953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2109956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2109961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2109964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2109967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2109970 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2109973 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2109976 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2109979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2109983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2109987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2109991 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2109995 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2109999 */     // MIs[0] round
     /* 2109999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110002 */     // MIs[0] policy
     /* 2110002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110012 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2110015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110017 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110019 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110021 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110023 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110025 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110035 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110038 */     // GIR_Coverage, 17006,
     /* 2110038 */     GIR_EraseRootFromParent_Done,
     /* 2110039 */   // Label 27913: @2110039
     /* 2110039 */   GIM_Try, /*On fail goto*//*Label 27914*/ GIMT_Encode4(2110130), // Rule ID 17007 //
     /* 2110044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2110055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2110058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2110061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2110064 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2110067 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110082 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2110086 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110090 */     // MIs[0] round
     /* 2110090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110093 */     // MIs[0] policy
     /* 2110093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110103 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR16_M4_E16_MASK),
     /* 2110106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110108 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110110 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110112 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110114 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110116 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110126 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110129 */     // GIR_Coverage, 17007,
     /* 2110129 */     GIR_EraseRootFromParent_Done,
     /* 2110130 */   // Label 27914: @2110130
     /* 2110130 */   GIM_Try, /*On fail goto*//*Label 27915*/ GIMT_Encode4(2110221), // Rule ID 17010 //
     /* 2110135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2110138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2110146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2110149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110158 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110177 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110181 */     // MIs[0] round
     /* 2110181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110184 */     // MIs[0] policy
     /* 2110184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110194 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2110197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110199 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110201 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110203 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110205 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110207 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110217 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110220 */     // GIR_Coverage, 17010,
     /* 2110220 */     GIR_EraseRootFromParent_Done,
     /* 2110221 */   // Label 27915: @2110221
     /* 2110221 */   GIM_Try, /*On fail goto*//*Label 27916*/ GIMT_Encode4(2110312), // Rule ID 17011 //
     /* 2110226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2110237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2110240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2110243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2110249 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110264 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110268 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110272 */     // MIs[0] round
     /* 2110272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110275 */     // MIs[0] policy
     /* 2110275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110285 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11247:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_MF2_E32_MASK),
     /* 2110288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110290 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110294 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110296 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110298 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110308 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110311 */     // GIR_Coverage, 17011,
     /* 2110311 */     GIR_EraseRootFromParent_Done,
     /* 2110312 */   // Label 27916: @2110312
     /* 2110312 */   GIM_Try, /*On fail goto*//*Label 27917*/ GIMT_Encode4(2110403), // Rule ID 17014 //
     /* 2110317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2110320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110340 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110359 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110363 */     // MIs[0] round
     /* 2110363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110366 */     // MIs[0] policy
     /* 2110366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110369 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110376 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2110379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110381 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110383 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110385 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110387 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110389 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110399 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110402 */     // GIR_Coverage, 17014,
     /* 2110402 */     GIR_EraseRootFromParent_Done,
     /* 2110403 */   // Label 27917: @2110403
     /* 2110403 */   GIM_Try, /*On fail goto*//*Label 27918*/ GIMT_Encode4(2110494), // Rule ID 17015 //
     /* 2110408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2110419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2110422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110431 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2110438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110446 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110450 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110454 */     // MIs[0] round
     /* 2110454 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110457 */     // MIs[0] policy
     /* 2110457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110467 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11247:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M1_E32_MASK),
     /* 2110470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110472 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110474 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110476 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110478 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110480 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110482 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110490 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110493 */     // GIR_Coverage, 17015,
     /* 2110493 */     GIR_EraseRootFromParent_Done,
     /* 2110494 */   // Label 27918: @2110494
     /* 2110494 */   GIM_Try, /*On fail goto*//*Label 27919*/ GIMT_Encode4(2110585), // Rule ID 17018 //
     /* 2110499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2110502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2110516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110537 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110541 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110545 */     // MIs[0] round
     /* 2110545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110548 */     // MIs[0] policy
     /* 2110548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110558 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2110561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110563 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110565 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110567 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110569 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110571 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110581 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110584 */     // GIR_Coverage, 17018,
     /* 2110584 */     GIR_EraseRootFromParent_Done,
     /* 2110585 */   // Label 27919: @2110585
     /* 2110585 */   GIM_Try, /*On fail goto*//*Label 27920*/ GIMT_Encode4(2110676), // Rule ID 17019 //
     /* 2110590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2110601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2110604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2110607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110610 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2110613 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2110620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2110628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110632 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110636 */     // MIs[0] round
     /* 2110636 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110639 */     // MIs[0] policy
     /* 2110639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110649 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11247:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M2_E32_MASK),
     /* 2110652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110654 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110656 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110658 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110660 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110662 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110672 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110675 */     // GIR_Coverage, 17019,
     /* 2110675 */     GIR_EraseRootFromParent_Done,
     /* 2110676 */   // Label 27920: @2110676
     /* 2110676 */   GIM_Try, /*On fail goto*//*Label 27921*/ GIMT_Encode4(2110767), // Rule ID 17022 //
     /* 2110681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2110684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110701 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110704 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110723 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110727 */     // MIs[0] round
     /* 2110727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110730 */     // MIs[0] policy
     /* 2110730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110740 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2110743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110745 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110747 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110749 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110751 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110753 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110763 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110766 */     // GIR_Coverage, 17022,
     /* 2110766 */     GIR_EraseRootFromParent_Done,
     /* 2110767 */   // Label 27921: @2110767
     /* 2110767 */   GIM_Try, /*On fail goto*//*Label 27922*/ GIMT_Encode4(2110858), // Rule ID 17023 //
     /* 2110772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2110775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_mask),
     /* 2110780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2110783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2110786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2110789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2110792 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2110795 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2110802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2110806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2110810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2110814 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110818 */     // MIs[0] round
     /* 2110818 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110821 */     // MIs[0] policy
     /* 2110821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110824 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110831 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11247:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2110831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_VFPR32_M4_E32_MASK),
     /* 2110834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110836 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110840 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110842 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110844 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2110854 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110857 */     // GIR_Coverage, 17023,
     /* 2110857 */     GIR_EraseRootFromParent_Done,
     /* 2110858 */   // Label 27922: @2110858
     /* 2110858 */   GIM_Try, /*On fail goto*//*Label 27923*/ GIMT_Encode4(2110949), // Rule ID 17032 //
     /* 2110863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2110866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2110871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2110883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110886 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2110889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110901 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110905 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2110909 */     // MIs[0] round
     /* 2110909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2110912 */     // MIs[0] policy
     /* 2110912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2110915 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2110922 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2110922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2110925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2110927 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2110929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2110931 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2110933 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2110935 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2110937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2110942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2110945 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2110947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2110948 */     // GIR_Coverage, 17032,
     /* 2110948 */     GIR_EraseRootFromParent_Done,
     /* 2110949 */   // Label 27923: @2110949
     /* 2110949 */   GIM_Try, /*On fail goto*//*Label 27924*/ GIMT_Encode4(2111040), // Rule ID 17033 //
     /* 2110954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2110957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2110962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2110965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2110968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2110971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2110974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2110977 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2110980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2110984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110992 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2110996 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111000 */     // MIs[0] round
     /* 2111000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111003 */     // MIs[0] policy
     /* 2111003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111013 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E16_MASK),
     /* 2111016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111018 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111020 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111022 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111024 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111026 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111036 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111039 */     // GIR_Coverage, 17033,
     /* 2111039 */     GIR_EraseRootFromParent_Done,
     /* 2111040 */   // Label 27924: @2111040
     /* 2111040 */   GIM_Try, /*On fail goto*//*Label 27925*/ GIMT_Encode4(2111131), // Rule ID 17042 //
     /* 2111045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2111048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2111065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111068 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111087 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111091 */     // MIs[0] round
     /* 2111091 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111094 */     // MIs[0] policy
     /* 2111094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111097 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111104 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2111107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111109 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111111 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111113 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111115 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111117 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111119 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111127 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111130 */     // GIR_Coverage, 17042,
     /* 2111130 */     GIR_EraseRootFromParent_Done,
     /* 2111131 */   // Label 27925: @2111131
     /* 2111131 */   GIM_Try, /*On fail goto*//*Label 27926*/ GIMT_Encode4(2111222), // Rule ID 17043 //
     /* 2111136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2111139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2111147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2111150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2111153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2111156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111159 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111174 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111178 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111182 */     // MIs[0] round
     /* 2111182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111185 */     // MIs[0] policy
     /* 2111185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111195 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E16_MASK),
     /* 2111198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111200 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111202 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111204 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111206 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111208 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111218 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111221 */     // GIR_Coverage, 17043,
     /* 2111221 */     GIR_EraseRootFromParent_Done,
     /* 2111222 */   // Label 27926: @2111222
     /* 2111222 */   GIM_Try, /*On fail goto*//*Label 27927*/ GIMT_Encode4(2111313), // Rule ID 17052 //
     /* 2111227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2111230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2111238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2111241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2111247 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111250 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111265 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111269 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111273 */     // MIs[0] round
     /* 2111273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111276 */     // MIs[0] policy
     /* 2111276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111286 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2111289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111291 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111293 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111295 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111297 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111299 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111309 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111312 */     // GIR_Coverage, 17052,
     /* 2111312 */     GIR_EraseRootFromParent_Done,
     /* 2111313 */   // Label 27927: @2111313
     /* 2111313 */   GIM_Try, /*On fail goto*//*Label 27928*/ GIMT_Encode4(2111404), // Rule ID 17053 //
     /* 2111318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2111321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2111329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2111332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2111335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2111338 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2111341 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111360 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111364 */     // MIs[0] round
     /* 2111364 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111367 */     // MIs[0] policy
     /* 2111367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111370 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111377 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E16_MASK),
     /* 2111380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111382 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111386 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111388 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111390 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111400 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111403 */     // GIR_Coverage, 17053,
     /* 2111403 */     GIR_EraseRootFromParent_Done,
     /* 2111404 */   // Label 27928: @2111404
     /* 2111404 */   GIM_Try, /*On fail goto*//*Label 27929*/ GIMT_Encode4(2111495), // Rule ID 17062 //
     /* 2111409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2111412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2111420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2111423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2111426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2111429 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111432 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111451 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111455 */     // MIs[0] round
     /* 2111455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111458 */     // MIs[0] policy
     /* 2111458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111461 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111468 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2111471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111473 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111477 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111479 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111481 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111491 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111494 */     // GIR_Coverage, 17062,
     /* 2111494 */     GIR_EraseRootFromParent_Done,
     /* 2111495 */   // Label 27929: @2111495
     /* 2111495 */   GIM_Try, /*On fail goto*//*Label 27930*/ GIMT_Encode4(2111586), // Rule ID 17063 //
     /* 2111500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2111503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2111511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2111514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2111517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2111520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2111523 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2111530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2111538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111542 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111546 */     // MIs[0] round
     /* 2111546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111549 */     // MIs[0] policy
     /* 2111549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111559 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E16_MASK),
     /* 2111562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111564 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111568 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111570 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111572 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2111582 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111585 */     // GIR_Coverage, 17063,
     /* 2111585 */     GIR_EraseRootFromParent_Done,
     /* 2111586 */   // Label 27930: @2111586
     /* 2111586 */   GIM_Try, /*On fail goto*//*Label 27931*/ GIMT_Encode4(2111677), // Rule ID 17072 //
     /* 2111591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2111611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111614 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111633 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111637 */     // MIs[0] round
     /* 2111637 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111640 */     // MIs[0] policy
     /* 2111640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111643 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111650 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2111653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111655 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111659 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111661 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111663 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111673 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111676 */     // GIR_Coverage, 17072,
     /* 2111676 */     GIR_EraseRootFromParent_Done,
     /* 2111677 */   // Label 27931: @2111677
     /* 2111677 */   GIM_Try, /*On fail goto*//*Label 27932*/ GIMT_Encode4(2111768), // Rule ID 17073 //
     /* 2111682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2111693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2111696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2111699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2111702 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2111705 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2111712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111720 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111724 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111728 */     // MIs[0] round
     /* 2111728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111731 */     // MIs[0] policy
     /* 2111731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111741 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_MF2_E32_MASK),
     /* 2111744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111746 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111748 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111750 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111752 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111754 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111756 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111764 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111767 */     // GIR_Coverage, 17073,
     /* 2111767 */     GIR_EraseRootFromParent_Done,
     /* 2111768 */   // Label 27932: @2111768
     /* 2111768 */   GIM_Try, /*On fail goto*//*Label 27933*/ GIMT_Encode4(2111859), // Rule ID 17082 //
     /* 2111773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2111784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2111787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2111790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2111793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111815 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111819 */     // MIs[0] round
     /* 2111819 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111822 */     // MIs[0] policy
     /* 2111822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111825 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2111832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2111835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111837 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111839 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111841 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111843 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111845 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111855 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111858 */     // GIR_Coverage, 17082,
     /* 2111858 */     GIR_EraseRootFromParent_Done,
     /* 2111859 */   // Label 27933: @2111859
     /* 2111859 */   GIM_Try, /*On fail goto*//*Label 27934*/ GIMT_Encode4(2111950), // Rule ID 17083 //
     /* 2111864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2111867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2111875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2111878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2111881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2111884 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2111887 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2111890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2111894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2111906 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2111910 */     // MIs[0] round
     /* 2111910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2111913 */     // MIs[0] policy
     /* 2111913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2111916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2111923 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2111923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M1_E32_MASK),
     /* 2111926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2111928 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2111930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2111932 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2111934 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2111936 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2111938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2111943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2111946 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2111948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2111949 */     // GIR_Coverage, 17083,
     /* 2111949 */     GIR_EraseRootFromParent_Done,
     /* 2111950 */   // Label 27934: @2111950
     /* 2111950 */   GIM_Try, /*On fail goto*//*Label 27935*/ GIMT_Encode4(2112041), // Rule ID 17092 //
     /* 2111955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2111958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2111963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2111966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2111969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2111972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2111975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2111978 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2111981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2111985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2111993 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2111997 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112001 */     // MIs[0] round
     /* 2112001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112004 */     // MIs[0] policy
     /* 2112004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112014 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2112017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112019 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112023 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112025 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112027 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112037 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112040 */     // GIR_Coverage, 17092,
     /* 2112040 */     GIR_EraseRootFromParent_Done,
     /* 2112041 */   // Label 27935: @2112041
     /* 2112041 */   GIM_Try, /*On fail goto*//*Label 27936*/ GIMT_Encode4(2112132), // Rule ID 17093 //
     /* 2112046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2112049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2112057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2112060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2112063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2112066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112069 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112088 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112092 */     // MIs[0] round
     /* 2112092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112095 */     // MIs[0] policy
     /* 2112095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112105 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M2_E32_MASK),
     /* 2112108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112110 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112114 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112116 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112118 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112128 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112131 */     // GIR_Coverage, 17093,
     /* 2112131 */     GIR_EraseRootFromParent_Done,
     /* 2112132 */   // Label 27936: @2112132
     /* 2112132 */   GIM_Try, /*On fail goto*//*Label 27937*/ GIMT_Encode4(2112223), // Rule ID 17102 //
     /* 2112137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2112140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2112157 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112160 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112175 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112179 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112183 */     // MIs[0] round
     /* 2112183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112186 */     // MIs[0] policy
     /* 2112186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112196 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2112199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112201 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112203 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112205 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112207 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112209 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112219 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112222 */     // GIR_Coverage, 17102,
     /* 2112222 */     GIR_EraseRootFromParent_Done,
     /* 2112223 */   // Label 27937: @2112223
     /* 2112223 */   GIM_Try, /*On fail goto*//*Label 27938*/ GIMT_Encode4(2112314), // Rule ID 17103 //
     /* 2112228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2112231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2112239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2112242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2112245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2112248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112251 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2112258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2112266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112270 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112274 */     // MIs[0] round
     /* 2112274 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112277 */     // MIs[0] policy
     /* 2112277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112280 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112287 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WV_M4_E32_MASK),
     /* 2112290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112292 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112294 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112296 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112298 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112300 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2112310 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112313 */     // GIR_Coverage, 17103,
     /* 2112313 */     GIR_EraseRootFromParent_Done,
     /* 2112314 */   // Label 27938: @2112314
     /* 2112314 */   GIM_Try, /*On fail goto*//*Label 27939*/ GIMT_Encode4(2112405), // Rule ID 17106 //
     /* 2112319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2112330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2112333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2112336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112342 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112357 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112361 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112365 */     // MIs[0] round
     /* 2112365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112368 */     // MIs[0] policy
     /* 2112368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112378 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2112381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112383 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112387 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112389 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112391 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112401 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112404 */     // GIR_Coverage, 17106,
     /* 2112404 */     GIR_EraseRootFromParent_Done,
     /* 2112405 */   // Label 27939: @2112405
     /* 2112405 */   GIM_Try, /*On fail goto*//*Label 27940*/ GIMT_Encode4(2112496), // Rule ID 17107 //
     /* 2112410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2112421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2112424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2112427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112430 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2112433 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112452 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112456 */     // MIs[0] round
     /* 2112456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112459 */     // MIs[0] policy
     /* 2112459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112462 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112469 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF4_E16_MASK),
     /* 2112472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112474 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112478 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112480 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112482 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112492 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112495 */     // GIR_Coverage, 17107,
     /* 2112495 */     GIR_EraseRootFromParent_Done,
     /* 2112496 */   // Label 27940: @2112496
     /* 2112496 */   GIM_Try, /*On fail goto*//*Label 27941*/ GIMT_Encode4(2112587), // Rule ID 17110 //
     /* 2112501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2112512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2112518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112521 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112524 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112539 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112543 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112547 */     // MIs[0] round
     /* 2112547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112550 */     // MIs[0] policy
     /* 2112550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112553 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112560 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2112563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112565 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112567 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112569 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112571 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112573 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112583 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112586 */     // GIR_Coverage, 17110,
     /* 2112586 */     GIR_EraseRootFromParent_Done,
     /* 2112587 */   // Label 27941: @2112587
     /* 2112587 */   GIM_Try, /*On fail goto*//*Label 27942*/ GIMT_Encode4(2112678), // Rule ID 17111 //
     /* 2112592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2112603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2112606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2112609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2112615 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2112622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2112630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112634 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112638 */     // MIs[0] round
     /* 2112638 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112641 */     // MIs[0] policy
     /* 2112641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112651 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11213:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_MF2_E16_MASK),
     /* 2112654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112656 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112658 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112660 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112662 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112664 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112674 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112677 */     // GIR_Coverage, 17111,
     /* 2112677 */     GIR_EraseRootFromParent_Done,
     /* 2112678 */   // Label 27942: @2112678
     /* 2112678 */   GIM_Try, /*On fail goto*//*Label 27943*/ GIMT_Encode4(2112769), // Rule ID 17114 //
     /* 2112683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112706 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112721 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112725 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112729 */     // MIs[0] round
     /* 2112729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112732 */     // MIs[0] policy
     /* 2112732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112735 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112742 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2112745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112747 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112751 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112753 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112755 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112765 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112768 */     // GIR_Coverage, 17114,
     /* 2112768 */     GIR_EraseRootFromParent_Done,
     /* 2112769 */   // Label 27943: @2112769
     /* 2112769 */   GIM_Try, /*On fail goto*//*Label 27944*/ GIMT_Encode4(2112860), // Rule ID 17115 //
     /* 2112774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2112785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2112788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2112791 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112794 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2112797 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2112804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2112812 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112816 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112820 */     // MIs[0] round
     /* 2112820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112823 */     // MIs[0] policy
     /* 2112823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112833 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2112833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M1_E16_MASK),
     /* 2112836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112838 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112840 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112842 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112844 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112846 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112856 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112859 */     // GIR_Coverage, 17115,
     /* 2112859 */     GIR_EraseRootFromParent_Done,
     /* 2112860 */   // Label 27944: @2112860
     /* 2112860 */   GIM_Try, /*On fail goto*//*Label 27945*/ GIMT_Encode4(2112951), // Rule ID 17118 //
     /* 2112865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2112868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112888 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2112891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112895 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112907 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2112911 */     // MIs[0] round
     /* 2112911 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2112914 */     // MIs[0] policy
     /* 2112914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2112917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2112924 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2112924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2112927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2112929 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2112931 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2112933 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2112935 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2112937 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2112939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2112944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2112947 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2112949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2112950 */     // GIR_Coverage, 17118,
     /* 2112950 */     GIR_EraseRootFromParent_Done,
     /* 2112951 */   // Label 27945: @2112951
     /* 2112951 */   GIM_Try, /*On fail goto*//*Label 27946*/ GIMT_Encode4(2113042), // Rule ID 17119 //
     /* 2112956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2112959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2112964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2112967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2112970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2112973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2112976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2112979 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2112982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2112986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2112994 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2112998 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113002 */     // MIs[0] round
     /* 2113002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113005 */     // MIs[0] policy
     /* 2113005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113008 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113015 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M2_E16_MASK),
     /* 2113018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113020 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113022 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113024 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113026 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113028 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113038 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113041 */     // GIR_Coverage, 17119,
     /* 2113041 */     GIR_EraseRootFromParent_Done,
     /* 2113042 */   // Label 27946: @2113042
     /* 2113042 */   GIM_Try, /*On fail goto*//*Label 27947*/ GIMT_Encode4(2113133), // Rule ID 17122 //
     /* 2113047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2113050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2113058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2113061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2113064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2113070 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113089 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113093 */     // MIs[0] round
     /* 2113093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113096 */     // MIs[0] policy
     /* 2113096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113106 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2113109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113111 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113115 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113117 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113119 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113129 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113132 */     // GIR_Coverage, 17122,
     /* 2113132 */     GIR_EraseRootFromParent_Done,
     /* 2113133 */   // Label 27947: @2113133
     /* 2113133 */   GIM_Try, /*On fail goto*//*Label 27948*/ GIMT_Encode4(2113224), // Rule ID 17123 //
     /* 2113138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2113141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2113149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2113152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2113155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2113158 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2113161 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113176 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2113180 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113184 */     // MIs[0] round
     /* 2113184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113187 */     // MIs[0] policy
     /* 2113187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113197 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR16_M4_E16_MASK),
     /* 2113200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113202 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113204 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113206 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113208 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113210 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2113220 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113223 */     // GIR_Coverage, 17123,
     /* 2113223 */     GIR_EraseRootFromParent_Done,
     /* 2113224 */   // Label 27948: @2113224
     /* 2113224 */   GIM_Try, /*On fail goto*//*Label 27949*/ GIMT_Encode4(2113315), // Rule ID 17126 //
     /* 2113229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113249 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113252 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113267 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113271 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113275 */     // MIs[0] round
     /* 2113275 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113278 */     // MIs[0] policy
     /* 2113278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113281 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113288 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2113291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113293 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113295 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113297 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113299 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113301 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113311 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113314 */     // GIR_Coverage, 17126,
     /* 2113314 */     GIR_EraseRootFromParent_Done,
     /* 2113315 */   // Label 27949: @2113315
     /* 2113315 */   GIM_Try, /*On fail goto*//*Label 27950*/ GIMT_Encode4(2113406), // Rule ID 17127 //
     /* 2113320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2113331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2113334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2113337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113362 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113366 */     // MIs[0] round
     /* 2113366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113369 */     // MIs[0] policy
     /* 2113369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113372 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113379 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11213:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_MF2_E32_MASK),
     /* 2113382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113384 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113388 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113390 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113392 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113402 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113405 */     // GIR_Coverage, 17127,
     /* 2113405 */     GIR_EraseRootFromParent_Done,
     /* 2113406 */   // Label 27950: @2113406
     /* 2113406 */   GIM_Try, /*On fail goto*//*Label 27951*/ GIMT_Encode4(2113497), // Rule ID 17130 //
     /* 2113411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2113428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113449 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113453 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113457 */     // MIs[0] round
     /* 2113457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113460 */     // MIs[0] policy
     /* 2113460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113470 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2113473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113475 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113479 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113481 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113483 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113493 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113496 */     // GIR_Coverage, 17130,
     /* 2113496 */     GIR_EraseRootFromParent_Done,
     /* 2113497 */   // Label 27951: @2113497
     /* 2113497 */   GIM_Try, /*On fail goto*//*Label 27952*/ GIMT_Encode4(2113588), // Rule ID 17131 //
     /* 2113502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2113513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2113516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2113519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113522 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2113525 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2113532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2113540 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113544 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113548 */     // MIs[0] round
     /* 2113548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113551 */     // MIs[0] policy
     /* 2113551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113561 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11213:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M1_E32_MASK),
     /* 2113564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113566 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113568 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113570 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113572 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113574 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113584 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113587 */     // GIR_Coverage, 17131,
     /* 2113587 */     GIR_EraseRootFromParent_Done,
     /* 2113588 */   // Label 27952: @2113588
     /* 2113588 */   GIM_Try, /*On fail goto*//*Label 27953*/ GIMT_Encode4(2113679), // Rule ID 17134 //
     /* 2113593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113613 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113616 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113631 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113635 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113639 */     // MIs[0] round
     /* 2113639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113642 */     // MIs[0] policy
     /* 2113642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113652 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2113655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113657 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113659 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113661 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113663 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113665 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113675 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113678 */     // GIR_Coverage, 17134,
     /* 2113678 */     GIR_EraseRootFromParent_Done,
     /* 2113679 */   // Label 27953: @2113679
     /* 2113679 */   GIM_Try, /*On fail goto*//*Label 27954*/ GIMT_Encode4(2113770), // Rule ID 17135 //
     /* 2113684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2113695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2113698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2113701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2113707 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2113714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2113722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113726 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113730 */     // MIs[0] round
     /* 2113730 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113733 */     // MIs[0] policy
     /* 2113733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113743 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11213:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M2_E32_MASK),
     /* 2113746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113748 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113750 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113752 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113754 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113756 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113766 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113769 */     // GIR_Coverage, 17135,
     /* 2113769 */     GIR_EraseRootFromParent_Done,
     /* 2113770 */   // Label 27954: @2113770
     /* 2113770 */   GIM_Try, /*On fail goto*//*Label 27955*/ GIMT_Encode4(2113861), // Rule ID 17138 //
     /* 2113775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2113778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113795 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113798 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113813 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113817 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113821 */     // MIs[0] round
     /* 2113821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113824 */     // MIs[0] policy
     /* 2113824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113827 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113834 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2113834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2113837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113839 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113841 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113843 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113845 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113847 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113857 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113860 */     // GIR_Coverage, 17138,
     /* 2113860 */     GIR_EraseRootFromParent_Done,
     /* 2113861 */   // Label 27955: @2113861
     /* 2113861 */   GIM_Try, /*On fail goto*//*Label 27956*/ GIMT_Encode4(2113952), // Rule ID 17139 //
     /* 2113866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2113869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwadd_w_mask),
     /* 2113874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2113877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2113880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2113883 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2113886 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2113889 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2113892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2113896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2113904 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2113908 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2113912 */     // MIs[0] round
     /* 2113912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2113915 */     // MIs[0] policy
     /* 2113915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2113918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2113925 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11213:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWADD_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2113925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWADD_WFPR32_M4_E32_MASK),
     /* 2113928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2113930 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2113932 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2113934 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2113936 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2113938 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2113940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2113945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2113948 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2113950 */     GIR_RootConstrainSelectedInstOperands,
     /* 2113951 */     // GIR_Coverage, 17139,
     /* 2113951 */     GIR_EraseRootFromParent_Done,
     /* 2113952 */   // Label 27956: @2113952
     /* 2113952 */   GIM_Try, /*On fail goto*//*Label 27957*/ GIMT_Encode4(2114043), // Rule ID 17148 //
     /* 2113957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2113960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2113965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2113968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2113971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2113974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2113977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2113980 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2113983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2113987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2113999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114003 */     // MIs[0] round
     /* 2114003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114006 */     // MIs[0] policy
     /* 2114006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114016 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2114019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114021 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114025 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114027 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114029 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114039 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114042 */     // GIR_Coverage, 17148,
     /* 2114042 */     GIR_EraseRootFromParent_Done,
     /* 2114043 */   // Label 27957: @2114043
     /* 2114043 */   GIM_Try, /*On fail goto*//*Label 27958*/ GIMT_Encode4(2114134), // Rule ID 17149 //
     /* 2114048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2114059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2114062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2114065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2114068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114071 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114090 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114094 */     // MIs[0] round
     /* 2114094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114097 */     // MIs[0] policy
     /* 2114097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114100 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114107 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF4_E16_MASK),
     /* 2114110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114112 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114116 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114118 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114120 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114130 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114133 */     // GIR_Coverage, 17149,
     /* 2114133 */     GIR_EraseRootFromParent_Done,
     /* 2114134 */   // Label 27958: @2114134
     /* 2114134 */   GIM_Try, /*On fail goto*//*Label 27959*/ GIMT_Encode4(2114225), // Rule ID 17158 //
     /* 2114139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114156 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2114159 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114181 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114185 */     // MIs[0] round
     /* 2114185 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114188 */     // MIs[0] policy
     /* 2114188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114198 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2114201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114203 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114207 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114209 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114211 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114221 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114224 */     // GIR_Coverage, 17158,
     /* 2114224 */     GIR_EraseRootFromParent_Done,
     /* 2114225 */   // Label 27959: @2114225
     /* 2114225 */   GIM_Try, /*On fail goto*//*Label 27960*/ GIMT_Encode4(2114316), // Rule ID 17159 //
     /* 2114230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2114241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2114244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2114247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2114250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2114253 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114268 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114272 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114276 */     // MIs[0] round
     /* 2114276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114279 */     // MIs[0] policy
     /* 2114279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114282 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114289 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E16_MASK),
     /* 2114292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114294 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114296 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114298 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114300 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114302 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114312 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114315 */     // GIR_Coverage, 17159,
     /* 2114315 */     GIR_EraseRootFromParent_Done,
     /* 2114316 */   // Label 27960: @2114316
     /* 2114316 */   GIM_Try, /*On fail goto*//*Label 27961*/ GIMT_Encode4(2114407), // Rule ID 17168 //
     /* 2114321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2114341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114344 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114359 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114363 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114367 */     // MIs[0] round
     /* 2114367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114370 */     // MIs[0] policy
     /* 2114370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114373 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114380 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2114383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114385 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114387 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114389 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114391 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114393 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114403 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114406 */     // GIR_Coverage, 17168,
     /* 2114406 */     GIR_EraseRootFromParent_Done,
     /* 2114407 */   // Label 27961: @2114407
     /* 2114407 */   GIM_Try, /*On fail goto*//*Label 27962*/ GIMT_Encode4(2114498), // Rule ID 17169 //
     /* 2114412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2114423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2114426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2114429 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2114432 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2114435 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2114442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114450 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114454 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114458 */     // MIs[0] round
     /* 2114458 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114461 */     // MIs[0] policy
     /* 2114461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114471 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E16_MASK),
     /* 2114474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114476 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114478 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114480 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114482 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114484 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114486 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114494 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114497 */     // GIR_Coverage, 17169,
     /* 2114497 */     GIR_EraseRootFromParent_Done,
     /* 2114498 */   // Label 27962: @2114498
     /* 2114498 */   GIM_Try, /*On fail goto*//*Label 27963*/ GIMT_Encode4(2114589), // Rule ID 17178 //
     /* 2114503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2114523 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114526 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114545 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114549 */     // MIs[0] round
     /* 2114549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114552 */     // MIs[0] policy
     /* 2114552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114555 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114562 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2114565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114567 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114569 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114571 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114573 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114575 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114585 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114588 */     // GIR_Coverage, 17178,
     /* 2114588 */     GIR_EraseRootFromParent_Done,
     /* 2114589 */   // Label 27963: @2114589
     /* 2114589 */   GIM_Try, /*On fail goto*//*Label 27964*/ GIMT_Encode4(2114680), // Rule ID 17179 //
     /* 2114594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2114605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2114608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2114611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2114614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2114617 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2114624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114632 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2114636 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114640 */     // MIs[0] round
     /* 2114640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114643 */     // MIs[0] policy
     /* 2114643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114653 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E16_MASK),
     /* 2114656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114658 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114662 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114664 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114666 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114676 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114679 */     // GIR_Coverage, 17179,
     /* 2114679 */     GIR_EraseRootFromParent_Done,
     /* 2114680 */   // Label 27964: @2114680
     /* 2114680 */   GIM_Try, /*On fail goto*//*Label 27965*/ GIMT_Encode4(2114771), // Rule ID 17188 //
     /* 2114685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2114688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2114705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114708 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114727 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114731 */     // MIs[0] round
     /* 2114731 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114734 */     // MIs[0] policy
     /* 2114734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114744 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2114747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114749 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114753 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114755 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114757 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114759 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114767 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114770 */     // GIR_Coverage, 17188,
     /* 2114770 */     GIR_EraseRootFromParent_Done,
     /* 2114771 */   // Label 27965: @2114771
     /* 2114771 */   GIM_Try, /*On fail goto*//*Label 27966*/ GIMT_Encode4(2114862), // Rule ID 17189 //
     /* 2114776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2114779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2114787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2114790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2114793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2114796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2114799 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2114806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2114814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2114818 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114822 */     // MIs[0] round
     /* 2114822 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114825 */     // MIs[0] policy
     /* 2114825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114828 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114835 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2114835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E16_MASK),
     /* 2114838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114840 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114844 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114846 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114848 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2114858 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114861 */     // GIR_Coverage, 17189,
     /* 2114861 */     GIR_EraseRootFromParent_Done,
     /* 2114862 */   // Label 27966: @2114862
     /* 2114862 */   GIM_Try, /*On fail goto*//*Label 27967*/ GIMT_Encode4(2114953), // Rule ID 17198 //
     /* 2114867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2114870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2114887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114890 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2114893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114905 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114909 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2114913 */     // MIs[0] round
     /* 2114913 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2114916 */     // MIs[0] policy
     /* 2114916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2114919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2114926 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2114926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2114929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2114931 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2114933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2114935 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2114937 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2114939 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2114941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2114946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2114949 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2114951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2114952 */     // GIR_Coverage, 17198,
     /* 2114952 */     GIR_EraseRootFromParent_Done,
     /* 2114953 */   // Label 27967: @2114953
     /* 2114953 */   GIM_Try, /*On fail goto*//*Label 27968*/ GIMT_Encode4(2115044), // Rule ID 17199 //
     /* 2114958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2114961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2114966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2114969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2114972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2114975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2114978 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2114981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2114984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2114988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2114996 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115000 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115004 */     // MIs[0] round
     /* 2115004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115007 */     // MIs[0] policy
     /* 2115007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115010 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115017 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_MF2_E32_MASK),
     /* 2115020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115022 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115026 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115028 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115030 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115040 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115043 */     // GIR_Coverage, 17199,
     /* 2115043 */     GIR_EraseRootFromParent_Done,
     /* 2115044 */   // Label 27968: @2115044
     /* 2115044 */   GIM_Try, /*On fail goto*//*Label 27969*/ GIMT_Encode4(2115135), // Rule ID 17208 //
     /* 2115049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2115052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2115069 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115072 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115087 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115091 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115095 */     // MIs[0] round
     /* 2115095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115098 */     // MIs[0] policy
     /* 2115098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115108 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2115111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115113 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115115 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115117 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115119 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115121 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115131 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115134 */     // GIR_Coverage, 17208,
     /* 2115134 */     GIR_EraseRootFromParent_Done,
     /* 2115135 */   // Label 27969: @2115135
     /* 2115135 */   GIM_Try, /*On fail goto*//*Label 27970*/ GIMT_Encode4(2115226), // Rule ID 17209 //
     /* 2115140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2115143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2115151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2115154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2115157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2115160 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115163 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115182 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115186 */     // MIs[0] round
     /* 2115186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115189 */     // MIs[0] policy
     /* 2115189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115199 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M1_E32_MASK),
     /* 2115202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115204 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115206 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115208 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115210 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115212 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115222 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115224 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115225 */     // GIR_Coverage, 17209,
     /* 2115225 */     GIR_EraseRootFromParent_Done,
     /* 2115226 */   // Label 27970: @2115226
     /* 2115226 */   GIM_Try, /*On fail goto*//*Label 27971*/ GIMT_Encode4(2115317), // Rule ID 17218 //
     /* 2115231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2115234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2115251 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115254 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115273 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115277 */     // MIs[0] round
     /* 2115277 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115280 */     // MIs[0] policy
     /* 2115280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115283 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115290 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2115293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115295 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115297 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115299 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115301 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115303 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115313 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115316 */     // GIR_Coverage, 17218,
     /* 2115316 */     GIR_EraseRootFromParent_Done,
     /* 2115317 */   // Label 27971: @2115317
     /* 2115317 */   GIM_Try, /*On fail goto*//*Label 27972*/ GIMT_Encode4(2115408), // Rule ID 17219 //
     /* 2115322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2115325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2115333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2115336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2115339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2115342 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115345 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2115352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115360 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115364 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115368 */     // MIs[0] round
     /* 2115368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115371 */     // MIs[0] policy
     /* 2115371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115381 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M2_E32_MASK),
     /* 2115384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115386 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115388 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115390 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115392 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115394 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115404 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115407 */     // GIR_Coverage, 17219,
     /* 2115407 */     GIR_EraseRootFromParent_Done,
     /* 2115408 */   // Label 27972: @2115408
     /* 2115408 */   GIM_Try, /*On fail goto*//*Label 27973*/ GIMT_Encode4(2115499), // Rule ID 17228 //
     /* 2115413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2115416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2115433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115436 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115455 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115459 */     // MIs[0] round
     /* 2115459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115462 */     // MIs[0] policy
     /* 2115462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115472 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2115475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115477 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115481 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115483 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115485 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115495 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115498 */     // GIR_Coverage, 17228,
     /* 2115498 */     GIR_EraseRootFromParent_Done,
     /* 2115499 */   // Label 27973: @2115499
     /* 2115499 */   GIM_Try, /*On fail goto*//*Label 27974*/ GIMT_Encode4(2115590), // Rule ID 17229 //
     /* 2115504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2115507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2115515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2115518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2115521 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2115524 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2115527 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2115534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2115542 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2115546 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115550 */     // MIs[0] round
     /* 2115550 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115553 */     // MIs[0] policy
     /* 2115553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115563 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WV_M4_E32_MASK),
     /* 2115566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115568 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115570 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115572 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115574 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115576 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2115586 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115589 */     // GIR_Coverage, 17229,
     /* 2115589 */     GIR_EraseRootFromParent_Done,
     /* 2115590 */   // Label 27974: @2115590
     /* 2115590 */   GIM_Try, /*On fail goto*//*Label 27975*/ GIMT_Encode4(2115681), // Rule ID 17232 //
     /* 2115595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2115612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115618 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115633 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115637 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115641 */     // MIs[0] round
     /* 2115641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115644 */     // MIs[0] policy
     /* 2115644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115654 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2115657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115659 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115661 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115663 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115665 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115667 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115677 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115680 */     // GIR_Coverage, 17232,
     /* 2115680 */     GIR_EraseRootFromParent_Done,
     /* 2115681 */   // Label 27975: @2115681
     /* 2115681 */   GIM_Try, /*On fail goto*//*Label 27976*/ GIMT_Encode4(2115772), // Rule ID 17233 //
     /* 2115686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2115697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2115700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2115703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115706 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2115709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115728 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115732 */     // MIs[0] round
     /* 2115732 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115735 */     // MIs[0] policy
     /* 2115735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115738 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115745 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF4_E16_MASK),
     /* 2115748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115750 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115752 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115754 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115756 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115758 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115768 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115771 */     // GIR_Coverage, 17233,
     /* 2115771 */     GIR_EraseRootFromParent_Done,
     /* 2115772 */   // Label 27976: @2115772
     /* 2115772 */   GIM_Try, /*On fail goto*//*Label 27977*/ GIMT_Encode4(2115863), // Rule ID 17236 //
     /* 2115777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2115794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115797 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115800 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115819 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115823 */     // MIs[0] round
     /* 2115823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115826 */     // MIs[0] policy
     /* 2115826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115836 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2115836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2115839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115841 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115843 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115845 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115847 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115849 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115859 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115862 */     // GIR_Coverage, 17236,
     /* 2115862 */     GIR_EraseRootFromParent_Done,
     /* 2115863 */   // Label 27977: @2115863
     /* 2115863 */   GIM_Try, /*On fail goto*//*Label 27978*/ GIMT_Encode4(2115954), // Rule ID 17237 //
     /* 2115868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2115871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2115879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2115882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2115885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115888 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2115891 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2115894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2115898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2115906 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2115910 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2115914 */     // MIs[0] round
     /* 2115914 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2115917 */     // MIs[0] policy
     /* 2115917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2115920 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2115927 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11249:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2115927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_MF2_E16_MASK),
     /* 2115930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2115932 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2115934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2115936 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2115938 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2115940 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2115942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2115947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2115950 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2115952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2115953 */     // GIR_Coverage, 17237,
     /* 2115953 */     GIR_EraseRootFromParent_Done,
     /* 2115954 */   // Label 27978: @2115954
     /* 2115954 */   GIM_Try, /*On fail goto*//*Label 27979*/ GIMT_Encode4(2116045), // Rule ID 17240 //
     /* 2115959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2115962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2115967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2115970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2115973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2115976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2115979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2115982 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2115985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2115989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2115997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116001 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116005 */     // MIs[0] round
     /* 2116005 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116008 */     // MIs[0] policy
     /* 2116008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116011 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116018 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2116021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116023 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116027 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116029 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116031 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116041 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116044 */     // GIR_Coverage, 17240,
     /* 2116044 */     GIR_EraseRootFromParent_Done,
     /* 2116045 */   // Label 27979: @2116045
     /* 2116045 */   GIM_Try, /*On fail goto*//*Label 27980*/ GIMT_Encode4(2116136), // Rule ID 17241 //
     /* 2116050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2116061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2116064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2116067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116073 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116092 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116096 */     // MIs[0] round
     /* 2116096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116099 */     // MIs[0] policy
     /* 2116099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116102 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116109 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M1_E16_MASK),
     /* 2116112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116114 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116116 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116118 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116120 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116122 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116132 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116135 */     // GIR_Coverage, 17241,
     /* 2116135 */     GIR_EraseRootFromParent_Done,
     /* 2116136 */   // Label 27980: @2116136
     /* 2116136 */   GIM_Try, /*On fail goto*//*Label 27981*/ GIMT_Encode4(2116227), // Rule ID 17244 //
     /* 2116141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2116158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116161 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116164 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116183 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116187 */     // MIs[0] round
     /* 2116187 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116190 */     // MIs[0] policy
     /* 2116190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116200 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2116203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116205 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116207 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116209 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116211 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116213 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116223 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116226 */     // GIR_Coverage, 17244,
     /* 2116226 */     GIR_EraseRootFromParent_Done,
     /* 2116227 */   // Label 27981: @2116227
     /* 2116227 */   GIM_Try, /*On fail goto*//*Label 27982*/ GIMT_Encode4(2116318), // Rule ID 17245 //
     /* 2116232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2116243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2116246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2116249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2116255 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116270 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116274 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116278 */     // MIs[0] round
     /* 2116278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116281 */     // MIs[0] policy
     /* 2116281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116291 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M2_E16_MASK),
     /* 2116294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116296 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116298 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116300 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116302 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116304 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116314 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116317 */     // GIR_Coverage, 17245,
     /* 2116317 */     GIR_EraseRootFromParent_Done,
     /* 2116318 */   // Label 27982: @2116318
     /* 2116318 */   GIM_Try, /*On fail goto*//*Label 27983*/ GIMT_Encode4(2116409), // Rule ID 17248 //
     /* 2116323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2116326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2116340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116361 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116365 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116369 */     // MIs[0] round
     /* 2116369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116372 */     // MIs[0] policy
     /* 2116372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116375 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116382 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2116385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116387 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116389 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116391 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116393 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116395 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116405 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116408 */     // GIR_Coverage, 17248,
     /* 2116408 */     GIR_EraseRootFromParent_Done,
     /* 2116409 */   // Label 27983: @2116409
     /* 2116409 */   GIM_Try, /*On fail goto*//*Label 27984*/ GIMT_Encode4(2116500), // Rule ID 17249 //
     /* 2116414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2116417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2116425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2116428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2116431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2116434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2116437 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2116444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2116452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2116456 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116460 */     // MIs[0] round
     /* 2116460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116463 */     // MIs[0] policy
     /* 2116463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116466 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116473 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR16_M4_E16_MASK),
     /* 2116476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116478 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116482 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116484 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116486 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2116496 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116499 */     // GIR_Coverage, 17249,
     /* 2116499 */     GIR_EraseRootFromParent_Done,
     /* 2116500 */   // Label 27984: @2116500
     /* 2116500 */   GIM_Try, /*On fail goto*//*Label 27985*/ GIMT_Encode4(2116591), // Rule ID 17252 //
     /* 2116505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2116522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116528 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116543 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116547 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116551 */     // MIs[0] round
     /* 2116551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116554 */     // MIs[0] policy
     /* 2116554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116564 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2116567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116569 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116571 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116573 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116575 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116577 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116587 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116590 */     // GIR_Coverage, 17252,
     /* 2116590 */     GIR_EraseRootFromParent_Done,
     /* 2116591 */   // Label 27985: @2116591
     /* 2116591 */   GIM_Try, /*On fail goto*//*Label 27986*/ GIMT_Encode4(2116682), // Rule ID 17253 //
     /* 2116596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2116607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2116610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2116613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2116619 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2116626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2116634 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116638 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116642 */     // MIs[0] round
     /* 2116642 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116645 */     // MIs[0] policy
     /* 2116645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116648 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116655 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11249:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_MF2_E32_MASK),
     /* 2116658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116660 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116662 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116664 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116666 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116668 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116678 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116681 */     // GIR_Coverage, 17253,
     /* 2116681 */     GIR_EraseRootFromParent_Done,
     /* 2116682 */   // Label 27986: @2116682
     /* 2116682 */   GIM_Try, /*On fail goto*//*Label 27987*/ GIMT_Encode4(2116773), // Rule ID 17256 //
     /* 2116687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116710 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116729 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116733 */     // MIs[0] round
     /* 2116733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116736 */     // MIs[0] policy
     /* 2116736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116739 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116746 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2116749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116751 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116753 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116755 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116757 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116759 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116761 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116769 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116772 */     // GIR_Coverage, 17256,
     /* 2116772 */     GIR_EraseRootFromParent_Done,
     /* 2116773 */   // Label 27987: @2116773
     /* 2116773 */   GIM_Try, /*On fail goto*//*Label 27988*/ GIMT_Encode4(2116864), // Rule ID 17257 //
     /* 2116778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2116789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2116792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2116795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2116801 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2116808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2116816 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116820 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116824 */     // MIs[0] round
     /* 2116824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116827 */     // MIs[0] policy
     /* 2116827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116837 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11249:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2116837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M1_E32_MASK),
     /* 2116840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116842 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116846 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116848 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116850 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116860 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116863 */     // GIR_Coverage, 17257,
     /* 2116863 */     GIR_EraseRootFromParent_Done,
     /* 2116864 */   // Label 27988: @2116864
     /* 2116864 */   GIM_Try, /*On fail goto*//*Label 27989*/ GIMT_Encode4(2116955), // Rule ID 17260 //
     /* 2116869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2116872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116886 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116889 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116892 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2116895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2116911 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2116915 */     // MIs[0] round
     /* 2116915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2116918 */     // MIs[0] policy
     /* 2116918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2116921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2116928 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2116928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2116931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2116933 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2116935 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2116937 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2116939 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2116941 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2116943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2116948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2116951 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2116953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2116954 */     // GIR_Coverage, 17260,
     /* 2116954 */     GIR_EraseRootFromParent_Done,
     /* 2116955 */   // Label 27989: @2116955
     /* 2116955 */   GIM_Try, /*On fail goto*//*Label 27990*/ GIMT_Encode4(2117046), // Rule ID 17261 //
     /* 2116960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2116963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2116968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2116971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2116974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2116977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2116980 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2116983 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2116986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2116990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2116998 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117002 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117006 */     // MIs[0] round
     /* 2117006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117009 */     // MIs[0] policy
     /* 2117009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117012 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117019 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11249:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M2_E32_MASK),
     /* 2117022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117024 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117028 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117030 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117032 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117042 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117045 */     // GIR_Coverage, 17261,
     /* 2117045 */     GIR_EraseRootFromParent_Done,
     /* 2117046 */   // Label 27990: @2117046
     /* 2117046 */   GIM_Try, /*On fail goto*//*Label 27991*/ GIMT_Encode4(2117137), // Rule ID 17264 //
     /* 2117051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2117054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2117059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2117068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117074 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117093 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117097 */     // MIs[0] round
     /* 2117097 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117100 */     // MIs[0] policy
     /* 2117100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117110 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2117113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117115 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117119 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117121 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117123 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117133 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117135 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117136 */     // GIR_Coverage, 17264,
     /* 2117136 */     GIR_EraseRootFromParent_Done,
     /* 2117137 */   // Label 27991: @2117137
     /* 2117137 */   GIM_Try, /*On fail goto*//*Label 27992*/ GIMT_Encode4(2117228), // Rule ID 17265 //
     /* 2117142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2117145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwsub_w_mask),
     /* 2117150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2117153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2117156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2117159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2117162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2117165 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2117172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2117180 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2117184 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117188 */     // MIs[0] round
     /* 2117188 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117191 */     // MIs[0] policy
     /* 2117191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117194 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117201 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11249:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWSUB_WFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWSUB_WFPR32_M4_E32_MASK),
     /* 2117204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117206 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117208 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117210 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117212 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117214 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117224 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117227 */     // GIR_Coverage, 17265,
     /* 2117227 */     GIR_EraseRootFromParent_Done,
     /* 2117228 */   // Label 27992: @2117228
     /* 2117228 */   GIM_Try, /*On fail goto*//*Label 27993*/ GIMT_Encode4(2117319), // Rule ID 17268 //
     /* 2117233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2117244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2117247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2117253 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117256 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117271 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117275 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117279 */     // MIs[0] round
     /* 2117279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117282 */     // MIs[0] policy
     /* 2117282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117292 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2117295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117297 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117301 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117303 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117305 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117315 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117318 */     // GIR_Coverage, 17268,
     /* 2117318 */     GIR_EraseRootFromParent_Done,
     /* 2117319 */   // Label 27993: @2117319
     /* 2117319 */   GIM_Try, /*On fail goto*//*Label 27994*/ GIMT_Encode4(2117410), // Rule ID 17269 //
     /* 2117324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2117327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2117335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2117338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2117341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2117344 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117347 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117366 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117370 */     // MIs[0] round
     /* 2117370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117373 */     // MIs[0] policy
     /* 2117373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117383 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16_MASK),
     /* 2117386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117388 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117390 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117392 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117394 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117396 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117406 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117409 */     // GIR_Coverage, 17269,
     /* 2117409 */     GIR_EraseRootFromParent_Done,
     /* 2117410 */   // Label 27994: @2117410
     /* 2117410 */   GIM_Try, /*On fail goto*//*Label 27995*/ GIMT_Encode4(2117501), // Rule ID 17272 //
     /* 2117415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2117426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2117429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2117435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117438 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117457 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117461 */     // MIs[0] round
     /* 2117461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117464 */     // MIs[0] policy
     /* 2117464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117467 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117474 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2117477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117479 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117483 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117485 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117487 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117497 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117500 */     // GIR_Coverage, 17272,
     /* 2117500 */     GIR_EraseRootFromParent_Done,
     /* 2117501 */   // Label 27995: @2117501
     /* 2117501 */   GIM_Try, /*On fail goto*//*Label 27996*/ GIMT_Encode4(2117592), // Rule ID 17273 //
     /* 2117506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2117509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2117517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2117520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2117523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2117526 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117529 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117544 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117548 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117552 */     // MIs[0] round
     /* 2117552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117555 */     // MIs[0] policy
     /* 2117555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117565 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16_MASK),
     /* 2117568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117570 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117572 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117574 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117576 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117578 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117588 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117591 */     // GIR_Coverage, 17273,
     /* 2117591 */     GIR_EraseRootFromParent_Done,
     /* 2117592 */   // Label 27996: @2117592
     /* 2117592 */   GIM_Try, /*On fail goto*//*Label 27997*/ GIMT_Encode4(2117683), // Rule ID 17276 //
     /* 2117597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2117600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2117617 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117620 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117635 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117639 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117643 */     // MIs[0] round
     /* 2117643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117646 */     // MIs[0] policy
     /* 2117646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117656 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2117659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117661 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117663 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117665 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117667 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117669 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117679 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117682 */     // GIR_Coverage, 17276,
     /* 2117682 */     GIR_EraseRootFromParent_Done,
     /* 2117683 */   // Label 27997: @2117683
     /* 2117683 */   GIM_Try, /*On fail goto*//*Label 27998*/ GIMT_Encode4(2117774), // Rule ID 17277 //
     /* 2117688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2117691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2117699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2117702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2117705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2117708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2117711 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117730 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117734 */     // MIs[0] round
     /* 2117734 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117737 */     // MIs[0] policy
     /* 2117737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117740 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117747 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32_MASK),
     /* 2117750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117752 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117754 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117756 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117758 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117760 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2117770 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117773 */     // GIR_Coverage, 17277,
     /* 2117773 */     GIR_EraseRootFromParent_Done,
     /* 2117774 */   // Label 27998: @2117774
     /* 2117774 */   GIM_Try, /*On fail goto*//*Label 27999*/ GIMT_Encode4(2117865), // Rule ID 17280 //
     /* 2117779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2117782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2117790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2117793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2117799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117802 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117821 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117825 */     // MIs[0] round
     /* 2117825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117828 */     // MIs[0] policy
     /* 2117828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117838 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2117838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2117841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117843 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117845 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117847 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117849 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117851 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117861 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117864 */     // GIR_Coverage, 17280,
     /* 2117864 */     GIR_EraseRootFromParent_Done,
     /* 2117865 */   // Label 27999: @2117865
     /* 2117865 */   GIM_Try, /*On fail goto*//*Label 28000*/ GIMT_Encode4(2117956), // Rule ID 17281 //
     /* 2117870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2117873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2117881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2117884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2117887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2117890 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2117893 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2117896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117912 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2117916 */     // MIs[0] round
     /* 2117916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2117919 */     // MIs[0] policy
     /* 2117919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2117922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2117929 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2117929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16_MASK),
     /* 2117932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2117934 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2117936 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2117938 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2117940 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2117942 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2117944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2117949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2117952 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2117954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2117955 */     // GIR_Coverage, 17281,
     /* 2117955 */     GIR_EraseRootFromParent_Done,
     /* 2117956 */   // Label 28000: @2117956
     /* 2117956 */   GIM_Try, /*On fail goto*//*Label 28001*/ GIMT_Encode4(2118047), // Rule ID 17284 //
     /* 2117961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2117964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2117969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2117972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2117975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2117978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2117981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2117984 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2117987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2117991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2117999 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118003 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118007 */     // MIs[0] round
     /* 2118007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118010 */     // MIs[0] policy
     /* 2118010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118020 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2118023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118025 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118029 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118031 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118033 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118043 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118046 */     // GIR_Coverage, 17284,
     /* 2118046 */     GIR_EraseRootFromParent_Done,
     /* 2118047 */   // Label 28001: @2118047
     /* 2118047 */   GIM_Try, /*On fail goto*//*Label 28002*/ GIMT_Encode4(2118138), // Rule ID 17285 //
     /* 2118052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2118055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2118063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2118066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2118069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2118072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2118075 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118094 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118098 */     // MIs[0] round
     /* 2118098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118101 */     // MIs[0] policy
     /* 2118101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118111 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32_MASK),
     /* 2118114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118116 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118120 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118122 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118124 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118134 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118137 */     // GIR_Coverage, 17285,
     /* 2118137 */     GIR_EraseRootFromParent_Done,
     /* 2118138 */   // Label 28002: @2118138
     /* 2118138 */   GIM_Try, /*On fail goto*//*Label 28003*/ GIMT_Encode4(2118229), // Rule ID 17288 //
     /* 2118143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2118146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2118160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2118163 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118166 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118181 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118185 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118189 */     // MIs[0] round
     /* 2118189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118192 */     // MIs[0] policy
     /* 2118192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118202 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2118205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118207 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118211 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118213 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118215 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118225 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118228 */     // GIR_Coverage, 17288,
     /* 2118228 */     GIR_EraseRootFromParent_Done,
     /* 2118229 */   // Label 28003: @2118229
     /* 2118229 */   GIM_Try, /*On fail goto*//*Label 28004*/ GIMT_Encode4(2118320), // Rule ID 17289 //
     /* 2118234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2118237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2118245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2118248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2118251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2118254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2118257 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2118264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2118276 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118280 */     // MIs[0] round
     /* 2118280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118283 */     // MIs[0] policy
     /* 2118283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118286 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118293 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64_MASK),
     /* 2118296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118298 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118300 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118302 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118304 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118306 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118308 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2118316 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118319 */     // GIR_Coverage, 17289,
     /* 2118319 */     GIR_EraseRootFromParent_Done,
     /* 2118320 */   // Label 28004: @2118320
     /* 2118320 */   GIM_Try, /*On fail goto*//*Label 28005*/ GIMT_Encode4(2118411), // Rule ID 17292 //
     /* 2118325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2118328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2118336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2118339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2118345 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118348 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118363 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118367 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118371 */     // MIs[0] round
     /* 2118371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118374 */     // MIs[0] policy
     /* 2118374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118377 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118384 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2118387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118389 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118393 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118395 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118397 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118407 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118410 */     // GIR_Coverage, 17292,
     /* 2118410 */     GIR_EraseRootFromParent_Done,
     /* 2118411 */   // Label 28005: @2118411
     /* 2118411 */   GIM_Try, /*On fail goto*//*Label 28006*/ GIMT_Encode4(2118502), // Rule ID 17293 //
     /* 2118416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2118419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2118427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2118430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2118433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2118436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2118439 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118454 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118458 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118462 */     // MIs[0] round
     /* 2118462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118465 */     // MIs[0] policy
     /* 2118465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118475 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16_MASK),
     /* 2118478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118480 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118482 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118484 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118486 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118488 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118498 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118501 */     // GIR_Coverage, 17293,
     /* 2118501 */     GIR_EraseRootFromParent_Done,
     /* 2118502 */   // Label 28006: @2118502
     /* 2118502 */   GIM_Try, /*On fail goto*//*Label 28007*/ GIMT_Encode4(2118593), // Rule ID 17296 //
     /* 2118507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2118510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2118518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2118521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2118527 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118530 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118549 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118553 */     // MIs[0] round
     /* 2118553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118556 */     // MIs[0] policy
     /* 2118556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118559 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118566 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2118569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118571 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118573 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118575 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118577 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118579 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118589 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118592 */     // GIR_Coverage, 17296,
     /* 2118592 */     GIR_EraseRootFromParent_Done,
     /* 2118593 */   // Label 28007: @2118593
     /* 2118593 */   GIM_Try, /*On fail goto*//*Label 28008*/ GIMT_Encode4(2118684), // Rule ID 17297 //
     /* 2118598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2118601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2118609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2118612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2118615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2118618 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2118621 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2118628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118636 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2118640 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118644 */     // MIs[0] round
     /* 2118644 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118647 */     // MIs[0] policy
     /* 2118647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118650 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118657 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16_MASK),
     /* 2118660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118662 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118664 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118666 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118668 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118670 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118680 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118683 */     // GIR_Coverage, 17297,
     /* 2118683 */     GIR_EraseRootFromParent_Done,
     /* 2118684 */   // Label 28008: @2118684
     /* 2118684 */   GIM_Try, /*On fail goto*//*Label 28009*/ GIMT_Encode4(2118775), // Rule ID 17300 //
     /* 2118689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2118692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2118700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2118703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2118706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2118709 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2118712 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118727 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118731 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118735 */     // MIs[0] round
     /* 2118735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118738 */     // MIs[0] policy
     /* 2118738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118748 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2118751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118753 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118757 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118759 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118761 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118771 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118774 */     // GIR_Coverage, 17300,
     /* 2118774 */     GIR_EraseRootFromParent_Done,
     /* 2118775 */   // Label 28009: @2118775
     /* 2118775 */   GIM_Try, /*On fail goto*//*Label 28010*/ GIMT_Encode4(2118866), // Rule ID 17301 //
     /* 2118780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2118783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2118791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2118794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2118797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2118800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2118803 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2118810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2118822 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118826 */     // MIs[0] round
     /* 2118826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118829 */     // MIs[0] policy
     /* 2118829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118839 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2118839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16_MASK),
     /* 2118842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118844 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118846 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118848 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118850 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118852 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118854 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2118862 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118865 */     // GIR_Coverage, 17301,
     /* 2118865 */     GIR_EraseRootFromParent_Done,
     /* 2118866 */   // Label 28010: @2118866
     /* 2118866 */   GIM_Try, /*On fail goto*//*Label 28011*/ GIMT_Encode4(2118957), // Rule ID 17304 //
     /* 2118871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2118874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2118891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118894 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2118897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118909 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118913 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2118917 */     // MIs[0] round
     /* 2118917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2118920 */     // MIs[0] policy
     /* 2118920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2118923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2118930 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2118930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2118933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2118935 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2118937 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2118939 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2118941 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2118943 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2118945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2118950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2118953 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2118955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2118956 */     // GIR_Coverage, 17304,
     /* 2118956 */     GIR_EraseRootFromParent_Done,
     /* 2118957 */   // Label 28011: @2118957
     /* 2118957 */   GIM_Try, /*On fail goto*//*Label 28012*/ GIMT_Encode4(2119048), // Rule ID 17305 //
     /* 2118962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2118965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2118970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2118973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2118976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2118979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2118982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2118985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2118988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2118992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2118996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119000 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119004 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119008 */     // MIs[0] round
     /* 2119008 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119011 */     // MIs[0] policy
     /* 2119011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119014 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119021 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32_MASK),
     /* 2119024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119026 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119028 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119030 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119032 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119034 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119044 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119047 */     // GIR_Coverage, 17305,
     /* 2119047 */     GIR_EraseRootFromParent_Done,
     /* 2119048 */   // Label 28012: @2119048
     /* 2119048 */   GIM_Try, /*On fail goto*//*Label 28013*/ GIMT_Encode4(2119139), // Rule ID 17308 //
     /* 2119053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2119056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2119073 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119076 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119095 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119099 */     // MIs[0] round
     /* 2119099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119102 */     // MIs[0] policy
     /* 2119102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119105 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119112 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2119115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119117 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119121 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119123 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119125 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119135 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119138 */     // GIR_Coverage, 17308,
     /* 2119138 */     GIR_EraseRootFromParent_Done,
     /* 2119139 */   // Label 28013: @2119139
     /* 2119139 */   GIM_Try, /*On fail goto*//*Label 28014*/ GIMT_Encode4(2119230), // Rule ID 17309 //
     /* 2119144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2119147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2119155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2119158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2119161 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2119164 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119167 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119182 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119186 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119190 */     // MIs[0] round
     /* 2119190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119193 */     // MIs[0] policy
     /* 2119193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119196 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119203 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32_MASK),
     /* 2119206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119208 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119212 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119214 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119216 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119226 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119229 */     // GIR_Coverage, 17309,
     /* 2119229 */     GIR_EraseRootFromParent_Done,
     /* 2119230 */   // Label 28014: @2119230
     /* 2119230 */   GIM_Try, /*On fail goto*//*Label 28015*/ GIMT_Encode4(2119321), // Rule ID 17312 //
     /* 2119235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2119238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2119252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2119255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119258 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119273 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119277 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119281 */     // MIs[0] round
     /* 2119281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119284 */     // MIs[0] policy
     /* 2119284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119287 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119294 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2119297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119299 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119303 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119305 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119307 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119317 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119320 */     // GIR_Coverage, 17312,
     /* 2119320 */     GIR_EraseRootFromParent_Done,
     /* 2119321 */   // Label 28015: @2119321
     /* 2119321 */   GIM_Try, /*On fail goto*//*Label 28016*/ GIMT_Encode4(2119412), // Rule ID 17313 //
     /* 2119326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2119329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2119337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2119340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2119343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2119346 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2119349 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119364 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119368 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119372 */     // MIs[0] round
     /* 2119372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119375 */     // MIs[0] policy
     /* 2119375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119378 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119385 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32_MASK),
     /* 2119388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119390 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119394 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119396 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119398 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2119408 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119411 */     // GIR_Coverage, 17313,
     /* 2119411 */     GIR_EraseRootFromParent_Done,
     /* 2119412 */   // Label 28016: @2119412
     /* 2119412 */   GIM_Try, /*On fail goto*//*Label 28017*/ GIMT_Encode4(2119503), // Rule ID 17316 //
     /* 2119417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2119420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2119434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2119437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119440 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119455 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119459 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119463 */     // MIs[0] round
     /* 2119463 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119466 */     // MIs[0] policy
     /* 2119466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119469 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119476 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2119479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119481 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119485 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119487 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119489 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119499 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119502 */     // GIR_Coverage, 17316,
     /* 2119502 */     GIR_EraseRootFromParent_Done,
     /* 2119503 */   // Label 28017: @2119503
     /* 2119503 */   GIM_Try, /*On fail goto*//*Label 28018*/ GIMT_Encode4(2119594), // Rule ID 17317 //
     /* 2119508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2119511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2119519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2119522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2119525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2119528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2119531 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2119538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119546 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2119550 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119554 */     // MIs[0] round
     /* 2119554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119557 */     // MIs[0] policy
     /* 2119557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119560 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119567 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64_MASK),
     /* 2119570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119572 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119576 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119578 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119580 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119590 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119593 */     // GIR_Coverage, 17317,
     /* 2119593 */     GIR_EraseRootFromParent_Done,
     /* 2119594 */   // Label 28018: @2119594
     /* 2119594 */   GIM_Try, /*On fail goto*//*Label 28019*/ GIMT_Encode4(2119685), // Rule ID 17320 //
     /* 2119599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2119602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2119619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119641 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119645 */     // MIs[0] round
     /* 2119645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119648 */     // MIs[0] policy
     /* 2119648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119658 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2119661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119663 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119667 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119669 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119671 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119681 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119684 */     // GIR_Coverage, 17320,
     /* 2119684 */     GIR_EraseRootFromParent_Done,
     /* 2119685 */   // Label 28019: @2119685
     /* 2119685 */   GIM_Try, /*On fail goto*//*Label 28020*/ GIMT_Encode4(2119776), // Rule ID 17321 //
     /* 2119690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2119693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2119701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2119704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2119707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2119710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2119713 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2119720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119728 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2119732 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119736 */     // MIs[0] round
     /* 2119736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119739 */     // MIs[0] policy
     /* 2119739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119742 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119749 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64_MASK),
     /* 2119752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119754 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119756 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119758 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119760 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119762 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119772 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119775 */     // GIR_Coverage, 17321,
     /* 2119775 */     GIR_EraseRootFromParent_Done,
     /* 2119776 */   // Label 28020: @2119776
     /* 2119776 */   GIM_Try, /*On fail goto*//*Label 28021*/ GIMT_Encode4(2119867), // Rule ID 17324 //
     /* 2119781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2119784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2119801 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119823 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119827 */     // MIs[0] round
     /* 2119827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119830 */     // MIs[0] policy
     /* 2119830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119840 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2119840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2119843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119845 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119849 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119851 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119853 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119863 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119866 */     // GIR_Coverage, 17324,
     /* 2119866 */     GIR_EraseRootFromParent_Done,
     /* 2119867 */   // Label 28021: @2119867
     /* 2119867 */   GIM_Try, /*On fail goto*//*Label 28022*/ GIMT_Encode4(2119958), // Rule ID 17325 //
     /* 2119872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2119875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2119883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2119886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2119889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2119892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2119895 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2119898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2119902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119910 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2119914 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2119918 */     // MIs[0] round
     /* 2119918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2119921 */     // MIs[0] policy
     /* 2119921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2119924 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2119931 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2119931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64_MASK),
     /* 2119934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2119936 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2119938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2119940 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2119942 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2119944 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2119946 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2119951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2119954 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2119956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2119957 */     // GIR_Coverage, 17325,
     /* 2119957 */     GIR_EraseRootFromParent_Done,
     /* 2119958 */   // Label 28022: @2119958
     /* 2119958 */   GIM_Try, /*On fail goto*//*Label 28023*/ GIMT_Encode4(2120049), // Rule ID 17328 //
     /* 2119963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2119966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2119971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2119974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2119977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2119980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2119983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2119986 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2119989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2119993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2119997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120001 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120005 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120009 */     // MIs[0] round
     /* 2120009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120012 */     // MIs[0] policy
     /* 2120012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120022 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2120025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120027 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120029 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120031 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120033 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120035 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120045 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120048 */     // GIR_Coverage, 17328,
     /* 2120048 */     GIR_EraseRootFromParent_Done,
     /* 2120049 */   // Label 28023: @2120049
     /* 2120049 */   GIM_Try, /*On fail goto*//*Label 28024*/ GIMT_Encode4(2120140), // Rule ID 17329 //
     /* 2120054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2120057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2120065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2120068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2120071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120077 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120096 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120100 */     // MIs[0] round
     /* 2120100 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120103 */     // MIs[0] policy
     /* 2120103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120106 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120113 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF4_E16_MASK),
     /* 2120116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120118 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120120 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120122 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120124 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120126 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120136 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120139 */     // GIR_Coverage, 17329,
     /* 2120139 */     GIR_EraseRootFromParent_Done,
     /* 2120140 */   // Label 28024: @2120140
     /* 2120140 */   GIM_Try, /*On fail goto*//*Label 28025*/ GIMT_Encode4(2120231), // Rule ID 17332 //
     /* 2120145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2120148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2120156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2120159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120168 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120183 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120187 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120191 */     // MIs[0] round
     /* 2120191 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120194 */     // MIs[0] policy
     /* 2120194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120204 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2120207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120209 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120213 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120215 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120217 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120227 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120230 */     // GIR_Coverage, 17332,
     /* 2120230 */     GIR_EraseRootFromParent_Done,
     /* 2120231 */   // Label 28025: @2120231
     /* 2120231 */   GIM_Try, /*On fail goto*//*Label 28026*/ GIMT_Encode4(2120322), // Rule ID 17333 //
     /* 2120236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2120239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2120247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2120250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2120253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120259 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120278 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120282 */     // MIs[0] round
     /* 2120282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120285 */     // MIs[0] policy
     /* 2120285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120295 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_MF2_E16_MASK),
     /* 2120298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120300 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120304 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120306 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120308 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120318 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120321 */     // GIR_Coverage, 17333,
     /* 2120321 */     GIR_EraseRootFromParent_Done,
     /* 2120322 */   // Label 28026: @2120322
     /* 2120322 */   GIM_Try, /*On fail goto*//*Label 28027*/ GIMT_Encode4(2120413), // Rule ID 17336 //
     /* 2120327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2120330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120347 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120350 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120361 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120365 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120369 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120373 */     // MIs[0] round
     /* 2120373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120376 */     // MIs[0] policy
     /* 2120376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120386 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2120389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120391 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120393 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120395 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120397 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120399 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120401 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120409 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120412 */     // GIR_Coverage, 17336,
     /* 2120412 */     GIR_EraseRootFromParent_Done,
     /* 2120413 */   // Label 28027: @2120413
     /* 2120413 */   GIM_Try, /*On fail goto*//*Label 28028*/ GIMT_Encode4(2120504), // Rule ID 17337 //
     /* 2120418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2120421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2120429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2120432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2120435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120441 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120460 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120464 */     // MIs[0] round
     /* 2120464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120467 */     // MIs[0] policy
     /* 2120467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120470 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120477 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_MF2_E32_MASK),
     /* 2120480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120482 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120486 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120488 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120490 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120500 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120503 */     // GIR_Coverage, 17337,
     /* 2120503 */     GIR_EraseRootFromParent_Done,
     /* 2120504 */   // Label 28028: @2120504
     /* 2120504 */   GIM_Try, /*On fail goto*//*Label 28029*/ GIMT_Encode4(2120595), // Rule ID 17340 //
     /* 2120509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2120512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2120520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2120523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120532 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120551 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120555 */     // MIs[0] round
     /* 2120555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120558 */     // MIs[0] policy
     /* 2120558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120561 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120568 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2120571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120573 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120577 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120579 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120581 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120591 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120594 */     // GIR_Coverage, 17340,
     /* 2120594 */     GIR_EraseRootFromParent_Done,
     /* 2120595 */   // Label 28029: @2120595
     /* 2120595 */   GIM_Try, /*On fail goto*//*Label 28030*/ GIMT_Encode4(2120686), // Rule ID 17341 //
     /* 2120600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2120603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2120611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2120614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2120617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2120620 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2120623 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120638 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2120642 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120646 */     // MIs[0] round
     /* 2120646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120649 */     // MIs[0] policy
     /* 2120649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120659 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11150:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M1_E16_MASK),
     /* 2120662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120664 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120666 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120668 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120670 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120672 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2120682 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120685 */     // GIR_Coverage, 17341,
     /* 2120685 */     GIR_EraseRootFromParent_Done,
     /* 2120686 */   // Label 28030: @2120686
     /* 2120686 */   GIM_Try, /*On fail goto*//*Label 28031*/ GIMT_Encode4(2120777), // Rule ID 17344 //
     /* 2120691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2120694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120711 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120714 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120733 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120737 */     // MIs[0] round
     /* 2120737 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120740 */     // MIs[0] policy
     /* 2120740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120750 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2120753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120755 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120757 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120759 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120761 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120763 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120773 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120776 */     // GIR_Coverage, 17344,
     /* 2120776 */     GIR_EraseRootFromParent_Done,
     /* 2120777 */   // Label 28031: @2120777
     /* 2120777 */   GIM_Try, /*On fail goto*//*Label 28032*/ GIMT_Encode4(2120868), // Rule ID 17345 //
     /* 2120782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2120785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2120793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2120796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2120799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2120802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2120805 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120816 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2120824 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120828 */     // MIs[0] round
     /* 2120828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120831 */     // MIs[0] policy
     /* 2120831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120841 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11150:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2120841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M1_E32_MASK),
     /* 2120844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120846 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120850 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120852 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120854 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2120864 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120867 */     // GIR_Coverage, 17345,
     /* 2120867 */     GIR_EraseRootFromParent_Done,
     /* 2120868 */   // Label 28032: @2120868
     /* 2120868 */   GIM_Try, /*On fail goto*//*Label 28033*/ GIMT_Encode4(2120959), // Rule ID 17348 //
     /* 2120873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2120876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2120890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2120893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120896 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2120899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2120915 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2120919 */     // MIs[0] round
     /* 2120919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2120922 */     // MIs[0] policy
     /* 2120922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2120925 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2120932 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2120932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2120935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2120937 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2120939 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2120941 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2120943 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2120945 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2120947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2120952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2120955 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2120957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2120958 */     // GIR_Coverage, 17348,
     /* 2120958 */     GIR_EraseRootFromParent_Done,
     /* 2120959 */   // Label 28033: @2120959
     /* 2120959 */   GIM_Try, /*On fail goto*//*Label 28034*/ GIMT_Encode4(2121050), // Rule ID 17349 //
     /* 2120964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2120967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2120972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2120975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2120978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2120981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2120984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2120987 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2120990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2120994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2120998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2121002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2121006 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121010 */     // MIs[0] round
     /* 2121010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121013 */     // MIs[0] policy
     /* 2121013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121023 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11150:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M1_E64_MASK),
     /* 2121026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121028 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121032 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121034 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121036 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2121046 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121049 */     // GIR_Coverage, 17349,
     /* 2121049 */     GIR_EraseRootFromParent_Done,
     /* 2121050 */   // Label 28034: @2121050
     /* 2121050 */   GIM_Try, /*On fail goto*//*Label 28035*/ GIMT_Encode4(2121141), // Rule ID 17352 //
     /* 2121055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2121058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2121066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2121069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121078 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121089 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121101 */     // MIs[0] round
     /* 2121101 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121104 */     // MIs[0] policy
     /* 2121104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2121117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121119 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121121 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121123 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121125 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121127 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121137 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121140 */     // GIR_Coverage, 17352,
     /* 2121140 */     GIR_EraseRootFromParent_Done,
     /* 2121141 */   // Label 28035: @2121141
     /* 2121141 */   GIM_Try, /*On fail goto*//*Label 28036*/ GIMT_Encode4(2121232), // Rule ID 17353 //
     /* 2121146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2121149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2121157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2121160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2121163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121166 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121169 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121184 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121188 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121192 */     // MIs[0] round
     /* 2121192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121195 */     // MIs[0] policy
     /* 2121195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121205 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M2_E16_MASK),
     /* 2121208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121210 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121212 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121214 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121216 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121218 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121228 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121231 */     // GIR_Coverage, 17353,
     /* 2121231 */     GIR_EraseRootFromParent_Done,
     /* 2121232 */   // Label 28036: @2121232
     /* 2121232 */   GIM_Try, /*On fail goto*//*Label 28037*/ GIMT_Encode4(2121323), // Rule ID 17356 //
     /* 2121237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2121240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2121248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2121251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121254 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121257 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121260 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121279 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121283 */     // MIs[0] round
     /* 2121283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121286 */     // MIs[0] policy
     /* 2121286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121296 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2121299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121301 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121305 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121307 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121309 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121319 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121322 */     // GIR_Coverage, 17356,
     /* 2121322 */     GIR_EraseRootFromParent_Done,
     /* 2121323 */   // Label 28037: @2121323
     /* 2121323 */   GIM_Try, /*On fail goto*//*Label 28038*/ GIMT_Encode4(2121414), // Rule ID 17357 //
     /* 2121328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2121331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2121339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2121342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2121345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121348 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121351 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121366 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121370 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121374 */     // MIs[0] round
     /* 2121374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121377 */     // MIs[0] policy
     /* 2121377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121387 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M4_E16_MASK),
     /* 2121390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121392 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121396 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121398 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121400 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121410 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121413 */     // GIR_Coverage, 17357,
     /* 2121413 */     GIR_EraseRootFromParent_Done,
     /* 2121414 */   // Label 28038: @2121414
     /* 2121414 */   GIM_Try, /*On fail goto*//*Label 28039*/ GIMT_Encode4(2121505), // Rule ID 17360 //
     /* 2121419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2121422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2121430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2121433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2121436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2121442 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121461 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121465 */     // MIs[0] round
     /* 2121465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121468 */     // MIs[0] policy
     /* 2121468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121478 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2121481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121483 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121485 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121487 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121489 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121491 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121501 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121504 */     // GIR_Coverage, 17360,
     /* 2121504 */     GIR_EraseRootFromParent_Done,
     /* 2121505 */   // Label 28039: @2121505
     /* 2121505 */   GIM_Try, /*On fail goto*//*Label 28040*/ GIMT_Encode4(2121596), // Rule ID 17361 //
     /* 2121510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2121513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2121521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2121524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2121527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2121530 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2121533 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2121552 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121556 */     // MIs[0] round
     /* 2121556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121559 */     // MIs[0] policy
     /* 2121559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121569 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR16_M8_E16_MASK),
     /* 2121572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121574 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121576 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121578 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121580 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121582 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2121592 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121595 */     // GIR_Coverage, 17361,
     /* 2121595 */     GIR_EraseRootFromParent_Done,
     /* 2121596 */   // Label 28040: @2121596
     /* 2121596 */   GIM_Try, /*On fail goto*//*Label 28041*/ GIMT_Encode4(2121687), // Rule ID 17364 //
     /* 2121601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2121604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121624 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121643 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121647 */     // MIs[0] round
     /* 2121647 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121650 */     // MIs[0] policy
     /* 2121650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121653 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121660 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2121663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121665 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121667 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121669 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121671 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121673 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121683 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121686 */     // GIR_Coverage, 17364,
     /* 2121686 */     GIR_EraseRootFromParent_Done,
     /* 2121687 */   // Label 28041: @2121687
     /* 2121687 */   GIM_Try, /*On fail goto*//*Label 28042*/ GIMT_Encode4(2121778), // Rule ID 17365 //
     /* 2121692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2121695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2121703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2121706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2121709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121712 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2121715 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2121722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2121730 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121734 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121738 */     // MIs[0] round
     /* 2121738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121741 */     // MIs[0] policy
     /* 2121741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121744 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121751 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M2_E32_MASK),
     /* 2121754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121756 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121758 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121760 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121762 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121764 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121774 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121777 */     // GIR_Coverage, 17365,
     /* 2121777 */     GIR_EraseRootFromParent_Done,
     /* 2121778 */   // Label 28042: @2121778
     /* 2121778 */   GIM_Try, /*On fail goto*//*Label 28043*/ GIMT_Encode4(2121869), // Rule ID 17368 //
     /* 2121783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2121786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2121800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121803 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121806 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121821 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121825 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121829 */     // MIs[0] round
     /* 2121829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121832 */     // MIs[0] policy
     /* 2121832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121835 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121842 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2121842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2121845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121847 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121849 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121851 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121853 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121855 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121865 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121868 */     // GIR_Coverage, 17368,
     /* 2121868 */     GIR_EraseRootFromParent_Done,
     /* 2121869 */   // Label 28043: @2121869
     /* 2121869 */   GIM_Try, /*On fail goto*//*Label 28044*/ GIMT_Encode4(2121960), // Rule ID 17369 //
     /* 2121874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2121877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2121885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2121888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2121891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2121897 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2121900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2121904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2121912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2121916 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2121920 */     // MIs[0] round
     /* 2121920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2121923 */     // MIs[0] policy
     /* 2121923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2121926 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2121933 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2121933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M4_E32_MASK),
     /* 2121936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2121938 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2121940 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2121942 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2121944 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2121946 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2121948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2121953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2121956 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2121958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2121959 */     // GIR_Coverage, 17369,
     /* 2121959 */     GIR_EraseRootFromParent_Done,
     /* 2121960 */   // Label 28044: @2121960
     /* 2121960 */   GIM_Try, /*On fail goto*//*Label 28045*/ GIMT_Encode4(2122051), // Rule ID 17372 //
     /* 2121965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2121968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2121973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2121976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2121979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2121982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2121985 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2121988 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2121991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2121995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2121999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122003 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122007 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122011 */     // MIs[0] round
     /* 2122011 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122014 */     // MIs[0] policy
     /* 2122014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122017 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122024 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2122027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122029 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122031 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122033 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122035 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122037 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122047 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122050 */     // GIR_Coverage, 17372,
     /* 2122050 */     GIR_EraseRootFromParent_Done,
     /* 2122051 */   // Label 28045: @2122051
     /* 2122051 */   GIM_Try, /*On fail goto*//*Label 28046*/ GIMT_Encode4(2122142), // Rule ID 17373 //
     /* 2122056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2122059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2122067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2122070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2122073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2122076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2122079 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2122098 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122102 */     // MIs[0] round
     /* 2122102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122105 */     // MIs[0] policy
     /* 2122105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122108 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122115 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR32_M8_E32_MASK),
     /* 2122118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122120 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122124 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122126 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122128 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2122138 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122141 */     // GIR_Coverage, 17373,
     /* 2122141 */     GIR_EraseRootFromParent_Done,
     /* 2122142 */   // Label 28046: @2122142
     /* 2122142 */   GIM_Try, /*On fail goto*//*Label 28047*/ GIMT_Encode4(2122233), // Rule ID 17376 //
     /* 2122147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2122150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2122164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122170 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122185 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122189 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122193 */     // MIs[0] round
     /* 2122193 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122196 */     // MIs[0] policy
     /* 2122196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122206 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2122209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122211 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122213 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122215 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122217 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122219 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122229 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122232 */     // GIR_Coverage, 17376,
     /* 2122232 */     GIR_EraseRootFromParent_Done,
     /* 2122233 */   // Label 28047: @2122233
     /* 2122233 */   GIM_Try, /*On fail goto*//*Label 28048*/ GIMT_Encode4(2122324), // Rule ID 17377 //
     /* 2122238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2122241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2122249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2122252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2122255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122258 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122261 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2122268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2122276 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122280 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122284 */     // MIs[0] round
     /* 2122284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122287 */     // MIs[0] policy
     /* 2122287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122297 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11150:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M2_E64_MASK),
     /* 2122300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122302 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122304 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122306 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122308 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122310 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122320 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122323 */     // GIR_Coverage, 17377,
     /* 2122323 */     GIR_EraseRootFromParent_Done,
     /* 2122324 */   // Label 28048: @2122324
     /* 2122324 */   GIM_Try, /*On fail goto*//*Label 28049*/ GIMT_Encode4(2122415), // Rule ID 17380 //
     /* 2122329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2122332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2122346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122349 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122352 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122367 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122371 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122375 */     // MIs[0] round
     /* 2122375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122378 */     // MIs[0] policy
     /* 2122378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122388 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2122391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122393 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122397 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122399 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122401 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122411 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122414 */     // GIR_Coverage, 17380,
     /* 2122414 */     GIR_EraseRootFromParent_Done,
     /* 2122415 */   // Label 28049: @2122415
     /* 2122415 */   GIM_Try, /*On fail goto*//*Label 28050*/ GIMT_Encode4(2122506), // Rule ID 17381 //
     /* 2122420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2122423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2122431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2122434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2122437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2122443 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2122450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2122458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122462 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122466 */     // MIs[0] round
     /* 2122466 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122469 */     // MIs[0] policy
     /* 2122469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122479 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11150:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M4_E64_MASK),
     /* 2122482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122484 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122486 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122488 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122490 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122492 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122502 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122505 */     // GIR_Coverage, 17381,
     /* 2122505 */     GIR_EraseRootFromParent_Done,
     /* 2122506 */   // Label 28050: @2122506
     /* 2122506 */   GIM_Try, /*On fail goto*//*Label 28051*/ GIMT_Encode4(2122597), // Rule ID 17384 //
     /* 2122511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2122514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2122528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122531 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122534 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122553 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122557 */     // MIs[0] round
     /* 2122557 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122560 */     // MIs[0] policy
     /* 2122560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122563 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122570 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2122573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122575 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122579 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122581 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122583 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122593 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122596 */     // GIR_Coverage, 17384,
     /* 2122596 */     GIR_EraseRootFromParent_Done,
     /* 2122597 */   // Label 28051: @2122597
     /* 2122597 */   GIM_Try, /*On fail goto*//*Label 28052*/ GIMT_Encode4(2122688), // Rule ID 17385 //
     /* 2122602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2122605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmul_mask),
     /* 2122610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2122613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2122616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2122619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2122622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2122625 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2122632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2122640 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2122644 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122648 */     // MIs[0] round
     /* 2122648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122651 */     // MIs[0] policy
     /* 2122651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122661 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11150:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMUL_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VFPR64_M8_E64_MASK),
     /* 2122664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122666 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122670 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122672 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122674 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2122684 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122687 */     // GIR_Coverage, 17385,
     /* 2122687 */     GIR_EraseRootFromParent_Done,
     /* 2122688 */   // Label 28052: @2122688
     /* 2122688 */   GIM_Try, /*On fail goto*//*Label 28053*/ GIMT_Encode4(2122779), // Rule ID 17388 //
     /* 2122693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2122696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2122701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2122704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2122707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2122710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2122713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122716 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122731 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122735 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122739 */     // MIs[0] round
     /* 2122739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122742 */     // MIs[0] policy
     /* 2122742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122752 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2122755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122757 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122759 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122761 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122763 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122765 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122775 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122778 */     // GIR_Coverage, 17388,
     /* 2122778 */     GIR_EraseRootFromParent_Done,
     /* 2122779 */   // Label 28053: @2122779
     /* 2122779 */   GIM_Try, /*On fail goto*//*Label 28054*/ GIMT_Encode4(2122870), // Rule ID 17389 //
     /* 2122784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2122787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2122792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2122795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2122798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2122801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2122804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2122807 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122826 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122830 */     // MIs[0] round
     /* 2122830 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122833 */     // MIs[0] policy
     /* 2122833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122843 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2122843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16_MASK),
     /* 2122846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122848 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122850 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122852 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122854 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122856 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122866 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122869 */     // GIR_Coverage, 17389,
     /* 2122869 */     GIR_EraseRootFromParent_Done,
     /* 2122870 */   // Label 28054: @2122870
     /* 2122870 */   GIM_Try, /*On fail goto*//*Label 28055*/ GIMT_Encode4(2122961), // Rule ID 17392 //
     /* 2122875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2122878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2122883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2122886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2122889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2122892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122898 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2122901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122913 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2122917 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2122921 */     // MIs[0] round
     /* 2122921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2122924 */     // MIs[0] policy
     /* 2122924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2122927 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2122934 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2122934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2122937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2122939 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2122941 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2122943 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2122945 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2122947 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2122949 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2122954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2122957 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2122959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2122960 */     // GIR_Coverage, 17392,
     /* 2122960 */     GIR_EraseRootFromParent_Done,
     /* 2122961 */   // Label 28055: @2122961
     /* 2122961 */   GIM_Try, /*On fail goto*//*Label 28056*/ GIMT_Encode4(2123052), // Rule ID 17393 //
     /* 2122966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2122969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2122974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2122977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2122980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2122983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2122986 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2122989 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2122992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2122996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123004 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123008 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123012 */     // MIs[0] round
     /* 2123012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123015 */     // MIs[0] policy
     /* 2123015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123025 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16_MASK),
     /* 2123028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123030 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123032 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123034 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123036 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123038 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123048 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123051 */     // GIR_Coverage, 17393,
     /* 2123051 */     GIR_EraseRootFromParent_Done,
     /* 2123052 */   // Label 28056: @2123052
     /* 2123052 */   GIM_Try, /*On fail goto*//*Label 28057*/ GIMT_Encode4(2123143), // Rule ID 17396 //
     /* 2123057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2123060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123080 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123095 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123099 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123103 */     // MIs[0] round
     /* 2123103 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123106 */     // MIs[0] policy
     /* 2123106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123109 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123116 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2123119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123121 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123123 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123125 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123127 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123129 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123139 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123142 */     // GIR_Coverage, 17396,
     /* 2123142 */     GIR_EraseRootFromParent_Done,
     /* 2123143 */   // Label 28057: @2123143
     /* 2123143 */   GIM_Try, /*On fail goto*//*Label 28058*/ GIMT_Encode4(2123234), // Rule ID 17397 //
     /* 2123148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2123151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2123159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2123162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2123165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2123168 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123171 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123190 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123194 */     // MIs[0] round
     /* 2123194 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123197 */     // MIs[0] policy
     /* 2123197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123200 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123207 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32_MASK),
     /* 2123210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123212 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123216 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123218 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123220 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123230 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123233 */     // GIR_Coverage, 17397,
     /* 2123233 */     GIR_EraseRootFromParent_Done,
     /* 2123234 */   // Label 28058: @2123234
     /* 2123234 */   GIM_Try, /*On fail goto*//*Label 28059*/ GIMT_Encode4(2123325), // Rule ID 17400 //
     /* 2123239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2123242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2123250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2123253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2123256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2123259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123262 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123277 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123281 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123285 */     // MIs[0] round
     /* 2123285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123288 */     // MIs[0] policy
     /* 2123288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123291 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123298 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2123301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123303 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123307 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123309 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123311 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123321 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123324 */     // GIR_Coverage, 17400,
     /* 2123324 */     GIR_EraseRootFromParent_Done,
     /* 2123325 */   // Label 28059: @2123325
     /* 2123325 */   GIM_Try, /*On fail goto*//*Label 28060*/ GIMT_Encode4(2123416), // Rule ID 17401 //
     /* 2123330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2123333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2123341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2123344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2123347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2123350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2123353 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123364 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123368 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123372 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123376 */     // MIs[0] round
     /* 2123376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123379 */     // MIs[0] policy
     /* 2123379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123382 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123389 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16_MASK),
     /* 2123392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123394 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123396 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123398 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123400 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123402 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123412 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123415 */     // GIR_Coverage, 17401,
     /* 2123415 */     GIR_EraseRootFromParent_Done,
     /* 2123416 */   // Label 28060: @2123416
     /* 2123416 */   GIM_Try, /*On fail goto*//*Label 28061*/ GIMT_Encode4(2123507), // Rule ID 17404 //
     /* 2123421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2123424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123441 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123444 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123459 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123463 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123467 */     // MIs[0] round
     /* 2123467 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123470 */     // MIs[0] policy
     /* 2123470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123480 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2123483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123485 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123487 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123489 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123491 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123493 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123503 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123506 */     // GIR_Coverage, 17404,
     /* 2123506 */     GIR_EraseRootFromParent_Done,
     /* 2123507 */   // Label 28061: @2123507
     /* 2123507 */   GIM_Try, /*On fail goto*//*Label 28062*/ GIMT_Encode4(2123598), // Rule ID 17405 //
     /* 2123512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2123515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2123523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2123526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2123529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2123532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2123535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123554 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123558 */     // MIs[0] round
     /* 2123558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123561 */     // MIs[0] policy
     /* 2123561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123564 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123571 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32_MASK),
     /* 2123574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123576 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123578 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123580 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123582 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123584 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123586 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2123594 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123597 */     // GIR_Coverage, 17405,
     /* 2123597 */     GIR_EraseRootFromParent_Done,
     /* 2123598 */   // Label 28062: @2123598
     /* 2123598 */   GIM_Try, /*On fail goto*//*Label 28063*/ GIMT_Encode4(2123689), // Rule ID 17408 //
     /* 2123603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2123606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2123623 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123626 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123641 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123645 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123649 */     // MIs[0] round
     /* 2123649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123652 */     // MIs[0] policy
     /* 2123652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123662 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2123665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123667 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123671 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123673 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123675 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123685 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123688 */     // GIR_Coverage, 17408,
     /* 2123688 */     GIR_EraseRootFromParent_Done,
     /* 2123689 */   // Label 28063: @2123689
     /* 2123689 */   GIM_Try, /*On fail goto*//*Label 28064*/ GIMT_Encode4(2123780), // Rule ID 17409 //
     /* 2123694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2123697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2123705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2123708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2123711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2123714 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2123717 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2123724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2123736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123740 */     // MIs[0] round
     /* 2123740 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123743 */     // MIs[0] policy
     /* 2123743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123753 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64_MASK),
     /* 2123756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123758 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123760 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123762 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123764 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123766 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2123776 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123779 */     // GIR_Coverage, 17409,
     /* 2123779 */     GIR_EraseRootFromParent_Done,
     /* 2123780 */   // Label 28064: @2123780
     /* 2123780 */   GIM_Try, /*On fail goto*//*Label 28065*/ GIMT_Encode4(2123871), // Rule ID 17412 //
     /* 2123785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2123788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2123796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2123799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2123802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123808 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123823 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123827 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123831 */     // MIs[0] round
     /* 2123831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123834 */     // MIs[0] policy
     /* 2123834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123837 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123844 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2123844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2123847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123849 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123851 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123853 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123855 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123857 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123867 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123870 */     // GIR_Coverage, 17412,
     /* 2123870 */     GIR_EraseRootFromParent_Done,
     /* 2123871 */   // Label 28065: @2123871
     /* 2123871 */   GIM_Try, /*On fail goto*//*Label 28066*/ GIMT_Encode4(2123962), // Rule ID 17413 //
     /* 2123876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2123879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2123887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2123890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2123893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2123896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2123899 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2123902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2123906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2123918 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2123922 */     // MIs[0] round
     /* 2123922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2123925 */     // MIs[0] policy
     /* 2123925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2123928 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2123935 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2123935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16_MASK),
     /* 2123938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2123940 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2123942 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2123944 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2123946 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2123948 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2123950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2123955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2123958 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2123960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2123961 */     // GIR_Coverage, 17413,
     /* 2123961 */     GIR_EraseRootFromParent_Done,
     /* 2123962 */   // Label 28066: @2123962
     /* 2123962 */   GIM_Try, /*On fail goto*//*Label 28067*/ GIMT_Encode4(2124053), // Rule ID 17416 //
     /* 2123967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2123970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2123975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2123978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2123981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2123984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2123987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2123990 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2123993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2123997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124009 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124013 */     // MIs[0] round
     /* 2124013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124016 */     // MIs[0] policy
     /* 2124016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124026 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2124029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124031 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124033 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124035 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124037 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124039 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124049 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124052 */     // GIR_Coverage, 17416,
     /* 2124052 */     GIR_EraseRootFromParent_Done,
     /* 2124053 */   // Label 28067: @2124053
     /* 2124053 */   GIM_Try, /*On fail goto*//*Label 28068*/ GIMT_Encode4(2124144), // Rule ID 17417 //
     /* 2124058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2124061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2124069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2124072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2124075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2124078 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124081 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124096 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124100 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124104 */     // MIs[0] round
     /* 2124104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124107 */     // MIs[0] policy
     /* 2124107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124117 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16_MASK),
     /* 2124120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124122 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124124 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124126 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124128 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124130 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124140 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124143 */     // GIR_Coverage, 17417,
     /* 2124143 */     GIR_EraseRootFromParent_Done,
     /* 2124144 */   // Label 28068: @2124144
     /* 2124144 */   GIM_Try, /*On fail goto*//*Label 28069*/ GIMT_Encode4(2124235), // Rule ID 17420 //
     /* 2124149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2124152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2124160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2124163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2124166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2124169 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2124172 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124195 */     // MIs[0] round
     /* 2124195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124198 */     // MIs[0] policy
     /* 2124198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124208 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2124211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124213 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124217 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124219 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124221 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124223 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124231 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124234 */     // GIR_Coverage, 17420,
     /* 2124234 */     GIR_EraseRootFromParent_Done,
     /* 2124235 */   // Label 28069: @2124235
     /* 2124235 */   GIM_Try, /*On fail goto*//*Label 28070*/ GIMT_Encode4(2124326), // Rule ID 17421 //
     /* 2124240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2124243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2124251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2124254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2124257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2124260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2124263 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124282 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124286 */     // MIs[0] round
     /* 2124286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124289 */     // MIs[0] policy
     /* 2124289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124299 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16_MASK),
     /* 2124302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124304 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124308 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124310 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124312 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2124322 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124325 */     // GIR_Coverage, 17421,
     /* 2124325 */     GIR_EraseRootFromParent_Done,
     /* 2124326 */   // Label 28070: @2124326
     /* 2124326 */   GIM_Try, /*On fail goto*//*Label 28071*/ GIMT_Encode4(2124417), // Rule ID 17424 //
     /* 2124331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2124334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124348 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2124351 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124354 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124373 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124377 */     // MIs[0] round
     /* 2124377 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124380 */     // MIs[0] policy
     /* 2124380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124390 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2124393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124395 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124399 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124401 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124403 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124413 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124416 */     // GIR_Coverage, 17424,
     /* 2124416 */     GIR_EraseRootFromParent_Done,
     /* 2124417 */   // Label 28071: @2124417
     /* 2124417 */   GIM_Try, /*On fail goto*//*Label 28072*/ GIMT_Encode4(2124508), // Rule ID 17425 //
     /* 2124422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2124425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2124433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2124436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2124439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2124442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2124445 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124460 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124464 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124468 */     // MIs[0] round
     /* 2124468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124471 */     // MIs[0] policy
     /* 2124471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124481 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32_MASK),
     /* 2124484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124486 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124488 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124490 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124492 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124494 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124504 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124507 */     // GIR_Coverage, 17425,
     /* 2124507 */     GIR_EraseRootFromParent_Done,
     /* 2124508 */   // Label 28072: @2124508
     /* 2124508 */   GIM_Try, /*On fail goto*//*Label 28073*/ GIMT_Encode4(2124599), // Rule ID 17428 //
     /* 2124513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2124516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2124533 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124536 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124551 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124555 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124559 */     // MIs[0] round
     /* 2124559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124562 */     // MIs[0] policy
     /* 2124562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124572 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2124575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124577 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124579 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124581 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124583 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124585 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124595 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124598 */     // GIR_Coverage, 17428,
     /* 2124598 */     GIR_EraseRootFromParent_Done,
     /* 2124599 */   // Label 28073: @2124599
     /* 2124599 */   GIM_Try, /*On fail goto*//*Label 28074*/ GIMT_Encode4(2124690), // Rule ID 17429 //
     /* 2124604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2124607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2124615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2124618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2124621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2124624 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2124627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2124634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2124646 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124650 */     // MIs[0] round
     /* 2124650 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124653 */     // MIs[0] policy
     /* 2124653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124663 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32_MASK),
     /* 2124666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124668 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124672 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124674 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124676 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124686 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124689 */     // GIR_Coverage, 17429,
     /* 2124689 */     GIR_EraseRootFromParent_Done,
     /* 2124690 */   // Label 28074: @2124690
     /* 2124690 */   GIM_Try, /*On fail goto*//*Label 28075*/ GIMT_Encode4(2124781), // Rule ID 17432 //
     /* 2124695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2124698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2124715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124718 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124733 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124737 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124741 */     // MIs[0] round
     /* 2124741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124744 */     // MIs[0] policy
     /* 2124744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124754 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2124757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124759 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124763 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124765 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124767 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124777 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124780 */     // GIR_Coverage, 17432,
     /* 2124780 */     GIR_EraseRootFromParent_Done,
     /* 2124781 */   // Label 28075: @2124781
     /* 2124781 */   GIM_Try, /*On fail goto*//*Label 28076*/ GIMT_Encode4(2124872), // Rule ID 17433 //
     /* 2124786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2124789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2124797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2124800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2124803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2124806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2124809 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2124816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2124828 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124832 */     // MIs[0] round
     /* 2124832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124835 */     // MIs[0] policy
     /* 2124835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124845 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2124845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32_MASK),
     /* 2124848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124850 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124854 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124856 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124858 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2124868 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124871 */     // GIR_Coverage, 17433,
     /* 2124871 */     GIR_EraseRootFromParent_Done,
     /* 2124872 */   // Label 28076: @2124872
     /* 2124872 */   GIM_Try, /*On fail goto*//*Label 28077*/ GIMT_Encode4(2124963), // Rule ID 17436 //
     /* 2124877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2124880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2124897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124900 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2124903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124915 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2124919 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2124923 */     // MIs[0] round
     /* 2124923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2124926 */     // MIs[0] policy
     /* 2124926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2124929 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2124936 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2124936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2124939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2124941 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2124943 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2124945 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2124947 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2124949 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2124951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2124956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2124959 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2124961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2124962 */     // GIR_Coverage, 17436,
     /* 2124962 */     GIR_EraseRootFromParent_Done,
     /* 2124963 */   // Label 28077: @2124963
     /* 2124963 */   GIM_Try, /*On fail goto*//*Label 28078*/ GIMT_Encode4(2125054), // Rule ID 17437 //
     /* 2124968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2124971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2124976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2124979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2124982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2124985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2124988 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2124991 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2124994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2124998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125006 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2125010 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125014 */     // MIs[0] round
     /* 2125014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125017 */     // MIs[0] policy
     /* 2125017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125027 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64_MASK),
     /* 2125030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125032 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125034 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125036 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125038 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125040 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125050 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125053 */     // GIR_Coverage, 17437,
     /* 2125053 */     GIR_EraseRootFromParent_Done,
     /* 2125054 */   // Label 28078: @2125054
     /* 2125054 */   GIM_Try, /*On fail goto*//*Label 28079*/ GIMT_Encode4(2125145), // Rule ID 17440 //
     /* 2125059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2125062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2125079 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125082 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125101 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125105 */     // MIs[0] round
     /* 2125105 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125108 */     // MIs[0] policy
     /* 2125108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125118 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2125121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125123 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125127 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125129 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125131 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125141 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125144 */     // GIR_Coverage, 17440,
     /* 2125144 */     GIR_EraseRootFromParent_Done,
     /* 2125145 */   // Label 28079: @2125145
     /* 2125145 */   GIM_Try, /*On fail goto*//*Label 28080*/ GIMT_Encode4(2125236), // Rule ID 17441 //
     /* 2125150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2125153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2125161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2125164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2125167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2125170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125173 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2125180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125188 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2125192 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125196 */     // MIs[0] round
     /* 2125196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125199 */     // MIs[0] policy
     /* 2125199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125202 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125209 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64_MASK),
     /* 2125212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125214 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125216 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125218 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125220 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125222 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125232 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125235 */     // GIR_Coverage, 17441,
     /* 2125235 */     GIR_EraseRootFromParent_Done,
     /* 2125236 */   // Label 28080: @2125236
     /* 2125236 */   GIM_Try, /*On fail goto*//*Label 28081*/ GIMT_Encode4(2125327), // Rule ID 17444 //
     /* 2125241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2125244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2125261 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125264 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125283 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125287 */     // MIs[0] round
     /* 2125287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125290 */     // MIs[0] policy
     /* 2125290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125300 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2125303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125305 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125307 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125309 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125311 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125313 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125323 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125326 */     // GIR_Coverage, 17444,
     /* 2125326 */     GIR_EraseRootFromParent_Done,
     /* 2125327 */   // Label 28081: @2125327
     /* 2125327 */   GIM_Try, /*On fail goto*//*Label 28082*/ GIMT_Encode4(2125418), // Rule ID 17445 //
     /* 2125332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2125335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2125343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2125346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2125349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2125352 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2125355 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2125362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2125374 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125378 */     // MIs[0] round
     /* 2125378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125381 */     // MIs[0] policy
     /* 2125381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125384 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125391 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64_MASK),
     /* 2125394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125396 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125400 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125402 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125404 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2125414 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125417 */     // GIR_Coverage, 17445,
     /* 2125417 */     GIR_EraseRootFromParent_Done,
     /* 2125418 */   // Label 28082: @2125418
     /* 2125418 */   GIM_Try, /*On fail goto*//*Label 28083*/ GIMT_Encode4(2125509), // Rule ID 17448 //
     /* 2125423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2125434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2125437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2125440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125443 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125465 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125469 */     // MIs[0] round
     /* 2125469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125472 */     // MIs[0] policy
     /* 2125472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125482 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2125485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125487 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125491 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125493 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125495 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125505 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125508 */     // GIR_Coverage, 17448,
     /* 2125508 */     GIR_EraseRootFromParent_Done,
     /* 2125509 */   // Label 28083: @2125509
     /* 2125509 */   GIM_Try, /*On fail goto*//*Label 28084*/ GIMT_Encode4(2125600), // Rule ID 17449 //
     /* 2125514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2125517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2125525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2125528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2125531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125534 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125537 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125552 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125556 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125560 */     // MIs[0] round
     /* 2125560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125563 */     // MIs[0] policy
     /* 2125563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125573 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF4_E16_MASK),
     /* 2125576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125578 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125580 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125582 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125584 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125586 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125596 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125599 */     // GIR_Coverage, 17449,
     /* 2125599 */     GIR_EraseRootFromParent_Done,
     /* 2125600 */   // Label 28084: @2125600
     /* 2125600 */   GIM_Try, /*On fail goto*//*Label 28085*/ GIMT_Encode4(2125691), // Rule ID 17452 //
     /* 2125605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2125616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2125619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2125622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125625 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125628 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125643 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125647 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125651 */     // MIs[0] round
     /* 2125651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125654 */     // MIs[0] policy
     /* 2125654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125664 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2125667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125669 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125671 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125673 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125675 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125677 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125687 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125690 */     // GIR_Coverage, 17452,
     /* 2125690 */     GIR_EraseRootFromParent_Done,
     /* 2125691 */   // Label 28085: @2125691
     /* 2125691 */   GIM_Try, /*On fail goto*//*Label 28086*/ GIMT_Encode4(2125782), // Rule ID 17453 //
     /* 2125696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2125699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2125707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2125710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2125713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2125719 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2125738 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125742 */     // MIs[0] round
     /* 2125742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125745 */     // MIs[0] policy
     /* 2125745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125755 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_MF2_E16_MASK),
     /* 2125758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125760 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125762 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125764 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125766 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125768 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2125778 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125781 */     // GIR_Coverage, 17453,
     /* 2125781 */     GIR_EraseRootFromParent_Done,
     /* 2125782 */   // Label 28086: @2125782
     /* 2125782 */   GIM_Try, /*On fail goto*//*Label 28087*/ GIMT_Encode4(2125873), // Rule ID 17456 //
     /* 2125787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2125790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125807 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125810 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125829 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125833 */     // MIs[0] round
     /* 2125833 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125836 */     // MIs[0] policy
     /* 2125836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125839 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125846 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2125846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2125849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125851 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125853 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125855 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125857 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125859 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125869 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125872 */     // GIR_Coverage, 17456,
     /* 2125872 */     GIR_EraseRootFromParent_Done,
     /* 2125873 */   // Label 28087: @2125873
     /* 2125873 */   GIM_Try, /*On fail goto*//*Label 28088*/ GIMT_Encode4(2125964), // Rule ID 17457 //
     /* 2125878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2125881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2125889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2125892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2125895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2125898 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2125901 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2125904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2125916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2125920 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2125924 */     // MIs[0] round
     /* 2125924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2125927 */     // MIs[0] policy
     /* 2125927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2125930 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2125937 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2125937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_MF2_E32_MASK),
     /* 2125940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2125942 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2125944 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2125946 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2125948 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2125950 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2125957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2125960 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2125962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2125963 */     // GIR_Coverage, 17457,
     /* 2125963 */     GIR_EraseRootFromParent_Done,
     /* 2125964 */   // Label 28088: @2125964
     /* 2125964 */   GIM_Try, /*On fail goto*//*Label 28089*/ GIMT_Encode4(2126055), // Rule ID 17460 //
     /* 2125969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2125972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2125977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2125980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2125983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2125986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2125989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2125992 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2125995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2125999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126007 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126011 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126015 */     // MIs[0] round
     /* 2126015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126018 */     // MIs[0] policy
     /* 2126018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126028 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2126031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126033 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126037 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126039 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126041 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126051 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126054 */     // GIR_Coverage, 17460,
     /* 2126054 */     GIR_EraseRootFromParent_Done,
     /* 2126055 */   // Label 28089: @2126055
     /* 2126055 */   GIM_Try, /*On fail goto*//*Label 28090*/ GIMT_Encode4(2126146), // Rule ID 17461 //
     /* 2126060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2126063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2126071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2126074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2126077 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126080 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2126083 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126090 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126098 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126102 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126106 */     // MIs[0] round
     /* 2126106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126109 */     // MIs[0] policy
     /* 2126109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126119 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11133:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M1_E16_MASK),
     /* 2126122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126124 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126126 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126128 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126130 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126132 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126142 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126145 */     // GIR_Coverage, 17461,
     /* 2126145 */     GIR_EraseRootFromParent_Done,
     /* 2126146 */   // Label 28090: @2126146
     /* 2126146 */   GIM_Try, /*On fail goto*//*Label 28091*/ GIMT_Encode4(2126237), // Rule ID 17464 //
     /* 2126151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2126154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2126162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2126165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2126168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126174 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126189 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126193 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126197 */     // MIs[0] round
     /* 2126197 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126200 */     // MIs[0] policy
     /* 2126200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126210 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2126213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126215 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126219 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126221 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126223 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126233 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126236 */     // GIR_Coverage, 17464,
     /* 2126236 */     GIR_EraseRootFromParent_Done,
     /* 2126237 */   // Label 28091: @2126237
     /* 2126237 */   GIM_Try, /*On fail goto*//*Label 28092*/ GIMT_Encode4(2126328), // Rule ID 17465 //
     /* 2126242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2126245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2126253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2126256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2126259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2126262 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2126265 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126280 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2126284 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126288 */     // MIs[0] round
     /* 2126288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126291 */     // MIs[0] policy
     /* 2126291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126301 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11133:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M1_E32_MASK),
     /* 2126304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126306 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126310 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126312 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126314 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2126324 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126327 */     // GIR_Coverage, 17465,
     /* 2126327 */     GIR_EraseRootFromParent_Done,
     /* 2126328 */   // Label 28092: @2126328
     /* 2126328 */   GIM_Try, /*On fail goto*//*Label 28093*/ GIMT_Encode4(2126419), // Rule ID 17468 //
     /* 2126333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2126336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126356 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126375 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126379 */     // MIs[0] round
     /* 2126379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126382 */     // MIs[0] policy
     /* 2126382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126385 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126392 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2126395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126397 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126399 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126401 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126403 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126405 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126415 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126418 */     // GIR_Coverage, 17468,
     /* 2126418 */     GIR_EraseRootFromParent_Done,
     /* 2126419 */   // Label 28093: @2126419
     /* 2126419 */   GIM_Try, /*On fail goto*//*Label 28094*/ GIMT_Encode4(2126510), // Rule ID 17469 //
     /* 2126424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2126427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2126435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2126438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2126441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2126444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2126447 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2126454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2126462 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2126466 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126470 */     // MIs[0] round
     /* 2126470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126473 */     // MIs[0] policy
     /* 2126473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126483 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11133:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M1_E64_MASK),
     /* 2126486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126488 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126492 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126494 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126496 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2126506 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126509 */     // GIR_Coverage, 17469,
     /* 2126509 */     GIR_EraseRootFromParent_Done,
     /* 2126510 */   // Label 28094: @2126510
     /* 2126510 */   GIM_Try, /*On fail goto*//*Label 28095*/ GIMT_Encode4(2126601), // Rule ID 17472 //
     /* 2126515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2126518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2126526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2126529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2126532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126538 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126553 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126557 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126561 */     // MIs[0] round
     /* 2126561 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126564 */     // MIs[0] policy
     /* 2126564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126574 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2126577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126579 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126583 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126585 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126587 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126597 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126600 */     // GIR_Coverage, 17472,
     /* 2126600 */     GIR_EraseRootFromParent_Done,
     /* 2126601 */   // Label 28095: @2126601
     /* 2126601 */   GIM_Try, /*On fail goto*//*Label 28096*/ GIMT_Encode4(2126692), // Rule ID 17473 //
     /* 2126606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2126609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2126617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2126620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2126623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2126629 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2126636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2126644 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126648 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126652 */     // MIs[0] round
     /* 2126652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126655 */     // MIs[0] policy
     /* 2126655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126658 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126665 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M2_E16_MASK),
     /* 2126668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126670 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126674 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126676 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126678 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126688 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126691 */     // GIR_Coverage, 17473,
     /* 2126691 */     GIR_EraseRootFromParent_Done,
     /* 2126692 */   // Label 28096: @2126692
     /* 2126692 */   GIM_Try, /*On fail goto*//*Label 28097*/ GIMT_Encode4(2126783), // Rule ID 17476 //
     /* 2126697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2126700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2126708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2126711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2126714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126720 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126735 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126739 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126743 */     // MIs[0] round
     /* 2126743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126746 */     // MIs[0] policy
     /* 2126746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126756 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2126759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126761 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126763 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126765 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126767 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126769 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126779 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126782 */     // GIR_Coverage, 17476,
     /* 2126782 */     GIR_EraseRootFromParent_Done,
     /* 2126783 */   // Label 28097: @2126783
     /* 2126783 */   GIM_Try, /*On fail goto*//*Label 28098*/ GIMT_Encode4(2126874), // Rule ID 17477 //
     /* 2126788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2126791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2126799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2126802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2126805 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126808 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2126811 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2126818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2126826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126830 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126834 */     // MIs[0] round
     /* 2126834 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126837 */     // MIs[0] policy
     /* 2126837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126847 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2126847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M4_E16_MASK),
     /* 2126850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126852 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126854 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126856 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126858 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126860 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126870 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126873 */     // GIR_Coverage, 17477,
     /* 2126873 */     GIR_EraseRootFromParent_Done,
     /* 2126874 */   // Label 28098: @2126874
     /* 2126874 */   GIM_Try, /*On fail goto*//*Label 28099*/ GIMT_Encode4(2126965), // Rule ID 17480 //
     /* 2126879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2126882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2126890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2126893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2126896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2126902 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2126905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2126909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2126917 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2126921 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2126925 */     // MIs[0] round
     /* 2126925 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2126928 */     // MIs[0] policy
     /* 2126928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2126931 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2126938 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2126938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2126941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2126943 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2126945 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2126947 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2126949 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2126951 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2126953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2126958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2126961 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2126963 */     GIR_RootConstrainSelectedInstOperands,
     /* 2126964 */     // GIR_Coverage, 17480,
     /* 2126964 */     GIR_EraseRootFromParent_Done,
     /* 2126965 */   // Label 28099: @2126965
     /* 2126965 */   GIM_Try, /*On fail goto*//*Label 28100*/ GIMT_Encode4(2127056), // Rule ID 17481 //
     /* 2126970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2126973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2126978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2126981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2126984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2126987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2126990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2126993 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2126996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2127012 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127016 */     // MIs[0] round
     /* 2127016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127019 */     // MIs[0] policy
     /* 2127019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127022 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127029 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR16_M8_E16_MASK),
     /* 2127032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127034 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127038 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127040 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127042 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2127052 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127055 */     // GIR_Coverage, 17481,
     /* 2127055 */     GIR_EraseRootFromParent_Done,
     /* 2127056 */   // Label 28100: @2127056
     /* 2127056 */   GIM_Try, /*On fail goto*//*Label 28101*/ GIMT_Encode4(2127147), // Rule ID 17484 //
     /* 2127061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2127064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127084 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127099 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127103 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127107 */     // MIs[0] round
     /* 2127107 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127110 */     // MIs[0] policy
     /* 2127110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127113 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127120 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2127123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127125 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127129 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127131 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127133 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127143 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127146 */     // GIR_Coverage, 17484,
     /* 2127146 */     GIR_EraseRootFromParent_Done,
     /* 2127147 */   // Label 28101: @2127147
     /* 2127147 */   GIM_Try, /*On fail goto*//*Label 28102*/ GIMT_Encode4(2127238), // Rule ID 17485 //
     /* 2127152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2127155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2127163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2127166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2127169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127175 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127186 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127190 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127194 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127198 */     // MIs[0] round
     /* 2127198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127201 */     // MIs[0] policy
     /* 2127201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127211 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M2_E32_MASK),
     /* 2127214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127216 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127218 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127220 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127222 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127224 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127234 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127237 */     // GIR_Coverage, 17485,
     /* 2127237 */     GIR_EraseRootFromParent_Done,
     /* 2127238 */   // Label 28102: @2127238
     /* 2127238 */   GIM_Try, /*On fail goto*//*Label 28103*/ GIMT_Encode4(2127329), // Rule ID 17488 //
     /* 2127243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2127246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127266 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127285 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127289 */     // MIs[0] round
     /* 2127289 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127292 */     // MIs[0] policy
     /* 2127292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127295 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127302 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2127305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127307 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127311 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127313 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127315 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127325 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127328 */     // GIR_Coverage, 17488,
     /* 2127328 */     GIR_EraseRootFromParent_Done,
     /* 2127329 */   // Label 28103: @2127329
     /* 2127329 */   GIM_Try, /*On fail goto*//*Label 28104*/ GIMT_Encode4(2127420), // Rule ID 17489 //
     /* 2127334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2127337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2127345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2127348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2127351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127357 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127372 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127376 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127380 */     // MIs[0] round
     /* 2127380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127383 */     // MIs[0] policy
     /* 2127383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127393 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M4_E32_MASK),
     /* 2127396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127398 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127402 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127404 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127406 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127416 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127419 */     // GIR_Coverage, 17489,
     /* 2127419 */     GIR_EraseRootFromParent_Done,
     /* 2127420 */   // Label 28104: @2127420
     /* 2127420 */   GIM_Try, /*On fail goto*//*Label 28105*/ GIMT_Encode4(2127511), // Rule ID 17492 //
     /* 2127425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2127428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127445 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127467 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127471 */     // MIs[0] round
     /* 2127471 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127474 */     // MIs[0] policy
     /* 2127474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127484 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2127487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127489 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127493 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127495 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127497 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127499 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127507 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127510 */     // GIR_Coverage, 17492,
     /* 2127510 */     GIR_EraseRootFromParent_Done,
     /* 2127511 */   // Label 28105: @2127511
     /* 2127511 */   GIM_Try, /*On fail goto*//*Label 28106*/ GIMT_Encode4(2127602), // Rule ID 17493 //
     /* 2127516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2127519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2127527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2127530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2127533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2127536 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2127539 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2127546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2127554 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2127558 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127562 */     // MIs[0] round
     /* 2127562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127565 */     // MIs[0] policy
     /* 2127565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127575 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR32_M8_E32_MASK),
     /* 2127578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127580 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127584 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127586 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127588 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2127598 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127601 */     // GIR_Coverage, 17493,
     /* 2127601 */     GIR_EraseRootFromParent_Done,
     /* 2127602 */   // Label 28106: @2127602
     /* 2127602 */   GIM_Try, /*On fail goto*//*Label 28107*/ GIMT_Encode4(2127693), // Rule ID 17496 //
     /* 2127607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2127610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2127618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2127621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2127624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2127627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127630 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2127649 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127653 */     // MIs[0] round
     /* 2127653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127656 */     // MIs[0] policy
     /* 2127656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127659 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127666 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2127669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127671 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127675 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127677 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127679 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2127689 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127692 */     // GIR_Coverage, 17496,
     /* 2127692 */     GIR_EraseRootFromParent_Done,
     /* 2127693 */   // Label 28107: @2127693
     /* 2127693 */   GIM_Try, /*On fail goto*//*Label 28108*/ GIMT_Encode4(2127784), // Rule ID 17497 //
     /* 2127698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2127701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2127709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2127712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2127715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2127718 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2127721 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2127728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2127736 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2127740 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127744 */     // MIs[0] round
     /* 2127744 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127747 */     // MIs[0] policy
     /* 2127747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127757 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11133:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M2_E64_MASK),
     /* 2127760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127762 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127766 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127768 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127770 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2127780 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127783 */     // GIR_Coverage, 17497,
     /* 2127783 */     GIR_EraseRootFromParent_Done,
     /* 2127784 */   // Label 28108: @2127784
     /* 2127784 */   GIM_Try, /*On fail goto*//*Label 28109*/ GIMT_Encode4(2127875), // Rule ID 17500 //
     /* 2127789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2127792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2127809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127812 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2127831 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127835 */     // MIs[0] round
     /* 2127835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127838 */     // MIs[0] policy
     /* 2127838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127848 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2127848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2127851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127853 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127857 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127859 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127861 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2127871 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127873 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127874 */     // GIR_Coverage, 17500,
     /* 2127874 */     GIR_EraseRootFromParent_Done,
     /* 2127875 */   // Label 28109: @2127875
     /* 2127875 */   GIM_Try, /*On fail goto*//*Label 28110*/ GIMT_Encode4(2127966), // Rule ID 17501 //
     /* 2127880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2127883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2127891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2127894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2127897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2127900 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2127903 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2127906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2127910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2127918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2127922 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2127926 */     // MIs[0] round
     /* 2127926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2127929 */     // MIs[0] policy
     /* 2127929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2127932 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2127939 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11133:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2127939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M4_E64_MASK),
     /* 2127942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2127944 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2127946 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2127948 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2127950 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2127952 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2127954 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2127959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2127962 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2127964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2127965 */     // GIR_Coverage, 17501,
     /* 2127965 */     GIR_EraseRootFromParent_Done,
     /* 2127966 */   // Label 28110: @2127966
     /* 2127966 */   GIM_Try, /*On fail goto*//*Label 28111*/ GIMT_Encode4(2128057), // Rule ID 17504 //
     /* 2127971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2127974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2127979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2127982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2127985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2127988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2127991 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2127994 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2127997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2128013 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128017 */     // MIs[0] round
     /* 2128017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128020 */     // MIs[0] policy
     /* 2128020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128030 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2128033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128035 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128039 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128041 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128043 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2128053 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128056 */     // GIR_Coverage, 17504,
     /* 2128056 */     GIR_EraseRootFromParent_Done,
     /* 2128057 */   // Label 28111: @2128057
     /* 2128057 */   GIM_Try, /*On fail goto*//*Label 28112*/ GIMT_Encode4(2128148), // Rule ID 17505 //
     /* 2128062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2128065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfdiv_mask),
     /* 2128070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2128073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2128076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2128079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2128082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2128085 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2128092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2128100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2128104 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128108 */     // MIs[0] round
     /* 2128108 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128111 */     // MIs[0] policy
     /* 2128111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128121 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11133:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VFPR64_M8_E64_MASK),
     /* 2128124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128126 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128128 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128130 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128132 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128134 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2128144 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128147 */     // GIR_Coverage, 17505,
     /* 2128147 */     GIR_EraseRootFromParent_Done,
     /* 2128148 */   // Label 28112: @2128148
     /* 2128148 */   GIM_Try, /*On fail goto*//*Label 28113*/ GIMT_Encode4(2128239), // Rule ID 17508 //
     /* 2128153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128173 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128176 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128195 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128199 */     // MIs[0] round
     /* 2128199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128202 */     // MIs[0] policy
     /* 2128202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128205 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128212 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2128215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128217 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128221 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128223 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128225 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128235 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128238 */     // GIR_Coverage, 17508,
     /* 2128238 */     GIR_EraseRootFromParent_Done,
     /* 2128239 */   // Label 28113: @2128239
     /* 2128239 */   GIM_Try, /*On fail goto*//*Label 28114*/ GIMT_Encode4(2128330), // Rule ID 17509 //
     /* 2128244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2128255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2128258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2128261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128267 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128286 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128290 */     // MIs[0] round
     /* 2128290 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128293 */     // MIs[0] policy
     /* 2128293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128303 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF4_E16_MASK),
     /* 2128306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128308 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128312 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128314 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128316 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128326 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128329 */     // GIR_Coverage, 17509,
     /* 2128329 */     GIR_EraseRootFromParent_Done,
     /* 2128330 */   // Label 28114: @2128330
     /* 2128330 */   GIM_Try, /*On fail goto*//*Label 28115*/ GIMT_Encode4(2128421), // Rule ID 17512 //
     /* 2128335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128358 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128377 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128381 */     // MIs[0] round
     /* 2128381 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128384 */     // MIs[0] policy
     /* 2128384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128394 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2128397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128399 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128401 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128403 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128405 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128407 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128417 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128420 */     // GIR_Coverage, 17512,
     /* 2128420 */     GIR_EraseRootFromParent_Done,
     /* 2128421 */   // Label 28115: @2128421
     /* 2128421 */   GIM_Try, /*On fail goto*//*Label 28116*/ GIMT_Encode4(2128512), // Rule ID 17513 //
     /* 2128426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2128437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2128440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2128443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128446 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128449 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128468 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128472 */     // MIs[0] round
     /* 2128472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128475 */     // MIs[0] policy
     /* 2128475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128485 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_MF2_E16_MASK),
     /* 2128488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128490 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128492 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128494 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128496 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128498 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128508 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128511 */     // GIR_Coverage, 17513,
     /* 2128511 */     GIR_EraseRootFromParent_Done,
     /* 2128512 */   // Label 28116: @2128512
     /* 2128512 */   GIM_Try, /*On fail goto*//*Label 28117*/ GIMT_Encode4(2128603), // Rule ID 17516 //
     /* 2128517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128537 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128540 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128559 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128563 */     // MIs[0] round
     /* 2128563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128566 */     // MIs[0] policy
     /* 2128566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128569 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128576 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2128579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128581 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128585 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128587 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128589 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128591 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128599 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128602 */     // GIR_Coverage, 17516,
     /* 2128602 */     GIR_EraseRootFromParent_Done,
     /* 2128603 */   // Label 28117: @2128603
     /* 2128603 */   GIM_Try, /*On fail goto*//*Label 28118*/ GIMT_Encode4(2128694), // Rule ID 17517 //
     /* 2128608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2128619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2128622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2128625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2128631 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128650 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128654 */     // MIs[0] round
     /* 2128654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128657 */     // MIs[0] policy
     /* 2128657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128660 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128667 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_MF2_E32_MASK),
     /* 2128670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128672 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128674 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128676 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128678 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128680 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128690 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128693 */     // GIR_Coverage, 17517,
     /* 2128693 */     GIR_EraseRootFromParent_Done,
     /* 2128694 */   // Label 28118: @2128694
     /* 2128694 */   GIM_Try, /*On fail goto*//*Label 28119*/ GIMT_Encode4(2128785), // Rule ID 17520 //
     /* 2128699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2128702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2128710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2128713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2128716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128722 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128741 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128745 */     // MIs[0] round
     /* 2128745 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128748 */     // MIs[0] policy
     /* 2128748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128758 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2128761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128763 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128767 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128769 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128771 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128781 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128784 */     // GIR_Coverage, 17520,
     /* 2128784 */     GIR_EraseRootFromParent_Done,
     /* 2128785 */   // Label 28119: @2128785
     /* 2128785 */   GIM_Try, /*On fail goto*//*Label 28120*/ GIMT_Encode4(2128876), // Rule ID 17521 //
     /* 2128790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2128793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2128801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2128804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2128807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2128810 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2128813 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128828 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2128832 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128836 */     // MIs[0] round
     /* 2128836 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128839 */     // MIs[0] policy
     /* 2128839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128842 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128849 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11181:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2128849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M1_E16_MASK),
     /* 2128852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128854 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128856 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128858 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128860 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128862 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2128872 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128875 */     // GIR_Coverage, 17521,
     /* 2128875 */     GIR_EraseRootFromParent_Done,
     /* 2128876 */   // Label 28120: @2128876
     /* 2128876 */   GIM_Try, /*On fail goto*//*Label 28121*/ GIMT_Encode4(2128967), // Rule ID 17524 //
     /* 2128881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2128884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2128892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2128895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2128898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128904 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2128907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2128911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2128919 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2128923 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2128927 */     // MIs[0] round
     /* 2128927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2128930 */     // MIs[0] policy
     /* 2128930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2128933 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2128940 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2128940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2128943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2128945 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2128947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2128949 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2128951 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2128953 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2128955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2128960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2128963 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2128965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2128966 */     // GIR_Coverage, 17524,
     /* 2128966 */     GIR_EraseRootFromParent_Done,
     /* 2128967 */   // Label 28121: @2128967
     /* 2128967 */   GIM_Try, /*On fail goto*//*Label 28122*/ GIMT_Encode4(2129058), // Rule ID 17525 //
     /* 2128972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2128975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2128980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2128983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2128986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2128989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2128992 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2128995 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2128998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129010 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2129014 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129018 */     // MIs[0] round
     /* 2129018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129021 */     // MIs[0] policy
     /* 2129021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129031 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11181:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M1_E32_MASK),
     /* 2129034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129036 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129038 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129040 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129042 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129044 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129054 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129057 */     // GIR_Coverage, 17525,
     /* 2129057 */     GIR_EraseRootFromParent_Done,
     /* 2129058 */   // Label 28122: @2129058
     /* 2129058 */   GIM_Try, /*On fail goto*//*Label 28123*/ GIMT_Encode4(2129149), // Rule ID 17528 //
     /* 2129063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2129066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129080 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2129083 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129086 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129101 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2129105 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129109 */     // MIs[0] round
     /* 2129109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129112 */     // MIs[0] policy
     /* 2129112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129115 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129122 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2129125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129127 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129129 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129131 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129133 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129135 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129145 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129148 */     // GIR_Coverage, 17528,
     /* 2129148 */     GIR_EraseRootFromParent_Done,
     /* 2129149 */   // Label 28123: @2129149
     /* 2129149 */   GIM_Try, /*On fail goto*//*Label 28124*/ GIMT_Encode4(2129240), // Rule ID 17529 //
     /* 2129154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2129157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2129165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2129168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2129171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2129174 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2129177 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2129184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2129192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2129196 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129200 */     // MIs[0] round
     /* 2129200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129203 */     // MIs[0] policy
     /* 2129203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129213 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11181:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M1_E64_MASK),
     /* 2129216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129218 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129220 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129222 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129224 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129226 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2129236 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129239 */     // GIR_Coverage, 17529,
     /* 2129239 */     GIR_EraseRootFromParent_Done,
     /* 2129240 */   // Label 28124: @2129240
     /* 2129240 */   GIM_Try, /*On fail goto*//*Label 28125*/ GIMT_Encode4(2129331), // Rule ID 17532 //
     /* 2129245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129265 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129268 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129287 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129291 */     // MIs[0] round
     /* 2129291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129294 */     // MIs[0] policy
     /* 2129294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129297 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129304 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2129307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129309 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129311 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129313 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129315 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129317 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129327 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129330 */     // GIR_Coverage, 17532,
     /* 2129330 */     GIR_EraseRootFromParent_Done,
     /* 2129331 */   // Label 28125: @2129331
     /* 2129331 */   GIM_Try, /*On fail goto*//*Label 28126*/ GIMT_Encode4(2129422), // Rule ID 17533 //
     /* 2129336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2129347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2129350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2129353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129359 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129374 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129378 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129382 */     // MIs[0] round
     /* 2129382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129385 */     // MIs[0] policy
     /* 2129385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129395 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M2_E16_MASK),
     /* 2129398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129400 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129402 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129404 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129406 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129408 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129418 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129421 */     // GIR_Coverage, 17533,
     /* 2129421 */     GIR_EraseRootFromParent_Done,
     /* 2129422 */   // Label 28126: @2129422
     /* 2129422 */   GIM_Try, /*On fail goto*//*Label 28127*/ GIMT_Encode4(2129513), // Rule ID 17536 //
     /* 2129427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129465 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129469 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129473 */     // MIs[0] round
     /* 2129473 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129476 */     // MIs[0] policy
     /* 2129476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129479 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129486 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2129489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129491 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129493 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129495 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129497 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129499 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129509 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129512 */     // GIR_Coverage, 17536,
     /* 2129512 */     GIR_EraseRootFromParent_Done,
     /* 2129513 */   // Label 28127: @2129513
     /* 2129513 */   GIM_Try, /*On fail goto*//*Label 28128*/ GIMT_Encode4(2129604), // Rule ID 17537 //
     /* 2129518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2129529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2129532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2129535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2129541 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2129548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2129556 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129560 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129564 */     // MIs[0] round
     /* 2129564 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129567 */     // MIs[0] policy
     /* 2129567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129570 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129577 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M4_E16_MASK),
     /* 2129580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129582 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129586 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129588 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129590 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129592 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129600 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129603 */     // GIR_Coverage, 17537,
     /* 2129603 */     GIR_EraseRootFromParent_Done,
     /* 2129604 */   // Label 28128: @2129604
     /* 2129604 */   GIM_Try, /*On fail goto*//*Label 28129*/ GIMT_Encode4(2129695), // Rule ID 17540 //
     /* 2129609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2129612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2129620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2129623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2129626 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129629 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2129632 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129655 */     // MIs[0] round
     /* 2129655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129658 */     // MIs[0] policy
     /* 2129658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129668 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2129671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129673 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129677 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129679 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129681 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129691 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129694 */     // GIR_Coverage, 17540,
     /* 2129694 */     GIR_EraseRootFromParent_Done,
     /* 2129695 */   // Label 28129: @2129695
     /* 2129695 */   GIM_Try, /*On fail goto*//*Label 28130*/ GIMT_Encode4(2129786), // Rule ID 17541 //
     /* 2129700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2129703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2129711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2129714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2129717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2129720 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2129723 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2129730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2129738 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2129742 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129746 */     // MIs[0] round
     /* 2129746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129749 */     // MIs[0] policy
     /* 2129749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129752 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129759 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR16_M8_E16_MASK),
     /* 2129762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129764 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129766 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129768 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129770 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129772 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2129782 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129785 */     // GIR_Coverage, 17541,
     /* 2129785 */     GIR_EraseRootFromParent_Done,
     /* 2129786 */   // Label 28130: @2129786
     /* 2129786 */   GIM_Try, /*On fail goto*//*Label 28131*/ GIMT_Encode4(2129877), // Rule ID 17544 //
     /* 2129791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2129802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2129805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2129808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2129811 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129814 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129829 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2129833 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129837 */     // MIs[0] round
     /* 2129837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129840 */     // MIs[0] policy
     /* 2129840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129843 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129850 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2129850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2129853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129855 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129857 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129859 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129861 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129863 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129873 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129876 */     // GIR_Coverage, 17544,
     /* 2129876 */     GIR_EraseRootFromParent_Done,
     /* 2129877 */   // Label 28131: @2129877
     /* 2129877 */   GIM_Try, /*On fail goto*//*Label 28132*/ GIMT_Encode4(2129968), // Rule ID 17545 //
     /* 2129882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2129885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2129893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2129896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2129899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2129902 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2129905 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2129908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2129912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2129920 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2129924 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2129928 */     // MIs[0] round
     /* 2129928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2129931 */     // MIs[0] policy
     /* 2129931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2129934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2129941 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2129941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M2_E32_MASK),
     /* 2129944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2129946 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2129948 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2129950 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2129952 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2129954 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2129956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2129961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2129964 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2129966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2129967 */     // GIR_Coverage, 17545,
     /* 2129967 */     GIR_EraseRootFromParent_Done,
     /* 2129968 */   // Label 28132: @2129968
     /* 2129968 */   GIM_Try, /*On fail goto*//*Label 28133*/ GIMT_Encode4(2130059), // Rule ID 17548 //
     /* 2129973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2129976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2129981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2129984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2129987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2129990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2129993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2129996 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2129999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130011 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130015 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130019 */     // MIs[0] round
     /* 2130019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130022 */     // MIs[0] policy
     /* 2130022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130032 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2130035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130037 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130041 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130043 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130045 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130055 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130058 */     // GIR_Coverage, 17548,
     /* 2130058 */     GIR_EraseRootFromParent_Done,
     /* 2130059 */   // Label 28133: @2130059
     /* 2130059 */   GIM_Try, /*On fail goto*//*Label 28134*/ GIMT_Encode4(2130150), // Rule ID 17549 //
     /* 2130064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2130075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2130078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2130081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130087 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130102 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130106 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130110 */     // MIs[0] round
     /* 2130110 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130113 */     // MIs[0] policy
     /* 2130113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130116 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130123 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M4_E32_MASK),
     /* 2130126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130128 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130130 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130132 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130134 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130136 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130138 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130146 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130149 */     // GIR_Coverage, 17549,
     /* 2130149 */     GIR_EraseRootFromParent_Done,
     /* 2130150 */   // Label 28134: @2130150
     /* 2130150 */   GIM_Try, /*On fail goto*//*Label 28135*/ GIMT_Encode4(2130241), // Rule ID 17552 //
     /* 2130155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2130158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130178 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130197 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130201 */     // MIs[0] round
     /* 2130201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130204 */     // MIs[0] policy
     /* 2130204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130214 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2130217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130219 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130221 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130223 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130225 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130227 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130237 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130240 */     // GIR_Coverage, 17552,
     /* 2130240 */     GIR_EraseRootFromParent_Done,
     /* 2130241 */   // Label 28135: @2130241
     /* 2130241 */   GIM_Try, /*On fail goto*//*Label 28136*/ GIMT_Encode4(2130332), // Rule ID 17553 //
     /* 2130246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2130249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2130257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2130260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2130263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2130266 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2130269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130284 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2130288 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130292 */     // MIs[0] round
     /* 2130292 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130295 */     // MIs[0] policy
     /* 2130295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130298 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130305 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR32_M8_E32_MASK),
     /* 2130308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130310 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130312 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130314 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130316 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130318 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2130328 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130331 */     // GIR_Coverage, 17553,
     /* 2130331 */     GIR_EraseRootFromParent_Done,
     /* 2130332 */   // Label 28136: @2130332
     /* 2130332 */   GIM_Try, /*On fail goto*//*Label 28137*/ GIMT_Encode4(2130423), // Rule ID 17556 //
     /* 2130337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130357 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130360 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130375 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130379 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130383 */     // MIs[0] round
     /* 2130383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130386 */     // MIs[0] policy
     /* 2130386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130396 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2130399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130401 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130405 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130407 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130409 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130419 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130422 */     // GIR_Coverage, 17556,
     /* 2130422 */     GIR_EraseRootFromParent_Done,
     /* 2130423 */   // Label 28137: @2130423
     /* 2130423 */   GIM_Try, /*On fail goto*//*Label 28138*/ GIMT_Encode4(2130514), // Rule ID 17557 //
     /* 2130428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2130439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2130442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2130445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130448 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2130451 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2130458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2130466 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130470 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130474 */     // MIs[0] round
     /* 2130474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130477 */     // MIs[0] policy
     /* 2130477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130480 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130487 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11181:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M2_E64_MASK),
     /* 2130490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130492 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130496 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130498 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130500 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130510 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130513 */     // GIR_Coverage, 17557,
     /* 2130513 */     GIR_EraseRootFromParent_Done,
     /* 2130514 */   // Label 28138: @2130514
     /* 2130514 */   GIM_Try, /*On fail goto*//*Label 28139*/ GIMT_Encode4(2130605), // Rule ID 17560 //
     /* 2130519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130542 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130557 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130561 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130565 */     // MIs[0] round
     /* 2130565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130568 */     // MIs[0] policy
     /* 2130568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130578 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2130581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130583 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130585 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130587 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130589 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130591 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130601 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130604 */     // GIR_Coverage, 17560,
     /* 2130604 */     GIR_EraseRootFromParent_Done,
     /* 2130605 */   // Label 28139: @2130605
     /* 2130605 */   GIM_Try, /*On fail goto*//*Label 28140*/ GIMT_Encode4(2130696), // Rule ID 17561 //
     /* 2130610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2130621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2130624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2130627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2130633 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2130640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2130648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130652 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130656 */     // MIs[0] round
     /* 2130656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130659 */     // MIs[0] policy
     /* 2130659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130669 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11181:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M4_E64_MASK),
     /* 2130672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130674 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130676 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130678 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130680 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130682 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130692 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130695 */     // GIR_Coverage, 17561,
     /* 2130695 */     GIR_EraseRootFromParent_Done,
     /* 2130696 */   // Label 28140: @2130696
     /* 2130696 */   GIM_Try, /*On fail goto*//*Label 28141*/ GIMT_Encode4(2130787), // Rule ID 17564 //
     /* 2130701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2130704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2130712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2130715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2130718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130724 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130735 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130739 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130743 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130747 */     // MIs[0] round
     /* 2130747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130750 */     // MIs[0] policy
     /* 2130750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130760 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2130763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130765 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130767 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130769 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130771 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130773 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130783 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130785 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130786 */     // GIR_Coverage, 17564,
     /* 2130786 */     GIR_EraseRootFromParent_Done,
     /* 2130787 */   // Label 28141: @2130787
     /* 2130787 */   GIM_Try, /*On fail goto*//*Label 28142*/ GIMT_Encode4(2130878), // Rule ID 17565 //
     /* 2130792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2130795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfrdiv_mask),
     /* 2130800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2130803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2130806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2130809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2130812 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2130815 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2130818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2130822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2130830 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2130834 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130838 */     // MIs[0] round
     /* 2130838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130841 */     // MIs[0] policy
     /* 2130841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130844 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130851 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11181:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFRDIV_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2130851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFRDIV_VFPR64_M8_E64_MASK),
     /* 2130854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130856 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130860 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130862 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130864 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2130874 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130877 */     // GIR_Coverage, 17565,
     /* 2130877 */     GIR_EraseRootFromParent_Done,
     /* 2130878 */   // Label 28142: @2130878
     /* 2130878 */   GIM_Try, /*On fail goto*//*Label 28143*/ GIMT_Encode4(2130969), // Rule ID 17568 //
     /* 2130883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2130886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2130891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2130900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2130903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130906 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2130909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2130913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130921 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2130925 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2130929 */     // MIs[0] round
     /* 2130929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2130932 */     // MIs[0] policy
     /* 2130932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2130935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2130942 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2130942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2130945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2130947 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2130949 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2130951 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2130953 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2130955 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2130957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2130962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2130965 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2130967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2130968 */     // GIR_Coverage, 17568,
     /* 2130968 */     GIR_EraseRootFromParent_Done,
     /* 2130969 */   // Label 28143: @2130969
     /* 2130969 */   GIM_Try, /*On fail goto*//*Label 28144*/ GIMT_Encode4(2131060), // Rule ID 17569 //
     /* 2130974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2130977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2130982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2130985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2130988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2130991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2130994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2130997 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131016 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131020 */     // MIs[0] round
     /* 2131020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131023 */     // MIs[0] policy
     /* 2131023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131033 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF4_E16_MASK),
     /* 2131036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131038 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131042 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131044 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131046 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131056 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131059 */     // GIR_Coverage, 17569,
     /* 2131059 */     GIR_EraseRootFromParent_Done,
     /* 2131060 */   // Label 28144: @2131060
     /* 2131060 */   GIM_Try, /*On fail goto*//*Label 28145*/ GIMT_Encode4(2131151), // Rule ID 17572 //
     /* 2131065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2131076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2131079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2131085 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131103 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131107 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131111 */     // MIs[0] round
     /* 2131111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131114 */     // MIs[0] policy
     /* 2131114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131124 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2131127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131129 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131131 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131133 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131135 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131137 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131147 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131150 */     // GIR_Coverage, 17572,
     /* 2131150 */     GIR_EraseRootFromParent_Done,
     /* 2131151 */   // Label 28145: @2131151
     /* 2131151 */   GIM_Try, /*On fail goto*//*Label 28146*/ GIMT_Encode4(2131242), // Rule ID 17573 //
     /* 2131156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2131167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2131170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2131173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2131176 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131179 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131198 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131202 */     // MIs[0] round
     /* 2131202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131205 */     // MIs[0] policy
     /* 2131205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131215 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E16_MASK),
     /* 2131218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131220 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131222 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131224 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131226 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131228 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131230 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131238 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131241 */     // GIR_Coverage, 17573,
     /* 2131241 */     GIR_EraseRootFromParent_Done,
     /* 2131242 */   // Label 28146: @2131242
     /* 2131242 */   GIM_Try, /*On fail goto*//*Label 28147*/ GIMT_Encode4(2131333), // Rule ID 17576 //
     /* 2131247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2131267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131270 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131289 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131293 */     // MIs[0] round
     /* 2131293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131296 */     // MIs[0] policy
     /* 2131296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131299 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131306 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2131309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131311 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131313 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131315 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131317 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131319 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131329 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131332 */     // GIR_Coverage, 17576,
     /* 2131332 */     GIR_EraseRootFromParent_Done,
     /* 2131333 */   // Label 28147: @2131333
     /* 2131333 */   GIM_Try, /*On fail goto*//*Label 28148*/ GIMT_Encode4(2131424), // Rule ID 17577 //
     /* 2131338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2131349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2131352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2131355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2131358 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2131361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2131368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131380 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131384 */     // MIs[0] round
     /* 2131384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131387 */     // MIs[0] policy
     /* 2131387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131397 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E16_MASK),
     /* 2131400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131402 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131406 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131408 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131410 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131420 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131423 */     // GIR_Coverage, 17577,
     /* 2131423 */     GIR_EraseRootFromParent_Done,
     /* 2131424 */   // Label 28148: @2131424
     /* 2131424 */   GIM_Try, /*On fail goto*//*Label 28149*/ GIMT_Encode4(2131515), // Rule ID 17580 //
     /* 2131429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2131446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2131449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131452 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131471 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131475 */     // MIs[0] round
     /* 2131475 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131478 */     // MIs[0] policy
     /* 2131478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131481 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131488 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2131491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131493 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131497 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131499 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131501 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131511 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131514 */     // GIR_Coverage, 17580,
     /* 2131514 */     GIR_EraseRootFromParent_Done,
     /* 2131515 */   // Label 28149: @2131515
     /* 2131515 */   GIM_Try, /*On fail goto*//*Label 28150*/ GIMT_Encode4(2131606), // Rule ID 17581 //
     /* 2131520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2131531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2131534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2131537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2131540 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2131543 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2131550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2131562 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131566 */     // MIs[0] round
     /* 2131566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131569 */     // MIs[0] policy
     /* 2131569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131579 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E16_MASK),
     /* 2131582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131584 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131586 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131588 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131590 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131592 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131602 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131605 */     // GIR_Coverage, 17581,
     /* 2131605 */     GIR_EraseRootFromParent_Done,
     /* 2131606 */   // Label 28150: @2131606
     /* 2131606 */   GIM_Try, /*On fail goto*//*Label 28151*/ GIMT_Encode4(2131697), // Rule ID 17584 //
     /* 2131611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2131614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2131628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2131631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131634 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131653 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131657 */     // MIs[0] round
     /* 2131657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131660 */     // MIs[0] policy
     /* 2131660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131670 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2131673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131675 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131677 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131679 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131681 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131683 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131693 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131696 */     // GIR_Coverage, 17584,
     /* 2131696 */     GIR_EraseRootFromParent_Done,
     /* 2131697 */   // Label 28151: @2131697
     /* 2131697 */   GIM_Try, /*On fail goto*//*Label 28152*/ GIMT_Encode4(2131788), // Rule ID 17585 //
     /* 2131702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2131705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2131713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2131716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2131719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2131722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2131725 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2131732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2131736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131740 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2131744 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131748 */     // MIs[0] round
     /* 2131748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131751 */     // MIs[0] policy
     /* 2131751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131761 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E16_MASK),
     /* 2131764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131766 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131768 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131770 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131772 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131774 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2131784 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131787 */     // GIR_Coverage, 17585,
     /* 2131787 */     GIR_EraseRootFromParent_Done,
     /* 2131788 */   // Label 28152: @2131788
     /* 2131788 */   GIM_Try, /*On fail goto*//*Label 28153*/ GIMT_Encode4(2131879), // Rule ID 17588 //
     /* 2131793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2131796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2131804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2131807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2131813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131816 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2131819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131835 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131839 */     // MIs[0] round
     /* 2131839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131842 */     // MIs[0] policy
     /* 2131842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131852 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2131852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2131855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131857 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131859 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131861 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131863 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131865 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131875 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131878 */     // GIR_Coverage, 17588,
     /* 2131878 */     GIR_EraseRootFromParent_Done,
     /* 2131879 */   // Label 28153: @2131879
     /* 2131879 */   GIM_Try, /*On fail goto*//*Label 28154*/ GIMT_Encode4(2131970), // Rule ID 17589 //
     /* 2131884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2131887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2131895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2131898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2131901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2131904 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2131907 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2131910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2131914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131922 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2131926 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2131930 */     // MIs[0] round
     /* 2131930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2131933 */     // MIs[0] policy
     /* 2131933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2131936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2131943 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2131943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_MF2_E32_MASK),
     /* 2131946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2131948 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2131950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2131952 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2131954 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2131956 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2131958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2131963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2131966 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2131968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2131969 */     // GIR_Coverage, 17589,
     /* 2131969 */     GIR_EraseRootFromParent_Done,
     /* 2131970 */   // Label 28154: @2131970
     /* 2131970 */   GIM_Try, /*On fail goto*//*Label 28155*/ GIMT_Encode4(2132061), // Rule ID 17592 //
     /* 2131975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2131978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2131983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2131986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2131989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2131992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2131995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2131998 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132017 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132021 */     // MIs[0] round
     /* 2132021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132024 */     // MIs[0] policy
     /* 2132024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132027 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132034 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2132037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132039 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132041 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132043 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132045 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132047 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132057 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132060 */     // GIR_Coverage, 17592,
     /* 2132060 */     GIR_EraseRootFromParent_Done,
     /* 2132061 */   // Label 28155: @2132061
     /* 2132061 */   GIM_Try, /*On fail goto*//*Label 28156*/ GIMT_Encode4(2132152), // Rule ID 17593 //
     /* 2132066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2132069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2132077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2132080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2132083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2132086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132089 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132104 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132108 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132112 */     // MIs[0] round
     /* 2132112 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132115 */     // MIs[0] policy
     /* 2132115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132125 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M1_E32_MASK),
     /* 2132128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132130 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132132 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132134 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132136 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132138 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132148 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132151 */     // GIR_Coverage, 17593,
     /* 2132151 */     GIR_EraseRootFromParent_Done,
     /* 2132152 */   // Label 28156: @2132152
     /* 2132152 */   GIM_Try, /*On fail goto*//*Label 28157*/ GIMT_Encode4(2132243), // Rule ID 17596 //
     /* 2132157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2132160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2132168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2132171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2132177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132180 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132195 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132199 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132203 */     // MIs[0] round
     /* 2132203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132206 */     // MIs[0] policy
     /* 2132206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132216 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2132219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132221 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132223 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132225 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132227 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132229 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132239 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132242 */     // GIR_Coverage, 17596,
     /* 2132242 */     GIR_EraseRootFromParent_Done,
     /* 2132243 */   // Label 28157: @2132243
     /* 2132243 */   GIM_Try, /*On fail goto*//*Label 28158*/ GIMT_Encode4(2132334), // Rule ID 17597 //
     /* 2132248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2132251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2132259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2132262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2132265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2132268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132271 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2132278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132290 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132294 */     // MIs[0] round
     /* 2132294 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132297 */     // MIs[0] policy
     /* 2132297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132307 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M2_E32_MASK),
     /* 2132310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132312 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132314 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132316 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132318 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132320 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132330 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132333 */     // GIR_Coverage, 17597,
     /* 2132333 */     GIR_EraseRootFromParent_Done,
     /* 2132334 */   // Label 28158: @2132334
     /* 2132334 */   GIM_Try, /*On fail goto*//*Label 28159*/ GIMT_Encode4(2132425), // Rule ID 17600 //
     /* 2132339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2132342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2132356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2132359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132362 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132377 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132381 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132385 */     // MIs[0] round
     /* 2132385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132388 */     // MIs[0] policy
     /* 2132388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132398 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2132401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132403 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132405 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132407 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132409 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132411 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132421 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132424 */     // GIR_Coverage, 17600,
     /* 2132424 */     GIR_EraseRootFromParent_Done,
     /* 2132425 */   // Label 28159: @2132425
     /* 2132425 */   GIM_Try, /*On fail goto*//*Label 28160*/ GIMT_Encode4(2132516), // Rule ID 17601 //
     /* 2132430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2132433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2132441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2132444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2132447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2132450 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2132453 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2132460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2132464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132468 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2132472 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132476 */     // MIs[0] round
     /* 2132476 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132479 */     // MIs[0] policy
     /* 2132479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132482 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132489 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VV_M4_E32_MASK),
     /* 2132492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132494 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132498 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132500 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132502 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2132512 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132515 */     // GIR_Coverage, 17601,
     /* 2132515 */     GIR_EraseRootFromParent_Done,
     /* 2132516 */   // Label 28160: @2132516
     /* 2132516 */   GIM_Try, /*On fail goto*//*Label 28161*/ GIMT_Encode4(2132607), // Rule ID 17604 //
     /* 2132521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2132524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132544 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132563 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132567 */     // MIs[0] round
     /* 2132567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132570 */     // MIs[0] policy
     /* 2132570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132573 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132580 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2132583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132585 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132587 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132589 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132591 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132593 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132603 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132606 */     // GIR_Coverage, 17604,
     /* 2132606 */     GIR_EraseRootFromParent_Done,
     /* 2132607 */   // Label 28161: @2132607
     /* 2132607 */   GIM_Try, /*On fail goto*//*Label 28162*/ GIMT_Encode4(2132698), // Rule ID 17605 //
     /* 2132612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2132615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2132623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2132626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2132629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2132635 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132654 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132658 */     // MIs[0] round
     /* 2132658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132661 */     // MIs[0] policy
     /* 2132661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132671 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF4_E16_MASK),
     /* 2132674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132676 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132680 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132682 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132684 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132694 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132697 */     // GIR_Coverage, 17605,
     /* 2132697 */     GIR_EraseRootFromParent_Done,
     /* 2132698 */   // Label 28162: @2132698
     /* 2132698 */   GIM_Try, /*On fail goto*//*Label 28163*/ GIMT_Encode4(2132789), // Rule ID 17608 //
     /* 2132703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2132706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132726 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132741 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132745 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132749 */     // MIs[0] round
     /* 2132749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132752 */     // MIs[0] policy
     /* 2132752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132755 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132762 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2132765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132767 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132771 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132773 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132775 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132785 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132788 */     // GIR_Coverage, 17608,
     /* 2132788 */     GIR_EraseRootFromParent_Done,
     /* 2132789 */   // Label 28163: @2132789
     /* 2132789 */   GIM_Try, /*On fail goto*//*Label 28164*/ GIMT_Encode4(2132880), // Rule ID 17609 //
     /* 2132794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2132797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2132805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2132808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2132811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132814 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2132817 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2132820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2132824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132832 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132836 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132840 */     // MIs[0] round
     /* 2132840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132843 */     // MIs[0] policy
     /* 2132843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132853 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11237:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2132853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_MF2_E16_MASK),
     /* 2132856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132858 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132860 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132862 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132864 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132866 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132876 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132879 */     // GIR_Coverage, 17609,
     /* 2132879 */     GIR_EraseRootFromParent_Done,
     /* 2132880 */   // Label 28164: @2132880
     /* 2132880 */   GIM_Try, /*On fail goto*//*Label 28165*/ GIMT_Encode4(2132971), // Rule ID 17612 //
     /* 2132885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2132888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132908 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2132911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2132915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2132919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2132923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2132927 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2132931 */     // MIs[0] round
     /* 2132931 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2132934 */     // MIs[0] policy
     /* 2132934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2132937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2132944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2132944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2132947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2132949 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2132951 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2132953 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2132955 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2132957 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2132959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2132964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2132967 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2132969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2132970 */     // GIR_Coverage, 17612,
     /* 2132970 */     GIR_EraseRootFromParent_Done,
     /* 2132971 */   // Label 28165: @2132971
     /* 2132971 */   GIM_Try, /*On fail goto*//*Label 28166*/ GIMT_Encode4(2133062), // Rule ID 17613 //
     /* 2132976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2132979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2132984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2132987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2132990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2132993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2132996 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2132999 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133018 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133022 */     // MIs[0] round
     /* 2133022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133025 */     // MIs[0] policy
     /* 2133025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133028 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133035 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VR:{ *:[nxv4f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M1_E16_MASK),
     /* 2133038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133040 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133042 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133044 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133046 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133048 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133058 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133061 */     // GIR_Coverage, 17613,
     /* 2133061 */     GIR_EraseRootFromParent_Done,
     /* 2133062 */   // Label 28166: @2133062
     /* 2133062 */   GIM_Try, /*On fail goto*//*Label 28167*/ GIMT_Encode4(2133153), // Rule ID 17616 //
     /* 2133067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2133070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133090 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133105 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133109 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133113 */     // MIs[0] round
     /* 2133113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133116 */     // MIs[0] policy
     /* 2133116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133119 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133126 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2133129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133131 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133135 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133137 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133139 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133149 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133152 */     // GIR_Coverage, 17616,
     /* 2133152 */     GIR_EraseRootFromParent_Done,
     /* 2133153 */   // Label 28167: @2133153
     /* 2133153 */   GIM_Try, /*On fail goto*//*Label 28168*/ GIMT_Encode4(2133244), // Rule ID 17617 //
     /* 2133158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2133161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2133169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2133172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2133175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2133181 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133196 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133200 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133204 */     // MIs[0] round
     /* 2133204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133207 */     // MIs[0] policy
     /* 2133207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133210 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133217 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M2_E16_MASK),
     /* 2133220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133222 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133224 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133226 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133228 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133230 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133240 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133243 */     // GIR_Coverage, 17617,
     /* 2133243 */     GIR_EraseRootFromParent_Done,
     /* 2133244 */   // Label 28168: @2133244
     /* 2133244 */   GIM_Try, /*On fail goto*//*Label 28169*/ GIMT_Encode4(2133335), // Rule ID 17620 //
     /* 2133249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2133252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133272 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133291 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133295 */     // MIs[0] round
     /* 2133295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133298 */     // MIs[0] policy
     /* 2133298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133308 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2133311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133313 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133317 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133319 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133321 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133331 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133334 */     // GIR_Coverage, 17620,
     /* 2133334 */     GIR_EraseRootFromParent_Done,
     /* 2133335 */   // Label 28169: @2133335
     /* 2133335 */   GIM_Try, /*On fail goto*//*Label 28170*/ GIMT_Encode4(2133426), // Rule ID 17621 //
     /* 2133340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2133343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2133351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2133354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2133357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s16,
     /* 2133360 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2133363 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2133370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2133374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133378 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2133382 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133386 */     // MIs[0] round
     /* 2133386 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133389 */     // MIs[0] policy
     /* 2133389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133399 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR16_M4_E16_MASK),
     /* 2133402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133404 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133408 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133410 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133412 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2133422 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133425 */     // GIR_Coverage, 17621,
     /* 2133425 */     GIR_EraseRootFromParent_Done,
     /* 2133426 */   // Label 28170: @2133426
     /* 2133426 */   GIM_Try, /*On fail goto*//*Label 28171*/ GIMT_Encode4(2133517), // Rule ID 17624 //
     /* 2133431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2133434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133451 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133454 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133469 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133473 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133477 */     // MIs[0] round
     /* 2133477 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133480 */     // MIs[0] policy
     /* 2133480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133483 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133490 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2133493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133495 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133499 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133501 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133503 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133513 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133515 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133516 */     // GIR_Coverage, 17624,
     /* 2133516 */     GIR_EraseRootFromParent_Done,
     /* 2133517 */   // Label 28171: @2133517
     /* 2133517 */   GIM_Try, /*On fail goto*//*Label 28172*/ GIMT_Encode4(2133608), // Rule ID 17625 //
     /* 2133522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2133525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2133533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2133536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2133539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2133545 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2133552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133556 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133560 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133564 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133568 */     // MIs[0] round
     /* 2133568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133571 */     // MIs[0] policy
     /* 2133571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133581 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11237:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_MF2_E32_MASK),
     /* 2133584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133586 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133588 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133590 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133592 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133594 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133604 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133607 */     // GIR_Coverage, 17625,
     /* 2133607 */     GIR_EraseRootFromParent_Done,
     /* 2133608 */   // Label 28172: @2133608
     /* 2133608 */   GIM_Try, /*On fail goto*//*Label 28173*/ GIMT_Encode4(2133699), // Rule ID 17628 //
     /* 2133613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2133616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133633 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133636 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133651 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133655 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133659 */     // MIs[0] round
     /* 2133659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133662 */     // MIs[0] policy
     /* 2133662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133672 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2133675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133677 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133679 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133681 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133683 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133685 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133695 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133698 */     // GIR_Coverage, 17628,
     /* 2133698 */     GIR_EraseRootFromParent_Done,
     /* 2133699 */   // Label 28173: @2133699
     /* 2133699 */   GIM_Try, /*On fail goto*//*Label 28174*/ GIMT_Encode4(2133790), // Rule ID 17629 //
     /* 2133704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2133707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2133715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2133718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2133721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133724 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2133727 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2133734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2133742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133746 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133750 */     // MIs[0] round
     /* 2133750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133753 */     // MIs[0] policy
     /* 2133753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133756 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133763 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11237:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M1_E32_MASK),
     /* 2133766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133768 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133772 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133774 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133776 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133786 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133789 */     // GIR_Coverage, 17629,
     /* 2133789 */     GIR_EraseRootFromParent_Done,
     /* 2133790 */   // Label 28174: @2133790
     /* 2133790 */   GIM_Try, /*On fail goto*//*Label 28175*/ GIMT_Encode4(2133881), // Rule ID 17632 //
     /* 2133795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2133798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133818 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2133821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133833 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133837 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133841 */     // MIs[0] round
     /* 2133841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133844 */     // MIs[0] policy
     /* 2133844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133847 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133854 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2133854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2133857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133859 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133863 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133865 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133867 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133877 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133880 */     // GIR_Coverage, 17632,
     /* 2133880 */     GIR_EraseRootFromParent_Done,
     /* 2133881 */   // Label 28175: @2133881
     /* 2133881 */   GIM_Try, /*On fail goto*//*Label 28176*/ GIMT_Encode4(2133972), // Rule ID 17633 //
     /* 2133886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2133889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2133897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2133900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2133903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2133909 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2133912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2133916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2133920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2133924 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2133928 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2133932 */     // MIs[0] round
     /* 2133932 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2133935 */     // MIs[0] policy
     /* 2133935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2133938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2133945 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11237:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2133945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M2_E32_MASK),
     /* 2133948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2133950 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2133952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2133954 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2133956 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2133958 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2133960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2133965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2133968 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2133970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2133971 */     // GIR_Coverage, 17633,
     /* 2133971 */     GIR_EraseRootFromParent_Done,
     /* 2133972 */   // Label 28176: @2133972
     /* 2133972 */   GIM_Try, /*On fail goto*//*Label 28177*/ GIMT_Encode4(2134063), // Rule ID 17636 //
     /* 2133977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2133980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2133985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2133988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2133991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2133994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2133997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134000 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134019 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134023 */     // MIs[0] round
     /* 2134023 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134026 */     // MIs[0] policy
     /* 2134026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134036 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2134039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134041 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134043 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134045 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134047 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134049 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134059 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134062 */     // GIR_Coverage, 17636,
     /* 2134062 */     GIR_EraseRootFromParent_Done,
     /* 2134063 */   // Label 28177: @2134063
     /* 2134063 */   GIM_Try, /*On fail goto*//*Label 28178*/ GIMT_Encode4(2134154), // Rule ID 17637 //
     /* 2134068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2134071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmul_mask),
     /* 2134076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2134079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2134082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2134085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2134088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2134091 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2134098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2134102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2134106 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2134110 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134114 */     // MIs[0] round
     /* 2134114 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134117 */     // MIs[0] policy
     /* 2134117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134127 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11237:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMUL_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMUL_VFPR32_M4_E32_MASK),
     /* 2134130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134132 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2134134 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134136 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134138 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134140 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134150 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134153 */     // GIR_Coverage, 17637,
     /* 2134153 */     GIR_EraseRootFromParent_Done,
     /* 2134154 */   // Label 28178: @2134154
     /* 2134154 */   GIM_Try, /*On fail goto*//*Label 28179*/ GIMT_Encode4(2134245), // Rule ID 17640 //
     /* 2134159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134179 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134182 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134197 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134201 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134205 */     // MIs[0] round
     /* 2134205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134208 */     // MIs[0] policy
     /* 2134208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134211 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134218 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2134221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134223 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134227 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134229 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134231 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134241 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134244 */     // GIR_Coverage, 17640,
     /* 2134244 */     GIR_EraseRootFromParent_Done,
     /* 2134245 */   // Label 28179: @2134245
     /* 2134245 */   GIM_Try, /*On fail goto*//*Label 28180*/ GIMT_Encode4(2134336), // Rule ID 17641 //
     /* 2134250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2134261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2134264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2134267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2134270 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134273 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134288 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134292 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134296 */     // MIs[0] round
     /* 2134296 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134299 */     // MIs[0] policy
     /* 2134299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134302 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134309 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E16_MASK),
     /* 2134312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134316 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134318 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134320 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134322 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134332 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134335 */     // GIR_Coverage, 17641,
     /* 2134335 */     GIR_EraseRootFromParent_Done,
     /* 2134336 */   // Label 28180: @2134336
     /* 2134336 */   GIM_Try, /*On fail goto*//*Label 28181*/ GIMT_Encode4(2134427), // Rule ID 17644 //
     /* 2134341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134364 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134379 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134383 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134387 */     // MIs[0] round
     /* 2134387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134390 */     // MIs[0] policy
     /* 2134390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134393 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134400 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2134403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134407 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134409 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134411 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134413 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134423 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134426 */     // GIR_Coverage, 17644,
     /* 2134426 */     GIR_EraseRootFromParent_Done,
     /* 2134427 */   // Label 28181: @2134427
     /* 2134427 */   GIM_Try, /*On fail goto*//*Label 28182*/ GIMT_Encode4(2134518), // Rule ID 17645 //
     /* 2134432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2134443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2134446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2134449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2134452 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134455 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134470 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134474 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134478 */     // MIs[0] round
     /* 2134478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134481 */     // MIs[0] policy
     /* 2134481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134491 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_MF2_E32_MASK),
     /* 2134494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134498 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134500 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134502 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134504 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134514 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134517 */     // GIR_Coverage, 17645,
     /* 2134517 */     GIR_EraseRootFromParent_Done,
     /* 2134518 */   // Label 28182: @2134518
     /* 2134518 */   GIM_Try, /*On fail goto*//*Label 28183*/ GIMT_Encode4(2134609), // Rule ID 17648 //
     /* 2134523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2134526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134546 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134565 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134569 */     // MIs[0] round
     /* 2134569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134572 */     // MIs[0] policy
     /* 2134572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134575 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134582 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2134585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134587 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134591 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134593 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134595 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134605 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134608 */     // GIR_Coverage, 17648,
     /* 2134608 */     GIR_EraseRootFromParent_Done,
     /* 2134609 */   // Label 28183: @2134609
     /* 2134609 */   GIM_Try, /*On fail goto*//*Label 28184*/ GIMT_Encode4(2134700), // Rule ID 17649 //
     /* 2134614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2134617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2134625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2134628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2134631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2134634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2134637 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134652 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134656 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134660 */     // MIs[0] round
     /* 2134660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134663 */     // MIs[0] policy
     /* 2134663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134673 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E16_MASK),
     /* 2134676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134680 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134682 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134684 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134686 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134688 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2134696 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134699 */     // GIR_Coverage, 17649,
     /* 2134699 */     GIR_EraseRootFromParent_Done,
     /* 2134700 */   // Label 28184: @2134700
     /* 2134700 */   GIM_Try, /*On fail goto*//*Label 28185*/ GIMT_Encode4(2134791), // Rule ID 17652 //
     /* 2134705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2134708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134725 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134728 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134747 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134751 */     // MIs[0] round
     /* 2134751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134754 */     // MIs[0] policy
     /* 2134754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134764 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2134767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134771 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134773 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134775 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134777 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134787 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134790 */     // GIR_Coverage, 17652,
     /* 2134790 */     GIR_EraseRootFromParent_Done,
     /* 2134791 */   // Label 28185: @2134791
     /* 2134791 */   GIM_Try, /*On fail goto*//*Label 28186*/ GIMT_Encode4(2134882), // Rule ID 17653 //
     /* 2134796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2134799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2134807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2134810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2134813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2134816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2134819 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2134822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134834 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134838 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134842 */     // MIs[0] round
     /* 2134842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134845 */     // MIs[0] policy
     /* 2134845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134848 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134855 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2134855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E32_MASK),
     /* 2134858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134864 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134866 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134868 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2134878 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134881 */     // GIR_Coverage, 17653,
     /* 2134881 */     GIR_EraseRootFromParent_Done,
     /* 2134882 */   // Label 28186: @2134882
     /* 2134882 */   GIM_Try, /*On fail goto*//*Label 28187*/ GIMT_Encode4(2134973), // Rule ID 17656 //
     /* 2134887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2134890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134907 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2134910 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2134913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2134917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134925 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2134929 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2134933 */     // MIs[0] round
     /* 2134933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2134936 */     // MIs[0] policy
     /* 2134936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2134939 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2134946 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2134946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2134949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2134951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2134953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2134955 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2134957 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2134959 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2134961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2134966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2134969 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2134971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2134972 */     // GIR_Coverage, 17656,
     /* 2134972 */     GIR_EraseRootFromParent_Done,
     /* 2134973 */   // Label 28187: @2134973
     /* 2134973 */   GIM_Try, /*On fail goto*//*Label 28188*/ GIMT_Encode4(2135064), // Rule ID 17657 //
     /* 2134978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2134981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2134986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2134989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2134992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2134995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2134998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2135001 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2135008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2135020 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135024 */     // MIs[0] round
     /* 2135024 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135027 */     // MIs[0] policy
     /* 2135027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135030 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135037 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M1_E64_MASK),
     /* 2135040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135046 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135048 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135050 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2135060 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135063 */     // GIR_Coverage, 17657,
     /* 2135063 */     GIR_EraseRootFromParent_Done,
     /* 2135064 */   // Label 28188: @2135064
     /* 2135064 */   GIM_Try, /*On fail goto*//*Label 28189*/ GIMT_Encode4(2135155), // Rule ID 17660 //
     /* 2135069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135086 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135089 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135107 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135111 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135115 */     // MIs[0] round
     /* 2135115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135118 */     // MIs[0] policy
     /* 2135118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135128 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2135131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135133 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135135 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135137 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135139 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135141 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135151 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135154 */     // GIR_Coverage, 17660,
     /* 2135154 */     GIR_EraseRootFromParent_Done,
     /* 2135155 */   // Label 28189: @2135155
     /* 2135155 */   GIM_Try, /*On fail goto*//*Label 28190*/ GIMT_Encode4(2135246), // Rule ID 17661 //
     /* 2135160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2135171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2135174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2135177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2135180 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135183 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135202 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135206 */     // MIs[0] round
     /* 2135206 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135209 */     // MIs[0] policy
     /* 2135209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135219 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E16_MASK),
     /* 2135222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135228 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135230 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135232 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135242 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135245 */     // GIR_Coverage, 17661,
     /* 2135245 */     GIR_EraseRootFromParent_Done,
     /* 2135246 */   // Label 28190: @2135246
     /* 2135246 */   GIM_Try, /*On fail goto*//*Label 28191*/ GIMT_Encode4(2135337), // Rule ID 17664 //
     /* 2135251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135293 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135297 */     // MIs[0] round
     /* 2135297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135300 */     // MIs[0] policy
     /* 2135300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135310 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2135313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135319 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135321 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135323 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135333 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135336 */     // GIR_Coverage, 17664,
     /* 2135336 */     GIR_EraseRootFromParent_Done,
     /* 2135337 */   // Label 28191: @2135337
     /* 2135337 */   GIM_Try, /*On fail goto*//*Label 28192*/ GIMT_Encode4(2135428), // Rule ID 17665 //
     /* 2135342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2135353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2135356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2135359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2135362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2135365 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135384 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135388 */     // MIs[0] round
     /* 2135388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135391 */     // MIs[0] policy
     /* 2135391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135401 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E16_MASK),
     /* 2135404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135410 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135412 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135414 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135424 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135427 */     // GIR_Coverage, 17665,
     /* 2135427 */     GIR_EraseRootFromParent_Done,
     /* 2135428 */   // Label 28192: @2135428
     /* 2135428 */   GIM_Try, /*On fail goto*//*Label 28193*/ GIMT_Encode4(2135519), // Rule ID 17668 //
     /* 2135433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2135436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135453 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135456 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135471 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135475 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135479 */     // MIs[0] round
     /* 2135479 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135482 */     // MIs[0] policy
     /* 2135482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135492 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2135495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135499 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135501 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135503 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135505 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135515 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135518 */     // GIR_Coverage, 17668,
     /* 2135518 */     GIR_EraseRootFromParent_Done,
     /* 2135519 */   // Label 28193: @2135519
     /* 2135519 */   GIM_Try, /*On fail goto*//*Label 28194*/ GIMT_Encode4(2135610), // Rule ID 17669 //
     /* 2135524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2135527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2135535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2135538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2135541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2135544 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2135547 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2135554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135562 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2135566 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135570 */     // MIs[0] round
     /* 2135570 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135573 */     // MIs[0] policy
     /* 2135573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135576 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135583 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E16_MASK),
     /* 2135586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135592 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135594 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135596 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2135606 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135609 */     // GIR_Coverage, 17669,
     /* 2135609 */     GIR_EraseRootFromParent_Done,
     /* 2135610 */   // Label 28194: @2135610
     /* 2135610 */   GIM_Try, /*On fail goto*//*Label 28195*/ GIMT_Encode4(2135701), // Rule ID 17672 //
     /* 2135615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135638 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135657 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135661 */     // MIs[0] round
     /* 2135661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135664 */     // MIs[0] policy
     /* 2135664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135674 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2135677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135683 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135685 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135687 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135697 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135700 */     // GIR_Coverage, 17672,
     /* 2135700 */     GIR_EraseRootFromParent_Done,
     /* 2135701 */   // Label 28195: @2135701
     /* 2135701 */   GIM_Try, /*On fail goto*//*Label 28196*/ GIMT_Encode4(2135792), // Rule ID 17673 //
     /* 2135706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2135717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2135720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2135723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2135726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2135729 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2135736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2135748 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135752 */     // MIs[0] round
     /* 2135752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135755 */     // MIs[0] policy
     /* 2135755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135758 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135765 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E32_MASK),
     /* 2135768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135772 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135774 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135776 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135778 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135788 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135791 */     // GIR_Coverage, 17673,
     /* 2135791 */     GIR_EraseRootFromParent_Done,
     /* 2135792 */   // Label 28196: @2135792
     /* 2135792 */   GIM_Try, /*On fail goto*//*Label 28197*/ GIMT_Encode4(2135883), // Rule ID 17676 //
     /* 2135797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135817 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135820 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2135823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135835 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135839 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135843 */     // MIs[0] round
     /* 2135843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135846 */     // MIs[0] policy
     /* 2135846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135849 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135856 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2135856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2135859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135863 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135865 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135867 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135869 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135879 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135882 */     // GIR_Coverage, 17676,
     /* 2135882 */     GIR_EraseRootFromParent_Done,
     /* 2135883 */   // Label 28197: @2135883
     /* 2135883 */   GIM_Try, /*On fail goto*//*Label 28198*/ GIMT_Encode4(2135974), // Rule ID 17677 //
     /* 2135888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2135891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2135899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2135902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2135905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2135908 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2135911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2135914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2135918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2135930 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2135934 */     // MIs[0] round
     /* 2135934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2135937 */     // MIs[0] policy
     /* 2135937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2135940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2135947 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2135947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E32_MASK),
     /* 2135950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2135952 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2135954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2135956 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2135958 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2135960 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2135962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2135967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2135970 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2135972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2135973 */     // GIR_Coverage, 17677,
     /* 2135973 */     GIR_EraseRootFromParent_Done,
     /* 2135974 */   // Label 28198: @2135974
     /* 2135974 */   GIM_Try, /*On fail goto*//*Label 28199*/ GIMT_Encode4(2136065), // Rule ID 17680 //
     /* 2135979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2135982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2135987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2135990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2135993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2135996 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2135999 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136002 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136021 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136025 */     // MIs[0] round
     /* 2136025 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136028 */     // MIs[0] policy
     /* 2136028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136031 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136038 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2136041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136047 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136049 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136051 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136061 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136064 */     // GIR_Coverage, 17680,
     /* 2136064 */     GIR_EraseRootFromParent_Done,
     /* 2136065 */   // Label 28199: @2136065
     /* 2136065 */   GIM_Try, /*On fail goto*//*Label 28200*/ GIMT_Encode4(2136156), // Rule ID 17681 //
     /* 2136070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2136073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2136081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2136084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2136087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2136090 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2136093 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136108 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136112 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136116 */     // MIs[0] round
     /* 2136116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136119 */     // MIs[0] policy
     /* 2136119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136129 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E32_MASK),
     /* 2136132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136136 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136138 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136140 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136142 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2136152 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136155 */     // GIR_Coverage, 17681,
     /* 2136155 */     GIR_EraseRootFromParent_Done,
     /* 2136156 */   // Label 28200: @2136156
     /* 2136156 */   GIM_Try, /*On fail goto*//*Label 28201*/ GIMT_Encode4(2136247), // Rule ID 17684 //
     /* 2136161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136184 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136203 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136207 */     // MIs[0] round
     /* 2136207 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136210 */     // MIs[0] policy
     /* 2136210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136220 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2136223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136227 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136229 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136231 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136233 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136243 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136246 */     // GIR_Coverage, 17684,
     /* 2136246 */     GIR_EraseRootFromParent_Done,
     /* 2136247 */   // Label 28201: @2136247
     /* 2136247 */   GIM_Try, /*On fail goto*//*Label 28202*/ GIMT_Encode4(2136338), // Rule ID 17685 //
     /* 2136252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2136263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2136266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2136269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2136272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136275 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2136282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136290 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2136294 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136298 */     // MIs[0] round
     /* 2136298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136301 */     // MIs[0] policy
     /* 2136301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M2_E64_MASK),
     /* 2136314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136318 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136320 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136322 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136324 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136334 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136337 */     // GIR_Coverage, 17685,
     /* 2136337 */     GIR_EraseRootFromParent_Done,
     /* 2136338 */   // Label 28202: @2136338
     /* 2136338 */   GIM_Try, /*On fail goto*//*Label 28203*/ GIMT_Encode4(2136429), // Rule ID 17688 //
     /* 2136343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136366 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136385 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136389 */     // MIs[0] round
     /* 2136389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136392 */     // MIs[0] policy
     /* 2136392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136402 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2136405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136409 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136411 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136413 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136415 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136425 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136428 */     // GIR_Coverage, 17688,
     /* 2136428 */     GIR_EraseRootFromParent_Done,
     /* 2136429 */   // Label 28203: @2136429
     /* 2136429 */   GIM_Try, /*On fail goto*//*Label 28204*/ GIMT_Encode4(2136520), // Rule ID 17689 //
     /* 2136434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2136445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2136448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2136451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2136454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2136457 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2136464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2136476 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136480 */     // MIs[0] round
     /* 2136480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136483 */     // MIs[0] policy
     /* 2136483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136493 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M4_E64_MASK),
     /* 2136496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136500 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136502 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136504 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136506 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136516 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136519 */     // GIR_Coverage, 17689,
     /* 2136519 */     GIR_EraseRootFromParent_Done,
     /* 2136520 */   // Label 28204: @2136520
     /* 2136520 */   GIM_Try, /*On fail goto*//*Label 28205*/ GIMT_Encode4(2136611), // Rule ID 17692 //
     /* 2136525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2136528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136548 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136563 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136567 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136571 */     // MIs[0] round
     /* 2136571 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136574 */     // MIs[0] policy
     /* 2136574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136584 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2136587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136591 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136593 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136595 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136597 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136607 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136610 */     // GIR_Coverage, 17692,
     /* 2136610 */     GIR_EraseRootFromParent_Done,
     /* 2136611 */   // Label 28205: @2136611
     /* 2136611 */   GIM_Try, /*On fail goto*//*Label 28206*/ GIMT_Encode4(2136702), // Rule ID 17693 //
     /* 2136616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2136619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2136627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2136630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2136633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2136636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2136639 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2136646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2136658 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136662 */     // MIs[0] round
     /* 2136662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136665 */     // MIs[0] policy
     /* 2136665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136668 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136675 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VV_M8_E64_MASK),
     /* 2136678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136682 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136684 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136686 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136688 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2136698 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136701 */     // GIR_Coverage, 17693,
     /* 2136701 */     GIR_EraseRootFromParent_Done,
     /* 2136702 */   // Label 28206: @2136702
     /* 2136702 */   GIM_Try, /*On fail goto*//*Label 28207*/ GIMT_Encode4(2136793), // Rule ID 17696 //
     /* 2136707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2136724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2136727 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136730 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136749 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136753 */     // MIs[0] round
     /* 2136753 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136756 */     // MIs[0] policy
     /* 2136756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136766 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2136769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136775 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136777 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136779 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136789 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136792 */     // GIR_Coverage, 17696,
     /* 2136792 */     GIR_EraseRootFromParent_Done,
     /* 2136793 */   // Label 28207: @2136793
     /* 2136793 */   GIM_Try, /*On fail goto*//*Label 28208*/ GIMT_Encode4(2136884), // Rule ID 17697 //
     /* 2136798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2136809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2136812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2136815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2136818 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2136821 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2136824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136836 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136840 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136844 */     // MIs[0] round
     /* 2136844 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136847 */     // MIs[0] policy
     /* 2136847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136850 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136857 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2136857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF4_E16_MASK),
     /* 2136860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136864 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136866 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136868 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136870 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136880 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136883 */     // GIR_Coverage, 17697,
     /* 2136883 */     GIR_EraseRootFromParent_Done,
     /* 2136884 */   // Label 28208: @2136884
     /* 2136884 */   GIM_Try, /*On fail goto*//*Label 28209*/ GIMT_Encode4(2136975), // Rule ID 17700 //
     /* 2136889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2136892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2136906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2136909 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2136912 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2136915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2136919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2136927 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2136931 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2136935 */     // MIs[0] round
     /* 2136935 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2136938 */     // MIs[0] policy
     /* 2136938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2136941 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2136948 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2136948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2136951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2136953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2136955 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2136957 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2136959 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2136961 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2136963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2136968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2136971 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2136973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2136974 */     // GIR_Coverage, 17700,
     /* 2136974 */     GIR_EraseRootFromParent_Done,
     /* 2136975 */   // Label 28209: @2136975
     /* 2136975 */   GIM_Try, /*On fail goto*//*Label 28210*/ GIMT_Encode4(2137066), // Rule ID 17701 //
     /* 2136980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2136983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2136988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2136991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2136994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2136997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2137000 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137003 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137014 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137018 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137022 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137026 */     // MIs[0] round
     /* 2137026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137029 */     // MIs[0] policy
     /* 2137029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137032 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137039 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_MF2_E16_MASK),
     /* 2137042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137046 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137048 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137050 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137052 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137062 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137065 */     // GIR_Coverage, 17701,
     /* 2137065 */     GIR_EraseRootFromParent_Done,
     /* 2137066 */   // Label 28210: @2137066
     /* 2137066 */   GIM_Try, /*On fail goto*//*Label 28211*/ GIMT_Encode4(2137157), // Rule ID 17704 //
     /* 2137071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2137088 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2137091 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137094 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137113 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137117 */     // MIs[0] round
     /* 2137117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137120 */     // MIs[0] policy
     /* 2137120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137130 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2137133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137139 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137141 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137143 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137153 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137156 */     // GIR_Coverage, 17704,
     /* 2137156 */     GIR_EraseRootFromParent_Done,
     /* 2137157 */   // Label 28211: @2137157
     /* 2137157 */   GIM_Try, /*On fail goto*//*Label 28212*/ GIMT_Encode4(2137248), // Rule ID 17705 //
     /* 2137162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2137173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2137176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2137179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2137182 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137185 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137204 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137208 */     // MIs[0] round
     /* 2137208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137211 */     // MIs[0] policy
     /* 2137211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137214 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137221 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_MF2_E32_MASK),
     /* 2137224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137230 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137232 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137234 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137236 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137244 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137247 */     // GIR_Coverage, 17705,
     /* 2137247 */     GIR_EraseRootFromParent_Done,
     /* 2137248 */   // Label 28212: @2137248
     /* 2137248 */   GIM_Try, /*On fail goto*//*Label 28213*/ GIMT_Encode4(2137339), // Rule ID 17708 //
     /* 2137253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2137270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2137273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137276 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137291 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137295 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137299 */     // MIs[0] round
     /* 2137299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137302 */     // MIs[0] policy
     /* 2137302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137305 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137312 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2137315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137319 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137321 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137323 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137325 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137335 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137338 */     // GIR_Coverage, 17708,
     /* 2137338 */     GIR_EraseRootFromParent_Done,
     /* 2137339 */   // Label 28213: @2137339
     /* 2137339 */   GIM_Try, /*On fail goto*//*Label 28214*/ GIMT_Encode4(2137430), // Rule ID 17709 //
     /* 2137344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2137355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2137358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2137361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2137364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2137367 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137382 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137386 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137390 */     // MIs[0] round
     /* 2137390 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137393 */     // MIs[0] policy
     /* 2137393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137403 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11137:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M1_E16_MASK),
     /* 2137406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137408 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137410 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137412 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137414 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137416 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137426 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137429 */     // GIR_Coverage, 17709,
     /* 2137429 */     GIR_EraseRootFromParent_Done,
     /* 2137430 */   // Label 28214: @2137430
     /* 2137430 */   GIM_Try, /*On fail goto*//*Label 28215*/ GIMT_Encode4(2137521), // Rule ID 17712 //
     /* 2137435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2137438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2137452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2137455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137458 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137473 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137477 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137481 */     // MIs[0] round
     /* 2137481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137484 */     // MIs[0] policy
     /* 2137484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137487 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137494 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2137497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137501 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137503 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137505 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137507 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137517 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137520 */     // GIR_Coverage, 17712,
     /* 2137520 */     GIR_EraseRootFromParent_Done,
     /* 2137521 */   // Label 28215: @2137521
     /* 2137521 */   GIM_Try, /*On fail goto*//*Label 28216*/ GIMT_Encode4(2137612), // Rule ID 17713 //
     /* 2137526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2137529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2137537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2137540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2137543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2137546 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2137549 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2137564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137568 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137572 */     // MIs[0] round
     /* 2137572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137575 */     // MIs[0] policy
     /* 2137575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137585 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11137:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M1_E32_MASK),
     /* 2137588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137590 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137592 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137594 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137596 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137598 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2137608 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137611 */     // GIR_Coverage, 17713,
     /* 2137611 */     GIR_EraseRootFromParent_Done,
     /* 2137612 */   // Label 28216: @2137612
     /* 2137612 */   GIM_Try, /*On fail goto*//*Label 28217*/ GIMT_Encode4(2137703), // Rule ID 17716 //
     /* 2137617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2137620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2137634 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2137637 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137640 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137659 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137663 */     // MIs[0] round
     /* 2137663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137666 */     // MIs[0] policy
     /* 2137666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137676 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2137679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137683 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137685 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137687 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137689 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137699 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137702 */     // GIR_Coverage, 17716,
     /* 2137702 */     GIR_EraseRootFromParent_Done,
     /* 2137703 */   // Label 28217: @2137703
     /* 2137703 */   GIM_Try, /*On fail goto*//*Label 28218*/ GIMT_Encode4(2137794), // Rule ID 17717 //
     /* 2137708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2137711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2137719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2137722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2137725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2137728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2137731 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2137738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2137746 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2137750 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137754 */     // MIs[0] round
     /* 2137754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137757 */     // MIs[0] policy
     /* 2137757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137760 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137767 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11137:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M1_E64_MASK),
     /* 2137770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137776 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137778 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137780 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2137790 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137793 */     // GIR_Coverage, 17717,
     /* 2137793 */     GIR_EraseRootFromParent_Done,
     /* 2137794 */   // Label 28218: @2137794
     /* 2137794 */   GIM_Try, /*On fail goto*//*Label 28219*/ GIMT_Encode4(2137885), // Rule ID 17720 //
     /* 2137799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2137816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2137819 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137822 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2137825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137837 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137841 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137845 */     // MIs[0] round
     /* 2137845 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137848 */     // MIs[0] policy
     /* 2137848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137858 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2137858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2137861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137863 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137867 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137869 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137871 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137881 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137884 */     // GIR_Coverage, 17720,
     /* 2137884 */     GIR_EraseRootFromParent_Done,
     /* 2137885 */   // Label 28219: @2137885
     /* 2137885 */   GIM_Try, /*On fail goto*//*Label 28220*/ GIMT_Encode4(2137976), // Rule ID 17721 //
     /* 2137890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2137893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2137901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2137904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2137907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2137910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2137913 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2137916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2137920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2137928 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2137932 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2137936 */     // MIs[0] round
     /* 2137936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2137939 */     // MIs[0] policy
     /* 2137939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2137942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2137949 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2137949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M2_E16_MASK),
     /* 2137952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2137954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2137956 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2137958 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2137960 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2137962 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2137964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2137969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2137972 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2137974 */     GIR_RootConstrainSelectedInstOperands,
     /* 2137975 */     // GIR_Coverage, 17721,
     /* 2137975 */     GIR_EraseRootFromParent_Done,
     /* 2137976 */   // Label 28220: @2137976
     /* 2137976 */   GIM_Try, /*On fail goto*//*Label 28221*/ GIMT_Encode4(2138067), // Rule ID 17724 //
     /* 2137981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2137984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2137989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2137992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2137995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2137998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2138001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138004 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138015 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138019 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138023 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138027 */     // MIs[0] round
     /* 2138027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138030 */     // MIs[0] policy
     /* 2138030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138040 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2138043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138045 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138047 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138049 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138051 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138053 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138063 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138066 */     // GIR_Coverage, 17724,
     /* 2138066 */     GIR_EraseRootFromParent_Done,
     /* 2138067 */   // Label 28221: @2138067
     /* 2138067 */   GIM_Try, /*On fail goto*//*Label 28222*/ GIMT_Encode4(2138158), // Rule ID 17725 //
     /* 2138072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2138083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2138086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2138089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2138092 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138095 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138106 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138110 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138114 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138118 */     // MIs[0] round
     /* 2138118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138121 */     // MIs[0] policy
     /* 2138121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138131 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M4_E16_MASK),
     /* 2138134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138140 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138142 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138144 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138154 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138157 */     // GIR_Coverage, 17725,
     /* 2138157 */     GIR_EraseRootFromParent_Done,
     /* 2138158 */   // Label 28222: @2138158
     /* 2138158 */   GIM_Try, /*On fail goto*//*Label 28223*/ GIMT_Encode4(2138249), // Rule ID 17728 //
     /* 2138163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2138166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2138180 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2138183 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138186 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138201 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138205 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138209 */     // MIs[0] round
     /* 2138209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138212 */     // MIs[0] policy
     /* 2138212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138222 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2138225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138231 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138233 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138235 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138245 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138248 */     // GIR_Coverage, 17728,
     /* 2138248 */     GIR_EraseRootFromParent_Done,
     /* 2138249 */   // Label 28223: @2138249
     /* 2138249 */   GIM_Try, /*On fail goto*//*Label 28224*/ GIMT_Encode4(2138340), // Rule ID 17729 //
     /* 2138254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2138257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2138265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2138268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2138271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2138274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2138277 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2138292 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138296 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138300 */     // MIs[0] round
     /* 2138300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138303 */     // MIs[0] policy
     /* 2138303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138306 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138313 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR16_M8_E16_MASK),
     /* 2138316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138320 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138322 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138324 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138326 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2138336 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138339 */     // GIR_Coverage, 17729,
     /* 2138339 */     GIR_EraseRootFromParent_Done,
     /* 2138340 */   // Label 28224: @2138340
     /* 2138340 */   GIM_Try, /*On fail goto*//*Label 28225*/ GIMT_Encode4(2138431), // Rule ID 17732 //
     /* 2138345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2138365 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138368 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138387 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138391 */     // MIs[0] round
     /* 2138391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138394 */     // MIs[0] policy
     /* 2138394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138397 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138404 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2138407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138411 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138413 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138415 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138417 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138427 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138430 */     // GIR_Coverage, 17732,
     /* 2138430 */     GIR_EraseRootFromParent_Done,
     /* 2138431 */   // Label 28225: @2138431
     /* 2138431 */   GIM_Try, /*On fail goto*//*Label 28226*/ GIMT_Encode4(2138522), // Rule ID 17733 //
     /* 2138436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2138447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2138450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2138456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2138459 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138474 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138478 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138482 */     // MIs[0] round
     /* 2138482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138485 */     // MIs[0] policy
     /* 2138485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138495 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M2_E32_MASK),
     /* 2138498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138504 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138506 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138508 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138518 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138521 */     // GIR_Coverage, 17733,
     /* 2138521 */     GIR_EraseRootFromParent_Done,
     /* 2138522 */   // Label 28226: @2138522
     /* 2138522 */   GIM_Try, /*On fail goto*//*Label 28227*/ GIMT_Encode4(2138613), // Rule ID 17736 //
     /* 2138527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2138547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138550 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138569 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138573 */     // MIs[0] round
     /* 2138573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138576 */     // MIs[0] policy
     /* 2138576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138586 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2138589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138593 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138595 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138597 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138599 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138609 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138612 */     // GIR_Coverage, 17736,
     /* 2138612 */     GIR_EraseRootFromParent_Done,
     /* 2138613 */   // Label 28227: @2138613
     /* 2138613 */   GIM_Try, /*On fail goto*//*Label 28228*/ GIMT_Encode4(2138704), // Rule ID 17737 //
     /* 2138618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2138629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2138632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2138638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2138641 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2138648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2138660 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138664 */     // MIs[0] round
     /* 2138664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138667 */     // MIs[0] policy
     /* 2138667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138677 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M4_E32_MASK),
     /* 2138680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138684 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138686 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138688 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138690 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138700 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138703 */     // GIR_Coverage, 17737,
     /* 2138703 */     GIR_EraseRootFromParent_Done,
     /* 2138704 */   // Label 28228: @2138704
     /* 2138704 */   GIM_Try, /*On fail goto*//*Label 28229*/ GIMT_Encode4(2138795), // Rule ID 17740 //
     /* 2138709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2138712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2138729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138732 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138751 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138755 */     // MIs[0] round
     /* 2138755 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138758 */     // MIs[0] policy
     /* 2138758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138768 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2138771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138777 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138779 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138781 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138791 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138794 */     // GIR_Coverage, 17740,
     /* 2138794 */     GIR_EraseRootFromParent_Done,
     /* 2138795 */   // Label 28229: @2138795
     /* 2138795 */   GIM_Try, /*On fail goto*//*Label 28230*/ GIMT_Encode4(2138886), // Rule ID 17741 //
     /* 2138800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2138803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2138811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2138814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2138817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2138820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2138823 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2138826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2138830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2138838 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2138842 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138846 */     // MIs[0] round
     /* 2138846 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138849 */     // MIs[0] policy
     /* 2138849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138859 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2138859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR32_M8_E32_MASK),
     /* 2138862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138868 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138870 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138872 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2138882 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138885 */     // GIR_Coverage, 17741,
     /* 2138885 */     GIR_EraseRootFromParent_Done,
     /* 2138886 */   // Label 28230: @2138886
     /* 2138886 */   GIM_Try, /*On fail goto*//*Label 28231*/ GIMT_Encode4(2138977), // Rule ID 17744 //
     /* 2138891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2138894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2138908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2138911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2138914 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2138917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2138921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2138929 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2138933 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2138937 */     // MIs[0] round
     /* 2138937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2138940 */     // MIs[0] policy
     /* 2138940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2138943 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2138950 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2138950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2138953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2138955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2138957 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2138959 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2138961 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2138963 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2138965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2138970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2138973 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2138975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2138976 */     // GIR_Coverage, 17744,
     /* 2138976 */     GIR_EraseRootFromParent_Done,
     /* 2138977 */   // Label 28231: @2138977
     /* 2138977 */   GIM_Try, /*On fail goto*//*Label 28232*/ GIMT_Encode4(2139068), // Rule ID 17745 //
     /* 2138982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2138985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2138990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2138993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2138996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2138999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2139002 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139005 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2139012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139020 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2139024 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139028 */     // MIs[0] round
     /* 2139028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139031 */     // MIs[0] policy
     /* 2139031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139041 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11137:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M2_E64_MASK),
     /* 2139044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139050 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139052 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139054 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139064 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139067 */     // GIR_Coverage, 17745,
     /* 2139067 */     GIR_EraseRootFromParent_Done,
     /* 2139068 */   // Label 28232: @2139068
     /* 2139068 */   GIM_Try, /*On fail goto*//*Label 28233*/ GIMT_Encode4(2139159), // Rule ID 17748 //
     /* 2139073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2139090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2139093 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139096 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139115 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139119 */     // MIs[0] round
     /* 2139119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139122 */     // MIs[0] policy
     /* 2139122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139132 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2139135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139137 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139141 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139143 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139145 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139155 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139158 */     // GIR_Coverage, 17748,
     /* 2139158 */     GIR_EraseRootFromParent_Done,
     /* 2139159 */   // Label 28233: @2139159
     /* 2139159 */   GIM_Try, /*On fail goto*//*Label 28234*/ GIMT_Encode4(2139250), // Rule ID 17749 //
     /* 2139164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2139175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2139178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2139181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2139184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2139187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2139194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2139206 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139210 */     // MIs[0] round
     /* 2139210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139213 */     // MIs[0] policy
     /* 2139213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139216 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139223 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11137:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M4_E64_MASK),
     /* 2139226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139230 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139232 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139234 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139236 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139246 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139249 */     // GIR_Coverage, 17749,
     /* 2139249 */     GIR_EraseRootFromParent_Done,
     /* 2139250 */   // Label 28234: @2139250
     /* 2139250 */   GIM_Try, /*On fail goto*//*Label 28235*/ GIMT_Encode4(2139341), // Rule ID 17752 //
     /* 2139255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2139258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2139272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2139275 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139278 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139293 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139297 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139301 */     // MIs[0] round
     /* 2139301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139304 */     // MIs[0] policy
     /* 2139304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139314 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2139317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139321 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139323 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139325 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139327 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139337 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139339 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139340 */     // GIR_Coverage, 17752,
     /* 2139340 */     GIR_EraseRootFromParent_Done,
     /* 2139341 */   // Label 28235: @2139341
     /* 2139341 */   GIM_Try, /*On fail goto*//*Label 28236*/ GIMT_Encode4(2139432), // Rule ID 17753 //
     /* 2139346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2139349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmacc_mask),
     /* 2139354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2139357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2139360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2139363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2139366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2139369 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2139376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2139384 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2139388 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139392 */     // MIs[0] round
     /* 2139392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139395 */     // MIs[0] policy
     /* 2139395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139398 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139405 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11137:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMACC_VFPR64_M8_E64_MASK),
     /* 2139408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139414 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139416 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139418 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2139428 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139431 */     // GIR_Coverage, 17753,
     /* 2139431 */     GIR_EraseRootFromParent_Done,
     /* 2139432 */   // Label 28236: @2139432
     /* 2139432 */   GIM_Try, /*On fail goto*//*Label 28237*/ GIMT_Encode4(2139523), // Rule ID 17756 //
     /* 2139437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2139457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139460 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139479 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139483 */     // MIs[0] round
     /* 2139483 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139486 */     // MIs[0] policy
     /* 2139486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139496 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2139499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139501 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139503 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139505 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139507 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139509 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139519 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139522 */     // GIR_Coverage, 17756,
     /* 2139522 */     GIR_EraseRootFromParent_Done,
     /* 2139523 */   // Label 28237: @2139523
     /* 2139523 */   GIM_Try, /*On fail goto*//*Label 28238*/ GIMT_Encode4(2139614), // Rule ID 17757 //
     /* 2139528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2139539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2139542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2139545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2139548 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139551 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139566 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139570 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139574 */     // MIs[0] round
     /* 2139574 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139577 */     // MIs[0] policy
     /* 2139577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139587 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF4_E16_MASK),
     /* 2139590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139594 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139596 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139598 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139600 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139610 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139613 */     // GIR_Coverage, 17757,
     /* 2139613 */     GIR_EraseRootFromParent_Done,
     /* 2139614 */   // Label 28238: @2139614
     /* 2139614 */   GIM_Try, /*On fail goto*//*Label 28239*/ GIMT_Encode4(2139705), // Rule ID 17760 //
     /* 2139619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2139639 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139642 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139657 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139661 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139665 */     // MIs[0] round
     /* 2139665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139668 */     // MIs[0] policy
     /* 2139668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139671 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139678 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2139681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139685 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139687 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139689 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139691 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139701 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139704 */     // GIR_Coverage, 17760,
     /* 2139704 */     GIR_EraseRootFromParent_Done,
     /* 2139705 */   // Label 28239: @2139705
     /* 2139705 */   GIM_Try, /*On fail goto*//*Label 28240*/ GIMT_Encode4(2139796), // Rule ID 17761 //
     /* 2139710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2139713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2139721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2139724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2139727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2139730 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2139733 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139752 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139756 */     // MIs[0] round
     /* 2139756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139759 */     // MIs[0] policy
     /* 2139759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139762 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139769 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E16_MASK),
     /* 2139772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139774 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139776 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139778 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139780 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139782 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2139792 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139795 */     // GIR_Coverage, 17761,
     /* 2139795 */     GIR_EraseRootFromParent_Done,
     /* 2139796 */   // Label 28240: @2139796
     /* 2139796 */   GIM_Try, /*On fail goto*//*Label 28241*/ GIMT_Encode4(2139887), // Rule ID 17764 //
     /* 2139801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2139804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2139821 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139824 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2139827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139843 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139847 */     // MIs[0] round
     /* 2139847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139850 */     // MIs[0] policy
     /* 2139850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139860 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2139860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2139863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139869 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139871 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139873 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139883 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139886 */     // GIR_Coverage, 17764,
     /* 2139886 */     GIR_EraseRootFromParent_Done,
     /* 2139887 */   // Label 28241: @2139887
     /* 2139887 */   GIM_Try, /*On fail goto*//*Label 28242*/ GIMT_Encode4(2139978), // Rule ID 17765 //
     /* 2139892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2139895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2139903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2139906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2139909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2139912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2139915 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2139918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2139922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2139934 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2139938 */     // MIs[0] round
     /* 2139938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2139941 */     // MIs[0] policy
     /* 2139941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2139944 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2139951 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2139951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_MF2_E32_MASK),
     /* 2139954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2139956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2139958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2139960 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2139962 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2139964 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2139966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2139971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2139974 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2139976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2139977 */     // GIR_Coverage, 17765,
     /* 2139977 */     GIR_EraseRootFromParent_Done,
     /* 2139978 */   // Label 28242: @2139978
     /* 2139978 */   GIM_Try, /*On fail goto*//*Label 28243*/ GIMT_Encode4(2140069), // Rule ID 17768 //
     /* 2139983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2139986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2139991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2139994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2139997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2140003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140006 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140025 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140029 */     // MIs[0] round
     /* 2140029 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140032 */     // MIs[0] policy
     /* 2140032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140042 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2140045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140049 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140051 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140053 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140055 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140065 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140068 */     // GIR_Coverage, 17768,
     /* 2140068 */     GIR_EraseRootFromParent_Done,
     /* 2140069 */   // Label 28243: @2140069
     /* 2140069 */   GIM_Try, /*On fail goto*//*Label 28244*/ GIMT_Encode4(2140160), // Rule ID 17769 //
     /* 2140074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2140085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2140088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2140091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2140094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2140097 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140112 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140116 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140120 */     // MIs[0] round
     /* 2140120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140123 */     // MIs[0] policy
     /* 2140123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140133 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E16_MASK),
     /* 2140136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140142 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140144 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140146 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140156 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140159 */     // GIR_Coverage, 17769,
     /* 2140159 */     GIR_EraseRootFromParent_Done,
     /* 2140160 */   // Label 28244: @2140160
     /* 2140160 */   GIM_Try, /*On fail goto*//*Label 28245*/ GIMT_Encode4(2140251), // Rule ID 17772 //
     /* 2140165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2140168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2140185 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140188 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140203 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140207 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140211 */     // MIs[0] round
     /* 2140211 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140214 */     // MIs[0] policy
     /* 2140214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140217 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140224 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2140227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140233 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140235 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140237 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140239 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140247 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140250 */     // GIR_Coverage, 17772,
     /* 2140250 */     GIR_EraseRootFromParent_Done,
     /* 2140251 */   // Label 28245: @2140251
     /* 2140251 */   GIM_Try, /*On fail goto*//*Label 28246*/ GIMT_Encode4(2140342), // Rule ID 17773 //
     /* 2140256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2140259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2140267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2140270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2140273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2140276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2140279 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140298 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140302 */     // MIs[0] round
     /* 2140302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140305 */     // MIs[0] policy
     /* 2140305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140315 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E32_MASK),
     /* 2140318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140322 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140324 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140326 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140328 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2140338 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140341 */     // GIR_Coverage, 17773,
     /* 2140341 */     GIR_EraseRootFromParent_Done,
     /* 2140342 */   // Label 28246: @2140342
     /* 2140342 */   GIM_Try, /*On fail goto*//*Label 28247*/ GIMT_Encode4(2140433), // Rule ID 17776 //
     /* 2140347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2140350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2140367 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140370 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140389 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140393 */     // MIs[0] round
     /* 2140393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140396 */     // MIs[0] policy
     /* 2140396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140399 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140406 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2140409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140411 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140413 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140415 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140417 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140419 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140421 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140429 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140432 */     // GIR_Coverage, 17776,
     /* 2140432 */     GIR_EraseRootFromParent_Done,
     /* 2140433 */   // Label 28247: @2140433
     /* 2140433 */   GIM_Try, /*On fail goto*//*Label 28248*/ GIMT_Encode4(2140524), // Rule ID 17777 //
     /* 2140438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2140441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2140449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2140452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2140455 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2140458 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2140461 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2140468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2140480 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140484 */     // MIs[0] round
     /* 2140484 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140487 */     // MIs[0] policy
     /* 2140487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140490 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140497 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M1_E64_MASK),
     /* 2140500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140504 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140506 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140508 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140510 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2140520 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140523 */     // GIR_Coverage, 17777,
     /* 2140523 */     GIR_EraseRootFromParent_Done,
     /* 2140524 */   // Label 28248: @2140524
     /* 2140524 */   GIM_Try, /*On fail goto*//*Label 28249*/ GIMT_Encode4(2140615), // Rule ID 17780 //
     /* 2140529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2140549 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140552 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140575 */     // MIs[0] round
     /* 2140575 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140578 */     // MIs[0] policy
     /* 2140578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140588 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2140591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140597 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140599 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140601 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140611 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140614 */     // GIR_Coverage, 17780,
     /* 2140614 */     GIR_EraseRootFromParent_Done,
     /* 2140615 */   // Label 28249: @2140615
     /* 2140615 */   GIM_Try, /*On fail goto*//*Label 28250*/ GIMT_Encode4(2140706), // Rule ID 17781 //
     /* 2140620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2140631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2140634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2140637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2140640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2140643 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2140650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140658 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2140662 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140666 */     // MIs[0] round
     /* 2140666 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140669 */     // MIs[0] policy
     /* 2140669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140672 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140679 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E16_MASK),
     /* 2140682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140688 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140690 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140692 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140694 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140702 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140705 */     // GIR_Coverage, 17781,
     /* 2140705 */     GIR_EraseRootFromParent_Done,
     /* 2140706 */   // Label 28250: @2140706
     /* 2140706 */   GIM_Try, /*On fail goto*//*Label 28251*/ GIMT_Encode4(2140797), // Rule ID 17784 //
     /* 2140711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2140731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140749 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140753 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140757 */     // MIs[0] round
     /* 2140757 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140760 */     // MIs[0] policy
     /* 2140760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140770 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2140773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140777 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140779 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140781 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140783 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140793 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140796 */     // GIR_Coverage, 17784,
     /* 2140796 */     GIR_EraseRootFromParent_Done,
     /* 2140797 */   // Label 28251: @2140797
     /* 2140797 */   GIM_Try, /*On fail goto*//*Label 28252*/ GIMT_Encode4(2140888), // Rule ID 17785 //
     /* 2140802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2140813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2140816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2140819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2140822 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2140825 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2140828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2140832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2140844 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140848 */     // MIs[0] round
     /* 2140848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140851 */     // MIs[0] policy
     /* 2140851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140854 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140861 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2140861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E16_MASK),
     /* 2140864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140868 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140870 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140872 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140874 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140876 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140884 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140887 */     // GIR_Coverage, 17785,
     /* 2140887 */     GIR_EraseRootFromParent_Done,
     /* 2140888 */   // Label 28252: @2140888
     /* 2140888 */   GIM_Try, /*On fail goto*//*Label 28253*/ GIMT_Encode4(2140979), // Rule ID 17788 //
     /* 2140893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2140896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2140910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2140913 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2140916 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2140919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2140923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140931 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2140935 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2140939 */     // MIs[0] round
     /* 2140939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2140942 */     // MIs[0] policy
     /* 2140942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2140945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2140952 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2140952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2140955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2140957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2140959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2140961 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2140963 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2140965 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2140967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2140972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2140975 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2140977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2140978 */     // GIR_Coverage, 17788,
     /* 2140978 */     GIR_EraseRootFromParent_Done,
     /* 2140979 */   // Label 28253: @2140979
     /* 2140979 */   GIM_Try, /*On fail goto*//*Label 28254*/ GIMT_Encode4(2141070), // Rule ID 17789 //
     /* 2140984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2140987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2140992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2140995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2140998 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2141001 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2141004 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2141007 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141026 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141030 */     // MIs[0] round
     /* 2141030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141033 */     // MIs[0] policy
     /* 2141033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141043 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E16_MASK),
     /* 2141046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141048 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141050 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141052 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141054 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141056 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2141066 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141069 */     // GIR_Coverage, 17789,
     /* 2141069 */     GIR_EraseRootFromParent_Done,
     /* 2141070 */   // Label 28254: @2141070
     /* 2141070 */   GIM_Try, /*On fail goto*//*Label 28255*/ GIMT_Encode4(2141161), // Rule ID 17792 //
     /* 2141075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2141095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141098 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141117 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141121 */     // MIs[0] round
     /* 2141121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141124 */     // MIs[0] policy
     /* 2141124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141127 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141134 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2141137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141143 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141145 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141147 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141157 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141160 */     // GIR_Coverage, 17792,
     /* 2141160 */     GIR_EraseRootFromParent_Done,
     /* 2141161 */   // Label 28255: @2141161
     /* 2141161 */   GIM_Try, /*On fail goto*//*Label 28256*/ GIMT_Encode4(2141252), // Rule ID 17793 //
     /* 2141166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2141177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2141180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2141183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2141186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141189 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141204 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141208 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141212 */     // MIs[0] round
     /* 2141212 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141215 */     // MIs[0] policy
     /* 2141215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E32_MASK),
     /* 2141228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141232 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141234 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141236 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141238 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141248 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141251 */     // GIR_Coverage, 17793,
     /* 2141251 */     GIR_EraseRootFromParent_Done,
     /* 2141252 */   // Label 28256: @2141252
     /* 2141252 */   GIM_Try, /*On fail goto*//*Label 28257*/ GIMT_Encode4(2141343), // Rule ID 17796 //
     /* 2141257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2141277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141280 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141295 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141299 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141303 */     // MIs[0] round
     /* 2141303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141306 */     // MIs[0] policy
     /* 2141306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141316 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2141319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141325 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141327 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141329 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141339 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141342 */     // GIR_Coverage, 17796,
     /* 2141342 */     GIR_EraseRootFromParent_Done,
     /* 2141343 */   // Label 28257: @2141343
     /* 2141343 */   GIM_Try, /*On fail goto*//*Label 28258*/ GIMT_Encode4(2141434), // Rule ID 17797 //
     /* 2141348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2141359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2141362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2141365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2141368 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2141371 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141390 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141394 */     // MIs[0] round
     /* 2141394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141397 */     // MIs[0] policy
     /* 2141397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141407 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E32_MASK),
     /* 2141410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141412 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141414 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141416 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141418 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141420 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141430 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141433 */     // GIR_Coverage, 17797,
     /* 2141433 */     GIR_EraseRootFromParent_Done,
     /* 2141434 */   // Label 28258: @2141434
     /* 2141434 */   GIM_Try, /*On fail goto*//*Label 28259*/ GIMT_Encode4(2141525), // Rule ID 17800 //
     /* 2141439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2141442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141456 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2141459 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141462 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141481 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141485 */     // MIs[0] round
     /* 2141485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141488 */     // MIs[0] policy
     /* 2141488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141498 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2141501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141505 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141507 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141509 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141511 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141521 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141524 */     // GIR_Coverage, 17800,
     /* 2141524 */     GIR_EraseRootFromParent_Done,
     /* 2141525 */   // Label 28259: @2141525
     /* 2141525 */   GIM_Try, /*On fail goto*//*Label 28260*/ GIMT_Encode4(2141616), // Rule ID 17801 //
     /* 2141530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2141533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2141541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2141544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2141547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2141550 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2141553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2141560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141568 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2141572 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141576 */     // MIs[0] round
     /* 2141576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141579 */     // MIs[0] policy
     /* 2141579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141582 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141589 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E32_MASK),
     /* 2141592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141598 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141600 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141602 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2141612 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141615 */     // GIR_Coverage, 17801,
     /* 2141615 */     GIR_EraseRootFromParent_Done,
     /* 2141616 */   // Label 28260: @2141616
     /* 2141616 */   GIM_Try, /*On fail goto*//*Label 28261*/ GIMT_Encode4(2141707), // Rule ID 17804 //
     /* 2141621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2141641 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141644 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141655 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141659 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141663 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141667 */     // MIs[0] round
     /* 2141667 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141670 */     // MIs[0] policy
     /* 2141670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141673 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141680 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2141683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141685 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141689 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141691 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141693 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141703 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141706 */     // GIR_Coverage, 17804,
     /* 2141706 */     GIR_EraseRootFromParent_Done,
     /* 2141707 */   // Label 28261: @2141707
     /* 2141707 */   GIM_Try, /*On fail goto*//*Label 28262*/ GIMT_Encode4(2141798), // Rule ID 17805 //
     /* 2141712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2141723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2141726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2141729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2141732 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2141735 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2141742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2141754 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141758 */     // MIs[0] round
     /* 2141758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141761 */     // MIs[0] policy
     /* 2141761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141771 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M2_E64_MASK),
     /* 2141774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141778 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141780 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141782 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141784 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141786 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141794 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141797 */     // GIR_Coverage, 17805,
     /* 2141797 */     GIR_EraseRootFromParent_Done,
     /* 2141798 */   // Label 28262: @2141798
     /* 2141798 */   GIM_Try, /*On fail goto*//*Label 28263*/ GIMT_Encode4(2141889), // Rule ID 17808 //
     /* 2141803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2141823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141826 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2141829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141845 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141849 */     // MIs[0] round
     /* 2141849 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141852 */     // MIs[0] policy
     /* 2141852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141862 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2141862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2141865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141869 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141871 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141873 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141875 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141885 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141888 */     // GIR_Coverage, 17808,
     /* 2141888 */     GIR_EraseRootFromParent_Done,
     /* 2141889 */   // Label 28263: @2141889
     /* 2141889 */   GIM_Try, /*On fail goto*//*Label 28264*/ GIMT_Encode4(2141980), // Rule ID 17809 //
     /* 2141894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2141897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2141905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2141908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2141911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2141914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2141917 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2141920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2141924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141932 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2141936 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2141940 */     // MIs[0] round
     /* 2141940 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2141943 */     // MIs[0] policy
     /* 2141943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2141946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2141953 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2141953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M4_E64_MASK),
     /* 2141956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2141958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2141960 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2141962 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2141964 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2141966 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2141968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2141973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2141976 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2141978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2141979 */     // GIR_Coverage, 17809,
     /* 2141979 */     GIR_EraseRootFromParent_Done,
     /* 2141980 */   // Label 28264: @2141980
     /* 2141980 */   GIM_Try, /*On fail goto*//*Label 28265*/ GIMT_Encode4(2142071), // Rule ID 17812 //
     /* 2141985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2141988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2141993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2141996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2141999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2142005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142008 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142023 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142027 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142031 */     // MIs[0] round
     /* 2142031 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142034 */     // MIs[0] policy
     /* 2142034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142044 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2142047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142051 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142053 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142055 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142057 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142067 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142070 */     // GIR_Coverage, 17812,
     /* 2142070 */     GIR_EraseRootFromParent_Done,
     /* 2142071 */   // Label 28265: @2142071
     /* 2142071 */   GIM_Try, /*On fail goto*//*Label 28266*/ GIMT_Encode4(2142162), // Rule ID 17813 //
     /* 2142076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2142079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2142087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2142090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2142093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2142096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2142099 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2142106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2142118 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142122 */     // MIs[0] round
     /* 2142122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142125 */     // MIs[0] policy
     /* 2142125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142135 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VV_M8_E64_MASK),
     /* 2142138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142144 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142146 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142148 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2142158 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142161 */     // GIR_Coverage, 17813,
     /* 2142161 */     GIR_EraseRootFromParent_Done,
     /* 2142162 */   // Label 28266: @2142162
     /* 2142162 */   GIM_Try, /*On fail goto*//*Label 28267*/ GIMT_Encode4(2142253), // Rule ID 17816 //
     /* 2142167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2142178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2142181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142190 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142209 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142213 */     // MIs[0] round
     /* 2142213 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142216 */     // MIs[0] policy
     /* 2142216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142226 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2142229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142233 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142235 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142237 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142239 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142249 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142252 */     // GIR_Coverage, 17816,
     /* 2142252 */     GIR_EraseRootFromParent_Done,
     /* 2142253 */   // Label 28267: @2142253
     /* 2142253 */   GIM_Try, /*On fail goto*//*Label 28268*/ GIMT_Encode4(2142344), // Rule ID 17817 //
     /* 2142258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2142269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2142272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2142278 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142281 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142296 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142300 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142304 */     // MIs[0] round
     /* 2142304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142307 */     // MIs[0] policy
     /* 2142307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142317 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF4_E16_MASK),
     /* 2142320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142324 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142326 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142328 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142330 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142340 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142343 */     // GIR_Coverage, 17817,
     /* 2142343 */     GIR_EraseRootFromParent_Done,
     /* 2142344 */   // Label 28268: @2142344
     /* 2142344 */   GIM_Try, /*On fail goto*//*Label 28269*/ GIMT_Encode4(2142435), // Rule ID 17820 //
     /* 2142349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2142360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2142363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142372 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142391 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142395 */     // MIs[0] round
     /* 2142395 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142398 */     // MIs[0] policy
     /* 2142398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142401 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142408 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2142411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142417 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142419 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142421 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142431 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142434 */     // GIR_Coverage, 17820,
     /* 2142434 */     GIR_EraseRootFromParent_Done,
     /* 2142435 */   // Label 28269: @2142435
     /* 2142435 */   GIM_Try, /*On fail goto*//*Label 28270*/ GIMT_Encode4(2142526), // Rule ID 17821 //
     /* 2142440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2142451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2142454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2142460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142463 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142478 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142482 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142486 */     // MIs[0] round
     /* 2142486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142489 */     // MIs[0] policy
     /* 2142489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142499 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_MF2_E16_MASK),
     /* 2142502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142506 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142508 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142510 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142512 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142522 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142525 */     // GIR_Coverage, 17821,
     /* 2142525 */     GIR_EraseRootFromParent_Done,
     /* 2142526 */   // Label 28270: @2142526
     /* 2142526 */   GIM_Try, /*On fail goto*//*Label 28271*/ GIMT_Encode4(2142617), // Rule ID 17824 //
     /* 2142531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2142551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142554 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142569 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142573 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142577 */     // MIs[0] round
     /* 2142577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142580 */     // MIs[0] policy
     /* 2142580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142590 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2142593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142597 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142599 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142601 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142603 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142613 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142616 */     // GIR_Coverage, 17824,
     /* 2142616 */     GIR_EraseRootFromParent_Done,
     /* 2142617 */   // Label 28271: @2142617
     /* 2142617 */   GIM_Try, /*On fail goto*//*Label 28272*/ GIMT_Encode4(2142708), // Rule ID 17825 //
     /* 2142622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2142633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2142636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142639 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2142642 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2142645 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142660 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142664 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142668 */     // MIs[0] round
     /* 2142668 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142671 */     // MIs[0] policy
     /* 2142671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142681 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_MF2_E32_MASK),
     /* 2142684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142686 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142690 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142692 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142694 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142704 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142707 */     // GIR_Coverage, 17825,
     /* 2142707 */     GIR_EraseRootFromParent_Done,
     /* 2142708 */   // Label 28272: @2142708
     /* 2142708 */   GIM_Try, /*On fail goto*//*Label 28273*/ GIMT_Encode4(2142799), // Rule ID 17828 //
     /* 2142713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2142716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2142724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142736 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142751 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142755 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142759 */     // MIs[0] round
     /* 2142759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142762 */     // MIs[0] policy
     /* 2142762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142772 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2142775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142781 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142783 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142785 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142795 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142798 */     // GIR_Coverage, 17828,
     /* 2142798 */     GIR_EraseRootFromParent_Done,
     /* 2142799 */   // Label 28273: @2142799
     /* 2142799 */   GIM_Try, /*On fail goto*//*Label 28274*/ GIMT_Encode4(2142890), // Rule ID 17829 //
     /* 2142804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2142807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2142815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2142818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2142821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2142824 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2142827 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2142830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2142842 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142846 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142850 */     // MIs[0] round
     /* 2142850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142853 */     // MIs[0] policy
     /* 2142853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142856 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142863 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11173:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2142863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M1_E16_MASK),
     /* 2142866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142870 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142872 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142874 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142876 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2142886 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142888 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142889 */     // GIR_Coverage, 17829,
     /* 2142889 */     GIR_EraseRootFromParent_Done,
     /* 2142890 */   // Label 28274: @2142890
     /* 2142890 */   GIM_Try, /*On fail goto*//*Label 28275*/ GIMT_Encode4(2142981), // Rule ID 17832 //
     /* 2142895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2142898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2142909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2142912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2142915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2142918 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2142921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2142925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2142933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2142937 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2142941 */     // MIs[0] round
     /* 2142941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2142944 */     // MIs[0] policy
     /* 2142944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2142947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2142954 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2142954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2142957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2142959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2142961 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2142963 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2142965 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2142967 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2142969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2142974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2142977 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2142979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2142980 */     // GIR_Coverage, 17832,
     /* 2142980 */     GIR_EraseRootFromParent_Done,
     /* 2142981 */   // Label 28275: @2142981
     /* 2142981 */   GIM_Try, /*On fail goto*//*Label 28276*/ GIMT_Encode4(2143072), // Rule ID 17833 //
     /* 2142986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2142989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2142994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2142997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2143000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2143003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2143006 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2143009 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143028 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143032 */     // MIs[0] round
     /* 2143032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143035 */     // MIs[0] policy
     /* 2143035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143045 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11173:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M1_E32_MASK),
     /* 2143048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143052 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143054 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143056 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143058 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143068 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143071 */     // GIR_Coverage, 17833,
     /* 2143071 */     GIR_EraseRootFromParent_Done,
     /* 2143072 */   // Label 28276: @2143072
     /* 2143072 */   GIM_Try, /*On fail goto*//*Label 28277*/ GIMT_Encode4(2143163), // Rule ID 17836 //
     /* 2143077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2143080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2143097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143119 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143123 */     // MIs[0] round
     /* 2143123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143126 */     // MIs[0] policy
     /* 2143126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143136 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2143139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143145 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143147 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143149 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143159 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143162 */     // GIR_Coverage, 17836,
     /* 2143162 */     GIR_EraseRootFromParent_Done,
     /* 2143163 */   // Label 28277: @2143163
     /* 2143163 */   GIM_Try, /*On fail goto*//*Label 28278*/ GIMT_Encode4(2143254), // Rule ID 17837 //
     /* 2143168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2143171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2143179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2143182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2143185 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2143188 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2143191 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2143198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2143206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2143210 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143214 */     // MIs[0] round
     /* 2143214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143217 */     // MIs[0] policy
     /* 2143217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143227 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11173:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M1_E64_MASK),
     /* 2143230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143236 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143238 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143240 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2143250 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143253 */     // GIR_Coverage, 17837,
     /* 2143253 */     GIR_EraseRootFromParent_Done,
     /* 2143254 */   // Label 28278: @2143254
     /* 2143254 */   GIM_Try, /*On fail goto*//*Label 28279*/ GIMT_Encode4(2143345), // Rule ID 17840 //
     /* 2143259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2143270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143282 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143301 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143305 */     // MIs[0] round
     /* 2143305 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143308 */     // MIs[0] policy
     /* 2143308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143318 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2143321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143327 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143329 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143331 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143341 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143344 */     // GIR_Coverage, 17840,
     /* 2143344 */     GIR_EraseRootFromParent_Done,
     /* 2143345 */   // Label 28279: @2143345
     /* 2143345 */   GIM_Try, /*On fail goto*//*Label 28280*/ GIMT_Encode4(2143436), // Rule ID 17841 //
     /* 2143350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2143361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2143364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2143370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2143373 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143388 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143392 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143396 */     // MIs[0] round
     /* 2143396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143399 */     // MIs[0] policy
     /* 2143399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143409 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M2_E16_MASK),
     /* 2143412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143418 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143420 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143422 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143432 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143435 */     // GIR_Coverage, 17841,
     /* 2143435 */     GIR_EraseRootFromParent_Done,
     /* 2143436 */   // Label 28280: @2143436
     /* 2143436 */   GIM_Try, /*On fail goto*//*Label 28281*/ GIMT_Encode4(2143527), // Rule ID 17844 //
     /* 2143441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2143452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2143455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143458 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143461 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143464 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143475 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143479 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143483 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143487 */     // MIs[0] round
     /* 2143487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143490 */     // MIs[0] policy
     /* 2143490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143493 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143500 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2143503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143507 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143509 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143511 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143513 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143523 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143526 */     // GIR_Coverage, 17844,
     /* 2143526 */     GIR_EraseRootFromParent_Done,
     /* 2143527 */   // Label 28281: @2143527
     /* 2143527 */   GIM_Try, /*On fail goto*//*Label 28282*/ GIMT_Encode4(2143618), // Rule ID 17845 //
     /* 2143532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2143543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2143546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2143552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2143555 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2143562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143570 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2143574 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143578 */     // MIs[0] round
     /* 2143578 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143581 */     // MIs[0] policy
     /* 2143581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143591 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M4_E16_MASK),
     /* 2143594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143598 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143600 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143602 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143604 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143614 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143616 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143617 */     // GIR_Coverage, 17845,
     /* 2143617 */     GIR_EraseRootFromParent_Done,
     /* 2143618 */   // Label 28282: @2143618
     /* 2143618 */   GIM_Try, /*On fail goto*//*Label 28283*/ GIMT_Encode4(2143709), // Rule ID 17848 //
     /* 2143623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2143626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2143634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2143637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2143643 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2143646 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143665 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143669 */     // MIs[0] round
     /* 2143669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143672 */     // MIs[0] policy
     /* 2143672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143675 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143682 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2143685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143689 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143691 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143693 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143695 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143705 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143708 */     // GIR_Coverage, 17848,
     /* 2143708 */     GIR_EraseRootFromParent_Done,
     /* 2143709 */   // Label 28283: @2143709
     /* 2143709 */   GIM_Try, /*On fail goto*//*Label 28284*/ GIMT_Encode4(2143800), // Rule ID 17849 //
     /* 2143714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2143717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2143725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2143728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2143731 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2143734 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2143737 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2143744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2143752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2143756 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143760 */     // MIs[0] round
     /* 2143760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143763 */     // MIs[0] policy
     /* 2143763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143766 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143773 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR16_M8_E16_MASK),
     /* 2143776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143780 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143782 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143784 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143786 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2143796 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143799 */     // GIR_Coverage, 17849,
     /* 2143799 */     GIR_EraseRootFromParent_Done,
     /* 2143800 */   // Label 28284: @2143800
     /* 2143800 */   GIM_Try, /*On fail goto*//*Label 28285*/ GIMT_Encode4(2143891), // Rule ID 17852 //
     /* 2143805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2143808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2143816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2143822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143825 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143828 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2143831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143847 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143851 */     // MIs[0] round
     /* 2143851 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143854 */     // MIs[0] policy
     /* 2143854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143864 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2143864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2143867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143869 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143871 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143873 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143875 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143877 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143887 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143890 */     // GIR_Coverage, 17852,
     /* 2143890 */     GIR_EraseRootFromParent_Done,
     /* 2143891 */   // Label 28285: @2143891
     /* 2143891 */   GIM_Try, /*On fail goto*//*Label 28286*/ GIMT_Encode4(2143982), // Rule ID 17853 //
     /* 2143896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2143899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2143907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2143910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2143913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2143916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2143919 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2143922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2143926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2143934 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2143938 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2143942 */     // MIs[0] round
     /* 2143942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2143945 */     // MIs[0] policy
     /* 2143945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2143948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2143955 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2143955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M2_E32_MASK),
     /* 2143958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2143960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2143962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2143964 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2143966 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2143968 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2143970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2143975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2143978 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2143980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2143981 */     // GIR_Coverage, 17853,
     /* 2143981 */     GIR_EraseRootFromParent_Done,
     /* 2143982 */   // Label 28286: @2143982
     /* 2143982 */   GIM_Try, /*On fail goto*//*Label 28287*/ GIMT_Encode4(2144073), // Rule ID 17856 //
     /* 2143987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2143990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2143995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2143998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2144004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144010 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144025 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144029 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144033 */     // MIs[0] round
     /* 2144033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144036 */     // MIs[0] policy
     /* 2144036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144039 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144046 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2144049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144055 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144057 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144059 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144069 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144072 */     // GIR_Coverage, 17856,
     /* 2144072 */     GIR_EraseRootFromParent_Done,
     /* 2144073 */   // Label 28287: @2144073
     /* 2144073 */   GIM_Try, /*On fail goto*//*Label 28288*/ GIMT_Encode4(2144164), // Rule ID 17857 //
     /* 2144078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2144089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2144092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2144095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2144098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144101 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144120 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144124 */     // MIs[0] round
     /* 2144124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144127 */     // MIs[0] policy
     /* 2144127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144130 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144137 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M4_E32_MASK),
     /* 2144140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144144 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144146 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144148 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144150 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144160 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144163 */     // GIR_Coverage, 17857,
     /* 2144163 */     GIR_EraseRootFromParent_Done,
     /* 2144164 */   // Label 28288: @2144164
     /* 2144164 */   GIM_Try, /*On fail goto*//*Label 28289*/ GIMT_Encode4(2144255), // Rule ID 17860 //
     /* 2144169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2144172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2144186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2144189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144192 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144207 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144211 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144215 */     // MIs[0] round
     /* 2144215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144218 */     // MIs[0] policy
     /* 2144218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144221 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144228 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2144231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144237 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144239 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144241 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144251 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144254 */     // GIR_Coverage, 17860,
     /* 2144254 */     GIR_EraseRootFromParent_Done,
     /* 2144255 */   // Label 28289: @2144255
     /* 2144255 */   GIM_Try, /*On fail goto*//*Label 28290*/ GIMT_Encode4(2144346), // Rule ID 17861 //
     /* 2144260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2144263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2144271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2144274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2144277 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2144280 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2144283 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2144298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144302 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144306 */     // MIs[0] round
     /* 2144306 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144309 */     // MIs[0] policy
     /* 2144309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144312 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144319 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR32_M8_E32_MASK),
     /* 2144322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144328 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144330 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144332 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2144342 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144345 */     // GIR_Coverage, 17861,
     /* 2144345 */     GIR_EraseRootFromParent_Done,
     /* 2144346 */   // Label 28290: @2144346
     /* 2144346 */   GIM_Try, /*On fail goto*//*Label 28291*/ GIMT_Encode4(2144437), // Rule ID 17864 //
     /* 2144351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2144354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2144371 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144374 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144393 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144397 */     // MIs[0] round
     /* 2144397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144400 */     // MIs[0] policy
     /* 2144400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144410 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2144413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144417 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144419 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144421 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144423 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144433 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144436 */     // GIR_Coverage, 17864,
     /* 2144436 */     GIR_EraseRootFromParent_Done,
     /* 2144437 */   // Label 28291: @2144437
     /* 2144437 */   GIM_Try, /*On fail goto*//*Label 28292*/ GIMT_Encode4(2144528), // Rule ID 17865 //
     /* 2144442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2144445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2144453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2144456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2144462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2144465 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2144472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144480 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2144484 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144488 */     // MIs[0] round
     /* 2144488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144491 */     // MIs[0] policy
     /* 2144491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144494 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144501 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11173:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M2_E64_MASK),
     /* 2144504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144510 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144512 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144514 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144524 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144527 */     // GIR_Coverage, 17865,
     /* 2144527 */     GIR_EraseRootFromParent_Done,
     /* 2144528 */   // Label 28292: @2144528
     /* 2144528 */   GIM_Try, /*On fail goto*//*Label 28293*/ GIMT_Encode4(2144619), // Rule ID 17868 //
     /* 2144533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2144536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2144544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2144547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2144553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144556 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144571 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144575 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144579 */     // MIs[0] round
     /* 2144579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144582 */     // MIs[0] policy
     /* 2144582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144592 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2144595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144597 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144599 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144601 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144603 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144605 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144615 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144618 */     // GIR_Coverage, 17868,
     /* 2144618 */     GIR_EraseRootFromParent_Done,
     /* 2144619 */   // Label 28293: @2144619
     /* 2144619 */   GIM_Try, /*On fail goto*//*Label 28294*/ GIMT_Encode4(2144710), // Rule ID 17869 //
     /* 2144624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2144627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2144635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2144638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2144644 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2144647 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2144654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144662 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2144666 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144670 */     // MIs[0] round
     /* 2144670 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144673 */     // MIs[0] policy
     /* 2144673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144683 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11173:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M4_E64_MASK),
     /* 2144686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144690 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144692 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144694 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144696 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144706 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144709 */     // GIR_Coverage, 17869,
     /* 2144709 */     GIR_EraseRootFromParent_Done,
     /* 2144710 */   // Label 28294: @2144710
     /* 2144710 */   GIM_Try, /*On fail goto*//*Label 28295*/ GIMT_Encode4(2144801), // Rule ID 17872 //
     /* 2144715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2144718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2144735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144738 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144753 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144757 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144761 */     // MIs[0] round
     /* 2144761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144764 */     // MIs[0] policy
     /* 2144764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144767 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144774 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2144777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144781 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144783 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144785 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144787 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144797 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144800 */     // GIR_Coverage, 17872,
     /* 2144800 */     GIR_EraseRootFromParent_Done,
     /* 2144801 */   // Label 28295: @2144801
     /* 2144801 */   GIM_Try, /*On fail goto*//*Label 28296*/ GIMT_Encode4(2144892), // Rule ID 17873 //
     /* 2144806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2144809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmacc_mask),
     /* 2144814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2144817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2144820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2144823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2144826 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2144829 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2144836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2144844 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2144848 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144852 */     // MIs[0] round
     /* 2144852 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144855 */     // MIs[0] policy
     /* 2144855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144865 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11173:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMACC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2144865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMACC_VFPR64_M8_E64_MASK),
     /* 2144868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144870 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144872 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144874 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144876 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144878 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2144888 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144891 */     // GIR_Coverage, 17873,
     /* 2144891 */     GIR_EraseRootFromParent_Done,
     /* 2144892 */   // Label 28296: @2144892
     /* 2144892 */   GIM_Try, /*On fail goto*//*Label 28297*/ GIMT_Encode4(2144983), // Rule ID 17876 //
     /* 2144897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2144900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2144905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2144908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2144911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2144914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2144917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2144920 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2144923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2144927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144935 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2144939 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2144943 */     // MIs[0] round
     /* 2144943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2144946 */     // MIs[0] policy
     /* 2144946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2144949 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2144956 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2144956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2144959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2144961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2144963 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2144965 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2144967 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2144969 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2144971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2144976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2144979 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2144981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2144982 */     // GIR_Coverage, 17876,
     /* 2144982 */     GIR_EraseRootFromParent_Done,
     /* 2144983 */   // Label 28297: @2144983
     /* 2144983 */   GIM_Try, /*On fail goto*//*Label 28298*/ GIMT_Encode4(2145074), // Rule ID 17877 //
     /* 2144988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2144991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2144996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2144999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2145002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2145005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2145008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145011 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145030 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145034 */     // MIs[0] round
     /* 2145034 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145037 */     // MIs[0] policy
     /* 2145037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145040 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145047 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF4_E16_MASK),
     /* 2145050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145056 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145058 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145060 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145070 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145073 */     // GIR_Coverage, 17877,
     /* 2145073 */     GIR_EraseRootFromParent_Done,
     /* 2145074 */   // Label 28298: @2145074
     /* 2145074 */   GIM_Try, /*On fail goto*//*Label 28299*/ GIMT_Encode4(2145165), // Rule ID 17880 //
     /* 2145079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145102 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145117 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145121 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145125 */     // MIs[0] round
     /* 2145125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145128 */     // MIs[0] policy
     /* 2145128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145138 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2145141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145147 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145149 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145151 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145161 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145164 */     // GIR_Coverage, 17880,
     /* 2145164 */     GIR_EraseRootFromParent_Done,
     /* 2145165 */   // Label 28299: @2145165
     /* 2145165 */   GIM_Try, /*On fail goto*//*Label 28300*/ GIMT_Encode4(2145256), // Rule ID 17881 //
     /* 2145170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2145181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2145184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2145187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2145190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145193 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145208 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145212 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145216 */     // MIs[0] round
     /* 2145216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145219 */     // MIs[0] policy
     /* 2145219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145229 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E16_MASK),
     /* 2145232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145236 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145238 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145240 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145242 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145244 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145252 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145255 */     // GIR_Coverage, 17881,
     /* 2145255 */     GIR_EraseRootFromParent_Done,
     /* 2145256 */   // Label 28300: @2145256
     /* 2145256 */   GIM_Try, /*On fail goto*//*Label 28301*/ GIMT_Encode4(2145347), // Rule ID 17884 //
     /* 2145261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145281 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145284 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145303 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145307 */     // MIs[0] round
     /* 2145307 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145310 */     // MIs[0] policy
     /* 2145310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145320 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2145323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145325 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145327 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145329 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145331 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145333 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145343 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145346 */     // GIR_Coverage, 17884,
     /* 2145346 */     GIR_EraseRootFromParent_Done,
     /* 2145347 */   // Label 28301: @2145347
     /* 2145347 */   GIM_Try, /*On fail goto*//*Label 28302*/ GIMT_Encode4(2145438), // Rule ID 17885 //
     /* 2145352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2145363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2145366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2145369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2145372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145375 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145394 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145398 */     // MIs[0] round
     /* 2145398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145401 */     // MIs[0] policy
     /* 2145401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145411 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_MF2_E32_MASK),
     /* 2145414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145420 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145422 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145424 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145434 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145437 */     // GIR_Coverage, 17885,
     /* 2145437 */     GIR_EraseRootFromParent_Done,
     /* 2145438 */   // Label 28302: @2145438
     /* 2145438 */   GIM_Try, /*On fail goto*//*Label 28303*/ GIMT_Encode4(2145529), // Rule ID 17888 //
     /* 2145443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145463 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145466 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145481 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145485 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145489 */     // MIs[0] round
     /* 2145489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145492 */     // MIs[0] policy
     /* 2145492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145502 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2145505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145511 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145513 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145515 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145517 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145525 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145528 */     // GIR_Coverage, 17888,
     /* 2145528 */     GIR_EraseRootFromParent_Done,
     /* 2145529 */   // Label 28303: @2145529
     /* 2145529 */   GIM_Try, /*On fail goto*//*Label 28304*/ GIMT_Encode4(2145620), // Rule ID 17889 //
     /* 2145534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2145537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2145545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2145548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2145551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2145554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2145557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145576 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145580 */     // MIs[0] round
     /* 2145580 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145583 */     // MIs[0] policy
     /* 2145583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145593 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E16_MASK),
     /* 2145596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145602 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145604 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145606 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2145616 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145619 */     // GIR_Coverage, 17889,
     /* 2145619 */     GIR_EraseRootFromParent_Done,
     /* 2145620 */   // Label 28304: @2145620
     /* 2145620 */   GIM_Try, /*On fail goto*//*Label 28305*/ GIMT_Encode4(2145711), // Rule ID 17892 //
     /* 2145625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2145628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2145636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2145639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2145645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145648 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145667 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145671 */     // MIs[0] round
     /* 2145671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145674 */     // MIs[0] policy
     /* 2145674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145677 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145684 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2145687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145691 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145693 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145695 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145697 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145699 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145707 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145710 */     // GIR_Coverage, 17892,
     /* 2145710 */     GIR_EraseRootFromParent_Done,
     /* 2145711 */   // Label 28305: @2145711
     /* 2145711 */   GIM_Try, /*On fail goto*//*Label 28306*/ GIMT_Encode4(2145802), // Rule ID 17893 //
     /* 2145716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2145719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2145727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2145730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2145733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2145736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2145739 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145758 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145762 */     // MIs[0] round
     /* 2145762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145765 */     // MIs[0] policy
     /* 2145765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145775 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E32_MASK),
     /* 2145778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145782 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145784 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145786 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145788 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2145798 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145801 */     // GIR_Coverage, 17893,
     /* 2145801 */     GIR_EraseRootFromParent_Done,
     /* 2145802 */   // Label 28306: @2145802
     /* 2145802 */   GIM_Try, /*On fail goto*//*Label 28307*/ GIMT_Encode4(2145893), // Rule ID 17896 //
     /* 2145807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2145810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2145824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2145827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145830 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2145833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145849 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145853 */     // MIs[0] round
     /* 2145853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145856 */     // MIs[0] policy
     /* 2145856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145866 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2145866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2145869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145873 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145875 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145877 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145879 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145889 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145892 */     // GIR_Coverage, 17896,
     /* 2145892 */     GIR_EraseRootFromParent_Done,
     /* 2145893 */   // Label 28307: @2145893
     /* 2145893 */   GIM_Try, /*On fail goto*//*Label 28308*/ GIMT_Encode4(2145984), // Rule ID 17897 //
     /* 2145898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2145901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2145909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2145912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2145915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2145918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2145921 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2145924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2145928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145936 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2145940 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2145944 */     // MIs[0] round
     /* 2145944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2145947 */     // MIs[0] policy
     /* 2145947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2145950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2145957 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2145957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M1_E64_MASK),
     /* 2145960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2145962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2145964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2145966 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2145968 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2145970 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2145972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2145977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2145980 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2145982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2145983 */     // GIR_Coverage, 17897,
     /* 2145983 */     GIR_EraseRootFromParent_Done,
     /* 2145984 */   // Label 28308: @2145984
     /* 2145984 */   GIM_Try, /*On fail goto*//*Label 28309*/ GIMT_Encode4(2146075), // Rule ID 17900 //
     /* 2145989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2145992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2145997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146009 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146012 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146027 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146031 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146035 */     // MIs[0] round
     /* 2146035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146038 */     // MIs[0] policy
     /* 2146038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146048 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2146051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146053 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146055 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146057 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146059 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146061 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146071 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146074 */     // GIR_Coverage, 17900,
     /* 2146074 */     GIR_EraseRootFromParent_Done,
     /* 2146075 */   // Label 28309: @2146075
     /* 2146075 */   GIM_Try, /*On fail goto*//*Label 28310*/ GIMT_Encode4(2146166), // Rule ID 17901 //
     /* 2146080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2146091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2146094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2146097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2146100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146103 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146122 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146126 */     // MIs[0] round
     /* 2146126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146129 */     // MIs[0] policy
     /* 2146129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146139 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E16_MASK),
     /* 2146142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146146 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146148 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146150 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146152 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146162 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146165 */     // GIR_Coverage, 17901,
     /* 2146165 */     GIR_EraseRootFromParent_Done,
     /* 2146166 */   // Label 28310: @2146166
     /* 2146166 */   GIM_Try, /*On fail goto*//*Label 28311*/ GIMT_Encode4(2146257), // Rule ID 17904 //
     /* 2146171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146191 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146194 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146205 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146209 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146213 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146217 */     // MIs[0] round
     /* 2146217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146220 */     // MIs[0] policy
     /* 2146220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146223 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146230 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2146233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146239 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146241 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146243 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146253 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146255 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146256 */     // GIR_Coverage, 17904,
     /* 2146256 */     GIR_EraseRootFromParent_Done,
     /* 2146257 */   // Label 28311: @2146257
     /* 2146257 */   GIM_Try, /*On fail goto*//*Label 28312*/ GIMT_Encode4(2146348), // Rule ID 17905 //
     /* 2146262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2146273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2146276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2146279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2146282 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146285 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146304 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146308 */     // MIs[0] round
     /* 2146308 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146311 */     // MIs[0] policy
     /* 2146311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146321 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E16_MASK),
     /* 2146324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146328 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146330 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146332 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146334 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146344 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146347 */     // GIR_Coverage, 17905,
     /* 2146347 */     GIR_EraseRootFromParent_Done,
     /* 2146348 */   // Label 28312: @2146348
     /* 2146348 */   GIM_Try, /*On fail goto*//*Label 28313*/ GIMT_Encode4(2146439), // Rule ID 17908 //
     /* 2146353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2146356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146391 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146395 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146399 */     // MIs[0] round
     /* 2146399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146402 */     // MIs[0] policy
     /* 2146402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146412 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2146415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146419 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146421 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146423 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146425 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146435 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146438 */     // GIR_Coverage, 17908,
     /* 2146438 */     GIR_EraseRootFromParent_Done,
     /* 2146439 */   // Label 28313: @2146439
     /* 2146439 */   GIM_Try, /*On fail goto*//*Label 28314*/ GIMT_Encode4(2146530), // Rule ID 17909 //
     /* 2146444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2146447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2146455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2146458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2146461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2146464 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2146467 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146486 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146490 */     // MIs[0] round
     /* 2146490 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146493 */     // MIs[0] policy
     /* 2146493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146503 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E16_MASK),
     /* 2146506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146510 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146512 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146514 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146516 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2146526 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146529 */     // GIR_Coverage, 17909,
     /* 2146529 */     GIR_EraseRootFromParent_Done,
     /* 2146530 */   // Label 28314: @2146530
     /* 2146530 */   GIM_Try, /*On fail goto*//*Label 28315*/ GIMT_Encode4(2146621), // Rule ID 17912 //
     /* 2146535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146558 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146577 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146581 */     // MIs[0] round
     /* 2146581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146584 */     // MIs[0] policy
     /* 2146584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146594 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2146597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146603 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146605 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146607 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146617 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146620 */     // GIR_Coverage, 17912,
     /* 2146620 */     GIR_EraseRootFromParent_Done,
     /* 2146621 */   // Label 28315: @2146621
     /* 2146621 */   GIM_Try, /*On fail goto*//*Label 28316*/ GIMT_Encode4(2146712), // Rule ID 17913 //
     /* 2146626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2146637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2146640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2146643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2146646 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2146649 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2146656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146664 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2146668 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146672 */     // MIs[0] round
     /* 2146672 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146675 */     // MIs[0] policy
     /* 2146675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146678 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E32_MASK),
     /* 2146688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146692 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146694 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146696 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146698 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146700 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146708 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146711 */     // GIR_Coverage, 17913,
     /* 2146711 */     GIR_EraseRootFromParent_Done,
     /* 2146712 */   // Label 28316: @2146712
     /* 2146712 */   GIM_Try, /*On fail goto*//*Label 28317*/ GIMT_Encode4(2146803), // Rule ID 17916 //
     /* 2146717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2146728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2146737 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146740 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146755 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146759 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146763 */     // MIs[0] round
     /* 2146763 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146766 */     // MIs[0] policy
     /* 2146766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146769 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146776 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2146779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146783 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146785 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146787 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146789 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146799 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146802 */     // GIR_Coverage, 17916,
     /* 2146802 */     GIR_EraseRootFromParent_Done,
     /* 2146803 */   // Label 28317: @2146803
     /* 2146803 */   GIM_Try, /*On fail goto*//*Label 28318*/ GIMT_Encode4(2146894), // Rule ID 17917 //
     /* 2146808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2146819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2146822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2146825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2146828 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2146831 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2146834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2146838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146846 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2146850 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146854 */     // MIs[0] round
     /* 2146854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146857 */     // MIs[0] policy
     /* 2146857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146867 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2146867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E32_MASK),
     /* 2146870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146872 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146874 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146876 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146878 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146880 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146890 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146893 */     // GIR_Coverage, 17917,
     /* 2146893 */     GIR_EraseRootFromParent_Done,
     /* 2146894 */   // Label 28318: @2146894
     /* 2146894 */   GIM_Try, /*On fail goto*//*Label 28319*/ GIMT_Encode4(2146985), // Rule ID 17920 //
     /* 2146899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2146902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2146910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2146913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2146916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2146919 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2146922 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2146925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2146929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2146941 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2146945 */     // MIs[0] round
     /* 2146945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2146948 */     // MIs[0] policy
     /* 2146948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2146951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2146958 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2146958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2146961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2146963 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2146965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2146967 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2146969 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2146971 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2146973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2146978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2146981 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2146983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2146984 */     // GIR_Coverage, 17920,
     /* 2146984 */     GIR_EraseRootFromParent_Done,
     /* 2146985 */   // Label 28319: @2146985
     /* 2146985 */   GIM_Try, /*On fail goto*//*Label 28320*/ GIMT_Encode4(2147076), // Rule ID 17921 //
     /* 2146990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2146993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2146998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2147001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2147004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2147007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2147010 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2147013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147032 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147036 */     // MIs[0] round
     /* 2147036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147039 */     // MIs[0] policy
     /* 2147039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147042 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147049 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E32_MASK),
     /* 2147052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147056 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147058 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147060 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147062 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2147072 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147074 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147075 */     // GIR_Coverage, 17921,
     /* 2147075 */     GIR_EraseRootFromParent_Done,
     /* 2147076 */   // Label 28320: @2147076
     /* 2147076 */   GIM_Try, /*On fail goto*//*Label 28321*/ GIMT_Encode4(2147167), // Rule ID 17924 //
     /* 2147081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147101 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147123 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147127 */     // MIs[0] round
     /* 2147127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147130 */     // MIs[0] policy
     /* 2147130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147133 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147140 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2147143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147147 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147149 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147151 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147153 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147163 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147166 */     // GIR_Coverage, 17924,
     /* 2147166 */     GIR_EraseRootFromParent_Done,
     /* 2147167 */   // Label 28321: @2147167
     /* 2147167 */   GIM_Try, /*On fail goto*//*Label 28322*/ GIMT_Encode4(2147258), // Rule ID 17925 //
     /* 2147172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2147183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2147186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2147189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2147192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2147202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2147214 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147218 */     // MIs[0] round
     /* 2147218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147221 */     // MIs[0] policy
     /* 2147221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147224 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147231 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M2_E64_MASK),
     /* 2147234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147240 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147242 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147244 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147254 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147257 */     // GIR_Coverage, 17925,
     /* 2147257 */     GIR_EraseRootFromParent_Done,
     /* 2147258 */   // Label 28322: @2147258
     /* 2147258 */   GIM_Try, /*On fail goto*//*Label 28323*/ GIMT_Encode4(2147349), // Rule ID 17928 //
     /* 2147263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147283 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147286 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147305 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147309 */     // MIs[0] round
     /* 2147309 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147312 */     // MIs[0] policy
     /* 2147312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147322 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2147325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147331 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147333 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147335 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147345 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147348 */     // GIR_Coverage, 17928,
     /* 2147348 */     GIR_EraseRootFromParent_Done,
     /* 2147349 */   // Label 28323: @2147349
     /* 2147349 */   GIM_Try, /*On fail goto*//*Label 28324*/ GIMT_Encode4(2147440), // Rule ID 17929 //
     /* 2147354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2147365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2147368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2147371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2147374 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2147377 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2147384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147392 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2147396 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147400 */     // MIs[0] round
     /* 2147400 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147403 */     // MIs[0] policy
     /* 2147403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147406 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147413 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M4_E64_MASK),
     /* 2147416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147422 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147424 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147426 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147436 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147439 */     // GIR_Coverage, 17929,
     /* 2147439 */     GIR_EraseRootFromParent_Done,
     /* 2147440 */   // Label 28324: @2147440
     /* 2147440 */   GIM_Try, /*On fail goto*//*Label 28325*/ GIMT_Encode4(2147531), // Rule ID 17932 //
     /* 2147445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2147448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147465 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147468 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147487 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147491 */     // MIs[0] round
     /* 2147491 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147494 */     // MIs[0] policy
     /* 2147494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147504 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2147507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147511 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147513 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147515 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147517 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147527 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147530 */     // GIR_Coverage, 17932,
     /* 2147530 */     GIR_EraseRootFromParent_Done,
     /* 2147531 */   // Label 28325: @2147531
     /* 2147531 */   GIM_Try, /*On fail goto*//*Label 28326*/ GIMT_Encode4(2147622), // Rule ID 17933 //
     /* 2147536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2147539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2147547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2147550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2147553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2147556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2147559 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2147566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147574 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2147578 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147582 */     // MIs[0] round
     /* 2147582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147585 */     // MIs[0] policy
     /* 2147585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147588 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147595 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VV_M8_E64_MASK),
     /* 2147598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147600 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147602 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147604 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147606 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147608 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2147618 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147621 */     // GIR_Coverage, 17933,
     /* 2147621 */     GIR_EraseRootFromParent_Done,
     /* 2147622 */   // Label 28326: @2147622
     /* 2147622 */   GIM_Try, /*On fail goto*//*Label 28327*/ GIMT_Encode4(2147713), // Rule ID 17936 //
     /* 2147627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2147638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2147641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2147647 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147650 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147669 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147673 */     // MIs[0] round
     /* 2147673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147676 */     // MIs[0] policy
     /* 2147676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147679 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147686 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2147689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147695 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147697 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147699 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147709 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147712 */     // GIR_Coverage, 17936,
     /* 2147712 */     GIR_EraseRootFromParent_Done,
     /* 2147713 */   // Label 28327: @2147713
     /* 2147713 */   GIM_Try, /*On fail goto*//*Label 28328*/ GIMT_Encode4(2147804), // Rule ID 17937 //
     /* 2147718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2147729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2147732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2147738 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2147741 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147756 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147760 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147764 */     // MIs[0] round
     /* 2147764 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147767 */     // MIs[0] policy
     /* 2147767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147777 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF4_E16_MASK),
     /* 2147780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147784 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147786 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147788 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147790 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147800 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147803 */     // GIR_Coverage, 17937,
     /* 2147803 */     GIR_EraseRootFromParent_Done,
     /* 2147804 */   // Label 28328: @2147804
     /* 2147804 */   GIM_Try, /*On fail goto*//*Label 28329*/ GIMT_Encode4(2147895), // Rule ID 17940 //
     /* 2147809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2147812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2147820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2147823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2147829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147832 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2147835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147847 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147851 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147855 */     // MIs[0] round
     /* 2147855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147858 */     // MIs[0] policy
     /* 2147858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147861 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147868 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2147868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2147871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147877 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147879 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147881 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147891 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147894 */     // GIR_Coverage, 17940,
     /* 2147894 */     GIR_EraseRootFromParent_Done,
     /* 2147895 */   // Label 28329: @2147895
     /* 2147895 */   GIM_Try, /*On fail goto*//*Label 28330*/ GIMT_Encode4(2147986), // Rule ID 17941 //
     /* 2147900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2147903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2147911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2147914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2147917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2147920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2147923 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2147926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2147930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2147938 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2147942 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2147946 */     // MIs[0] round
     /* 2147946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2147949 */     // MIs[0] policy
     /* 2147949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2147952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2147959 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2147959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_MF2_E16_MASK),
     /* 2147962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2147964 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2147966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2147968 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2147970 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2147972 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2147974 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2147979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2147982 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2147984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2147985 */     // GIR_Coverage, 17941,
     /* 2147985 */     GIR_EraseRootFromParent_Done,
     /* 2147986 */   // Label 28330: @2147986
     /* 2147986 */   GIM_Try, /*On fail goto*//*Label 28331*/ GIMT_Encode4(2148077), // Rule ID 17944 //
     /* 2147991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2147994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2147999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148033 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148037 */     // MIs[0] round
     /* 2148037 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148040 */     // MIs[0] policy
     /* 2148040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148043 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148050 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2148053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148059 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148061 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148063 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148073 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148075 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148076 */     // GIR_Coverage, 17944,
     /* 2148076 */     GIR_EraseRootFromParent_Done,
     /* 2148077 */   // Label 28331: @2148077
     /* 2148077 */   GIM_Try, /*On fail goto*//*Label 28332*/ GIMT_Encode4(2148168), // Rule ID 17945 //
     /* 2148082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2148093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2148096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2148102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148105 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148124 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148128 */     // MIs[0] round
     /* 2148128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148131 */     // MIs[0] policy
     /* 2148131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148134 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148141 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_MF2_E32_MASK),
     /* 2148144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148146 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148150 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148152 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148154 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148164 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148167 */     // GIR_Coverage, 17945,
     /* 2148167 */     GIR_EraseRootFromParent_Done,
     /* 2148168 */   // Label 28332: @2148168
     /* 2148168 */   GIM_Try, /*On fail goto*//*Label 28333*/ GIMT_Encode4(2148259), // Rule ID 17948 //
     /* 2148173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148196 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148215 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148219 */     // MIs[0] round
     /* 2148219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148222 */     // MIs[0] policy
     /* 2148222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148225 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148232 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2148235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148239 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148241 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148243 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148245 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148255 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148258 */     // GIR_Coverage, 17948,
     /* 2148258 */     GIR_EraseRootFromParent_Done,
     /* 2148259 */   // Label 28333: @2148259
     /* 2148259 */   GIM_Try, /*On fail goto*//*Label 28334*/ GIMT_Encode4(2148350), // Rule ID 17949 //
     /* 2148264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2148275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2148278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2148284 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2148287 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148302 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148306 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148310 */     // MIs[0] round
     /* 2148310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148313 */     // MIs[0] policy
     /* 2148313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148323 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11146:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M1_E16_MASK),
     /* 2148326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148332 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148334 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148336 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148346 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148349 */     // GIR_Coverage, 17949,
     /* 2148349 */     GIR_EraseRootFromParent_Done,
     /* 2148350 */   // Label 28334: @2148350
     /* 2148350 */   GIM_Try, /*On fail goto*//*Label 28335*/ GIMT_Encode4(2148441), // Rule ID 17952 //
     /* 2148355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2148358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148378 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148397 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148401 */     // MIs[0] round
     /* 2148401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148404 */     // MIs[0] policy
     /* 2148404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148407 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148414 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2148417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148421 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148423 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148425 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148427 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148437 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148440 */     // GIR_Coverage, 17952,
     /* 2148440 */     GIR_EraseRootFromParent_Done,
     /* 2148441 */   // Label 28335: @2148441
     /* 2148441 */   GIM_Try, /*On fail goto*//*Label 28336*/ GIMT_Encode4(2148532), // Rule ID 17953 //
     /* 2148446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2148449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2148457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2148460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2148463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2148466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2148469 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2148484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148488 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148492 */     // MIs[0] round
     /* 2148492 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148495 */     // MIs[0] policy
     /* 2148495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148505 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11146:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M1_E32_MASK),
     /* 2148508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148514 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148516 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148518 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2148528 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148531 */     // GIR_Coverage, 17953,
     /* 2148531 */     GIR_EraseRootFromParent_Done,
     /* 2148532 */   // Label 28336: @2148532
     /* 2148532 */   GIM_Try, /*On fail goto*//*Label 28337*/ GIMT_Encode4(2148623), // Rule ID 17956 //
     /* 2148537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2148540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148560 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148575 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148579 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148583 */     // MIs[0] round
     /* 2148583 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148586 */     // MIs[0] policy
     /* 2148586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148596 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2148599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148603 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148605 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148607 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148609 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148619 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148622 */     // GIR_Coverage, 17956,
     /* 2148622 */     GIR_EraseRootFromParent_Done,
     /* 2148623 */   // Label 28337: @2148623
     /* 2148623 */   GIM_Try, /*On fail goto*//*Label 28338*/ GIMT_Encode4(2148714), // Rule ID 17957 //
     /* 2148628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2148631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2148639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2148642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2148645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2148648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2148651 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2148658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2148666 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2148670 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148674 */     // MIs[0] round
     /* 2148674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148677 */     // MIs[0] policy
     /* 2148677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148687 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11146:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M1_E64_MASK),
     /* 2148690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148694 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148696 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148698 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148700 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2148710 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148713 */     // GIR_Coverage, 17957,
     /* 2148713 */     GIR_EraseRootFromParent_Done,
     /* 2148714 */   // Label 28338: @2148714
     /* 2148714 */   GIM_Try, /*On fail goto*//*Label 28339*/ GIMT_Encode4(2148805), // Rule ID 17960 //
     /* 2148719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2148730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2148733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2148739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148742 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148757 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148761 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148765 */     // MIs[0] round
     /* 2148765 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148768 */     // MIs[0] policy
     /* 2148768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148771 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148778 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2148781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148783 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148787 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148789 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148791 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148801 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148804 */     // GIR_Coverage, 17960,
     /* 2148804 */     GIR_EraseRootFromParent_Done,
     /* 2148805 */   // Label 28339: @2148805
     /* 2148805 */   GIM_Try, /*On fail goto*//*Label 28340*/ GIMT_Encode4(2148896), // Rule ID 17961 //
     /* 2148810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2148821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2148824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2148830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2148833 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2148836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2148840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148848 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2148852 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148856 */     // MIs[0] round
     /* 2148856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148859 */     // MIs[0] policy
     /* 2148859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148869 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2148869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M2_E16_MASK),
     /* 2148872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148874 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148876 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148878 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148880 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148882 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148892 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148895 */     // GIR_Coverage, 17961,
     /* 2148895 */     GIR_EraseRootFromParent_Done,
     /* 2148896 */   // Label 28340: @2148896
     /* 2148896 */   GIM_Try, /*On fail goto*//*Label 28341*/ GIMT_Encode4(2148987), // Rule ID 17964 //
     /* 2148901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2148904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2148909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2148912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2148915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2148918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2148921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2148924 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2148927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2148931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2148939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2148943 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2148947 */     // MIs[0] round
     /* 2148947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2148950 */     // MIs[0] policy
     /* 2148950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2148953 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2148960 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2148960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2148963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2148965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2148967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2148969 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2148971 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2148973 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2148975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2148980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2148983 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2148985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2148986 */     // GIR_Coverage, 17964,
     /* 2148986 */     GIR_EraseRootFromParent_Done,
     /* 2148987 */   // Label 28341: @2148987
     /* 2148987 */   GIM_Try, /*On fail goto*//*Label 28342*/ GIMT_Encode4(2149078), // Rule ID 17965 //
     /* 2148992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2148995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2149003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2149006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2149012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149015 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149030 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149034 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149038 */     // MIs[0] round
     /* 2149038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149041 */     // MIs[0] policy
     /* 2149041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149051 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M4_E16_MASK),
     /* 2149054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149058 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149060 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149062 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149064 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149074 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149076 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149077 */     // GIR_Coverage, 17965,
     /* 2149077 */     GIR_EraseRootFromParent_Done,
     /* 2149078 */   // Label 28342: @2149078
     /* 2149078 */   GIM_Try, /*On fail goto*//*Label 28343*/ GIMT_Encode4(2149169), // Rule ID 17968 //
     /* 2149083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2149086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149106 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149121 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149125 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149129 */     // MIs[0] round
     /* 2149129 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149132 */     // MIs[0] policy
     /* 2149132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149135 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149142 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2149145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149149 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149151 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149153 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149155 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149165 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149168 */     // GIR_Coverage, 17968,
     /* 2149168 */     GIR_EraseRootFromParent_Done,
     /* 2149169 */   // Label 28343: @2149169
     /* 2149169 */   GIM_Try, /*On fail goto*//*Label 28344*/ GIMT_Encode4(2149260), // Rule ID 17969 //
     /* 2149174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2149177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2149185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2149188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2149191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2149194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2149197 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2149212 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149216 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149220 */     // MIs[0] round
     /* 2149220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149223 */     // MIs[0] policy
     /* 2149223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149233 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR16_M8_E16_MASK),
     /* 2149236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149242 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149244 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149246 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2149256 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149259 */     // GIR_Coverage, 17969,
     /* 2149259 */     GIR_EraseRootFromParent_Done,
     /* 2149260 */   // Label 28344: @2149260
     /* 2149260 */   GIM_Try, /*On fail goto*//*Label 28345*/ GIMT_Encode4(2149351), // Rule ID 17972 //
     /* 2149265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149285 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149288 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149303 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149307 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149311 */     // MIs[0] round
     /* 2149311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149314 */     // MIs[0] policy
     /* 2149314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149317 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2149327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149333 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149335 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149337 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149347 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149350 */     // GIR_Coverage, 17972,
     /* 2149350 */     GIR_EraseRootFromParent_Done,
     /* 2149351 */   // Label 28345: @2149351
     /* 2149351 */   GIM_Try, /*On fail goto*//*Label 28346*/ GIMT_Encode4(2149442), // Rule ID 17973 //
     /* 2149356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2149367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2149370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2149376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2149379 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149394 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149398 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149402 */     // MIs[0] round
     /* 2149402 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149405 */     // MIs[0] policy
     /* 2149405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149415 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M2_E32_MASK),
     /* 2149418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149424 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149426 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149428 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149438 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149441 */     // GIR_Coverage, 17973,
     /* 2149441 */     GIR_EraseRootFromParent_Done,
     /* 2149442 */   // Label 28346: @2149442
     /* 2149442 */   GIM_Try, /*On fail goto*//*Label 28347*/ GIMT_Encode4(2149533), // Rule ID 17976 //
     /* 2149447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149464 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149467 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149470 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149489 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149493 */     // MIs[0] round
     /* 2149493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149496 */     // MIs[0] policy
     /* 2149496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149499 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149506 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2149509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149515 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149517 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149519 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149529 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149532 */     // GIR_Coverage, 17976,
     /* 2149532 */     GIR_EraseRootFromParent_Done,
     /* 2149533 */   // Label 28347: @2149533
     /* 2149533 */   GIM_Try, /*On fail goto*//*Label 28348*/ GIMT_Encode4(2149624), // Rule ID 17977 //
     /* 2149538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2149549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2149552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2149558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2149561 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2149568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149576 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2149580 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149584 */     // MIs[0] round
     /* 2149584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149587 */     // MIs[0] policy
     /* 2149587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149590 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149597 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M4_E32_MASK),
     /* 2149600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149604 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149606 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149608 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149610 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149620 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149623 */     // GIR_Coverage, 17977,
     /* 2149623 */     GIR_EraseRootFromParent_Done,
     /* 2149624 */   // Label 28348: @2149624
     /* 2149624 */   GIM_Try, /*On fail goto*//*Label 28349*/ GIMT_Encode4(2149715), // Rule ID 17980 //
     /* 2149629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2149632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2149640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2149649 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149652 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149671 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149675 */     // MIs[0] round
     /* 2149675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149678 */     // MIs[0] policy
     /* 2149678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149688 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2149691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149695 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149697 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149699 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149701 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149711 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149714 */     // GIR_Coverage, 17980,
     /* 2149714 */     GIR_EraseRootFromParent_Done,
     /* 2149715 */   // Label 28349: @2149715
     /* 2149715 */   GIM_Try, /*On fail goto*//*Label 28350*/ GIMT_Encode4(2149806), // Rule ID 17981 //
     /* 2149720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2149723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2149731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2149734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2149737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2149740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2149743 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2149750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2149758 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2149762 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149766 */     // MIs[0] round
     /* 2149766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149769 */     // MIs[0] policy
     /* 2149769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149772 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149779 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR32_M8_E32_MASK),
     /* 2149782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149786 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149788 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149790 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149792 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2149802 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149805 */     // GIR_Coverage, 17981,
     /* 2149805 */     GIR_EraseRootFromParent_Done,
     /* 2149806 */   // Label 28350: @2149806
     /* 2149806 */   GIM_Try, /*On fail goto*//*Label 28351*/ GIMT_Encode4(2149897), // Rule ID 17984 //
     /* 2149811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2149822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2149825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149828 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2149831 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149834 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2149837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149849 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149853 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149857 */     // MIs[0] round
     /* 2149857 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149860 */     // MIs[0] policy
     /* 2149860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149870 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2149870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2149873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149875 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149877 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149879 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149881 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149883 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149893 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149896 */     // GIR_Coverage, 17984,
     /* 2149896 */     GIR_EraseRootFromParent_Done,
     /* 2149897 */   // Label 28351: @2149897
     /* 2149897 */   GIM_Try, /*On fail goto*//*Label 28352*/ GIMT_Encode4(2149988), // Rule ID 17985 //
     /* 2149902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2149905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2149910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2149913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2149916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2149919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2149922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2149925 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2149928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2149932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2149940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2149944 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2149948 */     // MIs[0] round
     /* 2149948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2149951 */     // MIs[0] policy
     /* 2149951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2149954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2149961 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11146:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2149961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M2_E64_MASK),
     /* 2149964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2149966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2149968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2149970 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2149972 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2149974 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2149976 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2149981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2149984 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2149986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2149987 */     // GIR_Coverage, 17985,
     /* 2149987 */     GIR_EraseRootFromParent_Done,
     /* 2149988 */   // Label 28352: @2149988
     /* 2149988 */   GIM_Try, /*On fail goto*//*Label 28353*/ GIMT_Encode4(2150079), // Rule ID 17988 //
     /* 2149993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2149996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150010 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150013 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150016 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150035 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150039 */     // MIs[0] round
     /* 2150039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150042 */     // MIs[0] policy
     /* 2150042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150045 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150052 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2150055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150059 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150061 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150063 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150065 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150075 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150078 */     // GIR_Coverage, 17988,
     /* 2150078 */     GIR_EraseRootFromParent_Done,
     /* 2150079 */   // Label 28353: @2150079
     /* 2150079 */   GIM_Try, /*On fail goto*//*Label 28354*/ GIMT_Encode4(2150170), // Rule ID 17989 //
     /* 2150084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2150095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2150098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2150104 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150107 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2150114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2150126 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150130 */     // MIs[0] round
     /* 2150130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150133 */     // MIs[0] policy
     /* 2150133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150136 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150143 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11146:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M4_E64_MASK),
     /* 2150146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150150 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150152 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150154 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150156 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150166 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150169 */     // GIR_Coverage, 17989,
     /* 2150169 */     GIR_EraseRootFromParent_Done,
     /* 2150170 */   // Label 28354: @2150170
     /* 2150170 */   GIM_Try, /*On fail goto*//*Label 28355*/ GIMT_Encode4(2150261), // Rule ID 17992 //
     /* 2150175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2150178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150198 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150213 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150217 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150221 */     // MIs[0] round
     /* 2150221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150224 */     // MIs[0] policy
     /* 2150224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150227 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150234 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2150237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150239 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150241 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150243 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150245 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150247 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150249 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150257 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150260 */     // GIR_Coverage, 17992,
     /* 2150260 */     GIR_EraseRootFromParent_Done,
     /* 2150261 */   // Label 28355: @2150261
     /* 2150261 */   GIM_Try, /*On fail goto*//*Label 28356*/ GIMT_Encode4(2150352), // Rule ID 17993 //
     /* 2150266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2150269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsac_mask),
     /* 2150274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2150277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2150280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2150283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2150286 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2150289 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2150296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2150304 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2150308 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150312 */     // MIs[0] round
     /* 2150312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150315 */     // MIs[0] policy
     /* 2150315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150325 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11146:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSAC_VFPR64_M8_E64_MASK),
     /* 2150328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150330 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150332 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150334 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150336 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150338 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2150348 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150351 */     // GIR_Coverage, 17993,
     /* 2150351 */     GIR_EraseRootFromParent_Done,
     /* 2150352 */   // Label 28356: @2150352
     /* 2150352 */   GIM_Try, /*On fail goto*//*Label 28357*/ GIMT_Encode4(2150443), // Rule ID 17996 //
     /* 2150357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150374 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150377 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150380 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150395 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150399 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150403 */     // MIs[0] round
     /* 2150403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150406 */     // MIs[0] policy
     /* 2150406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150416 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2150419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150423 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150425 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150427 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150429 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150439 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150442 */     // GIR_Coverage, 17996,
     /* 2150442 */     GIR_EraseRootFromParent_Done,
     /* 2150443 */   // Label 28357: @2150443
     /* 2150443 */   GIM_Try, /*On fail goto*//*Label 28358*/ GIMT_Encode4(2150534), // Rule ID 17997 //
     /* 2150448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2150459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2150462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2150465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2150468 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150471 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150486 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150490 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150494 */     // MIs[0] round
     /* 2150494 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150497 */     // MIs[0] policy
     /* 2150497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150500 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150507 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF4_E16_MASK),
     /* 2150510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150516 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150518 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150520 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150530 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150533 */     // GIR_Coverage, 17997,
     /* 2150533 */     GIR_EraseRootFromParent_Done,
     /* 2150534 */   // Label 28358: @2150534
     /* 2150534 */   GIM_Try, /*On fail goto*//*Label 28359*/ GIMT_Encode4(2150625), // Rule ID 18000 //
     /* 2150539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150562 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150581 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150585 */     // MIs[0] round
     /* 2150585 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150588 */     // MIs[0] policy
     /* 2150588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150591 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150598 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2150601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150607 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150609 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150611 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150621 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150624 */     // GIR_Coverage, 18000,
     /* 2150624 */     GIR_EraseRootFromParent_Done,
     /* 2150625 */   // Label 28359: @2150625
     /* 2150625 */   GIM_Try, /*On fail goto*//*Label 28360*/ GIMT_Encode4(2150716), // Rule ID 18001 //
     /* 2150630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2150641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2150644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2150647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2150650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2150653 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150668 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150672 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150676 */     // MIs[0] round
     /* 2150676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150679 */     // MIs[0] policy
     /* 2150679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150689 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E16_MASK),
     /* 2150692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150696 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150698 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150700 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150702 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150712 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150715 */     // GIR_Coverage, 18001,
     /* 2150715 */     GIR_EraseRootFromParent_Done,
     /* 2150716 */   // Label 28360: @2150716
     /* 2150716 */   GIM_Try, /*On fail goto*//*Label 28361*/ GIMT_Encode4(2150807), // Rule ID 18004 //
     /* 2150721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2150724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2150732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2150735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2150738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2150741 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150744 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150759 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150763 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150767 */     // MIs[0] round
     /* 2150767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150770 */     // MIs[0] policy
     /* 2150770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150773 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150780 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2150783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150787 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150789 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150791 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150793 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150803 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150806 */     // GIR_Coverage, 18004,
     /* 2150806 */     GIR_EraseRootFromParent_Done,
     /* 2150807 */   // Label 28361: @2150807
     /* 2150807 */   GIM_Try, /*On fail goto*//*Label 28362*/ GIMT_Encode4(2150898), // Rule ID 18005 //
     /* 2150812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2150815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2150823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2150826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2150829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2150832 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2150835 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2150838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150854 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150858 */     // MIs[0] round
     /* 2150858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150861 */     // MIs[0] policy
     /* 2150861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150864 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150871 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2150871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_MF2_E32_MASK),
     /* 2150874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150880 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150882 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150884 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2150894 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150897 */     // GIR_Coverage, 18005,
     /* 2150897 */     GIR_EraseRootFromParent_Done,
     /* 2150898 */   // Label 28362: @2150898
     /* 2150898 */   GIM_Try, /*On fail goto*//*Label 28363*/ GIMT_Encode4(2150989), // Rule ID 18008 //
     /* 2150903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2150906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2150911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2150914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2150917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2150920 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2150923 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2150926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2150929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2150933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2150945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2150949 */     // MIs[0] round
     /* 2150949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2150952 */     // MIs[0] policy
     /* 2150952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2150955 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2150962 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2150962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2150965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2150967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2150969 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2150971 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2150973 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2150975 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2150977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2150982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2150985 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2150987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2150988 */     // GIR_Coverage, 18008,
     /* 2150988 */     GIR_EraseRootFromParent_Done,
     /* 2150989 */   // Label 28363: @2150989
     /* 2150989 */   GIM_Try, /*On fail goto*//*Label 28364*/ GIMT_Encode4(2151080), // Rule ID 18009 //
     /* 2150994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2150997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2151005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2151008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2151011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2151014 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2151017 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151036 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151040 */     // MIs[0] round
     /* 2151040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151043 */     // MIs[0] policy
     /* 2151043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151046 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151053 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E16_MASK),
     /* 2151056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151060 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151062 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151064 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151066 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151076 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151079 */     // GIR_Coverage, 18009,
     /* 2151079 */     GIR_EraseRootFromParent_Done,
     /* 2151080 */   // Label 28364: @2151080
     /* 2151080 */   GIM_Try, /*On fail goto*//*Label 28365*/ GIMT_Encode4(2151171), // Rule ID 18012 //
     /* 2151085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151108 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151127 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151131 */     // MIs[0] round
     /* 2151131 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151134 */     // MIs[0] policy
     /* 2151134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151144 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2151147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151151 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151153 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151155 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151157 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151167 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151170 */     // GIR_Coverage, 18012,
     /* 2151170 */     GIR_EraseRootFromParent_Done,
     /* 2151171 */   // Label 28365: @2151171
     /* 2151171 */   GIM_Try, /*On fail goto*//*Label 28366*/ GIMT_Encode4(2151262), // Rule ID 18013 //
     /* 2151176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2151179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2151187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2151190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2151193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2151196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2151199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151214 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151218 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151222 */     // MIs[0] round
     /* 2151222 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151225 */     // MIs[0] policy
     /* 2151225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151228 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151235 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E32_MASK),
     /* 2151238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151242 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151244 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151246 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151248 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2151258 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151261 */     // GIR_Coverage, 18013,
     /* 2151261 */     GIR_EraseRootFromParent_Done,
     /* 2151262 */   // Label 28366: @2151262
     /* 2151262 */   GIM_Try, /*On fail goto*//*Label 28367*/ GIMT_Encode4(2151353), // Rule ID 18016 //
     /* 2151267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2151270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151290 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151305 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151309 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151313 */     // MIs[0] round
     /* 2151313 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151316 */     // MIs[0] policy
     /* 2151316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151319 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151326 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2151329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151331 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151333 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151335 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151337 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151339 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151349 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151352 */     // GIR_Coverage, 18016,
     /* 2151352 */     GIR_EraseRootFromParent_Done,
     /* 2151353 */   // Label 28367: @2151353
     /* 2151353 */   GIM_Try, /*On fail goto*//*Label 28368*/ GIMT_Encode4(2151444), // Rule ID 18017 //
     /* 2151358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2151361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2151369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2151372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2151375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2151378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2151381 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2151388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151396 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2151400 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151404 */     // MIs[0] round
     /* 2151404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151407 */     // MIs[0] policy
     /* 2151407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151417 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M1_E64_MASK),
     /* 2151420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151424 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151426 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151428 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151430 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2151440 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151443 */     // GIR_Coverage, 18017,
     /* 2151443 */     GIR_EraseRootFromParent_Done,
     /* 2151444 */   // Label 28368: @2151444
     /* 2151444 */   GIM_Try, /*On fail goto*//*Label 28369*/ GIMT_Encode4(2151535), // Rule ID 18020 //
     /* 2151449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151469 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151472 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151487 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151491 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151495 */     // MIs[0] round
     /* 2151495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151498 */     // MIs[0] policy
     /* 2151498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151508 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2151511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151515 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151517 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151519 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151521 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151523 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151531 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151534 */     // GIR_Coverage, 18020,
     /* 2151534 */     GIR_EraseRootFromParent_Done,
     /* 2151535 */   // Label 28369: @2151535
     /* 2151535 */   GIM_Try, /*On fail goto*//*Label 28370*/ GIMT_Encode4(2151626), // Rule ID 18021 //
     /* 2151540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2151551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2151554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2151557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2151560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2151563 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2151570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2151582 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151586 */     // MIs[0] round
     /* 2151586 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151589 */     // MIs[0] policy
     /* 2151589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151599 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E16_MASK),
     /* 2151602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151604 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151608 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151610 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151612 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151622 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151625 */     // GIR_Coverage, 18021,
     /* 2151625 */     GIR_EraseRootFromParent_Done,
     /* 2151626 */   // Label 28370: @2151626
     /* 2151626 */   GIM_Try, /*On fail goto*//*Label 28371*/ GIMT_Encode4(2151717), // Rule ID 18024 //
     /* 2151631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2151642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2151645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2151648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2151651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151654 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151669 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151673 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151677 */     // MIs[0] round
     /* 2151677 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151680 */     // MIs[0] policy
     /* 2151680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151683 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151690 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2151693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151699 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151701 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151703 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151713 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151716 */     // GIR_Coverage, 18024,
     /* 2151716 */     GIR_EraseRootFromParent_Done,
     /* 2151717 */   // Label 28371: @2151717
     /* 2151717 */   GIM_Try, /*On fail goto*//*Label 28372*/ GIMT_Encode4(2151808), // Rule ID 18025 //
     /* 2151722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2151733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2151736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2151739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2151742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2151745 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2151752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151760 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2151764 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151768 */     // MIs[0] round
     /* 2151768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151771 */     // MIs[0] policy
     /* 2151771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151781 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E16_MASK),
     /* 2151784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151788 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151790 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151792 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151794 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151804 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151807 */     // GIR_Coverage, 18025,
     /* 2151807 */     GIR_EraseRootFromParent_Done,
     /* 2151808 */   // Label 28372: @2151808
     /* 2151808 */   GIM_Try, /*On fail goto*//*Label 28373*/ GIMT_Encode4(2151899), // Rule ID 18028 //
     /* 2151813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2151816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2151824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2151833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2151836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2151839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151859 */     // MIs[0] round
     /* 2151859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151862 */     // MIs[0] policy
     /* 2151862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151872 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2151872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2151875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151881 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151883 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151885 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151895 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151898 */     // GIR_Coverage, 18028,
     /* 2151898 */     GIR_EraseRootFromParent_Done,
     /* 2151899 */   // Label 28373: @2151899
     /* 2151899 */   GIM_Try, /*On fail goto*//*Label 28374*/ GIMT_Encode4(2151990), // Rule ID 18029 //
     /* 2151904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2151907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2151912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2151915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2151918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2151921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2151924 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2151927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2151930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2151934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2151946 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2151950 */     // MIs[0] round
     /* 2151950 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2151953 */     // MIs[0] policy
     /* 2151953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2151956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2151963 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2151963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E16_MASK),
     /* 2151966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2151968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2151970 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2151972 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2151974 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2151976 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2151978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2151983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2151986 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2151988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2151989 */     // GIR_Coverage, 18029,
     /* 2151989 */     GIR_EraseRootFromParent_Done,
     /* 2151990 */   // Label 28374: @2151990
     /* 2151990 */   GIM_Try, /*On fail goto*//*Label 28375*/ GIMT_Encode4(2152081), // Rule ID 18032 //
     /* 2151995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2151998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152033 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152037 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152041 */     // MIs[0] round
     /* 2152041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152044 */     // MIs[0] policy
     /* 2152044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152047 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152054 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2152057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152061 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152063 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152065 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152067 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152077 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152080 */     // GIR_Coverage, 18032,
     /* 2152080 */     GIR_EraseRootFromParent_Done,
     /* 2152081 */   // Label 28375: @2152081
     /* 2152081 */   GIM_Try, /*On fail goto*//*Label 28376*/ GIMT_Encode4(2152172), // Rule ID 18033 //
     /* 2152086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2152097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2152100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2152103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2152106 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152109 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152124 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152128 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152132 */     // MIs[0] round
     /* 2152132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152135 */     // MIs[0] policy
     /* 2152135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152145 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E32_MASK),
     /* 2152148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152152 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152154 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152156 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152158 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152168 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152171 */     // GIR_Coverage, 18033,
     /* 2152171 */     GIR_EraseRootFromParent_Done,
     /* 2152172 */   // Label 28376: @2152172
     /* 2152172 */   GIM_Try, /*On fail goto*//*Label 28377*/ GIMT_Encode4(2152263), // Rule ID 18036 //
     /* 2152177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152197 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152200 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152219 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152223 */     // MIs[0] round
     /* 2152223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152226 */     // MIs[0] policy
     /* 2152226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152236 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2152239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152243 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152245 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152247 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152249 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152259 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152261 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152262 */     // GIR_Coverage, 18036,
     /* 2152262 */     GIR_EraseRootFromParent_Done,
     /* 2152263 */   // Label 28377: @2152263
     /* 2152263 */   GIM_Try, /*On fail goto*//*Label 28378*/ GIMT_Encode4(2152354), // Rule ID 18037 //
     /* 2152268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2152279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2152282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2152285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2152288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152291 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152310 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152314 */     // MIs[0] round
     /* 2152314 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152317 */     // MIs[0] policy
     /* 2152317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152327 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E32_MASK),
     /* 2152330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152336 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152338 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152340 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152350 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152353 */     // GIR_Coverage, 18037,
     /* 2152353 */     GIR_EraseRootFromParent_Done,
     /* 2152354 */   // Label 28378: @2152354
     /* 2152354 */   GIM_Try, /*On fail goto*//*Label 28379*/ GIMT_Encode4(2152445), // Rule ID 18040 //
     /* 2152359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2152362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152382 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152401 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152405 */     // MIs[0] round
     /* 2152405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152408 */     // MIs[0] policy
     /* 2152408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152418 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2152421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152425 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152427 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152429 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152431 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152433 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152441 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152444 */     // GIR_Coverage, 18040,
     /* 2152444 */     GIR_EraseRootFromParent_Done,
     /* 2152445 */   // Label 28379: @2152445
     /* 2152445 */   GIM_Try, /*On fail goto*//*Label 28380*/ GIMT_Encode4(2152536), // Rule ID 18041 //
     /* 2152450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2152453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2152461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2152464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2152467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2152470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2152473 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152484 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152488 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152492 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152496 */     // MIs[0] round
     /* 2152496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152499 */     // MIs[0] policy
     /* 2152499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152502 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152509 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E32_MASK),
     /* 2152512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152516 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152518 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152520 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152522 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2152532 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152535 */     // GIR_Coverage, 18041,
     /* 2152535 */     GIR_EraseRootFromParent_Done,
     /* 2152536 */   // Label 28380: @2152536
     /* 2152536 */   GIM_Try, /*On fail goto*//*Label 28381*/ GIMT_Encode4(2152627), // Rule ID 18044 //
     /* 2152541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152558 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152561 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152564 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152579 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152583 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152587 */     // MIs[0] round
     /* 2152587 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152590 */     // MIs[0] policy
     /* 2152590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152600 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2152603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152605 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152609 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152611 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152613 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152623 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152626 */     // GIR_Coverage, 18044,
     /* 2152626 */     GIR_EraseRootFromParent_Done,
     /* 2152627 */   // Label 28381: @2152627
     /* 2152627 */   GIM_Try, /*On fail goto*//*Label 28382*/ GIMT_Encode4(2152718), // Rule ID 18045 //
     /* 2152632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2152643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2152646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2152649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2152652 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2152655 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2152662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152670 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2152674 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152678 */     // MIs[0] round
     /* 2152678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152681 */     // MIs[0] policy
     /* 2152681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152691 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M2_E64_MASK),
     /* 2152694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152700 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152702 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152704 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152714 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152717 */     // GIR_Coverage, 18045,
     /* 2152717 */     GIR_EraseRootFromParent_Done,
     /* 2152718 */   // Label 28382: @2152718
     /* 2152718 */   GIM_Try, /*On fail goto*//*Label 28383*/ GIMT_Encode4(2152809), // Rule ID 18048 //
     /* 2152723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2152734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2152737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2152740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2152743 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152769 */     // MIs[0] round
     /* 2152769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152772 */     // MIs[0] policy
     /* 2152772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152775 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152782 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2152785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152789 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152791 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152793 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152795 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152805 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152808 */     // GIR_Coverage, 18048,
     /* 2152808 */     GIR_EraseRootFromParent_Done,
     /* 2152809 */   // Label 28383: @2152809
     /* 2152809 */   GIM_Try, /*On fail goto*//*Label 28384*/ GIMT_Encode4(2152900), // Rule ID 18049 //
     /* 2152814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2152825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2152828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2152831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2152834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2152837 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2152840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2152844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2152856 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152860 */     // MIs[0] round
     /* 2152860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152863 */     // MIs[0] policy
     /* 2152863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152873 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2152873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M4_E64_MASK),
     /* 2152876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152880 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152882 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152884 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152886 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152896 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152899 */     // GIR_Coverage, 18049,
     /* 2152899 */     GIR_EraseRootFromParent_Done,
     /* 2152900 */   // Label 28384: @2152900
     /* 2152900 */   GIM_Try, /*On fail goto*//*Label 28385*/ GIMT_Encode4(2152991), // Rule ID 18052 //
     /* 2152905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2152908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2152913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2152916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2152919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2152922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2152925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2152928 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2152931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2152935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152943 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2152947 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2152951 */     // MIs[0] round
     /* 2152951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2152954 */     // MIs[0] policy
     /* 2152954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2152957 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2152964 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2152964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2152967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2152969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2152971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2152973 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2152975 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2152977 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2152979 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2152984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2152987 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2152989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2152990 */     // GIR_Coverage, 18052,
     /* 2152990 */     GIR_EraseRootFromParent_Done,
     /* 2152991 */   // Label 28385: @2152991
     /* 2152991 */   GIM_Try, /*On fail goto*//*Label 28386*/ GIMT_Encode4(2153082), // Rule ID 18053 //
     /* 2152996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2152999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2153007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2153010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2153013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2153016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2153019 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2153026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2153038 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153042 */     // MIs[0] round
     /* 2153042 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153045 */     // MIs[0] policy
     /* 2153045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153055 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VV_M8_E64_MASK),
     /* 2153058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153062 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153064 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153066 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153068 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2153078 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153081 */     // GIR_Coverage, 18053,
     /* 2153081 */     GIR_EraseRootFromParent_Done,
     /* 2153082 */   // Label 28386: @2153082
     /* 2153082 */   GIM_Try, /*On fail goto*//*Label 28387*/ GIMT_Encode4(2153173), // Rule ID 18056 //
     /* 2153087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153110 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153125 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153129 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153133 */     // MIs[0] round
     /* 2153133 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153136 */     // MIs[0] policy
     /* 2153136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153146 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2153149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153153 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153155 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153157 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153159 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153169 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153172 */     // GIR_Coverage, 18056,
     /* 2153172 */     GIR_EraseRootFromParent_Done,
     /* 2153173 */   // Label 28387: @2153173
     /* 2153173 */   GIM_Try, /*On fail goto*//*Label 28388*/ GIMT_Encode4(2153264), // Rule ID 18057 //
     /* 2153178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2153189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2153192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2153198 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153201 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153220 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153224 */     // MIs[0] round
     /* 2153224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153227 */     // MIs[0] policy
     /* 2153227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153237 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF4_E16_MASK),
     /* 2153240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153244 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153246 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153248 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153250 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153260 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153263 */     // GIR_Coverage, 18057,
     /* 2153263 */     GIR_EraseRootFromParent_Done,
     /* 2153264 */   // Label 28388: @2153264
     /* 2153264 */   GIM_Try, /*On fail goto*//*Label 28389*/ GIMT_Encode4(2153355), // Rule ID 18060 //
     /* 2153269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153292 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153311 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153315 */     // MIs[0] round
     /* 2153315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153318 */     // MIs[0] policy
     /* 2153318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153321 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153328 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2153331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153337 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153339 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153341 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153343 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153351 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153354 */     // GIR_Coverage, 18060,
     /* 2153354 */     GIR_EraseRootFromParent_Done,
     /* 2153355 */   // Label 28389: @2153355
     /* 2153355 */   GIM_Try, /*On fail goto*//*Label 28390*/ GIMT_Encode4(2153446), // Rule ID 18061 //
     /* 2153360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2153371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2153374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2153380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153383 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153398 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153402 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153406 */     // MIs[0] round
     /* 2153406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153409 */     // MIs[0] policy
     /* 2153409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153419 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_MF2_E16_MASK),
     /* 2153422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153426 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153428 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153430 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153432 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153434 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153442 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153445 */     // GIR_Coverage, 18061,
     /* 2153445 */     GIR_EraseRootFromParent_Done,
     /* 2153446 */   // Label 28390: @2153446
     /* 2153446 */   GIM_Try, /*On fail goto*//*Label 28391*/ GIMT_Encode4(2153537), // Rule ID 18064 //
     /* 2153451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153471 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153474 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153493 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153497 */     // MIs[0] round
     /* 2153497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153500 */     // MIs[0] policy
     /* 2153500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153510 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2153513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153519 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153521 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153523 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153533 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153536 */     // GIR_Coverage, 18064,
     /* 2153536 */     GIR_EraseRootFromParent_Done,
     /* 2153537 */   // Label 28391: @2153537
     /* 2153537 */   GIM_Try, /*On fail goto*//*Label 28392*/ GIMT_Encode4(2153628), // Rule ID 18065 //
     /* 2153542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2153553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2153556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2153562 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2153565 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153580 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153584 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153588 */     // MIs[0] round
     /* 2153588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153591 */     // MIs[0] policy
     /* 2153591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153601 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_MF2_E32_MASK),
     /* 2153604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153610 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153612 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153614 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153624 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153627 */     // GIR_Coverage, 18065,
     /* 2153627 */     GIR_EraseRootFromParent_Done,
     /* 2153628 */   // Label 28392: @2153628
     /* 2153628 */   GIM_Try, /*On fail goto*//*Label 28393*/ GIMT_Encode4(2153719), // Rule ID 18068 //
     /* 2153633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2153636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2153644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2153647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2153653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153671 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153679 */     // MIs[0] round
     /* 2153679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153682 */     // MIs[0] policy
     /* 2153682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153692 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2153695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153701 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153703 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153705 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153715 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153718 */     // GIR_Coverage, 18068,
     /* 2153718 */     GIR_EraseRootFromParent_Done,
     /* 2153719 */   // Label 28393: @2153719
     /* 2153719 */   GIM_Try, /*On fail goto*//*Label 28394*/ GIMT_Encode4(2153810), // Rule ID 18069 //
     /* 2153724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2153727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2153735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2153738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2153741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2153744 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2153747 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2153762 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153766 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153770 */     // MIs[0] round
     /* 2153770 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153773 */     // MIs[0] policy
     /* 2153773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153783 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11177:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M1_E16_MASK),
     /* 2153786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153792 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153794 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153796 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2153806 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153809 */     // GIR_Coverage, 18069,
     /* 2153809 */     GIR_EraseRootFromParent_Done,
     /* 2153810 */   // Label 28394: @2153810
     /* 2153810 */   GIM_Try, /*On fail goto*//*Label 28395*/ GIMT_Encode4(2153901), // Rule ID 18072 //
     /* 2153815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2153818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2153826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2153829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2153835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153838 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2153841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153857 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153861 */     // MIs[0] round
     /* 2153861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153864 */     // MIs[0] policy
     /* 2153864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153874 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2153874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2153877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153883 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153885 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153887 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153889 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153897 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153900 */     // GIR_Coverage, 18072,
     /* 2153900 */     GIR_EraseRootFromParent_Done,
     /* 2153901 */   // Label 28395: @2153901
     /* 2153901 */   GIM_Try, /*On fail goto*//*Label 28396*/ GIMT_Encode4(2153992), // Rule ID 18073 //
     /* 2153906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2153909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2153914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2153917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2153920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2153923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2153926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2153929 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2153932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2153936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2153944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2153948 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2153952 */     // MIs[0] round
     /* 2153952 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2153955 */     // MIs[0] policy
     /* 2153955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2153958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2153965 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11177:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2153965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M1_E32_MASK),
     /* 2153968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2153970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2153972 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2153974 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2153976 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2153978 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2153980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2153985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2153988 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2153990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2153991 */     // GIR_Coverage, 18073,
     /* 2153991 */     GIR_EraseRootFromParent_Done,
     /* 2153992 */   // Label 28396: @2153992
     /* 2153992 */   GIM_Try, /*On fail goto*//*Label 28397*/ GIMT_Encode4(2154083), // Rule ID 18076 //
     /* 2153997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2154000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154020 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154035 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154039 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154043 */     // MIs[0] round
     /* 2154043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154046 */     // MIs[0] policy
     /* 2154046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154056 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2154059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154065 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154067 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154069 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154079 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154082 */     // GIR_Coverage, 18076,
     /* 2154082 */     GIR_EraseRootFromParent_Done,
     /* 2154083 */   // Label 28397: @2154083
     /* 2154083 */   GIM_Try, /*On fail goto*//*Label 28398*/ GIMT_Encode4(2154174), // Rule ID 18077 //
     /* 2154088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2154091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2154099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2154102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2154105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2154108 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2154111 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2154118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2154126 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2154130 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154134 */     // MIs[0] round
     /* 2154134 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154137 */     // MIs[0] policy
     /* 2154137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154147 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11177:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M1_E64_MASK),
     /* 2154150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154156 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154158 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154160 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2154170 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154173 */     // GIR_Coverage, 18077,
     /* 2154173 */     GIR_EraseRootFromParent_Done,
     /* 2154174 */   // Label 28398: @2154174
     /* 2154174 */   GIM_Try, /*On fail goto*//*Label 28399*/ GIMT_Encode4(2154265), // Rule ID 18080 //
     /* 2154179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154202 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154221 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154225 */     // MIs[0] round
     /* 2154225 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154228 */     // MIs[0] policy
     /* 2154228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154238 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2154241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154243 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154245 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154247 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154249 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154251 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154261 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154264 */     // GIR_Coverage, 18080,
     /* 2154264 */     GIR_EraseRootFromParent_Done,
     /* 2154265 */   // Label 28399: @2154265
     /* 2154265 */   GIM_Try, /*On fail goto*//*Label 28400*/ GIMT_Encode4(2154356), // Rule ID 18081 //
     /* 2154270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2154281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2154284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2154290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154293 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154312 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154316 */     // MIs[0] round
     /* 2154316 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154319 */     // MIs[0] policy
     /* 2154319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154322 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154329 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M2_E16_MASK),
     /* 2154332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154338 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154340 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154342 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154352 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154355 */     // GIR_Coverage, 18081,
     /* 2154355 */     GIR_EraseRootFromParent_Done,
     /* 2154356 */   // Label 28400: @2154356
     /* 2154356 */   GIM_Try, /*On fail goto*//*Label 28401*/ GIMT_Encode4(2154447), // Rule ID 18084 //
     /* 2154361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154381 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154384 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154403 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154407 */     // MIs[0] round
     /* 2154407 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154410 */     // MIs[0] policy
     /* 2154410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154420 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2154423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154429 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154431 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154433 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154443 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154446 */     // GIR_Coverage, 18084,
     /* 2154446 */     GIR_EraseRootFromParent_Done,
     /* 2154447 */   // Label 28401: @2154447
     /* 2154447 */   GIM_Try, /*On fail goto*//*Label 28402*/ GIMT_Encode4(2154538), // Rule ID 18085 //
     /* 2154452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2154463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2154466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2154472 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2154475 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154490 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154494 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154498 */     // MIs[0] round
     /* 2154498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154501 */     // MIs[0] policy
     /* 2154501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154504 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154511 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M4_E16_MASK),
     /* 2154514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154520 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154522 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154524 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154534 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154537 */     // GIR_Coverage, 18085,
     /* 2154537 */     GIR_EraseRootFromParent_Done,
     /* 2154538 */   // Label 28402: @2154538
     /* 2154538 */   GIM_Try, /*On fail goto*//*Label 28403*/ GIMT_Encode4(2154629), // Rule ID 18088 //
     /* 2154543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2154546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154581 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154589 */     // MIs[0] round
     /* 2154589 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154592 */     // MIs[0] policy
     /* 2154592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154602 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2154605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154609 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154611 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154613 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154615 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154625 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154628 */     // GIR_Coverage, 18088,
     /* 2154628 */     GIR_EraseRootFromParent_Done,
     /* 2154629 */   // Label 28403: @2154629
     /* 2154629 */   GIM_Try, /*On fail goto*//*Label 28404*/ GIMT_Encode4(2154720), // Rule ID 18089 //
     /* 2154634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2154637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2154645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2154648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2154651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2154654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2154657 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2154664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2154672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2154676 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154680 */     // MIs[0] round
     /* 2154680 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154683 */     // MIs[0] policy
     /* 2154683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154693 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR16_M8_E16_MASK),
     /* 2154696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154700 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154702 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154704 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154706 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2154716 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154719 */     // GIR_Coverage, 18089,
     /* 2154719 */     GIR_EraseRootFromParent_Done,
     /* 2154720 */   // Label 28404: @2154720
     /* 2154720 */   GIM_Try, /*On fail goto*//*Label 28405*/ GIMT_Encode4(2154811), // Rule ID 18092 //
     /* 2154725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2154736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2154739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2154745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154748 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154763 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154767 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154771 */     // MIs[0] round
     /* 2154771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154774 */     // MIs[0] policy
     /* 2154774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154784 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2154787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154793 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154795 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154797 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154807 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154810 */     // GIR_Coverage, 18092,
     /* 2154810 */     GIR_EraseRootFromParent_Done,
     /* 2154811 */   // Label 28405: @2154811
     /* 2154811 */   GIM_Try, /*On fail goto*//*Label 28406*/ GIMT_Encode4(2154902), // Rule ID 18093 //
     /* 2154816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2154819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2154827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2154830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2154836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2154839 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2154842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2154846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2154858 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154862 */     // MIs[0] round
     /* 2154862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154865 */     // MIs[0] policy
     /* 2154865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154868 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154875 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2154875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M2_E32_MASK),
     /* 2154878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154882 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154884 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154886 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154888 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154898 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154901 */     // GIR_Coverage, 18093,
     /* 2154901 */     GIR_EraseRootFromParent_Done,
     /* 2154902 */   // Label 28406: @2154902
     /* 2154902 */   GIM_Try, /*On fail goto*//*Label 28407*/ GIMT_Encode4(2154993), // Rule ID 18096 //
     /* 2154907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2154910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2154915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2154918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2154921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2154924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2154927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2154930 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2154933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2154937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2154945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2154949 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2154953 */     // MIs[0] round
     /* 2154953 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2154956 */     // MIs[0] policy
     /* 2154956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2154959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2154966 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2154966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2154969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2154971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2154973 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2154975 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2154977 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2154979 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2154981 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2154986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2154989 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2154991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2154992 */     // GIR_Coverage, 18096,
     /* 2154992 */     GIR_EraseRootFromParent_Done,
     /* 2154993 */   // Label 28407: @2154993
     /* 2154993 */   GIM_Try, /*On fail goto*//*Label 28408*/ GIMT_Encode4(2155084), // Rule ID 18097 //
     /* 2154998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2155009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2155012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2155018 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155021 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155036 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155040 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155044 */     // MIs[0] round
     /* 2155044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155047 */     // MIs[0] policy
     /* 2155047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155057 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M4_E32_MASK),
     /* 2155060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155066 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155068 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155070 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155080 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155083 */     // GIR_Coverage, 18097,
     /* 2155083 */     GIR_EraseRootFromParent_Done,
     /* 2155084 */   // Label 28408: @2155084
     /* 2155084 */   GIM_Try, /*On fail goto*//*Label 28409*/ GIMT_Encode4(2155175), // Rule ID 18100 //
     /* 2155089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2155092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155112 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155127 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155131 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155135 */     // MIs[0] round
     /* 2155135 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155138 */     // MIs[0] policy
     /* 2155138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155148 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2155151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155155 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155157 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155159 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155161 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155171 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155174 */     // GIR_Coverage, 18100,
     /* 2155174 */     GIR_EraseRootFromParent_Done,
     /* 2155175 */   // Label 28409: @2155175
     /* 2155175 */   GIM_Try, /*On fail goto*//*Label 28410*/ GIMT_Encode4(2155266), // Rule ID 18101 //
     /* 2155180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2155183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2155191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2155194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2155197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2155200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2155203 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2155218 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155222 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155226 */     // MIs[0] round
     /* 2155226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155229 */     // MIs[0] policy
     /* 2155229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155239 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR32_M8_E32_MASK),
     /* 2155242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155246 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155248 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155250 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155252 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2155262 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155265 */     // GIR_Coverage, 18101,
     /* 2155265 */     GIR_EraseRootFromParent_Done,
     /* 2155266 */   // Label 28410: @2155266
     /* 2155266 */   GIM_Try, /*On fail goto*//*Label 28411*/ GIMT_Encode4(2155357), // Rule ID 18104 //
     /* 2155271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155294 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155309 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155313 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155317 */     // MIs[0] round
     /* 2155317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155320 */     // MIs[0] policy
     /* 2155320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155330 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2155333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155337 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155339 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155341 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155343 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155353 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155356 */     // GIR_Coverage, 18104,
     /* 2155356 */     GIR_EraseRootFromParent_Done,
     /* 2155357 */   // Label 28411: @2155357
     /* 2155357 */   GIM_Try, /*On fail goto*//*Label 28412*/ GIMT_Encode4(2155448), // Rule ID 18105 //
     /* 2155362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2155373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2155376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155379 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2155382 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2155385 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2155392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2155404 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155408 */     // MIs[0] round
     /* 2155408 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155411 */     // MIs[0] policy
     /* 2155411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155414 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155421 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11177:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M2_E64_MASK),
     /* 2155424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155428 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155430 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155432 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155434 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155444 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155447 */     // GIR_Coverage, 18105,
     /* 2155447 */     GIR_EraseRootFromParent_Done,
     /* 2155448 */   // Label 28412: @2155448
     /* 2155448 */   GIM_Try, /*On fail goto*//*Label 28413*/ GIMT_Encode4(2155539), // Rule ID 18108 //
     /* 2155453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155499 */     // MIs[0] round
     /* 2155499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155502 */     // MIs[0] policy
     /* 2155502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155505 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155512 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2155515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155517 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155519 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155521 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155523 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155525 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155535 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155538 */     // GIR_Coverage, 18108,
     /* 2155538 */     GIR_EraseRootFromParent_Done,
     /* 2155539 */   // Label 28413: @2155539
     /* 2155539 */   GIM_Try, /*On fail goto*//*Label 28414*/ GIMT_Encode4(2155630), // Rule ID 18109 //
     /* 2155544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2155555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2155558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2155564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2155567 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2155574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155582 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2155586 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155590 */     // MIs[0] round
     /* 2155590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155593 */     // MIs[0] policy
     /* 2155593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155603 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11177:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M4_E64_MASK),
     /* 2155606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155612 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155614 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155616 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155626 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155629 */     // GIR_Coverage, 18109,
     /* 2155629 */     GIR_EraseRootFromParent_Done,
     /* 2155630 */   // Label 28414: @2155630
     /* 2155630 */   GIM_Try, /*On fail goto*//*Label 28415*/ GIMT_Encode4(2155721), // Rule ID 18112 //
     /* 2155635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2155638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2155646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2155649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2155655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155658 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155673 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155677 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155681 */     // MIs[0] round
     /* 2155681 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155684 */     // MIs[0] policy
     /* 2155684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155694 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2155697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155703 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155705 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155707 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155717 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155720 */     // GIR_Coverage, 18112,
     /* 2155720 */     GIR_EraseRootFromParent_Done,
     /* 2155721 */   // Label 28415: @2155721
     /* 2155721 */   GIM_Try, /*On fail goto*//*Label 28416*/ GIMT_Encode4(2155812), // Rule ID 18113 //
     /* 2155726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2155729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsac_mask),
     /* 2155734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2155737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2155740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2155743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2155746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2155749 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2155756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2155764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2155768 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155772 */     // MIs[0] round
     /* 2155772 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155775 */     // MIs[0] policy
     /* 2155775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155778 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155785 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11177:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSAC_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSAC_VFPR64_M8_E64_MASK),
     /* 2155788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155792 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155794 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155796 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155798 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2155808 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155811 */     // GIR_Coverage, 18113,
     /* 2155811 */     GIR_EraseRootFromParent_Done,
     /* 2155812 */   // Label 28416: @2155812
     /* 2155812 */   GIM_Try, /*On fail goto*//*Label 28417*/ GIMT_Encode4(2155903), // Rule ID 18116 //
     /* 2155817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2155820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2155825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2155828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2155837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2155843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155859 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155863 */     // MIs[0] round
     /* 2155863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155866 */     // MIs[0] policy
     /* 2155866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155876 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2155876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2155879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155885 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155887 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155889 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155899 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155902 */     // GIR_Coverage, 18116,
     /* 2155902 */     GIR_EraseRootFromParent_Done,
     /* 2155903 */   // Label 28417: @2155903
     /* 2155903 */   GIM_Try, /*On fail goto*//*Label 28418*/ GIMT_Encode4(2155994), // Rule ID 18117 //
     /* 2155908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2155911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2155916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2155919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2155922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2155925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2155928 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2155931 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2155934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2155938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2155950 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2155954 */     // MIs[0] round
     /* 2155954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2155957 */     // MIs[0] policy
     /* 2155957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2155960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2155967 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2155967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16_MASK),
     /* 2155970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2155972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2155974 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2155976 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2155978 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2155980 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2155982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2155987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2155990 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2155992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2155993 */     // GIR_Coverage, 18117,
     /* 2155993 */     GIR_EraseRootFromParent_Done,
     /* 2155994 */   // Label 28418: @2155994
     /* 2155994 */   GIM_Try, /*On fail goto*//*Label 28419*/ GIMT_Encode4(2156085), // Rule ID 18120 //
     /* 2155999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156022 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156037 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156041 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156045 */     // MIs[0] round
     /* 2156045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156048 */     // MIs[0] policy
     /* 2156048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156058 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2156061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156067 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156069 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156071 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156081 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156084 */     // GIR_Coverage, 18120,
     /* 2156084 */     GIR_EraseRootFromParent_Done,
     /* 2156085 */   // Label 28419: @2156085
     /* 2156085 */   GIM_Try, /*On fail goto*//*Label 28420*/ GIMT_Encode4(2156176), // Rule ID 18121 //
     /* 2156090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2156101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2156104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2156107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2156110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156113 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156124 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156128 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156132 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156136 */     // MIs[0] round
     /* 2156136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156139 */     // MIs[0] policy
     /* 2156139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156149 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16_MASK),
     /* 2156152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156158 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156160 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156162 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156172 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156175 */     // GIR_Coverage, 18121,
     /* 2156175 */     GIR_EraseRootFromParent_Done,
     /* 2156176 */   // Label 28420: @2156176
     /* 2156176 */   GIM_Try, /*On fail goto*//*Label 28421*/ GIMT_Encode4(2156267), // Rule ID 18124 //
     /* 2156181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156198 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156201 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156204 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156219 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156223 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156227 */     // MIs[0] round
     /* 2156227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156230 */     // MIs[0] policy
     /* 2156230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156233 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156240 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2156243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156247 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156249 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156251 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156253 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156263 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156266 */     // GIR_Coverage, 18124,
     /* 2156266 */     GIR_EraseRootFromParent_Done,
     /* 2156267 */   // Label 28421: @2156267
     /* 2156267 */   GIM_Try, /*On fail goto*//*Label 28422*/ GIMT_Encode4(2156358), // Rule ID 18125 //
     /* 2156272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2156283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2156286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2156289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2156292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156295 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156310 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156314 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156318 */     // MIs[0] round
     /* 2156318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156321 */     // MIs[0] policy
     /* 2156321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156331 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32_MASK),
     /* 2156334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156338 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156340 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156342 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156344 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156354 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156357 */     // GIR_Coverage, 18125,
     /* 2156357 */     GIR_EraseRootFromParent_Done,
     /* 2156358 */   // Label 28422: @2156358
     /* 2156358 */   GIM_Try, /*On fail goto*//*Label 28423*/ GIMT_Encode4(2156449), // Rule ID 18128 //
     /* 2156363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156380 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156383 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156409 */     // MIs[0] round
     /* 2156409 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156412 */     // MIs[0] policy
     /* 2156412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156422 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2156425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156431 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156433 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156435 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156445 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156448 */     // GIR_Coverage, 18128,
     /* 2156448 */     GIR_EraseRootFromParent_Done,
     /* 2156449 */   // Label 28423: @2156449
     /* 2156449 */   GIM_Try, /*On fail goto*//*Label 28424*/ GIMT_Encode4(2156540), // Rule ID 18129 //
     /* 2156454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2156457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2156465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2156468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2156471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2156474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2156477 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156496 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156500 */     // MIs[0] round
     /* 2156500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156503 */     // MIs[0] policy
     /* 2156503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156506 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156513 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16_MASK),
     /* 2156516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156520 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156522 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156524 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156526 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156536 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156539 */     // GIR_Coverage, 18129,
     /* 2156539 */     GIR_EraseRootFromParent_Done,
     /* 2156540 */   // Label 28424: @2156540
     /* 2156540 */   GIM_Try, /*On fail goto*//*Label 28425*/ GIMT_Encode4(2156631), // Rule ID 18132 //
     /* 2156545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2156548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156565 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156568 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156587 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156591 */     // MIs[0] round
     /* 2156591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156594 */     // MIs[0] policy
     /* 2156594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156597 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156604 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2156607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156611 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156613 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156615 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156617 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156627 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156630 */     // GIR_Coverage, 18132,
     /* 2156630 */     GIR_EraseRootFromParent_Done,
     /* 2156631 */   // Label 28425: @2156631
     /* 2156631 */   GIM_Try, /*On fail goto*//*Label 28426*/ GIMT_Encode4(2156722), // Rule ID 18133 //
     /* 2156636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2156639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2156647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2156650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2156653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2156656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2156659 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156678 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156682 */     // MIs[0] round
     /* 2156682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156685 */     // MIs[0] policy
     /* 2156685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156688 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156695 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32_MASK),
     /* 2156698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156704 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156706 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156708 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2156718 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156720 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156721 */     // GIR_Coverage, 18133,
     /* 2156721 */     GIR_EraseRootFromParent_Done,
     /* 2156722 */   // Label 28426: @2156722
     /* 2156722 */   GIM_Try, /*On fail goto*//*Label 28427*/ GIMT_Encode4(2156813), // Rule ID 18136 //
     /* 2156727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2156730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2156738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2156741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2156744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2156747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156750 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156765 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156769 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156773 */     // MIs[0] round
     /* 2156773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156776 */     // MIs[0] policy
     /* 2156776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156779 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156786 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2156789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156795 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156797 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156799 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156809 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156812 */     // GIR_Coverage, 18136,
     /* 2156812 */     GIR_EraseRootFromParent_Done,
     /* 2156813 */   // Label 28427: @2156813
     /* 2156813 */   GIM_Try, /*On fail goto*//*Label 28428*/ GIMT_Encode4(2156904), // Rule ID 18137 //
     /* 2156818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2156821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2156829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2156832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2156835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2156838 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2156841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2156844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2156848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2156860 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156864 */     // MIs[0] round
     /* 2156864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156867 */     // MIs[0] policy
     /* 2156867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156877 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2156877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64_MASK),
     /* 2156880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156886 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156888 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156890 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2156900 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156903 */     // GIR_Coverage, 18137,
     /* 2156903 */     GIR_EraseRootFromParent_Done,
     /* 2156904 */   // Label 28428: @2156904
     /* 2156904 */   GIM_Try, /*On fail goto*//*Label 28429*/ GIMT_Encode4(2156995), // Rule ID 18140 //
     /* 2156909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2156912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2156917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2156920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2156923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2156926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2156929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2156932 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2156935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2156939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2156951 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2156955 */     // MIs[0] round
     /* 2156955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2156958 */     // MIs[0] policy
     /* 2156958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2156961 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2156968 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2156968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2156971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2156973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2156975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2156977 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2156979 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2156981 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2156983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2156988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2156991 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2156993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2156994 */     // GIR_Coverage, 18140,
     /* 2156994 */     GIR_EraseRootFromParent_Done,
     /* 2156995 */   // Label 28429: @2156995
     /* 2156995 */   GIM_Try, /*On fail goto*//*Label 28430*/ GIMT_Encode4(2157086), // Rule ID 18141 //
     /* 2157000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2157011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2157014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2157017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2157020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157023 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157038 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157042 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157046 */     // MIs[0] round
     /* 2157046 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157049 */     // MIs[0] policy
     /* 2157049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157052 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157059 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16_MASK),
     /* 2157062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157066 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157068 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157070 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157072 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157082 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157085 */     // GIR_Coverage, 18141,
     /* 2157085 */     GIR_EraseRootFromParent_Done,
     /* 2157086 */   // Label 28430: @2157086
     /* 2157086 */   GIM_Try, /*On fail goto*//*Label 28431*/ GIMT_Encode4(2157177), // Rule ID 18144 //
     /* 2157091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157111 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157114 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157129 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157133 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157137 */     // MIs[0] round
     /* 2157137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157140 */     // MIs[0] policy
     /* 2157140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157150 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2157153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157159 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157161 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157163 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157173 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157176 */     // GIR_Coverage, 18144,
     /* 2157176 */     GIR_EraseRootFromParent_Done,
     /* 2157177 */   // Label 28431: @2157177
     /* 2157177 */   GIM_Try, /*On fail goto*//*Label 28432*/ GIMT_Encode4(2157268), // Rule ID 18145 //
     /* 2157182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2157193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2157196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2157199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2157202 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157205 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157220 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157224 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157228 */     // MIs[0] round
     /* 2157228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157231 */     // MIs[0] policy
     /* 2157231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157234 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157241 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16_MASK),
     /* 2157244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157248 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157250 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157252 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157254 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157264 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157267 */     // GIR_Coverage, 18145,
     /* 2157267 */     GIR_EraseRootFromParent_Done,
     /* 2157268 */   // Label 28432: @2157268
     /* 2157268 */   GIM_Try, /*On fail goto*//*Label 28433*/ GIMT_Encode4(2157359), // Rule ID 18148 //
     /* 2157273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2157276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157319 */     // MIs[0] round
     /* 2157319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157322 */     // MIs[0] policy
     /* 2157322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157325 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157332 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2157335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157339 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157341 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157343 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157345 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157347 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157355 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157358 */     // GIR_Coverage, 18148,
     /* 2157358 */     GIR_EraseRootFromParent_Done,
     /* 2157359 */   // Label 28433: @2157359
     /* 2157359 */   GIM_Try, /*On fail goto*//*Label 28434*/ GIMT_Encode4(2157450), // Rule ID 18149 //
     /* 2157364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2157367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2157375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2157378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2157381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2157384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2157387 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157406 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157410 */     // MIs[0] round
     /* 2157410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157413 */     // MIs[0] policy
     /* 2157413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157416 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157423 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16_MASK),
     /* 2157426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157430 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157432 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157434 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157436 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157438 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2157446 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157449 */     // GIR_Coverage, 18149,
     /* 2157449 */     GIR_EraseRootFromParent_Done,
     /* 2157450 */   // Label 28434: @2157450
     /* 2157450 */   GIM_Try, /*On fail goto*//*Label 28435*/ GIMT_Encode4(2157541), // Rule ID 18152 //
     /* 2157455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157478 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157493 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157497 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157501 */     // MIs[0] round
     /* 2157501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157504 */     // MIs[0] policy
     /* 2157504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157514 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2157517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157521 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157523 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157525 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157527 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157537 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157540 */     // GIR_Coverage, 18152,
     /* 2157540 */     GIR_EraseRootFromParent_Done,
     /* 2157541 */   // Label 28435: @2157541
     /* 2157541 */   GIM_Try, /*On fail goto*//*Label 28436*/ GIMT_Encode4(2157632), // Rule ID 18153 //
     /* 2157546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2157557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2157560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2157563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2157566 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2157569 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2157576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157580 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2157588 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157592 */     // MIs[0] round
     /* 2157592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157595 */     // MIs[0] policy
     /* 2157595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32_MASK),
     /* 2157608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157614 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157616 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157618 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157628 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157631 */     // GIR_Coverage, 18153,
     /* 2157631 */     GIR_EraseRootFromParent_Done,
     /* 2157632 */   // Label 28436: @2157632
     /* 2157632 */   GIM_Try, /*On fail goto*//*Label 28437*/ GIMT_Encode4(2157723), // Rule ID 18156 //
     /* 2157637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2157648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2157651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2157654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2157657 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157679 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157683 */     // MIs[0] round
     /* 2157683 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157686 */     // MIs[0] policy
     /* 2157686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157696 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2157699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157705 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157707 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157709 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157719 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157722 */     // GIR_Coverage, 18156,
     /* 2157722 */     GIR_EraseRootFromParent_Done,
     /* 2157723 */   // Label 28437: @2157723
     /* 2157723 */   GIM_Try, /*On fail goto*//*Label 28438*/ GIMT_Encode4(2157814), // Rule ID 18157 //
     /* 2157728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2157739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2157742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2157745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2157748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2157751 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2157758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2157770 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157774 */     // MIs[0] round
     /* 2157774 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157777 */     // MIs[0] policy
     /* 2157777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157787 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32_MASK),
     /* 2157790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157794 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157796 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157798 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157800 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157810 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157813 */     // GIR_Coverage, 18157,
     /* 2157813 */     GIR_EraseRootFromParent_Done,
     /* 2157814 */   // Label 28438: @2157814
     /* 2157814 */   GIM_Try, /*On fail goto*//*Label 28439*/ GIMT_Encode4(2157905), // Rule ID 18160 //
     /* 2157819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2157822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2157830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2157833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2157836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2157839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157842 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2157845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157861 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157865 */     // MIs[0] round
     /* 2157865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157868 */     // MIs[0] policy
     /* 2157868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157871 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157878 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2157878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2157881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157887 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157889 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157891 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157901 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157904 */     // GIR_Coverage, 18160,
     /* 2157904 */     GIR_EraseRootFromParent_Done,
     /* 2157905 */   // Label 28439: @2157905
     /* 2157905 */   GIM_Try, /*On fail goto*//*Label 28440*/ GIMT_Encode4(2157996), // Rule ID 18161 //
     /* 2157910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2157913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2157918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2157921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2157924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2157927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2157930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2157933 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2157936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2157940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157944 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157948 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2157952 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2157956 */     // MIs[0] round
     /* 2157956 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2157959 */     // MIs[0] policy
     /* 2157959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2157962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2157969 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2157969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32_MASK),
     /* 2157972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2157974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2157976 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2157978 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2157980 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2157982 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2157984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2157989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2157992 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2157994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2157995 */     // GIR_Coverage, 18161,
     /* 2157995 */     GIR_EraseRootFromParent_Done,
     /* 2157996 */   // Label 28440: @2157996
     /* 2157996 */   GIM_Try, /*On fail goto*//*Label 28441*/ GIMT_Encode4(2158087), // Rule ID 18164 //
     /* 2158001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158024 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158043 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158047 */     // MIs[0] round
     /* 2158047 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158050 */     // MIs[0] policy
     /* 2158050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2158063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158065 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158067 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158069 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158071 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158073 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158083 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158086 */     // GIR_Coverage, 18164,
     /* 2158086 */     GIR_EraseRootFromParent_Done,
     /* 2158087 */   // Label 28441: @2158087
     /* 2158087 */   GIM_Try, /*On fail goto*//*Label 28442*/ GIMT_Encode4(2158178), // Rule ID 18165 //
     /* 2158092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2158103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2158106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2158109 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2158112 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158115 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2158122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158130 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2158134 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158138 */     // MIs[0] round
     /* 2158138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158141 */     // MIs[0] policy
     /* 2158141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158144 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158151 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64_MASK),
     /* 2158154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158160 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158162 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158164 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158174 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158177 */     // GIR_Coverage, 18165,
     /* 2158177 */     GIR_EraseRootFromParent_Done,
     /* 2158178 */   // Label 28442: @2158178
     /* 2158178 */   GIM_Try, /*On fail goto*//*Label 28443*/ GIMT_Encode4(2158269), // Rule ID 18168 //
     /* 2158183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158229 */     // MIs[0] round
     /* 2158229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158232 */     // MIs[0] policy
     /* 2158232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158235 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158242 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2158245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158251 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158253 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158255 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158265 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158268 */     // GIR_Coverage, 18168,
     /* 2158268 */     GIR_EraseRootFromParent_Done,
     /* 2158269 */   // Label 28443: @2158269
     /* 2158269 */   GIM_Try, /*On fail goto*//*Label 28444*/ GIMT_Encode4(2158360), // Rule ID 18169 //
     /* 2158274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2158285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2158288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2158291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2158294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2158297 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2158304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158312 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2158316 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158320 */     // MIs[0] round
     /* 2158320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158323 */     // MIs[0] policy
     /* 2158323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158333 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64_MASK),
     /* 2158336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158342 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158344 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158346 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158356 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158359 */     // GIR_Coverage, 18169,
     /* 2158359 */     GIR_EraseRootFromParent_Done,
     /* 2158360 */   // Label 28444: @2158360
     /* 2158360 */   GIM_Try, /*On fail goto*//*Label 28445*/ GIMT_Encode4(2158451), // Rule ID 18172 //
     /* 2158365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2158368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158382 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158385 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158388 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158403 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158407 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158411 */     // MIs[0] round
     /* 2158411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158414 */     // MIs[0] policy
     /* 2158414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158417 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158424 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2158427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158433 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158435 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158437 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158447 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158450 */     // GIR_Coverage, 18172,
     /* 2158450 */     GIR_EraseRootFromParent_Done,
     /* 2158451 */   // Label 28445: @2158451
     /* 2158451 */   GIM_Try, /*On fail goto*//*Label 28446*/ GIMT_Encode4(2158542), // Rule ID 18173 //
     /* 2158456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2158459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2158467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2158470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2158473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2158476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2158479 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2158486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2158498 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158502 */     // MIs[0] round
     /* 2158502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158505 */     // MIs[0] policy
     /* 2158505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158515 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64_MASK),
     /* 2158518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158522 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158524 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158526 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158528 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2158538 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158541 */     // GIR_Coverage, 18173,
     /* 2158541 */     GIR_EraseRootFromParent_Done,
     /* 2158542 */   // Label 28446: @2158542
     /* 2158542 */   GIM_Try, /*On fail goto*//*Label 28447*/ GIMT_Encode4(2158633), // Rule ID 18176 //
     /* 2158547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158570 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158589 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158593 */     // MIs[0] round
     /* 2158593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158596 */     // MIs[0] policy
     /* 2158596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158599 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158606 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2158609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158613 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158615 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158617 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158619 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158629 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158632 */     // GIR_Coverage, 18176,
     /* 2158632 */     GIR_EraseRootFromParent_Done,
     /* 2158633 */   // Label 28447: @2158633
     /* 2158633 */   GIM_Try, /*On fail goto*//*Label 28448*/ GIMT_Encode4(2158724), // Rule ID 18177 //
     /* 2158638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2158649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2158652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2158658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158661 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158680 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158684 */     // MIs[0] round
     /* 2158684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158687 */     // MIs[0] policy
     /* 2158687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158690 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158697 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF4_E16_MASK),
     /* 2158700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158704 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158706 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158708 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158710 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158720 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158723 */     // GIR_Coverage, 18177,
     /* 2158723 */     GIR_EraseRootFromParent_Done,
     /* 2158724 */   // Label 28448: @2158724
     /* 2158724 */   GIM_Try, /*On fail goto*//*Label 28449*/ GIMT_Encode4(2158815), // Rule ID 18180 //
     /* 2158729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2158732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2158740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2158743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2158749 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158752 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158771 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158775 */     // MIs[0] round
     /* 2158775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158778 */     // MIs[0] policy
     /* 2158778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158788 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2158791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158797 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158799 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158801 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158811 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158814 */     // GIR_Coverage, 18180,
     /* 2158814 */     GIR_EraseRootFromParent_Done,
     /* 2158815 */   // Label 28449: @2158815
     /* 2158815 */   GIM_Try, /*On fail goto*//*Label 28450*/ GIMT_Encode4(2158906), // Rule ID 18181 //
     /* 2158820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2158823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2158831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2158834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2158837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2158840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2158843 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2158846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2158858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158862 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158866 */     // MIs[0] round
     /* 2158866 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158869 */     // MIs[0] policy
     /* 2158869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158872 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158879 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2158879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_MF2_E16_MASK),
     /* 2158882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158888 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158890 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158892 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2158902 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158905 */     // GIR_Coverage, 18181,
     /* 2158905 */     GIR_EraseRootFromParent_Done,
     /* 2158906 */   // Label 28450: @2158906
     /* 2158906 */   GIM_Try, /*On fail goto*//*Label 28451*/ GIMT_Encode4(2158997), // Rule ID 18184 //
     /* 2158911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2158914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2158919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2158922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2158925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2158928 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2158931 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2158934 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2158937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2158941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2158949 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2158953 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2158957 */     // MIs[0] round
     /* 2158957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2158960 */     // MIs[0] policy
     /* 2158960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2158963 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2158970 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2158970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2158973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2158975 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2158977 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2158979 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2158981 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2158983 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2158985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2158990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2158993 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2158995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2158996 */     // GIR_Coverage, 18184,
     /* 2158996 */     GIR_EraseRootFromParent_Done,
     /* 2158997 */   // Label 28451: @2158997
     /* 2158997 */   GIM_Try, /*On fail goto*//*Label 28452*/ GIMT_Encode4(2159088), // Rule ID 18185 //
     /* 2159002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2159013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2159016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2159022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159025 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159044 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159048 */     // MIs[0] round
     /* 2159048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159051 */     // MIs[0] policy
     /* 2159051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159061 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_MF2_E32_MASK),
     /* 2159064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159066 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159068 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159070 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159072 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159074 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159076 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159084 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159087 */     // GIR_Coverage, 18185,
     /* 2159087 */     GIR_EraseRootFromParent_Done,
     /* 2159088 */   // Label 28452: @2159088
     /* 2159088 */   GIM_Try, /*On fail goto*//*Label 28453*/ GIMT_Encode4(2159179), // Rule ID 18188 //
     /* 2159093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159131 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159139 */     // MIs[0] round
     /* 2159139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159142 */     // MIs[0] policy
     /* 2159142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159152 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2159155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159159 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159161 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159163 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159165 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159175 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159178 */     // GIR_Coverage, 18188,
     /* 2159178 */     GIR_EraseRootFromParent_Done,
     /* 2159179 */   // Label 28453: @2159179
     /* 2159179 */   GIM_Try, /*On fail goto*//*Label 28454*/ GIMT_Encode4(2159270), // Rule ID 18189 //
     /* 2159184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2159195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2159198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2159204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2159207 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159222 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159226 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159230 */     // MIs[0] round
     /* 2159230 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159233 */     // MIs[0] policy
     /* 2159233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159236 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159243 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11139:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M1_E16_MASK),
     /* 2159246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159250 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159252 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159254 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159256 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159266 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159269 */     // GIR_Coverage, 18189,
     /* 2159269 */     GIR_EraseRootFromParent_Done,
     /* 2159270 */   // Label 28454: @2159270
     /* 2159270 */   GIM_Try, /*On fail goto*//*Label 28455*/ GIMT_Encode4(2159361), // Rule ID 18192 //
     /* 2159275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2159278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159298 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159317 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159321 */     // MIs[0] round
     /* 2159321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159324 */     // MIs[0] policy
     /* 2159324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159334 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2159337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159341 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159343 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159345 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159347 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159357 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159360 */     // GIR_Coverage, 18192,
     /* 2159360 */     GIR_EraseRootFromParent_Done,
     /* 2159361 */   // Label 28455: @2159361
     /* 2159361 */   GIM_Try, /*On fail goto*//*Label 28456*/ GIMT_Encode4(2159452), // Rule ID 18193 //
     /* 2159366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2159369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2159377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2159380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2159383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2159386 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2159389 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2159404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159408 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159412 */     // MIs[0] round
     /* 2159412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159415 */     // MIs[0] policy
     /* 2159415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159418 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159425 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11139:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M1_E32_MASK),
     /* 2159428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159432 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159434 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159436 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159438 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2159448 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159451 */     // GIR_Coverage, 18193,
     /* 2159451 */     GIR_EraseRootFromParent_Done,
     /* 2159452 */   // Label 28456: @2159452
     /* 2159452 */   GIM_Try, /*On fail goto*//*Label 28457*/ GIMT_Encode4(2159543), // Rule ID 18196 //
     /* 2159457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2159460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159480 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159495 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159499 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159503 */     // MIs[0] round
     /* 2159503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159506 */     // MIs[0] policy
     /* 2159506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159516 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2159519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159525 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159527 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159529 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159539 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159542 */     // GIR_Coverage, 18196,
     /* 2159542 */     GIR_EraseRootFromParent_Done,
     /* 2159543 */   // Label 28457: @2159543
     /* 2159543 */   GIM_Try, /*On fail goto*//*Label 28458*/ GIMT_Encode4(2159634), // Rule ID 18197 //
     /* 2159548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2159551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2159559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2159562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2159565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2159568 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2159571 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2159578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2159586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2159590 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159594 */     // MIs[0] round
     /* 2159594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159597 */     // MIs[0] policy
     /* 2159597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159600 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159607 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11139:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M1_E64_MASK),
     /* 2159610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159614 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159616 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159618 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159620 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2159630 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159633 */     // GIR_Coverage, 18197,
     /* 2159633 */     GIR_EraseRootFromParent_Done,
     /* 2159634 */   // Label 28458: @2159634
     /* 2159634 */   GIM_Try, /*On fail goto*//*Label 28459*/ GIMT_Encode4(2159725), // Rule ID 18200 //
     /* 2159639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2159650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2159653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2159659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159662 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159677 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159681 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159685 */     // MIs[0] round
     /* 2159685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159688 */     // MIs[0] policy
     /* 2159688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159698 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2159701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159707 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159709 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159711 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159721 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159724 */     // GIR_Coverage, 18200,
     /* 2159724 */     GIR_EraseRootFromParent_Done,
     /* 2159725 */   // Label 28459: @2159725
     /* 2159725 */   GIM_Try, /*On fail goto*//*Label 28460*/ GIMT_Encode4(2159816), // Rule ID 18201 //
     /* 2159730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2159741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2159744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2159750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2159753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2159760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2159772 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159776 */     // MIs[0] round
     /* 2159776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159779 */     // MIs[0] policy
     /* 2159779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159789 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M2_E16_MASK),
     /* 2159792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159796 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159798 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159800 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159802 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159812 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159815 */     // GIR_Coverage, 18201,
     /* 2159815 */     GIR_EraseRootFromParent_Done,
     /* 2159816 */   // Label 28460: @2159816
     /* 2159816 */   GIM_Try, /*On fail goto*//*Label 28461*/ GIMT_Encode4(2159907), // Rule ID 18204 //
     /* 2159821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2159824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2159832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2159841 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159844 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2159847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159859 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159863 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159867 */     // MIs[0] round
     /* 2159867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159870 */     // MIs[0] policy
     /* 2159870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159880 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2159880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2159883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159887 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159889 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159891 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159893 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159903 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159906 */     // GIR_Coverage, 18204,
     /* 2159906 */     GIR_EraseRootFromParent_Done,
     /* 2159907 */   // Label 28461: @2159907
     /* 2159907 */   GIM_Try, /*On fail goto*//*Label 28462*/ GIMT_Encode4(2159998), // Rule ID 18205 //
     /* 2159912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2159915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2159920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2159923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2159926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2159929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2159932 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2159935 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2159938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2159942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2159950 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2159954 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2159958 */     // MIs[0] round
     /* 2159958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2159961 */     // MIs[0] policy
     /* 2159961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2159964 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2159971 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2159971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M4_E16_MASK),
     /* 2159974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2159976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2159978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2159980 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2159982 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2159984 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2159986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2159991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2159994 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2159996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2159997 */     // GIR_Coverage, 18205,
     /* 2159997 */     GIR_EraseRootFromParent_Done,
     /* 2159998 */   // Label 28462: @2159998
     /* 2159998 */   GIM_Try, /*On fail goto*//*Label 28463*/ GIMT_Encode4(2160089), // Rule ID 18208 //
     /* 2160003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2160006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160023 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160049 */     // MIs[0] round
     /* 2160049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160052 */     // MIs[0] policy
     /* 2160052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160055 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160062 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2160065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160071 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160073 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160075 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160085 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160088 */     // GIR_Coverage, 18208,
     /* 2160088 */     GIR_EraseRootFromParent_Done,
     /* 2160089 */   // Label 28463: @2160089
     /* 2160089 */   GIM_Try, /*On fail goto*//*Label 28464*/ GIMT_Encode4(2160180), // Rule ID 18209 //
     /* 2160094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2160097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2160105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2160108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2160111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2160114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2160117 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2160132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160136 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160140 */     // MIs[0] round
     /* 2160140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160143 */     // MIs[0] policy
     /* 2160143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160146 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160153 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR16_M8_E16_MASK),
     /* 2160156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160160 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160162 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160164 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160166 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2160176 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160179 */     // GIR_Coverage, 18209,
     /* 2160179 */     GIR_EraseRootFromParent_Done,
     /* 2160180 */   // Label 28464: @2160180
     /* 2160180 */   GIM_Try, /*On fail goto*//*Label 28465*/ GIMT_Encode4(2160271), // Rule ID 18212 //
     /* 2160185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160205 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160208 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160227 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160231 */     // MIs[0] round
     /* 2160231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160234 */     // MIs[0] policy
     /* 2160234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160244 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2160247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160251 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160253 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160255 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160257 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160267 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160270 */     // GIR_Coverage, 18212,
     /* 2160270 */     GIR_EraseRootFromParent_Done,
     /* 2160271 */   // Label 28465: @2160271
     /* 2160271 */   GIM_Try, /*On fail goto*//*Label 28466*/ GIMT_Encode4(2160362), // Rule ID 18213 //
     /* 2160276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2160287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2160290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2160296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160299 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160318 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160322 */     // MIs[0] round
     /* 2160322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160325 */     // MIs[0] policy
     /* 2160325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160328 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160335 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M2_E32_MASK),
     /* 2160338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160340 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160342 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160344 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160346 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160348 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160358 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160361 */     // GIR_Coverage, 18213,
     /* 2160361 */     GIR_EraseRootFromParent_Done,
     /* 2160362 */   // Label 28466: @2160362
     /* 2160362 */   GIM_Try, /*On fail goto*//*Label 28467*/ GIMT_Encode4(2160453), // Rule ID 18216 //
     /* 2160367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160390 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160405 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160409 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160413 */     // MIs[0] round
     /* 2160413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160416 */     // MIs[0] policy
     /* 2160416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160419 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160426 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2160429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160433 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160435 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160437 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160439 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160449 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160452 */     // GIR_Coverage, 18216,
     /* 2160452 */     GIR_EraseRootFromParent_Done,
     /* 2160453 */   // Label 28467: @2160453
     /* 2160453 */   GIM_Try, /*On fail goto*//*Label 28468*/ GIMT_Encode4(2160544), // Rule ID 18217 //
     /* 2160458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2160469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2160472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2160478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2160481 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160496 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160500 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160504 */     // MIs[0] round
     /* 2160504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160507 */     // MIs[0] policy
     /* 2160507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160517 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M4_E32_MASK),
     /* 2160520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160526 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160528 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160530 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160540 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160543 */     // GIR_Coverage, 18217,
     /* 2160543 */     GIR_EraseRootFromParent_Done,
     /* 2160544 */   // Label 28468: @2160544
     /* 2160544 */   GIM_Try, /*On fail goto*//*Label 28469*/ GIMT_Encode4(2160635), // Rule ID 18220 //
     /* 2160549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2160552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160569 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160572 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160591 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160595 */     // MIs[0] round
     /* 2160595 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160598 */     // MIs[0] policy
     /* 2160598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160608 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2160611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160615 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160617 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160619 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160621 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160631 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160634 */     // GIR_Coverage, 18220,
     /* 2160634 */     GIR_EraseRootFromParent_Done,
     /* 2160635 */   // Label 28469: @2160635
     /* 2160635 */   GIM_Try, /*On fail goto*//*Label 28470*/ GIMT_Encode4(2160726), // Rule ID 18221 //
     /* 2160640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2160643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2160651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2160654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2160657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2160660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2160663 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2160670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2160678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2160682 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160686 */     // MIs[0] round
     /* 2160686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160689 */     // MIs[0] policy
     /* 2160689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160692 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160699 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR32_M8_E32_MASK),
     /* 2160702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160706 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160708 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160710 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160712 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2160722 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160725 */     // GIR_Coverage, 18221,
     /* 2160725 */     GIR_EraseRootFromParent_Done,
     /* 2160726 */   // Label 28470: @2160726
     /* 2160726 */   GIM_Try, /*On fail goto*//*Label 28471*/ GIMT_Encode4(2160817), // Rule ID 18224 //
     /* 2160731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2160734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2160742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2160745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2160751 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160754 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160773 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160777 */     // MIs[0] round
     /* 2160777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160780 */     // MIs[0] policy
     /* 2160780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160783 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160790 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2160793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160797 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160799 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160801 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160803 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160813 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160816 */     // GIR_Coverage, 18224,
     /* 2160816 */     GIR_EraseRootFromParent_Done,
     /* 2160817 */   // Label 28471: @2160817
     /* 2160817 */   GIM_Try, /*On fail goto*//*Label 28472*/ GIMT_Encode4(2160908), // Rule ID 18225 //
     /* 2160822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2160825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2160833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2160836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2160842 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2160845 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2160848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2160852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160860 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2160864 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160868 */     // MIs[0] round
     /* 2160868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160871 */     // MIs[0] policy
     /* 2160871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160881 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11139:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2160881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M2_E64_MASK),
     /* 2160884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160890 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160892 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160894 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160904 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160907 */     // GIR_Coverage, 18225,
     /* 2160907 */     GIR_EraseRootFromParent_Done,
     /* 2160908 */   // Label 28472: @2160908
     /* 2160908 */   GIM_Try, /*On fail goto*//*Label 28473*/ GIMT_Encode4(2160999), // Rule ID 18228 //
     /* 2160913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2160916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2160921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2160924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2160927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2160930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2160933 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2160936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2160939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2160943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2160951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2160955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2160959 */     // MIs[0] round
     /* 2160959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2160962 */     // MIs[0] policy
     /* 2160962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2160965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2160972 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2160972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2160975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2160977 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2160979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2160981 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2160983 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2160985 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2160987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2160992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2160995 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2160997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2160998 */     // GIR_Coverage, 18228,
     /* 2160998 */     GIR_EraseRootFromParent_Done,
     /* 2160999 */   // Label 28473: @2160999
     /* 2160999 */   GIM_Try, /*On fail goto*//*Label 28474*/ GIMT_Encode4(2161090), // Rule ID 18229 //
     /* 2161004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2161015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2161018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2161024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161027 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2161034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2161046 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161050 */     // MIs[0] round
     /* 2161050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161053 */     // MIs[0] policy
     /* 2161053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161063 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11139:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M4_E64_MASK),
     /* 2161066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161072 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161074 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161076 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161086 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161089 */     // GIR_Coverage, 18229,
     /* 2161089 */     GIR_EraseRootFromParent_Done,
     /* 2161090 */   // Label 28474: @2161090
     /* 2161090 */   GIM_Try, /*On fail goto*//*Label 28475*/ GIMT_Encode4(2161181), // Rule ID 18232 //
     /* 2161095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2161098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161118 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161137 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161141 */     // MIs[0] round
     /* 2161141 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161144 */     // MIs[0] policy
     /* 2161144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161147 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161154 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2161157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161161 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161163 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161165 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161167 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161177 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161180 */     // GIR_Coverage, 18232,
     /* 2161180 */     GIR_EraseRootFromParent_Done,
     /* 2161181 */   // Label 28475: @2161181
     /* 2161181 */   GIM_Try, /*On fail goto*//*Label 28476*/ GIMT_Encode4(2161272), // Rule ID 18233 //
     /* 2161186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2161189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmadd_mask),
     /* 2161194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2161197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2161200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2161203 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2161206 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2161209 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2161216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2161224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2161228 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161232 */     // MIs[0] round
     /* 2161232 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161235 */     // MIs[0] policy
     /* 2161235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161238 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161245 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11139:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VFPR64_M8_E64_MASK),
     /* 2161248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161250 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161254 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161256 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161258 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2161268 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161271 */     // GIR_Coverage, 18233,
     /* 2161271 */     GIR_EraseRootFromParent_Done,
     /* 2161272 */   // Label 28476: @2161272
     /* 2161272 */   GIM_Try, /*On fail goto*//*Label 28477*/ GIMT_Encode4(2161363), // Rule ID 18236 //
     /* 2161277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161297 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161300 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161319 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161323 */     // MIs[0] round
     /* 2161323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161326 */     // MIs[0] policy
     /* 2161326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161329 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161336 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2161339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161343 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161345 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161347 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161349 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161359 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161362 */     // GIR_Coverage, 18236,
     /* 2161362 */     GIR_EraseRootFromParent_Done,
     /* 2161363 */   // Label 28477: @2161363
     /* 2161363 */   GIM_Try, /*On fail goto*//*Label 28478*/ GIMT_Encode4(2161454), // Rule ID 18237 //
     /* 2161368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2161379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2161382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2161385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2161388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161391 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161410 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161414 */     // MIs[0] round
     /* 2161414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161417 */     // MIs[0] policy
     /* 2161417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161427 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16_MASK),
     /* 2161430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161432 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161434 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161436 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161438 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161440 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161450 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161453 */     // GIR_Coverage, 18237,
     /* 2161453 */     GIR_EraseRootFromParent_Done,
     /* 2161454 */   // Label 28478: @2161454
     /* 2161454 */   GIM_Try, /*On fail goto*//*Label 28479*/ GIMT_Encode4(2161545), // Rule ID 18240 //
     /* 2161459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161479 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161482 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161501 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161505 */     // MIs[0] round
     /* 2161505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161508 */     // MIs[0] policy
     /* 2161508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161511 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161518 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2161521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161525 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161527 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161529 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161531 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161541 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161544 */     // GIR_Coverage, 18240,
     /* 2161544 */     GIR_EraseRootFromParent_Done,
     /* 2161545 */   // Label 28479: @2161545
     /* 2161545 */   GIM_Try, /*On fail goto*//*Label 28480*/ GIMT_Encode4(2161636), // Rule ID 18241 //
     /* 2161550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2161561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2161564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2161567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2161570 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2161573 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161588 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161592 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161596 */     // MIs[0] round
     /* 2161596 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161599 */     // MIs[0] policy
     /* 2161599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161609 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16_MASK),
     /* 2161612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161616 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161618 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161620 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161622 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161632 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161635 */     // GIR_Coverage, 18241,
     /* 2161635 */     GIR_EraseRootFromParent_Done,
     /* 2161636 */   // Label 28480: @2161636
     /* 2161636 */   GIM_Try, /*On fail goto*//*Label 28481*/ GIMT_Encode4(2161727), // Rule ID 18244 //
     /* 2161641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2161644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2161652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2161655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2161658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2161661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161679 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161683 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161687 */     // MIs[0] round
     /* 2161687 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161690 */     // MIs[0] policy
     /* 2161690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161693 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161700 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2161703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161709 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161711 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161713 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161723 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161726 */     // GIR_Coverage, 18244,
     /* 2161726 */     GIR_EraseRootFromParent_Done,
     /* 2161727 */   // Label 28481: @2161727
     /* 2161727 */   GIM_Try, /*On fail goto*//*Label 28482*/ GIMT_Encode4(2161818), // Rule ID 18245 //
     /* 2161732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2161735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2161743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2161746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2161749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2161752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2161755 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161770 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161774 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161778 */     // MIs[0] round
     /* 2161778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161781 */     // MIs[0] policy
     /* 2161781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161784 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161791 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32_MASK),
     /* 2161794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161800 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161802 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161804 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161806 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2161814 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161817 */     // GIR_Coverage, 18245,
     /* 2161817 */     GIR_EraseRootFromParent_Done,
     /* 2161818 */   // Label 28482: @2161818
     /* 2161818 */   GIM_Try, /*On fail goto*//*Label 28483*/ GIMT_Encode4(2161909), // Rule ID 18248 //
     /* 2161823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2161826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2161834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2161837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2161840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2161843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2161849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161861 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161869 */     // MIs[0] round
     /* 2161869 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161872 */     // MIs[0] policy
     /* 2161872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161875 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161882 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2161882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2161885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161889 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161891 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161893 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161895 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161905 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161908 */     // GIR_Coverage, 18248,
     /* 2161908 */     GIR_EraseRootFromParent_Done,
     /* 2161909 */   // Label 28483: @2161909
     /* 2161909 */   GIM_Try, /*On fail goto*//*Label 28484*/ GIMT_Encode4(2162000), // Rule ID 18249 //
     /* 2161914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2161917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2161922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2161925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2161928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2161931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2161934 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2161937 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2161940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2161944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2161956 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2161960 */     // MIs[0] round
     /* 2161960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2161963 */     // MIs[0] policy
     /* 2161963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2161966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2161973 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2161973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16_MASK),
     /* 2161976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2161978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2161980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2161982 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2161984 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2161986 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2161988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2161993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2161996 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2161998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2161999 */     // GIR_Coverage, 18249,
     /* 2161999 */     GIR_EraseRootFromParent_Done,
     /* 2162000 */   // Label 28484: @2162000
     /* 2162000 */   GIM_Try, /*On fail goto*//*Label 28485*/ GIMT_Encode4(2162091), // Rule ID 18252 //
     /* 2162005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162025 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162028 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162043 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162047 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162051 */     // MIs[0] round
     /* 2162051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162054 */     // MIs[0] policy
     /* 2162054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162064 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2162067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162069 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162073 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162075 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162077 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162087 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162090 */     // GIR_Coverage, 18252,
     /* 2162090 */     GIR_EraseRootFromParent_Done,
     /* 2162091 */   // Label 28485: @2162091
     /* 2162091 */   GIM_Try, /*On fail goto*//*Label 28486*/ GIMT_Encode4(2162182), // Rule ID 18253 //
     /* 2162096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2162099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2162107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2162110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2162113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2162116 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2162119 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162138 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162142 */     // MIs[0] round
     /* 2162142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162145 */     // MIs[0] policy
     /* 2162145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162155 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32_MASK),
     /* 2162158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162164 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162166 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162168 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162178 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162181 */     // GIR_Coverage, 18253,
     /* 2162181 */     GIR_EraseRootFromParent_Done,
     /* 2162182 */   // Label 28486: @2162182
     /* 2162182 */   GIM_Try, /*On fail goto*//*Label 28487*/ GIMT_Encode4(2162273), // Rule ID 18256 //
     /* 2162187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2162190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162207 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162210 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162229 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162233 */     // MIs[0] round
     /* 2162233 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162236 */     // MIs[0] policy
     /* 2162236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162239 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162246 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2162249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162255 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162257 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162259 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162269 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162272 */     // GIR_Coverage, 18256,
     /* 2162272 */     GIR_EraseRootFromParent_Done,
     /* 2162273 */   // Label 28487: @2162273
     /* 2162273 */   GIM_Try, /*On fail goto*//*Label 28488*/ GIMT_Encode4(2162364), // Rule ID 18257 //
     /* 2162278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2162281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2162289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2162292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2162295 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2162298 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2162301 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2162308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162316 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2162320 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162324 */     // MIs[0] round
     /* 2162324 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162327 */     // MIs[0] policy
     /* 2162327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162330 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162337 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64_MASK),
     /* 2162340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162344 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162346 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162348 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162350 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2162360 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162363 */     // GIR_Coverage, 18257,
     /* 2162363 */     GIR_EraseRootFromParent_Done,
     /* 2162364 */   // Label 28488: @2162364
     /* 2162364 */   GIM_Try, /*On fail goto*//*Label 28489*/ GIMT_Encode4(2162455), // Rule ID 18260 //
     /* 2162369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162392 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162415 */     // MIs[0] round
     /* 2162415 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162418 */     // MIs[0] policy
     /* 2162418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2162431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162437 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162439 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162441 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162443 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162451 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162454 */     // GIR_Coverage, 18260,
     /* 2162454 */     GIR_EraseRootFromParent_Done,
     /* 2162455 */   // Label 28489: @2162455
     /* 2162455 */   GIM_Try, /*On fail goto*//*Label 28490*/ GIMT_Encode4(2162546), // Rule ID 18261 //
     /* 2162460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2162471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2162474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2162477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2162480 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2162483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162494 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162498 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162502 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162506 */     // MIs[0] round
     /* 2162506 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162509 */     // MIs[0] policy
     /* 2162509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162519 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16_MASK),
     /* 2162522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162526 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162528 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162530 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162532 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162542 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162545 */     // GIR_Coverage, 18261,
     /* 2162545 */     GIR_EraseRootFromParent_Done,
     /* 2162546 */   // Label 28490: @2162546
     /* 2162546 */   GIM_Try, /*On fail goto*//*Label 28491*/ GIMT_Encode4(2162637), // Rule ID 18264 //
     /* 2162551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162571 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162574 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162589 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162593 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162597 */     // MIs[0] round
     /* 2162597 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162600 */     // MIs[0] policy
     /* 2162600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162603 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162610 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2162613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162619 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162621 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162623 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162633 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162636 */     // GIR_Coverage, 18264,
     /* 2162636 */     GIR_EraseRootFromParent_Done,
     /* 2162637 */   // Label 28491: @2162637
     /* 2162637 */   GIM_Try, /*On fail goto*//*Label 28492*/ GIMT_Encode4(2162728), // Rule ID 18265 //
     /* 2162642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2162653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2162656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2162659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2162662 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2162665 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2162672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2162684 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162688 */     // MIs[0] round
     /* 2162688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162691 */     // MIs[0] policy
     /* 2162691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162694 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162701 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16_MASK),
     /* 2162704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162708 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162710 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162712 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162714 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162724 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162727 */     // GIR_Coverage, 18265,
     /* 2162727 */     GIR_EraseRootFromParent_Done,
     /* 2162728 */   // Label 28492: @2162728
     /* 2162728 */   GIM_Try, /*On fail goto*//*Label 28493*/ GIMT_Encode4(2162819), // Rule ID 18268 //
     /* 2162733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2162736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2162744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2162747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2162750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2162753 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2162756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162771 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162779 */     // MIs[0] round
     /* 2162779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162782 */     // MIs[0] policy
     /* 2162782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162785 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162792 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2162795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162801 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162803 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162805 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162815 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162818 */     // GIR_Coverage, 18268,
     /* 2162818 */     GIR_EraseRootFromParent_Done,
     /* 2162819 */   // Label 28493: @2162819
     /* 2162819 */   GIM_Try, /*On fail goto*//*Label 28494*/ GIMT_Encode4(2162910), // Rule ID 18269 //
     /* 2162824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2162827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2162835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2162838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2162841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2162844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2162847 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2162850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2162854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2162866 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162870 */     // MIs[0] round
     /* 2162870 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162873 */     // MIs[0] policy
     /* 2162873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162883 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2162883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16_MASK),
     /* 2162886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162892 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162894 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162896 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162898 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2162906 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2162909 */     // GIR_Coverage, 18269,
     /* 2162909 */     GIR_EraseRootFromParent_Done,
     /* 2162910 */   // Label 28494: @2162910
     /* 2162910 */   GIM_Try, /*On fail goto*//*Label 28495*/ GIMT_Encode4(2163001), // Rule ID 18272 //
     /* 2162915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2162918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2162923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2162926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2162929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2162932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2162935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2162938 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2162941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2162945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162953 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2162957 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2162961 */     // MIs[0] round
     /* 2162961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2162964 */     // MIs[0] policy
     /* 2162964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2162967 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2162974 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2162974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2162977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2162979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2162981 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2162983 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2162985 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2162987 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2162989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2162994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2162997 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2162999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163000 */     // GIR_Coverage, 18272,
     /* 2163000 */     GIR_EraseRootFromParent_Done,
     /* 2163001 */   // Label 28495: @2163001
     /* 2163001 */   GIM_Try, /*On fail goto*//*Label 28496*/ GIMT_Encode4(2163092), // Rule ID 18273 //
     /* 2163006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2163017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2163020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2163023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2163026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163029 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163044 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163048 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163052 */     // MIs[0] round
     /* 2163052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163055 */     // MIs[0] policy
     /* 2163055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32_MASK),
     /* 2163068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163072 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163074 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163076 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163078 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163088 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163091 */     // GIR_Coverage, 18273,
     /* 2163091 */     GIR_EraseRootFromParent_Done,
     /* 2163092 */   // Label 28496: @2163092
     /* 2163092 */   GIM_Try, /*On fail goto*//*Label 28497*/ GIMT_Encode4(2163183), // Rule ID 18276 //
     /* 2163097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163117 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163120 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163139 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163143 */     // MIs[0] round
     /* 2163143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163146 */     // MIs[0] policy
     /* 2163146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163156 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2163159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163165 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163167 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163169 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163179 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163182 */     // GIR_Coverage, 18276,
     /* 2163182 */     GIR_EraseRootFromParent_Done,
     /* 2163183 */   // Label 28497: @2163183
     /* 2163183 */   GIM_Try, /*On fail goto*//*Label 28498*/ GIMT_Encode4(2163274), // Rule ID 18277 //
     /* 2163188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2163199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2163202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2163205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2163208 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163211 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163226 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163230 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163234 */     // MIs[0] round
     /* 2163234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163237 */     // MIs[0] policy
     /* 2163237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163247 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32_MASK),
     /* 2163250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163254 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163256 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163258 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163260 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163270 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163273 */     // GIR_Coverage, 18277,
     /* 2163273 */     GIR_EraseRootFromParent_Done,
     /* 2163274 */   // Label 28498: @2163274
     /* 2163274 */   GIM_Try, /*On fail goto*//*Label 28499*/ GIMT_Encode4(2163365), // Rule ID 18280 //
     /* 2163279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2163282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163317 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163321 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163325 */     // MIs[0] round
     /* 2163325 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163328 */     // MIs[0] policy
     /* 2163328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163331 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163338 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2163341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163345 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163347 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163349 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163351 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163361 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163364 */     // GIR_Coverage, 18280,
     /* 2163364 */     GIR_EraseRootFromParent_Done,
     /* 2163365 */   // Label 28499: @2163365
     /* 2163365 */   GIM_Try, /*On fail goto*//*Label 28500*/ GIMT_Encode4(2163456), // Rule ID 18281 //
     /* 2163370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2163373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2163381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2163384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2163387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2163390 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2163393 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163412 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163416 */     // MIs[0] round
     /* 2163416 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163419 */     // MIs[0] policy
     /* 2163419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163422 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163429 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32_MASK),
     /* 2163432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163438 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163440 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163442 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2163452 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163455 */     // GIR_Coverage, 18281,
     /* 2163455 */     GIR_EraseRootFromParent_Done,
     /* 2163456 */   // Label 28500: @2163456
     /* 2163456 */   GIM_Try, /*On fail goto*//*Label 28501*/ GIMT_Encode4(2163547), // Rule ID 18284 //
     /* 2163461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163484 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163499 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163503 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163507 */     // MIs[0] round
     /* 2163507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163510 */     // MIs[0] policy
     /* 2163510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163513 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163520 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2163523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163529 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163531 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163533 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163543 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163546 */     // GIR_Coverage, 18284,
     /* 2163546 */     GIR_EraseRootFromParent_Done,
     /* 2163547 */   // Label 28501: @2163547
     /* 2163547 */   GIM_Try, /*On fail goto*//*Label 28502*/ GIMT_Encode4(2163638), // Rule ID 18285 //
     /* 2163552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2163563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2163566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2163569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2163572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2163575 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2163582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163586 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163590 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2163594 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163598 */     // MIs[0] round
     /* 2163598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163601 */     // MIs[0] policy
     /* 2163601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163611 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64_MASK),
     /* 2163614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163618 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163620 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163622 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163624 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163634 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163637 */     // GIR_Coverage, 18285,
     /* 2163637 */     GIR_EraseRootFromParent_Done,
     /* 2163638 */   // Label 28502: @2163638
     /* 2163638 */   GIM_Try, /*On fail goto*//*Label 28503*/ GIMT_Encode4(2163729), // Rule ID 18288 //
     /* 2163643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2163654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2163657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2163660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2163663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163689 */     // MIs[0] round
     /* 2163689 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163692 */     // MIs[0] policy
     /* 2163692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163702 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2163705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163709 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163711 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163713 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163715 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163725 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163728 */     // GIR_Coverage, 18288,
     /* 2163728 */     GIR_EraseRootFromParent_Done,
     /* 2163729 */   // Label 28503: @2163729
     /* 2163729 */   GIM_Try, /*On fail goto*//*Label 28504*/ GIMT_Encode4(2163820), // Rule ID 18289 //
     /* 2163734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2163745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2163748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2163751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2163754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2163757 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2163764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163772 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2163776 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163780 */     // MIs[0] round
     /* 2163780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163783 */     // MIs[0] policy
     /* 2163783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163793 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64_MASK),
     /* 2163796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163802 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163804 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163806 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163816 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163819 */     // GIR_Coverage, 18289,
     /* 2163819 */     GIR_EraseRootFromParent_Done,
     /* 2163820 */   // Label 28504: @2163820
     /* 2163820 */   GIM_Try, /*On fail goto*//*Label 28505*/ GIMT_Encode4(2163911), // Rule ID 18292 //
     /* 2163825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2163828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2163836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2163839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2163842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2163845 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163848 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2163851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163867 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163871 */     // MIs[0] round
     /* 2163871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163874 */     // MIs[0] policy
     /* 2163874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163877 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163884 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2163884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2163887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163891 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163893 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163895 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163897 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163907 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2163909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2163910 */     // GIR_Coverage, 18292,
     /* 2163910 */     GIR_EraseRootFromParent_Done,
     /* 2163911 */   // Label 28505: @2163911
     /* 2163911 */   GIM_Try, /*On fail goto*//*Label 28506*/ GIMT_Encode4(2164002), // Rule ID 18293 //
     /* 2163916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2163919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2163924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2163927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2163930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2163933 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2163936 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2163939 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2163942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2163946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2163958 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2163962 */     // MIs[0] round
     /* 2163962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2163965 */     // MIs[0] policy
     /* 2163965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2163968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2163975 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2163975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64_MASK),
     /* 2163978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2163980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2163982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2163984 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2163986 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2163988 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2163990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2163995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2163998 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164001 */     // GIR_Coverage, 18293,
     /* 2164001 */     GIR_EraseRootFromParent_Done,
     /* 2164002 */   // Label 28506: @2164002
     /* 2164002 */   GIM_Try, /*On fail goto*//*Label 28507*/ GIMT_Encode4(2164093), // Rule ID 18296 //
     /* 2164007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164030 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164045 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164049 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164053 */     // MIs[0] round
     /* 2164053 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164056 */     // MIs[0] policy
     /* 2164056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164066 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2164069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164075 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164077 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164079 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164089 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164092 */     // GIR_Coverage, 18296,
     /* 2164092 */     GIR_EraseRootFromParent_Done,
     /* 2164093 */   // Label 28507: @2164093
     /* 2164093 */   GIM_Try, /*On fail goto*//*Label 28508*/ GIMT_Encode4(2164184), // Rule ID 18297 //
     /* 2164098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2164109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2164112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2164118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164121 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164140 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164144 */     // MIs[0] round
     /* 2164144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164147 */     // MIs[0] policy
     /* 2164147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164157 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF4_E16_MASK),
     /* 2164160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164164 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164166 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164168 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164170 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164180 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164183 */     // GIR_Coverage, 18297,
     /* 2164183 */     GIR_EraseRootFromParent_Done,
     /* 2164184 */   // Label 28508: @2164184
     /* 2164184 */   GIM_Try, /*On fail goto*//*Label 28509*/ GIMT_Encode4(2164275), // Rule ID 18300 //
     /* 2164189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164212 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164231 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164235 */     // MIs[0] round
     /* 2164235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164238 */     // MIs[0] policy
     /* 2164238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164248 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2164251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164257 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164259 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164261 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164271 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164274 */     // GIR_Coverage, 18300,
     /* 2164274 */     GIR_EraseRootFromParent_Done,
     /* 2164275 */   // Label 28509: @2164275
     /* 2164275 */   GIM_Try, /*On fail goto*//*Label 28510*/ GIMT_Encode4(2164366), // Rule ID 18301 //
     /* 2164280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2164291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2164294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2164300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164303 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164318 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164322 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164326 */     // MIs[0] round
     /* 2164326 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164329 */     // MIs[0] policy
     /* 2164329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164339 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_MF2_E16_MASK),
     /* 2164342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164348 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164350 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164352 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164362 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164365 */     // GIR_Coverage, 18301,
     /* 2164365 */     GIR_EraseRootFromParent_Done,
     /* 2164366 */   // Label 28510: @2164366
     /* 2164366 */   GIM_Try, /*On fail goto*//*Label 28511*/ GIMT_Encode4(2164457), // Rule ID 18304 //
     /* 2164371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164391 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164394 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164409 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164413 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164417 */     // MIs[0] round
     /* 2164417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164420 */     // MIs[0] policy
     /* 2164420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164430 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2164433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164437 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164439 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164441 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164443 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164453 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164456 */     // GIR_Coverage, 18304,
     /* 2164456 */     GIR_EraseRootFromParent_Done,
     /* 2164457 */   // Label 28511: @2164457
     /* 2164457 */   GIM_Try, /*On fail goto*//*Label 28512*/ GIMT_Encode4(2164548), // Rule ID 18305 //
     /* 2164462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2164473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2164476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2164482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164485 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164504 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164508 */     // MIs[0] round
     /* 2164508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164511 */     // MIs[0] policy
     /* 2164511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164514 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164521 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_MF2_E32_MASK),
     /* 2164524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164530 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164532 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164534 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164544 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164546 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164547 */     // GIR_Coverage, 18305,
     /* 2164547 */     GIR_EraseRootFromParent_Done,
     /* 2164548 */   // Label 28512: @2164548
     /* 2164548 */   GIM_Try, /*On fail goto*//*Label 28513*/ GIMT_Encode4(2164639), // Rule ID 18308 //
     /* 2164553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2164556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164576 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164591 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164595 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164599 */     // MIs[0] round
     /* 2164599 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164602 */     // MIs[0] policy
     /* 2164602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164612 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2164615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164619 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164621 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164623 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164625 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164635 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164638 */     // GIR_Coverage, 18308,
     /* 2164638 */     GIR_EraseRootFromParent_Done,
     /* 2164639 */   // Label 28513: @2164639
     /* 2164639 */   GIM_Try, /*On fail goto*//*Label 28514*/ GIMT_Encode4(2164730), // Rule ID 18309 //
     /* 2164644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2164647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2164655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2164658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2164661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2164664 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2164667 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2164682 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164686 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164690 */     // MIs[0] round
     /* 2164690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164693 */     // MIs[0] policy
     /* 2164693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164703 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11175:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M1_E16_MASK),
     /* 2164706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164708 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164710 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164712 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164714 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164716 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2164726 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164729 */     // GIR_Coverage, 18309,
     /* 2164729 */     GIR_EraseRootFromParent_Done,
     /* 2164730 */   // Label 28514: @2164730
     /* 2164730 */   GIM_Try, /*On fail goto*//*Label 28515*/ GIMT_Encode4(2164821), // Rule ID 18312 //
     /* 2164735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2164738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2164746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2164749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2164755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164758 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164777 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164781 */     // MIs[0] round
     /* 2164781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164784 */     // MIs[0] policy
     /* 2164784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164794 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2164797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164801 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164803 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164805 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164807 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164817 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164820 */     // GIR_Coverage, 18312,
     /* 2164820 */     GIR_EraseRootFromParent_Done,
     /* 2164821 */   // Label 28515: @2164821
     /* 2164821 */   GIM_Try, /*On fail goto*//*Label 28516*/ GIMT_Encode4(2164912), // Rule ID 18313 //
     /* 2164826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2164829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2164837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2164840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2164843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2164846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2164849 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2164852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2164864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164868 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164872 */     // MIs[0] round
     /* 2164872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164875 */     // MIs[0] policy
     /* 2164875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164885 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11175:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2164885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M1_E32_MASK),
     /* 2164888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164894 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164896 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164898 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2164908 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2164910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2164911 */     // GIR_Coverage, 18313,
     /* 2164911 */     GIR_EraseRootFromParent_Done,
     /* 2164912 */   // Label 28516: @2164912
     /* 2164912 */   GIM_Try, /*On fail goto*//*Label 28517*/ GIMT_Encode4(2165003), // Rule ID 18316 //
     /* 2164917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2164920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2164925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2164928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2164931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2164934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2164937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2164940 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2164943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2164947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2164955 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2164959 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2164963 */     // MIs[0] round
     /* 2164963 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2164966 */     // MIs[0] policy
     /* 2164966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2164969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2164976 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2164976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2164979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2164981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2164983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2164985 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2164987 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2164989 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2164991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2164996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2164999 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165002 */     // GIR_Coverage, 18316,
     /* 2165002 */     GIR_EraseRootFromParent_Done,
     /* 2165003 */   // Label 28517: @2165003
     /* 2165003 */   GIM_Try, /*On fail goto*//*Label 28518*/ GIMT_Encode4(2165094), // Rule ID 18317 //
     /* 2165008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2165011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2165019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2165022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2165025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2165028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2165031 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2165038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2165046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2165050 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165054 */     // MIs[0] round
     /* 2165054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165057 */     // MIs[0] policy
     /* 2165057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165067 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11175:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M1_E64_MASK),
     /* 2165070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165076 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165078 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165080 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2165090 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165093 */     // GIR_Coverage, 18317,
     /* 2165093 */     GIR_EraseRootFromParent_Done,
     /* 2165094 */   // Label 28518: @2165094
     /* 2165094 */   GIM_Try, /*On fail goto*//*Label 28519*/ GIMT_Encode4(2165185), // Rule ID 18320 //
     /* 2165099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165122 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165141 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165145 */     // MIs[0] round
     /* 2165145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165148 */     // MIs[0] policy
     /* 2165148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165151 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165158 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2165161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165165 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165167 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165169 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165171 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165181 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165184 */     // GIR_Coverage, 18320,
     /* 2165184 */     GIR_EraseRootFromParent_Done,
     /* 2165185 */   // Label 28519: @2165185
     /* 2165185 */   GIM_Try, /*On fail goto*//*Label 28520*/ GIMT_Encode4(2165276), // Rule ID 18321 //
     /* 2165190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2165201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2165204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2165210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165213 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165232 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165236 */     // MIs[0] round
     /* 2165236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165239 */     // MIs[0] policy
     /* 2165239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165249 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M2_E16_MASK),
     /* 2165252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165256 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165258 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165260 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165262 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165272 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165275 */     // GIR_Coverage, 18321,
     /* 2165275 */     GIR_EraseRootFromParent_Done,
     /* 2165276 */   // Label 28520: @2165276
     /* 2165276 */   GIM_Try, /*On fail goto*//*Label 28521*/ GIMT_Encode4(2165367), // Rule ID 18324 //
     /* 2165281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165301 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165304 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165319 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165323 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165327 */     // MIs[0] round
     /* 2165327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165330 */     // MIs[0] policy
     /* 2165330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165340 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2165343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165347 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165349 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165351 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165353 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165363 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165365 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165366 */     // GIR_Coverage, 18324,
     /* 2165366 */     GIR_EraseRootFromParent_Done,
     /* 2165367 */   // Label 28521: @2165367
     /* 2165367 */   GIM_Try, /*On fail goto*//*Label 28522*/ GIMT_Encode4(2165458), // Rule ID 18325 //
     /* 2165372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2165383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2165386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2165392 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2165395 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165410 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165414 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165418 */     // MIs[0] round
     /* 2165418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165421 */     // MIs[0] policy
     /* 2165421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165431 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M4_E16_MASK),
     /* 2165434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165438 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165440 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165442 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165444 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165454 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165457 */     // GIR_Coverage, 18325,
     /* 2165457 */     GIR_EraseRootFromParent_Done,
     /* 2165458 */   // Label 28522: @2165458
     /* 2165458 */   GIM_Try, /*On fail goto*//*Label 28523*/ GIMT_Encode4(2165549), // Rule ID 18328 //
     /* 2165463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2165466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165483 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165486 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165505 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165509 */     // MIs[0] round
     /* 2165509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165512 */     // MIs[0] policy
     /* 2165512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165515 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165522 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2165525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165529 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165531 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165533 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165535 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165545 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165548 */     // GIR_Coverage, 18328,
     /* 2165548 */     GIR_EraseRootFromParent_Done,
     /* 2165549 */   // Label 28523: @2165549
     /* 2165549 */   GIM_Try, /*On fail goto*//*Label 28524*/ GIMT_Encode4(2165640), // Rule ID 18329 //
     /* 2165554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2165557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2165565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2165568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2165571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2165574 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2165577 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2165584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2165592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2165596 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165600 */     // MIs[0] round
     /* 2165600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165603 */     // MIs[0] policy
     /* 2165603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165606 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165613 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR16_M8_E16_MASK),
     /* 2165616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165622 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165624 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165626 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2165636 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165639 */     // GIR_Coverage, 18329,
     /* 2165639 */     GIR_EraseRootFromParent_Done,
     /* 2165640 */   // Label 28524: @2165640
     /* 2165640 */   GIM_Try, /*On fail goto*//*Label 28525*/ GIMT_Encode4(2165731), // Rule ID 18332 //
     /* 2165645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2165656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2165659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2165665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165668 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165683 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165687 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165691 */     // MIs[0] round
     /* 2165691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165694 */     // MIs[0] policy
     /* 2165694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165704 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2165707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165713 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165715 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165717 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165727 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165730 */     // GIR_Coverage, 18332,
     /* 2165730 */     GIR_EraseRootFromParent_Done,
     /* 2165731 */   // Label 28525: @2165731
     /* 2165731 */   GIM_Try, /*On fail goto*//*Label 28526*/ GIMT_Encode4(2165822), // Rule ID 18333 //
     /* 2165736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2165747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2165750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2165756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2165759 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2165766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2165778 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165782 */     // MIs[0] round
     /* 2165782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165785 */     // MIs[0] policy
     /* 2165785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165795 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M2_E32_MASK),
     /* 2165798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165802 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165804 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165806 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165808 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165818 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165821 */     // GIR_Coverage, 18333,
     /* 2165821 */     GIR_EraseRootFromParent_Done,
     /* 2165822 */   // Label 28526: @2165822
     /* 2165822 */   GIM_Try, /*On fail goto*//*Label 28527*/ GIMT_Encode4(2165913), // Rule ID 18336 //
     /* 2165827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2165830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2165838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2165841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2165847 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165850 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2165853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165865 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165869 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165873 */     // MIs[0] round
     /* 2165873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165876 */     // MIs[0] policy
     /* 2165876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165886 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2165886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2165889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165895 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165897 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165899 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165901 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2165909 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2165912 */     // GIR_Coverage, 18336,
     /* 2165912 */     GIR_EraseRootFromParent_Done,
     /* 2165913 */   // Label 28527: @2165913
     /* 2165913 */   GIM_Try, /*On fail goto*//*Label 28528*/ GIMT_Encode4(2166004), // Rule ID 18337 //
     /* 2165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2165921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2165926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2165929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2165932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2165935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2165938 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2165941 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2165944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2165948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2165956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2165960 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2165964 */     // MIs[0] round
     /* 2165964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2165967 */     // MIs[0] policy
     /* 2165967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2165970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2165977 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2165977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M4_E32_MASK),
     /* 2165980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2165982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2165984 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2165986 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2165988 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2165990 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2165992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2165997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166000 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166003 */     // GIR_Coverage, 18337,
     /* 2166003 */     GIR_EraseRootFromParent_Done,
     /* 2166004 */   // Label 28528: @2166004
     /* 2166004 */   GIM_Try, /*On fail goto*//*Label 28529*/ GIMT_Encode4(2166095), // Rule ID 18340 //
     /* 2166009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2166012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166029 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166032 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166051 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166055 */     // MIs[0] round
     /* 2166055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166058 */     // MIs[0] policy
     /* 2166058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166061 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166068 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2166071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166077 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166079 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166081 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166091 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166094 */     // GIR_Coverage, 18340,
     /* 2166094 */     GIR_EraseRootFromParent_Done,
     /* 2166095 */   // Label 28529: @2166095
     /* 2166095 */   GIM_Try, /*On fail goto*//*Label 28530*/ GIMT_Encode4(2166186), // Rule ID 18341 //
     /* 2166100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2166103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2166111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2166114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2166117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2166120 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2166123 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2166138 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166142 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166146 */     // MIs[0] round
     /* 2166146 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166149 */     // MIs[0] policy
     /* 2166149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166159 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR32_M8_E32_MASK),
     /* 2166162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166168 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166170 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166172 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166174 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2166182 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166184 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166185 */     // GIR_Coverage, 18341,
     /* 2166185 */     GIR_EraseRootFromParent_Done,
     /* 2166186 */   // Label 28530: @2166186
     /* 2166186 */   GIM_Try, /*On fail goto*//*Label 28531*/ GIMT_Encode4(2166277), // Rule ID 18344 //
     /* 2166191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166214 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166229 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166233 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166237 */     // MIs[0] round
     /* 2166237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166240 */     // MIs[0] policy
     /* 2166240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2166253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166259 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166261 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166263 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166273 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166276 */     // GIR_Coverage, 18344,
     /* 2166276 */     GIR_EraseRootFromParent_Done,
     /* 2166277 */   // Label 28531: @2166277
     /* 2166277 */   GIM_Try, /*On fail goto*//*Label 28532*/ GIMT_Encode4(2166368), // Rule ID 18345 //
     /* 2166282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2166293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2166296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2166302 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166305 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2166312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166320 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2166324 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166328 */     // MIs[0] round
     /* 2166328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166331 */     // MIs[0] policy
     /* 2166331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166341 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11175:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M2_E64_MASK),
     /* 2166344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166350 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166352 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166354 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166364 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166367 */     // GIR_Coverage, 18345,
     /* 2166367 */     GIR_EraseRootFromParent_Done,
     /* 2166368 */   // Label 28532: @2166368
     /* 2166368 */   GIM_Try, /*On fail goto*//*Label 28533*/ GIMT_Encode4(2166459), // Rule ID 18348 //
     /* 2166373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166396 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166411 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166415 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166419 */     // MIs[0] round
     /* 2166419 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166422 */     // MIs[0] policy
     /* 2166422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166425 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166432 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2166435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166441 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166443 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166445 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166455 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166458 */     // GIR_Coverage, 18348,
     /* 2166458 */     GIR_EraseRootFromParent_Done,
     /* 2166459 */   // Label 28533: @2166459
     /* 2166459 */   GIM_Try, /*On fail goto*//*Label 28534*/ GIMT_Encode4(2166550), // Rule ID 18349 //
     /* 2166464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2166475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2166478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2166484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2166487 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2166494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166502 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2166506 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166510 */     // MIs[0] round
     /* 2166510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166513 */     // MIs[0] policy
     /* 2166513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166516 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166523 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11175:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M4_E64_MASK),
     /* 2166526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166530 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166532 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166534 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166536 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166546 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166549 */     // GIR_Coverage, 18349,
     /* 2166549 */     GIR_EraseRootFromParent_Done,
     /* 2166550 */   // Label 28534: @2166550
     /* 2166550 */   GIM_Try, /*On fail goto*//*Label 28535*/ GIMT_Encode4(2166641), // Rule ID 18352 //
     /* 2166555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2166558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166597 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166601 */     // MIs[0] round
     /* 2166601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166604 */     // MIs[0] policy
     /* 2166604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166607 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166614 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2166617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166621 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166623 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166625 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166627 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166637 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166640 */     // GIR_Coverage, 18352,
     /* 2166640 */     GIR_EraseRootFromParent_Done,
     /* 2166641 */   // Label 28535: @2166641
     /* 2166641 */   GIM_Try, /*On fail goto*//*Label 28536*/ GIMT_Encode4(2166732), // Rule ID 18353 //
     /* 2166646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2166649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmadd_mask),
     /* 2166654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2166657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2166660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2166663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2166666 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2166669 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2166676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2166684 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2166688 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166692 */     // MIs[0] round
     /* 2166692 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166695 */     // MIs[0] policy
     /* 2166695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166705 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11175:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMADD_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VFPR64_M8_E64_MASK),
     /* 2166708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166712 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166714 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166716 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166718 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2166728 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166731 */     // GIR_Coverage, 18353,
     /* 2166731 */     GIR_EraseRootFromParent_Done,
     /* 2166732 */   // Label 28536: @2166732
     /* 2166732 */   GIM_Try, /*On fail goto*//*Label 28537*/ GIMT_Encode4(2166823), // Rule ID 18356 //
     /* 2166737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2166745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2166748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2166751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2166754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2166757 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166760 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166779 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166783 */     // MIs[0] round
     /* 2166783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166786 */     // MIs[0] policy
     /* 2166786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166789 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166796 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2166799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166805 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166807 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166809 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166819 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166822 */     // GIR_Coverage, 18356,
     /* 2166822 */     GIR_EraseRootFromParent_Done,
     /* 2166823 */   // Label 28537: @2166823
     /* 2166823 */   GIM_Try, /*On fail goto*//*Label 28538*/ GIMT_Encode4(2166914), // Rule ID 18357 //
     /* 2166828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2166831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2166836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2166839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2166842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2166845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2166848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2166851 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2166854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166866 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166870 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166874 */     // MIs[0] round
     /* 2166874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166877 */     // MIs[0] policy
     /* 2166877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166880 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166887 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2166887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16_MASK),
     /* 2166890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166892 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166894 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166896 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166898 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166900 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2166910 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2166912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2166913 */     // GIR_Coverage, 18357,
     /* 2166913 */     GIR_EraseRootFromParent_Done,
     /* 2166914 */   // Label 28538: @2166914
     /* 2166914 */   GIM_Try, /*On fail goto*//*Label 28539*/ GIMT_Encode4(2167005), // Rule ID 18360 //
     /* 2166919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2166922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2166927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2166930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2166933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2166936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2166939 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2166942 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2166945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2166949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166957 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2166961 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2166965 */     // MIs[0] round
     /* 2166965 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2166968 */     // MIs[0] policy
     /* 2166968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2166971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2166978 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2166978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2166981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2166983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2166985 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2166987 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2166989 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2166991 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2166993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2166998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167001 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167004 */     // GIR_Coverage, 18360,
     /* 2167004 */     GIR_EraseRootFromParent_Done,
     /* 2167005 */   // Label 28539: @2167005
     /* 2167005 */   GIM_Try, /*On fail goto*//*Label 28540*/ GIMT_Encode4(2167096), // Rule ID 18361 //
     /* 2167010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2167021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2167024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2167027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2167030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167033 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167048 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167052 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167056 */     // MIs[0] round
     /* 2167056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167059 */     // MIs[0] policy
     /* 2167059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167069 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16_MASK),
     /* 2167072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167076 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167078 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167080 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167082 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167092 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167095 */     // GIR_Coverage, 18361,
     /* 2167095 */     GIR_EraseRootFromParent_Done,
     /* 2167096 */   // Label 28540: @2167096
     /* 2167096 */   GIM_Try, /*On fail goto*//*Label 28541*/ GIMT_Encode4(2167187), // Rule ID 18364 //
     /* 2167101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167124 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167143 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167147 */     // MIs[0] round
     /* 2167147 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167150 */     // MIs[0] policy
     /* 2167150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167160 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2167163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167167 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167169 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167171 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167173 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167183 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167186 */     // GIR_Coverage, 18364,
     /* 2167186 */     GIR_EraseRootFromParent_Done,
     /* 2167187 */   // Label 28541: @2167187
     /* 2167187 */   GIM_Try, /*On fail goto*//*Label 28542*/ GIMT_Encode4(2167278), // Rule ID 18365 //
     /* 2167192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2167203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2167206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2167209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2167212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167215 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167234 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167238 */     // MIs[0] round
     /* 2167238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167241 */     // MIs[0] policy
     /* 2167241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167251 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32_MASK),
     /* 2167254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167260 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167262 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167264 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167274 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167277 */     // GIR_Coverage, 18365,
     /* 2167277 */     GIR_EraseRootFromParent_Done,
     /* 2167278 */   // Label 28542: @2167278
     /* 2167278 */   GIM_Try, /*On fail goto*//*Label 28543*/ GIMT_Encode4(2167369), // Rule ID 18368 //
     /* 2167283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167321 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167325 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167329 */     // MIs[0] round
     /* 2167329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167332 */     // MIs[0] policy
     /* 2167332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167335 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167342 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2167345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167351 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167353 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167355 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167365 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167368 */     // GIR_Coverage, 18368,
     /* 2167368 */     GIR_EraseRootFromParent_Done,
     /* 2167369 */   // Label 28543: @2167369
     /* 2167369 */   GIM_Try, /*On fail goto*//*Label 28544*/ GIMT_Encode4(2167460), // Rule ID 18369 //
     /* 2167374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2167385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2167388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2167391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2167394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2167397 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167416 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167420 */     // MIs[0] round
     /* 2167420 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167423 */     // MIs[0] policy
     /* 2167423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167433 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16_MASK),
     /* 2167436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167438 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167440 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167442 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167444 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167446 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167448 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167456 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167459 */     // GIR_Coverage, 18369,
     /* 2167459 */     GIR_EraseRootFromParent_Done,
     /* 2167460 */   // Label 28544: @2167460
     /* 2167460 */   GIM_Try, /*On fail goto*//*Label 28545*/ GIMT_Encode4(2167551), // Rule ID 18372 //
     /* 2167465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2167468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167485 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167488 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167507 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167511 */     // MIs[0] round
     /* 2167511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167514 */     // MIs[0] policy
     /* 2167514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167524 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2167527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167531 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167533 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167535 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167537 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167547 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167550 */     // GIR_Coverage, 18372,
     /* 2167550 */     GIR_EraseRootFromParent_Done,
     /* 2167551 */   // Label 28545: @2167551
     /* 2167551 */   GIM_Try, /*On fail goto*//*Label 28546*/ GIMT_Encode4(2167642), // Rule ID 18373 //
     /* 2167556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2167559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2167567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2167570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2167573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2167576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2167579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167598 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167602 */     // MIs[0] round
     /* 2167602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167605 */     // MIs[0] policy
     /* 2167605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167615 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32_MASK),
     /* 2167618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167624 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167626 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167628 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2167638 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167641 */     // GIR_Coverage, 18373,
     /* 2167641 */     GIR_EraseRootFromParent_Done,
     /* 2167642 */   // Label 28546: @2167642
     /* 2167642 */   GIM_Try, /*On fail goto*//*Label 28547*/ GIMT_Encode4(2167733), // Rule ID 18376 //
     /* 2167647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2167650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2167658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2167661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2167664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2167667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167670 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167685 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167689 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167693 */     // MIs[0] round
     /* 2167693 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167696 */     // MIs[0] policy
     /* 2167696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167706 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2167709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167713 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167715 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167717 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167719 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167729 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167732 */     // GIR_Coverage, 18376,
     /* 2167732 */     GIR_EraseRootFromParent_Done,
     /* 2167733 */   // Label 28547: @2167733
     /* 2167733 */   GIM_Try, /*On fail goto*//*Label 28548*/ GIMT_Encode4(2167824), // Rule ID 18377 //
     /* 2167738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2167741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2167749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2167752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2167755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2167758 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2167761 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2167768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167776 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2167780 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167784 */     // MIs[0] round
     /* 2167784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167787 */     // MIs[0] policy
     /* 2167787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167797 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64_MASK),
     /* 2167800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167806 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167808 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167810 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167812 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2167820 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167823 */     // GIR_Coverage, 18377,
     /* 2167823 */     GIR_EraseRootFromParent_Done,
     /* 2167824 */   // Label 28548: @2167824
     /* 2167824 */   GIM_Try, /*On fail goto*//*Label 28549*/ GIMT_Encode4(2167915), // Rule ID 18380 //
     /* 2167829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2167832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2167840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2167843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2167846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2167849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167852 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2167855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167871 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167875 */     // MIs[0] round
     /* 2167875 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167878 */     // MIs[0] policy
     /* 2167878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167881 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167888 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2167888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2167891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167897 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167899 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167901 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167903 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2167911 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2167913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2167914 */     // GIR_Coverage, 18380,
     /* 2167914 */     GIR_EraseRootFromParent_Done,
     /* 2167915 */   // Label 28549: @2167915
     /* 2167915 */   GIM_Try, /*On fail goto*//*Label 28550*/ GIMT_Encode4(2168006), // Rule ID 18381 //
     /* 2167920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2167923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2167928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2167931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2167934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2167937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2167940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2167943 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2167946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2167950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167958 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2167962 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2167966 */     // MIs[0] round
     /* 2167966 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2167969 */     // MIs[0] policy
     /* 2167969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2167972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2167979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2167979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16_MASK),
     /* 2167982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2167984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2167986 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2167988 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2167990 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2167992 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2167994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2167999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168002 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168005 */     // GIR_Coverage, 18381,
     /* 2168005 */     GIR_EraseRootFromParent_Done,
     /* 2168006 */   // Label 28550: @2168006
     /* 2168006 */   GIM_Try, /*On fail goto*//*Label 28551*/ GIMT_Encode4(2168097), // Rule ID 18384 //
     /* 2168011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168034 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168049 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168053 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168057 */     // MIs[0] round
     /* 2168057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168060 */     // MIs[0] policy
     /* 2168060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168063 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168070 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2168073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168075 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168079 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168081 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168083 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168093 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168096 */     // GIR_Coverage, 18384,
     /* 2168096 */     GIR_EraseRootFromParent_Done,
     /* 2168097 */   // Label 28551: @2168097
     /* 2168097 */   GIM_Try, /*On fail goto*//*Label 28552*/ GIMT_Encode4(2168188), // Rule ID 18385 //
     /* 2168102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2168113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2168116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2168119 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2168122 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168136 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168144 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168148 */     // MIs[0] round
     /* 2168148 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168151 */     // MIs[0] policy
     /* 2168151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168154 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168161 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16_MASK),
     /* 2168164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168168 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168170 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168172 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168174 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168184 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168187 */     // GIR_Coverage, 18385,
     /* 2168187 */     GIR_EraseRootFromParent_Done,
     /* 2168188 */   // Label 28552: @2168188
     /* 2168188 */   GIM_Try, /*On fail goto*//*Label 28553*/ GIMT_Encode4(2168279), // Rule ID 18388 //
     /* 2168193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2168196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168216 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168235 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168239 */     // MIs[0] round
     /* 2168239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168242 */     // MIs[0] policy
     /* 2168242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168252 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2168255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168261 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168263 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168265 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168275 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168278 */     // GIR_Coverage, 18388,
     /* 2168278 */     GIR_EraseRootFromParent_Done,
     /* 2168279 */   // Label 28553: @2168279
     /* 2168279 */   GIM_Try, /*On fail goto*//*Label 28554*/ GIMT_Encode4(2168370), // Rule ID 18389 //
     /* 2168284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2168287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2168295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2168298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2168301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2168304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2168307 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168326 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168330 */     // MIs[0] round
     /* 2168330 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168333 */     // MIs[0] policy
     /* 2168333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168336 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168343 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16_MASK),
     /* 2168346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168352 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168354 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168356 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2168366 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168369 */     // GIR_Coverage, 18389,
     /* 2168369 */     GIR_EraseRootFromParent_Done,
     /* 2168370 */   // Label 28554: @2168370
     /* 2168370 */   GIM_Try, /*On fail goto*//*Label 28555*/ GIMT_Encode4(2168461), // Rule ID 18392 //
     /* 2168375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168395 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168398 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168417 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168421 */     // MIs[0] round
     /* 2168421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168424 */     // MIs[0] policy
     /* 2168424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2168437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168443 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168445 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168447 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168457 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168460 */     // GIR_Coverage, 18392,
     /* 2168460 */     GIR_EraseRootFromParent_Done,
     /* 2168461 */   // Label 28555: @2168461
     /* 2168461 */   GIM_Try, /*On fail goto*//*Label 28556*/ GIMT_Encode4(2168552), // Rule ID 18393 //
     /* 2168466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2168477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2168480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2168483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2168486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2168489 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168504 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168508 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168512 */     // MIs[0] round
     /* 2168512 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168515 */     // MIs[0] policy
     /* 2168515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168525 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32_MASK),
     /* 2168528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168532 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168534 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168536 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168538 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168548 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168551 */     // GIR_Coverage, 18393,
     /* 2168551 */     GIR_EraseRootFromParent_Done,
     /* 2168552 */   // Label 28556: @2168552
     /* 2168552 */   GIM_Try, /*On fail goto*//*Label 28557*/ GIMT_Encode4(2168643), // Rule ID 18396 //
     /* 2168557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168577 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168580 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168595 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168599 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168603 */     // MIs[0] round
     /* 2168603 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168606 */     // MIs[0] policy
     /* 2168606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168616 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2168619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168623 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168625 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168627 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168629 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168639 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168641 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168642 */     // GIR_Coverage, 18396,
     /* 2168642 */     GIR_EraseRootFromParent_Done,
     /* 2168643 */   // Label 28557: @2168643
     /* 2168643 */   GIM_Try, /*On fail goto*//*Label 28558*/ GIMT_Encode4(2168734), // Rule ID 18397 //
     /* 2168648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2168659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2168662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2168665 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2168668 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2168671 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2168678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2168690 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168694 */     // MIs[0] round
     /* 2168694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168697 */     // MIs[0] policy
     /* 2168697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168707 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32_MASK),
     /* 2168710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168714 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168716 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168718 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168720 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168730 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168733 */     // GIR_Coverage, 18397,
     /* 2168733 */     GIR_EraseRootFromParent_Done,
     /* 2168734 */   // Label 28558: @2168734
     /* 2168734 */   GIM_Try, /*On fail goto*//*Label 28559*/ GIMT_Encode4(2168825), // Rule ID 18400 //
     /* 2168739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2168742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2168750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2168753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2168756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2168759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168762 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168777 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168781 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168785 */     // MIs[0] round
     /* 2168785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168788 */     // MIs[0] policy
     /* 2168788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168791 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168798 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2168801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168807 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168809 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168811 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168821 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168824 */     // GIR_Coverage, 18400,
     /* 2168824 */     GIR_EraseRootFromParent_Done,
     /* 2168825 */   // Label 28559: @2168825
     /* 2168825 */   GIM_Try, /*On fail goto*//*Label 28560*/ GIMT_Encode4(2168916), // Rule ID 18401 //
     /* 2168830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2168833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2168841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2168844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2168847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2168850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2168853 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2168856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2168860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168864 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168868 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2168872 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168876 */     // MIs[0] round
     /* 2168876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168879 */     // MIs[0] policy
     /* 2168879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168882 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168889 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2168889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32_MASK),
     /* 2168892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168894 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168896 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168898 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168900 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168902 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2168909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2168912 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2168914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2168915 */     // GIR_Coverage, 18401,
     /* 2168915 */     GIR_EraseRootFromParent_Done,
     /* 2168916 */   // Label 28560: @2168916
     /* 2168916 */   GIM_Try, /*On fail goto*//*Label 28561*/ GIMT_Encode4(2169007), // Rule ID 18404 //
     /* 2168921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2168924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2168929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2168932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2168935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2168938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2168941 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2168944 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2168947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2168951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168955 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168959 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2168963 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2168967 */     // MIs[0] round
     /* 2168967 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2168970 */     // MIs[0] policy
     /* 2168970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2168973 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2168980 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2168980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2168983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2168985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2168987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2168989 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2168991 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2168993 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2168995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169003 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169006 */     // GIR_Coverage, 18404,
     /* 2169006 */     GIR_EraseRootFromParent_Done,
     /* 2169007 */   // Label 28561: @2169007
     /* 2169007 */   GIM_Try, /*On fail goto*//*Label 28562*/ GIMT_Encode4(2169098), // Rule ID 18405 //
     /* 2169012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2169023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2169026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2169029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2169032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169035 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2169042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2169054 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169058 */     // MIs[0] round
     /* 2169058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169061 */     // MIs[0] policy
     /* 2169061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169064 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169071 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64_MASK),
     /* 2169074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169080 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169082 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169084 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169094 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169097 */     // GIR_Coverage, 18405,
     /* 2169097 */     GIR_EraseRootFromParent_Done,
     /* 2169098 */   // Label 28562: @2169098
     /* 2169098 */   GIM_Try, /*On fail goto*//*Label 28563*/ GIMT_Encode4(2169189), // Rule ID 18408 //
     /* 2169103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169123 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169126 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169145 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169149 */     // MIs[0] round
     /* 2169149 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169152 */     // MIs[0] policy
     /* 2169152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169155 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169162 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2169165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169171 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169173 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169175 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169185 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169188 */     // GIR_Coverage, 18408,
     /* 2169188 */     GIR_EraseRootFromParent_Done,
     /* 2169189 */   // Label 28563: @2169189
     /* 2169189 */   GIM_Try, /*On fail goto*//*Label 28564*/ GIMT_Encode4(2169280), // Rule ID 18409 //
     /* 2169194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2169205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2169208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2169211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2169214 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2169217 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2169224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169232 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2169236 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169240 */     // MIs[0] round
     /* 2169240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169243 */     // MIs[0] policy
     /* 2169243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169253 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64_MASK),
     /* 2169256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169258 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169260 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169262 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169264 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169266 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169276 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169279 */     // GIR_Coverage, 18409,
     /* 2169279 */     GIR_EraseRootFromParent_Done,
     /* 2169280 */   // Label 28564: @2169280
     /* 2169280 */   GIM_Try, /*On fail goto*//*Label 28565*/ GIMT_Encode4(2169371), // Rule ID 18412 //
     /* 2169285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2169288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169305 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169308 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169327 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169331 */     // MIs[0] round
     /* 2169331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169334 */     // MIs[0] policy
     /* 2169334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169337 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169344 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2169347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169351 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169353 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169355 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169357 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169367 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169370 */     // GIR_Coverage, 18412,
     /* 2169370 */     GIR_EraseRootFromParent_Done,
     /* 2169371 */   // Label 28565: @2169371
     /* 2169371 */   GIM_Try, /*On fail goto*//*Label 28566*/ GIMT_Encode4(2169462), // Rule ID 18413 //
     /* 2169376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2169379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2169387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2169390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2169393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2169396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2169399 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2169406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2169418 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169422 */     // MIs[0] round
     /* 2169422 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169425 */     // MIs[0] policy
     /* 2169425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169435 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64_MASK),
     /* 2169438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169444 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169446 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169448 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2169458 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169461 */     // GIR_Coverage, 18413,
     /* 2169461 */     GIR_EraseRootFromParent_Done,
     /* 2169462 */   // Label 28566: @2169462
     /* 2169462 */   GIM_Try, /*On fail goto*//*Label 28567*/ GIMT_Encode4(2169553), // Rule ID 18416 //
     /* 2169467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169487 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169513 */     // MIs[0] round
     /* 2169513 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169516 */     // MIs[0] policy
     /* 2169516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169519 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169526 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2169529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169535 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169537 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169539 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169549 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169552 */     // GIR_Coverage, 18416,
     /* 2169552 */     GIR_EraseRootFromParent_Done,
     /* 2169553 */   // Label 28567: @2169553
     /* 2169553 */   GIM_Try, /*On fail goto*//*Label 28568*/ GIMT_Encode4(2169644), // Rule ID 18417 //
     /* 2169558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2169569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2169572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2169578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169581 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169596 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169600 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169604 */     // MIs[0] round
     /* 2169604 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169607 */     // MIs[0] policy
     /* 2169607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169617 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF4_E16_MASK),
     /* 2169620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169626 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169628 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169630 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169640 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169643 */     // GIR_Coverage, 18417,
     /* 2169643 */     GIR_EraseRootFromParent_Done,
     /* 2169644 */   // Label 28568: @2169644
     /* 2169644 */   GIM_Try, /*On fail goto*//*Label 28569*/ GIMT_Encode4(2169735), // Rule ID 18420 //
     /* 2169649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2169652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2169660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2169663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2169669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169672 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169687 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169691 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169695 */     // MIs[0] round
     /* 2169695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169698 */     // MIs[0] policy
     /* 2169698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169708 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2169711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169715 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169717 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169719 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169721 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169723 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169731 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169734 */     // GIR_Coverage, 18420,
     /* 2169734 */     GIR_EraseRootFromParent_Done,
     /* 2169735 */   // Label 28569: @2169735
     /* 2169735 */   GIM_Try, /*On fail goto*//*Label 28570*/ GIMT_Encode4(2169826), // Rule ID 18421 //
     /* 2169740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2169743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2169751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2169754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2169757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2169760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2169763 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2169778 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169782 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169786 */     // MIs[0] round
     /* 2169786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169789 */     // MIs[0] policy
     /* 2169789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169799 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_MF2_E16_MASK),
     /* 2169802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169806 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169808 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169810 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169812 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2169822 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169825 */     // GIR_Coverage, 18421,
     /* 2169825 */     GIR_EraseRootFromParent_Done,
     /* 2169826 */   // Label 28570: @2169826
     /* 2169826 */   GIM_Try, /*On fail goto*//*Label 28571*/ GIMT_Encode4(2169917), // Rule ID 18424 //
     /* 2169831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2169834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2169842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2169845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2169851 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169854 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2169857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169873 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169877 */     // MIs[0] round
     /* 2169877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169880 */     // MIs[0] policy
     /* 2169880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169883 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169890 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2169890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2169893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169895 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169899 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169901 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169903 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2169910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2169913 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2169915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2169916 */     // GIR_Coverage, 18424,
     /* 2169916 */     GIR_EraseRootFromParent_Done,
     /* 2169917 */   // Label 28571: @2169917
     /* 2169917 */   GIM_Try, /*On fail goto*//*Label 28572*/ GIMT_Encode4(2170008), // Rule ID 18425 //
     /* 2169922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2169925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2169930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2169933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2169936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2169939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2169942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2169945 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2169948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2169952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2169960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2169964 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2169968 */     // MIs[0] round
     /* 2169968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2169971 */     // MIs[0] policy
     /* 2169971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2169974 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2169981 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2169981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_MF2_E32_MASK),
     /* 2169984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2169986 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2169988 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2169990 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2169992 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2169994 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2169996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170004 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170007 */     // GIR_Coverage, 18425,
     /* 2170007 */     GIR_EraseRootFromParent_Done,
     /* 2170008 */   // Label 28572: @2170008
     /* 2170008 */   GIM_Try, /*On fail goto*//*Label 28573*/ GIMT_Encode4(2170099), // Rule ID 18428 //
     /* 2170013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170036 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170051 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170055 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170059 */     // MIs[0] round
     /* 2170059 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170062 */     // MIs[0] policy
     /* 2170062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170072 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2170075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170079 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170081 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170083 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170085 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170095 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170098 */     // GIR_Coverage, 18428,
     /* 2170098 */     GIR_EraseRootFromParent_Done,
     /* 2170099 */   // Label 28573: @2170099
     /* 2170099 */   GIM_Try, /*On fail goto*//*Label 28574*/ GIMT_Encode4(2170190), // Rule ID 18429 //
     /* 2170104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2170115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2170118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2170124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2170127 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170146 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170150 */     // MIs[0] round
     /* 2170150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170153 */     // MIs[0] policy
     /* 2170153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170163 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11148:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M1_E16_MASK),
     /* 2170166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170170 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170172 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170174 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170176 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170186 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170189 */     // GIR_Coverage, 18429,
     /* 2170189 */     GIR_EraseRootFromParent_Done,
     /* 2170190 */   // Label 28574: @2170190
     /* 2170190 */   GIM_Try, /*On fail goto*//*Label 28575*/ GIMT_Encode4(2170281), // Rule ID 18432 //
     /* 2170195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2170198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170218 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170233 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170237 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170241 */     // MIs[0] round
     /* 2170241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170244 */     // MIs[0] policy
     /* 2170244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170254 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2170257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170263 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170265 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170267 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170277 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170280 */     // GIR_Coverage, 18432,
     /* 2170280 */     GIR_EraseRootFromParent_Done,
     /* 2170281 */   // Label 28575: @2170281
     /* 2170281 */   GIM_Try, /*On fail goto*//*Label 28576*/ GIMT_Encode4(2170372), // Rule ID 18433 //
     /* 2170286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2170289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2170297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2170300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2170303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2170306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2170309 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2170324 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170328 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170332 */     // MIs[0] round
     /* 2170332 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170335 */     // MIs[0] policy
     /* 2170335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170345 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11148:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M1_E32_MASK),
     /* 2170348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170352 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170354 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170356 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170358 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2170368 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170371 */     // GIR_Coverage, 18433,
     /* 2170371 */     GIR_EraseRootFromParent_Done,
     /* 2170372 */   // Label 28576: @2170372
     /* 2170372 */   GIM_Try, /*On fail goto*//*Label 28577*/ GIMT_Encode4(2170463), // Rule ID 18436 //
     /* 2170377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2170380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170400 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170423 */     // MIs[0] round
     /* 2170423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170426 */     // MIs[0] policy
     /* 2170426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170436 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2170439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170445 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170447 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170449 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170459 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170462 */     // GIR_Coverage, 18436,
     /* 2170462 */     GIR_EraseRootFromParent_Done,
     /* 2170463 */   // Label 28577: @2170463
     /* 2170463 */   GIM_Try, /*On fail goto*//*Label 28578*/ GIMT_Encode4(2170554), // Rule ID 18437 //
     /* 2170468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2170471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2170479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2170482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2170485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2170488 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2170491 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2170498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2170506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2170510 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170514 */     // MIs[0] round
     /* 2170514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170517 */     // MIs[0] policy
     /* 2170517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170520 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170527 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11148:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M1_E64_MASK),
     /* 2170530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170536 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170538 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170540 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170542 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2170550 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170553 */     // GIR_Coverage, 18437,
     /* 2170553 */     GIR_EraseRootFromParent_Done,
     /* 2170554 */   // Label 28578: @2170554
     /* 2170554 */   GIM_Try, /*On fail goto*//*Label 28579*/ GIMT_Encode4(2170645), // Rule ID 18440 //
     /* 2170559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170576 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170579 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170582 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170601 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170605 */     // MIs[0] round
     /* 2170605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170608 */     // MIs[0] policy
     /* 2170608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170611 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170618 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2170621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170627 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170629 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170631 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170641 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170644 */     // GIR_Coverage, 18440,
     /* 2170644 */     GIR_EraseRootFromParent_Done,
     /* 2170645 */   // Label 28579: @2170645
     /* 2170645 */   GIM_Try, /*On fail goto*//*Label 28580*/ GIMT_Encode4(2170736), // Rule ID 18441 //
     /* 2170650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2170661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2170664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2170670 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2170673 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2170680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170688 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2170692 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170696 */     // MIs[0] round
     /* 2170696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170699 */     // MIs[0] policy
     /* 2170699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170702 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170709 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M2_E16_MASK),
     /* 2170712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170714 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170716 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170718 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170720 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170722 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170732 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170735 */     // GIR_Coverage, 18441,
     /* 2170735 */     GIR_EraseRootFromParent_Done,
     /* 2170736 */   // Label 28580: @2170736
     /* 2170736 */   GIM_Try, /*On fail goto*//*Label 28581*/ GIMT_Encode4(2170827), // Rule ID 18444 //
     /* 2170741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2170752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2170755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2170761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170764 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170783 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170787 */     // MIs[0] round
     /* 2170787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170790 */     // MIs[0] policy
     /* 2170790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170793 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170800 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2170803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170807 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170809 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170811 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170813 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170823 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170826 */     // GIR_Coverage, 18444,
     /* 2170826 */     GIR_EraseRootFromParent_Done,
     /* 2170827 */   // Label 28581: @2170827
     /* 2170827 */   GIM_Try, /*On fail goto*//*Label 28582*/ GIMT_Encode4(2170918), // Rule ID 18445 //
     /* 2170832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2170835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2170843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2170846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2170852 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2170855 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2170858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2170862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2170874 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170878 */     // MIs[0] round
     /* 2170878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170881 */     // MIs[0] policy
     /* 2170881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170884 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170891 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2170891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M4_E16_MASK),
     /* 2170894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170898 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170900 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170902 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170904 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170906 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2170911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2170914 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2170916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2170917 */     // GIR_Coverage, 18445,
     /* 2170917 */     GIR_EraseRootFromParent_Done,
     /* 2170918 */   // Label 28582: @2170918
     /* 2170918 */   GIM_Try, /*On fail goto*//*Label 28583*/ GIMT_Encode4(2171009), // Rule ID 18448 //
     /* 2170923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2170926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2170931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2170934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2170937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2170940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2170943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2170946 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2170949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2170953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2170961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2170965 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2170969 */     // MIs[0] round
     /* 2170969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2170972 */     // MIs[0] policy
     /* 2170972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2170975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2170982 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2170982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2170985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2170987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2170989 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2170991 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2170993 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2170995 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2170997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171005 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171007 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171008 */     // GIR_Coverage, 18448,
     /* 2171008 */     GIR_EraseRootFromParent_Done,
     /* 2171009 */   // Label 28583: @2171009
     /* 2171009 */   GIM_Try, /*On fail goto*//*Label 28584*/ GIMT_Encode4(2171100), // Rule ID 18449 //
     /* 2171014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2171017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2171025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2171028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2171031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2171034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2171037 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2171052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171060 */     // MIs[0] round
     /* 2171060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171063 */     // MIs[0] policy
     /* 2171063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171073 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR16_M8_E16_MASK),
     /* 2171076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171082 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171084 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171086 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2171096 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171099 */     // GIR_Coverage, 18449,
     /* 2171099 */     GIR_EraseRootFromParent_Done,
     /* 2171100 */   // Label 28584: @2171100
     /* 2171100 */   GIM_Try, /*On fail goto*//*Label 28585*/ GIMT_Encode4(2171191), // Rule ID 18452 //
     /* 2171105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171125 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171128 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171143 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171147 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171151 */     // MIs[0] round
     /* 2171151 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171154 */     // MIs[0] policy
     /* 2171154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171164 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2171167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171171 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171173 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171175 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171177 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171179 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171187 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171190 */     // GIR_Coverage, 18452,
     /* 2171190 */     GIR_EraseRootFromParent_Done,
     /* 2171191 */   // Label 28585: @2171191
     /* 2171191 */   GIM_Try, /*On fail goto*//*Label 28586*/ GIMT_Encode4(2171282), // Rule ID 18453 //
     /* 2171196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2171207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2171210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2171216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171219 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171238 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171242 */     // MIs[0] round
     /* 2171242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171245 */     // MIs[0] policy
     /* 2171245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171255 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M2_E32_MASK),
     /* 2171258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171264 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171266 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171268 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171278 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171281 */     // GIR_Coverage, 18453,
     /* 2171281 */     GIR_EraseRootFromParent_Done,
     /* 2171282 */   // Label 28586: @2171282
     /* 2171282 */   GIM_Try, /*On fail goto*//*Label 28587*/ GIMT_Encode4(2171373), // Rule ID 18456 //
     /* 2171287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171307 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171310 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171329 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171333 */     // MIs[0] round
     /* 2171333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171336 */     // MIs[0] policy
     /* 2171336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171346 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2171349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171355 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171357 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171359 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171369 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171372 */     // GIR_Coverage, 18456,
     /* 2171372 */     GIR_EraseRootFromParent_Done,
     /* 2171373 */   // Label 28587: @2171373
     /* 2171373 */   GIM_Try, /*On fail goto*//*Label 28588*/ GIMT_Encode4(2171464), // Rule ID 18457 //
     /* 2171378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2171389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2171392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171395 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2171398 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2171401 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171416 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171420 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171424 */     // MIs[0] round
     /* 2171424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171427 */     // MIs[0] policy
     /* 2171427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171430 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171437 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M4_E32_MASK),
     /* 2171440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171444 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171446 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171448 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171450 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171460 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171463 */     // GIR_Coverage, 18457,
     /* 2171463 */     GIR_EraseRootFromParent_Done,
     /* 2171464 */   // Label 28588: @2171464
     /* 2171464 */   GIM_Try, /*On fail goto*//*Label 28589*/ GIMT_Encode4(2171555), // Rule ID 18460 //
     /* 2171469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2171472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171489 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171511 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171515 */     // MIs[0] round
     /* 2171515 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171518 */     // MIs[0] policy
     /* 2171518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171521 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171528 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2171531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171535 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171537 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171539 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171541 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171551 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171554 */     // GIR_Coverage, 18460,
     /* 2171554 */     GIR_EraseRootFromParent_Done,
     /* 2171555 */   // Label 28589: @2171555
     /* 2171555 */   GIM_Try, /*On fail goto*//*Label 28590*/ GIMT_Encode4(2171646), // Rule ID 18461 //
     /* 2171560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2171563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2171571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2171574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2171577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2171580 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2171583 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2171590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2171598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2171602 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171606 */     // MIs[0] round
     /* 2171606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171609 */     // MIs[0] policy
     /* 2171609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171619 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR32_M8_E32_MASK),
     /* 2171622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171628 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171630 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171632 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2171642 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171644 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171645 */     // GIR_Coverage, 18461,
     /* 2171645 */     GIR_EraseRootFromParent_Done,
     /* 2171646 */   // Label 28590: @2171646
     /* 2171646 */   GIM_Try, /*On fail goto*//*Label 28591*/ GIMT_Encode4(2171737), // Rule ID 18464 //
     /* 2171651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171654 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171659 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2171662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2171665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2171671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171674 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171689 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171693 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171697 */     // MIs[0] round
     /* 2171697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171700 */     // MIs[0] policy
     /* 2171700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171703 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171710 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2171713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171717 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171719 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171721 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171723 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171733 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171736 */     // GIR_Coverage, 18464,
     /* 2171736 */     GIR_EraseRootFromParent_Done,
     /* 2171737 */   // Label 28591: @2171737
     /* 2171737 */   GIM_Try, /*On fail goto*//*Label 28592*/ GIMT_Encode4(2171828), // Rule ID 18465 //
     /* 2171742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2171753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2171756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2171762 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2171765 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2171772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2171784 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171788 */     // MIs[0] round
     /* 2171788 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171791 */     // MIs[0] policy
     /* 2171791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171794 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171801 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11148:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M2_E64_MASK),
     /* 2171804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171808 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171810 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171812 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171814 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171824 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171827 */     // GIR_Coverage, 18465,
     /* 2171827 */     GIR_EraseRootFromParent_Done,
     /* 2171828 */   // Label 28592: @2171828
     /* 2171828 */   GIM_Try, /*On fail goto*//*Label 28593*/ GIMT_Encode4(2171919), // Rule ID 18468 //
     /* 2171833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2171836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2171844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2171847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2171853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171856 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2171859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171871 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171875 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171879 */     // MIs[0] round
     /* 2171879 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171882 */     // MIs[0] policy
     /* 2171882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171885 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171892 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2171892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2171895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171899 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171901 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171903 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171905 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2171912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2171915 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2171917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2171918 */     // GIR_Coverage, 18468,
     /* 2171918 */     GIR_EraseRootFromParent_Done,
     /* 2171919 */   // Label 28593: @2171919
     /* 2171919 */   GIM_Try, /*On fail goto*//*Label 28594*/ GIMT_Encode4(2172010), // Rule ID 18469 //
     /* 2171924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2171927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2171932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2171935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2171938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2171941 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2171944 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2171947 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2171954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2171962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2171966 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2171970 */     // MIs[0] round
     /* 2171970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2171973 */     // MIs[0] policy
     /* 2171973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2171976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2171983 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11148:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2171983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M4_E64_MASK),
     /* 2171986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2171988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2171990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2171992 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2171994 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2171996 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2171998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172006 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172009 */     // GIR_Coverage, 18469,
     /* 2172009 */     GIR_EraseRootFromParent_Done,
     /* 2172010 */   // Label 28594: @2172010
     /* 2172010 */   GIM_Try, /*On fail goto*//*Label 28595*/ GIMT_Encode4(2172101), // Rule ID 18472 //
     /* 2172015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2172018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172035 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172038 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172057 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172061 */     // MIs[0] round
     /* 2172061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172064 */     // MIs[0] policy
     /* 2172064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172074 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2172077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172083 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172085 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172087 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172097 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172100 */     // GIR_Coverage, 18472,
     /* 2172100 */     GIR_EraseRootFromParent_Done,
     /* 2172101 */   // Label 28595: @2172101
     /* 2172101 */   GIM_Try, /*On fail goto*//*Label 28596*/ GIMT_Encode4(2172192), // Rule ID 18473 //
     /* 2172106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2172109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfmsub_mask),
     /* 2172114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2172117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2172120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2172123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2172126 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2172129 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2172136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2172144 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2172148 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172152 */     // MIs[0] round
     /* 2172152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172155 */     // MIs[0] policy
     /* 2172155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172158 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172165 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11148:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VFPR64_M8_E64_MASK),
     /* 2172168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172172 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172174 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172176 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172178 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2172188 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172190 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172191 */     // GIR_Coverage, 18473,
     /* 2172191 */     GIR_EraseRootFromParent_Done,
     /* 2172192 */   // Label 28596: @2172192
     /* 2172192 */   GIM_Try, /*On fail goto*//*Label 28597*/ GIMT_Encode4(2172283), // Rule ID 18476 //
     /* 2172197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172220 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172239 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172243 */     // MIs[0] round
     /* 2172243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172246 */     // MIs[0] policy
     /* 2172246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172249 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172256 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2172259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172263 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172265 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172267 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172269 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172279 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172282 */     // GIR_Coverage, 18476,
     /* 2172282 */     GIR_EraseRootFromParent_Done,
     /* 2172283 */   // Label 28597: @2172283
     /* 2172283 */   GIM_Try, /*On fail goto*//*Label 28598*/ GIMT_Encode4(2172374), // Rule ID 18477 //
     /* 2172288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2172299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2172302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2172305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2172308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172311 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172326 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172330 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172334 */     // MIs[0] round
     /* 2172334 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172337 */     // MIs[0] policy
     /* 2172337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172347 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16_MASK),
     /* 2172350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172356 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172358 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172360 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172370 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172373 */     // GIR_Coverage, 18477,
     /* 2172373 */     GIR_EraseRootFromParent_Done,
     /* 2172374 */   // Label 28598: @2172374
     /* 2172374 */   GIM_Try, /*On fail goto*//*Label 28599*/ GIMT_Encode4(2172465), // Rule ID 18480 //
     /* 2172379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172417 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172421 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172425 */     // MIs[0] round
     /* 2172425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172428 */     // MIs[0] policy
     /* 2172428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172431 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172438 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2172441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172447 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172449 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172451 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172461 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172464 */     // GIR_Coverage, 18480,
     /* 2172464 */     GIR_EraseRootFromParent_Done,
     /* 2172465 */   // Label 28599: @2172465
     /* 2172465 */   GIM_Try, /*On fail goto*//*Label 28600*/ GIMT_Encode4(2172556), // Rule ID 18481 //
     /* 2172470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2172481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2172484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2172487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2172490 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172493 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172508 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172512 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172516 */     // MIs[0] round
     /* 2172516 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172519 */     // MIs[0] policy
     /* 2172519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172522 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172529 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16_MASK),
     /* 2172532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172536 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172538 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172540 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172542 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172552 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172555 */     // GIR_Coverage, 18481,
     /* 2172555 */     GIR_EraseRootFromParent_Done,
     /* 2172556 */   // Label 28600: @2172556
     /* 2172556 */   GIM_Try, /*On fail goto*//*Label 28601*/ GIMT_Encode4(2172647), // Rule ID 18484 //
     /* 2172561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172581 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172584 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172603 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172607 */     // MIs[0] round
     /* 2172607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172610 */     // MIs[0] policy
     /* 2172610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172613 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172620 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2172623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172627 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172629 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172631 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172633 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172643 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172646 */     // GIR_Coverage, 18484,
     /* 2172646 */     GIR_EraseRootFromParent_Done,
     /* 2172647 */   // Label 28601: @2172647
     /* 2172647 */   GIM_Try, /*On fail goto*//*Label 28602*/ GIMT_Encode4(2172738), // Rule ID 18485 //
     /* 2172652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2172655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2172663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2172666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2172669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2172672 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2172675 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172694 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172698 */     // MIs[0] round
     /* 2172698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172701 */     // MIs[0] policy
     /* 2172701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172704 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172711 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32_MASK),
     /* 2172714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172718 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172720 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172722 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172724 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2172734 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172737 */     // GIR_Coverage, 18485,
     /* 2172737 */     GIR_EraseRootFromParent_Done,
     /* 2172738 */   // Label 28602: @2172738
     /* 2172738 */   GIM_Try, /*On fail goto*//*Label 28603*/ GIMT_Encode4(2172829), // Rule ID 18488 //
     /* 2172743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2172746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2172754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2172757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2172760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2172763 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172766 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172785 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172789 */     // MIs[0] round
     /* 2172789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172792 */     // MIs[0] policy
     /* 2172792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172802 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2172805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172809 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172811 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172813 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172815 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172825 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172828 */     // GIR_Coverage, 18488,
     /* 2172828 */     GIR_EraseRootFromParent_Done,
     /* 2172829 */   // Label 28603: @2172829
     /* 2172829 */   GIM_Try, /*On fail goto*//*Label 28604*/ GIMT_Encode4(2172920), // Rule ID 18489 //
     /* 2172834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2172837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2172845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2172848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2172851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2172854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2172857 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2172860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172876 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172880 */     // MIs[0] round
     /* 2172880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172883 */     // MIs[0] policy
     /* 2172883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172886 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172893 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2172893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16_MASK),
     /* 2172896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172898 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172900 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172902 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172904 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172906 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2172913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2172916 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2172918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2172919 */     // GIR_Coverage, 18489,
     /* 2172919 */     GIR_EraseRootFromParent_Done,
     /* 2172920 */   // Label 28604: @2172920
     /* 2172920 */   GIM_Try, /*On fail goto*//*Label 28605*/ GIMT_Encode4(2173011), // Rule ID 18492 //
     /* 2172925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2172928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2172933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2172936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2172939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2172942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2172945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2172948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2172951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2172955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172963 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2172967 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2172971 */     // MIs[0] round
     /* 2172971 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2172974 */     // MIs[0] policy
     /* 2172974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2172977 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2172984 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2172984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2172987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2172989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2172991 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2172993 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2172995 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2172997 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2172999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173007 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173010 */     // GIR_Coverage, 18492,
     /* 2173010 */     GIR_EraseRootFromParent_Done,
     /* 2173011 */   // Label 28605: @2173011
     /* 2173011 */   GIM_Try, /*On fail goto*//*Label 28606*/ GIMT_Encode4(2173102), // Rule ID 18493 //
     /* 2173016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2173027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2173030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2173033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2173036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2173039 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173058 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173062 */     // MIs[0] round
     /* 2173062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173065 */     // MIs[0] policy
     /* 2173065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173075 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32_MASK),
     /* 2173078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173082 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173084 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173086 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173088 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173098 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173101 */     // GIR_Coverage, 18493,
     /* 2173101 */     GIR_EraseRootFromParent_Done,
     /* 2173102 */   // Label 28606: @2173102
     /* 2173102 */   GIM_Try, /*On fail goto*//*Label 28607*/ GIMT_Encode4(2173193), // Rule ID 18496 //
     /* 2173107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2173110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173127 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173130 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173145 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173149 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173153 */     // MIs[0] round
     /* 2173153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173156 */     // MIs[0] policy
     /* 2173156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173166 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2173169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173173 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173175 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173177 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173179 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173189 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173192 */     // GIR_Coverage, 18496,
     /* 2173192 */     GIR_EraseRootFromParent_Done,
     /* 2173193 */   // Label 28607: @2173193
     /* 2173193 */   GIM_Try, /*On fail goto*//*Label 28608*/ GIMT_Encode4(2173284), // Rule ID 18497 //
     /* 2173198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2173201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2173209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2173212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2173215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2173218 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2173221 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2173228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2173240 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173244 */     // MIs[0] round
     /* 2173244 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173247 */     // MIs[0] policy
     /* 2173247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173250 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173257 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64_MASK),
     /* 2173260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173266 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173268 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173270 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2173280 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173283 */     // GIR_Coverage, 18497,
     /* 2173283 */     GIR_EraseRootFromParent_Done,
     /* 2173284 */   // Label 28608: @2173284
     /* 2173284 */   GIM_Try, /*On fail goto*//*Label 28609*/ GIMT_Encode4(2173375), // Rule ID 18500 //
     /* 2173289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173306 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173309 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173312 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173327 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173331 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173335 */     // MIs[0] round
     /* 2173335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173338 */     // MIs[0] policy
     /* 2173338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173348 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2173351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173357 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173359 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173361 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173371 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173374 */     // GIR_Coverage, 18500,
     /* 2173374 */     GIR_EraseRootFromParent_Done,
     /* 2173375 */   // Label 28609: @2173375
     /* 2173375 */   GIM_Try, /*On fail goto*//*Label 28610*/ GIMT_Encode4(2173466), // Rule ID 18501 //
     /* 2173380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2173391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2173394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2173397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2173400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2173403 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173418 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173422 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173426 */     // MIs[0] round
     /* 2173426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173429 */     // MIs[0] policy
     /* 2173429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173439 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16_MASK),
     /* 2173442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173448 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173450 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173452 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173462 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173465 */     // GIR_Coverage, 18501,
     /* 2173465 */     GIR_EraseRootFromParent_Done,
     /* 2173466 */   // Label 28610: @2173466
     /* 2173466 */   GIM_Try, /*On fail goto*//*Label 28611*/ GIMT_Encode4(2173557), // Rule ID 18504 //
     /* 2173471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173494 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173509 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173513 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173517 */     // MIs[0] round
     /* 2173517 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173520 */     // MIs[0] policy
     /* 2173520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173523 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173530 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2173533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173535 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173537 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173539 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173541 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173543 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173553 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173556 */     // GIR_Coverage, 18504,
     /* 2173556 */     GIR_EraseRootFromParent_Done,
     /* 2173557 */   // Label 28611: @2173557
     /* 2173557 */   GIM_Try, /*On fail goto*//*Label 28612*/ GIMT_Encode4(2173648), // Rule ID 18505 //
     /* 2173562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2173573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2173576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2173579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2173582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2173585 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2173592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173600 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2173604 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173608 */     // MIs[0] round
     /* 2173608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173611 */     // MIs[0] policy
     /* 2173611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173621 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16_MASK),
     /* 2173624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173630 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173632 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173634 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173644 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173647 */     // GIR_Coverage, 18505,
     /* 2173647 */     GIR_EraseRootFromParent_Done,
     /* 2173648 */   // Label 28612: @2173648
     /* 2173648 */   GIM_Try, /*On fail goto*//*Label 28613*/ GIMT_Encode4(2173739), // Rule ID 18508 //
     /* 2173653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2173656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2173664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2173667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2173670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2173673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2173676 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173695 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173699 */     // MIs[0] round
     /* 2173699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173702 */     // MIs[0] policy
     /* 2173702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173705 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173712 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2173715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173721 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173723 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173725 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173735 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173738 */     // GIR_Coverage, 18508,
     /* 2173738 */     GIR_EraseRootFromParent_Done,
     /* 2173739 */   // Label 28613: @2173739
     /* 2173739 */   GIM_Try, /*On fail goto*//*Label 28614*/ GIMT_Encode4(2173830), // Rule ID 18509 //
     /* 2173744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2173747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2173755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2173758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2173761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2173764 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2173767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2173774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2173786 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173790 */     // MIs[0] round
     /* 2173790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173793 */     // MIs[0] policy
     /* 2173793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173803 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16_MASK),
     /* 2173806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173810 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173812 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173814 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173816 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2173826 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173829 */     // GIR_Coverage, 18509,
     /* 2173829 */     GIR_EraseRootFromParent_Done,
     /* 2173830 */   // Label 28614: @2173830
     /* 2173830 */   GIM_Try, /*On fail goto*//*Label 28615*/ GIMT_Encode4(2173921), // Rule ID 18512 //
     /* 2173835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2173838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2173846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2173849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2173852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2173855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173858 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2173861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173873 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173877 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173881 */     // MIs[0] round
     /* 2173881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173884 */     // MIs[0] policy
     /* 2173884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173887 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173894 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2173894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2173897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173901 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173903 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173905 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173907 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2173909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2173914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2173917 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2173919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2173920 */     // GIR_Coverage, 18512,
     /* 2173920 */     GIR_EraseRootFromParent_Done,
     /* 2173921 */   // Label 28615: @2173921
     /* 2173921 */   GIM_Try, /*On fail goto*//*Label 28616*/ GIMT_Encode4(2174012), // Rule ID 18513 //
     /* 2173926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2173929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2173934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2173937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2173940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2173943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2173946 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2173949 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2173952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2173956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2173968 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2173972 */     // MIs[0] round
     /* 2173972 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2173975 */     // MIs[0] policy
     /* 2173975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2173978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2173985 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2173985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32_MASK),
     /* 2173988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2173990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2173992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2173994 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2173996 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2173998 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174008 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174011 */     // GIR_Coverage, 18513,
     /* 2174011 */     GIR_EraseRootFromParent_Done,
     /* 2174012 */   // Label 28616: @2174012
     /* 2174012 */   GIM_Try, /*On fail goto*//*Label 28617*/ GIMT_Encode4(2174103), // Rule ID 18516 //
     /* 2174017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174040 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174055 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174059 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174063 */     // MIs[0] round
     /* 2174063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174066 */     // MIs[0] policy
     /* 2174066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174076 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2174079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174083 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174085 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174087 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174089 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174099 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174102 */     // GIR_Coverage, 18516,
     /* 2174102 */     GIR_EraseRootFromParent_Done,
     /* 2174103 */   // Label 28617: @2174103
     /* 2174103 */   GIM_Try, /*On fail goto*//*Label 28618*/ GIMT_Encode4(2174194), // Rule ID 18517 //
     /* 2174108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2174119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2174122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2174125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2174128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174131 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174146 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174150 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174154 */     // MIs[0] round
     /* 2174154 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174157 */     // MIs[0] policy
     /* 2174157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174167 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32_MASK),
     /* 2174170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174174 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174176 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174178 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174180 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174190 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174192 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174193 */     // GIR_Coverage, 18517,
     /* 2174193 */     GIR_EraseRootFromParent_Done,
     /* 2174194 */   // Label 28618: @2174194
     /* 2174194 */   GIM_Try, /*On fail goto*//*Label 28619*/ GIMT_Encode4(2174285), // Rule ID 18520 //
     /* 2174199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2174202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174222 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174237 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174241 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174245 */     // MIs[0] round
     /* 2174245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174248 */     // MIs[0] policy
     /* 2174248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174251 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174258 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2174261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174265 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174267 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174269 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174271 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174281 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174284 */     // GIR_Coverage, 18520,
     /* 2174284 */     GIR_EraseRootFromParent_Done,
     /* 2174285 */   // Label 28619: @2174285
     /* 2174285 */   GIM_Try, /*On fail goto*//*Label 28620*/ GIMT_Encode4(2174376), // Rule ID 18521 //
     /* 2174290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2174293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2174301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2174304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2174307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2174310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2174313 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174328 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174332 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174336 */     // MIs[0] round
     /* 2174336 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174339 */     // MIs[0] policy
     /* 2174339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174349 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32_MASK),
     /* 2174352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174356 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174358 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174360 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174362 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2174372 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174375 */     // GIR_Coverage, 18521,
     /* 2174375 */     GIR_EraseRootFromParent_Done,
     /* 2174376 */   // Label 28620: @2174376
     /* 2174376 */   GIM_Try, /*On fail goto*//*Label 28621*/ GIMT_Encode4(2174467), // Rule ID 18524 //
     /* 2174381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174401 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174404 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174419 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174423 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174427 */     // MIs[0] round
     /* 2174427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174430 */     // MIs[0] policy
     /* 2174430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174440 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2174443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174449 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174451 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174453 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174463 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174466 */     // GIR_Coverage, 18524,
     /* 2174466 */     GIR_EraseRootFromParent_Done,
     /* 2174467 */   // Label 28621: @2174467
     /* 2174467 */   GIM_Try, /*On fail goto*//*Label 28622*/ GIMT_Encode4(2174558), // Rule ID 18525 //
     /* 2174472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2174483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2174486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2174489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2174492 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2174495 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2174502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2174514 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174518 */     // MIs[0] round
     /* 2174518 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174521 */     // MIs[0] policy
     /* 2174521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174531 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64_MASK),
     /* 2174534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174540 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174542 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174544 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174554 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174557 */     // GIR_Coverage, 18525,
     /* 2174557 */     GIR_EraseRootFromParent_Done,
     /* 2174558 */   // Label 28622: @2174558
     /* 2174558 */   GIM_Try, /*On fail goto*//*Label 28623*/ GIMT_Encode4(2174649), // Rule ID 18528 //
     /* 2174563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174586 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174601 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174605 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174609 */     // MIs[0] round
     /* 2174609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174612 */     // MIs[0] policy
     /* 2174612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174622 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2174625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174629 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174631 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174633 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174635 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174645 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174648 */     // GIR_Coverage, 18528,
     /* 2174648 */     GIR_EraseRootFromParent_Done,
     /* 2174649 */   // Label 28623: @2174649
     /* 2174649 */   GIM_Try, /*On fail goto*//*Label 28624*/ GIMT_Encode4(2174740), // Rule ID 18529 //
     /* 2174654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2174665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2174668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2174671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2174674 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2174677 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2174684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2174696 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174700 */     // MIs[0] round
     /* 2174700 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174703 */     // MIs[0] policy
     /* 2174703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174706 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174713 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64_MASK),
     /* 2174716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174718 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174722 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174724 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174726 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174736 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174739 */     // GIR_Coverage, 18529,
     /* 2174739 */     GIR_EraseRootFromParent_Done,
     /* 2174740 */   // Label 28624: @2174740
     /* 2174740 */   GIM_Try, /*On fail goto*//*Label 28625*/ GIMT_Encode4(2174831), // Rule ID 18532 //
     /* 2174745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2174748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2174756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2174759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2174762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2174765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174768 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174787 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174791 */     // MIs[0] round
     /* 2174791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174794 */     // MIs[0] policy
     /* 2174794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174804 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2174807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174813 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174815 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174817 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174827 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174830 */     // GIR_Coverage, 18532,
     /* 2174830 */     GIR_EraseRootFromParent_Done,
     /* 2174831 */   // Label 28625: @2174831
     /* 2174831 */   GIM_Try, /*On fail goto*//*Label 28626*/ GIMT_Encode4(2174922), // Rule ID 18533 //
     /* 2174836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2174839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2174847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2174850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2174853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2174856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2174859 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2174862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2174866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174874 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2174878 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174882 */     // MIs[0] round
     /* 2174882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174885 */     // MIs[0] policy
     /* 2174885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174888 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174895 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VV_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2174895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64_MASK),
     /* 2174898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174900 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174902 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174904 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174906 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174908 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2174910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2174915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2174918 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2174920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2174921 */     // GIR_Coverage, 18533,
     /* 2174921 */     GIR_EraseRootFromParent_Done,
     /* 2174922 */   // Label 28626: @2174922
     /* 2174922 */   GIM_Try, /*On fail goto*//*Label 28627*/ GIMT_Encode4(2175013), // Rule ID 18536 //
     /* 2174927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2174930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2174935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2174938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2174941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2174944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2174947 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2174950 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2174953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2174957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174961 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2174965 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2174969 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2174973 */     // MIs[0] round
     /* 2174973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2174976 */     // MIs[0] policy
     /* 2174976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2174979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2174986 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2174986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2174989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2174991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2174993 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2174995 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2174997 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2174999 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175009 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175012 */     // GIR_Coverage, 18536,
     /* 2175012 */     GIR_EraseRootFromParent_Done,
     /* 2175013 */   // Label 28627: @2175013
     /* 2175013 */   GIM_Try, /*On fail goto*//*Label 28628*/ GIMT_Encode4(2175104), // Rule ID 18537 //
     /* 2175018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s16,
     /* 2175029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2175032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2175038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175041 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175056 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175060 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175064 */     // MIs[0] round
     /* 2175064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175067 */     // MIs[0] policy
     /* 2175067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175077 */     // (intrinsic_wo_chain:{ *:[nxv1f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF4_E16_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF4_E16_MASK),
     /* 2175080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175086 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175088 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175090 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175100 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175103 */     // GIR_Coverage, 18537,
     /* 2175103 */     GIR_EraseRootFromParent_Done,
     /* 2175104 */   // Label 28628: @2175104
     /* 2175104 */   GIM_Try, /*On fail goto*//*Label 28629*/ GIMT_Encode4(2175195), // Rule ID 18540 //
     /* 2175109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175129 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175132 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175147 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175151 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175155 */     // MIs[0] round
     /* 2175155 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175158 */     // MIs[0] policy
     /* 2175158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175168 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2175171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175177 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175179 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175181 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175191 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175194 */     // GIR_Coverage, 18540,
     /* 2175194 */     GIR_EraseRootFromParent_Done,
     /* 2175195 */   // Label 28629: @2175195
     /* 2175195 */   GIM_Try, /*On fail goto*//*Label 28630*/ GIMT_Encode4(2175286), // Rule ID 18541 //
     /* 2175200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 2175211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2175214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2175220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175223 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175242 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175246 */     // MIs[0] round
     /* 2175246 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175249 */     // MIs[0] policy
     /* 2175249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175252 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175259 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_MF2_E16_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_MF2_E16_MASK),
     /* 2175262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175266 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175268 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175270 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175272 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175282 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175285 */     // GIR_Coverage, 18541,
     /* 2175285 */     GIR_EraseRootFromParent_Done,
     /* 2175286 */   // Label 28630: @2175286
     /* 2175286 */   GIM_Try, /*On fail goto*//*Label 28631*/ GIMT_Encode4(2175377), // Rule ID 18544 //
     /* 2175291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175333 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175337 */     // MIs[0] round
     /* 2175337 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175340 */     // MIs[0] policy
     /* 2175340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175350 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2175353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175357 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175359 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175361 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175363 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175373 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175376 */     // GIR_Coverage, 18544,
     /* 2175376 */     GIR_EraseRootFromParent_Done,
     /* 2175377 */   // Label 28631: @2175377
     /* 2175377 */   GIM_Try, /*On fail goto*//*Label 28632*/ GIMT_Encode4(2175468), // Rule ID 18545 //
     /* 2175382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2175393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2175396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2175402 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175424 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175428 */     // MIs[0] round
     /* 2175428 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175431 */     // MIs[0] policy
     /* 2175431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175441 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_MF2_E32_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_MF2_E32_MASK),
     /* 2175444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175448 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175450 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175452 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175454 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175464 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175467 */     // GIR_Coverage, 18545,
     /* 2175467 */     GIR_EraseRootFromParent_Done,
     /* 2175468 */   // Label 28632: @2175468
     /* 2175468 */   GIM_Try, /*On fail goto*//*Label 28633*/ GIMT_Encode4(2175559), // Rule ID 18548 //
     /* 2175473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2175476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175496 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175511 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175515 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175519 */     // MIs[0] round
     /* 2175519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175522 */     // MIs[0] policy
     /* 2175522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175525 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175532 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2175535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175541 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175543 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175545 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175547 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175555 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175558 */     // GIR_Coverage, 18548,
     /* 2175558 */     GIR_EraseRootFromParent_Done,
     /* 2175559 */   // Label 28633: @2175559
     /* 2175559 */   GIM_Try, /*On fail goto*//*Label 28634*/ GIMT_Encode4(2175650), // Rule ID 18549 //
     /* 2175564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2175567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 2175575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2175578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2175581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2175584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2175587 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2175602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175606 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175610 */     // MIs[0] round
     /* 2175610 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175613 */     // MIs[0] policy
     /* 2175613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175616 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175623 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 11179:{ *:[iPTR] }, VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M1_E16_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M1_E16_MASK),
     /* 2175626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175630 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175632 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175634 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175636 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2175646 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175649 */     // GIR_Coverage, 18549,
     /* 2175649 */     GIR_EraseRootFromParent_Done,
     /* 2175650 */   // Label 28634: @2175650
     /* 2175650 */   GIM_Try, /*On fail goto*//*Label 28635*/ GIMT_Encode4(2175741), // Rule ID 18552 //
     /* 2175655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2175658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2175666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2175669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2175675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175678 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175697 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175701 */     // MIs[0] round
     /* 2175701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175704 */     // MIs[0] policy
     /* 2175704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175714 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2175717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175721 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175723 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175725 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175727 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175737 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175740 */     // GIR_Coverage, 18552,
     /* 2175740 */     GIR_EraseRootFromParent_Done,
     /* 2175741 */   // Label 28635: @2175741
     /* 2175741 */   GIM_Try, /*On fail goto*//*Label 28636*/ GIMT_Encode4(2175832), // Rule ID 18553 //
     /* 2175746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2175749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2175757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2175760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2175763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2175766 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2175769 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2175784 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175788 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175792 */     // MIs[0] round
     /* 2175792 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175795 */     // MIs[0] policy
     /* 2175795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175805 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11179:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M1_E32_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M1_E32_MASK),
     /* 2175808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175812 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175814 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175816 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175818 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2175828 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175831 */     // GIR_Coverage, 18553,
     /* 2175831 */     GIR_EraseRootFromParent_Done,
     /* 2175832 */   // Label 28636: @2175832
     /* 2175832 */   GIM_Try, /*On fail goto*//*Label 28637*/ GIMT_Encode4(2175923), // Rule ID 18556 //
     /* 2175837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2175840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2175848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2175851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2175854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2175857 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175860 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2175863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2175875 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175879 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175883 */     // MIs[0] round
     /* 2175883 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175886 */     // MIs[0] policy
     /* 2175886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175889 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175896 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2175896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2175899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175905 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175907 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2175909 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2175911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2175916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2175919 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2175921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2175922 */     // GIR_Coverage, 18556,
     /* 2175922 */     GIR_EraseRootFromParent_Done,
     /* 2175923 */   // Label 28637: @2175923
     /* 2175923 */   GIM_Try, /*On fail goto*//*Label 28638*/ GIMT_Encode4(2176014), // Rule ID 18557 //
     /* 2175928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2175931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2175936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2175939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2175942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2175945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s64,
     /* 2175948 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2175951 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2175954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2175958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2175966 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2175970 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2175974 */     // MIs[0] round
     /* 2175974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2175977 */     // MIs[0] policy
     /* 2175977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2175980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2175987 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11179:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M1_E64_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2175987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M1_E64_MASK),
     /* 2175990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2175992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2175994 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2175996 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2175998 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176000 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2176010 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176013 */     // GIR_Coverage, 18557,
     /* 2176013 */     GIR_EraseRootFromParent_Done,
     /* 2176014 */   // Label 28638: @2176014
     /* 2176014 */   GIM_Try, /*On fail goto*//*Label 28639*/ GIMT_Encode4(2176105), // Rule ID 18560 //
     /* 2176019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176042 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176061 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176065 */     // MIs[0] round
     /* 2176065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176068 */     // MIs[0] policy
     /* 2176068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176078 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2176081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176083 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176085 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176087 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176089 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176091 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176101 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176104 */     // GIR_Coverage, 18560,
     /* 2176104 */     GIR_EraseRootFromParent_Done,
     /* 2176105 */   // Label 28639: @2176105
     /* 2176105 */   GIM_Try, /*On fail goto*//*Label 28640*/ GIMT_Encode4(2176196), // Rule ID 18561 //
     /* 2176110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 2176121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2176124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2176130 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176133 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176152 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176156 */     // MIs[0] round
     /* 2176156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176159 */     // MIs[0] policy
     /* 2176159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176162 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176169 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M2_E16_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M2_E16_MASK),
     /* 2176172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176176 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176178 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176180 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176182 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176184 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176192 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176195 */     // GIR_Coverage, 18561,
     /* 2176195 */     GIR_EraseRootFromParent_Done,
     /* 2176196 */   // Label 28640: @2176196
     /* 2176196 */   GIM_Try, /*On fail goto*//*Label 28641*/ GIMT_Encode4(2176287), // Rule ID 18564 //
     /* 2176201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176221 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176224 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176243 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176247 */     // MIs[0] round
     /* 2176247 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176250 */     // MIs[0] policy
     /* 2176250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176253 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176260 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2176263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176269 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176271 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176273 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176283 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176286 */     // GIR_Coverage, 18564,
     /* 2176286 */     GIR_EraseRootFromParent_Done,
     /* 2176287 */   // Label 28641: @2176287
     /* 2176287 */   GIM_Try, /*On fail goto*//*Label 28642*/ GIMT_Encode4(2176378), // Rule ID 18565 //
     /* 2176292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s16,
     /* 2176303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2176306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2176312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176315 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176330 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176334 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176338 */     // MIs[0] round
     /* 2176338 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176341 */     // MIs[0] policy
     /* 2176341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176344 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176351 */     // (intrinsic_wo_chain:{ *:[nxv16f16] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M4_E16_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M4_E16_MASK),
     /* 2176354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176360 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176362 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176364 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176374 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176377 */     // GIR_Coverage, 18565,
     /* 2176377 */     GIR_EraseRootFromParent_Done,
     /* 2176378 */   // Label 28642: @2176378
     /* 2176378 */   GIM_Try, /*On fail goto*//*Label 28643*/ GIMT_Encode4(2176469), // Rule ID 18568 //
     /* 2176383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2176386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176406 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176421 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176425 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176429 */     // MIs[0] round
     /* 2176429 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176432 */     // MIs[0] policy
     /* 2176432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176442 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2176445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176449 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176451 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176453 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176455 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176465 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176468 */     // GIR_Coverage, 18568,
     /* 2176468 */     GIR_EraseRootFromParent_Done,
     /* 2176469 */   // Label 28643: @2176469
     /* 2176469 */   GIM_Try, /*On fail goto*//*Label 28644*/ GIMT_Encode4(2176560), // Rule ID 18569 //
     /* 2176474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2176477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv32s16,
     /* 2176485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2176488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2176491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s16,
     /* 2176494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv32s1,
     /* 2176497 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2176512 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176516 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176520 */     // MIs[0] round
     /* 2176520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176523 */     // MIs[0] policy
     /* 2176523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176533 */     // (intrinsic_wo_chain:{ *:[nxv32f16] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR16_M8_E16_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR16_M8_E16_MASK),
     /* 2176536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176542 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176544 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176546 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2176556 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176559 */     // GIR_Coverage, 18569,
     /* 2176559 */     GIR_EraseRootFromParent_Done,
     /* 2176560 */   // Label 28644: @2176560
     /* 2176560 */   GIM_Try, /*On fail goto*//*Label 28645*/ GIMT_Encode4(2176651), // Rule ID 18572 //
     /* 2176565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176588 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176611 */     // MIs[0] round
     /* 2176611 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176614 */     // MIs[0] policy
     /* 2176614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176617 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176624 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2176627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176633 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176635 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176637 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176647 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176650 */     // GIR_Coverage, 18572,
     /* 2176650 */     GIR_EraseRootFromParent_Done,
     /* 2176651 */   // Label 28645: @2176651
     /* 2176651 */   GIM_Try, /*On fail goto*//*Label 28646*/ GIMT_Encode4(2176742), // Rule ID 18573 //
     /* 2176656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2176667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2176670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2176676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2176679 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2176686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176694 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2176698 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176702 */     // MIs[0] round
     /* 2176702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176705 */     // MIs[0] policy
     /* 2176705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176708 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176715 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M2_E32_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M2_E32_MASK),
     /* 2176718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176724 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176726 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176728 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176738 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176741 */     // GIR_Coverage, 18573,
     /* 2176741 */     GIR_EraseRootFromParent_Done,
     /* 2176742 */   // Label 28646: @2176742
     /* 2176742 */   GIM_Try, /*On fail goto*//*Label 28647*/ GIMT_Encode4(2176833), // Rule ID 18576 //
     /* 2176747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2176758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2176761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2176767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176770 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176789 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176793 */     // MIs[0] round
     /* 2176793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176796 */     // MIs[0] policy
     /* 2176796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176806 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2176809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176813 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176815 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176817 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176819 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176829 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176832 */     // GIR_Coverage, 18576,
     /* 2176832 */     GIR_EraseRootFromParent_Done,
     /* 2176833 */   // Label 28647: @2176833
     /* 2176833 */   GIM_Try, /*On fail goto*//*Label 28648*/ GIMT_Encode4(2176924), // Rule ID 18577 //
     /* 2176838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2176841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2176849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2176852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2176858 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2176861 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2176864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2176868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176876 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2176880 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176884 */     // MIs[0] round
     /* 2176884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176887 */     // MIs[0] policy
     /* 2176887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176897 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M4_E32_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2176897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M4_E32_MASK),
     /* 2176900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176904 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176906 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176908 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2176910 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2176912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2176917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2176920 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2176922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2176923 */     // GIR_Coverage, 18577,
     /* 2176923 */     GIR_EraseRootFromParent_Done,
     /* 2176924 */   // Label 28648: @2176924
     /* 2176924 */   GIM_Try, /*On fail goto*//*Label 28649*/ GIMT_Encode4(2177015), // Rule ID 18580 //
     /* 2176929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2176932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2176937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2176940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2176943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2176946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2176949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2176952 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2176955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2176959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2176967 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2176971 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2176975 */     // MIs[0] round
     /* 2176975 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2176978 */     // MIs[0] policy
     /* 2176978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2176981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2176988 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2176988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2176991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2176993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2176995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2176997 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2176999 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177001 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177011 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177014 */     // GIR_Coverage, 18580,
     /* 2177014 */     GIR_EraseRootFromParent_Done,
     /* 2177015 */   // Label 28649: @2177015
     /* 2177015 */   GIM_Try, /*On fail goto*//*Label 28650*/ GIMT_Encode4(2177106), // Rule ID 18581 //
     /* 2177020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2177023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2177031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2177034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2177037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s32,
     /* 2177040 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2177043 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177050 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2177058 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177062 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177066 */     // MIs[0] round
     /* 2177066 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177069 */     // MIs[0] policy
     /* 2177069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177079 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR32_M8_E32_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR32_M8_E32_MASK),
     /* 2177082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177084 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177086 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177088 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177090 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177092 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2177102 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177105 */     // GIR_Coverage, 18581,
     /* 2177105 */     GIR_EraseRootFromParent_Done,
     /* 2177106 */   // Label 28650: @2177106
     /* 2177106 */   GIM_Try, /*On fail goto*//*Label 28651*/ GIMT_Encode4(2177197), // Rule ID 18584 //
     /* 2177111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177134 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177149 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177153 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177157 */     // MIs[0] round
     /* 2177157 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177160 */     // MIs[0] policy
     /* 2177160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177170 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2177173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177177 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177179 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177181 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177183 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177193 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177196 */     // GIR_Coverage, 18584,
     /* 2177196 */     GIR_EraseRootFromParent_Done,
     /* 2177197 */   // Label 28651: @2177197
     /* 2177197 */   GIM_Try, /*On fail goto*//*Label 28652*/ GIMT_Encode4(2177288), // Rule ID 18585 //
     /* 2177202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2177213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2177216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 2177222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177225 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2177232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2177244 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177248 */     // MIs[0] round
     /* 2177248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177251 */     // MIs[0] policy
     /* 2177251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177254 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177261 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11179:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M2_E64_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M2_E64_MASK),
     /* 2177264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177270 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177272 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177274 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177284 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177287 */     // GIR_Coverage, 18585,
     /* 2177287 */     GIR_EraseRootFromParent_Done,
     /* 2177288 */   // Label 28652: @2177288
     /* 2177288 */   GIM_Try, /*On fail goto*//*Label 28653*/ GIMT_Encode4(2177379), // Rule ID 18588 //
     /* 2177293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177313 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177316 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177335 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177339 */     // MIs[0] round
     /* 2177339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177342 */     // MIs[0] policy
     /* 2177342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177345 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177352 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2177355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177361 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177363 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177365 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177375 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177378 */     // GIR_Coverage, 18588,
     /* 2177378 */     GIR_EraseRootFromParent_Done,
     /* 2177379 */   // Label 28653: @2177379
     /* 2177379 */   GIM_Try, /*On fail goto*//*Label 28654*/ GIMT_Encode4(2177470), // Rule ID 18589 //
     /* 2177384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2177395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2177398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s64,
     /* 2177404 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2177407 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2177414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177422 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2177426 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177430 */     // MIs[0] round
     /* 2177430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177433 */     // MIs[0] policy
     /* 2177433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177436 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177443 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11179:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M4_E64_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M4_E64_MASK),
     /* 2177446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177452 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177454 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177456 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177466 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177469 */     // GIR_Coverage, 18589,
     /* 2177469 */     GIR_EraseRootFromParent_Done,
     /* 2177470 */   // Label 28654: @2177470
     /* 2177470 */   GIM_Try, /*On fail goto*//*Label 28655*/ GIMT_Encode4(2177561), // Rule ID 18592 //
     /* 2177475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2177478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177498 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177513 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177517 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177521 */     // MIs[0] round
     /* 2177521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177524 */     // MIs[0] policy
     /* 2177524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177534 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2177537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177541 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177543 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177545 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177547 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177557 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177560 */     // GIR_Coverage, 18592,
     /* 2177560 */     GIR_EraseRootFromParent_Done,
     /* 2177561 */   // Label 28655: @2177561
     /* 2177561 */   GIM_Try, /*On fail goto*//*Label 28656*/ GIMT_Encode4(2177652), // Rule ID 18593 //
     /* 2177566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2177569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfnmsub_mask),
     /* 2177574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2177577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2177580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2177583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s64,
     /* 2177586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2177589 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2177596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2177604 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2177608 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177612 */     // MIs[0] round
     /* 2177612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177615 */     // MIs[0] policy
     /* 2177615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177625 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11179:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNMSUB_VFPR64_M8_E64_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR64:{ *:[f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VFPR64_M8_E64_MASK),
     /* 2177628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177630 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177632 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177634 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177636 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177638 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2177648 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177651 */     // GIR_Coverage, 18593,
     /* 2177651 */     GIR_EraseRootFromParent_Done,
     /* 2177652 */   // Label 28656: @2177652
     /* 2177652 */   GIM_Try, /*On fail goto*//*Label 28657*/ GIMT_Encode4(2177743), // Rule ID 18596 //
     /* 2177657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2177660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2177665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2177668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2177671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2177674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2177677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177680 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177695 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177699 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177703 */     // MIs[0] round
     /* 2177703 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177706 */     // MIs[0] policy
     /* 2177706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177716 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2177719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177725 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177727 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177729 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177739 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177742 */     // GIR_Coverage, 18596,
     /* 2177742 */     GIR_EraseRootFromParent_Done,
     /* 2177743 */   // Label 28657: @2177743
     /* 2177743 */   GIM_Try, /*On fail goto*//*Label 28658*/ GIMT_Encode4(2177834), // Rule ID 18597 //
     /* 2177748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2177751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2177756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2177759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2177762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2177765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2177768 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2177771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177786 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177790 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177794 */     // MIs[0] round
     /* 2177794 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177797 */     // MIs[0] policy
     /* 2177797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177807 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF4_E16_MASK),
     /* 2177810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177816 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177818 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177820 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177830 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177833 */     // GIR_Coverage, 18597,
     /* 2177833 */     GIR_EraseRootFromParent_Done,
     /* 2177834 */   // Label 28658: @2177834
     /* 2177834 */   GIM_Try, /*On fail goto*//*Label 28659*/ GIMT_Encode4(2177925), // Rule ID 18600 //
     /* 2177839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2177842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2177847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2177856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2177859 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177862 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2177865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177877 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177881 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177885 */     // MIs[0] round
     /* 2177885 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177888 */     // MIs[0] policy
     /* 2177888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177898 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2177898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2177901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177905 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177907 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2177909 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2177911 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2177913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2177918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2177921 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2177923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2177924 */     // GIR_Coverage, 18600,
     /* 2177924 */     GIR_EraseRootFromParent_Done,
     /* 2177925 */   // Label 28659: @2177925
     /* 2177925 */   GIM_Try, /*On fail goto*//*Label 28660*/ GIMT_Encode4(2178016), // Rule ID 18601 //
     /* 2177930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2177933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2177938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2177941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2177944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2177947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2177950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2177953 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2177956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2177960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177968 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2177972 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2177976 */     // MIs[0] round
     /* 2177976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2177979 */     // MIs[0] policy
     /* 2177979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2177982 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2177989 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2177989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E16_MASK),
     /* 2177992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2177994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2177996 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2177998 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178000 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178002 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178004 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178012 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178015 */     // GIR_Coverage, 18601,
     /* 2178015 */     GIR_EraseRootFromParent_Done,
     /* 2178016 */   // Label 28660: @2178016
     /* 2178016 */   GIM_Try, /*On fail goto*//*Label 28661*/ GIMT_Encode4(2178107), // Rule ID 18604 //
     /* 2178021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2178024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178038 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178041 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178044 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178063 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178067 */     // MIs[0] round
     /* 2178067 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178070 */     // MIs[0] policy
     /* 2178070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178080 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2178083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178087 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178089 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178091 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178093 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178103 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178106 */     // GIR_Coverage, 18604,
     /* 2178106 */     GIR_EraseRootFromParent_Done,
     /* 2178107 */   // Label 28661: @2178107
     /* 2178107 */   GIM_Try, /*On fail goto*//*Label 28662*/ GIMT_Encode4(2178198), // Rule ID 18605 //
     /* 2178112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2178115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2178123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2178126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2178129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2178132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178135 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178150 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178154 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178158 */     // MIs[0] round
     /* 2178158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178161 */     // MIs[0] policy
     /* 2178161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178171 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E16_MASK),
     /* 2178174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178178 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178180 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178182 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178184 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178186 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178194 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178197 */     // GIR_Coverage, 18605,
     /* 2178197 */     GIR_EraseRootFromParent_Done,
     /* 2178198 */   // Label 28662: @2178198
     /* 2178198 */   GIM_Try, /*On fail goto*//*Label 28663*/ GIMT_Encode4(2178289), // Rule ID 18608 //
     /* 2178203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2178206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2178220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2178223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178241 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178245 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178249 */     // MIs[0] round
     /* 2178249 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178252 */     // MIs[0] policy
     /* 2178252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178262 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2178265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178269 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178271 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178273 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178275 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178285 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178288 */     // GIR_Coverage, 18608,
     /* 2178288 */     GIR_EraseRootFromParent_Done,
     /* 2178289 */   // Label 28663: @2178289
     /* 2178289 */   GIM_Try, /*On fail goto*//*Label 28664*/ GIMT_Encode4(2178380), // Rule ID 18609 //
     /* 2178294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2178297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2178305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2178308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2178311 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2178314 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2178317 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178336 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178340 */     // MIs[0] round
     /* 2178340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178343 */     // MIs[0] policy
     /* 2178343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178353 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E16_MASK),
     /* 2178356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178358 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178360 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178362 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178364 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178366 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178376 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178379 */     // GIR_Coverage, 18609,
     /* 2178379 */     GIR_EraseRootFromParent_Done,
     /* 2178380 */   // Label 28664: @2178380
     /* 2178380 */   GIM_Try, /*On fail goto*//*Label 28665*/ GIMT_Encode4(2178471), // Rule ID 18612 //
     /* 2178385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2178388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2178402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2178405 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178408 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178427 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178431 */     // MIs[0] round
     /* 2178431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178434 */     // MIs[0] policy
     /* 2178434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178437 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178444 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2178447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178453 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178455 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178457 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178467 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178470 */     // GIR_Coverage, 18612,
     /* 2178470 */     GIR_EraseRootFromParent_Done,
     /* 2178471 */   // Label 28665: @2178471
     /* 2178471 */   GIM_Try, /*On fail goto*//*Label 28666*/ GIMT_Encode4(2178562), // Rule ID 18613 //
     /* 2178476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2178479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2178487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2178490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2178493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2178496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2178499 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2178506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2178510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178514 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178518 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178522 */     // MIs[0] round
     /* 2178522 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178525 */     // MIs[0] policy
     /* 2178525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178535 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E16_MASK),
     /* 2178538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178544 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178546 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178548 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2178558 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178561 */     // GIR_Coverage, 18613,
     /* 2178561 */     GIR_EraseRootFromParent_Done,
     /* 2178562 */   // Label 28666: @2178562
     /* 2178562 */   GIM_Try, /*On fail goto*//*Label 28667*/ GIMT_Encode4(2178653), // Rule ID 18616 //
     /* 2178567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2178570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178609 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178613 */     // MIs[0] round
     /* 2178613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178616 */     // MIs[0] policy
     /* 2178616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178619 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178626 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2178629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178633 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178635 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178637 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178639 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178649 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178652 */     // GIR_Coverage, 18616,
     /* 2178652 */     GIR_EraseRootFromParent_Done,
     /* 2178653 */   // Label 28667: @2178653
     /* 2178653 */   GIM_Try, /*On fail goto*//*Label 28668*/ GIMT_Encode4(2178744), // Rule ID 18617 //
     /* 2178658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2178661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2178669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2178672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2178675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2178678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2178681 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2178688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178696 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178700 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178704 */     // MIs[0] round
     /* 2178704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178707 */     // MIs[0] policy
     /* 2178707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178717 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_MF2_E32_MASK),
     /* 2178720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178724 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178726 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178728 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178730 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178740 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178743 */     // GIR_Coverage, 18617,
     /* 2178743 */     GIR_EraseRootFromParent_Done,
     /* 2178744 */   // Label 28668: @2178744
     /* 2178744 */   GIM_Try, /*On fail goto*//*Label 28669*/ GIMT_Encode4(2178835), // Rule ID 18620 //
     /* 2178749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2178752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178769 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178772 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178791 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178795 */     // MIs[0] round
     /* 2178795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178798 */     // MIs[0] policy
     /* 2178798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178808 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2178811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178817 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178819 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178821 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178831 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178834 */     // GIR_Coverage, 18620,
     /* 2178834 */     GIR_EraseRootFromParent_Done,
     /* 2178835 */   // Label 28669: @2178835
     /* 2178835 */   GIM_Try, /*On fail goto*//*Label 28670*/ GIMT_Encode4(2178926), // Rule ID 18621 //
     /* 2178840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2178843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2178851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2178854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2178857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2178860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2178863 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2178866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2178870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178878 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2178882 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178886 */     // MIs[0] round
     /* 2178886 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178889 */     // MIs[0] policy
     /* 2178889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178892 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178899 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2178899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M1_E32_MASK),
     /* 2178902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178908 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2178910 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2178912 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2178914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2178919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2178922 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2178924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2178925 */     // GIR_Coverage, 18621,
     /* 2178925 */     GIR_EraseRootFromParent_Done,
     /* 2178926 */   // Label 28670: @2178926
     /* 2178926 */   GIM_Try, /*On fail goto*//*Label 28671*/ GIMT_Encode4(2179017), // Rule ID 18624 //
     /* 2178931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2178934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2178939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2178942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2178945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2178948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2178951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2178954 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2178957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2178961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2178965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2178973 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2178977 */     // MIs[0] round
     /* 2178977 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2178980 */     // MIs[0] policy
     /* 2178980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2178983 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2178990 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2178990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2178993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2178995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2178997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2178999 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179001 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179003 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179013 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179016 */     // GIR_Coverage, 18624,
     /* 2179016 */     GIR_EraseRootFromParent_Done,
     /* 2179017 */   // Label 28671: @2179017
     /* 2179017 */   GIM_Try, /*On fail goto*//*Label 28672*/ GIMT_Encode4(2179108), // Rule ID 18625 //
     /* 2179022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2179025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2179033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2179036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2179039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2179042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179045 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179060 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179064 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179068 */     // MIs[0] round
     /* 2179068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179071 */     // MIs[0] policy
     /* 2179071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179081 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M2_E32_MASK),
     /* 2179084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179088 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179090 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179092 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179094 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179104 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179107 */     // GIR_Coverage, 18625,
     /* 2179107 */     GIR_EraseRootFromParent_Done,
     /* 2179108 */   // Label 28672: @2179108
     /* 2179108 */   GIM_Try, /*On fail goto*//*Label 28673*/ GIMT_Encode4(2179199), // Rule ID 18628 //
     /* 2179113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2179116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2179124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2179127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179133 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179136 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179151 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179155 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179159 */     // MIs[0] round
     /* 2179159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179162 */     // MIs[0] policy
     /* 2179162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179172 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2179175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179179 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179181 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179183 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179185 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179195 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179198 */     // GIR_Coverage, 18628,
     /* 2179198 */     GIR_EraseRootFromParent_Done,
     /* 2179199 */   // Label 28673: @2179199
     /* 2179199 */   GIM_Try, /*On fail goto*//*Label 28674*/ GIMT_Encode4(2179290), // Rule ID 18629 //
     /* 2179204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2179207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2179215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2179218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2179221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2179224 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179227 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2179234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2179238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179242 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179246 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179250 */     // MIs[0] round
     /* 2179250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179253 */     // MIs[0] policy
     /* 2179253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179263 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VV_M4_E32_MASK),
     /* 2179266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179272 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179274 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179276 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2179286 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179289 */     // GIR_Coverage, 18629,
     /* 2179289 */     GIR_EraseRootFromParent_Done,
     /* 2179290 */   // Label 28674: @2179290
     /* 2179290 */   GIM_Try, /*On fail goto*//*Label 28675*/ GIMT_Encode4(2179381), // Rule ID 18632 //
     /* 2179295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2179298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179337 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179341 */     // MIs[0] round
     /* 2179341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179344 */     // MIs[0] policy
     /* 2179344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179354 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2179357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179361 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179363 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179365 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179367 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179377 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179380 */     // GIR_Coverage, 18632,
     /* 2179380 */     GIR_EraseRootFromParent_Done,
     /* 2179381 */   // Label 28675: @2179381
     /* 2179381 */   GIM_Try, /*On fail goto*//*Label 28676*/ GIMT_Encode4(2179472), // Rule ID 18633 //
     /* 2179386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2179389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2179397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2179400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179403 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2179406 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2179409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179424 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179428 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179432 */     // MIs[0] round
     /* 2179432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179435 */     // MIs[0] policy
     /* 2179435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179445 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF4_E16_MASK),
     /* 2179448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179452 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179454 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179456 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179458 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179468 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179471 */     // GIR_Coverage, 18633,
     /* 2179471 */     GIR_EraseRootFromParent_Done,
     /* 2179472 */   // Label 28676: @2179472
     /* 2179472 */   GIM_Try, /*On fail goto*//*Label 28677*/ GIMT_Encode4(2179563), // Rule ID 18636 //
     /* 2179477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2179480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179500 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179519 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179523 */     // MIs[0] round
     /* 2179523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179526 */     // MIs[0] policy
     /* 2179526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179536 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2179539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179543 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179545 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179547 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179549 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179559 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179562 */     // GIR_Coverage, 18636,
     /* 2179562 */     GIR_EraseRootFromParent_Done,
     /* 2179563 */   // Label 28677: @2179563
     /* 2179563 */   GIM_Try, /*On fail goto*//*Label 28678*/ GIMT_Encode4(2179654), // Rule ID 18637 //
     /* 2179568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2179571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2179579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2179582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2179588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2179591 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2179598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179606 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179610 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179614 */     // MIs[0] round
     /* 2179614 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179617 */     // MIs[0] policy
     /* 2179617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179620 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179627 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11231:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_MF2_E16_MASK),
     /* 2179630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179636 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179638 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179640 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179650 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179653 */     // GIR_Coverage, 18637,
     /* 2179653 */     GIR_EraseRootFromParent_Done,
     /* 2179654 */   // Label 28678: @2179654
     /* 2179654 */   GIM_Try, /*On fail goto*//*Label 28679*/ GIMT_Encode4(2179745), // Rule ID 18640 //
     /* 2179659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2179662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179682 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179697 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179701 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179705 */     // MIs[0] round
     /* 2179705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179708 */     // MIs[0] policy
     /* 2179708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179711 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179718 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2179721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179725 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179727 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179729 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179731 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179741 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179744 */     // GIR_Coverage, 18640,
     /* 2179744 */     GIR_EraseRootFromParent_Done,
     /* 2179745 */   // Label 28679: @2179745
     /* 2179745 */   GIM_Try, /*On fail goto*//*Label 28680*/ GIMT_Encode4(2179836), // Rule ID 18641 //
     /* 2179750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2179753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2179761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2179764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2179770 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2179773 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2179780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179788 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2179792 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179796 */     // MIs[0] round
     /* 2179796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179799 */     // MIs[0] policy
     /* 2179799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179809 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M1_E16_MASK),
     /* 2179812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179816 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179818 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179820 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179822 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179832 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179835 */     // GIR_Coverage, 18641,
     /* 2179835 */     GIR_EraseRootFromParent_Done,
     /* 2179836 */   // Label 28680: @2179836
     /* 2179836 */   GIM_Try, /*On fail goto*//*Label 28681*/ GIMT_Encode4(2179927), // Rule ID 18644 //
     /* 2179841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2179844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179861 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179864 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2179867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179879 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179883 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179887 */     // MIs[0] round
     /* 2179887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179890 */     // MIs[0] policy
     /* 2179890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179893 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179900 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2179900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2179903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179907 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2179909 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2179911 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2179913 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2179915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2179920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2179923 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2179925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2179926 */     // GIR_Coverage, 18644,
     /* 2179926 */     GIR_EraseRootFromParent_Done,
     /* 2179927 */   // Label 28681: @2179927
     /* 2179927 */   GIM_Try, /*On fail goto*//*Label 28682*/ GIMT_Encode4(2180018), // Rule ID 18645 //
     /* 2179932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2179935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2179940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2179943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2179946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2179949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2179952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2179955 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2179958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2179962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2179966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2179970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2179974 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2179978 */     // MIs[0] round
     /* 2179978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2179981 */     // MIs[0] policy
     /* 2179981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2179984 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2179991 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2179991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M2_E16_MASK),
     /* 2179994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2179996 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2179998 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180000 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180002 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180004 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180014 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180017 */     // GIR_Coverage, 18645,
     /* 2180017 */     GIR_EraseRootFromParent_Done,
     /* 2180018 */   // Label 28682: @2180018
     /* 2180018 */   GIM_Try, /*On fail goto*//*Label 28683*/ GIMT_Encode4(2180109), // Rule ID 18648 //
     /* 2180023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2180026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180046 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180065 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180069 */     // MIs[0] round
     /* 2180069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180072 */     // MIs[0] policy
     /* 2180072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180082 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2180085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180091 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180093 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180095 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180105 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180108 */     // GIR_Coverage, 18648,
     /* 2180108 */     GIR_EraseRootFromParent_Done,
     /* 2180109 */   // Label 28683: @2180109
     /* 2180109 */   GIM_Try, /*On fail goto*//*Label 28684*/ GIMT_Encode4(2180200), // Rule ID 18649 //
     /* 2180114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2180117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2180125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2180128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2180131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2180134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2180137 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2180152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180156 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180160 */     // MIs[0] round
     /* 2180160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180163 */     // MIs[0] policy
     /* 2180163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180166 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180173 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR16_M4_E16_MASK),
     /* 2180176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180180 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180182 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180184 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180186 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2180196 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180199 */     // GIR_Coverage, 18649,
     /* 2180199 */     GIR_EraseRootFromParent_Done,
     /* 2180200 */   // Label 28684: @2180200
     /* 2180200 */   GIM_Try, /*On fail goto*//*Label 28685*/ GIMT_Encode4(2180291), // Rule ID 18652 //
     /* 2180205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2180208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2180225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180228 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180243 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180247 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180251 */     // MIs[0] round
     /* 2180251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180254 */     // MIs[0] policy
     /* 2180254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180264 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2180267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180271 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180273 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180275 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180277 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180279 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180287 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180290 */     // GIR_Coverage, 18652,
     /* 2180290 */     GIR_EraseRootFromParent_Done,
     /* 2180291 */   // Label 28685: @2180291
     /* 2180291 */   GIM_Try, /*On fail goto*//*Label 28686*/ GIMT_Encode4(2180382), // Rule ID 18653 //
     /* 2180296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2180299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2180307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2180310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2180316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180319 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180334 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180338 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180342 */     // MIs[0] round
     /* 2180342 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180345 */     // MIs[0] policy
     /* 2180345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180355 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11231:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_MF2_E32_MASK),
     /* 2180358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180362 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180364 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180366 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180368 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180378 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180381 */     // GIR_Coverage, 18653,
     /* 2180381 */     GIR_EraseRootFromParent_Done,
     /* 2180382 */   // Label 28686: @2180382
     /* 2180382 */   GIM_Try, /*On fail goto*//*Label 28687*/ GIMT_Encode4(2180473), // Rule ID 18656 //
     /* 2180387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2180390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2180407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180410 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180425 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180429 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180433 */     // MIs[0] round
     /* 2180433 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180436 */     // MIs[0] policy
     /* 2180436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180446 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2180449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180453 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180455 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180457 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180459 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180469 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180472 */     // GIR_Coverage, 18656,
     /* 2180472 */     GIR_EraseRootFromParent_Done,
     /* 2180473 */   // Label 28687: @2180473
     /* 2180473 */   GIM_Try, /*On fail goto*//*Label 28688*/ GIMT_Encode4(2180564), // Rule ID 18657 //
     /* 2180478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2180481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2180489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2180492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2180498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2180501 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2180508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180516 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180520 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180524 */     // MIs[0] round
     /* 2180524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180527 */     // MIs[0] policy
     /* 2180527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180537 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11231:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M1_E32_MASK),
     /* 2180540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180544 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180546 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180548 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180550 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180560 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180563 */     // GIR_Coverage, 18657,
     /* 2180563 */     GIR_EraseRootFromParent_Done,
     /* 2180564 */   // Label 28688: @2180564
     /* 2180564 */   GIM_Try, /*On fail goto*//*Label 28689*/ GIMT_Encode4(2180655), // Rule ID 18660 //
     /* 2180569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2180572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180592 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180611 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180615 */     // MIs[0] round
     /* 2180615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180618 */     // MIs[0] policy
     /* 2180618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180628 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2180631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180633 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180635 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180637 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180639 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180641 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180651 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180654 */     // GIR_Coverage, 18660,
     /* 2180654 */     GIR_EraseRootFromParent_Done,
     /* 2180655 */   // Label 28689: @2180655
     /* 2180655 */   GIM_Try, /*On fail goto*//*Label 28690*/ GIMT_Encode4(2180746), // Rule ID 18661 //
     /* 2180660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2180663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2180671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2180674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2180680 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2180683 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2180690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2180702 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180706 */     // MIs[0] round
     /* 2180706 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180709 */     // MIs[0] policy
     /* 2180709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180712 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180719 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11231:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M2_E32_MASK),
     /* 2180722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180728 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180730 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180732 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180742 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180745 */     // GIR_Coverage, 18661,
     /* 2180745 */     GIR_EraseRootFromParent_Done,
     /* 2180746 */   // Label 28690: @2180746
     /* 2180746 */   GIM_Try, /*On fail goto*//*Label 28691*/ GIMT_Encode4(2180837), // Rule ID 18664 //
     /* 2180751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2180754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180771 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180774 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180789 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180793 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180797 */     // MIs[0] round
     /* 2180797 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180800 */     // MIs[0] policy
     /* 2180800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180810 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2180813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180819 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180821 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180823 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180833 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180836 */     // GIR_Coverage, 18664,
     /* 2180836 */     GIR_EraseRootFromParent_Done,
     /* 2180837 */   // Label 28691: @2180837
     /* 2180837 */   GIM_Try, /*On fail goto*//*Label 28692*/ GIMT_Encode4(2180928), // Rule ID 18665 //
     /* 2180842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2180845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmacc_mask),
     /* 2180850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2180853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2180856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2180859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2180862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2180865 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2180868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2180872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2180876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2180880 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2180884 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180888 */     // MIs[0] round
     /* 2180888 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180891 */     // MIs[0] policy
     /* 2180891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180894 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180901 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11231:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2180901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMACC_VFPR32_M4_E32_MASK),
     /* 2180904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180908 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2180910 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2180912 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2180914 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2180916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2180921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2180924 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2180926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2180927 */     // GIR_Coverage, 18665,
     /* 2180927 */     GIR_EraseRootFromParent_Done,
     /* 2180928 */   // Label 28692: @2180928
     /* 2180928 */   GIM_Try, /*On fail goto*//*Label 28693*/ GIMT_Encode4(2181019), // Rule ID 18668 //
     /* 2180933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2180936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2180941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2180944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2180947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2180950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2180953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2180956 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2180959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2180963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2180975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2180979 */     // MIs[0] round
     /* 2180979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2180982 */     // MIs[0] policy
     /* 2180982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2180985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2180992 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2180992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2180995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2180997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2180999 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181001 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181003 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181005 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181015 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181018 */     // GIR_Coverage, 18668,
     /* 2181018 */     GIR_EraseRootFromParent_Done,
     /* 2181019 */   // Label 28693: @2181019
     /* 2181019 */   GIM_Try, /*On fail goto*//*Label 28694*/ GIMT_Encode4(2181110), // Rule ID 18669 //
     /* 2181024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2181027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2181035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2181038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2181041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2181044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181047 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181066 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181070 */     // MIs[0] round
     /* 2181070 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181073 */     // MIs[0] policy
     /* 2181073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181076 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181083 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF4_E16_MASK),
     /* 2181086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181090 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181092 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181094 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181096 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181106 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181109 */     // GIR_Coverage, 18669,
     /* 2181109 */     GIR_EraseRootFromParent_Done,
     /* 2181110 */   // Label 28694: @2181110
     /* 2181110 */   GIM_Try, /*On fail goto*//*Label 28695*/ GIMT_Encode4(2181201), // Rule ID 18672 //
     /* 2181115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2181118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2181132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181153 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181157 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181161 */     // MIs[0] round
     /* 2181161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181164 */     // MIs[0] policy
     /* 2181164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181167 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181174 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2181177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181183 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181185 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181187 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181197 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181200 */     // GIR_Coverage, 18672,
     /* 2181200 */     GIR_EraseRootFromParent_Done,
     /* 2181201 */   // Label 28695: @2181201
     /* 2181201 */   GIM_Try, /*On fail goto*//*Label 28696*/ GIMT_Encode4(2181292), // Rule ID 18673 //
     /* 2181206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2181209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2181217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2181220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2181223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2181226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2181229 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181240 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181244 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181248 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181252 */     // MIs[0] round
     /* 2181252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181255 */     // MIs[0] policy
     /* 2181255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181265 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E16_MASK),
     /* 2181268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181274 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181276 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181278 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181288 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181291 */     // GIR_Coverage, 18673,
     /* 2181291 */     GIR_EraseRootFromParent_Done,
     /* 2181292 */   // Label 28696: @2181292
     /* 2181292 */   GIM_Try, /*On fail goto*//*Label 28697*/ GIMT_Encode4(2181383), // Rule ID 18676 //
     /* 2181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2181300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2181308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2181311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2181314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181320 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181335 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181339 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181343 */     // MIs[0] round
     /* 2181343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181346 */     // MIs[0] policy
     /* 2181346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181356 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2181359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181363 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181365 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181367 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181369 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181379 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181382 */     // GIR_Coverage, 18676,
     /* 2181382 */     GIR_EraseRootFromParent_Done,
     /* 2181383 */   // Label 28697: @2181383
     /* 2181383 */   GIM_Try, /*On fail goto*//*Label 28698*/ GIMT_Encode4(2181474), // Rule ID 18677 //
     /* 2181388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2181391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2181399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2181402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2181405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2181408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2181411 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2181418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181430 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181434 */     // MIs[0] round
     /* 2181434 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181437 */     // MIs[0] policy
     /* 2181437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181447 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E16_MASK),
     /* 2181450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181456 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181458 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181460 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181470 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181473 */     // GIR_Coverage, 18677,
     /* 2181473 */     GIR_EraseRootFromParent_Done,
     /* 2181474 */   // Label 28698: @2181474
     /* 2181474 */   GIM_Try, /*On fail goto*//*Label 28699*/ GIMT_Encode4(2181565), // Rule ID 18680 //
     /* 2181479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2181482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2181490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2181493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2181496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181502 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181521 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181525 */     // MIs[0] round
     /* 2181525 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181528 */     // MIs[0] policy
     /* 2181528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181538 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2181541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181547 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181549 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181551 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181561 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181564 */     // GIR_Coverage, 18680,
     /* 2181564 */     GIR_EraseRootFromParent_Done,
     /* 2181565 */   // Label 28699: @2181565
     /* 2181565 */   GIM_Try, /*On fail goto*//*Label 28700*/ GIMT_Encode4(2181656), // Rule ID 18681 //
     /* 2181570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2181573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2181581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2181584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2181587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2181590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2181593 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2181600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2181612 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181616 */     // MIs[0] round
     /* 2181616 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181619 */     // MIs[0] policy
     /* 2181619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181622 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181629 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E16_MASK),
     /* 2181632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181634 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181636 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181638 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181640 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181642 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181652 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181655 */     // GIR_Coverage, 18681,
     /* 2181655 */     GIR_EraseRootFromParent_Done,
     /* 2181656 */   // Label 28700: @2181656
     /* 2181656 */   GIM_Try, /*On fail goto*//*Label 28701*/ GIMT_Encode4(2181747), // Rule ID 18684 //
     /* 2181661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2181664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2181678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2181681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181684 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181699 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181703 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181707 */     // MIs[0] round
     /* 2181707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181710 */     // MIs[0] policy
     /* 2181710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181720 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2181723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181727 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181729 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181731 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181733 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181743 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181746 */     // GIR_Coverage, 18684,
     /* 2181746 */     GIR_EraseRootFromParent_Done,
     /* 2181747 */   // Label 28701: @2181747
     /* 2181747 */   GIM_Try, /*On fail goto*//*Label 28702*/ GIMT_Encode4(2181838), // Rule ID 18685 //
     /* 2181752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2181755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2181763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2181766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2181769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2181772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2181775 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2181782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2181786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181790 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2181794 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181798 */     // MIs[0] round
     /* 2181798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181801 */     // MIs[0] policy
     /* 2181801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181811 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E16_MASK),
     /* 2181814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181820 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181822 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181824 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2181834 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181837 */     // GIR_Coverage, 18685,
     /* 2181837 */     GIR_EraseRootFromParent_Done,
     /* 2181838 */   // Label 28702: @2181838
     /* 2181838 */   GIM_Try, /*On fail goto*//*Label 28703*/ GIMT_Encode4(2181929), // Rule ID 18688 //
     /* 2181843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2181846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2181860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181866 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2181869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181881 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181885 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181889 */     // MIs[0] round
     /* 2181889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181892 */     // MIs[0] policy
     /* 2181892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181895 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181902 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2181902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2181905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181907 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2181909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2181911 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2181913 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2181915 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2181917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2181922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2181925 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2181927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2181928 */     // GIR_Coverage, 18688,
     /* 2181928 */     GIR_EraseRootFromParent_Done,
     /* 2181929 */   // Label 28703: @2181929
     /* 2181929 */   GIM_Try, /*On fail goto*//*Label 28704*/ GIMT_Encode4(2182020), // Rule ID 18689 //
     /* 2181934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2181937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2181942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2181945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2181948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2181951 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2181954 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2181957 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2181960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2181964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2181976 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2181980 */     // MIs[0] round
     /* 2181980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2181983 */     // MIs[0] policy
     /* 2181983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2181986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2181993 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2181993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_MF2_E32_MASK),
     /* 2181996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2181998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182000 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182002 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182004 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182006 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182016 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182019 */     // GIR_Coverage, 18689,
     /* 2182019 */     GIR_EraseRootFromParent_Done,
     /* 2182020 */   // Label 28704: @2182020
     /* 2182020 */   GIM_Try, /*On fail goto*//*Label 28705*/ GIMT_Encode4(2182111), // Rule ID 18692 //
     /* 2182025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2182028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2182042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182048 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182063 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182067 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182071 */     // MIs[0] round
     /* 2182071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182074 */     // MIs[0] policy
     /* 2182074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182077 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182084 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2182087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182091 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182093 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182095 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182097 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182107 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182110 */     // GIR_Coverage, 18692,
     /* 2182110 */     GIR_EraseRootFromParent_Done,
     /* 2182111 */   // Label 28705: @2182111
     /* 2182111 */   GIM_Try, /*On fail goto*//*Label 28706*/ GIMT_Encode4(2182202), // Rule ID 18693 //
     /* 2182116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2182119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2182127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2182130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2182133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2182136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182139 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182158 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182162 */     // MIs[0] round
     /* 2182162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182165 */     // MIs[0] policy
     /* 2182165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M1_E32_MASK),
     /* 2182178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182182 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182184 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182186 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182188 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182198 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182201 */     // GIR_Coverage, 18693,
     /* 2182201 */     GIR_EraseRootFromParent_Done,
     /* 2182202 */   // Label 28706: @2182202
     /* 2182202 */   GIM_Try, /*On fail goto*//*Label 28707*/ GIMT_Encode4(2182293), // Rule ID 18696 //
     /* 2182207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2182210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2182218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2182221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2182224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182230 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182245 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182249 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182253 */     // MIs[0] round
     /* 2182253 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182256 */     // MIs[0] policy
     /* 2182256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182266 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2182269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182275 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182277 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182279 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182289 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182292 */     // GIR_Coverage, 18696,
     /* 2182292 */     GIR_EraseRootFromParent_Done,
     /* 2182293 */   // Label 28707: @2182293
     /* 2182293 */   GIM_Try, /*On fail goto*//*Label 28708*/ GIMT_Encode4(2182384), // Rule ID 18697 //
     /* 2182298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2182301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2182309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2182312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2182315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2182318 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182321 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2182328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182340 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182344 */     // MIs[0] round
     /* 2182344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182347 */     // MIs[0] policy
     /* 2182347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182357 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M2_E32_MASK),
     /* 2182360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182366 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182368 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182370 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182380 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182383 */     // GIR_Coverage, 18697,
     /* 2182383 */     GIR_EraseRootFromParent_Done,
     /* 2182384 */   // Label 28708: @2182384
     /* 2182384 */   GIM_Try, /*On fail goto*//*Label 28709*/ GIMT_Encode4(2182475), // Rule ID 18700 //
     /* 2182389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2182392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2182400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2182403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2182406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182412 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182431 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182435 */     // MIs[0] round
     /* 2182435 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182438 */     // MIs[0] policy
     /* 2182438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182448 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2182451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182453 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182455 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182457 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182459 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182461 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182471 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182474 */     // GIR_Coverage, 18700,
     /* 2182474 */     GIR_EraseRootFromParent_Done,
     /* 2182475 */   // Label 28709: @2182475
     /* 2182475 */   GIM_Try, /*On fail goto*//*Label 28710*/ GIMT_Encode4(2182566), // Rule ID 18701 //
     /* 2182480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2182483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2182491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2182494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2182497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2182500 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2182503 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2182510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2182514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182518 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2182522 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182526 */     // MIs[0] round
     /* 2182526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182529 */     // MIs[0] policy
     /* 2182529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182539 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VV_M4_E32_MASK),
     /* 2182542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182546 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182548 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182550 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182552 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2182562 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182564 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182565 */     // GIR_Coverage, 18701,
     /* 2182565 */     GIR_EraseRootFromParent_Done,
     /* 2182566 */   // Label 28710: @2182566
     /* 2182566 */   GIM_Try, /*On fail goto*//*Label 28711*/ GIMT_Encode4(2182657), // Rule ID 18704 //
     /* 2182571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2182591 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182594 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182613 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182617 */     // MIs[0] round
     /* 2182617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182620 */     // MIs[0] policy
     /* 2182620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182623 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182630 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2182633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182639 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182641 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182643 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182653 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182656 */     // GIR_Coverage, 18704,
     /* 2182656 */     GIR_EraseRootFromParent_Done,
     /* 2182657 */   // Label 28711: @2182657
     /* 2182657 */   GIM_Try, /*On fail goto*//*Label 28712*/ GIMT_Encode4(2182748), // Rule ID 18705 //
     /* 2182662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2182673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2182676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2182682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2182685 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182704 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182708 */     // MIs[0] round
     /* 2182708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182711 */     // MIs[0] policy
     /* 2182711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182721 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF4_E16_MASK),
     /* 2182724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182730 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182732 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182734 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182744 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182747 */     // GIR_Coverage, 18705,
     /* 2182747 */     GIR_EraseRootFromParent_Done,
     /* 2182748 */   // Label 28712: @2182748
     /* 2182748 */   GIM_Try, /*On fail goto*//*Label 28713*/ GIMT_Encode4(2182839), // Rule ID 18708 //
     /* 2182753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182776 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182795 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182799 */     // MIs[0] round
     /* 2182799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182802 */     // MIs[0] policy
     /* 2182802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182812 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2182815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182819 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182821 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182823 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182825 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182835 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182838 */     // GIR_Coverage, 18708,
     /* 2182838 */     GIR_EraseRootFromParent_Done,
     /* 2182839 */   // Label 28713: @2182839
     /* 2182839 */   GIM_Try, /*On fail goto*//*Label 28714*/ GIMT_Encode4(2182930), // Rule ID 18709 //
     /* 2182844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2182847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2182855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2182858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2182864 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2182867 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2182870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2182874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182890 */     // MIs[0] round
     /* 2182890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182893 */     // MIs[0] policy
     /* 2182893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182903 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11239:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2182903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_MF2_E16_MASK),
     /* 2182906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2182910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2182912 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2182914 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2182916 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2182918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2182923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2182926 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2182928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2182929 */     // GIR_Coverage, 18709,
     /* 2182929 */     GIR_EraseRootFromParent_Done,
     /* 2182930 */   // Label 28714: @2182930
     /* 2182930 */   GIM_Try, /*On fail goto*//*Label 28715*/ GIMT_Encode4(2183021), // Rule ID 18712 //
     /* 2182935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2182938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2182943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2182946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2182949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2182952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2182955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2182958 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2182961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2182965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2182969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2182973 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2182977 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2182981 */     // MIs[0] round
     /* 2182981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2182984 */     // MIs[0] policy
     /* 2182984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2182987 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2182994 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2182994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2182997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2182999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183003 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183005 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183007 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183017 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183020 */     // GIR_Coverage, 18712,
     /* 2183020 */     GIR_EraseRootFromParent_Done,
     /* 2183021 */   // Label 28715: @2183021
     /* 2183021 */   GIM_Try, /*On fail goto*//*Label 28716*/ GIMT_Encode4(2183112), // Rule ID 18713 //
     /* 2183026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2183029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2183037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2183040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183043 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2183046 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183049 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183064 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183068 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183072 */     // MIs[0] round
     /* 2183072 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183075 */     // MIs[0] policy
     /* 2183075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183085 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M1_E16_MASK),
     /* 2183088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183090 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183092 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183094 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183096 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183098 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183108 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183111 */     // GIR_Coverage, 18713,
     /* 2183111 */     GIR_EraseRootFromParent_Done,
     /* 2183112 */   // Label 28716: @2183112
     /* 2183112 */   GIM_Try, /*On fail goto*//*Label 28717*/ GIMT_Encode4(2183203), // Rule ID 18716 //
     /* 2183117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2183120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2183137 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183140 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183159 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183163 */     // MIs[0] round
     /* 2183163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183166 */     // MIs[0] policy
     /* 2183166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183169 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183176 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2183179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183183 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183185 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183187 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183189 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183199 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183202 */     // GIR_Coverage, 18716,
     /* 2183202 */     GIR_EraseRootFromParent_Done,
     /* 2183203 */   // Label 28717: @2183203
     /* 2183203 */   GIM_Try, /*On fail goto*//*Label 28718*/ GIMT_Encode4(2183294), // Rule ID 18717 //
     /* 2183208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2183211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2183219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2183222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2183228 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2183231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183250 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183254 */     // MIs[0] round
     /* 2183254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183257 */     // MIs[0] policy
     /* 2183257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183267 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M2_E16_MASK),
     /* 2183270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183274 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183276 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183278 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183280 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183282 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183290 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183293 */     // GIR_Coverage, 18717,
     /* 2183293 */     GIR_EraseRootFromParent_Done,
     /* 2183294 */   // Label 28718: @2183294
     /* 2183294 */   GIM_Try, /*On fail goto*//*Label 28719*/ GIMT_Encode4(2183385), // Rule ID 18720 //
     /* 2183299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2183302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2183319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183322 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183341 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183345 */     // MIs[0] round
     /* 2183345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183348 */     // MIs[0] policy
     /* 2183348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183358 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2183361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183363 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183367 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183369 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183371 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183381 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183384 */     // GIR_Coverage, 18720,
     /* 2183384 */     GIR_EraseRootFromParent_Done,
     /* 2183385 */   // Label 28719: @2183385
     /* 2183385 */   GIM_Try, /*On fail goto*//*Label 28720*/ GIMT_Encode4(2183476), // Rule ID 18721 //
     /* 2183390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2183393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2183401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2183404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2183407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2183410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2183413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2183420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2183424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2183428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183432 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183436 */     // MIs[0] round
     /* 2183436 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183439 */     // MIs[0] policy
     /* 2183439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183442 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183449 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR16_M4_E16_MASK),
     /* 2183452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183458 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183460 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183462 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2183472 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183475 */     // GIR_Coverage, 18721,
     /* 2183475 */     GIR_EraseRootFromParent_Done,
     /* 2183476 */   // Label 28720: @2183476
     /* 2183476 */   GIM_Try, /*On fail goto*//*Label 28721*/ GIMT_Encode4(2183567), // Rule ID 18724 //
     /* 2183481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2183492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2183495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183504 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183523 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183527 */     // MIs[0] round
     /* 2183527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183530 */     // MIs[0] policy
     /* 2183530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183540 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2183543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183547 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183549 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183551 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183553 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183563 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183566 */     // GIR_Coverage, 18724,
     /* 2183566 */     GIR_EraseRootFromParent_Done,
     /* 2183567 */   // Label 28721: @2183567
     /* 2183567 */   GIM_Try, /*On fail goto*//*Label 28722*/ GIMT_Encode4(2183658), // Rule ID 18725 //
     /* 2183572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2183583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2183586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2183592 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2183595 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2183602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183610 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183614 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183618 */     // MIs[0] round
     /* 2183618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183621 */     // MIs[0] policy
     /* 2183621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183624 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183631 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11239:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_MF2_E32_MASK),
     /* 2183634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183638 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183640 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183642 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183644 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183654 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183657 */     // GIR_Coverage, 18725,
     /* 2183657 */     GIR_EraseRootFromParent_Done,
     /* 2183658 */   // Label 28722: @2183658
     /* 2183658 */   GIM_Try, /*On fail goto*//*Label 28723*/ GIMT_Encode4(2183749), // Rule ID 18728 //
     /* 2183663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2183683 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183686 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183709 */     // MIs[0] round
     /* 2183709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183712 */     // MIs[0] policy
     /* 2183712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183722 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2183725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183729 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183731 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183733 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183735 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183745 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183748 */     // GIR_Coverage, 18728,
     /* 2183748 */     GIR_EraseRootFromParent_Done,
     /* 2183749 */   // Label 28723: @2183749
     /* 2183749 */   GIM_Try, /*On fail goto*//*Label 28724*/ GIMT_Encode4(2183840), // Rule ID 18729 //
     /* 2183754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2183765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2183768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2183774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2183777 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2183784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183792 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2183796 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183800 */     // MIs[0] round
     /* 2183800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183803 */     // MIs[0] policy
     /* 2183803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11239:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M1_E32_MASK),
     /* 2183816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183822 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183824 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183826 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183836 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183838 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183839 */     // GIR_Coverage, 18729,
     /* 2183839 */     GIR_EraseRootFromParent_Done,
     /* 2183840 */   // Label 28724: @2183840
     /* 2183840 */   GIM_Try, /*On fail goto*//*Label 28725*/ GIMT_Encode4(2183931), // Rule ID 18732 //
     /* 2183845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2183848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183865 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183868 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2183871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183887 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183891 */     // MIs[0] round
     /* 2183891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183894 */     // MIs[0] policy
     /* 2183894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183897 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183904 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2183904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2183907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2183909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2183911 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2183913 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2183915 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2183917 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2183919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2183924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2183927 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2183929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2183930 */     // GIR_Coverage, 18732,
     /* 2183930 */     GIR_EraseRootFromParent_Done,
     /* 2183931 */   // Label 28725: @2183931
     /* 2183931 */   GIM_Try, /*On fail goto*//*Label 28726*/ GIMT_Encode4(2184022), // Rule ID 18733 //
     /* 2183936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2183939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2183944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2183947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2183950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2183953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2183956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2183959 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2183962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2183966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2183970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2183974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2183978 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2183982 */     // MIs[0] round
     /* 2183982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2183985 */     // MIs[0] policy
     /* 2183985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2183988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2183995 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11239:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2183995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M2_E32_MASK),
     /* 2183998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184004 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184006 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184008 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184018 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184021 */     // GIR_Coverage, 18733,
     /* 2184021 */     GIR_EraseRootFromParent_Done,
     /* 2184022 */   // Label 28726: @2184022
     /* 2184022 */   GIM_Try, /*On fail goto*//*Label 28727*/ GIMT_Encode4(2184113), // Rule ID 18736 //
     /* 2184027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2184030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2184035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2184038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2184041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2184047 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184069 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184073 */     // MIs[0] round
     /* 2184073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184076 */     // MIs[0] policy
     /* 2184076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184079 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184086 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2184089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184095 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184097 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184099 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184109 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184112 */     // GIR_Coverage, 18736,
     /* 2184112 */     GIR_EraseRootFromParent_Done,
     /* 2184113 */   // Label 28727: @2184113
     /* 2184113 */   GIM_Try, /*On fail goto*//*Label 28728*/ GIMT_Encode4(2184204), // Rule ID 18737 //
     /* 2184118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2184121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmacc_mask),
     /* 2184126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2184129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2184132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2184135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2184138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184141 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2184156 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184160 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184164 */     // MIs[0] round
     /* 2184164 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184167 */     // MIs[0] policy
     /* 2184167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184177 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11239:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMACC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMACC_VFPR32_M4_E32_MASK),
     /* 2184180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184186 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184188 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184190 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2184200 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184203 */     // GIR_Coverage, 18737,
     /* 2184203 */     GIR_EraseRootFromParent_Done,
     /* 2184204 */   // Label 28728: @2184204
     /* 2184204 */   GIM_Try, /*On fail goto*//*Label 28729*/ GIMT_Encode4(2184295), // Rule ID 18740 //
     /* 2184209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2184226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184229 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184251 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184255 */     // MIs[0] round
     /* 2184255 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184258 */     // MIs[0] policy
     /* 2184258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184268 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2184271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184277 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184279 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184281 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184291 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184294 */     // GIR_Coverage, 18740,
     /* 2184294 */     GIR_EraseRootFromParent_Done,
     /* 2184295 */   // Label 28729: @2184295
     /* 2184295 */   GIM_Try, /*On fail goto*//*Label 28730*/ GIMT_Encode4(2184386), // Rule ID 18741 //
     /* 2184300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2184311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2184314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2184317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2184320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2184323 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184338 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184342 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184346 */     // MIs[0] round
     /* 2184346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184349 */     // MIs[0] policy
     /* 2184349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184359 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF4_E16_MASK),
     /* 2184362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184364 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184366 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184368 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184370 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184372 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184382 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184385 */     // GIR_Coverage, 18741,
     /* 2184385 */     GIR_EraseRootFromParent_Done,
     /* 2184386 */   // Label 28730: @2184386
     /* 2184386 */   GIM_Try, /*On fail goto*//*Label 28731*/ GIMT_Encode4(2184477), // Rule ID 18744 //
     /* 2184391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184411 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184414 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184429 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184433 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184437 */     // MIs[0] round
     /* 2184437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184440 */     // MIs[0] policy
     /* 2184440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184443 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184450 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2184453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184457 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184459 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184461 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184463 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184473 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184476 */     // GIR_Coverage, 18744,
     /* 2184476 */     GIR_EraseRootFromParent_Done,
     /* 2184477 */   // Label 28731: @2184477
     /* 2184477 */   GIM_Try, /*On fail goto*//*Label 28732*/ GIMT_Encode4(2184568), // Rule ID 18745 //
     /* 2184482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2184493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2184496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2184499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2184502 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2184505 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2184512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184524 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184528 */     // MIs[0] round
     /* 2184528 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184531 */     // MIs[0] policy
     /* 2184531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184541 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E16_MASK),
     /* 2184544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184550 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184552 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184554 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184564 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184567 */     // GIR_Coverage, 18745,
     /* 2184567 */     GIR_EraseRootFromParent_Done,
     /* 2184568 */   // Label 28732: @2184568
     /* 2184568 */   GIM_Try, /*On fail goto*//*Label 28733*/ GIMT_Encode4(2184659), // Rule ID 18748 //
     /* 2184573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2184584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2184587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184593 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184596 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184611 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184615 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184619 */     // MIs[0] round
     /* 2184619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184622 */     // MIs[0] policy
     /* 2184622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184625 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184632 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2184635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184639 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184641 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184643 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184645 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184655 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184658 */     // GIR_Coverage, 18748,
     /* 2184658 */     GIR_EraseRootFromParent_Done,
     /* 2184659 */   // Label 28733: @2184659
     /* 2184659 */   GIM_Try, /*On fail goto*//*Label 28734*/ GIMT_Encode4(2184750), // Rule ID 18749 //
     /* 2184664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2184675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2184678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2184681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2184684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2184687 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2184694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184702 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2184706 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184710 */     // MIs[0] round
     /* 2184710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184713 */     // MIs[0] policy
     /* 2184713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184723 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E16_MASK),
     /* 2184726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184730 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184732 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184734 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184736 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184746 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184749 */     // GIR_Coverage, 18749,
     /* 2184749 */     GIR_EraseRootFromParent_Done,
     /* 2184750 */   // Label 28734: @2184750
     /* 2184750 */   GIM_Try, /*On fail goto*//*Label 28735*/ GIMT_Encode4(2184841), // Rule ID 18752 //
     /* 2184755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2184766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2184769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184778 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184801 */     // MIs[0] round
     /* 2184801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184804 */     // MIs[0] policy
     /* 2184804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184814 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2184817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184821 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184823 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184825 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184827 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184837 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184840 */     // GIR_Coverage, 18752,
     /* 2184840 */     GIR_EraseRootFromParent_Done,
     /* 2184841 */   // Label 28735: @2184841
     /* 2184841 */   GIM_Try, /*On fail goto*//*Label 28736*/ GIMT_Encode4(2184932), // Rule ID 18753 //
     /* 2184846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2184849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2184857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2184860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2184863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2184866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2184869 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2184872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2184876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184884 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2184888 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184892 */     // MIs[0] round
     /* 2184892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184895 */     // MIs[0] policy
     /* 2184895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184905 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2184905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E16_MASK),
     /* 2184908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2184910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2184912 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2184914 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2184916 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2184918 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2184920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2184925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2184928 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2184930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2184931 */     // GIR_Coverage, 18753,
     /* 2184931 */     GIR_EraseRootFromParent_Done,
     /* 2184932 */   // Label 28736: @2184932
     /* 2184932 */   GIM_Try, /*On fail goto*//*Label 28737*/ GIMT_Encode4(2185023), // Rule ID 18756 //
     /* 2184937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2184940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2184945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2184948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2184951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2184954 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2184957 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2184960 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2184963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2184967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2184971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184975 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2184979 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2184983 */     // MIs[0] round
     /* 2184983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2184986 */     // MIs[0] policy
     /* 2184986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2184989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2184996 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2184996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2184999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185005 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185007 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185009 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185011 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185019 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185021 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185022 */     // GIR_Coverage, 18756,
     /* 2185022 */     GIR_EraseRootFromParent_Done,
     /* 2185023 */   // Label 28737: @2185023
     /* 2185023 */   GIM_Try, /*On fail goto*//*Label 28738*/ GIMT_Encode4(2185114), // Rule ID 18757 //
     /* 2185028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2185039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2185042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2185045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2185048 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2185051 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185066 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185070 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185074 */     // MIs[0] round
     /* 2185074 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185077 */     // MIs[0] policy
     /* 2185077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185080 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185087 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E16_MASK),
     /* 2185090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185094 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185096 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185098 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185100 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185110 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185113 */     // GIR_Coverage, 18757,
     /* 2185113 */     GIR_EraseRootFromParent_Done,
     /* 2185114 */   // Label 28738: @2185114
     /* 2185114 */   GIM_Try, /*On fail goto*//*Label 28739*/ GIMT_Encode4(2185205), // Rule ID 18760 //
     /* 2185119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2185122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2185130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2185133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2185136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2185139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185142 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185157 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185161 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185165 */     // MIs[0] round
     /* 2185165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185168 */     // MIs[0] policy
     /* 2185168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185178 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2185181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185187 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185189 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185191 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185201 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185204 */     // GIR_Coverage, 18760,
     /* 2185204 */     GIR_EraseRootFromParent_Done,
     /* 2185205 */   // Label 28739: @2185205
     /* 2185205 */   GIM_Try, /*On fail goto*//*Label 28740*/ GIMT_Encode4(2185296), // Rule ID 18761 //
     /* 2185210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2185221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2185224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2185227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2185230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185233 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185244 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185248 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185252 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185256 */     // MIs[0] round
     /* 2185256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185259 */     // MIs[0] policy
     /* 2185259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185262 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185269 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_MF2_E32_MASK),
     /* 2185272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185276 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185278 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185280 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185282 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185292 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185295 */     // GIR_Coverage, 18761,
     /* 2185295 */     GIR_EraseRootFromParent_Done,
     /* 2185296 */   // Label 28740: @2185296
     /* 2185296 */   GIM_Try, /*On fail goto*//*Label 28741*/ GIMT_Encode4(2185387), // Rule ID 18764 //
     /* 2185301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2185304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2185318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2185321 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185324 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185347 */     // MIs[0] round
     /* 2185347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185350 */     // MIs[0] policy
     /* 2185350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185360 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2185363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185369 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185371 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185373 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185383 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185386 */     // GIR_Coverage, 18764,
     /* 2185386 */     GIR_EraseRootFromParent_Done,
     /* 2185387 */   // Label 28741: @2185387
     /* 2185387 */   GIM_Try, /*On fail goto*//*Label 28742*/ GIMT_Encode4(2185478), // Rule ID 18765 //
     /* 2185392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2185403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2185406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2185409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2185412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2185415 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2185422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185434 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185438 */     // MIs[0] round
     /* 2185438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185441 */     // MIs[0] policy
     /* 2185441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185451 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M1_E32_MASK),
     /* 2185454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185458 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185460 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185462 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185464 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185474 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185477 */     // GIR_Coverage, 18765,
     /* 2185477 */     GIR_EraseRootFromParent_Done,
     /* 2185478 */   // Label 28742: @2185478
     /* 2185478 */   GIM_Try, /*On fail goto*//*Label 28743*/ GIMT_Encode4(2185569), // Rule ID 18768 //
     /* 2185483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2185486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185503 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185506 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185521 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185525 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185529 */     // MIs[0] round
     /* 2185529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185532 */     // MIs[0] policy
     /* 2185532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185542 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2185545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185549 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185551 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185553 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185555 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185565 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185568 */     // GIR_Coverage, 18768,
     /* 2185568 */     GIR_EraseRootFromParent_Done,
     /* 2185569 */   // Label 28743: @2185569
     /* 2185569 */   GIM_Try, /*On fail goto*//*Label 28744*/ GIMT_Encode4(2185660), // Rule ID 18769 //
     /* 2185574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2185585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2185588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2185591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2185594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2185597 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2185604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185612 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2185616 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185620 */     // MIs[0] round
     /* 2185620 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185623 */     // MIs[0] policy
     /* 2185623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185633 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M2_E32_MASK),
     /* 2185636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185638 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185640 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185642 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185644 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185646 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185656 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185659 */     // GIR_Coverage, 18769,
     /* 2185659 */     GIR_EraseRootFromParent_Done,
     /* 2185660 */   // Label 28744: @2185660
     /* 2185660 */   GIM_Try, /*On fail goto*//*Label 28745*/ GIMT_Encode4(2185751), // Rule ID 18772 //
     /* 2185665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2185668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185688 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185703 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185707 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185711 */     // MIs[0] round
     /* 2185711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185714 */     // MIs[0] policy
     /* 2185714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185717 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185724 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2185727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185731 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185733 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185735 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185737 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185747 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185749 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185750 */     // GIR_Coverage, 18772,
     /* 2185750 */     GIR_EraseRootFromParent_Done,
     /* 2185751 */   // Label 28745: @2185751
     /* 2185751 */   GIM_Try, /*On fail goto*//*Label 28746*/ GIMT_Encode4(2185842), // Rule ID 18773 //
     /* 2185756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2185759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2185767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2185770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2185773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2185776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2185779 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2185786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2185790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2185798 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185802 */     // MIs[0] round
     /* 2185802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185805 */     // MIs[0] policy
     /* 2185805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185815 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VV_M4_E32_MASK),
     /* 2185818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185824 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185826 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185828 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2185838 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185841 */     // GIR_Coverage, 18773,
     /* 2185841 */     GIR_EraseRootFromParent_Done,
     /* 2185842 */   // Label 28746: @2185842
     /* 2185842 */   GIM_Try, /*On fail goto*//*Label 28747*/ GIMT_Encode4(2185933), // Rule ID 18776 //
     /* 2185847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2185850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2185858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2185861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2185867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185870 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2185873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185885 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185889 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185893 */     // MIs[0] round
     /* 2185893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185896 */     // MIs[0] policy
     /* 2185896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185906 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2185906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2185909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2185911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2185913 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2185915 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2185917 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2185919 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2185921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2185926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2185929 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2185931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2185932 */     // GIR_Coverage, 18776,
     /* 2185932 */     GIR_EraseRootFromParent_Done,
     /* 2185933 */   // Label 28747: @2185933
     /* 2185933 */   GIM_Try, /*On fail goto*//*Label 28748*/ GIMT_Encode4(2186024), // Rule ID 18777 //
     /* 2185938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2185941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2185946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2185949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2185952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2185955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2185958 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2185961 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2185964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2185968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2185976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2185980 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2185984 */     // MIs[0] round
     /* 2185984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2185987 */     // MIs[0] policy
     /* 2185987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2185990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2185997 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2185997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF4_E16_MASK),
     /* 2186000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186004 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186006 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186008 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186010 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186020 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186023 */     // GIR_Coverage, 18777,
     /* 2186023 */     GIR_EraseRootFromParent_Done,
     /* 2186024 */   // Label 28748: @2186024
     /* 2186024 */   GIM_Try, /*On fail goto*//*Label 28749*/ GIMT_Encode4(2186115), // Rule ID 18780 //
     /* 2186029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2186043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186052 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186067 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186071 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186075 */     // MIs[0] round
     /* 2186075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186078 */     // MIs[0] policy
     /* 2186078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186088 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2186091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186097 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186099 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186101 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186111 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186114 */     // GIR_Coverage, 18780,
     /* 2186114 */     GIR_EraseRootFromParent_Done,
     /* 2186115 */   // Label 28749: @2186115
     /* 2186115 */   GIM_Try, /*On fail goto*//*Label 28750*/ GIMT_Encode4(2186206), // Rule ID 18781 //
     /* 2186120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2186123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2186131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2186134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2186140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186143 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186162 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186166 */     // MIs[0] round
     /* 2186166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186169 */     // MIs[0] policy
     /* 2186169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186172 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186179 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11235:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_MF2_E16_MASK),
     /* 2186182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186188 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186190 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186192 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186202 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186205 */     // GIR_Coverage, 18781,
     /* 2186205 */     GIR_EraseRootFromParent_Done,
     /* 2186206 */   // Label 28750: @2186206
     /* 2186206 */   GIM_Try, /*On fail goto*//*Label 28751*/ GIMT_Encode4(2186297), // Rule ID 18784 //
     /* 2186211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2186222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2186225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186231 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186234 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186249 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186253 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186257 */     // MIs[0] round
     /* 2186257 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186260 */     // MIs[0] policy
     /* 2186260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186270 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2186273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186277 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186279 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186281 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186283 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186293 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186296 */     // GIR_Coverage, 18784,
     /* 2186296 */     GIR_EraseRootFromParent_Done,
     /* 2186297 */   // Label 28751: @2186297
     /* 2186297 */   GIM_Try, /*On fail goto*//*Label 28752*/ GIMT_Encode4(2186388), // Rule ID 18785 //
     /* 2186302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2186305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2186313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2186316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2186322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2186325 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186340 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186344 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186348 */     // MIs[0] round
     /* 2186348 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186351 */     // MIs[0] policy
     /* 2186351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M1_E16_MASK),
     /* 2186364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186368 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186370 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186372 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186374 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186384 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186387 */     // GIR_Coverage, 18785,
     /* 2186387 */     GIR_EraseRootFromParent_Done,
     /* 2186388 */   // Label 28752: @2186388
     /* 2186388 */   GIM_Try, /*On fail goto*//*Label 28753*/ GIMT_Encode4(2186479), // Rule ID 18788 //
     /* 2186393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2186404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2186407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2186413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186416 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186435 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186439 */     // MIs[0] round
     /* 2186439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186442 */     // MIs[0] policy
     /* 2186442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186445 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186452 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2186455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186461 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186463 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186465 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186475 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186478 */     // GIR_Coverage, 18788,
     /* 2186478 */     GIR_EraseRootFromParent_Done,
     /* 2186479 */   // Label 28753: @2186479
     /* 2186479 */   GIM_Try, /*On fail goto*//*Label 28754*/ GIMT_Encode4(2186570), // Rule ID 18789 //
     /* 2186484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2186487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2186495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2186498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2186504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2186507 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2186514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186526 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186530 */     // MIs[0] round
     /* 2186530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186533 */     // MIs[0] policy
     /* 2186533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186543 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M2_E16_MASK),
     /* 2186546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186550 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186552 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186554 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186556 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186566 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186569 */     // GIR_Coverage, 18789,
     /* 2186569 */     GIR_EraseRootFromParent_Done,
     /* 2186570 */   // Label 28754: @2186570
     /* 2186570 */   GIM_Try, /*On fail goto*//*Label 28755*/ GIMT_Encode4(2186661), // Rule ID 18792 //
     /* 2186575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2186578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2186595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186598 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186613 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186617 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186621 */     // MIs[0] round
     /* 2186621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186624 */     // MIs[0] policy
     /* 2186624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186634 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2186637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186641 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186643 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186645 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186647 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186657 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186660 */     // GIR_Coverage, 18792,
     /* 2186660 */     GIR_EraseRootFromParent_Done,
     /* 2186661 */   // Label 28755: @2186661
     /* 2186661 */   GIM_Try, /*On fail goto*//*Label 28756*/ GIMT_Encode4(2186752), // Rule ID 18793 //
     /* 2186666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2186669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2186677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2186680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2186683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2186686 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2186689 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2186696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2186700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2186704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2186708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186712 */     // MIs[0] round
     /* 2186712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186715 */     // MIs[0] policy
     /* 2186715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186725 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR16_M4_E16_MASK),
     /* 2186728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186732 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186734 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186736 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186738 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2186748 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186751 */     // GIR_Coverage, 18793,
     /* 2186751 */     GIR_EraseRootFromParent_Done,
     /* 2186752 */   // Label 28756: @2186752
     /* 2186752 */   GIM_Try, /*On fail goto*//*Label 28757*/ GIMT_Encode4(2186843), // Rule ID 18796 //
     /* 2186757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2186768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2186771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186777 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186780 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186799 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186803 */     // MIs[0] round
     /* 2186803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186806 */     // MIs[0] policy
     /* 2186806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186809 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186816 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2186819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186825 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186827 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186829 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186839 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186842 */     // GIR_Coverage, 18796,
     /* 2186842 */     GIR_EraseRootFromParent_Done,
     /* 2186843 */   // Label 28757: @2186843
     /* 2186843 */   GIM_Try, /*On fail goto*//*Label 28758*/ GIMT_Encode4(2186934), // Rule ID 18797 //
     /* 2186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2186851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2186859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2186862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2186868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2186871 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2186874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2186878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186886 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186890 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186894 */     // MIs[0] round
     /* 2186894 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186897 */     // MIs[0] policy
     /* 2186897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186907 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11235:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2186907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_MF2_E32_MASK),
     /* 2186910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2186912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2186914 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2186916 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2186918 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2186920 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2186922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2186927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2186930 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2186932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2186933 */     // GIR_Coverage, 18797,
     /* 2186933 */     GIR_EraseRootFromParent_Done,
     /* 2186934 */   // Label 28758: @2186934
     /* 2186934 */   GIM_Try, /*On fail goto*//*Label 28759*/ GIMT_Encode4(2187025), // Rule ID 18800 //
     /* 2186939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2186942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2186947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2186950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2186953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2186956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2186959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2186962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2186965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2186969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2186973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2186977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2186981 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2186985 */     // MIs[0] round
     /* 2186985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2186988 */     // MIs[0] policy
     /* 2186988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2186991 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2186998 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2186998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2187001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187005 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187007 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187009 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187011 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187021 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187024 */     // GIR_Coverage, 18800,
     /* 2187024 */     GIR_EraseRootFromParent_Done,
     /* 2187025 */   // Label 28759: @2187025
     /* 2187025 */   GIM_Try, /*On fail goto*//*Label 28760*/ GIMT_Encode4(2187116), // Rule ID 18801 //
     /* 2187030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2187033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2187038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2187041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2187044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2187050 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187053 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187068 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187072 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187076 */     // MIs[0] round
     /* 2187076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187079 */     // MIs[0] policy
     /* 2187079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187082 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187089 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11235:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M1_E32_MASK),
     /* 2187092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187096 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187098 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187100 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187102 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187112 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187115 */     // GIR_Coverage, 18801,
     /* 2187115 */     GIR_EraseRootFromParent_Done,
     /* 2187116 */   // Label 28760: @2187116
     /* 2187116 */   GIM_Try, /*On fail goto*//*Label 28761*/ GIMT_Encode4(2187207), // Rule ID 18804 //
     /* 2187121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2187124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2187129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2187132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2187135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187141 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187163 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187167 */     // MIs[0] round
     /* 2187167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187170 */     // MIs[0] policy
     /* 2187170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187180 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2187183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187189 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187191 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187193 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187203 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187205 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187206 */     // GIR_Coverage, 18804,
     /* 2187206 */     GIR_EraseRootFromParent_Done,
     /* 2187207 */   // Label 28761: @2187207
     /* 2187207 */   GIM_Try, /*On fail goto*//*Label 28762*/ GIMT_Encode4(2187298), // Rule ID 18805 //
     /* 2187212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2187215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2187220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2187223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2187226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2187232 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187235 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2187242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187254 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187258 */     // MIs[0] round
     /* 2187258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187261 */     // MIs[0] policy
     /* 2187261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187264 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187271 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11235:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M2_E32_MASK),
     /* 2187274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187278 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187280 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187282 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187284 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187294 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187297 */     // GIR_Coverage, 18805,
     /* 2187297 */     GIR_EraseRootFromParent_Done,
     /* 2187298 */   // Label 28762: @2187298
     /* 2187298 */   GIM_Try, /*On fail goto*//*Label 28763*/ GIMT_Encode4(2187389), // Rule ID 18808 //
     /* 2187303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2187306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2187311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2187314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2187317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2187323 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187326 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187345 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187349 */     // MIs[0] round
     /* 2187349 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187352 */     // MIs[0] policy
     /* 2187352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187355 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187362 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2187365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187369 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187371 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187373 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187375 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187385 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187388 */     // GIR_Coverage, 18808,
     /* 2187388 */     GIR_EraseRootFromParent_Done,
     /* 2187389 */   // Label 28763: @2187389
     /* 2187389 */   GIM_Try, /*On fail goto*//*Label 28764*/ GIMT_Encode4(2187480), // Rule ID 18809 //
     /* 2187394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2187397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwmsac_mask),
     /* 2187402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2187405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2187408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2187411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2187414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2187417 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2187424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2187428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2187432 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2187436 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187440 */     // MIs[0] round
     /* 2187440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187443 */     // MIs[0] policy
     /* 2187443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187446 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187453 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11235:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWMSAC_VFPR32_M4_E32_MASK),
     /* 2187456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187462 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187464 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187466 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2187476 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187479 */     // GIR_Coverage, 18809,
     /* 2187479 */     GIR_EraseRootFromParent_Done,
     /* 2187480 */   // Label 28764: @2187480
     /* 2187480 */   GIM_Try, /*On fail goto*//*Label 28765*/ GIMT_Encode4(2187571), // Rule ID 18812 //
     /* 2187485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2187502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2187505 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187508 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187527 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187531 */     // MIs[0] round
     /* 2187531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187534 */     // MIs[0] policy
     /* 2187534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187544 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2187547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187553 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187555 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187557 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187567 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187570 */     // GIR_Coverage, 18812,
     /* 2187570 */     GIR_EraseRootFromParent_Done,
     /* 2187571 */   // Label 28765: @2187571
     /* 2187571 */   GIM_Try, /*On fail goto*//*Label 28766*/ GIMT_Encode4(2187662), // Rule ID 18813 //
     /* 2187576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2187587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2187590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2187593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2187596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2187599 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187614 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187618 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187622 */     // MIs[0] round
     /* 2187622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187625 */     // MIs[0] policy
     /* 2187625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187628 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187635 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF4_E16_MASK),
     /* 2187638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187642 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187644 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187646 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187648 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187658 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187661 */     // GIR_Coverage, 18813,
     /* 2187661 */     GIR_EraseRootFromParent_Done,
     /* 2187662 */   // Label 28766: @2187662
     /* 2187662 */   GIM_Try, /*On fail goto*//*Label 28767*/ GIMT_Encode4(2187753), // Rule ID 18816 //
     /* 2187667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2187684 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187687 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187690 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187709 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187713 */     // MIs[0] round
     /* 2187713 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187716 */     // MIs[0] policy
     /* 2187716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187719 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187726 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2187729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187733 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187735 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187737 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187739 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187749 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187752 */     // GIR_Coverage, 18816,
     /* 2187752 */     GIR_EraseRootFromParent_Done,
     /* 2187753 */   // Label 28767: @2187753
     /* 2187753 */   GIM_Try, /*On fail goto*//*Label 28768*/ GIMT_Encode4(2187844), // Rule ID 18817 //
     /* 2187758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2187769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2187772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2187775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2187778 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2187781 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2187788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187800 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187804 */     // MIs[0] round
     /* 2187804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187807 */     // MIs[0] policy
     /* 2187807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187810 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187817 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E16_MASK),
     /* 2187820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187824 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187826 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187828 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187830 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187840 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187843 */     // GIR_Coverage, 18817,
     /* 2187843 */     GIR_EraseRootFromParent_Done,
     /* 2187844 */   // Label 28768: @2187844
     /* 2187844 */   GIM_Try, /*On fail goto*//*Label 28769*/ GIMT_Encode4(2187935), // Rule ID 18820 //
     /* 2187849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2187852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2187866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187869 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187872 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2187875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187891 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187895 */     // MIs[0] round
     /* 2187895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187898 */     // MIs[0] policy
     /* 2187898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187908 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2187908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2187911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2187913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2187915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2187917 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2187919 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2187921 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2187923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2187928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2187931 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2187933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2187934 */     // GIR_Coverage, 18820,
     /* 2187934 */     GIR_EraseRootFromParent_Done,
     /* 2187935 */   // Label 28769: @2187935
     /* 2187935 */   GIM_Try, /*On fail goto*//*Label 28770*/ GIMT_Encode4(2188026), // Rule ID 18821 //
     /* 2187940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2187943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2187948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2187951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2187954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2187957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2187960 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2187963 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2187966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2187970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2187974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2187982 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2187986 */     // MIs[0] round
     /* 2187986 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2187989 */     // MIs[0] policy
     /* 2187989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2187992 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2187999 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2187999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E16_MASK),
     /* 2188002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188008 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188010 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188012 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188022 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188024 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188025 */     // GIR_Coverage, 18821,
     /* 2188025 */     GIR_EraseRootFromParent_Done,
     /* 2188026 */   // Label 28770: @2188026
     /* 2188026 */   GIM_Try, /*On fail goto*//*Label 28771*/ GIMT_Encode4(2188117), // Rule ID 18824 //
     /* 2188031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2188048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2188051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188054 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188073 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188077 */     // MIs[0] round
     /* 2188077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188080 */     // MIs[0] policy
     /* 2188080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188083 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188090 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2188093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188099 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188101 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188103 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188113 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188116 */     // GIR_Coverage, 18824,
     /* 2188116 */     GIR_EraseRootFromParent_Done,
     /* 2188117 */   // Label 28771: @2188117
     /* 2188117 */   GIM_Try, /*On fail goto*//*Label 28772*/ GIMT_Encode4(2188208), // Rule ID 18825 //
     /* 2188122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2188133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2188136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2188139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2188142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188145 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188164 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188168 */     // MIs[0] round
     /* 2188168 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188171 */     // MIs[0] policy
     /* 2188171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188181 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E16_MASK),
     /* 2188184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188190 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188192 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188194 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188204 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188207 */     // GIR_Coverage, 18825,
     /* 2188207 */     GIR_EraseRootFromParent_Done,
     /* 2188208 */   // Label 28772: @2188208
     /* 2188208 */   GIM_Try, /*On fail goto*//*Label 28773*/ GIMT_Encode4(2188299), // Rule ID 18828 //
     /* 2188213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2188216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2188230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188251 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188255 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188259 */     // MIs[0] round
     /* 2188259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188262 */     // MIs[0] policy
     /* 2188262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188265 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188272 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2188275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188279 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188281 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188283 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188285 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188287 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188295 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188298 */     // GIR_Coverage, 18828,
     /* 2188298 */     GIR_EraseRootFromParent_Done,
     /* 2188299 */   // Label 28773: @2188299
     /* 2188299 */   GIM_Try, /*On fail goto*//*Label 28774*/ GIMT_Encode4(2188390), // Rule ID 18829 //
     /* 2188304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2188307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2188315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2188318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2188321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2188324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2188327 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188342 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188346 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188350 */     // MIs[0] round
     /* 2188350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188353 */     // MIs[0] policy
     /* 2188353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188363 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E16_MASK),
     /* 2188366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188372 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188374 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188376 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188378 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2188386 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188389 */     // GIR_Coverage, 18829,
     /* 2188389 */     GIR_EraseRootFromParent_Done,
     /* 2188390 */   // Label 28774: @2188390
     /* 2188390 */   GIM_Try, /*On fail goto*//*Label 28775*/ GIMT_Encode4(2188481), // Rule ID 18832 //
     /* 2188395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2188406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2188409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2188412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2188415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188418 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188437 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188441 */     // MIs[0] round
     /* 2188441 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188444 */     // MIs[0] policy
     /* 2188444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188454 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2188457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188461 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188463 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188465 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188467 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188477 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188480 */     // GIR_Coverage, 18832,
     /* 2188480 */     GIR_EraseRootFromParent_Done,
     /* 2188481 */   // Label 28775: @2188481
     /* 2188481 */   GIM_Try, /*On fail goto*//*Label 28776*/ GIMT_Encode4(2188572), // Rule ID 18833 //
     /* 2188486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2188497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2188500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2188503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2188506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2188509 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2188516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188524 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188528 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188532 */     // MIs[0] round
     /* 2188532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188535 */     // MIs[0] policy
     /* 2188535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188538 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188545 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_MF2_E32_MASK),
     /* 2188548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188554 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188556 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188558 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188568 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188571 */     // GIR_Coverage, 18833,
     /* 2188571 */     GIR_EraseRootFromParent_Done,
     /* 2188572 */   // Label 28776: @2188572
     /* 2188572 */   GIM_Try, /*On fail goto*//*Label 28777*/ GIMT_Encode4(2188663), // Rule ID 18836 //
     /* 2188577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2188594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188597 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188600 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188623 */     // MIs[0] round
     /* 2188623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188626 */     // MIs[0] policy
     /* 2188626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2188639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188643 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188645 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188647 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188649 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188659 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188662 */     // GIR_Coverage, 18836,
     /* 2188662 */     GIR_EraseRootFromParent_Done,
     /* 2188663 */   // Label 28777: @2188663
     /* 2188663 */   GIM_Try, /*On fail goto*//*Label 28778*/ GIMT_Encode4(2188754), // Rule ID 18837 //
     /* 2188668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2188679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2188682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2188685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2188688 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2188691 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2188698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188706 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2188710 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188714 */     // MIs[0] round
     /* 2188714 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188717 */     // MIs[0] policy
     /* 2188717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188727 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M1_E32_MASK),
     /* 2188730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188734 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188736 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188738 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188740 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188750 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188753 */     // GIR_Coverage, 18837,
     /* 2188753 */     GIR_EraseRootFromParent_Done,
     /* 2188754 */   // Label 28778: @2188754
     /* 2188754 */   GIM_Try, /*On fail goto*//*Label 28779*/ GIMT_Encode4(2188845), // Rule ID 18840 //
     /* 2188759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2188776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188782 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188797 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188801 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188805 */     // MIs[0] round
     /* 2188805 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188808 */     // MIs[0] policy
     /* 2188808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188818 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2188818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2188821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188823 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188825 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188827 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188829 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188831 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188841 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188844 */     // GIR_Coverage, 18840,
     /* 2188844 */     GIR_EraseRootFromParent_Done,
     /* 2188845 */   // Label 28779: @2188845
     /* 2188845 */   GIM_Try, /*On fail goto*//*Label 28780*/ GIMT_Encode4(2188936), // Rule ID 18841 //
     /* 2188850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2188853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2188861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2188864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2188867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2188870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2188873 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2188876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2188880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2188892 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188896 */     // MIs[0] round
     /* 2188896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188899 */     // MIs[0] policy
     /* 2188899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2188909 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2188909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M2_E32_MASK),
     /* 2188912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2188914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2188916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2188918 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2188920 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2188922 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2188924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2188929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2188932 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2188934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2188935 */     // GIR_Coverage, 18841,
     /* 2188935 */     GIR_EraseRootFromParent_Done,
     /* 2188936 */   // Label 28780: @2188936
     /* 2188936 */   GIM_Try, /*On fail goto*//*Label 28781*/ GIMT_Encode4(2189027), // Rule ID 18844 //
     /* 2188941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2188944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2188949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2188952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2188955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2188958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2188961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2188964 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2188967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2188971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2188975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188979 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2188983 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2188987 */     // MIs[0] round
     /* 2188987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2188990 */     // MIs[0] policy
     /* 2188990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2188993 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189000 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2189003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189009 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189011 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189013 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189023 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189026 */     // GIR_Coverage, 18844,
     /* 2189026 */     GIR_EraseRootFromParent_Done,
     /* 2189027 */   // Label 28781: @2189027
     /* 2189027 */   GIM_Try, /*On fail goto*//*Label 28782*/ GIMT_Encode4(2189118), // Rule ID 18845 //
     /* 2189032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2189035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2189043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2189046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2189049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2189052 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189070 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189074 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189078 */     // MIs[0] round
     /* 2189078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189081 */     // MIs[0] policy
     /* 2189081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189091 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VV_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VV_M4_E32_MASK),
     /* 2189094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189100 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189102 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189104 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2189114 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189117 */     // GIR_Coverage, 18845,
     /* 2189117 */     GIR_EraseRootFromParent_Done,
     /* 2189118 */   // Label 28782: @2189118
     /* 2189118 */   GIM_Try, /*On fail goto*//*Label 28783*/ GIMT_Encode4(2189209), // Rule ID 18848 //
     /* 2189123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189143 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189146 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189165 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189169 */     // MIs[0] round
     /* 2189169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189172 */     // MIs[0] policy
     /* 2189172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189175 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189182 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2189185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189191 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189193 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189195 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189205 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189208 */     // GIR_Coverage, 18848,
     /* 2189208 */     GIR_EraseRootFromParent_Done,
     /* 2189209 */   // Label 28783: @2189209
     /* 2189209 */   GIM_Try, /*On fail goto*//*Label 28784*/ GIMT_Encode4(2189300), // Rule ID 18849 //
     /* 2189214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s32,
     /* 2189225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2189228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s16,
     /* 2189234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2189237 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189252 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189256 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189260 */     // MIs[0] round
     /* 2189260 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189263 */     // MIs[0] policy
     /* 2189263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189273 */     // (intrinsic_wo_chain:{ *:[nxv1f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF4_E16_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF4_E16_MASK),
     /* 2189276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189280 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189282 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189284 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189286 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189288 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189296 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189299 */     // GIR_Coverage, 18849,
     /* 2189299 */     GIR_EraseRootFromParent_Done,
     /* 2189300 */   // Label 28784: @2189300
     /* 2189300 */   GIM_Try, /*On fail goto*//*Label 28785*/ GIMT_Encode4(2189391), // Rule ID 18852 //
     /* 2189305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189325 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189328 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189347 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189351 */     // MIs[0] round
     /* 2189351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189354 */     // MIs[0] policy
     /* 2189354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189364 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2189367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189371 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189373 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189375 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189377 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189387 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189390 */     // GIR_Coverage, 18852,
     /* 2189390 */     GIR_EraseRootFromParent_Done,
     /* 2189391 */   // Label 28785: @2189391
     /* 2189391 */   GIM_Try, /*On fail goto*//*Label 28786*/ GIMT_Encode4(2189482), // Rule ID 18853 //
     /* 2189396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 2189407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2189410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 2189416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2189419 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2189426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189438 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189442 */     // MIs[0] round
     /* 2189442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189445 */     // MIs[0] policy
     /* 2189445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189455 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 11241:{ *:[iPTR] }, VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_MF2_E16_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_MF2_E16_MASK),
     /* 2189458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189464 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189466 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189468 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189478 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189481 */     // GIR_Coverage, 18853,
     /* 2189481 */     GIR_EraseRootFromParent_Done,
     /* 2189482 */   // Label 28786: @2189482
     /* 2189482 */   GIM_Try, /*On fail goto*//*Label 28787*/ GIMT_Encode4(2189573), // Rule ID 18856 //
     /* 2189487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189510 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189529 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189533 */     // MIs[0] round
     /* 2189533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189536 */     // MIs[0] policy
     /* 2189536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189546 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2189549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189555 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189557 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189559 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189569 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189572 */     // GIR_Coverage, 18856,
     /* 2189572 */     GIR_EraseRootFromParent_Done,
     /* 2189573 */   // Label 28787: @2189573
     /* 2189573 */   GIM_Try, /*On fail goto*//*Label 28788*/ GIMT_Encode4(2189664), // Rule ID 18857 //
     /* 2189578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 2189589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2189592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 2189598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2189601 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2189608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189616 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2189620 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189624 */     // MIs[0] round
     /* 2189624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189627 */     // MIs[0] policy
     /* 2189627 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189637 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M1_E16_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M1_E16_MASK),
     /* 2189640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189642 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189644 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189646 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189648 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189650 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189660 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189663 */     // GIR_Coverage, 18857,
     /* 2189663 */     GIR_EraseRootFromParent_Done,
     /* 2189664 */   // Label 28788: @2189664
     /* 2189664 */   GIM_Try, /*On fail goto*//*Label 28789*/ GIMT_Encode4(2189755), // Rule ID 18860 //
     /* 2189669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189689 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189692 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189711 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189715 */     // MIs[0] round
     /* 2189715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189718 */     // MIs[0] policy
     /* 2189718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189721 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189728 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2189731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189735 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189737 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189739 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189741 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189751 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189753 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189754 */     // GIR_Coverage, 18860,
     /* 2189754 */     GIR_EraseRootFromParent_Done,
     /* 2189755 */   // Label 28789: @2189755
     /* 2189755 */   GIM_Try, /*On fail goto*//*Label 28790*/ GIMT_Encode4(2189846), // Rule ID 18861 //
     /* 2189760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s32,
     /* 2189771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2189774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 2189780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2189783 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2189790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189798 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2189802 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189806 */     // MIs[0] round
     /* 2189806 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189809 */     // MIs[0] policy
     /* 2189809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189812 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189819 */     // (intrinsic_wo_chain:{ *:[nxv8f32] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M2_E16_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2189819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M2_E16_MASK),
     /* 2189822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189826 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189828 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189830 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189832 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189834 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189842 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189845 */     // GIR_Coverage, 18861,
     /* 2189845 */     GIR_EraseRootFromParent_Done,
     /* 2189846 */   // Label 28790: @2189846
     /* 2189846 */   GIM_Try, /*On fail goto*//*Label 28791*/ GIMT_Encode4(2189937), // Rule ID 18864 //
     /* 2189851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode0),
     /* 2189854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189871 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2189877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189893 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189897 */     // MIs[0] round
     /* 2189897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189900 */     // MIs[0] policy
     /* 2189900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2189910 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2189910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2189913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2189915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2189917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2189919 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2189921 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2189923 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2189925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2189930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2189933 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2189935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2189936 */     // GIR_Coverage, 18864,
     /* 2189936 */     GIR_EraseRootFromParent_Done,
     /* 2189937 */   // Label 28791: @2189937
     /* 2189937 */   GIM_Try, /*On fail goto*//*Label 28792*/ GIMT_Encode4(2190028), // Rule ID 18865 //
     /* 2189942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF16_HwMode1),
     /* 2189945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2189950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s32,
     /* 2189953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2189956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2189959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s16,
     /* 2189962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2189965 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2189968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2189972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2189976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2189980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2189984 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2189988 */     // MIs[0] round
     /* 2189988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2189991 */     // MIs[0] policy
     /* 2189991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2189994 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190001 */     // (intrinsic_wo_chain:{ *:[nxv16f32] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR16_M4_E16_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs3, FPR16:{ *:[f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR16_M4_E16_MASK),
     /* 2190004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190008 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190010 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190012 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190014 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2190024 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190027 */     // GIR_Coverage, 18865,
     /* 2190027 */     GIR_EraseRootFromParent_Done,
     /* 2190028 */   // Label 28792: @2190028
     /* 2190028 */   GIM_Try, /*On fail goto*//*Label 28793*/ GIMT_Encode4(2190119), // Rule ID 18868 //
     /* 2190033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190053 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190056 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190071 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190075 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190079 */     // MIs[0] round
     /* 2190079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190082 */     // MIs[0] policy
     /* 2190082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190092 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2190095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190099 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190101 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190103 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190105 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190115 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190118 */     // GIR_Coverage, 18868,
     /* 2190118 */     GIR_EraseRootFromParent_Done,
     /* 2190119 */   // Label 28793: @2190119
     /* 2190119 */   GIM_Try, /*On fail goto*//*Label 28794*/ GIMT_Encode4(2190210), // Rule ID 18869 //
     /* 2190124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s64,
     /* 2190135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2190138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s32,
     /* 2190144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190147 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190162 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190166 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190170 */     // MIs[0] round
     /* 2190170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190173 */     // MIs[0] policy
     /* 2190173 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190183 */     // (intrinsic_wo_chain:{ *:[nxv1f64] } 11241:{ *:[iPTR] }, VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_MF2_E32_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_MF2_E32_MASK),
     /* 2190186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190192 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190194 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190196 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190206 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190209 */     // GIR_Coverage, 18869,
     /* 2190209 */     GIR_EraseRootFromParent_Done,
     /* 2190210 */   // Label 28794: @2190210
     /* 2190210 */   GIM_Try, /*On fail goto*//*Label 28795*/ GIMT_Encode4(2190301), // Rule ID 18872 //
     /* 2190215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190238 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190253 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190257 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190261 */     // MIs[0] round
     /* 2190261 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190264 */     // MIs[0] policy
     /* 2190264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190267 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190274 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2190277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190279 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190283 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190285 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190287 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190297 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190300 */     // GIR_Coverage, 18872,
     /* 2190300 */     GIR_EraseRootFromParent_Done,
     /* 2190301 */   // Label 28795: @2190301
     /* 2190301 */   GIM_Try, /*On fail goto*//*Label 28796*/ GIMT_Encode4(2190392), // Rule ID 18873 //
     /* 2190306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 2190317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2190320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 2190326 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190329 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2190336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190348 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190352 */     // MIs[0] round
     /* 2190352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190355 */     // MIs[0] policy
     /* 2190355 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190365 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 11241:{ *:[iPTR] }, VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M1_E32_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M1_E32_MASK),
     /* 2190368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190370 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190372 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190374 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190376 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190378 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190388 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190391 */     // GIR_Coverage, 18873,
     /* 2190391 */     GIR_EraseRootFromParent_Done,
     /* 2190392 */   // Label 28796: @2190392
     /* 2190392 */   GIM_Try, /*On fail goto*//*Label 28797*/ GIMT_Encode4(2190483), // Rule ID 18876 //
     /* 2190397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190414 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190417 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190420 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190435 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190439 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190443 */     // MIs[0] round
     /* 2190443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190446 */     // MIs[0] policy
     /* 2190446 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190449 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190456 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2190459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190465 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190467 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190469 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190479 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190482 */     // GIR_Coverage, 18876,
     /* 2190482 */     GIR_EraseRootFromParent_Done,
     /* 2190483 */   // Label 28797: @2190483
     /* 2190483 */   GIM_Try, /*On fail goto*//*Label 28798*/ GIMT_Encode4(2190574), // Rule ID 18877 //
     /* 2190488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s64,
     /* 2190499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2190502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190505 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 2190508 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2190511 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2190518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2190530 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190534 */     // MIs[0] round
     /* 2190534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190537 */     // MIs[0] policy
     /* 2190537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190547 */     // (intrinsic_wo_chain:{ *:[nxv4f64] } 11241:{ *:[iPTR] }, VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M2_E32_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M2_E32_MASK),
     /* 2190550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190552 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190554 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190556 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190558 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190560 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190570 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190573 */     // GIR_Coverage, 18877,
     /* 2190573 */     GIR_EraseRootFromParent_Done,
     /* 2190574 */   // Label 28798: @2190574
     /* 2190574 */   GIM_Try, /*On fail goto*//*Label 28799*/ GIMT_Encode4(2190665), // Rule ID 18880 //
     /* 2190579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2190582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190599 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190602 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190621 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190625 */     // MIs[0] round
     /* 2190625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190628 */     // MIs[0] policy
     /* 2190628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190638 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2190641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190647 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190649 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190651 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190661 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190664 */     // GIR_Coverage, 18880,
     /* 2190664 */     GIR_EraseRootFromParent_Done,
     /* 2190665 */   // Label 28799: @2190665
     /* 2190665 */   GIM_Try, /*On fail goto*//*Label 28800*/ GIMT_Encode4(2190756), // Rule ID 18881 //
     /* 2190670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2190673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_vfwnmsac_mask),
     /* 2190678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s64,
     /* 2190681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2190684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2190687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s32,
     /* 2190690 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2190693 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2190700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2190704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190708 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2190712 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190716 */     // MIs[0] round
     /* 2190716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190719 */     // MIs[0] policy
     /* 2190719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190729 */     // (intrinsic_wo_chain:{ *:[nxv8f64] } 11241:{ *:[iPTR] }, VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFWNMSAC_VFPR32_M4_E32_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs3, FPR32:{ *:[f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWNMSAC_VFPR32_M4_E32_MASK),
     /* 2190732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs3
     /* 2190736 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190738 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190740 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190742 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2190752 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190755 */     // GIR_Coverage, 18881,
     /* 2190755 */     GIR_EraseRootFromParent_Done,
     /* 2190756 */   // Label 28800: @2190756
     /* 2190756 */   GIM_Try, /*On fail goto*//*Label 28801*/ GIMT_Encode4(2190847), // Rule ID 64330 //
     /* 2190761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2190764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2190769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2190772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2190775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2190781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190784 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190807 */     // MIs[0] round
     /* 2190807 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190810 */     // MIs[0] policy
     /* 2190810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190820 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2190820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2190823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190825 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2190827 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190829 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190831 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190833 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2190843 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190846 */     // GIR_Coverage, 64330,
     /* 2190846 */     GIR_EraseRootFromParent_Done,
     /* 2190847 */   // Label 28801: @2190847
     /* 2190847 */   GIM_Try, /*On fail goto*//*Label 28802*/ GIMT_Encode4(2190938), // Rule ID 64331 //
     /* 2190852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2190855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2190860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2190863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2190866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2190869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2190872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2190875 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2190878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190890 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190894 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190898 */     // MIs[0] round
     /* 2190898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190901 */     // MIs[0] policy
     /* 2190901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2190911 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2190911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF8_MASK),
     /* 2190914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2190916 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2190918 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2190920 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2190922 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2190924 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2190926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2190931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2190934 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2190936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2190937 */     // GIR_Coverage, 64331,
     /* 2190937 */     GIR_EraseRootFromParent_Done,
     /* 2190938 */   // Label 28802: @2190938
     /* 2190938 */   GIM_Try, /*On fail goto*//*Label 28803*/ GIMT_Encode4(2191029), // Rule ID 64334 //
     /* 2190943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2190946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2190951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2190954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2190957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2190960 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2190963 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2190966 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2190969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2190973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2190981 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2190985 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2190989 */     // MIs[0] round
     /* 2190989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2190992 */     // MIs[0] policy
     /* 2190992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2190995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191002 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2191005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191007 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191011 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191013 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191015 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191025 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191028 */     // GIR_Coverage, 64334,
     /* 2191028 */     GIR_EraseRootFromParent_Done,
     /* 2191029 */   // Label 28803: @2191029
     /* 2191029 */   GIM_Try, /*On fail goto*//*Label 28804*/ GIMT_Encode4(2191120), // Rule ID 64335 //
     /* 2191034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2191045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2191048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2191051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191076 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191080 */     // MIs[0] round
     /* 2191080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191083 */     // MIs[0] policy
     /* 2191083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191086 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191093 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF4_MASK),
     /* 2191096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191098 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191100 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191102 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191104 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191106 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191116 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191119 */     // GIR_Coverage, 64335,
     /* 2191119 */     GIR_EraseRootFromParent_Done,
     /* 2191120 */   // Label 28804: @2191120
     /* 2191120 */   GIM_Try, /*On fail goto*//*Label 28805*/ GIMT_Encode4(2191211), // Rule ID 64338 //
     /* 2191125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2191128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2191136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2191139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2191142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191145 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191148 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191167 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191171 */     // MIs[0] round
     /* 2191171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191174 */     // MIs[0] policy
     /* 2191174 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191177 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191184 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2191187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191189 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191191 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191193 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191195 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191197 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191207 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191210 */     // GIR_Coverage, 64338,
     /* 2191210 */     GIR_EraseRootFromParent_Done,
     /* 2191211 */   // Label 28805: @2191211
     /* 2191211 */   GIM_Try, /*On fail goto*//*Label 28806*/ GIMT_Encode4(2191302), // Rule ID 64339 //
     /* 2191216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2191227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2191230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2191233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191236 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2191239 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191258 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191262 */     // MIs[0] round
     /* 2191262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191265 */     // MIs[0] policy
     /* 2191265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191275 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_MF2_MASK),
     /* 2191278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191280 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191284 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191286 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191288 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191298 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191301 */     // GIR_Coverage, 64339,
     /* 2191301 */     GIR_EraseRootFromParent_Done,
     /* 2191302 */   // Label 28806: @2191302
     /* 2191302 */   GIM_Try, /*On fail goto*//*Label 28807*/ GIMT_Encode4(2191393), // Rule ID 64342 //
     /* 2191307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2191310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2191318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2191321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2191324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191327 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191330 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191345 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191349 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191353 */     // MIs[0] round
     /* 2191353 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191356 */     // MIs[0] policy
     /* 2191356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191366 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2191369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191371 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191375 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191377 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191379 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191389 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191392 */     // GIR_Coverage, 64342,
     /* 2191392 */     GIR_EraseRootFromParent_Done,
     /* 2191393 */   // Label 28807: @2191393
     /* 2191393 */   GIM_Try, /*On fail goto*//*Label 28808*/ GIMT_Encode4(2191484), // Rule ID 64343 //
     /* 2191398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2191409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2191412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2191415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2191421 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2191436 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191440 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191444 */     // MIs[0] round
     /* 2191444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191447 */     // MIs[0] policy
     /* 2191447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191457 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11030:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M1_MASK),
     /* 2191460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191462 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191466 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191468 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191470 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191480 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191483 */     // GIR_Coverage, 64343,
     /* 2191483 */     GIR_EraseRootFromParent_Done,
     /* 2191484 */   // Label 28808: @2191484
     /* 2191484 */   GIM_Try, /*On fail goto*//*Label 28809*/ GIMT_Encode4(2191575), // Rule ID 64346 //
     /* 2191489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2191492 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191497 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2191500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2191503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2191506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191512 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191527 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191531 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191535 */     // MIs[0] round
     /* 2191535 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191538 */     // MIs[0] policy
     /* 2191538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191541 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2191551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191553 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191555 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191557 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191559 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191561 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191563 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191571 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191574 */     // GIR_Coverage, 64346,
     /* 2191574 */     GIR_EraseRootFromParent_Done,
     /* 2191575 */   // Label 28809: @2191575
     /* 2191575 */   GIM_Try, /*On fail goto*//*Label 28810*/ GIMT_Encode4(2191666), // Rule ID 64347 //
     /* 2191580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_xu_f_qf_mask),
     /* 2191588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2191591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2191594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2191597 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191600 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2191603 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2191610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2191614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2191618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191622 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191626 */     // MIs[0] round
     /* 2191626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191629 */     // MIs[0] policy
     /* 2191629 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191639 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11030:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_XU_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_XU_F_QF_M2_MASK),
     /* 2191642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191644 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191646 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191648 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191650 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191652 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191662 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191665 */     // GIR_Coverage, 64347,
     /* 2191665 */     GIR_EraseRootFromParent_Done,
     /* 2191666 */   // Label 28810: @2191666
     /* 2191666 */   GIM_Try, /*On fail goto*//*Label 28811*/ GIMT_Encode4(2191757), // Rule ID 64350 //
     /* 2191671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2191674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2191679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2191682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2191685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2191688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191694 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191709 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191713 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191717 */     // MIs[0] round
     /* 2191717 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191720 */     // MIs[0] policy
     /* 2191720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191723 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191730 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2191733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191735 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191739 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191741 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191743 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191753 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191756 */     // GIR_Coverage, 64350,
     /* 2191756 */     GIR_EraseRootFromParent_Done,
     /* 2191757 */   // Label 28811: @2191757
     /* 2191757 */   GIM_Try, /*On fail goto*//*Label 28812*/ GIMT_Encode4(2191848), // Rule ID 64351 //
     /* 2191762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2191770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s8,
     /* 2191773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2191776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2191779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191782 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv1s1,
     /* 2191785 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191804 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191808 */     // MIs[0] round
     /* 2191808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191811 */     // MIs[0] policy
     /* 2191811 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191821 */     // (intrinsic_wo_chain:{ *:[nxv1i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2191821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF8_MASK),
     /* 2191824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191826 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191828 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191830 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191832 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191834 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191844 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191847 */     // GIR_Coverage, 64351,
     /* 2191847 */     GIR_EraseRootFromParent_Done,
     /* 2191848 */   // Label 28812: @2191848
     /* 2191848 */   GIM_Try, /*On fail goto*//*Label 28813*/ GIMT_Encode4(2191939), // Rule ID 64354 //
     /* 2191853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2191856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2191861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2191864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2191867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2191870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191876 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2191879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191891 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191895 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191899 */     // MIs[0] round
     /* 2191899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191902 */     // MIs[0] policy
     /* 2191902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191905 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2191912 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2191912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2191915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2191917 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2191919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2191921 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2191923 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2191925 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2191927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2191932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2191935 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2191937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2191938 */     // GIR_Coverage, 64354,
     /* 2191938 */     GIR_EraseRootFromParent_Done,
     /* 2191939 */   // Label 28813: @2191939
     /* 2191939 */   GIM_Try, /*On fail goto*//*Label 28814*/ GIMT_Encode4(2192030), // Rule ID 64355 //
     /* 2191944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2191947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2191952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s8,
     /* 2191955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2191958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2191961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2191964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s1,
     /* 2191967 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2191970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2191974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2191982 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2191986 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2191990 */     // MIs[0] round
     /* 2191990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2191993 */     // MIs[0] policy
     /* 2191993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2191996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192003 */     // (intrinsic_wo_chain:{ *:[nxv2i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF4_MASK),
     /* 2192006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192008 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192010 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192012 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192014 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192016 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192018 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192026 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192029 */     // GIR_Coverage, 64355,
     /* 2192029 */     GIR_EraseRootFromParent_Done,
     /* 2192030 */   // Label 28814: @2192030
     /* 2192030 */   GIM_Try, /*On fail goto*//*Label 28815*/ GIMT_Encode4(2192121), // Rule ID 64358 //
     /* 2192035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2192038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2192046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2192049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2192052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192058 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192073 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192077 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192081 */     // MIs[0] round
     /* 2192081 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192084 */     // MIs[0] policy
     /* 2192084 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192094 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2192097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192099 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192103 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192105 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192107 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192117 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192120 */     // GIR_Coverage, 64358,
     /* 2192120 */     GIR_EraseRootFromParent_Done,
     /* 2192121 */   // Label 28815: @2192121
     /* 2192121 */   GIM_Try, /*On fail goto*//*Label 28816*/ GIMT_Encode4(2192212), // Rule ID 64359 //
     /* 2192126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2192129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s8,
     /* 2192137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2192140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2192143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192146 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s1,
     /* 2192149 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192164 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192168 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192172 */     // MIs[0] round
     /* 2192172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192175 */     // MIs[0] policy
     /* 2192175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192185 */     // (intrinsic_wo_chain:{ *:[nxv4i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_MF2_MASK),
     /* 2192188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192190 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192192 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192194 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192196 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192198 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192208 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192211 */     // GIR_Coverage, 64359,
     /* 2192211 */     GIR_EraseRootFromParent_Done,
     /* 2192212 */   // Label 28816: @2192212
     /* 2192212 */   GIM_Try, /*On fail goto*//*Label 28817*/ GIMT_Encode4(2192303), // Rule ID 64362 //
     /* 2192217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2192220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2192228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2192231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2192234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192237 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192240 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192255 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192259 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192263 */     // MIs[0] round
     /* 2192263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192266 */     // MIs[0] policy
     /* 2192266 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192276 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2192279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192281 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192283 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192285 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192287 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192289 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192299 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192302 */     // GIR_Coverage, 64362,
     /* 2192302 */     GIR_EraseRootFromParent_Done,
     /* 2192303 */   // Label 28817: @2192303
     /* 2192303 */   GIM_Try, /*On fail goto*//*Label 28818*/ GIMT_Encode4(2192394), // Rule ID 64363 //
     /* 2192308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2192311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s8,
     /* 2192319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2192322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2192325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192328 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s1,
     /* 2192331 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2192338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2192342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2192346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192350 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192354 */     // MIs[0] round
     /* 2192354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192357 */     // MIs[0] policy
     /* 2192357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192367 */     // (intrinsic_wo_chain:{ *:[nxv8i8] } 11028:{ *:[iPTR] }, VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M1_MASK),
     /* 2192370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192372 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192376 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192378 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192380 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192390 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192393 */     // GIR_Coverage, 64363,
     /* 2192393 */     GIR_EraseRootFromParent_Done,
     /* 2192394 */   // Label 28818: @2192394
     /* 2192394 */   GIM_Try, /*On fail goto*//*Label 28819*/ GIMT_Encode4(2192485), // Rule ID 64366 //
     /* 2192399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode0),
     /* 2192402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2192410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2192413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2192416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192422 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s64,
     /* 2192425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192441 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192445 */     // MIs[0] round
     /* 2192445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192448 */     // MIs[0] policy
     /* 2192448 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192458 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i64] }):$round, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2192458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2192461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192463 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192467 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192469 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192471 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192481 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192484 */     // GIR_Coverage, 64366,
     /* 2192484 */     GIR_EraseRootFromParent_Done,
     /* 2192485 */   // Label 28819: @2192485
     /* 2192485 */   GIM_Try, /*On fail goto*//*Label 28820*/ GIMT_Encode4(2192576), // Rule ID 64367 //
     /* 2192490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXSfvfnrclipxfqf_HwMode1),
     /* 2192493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_sf_vfnrclip_x_f_qf_mask),
     /* 2192498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 2192501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2192504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2192507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s1,
     /* 2192513 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /* 2192516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2192520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2192524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2192528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2192532 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2192536 */     // MIs[0] round
     /* 2192536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2192539 */     // MIs[0] policy
     /* 2192539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/8,
     /* 2192542 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/7, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2192549 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 11028:{ *:[iPTR] }, VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVFNRCLIP_X_F_QF_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (timm:{ *:[i32] }):$round, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2192549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNRCLIP_X_F_QF_M2_MASK),
     /* 2192552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2192554 */     GIR_RootToRootCopy, /*OpIdx*/2, // passthru
     /* 2192556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2192558 */     GIR_RootToRootCopy, /*OpIdx*/4, // rs2
     /* 2192560 */     GIR_RootToRootCopy, /*OpIdx*/5, // vm
     /* 2192562 */     GIR_RootToRootCopy, /*OpIdx*/6, // round
     /* 2192564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2192569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2192572 */     GIR_RootToRootCopy, /*OpIdx*/8, // policy
     /* 2192574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192575 */     // GIR_Coverage, 64367,
     /* 2192575 */     GIR_EraseRootFromParent_Done,
     /* 2192576 */   // Label 28820: @2192576
     /* 2192576 */   GIM_Reject,
     /* 2192577 */ // Label 26776: @2192577
     /* 2192577 */ GIM_Reject,
     /* 2192578 */ // Label 38: @2192578
     /* 2192578 */ GIM_Try, /*On fail goto*//*Label 28821*/ GIMT_Encode4(2192661), // Rule ID 35 //
     /* 2192583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2192586 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 2192589 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 2192594 */   // MIs[0] Operand 1
     /* 2192594 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 2192598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRX5RegClassID),
     /* 2192602 */   // MIs[0] ptr
     /* 2192602 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192606 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRJALRRegClassID),
     /* 2192610 */   // MIs[0] accessinfo
     /* 2192610 */   GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 2192613 */   // (intrinsic_void 192:{ *:[iPTR] }, X5:{ *:[i64] }, GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES GPRJALR:{ *:[iPTR] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 2192613 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 2192617 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(RISCV::X5), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2192623 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X5
     /* 2192627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 2192630 */   GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 2192632 */   GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 2192634 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X1*/0,
     /* 2192637 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X6*/1,
     /* 2192640 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X7*/2,
     /* 2192643 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X28*/3,
     /* 2192646 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X29*/4,
     /* 2192649 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X30*/5,
     /* 2192652 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::X31*/6,
     /* 2192655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2192659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2192660 */   // GIR_Coverage, 35,
     /* 2192660 */   GIR_EraseRootFromParent_Done,
     /* 2192661 */ // Label 28821: @2192661
     /* 2192661 */ GIM_Try, /*On fail goto*//*Label 28822*/ GIMT_Encode4(2193566),
     /* 2192666 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 2192669 */   GIM_Try, /*On fail goto*//*Label 28823*/ GIMT_Encode4(2192741), // Rule ID 621 //
     /* 2192674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2192677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i32),
     /* 2192682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2192685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192695 */     // MIs[0] addr
     /* 2192695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192711 */     // MIs[0] ordering
     /* 2192711 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2192714 */     // (intrinsic_w_chain:{ *:[i32] } 10964:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2192714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2192717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2192720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2192722 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2192727 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2192729 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2192731 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2192733 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2192735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2192739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192740 */     // GIR_Coverage, 621,
     /* 2192740 */     GIR_EraseRootFromParent_Done,
     /* 2192741 */   // Label 28823: @2192741
     /* 2192741 */   GIM_Try, /*On fail goto*//*Label 28824*/ GIMT_Encode4(2192813), // Rule ID 622 //
     /* 2192746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2192749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i32),
     /* 2192754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2192757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192760 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192767 */     // MIs[0] addr
     /* 2192767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192779 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192783 */     // MIs[0] ordering
     /* 2192783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2192786 */     // (intrinsic_w_chain:{ *:[i32] } 10950:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2192786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2192789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2192792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2192794 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2192799 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2192801 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2192803 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2192805 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2192807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2192811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192812 */     // GIR_Coverage, 622,
     /* 2192812 */     GIR_EraseRootFromParent_Done,
     /* 2192813 */   // Label 28824: @2192813
     /* 2192813 */   GIM_Try, /*On fail goto*//*Label 28825*/ GIMT_Encode4(2192885), // Rule ID 623 //
     /* 2192818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2192821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i32),
     /* 2192826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2192829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192839 */     // MIs[0] addr
     /* 2192839 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192851 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192855 */     // MIs[0] ordering
     /* 2192855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2192858 */     // (intrinsic_w_chain:{ *:[i32] } 10958:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2192858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2192861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2192864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2192866 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2192871 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2192873 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2192875 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2192877 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2192879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2192883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192884 */     // GIR_Coverage, 623,
     /* 2192884 */     GIR_EraseRootFromParent_Done,
     /* 2192885 */   // Label 28825: @2192885
     /* 2192885 */   GIM_Try, /*On fail goto*//*Label 28826*/ GIMT_Encode4(2192957), // Rule ID 624 //
     /* 2192890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2192893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i32),
     /* 2192898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2192901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192911 */     // MIs[0] addr
     /* 2192911 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192927 */     // MIs[0] ordering
     /* 2192927 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2192930 */     // (intrinsic_w_chain:{ *:[i32] } 10956:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2192930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2192933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2192936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2192938 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2192943 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2192945 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2192947 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2192949 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2192951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2192955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2192956 */     // GIR_Coverage, 624,
     /* 2192956 */     GIR_EraseRootFromParent_Done,
     /* 2192957 */   // Label 28826: @2192957
     /* 2192957 */   GIM_Try, /*On fail goto*//*Label 28827*/ GIMT_Encode4(2193037), // Rule ID 627 //
     /* 2192962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2192965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i32),
     /* 2192970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2192973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2192976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2192979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192983 */     // MIs[0] addr
     /* 2192983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2192987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2192999 */     // MIs[0] ordering
     /* 2192999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193002 */     // (intrinsic_w_chain:{ *:[i32] } 10960:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2193002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2193011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193013 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193018 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193023 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193025 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193027 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193029 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193031 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193036 */     // GIR_Coverage, 627,
     /* 2193036 */     GIR_EraseRootFromParent_Done,
     /* 2193037 */   // Label 28827: @2193037
     /* 2193037 */   GIM_Try, /*On fail goto*//*Label 28828*/ GIMT_Encode4(2193117), // Rule ID 628 //
     /* 2193042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2193045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i32),
     /* 2193050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2193053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2193056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2193059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193063 */     // MIs[0] addr
     /* 2193063 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193075 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193079 */     // MIs[0] ordering
     /* 2193079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193082 */     // (intrinsic_w_chain:{ *:[i32] } 10962:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2193082 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2193091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193093 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193098 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193103 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193105 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193107 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193109 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193116 */     // GIR_Coverage, 628,
     /* 2193116 */     GIR_EraseRootFromParent_Done,
     /* 2193117 */   // Label 28828: @2193117
     /* 2193117 */   GIM_Try, /*On fail goto*//*Label 28829*/ GIMT_Encode4(2193189), // Rule ID 634 //
     /* 2193122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_xchg_i64),
     /* 2193130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193143 */     // MIs[0] addr
     /* 2193143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193159 */     // MIs[0] ordering
     /* 2193159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193162 */     // (intrinsic_w_chain:{ *:[i64] } 10965:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicSwap32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicSwap32),
     /* 2193168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193170 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193175 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193177 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193179 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193181 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193188 */     // GIR_Coverage, 634,
     /* 2193188 */     GIR_EraseRootFromParent_Done,
     /* 2193189 */   // Label 28829: @2193189
     /* 2193189 */   GIM_Try, /*On fail goto*//*Label 28830*/ GIMT_Encode4(2193261), // Rule ID 635 //
     /* 2193194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_add_i64),
     /* 2193202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193215 */     // MIs[0] addr
     /* 2193215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193227 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193231 */     // MIs[0] ordering
     /* 2193231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193234 */     // (intrinsic_w_chain:{ *:[i64] } 10951:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadAdd32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadAdd32),
     /* 2193240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193242 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193247 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193249 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193251 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193253 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193255 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193260 */     // GIR_Coverage, 635,
     /* 2193260 */     GIR_EraseRootFromParent_Done,
     /* 2193261 */   // Label 28830: @2193261
     /* 2193261 */   GIM_Try, /*On fail goto*//*Label 28831*/ GIMT_Encode4(2193333), // Rule ID 636 //
     /* 2193266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_sub_i64),
     /* 2193274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193287 */     // MIs[0] addr
     /* 2193287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193299 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193303 */     // MIs[0] ordering
     /* 2193303 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193306 */     // (intrinsic_w_chain:{ *:[i64] } 10959:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadSub32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadSub32),
     /* 2193312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193314 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193319 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193321 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193323 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193325 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193332 */     // GIR_Coverage, 636,
     /* 2193332 */     GIR_EraseRootFromParent_Done,
     /* 2193333 */   // Label 28831: @2193333
     /* 2193333 */   GIM_Try, /*On fail goto*//*Label 28832*/ GIMT_Encode4(2193405), // Rule ID 637 //
     /* 2193338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_nand_i64),
     /* 2193346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193359 */     // MIs[0] addr
     /* 2193359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193371 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193375 */     // MIs[0] ordering
     /* 2193375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193378 */     // (intrinsic_w_chain:{ *:[i64] } 10957:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadNand32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadNand32),
     /* 2193384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193386 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193391 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193393 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193395 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193397 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193404 */     // GIR_Coverage, 637,
     /* 2193404 */     GIR_EraseRootFromParent_Done,
     /* 2193405 */   // Label 28832: @2193405
     /* 2193405 */   GIM_Try, /*On fail goto*//*Label 28833*/ GIMT_Encode4(2193485), // Rule ID 640 //
     /* 2193410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umax_i64),
     /* 2193418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193431 */     // MIs[0] addr
     /* 2193431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193439 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193447 */     // MIs[0] ordering
     /* 2193447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193450 */     // (intrinsic_w_chain:{ *:[i64] } 10961:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMax32),
     /* 2193459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193461 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193466 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193471 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193473 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193475 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193477 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193484 */     // GIR_Coverage, 640,
     /* 2193484 */     GIR_EraseRootFromParent_Done,
     /* 2193485 */   // Label 28833: @2193485
     /* 2193485 */   GIM_Try, /*On fail goto*//*Label 28834*/ GIMT_Encode4(2193565), // Rule ID 641 //
     /* 2193490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_umin_i64),
     /* 2193498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193511 */     // MIs[0] addr
     /* 2193511 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193523 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193527 */     // MIs[0] ordering
     /* 2193527 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 2193530 */     // (intrinsic_w_chain:{ *:[i64] } 10963:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadUMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2193530 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadUMin32),
     /* 2193539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193541 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193546 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193551 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193553 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193555 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193557 */     GIR_RootToRootCopy, /*OpIdx*/5, // ordering
     /* 2193559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193564 */     // GIR_Coverage, 641,
     /* 2193564 */     GIR_EraseRootFromParent_Done,
     /* 2193565 */   // Label 28834: @2193565
     /* 2193565 */   GIM_Reject,
     /* 2193566 */ // Label 28822: @2193566
     /* 2193566 */ GIM_Try, /*On fail goto*//*Label 28835*/ GIMT_Encode4(2194093),
     /* 2193571 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /* 2193574 */   GIM_Try, /*On fail goto*//*Label 28836*/ GIMT_Encode4(2193663), // Rule ID 625 //
     /* 2193579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2193582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i32),
     /* 2193587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2193590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2193593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2193596 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2193599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193603 */     // MIs[0] addr
     /* 2193603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193615 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193619 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193623 */     // MIs[0] ordering
     /* 2193623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193626 */     // (intrinsic_w_chain:{ *:[i32] } 10952:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2193626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2193635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193637 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193642 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193647 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193649 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193651 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193653 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2193655 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2193657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193662 */     // GIR_Coverage, 625,
     /* 2193662 */     GIR_EraseRootFromParent_Done,
     /* 2193663 */   // Label 28836: @2193663
     /* 2193663 */   GIM_Try, /*On fail goto*//*Label 28837*/ GIMT_Encode4(2193752), // Rule ID 626 //
     /* 2193668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2193671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i32),
     /* 2193676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2193679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2193682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2193685 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2193688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193692 */     // MIs[0] addr
     /* 2193692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193708 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193712 */     // MIs[0] ordering
     /* 2193712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193715 */     // (intrinsic_w_chain:{ *:[i32] } 10954:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i32] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$incr, GPR:{ *:[i32] }:$mask, GPR:{ *:[i32] }:$shiftamt, (timm:{ *:[i32] }):$ordering)
     /* 2193715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2193724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193726 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193731 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193736 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193738 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193740 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193742 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2193744 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2193746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193751 */     // GIR_Coverage, 626,
     /* 2193751 */     GIR_EraseRootFromParent_Done,
     /* 2193752 */   // Label 28837: @2193752
     /* 2193752 */   GIM_Try, /*On fail goto*//*Label 28838*/ GIMT_Encode4(2193841), // Rule ID 638 //
     /* 2193757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_max_i64),
     /* 2193765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193774 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2193777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193781 */     // MIs[0] addr
     /* 2193781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193793 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193797 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193801 */     // MIs[0] ordering
     /* 2193801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193804 */     // (intrinsic_w_chain:{ *:[i64] } 10953:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMax32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2193804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMax32),
     /* 2193813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193815 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193820 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193825 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193827 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193829 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193831 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2193833 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2193835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193840 */     // GIR_Coverage, 638,
     /* 2193840 */     GIR_EraseRootFromParent_Done,
     /* 2193841 */   // Label 28838: @2193841
     /* 2193841 */   GIM_Try, /*On fail goto*//*Label 28839*/ GIMT_Encode4(2193930), // Rule ID 639 //
     /* 2193846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2193849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_atomicrmw_min_i64),
     /* 2193854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2193857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2193860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2193863 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2193866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193870 */     // MIs[0] addr
     /* 2193870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193882 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193886 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193890 */     // MIs[0] ordering
     /* 2193890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193893 */     // (intrinsic_w_chain:{ *:[i64] } 10955:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedAtomicLoadMin32:{ *:[i64] }:{ *:[i16] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$incr, GPR:{ *:[i64] }:$mask, GPR:{ *:[i64] }:$shiftamt, (timm:{ *:[i64] }):$ordering)
     /* 2193893 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 2193896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedAtomicLoadMin32),
     /* 2193902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193904 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193909 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193914 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193916 */     GIR_RootToRootCopy, /*OpIdx*/3, // incr
     /* 2193918 */     GIR_RootToRootCopy, /*OpIdx*/4, // mask
     /* 2193920 */     GIR_RootToRootCopy, /*OpIdx*/5, // shiftamt
     /* 2193922 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2193924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2193928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2193929 */     // GIR_Coverage, 639,
     /* 2193929 */     GIR_EraseRootFromParent_Done,
     /* 2193930 */   // Label 28839: @2193930
     /* 2193930 */   GIM_Try, /*On fail goto*//*Label 28840*/ GIMT_Encode4(2194011), // Rule ID 657 //
     /* 2193935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_HwMode1),
     /* 2193938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i32),
     /* 2193943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2193946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2193949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 2193952 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2193955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193959 */     // MIs[0] addr
     /* 2193959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2193963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193975 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2193979 */     // MIs[0] ordering
     /* 2193979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2193982 */     // (intrinsic_w_chain:{ *:[i32] } 10966:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i32] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i32] }:$cmpval, GPR:{ *:[i32] }:$newval, GPR:{ *:[i32] }:$mask, (timm:{ *:[i32] }):$ordering)
     /* 2193982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2193985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2193988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2193990 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2193995 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2193997 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2193999 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2194001 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2194003 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2194005 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2194009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194010 */     // GIR_Coverage, 657,
     /* 2194010 */     GIR_EraseRootFromParent_Done,
     /* 2194011 */   // Label 28840: @2194011
     /* 2194011 */   GIM_Try, /*On fail goto*//*Label 28841*/ GIMT_Encode4(2194092), // Rule ID 658 //
     /* 2194016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtA_IsRV64_HwMode0),
     /* 2194019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::riscv_masked_cmpxchg_i64),
     /* 2194024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2194027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2194030 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 2194033 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2194036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2194040 */     // MIs[0] addr
     /* 2194040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/0,
     /* 2194044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2194048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2194052 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2194056 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2194060 */     // MIs[0] ordering
     /* 2194060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2194063 */     // (intrinsic_w_chain:{ *:[i64] } 10967:{ *:[iPTR] }, GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)  =>  (PseudoMaskedCmpXchg32:{ *:[i64] }:{ *:[i16] } GPR:{ *:[iPTR] }:$addr, GPR:{ *:[i64] }:$cmpval, GPR:{ *:[i64] }:$newval, GPR:{ *:[i64] }:$mask, (timm:{ *:[i64] }):$ordering)
     /* 2194063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2194066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoMaskedCmpXchg32),
     /* 2194069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[res]
     /* 2194071 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 2194076 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 2194078 */     GIR_RootToRootCopy, /*OpIdx*/3, // cmpval
     /* 2194080 */     GIR_RootToRootCopy, /*OpIdx*/4, // newval
     /* 2194082 */     GIR_RootToRootCopy, /*OpIdx*/5, // mask
     /* 2194084 */     GIR_RootToRootCopy, /*OpIdx*/6, // ordering
     /* 2194086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 2194090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194091 */     // GIR_Coverage, 658,
     /* 2194091 */     GIR_EraseRootFromParent_Done,
     /* 2194092 */   // Label 28841: @2194092
     /* 2194092 */   GIM_Reject,
     /* 2194093 */ // Label 28835: @2194093
     /* 2194093 */ GIM_Reject,
     /* 2194094 */ // Label 39: @2194094
     /* 2194094 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(32), /*)*//*default:*//*Label 28857*/ GIMT_Encode4(2197214),
     /* 2194105 */ /*GILLT_nxv1s16*//*Label 28842*/ GIMT_Encode4(2194205),
     /* 2194109 */ /*GILLT_nxv1s32*//*Label 28843*/ GIMT_Encode4(2194309),
     /* 2194113 */ /*GILLT_nxv1s64*//*Label 28844*/ GIMT_Encode4(2194526), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2194125 */ /*GILLT_nxv2s16*//*Label 28845*/ GIMT_Encode4(2194851),
     /* 2194129 */ /*GILLT_nxv2s32*//*Label 28846*/ GIMT_Encode4(2194955),
     /* 2194133 */ /*GILLT_nxv2s64*//*Label 28847*/ GIMT_Encode4(2195172), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2194145 */ /*GILLT_nxv4s16*//*Label 28848*/ GIMT_Encode4(2195497),
     /* 2194149 */ /*GILLT_nxv4s32*//*Label 28849*/ GIMT_Encode4(2195601),
     /* 2194153 */ /*GILLT_nxv4s64*//*Label 28850*/ GIMT_Encode4(2195818), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2194165 */ /*GILLT_nxv8s16*//*Label 28851*/ GIMT_Encode4(2196143),
     /* 2194169 */ /*GILLT_nxv8s32*//*Label 28852*/ GIMT_Encode4(2196247),
     /* 2194173 */ /*GILLT_nxv8s64*//*Label 28853*/ GIMT_Encode4(2196464), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2194185 */ /*GILLT_nxv16s16*//*Label 28854*/ GIMT_Encode4(2196789),
     /* 2194189 */ /*GILLT_nxv16s32*//*Label 28855*/ GIMT_Encode4(2196893), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2194201 */ /*GILLT_nxv32s16*//*Label 28856*/ GIMT_Encode4(2197110),
     /* 2194205 */ // Label 28842: @2194205
     /* 2194205 */ GIM_Try, /*On fail goto*//*Label 28858*/ GIMT_Encode4(2194308),
     /* 2194210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2194213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194221 */   GIM_Try, /*On fail goto*//*Label 28859*/ GIMT_Encode4(2194264), // Rule ID 47360 //
     /* 2194226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2194229 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2194232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2194246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194263 */     // GIR_Coverage, 47360,
     /* 2194263 */     GIR_EraseRootFromParent_Done,
     /* 2194264 */   // Label 28859: @2194264
     /* 2194264 */   GIM_Try, /*On fail goto*//*Label 28860*/ GIMT_Encode4(2194307), // Rule ID 47361 //
     /* 2194269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2194272 */     // (anyext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2194275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2194289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194305 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194306 */     // GIR_Coverage, 47361,
     /* 2194306 */     GIR_EraseRootFromParent_Done,
     /* 2194307 */   // Label 28860: @2194307
     /* 2194307 */   GIM_Reject,
     /* 2194308 */ // Label 28858: @2194308
     /* 2194308 */ GIM_Reject,
     /* 2194309 */ // Label 28843: @2194309
     /* 2194309 */ GIM_Try, /*On fail goto*//*Label 28861*/ GIMT_Encode4(2194363), // Rule ID 47384 //
     /* 2194314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2194317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2194320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194328 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2194331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2194345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194362 */   // GIR_Coverage, 47384,
     /* 2194362 */   GIR_EraseRootFromParent_Done,
     /* 2194363 */ // Label 28861: @2194363
     /* 2194363 */ GIM_Try, /*On fail goto*//*Label 28862*/ GIMT_Encode4(2194417), // Rule ID 47385 //
     /* 2194368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2194371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2194374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194382 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2194385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2194399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194416 */   // GIR_Coverage, 47385,
     /* 2194416 */   GIR_EraseRootFromParent_Done,
     /* 2194417 */ // Label 28862: @2194417
     /* 2194417 */ GIM_Try, /*On fail goto*//*Label 28863*/ GIMT_Encode4(2194471), // Rule ID 47450 //
     /* 2194422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2194425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2194428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194436 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2194439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2194453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194470 */   // GIR_Coverage, 47450,
     /* 2194470 */   GIR_EraseRootFromParent_Done,
     /* 2194471 */ // Label 28863: @2194471
     /* 2194471 */ GIM_Try, /*On fail goto*//*Label 28864*/ GIMT_Encode4(2194525), // Rule ID 47451 //
     /* 2194476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2194479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2194482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194490 */   // (anyext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194490 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2194493 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194497 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194502 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2194507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194509 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194512 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2194520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194523 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194524 */   // GIR_Coverage, 47451,
     /* 2194524 */   GIR_EraseRootFromParent_Done,
     /* 2194525 */ // Label 28864: @2194525
     /* 2194525 */ GIM_Reject,
     /* 2194526 */ // Label 28844: @2194526
     /* 2194526 */ GIM_Try, /*On fail goto*//*Label 28865*/ GIMT_Encode4(2194580), // Rule ID 47404 //
     /* 2194531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2194534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194545 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194545 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194548 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194552 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2194562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194567 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194579 */   // GIR_Coverage, 47404,
     /* 2194579 */   GIR_EraseRootFromParent_Done,
     /* 2194580 */ // Label 28865: @2194580
     /* 2194580 */ GIM_Try, /*On fail goto*//*Label 28866*/ GIMT_Encode4(2194634), // Rule ID 47405 //
     /* 2194585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2194588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2194591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194599 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194599 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194602 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194606 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2194616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194621 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194633 */   // GIR_Coverage, 47405,
     /* 2194633 */   GIR_EraseRootFromParent_Done,
     /* 2194634 */ // Label 28866: @2194634
     /* 2194634 */ GIM_Try, /*On fail goto*//*Label 28867*/ GIMT_Encode4(2194688), // Rule ID 47470 //
     /* 2194639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2194642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2194645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194653 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2194670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194675 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194687 */   // GIR_Coverage, 47470,
     /* 2194687 */   GIR_EraseRootFromParent_Done,
     /* 2194688 */ // Label 28867: @2194688
     /* 2194688 */ GIM_Try, /*On fail goto*//*Label 28868*/ GIMT_Encode4(2194742), // Rule ID 47471 //
     /* 2194693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2194696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2194699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194707 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194707 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194710 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194714 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194719 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2194724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194729 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194741 */   // GIR_Coverage, 47471,
     /* 2194741 */   GIR_EraseRootFromParent_Done,
     /* 2194742 */ // Label 28868: @2194742
     /* 2194742 */ GIM_Try, /*On fail goto*//*Label 28869*/ GIMT_Encode4(2194796), // Rule ID 47504 //
     /* 2194747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2194750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2194753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194761 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194761 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194764 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194768 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2194778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194783 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194795 */   // GIR_Coverage, 47504,
     /* 2194795 */   GIR_EraseRootFromParent_Done,
     /* 2194796 */ // Label 28869: @2194796
     /* 2194796 */ GIM_Try, /*On fail goto*//*Label 28870*/ GIMT_Encode4(2194850), // Rule ID 47505 //
     /* 2194801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2194804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2194807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194815 */   // (anyext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194815 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2194818 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194822 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194827 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2194832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194837 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2194845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194848 */   GIR_RootConstrainSelectedInstOperands,
     /* 2194849 */   // GIR_Coverage, 47505,
     /* 2194849 */   GIR_EraseRootFromParent_Done,
     /* 2194850 */ // Label 28870: @2194850
     /* 2194850 */ GIM_Reject,
     /* 2194851 */ // Label 28845: @2194851
     /* 2194851 */ GIM_Try, /*On fail goto*//*Label 28871*/ GIMT_Encode4(2194954),
     /* 2194856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2194859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194867 */   GIM_Try, /*On fail goto*//*Label 28872*/ GIMT_Encode4(2194910), // Rule ID 47364 //
     /* 2194872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2194875 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2194878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2194892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194909 */     // GIR_Coverage, 47364,
     /* 2194909 */     GIR_EraseRootFromParent_Done,
     /* 2194910 */   // Label 28872: @2194910
     /* 2194910 */   GIM_Try, /*On fail goto*//*Label 28873*/ GIMT_Encode4(2194953), // Rule ID 47365 //
     /* 2194915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2194918 */     // (anyext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2194918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2194921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2194935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2194945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2194948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2194951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2194952 */     // GIR_Coverage, 47365,
     /* 2194952 */     GIR_EraseRootFromParent_Done,
     /* 2194953 */   // Label 28873: @2194953
     /* 2194953 */   GIM_Reject,
     /* 2194954 */ // Label 28871: @2194954
     /* 2194954 */ GIM_Reject,
     /* 2194955 */ // Label 28846: @2194955
     /* 2194955 */ GIM_Try, /*On fail goto*//*Label 28874*/ GIMT_Encode4(2195009), // Rule ID 47388 //
     /* 2194960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2194963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2194966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2194974 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2194974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2194977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2194981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2194986 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2194988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2194991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2194993 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2194996 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2194998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195008 */   // GIR_Coverage, 47388,
     /* 2195008 */   GIR_EraseRootFromParent_Done,
     /* 2195009 */ // Label 28874: @2195009
     /* 2195009 */ GIM_Try, /*On fail goto*//*Label 28875*/ GIMT_Encode4(2195063), // Rule ID 47389 //
     /* 2195014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2195017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195028 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2195031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2195045 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195047 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195050 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195062 */   // GIR_Coverage, 47389,
     /* 2195062 */   GIR_EraseRootFromParent_Done,
     /* 2195063 */ // Label 28875: @2195063
     /* 2195063 */ GIM_Try, /*On fail goto*//*Label 28876*/ GIMT_Encode4(2195117), // Rule ID 47454 //
     /* 2195068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2195071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2195074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195082 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2195085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2195099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195116 */   // GIR_Coverage, 47454,
     /* 2195116 */   GIR_EraseRootFromParent_Done,
     /* 2195117 */ // Label 28876: @2195117
     /* 2195117 */ GIM_Try, /*On fail goto*//*Label 28877*/ GIMT_Encode4(2195171), // Rule ID 47455 //
     /* 2195122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2195125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2195128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195136 */   // (anyext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2195139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2195153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195170 */   // GIR_Coverage, 47455,
     /* 2195170 */   GIR_EraseRootFromParent_Done,
     /* 2195171 */ // Label 28877: @2195171
     /* 2195171 */ GIM_Reject,
     /* 2195172 */ // Label 28847: @2195172
     /* 2195172 */ GIM_Try, /*On fail goto*//*Label 28878*/ GIMT_Encode4(2195226), // Rule ID 47408 //
     /* 2195177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2195180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2195183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195191 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2195208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195213 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195225 */   // GIR_Coverage, 47408,
     /* 2195225 */   GIR_EraseRootFromParent_Done,
     /* 2195226 */ // Label 28878: @2195226
     /* 2195226 */ GIM_Try, /*On fail goto*//*Label 28879*/ GIMT_Encode4(2195280), // Rule ID 47409 //
     /* 2195231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2195234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2195237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195245 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195245 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195248 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195252 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2195262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195267 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195279 */   // GIR_Coverage, 47409,
     /* 2195279 */   GIR_EraseRootFromParent_Done,
     /* 2195280 */ // Label 28879: @2195280
     /* 2195280 */ GIM_Try, /*On fail goto*//*Label 28880*/ GIMT_Encode4(2195334), // Rule ID 47474 //
     /* 2195285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2195288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195299 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2195316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195321 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195333 */   // GIR_Coverage, 47474,
     /* 2195333 */   GIR_EraseRootFromParent_Done,
     /* 2195334 */ // Label 28880: @2195334
     /* 2195334 */ GIM_Try, /*On fail goto*//*Label 28881*/ GIMT_Encode4(2195388), // Rule ID 47475 //
     /* 2195339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2195342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2195345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195353 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195353 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195356 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195360 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2195370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195375 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195387 */   // GIR_Coverage, 47475,
     /* 2195387 */   GIR_EraseRootFromParent_Done,
     /* 2195388 */ // Label 28881: @2195388
     /* 2195388 */ GIM_Try, /*On fail goto*//*Label 28882*/ GIMT_Encode4(2195442), // Rule ID 47508 //
     /* 2195393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2195396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2195399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195407 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195407 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195410 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195414 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2195424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195429 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195441 */   // GIR_Coverage, 47508,
     /* 2195441 */   GIR_EraseRootFromParent_Done,
     /* 2195442 */ // Label 28882: @2195442
     /* 2195442 */ GIM_Try, /*On fail goto*//*Label 28883*/ GIMT_Encode4(2195496), // Rule ID 47509 //
     /* 2195447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2195450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2195453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195461 */   // (anyext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195461 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2195464 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195468 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195475 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2195478 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195480 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195483 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195495 */   // GIR_Coverage, 47509,
     /* 2195495 */   GIR_EraseRootFromParent_Done,
     /* 2195496 */ // Label 28883: @2195496
     /* 2195496 */ GIM_Reject,
     /* 2195497 */ // Label 28848: @2195497
     /* 2195497 */ GIM_Try, /*On fail goto*//*Label 28884*/ GIMT_Encode4(2195600),
     /* 2195502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2195505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195513 */   GIM_Try, /*On fail goto*//*Label 28885*/ GIMT_Encode4(2195556), // Rule ID 47368 //
     /* 2195518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2195521 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2195524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2195538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195555 */     // GIR_Coverage, 47368,
     /* 2195555 */     GIR_EraseRootFromParent_Done,
     /* 2195556 */   // Label 28885: @2195556
     /* 2195556 */   GIM_Try, /*On fail goto*//*Label 28886*/ GIMT_Encode4(2195599), // Rule ID 47369 //
     /* 2195561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2195564 */     // (anyext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2195567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2195581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2195594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2195598 */     // GIR_Coverage, 47369,
     /* 2195598 */     GIR_EraseRootFromParent_Done,
     /* 2195599 */   // Label 28886: @2195599
     /* 2195599 */   GIM_Reject,
     /* 2195600 */ // Label 28884: @2195600
     /* 2195600 */ GIM_Reject,
     /* 2195601 */ // Label 28849: @2195601
     /* 2195601 */ GIM_Try, /*On fail goto*//*Label 28887*/ GIMT_Encode4(2195655), // Rule ID 47392 //
     /* 2195606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2195609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2195612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195620 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2195623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2195637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195642 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195654 */   // GIR_Coverage, 47392,
     /* 2195654 */   GIR_EraseRootFromParent_Done,
     /* 2195655 */ // Label 28887: @2195655
     /* 2195655 */ GIM_Try, /*On fail goto*//*Label 28888*/ GIMT_Encode4(2195709), // Rule ID 47393 //
     /* 2195660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2195663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2195666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195674 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2195677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2195691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195708 */   // GIR_Coverage, 47393,
     /* 2195708 */   GIR_EraseRootFromParent_Done,
     /* 2195709 */ // Label 28888: @2195709
     /* 2195709 */ GIM_Try, /*On fail goto*//*Label 28889*/ GIMT_Encode4(2195763), // Rule ID 47458 //
     /* 2195714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2195717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2195720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195728 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2195731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2195745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195762 */   // GIR_Coverage, 47458,
     /* 2195762 */   GIR_EraseRootFromParent_Done,
     /* 2195763 */ // Label 28889: @2195763
     /* 2195763 */ GIM_Try, /*On fail goto*//*Label 28890*/ GIMT_Encode4(2195817), // Rule ID 47459 //
     /* 2195768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2195771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2195774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195782 */   // (anyext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2195785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2195799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2195812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195816 */   // GIR_Coverage, 47459,
     /* 2195816 */   GIR_EraseRootFromParent_Done,
     /* 2195817 */ // Label 28890: @2195817
     /* 2195817 */ GIM_Reject,
     /* 2195818 */ // Label 28850: @2195818
     /* 2195818 */ GIM_Try, /*On fail goto*//*Label 28891*/ GIMT_Encode4(2195872), // Rule ID 47412 //
     /* 2195823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2195826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2195829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195837 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2195840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2195854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195871 */   // GIR_Coverage, 47412,
     /* 2195871 */   GIR_EraseRootFromParent_Done,
     /* 2195872 */ // Label 28891: @2195872
     /* 2195872 */ GIM_Try, /*On fail goto*//*Label 28892*/ GIMT_Encode4(2195926), // Rule ID 47413 //
     /* 2195877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2195880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2195883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2195891 */   // (anyext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2195894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195903 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2195908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195910 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195913 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195925 */   // GIR_Coverage, 47413,
     /* 2195925 */   GIR_EraseRootFromParent_Done,
     /* 2195926 */ // Label 28892: @2195926
     /* 2195926 */ GIM_Try, /*On fail goto*//*Label 28893*/ GIMT_Encode4(2195980), // Rule ID 47478 //
     /* 2195931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2195934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2195937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195945 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2195945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2195948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2195952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2195957 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2195959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2195962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2195964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2195967 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2195969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2195972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2195975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2195978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2195979 */   // GIR_Coverage, 47478,
     /* 2195979 */   GIR_EraseRootFromParent_Done,
     /* 2195980 */ // Label 28893: @2195980
     /* 2195980 */ GIM_Try, /*On fail goto*//*Label 28894*/ GIMT_Encode4(2196034), // Rule ID 47479 //
     /* 2195985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2195988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2195991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2195995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2195999 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2195999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2196002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2196016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196033 */   // GIR_Coverage, 47479,
     /* 2196033 */   GIR_EraseRootFromParent_Done,
     /* 2196034 */ // Label 28894: @2196034
     /* 2196034 */ GIM_Try, /*On fail goto*//*Label 28895*/ GIMT_Encode4(2196088), // Rule ID 47512 //
     /* 2196039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2196042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2196045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196053 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2196056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2196070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196087 */   // GIR_Coverage, 47512,
     /* 2196087 */   GIR_EraseRootFromParent_Done,
     /* 2196088 */ // Label 28895: @2196088
     /* 2196088 */ GIM_Try, /*On fail goto*//*Label 28896*/ GIMT_Encode4(2196142), // Rule ID 47513 //
     /* 2196093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2196096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2196099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196107 */   // (anyext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2196110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2196124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196141 */   // GIR_Coverage, 47513,
     /* 2196141 */   GIR_EraseRootFromParent_Done,
     /* 2196142 */ // Label 28896: @2196142
     /* 2196142 */ GIM_Reject,
     /* 2196143 */ // Label 28851: @2196143
     /* 2196143 */ GIM_Try, /*On fail goto*//*Label 28897*/ GIMT_Encode4(2196246),
     /* 2196148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2196151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196159 */   GIM_Try, /*On fail goto*//*Label 28898*/ GIMT_Encode4(2196202), // Rule ID 47372 //
     /* 2196164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2196167 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2196170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2196184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196186 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196189 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196201 */     // GIR_Coverage, 47372,
     /* 2196201 */     GIR_EraseRootFromParent_Done,
     /* 2196202 */   // Label 28898: @2196202
     /* 2196202 */   GIM_Try, /*On fail goto*//*Label 28899*/ GIMT_Encode4(2196245), // Rule ID 47373 //
     /* 2196207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2196210 */     // (anyext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2196213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2196227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196244 */     // GIR_Coverage, 47373,
     /* 2196244 */     GIR_EraseRootFromParent_Done,
     /* 2196245 */   // Label 28899: @2196245
     /* 2196245 */   GIM_Reject,
     /* 2196246 */ // Label 28897: @2196246
     /* 2196246 */ GIM_Reject,
     /* 2196247 */ // Label 28852: @2196247
     /* 2196247 */ GIM_Try, /*On fail goto*//*Label 28900*/ GIMT_Encode4(2196301), // Rule ID 47396 //
     /* 2196252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2196255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2196258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196266 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2196269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196278 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2196283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196285 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196288 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196300 */   // GIR_Coverage, 47396,
     /* 2196300 */   GIR_EraseRootFromParent_Done,
     /* 2196301 */ // Label 28900: @2196301
     /* 2196301 */ GIM_Try, /*On fail goto*//*Label 28901*/ GIMT_Encode4(2196355), // Rule ID 47397 //
     /* 2196306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2196309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2196312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196320 */   // (anyext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2196323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2196337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196342 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196354 */   // GIR_Coverage, 47397,
     /* 2196354 */   GIR_EraseRootFromParent_Done,
     /* 2196355 */ // Label 28901: @2196355
     /* 2196355 */ GIM_Try, /*On fail goto*//*Label 28902*/ GIMT_Encode4(2196409), // Rule ID 47462 //
     /* 2196360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2196363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2196366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196374 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2196377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2196391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196396 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196408 */   // GIR_Coverage, 47462,
     /* 2196408 */   GIR_EraseRootFromParent_Done,
     /* 2196409 */ // Label 28902: @2196409
     /* 2196409 */ GIM_Try, /*On fail goto*//*Label 28903*/ GIMT_Encode4(2196463), // Rule ID 47463 //
     /* 2196414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2196417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2196420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196428 */   // (anyext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2196431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2196445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196450 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196462 */   // GIR_Coverage, 47463,
     /* 2196462 */   GIR_EraseRootFromParent_Done,
     /* 2196463 */ // Label 28903: @2196463
     /* 2196463 */ GIM_Reject,
     /* 2196464 */ // Label 28853: @2196464
     /* 2196464 */ GIM_Try, /*On fail goto*//*Label 28904*/ GIMT_Encode4(2196518), // Rule ID 47416 //
     /* 2196469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2196472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2196475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196483 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196483 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196486 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196490 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196495 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2196500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196505 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196516 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196517 */   // GIR_Coverage, 47416,
     /* 2196517 */   GIR_EraseRootFromParent_Done,
     /* 2196518 */ // Label 28904: @2196518
     /* 2196518 */ GIM_Try, /*On fail goto*//*Label 28905*/ GIMT_Encode4(2196572), // Rule ID 47417 //
     /* 2196523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2196526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2196529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196537 */   // (anyext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2196554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196559 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196571 */   // GIR_Coverage, 47417,
     /* 2196571 */   GIR_EraseRootFromParent_Done,
     /* 2196572 */ // Label 28905: @2196572
     /* 2196572 */ GIM_Try, /*On fail goto*//*Label 28906*/ GIMT_Encode4(2196626), // Rule ID 47482 //
     /* 2196577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2196580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2196583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196591 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2196608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196625 */   // GIR_Coverage, 47482,
     /* 2196625 */   GIR_EraseRootFromParent_Done,
     /* 2196626 */ // Label 28906: @2196626
     /* 2196626 */ GIM_Try, /*On fail goto*//*Label 28907*/ GIMT_Encode4(2196680), // Rule ID 47483 //
     /* 2196631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2196634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2196637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196645 */   // (anyext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2196662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196679 */   // GIR_Coverage, 47483,
     /* 2196679 */   GIR_EraseRootFromParent_Done,
     /* 2196680 */ // Label 28907: @2196680
     /* 2196680 */ GIM_Try, /*On fail goto*//*Label 28908*/ GIMT_Encode4(2196734), // Rule ID 47516 //
     /* 2196685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2196688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2196691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196699 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2196716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196721 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196733 */   // GIR_Coverage, 47516,
     /* 2196733 */   GIR_EraseRootFromParent_Done,
     /* 2196734 */ // Label 28908: @2196734
     /* 2196734 */ GIM_Try, /*On fail goto*//*Label 28909*/ GIMT_Encode4(2196788), // Rule ID 47517 //
     /* 2196739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2196742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2196745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2196753 */   // (anyext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196753 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2196756 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196760 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196765 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2196770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196772 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2196783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196787 */   // GIR_Coverage, 47517,
     /* 2196787 */   GIR_EraseRootFromParent_Done,
     /* 2196788 */ // Label 28909: @2196788
     /* 2196788 */ GIM_Reject,
     /* 2196789 */ // Label 28854: @2196789
     /* 2196789 */ GIM_Try, /*On fail goto*//*Label 28910*/ GIMT_Encode4(2196892),
     /* 2196794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2196797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2196805 */   GIM_Try, /*On fail goto*//*Label 28911*/ GIMT_Encode4(2196848), // Rule ID 47376 //
     /* 2196810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2196813 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2196816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2196830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196835 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196847 */     // GIR_Coverage, 47376,
     /* 2196847 */     GIR_EraseRootFromParent_Done,
     /* 2196848 */   // Label 28911: @2196848
     /* 2196848 */   GIM_Try, /*On fail goto*//*Label 28912*/ GIMT_Encode4(2196891), // Rule ID 47377 //
     /* 2196853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2196856 */     // (anyext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2196859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2196873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2196886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2196890 */     // GIR_Coverage, 47377,
     /* 2196890 */     GIR_EraseRootFromParent_Done,
     /* 2196891 */   // Label 28912: @2196891
     /* 2196891 */   GIM_Reject,
     /* 2196892 */ // Label 28910: @2196892
     /* 2196892 */ GIM_Reject,
     /* 2196893 */ // Label 28855: @2196893
     /* 2196893 */ GIM_Try, /*On fail goto*//*Label 28913*/ GIMT_Encode4(2196947), // Rule ID 47400 //
     /* 2196898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2196901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2196904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196912 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2196912 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2196915 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196919 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2196929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196934 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196945 */   GIR_RootConstrainSelectedInstOperands,
     /* 2196946 */   // GIR_Coverage, 47400,
     /* 2196946 */   GIR_EraseRootFromParent_Done,
     /* 2196947 */ // Label 28913: @2196947
     /* 2196947 */ GIM_Try, /*On fail goto*//*Label 28914*/ GIMT_Encode4(2197001), // Rule ID 47401 //
     /* 2196952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2196955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2196958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2196962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2196966 */   // (anyext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2196966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2196969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2196973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2196978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2196980 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2196983 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2196985 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2196988 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2196990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2196993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2196996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2196999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197000 */   // GIR_Coverage, 47401,
     /* 2197000 */   GIR_EraseRootFromParent_Done,
     /* 2197001 */ // Label 28914: @2197001
     /* 2197001 */ GIM_Try, /*On fail goto*//*Label 28915*/ GIMT_Encode4(2197055), // Rule ID 47466 //
     /* 2197006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2197009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2197012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197020 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2197020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2197023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2197037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197054 */   // GIR_Coverage, 47466,
     /* 2197054 */   GIR_EraseRootFromParent_Done,
     /* 2197055 */ // Label 28915: @2197055
     /* 2197055 */ GIM_Try, /*On fail goto*//*Label 28916*/ GIMT_Encode4(2197109), // Rule ID 47467 //
     /* 2197060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2197063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2197066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2197074 */   // (anyext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2197074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2197077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2197091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197096 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197108 */   // GIR_Coverage, 47467,
     /* 2197108 */   GIR_EraseRootFromParent_Done,
     /* 2197109 */ // Label 28916: @2197109
     /* 2197109 */ GIM_Reject,
     /* 2197110 */ // Label 28856: @2197110
     /* 2197110 */ GIM_Try, /*On fail goto*//*Label 28917*/ GIMT_Encode4(2197213),
     /* 2197115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2197118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2197122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2197126 */   GIM_Try, /*On fail goto*//*Label 28918*/ GIMT_Encode4(2197169), // Rule ID 47380 //
     /* 2197131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2197134 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2197134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2197137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2197151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197168 */     // GIR_Coverage, 47380,
     /* 2197168 */     GIR_EraseRootFromParent_Done,
     /* 2197169 */   // Label 28918: @2197169
     /* 2197169 */   GIM_Try, /*On fail goto*//*Label 28919*/ GIMT_Encode4(2197212), // Rule ID 47381 //
     /* 2197174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2197177 */     // (anyext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2197177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2197180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2197194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197210 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197211 */     // GIR_Coverage, 47381,
     /* 2197211 */     GIR_EraseRootFromParent_Done,
     /* 2197212 */   // Label 28919: @2197212
     /* 2197212 */   GIM_Reject,
     /* 2197213 */ // Label 28917: @2197213
     /* 2197213 */ GIM_Reject,
     /* 2197214 */ // Label 28857: @2197214
     /* 2197214 */ GIM_Reject,
     /* 2197215 */ // Label 40: @2197215
     /* 2197215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 28937*/ GIMT_Encode4(2200689),
     /* 2197226 */ /*GILLT_s32*//*Label 28920*/ GIMT_Encode4(2197342),
     /* 2197230 */ /*GILLT_s64*//*Label 28921*/ GIMT_Encode4(2197516), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197242 */ /*GILLT_nxv1s16*//*Label 28922*/ GIMT_Encode4(2197680),
     /* 2197246 */ /*GILLT_nxv1s32*//*Label 28923*/ GIMT_Encode4(2197784),
     /* 2197250 */ /*GILLT_nxv1s64*//*Label 28924*/ GIMT_Encode4(2198001), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197262 */ /*GILLT_nxv2s16*//*Label 28925*/ GIMT_Encode4(2198326),
     /* 2197266 */ /*GILLT_nxv2s32*//*Label 28926*/ GIMT_Encode4(2198430),
     /* 2197270 */ /*GILLT_nxv2s64*//*Label 28927*/ GIMT_Encode4(2198647), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197282 */ /*GILLT_nxv4s16*//*Label 28928*/ GIMT_Encode4(2198972),
     /* 2197286 */ /*GILLT_nxv4s32*//*Label 28929*/ GIMT_Encode4(2199076),
     /* 2197290 */ /*GILLT_nxv4s64*//*Label 28930*/ GIMT_Encode4(2199293), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197302 */ /*GILLT_nxv8s16*//*Label 28931*/ GIMT_Encode4(2199618),
     /* 2197306 */ /*GILLT_nxv8s32*//*Label 28932*/ GIMT_Encode4(2199722),
     /* 2197310 */ /*GILLT_nxv8s64*//*Label 28933*/ GIMT_Encode4(2199939), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197322 */ /*GILLT_nxv16s16*//*Label 28934*/ GIMT_Encode4(2200264),
     /* 2197326 */ /*GILLT_nxv16s32*//*Label 28935*/ GIMT_Encode4(2200368), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2197338 */ /*GILLT_nxv32s16*//*Label 28936*/ GIMT_Encode4(2200585),
     /* 2197342 */ // Label 28920: @2197342
     /* 2197342 */ GIM_Try, /*On fail goto*//*Label 28938*/ GIMT_Encode4(2197515),
     /* 2197347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2197350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197358 */   GIM_Try, /*On fail goto*//*Label 28939*/ GIMT_Encode4(2197400), // Rule ID 65046 //
     /* 2197363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode1),
     /* 2197366 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2197366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2197369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2197373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197378 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2197382 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2197385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2197390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2197398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197399 */     // GIR_Coverage, 65046,
     /* 2197399 */     GIR_EraseRootFromParent_Done,
     /* 2197400 */   // Label 28939: @2197400
     /* 2197400 */   GIM_Try, /*On fail goto*//*Label 28940*/ GIMT_Encode4(2197442), // Rule ID 65048 //
     /* 2197405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2197408 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2197408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2197411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2197415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197420 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2197424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2197427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2197432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2197440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197441 */     // GIR_Coverage, 65048,
     /* 2197441 */     GIR_EraseRootFromParent_Done,
     /* 2197442 */   // Label 28940: @2197442
     /* 2197442 */   GIM_Try, /*On fail goto*//*Label 28941*/ GIMT_Encode4(2197484), // Rule ID 65049 //
     /* 2197447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode1),
     /* 2197450 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2197450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2197453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2197457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197462 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2197466 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2197469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2197474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2197482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197483 */     // GIR_Coverage, 65049,
     /* 2197483 */     GIR_EraseRootFromParent_Done,
     /* 2197484 */   // Label 28941: @2197484
     /* 2197484 */   GIM_Try, /*On fail goto*//*Label 28942*/ GIMT_Encode4(2197499), // Rule ID 65051 //
     /* 2197489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2197492 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2197492 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2197497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197498 */     // GIR_Coverage, 65051,
     /* 2197498 */     GIR_Done,
     /* 2197499 */   // Label 28942: @2197499
     /* 2197499 */   GIM_Try, /*On fail goto*//*Label 28943*/ GIMT_Encode4(2197514), // Rule ID 65052 //
     /* 2197504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2197507 */     // (sext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2197507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2197512 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197513 */     // GIR_Coverage, 65052,
     /* 2197513 */     GIR_Done,
     /* 2197514 */   // Label 28943: @2197514
     /* 2197514 */   GIM_Reject,
     /* 2197515 */ // Label 28938: @2197515
     /* 2197515 */ GIM_Reject,
     /* 2197516 */ // Label 28921: @2197516
     /* 2197516 */ GIM_Try, /*On fail goto*//*Label 28944*/ GIMT_Encode4(2197547), // Rule ID 65036 //
     /* 2197521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2197524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2197527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197535 */   // (sext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i32] }:$src, 0:{ *:[i64] })
     /* 2197535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2197538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197540 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2197542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2197545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197546 */   // GIR_Coverage, 65036,
     /* 2197546 */   GIR_EraseRootFromParent_Done,
     /* 2197547 */ // Label 28944: @2197547
     /* 2197547 */ GIM_Try, /*On fail goto*//*Label 28945*/ GIMT_Encode4(2197600), // Rule ID 65045 //
     /* 2197552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_HwMode0),
     /* 2197555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2197558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197566 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2197566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2197569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2197573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197578 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2197582 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2197585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2197590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2197598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197599 */   // GIR_Coverage, 65045,
     /* 2197599 */   GIR_EraseRootFromParent_Done,
     /* 2197600 */ // Label 28945: @2197600
     /* 2197600 */ GIM_Try, /*On fail goto*//*Label 28946*/ GIMT_Encode4(2197653), // Rule ID 65047 //
     /* 2197605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_HwMode0),
     /* 2197608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2197611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197619 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRAI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2197619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2197622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2197626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197631 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2197635 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2197638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2197643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197645 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2197651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197652 */   // GIR_Coverage, 65047,
     /* 2197652 */   GIR_EraseRootFromParent_Done,
     /* 2197653 */ // Label 28946: @2197653
     /* 2197653 */ GIM_Try, /*On fail goto*//*Label 28947*/ GIMT_Encode4(2197679), // Rule ID 65053 //
     /* 2197658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2197661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2197664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2197672 */   // (sext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2197672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2197677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197678 */   // GIR_Coverage, 65053,
     /* 2197678 */   GIR_Done,
     /* 2197679 */ // Label 28947: @2197679
     /* 2197679 */ GIM_Reject,
     /* 2197680 */ // Label 28922: @2197680
     /* 2197680 */ GIM_Try, /*On fail goto*//*Label 28948*/ GIMT_Encode4(2197783),
     /* 2197685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2197688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197696 */   GIM_Try, /*On fail goto*//*Label 28949*/ GIMT_Encode4(2197739), // Rule ID 47418 //
     /* 2197701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2197704 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2197704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2197707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2197721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197738 */     // GIR_Coverage, 47418,
     /* 2197738 */     GIR_EraseRootFromParent_Done,
     /* 2197739 */   // Label 28949: @2197739
     /* 2197739 */   GIM_Try, /*On fail goto*//*Label 28950*/ GIMT_Encode4(2197782), // Rule ID 47419 //
     /* 2197744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2197747 */     // (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2197747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2197750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF4),
     /* 2197764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2197777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197780 */     GIR_RootConstrainSelectedInstOperands,
     /* 2197781 */     // GIR_Coverage, 47419,
     /* 2197781 */     GIR_EraseRootFromParent_Done,
     /* 2197782 */   // Label 28950: @2197782
     /* 2197782 */   GIM_Reject,
     /* 2197783 */ // Label 28948: @2197783
     /* 2197783 */ GIM_Reject,
     /* 2197784 */ // Label 28923: @2197784
     /* 2197784 */ GIM_Try, /*On fail goto*//*Label 28951*/ GIMT_Encode4(2197838), // Rule ID 47430 //
     /* 2197789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2197792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2197795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197803 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2197803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2197806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2197820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197822 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197825 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197837 */   // GIR_Coverage, 47430,
     /* 2197837 */   GIR_EraseRootFromParent_Done,
     /* 2197838 */ // Label 28951: @2197838
     /* 2197838 */ GIM_Try, /*On fail goto*//*Label 28952*/ GIMT_Encode4(2197892), // Rule ID 47431 //
     /* 2197843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2197846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2197849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197857 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2197857 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2197860 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197864 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2197874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197876 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197879 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197891 */   // GIR_Coverage, 47431,
     /* 2197891 */   GIR_EraseRootFromParent_Done,
     /* 2197892 */ // Label 28952: @2197892
     /* 2197892 */ GIM_Try, /*On fail goto*//*Label 28953*/ GIMT_Encode4(2197946), // Rule ID 47484 //
     /* 2197897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2197900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2197903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197911 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2197911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2197914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2197928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197933 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197944 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197945 */   // GIR_Coverage, 47484,
     /* 2197945 */   GIR_EraseRootFromParent_Done,
     /* 2197946 */ // Label 28953: @2197946
     /* 2197946 */ GIM_Try, /*On fail goto*//*Label 28954*/ GIMT_Encode4(2198000), // Rule ID 47485 //
     /* 2197951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2197954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2197957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2197965 */   // (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2197965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2197968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2197972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2197977 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2197979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_MF2),
     /* 2197982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2197984 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2197987 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2197989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2197992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2197995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2197998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2197999 */   // GIR_Coverage, 47485,
     /* 2197999 */   GIR_EraseRootFromParent_Done,
     /* 2198000 */ // Label 28954: @2198000
     /* 2198000 */ GIM_Reject,
     /* 2198001 */ // Label 28924: @2198001
     /* 2198001 */ GIM_Try, /*On fail goto*//*Label 28955*/ GIMT_Encode4(2198055), // Rule ID 47440 //
     /* 2198006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2198012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198020 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198020 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198023 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198027 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2198037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198039 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198042 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198054 */   // GIR_Coverage, 47440,
     /* 2198054 */   GIR_EraseRootFromParent_Done,
     /* 2198055 */ // Label 28955: @2198055
     /* 2198055 */ GIM_Try, /*On fail goto*//*Label 28956*/ GIMT_Encode4(2198109), // Rule ID 47441 //
     /* 2198060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2198066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198074 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2198091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198093 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198096 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198108 */   // GIR_Coverage, 47441,
     /* 2198108 */   GIR_EraseRootFromParent_Done,
     /* 2198109 */ // Label 28956: @2198109
     /* 2198109 */ GIM_Try, /*On fail goto*//*Label 28957*/ GIMT_Encode4(2198163), // Rule ID 47494 //
     /* 2198114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2198120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198128 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2198145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198150 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198162 */   // GIR_Coverage, 47494,
     /* 2198162 */   GIR_EraseRootFromParent_Done,
     /* 2198163 */ // Label 28957: @2198163
     /* 2198163 */ GIM_Try, /*On fail goto*//*Label 28958*/ GIMT_Encode4(2198217), // Rule ID 47495 //
     /* 2198168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2198174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198182 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198182 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198185 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198189 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198194 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2198199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198204 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198216 */   // GIR_Coverage, 47495,
     /* 2198216 */   GIR_EraseRootFromParent_Done,
     /* 2198217 */ // Label 28958: @2198217
     /* 2198217 */ GIM_Try, /*On fail goto*//*Label 28959*/ GIMT_Encode4(2198271), // Rule ID 47518 //
     /* 2198222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2198228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198236 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2198253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198258 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198270 */   // GIR_Coverage, 47518,
     /* 2198270 */   GIR_EraseRootFromParent_Done,
     /* 2198271 */ // Label 28959: @2198271
     /* 2198271 */ GIM_Try, /*On fail goto*//*Label 28960*/ GIMT_Encode4(2198325), // Rule ID 47519 //
     /* 2198276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2198282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198290 */   // (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2198293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198304 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M1),
     /* 2198307 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198309 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198312 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198324 */   // GIR_Coverage, 47519,
     /* 2198324 */   GIR_EraseRootFromParent_Done,
     /* 2198325 */ // Label 28960: @2198325
     /* 2198325 */ GIM_Reject,
     /* 2198326 */ // Label 28925: @2198326
     /* 2198326 */ GIM_Try, /*On fail goto*//*Label 28961*/ GIMT_Encode4(2198429),
     /* 2198331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2198334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198342 */   GIM_Try, /*On fail goto*//*Label 28962*/ GIMT_Encode4(2198385), // Rule ID 47420 //
     /* 2198347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198350 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2198353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2198367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198384 */     // GIR_Coverage, 47420,
     /* 2198384 */     GIR_EraseRootFromParent_Done,
     /* 2198385 */   // Label 28962: @2198385
     /* 2198385 */   GIM_Try, /*On fail goto*//*Label 28963*/ GIMT_Encode4(2198428), // Rule ID 47421 //
     /* 2198390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198393 */     // (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2198396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_MF2),
     /* 2198410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2198423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2198427 */     // GIR_Coverage, 47421,
     /* 2198427 */     GIR_EraseRootFromParent_Done,
     /* 2198428 */   // Label 28963: @2198428
     /* 2198428 */   GIM_Reject,
     /* 2198429 */ // Label 28961: @2198429
     /* 2198429 */ GIM_Reject,
     /* 2198430 */ // Label 28926: @2198430
     /* 2198430 */ GIM_Try, /*On fail goto*//*Label 28964*/ GIMT_Encode4(2198484), // Rule ID 47432 //
     /* 2198435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2198441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198449 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198449 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2198452 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198456 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198461 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2198466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198468 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198471 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198483 */   // GIR_Coverage, 47432,
     /* 2198483 */   GIR_EraseRootFromParent_Done,
     /* 2198484 */ // Label 28964: @2198484
     /* 2198484 */ GIM_Try, /*On fail goto*//*Label 28965*/ GIMT_Encode4(2198538), // Rule ID 47433 //
     /* 2198489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2198495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198503 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2198506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2198520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198525 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198537 */   // GIR_Coverage, 47433,
     /* 2198537 */   GIR_EraseRootFromParent_Done,
     /* 2198538 */ // Label 28965: @2198538
     /* 2198538 */ GIM_Try, /*On fail goto*//*Label 28966*/ GIMT_Encode4(2198592), // Rule ID 47486 //
     /* 2198543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2198549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198557 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2198560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2198574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198579 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198591 */   // GIR_Coverage, 47486,
     /* 2198591 */   GIR_EraseRootFromParent_Done,
     /* 2198592 */ // Label 28966: @2198592
     /* 2198592 */ GIM_Try, /*On fail goto*//*Label 28967*/ GIMT_Encode4(2198646), // Rule ID 47487 //
     /* 2198597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2198600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2198603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198611 */   // (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198611 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2198614 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198618 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198623 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M1),
     /* 2198628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198630 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198633 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2198641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198645 */   // GIR_Coverage, 47487,
     /* 2198645 */   GIR_EraseRootFromParent_Done,
     /* 2198646 */ // Label 28967: @2198646
     /* 2198646 */ GIM_Reject,
     /* 2198647 */ // Label 28927: @2198647
     /* 2198647 */ GIM_Try, /*On fail goto*//*Label 28968*/ GIMT_Encode4(2198701), // Rule ID 47442 //
     /* 2198652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2198658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198666 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198678 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2198683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198688 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198700 */   // GIR_Coverage, 47442,
     /* 2198700 */   GIR_EraseRootFromParent_Done,
     /* 2198701 */ // Label 28968: @2198701
     /* 2198701 */ GIM_Try, /*On fail goto*//*Label 28969*/ GIMT_Encode4(2198755), // Rule ID 47443 //
     /* 2198706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2198712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198720 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2198737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198742 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198753 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198754 */   // GIR_Coverage, 47443,
     /* 2198754 */   GIR_EraseRootFromParent_Done,
     /* 2198755 */ // Label 28969: @2198755
     /* 2198755 */ GIM_Try, /*On fail goto*//*Label 28970*/ GIMT_Encode4(2198809), // Rule ID 47496 //
     /* 2198760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2198766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198774 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2198791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198808 */   // GIR_Coverage, 47496,
     /* 2198808 */   GIR_EraseRootFromParent_Done,
     /* 2198809 */ // Label 28970: @2198809
     /* 2198809 */ GIM_Try, /*On fail goto*//*Label 28971*/ GIMT_Encode4(2198863), // Rule ID 47497 //
     /* 2198814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2198820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198828 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2198845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198850 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198862 */   // GIR_Coverage, 47497,
     /* 2198862 */   GIR_EraseRootFromParent_Done,
     /* 2198863 */ // Label 28971: @2198863
     /* 2198863 */ GIM_Try, /*On fail goto*//*Label 28972*/ GIMT_Encode4(2198917), // Rule ID 47520 //
     /* 2198868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2198871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2198874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198882 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198882 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198885 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198889 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2198899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198904 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198915 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198916 */   // GIR_Coverage, 47520,
     /* 2198916 */   GIR_EraseRootFromParent_Done,
     /* 2198917 */ // Label 28972: @2198917
     /* 2198917 */ GIM_Try, /*On fail goto*//*Label 28973*/ GIMT_Encode4(2198971), // Rule ID 47521 //
     /* 2198922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2198925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2198928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2198932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198936 */   // (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2198936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2198939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2198943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2198948 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2198950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M2),
     /* 2198953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2198955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2198958 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2198960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2198963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2198966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2198969 */   GIR_RootConstrainSelectedInstOperands,
     /* 2198970 */   // GIR_Coverage, 47521,
     /* 2198970 */   GIR_EraseRootFromParent_Done,
     /* 2198971 */ // Label 28973: @2198971
     /* 2198971 */ GIM_Reject,
     /* 2198972 */ // Label 28928: @2198972
     /* 2198972 */ GIM_Try, /*On fail goto*//*Label 28974*/ GIMT_Encode4(2199075),
     /* 2198977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2198980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2198988 */   GIM_Try, /*On fail goto*//*Label 28975*/ GIMT_Encode4(2199031), // Rule ID 47422 //
     /* 2198993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2198996 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2198996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2198999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2199013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199030 */     // GIR_Coverage, 47422,
     /* 2199030 */     GIR_EraseRootFromParent_Done,
     /* 2199031 */   // Label 28975: @2199031
     /* 2199031 */   GIM_Try, /*On fail goto*//*Label 28976*/ GIMT_Encode4(2199074), // Rule ID 47423 //
     /* 2199036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199039 */     // (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2199042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M1),
     /* 2199056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199073 */     // GIR_Coverage, 47423,
     /* 2199073 */     GIR_EraseRootFromParent_Done,
     /* 2199074 */   // Label 28976: @2199074
     /* 2199074 */   GIM_Reject,
     /* 2199075 */ // Label 28974: @2199075
     /* 2199075 */ GIM_Reject,
     /* 2199076 */ // Label 28929: @2199076
     /* 2199076 */ GIM_Try, /*On fail goto*//*Label 28977*/ GIMT_Encode4(2199130), // Rule ID 47434 //
     /* 2199081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2199087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199095 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199095 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2199098 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199102 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2199112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199117 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199129 */   // GIR_Coverage, 47434,
     /* 2199129 */   GIR_EraseRootFromParent_Done,
     /* 2199130 */ // Label 28977: @2199130
     /* 2199130 */ GIM_Try, /*On fail goto*//*Label 28978*/ GIMT_Encode4(2199184), // Rule ID 47435 //
     /* 2199135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2199141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199149 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199149 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2199152 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199156 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2199166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199171 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199183 */   // GIR_Coverage, 47435,
     /* 2199183 */   GIR_EraseRootFromParent_Done,
     /* 2199184 */ // Label 28978: @2199184
     /* 2199184 */ GIM_Try, /*On fail goto*//*Label 28979*/ GIMT_Encode4(2199238), // Rule ID 47488 //
     /* 2199189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2199195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199203 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2199206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2199220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199222 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199225 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199237 */   // GIR_Coverage, 47488,
     /* 2199237 */   GIR_EraseRootFromParent_Done,
     /* 2199238 */ // Label 28979: @2199238
     /* 2199238 */ GIM_Try, /*On fail goto*//*Label 28980*/ GIMT_Encode4(2199292), // Rule ID 47489 //
     /* 2199243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2199249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199257 */   // (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199257 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2199260 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199264 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199269 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199271 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M2),
     /* 2199274 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199276 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199279 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199291 */   // GIR_Coverage, 47489,
     /* 2199291 */   GIR_EraseRootFromParent_Done,
     /* 2199292 */ // Label 28980: @2199292
     /* 2199292 */ GIM_Reject,
     /* 2199293 */ // Label 28930: @2199293
     /* 2199293 */ GIM_Try, /*On fail goto*//*Label 28981*/ GIMT_Encode4(2199347), // Rule ID 47444 //
     /* 2199298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199312 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199324 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2199329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199331 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199334 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199336 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199345 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199346 */   // GIR_Coverage, 47444,
     /* 2199346 */   GIR_EraseRootFromParent_Done,
     /* 2199347 */ // Label 28981: @2199347
     /* 2199347 */ GIM_Try, /*On fail goto*//*Label 28982*/ GIMT_Encode4(2199401), // Rule ID 47445 //
     /* 2199352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2199358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199366 */   // (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2199383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199385 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199388 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199399 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199400 */   // GIR_Coverage, 47445,
     /* 2199400 */   GIR_EraseRootFromParent_Done,
     /* 2199401 */ // Label 28982: @2199401
     /* 2199401 */ GIM_Try, /*On fail goto*//*Label 28983*/ GIMT_Encode4(2199455), // Rule ID 47498 //
     /* 2199406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2199412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199420 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199420 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199423 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199427 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199432 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2199437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199442 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199444 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199447 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199453 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199454 */   // GIR_Coverage, 47498,
     /* 2199454 */   GIR_EraseRootFromParent_Done,
     /* 2199455 */ // Label 28983: @2199455
     /* 2199455 */ GIM_Try, /*On fail goto*//*Label 28984*/ GIMT_Encode4(2199509), // Rule ID 47499 //
     /* 2199460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2199466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199474 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2199491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199493 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199508 */   // GIR_Coverage, 47499,
     /* 2199508 */   GIR_EraseRootFromParent_Done,
     /* 2199509 */ // Label 28984: @2199509
     /* 2199509 */ GIM_Try, /*On fail goto*//*Label 28985*/ GIMT_Encode4(2199563), // Rule ID 47522 //
     /* 2199514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2199520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199528 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2199545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199550 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199561 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199562 */   // GIR_Coverage, 47522,
     /* 2199562 */   GIR_EraseRootFromParent_Done,
     /* 2199563 */ // Label 28985: @2199563
     /* 2199563 */ GIM_Try, /*On fail goto*//*Label 28986*/ GIMT_Encode4(2199617), // Rule ID 47523 //
     /* 2199568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2199571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2199574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199582 */   // (sext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199582 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2199585 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199589 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M4),
     /* 2199599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199604 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199616 */   // GIR_Coverage, 47523,
     /* 2199616 */   GIR_EraseRootFromParent_Done,
     /* 2199617 */ // Label 28986: @2199617
     /* 2199617 */ GIM_Reject,
     /* 2199618 */ // Label 28931: @2199618
     /* 2199618 */ GIM_Try, /*On fail goto*//*Label 28987*/ GIMT_Encode4(2199721),
     /* 2199623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2199626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199634 */   GIM_Try, /*On fail goto*//*Label 28988*/ GIMT_Encode4(2199677), // Rule ID 47424 //
     /* 2199639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199642 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2199645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2199659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199676 */     // GIR_Coverage, 47424,
     /* 2199676 */     GIR_EraseRootFromParent_Done,
     /* 2199677 */   // Label 28988: @2199677
     /* 2199677 */   GIM_Try, /*On fail goto*//*Label 28989*/ GIMT_Encode4(2199720), // Rule ID 47425 //
     /* 2199682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199685 */     // (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2199688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M2),
     /* 2199702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2199715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2199719 */     // GIR_Coverage, 47425,
     /* 2199719 */     GIR_EraseRootFromParent_Done,
     /* 2199720 */   // Label 28989: @2199720
     /* 2199720 */   GIM_Reject,
     /* 2199721 */ // Label 28987: @2199721
     /* 2199721 */ GIM_Reject,
     /* 2199722 */ // Label 28932: @2199722
     /* 2199722 */ GIM_Try, /*On fail goto*//*Label 28990*/ GIMT_Encode4(2199776), // Rule ID 47436 //
     /* 2199727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2199733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199741 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2199744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2199758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199763 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199775 */   // GIR_Coverage, 47436,
     /* 2199775 */   GIR_EraseRootFromParent_Done,
     /* 2199776 */ // Label 28990: @2199776
     /* 2199776 */ GIM_Try, /*On fail goto*//*Label 28991*/ GIMT_Encode4(2199830), // Rule ID 47437 //
     /* 2199781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2199787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2199795 */   // (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199795 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2199798 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199802 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199809 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2199812 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199814 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199817 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199829 */   // GIR_Coverage, 47437,
     /* 2199829 */   GIR_EraseRootFromParent_Done,
     /* 2199830 */ // Label 28991: @2199830
     /* 2199830 */ GIM_Try, /*On fail goto*//*Label 28992*/ GIMT_Encode4(2199884), // Rule ID 47490 //
     /* 2199835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2199838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2199841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199849 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199849 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2199852 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199856 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199861 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2199866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199871 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199876 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199883 */   // GIR_Coverage, 47490,
     /* 2199883 */   GIR_EraseRootFromParent_Done,
     /* 2199884 */ // Label 28992: @2199884
     /* 2199884 */ GIM_Try, /*On fail goto*//*Label 28993*/ GIMT_Encode4(2199938), // Rule ID 47491 //
     /* 2199889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2199892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2199895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2199903 */   // (sext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2199903 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2199906 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199910 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M4),
     /* 2199920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199922 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199925 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2199933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199937 */   // GIR_Coverage, 47491,
     /* 2199937 */   GIR_EraseRootFromParent_Done,
     /* 2199938 */ // Label 28993: @2199938
     /* 2199938 */ GIM_Reject,
     /* 2199939 */ // Label 28933: @2199939
     /* 2199939 */ GIM_Try, /*On fail goto*//*Label 28994*/ GIMT_Encode4(2199993), // Rule ID 47446 //
     /* 2199944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2199947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2199950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2199954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2199958 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2199958 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2199961 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2199965 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2199970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2199972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2199975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2199977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2199980 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2199982 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2199985 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2199988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2199991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2199992 */   // GIR_Coverage, 47446,
     /* 2199992 */   GIR_EraseRootFromParent_Done,
     /* 2199993 */ // Label 28994: @2199993
     /* 2199993 */ GIM_Try, /*On fail goto*//*Label 28995*/ GIMT_Encode4(2200047), // Rule ID 47447 //
     /* 2199998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2200004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200012 */   // (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200012 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200015 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200019 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2200029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200034 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200036 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200046 */   // GIR_Coverage, 47447,
     /* 2200046 */   GIR_EraseRootFromParent_Done,
     /* 2200047 */ // Label 28995: @2200047
     /* 2200047 */ GIM_Try, /*On fail goto*//*Label 28996*/ GIMT_Encode4(2200101), // Rule ID 47500 //
     /* 2200052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200066 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200066 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200069 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200073 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200078 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2200083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200085 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200088 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200096 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200099 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200100 */   // GIR_Coverage, 47500,
     /* 2200100 */   GIR_EraseRootFromParent_Done,
     /* 2200101 */ // Label 28996: @2200101
     /* 2200101 */ GIM_Try, /*On fail goto*//*Label 28997*/ GIMT_Encode4(2200155), // Rule ID 47501 //
     /* 2200106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2200112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200120 */   // (sext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200132 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2200137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200139 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200142 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200154 */   // GIR_Coverage, 47501,
     /* 2200154 */   GIR_EraseRootFromParent_Done,
     /* 2200155 */ // Label 28997: @2200155
     /* 2200155 */ GIM_Try, /*On fail goto*//*Label 28998*/ GIMT_Encode4(2200209), // Rule ID 47524 //
     /* 2200160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2200163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2200166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200174 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2200191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200196 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200208 */   // GIR_Coverage, 47524,
     /* 2200208 */   GIR_EraseRootFromParent_Done,
     /* 2200209 */ // Label 28998: @2200209
     /* 2200209 */ GIM_Try, /*On fail goto*//*Label 28999*/ GIMT_Encode4(2200263), // Rule ID 47525 //
     /* 2200214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2200217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2200220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2200228 */   // (sext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2200231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF8_M8),
     /* 2200245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200250 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2200258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200262 */   // GIR_Coverage, 47525,
     /* 2200262 */   GIR_EraseRootFromParent_Done,
     /* 2200263 */ // Label 28999: @2200263
     /* 2200263 */ GIM_Reject,
     /* 2200264 */ // Label 28934: @2200264
     /* 2200264 */ GIM_Try, /*On fail goto*//*Label 29000*/ GIMT_Encode4(2200367),
     /* 2200269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2200272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200280 */   GIM_Try, /*On fail goto*//*Label 29001*/ GIMT_Encode4(2200323), // Rule ID 47426 //
     /* 2200285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200288 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2200291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2200305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200322 */     // GIR_Coverage, 47426,
     /* 2200322 */     GIR_EraseRootFromParent_Done,
     /* 2200323 */   // Label 29001: @2200323
     /* 2200323 */   GIM_Try, /*On fail goto*//*Label 29002*/ GIMT_Encode4(2200366), // Rule ID 47427 //
     /* 2200328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200331 */     // (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2200334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M4),
     /* 2200348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200365 */     // GIR_Coverage, 47427,
     /* 2200365 */     GIR_EraseRootFromParent_Done,
     /* 2200366 */   // Label 29002: @2200366
     /* 2200366 */   GIM_Reject,
     /* 2200367 */ // Label 29000: @2200367
     /* 2200367 */ GIM_Reject,
     /* 2200368 */ // Label 28935: @2200368
     /* 2200368 */ GIM_Try, /*On fail goto*//*Label 29003*/ GIMT_Encode4(2200422), // Rule ID 47438 //
     /* 2200373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2200379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200387 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2200390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2200404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200421 */   // GIR_Coverage, 47438,
     /* 2200421 */   GIR_EraseRootFromParent_Done,
     /* 2200422 */ // Label 29003: @2200422
     /* 2200422 */ GIM_Try, /*On fail goto*//*Label 29004*/ GIMT_Encode4(2200476), // Rule ID 47439 //
     /* 2200427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2200433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200441 */   // (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2200444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2200458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200463 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200475 */   // GIR_Coverage, 47439,
     /* 2200475 */   GIR_EraseRootFromParent_Done,
     /* 2200476 */ // Label 29004: @2200476
     /* 2200476 */ GIM_Try, /*On fail goto*//*Label 29005*/ GIMT_Encode4(2200530), // Rule ID 47492 //
     /* 2200481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2200487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200495 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2200498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2200512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200517 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200529 */   // GIR_Coverage, 47492,
     /* 2200529 */   GIR_EraseRootFromParent_Done,
     /* 2200530 */ // Label 29005: @2200530
     /* 2200530 */ GIM_Try, /*On fail goto*//*Label 29006*/ GIMT_Encode4(2200584), // Rule ID 47493 //
     /* 2200535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2200541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2200549 */   // (sext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2200552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF4_M8),
     /* 2200566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2200579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2200583 */   // GIR_Coverage, 47493,
     /* 2200583 */   GIR_EraseRootFromParent_Done,
     /* 2200584 */ // Label 29006: @2200584
     /* 2200584 */ GIM_Reject,
     /* 2200585 */ // Label 28936: @2200585
     /* 2200585 */ GIM_Try, /*On fail goto*//*Label 29007*/ GIMT_Encode4(2200688),
     /* 2200590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2200593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2200597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2200601 */   GIM_Try, /*On fail goto*//*Label 29008*/ GIMT_Encode4(2200644), // Rule ID 47428 //
     /* 2200606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2200609 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2200609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2200612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2200626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200643 */     // GIR_Coverage, 47428,
     /* 2200643 */     GIR_EraseRootFromParent_Done,
     /* 2200644 */   // Label 29008: @2200644
     /* 2200644 */   GIM_Try, /*On fail goto*//*Label 29009*/ GIMT_Encode4(2200687), // Rule ID 47429 //
     /* 2200649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2200652 */     // (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2200652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2200655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2200659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2200664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2200666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSEXT_VF2_M8),
     /* 2200669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2200674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2200676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2200679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2200682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2200685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200686 */     // GIR_Coverage, 47429,
     /* 2200686 */     GIR_EraseRootFromParent_Done,
     /* 2200687 */   // Label 29009: @2200687
     /* 2200687 */   GIM_Reject,
     /* 2200688 */ // Label 29007: @2200688
     /* 2200688 */ GIM_Reject,
     /* 2200689 */ // Label 28937: @2200689
     /* 2200689 */ GIM_Reject,
     /* 2200690 */ // Label 41: @2200690
     /* 2200690 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 29012*/ GIMT_Encode4(2201238),
     /* 2200701 */ /*GILLT_s32*//*Label 29010*/ GIMT_Encode4(2200709),
     /* 2200705 */ /*GILLT_s64*//*Label 29011*/ GIMT_Encode4(2200941),
     /* 2200709 */ // Label 29010: @2200709
     /* 2200709 */ GIM_Try, /*On fail goto*//*Label 29013*/ GIMT_Encode4(2200940),
     /* 2200714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2200717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2200721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2200725 */   GIM_Try, /*On fail goto*//*Label 29014*/ GIMT_Encode4(2200753), // Rule ID 64443 //
     /* 2200730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2200733 */     // MIs[0] Operand 2
     /* 2200733 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2200744 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2200744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2200747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200752 */     // GIR_Coverage, 64443,
     /* 2200752 */     GIR_EraseRootFromParent_Done,
     /* 2200753 */   // Label 29014: @2200753
     /* 2200753 */   GIM_Try, /*On fail goto*//*Label 29015*/ GIMT_Encode4(2200781), // Rule ID 64445 //
     /* 2200758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2200761 */     // MIs[0] Operand 2
     /* 2200761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2200772 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2200772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2200775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200780 */     // GIR_Coverage, 64445,
     /* 2200780 */     GIR_EraseRootFromParent_Done,
     /* 2200781 */   // Label 29015: @2200781
     /* 2200781 */   GIM_Try, /*On fail goto*//*Label 29016*/ GIMT_Encode4(2200809), // Rule ID 2415 //
     /* 2200786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2200789 */     // MIs[0] Operand 2
     /* 2200789 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2200800 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2200800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2200803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200808 */     // GIR_Coverage, 2415,
     /* 2200808 */     GIR_EraseRootFromParent_Done,
     /* 2200809 */   // Label 29016: @2200809
     /* 2200809 */   GIM_Try, /*On fail goto*//*Label 29017*/ GIMT_Encode4(2200837), // Rule ID 2417 //
     /* 2200814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2200817 */     // MIs[0] Operand 2
     /* 2200817 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2200828 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2200828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2200831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200836 */     // GIR_Coverage, 2417,
     /* 2200836 */     GIR_EraseRootFromParent_Done,
     /* 2200837 */   // Label 29017: @2200837
     /* 2200837 */   GIM_Try, /*On fail goto*//*Label 29018*/ GIMT_Encode4(2200871), // Rule ID 62529 //
     /* 2200842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2200845 */     // MIs[0] Operand 2
     /* 2200845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2200856 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 15:{ *:[i32] }, 0:{ *:[i32] })
     /* 2200856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2200859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2200866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2200869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200870 */     // GIR_Coverage, 62529,
     /* 2200870 */     GIR_EraseRootFromParent_Done,
     /* 2200871 */   // Label 29018: @2200871
     /* 2200871 */   GIM_Try, /*On fail goto*//*Label 29019*/ GIMT_Encode4(2200905), // Rule ID 62531 //
     /* 2200876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2200879 */     // MIs[0] Operand 2
     /* 2200879 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2200890 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 7:{ *:[i32] }, 0:{ *:[i32] })
     /* 2200890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2200893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2200900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2200903 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200904 */     // GIR_Coverage, 62531,
     /* 2200904 */     GIR_EraseRootFromParent_Done,
     /* 2200905 */   // Label 29019: @2200905
     /* 2200905 */   GIM_Try, /*On fail goto*//*Label 29020*/ GIMT_Encode4(2200939), // Rule ID 62533 //
     /* 2200910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2200913 */     // MIs[0] Operand 2
     /* 2200913 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2200924 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2200924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2200927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2200934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2200937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200938 */     // GIR_Coverage, 62533,
     /* 2200938 */     GIR_EraseRootFromParent_Done,
     /* 2200939 */   // Label 29020: @2200939
     /* 2200939 */   GIM_Reject,
     /* 2200940 */ // Label 29013: @2200940
     /* 2200940 */ GIM_Reject,
     /* 2200941 */ // Label 29011: @2200941
     /* 2200941 */ GIM_Try, /*On fail goto*//*Label 29021*/ GIMT_Encode4(2201237),
     /* 2200946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2200949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2200953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2200957 */   GIM_Try, /*On fail goto*//*Label 29022*/ GIMT_Encode4(2200985), // Rule ID 64442 //
     /* 2200962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2200965 */     // MIs[0] Operand 2
     /* 2200965 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2200976 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (CV_EXTHS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2200976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTHS),
     /* 2200979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2200981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2200983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2200984 */     // GIR_Coverage, 64442,
     /* 2200984 */     GIR_EraseRootFromParent_Done,
     /* 2200985 */   // Label 29022: @2200985
     /* 2200985 */   GIM_Try, /*On fail goto*//*Label 29023*/ GIMT_Encode4(2201013), // Rule ID 64444 //
     /* 2200990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2200993 */     // MIs[0] Operand 2
     /* 2200993 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2201004 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (CV_EXTBS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2201004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_EXTBS),
     /* 2201007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201012 */     // GIR_Coverage, 64444,
     /* 2201012 */     GIR_EraseRootFromParent_Done,
     /* 2201013 */   // Label 29023: @2201013
     /* 2201013 */   GIM_Try, /*On fail goto*//*Label 29024*/ GIMT_Encode4(2201044), // Rule ID 256 //
     /* 2201018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2201021 */     // MIs[0] Operand 2
     /* 2201021 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2201032 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (ADDIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2201032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADDIW),
     /* 2201035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201043 */     // GIR_Coverage, 256,
     /* 2201043 */     GIR_EraseRootFromParent_Done,
     /* 2201044 */   // Label 29024: @2201044
     /* 2201044 */   GIM_Try, /*On fail goto*//*Label 29025*/ GIMT_Encode4(2201072), // Rule ID 2414 //
     /* 2201049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2201052 */     // MIs[0] Operand 2
     /* 2201052 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2201063 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (SEXT_B:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2201063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_B),
     /* 2201066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201071 */     // GIR_Coverage, 2414,
     /* 2201071 */     GIR_EraseRootFromParent_Done,
     /* 2201072 */   // Label 29025: @2201072
     /* 2201072 */   GIM_Try, /*On fail goto*//*Label 29026*/ GIMT_Encode4(2201100), // Rule ID 2416 //
     /* 2201077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2201080 */     // MIs[0] Operand 2
     /* 2201080 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2201091 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (SEXT_H:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2201091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SEXT_H),
     /* 2201094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201099 */     // GIR_Coverage, 2416,
     /* 2201099 */     GIR_EraseRootFromParent_Done,
     /* 2201100 */   // Label 29026: @2201100
     /* 2201100 */   GIM_Try, /*On fail goto*//*Label 29027*/ GIMT_Encode4(2201134), // Rule ID 62527 //
     /* 2201105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2201108 */     // MIs[0] Operand 2
     /* 2201108 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2201119 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 31:{ *:[i64] }, 0:{ *:[i64] })
     /* 2201119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2201122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 2201129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201133 */     // GIR_Coverage, 62527,
     /* 2201133 */     GIR_EraseRootFromParent_Done,
     /* 2201134 */   // Label 29027: @2201134
     /* 2201134 */   GIM_Try, /*On fail goto*//*Label 29028*/ GIMT_Encode4(2201168), // Rule ID 62528 //
     /* 2201139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2201142 */     // MIs[0] Operand 2
     /* 2201142 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2201153 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i16:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 15:{ *:[i64] }, 0:{ *:[i64] })
     /* 2201153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2201156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 2201163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201167 */     // GIR_Coverage, 62528,
     /* 2201167 */     GIR_EraseRootFromParent_Done,
     /* 2201168 */   // Label 29028: @2201168
     /* 2201168 */   GIM_Try, /*On fail goto*//*Label 29029*/ GIMT_Encode4(2201202), // Rule ID 62530 //
     /* 2201173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2201176 */     // MIs[0] Operand 2
     /* 2201176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2201187 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i8:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] }, 0:{ *:[i64] })
     /* 2201187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2201190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2201197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201201 */     // GIR_Coverage, 62530,
     /* 2201201 */     GIR_EraseRootFromParent_Done,
     /* 2201202 */   // Label 29029: @2201202
     /* 2201202 */   GIM_Try, /*On fail goto*//*Label 29030*/ GIMT_Encode4(2201236), // Rule ID 62532 //
     /* 2201207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2201210 */     // MIs[0] Operand 2
     /* 2201210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 2201221 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i1:{ *:[Other] })  =>  (TH_EXT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2201221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_EXT),
     /* 2201224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2201228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2201234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201235 */     // GIR_Coverage, 62532,
     /* 2201235 */     GIR_EraseRootFromParent_Done,
     /* 2201236 */   // Label 29030: @2201236
     /* 2201236 */   GIM_Reject,
     /* 2201237 */ // Label 29021: @2201237
     /* 2201237 */ GIM_Reject,
     /* 2201238 */ // Label 29012: @2201238
     /* 2201238 */ GIM_Reject,
     /* 2201239 */ // Label 42: @2201239
     /* 2201239 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 29048*/ GIMT_Encode4(2204925),
     /* 2201250 */ /*GILLT_s32*//*Label 29031*/ GIMT_Encode4(2201366),
     /* 2201254 */ /*GILLT_s64*//*Label 29032*/ GIMT_Encode4(2201662), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201266 */ /*GILLT_nxv1s16*//*Label 29033*/ GIMT_Encode4(2201916),
     /* 2201270 */ /*GILLT_nxv1s32*//*Label 29034*/ GIMT_Encode4(2202020),
     /* 2201274 */ /*GILLT_nxv1s64*//*Label 29035*/ GIMT_Encode4(2202237), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201286 */ /*GILLT_nxv2s16*//*Label 29036*/ GIMT_Encode4(2202562),
     /* 2201290 */ /*GILLT_nxv2s32*//*Label 29037*/ GIMT_Encode4(2202666),
     /* 2201294 */ /*GILLT_nxv2s64*//*Label 29038*/ GIMT_Encode4(2202883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201306 */ /*GILLT_nxv4s16*//*Label 29039*/ GIMT_Encode4(2203208),
     /* 2201310 */ /*GILLT_nxv4s32*//*Label 29040*/ GIMT_Encode4(2203312),
     /* 2201314 */ /*GILLT_nxv4s64*//*Label 29041*/ GIMT_Encode4(2203529), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201326 */ /*GILLT_nxv8s16*//*Label 29042*/ GIMT_Encode4(2203854),
     /* 2201330 */ /*GILLT_nxv8s32*//*Label 29043*/ GIMT_Encode4(2203958),
     /* 2201334 */ /*GILLT_nxv8s64*//*Label 29044*/ GIMT_Encode4(2204175), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201346 */ /*GILLT_nxv16s16*//*Label 29045*/ GIMT_Encode4(2204500),
     /* 2201350 */ /*GILLT_nxv16s32*//*Label 29046*/ GIMT_Encode4(2204604), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2201362 */ /*GILLT_nxv32s16*//*Label 29047*/ GIMT_Encode4(2204821),
     /* 2201366 */ // Label 29031: @2201366
     /* 2201366 */ GIM_Try, /*On fail goto*//*Label 29049*/ GIMT_Encode4(2201661),
     /* 2201371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201382 */   GIM_Try, /*On fail goto*//*Label 29050*/ GIMT_Encode4(2201424), // Rule ID 65041 //
     /* 2201387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2201390 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 16:{ *:[i32] }), 16:{ *:[i32] })
     /* 2201390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2201393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201406 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2201409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2201422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201423 */     // GIR_Coverage, 65041,
     /* 2201423 */     GIR_EraseRootFromParent_Done,
     /* 2201424 */   // Label 29050: @2201424
     /* 2201424 */   GIM_Try, /*On fail goto*//*Label 29051*/ GIMT_Encode4(2201466), // Rule ID 65043 //
     /* 2201429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2201432 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2201432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2201464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201465 */     // GIR_Coverage, 65043,
     /* 2201465 */     GIR_EraseRootFromParent_Done,
     /* 2201466 */   // Label 29051: @2201466
     /* 2201466 */   GIM_Try, /*On fail goto*//*Label 29052*/ GIMT_Encode4(2201508), // Rule ID 65044 //
     /* 2201471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode1),
     /* 2201474 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i32] } (SLLI:{ *:[i32] } GPR:{ *:[i16] }:$src, 48:{ *:[i32] }), 48:{ *:[i32] })
     /* 2201474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2201477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201490 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2201506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201507 */     // GIR_Coverage, 65044,
     /* 2201507 */     GIR_EraseRootFromParent_Done,
     /* 2201508 */   // Label 29052: @2201508
     /* 2201508 */   GIM_Try, /*On fail goto*//*Label 29053*/ GIMT_Encode4(2201523), // Rule ID 65054 //
     /* 2201513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode0),
     /* 2201516 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201516 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2201521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201522 */     // GIR_Coverage, 65054,
     /* 2201522 */     GIR_Done,
     /* 2201523 */   // Label 29053: @2201523
     /* 2201523 */   GIM_Try, /*On fail goto*//*Label 29054*/ GIMT_Encode4(2201538), // Rule ID 65055 //
     /* 2201528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV32_HwMode1),
     /* 2201531 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV32:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV32),
     /* 2201536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201537 */     // GIR_Coverage, 65055,
     /* 2201537 */     GIR_Done,
     /* 2201538 */   // Label 29054: @2201538
     /* 2201538 */   GIM_Try, /*On fail goto*//*Label 29055*/ GIMT_Encode4(2201553), // Rule ID 65057 //
     /* 2201543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2201546 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2201551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201552 */     // GIR_Coverage, 65057,
     /* 2201552 */     GIR_Done,
     /* 2201553 */   // Label 29055: @2201553
     /* 2201553 */   GIM_Try, /*On fail goto*//*Label 29056*/ GIMT_Encode4(2201568), // Rule ID 65058 //
     /* 2201558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode1),
     /* 2201561 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i32] } GPR:{ *:[i16] }:$rs)
     /* 2201561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2201566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201567 */     // GIR_Coverage, 65058,
     /* 2201567 */     GIR_Done,
     /* 2201568 */   // Label 29056: @2201568
     /* 2201568 */   GIM_Try, /*On fail goto*//*Label 29057*/ GIMT_Encode4(2201591), // Rule ID 65059 //
     /* 2201573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode0),
     /* 2201576 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2201576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2201579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2201583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201590 */     // GIR_Coverage, 65059,
     /* 2201590 */     GIR_EraseRootFromParent_Done,
     /* 2201591 */   // Label 29057: @2201591
     /* 2201591 */   GIM_Try, /*On fail goto*//*Label 29058*/ GIMT_Encode4(2201614), // Rule ID 65060 //
     /* 2201596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV32_NoStdExtZbb_HwMode1),
     /* 2201599 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACK:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2201599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACK),
     /* 2201602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2201606 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201613 */     // GIR_Coverage, 65060,
     /* 2201613 */     GIR_EraseRootFromParent_Done,
     /* 2201614 */   // Label 29058: @2201614
     /* 2201614 */   GIM_Try, /*On fail goto*//*Label 29059*/ GIMT_Encode4(2201637), // Rule ID 65062 //
     /* 2201619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2201622 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2201622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2201625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2201629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201636 */     // GIR_Coverage, 65062,
     /* 2201636 */     GIR_EraseRootFromParent_Done,
     /* 2201637 */   // Label 29059: @2201637
     /* 2201637 */   GIM_Try, /*On fail goto*//*Label 29060*/ GIMT_Encode4(2201660), // Rule ID 65063 //
     /* 2201642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode1),
     /* 2201645 */     // (zext:{ *:[i32] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i32] } GPR:{ *:[i16] }:$rs, X0:{ *:[i32] })
     /* 2201645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2201648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2201652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201659 */     // GIR_Coverage, 65063,
     /* 2201659 */     GIR_EraseRootFromParent_Done,
     /* 2201660 */   // Label 29060: @2201660
     /* 2201660 */   GIM_Reject,
     /* 2201661 */ // Label 29049: @2201661
     /* 2201661 */ GIM_Reject,
     /* 2201662 */ // Label 29032: @2201662
     /* 2201662 */ GIM_Try, /*On fail goto*//*Label 29061*/ GIMT_Encode4(2201715), // Rule ID 65039 //
     /* 2201667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2201670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2201673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201677 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201681 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i32] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 2201681 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201684 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201688 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201693 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201697 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2201700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 2201713 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201714 */   // GIR_Coverage, 65039,
     /* 2201714 */   GIR_EraseRootFromParent_Done,
     /* 2201715 */ // Label 29061: @2201715
     /* 2201715 */ GIM_Try, /*On fail goto*//*Label 29062*/ GIMT_Encode4(2201768), // Rule ID 65040 //
     /* 2201720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV32_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2201723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201734 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 16:{ *:[i64] }), 16:{ *:[i64] })
     /* 2201734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201746 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201750 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 2201753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 2201766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201767 */   // GIR_Coverage, 65040,
     /* 2201767 */   GIR_EraseRootFromParent_Done,
     /* 2201768 */ // Label 29062: @2201768
     /* 2201768 */ GIM_Try, /*On fail goto*//*Label 29063*/ GIMT_Encode4(2201821), // Rule ID 65042 //
     /* 2201773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NoStdExtZbb_NoStdExtZbkb_HwMode0),
     /* 2201776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201787 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$src)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i16] }:$src, 48:{ *:[i64] }), 48:{ *:[i64] })
     /* 2201787 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2201790 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2201794 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201799 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 2201803 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/48,
     /* 2201806 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2201811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201813 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 2201819 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201820 */   // GIR_Coverage, 65042,
     /* 2201820 */   GIR_EraseRootFromParent_Done,
     /* 2201821 */ // Label 29063: @2201821
     /* 2201821 */ GIM_Try, /*On fail goto*//*Label 29064*/ GIMT_Encode4(2201855), // Rule ID 65050 //
     /* 2201826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2201829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2201832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201840 */   // (zext:{ *:[i64] } GPR:{ *:[i32] }:$src)  =>  (ADD_UW:{ *:[i64] } GPR:{ *:[i32] }:$src, X0:{ *:[i64] })
     /* 2201840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ADD_UW),
     /* 2201843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2201847 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201854 */   // GIR_Coverage, 65050,
     /* 2201854 */   GIR_EraseRootFromParent_Done,
     /* 2201855 */ // Label 29064: @2201855
     /* 2201855 */ GIM_Try, /*On fail goto*//*Label 29065*/ GIMT_Encode4(2201881), // Rule ID 65056 //
     /* 2201860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2201863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201874 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (ZEXT_H_RV64:{ *:[i64] } GPR:{ *:[i16] }:$rs)
     /* 2201874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::ZEXT_H_RV64),
     /* 2201879 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201880 */   // GIR_Coverage, 65056,
     /* 2201880 */   GIR_Done,
     /* 2201881 */ // Label 29065: @2201881
     /* 2201881 */ GIM_Try, /*On fail goto*//*Label 29066*/ GIMT_Encode4(2201915), // Rule ID 65061 //
     /* 2201886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbkb_IsRV64_NoStdExtZbb_HwMode0),
     /* 2201889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2201892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2201900 */   // (zext:{ *:[i64] } GPR:{ *:[i16] }:$rs)  =>  (PACKW:{ *:[i64] } GPR:{ *:[i16] }:$rs, X0:{ *:[i64] })
     /* 2201900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PACKW),
     /* 2201903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201905 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2201907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2201913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2201914 */   // GIR_Coverage, 65061,
     /* 2201914 */   GIR_EraseRootFromParent_Done,
     /* 2201915 */ // Label 29066: @2201915
     /* 2201915 */ GIM_Reject,
     /* 2201916 */ // Label 29033: @2201916
     /* 2201916 */ GIM_Try, /*On fail goto*//*Label 29067*/ GIMT_Encode4(2202019),
     /* 2201921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2201924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2201932 */   GIM_Try, /*On fail goto*//*Label 29068*/ GIMT_Encode4(2201975), // Rule ID 45674 //
     /* 2201937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2201940 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2201940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2201943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2201957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2201959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2201962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2201964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2201967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2201970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2201973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2201974 */     // GIR_Coverage, 45674,
     /* 2201974 */     GIR_EraseRootFromParent_Done,
     /* 2201975 */   // Label 29068: @2201975
     /* 2201975 */   GIM_Try, /*On fail goto*//*Label 29069*/ GIMT_Encode4(2202018), // Rule ID 45675 //
     /* 2201980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2201983 */     // (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2201983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2201986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2201990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2201995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2201997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF4),
     /* 2202000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202017 */     // GIR_Coverage, 45675,
     /* 2202017 */     GIR_EraseRootFromParent_Done,
     /* 2202018 */   // Label 29069: @2202018
     /* 2202018 */   GIM_Reject,
     /* 2202019 */ // Label 29067: @2202019
     /* 2202019 */ GIM_Reject,
     /* 2202020 */ // Label 29034: @2202020
     /* 2202020 */ GIM_Try, /*On fail goto*//*Label 29070*/ GIMT_Encode4(2202074), // Rule ID 47382 //
     /* 2202025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202039 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2202056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202061 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202072 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202073 */   // GIR_Coverage, 47382,
     /* 2202073 */   GIR_EraseRootFromParent_Done,
     /* 2202074 */ // Label 29070: @2202074
     /* 2202074 */ GIM_Try, /*On fail goto*//*Label 29071*/ GIMT_Encode4(2202128), // Rule ID 47383 //
     /* 2202079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202093 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2202110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202115 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202127 */   // GIR_Coverage, 47383,
     /* 2202127 */   GIR_EraseRootFromParent_Done,
     /* 2202128 */ // Label 29071: @2202128
     /* 2202128 */ GIM_Try, /*On fail goto*//*Label 29072*/ GIMT_Encode4(2202182), // Rule ID 47448 //
     /* 2202133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202147 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202147 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202150 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202154 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202159 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2202164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202169 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202177 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202180 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202181 */   // GIR_Coverage, 47448,
     /* 2202181 */   GIR_EraseRootFromParent_Done,
     /* 2202182 */ // Label 29072: @2202182
     /* 2202182 */ GIM_Try, /*On fail goto*//*Label 29073*/ GIMT_Encode4(2202236), // Rule ID 47449 //
     /* 2202187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202201 */   // (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF4_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2202204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202213 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_MF2),
     /* 2202218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202223 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202228 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202234 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202235 */   // GIR_Coverage, 47449,
     /* 2202235 */   GIR_EraseRootFromParent_Done,
     /* 2202236 */ // Label 29073: @2202236
     /* 2202236 */ GIM_Reject,
     /* 2202237 */ // Label 29035: @2202237
     /* 2202237 */ GIM_Try, /*On fail goto*//*Label 29074*/ GIMT_Encode4(2202291), // Rule ID 47402 //
     /* 2202242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2202248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202256 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2202273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202290 */   // GIR_Coverage, 47402,
     /* 2202290 */   GIR_EraseRootFromParent_Done,
     /* 2202291 */ // Label 29074: @2202291
     /* 2202291 */ GIM_Try, /*On fail goto*//*Label 29075*/ GIMT_Encode4(2202345), // Rule ID 47403 //
     /* 2202296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2202302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202310 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202310 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202313 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202317 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2202327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202329 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202332 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202344 */   // GIR_Coverage, 47403,
     /* 2202344 */   GIR_EraseRootFromParent_Done,
     /* 2202345 */ // Label 29075: @2202345
     /* 2202345 */ GIM_Try, /*On fail goto*//*Label 29076*/ GIMT_Encode4(2202399), // Rule ID 47468 //
     /* 2202350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202364 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2202381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202386 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202398 */   // GIR_Coverage, 47468,
     /* 2202398 */   GIR_EraseRootFromParent_Done,
     /* 2202399 */ // Label 29076: @2202399
     /* 2202399 */ GIM_Try, /*On fail goto*//*Label 29077*/ GIMT_Encode4(2202453), // Rule ID 47469 //
     /* 2202404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2202410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202418 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2202435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202440 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202452 */   // GIR_Coverage, 47469,
     /* 2202452 */   GIR_EraseRootFromParent_Done,
     /* 2202453 */ // Label 29077: @2202453
     /* 2202453 */ GIM_Try, /*On fail goto*//*Label 29078*/ GIMT_Encode4(2202507), // Rule ID 47502 //
     /* 2202458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202472 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2202489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202494 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202502 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202505 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202506 */   // GIR_Coverage, 47502,
     /* 2202506 */   GIR_EraseRootFromParent_Done,
     /* 2202507 */ // Label 29078: @2202507
     /* 2202507 */ GIM_Try, /*On fail goto*//*Label 29079*/ GIMT_Encode4(2202561), // Rule ID 47503 //
     /* 2202512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2202518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202526 */   // (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2202529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M1),
     /* 2202543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202548 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202556 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202559 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202560 */   // GIR_Coverage, 47503,
     /* 2202560 */   GIR_EraseRootFromParent_Done,
     /* 2202561 */ // Label 29079: @2202561
     /* 2202561 */ GIM_Reject,
     /* 2202562 */ // Label 29036: @2202562
     /* 2202562 */ GIM_Try, /*On fail goto*//*Label 29080*/ GIMT_Encode4(2202665),
     /* 2202567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202578 */   GIM_Try, /*On fail goto*//*Label 29081*/ GIMT_Encode4(2202621), // Rule ID 47362 //
     /* 2202583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202586 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2202589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2202603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202620 */     // GIR_Coverage, 47362,
     /* 2202620 */     GIR_EraseRootFromParent_Done,
     /* 2202621 */   // Label 29081: @2202621
     /* 2202621 */   GIM_Try, /*On fail goto*//*Label 29082*/ GIMT_Encode4(2202664), // Rule ID 47363 //
     /* 2202626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202629 */     // (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF2_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2202632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_MF2),
     /* 2202646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2202659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2202663 */     // GIR_Coverage, 47363,
     /* 2202663 */     GIR_EraseRootFromParent_Done,
     /* 2202664 */   // Label 29082: @2202664
     /* 2202664 */   GIM_Reject,
     /* 2202665 */ // Label 29080: @2202665
     /* 2202665 */ GIM_Reject,
     /* 2202666 */ // Label 29037: @2202666
     /* 2202666 */ GIM_Try, /*On fail goto*//*Label 29083*/ GIMT_Encode4(2202720), // Rule ID 47386 //
     /* 2202671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2202677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202685 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202697 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2202702 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202704 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202707 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202718 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202719 */   // GIR_Coverage, 47386,
     /* 2202719 */   GIR_EraseRootFromParent_Done,
     /* 2202720 */ // Label 29083: @2202720
     /* 2202720 */ GIM_Try, /*On fail goto*//*Label 29084*/ GIMT_Encode4(2202774), // Rule ID 47387 //
     /* 2202725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2202731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202739 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202739 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202742 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202746 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2202756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202761 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202773 */   // GIR_Coverage, 47387,
     /* 2202773 */   GIR_EraseRootFromParent_Done,
     /* 2202774 */ // Label 29084: @2202774
     /* 2202774 */ GIM_Try, /*On fail goto*//*Label 29085*/ GIMT_Encode4(2202828), // Rule ID 47452 //
     /* 2202779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2202782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202793 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202793 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202796 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202800 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202805 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2202810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202812 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202815 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202827 */   // GIR_Coverage, 47452,
     /* 2202827 */   GIR_EraseRootFromParent_Done,
     /* 2202828 */ // Label 29085: @2202828
     /* 2202828 */ GIM_Try, /*On fail goto*//*Label 29086*/ GIMT_Encode4(2202882), // Rule ID 47453 //
     /* 2202833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2202836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2202839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202847 */   // (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2202850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M1),
     /* 2202864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202869 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2202877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202881 */   // GIR_Coverage, 47453,
     /* 2202881 */   GIR_EraseRootFromParent_Done,
     /* 2202882 */ // Label 29086: @2202882
     /* 2202882 */ GIM_Reject,
     /* 2202883 */ // Label 29038: @2202883
     /* 2202883 */ GIM_Try, /*On fail goto*//*Label 29087*/ GIMT_Encode4(2202937), // Rule ID 47406 //
     /* 2202888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2202894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202902 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2202902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2202905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2202919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202936 */   // GIR_Coverage, 47406,
     /* 2202936 */   GIR_EraseRootFromParent_Done,
     /* 2202937 */ // Label 29087: @2202937
     /* 2202937 */ GIM_Try, /*On fail goto*//*Label 29088*/ GIMT_Encode4(2202991), // Rule ID 47407 //
     /* 2202942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2202945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2202948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2202952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2202956 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2202956 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2202959 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2202963 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2202968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2202970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2202973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2202975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2202978 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2202980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2202983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2202986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2202989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2202990 */   // GIR_Coverage, 47407,
     /* 2202990 */   GIR_EraseRootFromParent_Done,
     /* 2202991 */ // Label 29088: @2202991
     /* 2202991 */ GIM_Try, /*On fail goto*//*Label 29089*/ GIMT_Encode4(2203045), // Rule ID 47472 //
     /* 2202996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2202999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2203002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203010 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2203027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203032 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203043 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203044 */   // GIR_Coverage, 47472,
     /* 2203044 */   GIR_EraseRootFromParent_Done,
     /* 2203045 */ // Label 29089: @2203045
     /* 2203045 */ GIM_Try, /*On fail goto*//*Label 29090*/ GIMT_Encode4(2203099), // Rule ID 47473 //
     /* 2203050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2203056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203064 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203076 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2203081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203083 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203086 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203097 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203098 */   // GIR_Coverage, 47473,
     /* 2203098 */   GIR_EraseRootFromParent_Done,
     /* 2203099 */ // Label 29090: @2203099
     /* 2203099 */ GIM_Try, /*On fail goto*//*Label 29091*/ GIMT_Encode4(2203153), // Rule ID 47506 //
     /* 2203104 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2203110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203118 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2203135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203140 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203152 */   // GIR_Coverage, 47506,
     /* 2203152 */   GIR_EraseRootFromParent_Done,
     /* 2203153 */ // Label 29091: @2203153
     /* 2203153 */ GIM_Try, /*On fail goto*//*Label 29092*/ GIMT_Encode4(2203207), // Rule ID 47507 //
     /* 2203158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2203164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203172 */   // (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203172 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2203175 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203179 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M2),
     /* 2203189 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203191 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203194 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203202 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203205 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203206 */   // GIR_Coverage, 47507,
     /* 2203206 */   GIR_EraseRootFromParent_Done,
     /* 2203207 */ // Label 29092: @2203207
     /* 2203207 */ GIM_Reject,
     /* 2203208 */ // Label 29039: @2203208
     /* 2203208 */ GIM_Try, /*On fail goto*//*Label 29093*/ GIMT_Encode4(2203311),
     /* 2203213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203224 */   GIM_Try, /*On fail goto*//*Label 29094*/ GIMT_Encode4(2203267), // Rule ID 47366 //
     /* 2203229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203232 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2203235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2203249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203266 */     // GIR_Coverage, 47366,
     /* 2203266 */     GIR_EraseRootFromParent_Done,
     /* 2203267 */   // Label 29094: @2203267
     /* 2203267 */   GIM_Try, /*On fail goto*//*Label 29095*/ GIMT_Encode4(2203310), // Rule ID 47367 //
     /* 2203272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203275 */     // (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2203278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M1),
     /* 2203292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203309 */     // GIR_Coverage, 47367,
     /* 2203309 */     GIR_EraseRootFromParent_Done,
     /* 2203310 */   // Label 29095: @2203310
     /* 2203310 */   GIM_Reject,
     /* 2203311 */ // Label 29093: @2203311
     /* 2203311 */ GIM_Reject,
     /* 2203312 */ // Label 29040: @2203312
     /* 2203312 */ GIM_Try, /*On fail goto*//*Label 29096*/ GIMT_Encode4(2203366), // Rule ID 47390 //
     /* 2203317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203331 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2203348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203353 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203365 */   // GIR_Coverage, 47390,
     /* 2203365 */   GIR_EraseRootFromParent_Done,
     /* 2203366 */ // Label 29096: @2203366
     /* 2203366 */ GIM_Try, /*On fail goto*//*Label 29097*/ GIMT_Encode4(2203420), // Rule ID 47391 //
     /* 2203371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203385 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2203402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203407 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203418 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203419 */   // GIR_Coverage, 47391,
     /* 2203419 */   GIR_EraseRootFromParent_Done,
     /* 2203420 */ // Label 29097: @2203420
     /* 2203420 */ GIM_Try, /*On fail goto*//*Label 29098*/ GIMT_Encode4(2203474), // Rule ID 47456 //
     /* 2203425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203439 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203439 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203442 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203446 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203451 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2203456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203461 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203473 */   // GIR_Coverage, 47456,
     /* 2203473 */   GIR_EraseRootFromParent_Done,
     /* 2203474 */ // Label 29098: @2203474
     /* 2203474 */ GIM_Try, /*On fail goto*//*Label 29099*/ GIMT_Encode4(2203528), // Rule ID 47457 //
     /* 2203479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203493 */   // (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2203496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M2),
     /* 2203510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203515 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2203523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203527 */   // GIR_Coverage, 47457,
     /* 2203527 */   GIR_EraseRootFromParent_Done,
     /* 2203528 */ // Label 29099: @2203528
     /* 2203528 */ GIM_Reject,
     /* 2203529 */ // Label 29041: @2203529
     /* 2203529 */ GIM_Try, /*On fail goto*//*Label 29100*/ GIMT_Encode4(2203583), // Rule ID 47410 //
     /* 2203534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2203540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203548 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203548 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203551 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203555 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203560 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2203565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203570 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203582 */   // GIR_Coverage, 47410,
     /* 2203582 */   GIR_EraseRootFromParent_Done,
     /* 2203583 */ // Label 29100: @2203583
     /* 2203583 */ GIM_Try, /*On fail goto*//*Label 29101*/ GIMT_Encode4(2203637), // Rule ID 47411 //
     /* 2203588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2203594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203602 */   // (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203602 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203605 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203609 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203614 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2203619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203624 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203636 */   // GIR_Coverage, 47411,
     /* 2203636 */   GIR_EraseRootFromParent_Done,
     /* 2203637 */ // Label 29101: @2203637
     /* 2203637 */ GIM_Try, /*On fail goto*//*Label 29102*/ GIMT_Encode4(2203691), // Rule ID 47476 //
     /* 2203642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203656 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203656 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203659 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203663 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2203673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203675 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203678 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203689 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203690 */   // GIR_Coverage, 47476,
     /* 2203690 */   GIR_EraseRootFromParent_Done,
     /* 2203691 */ // Label 29102: @2203691
     /* 2203691 */ GIM_Try, /*On fail goto*//*Label 29103*/ GIMT_Encode4(2203745), // Rule ID 47477 //
     /* 2203696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2203702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203710 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203710 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203713 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203717 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203722 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2203727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203729 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203732 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203740 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203743 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203744 */   // GIR_Coverage, 47477,
     /* 2203744 */   GIR_EraseRootFromParent_Done,
     /* 2203745 */ // Label 29103: @2203745
     /* 2203745 */ GIM_Try, /*On fail goto*//*Label 29104*/ GIMT_Encode4(2203799), // Rule ID 47510 //
     /* 2203750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2203753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203764 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203776 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203778 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2203781 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203783 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203786 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203798 */   // GIR_Coverage, 47510,
     /* 2203798 */   GIR_EraseRootFromParent_Done,
     /* 2203799 */ // Label 29104: @2203799
     /* 2203799 */ GIM_Try, /*On fail goto*//*Label 29105*/ GIMT_Encode4(2203853), // Rule ID 47511 //
     /* 2203804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2203807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2203810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203814 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203818 */   // (zext:{ *:[nxv4i64] } VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2203821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M4),
     /* 2203835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203840 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2203848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2203852 */   // GIR_Coverage, 47511,
     /* 2203852 */   GIR_EraseRootFromParent_Done,
     /* 2203853 */ // Label 29105: @2203853
     /* 2203853 */ GIM_Reject,
     /* 2203854 */ // Label 29042: @2203854
     /* 2203854 */ GIM_Try, /*On fail goto*//*Label 29106*/ GIMT_Encode4(2203957),
     /* 2203859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2203862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2203870 */   GIM_Try, /*On fail goto*//*Label 29107*/ GIMT_Encode4(2203913), // Rule ID 47370 //
     /* 2203875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203878 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2203881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2203895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203912 */     // GIR_Coverage, 47370,
     /* 2203912 */     GIR_EraseRootFromParent_Done,
     /* 2203913 */   // Label 29107: @2203913
     /* 2203913 */   GIM_Try, /*On fail goto*//*Label 29108*/ GIMT_Encode4(2203956), // Rule ID 47371 //
     /* 2203918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2203921 */     // (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2203921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2203924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203933 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M2),
     /* 2203938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203943 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2203945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2203948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2203951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2203954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2203955 */     // GIR_Coverage, 47371,
     /* 2203955 */     GIR_EraseRootFromParent_Done,
     /* 2203956 */   // Label 29108: @2203956
     /* 2203956 */   GIM_Reject,
     /* 2203957 */ // Label 29106: @2203957
     /* 2203957 */ GIM_Reject,
     /* 2203958 */ // Label 29043: @2203958
     /* 2203958 */ GIM_Try, /*On fail goto*//*Label 29109*/ GIMT_Encode4(2204012), // Rule ID 47394 //
     /* 2203963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2203966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2203969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2203973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2203977 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2203977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2203980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2203984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2203989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2203991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2203994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2203996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2203999 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204007 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204010 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204011 */   // GIR_Coverage, 47394,
     /* 2204011 */   GIR_EraseRootFromParent_Done,
     /* 2204012 */ // Label 29109: @2204012
     /* 2204012 */ GIM_Try, /*On fail goto*//*Label 29110*/ GIMT_Encode4(2204066), // Rule ID 47395 //
     /* 2204017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204031 */   // (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204031 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204034 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204038 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2204048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204053 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204064 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204065 */   // GIR_Coverage, 47395,
     /* 2204065 */   GIR_EraseRootFromParent_Done,
     /* 2204066 */ // Label 29110: @2204066
     /* 2204066 */ GIM_Try, /*On fail goto*//*Label 29111*/ GIMT_Encode4(2204120), // Rule ID 47460 //
     /* 2204071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204085 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2204102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204107 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204119 */   // GIR_Coverage, 47460,
     /* 2204119 */   GIR_EraseRootFromParent_Done,
     /* 2204120 */ // Label 29111: @2204120
     /* 2204120 */ GIM_Try, /*On fail goto*//*Label 29112*/ GIMT_Encode4(2204174), // Rule ID 47461 //
     /* 2204125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204139 */   // (zext:{ *:[nxv8i32] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2204142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M4),
     /* 2204156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204173 */   // GIR_Coverage, 47461,
     /* 2204173 */   GIR_EraseRootFromParent_Done,
     /* 2204174 */ // Label 29112: @2204174
     /* 2204174 */ GIM_Reject,
     /* 2204175 */ // Label 29044: @2204175
     /* 2204175 */ GIM_Try, /*On fail goto*//*Label 29113*/ GIMT_Encode4(2204229), // Rule ID 47414 //
     /* 2204180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2204186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204194 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204208 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204211 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204213 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204216 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204228 */   // GIR_Coverage, 47414,
     /* 2204228 */   GIR_EraseRootFromParent_Done,
     /* 2204229 */ // Label 29113: @2204229
     /* 2204229 */ GIM_Try, /*On fail goto*//*Label 29114*/ GIMT_Encode4(2204283), // Rule ID 47415 //
     /* 2204234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2204240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204248 */   // (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204270 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204282 */   // GIR_Coverage, 47415,
     /* 2204282 */   GIR_EraseRootFromParent_Done,
     /* 2204283 */ // Label 29114: @2204283
     /* 2204283 */ GIM_Try, /*On fail goto*//*Label 29115*/ GIMT_Encode4(2204337), // Rule ID 47480 //
     /* 2204288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204302 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2204319 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204324 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204336 */   // GIR_Coverage, 47480,
     /* 2204336 */   GIR_EraseRootFromParent_Done,
     /* 2204337 */ // Label 29115: @2204337
     /* 2204337 */ GIM_Try, /*On fail goto*//*Label 29116*/ GIMT_Encode4(2204391), // Rule ID 47481 //
     /* 2204342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2204348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204356 */   // (zext:{ *:[nxv8i64] } VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2204373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204378 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204390 */   // GIR_Coverage, 47481,
     /* 2204390 */   GIR_EraseRootFromParent_Done,
     /* 2204391 */ // Label 29116: @2204391
     /* 2204391 */ GIM_Try, /*On fail goto*//*Label 29117*/ GIMT_Encode4(2204445), // Rule ID 47514 //
     /* 2204396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2204399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204410 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2204427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204444 */   // GIR_Coverage, 47514,
     /* 2204444 */   GIR_EraseRootFromParent_Done,
     /* 2204445 */ // Label 29117: @2204445
     /* 2204445 */ GIM_Try, /*On fail goto*//*Label 29118*/ GIMT_Encode4(2204499), // Rule ID 47515 //
     /* 2204450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2204453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2204456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2204464 */   // (zext:{ *:[nxv8i64] } VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVZEXT_VF8_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2204467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF8_M8),
     /* 2204481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204486 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2204494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204498 */   // GIR_Coverage, 47515,
     /* 2204498 */   GIR_EraseRootFromParent_Done,
     /* 2204499 */ // Label 29118: @2204499
     /* 2204499 */ GIM_Reject,
     /* 2204500 */ // Label 29045: @2204500
     /* 2204500 */ GIM_Try, /*On fail goto*//*Label 29119*/ GIMT_Encode4(2204603),
     /* 2204505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204516 */   GIM_Try, /*On fail goto*//*Label 29120*/ GIMT_Encode4(2204559), // Rule ID 47374 //
     /* 2204521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204524 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2204527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2204541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204558 */     // GIR_Coverage, 47374,
     /* 2204558 */     GIR_EraseRootFromParent_Done,
     /* 2204559 */   // Label 29120: @2204559
     /* 2204559 */   GIM_Try, /*On fail goto*//*Label 29121*/ GIMT_Encode4(2204602), // Rule ID 47375 //
     /* 2204564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204567 */     // (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2204570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M4),
     /* 2204584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204601 */     // GIR_Coverage, 47375,
     /* 2204601 */     GIR_EraseRootFromParent_Done,
     /* 2204602 */   // Label 29121: @2204602
     /* 2204602 */   GIM_Reject,
     /* 2204603 */ // Label 29119: @2204603
     /* 2204603 */ GIM_Reject,
     /* 2204604 */ // Label 29046: @2204604
     /* 2204604 */ GIM_Try, /*On fail goto*//*Label 29122*/ GIMT_Encode4(2204658), // Rule ID 47398 //
     /* 2204609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2204615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204623 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204635 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204640 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204642 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204645 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204657 */   // GIR_Coverage, 47398,
     /* 2204657 */   GIR_EraseRootFromParent_Done,
     /* 2204658 */ // Label 29122: @2204658
     /* 2204658 */ GIM_Try, /*On fail goto*//*Label 29123*/ GIMT_Encode4(2204712), // Rule ID 47399 //
     /* 2204663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2204669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204677 */   // (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204699 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204711 */   // GIR_Coverage, 47399,
     /* 2204711 */   GIR_EraseRootFromParent_Done,
     /* 2204712 */ // Label 29123: @2204712
     /* 2204712 */ GIM_Try, /*On fail goto*//*Label 29124*/ GIMT_Encode4(2204766), // Rule ID 47464 //
     /* 2204717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204731 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2204748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204765 */   // GIR_Coverage, 47464,
     /* 2204765 */   GIR_EraseRootFromParent_Done,
     /* 2204766 */ // Label 29124: @2204766
     /* 2204766 */ GIM_Try, /*On fail goto*//*Label 29125*/ GIMT_Encode4(2204820), // Rule ID 47465 //
     /* 2204771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2204777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2204785 */   // (zext:{ *:[nxv16i32] } VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVZEXT_VF4_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2204788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF4_M8),
     /* 2204802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2204815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2204819 */   // GIR_Coverage, 47465,
     /* 2204819 */   GIR_EraseRootFromParent_Done,
     /* 2204820 */ // Label 29125: @2204820
     /* 2204820 */ GIM_Reject,
     /* 2204821 */ // Label 29047: @2204821
     /* 2204821 */ GIM_Try, /*On fail goto*//*Label 29126*/ GIMT_Encode4(2204924),
     /* 2204826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2204829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2204833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2204837 */   GIM_Try, /*On fail goto*//*Label 29127*/ GIMT_Encode4(2204880), // Rule ID 47378 //
     /* 2204842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2204845 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2204845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2204848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204867 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204879 */     // GIR_Coverage, 47378,
     /* 2204879 */     GIR_EraseRootFromParent_Done,
     /* 2204880 */   // Label 29127: @2204880
     /* 2204880 */   GIM_Try, /*On fail goto*//*Label 29128*/ GIMT_Encode4(2204923), // Rule ID 47379 //
     /* 2204885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2204888 */     // (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVZEXT_VF2_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2204888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2204891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2204895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2204900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2204902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVZEXT_VF2_M8),
     /* 2204905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2204907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2204910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2204912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2204915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2204918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2204921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2204922 */     // GIR_Coverage, 47379,
     /* 2204922 */     GIR_EraseRootFromParent_Done,
     /* 2204923 */   // Label 29128: @2204923
     /* 2204923 */   GIM_Reject,
     /* 2204924 */ // Label 29126: @2204924
     /* 2204924 */ GIM_Reject,
     /* 2204925 */ // Label 29048: @2204925
     /* 2204925 */ GIM_Reject,
     /* 2204926 */ // Label 43: @2204926
     /* 2204926 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29153*/ GIMT_Encode4(2213521),
     /* 2204937 */ /*GILLT_s32*//*Label 29129*/ GIMT_Encode4(2205061),
     /* 2204941 */ /*GILLT_s64*//*Label 29130*/ GIMT_Encode4(2205186), GIMT_Encode4(0),
     /* 2204949 */ /*GILLT_nxv1s8*//*Label 29131*/ GIMT_Encode4(2205531),
     /* 2204953 */ /*GILLT_nxv1s16*//*Label 29132*/ GIMT_Encode4(2205646),
     /* 2204957 */ /*GILLT_nxv1s32*//*Label 29133*/ GIMT_Encode4(2206125),
     /* 2204961 */ /*GILLT_nxv1s64*//*Label 29134*/ GIMT_Encode4(2206604), GIMT_Encode4(0),
     /* 2204969 */ /*GILLT_nxv2s8*//*Label 29135*/ GIMT_Encode4(2207083),
     /* 2204973 */ /*GILLT_nxv2s16*//*Label 29136*/ GIMT_Encode4(2207198),
     /* 2204977 */ /*GILLT_nxv2s32*//*Label 29137*/ GIMT_Encode4(2207677),
     /* 2204981 */ /*GILLT_nxv2s64*//*Label 29138*/ GIMT_Encode4(2208156), GIMT_Encode4(0),
     /* 2204989 */ /*GILLT_nxv4s8*//*Label 29139*/ GIMT_Encode4(2208635),
     /* 2204993 */ /*GILLT_nxv4s16*//*Label 29140*/ GIMT_Encode4(2208750),
     /* 2204997 */ /*GILLT_nxv4s32*//*Label 29141*/ GIMT_Encode4(2209229),
     /* 2205001 */ /*GILLT_nxv4s64*//*Label 29142*/ GIMT_Encode4(2209708), GIMT_Encode4(0),
     /* 2205009 */ /*GILLT_nxv8s8*//*Label 29143*/ GIMT_Encode4(2210187),
     /* 2205013 */ /*GILLT_nxv8s16*//*Label 29144*/ GIMT_Encode4(2210302),
     /* 2205017 */ /*GILLT_nxv8s32*//*Label 29145*/ GIMT_Encode4(2210781),
     /* 2205021 */ /*GILLT_nxv8s64*//*Label 29146*/ GIMT_Encode4(2211260), GIMT_Encode4(0),
     /* 2205029 */ /*GILLT_nxv16s8*//*Label 29147*/ GIMT_Encode4(2211739),
     /* 2205033 */ /*GILLT_nxv16s16*//*Label 29148*/ GIMT_Encode4(2211854),
     /* 2205037 */ /*GILLT_nxv16s32*//*Label 29149*/ GIMT_Encode4(2212333), GIMT_Encode4(0),
     /* 2205045 */ /*GILLT_nxv32s8*//*Label 29150*/ GIMT_Encode4(2212812),
     /* 2205049 */ /*GILLT_nxv32s16*//*Label 29151*/ GIMT_Encode4(2212927), GIMT_Encode4(0),
     /* 2205057 */ /*GILLT_nxv64s8*//*Label 29152*/ GIMT_Encode4(2213406),
     /* 2205061 */ // Label 29129: @2205061
     /* 2205061 */ GIM_Try, /*On fail goto*//*Label 29154*/ GIMT_Encode4(2205185),
     /* 2205066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2205069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2205072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205076 */   GIM_Try, /*On fail goto*//*Label 29155*/ GIMT_Encode4(2205113), // Rule ID 2371 //
     /* 2205081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode1),
     /* 2205084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2205088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2205095 */     // (shl:{ *:[i32] } 1:{ *:[i32] }, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (BSET:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs2)
     /* 2205095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2205098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2205111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205112 */     // GIR_Coverage, 2371,
     /* 2205112 */     GIR_EraseRootFromParent_Done,
     /* 2205113 */   // Label 29155: @2205113
     /* 2205113 */   GIM_Try, /*On fail goto*//*Label 29156*/ GIMT_Encode4(2205151), // Rule ID 91 //
     /* 2205118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2205129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2205133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2205137 */     // MIs[1] Operand 1
     /* 2205137 */     // No operand predicates
     /* 2205137 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2205139 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2205139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2205149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205150 */     // GIR_Coverage, 91,
     /* 2205150 */     GIR_EraseRootFromParent_Done,
     /* 2205151 */   // Label 29156: @2205151
     /* 2205151 */   GIM_Try, /*On fail goto*//*Label 29157*/ GIMT_Encode4(2205184), // Rule ID 105 //
     /* 2205156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2205159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205163 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2205170 */     // (shl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SLL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2205170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2205173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2205182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205183 */     // GIR_Coverage, 105,
     /* 2205183 */     GIR_EraseRootFromParent_Done,
     /* 2205184 */   // Label 29157: @2205184
     /* 2205184 */   GIM_Reject,
     /* 2205185 */ // Label 29154: @2205185
     /* 2205185 */ GIM_Reject,
     /* 2205186 */ // Label 29130: @2205186
     /* 2205186 */ GIM_Try, /*On fail goto*//*Label 29158*/ GIMT_Encode4(2205530),
     /* 2205191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2205194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2205197 */   GIM_Try, /*On fail goto*//*Label 29159*/ GIMT_Encode4(2205291), // Rule ID 253 //
     /* 2205202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_NotHasStdExtZba_HwMode0),
     /* 2205205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2205217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2205221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2205225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205230 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2205241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2205249 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2205253 */     // MIs[2] Operand 1
     /* 2205253 */     // No operand predicates
     /* 2205253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205255 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLI:{ *:[i64] } (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 32:{ *:[i64] }), (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt))
     /* 2205255 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2205258 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205262 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205267 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2205271 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2205274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2205279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205284 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // shamt
     /* 2205289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205290 */     // GIR_Coverage, 253,
     /* 2205290 */     GIR_EraseRootFromParent_Done,
     /* 2205291 */   // Label 29159: @2205291
     /* 2205291 */   GIM_Try, /*On fail goto*//*Label 29160*/ GIMT_Encode4(2205363), // Rule ID 2489 //
     /* 2205296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZba_IsRV64_HwMode0),
     /* 2205299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2205311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2205315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2205319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205324 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2205335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2205343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2205347 */     // MIs[2] Operand 1
     /* 2205347 */     // No operand predicates
     /* 2205347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205349 */     // (shl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SLLI_UW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2205349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI_UW),
     /* 2205352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2205358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2205361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205362 */     // GIR_Coverage, 2489,
     /* 2205362 */     GIR_EraseRootFromParent_Done,
     /* 2205363 */   // Label 29160: @2205363
     /* 2205363 */   GIM_Try, /*On fail goto*//*Label 29161*/ GIMT_Encode4(2205404), // Rule ID 2370 //
     /* 2205368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbs_HwMode0),
     /* 2205371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 1,
     /* 2205379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2205386 */     // (shl:{ *:[i64] } 1:{ *:[i64] }, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (BSET:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs2)
     /* 2205386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::BSET),
     /* 2205389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2205397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2205402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205403 */     // GIR_Coverage, 2370,
     /* 2205403 */     GIR_EraseRootFromParent_Done,
     /* 2205404 */   // Label 29161: @2205404
     /* 2205404 */   GIM_Try, /*On fail goto*//*Label 29162*/ GIMT_Encode4(2205450), // Rule ID 268 //
     /* 2205409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2205412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2205424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2205428 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2205432 */     // MIs[1] Operand 1
     /* 2205432 */     // No operand predicates
     /* 2205432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10044),
     /* 2205436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2205438 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)<<P:Predicate_anonymous_10044>>  =>  (SLLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2205438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLIW),
     /* 2205441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2205448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205449 */     // GIR_Coverage, 268,
     /* 2205449 */     GIR_EraseRootFromParent_Done,
     /* 2205450 */   // Label 29162: @2205450
     /* 2205450 */   GIM_Try, /*On fail goto*//*Label 29163*/ GIMT_Encode4(2205492), // Rule ID 90 //
     /* 2205455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2205470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2205474 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2205478 */     // MIs[1] Operand 1
     /* 2205478 */     // No operand predicates
     /* 2205478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2205480 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SLLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2205480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2205483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2205490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205491 */     // GIR_Coverage, 90,
     /* 2205491 */     GIR_EraseRootFromParent_Done,
     /* 2205492 */   // Label 29163: @2205492
     /* 2205492 */   GIM_Try, /*On fail goto*//*Label 29164*/ GIMT_Encode4(2205529), // Rule ID 104 //
     /* 2205497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2205500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2205508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2205515 */     // (shl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2205515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLL),
     /* 2205518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205522 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2205527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205528 */     // GIR_Coverage, 104,
     /* 2205528 */     GIR_EraseRootFromParent_Done,
     /* 2205529 */   // Label 29164: @2205529
     /* 2205529 */   GIM_Reject,
     /* 2205530 */ // Label 29158: @2205530
     /* 2205530 */ GIM_Reject,
     /* 2205531 */ // Label 29131: @2205531
     /* 2205531 */ GIM_Try, /*On fail goto*//*Label 29165*/ GIMT_Encode4(2205645),
     /* 2205536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2205542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205554 */   GIM_Try, /*On fail goto*//*Label 29166*/ GIMT_Encode4(2205599), // Rule ID 47922 //
     /* 2205559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2205562 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2205565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2205579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205598 */     // GIR_Coverage, 47922,
     /* 2205598 */     GIR_EraseRootFromParent_Done,
     /* 2205599 */   // Label 29166: @2205599
     /* 2205599 */   GIM_Try, /*On fail goto*//*Label 29167*/ GIMT_Encode4(2205644), // Rule ID 47923 //
     /* 2205604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2205607 */     // (shl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSLL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2205610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF8),
     /* 2205624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2205631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2205633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205643 */     // GIR_Coverage, 47923,
     /* 2205643 */     GIR_EraseRootFromParent_Done,
     /* 2205644 */   // Label 29167: @2205644
     /* 2205644 */   GIM_Reject,
     /* 2205645 */ // Label 29165: @2205645
     /* 2205645 */ GIM_Reject,
     /* 2205646 */ // Label 29132: @2205646
     /* 2205646 */ GIM_Try, /*On fail goto*//*Label 29168*/ GIMT_Encode4(2206124),
     /* 2205651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2205654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2205657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205661 */   GIM_Try, /*On fail goto*//*Label 29169*/ GIMT_Encode4(2205750), // Rule ID 59410 //
     /* 2205666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2205669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205681 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2205683 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2205696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205700 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2205702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205709 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2205726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2205735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2205739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205749 */     // GIR_Coverage, 59410,
     /* 2205749 */     GIR_EraseRootFromParent_Done,
     /* 2205750 */   // Label 29169: @2205750
     /* 2205750 */   GIM_Try, /*On fail goto*//*Label 29170*/ GIMT_Encode4(2205839), // Rule ID 59411 //
     /* 2205755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2205758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205770 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2205772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2205785 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205789 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2205791 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205798 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2205815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2205824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2205828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205838 */     // GIR_Coverage, 59411,
     /* 2205838 */     GIR_EraseRootFromParent_Done,
     /* 2205839 */   // Label 29170: @2205839
     /* 2205839 */   GIM_Try, /*On fail goto*//*Label 29171*/ GIMT_Encode4(2205928), // Rule ID 59412 //
     /* 2205844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2205847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205859 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2205861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205878 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2205880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205885 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205887 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2205887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2205904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2205913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2205917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2205920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2205926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2205927 */     // GIR_Coverage, 59412,
     /* 2205927 */     GIR_EraseRootFromParent_Done,
     /* 2205928 */   // Label 29171: @2205928
     /* 2205928 */   GIM_Try, /*On fail goto*//*Label 29172*/ GIMT_Encode4(2206017), // Rule ID 59413 //
     /* 2205933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2205936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2205940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205948 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2205950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2205959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2205963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2205967 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2205969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2205974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2205976 */     // (shl:{ *:[nxv1i16] } (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i16] } VR:{ *:[nxv1i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF8:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2205976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2205979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2205983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2205988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2205990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF8),
     /* 2205993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2205995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2205998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206016 */     // GIR_Coverage, 59413,
     /* 2206016 */     GIR_EraseRootFromParent_Done,
     /* 2206017 */   // Label 29172: @2206017
     /* 2206017 */   GIM_Try, /*On fail goto*//*Label 29173*/ GIMT_Encode4(2206070), // Rule ID 47934 //
     /* 2206022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206033 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2206036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206045 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2206050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206055 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206069 */     // GIR_Coverage, 47934,
     /* 2206069 */     GIR_EraseRootFromParent_Done,
     /* 2206070 */   // Label 29173: @2206070
     /* 2206070 */   GIM_Try, /*On fail goto*//*Label 29174*/ GIMT_Encode4(2206123), // Rule ID 47935 //
     /* 2206075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206086 */     // (shl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2206089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2206103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206105 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206122 */     // GIR_Coverage, 47935,
     /* 2206122 */     GIR_EraseRootFromParent_Done,
     /* 2206123 */   // Label 29174: @2206123
     /* 2206123 */   GIM_Reject,
     /* 2206124 */ // Label 29168: @2206124
     /* 2206124 */ GIM_Reject,
     /* 2206125 */ // Label 29133: @2206125
     /* 2206125 */ GIM_Try, /*On fail goto*//*Label 29175*/ GIMT_Encode4(2206603),
     /* 2206130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2206136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206140 */   GIM_Try, /*On fail goto*//*Label 29176*/ GIMT_Encode4(2206229), // Rule ID 59458 //
     /* 2206145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2206148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206160 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2206175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206179 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206188 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2206205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206228 */     // GIR_Coverage, 59458,
     /* 2206228 */     GIR_EraseRootFromParent_Done,
     /* 2206229 */   // Label 29176: @2206229
     /* 2206229 */   GIM_Try, /*On fail goto*//*Label 29177*/ GIMT_Encode4(2206318), // Rule ID 59459 //
     /* 2206234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2206237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206249 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2206264 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206268 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206277 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2206294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206317 */     // GIR_Coverage, 59459,
     /* 2206317 */     GIR_EraseRootFromParent_Done,
     /* 2206318 */   // Label 29177: @2206318
     /* 2206318 */   GIM_Try, /*On fail goto*//*Label 29178*/ GIMT_Encode4(2206407), // Rule ID 59460 //
     /* 2206323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2206326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206338 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206357 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206359 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206366 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2206383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206406 */     // GIR_Coverage, 59460,
     /* 2206406 */     GIR_EraseRootFromParent_Done,
     /* 2206407 */   // Label 29178: @2206407
     /* 2206407 */   GIM_Try, /*On fail goto*//*Label 29179*/ GIMT_Encode4(2206496), // Rule ID 59461 //
     /* 2206412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2206415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206427 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2206446 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206455 */     // (shl:{ *:[nxv1i32] } (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i32] } VR:{ *:[nxv1i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2206472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2206491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206495 */     // GIR_Coverage, 59461,
     /* 2206495 */     GIR_EraseRootFromParent_Done,
     /* 2206496 */   // Label 29179: @2206496
     /* 2206496 */   GIM_Try, /*On fail goto*//*Label 29180*/ GIMT_Encode4(2206549), // Rule ID 47942 //
     /* 2206501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2206504 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206512 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2206529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206548 */     // GIR_Coverage, 47942,
     /* 2206548 */     GIR_EraseRootFromParent_Done,
     /* 2206549 */   // Label 29180: @2206549
     /* 2206549 */   GIM_Try, /*On fail goto*//*Label 29181*/ GIMT_Encode4(2206602), // Rule ID 47943 //
     /* 2206554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2206557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206565 */     // (shl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2206568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2206582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206587 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2206589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2206591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206601 */     // GIR_Coverage, 47943,
     /* 2206601 */     GIR_EraseRootFromParent_Done,
     /* 2206602 */   // Label 29181: @2206602
     /* 2206602 */   GIM_Reject,
     /* 2206603 */ // Label 29175: @2206603
     /* 2206603 */ GIM_Reject,
     /* 2206604 */ // Label 29134: @2206604
     /* 2206604 */ GIM_Try, /*On fail goto*//*Label 29182*/ GIMT_Encode4(2207082),
     /* 2206609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2206612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2206615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206619 */   GIM_Try, /*On fail goto*//*Label 29183*/ GIMT_Encode4(2206708), // Rule ID 59498 //
     /* 2206624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2206627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206639 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2206654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206658 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206660 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206667 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2206684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206707 */     // GIR_Coverage, 59498,
     /* 2206707 */     GIR_EraseRootFromParent_Done,
     /* 2206708 */   // Label 29183: @2206708
     /* 2206708 */   GIM_Try, /*On fail goto*//*Label 29184*/ GIMT_Encode4(2206797), // Rule ID 59499 //
     /* 2206713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2206716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206728 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2206743 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206747 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206754 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206756 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2206773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206796 */     // GIR_Coverage, 59499,
     /* 2206796 */     GIR_EraseRootFromParent_Done,
     /* 2206797 */   // Label 29184: @2206797
     /* 2206797 */   GIM_Try, /*On fail goto*//*Label 29185*/ GIMT_Encode4(2206886), // Rule ID 59500 //
     /* 2206802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2206805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206817 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206836 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206845 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2206862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206885 */     // GIR_Coverage, 59500,
     /* 2206885 */     GIR_EraseRootFromParent_Done,
     /* 2206886 */   // Label 29185: @2206886
     /* 2206886 */   GIM_Try, /*On fail goto*//*Label 29186*/ GIMT_Encode4(2206975), // Rule ID 59501 //
     /* 2206891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2206894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2206898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206906 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2206908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2206917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2206921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2206925 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2206927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2206934 */     // (shl:{ *:[nxv1i64] } (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv1i64] } VR:{ *:[nxv1i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2206934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2206946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2206948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2206951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2206953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2206956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2206960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2206964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2206967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2206970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2206973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2206974 */     // GIR_Coverage, 59501,
     /* 2206974 */     GIR_EraseRootFromParent_Done,
     /* 2206975 */   // Label 29186: @2206975
     /* 2206975 */   GIM_Try, /*On fail goto*//*Label 29187*/ GIMT_Encode4(2207028), // Rule ID 47958 //
     /* 2206980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2206983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2206991 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2206991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2206994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2206998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2207008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207013 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207015 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207027 */     // GIR_Coverage, 47958,
     /* 2207027 */     GIR_EraseRootFromParent_Done,
     /* 2207028 */   // Label 29187: @2207028
     /* 2207028 */   GIM_Try, /*On fail goto*//*Label 29188*/ GIMT_Encode4(2207081), // Rule ID 47959 //
     /* 2207033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2207036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207044 */     // (shl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2207047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2207061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2207076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207080 */     // GIR_Coverage, 47959,
     /* 2207080 */     GIR_EraseRootFromParent_Done,
     /* 2207081 */   // Label 29188: @2207081
     /* 2207081 */   GIM_Reject,
     /* 2207082 */ // Label 29182: @2207082
     /* 2207082 */ GIM_Reject,
     /* 2207083 */ // Label 29135: @2207083
     /* 2207083 */ GIM_Try, /*On fail goto*//*Label 29189*/ GIMT_Encode4(2207197),
     /* 2207088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2207094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207106 */   GIM_Try, /*On fail goto*//*Label 29190*/ GIMT_Encode4(2207151), // Rule ID 47926 //
     /* 2207111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207114 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2207117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2207131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207150 */     // GIR_Coverage, 47926,
     /* 2207150 */     GIR_EraseRootFromParent_Done,
     /* 2207151 */   // Label 29190: @2207151
     /* 2207151 */   GIM_Try, /*On fail goto*//*Label 29191*/ GIMT_Encode4(2207196), // Rule ID 47927 //
     /* 2207156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207159 */     // (shl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSLL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2207162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF4),
     /* 2207176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207195 */     // GIR_Coverage, 47927,
     /* 2207195 */     GIR_EraseRootFromParent_Done,
     /* 2207196 */   // Label 29191: @2207196
     /* 2207196 */   GIM_Reject,
     /* 2207197 */ // Label 29189: @2207197
     /* 2207197 */ GIM_Reject,
     /* 2207198 */ // Label 29136: @2207198
     /* 2207198 */ GIM_Try, /*On fail goto*//*Label 29192*/ GIMT_Encode4(2207676),
     /* 2207203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2207209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207213 */   GIM_Try, /*On fail goto*//*Label 29193*/ GIMT_Encode4(2207302), // Rule ID 59418 //
     /* 2207218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2207221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207233 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2207248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207252 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207261 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2207278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207301 */     // GIR_Coverage, 59418,
     /* 2207301 */     GIR_EraseRootFromParent_Done,
     /* 2207302 */   // Label 29193: @2207302
     /* 2207302 */   GIM_Try, /*On fail goto*//*Label 29194*/ GIMT_Encode4(2207391), // Rule ID 59419 //
     /* 2207307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2207310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207322 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2207337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207341 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207350 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2207367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207390 */     // GIR_Coverage, 59419,
     /* 2207390 */     GIR_EraseRootFromParent_Done,
     /* 2207391 */   // Label 29194: @2207391
     /* 2207391 */   GIM_Try, /*On fail goto*//*Label 29195*/ GIMT_Encode4(2207480), // Rule ID 59420 //
     /* 2207396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2207399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207411 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207430 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207439 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2207456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207479 */     // GIR_Coverage, 59420,
     /* 2207479 */     GIR_EraseRootFromParent_Done,
     /* 2207480 */   // Label 29195: @2207480
     /* 2207480 */   GIM_Try, /*On fail goto*//*Label 29196*/ GIMT_Encode4(2207569), // Rule ID 59421 //
     /* 2207485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2207488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207500 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2207519 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207528 */     // (shl:{ *:[nxv2i16] } (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i16] } VR:{ *:[nxv2i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF4:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207528 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207531 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207535 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF4),
     /* 2207545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207547 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207568 */     // GIR_Coverage, 59421,
     /* 2207568 */     GIR_EraseRootFromParent_Done,
     /* 2207569 */   // Label 29196: @2207569
     /* 2207569 */   GIM_Try, /*On fail goto*//*Label 29197*/ GIMT_Encode4(2207622), // Rule ID 47938 //
     /* 2207574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2207577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207585 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2207602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207621 */     // GIR_Coverage, 47938,
     /* 2207621 */     GIR_EraseRootFromParent_Done,
     /* 2207622 */   // Label 29197: @2207622
     /* 2207622 */   GIM_Try, /*On fail goto*//*Label 29198*/ GIMT_Encode4(2207675), // Rule ID 47939 //
     /* 2207627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2207630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207638 */     // (shl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2207641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2207655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207660 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2207662 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2207664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207674 */     // GIR_Coverage, 47939,
     /* 2207674 */     GIR_EraseRootFromParent_Done,
     /* 2207675 */   // Label 29198: @2207675
     /* 2207675 */   GIM_Reject,
     /* 2207676 */ // Label 29192: @2207676
     /* 2207676 */ GIM_Reject,
     /* 2207677 */ // Label 29137: @2207677
     /* 2207677 */ GIM_Try, /*On fail goto*//*Label 29199*/ GIMT_Encode4(2208155),
     /* 2207682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2207685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2207688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207692 */   GIM_Try, /*On fail goto*//*Label 29200*/ GIMT_Encode4(2207781), // Rule ID 59466 //
     /* 2207697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2207700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207712 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2207727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207731 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207733 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207740 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2207757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207780 */     // GIR_Coverage, 59466,
     /* 2207780 */     GIR_EraseRootFromParent_Done,
     /* 2207781 */   // Label 29200: @2207781
     /* 2207781 */   GIM_Try, /*On fail goto*//*Label 29201*/ GIMT_Encode4(2207870), // Rule ID 59467 //
     /* 2207786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2207789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207801 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2207816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207820 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207829 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2207829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2207846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207869 */     // GIR_Coverage, 59467,
     /* 2207869 */     GIR_EraseRootFromParent_Done,
     /* 2207870 */   // Label 29201: @2207870
     /* 2207870 */   GIM_Try, /*On fail goto*//*Label 29202*/ GIMT_Encode4(2207959), // Rule ID 59468 //
     /* 2207875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2207878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207890 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207909 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2207911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2207918 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2207918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2207921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2207925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2207930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2207932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2207935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2207937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2207940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2207944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2207948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2207951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2207954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2207957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2207958 */     // GIR_Coverage, 59468,
     /* 2207958 */     GIR_EraseRootFromParent_Done,
     /* 2207959 */   // Label 29202: @2207959
     /* 2207959 */   GIM_Try, /*On fail goto*//*Label 29203*/ GIMT_Encode4(2208048), // Rule ID 59469 //
     /* 2207964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2207967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2207971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207979 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2207981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2207986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2207990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2207994 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2207998 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208007 */     // (shl:{ *:[nxv2i32] } (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i32] } VR:{ *:[nxv2i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2208024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2208043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208047 */     // GIR_Coverage, 59469,
     /* 2208047 */     GIR_EraseRootFromParent_Done,
     /* 2208048 */   // Label 29203: @2208048
     /* 2208048 */   GIM_Try, /*On fail goto*//*Label 29204*/ GIMT_Encode4(2208101), // Rule ID 47954 //
     /* 2208053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208064 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2208081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208100 */     // GIR_Coverage, 47954,
     /* 2208100 */     GIR_EraseRootFromParent_Done,
     /* 2208101 */   // Label 29204: @2208101
     /* 2208101 */   GIM_Try, /*On fail goto*//*Label 29205*/ GIMT_Encode4(2208154), // Rule ID 47955 //
     /* 2208106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208117 */     // (shl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2208120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2208134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208153 */     // GIR_Coverage, 47955,
     /* 2208153 */     GIR_EraseRootFromParent_Done,
     /* 2208154 */   // Label 29205: @2208154
     /* 2208154 */   GIM_Reject,
     /* 2208155 */ // Label 29199: @2208155
     /* 2208155 */ GIM_Reject,
     /* 2208156 */ // Label 29138: @2208156
     /* 2208156 */ GIM_Try, /*On fail goto*//*Label 29206*/ GIMT_Encode4(2208634),
     /* 2208161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2208164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2208167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208171 */   GIM_Try, /*On fail goto*//*Label 29207*/ GIMT_Encode4(2208260), // Rule ID 59506 //
     /* 2208176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208191 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2208206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208210 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208219 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2208236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208259 */     // GIR_Coverage, 59506,
     /* 2208259 */     GIR_EraseRootFromParent_Done,
     /* 2208260 */   // Label 29207: @2208260
     /* 2208260 */   GIM_Try, /*On fail goto*//*Label 29208*/ GIMT_Encode4(2208349), // Rule ID 59507 //
     /* 2208265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208280 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2208295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208299 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208306 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208308 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2208325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208348 */     // GIR_Coverage, 59507,
     /* 2208348 */     GIR_EraseRootFromParent_Done,
     /* 2208349 */   // Label 29208: @2208349
     /* 2208349 */   GIM_Try, /*On fail goto*//*Label 29209*/ GIMT_Encode4(2208438), // Rule ID 59508 //
     /* 2208354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2208357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208369 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208388 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208397 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2208414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208437 */     // GIR_Coverage, 59508,
     /* 2208437 */     GIR_EraseRootFromParent_Done,
     /* 2208438 */   // Label 29209: @2208438
     /* 2208438 */   GIM_Try, /*On fail goto*//*Label 29210*/ GIMT_Encode4(2208527), // Rule ID 59509 //
     /* 2208443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2208446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208458 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208460 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2208477 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208479 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208484 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208486 */     // (shl:{ *:[nxv2i64] } (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv2i64] } VR:{ *:[nxv2i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2208503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2208522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208526 */     // GIR_Coverage, 59509,
     /* 2208526 */     GIR_EraseRootFromParent_Done,
     /* 2208527 */   // Label 29210: @2208527
     /* 2208527 */   GIM_Try, /*On fail goto*//*Label 29211*/ GIMT_Encode4(2208580), // Rule ID 47998 //
     /* 2208532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2208535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208543 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2208560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208579 */     // GIR_Coverage, 47998,
     /* 2208579 */     GIR_EraseRootFromParent_Done,
     /* 2208580 */   // Label 29211: @2208580
     /* 2208580 */   GIM_Try, /*On fail goto*//*Label 29212*/ GIMT_Encode4(2208633), // Rule ID 47999 //
     /* 2208585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2208588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2208596 */     // (shl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2208599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2208613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2208628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208632 */     // GIR_Coverage, 47999,
     /* 2208632 */     GIR_EraseRootFromParent_Done,
     /* 2208633 */   // Label 29212: @2208633
     /* 2208633 */   GIM_Reject,
     /* 2208634 */ // Label 29206: @2208634
     /* 2208634 */ GIM_Reject,
     /* 2208635 */ // Label 29139: @2208635
     /* 2208635 */ GIM_Try, /*On fail goto*//*Label 29213*/ GIMT_Encode4(2208749),
     /* 2208640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2208646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208658 */   GIM_Try, /*On fail goto*//*Label 29214*/ GIMT_Encode4(2208703), // Rule ID 47930 //
     /* 2208663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2208666 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2208669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2208683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208702 */     // GIR_Coverage, 47930,
     /* 2208702 */     GIR_EraseRootFromParent_Done,
     /* 2208703 */   // Label 29214: @2208703
     /* 2208703 */   GIM_Try, /*On fail goto*//*Label 29215*/ GIMT_Encode4(2208748), // Rule ID 47931 //
     /* 2208708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2208711 */     // (shl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSLL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2208714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_MF2),
     /* 2208728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2208735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2208737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208747 */     // GIR_Coverage, 47931,
     /* 2208747 */     GIR_EraseRootFromParent_Done,
     /* 2208748 */   // Label 29215: @2208748
     /* 2208748 */   GIM_Reject,
     /* 2208749 */ // Label 29213: @2208749
     /* 2208749 */ GIM_Reject,
     /* 2208750 */ // Label 29140: @2208750
     /* 2208750 */ GIM_Try, /*On fail goto*//*Label 29216*/ GIMT_Encode4(2209228),
     /* 2208755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2208758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2208761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208765 */   GIM_Try, /*On fail goto*//*Label 29217*/ GIMT_Encode4(2208854), // Rule ID 59426 //
     /* 2208770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2208773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208785 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2208800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208804 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208811 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208813 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2208830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208853 */     // GIR_Coverage, 59426,
     /* 2208853 */     GIR_EraseRootFromParent_Done,
     /* 2208854 */   // Label 29217: @2208854
     /* 2208854 */   GIM_Try, /*On fail goto*//*Label 29218*/ GIMT_Encode4(2208943), // Rule ID 59427 //
     /* 2208859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2208862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208874 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2208889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208893 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208902 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2208902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2208914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2208916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2208919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2208921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2208924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2208928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2208932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2208935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2208941 */     GIR_RootConstrainSelectedInstOperands,
     /* 2208942 */     // GIR_Coverage, 59427,
     /* 2208942 */     GIR_EraseRootFromParent_Done,
     /* 2208943 */   // Label 29218: @2208943
     /* 2208943 */   GIM_Try, /*On fail goto*//*Label 29219*/ GIMT_Encode4(2209032), // Rule ID 59428 //
     /* 2208948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2208951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2208955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208963 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2208965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2208974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2208978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2208982 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2208984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2208989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2208991 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2208991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2208994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2208998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209003 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2209008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209010 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209031 */     // GIR_Coverage, 59428,
     /* 2209031 */     GIR_EraseRootFromParent_Done,
     /* 2209032 */   // Label 29219: @2209032
     /* 2209032 */   GIM_Try, /*On fail goto*//*Label 29220*/ GIMT_Encode4(2209121), // Rule ID 59429 //
     /* 2209037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2209040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209052 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2209071 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209073 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209080 */     // (shl:{ *:[nxv4i16] } (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i16] } VR:{ *:[nxv4i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_MF2:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_MF2),
     /* 2209097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209119 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209120 */     // GIR_Coverage, 59429,
     /* 2209120 */     GIR_EraseRootFromParent_Done,
     /* 2209121 */   // Label 29220: @2209121
     /* 2209121 */   GIM_Try, /*On fail goto*//*Label 29221*/ GIMT_Encode4(2209174), // Rule ID 47950 //
     /* 2209126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209137 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2209154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209173 */     // GIR_Coverage, 47950,
     /* 2209173 */     GIR_EraseRootFromParent_Done,
     /* 2209174 */   // Label 29221: @2209174
     /* 2209174 */   GIM_Try, /*On fail goto*//*Label 29222*/ GIMT_Encode4(2209227), // Rule ID 47951 //
     /* 2209179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209190 */     // (shl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2209193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2209207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209226 */     // GIR_Coverage, 47951,
     /* 2209226 */     GIR_EraseRootFromParent_Done,
     /* 2209227 */   // Label 29222: @2209227
     /* 2209227 */   GIM_Reject,
     /* 2209228 */ // Label 29216: @2209228
     /* 2209228 */ GIM_Reject,
     /* 2209229 */ // Label 29141: @2209229
     /* 2209229 */ GIM_Try, /*On fail goto*//*Label 29223*/ GIMT_Encode4(2209707),
     /* 2209234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2209240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209244 */   GIM_Try, /*On fail goto*//*Label 29224*/ GIMT_Encode4(2209333), // Rule ID 59474 //
     /* 2209249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2209252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209264 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2209279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209283 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209292 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2209309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209332 */     // GIR_Coverage, 59474,
     /* 2209332 */     GIR_EraseRootFromParent_Done,
     /* 2209333 */   // Label 29224: @2209333
     /* 2209333 */   GIM_Try, /*On fail goto*//*Label 29225*/ GIMT_Encode4(2209422), // Rule ID 59475 //
     /* 2209338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2209341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209353 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2209368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209372 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209381 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2209398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209421 */     // GIR_Coverage, 59475,
     /* 2209421 */     GIR_EraseRootFromParent_Done,
     /* 2209422 */   // Label 29225: @2209422
     /* 2209422 */   GIM_Try, /*On fail goto*//*Label 29226*/ GIMT_Encode4(2209511), // Rule ID 59476 //
     /* 2209427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2209430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209442 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209461 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209470 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2209487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209510 */     // GIR_Coverage, 59476,
     /* 2209510 */     GIR_EraseRootFromParent_Done,
     /* 2209511 */   // Label 29226: @2209511
     /* 2209511 */   GIM_Try, /*On fail goto*//*Label 29227*/ GIMT_Encode4(2209600), // Rule ID 59477 //
     /* 2209516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2209519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209531 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209538 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209542 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209546 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2209550 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2209557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209559 */     // (shl:{ *:[nxv4i32] } (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i32] } VR:{ *:[nxv4i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2209576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2209595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209599 */     // GIR_Coverage, 59477,
     /* 2209599 */     GIR_EraseRootFromParent_Done,
     /* 2209600 */   // Label 29227: @2209600
     /* 2209600 */   GIM_Try, /*On fail goto*//*Label 29228*/ GIMT_Encode4(2209653), // Rule ID 47986 //
     /* 2209605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2209608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209616 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2209633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209652 */     // GIR_Coverage, 47986,
     /* 2209652 */     GIR_EraseRootFromParent_Done,
     /* 2209653 */   // Label 29228: @2209653
     /* 2209653 */   GIM_Try, /*On fail goto*//*Label 29229*/ GIMT_Encode4(2209706), // Rule ID 47987 //
     /* 2209658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2209661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209669 */     // (shl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2209672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2209686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2209693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2209695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209705 */     // GIR_Coverage, 47987,
     /* 2209705 */     GIR_EraseRootFromParent_Done,
     /* 2209706 */   // Label 29229: @2209706
     /* 2209706 */   GIM_Reject,
     /* 2209707 */ // Label 29223: @2209707
     /* 2209707 */ GIM_Reject,
     /* 2209708 */ // Label 29142: @2209708
     /* 2209708 */ GIM_Try, /*On fail goto*//*Label 29230*/ GIMT_Encode4(2210186),
     /* 2209713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2209716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2209719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2209723 */   GIM_Try, /*On fail goto*//*Label 29231*/ GIMT_Encode4(2209812), // Rule ID 59514 //
     /* 2209728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209743 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209754 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2209758 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209762 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209764 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209771 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2209788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209811 */     // GIR_Coverage, 59514,
     /* 2209811 */     GIR_EraseRootFromParent_Done,
     /* 2209812 */   // Label 29231: @2209812
     /* 2209812 */   GIM_Try, /*On fail goto*//*Label 29232*/ GIMT_Encode4(2209901), // Rule ID 59515 //
     /* 2209817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209832 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2209847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209851 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209860 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2209860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2209877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209900 */     // GIR_Coverage, 59515,
     /* 2209900 */     GIR_EraseRootFromParent_Done,
     /* 2209901 */   // Label 29232: @2209901
     /* 2209901 */   GIM_Try, /*On fail goto*//*Label 29233*/ GIMT_Encode4(2209990), // Rule ID 59516 //
     /* 2209906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2209909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2209913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209921 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2209923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2209932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2209936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2209940 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2209942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2209947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2209949 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2209949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2209952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2209956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2209961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2209963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2209966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2209968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2209971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2209975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2209979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2209982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2209985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2209988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2209989 */     // GIR_Coverage, 59516,
     /* 2209989 */     GIR_EraseRootFromParent_Done,
     /* 2209990 */   // Label 29233: @2209990
     /* 2209990 */   GIM_Try, /*On fail goto*//*Label 29234*/ GIMT_Encode4(2210079), // Rule ID 59517 //
     /* 2209995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2209998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2210010 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2210029 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210038 */     // (shl:{ *:[nxv4i64] } (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv4i64] } VRM2:{ *:[nxv4i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2210041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2210055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2210074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210078 */     // GIR_Coverage, 59517,
     /* 2210078 */     GIR_EraseRootFromParent_Done,
     /* 2210079 */   // Label 29234: @2210079
     /* 2210079 */   GIM_Try, /*On fail goto*//*Label 29235*/ GIMT_Encode4(2210132), // Rule ID 48002 //
     /* 2210084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2210087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210095 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2210098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2210112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210131 */     // GIR_Coverage, 48002,
     /* 2210131 */     GIR_EraseRootFromParent_Done,
     /* 2210132 */   // Label 29235: @2210132
     /* 2210132 */   GIM_Try, /*On fail goto*//*Label 29236*/ GIMT_Encode4(2210185), // Rule ID 48003 //
     /* 2210137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2210140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210148 */     // (shl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210148 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2210151 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210155 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2210165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210170 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210172 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2210180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210184 */     // GIR_Coverage, 48003,
     /* 2210184 */     GIR_EraseRootFromParent_Done,
     /* 2210185 */   // Label 29236: @2210185
     /* 2210185 */   GIM_Reject,
     /* 2210186 */ // Label 29230: @2210186
     /* 2210186 */ GIM_Reject,
     /* 2210187 */ // Label 29143: @2210187
     /* 2210187 */ GIM_Try, /*On fail goto*//*Label 29237*/ GIMT_Encode4(2210301),
     /* 2210192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2210198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210210 */   GIM_Try, /*On fail goto*//*Label 29238*/ GIMT_Encode4(2210255), // Rule ID 47946 //
     /* 2210215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210218 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2210221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2210235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210242 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210253 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210254 */     // GIR_Coverage, 47946,
     /* 2210254 */     GIR_EraseRootFromParent_Done,
     /* 2210255 */   // Label 29238: @2210255
     /* 2210255 */   GIM_Try, /*On fail goto*//*Label 29239*/ GIMT_Encode4(2210300), // Rule ID 47947 //
     /* 2210260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210263 */     // (shl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSLL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210263 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2210266 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210270 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210275 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M1),
     /* 2210280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210299 */     // GIR_Coverage, 47947,
     /* 2210299 */     GIR_EraseRootFromParent_Done,
     /* 2210300 */   // Label 29239: @2210300
     /* 2210300 */   GIM_Reject,
     /* 2210301 */ // Label 29237: @2210301
     /* 2210301 */ GIM_Reject,
     /* 2210302 */ // Label 29144: @2210302
     /* 2210302 */ GIM_Try, /*On fail goto*//*Label 29240*/ GIMT_Encode4(2210780),
     /* 2210307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2210313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210317 */   GIM_Try, /*On fail goto*//*Label 29241*/ GIMT_Encode4(2210406), // Rule ID 59434 //
     /* 2210322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210337 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210356 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210365 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2210382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210405 */     // GIR_Coverage, 59434,
     /* 2210405 */     GIR_EraseRootFromParent_Done,
     /* 2210406 */   // Label 29241: @2210406
     /* 2210406 */   GIM_Try, /*On fail goto*//*Label 29242*/ GIMT_Encode4(2210495), // Rule ID 59435 //
     /* 2210411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210426 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210445 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210454 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2210471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210494 */     // GIR_Coverage, 59435,
     /* 2210494 */     GIR_EraseRootFromParent_Done,
     /* 2210495 */   // Label 29242: @2210495
     /* 2210495 */   GIM_Try, /*On fail goto*//*Label 29243*/ GIMT_Encode4(2210584), // Rule ID 59436 //
     /* 2210500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210515 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210534 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210543 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2210560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210583 */     // GIR_Coverage, 59436,
     /* 2210583 */     GIR_EraseRootFromParent_Done,
     /* 2210584 */   // Label 29243: @2210584
     /* 2210584 */   GIM_Try, /*On fail goto*//*Label 29244*/ GIMT_Encode4(2210673), // Rule ID 59437 //
     /* 2210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210604 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2210623 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2210630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210632 */     // (shl:{ *:[nxv8i16] } (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i16] } VR:{ *:[nxv8i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M1:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M1),
     /* 2210649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210672 */     // GIR_Coverage, 59437,
     /* 2210672 */     GIR_EraseRootFromParent_Done,
     /* 2210673 */   // Label 29244: @2210673
     /* 2210673 */   GIM_Try, /*On fail goto*//*Label 29245*/ GIMT_Encode4(2210726), // Rule ID 47974 //
     /* 2210678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2210681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210689 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2210706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210725 */     // GIR_Coverage, 47974,
     /* 2210725 */     GIR_EraseRootFromParent_Done,
     /* 2210726 */   // Label 29245: @2210726
     /* 2210726 */   GIM_Try, /*On fail goto*//*Label 29246*/ GIMT_Encode4(2210779), // Rule ID 47975 //
     /* 2210731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2210734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210742 */     // (shl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2210745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2210759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2210766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2210768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210778 */     // GIR_Coverage, 47975,
     /* 2210778 */     GIR_EraseRootFromParent_Done,
     /* 2210779 */   // Label 29246: @2210779
     /* 2210779 */   GIM_Reject,
     /* 2210780 */ // Label 29240: @2210780
     /* 2210780 */ GIM_Reject,
     /* 2210781 */ // Label 29145: @2210781
     /* 2210781 */ GIM_Try, /*On fail goto*//*Label 29247*/ GIMT_Encode4(2211259),
     /* 2210786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2210789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2210792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2210796 */   GIM_Try, /*On fail goto*//*Label 29248*/ GIMT_Encode4(2210885), // Rule ID 59482 //
     /* 2210801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210816 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210835 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210844 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2210844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2210861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210884 */     // GIR_Coverage, 59482,
     /* 2210884 */     GIR_EraseRootFromParent_Done,
     /* 2210885 */   // Label 29248: @2210885
     /* 2210885 */   GIM_Try, /*On fail goto*//*Label 29249*/ GIMT_Encode4(2210974), // Rule ID 59483 //
     /* 2210890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2210893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210905 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2210916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2210920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210924 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2210926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2210931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2210933 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2210933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2210936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2210940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2210945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2210947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2210950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2210952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2210955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2210959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2210963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2210966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2210969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2210972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2210973 */     // GIR_Coverage, 59483,
     /* 2210973 */     GIR_EraseRootFromParent_Done,
     /* 2210974 */   // Label 29249: @2210974
     /* 2210974 */   GIM_Try, /*On fail goto*//*Label 29250*/ GIMT_Encode4(2211063), // Rule ID 59484 //
     /* 2210979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2210982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2210986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2210990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2210994 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2210996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2211013 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211022 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2211039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211062 */     // GIR_Coverage, 59484,
     /* 2211062 */     GIR_EraseRootFromParent_Done,
     /* 2211063 */   // Label 29250: @2211063
     /* 2211063 */   GIM_Try, /*On fail goto*//*Label 29251*/ GIMT_Encode4(2211152), // Rule ID 59485 //
     /* 2211068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2211071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2211083 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2211102 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211109 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211111 */     // (shl:{ *:[nxv8i32] } (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i32] } VRM2:{ *:[nxv8i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2211128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2211147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211151 */     // GIR_Coverage, 59485,
     /* 2211151 */     GIR_EraseRootFromParent_Done,
     /* 2211152 */   // Label 29251: @2211152
     /* 2211152 */   GIM_Try, /*On fail goto*//*Label 29252*/ GIMT_Encode4(2211205), // Rule ID 47990 //
     /* 2211157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211168 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2211185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211204 */     // GIR_Coverage, 47990,
     /* 2211204 */     GIR_EraseRootFromParent_Done,
     /* 2211205 */   // Label 29252: @2211205
     /* 2211205 */   GIM_Try, /*On fail goto*//*Label 29253*/ GIMT_Encode4(2211258), // Rule ID 47991 //
     /* 2211210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211221 */     // (shl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2211224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2211238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211257 */     // GIR_Coverage, 47991,
     /* 2211257 */     GIR_EraseRootFromParent_Done,
     /* 2211258 */   // Label 29253: @2211258
     /* 2211258 */   GIM_Reject,
     /* 2211259 */ // Label 29247: @2211259
     /* 2211259 */ GIM_Reject,
     /* 2211260 */ // Label 29146: @2211260
     /* 2211260 */ GIM_Try, /*On fail goto*//*Label 29254*/ GIMT_Encode4(2211738),
     /* 2211265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2211268 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2211271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211275 */   GIM_Try, /*On fail goto*//*Label 29255*/ GIMT_Encode4(2211364), // Rule ID 59522 //
     /* 2211280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211295 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211314 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211323 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2211340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211363 */     // GIR_Coverage, 59522,
     /* 2211363 */     GIR_EraseRootFromParent_Done,
     /* 2211364 */   // Label 29255: @2211364
     /* 2211364 */   GIM_Try, /*On fail goto*//*Label 29256*/ GIMT_Encode4(2211453), // Rule ID 59523 //
     /* 2211369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211384 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211403 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211412 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2211429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211451 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211452 */     // GIR_Coverage, 59523,
     /* 2211452 */     GIR_EraseRootFromParent_Done,
     /* 2211453 */   // Label 29256: @2211453
     /* 2211453 */   GIM_Try, /*On fail goto*//*Label 29257*/ GIMT_Encode4(2211542), // Rule ID 59524 //
     /* 2211458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode0),
     /* 2211461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211473 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211492 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211494 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211499 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211501 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2211518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211541 */     // GIR_Coverage, 59524,
     /* 2211541 */     GIR_EraseRootFromParent_Done,
     /* 2211542 */   // Label 29257: @2211542
     /* 2211542 */   GIM_Try, /*On fail goto*//*Label 29258*/ GIMT_Encode4(2211631), // Rule ID 59525 //
     /* 2211547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HasVInstructionsI64_HwMode1),
     /* 2211550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211562 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211564 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2211581 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211583 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211590 */     // (shl:{ *:[nxv8i64] } (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv8i64] } VRM4:{ *:[nxv8i32] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2211607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2211626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211630 */     // GIR_Coverage, 59525,
     /* 2211630 */     GIR_EraseRootFromParent_Done,
     /* 2211631 */   // Label 29258: @2211631
     /* 2211631 */   GIM_Try, /*On fail goto*//*Label 29259*/ GIMT_Encode4(2211684), // Rule ID 48006 //
     /* 2211636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2211639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211647 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2211664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211683 */     // GIR_Coverage, 48006,
     /* 2211683 */     GIR_EraseRootFromParent_Done,
     /* 2211684 */   // Label 29259: @2211684
     /* 2211684 */   GIM_Try, /*On fail goto*//*Label 29260*/ GIMT_Encode4(2211737), // Rule ID 48007 //
     /* 2211689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2211692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2211700 */     // (shl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2211703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2211717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2211732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211735 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211736 */     // GIR_Coverage, 48007,
     /* 2211736 */     GIR_EraseRootFromParent_Done,
     /* 2211737 */   // Label 29260: @2211737
     /* 2211737 */   GIM_Reject,
     /* 2211738 */ // Label 29254: @2211738
     /* 2211738 */ GIM_Reject,
     /* 2211739 */ // Label 29147: @2211739
     /* 2211739 */ GIM_Try, /*On fail goto*//*Label 29261*/ GIMT_Encode4(2211853),
     /* 2211744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2211750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211758 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211762 */   GIM_Try, /*On fail goto*//*Label 29262*/ GIMT_Encode4(2211807), // Rule ID 47962 //
     /* 2211767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2211770 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2211773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2211787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211805 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211806 */     // GIR_Coverage, 47962,
     /* 2211806 */     GIR_EraseRootFromParent_Done,
     /* 2211807 */   // Label 29262: @2211807
     /* 2211807 */   GIM_Try, /*On fail goto*//*Label 29263*/ GIMT_Encode4(2211852), // Rule ID 47963 //
     /* 2211812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2211815 */     // (shl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSLL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2211815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2211818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211827 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M2),
     /* 2211832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211834 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211837 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2211839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2211841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211851 */     // GIR_Coverage, 47963,
     /* 2211851 */     GIR_EraseRootFromParent_Done,
     /* 2211852 */   // Label 29263: @2211852
     /* 2211852 */   GIM_Reject,
     /* 2211853 */ // Label 29261: @2211853
     /* 2211853 */ GIM_Reject,
     /* 2211854 */ // Label 29148: @2211854
     /* 2211854 */ GIM_Try, /*On fail goto*//*Label 29264*/ GIMT_Encode4(2212332),
     /* 2211859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2211862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2211865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2211869 */   GIM_Try, /*On fail goto*//*Label 29265*/ GIMT_Encode4(2211958), // Rule ID 59442 //
     /* 2211874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2211877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211889 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211908 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211910 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2211917 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2211917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2211920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2211924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2211929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2211931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2211934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2211936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2211939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2211943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2211947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2211950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2211956 */     GIR_RootConstrainSelectedInstOperands,
     /* 2211957 */     // GIR_Coverage, 59442,
     /* 2211957 */     GIR_EraseRootFromParent_Done,
     /* 2211958 */   // Label 29265: @2211958
     /* 2211958 */   GIM_Try, /*On fail goto*//*Label 29266*/ GIMT_Encode4(2212047), // Rule ID 59443 //
     /* 2211963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2211966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2211970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2211974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211978 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2211980 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2211985 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2211989 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2211993 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2211997 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2211999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212004 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212006 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2212009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2212023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212032 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212046 */     // GIR_Coverage, 59443,
     /* 2212046 */     GIR_EraseRootFromParent_Done,
     /* 2212047 */   // Label 29266: @2212047
     /* 2212047 */   GIM_Try, /*On fail goto*//*Label 29267*/ GIMT_Encode4(2212136), // Rule ID 59444 //
     /* 2212052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2212067 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212078 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212082 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2212086 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212093 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212095 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2212098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2212112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212135 */     // GIR_Coverage, 59444,
     /* 2212135 */     GIR_EraseRootFromParent_Done,
     /* 2212136 */   // Label 29267: @2212136
     /* 2212136 */   GIM_Try, /*On fail goto*//*Label 29268*/ GIMT_Encode4(2212225), // Rule ID 59445 //
     /* 2212141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2212144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2212156 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2212175 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2212182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212184 */     // (shl:{ *:[nxv16i16] } (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i16] } VRM2:{ *:[nxv16i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M2:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2212187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M2),
     /* 2212201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212224 */     // GIR_Coverage, 59445,
     /* 2212224 */     GIR_EraseRootFromParent_Done,
     /* 2212225 */   // Label 29268: @2212225
     /* 2212225 */   GIM_Try, /*On fail goto*//*Label 29269*/ GIMT_Encode4(2212278), // Rule ID 47978 //
     /* 2212230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212241 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2212244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2212258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212277 */     // GIR_Coverage, 47978,
     /* 2212277 */     GIR_EraseRootFromParent_Done,
     /* 2212278 */   // Label 29269: @2212278
     /* 2212278 */   GIM_Try, /*On fail goto*//*Label 29270*/ GIMT_Encode4(2212331), // Rule ID 47979 //
     /* 2212283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212294 */     // (shl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2212297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2212311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212330 */     // GIR_Coverage, 47979,
     /* 2212330 */     GIR_EraseRootFromParent_Done,
     /* 2212331 */   // Label 29270: @2212331
     /* 2212331 */   GIM_Reject,
     /* 2212332 */ // Label 29264: @2212332
     /* 2212332 */ GIM_Reject,
     /* 2212333 */ // Label 29149: @2212333
     /* 2212333 */ GIM_Try, /*On fail goto*//*Label 29271*/ GIMT_Encode4(2212811),
     /* 2212338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2212341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2212344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212348 */   GIM_Try, /*On fail goto*//*Label 29272*/ GIMT_Encode4(2212437), // Rule ID 59490 //
     /* 2212353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212368 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212387 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212396 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2212413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212436 */     // GIR_Coverage, 59490,
     /* 2212436 */     GIR_EraseRootFromParent_Done,
     /* 2212437 */   // Label 29272: @2212437
     /* 2212437 */   GIM_Try, /*On fail goto*//*Label 29273*/ GIMT_Encode4(2212526), // Rule ID 59491 //
     /* 2212442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2212445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212457 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212464 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212468 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212472 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212476 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212485 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2212502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212525 */     // GIR_Coverage, 59491,
     /* 2212525 */     GIR_EraseRootFromParent_Done,
     /* 2212526 */   // Label 29273: @2212526
     /* 2212526 */   GIM_Try, /*On fail goto*//*Label 29274*/ GIMT_Encode4(2212615), // Rule ID 59492 //
     /* 2212531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212546 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212565 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212574 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2212591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212614 */     // GIR_Coverage, 59492,
     /* 2212614 */     GIR_EraseRootFromParent_Done,
     /* 2212615 */   // Label 29274: @2212615
     /* 2212615 */   GIM_Try, /*On fail goto*//*Label 29275*/ GIMT_Encode4(2212704), // Rule ID 59493 //
     /* 2212620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2212623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212635 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2212654 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212663 */     // (shl:{ *:[nxv16i32] } (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv16i32] } VRM4:{ *:[nxv16i16] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2212680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2212689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2212693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2212699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212703 */     // GIR_Coverage, 59493,
     /* 2212703 */     GIR_EraseRootFromParent_Done,
     /* 2212704 */   // Label 29275: @2212704
     /* 2212704 */   GIM_Try, /*On fail goto*//*Label 29276*/ GIMT_Encode4(2212757), // Rule ID 47994 //
     /* 2212709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212720 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2212737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212756 */     // GIR_Coverage, 47994,
     /* 2212756 */     GIR_EraseRootFromParent_Done,
     /* 2212757 */   // Label 29276: @2212757
     /* 2212757 */   GIM_Try, /*On fail goto*//*Label 29277*/ GIMT_Encode4(2212810), // Rule ID 47995 //
     /* 2212762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212773 */     // (shl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2212776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2212790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2212805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212809 */     // GIR_Coverage, 47995,
     /* 2212809 */     GIR_EraseRootFromParent_Done,
     /* 2212810 */   // Label 29277: @2212810
     /* 2212810 */   GIM_Reject,
     /* 2212811 */ // Label 29271: @2212811
     /* 2212811 */ GIM_Reject,
     /* 2212812 */ // Label 29150: @2212812
     /* 2212812 */ GIM_Try, /*On fail goto*//*Label 29278*/ GIMT_Encode4(2212926),
     /* 2212817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2212820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2212823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212835 */   GIM_Try, /*On fail goto*//*Label 29279*/ GIMT_Encode4(2212880), // Rule ID 47966 //
     /* 2212840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2212843 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2212846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2212860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212879 */     // GIR_Coverage, 47966,
     /* 2212879 */     GIR_EraseRootFromParent_Done,
     /* 2212880 */   // Label 29279: @2212880
     /* 2212880 */   GIM_Try, /*On fail goto*//*Label 29280*/ GIMT_Encode4(2212925), // Rule ID 47967 //
     /* 2212885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2212888 */     // (shl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSLL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2212888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2212891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2212900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2212902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M4),
     /* 2212905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2212907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2212910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2212912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2212914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2212917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2212923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2212924 */     // GIR_Coverage, 47967,
     /* 2212924 */     GIR_EraseRootFromParent_Done,
     /* 2212925 */   // Label 29280: @2212925
     /* 2212925 */   GIM_Reject,
     /* 2212926 */ // Label 29278: @2212926
     /* 2212926 */ GIM_Reject,
     /* 2212927 */ // Label 29151: @2212927
     /* 2212927 */ GIM_Try, /*On fail goto*//*Label 29281*/ GIMT_Encode4(2213405),
     /* 2212932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2212935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2212938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2212942 */   GIM_Try, /*On fail goto*//*Label 29282*/ GIMT_Encode4(2213031), // Rule ID 59450 //
     /* 2212947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2212950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2212954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2212958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2212962 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2212964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2212973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2212977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2212981 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2212983 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2212988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2212990 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2212990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2212993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2212997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2213007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213030 */     // GIR_Coverage, 59450,
     /* 2213030 */     GIR_EraseRootFromParent_Done,
     /* 2213031 */   // Label 29282: @2213031
     /* 2213031 */   GIM_Try, /*On fail goto*//*Label 29283*/ GIMT_Encode4(2213120), // Rule ID 59451 //
     /* 2213036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213051 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 2213066 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213070 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213077 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213079 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (sext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2213082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2213096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213119 */     // GIR_Coverage, 59451,
     /* 2213119 */     GIR_EraseRootFromParent_Done,
     /* 2213120 */   // Label 29283: @2213120
     /* 2213120 */   GIM_Try, /*On fail goto*//*Label 29284*/ GIMT_Encode4(2213209), // Rule ID 59452 //
     /* 2213125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2213128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213140 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213159 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213168 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2213171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2213185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213208 */     // GIR_Coverage, 59452,
     /* 2213208 */     GIR_EraseRootFromParent_Done,
     /* 2213209 */   // Label 29284: @2213209
     /* 2213209 */   GIM_Try, /*On fail goto*//*Label 29285*/ GIMT_Encode4(2213298), // Rule ID 59453 //
     /* 2213214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2213217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213229 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 2213231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 2213244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2213248 */     GIM_CheckHasOneUse, /*MI*/2,
     /* 2213250 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2213255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213257 */     // (shl:{ *:[nxv32i16] } (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs2)<<P:Predicate_zext_oneuse>>, (zext:{ *:[nxv32i16] } VRM4:{ *:[nxv32i8] }:$rs1)<<P:Predicate_ext_oneuse>>)  =>  (PseudoVWSLL_VV_M4:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2213260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVWSLL_VV_M4),
     /* 2213274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2213283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs1
     /* 2213287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213297 */     // GIR_Coverage, 59453,
     /* 2213297 */     GIR_EraseRootFromParent_Done,
     /* 2213298 */   // Label 29285: @2213298
     /* 2213298 */   GIM_Try, /*On fail goto*//*Label 29286*/ GIMT_Encode4(2213351), // Rule ID 47982 //
     /* 2213303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213314 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2213317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2213331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213350 */     // GIR_Coverage, 47982,
     /* 2213350 */     GIR_EraseRootFromParent_Done,
     /* 2213351 */   // Label 29286: @2213351
     /* 2213351 */   GIM_Try, /*On fail goto*//*Label 29287*/ GIMT_Encode4(2213404), // Rule ID 47983 //
     /* 2213356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213367 */     // (shl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2213370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2213384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2213399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213403 */     // GIR_Coverage, 47983,
     /* 2213403 */     GIR_EraseRootFromParent_Done,
     /* 2213404 */   // Label 29287: @2213404
     /* 2213404 */   GIM_Reject,
     /* 2213405 */ // Label 29281: @2213405
     /* 2213405 */ GIM_Reject,
     /* 2213406 */ // Label 29152: @2213406
     /* 2213406 */ GIM_Try, /*On fail goto*//*Label 29288*/ GIMT_Encode4(2213520),
     /* 2213411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2213414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2213417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2213429 */   GIM_Try, /*On fail goto*//*Label 29289*/ GIMT_Encode4(2213474), // Rule ID 47970 //
     /* 2213434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2213437 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2213437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2213440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2213454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213473 */     // GIR_Coverage, 47970,
     /* 2213473 */     GIR_EraseRootFromParent_Done,
     /* 2213474 */   // Label 29289: @2213474
     /* 2213474 */   GIM_Try, /*On fail goto*//*Label 29290*/ GIMT_Encode4(2213519), // Rule ID 47971 //
     /* 2213479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2213482 */     // (shl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSLL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2213482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2213485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2213489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2213494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2213496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLL_VV_M8),
     /* 2213499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2213504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2213508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2213511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2213517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213518 */     // GIR_Coverage, 47971,
     /* 2213518 */     GIR_EraseRootFromParent_Done,
     /* 2213519 */   // Label 29290: @2213519
     /* 2213519 */   GIM_Reject,
     /* 2213520 */ // Label 29288: @2213520
     /* 2213520 */ GIM_Reject,
     /* 2213521 */ // Label 29153: @2213521
     /* 2213521 */ GIM_Reject,
     /* 2213522 */ // Label 44: @2213522
     /* 2213522 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29315*/ GIMT_Encode4(2216552),
     /* 2213533 */ /*GILLT_s32*//*Label 29291*/ GIMT_Encode4(2213657),
     /* 2213537 */ /*GILLT_s64*//*Label 29292*/ GIMT_Encode4(2213741), GIMT_Encode4(0),
     /* 2213545 */ /*GILLT_nxv1s8*//*Label 29293*/ GIMT_Encode4(2214022),
     /* 2213549 */ /*GILLT_nxv1s16*//*Label 29294*/ GIMT_Encode4(2214137),
     /* 2213553 */ /*GILLT_nxv1s32*//*Label 29295*/ GIMT_Encode4(2214252),
     /* 2213557 */ /*GILLT_nxv1s64*//*Label 29296*/ GIMT_Encode4(2214367), GIMT_Encode4(0),
     /* 2213565 */ /*GILLT_nxv2s8*//*Label 29297*/ GIMT_Encode4(2214482),
     /* 2213569 */ /*GILLT_nxv2s16*//*Label 29298*/ GIMT_Encode4(2214597),
     /* 2213573 */ /*GILLT_nxv2s32*//*Label 29299*/ GIMT_Encode4(2214712),
     /* 2213577 */ /*GILLT_nxv2s64*//*Label 29300*/ GIMT_Encode4(2214827), GIMT_Encode4(0),
     /* 2213585 */ /*GILLT_nxv4s8*//*Label 29301*/ GIMT_Encode4(2214942),
     /* 2213589 */ /*GILLT_nxv4s16*//*Label 29302*/ GIMT_Encode4(2215057),
     /* 2213593 */ /*GILLT_nxv4s32*//*Label 29303*/ GIMT_Encode4(2215172),
     /* 2213597 */ /*GILLT_nxv4s64*//*Label 29304*/ GIMT_Encode4(2215287), GIMT_Encode4(0),
     /* 2213605 */ /*GILLT_nxv8s8*//*Label 29305*/ GIMT_Encode4(2215402),
     /* 2213609 */ /*GILLT_nxv8s16*//*Label 29306*/ GIMT_Encode4(2215517),
     /* 2213613 */ /*GILLT_nxv8s32*//*Label 29307*/ GIMT_Encode4(2215632),
     /* 2213617 */ /*GILLT_nxv8s64*//*Label 29308*/ GIMT_Encode4(2215747), GIMT_Encode4(0),
     /* 2213625 */ /*GILLT_nxv16s8*//*Label 29309*/ GIMT_Encode4(2215862),
     /* 2213629 */ /*GILLT_nxv16s16*//*Label 29310*/ GIMT_Encode4(2215977),
     /* 2213633 */ /*GILLT_nxv16s32*//*Label 29311*/ GIMT_Encode4(2216092), GIMT_Encode4(0),
     /* 2213641 */ /*GILLT_nxv32s8*//*Label 29312*/ GIMT_Encode4(2216207),
     /* 2213645 */ /*GILLT_nxv32s16*//*Label 29313*/ GIMT_Encode4(2216322), GIMT_Encode4(0),
     /* 2213653 */ /*GILLT_nxv64s8*//*Label 29314*/ GIMT_Encode4(2216437),
     /* 2213657 */ // Label 29291: @2213657
     /* 2213657 */ GIM_Try, /*On fail goto*//*Label 29316*/ GIMT_Encode4(2213740),
     /* 2213662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2213665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2213668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213676 */   GIM_Try, /*On fail goto*//*Label 29317*/ GIMT_Encode4(2213710), // Rule ID 93 //
     /* 2213681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2213684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2213688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2213692 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2213696 */     // MIs[1] Operand 1
     /* 2213696 */     // No operand predicates
     /* 2213696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2213698 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2213698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2213701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213705 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2213708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213709 */     // GIR_Coverage, 93,
     /* 2213709 */     GIR_EraseRootFromParent_Done,
     /* 2213710 */   // Label 29317: @2213710
     /* 2213710 */   GIM_Try, /*On fail goto*//*Label 29318*/ GIMT_Encode4(2213739), // Rule ID 107 //
     /* 2213715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2213718 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2213725 */     // (srl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2213725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2213728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2213737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213738 */     // GIR_Coverage, 107,
     /* 2213738 */     GIR_EraseRootFromParent_Done,
     /* 2213739 */   // Label 29318: @2213739
     /* 2213739 */   GIM_Reject,
     /* 2213740 */ // Label 29316: @2213740
     /* 2213740 */ GIM_Reject,
     /* 2213741 */ // Label 29292: @2213741
     /* 2213741 */ GIM_Try, /*On fail goto*//*Label 29319*/ GIMT_Encode4(2214021),
     /* 2213746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2213749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2213752 */   GIM_Try, /*On fail goto*//*Label 29320*/ GIMT_Encode4(2213824), // Rule ID 257 //
     /* 2213757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2213760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 2213772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2213776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2213780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213785 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 2213796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2213804 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2213808 */     // MIs[2] Operand 1
     /* 2213808 */     // No operand predicates
     /* 2213808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213810 */     // (srl:{ *:[i64] } (and:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 4294967295:{ *:[i64] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRLIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2213810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLIW),
     /* 2213813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2213819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2213822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213823 */     // GIR_Coverage, 257,
     /* 2213823 */     GIR_EraseRootFromParent_Done,
     /* 2213824 */   // Label 29320: @2213824
     /* 2213824 */   GIM_Try, /*On fail goto*//*Label 29321*/ GIMT_Encode4(2213869), // Rule ID 62543 //
     /* 2213829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2213832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2213844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2213848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2213852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /* 2213856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2213858 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })<<P:Predicate_anonymous_10046>>  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2213858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2213861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2213867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213868 */     // GIR_Coverage, 62543,
     /* 2213868 */     GIR_EraseRootFromParent_Done,
     /* 2213869 */   // Label 29321: @2213869
     /* 2213869 */   GIM_Try, /*On fail goto*//*Label 29322*/ GIMT_Encode4(2213941), // Rule ID 269 //
     /* 2213874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2213877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2213885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2213889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2213893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213898 */     // MIs[1] Operand 2
     /* 2213898 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2213909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2213913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2213917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2213921 */     // MIs[2] Operand 1
     /* 2213921 */     // No operand predicates
     /* 2213921 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_anonymous_10046),
     /* 2213925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2213927 */     // (srl:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)<<P:Predicate_anonymous_10046>>  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2213927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2213930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2213936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2213939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213940 */     // GIR_Coverage, 269,
     /* 2213940 */     GIR_EraseRootFromParent_Done,
     /* 2213941 */   // Label 29322: @2213941
     /* 2213941 */   GIM_Try, /*On fail goto*//*Label 29323*/ GIMT_Encode4(2213983), // Rule ID 92 //
     /* 2213946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2213949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2213961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2213965 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2213969 */     // MIs[1] Operand 1
     /* 2213969 */     // No operand predicates
     /* 2213969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2213971 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRLI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2213971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLI),
     /* 2213974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2213976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2213978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2213981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2213982 */     // GIR_Coverage, 92,
     /* 2213982 */     GIR_EraseRootFromParent_Done,
     /* 2213983 */   // Label 29323: @2213983
     /* 2213983 */   GIM_Try, /*On fail goto*//*Label 29324*/ GIMT_Encode4(2214020), // Rule ID 106 //
     /* 2213988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2213991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2213999 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2214006 */     // (srl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2214006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRL),
     /* 2214009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214011 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2214018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214019 */     // GIR_Coverage, 106,
     /* 2214019 */     GIR_EraseRootFromParent_Done,
     /* 2214020 */   // Label 29324: @2214020
     /* 2214020 */   GIM_Reject,
     /* 2214021 */ // Label 29319: @2214021
     /* 2214021 */ GIM_Reject,
     /* 2214022 */ // Label 29293: @2214022
     /* 2214022 */ GIM_Try, /*On fail goto*//*Label 29325*/ GIMT_Encode4(2214136),
     /* 2214027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2214030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2214033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214037 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214041 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214045 */   GIM_Try, /*On fail goto*//*Label 29326*/ GIMT_Encode4(2214090), // Rule ID 48054 //
     /* 2214050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214053 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2214056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2214070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214089 */     // GIR_Coverage, 48054,
     /* 2214089 */     GIR_EraseRootFromParent_Done,
     /* 2214090 */   // Label 29326: @2214090
     /* 2214090 */   GIM_Try, /*On fail goto*//*Label 29327*/ GIMT_Encode4(2214135), // Rule ID 48055 //
     /* 2214095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214098 */     // (srl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2214101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF8),
     /* 2214115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214134 */     // GIR_Coverage, 48055,
     /* 2214134 */     GIR_EraseRootFromParent_Done,
     /* 2214135 */   // Label 29327: @2214135
     /* 2214135 */   GIM_Reject,
     /* 2214136 */ // Label 29325: @2214136
     /* 2214136 */ GIM_Reject,
     /* 2214137 */ // Label 29294: @2214137
     /* 2214137 */ GIM_Try, /*On fail goto*//*Label 29328*/ GIMT_Encode4(2214251),
     /* 2214142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2214145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2214148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214160 */   GIM_Try, /*On fail goto*//*Label 29329*/ GIMT_Encode4(2214205), // Rule ID 48066 //
     /* 2214165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214168 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2214171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2214185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214204 */     // GIR_Coverage, 48066,
     /* 2214204 */     GIR_EraseRootFromParent_Done,
     /* 2214205 */   // Label 29329: @2214205
     /* 2214205 */   GIM_Try, /*On fail goto*//*Label 29330*/ GIMT_Encode4(2214250), // Rule ID 48067 //
     /* 2214210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214213 */     // (srl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2214216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2214230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214232 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214249 */     // GIR_Coverage, 48067,
     /* 2214249 */     GIR_EraseRootFromParent_Done,
     /* 2214250 */   // Label 29330: @2214250
     /* 2214250 */   GIM_Reject,
     /* 2214251 */ // Label 29328: @2214251
     /* 2214251 */ GIM_Reject,
     /* 2214252 */ // Label 29295: @2214252
     /* 2214252 */ GIM_Try, /*On fail goto*//*Label 29331*/ GIMT_Encode4(2214366),
     /* 2214257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2214260 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2214263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214271 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214275 */   GIM_Try, /*On fail goto*//*Label 29332*/ GIMT_Encode4(2214320), // Rule ID 48074 //
     /* 2214280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214283 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2214286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2214300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214319 */     // GIR_Coverage, 48074,
     /* 2214319 */     GIR_EraseRootFromParent_Done,
     /* 2214320 */   // Label 29332: @2214320
     /* 2214320 */   GIM_Try, /*On fail goto*//*Label 29333*/ GIMT_Encode4(2214365), // Rule ID 48075 //
     /* 2214325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214328 */     // (srl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2214331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2214345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214350 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214364 */     // GIR_Coverage, 48075,
     /* 2214364 */     GIR_EraseRootFromParent_Done,
     /* 2214365 */   // Label 29333: @2214365
     /* 2214365 */   GIM_Reject,
     /* 2214366 */ // Label 29331: @2214366
     /* 2214366 */ GIM_Reject,
     /* 2214367 */ // Label 29296: @2214367
     /* 2214367 */ GIM_Try, /*On fail goto*//*Label 29334*/ GIMT_Encode4(2214481),
     /* 2214372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2214375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2214378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214386 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214390 */   GIM_Try, /*On fail goto*//*Label 29335*/ GIMT_Encode4(2214435), // Rule ID 48090 //
     /* 2214395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2214398 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2214401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2214415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214434 */     // GIR_Coverage, 48090,
     /* 2214434 */     GIR_EraseRootFromParent_Done,
     /* 2214435 */   // Label 29335: @2214435
     /* 2214435 */   GIM_Try, /*On fail goto*//*Label 29336*/ GIMT_Encode4(2214480), // Rule ID 48091 //
     /* 2214440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2214443 */     // (srl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2214446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2214460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214479 */     // GIR_Coverage, 48091,
     /* 2214479 */     GIR_EraseRootFromParent_Done,
     /* 2214480 */   // Label 29336: @2214480
     /* 2214480 */   GIM_Reject,
     /* 2214481 */ // Label 29334: @2214481
     /* 2214481 */ GIM_Reject,
     /* 2214482 */ // Label 29297: @2214482
     /* 2214482 */ GIM_Try, /*On fail goto*//*Label 29337*/ GIMT_Encode4(2214596),
     /* 2214487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2214490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2214493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214497 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214505 */   GIM_Try, /*On fail goto*//*Label 29338*/ GIMT_Encode4(2214550), // Rule ID 48058 //
     /* 2214510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214513 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2214516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2214530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214549 */     // GIR_Coverage, 48058,
     /* 2214549 */     GIR_EraseRootFromParent_Done,
     /* 2214550 */   // Label 29338: @2214550
     /* 2214550 */   GIM_Try, /*On fail goto*//*Label 29339*/ GIMT_Encode4(2214595), // Rule ID 48059 //
     /* 2214555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214558 */     // (srl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2214561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF4),
     /* 2214575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214594 */     // GIR_Coverage, 48059,
     /* 2214594 */     GIR_EraseRootFromParent_Done,
     /* 2214595 */   // Label 29339: @2214595
     /* 2214595 */   GIM_Reject,
     /* 2214596 */ // Label 29337: @2214596
     /* 2214596 */ GIM_Reject,
     /* 2214597 */ // Label 29298: @2214597
     /* 2214597 */ GIM_Try, /*On fail goto*//*Label 29340*/ GIMT_Encode4(2214711),
     /* 2214602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2214605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2214608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214616 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214620 */   GIM_Try, /*On fail goto*//*Label 29341*/ GIMT_Encode4(2214665), // Rule ID 48070 //
     /* 2214625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214628 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2214631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2214645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214664 */     // GIR_Coverage, 48070,
     /* 2214664 */     GIR_EraseRootFromParent_Done,
     /* 2214665 */   // Label 29341: @2214665
     /* 2214665 */   GIM_Try, /*On fail goto*//*Label 29342*/ GIMT_Encode4(2214710), // Rule ID 48071 //
     /* 2214670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214673 */     // (srl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2214676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2214690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2214705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214709 */     // GIR_Coverage, 48071,
     /* 2214709 */     GIR_EraseRootFromParent_Done,
     /* 2214710 */   // Label 29342: @2214710
     /* 2214710 */   GIM_Reject,
     /* 2214711 */ // Label 29340: @2214711
     /* 2214711 */ GIM_Reject,
     /* 2214712 */ // Label 29299: @2214712
     /* 2214712 */ GIM_Try, /*On fail goto*//*Label 29343*/ GIMT_Encode4(2214826),
     /* 2214717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2214720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2214723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214735 */   GIM_Try, /*On fail goto*//*Label 29344*/ GIMT_Encode4(2214780), // Rule ID 48086 //
     /* 2214740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214743 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2214746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2214760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214779 */     // GIR_Coverage, 48086,
     /* 2214779 */     GIR_EraseRootFromParent_Done,
     /* 2214780 */   // Label 29344: @2214780
     /* 2214780 */   GIM_Try, /*On fail goto*//*Label 29345*/ GIMT_Encode4(2214825), // Rule ID 48087 //
     /* 2214785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2214788 */     // (srl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2214791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2214805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2214820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214824 */     // GIR_Coverage, 48087,
     /* 2214824 */     GIR_EraseRootFromParent_Done,
     /* 2214825 */   // Label 29345: @2214825
     /* 2214825 */   GIM_Reject,
     /* 2214826 */ // Label 29343: @2214826
     /* 2214826 */ GIM_Reject,
     /* 2214827 */ // Label 29300: @2214827
     /* 2214827 */ GIM_Try, /*On fail goto*//*Label 29346*/ GIMT_Encode4(2214941),
     /* 2214832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2214835 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2214838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214846 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2214850 */   GIM_Try, /*On fail goto*//*Label 29347*/ GIMT_Encode4(2214895), // Rule ID 48130 //
     /* 2214855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2214858 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2214861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2214875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214894 */     // GIR_Coverage, 48130,
     /* 2214894 */     GIR_EraseRootFromParent_Done,
     /* 2214895 */   // Label 29347: @2214895
     /* 2214895 */   GIM_Try, /*On fail goto*//*Label 29348*/ GIMT_Encode4(2214940), // Rule ID 48131 //
     /* 2214900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2214903 */     // (srl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2214903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2214906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2214920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214927 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2214932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2214935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2214938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2214939 */     // GIR_Coverage, 48131,
     /* 2214939 */     GIR_EraseRootFromParent_Done,
     /* 2214940 */   // Label 29348: @2214940
     /* 2214940 */   GIM_Reject,
     /* 2214941 */ // Label 29346: @2214941
     /* 2214941 */ GIM_Reject,
     /* 2214942 */ // Label 29301: @2214942
     /* 2214942 */ GIM_Try, /*On fail goto*//*Label 29349*/ GIMT_Encode4(2215056),
     /* 2214947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2214950 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2214953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2214965 */   GIM_Try, /*On fail goto*//*Label 29350*/ GIMT_Encode4(2215010), // Rule ID 48062 //
     /* 2214970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2214973 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2214973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2214976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2214980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2214985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2214987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2214990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2214992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2214995 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2214997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2214999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215009 */     // GIR_Coverage, 48062,
     /* 2215009 */     GIR_EraseRootFromParent_Done,
     /* 2215010 */   // Label 29350: @2215010
     /* 2215010 */   GIM_Try, /*On fail goto*//*Label 29351*/ GIMT_Encode4(2215055), // Rule ID 48063 //
     /* 2215015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215018 */     // (srl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2215021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_MF2),
     /* 2215035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215054 */     // GIR_Coverage, 48063,
     /* 2215054 */     GIR_EraseRootFromParent_Done,
     /* 2215055 */   // Label 29351: @2215055
     /* 2215055 */   GIM_Reject,
     /* 2215056 */ // Label 29349: @2215056
     /* 2215056 */ GIM_Reject,
     /* 2215057 */ // Label 29302: @2215057
     /* 2215057 */ GIM_Try, /*On fail goto*//*Label 29352*/ GIMT_Encode4(2215171),
     /* 2215062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2215065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2215068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215076 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215080 */   GIM_Try, /*On fail goto*//*Label 29353*/ GIMT_Encode4(2215125), // Rule ID 48082 //
     /* 2215085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215088 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2215091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2215105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215124 */     // GIR_Coverage, 48082,
     /* 2215124 */     GIR_EraseRootFromParent_Done,
     /* 2215125 */   // Label 29353: @2215125
     /* 2215125 */   GIM_Try, /*On fail goto*//*Label 29354*/ GIMT_Encode4(2215170), // Rule ID 48083 //
     /* 2215130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215133 */     // (srl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215133 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2215136 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215140 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2215150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215152 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215168 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215169 */     // GIR_Coverage, 48083,
     /* 2215169 */     GIR_EraseRootFromParent_Done,
     /* 2215170 */   // Label 29354: @2215170
     /* 2215170 */   GIM_Reject,
     /* 2215171 */ // Label 29352: @2215171
     /* 2215171 */ GIM_Reject,
     /* 2215172 */ // Label 29303: @2215172
     /* 2215172 */ GIM_Try, /*On fail goto*//*Label 29355*/ GIMT_Encode4(2215286),
     /* 2215177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2215180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2215183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215195 */   GIM_Try, /*On fail goto*//*Label 29356*/ GIMT_Encode4(2215240), // Rule ID 48118 //
     /* 2215200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215203 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2215206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215239 */     // GIR_Coverage, 48118,
     /* 2215239 */     GIR_EraseRootFromParent_Done,
     /* 2215240 */   // Label 29356: @2215240
     /* 2215240 */   GIM_Try, /*On fail goto*//*Label 29357*/ GIMT_Encode4(2215285), // Rule ID 48119 //
     /* 2215245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215248 */     // (srl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2215251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215284 */     // GIR_Coverage, 48119,
     /* 2215284 */     GIR_EraseRootFromParent_Done,
     /* 2215285 */   // Label 29357: @2215285
     /* 2215285 */   GIM_Reject,
     /* 2215286 */ // Label 29355: @2215286
     /* 2215286 */ GIM_Reject,
     /* 2215287 */ // Label 29304: @2215287
     /* 2215287 */ GIM_Try, /*On fail goto*//*Label 29358*/ GIMT_Encode4(2215401),
     /* 2215292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2215295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2215298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215310 */   GIM_Try, /*On fail goto*//*Label 29359*/ GIMT_Encode4(2215355), // Rule ID 48134 //
     /* 2215315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2215318 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2215321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2215335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215353 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215354 */     // GIR_Coverage, 48134,
     /* 2215354 */     GIR_EraseRootFromParent_Done,
     /* 2215355 */   // Label 29359: @2215355
     /* 2215355 */   GIM_Try, /*On fail goto*//*Label 29360*/ GIMT_Encode4(2215400), // Rule ID 48135 //
     /* 2215360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2215363 */     // (srl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2215366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2215380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215399 */     // GIR_Coverage, 48135,
     /* 2215399 */     GIR_EraseRootFromParent_Done,
     /* 2215400 */   // Label 29360: @2215400
     /* 2215400 */   GIM_Reject,
     /* 2215401 */ // Label 29358: @2215401
     /* 2215401 */ GIM_Reject,
     /* 2215402 */ // Label 29305: @2215402
     /* 2215402 */ GIM_Try, /*On fail goto*//*Label 29361*/ GIMT_Encode4(2215516),
     /* 2215407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2215410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2215413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2215425 */   GIM_Try, /*On fail goto*//*Label 29362*/ GIMT_Encode4(2215470), // Rule ID 48078 //
     /* 2215430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215433 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2215436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215445 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2215450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215455 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215457 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215469 */     // GIR_Coverage, 48078,
     /* 2215469 */     GIR_EraseRootFromParent_Done,
     /* 2215470 */   // Label 29362: @2215470
     /* 2215470 */   GIM_Try, /*On fail goto*//*Label 29363*/ GIMT_Encode4(2215515), // Rule ID 48079 //
     /* 2215475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215478 */     // (srl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2215481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M1),
     /* 2215495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215502 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215514 */     // GIR_Coverage, 48079,
     /* 2215514 */     GIR_EraseRootFromParent_Done,
     /* 2215515 */   // Label 29363: @2215515
     /* 2215515 */   GIM_Reject,
     /* 2215516 */ // Label 29361: @2215516
     /* 2215516 */ GIM_Reject,
     /* 2215517 */ // Label 29306: @2215517
     /* 2215517 */ GIM_Try, /*On fail goto*//*Label 29364*/ GIMT_Encode4(2215631),
     /* 2215522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2215525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2215528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215540 */   GIM_Try, /*On fail goto*//*Label 29365*/ GIMT_Encode4(2215585), // Rule ID 48106 //
     /* 2215545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215548 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2215551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215584 */     // GIR_Coverage, 48106,
     /* 2215584 */     GIR_EraseRootFromParent_Done,
     /* 2215585 */   // Label 29365: @2215585
     /* 2215585 */   GIM_Try, /*On fail goto*//*Label 29366*/ GIMT_Encode4(2215630), // Rule ID 48107 //
     /* 2215590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215593 */     // (srl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2215596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215615 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215617 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2215625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215628 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215629 */     // GIR_Coverage, 48107,
     /* 2215629 */     GIR_EraseRootFromParent_Done,
     /* 2215630 */   // Label 29366: @2215630
     /* 2215630 */   GIM_Reject,
     /* 2215631 */ // Label 29364: @2215631
     /* 2215631 */ GIM_Reject,
     /* 2215632 */ // Label 29307: @2215632
     /* 2215632 */ GIM_Try, /*On fail goto*//*Label 29367*/ GIMT_Encode4(2215746),
     /* 2215637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2215640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2215643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215655 */   GIM_Try, /*On fail goto*//*Label 29368*/ GIMT_Encode4(2215700), // Rule ID 48122 //
     /* 2215660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215663 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2215680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215699 */     // GIR_Coverage, 48122,
     /* 2215699 */     GIR_EraseRootFromParent_Done,
     /* 2215700 */   // Label 29368: @2215700
     /* 2215700 */   GIM_Try, /*On fail goto*//*Label 29369*/ GIMT_Encode4(2215745), // Rule ID 48123 //
     /* 2215705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215708 */     // (srl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2215711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2215725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2215740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215744 */     // GIR_Coverage, 48123,
     /* 2215744 */     GIR_EraseRootFromParent_Done,
     /* 2215745 */   // Label 29369: @2215745
     /* 2215745 */   GIM_Reject,
     /* 2215746 */ // Label 29367: @2215746
     /* 2215746 */ GIM_Reject,
     /* 2215747 */ // Label 29308: @2215747
     /* 2215747 */ GIM_Try, /*On fail goto*//*Label 29370*/ GIMT_Encode4(2215861),
     /* 2215752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2215755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2215758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2215770 */   GIM_Try, /*On fail goto*//*Label 29371*/ GIMT_Encode4(2215815), // Rule ID 48138 //
     /* 2215775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2215778 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2215795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215814 */     // GIR_Coverage, 48138,
     /* 2215814 */     GIR_EraseRootFromParent_Done,
     /* 2215815 */   // Label 29371: @2215815
     /* 2215815 */   GIM_Try, /*On fail goto*//*Label 29372*/ GIMT_Encode4(2215860), // Rule ID 48139 //
     /* 2215820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2215823 */     // (srl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2215826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215835 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2215840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215845 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215847 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2215855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215859 */     // GIR_Coverage, 48139,
     /* 2215859 */     GIR_EraseRootFromParent_Done,
     /* 2215860 */   // Label 29372: @2215860
     /* 2215860 */   GIM_Reject,
     /* 2215861 */ // Label 29370: @2215861
     /* 2215861 */ GIM_Reject,
     /* 2215862 */ // Label 29309: @2215862
     /* 2215862 */ GIM_Try, /*On fail goto*//*Label 29373*/ GIMT_Encode4(2215976),
     /* 2215867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2215870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2215873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2215885 */   GIM_Try, /*On fail goto*//*Label 29374*/ GIMT_Encode4(2215930), // Rule ID 48094 //
     /* 2215890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2215893 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2215893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2215896 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215900 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215929 */     // GIR_Coverage, 48094,
     /* 2215929 */     GIR_EraseRootFromParent_Done,
     /* 2215930 */   // Label 29374: @2215930
     /* 2215930 */   GIM_Try, /*On fail goto*//*Label 29375*/ GIMT_Encode4(2215975), // Rule ID 48095 //
     /* 2215935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2215938 */     // (srl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2215938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2215941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2215945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2215950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2215952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M2),
     /* 2215955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2215957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2215960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2215962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2215964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2215967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2215973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2215974 */     // GIR_Coverage, 48095,
     /* 2215974 */     GIR_EraseRootFromParent_Done,
     /* 2215975 */   // Label 29375: @2215975
     /* 2215975 */   GIM_Reject,
     /* 2215976 */ // Label 29373: @2215976
     /* 2215976 */ GIM_Reject,
     /* 2215977 */ // Label 29310: @2215977
     /* 2215977 */ GIM_Try, /*On fail goto*//*Label 29376*/ GIMT_Encode4(2216091),
     /* 2215982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2215985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2215988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2215996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216000 */   GIM_Try, /*On fail goto*//*Label 29377*/ GIMT_Encode4(2216045), // Rule ID 48110 //
     /* 2216005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216008 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2216025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216044 */     // GIR_Coverage, 48110,
     /* 2216044 */     GIR_EraseRootFromParent_Done,
     /* 2216045 */   // Label 29377: @2216045
     /* 2216045 */   GIM_Try, /*On fail goto*//*Label 29378*/ GIMT_Encode4(2216090), // Rule ID 48111 //
     /* 2216050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216053 */     // (srl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2216056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2216070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216075 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216088 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216089 */     // GIR_Coverage, 48111,
     /* 2216089 */     GIR_EraseRootFromParent_Done,
     /* 2216090 */   // Label 29378: @2216090
     /* 2216090 */   GIM_Reject,
     /* 2216091 */ // Label 29376: @2216091
     /* 2216091 */ GIM_Reject,
     /* 2216092 */ // Label 29311: @2216092
     /* 2216092 */ GIM_Try, /*On fail goto*//*Label 29379*/ GIMT_Encode4(2216206),
     /* 2216097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2216100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2216103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216115 */   GIM_Try, /*On fail goto*//*Label 29380*/ GIMT_Encode4(2216160), // Rule ID 48126 //
     /* 2216120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216123 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216159 */     // GIR_Coverage, 48126,
     /* 2216159 */     GIR_EraseRootFromParent_Done,
     /* 2216160 */   // Label 29380: @2216160
     /* 2216160 */   GIM_Try, /*On fail goto*//*Label 29381*/ GIMT_Encode4(2216205), // Rule ID 48127 //
     /* 2216165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216168 */     // (srl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2216171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2216200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216204 */     // GIR_Coverage, 48127,
     /* 2216204 */     GIR_EraseRootFromParent_Done,
     /* 2216205 */   // Label 29381: @2216205
     /* 2216205 */   GIM_Reject,
     /* 2216206 */ // Label 29379: @2216206
     /* 2216206 */ GIM_Reject,
     /* 2216207 */ // Label 29312: @2216207
     /* 2216207 */ GIM_Try, /*On fail goto*//*Label 29382*/ GIMT_Encode4(2216321),
     /* 2216212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2216215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2216218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2216230 */   GIM_Try, /*On fail goto*//*Label 29383*/ GIMT_Encode4(2216275), // Rule ID 48098 //
     /* 2216235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216238 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2216241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2216255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216274 */     // GIR_Coverage, 48098,
     /* 2216274 */     GIR_EraseRootFromParent_Done,
     /* 2216275 */   // Label 29383: @2216275
     /* 2216275 */   GIM_Try, /*On fail goto*//*Label 29384*/ GIMT_Encode4(2216320), // Rule ID 48099 //
     /* 2216280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216283 */     // (srl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2216286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216295 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M4),
     /* 2216300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216302 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216305 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216319 */     // GIR_Coverage, 48099,
     /* 2216319 */     GIR_EraseRootFromParent_Done,
     /* 2216320 */   // Label 29384: @2216320
     /* 2216320 */   GIM_Reject,
     /* 2216321 */ // Label 29382: @2216321
     /* 2216321 */ GIM_Reject,
     /* 2216322 */ // Label 29313: @2216322
     /* 2216322 */ GIM_Try, /*On fail goto*//*Label 29385*/ GIMT_Encode4(2216436),
     /* 2216327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2216330 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2216333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216341 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216345 */   GIM_Try, /*On fail goto*//*Label 29386*/ GIMT_Encode4(2216390), // Rule ID 48114 //
     /* 2216350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216353 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2216356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216389 */     // GIR_Coverage, 48114,
     /* 2216389 */     GIR_EraseRootFromParent_Done,
     /* 2216390 */   // Label 29386: @2216390
     /* 2216390 */   GIM_Try, /*On fail goto*//*Label 29387*/ GIMT_Encode4(2216435), // Rule ID 48115 //
     /* 2216395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216398 */     // (srl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2216401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2216430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216434 */     // GIR_Coverage, 48115,
     /* 2216434 */     GIR_EraseRootFromParent_Done,
     /* 2216435 */   // Label 29387: @2216435
     /* 2216435 */   GIM_Reject,
     /* 2216436 */ // Label 29385: @2216436
     /* 2216436 */ GIM_Reject,
     /* 2216437 */ // Label 29314: @2216437
     /* 2216437 */ GIM_Try, /*On fail goto*//*Label 29388*/ GIMT_Encode4(2216551),
     /* 2216442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2216445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2216448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2216460 */   GIM_Try, /*On fail goto*//*Label 29389*/ GIMT_Encode4(2216505), // Rule ID 48102 //
     /* 2216465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216468 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2216471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216504 */     // GIR_Coverage, 48102,
     /* 2216504 */     GIR_EraseRootFromParent_Done,
     /* 2216505 */   // Label 29389: @2216505
     /* 2216505 */   GIM_Try, /*On fail goto*//*Label 29390*/ GIMT_Encode4(2216550), // Rule ID 48103 //
     /* 2216510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2216513 */     // (srl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2216513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2216516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2216525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2216527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRL_VV_M8),
     /* 2216530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216532 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2216535 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216537 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2216539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2216542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2216548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216549 */     // GIR_Coverage, 48103,
     /* 2216549 */     GIR_EraseRootFromParent_Done,
     /* 2216550 */   // Label 29390: @2216550
     /* 2216550 */   GIM_Reject,
     /* 2216551 */ // Label 29388: @2216551
     /* 2216551 */ GIM_Reject,
     /* 2216552 */ // Label 29315: @2216552
     /* 2216552 */ GIM_Reject,
     /* 2216553 */ // Label 45: @2216553
     /* 2216553 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29415*/ GIMT_Encode4(2219491),
     /* 2216564 */ /*GILLT_s32*//*Label 29391*/ GIMT_Encode4(2216688),
     /* 2216568 */ /*GILLT_s64*//*Label 29392*/ GIMT_Encode4(2216772), GIMT_Encode4(0),
     /* 2216576 */ /*GILLT_nxv1s8*//*Label 29393*/ GIMT_Encode4(2216961),
     /* 2216580 */ /*GILLT_nxv1s16*//*Label 29394*/ GIMT_Encode4(2217076),
     /* 2216584 */ /*GILLT_nxv1s32*//*Label 29395*/ GIMT_Encode4(2217191),
     /* 2216588 */ /*GILLT_nxv1s64*//*Label 29396*/ GIMT_Encode4(2217306), GIMT_Encode4(0),
     /* 2216596 */ /*GILLT_nxv2s8*//*Label 29397*/ GIMT_Encode4(2217421),
     /* 2216600 */ /*GILLT_nxv2s16*//*Label 29398*/ GIMT_Encode4(2217536),
     /* 2216604 */ /*GILLT_nxv2s32*//*Label 29399*/ GIMT_Encode4(2217651),
     /* 2216608 */ /*GILLT_nxv2s64*//*Label 29400*/ GIMT_Encode4(2217766), GIMT_Encode4(0),
     /* 2216616 */ /*GILLT_nxv4s8*//*Label 29401*/ GIMT_Encode4(2217881),
     /* 2216620 */ /*GILLT_nxv4s16*//*Label 29402*/ GIMT_Encode4(2217996),
     /* 2216624 */ /*GILLT_nxv4s32*//*Label 29403*/ GIMT_Encode4(2218111),
     /* 2216628 */ /*GILLT_nxv4s64*//*Label 29404*/ GIMT_Encode4(2218226), GIMT_Encode4(0),
     /* 2216636 */ /*GILLT_nxv8s8*//*Label 29405*/ GIMT_Encode4(2218341),
     /* 2216640 */ /*GILLT_nxv8s16*//*Label 29406*/ GIMT_Encode4(2218456),
     /* 2216644 */ /*GILLT_nxv8s32*//*Label 29407*/ GIMT_Encode4(2218571),
     /* 2216648 */ /*GILLT_nxv8s64*//*Label 29408*/ GIMT_Encode4(2218686), GIMT_Encode4(0),
     /* 2216656 */ /*GILLT_nxv16s8*//*Label 29409*/ GIMT_Encode4(2218801),
     /* 2216660 */ /*GILLT_nxv16s16*//*Label 29410*/ GIMT_Encode4(2218916),
     /* 2216664 */ /*GILLT_nxv16s32*//*Label 29411*/ GIMT_Encode4(2219031), GIMT_Encode4(0),
     /* 2216672 */ /*GILLT_nxv32s8*//*Label 29412*/ GIMT_Encode4(2219146),
     /* 2216676 */ /*GILLT_nxv32s16*//*Label 29413*/ GIMT_Encode4(2219261), GIMT_Encode4(0),
     /* 2216684 */ /*GILLT_nxv64s8*//*Label 29414*/ GIMT_Encode4(2219376),
     /* 2216688 */ // Label 29391: @2216688
     /* 2216688 */ GIM_Try, /*On fail goto*//*Label 29416*/ GIMT_Encode4(2216771),
     /* 2216693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2216696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2216699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216707 */   GIM_Try, /*On fail goto*//*Label 29417*/ GIMT_Encode4(2216741), // Rule ID 95 //
     /* 2216712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2216715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2216719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2216723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2216727 */     // MIs[1] Operand 1
     /* 2216727 */     // No operand predicates
     /* 2216727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2216729 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2216729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2216732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2216739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216740 */     // GIR_Coverage, 95,
     /* 2216740 */     GIR_EraseRootFromParent_Done,
     /* 2216741 */   // Label 29417: @2216741
     /* 2216741 */   GIM_Try, /*On fail goto*//*Label 29418*/ GIMT_Encode4(2216770), // Rule ID 109 //
     /* 2216746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2216749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2216756 */     // (sra:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (SRA:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2216756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2216759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2216768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216769 */     // GIR_Coverage, 109,
     /* 2216769 */     GIR_EraseRootFromParent_Done,
     /* 2216770 */   // Label 29418: @2216770
     /* 2216770 */   GIM_Reject,
     /* 2216771 */ // Label 29416: @2216771
     /* 2216771 */ GIM_Reject,
     /* 2216772 */ // Label 29392: @2216772
     /* 2216772 */ GIM_Try, /*On fail goto*//*Label 29419*/ GIMT_Encode4(2216960),
     /* 2216777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2216783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216787 */   GIM_Try, /*On fail goto*//*Label 29420*/ GIMT_Encode4(2216824), // Rule ID 62542 //
     /* 2216792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2216795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2216803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2216811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2216813 */     // (sra:{ *:[i64] } (bswap:{ *:[i64] } i64:{ *:[i64] }:$rs1), 32:{ *:[i64] })  =>  (TH_REVW:{ *:[i64] } i64:{ *:[i64] }:$rs1)
     /* 2216813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_REVW),
     /* 2216816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2216822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216823 */     // GIR_Coverage, 62542,
     /* 2216823 */     GIR_EraseRootFromParent_Done,
     /* 2216824 */   // Label 29420: @2216824
     /* 2216824 */   GIM_Try, /*On fail goto*//*Label 29421*/ GIMT_Encode4(2216888), // Rule ID 259 //
     /* 2216829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2216832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2216836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 2216840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2216844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216849 */     // MIs[1] Operand 2
     /* 2216849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 2216860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 2216864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2216868 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2216872 */     // MIs[2] Operand 1
     /* 2216872 */     // No operand predicates
     /* 2216872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2216874 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$rs1, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)  =>  (SRAIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$shamt)
     /* 2216874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAIW),
     /* 2216877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2216883 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shamt
     /* 2216886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216887 */     // GIR_Coverage, 259,
     /* 2216887 */     GIR_EraseRootFromParent_Done,
     /* 2216888 */   // Label 29421: @2216888
     /* 2216888 */   GIM_Try, /*On fail goto*//*Label 29422*/ GIMT_Encode4(2216926), // Rule ID 94 //
     /* 2216893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2216896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2216904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2216908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2216912 */     // MIs[1] Operand 1
     /* 2216912 */     // No operand predicates
     /* 2216912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2216914 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (SRAI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2216914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAI),
     /* 2216917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2216924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216925 */     // GIR_Coverage, 94,
     /* 2216925 */     GIR_EraseRootFromParent_Done,
     /* 2216926 */   // Label 29422: @2216926
     /* 2216926 */   GIM_Try, /*On fail goto*//*Label 29423*/ GIMT_Encode4(2216959), // Rule ID 108 //
     /* 2216931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2216934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2216938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2216945 */     // (sra:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRA:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2216945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRA),
     /* 2216948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2216950 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2216952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2216957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2216958 */     // GIR_Coverage, 108,
     /* 2216958 */     GIR_EraseRootFromParent_Done,
     /* 2216959 */   // Label 29423: @2216959
     /* 2216959 */   GIM_Reject,
     /* 2216960 */ // Label 29419: @2216960
     /* 2216960 */ GIM_Reject,
     /* 2216961 */ // Label 29393: @2216961
     /* 2216961 */ GIM_Try, /*On fail goto*//*Label 29424*/ GIMT_Encode4(2217075),
     /* 2216966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2216969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2216972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2216984 */   GIM_Try, /*On fail goto*//*Label 29425*/ GIMT_Encode4(2217029), // Rule ID 48186 //
     /* 2216989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2216992 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2216992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2216995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2216999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2217009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217028 */     // GIR_Coverage, 48186,
     /* 2217028 */     GIR_EraseRootFromParent_Done,
     /* 2217029 */   // Label 29425: @2217029
     /* 2217029 */   GIM_Try, /*On fail goto*//*Label 29426*/ GIMT_Encode4(2217074), // Rule ID 48187 //
     /* 2217034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217037 */     // (sra:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSRA_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2217040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF8),
     /* 2217054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217073 */     // GIR_Coverage, 48187,
     /* 2217073 */     GIR_EraseRootFromParent_Done,
     /* 2217074 */   // Label 29426: @2217074
     /* 2217074 */   GIM_Reject,
     /* 2217075 */ // Label 29424: @2217075
     /* 2217075 */ GIM_Reject,
     /* 2217076 */ // Label 29394: @2217076
     /* 2217076 */ GIM_Try, /*On fail goto*//*Label 29427*/ GIMT_Encode4(2217190),
     /* 2217081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2217084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2217087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217099 */   GIM_Try, /*On fail goto*//*Label 29428*/ GIMT_Encode4(2217144), // Rule ID 48198 //
     /* 2217104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217107 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2217124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217143 */     // GIR_Coverage, 48198,
     /* 2217143 */     GIR_EraseRootFromParent_Done,
     /* 2217144 */   // Label 29428: @2217144
     /* 2217144 */   GIM_Try, /*On fail goto*//*Label 29429*/ GIMT_Encode4(2217189), // Rule ID 48199 //
     /* 2217149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217152 */     // (sra:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2217155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2217169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217188 */     // GIR_Coverage, 48199,
     /* 2217188 */     GIR_EraseRootFromParent_Done,
     /* 2217189 */   // Label 29429: @2217189
     /* 2217189 */   GIM_Reject,
     /* 2217190 */ // Label 29427: @2217190
     /* 2217190 */ GIM_Reject,
     /* 2217191 */ // Label 29395: @2217191
     /* 2217191 */ GIM_Try, /*On fail goto*//*Label 29430*/ GIMT_Encode4(2217305),
     /* 2217196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2217199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2217202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217214 */   GIM_Try, /*On fail goto*//*Label 29431*/ GIMT_Encode4(2217259), // Rule ID 48206 //
     /* 2217219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217222 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217258 */     // GIR_Coverage, 48206,
     /* 2217258 */     GIR_EraseRootFromParent_Done,
     /* 2217259 */   // Label 29431: @2217259
     /* 2217259 */   GIM_Try, /*On fail goto*//*Label 29432*/ GIMT_Encode4(2217304), // Rule ID 48207 //
     /* 2217264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217267 */     // (sra:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2217270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217303 */     // GIR_Coverage, 48207,
     /* 2217303 */     GIR_EraseRootFromParent_Done,
     /* 2217304 */   // Label 29432: @2217304
     /* 2217304 */   GIM_Reject,
     /* 2217305 */ // Label 29430: @2217305
     /* 2217305 */ GIM_Reject,
     /* 2217306 */ // Label 29396: @2217306
     /* 2217306 */ GIM_Try, /*On fail goto*//*Label 29433*/ GIMT_Encode4(2217420),
     /* 2217311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2217314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2217317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217329 */   GIM_Try, /*On fail goto*//*Label 29434*/ GIMT_Encode4(2217374), // Rule ID 48222 //
     /* 2217334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2217337 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2217354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217373 */     // GIR_Coverage, 48222,
     /* 2217373 */     GIR_EraseRootFromParent_Done,
     /* 2217374 */   // Label 29434: @2217374
     /* 2217374 */   GIM_Try, /*On fail goto*//*Label 29435*/ GIMT_Encode4(2217419), // Rule ID 48223 //
     /* 2217379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2217382 */     // (sra:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2217385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2217399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217418 */     // GIR_Coverage, 48223,
     /* 2217418 */     GIR_EraseRootFromParent_Done,
     /* 2217419 */   // Label 29435: @2217419
     /* 2217419 */   GIM_Reject,
     /* 2217420 */ // Label 29433: @2217420
     /* 2217420 */ GIM_Reject,
     /* 2217421 */ // Label 29397: @2217421
     /* 2217421 */ GIM_Try, /*On fail goto*//*Label 29436*/ GIMT_Encode4(2217535),
     /* 2217426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2217429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2217432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217444 */   GIM_Try, /*On fail goto*//*Label 29437*/ GIMT_Encode4(2217489), // Rule ID 48190 //
     /* 2217449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217452 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2217455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2217469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217488 */     // GIR_Coverage, 48190,
     /* 2217488 */     GIR_EraseRootFromParent_Done,
     /* 2217489 */   // Label 29437: @2217489
     /* 2217489 */   GIM_Try, /*On fail goto*//*Label 29438*/ GIMT_Encode4(2217534), // Rule ID 48191 //
     /* 2217494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217497 */     // (sra:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSRA_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2217500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF4),
     /* 2217514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217533 */     // GIR_Coverage, 48191,
     /* 2217533 */     GIR_EraseRootFromParent_Done,
     /* 2217534 */   // Label 29438: @2217534
     /* 2217534 */   GIM_Reject,
     /* 2217535 */ // Label 29436: @2217535
     /* 2217535 */ GIM_Reject,
     /* 2217536 */ // Label 29398: @2217536
     /* 2217536 */ GIM_Try, /*On fail goto*//*Label 29439*/ GIMT_Encode4(2217650),
     /* 2217541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2217544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2217547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217559 */   GIM_Try, /*On fail goto*//*Label 29440*/ GIMT_Encode4(2217604), // Rule ID 48202 //
     /* 2217564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217567 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217603 */     // GIR_Coverage, 48202,
     /* 2217603 */     GIR_EraseRootFromParent_Done,
     /* 2217604 */   // Label 29440: @2217604
     /* 2217604 */   GIM_Try, /*On fail goto*//*Label 29441*/ GIMT_Encode4(2217649), // Rule ID 48203 //
     /* 2217609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217612 */     // (sra:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2217615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2217644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217648 */     // GIR_Coverage, 48203,
     /* 2217648 */     GIR_EraseRootFromParent_Done,
     /* 2217649 */   // Label 29441: @2217649
     /* 2217649 */   GIM_Reject,
     /* 2217650 */ // Label 29439: @2217650
     /* 2217650 */ GIM_Reject,
     /* 2217651 */ // Label 29399: @2217651
     /* 2217651 */ GIM_Try, /*On fail goto*//*Label 29442*/ GIMT_Encode4(2217765),
     /* 2217656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2217659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2217662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217674 */   GIM_Try, /*On fail goto*//*Label 29443*/ GIMT_Encode4(2217719), // Rule ID 48218 //
     /* 2217679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217682 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2217699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217718 */     // GIR_Coverage, 48218,
     /* 2217718 */     GIR_EraseRootFromParent_Done,
     /* 2217719 */   // Label 29443: @2217719
     /* 2217719 */   GIM_Try, /*On fail goto*//*Label 29444*/ GIMT_Encode4(2217764), // Rule ID 48219 //
     /* 2217724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217727 */     // (sra:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2217730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2217744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2217759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217763 */     // GIR_Coverage, 48219,
     /* 2217763 */     GIR_EraseRootFromParent_Done,
     /* 2217764 */   // Label 29444: @2217764
     /* 2217764 */   GIM_Reject,
     /* 2217765 */ // Label 29442: @2217765
     /* 2217765 */ GIM_Reject,
     /* 2217766 */ // Label 29400: @2217766
     /* 2217766 */ GIM_Try, /*On fail goto*//*Label 29445*/ GIMT_Encode4(2217880),
     /* 2217771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2217774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2217777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2217789 */   GIM_Try, /*On fail goto*//*Label 29446*/ GIMT_Encode4(2217834), // Rule ID 48262 //
     /* 2217794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2217797 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2217814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217833 */     // GIR_Coverage, 48262,
     /* 2217833 */     GIR_EraseRootFromParent_Done,
     /* 2217834 */   // Label 29446: @2217834
     /* 2217834 */   GIM_Try, /*On fail goto*//*Label 29447*/ GIMT_Encode4(2217879), // Rule ID 48263 //
     /* 2217839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2217842 */     // (sra:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2217845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2217859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2217874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217878 */     // GIR_Coverage, 48263,
     /* 2217878 */     GIR_EraseRootFromParent_Done,
     /* 2217879 */   // Label 29447: @2217879
     /* 2217879 */   GIM_Reject,
     /* 2217880 */ // Label 29445: @2217880
     /* 2217880 */ GIM_Reject,
     /* 2217881 */ // Label 29401: @2217881
     /* 2217881 */ GIM_Try, /*On fail goto*//*Label 29448*/ GIMT_Encode4(2217995),
     /* 2217886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2217889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2217892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2217904 */   GIM_Try, /*On fail goto*//*Label 29449*/ GIMT_Encode4(2217949), // Rule ID 48194 //
     /* 2217909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2217912 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2217912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2217915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217948 */     // GIR_Coverage, 48194,
     /* 2217948 */     GIR_EraseRootFromParent_Done,
     /* 2217949 */   // Label 29449: @2217949
     /* 2217949 */   GIM_Try, /*On fail goto*//*Label 29450*/ GIMT_Encode4(2217994), // Rule ID 48195 //
     /* 2217954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2217957 */     // (sra:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSRA_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2217957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2217960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2217964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2217969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2217971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_MF2),
     /* 2217974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2217976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2217979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2217981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2217983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2217986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2217992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2217993 */     // GIR_Coverage, 48195,
     /* 2217993 */     GIR_EraseRootFromParent_Done,
     /* 2217994 */   // Label 29450: @2217994
     /* 2217994 */   GIM_Reject,
     /* 2217995 */ // Label 29448: @2217995
     /* 2217995 */ GIM_Reject,
     /* 2217996 */ // Label 29402: @2217996
     /* 2217996 */ GIM_Try, /*On fail goto*//*Label 29451*/ GIMT_Encode4(2218110),
     /* 2218001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2218004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2218007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218019 */   GIM_Try, /*On fail goto*//*Label 29452*/ GIMT_Encode4(2218064), // Rule ID 48214 //
     /* 2218024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218027 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2218030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2218044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218063 */     // GIR_Coverage, 48214,
     /* 2218063 */     GIR_EraseRootFromParent_Done,
     /* 2218064 */   // Label 29452: @2218064
     /* 2218064 */   GIM_Try, /*On fail goto*//*Label 29453*/ GIMT_Encode4(2218109), // Rule ID 48215 //
     /* 2218069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218072 */     // (sra:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2218075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2218089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218108 */     // GIR_Coverage, 48215,
     /* 2218108 */     GIR_EraseRootFromParent_Done,
     /* 2218109 */   // Label 29453: @2218109
     /* 2218109 */   GIM_Reject,
     /* 2218110 */ // Label 29451: @2218110
     /* 2218110 */ GIM_Reject,
     /* 2218111 */ // Label 29403: @2218111
     /* 2218111 */ GIM_Try, /*On fail goto*//*Label 29454*/ GIMT_Encode4(2218225),
     /* 2218116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2218119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2218122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218134 */   GIM_Try, /*On fail goto*//*Label 29455*/ GIMT_Encode4(2218179), // Rule ID 48250 //
     /* 2218139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218142 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2218145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218178 */     // GIR_Coverage, 48250,
     /* 2218178 */     GIR_EraseRootFromParent_Done,
     /* 2218179 */   // Label 29455: @2218179
     /* 2218179 */   GIM_Try, /*On fail goto*//*Label 29456*/ GIMT_Encode4(2218224), // Rule ID 48251 //
     /* 2218184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218187 */     // (sra:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2218190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218223 */     // GIR_Coverage, 48251,
     /* 2218223 */     GIR_EraseRootFromParent_Done,
     /* 2218224 */   // Label 29456: @2218224
     /* 2218224 */   GIM_Reject,
     /* 2218225 */ // Label 29454: @2218225
     /* 2218225 */ GIM_Reject,
     /* 2218226 */ // Label 29404: @2218226
     /* 2218226 */ GIM_Try, /*On fail goto*//*Label 29457*/ GIMT_Encode4(2218340),
     /* 2218231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2218234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2218237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218249 */   GIM_Try, /*On fail goto*//*Label 29458*/ GIMT_Encode4(2218294), // Rule ID 48266 //
     /* 2218254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2218257 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2218274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218293 */     // GIR_Coverage, 48266,
     /* 2218293 */     GIR_EraseRootFromParent_Done,
     /* 2218294 */   // Label 29458: @2218294
     /* 2218294 */   GIM_Try, /*On fail goto*//*Label 29459*/ GIMT_Encode4(2218339), // Rule ID 48267 //
     /* 2218299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2218302 */     // (sra:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2218305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2218319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218338 */     // GIR_Coverage, 48267,
     /* 2218338 */     GIR_EraseRootFromParent_Done,
     /* 2218339 */   // Label 29459: @2218339
     /* 2218339 */   GIM_Reject,
     /* 2218340 */ // Label 29457: @2218340
     /* 2218340 */ GIM_Reject,
     /* 2218341 */ // Label 29405: @2218341
     /* 2218341 */ GIM_Try, /*On fail goto*//*Label 29460*/ GIMT_Encode4(2218455),
     /* 2218346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2218349 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2218352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218356 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2218364 */   GIM_Try, /*On fail goto*//*Label 29461*/ GIMT_Encode4(2218409), // Rule ID 48210 //
     /* 2218369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218372 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2218375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2218389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218408 */     // GIR_Coverage, 48210,
     /* 2218408 */     GIR_EraseRootFromParent_Done,
     /* 2218409 */   // Label 29461: @2218409
     /* 2218409 */   GIM_Try, /*On fail goto*//*Label 29462*/ GIMT_Encode4(2218454), // Rule ID 48211 //
     /* 2218414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218417 */     // (sra:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSRA_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2218420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M1),
     /* 2218434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218453 */     // GIR_Coverage, 48211,
     /* 2218453 */     GIR_EraseRootFromParent_Done,
     /* 2218454 */   // Label 29462: @2218454
     /* 2218454 */   GIM_Reject,
     /* 2218455 */ // Label 29460: @2218455
     /* 2218455 */ GIM_Reject,
     /* 2218456 */ // Label 29406: @2218456
     /* 2218456 */ GIM_Try, /*On fail goto*//*Label 29463*/ GIMT_Encode4(2218570),
     /* 2218461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2218464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2218467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218479 */   GIM_Try, /*On fail goto*//*Label 29464*/ GIMT_Encode4(2218524), // Rule ID 48238 //
     /* 2218484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218487 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218523 */     // GIR_Coverage, 48238,
     /* 2218523 */     GIR_EraseRootFromParent_Done,
     /* 2218524 */   // Label 29464: @2218524
     /* 2218524 */   GIM_Try, /*On fail goto*//*Label 29465*/ GIMT_Encode4(2218569), // Rule ID 48239 //
     /* 2218529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218532 */     // (sra:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2218535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218568 */     // GIR_Coverage, 48239,
     /* 2218568 */     GIR_EraseRootFromParent_Done,
     /* 2218569 */   // Label 29465: @2218569
     /* 2218569 */   GIM_Reject,
     /* 2218570 */ // Label 29463: @2218570
     /* 2218570 */ GIM_Reject,
     /* 2218571 */ // Label 29407: @2218571
     /* 2218571 */ GIM_Try, /*On fail goto*//*Label 29466*/ GIMT_Encode4(2218685),
     /* 2218576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2218579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2218582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218594 */   GIM_Try, /*On fail goto*//*Label 29467*/ GIMT_Encode4(2218639), // Rule ID 48254 //
     /* 2218599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218602 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2218619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218637 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218638 */     // GIR_Coverage, 48254,
     /* 2218638 */     GIR_EraseRootFromParent_Done,
     /* 2218639 */   // Label 29467: @2218639
     /* 2218639 */   GIM_Try, /*On fail goto*//*Label 29468*/ GIMT_Encode4(2218684), // Rule ID 48255 //
     /* 2218644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218647 */     // (sra:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2218650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2218664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2218679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218683 */     // GIR_Coverage, 48255,
     /* 2218683 */     GIR_EraseRootFromParent_Done,
     /* 2218684 */   // Label 29468: @2218684
     /* 2218684 */   GIM_Reject,
     /* 2218685 */ // Label 29466: @2218685
     /* 2218685 */ GIM_Reject,
     /* 2218686 */ // Label 29408: @2218686
     /* 2218686 */ GIM_Try, /*On fail goto*//*Label 29469*/ GIMT_Encode4(2218800),
     /* 2218691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2218694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2218697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2218709 */   GIM_Try, /*On fail goto*//*Label 29470*/ GIMT_Encode4(2218754), // Rule ID 48270 //
     /* 2218714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2218717 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2218734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218752 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218753 */     // GIR_Coverage, 48270,
     /* 2218753 */     GIR_EraseRootFromParent_Done,
     /* 2218754 */   // Label 29470: @2218754
     /* 2218754 */   GIM_Try, /*On fail goto*//*Label 29471*/ GIMT_Encode4(2218799), // Rule ID 48271 //
     /* 2218759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2218762 */     // (sra:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2218765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2218779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2218794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218798 */     // GIR_Coverage, 48271,
     /* 2218798 */     GIR_EraseRootFromParent_Done,
     /* 2218799 */   // Label 29471: @2218799
     /* 2218799 */   GIM_Reject,
     /* 2218800 */ // Label 29469: @2218800
     /* 2218800 */ GIM_Reject,
     /* 2218801 */ // Label 29409: @2218801
     /* 2218801 */ GIM_Try, /*On fail goto*//*Label 29472*/ GIMT_Encode4(2218915),
     /* 2218806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2218809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2218812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2218824 */   GIM_Try, /*On fail goto*//*Label 29473*/ GIMT_Encode4(2218869), // Rule ID 48226 //
     /* 2218829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218832 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2218835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218856 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218868 */     // GIR_Coverage, 48226,
     /* 2218868 */     GIR_EraseRootFromParent_Done,
     /* 2218869 */   // Label 29473: @2218869
     /* 2218869 */   GIM_Try, /*On fail goto*//*Label 29474*/ GIMT_Encode4(2218914), // Rule ID 48227 //
     /* 2218874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218877 */     // (sra:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSRA_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2218880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M2),
     /* 2218894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218913 */     // GIR_Coverage, 48227,
     /* 2218913 */     GIR_EraseRootFromParent_Done,
     /* 2218914 */   // Label 29474: @2218914
     /* 2218914 */   GIM_Reject,
     /* 2218915 */ // Label 29472: @2218915
     /* 2218915 */ GIM_Reject,
     /* 2218916 */ // Label 29410: @2218916
     /* 2218916 */ GIM_Try, /*On fail goto*//*Label 29475*/ GIMT_Encode4(2219030),
     /* 2218921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2218924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2218927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2218939 */   GIM_Try, /*On fail goto*//*Label 29476*/ GIMT_Encode4(2218984), // Rule ID 48242 //
     /* 2218944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2218947 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2218947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2218959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2218961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2218964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2218966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2218969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2218971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2218973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2218976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2218979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2218982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2218983 */     // GIR_Coverage, 48242,
     /* 2218983 */     GIR_EraseRootFromParent_Done,
     /* 2218984 */   // Label 29476: @2218984
     /* 2218984 */   GIM_Try, /*On fail goto*//*Label 29477*/ GIMT_Encode4(2219029), // Rule ID 48243 //
     /* 2218989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2218992 */     // (sra:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2218992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2218995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2218999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2219009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219028 */     // GIR_Coverage, 48243,
     /* 2219028 */     GIR_EraseRootFromParent_Done,
     /* 2219029 */   // Label 29477: @2219029
     /* 2219029 */   GIM_Reject,
     /* 2219030 */ // Label 29475: @2219030
     /* 2219030 */ GIM_Reject,
     /* 2219031 */ // Label 29411: @2219031
     /* 2219031 */ GIM_Try, /*On fail goto*//*Label 29478*/ GIMT_Encode4(2219145),
     /* 2219036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2219039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2219042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219054 */   GIM_Try, /*On fail goto*//*Label 29479*/ GIMT_Encode4(2219099), // Rule ID 48258 //
     /* 2219059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219062 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219098 */     // GIR_Coverage, 48258,
     /* 2219098 */     GIR_EraseRootFromParent_Done,
     /* 2219099 */   // Label 29479: @2219099
     /* 2219099 */   GIM_Try, /*On fail goto*//*Label 29480*/ GIMT_Encode4(2219144), // Rule ID 48259 //
     /* 2219104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219107 */     // (sra:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2219110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2219139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219143 */     // GIR_Coverage, 48259,
     /* 2219143 */     GIR_EraseRootFromParent_Done,
     /* 2219144 */   // Label 29480: @2219144
     /* 2219144 */   GIM_Reject,
     /* 2219145 */ // Label 29478: @2219145
     /* 2219145 */ GIM_Reject,
     /* 2219146 */ // Label 29412: @2219146
     /* 2219146 */ GIM_Try, /*On fail goto*//*Label 29481*/ GIMT_Encode4(2219260),
     /* 2219151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2219154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2219157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219161 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2219169 */   GIM_Try, /*On fail goto*//*Label 29482*/ GIMT_Encode4(2219214), // Rule ID 48230 //
     /* 2219174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219177 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2219180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2219194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219213 */     // GIR_Coverage, 48230,
     /* 2219213 */     GIR_EraseRootFromParent_Done,
     /* 2219214 */   // Label 29482: @2219214
     /* 2219214 */   GIM_Try, /*On fail goto*//*Label 29483*/ GIMT_Encode4(2219259), // Rule ID 48231 //
     /* 2219219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219222 */     // (sra:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSRA_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2219225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M4),
     /* 2219239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219258 */     // GIR_Coverage, 48231,
     /* 2219258 */     GIR_EraseRootFromParent_Done,
     /* 2219259 */   // Label 29483: @2219259
     /* 2219259 */   GIM_Reject,
     /* 2219260 */ // Label 29481: @2219260
     /* 2219260 */ GIM_Reject,
     /* 2219261 */ // Label 29413: @2219261
     /* 2219261 */ GIM_Try, /*On fail goto*//*Label 29484*/ GIMT_Encode4(2219375),
     /* 2219266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2219269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2219272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219284 */   GIM_Try, /*On fail goto*//*Label 29485*/ GIMT_Encode4(2219329), // Rule ID 48246 //
     /* 2219289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219292 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219314 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219316 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219328 */     // GIR_Coverage, 48246,
     /* 2219328 */     GIR_EraseRootFromParent_Done,
     /* 2219329 */   // Label 29485: @2219329
     /* 2219329 */   GIM_Try, /*On fail goto*//*Label 29486*/ GIMT_Encode4(2219374), // Rule ID 48247 //
     /* 2219334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219337 */     // (sra:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2219340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2219369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219373 */     // GIR_Coverage, 48247,
     /* 2219373 */     GIR_EraseRootFromParent_Done,
     /* 2219374 */   // Label 29486: @2219374
     /* 2219374 */   GIM_Reject,
     /* 2219375 */ // Label 29484: @2219375
     /* 2219375 */ GIM_Reject,
     /* 2219376 */ // Label 29414: @2219376
     /* 2219376 */ GIM_Try, /*On fail goto*//*Label 29487*/ GIMT_Encode4(2219490),
     /* 2219381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2219384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2219387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219395 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2219399 */   GIM_Try, /*On fail goto*//*Label 29488*/ GIMT_Encode4(2219444), // Rule ID 48234 //
     /* 2219404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219407 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2219410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219431 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219443 */     // GIR_Coverage, 48234,
     /* 2219443 */     GIR_EraseRootFromParent_Done,
     /* 2219444 */   // Label 29488: @2219444
     /* 2219444 */   GIM_Try, /*On fail goto*//*Label 29489*/ GIMT_Encode4(2219489), // Rule ID 48235 //
     /* 2219449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219452 */     // (sra:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSRA_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2219455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSRA_VV_M8),
     /* 2219469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219488 */     // GIR_Coverage, 48235,
     /* 2219488 */     GIR_EraseRootFromParent_Done,
     /* 2219489 */   // Label 29489: @2219489
     /* 2219489 */   GIM_Reject,
     /* 2219490 */ // Label 29487: @2219490
     /* 2219490 */ GIM_Reject,
     /* 2219491 */ // Label 29415: @2219491
     /* 2219491 */ GIM_Reject,
     /* 2219492 */ // Label 46: @2219492
     /* 2219492 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29514*/ GIMT_Encode4(2222431),
     /* 2219503 */ /*GILLT_s32*//*Label 29490*/ GIMT_Encode4(2219627),
     /* 2219507 */ /*GILLT_s64*//*Label 29491*/ GIMT_Encode4(2219764), GIMT_Encode4(0),
     /* 2219515 */ /*GILLT_nxv1s8*//*Label 29492*/ GIMT_Encode4(2219901),
     /* 2219519 */ /*GILLT_nxv1s16*//*Label 29493*/ GIMT_Encode4(2220016),
     /* 2219523 */ /*GILLT_nxv1s32*//*Label 29494*/ GIMT_Encode4(2220131),
     /* 2219527 */ /*GILLT_nxv1s64*//*Label 29495*/ GIMT_Encode4(2220246), GIMT_Encode4(0),
     /* 2219535 */ /*GILLT_nxv2s8*//*Label 29496*/ GIMT_Encode4(2220361),
     /* 2219539 */ /*GILLT_nxv2s16*//*Label 29497*/ GIMT_Encode4(2220476),
     /* 2219543 */ /*GILLT_nxv2s32*//*Label 29498*/ GIMT_Encode4(2220591),
     /* 2219547 */ /*GILLT_nxv2s64*//*Label 29499*/ GIMT_Encode4(2220706), GIMT_Encode4(0),
     /* 2219555 */ /*GILLT_nxv4s8*//*Label 29500*/ GIMT_Encode4(2220821),
     /* 2219559 */ /*GILLT_nxv4s16*//*Label 29501*/ GIMT_Encode4(2220936),
     /* 2219563 */ /*GILLT_nxv4s32*//*Label 29502*/ GIMT_Encode4(2221051),
     /* 2219567 */ /*GILLT_nxv4s64*//*Label 29503*/ GIMT_Encode4(2221166), GIMT_Encode4(0),
     /* 2219575 */ /*GILLT_nxv8s8*//*Label 29504*/ GIMT_Encode4(2221281),
     /* 2219579 */ /*GILLT_nxv8s16*//*Label 29505*/ GIMT_Encode4(2221396),
     /* 2219583 */ /*GILLT_nxv8s32*//*Label 29506*/ GIMT_Encode4(2221511),
     /* 2219587 */ /*GILLT_nxv8s64*//*Label 29507*/ GIMT_Encode4(2221626), GIMT_Encode4(0),
     /* 2219595 */ /*GILLT_nxv16s8*//*Label 29508*/ GIMT_Encode4(2221741),
     /* 2219599 */ /*GILLT_nxv16s16*//*Label 29509*/ GIMT_Encode4(2221856),
     /* 2219603 */ /*GILLT_nxv16s32*//*Label 29510*/ GIMT_Encode4(2221971), GIMT_Encode4(0),
     /* 2219611 */ /*GILLT_nxv32s8*//*Label 29511*/ GIMT_Encode4(2222086),
     /* 2219615 */ /*GILLT_nxv32s16*//*Label 29512*/ GIMT_Encode4(2222201), GIMT_Encode4(0),
     /* 2219623 */ /*GILLT_nxv64s8*//*Label 29513*/ GIMT_Encode4(2222316),
     /* 2219627 */ // Label 29490: @2219627
     /* 2219627 */ GIM_Try, /*On fail goto*//*Label 29515*/ GIMT_Encode4(2219763),
     /* 2219632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2219635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2219638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219646 */   GIM_Try, /*On fail goto*//*Label 29516*/ GIMT_Encode4(2219680), // Rule ID 2353 //
     /* 2219651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2219654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219662 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219666 */     // MIs[1] Operand 1
     /* 2219666 */     // No operand predicates
     /* 2219666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219668 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2219671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219675 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219679 */     // GIR_Coverage, 2353,
     /* 2219679 */     GIR_EraseRootFromParent_Done,
     /* 2219680 */   // Label 29516: @2219680
     /* 2219680 */   GIM_Try, /*On fail goto*//*Label 29517*/ GIMT_Encode4(2219714), // Rule ID 62524 //
     /* 2219685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2219688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219700 */     // MIs[1] Operand 1
     /* 2219700 */     // No operand predicates
     /* 2219700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219702 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2219705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219713 */     // GIR_Coverage, 62524,
     /* 2219713 */     GIR_EraseRootFromParent_Done,
     /* 2219714 */   // Label 29517: @2219714
     /* 2219714 */   GIM_Try, /*On fail goto*//*Label 29518*/ GIMT_Encode4(2219743), // Rule ID 2351 //
     /* 2219719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2219722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219729 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2219732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219742 */     // GIR_Coverage, 2351,
     /* 2219742 */     GIR_EraseRootFromParent_Done,
     /* 2219743 */   // Label 29518: @2219743
     /* 2219743 */   GIM_Try, /*On fail goto*//*Label 29519*/ GIMT_Encode4(2219762), // Rule ID 64419 //
     /* 2219748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2219751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219755 */     // (rotr:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_ROR:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2219755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2219760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219761 */     // GIR_Coverage, 64419,
     /* 2219761 */     GIR_Done,
     /* 2219762 */   // Label 29519: @2219762
     /* 2219762 */   GIM_Reject,
     /* 2219763 */ // Label 29515: @2219763
     /* 2219763 */ GIM_Reject,
     /* 2219764 */ // Label 29491: @2219764
     /* 2219764 */ GIM_Try, /*On fail goto*//*Label 29520*/ GIMT_Encode4(2219900),
     /* 2219769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2219772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2219775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219783 */   GIM_Try, /*On fail goto*//*Label 29521*/ GIMT_Encode4(2219817), // Rule ID 2352 //
     /* 2219788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2219791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219799 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219803 */     // MIs[1] Operand 1
     /* 2219803 */     // No operand predicates
     /* 2219803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219805 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2219808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219815 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219816 */     // GIR_Coverage, 2352,
     /* 2219816 */     GIR_EraseRootFromParent_Done,
     /* 2219817 */   // Label 29521: @2219817
     /* 2219817 */   GIM_Try, /*On fail goto*//*Label 29522*/ GIMT_Encode4(2219851), // Rule ID 62523 //
     /* 2219822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2219825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2219829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2219833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2219837 */     // MIs[1] Operand 1
     /* 2219837 */     // No operand predicates
     /* 2219837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2219839 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$imm)
     /* 2219839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2219842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2219849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219850 */     // GIR_Coverage, 62523,
     /* 2219850 */     GIR_EraseRootFromParent_Done,
     /* 2219851 */   // Label 29522: @2219851
     /* 2219851 */   GIM_Try, /*On fail goto*//*Label 29523*/ GIMT_Encode4(2219880), // Rule ID 2350 //
     /* 2219856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2219859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2219866 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROR),
     /* 2219869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2219878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219879 */     // GIR_Coverage, 2350,
     /* 2219879 */     GIR_EraseRootFromParent_Done,
     /* 2219880 */   // Label 29523: @2219880
     /* 2219880 */   GIM_Try, /*On fail goto*//*Label 29524*/ GIMT_Encode4(2219899), // Rule ID 64418 //
     /* 2219885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2219888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2219892 */     // (rotr:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_ROR:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2219892 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ROR),
     /* 2219897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219898 */     // GIR_Coverage, 64418,
     /* 2219898 */     GIR_Done,
     /* 2219899 */   // Label 29524: @2219899
     /* 2219899 */   GIM_Reject,
     /* 2219900 */ // Label 29520: @2219900
     /* 2219900 */ GIM_Reject,
     /* 2219901 */ // Label 29492: @2219901
     /* 2219901 */ GIM_Try, /*On fail goto*//*Label 29525*/ GIMT_Encode4(2220015),
     /* 2219906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2219909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2219912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2219924 */   GIM_Try, /*On fail goto*//*Label 29526*/ GIMT_Encode4(2219969), // Rule ID 59278 //
     /* 2219929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2219932 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2219932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2219949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2219956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2219958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2219961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2219967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2219968 */     // GIR_Coverage, 59278,
     /* 2219968 */     GIR_EraseRootFromParent_Done,
     /* 2219969 */   // Label 29526: @2219969
     /* 2219969 */   GIM_Try, /*On fail goto*//*Label 29527*/ GIMT_Encode4(2220014), // Rule ID 59279 //
     /* 2219974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2219977 */     // (rotr:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROR_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2219977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2219980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2219984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2219989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2219991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF8),
     /* 2219994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2219996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2219999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220013 */     // GIR_Coverage, 59279,
     /* 2220013 */     GIR_EraseRootFromParent_Done,
     /* 2220014 */   // Label 29527: @2220014
     /* 2220014 */   GIM_Reject,
     /* 2220015 */ // Label 29525: @2220015
     /* 2220015 */ GIM_Reject,
     /* 2220016 */ // Label 29493: @2220016
     /* 2220016 */ GIM_Try, /*On fail goto*//*Label 29528*/ GIMT_Encode4(2220130),
     /* 2220021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2220024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2220027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220039 */   GIM_Try, /*On fail goto*//*Label 29529*/ GIMT_Encode4(2220084), // Rule ID 59290 //
     /* 2220044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220047 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2220064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220083 */     // GIR_Coverage, 59290,
     /* 2220083 */     GIR_EraseRootFromParent_Done,
     /* 2220084 */   // Label 29529: @2220084
     /* 2220084 */   GIM_Try, /*On fail goto*//*Label 29530*/ GIMT_Encode4(2220129), // Rule ID 59291 //
     /* 2220089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220092 */     // (rotr:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2220095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2220109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220128 */     // GIR_Coverage, 59291,
     /* 2220128 */     GIR_EraseRootFromParent_Done,
     /* 2220129 */   // Label 29530: @2220129
     /* 2220129 */   GIM_Reject,
     /* 2220130 */ // Label 29528: @2220130
     /* 2220130 */ GIM_Reject,
     /* 2220131 */ // Label 29494: @2220131
     /* 2220131 */ GIM_Try, /*On fail goto*//*Label 29531*/ GIMT_Encode4(2220245),
     /* 2220136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2220139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2220142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220154 */   GIM_Try, /*On fail goto*//*Label 29532*/ GIMT_Encode4(2220199), // Rule ID 59298 //
     /* 2220159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220162 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220198 */     // GIR_Coverage, 59298,
     /* 2220198 */     GIR_EraseRootFromParent_Done,
     /* 2220199 */   // Label 29532: @2220199
     /* 2220199 */   GIM_Try, /*On fail goto*//*Label 29533*/ GIMT_Encode4(2220244), // Rule ID 59299 //
     /* 2220204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220207 */     // (rotr:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2220210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220243 */     // GIR_Coverage, 59299,
     /* 2220243 */     GIR_EraseRootFromParent_Done,
     /* 2220244 */   // Label 29533: @2220244
     /* 2220244 */   GIM_Reject,
     /* 2220245 */ // Label 29531: @2220245
     /* 2220245 */ GIM_Reject,
     /* 2220246 */ // Label 29495: @2220246
     /* 2220246 */ GIM_Try, /*On fail goto*//*Label 29534*/ GIMT_Encode4(2220360),
     /* 2220251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2220254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2220257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220269 */   GIM_Try, /*On fail goto*//*Label 29535*/ GIMT_Encode4(2220314), // Rule ID 59314 //
     /* 2220274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2220277 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2220294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220313 */     // GIR_Coverage, 59314,
     /* 2220313 */     GIR_EraseRootFromParent_Done,
     /* 2220314 */   // Label 29535: @2220314
     /* 2220314 */   GIM_Try, /*On fail goto*//*Label 29536*/ GIMT_Encode4(2220359), // Rule ID 59315 //
     /* 2220319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2220322 */     // (rotr:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2220325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2220339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220358 */     // GIR_Coverage, 59315,
     /* 2220358 */     GIR_EraseRootFromParent_Done,
     /* 2220359 */   // Label 29536: @2220359
     /* 2220359 */   GIM_Reject,
     /* 2220360 */ // Label 29534: @2220360
     /* 2220360 */ GIM_Reject,
     /* 2220361 */ // Label 29496: @2220361
     /* 2220361 */ GIM_Try, /*On fail goto*//*Label 29537*/ GIMT_Encode4(2220475),
     /* 2220366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2220369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2220372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220384 */   GIM_Try, /*On fail goto*//*Label 29538*/ GIMT_Encode4(2220429), // Rule ID 59282 //
     /* 2220389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220392 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2220395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2220409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220428 */     // GIR_Coverage, 59282,
     /* 2220428 */     GIR_EraseRootFromParent_Done,
     /* 2220429 */   // Label 29538: @2220429
     /* 2220429 */   GIM_Try, /*On fail goto*//*Label 29539*/ GIMT_Encode4(2220474), // Rule ID 59283 //
     /* 2220434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220437 */     // (rotr:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROR_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2220440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF4),
     /* 2220454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220473 */     // GIR_Coverage, 59283,
     /* 2220473 */     GIR_EraseRootFromParent_Done,
     /* 2220474 */   // Label 29539: @2220474
     /* 2220474 */   GIM_Reject,
     /* 2220475 */ // Label 29537: @2220475
     /* 2220475 */ GIM_Reject,
     /* 2220476 */ // Label 29497: @2220476
     /* 2220476 */ GIM_Try, /*On fail goto*//*Label 29540*/ GIMT_Encode4(2220590),
     /* 2220481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2220484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2220487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220499 */   GIM_Try, /*On fail goto*//*Label 29541*/ GIMT_Encode4(2220544), // Rule ID 59294 //
     /* 2220504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220507 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2220510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220531 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220543 */     // GIR_Coverage, 59294,
     /* 2220543 */     GIR_EraseRootFromParent_Done,
     /* 2220544 */   // Label 29541: @2220544
     /* 2220544 */   GIM_Try, /*On fail goto*//*Label 29542*/ GIMT_Encode4(2220589), // Rule ID 59295 //
     /* 2220549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220552 */     // (rotr:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2220555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220588 */     // GIR_Coverage, 59295,
     /* 2220588 */     GIR_EraseRootFromParent_Done,
     /* 2220589 */   // Label 29542: @2220589
     /* 2220589 */   GIM_Reject,
     /* 2220590 */ // Label 29540: @2220590
     /* 2220590 */ GIM_Reject,
     /* 2220591 */ // Label 29498: @2220591
     /* 2220591 */ GIM_Try, /*On fail goto*//*Label 29543*/ GIMT_Encode4(2220705),
     /* 2220596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2220599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2220602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220614 */   GIM_Try, /*On fail goto*//*Label 29544*/ GIMT_Encode4(2220659), // Rule ID 59310 //
     /* 2220619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220622 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2220639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220641 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220658 */     // GIR_Coverage, 59310,
     /* 2220658 */     GIR_EraseRootFromParent_Done,
     /* 2220659 */   // Label 29544: @2220659
     /* 2220659 */   GIM_Try, /*On fail goto*//*Label 29545*/ GIMT_Encode4(2220704), // Rule ID 59311 //
     /* 2220664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220667 */     // (rotr:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2220670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2220684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2220699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220703 */     // GIR_Coverage, 59311,
     /* 2220703 */     GIR_EraseRootFromParent_Done,
     /* 2220704 */   // Label 29545: @2220704
     /* 2220704 */   GIM_Reject,
     /* 2220705 */ // Label 29543: @2220705
     /* 2220705 */ GIM_Reject,
     /* 2220706 */ // Label 29499: @2220706
     /* 2220706 */ GIM_Try, /*On fail goto*//*Label 29546*/ GIMT_Encode4(2220820),
     /* 2220711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2220714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2220717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2220729 */   GIM_Try, /*On fail goto*//*Label 29547*/ GIMT_Encode4(2220774), // Rule ID 59354 //
     /* 2220734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2220737 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2220754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220773 */     // GIR_Coverage, 59354,
     /* 2220773 */     GIR_EraseRootFromParent_Done,
     /* 2220774 */   // Label 29547: @2220774
     /* 2220774 */   GIM_Try, /*On fail goto*//*Label 29548*/ GIMT_Encode4(2220819), // Rule ID 59355 //
     /* 2220779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2220782 */     // (rotr:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2220785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2220799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2220814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220818 */     // GIR_Coverage, 59355,
     /* 2220818 */     GIR_EraseRootFromParent_Done,
     /* 2220819 */   // Label 29548: @2220819
     /* 2220819 */   GIM_Reject,
     /* 2220820 */ // Label 29546: @2220820
     /* 2220820 */ GIM_Reject,
     /* 2220821 */ // Label 29500: @2220821
     /* 2220821 */ GIM_Try, /*On fail goto*//*Label 29549*/ GIMT_Encode4(2220935),
     /* 2220826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2220829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2220832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220844 */   GIM_Try, /*On fail goto*//*Label 29550*/ GIMT_Encode4(2220889), // Rule ID 59286 //
     /* 2220849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220852 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2220855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220888 */     // GIR_Coverage, 59286,
     /* 2220888 */     GIR_EraseRootFromParent_Done,
     /* 2220889 */   // Label 29550: @2220889
     /* 2220889 */   GIM_Try, /*On fail goto*//*Label 29551*/ GIMT_Encode4(2220934), // Rule ID 59287 //
     /* 2220894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2220897 */     // (rotr:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROR_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2220897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2220900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_MF2),
     /* 2220914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2220932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2220933 */     // GIR_Coverage, 59287,
     /* 2220933 */     GIR_EraseRootFromParent_Done,
     /* 2220934 */   // Label 29551: @2220934
     /* 2220934 */   GIM_Reject,
     /* 2220935 */ // Label 29549: @2220935
     /* 2220935 */ GIM_Reject,
     /* 2220936 */ // Label 29501: @2220936
     /* 2220936 */ GIM_Try, /*On fail goto*//*Label 29552*/ GIMT_Encode4(2221050),
     /* 2220941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2220944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2220947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2220959 */   GIM_Try, /*On fail goto*//*Label 29553*/ GIMT_Encode4(2221004), // Rule ID 59306 //
     /* 2220964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2220967 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2220967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2220970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2220974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2220979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2220981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2220984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2220986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2220989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2220991 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2220993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2220996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2220999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221002 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221003 */     // GIR_Coverage, 59306,
     /* 2221003 */     GIR_EraseRootFromParent_Done,
     /* 2221004 */   // Label 29553: @2221004
     /* 2221004 */   GIM_Try, /*On fail goto*//*Label 29554*/ GIMT_Encode4(2221049), // Rule ID 59307 //
     /* 2221009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221012 */     // (rotr:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2221015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2221029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221048 */     // GIR_Coverage, 59307,
     /* 2221048 */     GIR_EraseRootFromParent_Done,
     /* 2221049 */   // Label 29554: @2221049
     /* 2221049 */   GIM_Reject,
     /* 2221050 */ // Label 29552: @2221050
     /* 2221050 */ GIM_Reject,
     /* 2221051 */ // Label 29502: @2221051
     /* 2221051 */ GIM_Try, /*On fail goto*//*Label 29555*/ GIMT_Encode4(2221165),
     /* 2221056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2221059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2221062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221074 */   GIM_Try, /*On fail goto*//*Label 29556*/ GIMT_Encode4(2221119), // Rule ID 59342 //
     /* 2221079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221082 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221082 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221085 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221089 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221118 */     // GIR_Coverage, 59342,
     /* 2221118 */     GIR_EraseRootFromParent_Done,
     /* 2221119 */   // Label 29556: @2221119
     /* 2221119 */   GIM_Try, /*On fail goto*//*Label 29557*/ GIMT_Encode4(2221164), // Rule ID 59343 //
     /* 2221124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221127 */     // (rotr:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2221130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221163 */     // GIR_Coverage, 59343,
     /* 2221163 */     GIR_EraseRootFromParent_Done,
     /* 2221164 */   // Label 29557: @2221164
     /* 2221164 */   GIM_Reject,
     /* 2221165 */ // Label 29555: @2221165
     /* 2221165 */ GIM_Reject,
     /* 2221166 */ // Label 29503: @2221166
     /* 2221166 */ GIM_Try, /*On fail goto*//*Label 29558*/ GIMT_Encode4(2221280),
     /* 2221171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2221174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2221177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221189 */   GIM_Try, /*On fail goto*//*Label 29559*/ GIMT_Encode4(2221234), // Rule ID 59358 //
     /* 2221194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2221197 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221233 */     // GIR_Coverage, 59358,
     /* 2221233 */     GIR_EraseRootFromParent_Done,
     /* 2221234 */   // Label 29559: @2221234
     /* 2221234 */   GIM_Try, /*On fail goto*//*Label 29560*/ GIMT_Encode4(2221279), // Rule ID 59359 //
     /* 2221239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221242 */     // (rotr:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2221245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221278 */     // GIR_Coverage, 59359,
     /* 2221278 */     GIR_EraseRootFromParent_Done,
     /* 2221279 */   // Label 29560: @2221279
     /* 2221279 */   GIM_Reject,
     /* 2221280 */ // Label 29558: @2221280
     /* 2221280 */ GIM_Reject,
     /* 2221281 */ // Label 29504: @2221281
     /* 2221281 */ GIM_Try, /*On fail goto*//*Label 29561*/ GIMT_Encode4(2221395),
     /* 2221286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2221289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2221292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2221304 */   GIM_Try, /*On fail goto*//*Label 29562*/ GIMT_Encode4(2221349), // Rule ID 59302 //
     /* 2221309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221312 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2221315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2221329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221336 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221347 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221348 */     // GIR_Coverage, 59302,
     /* 2221348 */     GIR_EraseRootFromParent_Done,
     /* 2221349 */   // Label 29562: @2221349
     /* 2221349 */   GIM_Try, /*On fail goto*//*Label 29563*/ GIMT_Encode4(2221394), // Rule ID 59303 //
     /* 2221354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221357 */     // (rotr:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROR_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2221360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221369 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M1),
     /* 2221374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221393 */     // GIR_Coverage, 59303,
     /* 2221393 */     GIR_EraseRootFromParent_Done,
     /* 2221394 */   // Label 29563: @2221394
     /* 2221394 */   GIM_Reject,
     /* 2221395 */ // Label 29561: @2221395
     /* 2221395 */ GIM_Reject,
     /* 2221396 */ // Label 29505: @2221396
     /* 2221396 */ GIM_Try, /*On fail goto*//*Label 29564*/ GIMT_Encode4(2221510),
     /* 2221401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2221404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2221407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221419 */   GIM_Try, /*On fail goto*//*Label 29565*/ GIMT_Encode4(2221464), // Rule ID 59330 //
     /* 2221424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221427 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2221430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221463 */     // GIR_Coverage, 59330,
     /* 2221463 */     GIR_EraseRootFromParent_Done,
     /* 2221464 */   // Label 29565: @2221464
     /* 2221464 */   GIM_Try, /*On fail goto*//*Label 29566*/ GIMT_Encode4(2221509), // Rule ID 59331 //
     /* 2221469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221472 */     // (rotr:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2221475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221508 */     // GIR_Coverage, 59331,
     /* 2221508 */     GIR_EraseRootFromParent_Done,
     /* 2221509 */   // Label 29566: @2221509
     /* 2221509 */   GIM_Reject,
     /* 2221510 */ // Label 29564: @2221510
     /* 2221510 */ GIM_Reject,
     /* 2221511 */ // Label 29506: @2221511
     /* 2221511 */ GIM_Try, /*On fail goto*//*Label 29567*/ GIMT_Encode4(2221625),
     /* 2221516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2221519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2221522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221534 */   GIM_Try, /*On fail goto*//*Label 29568*/ GIMT_Encode4(2221579), // Rule ID 59346 //
     /* 2221539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221542 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221578 */     // GIR_Coverage, 59346,
     /* 2221578 */     GIR_EraseRootFromParent_Done,
     /* 2221579 */   // Label 29568: @2221579
     /* 2221579 */   GIM_Try, /*On fail goto*//*Label 29569*/ GIMT_Encode4(2221624), // Rule ID 59347 //
     /* 2221584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221587 */     // (rotr:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2221590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2221619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221623 */     // GIR_Coverage, 59347,
     /* 2221623 */     GIR_EraseRootFromParent_Done,
     /* 2221624 */   // Label 29569: @2221624
     /* 2221624 */   GIM_Reject,
     /* 2221625 */ // Label 29567: @2221625
     /* 2221625 */ GIM_Reject,
     /* 2221626 */ // Label 29507: @2221626
     /* 2221626 */ GIM_Try, /*On fail goto*//*Label 29570*/ GIMT_Encode4(2221740),
     /* 2221631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2221634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2221637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221649 */   GIM_Try, /*On fail goto*//*Label 29571*/ GIMT_Encode4(2221694), // Rule ID 59362 //
     /* 2221654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2221657 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2221660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2221674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221693 */     // GIR_Coverage, 59362,
     /* 2221693 */     GIR_EraseRootFromParent_Done,
     /* 2221694 */   // Label 29571: @2221694
     /* 2221694 */   GIM_Try, /*On fail goto*//*Label 29572*/ GIMT_Encode4(2221739), // Rule ID 59363 //
     /* 2221699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2221702 */     // (rotr:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2221705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2221719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221721 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221724 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221726 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2221734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221738 */     // GIR_Coverage, 59363,
     /* 2221738 */     GIR_EraseRootFromParent_Done,
     /* 2221739 */   // Label 29572: @2221739
     /* 2221739 */   GIM_Reject,
     /* 2221740 */ // Label 29570: @2221740
     /* 2221740 */ GIM_Reject,
     /* 2221741 */ // Label 29508: @2221741
     /* 2221741 */ GIM_Try, /*On fail goto*//*Label 29573*/ GIMT_Encode4(2221855),
     /* 2221746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2221749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2221752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2221764 */   GIM_Try, /*On fail goto*//*Label 29574*/ GIMT_Encode4(2221809), // Rule ID 59318 //
     /* 2221769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221772 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2221775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221784 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221791 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221808 */     // GIR_Coverage, 59318,
     /* 2221808 */     GIR_EraseRootFromParent_Done,
     /* 2221809 */   // Label 29574: @2221809
     /* 2221809 */   GIM_Try, /*On fail goto*//*Label 29575*/ GIMT_Encode4(2221854), // Rule ID 59319 //
     /* 2221814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221817 */     // (rotr:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROR_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2221820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M2),
     /* 2221834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221853 */     // GIR_Coverage, 59319,
     /* 2221853 */     GIR_EraseRootFromParent_Done,
     /* 2221854 */   // Label 29575: @2221854
     /* 2221854 */   GIM_Reject,
     /* 2221855 */ // Label 29573: @2221855
     /* 2221855 */ GIM_Reject,
     /* 2221856 */ // Label 29509: @2221856
     /* 2221856 */ GIM_Try, /*On fail goto*//*Label 29576*/ GIMT_Encode4(2221970),
     /* 2221861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2221864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2221867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221875 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2221879 */   GIM_Try, /*On fail goto*//*Label 29577*/ GIMT_Encode4(2221924), // Rule ID 59334 //
     /* 2221884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2221887 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2221887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2221890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221923 */     // GIR_Coverage, 59334,
     /* 2221923 */     GIR_EraseRootFromParent_Done,
     /* 2221924 */   // Label 29577: @2221924
     /* 2221924 */   GIM_Try, /*On fail goto*//*Label 29578*/ GIMT_Encode4(2221969), // Rule ID 59335 //
     /* 2221929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2221932 */     // (rotr:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2221932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2221935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2221939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2221944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2221946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2221949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2221951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2221954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2221956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2221958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2221961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2221964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2221967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2221968 */     // GIR_Coverage, 59335,
     /* 2221968 */     GIR_EraseRootFromParent_Done,
     /* 2221969 */   // Label 29578: @2221969
     /* 2221969 */   GIM_Reject,
     /* 2221970 */ // Label 29576: @2221970
     /* 2221970 */ GIM_Reject,
     /* 2221971 */ // Label 29510: @2221971
     /* 2221971 */ GIM_Try, /*On fail goto*//*Label 29579*/ GIMT_Encode4(2222085),
     /* 2221976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2221979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2221982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2221994 */   GIM_Try, /*On fail goto*//*Label 29580*/ GIMT_Encode4(2222039), // Rule ID 59350 //
     /* 2221999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222002 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222038 */     // GIR_Coverage, 59350,
     /* 2222038 */     GIR_EraseRootFromParent_Done,
     /* 2222039 */   // Label 29580: @2222039
     /* 2222039 */   GIM_Try, /*On fail goto*//*Label 29581*/ GIMT_Encode4(2222084), // Rule ID 59351 //
     /* 2222044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222047 */     // (rotr:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2222050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2222079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222083 */     // GIR_Coverage, 59351,
     /* 2222083 */     GIR_EraseRootFromParent_Done,
     /* 2222084 */   // Label 29581: @2222084
     /* 2222084 */   GIM_Reject,
     /* 2222085 */ // Label 29579: @2222085
     /* 2222085 */ GIM_Reject,
     /* 2222086 */ // Label 29511: @2222086
     /* 2222086 */ GIM_Try, /*On fail goto*//*Label 29582*/ GIMT_Encode4(2222200),
     /* 2222091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2222094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2222097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2222109 */   GIM_Try, /*On fail goto*//*Label 29583*/ GIMT_Encode4(2222154), // Rule ID 59322 //
     /* 2222114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222117 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2222120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2222134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222153 */     // GIR_Coverage, 59322,
     /* 2222153 */     GIR_EraseRootFromParent_Done,
     /* 2222154 */   // Label 29583: @2222154
     /* 2222154 */   GIM_Try, /*On fail goto*//*Label 29584*/ GIMT_Encode4(2222199), // Rule ID 59323 //
     /* 2222159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222162 */     // (rotr:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROR_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2222165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M4),
     /* 2222179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222184 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222197 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222198 */     // GIR_Coverage, 59323,
     /* 2222198 */     GIR_EraseRootFromParent_Done,
     /* 2222199 */   // Label 29584: @2222199
     /* 2222199 */   GIM_Reject,
     /* 2222200 */ // Label 29582: @2222200
     /* 2222200 */ GIM_Reject,
     /* 2222201 */ // Label 29512: @2222201
     /* 2222201 */ GIM_Try, /*On fail goto*//*Label 29585*/ GIMT_Encode4(2222315),
     /* 2222206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2222209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2222212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222220 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222224 */   GIM_Try, /*On fail goto*//*Label 29586*/ GIMT_Encode4(2222269), // Rule ID 59338 //
     /* 2222229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222232 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2222235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222268 */     // GIR_Coverage, 59338,
     /* 2222268 */     GIR_EraseRootFromParent_Done,
     /* 2222269 */   // Label 29586: @2222269
     /* 2222269 */   GIM_Try, /*On fail goto*//*Label 29587*/ GIMT_Encode4(2222314), // Rule ID 59339 //
     /* 2222274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222277 */     // (rotr:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2222280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222313 */     // GIR_Coverage, 59339,
     /* 2222313 */     GIR_EraseRootFromParent_Done,
     /* 2222314 */   // Label 29587: @2222314
     /* 2222314 */   GIM_Reject,
     /* 2222315 */ // Label 29585: @2222315
     /* 2222315 */ GIM_Reject,
     /* 2222316 */ // Label 29513: @2222316
     /* 2222316 */ GIM_Try, /*On fail goto*//*Label 29588*/ GIMT_Encode4(2222430),
     /* 2222321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2222324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2222327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2222339 */   GIM_Try, /*On fail goto*//*Label 29589*/ GIMT_Encode4(2222384), // Rule ID 59326 //
     /* 2222344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222347 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2222350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222383 */     // GIR_Coverage, 59326,
     /* 2222383 */     GIR_EraseRootFromParent_Done,
     /* 2222384 */   // Label 29589: @2222384
     /* 2222384 */   GIM_Try, /*On fail goto*//*Label 29590*/ GIMT_Encode4(2222429), // Rule ID 59327 //
     /* 2222389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222392 */     // (rotr:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROR_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2222395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROR_VV_M8),
     /* 2222409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222416 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222428 */     // GIR_Coverage, 59327,
     /* 2222428 */     GIR_EraseRootFromParent_Done,
     /* 2222429 */   // Label 29590: @2222429
     /* 2222429 */   GIM_Reject,
     /* 2222430 */ // Label 29588: @2222430
     /* 2222430 */ GIM_Reject,
     /* 2222431 */ // Label 29514: @2222431
     /* 2222431 */ GIM_Reject,
     /* 2222432 */ // Label 47: @2222432
     /* 2222432 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 29615*/ GIMT_Encode4(2225341),
     /* 2222443 */ /*GILLT_s32*//*Label 29591*/ GIMT_Encode4(2222567),
     /* 2222447 */ /*GILLT_s64*//*Label 29592*/ GIMT_Encode4(2222689), GIMT_Encode4(0),
     /* 2222455 */ /*GILLT_nxv1s8*//*Label 29593*/ GIMT_Encode4(2222811),
     /* 2222459 */ /*GILLT_nxv1s16*//*Label 29594*/ GIMT_Encode4(2222926),
     /* 2222463 */ /*GILLT_nxv1s32*//*Label 29595*/ GIMT_Encode4(2223041),
     /* 2222467 */ /*GILLT_nxv1s64*//*Label 29596*/ GIMT_Encode4(2223156), GIMT_Encode4(0),
     /* 2222475 */ /*GILLT_nxv2s8*//*Label 29597*/ GIMT_Encode4(2223271),
     /* 2222479 */ /*GILLT_nxv2s16*//*Label 29598*/ GIMT_Encode4(2223386),
     /* 2222483 */ /*GILLT_nxv2s32*//*Label 29599*/ GIMT_Encode4(2223501),
     /* 2222487 */ /*GILLT_nxv2s64*//*Label 29600*/ GIMT_Encode4(2223616), GIMT_Encode4(0),
     /* 2222495 */ /*GILLT_nxv4s8*//*Label 29601*/ GIMT_Encode4(2223731),
     /* 2222499 */ /*GILLT_nxv4s16*//*Label 29602*/ GIMT_Encode4(2223846),
     /* 2222503 */ /*GILLT_nxv4s32*//*Label 29603*/ GIMT_Encode4(2223961),
     /* 2222507 */ /*GILLT_nxv4s64*//*Label 29604*/ GIMT_Encode4(2224076), GIMT_Encode4(0),
     /* 2222515 */ /*GILLT_nxv8s8*//*Label 29605*/ GIMT_Encode4(2224191),
     /* 2222519 */ /*GILLT_nxv8s16*//*Label 29606*/ GIMT_Encode4(2224306),
     /* 2222523 */ /*GILLT_nxv8s32*//*Label 29607*/ GIMT_Encode4(2224421),
     /* 2222527 */ /*GILLT_nxv8s64*//*Label 29608*/ GIMT_Encode4(2224536), GIMT_Encode4(0),
     /* 2222535 */ /*GILLT_nxv16s8*//*Label 29609*/ GIMT_Encode4(2224651),
     /* 2222539 */ /*GILLT_nxv16s16*//*Label 29610*/ GIMT_Encode4(2224766),
     /* 2222543 */ /*GILLT_nxv16s32*//*Label 29611*/ GIMT_Encode4(2224881), GIMT_Encode4(0),
     /* 2222551 */ /*GILLT_nxv32s8*//*Label 29612*/ GIMT_Encode4(2224996),
     /* 2222555 */ /*GILLT_nxv32s16*//*Label 29613*/ GIMT_Encode4(2225111), GIMT_Encode4(0),
     /* 2222563 */ /*GILLT_nxv64s8*//*Label 29614*/ GIMT_Encode4(2225226),
     /* 2222567 */ // Label 29591: @2222567
     /* 2222567 */ GIM_Try, /*On fail goto*//*Label 29616*/ GIMT_Encode4(2222688),
     /* 2222572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2222575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2222578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222586 */   GIM_Try, /*On fail goto*//*Label 29617*/ GIMT_Encode4(2222622), // Rule ID 2355 //
     /* 2222591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2222594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2222598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2222602 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2222606 */     // MIs[1] Operand 1
     /* 2222606 */     // No operand predicates
     /* 2222606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222608 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2222608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2222611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222615 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2222620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222621 */     // GIR_Coverage, 2355,
     /* 2222621 */     GIR_EraseRootFromParent_Done,
     /* 2222622 */   // Label 29617: @2222622
     /* 2222622 */   GIM_Try, /*On fail goto*//*Label 29618*/ GIMT_Encode4(2222658), // Rule ID 62526 //
     /* 2222627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2222630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2222634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2222638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2222642 */     // MIs[1] Operand 1
     /* 2222642 */     // No operand predicates
     /* 2222642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222644 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmSubFromXLen:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2222644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2222647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222651 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2222656 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222657 */     // GIR_Coverage, 62526,
     /* 2222657 */     GIR_EraseRootFromParent_Done,
     /* 2222658 */   // Label 29618: @2222658
     /* 2222658 */   GIM_Try, /*On fail goto*//*Label 29619*/ GIMT_Encode4(2222687), // Rule ID 2349 //
     /* 2222663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode1),
     /* 2222666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2222673 */     // (rotl:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (shiftMaskXLen:{ *:[i32] } GPR:{ *:[i32] }:$rs2))  =>  (ROL:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2222673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2222676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2222685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222686 */     // GIR_Coverage, 2349,
     /* 2222686 */     GIR_EraseRootFromParent_Done,
     /* 2222687 */   // Label 29619: @2222687
     /* 2222687 */   GIM_Reject,
     /* 2222688 */ // Label 29616: @2222688
     /* 2222688 */ GIM_Reject,
     /* 2222689 */ // Label 29592: @2222689
     /* 2222689 */ GIM_Try, /*On fail goto*//*Label 29620*/ GIMT_Encode4(2222810),
     /* 2222694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2222697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2222700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2222708 */   GIM_Try, /*On fail goto*//*Label 29621*/ GIMT_Encode4(2222744), // Rule ID 2354 //
     /* 2222713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2222716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2222720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2222724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2222728 */     // MIs[1] Operand 1
     /* 2222728 */     // No operand predicates
     /* 2222728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222730 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (RORI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2222730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORI),
     /* 2222733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222737 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2222742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222743 */     // GIR_Coverage, 2354,
     /* 2222743 */     GIR_EraseRootFromParent_Done,
     /* 2222744 */   // Label 29621: @2222744
     /* 2222744 */   GIM_Try, /*On fail goto*//*Label 29622*/ GIMT_Encode4(2222780), // Rule ID 62525 //
     /* 2222749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2222752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2222756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2222760 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimmlog2xlen),
     /* 2222764 */     // MIs[1] Operand 1
     /* 2222764 */     // No operand predicates
     /* 2222764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2222766 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt)  =>  (TH_SRRI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFromXLen:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimmlog2xlen>>:$shamt))
     /* 2222766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRI),
     /* 2222769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222773 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFromXLen), // shamt
     /* 2222778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222779 */     // GIR_Coverage, 62525,
     /* 2222779 */     GIR_EraseRootFromParent_Done,
     /* 2222780 */   // Label 29622: @2222780
     /* 2222780 */   GIM_Try, /*On fail goto*//*Label 29623*/ GIMT_Encode4(2222809), // Rule ID 2348 //
     /* 2222785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_HwMode0),
     /* 2222788 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMaskXLen),
     /* 2222795 */     // (rotl:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMaskXLen:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROL:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2222795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROL),
     /* 2222798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2222807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222808 */     // GIR_Coverage, 2348,
     /* 2222808 */     GIR_EraseRootFromParent_Done,
     /* 2222809 */   // Label 29623: @2222809
     /* 2222809 */   GIM_Reject,
     /* 2222810 */ // Label 29620: @2222810
     /* 2222810 */ GIM_Reject,
     /* 2222811 */ // Label 29593: @2222811
     /* 2222811 */ GIM_Try, /*On fail goto*//*Label 29624*/ GIMT_Encode4(2222925),
     /* 2222816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2222819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2222822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222834 */   GIM_Try, /*On fail goto*//*Label 29625*/ GIMT_Encode4(2222879), // Rule ID 59146 //
     /* 2222839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222842 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2222845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2222859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222878 */     // GIR_Coverage, 59146,
     /* 2222878 */     GIR_EraseRootFromParent_Done,
     /* 2222879 */   // Label 29625: @2222879
     /* 2222879 */   GIM_Try, /*On fail goto*//*Label 29626*/ GIMT_Encode4(2222924), // Rule ID 59147 //
     /* 2222884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2222887 */     // (rotl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVROL_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2222887 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2222890 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222894 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF8),
     /* 2222904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222909 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222911 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222923 */     // GIR_Coverage, 59147,
     /* 2222923 */     GIR_EraseRootFromParent_Done,
     /* 2222924 */   // Label 29626: @2222924
     /* 2222924 */   GIM_Reject,
     /* 2222925 */ // Label 29624: @2222925
     /* 2222925 */ GIM_Reject,
     /* 2222926 */ // Label 29594: @2222926
     /* 2222926 */ GIM_Try, /*On fail goto*//*Label 29627*/ GIMT_Encode4(2223040),
     /* 2222931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2222934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2222937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222945 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2222949 */   GIM_Try, /*On fail goto*//*Label 29628*/ GIMT_Encode4(2222994), // Rule ID 59158 //
     /* 2222954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2222957 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2222957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2222960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2222964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2222969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2222971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2222974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2222976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2222979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2222981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2222983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2222986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2222989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2222992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2222993 */     // GIR_Coverage, 59158,
     /* 2222993 */     GIR_EraseRootFromParent_Done,
     /* 2222994 */   // Label 29628: @2222994
     /* 2222994 */   GIM_Try, /*On fail goto*//*Label 29629*/ GIMT_Encode4(2223039), // Rule ID 59159 //
     /* 2222999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223002 */     // (rotl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2223005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2223019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223037 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223038 */     // GIR_Coverage, 59159,
     /* 2223038 */     GIR_EraseRootFromParent_Done,
     /* 2223039 */   // Label 29629: @2223039
     /* 2223039 */   GIM_Reject,
     /* 2223040 */ // Label 29627: @2223040
     /* 2223040 */ GIM_Reject,
     /* 2223041 */ // Label 29595: @2223041
     /* 2223041 */ GIM_Try, /*On fail goto*//*Label 29630*/ GIMT_Encode4(2223155),
     /* 2223046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2223049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2223052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223064 */   GIM_Try, /*On fail goto*//*Label 29631*/ GIMT_Encode4(2223109), // Rule ID 59166 //
     /* 2223069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223072 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2223075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223108 */     // GIR_Coverage, 59166,
     /* 2223108 */     GIR_EraseRootFromParent_Done,
     /* 2223109 */   // Label 29631: @2223109
     /* 2223109 */   GIM_Try, /*On fail goto*//*Label 29632*/ GIMT_Encode4(2223154), // Rule ID 59167 //
     /* 2223114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223117 */     // (rotl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2223120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223153 */     // GIR_Coverage, 59167,
     /* 2223153 */     GIR_EraseRootFromParent_Done,
     /* 2223154 */   // Label 29632: @2223154
     /* 2223154 */   GIM_Reject,
     /* 2223155 */ // Label 29630: @2223155
     /* 2223155 */ GIM_Reject,
     /* 2223156 */ // Label 29596: @2223156
     /* 2223156 */ GIM_Try, /*On fail goto*//*Label 29633*/ GIMT_Encode4(2223270),
     /* 2223161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2223164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2223167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223179 */   GIM_Try, /*On fail goto*//*Label 29634*/ GIMT_Encode4(2223224), // Rule ID 59182 //
     /* 2223184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2223187 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2223190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223223 */     // GIR_Coverage, 59182,
     /* 2223223 */     GIR_EraseRootFromParent_Done,
     /* 2223224 */   // Label 29634: @2223224
     /* 2223224 */   GIM_Try, /*On fail goto*//*Label 29635*/ GIMT_Encode4(2223269), // Rule ID 59183 //
     /* 2223229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2223232 */     // (rotl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2223235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223244 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223251 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223268 */     // GIR_Coverage, 59183,
     /* 2223268 */     GIR_EraseRootFromParent_Done,
     /* 2223269 */   // Label 29635: @2223269
     /* 2223269 */   GIM_Reject,
     /* 2223270 */ // Label 29633: @2223270
     /* 2223270 */ GIM_Reject,
     /* 2223271 */ // Label 29597: @2223271
     /* 2223271 */ GIM_Try, /*On fail goto*//*Label 29636*/ GIMT_Encode4(2223385),
     /* 2223276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2223279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2223282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223294 */   GIM_Try, /*On fail goto*//*Label 29637*/ GIMT_Encode4(2223339), // Rule ID 59150 //
     /* 2223299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223302 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2223305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2223319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223338 */     // GIR_Coverage, 59150,
     /* 2223338 */     GIR_EraseRootFromParent_Done,
     /* 2223339 */   // Label 29637: @2223339
     /* 2223339 */   GIM_Try, /*On fail goto*//*Label 29638*/ GIMT_Encode4(2223384), // Rule ID 59151 //
     /* 2223344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223347 */     // (rotl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVROL_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2223350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF4),
     /* 2223364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223383 */     // GIR_Coverage, 59151,
     /* 2223383 */     GIR_EraseRootFromParent_Done,
     /* 2223384 */   // Label 29638: @2223384
     /* 2223384 */   GIM_Reject,
     /* 2223385 */ // Label 29636: @2223385
     /* 2223385 */ GIM_Reject,
     /* 2223386 */ // Label 29598: @2223386
     /* 2223386 */ GIM_Try, /*On fail goto*//*Label 29639*/ GIMT_Encode4(2223500),
     /* 2223391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2223394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2223397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223409 */   GIM_Try, /*On fail goto*//*Label 29640*/ GIMT_Encode4(2223454), // Rule ID 59162 //
     /* 2223414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223417 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223452 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223453 */     // GIR_Coverage, 59162,
     /* 2223453 */     GIR_EraseRootFromParent_Done,
     /* 2223454 */   // Label 29640: @2223454
     /* 2223454 */   GIM_Try, /*On fail goto*//*Label 29641*/ GIMT_Encode4(2223499), // Rule ID 59163 //
     /* 2223459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223462 */     // (rotl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2223465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223498 */     // GIR_Coverage, 59163,
     /* 2223498 */     GIR_EraseRootFromParent_Done,
     /* 2223499 */   // Label 29641: @2223499
     /* 2223499 */   GIM_Reject,
     /* 2223500 */ // Label 29639: @2223500
     /* 2223500 */ GIM_Reject,
     /* 2223501 */ // Label 29599: @2223501
     /* 2223501 */ GIM_Try, /*On fail goto*//*Label 29642*/ GIMT_Encode4(2223615),
     /* 2223506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2223509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2223512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223520 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223524 */   GIM_Try, /*On fail goto*//*Label 29643*/ GIMT_Encode4(2223569), // Rule ID 59178 //
     /* 2223529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223532 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223568 */     // GIR_Coverage, 59178,
     /* 2223568 */     GIR_EraseRootFromParent_Done,
     /* 2223569 */   // Label 29643: @2223569
     /* 2223569 */   GIM_Try, /*On fail goto*//*Label 29644*/ GIMT_Encode4(2223614), // Rule ID 59179 //
     /* 2223574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223577 */     // (rotl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2223580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223596 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2223609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223613 */     // GIR_Coverage, 59179,
     /* 2223613 */     GIR_EraseRootFromParent_Done,
     /* 2223614 */   // Label 29644: @2223614
     /* 2223614 */   GIM_Reject,
     /* 2223615 */ // Label 29642: @2223615
     /* 2223615 */ GIM_Reject,
     /* 2223616 */ // Label 29600: @2223616
     /* 2223616 */ GIM_Try, /*On fail goto*//*Label 29645*/ GIMT_Encode4(2223730),
     /* 2223621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2223624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2223627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223631 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223635 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223639 */   GIM_Try, /*On fail goto*//*Label 29646*/ GIMT_Encode4(2223684), // Rule ID 59222 //
     /* 2223644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2223647 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2223664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223666 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223683 */     // GIR_Coverage, 59222,
     /* 2223683 */     GIR_EraseRootFromParent_Done,
     /* 2223684 */   // Label 29646: @2223684
     /* 2223684 */   GIM_Try, /*On fail goto*//*Label 29647*/ GIMT_Encode4(2223729), // Rule ID 59223 //
     /* 2223689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2223692 */     // (rotl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2223695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2223709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2223724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223728 */     // GIR_Coverage, 59223,
     /* 2223728 */     GIR_EraseRootFromParent_Done,
     /* 2223729 */   // Label 29647: @2223729
     /* 2223729 */   GIM_Reject,
     /* 2223730 */ // Label 29645: @2223730
     /* 2223730 */ GIM_Reject,
     /* 2223731 */ // Label 29601: @2223731
     /* 2223731 */ GIM_Try, /*On fail goto*//*Label 29648*/ GIMT_Encode4(2223845),
     /* 2223736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2223739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2223742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223754 */   GIM_Try, /*On fail goto*//*Label 29649*/ GIMT_Encode4(2223799), // Rule ID 59154 //
     /* 2223759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223762 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223762 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223765 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223769 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223784 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223786 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223798 */     // GIR_Coverage, 59154,
     /* 2223798 */     GIR_EraseRootFromParent_Done,
     /* 2223799 */   // Label 29649: @2223799
     /* 2223799 */   GIM_Try, /*On fail goto*//*Label 29650*/ GIMT_Encode4(2223844), // Rule ID 59155 //
     /* 2223804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223807 */     // (rotl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVROL_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2223810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_MF2),
     /* 2223824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223831 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223843 */     // GIR_Coverage, 59155,
     /* 2223843 */     GIR_EraseRootFromParent_Done,
     /* 2223844 */   // Label 29650: @2223844
     /* 2223844 */   GIM_Reject,
     /* 2223845 */ // Label 29648: @2223845
     /* 2223845 */ GIM_Reject,
     /* 2223846 */ // Label 29602: @2223846
     /* 2223846 */ GIM_Try, /*On fail goto*//*Label 29651*/ GIMT_Encode4(2223960),
     /* 2223851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2223854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2223857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2223869 */   GIM_Try, /*On fail goto*//*Label 29652*/ GIMT_Encode4(2223914), // Rule ID 59174 //
     /* 2223874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223877 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223912 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223913 */     // GIR_Coverage, 59174,
     /* 2223913 */     GIR_EraseRootFromParent_Done,
     /* 2223914 */   // Label 29652: @2223914
     /* 2223914 */   GIM_Try, /*On fail goto*//*Label 29653*/ GIMT_Encode4(2223959), // Rule ID 59175 //
     /* 2223919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2223922 */     // (rotl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2223922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2223925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2223934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2223936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2223939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2223941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2223944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2223946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2223948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2223951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2223954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2223957 */     GIR_RootConstrainSelectedInstOperands,
     /* 2223958 */     // GIR_Coverage, 59175,
     /* 2223958 */     GIR_EraseRootFromParent_Done,
     /* 2223959 */   // Label 29653: @2223959
     /* 2223959 */   GIM_Reject,
     /* 2223960 */ // Label 29651: @2223960
     /* 2223960 */ GIM_Reject,
     /* 2223961 */ // Label 29603: @2223961
     /* 2223961 */ GIM_Try, /*On fail goto*//*Label 29654*/ GIMT_Encode4(2224075),
     /* 2223966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2223969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2223972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2223984 */   GIM_Try, /*On fail goto*//*Label 29655*/ GIMT_Encode4(2224029), // Rule ID 59210 //
     /* 2223989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2223992 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2223992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2223995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2223999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224016 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224028 */     // GIR_Coverage, 59210,
     /* 2224028 */     GIR_EraseRootFromParent_Done,
     /* 2224029 */   // Label 29655: @2224029
     /* 2224029 */   GIM_Try, /*On fail goto*//*Label 29656*/ GIMT_Encode4(2224074), // Rule ID 59211 //
     /* 2224034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224037 */     // (rotl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2224040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224056 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224061 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224073 */     // GIR_Coverage, 59211,
     /* 2224073 */     GIR_EraseRootFromParent_Done,
     /* 2224074 */   // Label 29656: @2224074
     /* 2224074 */   GIM_Reject,
     /* 2224075 */ // Label 29654: @2224075
     /* 2224075 */ GIM_Reject,
     /* 2224076 */ // Label 29604: @2224076
     /* 2224076 */ GIM_Try, /*On fail goto*//*Label 29657*/ GIMT_Encode4(2224190),
     /* 2224081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2224084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2224087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224099 */   GIM_Try, /*On fail goto*//*Label 29658*/ GIMT_Encode4(2224144), // Rule ID 59226 //
     /* 2224104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224107 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224143 */     // GIR_Coverage, 59226,
     /* 2224143 */     GIR_EraseRootFromParent_Done,
     /* 2224144 */   // Label 29658: @2224144
     /* 2224144 */   GIM_Try, /*On fail goto*//*Label 29659*/ GIMT_Encode4(2224189), // Rule ID 59227 //
     /* 2224149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224152 */     // (rotl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2224155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224174 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224176 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224188 */     // GIR_Coverage, 59227,
     /* 2224188 */     GIR_EraseRootFromParent_Done,
     /* 2224189 */   // Label 29659: @2224189
     /* 2224189 */   GIM_Reject,
     /* 2224190 */ // Label 29657: @2224190
     /* 2224190 */ GIM_Reject,
     /* 2224191 */ // Label 29605: @2224191
     /* 2224191 */ GIM_Try, /*On fail goto*//*Label 29660*/ GIMT_Encode4(2224305),
     /* 2224196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2224199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2224202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2224214 */   GIM_Try, /*On fail goto*//*Label 29661*/ GIMT_Encode4(2224259), // Rule ID 59170 //
     /* 2224219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224222 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2224239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224258 */     // GIR_Coverage, 59170,
     /* 2224258 */     GIR_EraseRootFromParent_Done,
     /* 2224259 */   // Label 29661: @2224259
     /* 2224259 */   GIM_Try, /*On fail goto*//*Label 29662*/ GIMT_Encode4(2224304), // Rule ID 59171 //
     /* 2224264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224267 */     // (rotl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVROL_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224267 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2224270 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224274 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M1),
     /* 2224284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224291 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224303 */     // GIR_Coverage, 59171,
     /* 2224303 */     GIR_EraseRootFromParent_Done,
     /* 2224304 */   // Label 29662: @2224304
     /* 2224304 */   GIM_Reject,
     /* 2224305 */ // Label 29660: @2224305
     /* 2224305 */ GIM_Reject,
     /* 2224306 */ // Label 29606: @2224306
     /* 2224306 */ GIM_Try, /*On fail goto*//*Label 29663*/ GIMT_Encode4(2224420),
     /* 2224311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2224314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2224317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224329 */   GIM_Try, /*On fail goto*//*Label 29664*/ GIMT_Encode4(2224374), // Rule ID 59198 //
     /* 2224334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224337 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224373 */     // GIR_Coverage, 59198,
     /* 2224373 */     GIR_EraseRootFromParent_Done,
     /* 2224374 */   // Label 29664: @2224374
     /* 2224374 */   GIM_Try, /*On fail goto*//*Label 29665*/ GIMT_Encode4(2224419), // Rule ID 59199 //
     /* 2224379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224382 */     // (rotl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2224385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224418 */     // GIR_Coverage, 59199,
     /* 2224418 */     GIR_EraseRootFromParent_Done,
     /* 2224419 */   // Label 29665: @2224419
     /* 2224419 */   GIM_Reject,
     /* 2224420 */ // Label 29663: @2224420
     /* 2224420 */ GIM_Reject,
     /* 2224421 */ // Label 29607: @2224421
     /* 2224421 */ GIM_Try, /*On fail goto*//*Label 29666*/ GIMT_Encode4(2224535),
     /* 2224426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2224429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2224432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224444 */   GIM_Try, /*On fail goto*//*Label 29667*/ GIMT_Encode4(2224489), // Rule ID 59214 //
     /* 2224449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224452 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224488 */     // GIR_Coverage, 59214,
     /* 2224488 */     GIR_EraseRootFromParent_Done,
     /* 2224489 */   // Label 29667: @2224489
     /* 2224489 */   GIM_Try, /*On fail goto*//*Label 29668*/ GIMT_Encode4(2224534), // Rule ID 59215 //
     /* 2224494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224497 */     // (rotl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2224500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224533 */     // GIR_Coverage, 59215,
     /* 2224533 */     GIR_EraseRootFromParent_Done,
     /* 2224534 */   // Label 29668: @2224534
     /* 2224534 */   GIM_Reject,
     /* 2224535 */ // Label 29666: @2224535
     /* 2224535 */ GIM_Reject,
     /* 2224536 */ // Label 29608: @2224536
     /* 2224536 */ GIM_Try, /*On fail goto*//*Label 29669*/ GIMT_Encode4(2224650),
     /* 2224541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2224544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2224547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224559 */   GIM_Try, /*On fail goto*//*Label 29670*/ GIMT_Encode4(2224604), // Rule ID 59230 //
     /* 2224564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2224567 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2224570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2224584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224589 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224591 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224603 */     // GIR_Coverage, 59230,
     /* 2224603 */     GIR_EraseRootFromParent_Done,
     /* 2224604 */   // Label 29670: @2224604
     /* 2224604 */   GIM_Try, /*On fail goto*//*Label 29671*/ GIMT_Encode4(2224649), // Rule ID 59231 //
     /* 2224609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2224612 */     // (rotl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2224615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2224629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2224644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224648 */     // GIR_Coverage, 59231,
     /* 2224648 */     GIR_EraseRootFromParent_Done,
     /* 2224649 */   // Label 29671: @2224649
     /* 2224649 */   GIM_Reject,
     /* 2224650 */ // Label 29669: @2224650
     /* 2224650 */ GIM_Reject,
     /* 2224651 */ // Label 29609: @2224651
     /* 2224651 */ GIM_Try, /*On fail goto*//*Label 29672*/ GIMT_Encode4(2224765),
     /* 2224656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2224659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2224662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2224674 */   GIM_Try, /*On fail goto*//*Label 29673*/ GIMT_Encode4(2224719), // Rule ID 59186 //
     /* 2224679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224682 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2224685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224704 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224706 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224718 */     // GIR_Coverage, 59186,
     /* 2224718 */     GIR_EraseRootFromParent_Done,
     /* 2224719 */   // Label 29673: @2224719
     /* 2224719 */   GIM_Try, /*On fail goto*//*Label 29674*/ GIMT_Encode4(2224764), // Rule ID 59187 //
     /* 2224724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224727 */     // (rotl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVROL_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2224730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M2),
     /* 2224744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224746 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224749 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224751 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224762 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224763 */     // GIR_Coverage, 59187,
     /* 2224763 */     GIR_EraseRootFromParent_Done,
     /* 2224764 */   // Label 29674: @2224764
     /* 2224764 */   GIM_Reject,
     /* 2224765 */ // Label 29672: @2224765
     /* 2224765 */ GIM_Reject,
     /* 2224766 */ // Label 29610: @2224766
     /* 2224766 */ GIM_Try, /*On fail goto*//*Label 29675*/ GIMT_Encode4(2224880),
     /* 2224771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2224774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2224777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2224789 */   GIM_Try, /*On fail goto*//*Label 29676*/ GIMT_Encode4(2224834), // Rule ID 59202 //
     /* 2224794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224797 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2224800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224833 */     // GIR_Coverage, 59202,
     /* 2224833 */     GIR_EraseRootFromParent_Done,
     /* 2224834 */   // Label 29676: @2224834
     /* 2224834 */   GIM_Try, /*On fail goto*//*Label 29677*/ GIMT_Encode4(2224879), // Rule ID 59203 //
     /* 2224839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224842 */     // (rotl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2224845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2224859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2224874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224877 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224878 */     // GIR_Coverage, 59203,
     /* 2224878 */     GIR_EraseRootFromParent_Done,
     /* 2224879 */   // Label 29677: @2224879
     /* 2224879 */   GIM_Reject,
     /* 2224880 */ // Label 29675: @2224880
     /* 2224880 */ GIM_Reject,
     /* 2224881 */ // Label 29611: @2224881
     /* 2224881 */ GIM_Try, /*On fail goto*//*Label 29678*/ GIMT_Encode4(2224995),
     /* 2224886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2224889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2224892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2224904 */   GIM_Try, /*On fail goto*//*Label 29679*/ GIMT_Encode4(2224949), // Rule ID 59218 //
     /* 2224909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2224912 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2224912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2224915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2224929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224948 */     // GIR_Coverage, 59218,
     /* 2224948 */     GIR_EraseRootFromParent_Done,
     /* 2224949 */   // Label 29679: @2224949
     /* 2224949 */   GIM_Try, /*On fail goto*//*Label 29680*/ GIMT_Encode4(2224994), // Rule ID 59219 //
     /* 2224954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2224957 */     // (rotl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2224957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2224960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2224964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2224969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2224971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2224974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2224976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2224979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2224981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2224983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2224986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2224989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2224992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2224993 */     // GIR_Coverage, 59219,
     /* 2224993 */     GIR_EraseRootFromParent_Done,
     /* 2224994 */   // Label 29680: @2224994
     /* 2224994 */   GIM_Reject,
     /* 2224995 */ // Label 29678: @2224995
     /* 2224995 */ GIM_Reject,
     /* 2224996 */ // Label 29612: @2224996
     /* 2224996 */ GIM_Try, /*On fail goto*//*Label 29681*/ GIMT_Encode4(2225110),
     /* 2225001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2225004 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2225007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2225019 */   GIM_Try, /*On fail goto*//*Label 29682*/ GIMT_Encode4(2225064), // Rule ID 59190 //
     /* 2225024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225027 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2225030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2225044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225063 */     // GIR_Coverage, 59190,
     /* 2225063 */     GIR_EraseRootFromParent_Done,
     /* 2225064 */   // Label 29682: @2225064
     /* 2225064 */   GIM_Try, /*On fail goto*//*Label 29683*/ GIMT_Encode4(2225109), // Rule ID 59191 //
     /* 2225069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225072 */     // (rotl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVROL_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2225075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M4),
     /* 2225089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225094 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225096 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225108 */     // GIR_Coverage, 59191,
     /* 2225108 */     GIR_EraseRootFromParent_Done,
     /* 2225109 */   // Label 29683: @2225109
     /* 2225109 */   GIM_Reject,
     /* 2225110 */ // Label 29681: @2225110
     /* 2225110 */ GIM_Reject,
     /* 2225111 */ // Label 29613: @2225111
     /* 2225111 */ GIM_Try, /*On fail goto*//*Label 29684*/ GIMT_Encode4(2225225),
     /* 2225116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2225119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2225122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225130 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225134 */   GIM_Try, /*On fail goto*//*Label 29685*/ GIMT_Encode4(2225179), // Rule ID 59206 //
     /* 2225139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225142 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2225145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2225159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225164 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225166 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225178 */     // GIR_Coverage, 59206,
     /* 2225178 */     GIR_EraseRootFromParent_Done,
     /* 2225179 */   // Label 29685: @2225179
     /* 2225179 */   GIM_Try, /*On fail goto*//*Label 29686*/ GIMT_Encode4(2225224), // Rule ID 59207 //
     /* 2225184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225187 */     // (rotl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2225190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2225204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225211 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2225219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225223 */     // GIR_Coverage, 59207,
     /* 2225223 */     GIR_EraseRootFromParent_Done,
     /* 2225224 */   // Label 29686: @2225224
     /* 2225224 */   GIM_Reject,
     /* 2225225 */ // Label 29684: @2225225
     /* 2225225 */ GIM_Reject,
     /* 2225226 */ // Label 29614: @2225226
     /* 2225226 */ GIM_Try, /*On fail goto*//*Label 29687*/ GIMT_Encode4(2225340),
     /* 2225231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2225234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2225237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2225249 */   GIM_Try, /*On fail goto*//*Label 29688*/ GIMT_Encode4(2225294), // Rule ID 59194 //
     /* 2225254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2225257 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2225257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2225260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2225274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225293 */     // GIR_Coverage, 59194,
     /* 2225293 */     GIR_EraseRootFromParent_Done,
     /* 2225294 */   // Label 29688: @2225294
     /* 2225294 */   GIM_Try, /*On fail goto*//*Label 29689*/ GIMT_Encode4(2225339), // Rule ID 59195 //
     /* 2225299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2225302 */     // (rotl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVROL_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2225302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2225305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2225309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVROL_VV_M8),
     /* 2225319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2225326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2225328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2225337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2225338 */     // GIR_Coverage, 59195,
     /* 2225338 */     GIR_EraseRootFromParent_Done,
     /* 2225339 */   // Label 29689: @2225339
     /* 2225339 */   GIM_Reject,
     /* 2225340 */ // Label 29687: @2225340
     /* 2225340 */ GIM_Reject,
     /* 2225341 */ // Label 29615: @2225341
     /* 2225341 */ GIM_Reject,
     /* 2225342 */ // Label 48: @2225342
     /* 2225342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(33), /*)*//*default:*//*Label 29699*/ GIMT_Encode4(2252004),
     /* 2225353 */ /*GILLT_s32*//*Label 29690*/ GIMT_Encode4(2225473),
     /* 2225357 */ /*GILLT_s64*//*Label 29691*/ GIMT_Encode4(2228267),
     /* 2225361 */ /*GILLT_nxv1s1*//*Label 29692*/ GIMT_Encode4(2231061), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225381 */ /*GILLT_nxv2s1*//*Label 29693*/ GIMT_Encode4(2234902), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225401 */ /*GILLT_nxv4s1*//*Label 29694*/ GIMT_Encode4(2238743), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225421 */ /*GILLT_nxv8s1*//*Label 29695*/ GIMT_Encode4(2242584), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225441 */ /*GILLT_nxv16s1*//*Label 29696*/ GIMT_Encode4(2246425), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225457 */ /*GILLT_nxv32s1*//*Label 29697*/ GIMT_Encode4(2249306), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2225469 */ /*GILLT_nxv64s1*//*Label 29698*/ GIMT_Encode4(2251227),
     /* 2225473 */ // Label 29690: @2225473
     /* 2225473 */ GIM_Try, /*On fail goto*//*Label 29700*/ GIMT_Encode4(2225516), // Rule ID 159 //
     /* 2225478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2225484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225491 */   // MIs[0] Operand 1
     /* 2225491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2225496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225500 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2225504 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] })
     /* 2225504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2225514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225515 */   // GIR_Coverage, 159,
     /* 2225515 */   GIR_EraseRootFromParent_Done,
     /* 2225516 */ // Label 29700: @2225516
     /* 2225516 */ GIM_Try, /*On fail goto*//*Label 29701*/ GIMT_Encode4(2225559), // Rule ID 64927 //
     /* 2225521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225527 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2225530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225534 */   // MIs[0] Operand 1
     /* 2225534 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2225539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225543 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2225547 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2225547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225552 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2225557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225558 */   // GIR_Coverage, 64927,
     /* 2225558 */   GIR_EraseRootFromParent_Done,
     /* 2225559 */ // Label 29701: @2225559
     /* 2225559 */ GIM_Try, /*On fail goto*//*Label 29702*/ GIMT_Encode4(2225605), // Rule ID 64933 //
     /* 2225564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2225573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225577 */   // MIs[0] Operand 1
     /* 2225577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2225582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225586 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2225590 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2225590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2225593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225595 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2225601 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225604 */   // GIR_Coverage, 64933,
     /* 2225604 */   GIR_EraseRootFromParent_Done,
     /* 2225605 */ // Label 29702: @2225605
     /* 2225605 */ GIM_Try, /*On fail goto*//*Label 29703*/ GIMT_Encode4(2225648), // Rule ID 64963 //
     /* 2225610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2225616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225623 */   // MIs[0] Operand 1
     /* 2225623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2225628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225632 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2225636 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 1:{ *:[i32] })
     /* 2225636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225641 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2225646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225647 */   // GIR_Coverage, 64963,
     /* 2225647 */   GIR_EraseRootFromParent_Done,
     /* 2225648 */ // Label 29703: @2225648
     /* 2225648 */ GIM_Try, /*On fail goto*//*Label 29704*/ GIMT_Encode4(2225694), // Rule ID 64969 //
     /* 2225653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2225659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225666 */   // MIs[0] Operand 1
     /* 2225666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2225671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225675 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2225679 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2225679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2225682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225684 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2225690 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225693 */   // GIR_Coverage, 64969,
     /* 2225693 */   GIR_EraseRootFromParent_Done,
     /* 2225694 */ // Label 29704: @2225694
     /* 2225694 */ GIM_Try, /*On fail goto*//*Label 29705*/ GIMT_Encode4(2225747), // Rule ID 149 //
     /* 2225699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2225705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225712 */   // MIs[0] Operand 1
     /* 2225712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2225717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2225725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2225729 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2225733 */   // MIs[1] Operand 1
     /* 2225733 */   // No operand predicates
     /* 2225733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2225735 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2225735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2225738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225740 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225742 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2225745 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225746 */   // GIR_Coverage, 149,
     /* 2225746 */   GIR_EraseRootFromParent_Done,
     /* 2225747 */ // Label 29705: @2225747
     /* 2225747 */ GIM_Try, /*On fail goto*//*Label 29706*/ GIMT_Encode4(2225800), // Rule ID 153 //
     /* 2225752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2225758 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225765 */   // MIs[0] Operand 1
     /* 2225765 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2225770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225774 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2225778 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2225782 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2225786 */   // MIs[1] Operand 1
     /* 2225786 */   // No operand predicates
     /* 2225786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2225788 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm)
     /* 2225788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225793 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225795 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2225798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225799 */   // GIR_Coverage, 153,
     /* 2225799 */   GIR_EraseRootFromParent_Done,
     /* 2225800 */ // Label 29706: @2225800
     /* 2225800 */ GIM_Try, /*On fail goto*//*Label 29707*/ GIMT_Encode4(2225853), // Rule ID 64919 //
     /* 2225805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225818 */   // MIs[0] Operand 1
     /* 2225818 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2225823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225827 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2225831 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2225835 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2225839 */   // MIs[1] Operand 1
     /* 2225839 */   // No operand predicates
     /* 2225839 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2225841 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2225841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225846 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225848 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2225851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225852 */   // GIR_Coverage, 64919,
     /* 2225852 */   GIR_EraseRootFromParent_Done,
     /* 2225853 */ // Label 29707: @2225853
     /* 2225853 */ GIM_Try, /*On fail goto*//*Label 29708*/ GIMT_Encode4(2225906), // Rule ID 64923 //
     /* 2225858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225871 */   // MIs[0] Operand 1
     /* 2225871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2225876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225880 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2225884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2225888 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2225892 */   // MIs[1] Operand 1
     /* 2225892 */   // No operand predicates
     /* 2225892 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2225894 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm12)
     /* 2225894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2225897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225899 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2225901 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2225904 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225905 */   // GIR_Coverage, 64923,
     /* 2225905 */   GIR_EraseRootFromParent_Done,
     /* 2225906 */ // Label 29708: @2225906
     /* 2225906 */ GIM_Try, /*On fail goto*//*Label 29709*/ GIMT_Encode4(2225983), // Rule ID 64929 //
     /* 2225911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225917 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225924 */   // MIs[0] Operand 1
     /* 2225924 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2225929 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2225933 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2225937 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2225941 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2225945 */   // MIs[1] Operand 1
     /* 2225945 */   // No operand predicates
     /* 2225945 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2225947 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2225947 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2225950 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2225954 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2225959 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2225963 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2225968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2225970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2225973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2225975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2225978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2225981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2225982 */   // GIR_Coverage, 64929,
     /* 2225982 */   GIR_EraseRootFromParent_Done,
     /* 2225983 */ // Label 29709: @2225983
     /* 2225983 */ GIM_Try, /*On fail goto*//*Label 29710*/ GIMT_Encode4(2226063), // Rule ID 64935 //
     /* 2225988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2225991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2225994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2225997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226001 */   // MIs[0] Operand 1
     /* 2226001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2226006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226018 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2226022 */   // MIs[1] Operand 1
     /* 2226022 */   // No operand predicates
     /* 2226022 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226024 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2226024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2226031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226036 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226040 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2226045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2226050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226052 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2226058 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226062 */   // GIR_Coverage, 64935,
     /* 2226062 */   GIR_EraseRootFromParent_Done,
     /* 2226063 */ // Label 29710: @2226063
     /* 2226063 */ GIM_Try, /*On fail goto*//*Label 29711*/ GIMT_Encode4(2226140), // Rule ID 64939 //
     /* 2226068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2226074 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226081 */   // MIs[0] Operand 1
     /* 2226081 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2226086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226098 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2226102 */   // MIs[1] Operand 1
     /* 2226102 */   // No operand predicates
     /* 2226102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226104 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2226104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226120 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226139 */   // GIR_Coverage, 64939,
     /* 2226139 */   GIR_EraseRootFromParent_Done,
     /* 2226140 */ // Label 29711: @2226140
     /* 2226140 */ GIM_Try, /*On fail goto*//*Label 29712*/ GIMT_Encode4(2226217), // Rule ID 64943 //
     /* 2226145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2226151 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226158 */   // MIs[0] Operand 1
     /* 2226158 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2226163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226175 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2226179 */   // MIs[1] Operand 1
     /* 2226179 */   // No operand predicates
     /* 2226179 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226181 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2226181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2226188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226193 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226197 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226216 */   // GIR_Coverage, 64943,
     /* 2226216 */   GIR_EraseRootFromParent_Done,
     /* 2226217 */ // Label 29712: @2226217
     /* 2226217 */ GIM_Try, /*On fail goto*//*Label 29713*/ GIMT_Encode4(2226292), // Rule ID 64947 //
     /* 2226222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226235 */   // MIs[0] Operand 1
     /* 2226235 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2226240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226244 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226248 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226252 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2226256 */   // MIs[1] Operand 1
     /* 2226256 */   // No operand predicates
     /* 2226256 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226258 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2226258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226270 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226274 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2226277 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226291 */   // GIR_Coverage, 64947,
     /* 2226291 */   GIR_EraseRootFromParent_Done,
     /* 2226292 */ // Label 29713: @2226292
     /* 2226292 */ GIM_Try, /*On fail goto*//*Label 29714*/ GIMT_Encode4(2226367), // Rule ID 64951 //
     /* 2226297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2226303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226310 */   // MIs[0] Operand 1
     /* 2226310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2226315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226327 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2226331 */   // MIs[1] Operand 1
     /* 2226331 */   // No operand predicates
     /* 2226331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226333 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2226333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2226340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226345 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226349 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2226352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226359 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226366 */   // GIR_Coverage, 64951,
     /* 2226366 */   GIR_EraseRootFromParent_Done,
     /* 2226367 */ // Label 29714: @2226367
     /* 2226367 */ GIM_Try, /*On fail goto*//*Label 29715*/ GIMT_Encode4(2226422), // Rule ID 64955 //
     /* 2226372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2226378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226385 */   // MIs[0] Operand 1
     /* 2226385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2226390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226394 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226398 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226402 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2226406 */   // MIs[1] Operand 1
     /* 2226406 */   // No operand predicates
     /* 2226406 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226408 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2226408 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226411 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226413 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2226415 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226421 */   // GIR_Coverage, 64955,
     /* 2226421 */   GIR_EraseRootFromParent_Done,
     /* 2226422 */ // Label 29715: @2226422
     /* 2226422 */ GIM_Try, /*On fail goto*//*Label 29716*/ GIMT_Encode4(2226477), // Rule ID 64959 //
     /* 2226427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2226433 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226440 */   // MIs[0] Operand 1
     /* 2226440 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2226445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226449 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226453 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226457 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2226461 */   // MIs[1] Operand 1
     /* 2226461 */   // No operand predicates
     /* 2226461 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226463 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2226463 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2226466 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226468 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2226470 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226476 */   // GIR_Coverage, 64959,
     /* 2226476 */   GIR_EraseRootFromParent_Done,
     /* 2226477 */ // Label 29716: @2226477
     /* 2226477 */ GIM_Try, /*On fail goto*//*Label 29717*/ GIMT_Encode4(2226554), // Rule ID 64965 //
     /* 2226482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226495 */   // MIs[0] Operand 1
     /* 2226495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2226500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226512 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2226516 */   // MIs[1] Operand 1
     /* 2226516 */   // No operand predicates
     /* 2226516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226518 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i32] })
     /* 2226518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2226525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226530 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226534 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2226539 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226553 */   // GIR_Coverage, 64965,
     /* 2226553 */   GIR_EraseRootFromParent_Done,
     /* 2226554 */ // Label 29717: @2226554
     /* 2226554 */ GIM_Try, /*On fail goto*//*Label 29718*/ GIMT_Encode4(2226634), // Rule ID 64971 //
     /* 2226559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226572 */   // MIs[0] Operand 1
     /* 2226572 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2226577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226581 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226585 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226589 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2226593 */   // MIs[1] Operand 1
     /* 2226593 */   // No operand predicates
     /* 2226593 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226595 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (ADDI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (NegImm:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2226595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2226602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226611 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2226616 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226618 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2226621 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226623 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2226629 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226633 */   // GIR_Coverage, 64971,
     /* 2226633 */   GIR_EraseRootFromParent_Done,
     /* 2226634 */ // Label 29718: @2226634
     /* 2226634 */ GIM_Try, /*On fail goto*//*Label 29719*/ GIMT_Encode4(2226711), // Rule ID 64975 //
     /* 2226639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226645 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226652 */   // MIs[0] Operand 1
     /* 2226652 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2226657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226661 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226665 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226669 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2226673 */   // MIs[1] Operand 1
     /* 2226673 */   // No operand predicates
     /* 2226673 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226675 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i32] })
     /* 2226675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226691 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226710 */   // GIR_Coverage, 64975,
     /* 2226710 */   GIR_EraseRootFromParent_Done,
     /* 2226711 */ // Label 29719: @2226711
     /* 2226711 */ GIM_Try, /*On fail goto*//*Label 29720*/ GIMT_Encode4(2226788), // Rule ID 64979 //
     /* 2226716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226729 */   // MIs[0] Operand 1
     /* 2226729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2226734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226738 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226742 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226746 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2226750 */   // MIs[1] Operand 1
     /* 2226750 */   // No operand predicates
     /* 2226750 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226752 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i32] })
     /* 2226752 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226755 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2226759 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226764 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226768 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226773 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226786 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226787 */   // GIR_Coverage, 64979,
     /* 2226787 */   GIR_EraseRootFromParent_Done,
     /* 2226788 */ // Label 29720: @2226788
     /* 2226788 */ GIM_Try, /*On fail goto*//*Label 29721*/ GIMT_Encode4(2226863), // Rule ID 64983 //
     /* 2226793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226799 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226806 */   // MIs[0] Operand 1
     /* 2226806 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2226811 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226815 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226819 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226823 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2226827 */   // MIs[1] Operand 1
     /* 2226827 */   // No operand predicates
     /* 2226827 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226829 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTIU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2226829 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226832 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226836 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226841 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226845 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2226848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226862 */   // GIR_Coverage, 64983,
     /* 2226862 */   GIR_EraseRootFromParent_Done,
     /* 2226863 */ // Label 29721: @2226863
     /* 2226863 */ GIM_Try, /*On fail goto*//*Label 29722*/ GIMT_Encode4(2226938), // Rule ID 64987 //
     /* 2226868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226881 */   // MIs[0] Operand 1
     /* 2226881 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2226886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226898 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2226902 */   // MIs[1] Operand 1
     /* 2226902 */   // No operand predicates
     /* 2226902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226904 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTI:{ *:[i16] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i32] })
     /* 2226904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2226907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2226911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2226916 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2226920 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2226923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2226925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2226928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2226933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2226936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226937 */   // GIR_Coverage, 64987,
     /* 2226937 */   GIR_EraseRootFromParent_Done,
     /* 2226938 */ // Label 29722: @2226938
     /* 2226938 */ GIM_Try, /*On fail goto*//*Label 29723*/ GIMT_Encode4(2226993), // Rule ID 64991 //
     /* 2226943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2226946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2226949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2226952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226956 */   // MIs[0] Operand 1
     /* 2226956 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2226961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2226965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2226969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2226973 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2226977 */   // MIs[1] Operand 1
     /* 2226977 */   // No operand predicates
     /* 2226977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2226979 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2226979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2226982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2226984 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2226986 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2226991 */   GIR_RootConstrainSelectedInstOperands,
     /* 2226992 */   // GIR_Coverage, 64991,
     /* 2226992 */   GIR_EraseRootFromParent_Done,
     /* 2226993 */ // Label 29723: @2226993
     /* 2226993 */ GIM_Try, /*On fail goto*//*Label 29724*/ GIMT_Encode4(2227048), // Rule ID 64995 //
     /* 2226998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227011 */   // MIs[0] Operand 1
     /* 2227011 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2227016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227020 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2227024 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2227028 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2227032 */   // MIs[1] Operand 1
     /* 2227032 */   // No operand predicates
     /* 2227032 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2227034 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i32] } GPR:{ *:[i32] }:$rs1, (ImmPlus1:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2227034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2227037 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227039 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227041 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2227046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227047 */   // GIR_Coverage, 64995,
     /* 2227047 */   GIR_EraseRootFromParent_Done,
     /* 2227048 */ // Label 29724: @2227048
     /* 2227048 */ GIM_Try, /*On fail goto*//*Label 29725*/ GIMT_Encode4(2227090), // Rule ID 64431 //
     /* 2227053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2227056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227066 */   // MIs[0] Operand 1
     /* 2227066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2227071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227079 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2227082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227088 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227089 */   // GIR_Coverage, 64431,
     /* 2227089 */   GIR_EraseRootFromParent_Done,
     /* 2227090 */ // Label 29725: @2227090
     /* 2227090 */ GIM_Try, /*On fail goto*//*Label 29726*/ GIMT_Encode4(2227132), // Rule ID 64433 //
     /* 2227095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2227098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227101 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227108 */   // MIs[0] Operand 1
     /* 2227108 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2227113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227117 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227121 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2227124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227128 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227130 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227131 */   // GIR_Coverage, 64433,
     /* 2227131 */   GIR_EraseRootFromParent_Done,
     /* 2227132 */ // Label 29726: @2227132
     /* 2227132 */ GIM_Try, /*On fail goto*//*Label 29727*/ GIMT_Encode4(2227174), // Rule ID 147 //
     /* 2227137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227143 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227150 */   // MIs[0] Operand 1
     /* 2227150 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2227155 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227159 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227163 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227170 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227173 */   // GIR_Coverage, 147,
     /* 2227173 */   GIR_EraseRootFromParent_Done,
     /* 2227174 */ // Label 29727: @2227174
     /* 2227174 */ GIM_Try, /*On fail goto*//*Label 29728*/ GIMT_Encode4(2227216), // Rule ID 151 //
     /* 2227179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227192 */   // MIs[0] Operand 1
     /* 2227192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2227197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227205 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227215 */   // GIR_Coverage, 151,
     /* 2227215 */   GIR_EraseRootFromParent_Done,
     /* 2227216 */ // Label 29728: @2227216
     /* 2227216 */ GIM_Try, /*On fail goto*//*Label 29729*/ GIMT_Encode4(2227258), // Rule ID 64921 //
     /* 2227221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227234 */   // MIs[0] Operand 1
     /* 2227234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2227239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227247 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227257 */   // GIR_Coverage, 64921,
     /* 2227257 */   GIR_EraseRootFromParent_Done,
     /* 2227258 */ // Label 29729: @2227258
     /* 2227258 */ GIM_Try, /*On fail goto*//*Label 29730*/ GIMT_Encode4(2227300), // Rule ID 64925 //
     /* 2227263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227269 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227276 */   // MIs[0] Operand 1
     /* 2227276 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2227281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227285 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227289 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2227289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227294 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227296 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227298 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227299 */   // GIR_Coverage, 64925,
     /* 2227299 */   GIR_EraseRootFromParent_Done,
     /* 2227300 */ // Label 29730: @2227300
     /* 2227300 */ GIM_Try, /*On fail goto*//*Label 29731*/ GIMT_Encode4(2227366), // Rule ID 64931 //
     /* 2227305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227311 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227318 */   // MIs[0] Operand 1
     /* 2227318 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2227323 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227327 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227331 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2227331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2227338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227347 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2227356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227365 */   // GIR_Coverage, 64931,
     /* 2227365 */   GIR_EraseRootFromParent_Done,
     /* 2227366 */ // Label 29731: @2227366
     /* 2227366 */ GIM_Try, /*On fail goto*//*Label 29732*/ GIMT_Encode4(2227435), // Rule ID 64937 //
     /* 2227371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227377 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227384 */   // MIs[0] Operand 1
     /* 2227384 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2227389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227393 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227397 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2227397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2227404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227409 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227413 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227417 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227424 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2227430 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227434 */   // GIR_Coverage, 64937,
     /* 2227434 */   GIR_EraseRootFromParent_Done,
     /* 2227435 */ // Label 29732: @2227435
     /* 2227435 */ GIM_Try, /*On fail goto*//*Label 29733*/ GIMT_Encode4(2227477), // Rule ID 64941 //
     /* 2227440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227446 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227453 */   // MIs[0] Operand 1
     /* 2227453 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2227458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227462 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227466 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2227466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227471 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227473 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227475 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227476 */   // GIR_Coverage, 64941,
     /* 2227476 */   GIR_EraseRootFromParent_Done,
     /* 2227477 */ // Label 29733: @2227477
     /* 2227477 */ GIM_Try, /*On fail goto*//*Label 29734*/ GIMT_Encode4(2227519), // Rule ID 64945 //
     /* 2227482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227488 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227495 */   // MIs[0] Operand 1
     /* 2227495 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2227500 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227504 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227508 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2227508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227513 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227515 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227518 */   // GIR_Coverage, 64945,
     /* 2227518 */   GIR_EraseRootFromParent_Done,
     /* 2227519 */ // Label 29734: @2227519
     /* 2227519 */ GIM_Try, /*On fail goto*//*Label 29735*/ GIMT_Encode4(2227585), // Rule ID 64949 //
     /* 2227524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227537 */   // MIs[0] Operand 1
     /* 2227537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2227542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227550 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2227550 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227553 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227557 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227562 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227566 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2227575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227577 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227584 */   // GIR_Coverage, 64949,
     /* 2227584 */   GIR_EraseRootFromParent_Done,
     /* 2227585 */ // Label 29735: @2227585
     /* 2227585 */ GIM_Try, /*On fail goto*//*Label 29736*/ GIMT_Encode4(2227651), // Rule ID 64953 //
     /* 2227590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227603 */   // MIs[0] Operand 1
     /* 2227603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2227608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227616 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2227616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227628 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227632 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227636 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2227641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227643 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227650 */   // GIR_Coverage, 64953,
     /* 2227650 */   GIR_EraseRootFromParent_Done,
     /* 2227651 */ // Label 29736: @2227651
     /* 2227651 */ GIM_Try, /*On fail goto*//*Label 29737*/ GIMT_Encode4(2227717), // Rule ID 64957 //
     /* 2227656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227662 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227669 */   // MIs[0] Operand 1
     /* 2227669 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2227674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227678 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227682 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2227682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227698 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2227707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227716 */   // GIR_Coverage, 64957,
     /* 2227716 */   GIR_EraseRootFromParent_Done,
     /* 2227717 */ // Label 29737: @2227717
     /* 2227717 */ GIM_Try, /*On fail goto*//*Label 29738*/ GIMT_Encode4(2227783), // Rule ID 64961 //
     /* 2227722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s32,
     /* 2227728 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s32,
     /* 2227731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227735 */   // MIs[0] Operand 1
     /* 2227735 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2227740 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227744 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227748 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2227748 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227751 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227755 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227760 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227764 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2227773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227781 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227782 */   // GIR_Coverage, 64961,
     /* 2227782 */   GIR_EraseRootFromParent_Done,
     /* 2227783 */ // Label 29738: @2227783
     /* 2227783 */ GIM_Try, /*On fail goto*//*Label 29739*/ GIMT_Encode4(2227849), // Rule ID 64967 //
     /* 2227788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227794 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227801 */   // MIs[0] Operand 1
     /* 2227801 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2227806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227810 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227814 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i32] } (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2227814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2227821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227826 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227830 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227834 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2227839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227844 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2227847 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227848 */   // GIR_Coverage, 64967,
     /* 2227848 */   GIR_EraseRootFromParent_Done,
     /* 2227849 */ // Label 29739: @2227849
     /* 2227849 */ GIM_Try, /*On fail goto*//*Label 29740*/ GIMT_Encode4(2227918), // Rule ID 64973 //
     /* 2227854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227860 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227867 */   // MIs[0] Operand 1
     /* 2227867 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2227872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227876 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227880 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i32] } X0:{ *:[i32] }, (XOR:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2))
     /* 2227880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2227883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2227887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2227892 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2227896 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2227900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2227902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2227913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2227916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227917 */   // GIR_Coverage, 64973,
     /* 2227917 */   GIR_EraseRootFromParent_Done,
     /* 2227918 */ // Label 29740: @2227918
     /* 2227918 */ GIM_Try, /*On fail goto*//*Label 29741*/ GIMT_Encode4(2227960), // Rule ID 64977 //
     /* 2227923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227936 */   // MIs[0] Operand 1
     /* 2227936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2227941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227949 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2227949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2227952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2227958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2227959 */   // GIR_Coverage, 64977,
     /* 2227959 */   GIR_EraseRootFromParent_Done,
     /* 2227960 */ // Label 29741: @2227960
     /* 2227960 */ GIM_Try, /*On fail goto*//*Label 29742*/ GIMT_Encode4(2228002), // Rule ID 64981 //
     /* 2227965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2227968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2227971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2227974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227978 */   // MIs[0] Operand 1
     /* 2227978 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2227983 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227987 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2227991 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1)
     /* 2227991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2227994 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2227996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2227998 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228000 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228001 */   // GIR_Coverage, 64981,
     /* 2228001 */   GIR_EraseRootFromParent_Done,
     /* 2228002 */ // Label 29742: @2228002
     /* 2228002 */ GIM_Try, /*On fail goto*//*Label 29743*/ GIMT_Encode4(2228068), // Rule ID 64985 //
     /* 2228007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228013 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2228016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228020 */   // MIs[0] Operand 1
     /* 2228020 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2228025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228029 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228033 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2228033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2228040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228045 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228049 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2228053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2228058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228067 */   // GIR_Coverage, 64985,
     /* 2228067 */   GIR_EraseRootFromParent_Done,
     /* 2228068 */ // Label 29743: @2228068
     /* 2228068 */ GIM_Try, /*On fail goto*//*Label 29744*/ GIMT_Encode4(2228134), // Rule ID 64989 //
     /* 2228073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228079 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2228082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228086 */   // MIs[0] Operand 1
     /* 2228086 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2228091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228095 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228099 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2), 1:{ *:[i32] })
     /* 2228099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2228106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228111 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228115 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2228119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2228124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228132 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228133 */   // GIR_Coverage, 64989,
     /* 2228133 */   GIR_EraseRootFromParent_Done,
     /* 2228134 */ // Label 29744: @2228134
     /* 2228134 */ GIM_Try, /*On fail goto*//*Label 29745*/ GIMT_Encode4(2228200), // Rule ID 64993 //
     /* 2228139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228145 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2228148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228152 */   // MIs[0] Operand 1
     /* 2228152 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2228157 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228161 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228165 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLTU:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2228165 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228168 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2228172 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228177 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2228181 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2228190 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228192 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228198 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228199 */   // GIR_Coverage, 64993,
     /* 2228199 */   GIR_EraseRootFromParent_Done,
     /* 2228200 */ // Label 29745: @2228200
     /* 2228200 */ GIM_Try, /*On fail goto*//*Label 29746*/ GIMT_Encode4(2228266), // Rule ID 64997 //
     /* 2228205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode1),
     /* 2228208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2228211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2228214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228218 */   // MIs[0] Operand 1
     /* 2228218 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2228223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228227 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228231 */   // (setcc:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i32] } (SLT:{ *:[i16] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1), 1:{ *:[i32] })
     /* 2228231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2228238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2228247 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2228256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228265 */   // GIR_Coverage, 64997,
     /* 2228265 */   GIR_EraseRootFromParent_Done,
     /* 2228266 */ // Label 29746: @2228266
     /* 2228266 */ GIM_Reject,
     /* 2228267 */ // Label 29691: @2228267
     /* 2228267 */ GIM_Try, /*On fail goto*//*Label 29747*/ GIMT_Encode4(2228310), // Rule ID 158 //
     /* 2228272 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228285 */   // MIs[0] Operand 1
     /* 2228285 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2228290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228294 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, uint8_t(-1),
     /* 2228298 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] })
     /* 2228298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228303 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2228308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228309 */   // GIR_Coverage, 158,
     /* 2228309 */   GIR_EraseRootFromParent_Done,
     /* 2228310 */ // Label 29747: @2228310
     /* 2228310 */ GIM_Try, /*On fail goto*//*Label 29748*/ GIMT_Encode4(2228353), // Rule ID 64926 //
     /* 2228315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2228324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228328 */   // MIs[0] Operand 1
     /* 2228328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2228333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228337 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2228341 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2228341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228351 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228352 */   // GIR_Coverage, 64926,
     /* 2228352 */   GIR_EraseRootFromParent_Done,
     /* 2228353 */ // Label 29748: @2228353
     /* 2228353 */ GIM_Try, /*On fail goto*//*Label 29749*/ GIMT_Encode4(2228399), // Rule ID 64932 //
     /* 2228358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228364 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2228367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228371 */   // MIs[0] Operand 1
     /* 2228371 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2228376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228380 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2228384 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2228384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2228387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228389 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2228395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228397 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228398 */   // GIR_Coverage, 64932,
     /* 2228398 */   GIR_EraseRootFromParent_Done,
     /* 2228399 */ // Label 29749: @2228399
     /* 2228399 */ GIM_Try, /*On fail goto*//*Label 29750*/ GIMT_Encode4(2228442), // Rule ID 64962 //
     /* 2228404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228410 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228417 */   // MIs[0] Operand 1
     /* 2228417 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2228422 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228426 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2228430 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 1:{ *:[i64] })
     /* 2228430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228435 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228440 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228441 */   // GIR_Coverage, 64962,
     /* 2228441 */   GIR_EraseRootFromParent_Done,
     /* 2228442 */ // Label 29750: @2228442
     /* 2228442 */ GIM_Try, /*On fail goto*//*Label 29751*/ GIMT_Encode4(2228488), // Rule ID 64968 //
     /* 2228447 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228453 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228460 */   // MIs[0] Operand 1
     /* 2228460 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2228465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228469 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2228473 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, 0:{ *:[i64] }, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2228473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2228476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2228484 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228486 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228487 */   // GIR_Coverage, 64968,
     /* 2228487 */   GIR_EraseRootFromParent_Done,
     /* 2228488 */ // Label 29751: @2228488
     /* 2228488 */ GIM_Try, /*On fail goto*//*Label 29752*/ GIMT_Encode4(2228541), // Rule ID 148 //
     /* 2228493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228506 */   // MIs[0] Operand 1
     /* 2228506 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2228511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228523 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2228527 */   // MIs[1] Operand 1
     /* 2228527 */   // No operand predicates
     /* 2228527 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228529 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2228529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2228532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228536 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228540 */   // GIR_Coverage, 148,
     /* 2228540 */   GIR_EraseRootFromParent_Done,
     /* 2228541 */ // Label 29752: @2228541
     /* 2228541 */ GIM_Try, /*On fail goto*//*Label 29753*/ GIMT_Encode4(2228594), // Rule ID 152 //
     /* 2228546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2228552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228559 */   // MIs[0] Operand 1
     /* 2228559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2228564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228568 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228572 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228576 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2228580 */   // MIs[1] Operand 1
     /* 2228580 */   // No operand predicates
     /* 2228580 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228582 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm)
     /* 2228582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228589 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2228592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228593 */   // GIR_Coverage, 152,
     /* 2228593 */   GIR_EraseRootFromParent_Done,
     /* 2228594 */ // Label 29753: @2228594
     /* 2228594 */ GIM_Try, /*On fail goto*//*Label 29754*/ GIMT_Encode4(2228647), // Rule ID 64918 //
     /* 2228599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228612 */   // MIs[0] Operand 1
     /* 2228612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2228617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2228633 */   // MIs[1] Operand 1
     /* 2228633 */   // No operand predicates
     /* 2228633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228635 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETULT:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2228635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228640 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2228645 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228646 */   // GIR_Coverage, 64918,
     /* 2228646 */   GIR_EraseRootFromParent_Done,
     /* 2228647 */ // Label 29754: @2228647
     /* 2228647 */ GIM_Try, /*On fail goto*//*Label 29755*/ GIMT_Encode4(2228700), // Rule ID 64922 //
     /* 2228652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228658 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228665 */   // MIs[0] Operand 1
     /* 2228665 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2228670 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228682 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2228686 */   // MIs[1] Operand 1
     /* 2228686 */   // No operand predicates
     /* 2228686 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228688 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12, SETLT:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm12)
     /* 2228688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2228691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228693 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2228695 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm12
     /* 2228698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228699 */   // GIR_Coverage, 64922,
     /* 2228699 */   GIR_EraseRootFromParent_Done,
     /* 2228700 */ // Label 29755: @2228700
     /* 2228700 */ GIM_Try, /*On fail goto*//*Label 29756*/ GIMT_Encode4(2228777), // Rule ID 64928 //
     /* 2228705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228708 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228711 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228718 */   // MIs[0] Operand 1
     /* 2228718 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2228723 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228727 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228731 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228735 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2228739 */   // MIs[1] Operand 1
     /* 2228739 */   // No operand predicates
     /* 2228739 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228741 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2228741 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228744 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2228748 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228753 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228757 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2228762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228769 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228776 */   // GIR_Coverage, 64928,
     /* 2228776 */   GIR_EraseRootFromParent_Done,
     /* 2228777 */ // Label 29756: @2228777
     /* 2228777 */ GIM_Try, /*On fail goto*//*Label 29757*/ GIMT_Encode4(2228857), // Rule ID 64934 //
     /* 2228782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228795 */   // MIs[0] Operand 1
     /* 2228795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2228800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228804 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228808 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228812 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2228816 */   // MIs[1] Operand 1
     /* 2228816 */   // No operand predicates
     /* 2228816 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228818 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2228818 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228821 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2228825 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228830 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228834 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2228839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2228844 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228846 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2228852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228856 */   // GIR_Coverage, 64934,
     /* 2228856 */   GIR_EraseRootFromParent_Done,
     /* 2228857 */ // Label 29757: @2228857
     /* 2228857 */ GIM_Try, /*On fail goto*//*Label 29758*/ GIMT_Encode4(2228934), // Rule ID 64938 //
     /* 2228862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228875 */   // MIs[0] Operand 1
     /* 2228875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2228880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228884 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228888 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228892 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2228896 */   // MIs[1] Operand 1
     /* 2228896 */   // No operand predicates
     /* 2228896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228898 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2228898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2228905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228910 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228914 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2228919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2228924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2228926 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2228929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2228932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2228933 */   // GIR_Coverage, 64938,
     /* 2228933 */   GIR_EraseRootFromParent_Done,
     /* 2228934 */ // Label 29758: @2228934
     /* 2228934 */ GIM_Try, /*On fail goto*//*Label 29759*/ GIMT_Encode4(2229011), // Rule ID 64942 //
     /* 2228939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2228942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2228945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2228948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228952 */   // MIs[0] Operand 1
     /* 2228952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2228957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2228961 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2228965 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2228969 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2228973 */   // MIs[1] Operand 1
     /* 2228973 */   // No operand predicates
     /* 2228973 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2228975 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2228975 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2228978 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2228982 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2228987 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2228991 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2228996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2228998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229003 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229010 */   // GIR_Coverage, 64942,
     /* 2229010 */   GIR_EraseRootFromParent_Done,
     /* 2229011 */ // Label 29759: @2229011
     /* 2229011 */ GIM_Try, /*On fail goto*//*Label 29760*/ GIMT_Encode4(2229086), // Rule ID 64946 //
     /* 2229016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229022 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229029 */   // MIs[0] Operand 1
     /* 2229029 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2229034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229038 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229042 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229046 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2229050 */   // MIs[1] Operand 1
     /* 2229050 */   // No operand predicates
     /* 2229050 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229052 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2229052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229064 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229068 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2229071 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229073 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229076 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229084 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229085 */   // GIR_Coverage, 64946,
     /* 2229085 */   GIR_EraseRootFromParent_Done,
     /* 2229086 */ // Label 29760: @2229086
     /* 2229086 */ GIM_Try, /*On fail goto*//*Label 29761*/ GIMT_Encode4(2229161), // Rule ID 64950 //
     /* 2229091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2229097 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229104 */   // MIs[0] Operand 1
     /* 2229104 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2229109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229121 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2229125 */   // MIs[1] Operand 1
     /* 2229125 */   // No operand predicates
     /* 2229125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229127 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2229127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2229134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229139 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229143 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2229146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229160 */   // GIR_Coverage, 64950,
     /* 2229160 */   GIR_EraseRootFromParent_Done,
     /* 2229161 */ // Label 29761: @2229161
     /* 2229161 */ GIM_Try, /*On fail goto*//*Label 29762*/ GIMT_Encode4(2229216), // Rule ID 64954 //
     /* 2229166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2229172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229179 */   // MIs[0] Operand 1
     /* 2229179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2229184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229188 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229192 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229196 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2229200 */   // MIs[1] Operand 1
     /* 2229200 */   // No operand predicates
     /* 2229200 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229202 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2229202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229207 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229209 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229215 */   // GIR_Coverage, 64954,
     /* 2229215 */   GIR_EraseRootFromParent_Done,
     /* 2229216 */ // Label 29762: @2229216
     /* 2229216 */ GIM_Try, /*On fail goto*//*Label 29763*/ GIMT_Encode4(2229271), // Rule ID 64958 //
     /* 2229221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2229227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229234 */   // MIs[0] Operand 1
     /* 2229234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2229239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229243 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229251 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2229255 */   // MIs[1] Operand 1
     /* 2229255 */   // No operand predicates
     /* 2229255 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229257 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2229257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2229260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229262 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229264 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229270 */   // GIR_Coverage, 64958,
     /* 2229270 */   GIR_EraseRootFromParent_Done,
     /* 2229271 */ // Label 29763: @2229271
     /* 2229271 */ GIM_Try, /*On fail goto*//*Label 29764*/ GIMT_Encode4(2229348), // Rule ID 64964 //
     /* 2229276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229289 */   // MIs[0] Operand 1
     /* 2229289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2229294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229306 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2229310 */   // MIs[1] Operand 1
     /* 2229310 */   // No operand predicates
     /* 2229310 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229312 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)), 1:{ *:[i64] })
     /* 2229312 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229315 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2229319 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229324 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229328 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2229333 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229340 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229346 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229347 */   // GIR_Coverage, 64964,
     /* 2229347 */   GIR_EraseRootFromParent_Done,
     /* 2229348 */ // Label 29764: @2229348
     /* 2229348 */ GIM_Try, /*On fail goto*//*Label 29765*/ GIMT_Encode4(2229428), // Rule ID 64970 //
     /* 2229353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229359 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229366 */   // MIs[0] Operand 1
     /* 2229366 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2229371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229375 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229379 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229383 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Plus1),
     /* 2229387 */   // MIs[1] Operand 1
     /* 2229387 */   // No operand predicates
     /* 2229387 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229389 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (ADDI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (NegImm:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Plus1>>:$imm12)))
     /* 2229389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::ADDI),
     /* 2229396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229401 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229405 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderNegImm), // imm12
     /* 2229410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2229415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229417 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2229423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229427 */   // GIR_Coverage, 64970,
     /* 2229427 */   GIR_EraseRootFromParent_Done,
     /* 2229428 */ // Label 29765: @2229428
     /* 2229428 */ GIM_Try, /*On fail goto*//*Label 29766*/ GIMT_Encode4(2229505), // Rule ID 64974 //
     /* 2229433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229446 */   // MIs[0] Operand 1
     /* 2229446 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2229451 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229455 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229459 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229463 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2229467 */   // MIs[1] Operand 1
     /* 2229467 */   // No operand predicates
     /* 2229467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229469 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETUGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm)), 1:{ *:[i64] })
     /* 2229469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229485 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229503 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229504 */   // GIR_Coverage, 64974,
     /* 2229504 */   GIR_EraseRootFromParent_Done,
     /* 2229505 */ // Label 29766: @2229505
     /* 2229505 */ GIM_Try, /*On fail goto*//*Label 29767*/ GIMT_Encode4(2229582), // Rule ID 64978 //
     /* 2229510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229516 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229523 */   // MIs[0] Operand 1
     /* 2229523 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2229528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229532 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229536 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229540 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2229544 */   // MIs[1] Operand 1
     /* 2229544 */   // No operand predicates
     /* 2229544 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229546 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETGT:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm)), 1:{ *:[i64] })
     /* 2229546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2229553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229562 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229581 */   // GIR_Coverage, 64978,
     /* 2229581 */   GIR_EraseRootFromParent_Done,
     /* 2229582 */ // Label 29767: @2229582
     /* 2229582 */ GIM_Try, /*On fail goto*//*Label 29768*/ GIMT_Encode4(2229657), // Rule ID 64982 //
     /* 2229587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229600 */   // MIs[0] Operand 1
     /* 2229600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2229605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229609 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229613 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229617 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2229621 */   // MIs[1] Operand 1
     /* 2229621 */   // No operand predicates
     /* 2229621 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229623 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTIU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2229623 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229626 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229630 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229635 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229639 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2229642 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229649 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229656 */   // GIR_Coverage, 64982,
     /* 2229656 */   GIR_EraseRootFromParent_Done,
     /* 2229657 */ // Label 29768: @2229657
     /* 2229657 */ GIM_Try, /*On fail goto*//*Label 29769*/ GIMT_Encode4(2229732), // Rule ID 64986 //
     /* 2229662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229668 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229675 */   // MIs[0] Operand 1
     /* 2229675 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2229680 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229684 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229688 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229692 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12),
     /* 2229696 */   // MIs[1] Operand 1
     /* 2229696 */   // No operand predicates
     /* 2229696 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229698 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTI:{ *:[i16] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12>>:$imm), 1:{ *:[i64] })
     /* 2229698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2229701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2229705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2229710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2229714 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 2229717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2229719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2229722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2229727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2229730 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229731 */   // GIR_Coverage, 64986,
     /* 2229731 */   GIR_EraseRootFromParent_Done,
     /* 2229732 */ // Label 29769: @2229732
     /* 2229732 */ GIM_Try, /*On fail goto*//*Label 29770*/ GIMT_Encode4(2229787), // Rule ID 64990 //
     /* 2229737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229750 */   // MIs[0] Operand 1
     /* 2229750 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2229755 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229759 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229767 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1NonzeroNonNeg1),
     /* 2229771 */   // MIs[1] Operand 1
     /* 2229771 */   // No operand predicates
     /* 2229771 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229773 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm, SETULE:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1NonzeroNonNeg1>>:$imm))
     /* 2229773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2229776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229780 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229785 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229786 */   // GIR_Coverage, 64990,
     /* 2229786 */   GIR_EraseRootFromParent_Done,
     /* 2229787 */ // Label 29770: @2229787
     /* 2229787 */ GIM_Try, /*On fail goto*//*Label 29771*/ GIMT_Encode4(2229842), // Rule ID 64994 //
     /* 2229792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229798 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229805 */   // MIs[0] Operand 1
     /* 2229805 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2229810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229814 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2229818 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2229822 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm12Minus1Nonzero),
     /* 2229826 */   // MIs[1] Operand 1
     /* 2229826 */   // No operand predicates
     /* 2229826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2229828 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm, SETLE:{ *:[Other] })  =>  (SLTI:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmPlus1:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_simm12Minus1Nonzero>>:$imm))
     /* 2229828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTI),
     /* 2229831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229833 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229835 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmPlus1), // imm
     /* 2229840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229841 */   // GIR_Coverage, 64994,
     /* 2229841 */   GIR_EraseRootFromParent_Done,
     /* 2229842 */ // Label 29771: @2229842
     /* 2229842 */ GIM_Try, /*On fail goto*//*Label 29772*/ GIMT_Encode4(2229884), // Rule ID 64430 //
     /* 2229847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2229850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229860 */   // MIs[0] Operand 1
     /* 2229860 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2229865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229873 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (CV_SLE:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2229873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLE),
     /* 2229876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229880 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2229882 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229883 */   // GIR_Coverage, 64430,
     /* 2229883 */   GIR_EraseRootFromParent_Done,
     /* 2229884 */ // Label 29772: @2229884
     /* 2229884 */ GIM_Try, /*On fail goto*//*Label 29773*/ GIMT_Encode4(2229926), // Rule ID 64432 //
     /* 2229889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2229892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229902 */   // MIs[0] Operand 1
     /* 2229902 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2229907 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229911 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229915 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (CV_SLEU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2229915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_SLEU),
     /* 2229918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229922 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2229924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229925 */   // GIR_Coverage, 64432,
     /* 2229925 */   GIR_EraseRootFromParent_Done,
     /* 2229926 */ // Label 29773: @2229926
     /* 2229926 */ GIM_Try, /*On fail goto*//*Label 29774*/ GIMT_Encode4(2229968), // Rule ID 146 //
     /* 2229931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229944 */   // MIs[0] Operand 1
     /* 2229944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2229949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229957 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2229957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2229960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2229962 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2229964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2229966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2229967 */   // GIR_Coverage, 146,
     /* 2229967 */   GIR_EraseRootFromParent_Done,
     /* 2229968 */ // Label 29774: @2229968
     /* 2229968 */ GIM_Try, /*On fail goto*//*Label 29775*/ GIMT_Encode4(2230010), // Rule ID 150 //
     /* 2229973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2229976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2229979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2229982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229986 */   // MIs[0] Operand 1
     /* 2229986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2229991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2229999 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2229999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230008 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230009 */   // GIR_Coverage, 150,
     /* 2230009 */   GIR_EraseRootFromParent_Done,
     /* 2230010 */ // Label 29775: @2230010
     /* 2230010 */ GIM_Try, /*On fail goto*//*Label 29776*/ GIMT_Encode4(2230052), // Rule ID 64920 //
     /* 2230015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230018 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230021 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230028 */   // MIs[0] Operand 1
     /* 2230028 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2230033 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230037 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230041 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2230041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230046 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230048 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230051 */   // GIR_Coverage, 64920,
     /* 2230051 */   GIR_EraseRootFromParent_Done,
     /* 2230052 */ // Label 29776: @2230052
     /* 2230052 */ GIM_Try, /*On fail goto*//*Label 29777*/ GIMT_Encode4(2230094), // Rule ID 64924 //
     /* 2230057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230070 */   // MIs[0] Operand 1
     /* 2230070 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2230075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230083 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2230083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230088 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230093 */   // GIR_Coverage, 64924,
     /* 2230093 */   GIR_EraseRootFromParent_Done,
     /* 2230094 */ // Label 29777: @2230094
     /* 2230094 */ GIM_Try, /*On fail goto*//*Label 29778*/ GIMT_Encode4(2230160), // Rule ID 64930 //
     /* 2230099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230112 */   // MIs[0] Operand 1
     /* 2230112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2230117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230125 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2230132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230137 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230141 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230159 */   // GIR_Coverage, 64930,
     /* 2230159 */   GIR_EraseRootFromParent_Done,
     /* 2230160 */ // Label 29778: @2230160
     /* 2230160 */ GIM_Try, /*On fail goto*//*Label 29779*/ GIMT_Encode4(2230229), // Rule ID 64936 //
     /* 2230165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230178 */   // MIs[0] Operand 1
     /* 2230178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2230183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230191 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2230191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2230198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230203 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230218 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2230224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230228 */   // GIR_Coverage, 64936,
     /* 2230228 */   GIR_EraseRootFromParent_Done,
     /* 2230229 */ // Label 29779: @2230229
     /* 2230229 */ GIM_Try, /*On fail goto*//*Label 29780*/ GIMT_Encode4(2230271), // Rule ID 64940 //
     /* 2230234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230247 */   // MIs[0] Operand 1
     /* 2230247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2230252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230260 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2230260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230265 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230270 */   // GIR_Coverage, 64940,
     /* 2230270 */   GIR_EraseRootFromParent_Done,
     /* 2230271 */ // Label 29780: @2230271
     /* 2230271 */ GIM_Try, /*On fail goto*//*Label 29781*/ GIMT_Encode4(2230313), // Rule ID 64944 //
     /* 2230276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230289 */   // MIs[0] Operand 1
     /* 2230289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2230294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230302 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2230302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230307 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230309 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230312 */   // GIR_Coverage, 64944,
     /* 2230312 */   GIR_EraseRootFromParent_Done,
     /* 2230313 */ // Label 29781: @2230313
     /* 2230313 */ GIM_Try, /*On fail goto*//*Label 29782*/ GIMT_Encode4(2230379), // Rule ID 64948 //
     /* 2230318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230324 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230331 */   // MIs[0] Operand 1
     /* 2230331 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2230336 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230340 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230344 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230356 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230377 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230378 */   // GIR_Coverage, 64948,
     /* 2230378 */   GIR_EraseRootFromParent_Done,
     /* 2230379 */ // Label 29782: @2230379
     /* 2230379 */ GIM_Try, /*On fail goto*//*Label 29783*/ GIMT_Encode4(2230445), // Rule ID 64952 //
     /* 2230384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230390 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230397 */   // MIs[0] Operand 1
     /* 2230397 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2230402 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230406 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230410 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230422 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230426 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230444 */   // GIR_Coverage, 64952,
     /* 2230444 */   GIR_EraseRootFromParent_Done,
     /* 2230445 */ // Label 29783: @2230445
     /* 2230445 */ GIM_Try, /*On fail goto*//*Label 29784*/ GIMT_Encode4(2230511), // Rule ID 64956 //
     /* 2230450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230463 */   // MIs[0] Operand 1
     /* 2230463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2230468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230476 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2230476 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230479 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230483 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230488 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230492 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230496 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230503 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230510 */   // GIR_Coverage, 64956,
     /* 2230510 */   GIR_EraseRootFromParent_Done,
     /* 2230511 */ // Label 29784: @2230511
     /* 2230511 */ GIM_Try, /*On fail goto*//*Label 29785*/ GIMT_Encode4(2230577), // Rule ID 64960 //
     /* 2230516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_p0s64,
     /* 2230522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_p0s64,
     /* 2230525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230529 */   // MIs[0] Operand 1
     /* 2230529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2230534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230542 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2230542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230554 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230558 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230576 */   // GIR_Coverage, 64960,
     /* 2230576 */   GIR_EraseRootFromParent_Done,
     /* 2230577 */ // Label 29785: @2230577
     /* 2230577 */ GIM_Try, /*On fail goto*//*Label 29786*/ GIMT_Encode4(2230643), // Rule ID 64966 //
     /* 2230582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230595 */   // MIs[0] Operand 1
     /* 2230595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2230600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230608 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (SLTIU:{ *:[i64] } (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2230615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230620 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230624 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTIU),
     /* 2230633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230642 */   // GIR_Coverage, 64966,
     /* 2230642 */   GIR_EraseRootFromParent_Done,
     /* 2230643 */ // Label 29786: @2230643
     /* 2230643 */ GIM_Try, /*On fail goto*//*Label 29787*/ GIMT_Encode4(2230712), // Rule ID 64972 //
     /* 2230648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230654 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230661 */   // MIs[0] Operand 1
     /* 2230661 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2230666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230670 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230674 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETNE:{ *:[Other] })  =>  (SLTU:{ *:[i64] } X0:{ *:[i64] }, (XOR:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2))
     /* 2230674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::XOR),
     /* 2230681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230686 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230690 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230701 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2230707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230711 */   // GIR_Coverage, 64972,
     /* 2230711 */   GIR_EraseRootFromParent_Done,
     /* 2230712 */ // Label 29787: @2230712
     /* 2230712 */ GIM_Try, /*On fail goto*//*Label 29788*/ GIMT_Encode4(2230754), // Rule ID 64976 //
     /* 2230717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230730 */   // MIs[0] Operand 1
     /* 2230730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2230735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230743 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGT:{ *:[Other] })  =>  (SLTU:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2230743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230748 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230750 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230753 */   // GIR_Coverage, 64976,
     /* 2230753 */   GIR_EraseRootFromParent_Done,
     /* 2230754 */ // Label 29788: @2230754
     /* 2230754 */ GIM_Try, /*On fail goto*//*Label 29789*/ GIMT_Encode4(2230796), // Rule ID 64980 //
     /* 2230759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230772 */   // MIs[0] Operand 1
     /* 2230772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2230777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230785 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGT:{ *:[Other] })  =>  (SLT:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1)
     /* 2230785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2230792 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2230794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230795 */   // GIR_Coverage, 64980,
     /* 2230795 */   GIR_EraseRootFromParent_Done,
     /* 2230796 */ // Label 29789: @2230796
     /* 2230796 */ GIM_Try, /*On fail goto*//*Label 29790*/ GIMT_Encode4(2230862), // Rule ID 64984 //
     /* 2230801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230814 */   // MIs[0] Operand 1
     /* 2230814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2230819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230827 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETUGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230839 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230843 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230847 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230854 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230861 */   // GIR_Coverage, 64984,
     /* 2230861 */   GIR_EraseRootFromParent_Done,
     /* 2230862 */ // Label 29790: @2230862
     /* 2230862 */ GIM_Try, /*On fail goto*//*Label 29791*/ GIMT_Encode4(2230928), // Rule ID 64988 //
     /* 2230867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230880 */   // MIs[0] Operand 1
     /* 2230880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2230885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230893 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETGE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2), 1:{ *:[i64] })
     /* 2230893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2230900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230905 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230909 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230913 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230915 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230918 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230920 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230927 */   // GIR_Coverage, 64988,
     /* 2230927 */   GIR_EraseRootFromParent_Done,
     /* 2230928 */ // Label 29791: @2230928
     /* 2230928 */ GIM_Try, /*On fail goto*//*Label 29792*/ GIMT_Encode4(2230994), // Rule ID 64992 //
     /* 2230933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2230936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2230939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2230942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230946 */   // MIs[0] Operand 1
     /* 2230946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2230951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2230959 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETULE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLTU:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2230959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2230962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLTU),
     /* 2230966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2230971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2230975 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2230979 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2230981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2230984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2230986 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2230989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2230992 */   GIR_RootConstrainSelectedInstOperands,
     /* 2230993 */   // GIR_Coverage, 64992,
     /* 2230993 */   GIR_EraseRootFromParent_Done,
     /* 2230994 */ // Label 29792: @2230994
     /* 2230994 */ GIM_Try, /*On fail goto*//*Label 29793*/ GIMT_Encode4(2231060), // Rule ID 64996 //
     /* 2230999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HwMode0),
     /* 2231002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2231005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2231008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231012 */   // MIs[0] Operand 1
     /* 2231012 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2231017 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231021 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2231025 */   // (setcc:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, SETLE:{ *:[Other] })  =>  (XORI:{ *:[i64] } (SLT:{ *:[i16] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1), 1:{ *:[i64] })
     /* 2231025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2231028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLT),
     /* 2231032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2231037 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // rs2
     /* 2231041 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs1
     /* 2231045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2231047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2231050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2231055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2231058 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231059 */   // GIR_Coverage, 64996,
     /* 2231059 */   GIR_EraseRootFromParent_Done,
     /* 2231060 */ // Label 29793: @2231060
     /* 2231060 */ GIM_Reject,
     /* 2231061 */ // Label 29692: @2231061
     /* 2231061 */ GIM_Try, /*On fail goto*//*Label 29794*/ GIMT_Encode4(2231109), // Rule ID 45656 //
     /* 2231066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231079 */   // MIs[0] Operand 1
     /* 2231079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231092 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2231095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231097 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231099 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231108 */   // GIR_Coverage, 45656,
     /* 2231108 */   GIR_EraseRootFromParent_Done,
     /* 2231109 */ // Label 29794: @2231109
     /* 2231109 */ GIM_Try, /*On fail goto*//*Label 29795*/ GIMT_Encode4(2231157), // Rule ID 45657 //
     /* 2231114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231127 */   // MIs[0] Operand 1
     /* 2231127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231140 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF8),
     /* 2231143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231145 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231156 */   // GIR_Coverage, 45657,
     /* 2231156 */   GIR_EraseRootFromParent_Done,
     /* 2231157 */ // Label 29795: @2231157
     /* 2231157 */ GIM_Try, /*On fail goto*//*Label 29796*/ GIMT_Encode4(2231205), // Rule ID 45658 //
     /* 2231162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231175 */   // MIs[0] Operand 1
     /* 2231175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2231180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231188 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2231191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231193 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2231195 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231204 */   // GIR_Coverage, 45658,
     /* 2231204 */   GIR_EraseRootFromParent_Done,
     /* 2231205 */ // Label 29796: @2231205
     /* 2231205 */ GIM_Try, /*On fail goto*//*Label 29797*/ GIMT_Encode4(2231253), // Rule ID 45659 //
     /* 2231210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231223 */   // MIs[0] Operand 1
     /* 2231223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2231228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231236 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2231239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231241 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2231243 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2231245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231252 */   // GIR_Coverage, 45659,
     /* 2231252 */   GIR_EraseRootFromParent_Done,
     /* 2231253 */ // Label 29797: @2231253
     /* 2231253 */ GIM_Try, /*On fail goto*//*Label 29798*/ GIMT_Encode4(2231301), // Rule ID 48366 //
     /* 2231258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2231267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231271 */   // MIs[0] Operand 1
     /* 2231271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231284 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2231284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2231287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231300 */   // GIR_Coverage, 48366,
     /* 2231300 */   GIR_EraseRootFromParent_Done,
     /* 2231301 */ // Label 29798: @2231301
     /* 2231301 */ GIM_Try, /*On fail goto*//*Label 29799*/ GIMT_Encode4(2231349), // Rule ID 48367 //
     /* 2231306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2231315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231319 */   // MIs[0] Operand 1
     /* 2231319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231332 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2231332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2231335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231348 */   // GIR_Coverage, 48367,
     /* 2231348 */   GIR_EraseRootFromParent_Done,
     /* 2231349 */ // Label 29799: @2231349
     /* 2231349 */ GIM_Try, /*On fail goto*//*Label 29800*/ GIMT_Encode4(2231397), // Rule ID 48370 //
     /* 2231354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2231363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231367 */   // MIs[0] Operand 1
     /* 2231367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231380 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2231380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2231383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231396 */   // GIR_Coverage, 48370,
     /* 2231396 */   GIR_EraseRootFromParent_Done,
     /* 2231397 */ // Label 29800: @2231397
     /* 2231397 */ GIM_Try, /*On fail goto*//*Label 29801*/ GIMT_Encode4(2231445), // Rule ID 48371 //
     /* 2231402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2231411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231415 */   // MIs[0] Operand 1
     /* 2231415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231428 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2231428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2231431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231444 */   // GIR_Coverage, 48371,
     /* 2231444 */   GIR_EraseRootFromParent_Done,
     /* 2231445 */ // Label 29801: @2231445
     /* 2231445 */ GIM_Try, /*On fail goto*//*Label 29802*/ GIMT_Encode4(2231493), // Rule ID 48378 //
     /* 2231450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2231459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231463 */   // MIs[0] Operand 1
     /* 2231463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231476 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2231476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2231479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231492 */   // GIR_Coverage, 48378,
     /* 2231492 */   GIR_EraseRootFromParent_Done,
     /* 2231493 */ // Label 29802: @2231493
     /* 2231493 */ GIM_Try, /*On fail goto*//*Label 29803*/ GIMT_Encode4(2231541), // Rule ID 48379 //
     /* 2231498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2231507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231511 */   // MIs[0] Operand 1
     /* 2231511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2231516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231524 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2231524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2231527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231540 */   // GIR_Coverage, 48379,
     /* 2231540 */   GIR_EraseRootFromParent_Done,
     /* 2231541 */ // Label 29803: @2231541
     /* 2231541 */ GIM_Try, /*On fail goto*//*Label 29804*/ GIMT_Encode4(2231589), // Rule ID 48404 //
     /* 2231546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231559 */   // MIs[0] Operand 1
     /* 2231559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231572 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2231575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231588 */   // GIR_Coverage, 48404,
     /* 2231588 */   GIR_EraseRootFromParent_Done,
     /* 2231589 */ // Label 29804: @2231589
     /* 2231589 */ GIM_Try, /*On fail goto*//*Label 29805*/ GIMT_Encode4(2231637), // Rule ID 48405 //
     /* 2231594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231607 */   // MIs[0] Operand 1
     /* 2231607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231620 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2231620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF8),
     /* 2231623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231636 */   // GIR_Coverage, 48405,
     /* 2231636 */   GIR_EraseRootFromParent_Done,
     /* 2231637 */ // Label 29805: @2231637
     /* 2231637 */ GIM_Try, /*On fail goto*//*Label 29806*/ GIMT_Encode4(2231685), // Rule ID 48410 //
     /* 2231642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2231651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231655 */   // MIs[0] Operand 1
     /* 2231655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231668 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2231668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2231671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231684 */   // GIR_Coverage, 48410,
     /* 2231684 */   GIR_EraseRootFromParent_Done,
     /* 2231685 */ // Label 29806: @2231685
     /* 2231685 */ GIM_Try, /*On fail goto*//*Label 29807*/ GIMT_Encode4(2231733), // Rule ID 48411 //
     /* 2231690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2231696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2231699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231703 */   // MIs[0] Operand 1
     /* 2231703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231716 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2231716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2231719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2231731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231732 */   // GIR_Coverage, 48411,
     /* 2231732 */   GIR_EraseRootFromParent_Done,
     /* 2231733 */ // Label 29807: @2231733
     /* 2231733 */ GIM_Try, /*On fail goto*//*Label 29808*/ GIMT_Encode4(2231781), // Rule ID 48414 //
     /* 2231738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2231747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231751 */   // MIs[0] Operand 1
     /* 2231751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231764 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2231764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2231767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231780 */   // GIR_Coverage, 48414,
     /* 2231780 */   GIR_EraseRootFromParent_Done,
     /* 2231781 */ // Label 29808: @2231781
     /* 2231781 */ GIM_Try, /*On fail goto*//*Label 29809*/ GIMT_Encode4(2231829), // Rule ID 48415 //
     /* 2231786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2231792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2231795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231799 */   // MIs[0] Operand 1
     /* 2231799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231812 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2231812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2231815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2231827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231828 */   // GIR_Coverage, 48415,
     /* 2231828 */   GIR_EraseRootFromParent_Done,
     /* 2231829 */ // Label 29809: @2231829
     /* 2231829 */ GIM_Try, /*On fail goto*//*Label 29810*/ GIMT_Encode4(2231877), // Rule ID 48422 //
     /* 2231834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2231837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2231843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231847 */   // MIs[0] Operand 1
     /* 2231847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231860 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2231860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2231863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231876 */   // GIR_Coverage, 48422,
     /* 2231876 */   GIR_EraseRootFromParent_Done,
     /* 2231877 */ // Label 29810: @2231877
     /* 2231877 */ GIM_Try, /*On fail goto*//*Label 29811*/ GIMT_Encode4(2231925), // Rule ID 48423 //
     /* 2231882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2231885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2231888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2231891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231895 */   // MIs[0] Operand 1
     /* 2231895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2231900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231908 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2231908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2231911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2231923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231924 */   // GIR_Coverage, 48423,
     /* 2231924 */   GIR_EraseRootFromParent_Done,
     /* 2231925 */ // Label 29811: @2231925
     /* 2231925 */ GIM_Try, /*On fail goto*//*Label 29812*/ GIMT_Encode4(2231973), // Rule ID 48448 //
     /* 2231930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2231933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231943 */   // MIs[0] Operand 1
     /* 2231943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2231948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231956 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2231956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2231959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2231961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2231963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2231965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2231968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2231971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2231972 */   // GIR_Coverage, 48448,
     /* 2231972 */   GIR_EraseRootFromParent_Done,
     /* 2231973 */ // Label 29812: @2231973
     /* 2231973 */ GIM_Try, /*On fail goto*//*Label 29813*/ GIMT_Encode4(2232021), // Rule ID 48449 //
     /* 2231978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2231981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2231984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2231987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2231991 */   // MIs[0] Operand 1
     /* 2231991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2231996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232004 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF8),
     /* 2232007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232020 */   // GIR_Coverage, 48449,
     /* 2232020 */   GIR_EraseRootFromParent_Done,
     /* 2232021 */ // Label 29813: @2232021
     /* 2232021 */ GIM_Try, /*On fail goto*//*Label 29814*/ GIMT_Encode4(2232069), // Rule ID 48454 //
     /* 2232026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232039 */   // MIs[0] Operand 1
     /* 2232039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232052 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2232052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2232055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232068 */   // GIR_Coverage, 48454,
     /* 2232068 */   GIR_EraseRootFromParent_Done,
     /* 2232069 */ // Label 29814: @2232069
     /* 2232069 */ GIM_Try, /*On fail goto*//*Label 29815*/ GIMT_Encode4(2232117), // Rule ID 48455 //
     /* 2232074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232080 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232087 */   // MIs[0] Operand 1
     /* 2232087 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232096 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232100 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2232100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2232103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232105 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232107 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232115 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232116 */   // GIR_Coverage, 48455,
     /* 2232116 */   GIR_EraseRootFromParent_Done,
     /* 2232117 */ // Label 29815: @2232117
     /* 2232117 */ GIM_Try, /*On fail goto*//*Label 29816*/ GIMT_Encode4(2232165), // Rule ID 48458 //
     /* 2232122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232128 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232135 */   // MIs[0] Operand 1
     /* 2232135 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232144 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232148 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2232148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2232151 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232153 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232155 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232164 */   // GIR_Coverage, 48458,
     /* 2232164 */   GIR_EraseRootFromParent_Done,
     /* 2232165 */ // Label 29816: @2232165
     /* 2232165 */ GIM_Try, /*On fail goto*//*Label 29817*/ GIMT_Encode4(2232213), // Rule ID 48459 //
     /* 2232170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232176 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232183 */   // MIs[0] Operand 1
     /* 2232183 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232192 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232196 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2232196 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2232199 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232201 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232203 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232205 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232211 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232212 */   // GIR_Coverage, 48459,
     /* 2232212 */   GIR_EraseRootFromParent_Done,
     /* 2232213 */ // Label 29817: @2232213
     /* 2232213 */ GIM_Try, /*On fail goto*//*Label 29818*/ GIMT_Encode4(2232261), // Rule ID 48466 //
     /* 2232218 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232224 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232231 */   // MIs[0] Operand 1
     /* 2232231 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232240 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232244 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2232244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2232247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232249 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232251 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232259 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232260 */   // GIR_Coverage, 48466,
     /* 2232260 */   GIR_EraseRootFromParent_Done,
     /* 2232261 */ // Label 29818: @2232261
     /* 2232261 */ GIM_Try, /*On fail goto*//*Label 29819*/ GIMT_Encode4(2232309), // Rule ID 48467 //
     /* 2232266 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232272 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232279 */   // MIs[0] Operand 1
     /* 2232279 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2232284 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232288 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232292 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2232292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2232295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232297 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232299 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232308 */   // GIR_Coverage, 48467,
     /* 2232308 */   GIR_EraseRootFromParent_Done,
     /* 2232309 */ // Label 29819: @2232309
     /* 2232309 */ GIM_Try, /*On fail goto*//*Label 29820*/ GIMT_Encode4(2232357), // Rule ID 48496 //
     /* 2232314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232320 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232327 */   // MIs[0] Operand 1
     /* 2232327 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232336 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232340 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2232340 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2232343 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232345 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232347 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232355 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232356 */   // GIR_Coverage, 48496,
     /* 2232356 */   GIR_EraseRootFromParent_Done,
     /* 2232357 */ // Label 29820: @2232357
     /* 2232357 */ GIM_Try, /*On fail goto*//*Label 29821*/ GIMT_Encode4(2232405), // Rule ID 48497 //
     /* 2232362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232368 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232375 */   // MIs[0] Operand 1
     /* 2232375 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232384 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232388 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2232388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2232391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232393 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232395 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232403 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232404 */   // GIR_Coverage, 48497,
     /* 2232404 */   GIR_EraseRootFromParent_Done,
     /* 2232405 */ // Label 29821: @2232405
     /* 2232405 */ GIM_Try, /*On fail goto*//*Label 29822*/ GIMT_Encode4(2232453), // Rule ID 48500 //
     /* 2232410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232416 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232423 */   // MIs[0] Operand 1
     /* 2232423 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232428 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232432 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232436 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2232436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2232439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232441 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232443 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232451 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232452 */   // GIR_Coverage, 48500,
     /* 2232452 */   GIR_EraseRootFromParent_Done,
     /* 2232453 */ // Label 29822: @2232453
     /* 2232453 */ GIM_Try, /*On fail goto*//*Label 29823*/ GIMT_Encode4(2232501), // Rule ID 48501 //
     /* 2232458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232464 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232471 */   // MIs[0] Operand 1
     /* 2232471 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232480 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232484 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2232484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2232487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232489 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232491 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232499 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232500 */   // GIR_Coverage, 48501,
     /* 2232500 */   GIR_EraseRootFromParent_Done,
     /* 2232501 */ // Label 29823: @2232501
     /* 2232501 */ GIM_Try, /*On fail goto*//*Label 29824*/ GIMT_Encode4(2232549), // Rule ID 48508 //
     /* 2232506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232512 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232519 */   // MIs[0] Operand 1
     /* 2232519 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232528 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232532 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2232532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2232535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232537 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232539 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232547 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232548 */   // GIR_Coverage, 48508,
     /* 2232548 */   GIR_EraseRootFromParent_Done,
     /* 2232549 */ // Label 29824: @2232549
     /* 2232549 */ GIM_Try, /*On fail goto*//*Label 29825*/ GIMT_Encode4(2232597), // Rule ID 48509 //
     /* 2232554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232560 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232567 */   // MIs[0] Operand 1
     /* 2232567 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2232572 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232576 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232580 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2232580 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2232583 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232585 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2232587 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2232589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232596 */   // GIR_Coverage, 48509,
     /* 2232596 */   GIR_EraseRootFromParent_Done,
     /* 2232597 */ // Label 29825: @2232597
     /* 2232597 */ GIM_Try, /*On fail goto*//*Label 29826*/ GIMT_Encode4(2232645), // Rule ID 48534 //
     /* 2232602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2232608 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2232611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232615 */   // MIs[0] Operand 1
     /* 2232615 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232624 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232628 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2232628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2232631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232633 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232635 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232643 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232644 */   // GIR_Coverage, 48534,
     /* 2232644 */   GIR_EraseRootFromParent_Done,
     /* 2232645 */ // Label 29826: @2232645
     /* 2232645 */ GIM_Try, /*On fail goto*//*Label 29827*/ GIMT_Encode4(2232693), // Rule ID 48535 //
     /* 2232650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2232656 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2232659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232663 */   // MIs[0] Operand 1
     /* 2232663 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232672 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232676 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2232676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2232679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232681 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232683 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2232691 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232692 */   // GIR_Coverage, 48535,
     /* 2232692 */   GIR_EraseRootFromParent_Done,
     /* 2232693 */ // Label 29827: @2232693
     /* 2232693 */ GIM_Try, /*On fail goto*//*Label 29828*/ GIMT_Encode4(2232741), // Rule ID 48540 //
     /* 2232698 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232704 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232711 */   // MIs[0] Operand 1
     /* 2232711 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232724 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2232724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2232727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232729 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232731 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232739 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232740 */   // GIR_Coverage, 48540,
     /* 2232740 */   GIR_EraseRootFromParent_Done,
     /* 2232741 */ // Label 29828: @2232741
     /* 2232741 */ GIM_Try, /*On fail goto*//*Label 29829*/ GIMT_Encode4(2232789), // Rule ID 48541 //
     /* 2232746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2232752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2232755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232759 */   // MIs[0] Operand 1
     /* 2232759 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232764 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232768 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232772 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2232772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2232775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232777 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232779 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2232787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232788 */   // GIR_Coverage, 48541,
     /* 2232788 */   GIR_EraseRootFromParent_Done,
     /* 2232789 */ // Label 29829: @2232789
     /* 2232789 */ GIM_Try, /*On fail goto*//*Label 29830*/ GIMT_Encode4(2232837), // Rule ID 48544 //
     /* 2232794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232797 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232800 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232807 */   // MIs[0] Operand 1
     /* 2232807 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232816 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232820 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2232820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2232823 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232825 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232827 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232835 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232836 */   // GIR_Coverage, 48544,
     /* 2232836 */   GIR_EraseRootFromParent_Done,
     /* 2232837 */ // Label 29830: @2232837
     /* 2232837 */ GIM_Try, /*On fail goto*//*Label 29831*/ GIMT_Encode4(2232885), // Rule ID 48545 //
     /* 2232842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2232845 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2232848 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2232851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232855 */   // MIs[0] Operand 1
     /* 2232855 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232864 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232868 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2232868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2232871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232873 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232875 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2232883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232884 */   // GIR_Coverage, 48545,
     /* 2232884 */   GIR_EraseRootFromParent_Done,
     /* 2232885 */ // Label 29831: @2232885
     /* 2232885 */ GIM_Try, /*On fail goto*//*Label 29832*/ GIMT_Encode4(2232933), // Rule ID 48552 //
     /* 2232890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2232893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232903 */   // MIs[0] Operand 1
     /* 2232903 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232912 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232916 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2232916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2232919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232921 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232923 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232931 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232932 */   // GIR_Coverage, 48552,
     /* 2232932 */   GIR_EraseRootFromParent_Done,
     /* 2232933 */ // Label 29832: @2232933
     /* 2232933 */ GIM_Try, /*On fail goto*//*Label 29833*/ GIMT_Encode4(2232981), // Rule ID 48553 //
     /* 2232938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2232941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2232944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2232947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232951 */   // MIs[0] Operand 1
     /* 2232951 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2232956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232960 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232964 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2232964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2232967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2232969 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2232971 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2232973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2232976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2232979 */   GIR_RootConstrainSelectedInstOperands,
     /* 2232980 */   // GIR_Coverage, 48553,
     /* 2232980 */   GIR_EraseRootFromParent_Done,
     /* 2232981 */ // Label 29833: @2232981
     /* 2232981 */ GIM_Try, /*On fail goto*//*Label 29834*/ GIMT_Encode4(2233029), // Rule ID 48578 //
     /* 2232986 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2232989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2232992 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2232995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2232999 */   // MIs[0] Operand 1
     /* 2232999 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233008 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233012 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2233015 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233017 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233027 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233028 */   // GIR_Coverage, 48578,
     /* 2233028 */   GIR_EraseRootFromParent_Done,
     /* 2233029 */ // Label 29834: @2233029
     /* 2233029 */ GIM_Try, /*On fail goto*//*Label 29835*/ GIMT_Encode4(2233077), // Rule ID 48579 //
     /* 2233034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233040 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2233043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233047 */   // MIs[0] Operand 1
     /* 2233047 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233056 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233060 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF8),
     /* 2233063 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233065 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233075 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233076 */   // GIR_Coverage, 48579,
     /* 2233076 */   GIR_EraseRootFromParent_Done,
     /* 2233077 */ // Label 29835: @2233077
     /* 2233077 */ GIM_Try, /*On fail goto*//*Label 29836*/ GIMT_Encode4(2233125), // Rule ID 48584 //
     /* 2233082 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233088 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233095 */   // MIs[0] Operand 1
     /* 2233095 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233104 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233108 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2233108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2233111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233113 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233124 */   // GIR_Coverage, 48584,
     /* 2233124 */   GIR_EraseRootFromParent_Done,
     /* 2233125 */ // Label 29836: @2233125
     /* 2233125 */ GIM_Try, /*On fail goto*//*Label 29837*/ GIMT_Encode4(2233173), // Rule ID 48585 //
     /* 2233130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233136 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233143 */   // MIs[0] Operand 1
     /* 2233143 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233152 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233156 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2233156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2233159 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233161 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233171 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233172 */   // GIR_Coverage, 48585,
     /* 2233172 */   GIR_EraseRootFromParent_Done,
     /* 2233173 */ // Label 29837: @2233173
     /* 2233173 */ GIM_Try, /*On fail goto*//*Label 29838*/ GIMT_Encode4(2233221), // Rule ID 48588 //
     /* 2233178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233181 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2233184 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2233187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233191 */   // MIs[0] Operand 1
     /* 2233191 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233200 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233204 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2233204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2233207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233209 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233219 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233220 */   // GIR_Coverage, 48588,
     /* 2233220 */   GIR_EraseRootFromParent_Done,
     /* 2233221 */ // Label 29838: @2233221
     /* 2233221 */ GIM_Try, /*On fail goto*//*Label 29839*/ GIMT_Encode4(2233269), // Rule ID 48589 //
     /* 2233226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2233232 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2233235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233239 */   // MIs[0] Operand 1
     /* 2233239 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233244 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233248 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233252 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2233252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2233255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233257 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233268 */   // GIR_Coverage, 48589,
     /* 2233268 */   GIR_EraseRootFromParent_Done,
     /* 2233269 */ // Label 29839: @2233269
     /* 2233269 */ GIM_Try, /*On fail goto*//*Label 29840*/ GIMT_Encode4(2233317), // Rule ID 48596 //
     /* 2233274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2233280 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2233283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233287 */   // MIs[0] Operand 1
     /* 2233287 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233292 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233296 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233300 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2233300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2233303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233305 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233315 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233316 */   // GIR_Coverage, 48596,
     /* 2233316 */   GIR_EraseRootFromParent_Done,
     /* 2233317 */ // Label 29840: @2233317
     /* 2233317 */ GIM_Try, /*On fail goto*//*Label 29841*/ GIMT_Encode4(2233365), // Rule ID 48597 //
     /* 2233322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233325 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2233328 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2233331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233335 */   // MIs[0] Operand 1
     /* 2233335 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2233340 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233344 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233348 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2233348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2233351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233353 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233363 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233364 */   // GIR_Coverage, 48597,
     /* 2233364 */   GIR_EraseRootFromParent_Done,
     /* 2233365 */ // Label 29841: @2233365
     /* 2233365 */ GIM_Try, /*On fail goto*//*Label 29842*/ GIMT_Encode4(2233413), // Rule ID 48622 //
     /* 2233370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233376 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2233379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233383 */   // MIs[0] Operand 1
     /* 2233383 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233392 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233396 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2233399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233401 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233403 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233411 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233412 */   // GIR_Coverage, 48622,
     /* 2233412 */   GIR_EraseRootFromParent_Done,
     /* 2233413 */ // Label 29842: @2233413
     /* 2233413 */ GIM_Try, /*On fail goto*//*Label 29843*/ GIMT_Encode4(2233461), // Rule ID 48623 //
     /* 2233418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2233427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233431 */   // MIs[0] Operand 1
     /* 2233431 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233440 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233444 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2233447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233449 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233451 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233459 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233460 */   // GIR_Coverage, 48623,
     /* 2233460 */   GIR_EraseRootFromParent_Done,
     /* 2233461 */ // Label 29843: @2233461
     /* 2233461 */ GIM_Try, /*On fail goto*//*Label 29844*/ GIMT_Encode4(2233509), // Rule ID 48628 //
     /* 2233466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233469 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233472 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233479 */   // MIs[0] Operand 1
     /* 2233479 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233488 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233492 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2233492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2233495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233497 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233499 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233507 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233508 */   // GIR_Coverage, 48628,
     /* 2233508 */   GIR_EraseRootFromParent_Done,
     /* 2233509 */ // Label 29844: @2233509
     /* 2233509 */ GIM_Try, /*On fail goto*//*Label 29845*/ GIMT_Encode4(2233557), // Rule ID 48629 //
     /* 2233514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233520 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233527 */   // MIs[0] Operand 1
     /* 2233527 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233536 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233540 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2233540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2233543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233545 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233547 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233556 */   // GIR_Coverage, 48629,
     /* 2233556 */   GIR_EraseRootFromParent_Done,
     /* 2233557 */ // Label 29845: @2233557
     /* 2233557 */ GIM_Try, /*On fail goto*//*Label 29846*/ GIMT_Encode4(2233605), // Rule ID 48632 //
     /* 2233562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2233568 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2233571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233575 */   // MIs[0] Operand 1
     /* 2233575 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233584 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233588 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2233588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2233591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233593 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233595 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233603 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233604 */   // GIR_Coverage, 48632,
     /* 2233604 */   GIR_EraseRootFromParent_Done,
     /* 2233605 */ // Label 29846: @2233605
     /* 2233605 */ GIM_Try, /*On fail goto*//*Label 29847*/ GIMT_Encode4(2233653), // Rule ID 48633 //
     /* 2233610 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2233616 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2233619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233623 */   // MIs[0] Operand 1
     /* 2233623 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233632 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233636 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2233636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2233639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233641 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233643 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233651 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233652 */   // GIR_Coverage, 48633,
     /* 2233652 */   GIR_EraseRootFromParent_Done,
     /* 2233653 */ // Label 29847: @2233653
     /* 2233653 */ GIM_Try, /*On fail goto*//*Label 29848*/ GIMT_Encode4(2233701), // Rule ID 48640 //
     /* 2233658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2233661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2233664 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2233667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233671 */   // MIs[0] Operand 1
     /* 2233671 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233680 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233684 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2233684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2233687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233689 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233691 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233699 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233700 */   // GIR_Coverage, 48640,
     /* 2233700 */   GIR_EraseRootFromParent_Done,
     /* 2233701 */ // Label 29848: @2233701
     /* 2233701 */ GIM_Try, /*On fail goto*//*Label 29849*/ GIMT_Encode4(2233749), // Rule ID 48641 //
     /* 2233706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2233709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2233712 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2233715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233719 */   // MIs[0] Operand 1
     /* 2233719 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2233724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233728 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233732 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2233732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2233735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233737 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2233739 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2233741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2233747 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233748 */   // GIR_Coverage, 48641,
     /* 2233748 */   GIR_EraseRootFromParent_Done,
     /* 2233749 */ // Label 29849: @2233749
     /* 2233749 */ GIM_Try, /*On fail goto*//*Label 29850*/ GIMT_Encode4(2233797), // Rule ID 48666 //
     /* 2233754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233760 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2233763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233767 */   // MIs[0] Operand 1
     /* 2233767 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233776 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233780 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2233780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2233783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233785 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233796 */   // GIR_Coverage, 48666,
     /* 2233796 */   GIR_EraseRootFromParent_Done,
     /* 2233797 */ // Label 29850: @2233797
     /* 2233797 */ GIM_Try, /*On fail goto*//*Label 29851*/ GIMT_Encode4(2233845), // Rule ID 48667 //
     /* 2233802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2233808 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2233811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233815 */   // MIs[0] Operand 1
     /* 2233815 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233820 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233824 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233828 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2233828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF8),
     /* 2233831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233833 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2233843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233844 */   // GIR_Coverage, 48667,
     /* 2233844 */   GIR_EraseRootFromParent_Done,
     /* 2233845 */ // Label 29851: @2233845
     /* 2233845 */ GIM_Try, /*On fail goto*//*Label 29852*/ GIMT_Encode4(2233893), // Rule ID 48672 //
     /* 2233850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233863 */   // MIs[0] Operand 1
     /* 2233863 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233876 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2233876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2233879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233881 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233891 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233892 */   // GIR_Coverage, 48672,
     /* 2233892 */   GIR_EraseRootFromParent_Done,
     /* 2233893 */ // Label 29852: @2233893
     /* 2233893 */ GIM_Try, /*On fail goto*//*Label 29853*/ GIMT_Encode4(2233941), // Rule ID 48673 //
     /* 2233898 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2233904 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2233907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233911 */   // MIs[0] Operand 1
     /* 2233911 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233916 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233920 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233924 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2233924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2233927 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233929 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2233939 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233940 */   // GIR_Coverage, 48673,
     /* 2233940 */   GIR_EraseRootFromParent_Done,
     /* 2233941 */ // Label 29853: @2233941
     /* 2233941 */ GIM_Try, /*On fail goto*//*Label 29854*/ GIMT_Encode4(2233989), // Rule ID 48676 //
     /* 2233946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2233949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2233952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2233955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233959 */   // MIs[0] Operand 1
     /* 2233959 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2233964 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233968 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2233972 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2233972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2233975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2233977 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2233979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2233981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2233984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2233987 */   GIR_RootConstrainSelectedInstOperands,
     /* 2233988 */   // GIR_Coverage, 48676,
     /* 2233988 */   GIR_EraseRootFromParent_Done,
     /* 2233989 */ // Label 29854: @2233989
     /* 2233989 */ GIM_Try, /*On fail goto*//*Label 29855*/ GIMT_Encode4(2234037), // Rule ID 48677 //
     /* 2233994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2233997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234000 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2234003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234007 */   // MIs[0] Operand 1
     /* 2234007 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2234012 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234016 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234020 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2234020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2234023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234025 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234036 */   // GIR_Coverage, 48677,
     /* 2234036 */   GIR_EraseRootFromParent_Done,
     /* 2234037 */ // Label 29855: @2234037
     /* 2234037 */ GIM_Try, /*On fail goto*//*Label 29856*/ GIMT_Encode4(2234085), // Rule ID 48684 //
     /* 2234042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234048 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234055 */   // MIs[0] Operand 1
     /* 2234055 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2234060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234064 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234068 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2234068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2234071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234073 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234084 */   // GIR_Coverage, 48684,
     /* 2234084 */   GIR_EraseRootFromParent_Done,
     /* 2234085 */ // Label 29856: @2234085
     /* 2234085 */ GIM_Try, /*On fail goto*//*Label 29857*/ GIMT_Encode4(2234133), // Rule ID 48685 //
     /* 2234090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234096 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234103 */   // MIs[0] Operand 1
     /* 2234103 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2234108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234112 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234116 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2234116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2234119 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234121 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234132 */   // GIR_Coverage, 48685,
     /* 2234132 */   GIR_EraseRootFromParent_Done,
     /* 2234133 */ // Label 29857: @2234133
     /* 2234133 */ GIM_Try, /*On fail goto*//*Label 29858*/ GIMT_Encode4(2234181), // Rule ID 48710 //
     /* 2234138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2234147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234151 */   // MIs[0] Operand 1
     /* 2234151 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234164 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2234167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234169 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234179 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234180 */   // GIR_Coverage, 48710,
     /* 2234180 */   GIR_EraseRootFromParent_Done,
     /* 2234181 */ // Label 29858: @2234181
     /* 2234181 */ GIM_Try, /*On fail goto*//*Label 29859*/ GIMT_Encode4(2234229), // Rule ID 48711 //
     /* 2234186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234192 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2234195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234199 */   // MIs[0] Operand 1
     /* 2234199 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234208 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234212 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2234215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234217 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234228 */   // GIR_Coverage, 48711,
     /* 2234228 */   GIR_EraseRootFromParent_Done,
     /* 2234229 */ // Label 29859: @2234229
     /* 2234229 */ GIM_Try, /*On fail goto*//*Label 29860*/ GIMT_Encode4(2234277), // Rule ID 48716 //
     /* 2234234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234240 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2234243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234247 */   // MIs[0] Operand 1
     /* 2234247 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234252 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234256 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234260 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2234260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2234263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234265 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234275 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234276 */   // GIR_Coverage, 48716,
     /* 2234276 */   GIR_EraseRootFromParent_Done,
     /* 2234277 */ // Label 29860: @2234277
     /* 2234277 */ GIM_Try, /*On fail goto*//*Label 29861*/ GIMT_Encode4(2234325), // Rule ID 48717 //
     /* 2234282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234288 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2234291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234295 */   // MIs[0] Operand 1
     /* 2234295 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234300 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234304 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234308 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2234308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2234311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234313 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234315 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234324 */   // GIR_Coverage, 48717,
     /* 2234324 */   GIR_EraseRootFromParent_Done,
     /* 2234325 */ // Label 29861: @2234325
     /* 2234325 */ GIM_Try, /*On fail goto*//*Label 29862*/ GIMT_Encode4(2234373), // Rule ID 48720 //
     /* 2234330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234336 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2234339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234343 */   // MIs[0] Operand 1
     /* 2234343 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234348 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234352 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234356 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2234356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2234359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234361 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234363 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234372 */   // GIR_Coverage, 48720,
     /* 2234372 */   GIR_EraseRootFromParent_Done,
     /* 2234373 */ // Label 29862: @2234373
     /* 2234373 */ GIM_Try, /*On fail goto*//*Label 29863*/ GIMT_Encode4(2234421), // Rule ID 48721 //
     /* 2234378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234381 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234384 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2234387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234391 */   // MIs[0] Operand 1
     /* 2234391 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234396 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234400 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234404 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2234404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2234407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234409 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234411 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234413 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234419 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234420 */   // GIR_Coverage, 48721,
     /* 2234420 */   GIR_EraseRootFromParent_Done,
     /* 2234421 */ // Label 29863: @2234421
     /* 2234421 */ GIM_Try, /*On fail goto*//*Label 29864*/ GIMT_Encode4(2234469), // Rule ID 48728 //
     /* 2234426 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234439 */   // MIs[0] Operand 1
     /* 2234439 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234448 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234452 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2234452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2234455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234457 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234459 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234468 */   // GIR_Coverage, 48728,
     /* 2234468 */   GIR_EraseRootFromParent_Done,
     /* 2234469 */ // Label 29864: @2234469
     /* 2234469 */ GIM_Try, /*On fail goto*//*Label 29865*/ GIMT_Encode4(2234517), // Rule ID 48729 //
     /* 2234474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234487 */   // MIs[0] Operand 1
     /* 2234487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2234492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234500 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2234500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2234503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234516 */   // GIR_Coverage, 48729,
     /* 2234516 */   GIR_EraseRootFromParent_Done,
     /* 2234517 */ // Label 29865: @2234517
     /* 2234517 */ GIM_Try, /*On fail goto*//*Label 29866*/ GIMT_Encode4(2234565), // Rule ID 48754 //
     /* 2234522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234528 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2234531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234535 */   // MIs[0] Operand 1
     /* 2234535 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234544 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234548 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2234551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234553 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234564 */   // GIR_Coverage, 48754,
     /* 2234564 */   GIR_EraseRootFromParent_Done,
     /* 2234565 */ // Label 29866: @2234565
     /* 2234565 */ GIM_Try, /*On fail goto*//*Label 29867*/ GIMT_Encode4(2234613), // Rule ID 48755 //
     /* 2234570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2234576 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2234579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234583 */   // MIs[0] Operand 1
     /* 2234583 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234588 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234592 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234596 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF8:{ *:[nxv1i1] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF8),
     /* 2234599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234601 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234612 */   // GIR_Coverage, 48755,
     /* 2234612 */   GIR_EraseRootFromParent_Done,
     /* 2234613 */ // Label 29867: @2234613
     /* 2234613 */ GIM_Try, /*On fail goto*//*Label 29868*/ GIMT_Encode4(2234661), // Rule ID 48760 //
     /* 2234618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234624 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2234627 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234631 */   // MIs[0] Operand 1
     /* 2234631 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234640 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234644 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2234644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2234647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234649 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234659 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234660 */   // GIR_Coverage, 48760,
     /* 2234660 */   GIR_EraseRootFromParent_Done,
     /* 2234661 */ // Label 29868: @2234661
     /* 2234661 */ GIM_Try, /*On fail goto*//*Label 29869*/ GIMT_Encode4(2234709), // Rule ID 48761 //
     /* 2234666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2234672 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2234675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234679 */   // MIs[0] Operand 1
     /* 2234679 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234684 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234688 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234692 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2234692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2234695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234697 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234699 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2234707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234708 */   // GIR_Coverage, 48761,
     /* 2234708 */   GIR_EraseRootFromParent_Done,
     /* 2234709 */ // Label 29869: @2234709
     /* 2234709 */ GIM_Try, /*On fail goto*//*Label 29870*/ GIMT_Encode4(2234757), // Rule ID 48764 //
     /* 2234714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234720 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2234723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234727 */   // MIs[0] Operand 1
     /* 2234727 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234736 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234740 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2234740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2234743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234745 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234747 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234755 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234756 */   // GIR_Coverage, 48764,
     /* 2234756 */   GIR_EraseRootFromParent_Done,
     /* 2234757 */ // Label 29870: @2234757
     /* 2234757 */ GIM_Try, /*On fail goto*//*Label 29871*/ GIMT_Encode4(2234805), // Rule ID 48765 //
     /* 2234762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2234768 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2234771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234775 */   // MIs[0] Operand 1
     /* 2234775 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234784 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234788 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2234788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2234791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234793 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234795 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234797 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2234803 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234804 */   // GIR_Coverage, 48765,
     /* 2234804 */   GIR_EraseRootFromParent_Done,
     /* 2234805 */ // Label 29871: @2234805
     /* 2234805 */ GIM_Try, /*On fail goto*//*Label 29872*/ GIMT_Encode4(2234853), // Rule ID 48772 //
     /* 2234810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2234813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234816 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234823 */   // MIs[0] Operand 1
     /* 2234823 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234832 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234836 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2234836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2234839 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234841 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234843 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234845 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234851 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234852 */   // GIR_Coverage, 48772,
     /* 2234852 */   GIR_EraseRootFromParent_Done,
     /* 2234853 */ // Label 29872: @2234853
     /* 2234853 */ GIM_Try, /*On fail goto*//*Label 29873*/ GIMT_Encode4(2234901), // Rule ID 48773 //
     /* 2234858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2234861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2234864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2234867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234871 */   // MIs[0] Operand 1
     /* 2234871 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2234876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234884 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2234884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2234887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234889 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2234891 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2234893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2234899 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234900 */   // GIR_Coverage, 48773,
     /* 2234900 */   GIR_EraseRootFromParent_Done,
     /* 2234901 */ // Label 29873: @2234901
     /* 2234901 */ GIM_Reject,
     /* 2234902 */ // Label 29693: @2234902
     /* 2234902 */ GIM_Try, /*On fail goto*//*Label 29874*/ GIMT_Encode4(2234950), // Rule ID 48362 //
     /* 2234907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2234910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234913 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2234916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234920 */   // MIs[0] Operand 1
     /* 2234920 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2234925 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234929 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234933 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2234933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2234936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234938 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234940 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234942 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234948 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234949 */   // GIR_Coverage, 48362,
     /* 2234949 */   GIR_EraseRootFromParent_Done,
     /* 2234950 */ // Label 29874: @2234950
     /* 2234950 */ GIM_Try, /*On fail goto*//*Label 29875*/ GIMT_Encode4(2234998), // Rule ID 48363 //
     /* 2234955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2234958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2234961 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2234964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234968 */   // MIs[0] Operand 1
     /* 2234968 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2234973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234977 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2234981 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2234981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF4),
     /* 2234984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2234986 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2234988 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2234990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2234993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2234996 */   GIR_RootConstrainSelectedInstOperands,
     /* 2234997 */   // GIR_Coverage, 48363,
     /* 2234997 */   GIR_EraseRootFromParent_Done,
     /* 2234998 */ // Label 29875: @2234998
     /* 2234998 */ GIM_Try, /*On fail goto*//*Label 29876*/ GIMT_Encode4(2235046), // Rule ID 48368 //
     /* 2235003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235006 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235009 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235016 */   // MIs[0] Operand 1
     /* 2235016 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235021 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235025 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235029 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2235029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2235032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235034 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235036 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235045 */   // GIR_Coverage, 48368,
     /* 2235045 */   GIR_EraseRootFromParent_Done,
     /* 2235046 */ // Label 29876: @2235046
     /* 2235046 */ GIM_Try, /*On fail goto*//*Label 29877*/ GIMT_Encode4(2235094), // Rule ID 48369 //
     /* 2235051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235057 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235064 */   // MIs[0] Operand 1
     /* 2235064 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235069 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235073 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235077 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2235077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2235080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235082 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235084 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235092 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235093 */   // GIR_Coverage, 48369,
     /* 2235093 */   GIR_EraseRootFromParent_Done,
     /* 2235094 */ // Label 29877: @2235094
     /* 2235094 */ GIM_Try, /*On fail goto*//*Label 29878*/ GIMT_Encode4(2235142), // Rule ID 48376 //
     /* 2235099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235105 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235112 */   // MIs[0] Operand 1
     /* 2235112 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235121 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235125 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2235125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2235128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235130 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235132 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235141 */   // GIR_Coverage, 48376,
     /* 2235141 */   GIR_EraseRootFromParent_Done,
     /* 2235142 */ // Label 29878: @2235142
     /* 2235142 */ GIM_Try, /*On fail goto*//*Label 29879*/ GIMT_Encode4(2235190), // Rule ID 48377 //
     /* 2235147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235160 */   // MIs[0] Operand 1
     /* 2235160 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235165 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235169 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235173 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2235173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2235176 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235178 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235180 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235182 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235188 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235189 */   // GIR_Coverage, 48377,
     /* 2235189 */   GIR_EraseRootFromParent_Done,
     /* 2235190 */ // Label 29879: @2235190
     /* 2235190 */ GIM_Try, /*On fail goto*//*Label 29880*/ GIMT_Encode4(2235238), // Rule ID 48398 //
     /* 2235195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235201 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2235204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235208 */   // MIs[0] Operand 1
     /* 2235208 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235217 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235221 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2235221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2235224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235226 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235228 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235236 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235237 */   // GIR_Coverage, 48398,
     /* 2235237 */   GIR_EraseRootFromParent_Done,
     /* 2235238 */ // Label 29880: @2235238
     /* 2235238 */ GIM_Try, /*On fail goto*//*Label 29881*/ GIMT_Encode4(2235286), // Rule ID 48399 //
     /* 2235243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235249 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2235252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235256 */   // MIs[0] Operand 1
     /* 2235256 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2235261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235265 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235269 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2235269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2235272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235274 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235276 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235285 */   // GIR_Coverage, 48399,
     /* 2235285 */   GIR_EraseRootFromParent_Done,
     /* 2235286 */ // Label 29881: @2235286
     /* 2235286 */ GIM_Try, /*On fail goto*//*Label 29882*/ GIMT_Encode4(2235334), // Rule ID 48406 //
     /* 2235291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2235297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2235300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235304 */   // MIs[0] Operand 1
     /* 2235304 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235309 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235313 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235317 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2235320 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235322 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235324 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235333 */   // GIR_Coverage, 48406,
     /* 2235333 */   GIR_EraseRootFromParent_Done,
     /* 2235334 */ // Label 29882: @2235334
     /* 2235334 */ GIM_Try, /*On fail goto*//*Label 29883*/ GIMT_Encode4(2235382), // Rule ID 48407 //
     /* 2235339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2235345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2235348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235352 */   // MIs[0] Operand 1
     /* 2235352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235365 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF4),
     /* 2235368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235381 */   // GIR_Coverage, 48407,
     /* 2235381 */   GIR_EraseRootFromParent_Done,
     /* 2235382 */ // Label 29883: @2235382
     /* 2235382 */ GIM_Try, /*On fail goto*//*Label 29884*/ GIMT_Encode4(2235430), // Rule ID 48412 //
     /* 2235387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235393 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235400 */   // MIs[0] Operand 1
     /* 2235400 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235409 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235413 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2235413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2235416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235418 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235420 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235428 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235429 */   // GIR_Coverage, 48412,
     /* 2235429 */   GIR_EraseRootFromParent_Done,
     /* 2235430 */ // Label 29884: @2235430
     /* 2235430 */ GIM_Try, /*On fail goto*//*Label 29885*/ GIMT_Encode4(2235478), // Rule ID 48413 //
     /* 2235435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235441 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235448 */   // MIs[0] Operand 1
     /* 2235448 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235457 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235461 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2235461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2235464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235466 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235468 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235470 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235476 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235477 */   // GIR_Coverage, 48413,
     /* 2235477 */   GIR_EraseRootFromParent_Done,
     /* 2235478 */ // Label 29885: @2235478
     /* 2235478 */ GIM_Try, /*On fail goto*//*Label 29886*/ GIMT_Encode4(2235526), // Rule ID 48420 //
     /* 2235483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235489 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235496 */   // MIs[0] Operand 1
     /* 2235496 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235501 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235505 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235509 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2235509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2235512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235514 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235516 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235525 */   // GIR_Coverage, 48420,
     /* 2235525 */   GIR_EraseRootFromParent_Done,
     /* 2235526 */ // Label 29886: @2235526
     /* 2235526 */ GIM_Try, /*On fail goto*//*Label 29887*/ GIMT_Encode4(2235574), // Rule ID 48421 //
     /* 2235531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235544 */   // MIs[0] Operand 1
     /* 2235544 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235549 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235553 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235557 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2235557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2235560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235562 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235564 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235572 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235573 */   // GIR_Coverage, 48421,
     /* 2235573 */   GIR_EraseRootFromParent_Done,
     /* 2235574 */ // Label 29887: @2235574
     /* 2235574 */ GIM_Try, /*On fail goto*//*Label 29888*/ GIMT_Encode4(2235622), // Rule ID 48442 //
     /* 2235579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235585 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2235588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235592 */   // MIs[0] Operand 1
     /* 2235592 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235597 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235601 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235605 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2235605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2235608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235610 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235612 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235614 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235620 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235621 */   // GIR_Coverage, 48442,
     /* 2235621 */   GIR_EraseRootFromParent_Done,
     /* 2235622 */ // Label 29888: @2235622
     /* 2235622 */ GIM_Try, /*On fail goto*//*Label 29889*/ GIMT_Encode4(2235670), // Rule ID 48443 //
     /* 2235627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2235630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235633 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2235636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235640 */   // MIs[0] Operand 1
     /* 2235640 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2235645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235649 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235653 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2235653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2235656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235658 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235660 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2235668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235669 */   // GIR_Coverage, 48443,
     /* 2235669 */   GIR_EraseRootFromParent_Done,
     /* 2235670 */ // Label 29889: @2235670
     /* 2235670 */ GIM_Try, /*On fail goto*//*Label 29890*/ GIMT_Encode4(2235718), // Rule ID 48450 //
     /* 2235675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2235681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2235684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235688 */   // MIs[0] Operand 1
     /* 2235688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235701 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2235701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2235704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235706 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235716 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235717 */   // GIR_Coverage, 48450,
     /* 2235717 */   GIR_EraseRootFromParent_Done,
     /* 2235718 */ // Label 29890: @2235718
     /* 2235718 */ GIM_Try, /*On fail goto*//*Label 29891*/ GIMT_Encode4(2235766), // Rule ID 48451 //
     /* 2235723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2235729 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2235732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235736 */   // MIs[0] Operand 1
     /* 2235736 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235745 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235749 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2235749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2235752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235754 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235756 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2235764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235765 */   // GIR_Coverage, 48451,
     /* 2235765 */   GIR_EraseRootFromParent_Done,
     /* 2235766 */ // Label 29891: @2235766
     /* 2235766 */ GIM_Try, /*On fail goto*//*Label 29892*/ GIMT_Encode4(2235814), // Rule ID 48456 //
     /* 2235771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235777 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235784 */   // MIs[0] Operand 1
     /* 2235784 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235793 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235797 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2235797 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2235800 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235802 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235804 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235812 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235813 */   // GIR_Coverage, 48456,
     /* 2235813 */   GIR_EraseRootFromParent_Done,
     /* 2235814 */ // Label 29892: @2235814
     /* 2235814 */ GIM_Try, /*On fail goto*//*Label 29893*/ GIMT_Encode4(2235862), // Rule ID 48457 //
     /* 2235819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2235825 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2235828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235832 */   // MIs[0] Operand 1
     /* 2235832 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235841 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235845 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2235845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2235848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235850 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235852 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2235860 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235861 */   // GIR_Coverage, 48457,
     /* 2235861 */   GIR_EraseRootFromParent_Done,
     /* 2235862 */ // Label 29893: @2235862
     /* 2235862 */ GIM_Try, /*On fail goto*//*Label 29894*/ GIMT_Encode4(2235910), // Rule ID 48464 //
     /* 2235867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2235870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235873 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235880 */   // MIs[0] Operand 1
     /* 2235880 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235889 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235893 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2235893 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2235896 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235898 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235900 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235902 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235908 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235909 */   // GIR_Coverage, 48464,
     /* 2235909 */   GIR_EraseRootFromParent_Done,
     /* 2235910 */ // Label 29894: @2235910
     /* 2235910 */ GIM_Try, /*On fail goto*//*Label 29895*/ GIMT_Encode4(2235958), // Rule ID 48465 //
     /* 2235915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2235918 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2235921 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2235924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235928 */   // MIs[0] Operand 1
     /* 2235928 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235933 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235937 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235941 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2235941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2235944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235946 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235948 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235950 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2235953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2235956 */   GIR_RootConstrainSelectedInstOperands,
     /* 2235957 */   // GIR_Coverage, 48465,
     /* 2235957 */   GIR_EraseRootFromParent_Done,
     /* 2235958 */ // Label 29895: @2235958
     /* 2235958 */ GIM_Try, /*On fail goto*//*Label 29896*/ GIMT_Encode4(2236006), // Rule ID 48486 //
     /* 2235963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2235966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2235969 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2235972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2235976 */   // MIs[0] Operand 1
     /* 2235976 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2235981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235985 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2235989 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2235989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2235992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2235994 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2235996 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2235998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236005 */   // GIR_Coverage, 48486,
     /* 2236005 */   GIR_EraseRootFromParent_Done,
     /* 2236006 */ // Label 29896: @2236006
     /* 2236006 */ GIM_Try, /*On fail goto*//*Label 29897*/ GIMT_Encode4(2236054), // Rule ID 48487 //
     /* 2236011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2236017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2236020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236024 */   // MIs[0] Operand 1
     /* 2236024 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2236029 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236033 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236037 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2236040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236042 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236044 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236053 */   // GIR_Coverage, 48487,
     /* 2236053 */   GIR_EraseRootFromParent_Done,
     /* 2236054 */ // Label 29897: @2236054
     /* 2236054 */ GIM_Try, /*On fail goto*//*Label 29898*/ GIMT_Encode4(2236102), // Rule ID 48492 //
     /* 2236059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236065 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236072 */   // MIs[0] Operand 1
     /* 2236072 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236081 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236085 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236092 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236100 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236101 */   // GIR_Coverage, 48492,
     /* 2236101 */   GIR_EraseRootFromParent_Done,
     /* 2236102 */ // Label 29898: @2236102
     /* 2236102 */ GIM_Try, /*On fail goto*//*Label 29899*/ GIMT_Encode4(2236150), // Rule ID 48493 //
     /* 2236107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236113 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236120 */   // MIs[0] Operand 1
     /* 2236120 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236129 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236133 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF4),
     /* 2236136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236138 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236140 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236142 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236148 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236149 */   // GIR_Coverage, 48493,
     /* 2236149 */   GIR_EraseRootFromParent_Done,
     /* 2236150 */ // Label 29899: @2236150
     /* 2236150 */ GIM_Try, /*On fail goto*//*Label 29900*/ GIMT_Encode4(2236198), // Rule ID 48498 //
     /* 2236155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236161 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236168 */   // MIs[0] Operand 1
     /* 2236168 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236177 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236181 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2236181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236186 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236188 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236196 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236197 */   // GIR_Coverage, 48498,
     /* 2236197 */   GIR_EraseRootFromParent_Done,
     /* 2236198 */ // Label 29900: @2236198
     /* 2236198 */ GIM_Try, /*On fail goto*//*Label 29901*/ GIMT_Encode4(2236246), // Rule ID 48499 //
     /* 2236203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236209 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236216 */   // MIs[0] Operand 1
     /* 2236216 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236221 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236225 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236229 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236229 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2236232 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236236 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236244 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236245 */   // GIR_Coverage, 48499,
     /* 2236245 */   GIR_EraseRootFromParent_Done,
     /* 2236246 */ // Label 29901: @2236246
     /* 2236246 */ GIM_Try, /*On fail goto*//*Label 29902*/ GIMT_Encode4(2236294), // Rule ID 48506 //
     /* 2236251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2236257 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2236260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236264 */   // MIs[0] Operand 1
     /* 2236264 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236269 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236273 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236277 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2236277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236280 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236284 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236292 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236293 */   // GIR_Coverage, 48506,
     /* 2236293 */   GIR_EraseRootFromParent_Done,
     /* 2236294 */ // Label 29902: @2236294
     /* 2236294 */ GIM_Try, /*On fail goto*//*Label 29903*/ GIMT_Encode4(2236342), // Rule ID 48507 //
     /* 2236299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2236305 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2236308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236312 */   // MIs[0] Operand 1
     /* 2236312 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236321 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236325 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2236325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2236328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236332 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236341 */   // GIR_Coverage, 48507,
     /* 2236341 */   GIR_EraseRootFromParent_Done,
     /* 2236342 */ // Label 29903: @2236342
     /* 2236342 */ GIM_Try, /*On fail goto*//*Label 29904*/ GIMT_Encode4(2236390), // Rule ID 48528 //
     /* 2236347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2236353 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2236356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236360 */   // MIs[0] Operand 1
     /* 2236360 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236365 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236369 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236373 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2236373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2236376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236380 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236389 */   // GIR_Coverage, 48528,
     /* 2236389 */   GIR_EraseRootFromParent_Done,
     /* 2236390 */ // Label 29904: @2236390
     /* 2236390 */ GIM_Try, /*On fail goto*//*Label 29905*/ GIMT_Encode4(2236438), // Rule ID 48529 //
     /* 2236395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2236401 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2236404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236408 */   // MIs[0] Operand 1
     /* 2236408 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2236413 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236417 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236421 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2236424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236428 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236436 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236437 */   // GIR_Coverage, 48529,
     /* 2236437 */   GIR_EraseRootFromParent_Done,
     /* 2236438 */ // Label 29905: @2236438
     /* 2236438 */ GIM_Try, /*On fail goto*//*Label 29906*/ GIMT_Encode4(2236486), // Rule ID 48536 //
     /* 2236443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236456 */   // MIs[0] Operand 1
     /* 2236456 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236465 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236469 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2236472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236474 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236476 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236485 */   // GIR_Coverage, 48536,
     /* 2236485 */   GIR_EraseRootFromParent_Done,
     /* 2236486 */ // Label 29906: @2236486
     /* 2236486 */ GIM_Try, /*On fail goto*//*Label 29907*/ GIMT_Encode4(2236534), // Rule ID 48537 //
     /* 2236491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236497 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236504 */   // MIs[0] Operand 1
     /* 2236504 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236509 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236513 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236517 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2236520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236522 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236524 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236533 */   // GIR_Coverage, 48537,
     /* 2236533 */   GIR_EraseRootFromParent_Done,
     /* 2236534 */ // Label 29907: @2236534
     /* 2236534 */ GIM_Try, /*On fail goto*//*Label 29908*/ GIMT_Encode4(2236582), // Rule ID 48542 //
     /* 2236539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236545 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236552 */   // MIs[0] Operand 1
     /* 2236552 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236557 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236561 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236565 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2236565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2236568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236570 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236572 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236580 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236581 */   // GIR_Coverage, 48542,
     /* 2236581 */   GIR_EraseRootFromParent_Done,
     /* 2236582 */ // Label 29908: @2236582
     /* 2236582 */ GIM_Try, /*On fail goto*//*Label 29909*/ GIMT_Encode4(2236630), // Rule ID 48543 //
     /* 2236587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236593 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236600 */   // MIs[0] Operand 1
     /* 2236600 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236609 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236613 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2236616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236618 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236620 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236622 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236628 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236629 */   // GIR_Coverage, 48543,
     /* 2236629 */   GIR_EraseRootFromParent_Done,
     /* 2236630 */ // Label 29909: @2236630
     /* 2236630 */ GIM_Try, /*On fail goto*//*Label 29910*/ GIMT_Encode4(2236678), // Rule ID 48550 //
     /* 2236635 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2236641 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2236644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236648 */   // MIs[0] Operand 1
     /* 2236648 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236657 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236661 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2236661 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2236664 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236666 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236668 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236676 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236677 */   // GIR_Coverage, 48550,
     /* 2236677 */   GIR_EraseRootFromParent_Done,
     /* 2236678 */ // Label 29910: @2236678
     /* 2236678 */ GIM_Try, /*On fail goto*//*Label 29911*/ GIMT_Encode4(2236726), // Rule ID 48551 //
     /* 2236683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2236689 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2236692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236696 */   // MIs[0] Operand 1
     /* 2236696 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236705 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236709 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2236709 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2236712 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236714 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236716 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2236724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236725 */   // GIR_Coverage, 48551,
     /* 2236725 */   GIR_EraseRootFromParent_Done,
     /* 2236726 */ // Label 29911: @2236726
     /* 2236726 */ GIM_Try, /*On fail goto*//*Label 29912*/ GIMT_Encode4(2236774), // Rule ID 48572 //
     /* 2236731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2236734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2236737 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2236740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236744 */   // MIs[0] Operand 1
     /* 2236744 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236749 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236753 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236757 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2236757 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2236760 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236762 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236764 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236772 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236773 */   // GIR_Coverage, 48572,
     /* 2236773 */   GIR_EraseRootFromParent_Done,
     /* 2236774 */ // Label 29912: @2236774
     /* 2236774 */ GIM_Try, /*On fail goto*//*Label 29913*/ GIMT_Encode4(2236822), // Rule ID 48573 //
     /* 2236779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2236782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2236785 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2236788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236792 */   // MIs[0] Operand 1
     /* 2236792 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2236797 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236801 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2236805 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2236805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2236808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236810 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2236812 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2236814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2236820 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236821 */   // GIR_Coverage, 48573,
     /* 2236821 */   GIR_EraseRootFromParent_Done,
     /* 2236822 */ // Label 29913: @2236822
     /* 2236822 */ GIM_Try, /*On fail goto*//*Label 29914*/ GIMT_Encode4(2236870), // Rule ID 48580 //
     /* 2236827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236833 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236840 */   // MIs[0] Operand 1
     /* 2236840 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2236845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236849 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236853 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2236853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2236856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236868 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236869 */   // GIR_Coverage, 48580,
     /* 2236869 */   GIR_EraseRootFromParent_Done,
     /* 2236870 */ // Label 29914: @2236870
     /* 2236870 */ GIM_Try, /*On fail goto*//*Label 29915*/ GIMT_Encode4(2236918), // Rule ID 48581 //
     /* 2236875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2236881 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2236884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236888 */   // MIs[0] Operand 1
     /* 2236888 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2236893 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236897 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236901 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2236901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF4),
     /* 2236904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2236916 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236917 */   // GIR_Coverage, 48581,
     /* 2236917 */   GIR_EraseRootFromParent_Done,
     /* 2236918 */ // Label 29915: @2236918
     /* 2236918 */ GIM_Try, /*On fail goto*//*Label 29916*/ GIMT_Encode4(2236966), // Rule ID 48586 //
     /* 2236923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2236926 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236929 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236936 */   // MIs[0] Operand 1
     /* 2236936 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2236941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236945 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236949 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2236949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2236952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2236954 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2236956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2236958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2236961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2236964 */   GIR_RootConstrainSelectedInstOperands,
     /* 2236965 */   // GIR_Coverage, 48586,
     /* 2236965 */   GIR_EraseRootFromParent_Done,
     /* 2236966 */ // Label 29916: @2236966
     /* 2236966 */ GIM_Try, /*On fail goto*//*Label 29917*/ GIMT_Encode4(2237014), // Rule ID 48587 //
     /* 2236971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2236974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2236977 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2236980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236984 */   // MIs[0] Operand 1
     /* 2236984 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2236989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236993 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2236997 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2236997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2237000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237002 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237013 */   // GIR_Coverage, 48587,
     /* 2237013 */   GIR_EraseRootFromParent_Done,
     /* 2237014 */ // Label 29917: @2237014
     /* 2237014 */ GIM_Try, /*On fail goto*//*Label 29918*/ GIMT_Encode4(2237062), // Rule ID 48594 //
     /* 2237019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237025 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237032 */   // MIs[0] Operand 1
     /* 2237032 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237041 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237045 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237050 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237061 */   // GIR_Coverage, 48594,
     /* 2237061 */   GIR_EraseRootFromParent_Done,
     /* 2237062 */ // Label 29918: @2237062
     /* 2237062 */ GIM_Try, /*On fail goto*//*Label 29919*/ GIMT_Encode4(2237110), // Rule ID 48595 //
     /* 2237067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237073 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237080 */   // MIs[0] Operand 1
     /* 2237080 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237085 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237089 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237093 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2237096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237098 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237108 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237109 */   // GIR_Coverage, 48595,
     /* 2237109 */   GIR_EraseRootFromParent_Done,
     /* 2237110 */ // Label 29919: @2237110
     /* 2237110 */ GIM_Try, /*On fail goto*//*Label 29920*/ GIMT_Encode4(2237158), // Rule ID 48616 //
     /* 2237115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237121 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237128 */   // MIs[0] Operand 1
     /* 2237128 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237137 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237141 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2237141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2237144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237146 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237156 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237157 */   // GIR_Coverage, 48616,
     /* 2237157 */   GIR_EraseRootFromParent_Done,
     /* 2237158 */ // Label 29920: @2237158
     /* 2237158 */ GIM_Try, /*On fail goto*//*Label 29921*/ GIMT_Encode4(2237206), // Rule ID 48617 //
     /* 2237163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237166 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237169 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237176 */   // MIs[0] Operand 1
     /* 2237176 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2237181 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237185 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237189 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2237189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2237192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237194 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237205 */   // GIR_Coverage, 48617,
     /* 2237205 */   GIR_EraseRootFromParent_Done,
     /* 2237206 */ // Label 29921: @2237206
     /* 2237206 */ GIM_Try, /*On fail goto*//*Label 29922*/ GIMT_Encode4(2237254), // Rule ID 48624 //
     /* 2237211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237214 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237217 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2237220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237224 */   // MIs[0] Operand 1
     /* 2237224 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237233 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237237 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237242 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237244 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237246 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237252 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237253 */   // GIR_Coverage, 48624,
     /* 2237253 */   GIR_EraseRootFromParent_Done,
     /* 2237254 */ // Label 29922: @2237254
     /* 2237254 */ GIM_Try, /*On fail goto*//*Label 29923*/ GIMT_Encode4(2237302), // Rule ID 48625 //
     /* 2237259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237265 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2237268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237272 */   // MIs[0] Operand 1
     /* 2237272 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237281 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237285 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237290 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237292 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237294 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237300 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237301 */   // GIR_Coverage, 48625,
     /* 2237301 */   GIR_EraseRootFromParent_Done,
     /* 2237302 */ // Label 29923: @2237302
     /* 2237302 */ GIM_Try, /*On fail goto*//*Label 29924*/ GIMT_Encode4(2237350), // Rule ID 48630 //
     /* 2237307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237313 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2237316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237320 */   // MIs[0] Operand 1
     /* 2237320 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237329 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237333 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2237333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237338 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237340 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237348 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237349 */   // GIR_Coverage, 48630,
     /* 2237349 */   GIR_EraseRootFromParent_Done,
     /* 2237350 */ // Label 29924: @2237350
     /* 2237350 */ GIM_Try, /*On fail goto*//*Label 29925*/ GIMT_Encode4(2237398), // Rule ID 48631 //
     /* 2237355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237361 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2237364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237368 */   // MIs[0] Operand 1
     /* 2237368 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237373 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237377 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237381 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2237381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237384 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237386 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237388 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237397 */   // GIR_Coverage, 48631,
     /* 2237397 */   GIR_EraseRootFromParent_Done,
     /* 2237398 */ // Label 29925: @2237398
     /* 2237398 */ GIM_Try, /*On fail goto*//*Label 29926*/ GIMT_Encode4(2237446), // Rule ID 48638 //
     /* 2237403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237406 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237409 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237416 */   // MIs[0] Operand 1
     /* 2237416 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237425 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237429 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2237432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237434 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237436 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237441 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237444 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237445 */   // GIR_Coverage, 48638,
     /* 2237445 */   GIR_EraseRootFromParent_Done,
     /* 2237446 */ // Label 29926: @2237446
     /* 2237446 */ GIM_Try, /*On fail goto*//*Label 29927*/ GIMT_Encode4(2237494), // Rule ID 48639 //
     /* 2237451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237457 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237464 */   // MIs[0] Operand 1
     /* 2237464 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237473 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237477 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2237480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237482 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237484 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237493 */   // GIR_Coverage, 48639,
     /* 2237493 */   GIR_EraseRootFromParent_Done,
     /* 2237494 */ // Label 29927: @2237494
     /* 2237494 */ GIM_Try, /*On fail goto*//*Label 29928*/ GIMT_Encode4(2237542), // Rule ID 48660 //
     /* 2237499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237505 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237512 */   // MIs[0] Operand 1
     /* 2237512 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237517 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237521 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237525 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2237525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2237528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237530 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237532 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237540 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237541 */   // GIR_Coverage, 48660,
     /* 2237541 */   GIR_EraseRootFromParent_Done,
     /* 2237542 */ // Label 29928: @2237542
     /* 2237542 */ GIM_Try, /*On fail goto*//*Label 29929*/ GIMT_Encode4(2237590), // Rule ID 48661 //
     /* 2237547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237550 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237553 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237560 */   // MIs[0] Operand 1
     /* 2237560 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2237565 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237569 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237573 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2237573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2237576 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237578 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2237580 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2237582 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237589 */   // GIR_Coverage, 48661,
     /* 2237589 */   GIR_EraseRootFromParent_Done,
     /* 2237590 */ // Label 29929: @2237590
     /* 2237590 */ GIM_Try, /*On fail goto*//*Label 29930*/ GIMT_Encode4(2237638), // Rule ID 48668 //
     /* 2237595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237601 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2237604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237608 */   // MIs[0] Operand 1
     /* 2237608 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237617 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237621 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2237621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237626 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237636 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237637 */   // GIR_Coverage, 48668,
     /* 2237637 */   GIR_EraseRootFromParent_Done,
     /* 2237638 */ // Label 29930: @2237638
     /* 2237638 */ GIM_Try, /*On fail goto*//*Label 29931*/ GIMT_Encode4(2237686), // Rule ID 48669 //
     /* 2237643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237649 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2237652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237656 */   // MIs[0] Operand 1
     /* 2237656 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237665 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237669 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2237669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF4),
     /* 2237672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237674 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2237684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237685 */   // GIR_Coverage, 48669,
     /* 2237685 */   GIR_EraseRootFromParent_Done,
     /* 2237686 */ // Label 29931: @2237686
     /* 2237686 */ GIM_Try, /*On fail goto*//*Label 29932*/ GIMT_Encode4(2237734), // Rule ID 48674 //
     /* 2237691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237697 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2237700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237704 */   // MIs[0] Operand 1
     /* 2237704 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237709 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237713 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237717 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2237717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237722 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237733 */   // GIR_Coverage, 48674,
     /* 2237733 */   GIR_EraseRootFromParent_Done,
     /* 2237734 */ // Label 29932: @2237734
     /* 2237734 */ GIM_Try, /*On fail goto*//*Label 29933*/ GIMT_Encode4(2237782), // Rule ID 48675 //
     /* 2237739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237742 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2237745 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2237748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237752 */   // MIs[0] Operand 1
     /* 2237752 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237761 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237765 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2237765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2237768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237770 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237772 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2237780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237781 */   // GIR_Coverage, 48675,
     /* 2237781 */   GIR_EraseRootFromParent_Done,
     /* 2237782 */ // Label 29933: @2237782
     /* 2237782 */ GIM_Try, /*On fail goto*//*Label 29934*/ GIMT_Encode4(2237830), // Rule ID 48682 //
     /* 2237787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237790 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237793 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237800 */   // MIs[0] Operand 1
     /* 2237800 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237809 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237813 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2237813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2237816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237818 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237820 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237825 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237828 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237829 */   // GIR_Coverage, 48682,
     /* 2237829 */   GIR_EraseRootFromParent_Done,
     /* 2237830 */ // Label 29934: @2237830
     /* 2237830 */ GIM_Try, /*On fail goto*//*Label 29935*/ GIMT_Encode4(2237878), // Rule ID 48683 //
     /* 2237835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2237838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2237841 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2237844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237848 */   // MIs[0] Operand 1
     /* 2237848 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237853 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237857 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237861 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2237861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2237864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237866 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237868 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237873 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2237876 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237877 */   // GIR_Coverage, 48683,
     /* 2237877 */   GIR_EraseRootFromParent_Done,
     /* 2237878 */ // Label 29935: @2237878
     /* 2237878 */ GIM_Try, /*On fail goto*//*Label 29936*/ GIMT_Encode4(2237926), // Rule ID 48704 //
     /* 2237883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2237886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237889 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237896 */   // MIs[0] Operand 1
     /* 2237896 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237901 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237905 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237909 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2237909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2237912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237914 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237916 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237924 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237925 */   // GIR_Coverage, 48704,
     /* 2237925 */   GIR_EraseRootFromParent_Done,
     /* 2237926 */ // Label 29936: @2237926
     /* 2237926 */ GIM_Try, /*On fail goto*//*Label 29937*/ GIMT_Encode4(2237974), // Rule ID 48705 //
     /* 2237931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2237934 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2237937 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2237940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237944 */   // MIs[0] Operand 1
     /* 2237944 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2237949 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237953 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2237957 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2237957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2237960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2237962 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2237964 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2237966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2237969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2237972 */   GIR_RootConstrainSelectedInstOperands,
     /* 2237973 */   // GIR_Coverage, 48705,
     /* 2237973 */   GIR_EraseRootFromParent_Done,
     /* 2237974 */ // Label 29937: @2237974
     /* 2237974 */ GIM_Try, /*On fail goto*//*Label 29938*/ GIMT_Encode4(2238022), // Rule ID 48712 //
     /* 2237979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2237982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2237985 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2237988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2237992 */   // MIs[0] Operand 1
     /* 2237992 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2237997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238001 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238005 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238010 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238017 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238020 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238021 */   // GIR_Coverage, 48712,
     /* 2238021 */   GIR_EraseRootFromParent_Done,
     /* 2238022 */ // Label 29938: @2238022
     /* 2238022 */ GIM_Try, /*On fail goto*//*Label 29939*/ GIMT_Encode4(2238070), // Rule ID 48713 //
     /* 2238027 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2238033 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2238036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238040 */   // MIs[0] Operand 1
     /* 2238040 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238049 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238053 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238058 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238068 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238069 */   // GIR_Coverage, 48713,
     /* 2238069 */   GIR_EraseRootFromParent_Done,
     /* 2238070 */ // Label 29939: @2238070
     /* 2238070 */ GIM_Try, /*On fail goto*//*Label 29940*/ GIMT_Encode4(2238118), // Rule ID 48718 //
     /* 2238075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2238081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2238084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238088 */   // MIs[0] Operand 1
     /* 2238088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238101 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238117 */   // GIR_Coverage, 48718,
     /* 2238117 */   GIR_EraseRootFromParent_Done,
     /* 2238118 */ // Label 29940: @2238118
     /* 2238118 */ GIM_Try, /*On fail goto*//*Label 29941*/ GIMT_Encode4(2238166), // Rule ID 48719 //
     /* 2238123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2238129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2238132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238136 */   // MIs[0] Operand 1
     /* 2238136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238149 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2238149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238154 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238165 */   // GIR_Coverage, 48719,
     /* 2238165 */   GIR_EraseRootFromParent_Done,
     /* 2238166 */ // Label 29941: @2238166
     /* 2238166 */ GIM_Try, /*On fail goto*//*Label 29942*/ GIMT_Encode4(2238214), // Rule ID 48726 //
     /* 2238171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2238177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2238180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238184 */   // MIs[0] Operand 1
     /* 2238184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238197 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2238197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238213 */   // GIR_Coverage, 48726,
     /* 2238213 */   GIR_EraseRootFromParent_Done,
     /* 2238214 */ // Label 29942: @2238214
     /* 2238214 */ GIM_Try, /*On fail goto*//*Label 29943*/ GIMT_Encode4(2238262), // Rule ID 48727 //
     /* 2238219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2238225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2238228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238232 */   // MIs[0] Operand 1
     /* 2238232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238245 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2238245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238261 */   // GIR_Coverage, 48727,
     /* 2238261 */   GIR_EraseRootFromParent_Done,
     /* 2238262 */ // Label 29943: @2238262
     /* 2238262 */ GIM_Try, /*On fail goto*//*Label 29944*/ GIMT_Encode4(2238310), // Rule ID 48748 //
     /* 2238267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2238276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238280 */   // MIs[0] Operand 1
     /* 2238280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238293 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2238293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2238296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238309 */   // GIR_Coverage, 48748,
     /* 2238309 */   GIR_EraseRootFromParent_Done,
     /* 2238310 */ // Label 29944: @2238310
     /* 2238310 */ GIM_Try, /*On fail goto*//*Label 29945*/ GIMT_Encode4(2238358), // Rule ID 48749 //
     /* 2238315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2238324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238328 */   // MIs[0] Operand 1
     /* 2238328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2238333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238341 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2238341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2238344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238357 */   // GIR_Coverage, 48749,
     /* 2238357 */   GIR_EraseRootFromParent_Done,
     /* 2238358 */ // Label 29945: @2238358
     /* 2238358 */ GIM_Try, /*On fail goto*//*Label 29946*/ GIMT_Encode4(2238406), // Rule ID 48756 //
     /* 2238363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2238369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2238372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238376 */   // MIs[0] Operand 1
     /* 2238376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238389 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238394 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238405 */   // GIR_Coverage, 48756,
     /* 2238405 */   GIR_EraseRootFromParent_Done,
     /* 2238406 */ // Label 29946: @2238406
     /* 2238406 */ GIM_Try, /*On fail goto*//*Label 29947*/ GIMT_Encode4(2238454), // Rule ID 48757 //
     /* 2238411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2238417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2238420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238424 */   // MIs[0] Operand 1
     /* 2238424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238437 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF4:{ *:[nxv2i1] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF4),
     /* 2238440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238442 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238453 */   // GIR_Coverage, 48757,
     /* 2238453 */   GIR_EraseRootFromParent_Done,
     /* 2238454 */ // Label 29947: @2238454
     /* 2238454 */ GIM_Try, /*On fail goto*//*Label 29948*/ GIMT_Encode4(2238502), // Rule ID 48762 //
     /* 2238459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2238465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2238468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238472 */   // MIs[0] Operand 1
     /* 2238472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238485 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238490 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238501 */   // GIR_Coverage, 48762,
     /* 2238501 */   GIR_EraseRootFromParent_Done,
     /* 2238502 */ // Label 29948: @2238502
     /* 2238502 */ GIM_Try, /*On fail goto*//*Label 29949*/ GIMT_Encode4(2238550), // Rule ID 48763 //
     /* 2238507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2238513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2238516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238520 */   // MIs[0] Operand 1
     /* 2238520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238533 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2238533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2238536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238538 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238540 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238549 */   // GIR_Coverage, 48763,
     /* 2238549 */   GIR_EraseRootFromParent_Done,
     /* 2238550 */ // Label 29949: @2238550
     /* 2238550 */ GIM_Try, /*On fail goto*//*Label 29950*/ GIMT_Encode4(2238598), // Rule ID 48770 //
     /* 2238555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2238561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2238564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238568 */   // MIs[0] Operand 1
     /* 2238568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238581 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2238581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238586 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238588 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238597 */   // GIR_Coverage, 48770,
     /* 2238597 */   GIR_EraseRootFromParent_Done,
     /* 2238598 */ // Label 29950: @2238598
     /* 2238598 */ GIM_Try, /*On fail goto*//*Label 29951*/ GIMT_Encode4(2238646), // Rule ID 48771 //
     /* 2238603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2238609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2238612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238616 */   // MIs[0] Operand 1
     /* 2238616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238629 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2238629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2238632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238634 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238636 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238645 */   // GIR_Coverage, 48771,
     /* 2238645 */   GIR_EraseRootFromParent_Done,
     /* 2238646 */ // Label 29951: @2238646
     /* 2238646 */ GIM_Try, /*On fail goto*//*Label 29952*/ GIMT_Encode4(2238694), // Rule ID 48792 //
     /* 2238651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2238654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2238660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238664 */   // MIs[0] Operand 1
     /* 2238664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238677 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2238677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2238680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238682 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238684 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238693 */   // GIR_Coverage, 48792,
     /* 2238693 */   GIR_EraseRootFromParent_Done,
     /* 2238694 */ // Label 29952: @2238694
     /* 2238694 */ GIM_Try, /*On fail goto*//*Label 29953*/ GIMT_Encode4(2238742), // Rule ID 48793 //
     /* 2238699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2238702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2238705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2238708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238712 */   // MIs[0] Operand 1
     /* 2238712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2238717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238725 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2238725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2238728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238730 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2238732 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2238734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2238740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238741 */   // GIR_Coverage, 48793,
     /* 2238741 */   GIR_EraseRootFromParent_Done,
     /* 2238742 */ // Label 29953: @2238742
     /* 2238742 */ GIM_Reject,
     /* 2238743 */ // Label 29694: @2238743
     /* 2238743 */ GIM_Try, /*On fail goto*//*Label 29954*/ GIMT_Encode4(2238791), // Rule ID 48364 //
     /* 2238748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2238754 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2238757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238761 */   // MIs[0] Operand 1
     /* 2238761 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2238766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238770 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238774 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2238774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2238777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238779 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238781 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238790 */   // GIR_Coverage, 48364,
     /* 2238790 */   GIR_EraseRootFromParent_Done,
     /* 2238791 */ // Label 29954: @2238791
     /* 2238791 */ GIM_Try, /*On fail goto*//*Label 29955*/ GIMT_Encode4(2238839), // Rule ID 48365 //
     /* 2238796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2238802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2238805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238809 */   // MIs[0] Operand 1
     /* 2238809 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2238814 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238818 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238822 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2238822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_MF2),
     /* 2238825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238827 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238829 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238831 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2238837 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238838 */   // GIR_Coverage, 48365,
     /* 2238838 */   GIR_EraseRootFromParent_Done,
     /* 2238839 */ // Label 29955: @2238839
     /* 2238839 */ GIM_Try, /*On fail goto*//*Label 29956*/ GIMT_Encode4(2238887), // Rule ID 48374 //
     /* 2238844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2238850 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2238853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238857 */   // MIs[0] Operand 1
     /* 2238857 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2238862 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238866 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238870 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2238870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2238873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238875 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238877 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238885 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238886 */   // GIR_Coverage, 48374,
     /* 2238886 */   GIR_EraseRootFromParent_Done,
     /* 2238887 */ // Label 29956: @2238887
     /* 2238887 */ GIM_Try, /*On fail goto*//*Label 29957*/ GIMT_Encode4(2238935), // Rule ID 48375 //
     /* 2238892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2238898 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2238901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238905 */   // MIs[0] Operand 1
     /* 2238905 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2238910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238914 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238918 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2238918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2238921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238923 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238925 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2238933 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238934 */   // GIR_Coverage, 48375,
     /* 2238934 */   GIR_EraseRootFromParent_Done,
     /* 2238935 */ // Label 29957: @2238935
     /* 2238935 */ GIM_Try, /*On fail goto*//*Label 29958*/ GIMT_Encode4(2238983), // Rule ID 48392 //
     /* 2238940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2238943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2238946 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2238949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2238953 */   // MIs[0] Operand 1
     /* 2238953 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2238958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238962 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2238966 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2238966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2238969 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2238971 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2238973 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2238975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2238978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2238981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2238982 */   // GIR_Coverage, 48392,
     /* 2238982 */   GIR_EraseRootFromParent_Done,
     /* 2238983 */ // Label 29958: @2238983
     /* 2238983 */ GIM_Try, /*On fail goto*//*Label 29959*/ GIMT_Encode4(2239031), // Rule ID 48393 //
     /* 2238988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2238991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2238994 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2238997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239001 */   // MIs[0] Operand 1
     /* 2239001 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239006 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239010 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239014 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2239017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239019 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239021 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239029 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239030 */   // GIR_Coverage, 48393,
     /* 2239030 */   GIR_EraseRootFromParent_Done,
     /* 2239031 */ // Label 29959: @2239031
     /* 2239031 */ GIM_Try, /*On fail goto*//*Label 29960*/ GIMT_Encode4(2239079), // Rule ID 48400 //
     /* 2239036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239042 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239049 */   // MIs[0] Operand 1
     /* 2239049 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239054 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239058 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239062 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2239065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239067 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239069 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239071 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239077 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239078 */   // GIR_Coverage, 48400,
     /* 2239078 */   GIR_EraseRootFromParent_Done,
     /* 2239079 */ // Label 29960: @2239079
     /* 2239079 */ GIM_Try, /*On fail goto*//*Label 29961*/ GIMT_Encode4(2239127), // Rule ID 48401 //
     /* 2239084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239090 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239097 */   // MIs[0] Operand 1
     /* 2239097 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2239102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239106 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239110 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2239113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239115 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239117 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239119 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239125 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239126 */   // GIR_Coverage, 48401,
     /* 2239126 */   GIR_EraseRootFromParent_Done,
     /* 2239127 */ // Label 29961: @2239127
     /* 2239127 */ GIM_Try, /*On fail goto*//*Label 29962*/ GIMT_Encode4(2239175), // Rule ID 48408 //
     /* 2239132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239138 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239145 */   // MIs[0] Operand 1
     /* 2239145 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239154 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239158 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2239161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239163 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239165 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239167 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239174 */   // GIR_Coverage, 48408,
     /* 2239174 */   GIR_EraseRootFromParent_Done,
     /* 2239175 */ // Label 29962: @2239175
     /* 2239175 */ GIM_Try, /*On fail goto*//*Label 29963*/ GIMT_Encode4(2239223), // Rule ID 48409 //
     /* 2239180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239193 */   // MIs[0] Operand 1
     /* 2239193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239206 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_MF2),
     /* 2239209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239221 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239222 */   // GIR_Coverage, 48409,
     /* 2239222 */   GIR_EraseRootFromParent_Done,
     /* 2239223 */ // Label 29963: @2239223
     /* 2239223 */ GIM_Try, /*On fail goto*//*Label 29964*/ GIMT_Encode4(2239271), // Rule ID 48418 //
     /* 2239228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2239234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2239237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239241 */   // MIs[0] Operand 1
     /* 2239241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239254 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2239254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2239257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239270 */   // GIR_Coverage, 48418,
     /* 2239270 */   GIR_EraseRootFromParent_Done,
     /* 2239271 */ // Label 29964: @2239271
     /* 2239271 */ GIM_Try, /*On fail goto*//*Label 29965*/ GIMT_Encode4(2239319), // Rule ID 48419 //
     /* 2239276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2239282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2239285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239289 */   // MIs[0] Operand 1
     /* 2239289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239302 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2239302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2239305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239318 */   // GIR_Coverage, 48419,
     /* 2239318 */   GIR_EraseRootFromParent_Done,
     /* 2239319 */ // Label 29965: @2239319
     /* 2239319 */ GIM_Try, /*On fail goto*//*Label 29966*/ GIMT_Encode4(2239367), // Rule ID 48436 //
     /* 2239324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2239330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2239333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239337 */   // MIs[0] Operand 1
     /* 2239337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239350 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2239350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2239353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239366 */   // GIR_Coverage, 48436,
     /* 2239366 */   GIR_EraseRootFromParent_Done,
     /* 2239367 */ // Label 29966: @2239367
     /* 2239367 */ GIM_Try, /*On fail goto*//*Label 29967*/ GIMT_Encode4(2239415), // Rule ID 48437 //
     /* 2239372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2239378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2239381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239385 */   // MIs[0] Operand 1
     /* 2239385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239398 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2239401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239414 */   // GIR_Coverage, 48437,
     /* 2239414 */   GIR_EraseRootFromParent_Done,
     /* 2239415 */ // Label 29967: @2239415
     /* 2239415 */ GIM_Try, /*On fail goto*//*Label 29968*/ GIMT_Encode4(2239463), // Rule ID 48444 //
     /* 2239420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239433 */   // MIs[0] Operand 1
     /* 2239433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239446 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2239449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239462 */   // GIR_Coverage, 48444,
     /* 2239462 */   GIR_EraseRootFromParent_Done,
     /* 2239463 */ // Label 29968: @2239463
     /* 2239463 */ GIM_Try, /*On fail goto*//*Label 29969*/ GIMT_Encode4(2239511), // Rule ID 48445 //
     /* 2239468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239481 */   // MIs[0] Operand 1
     /* 2239481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2239486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239494 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2239497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239510 */   // GIR_Coverage, 48445,
     /* 2239510 */   GIR_EraseRootFromParent_Done,
     /* 2239511 */ // Label 29969: @2239511
     /* 2239511 */ GIM_Try, /*On fail goto*//*Label 29970*/ GIMT_Encode4(2239559), // Rule ID 48452 //
     /* 2239516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239529 */   // MIs[0] Operand 1
     /* 2239529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239542 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2239545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239558 */   // GIR_Coverage, 48452,
     /* 2239558 */   GIR_EraseRootFromParent_Done,
     /* 2239559 */ // Label 29970: @2239559
     /* 2239559 */ GIM_Try, /*On fail goto*//*Label 29971*/ GIMT_Encode4(2239607), // Rule ID 48453 //
     /* 2239564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239577 */   // MIs[0] Operand 1
     /* 2239577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239590 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2239593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239595 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239597 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239606 */   // GIR_Coverage, 48453,
     /* 2239606 */   GIR_EraseRootFromParent_Done,
     /* 2239607 */ // Label 29971: @2239607
     /* 2239607 */ GIM_Try, /*On fail goto*//*Label 29972*/ GIMT_Encode4(2239655), // Rule ID 48462 //
     /* 2239612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2239618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2239621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239625 */   // MIs[0] Operand 1
     /* 2239625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239638 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2239638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2239641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239643 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239645 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239654 */   // GIR_Coverage, 48462,
     /* 2239654 */   GIR_EraseRootFromParent_Done,
     /* 2239655 */ // Label 29972: @2239655
     /* 2239655 */ GIM_Try, /*On fail goto*//*Label 29973*/ GIMT_Encode4(2239703), // Rule ID 48463 //
     /* 2239660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2239666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2239669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239673 */   // MIs[0] Operand 1
     /* 2239673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239686 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2239686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2239689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239691 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2239701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239702 */   // GIR_Coverage, 48463,
     /* 2239702 */   GIR_EraseRootFromParent_Done,
     /* 2239703 */ // Label 29973: @2239703
     /* 2239703 */ GIM_Try, /*On fail goto*//*Label 29974*/ GIMT_Encode4(2239751), // Rule ID 48480 //
     /* 2239708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2239714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2239717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239721 */   // MIs[0] Operand 1
     /* 2239721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239734 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2239734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2239737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239750 */   // GIR_Coverage, 48480,
     /* 2239750 */   GIR_EraseRootFromParent_Done,
     /* 2239751 */ // Label 29974: @2239751
     /* 2239751 */ GIM_Try, /*On fail goto*//*Label 29975*/ GIMT_Encode4(2239799), // Rule ID 48481 //
     /* 2239756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2239762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2239765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239769 */   // MIs[0] Operand 1
     /* 2239769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2239782 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2239782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2239785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2239797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239798 */   // GIR_Coverage, 48481,
     /* 2239798 */   GIR_EraseRootFromParent_Done,
     /* 2239799 */ // Label 29975: @2239799
     /* 2239799 */ GIM_Try, /*On fail goto*//*Label 29976*/ GIMT_Encode4(2239847), // Rule ID 48488 //
     /* 2239804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2239807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239817 */   // MIs[0] Operand 1
     /* 2239817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239830 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2239830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2239833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239846 */   // GIR_Coverage, 48488,
     /* 2239846 */   GIR_EraseRootFromParent_Done,
     /* 2239847 */ // Label 29976: @2239847
     /* 2239847 */ GIM_Try, /*On fail goto*//*Label 29977*/ GIMT_Encode4(2239895), // Rule ID 48489 //
     /* 2239852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2239855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2239858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2239861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239865 */   // MIs[0] Operand 1
     /* 2239865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2239870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2239878 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2239878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2239881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2239885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2239887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2239893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239894 */   // GIR_Coverage, 48489,
     /* 2239894 */   GIR_EraseRootFromParent_Done,
     /* 2239895 */ // Label 29977: @2239895
     /* 2239895 */ GIM_Try, /*On fail goto*//*Label 29978*/ GIMT_Encode4(2239943), // Rule ID 48494 //
     /* 2239900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239913 */   // MIs[0] Operand 1
     /* 2239913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2239918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239926 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2239926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2239929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239931 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239933 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239942 */   // GIR_Coverage, 48494,
     /* 2239942 */   GIR_EraseRootFromParent_Done,
     /* 2239943 */ // Label 29978: @2239943
     /* 2239943 */ GIM_Try, /*On fail goto*//*Label 29979*/ GIMT_Encode4(2239991), // Rule ID 48495 //
     /* 2239948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2239951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2239954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2239957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239961 */   // MIs[0] Operand 1
     /* 2239961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2239966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2239974 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2239974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_MF2),
     /* 2239977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2239979 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2239981 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2239983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2239986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2239989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2239990 */   // GIR_Coverage, 48495,
     /* 2239990 */   GIR_EraseRootFromParent_Done,
     /* 2239991 */ // Label 29979: @2239991
     /* 2239991 */ GIM_Try, /*On fail goto*//*Label 29980*/ GIMT_Encode4(2240039), // Rule ID 48504 //
     /* 2239996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2239999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240009 */   // MIs[0] Operand 1
     /* 2240009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240022 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240027 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240029 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240038 */   // GIR_Coverage, 48504,
     /* 2240038 */   GIR_EraseRootFromParent_Done,
     /* 2240039 */ // Label 29980: @2240039
     /* 2240039 */ GIM_Try, /*On fail goto*//*Label 29981*/ GIMT_Encode4(2240087), // Rule ID 48505 //
     /* 2240044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240057 */   // MIs[0] Operand 1
     /* 2240057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240070 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2240073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240075 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240077 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240086 */   // GIR_Coverage, 48505,
     /* 2240086 */   GIR_EraseRootFromParent_Done,
     /* 2240087 */ // Label 29981: @2240087
     /* 2240087 */ GIM_Try, /*On fail goto*//*Label 29982*/ GIMT_Encode4(2240135), // Rule ID 48522 //
     /* 2240092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240105 */   // MIs[0] Operand 1
     /* 2240105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240118 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240123 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240125 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240134 */   // GIR_Coverage, 48522,
     /* 2240134 */   GIR_EraseRootFromParent_Done,
     /* 2240135 */ // Label 29982: @2240135
     /* 2240135 */ GIM_Try, /*On fail goto*//*Label 29983*/ GIMT_Encode4(2240183), // Rule ID 48523 //
     /* 2240140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240153 */   // MIs[0] Operand 1
     /* 2240153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240166 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2240166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2240169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240173 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240182 */   // GIR_Coverage, 48523,
     /* 2240182 */   GIR_EraseRootFromParent_Done,
     /* 2240183 */ // Label 29983: @2240183
     /* 2240183 */ GIM_Try, /*On fail goto*//*Label 29984*/ GIMT_Encode4(2240231), // Rule ID 48530 //
     /* 2240188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2240194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2240197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240201 */   // MIs[0] Operand 1
     /* 2240201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240214 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2240214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2240217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240219 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240221 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240230 */   // GIR_Coverage, 48530,
     /* 2240230 */   GIR_EraseRootFromParent_Done,
     /* 2240231 */ // Label 29984: @2240231
     /* 2240231 */ GIM_Try, /*On fail goto*//*Label 29985*/ GIMT_Encode4(2240279), // Rule ID 48531 //
     /* 2240236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2240239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2240242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2240245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240249 */   // MIs[0] Operand 1
     /* 2240249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2240254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240262 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2240262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2240265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240267 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240269 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240278 */   // GIR_Coverage, 48531,
     /* 2240278 */   GIR_EraseRootFromParent_Done,
     /* 2240279 */ // Label 29985: @2240279
     /* 2240279 */ GIM_Try, /*On fail goto*//*Label 29986*/ GIMT_Encode4(2240327), // Rule ID 48538 //
     /* 2240284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2240290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2240293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240297 */   // MIs[0] Operand 1
     /* 2240297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240310 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240315 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240326 */   // GIR_Coverage, 48538,
     /* 2240326 */   GIR_EraseRootFromParent_Done,
     /* 2240327 */ // Label 29986: @2240327
     /* 2240327 */ GIM_Try, /*On fail goto*//*Label 29987*/ GIMT_Encode4(2240375), // Rule ID 48539 //
     /* 2240332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2240338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2240341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240345 */   // MIs[0] Operand 1
     /* 2240345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240358 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240363 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240374 */   // GIR_Coverage, 48539,
     /* 2240374 */   GIR_EraseRootFromParent_Done,
     /* 2240375 */ // Label 29987: @2240375
     /* 2240375 */ GIM_Try, /*On fail goto*//*Label 29988*/ GIMT_Encode4(2240423), // Rule ID 48548 //
     /* 2240380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240386 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240393 */   // MIs[0] Operand 1
     /* 2240393 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240402 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240406 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240406 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2240409 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240411 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240413 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240422 */   // GIR_Coverage, 48548,
     /* 2240422 */   GIR_EraseRootFromParent_Done,
     /* 2240423 */ // Label 29988: @2240423
     /* 2240423 */ GIM_Try, /*On fail goto*//*Label 29989*/ GIMT_Encode4(2240471), // Rule ID 48549 //
     /* 2240428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240441 */   // MIs[0] Operand 1
     /* 2240441 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240450 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240454 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2240457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240459 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240461 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240469 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240470 */   // GIR_Coverage, 48549,
     /* 2240470 */   GIR_EraseRootFromParent_Done,
     /* 2240471 */ // Label 29989: @2240471
     /* 2240471 */ GIM_Try, /*On fail goto*//*Label 29990*/ GIMT_Encode4(2240519), // Rule ID 48566 //
     /* 2240476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240482 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240489 */   // MIs[0] Operand 1
     /* 2240489 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240494 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240498 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240502 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2240505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240507 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240509 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240517 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240518 */   // GIR_Coverage, 48566,
     /* 2240518 */   GIR_EraseRootFromParent_Done,
     /* 2240519 */ // Label 29990: @2240519
     /* 2240519 */ GIM_Try, /*On fail goto*//*Label 29991*/ GIMT_Encode4(2240567), // Rule ID 48567 //
     /* 2240524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240527 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240530 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240537 */   // MIs[0] Operand 1
     /* 2240537 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240542 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240546 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240550 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2240550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2240553 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240555 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240557 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240559 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240562 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240565 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240566 */   // GIR_Coverage, 48567,
     /* 2240566 */   GIR_EraseRootFromParent_Done,
     /* 2240567 */ // Label 29991: @2240567
     /* 2240567 */ GIM_Try, /*On fail goto*//*Label 29992*/ GIMT_Encode4(2240615), // Rule ID 48574 //
     /* 2240572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2240578 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2240581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240585 */   // MIs[0] Operand 1
     /* 2240585 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240594 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240598 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2240598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2240601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240603 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240605 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240607 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240613 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240614 */   // GIR_Coverage, 48574,
     /* 2240614 */   GIR_EraseRootFromParent_Done,
     /* 2240615 */ // Label 29992: @2240615
     /* 2240615 */ GIM_Try, /*On fail goto*//*Label 29993*/ GIMT_Encode4(2240663), // Rule ID 48575 //
     /* 2240620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2240623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2240626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2240629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240633 */   // MIs[0] Operand 1
     /* 2240633 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2240638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240642 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240646 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2240646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2240649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240651 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2240653 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2240655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240662 */   // GIR_Coverage, 48575,
     /* 2240662 */   GIR_EraseRootFromParent_Done,
     /* 2240663 */ // Label 29993: @2240663
     /* 2240663 */ GIM_Try, /*On fail goto*//*Label 29994*/ GIMT_Encode4(2240711), // Rule ID 48582 //
     /* 2240668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2240674 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2240677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240681 */   // MIs[0] Operand 1
     /* 2240681 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240690 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240694 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2240694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240699 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240709 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240710 */   // GIR_Coverage, 48582,
     /* 2240710 */   GIR_EraseRootFromParent_Done,
     /* 2240711 */ // Label 29994: @2240711
     /* 2240711 */ GIM_Try, /*On fail goto*//*Label 29995*/ GIMT_Encode4(2240759), // Rule ID 48583 //
     /* 2240716 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2240722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2240725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240729 */   // MIs[0] Operand 1
     /* 2240729 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240738 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240742 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2240742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_MF2),
     /* 2240745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240747 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240749 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240751 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2240757 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240758 */   // GIR_Coverage, 48583,
     /* 2240758 */   GIR_EraseRootFromParent_Done,
     /* 2240759 */ // Label 29995: @2240759
     /* 2240759 */ GIM_Try, /*On fail goto*//*Label 29996*/ GIMT_Encode4(2240807), // Rule ID 48592 //
     /* 2240764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240777 */   // MIs[0] Operand 1
     /* 2240777 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240782 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240786 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240790 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2240790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2240793 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240795 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240797 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240799 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240802 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240805 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240806 */   // GIR_Coverage, 48592,
     /* 2240806 */   GIR_EraseRootFromParent_Done,
     /* 2240807 */ // Label 29996: @2240807
     /* 2240807 */ GIM_Try, /*On fail goto*//*Label 29997*/ GIMT_Encode4(2240855), // Rule ID 48593 //
     /* 2240812 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2240818 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2240821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240825 */   // MIs[0] Operand 1
     /* 2240825 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240838 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2240838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2240841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240843 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240845 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240847 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240850 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2240853 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240854 */   // GIR_Coverage, 48593,
     /* 2240854 */   GIR_EraseRootFromParent_Done,
     /* 2240855 */ // Label 29997: @2240855
     /* 2240855 */ GIM_Try, /*On fail goto*//*Label 29998*/ GIMT_Encode4(2240903), // Rule ID 48610 //
     /* 2240860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2240863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240866 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240873 */   // MIs[0] Operand 1
     /* 2240873 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240882 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240886 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2240886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2240889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240891 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240902 */   // GIR_Coverage, 48610,
     /* 2240902 */   GIR_EraseRootFromParent_Done,
     /* 2240903 */ // Label 29998: @2240903
     /* 2240903 */ GIM_Try, /*On fail goto*//*Label 29999*/ GIMT_Encode4(2240951), // Rule ID 48611 //
     /* 2240908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2240911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2240914 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2240917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240921 */   // MIs[0] Operand 1
     /* 2240921 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240930 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2240934 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2240934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2240937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240939 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2240949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240950 */   // GIR_Coverage, 48611,
     /* 2240950 */   GIR_EraseRootFromParent_Done,
     /* 2240951 */ // Label 29999: @2240951
     /* 2240951 */ GIM_Try, /*On fail goto*//*Label 30000*/ GIMT_Encode4(2240999), // Rule ID 48618 //
     /* 2240956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2240959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2240962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2240965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2240969 */   // MIs[0] Operand 1
     /* 2240969 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2240974 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240978 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2240982 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2240982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2240985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2240987 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2240989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2240991 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2240994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2240997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2240998 */   // GIR_Coverage, 48618,
     /* 2240998 */   GIR_EraseRootFromParent_Done,
     /* 2240999 */ // Label 30000: @2240999
     /* 2240999 */ GIM_Try, /*On fail goto*//*Label 30001*/ GIMT_Encode4(2241047), // Rule ID 48619 //
     /* 2241004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241010 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2241013 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241017 */   // MIs[0] Operand 1
     /* 2241017 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2241022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241026 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241030 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2241033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241035 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241046 */   // GIR_Coverage, 48619,
     /* 2241046 */   GIR_EraseRootFromParent_Done,
     /* 2241047 */ // Label 30001: @2241047
     /* 2241047 */ GIM_Try, /*On fail goto*//*Label 30002*/ GIMT_Encode4(2241095), // Rule ID 48626 //
     /* 2241052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241058 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241065 */   // MIs[0] Operand 1
     /* 2241065 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241074 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241078 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241083 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241085 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241093 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241094 */   // GIR_Coverage, 48626,
     /* 2241094 */   GIR_EraseRootFromParent_Done,
     /* 2241095 */ // Label 30002: @2241095
     /* 2241095 */ GIM_Try, /*On fail goto*//*Label 30003*/ GIMT_Encode4(2241143), // Rule ID 48627 //
     /* 2241100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241113 */   // MIs[0] Operand 1
     /* 2241113 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241122 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241126 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241131 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241133 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241142 */   // GIR_Coverage, 48627,
     /* 2241142 */   GIR_EraseRootFromParent_Done,
     /* 2241143 */ // Label 30003: @2241143
     /* 2241143 */ GIM_Try, /*On fail goto*//*Label 30004*/ GIMT_Encode4(2241191), // Rule ID 48636 //
     /* 2241148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241161 */   // MIs[0] Operand 1
     /* 2241161 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241170 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241174 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2241174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241179 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241181 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241189 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241190 */   // GIR_Coverage, 48636,
     /* 2241190 */   GIR_EraseRootFromParent_Done,
     /* 2241191 */ // Label 30004: @2241191
     /* 2241191 */ GIM_Try, /*On fail goto*//*Label 30005*/ GIMT_Encode4(2241239), // Rule ID 48637 //
     /* 2241196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241202 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241209 */   // MIs[0] Operand 1
     /* 2241209 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241218 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241222 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2241222 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241225 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241227 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241229 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241237 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241238 */   // GIR_Coverage, 48637,
     /* 2241238 */   GIR_EraseRootFromParent_Done,
     /* 2241239 */ // Label 30005: @2241239
     /* 2241239 */ GIM_Try, /*On fail goto*//*Label 30006*/ GIMT_Encode4(2241287), // Rule ID 48654 //
     /* 2241244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241250 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2241253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241257 */   // MIs[0] Operand 1
     /* 2241257 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241266 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241270 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2241270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241275 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241277 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241282 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241285 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241286 */   // GIR_Coverage, 48654,
     /* 2241286 */   GIR_EraseRootFromParent_Done,
     /* 2241287 */ // Label 30006: @2241287
     /* 2241287 */ GIM_Try, /*On fail goto*//*Label 30007*/ GIMT_Encode4(2241335), // Rule ID 48655 //
     /* 2241292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241298 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2241301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241305 */   // MIs[0] Operand 1
     /* 2241305 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241314 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241318 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2241318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241323 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241334 */   // GIR_Coverage, 48655,
     /* 2241334 */   GIR_EraseRootFromParent_Done,
     /* 2241335 */ // Label 30007: @2241335
     /* 2241335 */ GIM_Try, /*On fail goto*//*Label 30008*/ GIMT_Encode4(2241383), // Rule ID 48662 //
     /* 2241340 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241346 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2241349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241353 */   // MIs[0] Operand 1
     /* 2241353 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241358 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241362 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241366 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2241366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2241369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241371 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241382 */   // GIR_Coverage, 48662,
     /* 2241382 */   GIR_EraseRootFromParent_Done,
     /* 2241383 */ // Label 30008: @2241383
     /* 2241383 */ GIM_Try, /*On fail goto*//*Label 30009*/ GIMT_Encode4(2241431), // Rule ID 48663 //
     /* 2241388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241391 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241394 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2241397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241401 */   // MIs[0] Operand 1
     /* 2241401 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2241406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241410 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241414 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2241417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241419 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241429 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241430 */   // GIR_Coverage, 48663,
     /* 2241430 */   GIR_EraseRootFromParent_Done,
     /* 2241431 */ // Label 30009: @2241431
     /* 2241431 */ GIM_Try, /*On fail goto*//*Label 30010*/ GIMT_Encode4(2241479), // Rule ID 48670 //
     /* 2241436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241442 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241449 */   // MIs[0] Operand 1
     /* 2241449 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241458 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241462 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241467 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241469 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241478 */   // GIR_Coverage, 48670,
     /* 2241478 */   GIR_EraseRootFromParent_Done,
     /* 2241479 */ // Label 30010: @2241479
     /* 2241479 */ GIM_Try, /*On fail goto*//*Label 30011*/ GIMT_Encode4(2241527), // Rule ID 48671 //
     /* 2241484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241490 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241497 */   // MIs[0] Operand 1
     /* 2241497 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241502 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241506 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241510 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_MF2),
     /* 2241513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241515 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241517 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241525 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241526 */   // GIR_Coverage, 48671,
     /* 2241526 */   GIR_EraseRootFromParent_Done,
     /* 2241527 */ // Label 30011: @2241527
     /* 2241527 */ GIM_Try, /*On fail goto*//*Label 30012*/ GIMT_Encode4(2241575), // Rule ID 48680 //
     /* 2241532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241535 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241538 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241545 */   // MIs[0] Operand 1
     /* 2241545 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241554 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241558 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2241558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241561 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241563 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241565 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241570 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241573 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241574 */   // GIR_Coverage, 48680,
     /* 2241574 */   GIR_EraseRootFromParent_Done,
     /* 2241575 */ // Label 30012: @2241575
     /* 2241575 */ GIM_Try, /*On fail goto*//*Label 30013*/ GIMT_Encode4(2241623), // Rule ID 48681 //
     /* 2241580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241586 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241593 */   // MIs[0] Operand 1
     /* 2241593 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241598 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241602 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241606 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2241606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2241609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241611 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241622 */   // GIR_Coverage, 48681,
     /* 2241622 */   GIR_EraseRootFromParent_Done,
     /* 2241623 */ // Label 30013: @2241623
     /* 2241623 */ GIM_Try, /*On fail goto*//*Label 30014*/ GIMT_Encode4(2241671), // Rule ID 48698 //
     /* 2241628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2241637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241641 */   // MIs[0] Operand 1
     /* 2241641 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241646 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241650 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241654 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2241654 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241657 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241659 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241670 */   // GIR_Coverage, 48698,
     /* 2241670 */   GIR_EraseRootFromParent_Done,
     /* 2241671 */ // Label 30014: @2241671
     /* 2241671 */ GIM_Try, /*On fail goto*//*Label 30015*/ GIMT_Encode4(2241719), // Rule ID 48699 //
     /* 2241676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2241682 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2241685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241689 */   // MIs[0] Operand 1
     /* 2241689 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241698 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2241702 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2241702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2241705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241707 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2241717 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241718 */   // GIR_Coverage, 48699,
     /* 2241718 */   GIR_EraseRootFromParent_Done,
     /* 2241719 */ // Label 30015: @2241719
     /* 2241719 */ GIM_Try, /*On fail goto*//*Label 30016*/ GIMT_Encode4(2241767), // Rule ID 48706 //
     /* 2241724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2241727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241730 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2241733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241737 */   // MIs[0] Operand 1
     /* 2241737 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241742 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241746 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241750 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2241750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2241753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241755 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241766 */   // GIR_Coverage, 48706,
     /* 2241766 */   GIR_EraseRootFromParent_Done,
     /* 2241767 */ // Label 30016: @2241767
     /* 2241767 */ GIM_Try, /*On fail goto*//*Label 30017*/ GIMT_Encode4(2241815), // Rule ID 48707 //
     /* 2241772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2241775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2241778 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2241781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241785 */   // MIs[0] Operand 1
     /* 2241785 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2241790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241794 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2241798 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2241798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2241801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241803 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2241805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2241807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241810 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2241813 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241814 */   // GIR_Coverage, 48707,
     /* 2241814 */   GIR_EraseRootFromParent_Done,
     /* 2241815 */ // Label 30017: @2241815
     /* 2241815 */ GIM_Try, /*On fail goto*//*Label 30018*/ GIMT_Encode4(2241863), // Rule ID 48714 //
     /* 2241820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241833 */   // MIs[0] Operand 1
     /* 2241833 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241846 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2241846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2241849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241851 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241853 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241861 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241862 */   // GIR_Coverage, 48714,
     /* 2241862 */   GIR_EraseRootFromParent_Done,
     /* 2241863 */ // Label 30018: @2241863
     /* 2241863 */ GIM_Try, /*On fail goto*//*Label 30019*/ GIMT_Encode4(2241911), // Rule ID 48715 //
     /* 2241868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2241874 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2241877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241881 */   // MIs[0] Operand 1
     /* 2241881 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241890 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241894 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2241894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2241897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241899 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241906 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2241909 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241910 */   // GIR_Coverage, 48715,
     /* 2241910 */   GIR_EraseRootFromParent_Done,
     /* 2241911 */ // Label 30019: @2241911
     /* 2241911 */ GIM_Try, /*On fail goto*//*Label 30020*/ GIMT_Encode4(2241959), // Rule ID 48724 //
     /* 2241916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2241919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241922 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241929 */   // MIs[0] Operand 1
     /* 2241929 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241934 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241938 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241942 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2241942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2241945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241947 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241949 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2241954 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2241957 */   GIR_RootConstrainSelectedInstOperands,
     /* 2241958 */   // GIR_Coverage, 48724,
     /* 2241958 */   GIR_EraseRootFromParent_Done,
     /* 2241959 */ // Label 30020: @2241959
     /* 2241959 */ GIM_Try, /*On fail goto*//*Label 30021*/ GIMT_Encode4(2242007), // Rule ID 48725 //
     /* 2241964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2241967 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2241970 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2241973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241977 */   // MIs[0] Operand 1
     /* 2241977 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2241982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241986 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2241990 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2241990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2241993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2241995 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2241997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2241999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242006 */   // GIR_Coverage, 48725,
     /* 2242006 */   GIR_EraseRootFromParent_Done,
     /* 2242007 */ // Label 30021: @2242007
     /* 2242007 */ GIM_Try, /*On fail goto*//*Label 30022*/ GIMT_Encode4(2242055), // Rule ID 48742 //
     /* 2242012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2242018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2242021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242025 */   // MIs[0] Operand 1
     /* 2242025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242034 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242038 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242043 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242050 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242053 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242054 */   // GIR_Coverage, 48742,
     /* 2242054 */   GIR_EraseRootFromParent_Done,
     /* 2242055 */ // Label 30022: @2242055
     /* 2242055 */ GIM_Try, /*On fail goto*//*Label 30023*/ GIMT_Encode4(2242103), // Rule ID 48743 //
     /* 2242060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2242066 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2242069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242073 */   // MIs[0] Operand 1
     /* 2242073 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242078 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242082 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242086 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242091 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242102 */   // GIR_Coverage, 48743,
     /* 2242102 */   GIR_EraseRootFromParent_Done,
     /* 2242103 */ // Label 30023: @2242103
     /* 2242103 */ GIM_Try, /*On fail goto*//*Label 30024*/ GIMT_Encode4(2242151), // Rule ID 48750 //
     /* 2242108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2242114 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2242117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242121 */   // MIs[0] Operand 1
     /* 2242121 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242126 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242130 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242134 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2242137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242139 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242149 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242150 */   // GIR_Coverage, 48750,
     /* 2242150 */   GIR_EraseRootFromParent_Done,
     /* 2242151 */ // Label 30024: @2242151
     /* 2242151 */ GIM_Try, /*On fail goto*//*Label 30025*/ GIMT_Encode4(2242199), // Rule ID 48751 //
     /* 2242156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2242162 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2242165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242169 */   // MIs[0] Operand 1
     /* 2242169 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2242174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242178 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242182 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2242182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2242185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242187 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242189 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242198 */   // GIR_Coverage, 48751,
     /* 2242198 */   GIR_EraseRootFromParent_Done,
     /* 2242199 */ // Label 30025: @2242199
     /* 2242199 */ GIM_Try, /*On fail goto*//*Label 30026*/ GIMT_Encode4(2242247), // Rule ID 48758 //
     /* 2242204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242207 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2242210 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2242213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242217 */   // MIs[0] Operand 1
     /* 2242217 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242226 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242230 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242235 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242246 */   // GIR_Coverage, 48758,
     /* 2242246 */   GIR_EraseRootFromParent_Done,
     /* 2242247 */ // Label 30026: @2242247
     /* 2242247 */ GIM_Try, /*On fail goto*//*Label 30027*/ GIMT_Encode4(2242295), // Rule ID 48759 //
     /* 2242252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2242258 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2242261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242265 */   // MIs[0] Operand 1
     /* 2242265 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242270 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242274 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242278 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_MF2:{ *:[nxv4i1] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_MF2),
     /* 2242281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242283 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242290 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242293 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242294 */   // GIR_Coverage, 48759,
     /* 2242294 */   GIR_EraseRootFromParent_Done,
     /* 2242295 */ // Label 30027: @2242295
     /* 2242295 */ GIM_Try, /*On fail goto*//*Label 30028*/ GIMT_Encode4(2242343), // Rule ID 48768 //
     /* 2242300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2242306 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2242309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242313 */   // MIs[0] Operand 1
     /* 2242313 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242322 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242326 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2242326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242331 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242341 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242342 */   // GIR_Coverage, 48768,
     /* 2242342 */   GIR_EraseRootFromParent_Done,
     /* 2242343 */ // Label 30028: @2242343
     /* 2242343 */ GIM_Try, /*On fail goto*//*Label 30029*/ GIMT_Encode4(2242391), // Rule ID 48769 //
     /* 2242348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2242354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2242357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242361 */   // MIs[0] Operand 1
     /* 2242361 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242370 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242374 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2242374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2242377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242379 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242390 */   // GIR_Coverage, 48769,
     /* 2242390 */   GIR_EraseRootFromParent_Done,
     /* 2242391 */ // Label 30029: @2242391
     /* 2242391 */ GIM_Try, /*On fail goto*//*Label 30030*/ GIMT_Encode4(2242439), // Rule ID 48786 //
     /* 2242396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2242402 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2242405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242409 */   // MIs[0] Operand 1
     /* 2242409 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242418 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242422 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242427 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242437 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242438 */   // GIR_Coverage, 48786,
     /* 2242438 */   GIR_EraseRootFromParent_Done,
     /* 2242439 */ // Label 30030: @2242439
     /* 2242439 */ GIM_Try, /*On fail goto*//*Label 30031*/ GIMT_Encode4(2242487), // Rule ID 48787 //
     /* 2242444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2242450 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2242453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242457 */   // MIs[0] Operand 1
     /* 2242457 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242466 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242470 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2242473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242475 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242477 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242482 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242485 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242486 */   // GIR_Coverage, 48787,
     /* 2242486 */   GIR_EraseRootFromParent_Done,
     /* 2242487 */ // Label 30031: @2242487
     /* 2242487 */ GIM_Try, /*On fail goto*//*Label 30032*/ GIMT_Encode4(2242535), // Rule ID 48794 //
     /* 2242492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2242498 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2242501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242505 */   // MIs[0] Operand 1
     /* 2242505 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242514 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242518 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2242521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242523 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242525 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242533 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242534 */   // GIR_Coverage, 48794,
     /* 2242534 */   GIR_EraseRootFromParent_Done,
     /* 2242535 */ // Label 30032: @2242535
     /* 2242535 */ GIM_Try, /*On fail goto*//*Label 30033*/ GIMT_Encode4(2242583), // Rule ID 48795 //
     /* 2242540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242543 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2242546 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2242549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242553 */   // MIs[0] Operand 1
     /* 2242553 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2242558 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242562 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242566 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2242566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2242569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242571 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2242573 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2242575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242582 */   // GIR_Coverage, 48795,
     /* 2242582 */   GIR_EraseRootFromParent_Done,
     /* 2242583 */ // Label 30033: @2242583
     /* 2242583 */ GIM_Reject,
     /* 2242584 */ // Label 29695: @2242584
     /* 2242584 */ GIM_Try, /*On fail goto*//*Label 30034*/ GIMT_Encode4(2242632), // Rule ID 48372 //
     /* 2242589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2242595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2242598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242602 */   // MIs[0] Operand 1
     /* 2242602 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242611 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242615 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242615 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2242618 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242620 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242622 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242627 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242630 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242631 */   // GIR_Coverage, 48372,
     /* 2242631 */   GIR_EraseRootFromParent_Done,
     /* 2242632 */ // Label 30034: @2242632
     /* 2242632 */ GIM_Try, /*On fail goto*//*Label 30035*/ GIMT_Encode4(2242680), // Rule ID 48373 //
     /* 2242637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2242643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2242646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242650 */   // MIs[0] Operand 1
     /* 2242650 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242659 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242663 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2242663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M1),
     /* 2242666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242668 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242670 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2242678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242679 */   // GIR_Coverage, 48373,
     /* 2242679 */   GIR_EraseRootFromParent_Done,
     /* 2242680 */ // Label 30035: @2242680
     /* 2242680 */ GIM_Try, /*On fail goto*//*Label 30036*/ GIMT_Encode4(2242728), // Rule ID 48386 //
     /* 2242685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2242691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2242694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242698 */   // MIs[0] Operand 1
     /* 2242698 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242707 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242711 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2242711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2242714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242716 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242718 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242726 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242727 */   // GIR_Coverage, 48386,
     /* 2242727 */   GIR_EraseRootFromParent_Done,
     /* 2242728 */ // Label 30036: @2242728
     /* 2242728 */ GIM_Try, /*On fail goto*//*Label 30037*/ GIMT_Encode4(2242776), // Rule ID 48387 //
     /* 2242733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2242739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2242742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242746 */   // MIs[0] Operand 1
     /* 2242746 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242755 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2242759 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2242759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2242762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242764 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242766 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2242774 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242775 */   // GIR_Coverage, 48387,
     /* 2242775 */   GIR_EraseRootFromParent_Done,
     /* 2242776 */ // Label 30037: @2242776
     /* 2242776 */ GIM_Try, /*On fail goto*//*Label 30038*/ GIMT_Encode4(2242824), // Rule ID 48394 //
     /* 2242781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2242787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2242790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242794 */   // MIs[0] Operand 1
     /* 2242794 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242803 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242807 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2242807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2242810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242812 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242814 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242816 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242822 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242823 */   // GIR_Coverage, 48394,
     /* 2242823 */   GIR_EraseRootFromParent_Done,
     /* 2242824 */ // Label 30038: @2242824
     /* 2242824 */ GIM_Try, /*On fail goto*//*Label 30039*/ GIMT_Encode4(2242872), // Rule ID 48395 //
     /* 2242829 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2242832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2242835 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2242838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242842 */   // MIs[0] Operand 1
     /* 2242842 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242851 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2242855 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2242855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2242858 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242860 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242862 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2242870 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242871 */   // GIR_Coverage, 48395,
     /* 2242871 */   GIR_EraseRootFromParent_Done,
     /* 2242872 */ // Label 30039: @2242872
     /* 2242872 */ GIM_Try, /*On fail goto*//*Label 30040*/ GIMT_Encode4(2242920), // Rule ID 48402 //
     /* 2242877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2242880 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2242883 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2242886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242890 */   // MIs[0] Operand 1
     /* 2242890 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242899 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242903 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2242903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2242906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242908 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242910 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242919 */   // GIR_Coverage, 48402,
     /* 2242919 */   GIR_EraseRootFromParent_Done,
     /* 2242920 */ // Label 30040: @2242920
     /* 2242920 */ GIM_Try, /*On fail goto*//*Label 30041*/ GIMT_Encode4(2242968), // Rule ID 48403 //
     /* 2242925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2242928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2242931 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2242934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242938 */   // MIs[0] Operand 1
     /* 2242938 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2242943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242947 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2242951 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2242951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2242954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2242956 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2242958 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2242960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2242963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2242966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2242967 */   // GIR_Coverage, 48403,
     /* 2242967 */   GIR_EraseRootFromParent_Done,
     /* 2242968 */ // Label 30041: @2242968
     /* 2242968 */ GIM_Try, /*On fail goto*//*Label 30042*/ GIMT_Encode4(2243016), // Rule ID 48416 //
     /* 2242973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2242976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2242979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2242982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242986 */   // MIs[0] Operand 1
     /* 2242986 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2242991 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242995 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2242999 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2242999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2243002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243004 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243006 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243015 */   // GIR_Coverage, 48416,
     /* 2243015 */   GIR_EraseRootFromParent_Done,
     /* 2243016 */ // Label 30042: @2243016
     /* 2243016 */ GIM_Try, /*On fail goto*//*Label 30043*/ GIMT_Encode4(2243064), // Rule ID 48417 //
     /* 2243021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2243027 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2243030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243034 */   // MIs[0] Operand 1
     /* 2243034 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243043 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243047 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M1),
     /* 2243050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243052 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243054 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243059 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243062 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243063 */   // GIR_Coverage, 48417,
     /* 2243063 */   GIR_EraseRootFromParent_Done,
     /* 2243064 */ // Label 30043: @2243064
     /* 2243064 */ GIM_Try, /*On fail goto*//*Label 30044*/ GIMT_Encode4(2243112), // Rule ID 48430 //
     /* 2243069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243082 */   // MIs[0] Operand 1
     /* 2243082 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243091 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243095 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2243098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243100 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243102 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243111 */   // GIR_Coverage, 48430,
     /* 2243111 */   GIR_EraseRootFromParent_Done,
     /* 2243112 */ // Label 30044: @2243112
     /* 2243112 */ GIM_Try, /*On fail goto*//*Label 30045*/ GIMT_Encode4(2243160), // Rule ID 48431 //
     /* 2243117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243123 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243130 */   // MIs[0] Operand 1
     /* 2243130 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243135 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243139 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243143 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2243143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2243146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243148 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243150 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243159 */   // GIR_Coverage, 48431,
     /* 2243159 */   GIR_EraseRootFromParent_Done,
     /* 2243160 */ // Label 30045: @2243160
     /* 2243160 */ GIM_Try, /*On fail goto*//*Label 30046*/ GIMT_Encode4(2243208), // Rule ID 48438 //
     /* 2243165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243168 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243171 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243178 */   // MIs[0] Operand 1
     /* 2243178 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243183 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243187 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243191 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2243191 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2243194 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243196 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243198 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243207 */   // GIR_Coverage, 48438,
     /* 2243207 */   GIR_EraseRootFromParent_Done,
     /* 2243208 */ // Label 30046: @2243208
     /* 2243208 */ GIM_Try, /*On fail goto*//*Label 30047*/ GIMT_Encode4(2243256), // Rule ID 48439 //
     /* 2243213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243226 */   // MIs[0] Operand 1
     /* 2243226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243239 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2243239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2243242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243255 */   // GIR_Coverage, 48439,
     /* 2243255 */   GIR_EraseRootFromParent_Done,
     /* 2243256 */ // Label 30047: @2243256
     /* 2243256 */ GIM_Try, /*On fail goto*//*Label 30048*/ GIMT_Encode4(2243304), // Rule ID 48446 //
     /* 2243261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2243264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2243267 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2243270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243274 */   // MIs[0] Operand 1
     /* 2243274 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243279 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243283 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243287 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2243287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2243290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243292 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243294 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243303 */   // GIR_Coverage, 48446,
     /* 2243303 */   GIR_EraseRootFromParent_Done,
     /* 2243304 */ // Label 30048: @2243304
     /* 2243304 */ GIM_Try, /*On fail goto*//*Label 30049*/ GIMT_Encode4(2243352), // Rule ID 48447 //
     /* 2243309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2243312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2243315 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2243318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243322 */   // MIs[0] Operand 1
     /* 2243322 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2243327 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243331 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243335 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2243335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2243338 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243340 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243342 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243350 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243351 */   // GIR_Coverage, 48447,
     /* 2243351 */   GIR_EraseRootFromParent_Done,
     /* 2243352 */ // Label 30049: @2243352
     /* 2243352 */ GIM_Try, /*On fail goto*//*Label 30050*/ GIMT_Encode4(2243400), // Rule ID 48460 //
     /* 2243357 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2243363 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2243366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243370 */   // MIs[0] Operand 1
     /* 2243370 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243375 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243379 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243383 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2243386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243388 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243390 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243398 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243399 */   // GIR_Coverage, 48460,
     /* 2243399 */   GIR_EraseRootFromParent_Done,
     /* 2243400 */ // Label 30050: @2243400
     /* 2243400 */ GIM_Try, /*On fail goto*//*Label 30051*/ GIMT_Encode4(2243448), // Rule ID 48461 //
     /* 2243405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2243411 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2243414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243418 */   // MIs[0] Operand 1
     /* 2243418 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243427 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243431 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2243434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243436 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243438 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243447 */   // GIR_Coverage, 48461,
     /* 2243447 */   GIR_EraseRootFromParent_Done,
     /* 2243448 */ // Label 30051: @2243448
     /* 2243448 */ GIM_Try, /*On fail goto*//*Label 30052*/ GIMT_Encode4(2243496), // Rule ID 48474 //
     /* 2243453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243466 */   // MIs[0] Operand 1
     /* 2243466 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243471 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243475 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243479 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2243482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243484 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243486 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243494 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243495 */   // GIR_Coverage, 48474,
     /* 2243495 */   GIR_EraseRootFromParent_Done,
     /* 2243496 */ // Label 30052: @2243496
     /* 2243496 */ GIM_Try, /*On fail goto*//*Label 30053*/ GIMT_Encode4(2243544), // Rule ID 48475 //
     /* 2243501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243507 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243514 */   // MIs[0] Operand 1
     /* 2243514 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243523 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243527 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2243527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2243530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243532 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243534 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243539 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243543 */   // GIR_Coverage, 48475,
     /* 2243543 */   GIR_EraseRootFromParent_Done,
     /* 2243544 */ // Label 30053: @2243544
     /* 2243544 */ GIM_Try, /*On fail goto*//*Label 30054*/ GIMT_Encode4(2243592), // Rule ID 48482 //
     /* 2243549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243562 */   // MIs[0] Operand 1
     /* 2243562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243575 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2243575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2243578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243582 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243590 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243591 */   // GIR_Coverage, 48482,
     /* 2243591 */   GIR_EraseRootFromParent_Done,
     /* 2243592 */ // Label 30054: @2243592
     /* 2243592 */ GIM_Try, /*On fail goto*//*Label 30055*/ GIMT_Encode4(2243640), // Rule ID 48483 //
     /* 2243597 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243600 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243603 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243610 */   // MIs[0] Operand 1
     /* 2243610 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243619 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243623 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2243623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2243626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243628 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243630 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243639 */   // GIR_Coverage, 48483,
     /* 2243639 */   GIR_EraseRootFromParent_Done,
     /* 2243640 */ // Label 30055: @2243640
     /* 2243640 */ GIM_Try, /*On fail goto*//*Label 30056*/ GIMT_Encode4(2243688), // Rule ID 48490 //
     /* 2243645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2243648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2243651 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2243654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243658 */   // MIs[0] Operand 1
     /* 2243658 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243663 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243667 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243671 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2243671 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2243674 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243676 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243678 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243683 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243686 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243687 */   // GIR_Coverage, 48490,
     /* 2243687 */   GIR_EraseRootFromParent_Done,
     /* 2243688 */ // Label 30056: @2243688
     /* 2243688 */ GIM_Try, /*On fail goto*//*Label 30057*/ GIMT_Encode4(2243736), // Rule ID 48491 //
     /* 2243693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2243696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2243699 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2243702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243706 */   // MIs[0] Operand 1
     /* 2243706 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2243711 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243715 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2243719 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2243719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2243722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243724 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2243726 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2243728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2243734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243735 */   // GIR_Coverage, 48491,
     /* 2243735 */   GIR_EraseRootFromParent_Done,
     /* 2243736 */ // Label 30057: @2243736
     /* 2243736 */ GIM_Try, /*On fail goto*//*Label 30058*/ GIMT_Encode4(2243784), // Rule ID 48502 //
     /* 2243741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2243747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2243750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243754 */   // MIs[0] Operand 1
     /* 2243754 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243763 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243767 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2243767 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2243770 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243772 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243774 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243779 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243782 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243783 */   // GIR_Coverage, 48502,
     /* 2243783 */   GIR_EraseRootFromParent_Done,
     /* 2243784 */ // Label 30058: @2243784
     /* 2243784 */ GIM_Try, /*On fail goto*//*Label 30059*/ GIMT_Encode4(2243832), // Rule ID 48503 //
     /* 2243789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2243795 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2243798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243802 */   // MIs[0] Operand 1
     /* 2243802 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243811 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243815 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2243815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M1),
     /* 2243818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243820 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243822 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2243830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243831 */   // GIR_Coverage, 48503,
     /* 2243831 */   GIR_EraseRootFromParent_Done,
     /* 2243832 */ // Label 30059: @2243832
     /* 2243832 */ GIM_Try, /*On fail goto*//*Label 30060*/ GIMT_Encode4(2243880), // Rule ID 48516 //
     /* 2243837 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243843 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243850 */   // MIs[0] Operand 1
     /* 2243850 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243855 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243859 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243863 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2243863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2243866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243868 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243879 */   // GIR_Coverage, 48516,
     /* 2243879 */   GIR_EraseRootFromParent_Done,
     /* 2243880 */ // Label 30060: @2243880
     /* 2243880 */ GIM_Try, /*On fail goto*//*Label 30061*/ GIMT_Encode4(2243928), // Rule ID 48517 //
     /* 2243885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2243891 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2243894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243898 */   // MIs[0] Operand 1
     /* 2243898 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243907 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2243911 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2243911 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2243914 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243916 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243918 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2243926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243927 */   // GIR_Coverage, 48517,
     /* 2243927 */   GIR_EraseRootFromParent_Done,
     /* 2243928 */ // Label 30061: @2243928
     /* 2243928 */ GIM_Try, /*On fail goto*//*Label 30062*/ GIMT_Encode4(2243976), // Rule ID 48524 //
     /* 2243933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2243936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243939 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243946 */   // MIs[0] Operand 1
     /* 2243946 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243951 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243955 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2243959 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2243959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2243962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2243964 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2243966 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2243968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2243971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2243974 */   GIR_RootConstrainSelectedInstOperands,
     /* 2243975 */   // GIR_Coverage, 48524,
     /* 2243975 */   GIR_EraseRootFromParent_Done,
     /* 2243976 */ // Label 30062: @2243976
     /* 2243976 */ GIM_Try, /*On fail goto*//*Label 30063*/ GIMT_Encode4(2244024), // Rule ID 48525 //
     /* 2243981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2243984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2243987 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2243990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2243994 */   // MIs[0] Operand 1
     /* 2243994 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2243999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244003 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244007 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2244010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244012 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244014 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244019 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244022 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244023 */   // GIR_Coverage, 48525,
     /* 2244023 */   GIR_EraseRootFromParent_Done,
     /* 2244024 */ // Label 30063: @2244024
     /* 2244024 */ GIM_Try, /*On fail goto*//*Label 30064*/ GIMT_Encode4(2244072), // Rule ID 48532 //
     /* 2244029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244035 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244042 */   // MIs[0] Operand 1
     /* 2244042 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244051 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244055 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2244058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244060 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244062 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244070 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244071 */   // GIR_Coverage, 48532,
     /* 2244071 */   GIR_EraseRootFromParent_Done,
     /* 2244072 */ // Label 30064: @2244072
     /* 2244072 */ GIM_Try, /*On fail goto*//*Label 30065*/ GIMT_Encode4(2244120), // Rule ID 48533 //
     /* 2244077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244083 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244090 */   // MIs[0] Operand 1
     /* 2244090 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2244095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244099 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244103 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2244106 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244119 */   // GIR_Coverage, 48533,
     /* 2244119 */   GIR_EraseRootFromParent_Done,
     /* 2244120 */ // Label 30065: @2244120
     /* 2244120 */ GIM_Try, /*On fail goto*//*Label 30066*/ GIMT_Encode4(2244168), // Rule ID 48546 //
     /* 2244125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244138 */   // MIs[0] Operand 1
     /* 2244138 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244147 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244151 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244156 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244158 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244166 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244167 */   // GIR_Coverage, 48546,
     /* 2244167 */   GIR_EraseRootFromParent_Done,
     /* 2244168 */ // Label 30066: @2244168
     /* 2244168 */ GIM_Try, /*On fail goto*//*Label 30067*/ GIMT_Encode4(2244216), // Rule ID 48547 //
     /* 2244173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244179 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244186 */   // MIs[0] Operand 1
     /* 2244186 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244195 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244199 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244204 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244206 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244215 */   // GIR_Coverage, 48547,
     /* 2244215 */   GIR_EraseRootFromParent_Done,
     /* 2244216 */ // Label 30067: @2244216
     /* 2244216 */ GIM_Try, /*On fail goto*//*Label 30068*/ GIMT_Encode4(2244264), // Rule ID 48560 //
     /* 2244221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2244227 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2244230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244234 */   // MIs[0] Operand 1
     /* 2244234 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244239 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244243 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244247 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2244247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244250 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244252 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244254 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244256 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244259 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244262 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244263 */   // GIR_Coverage, 48560,
     /* 2244263 */   GIR_EraseRootFromParent_Done,
     /* 2244264 */ // Label 30068: @2244264
     /* 2244264 */ GIM_Try, /*On fail goto*//*Label 30069*/ GIMT_Encode4(2244312), // Rule ID 48561 //
     /* 2244269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2244275 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2244278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244282 */   // MIs[0] Operand 1
     /* 2244282 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244291 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244295 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2244295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244300 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244311 */   // GIR_Coverage, 48561,
     /* 2244311 */   GIR_EraseRootFromParent_Done,
     /* 2244312 */ // Label 30069: @2244312
     /* 2244312 */ GIM_Try, /*On fail goto*//*Label 30070*/ GIMT_Encode4(2244360), // Rule ID 48568 //
     /* 2244317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2244323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2244326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244330 */   // MIs[0] Operand 1
     /* 2244330 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244339 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244343 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2244343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244348 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244358 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244359 */   // GIR_Coverage, 48568,
     /* 2244359 */   GIR_EraseRootFromParent_Done,
     /* 2244360 */ // Label 30070: @2244360
     /* 2244360 */ GIM_Try, /*On fail goto*//*Label 30071*/ GIMT_Encode4(2244408), // Rule ID 48569 //
     /* 2244365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2244371 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2244374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244378 */   // MIs[0] Operand 1
     /* 2244378 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244387 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244391 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244396 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244406 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244407 */   // GIR_Coverage, 48569,
     /* 2244407 */   GIR_EraseRootFromParent_Done,
     /* 2244408 */ // Label 30071: @2244408
     /* 2244408 */ GIM_Try, /*On fail goto*//*Label 30072*/ GIMT_Encode4(2244456), // Rule ID 48576 //
     /* 2244413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244419 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244426 */   // MIs[0] Operand 1
     /* 2244426 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244435 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244439 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2244442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244444 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244448 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244454 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244455 */   // GIR_Coverage, 48576,
     /* 2244455 */   GIR_EraseRootFromParent_Done,
     /* 2244456 */ // Label 30072: @2244456
     /* 2244456 */ GIM_Try, /*On fail goto*//*Label 30073*/ GIMT_Encode4(2244504), // Rule ID 48577 //
     /* 2244461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244467 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244474 */   // MIs[0] Operand 1
     /* 2244474 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2244479 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244483 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244487 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2244490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244492 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244494 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244503 */   // GIR_Coverage, 48577,
     /* 2244503 */   GIR_EraseRootFromParent_Done,
     /* 2244504 */ // Label 30073: @2244504
     /* 2244504 */ GIM_Try, /*On fail goto*//*Label 30074*/ GIMT_Encode4(2244552), // Rule ID 48590 //
     /* 2244509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244522 */   // MIs[0] Operand 1
     /* 2244522 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244531 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244535 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244542 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244544 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244547 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244550 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244551 */   // GIR_Coverage, 48590,
     /* 2244551 */   GIR_EraseRootFromParent_Done,
     /* 2244552 */ // Label 30074: @2244552
     /* 2244552 */ GIM_Try, /*On fail goto*//*Label 30075*/ GIMT_Encode4(2244600), // Rule ID 48591 //
     /* 2244557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244570 */   // MIs[0] Operand 1
     /* 2244570 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244579 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244583 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M1),
     /* 2244586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244588 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244590 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244599 */   // GIR_Coverage, 48591,
     /* 2244599 */   GIR_EraseRootFromParent_Done,
     /* 2244600 */ // Label 30075: @2244600
     /* 2244600 */ GIM_Try, /*On fail goto*//*Label 30076*/ GIMT_Encode4(2244648), // Rule ID 48604 //
     /* 2244605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2244611 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2244614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244618 */   // MIs[0] Operand 1
     /* 2244618 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244627 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244631 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2244631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244636 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244638 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244646 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244647 */   // GIR_Coverage, 48604,
     /* 2244647 */   GIR_EraseRootFromParent_Done,
     /* 2244648 */ // Label 30076: @2244648
     /* 2244648 */ GIM_Try, /*On fail goto*//*Label 30077*/ GIMT_Encode4(2244696), // Rule ID 48605 //
     /* 2244653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2244659 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2244662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244666 */   // MIs[0] Operand 1
     /* 2244666 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244675 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2244679 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2244679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2244682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244684 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244686 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244688 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2244694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244695 */   // GIR_Coverage, 48605,
     /* 2244695 */   GIR_EraseRootFromParent_Done,
     /* 2244696 */ // Label 30077: @2244696
     /* 2244696 */ GIM_Try, /*On fail goto*//*Label 30078*/ GIMT_Encode4(2244744), // Rule ID 48612 //
     /* 2244701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244704 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2244707 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2244710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244714 */   // MIs[0] Operand 1
     /* 2244714 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244719 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244723 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244727 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2244727 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244730 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244734 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244736 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244743 */   // GIR_Coverage, 48612,
     /* 2244743 */   GIR_EraseRootFromParent_Done,
     /* 2244744 */ // Label 30078: @2244744
     /* 2244744 */ GIM_Try, /*On fail goto*//*Label 30079*/ GIMT_Encode4(2244792), // Rule ID 48613 //
     /* 2244749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2244755 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2244758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244762 */   // MIs[0] Operand 1
     /* 2244762 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244771 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2244775 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2244775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2244778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244782 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244787 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2244790 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244791 */   // GIR_Coverage, 48613,
     /* 2244791 */   GIR_EraseRootFromParent_Done,
     /* 2244792 */ // Label 30079: @2244792
     /* 2244792 */ GIM_Try, /*On fail goto*//*Label 30080*/ GIMT_Encode4(2244840), // Rule ID 48620 //
     /* 2244797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2244800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244803 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244810 */   // MIs[0] Operand 1
     /* 2244810 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244819 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244823 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2244823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2244826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244830 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244839 */   // GIR_Coverage, 48620,
     /* 2244839 */   GIR_EraseRootFromParent_Done,
     /* 2244840 */ // Label 30080: @2244840
     /* 2244840 */ GIM_Try, /*On fail goto*//*Label 30081*/ GIMT_Encode4(2244888), // Rule ID 48621 //
     /* 2244845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2244848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2244851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2244854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244858 */   // MIs[0] Operand 1
     /* 2244858 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2244863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2244871 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2244871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2244874 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2244878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2244880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2244886 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244887 */   // GIR_Coverage, 48621,
     /* 2244887 */   GIR_EraseRootFromParent_Done,
     /* 2244888 */ // Label 30081: @2244888
     /* 2244888 */ GIM_Try, /*On fail goto*//*Label 30082*/ GIMT_Encode4(2244936), // Rule ID 48634 //
     /* 2244893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244896 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244899 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244906 */   // MIs[0] Operand 1
     /* 2244906 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244911 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244915 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244919 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2244919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2244922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244924 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244926 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244928 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244931 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244934 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244935 */   // GIR_Coverage, 48634,
     /* 2244935 */   GIR_EraseRootFromParent_Done,
     /* 2244936 */ // Label 30082: @2244936
     /* 2244936 */ GIM_Try, /*On fail goto*//*Label 30083*/ GIMT_Encode4(2244984), // Rule ID 48635 //
     /* 2244941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2244944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2244947 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2244950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244954 */   // MIs[0] Operand 1
     /* 2244954 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2244959 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244963 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2244967 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2244967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2244970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2244972 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2244974 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2244976 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2244979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2244982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2244983 */   // GIR_Coverage, 48635,
     /* 2244983 */   GIR_EraseRootFromParent_Done,
     /* 2244984 */ // Label 30083: @2244984
     /* 2244984 */ GIM_Try, /*On fail goto*//*Label 30084*/ GIMT_Encode4(2245032), // Rule ID 48648 //
     /* 2244989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2244992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2244995 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2244998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245002 */   // MIs[0] Operand 1
     /* 2245002 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245011 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245015 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245018 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245020 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245022 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245024 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245031 */   // GIR_Coverage, 48648,
     /* 2245031 */   GIR_EraseRootFromParent_Done,
     /* 2245032 */ // Label 30084: @2245032
     /* 2245032 */ GIM_Try, /*On fail goto*//*Label 30085*/ GIMT_Encode4(2245080), // Rule ID 48649 //
     /* 2245037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2245043 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2245046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245050 */   // MIs[0] Operand 1
     /* 2245050 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245059 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245063 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245066 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245068 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245070 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245079 */   // GIR_Coverage, 48649,
     /* 2245079 */   GIR_EraseRootFromParent_Done,
     /* 2245080 */ // Label 30085: @2245080
     /* 2245080 */ GIM_Try, /*On fail goto*//*Label 30086*/ GIMT_Encode4(2245128), // Rule ID 48656 //
     /* 2245085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245088 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245091 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245098 */   // MIs[0] Operand 1
     /* 2245098 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245103 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245107 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245111 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245116 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245126 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245127 */   // GIR_Coverage, 48656,
     /* 2245127 */   GIR_EraseRootFromParent_Done,
     /* 2245128 */ // Label 30086: @2245128
     /* 2245128 */ GIM_Try, /*On fail goto*//*Label 30087*/ GIMT_Encode4(2245176), // Rule ID 48657 //
     /* 2245133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245139 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245146 */   // MIs[0] Operand 1
     /* 2245146 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245155 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245159 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245164 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245175 */   // GIR_Coverage, 48657,
     /* 2245175 */   GIR_EraseRootFromParent_Done,
     /* 2245176 */ // Label 30087: @2245176
     /* 2245176 */ GIM_Try, /*On fail goto*//*Label 30088*/ GIMT_Encode4(2245224), // Rule ID 48664 //
     /* 2245181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2245187 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2245190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245194 */   // MIs[0] Operand 1
     /* 2245194 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245203 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245207 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2245210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245212 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245216 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245222 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245223 */   // GIR_Coverage, 48664,
     /* 2245223 */   GIR_EraseRootFromParent_Done,
     /* 2245224 */ // Label 30088: @2245224
     /* 2245224 */ GIM_Try, /*On fail goto*//*Label 30089*/ GIMT_Encode4(2245272), // Rule ID 48665 //
     /* 2245229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2245235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2245238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245242 */   // MIs[0] Operand 1
     /* 2245242 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2245247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245251 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245255 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2245258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245260 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245262 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245270 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245271 */   // GIR_Coverage, 48665,
     /* 2245271 */   GIR_EraseRootFromParent_Done,
     /* 2245272 */ // Label 30089: @2245272
     /* 2245272 */ GIM_Try, /*On fail goto*//*Label 30090*/ GIMT_Encode4(2245320), // Rule ID 48678 //
     /* 2245277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2245283 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2245286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245290 */   // MIs[0] Operand 1
     /* 2245290 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245295 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245299 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245303 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245308 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245310 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245319 */   // GIR_Coverage, 48678,
     /* 2245319 */   GIR_EraseRootFromParent_Done,
     /* 2245320 */ // Label 30090: @2245320
     /* 2245320 */ GIM_Try, /*On fail goto*//*Label 30091*/ GIMT_Encode4(2245368), // Rule ID 48679 //
     /* 2245325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2245331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2245334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245338 */   // MIs[0] Operand 1
     /* 2245338 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245343 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245347 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245351 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245351 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M1),
     /* 2245354 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245356 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245358 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245366 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245367 */   // GIR_Coverage, 48679,
     /* 2245367 */   GIR_EraseRootFromParent_Done,
     /* 2245368 */ // Label 30091: @2245368
     /* 2245368 */ GIM_Try, /*On fail goto*//*Label 30092*/ GIMT_Encode4(2245416), // Rule ID 48692 //
     /* 2245373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2245379 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2245382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245386 */   // MIs[0] Operand 1
     /* 2245386 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245395 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245399 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245404 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245406 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245415 */   // GIR_Coverage, 48692,
     /* 2245415 */   GIR_EraseRootFromParent_Done,
     /* 2245416 */ // Label 30092: @2245416
     /* 2245416 */ GIM_Try, /*On fail goto*//*Label 30093*/ GIMT_Encode4(2245464), // Rule ID 48693 //
     /* 2245421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2245427 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2245430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245434 */   // MIs[0] Operand 1
     /* 2245434 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245439 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245443 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245447 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245447 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2245450 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245452 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245454 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245463 */   // GIR_Coverage, 48693,
     /* 2245463 */   GIR_EraseRootFromParent_Done,
     /* 2245464 */ // Label 30093: @2245464
     /* 2245464 */ GIM_Try, /*On fail goto*//*Label 30094*/ GIMT_Encode4(2245512), // Rule ID 48700 //
     /* 2245469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245475 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245482 */   // MIs[0] Operand 1
     /* 2245482 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245491 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245495 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245500 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245502 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245504 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245507 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245510 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245511 */   // GIR_Coverage, 48700,
     /* 2245511 */   GIR_EraseRootFromParent_Done,
     /* 2245512 */ // Label 30094: @2245512
     /* 2245512 */ GIM_Try, /*On fail goto*//*Label 30095*/ GIMT_Encode4(2245560), // Rule ID 48701 //
     /* 2245517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245523 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245530 */   // MIs[0] Operand 1
     /* 2245530 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245539 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245543 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245543 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2245546 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245548 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245550 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245559 */   // GIR_Coverage, 48701,
     /* 2245559 */   GIR_EraseRootFromParent_Done,
     /* 2245560 */ // Label 30095: @2245560
     /* 2245560 */ GIM_Try, /*On fail goto*//*Label 30096*/ GIMT_Encode4(2245608), // Rule ID 48708 //
     /* 2245565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2245571 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2245574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245578 */   // MIs[0] Operand 1
     /* 2245578 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245583 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245587 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245591 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2245594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245596 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245598 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245606 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245607 */   // GIR_Coverage, 48708,
     /* 2245607 */   GIR_EraseRootFromParent_Done,
     /* 2245608 */ // Label 30096: @2245608
     /* 2245608 */ GIM_Try, /*On fail goto*//*Label 30097*/ GIMT_Encode4(2245656), // Rule ID 48709 //
     /* 2245613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2245616 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2245619 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2245622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245626 */   // MIs[0] Operand 1
     /* 2245626 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2245631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245635 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245639 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2245639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2245642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245644 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2245646 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2245648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245651 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245654 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245655 */   // GIR_Coverage, 48709,
     /* 2245655 */   GIR_EraseRootFromParent_Done,
     /* 2245656 */ // Label 30097: @2245656
     /* 2245656 */ GIM_Try, /*On fail goto*//*Label 30098*/ GIMT_Encode4(2245704), // Rule ID 48722 //
     /* 2245661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2245667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2245670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245674 */   // MIs[0] Operand 1
     /* 2245674 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245679 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245683 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245687 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2245687 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2245690 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245692 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245694 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245699 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245702 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245703 */   // GIR_Coverage, 48722,
     /* 2245703 */   GIR_EraseRootFromParent_Done,
     /* 2245704 */ // Label 30098: @2245704
     /* 2245704 */ GIM_Try, /*On fail goto*//*Label 30099*/ GIMT_Encode4(2245752), // Rule ID 48723 //
     /* 2245709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245712 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2245715 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2245718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245722 */   // MIs[0] Operand 1
     /* 2245722 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245731 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245735 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2245735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2245738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245740 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245742 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245747 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2245750 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245751 */   // GIR_Coverage, 48723,
     /* 2245751 */   GIR_EraseRootFromParent_Done,
     /* 2245752 */ // Label 30099: @2245752
     /* 2245752 */ GIM_Try, /*On fail goto*//*Label 30100*/ GIMT_Encode4(2245800), // Rule ID 48736 //
     /* 2245757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2245763 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2245766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245770 */   // MIs[0] Operand 1
     /* 2245770 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245775 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245779 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245783 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2245783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2245786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245788 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245790 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245798 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245799 */   // GIR_Coverage, 48736,
     /* 2245799 */   GIR_EraseRootFromParent_Done,
     /* 2245800 */ // Label 30100: @2245800
     /* 2245800 */ GIM_Try, /*On fail goto*//*Label 30101*/ GIMT_Encode4(2245848), // Rule ID 48737 //
     /* 2245805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2245811 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2245814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245818 */   // MIs[0] Operand 1
     /* 2245818 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245827 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2245831 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2245831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2245834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245836 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245838 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2245846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245847 */   // GIR_Coverage, 48737,
     /* 2245847 */   GIR_EraseRootFromParent_Done,
     /* 2245848 */ // Label 30101: @2245848
     /* 2245848 */ GIM_Try, /*On fail goto*//*Label 30102*/ GIMT_Encode4(2245896), // Rule ID 48744 //
     /* 2245853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2245856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245859 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245866 */   // MIs[0] Operand 1
     /* 2245866 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245875 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245879 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2245879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2245882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245884 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245886 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245891 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245894 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245895 */   // GIR_Coverage, 48744,
     /* 2245895 */   GIR_EraseRootFromParent_Done,
     /* 2245896 */ // Label 30102: @2245896
     /* 2245896 */ GIM_Try, /*On fail goto*//*Label 30103*/ GIMT_Encode4(2245944), // Rule ID 48745 //
     /* 2245901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2245904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2245907 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2245910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245914 */   // MIs[0] Operand 1
     /* 2245914 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245923 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2245927 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2245927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2245930 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245932 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245934 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245939 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2245942 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245943 */   // GIR_Coverage, 48745,
     /* 2245943 */   GIR_EraseRootFromParent_Done,
     /* 2245944 */ // Label 30103: @2245944
     /* 2245944 */ GIM_Try, /*On fail goto*//*Label 30104*/ GIMT_Encode4(2245992), // Rule ID 48752 //
     /* 2245949 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2245952 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2245955 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2245958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2245962 */   // MIs[0] Operand 1
     /* 2245962 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2245967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245971 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2245975 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2245975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2245978 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2245980 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2245982 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2245984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2245987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2245990 */   GIR_RootConstrainSelectedInstOperands,
     /* 2245991 */   // GIR_Coverage, 48752,
     /* 2245991 */   GIR_EraseRootFromParent_Done,
     /* 2245992 */ // Label 30104: @2245992
     /* 2245992 */ GIM_Try, /*On fail goto*//*Label 30105*/ GIMT_Encode4(2246040), // Rule ID 48753 //
     /* 2245997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2246003 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2246006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246010 */   // MIs[0] Operand 1
     /* 2246010 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2246015 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246019 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246023 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246023 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2246026 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246028 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246030 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246039 */   // GIR_Coverage, 48753,
     /* 2246039 */   GIR_EraseRootFromParent_Done,
     /* 2246040 */ // Label 30105: @2246040
     /* 2246040 */ GIM_Try, /*On fail goto*//*Label 30106*/ GIMT_Encode4(2246088), // Rule ID 48766 //
     /* 2246045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2246051 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2246054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246058 */   // MIs[0] Operand 1
     /* 2246058 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246067 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246071 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246076 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246078 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246087 */   // GIR_Coverage, 48766,
     /* 2246087 */   GIR_EraseRootFromParent_Done,
     /* 2246088 */ // Label 30106: @2246088
     /* 2246088 */ GIM_Try, /*On fail goto*//*Label 30107*/ GIMT_Encode4(2246136), // Rule ID 48767 //
     /* 2246093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2246099 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2246102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246106 */   // MIs[0] Operand 1
     /* 2246106 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246111 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246115 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246119 */   // (setcc:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M1:{ *:[nxv8i1] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M1),
     /* 2246122 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246124 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246126 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246128 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246134 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246135 */   // GIR_Coverage, 48767,
     /* 2246135 */   GIR_EraseRootFromParent_Done,
     /* 2246136 */ // Label 30107: @2246136
     /* 2246136 */ GIM_Try, /*On fail goto*//*Label 30108*/ GIMT_Encode4(2246184), // Rule ID 48780 //
     /* 2246141 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246144 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2246147 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2246150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246154 */   // MIs[0] Operand 1
     /* 2246154 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246159 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246163 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246167 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246172 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246174 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246176 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246182 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246183 */   // GIR_Coverage, 48780,
     /* 2246183 */   GIR_EraseRootFromParent_Done,
     /* 2246184 */ // Label 30108: @2246184
     /* 2246184 */ GIM_Try, /*On fail goto*//*Label 30109*/ GIMT_Encode4(2246232), // Rule ID 48781 //
     /* 2246189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246192 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2246195 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2246198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246202 */   // MIs[0] Operand 1
     /* 2246202 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246207 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246211 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246215 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2246218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246220 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246222 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246231 */   // GIR_Coverage, 48781,
     /* 2246231 */   GIR_EraseRootFromParent_Done,
     /* 2246232 */ // Label 30109: @2246232
     /* 2246232 */ GIM_Try, /*On fail goto*//*Label 30110*/ GIMT_Encode4(2246280), // Rule ID 48788 //
     /* 2246237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2246243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2246246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246250 */   // MIs[0] Operand 1
     /* 2246250 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246255 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246259 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246263 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246263 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246266 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246268 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246270 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246279 */   // GIR_Coverage, 48788,
     /* 2246279 */   GIR_EraseRootFromParent_Done,
     /* 2246280 */ // Label 30110: @2246280
     /* 2246280 */ GIM_Try, /*On fail goto*//*Label 30111*/ GIMT_Encode4(2246328), // Rule ID 48789 //
     /* 2246285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2246291 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2246294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246298 */   // MIs[0] Operand 1
     /* 2246298 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246307 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246311 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2246314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246316 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246318 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246326 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246327 */   // GIR_Coverage, 48789,
     /* 2246327 */   GIR_EraseRootFromParent_Done,
     /* 2246328 */ // Label 30111: @2246328
     /* 2246328 */ GIM_Try, /*On fail goto*//*Label 30112*/ GIMT_Encode4(2246376), // Rule ID 48796 //
     /* 2246333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2246336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2246339 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2246342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246346 */   // MIs[0] Operand 1
     /* 2246346 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246355 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246359 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2246359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2246362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246364 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246366 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246375 */   // GIR_Coverage, 48796,
     /* 2246375 */   GIR_EraseRootFromParent_Done,
     /* 2246376 */ // Label 30112: @2246376
     /* 2246376 */ GIM_Try, /*On fail goto*//*Label 30113*/ GIMT_Encode4(2246424), // Rule ID 48797 //
     /* 2246381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2246384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2246387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2246390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246394 */   // MIs[0] Operand 1
     /* 2246394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2246399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246407 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2246407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2246410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246412 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2246414 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2246416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2246422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246423 */   // GIR_Coverage, 48797,
     /* 2246423 */   GIR_EraseRootFromParent_Done,
     /* 2246424 */ // Label 30113: @2246424
     /* 2246424 */ GIM_Reject,
     /* 2246425 */ // Label 29696: @2246425
     /* 2246425 */ GIM_Try, /*On fail goto*//*Label 30114*/ GIMT_Encode4(2246473), // Rule ID 48380 //
     /* 2246430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2246436 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2246439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246443 */   // MIs[0] Operand 1
     /* 2246443 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246452 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246456 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2246459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246461 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246463 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246471 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246472 */   // GIR_Coverage, 48380,
     /* 2246472 */   GIR_EraseRootFromParent_Done,
     /* 2246473 */ // Label 30114: @2246473
     /* 2246473 */ GIM_Try, /*On fail goto*//*Label 30115*/ GIMT_Encode4(2246521), // Rule ID 48381 //
     /* 2246478 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2246484 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2246487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246491 */   // MIs[0] Operand 1
     /* 2246491 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246500 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246504 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M2),
     /* 2246507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246509 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246511 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246513 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246519 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246520 */   // GIR_Coverage, 48381,
     /* 2246520 */   GIR_EraseRootFromParent_Done,
     /* 2246521 */ // Label 30115: @2246521
     /* 2246521 */ GIM_Try, /*On fail goto*//*Label 30116*/ GIMT_Encode4(2246569), // Rule ID 48388 //
     /* 2246526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2246532 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2246535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246539 */   // MIs[0] Operand 1
     /* 2246539 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246548 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246552 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2246555 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246557 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246559 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246567 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246568 */   // GIR_Coverage, 48388,
     /* 2246568 */   GIR_EraseRootFromParent_Done,
     /* 2246569 */ // Label 30116: @2246569
     /* 2246569 */ GIM_Try, /*On fail goto*//*Label 30117*/ GIMT_Encode4(2246617), // Rule ID 48389 //
     /* 2246574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2246580 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2246583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246587 */   // MIs[0] Operand 1
     /* 2246587 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246592 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246596 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246600 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2246603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246605 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246607 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246615 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246616 */   // GIR_Coverage, 48389,
     /* 2246616 */   GIR_EraseRootFromParent_Done,
     /* 2246617 */ // Label 30117: @2246617
     /* 2246617 */ GIM_Try, /*On fail goto*//*Label 30118*/ GIMT_Encode4(2246665), // Rule ID 48396 //
     /* 2246622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2246628 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2246631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246635 */   // MIs[0] Operand 1
     /* 2246635 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246648 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2246651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246653 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246655 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246663 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246664 */   // GIR_Coverage, 48396,
     /* 2246664 */   GIR_EraseRootFromParent_Done,
     /* 2246665 */ // Label 30118: @2246665
     /* 2246665 */ GIM_Try, /*On fail goto*//*Label 30119*/ GIMT_Encode4(2246713), // Rule ID 48397 //
     /* 2246670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2246676 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2246679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246683 */   // MIs[0] Operand 1
     /* 2246683 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2246688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246696 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2246699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246701 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246703 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246712 */   // GIR_Coverage, 48397,
     /* 2246712 */   GIR_EraseRootFromParent_Done,
     /* 2246713 */ // Label 30119: @2246713
     /* 2246713 */ GIM_Try, /*On fail goto*//*Label 30120*/ GIMT_Encode4(2246761), // Rule ID 48424 //
     /* 2246718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2246724 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2246727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246731 */   // MIs[0] Operand 1
     /* 2246731 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246744 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2246744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2246747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246749 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246751 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246760 */   // GIR_Coverage, 48424,
     /* 2246760 */   GIR_EraseRootFromParent_Done,
     /* 2246761 */ // Label 30120: @2246761
     /* 2246761 */ GIM_Try, /*On fail goto*//*Label 30121*/ GIMT_Encode4(2246809), // Rule ID 48425 //
     /* 2246766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2246772 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2246775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246779 */   // MIs[0] Operand 1
     /* 2246779 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246788 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2246792 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2246792 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M2),
     /* 2246795 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246797 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246799 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2246807 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246808 */   // GIR_Coverage, 48425,
     /* 2246808 */   GIR_EraseRootFromParent_Done,
     /* 2246809 */ // Label 30121: @2246809
     /* 2246809 */ GIM_Try, /*On fail goto*//*Label 30122*/ GIMT_Encode4(2246857), // Rule ID 48432 //
     /* 2246814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2246820 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2246823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246827 */   // MIs[0] Operand 1
     /* 2246827 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246832 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246836 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246840 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2246840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2246843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246845 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246847 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246849 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246856 */   // GIR_Coverage, 48432,
     /* 2246856 */   GIR_EraseRootFromParent_Done,
     /* 2246857 */ // Label 30122: @2246857
     /* 2246857 */ GIM_Try, /*On fail goto*//*Label 30123*/ GIMT_Encode4(2246905), // Rule ID 48433 //
     /* 2246862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2246868 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2246871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246875 */   // MIs[0] Operand 1
     /* 2246875 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246880 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246884 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2246888 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2246888 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2246891 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246893 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246895 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2246903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246904 */   // GIR_Coverage, 48433,
     /* 2246904 */   GIR_EraseRootFromParent_Done,
     /* 2246905 */ // Label 30123: @2246905
     /* 2246905 */ GIM_Try, /*On fail goto*//*Label 30124*/ GIMT_Encode4(2246953), // Rule ID 48440 //
     /* 2246910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2246913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2246916 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2246919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246923 */   // MIs[0] Operand 1
     /* 2246923 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246928 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246932 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246936 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2246936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2246939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246941 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246943 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246945 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2246952 */   // GIR_Coverage, 48440,
     /* 2246952 */   GIR_EraseRootFromParent_Done,
     /* 2246953 */ // Label 30124: @2246953
     /* 2246953 */ GIM_Try, /*On fail goto*//*Label 30125*/ GIMT_Encode4(2247001), // Rule ID 48441 //
     /* 2246958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2246961 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2246964 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2246967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2246971 */   // MIs[0] Operand 1
     /* 2246971 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2246976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246980 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2246984 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2246984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2246987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2246989 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2246991 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2246993 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2246996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2246999 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247000 */   // GIR_Coverage, 48441,
     /* 2247000 */   GIR_EraseRootFromParent_Done,
     /* 2247001 */ // Label 30125: @2247001
     /* 2247001 */ GIM_Try, /*On fail goto*//*Label 30126*/ GIMT_Encode4(2247049), // Rule ID 48468 //
     /* 2247006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247019 */   // MIs[0] Operand 1
     /* 2247019 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247028 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247032 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247037 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247039 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247048 */   // GIR_Coverage, 48468,
     /* 2247048 */   GIR_EraseRootFromParent_Done,
     /* 2247049 */ // Label 30126: @2247049
     /* 2247049 */ GIM_Try, /*On fail goto*//*Label 30127*/ GIMT_Encode4(2247097), // Rule ID 48469 //
     /* 2247054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247067 */   // MIs[0] Operand 1
     /* 2247067 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247080 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247087 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247096 */   // GIR_Coverage, 48469,
     /* 2247096 */   GIR_EraseRootFromParent_Done,
     /* 2247097 */ // Label 30127: @2247097
     /* 2247097 */ GIM_Try, /*On fail goto*//*Label 30128*/ GIMT_Encode4(2247145), // Rule ID 48476 //
     /* 2247102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247108 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247115 */   // MIs[0] Operand 1
     /* 2247115 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247124 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247128 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247133 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247135 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247144 */   // GIR_Coverage, 48476,
     /* 2247144 */   GIR_EraseRootFromParent_Done,
     /* 2247145 */ // Label 30128: @2247145
     /* 2247145 */ GIM_Try, /*On fail goto*//*Label 30129*/ GIMT_Encode4(2247193), // Rule ID 48477 //
     /* 2247150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247153 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247156 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247163 */   // MIs[0] Operand 1
     /* 2247163 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247172 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247176 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247176 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247179 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247181 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247183 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247191 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247192 */   // GIR_Coverage, 48477,
     /* 2247192 */   GIR_EraseRootFromParent_Done,
     /* 2247193 */ // Label 30129: @2247193
     /* 2247193 */ GIM_Try, /*On fail goto*//*Label 30130*/ GIMT_Encode4(2247241), // Rule ID 48484 //
     /* 2247198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247204 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247211 */   // MIs[0] Operand 1
     /* 2247211 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247220 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247224 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2247227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247229 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247231 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247233 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247240 */   // GIR_Coverage, 48484,
     /* 2247240 */   GIR_EraseRootFromParent_Done,
     /* 2247241 */ // Label 30130: @2247241
     /* 2247241 */ GIM_Try, /*On fail goto*//*Label 30131*/ GIMT_Encode4(2247289), // Rule ID 48485 //
     /* 2247246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247252 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247259 */   // MIs[0] Operand 1
     /* 2247259 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2247264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247268 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247272 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2247275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247277 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247279 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247287 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247288 */   // GIR_Coverage, 48485,
     /* 2247288 */   GIR_EraseRootFromParent_Done,
     /* 2247289 */ // Label 30131: @2247289
     /* 2247289 */ GIM_Try, /*On fail goto*//*Label 30132*/ GIMT_Encode4(2247337), // Rule ID 48510 //
     /* 2247294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247300 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247307 */   // MIs[0] Operand 1
     /* 2247307 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247312 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247316 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247320 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247325 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247327 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247336 */   // GIR_Coverage, 48510,
     /* 2247336 */   GIR_EraseRootFromParent_Done,
     /* 2247337 */ // Label 30132: @2247337
     /* 2247337 */ GIM_Try, /*On fail goto*//*Label 30133*/ GIMT_Encode4(2247385), // Rule ID 48511 //
     /* 2247342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247348 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247355 */   // MIs[0] Operand 1
     /* 2247355 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247360 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247364 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247368 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M2),
     /* 2247371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247373 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247375 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247384 */   // GIR_Coverage, 48511,
     /* 2247384 */   GIR_EraseRootFromParent_Done,
     /* 2247385 */ // Label 30133: @2247385
     /* 2247385 */ GIM_Try, /*On fail goto*//*Label 30134*/ GIMT_Encode4(2247433), // Rule ID 48518 //
     /* 2247390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247403 */   // MIs[0] Operand 1
     /* 2247403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247416 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247421 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247423 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247425 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247432 */   // GIR_Coverage, 48518,
     /* 2247432 */   GIR_EraseRootFromParent_Done,
     /* 2247433 */ // Label 30134: @2247433
     /* 2247433 */ GIM_Try, /*On fail goto*//*Label 30135*/ GIMT_Encode4(2247481), // Rule ID 48519 //
     /* 2247438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247444 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247451 */   // MIs[0] Operand 1
     /* 2247451 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247464 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247464 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2247467 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247469 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247471 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247479 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247480 */   // GIR_Coverage, 48519,
     /* 2247480 */   GIR_EraseRootFromParent_Done,
     /* 2247481 */ // Label 30135: @2247481
     /* 2247481 */ GIM_Try, /*On fail goto*//*Label 30136*/ GIMT_Encode4(2247529), // Rule ID 48526 //
     /* 2247486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247492 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247499 */   // MIs[0] Operand 1
     /* 2247499 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247508 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247512 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2247515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247517 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247519 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247527 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247528 */   // GIR_Coverage, 48526,
     /* 2247528 */   GIR_EraseRootFromParent_Done,
     /* 2247529 */ // Label 30136: @2247529
     /* 2247529 */ GIM_Try, /*On fail goto*//*Label 30137*/ GIMT_Encode4(2247577), // Rule ID 48527 //
     /* 2247534 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247540 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247547 */   // MIs[0] Operand 1
     /* 2247547 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2247552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247556 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247560 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2247563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247565 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247567 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247576 */   // GIR_Coverage, 48527,
     /* 2247576 */   GIR_EraseRootFromParent_Done,
     /* 2247577 */ // Label 30137: @2247577
     /* 2247577 */ GIM_Try, /*On fail goto*//*Label 30138*/ GIMT_Encode4(2247625), // Rule ID 48554 //
     /* 2247582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247588 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247595 */   // MIs[0] Operand 1
     /* 2247595 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247604 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247608 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2247611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247613 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247615 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247617 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247623 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247624 */   // GIR_Coverage, 48554,
     /* 2247624 */   GIR_EraseRootFromParent_Done,
     /* 2247625 */ // Label 30138: @2247625
     /* 2247625 */ GIM_Try, /*On fail goto*//*Label 30139*/ GIMT_Encode4(2247673), // Rule ID 48555 //
     /* 2247630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247636 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247643 */   // MIs[0] Operand 1
     /* 2247643 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247652 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247656 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2247659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247661 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247663 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247665 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247671 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247672 */   // GIR_Coverage, 48555,
     /* 2247672 */   GIR_EraseRootFromParent_Done,
     /* 2247673 */ // Label 30139: @2247673
     /* 2247673 */ GIM_Try, /*On fail goto*//*Label 30140*/ GIMT_Encode4(2247721), // Rule ID 48562 //
     /* 2247678 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247691 */   // MIs[0] Operand 1
     /* 2247691 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247700 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247704 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2247707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247709 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247711 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247720 */   // GIR_Coverage, 48562,
     /* 2247720 */   GIR_EraseRootFromParent_Done,
     /* 2247721 */ // Label 30140: @2247721
     /* 2247721 */ GIM_Try, /*On fail goto*//*Label 30141*/ GIMT_Encode4(2247769), // Rule ID 48563 //
     /* 2247726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247739 */   // MIs[0] Operand 1
     /* 2247739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247752 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2247752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2247755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2247767 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247768 */   // GIR_Coverage, 48563,
     /* 2247768 */   GIR_EraseRootFromParent_Done,
     /* 2247769 */ // Label 30141: @2247769
     /* 2247769 */ GIM_Try, /*On fail goto*//*Label 30142*/ GIMT_Encode4(2247817), // Rule ID 48570 //
     /* 2247774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247780 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247787 */   // MIs[0] Operand 1
     /* 2247787 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247800 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2247800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2247803 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247805 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247807 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247816 */   // GIR_Coverage, 48570,
     /* 2247816 */   GIR_EraseRootFromParent_Done,
     /* 2247817 */ // Label 30142: @2247817
     /* 2247817 */ GIM_Try, /*On fail goto*//*Label 30143*/ GIMT_Encode4(2247865), // Rule ID 48571 //
     /* 2247822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2247828 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2247831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247835 */   // MIs[0] Operand 1
     /* 2247835 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2247840 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247844 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2247848 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2247848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2247851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247853 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2247855 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2247857 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2247863 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247864 */   // GIR_Coverage, 48571,
     /* 2247864 */   GIR_EraseRootFromParent_Done,
     /* 2247865 */ // Label 30143: @2247865
     /* 2247865 */ GIM_Try, /*On fail goto*//*Label 30144*/ GIMT_Encode4(2247913), // Rule ID 48598 //
     /* 2247870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247876 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247883 */   // MIs[0] Operand 1
     /* 2247883 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247892 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247896 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2247896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2247899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247901 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247903 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247905 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247911 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247912 */   // GIR_Coverage, 48598,
     /* 2247912 */   GIR_EraseRootFromParent_Done,
     /* 2247913 */ // Label 30144: @2247913
     /* 2247913 */ GIM_Try, /*On fail goto*//*Label 30145*/ GIMT_Encode4(2247961), // Rule ID 48599 //
     /* 2247918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2247921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2247924 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2247927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247931 */   // MIs[0] Operand 1
     /* 2247931 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247940 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2247944 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2247944 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M2),
     /* 2247947 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247949 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247951 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2247953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2247956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2247959 */   GIR_RootConstrainSelectedInstOperands,
     /* 2247960 */   // GIR_Coverage, 48599,
     /* 2247960 */   GIR_EraseRootFromParent_Done,
     /* 2247961 */ // Label 30145: @2247961
     /* 2247961 */ GIM_Try, /*On fail goto*//*Label 30146*/ GIMT_Encode4(2248009), // Rule ID 48606 //
     /* 2247966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2247969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2247972 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2247975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2247979 */   // MIs[0] Operand 1
     /* 2247979 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2247984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247988 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2247992 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2247992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2247995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2247997 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2247999 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248004 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248007 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248008 */   // GIR_Coverage, 48606,
     /* 2248008 */   GIR_EraseRootFromParent_Done,
     /* 2248009 */ // Label 30146: @2248009
     /* 2248009 */ GIM_Try, /*On fail goto*//*Label 30147*/ GIMT_Encode4(2248057), // Rule ID 48607 //
     /* 2248014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248020 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248027 */   // MIs[0] Operand 1
     /* 2248027 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248036 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248040 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2248043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248047 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248056 */   // GIR_Coverage, 48607,
     /* 2248056 */   GIR_EraseRootFromParent_Done,
     /* 2248057 */ // Label 30147: @2248057
     /* 2248057 */ GIM_Try, /*On fail goto*//*Label 30148*/ GIMT_Encode4(2248105), // Rule ID 48614 //
     /* 2248062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248075 */   // MIs[0] Operand 1
     /* 2248075 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248084 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248088 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2248091 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248093 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248095 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248103 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248104 */   // GIR_Coverage, 48614,
     /* 2248104 */   GIR_EraseRootFromParent_Done,
     /* 2248105 */ // Label 30148: @2248105
     /* 2248105 */ GIM_Try, /*On fail goto*//*Label 30149*/ GIMT_Encode4(2248153), // Rule ID 48615 //
     /* 2248110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248116 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248123 */   // MIs[0] Operand 1
     /* 2248123 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2248128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248132 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248136 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2248139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248141 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248143 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248145 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248148 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248151 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248152 */   // GIR_Coverage, 48615,
     /* 2248152 */   GIR_EraseRootFromParent_Done,
     /* 2248153 */ // Label 30149: @2248153
     /* 2248153 */ GIM_Try, /*On fail goto*//*Label 30150*/ GIMT_Encode4(2248201), // Rule ID 48642 //
     /* 2248158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248164 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248171 */   // MIs[0] Operand 1
     /* 2248171 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248180 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248184 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2248187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248189 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248191 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248200 */   // GIR_Coverage, 48642,
     /* 2248200 */   GIR_EraseRootFromParent_Done,
     /* 2248201 */ // Label 30150: @2248201
     /* 2248201 */ GIM_Try, /*On fail goto*//*Label 30151*/ GIMT_Encode4(2248249), // Rule ID 48643 //
     /* 2248206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248209 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248212 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248219 */   // MIs[0] Operand 1
     /* 2248219 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248232 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2248235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248237 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248239 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248247 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248248 */   // GIR_Coverage, 48643,
     /* 2248248 */   GIR_EraseRootFromParent_Done,
     /* 2248249 */ // Label 30151: @2248249
     /* 2248249 */ GIM_Try, /*On fail goto*//*Label 30152*/ GIMT_Encode4(2248297), // Rule ID 48650 //
     /* 2248254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248260 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248267 */   // MIs[0] Operand 1
     /* 2248267 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248280 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248280 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2248283 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248285 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248287 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248295 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248296 */   // GIR_Coverage, 48650,
     /* 2248296 */   GIR_EraseRootFromParent_Done,
     /* 2248297 */ // Label 30152: @2248297
     /* 2248297 */ GIM_Try, /*On fail goto*//*Label 30153*/ GIMT_Encode4(2248345), // Rule ID 48651 //
     /* 2248302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248308 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248315 */   // MIs[0] Operand 1
     /* 2248315 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248324 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248328 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2248331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248333 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248335 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248340 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248343 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248344 */   // GIR_Coverage, 48651,
     /* 2248344 */   GIR_EraseRootFromParent_Done,
     /* 2248345 */ // Label 30153: @2248345
     /* 2248345 */ GIM_Try, /*On fail goto*//*Label 30154*/ GIMT_Encode4(2248393), // Rule ID 48658 //
     /* 2248350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248356 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248363 */   // MIs[0] Operand 1
     /* 2248363 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248368 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248372 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248376 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2248379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248381 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248383 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248392 */   // GIR_Coverage, 48658,
     /* 2248392 */   GIR_EraseRootFromParent_Done,
     /* 2248393 */ // Label 30154: @2248393
     /* 2248393 */ GIM_Try, /*On fail goto*//*Label 30155*/ GIMT_Encode4(2248441), // Rule ID 48659 //
     /* 2248398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248404 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248411 */   // MIs[0] Operand 1
     /* 2248411 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2248416 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248420 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248424 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2248427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248429 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248431 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248433 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248440 */   // GIR_Coverage, 48659,
     /* 2248440 */   GIR_EraseRootFromParent_Done,
     /* 2248441 */ // Label 30155: @2248441
     /* 2248441 */ GIM_Try, /*On fail goto*//*Label 30156*/ GIMT_Encode4(2248489), // Rule ID 48686 //
     /* 2248446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248452 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248459 */   // MIs[0] Operand 1
     /* 2248459 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248464 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248468 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248472 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2248475 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248477 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248479 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248487 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248488 */   // GIR_Coverage, 48686,
     /* 2248488 */   GIR_EraseRootFromParent_Done,
     /* 2248489 */ // Label 30156: @2248489
     /* 2248489 */ GIM_Try, /*On fail goto*//*Label 30157*/ GIMT_Encode4(2248537), // Rule ID 48687 //
     /* 2248494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248507 */   // MIs[0] Operand 1
     /* 2248507 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248512 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248516 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248520 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M2),
     /* 2248523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248525 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248527 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248535 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248536 */   // GIR_Coverage, 48687,
     /* 2248536 */   GIR_EraseRootFromParent_Done,
     /* 2248537 */ // Label 30157: @2248537
     /* 2248537 */ GIM_Try, /*On fail goto*//*Label 30158*/ GIMT_Encode4(2248585), // Rule ID 48694 //
     /* 2248542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248548 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248555 */   // MIs[0] Operand 1
     /* 2248555 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248560 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248564 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248568 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2248571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248573 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248575 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248577 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248580 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248583 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248584 */   // GIR_Coverage, 48694,
     /* 2248584 */   GIR_EraseRootFromParent_Done,
     /* 2248585 */ // Label 30158: @2248585
     /* 2248585 */ GIM_Try, /*On fail goto*//*Label 30159*/ GIMT_Encode4(2248633), // Rule ID 48695 //
     /* 2248590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248603 */   // MIs[0] Operand 1
     /* 2248603 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248612 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248616 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2248619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248621 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248623 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248625 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248628 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248631 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248632 */   // GIR_Coverage, 48695,
     /* 2248632 */   GIR_EraseRootFromParent_Done,
     /* 2248633 */ // Label 30159: @2248633
     /* 2248633 */ GIM_Try, /*On fail goto*//*Label 30160*/ GIMT_Encode4(2248681), // Rule ID 48702 //
     /* 2248638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248641 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248644 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248651 */   // MIs[0] Operand 1
     /* 2248651 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248660 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248664 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2248667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248669 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248671 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248676 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248679 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248680 */   // GIR_Coverage, 48702,
     /* 2248680 */   GIR_EraseRootFromParent_Done,
     /* 2248681 */ // Label 30160: @2248681
     /* 2248681 */ GIM_Try, /*On fail goto*//*Label 30161*/ GIMT_Encode4(2248729), // Rule ID 48703 //
     /* 2248686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248692 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248699 */   // MIs[0] Operand 1
     /* 2248699 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2248704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248708 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248712 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2248712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2248715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248717 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2248719 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2248721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248724 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248727 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248728 */   // GIR_Coverage, 48703,
     /* 2248728 */   GIR_EraseRootFromParent_Done,
     /* 2248729 */ // Label 30161: @2248729
     /* 2248729 */ GIM_Try, /*On fail goto*//*Label 30162*/ GIMT_Encode4(2248777), // Rule ID 48730 //
     /* 2248734 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248740 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248747 */   // MIs[0] Operand 1
     /* 2248747 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248756 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248760 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2248760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2248763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248765 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248767 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248775 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248776 */   // GIR_Coverage, 48730,
     /* 2248776 */   GIR_EraseRootFromParent_Done,
     /* 2248777 */ // Label 30162: @2248777
     /* 2248777 */ GIM_Try, /*On fail goto*//*Label 30163*/ GIMT_Encode4(2248825), // Rule ID 48731 //
     /* 2248782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248785 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2248788 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2248791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248795 */   // MIs[0] Operand 1
     /* 2248795 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248804 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2248808 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2248808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2248811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248813 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248815 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2248823 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248824 */   // GIR_Coverage, 48731,
     /* 2248824 */   GIR_EraseRootFromParent_Done,
     /* 2248825 */ // Label 30163: @2248825
     /* 2248825 */ GIM_Try, /*On fail goto*//*Label 30164*/ GIMT_Encode4(2248873), // Rule ID 48738 //
     /* 2248830 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248843 */   // MIs[0] Operand 1
     /* 2248843 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248852 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248856 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2248856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2248859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248861 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248863 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248865 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248868 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248871 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248872 */   // GIR_Coverage, 48738,
     /* 2248872 */   GIR_EraseRootFromParent_Done,
     /* 2248873 */ // Label 30164: @2248873
     /* 2248873 */ GIM_Try, /*On fail goto*//*Label 30165*/ GIMT_Encode4(2248921), // Rule ID 48739 //
     /* 2248878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2248884 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2248887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248891 */   // MIs[0] Operand 1
     /* 2248891 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2248904 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2248904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2248907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248909 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248911 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248913 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2248919 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248920 */   // GIR_Coverage, 48739,
     /* 2248920 */   GIR_EraseRootFromParent_Done,
     /* 2248921 */ // Label 30165: @2248921
     /* 2248921 */ GIM_Try, /*On fail goto*//*Label 30166*/ GIMT_Encode4(2248969), // Rule ID 48746 //
     /* 2248926 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2248929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248932 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248939 */   // MIs[0] Operand 1
     /* 2248939 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248952 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2248952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2248955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2248957 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2248959 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2248961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2248964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2248967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2248968 */   // GIR_Coverage, 48746,
     /* 2248968 */   GIR_EraseRootFromParent_Done,
     /* 2248969 */ // Label 30166: @2248969
     /* 2248969 */ GIM_Try, /*On fail goto*//*Label 30167*/ GIMT_Encode4(2249017), // Rule ID 48747 //
     /* 2248974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2248977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2248980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2248983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2248987 */   // MIs[0] Operand 1
     /* 2248987 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2248992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2248996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249000 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249000 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2249003 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249005 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249007 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249016 */   // GIR_Coverage, 48747,
     /* 2249016 */   GIR_EraseRootFromParent_Done,
     /* 2249017 */ // Label 30167: @2249017
     /* 2249017 */ GIM_Try, /*On fail goto*//*Label 30168*/ GIMT_Encode4(2249065), // Rule ID 48774 //
     /* 2249022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2249028 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2249031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249035 */   // MIs[0] Operand 1
     /* 2249035 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249048 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2249051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249053 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249055 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249064 */   // GIR_Coverage, 48774,
     /* 2249064 */   GIR_EraseRootFromParent_Done,
     /* 2249065 */ // Label 30168: @2249065
     /* 2249065 */ GIM_Try, /*On fail goto*//*Label 30169*/ GIMT_Encode4(2249113), // Rule ID 48775 //
     /* 2249070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2249076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2249079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249083 */   // MIs[0] Operand 1
     /* 2249083 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249092 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2249096 */   // (setcc:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M2:{ *:[nxv16i1] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M2),
     /* 2249099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249101 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249103 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249111 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249112 */   // GIR_Coverage, 48775,
     /* 2249112 */   GIR_EraseRootFromParent_Done,
     /* 2249113 */ // Label 30169: @2249113
     /* 2249113 */ GIM_Try, /*On fail goto*//*Label 30170*/ GIMT_Encode4(2249161), // Rule ID 48782 //
     /* 2249118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2249124 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2249127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249131 */   // MIs[0] Operand 1
     /* 2249131 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249140 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249144 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249144 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2249147 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249149 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249151 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249153 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249159 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249160 */   // GIR_Coverage, 48782,
     /* 2249160 */   GIR_EraseRootFromParent_Done,
     /* 2249161 */ // Label 30170: @2249161
     /* 2249161 */ GIM_Try, /*On fail goto*//*Label 30171*/ GIMT_Encode4(2249209), // Rule ID 48783 //
     /* 2249166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2249172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2249175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249179 */   // MIs[0] Operand 1
     /* 2249179 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249188 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249192 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2249195 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249197 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249199 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249208 */   // GIR_Coverage, 48783,
     /* 2249208 */   GIR_EraseRootFromParent_Done,
     /* 2249209 */ // Label 30171: @2249209
     /* 2249209 */ GIM_Try, /*On fail goto*//*Label 30172*/ GIMT_Encode4(2249257), // Rule ID 48790 //
     /* 2249214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2249220 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2249223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249227 */   // MIs[0] Operand 1
     /* 2249227 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249236 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249240 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2249240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2249243 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249245 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249247 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249255 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249256 */   // GIR_Coverage, 48790,
     /* 2249256 */   GIR_EraseRootFromParent_Done,
     /* 2249257 */ // Label 30172: @2249257
     /* 2249257 */ GIM_Try, /*On fail goto*//*Label 30173*/ GIMT_Encode4(2249305), // Rule ID 48791 //
     /* 2249262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2249268 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2249271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249275 */   // MIs[0] Operand 1
     /* 2249275 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2249280 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249284 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249288 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2249288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2249291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249293 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249295 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2249303 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249304 */   // GIR_Coverage, 48791,
     /* 2249304 */   GIR_EraseRootFromParent_Done,
     /* 2249305 */ // Label 30173: @2249305
     /* 2249305 */ GIM_Reject,
     /* 2249306 */ // Label 29697: @2249306
     /* 2249306 */ GIM_Try, /*On fail goto*//*Label 30174*/ GIMT_Encode4(2249354), // Rule ID 48382 //
     /* 2249311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249324 */   // MIs[0] Operand 1
     /* 2249324 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249333 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249337 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2249340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249342 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249344 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249346 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249349 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249352 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249353 */   // GIR_Coverage, 48382,
     /* 2249353 */   GIR_EraseRootFromParent_Done,
     /* 2249354 */ // Label 30174: @2249354
     /* 2249354 */ GIM_Try, /*On fail goto*//*Label 30175*/ GIMT_Encode4(2249402), // Rule ID 48383 //
     /* 2249359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249365 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249372 */   // MIs[0] Operand 1
     /* 2249372 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249381 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249385 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M4),
     /* 2249388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249390 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249392 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249394 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249401 */   // GIR_Coverage, 48383,
     /* 2249401 */   GIR_EraseRootFromParent_Done,
     /* 2249402 */ // Label 30175: @2249402
     /* 2249402 */ GIM_Try, /*On fail goto*//*Label 30176*/ GIMT_Encode4(2249450), // Rule ID 48390 //
     /* 2249407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249413 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249420 */   // MIs[0] Operand 1
     /* 2249420 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249429 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249433 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2249436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249438 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249440 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249449 */   // GIR_Coverage, 48390,
     /* 2249449 */   GIR_EraseRootFromParent_Done,
     /* 2249450 */ // Label 30176: @2249450
     /* 2249450 */ GIM_Try, /*On fail goto*//*Label 30177*/ GIMT_Encode4(2249498), // Rule ID 48391 //
     /* 2249455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249458 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249461 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249468 */   // MIs[0] Operand 1
     /* 2249468 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2249473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249477 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249481 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2249484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249486 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249488 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249496 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249497 */   // GIR_Coverage, 48391,
     /* 2249497 */   GIR_EraseRootFromParent_Done,
     /* 2249498 */ // Label 30177: @2249498
     /* 2249498 */ GIM_Try, /*On fail goto*//*Label 30178*/ GIMT_Encode4(2249546), // Rule ID 48426 //
     /* 2249503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249509 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249516 */   // MIs[0] Operand 1
     /* 2249516 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249525 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249529 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2249532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249534 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249536 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249545 */   // GIR_Coverage, 48426,
     /* 2249545 */   GIR_EraseRootFromParent_Done,
     /* 2249546 */ // Label 30178: @2249546
     /* 2249546 */ GIM_Try, /*On fail goto*//*Label 30179*/ GIMT_Encode4(2249594), // Rule ID 48427 //
     /* 2249551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249557 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249564 */   // MIs[0] Operand 1
     /* 2249564 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249569 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249573 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249577 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M4),
     /* 2249580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249582 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249584 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249592 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249593 */   // GIR_Coverage, 48427,
     /* 2249593 */   GIR_EraseRootFromParent_Done,
     /* 2249594 */ // Label 30179: @2249594
     /* 2249594 */ GIM_Try, /*On fail goto*//*Label 30180*/ GIMT_Encode4(2249642), // Rule ID 48434 //
     /* 2249599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249605 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249612 */   // MIs[0] Operand 1
     /* 2249612 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249621 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249625 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2249628 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249630 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249632 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249634 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249637 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249640 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249641 */   // GIR_Coverage, 48434,
     /* 2249641 */   GIR_EraseRootFromParent_Done,
     /* 2249642 */ // Label 30180: @2249642
     /* 2249642 */ GIM_Try, /*On fail goto*//*Label 30181*/ GIMT_Encode4(2249690), // Rule ID 48435 //
     /* 2249647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249660 */   // MIs[0] Operand 1
     /* 2249660 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2249665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249669 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249673 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2249676 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249678 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249680 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249682 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249688 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249689 */   // GIR_Coverage, 48435,
     /* 2249689 */   GIR_EraseRootFromParent_Done,
     /* 2249690 */ // Label 30181: @2249690
     /* 2249690 */ GIM_Try, /*On fail goto*//*Label 30182*/ GIMT_Encode4(2249738), // Rule ID 48470 //
     /* 2249695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249701 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249708 */   // MIs[0] Operand 1
     /* 2249708 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249717 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249721 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2249724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249726 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249728 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249733 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249736 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249737 */   // GIR_Coverage, 48470,
     /* 2249737 */   GIR_EraseRootFromParent_Done,
     /* 2249738 */ // Label 30182: @2249738
     /* 2249738 */ GIM_Try, /*On fail goto*//*Label 30183*/ GIMT_Encode4(2249786), // Rule ID 48471 //
     /* 2249743 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249756 */   // MIs[0] Operand 1
     /* 2249756 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249765 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249769 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2249772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249774 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249776 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249784 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249785 */   // GIR_Coverage, 48471,
     /* 2249785 */   GIR_EraseRootFromParent_Done,
     /* 2249786 */ // Label 30183: @2249786
     /* 2249786 */ GIM_Try, /*On fail goto*//*Label 30184*/ GIMT_Encode4(2249834), // Rule ID 48478 //
     /* 2249791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249797 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249804 */   // MIs[0] Operand 1
     /* 2249804 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249813 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249817 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2249817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2249820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249822 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249824 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249833 */   // GIR_Coverage, 48478,
     /* 2249833 */   GIR_EraseRootFromParent_Done,
     /* 2249834 */ // Label 30184: @2249834
     /* 2249834 */ GIM_Try, /*On fail goto*//*Label 30185*/ GIMT_Encode4(2249882), // Rule ID 48479 //
     /* 2249839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249845 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249852 */   // MIs[0] Operand 1
     /* 2249852 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2249857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249861 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2249865 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2249865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2249868 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249870 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2249872 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2249874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2249880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249881 */   // GIR_Coverage, 48479,
     /* 2249881 */   GIR_EraseRootFromParent_Done,
     /* 2249882 */ // Label 30185: @2249882
     /* 2249882 */ GIM_Try, /*On fail goto*//*Label 30186*/ GIMT_Encode4(2249930), // Rule ID 48512 //
     /* 2249887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249893 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249900 */   // MIs[0] Operand 1
     /* 2249900 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2249905 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249909 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249913 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2249913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2249916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249918 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249920 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249922 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249925 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249928 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249929 */   // GIR_Coverage, 48512,
     /* 2249929 */   GIR_EraseRootFromParent_Done,
     /* 2249930 */ // Label 30186: @2249930
     /* 2249930 */ GIM_Try, /*On fail goto*//*Label 30187*/ GIMT_Encode4(2249978), // Rule ID 48513 //
     /* 2249935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2249938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2249941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2249944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249948 */   // MIs[0] Operand 1
     /* 2249948 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2249953 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249957 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2249961 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2249961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M4),
     /* 2249964 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2249966 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2249968 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2249970 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2249973 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2249976 */   GIR_RootConstrainSelectedInstOperands,
     /* 2249977 */   // GIR_Coverage, 48513,
     /* 2249977 */   GIR_EraseRootFromParent_Done,
     /* 2249978 */ // Label 30187: @2249978
     /* 2249978 */ GIM_Try, /*On fail goto*//*Label 30188*/ GIMT_Encode4(2250026), // Rule ID 48520 //
     /* 2249983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2249986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2249989 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2249992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2249996 */   // MIs[0] Operand 1
     /* 2249996 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250005 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250009 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2250012 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250014 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250016 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250025 */   // GIR_Coverage, 48520,
     /* 2250025 */   GIR_EraseRootFromParent_Done,
     /* 2250026 */ // Label 30188: @2250026
     /* 2250026 */ GIM_Try, /*On fail goto*//*Label 30189*/ GIMT_Encode4(2250074), // Rule ID 48521 //
     /* 2250031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250037 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250044 */   // MIs[0] Operand 1
     /* 2250044 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2250049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250053 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250057 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2250060 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250062 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250064 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250072 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250073 */   // GIR_Coverage, 48521,
     /* 2250073 */   GIR_EraseRootFromParent_Done,
     /* 2250074 */ // Label 30189: @2250074
     /* 2250074 */ GIM_Try, /*On fail goto*//*Label 30190*/ GIMT_Encode4(2250122), // Rule ID 48556 //
     /* 2250079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250085 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250092 */   // MIs[0] Operand 1
     /* 2250092 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250097 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250101 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250105 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2250108 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250110 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250112 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250121 */   // GIR_Coverage, 48556,
     /* 2250121 */   GIR_EraseRootFromParent_Done,
     /* 2250122 */ // Label 30190: @2250122
     /* 2250122 */ GIM_Try, /*On fail goto*//*Label 30191*/ GIMT_Encode4(2250170), // Rule ID 48557 //
     /* 2250127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250133 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250140 */   // MIs[0] Operand 1
     /* 2250140 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250145 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250149 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250153 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2250156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250158 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250160 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250168 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250169 */   // GIR_Coverage, 48557,
     /* 2250169 */   GIR_EraseRootFromParent_Done,
     /* 2250170 */ // Label 30191: @2250170
     /* 2250170 */ GIM_Try, /*On fail goto*//*Label 30192*/ GIMT_Encode4(2250218), // Rule ID 48564 //
     /* 2250175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250181 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250188 */   // MIs[0] Operand 1
     /* 2250188 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250197 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250201 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250201 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2250204 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250206 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250208 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250210 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250213 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250216 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250217 */   // GIR_Coverage, 48564,
     /* 2250217 */   GIR_EraseRootFromParent_Done,
     /* 2250218 */ // Label 30192: @2250218
     /* 2250218 */ GIM_Try, /*On fail goto*//*Label 30193*/ GIMT_Encode4(2250266), // Rule ID 48565 //
     /* 2250223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250229 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250236 */   // MIs[0] Operand 1
     /* 2250236 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2250241 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250245 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250249 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2250252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250254 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250256 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250261 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250264 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250265 */   // GIR_Coverage, 48565,
     /* 2250265 */   GIR_EraseRootFromParent_Done,
     /* 2250266 */ // Label 30193: @2250266
     /* 2250266 */ GIM_Try, /*On fail goto*//*Label 30194*/ GIMT_Encode4(2250314), // Rule ID 48600 //
     /* 2250271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250277 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250284 */   // MIs[0] Operand 1
     /* 2250284 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250289 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250293 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250297 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2250300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250302 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250304 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250313 */   // GIR_Coverage, 48600,
     /* 2250313 */   GIR_EraseRootFromParent_Done,
     /* 2250314 */ // Label 30194: @2250314
     /* 2250314 */ GIM_Try, /*On fail goto*//*Label 30195*/ GIMT_Encode4(2250362), // Rule ID 48601 //
     /* 2250319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250325 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250332 */   // MIs[0] Operand 1
     /* 2250332 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250341 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250345 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M4),
     /* 2250348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250350 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250352 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250361 */   // GIR_Coverage, 48601,
     /* 2250361 */   GIR_EraseRootFromParent_Done,
     /* 2250362 */ // Label 30195: @2250362
     /* 2250362 */ GIM_Try, /*On fail goto*//*Label 30196*/ GIMT_Encode4(2250410), // Rule ID 48608 //
     /* 2250367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250373 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250380 */   // MIs[0] Operand 1
     /* 2250380 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250389 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250393 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2250396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250398 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250400 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250402 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250409 */   // GIR_Coverage, 48608,
     /* 2250409 */   GIR_EraseRootFromParent_Done,
     /* 2250410 */ // Label 30196: @2250410
     /* 2250410 */ GIM_Try, /*On fail goto*//*Label 30197*/ GIMT_Encode4(2250458), // Rule ID 48609 //
     /* 2250415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250428 */   // MIs[0] Operand 1
     /* 2250428 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2250433 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250437 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250441 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2250444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250446 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250448 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250450 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250453 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250456 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250457 */   // GIR_Coverage, 48609,
     /* 2250457 */   GIR_EraseRootFromParent_Done,
     /* 2250458 */ // Label 30197: @2250458
     /* 2250458 */ GIM_Try, /*On fail goto*//*Label 30198*/ GIMT_Encode4(2250506), // Rule ID 48644 //
     /* 2250463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250476 */   // MIs[0] Operand 1
     /* 2250476 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2250481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250485 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250489 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2250492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250494 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250496 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250501 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250504 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250505 */   // GIR_Coverage, 48644,
     /* 2250505 */   GIR_EraseRootFromParent_Done,
     /* 2250506 */ // Label 30198: @2250506
     /* 2250506 */ GIM_Try, /*On fail goto*//*Label 30199*/ GIMT_Encode4(2250554), // Rule ID 48645 //
     /* 2250511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250524 */   // MIs[0] Operand 1
     /* 2250524 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2250529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250533 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250537 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250537 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2250540 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250542 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250544 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250553 */   // GIR_Coverage, 48645,
     /* 2250553 */   GIR_EraseRootFromParent_Done,
     /* 2250554 */ // Label 30199: @2250554
     /* 2250554 */ GIM_Try, /*On fail goto*//*Label 30200*/ GIMT_Encode4(2250602), // Rule ID 48652 //
     /* 2250559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250565 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250572 */   // MIs[0] Operand 1
     /* 2250572 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2250577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250581 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250585 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2250588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250590 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250592 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250600 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250601 */   // GIR_Coverage, 48652,
     /* 2250601 */   GIR_EraseRootFromParent_Done,
     /* 2250602 */ // Label 30200: @2250602
     /* 2250602 */ GIM_Try, /*On fail goto*//*Label 30201*/ GIMT_Encode4(2250650), // Rule ID 48653 //
     /* 2250607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250620 */   // MIs[0] Operand 1
     /* 2250620 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2250625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250629 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250633 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2250636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250638 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250640 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250642 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250645 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250648 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250649 */   // GIR_Coverage, 48653,
     /* 2250649 */   GIR_EraseRootFromParent_Done,
     /* 2250650 */ // Label 30201: @2250650
     /* 2250650 */ GIM_Try, /*On fail goto*//*Label 30202*/ GIMT_Encode4(2250698), // Rule ID 48688 //
     /* 2250655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250661 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250668 */   // MIs[0] Operand 1
     /* 2250668 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2250673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250677 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250681 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2250684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250686 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250688 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250693 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250696 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250697 */   // GIR_Coverage, 48688,
     /* 2250697 */   GIR_EraseRootFromParent_Done,
     /* 2250698 */ // Label 30202: @2250698
     /* 2250698 */ GIM_Try, /*On fail goto*//*Label 30203*/ GIMT_Encode4(2250746), // Rule ID 48689 //
     /* 2250703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250709 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250716 */   // MIs[0] Operand 1
     /* 2250716 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2250721 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250725 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250729 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M4),
     /* 2250732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250734 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250736 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250741 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250744 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250745 */   // GIR_Coverage, 48689,
     /* 2250745 */   GIR_EraseRootFromParent_Done,
     /* 2250746 */ // Label 30203: @2250746
     /* 2250746 */ GIM_Try, /*On fail goto*//*Label 30204*/ GIMT_Encode4(2250794), // Rule ID 48696 //
     /* 2250751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250757 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250764 */   // MIs[0] Operand 1
     /* 2250764 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2250769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250773 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250777 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2250780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250782 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250784 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250793 */   // GIR_Coverage, 48696,
     /* 2250793 */   GIR_EraseRootFromParent_Done,
     /* 2250794 */ // Label 30204: @2250794
     /* 2250794 */ GIM_Try, /*On fail goto*//*Label 30205*/ GIMT_Encode4(2250842), // Rule ID 48697 //
     /* 2250799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250805 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250812 */   // MIs[0] Operand 1
     /* 2250812 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2250817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250821 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250825 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2250825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2250828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250830 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2250832 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2250834 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250840 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250841 */   // GIR_Coverage, 48697,
     /* 2250841 */   GIR_EraseRootFromParent_Done,
     /* 2250842 */ // Label 30205: @2250842
     /* 2250842 */ GIM_Try, /*On fail goto*//*Label 30206*/ GIMT_Encode4(2250890), // Rule ID 48732 //
     /* 2250847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250853 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250860 */   // MIs[0] Operand 1
     /* 2250860 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250865 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250869 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250873 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2250873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250878 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250880 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250882 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250885 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250888 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250889 */   // GIR_Coverage, 48732,
     /* 2250889 */   GIR_EraseRootFromParent_Done,
     /* 2250890 */ // Label 30206: @2250890
     /* 2250890 */ GIM_Try, /*On fail goto*//*Label 30207*/ GIMT_Encode4(2250938), // Rule ID 48733 //
     /* 2250895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2250901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2250904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250908 */   // MIs[0] Operand 1
     /* 2250908 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250917 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2250921 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2250921 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2250924 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250926 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250928 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250933 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2250936 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250937 */   // GIR_Coverage, 48733,
     /* 2250937 */   GIR_EraseRootFromParent_Done,
     /* 2250938 */ // Label 30207: @2250938
     /* 2250938 */ GIM_Try, /*On fail goto*//*Label 30208*/ GIMT_Encode4(2250986), // Rule ID 48740 //
     /* 2250943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2250946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2250952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2250956 */   // MIs[0] Operand 1
     /* 2250956 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2250961 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250965 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2250969 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2250969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2250972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2250974 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2250976 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2250978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2250981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2250984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2250985 */   // GIR_Coverage, 48740,
     /* 2250985 */   GIR_EraseRootFromParent_Done,
     /* 2250986 */ // Label 30208: @2250986
     /* 2250986 */ GIM_Try, /*On fail goto*//*Label 30209*/ GIMT_Encode4(2251034), // Rule ID 48741 //
     /* 2250991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2250994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2250997 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2251000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251004 */   // MIs[0] Operand 1
     /* 2251004 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2251009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251013 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251017 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251022 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251024 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251033 */   // GIR_Coverage, 48741,
     /* 2251033 */   GIR_EraseRootFromParent_Done,
     /* 2251034 */ // Label 30209: @2251034
     /* 2251034 */ GIM_Try, /*On fail goto*//*Label 30210*/ GIMT_Encode4(2251082), // Rule ID 48776 //
     /* 2251039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2251045 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2251048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251052 */   // MIs[0] Operand 1
     /* 2251052 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251061 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251065 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2251068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251070 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251072 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251074 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251081 */   // GIR_Coverage, 48776,
     /* 2251081 */   GIR_EraseRootFromParent_Done,
     /* 2251082 */ // Label 30210: @2251082
     /* 2251082 */ GIM_Try, /*On fail goto*//*Label 30211*/ GIMT_Encode4(2251130), // Rule ID 48777 //
     /* 2251087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2251093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2251096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251100 */   // MIs[0] Operand 1
     /* 2251100 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251109 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2251113 */   // (setcc:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M4:{ *:[nxv32i1] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M4),
     /* 2251116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251118 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251120 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251122 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251128 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251129 */   // GIR_Coverage, 48777,
     /* 2251129 */   GIR_EraseRootFromParent_Done,
     /* 2251130 */ // Label 30211: @2251130
     /* 2251130 */ GIM_Try, /*On fail goto*//*Label 30212*/ GIMT_Encode4(2251178), // Rule ID 48784 //
     /* 2251135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2251141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2251144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251148 */   // MIs[0] Operand 1
     /* 2251148 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251157 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251161 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2251161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251166 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251168 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251170 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251173 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251176 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251177 */   // GIR_Coverage, 48784,
     /* 2251177 */   GIR_EraseRootFromParent_Done,
     /* 2251178 */ // Label 30212: @2251178
     /* 2251178 */ GIM_Try, /*On fail goto*//*Label 30213*/ GIMT_Encode4(2251226), // Rule ID 48785 //
     /* 2251183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2251189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2251192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251196 */   // MIs[0] Operand 1
     /* 2251196 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251205 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251209 */   // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2251209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251214 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251216 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2251224 */   GIR_RootConstrainSelectedInstOperands,
     /* 2251225 */   // GIR_Coverage, 48785,
     /* 2251225 */   GIR_EraseRootFromParent_Done,
     /* 2251226 */ // Label 30213: @2251226
     /* 2251226 */ GIM_Reject,
     /* 2251227 */ // Label 29698: @2251227
     /* 2251227 */ GIM_Try, /*On fail goto*//*Label 30214*/ GIMT_Encode4(2252003),
     /* 2251232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2251235 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2251238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2251242 */   GIM_Try, /*On fail goto*//*Label 30215*/ GIMT_Encode4(2251280), // Rule ID 48384 //
     /* 2251247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251250 */     // MIs[0] Operand 1
     /* 2251250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2251255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251263 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2251266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251270 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251279 */     // GIR_Coverage, 48384,
     /* 2251279 */     GIR_EraseRootFromParent_Done,
     /* 2251280 */   // Label 30215: @2251280
     /* 2251280 */   GIM_Try, /*On fail goto*//*Label 30216*/ GIMT_Encode4(2251318), // Rule ID 48385 //
     /* 2251285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251288 */     // MIs[0] Operand 1
     /* 2251288 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 2251293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251301 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETEQ:{ *:[Other] })  =>  (PseudoVMSEQ_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSEQ_VV_M8),
     /* 2251304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251306 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251317 */     // GIR_Coverage, 48385,
     /* 2251317 */     GIR_EraseRootFromParent_Done,
     /* 2251318 */   // Label 30216: @2251318
     /* 2251318 */   GIM_Try, /*On fail goto*//*Label 30217*/ GIMT_Encode4(2251356), // Rule ID 48428 //
     /* 2251323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251326 */     // MIs[0] Operand 1
     /* 2251326 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251339 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2251342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251355 */     // GIR_Coverage, 48428,
     /* 2251355 */     GIR_EraseRootFromParent_Done,
     /* 2251356 */   // Label 30217: @2251356
     /* 2251356 */   GIM_Try, /*On fail goto*//*Label 30218*/ GIMT_Encode4(2251394), // Rule ID 48429 //
     /* 2251361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251364 */     // MIs[0] Operand 1
     /* 2251364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_NE),
     /* 2251369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251377 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETNE:{ *:[Other] })  =>  (PseudoVMSNE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSNE_VV_M8),
     /* 2251380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251384 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251393 */     // GIR_Coverage, 48429,
     /* 2251393 */     GIR_EraseRootFromParent_Done,
     /* 2251394 */   // Label 30218: @2251394
     /* 2251394 */   GIM_Try, /*On fail goto*//*Label 30219*/ GIMT_Encode4(2251432), // Rule ID 48472 //
     /* 2251399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251402 */     // MIs[0] Operand 1
     /* 2251402 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251415 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251422 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251431 */     // GIR_Coverage, 48472,
     /* 2251431 */     GIR_EraseRootFromParent_Done,
     /* 2251432 */   // Label 30219: @2251432
     /* 2251432 */   GIM_Try, /*On fail goto*//*Label 30220*/ GIMT_Encode4(2251470), // Rule ID 48473 //
     /* 2251437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251440 */     // MIs[0] Operand 1
     /* 2251440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 2251445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251453 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251469 */     // GIR_Coverage, 48473,
     /* 2251469 */     GIR_EraseRootFromParent_Done,
     /* 2251470 */   // Label 30220: @2251470
     /* 2251470 */   GIM_Try, /*On fail goto*//*Label 30221*/ GIMT_Encode4(2251508), // Rule ID 48514 //
     /* 2251475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251478 */     // MIs[0] Operand 1
     /* 2251478 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251491 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251496 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251507 */     // GIR_Coverage, 48514,
     /* 2251507 */     GIR_EraseRootFromParent_Done,
     /* 2251508 */   // Label 30221: @2251508
     /* 2251508 */   GIM_Try, /*On fail goto*//*Label 30222*/ GIMT_Encode4(2251546), // Rule ID 48515 //
     /* 2251513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251516 */     // MIs[0] Operand 1
     /* 2251516 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 2251521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251529 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGT:{ *:[Other] })  =>  (PseudoVMSLT_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLT_VV_M8),
     /* 2251532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251534 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251545 */     // GIR_Coverage, 48515,
     /* 2251545 */     GIR_EraseRootFromParent_Done,
     /* 2251546 */   // Label 30222: @2251546
     /* 2251546 */   GIM_Try, /*On fail goto*//*Label 30223*/ GIMT_Encode4(2251584), // Rule ID 48558 //
     /* 2251551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251554 */     // MIs[0] Operand 1
     /* 2251554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251567 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2251570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251583 */     // GIR_Coverage, 48558,
     /* 2251583 */     GIR_EraseRootFromParent_Done,
     /* 2251584 */   // Label 30223: @2251584
     /* 2251584 */   GIM_Try, /*On fail goto*//*Label 30224*/ GIMT_Encode4(2251622), // Rule ID 48559 //
     /* 2251589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251592 */     // MIs[0] Operand 1
     /* 2251592 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 2251597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251605 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2251608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251612 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251621 */     // GIR_Coverage, 48559,
     /* 2251621 */     GIR_EraseRootFromParent_Done,
     /* 2251622 */   // Label 30224: @2251622
     /* 2251622 */   GIM_Try, /*On fail goto*//*Label 30225*/ GIMT_Encode4(2251660), // Rule ID 48602 //
     /* 2251627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251630 */     // MIs[0] Operand 1
     /* 2251630 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251643 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2251646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251648 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251650 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251659 */     // GIR_Coverage, 48602,
     /* 2251659 */     GIR_EraseRootFromParent_Done,
     /* 2251660 */   // Label 30225: @2251660
     /* 2251660 */   GIM_Try, /*On fail goto*//*Label 30226*/ GIMT_Encode4(2251698), // Rule ID 48603 //
     /* 2251665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251668 */     // MIs[0] Operand 1
     /* 2251668 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 2251673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251681 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGT:{ *:[Other] })  =>  (PseudoVMSLTU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLTU_VV_M8),
     /* 2251684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251686 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251697 */     // GIR_Coverage, 48603,
     /* 2251697 */     GIR_EraseRootFromParent_Done,
     /* 2251698 */   // Label 30226: @2251698
     /* 2251698 */   GIM_Try, /*On fail goto*//*Label 30227*/ GIMT_Encode4(2251736), // Rule ID 48646 //
     /* 2251703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251706 */     // MIs[0] Operand 1
     /* 2251706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251719 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2251722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251735 */     // GIR_Coverage, 48646,
     /* 2251735 */     GIR_EraseRootFromParent_Done,
     /* 2251736 */   // Label 30227: @2251736
     /* 2251736 */   GIM_Try, /*On fail goto*//*Label 30228*/ GIMT_Encode4(2251774), // Rule ID 48647 //
     /* 2251741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251744 */     // MIs[0] Operand 1
     /* 2251744 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 2251749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251757 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETLE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2251760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251772 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251773 */     // GIR_Coverage, 48647,
     /* 2251773 */     GIR_EraseRootFromParent_Done,
     /* 2251774 */   // Label 30228: @2251774
     /* 2251774 */   GIM_Try, /*On fail goto*//*Label 30229*/ GIMT_Encode4(2251812), // Rule ID 48690 //
     /* 2251779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251782 */     // MIs[0] Operand 1
     /* 2251782 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251795 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2251798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251800 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251811 */     // GIR_Coverage, 48690,
     /* 2251811 */     GIR_EraseRootFromParent_Done,
     /* 2251812 */   // Label 30229: @2251812
     /* 2251812 */   GIM_Try, /*On fail goto*//*Label 30230*/ GIMT_Encode4(2251850), // Rule ID 48691 //
     /* 2251817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251820 */     // MIs[0] Operand 1
     /* 2251820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 2251825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251833 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETGE:{ *:[Other] })  =>  (PseudoVMSLE_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLE_VV_M8),
     /* 2251836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251849 */     // GIR_Coverage, 48691,
     /* 2251849 */     GIR_EraseRootFromParent_Done,
     /* 2251850 */   // Label 30230: @2251850
     /* 2251850 */   GIM_Try, /*On fail goto*//*Label 30231*/ GIMT_Encode4(2251888), // Rule ID 48734 //
     /* 2251855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251858 */     // MIs[0] Operand 1
     /* 2251858 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2251863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251871 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251878 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251886 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251887 */     // GIR_Coverage, 48734,
     /* 2251887 */     GIR_EraseRootFromParent_Done,
     /* 2251888 */   // Label 30231: @2251888
     /* 2251888 */   GIM_Try, /*On fail goto*//*Label 30232*/ GIMT_Encode4(2251926), // Rule ID 48735 //
     /* 2251893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251896 */     // MIs[0] Operand 1
     /* 2251896 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 2251901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251909 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, SETULE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2251916 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2251918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251925 */     // GIR_Coverage, 48735,
     /* 2251925 */     GIR_EraseRootFromParent_Done,
     /* 2251926 */   // Label 30232: @2251926
     /* 2251926 */   GIM_Try, /*On fail goto*//*Label 30233*/ GIMT_Encode4(2251964), // Rule ID 48778 //
     /* 2251931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2251934 */     // MIs[0] Operand 1
     /* 2251934 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251947 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2251947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251952 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2251962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2251963 */     // GIR_Coverage, 48778,
     /* 2251963 */     GIR_EraseRootFromParent_Done,
     /* 2251964 */   // Label 30233: @2251964
     /* 2251964 */   GIM_Try, /*On fail goto*//*Label 30234*/ GIMT_Encode4(2252002), // Rule ID 48779 //
     /* 2251969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2251972 */     // MIs[0] Operand 1
     /* 2251972 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 2251977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2251985 */     // (setcc:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, SETUGE:{ *:[Other] })  =>  (PseudoVMSLEU_VV_M8:{ *:[nxv64i1] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2251985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSLEU_VV_M8),
     /* 2251988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2251990 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs1
     /* 2251992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2251994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2251997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2252000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2252001 */     // GIR_Coverage, 48779,
     /* 2252001 */     GIR_EraseRootFromParent_Done,
     /* 2252002 */   // Label 30234: @2252002
     /* 2252002 */   GIM_Reject,
     /* 2252003 */ // Label 30214: @2252003
     /* 2252003 */ GIM_Reject,
     /* 2252004 */ // Label 29699: @2252004
     /* 2252004 */ GIM_Reject,
     /* 2252005 */ // Label 49: @2252005
     /* 2252005 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(30), /*)*//*default:*//*Label 30243*/ GIMT_Encode4(2259466),
     /* 2252016 */ /*GILLT_s32*//*Label 30235*/ GIMT_Encode4(2252124),
     /* 2252020 */ /*GILLT_s64*//*Label 30236*/ GIMT_Encode4(2252881),
     /* 2252024 */ /*GILLT_nxv1s1*//*Label 30237*/ GIMT_Encode4(2253764), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2252044 */ /*GILLT_nxv2s1*//*Label 30238*/ GIMT_Encode4(2254917), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2252064 */ /*GILLT_nxv4s1*//*Label 30239*/ GIMT_Encode4(2256070), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2252084 */ /*GILLT_nxv8s1*//*Label 30240*/ GIMT_Encode4(2257223), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2252104 */ /*GILLT_nxv16s1*//*Label 30241*/ GIMT_Encode4(2258376), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2252120 */ /*GILLT_nxv32s1*//*Label 30242*/ GIMT_Encode4(2259145),
     /* 2252124 */ // Label 30235: @2252124
     /* 2252124 */ GIM_Try, /*On fail goto*//*Label 30244*/ GIMT_Encode4(2252166), // Rule ID 1256 //
     /* 2252129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2252132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252135 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252142 */   // MIs[0] Operand 1
     /* 2252142 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252151 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252155 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2252158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252160 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252162 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252165 */   // GIR_Coverage, 1256,
     /* 2252165 */   GIR_EraseRootFromParent_Done,
     /* 2252166 */ // Label 30244: @2252166
     /* 2252166 */ GIM_Try, /*On fail goto*//*Label 30245*/ GIMT_Encode4(2252208), // Rule ID 1260 //
     /* 2252171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2252174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252184 */   // MIs[0] Operand 1
     /* 2252184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252197 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2252200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252207 */   // GIR_Coverage, 1260,
     /* 2252207 */   GIR_EraseRootFromParent_Done,
     /* 2252208 */ // Label 30245: @2252208
     /* 2252208 */ GIM_Try, /*On fail goto*//*Label 30246*/ GIMT_Encode4(2252250), // Rule ID 1304 //
     /* 2252213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2252216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252226 */   // MIs[0] Operand 1
     /* 2252226 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252235 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252239 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2252242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252244 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252246 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252248 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252249 */   // GIR_Coverage, 1304,
     /* 2252249 */   GIR_EraseRootFromParent_Done,
     /* 2252250 */ // Label 30246: @2252250
     /* 2252250 */ GIM_Try, /*On fail goto*//*Label 30247*/ GIMT_Encode4(2252292), // Rule ID 1308 //
     /* 2252255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2252258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252268 */   // MIs[0] Operand 1
     /* 2252268 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252277 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252281 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252281 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2252284 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252286 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252288 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252291 */   // GIR_Coverage, 1308,
     /* 2252291 */   GIR_EraseRootFromParent_Done,
     /* 2252292 */ // Label 30247: @2252292
     /* 2252292 */ GIM_Try, /*On fail goto*//*Label 30248*/ GIMT_Encode4(2252334), // Rule ID 1320 //
     /* 2252297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2252300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252310 */   // MIs[0] Operand 1
     /* 2252310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252323 */   // (setcc:{ *:[i32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2252326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252332 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252333 */   // GIR_Coverage, 1320,
     /* 2252333 */   GIR_EraseRootFromParent_Done,
     /* 2252334 */ // Label 30248: @2252334
     /* 2252334 */ GIM_Try, /*On fail goto*//*Label 30249*/ GIMT_Encode4(2252376), // Rule ID 1324 //
     /* 2252339 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2252342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252345 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252352 */   // MIs[0] Operand 1
     /* 2252352 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252361 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252365 */   // (setcc:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2252368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252370 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252372 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252374 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252375 */   // GIR_Coverage, 1324,
     /* 2252375 */   GIR_EraseRootFromParent_Done,
     /* 2252376 */ // Label 30249: @2252376
     /* 2252376 */ GIM_Try, /*On fail goto*//*Label 30250*/ GIMT_Encode4(2252418), // Rule ID 1636 //
     /* 2252381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2252384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252394 */   // MIs[0] Operand 1
     /* 2252394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252407 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2252410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252412 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252414 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252416 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252417 */   // GIR_Coverage, 1636,
     /* 2252417 */   GIR_EraseRootFromParent_Done,
     /* 2252418 */ // Label 30250: @2252418
     /* 2252418 */ GIM_Try, /*On fail goto*//*Label 30251*/ GIMT_Encode4(2252460), // Rule ID 1640 //
     /* 2252423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2252426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252429 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252436 */   // MIs[0] Operand 1
     /* 2252436 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252445 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252449 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2252452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252454 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252456 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252459 */   // GIR_Coverage, 1640,
     /* 2252459 */   GIR_EraseRootFromParent_Done,
     /* 2252460 */ // Label 30251: @2252460
     /* 2252460 */ GIM_Try, /*On fail goto*//*Label 30252*/ GIMT_Encode4(2252502), // Rule ID 1678 //
     /* 2252465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2252468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252471 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252478 */   // MIs[0] Operand 1
     /* 2252478 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252487 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252491 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2252494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252496 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252498 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252501 */   // GIR_Coverage, 1678,
     /* 2252501 */   GIR_EraseRootFromParent_Done,
     /* 2252502 */ // Label 30252: @2252502
     /* 2252502 */ GIM_Try, /*On fail goto*//*Label 30253*/ GIMT_Encode4(2252544), // Rule ID 1686 //
     /* 2252507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2252510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252520 */   // MIs[0] Operand 1
     /* 2252520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2252533 */   // (setcc:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2252536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252542 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252543 */   // GIR_Coverage, 1686,
     /* 2252543 */   GIR_EraseRootFromParent_Done,
     /* 2252544 */ // Label 30253: @2252544
     /* 2252544 */ GIM_Try, /*On fail goto*//*Label 30254*/ GIMT_Encode4(2252586), // Rule ID 1714 //
     /* 2252549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2252552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252562 */   // MIs[0] Operand 1
     /* 2252562 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252571 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252575 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2252578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252580 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252582 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252584 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252585 */   // GIR_Coverage, 1714,
     /* 2252585 */   GIR_EraseRootFromParent_Done,
     /* 2252586 */ // Label 30254: @2252586
     /* 2252586 */ GIM_Try, /*On fail goto*//*Label 30255*/ GIMT_Encode4(2252628), // Rule ID 1722 //
     /* 2252591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2252594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2252597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2252600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252604 */   // MIs[0] Operand 1
     /* 2252604 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252609 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252613 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2252617 */   // (setcc:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2252617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2252620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252622 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252624 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252627 */   // GIR_Coverage, 1722,
     /* 2252627 */   GIR_EraseRootFromParent_Done,
     /* 2252628 */ // Label 30255: @2252628
     /* 2252628 */ GIM_Try, /*On fail goto*//*Label 30256*/ GIMT_Encode4(2252670), // Rule ID 1969 //
     /* 2252633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2252636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252646 */   // MIs[0] Operand 1
     /* 2252646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252659 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2252662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252669 */   // GIR_Coverage, 1969,
     /* 2252669 */   GIR_EraseRootFromParent_Done,
     /* 2252670 */ // Label 30256: @2252670
     /* 2252670 */ GIM_Try, /*On fail goto*//*Label 30257*/ GIMT_Encode4(2252712), // Rule ID 1973 //
     /* 2252675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2252678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252681 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252688 */   // MIs[0] Operand 1
     /* 2252688 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252697 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252701 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2252704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252706 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252708 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252711 */   // GIR_Coverage, 1973,
     /* 2252711 */   GIR_EraseRootFromParent_Done,
     /* 2252712 */ // Label 30257: @2252712
     /* 2252712 */ GIM_Try, /*On fail goto*//*Label 30258*/ GIMT_Encode4(2252754), // Rule ID 2017 //
     /* 2252717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2252720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252730 */   // MIs[0] Operand 1
     /* 2252730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252743 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2252746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252753 */   // GIR_Coverage, 2017,
     /* 2252753 */   GIR_EraseRootFromParent_Done,
     /* 2252754 */ // Label 30258: @2252754
     /* 2252754 */ GIM_Try, /*On fail goto*//*Label 30259*/ GIMT_Encode4(2252796), // Rule ID 2021 //
     /* 2252759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2252762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252772 */   // MIs[0] Operand 1
     /* 2252772 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252781 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252785 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2252788 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252790 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252792 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252795 */   // GIR_Coverage, 2021,
     /* 2252795 */   GIR_EraseRootFromParent_Done,
     /* 2252796 */ // Label 30259: @2252796
     /* 2252796 */ GIM_Try, /*On fail goto*//*Label 30260*/ GIMT_Encode4(2252838), // Rule ID 2033 //
     /* 2252801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2252804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252814 */   // MIs[0] Operand 1
     /* 2252814 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252823 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2252827 */   // (setcc:{ *:[i32] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2252830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252832 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252834 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252837 */   // GIR_Coverage, 2033,
     /* 2252837 */   GIR_EraseRootFromParent_Done,
     /* 2252838 */ // Label 30260: @2252838
     /* 2252838 */ GIM_Try, /*On fail goto*//*Label 30261*/ GIMT_Encode4(2252880), // Rule ID 2037 //
     /* 2252843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2252846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2252849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2252852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252856 */   // MIs[0] Operand 1
     /* 2252856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2252861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2252869 */   // (setcc:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2252869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2252872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252874 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252879 */   // GIR_Coverage, 2037,
     /* 2252879 */   GIR_EraseRootFromParent_Done,
     /* 2252880 */ // Label 30261: @2252880
     /* 2252880 */ GIM_Reject,
     /* 2252881 */ // Label 30236: @2252881
     /* 2252881 */ GIM_Try, /*On fail goto*//*Label 30262*/ GIMT_Encode4(2252923), // Rule ID 1255 //
     /* 2252886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2252889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252899 */   // MIs[0] Operand 1
     /* 2252899 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252904 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252908 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252912 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S),
     /* 2252915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252917 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252919 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252922 */   // GIR_Coverage, 1255,
     /* 2252922 */   GIR_EraseRootFromParent_Done,
     /* 2252923 */ // Label 30262: @2252923
     /* 2252923 */ GIM_Try, /*On fail goto*//*Label 30263*/ GIMT_Encode4(2252965), // Rule ID 1259 //
     /* 2252928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2252931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252934 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252941 */   // MIs[0] Operand 1
     /* 2252941 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2252946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252950 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2252954 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_S_INX),
     /* 2252957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2252959 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2252961 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2252963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2252964 */   // GIR_Coverage, 1259,
     /* 2252964 */   GIR_EraseRootFromParent_Done,
     /* 2252965 */ // Label 30263: @2252965
     /* 2252965 */ GIM_Try, /*On fail goto*//*Label 30264*/ GIMT_Encode4(2253007), // Rule ID 1303 //
     /* 2252970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2252973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2252976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2252979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2252983 */   // MIs[0] Operand 1
     /* 2252983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2252988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2252996 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2252996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S),
     /* 2252999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253003 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253006 */   // GIR_Coverage, 1303,
     /* 2253006 */   GIR_EraseRootFromParent_Done,
     /* 2253007 */ // Label 30264: @2253007
     /* 2253007 */ GIM_Try, /*On fail goto*//*Label 30265*/ GIMT_Encode4(2253049), // Rule ID 1307 //
     /* 2253012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2253015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2253018 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2253021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253025 */   // MIs[0] Operand 1
     /* 2253025 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253030 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2253034 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2253038 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2253038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_S_INX),
     /* 2253041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253043 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253045 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253047 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253048 */   // GIR_Coverage, 1307,
     /* 2253048 */   GIR_EraseRootFromParent_Done,
     /* 2253049 */ // Label 30265: @2253049
     /* 2253049 */ GIM_Try, /*On fail goto*//*Label 30266*/ GIMT_Encode4(2253091), // Rule ID 1319 //
     /* 2253054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2253057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2253060 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2253063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253067 */   // MIs[0] Operand 1
     /* 2253067 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253072 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2253076 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2253080 */   // (setcc:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2253080 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S),
     /* 2253083 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253085 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253087 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253090 */   // GIR_Coverage, 1319,
     /* 2253090 */   GIR_EraseRootFromParent_Done,
     /* 2253091 */ // Label 30266: @2253091
     /* 2253091 */ GIM_Try, /*On fail goto*//*Label 30267*/ GIMT_Encode4(2253133), // Rule ID 1323 //
     /* 2253096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2253099 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2253102 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2253105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253109 */   // MIs[0] Operand 1
     /* 2253109 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2253118 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2253122 */   // (setcc:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2253122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_S_INX),
     /* 2253125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253127 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253129 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253131 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253132 */   // GIR_Coverage, 1323,
     /* 2253132 */   GIR_EraseRootFromParent_Done,
     /* 2253133 */ // Label 30267: @2253133
     /* 2253133 */ GIM_Try, /*On fail goto*//*Label 30268*/ GIMT_Encode4(2253175), // Rule ID 1635 //
     /* 2253138 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2253141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253144 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253147 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253151 */   // MIs[0] Operand 1
     /* 2253151 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253160 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253164 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D),
     /* 2253167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253169 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253171 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253173 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253174 */   // GIR_Coverage, 1635,
     /* 2253174 */   GIR_EraseRootFromParent_Done,
     /* 2253175 */ // Label 30268: @2253175
     /* 2253175 */ GIM_Try, /*On fail goto*//*Label 30269*/ GIMT_Encode4(2253217), // Rule ID 1639 //
     /* 2253180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2253183 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253186 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253193 */   // MIs[0] Operand 1
     /* 2253193 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253202 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253206 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_IN32X),
     /* 2253209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253211 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253213 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253216 */   // GIR_Coverage, 1639,
     /* 2253216 */   GIR_EraseRootFromParent_Done,
     /* 2253217 */ // Label 30269: @2253217
     /* 2253217 */ GIM_Try, /*On fail goto*//*Label 30270*/ GIMT_Encode4(2253259), // Rule ID 1642 //
     /* 2253222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2253225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253228 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253235 */   // MIs[0] Operand 1
     /* 2253235 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253244 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253248 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_D_INX),
     /* 2253251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253253 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253255 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253258 */   // GIR_Coverage, 1642,
     /* 2253258 */   GIR_EraseRootFromParent_Done,
     /* 2253259 */ // Label 30270: @2253259
     /* 2253259 */ GIM_Try, /*On fail goto*//*Label 30271*/ GIMT_Encode4(2253301), // Rule ID 1677 //
     /* 2253264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2253267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253270 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253277 */   // MIs[0] Operand 1
     /* 2253277 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253286 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253290 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D),
     /* 2253293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253295 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253297 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253300 */   // GIR_Coverage, 1677,
     /* 2253300 */   GIR_EraseRootFromParent_Done,
     /* 2253301 */ // Label 30271: @2253301
     /* 2253301 */ GIM_Try, /*On fail goto*//*Label 30272*/ GIMT_Encode4(2253343), // Rule ID 1685 //
     /* 2253306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2253309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253319 */   // MIs[0] Operand 1
     /* 2253319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2253332 */   // (setcc:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D),
     /* 2253335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253341 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253342 */   // GIR_Coverage, 1685,
     /* 2253342 */   GIR_EraseRootFromParent_Done,
     /* 2253343 */ // Label 30272: @2253343
     /* 2253343 */ GIM_Try, /*On fail goto*//*Label 30273*/ GIMT_Encode4(2253385), // Rule ID 1694 //
     /* 2253348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2253351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253354 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253361 */   // MIs[0] Operand 1
     /* 2253361 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253370 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253374 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_INX),
     /* 2253377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253379 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253381 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253383 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253384 */   // GIR_Coverage, 1694,
     /* 2253384 */   GIR_EraseRootFromParent_Done,
     /* 2253385 */ // Label 30273: @2253385
     /* 2253385 */ GIM_Try, /*On fail goto*//*Label 30274*/ GIMT_Encode4(2253427), // Rule ID 1698 //
     /* 2253390 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2253393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253403 */   // MIs[0] Operand 1
     /* 2253403 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253416 */   // (setcc:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_INX),
     /* 2253419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253421 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253423 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253425 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253426 */   // GIR_Coverage, 1698,
     /* 2253426 */   GIR_EraseRootFromParent_Done,
     /* 2253427 */ // Label 30274: @2253427
     /* 2253427 */ GIM_Try, /*On fail goto*//*Label 30275*/ GIMT_Encode4(2253469), // Rule ID 1713 //
     /* 2253432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2253435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253438 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253445 */   // MIs[0] Operand 1
     /* 2253445 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253454 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253458 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_D_IN32X),
     /* 2253461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253463 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253465 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253468 */   // GIR_Coverage, 1713,
     /* 2253468 */   GIR_EraseRootFromParent_Done,
     /* 2253469 */ // Label 30275: @2253469
     /* 2253469 */ GIM_Try, /*On fail goto*//*Label 30276*/ GIMT_Encode4(2253511), // Rule ID 1721 //
     /* 2253474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2253477 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2253480 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2253483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253487 */   // MIs[0] Operand 1
     /* 2253487 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253496 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2253500 */   // (setcc:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2253500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_D_IN32X),
     /* 2253503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253505 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253507 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253510 */   // GIR_Coverage, 1721,
     /* 2253510 */   GIR_EraseRootFromParent_Done,
     /* 2253511 */ // Label 30276: @2253511
     /* 2253511 */ GIM_Try, /*On fail goto*//*Label 30277*/ GIMT_Encode4(2253553), // Rule ID 1968 //
     /* 2253516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2253519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253529 */   // MIs[0] Operand 1
     /* 2253529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253542 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H),
     /* 2253545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253552 */   // GIR_Coverage, 1968,
     /* 2253552 */   GIR_EraseRootFromParent_Done,
     /* 2253553 */ // Label 30277: @2253553
     /* 2253553 */ GIM_Try, /*On fail goto*//*Label 30278*/ GIMT_Encode4(2253595), // Rule ID 1972 //
     /* 2253558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2253561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253571 */   // MIs[0] Operand 1
     /* 2253571 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253580 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253584 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (FEQ_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FEQ_H_INX),
     /* 2253587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253589 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253591 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253594 */   // GIR_Coverage, 1972,
     /* 2253594 */   GIR_EraseRootFromParent_Done,
     /* 2253595 */ // Label 30278: @2253595
     /* 2253595 */ GIM_Try, /*On fail goto*//*Label 30279*/ GIMT_Encode4(2253637), // Rule ID 2016 //
     /* 2253600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2253603 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253606 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253613 */   // MIs[0] Operand 1
     /* 2253613 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253618 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253622 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253626 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H),
     /* 2253629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253631 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253633 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253636 */   // GIR_Coverage, 2016,
     /* 2253636 */   GIR_EraseRootFromParent_Done,
     /* 2253637 */ // Label 30279: @2253637
     /* 2253637 */ GIM_Try, /*On fail goto*//*Label 30280*/ GIMT_Encode4(2253679), // Rule ID 2020 //
     /* 2253642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2253645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253655 */   // MIs[0] Operand 1
     /* 2253655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2253660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253668 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (FLT_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLT_H_INX),
     /* 2253671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253677 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253678 */   // GIR_Coverage, 2020,
     /* 2253678 */   GIR_EraseRootFromParent_Done,
     /* 2253679 */ // Label 30280: @2253679
     /* 2253679 */ GIM_Try, /*On fail goto*//*Label 30281*/ GIMT_Encode4(2253721), // Rule ID 2032 //
     /* 2253684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2253687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253690 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253697 */   // MIs[0] Operand 1
     /* 2253697 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253702 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253706 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2253710 */   // (setcc:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H),
     /* 2253713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253715 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253717 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253720 */   // GIR_Coverage, 2032,
     /* 2253720 */   GIR_EraseRootFromParent_Done,
     /* 2253721 */ // Label 30281: @2253721
     /* 2253721 */ GIM_Try, /*On fail goto*//*Label 30282*/ GIMT_Encode4(2253763), // Rule ID 2036 //
     /* 2253726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2253729 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2253732 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2253735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2253739 */   // MIs[0] Operand 1
     /* 2253739 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2253744 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253748 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2253752 */   // (setcc:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (FLE_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2253752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FLE_H_INX),
     /* 2253755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253757 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253759 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253762 */   // GIR_Coverage, 2036,
     /* 2253762 */   GIR_EraseRootFromParent_Done,
     /* 2253763 */ // Label 30282: @2253763
     /* 2253763 */ GIM_Reject,
     /* 2253764 */ // Label 30237: @2253764
     /* 2253764 */ GIM_Try, /*On fail goto*//*Label 30283*/ GIMT_Encode4(2253812), // Rule ID 56904 //
     /* 2253769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2253772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2253775 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2253778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253782 */   // MIs[0] Operand 1
     /* 2253782 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253787 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253791 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253795 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2253795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2253798 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253800 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253802 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253811 */   // GIR_Coverage, 56904,
     /* 2253811 */   GIR_EraseRootFromParent_Done,
     /* 2253812 */ // Label 30283: @2253812
     /* 2253812 */ GIM_Try, /*On fail goto*//*Label 30284*/ GIMT_Encode4(2253860), // Rule ID 56905 //
     /* 2253817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2253820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2253823 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2253826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253830 */   // MIs[0] Operand 1
     /* 2253830 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253839 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253843 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2253843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF4),
     /* 2253846 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253848 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253850 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2253858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253859 */   // GIR_Coverage, 56905,
     /* 2253859 */   GIR_EraseRootFromParent_Done,
     /* 2253860 */ // Label 30284: @2253860
     /* 2253860 */ GIM_Try, /*On fail goto*//*Label 30285*/ GIMT_Encode4(2253908), // Rule ID 56924 //
     /* 2253865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2253868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2253871 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2253874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253878 */   // MIs[0] Operand 1
     /* 2253878 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253883 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253887 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253891 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2253891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2253894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253896 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253898 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253903 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253906 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253907 */   // GIR_Coverage, 56924,
     /* 2253907 */   GIR_EraseRootFromParent_Done,
     /* 2253908 */ // Label 30285: @2253908
     /* 2253908 */ GIM_Try, /*On fail goto*//*Label 30286*/ GIMT_Encode4(2253956), // Rule ID 56925 //
     /* 2253913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2253916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2253919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2253922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253926 */   // MIs[0] Operand 1
     /* 2253926 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253935 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253939 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2253939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2253942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253944 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253946 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253951 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2253954 */   GIR_RootConstrainSelectedInstOperands,
     /* 2253955 */   // GIR_Coverage, 56925,
     /* 2253955 */   GIR_EraseRootFromParent_Done,
     /* 2253956 */ // Label 30286: @2253956
     /* 2253956 */ GIM_Try, /*On fail goto*//*Label 30287*/ GIMT_Encode4(2254004), // Rule ID 56954 //
     /* 2253961 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2253964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2253967 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2253970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253974 */   // MIs[0] Operand 1
     /* 2253974 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2253979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253983 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2253987 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2253987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2253990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2253992 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2253994 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2253996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2253999 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254002 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254003 */   // GIR_Coverage, 56954,
     /* 2254003 */   GIR_EraseRootFromParent_Done,
     /* 2254004 */ // Label 30287: @2254004
     /* 2254004 */ GIM_Try, /*On fail goto*//*Label 30288*/ GIMT_Encode4(2254052), // Rule ID 56955 //
     /* 2254009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2254012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254015 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254022 */   // MIs[0] Operand 1
     /* 2254022 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2254027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254031 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254035 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2254038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254040 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254042 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254051 */   // GIR_Coverage, 56955,
     /* 2254051 */   GIR_EraseRootFromParent_Done,
     /* 2254052 */ // Label 30288: @2254052
     /* 2254052 */ GIM_Try, /*On fail goto*//*Label 30289*/ GIMT_Encode4(2254100), // Rule ID 57204 //
     /* 2254057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2254060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254063 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254070 */   // MIs[0] Operand 1
     /* 2254070 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254075 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254079 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254083 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2254086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254088 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254090 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254099 */   // GIR_Coverage, 57204,
     /* 2254099 */   GIR_EraseRootFromParent_Done,
     /* 2254100 */ // Label 30289: @2254100
     /* 2254100 */ GIM_Try, /*On fail goto*//*Label 30290*/ GIMT_Encode4(2254148), // Rule ID 57205 //
     /* 2254105 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2254108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254111 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254118 */   // MIs[0] Operand 1
     /* 2254118 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254123 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254127 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254131 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF4),
     /* 2254134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254136 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254138 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254147 */   // GIR_Coverage, 57205,
     /* 2254147 */   GIR_EraseRootFromParent_Done,
     /* 2254148 */ // Label 30290: @2254148
     /* 2254148 */ GIM_Try, /*On fail goto*//*Label 30291*/ GIMT_Encode4(2254196), // Rule ID 57224 //
     /* 2254153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2254156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254166 */   // MIs[0] Operand 1
     /* 2254166 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254171 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254175 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254179 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2254182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254184 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254186 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254195 */   // GIR_Coverage, 57224,
     /* 2254195 */   GIR_EraseRootFromParent_Done,
     /* 2254196 */ // Label 30291: @2254196
     /* 2254196 */ GIM_Try, /*On fail goto*//*Label 30292*/ GIMT_Encode4(2254244), // Rule ID 57225 //
     /* 2254201 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2254204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254207 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254214 */   // MIs[0] Operand 1
     /* 2254214 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254223 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254227 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2254230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254232 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254234 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254236 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254242 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254243 */   // GIR_Coverage, 57225,
     /* 2254243 */   GIR_EraseRootFromParent_Done,
     /* 2254244 */ // Label 30292: @2254244
     /* 2254244 */ GIM_Try, /*On fail goto*//*Label 30293*/ GIMT_Encode4(2254292), // Rule ID 57254 //
     /* 2254249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2254252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254262 */   // MIs[0] Operand 1
     /* 2254262 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254271 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254275 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254275 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2254278 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254280 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254282 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254284 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254290 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254291 */   // GIR_Coverage, 57254,
     /* 2254291 */   GIR_EraseRootFromParent_Done,
     /* 2254292 */ // Label 30293: @2254292
     /* 2254292 */ GIM_Try, /*On fail goto*//*Label 30294*/ GIMT_Encode4(2254340), // Rule ID 57255 //
     /* 2254297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2254300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254303 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254310 */   // MIs[0] Operand 1
     /* 2254310 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2254315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254319 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254323 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2254326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254328 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254330 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254339 */   // GIR_Coverage, 57255,
     /* 2254339 */   GIR_EraseRootFromParent_Done,
     /* 2254340 */ // Label 30294: @2254340
     /* 2254340 */ GIM_Try, /*On fail goto*//*Label 30295*/ GIMT_Encode4(2254388), // Rule ID 57504 //
     /* 2254345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2254348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254351 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254358 */   // MIs[0] Operand 1
     /* 2254358 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254367 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254371 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2254374 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254376 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254378 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254386 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254387 */   // GIR_Coverage, 57504,
     /* 2254387 */   GIR_EraseRootFromParent_Done,
     /* 2254388 */ // Label 30295: @2254388
     /* 2254388 */ GIM_Try, /*On fail goto*//*Label 30296*/ GIMT_Encode4(2254436), // Rule ID 57505 //
     /* 2254393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2254396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254399 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254406 */   // MIs[0] Operand 1
     /* 2254406 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254415 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254419 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF4),
     /* 2254422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254424 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254426 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254431 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254434 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254435 */   // GIR_Coverage, 57505,
     /* 2254435 */   GIR_EraseRootFromParent_Done,
     /* 2254436 */ // Label 30296: @2254436
     /* 2254436 */ GIM_Try, /*On fail goto*//*Label 30297*/ GIMT_Encode4(2254484), // Rule ID 57524 //
     /* 2254441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2254444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254447 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254454 */   // MIs[0] Operand 1
     /* 2254454 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254463 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254467 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2254470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254472 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254474 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254476 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254479 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254482 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254483 */   // GIR_Coverage, 57524,
     /* 2254483 */   GIR_EraseRootFromParent_Done,
     /* 2254484 */ // Label 30297: @2254484
     /* 2254484 */ GIM_Try, /*On fail goto*//*Label 30298*/ GIMT_Encode4(2254532), // Rule ID 57525 //
     /* 2254489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2254492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254495 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254502 */   // MIs[0] Operand 1
     /* 2254502 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254507 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254511 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254515 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2254518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254520 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254522 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254531 */   // GIR_Coverage, 57525,
     /* 2254531 */   GIR_EraseRootFromParent_Done,
     /* 2254532 */ // Label 30298: @2254532
     /* 2254532 */ GIM_Try, /*On fail goto*//*Label 30299*/ GIMT_Encode4(2254580), // Rule ID 57554 //
     /* 2254537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2254540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254550 */   // MIs[0] Operand 1
     /* 2254550 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254559 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254563 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2254566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254568 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254570 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254578 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254579 */   // GIR_Coverage, 57554,
     /* 2254579 */   GIR_EraseRootFromParent_Done,
     /* 2254580 */ // Label 30299: @2254580
     /* 2254580 */ GIM_Try, /*On fail goto*//*Label 30300*/ GIMT_Encode4(2254628), // Rule ID 57555 //
     /* 2254585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2254588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254591 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254598 */   // MIs[0] Operand 1
     /* 2254598 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2254603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254607 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254611 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254611 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2254614 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254616 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254618 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254626 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254627 */   // GIR_Coverage, 57555,
     /* 2254627 */   GIR_EraseRootFromParent_Done,
     /* 2254628 */ // Label 30300: @2254628
     /* 2254628 */ GIM_Try, /*On fail goto*//*Label 30301*/ GIMT_Encode4(2254676), // Rule ID 57804 //
     /* 2254633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2254636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254639 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254646 */   // MIs[0] Operand 1
     /* 2254646 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254655 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254659 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2254662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254664 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254666 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254668 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254671 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254674 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254675 */   // GIR_Coverage, 57804,
     /* 2254675 */   GIR_EraseRootFromParent_Done,
     /* 2254676 */ // Label 30301: @2254676
     /* 2254676 */ GIM_Try, /*On fail goto*//*Label 30302*/ GIMT_Encode4(2254724), // Rule ID 57805 //
     /* 2254681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2254684 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2254687 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2254690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254694 */   // MIs[0] Operand 1
     /* 2254694 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254699 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254703 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254707 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF4:{ *:[nxv1i1] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF4),
     /* 2254710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254712 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254714 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254719 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254722 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254723 */   // GIR_Coverage, 57805,
     /* 2254723 */   GIR_EraseRootFromParent_Done,
     /* 2254724 */ // Label 30302: @2254724
     /* 2254724 */ GIM_Try, /*On fail goto*//*Label 30303*/ GIMT_Encode4(2254772), // Rule ID 57824 //
     /* 2254729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2254732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254735 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254742 */   // MIs[0] Operand 1
     /* 2254742 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254751 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254755 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2254755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2254758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254760 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254762 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254771 */   // GIR_Coverage, 57824,
     /* 2254771 */   GIR_EraseRootFromParent_Done,
     /* 2254772 */ // Label 30303: @2254772
     /* 2254772 */ GIM_Try, /*On fail goto*//*Label 30304*/ GIMT_Encode4(2254820), // Rule ID 57825 //
     /* 2254777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2254780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2254783 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2254786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254790 */   // MIs[0] Operand 1
     /* 2254790 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254795 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254799 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254803 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv1i1] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2254803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2254806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254808 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254810 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2254818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254819 */   // GIR_Coverage, 57825,
     /* 2254819 */   GIR_EraseRootFromParent_Done,
     /* 2254820 */ // Label 30304: @2254820
     /* 2254820 */ GIM_Try, /*On fail goto*//*Label 30305*/ GIMT_Encode4(2254868), // Rule ID 57854 //
     /* 2254825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2254828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254831 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254838 */   // MIs[0] Operand 1
     /* 2254838 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254847 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254851 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2254851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2254854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254856 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254858 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254866 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254867 */   // GIR_Coverage, 57854,
     /* 2254867 */   GIR_EraseRootFromParent_Done,
     /* 2254868 */ // Label 30305: @2254868
     /* 2254868 */ GIM_Try, /*On fail goto*//*Label 30306*/ GIMT_Encode4(2254916), // Rule ID 57855 //
     /* 2254873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2254876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2254879 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2254882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254886 */   // MIs[0] Operand 1
     /* 2254886 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2254891 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254895 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254899 */   // (setcc:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv1i1] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2254899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2254902 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254904 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254906 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254911 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2254914 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254915 */   // GIR_Coverage, 57855,
     /* 2254915 */   GIR_EraseRootFromParent_Done,
     /* 2254916 */ // Label 30306: @2254916
     /* 2254916 */ GIM_Reject,
     /* 2254917 */ // Label 30238: @2254917
     /* 2254917 */ GIM_Try, /*On fail goto*//*Label 30307*/ GIMT_Encode4(2254965), // Rule ID 56914 //
     /* 2254922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2254925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254928 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254935 */   // MIs[0] Operand 1
     /* 2254935 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2254940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254944 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254948 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2254948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2254951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2254953 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2254955 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2254957 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2254960 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2254963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2254964 */   // GIR_Coverage, 56914,
     /* 2254964 */   GIR_EraseRootFromParent_Done,
     /* 2254965 */ // Label 30307: @2254965
     /* 2254965 */ GIM_Try, /*On fail goto*//*Label 30308*/ GIMT_Encode4(2255013), // Rule ID 56915 //
     /* 2254970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2254973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2254976 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2254979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254983 */   // MIs[0] Operand 1
     /* 2254983 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2254988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2254996 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2254996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_MF2),
     /* 2254999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255001 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255003 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255011 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255012 */   // GIR_Coverage, 56915,
     /* 2255012 */   GIR_EraseRootFromParent_Done,
     /* 2255013 */ // Label 30308: @2255013
     /* 2255013 */ GIM_Try, /*On fail goto*//*Label 30309*/ GIMT_Encode4(2255061), // Rule ID 56944 //
     /* 2255018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2255021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255024 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255031 */   // MIs[0] Operand 1
     /* 2255031 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2255036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255040 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255044 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2255047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255049 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255051 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255053 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255056 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255060 */   // GIR_Coverage, 56944,
     /* 2255060 */   GIR_EraseRootFromParent_Done,
     /* 2255061 */ // Label 30309: @2255061
     /* 2255061 */ GIM_Try, /*On fail goto*//*Label 30310*/ GIMT_Encode4(2255109), // Rule ID 56945 //
     /* 2255066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2255069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255072 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255079 */   // MIs[0] Operand 1
     /* 2255079 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2255084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255088 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255092 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2255095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255097 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255099 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255108 */   // GIR_Coverage, 56945,
     /* 2255108 */   GIR_EraseRootFromParent_Done,
     /* 2255109 */ // Label 30310: @2255109
     /* 2255109 */ GIM_Try, /*On fail goto*//*Label 30311*/ GIMT_Encode4(2255157), // Rule ID 57024 //
     /* 2255114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2255117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255120 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255127 */   // MIs[0] Operand 1
     /* 2255127 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2255132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255136 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255140 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2255143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255145 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255147 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255156 */   // GIR_Coverage, 57024,
     /* 2255156 */   GIR_EraseRootFromParent_Done,
     /* 2255157 */ // Label 30311: @2255157
     /* 2255157 */ GIM_Try, /*On fail goto*//*Label 30312*/ GIMT_Encode4(2255205), // Rule ID 57025 //
     /* 2255162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2255165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255168 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255175 */   // MIs[0] Operand 1
     /* 2255175 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2255180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255184 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255188 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2255191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255193 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255195 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255204 */   // GIR_Coverage, 57025,
     /* 2255204 */   GIR_EraseRootFromParent_Done,
     /* 2255205 */ // Label 30312: @2255205
     /* 2255205 */ GIM_Try, /*On fail goto*//*Label 30313*/ GIMT_Encode4(2255253), // Rule ID 57214 //
     /* 2255210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2255213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255216 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255223 */   // MIs[0] Operand 1
     /* 2255223 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255228 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255232 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255236 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2255239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255241 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255243 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255252 */   // GIR_Coverage, 57214,
     /* 2255252 */   GIR_EraseRootFromParent_Done,
     /* 2255253 */ // Label 30313: @2255253
     /* 2255253 */ GIM_Try, /*On fail goto*//*Label 30314*/ GIMT_Encode4(2255301), // Rule ID 57215 //
     /* 2255258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2255261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255271 */   // MIs[0] Operand 1
     /* 2255271 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255280 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255284 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_MF2),
     /* 2255287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255289 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255291 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255293 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255299 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255300 */   // GIR_Coverage, 57215,
     /* 2255300 */   GIR_EraseRootFromParent_Done,
     /* 2255301 */ // Label 30314: @2255301
     /* 2255301 */ GIM_Try, /*On fail goto*//*Label 30315*/ GIMT_Encode4(2255349), // Rule ID 57244 //
     /* 2255306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2255309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255312 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255319 */   // MIs[0] Operand 1
     /* 2255319 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255328 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255332 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2255335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255337 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255339 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255348 */   // GIR_Coverage, 57244,
     /* 2255348 */   GIR_EraseRootFromParent_Done,
     /* 2255349 */ // Label 30315: @2255349
     /* 2255349 */ GIM_Try, /*On fail goto*//*Label 30316*/ GIMT_Encode4(2255397), // Rule ID 57245 //
     /* 2255354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2255357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255360 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255367 */   // MIs[0] Operand 1
     /* 2255367 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255376 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255380 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2255383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255385 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255387 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255395 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255396 */   // GIR_Coverage, 57245,
     /* 2255396 */   GIR_EraseRootFromParent_Done,
     /* 2255397 */ // Label 30316: @2255397
     /* 2255397 */ GIM_Try, /*On fail goto*//*Label 30317*/ GIMT_Encode4(2255445), // Rule ID 57324 //
     /* 2255402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2255405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255408 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255415 */   // MIs[0] Operand 1
     /* 2255415 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255424 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255428 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2255431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255433 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255435 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255444 */   // GIR_Coverage, 57324,
     /* 2255444 */   GIR_EraseRootFromParent_Done,
     /* 2255445 */ // Label 30317: @2255445
     /* 2255445 */ GIM_Try, /*On fail goto*//*Label 30318*/ GIMT_Encode4(2255493), // Rule ID 57325 //
     /* 2255450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2255453 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255456 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255463 */   // MIs[0] Operand 1
     /* 2255463 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2255468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255472 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255476 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2255479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255481 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255483 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255485 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255491 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255492 */   // GIR_Coverage, 57325,
     /* 2255492 */   GIR_EraseRootFromParent_Done,
     /* 2255493 */ // Label 30318: @2255493
     /* 2255493 */ GIM_Try, /*On fail goto*//*Label 30319*/ GIMT_Encode4(2255541), // Rule ID 57514 //
     /* 2255498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2255501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255504 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255511 */   // MIs[0] Operand 1
     /* 2255511 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255520 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255524 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2255527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255529 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255531 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255540 */   // GIR_Coverage, 57514,
     /* 2255540 */   GIR_EraseRootFromParent_Done,
     /* 2255541 */ // Label 30319: @2255541
     /* 2255541 */ GIM_Try, /*On fail goto*//*Label 30320*/ GIMT_Encode4(2255589), // Rule ID 57515 //
     /* 2255546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2255549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255552 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255559 */   // MIs[0] Operand 1
     /* 2255559 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255564 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255568 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255572 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_MF2),
     /* 2255575 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255577 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255579 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255588 */   // GIR_Coverage, 57515,
     /* 2255588 */   GIR_EraseRootFromParent_Done,
     /* 2255589 */ // Label 30320: @2255589
     /* 2255589 */ GIM_Try, /*On fail goto*//*Label 30321*/ GIMT_Encode4(2255637), // Rule ID 57544 //
     /* 2255594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2255597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255600 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255607 */   // MIs[0] Operand 1
     /* 2255607 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255616 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255620 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2255623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255625 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255627 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255635 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255636 */   // GIR_Coverage, 57544,
     /* 2255636 */   GIR_EraseRootFromParent_Done,
     /* 2255637 */ // Label 30321: @2255637
     /* 2255637 */ GIM_Try, /*On fail goto*//*Label 30322*/ GIMT_Encode4(2255685), // Rule ID 57545 //
     /* 2255642 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2255645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255648 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255655 */   // MIs[0] Operand 1
     /* 2255655 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255664 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255668 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2255671 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255673 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255675 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255680 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255683 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255684 */   // GIR_Coverage, 57545,
     /* 2255684 */   GIR_EraseRootFromParent_Done,
     /* 2255685 */ // Label 30322: @2255685
     /* 2255685 */ GIM_Try, /*On fail goto*//*Label 30323*/ GIMT_Encode4(2255733), // Rule ID 57624 //
     /* 2255690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2255693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255696 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255703 */   // MIs[0] Operand 1
     /* 2255703 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255708 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255712 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255716 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2255716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2255719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255721 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255723 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255725 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255732 */   // GIR_Coverage, 57624,
     /* 2255732 */   GIR_EraseRootFromParent_Done,
     /* 2255733 */ // Label 30323: @2255733
     /* 2255733 */ GIM_Try, /*On fail goto*//*Label 30324*/ GIMT_Encode4(2255781), // Rule ID 57625 //
     /* 2255738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2255741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255744 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255751 */   // MIs[0] Operand 1
     /* 2255751 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2255756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255760 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2255764 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2255764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2255767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255769 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255771 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255773 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255776 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2255779 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255780 */   // GIR_Coverage, 57625,
     /* 2255780 */   GIR_EraseRootFromParent_Done,
     /* 2255781 */ // Label 30324: @2255781
     /* 2255781 */ GIM_Try, /*On fail goto*//*Label 30325*/ GIMT_Encode4(2255829), // Rule ID 57814 //
     /* 2255786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2255789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255792 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255799 */   // MIs[0] Operand 1
     /* 2255799 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2255804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255808 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255812 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2255812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2255815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255817 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255819 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255828 */   // GIR_Coverage, 57814,
     /* 2255828 */   GIR_EraseRootFromParent_Done,
     /* 2255829 */ // Label 30325: @2255829
     /* 2255829 */ GIM_Try, /*On fail goto*//*Label 30326*/ GIMT_Encode4(2255877), // Rule ID 57815 //
     /* 2255834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2255837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2255840 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2255843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255847 */   // MIs[0] Operand 1
     /* 2255847 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2255852 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255856 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255860 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_MF2:{ *:[nxv2i1] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2255860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_MF2),
     /* 2255863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255865 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255867 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2255875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255876 */   // GIR_Coverage, 57815,
     /* 2255876 */   GIR_EraseRootFromParent_Done,
     /* 2255877 */ // Label 30326: @2255877
     /* 2255877 */ GIM_Try, /*On fail goto*//*Label 30327*/ GIMT_Encode4(2255925), // Rule ID 57844 //
     /* 2255882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2255885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255888 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255895 */   // MIs[0] Operand 1
     /* 2255895 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2255900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255904 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255908 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2255908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2255911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255913 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255915 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255924 */   // GIR_Coverage, 57844,
     /* 2255924 */   GIR_EraseRootFromParent_Done,
     /* 2255925 */ // Label 30327: @2255925
     /* 2255925 */ GIM_Try, /*On fail goto*//*Label 30328*/ GIMT_Encode4(2255973), // Rule ID 57845 //
     /* 2255930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2255933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2255936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2255939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255943 */   // MIs[0] Operand 1
     /* 2255943 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2255948 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255952 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255956 */   // (setcc:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv2i1] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2255956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2255959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2255961 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2255963 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2255965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2255968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2255971 */   GIR_RootConstrainSelectedInstOperands,
     /* 2255972 */   // GIR_Coverage, 57845,
     /* 2255972 */   GIR_EraseRootFromParent_Done,
     /* 2255973 */ // Label 30328: @2255973
     /* 2255973 */ GIM_Try, /*On fail goto*//*Label 30329*/ GIMT_Encode4(2256021), // Rule ID 57924 //
     /* 2255978 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2255981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2255984 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2255987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2255991 */   // MIs[0] Operand 1
     /* 2255991 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2255996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256000 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256004 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2256007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256009 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256011 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256013 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256016 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256019 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256020 */   // GIR_Coverage, 57924,
     /* 2256020 */   GIR_EraseRootFromParent_Done,
     /* 2256021 */ // Label 30329: @2256021
     /* 2256021 */ GIM_Try, /*On fail goto*//*Label 30330*/ GIMT_Encode4(2256069), // Rule ID 57925 //
     /* 2256026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2256029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2256032 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2256035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256039 */   // MIs[0] Operand 1
     /* 2256039 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256048 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256052 */   // (setcc:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv2i1] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2256055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256057 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256059 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256067 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256068 */   // GIR_Coverage, 57925,
     /* 2256068 */   GIR_EraseRootFromParent_Done,
     /* 2256069 */ // Label 30330: @2256069
     /* 2256069 */ GIM_Reject,
     /* 2256070 */ // Label 30239: @2256070
     /* 2256070 */ GIM_Try, /*On fail goto*//*Label 30331*/ GIMT_Encode4(2256118), // Rule ID 56934 //
     /* 2256075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2256078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256081 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256088 */   // MIs[0] Operand 1
     /* 2256088 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256093 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256097 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256101 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2256104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256106 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256108 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256110 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256116 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256117 */   // GIR_Coverage, 56934,
     /* 2256117 */   GIR_EraseRootFromParent_Done,
     /* 2256118 */ // Label 30331: @2256118
     /* 2256118 */ GIM_Try, /*On fail goto*//*Label 30332*/ GIMT_Encode4(2256166), // Rule ID 56935 //
     /* 2256123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2256126 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256129 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256136 */   // MIs[0] Operand 1
     /* 2256136 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256145 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256149 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256149 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M1),
     /* 2256152 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256154 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256156 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256158 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256161 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256164 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256165 */   // GIR_Coverage, 56935,
     /* 2256165 */   GIR_EraseRootFromParent_Done,
     /* 2256166 */ // Label 30332: @2256166
     /* 2256166 */ GIM_Try, /*On fail goto*//*Label 30333*/ GIMT_Encode4(2256214), // Rule ID 56994 //
     /* 2256171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2256174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256184 */   // MIs[0] Operand 1
     /* 2256184 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256193 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256197 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2256200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256202 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256204 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256212 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256213 */   // GIR_Coverage, 56994,
     /* 2256213 */   GIR_EraseRootFromParent_Done,
     /* 2256214 */ // Label 30333: @2256214
     /* 2256214 */ GIM_Try, /*On fail goto*//*Label 30334*/ GIMT_Encode4(2256262), // Rule ID 56995 //
     /* 2256219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2256222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256225 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256232 */   // MIs[0] Operand 1
     /* 2256232 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256241 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256245 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2256248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256250 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256252 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256260 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256261 */   // GIR_Coverage, 56995,
     /* 2256261 */   GIR_EraseRootFromParent_Done,
     /* 2256262 */ // Label 30334: @2256262
     /* 2256262 */ GIM_Try, /*On fail goto*//*Label 30335*/ GIMT_Encode4(2256310), // Rule ID 57034 //
     /* 2256267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2256270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256273 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256280 */   // MIs[0] Operand 1
     /* 2256280 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256289 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256293 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2256296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256298 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256300 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256309 */   // GIR_Coverage, 57034,
     /* 2256309 */   GIR_EraseRootFromParent_Done,
     /* 2256310 */ // Label 30335: @2256310
     /* 2256310 */ GIM_Try, /*On fail goto*//*Label 30336*/ GIMT_Encode4(2256358), // Rule ID 57035 //
     /* 2256315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2256318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256328 */   // MIs[0] Operand 1
     /* 2256328 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2256333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256337 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256341 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2256344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256346 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256348 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256357 */   // GIR_Coverage, 57035,
     /* 2256357 */   GIR_EraseRootFromParent_Done,
     /* 2256358 */ // Label 30336: @2256358
     /* 2256358 */ GIM_Try, /*On fail goto*//*Label 30337*/ GIMT_Encode4(2256406), // Rule ID 57234 //
     /* 2256363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2256366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256369 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256376 */   // MIs[0] Operand 1
     /* 2256376 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256385 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256389 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256389 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2256392 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256394 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256396 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256405 */   // GIR_Coverage, 57234,
     /* 2256405 */   GIR_EraseRootFromParent_Done,
     /* 2256406 */ // Label 30337: @2256406
     /* 2256406 */ GIM_Try, /*On fail goto*//*Label 30338*/ GIMT_Encode4(2256454), // Rule ID 57235 //
     /* 2256411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2256414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256424 */   // MIs[0] Operand 1
     /* 2256424 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256433 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256437 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256437 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M1),
     /* 2256440 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256442 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256444 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256453 */   // GIR_Coverage, 57235,
     /* 2256453 */   GIR_EraseRootFromParent_Done,
     /* 2256454 */ // Label 30338: @2256454
     /* 2256454 */ GIM_Try, /*On fail goto*//*Label 30339*/ GIMT_Encode4(2256502), // Rule ID 57294 //
     /* 2256459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2256462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256465 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256472 */   // MIs[0] Operand 1
     /* 2256472 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256481 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256485 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2256488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256490 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256492 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256500 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256501 */   // GIR_Coverage, 57294,
     /* 2256501 */   GIR_EraseRootFromParent_Done,
     /* 2256502 */ // Label 30339: @2256502
     /* 2256502 */ GIM_Try, /*On fail goto*//*Label 30340*/ GIMT_Encode4(2256550), // Rule ID 57295 //
     /* 2256507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2256510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256520 */   // MIs[0] Operand 1
     /* 2256520 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256525 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256529 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256533 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2256536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256538 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256540 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256548 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256549 */   // GIR_Coverage, 57295,
     /* 2256549 */   GIR_EraseRootFromParent_Done,
     /* 2256550 */ // Label 30340: @2256550
     /* 2256550 */ GIM_Try, /*On fail goto*//*Label 30341*/ GIMT_Encode4(2256598), // Rule ID 57334 //
     /* 2256555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2256558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256561 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256568 */   // MIs[0] Operand 1
     /* 2256568 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256577 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256581 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2256584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256586 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256588 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256593 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256596 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256597 */   // GIR_Coverage, 57334,
     /* 2256597 */   GIR_EraseRootFromParent_Done,
     /* 2256598 */ // Label 30341: @2256598
     /* 2256598 */ GIM_Try, /*On fail goto*//*Label 30342*/ GIMT_Encode4(2256646), // Rule ID 57335 //
     /* 2256603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2256606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256609 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256616 */   // MIs[0] Operand 1
     /* 2256616 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2256621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256625 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256629 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2256632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256634 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256636 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256645 */   // GIR_Coverage, 57335,
     /* 2256645 */   GIR_EraseRootFromParent_Done,
     /* 2256646 */ // Label 30342: @2256646
     /* 2256646 */ GIM_Try, /*On fail goto*//*Label 30343*/ GIMT_Encode4(2256694), // Rule ID 57534 //
     /* 2256651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2256654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256657 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256664 */   // MIs[0] Operand 1
     /* 2256664 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256673 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256677 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2256680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256682 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256684 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256686 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256692 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256693 */   // GIR_Coverage, 57534,
     /* 2256693 */   GIR_EraseRootFromParent_Done,
     /* 2256694 */ // Label 30343: @2256694
     /* 2256694 */ GIM_Try, /*On fail goto*//*Label 30344*/ GIMT_Encode4(2256742), // Rule ID 57535 //
     /* 2256699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2256702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256712 */   // MIs[0] Operand 1
     /* 2256712 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256721 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256725 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2256725 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M1),
     /* 2256728 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256730 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256732 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256740 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256741 */   // GIR_Coverage, 57535,
     /* 2256741 */   GIR_EraseRootFromParent_Done,
     /* 2256742 */ // Label 30344: @2256742
     /* 2256742 */ GIM_Try, /*On fail goto*//*Label 30345*/ GIMT_Encode4(2256790), // Rule ID 57594 //
     /* 2256747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2256750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256753 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256760 */   // MIs[0] Operand 1
     /* 2256760 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256769 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256773 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2256773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2256776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256778 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256780 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256788 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256789 */   // GIR_Coverage, 57594,
     /* 2256789 */   GIR_EraseRootFromParent_Done,
     /* 2256790 */ // Label 30345: @2256790
     /* 2256790 */ GIM_Try, /*On fail goto*//*Label 30346*/ GIMT_Encode4(2256838), // Rule ID 57595 //
     /* 2256795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2256798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2256801 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2256804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256808 */   // MIs[0] Operand 1
     /* 2256808 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256817 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2256821 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2256821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2256824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256826 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256828 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2256836 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256837 */   // GIR_Coverage, 57595,
     /* 2256837 */   GIR_EraseRootFromParent_Done,
     /* 2256838 */ // Label 30346: @2256838
     /* 2256838 */ GIM_Try, /*On fail goto*//*Label 30347*/ GIMT_Encode4(2256886), // Rule ID 57634 //
     /* 2256843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2256846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256849 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256856 */   // MIs[0] Operand 1
     /* 2256856 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256861 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256865 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256869 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2256869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2256872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256874 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256876 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256884 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256885 */   // GIR_Coverage, 57634,
     /* 2256885 */   GIR_EraseRootFromParent_Done,
     /* 2256886 */ // Label 30347: @2256886
     /* 2256886 */ GIM_Try, /*On fail goto*//*Label 30348*/ GIMT_Encode4(2256934), // Rule ID 57635 //
     /* 2256891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2256894 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2256897 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2256900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256904 */   // MIs[0] Operand 1
     /* 2256904 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2256909 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256913 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2256917 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2256917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2256920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256922 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256924 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2256932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256933 */   // GIR_Coverage, 57635,
     /* 2256933 */   GIR_EraseRootFromParent_Done,
     /* 2256934 */ // Label 30348: @2256934
     /* 2256934 */ GIM_Try, /*On fail goto*//*Label 30349*/ GIMT_Encode4(2256982), // Rule ID 57834 //
     /* 2256939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2256942 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256945 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256952 */   // MIs[0] Operand 1
     /* 2256952 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2256957 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256961 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2256965 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2256965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2256968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2256970 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2256972 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2256974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2256977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2256980 */   GIR_RootConstrainSelectedInstOperands,
     /* 2256981 */   // GIR_Coverage, 57834,
     /* 2256981 */   GIR_EraseRootFromParent_Done,
     /* 2256982 */ // Label 30349: @2256982
     /* 2256982 */ GIM_Try, /*On fail goto*//*Label 30350*/ GIMT_Encode4(2257030), // Rule ID 57835 //
     /* 2256987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2256990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2256993 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2256996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257000 */   // MIs[0] Operand 1
     /* 2257000 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257005 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257009 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257013 */   // (setcc:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M1:{ *:[nxv4i1] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M1),
     /* 2257016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257018 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257020 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257022 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257029 */   // GIR_Coverage, 57835,
     /* 2257029 */   GIR_EraseRootFromParent_Done,
     /* 2257030 */ // Label 30350: @2257030
     /* 2257030 */ GIM_Try, /*On fail goto*//*Label 30351*/ GIMT_Encode4(2257078), // Rule ID 57894 //
     /* 2257035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2257038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257048 */   // MIs[0] Operand 1
     /* 2257048 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257053 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257057 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257061 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2257064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257066 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257068 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257077 */   // GIR_Coverage, 57894,
     /* 2257077 */   GIR_EraseRootFromParent_Done,
     /* 2257078 */ // Label 30351: @2257078
     /* 2257078 */ GIM_Try, /*On fail goto*//*Label 30352*/ GIMT_Encode4(2257126), // Rule ID 57895 //
     /* 2257083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2257086 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2257089 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2257092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257096 */   // MIs[0] Operand 1
     /* 2257096 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257109 */   // (setcc:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv4i1] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2257112 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257114 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257116 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257125 */   // GIR_Coverage, 57895,
     /* 2257125 */   GIR_EraseRootFromParent_Done,
     /* 2257126 */ // Label 30352: @2257126
     /* 2257126 */ GIM_Try, /*On fail goto*//*Label 30353*/ GIMT_Encode4(2257174), // Rule ID 57934 //
     /* 2257131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2257134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257137 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257144 */   // MIs[0] Operand 1
     /* 2257144 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257153 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257157 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257157 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2257160 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257162 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257164 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257173 */   // GIR_Coverage, 57934,
     /* 2257173 */   GIR_EraseRootFromParent_Done,
     /* 2257174 */ // Label 30353: @2257174
     /* 2257174 */ GIM_Try, /*On fail goto*//*Label 30354*/ GIMT_Encode4(2257222), // Rule ID 57935 //
     /* 2257179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2257182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2257185 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2257188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257192 */   // MIs[0] Operand 1
     /* 2257192 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2257197 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257201 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257205 */   // (setcc:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv4i1] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2257208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257210 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257212 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257221 */   // GIR_Coverage, 57935,
     /* 2257221 */   GIR_EraseRootFromParent_Done,
     /* 2257222 */ // Label 30354: @2257222
     /* 2257222 */ GIM_Reject,
     /* 2257223 */ // Label 30240: @2257223
     /* 2257223 */ GIM_Try, /*On fail goto*//*Label 30355*/ GIMT_Encode4(2257271), // Rule ID 56964 //
     /* 2257228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2257231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257234 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257241 */   // MIs[0] Operand 1
     /* 2257241 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257250 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257254 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2257257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257259 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257261 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257269 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257270 */   // GIR_Coverage, 56964,
     /* 2257270 */   GIR_EraseRootFromParent_Done,
     /* 2257271 */ // Label 30355: @2257271
     /* 2257271 */ GIM_Try, /*On fail goto*//*Label 30356*/ GIMT_Encode4(2257319), // Rule ID 56965 //
     /* 2257276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2257279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257282 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257289 */   // MIs[0] Operand 1
     /* 2257289 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257294 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257298 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257302 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M2),
     /* 2257305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257307 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257309 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257317 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257318 */   // GIR_Coverage, 56965,
     /* 2257318 */   GIR_EraseRootFromParent_Done,
     /* 2257319 */ // Label 30356: @2257319
     /* 2257319 */ GIM_Try, /*On fail goto*//*Label 30357*/ GIMT_Encode4(2257367), // Rule ID 57004 //
     /* 2257324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2257327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257330 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257337 */   // MIs[0] Operand 1
     /* 2257337 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257346 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257350 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257350 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2257353 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257355 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257357 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257366 */   // GIR_Coverage, 57004,
     /* 2257366 */   GIR_EraseRootFromParent_Done,
     /* 2257367 */ // Label 30357: @2257367
     /* 2257367 */ GIM_Try, /*On fail goto*//*Label 30358*/ GIMT_Encode4(2257415), // Rule ID 57005 //
     /* 2257372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2257375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257378 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257385 */   // MIs[0] Operand 1
     /* 2257385 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257394 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257398 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2257401 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257403 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257405 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257410 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257413 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257414 */   // GIR_Coverage, 57005,
     /* 2257414 */   GIR_EraseRootFromParent_Done,
     /* 2257415 */ // Label 30358: @2257415
     /* 2257415 */ GIM_Try, /*On fail goto*//*Label 30359*/ GIMT_Encode4(2257463), // Rule ID 57044 //
     /* 2257420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2257423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257426 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257433 */   // MIs[0] Operand 1
     /* 2257433 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257442 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257446 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2257449 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257451 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257453 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257462 */   // GIR_Coverage, 57044,
     /* 2257462 */   GIR_EraseRootFromParent_Done,
     /* 2257463 */ // Label 30359: @2257463
     /* 2257463 */ GIM_Try, /*On fail goto*//*Label 30360*/ GIMT_Encode4(2257511), // Rule ID 57045 //
     /* 2257468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2257471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257481 */   // MIs[0] Operand 1
     /* 2257481 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2257486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257490 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257494 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2257497 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257499 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257501 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257509 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257510 */   // GIR_Coverage, 57045,
     /* 2257510 */   GIR_EraseRootFromParent_Done,
     /* 2257511 */ // Label 30360: @2257511
     /* 2257511 */ GIM_Try, /*On fail goto*//*Label 30361*/ GIMT_Encode4(2257559), // Rule ID 57264 //
     /* 2257516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2257519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257522 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257529 */   // MIs[0] Operand 1
     /* 2257529 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257534 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257538 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257542 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2257545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257547 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257549 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257558 */   // GIR_Coverage, 57264,
     /* 2257558 */   GIR_EraseRootFromParent_Done,
     /* 2257559 */ // Label 30361: @2257559
     /* 2257559 */ GIM_Try, /*On fail goto*//*Label 30362*/ GIMT_Encode4(2257607), // Rule ID 57265 //
     /* 2257564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2257567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257570 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257577 */   // MIs[0] Operand 1
     /* 2257577 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257586 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257590 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M2),
     /* 2257593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257595 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257597 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257606 */   // GIR_Coverage, 57265,
     /* 2257606 */   GIR_EraseRootFromParent_Done,
     /* 2257607 */ // Label 30362: @2257607
     /* 2257607 */ GIM_Try, /*On fail goto*//*Label 30363*/ GIMT_Encode4(2257655), // Rule ID 57304 //
     /* 2257612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2257615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257618 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257625 */   // MIs[0] Operand 1
     /* 2257625 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257634 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257638 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2257641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257643 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257645 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257650 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257653 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257654 */   // GIR_Coverage, 57304,
     /* 2257654 */   GIR_EraseRootFromParent_Done,
     /* 2257655 */ // Label 30363: @2257655
     /* 2257655 */ GIM_Try, /*On fail goto*//*Label 30364*/ GIMT_Encode4(2257703), // Rule ID 57305 //
     /* 2257660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2257663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257666 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257673 */   // MIs[0] Operand 1
     /* 2257673 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257686 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257686 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2257689 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257691 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257693 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257702 */   // GIR_Coverage, 57305,
     /* 2257702 */   GIR_EraseRootFromParent_Done,
     /* 2257703 */ // Label 30364: @2257703
     /* 2257703 */ GIM_Try, /*On fail goto*//*Label 30365*/ GIMT_Encode4(2257751), // Rule ID 57344 //
     /* 2257708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2257711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257721 */   // MIs[0] Operand 1
     /* 2257721 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257730 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257734 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2257734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2257737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257739 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257741 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257749 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257750 */   // GIR_Coverage, 57344,
     /* 2257750 */   GIR_EraseRootFromParent_Done,
     /* 2257751 */ // Label 30365: @2257751
     /* 2257751 */ GIM_Try, /*On fail goto*//*Label 30366*/ GIMT_Encode4(2257799), // Rule ID 57345 //
     /* 2257756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2257759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2257762 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2257765 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257769 */   // MIs[0] Operand 1
     /* 2257769 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2257774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257778 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2257782 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2257782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2257785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257787 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257789 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2257797 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257798 */   // GIR_Coverage, 57345,
     /* 2257798 */   GIR_EraseRootFromParent_Done,
     /* 2257799 */ // Label 30366: @2257799
     /* 2257799 */ GIM_Try, /*On fail goto*//*Label 30367*/ GIMT_Encode4(2257847), // Rule ID 57564 //
     /* 2257804 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2257807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257810 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257817 */   // MIs[0] Operand 1
     /* 2257817 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257826 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257830 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2257830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2257833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257835 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257837 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257845 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257846 */   // GIR_Coverage, 57564,
     /* 2257846 */   GIR_EraseRootFromParent_Done,
     /* 2257847 */ // Label 30367: @2257847
     /* 2257847 */ GIM_Try, /*On fail goto*//*Label 30368*/ GIMT_Encode4(2257895), // Rule ID 57565 //
     /* 2257852 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2257855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2257858 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2257861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257865 */   // MIs[0] Operand 1
     /* 2257865 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257870 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257874 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2257878 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2257878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M2),
     /* 2257881 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257883 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257885 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257890 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2257893 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257894 */   // GIR_Coverage, 57565,
     /* 2257894 */   GIR_EraseRootFromParent_Done,
     /* 2257895 */ // Label 30368: @2257895
     /* 2257895 */ GIM_Try, /*On fail goto*//*Label 30369*/ GIMT_Encode4(2257943), // Rule ID 57604 //
     /* 2257900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2257903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257906 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257913 */   // MIs[0] Operand 1
     /* 2257913 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257918 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257922 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257926 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2257926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2257929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257931 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257933 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257942 */   // GIR_Coverage, 57604,
     /* 2257942 */   GIR_EraseRootFromParent_Done,
     /* 2257943 */ // Label 30369: @2257943
     /* 2257943 */ GIM_Try, /*On fail goto*//*Label 30370*/ GIMT_Encode4(2257991), // Rule ID 57605 //
     /* 2257948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2257951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2257954 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2257957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2257961 */   // MIs[0] Operand 1
     /* 2257961 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2257966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257970 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2257974 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2257974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2257977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2257979 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2257981 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2257983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2257986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2257989 */   GIR_RootConstrainSelectedInstOperands,
     /* 2257990 */   // GIR_Coverage, 57605,
     /* 2257990 */   GIR_EraseRootFromParent_Done,
     /* 2257991 */ // Label 30370: @2257991
     /* 2257991 */ GIM_Try, /*On fail goto*//*Label 30371*/ GIMT_Encode4(2258039), // Rule ID 57644 //
     /* 2257996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2257999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258002 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258009 */   // MIs[0] Operand 1
     /* 2258009 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258018 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258022 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2258025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258027 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258029 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258038 */   // GIR_Coverage, 57644,
     /* 2258038 */   GIR_EraseRootFromParent_Done,
     /* 2258039 */ // Label 30371: @2258039
     /* 2258039 */ GIM_Try, /*On fail goto*//*Label 30372*/ GIMT_Encode4(2258087), // Rule ID 57645 //
     /* 2258044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2258047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258050 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258057 */   // MIs[0] Operand 1
     /* 2258057 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258070 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2258073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258075 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258077 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258079 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258085 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258086 */   // GIR_Coverage, 57645,
     /* 2258086 */   GIR_EraseRootFromParent_Done,
     /* 2258087 */ // Label 30372: @2258087
     /* 2258087 */ GIM_Try, /*On fail goto*//*Label 30373*/ GIMT_Encode4(2258135), // Rule ID 57864 //
     /* 2258092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258098 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258105 */   // MIs[0] Operand 1
     /* 2258105 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258110 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258114 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258118 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2258121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258123 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258125 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258130 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258133 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258134 */   // GIR_Coverage, 57864,
     /* 2258134 */   GIR_EraseRootFromParent_Done,
     /* 2258135 */ // Label 30373: @2258135
     /* 2258135 */ GIM_Try, /*On fail goto*//*Label 30374*/ GIMT_Encode4(2258183), // Rule ID 57865 //
     /* 2258140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2258146 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2258149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258153 */   // MIs[0] Operand 1
     /* 2258153 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258158 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258162 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2258166 */   // (setcc:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M2:{ *:[nxv8i1] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M2),
     /* 2258169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258171 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258173 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258182 */   // GIR_Coverage, 57865,
     /* 2258182 */   GIR_EraseRootFromParent_Done,
     /* 2258183 */ // Label 30374: @2258183
     /* 2258183 */ GIM_Try, /*On fail goto*//*Label 30375*/ GIMT_Encode4(2258231), // Rule ID 57904 //
     /* 2258188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258194 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258201 */   // MIs[0] Operand 1
     /* 2258201 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258210 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258214 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2258217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258219 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258221 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258229 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258230 */   // GIR_Coverage, 57904,
     /* 2258230 */   GIR_EraseRootFromParent_Done,
     /* 2258231 */ // Label 30375: @2258231
     /* 2258231 */ GIM_Try, /*On fail goto*//*Label 30376*/ GIMT_Encode4(2258279), // Rule ID 57905 //
     /* 2258236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2258242 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2258245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258249 */   // MIs[0] Operand 1
     /* 2258249 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258254 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258258 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258262 */   // (setcc:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv8i1] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2258265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258267 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258269 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258278 */   // GIR_Coverage, 57905,
     /* 2258278 */   GIR_EraseRootFromParent_Done,
     /* 2258279 */ // Label 30376: @2258279
     /* 2258279 */ GIM_Try, /*On fail goto*//*Label 30377*/ GIMT_Encode4(2258327), // Rule ID 57944 //
     /* 2258284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2258287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258290 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258297 */   // MIs[0] Operand 1
     /* 2258297 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258302 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258306 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258310 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2258310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2258313 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258315 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258317 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258325 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258326 */   // GIR_Coverage, 57944,
     /* 2258326 */   GIR_EraseRootFromParent_Done,
     /* 2258327 */ // Label 30377: @2258327
     /* 2258327 */ GIM_Try, /*On fail goto*//*Label 30378*/ GIMT_Encode4(2258375), // Rule ID 57945 //
     /* 2258332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2258335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2258338 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2258341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258345 */   // MIs[0] Operand 1
     /* 2258345 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258350 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258354 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258358 */   // (setcc:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv8i1] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2258358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2258361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258363 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258365 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258367 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258370 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2258373 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258374 */   // GIR_Coverage, 57945,
     /* 2258374 */   GIR_EraseRootFromParent_Done,
     /* 2258375 */ // Label 30378: @2258375
     /* 2258375 */ GIM_Reject,
     /* 2258376 */ // Label 30241: @2258376
     /* 2258376 */ GIM_Try, /*On fail goto*//*Label 30379*/ GIMT_Encode4(2258424), // Rule ID 56974 //
     /* 2258381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258387 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258394 */   // MIs[0] Operand 1
     /* 2258394 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258403 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258407 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2258410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258412 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258414 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258416 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258422 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258423 */   // GIR_Coverage, 56974,
     /* 2258423 */   GIR_EraseRootFromParent_Done,
     /* 2258424 */ // Label 30379: @2258424
     /* 2258424 */ GIM_Try, /*On fail goto*//*Label 30380*/ GIMT_Encode4(2258472), // Rule ID 56975 //
     /* 2258429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258435 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258442 */   // MIs[0] Operand 1
     /* 2258442 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258451 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258455 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M4),
     /* 2258458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258460 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258462 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258471 */   // GIR_Coverage, 56975,
     /* 2258471 */   GIR_EraseRootFromParent_Done,
     /* 2258472 */ // Label 30380: @2258472
     /* 2258472 */ GIM_Try, /*On fail goto*//*Label 30381*/ GIMT_Encode4(2258520), // Rule ID 57014 //
     /* 2258477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258490 */   // MIs[0] Operand 1
     /* 2258490 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258495 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258499 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258503 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258503 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2258506 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258508 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258510 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258518 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258519 */   // GIR_Coverage, 57014,
     /* 2258519 */   GIR_EraseRootFromParent_Done,
     /* 2258520 */ // Label 30381: @2258520
     /* 2258520 */ GIM_Try, /*On fail goto*//*Label 30382*/ GIMT_Encode4(2258568), // Rule ID 57015 //
     /* 2258525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258531 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258538 */   // MIs[0] Operand 1
     /* 2258538 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2258543 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258547 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258551 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2258554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258556 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258558 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258563 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258566 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258567 */   // GIR_Coverage, 57015,
     /* 2258567 */   GIR_EraseRootFromParent_Done,
     /* 2258568 */ // Label 30382: @2258568
     /* 2258568 */ GIM_Try, /*On fail goto*//*Label 30383*/ GIMT_Encode4(2258616), // Rule ID 57274 //
     /* 2258573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258579 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258586 */   // MIs[0] Operand 1
     /* 2258586 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258595 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258599 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2258602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258604 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258606 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258614 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258615 */   // GIR_Coverage, 57274,
     /* 2258615 */   GIR_EraseRootFromParent_Done,
     /* 2258616 */ // Label 30383: @2258616
     /* 2258616 */ GIM_Try, /*On fail goto*//*Label 30384*/ GIMT_Encode4(2258664), // Rule ID 57275 //
     /* 2258621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258624 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258627 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258634 */   // MIs[0] Operand 1
     /* 2258634 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258643 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258647 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M4),
     /* 2258650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258652 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258654 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258662 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258663 */   // GIR_Coverage, 57275,
     /* 2258663 */   GIR_EraseRootFromParent_Done,
     /* 2258664 */ // Label 30384: @2258664
     /* 2258664 */ GIM_Try, /*On fail goto*//*Label 30385*/ GIMT_Encode4(2258712), // Rule ID 57314 //
     /* 2258669 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258675 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258682 */   // MIs[0] Operand 1
     /* 2258682 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258691 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258695 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2258698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258700 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258702 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258710 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258711 */   // GIR_Coverage, 57314,
     /* 2258711 */   GIR_EraseRootFromParent_Done,
     /* 2258712 */ // Label 30385: @2258712
     /* 2258712 */ GIM_Try, /*On fail goto*//*Label 30386*/ GIMT_Encode4(2258760), // Rule ID 57315 //
     /* 2258717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258723 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258730 */   // MIs[0] Operand 1
     /* 2258730 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2258735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258739 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258743 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2258746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258748 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258750 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258759 */   // GIR_Coverage, 57315,
     /* 2258759 */   GIR_EraseRootFromParent_Done,
     /* 2258760 */ // Label 30386: @2258760
     /* 2258760 */ GIM_Try, /*On fail goto*//*Label 30387*/ GIMT_Encode4(2258808), // Rule ID 57574 //
     /* 2258765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258771 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258778 */   // MIs[0] Operand 1
     /* 2258778 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258787 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258791 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2258794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258796 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258798 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258800 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258807 */   // GIR_Coverage, 57574,
     /* 2258807 */   GIR_EraseRootFromParent_Done,
     /* 2258808 */ // Label 30387: @2258808
     /* 2258808 */ GIM_Try, /*On fail goto*//*Label 30388*/ GIMT_Encode4(2258856), // Rule ID 57575 //
     /* 2258813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2258816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258826 */   // MIs[0] Operand 1
     /* 2258826 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258835 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258839 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2258839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M4),
     /* 2258842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258844 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258846 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258854 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258855 */   // GIR_Coverage, 57575,
     /* 2258855 */   GIR_EraseRootFromParent_Done,
     /* 2258856 */ // Label 30388: @2258856
     /* 2258856 */ GIM_Try, /*On fail goto*//*Label 30389*/ GIMT_Encode4(2258904), // Rule ID 57614 //
     /* 2258861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2258864 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258867 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258874 */   // MIs[0] Operand 1
     /* 2258874 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258879 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258883 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258887 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2258887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2258890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258892 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258894 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258896 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258899 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258902 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258903 */   // GIR_Coverage, 57614,
     /* 2258903 */   GIR_EraseRootFromParent_Done,
     /* 2258904 */ // Label 30389: @2258904
     /* 2258904 */ GIM_Try, /*On fail goto*//*Label 30390*/ GIMT_Encode4(2258952), // Rule ID 57615 //
     /* 2258909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2258912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2258915 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2258918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258922 */   // MIs[0] Operand 1
     /* 2258922 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2258927 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258931 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2258935 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2258935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2258938 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258940 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258942 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2258950 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258951 */   // GIR_Coverage, 57615,
     /* 2258951 */   GIR_EraseRootFromParent_Done,
     /* 2258952 */ // Label 30390: @2258952
     /* 2258952 */ GIM_Try, /*On fail goto*//*Label 30391*/ GIMT_Encode4(2259000), // Rule ID 57874 //
     /* 2258957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2258960 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2258963 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2258966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2258970 */   // MIs[0] Operand 1
     /* 2258970 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2258975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258979 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2258983 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2258983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2258986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2258988 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2258990 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2258992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2258995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2258998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2258999 */   // GIR_Coverage, 57874,
     /* 2258999 */   GIR_EraseRootFromParent_Done,
     /* 2259000 */ // Label 30391: @2259000
     /* 2259000 */ GIM_Try, /*On fail goto*//*Label 30392*/ GIMT_Encode4(2259048), // Rule ID 57875 //
     /* 2259005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2259011 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2259014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259018 */   // MIs[0] Operand 1
     /* 2259018 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259023 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259027 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2259031 */   // (setcc:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M4:{ *:[nxv16i1] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M4),
     /* 2259034 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259036 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259038 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259046 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259047 */   // GIR_Coverage, 57875,
     /* 2259047 */   GIR_EraseRootFromParent_Done,
     /* 2259048 */ // Label 30392: @2259048
     /* 2259048 */ GIM_Try, /*On fail goto*//*Label 30393*/ GIMT_Encode4(2259096), // Rule ID 57914 //
     /* 2259053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2259056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2259059 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2259062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259066 */   // MIs[0] Operand 1
     /* 2259066 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259075 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259079 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2259079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2259082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259084 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259086 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259091 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259094 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259095 */   // GIR_Coverage, 57914,
     /* 2259095 */   GIR_EraseRootFromParent_Done,
     /* 2259096 */ // Label 30393: @2259096
     /* 2259096 */ GIM_Try, /*On fail goto*//*Label 30394*/ GIMT_Encode4(2259144), // Rule ID 57915 //
     /* 2259101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2259104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2259107 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2259110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259114 */   // MIs[0] Operand 1
     /* 2259114 */   GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259123 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259127 */   // (setcc:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv16i1] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2259127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2259130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259132 */   GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259134 */   GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259136 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2259142 */   GIR_RootConstrainSelectedInstOperands,
     /* 2259143 */   // GIR_Coverage, 57915,
     /* 2259143 */   GIR_EraseRootFromParent_Done,
     /* 2259144 */ // Label 30394: @2259144
     /* 2259144 */ GIM_Reject,
     /* 2259145 */ // Label 30242: @2259145
     /* 2259145 */ GIM_Try, /*On fail goto*//*Label 30395*/ GIMT_Encode4(2259465),
     /* 2259150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2259153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2259156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259160 */   GIM_Try, /*On fail goto*//*Label 30396*/ GIMT_Encode4(2259198), // Rule ID 56984 //
     /* 2259165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259168 */     // MIs[0] Operand 1
     /* 2259168 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259181 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2259184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259188 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259197 */     // GIR_Coverage, 56984,
     /* 2259197 */     GIR_EraseRootFromParent_Done,
     /* 2259198 */   // Label 30396: @2259198
     /* 2259198 */   GIM_Try, /*On fail goto*//*Label 30397*/ GIMT_Encode4(2259236), // Rule ID 56985 //
     /* 2259203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259206 */     // MIs[0] Operand 1
     /* 2259206 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OEQ),
     /* 2259211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259219 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOEQ:{ *:[Other] })  =>  (PseudoVMFEQ_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFEQ_VV_M8),
     /* 2259222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259226 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259235 */     // GIR_Coverage, 56985,
     /* 2259235 */     GIR_EraseRootFromParent_Done,
     /* 2259236 */   // Label 30397: @2259236
     /* 2259236 */   GIM_Try, /*On fail goto*//*Label 30398*/ GIMT_Encode4(2259274), // Rule ID 57284 //
     /* 2259241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259244 */     // MIs[0] Operand 1
     /* 2259244 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259257 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2259260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259264 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259273 */     // GIR_Coverage, 57284,
     /* 2259273 */     GIR_EraseRootFromParent_Done,
     /* 2259274 */   // Label 30398: @2259274
     /* 2259274 */   GIM_Try, /*On fail goto*//*Label 30399*/ GIMT_Encode4(2259312), // Rule ID 57285 //
     /* 2259279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259282 */     // MIs[0] Operand 1
     /* 2259282 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_UNE),
     /* 2259287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259295 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETUNE:{ *:[Other] })  =>  (PseudoVMFNE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFNE_VV_M8),
     /* 2259298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259302 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259311 */     // GIR_Coverage, 57285,
     /* 2259311 */     GIR_EraseRootFromParent_Done,
     /* 2259312 */   // Label 30399: @2259312
     /* 2259312 */   GIM_Try, /*On fail goto*//*Label 30400*/ GIMT_Encode4(2259350), // Rule ID 57584 //
     /* 2259317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259320 */     // MIs[0] Operand 1
     /* 2259320 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259333 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2259336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259338 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259340 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259349 */     // GIR_Coverage, 57584,
     /* 2259349 */     GIR_EraseRootFromParent_Done,
     /* 2259350 */   // Label 30400: @2259350
     /* 2259350 */   GIM_Try, /*On fail goto*//*Label 30401*/ GIMT_Encode4(2259388), // Rule ID 57585 //
     /* 2259355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259358 */     // MIs[0] Operand 1
     /* 2259358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLT),
     /* 2259363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259371 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLT:{ *:[Other] })  =>  (PseudoVMFLT_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLT_VV_M8),
     /* 2259374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259387 */     // GIR_Coverage, 57585,
     /* 2259387 */     GIR_EraseRootFromParent_Done,
     /* 2259388 */   // Label 30401: @2259388
     /* 2259388 */   GIM_Try, /*On fail goto*//*Label 30402*/ GIMT_Encode4(2259426), // Rule ID 57884 //
     /* 2259393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2259396 */     // MIs[0] Operand 1
     /* 2259396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259409 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2259409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2259412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259416 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259425 */     // GIR_Coverage, 57884,
     /* 2259425 */     GIR_EraseRootFromParent_Done,
     /* 2259426 */   // Label 30402: @2259426
     /* 2259426 */   GIM_Try, /*On fail goto*//*Label 30403*/ GIMT_Encode4(2259464), // Rule ID 57885 //
     /* 2259431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2259434 */     // MIs[0] Operand 1
     /* 2259434 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::FCMP_OLE),
     /* 2259439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2259447 */     // (setcc:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, SETOLE:{ *:[Other] })  =>  (PseudoVMFLE_VV_M8:{ *:[nxv32i1] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2259447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMFLE_VV_M8),
     /* 2259450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259454 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2259462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259463 */     // GIR_Coverage, 57885,
     /* 2259463 */     GIR_EraseRootFromParent_Done,
     /* 2259464 */   // Label 30403: @2259464
     /* 2259464 */   GIM_Reject,
     /* 2259465 */ // Label 30395: @2259465
     /* 2259465 */ GIM_Reject,
     /* 2259466 */ // Label 30243: @2259466
     /* 2259466 */ GIM_Reject,
     /* 2259467 */ // Label 50: @2259467
     /* 2259467 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30428*/ GIMT_Encode4(2263858),
     /* 2259478 */ /*GILLT_s32*//*Label 30404*/ GIMT_Encode4(2259602),
     /* 2259482 */ /*GILLT_s64*//*Label 30405*/ GIMT_Encode4(2259750), GIMT_Encode4(0),
     /* 2259490 */ /*GILLT_nxv1s8*//*Label 30406*/ GIMT_Encode4(2259898),
     /* 2259494 */ /*GILLT_nxv1s16*//*Label 30407*/ GIMT_Encode4(2260018),
     /* 2259498 */ /*GILLT_nxv1s32*//*Label 30408*/ GIMT_Encode4(2260226),
     /* 2259502 */ /*GILLT_nxv1s64*//*Label 30409*/ GIMT_Encode4(2260434), GIMT_Encode4(0),
     /* 2259510 */ /*GILLT_nxv2s8*//*Label 30410*/ GIMT_Encode4(2260642),
     /* 2259514 */ /*GILLT_nxv2s16*//*Label 30411*/ GIMT_Encode4(2260762),
     /* 2259518 */ /*GILLT_nxv2s32*//*Label 30412*/ GIMT_Encode4(2260970),
     /* 2259522 */ /*GILLT_nxv2s64*//*Label 30413*/ GIMT_Encode4(2261178), GIMT_Encode4(0),
     /* 2259530 */ /*GILLT_nxv4s8*//*Label 30414*/ GIMT_Encode4(2261386),
     /* 2259534 */ /*GILLT_nxv4s16*//*Label 30415*/ GIMT_Encode4(2261506),
     /* 2259538 */ /*GILLT_nxv4s32*//*Label 30416*/ GIMT_Encode4(2261714),
     /* 2259542 */ /*GILLT_nxv4s64*//*Label 30417*/ GIMT_Encode4(2261922), GIMT_Encode4(0),
     /* 2259550 */ /*GILLT_nxv8s8*//*Label 30418*/ GIMT_Encode4(2262130),
     /* 2259554 */ /*GILLT_nxv8s16*//*Label 30419*/ GIMT_Encode4(2262250),
     /* 2259558 */ /*GILLT_nxv8s32*//*Label 30420*/ GIMT_Encode4(2262458),
     /* 2259562 */ /*GILLT_nxv8s64*//*Label 30421*/ GIMT_Encode4(2262666), GIMT_Encode4(0),
     /* 2259570 */ /*GILLT_nxv16s8*//*Label 30422*/ GIMT_Encode4(2262874),
     /* 2259574 */ /*GILLT_nxv16s16*//*Label 30423*/ GIMT_Encode4(2262994),
     /* 2259578 */ /*GILLT_nxv16s32*//*Label 30424*/ GIMT_Encode4(2263202), GIMT_Encode4(0),
     /* 2259586 */ /*GILLT_nxv32s8*//*Label 30425*/ GIMT_Encode4(2263410),
     /* 2259590 */ /*GILLT_nxv32s16*//*Label 30426*/ GIMT_Encode4(2263530), GIMT_Encode4(0),
     /* 2259598 */ /*GILLT_nxv64s8*//*Label 30427*/ GIMT_Encode4(2263738),
     /* 2259602 */ // Label 30404: @2259602
     /* 2259602 */ GIM_Try, /*On fail goto*//*Label 30429*/ GIMT_Encode4(2259749),
     /* 2259607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2259610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2259613 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2259616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259624 */   GIM_Try, /*On fail goto*//*Label 30430*/ GIMT_Encode4(2259657), // Rule ID 62554 //
     /* 2259629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2259632 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2259636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259640 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, 0:{ *:[i32] }, GPR:{ *:[i32] }:$b)  =>  (TH_MVNEZ:{ *:[i32] } GPR:{ *:[i32] }:$b, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2259640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2259643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259645 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2259647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2259653 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259656 */     // GIR_Coverage, 62554,
     /* 2259656 */     GIR_EraseRootFromParent_Done,
     /* 2259657 */   // Label 30430: @2259657
     /* 2259657 */   GIM_Try, /*On fail goto*//*Label 30431*/ GIMT_Encode4(2259690), // Rule ID 62552 //
     /* 2259662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2259665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259669 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2259673 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, X0:{ *:[i32] }, GPR:{ *:[i32] }:$cond)
     /* 2259673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2259676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259678 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2259680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2259686 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259689 */     // GIR_Coverage, 62552,
     /* 2259689 */     GIR_EraseRootFromParent_Done,
     /* 2259690 */   // Label 30431: @2259690
     /* 2259690 */   GIM_Try, /*On fail goto*//*Label 30432*/ GIMT_Encode4(2259719), // Rule ID 62550 //
     /* 2259695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode1),
     /* 2259698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259706 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$cond, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (TH_MVEQZ:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$cond)
     /* 2259706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2259709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259711 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2259713 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2259715 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259718 */     // GIR_Coverage, 62550,
     /* 2259718 */     GIR_EraseRootFromParent_Done,
     /* 2259719 */   // Label 30432: @2259719
     /* 2259719 */   GIM_Try, /*On fail goto*//*Label 30433*/ GIMT_Encode4(2259748), // Rule ID 64565 //
     /* 2259724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode1),
     /* 2259727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259735 */     // (select:{ *:[i32] } GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2, GPR:{ *:[i32] }:$rs3)
     /* 2259735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2259738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2259744 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2259746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259747 */     // GIR_Coverage, 64565,
     /* 2259747 */     GIR_EraseRootFromParent_Done,
     /* 2259748 */   // Label 30433: @2259748
     /* 2259748 */   GIM_Reject,
     /* 2259749 */ // Label 30429: @2259749
     /* 2259749 */ GIM_Reject,
     /* 2259750 */ // Label 30405: @2259750
     /* 2259750 */ GIM_Try, /*On fail goto*//*Label 30434*/ GIMT_Encode4(2259897),
     /* 2259755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2259758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2259761 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2259764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259772 */   GIM_Try, /*On fail goto*//*Label 30435*/ GIMT_Encode4(2259805), // Rule ID 62553 //
     /* 2259777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2259780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 2259784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259788 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, 0:{ *:[i64] }, GPR:{ *:[i64] }:$b)  =>  (TH_MVNEZ:{ *:[i64] } GPR:{ *:[i64] }:$b, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2259788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVNEZ),
     /* 2259791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259793 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2259795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2259801 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259804 */     // GIR_Coverage, 62553,
     /* 2259804 */     GIR_EraseRootFromParent_Done,
     /* 2259805 */   // Label 30435: @2259805
     /* 2259805 */   GIM_Try, /*On fail goto*//*Label 30436*/ GIMT_Encode4(2259838), // Rule ID 62551 //
     /* 2259810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2259813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 2259821 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, 0:{ *:[i64] })  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, X0:{ *:[i64] }, GPR:{ *:[i64] }:$cond)
     /* 2259821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2259824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259826 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2259828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2259834 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259837 */     // GIR_Coverage, 62551,
     /* 2259837 */     GIR_EraseRootFromParent_Done,
     /* 2259838 */   // Label 30436: @2259838
     /* 2259838 */   GIM_Try, /*On fail goto*//*Label 30437*/ GIMT_Encode4(2259867), // Rule ID 62549 //
     /* 2259843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadCondMov_HwMode0),
     /* 2259846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259854 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$cond, GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b)  =>  (TH_MVEQZ:{ *:[i64] } GPR:{ *:[i64] }:$a, GPR:{ *:[i64] }:$b, GPR:{ *:[i64] }:$cond)
     /* 2259854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_MVEQZ),
     /* 2259857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd_wb]
     /* 2259859 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /* 2259861 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /* 2259863 */     GIR_RootToRootCopy, /*OpIdx*/1, // cond
     /* 2259865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259866 */     // GIR_Coverage, 62549,
     /* 2259866 */     GIR_EraseRootFromParent_Done,
     /* 2259867 */   // Label 30437: @2259867
     /* 2259867 */   GIM_Try, /*On fail goto*//*Label 30438*/ GIMT_Encode4(2259896), // Rule ID 64564 //
     /* 2259872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseCCMovInsn_HwMode0),
     /* 2259875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2259883 */     // (select:{ *:[i64] } GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs3)  =>  (MIPS_CCMOV:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2, GPR:{ *:[i64] }:$rs3)
     /* 2259883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::MIPS_CCMOV),
     /* 2259886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2259892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2259894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259895 */     // GIR_Coverage, 64564,
     /* 2259895 */     GIR_EraseRootFromParent_Done,
     /* 2259896 */   // Label 30438: @2259896
     /* 2259896 */   GIM_Reject,
     /* 2259897 */ // Label 30434: @2259897
     /* 2259897 */ GIM_Reject,
     /* 2259898 */ // Label 30406: @2259898
     /* 2259898 */ GIM_Try, /*On fail goto*//*Label 30439*/ GIMT_Encode4(2260017),
     /* 2259903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2259906 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2259909 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s8,
     /* 2259912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2259916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2259920 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259924 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2259928 */   GIM_Try, /*On fail goto*//*Label 30440*/ GIMT_Encode4(2259972), // Rule ID 52114 //
     /* 2259933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2259936 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2259936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2259939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2259953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2259958 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2259960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2259962 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2259964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2259967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2259970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2259971 */     // GIR_Coverage, 52114,
     /* 2259971 */     GIR_EraseRootFromParent_Done,
     /* 2259972 */   // Label 30440: @2259972
     /* 2259972 */   GIM_Try, /*On fail goto*//*Label 30441*/ GIMT_Encode4(2260016), // Rule ID 52115 //
     /* 2259977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2259980 */     // (vselect:{ *:[nxv1i8] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs2, VR:{ *:[nxv1i8] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2259980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2259983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2259987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2259992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2259994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF8),
     /* 2259997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2259999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260002 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260006 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260015 */     // GIR_Coverage, 52115,
     /* 2260015 */     GIR_EraseRootFromParent_Done,
     /* 2260016 */   // Label 30441: @2260016
     /* 2260016 */   GIM_Reject,
     /* 2260017 */ // Label 30439: @2260017
     /* 2260017 */ GIM_Reject,
     /* 2260018 */ // Label 30407: @2260018
     /* 2260018 */ GIM_Try, /*On fail goto*//*Label 30442*/ GIMT_Encode4(2260225),
     /* 2260023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2260026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2260029 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2260032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260044 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260048 */   GIM_Try, /*On fail goto*//*Label 30443*/ GIMT_Encode4(2260092), // Rule ID 52132 //
     /* 2260053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260056 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2260059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260078 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260082 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260091 */     // GIR_Coverage, 52132,
     /* 2260091 */     GIR_EraseRootFromParent_Done,
     /* 2260092 */   // Label 30443: @2260092
     /* 2260092 */   GIM_Try, /*On fail goto*//*Label 30444*/ GIMT_Encode4(2260136), // Rule ID 52133 //
     /* 2260097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260100 */     // (vselect:{ *:[nxv1i16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs2, VR:{ *:[nxv1i16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2260103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260122 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260126 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260135 */     // GIR_Coverage, 52133,
     /* 2260135 */     GIR_EraseRootFromParent_Done,
     /* 2260136 */   // Label 30444: @2260136
     /* 2260136 */   GIM_Try, /*On fail goto*//*Label 30445*/ GIMT_Encode4(2260180), // Rule ID 57954 //
     /* 2260141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260144 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2260147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260166 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260168 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260170 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260179 */     // GIR_Coverage, 57954,
     /* 2260179 */     GIR_EraseRootFromParent_Done,
     /* 2260180 */   // Label 30445: @2260180
     /* 2260180 */   GIM_Try, /*On fail goto*//*Label 30446*/ GIMT_Encode4(2260224), // Rule ID 57955 //
     /* 2260185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260188 */     // (vselect:{ *:[nxv1f16] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, VR:{ *:[nxv1f16] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2260191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260210 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260214 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260223 */     // GIR_Coverage, 57955,
     /* 2260223 */     GIR_EraseRootFromParent_Done,
     /* 2260224 */   // Label 30446: @2260224
     /* 2260224 */   GIM_Reject,
     /* 2260225 */ // Label 30442: @2260225
     /* 2260225 */ GIM_Reject,
     /* 2260226 */ // Label 30408: @2260226
     /* 2260226 */ GIM_Try, /*On fail goto*//*Label 30447*/ GIMT_Encode4(2260433),
     /* 2260231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2260234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2260237 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2260240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260252 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260256 */   GIM_Try, /*On fail goto*//*Label 30448*/ GIMT_Encode4(2260300), // Rule ID 52144 //
     /* 2260261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260264 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2260267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260290 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260299 */     // GIR_Coverage, 52144,
     /* 2260299 */     GIR_EraseRootFromParent_Done,
     /* 2260300 */   // Label 30448: @2260300
     /* 2260300 */   GIM_Try, /*On fail goto*//*Label 30449*/ GIMT_Encode4(2260344), // Rule ID 52145 //
     /* 2260305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260308 */     // (vselect:{ *:[nxv1i32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs2, VR:{ *:[nxv1i32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2260311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260334 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260342 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260343 */     // GIR_Coverage, 52145,
     /* 2260343 */     GIR_EraseRootFromParent_Done,
     /* 2260344 */   // Label 30449: @2260344
     /* 2260344 */   GIM_Try, /*On fail goto*//*Label 30450*/ GIMT_Encode4(2260388), // Rule ID 57974 //
     /* 2260349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260352 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2260352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2260355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260374 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260378 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260387 */     // GIR_Coverage, 57974,
     /* 2260387 */     GIR_EraseRootFromParent_Done,
     /* 2260388 */   // Label 30450: @2260388
     /* 2260388 */   GIM_Try, /*On fail goto*//*Label 30451*/ GIMT_Encode4(2260432), // Rule ID 57975 //
     /* 2260393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260396 */     // (vselect:{ *:[nxv1f32] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, VR:{ *:[nxv1f32] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2260396 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2260399 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260403 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260420 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260422 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2260430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260431 */     // GIR_Coverage, 57975,
     /* 2260431 */     GIR_EraseRootFromParent_Done,
     /* 2260432 */   // Label 30451: @2260432
     /* 2260432 */   GIM_Reject,
     /* 2260433 */ // Label 30447: @2260433
     /* 2260433 */ GIM_Reject,
     /* 2260434 */ // Label 30409: @2260434
     /* 2260434 */ GIM_Try, /*On fail goto*//*Label 30452*/ GIMT_Encode4(2260641),
     /* 2260439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 2260442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2260445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2260448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260456 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260460 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260464 */   GIM_Try, /*On fail goto*//*Label 30453*/ GIMT_Encode4(2260508), // Rule ID 52168 //
     /* 2260469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260472 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2260475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2260489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260494 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260498 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260507 */     // GIR_Coverage, 52168,
     /* 2260507 */     GIR_EraseRootFromParent_Done,
     /* 2260508 */   // Label 30453: @2260508
     /* 2260508 */   GIM_Try, /*On fail goto*//*Label 30454*/ GIMT_Encode4(2260552), // Rule ID 52169 //
     /* 2260513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260516 */     // (vselect:{ *:[nxv1i64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs2, VR:{ *:[nxv1i64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2260519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2260533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260538 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260542 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260551 */     // GIR_Coverage, 52169,
     /* 2260551 */     GIR_EraseRootFromParent_Done,
     /* 2260552 */   // Label 30454: @2260552
     /* 2260552 */   GIM_Try, /*On fail goto*//*Label 30455*/ GIMT_Encode4(2260596), // Rule ID 58004 //
     /* 2260557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2260560 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2260560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2260563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2260577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260586 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260595 */     // GIR_Coverage, 58004,
     /* 2260595 */     GIR_EraseRootFromParent_Done,
     /* 2260596 */   // Label 30455: @2260596
     /* 2260596 */   GIM_Try, /*On fail goto*//*Label 30456*/ GIMT_Encode4(2260640), // Rule ID 58005 //
     /* 2260601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2260604 */     // (vselect:{ *:[nxv1f64] } VMV0:{ *:[nxv1i1] }:$vm, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, VR:{ *:[nxv1f64] }:$rs1, VMV0:{ *:[nxv1i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2260604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2260607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2260621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260630 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2260638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260639 */     // GIR_Coverage, 58005,
     /* 2260639 */     GIR_EraseRootFromParent_Done,
     /* 2260640 */   // Label 30456: @2260640
     /* 2260640 */   GIM_Reject,
     /* 2260641 */ // Label 30452: @2260641
     /* 2260641 */ GIM_Reject,
     /* 2260642 */ // Label 30410: @2260642
     /* 2260642 */ GIM_Try, /*On fail goto*//*Label 30457*/ GIMT_Encode4(2260761),
     /* 2260647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2260650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2260653 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s8,
     /* 2260656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260664 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260668 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260672 */   GIM_Try, /*On fail goto*//*Label 30458*/ GIMT_Encode4(2260716), // Rule ID 52120 //
     /* 2260677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260680 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2260680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2260683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260702 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260706 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260715 */     // GIR_Coverage, 52120,
     /* 2260715 */     GIR_EraseRootFromParent_Done,
     /* 2260716 */   // Label 30458: @2260716
     /* 2260716 */   GIM_Try, /*On fail goto*//*Label 30459*/ GIMT_Encode4(2260760), // Rule ID 52121 //
     /* 2260721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260724 */     // (vselect:{ *:[nxv2i8] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs2, VR:{ *:[nxv2i8] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2260724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2260727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF4),
     /* 2260741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260750 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2260758 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260759 */     // GIR_Coverage, 52121,
     /* 2260759 */     GIR_EraseRootFromParent_Done,
     /* 2260760 */   // Label 30459: @2260760
     /* 2260760 */   GIM_Reject,
     /* 2260761 */ // Label 30457: @2260761
     /* 2260761 */ GIM_Reject,
     /* 2260762 */ // Label 30411: @2260762
     /* 2260762 */ GIM_Try, /*On fail goto*//*Label 30460*/ GIMT_Encode4(2260969),
     /* 2260767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2260770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2260773 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2260776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260788 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260792 */   GIM_Try, /*On fail goto*//*Label 30461*/ GIMT_Encode4(2260836), // Rule ID 52138 //
     /* 2260797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260800 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260800 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2260803 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260807 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260819 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260822 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260826 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260835 */     // GIR_Coverage, 52138,
     /* 2260835 */     GIR_EraseRootFromParent_Done,
     /* 2260836 */   // Label 30461: @2260836
     /* 2260836 */   GIM_Try, /*On fail goto*//*Label 30462*/ GIMT_Encode4(2260880), // Rule ID 52139 //
     /* 2260841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260844 */     // (vselect:{ *:[nxv2i16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs2, VR:{ *:[nxv2i16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2260847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260866 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260868 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260870 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260879 */     // GIR_Coverage, 52139,
     /* 2260879 */     GIR_EraseRootFromParent_Done,
     /* 2260880 */   // Label 30462: @2260880
     /* 2260880 */   GIM_Try, /*On fail goto*//*Label 30463*/ GIMT_Encode4(2260924), // Rule ID 57964 //
     /* 2260885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2260888 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2260888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2260891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260914 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260923 */     // GIR_Coverage, 57964,
     /* 2260923 */     GIR_EraseRootFromParent_Done,
     /* 2260924 */   // Label 30463: @2260924
     /* 2260924 */   GIM_Try, /*On fail goto*//*Label 30464*/ GIMT_Encode4(2260968), // Rule ID 57965 //
     /* 2260929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2260932 */     // (vselect:{ *:[nxv2f16] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, VR:{ *:[nxv2f16] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2260932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2260935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2260939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2260944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2260946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2260949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2260951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2260954 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2260956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2260958 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2260960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2260963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2260966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2260967 */     // GIR_Coverage, 57965,
     /* 2260967 */     GIR_EraseRootFromParent_Done,
     /* 2260968 */   // Label 30464: @2260968
     /* 2260968 */   GIM_Reject,
     /* 2260969 */ // Label 30460: @2260969
     /* 2260969 */ GIM_Reject,
     /* 2260970 */ // Label 30412: @2260970
     /* 2260970 */ GIM_Try, /*On fail goto*//*Label 30465*/ GIMT_Encode4(2261177),
     /* 2260975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2260978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2260981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2260984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2260988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2260992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2260996 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261000 */   GIM_Try, /*On fail goto*//*Label 30466*/ GIMT_Encode4(2261044), // Rule ID 52162 //
     /* 2261005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261008 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2261011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261034 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261043 */     // GIR_Coverage, 52162,
     /* 2261043 */     GIR_EraseRootFromParent_Done,
     /* 2261044 */   // Label 30466: @2261044
     /* 2261044 */   GIM_Try, /*On fail goto*//*Label 30467*/ GIMT_Encode4(2261088), // Rule ID 52163 //
     /* 2261049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261052 */     // (vselect:{ *:[nxv2i32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs2, VR:{ *:[nxv2i32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2261055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261074 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261078 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261087 */     // GIR_Coverage, 52163,
     /* 2261087 */     GIR_EraseRootFromParent_Done,
     /* 2261088 */   // Label 30467: @2261088
     /* 2261088 */   GIM_Try, /*On fail goto*//*Label 30468*/ GIMT_Encode4(2261132), // Rule ID 57994 //
     /* 2261093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261096 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2261099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261118 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261122 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261131 */     // GIR_Coverage, 57994,
     /* 2261131 */     GIR_EraseRootFromParent_Done,
     /* 2261132 */   // Label 30468: @2261132
     /* 2261132 */   GIM_Try, /*On fail goto*//*Label 30469*/ GIMT_Encode4(2261176), // Rule ID 57995 //
     /* 2261137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261140 */     // (vselect:{ *:[nxv2f32] } VMV0:{ *:[nxv2i1] }:$vm, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, VR:{ *:[nxv2f32] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2261143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261162 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261166 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261175 */     // GIR_Coverage, 57995,
     /* 2261175 */     GIR_EraseRootFromParent_Done,
     /* 2261176 */   // Label 30469: @2261176
     /* 2261176 */   GIM_Reject,
     /* 2261177 */ // Label 30465: @2261177
     /* 2261177 */ GIM_Reject,
     /* 2261178 */ // Label 30413: @2261178
     /* 2261178 */ GIM_Try, /*On fail goto*//*Label 30470*/ GIMT_Encode4(2261385),
     /* 2261183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 2261186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2261189 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2261192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2261196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2261200 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261204 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261208 */   GIM_Try, /*On fail goto*//*Label 30471*/ GIMT_Encode4(2261252), // Rule ID 52228 //
     /* 2261213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261216 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2261219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261238 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261242 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261251 */     // GIR_Coverage, 52228,
     /* 2261251 */     GIR_EraseRootFromParent_Done,
     /* 2261252 */   // Label 30471: @2261252
     /* 2261252 */   GIM_Try, /*On fail goto*//*Label 30472*/ GIMT_Encode4(2261296), // Rule ID 52229 //
     /* 2261257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261260 */     // (vselect:{ *:[nxv2i64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs2, VRM2:{ *:[nxv2i64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261260 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2261263 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261267 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261282 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261286 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261295 */     // GIR_Coverage, 52229,
     /* 2261295 */     GIR_EraseRootFromParent_Done,
     /* 2261296 */   // Label 30472: @2261296
     /* 2261296 */   GIM_Try, /*On fail goto*//*Label 30473*/ GIMT_Encode4(2261340), // Rule ID 58074 //
     /* 2261301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261304 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2261307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261323 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261326 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261330 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261339 */     // GIR_Coverage, 58074,
     /* 2261339 */     GIR_EraseRootFromParent_Done,
     /* 2261340 */   // Label 30473: @2261340
     /* 2261340 */   GIM_Try, /*On fail goto*//*Label 30474*/ GIMT_Encode4(2261384), // Rule ID 58075 //
     /* 2261345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2261348 */     // (vselect:{ *:[nxv2f64] } VMV0:{ *:[nxv2i1] }:$vm, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, VRM2:{ *:[nxv2f64] }:$rs1, VMV0:{ *:[nxv2i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2261348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2261351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261370 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261374 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261382 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261383 */     // GIR_Coverage, 58075,
     /* 2261383 */     GIR_EraseRootFromParent_Done,
     /* 2261384 */   // Label 30474: @2261384
     /* 2261384 */   GIM_Reject,
     /* 2261385 */ // Label 30470: @2261385
     /* 2261385 */ GIM_Reject,
     /* 2261386 */ // Label 30414: @2261386
     /* 2261386 */ GIM_Try, /*On fail goto*//*Label 30475*/ GIMT_Encode4(2261505),
     /* 2261391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2261394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2261397 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s8,
     /* 2261400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2261404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2261408 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261412 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261416 */   GIM_Try, /*On fail goto*//*Label 30476*/ GIMT_Encode4(2261460), // Rule ID 52126 //
     /* 2261421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261424 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2261424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2261427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2261441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261446 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261450 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261459 */     // GIR_Coverage, 52126,
     /* 2261459 */     GIR_EraseRootFromParent_Done,
     /* 2261460 */   // Label 30476: @2261460
     /* 2261460 */   GIM_Try, /*On fail goto*//*Label 30477*/ GIMT_Encode4(2261504), // Rule ID 52127 //
     /* 2261465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261468 */     // (vselect:{ *:[nxv4i8] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMERGE_VVM_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs2, VR:{ *:[nxv4i8] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2261468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2261471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_MF2),
     /* 2261485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261490 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261494 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2261502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261503 */     // GIR_Coverage, 52127,
     /* 2261503 */     GIR_EraseRootFromParent_Done,
     /* 2261504 */   // Label 30477: @2261504
     /* 2261504 */   GIM_Reject,
     /* 2261505 */ // Label 30475: @2261505
     /* 2261505 */ GIM_Reject,
     /* 2261506 */ // Label 30415: @2261506
     /* 2261506 */ GIM_Try, /*On fail goto*//*Label 30478*/ GIMT_Encode4(2261713),
     /* 2261511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2261514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2261517 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2261520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2261524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2261528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261532 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2261536 */   GIM_Try, /*On fail goto*//*Label 30479*/ GIMT_Encode4(2261580), // Rule ID 52156 //
     /* 2261541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261544 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2261547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261566 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261570 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261579 */     // GIR_Coverage, 52156,
     /* 2261579 */     GIR_EraseRootFromParent_Done,
     /* 2261580 */   // Label 30479: @2261580
     /* 2261580 */   GIM_Try, /*On fail goto*//*Label 30480*/ GIMT_Encode4(2261624), // Rule ID 52157 //
     /* 2261585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261588 */     // (vselect:{ *:[nxv4i16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs2, VR:{ *:[nxv4i16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2261591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261614 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261623 */     // GIR_Coverage, 52157,
     /* 2261623 */     GIR_EraseRootFromParent_Done,
     /* 2261624 */   // Label 30480: @2261624
     /* 2261624 */   GIM_Try, /*On fail goto*//*Label 30481*/ GIMT_Encode4(2261668), // Rule ID 57984 //
     /* 2261629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261632 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2261632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2261635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261654 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261658 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261667 */     // GIR_Coverage, 57984,
     /* 2261667 */     GIR_EraseRootFromParent_Done,
     /* 2261668 */   // Label 30481: @2261668
     /* 2261668 */   GIM_Try, /*On fail goto*//*Label 30482*/ GIMT_Encode4(2261712), // Rule ID 57985 //
     /* 2261673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261676 */     // (vselect:{ *:[nxv4f16] } VMV0:{ *:[nxv4i1] }:$vm, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, VR:{ *:[nxv4f16] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2261676 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2261679 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261683 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2261693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261700 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261702 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2261710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261711 */     // GIR_Coverage, 57985,
     /* 2261711 */     GIR_EraseRootFromParent_Done,
     /* 2261712 */   // Label 30482: @2261712
     /* 2261712 */   GIM_Reject,
     /* 2261713 */ // Label 30478: @2261713
     /* 2261713 */ GIM_Reject,
     /* 2261714 */ // Label 30416: @2261714
     /* 2261714 */ GIM_Try, /*On fail goto*//*Label 30483*/ GIMT_Encode4(2261921),
     /* 2261719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2261722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2261725 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2261728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2261732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2261736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261740 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2261744 */   GIM_Try, /*On fail goto*//*Label 30484*/ GIMT_Encode4(2261788), // Rule ID 52210 //
     /* 2261749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261752 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2261755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261774 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261778 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261787 */     // GIR_Coverage, 52210,
     /* 2261787 */     GIR_EraseRootFromParent_Done,
     /* 2261788 */   // Label 30484: @2261788
     /* 2261788 */   GIM_Try, /*On fail goto*//*Label 30485*/ GIMT_Encode4(2261832), // Rule ID 52211 //
     /* 2261793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261796 */     // (vselect:{ *:[nxv4i32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs2, VRM2:{ *:[nxv4i32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2261799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261822 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261831 */     // GIR_Coverage, 52211,
     /* 2261831 */     GIR_EraseRootFromParent_Done,
     /* 2261832 */   // Label 30485: @2261832
     /* 2261832 */   GIM_Try, /*On fail goto*//*Label 30486*/ GIMT_Encode4(2261876), // Rule ID 58044 //
     /* 2261837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2261840 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2261840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2261843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261864 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261866 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261875 */     // GIR_Coverage, 58044,
     /* 2261875 */     GIR_EraseRootFromParent_Done,
     /* 2261876 */   // Label 30486: @2261876
     /* 2261876 */   GIM_Try, /*On fail goto*//*Label 30487*/ GIMT_Encode4(2261920), // Rule ID 58045 //
     /* 2261881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2261884 */     // (vselect:{ *:[nxv4f32] } VMV0:{ *:[nxv4i1] }:$vm, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, VRM2:{ *:[nxv4f32] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2261884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2261887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2261901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261906 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261910 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2261918 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261919 */     // GIR_Coverage, 58045,
     /* 2261919 */     GIR_EraseRootFromParent_Done,
     /* 2261920 */   // Label 30487: @2261920
     /* 2261920 */   GIM_Reject,
     /* 2261921 */ // Label 30483: @2261921
     /* 2261921 */ GIM_Reject,
     /* 2261922 */ // Label 30417: @2261922
     /* 2261922 */ GIM_Try, /*On fail goto*//*Label 30488*/ GIMT_Encode4(2262129),
     /* 2261927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 2261930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2261933 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2261936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2261940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2261944 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261948 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2261952 */   GIM_Try, /*On fail goto*//*Label 30489*/ GIMT_Encode4(2261996), // Rule ID 52234 //
     /* 2261957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2261960 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2261960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2261963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2261967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2261972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2261974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2261977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2261979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2261982 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2261984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2261986 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2261988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2261991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2261994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2261995 */     // GIR_Coverage, 52234,
     /* 2261995 */     GIR_EraseRootFromParent_Done,
     /* 2261996 */   // Label 30489: @2261996
     /* 2261996 */   GIM_Try, /*On fail goto*//*Label 30490*/ GIMT_Encode4(2262040), // Rule ID 52235 //
     /* 2262001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262004 */     // (vselect:{ *:[nxv4i64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs2, VRM4:{ *:[nxv4i64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2262007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262026 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262028 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262030 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262039 */     // GIR_Coverage, 52235,
     /* 2262039 */     GIR_EraseRootFromParent_Done,
     /* 2262040 */   // Label 30490: @2262040
     /* 2262040 */   GIM_Try, /*On fail goto*//*Label 30491*/ GIMT_Encode4(2262084), // Rule ID 58084 //
     /* 2262045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262048 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2262051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262074 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262083 */     // GIR_Coverage, 58084,
     /* 2262083 */     GIR_EraseRootFromParent_Done,
     /* 2262084 */   // Label 30491: @2262084
     /* 2262084 */   GIM_Try, /*On fail goto*//*Label 30492*/ GIMT_Encode4(2262128), // Rule ID 58085 //
     /* 2262089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262092 */     // (vselect:{ *:[nxv4f64] } VMV0:{ *:[nxv4i1] }:$vm, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, VRM4:{ *:[nxv4f64] }:$rs1, VMV0:{ *:[nxv4i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2262095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262118 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262127 */     // GIR_Coverage, 58085,
     /* 2262127 */     GIR_EraseRootFromParent_Done,
     /* 2262128 */   // Label 30492: @2262128
     /* 2262128 */   GIM_Reject,
     /* 2262129 */ // Label 30488: @2262129
     /* 2262129 */ GIM_Reject,
     /* 2262130 */ // Label 30418: @2262130
     /* 2262130 */ GIM_Try, /*On fail goto*//*Label 30493*/ GIMT_Encode4(2262249),
     /* 2262135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2262138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2262141 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s8,
     /* 2262144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2262148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2262152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262156 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2262160 */   GIM_Try, /*On fail goto*//*Label 30494*/ GIMT_Encode4(2262204), // Rule ID 52150 //
     /* 2262165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262168 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2262171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2262185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262194 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262203 */     // GIR_Coverage, 52150,
     /* 2262203 */     GIR_EraseRootFromParent_Done,
     /* 2262204 */   // Label 30494: @2262204
     /* 2262204 */   GIM_Try, /*On fail goto*//*Label 30495*/ GIMT_Encode4(2262248), // Rule ID 52151 //
     /* 2262209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262212 */     // (vselect:{ *:[nxv8i8] } VMV0:{ *:[nxv8i1] }:$vm, VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs2, VR:{ *:[nxv8i8] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2262215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M1),
     /* 2262229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262238 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262247 */     // GIR_Coverage, 52151,
     /* 2262247 */     GIR_EraseRootFromParent_Done,
     /* 2262248 */   // Label 30495: @2262248
     /* 2262248 */   GIM_Reject,
     /* 2262249 */ // Label 30493: @2262249
     /* 2262249 */ GIM_Reject,
     /* 2262250 */ // Label 30419: @2262250
     /* 2262250 */ GIM_Try, /*On fail goto*//*Label 30496*/ GIMT_Encode4(2262457),
     /* 2262255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2262258 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2262261 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2262264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2262268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2262272 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262276 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262280 */   GIM_Try, /*On fail goto*//*Label 30497*/ GIMT_Encode4(2262324), // Rule ID 52192 //
     /* 2262285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262288 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2262291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262310 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262314 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262323 */     // GIR_Coverage, 52192,
     /* 2262323 */     GIR_EraseRootFromParent_Done,
     /* 2262324 */   // Label 30497: @2262324
     /* 2262324 */   GIM_Try, /*On fail goto*//*Label 30498*/ GIMT_Encode4(2262368), // Rule ID 52193 //
     /* 2262329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262332 */     // (vselect:{ *:[nxv8i16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs2, VRM2:{ *:[nxv8i16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2262335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262354 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262358 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262367 */     // GIR_Coverage, 52193,
     /* 2262367 */     GIR_EraseRootFromParent_Done,
     /* 2262368 */   // Label 30498: @2262368
     /* 2262368 */   GIM_Try, /*On fail goto*//*Label 30499*/ GIMT_Encode4(2262412), // Rule ID 58014 //
     /* 2262373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262376 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2262376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2262379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262398 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262400 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262402 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262411 */     // GIR_Coverage, 58014,
     /* 2262411 */     GIR_EraseRootFromParent_Done,
     /* 2262412 */   // Label 30499: @2262412
     /* 2262412 */   GIM_Try, /*On fail goto*//*Label 30500*/ GIMT_Encode4(2262456), // Rule ID 58015 //
     /* 2262417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262420 */     // (vselect:{ *:[nxv8f16] } VMV0:{ *:[nxv8i1] }:$vm, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, VRM2:{ *:[nxv8f16] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2262420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2262423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262442 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262444 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262446 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2262454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262455 */     // GIR_Coverage, 58015,
     /* 2262455 */     GIR_EraseRootFromParent_Done,
     /* 2262456 */   // Label 30500: @2262456
     /* 2262456 */   GIM_Reject,
     /* 2262457 */ // Label 30496: @2262457
     /* 2262457 */ GIM_Reject,
     /* 2262458 */ // Label 30420: @2262458
     /* 2262458 */ GIM_Try, /*On fail goto*//*Label 30501*/ GIMT_Encode4(2262665),
     /* 2262463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2262466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2262469 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2262472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2262476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2262480 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262484 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2262488 */   GIM_Try, /*On fail goto*//*Label 30502*/ GIMT_Encode4(2262532), // Rule ID 52216 //
     /* 2262493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262496 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2262499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262522 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262531 */     // GIR_Coverage, 52216,
     /* 2262531 */     GIR_EraseRootFromParent_Done,
     /* 2262532 */   // Label 30502: @2262532
     /* 2262532 */   GIM_Try, /*On fail goto*//*Label 30503*/ GIMT_Encode4(2262576), // Rule ID 52217 //
     /* 2262537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262540 */     // (vselect:{ *:[nxv8i32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs2, VRM4:{ *:[nxv8i32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2262543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262562 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262564 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262566 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262575 */     // GIR_Coverage, 52217,
     /* 2262575 */     GIR_EraseRootFromParent_Done,
     /* 2262576 */   // Label 30503: @2262576
     /* 2262576 */   GIM_Try, /*On fail goto*//*Label 30504*/ GIMT_Encode4(2262620), // Rule ID 58054 //
     /* 2262581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262584 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2262584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2262587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262606 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262610 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262619 */     // GIR_Coverage, 58054,
     /* 2262619 */     GIR_EraseRootFromParent_Done,
     /* 2262620 */   // Label 30504: @2262620
     /* 2262620 */   GIM_Try, /*On fail goto*//*Label 30505*/ GIMT_Encode4(2262664), // Rule ID 58055 //
     /* 2262625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262628 */     // (vselect:{ *:[nxv8f32] } VMV0:{ *:[nxv8i1] }:$vm, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, VRM4:{ *:[nxv8f32] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2262628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2262631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2262645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262647 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262650 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262654 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2262662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262663 */     // GIR_Coverage, 58055,
     /* 2262663 */     GIR_EraseRootFromParent_Done,
     /* 2262664 */   // Label 30505: @2262664
     /* 2262664 */   GIM_Reject,
     /* 2262665 */ // Label 30501: @2262665
     /* 2262665 */ GIM_Reject,
     /* 2262666 */ // Label 30421: @2262666
     /* 2262666 */ GIM_Try, /*On fail goto*//*Label 30506*/ GIMT_Encode4(2262873),
     /* 2262671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 2262674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2262677 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2262680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2262684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2262688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262692 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2262696 */   GIM_Try, /*On fail goto*//*Label 30507*/ GIMT_Encode4(2262740), // Rule ID 52240 //
     /* 2262701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262704 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2262707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2262721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262726 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262730 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262739 */     // GIR_Coverage, 52240,
     /* 2262739 */     GIR_EraseRootFromParent_Done,
     /* 2262740 */   // Label 30507: @2262740
     /* 2262740 */   GIM_Try, /*On fail goto*//*Label 30508*/ GIMT_Encode4(2262784), // Rule ID 52241 //
     /* 2262745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262748 */     // (vselect:{ *:[nxv8i64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs2, VRM8:{ *:[nxv8i64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2262751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2262765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262774 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262783 */     // GIR_Coverage, 52241,
     /* 2262783 */     GIR_EraseRootFromParent_Done,
     /* 2262784 */   // Label 30508: @2262784
     /* 2262784 */   GIM_Try, /*On fail goto*//*Label 30509*/ GIMT_Encode4(2262828), // Rule ID 58094 //
     /* 2262789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2262792 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i64] }, 6:{ *:[i64] })
     /* 2262792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2262795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2262809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262818 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262827 */     // GIR_Coverage, 58094,
     /* 2262827 */     GIR_EraseRootFromParent_Done,
     /* 2262828 */   // Label 30509: @2262828
     /* 2262828 */   GIM_Try, /*On fail goto*//*Label 30510*/ GIMT_Encode4(2262872), // Rule ID 58095 //
     /* 2262833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2262836 */     // (vselect:{ *:[nxv8f64] } VMV0:{ *:[nxv8i1] }:$vm, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, VRM8:{ *:[nxv8f64] }:$rs1, VMV0:{ *:[nxv8i1] }:$vm, -1:{ *:[i32] }, 6:{ *:[i32] })
     /* 2262836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2262839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2262853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262858 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262862 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2262870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262871 */     // GIR_Coverage, 58095,
     /* 2262871 */     GIR_EraseRootFromParent_Done,
     /* 2262872 */   // Label 30510: @2262872
     /* 2262872 */   GIM_Reject,
     /* 2262873 */ // Label 30506: @2262873
     /* 2262873 */ GIM_Reject,
     /* 2262874 */ // Label 30422: @2262874
     /* 2262874 */ GIM_Try, /*On fail goto*//*Label 30511*/ GIMT_Encode4(2262993),
     /* 2262879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2262882 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2262885 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 2262888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2262892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2262896 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262900 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2262904 */   GIM_Try, /*On fail goto*//*Label 30512*/ GIMT_Encode4(2262948), // Rule ID 52174 //
     /* 2262909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2262912 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2262912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2262915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262936 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262938 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262947 */     // GIR_Coverage, 52174,
     /* 2262947 */     GIR_EraseRootFromParent_Done,
     /* 2262948 */   // Label 30512: @2262948
     /* 2262948 */   GIM_Try, /*On fail goto*//*Label 30513*/ GIMT_Encode4(2262992), // Rule ID 52175 //
     /* 2262953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2262956 */     // (vselect:{ *:[nxv16i8] } VMV0:{ *:[nxv16i1] }:$vm, VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs2, VRM2:{ *:[nxv16i8] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2262956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2262959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2262963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2262968 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2262970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M2),
     /* 2262973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2262975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2262978 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2262980 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2262982 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2262984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2262987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2262990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2262991 */     // GIR_Coverage, 52175,
     /* 2262991 */     GIR_EraseRootFromParent_Done,
     /* 2262992 */   // Label 30513: @2262992
     /* 2262992 */   GIM_Reject,
     /* 2262993 */ // Label 30511: @2262993
     /* 2262993 */ GIM_Reject,
     /* 2262994 */ // Label 30423: @2262994
     /* 2262994 */ GIM_Try, /*On fail goto*//*Label 30514*/ GIMT_Encode4(2263201),
     /* 2262999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2263002 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2263005 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2263008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2263012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2263016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263020 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263024 */   GIM_Try, /*On fail goto*//*Label 30515*/ GIMT_Encode4(2263068), // Rule ID 52198 //
     /* 2263029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263032 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263054 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263058 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263067 */     // GIR_Coverage, 52198,
     /* 2263067 */     GIR_EraseRootFromParent_Done,
     /* 2263068 */   // Label 30515: @2263068
     /* 2263068 */   GIM_Try, /*On fail goto*//*Label 30516*/ GIMT_Encode4(2263112), // Rule ID 52199 //
     /* 2263073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263076 */     // (vselect:{ *:[nxv16i16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs2, VRM4:{ *:[nxv16i16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263102 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263111 */     // GIR_Coverage, 52199,
     /* 2263111 */     GIR_EraseRootFromParent_Done,
     /* 2263112 */   // Label 30516: @2263112
     /* 2263112 */   GIM_Try, /*On fail goto*//*Label 30517*/ GIMT_Encode4(2263156), // Rule ID 58024 //
     /* 2263117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263120 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263146 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263155 */     // GIR_Coverage, 58024,
     /* 2263155 */     GIR_EraseRootFromParent_Done,
     /* 2263156 */   // Label 30517: @2263156
     /* 2263156 */   GIM_Try, /*On fail goto*//*Label 30518*/ GIMT_Encode4(2263200), // Rule ID 58025 //
     /* 2263161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263164 */     // (vselect:{ *:[nxv16f16] } VMV0:{ *:[nxv16i1] }:$vm, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, VRM4:{ *:[nxv16f16] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2263167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263190 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263199 */     // GIR_Coverage, 58025,
     /* 2263199 */     GIR_EraseRootFromParent_Done,
     /* 2263200 */   // Label 30518: @2263200
     /* 2263200 */   GIM_Reject,
     /* 2263201 */ // Label 30514: @2263201
     /* 2263201 */ GIM_Reject,
     /* 2263202 */ // Label 30424: @2263202
     /* 2263202 */ GIM_Try, /*On fail goto*//*Label 30519*/ GIMT_Encode4(2263409),
     /* 2263207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 2263210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2263213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2263216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2263220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2263224 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263228 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263232 */   GIM_Try, /*On fail goto*//*Label 30520*/ GIMT_Encode4(2263276), // Rule ID 52222 //
     /* 2263237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263240 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263266 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263275 */     // GIR_Coverage, 52222,
     /* 2263275 */     GIR_EraseRootFromParent_Done,
     /* 2263276 */   // Label 30520: @2263276
     /* 2263276 */   GIM_Try, /*On fail goto*//*Label 30521*/ GIMT_Encode4(2263320), // Rule ID 52223 //
     /* 2263281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263284 */     // (vselect:{ *:[nxv16i32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs2, VRM8:{ *:[nxv16i32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263308 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263310 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263318 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263319 */     // GIR_Coverage, 52223,
     /* 2263319 */     GIR_EraseRootFromParent_Done,
     /* 2263320 */   // Label 30521: @2263320
     /* 2263320 */   GIM_Try, /*On fail goto*//*Label 30522*/ GIMT_Encode4(2263364), // Rule ID 58064 //
     /* 2263325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263328 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i64] }, 5:{ *:[i64] })
     /* 2263328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263352 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263354 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263363 */     // GIR_Coverage, 58064,
     /* 2263363 */     GIR_EraseRootFromParent_Done,
     /* 2263364 */   // Label 30522: @2263364
     /* 2263364 */   GIM_Try, /*On fail goto*//*Label 30523*/ GIMT_Encode4(2263408), // Rule ID 58065 //
     /* 2263369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263372 */     // (vselect:{ *:[nxv16f32] } VMV0:{ *:[nxv16i1] }:$vm, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, VRM8:{ *:[nxv16f32] }:$rs1, VMV0:{ *:[nxv16i1] }:$vm, -1:{ *:[i32] }, 5:{ *:[i32] })
     /* 2263372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2263375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263394 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263398 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2263406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263407 */     // GIR_Coverage, 58065,
     /* 2263407 */     GIR_EraseRootFromParent_Done,
     /* 2263408 */   // Label 30523: @2263408
     /* 2263408 */   GIM_Reject,
     /* 2263409 */ // Label 30519: @2263409
     /* 2263409 */ GIM_Reject,
     /* 2263410 */ // Label 30425: @2263410
     /* 2263410 */ GIM_Try, /*On fail goto*//*Label 30524*/ GIMT_Encode4(2263529),
     /* 2263415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2263418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2263421 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s8,
     /* 2263424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2263428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2263432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263436 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2263440 */   GIM_Try, /*On fail goto*//*Label 30525*/ GIMT_Encode4(2263484), // Rule ID 52180 //
     /* 2263445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263448 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2263451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263470 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263474 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263483 */     // GIR_Coverage, 52180,
     /* 2263483 */     GIR_EraseRootFromParent_Done,
     /* 2263484 */   // Label 30525: @2263484
     /* 2263484 */   GIM_Try, /*On fail goto*//*Label 30526*/ GIMT_Encode4(2263528), // Rule ID 52181 //
     /* 2263489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263492 */     // (vselect:{ *:[nxv32i8] } VMV0:{ *:[nxv32i1] }:$vm, VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs2, VRM4:{ *:[nxv32i8] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2263495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M4),
     /* 2263509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263514 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263518 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263527 */     // GIR_Coverage, 52181,
     /* 2263527 */     GIR_EraseRootFromParent_Done,
     /* 2263528 */   // Label 30526: @2263528
     /* 2263528 */   GIM_Reject,
     /* 2263529 */ // Label 30524: @2263529
     /* 2263529 */ GIM_Reject,
     /* 2263530 */ // Label 30426: @2263530
     /* 2263530 */ GIM_Try, /*On fail goto*//*Label 30527*/ GIMT_Encode4(2263737),
     /* 2263535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s1,
     /* 2263538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2263541 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2263544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2263548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2263552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263556 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263560 */   GIM_Try, /*On fail goto*//*Label 30528*/ GIMT_Encode4(2263604), // Rule ID 52204 //
     /* 2263565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263568 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2263571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263590 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263594 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263603 */     // GIR_Coverage, 52204,
     /* 2263603 */     GIR_EraseRootFromParent_Done,
     /* 2263604 */   // Label 30528: @2263604
     /* 2263604 */   GIM_Try, /*On fail goto*//*Label 30529*/ GIMT_Encode4(2263648), // Rule ID 52205 //
     /* 2263609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263612 */     // (vselect:{ *:[nxv32i16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs2, VRM8:{ *:[nxv32i16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2263615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263634 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263638 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263647 */     // GIR_Coverage, 52205,
     /* 2263647 */     GIR_EraseRootFromParent_Done,
     /* 2263648 */   // Label 30529: @2263648
     /* 2263648 */   GIM_Try, /*On fail goto*//*Label 30530*/ GIMT_Encode4(2263692), // Rule ID 58034 //
     /* 2263653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263656 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i64] }, 4:{ *:[i64] })
     /* 2263656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2263659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263682 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263691 */     // GIR_Coverage, 58034,
     /* 2263691 */     GIR_EraseRootFromParent_Done,
     /* 2263692 */   // Label 30530: @2263692
     /* 2263692 */   GIM_Try, /*On fail goto*//*Label 30531*/ GIMT_Encode4(2263736), // Rule ID 58035 //
     /* 2263697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263700 */     // (vselect:{ *:[nxv32f16] } VMV0:{ *:[nxv32i1] }:$vm, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, VRM8:{ *:[nxv32f16] }:$rs1, VMV0:{ *:[nxv32i1] }:$vm, -1:{ *:[i32] }, 4:{ *:[i32] })
     /* 2263700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2263703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263726 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2263734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263735 */     // GIR_Coverage, 58035,
     /* 2263735 */     GIR_EraseRootFromParent_Done,
     /* 2263736 */   // Label 30531: @2263736
     /* 2263736 */   GIM_Reject,
     /* 2263737 */ // Label 30527: @2263737
     /* 2263737 */ GIM_Reject,
     /* 2263738 */ // Label 30427: @2263738
     /* 2263738 */ GIM_Try, /*On fail goto*//*Label 30532*/ GIMT_Encode4(2263857),
     /* 2263743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s1,
     /* 2263746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2263749 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv64s8,
     /* 2263752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2263756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2263760 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263764 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2263768 */   GIM_Try, /*On fail goto*//*Label 30533*/ GIMT_Encode4(2263812), // Rule ID 52186 //
     /* 2263773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2263776 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i64] }, 3:{ *:[i64] })
     /* 2263776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2263779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263788 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263798 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263800 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263802 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263811 */     // GIR_Coverage, 52186,
     /* 2263811 */     GIR_EraseRootFromParent_Done,
     /* 2263812 */   // Label 30533: @2263812
     /* 2263812 */   GIM_Try, /*On fail goto*//*Label 30534*/ GIMT_Encode4(2263856), // Rule ID 52187 //
     /* 2263817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2263820 */     // (vselect:{ *:[nxv64i8] } VMV0:{ *:[nxv64i1] }:$vm, VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMERGE_VVM_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs2, VRM8:{ *:[nxv64i8] }:$rs1, VMV0:{ *:[nxv64i1] }:$vm, -1:{ *:[i32] }, 3:{ *:[i32] })
     /* 2263820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2263823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2263827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2263832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2263834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMERGE_VVM_M8),
     /* 2263837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2263839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2263842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2263844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2263846 */     GIR_RootToRootCopy, /*OpIdx*/1, // vm
     /* 2263848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2263851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2263854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2263855 */     // GIR_Coverage, 52187,
     /* 2263855 */     GIR_EraseRootFromParent_Done,
     /* 2263856 */   // Label 30534: @2263856
     /* 2263856 */   GIM_Reject,
     /* 2263857 */ // Label 30532: @2263857
     /* 2263857 */ GIM_Reject,
     /* 2263858 */ // Label 30428: @2263858
     /* 2263858 */ GIM_Reject,
     /* 2263859 */ // Label 51: @2263859
     /* 2263859 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30559*/ GIMT_Encode4(2266592),
     /* 2263870 */ /*GILLT_s32*//*Label 30535*/ GIMT_Encode4(2263994),
     /* 2263874 */ /*GILLT_s64*//*Label 30536*/ GIMT_Encode4(2264028), GIMT_Encode4(0),
     /* 2263882 */ /*GILLT_nxv1s8*//*Label 30537*/ GIMT_Encode4(2264062),
     /* 2263886 */ /*GILLT_nxv1s16*//*Label 30538*/ GIMT_Encode4(2264177),
     /* 2263890 */ /*GILLT_nxv1s32*//*Label 30539*/ GIMT_Encode4(2264292),
     /* 2263894 */ /*GILLT_nxv1s64*//*Label 30540*/ GIMT_Encode4(2264407), GIMT_Encode4(0),
     /* 2263902 */ /*GILLT_nxv2s8*//*Label 30541*/ GIMT_Encode4(2264522),
     /* 2263906 */ /*GILLT_nxv2s16*//*Label 30542*/ GIMT_Encode4(2264637),
     /* 2263910 */ /*GILLT_nxv2s32*//*Label 30543*/ GIMT_Encode4(2264752),
     /* 2263914 */ /*GILLT_nxv2s64*//*Label 30544*/ GIMT_Encode4(2264867), GIMT_Encode4(0),
     /* 2263922 */ /*GILLT_nxv4s8*//*Label 30545*/ GIMT_Encode4(2264982),
     /* 2263926 */ /*GILLT_nxv4s16*//*Label 30546*/ GIMT_Encode4(2265097),
     /* 2263930 */ /*GILLT_nxv4s32*//*Label 30547*/ GIMT_Encode4(2265212),
     /* 2263934 */ /*GILLT_nxv4s64*//*Label 30548*/ GIMT_Encode4(2265327), GIMT_Encode4(0),
     /* 2263942 */ /*GILLT_nxv8s8*//*Label 30549*/ GIMT_Encode4(2265442),
     /* 2263946 */ /*GILLT_nxv8s16*//*Label 30550*/ GIMT_Encode4(2265557),
     /* 2263950 */ /*GILLT_nxv8s32*//*Label 30551*/ GIMT_Encode4(2265672),
     /* 2263954 */ /*GILLT_nxv8s64*//*Label 30552*/ GIMT_Encode4(2265787), GIMT_Encode4(0),
     /* 2263962 */ /*GILLT_nxv16s8*//*Label 30553*/ GIMT_Encode4(2265902),
     /* 2263966 */ /*GILLT_nxv16s16*//*Label 30554*/ GIMT_Encode4(2266017),
     /* 2263970 */ /*GILLT_nxv16s32*//*Label 30555*/ GIMT_Encode4(2266132), GIMT_Encode4(0),
     /* 2263978 */ /*GILLT_nxv32s8*//*Label 30556*/ GIMT_Encode4(2266247),
     /* 2263982 */ /*GILLT_nxv32s16*//*Label 30557*/ GIMT_Encode4(2266362), GIMT_Encode4(0),
     /* 2263990 */ /*GILLT_nxv64s8*//*Label 30558*/ GIMT_Encode4(2266477),
     /* 2263994 */ // Label 30535: @2263994
     /* 2263994 */ GIM_Try, /*On fail goto*//*Label 30560*/ GIMT_Encode4(2264027), // Rule ID 294 //
     /* 2263999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2264002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2264005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2264008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264016 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264020 */   // (mulhu:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULHU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2264020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2264025 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264026 */   // GIR_Coverage, 294,
     /* 2264026 */   GIR_Done,
     /* 2264027 */ // Label 30560: @2264027
     /* 2264027 */ GIM_Reject,
     /* 2264028 */ // Label 30536: @2264028
     /* 2264028 */ GIM_Try, /*On fail goto*//*Label 30561*/ GIMT_Encode4(2264061), // Rule ID 293 //
     /* 2264033 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2264036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2264039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2264042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264050 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2264054 */   // (mulhu:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULHU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2264054 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULHU),
     /* 2264059 */   GIR_RootConstrainSelectedInstOperands,
     /* 2264060 */   // GIR_Coverage, 293,
     /* 2264060 */   GIR_Done,
     /* 2264061 */ // Label 30561: @2264061
     /* 2264061 */ GIM_Reject,
     /* 2264062 */ // Label 30537: @2264062
     /* 2264062 */ GIM_Try, /*On fail goto*//*Label 30562*/ GIMT_Encode4(2264176),
     /* 2264067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2264070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2264073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264081 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264085 */   GIM_Try, /*On fail goto*//*Label 30563*/ GIMT_Encode4(2264130), // Rule ID 50890 //
     /* 2264090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264093 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2264110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264129 */     // GIR_Coverage, 50890,
     /* 2264129 */     GIR_EraseRootFromParent_Done,
     /* 2264130 */   // Label 30563: @2264130
     /* 2264130 */   GIM_Try, /*On fail goto*//*Label 30564*/ GIMT_Encode4(2264175), // Rule ID 50891 //
     /* 2264135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264138 */     // (mulhu:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2264141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264150 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF8),
     /* 2264155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264160 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264162 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264174 */     // GIR_Coverage, 50891,
     /* 2264174 */     GIR_EraseRootFromParent_Done,
     /* 2264175 */   // Label 30564: @2264175
     /* 2264175 */   GIM_Reject,
     /* 2264176 */ // Label 30562: @2264176
     /* 2264176 */ GIM_Reject,
     /* 2264177 */ // Label 30538: @2264177
     /* 2264177 */ GIM_Try, /*On fail goto*//*Label 30565*/ GIMT_Encode4(2264291),
     /* 2264182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2264185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2264188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264196 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264200 */   GIM_Try, /*On fail goto*//*Label 30566*/ GIMT_Encode4(2264245), // Rule ID 50902 //
     /* 2264205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264208 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2264225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264244 */     // GIR_Coverage, 50902,
     /* 2264244 */     GIR_EraseRootFromParent_Done,
     /* 2264245 */   // Label 30566: @2264245
     /* 2264245 */   GIM_Try, /*On fail goto*//*Label 30567*/ GIMT_Encode4(2264290), // Rule ID 50903 //
     /* 2264250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264253 */     // (mulhu:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2264256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2264270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264272 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264288 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264289 */     // GIR_Coverage, 50903,
     /* 2264289 */     GIR_EraseRootFromParent_Done,
     /* 2264290 */   // Label 30567: @2264290
     /* 2264290 */   GIM_Reject,
     /* 2264291 */ // Label 30565: @2264291
     /* 2264291 */ GIM_Reject,
     /* 2264292 */ // Label 30539: @2264292
     /* 2264292 */ GIM_Try, /*On fail goto*//*Label 30568*/ GIMT_Encode4(2264406),
     /* 2264297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2264300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2264303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264315 */   GIM_Try, /*On fail goto*//*Label 30569*/ GIMT_Encode4(2264360), // Rule ID 50910 //
     /* 2264320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264323 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2264340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264359 */     // GIR_Coverage, 50910,
     /* 2264359 */     GIR_EraseRootFromParent_Done,
     /* 2264360 */   // Label 30569: @2264360
     /* 2264360 */   GIM_Try, /*On fail goto*//*Label 30570*/ GIMT_Encode4(2264405), // Rule ID 50911 //
     /* 2264365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264368 */     // (mulhu:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2264371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2264385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264387 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264390 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264404 */     // GIR_Coverage, 50911,
     /* 2264404 */     GIR_EraseRootFromParent_Done,
     /* 2264405 */   // Label 30570: @2264405
     /* 2264405 */   GIM_Reject,
     /* 2264406 */ // Label 30568: @2264406
     /* 2264406 */ GIM_Reject,
     /* 2264407 */ // Label 30540: @2264407
     /* 2264407 */ GIM_Try, /*On fail goto*//*Label 30571*/ GIMT_Encode4(2264521),
     /* 2264412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2264415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2264418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264430 */   GIM_Try, /*On fail goto*//*Label 30572*/ GIMT_Encode4(2264475), // Rule ID 50978 //
     /* 2264435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2264438 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2264455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264474 */     // GIR_Coverage, 50978,
     /* 2264474 */     GIR_EraseRootFromParent_Done,
     /* 2264475 */   // Label 30572: @2264475
     /* 2264475 */   GIM_Try, /*On fail goto*//*Label 30573*/ GIMT_Encode4(2264520), // Rule ID 50979 //
     /* 2264480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2264483 */     // (mulhu:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2264486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2264500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264502 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264507 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264519 */     // GIR_Coverage, 50979,
     /* 2264519 */     GIR_EraseRootFromParent_Done,
     /* 2264520 */   // Label 30573: @2264520
     /* 2264520 */   GIM_Reject,
     /* 2264521 */ // Label 30571: @2264521
     /* 2264521 */ GIM_Reject,
     /* 2264522 */ // Label 30541: @2264522
     /* 2264522 */ GIM_Try, /*On fail goto*//*Label 30574*/ GIMT_Encode4(2264636),
     /* 2264527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2264530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2264533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264545 */   GIM_Try, /*On fail goto*//*Label 30575*/ GIMT_Encode4(2264590), // Rule ID 50894 //
     /* 2264550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264553 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2264556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2264570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264589 */     // GIR_Coverage, 50894,
     /* 2264589 */     GIR_EraseRootFromParent_Done,
     /* 2264590 */   // Label 30575: @2264590
     /* 2264590 */   GIM_Try, /*On fail goto*//*Label 30576*/ GIMT_Encode4(2264635), // Rule ID 50895 //
     /* 2264595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264598 */     // (mulhu:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264598 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2264601 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264605 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF4),
     /* 2264615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264620 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264634 */     // GIR_Coverage, 50895,
     /* 2264634 */     GIR_EraseRootFromParent_Done,
     /* 2264635 */   // Label 30576: @2264635
     /* 2264635 */   GIM_Reject,
     /* 2264636 */ // Label 30574: @2264636
     /* 2264636 */ GIM_Reject,
     /* 2264637 */ // Label 30542: @2264637
     /* 2264637 */ GIM_Try, /*On fail goto*//*Label 30577*/ GIMT_Encode4(2264751),
     /* 2264642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2264645 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2264648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264656 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264660 */   GIM_Try, /*On fail goto*//*Label 30578*/ GIMT_Encode4(2264705), // Rule ID 50906 //
     /* 2264665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264668 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2264671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2264685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264704 */     // GIR_Coverage, 50906,
     /* 2264704 */     GIR_EraseRootFromParent_Done,
     /* 2264705 */   // Label 30578: @2264705
     /* 2264705 */   GIM_Try, /*On fail goto*//*Label 30579*/ GIMT_Encode4(2264750), // Rule ID 50907 //
     /* 2264710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264713 */     // (mulhu:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2264716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2264730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2264745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264748 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264749 */     // GIR_Coverage, 50907,
     /* 2264749 */     GIR_EraseRootFromParent_Done,
     /* 2264750 */   // Label 30579: @2264750
     /* 2264750 */   GIM_Reject,
     /* 2264751 */ // Label 30577: @2264751
     /* 2264751 */ GIM_Reject,
     /* 2264752 */ // Label 30543: @2264752
     /* 2264752 */ GIM_Try, /*On fail goto*//*Label 30580*/ GIMT_Encode4(2264866),
     /* 2264757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2264760 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2264763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264771 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264775 */   GIM_Try, /*On fail goto*//*Label 30581*/ GIMT_Encode4(2264820), // Rule ID 50922 //
     /* 2264780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2264783 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2264786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2264800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264807 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264819 */     // GIR_Coverage, 50922,
     /* 2264819 */     GIR_EraseRootFromParent_Done,
     /* 2264820 */   // Label 30581: @2264820
     /* 2264820 */   GIM_Try, /*On fail goto*//*Label 30582*/ GIMT_Encode4(2264865), // Rule ID 50923 //
     /* 2264825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2264828 */     // (mulhu:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2264831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2264845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2264860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264863 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264864 */     // GIR_Coverage, 50923,
     /* 2264864 */     GIR_EraseRootFromParent_Done,
     /* 2264865 */   // Label 30582: @2264865
     /* 2264865 */   GIM_Reject,
     /* 2264866 */ // Label 30580: @2264866
     /* 2264866 */ GIM_Reject,
     /* 2264867 */ // Label 30544: @2264867
     /* 2264867 */ GIM_Try, /*On fail goto*//*Label 30583*/ GIMT_Encode4(2264981),
     /* 2264872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2264875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2264878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2264890 */   GIM_Try, /*On fail goto*//*Label 30584*/ GIMT_Encode4(2264935), // Rule ID 50982 //
     /* 2264895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2264898 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2264898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2264901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2264915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264917 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264934 */     // GIR_Coverage, 50982,
     /* 2264934 */     GIR_EraseRootFromParent_Done,
     /* 2264935 */   // Label 30584: @2264935
     /* 2264935 */   GIM_Try, /*On fail goto*//*Label 30585*/ GIMT_Encode4(2264980), // Rule ID 50983 //
     /* 2264940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2264943 */     // (mulhu:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2264943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2264946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2264950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2264955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2264957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2264960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2264962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2264965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2264967 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2264969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2264972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2264975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2264978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2264979 */     // GIR_Coverage, 50983,
     /* 2264979 */     GIR_EraseRootFromParent_Done,
     /* 2264980 */   // Label 30585: @2264980
     /* 2264980 */   GIM_Reject,
     /* 2264981 */ // Label 30583: @2264981
     /* 2264981 */ GIM_Reject,
     /* 2264982 */ // Label 30545: @2264982
     /* 2264982 */ GIM_Try, /*On fail goto*//*Label 30586*/ GIMT_Encode4(2265096),
     /* 2264987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2264990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2264993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2264997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265005 */   GIM_Try, /*On fail goto*//*Label 30587*/ GIMT_Encode4(2265050), // Rule ID 50898 //
     /* 2265010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265013 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265025 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2265030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265032 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265049 */     // GIR_Coverage, 50898,
     /* 2265049 */     GIR_EraseRootFromParent_Done,
     /* 2265050 */   // Label 30587: @2265050
     /* 2265050 */   GIM_Try, /*On fail goto*//*Label 30588*/ GIMT_Encode4(2265095), // Rule ID 50899 //
     /* 2265055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265058 */     // (mulhu:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULHU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2265061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_MF2),
     /* 2265075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265094 */     // GIR_Coverage, 50899,
     /* 2265094 */     GIR_EraseRootFromParent_Done,
     /* 2265095 */   // Label 30588: @2265095
     /* 2265095 */   GIM_Reject,
     /* 2265096 */ // Label 30586: @2265096
     /* 2265096 */ GIM_Reject,
     /* 2265097 */ // Label 30546: @2265097
     /* 2265097 */ GIM_Try, /*On fail goto*//*Label 30589*/ GIMT_Encode4(2265211),
     /* 2265102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2265105 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2265108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265116 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265120 */   GIM_Try, /*On fail goto*//*Label 30590*/ GIMT_Encode4(2265165), // Rule ID 50918 //
     /* 2265125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265128 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2265145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265164 */     // GIR_Coverage, 50918,
     /* 2265164 */     GIR_EraseRootFromParent_Done,
     /* 2265165 */   // Label 30590: @2265165
     /* 2265165 */   GIM_Try, /*On fail goto*//*Label 30591*/ GIMT_Encode4(2265210), // Rule ID 50919 //
     /* 2265170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265173 */     // (mulhu:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2265176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2265190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265209 */     // GIR_Coverage, 50919,
     /* 2265209 */     GIR_EraseRootFromParent_Done,
     /* 2265210 */   // Label 30591: @2265210
     /* 2265210 */   GIM_Reject,
     /* 2265211 */ // Label 30589: @2265211
     /* 2265211 */ GIM_Reject,
     /* 2265212 */ // Label 30547: @2265212
     /* 2265212 */ GIM_Try, /*On fail goto*//*Label 30592*/ GIMT_Encode4(2265326),
     /* 2265217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2265220 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2265223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265231 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265235 */   GIM_Try, /*On fail goto*//*Label 30593*/ GIMT_Encode4(2265280), // Rule ID 50950 //
     /* 2265240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265243 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2265246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265265 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265279 */     // GIR_Coverage, 50950,
     /* 2265279 */     GIR_EraseRootFromParent_Done,
     /* 2265280 */   // Label 30593: @2265280
     /* 2265280 */   GIM_Try, /*On fail goto*//*Label 30594*/ GIMT_Encode4(2265325), // Rule ID 50951 //
     /* 2265285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265288 */     // (mulhu:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2265291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265312 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265324 */     // GIR_Coverage, 50951,
     /* 2265324 */     GIR_EraseRootFromParent_Done,
     /* 2265325 */   // Label 30594: @2265325
     /* 2265325 */   GIM_Reject,
     /* 2265326 */ // Label 30592: @2265326
     /* 2265326 */ GIM_Reject,
     /* 2265327 */ // Label 30548: @2265327
     /* 2265327 */ GIM_Try, /*On fail goto*//*Label 30595*/ GIMT_Encode4(2265441),
     /* 2265332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2265335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2265338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265346 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265350 */   GIM_Try, /*On fail goto*//*Label 30596*/ GIMT_Encode4(2265395), // Rule ID 50986 //
     /* 2265355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2265358 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2265361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2265375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265382 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265394 */     // GIR_Coverage, 50986,
     /* 2265394 */     GIR_EraseRootFromParent_Done,
     /* 2265395 */   // Label 30596: @2265395
     /* 2265395 */   GIM_Try, /*On fail goto*//*Label 30597*/ GIMT_Encode4(2265440), // Rule ID 50987 //
     /* 2265400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2265403 */     // (mulhu:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2265406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2265420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265422 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265425 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265427 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265439 */     // GIR_Coverage, 50987,
     /* 2265439 */     GIR_EraseRootFromParent_Done,
     /* 2265440 */   // Label 30597: @2265440
     /* 2265440 */   GIM_Reject,
     /* 2265441 */ // Label 30595: @2265441
     /* 2265441 */ GIM_Reject,
     /* 2265442 */ // Label 30549: @2265442
     /* 2265442 */ GIM_Try, /*On fail goto*//*Label 30598*/ GIMT_Encode4(2265556),
     /* 2265447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2265450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2265453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2265465 */   GIM_Try, /*On fail goto*//*Label 30599*/ GIMT_Encode4(2265510), // Rule ID 50914 //
     /* 2265470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265473 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2265476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2265490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265495 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265509 */     // GIR_Coverage, 50914,
     /* 2265509 */     GIR_EraseRootFromParent_Done,
     /* 2265510 */   // Label 30599: @2265510
     /* 2265510 */   GIM_Try, /*On fail goto*//*Label 30600*/ GIMT_Encode4(2265555), // Rule ID 50915 //
     /* 2265515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265518 */     // (mulhu:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULHU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2265521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M1),
     /* 2265535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265554 */     // GIR_Coverage, 50915,
     /* 2265554 */     GIR_EraseRootFromParent_Done,
     /* 2265555 */   // Label 30600: @2265555
     /* 2265555 */   GIM_Reject,
     /* 2265556 */ // Label 30598: @2265556
     /* 2265556 */ GIM_Reject,
     /* 2265557 */ // Label 30550: @2265557
     /* 2265557 */ GIM_Try, /*On fail goto*//*Label 30601*/ GIMT_Encode4(2265671),
     /* 2265562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2265565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2265568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265580 */   GIM_Try, /*On fail goto*//*Label 30602*/ GIMT_Encode4(2265625), // Rule ID 50938 //
     /* 2265585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265588 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2265591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265624 */     // GIR_Coverage, 50938,
     /* 2265624 */     GIR_EraseRootFromParent_Done,
     /* 2265625 */   // Label 30602: @2265625
     /* 2265625 */   GIM_Try, /*On fail goto*//*Label 30603*/ GIMT_Encode4(2265670), // Rule ID 50939 //
     /* 2265630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265633 */     // (mulhu:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2265636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2265665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265669 */     // GIR_Coverage, 50939,
     /* 2265669 */     GIR_EraseRootFromParent_Done,
     /* 2265670 */   // Label 30603: @2265670
     /* 2265670 */   GIM_Reject,
     /* 2265671 */ // Label 30601: @2265671
     /* 2265671 */ GIM_Reject,
     /* 2265672 */ // Label 30551: @2265672
     /* 2265672 */ GIM_Try, /*On fail goto*//*Label 30604*/ GIMT_Encode4(2265786),
     /* 2265677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2265680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2265683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2265695 */   GIM_Try, /*On fail goto*//*Label 30605*/ GIMT_Encode4(2265740), // Rule ID 50954 //
     /* 2265700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265703 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2265706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2265720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265739 */     // GIR_Coverage, 50954,
     /* 2265739 */     GIR_EraseRootFromParent_Done,
     /* 2265740 */   // Label 30605: @2265740
     /* 2265740 */   GIM_Try, /*On fail goto*//*Label 30606*/ GIMT_Encode4(2265785), // Rule ID 50955 //
     /* 2265745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265748 */     // (mulhu:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2265751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2265765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2265780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265784 */     // GIR_Coverage, 50955,
     /* 2265784 */     GIR_EraseRootFromParent_Done,
     /* 2265785 */   // Label 30606: @2265785
     /* 2265785 */   GIM_Reject,
     /* 2265786 */ // Label 30604: @2265786
     /* 2265786 */ GIM_Reject,
     /* 2265787 */ // Label 30552: @2265787
     /* 2265787 */ GIM_Try, /*On fail goto*//*Label 30607*/ GIMT_Encode4(2265901),
     /* 2265792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2265795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2265798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265806 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2265810 */   GIM_Try, /*On fail goto*//*Label 30608*/ GIMT_Encode4(2265855), // Rule ID 50990 //
     /* 2265815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2265818 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2265821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2265835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265854 */     // GIR_Coverage, 50990,
     /* 2265854 */     GIR_EraseRootFromParent_Done,
     /* 2265855 */   // Label 30608: @2265855
     /* 2265855 */   GIM_Try, /*On fail goto*//*Label 30609*/ GIMT_Encode4(2265900), // Rule ID 50991 //
     /* 2265860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2265863 */     // (mulhu:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2265866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2265880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2265895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265899 */     // GIR_Coverage, 50991,
     /* 2265899 */     GIR_EraseRootFromParent_Done,
     /* 2265900 */   // Label 30609: @2265900
     /* 2265900 */   GIM_Reject,
     /* 2265901 */ // Label 30607: @2265901
     /* 2265901 */ GIM_Reject,
     /* 2265902 */ // Label 30553: @2265902
     /* 2265902 */ GIM_Try, /*On fail goto*//*Label 30610*/ GIMT_Encode4(2266016),
     /* 2265907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2265910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2265913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2265925 */   GIM_Try, /*On fail goto*//*Label 30611*/ GIMT_Encode4(2265970), // Rule ID 50926 //
     /* 2265930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2265933 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2265933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2265936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2265955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2265957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2265959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2265962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2265968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265969 */     // GIR_Coverage, 50926,
     /* 2265969 */     GIR_EraseRootFromParent_Done,
     /* 2265970 */   // Label 30611: @2265970
     /* 2265970 */   GIM_Try, /*On fail goto*//*Label 30612*/ GIMT_Encode4(2266015), // Rule ID 50927 //
     /* 2265975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2265978 */     // (mulhu:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULHU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2265978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2265981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2265985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2265990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2265992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M2),
     /* 2265995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2265997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266014 */     // GIR_Coverage, 50927,
     /* 2266014 */     GIR_EraseRootFromParent_Done,
     /* 2266015 */   // Label 30612: @2266015
     /* 2266015 */   GIM_Reject,
     /* 2266016 */ // Label 30610: @2266016
     /* 2266016 */ GIM_Reject,
     /* 2266017 */ // Label 30554: @2266017
     /* 2266017 */ GIM_Try, /*On fail goto*//*Label 30613*/ GIMT_Encode4(2266131),
     /* 2266022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2266025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2266028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266040 */   GIM_Try, /*On fail goto*//*Label 30614*/ GIMT_Encode4(2266085), // Rule ID 50942 //
     /* 2266045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266048 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2266051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2266065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266084 */     // GIR_Coverage, 50942,
     /* 2266084 */     GIR_EraseRootFromParent_Done,
     /* 2266085 */   // Label 30614: @2266085
     /* 2266085 */   GIM_Try, /*On fail goto*//*Label 30615*/ GIMT_Encode4(2266130), // Rule ID 50943 //
     /* 2266090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266093 */     // (mulhu:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2266096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2266110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266112 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266129 */     // GIR_Coverage, 50943,
     /* 2266129 */     GIR_EraseRootFromParent_Done,
     /* 2266130 */   // Label 30615: @2266130
     /* 2266130 */   GIM_Reject,
     /* 2266131 */ // Label 30613: @2266131
     /* 2266131 */ GIM_Reject,
     /* 2266132 */ // Label 30555: @2266132
     /* 2266132 */ GIM_Try, /*On fail goto*//*Label 30616*/ GIMT_Encode4(2266246),
     /* 2266137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2266140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2266143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266151 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266155 */   GIM_Try, /*On fail goto*//*Label 30617*/ GIMT_Encode4(2266200), // Rule ID 50958 //
     /* 2266160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266163 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2266166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266199 */     // GIR_Coverage, 50958,
     /* 2266199 */     GIR_EraseRootFromParent_Done,
     /* 2266200 */   // Label 30617: @2266200
     /* 2266200 */   GIM_Try, /*On fail goto*//*Label 30618*/ GIMT_Encode4(2266245), // Rule ID 50959 //
     /* 2266205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266208 */     // (mulhu:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2266211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2266240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266244 */     // GIR_Coverage, 50959,
     /* 2266244 */     GIR_EraseRootFromParent_Done,
     /* 2266245 */   // Label 30618: @2266245
     /* 2266245 */   GIM_Reject,
     /* 2266246 */ // Label 30616: @2266246
     /* 2266246 */ GIM_Reject,
     /* 2266247 */ // Label 30556: @2266247
     /* 2266247 */ GIM_Try, /*On fail goto*//*Label 30619*/ GIMT_Encode4(2266361),
     /* 2266252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2266255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2266258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266266 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2266270 */   GIM_Try, /*On fail goto*//*Label 30620*/ GIMT_Encode4(2266315), // Rule ID 50930 //
     /* 2266275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266278 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2266281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2266295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266314 */     // GIR_Coverage, 50930,
     /* 2266314 */     GIR_EraseRootFromParent_Done,
     /* 2266315 */   // Label 30620: @2266315
     /* 2266315 */   GIM_Try, /*On fail goto*//*Label 30621*/ GIMT_Encode4(2266360), // Rule ID 50931 //
     /* 2266320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266323 */     // (mulhu:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULHU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2266326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M4),
     /* 2266340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266347 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266359 */     // GIR_Coverage, 50931,
     /* 2266359 */     GIR_EraseRootFromParent_Done,
     /* 2266360 */   // Label 30621: @2266360
     /* 2266360 */   GIM_Reject,
     /* 2266361 */ // Label 30619: @2266361
     /* 2266361 */ GIM_Reject,
     /* 2266362 */ // Label 30557: @2266362
     /* 2266362 */ GIM_Try, /*On fail goto*//*Label 30622*/ GIMT_Encode4(2266476),
     /* 2266367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2266370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2266373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266381 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266385 */   GIM_Try, /*On fail goto*//*Label 30623*/ GIMT_Encode4(2266430), // Rule ID 50946 //
     /* 2266390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266393 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2266396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266429 */     // GIR_Coverage, 50946,
     /* 2266429 */     GIR_EraseRootFromParent_Done,
     /* 2266430 */   // Label 30623: @2266430
     /* 2266430 */   GIM_Try, /*On fail goto*//*Label 30624*/ GIMT_Encode4(2266475), // Rule ID 50947 //
     /* 2266435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266438 */     // (mulhu:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2266441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266474 */     // GIR_Coverage, 50947,
     /* 2266474 */     GIR_EraseRootFromParent_Done,
     /* 2266475 */   // Label 30624: @2266475
     /* 2266475 */   GIM_Reject,
     /* 2266476 */ // Label 30622: @2266476
     /* 2266476 */ GIM_Reject,
     /* 2266477 */ // Label 30558: @2266477
     /* 2266477 */ GIM_Try, /*On fail goto*//*Label 30625*/ GIMT_Encode4(2266591),
     /* 2266482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2266485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2266488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266492 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266496 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2266500 */   GIM_Try, /*On fail goto*//*Label 30626*/ GIMT_Encode4(2266545), // Rule ID 50934 //
     /* 2266505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266508 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2266511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266527 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266530 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266532 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266544 */     // GIR_Coverage, 50934,
     /* 2266544 */     GIR_EraseRootFromParent_Done,
     /* 2266545 */   // Label 30626: @2266545
     /* 2266545 */   GIM_Try, /*On fail goto*//*Label 30627*/ GIMT_Encode4(2266590), // Rule ID 50935 //
     /* 2266550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266553 */     // (mulhu:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULHU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2266556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULHU_VV_M8),
     /* 2266570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266589 */     // GIR_Coverage, 50935,
     /* 2266589 */     GIR_EraseRootFromParent_Done,
     /* 2266590 */   // Label 30627: @2266590
     /* 2266590 */   GIM_Reject,
     /* 2266591 */ // Label 30625: @2266591
     /* 2266591 */ GIM_Reject,
     /* 2266592 */ // Label 30559: @2266592
     /* 2266592 */ GIM_Reject,
     /* 2266593 */ // Label 52: @2266593
     /* 2266593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30652*/ GIMT_Encode4(2269326),
     /* 2266604 */ /*GILLT_s32*//*Label 30628*/ GIMT_Encode4(2266728),
     /* 2266608 */ /*GILLT_s64*//*Label 30629*/ GIMT_Encode4(2266762), GIMT_Encode4(0),
     /* 2266616 */ /*GILLT_nxv1s8*//*Label 30630*/ GIMT_Encode4(2266796),
     /* 2266620 */ /*GILLT_nxv1s16*//*Label 30631*/ GIMT_Encode4(2266911),
     /* 2266624 */ /*GILLT_nxv1s32*//*Label 30632*/ GIMT_Encode4(2267026),
     /* 2266628 */ /*GILLT_nxv1s64*//*Label 30633*/ GIMT_Encode4(2267141), GIMT_Encode4(0),
     /* 2266636 */ /*GILLT_nxv2s8*//*Label 30634*/ GIMT_Encode4(2267256),
     /* 2266640 */ /*GILLT_nxv2s16*//*Label 30635*/ GIMT_Encode4(2267371),
     /* 2266644 */ /*GILLT_nxv2s32*//*Label 30636*/ GIMT_Encode4(2267486),
     /* 2266648 */ /*GILLT_nxv2s64*//*Label 30637*/ GIMT_Encode4(2267601), GIMT_Encode4(0),
     /* 2266656 */ /*GILLT_nxv4s8*//*Label 30638*/ GIMT_Encode4(2267716),
     /* 2266660 */ /*GILLT_nxv4s16*//*Label 30639*/ GIMT_Encode4(2267831),
     /* 2266664 */ /*GILLT_nxv4s32*//*Label 30640*/ GIMT_Encode4(2267946),
     /* 2266668 */ /*GILLT_nxv4s64*//*Label 30641*/ GIMT_Encode4(2268061), GIMT_Encode4(0),
     /* 2266676 */ /*GILLT_nxv8s8*//*Label 30642*/ GIMT_Encode4(2268176),
     /* 2266680 */ /*GILLT_nxv8s16*//*Label 30643*/ GIMT_Encode4(2268291),
     /* 2266684 */ /*GILLT_nxv8s32*//*Label 30644*/ GIMT_Encode4(2268406),
     /* 2266688 */ /*GILLT_nxv8s64*//*Label 30645*/ GIMT_Encode4(2268521), GIMT_Encode4(0),
     /* 2266696 */ /*GILLT_nxv16s8*//*Label 30646*/ GIMT_Encode4(2268636),
     /* 2266700 */ /*GILLT_nxv16s16*//*Label 30647*/ GIMT_Encode4(2268751),
     /* 2266704 */ /*GILLT_nxv16s32*//*Label 30648*/ GIMT_Encode4(2268866), GIMT_Encode4(0),
     /* 2266712 */ /*GILLT_nxv32s8*//*Label 30649*/ GIMT_Encode4(2268981),
     /* 2266716 */ /*GILLT_nxv32s16*//*Label 30650*/ GIMT_Encode4(2269096), GIMT_Encode4(0),
     /* 2266724 */ /*GILLT_nxv64s8*//*Label 30651*/ GIMT_Encode4(2269211),
     /* 2266728 */ // Label 30628: @2266728
     /* 2266728 */ GIM_Try, /*On fail goto*//*Label 30653*/ GIMT_Encode4(2266761), // Rule ID 292 //
     /* 2266733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode1),
     /* 2266736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2266739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2266742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266754 */   // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MULH:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2266754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2266759 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266760 */   // GIR_Coverage, 292,
     /* 2266760 */   GIR_Done,
     /* 2266761 */ // Label 30653: @2266761
     /* 2266761 */ GIM_Reject,
     /* 2266762 */ // Label 30629: @2266762
     /* 2266762 */ GIM_Try, /*On fail goto*//*Label 30654*/ GIMT_Encode4(2266795), // Rule ID 291 //
     /* 2266767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZmmul_HwMode0),
     /* 2266770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2266773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2266776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266784 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2266788 */   // (mulhs:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MULH:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2266788 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MULH),
     /* 2266793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2266794 */   // GIR_Coverage, 291,
     /* 2266794 */   GIR_Done,
     /* 2266795 */ // Label 30654: @2266795
     /* 2266795 */ GIM_Reject,
     /* 2266796 */ // Label 30630: @2266796
     /* 2266796 */ GIM_Try, /*On fail goto*//*Label 30655*/ GIMT_Encode4(2266910),
     /* 2266801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2266804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2266807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266819 */   GIM_Try, /*On fail goto*//*Label 30656*/ GIMT_Encode4(2266864), // Rule ID 50818 //
     /* 2266824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266827 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2266830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2266844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266863 */     // GIR_Coverage, 50818,
     /* 2266863 */     GIR_EraseRootFromParent_Done,
     /* 2266864 */   // Label 30656: @2266864
     /* 2266864 */   GIM_Try, /*On fail goto*//*Label 30657*/ GIMT_Encode4(2266909), // Rule ID 50819 //
     /* 2266869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266872 */     // (mulhs:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMULH_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2266875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF8),
     /* 2266889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266908 */     // GIR_Coverage, 50819,
     /* 2266908 */     GIR_EraseRootFromParent_Done,
     /* 2266909 */   // Label 30657: @2266909
     /* 2266909 */   GIM_Reject,
     /* 2266910 */ // Label 30655: @2266910
     /* 2266910 */ GIM_Reject,
     /* 2266911 */ // Label 30631: @2266911
     /* 2266911 */ GIM_Try, /*On fail goto*//*Label 30658*/ GIMT_Encode4(2267025),
     /* 2266916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2266919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2266922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2266934 */   GIM_Try, /*On fail goto*//*Label 30659*/ GIMT_Encode4(2266979), // Rule ID 50830 //
     /* 2266939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2266942 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2266942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2266945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2266956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2266959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2266961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2266964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2266966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2266968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2266971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2266974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2266977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2266978 */     // GIR_Coverage, 50830,
     /* 2266978 */     GIR_EraseRootFromParent_Done,
     /* 2266979 */   // Label 30659: @2266979
     /* 2266979 */   GIM_Try, /*On fail goto*//*Label 30660*/ GIMT_Encode4(2267024), // Rule ID 50831 //
     /* 2266984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2266987 */     // (mulhs:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2266987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2266990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2266994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2266999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2267004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267023 */     // GIR_Coverage, 50831,
     /* 2267023 */     GIR_EraseRootFromParent_Done,
     /* 2267024 */   // Label 30660: @2267024
     /* 2267024 */   GIM_Reject,
     /* 2267025 */ // Label 30658: @2267025
     /* 2267025 */ GIM_Reject,
     /* 2267026 */ // Label 30632: @2267026
     /* 2267026 */ GIM_Try, /*On fail goto*//*Label 30661*/ GIMT_Encode4(2267140),
     /* 2267031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2267034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2267037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267049 */   GIM_Try, /*On fail goto*//*Label 30662*/ GIMT_Encode4(2267094), // Rule ID 50838 //
     /* 2267054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267057 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2267060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267093 */     // GIR_Coverage, 50838,
     /* 2267093 */     GIR_EraseRootFromParent_Done,
     /* 2267094 */   // Label 30662: @2267094
     /* 2267094 */   GIM_Try, /*On fail goto*//*Label 30663*/ GIMT_Encode4(2267139), // Rule ID 50839 //
     /* 2267099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267102 */     // (mulhs:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2267105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267138 */     // GIR_Coverage, 50839,
     /* 2267138 */     GIR_EraseRootFromParent_Done,
     /* 2267139 */   // Label 30663: @2267139
     /* 2267139 */   GIM_Reject,
     /* 2267140 */ // Label 30661: @2267140
     /* 2267140 */ GIM_Reject,
     /* 2267141 */ // Label 30633: @2267141
     /* 2267141 */ GIM_Try, /*On fail goto*//*Label 30664*/ GIMT_Encode4(2267255),
     /* 2267146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2267149 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2267152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267160 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267164 */   GIM_Try, /*On fail goto*//*Label 30665*/ GIMT_Encode4(2267209), // Rule ID 50962 //
     /* 2267169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2267172 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2267175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267208 */     // GIR_Coverage, 50962,
     /* 2267208 */     GIR_EraseRootFromParent_Done,
     /* 2267209 */   // Label 30665: @2267209
     /* 2267209 */   GIM_Try, /*On fail goto*//*Label 30666*/ GIMT_Encode4(2267254), // Rule ID 50963 //
     /* 2267214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2267217 */     // (mulhs:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2267220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267253 */     // GIR_Coverage, 50963,
     /* 2267253 */     GIR_EraseRootFromParent_Done,
     /* 2267254 */   // Label 30666: @2267254
     /* 2267254 */   GIM_Reject,
     /* 2267255 */ // Label 30664: @2267255
     /* 2267255 */ GIM_Reject,
     /* 2267256 */ // Label 30634: @2267256
     /* 2267256 */ GIM_Try, /*On fail goto*//*Label 30667*/ GIMT_Encode4(2267370),
     /* 2267261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2267264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2267267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267279 */   GIM_Try, /*On fail goto*//*Label 30668*/ GIMT_Encode4(2267324), // Rule ID 50822 //
     /* 2267284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267287 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2267290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2267304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267323 */     // GIR_Coverage, 50822,
     /* 2267323 */     GIR_EraseRootFromParent_Done,
     /* 2267324 */   // Label 30668: @2267324
     /* 2267324 */   GIM_Try, /*On fail goto*//*Label 30669*/ GIMT_Encode4(2267369), // Rule ID 50823 //
     /* 2267329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267332 */     // (mulhs:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMULH_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2267335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF4),
     /* 2267349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267368 */     // GIR_Coverage, 50823,
     /* 2267368 */     GIR_EraseRootFromParent_Done,
     /* 2267369 */   // Label 30669: @2267369
     /* 2267369 */   GIM_Reject,
     /* 2267370 */ // Label 30667: @2267370
     /* 2267370 */ GIM_Reject,
     /* 2267371 */ // Label 30635: @2267371
     /* 2267371 */ GIM_Try, /*On fail goto*//*Label 30670*/ GIMT_Encode4(2267485),
     /* 2267376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2267379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2267382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267390 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267394 */   GIM_Try, /*On fail goto*//*Label 30671*/ GIMT_Encode4(2267439), // Rule ID 50834 //
     /* 2267399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267402 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2267405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267438 */     // GIR_Coverage, 50834,
     /* 2267438 */     GIR_EraseRootFromParent_Done,
     /* 2267439 */   // Label 30671: @2267439
     /* 2267439 */   GIM_Try, /*On fail goto*//*Label 30672*/ GIMT_Encode4(2267484), // Rule ID 50835 //
     /* 2267444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267447 */     // (mulhs:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2267450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267483 */     // GIR_Coverage, 50835,
     /* 2267483 */     GIR_EraseRootFromParent_Done,
     /* 2267484 */   // Label 30672: @2267484
     /* 2267484 */   GIM_Reject,
     /* 2267485 */ // Label 30670: @2267485
     /* 2267485 */ GIM_Reject,
     /* 2267486 */ // Label 30636: @2267486
     /* 2267486 */ GIM_Try, /*On fail goto*//*Label 30673*/ GIMT_Encode4(2267600),
     /* 2267491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2267494 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2267497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267505 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267509 */   GIM_Try, /*On fail goto*//*Label 30674*/ GIMT_Encode4(2267554), // Rule ID 50850 //
     /* 2267514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267517 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2267520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267553 */     // GIR_Coverage, 50850,
     /* 2267553 */     GIR_EraseRootFromParent_Done,
     /* 2267554 */   // Label 30674: @2267554
     /* 2267554 */   GIM_Try, /*On fail goto*//*Label 30675*/ GIMT_Encode4(2267599), // Rule ID 50851 //
     /* 2267559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267562 */     // (mulhs:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2267565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2267594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267598 */     // GIR_Coverage, 50851,
     /* 2267598 */     GIR_EraseRootFromParent_Done,
     /* 2267599 */   // Label 30675: @2267599
     /* 2267599 */   GIM_Reject,
     /* 2267600 */ // Label 30673: @2267600
     /* 2267600 */ GIM_Reject,
     /* 2267601 */ // Label 30637: @2267601
     /* 2267601 */ GIM_Try, /*On fail goto*//*Label 30676*/ GIMT_Encode4(2267715),
     /* 2267606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2267609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2267612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267624 */   GIM_Try, /*On fail goto*//*Label 30677*/ GIMT_Encode4(2267669), // Rule ID 50966 //
     /* 2267629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2267632 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2267635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2267649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267668 */     // GIR_Coverage, 50966,
     /* 2267668 */     GIR_EraseRootFromParent_Done,
     /* 2267669 */   // Label 30677: @2267669
     /* 2267669 */   GIM_Try, /*On fail goto*//*Label 30678*/ GIMT_Encode4(2267714), // Rule ID 50967 //
     /* 2267674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2267677 */     // (mulhs:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2267680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2267694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2267709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267713 */     // GIR_Coverage, 50967,
     /* 2267713 */     GIR_EraseRootFromParent_Done,
     /* 2267714 */   // Label 30678: @2267714
     /* 2267714 */   GIM_Reject,
     /* 2267715 */ // Label 30676: @2267715
     /* 2267715 */ GIM_Reject,
     /* 2267716 */ // Label 30638: @2267716
     /* 2267716 */ GIM_Try, /*On fail goto*//*Label 30679*/ GIMT_Encode4(2267830),
     /* 2267721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2267724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2267727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267739 */   GIM_Try, /*On fail goto*//*Label 30680*/ GIMT_Encode4(2267784), // Rule ID 50826 //
     /* 2267744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267747 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2267750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267759 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267783 */     // GIR_Coverage, 50826,
     /* 2267783 */     GIR_EraseRootFromParent_Done,
     /* 2267784 */   // Label 30680: @2267784
     /* 2267784 */   GIM_Try, /*On fail goto*//*Label 30681*/ GIMT_Encode4(2267829), // Rule ID 50827 //
     /* 2267789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267792 */     // (mulhs:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMULH_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2267795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_MF2),
     /* 2267809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267828 */     // GIR_Coverage, 50827,
     /* 2267828 */     GIR_EraseRootFromParent_Done,
     /* 2267829 */   // Label 30681: @2267829
     /* 2267829 */   GIM_Reject,
     /* 2267830 */ // Label 30679: @2267830
     /* 2267830 */ GIM_Reject,
     /* 2267831 */ // Label 30639: @2267831
     /* 2267831 */ GIM_Try, /*On fail goto*//*Label 30682*/ GIMT_Encode4(2267945),
     /* 2267836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2267839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2267842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267846 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267850 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2267854 */   GIM_Try, /*On fail goto*//*Label 30683*/ GIMT_Encode4(2267899), // Rule ID 50846 //
     /* 2267859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267862 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2267865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267898 */     // GIR_Coverage, 50846,
     /* 2267898 */     GIR_EraseRootFromParent_Done,
     /* 2267899 */   // Label 30683: @2267899
     /* 2267899 */   GIM_Try, /*On fail goto*//*Label 30684*/ GIMT_Encode4(2267944), // Rule ID 50847 //
     /* 2267904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2267907 */     // (mulhs:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2267907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2267910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2267924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2267931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2267933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2267936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2267939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2267942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2267943 */     // GIR_Coverage, 50847,
     /* 2267943 */     GIR_EraseRootFromParent_Done,
     /* 2267944 */   // Label 30684: @2267944
     /* 2267944 */   GIM_Reject,
     /* 2267945 */ // Label 30682: @2267945
     /* 2267945 */ GIM_Reject,
     /* 2267946 */ // Label 30640: @2267946
     /* 2267946 */ GIM_Try, /*On fail goto*//*Label 30685*/ GIMT_Encode4(2268060),
     /* 2267951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2267954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2267957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2267969 */   GIM_Try, /*On fail goto*//*Label 30686*/ GIMT_Encode4(2268014), // Rule ID 50878 //
     /* 2267974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2267977 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2267977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2267980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2267984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2267989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2267991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2267994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2267996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2267999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268001 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268013 */     // GIR_Coverage, 50878,
     /* 2268013 */     GIR_EraseRootFromParent_Done,
     /* 2268014 */   // Label 30686: @2268014
     /* 2268014 */   GIM_Try, /*On fail goto*//*Label 30687*/ GIMT_Encode4(2268059), // Rule ID 50879 //
     /* 2268019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268022 */     // (mulhs:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2268025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2268039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268058 */     // GIR_Coverage, 50879,
     /* 2268058 */     GIR_EraseRootFromParent_Done,
     /* 2268059 */   // Label 30687: @2268059
     /* 2268059 */   GIM_Reject,
     /* 2268060 */ // Label 30685: @2268060
     /* 2268060 */ GIM_Reject,
     /* 2268061 */ // Label 30641: @2268061
     /* 2268061 */ GIM_Try, /*On fail goto*//*Label 30688*/ GIMT_Encode4(2268175),
     /* 2268066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2268069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2268072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268084 */   GIM_Try, /*On fail goto*//*Label 30689*/ GIMT_Encode4(2268129), // Rule ID 50970 //
     /* 2268089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2268092 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2268095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268116 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268128 */     // GIR_Coverage, 50970,
     /* 2268128 */     GIR_EraseRootFromParent_Done,
     /* 2268129 */   // Label 30689: @2268129
     /* 2268129 */   GIM_Try, /*On fail goto*//*Label 30690*/ GIMT_Encode4(2268174), // Rule ID 50971 //
     /* 2268134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2268137 */     // (mulhs:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2268140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268172 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268173 */     // GIR_Coverage, 50971,
     /* 2268173 */     GIR_EraseRootFromParent_Done,
     /* 2268174 */   // Label 30690: @2268174
     /* 2268174 */   GIM_Reject,
     /* 2268175 */ // Label 30688: @2268175
     /* 2268175 */ GIM_Reject,
     /* 2268176 */ // Label 30642: @2268176
     /* 2268176 */ GIM_Try, /*On fail goto*//*Label 30691*/ GIMT_Encode4(2268290),
     /* 2268181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2268184 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2268187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2268199 */   GIM_Try, /*On fail goto*//*Label 30692*/ GIMT_Encode4(2268244), // Rule ID 50842 //
     /* 2268204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268207 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2268210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2268224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268243 */     // GIR_Coverage, 50842,
     /* 2268243 */     GIR_EraseRootFromParent_Done,
     /* 2268244 */   // Label 30692: @2268244
     /* 2268244 */   GIM_Try, /*On fail goto*//*Label 30693*/ GIMT_Encode4(2268289), // Rule ID 50843 //
     /* 2268249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268252 */     // (mulhs:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMULH_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2268255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M1),
     /* 2268269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268288 */     // GIR_Coverage, 50843,
     /* 2268288 */     GIR_EraseRootFromParent_Done,
     /* 2268289 */   // Label 30693: @2268289
     /* 2268289 */   GIM_Reject,
     /* 2268290 */ // Label 30691: @2268290
     /* 2268290 */ GIM_Reject,
     /* 2268291 */ // Label 30643: @2268291
     /* 2268291 */ GIM_Try, /*On fail goto*//*Label 30694*/ GIMT_Encode4(2268405),
     /* 2268296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2268299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2268302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268314 */   GIM_Try, /*On fail goto*//*Label 30695*/ GIMT_Encode4(2268359), // Rule ID 50866 //
     /* 2268319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268322 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2268325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2268339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268358 */     // GIR_Coverage, 50866,
     /* 2268358 */     GIR_EraseRootFromParent_Done,
     /* 2268359 */   // Label 30695: @2268359
     /* 2268359 */   GIM_Try, /*On fail goto*//*Label 30696*/ GIMT_Encode4(2268404), // Rule ID 50867 //
     /* 2268364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268367 */     // (mulhs:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2268370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2268384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268403 */     // GIR_Coverage, 50867,
     /* 2268403 */     GIR_EraseRootFromParent_Done,
     /* 2268404 */   // Label 30696: @2268404
     /* 2268404 */   GIM_Reject,
     /* 2268405 */ // Label 30694: @2268405
     /* 2268405 */ GIM_Reject,
     /* 2268406 */ // Label 30644: @2268406
     /* 2268406 */ GIM_Try, /*On fail goto*//*Label 30697*/ GIMT_Encode4(2268520),
     /* 2268411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2268414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2268417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268429 */   GIM_Try, /*On fail goto*//*Label 30698*/ GIMT_Encode4(2268474), // Rule ID 50882 //
     /* 2268434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268437 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2268440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268459 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268461 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268472 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268473 */     // GIR_Coverage, 50882,
     /* 2268473 */     GIR_EraseRootFromParent_Done,
     /* 2268474 */   // Label 30698: @2268474
     /* 2268474 */   GIM_Try, /*On fail goto*//*Label 30699*/ GIMT_Encode4(2268519), // Rule ID 50883 //
     /* 2268479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268482 */     // (mulhs:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268482 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2268485 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268489 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268518 */     // GIR_Coverage, 50883,
     /* 2268518 */     GIR_EraseRootFromParent_Done,
     /* 2268519 */   // Label 30699: @2268519
     /* 2268519 */   GIM_Reject,
     /* 2268520 */ // Label 30697: @2268520
     /* 2268520 */ GIM_Reject,
     /* 2268521 */ // Label 30645: @2268521
     /* 2268521 */ GIM_Try, /*On fail goto*//*Label 30700*/ GIMT_Encode4(2268635),
     /* 2268526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2268529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2268532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268544 */   GIM_Try, /*On fail goto*//*Label 30701*/ GIMT_Encode4(2268589), // Rule ID 50974 //
     /* 2268549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode0),
     /* 2268552 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2268555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2268569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268588 */     // GIR_Coverage, 50974,
     /* 2268588 */     GIR_EraseRootFromParent_Done,
     /* 2268589 */   // Label 30701: @2268589
     /* 2268589 */   GIM_Try, /*On fail goto*//*Label 30702*/ GIMT_Encode4(2268634), // Rule ID 50975 //
     /* 2268594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsFullMultiply_HwMode1),
     /* 2268597 */     // (mulhs:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268597 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2268600 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268604 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2268614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268619 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268621 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2268629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268633 */     // GIR_Coverage, 50975,
     /* 2268633 */     GIR_EraseRootFromParent_Done,
     /* 2268634 */   // Label 30702: @2268634
     /* 2268634 */   GIM_Reject,
     /* 2268635 */ // Label 30700: @2268635
     /* 2268635 */ GIM_Reject,
     /* 2268636 */ // Label 30646: @2268636
     /* 2268636 */ GIM_Try, /*On fail goto*//*Label 30703*/ GIMT_Encode4(2268750),
     /* 2268641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2268644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2268647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2268659 */   GIM_Try, /*On fail goto*//*Label 30704*/ GIMT_Encode4(2268704), // Rule ID 50854 //
     /* 2268664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268667 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2268670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2268684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268703 */     // GIR_Coverage, 50854,
     /* 2268703 */     GIR_EraseRootFromParent_Done,
     /* 2268704 */   // Label 30704: @2268704
     /* 2268704 */   GIM_Try, /*On fail goto*//*Label 30705*/ GIMT_Encode4(2268749), // Rule ID 50855 //
     /* 2268709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268712 */     // (mulhs:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMULH_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2268715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M2),
     /* 2268729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268747 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268748 */     // GIR_Coverage, 50855,
     /* 2268748 */     GIR_EraseRootFromParent_Done,
     /* 2268749 */   // Label 30705: @2268749
     /* 2268749 */   GIM_Reject,
     /* 2268750 */ // Label 30703: @2268750
     /* 2268750 */ GIM_Reject,
     /* 2268751 */ // Label 30647: @2268751
     /* 2268751 */ GIM_Try, /*On fail goto*//*Label 30706*/ GIMT_Encode4(2268865),
     /* 2268756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2268759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2268762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268770 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268774 */   GIM_Try, /*On fail goto*//*Label 30707*/ GIMT_Encode4(2268819), // Rule ID 50870 //
     /* 2268779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268782 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2268785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268794 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268818 */     // GIR_Coverage, 50870,
     /* 2268818 */     GIR_EraseRootFromParent_Done,
     /* 2268819 */   // Label 30707: @2268819
     /* 2268819 */   GIM_Try, /*On fail goto*//*Label 30708*/ GIMT_Encode4(2268864), // Rule ID 50871 //
     /* 2268824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268827 */     // (mulhs:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2268830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2268844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2268859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268863 */     // GIR_Coverage, 50871,
     /* 2268863 */     GIR_EraseRootFromParent_Done,
     /* 2268864 */   // Label 30708: @2268864
     /* 2268864 */   GIM_Reject,
     /* 2268865 */ // Label 30706: @2268865
     /* 2268865 */ GIM_Reject,
     /* 2268866 */ // Label 30648: @2268866
     /* 2268866 */ GIM_Try, /*On fail goto*//*Label 30709*/ GIMT_Encode4(2268980),
     /* 2268871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2268874 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2268877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268885 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2268889 */   GIM_Try, /*On fail goto*//*Label 30710*/ GIMT_Encode4(2268934), // Rule ID 50886 //
     /* 2268894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2268897 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2268897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2268900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2268914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268933 */     // GIR_Coverage, 50886,
     /* 2268933 */     GIR_EraseRootFromParent_Done,
     /* 2268934 */   // Label 30710: @2268934
     /* 2268934 */   GIM_Try, /*On fail goto*//*Label 30711*/ GIMT_Encode4(2268979), // Rule ID 50887 //
     /* 2268939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2268942 */     // (mulhs:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2268942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2268945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2268949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2268954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2268956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2268959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2268961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2268964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2268966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2268968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2268971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2268974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2268977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2268978 */     // GIR_Coverage, 50887,
     /* 2268978 */     GIR_EraseRootFromParent_Done,
     /* 2268979 */   // Label 30711: @2268979
     /* 2268979 */   GIM_Reject,
     /* 2268980 */ // Label 30709: @2268980
     /* 2268980 */ GIM_Reject,
     /* 2268981 */ // Label 30649: @2268981
     /* 2268981 */ GIM_Try, /*On fail goto*//*Label 30712*/ GIMT_Encode4(2269095),
     /* 2268986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2268989 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2268992 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2268996 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2269000 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2269004 */   GIM_Try, /*On fail goto*//*Label 30713*/ GIMT_Encode4(2269049), // Rule ID 50858 //
     /* 2269009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269012 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2269015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2269029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269034 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269036 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269048 */     // GIR_Coverage, 50858,
     /* 2269048 */     GIR_EraseRootFromParent_Done,
     /* 2269049 */   // Label 30713: @2269049
     /* 2269049 */   GIM_Try, /*On fail goto*//*Label 30714*/ GIMT_Encode4(2269094), // Rule ID 50859 //
     /* 2269054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269057 */     // (mulhs:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMULH_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2269060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M4),
     /* 2269074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269093 */     // GIR_Coverage, 50859,
     /* 2269093 */     GIR_EraseRootFromParent_Done,
     /* 2269094 */   // Label 30714: @2269094
     /* 2269094 */   GIM_Reject,
     /* 2269095 */ // Label 30712: @2269095
     /* 2269095 */ GIM_Reject,
     /* 2269096 */ // Label 30650: @2269096
     /* 2269096 */ GIM_Try, /*On fail goto*//*Label 30715*/ GIMT_Encode4(2269210),
     /* 2269101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2269104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2269107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269119 */   GIM_Try, /*On fail goto*//*Label 30716*/ GIMT_Encode4(2269164), // Rule ID 50874 //
     /* 2269124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269127 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2269130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2269144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269163 */     // GIR_Coverage, 50874,
     /* 2269163 */     GIR_EraseRootFromParent_Done,
     /* 2269164 */   // Label 30716: @2269164
     /* 2269164 */   GIM_Try, /*On fail goto*//*Label 30717*/ GIMT_Encode4(2269209), // Rule ID 50875 //
     /* 2269169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269172 */     // (mulhs:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2269175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2269189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269194 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269196 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269208 */     // GIR_Coverage, 50875,
     /* 2269208 */     GIR_EraseRootFromParent_Done,
     /* 2269209 */   // Label 30717: @2269209
     /* 2269209 */   GIM_Reject,
     /* 2269210 */ // Label 30715: @2269210
     /* 2269210 */ GIM_Reject,
     /* 2269211 */ // Label 30651: @2269211
     /* 2269211 */ GIM_Try, /*On fail goto*//*Label 30718*/ GIMT_Encode4(2269325),
     /* 2269216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2269219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2269222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2269234 */   GIM_Try, /*On fail goto*//*Label 30719*/ GIMT_Encode4(2269279), // Rule ID 50862 //
     /* 2269239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269242 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2269245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2269259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269278 */     // GIR_Coverage, 50862,
     /* 2269278 */     GIR_EraseRootFromParent_Done,
     /* 2269279 */   // Label 30719: @2269279
     /* 2269279 */   GIM_Try, /*On fail goto*//*Label 30720*/ GIMT_Encode4(2269324), // Rule ID 50863 //
     /* 2269284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269287 */     // (mulhs:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMULH_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2269290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMULH_VV_M8),
     /* 2269304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269323 */     // GIR_Coverage, 50863,
     /* 2269323 */     GIR_EraseRootFromParent_Done,
     /* 2269324 */   // Label 30720: @2269324
     /* 2269324 */   GIM_Reject,
     /* 2269325 */ // Label 30718: @2269325
     /* 2269325 */ GIM_Reject,
     /* 2269326 */ // Label 30652: @2269326
     /* 2269326 */ GIM_Reject,
     /* 2269327 */ // Label 53: @2269327
     /* 2269327 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30744*/ GIMT_Encode4(2272179),
     /* 2269338 */ /*GILLT_s32*//*Label 30721*/ GIMT_Encode4(2269462), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2269350 */ /*GILLT_nxv1s8*//*Label 30722*/ GIMT_Encode4(2269517),
     /* 2269354 */ /*GILLT_nxv1s16*//*Label 30723*/ GIMT_Encode4(2269638),
     /* 2269358 */ /*GILLT_nxv1s32*//*Label 30724*/ GIMT_Encode4(2269759),
     /* 2269362 */ /*GILLT_nxv1s64*//*Label 30725*/ GIMT_Encode4(2269880), GIMT_Encode4(0),
     /* 2269370 */ /*GILLT_nxv2s8*//*Label 30726*/ GIMT_Encode4(2270001),
     /* 2269374 */ /*GILLT_nxv2s16*//*Label 30727*/ GIMT_Encode4(2270122),
     /* 2269378 */ /*GILLT_nxv2s32*//*Label 30728*/ GIMT_Encode4(2270243),
     /* 2269382 */ /*GILLT_nxv2s64*//*Label 30729*/ GIMT_Encode4(2270364), GIMT_Encode4(0),
     /* 2269390 */ /*GILLT_nxv4s8*//*Label 30730*/ GIMT_Encode4(2270485),
     /* 2269394 */ /*GILLT_nxv4s16*//*Label 30731*/ GIMT_Encode4(2270606),
     /* 2269398 */ /*GILLT_nxv4s32*//*Label 30732*/ GIMT_Encode4(2270727),
     /* 2269402 */ /*GILLT_nxv4s64*//*Label 30733*/ GIMT_Encode4(2270848), GIMT_Encode4(0),
     /* 2269410 */ /*GILLT_nxv8s8*//*Label 30734*/ GIMT_Encode4(2270969),
     /* 2269414 */ /*GILLT_nxv8s16*//*Label 30735*/ GIMT_Encode4(2271090),
     /* 2269418 */ /*GILLT_nxv8s32*//*Label 30736*/ GIMT_Encode4(2271211),
     /* 2269422 */ /*GILLT_nxv8s64*//*Label 30737*/ GIMT_Encode4(2271332), GIMT_Encode4(0),
     /* 2269430 */ /*GILLT_nxv16s8*//*Label 30738*/ GIMT_Encode4(2271453),
     /* 2269434 */ /*GILLT_nxv16s16*//*Label 30739*/ GIMT_Encode4(2271574),
     /* 2269438 */ /*GILLT_nxv16s32*//*Label 30740*/ GIMT_Encode4(2271695), GIMT_Encode4(0),
     /* 2269446 */ /*GILLT_nxv32s8*//*Label 30741*/ GIMT_Encode4(2271816),
     /* 2269450 */ /*GILLT_nxv32s16*//*Label 30742*/ GIMT_Encode4(2271937), GIMT_Encode4(0),
     /* 2269458 */ /*GILLT_nxv64s8*//*Label 30743*/ GIMT_Encode4(2272058),
     /* 2269462 */ // Label 30721: @2269462
     /* 2269462 */ GIM_Try, /*On fail goto*//*Label 30745*/ GIMT_Encode4(2269516),
     /* 2269467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2269470 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2269473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2269477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2269481 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2269485 */   GIM_Try, /*On fail goto*//*Label 30746*/ GIMT_Encode4(2269500), // Rule ID 64549 //
     /* 2269490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2269493 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2269493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2269498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269499 */     // GIR_Coverage, 64549,
     /* 2269499 */     GIR_Done,
     /* 2269500 */   // Label 30746: @2269500
     /* 2269500 */   GIM_Try, /*On fail goto*//*Label 30747*/ GIMT_Encode4(2269515), // Rule ID 64550 //
     /* 2269505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2269508 */     // (uaddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2269508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDUSAT),
     /* 2269513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269514 */     // GIR_Coverage, 64550,
     /* 2269514 */     GIR_Done,
     /* 2269515 */   // Label 30747: @2269515
     /* 2269515 */   GIM_Reject,
     /* 2269516 */ // Label 30745: @2269516
     /* 2269516 */ GIM_Reject,
     /* 2269517 */ // Label 30722: @2269517
     /* 2269517 */ GIM_Try, /*On fail goto*//*Label 30748*/ GIMT_Encode4(2269637),
     /* 2269522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2269525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2269528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269540 */   GIM_Try, /*On fail goto*//*Label 30749*/ GIMT_Encode4(2269588), // Rule ID 52378 //
     /* 2269545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269548 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2269551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2269565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269583 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269587 */     // GIR_Coverage, 52378,
     /* 2269587 */     GIR_EraseRootFromParent_Done,
     /* 2269588 */   // Label 30749: @2269588
     /* 2269588 */   GIM_Try, /*On fail goto*//*Label 30750*/ GIMT_Encode4(2269636), // Rule ID 52379 //
     /* 2269593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269596 */     // (uaddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2269599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF8),
     /* 2269613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269635 */     // GIR_Coverage, 52379,
     /* 2269635 */     GIR_EraseRootFromParent_Done,
     /* 2269636 */   // Label 30750: @2269636
     /* 2269636 */   GIM_Reject,
     /* 2269637 */ // Label 30748: @2269637
     /* 2269637 */ GIM_Reject,
     /* 2269638 */ // Label 30723: @2269638
     /* 2269638 */ GIM_Try, /*On fail goto*//*Label 30751*/ GIMT_Encode4(2269758),
     /* 2269643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2269646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2269649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269661 */   GIM_Try, /*On fail goto*//*Label 30752*/ GIMT_Encode4(2269709), // Rule ID 52390 //
     /* 2269666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269669 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2269672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2269686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269704 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269708 */     // GIR_Coverage, 52390,
     /* 2269708 */     GIR_EraseRootFromParent_Done,
     /* 2269709 */   // Label 30752: @2269709
     /* 2269709 */   GIM_Try, /*On fail goto*//*Label 30753*/ GIMT_Encode4(2269757), // Rule ID 52391 //
     /* 2269714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269717 */     // (uaddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2269720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2269734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2269749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269752 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269756 */     // GIR_Coverage, 52391,
     /* 2269756 */     GIR_EraseRootFromParent_Done,
     /* 2269757 */   // Label 30753: @2269757
     /* 2269757 */   GIM_Reject,
     /* 2269758 */ // Label 30751: @2269758
     /* 2269758 */ GIM_Reject,
     /* 2269759 */ // Label 30724: @2269759
     /* 2269759 */ GIM_Try, /*On fail goto*//*Label 30754*/ GIMT_Encode4(2269879),
     /* 2269764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2269767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2269770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269782 */   GIM_Try, /*On fail goto*//*Label 30755*/ GIMT_Encode4(2269830), // Rule ID 52398 //
     /* 2269787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2269790 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2269793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2269807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269829 */     // GIR_Coverage, 52398,
     /* 2269829 */     GIR_EraseRootFromParent_Done,
     /* 2269830 */   // Label 30755: @2269830
     /* 2269830 */   GIM_Try, /*On fail goto*//*Label 30756*/ GIMT_Encode4(2269878), // Rule ID 52399 //
     /* 2269835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2269838 */     // (uaddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2269841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2269855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2269870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269873 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269877 */     // GIR_Coverage, 52399,
     /* 2269877 */     GIR_EraseRootFromParent_Done,
     /* 2269878 */   // Label 30756: @2269878
     /* 2269878 */   GIM_Reject,
     /* 2269879 */ // Label 30754: @2269879
     /* 2269879 */ GIM_Reject,
     /* 2269880 */ // Label 30725: @2269880
     /* 2269880 */ GIM_Try, /*On fail goto*//*Label 30757*/ GIMT_Encode4(2270000),
     /* 2269885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2269888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2269891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2269903 */   GIM_Try, /*On fail goto*//*Label 30758*/ GIMT_Encode4(2269951), // Rule ID 52414 //
     /* 2269908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2269911 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2269911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2269914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2269928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269946 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269950 */     // GIR_Coverage, 52414,
     /* 2269950 */     GIR_EraseRootFromParent_Done,
     /* 2269951 */   // Label 30758: @2269951
     /* 2269951 */   GIM_Try, /*On fail goto*//*Label 30759*/ GIMT_Encode4(2269999), // Rule ID 52415 //
     /* 2269956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2269959 */     // (uaddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2269959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2269962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2269966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2269971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2269973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2269976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2269978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2269981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2269983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2269985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2269988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2269991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2269994 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2269997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2269998 */     // GIR_Coverage, 52415,
     /* 2269998 */     GIR_EraseRootFromParent_Done,
     /* 2269999 */   // Label 30759: @2269999
     /* 2269999 */   GIM_Reject,
     /* 2270000 */ // Label 30757: @2270000
     /* 2270000 */ GIM_Reject,
     /* 2270001 */ // Label 30726: @2270001
     /* 2270001 */ GIM_Try, /*On fail goto*//*Label 30760*/ GIMT_Encode4(2270121),
     /* 2270006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2270009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2270012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270024 */   GIM_Try, /*On fail goto*//*Label 30761*/ GIMT_Encode4(2270072), // Rule ID 52382 //
     /* 2270029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270032 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2270035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2270049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270067 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270071 */     // GIR_Coverage, 52382,
     /* 2270071 */     GIR_EraseRootFromParent_Done,
     /* 2270072 */   // Label 30761: @2270072
     /* 2270072 */   GIM_Try, /*On fail goto*//*Label 30762*/ GIMT_Encode4(2270120), // Rule ID 52383 //
     /* 2270077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270080 */     // (uaddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2270083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF4),
     /* 2270097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270115 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270119 */     // GIR_Coverage, 52383,
     /* 2270119 */     GIR_EraseRootFromParent_Done,
     /* 2270120 */   // Label 30762: @2270120
     /* 2270120 */   GIM_Reject,
     /* 2270121 */ // Label 30760: @2270121
     /* 2270121 */ GIM_Reject,
     /* 2270122 */ // Label 30727: @2270122
     /* 2270122 */ GIM_Try, /*On fail goto*//*Label 30763*/ GIMT_Encode4(2270242),
     /* 2270127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2270130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2270133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270145 */   GIM_Try, /*On fail goto*//*Label 30764*/ GIMT_Encode4(2270193), // Rule ID 52394 //
     /* 2270150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270153 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2270156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2270170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270188 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270192 */     // GIR_Coverage, 52394,
     /* 2270192 */     GIR_EraseRootFromParent_Done,
     /* 2270193 */   // Label 30764: @2270193
     /* 2270193 */   GIM_Try, /*On fail goto*//*Label 30765*/ GIMT_Encode4(2270241), // Rule ID 52395 //
     /* 2270198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270201 */     // (uaddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2270204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2270218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270236 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270240 */     // GIR_Coverage, 52395,
     /* 2270240 */     GIR_EraseRootFromParent_Done,
     /* 2270241 */   // Label 30765: @2270241
     /* 2270241 */   GIM_Reject,
     /* 2270242 */ // Label 30763: @2270242
     /* 2270242 */ GIM_Reject,
     /* 2270243 */ // Label 30728: @2270243
     /* 2270243 */ GIM_Try, /*On fail goto*//*Label 30766*/ GIMT_Encode4(2270363),
     /* 2270248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2270251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2270254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270266 */   GIM_Try, /*On fail goto*//*Label 30767*/ GIMT_Encode4(2270314), // Rule ID 52410 //
     /* 2270271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270274 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2270277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2270291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270309 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270313 */     // GIR_Coverage, 52410,
     /* 2270313 */     GIR_EraseRootFromParent_Done,
     /* 2270314 */   // Label 30767: @2270314
     /* 2270314 */   GIM_Try, /*On fail goto*//*Label 30768*/ GIMT_Encode4(2270362), // Rule ID 52411 //
     /* 2270319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270322 */     // (uaddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2270325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2270339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270357 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270361 */     // GIR_Coverage, 52411,
     /* 2270361 */     GIR_EraseRootFromParent_Done,
     /* 2270362 */   // Label 30768: @2270362
     /* 2270362 */   GIM_Reject,
     /* 2270363 */ // Label 30766: @2270363
     /* 2270363 */ GIM_Reject,
     /* 2270364 */ // Label 30729: @2270364
     /* 2270364 */ GIM_Try, /*On fail goto*//*Label 30769*/ GIMT_Encode4(2270484),
     /* 2270369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2270372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2270375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270387 */   GIM_Try, /*On fail goto*//*Label 30770*/ GIMT_Encode4(2270435), // Rule ID 52454 //
     /* 2270392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2270395 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2270398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2270412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270430 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270434 */     // GIR_Coverage, 52454,
     /* 2270434 */     GIR_EraseRootFromParent_Done,
     /* 2270435 */   // Label 30770: @2270435
     /* 2270435 */   GIM_Try, /*On fail goto*//*Label 30771*/ GIMT_Encode4(2270483), // Rule ID 52455 //
     /* 2270440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2270443 */     // (uaddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2270446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2270460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270478 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270482 */     // GIR_Coverage, 52455,
     /* 2270482 */     GIR_EraseRootFromParent_Done,
     /* 2270483 */   // Label 30771: @2270483
     /* 2270483 */   GIM_Reject,
     /* 2270484 */ // Label 30769: @2270484
     /* 2270484 */ GIM_Reject,
     /* 2270485 */ // Label 30730: @2270485
     /* 2270485 */ GIM_Try, /*On fail goto*//*Label 30772*/ GIMT_Encode4(2270605),
     /* 2270490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2270493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2270496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270508 */   GIM_Try, /*On fail goto*//*Label 30773*/ GIMT_Encode4(2270556), // Rule ID 52386 //
     /* 2270513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270516 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2270519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2270533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270551 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270555 */     // GIR_Coverage, 52386,
     /* 2270555 */     GIR_EraseRootFromParent_Done,
     /* 2270556 */   // Label 30773: @2270556
     /* 2270556 */   GIM_Try, /*On fail goto*//*Label 30774*/ GIMT_Encode4(2270604), // Rule ID 52387 //
     /* 2270561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270564 */     // (uaddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADDU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2270567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_MF2),
     /* 2270581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270599 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270603 */     // GIR_Coverage, 52387,
     /* 2270603 */     GIR_EraseRootFromParent_Done,
     /* 2270604 */   // Label 30774: @2270604
     /* 2270604 */   GIM_Reject,
     /* 2270605 */ // Label 30772: @2270605
     /* 2270605 */ GIM_Reject,
     /* 2270606 */ // Label 30731: @2270606
     /* 2270606 */ GIM_Try, /*On fail goto*//*Label 30775*/ GIMT_Encode4(2270726),
     /* 2270611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2270614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2270617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270629 */   GIM_Try, /*On fail goto*//*Label 30776*/ GIMT_Encode4(2270677), // Rule ID 52406 //
     /* 2270634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270637 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2270640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2270654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270672 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270676 */     // GIR_Coverage, 52406,
     /* 2270676 */     GIR_EraseRootFromParent_Done,
     /* 2270677 */   // Label 30776: @2270677
     /* 2270677 */   GIM_Try, /*On fail goto*//*Label 30777*/ GIMT_Encode4(2270725), // Rule ID 52407 //
     /* 2270682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270685 */     // (uaddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2270688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2270702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2270717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270720 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270724 */     // GIR_Coverage, 52407,
     /* 2270724 */     GIR_EraseRootFromParent_Done,
     /* 2270725 */   // Label 30777: @2270725
     /* 2270725 */   GIM_Reject,
     /* 2270726 */ // Label 30775: @2270726
     /* 2270726 */ GIM_Reject,
     /* 2270727 */ // Label 30732: @2270727
     /* 2270727 */ GIM_Try, /*On fail goto*//*Label 30778*/ GIMT_Encode4(2270847),
     /* 2270732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2270735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2270738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2270750 */   GIM_Try, /*On fail goto*//*Label 30779*/ GIMT_Encode4(2270798), // Rule ID 52442 //
     /* 2270755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2270758 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2270761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2270775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270793 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270797 */     // GIR_Coverage, 52442,
     /* 2270797 */     GIR_EraseRootFromParent_Done,
     /* 2270798 */   // Label 30779: @2270798
     /* 2270798 */   GIM_Try, /*On fail goto*//*Label 30780*/ GIMT_Encode4(2270846), // Rule ID 52443 //
     /* 2270803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2270806 */     // (uaddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2270809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2270823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2270838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270841 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270845 */     // GIR_Coverage, 52443,
     /* 2270845 */     GIR_EraseRootFromParent_Done,
     /* 2270846 */   // Label 30780: @2270846
     /* 2270846 */   GIM_Reject,
     /* 2270847 */ // Label 30778: @2270847
     /* 2270847 */ GIM_Reject,
     /* 2270848 */ // Label 30733: @2270848
     /* 2270848 */ GIM_Try, /*On fail goto*//*Label 30781*/ GIMT_Encode4(2270968),
     /* 2270853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2270856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2270859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2270871 */   GIM_Try, /*On fail goto*//*Label 30782*/ GIMT_Encode4(2270919), // Rule ID 52458 //
     /* 2270876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2270879 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2270879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2270882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2270896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270914 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270918 */     // GIR_Coverage, 52458,
     /* 2270918 */     GIR_EraseRootFromParent_Done,
     /* 2270919 */   // Label 30782: @2270919
     /* 2270919 */   GIM_Try, /*On fail goto*//*Label 30783*/ GIMT_Encode4(2270967), // Rule ID 52459 //
     /* 2270924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2270927 */     // (uaddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2270927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2270930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2270934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2270939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2270941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2270944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2270946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2270949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2270951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2270953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2270956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2270959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2270962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2270965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2270966 */     // GIR_Coverage, 52459,
     /* 2270966 */     GIR_EraseRootFromParent_Done,
     /* 2270967 */   // Label 30783: @2270967
     /* 2270967 */   GIM_Reject,
     /* 2270968 */ // Label 30781: @2270968
     /* 2270968 */ GIM_Reject,
     /* 2270969 */ // Label 30734: @2270969
     /* 2270969 */ GIM_Try, /*On fail goto*//*Label 30784*/ GIMT_Encode4(2271089),
     /* 2270974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2270977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2270980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2270992 */   GIM_Try, /*On fail goto*//*Label 30785*/ GIMT_Encode4(2271040), // Rule ID 52402 //
     /* 2270997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271000 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2271003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2271017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271035 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271039 */     // GIR_Coverage, 52402,
     /* 2271039 */     GIR_EraseRootFromParent_Done,
     /* 2271040 */   // Label 30785: @2271040
     /* 2271040 */   GIM_Try, /*On fail goto*//*Label 30786*/ GIMT_Encode4(2271088), // Rule ID 52403 //
     /* 2271045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271048 */     // (uaddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADDU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2271051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M1),
     /* 2271065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271083 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271087 */     // GIR_Coverage, 52403,
     /* 2271087 */     GIR_EraseRootFromParent_Done,
     /* 2271088 */   // Label 30786: @2271088
     /* 2271088 */   GIM_Reject,
     /* 2271089 */ // Label 30784: @2271089
     /* 2271089 */ GIM_Reject,
     /* 2271090 */ // Label 30735: @2271090
     /* 2271090 */ GIM_Try, /*On fail goto*//*Label 30787*/ GIMT_Encode4(2271210),
     /* 2271095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2271098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2271101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271113 */   GIM_Try, /*On fail goto*//*Label 30788*/ GIMT_Encode4(2271161), // Rule ID 52430 //
     /* 2271118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271121 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2271124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2271138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271156 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271160 */     // GIR_Coverage, 52430,
     /* 2271160 */     GIR_EraseRootFromParent_Done,
     /* 2271161 */   // Label 30788: @2271161
     /* 2271161 */   GIM_Try, /*On fail goto*//*Label 30789*/ GIMT_Encode4(2271209), // Rule ID 52431 //
     /* 2271166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271169 */     // (uaddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2271172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2271186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271208 */     // GIR_Coverage, 52431,
     /* 2271208 */     GIR_EraseRootFromParent_Done,
     /* 2271209 */   // Label 30789: @2271209
     /* 2271209 */   GIM_Reject,
     /* 2271210 */ // Label 30787: @2271210
     /* 2271210 */ GIM_Reject,
     /* 2271211 */ // Label 30736: @2271211
     /* 2271211 */ GIM_Try, /*On fail goto*//*Label 30790*/ GIMT_Encode4(2271331),
     /* 2271216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2271219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2271222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271230 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271234 */   GIM_Try, /*On fail goto*//*Label 30791*/ GIMT_Encode4(2271282), // Rule ID 52446 //
     /* 2271239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271242 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2271245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271264 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271266 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271277 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271281 */     // GIR_Coverage, 52446,
     /* 2271281 */     GIR_EraseRootFromParent_Done,
     /* 2271282 */   // Label 30791: @2271282
     /* 2271282 */   GIM_Try, /*On fail goto*//*Label 30792*/ GIMT_Encode4(2271330), // Rule ID 52447 //
     /* 2271287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271290 */     // (uaddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2271293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271325 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271329 */     // GIR_Coverage, 52447,
     /* 2271329 */     GIR_EraseRootFromParent_Done,
     /* 2271330 */   // Label 30792: @2271330
     /* 2271330 */   GIM_Reject,
     /* 2271331 */ // Label 30790: @2271331
     /* 2271331 */ GIM_Reject,
     /* 2271332 */ // Label 30737: @2271332
     /* 2271332 */ GIM_Try, /*On fail goto*//*Label 30793*/ GIMT_Encode4(2271452),
     /* 2271337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2271340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2271343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271355 */   GIM_Try, /*On fail goto*//*Label 30794*/ GIMT_Encode4(2271403), // Rule ID 52462 //
     /* 2271360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2271363 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2271366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2271380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271398 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271402 */     // GIR_Coverage, 52462,
     /* 2271402 */     GIR_EraseRootFromParent_Done,
     /* 2271403 */   // Label 30794: @2271403
     /* 2271403 */   GIM_Try, /*On fail goto*//*Label 30795*/ GIMT_Encode4(2271451), // Rule ID 52463 //
     /* 2271408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2271411 */     // (uaddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2271414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2271428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271433 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271435 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2271443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271446 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271450 */     // GIR_Coverage, 52463,
     /* 2271450 */     GIR_EraseRootFromParent_Done,
     /* 2271451 */   // Label 30795: @2271451
     /* 2271451 */   GIM_Reject,
     /* 2271452 */ // Label 30793: @2271452
     /* 2271452 */ GIM_Reject,
     /* 2271453 */ // Label 30738: @2271453
     /* 2271453 */ GIM_Try, /*On fail goto*//*Label 30796*/ GIMT_Encode4(2271573),
     /* 2271458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2271461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2271464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271472 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2271476 */   GIM_Try, /*On fail goto*//*Label 30797*/ GIMT_Encode4(2271524), // Rule ID 52418 //
     /* 2271481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271484 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2271487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2271501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271503 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271506 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271508 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271519 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271523 */     // GIR_Coverage, 52418,
     /* 2271523 */     GIR_EraseRootFromParent_Done,
     /* 2271524 */   // Label 30797: @2271524
     /* 2271524 */   GIM_Try, /*On fail goto*//*Label 30798*/ GIMT_Encode4(2271572), // Rule ID 52419 //
     /* 2271529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271532 */     // (uaddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADDU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2271535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M2),
     /* 2271549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271567 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271571 */     // GIR_Coverage, 52419,
     /* 2271571 */     GIR_EraseRootFromParent_Done,
     /* 2271572 */   // Label 30798: @2271572
     /* 2271572 */   GIM_Reject,
     /* 2271573 */ // Label 30796: @2271573
     /* 2271573 */ GIM_Reject,
     /* 2271574 */ // Label 30739: @2271574
     /* 2271574 */ GIM_Try, /*On fail goto*//*Label 30799*/ GIMT_Encode4(2271694),
     /* 2271579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2271582 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2271585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271593 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271597 */   GIM_Try, /*On fail goto*//*Label 30800*/ GIMT_Encode4(2271645), // Rule ID 52434 //
     /* 2271602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271605 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271605 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2271608 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271612 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271629 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271644 */     // GIR_Coverage, 52434,
     /* 2271644 */     GIR_EraseRootFromParent_Done,
     /* 2271645 */   // Label 30800: @2271645
     /* 2271645 */   GIM_Try, /*On fail goto*//*Label 30801*/ GIMT_Encode4(2271693), // Rule ID 52435 //
     /* 2271650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271653 */     // (uaddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2271656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2271685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271688 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271691 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271692 */     // GIR_Coverage, 52435,
     /* 2271692 */     GIR_EraseRootFromParent_Done,
     /* 2271693 */   // Label 30801: @2271693
     /* 2271693 */   GIM_Reject,
     /* 2271694 */ // Label 30799: @2271694
     /* 2271694 */ GIM_Reject,
     /* 2271695 */ // Label 30740: @2271695
     /* 2271695 */ GIM_Try, /*On fail goto*//*Label 30802*/ GIMT_Encode4(2271815),
     /* 2271700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2271703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2271706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271718 */   GIM_Try, /*On fail goto*//*Label 30803*/ GIMT_Encode4(2271766), // Rule ID 52450 //
     /* 2271723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271726 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271726 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2271729 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271733 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2271743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271761 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271765 */     // GIR_Coverage, 52450,
     /* 2271765 */     GIR_EraseRootFromParent_Done,
     /* 2271766 */   // Label 30803: @2271766
     /* 2271766 */   GIM_Try, /*On fail goto*//*Label 30804*/ GIMT_Encode4(2271814), // Rule ID 52451 //
     /* 2271771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271774 */     // (uaddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2271777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2271791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2271806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271809 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271813 */     // GIR_Coverage, 52451,
     /* 2271813 */     GIR_EraseRootFromParent_Done,
     /* 2271814 */   // Label 30804: @2271814
     /* 2271814 */   GIM_Reject,
     /* 2271815 */ // Label 30802: @2271815
     /* 2271815 */ GIM_Reject,
     /* 2271816 */ // Label 30741: @2271816
     /* 2271816 */ GIM_Try, /*On fail goto*//*Label 30805*/ GIMT_Encode4(2271936),
     /* 2271821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2271824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2271827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2271839 */   GIM_Try, /*On fail goto*//*Label 30806*/ GIMT_Encode4(2271887), // Rule ID 52422 //
     /* 2271844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271847 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2271850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271886 */     // GIR_Coverage, 52422,
     /* 2271886 */     GIR_EraseRootFromParent_Done,
     /* 2271887 */   // Label 30806: @2271887
     /* 2271887 */   GIM_Try, /*On fail goto*//*Label 30807*/ GIMT_Encode4(2271935), // Rule ID 52423 //
     /* 2271892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2271895 */     // (uaddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADDU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2271895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2271898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M4),
     /* 2271912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271919 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2271930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2271933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2271934 */     // GIR_Coverage, 52423,
     /* 2271934 */     GIR_EraseRootFromParent_Done,
     /* 2271935 */   // Label 30807: @2271935
     /* 2271935 */   GIM_Reject,
     /* 2271936 */ // Label 30805: @2271936
     /* 2271936 */ GIM_Reject,
     /* 2271937 */ // Label 30742: @2271937
     /* 2271937 */ GIM_Try, /*On fail goto*//*Label 30808*/ GIMT_Encode4(2272057),
     /* 2271942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2271945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2271948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271956 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2271960 */   GIM_Try, /*On fail goto*//*Label 30809*/ GIMT_Encode4(2272008), // Rule ID 52438 //
     /* 2271965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2271968 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2271968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2271971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2271975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2271980 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2271982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2271985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2271987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2271990 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2271992 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2271994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2271997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272003 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272007 */     // GIR_Coverage, 52438,
     /* 2272007 */     GIR_EraseRootFromParent_Done,
     /* 2272008 */   // Label 30809: @2272008
     /* 2272008 */   GIM_Try, /*On fail goto*//*Label 30810*/ GIMT_Encode4(2272056), // Rule ID 52439 //
     /* 2272013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272016 */     // (uaddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2272019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2272033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272055 */     // GIR_Coverage, 52439,
     /* 2272055 */     GIR_EraseRootFromParent_Done,
     /* 2272056 */   // Label 30810: @2272056
     /* 2272056 */   GIM_Reject,
     /* 2272057 */ // Label 30808: @2272057
     /* 2272057 */ GIM_Reject,
     /* 2272058 */ // Label 30743: @2272058
     /* 2272058 */ GIM_Try, /*On fail goto*//*Label 30811*/ GIMT_Encode4(2272178),
     /* 2272063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2272066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2272069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2272081 */   GIM_Try, /*On fail goto*//*Label 30812*/ GIMT_Encode4(2272129), // Rule ID 52426 //
     /* 2272086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272089 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2272092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272101 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2272106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272111 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272113 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272128 */     // GIR_Coverage, 52426,
     /* 2272128 */     GIR_EraseRootFromParent_Done,
     /* 2272129 */   // Label 30812: @2272129
     /* 2272129 */   GIM_Try, /*On fail goto*//*Label 30813*/ GIMT_Encode4(2272177), // Rule ID 52427 //
     /* 2272134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272137 */     // (uaddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADDU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2272140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADDU_VV_M8),
     /* 2272154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272156 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272159 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272161 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272172 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272176 */     // GIR_Coverage, 52427,
     /* 2272176 */     GIR_EraseRootFromParent_Done,
     /* 2272177 */   // Label 30813: @2272177
     /* 2272177 */   GIM_Reject,
     /* 2272178 */ // Label 30811: @2272178
     /* 2272178 */ GIM_Reject,
     /* 2272179 */ // Label 30744: @2272179
     /* 2272179 */ GIM_Reject,
     /* 2272180 */ // Label 54: @2272180
     /* 2272180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30837*/ GIMT_Encode4(2275032),
     /* 2272191 */ /*GILLT_s32*//*Label 30814*/ GIMT_Encode4(2272315), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2272203 */ /*GILLT_nxv1s8*//*Label 30815*/ GIMT_Encode4(2272370),
     /* 2272207 */ /*GILLT_nxv1s16*//*Label 30816*/ GIMT_Encode4(2272491),
     /* 2272211 */ /*GILLT_nxv1s32*//*Label 30817*/ GIMT_Encode4(2272612),
     /* 2272215 */ /*GILLT_nxv1s64*//*Label 30818*/ GIMT_Encode4(2272733), GIMT_Encode4(0),
     /* 2272223 */ /*GILLT_nxv2s8*//*Label 30819*/ GIMT_Encode4(2272854),
     /* 2272227 */ /*GILLT_nxv2s16*//*Label 30820*/ GIMT_Encode4(2272975),
     /* 2272231 */ /*GILLT_nxv2s32*//*Label 30821*/ GIMT_Encode4(2273096),
     /* 2272235 */ /*GILLT_nxv2s64*//*Label 30822*/ GIMT_Encode4(2273217), GIMT_Encode4(0),
     /* 2272243 */ /*GILLT_nxv4s8*//*Label 30823*/ GIMT_Encode4(2273338),
     /* 2272247 */ /*GILLT_nxv4s16*//*Label 30824*/ GIMT_Encode4(2273459),
     /* 2272251 */ /*GILLT_nxv4s32*//*Label 30825*/ GIMT_Encode4(2273580),
     /* 2272255 */ /*GILLT_nxv4s64*//*Label 30826*/ GIMT_Encode4(2273701), GIMT_Encode4(0),
     /* 2272263 */ /*GILLT_nxv8s8*//*Label 30827*/ GIMT_Encode4(2273822),
     /* 2272267 */ /*GILLT_nxv8s16*//*Label 30828*/ GIMT_Encode4(2273943),
     /* 2272271 */ /*GILLT_nxv8s32*//*Label 30829*/ GIMT_Encode4(2274064),
     /* 2272275 */ /*GILLT_nxv8s64*//*Label 30830*/ GIMT_Encode4(2274185), GIMT_Encode4(0),
     /* 2272283 */ /*GILLT_nxv16s8*//*Label 30831*/ GIMT_Encode4(2274306),
     /* 2272287 */ /*GILLT_nxv16s16*//*Label 30832*/ GIMT_Encode4(2274427),
     /* 2272291 */ /*GILLT_nxv16s32*//*Label 30833*/ GIMT_Encode4(2274548), GIMT_Encode4(0),
     /* 2272299 */ /*GILLT_nxv32s8*//*Label 30834*/ GIMT_Encode4(2274669),
     /* 2272303 */ /*GILLT_nxv32s16*//*Label 30835*/ GIMT_Encode4(2274790), GIMT_Encode4(0),
     /* 2272311 */ /*GILLT_nxv64s8*//*Label 30836*/ GIMT_Encode4(2274911),
     /* 2272315 */ // Label 30814: @2272315
     /* 2272315 */ GIM_Try, /*On fail goto*//*Label 30838*/ GIMT_Encode4(2272369),
     /* 2272320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2272323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2272326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2272330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2272334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2272338 */   GIM_Try, /*On fail goto*//*Label 30839*/ GIMT_Encode4(2272353), // Rule ID 64547 //
     /* 2272343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2272346 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2272346 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2272351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272352 */     // GIR_Coverage, 64547,
     /* 2272352 */     GIR_Done,
     /* 2272353 */   // Label 30839: @2272353
     /* 2272353 */   GIM_Try, /*On fail goto*//*Label 30840*/ GIMT_Encode4(2272368), // Rule ID 64548 //
     /* 2272358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2272361 */     // (saddsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_ADDSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2272361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_ADDSAT),
     /* 2272366 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272367 */     // GIR_Coverage, 64548,
     /* 2272367 */     GIR_Done,
     /* 2272368 */   // Label 30840: @2272368
     /* 2272368 */   GIM_Reject,
     /* 2272369 */ // Label 30838: @2272369
     /* 2272369 */ GIM_Reject,
     /* 2272370 */ // Label 30815: @2272370
     /* 2272370 */ GIM_Try, /*On fail goto*//*Label 30841*/ GIMT_Encode4(2272490),
     /* 2272375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2272378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2272381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272393 */   GIM_Try, /*On fail goto*//*Label 30842*/ GIMT_Encode4(2272441), // Rule ID 52246 //
     /* 2272398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272401 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2272404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2272418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272436 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272440 */     // GIR_Coverage, 52246,
     /* 2272440 */     GIR_EraseRootFromParent_Done,
     /* 2272441 */   // Label 30842: @2272441
     /* 2272441 */   GIM_Try, /*On fail goto*//*Label 30843*/ GIMT_Encode4(2272489), // Rule ID 52247 //
     /* 2272446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272449 */     // (saddsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSADD_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2272452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF8),
     /* 2272466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272488 */     // GIR_Coverage, 52247,
     /* 2272488 */     GIR_EraseRootFromParent_Done,
     /* 2272489 */   // Label 30843: @2272489
     /* 2272489 */   GIM_Reject,
     /* 2272490 */ // Label 30841: @2272490
     /* 2272490 */ GIM_Reject,
     /* 2272491 */ // Label 30816: @2272491
     /* 2272491 */ GIM_Try, /*On fail goto*//*Label 30844*/ GIMT_Encode4(2272611),
     /* 2272496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2272499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2272502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272510 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272514 */   GIM_Try, /*On fail goto*//*Label 30845*/ GIMT_Encode4(2272562), // Rule ID 52258 //
     /* 2272519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272522 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2272525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2272539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272557 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272561 */     // GIR_Coverage, 52258,
     /* 2272561 */     GIR_EraseRootFromParent_Done,
     /* 2272562 */   // Label 30845: @2272562
     /* 2272562 */   GIM_Try, /*On fail goto*//*Label 30846*/ GIMT_Encode4(2272610), // Rule ID 52259 //
     /* 2272567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272570 */     // (saddsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2272573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2272587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2272602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272609 */     // GIR_Coverage, 52259,
     /* 2272609 */     GIR_EraseRootFromParent_Done,
     /* 2272610 */   // Label 30846: @2272610
     /* 2272610 */   GIM_Reject,
     /* 2272611 */ // Label 30844: @2272611
     /* 2272611 */ GIM_Reject,
     /* 2272612 */ // Label 30817: @2272612
     /* 2272612 */ GIM_Try, /*On fail goto*//*Label 30847*/ GIMT_Encode4(2272732),
     /* 2272617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2272620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2272623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272635 */   GIM_Try, /*On fail goto*//*Label 30848*/ GIMT_Encode4(2272683), // Rule ID 52266 //
     /* 2272640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272643 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272643 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2272646 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272650 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2272660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272678 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272682 */     // GIR_Coverage, 52266,
     /* 2272682 */     GIR_EraseRootFromParent_Done,
     /* 2272683 */   // Label 30848: @2272683
     /* 2272683 */   GIM_Try, /*On fail goto*//*Label 30849*/ GIMT_Encode4(2272731), // Rule ID 52267 //
     /* 2272688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272691 */     // (saddsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2272694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2272708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2272723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272726 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272730 */     // GIR_Coverage, 52267,
     /* 2272730 */     GIR_EraseRootFromParent_Done,
     /* 2272731 */   // Label 30849: @2272731
     /* 2272731 */   GIM_Reject,
     /* 2272732 */ // Label 30847: @2272732
     /* 2272732 */ GIM_Reject,
     /* 2272733 */ // Label 30818: @2272733
     /* 2272733 */ GIM_Try, /*On fail goto*//*Label 30850*/ GIMT_Encode4(2272853),
     /* 2272738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2272741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2272744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272756 */   GIM_Try, /*On fail goto*//*Label 30851*/ GIMT_Encode4(2272804), // Rule ID 52282 //
     /* 2272761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2272764 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2272767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2272781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272799 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272803 */     // GIR_Coverage, 52282,
     /* 2272803 */     GIR_EraseRootFromParent_Done,
     /* 2272804 */   // Label 30851: @2272804
     /* 2272804 */   GIM_Try, /*On fail goto*//*Label 30852*/ GIMT_Encode4(2272852), // Rule ID 52283 //
     /* 2272809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2272812 */     // (saddsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2272815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2272829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272836 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2272844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272847 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272851 */     // GIR_Coverage, 52283,
     /* 2272851 */     GIR_EraseRootFromParent_Done,
     /* 2272852 */   // Label 30852: @2272852
     /* 2272852 */   GIM_Reject,
     /* 2272853 */ // Label 30850: @2272853
     /* 2272853 */ GIM_Reject,
     /* 2272854 */ // Label 30819: @2272854
     /* 2272854 */ GIM_Try, /*On fail goto*//*Label 30853*/ GIMT_Encode4(2272974),
     /* 2272859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2272862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2272865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272877 */   GIM_Try, /*On fail goto*//*Label 30854*/ GIMT_Encode4(2272925), // Rule ID 52250 //
     /* 2272882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2272885 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2272885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2272888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2272902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272904 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272909 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272924 */     // GIR_Coverage, 52250,
     /* 2272924 */     GIR_EraseRootFromParent_Done,
     /* 2272925 */   // Label 30854: @2272925
     /* 2272925 */   GIM_Try, /*On fail goto*//*Label 30855*/ GIMT_Encode4(2272973), // Rule ID 52251 //
     /* 2272930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2272933 */     // (saddsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSADD_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2272933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2272936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2272940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2272945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2272947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF4),
     /* 2272950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2272952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2272955 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2272957 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2272959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2272962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2272968 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2272971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2272972 */     // GIR_Coverage, 52251,
     /* 2272972 */     GIR_EraseRootFromParent_Done,
     /* 2272973 */   // Label 30855: @2272973
     /* 2272973 */   GIM_Reject,
     /* 2272974 */ // Label 30853: @2272974
     /* 2272974 */ GIM_Reject,
     /* 2272975 */ // Label 30820: @2272975
     /* 2272975 */ GIM_Try, /*On fail goto*//*Label 30856*/ GIMT_Encode4(2273095),
     /* 2272980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2272983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2272986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2272998 */   GIM_Try, /*On fail goto*//*Label 30857*/ GIMT_Encode4(2273046), // Rule ID 52262 //
     /* 2273003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273006 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2273009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2273023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273030 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273041 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273045 */     // GIR_Coverage, 52262,
     /* 2273045 */     GIR_EraseRootFromParent_Done,
     /* 2273046 */   // Label 30857: @2273046
     /* 2273046 */   GIM_Try, /*On fail goto*//*Label 30858*/ GIMT_Encode4(2273094), // Rule ID 52263 //
     /* 2273051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273054 */     // (saddsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2273057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2273071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273076 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273078 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273092 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273093 */     // GIR_Coverage, 52263,
     /* 2273093 */     GIR_EraseRootFromParent_Done,
     /* 2273094 */   // Label 30858: @2273094
     /* 2273094 */   GIM_Reject,
     /* 2273095 */ // Label 30856: @2273095
     /* 2273095 */ GIM_Reject,
     /* 2273096 */ // Label 30821: @2273096
     /* 2273096 */ GIM_Try, /*On fail goto*//*Label 30859*/ GIMT_Encode4(2273216),
     /* 2273101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2273104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2273107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273119 */   GIM_Try, /*On fail goto*//*Label 30860*/ GIMT_Encode4(2273167), // Rule ID 52278 //
     /* 2273124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273127 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2273130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273149 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273166 */     // GIR_Coverage, 52278,
     /* 2273166 */     GIR_EraseRootFromParent_Done,
     /* 2273167 */   // Label 30860: @2273167
     /* 2273167 */   GIM_Try, /*On fail goto*//*Label 30861*/ GIMT_Encode4(2273215), // Rule ID 52279 //
     /* 2273172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273175 */     // (saddsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2273178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273210 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273214 */     // GIR_Coverage, 52279,
     /* 2273214 */     GIR_EraseRootFromParent_Done,
     /* 2273215 */   // Label 30861: @2273215
     /* 2273215 */   GIM_Reject,
     /* 2273216 */ // Label 30859: @2273216
     /* 2273216 */ GIM_Reject,
     /* 2273217 */ // Label 30822: @2273217
     /* 2273217 */ GIM_Try, /*On fail goto*//*Label 30862*/ GIMT_Encode4(2273337),
     /* 2273222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2273225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2273228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273236 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273240 */   GIM_Try, /*On fail goto*//*Label 30863*/ GIMT_Encode4(2273288), // Rule ID 52322 //
     /* 2273245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2273248 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2273251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2273265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273272 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273283 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273286 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273287 */     // GIR_Coverage, 52322,
     /* 2273287 */     GIR_EraseRootFromParent_Done,
     /* 2273288 */   // Label 30863: @2273288
     /* 2273288 */   GIM_Try, /*On fail goto*//*Label 30864*/ GIMT_Encode4(2273336), // Rule ID 52323 //
     /* 2273293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2273296 */     // (saddsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2273299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2273313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273320 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273335 */     // GIR_Coverage, 52323,
     /* 2273335 */     GIR_EraseRootFromParent_Done,
     /* 2273336 */   // Label 30864: @2273336
     /* 2273336 */   GIM_Reject,
     /* 2273337 */ // Label 30862: @2273337
     /* 2273337 */ GIM_Reject,
     /* 2273338 */ // Label 30823: @2273338
     /* 2273338 */ GIM_Try, /*On fail goto*//*Label 30865*/ GIMT_Encode4(2273458),
     /* 2273343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2273346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2273349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273357 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273361 */   GIM_Try, /*On fail goto*//*Label 30866*/ GIMT_Encode4(2273409), // Rule ID 52254 //
     /* 2273366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273369 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273369 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2273372 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273376 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2273386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273408 */     // GIR_Coverage, 52254,
     /* 2273408 */     GIR_EraseRootFromParent_Done,
     /* 2273409 */   // Label 30866: @2273409
     /* 2273409 */   GIM_Try, /*On fail goto*//*Label 30867*/ GIMT_Encode4(2273457), // Rule ID 52255 //
     /* 2273414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273417 */     // (saddsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSADD_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2273420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_MF2),
     /* 2273434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273456 */     // GIR_Coverage, 52255,
     /* 2273456 */     GIR_EraseRootFromParent_Done,
     /* 2273457 */   // Label 30867: @2273457
     /* 2273457 */   GIM_Reject,
     /* 2273458 */ // Label 30865: @2273458
     /* 2273458 */ GIM_Reject,
     /* 2273459 */ // Label 30824: @2273459
     /* 2273459 */ GIM_Try, /*On fail goto*//*Label 30868*/ GIMT_Encode4(2273579),
     /* 2273464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2273467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2273470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273478 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273482 */   GIM_Try, /*On fail goto*//*Label 30869*/ GIMT_Encode4(2273530), // Rule ID 52274 //
     /* 2273487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273490 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2273493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273529 */     // GIR_Coverage, 52274,
     /* 2273529 */     GIR_EraseRootFromParent_Done,
     /* 2273530 */   // Label 30869: @2273530
     /* 2273530 */   GIM_Try, /*On fail goto*//*Label 30870*/ GIMT_Encode4(2273578), // Rule ID 52275 //
     /* 2273535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273538 */     // (saddsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2273541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273562 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2273570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273573 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273577 */     // GIR_Coverage, 52275,
     /* 2273577 */     GIR_EraseRootFromParent_Done,
     /* 2273578 */   // Label 30870: @2273578
     /* 2273578 */   GIM_Reject,
     /* 2273579 */ // Label 30868: @2273579
     /* 2273579 */ GIM_Reject,
     /* 2273580 */ // Label 30825: @2273580
     /* 2273580 */ GIM_Try, /*On fail goto*//*Label 30871*/ GIMT_Encode4(2273700),
     /* 2273585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2273588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2273591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273599 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273603 */   GIM_Try, /*On fail goto*//*Label 30872*/ GIMT_Encode4(2273651), // Rule ID 52310 //
     /* 2273608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273611 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2273614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273623 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2273628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273646 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273650 */     // GIR_Coverage, 52310,
     /* 2273650 */     GIR_EraseRootFromParent_Done,
     /* 2273651 */   // Label 30872: @2273651
     /* 2273651 */   GIM_Try, /*On fail goto*//*Label 30873*/ GIMT_Encode4(2273699), // Rule ID 52311 //
     /* 2273656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273659 */     // (saddsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2273662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2273676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273683 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2273691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273694 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273698 */     // GIR_Coverage, 52311,
     /* 2273698 */     GIR_EraseRootFromParent_Done,
     /* 2273699 */   // Label 30873: @2273699
     /* 2273699 */   GIM_Reject,
     /* 2273700 */ // Label 30871: @2273700
     /* 2273700 */ GIM_Reject,
     /* 2273701 */ // Label 30826: @2273701
     /* 2273701 */ GIM_Try, /*On fail goto*//*Label 30874*/ GIMT_Encode4(2273821),
     /* 2273706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2273709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2273712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273720 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2273724 */   GIM_Try, /*On fail goto*//*Label 30875*/ GIMT_Encode4(2273772), // Rule ID 52326 //
     /* 2273729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2273732 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273732 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2273735 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273739 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273744 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2273749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273767 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273771 */     // GIR_Coverage, 52326,
     /* 2273771 */     GIR_EraseRootFromParent_Done,
     /* 2273772 */   // Label 30875: @2273772
     /* 2273772 */   GIM_Try, /*On fail goto*//*Label 30876*/ GIMT_Encode4(2273820), // Rule ID 52327 //
     /* 2273777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2273780 */     // (saddsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2273783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273792 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2273797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2273812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273815 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273818 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273819 */     // GIR_Coverage, 52327,
     /* 2273819 */     GIR_EraseRootFromParent_Done,
     /* 2273820 */   // Label 30876: @2273820
     /* 2273820 */   GIM_Reject,
     /* 2273821 */ // Label 30874: @2273821
     /* 2273821 */ GIM_Reject,
     /* 2273822 */ // Label 30827: @2273822
     /* 2273822 */ GIM_Try, /*On fail goto*//*Label 30877*/ GIMT_Encode4(2273942),
     /* 2273827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2273830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2273833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2273845 */   GIM_Try, /*On fail goto*//*Label 30878*/ GIMT_Encode4(2273893), // Rule ID 52270 //
     /* 2273850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273853 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2273856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273865 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273888 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273892 */     // GIR_Coverage, 52270,
     /* 2273892 */     GIR_EraseRootFromParent_Done,
     /* 2273893 */   // Label 30878: @2273893
     /* 2273893 */   GIM_Try, /*On fail goto*//*Label 30879*/ GIMT_Encode4(2273941), // Rule ID 52271 //
     /* 2273898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2273901 */     // (saddsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSADD_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2273901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2273904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M1),
     /* 2273918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2273927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2273930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2273936 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2273939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2273940 */     // GIR_Coverage, 52271,
     /* 2273940 */     GIR_EraseRootFromParent_Done,
     /* 2273941 */   // Label 30879: @2273941
     /* 2273941 */   GIM_Reject,
     /* 2273942 */ // Label 30877: @2273942
     /* 2273942 */ GIM_Reject,
     /* 2273943 */ // Label 30828: @2273943
     /* 2273943 */ GIM_Try, /*On fail goto*//*Label 30880*/ GIMT_Encode4(2274063),
     /* 2273948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2273951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2273954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273962 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2273966 */   GIM_Try, /*On fail goto*//*Label 30881*/ GIMT_Encode4(2274014), // Rule ID 52298 //
     /* 2273971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2273974 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2273974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2273977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2273981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2273986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2273988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2273991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2273993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2273996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2273998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274009 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274013 */     // GIR_Coverage, 52298,
     /* 2274013 */     GIR_EraseRootFromParent_Done,
     /* 2274014 */   // Label 30881: @2274014
     /* 2274014 */   GIM_Try, /*On fail goto*//*Label 30882*/ GIMT_Encode4(2274062), // Rule ID 52299 //
     /* 2274019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274022 */     // (saddsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2274025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2274039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274057 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274061 */     // GIR_Coverage, 52299,
     /* 2274061 */     GIR_EraseRootFromParent_Done,
     /* 2274062 */   // Label 30882: @2274062
     /* 2274062 */   GIM_Reject,
     /* 2274063 */ // Label 30880: @2274063
     /* 2274063 */ GIM_Reject,
     /* 2274064 */ // Label 30829: @2274064
     /* 2274064 */ GIM_Try, /*On fail goto*//*Label 30883*/ GIMT_Encode4(2274184),
     /* 2274069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2274072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2274075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274083 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274087 */   GIM_Try, /*On fail goto*//*Label 30884*/ GIMT_Encode4(2274135), // Rule ID 52314 //
     /* 2274092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274095 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2274098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274130 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274134 */     // GIR_Coverage, 52314,
     /* 2274134 */     GIR_EraseRootFromParent_Done,
     /* 2274135 */   // Label 30884: @2274135
     /* 2274135 */   GIM_Try, /*On fail goto*//*Label 30885*/ GIMT_Encode4(2274183), // Rule ID 52315 //
     /* 2274140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274143 */     // (saddsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2274146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274167 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274178 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274181 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274182 */     // GIR_Coverage, 52315,
     /* 2274182 */     GIR_EraseRootFromParent_Done,
     /* 2274183 */   // Label 30885: @2274183
     /* 2274183 */   GIM_Reject,
     /* 2274184 */ // Label 30883: @2274184
     /* 2274184 */ GIM_Reject,
     /* 2274185 */ // Label 30830: @2274185
     /* 2274185 */ GIM_Try, /*On fail goto*//*Label 30886*/ GIMT_Encode4(2274305),
     /* 2274190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2274193 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2274196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274204 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274208 */   GIM_Try, /*On fail goto*//*Label 30887*/ GIMT_Encode4(2274256), // Rule ID 52330 //
     /* 2274213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2274216 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2274219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274255 */     // GIR_Coverage, 52330,
     /* 2274255 */     GIR_EraseRootFromParent_Done,
     /* 2274256 */   // Label 30887: @2274256
     /* 2274256 */   GIM_Try, /*On fail goto*//*Label 30888*/ GIMT_Encode4(2274304), // Rule ID 52331 //
     /* 2274261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2274264 */     // (saddsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2274267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274288 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2274296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274299 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274302 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274303 */     // GIR_Coverage, 52331,
     /* 2274303 */     GIR_EraseRootFromParent_Done,
     /* 2274304 */   // Label 30888: @2274304
     /* 2274304 */   GIM_Reject,
     /* 2274305 */ // Label 30886: @2274305
     /* 2274305 */ GIM_Reject,
     /* 2274306 */ // Label 30831: @2274306
     /* 2274306 */ GIM_Try, /*On fail goto*//*Label 30889*/ GIMT_Encode4(2274426),
     /* 2274311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2274314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2274317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274321 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274325 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2274329 */   GIM_Try, /*On fail goto*//*Label 30890*/ GIMT_Encode4(2274377), // Rule ID 52286 //
     /* 2274334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274337 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2274340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2274354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274376 */     // GIR_Coverage, 52286,
     /* 2274376 */     GIR_EraseRootFromParent_Done,
     /* 2274377 */   // Label 30890: @2274377
     /* 2274377 */   GIM_Try, /*On fail goto*//*Label 30891*/ GIMT_Encode4(2274425), // Rule ID 52287 //
     /* 2274382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274385 */     // (saddsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSADD_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2274388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M2),
     /* 2274402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274420 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274424 */     // GIR_Coverage, 52287,
     /* 2274424 */     GIR_EraseRootFromParent_Done,
     /* 2274425 */   // Label 30891: @2274425
     /* 2274425 */   GIM_Reject,
     /* 2274426 */ // Label 30889: @2274426
     /* 2274426 */ GIM_Reject,
     /* 2274427 */ // Label 30832: @2274427
     /* 2274427 */ GIM_Try, /*On fail goto*//*Label 30892*/ GIMT_Encode4(2274547),
     /* 2274432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2274435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2274438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274450 */   GIM_Try, /*On fail goto*//*Label 30893*/ GIMT_Encode4(2274498), // Rule ID 52302 //
     /* 2274455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274458 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2274461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274497 */     // GIR_Coverage, 52302,
     /* 2274497 */     GIR_EraseRootFromParent_Done,
     /* 2274498 */   // Label 30893: @2274498
     /* 2274498 */   GIM_Try, /*On fail goto*//*Label 30894*/ GIMT_Encode4(2274546), // Rule ID 52303 //
     /* 2274503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274506 */     // (saddsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274506 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2274509 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274513 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274530 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274545 */     // GIR_Coverage, 52303,
     /* 2274545 */     GIR_EraseRootFromParent_Done,
     /* 2274546 */   // Label 30894: @2274546
     /* 2274546 */   GIM_Reject,
     /* 2274547 */ // Label 30892: @2274547
     /* 2274547 */ GIM_Reject,
     /* 2274548 */ // Label 30833: @2274548
     /* 2274548 */ GIM_Try, /*On fail goto*//*Label 30895*/ GIMT_Encode4(2274668),
     /* 2274553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2274556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2274559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274571 */   GIM_Try, /*On fail goto*//*Label 30896*/ GIMT_Encode4(2274619), // Rule ID 52318 //
     /* 2274576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274579 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2274582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274614 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274618 */     // GIR_Coverage, 52318,
     /* 2274618 */     GIR_EraseRootFromParent_Done,
     /* 2274619 */   // Label 30896: @2274619
     /* 2274619 */   GIM_Try, /*On fail goto*//*Label 30897*/ GIMT_Encode4(2274667), // Rule ID 52319 //
     /* 2274624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274627 */     // (saddsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2274630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2274659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274662 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274666 */     // GIR_Coverage, 52319,
     /* 2274666 */     GIR_EraseRootFromParent_Done,
     /* 2274667 */   // Label 30897: @2274667
     /* 2274667 */   GIM_Reject,
     /* 2274668 */ // Label 30895: @2274668
     /* 2274668 */ GIM_Reject,
     /* 2274669 */ // Label 30834: @2274669
     /* 2274669 */ GIM_Try, /*On fail goto*//*Label 30898*/ GIMT_Encode4(2274789),
     /* 2274674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2274677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2274680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274688 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2274692 */   GIM_Try, /*On fail goto*//*Label 30899*/ GIMT_Encode4(2274740), // Rule ID 52290 //
     /* 2274697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274700 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2274703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274735 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274739 */     // GIR_Coverage, 52290,
     /* 2274739 */     GIR_EraseRootFromParent_Done,
     /* 2274740 */   // Label 30899: @2274740
     /* 2274740 */   GIM_Try, /*On fail goto*//*Label 30900*/ GIMT_Encode4(2274788), // Rule ID 52291 //
     /* 2274745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274748 */     // (saddsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSADD_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2274751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M4),
     /* 2274765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274783 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274787 */     // GIR_Coverage, 52291,
     /* 2274787 */     GIR_EraseRootFromParent_Done,
     /* 2274788 */   // Label 30900: @2274788
     /* 2274788 */   GIM_Reject,
     /* 2274789 */ // Label 30898: @2274789
     /* 2274789 */ GIM_Reject,
     /* 2274790 */ // Label 30835: @2274790
     /* 2274790 */ GIM_Try, /*On fail goto*//*Label 30901*/ GIMT_Encode4(2274910),
     /* 2274795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2274798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2274801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274813 */   GIM_Try, /*On fail goto*//*Label 30902*/ GIMT_Encode4(2274861), // Rule ID 52306 //
     /* 2274818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274821 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2274824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274856 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274860 */     // GIR_Coverage, 52306,
     /* 2274860 */     GIR_EraseRootFromParent_Done,
     /* 2274861 */   // Label 30902: @2274861
     /* 2274861 */   GIM_Try, /*On fail goto*//*Label 30903*/ GIMT_Encode4(2274909), // Rule ID 52307 //
     /* 2274866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274869 */     // (saddsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2274872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2274901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274904 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274908 */     // GIR_Coverage, 52307,
     /* 2274908 */     GIR_EraseRootFromParent_Done,
     /* 2274909 */   // Label 30903: @2274909
     /* 2274909 */   GIM_Reject,
     /* 2274910 */ // Label 30901: @2274910
     /* 2274910 */ GIM_Reject,
     /* 2274911 */ // Label 30836: @2274911
     /* 2274911 */ GIM_Try, /*On fail goto*//*Label 30904*/ GIMT_Encode4(2275031),
     /* 2274916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2274919 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2274922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274930 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2274934 */   GIM_Try, /*On fail goto*//*Label 30905*/ GIMT_Encode4(2274982), // Rule ID 52294 //
     /* 2274939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2274942 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2274942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2274945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2274954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2274956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2274959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2274961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2274964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2274966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2274968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2274971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2274977 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2274980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2274981 */     // GIR_Coverage, 52294,
     /* 2274981 */     GIR_EraseRootFromParent_Done,
     /* 2274982 */   // Label 30905: @2274982
     /* 2274982 */   GIM_Try, /*On fail goto*//*Label 30906*/ GIMT_Encode4(2275030), // Rule ID 52295 //
     /* 2274987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2274990 */     // (saddsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSADD_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2274990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2274993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2274997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSADD_VV_M8),
     /* 2275007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275014 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275025 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275029 */     // GIR_Coverage, 52295,
     /* 2275029 */     GIR_EraseRootFromParent_Done,
     /* 2275030 */   // Label 30906: @2275030
     /* 2275030 */   GIM_Reject,
     /* 2275031 */ // Label 30904: @2275031
     /* 2275031 */ GIM_Reject,
     /* 2275032 */ // Label 30837: @2275032
     /* 2275032 */ GIM_Reject,
     /* 2275033 */ // Label 55: @2275033
     /* 2275033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 30930*/ GIMT_Encode4(2277885),
     /* 2275044 */ /*GILLT_s32*//*Label 30907*/ GIMT_Encode4(2275168), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2275056 */ /*GILLT_nxv1s8*//*Label 30908*/ GIMT_Encode4(2275223),
     /* 2275060 */ /*GILLT_nxv1s16*//*Label 30909*/ GIMT_Encode4(2275344),
     /* 2275064 */ /*GILLT_nxv1s32*//*Label 30910*/ GIMT_Encode4(2275465),
     /* 2275068 */ /*GILLT_nxv1s64*//*Label 30911*/ GIMT_Encode4(2275586), GIMT_Encode4(0),
     /* 2275076 */ /*GILLT_nxv2s8*//*Label 30912*/ GIMT_Encode4(2275707),
     /* 2275080 */ /*GILLT_nxv2s16*//*Label 30913*/ GIMT_Encode4(2275828),
     /* 2275084 */ /*GILLT_nxv2s32*//*Label 30914*/ GIMT_Encode4(2275949),
     /* 2275088 */ /*GILLT_nxv2s64*//*Label 30915*/ GIMT_Encode4(2276070), GIMT_Encode4(0),
     /* 2275096 */ /*GILLT_nxv4s8*//*Label 30916*/ GIMT_Encode4(2276191),
     /* 2275100 */ /*GILLT_nxv4s16*//*Label 30917*/ GIMT_Encode4(2276312),
     /* 2275104 */ /*GILLT_nxv4s32*//*Label 30918*/ GIMT_Encode4(2276433),
     /* 2275108 */ /*GILLT_nxv4s64*//*Label 30919*/ GIMT_Encode4(2276554), GIMT_Encode4(0),
     /* 2275116 */ /*GILLT_nxv8s8*//*Label 30920*/ GIMT_Encode4(2276675),
     /* 2275120 */ /*GILLT_nxv8s16*//*Label 30921*/ GIMT_Encode4(2276796),
     /* 2275124 */ /*GILLT_nxv8s32*//*Label 30922*/ GIMT_Encode4(2276917),
     /* 2275128 */ /*GILLT_nxv8s64*//*Label 30923*/ GIMT_Encode4(2277038), GIMT_Encode4(0),
     /* 2275136 */ /*GILLT_nxv16s8*//*Label 30924*/ GIMT_Encode4(2277159),
     /* 2275140 */ /*GILLT_nxv16s16*//*Label 30925*/ GIMT_Encode4(2277280),
     /* 2275144 */ /*GILLT_nxv16s32*//*Label 30926*/ GIMT_Encode4(2277401), GIMT_Encode4(0),
     /* 2275152 */ /*GILLT_nxv32s8*//*Label 30927*/ GIMT_Encode4(2277522),
     /* 2275156 */ /*GILLT_nxv32s16*//*Label 30928*/ GIMT_Encode4(2277643), GIMT_Encode4(0),
     /* 2275164 */ /*GILLT_nxv64s8*//*Label 30929*/ GIMT_Encode4(2277764),
     /* 2275168 */ // Label 30907: @2275168
     /* 2275168 */ GIM_Try, /*On fail goto*//*Label 30931*/ GIMT_Encode4(2275222),
     /* 2275173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2275176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2275179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2275191 */   GIM_Try, /*On fail goto*//*Label 30932*/ GIMT_Encode4(2275206), // Rule ID 64553 //
     /* 2275196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2275199 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2275199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2275204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275205 */     // GIR_Coverage, 64553,
     /* 2275205 */     GIR_Done,
     /* 2275206 */   // Label 30932: @2275206
     /* 2275206 */   GIM_Try, /*On fail goto*//*Label 30933*/ GIMT_Encode4(2275221), // Rule ID 64554 //
     /* 2275211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2275214 */     // (usubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2275214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBUSAT),
     /* 2275219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275220 */     // GIR_Coverage, 64554,
     /* 2275220 */     GIR_Done,
     /* 2275221 */   // Label 30933: @2275221
     /* 2275221 */   GIM_Reject,
     /* 2275222 */ // Label 30931: @2275222
     /* 2275222 */ GIM_Reject,
     /* 2275223 */ // Label 30908: @2275223
     /* 2275223 */ GIM_Try, /*On fail goto*//*Label 30934*/ GIMT_Encode4(2275343),
     /* 2275228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2275231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2275234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275246 */   GIM_Try, /*On fail goto*//*Label 30935*/ GIMT_Encode4(2275294), // Rule ID 52598 //
     /* 2275251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275254 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2275271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275289 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275293 */     // GIR_Coverage, 52598,
     /* 2275293 */     GIR_EraseRootFromParent_Done,
     /* 2275294 */   // Label 30935: @2275294
     /* 2275294 */   GIM_Try, /*On fail goto*//*Label 30936*/ GIMT_Encode4(2275342), // Rule ID 52599 //
     /* 2275299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275302 */     // (usubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275302 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2275305 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275309 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF8),
     /* 2275319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275321 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275324 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275326 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275337 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275341 */     // GIR_Coverage, 52599,
     /* 2275341 */     GIR_EraseRootFromParent_Done,
     /* 2275342 */   // Label 30936: @2275342
     /* 2275342 */   GIM_Reject,
     /* 2275343 */ // Label 30934: @2275343
     /* 2275343 */ GIM_Reject,
     /* 2275344 */ // Label 30909: @2275344
     /* 2275344 */ GIM_Try, /*On fail goto*//*Label 30937*/ GIMT_Encode4(2275464),
     /* 2275349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2275352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2275355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275367 */   GIM_Try, /*On fail goto*//*Label 30938*/ GIMT_Encode4(2275415), // Rule ID 52610 //
     /* 2275372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275375 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275375 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275378 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275382 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2275392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275397 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275410 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275414 */     // GIR_Coverage, 52610,
     /* 2275414 */     GIR_EraseRootFromParent_Done,
     /* 2275415 */   // Label 30938: @2275415
     /* 2275415 */   GIM_Try, /*On fail goto*//*Label 30939*/ GIMT_Encode4(2275463), // Rule ID 52611 //
     /* 2275420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275423 */     // (usubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2275426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2275440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275458 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275462 */     // GIR_Coverage, 52611,
     /* 2275462 */     GIR_EraseRootFromParent_Done,
     /* 2275463 */   // Label 30939: @2275463
     /* 2275463 */   GIM_Reject,
     /* 2275464 */ // Label 30937: @2275464
     /* 2275464 */ GIM_Reject,
     /* 2275465 */ // Label 30910: @2275465
     /* 2275465 */ GIM_Try, /*On fail goto*//*Label 30940*/ GIMT_Encode4(2275585),
     /* 2275470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2275473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2275476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275484 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275488 */   GIM_Try, /*On fail goto*//*Label 30941*/ GIMT_Encode4(2275536), // Rule ID 52618 //
     /* 2275493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275496 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2275513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275534 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275535 */     // GIR_Coverage, 52618,
     /* 2275535 */     GIR_EraseRootFromParent_Done,
     /* 2275536 */   // Label 30941: @2275536
     /* 2275536 */   GIM_Try, /*On fail goto*//*Label 30942*/ GIMT_Encode4(2275584), // Rule ID 52619 //
     /* 2275541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275544 */     // (usubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2275547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275556 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2275561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2275576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275579 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275583 */     // GIR_Coverage, 52619,
     /* 2275583 */     GIR_EraseRootFromParent_Done,
     /* 2275584 */   // Label 30942: @2275584
     /* 2275584 */   GIM_Reject,
     /* 2275585 */ // Label 30940: @2275585
     /* 2275585 */ GIM_Reject,
     /* 2275586 */ // Label 30911: @2275586
     /* 2275586 */ GIM_Try, /*On fail goto*//*Label 30943*/ GIMT_Encode4(2275706),
     /* 2275591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2275594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2275597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275609 */   GIM_Try, /*On fail goto*//*Label 30944*/ GIMT_Encode4(2275657), // Rule ID 52634 //
     /* 2275614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2275617 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2275634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275641 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275652 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275655 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275656 */     // GIR_Coverage, 52634,
     /* 2275656 */     GIR_EraseRootFromParent_Done,
     /* 2275657 */   // Label 30944: @2275657
     /* 2275657 */   GIM_Try, /*On fail goto*//*Label 30945*/ GIMT_Encode4(2275705), // Rule ID 52635 //
     /* 2275662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2275665 */     // (usubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2275668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2275682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275687 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275689 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2275697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275700 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275704 */     // GIR_Coverage, 52635,
     /* 2275704 */     GIR_EraseRootFromParent_Done,
     /* 2275705 */   // Label 30945: @2275705
     /* 2275705 */   GIM_Reject,
     /* 2275706 */ // Label 30943: @2275706
     /* 2275706 */ GIM_Reject,
     /* 2275707 */ // Label 30912: @2275707
     /* 2275707 */ GIM_Try, /*On fail goto*//*Label 30946*/ GIMT_Encode4(2275827),
     /* 2275712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2275715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2275718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275726 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275730 */   GIM_Try, /*On fail goto*//*Label 30947*/ GIMT_Encode4(2275778), // Rule ID 52602 //
     /* 2275735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275738 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2275741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2275755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275777 */     // GIR_Coverage, 52602,
     /* 2275777 */     GIR_EraseRootFromParent_Done,
     /* 2275778 */   // Label 30947: @2275778
     /* 2275778 */   GIM_Try, /*On fail goto*//*Label 30948*/ GIMT_Encode4(2275826), // Rule ID 52603 //
     /* 2275783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275786 */     // (usubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2275789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF4),
     /* 2275803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275821 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275825 */     // GIR_Coverage, 52603,
     /* 2275825 */     GIR_EraseRootFromParent_Done,
     /* 2275826 */   // Label 30948: @2275826
     /* 2275826 */   GIM_Reject,
     /* 2275827 */ // Label 30946: @2275827
     /* 2275827 */ GIM_Reject,
     /* 2275828 */ // Label 30913: @2275828
     /* 2275828 */ GIM_Try, /*On fail goto*//*Label 30949*/ GIMT_Encode4(2275948),
     /* 2275833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2275836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2275839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275851 */   GIM_Try, /*On fail goto*//*Label 30950*/ GIMT_Encode4(2275899), // Rule ID 52614 //
     /* 2275856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275859 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2275862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2275876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275883 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275894 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275898 */     // GIR_Coverage, 52614,
     /* 2275898 */     GIR_EraseRootFromParent_Done,
     /* 2275899 */   // Label 30950: @2275899
     /* 2275899 */   GIM_Try, /*On fail goto*//*Label 30951*/ GIMT_Encode4(2275947), // Rule ID 52615 //
     /* 2275904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2275907 */     // (usubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2275907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2275910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2275924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2275929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2275931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2275933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2275936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2275939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2275942 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2275945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2275946 */     // GIR_Coverage, 52615,
     /* 2275946 */     GIR_EraseRootFromParent_Done,
     /* 2275947 */   // Label 30951: @2275947
     /* 2275947 */   GIM_Reject,
     /* 2275948 */ // Label 30949: @2275948
     /* 2275948 */ GIM_Reject,
     /* 2275949 */ // Label 30914: @2275949
     /* 2275949 */ GIM_Try, /*On fail goto*//*Label 30952*/ GIMT_Encode4(2276069),
     /* 2275954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2275957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2275960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275968 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2275972 */   GIM_Try, /*On fail goto*//*Label 30953*/ GIMT_Encode4(2276020), // Rule ID 52630 //
     /* 2275977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2275980 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2275980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2275983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2275987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2275992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2275994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2275997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2275999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276015 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276019 */     // GIR_Coverage, 52630,
     /* 2276019 */     GIR_EraseRootFromParent_Done,
     /* 2276020 */   // Label 30953: @2276020
     /* 2276020 */   GIM_Try, /*On fail goto*//*Label 30954*/ GIMT_Encode4(2276068), // Rule ID 52631 //
     /* 2276025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276028 */     // (usubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2276031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2276045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276050 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276052 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276063 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276067 */     // GIR_Coverage, 52631,
     /* 2276067 */     GIR_EraseRootFromParent_Done,
     /* 2276068 */   // Label 30954: @2276068
     /* 2276068 */   GIM_Reject,
     /* 2276069 */ // Label 30952: @2276069
     /* 2276069 */ GIM_Reject,
     /* 2276070 */ // Label 30915: @2276070
     /* 2276070 */ GIM_Try, /*On fail goto*//*Label 30955*/ GIMT_Encode4(2276190),
     /* 2276075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2276078 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2276081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276089 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276093 */   GIM_Try, /*On fail goto*//*Label 30956*/ GIMT_Encode4(2276141), // Rule ID 52674 //
     /* 2276098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276101 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276125 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276136 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276140 */     // GIR_Coverage, 52674,
     /* 2276140 */     GIR_EraseRootFromParent_Done,
     /* 2276141 */   // Label 30956: @2276141
     /* 2276141 */   GIM_Try, /*On fail goto*//*Label 30957*/ GIMT_Encode4(2276189), // Rule ID 52675 //
     /* 2276146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276149 */     // (usubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2276152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276184 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276188 */     // GIR_Coverage, 52675,
     /* 2276188 */     GIR_EraseRootFromParent_Done,
     /* 2276189 */   // Label 30957: @2276189
     /* 2276189 */   GIM_Reject,
     /* 2276190 */ // Label 30955: @2276190
     /* 2276190 */ GIM_Reject,
     /* 2276191 */ // Label 30916: @2276191
     /* 2276191 */ GIM_Try, /*On fail goto*//*Label 30958*/ GIMT_Encode4(2276311),
     /* 2276196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2276199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2276202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276206 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276210 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276214 */   GIM_Try, /*On fail goto*//*Label 30959*/ GIMT_Encode4(2276262), // Rule ID 52606 //
     /* 2276219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276222 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276222 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2276225 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276229 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2276239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276257 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276261 */     // GIR_Coverage, 52606,
     /* 2276261 */     GIR_EraseRootFromParent_Done,
     /* 2276262 */   // Label 30959: @2276262
     /* 2276262 */   GIM_Try, /*On fail goto*//*Label 30960*/ GIMT_Encode4(2276310), // Rule ID 52607 //
     /* 2276267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276270 */     // (usubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUBU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2276273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_MF2),
     /* 2276287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276305 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276308 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276309 */     // GIR_Coverage, 52607,
     /* 2276309 */     GIR_EraseRootFromParent_Done,
     /* 2276310 */   // Label 30960: @2276310
     /* 2276310 */   GIM_Reject,
     /* 2276311 */ // Label 30958: @2276311
     /* 2276311 */ GIM_Reject,
     /* 2276312 */ // Label 30917: @2276312
     /* 2276312 */ GIM_Try, /*On fail goto*//*Label 30961*/ GIMT_Encode4(2276432),
     /* 2276317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2276320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2276323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276331 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276335 */   GIM_Try, /*On fail goto*//*Label 30962*/ GIMT_Encode4(2276383), // Rule ID 52626 //
     /* 2276340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276343 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2276360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276378 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276382 */     // GIR_Coverage, 52626,
     /* 2276382 */     GIR_EraseRootFromParent_Done,
     /* 2276383 */   // Label 30962: @2276383
     /* 2276383 */   GIM_Try, /*On fail goto*//*Label 30963*/ GIMT_Encode4(2276431), // Rule ID 52627 //
     /* 2276388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276391 */     // (usubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2276394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2276408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276415 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276426 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276430 */     // GIR_Coverage, 52627,
     /* 2276430 */     GIR_EraseRootFromParent_Done,
     /* 2276431 */   // Label 30963: @2276431
     /* 2276431 */   GIM_Reject,
     /* 2276432 */ // Label 30961: @2276432
     /* 2276432 */ GIM_Reject,
     /* 2276433 */ // Label 30918: @2276433
     /* 2276433 */ GIM_Try, /*On fail goto*//*Label 30964*/ GIMT_Encode4(2276553),
     /* 2276438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2276441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2276444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276452 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276456 */   GIM_Try, /*On fail goto*//*Label 30965*/ GIMT_Encode4(2276504), // Rule ID 52662 //
     /* 2276461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276464 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276464 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2276467 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276471 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276483 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276486 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276488 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276499 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276503 */     // GIR_Coverage, 52662,
     /* 2276503 */     GIR_EraseRootFromParent_Done,
     /* 2276504 */   // Label 30965: @2276504
     /* 2276504 */   GIM_Try, /*On fail goto*//*Label 30966*/ GIMT_Encode4(2276552), // Rule ID 52663 //
     /* 2276509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276512 */     // (usubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2276515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276531 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276534 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276536 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276547 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276551 */     // GIR_Coverage, 52663,
     /* 2276551 */     GIR_EraseRootFromParent_Done,
     /* 2276552 */   // Label 30966: @2276552
     /* 2276552 */   GIM_Reject,
     /* 2276553 */ // Label 30964: @2276553
     /* 2276553 */ GIM_Reject,
     /* 2276554 */ // Label 30919: @2276554
     /* 2276554 */ GIM_Try, /*On fail goto*//*Label 30967*/ GIMT_Encode4(2276674),
     /* 2276559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2276562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2276565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276573 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276577 */   GIM_Try, /*On fail goto*//*Label 30968*/ GIMT_Encode4(2276625), // Rule ID 52678 //
     /* 2276582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2276585 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2276588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2276602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276620 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276624 */     // GIR_Coverage, 52678,
     /* 2276624 */     GIR_EraseRootFromParent_Done,
     /* 2276625 */   // Label 30968: @2276625
     /* 2276625 */   GIM_Try, /*On fail goto*//*Label 30969*/ GIMT_Encode4(2276673), // Rule ID 52679 //
     /* 2276630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2276633 */     // (usubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2276636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2276650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2276665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276668 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276672 */     // GIR_Coverage, 52679,
     /* 2276672 */     GIR_EraseRootFromParent_Done,
     /* 2276673 */   // Label 30969: @2276673
     /* 2276673 */   GIM_Reject,
     /* 2276674 */ // Label 30967: @2276674
     /* 2276674 */ GIM_Reject,
     /* 2276675 */ // Label 30920: @2276675
     /* 2276675 */ GIM_Try, /*On fail goto*//*Label 30970*/ GIMT_Encode4(2276795),
     /* 2276680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2276683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2276686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2276698 */   GIM_Try, /*On fail goto*//*Label 30971*/ GIMT_Encode4(2276746), // Rule ID 52622 //
     /* 2276703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276706 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2276709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2276723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276728 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276730 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276741 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276745 */     // GIR_Coverage, 52622,
     /* 2276745 */     GIR_EraseRootFromParent_Done,
     /* 2276746 */   // Label 30971: @2276746
     /* 2276746 */   GIM_Try, /*On fail goto*//*Label 30972*/ GIMT_Encode4(2276794), // Rule ID 52623 //
     /* 2276751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276754 */     // (usubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2276757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M1),
     /* 2276771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276789 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276793 */     // GIR_Coverage, 52623,
     /* 2276793 */     GIR_EraseRootFromParent_Done,
     /* 2276794 */   // Label 30972: @2276794
     /* 2276794 */   GIM_Reject,
     /* 2276795 */ // Label 30970: @2276795
     /* 2276795 */ GIM_Reject,
     /* 2276796 */ // Label 30921: @2276796
     /* 2276796 */ GIM_Try, /*On fail goto*//*Label 30973*/ GIMT_Encode4(2276916),
     /* 2276801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2276804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2276807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276815 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2276819 */   GIM_Try, /*On fail goto*//*Label 30974*/ GIMT_Encode4(2276867), // Rule ID 52650 //
     /* 2276824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276827 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2276830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276851 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276862 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276866 */     // GIR_Coverage, 52650,
     /* 2276866 */     GIR_EraseRootFromParent_Done,
     /* 2276867 */   // Label 30974: @2276867
     /* 2276867 */   GIM_Try, /*On fail goto*//*Label 30975*/ GIMT_Encode4(2276915), // Rule ID 52651 //
     /* 2276872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276875 */     // (usubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2276878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2276892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276899 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2276907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276914 */     // GIR_Coverage, 52651,
     /* 2276914 */     GIR_EraseRootFromParent_Done,
     /* 2276915 */   // Label 30975: @2276915
     /* 2276915 */   GIM_Reject,
     /* 2276916 */ // Label 30973: @2276916
     /* 2276916 */ GIM_Reject,
     /* 2276917 */ // Label 30922: @2276917
     /* 2276917 */ GIM_Try, /*On fail goto*//*Label 30976*/ GIMT_Encode4(2277037),
     /* 2276922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2276925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2276928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2276940 */   GIM_Try, /*On fail goto*//*Label 30977*/ GIMT_Encode4(2276988), // Rule ID 52666 //
     /* 2276945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2276948 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2276948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2276951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2276955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2276960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2276962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2276965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2276967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2276970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2276972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2276974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2276977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2276980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2276983 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2276986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2276987 */     // GIR_Coverage, 52666,
     /* 2276987 */     GIR_EraseRootFromParent_Done,
     /* 2276988 */   // Label 30977: @2276988
     /* 2276988 */   GIM_Try, /*On fail goto*//*Label 30978*/ GIMT_Encode4(2277036), // Rule ID 52667 //
     /* 2276993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2276996 */     // (usubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2276996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2276999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2277013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277031 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277035 */     // GIR_Coverage, 52667,
     /* 2277035 */     GIR_EraseRootFromParent_Done,
     /* 2277036 */   // Label 30978: @2277036
     /* 2277036 */   GIM_Reject,
     /* 2277037 */ // Label 30976: @2277037
     /* 2277037 */ GIM_Reject,
     /* 2277038 */ // Label 30923: @2277038
     /* 2277038 */ GIM_Try, /*On fail goto*//*Label 30979*/ GIMT_Encode4(2277158),
     /* 2277043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2277046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2277049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277057 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277061 */   GIM_Try, /*On fail goto*//*Label 30980*/ GIMT_Encode4(2277109), // Rule ID 52682 //
     /* 2277066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2277069 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2277072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277093 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277104 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277108 */     // GIR_Coverage, 52682,
     /* 2277108 */     GIR_EraseRootFromParent_Done,
     /* 2277109 */   // Label 30980: @2277109
     /* 2277109 */   GIM_Try, /*On fail goto*//*Label 30981*/ GIMT_Encode4(2277157), // Rule ID 52683 //
     /* 2277114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2277117 */     // (usubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2277120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277139 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2277149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277156 */     // GIR_Coverage, 52683,
     /* 2277156 */     GIR_EraseRootFromParent_Done,
     /* 2277157 */   // Label 30981: @2277157
     /* 2277157 */   GIM_Reject,
     /* 2277158 */ // Label 30979: @2277158
     /* 2277158 */ GIM_Reject,
     /* 2277159 */ // Label 30924: @2277159
     /* 2277159 */ GIM_Try, /*On fail goto*//*Label 30982*/ GIMT_Encode4(2277279),
     /* 2277164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2277167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2277170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2277182 */   GIM_Try, /*On fail goto*//*Label 30983*/ GIMT_Encode4(2277230), // Rule ID 52638 //
     /* 2277187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277190 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2277193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2277207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277212 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277214 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277229 */     // GIR_Coverage, 52638,
     /* 2277229 */     GIR_EraseRootFromParent_Done,
     /* 2277230 */   // Label 30983: @2277230
     /* 2277230 */   GIM_Try, /*On fail goto*//*Label 30984*/ GIMT_Encode4(2277278), // Rule ID 52639 //
     /* 2277235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277238 */     // (usubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2277241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M2),
     /* 2277255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277257 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277260 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277262 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277273 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277277 */     // GIR_Coverage, 52639,
     /* 2277277 */     GIR_EraseRootFromParent_Done,
     /* 2277278 */   // Label 30984: @2277278
     /* 2277278 */   GIM_Reject,
     /* 2277279 */ // Label 30982: @2277279
     /* 2277279 */ GIM_Reject,
     /* 2277280 */ // Label 30925: @2277280
     /* 2277280 */ GIM_Try, /*On fail goto*//*Label 30985*/ GIMT_Encode4(2277400),
     /* 2277285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2277288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2277291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277303 */   GIM_Try, /*On fail goto*//*Label 30986*/ GIMT_Encode4(2277351), // Rule ID 52654 //
     /* 2277308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277311 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2277314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277323 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2277328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277333 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277335 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277346 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277350 */     // GIR_Coverage, 52654,
     /* 2277350 */     GIR_EraseRootFromParent_Done,
     /* 2277351 */   // Label 30986: @2277351
     /* 2277351 */   GIM_Try, /*On fail goto*//*Label 30987*/ GIMT_Encode4(2277399), // Rule ID 52655 //
     /* 2277356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277359 */     // (usubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2277362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2277376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277398 */     // GIR_Coverage, 52655,
     /* 2277398 */     GIR_EraseRootFromParent_Done,
     /* 2277399 */   // Label 30987: @2277399
     /* 2277399 */   GIM_Reject,
     /* 2277400 */ // Label 30985: @2277400
     /* 2277400 */ GIM_Reject,
     /* 2277401 */ // Label 30926: @2277401
     /* 2277401 */ GIM_Try, /*On fail goto*//*Label 30988*/ GIMT_Encode4(2277521),
     /* 2277406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2277409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2277412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277420 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277424 */   GIM_Try, /*On fail goto*//*Label 30989*/ GIMT_Encode4(2277472), // Rule ID 52670 //
     /* 2277429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277432 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2277435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277456 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277467 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277471 */     // GIR_Coverage, 52670,
     /* 2277471 */     GIR_EraseRootFromParent_Done,
     /* 2277472 */   // Label 30989: @2277472
     /* 2277472 */   GIM_Try, /*On fail goto*//*Label 30990*/ GIMT_Encode4(2277520), // Rule ID 52671 //
     /* 2277477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277480 */     // (usubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2277483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277504 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2277512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277519 */     // GIR_Coverage, 52671,
     /* 2277519 */     GIR_EraseRootFromParent_Done,
     /* 2277520 */   // Label 30990: @2277520
     /* 2277520 */   GIM_Reject,
     /* 2277521 */ // Label 30988: @2277521
     /* 2277521 */ GIM_Reject,
     /* 2277522 */ // Label 30927: @2277522
     /* 2277522 */ GIM_Try, /*On fail goto*//*Label 30991*/ GIMT_Encode4(2277642),
     /* 2277527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2277530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2277533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2277545 */   GIM_Try, /*On fail goto*//*Label 30992*/ GIMT_Encode4(2277593), // Rule ID 52642 //
     /* 2277550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277553 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2277556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2277570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277575 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277588 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277592 */     // GIR_Coverage, 52642,
     /* 2277592 */     GIR_EraseRootFromParent_Done,
     /* 2277593 */   // Label 30992: @2277593
     /* 2277593 */   GIM_Try, /*On fail goto*//*Label 30993*/ GIMT_Encode4(2277641), // Rule ID 52643 //
     /* 2277598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277601 */     // (usubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2277604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M4),
     /* 2277618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277636 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277640 */     // GIR_Coverage, 52643,
     /* 2277640 */     GIR_EraseRootFromParent_Done,
     /* 2277641 */   // Label 30993: @2277641
     /* 2277641 */   GIM_Reject,
     /* 2277642 */ // Label 30991: @2277642
     /* 2277642 */ GIM_Reject,
     /* 2277643 */ // Label 30928: @2277643
     /* 2277643 */ GIM_Try, /*On fail goto*//*Label 30994*/ GIMT_Encode4(2277763),
     /* 2277648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2277651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2277654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277666 */   GIM_Try, /*On fail goto*//*Label 30995*/ GIMT_Encode4(2277714), // Rule ID 52658 //
     /* 2277671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277674 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2277677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277709 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277713 */     // GIR_Coverage, 52658,
     /* 2277713 */     GIR_EraseRootFromParent_Done,
     /* 2277714 */   // Label 30995: @2277714
     /* 2277714 */   GIM_Try, /*On fail goto*//*Label 30996*/ GIMT_Encode4(2277762), // Rule ID 52659 //
     /* 2277719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277722 */     // (usubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2277725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2277754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277757 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277761 */     // GIR_Coverage, 52659,
     /* 2277761 */     GIR_EraseRootFromParent_Done,
     /* 2277762 */   // Label 30996: @2277762
     /* 2277762 */   GIM_Reject,
     /* 2277763 */ // Label 30994: @2277763
     /* 2277763 */ GIM_Reject,
     /* 2277764 */ // Label 30929: @2277764
     /* 2277764 */ GIM_Try, /*On fail goto*//*Label 30997*/ GIMT_Encode4(2277884),
     /* 2277769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2277772 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2277775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277783 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2277787 */   GIM_Try, /*On fail goto*//*Label 30998*/ GIMT_Encode4(2277835), // Rule ID 52646 //
     /* 2277792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2277795 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2277795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2277798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277817 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277819 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277834 */     // GIR_Coverage, 52646,
     /* 2277834 */     GIR_EraseRootFromParent_Done,
     /* 2277835 */   // Label 30998: @2277835
     /* 2277835 */   GIM_Try, /*On fail goto*//*Label 30999*/ GIMT_Encode4(2277883), // Rule ID 52647 //
     /* 2277840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2277843 */     // (usubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUBU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2277843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2277846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2277850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2277855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2277857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUBU_VV_M8),
     /* 2277860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2277862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2277865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2277867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2277869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2277872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2277878 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2277881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2277882 */     // GIR_Coverage, 52647,
     /* 2277882 */     GIR_EraseRootFromParent_Done,
     /* 2277883 */   // Label 30999: @2277883
     /* 2277883 */   GIM_Reject,
     /* 2277884 */ // Label 30997: @2277884
     /* 2277884 */ GIM_Reject,
     /* 2277885 */ // Label 30930: @2277885
     /* 2277885 */ GIM_Reject,
     /* 2277886 */ // Label 56: @2277886
     /* 2277886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 31023*/ GIMT_Encode4(2280738),
     /* 2277897 */ /*GILLT_s32*//*Label 31000*/ GIMT_Encode4(2278021), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2277909 */ /*GILLT_nxv1s8*//*Label 31001*/ GIMT_Encode4(2278076),
     /* 2277913 */ /*GILLT_nxv1s16*//*Label 31002*/ GIMT_Encode4(2278197),
     /* 2277917 */ /*GILLT_nxv1s32*//*Label 31003*/ GIMT_Encode4(2278318),
     /* 2277921 */ /*GILLT_nxv1s64*//*Label 31004*/ GIMT_Encode4(2278439), GIMT_Encode4(0),
     /* 2277929 */ /*GILLT_nxv2s8*//*Label 31005*/ GIMT_Encode4(2278560),
     /* 2277933 */ /*GILLT_nxv2s16*//*Label 31006*/ GIMT_Encode4(2278681),
     /* 2277937 */ /*GILLT_nxv2s32*//*Label 31007*/ GIMT_Encode4(2278802),
     /* 2277941 */ /*GILLT_nxv2s64*//*Label 31008*/ GIMT_Encode4(2278923), GIMT_Encode4(0),
     /* 2277949 */ /*GILLT_nxv4s8*//*Label 31009*/ GIMT_Encode4(2279044),
     /* 2277953 */ /*GILLT_nxv4s16*//*Label 31010*/ GIMT_Encode4(2279165),
     /* 2277957 */ /*GILLT_nxv4s32*//*Label 31011*/ GIMT_Encode4(2279286),
     /* 2277961 */ /*GILLT_nxv4s64*//*Label 31012*/ GIMT_Encode4(2279407), GIMT_Encode4(0),
     /* 2277969 */ /*GILLT_nxv8s8*//*Label 31013*/ GIMT_Encode4(2279528),
     /* 2277973 */ /*GILLT_nxv8s16*//*Label 31014*/ GIMT_Encode4(2279649),
     /* 2277977 */ /*GILLT_nxv8s32*//*Label 31015*/ GIMT_Encode4(2279770),
     /* 2277981 */ /*GILLT_nxv8s64*//*Label 31016*/ GIMT_Encode4(2279891), GIMT_Encode4(0),
     /* 2277989 */ /*GILLT_nxv16s8*//*Label 31017*/ GIMT_Encode4(2280012),
     /* 2277993 */ /*GILLT_nxv16s16*//*Label 31018*/ GIMT_Encode4(2280133),
     /* 2277997 */ /*GILLT_nxv16s32*//*Label 31019*/ GIMT_Encode4(2280254), GIMT_Encode4(0),
     /* 2278005 */ /*GILLT_nxv32s8*//*Label 31020*/ GIMT_Encode4(2280375),
     /* 2278009 */ /*GILLT_nxv32s16*//*Label 31021*/ GIMT_Encode4(2280496), GIMT_Encode4(0),
     /* 2278017 */ /*GILLT_nxv64s8*//*Label 31022*/ GIMT_Encode4(2280617),
     /* 2278021 */ // Label 31000: @2278021
     /* 2278021 */ GIM_Try, /*On fail goto*//*Label 31024*/ GIMT_Encode4(2278075),
     /* 2278026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2278029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2278032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2278044 */   GIM_Try, /*On fail goto*//*Label 31025*/ GIMT_Encode4(2278059), // Rule ID 64551 //
     /* 2278049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2278052 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2278052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2278057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278058 */     // GIR_Coverage, 64551,
     /* 2278058 */     GIR_Done,
     /* 2278059 */   // Label 31025: @2278059
     /* 2278059 */   GIM_Try, /*On fail goto*//*Label 31026*/ GIMT_Encode4(2278074), // Rule ID 64552 //
     /* 2278064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2278067 */     // (ssubsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SUBSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2278067 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SUBSAT),
     /* 2278072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278073 */     // GIR_Coverage, 64552,
     /* 2278073 */     GIR_Done,
     /* 2278074 */   // Label 31026: @2278074
     /* 2278074 */   GIM_Reject,
     /* 2278075 */ // Label 31024: @2278075
     /* 2278075 */ GIM_Reject,
     /* 2278076 */ // Label 31001: @2278076
     /* 2278076 */ GIM_Try, /*On fail goto*//*Label 31027*/ GIMT_Encode4(2278196),
     /* 2278081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2278084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2278087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278099 */   GIM_Try, /*On fail goto*//*Label 31028*/ GIMT_Encode4(2278147), // Rule ID 52510 //
     /* 2278104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278107 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2278110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2278124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278142 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278145 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278146 */     // GIR_Coverage, 52510,
     /* 2278146 */     GIR_EraseRootFromParent_Done,
     /* 2278147 */   // Label 31028: @2278147
     /* 2278147 */   GIM_Try, /*On fail goto*//*Label 31029*/ GIMT_Encode4(2278195), // Rule ID 52511 //
     /* 2278152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278155 */     // (ssubsat:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2278158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF8),
     /* 2278172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278190 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278193 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278194 */     // GIR_Coverage, 52511,
     /* 2278194 */     GIR_EraseRootFromParent_Done,
     /* 2278195 */   // Label 31029: @2278195
     /* 2278195 */   GIM_Reject,
     /* 2278196 */ // Label 31027: @2278196
     /* 2278196 */ GIM_Reject,
     /* 2278197 */ // Label 31002: @2278197
     /* 2278197 */ GIM_Try, /*On fail goto*//*Label 31030*/ GIMT_Encode4(2278317),
     /* 2278202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2278205 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2278208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278216 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278220 */   GIM_Try, /*On fail goto*//*Label 31031*/ GIMT_Encode4(2278268), // Rule ID 52522 //
     /* 2278225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278228 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278228 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2278231 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278235 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2278245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278263 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278267 */     // GIR_Coverage, 52522,
     /* 2278267 */     GIR_EraseRootFromParent_Done,
     /* 2278268 */   // Label 31031: @2278268
     /* 2278268 */   GIM_Try, /*On fail goto*//*Label 31032*/ GIMT_Encode4(2278316), // Rule ID 52523 //
     /* 2278273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278276 */     // (ssubsat:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2278279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2278293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278298 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278300 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278311 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278315 */     // GIR_Coverage, 52523,
     /* 2278315 */     GIR_EraseRootFromParent_Done,
     /* 2278316 */   // Label 31032: @2278316
     /* 2278316 */   GIM_Reject,
     /* 2278317 */ // Label 31030: @2278317
     /* 2278317 */ GIM_Reject,
     /* 2278318 */ // Label 31003: @2278318
     /* 2278318 */ GIM_Try, /*On fail goto*//*Label 31033*/ GIMT_Encode4(2278438),
     /* 2278323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2278326 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2278329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278337 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278341 */   GIM_Try, /*On fail goto*//*Label 31034*/ GIMT_Encode4(2278389), // Rule ID 52530 //
     /* 2278346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278349 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2278366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278368 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278371 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278384 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278388 */     // GIR_Coverage, 52530,
     /* 2278388 */     GIR_EraseRootFromParent_Done,
     /* 2278389 */   // Label 31034: @2278389
     /* 2278389 */   GIM_Try, /*On fail goto*//*Label 31035*/ GIMT_Encode4(2278437), // Rule ID 52531 //
     /* 2278394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278397 */     // (ssubsat:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2278400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2278414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278432 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278436 */     // GIR_Coverage, 52531,
     /* 2278436 */     GIR_EraseRootFromParent_Done,
     /* 2278437 */   // Label 31035: @2278437
     /* 2278437 */   GIM_Reject,
     /* 2278438 */ // Label 31033: @2278438
     /* 2278438 */ GIM_Reject,
     /* 2278439 */ // Label 31004: @2278439
     /* 2278439 */ GIM_Try, /*On fail goto*//*Label 31036*/ GIMT_Encode4(2278559),
     /* 2278444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2278447 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2278450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278458 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278462 */   GIM_Try, /*On fail goto*//*Label 31037*/ GIMT_Encode4(2278510), // Rule ID 52546 //
     /* 2278467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278470 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2278487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278492 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278494 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278508 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278509 */     // GIR_Coverage, 52546,
     /* 2278509 */     GIR_EraseRootFromParent_Done,
     /* 2278510 */   // Label 31037: @2278510
     /* 2278510 */   GIM_Try, /*On fail goto*//*Label 31038*/ GIMT_Encode4(2278558), // Rule ID 52547 //
     /* 2278515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2278518 */     // (ssubsat:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278518 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2278521 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278525 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2278535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278540 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278553 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278557 */     // GIR_Coverage, 52547,
     /* 2278557 */     GIR_EraseRootFromParent_Done,
     /* 2278558 */   // Label 31038: @2278558
     /* 2278558 */   GIM_Reject,
     /* 2278559 */ // Label 31036: @2278559
     /* 2278559 */ GIM_Reject,
     /* 2278560 */ // Label 31005: @2278560
     /* 2278560 */ GIM_Try, /*On fail goto*//*Label 31039*/ GIMT_Encode4(2278680),
     /* 2278565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2278568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2278571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278583 */   GIM_Try, /*On fail goto*//*Label 31040*/ GIMT_Encode4(2278631), // Rule ID 52514 //
     /* 2278588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278591 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2278594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2278608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278626 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278630 */     // GIR_Coverage, 52514,
     /* 2278630 */     GIR_EraseRootFromParent_Done,
     /* 2278631 */   // Label 31040: @2278631
     /* 2278631 */   GIM_Try, /*On fail goto*//*Label 31041*/ GIMT_Encode4(2278679), // Rule ID 52515 //
     /* 2278636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278639 */     // (ssubsat:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2278642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF4),
     /* 2278656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278674 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278678 */     // GIR_Coverage, 52515,
     /* 2278678 */     GIR_EraseRootFromParent_Done,
     /* 2278679 */   // Label 31041: @2278679
     /* 2278679 */   GIM_Reject,
     /* 2278680 */ // Label 31039: @2278680
     /* 2278680 */ GIM_Reject,
     /* 2278681 */ // Label 31006: @2278681
     /* 2278681 */ GIM_Try, /*On fail goto*//*Label 31042*/ GIMT_Encode4(2278801),
     /* 2278686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2278689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2278692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278704 */   GIM_Try, /*On fail goto*//*Label 31043*/ GIMT_Encode4(2278752), // Rule ID 52526 //
     /* 2278709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278712 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2278729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278731 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278734 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278747 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278751 */     // GIR_Coverage, 52526,
     /* 2278751 */     GIR_EraseRootFromParent_Done,
     /* 2278752 */   // Label 31043: @2278752
     /* 2278752 */   GIM_Try, /*On fail goto*//*Label 31044*/ GIMT_Encode4(2278800), // Rule ID 52527 //
     /* 2278757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278760 */     // (ssubsat:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2278763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2278777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2278792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278795 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278799 */     // GIR_Coverage, 52527,
     /* 2278799 */     GIR_EraseRootFromParent_Done,
     /* 2278800 */   // Label 31044: @2278800
     /* 2278800 */   GIM_Reject,
     /* 2278801 */ // Label 31042: @2278801
     /* 2278801 */ GIM_Reject,
     /* 2278802 */ // Label 31007: @2278802
     /* 2278802 */ GIM_Try, /*On fail goto*//*Label 31045*/ GIMT_Encode4(2278922),
     /* 2278807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2278810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2278813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278821 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2278825 */   GIM_Try, /*On fail goto*//*Label 31046*/ GIMT_Encode4(2278873), // Rule ID 52542 //
     /* 2278830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2278833 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2278850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278857 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278868 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278872 */     // GIR_Coverage, 52542,
     /* 2278872 */     GIR_EraseRootFromParent_Done,
     /* 2278873 */   // Label 31046: @2278873
     /* 2278873 */   GIM_Try, /*On fail goto*//*Label 31047*/ GIMT_Encode4(2278921), // Rule ID 52543 //
     /* 2278878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2278881 */     // (ssubsat:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2278881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2278884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2278898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2278913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278916 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278920 */     // GIR_Coverage, 52543,
     /* 2278920 */     GIR_EraseRootFromParent_Done,
     /* 2278921 */   // Label 31047: @2278921
     /* 2278921 */   GIM_Reject,
     /* 2278922 */ // Label 31045: @2278922
     /* 2278922 */ GIM_Reject,
     /* 2278923 */ // Label 31008: @2278923
     /* 2278923 */ GIM_Try, /*On fail goto*//*Label 31048*/ GIMT_Encode4(2279043),
     /* 2278928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2278931 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2278934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278942 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2278946 */   GIM_Try, /*On fail goto*//*Label 31049*/ GIMT_Encode4(2278994), // Rule ID 52586 //
     /* 2278951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2278954 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2278954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2278957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2278961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2278966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2278968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2278971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2278973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2278976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2278978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2278980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2278983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2278986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2278989 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2278992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2278993 */     // GIR_Coverage, 52586,
     /* 2278993 */     GIR_EraseRootFromParent_Done,
     /* 2278994 */   // Label 31049: @2278994
     /* 2278994 */   GIM_Try, /*On fail goto*//*Label 31050*/ GIMT_Encode4(2279042), // Rule ID 52587 //
     /* 2278999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279002 */     // (ssubsat:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2279005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2279019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279021 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279024 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279037 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279041 */     // GIR_Coverage, 52587,
     /* 2279041 */     GIR_EraseRootFromParent_Done,
     /* 2279042 */   // Label 31050: @2279042
     /* 2279042 */   GIM_Reject,
     /* 2279043 */ // Label 31048: @2279043
     /* 2279043 */ GIM_Reject,
     /* 2279044 */ // Label 31009: @2279044
     /* 2279044 */ GIM_Try, /*On fail goto*//*Label 31051*/ GIMT_Encode4(2279164),
     /* 2279049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2279052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2279055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279063 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279067 */   GIM_Try, /*On fail goto*//*Label 31052*/ GIMT_Encode4(2279115), // Rule ID 52518 //
     /* 2279072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279075 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2279078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279087 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2279092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279114 */     // GIR_Coverage, 52518,
     /* 2279114 */     GIR_EraseRootFromParent_Done,
     /* 2279115 */   // Label 31052: @2279115
     /* 2279115 */   GIM_Try, /*On fail goto*//*Label 31053*/ GIMT_Encode4(2279163), // Rule ID 52519 //
     /* 2279120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279123 */     // (ssubsat:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVSSUB_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2279126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_MF2),
     /* 2279140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279147 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279158 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279162 */     // GIR_Coverage, 52519,
     /* 2279162 */     GIR_EraseRootFromParent_Done,
     /* 2279163 */   // Label 31053: @2279163
     /* 2279163 */   GIM_Reject,
     /* 2279164 */ // Label 31051: @2279164
     /* 2279164 */ GIM_Reject,
     /* 2279165 */ // Label 31010: @2279165
     /* 2279165 */ GIM_Try, /*On fail goto*//*Label 31054*/ GIMT_Encode4(2279285),
     /* 2279170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2279173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2279176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279188 */   GIM_Try, /*On fail goto*//*Label 31055*/ GIMT_Encode4(2279236), // Rule ID 52538 //
     /* 2279193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279196 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2279213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279231 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279235 */     // GIR_Coverage, 52538,
     /* 2279235 */     GIR_EraseRootFromParent_Done,
     /* 2279236 */   // Label 31055: @2279236
     /* 2279236 */   GIM_Try, /*On fail goto*//*Label 31056*/ GIMT_Encode4(2279284), // Rule ID 52539 //
     /* 2279241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279244 */     // (ssubsat:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2279247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2279261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279279 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279283 */     // GIR_Coverage, 52539,
     /* 2279283 */     GIR_EraseRootFromParent_Done,
     /* 2279284 */   // Label 31056: @2279284
     /* 2279284 */   GIM_Reject,
     /* 2279285 */ // Label 31054: @2279285
     /* 2279285 */ GIM_Reject,
     /* 2279286 */ // Label 31011: @2279286
     /* 2279286 */ GIM_Try, /*On fail goto*//*Label 31057*/ GIMT_Encode4(2279406),
     /* 2279291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2279294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2279297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279309 */   GIM_Try, /*On fail goto*//*Label 31058*/ GIMT_Encode4(2279357), // Rule ID 52574 //
     /* 2279314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279317 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2279334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279356 */     // GIR_Coverage, 52574,
     /* 2279356 */     GIR_EraseRootFromParent_Done,
     /* 2279357 */   // Label 31058: @2279357
     /* 2279357 */   GIM_Try, /*On fail goto*//*Label 31059*/ GIMT_Encode4(2279405), // Rule ID 52575 //
     /* 2279362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279365 */     // (ssubsat:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2279368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2279382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279400 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279404 */     // GIR_Coverage, 52575,
     /* 2279404 */     GIR_EraseRootFromParent_Done,
     /* 2279405 */   // Label 31059: @2279405
     /* 2279405 */   GIM_Reject,
     /* 2279406 */ // Label 31057: @2279406
     /* 2279406 */ GIM_Reject,
     /* 2279407 */ // Label 31012: @2279407
     /* 2279407 */ GIM_Try, /*On fail goto*//*Label 31060*/ GIMT_Encode4(2279527),
     /* 2279412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2279415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2279418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279430 */   GIM_Try, /*On fail goto*//*Label 31061*/ GIMT_Encode4(2279478), // Rule ID 52590 //
     /* 2279435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279438 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2279455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279473 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279477 */     // GIR_Coverage, 52590,
     /* 2279477 */     GIR_EraseRootFromParent_Done,
     /* 2279478 */   // Label 31061: @2279478
     /* 2279478 */   GIM_Try, /*On fail goto*//*Label 31062*/ GIMT_Encode4(2279526), // Rule ID 52591 //
     /* 2279483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279486 */     // (ssubsat:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2279489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2279503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279521 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279525 */     // GIR_Coverage, 52591,
     /* 2279525 */     GIR_EraseRootFromParent_Done,
     /* 2279526 */   // Label 31062: @2279526
     /* 2279526 */   GIM_Reject,
     /* 2279527 */ // Label 31060: @2279527
     /* 2279527 */ GIM_Reject,
     /* 2279528 */ // Label 31013: @2279528
     /* 2279528 */ GIM_Try, /*On fail goto*//*Label 31063*/ GIMT_Encode4(2279648),
     /* 2279533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2279536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2279539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2279551 */   GIM_Try, /*On fail goto*//*Label 31064*/ GIMT_Encode4(2279599), // Rule ID 52534 //
     /* 2279556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279559 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2279562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2279576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279594 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279598 */     // GIR_Coverage, 52534,
     /* 2279598 */     GIR_EraseRootFromParent_Done,
     /* 2279599 */   // Label 31064: @2279599
     /* 2279599 */   GIM_Try, /*On fail goto*//*Label 31065*/ GIMT_Encode4(2279647), // Rule ID 52535 //
     /* 2279604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279607 */     // (ssubsat:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVSSUB_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2279610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M1),
     /* 2279624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279646 */     // GIR_Coverage, 52535,
     /* 2279646 */     GIR_EraseRootFromParent_Done,
     /* 2279647 */   // Label 31065: @2279647
     /* 2279647 */   GIM_Reject,
     /* 2279648 */ // Label 31063: @2279648
     /* 2279648 */ GIM_Reject,
     /* 2279649 */ // Label 31014: @2279649
     /* 2279649 */ GIM_Try, /*On fail goto*//*Label 31066*/ GIMT_Encode4(2279769),
     /* 2279654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2279657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2279660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2279672 */   GIM_Try, /*On fail goto*//*Label 31067*/ GIMT_Encode4(2279720), // Rule ID 52562 //
     /* 2279677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279680 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2279683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2279697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279715 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279719 */     // GIR_Coverage, 52562,
     /* 2279719 */     GIR_EraseRootFromParent_Done,
     /* 2279720 */   // Label 31067: @2279720
     /* 2279720 */   GIM_Try, /*On fail goto*//*Label 31068*/ GIMT_Encode4(2279768), // Rule ID 52563 //
     /* 2279725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279728 */     // (ssubsat:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2279731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2279745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2279760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279763 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279767 */     // GIR_Coverage, 52563,
     /* 2279767 */     GIR_EraseRootFromParent_Done,
     /* 2279768 */   // Label 31068: @2279768
     /* 2279768 */   GIM_Reject,
     /* 2279769 */ // Label 31066: @2279769
     /* 2279769 */ GIM_Reject,
     /* 2279770 */ // Label 31015: @2279770
     /* 2279770 */ GIM_Try, /*On fail goto*//*Label 31069*/ GIMT_Encode4(2279890),
     /* 2279775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2279778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2279781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2279793 */   GIM_Try, /*On fail goto*//*Label 31070*/ GIMT_Encode4(2279841), // Rule ID 52578 //
     /* 2279798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2279801 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2279804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2279818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279836 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279840 */     // GIR_Coverage, 52578,
     /* 2279840 */     GIR_EraseRootFromParent_Done,
     /* 2279841 */   // Label 31070: @2279841
     /* 2279841 */   GIM_Try, /*On fail goto*//*Label 31071*/ GIMT_Encode4(2279889), // Rule ID 52579 //
     /* 2279846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2279849 */     // (ssubsat:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2279852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2279866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2279881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279888 */     // GIR_Coverage, 52579,
     /* 2279888 */     GIR_EraseRootFromParent_Done,
     /* 2279889 */   // Label 31071: @2279889
     /* 2279889 */   GIM_Reject,
     /* 2279890 */ // Label 31069: @2279890
     /* 2279890 */ GIM_Reject,
     /* 2279891 */ // Label 31016: @2279891
     /* 2279891 */ GIM_Try, /*On fail goto*//*Label 31072*/ GIMT_Encode4(2280011),
     /* 2279896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2279899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2279902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2279914 */   GIM_Try, /*On fail goto*//*Label 31073*/ GIMT_Encode4(2279962), // Rule ID 52594 //
     /* 2279919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2279922 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2279922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2279925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2279939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2279954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2279957 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2279960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2279961 */     // GIR_Coverage, 52594,
     /* 2279961 */     GIR_EraseRootFromParent_Done,
     /* 2279962 */   // Label 31073: @2279962
     /* 2279962 */   GIM_Try, /*On fail goto*//*Label 31074*/ GIMT_Encode4(2280010), // Rule ID 52595 //
     /* 2279967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2279970 */     // (ssubsat:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2279970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2279973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2279977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2279982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2279984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2279987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2279989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2279992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2279994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2279996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2279999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2280002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280005 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280009 */     // GIR_Coverage, 52595,
     /* 2280009 */     GIR_EraseRootFromParent_Done,
     /* 2280010 */   // Label 31074: @2280010
     /* 2280010 */   GIM_Reject,
     /* 2280011 */ // Label 31072: @2280011
     /* 2280011 */ GIM_Reject,
     /* 2280012 */ // Label 31017: @2280012
     /* 2280012 */ GIM_Try, /*On fail goto*//*Label 31075*/ GIMT_Encode4(2280132),
     /* 2280017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2280020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2280023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2280035 */   GIM_Try, /*On fail goto*//*Label 31076*/ GIMT_Encode4(2280083), // Rule ID 52550 //
     /* 2280040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280043 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2280046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2280060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280082 */     // GIR_Coverage, 52550,
     /* 2280082 */     GIR_EraseRootFromParent_Done,
     /* 2280083 */   // Label 31076: @2280083
     /* 2280083 */   GIM_Try, /*On fail goto*//*Label 31077*/ GIMT_Encode4(2280131), // Rule ID 52551 //
     /* 2280088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280091 */     // (ssubsat:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVSSUB_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2280094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M2),
     /* 2280108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280126 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280130 */     // GIR_Coverage, 52551,
     /* 2280130 */     GIR_EraseRootFromParent_Done,
     /* 2280131 */   // Label 31077: @2280131
     /* 2280131 */   GIM_Reject,
     /* 2280132 */ // Label 31075: @2280132
     /* 2280132 */ GIM_Reject,
     /* 2280133 */ // Label 31018: @2280133
     /* 2280133 */ GIM_Try, /*On fail goto*//*Label 31078*/ GIMT_Encode4(2280253),
     /* 2280138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2280141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2280144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280156 */   GIM_Try, /*On fail goto*//*Label 31079*/ GIMT_Encode4(2280204), // Rule ID 52566 //
     /* 2280161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280164 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2280181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280199 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280203 */     // GIR_Coverage, 52566,
     /* 2280203 */     GIR_EraseRootFromParent_Done,
     /* 2280204 */   // Label 31079: @2280204
     /* 2280204 */   GIM_Try, /*On fail goto*//*Label 31080*/ GIMT_Encode4(2280252), // Rule ID 52567 //
     /* 2280209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280212 */     // (ssubsat:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2280215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2280229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280251 */     // GIR_Coverage, 52567,
     /* 2280251 */     GIR_EraseRootFromParent_Done,
     /* 2280252 */   // Label 31080: @2280252
     /* 2280252 */   GIM_Reject,
     /* 2280253 */ // Label 31078: @2280253
     /* 2280253 */ GIM_Reject,
     /* 2280254 */ // Label 31019: @2280254
     /* 2280254 */ GIM_Try, /*On fail goto*//*Label 31081*/ GIMT_Encode4(2280374),
     /* 2280259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2280262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2280265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280277 */   GIM_Try, /*On fail goto*//*Label 31082*/ GIMT_Encode4(2280325), // Rule ID 52582 //
     /* 2280282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280285 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2280288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280320 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280324 */     // GIR_Coverage, 52582,
     /* 2280324 */     GIR_EraseRootFromParent_Done,
     /* 2280325 */   // Label 31082: @2280325
     /* 2280325 */   GIM_Try, /*On fail goto*//*Label 31083*/ GIMT_Encode4(2280373), // Rule ID 52583 //
     /* 2280330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280333 */     // (ssubsat:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2280336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2280365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280368 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280372 */     // GIR_Coverage, 52583,
     /* 2280372 */     GIR_EraseRootFromParent_Done,
     /* 2280373 */   // Label 31083: @2280373
     /* 2280373 */   GIM_Reject,
     /* 2280374 */ // Label 31081: @2280374
     /* 2280374 */ GIM_Reject,
     /* 2280375 */ // Label 31020: @2280375
     /* 2280375 */ GIM_Try, /*On fail goto*//*Label 31084*/ GIMT_Encode4(2280495),
     /* 2280380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2280383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2280386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2280398 */   GIM_Try, /*On fail goto*//*Label 31085*/ GIMT_Encode4(2280446), // Rule ID 52554 //
     /* 2280403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280406 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2280409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2280423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280445 */     // GIR_Coverage, 52554,
     /* 2280445 */     GIR_EraseRootFromParent_Done,
     /* 2280446 */   // Label 31085: @2280446
     /* 2280446 */   GIM_Try, /*On fail goto*//*Label 31086*/ GIMT_Encode4(2280494), // Rule ID 52555 //
     /* 2280451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280454 */     // (ssubsat:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVSSUB_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2280457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M4),
     /* 2280471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280489 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280493 */     // GIR_Coverage, 52555,
     /* 2280493 */     GIR_EraseRootFromParent_Done,
     /* 2280494 */   // Label 31086: @2280494
     /* 2280494 */   GIM_Reject,
     /* 2280495 */ // Label 31084: @2280495
     /* 2280495 */ GIM_Reject,
     /* 2280496 */ // Label 31021: @2280496
     /* 2280496 */ GIM_Try, /*On fail goto*//*Label 31087*/ GIMT_Encode4(2280616),
     /* 2280501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2280504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2280507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280519 */   GIM_Try, /*On fail goto*//*Label 31088*/ GIMT_Encode4(2280567), // Rule ID 52570 //
     /* 2280524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280527 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2280530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280566 */     // GIR_Coverage, 52570,
     /* 2280566 */     GIR_EraseRootFromParent_Done,
     /* 2280567 */   // Label 31088: @2280567
     /* 2280567 */   GIM_Try, /*On fail goto*//*Label 31089*/ GIMT_Encode4(2280615), // Rule ID 52571 //
     /* 2280572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280575 */     // (ssubsat:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2280578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2280607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280610 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280614 */     // GIR_Coverage, 52571,
     /* 2280614 */     GIR_EraseRootFromParent_Done,
     /* 2280615 */   // Label 31089: @2280615
     /* 2280615 */   GIM_Reject,
     /* 2280616 */ // Label 31087: @2280616
     /* 2280616 */ GIM_Reject,
     /* 2280617 */ // Label 31022: @2280617
     /* 2280617 */ GIM_Try, /*On fail goto*//*Label 31090*/ GIMT_Encode4(2280737),
     /* 2280622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2280625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2280628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2280640 */   GIM_Try, /*On fail goto*//*Label 31091*/ GIMT_Encode4(2280688), // Rule ID 52558 //
     /* 2280645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2280648 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2280648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2280651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280683 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280687 */     // GIR_Coverage, 52558,
     /* 2280687 */     GIR_EraseRootFromParent_Done,
     /* 2280688 */   // Label 31091: @2280688
     /* 2280688 */   GIM_Try, /*On fail goto*//*Label 31092*/ GIMT_Encode4(2280736), // Rule ID 52559 //
     /* 2280693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2280696 */     // (ssubsat:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVSSUB_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2280696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2280699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2280703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2280708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2280710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSSUB_VV_M8),
     /* 2280713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2280715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2280718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2280720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2280722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2280725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2280731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for RISCV::VXSAT*/0,
     /* 2280734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280735 */     // GIR_Coverage, 52559,
     /* 2280735 */     GIR_EraseRootFromParent_Done,
     /* 2280736 */   // Label 31092: @2280736
     /* 2280736 */   GIM_Reject,
     /* 2280737 */ // Label 31090: @2280737
     /* 2280737 */ GIM_Reject,
     /* 2280738 */ // Label 31023: @2280738
     /* 2280738 */ GIM_Reject,
     /* 2280739 */ // Label 57: @2280739
     /* 2280739 */ GIM_Try, /*On fail goto*//*Label 31093*/ GIMT_Encode4(2280796),
     /* 2280744 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2280747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2280750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2280753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280765 */   GIM_Try, /*On fail goto*//*Label 31094*/ GIMT_Encode4(2280780), // Rule ID 64555 //
     /* 2280770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2280773 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2280773 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2280778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280779 */     // GIR_Coverage, 64555,
     /* 2280779 */     GIR_Done,
     /* 2280780 */   // Label 31094: @2280780
     /* 2280780 */   GIM_Try, /*On fail goto*//*Label 31095*/ GIMT_Encode4(2280795), // Rule ID 64556 //
     /* 2280785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2280788 */     // (ushlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLUSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2280788 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLUSAT),
     /* 2280793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280794 */     // GIR_Coverage, 64556,
     /* 2280794 */     GIR_Done,
     /* 2280795 */   // Label 31095: @2280795
     /* 2280795 */   GIM_Reject,
     /* 2280796 */ // Label 31093: @2280796
     /* 2280796 */ GIM_Reject,
     /* 2280797 */ // Label 58: @2280797
     /* 2280797 */ GIM_Try, /*On fail goto*//*Label 31096*/ GIMT_Encode4(2280854),
     /* 2280802 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 2280805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2280808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2280811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRNoX0RegClassID),
     /* 2280823 */   GIM_Try, /*On fail goto*//*Label 31097*/ GIMT_Encode4(2280838), // Rule ID 64557 //
     /* 2280828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode0),
     /* 2280831 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2280831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2280836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280837 */     // GIR_Coverage, 64557,
     /* 2280837 */     GIR_Done,
     /* 2280838 */   // Label 31097: @2280838
     /* 2280838 */   GIM_Try, /*On fail goto*//*Label 31098*/ GIMT_Encode4(2280853), // Rule ID 64558 //
     /* 2280843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXqcia_IsRV32_HwMode1),
     /* 2280846 */     // (sshlsat:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)  =>  (QC_SHLSAT:{ *:[i32] } GPRNoX0:{ *:[i32] }:$rs1, GPRNoX0:{ *:[i32] }:$rs2)
     /* 2280846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::QC_SHLSAT),
     /* 2280851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2280852 */     // GIR_Coverage, 64558,
     /* 2280852 */     GIR_Done,
     /* 2280853 */   // Label 31098: @2280853
     /* 2280853 */   GIM_Reject,
     /* 2280854 */ // Label 31096: @2280854
     /* 2280854 */ GIM_Reject,
     /* 2280855 */ // Label 59: @2280855
     /* 2280855 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31117*/ GIMT_Encode4(2283282),
     /* 2280866 */ /*GILLT_s16*//*Label 31099*/ GIMT_Encode4(2280986),
     /* 2280870 */ /*GILLT_s32*//*Label 31100*/ GIMT_Encode4(2281135),
     /* 2280874 */ /*GILLT_s64*//*Label 31101*/ GIMT_Encode4(2281284), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280886 */ /*GILLT_nxv1s16*//*Label 31102*/ GIMT_Encode4(2281467),
     /* 2280890 */ /*GILLT_nxv1s32*//*Label 31103*/ GIMT_Encode4(2281588),
     /* 2280894 */ /*GILLT_nxv1s64*//*Label 31104*/ GIMT_Encode4(2281709), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280906 */ /*GILLT_nxv2s16*//*Label 31105*/ GIMT_Encode4(2281830),
     /* 2280910 */ /*GILLT_nxv2s32*//*Label 31106*/ GIMT_Encode4(2281951),
     /* 2280914 */ /*GILLT_nxv2s64*//*Label 31107*/ GIMT_Encode4(2282072), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280926 */ /*GILLT_nxv4s16*//*Label 31108*/ GIMT_Encode4(2282193),
     /* 2280930 */ /*GILLT_nxv4s32*//*Label 31109*/ GIMT_Encode4(2282314),
     /* 2280934 */ /*GILLT_nxv4s64*//*Label 31110*/ GIMT_Encode4(2282435), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280946 */ /*GILLT_nxv8s16*//*Label 31111*/ GIMT_Encode4(2282556),
     /* 2280950 */ /*GILLT_nxv8s32*//*Label 31112*/ GIMT_Encode4(2282677),
     /* 2280954 */ /*GILLT_nxv8s64*//*Label 31113*/ GIMT_Encode4(2282798), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280966 */ /*GILLT_nxv16s16*//*Label 31114*/ GIMT_Encode4(2282919),
     /* 2280970 */ /*GILLT_nxv16s32*//*Label 31115*/ GIMT_Encode4(2283040), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2280982 */ /*GILLT_nxv32s16*//*Label 31116*/ GIMT_Encode4(2283161),
     /* 2280986 */ // Label 31099: @2280986
     /* 2280986 */ GIM_Try, /*On fail goto*//*Label 31118*/ GIMT_Encode4(2281134),
     /* 2280991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2280994 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2280997 */   GIM_Try, /*On fail goto*//*Label 31119*/ GIMT_Encode4(2281031), // Rule ID 1848 //
     /* 2281002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2281005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281017 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2281017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2281020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281030 */     // GIR_Coverage, 1848,
     /* 2281030 */     GIR_EraseRootFromParent_Done,
     /* 2281031 */   // Label 31119: @2281031
     /* 2281031 */   GIM_Try, /*On fail goto*//*Label 31120*/ GIMT_Encode4(2281065), // Rule ID 1849 //
     /* 2281036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2281039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2281051 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2281051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2281054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281056 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281058 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281064 */     // GIR_Coverage, 1849,
     /* 2281064 */     GIR_EraseRootFromParent_Done,
     /* 2281065 */   // Label 31120: @2281065
     /* 2281065 */   GIM_Try, /*On fail goto*//*Label 31121*/ GIMT_Encode4(2281099), // Rule ID 1852 //
     /* 2281070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2281073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281085 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2281085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2281088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281098 */     // GIR_Coverage, 1852,
     /* 2281098 */     GIR_EraseRootFromParent_Done,
     /* 2281099 */   // Label 31121: @2281099
     /* 2281099 */   GIM_Try, /*On fail goto*//*Label 31122*/ GIMT_Encode4(2281133), // Rule ID 1853 //
     /* 2281104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2281107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2281119 */     // (fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2281119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2281122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281132 */     // GIR_Coverage, 1853,
     /* 2281132 */     GIR_EraseRootFromParent_Done,
     /* 2281133 */   // Label 31122: @2281133
     /* 2281133 */   GIM_Reject,
     /* 2281134 */ // Label 31118: @2281134
     /* 2281134 */ GIM_Reject,
     /* 2281135 */ // Label 31100: @2281135
     /* 2281135 */ GIM_Try, /*On fail goto*//*Label 31123*/ GIMT_Encode4(2281283),
     /* 2281140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2281143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2281146 */   GIM_Try, /*On fail goto*//*Label 31124*/ GIMT_Encode4(2281180), // Rule ID 1139 //
     /* 2281151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2281154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281166 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2281166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2281169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281171 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281173 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281179 */     // GIR_Coverage, 1139,
     /* 2281179 */     GIR_EraseRootFromParent_Done,
     /* 2281180 */   // Label 31124: @2281180
     /* 2281180 */   GIM_Try, /*On fail goto*//*Label 31125*/ GIMT_Encode4(2281214), // Rule ID 1140 //
     /* 2281185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2281188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2281200 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2281200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2281203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281213 */     // GIR_Coverage, 1140,
     /* 2281213 */     GIR_EraseRootFromParent_Done,
     /* 2281214 */   // Label 31125: @2281214
     /* 2281214 */   GIM_Try, /*On fail goto*//*Label 31126*/ GIMT_Encode4(2281248), // Rule ID 1143 //
     /* 2281219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2281222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281234 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2281234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2281237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281247 */     // GIR_Coverage, 1143,
     /* 2281247 */     GIR_EraseRootFromParent_Done,
     /* 2281248 */   // Label 31126: @2281248
     /* 2281248 */   GIM_Try, /*On fail goto*//*Label 31127*/ GIMT_Encode4(2281282), // Rule ID 1144 //
     /* 2281253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2281256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2281268 */     // (fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2281268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2281271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281275 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281281 */     // GIR_Coverage, 1144,
     /* 2281281 */     GIR_EraseRootFromParent_Done,
     /* 2281282 */   // Label 31127: @2281282
     /* 2281282 */   GIM_Reject,
     /* 2281283 */ // Label 31123: @2281283
     /* 2281283 */ GIM_Reject,
     /* 2281284 */ // Label 31101: @2281284
     /* 2281284 */ GIM_Try, /*On fail goto*//*Label 31128*/ GIMT_Encode4(2281466),
     /* 2281289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2281292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2281295 */   GIM_Try, /*On fail goto*//*Label 31129*/ GIMT_Encode4(2281329), // Rule ID 1474 //
     /* 2281300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2281303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281307 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281315 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2281315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2281318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281320 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281328 */     // GIR_Coverage, 1474,
     /* 2281328 */     GIR_EraseRootFromParent_Done,
     /* 2281329 */   // Label 31129: @2281329
     /* 2281329 */   GIM_Try, /*On fail goto*//*Label 31130*/ GIMT_Encode4(2281363), // Rule ID 1475 //
     /* 2281334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2281337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2281349 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2281349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2281352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281362 */     // GIR_Coverage, 1475,
     /* 2281362 */     GIR_EraseRootFromParent_Done,
     /* 2281363 */   // Label 31130: @2281363
     /* 2281363 */   GIM_Try, /*On fail goto*//*Label 31131*/ GIMT_Encode4(2281397), // Rule ID 1478 //
     /* 2281368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2281371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281383 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2281383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2281386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281396 */     // GIR_Coverage, 1478,
     /* 2281396 */     GIR_EraseRootFromParent_Done,
     /* 2281397 */   // Label 31131: @2281397
     /* 2281397 */   GIM_Try, /*On fail goto*//*Label 31132*/ GIMT_Encode4(2281431), // Rule ID 1479 //
     /* 2281402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2281405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2281417 */     // (fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2281417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2281420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281422 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281430 */     // GIR_Coverage, 1479,
     /* 2281430 */     GIR_EraseRootFromParent_Done,
     /* 2281431 */   // Label 31132: @2281431
     /* 2281431 */   GIM_Try, /*On fail goto*//*Label 31133*/ GIMT_Encode4(2281465), // Rule ID 1481 //
     /* 2281436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2281439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2281451 */     // (fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2281451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2281454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281464 */     // GIR_Coverage, 1481,
     /* 2281464 */     GIR_EraseRootFromParent_Done,
     /* 2281465 */   // Label 31133: @2281465
     /* 2281465 */   GIM_Reject,
     /* 2281466 */ // Label 31128: @2281466
     /* 2281466 */ GIM_Reject,
     /* 2281467 */ // Label 31102: @2281467
     /* 2281467 */ GIM_Try, /*On fail goto*//*Label 31134*/ GIMT_Encode4(2281587),
     /* 2281472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2281475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2281478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281490 */   GIM_Try, /*On fail goto*//*Label 31135*/ GIMT_Encode4(2281538), // Rule ID 45638 //
     /* 2281495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2281498 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2281515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281537 */     // GIR_Coverage, 45638,
     /* 2281537 */     GIR_EraseRootFromParent_Done,
     /* 2281538 */   // Label 31135: @2281538
     /* 2281538 */   GIM_Try, /*On fail goto*//*Label 31136*/ GIMT_Encode4(2281586), // Rule ID 45639 //
     /* 2281543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2281546 */     // (fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281546 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2281549 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281553 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2281563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281568 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281570 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281585 */     // GIR_Coverage, 45639,
     /* 2281585 */     GIR_EraseRootFromParent_Done,
     /* 2281586 */   // Label 31136: @2281586
     /* 2281586 */   GIM_Reject,
     /* 2281587 */ // Label 31134: @2281587
     /* 2281587 */ GIM_Reject,
     /* 2281588 */ // Label 31103: @2281588
     /* 2281588 */ GIM_Try, /*On fail goto*//*Label 31137*/ GIMT_Encode4(2281708),
     /* 2281593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2281596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2281599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281611 */   GIM_Try, /*On fail goto*//*Label 31138*/ GIMT_Encode4(2281659), // Rule ID 53174 //
     /* 2281616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2281619 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2281636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281658 */     // GIR_Coverage, 53174,
     /* 2281658 */     GIR_EraseRootFromParent_Done,
     /* 2281659 */   // Label 31138: @2281659
     /* 2281659 */   GIM_Try, /*On fail goto*//*Label 31139*/ GIMT_Encode4(2281707), // Rule ID 53175 //
     /* 2281664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2281667 */     // (fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2281670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2281684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281691 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2281702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281706 */     // GIR_Coverage, 53175,
     /* 2281706 */     GIR_EraseRootFromParent_Done,
     /* 2281707 */   // Label 31139: @2281707
     /* 2281707 */   GIM_Reject,
     /* 2281708 */ // Label 31137: @2281708
     /* 2281708 */ GIM_Reject,
     /* 2281709 */ // Label 31104: @2281709
     /* 2281709 */ GIM_Try, /*On fail goto*//*Label 31140*/ GIMT_Encode4(2281829),
     /* 2281714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2281717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2281720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281732 */   GIM_Try, /*On fail goto*//*Label 31141*/ GIMT_Encode4(2281780), // Rule ID 53210 //
     /* 2281737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2281740 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2281757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281779 */     // GIR_Coverage, 53210,
     /* 2281779 */     GIR_EraseRootFromParent_Done,
     /* 2281780 */   // Label 31141: @2281780
     /* 2281780 */   GIM_Try, /*On fail goto*//*Label 31142*/ GIMT_Encode4(2281828), // Rule ID 53211 //
     /* 2281785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2281788 */     // (fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2281791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2281805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2281823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281827 */     // GIR_Coverage, 53211,
     /* 2281827 */     GIR_EraseRootFromParent_Done,
     /* 2281828 */   // Label 31142: @2281828
     /* 2281828 */   GIM_Reject,
     /* 2281829 */ // Label 31140: @2281829
     /* 2281829 */ GIM_Reject,
     /* 2281830 */ // Label 31105: @2281830
     /* 2281830 */ GIM_Try, /*On fail goto*//*Label 31143*/ GIMT_Encode4(2281950),
     /* 2281835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2281838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2281841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281853 */   GIM_Try, /*On fail goto*//*Label 31144*/ GIMT_Encode4(2281901), // Rule ID 53162 //
     /* 2281858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2281861 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2281864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2281878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281900 */     // GIR_Coverage, 53162,
     /* 2281900 */     GIR_EraseRootFromParent_Done,
     /* 2281901 */   // Label 31144: @2281901
     /* 2281901 */   GIM_Try, /*On fail goto*//*Label 31145*/ GIMT_Encode4(2281949), // Rule ID 53163 //
     /* 2281906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2281909 */     // (fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2281909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2281912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2281926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2281928 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2281931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2281933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2281935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2281938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2281941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2281944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2281947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2281948 */     // GIR_Coverage, 53163,
     /* 2281948 */     GIR_EraseRootFromParent_Done,
     /* 2281949 */   // Label 31145: @2281949
     /* 2281949 */   GIM_Reject,
     /* 2281950 */ // Label 31143: @2281950
     /* 2281950 */ GIM_Reject,
     /* 2281951 */ // Label 31106: @2281951
     /* 2281951 */ GIM_Try, /*On fail goto*//*Label 31146*/ GIMT_Encode4(2282071),
     /* 2281956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2281959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2281962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2281974 */   GIM_Try, /*On fail goto*//*Label 31147*/ GIMT_Encode4(2282022), // Rule ID 53198 //
     /* 2281979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2281982 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2281982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2281985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2281989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2281994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2281996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2281999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282001 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282004 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282006 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282021 */     // GIR_Coverage, 53198,
     /* 2282021 */     GIR_EraseRootFromParent_Done,
     /* 2282022 */   // Label 31147: @2282022
     /* 2282022 */   GIM_Try, /*On fail goto*//*Label 31148*/ GIMT_Encode4(2282070), // Rule ID 53199 //
     /* 2282027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2282030 */     // (fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2282033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282042 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2282047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282049 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282069 */     // GIR_Coverage, 53199,
     /* 2282069 */     GIR_EraseRootFromParent_Done,
     /* 2282070 */   // Label 31148: @2282070
     /* 2282070 */   GIM_Reject,
     /* 2282071 */ // Label 31146: @2282071
     /* 2282071 */ GIM_Reject,
     /* 2282072 */ // Label 31107: @2282072
     /* 2282072 */ GIM_Try, /*On fail goto*//*Label 31149*/ GIMT_Encode4(2282192),
     /* 2282077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2282080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2282083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282095 */   GIM_Try, /*On fail goto*//*Label 31150*/ GIMT_Encode4(2282143), // Rule ID 53294 //
     /* 2282100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2282103 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2282120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282125 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282142 */     // GIR_Coverage, 53294,
     /* 2282142 */     GIR_EraseRootFromParent_Done,
     /* 2282143 */   // Label 31150: @2282143
     /* 2282143 */   GIM_Try, /*On fail goto*//*Label 31151*/ GIMT_Encode4(2282191), // Rule ID 53295 //
     /* 2282148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2282151 */     // (fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2282154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2282168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282175 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282190 */     // GIR_Coverage, 53295,
     /* 2282190 */     GIR_EraseRootFromParent_Done,
     /* 2282191 */   // Label 31151: @2282191
     /* 2282191 */   GIM_Reject,
     /* 2282192 */ // Label 31149: @2282192
     /* 2282192 */ GIM_Reject,
     /* 2282193 */ // Label 31108: @2282193
     /* 2282193 */ GIM_Try, /*On fail goto*//*Label 31152*/ GIMT_Encode4(2282313),
     /* 2282198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2282201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2282204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2282216 */   GIM_Try, /*On fail goto*//*Label 31153*/ GIMT_Encode4(2282264), // Rule ID 53186 //
     /* 2282221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2282224 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2282241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282248 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282263 */     // GIR_Coverage, 53186,
     /* 2282263 */     GIR_EraseRootFromParent_Done,
     /* 2282264 */   // Label 31153: @2282264
     /* 2282264 */   GIM_Try, /*On fail goto*//*Label 31154*/ GIMT_Encode4(2282312), // Rule ID 53187 //
     /* 2282269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2282272 */     // (fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2282275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2282289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282294 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282296 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282310 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282311 */     // GIR_Coverage, 53187,
     /* 2282311 */     GIR_EraseRootFromParent_Done,
     /* 2282312 */   // Label 31154: @2282312
     /* 2282312 */   GIM_Reject,
     /* 2282313 */ // Label 31152: @2282313
     /* 2282313 */ GIM_Reject,
     /* 2282314 */ // Label 31109: @2282314
     /* 2282314 */ GIM_Try, /*On fail goto*//*Label 31155*/ GIMT_Encode4(2282434),
     /* 2282319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2282322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2282325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282337 */   GIM_Try, /*On fail goto*//*Label 31156*/ GIMT_Encode4(2282385), // Rule ID 53258 //
     /* 2282342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2282345 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2282348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2282362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282364 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282367 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282369 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282384 */     // GIR_Coverage, 53258,
     /* 2282384 */     GIR_EraseRootFromParent_Done,
     /* 2282385 */   // Label 31156: @2282385
     /* 2282385 */   GIM_Try, /*On fail goto*//*Label 31157*/ GIMT_Encode4(2282433), // Rule ID 53259 //
     /* 2282390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2282393 */     // (fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2282396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2282410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282415 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282432 */     // GIR_Coverage, 53259,
     /* 2282432 */     GIR_EraseRootFromParent_Done,
     /* 2282433 */   // Label 31157: @2282433
     /* 2282433 */   GIM_Reject,
     /* 2282434 */ // Label 31155: @2282434
     /* 2282434 */ GIM_Reject,
     /* 2282435 */ // Label 31110: @2282435
     /* 2282435 */ GIM_Try, /*On fail goto*//*Label 31158*/ GIMT_Encode4(2282555),
     /* 2282440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2282443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2282446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282458 */   GIM_Try, /*On fail goto*//*Label 31159*/ GIMT_Encode4(2282506), // Rule ID 53306 //
     /* 2282463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2282466 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2282469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2282483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282505 */     // GIR_Coverage, 53306,
     /* 2282505 */     GIR_EraseRootFromParent_Done,
     /* 2282506 */   // Label 31159: @2282506
     /* 2282506 */   GIM_Try, /*On fail goto*//*Label 31160*/ GIMT_Encode4(2282554), // Rule ID 53307 //
     /* 2282511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2282514 */     // (fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2282517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2282531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282553 */     // GIR_Coverage, 53307,
     /* 2282553 */     GIR_EraseRootFromParent_Done,
     /* 2282554 */   // Label 31160: @2282554
     /* 2282554 */   GIM_Reject,
     /* 2282555 */ // Label 31158: @2282555
     /* 2282555 */ GIM_Reject,
     /* 2282556 */ // Label 31111: @2282556
     /* 2282556 */ GIM_Try, /*On fail goto*//*Label 31161*/ GIMT_Encode4(2282676),
     /* 2282561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2282564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2282567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2282579 */   GIM_Try, /*On fail goto*//*Label 31162*/ GIMT_Encode4(2282627), // Rule ID 53222 //
     /* 2282584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2282587 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2282590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2282604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282626 */     // GIR_Coverage, 53222,
     /* 2282626 */     GIR_EraseRootFromParent_Done,
     /* 2282627 */   // Label 31162: @2282627
     /* 2282627 */   GIM_Try, /*On fail goto*//*Label 31163*/ GIMT_Encode4(2282675), // Rule ID 53223 //
     /* 2282632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2282635 */     // (fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282635 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2282638 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282642 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2282652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282657 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282659 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282673 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282674 */     // GIR_Coverage, 53223,
     /* 2282674 */     GIR_EraseRootFromParent_Done,
     /* 2282675 */   // Label 31163: @2282675
     /* 2282675 */   GIM_Reject,
     /* 2282676 */ // Label 31161: @2282676
     /* 2282676 */ GIM_Reject,
     /* 2282677 */ // Label 31112: @2282677
     /* 2282677 */ GIM_Try, /*On fail goto*//*Label 31164*/ GIMT_Encode4(2282797),
     /* 2282682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2282685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2282688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282696 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282700 */   GIM_Try, /*On fail goto*//*Label 31165*/ GIMT_Encode4(2282748), // Rule ID 53270 //
     /* 2282705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2282708 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2282711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2282725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282732 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282747 */     // GIR_Coverage, 53270,
     /* 2282747 */     GIR_EraseRootFromParent_Done,
     /* 2282748 */   // Label 31165: @2282748
     /* 2282748 */   GIM_Try, /*On fail goto*//*Label 31166*/ GIMT_Encode4(2282796), // Rule ID 53271 //
     /* 2282753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2282756 */     // (fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2282759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2282773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2282791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282794 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282795 */     // GIR_Coverage, 53271,
     /* 2282795 */     GIR_EraseRootFromParent_Done,
     /* 2282796 */   // Label 31166: @2282796
     /* 2282796 */   GIM_Reject,
     /* 2282797 */ // Label 31164: @2282797
     /* 2282797 */ GIM_Reject,
     /* 2282798 */ // Label 31113: @2282798
     /* 2282798 */ GIM_Try, /*On fail goto*//*Label 31167*/ GIMT_Encode4(2282918),
     /* 2282803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2282806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2282809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282817 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2282821 */   GIM_Try, /*On fail goto*//*Label 31168*/ GIMT_Encode4(2282869), // Rule ID 53318 //
     /* 2282826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2282829 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2282832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2282846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282868 */     // GIR_Coverage, 53318,
     /* 2282868 */     GIR_EraseRootFromParent_Done,
     /* 2282869 */   // Label 31168: @2282869
     /* 2282869 */   GIM_Try, /*On fail goto*//*Label 31169*/ GIMT_Encode4(2282917), // Rule ID 53319 //
     /* 2282874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2282877 */     // (fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2282880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2282894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282899 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282901 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2282912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282916 */     // GIR_Coverage, 53319,
     /* 2282916 */     GIR_EraseRootFromParent_Done,
     /* 2282917 */   // Label 31169: @2282917
     /* 2282917 */   GIM_Reject,
     /* 2282918 */ // Label 31167: @2282918
     /* 2282918 */ GIM_Reject,
     /* 2282919 */ // Label 31114: @2282919
     /* 2282919 */ GIM_Try, /*On fail goto*//*Label 31170*/ GIMT_Encode4(2283039),
     /* 2282924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2282927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2282930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2282942 */   GIM_Try, /*On fail goto*//*Label 31171*/ GIMT_Encode4(2282990), // Rule ID 53234 //
     /* 2282947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2282950 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2282950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2282953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2282957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2282962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2282964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2282967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2282969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2282972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2282974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2282976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2282979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2282982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2282985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2282988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2282989 */     // GIR_Coverage, 53234,
     /* 2282989 */     GIR_EraseRootFromParent_Done,
     /* 2282990 */   // Label 31171: @2282990
     /* 2282990 */   GIM_Try, /*On fail goto*//*Label 31172*/ GIMT_Encode4(2283038), // Rule ID 53235 //
     /* 2282995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2282998 */     // (fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2282998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2283001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2283015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283036 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283037 */     // GIR_Coverage, 53235,
     /* 2283037 */     GIR_EraseRootFromParent_Done,
     /* 2283038 */   // Label 31172: @2283038
     /* 2283038 */   GIM_Reject,
     /* 2283039 */ // Label 31170: @2283039
     /* 2283039 */ GIM_Reject,
     /* 2283040 */ // Label 31115: @2283040
     /* 2283040 */ GIM_Try, /*On fail goto*//*Label 31173*/ GIMT_Encode4(2283160),
     /* 2283045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2283048 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2283051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283059 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283063 */   GIM_Try, /*On fail goto*//*Label 31174*/ GIMT_Encode4(2283111), // Rule ID 53282 //
     /* 2283068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2283071 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2283074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2283088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283110 */     // GIR_Coverage, 53282,
     /* 2283110 */     GIR_EraseRootFromParent_Done,
     /* 2283111 */   // Label 31174: @2283111
     /* 2283111 */   GIM_Try, /*On fail goto*//*Label 31175*/ GIMT_Encode4(2283159), // Rule ID 53283 //
     /* 2283116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2283119 */     // (fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2283122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2283136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2283154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283158 */     // GIR_Coverage, 53283,
     /* 2283158 */     GIR_EraseRootFromParent_Done,
     /* 2283159 */   // Label 31175: @2283159
     /* 2283159 */   GIM_Reject,
     /* 2283160 */ // Label 31173: @2283160
     /* 2283160 */ GIM_Reject,
     /* 2283161 */ // Label 31116: @2283161
     /* 2283161 */ GIM_Try, /*On fail goto*//*Label 31176*/ GIMT_Encode4(2283281),
     /* 2283166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2283169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2283172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2283184 */   GIM_Try, /*On fail goto*//*Label 31177*/ GIMT_Encode4(2283232), // Rule ID 53246 //
     /* 2283189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2283192 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2283195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2283209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283214 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283216 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283230 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283231 */     // GIR_Coverage, 53246,
     /* 2283231 */     GIR_EraseRootFromParent_Done,
     /* 2283232 */   // Label 31177: @2283232
     /* 2283232 */   GIM_Try, /*On fail goto*//*Label 31178*/ GIMT_Encode4(2283280), // Rule ID 53247 //
     /* 2283237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2283240 */     // (fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2283243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2283257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283262 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283264 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283279 */     // GIR_Coverage, 53247,
     /* 2283279 */     GIR_EraseRootFromParent_Done,
     /* 2283280 */   // Label 31178: @2283280
     /* 2283280 */   GIM_Reject,
     /* 2283281 */ // Label 31176: @2283281
     /* 2283281 */ GIM_Reject,
     /* 2283282 */ // Label 31117: @2283282
     /* 2283282 */ GIM_Reject,
     /* 2283283 */ // Label 60: @2283283
     /* 2283283 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31197*/ GIMT_Encode4(2285710),
     /* 2283294 */ /*GILLT_s16*//*Label 31179*/ GIMT_Encode4(2283414),
     /* 2283298 */ /*GILLT_s32*//*Label 31180*/ GIMT_Encode4(2283563),
     /* 2283302 */ /*GILLT_s64*//*Label 31181*/ GIMT_Encode4(2283712), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283314 */ /*GILLT_nxv1s16*//*Label 31182*/ GIMT_Encode4(2283895),
     /* 2283318 */ /*GILLT_nxv1s32*//*Label 31183*/ GIMT_Encode4(2284016),
     /* 2283322 */ /*GILLT_nxv1s64*//*Label 31184*/ GIMT_Encode4(2284137), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283334 */ /*GILLT_nxv2s16*//*Label 31185*/ GIMT_Encode4(2284258),
     /* 2283338 */ /*GILLT_nxv2s32*//*Label 31186*/ GIMT_Encode4(2284379),
     /* 2283342 */ /*GILLT_nxv2s64*//*Label 31187*/ GIMT_Encode4(2284500), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283354 */ /*GILLT_nxv4s16*//*Label 31188*/ GIMT_Encode4(2284621),
     /* 2283358 */ /*GILLT_nxv4s32*//*Label 31189*/ GIMT_Encode4(2284742),
     /* 2283362 */ /*GILLT_nxv4s64*//*Label 31190*/ GIMT_Encode4(2284863), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283374 */ /*GILLT_nxv8s16*//*Label 31191*/ GIMT_Encode4(2284984),
     /* 2283378 */ /*GILLT_nxv8s32*//*Label 31192*/ GIMT_Encode4(2285105),
     /* 2283382 */ /*GILLT_nxv8s64*//*Label 31193*/ GIMT_Encode4(2285226), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283394 */ /*GILLT_nxv16s16*//*Label 31194*/ GIMT_Encode4(2285347),
     /* 2283398 */ /*GILLT_nxv16s32*//*Label 31195*/ GIMT_Encode4(2285468), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2283410 */ /*GILLT_nxv32s16*//*Label 31196*/ GIMT_Encode4(2285589),
     /* 2283414 */ // Label 31179: @2283414
     /* 2283414 */ GIM_Try, /*On fail goto*//*Label 31198*/ GIMT_Encode4(2283562),
     /* 2283419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2283422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2283425 */   GIM_Try, /*On fail goto*//*Label 31199*/ GIMT_Encode4(2283459), // Rule ID 1856 //
     /* 2283430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2283433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283445 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2283445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2283448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283457 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283458 */     // GIR_Coverage, 1856,
     /* 2283458 */     GIR_EraseRootFromParent_Done,
     /* 2283459 */   // Label 31199: @2283459
     /* 2283459 */   GIM_Try, /*On fail goto*//*Label 31200*/ GIMT_Encode4(2283493), // Rule ID 1857 //
     /* 2283464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2283467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2283479 */     // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2283479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2283482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283492 */     // GIR_Coverage, 1857,
     /* 2283492 */     GIR_EraseRootFromParent_Done,
     /* 2283493 */   // Label 31200: @2283493
     /* 2283493 */   GIM_Try, /*On fail goto*//*Label 31201*/ GIMT_Encode4(2283527), // Rule ID 1860 //
     /* 2283498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2283501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283513 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2283513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2283516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283520 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283525 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283526 */     // GIR_Coverage, 1860,
     /* 2283526 */     GIR_EraseRootFromParent_Done,
     /* 2283527 */   // Label 31201: @2283527
     /* 2283527 */   GIM_Try, /*On fail goto*//*Label 31202*/ GIMT_Encode4(2283561), // Rule ID 1861 //
     /* 2283532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2283535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2283547 */     // (fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2283547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2283550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283560 */     // GIR_Coverage, 1861,
     /* 2283560 */     GIR_EraseRootFromParent_Done,
     /* 2283561 */   // Label 31202: @2283561
     /* 2283561 */   GIM_Reject,
     /* 2283562 */ // Label 31198: @2283562
     /* 2283562 */ GIM_Reject,
     /* 2283563 */ // Label 31180: @2283563
     /* 2283563 */ GIM_Try, /*On fail goto*//*Label 31203*/ GIMT_Encode4(2283711),
     /* 2283568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2283571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2283574 */   GIM_Try, /*On fail goto*//*Label 31204*/ GIMT_Encode4(2283608), // Rule ID 1147 //
     /* 2283579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2283582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283594 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2283594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2283597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283607 */     // GIR_Coverage, 1147,
     /* 2283607 */     GIR_EraseRootFromParent_Done,
     /* 2283608 */   // Label 31204: @2283608
     /* 2283608 */   GIM_Try, /*On fail goto*//*Label 31205*/ GIMT_Encode4(2283642), // Rule ID 1148 //
     /* 2283613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2283616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2283628 */     // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2283628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2283631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283635 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283641 */     // GIR_Coverage, 1148,
     /* 2283641 */     GIR_EraseRootFromParent_Done,
     /* 2283642 */   // Label 31205: @2283642
     /* 2283642 */   GIM_Try, /*On fail goto*//*Label 31206*/ GIMT_Encode4(2283676), // Rule ID 1151 //
     /* 2283647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2283650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283662 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2283662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2283665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283675 */     // GIR_Coverage, 1151,
     /* 2283675 */     GIR_EraseRootFromParent_Done,
     /* 2283676 */   // Label 31206: @2283676
     /* 2283676 */   GIM_Try, /*On fail goto*//*Label 31207*/ GIMT_Encode4(2283710), // Rule ID 1152 //
     /* 2283681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2283684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2283696 */     // (fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2283696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2283699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283703 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283709 */     // GIR_Coverage, 1152,
     /* 2283709 */     GIR_EraseRootFromParent_Done,
     /* 2283710 */   // Label 31207: @2283710
     /* 2283710 */   GIM_Reject,
     /* 2283711 */ // Label 31203: @2283711
     /* 2283711 */ GIM_Reject,
     /* 2283712 */ // Label 31181: @2283712
     /* 2283712 */ GIM_Try, /*On fail goto*//*Label 31208*/ GIMT_Encode4(2283894),
     /* 2283717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2283720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2283723 */   GIM_Try, /*On fail goto*//*Label 31209*/ GIMT_Encode4(2283757), // Rule ID 1484 //
     /* 2283728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2283731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283743 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2283743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2283746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283748 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283750 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283756 */     // GIR_Coverage, 1484,
     /* 2283756 */     GIR_EraseRootFromParent_Done,
     /* 2283757 */   // Label 31209: @2283757
     /* 2283757 */   GIM_Try, /*On fail goto*//*Label 31210*/ GIMT_Encode4(2283791), // Rule ID 1485 //
     /* 2283762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2283765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2283777 */     // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2283777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2283780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283782 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283784 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283790 */     // GIR_Coverage, 1485,
     /* 2283790 */     GIR_EraseRootFromParent_Done,
     /* 2283791 */   // Label 31210: @2283791
     /* 2283791 */   GIM_Try, /*On fail goto*//*Label 31211*/ GIMT_Encode4(2283825), // Rule ID 1488 //
     /* 2283796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2283799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283811 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2283811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2283814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283824 */     // GIR_Coverage, 1488,
     /* 2283824 */     GIR_EraseRootFromParent_Done,
     /* 2283825 */   // Label 31211: @2283825
     /* 2283825 */   GIM_Try, /*On fail goto*//*Label 31212*/ GIMT_Encode4(2283859), // Rule ID 1489 //
     /* 2283830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2283833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2283845 */     // (fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2283845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2283848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283852 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283858 */     // GIR_Coverage, 1489,
     /* 2283858 */     GIR_EraseRootFromParent_Done,
     /* 2283859 */   // Label 31212: @2283859
     /* 2283859 */   GIM_Try, /*On fail goto*//*Label 31213*/ GIMT_Encode4(2283893), // Rule ID 1491 //
     /* 2283864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2283867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2283871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2283875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2283879 */     // (fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2283879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2283882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283886 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283892 */     // GIR_Coverage, 1491,
     /* 2283892 */     GIR_EraseRootFromParent_Done,
     /* 2283893 */   // Label 31213: @2283893
     /* 2283893 */   GIM_Reject,
     /* 2283894 */ // Label 31208: @2283894
     /* 2283894 */ GIM_Reject,
     /* 2283895 */ // Label 31182: @2283895
     /* 2283895 */ GIM_Try, /*On fail goto*//*Label 31214*/ GIMT_Encode4(2284015),
     /* 2283900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2283903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2283906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2283918 */   GIM_Try, /*On fail goto*//*Label 31215*/ GIMT_Encode4(2283966), // Rule ID 53330 //
     /* 2283923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2283926 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2283926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2283929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2283943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283950 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2283952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2283955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2283958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2283961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2283964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2283965 */     // GIR_Coverage, 53330,
     /* 2283965 */     GIR_EraseRootFromParent_Done,
     /* 2283966 */   // Label 31215: @2283966
     /* 2283966 */   GIM_Try, /*On fail goto*//*Label 31216*/ GIMT_Encode4(2284014), // Rule ID 53331 //
     /* 2283971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2283974 */     // (fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2283974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2283977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2283981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2283986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2283988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2283991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2283993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2283996 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2283998 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284013 */     // GIR_Coverage, 53331,
     /* 2284013 */     GIR_EraseRootFromParent_Done,
     /* 2284014 */   // Label 31216: @2284014
     /* 2284014 */   GIM_Reject,
     /* 2284015 */ // Label 31214: @2284015
     /* 2284015 */ GIM_Reject,
     /* 2284016 */ // Label 31183: @2284016
     /* 2284016 */ GIM_Try, /*On fail goto*//*Label 31217*/ GIMT_Encode4(2284136),
     /* 2284021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2284024 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2284027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284035 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284039 */   GIM_Try, /*On fail goto*//*Label 31218*/ GIMT_Encode4(2284087), // Rule ID 53354 //
     /* 2284044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2284047 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2284050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2284064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284086 */     // GIR_Coverage, 53354,
     /* 2284086 */     GIR_EraseRootFromParent_Done,
     /* 2284087 */   // Label 31218: @2284087
     /* 2284087 */   GIM_Try, /*On fail goto*//*Label 31219*/ GIMT_Encode4(2284135), // Rule ID 53355 //
     /* 2284092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2284095 */     // (fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2284098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2284112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284134 */     // GIR_Coverage, 53355,
     /* 2284134 */     GIR_EraseRootFromParent_Done,
     /* 2284135 */   // Label 31219: @2284135
     /* 2284135 */   GIM_Reject,
     /* 2284136 */ // Label 31217: @2284136
     /* 2284136 */ GIM_Reject,
     /* 2284137 */ // Label 31184: @2284137
     /* 2284137 */ GIM_Try, /*On fail goto*//*Label 31220*/ GIMT_Encode4(2284257),
     /* 2284142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2284145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2284148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284156 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284160 */   GIM_Try, /*On fail goto*//*Label 31221*/ GIMT_Encode4(2284208), // Rule ID 53390 //
     /* 2284165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2284168 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2284171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2284185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284190 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284192 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284207 */     // GIR_Coverage, 53390,
     /* 2284207 */     GIR_EraseRootFromParent_Done,
     /* 2284208 */   // Label 31221: @2284208
     /* 2284208 */   GIM_Try, /*On fail goto*//*Label 31222*/ GIMT_Encode4(2284256), // Rule ID 53391 //
     /* 2284213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2284216 */     // (fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2284219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2284233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284255 */     // GIR_Coverage, 53391,
     /* 2284255 */     GIR_EraseRootFromParent_Done,
     /* 2284256 */   // Label 31222: @2284256
     /* 2284256 */   GIM_Reject,
     /* 2284257 */ // Label 31220: @2284257
     /* 2284257 */ GIM_Reject,
     /* 2284258 */ // Label 31185: @2284258
     /* 2284258 */ GIM_Try, /*On fail goto*//*Label 31223*/ GIMT_Encode4(2284378),
     /* 2284263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2284266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2284269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284277 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284281 */   GIM_Try, /*On fail goto*//*Label 31224*/ GIMT_Encode4(2284329), // Rule ID 53342 //
     /* 2284286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2284289 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2284292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2284306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284328 */     // GIR_Coverage, 53342,
     /* 2284328 */     GIR_EraseRootFromParent_Done,
     /* 2284329 */   // Label 31224: @2284329
     /* 2284329 */   GIM_Try, /*On fail goto*//*Label 31225*/ GIMT_Encode4(2284377), // Rule ID 53343 //
     /* 2284334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2284337 */     // (fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2284340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2284354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284356 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284376 */     // GIR_Coverage, 53343,
     /* 2284376 */     GIR_EraseRootFromParent_Done,
     /* 2284377 */   // Label 31225: @2284377
     /* 2284377 */   GIM_Reject,
     /* 2284378 */ // Label 31223: @2284378
     /* 2284378 */ GIM_Reject,
     /* 2284379 */ // Label 31186: @2284379
     /* 2284379 */ GIM_Try, /*On fail goto*//*Label 31226*/ GIMT_Encode4(2284499),
     /* 2284384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2284387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2284390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284402 */   GIM_Try, /*On fail goto*//*Label 31227*/ GIMT_Encode4(2284450), // Rule ID 53378 //
     /* 2284407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2284410 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2284413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2284427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284429 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284449 */     // GIR_Coverage, 53378,
     /* 2284449 */     GIR_EraseRootFromParent_Done,
     /* 2284450 */   // Label 31227: @2284450
     /* 2284450 */   GIM_Try, /*On fail goto*//*Label 31228*/ GIMT_Encode4(2284498), // Rule ID 53379 //
     /* 2284455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2284458 */     // (fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2284461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2284475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284496 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284497 */     // GIR_Coverage, 53379,
     /* 2284497 */     GIR_EraseRootFromParent_Done,
     /* 2284498 */   // Label 31228: @2284498
     /* 2284498 */   GIM_Reject,
     /* 2284499 */ // Label 31226: @2284499
     /* 2284499 */ GIM_Reject,
     /* 2284500 */ // Label 31187: @2284500
     /* 2284500 */ GIM_Try, /*On fail goto*//*Label 31229*/ GIMT_Encode4(2284620),
     /* 2284505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2284508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2284511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284519 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284523 */   GIM_Try, /*On fail goto*//*Label 31230*/ GIMT_Encode4(2284571), // Rule ID 53474 //
     /* 2284528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2284531 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2284534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2284548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284555 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284569 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284570 */     // GIR_Coverage, 53474,
     /* 2284570 */     GIR_EraseRootFromParent_Done,
     /* 2284571 */   // Label 31230: @2284571
     /* 2284571 */   GIM_Try, /*On fail goto*//*Label 31231*/ GIMT_Encode4(2284619), // Rule ID 53475 //
     /* 2284576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2284579 */     // (fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2284582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2284596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284603 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284618 */     // GIR_Coverage, 53475,
     /* 2284618 */     GIR_EraseRootFromParent_Done,
     /* 2284619 */   // Label 31231: @2284619
     /* 2284619 */   GIM_Reject,
     /* 2284620 */ // Label 31229: @2284620
     /* 2284620 */ GIM_Reject,
     /* 2284621 */ // Label 31188: @2284621
     /* 2284621 */ GIM_Try, /*On fail goto*//*Label 31232*/ GIMT_Encode4(2284741),
     /* 2284626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2284629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2284632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2284644 */   GIM_Try, /*On fail goto*//*Label 31233*/ GIMT_Encode4(2284692), // Rule ID 53366 //
     /* 2284649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2284652 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2284655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2284669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284690 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284691 */     // GIR_Coverage, 53366,
     /* 2284691 */     GIR_EraseRootFromParent_Done,
     /* 2284692 */   // Label 31233: @2284692
     /* 2284692 */   GIM_Try, /*On fail goto*//*Label 31234*/ GIMT_Encode4(2284740), // Rule ID 53367 //
     /* 2284697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2284700 */     // (fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2284703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2284717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284722 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2284735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284739 */     // GIR_Coverage, 53367,
     /* 2284739 */     GIR_EraseRootFromParent_Done,
     /* 2284740 */   // Label 31234: @2284740
     /* 2284740 */   GIM_Reject,
     /* 2284741 */ // Label 31232: @2284741
     /* 2284741 */ GIM_Reject,
     /* 2284742 */ // Label 31189: @2284742
     /* 2284742 */ GIM_Try, /*On fail goto*//*Label 31235*/ GIMT_Encode4(2284862),
     /* 2284747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2284750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2284753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284761 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284765 */   GIM_Try, /*On fail goto*//*Label 31236*/ GIMT_Encode4(2284813), // Rule ID 53438 //
     /* 2284770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2284773 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2284776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2284790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284812 */     // GIR_Coverage, 53438,
     /* 2284812 */     GIR_EraseRootFromParent_Done,
     /* 2284813 */   // Label 31236: @2284813
     /* 2284813 */   GIM_Try, /*On fail goto*//*Label 31237*/ GIMT_Encode4(2284861), // Rule ID 53439 //
     /* 2284818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2284821 */     // (fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2284824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2284838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2284856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284860 */     // GIR_Coverage, 53439,
     /* 2284860 */     GIR_EraseRootFromParent_Done,
     /* 2284861 */   // Label 31237: @2284861
     /* 2284861 */   GIM_Reject,
     /* 2284862 */ // Label 31235: @2284862
     /* 2284862 */ GIM_Reject,
     /* 2284863 */ // Label 31190: @2284863
     /* 2284863 */ GIM_Try, /*On fail goto*//*Label 31238*/ GIMT_Encode4(2284983),
     /* 2284868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2284871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2284874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284882 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2284886 */   GIM_Try, /*On fail goto*//*Label 31239*/ GIMT_Encode4(2284934), // Rule ID 53486 //
     /* 2284891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2284894 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2284894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2284897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2284911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284933 */     // GIR_Coverage, 53486,
     /* 2284933 */     GIR_EraseRootFromParent_Done,
     /* 2284934 */   // Label 31239: @2284934
     /* 2284934 */   GIM_Try, /*On fail goto*//*Label 31240*/ GIMT_Encode4(2284982), // Rule ID 53487 //
     /* 2284939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2284942 */     // (fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2284942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2284945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2284949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2284954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2284956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2284959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2284961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2284964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2284966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2284968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2284971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2284974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2284977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2284980 */     GIR_RootConstrainSelectedInstOperands,
     /* 2284981 */     // GIR_Coverage, 53487,
     /* 2284981 */     GIR_EraseRootFromParent_Done,
     /* 2284982 */   // Label 31240: @2284982
     /* 2284982 */   GIM_Reject,
     /* 2284983 */ // Label 31238: @2284983
     /* 2284983 */ GIM_Reject,
     /* 2284984 */ // Label 31191: @2284984
     /* 2284984 */ GIM_Try, /*On fail goto*//*Label 31241*/ GIMT_Encode4(2285104),
     /* 2284989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2284992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2284995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2284999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2285007 */   GIM_Try, /*On fail goto*//*Label 31242*/ GIMT_Encode4(2285055), // Rule ID 53402 //
     /* 2285012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2285015 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2285018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2285032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285054 */     // GIR_Coverage, 53402,
     /* 2285054 */     GIR_EraseRootFromParent_Done,
     /* 2285055 */   // Label 31242: @2285055
     /* 2285055 */   GIM_Try, /*On fail goto*//*Label 31243*/ GIMT_Encode4(2285103), // Rule ID 53403 //
     /* 2285060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2285063 */     // (fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2285066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2285080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285101 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285102 */     // GIR_Coverage, 53403,
     /* 2285102 */     GIR_EraseRootFromParent_Done,
     /* 2285103 */   // Label 31243: @2285103
     /* 2285103 */   GIM_Reject,
     /* 2285104 */ // Label 31241: @2285104
     /* 2285104 */ GIM_Reject,
     /* 2285105 */ // Label 31192: @2285105
     /* 2285105 */ GIM_Try, /*On fail goto*//*Label 31244*/ GIMT_Encode4(2285225),
     /* 2285110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2285113 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2285116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285124 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285128 */   GIM_Try, /*On fail goto*//*Label 31245*/ GIMT_Encode4(2285176), // Rule ID 53450 //
     /* 2285133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2285136 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2285139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2285153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285160 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285175 */     // GIR_Coverage, 53450,
     /* 2285175 */     GIR_EraseRootFromParent_Done,
     /* 2285176 */   // Label 31245: @2285176
     /* 2285176 */   GIM_Try, /*On fail goto*//*Label 31246*/ GIMT_Encode4(2285224), // Rule ID 53451 //
     /* 2285181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2285184 */     // (fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2285187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2285201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285208 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285223 */     // GIR_Coverage, 53451,
     /* 2285223 */     GIR_EraseRootFromParent_Done,
     /* 2285224 */   // Label 31246: @2285224
     /* 2285224 */   GIM_Reject,
     /* 2285225 */ // Label 31244: @2285225
     /* 2285225 */ GIM_Reject,
     /* 2285226 */ // Label 31193: @2285226
     /* 2285226 */ GIM_Try, /*On fail goto*//*Label 31247*/ GIMT_Encode4(2285346),
     /* 2285231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2285234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2285237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285249 */   GIM_Try, /*On fail goto*//*Label 31248*/ GIMT_Encode4(2285297), // Rule ID 53498 //
     /* 2285254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2285257 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2285260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2285274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285296 */     // GIR_Coverage, 53498,
     /* 2285296 */     GIR_EraseRootFromParent_Done,
     /* 2285297 */   // Label 31248: @2285297
     /* 2285297 */   GIM_Try, /*On fail goto*//*Label 31249*/ GIMT_Encode4(2285345), // Rule ID 53499 //
     /* 2285302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2285305 */     // (fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2285308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2285322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285324 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2285340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285344 */     // GIR_Coverage, 53499,
     /* 2285344 */     GIR_EraseRootFromParent_Done,
     /* 2285345 */   // Label 31249: @2285345
     /* 2285345 */   GIM_Reject,
     /* 2285346 */ // Label 31247: @2285346
     /* 2285346 */ GIM_Reject,
     /* 2285347 */ // Label 31194: @2285347
     /* 2285347 */ GIM_Try, /*On fail goto*//*Label 31250*/ GIMT_Encode4(2285467),
     /* 2285352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2285355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2285358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285366 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2285370 */   GIM_Try, /*On fail goto*//*Label 31251*/ GIMT_Encode4(2285418), // Rule ID 53414 //
     /* 2285375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2285378 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2285381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2285395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285417 */     // GIR_Coverage, 53414,
     /* 2285417 */     GIR_EraseRootFromParent_Done,
     /* 2285418 */   // Label 31251: @2285418
     /* 2285418 */   GIM_Try, /*On fail goto*//*Label 31252*/ GIMT_Encode4(2285466), // Rule ID 53415 //
     /* 2285423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2285426 */     // (fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2285429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2285443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285450 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285465 */     // GIR_Coverage, 53415,
     /* 2285465 */     GIR_EraseRootFromParent_Done,
     /* 2285466 */   // Label 31252: @2285466
     /* 2285466 */   GIM_Reject,
     /* 2285467 */ // Label 31250: @2285467
     /* 2285467 */ GIM_Reject,
     /* 2285468 */ // Label 31195: @2285468
     /* 2285468 */ GIM_Try, /*On fail goto*//*Label 31253*/ GIMT_Encode4(2285588),
     /* 2285473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2285476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2285479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285491 */   GIM_Try, /*On fail goto*//*Label 31254*/ GIMT_Encode4(2285539), // Rule ID 53462 //
     /* 2285496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2285499 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2285502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2285516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285523 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285538 */     // GIR_Coverage, 53462,
     /* 2285538 */     GIR_EraseRootFromParent_Done,
     /* 2285539 */   // Label 31254: @2285539
     /* 2285539 */   GIM_Try, /*On fail goto*//*Label 31255*/ GIMT_Encode4(2285587), // Rule ID 53463 //
     /* 2285544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2285547 */     // (fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2285550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2285564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285566 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285571 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2285582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285586 */     // GIR_Coverage, 53463,
     /* 2285586 */     GIR_EraseRootFromParent_Done,
     /* 2285587 */   // Label 31255: @2285587
     /* 2285587 */   GIM_Reject,
     /* 2285588 */ // Label 31253: @2285588
     /* 2285588 */ GIM_Reject,
     /* 2285589 */ // Label 31196: @2285589
     /* 2285589 */ GIM_Try, /*On fail goto*//*Label 31256*/ GIMT_Encode4(2285709),
     /* 2285594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2285597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2285600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285608 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2285612 */   GIM_Try, /*On fail goto*//*Label 31257*/ GIMT_Encode4(2285660), // Rule ID 53426 //
     /* 2285617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2285620 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2285620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2285637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285659 */     // GIR_Coverage, 53426,
     /* 2285659 */     GIR_EraseRootFromParent_Done,
     /* 2285660 */   // Label 31257: @2285660
     /* 2285660 */   GIM_Try, /*On fail goto*//*Label 31258*/ GIMT_Encode4(2285708), // Rule ID 53427 //
     /* 2285665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2285668 */     // (fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2285668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2285671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2285675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2285680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2285682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2285685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2285690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285692 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2285700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2285703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2285706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285707 */     // GIR_Coverage, 53427,
     /* 2285707 */     GIR_EraseRootFromParent_Done,
     /* 2285708 */   // Label 31258: @2285708
     /* 2285708 */   GIM_Reject,
     /* 2285709 */ // Label 31256: @2285709
     /* 2285709 */ GIM_Reject,
     /* 2285710 */ // Label 31197: @2285710
     /* 2285710 */ GIM_Reject,
     /* 2285711 */ // Label 61: @2285711
     /* 2285711 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31277*/ GIMT_Encode4(2288138),
     /* 2285722 */ /*GILLT_s16*//*Label 31259*/ GIMT_Encode4(2285842),
     /* 2285726 */ /*GILLT_s32*//*Label 31260*/ GIMT_Encode4(2285991),
     /* 2285730 */ /*GILLT_s64*//*Label 31261*/ GIMT_Encode4(2286140), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285742 */ /*GILLT_nxv1s16*//*Label 31262*/ GIMT_Encode4(2286323),
     /* 2285746 */ /*GILLT_nxv1s32*//*Label 31263*/ GIMT_Encode4(2286444),
     /* 2285750 */ /*GILLT_nxv1s64*//*Label 31264*/ GIMT_Encode4(2286565), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285762 */ /*GILLT_nxv2s16*//*Label 31265*/ GIMT_Encode4(2286686),
     /* 2285766 */ /*GILLT_nxv2s32*//*Label 31266*/ GIMT_Encode4(2286807),
     /* 2285770 */ /*GILLT_nxv2s64*//*Label 31267*/ GIMT_Encode4(2286928), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285782 */ /*GILLT_nxv4s16*//*Label 31268*/ GIMT_Encode4(2287049),
     /* 2285786 */ /*GILLT_nxv4s32*//*Label 31269*/ GIMT_Encode4(2287170),
     /* 2285790 */ /*GILLT_nxv4s64*//*Label 31270*/ GIMT_Encode4(2287291), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285802 */ /*GILLT_nxv8s16*//*Label 31271*/ GIMT_Encode4(2287412),
     /* 2285806 */ /*GILLT_nxv8s32*//*Label 31272*/ GIMT_Encode4(2287533),
     /* 2285810 */ /*GILLT_nxv8s64*//*Label 31273*/ GIMT_Encode4(2287654), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285822 */ /*GILLT_nxv16s16*//*Label 31274*/ GIMT_Encode4(2287775),
     /* 2285826 */ /*GILLT_nxv16s32*//*Label 31275*/ GIMT_Encode4(2287896), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2285838 */ /*GILLT_nxv32s16*//*Label 31276*/ GIMT_Encode4(2288017),
     /* 2285842 */ // Label 31259: @2285842
     /* 2285842 */ GIM_Try, /*On fail goto*//*Label 31278*/ GIMT_Encode4(2285990),
     /* 2285847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2285850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2285853 */   GIM_Try, /*On fail goto*//*Label 31279*/ GIMT_Encode4(2285887), // Rule ID 1864 //
     /* 2285858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2285861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285873 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2285873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2285876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285878 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285880 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285886 */     // GIR_Coverage, 1864,
     /* 2285886 */     GIR_EraseRootFromParent_Done,
     /* 2285887 */   // Label 31279: @2285887
     /* 2285887 */   GIM_Try, /*On fail goto*//*Label 31280*/ GIMT_Encode4(2285921), // Rule ID 1865 //
     /* 2285892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2285895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2285907 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2285907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2285910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285920 */     // GIR_Coverage, 1865,
     /* 2285920 */     GIR_EraseRootFromParent_Done,
     /* 2285921 */   // Label 31280: @2285921
     /* 2285921 */   GIM_Try, /*On fail goto*//*Label 31281*/ GIMT_Encode4(2285955), // Rule ID 1868 //
     /* 2285926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2285929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285941 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2285941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2285944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285946 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285948 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285953 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285954 */     // GIR_Coverage, 1868,
     /* 2285954 */     GIR_EraseRootFromParent_Done,
     /* 2285955 */   // Label 31281: @2285955
     /* 2285955 */   GIM_Try, /*On fail goto*//*Label 31282*/ GIMT_Encode4(2285989), // Rule ID 1869 //
     /* 2285960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2285963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2285975 */     // (fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2285975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2285978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2285980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2285982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2285984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2285987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2285988 */     // GIR_Coverage, 1869,
     /* 2285988 */     GIR_EraseRootFromParent_Done,
     /* 2285989 */   // Label 31282: @2285989
     /* 2285989 */   GIM_Reject,
     /* 2285990 */ // Label 31278: @2285990
     /* 2285990 */ GIM_Reject,
     /* 2285991 */ // Label 31260: @2285991
     /* 2285991 */ GIM_Try, /*On fail goto*//*Label 31283*/ GIMT_Encode4(2286139),
     /* 2285996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2285999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2286002 */   GIM_Try, /*On fail goto*//*Label 31284*/ GIMT_Encode4(2286036), // Rule ID 1155 //
     /* 2286007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2286010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286022 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2286022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2286025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286035 */     // GIR_Coverage, 1155,
     /* 2286035 */     GIR_EraseRootFromParent_Done,
     /* 2286036 */   // Label 31284: @2286036
     /* 2286036 */   GIM_Try, /*On fail goto*//*Label 31285*/ GIMT_Encode4(2286070), // Rule ID 1156 //
     /* 2286041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2286044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2286056 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2286056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2286059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286063 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286069 */     // GIR_Coverage, 1156,
     /* 2286069 */     GIR_EraseRootFromParent_Done,
     /* 2286070 */   // Label 31285: @2286070
     /* 2286070 */   GIM_Try, /*On fail goto*//*Label 31286*/ GIMT_Encode4(2286104), // Rule ID 1159 //
     /* 2286075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2286078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286090 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2286090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2286093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286103 */     // GIR_Coverage, 1159,
     /* 2286103 */     GIR_EraseRootFromParent_Done,
     /* 2286104 */   // Label 31286: @2286104
     /* 2286104 */   GIM_Try, /*On fail goto*//*Label 31287*/ GIMT_Encode4(2286138), // Rule ID 1160 //
     /* 2286109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2286112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2286124 */     // (fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2286124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2286127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286137 */     // GIR_Coverage, 1160,
     /* 2286137 */     GIR_EraseRootFromParent_Done,
     /* 2286138 */   // Label 31287: @2286138
     /* 2286138 */   GIM_Reject,
     /* 2286139 */ // Label 31283: @2286139
     /* 2286139 */ GIM_Reject,
     /* 2286140 */ // Label 31261: @2286140
     /* 2286140 */ GIM_Try, /*On fail goto*//*Label 31288*/ GIMT_Encode4(2286322),
     /* 2286145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286148 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2286151 */   GIM_Try, /*On fail goto*//*Label 31289*/ GIMT_Encode4(2286185), // Rule ID 1494 //
     /* 2286156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2286159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286171 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2286171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2286174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286184 */     // GIR_Coverage, 1494,
     /* 2286184 */     GIR_EraseRootFromParent_Done,
     /* 2286185 */   // Label 31289: @2286185
     /* 2286185 */   GIM_Try, /*On fail goto*//*Label 31290*/ GIMT_Encode4(2286219), // Rule ID 1495 //
     /* 2286190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2286193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2286205 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2286205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2286208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286218 */     // GIR_Coverage, 1495,
     /* 2286218 */     GIR_EraseRootFromParent_Done,
     /* 2286219 */   // Label 31290: @2286219
     /* 2286219 */   GIM_Try, /*On fail goto*//*Label 31291*/ GIMT_Encode4(2286253), // Rule ID 1498 //
     /* 2286224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2286227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286239 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2286239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2286242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286252 */     // GIR_Coverage, 1498,
     /* 2286252 */     GIR_EraseRootFromParent_Done,
     /* 2286253 */   // Label 31291: @2286253
     /* 2286253 */   GIM_Try, /*On fail goto*//*Label 31292*/ GIMT_Encode4(2286287), // Rule ID 1499 //
     /* 2286258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2286261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2286273 */     // (fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2286273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2286276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286286 */     // GIR_Coverage, 1499,
     /* 2286286 */     GIR_EraseRootFromParent_Done,
     /* 2286287 */   // Label 31292: @2286287
     /* 2286287 */   GIM_Try, /*On fail goto*//*Label 31293*/ GIMT_Encode4(2286321), // Rule ID 1501 //
     /* 2286292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2286295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2286307 */     // (fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2286307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2286310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286312 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286314 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286320 */     // GIR_Coverage, 1501,
     /* 2286320 */     GIR_EraseRootFromParent_Done,
     /* 2286321 */   // Label 31293: @2286321
     /* 2286321 */   GIM_Reject,
     /* 2286322 */ // Label 31288: @2286322
     /* 2286322 */ GIM_Reject,
     /* 2286323 */ // Label 31262: @2286323
     /* 2286323 */ GIM_Try, /*On fail goto*//*Label 31294*/ GIMT_Encode4(2286443),
     /* 2286328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2286331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2286334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286346 */   GIM_Try, /*On fail goto*//*Label 31295*/ GIMT_Encode4(2286394), // Rule ID 54098 //
     /* 2286351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286354 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2286357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2286371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286393 */     // GIR_Coverage, 54098,
     /* 2286393 */     GIR_EraseRootFromParent_Done,
     /* 2286394 */   // Label 31295: @2286394
     /* 2286394 */   GIM_Try, /*On fail goto*//*Label 31296*/ GIMT_Encode4(2286442), // Rule ID 54099 //
     /* 2286399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286402 */     // (fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2286405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2286419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286441 */     // GIR_Coverage, 54099,
     /* 2286441 */     GIR_EraseRootFromParent_Done,
     /* 2286442 */   // Label 31296: @2286442
     /* 2286442 */   GIM_Reject,
     /* 2286443 */ // Label 31294: @2286443
     /* 2286443 */ GIM_Reject,
     /* 2286444 */ // Label 31263: @2286444
     /* 2286444 */ GIM_Try, /*On fail goto*//*Label 31297*/ GIMT_Encode4(2286564),
     /* 2286449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2286452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2286455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286467 */   GIM_Try, /*On fail goto*//*Label 31298*/ GIMT_Encode4(2286515), // Rule ID 54122 //
     /* 2286472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2286475 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2286478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2286492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286514 */     // GIR_Coverage, 54122,
     /* 2286514 */     GIR_EraseRootFromParent_Done,
     /* 2286515 */   // Label 31298: @2286515
     /* 2286515 */   GIM_Try, /*On fail goto*//*Label 31299*/ GIMT_Encode4(2286563), // Rule ID 54123 //
     /* 2286520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2286523 */     // (fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2286526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286535 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2286540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286561 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286562 */     // GIR_Coverage, 54123,
     /* 2286562 */     GIR_EraseRootFromParent_Done,
     /* 2286563 */   // Label 31299: @2286563
     /* 2286563 */   GIM_Reject,
     /* 2286564 */ // Label 31297: @2286564
     /* 2286564 */ GIM_Reject,
     /* 2286565 */ // Label 31264: @2286565
     /* 2286565 */ GIM_Try, /*On fail goto*//*Label 31300*/ GIMT_Encode4(2286685),
     /* 2286570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2286573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2286576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286588 */   GIM_Try, /*On fail goto*//*Label 31301*/ GIMT_Encode4(2286636), // Rule ID 54158 //
     /* 2286593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2286596 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2286599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2286613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286635 */     // GIR_Coverage, 54158,
     /* 2286635 */     GIR_EraseRootFromParent_Done,
     /* 2286636 */   // Label 31301: @2286636
     /* 2286636 */   GIM_Try, /*On fail goto*//*Label 31302*/ GIMT_Encode4(2286684), // Rule ID 54159 //
     /* 2286641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2286644 */     // (fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2286647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2286661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286683 */     // GIR_Coverage, 54159,
     /* 2286683 */     GIR_EraseRootFromParent_Done,
     /* 2286684 */   // Label 31302: @2286684
     /* 2286684 */   GIM_Reject,
     /* 2286685 */ // Label 31300: @2286685
     /* 2286685 */ GIM_Reject,
     /* 2286686 */ // Label 31265: @2286686
     /* 2286686 */ GIM_Try, /*On fail goto*//*Label 31303*/ GIMT_Encode4(2286806),
     /* 2286691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2286694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2286697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286709 */   GIM_Try, /*On fail goto*//*Label 31304*/ GIMT_Encode4(2286757), // Rule ID 54110 //
     /* 2286714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2286717 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2286734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286756 */     // GIR_Coverage, 54110,
     /* 2286756 */     GIR_EraseRootFromParent_Done,
     /* 2286757 */   // Label 31304: @2286757
     /* 2286757 */   GIM_Try, /*On fail goto*//*Label 31305*/ GIMT_Encode4(2286805), // Rule ID 54111 //
     /* 2286762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2286765 */     // (fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2286768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2286782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2286800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286803 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286804 */     // GIR_Coverage, 54111,
     /* 2286804 */     GIR_EraseRootFromParent_Done,
     /* 2286805 */   // Label 31305: @2286805
     /* 2286805 */   GIM_Reject,
     /* 2286806 */ // Label 31303: @2286806
     /* 2286806 */ GIM_Reject,
     /* 2286807 */ // Label 31266: @2286807
     /* 2286807 */ GIM_Try, /*On fail goto*//*Label 31306*/ GIMT_Encode4(2286927),
     /* 2286812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2286815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2286818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2286830 */   GIM_Try, /*On fail goto*//*Label 31307*/ GIMT_Encode4(2286878), // Rule ID 54146 //
     /* 2286835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2286838 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2286855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286877 */     // GIR_Coverage, 54146,
     /* 2286877 */     GIR_EraseRootFromParent_Done,
     /* 2286878 */   // Label 31307: @2286878
     /* 2286878 */   GIM_Try, /*On fail goto*//*Label 31308*/ GIMT_Encode4(2286926), // Rule ID 54147 //
     /* 2286883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2286886 */     // (fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2286886 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2286889 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286893 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2286903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2286921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286925 */     // GIR_Coverage, 54147,
     /* 2286925 */     GIR_EraseRootFromParent_Done,
     /* 2286926 */   // Label 31308: @2286926
     /* 2286926 */   GIM_Reject,
     /* 2286927 */ // Label 31306: @2286927
     /* 2286927 */ GIM_Reject,
     /* 2286928 */ // Label 31267: @2286928
     /* 2286928 */ GIM_Try, /*On fail goto*//*Label 31309*/ GIMT_Encode4(2287048),
     /* 2286933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2286936 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2286939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286947 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2286951 */   GIM_Try, /*On fail goto*//*Label 31310*/ GIMT_Encode4(2286999), // Rule ID 54242 //
     /* 2286956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2286959 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2286959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2286962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2286966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2286971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2286973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2286976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2286978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2286981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2286983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2286985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2286988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2286991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2286994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2286997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2286998 */     // GIR_Coverage, 54242,
     /* 2286998 */     GIR_EraseRootFromParent_Done,
     /* 2286999 */   // Label 31310: @2286999
     /* 2286999 */   GIM_Try, /*On fail goto*//*Label 31311*/ GIMT_Encode4(2287047), // Rule ID 54243 //
     /* 2287004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2287007 */     // (fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2287010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2287024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287046 */     // GIR_Coverage, 54243,
     /* 2287046 */     GIR_EraseRootFromParent_Done,
     /* 2287047 */   // Label 31311: @2287047
     /* 2287047 */   GIM_Reject,
     /* 2287048 */ // Label 31309: @2287048
     /* 2287048 */ GIM_Reject,
     /* 2287049 */ // Label 31268: @2287049
     /* 2287049 */ GIM_Try, /*On fail goto*//*Label 31312*/ GIMT_Encode4(2287169),
     /* 2287054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2287057 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2287060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287068 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2287072 */   GIM_Try, /*On fail goto*//*Label 31313*/ GIMT_Encode4(2287120), // Rule ID 54134 //
     /* 2287077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287080 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2287083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2287097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287119 */     // GIR_Coverage, 54134,
     /* 2287119 */     GIR_EraseRootFromParent_Done,
     /* 2287120 */   // Label 31313: @2287120
     /* 2287120 */   GIM_Try, /*On fail goto*//*Label 31314*/ GIMT_Encode4(2287168), // Rule ID 54135 //
     /* 2287125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287128 */     // (fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2287131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2287145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287147 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287167 */     // GIR_Coverage, 54135,
     /* 2287167 */     GIR_EraseRootFromParent_Done,
     /* 2287168 */   // Label 31314: @2287168
     /* 2287168 */   GIM_Reject,
     /* 2287169 */ // Label 31312: @2287169
     /* 2287169 */ GIM_Reject,
     /* 2287170 */ // Label 31269: @2287170
     /* 2287170 */ GIM_Try, /*On fail goto*//*Label 31315*/ GIMT_Encode4(2287290),
     /* 2287175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2287178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2287181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287189 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287193 */   GIM_Try, /*On fail goto*//*Label 31316*/ GIMT_Encode4(2287241), // Rule ID 54206 //
     /* 2287198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287201 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2287204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2287218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287240 */     // GIR_Coverage, 54206,
     /* 2287240 */     GIR_EraseRootFromParent_Done,
     /* 2287241 */   // Label 31316: @2287241
     /* 2287241 */   GIM_Try, /*On fail goto*//*Label 31317*/ GIMT_Encode4(2287289), // Rule ID 54207 //
     /* 2287246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287249 */     // (fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2287252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2287266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287288 */     // GIR_Coverage, 54207,
     /* 2287288 */     GIR_EraseRootFromParent_Done,
     /* 2287289 */   // Label 31317: @2287289
     /* 2287289 */   GIM_Reject,
     /* 2287290 */ // Label 31315: @2287290
     /* 2287290 */ GIM_Reject,
     /* 2287291 */ // Label 31270: @2287291
     /* 2287291 */ GIM_Try, /*On fail goto*//*Label 31318*/ GIMT_Encode4(2287411),
     /* 2287296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2287299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2287302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287314 */   GIM_Try, /*On fail goto*//*Label 31319*/ GIMT_Encode4(2287362), // Rule ID 54254 //
     /* 2287319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2287322 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2287325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2287339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287361 */     // GIR_Coverage, 54254,
     /* 2287361 */     GIR_EraseRootFromParent_Done,
     /* 2287362 */   // Label 31319: @2287362
     /* 2287362 */   GIM_Try, /*On fail goto*//*Label 31320*/ GIMT_Encode4(2287410), // Rule ID 54255 //
     /* 2287367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2287370 */     // (fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2287373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287382 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2287387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287389 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287392 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287394 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287409 */     // GIR_Coverage, 54255,
     /* 2287409 */     GIR_EraseRootFromParent_Done,
     /* 2287410 */   // Label 31320: @2287410
     /* 2287410 */   GIM_Reject,
     /* 2287411 */ // Label 31318: @2287411
     /* 2287411 */ GIM_Reject,
     /* 2287412 */ // Label 31271: @2287412
     /* 2287412 */ GIM_Try, /*On fail goto*//*Label 31321*/ GIMT_Encode4(2287532),
     /* 2287417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2287420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2287423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2287435 */   GIM_Try, /*On fail goto*//*Label 31322*/ GIMT_Encode4(2287483), // Rule ID 54170 //
     /* 2287440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287443 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2287460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287482 */     // GIR_Coverage, 54170,
     /* 2287482 */     GIR_EraseRootFromParent_Done,
     /* 2287483 */   // Label 31322: @2287483
     /* 2287483 */   GIM_Try, /*On fail goto*//*Label 31323*/ GIMT_Encode4(2287531), // Rule ID 54171 //
     /* 2287488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287491 */     // (fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2287494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2287508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287530 */     // GIR_Coverage, 54171,
     /* 2287530 */     GIR_EraseRootFromParent_Done,
     /* 2287531 */   // Label 31323: @2287531
     /* 2287531 */   GIM_Reject,
     /* 2287532 */ // Label 31321: @2287532
     /* 2287532 */ GIM_Reject,
     /* 2287533 */ // Label 31272: @2287533
     /* 2287533 */ GIM_Try, /*On fail goto*//*Label 31324*/ GIMT_Encode4(2287653),
     /* 2287538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2287541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2287544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287556 */   GIM_Try, /*On fail goto*//*Label 31325*/ GIMT_Encode4(2287604), // Rule ID 54218 //
     /* 2287561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287564 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2287581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287603 */     // GIR_Coverage, 54218,
     /* 2287603 */     GIR_EraseRootFromParent_Done,
     /* 2287604 */   // Label 31325: @2287604
     /* 2287604 */   GIM_Try, /*On fail goto*//*Label 31326*/ GIMT_Encode4(2287652), // Rule ID 54219 //
     /* 2287609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287612 */     // (fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2287615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2287629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287631 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287634 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287636 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287650 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287651 */     // GIR_Coverage, 54219,
     /* 2287651 */     GIR_EraseRootFromParent_Done,
     /* 2287652 */   // Label 31326: @2287652
     /* 2287652 */   GIM_Reject,
     /* 2287653 */ // Label 31324: @2287653
     /* 2287653 */ GIM_Reject,
     /* 2287654 */ // Label 31273: @2287654
     /* 2287654 */ GIM_Try, /*On fail goto*//*Label 31327*/ GIMT_Encode4(2287774),
     /* 2287659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2287662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2287665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287673 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287677 */   GIM_Try, /*On fail goto*//*Label 31328*/ GIMT_Encode4(2287725), // Rule ID 54266 //
     /* 2287682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2287685 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2287702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287724 */     // GIR_Coverage, 54266,
     /* 2287724 */     GIR_EraseRootFromParent_Done,
     /* 2287725 */   // Label 31328: @2287725
     /* 2287725 */   GIM_Try, /*On fail goto*//*Label 31329*/ GIMT_Encode4(2287773), // Rule ID 54267 //
     /* 2287730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2287733 */     // (fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287733 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2287736 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287740 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2287750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2287768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287772 */     // GIR_Coverage, 54267,
     /* 2287772 */     GIR_EraseRootFromParent_Done,
     /* 2287773 */   // Label 31329: @2287773
     /* 2287773 */   GIM_Reject,
     /* 2287774 */ // Label 31327: @2287774
     /* 2287774 */ GIM_Reject,
     /* 2287775 */ // Label 31274: @2287775
     /* 2287775 */ GIM_Try, /*On fail goto*//*Label 31330*/ GIMT_Encode4(2287895),
     /* 2287780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2287783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2287786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2287798 */   GIM_Try, /*On fail goto*//*Label 31331*/ GIMT_Encode4(2287846), // Rule ID 54182 //
     /* 2287803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2287806 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2287823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287845 */     // GIR_Coverage, 54182,
     /* 2287845 */     GIR_EraseRootFromParent_Done,
     /* 2287846 */   // Label 31331: @2287846
     /* 2287846 */   GIM_Try, /*On fail goto*//*Label 31332*/ GIMT_Encode4(2287894), // Rule ID 54183 //
     /* 2287851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2287854 */     // (fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2287857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2287871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287878 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2287889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287892 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287893 */     // GIR_Coverage, 54183,
     /* 2287893 */     GIR_EraseRootFromParent_Done,
     /* 2287894 */   // Label 31332: @2287894
     /* 2287894 */   GIM_Reject,
     /* 2287895 */ // Label 31330: @2287895
     /* 2287895 */ GIM_Reject,
     /* 2287896 */ // Label 31275: @2287896
     /* 2287896 */ GIM_Try, /*On fail goto*//*Label 31333*/ GIMT_Encode4(2288016),
     /* 2287901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2287904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2287907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287915 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2287919 */   GIM_Try, /*On fail goto*//*Label 31334*/ GIMT_Encode4(2287967), // Rule ID 54230 //
     /* 2287924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2287927 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2287927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2287944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2287953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2287956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2287959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2287962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2287965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2287966 */     // GIR_Coverage, 54230,
     /* 2287966 */     GIR_EraseRootFromParent_Done,
     /* 2287967 */   // Label 31334: @2287967
     /* 2287967 */   GIM_Try, /*On fail goto*//*Label 31335*/ GIMT_Encode4(2288015), // Rule ID 54231 //
     /* 2287972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2287975 */     // (fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2287975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2287978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2287982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2287987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2287989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2287992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2287994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2287997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2287999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2288010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288014 */     // GIR_Coverage, 54231,
     /* 2288014 */     GIR_EraseRootFromParent_Done,
     /* 2288015 */   // Label 31335: @2288015
     /* 2288015 */   GIM_Reject,
     /* 2288016 */ // Label 31333: @2288016
     /* 2288016 */ GIM_Reject,
     /* 2288017 */ // Label 31276: @2288017
     /* 2288017 */ GIM_Try, /*On fail goto*//*Label 31336*/ GIMT_Encode4(2288137),
     /* 2288022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2288025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2288028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2288032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2288036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2288040 */   GIM_Try, /*On fail goto*//*Label 31337*/ GIMT_Encode4(2288088), // Rule ID 54194 //
     /* 2288045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2288048 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2288048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2288051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2288065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288087 */     // GIR_Coverage, 54194,
     /* 2288087 */     GIR_EraseRootFromParent_Done,
     /* 2288088 */   // Label 31337: @2288088
     /* 2288088 */   GIM_Try, /*On fail goto*//*Label 31338*/ GIMT_Encode4(2288136), // Rule ID 54195 //
     /* 2288093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2288096 */     // (fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2288096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2288099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2288103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2288108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2288110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2288113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2288118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2288120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2288128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2288131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2288134 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288135 */     // GIR_Coverage, 54195,
     /* 2288135 */     GIR_EraseRootFromParent_Done,
     /* 2288136 */   // Label 31338: @2288136
     /* 2288136 */   GIM_Reject,
     /* 2288137 */ // Label 31336: @2288137
     /* 2288137 */ GIM_Reject,
     /* 2288138 */ // Label 31277: @2288138
     /* 2288138 */ GIM_Reject,
     /* 2288139 */ // Label 62: @2288139
     /* 2288139 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31357*/ GIMT_Encode4(2304783),
     /* 2288150 */ /*GILLT_s16*//*Label 31339*/ GIMT_Encode4(2288270),
     /* 2288154 */ /*GILLT_s32*//*Label 31340*/ GIMT_Encode4(2289706),
     /* 2288158 */ /*GILLT_s64*//*Label 31341*/ GIMT_Encode4(2291142), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288170 */ /*GILLT_nxv1s16*//*Label 31342*/ GIMT_Encode4(2292933),
     /* 2288174 */ /*GILLT_nxv1s32*//*Label 31343*/ GIMT_Encode4(2293723),
     /* 2288178 */ /*GILLT_nxv1s64*//*Label 31344*/ GIMT_Encode4(2294513), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288190 */ /*GILLT_nxv2s16*//*Label 31345*/ GIMT_Encode4(2295303),
     /* 2288194 */ /*GILLT_nxv2s32*//*Label 31346*/ GIMT_Encode4(2296093),
     /* 2288198 */ /*GILLT_nxv2s64*//*Label 31347*/ GIMT_Encode4(2296883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288210 */ /*GILLT_nxv4s16*//*Label 31348*/ GIMT_Encode4(2297673),
     /* 2288214 */ /*GILLT_nxv4s32*//*Label 31349*/ GIMT_Encode4(2298463),
     /* 2288218 */ /*GILLT_nxv4s64*//*Label 31350*/ GIMT_Encode4(2299253), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288230 */ /*GILLT_nxv8s16*//*Label 31351*/ GIMT_Encode4(2300043),
     /* 2288234 */ /*GILLT_nxv8s32*//*Label 31352*/ GIMT_Encode4(2300833),
     /* 2288238 */ /*GILLT_nxv8s64*//*Label 31353*/ GIMT_Encode4(2301623), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288250 */ /*GILLT_nxv16s16*//*Label 31354*/ GIMT_Encode4(2302413),
     /* 2288254 */ /*GILLT_nxv16s32*//*Label 31355*/ GIMT_Encode4(2303203), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2288266 */ /*GILLT_nxv32s16*//*Label 31356*/ GIMT_Encode4(2303993),
     /* 2288270 */ // Label 31339: @2288270
     /* 2288270 */ GIM_Try, /*On fail goto*//*Label 31358*/ GIMT_Encode4(2289705),
     /* 2288275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288278 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2288281 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2288284 */   GIM_Try, /*On fail goto*//*Label 31359*/ GIMT_Encode4(2288356), // Rule ID 1905 //
     /* 2288289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2288292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288329 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288336 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2288336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2288339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288345 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288355 */     // GIR_Coverage, 1905,
     /* 2288355 */     GIR_EraseRootFromParent_Done,
     /* 2288356 */   // Label 31359: @2288356
     /* 2288356 */   GIM_Try, /*On fail goto*//*Label 31360*/ GIMT_Encode4(2288428), // Rule ID 1906 //
     /* 2288361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2288364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288372 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288376 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288408 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2288408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2288411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288427 */     // GIR_Coverage, 1906,
     /* 2288427 */     GIR_EraseRootFromParent_Done,
     /* 2288428 */   // Label 31360: @2288428
     /* 2288428 */   GIM_Try, /*On fail goto*//*Label 31361*/ GIMT_Encode4(2288500), // Rule ID 1938 //
     /* 2288433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2288436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288480 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2288480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2288483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288499 */     // GIR_Coverage, 1938,
     /* 2288499 */     GIR_EraseRootFromParent_Done,
     /* 2288500 */   // Label 31361: @2288500
     /* 2288500 */   GIM_Try, /*On fail goto*//*Label 31362*/ GIMT_Encode4(2288572), // Rule ID 1939 //
     /* 2288505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2288508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288552 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2288552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2288555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288571 */     // GIR_Coverage, 1939,
     /* 2288571 */     GIR_EraseRootFromParent_Done,
     /* 2288572 */   // Label 31362: @2288572
     /* 2288572 */   GIM_Try, /*On fail goto*//*Label 31363*/ GIMT_Encode4(2288644), // Rule ID 65107 //
     /* 2288577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2288580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288624 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2288624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2288627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288633 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2288635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288643 */     // GIR_Coverage, 65107,
     /* 2288643 */     GIR_EraseRootFromParent_Done,
     /* 2288644 */   // Label 31363: @2288644
     /* 2288644 */   GIM_Try, /*On fail goto*//*Label 31364*/ GIMT_Encode4(2288716), // Rule ID 65108 //
     /* 2288649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2288652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288694 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288696 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2288696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2288699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2288707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288714 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288715 */     // GIR_Coverage, 65108,
     /* 2288715 */     GIR_EraseRootFromParent_Done,
     /* 2288716 */   // Label 31364: @2288716
     /* 2288716 */   GIM_Try, /*On fail goto*//*Label 31365*/ GIMT_Encode4(2288788), // Rule ID 65115 //
     /* 2288721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2288724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288766 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288768 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2288768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2288771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2288779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288787 */     // GIR_Coverage, 65115,
     /* 2288787 */     GIR_EraseRootFromParent_Done,
     /* 2288788 */   // Label 31365: @2288788
     /* 2288788 */   GIM_Try, /*On fail goto*//*Label 31366*/ GIMT_Encode4(2288860), // Rule ID 65116 //
     /* 2288793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2288796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2288808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288821 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2288825 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288829 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2288840 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2288840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2288843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2288851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2288855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288858 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288859 */     // GIR_Coverage, 65116,
     /* 2288859 */     GIR_EraseRootFromParent_Done,
     /* 2288860 */   // Label 31366: @2288860
     /* 2288860 */   GIM_Try, /*On fail goto*//*Label 31367*/ GIMT_Encode4(2288917), // Rule ID 1901 //
     /* 2288865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2288868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288899 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2288899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2288902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288910 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2288912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288916 */     // GIR_Coverage, 1901,
     /* 2288916 */     GIR_EraseRootFromParent_Done,
     /* 2288917 */   // Label 31367: @2288917
     /* 2288917 */   GIM_Try, /*On fail goto*//*Label 31368*/ GIMT_Encode4(2288974), // Rule ID 1902 //
     /* 2288922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2288925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2288954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2288956 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2288956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2288959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2288961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2288965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2288967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2288969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2288972 */     GIR_RootConstrainSelectedInstOperands,
     /* 2288973 */     // GIR_Coverage, 1902,
     /* 2288973 */     GIR_EraseRootFromParent_Done,
     /* 2288974 */   // Label 31368: @2288974
     /* 2288974 */   GIM_Try, /*On fail goto*//*Label 31369*/ GIMT_Encode4(2289031), // Rule ID 1934 //
     /* 2288979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2288982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2288986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2288990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2288994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2288998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289013 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2289016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289024 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289030 */     // GIR_Coverage, 1934,
     /* 2289030 */     GIR_EraseRootFromParent_Done,
     /* 2289031 */   // Label 31369: @2289031
     /* 2289031 */   GIM_Try, /*On fail goto*//*Label 31370*/ GIMT_Encode4(2289088), // Rule ID 1935 //
     /* 2289036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2289039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289070 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2289073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289079 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289081 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289087 */     // GIR_Coverage, 1935,
     /* 2289087 */     GIR_EraseRootFromParent_Done,
     /* 2289088 */   // Label 31370: @2289088
     /* 2289088 */   GIM_Try, /*On fail goto*//*Label 31371*/ GIMT_Encode4(2289145), // Rule ID 65103 //
     /* 2289093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2289096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289127 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2289130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2289138 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289144 */     // GIR_Coverage, 65103,
     /* 2289144 */     GIR_EraseRootFromParent_Done,
     /* 2289145 */   // Label 31371: @2289145
     /* 2289145 */   GIM_Try, /*On fail goto*//*Label 31372*/ GIMT_Encode4(2289202), // Rule ID 65104 //
     /* 2289150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2289153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289184 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2289187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2289195 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289201 */     // GIR_Coverage, 65104,
     /* 2289201 */     GIR_EraseRootFromParent_Done,
     /* 2289202 */   // Label 31372: @2289202
     /* 2289202 */   GIM_Try, /*On fail goto*//*Label 31373*/ GIMT_Encode4(2289259), // Rule ID 65111 //
     /* 2289207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2289210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289241 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2289244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2289252 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289258 */     // GIR_Coverage, 65111,
     /* 2289258 */     GIR_EraseRootFromParent_Done,
     /* 2289259 */   // Label 31373: @2289259
     /* 2289259 */   GIM_Try, /*On fail goto*//*Label 31374*/ GIMT_Encode4(2289316), // Rule ID 65112 //
     /* 2289264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2289267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2289279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289298 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2289301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2289309 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289315 */     // GIR_Coverage, 65112,
     /* 2289315 */     GIR_EraseRootFromParent_Done,
     /* 2289316 */   // Label 31374: @2289316
     /* 2289316 */   GIM_Try, /*On fail goto*//*Label 31375*/ GIMT_Encode4(2289373), // Rule ID 1897 //
     /* 2289321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2289324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289355 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2289358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2289368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289372 */     // GIR_Coverage, 1897,
     /* 2289372 */     GIR_EraseRootFromParent_Done,
     /* 2289373 */   // Label 31375: @2289373
     /* 2289373 */   GIM_Try, /*On fail goto*//*Label 31376*/ GIMT_Encode4(2289430), // Rule ID 1898 //
     /* 2289378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2289381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289412 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2289415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2289425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289429 */     // GIR_Coverage, 1898,
     /* 2289429 */     GIR_EraseRootFromParent_Done,
     /* 2289430 */   // Label 31376: @2289430
     /* 2289430 */   GIM_Try, /*On fail goto*//*Label 31377*/ GIMT_Encode4(2289487), // Rule ID 1930 //
     /* 2289435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2289438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289469 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2289472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2289482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289486 */     // GIR_Coverage, 1930,
     /* 2289486 */     GIR_EraseRootFromParent_Done,
     /* 2289487 */   // Label 31377: @2289487
     /* 2289487 */   GIM_Try, /*On fail goto*//*Label 31378*/ GIMT_Encode4(2289544), // Rule ID 1931 //
     /* 2289492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2289495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2289511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2289519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2289526 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2289529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2289539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289543 */     // GIR_Coverage, 1931,
     /* 2289543 */     GIR_EraseRootFromParent_Done,
     /* 2289544 */   // Label 31378: @2289544
     /* 2289544 */   GIM_Try, /*On fail goto*//*Label 31379*/ GIMT_Encode4(2289584), // Rule ID 1893 //
     /* 2289549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2289552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289568 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2289571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289577 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289582 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289583 */     // GIR_Coverage, 1893,
     /* 2289583 */     GIR_EraseRootFromParent_Done,
     /* 2289584 */   // Label 31379: @2289584
     /* 2289584 */   GIM_Try, /*On fail goto*//*Label 31380*/ GIMT_Encode4(2289624), // Rule ID 1894 //
     /* 2289589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2289592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2289608 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2289611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289617 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289623 */     // GIR_Coverage, 1894,
     /* 2289623 */     GIR_EraseRootFromParent_Done,
     /* 2289624 */   // Label 31380: @2289624
     /* 2289624 */   GIM_Try, /*On fail goto*//*Label 31381*/ GIMT_Encode4(2289664), // Rule ID 1926 //
     /* 2289629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2289632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289648 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2289648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2289651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289663 */     // GIR_Coverage, 1926,
     /* 2289663 */     GIR_EraseRootFromParent_Done,
     /* 2289664 */   // Label 31381: @2289664
     /* 2289664 */   GIM_Try, /*On fail goto*//*Label 31382*/ GIMT_Encode4(2289704), // Rule ID 1927 //
     /* 2289669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2289672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289676 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2289688 */     // (fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2289688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2289691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2289695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2289699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289703 */     // GIR_Coverage, 1927,
     /* 2289703 */     GIR_EraseRootFromParent_Done,
     /* 2289704 */   // Label 31382: @2289704
     /* 2289704 */   GIM_Reject,
     /* 2289705 */ // Label 31358: @2289705
     /* 2289705 */ GIM_Reject,
     /* 2289706 */ // Label 31340: @2289706
     /* 2289706 */ GIM_Try, /*On fail goto*//*Label 31383*/ GIMT_Encode4(2291141),
     /* 2289711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2289717 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2289720 */   GIM_Try, /*On fail goto*//*Label 31384*/ GIMT_Encode4(2289792), // Rule ID 1204 //
     /* 2289725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2289728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289744 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289772 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2289772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2289775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2289787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289791 */     // GIR_Coverage, 1204,
     /* 2289791 */     GIR_EraseRootFromParent_Done,
     /* 2289792 */   // Label 31384: @2289792
     /* 2289792 */   GIM_Try, /*On fail goto*//*Label 31385*/ GIMT_Encode4(2289864), // Rule ID 1205 //
     /* 2289797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2289800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289816 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2289842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289844 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2289844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2289847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289853 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2289859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289863 */     // GIR_Coverage, 1205,
     /* 2289863 */     GIR_EraseRootFromParent_Done,
     /* 2289864 */   // Label 31385: @2289864
     /* 2289864 */   GIM_Try, /*On fail goto*//*Label 31386*/ GIMT_Encode4(2289936), // Rule ID 1225 //
     /* 2289869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2289872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289905 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289916 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2289916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2289919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2289931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2289934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2289935 */     // GIR_Coverage, 1225,
     /* 2289935 */     GIR_EraseRootFromParent_Done,
     /* 2289936 */   // Label 31386: @2289936
     /* 2289936 */   GIM_Try, /*On fail goto*//*Label 31387*/ GIMT_Encode4(2290008), // Rule ID 1226 //
     /* 2289941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2289944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2289952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2289973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2289977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2289981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2289986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2289988 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2289988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2289991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2289993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2289997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2289999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2290003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290007 */     // GIR_Coverage, 1226,
     /* 2290007 */     GIR_EraseRootFromParent_Done,
     /* 2290008 */   // Label 31387: @2290008
     /* 2290008 */   GIM_Try, /*On fail goto*//*Label 31388*/ GIMT_Encode4(2290080), // Rule ID 65071 //
     /* 2290013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290060 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2290063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2290075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290079 */     // GIR_Coverage, 65071,
     /* 2290079 */     GIR_EraseRootFromParent_Done,
     /* 2290080 */   // Label 31388: @2290080
     /* 2290080 */   GIM_Try, /*On fail goto*//*Label 31389*/ GIMT_Encode4(2290152), // Rule ID 65072 //
     /* 2290085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2290088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290132 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2290135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2290147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290151 */     // GIR_Coverage, 65072,
     /* 2290151 */     GIR_EraseRootFromParent_Done,
     /* 2290152 */   // Label 31389: @2290152
     /* 2290152 */   GIM_Try, /*On fail goto*//*Label 31390*/ GIMT_Encode4(2290224), // Rule ID 65079 //
     /* 2290157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2290160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290204 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2290207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2290219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290222 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290223 */     // GIR_Coverage, 65079,
     /* 2290223 */     GIR_EraseRootFromParent_Done,
     /* 2290224 */   // Label 31390: @2290224
     /* 2290224 */   GIM_Try, /*On fail goto*//*Label 31391*/ GIMT_Encode4(2290296), // Rule ID 65080 //
     /* 2290229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2290232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2290261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290269 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2290276 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2290279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2290291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290295 */     // GIR_Coverage, 65080,
     /* 2290295 */     GIR_EraseRootFromParent_Done,
     /* 2290296 */   // Label 31391: @2290296
     /* 2290296 */   GIM_Try, /*On fail goto*//*Label 31392*/ GIMT_Encode4(2290353), // Rule ID 1200 //
     /* 2290301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290335 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2290338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290344 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290346 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290352 */     // GIR_Coverage, 1200,
     /* 2290352 */     GIR_EraseRootFromParent_Done,
     /* 2290353 */   // Label 31392: @2290353
     /* 2290353 */   GIM_Try, /*On fail goto*//*Label 31393*/ GIMT_Encode4(2290410), // Rule ID 1201 //
     /* 2290358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2290361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290392 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2290395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290409 */     // GIR_Coverage, 1201,
     /* 2290409 */     GIR_EraseRootFromParent_Done,
     /* 2290410 */   // Label 31393: @2290410
     /* 2290410 */   GIM_Try, /*On fail goto*//*Label 31394*/ GIMT_Encode4(2290467), // Rule ID 1221 //
     /* 2290415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2290418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290449 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2290452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290460 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290466 */     // GIR_Coverage, 1221,
     /* 2290466 */     GIR_EraseRootFromParent_Done,
     /* 2290467 */   // Label 31394: @2290467
     /* 2290467 */   GIM_Try, /*On fail goto*//*Label 31395*/ GIMT_Encode4(2290524), // Rule ID 1222 //
     /* 2290472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2290475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2290483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290506 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2290509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290517 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290523 */     // GIR_Coverage, 1222,
     /* 2290523 */     GIR_EraseRootFromParent_Done,
     /* 2290524 */   // Label 31395: @2290524
     /* 2290524 */   GIM_Try, /*On fail goto*//*Label 31396*/ GIMT_Encode4(2290581), // Rule ID 65067 //
     /* 2290529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290536 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290563 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2290566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290572 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290574 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290580 */     // GIR_Coverage, 65067,
     /* 2290580 */     GIR_EraseRootFromParent_Done,
     /* 2290581 */   // Label 31396: @2290581
     /* 2290581 */   GIM_Try, /*On fail goto*//*Label 31397*/ GIMT_Encode4(2290638), // Rule ID 65068 //
     /* 2290586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2290589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290620 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2290623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290631 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290637 */     // GIR_Coverage, 65068,
     /* 2290637 */     GIR_EraseRootFromParent_Done,
     /* 2290638 */   // Label 31397: @2290638
     /* 2290638 */   GIM_Try, /*On fail goto*//*Label 31398*/ GIMT_Encode4(2290695), // Rule ID 65075 //
     /* 2290643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2290646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290677 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2290680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290688 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290694 */     // GIR_Coverage, 65075,
     /* 2290694 */     GIR_EraseRootFromParent_Done,
     /* 2290695 */   // Label 31398: @2290695
     /* 2290695 */   GIM_Try, /*On fail goto*//*Label 31399*/ GIMT_Encode4(2290752), // Rule ID 65076 //
     /* 2290700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2290703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2290715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290734 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2290737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2290743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2290745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2290747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290750 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290751 */     // GIR_Coverage, 65076,
     /* 2290751 */     GIR_EraseRootFromParent_Done,
     /* 2290752 */   // Label 31399: @2290752
     /* 2290752 */   GIM_Try, /*On fail goto*//*Label 31400*/ GIMT_Encode4(2290809), // Rule ID 1196 //
     /* 2290757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290784 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290791 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2290794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290798 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2290804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290808 */     // GIR_Coverage, 1196,
     /* 2290808 */     GIR_EraseRootFromParent_Done,
     /* 2290809 */   // Label 31400: @2290809
     /* 2290809 */   GIM_Try, /*On fail goto*//*Label 31401*/ GIMT_Encode4(2290866), // Rule ID 1197 //
     /* 2290814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2290817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290846 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290848 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2290851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2290861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290865 */     // GIR_Coverage, 1197,
     /* 2290865 */     GIR_EraseRootFromParent_Done,
     /* 2290866 */   // Label 31401: @2290866
     /* 2290866 */   GIM_Try, /*On fail goto*//*Label 31402*/ GIMT_Encode4(2290923), // Rule ID 1217 //
     /* 2290871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2290874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290905 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2290905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2290908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2290918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290921 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290922 */     // GIR_Coverage, 1217,
     /* 2290922 */     GIR_EraseRootFromParent_Done,
     /* 2290923 */   // Label 31402: @2290923
     /* 2290923 */   GIM_Try, /*On fail goto*//*Label 31403*/ GIMT_Encode4(2290980), // Rule ID 1218 //
     /* 2290928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2290931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2290947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2290951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2290955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2290960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2290962 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2290962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2290965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2290967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2290969 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2290971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2290975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2290978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2290979 */     // GIR_Coverage, 1218,
     /* 2290979 */     GIR_EraseRootFromParent_Done,
     /* 2290980 */   // Label 31403: @2290980
     /* 2290980 */   GIM_Try, /*On fail goto*//*Label 31404*/ GIMT_Encode4(2291020), // Rule ID 1192 //
     /* 2290985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2290988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2290996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291004 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2291004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2291007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291013 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291019 */     // GIR_Coverage, 1192,
     /* 2291019 */     GIR_EraseRootFromParent_Done,
     /* 2291020 */   // Label 31404: @2291020
     /* 2291020 */   GIM_Try, /*On fail goto*//*Label 31405*/ GIMT_Encode4(2291060), // Rule ID 1193 //
     /* 2291025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2291028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2291044 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2291044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2291047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291053 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291059 */     // GIR_Coverage, 1193,
     /* 2291059 */     GIR_EraseRootFromParent_Done,
     /* 2291060 */   // Label 31405: @2291060
     /* 2291060 */   GIM_Try, /*On fail goto*//*Label 31406*/ GIMT_Encode4(2291100), // Rule ID 1213 //
     /* 2291065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2291068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291084 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2291084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2291087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291099 */     // GIR_Coverage, 1213,
     /* 2291099 */     GIR_EraseRootFromParent_Done,
     /* 2291100 */   // Label 31406: @2291100
     /* 2291100 */   GIM_Try, /*On fail goto*//*Label 31407*/ GIMT_Encode4(2291140), // Rule ID 1214 //
     /* 2291105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2291108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2291124 */     // (fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2291124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2291127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2291131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291133 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291139 */     // GIR_Coverage, 1214,
     /* 2291139 */     GIR_EraseRootFromParent_Done,
     /* 2291140 */   // Label 31407: @2291140
     /* 2291140 */   GIM_Reject,
     /* 2291141 */ // Label 31383: @2291141
     /* 2291141 */ GIM_Reject,
     /* 2291142 */ // Label 31341: @2291142
     /* 2291142 */ GIM_Try, /*On fail goto*//*Label 31408*/ GIMT_Encode4(2292932),
     /* 2291147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2291153 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2291156 */   GIM_Try, /*On fail goto*//*Label 31409*/ GIMT_Encode4(2291228), // Rule ID 1541 //
     /* 2291161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2291164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291208 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2291211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291226 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291227 */     // GIR_Coverage, 1541,
     /* 2291227 */     GIR_EraseRootFromParent_Done,
     /* 2291228 */   // Label 31409: @2291228
     /* 2291228 */   GIM_Try, /*On fail goto*//*Label 31410*/ GIMT_Encode4(2291300), // Rule ID 1542 //
     /* 2291233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2291236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291280 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2291280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2291283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291289 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291298 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291299 */     // GIR_Coverage, 1542,
     /* 2291299 */     GIR_EraseRootFromParent_Done,
     /* 2291300 */   // Label 31410: @2291300
     /* 2291300 */   GIM_Try, /*On fail goto*//*Label 31411*/ GIMT_Encode4(2291372), // Rule ID 1564 //
     /* 2291305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2291308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291352 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2291355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291371 */     // GIR_Coverage, 1564,
     /* 2291371 */     GIR_EraseRootFromParent_Done,
     /* 2291372 */   // Label 31411: @2291372
     /* 2291372 */   GIM_Try, /*On fail goto*//*Label 31412*/ GIMT_Encode4(2291444), // Rule ID 1596 //
     /* 2291377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2291380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291388 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291392 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291424 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2291427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291443 */     // GIR_Coverage, 1596,
     /* 2291443 */     GIR_EraseRootFromParent_Done,
     /* 2291444 */   // Label 31412: @2291444
     /* 2291444 */   GIM_Try, /*On fail goto*//*Label 31413*/ GIMT_Encode4(2291516), // Rule ID 1597 //
     /* 2291449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2291452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291496 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2291496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2291499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291515 */     // GIR_Coverage, 1597,
     /* 2291515 */     GIR_EraseRootFromParent_Done,
     /* 2291516 */   // Label 31413: @2291516
     /* 2291516 */   GIM_Try, /*On fail goto*//*Label 31414*/ GIMT_Encode4(2291588), // Rule ID 65087 //
     /* 2291521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2291524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291568 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2291571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2291579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291587 */     // GIR_Coverage, 65087,
     /* 2291587 */     GIR_EraseRootFromParent_Done,
     /* 2291588 */   // Label 31414: @2291588
     /* 2291588 */   GIM_Try, /*On fail goto*//*Label 31415*/ GIMT_Encode4(2291660), // Rule ID 65088 //
     /* 2291593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2291596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291640 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2291640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2291643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2291651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291659 */     // GIR_Coverage, 65088,
     /* 2291659 */     GIR_EraseRootFromParent_Done,
     /* 2291660 */   // Label 31415: @2291660
     /* 2291660 */   GIM_Try, /*On fail goto*//*Label 31416*/ GIMT_Encode4(2291732), // Rule ID 65092 //
     /* 2291665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2291668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291701 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2291710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291712 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2291715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2291723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291731 */     // GIR_Coverage, 65092,
     /* 2291731 */     GIR_EraseRootFromParent_Done,
     /* 2291732 */   // Label 31416: @2291732
     /* 2291732 */   GIM_Try, /*On fail goto*//*Label 31417*/ GIMT_Encode4(2291804), // Rule ID 65099 //
     /* 2291737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2291740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291760 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291784 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2291787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2291795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291803 */     // GIR_Coverage, 65099,
     /* 2291803 */     GIR_EraseRootFromParent_Done,
     /* 2291804 */   // Label 31417: @2291804
     /* 2291804 */   GIM_Try, /*On fail goto*//*Label 31418*/ GIMT_Encode4(2291876), // Rule ID 65100 //
     /* 2291809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2291812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2291824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2291841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2291854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2291856 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2291856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2291859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2291867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2291871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291875 */     // GIR_Coverage, 65100,
     /* 2291875 */     GIR_EraseRootFromParent_Done,
     /* 2291876 */   // Label 31418: @2291876
     /* 2291876 */   GIM_Try, /*On fail goto*//*Label 31419*/ GIMT_Encode4(2291933), // Rule ID 1537 //
     /* 2291881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2291884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291915 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2291915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2291918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291926 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291932 */     // GIR_Coverage, 1537,
     /* 2291932 */     GIR_EraseRootFromParent_Done,
     /* 2291933 */   // Label 31419: @2291933
     /* 2291933 */   GIM_Try, /*On fail goto*//*Label 31420*/ GIMT_Encode4(2291990), // Rule ID 1538 //
     /* 2291938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2291941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2291949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2291953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2291957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2291970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2291972 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2291972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2291975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2291977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2291981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2291983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2291985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2291988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2291989 */     // GIR_Coverage, 1538,
     /* 2291989 */     GIR_EraseRootFromParent_Done,
     /* 2291990 */   // Label 31420: @2291990
     /* 2291990 */   GIM_Try, /*On fail goto*//*Label 31421*/ GIMT_Encode4(2292047), // Rule ID 1562 //
     /* 2291995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2291998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292029 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2292032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292045 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292046 */     // GIR_Coverage, 1562,
     /* 2292046 */     GIR_EraseRootFromParent_Done,
     /* 2292047 */   // Label 31421: @2292047
     /* 2292047 */   GIM_Try, /*On fail goto*//*Label 31422*/ GIMT_Encode4(2292104), // Rule ID 1592 //
     /* 2292052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2292055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292086 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2292089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292103 */     // GIR_Coverage, 1592,
     /* 2292103 */     GIR_EraseRootFromParent_Done,
     /* 2292104 */   // Label 31422: @2292104
     /* 2292104 */   GIM_Try, /*On fail goto*//*Label 31423*/ GIMT_Encode4(2292161), // Rule ID 1593 //
     /* 2292109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2292112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292143 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2292146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292154 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292160 */     // GIR_Coverage, 1593,
     /* 2292160 */     GIR_EraseRootFromParent_Done,
     /* 2292161 */   // Label 31423: @2292161
     /* 2292161 */   GIM_Try, /*On fail goto*//*Label 31424*/ GIMT_Encode4(2292218), // Rule ID 65083 //
     /* 2292166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2292169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292200 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2292203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292211 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292217 */     // GIR_Coverage, 65083,
     /* 2292217 */     GIR_EraseRootFromParent_Done,
     /* 2292218 */   // Label 31424: @2292218
     /* 2292218 */   GIM_Try, /*On fail goto*//*Label 31425*/ GIMT_Encode4(2292275), // Rule ID 65084 //
     /* 2292223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2292226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292251 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292257 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2292260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292268 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292274 */     // GIR_Coverage, 65084,
     /* 2292274 */     GIR_EraseRootFromParent_Done,
     /* 2292275 */   // Label 31425: @2292275
     /* 2292275 */   GIM_Try, /*On fail goto*//*Label 31426*/ GIMT_Encode4(2292332), // Rule ID 65090 //
     /* 2292280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2292283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292314 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2292317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292325 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292331 */     // GIR_Coverage, 65090,
     /* 2292331 */     GIR_EraseRootFromParent_Done,
     /* 2292332 */   // Label 31426: @2292332
     /* 2292332 */   GIM_Try, /*On fail goto*//*Label 31427*/ GIMT_Encode4(2292389), // Rule ID 65095 //
     /* 2292337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2292340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292360 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292371 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2292374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292382 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292388 */     // GIR_Coverage, 65095,
     /* 2292388 */     GIR_EraseRootFromParent_Done,
     /* 2292389 */   // Label 31427: @2292389
     /* 2292389 */   GIM_Try, /*On fail goto*//*Label 31428*/ GIMT_Encode4(2292446), // Rule ID 65096 //
     /* 2292394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2292397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2292409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292428 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2292431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2292437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2292439 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292445 */     // GIR_Coverage, 65096,
     /* 2292445 */     GIR_EraseRootFromParent_Done,
     /* 2292446 */   // Label 31428: @2292446
     /* 2292446 */   GIM_Try, /*On fail goto*//*Label 31429*/ GIMT_Encode4(2292503), // Rule ID 1533 //
     /* 2292451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2292454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292485 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2292488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292490 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2292498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292502 */     // GIR_Coverage, 1533,
     /* 2292502 */     GIR_EraseRootFromParent_Done,
     /* 2292503 */   // Label 31429: @2292503
     /* 2292503 */   GIM_Try, /*On fail goto*//*Label 31430*/ GIMT_Encode4(2292560), // Rule ID 1534 //
     /* 2292508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2292511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292542 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2292545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2292555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292559 */     // GIR_Coverage, 1534,
     /* 2292559 */     GIR_EraseRootFromParent_Done,
     /* 2292560 */   // Label 31430: @2292560
     /* 2292560 */   GIM_Try, /*On fail goto*//*Label 31431*/ GIMT_Encode4(2292617), // Rule ID 1560 //
     /* 2292565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2292568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292592 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292597 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292599 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2292602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2292612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292616 */     // GIR_Coverage, 1560,
     /* 2292616 */     GIR_EraseRootFromParent_Done,
     /* 2292617 */   // Label 31431: @2292617
     /* 2292617 */   GIM_Try, /*On fail goto*//*Label 31432*/ GIMT_Encode4(2292674), // Rule ID 1588 //
     /* 2292622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2292625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292656 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2292659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2292669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292672 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292673 */     // GIR_Coverage, 1588,
     /* 2292673 */     GIR_EraseRootFromParent_Done,
     /* 2292674 */   // Label 31432: @2292674
     /* 2292674 */   GIM_Try, /*On fail goto*//*Label 31433*/ GIMT_Encode4(2292731), // Rule ID 1589 //
     /* 2292679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2292682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2292698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2292706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2292713 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2292716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2292726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292730 */     // GIR_Coverage, 1589,
     /* 2292730 */     GIR_EraseRootFromParent_Done,
     /* 2292731 */   // Label 31433: @2292731
     /* 2292731 */   GIM_Try, /*On fail goto*//*Label 31434*/ GIMT_Encode4(2292771), // Rule ID 1529 //
     /* 2292736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2292739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292755 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2292758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292764 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292770 */     // GIR_Coverage, 1529,
     /* 2292770 */     GIR_EraseRootFromParent_Done,
     /* 2292771 */   // Label 31434: @2292771
     /* 2292771 */   GIM_Try, /*On fail goto*//*Label 31435*/ GIMT_Encode4(2292811), // Rule ID 1530 //
     /* 2292776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2292779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2292795 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2292798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292804 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292810 */     // GIR_Coverage, 1530,
     /* 2292810 */     GIR_EraseRootFromParent_Done,
     /* 2292811 */   // Label 31435: @2292811
     /* 2292811 */   GIM_Try, /*On fail goto*//*Label 31436*/ GIMT_Encode4(2292851), // Rule ID 1558 //
     /* 2292816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2292819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2292835 */     // (fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2292838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292840 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292842 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292844 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292850 */     // GIR_Coverage, 1558,
     /* 2292850 */     GIR_EraseRootFromParent_Done,
     /* 2292851 */   // Label 31436: @2292851
     /* 2292851 */   GIM_Try, /*On fail goto*//*Label 31437*/ GIMT_Encode4(2292891), // Rule ID 1584 //
     /* 2292856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2292859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292875 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2292875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2292878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292880 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292882 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292884 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292890 */     // GIR_Coverage, 1584,
     /* 2292890 */     GIR_EraseRootFromParent_Done,
     /* 2292891 */   // Label 31437: @2292891
     /* 2292891 */   GIM_Try, /*On fail goto*//*Label 31438*/ GIMT_Encode4(2292931), // Rule ID 1585 //
     /* 2292896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2292899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2292915 */     // (fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2292915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2292918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2292920 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2292922 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2292924 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2292926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2292929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2292930 */     // GIR_Coverage, 1585,
     /* 2292930 */     GIR_EraseRootFromParent_Done,
     /* 2292931 */   // Label 31438: @2292931
     /* 2292931 */   GIM_Reject,
     /* 2292932 */ // Label 31408: @2292932
     /* 2292932 */ GIM_Reject,
     /* 2292933 */ // Label 31342: @2292933
     /* 2292933 */ GIM_Try, /*On fail goto*//*Label 31439*/ GIMT_Encode4(2293722),
     /* 2292938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2292941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2292944 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2292947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292951 */   GIM_Try, /*On fail goto*//*Label 31440*/ GIMT_Encode4(2293028), // Rule ID 54712 //
     /* 2292956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2292959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2292963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2292971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2292984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2292988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2292992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2292997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2292999 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2292999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2293002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293027 */     // GIR_Coverage, 54712,
     /* 2293027 */     GIR_EraseRootFromParent_Done,
     /* 2293028 */   // Label 31440: @2293028
     /* 2293028 */   GIM_Try, /*On fail goto*//*Label 31441*/ GIMT_Encode4(2293105), // Rule ID 54713 //
     /* 2293033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293076 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2293079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293081 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293104 */     // GIR_Coverage, 54713,
     /* 2293104 */     GIR_EraseRootFromParent_Done,
     /* 2293105 */   // Label 31441: @2293105
     /* 2293105 */   GIM_Try, /*On fail goto*//*Label 31442*/ GIMT_Encode4(2293182), // Rule ID 72061 //
     /* 2293110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293153 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2293156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293158 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293181 */     // GIR_Coverage, 72061,
     /* 2293181 */     GIR_EraseRootFromParent_Done,
     /* 2293182 */   // Label 31442: @2293182
     /* 2293182 */   GIM_Try, /*On fail goto*//*Label 31443*/ GIMT_Encode4(2293259), // Rule ID 72062 //
     /* 2293187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293230 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2293233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293235 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293258 */     // GIR_Coverage, 72062,
     /* 2293258 */     GIR_EraseRootFromParent_Done,
     /* 2293259 */   // Label 31443: @2293259
     /* 2293259 */   GIM_Try, /*On fail goto*//*Label 31444*/ GIMT_Encode4(2293321), // Rule ID 54716 //
     /* 2293264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293294 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2293297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293305 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293320 */     // GIR_Coverage, 54716,
     /* 2293320 */     GIR_EraseRootFromParent_Done,
     /* 2293321 */   // Label 31444: @2293321
     /* 2293321 */   GIM_Try, /*On fail goto*//*Label 31445*/ GIMT_Encode4(2293383), // Rule ID 54717 //
     /* 2293326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293356 */     // (fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2293359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293367 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293382 */     // GIR_Coverage, 54717,
     /* 2293382 */     GIR_EraseRootFromParent_Done,
     /* 2293383 */   // Label 31445: @2293383
     /* 2293383 */   GIM_Try, /*On fail goto*//*Label 31446*/ GIMT_Encode4(2293445), // Rule ID 72065 //
     /* 2293388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293418 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2293421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293429 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293444 */     // GIR_Coverage, 72065,
     /* 2293444 */     GIR_EraseRootFromParent_Done,
     /* 2293445 */   // Label 31446: @2293445
     /* 2293445 */   GIM_Try, /*On fail goto*//*Label 31447*/ GIMT_Encode4(2293507), // Rule ID 72066 //
     /* 2293450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293478 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293480 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2293483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293491 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293506 */     // GIR_Coverage, 72066,
     /* 2293506 */     GIR_EraseRootFromParent_Done,
     /* 2293507 */   // Label 31447: @2293507
     /* 2293507 */   GIM_Try, /*On fail goto*//*Label 31448*/ GIMT_Encode4(2293569), // Rule ID 54708 //
     /* 2293512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293542 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2293545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293547 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2293555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293568 */     // GIR_Coverage, 54708,
     /* 2293568 */     GIR_EraseRootFromParent_Done,
     /* 2293569 */   // Label 31448: @2293569
     /* 2293569 */   GIM_Try, /*On fail goto*//*Label 31449*/ GIMT_Encode4(2293631), // Rule ID 54709 //
     /* 2293574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293585 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2293589 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293593 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2293597 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2293604 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2293607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2293617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293630 */     // GIR_Coverage, 54709,
     /* 2293630 */     GIR_EraseRootFromParent_Done,
     /* 2293631 */   // Label 31449: @2293631
     /* 2293631 */   GIM_Try, /*On fail goto*//*Label 31450*/ GIMT_Encode4(2293676), // Rule ID 54704 //
     /* 2293636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2293639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293651 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2293654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293656 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293660 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293675 */     // GIR_Coverage, 54704,
     /* 2293675 */     GIR_EraseRootFromParent_Done,
     /* 2293676 */   // Label 31450: @2293676
     /* 2293676 */   GIM_Try, /*On fail goto*//*Label 31451*/ GIMT_Encode4(2293721), // Rule ID 54705 //
     /* 2293681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2293684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293696 */     // (fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2293699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2293705 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2293707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2293716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293719 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293720 */     // GIR_Coverage, 54705,
     /* 2293720 */     GIR_EraseRootFromParent_Done,
     /* 2293721 */   // Label 31451: @2293721
     /* 2293721 */   GIM_Reject,
     /* 2293722 */ // Label 31439: @2293722
     /* 2293722 */ GIM_Reject,
     /* 2293723 */ // Label 31343: @2293723
     /* 2293723 */ GIM_Try, /*On fail goto*//*Label 31452*/ GIMT_Encode4(2294512),
     /* 2293728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2293734 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2293737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293741 */   GIM_Try, /*On fail goto*//*Label 31453*/ GIMT_Encode4(2293818), // Rule ID 54840 //
     /* 2293746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2293749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293789 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2293792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293794 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293800 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293817 */     // GIR_Coverage, 54840,
     /* 2293817 */     GIR_EraseRootFromParent_Done,
     /* 2293818 */   // Label 31453: @2293818
     /* 2293818 */   GIM_Try, /*On fail goto*//*Label 31454*/ GIMT_Encode4(2293895), // Rule ID 54841 //
     /* 2293823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2293826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2293830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293866 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2293866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2293869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2293873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293894 */     // GIR_Coverage, 54841,
     /* 2293894 */     GIR_EraseRootFromParent_Done,
     /* 2293895 */   // Label 31454: @2293895
     /* 2293895 */   GIM_Try, /*On fail goto*//*Label 31455*/ GIMT_Encode4(2293972), // Rule ID 72173 //
     /* 2293900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2293903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2293928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2293943 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2293943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2293946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2293948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2293950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2293954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2293958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2293961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2293964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2293967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2293970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2293971 */     // GIR_Coverage, 72173,
     /* 2293971 */     GIR_EraseRootFromParent_Done,
     /* 2293972 */   // Label 31455: @2293972
     /* 2293972 */   GIM_Try, /*On fail goto*//*Label 31456*/ GIMT_Encode4(2294049), // Rule ID 72174 //
     /* 2293977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2293980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2293984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2293988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2293992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2293996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294013 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294020 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2294023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294048 */     // GIR_Coverage, 72174,
     /* 2294048 */     GIR_EraseRootFromParent_Done,
     /* 2294049 */   // Label 31456: @2294049
     /* 2294049 */   GIM_Try, /*On fail goto*//*Label 31457*/ GIMT_Encode4(2294111), // Rule ID 54844 //
     /* 2294054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294084 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2294087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294095 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294110 */     // GIR_Coverage, 54844,
     /* 2294110 */     GIR_EraseRootFromParent_Done,
     /* 2294111 */   // Label 31457: @2294111
     /* 2294111 */   GIM_Try, /*On fail goto*//*Label 31458*/ GIMT_Encode4(2294173), // Rule ID 54845 //
     /* 2294116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294146 */     // (fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2294149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294172 */     // GIR_Coverage, 54845,
     /* 2294172 */     GIR_EraseRootFromParent_Done,
     /* 2294173 */   // Label 31458: @2294173
     /* 2294173 */   GIM_Try, /*On fail goto*//*Label 31459*/ GIMT_Encode4(2294235), // Rule ID 72177 //
     /* 2294178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294208 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2294211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294219 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294233 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294234 */     // GIR_Coverage, 72177,
     /* 2294234 */     GIR_EraseRootFromParent_Done,
     /* 2294235 */   // Label 31459: @2294235
     /* 2294235 */   GIM_Try, /*On fail goto*//*Label 31460*/ GIMT_Encode4(2294297), // Rule ID 72178 //
     /* 2294240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294264 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294270 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2294273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294281 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294295 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294296 */     // GIR_Coverage, 72178,
     /* 2294296 */     GIR_EraseRootFromParent_Done,
     /* 2294297 */   // Label 31460: @2294297
     /* 2294297 */   GIM_Try, /*On fail goto*//*Label 31461*/ GIMT_Encode4(2294359), // Rule ID 54836 //
     /* 2294302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2294317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294332 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2294335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2294345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294358 */     // GIR_Coverage, 54836,
     /* 2294358 */     GIR_EraseRootFromParent_Done,
     /* 2294359 */   // Label 31461: @2294359
     /* 2294359 */   GIM_Try, /*On fail goto*//*Label 31462*/ GIMT_Encode4(2294421), // Rule ID 54837 //
     /* 2294364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2294379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2294387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294394 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2294397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2294407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294419 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294420 */     // GIR_Coverage, 54837,
     /* 2294420 */     GIR_EraseRootFromParent_Done,
     /* 2294421 */   // Label 31462: @2294421
     /* 2294421 */   GIM_Try, /*On fail goto*//*Label 31463*/ GIMT_Encode4(2294466), // Rule ID 54832 //
     /* 2294426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2294429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294441 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2294444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294446 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294465 */     // GIR_Coverage, 54832,
     /* 2294465 */     GIR_EraseRootFromParent_Done,
     /* 2294466 */   // Label 31463: @2294466
     /* 2294466 */   GIM_Try, /*On fail goto*//*Label 31464*/ GIMT_Encode4(2294511), // Rule ID 54833 //
     /* 2294471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2294474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294486 */     // (fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2294489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2294495 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2294506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294510 */     // GIR_Coverage, 54833,
     /* 2294510 */     GIR_EraseRootFromParent_Done,
     /* 2294511 */   // Label 31464: @2294511
     /* 2294511 */   GIM_Reject,
     /* 2294512 */ // Label 31452: @2294512
     /* 2294512 */ GIM_Reject,
     /* 2294513 */ // Label 31344: @2294513
     /* 2294513 */ GIM_Try, /*On fail goto*//*Label 31465*/ GIMT_Encode4(2295302),
     /* 2294518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2294524 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2294527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294531 */   GIM_Try, /*On fail goto*//*Label 31466*/ GIMT_Encode4(2294608), // Rule ID 55032 //
     /* 2294536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2294539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294579 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2294582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294607 */     // GIR_Coverage, 55032,
     /* 2294607 */     GIR_EraseRootFromParent_Done,
     /* 2294608 */   // Label 31466: @2294608
     /* 2294608 */   GIM_Try, /*On fail goto*//*Label 31467*/ GIMT_Encode4(2294685), // Rule ID 55033 //
     /* 2294613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2294616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294645 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294649 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294654 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294656 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2294659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294684 */     // GIR_Coverage, 55033,
     /* 2294684 */     GIR_EraseRootFromParent_Done,
     /* 2294685 */   // Label 31467: @2294685
     /* 2294685 */   GIM_Try, /*On fail goto*//*Label 31468*/ GIMT_Encode4(2294762), // Rule ID 72341 //
     /* 2294690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2294693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294726 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294733 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2294736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294761 */     // GIR_Coverage, 72341,
     /* 2294761 */     GIR_EraseRootFromParent_Done,
     /* 2294762 */   // Label 31468: @2294762
     /* 2294762 */   GIM_Try, /*On fail goto*//*Label 31469*/ GIMT_Encode4(2294839), // Rule ID 72342 //
     /* 2294767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2294770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2294795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294808 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2294810 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2294813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2294817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2294825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294838 */     // GIR_Coverage, 72342,
     /* 2294838 */     GIR_EraseRootFromParent_Done,
     /* 2294839 */   // Label 31469: @2294839
     /* 2294839 */   GIM_Try, /*On fail goto*//*Label 31470*/ GIMT_Encode4(2294901), // Rule ID 55036 //
     /* 2294844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2294847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294874 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2294877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294885 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294900 */     // GIR_Coverage, 55036,
     /* 2294900 */     GIR_EraseRootFromParent_Done,
     /* 2294901 */   // Label 31470: @2294901
     /* 2294901 */   GIM_Try, /*On fail goto*//*Label 31471*/ GIMT_Encode4(2294963), // Rule ID 55037 //
     /* 2294906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2294909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2294913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294930 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294934 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294936 */     // (fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2294936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2294939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2294941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2294943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2294947 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2294949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2294952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2294955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2294958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2294961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2294962 */     // GIR_Coverage, 55037,
     /* 2294962 */     GIR_EraseRootFromParent_Done,
     /* 2294963 */   // Label 31471: @2294963
     /* 2294963 */   GIM_Try, /*On fail goto*//*Label 31472*/ GIMT_Encode4(2295025), // Rule ID 72345 //
     /* 2294968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2294971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2294979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2294983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2294987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2294996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2294998 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2294998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2295001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295009 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295023 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295024 */     // GIR_Coverage, 72345,
     /* 2295024 */     GIR_EraseRootFromParent_Done,
     /* 2295025 */   // Label 31472: @2295025
     /* 2295025 */   GIM_Try, /*On fail goto*//*Label 31473*/ GIMT_Encode4(2295087), // Rule ID 72346 //
     /* 2295030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2295049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295054 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295060 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2295063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295071 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295086 */     // GIR_Coverage, 72346,
     /* 2295086 */     GIR_EraseRootFromParent_Done,
     /* 2295087 */   // Label 31473: @2295087
     /* 2295087 */   GIM_Try, /*On fail goto*//*Label 31474*/ GIMT_Encode4(2295149), // Rule ID 55028 //
     /* 2295092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2295115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295122 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2295125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295127 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295129 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295148 */     // GIR_Coverage, 55028,
     /* 2295148 */     GIR_EraseRootFromParent_Done,
     /* 2295149 */   // Label 31474: @2295149
     /* 2295149 */   GIM_Try, /*On fail goto*//*Label 31475*/ GIMT_Encode4(2295211), // Rule ID 55029 //
     /* 2295154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2295177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295184 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2295187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295210 */     // GIR_Coverage, 55029,
     /* 2295210 */     GIR_EraseRootFromParent_Done,
     /* 2295211 */   // Label 31475: @2295211
     /* 2295211 */   GIM_Try, /*On fail goto*//*Label 31476*/ GIMT_Encode4(2295256), // Rule ID 55024 //
     /* 2295216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2295219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295231 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2295234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295240 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295255 */     // GIR_Coverage, 55024,
     /* 2295255 */     GIR_EraseRootFromParent_Done,
     /* 2295256 */   // Label 31476: @2295256
     /* 2295256 */   GIM_Try, /*On fail goto*//*Label 31477*/ GIMT_Encode4(2295301), // Rule ID 55025 //
     /* 2295261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2295264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295276 */     // (fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2295279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295281 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295285 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2295296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295300 */     // GIR_Coverage, 55025,
     /* 2295300 */     GIR_EraseRootFromParent_Done,
     /* 2295301 */   // Label 31477: @2295301
     /* 2295301 */   GIM_Reject,
     /* 2295302 */ // Label 31465: @2295302
     /* 2295302 */ GIM_Reject,
     /* 2295303 */ // Label 31345: @2295303
     /* 2295303 */ GIM_Try, /*On fail goto*//*Label 31478*/ GIMT_Encode4(2296092),
     /* 2295308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2295314 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2295317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295321 */   GIM_Try, /*On fail goto*//*Label 31479*/ GIMT_Encode4(2295398), // Rule ID 54776 //
     /* 2295326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2295329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295358 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295362 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295367 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295369 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2295372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295397 */     // GIR_Coverage, 54776,
     /* 2295397 */     GIR_EraseRootFromParent_Done,
     /* 2295398 */   // Label 31479: @2295398
     /* 2295398 */   GIM_Try, /*On fail goto*//*Label 31480*/ GIMT_Encode4(2295475), // Rule ID 54777 //
     /* 2295403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2295406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295446 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2295449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295474 */     // GIR_Coverage, 54777,
     /* 2295474 */     GIR_EraseRootFromParent_Done,
     /* 2295475 */   // Label 31480: @2295475
     /* 2295475 */   GIM_Try, /*On fail goto*//*Label 31481*/ GIMT_Encode4(2295552), // Rule ID 72117 //
     /* 2295480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2295483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295523 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2295526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295528 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295551 */     // GIR_Coverage, 72117,
     /* 2295551 */     GIR_EraseRootFromParent_Done,
     /* 2295552 */   // Label 31481: @2295552
     /* 2295552 */   GIM_Try, /*On fail goto*//*Label 31482*/ GIMT_Encode4(2295629), // Rule ID 72118 //
     /* 2295557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2295560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2295585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2295600 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2295603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2295615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295628 */     // GIR_Coverage, 72118,
     /* 2295628 */     GIR_EraseRootFromParent_Done,
     /* 2295629 */   // Label 31482: @2295629
     /* 2295629 */   GIM_Try, /*On fail goto*//*Label 31483*/ GIMT_Encode4(2295691), // Rule ID 54780 //
     /* 2295634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2295637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295664 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2295667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295675 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295690 */     // GIR_Coverage, 54780,
     /* 2295690 */     GIR_EraseRootFromParent_Done,
     /* 2295691 */   // Label 31483: @2295691
     /* 2295691 */   GIM_Try, /*On fail goto*//*Label 31484*/ GIMT_Encode4(2295753), // Rule ID 54781 //
     /* 2295696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2295699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2295703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295726 */     // (fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2295729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295737 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295752 */     // GIR_Coverage, 54781,
     /* 2295752 */     GIR_EraseRootFromParent_Done,
     /* 2295753 */   // Label 31484: @2295753
     /* 2295753 */   GIM_Try, /*On fail goto*//*Label 31485*/ GIMT_Encode4(2295815), // Rule ID 72121 //
     /* 2295758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2295761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295788 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2295791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295799 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295814 */     // GIR_Coverage, 72121,
     /* 2295814 */     GIR_EraseRootFromParent_Done,
     /* 2295815 */   // Label 31485: @2295815
     /* 2295815 */   GIM_Try, /*On fail goto*//*Label 31486*/ GIMT_Encode4(2295877), // Rule ID 72122 //
     /* 2295820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2295823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2295831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295850 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2295853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2295857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2295861 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2295863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295876 */     // GIR_Coverage, 72122,
     /* 2295876 */     GIR_EraseRootFromParent_Done,
     /* 2295877 */   // Label 31486: @2295877
     /* 2295877 */   GIM_Try, /*On fail goto*//*Label 31487*/ GIMT_Encode4(2295939), // Rule ID 54772 //
     /* 2295882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2295885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295912 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2295912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2295915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2295938 */     // GIR_Coverage, 54772,
     /* 2295938 */     GIR_EraseRootFromParent_Done,
     /* 2295939 */   // Label 31487: @2295939
     /* 2295939 */   GIM_Try, /*On fail goto*//*Label 31488*/ GIMT_Encode4(2296001), // Rule ID 54773 //
     /* 2295944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2295947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2295959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2295963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2295967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2295972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2295974 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2295974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2295977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2295979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2295981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2295983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2295987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2295990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2295993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2295996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2295999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296000 */     // GIR_Coverage, 54773,
     /* 2296000 */     GIR_EraseRootFromParent_Done,
     /* 2296001 */   // Label 31488: @2296001
     /* 2296001 */   GIM_Try, /*On fail goto*//*Label 31489*/ GIMT_Encode4(2296046), // Rule ID 54768 //
     /* 2296006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2296009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296021 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2296024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296026 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296030 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296045 */     // GIR_Coverage, 54768,
     /* 2296045 */     GIR_EraseRootFromParent_Done,
     /* 2296046 */   // Label 31489: @2296046
     /* 2296046 */   GIM_Try, /*On fail goto*//*Label 31490*/ GIMT_Encode4(2296091), // Rule ID 54769 //
     /* 2296051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2296054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296066 */     // (fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2296069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296073 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296075 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2296086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296089 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296090 */     // GIR_Coverage, 54769,
     /* 2296090 */     GIR_EraseRootFromParent_Done,
     /* 2296091 */   // Label 31490: @2296091
     /* 2296091 */   GIM_Reject,
     /* 2296092 */ // Label 31478: @2296092
     /* 2296092 */ GIM_Reject,
     /* 2296093 */ // Label 31346: @2296093
     /* 2296093 */ GIM_Try, /*On fail goto*//*Label 31491*/ GIMT_Encode4(2296882),
     /* 2296098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2296104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2296107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296111 */   GIM_Try, /*On fail goto*//*Label 31492*/ GIMT_Encode4(2296188), // Rule ID 54968 //
     /* 2296116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296152 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296159 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2296162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296164 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296187 */     // GIR_Coverage, 54968,
     /* 2296187 */     GIR_EraseRootFromParent_Done,
     /* 2296188 */   // Label 31492: @2296188
     /* 2296188 */   GIM_Try, /*On fail goto*//*Label 31493*/ GIMT_Encode4(2296265), // Rule ID 54969 //
     /* 2296193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296236 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2296239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296264 */     // GIR_Coverage, 54969,
     /* 2296264 */     GIR_EraseRootFromParent_Done,
     /* 2296265 */   // Label 31493: @2296265
     /* 2296265 */   GIM_Try, /*On fail goto*//*Label 31494*/ GIMT_Encode4(2296342), // Rule ID 72285 //
     /* 2296270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296313 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2296316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296341 */     // GIR_Coverage, 72285,
     /* 2296341 */     GIR_EraseRootFromParent_Done,
     /* 2296342 */   // Label 31494: @2296342
     /* 2296342 */   GIM_Try, /*On fail goto*//*Label 31495*/ GIMT_Encode4(2296419), // Rule ID 72286 //
     /* 2296347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296390 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2296393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296418 */     // GIR_Coverage, 72286,
     /* 2296418 */     GIR_EraseRootFromParent_Done,
     /* 2296419 */   // Label 31495: @2296419
     /* 2296419 */   GIM_Try, /*On fail goto*//*Label 31496*/ GIMT_Encode4(2296481), // Rule ID 54972 //
     /* 2296424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296454 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2296457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296465 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296480 */     // GIR_Coverage, 54972,
     /* 2296480 */     GIR_EraseRootFromParent_Done,
     /* 2296481 */   // Label 31496: @2296481
     /* 2296481 */   GIM_Try, /*On fail goto*//*Label 31497*/ GIMT_Encode4(2296543), // Rule ID 54973 //
     /* 2296486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296516 */     // (fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2296519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296527 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296542 */     // GIR_Coverage, 54973,
     /* 2296542 */     GIR_EraseRootFromParent_Done,
     /* 2296543 */   // Label 31497: @2296543
     /* 2296543 */   GIM_Try, /*On fail goto*//*Label 31498*/ GIMT_Encode4(2296605), // Rule ID 72289 //
     /* 2296548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296576 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296578 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2296581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296589 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296604 */     // GIR_Coverage, 72289,
     /* 2296604 */     GIR_EraseRootFromParent_Done,
     /* 2296605 */   // Label 31498: @2296605
     /* 2296605 */   GIM_Try, /*On fail goto*//*Label 31499*/ GIMT_Encode4(2296667), // Rule ID 72290 //
     /* 2296610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2296621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296640 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2296643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296645 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2296647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296651 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296666 */     // GIR_Coverage, 72290,
     /* 2296666 */     GIR_EraseRootFromParent_Done,
     /* 2296667 */   // Label 31499: @2296667
     /* 2296667 */   GIM_Try, /*On fail goto*//*Label 31500*/ GIMT_Encode4(2296729), // Rule ID 54964 //
     /* 2296672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296702 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2296705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296728 */     // GIR_Coverage, 54964,
     /* 2296728 */     GIR_EraseRootFromParent_Done,
     /* 2296729 */   // Label 31500: @2296729
     /* 2296729 */   GIM_Try, /*On fail goto*//*Label 31501*/ GIMT_Encode4(2296791), // Rule ID 54965 //
     /* 2296734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2296749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2296757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2296764 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2296767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2296777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296790 */     // GIR_Coverage, 54965,
     /* 2296790 */     GIR_EraseRootFromParent_Done,
     /* 2296791 */   // Label 31501: @2296791
     /* 2296791 */   GIM_Try, /*On fail goto*//*Label 31502*/ GIMT_Encode4(2296836), // Rule ID 54960 //
     /* 2296796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2296799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296811 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2296814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296820 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296835 */     // GIR_Coverage, 54960,
     /* 2296835 */     GIR_EraseRootFromParent_Done,
     /* 2296836 */   // Label 31502: @2296836
     /* 2296836 */   GIM_Try, /*On fail goto*//*Label 31503*/ GIMT_Encode4(2296881), // Rule ID 54961 //
     /* 2296841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2296844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2296856 */     // (fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2296856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2296859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2296865 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2296867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2296876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296880 */     // GIR_Coverage, 54961,
     /* 2296880 */     GIR_EraseRootFromParent_Done,
     /* 2296881 */   // Label 31503: @2296881
     /* 2296881 */   GIM_Reject,
     /* 2296882 */ // Label 31491: @2296882
     /* 2296882 */ GIM_Reject,
     /* 2296883 */ // Label 31347: @2296883
     /* 2296883 */ GIM_Try, /*On fail goto*//*Label 31504*/ GIMT_Encode4(2297672),
     /* 2296888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2296891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2296894 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2296897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296901 */   GIM_Try, /*On fail goto*//*Label 31505*/ GIMT_Encode4(2296978), // Rule ID 55480 //
     /* 2296906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2296909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2296921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2296934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2296942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2296947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2296949 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2296949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2296952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2296954 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2296956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2296960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2296964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2296967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2296970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2296973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2296976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2296977 */     // GIR_Coverage, 55480,
     /* 2296977 */     GIR_EraseRootFromParent_Done,
     /* 2296978 */   // Label 31505: @2296978
     /* 2296978 */   GIM_Try, /*On fail goto*//*Label 31506*/ GIMT_Encode4(2297055), // Rule ID 55481 //
     /* 2296983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2296986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2296990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2296994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2296998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297026 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2297029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297054 */     // GIR_Coverage, 55481,
     /* 2297054 */     GIR_EraseRootFromParent_Done,
     /* 2297055 */   // Label 31506: @2297055
     /* 2297055 */   GIM_Try, /*On fail goto*//*Label 31507*/ GIMT_Encode4(2297132), // Rule ID 72733 //
     /* 2297060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297103 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2297106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297131 */     // GIR_Coverage, 72733,
     /* 2297131 */     GIR_EraseRootFromParent_Done,
     /* 2297132 */   // Label 31507: @2297132
     /* 2297132 */   GIM_Try, /*On fail goto*//*Label 31508*/ GIMT_Encode4(2297209), // Rule ID 72734 //
     /* 2297137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297180 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2297183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297208 */     // GIR_Coverage, 72734,
     /* 2297208 */     GIR_EraseRootFromParent_Done,
     /* 2297209 */   // Label 31508: @2297209
     /* 2297209 */   GIM_Try, /*On fail goto*//*Label 31509*/ GIMT_Encode4(2297271), // Rule ID 55484 //
     /* 2297214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297244 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2297247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297249 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297255 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297270 */     // GIR_Coverage, 55484,
     /* 2297270 */     GIR_EraseRootFromParent_Done,
     /* 2297271 */   // Label 31509: @2297271
     /* 2297271 */   GIM_Try, /*On fail goto*//*Label 31510*/ GIMT_Encode4(2297333), // Rule ID 55485 //
     /* 2297276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297304 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297306 */     // (fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2297309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297311 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297317 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297332 */     // GIR_Coverage, 55485,
     /* 2297332 */     GIR_EraseRootFromParent_Done,
     /* 2297333 */   // Label 31510: @2297333
     /* 2297333 */   GIM_Try, /*On fail goto*//*Label 31511*/ GIMT_Encode4(2297395), // Rule ID 72737 //
     /* 2297338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297368 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2297371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297394 */     // GIR_Coverage, 72737,
     /* 2297394 */     GIR_EraseRootFromParent_Done,
     /* 2297395 */   // Label 31511: @2297395
     /* 2297395 */   GIM_Try, /*On fail goto*//*Label 31512*/ GIMT_Encode4(2297457), // Rule ID 72738 //
     /* 2297400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297411 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297415 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297419 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297430 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2297433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297441 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297456 */     // GIR_Coverage, 72738,
     /* 2297456 */     GIR_EraseRootFromParent_Done,
     /* 2297457 */   // Label 31512: @2297457
     /* 2297457 */   GIM_Try, /*On fail goto*//*Label 31513*/ GIMT_Encode4(2297519), // Rule ID 55476 //
     /* 2297462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297492 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2297495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297497 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297518 */     // GIR_Coverage, 55476,
     /* 2297518 */     GIR_EraseRootFromParent_Done,
     /* 2297519 */   // Label 31513: @2297519
     /* 2297519 */   GIM_Try, /*On fail goto*//*Label 31514*/ GIMT_Encode4(2297581), // Rule ID 55477 //
     /* 2297524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2297539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2297547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297554 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2297557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2297567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297579 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297580 */     // GIR_Coverage, 55477,
     /* 2297580 */     GIR_EraseRootFromParent_Done,
     /* 2297581 */   // Label 31514: @2297581
     /* 2297581 */   GIM_Try, /*On fail goto*//*Label 31515*/ GIMT_Encode4(2297626), // Rule ID 55472 //
     /* 2297586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2297589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297601 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2297604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297610 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297625 */     // GIR_Coverage, 55472,
     /* 2297625 */     GIR_EraseRootFromParent_Done,
     /* 2297626 */   // Label 31515: @2297626
     /* 2297626 */   GIM_Try, /*On fail goto*//*Label 31516*/ GIMT_Encode4(2297671), // Rule ID 55473 //
     /* 2297631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2297634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2297646 */     // (fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2297649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2297655 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2297657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2297666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297670 */     // GIR_Coverage, 55473,
     /* 2297670 */     GIR_EraseRootFromParent_Done,
     /* 2297671 */   // Label 31516: @2297671
     /* 2297671 */   GIM_Reject,
     /* 2297672 */ // Label 31504: @2297672
     /* 2297672 */ GIM_Reject,
     /* 2297673 */ // Label 31348: @2297673
     /* 2297673 */ GIM_Try, /*On fail goto*//*Label 31517*/ GIMT_Encode4(2298462),
     /* 2297678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2297684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2297687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297691 */   GIM_Try, /*On fail goto*//*Label 31518*/ GIMT_Encode4(2297768), // Rule ID 54904 //
     /* 2297696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297739 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2297742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297767 */     // GIR_Coverage, 54904,
     /* 2297767 */     GIR_EraseRootFromParent_Done,
     /* 2297768 */   // Label 31518: @2297768
     /* 2297768 */   GIM_Try, /*On fail goto*//*Label 31519*/ GIMT_Encode4(2297845), // Rule ID 54905 //
     /* 2297773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2297780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297816 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2297819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2297823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297844 */     // GIR_Coverage, 54905,
     /* 2297844 */     GIR_EraseRootFromParent_Done,
     /* 2297845 */   // Label 31519: @2297845
     /* 2297845 */   GIM_Try, /*On fail goto*//*Label 31520*/ GIMT_Encode4(2297922), // Rule ID 72229 //
     /* 2297850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2297853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297893 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2297893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2297896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297898 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297921 */     // GIR_Coverage, 72229,
     /* 2297921 */     GIR_EraseRootFromParent_Done,
     /* 2297922 */   // Label 31520: @2297922
     /* 2297922 */   GIM_Try, /*On fail goto*//*Label 31521*/ GIMT_Encode4(2297999), // Rule ID 72230 //
     /* 2297927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2297930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2297938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2297955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2297959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2297963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2297968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2297970 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2297970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2297973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2297975 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2297977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2297981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2297985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2297988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2297991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2297994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2297997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2297998 */     // GIR_Coverage, 72230,
     /* 2297998 */     GIR_EraseRootFromParent_Done,
     /* 2297999 */   // Label 31521: @2297999
     /* 2297999 */   GIM_Try, /*On fail goto*//*Label 31522*/ GIMT_Encode4(2298061), // Rule ID 54908 //
     /* 2298004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298034 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2298037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298060 */     // GIR_Coverage, 54908,
     /* 2298060 */     GIR_EraseRootFromParent_Done,
     /* 2298061 */   // Label 31522: @2298061
     /* 2298061 */   GIM_Try, /*On fail goto*//*Label 31523*/ GIMT_Encode4(2298123), // Rule ID 54909 //
     /* 2298066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298094 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298096 */     // (fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2298099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298122 */     // GIR_Coverage, 54909,
     /* 2298122 */     GIR_EraseRootFromParent_Done,
     /* 2298123 */   // Label 31523: @2298123
     /* 2298123 */   GIM_Try, /*On fail goto*//*Label 31524*/ GIMT_Encode4(2298185), // Rule ID 72233 //
     /* 2298128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298158 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2298161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298169 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298184 */     // GIR_Coverage, 72233,
     /* 2298184 */     GIR_EraseRootFromParent_Done,
     /* 2298185 */   // Label 31524: @2298185
     /* 2298185 */   GIM_Try, /*On fail goto*//*Label 31525*/ GIMT_Encode4(2298247), // Rule ID 72234 //
     /* 2298190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298214 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298220 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2298223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298231 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298246 */     // GIR_Coverage, 72234,
     /* 2298246 */     GIR_EraseRootFromParent_Done,
     /* 2298247 */   // Label 31525: @2298247
     /* 2298247 */   GIM_Try, /*On fail goto*//*Label 31526*/ GIMT_Encode4(2298309), // Rule ID 54900 //
     /* 2298252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298280 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298282 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2298285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298287 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298289 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298308 */     // GIR_Coverage, 54900,
     /* 2298308 */     GIR_EraseRootFromParent_Done,
     /* 2298309 */   // Label 31526: @2298309
     /* 2298309 */   GIM_Try, /*On fail goto*//*Label 31527*/ GIMT_Encode4(2298371), // Rule ID 54901 //
     /* 2298314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2298329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2298337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298344 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2298347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2298357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298369 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298370 */     // GIR_Coverage, 54901,
     /* 2298370 */     GIR_EraseRootFromParent_Done,
     /* 2298371 */   // Label 31527: @2298371
     /* 2298371 */   GIM_Try, /*On fail goto*//*Label 31528*/ GIMT_Encode4(2298416), // Rule ID 54896 //
     /* 2298376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2298379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298391 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2298394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298398 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298400 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298415 */     // GIR_Coverage, 54896,
     /* 2298415 */     GIR_EraseRootFromParent_Done,
     /* 2298416 */   // Label 31528: @2298416
     /* 2298416 */   GIM_Try, /*On fail goto*//*Label 31529*/ GIMT_Encode4(2298461), // Rule ID 54897 //
     /* 2298421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2298424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2298436 */     // (fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2298439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298441 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2298445 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2298456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298460 */     // GIR_Coverage, 54897,
     /* 2298460 */     GIR_EraseRootFromParent_Done,
     /* 2298461 */   // Label 31529: @2298461
     /* 2298461 */   GIM_Reject,
     /* 2298462 */ // Label 31517: @2298462
     /* 2298462 */ GIM_Reject,
     /* 2298463 */ // Label 31349: @2298463
     /* 2298463 */ GIM_Try, /*On fail goto*//*Label 31530*/ GIMT_Encode4(2299252),
     /* 2298468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2298474 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2298477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298481 */   GIM_Try, /*On fail goto*//*Label 31531*/ GIMT_Encode4(2298558), // Rule ID 55288 //
     /* 2298486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298529 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2298532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298557 */     // GIR_Coverage, 55288,
     /* 2298557 */     GIR_EraseRootFromParent_Done,
     /* 2298558 */   // Label 31531: @2298558
     /* 2298558 */   GIM_Try, /*On fail goto*//*Label 31532*/ GIMT_Encode4(2298635), // Rule ID 55289 //
     /* 2298563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298574 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298606 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2298609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298611 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298633 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298634 */     // GIR_Coverage, 55289,
     /* 2298634 */     GIR_EraseRootFromParent_Done,
     /* 2298635 */   // Label 31532: @2298635
     /* 2298635 */   GIM_Try, /*On fail goto*//*Label 31533*/ GIMT_Encode4(2298712), // Rule ID 72565 //
     /* 2298640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298683 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2298686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298711 */     // GIR_Coverage, 72565,
     /* 2298711 */     GIR_EraseRootFromParent_Done,
     /* 2298712 */   // Label 31533: @2298712
     /* 2298712 */   GIM_Try, /*On fail goto*//*Label 31534*/ GIMT_Encode4(2298789), // Rule ID 72566 //
     /* 2298717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2298745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2298760 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2298763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2298775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298788 */     // GIR_Coverage, 72566,
     /* 2298788 */     GIR_EraseRootFromParent_Done,
     /* 2298789 */   // Label 31534: @2298789
     /* 2298789 */   GIM_Try, /*On fail goto*//*Label 31535*/ GIMT_Encode4(2298851), // Rule ID 55292 //
     /* 2298794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298822 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298824 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2298827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298835 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298850 */     // GIR_Coverage, 55292,
     /* 2298850 */     GIR_EraseRootFromParent_Done,
     /* 2298851 */   // Label 31535: @2298851
     /* 2298851 */   GIM_Try, /*On fail goto*//*Label 31536*/ GIMT_Encode4(2298913), // Rule ID 55293 //
     /* 2298856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2298863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298886 */     // (fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2298886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2298889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298891 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2298893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298897 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298912 */     // GIR_Coverage, 55293,
     /* 2298912 */     GIR_EraseRootFromParent_Done,
     /* 2298913 */   // Label 31536: @2298913
     /* 2298913 */   GIM_Try, /*On fail goto*//*Label 31537*/ GIMT_Encode4(2298975), // Rule ID 72569 //
     /* 2298918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2298921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2298948 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2298948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2298951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2298953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2298955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2298959 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2298961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2298964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2298967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2298970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2298973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2298974 */     // GIR_Coverage, 72569,
     /* 2298974 */     GIR_EraseRootFromParent_Done,
     /* 2298975 */   // Label 31537: @2298975
     /* 2298975 */   GIM_Try, /*On fail goto*//*Label 31538*/ GIMT_Encode4(2299037), // Rule ID 72570 //
     /* 2298980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2298983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2298987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2298991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2298995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2298999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299010 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2299013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299021 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299036 */     // GIR_Coverage, 72570,
     /* 2299036 */     GIR_EraseRootFromParent_Done,
     /* 2299037 */   // Label 31538: @2299037
     /* 2299037 */   GIM_Try, /*On fail goto*//*Label 31539*/ GIMT_Encode4(2299099), // Rule ID 55284 //
     /* 2299042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2299065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299070 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299072 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2299075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299077 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299079 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299098 */     // GIR_Coverage, 55284,
     /* 2299098 */     GIR_EraseRootFromParent_Done,
     /* 2299099 */   // Label 31539: @2299099
     /* 2299099 */   GIM_Try, /*On fail goto*//*Label 31540*/ GIMT_Encode4(2299161), // Rule ID 55285 //
     /* 2299104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2299127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299134 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2299137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299160 */     // GIR_Coverage, 55285,
     /* 2299160 */     GIR_EraseRootFromParent_Done,
     /* 2299161 */   // Label 31540: @2299161
     /* 2299161 */   GIM_Try, /*On fail goto*//*Label 31541*/ GIMT_Encode4(2299206), // Rule ID 55280 //
     /* 2299166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2299169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299181 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2299184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299186 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299205 */     // GIR_Coverage, 55280,
     /* 2299205 */     GIR_EraseRootFromParent_Done,
     /* 2299206 */   // Label 31541: @2299206
     /* 2299206 */   GIM_Try, /*On fail goto*//*Label 31542*/ GIMT_Encode4(2299251), // Rule ID 55281 //
     /* 2299211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2299214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2299226 */     // (fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2299229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299235 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2299246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299250 */     // GIR_Coverage, 55281,
     /* 2299250 */     GIR_EraseRootFromParent_Done,
     /* 2299251 */   // Label 31542: @2299251
     /* 2299251 */   GIM_Reject,
     /* 2299252 */ // Label 31530: @2299252
     /* 2299252 */ GIM_Reject,
     /* 2299253 */ // Label 31350: @2299253
     /* 2299253 */ GIM_Try, /*On fail goto*//*Label 31543*/ GIMT_Encode4(2300042),
     /* 2299258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2299264 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2299267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299271 */   GIM_Try, /*On fail goto*//*Label 31544*/ GIMT_Encode4(2299348), // Rule ID 55544 //
     /* 2299276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299308 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299312 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299319 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2299322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299326 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299347 */     // GIR_Coverage, 55544,
     /* 2299347 */     GIR_EraseRootFromParent_Done,
     /* 2299348 */   // Label 31544: @2299348
     /* 2299348 */   GIM_Try, /*On fail goto*//*Label 31545*/ GIMT_Encode4(2299425), // Rule ID 55545 //
     /* 2299353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299385 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299394 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299396 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2299399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299424 */     // GIR_Coverage, 55545,
     /* 2299424 */     GIR_EraseRootFromParent_Done,
     /* 2299425 */   // Label 31545: @2299425
     /* 2299425 */   GIM_Try, /*On fail goto*//*Label 31546*/ GIMT_Encode4(2299502), // Rule ID 72789 //
     /* 2299430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299471 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299473 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2299476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299501 */     // GIR_Coverage, 72789,
     /* 2299501 */     GIR_EraseRootFromParent_Done,
     /* 2299502 */   // Label 31546: @2299502
     /* 2299502 */   GIM_Try, /*On fail goto*//*Label 31547*/ GIMT_Encode4(2299579), // Rule ID 72790 //
     /* 2299507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299526 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2299535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2299550 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2299553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2299565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299578 */     // GIR_Coverage, 72790,
     /* 2299578 */     GIR_EraseRootFromParent_Done,
     /* 2299579 */   // Label 31547: @2299579
     /* 2299579 */   GIM_Try, /*On fail goto*//*Label 31548*/ GIMT_Encode4(2299641), // Rule ID 55548 //
     /* 2299584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299614 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2299617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299619 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299640 */     // GIR_Coverage, 55548,
     /* 2299640 */     GIR_EraseRootFromParent_Done,
     /* 2299641 */   // Label 31548: @2299641
     /* 2299641 */   GIM_Try, /*On fail goto*//*Label 31549*/ GIMT_Encode4(2299703), // Rule ID 55549 //
     /* 2299646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2299653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299676 */     // (fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2299679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299687 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299702 */     // GIR_Coverage, 55549,
     /* 2299702 */     GIR_EraseRootFromParent_Done,
     /* 2299703 */   // Label 31549: @2299703
     /* 2299703 */   GIM_Try, /*On fail goto*//*Label 31550*/ GIMT_Encode4(2299765), // Rule ID 72793 //
     /* 2299708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299738 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2299741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299743 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299749 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299764 */     // GIR_Coverage, 72793,
     /* 2299764 */     GIR_EraseRootFromParent_Done,
     /* 2299765 */   // Label 31550: @2299765
     /* 2299765 */   GIM_Try, /*On fail goto*//*Label 31551*/ GIMT_Encode4(2299827), // Rule ID 72794 //
     /* 2299770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2299781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299800 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2299803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299805 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2299807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2299811 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299826 */     // GIR_Coverage, 72794,
     /* 2299826 */     GIR_EraseRootFromParent_Done,
     /* 2299827 */   // Label 31551: @2299827
     /* 2299827 */   GIM_Try, /*On fail goto*//*Label 31552*/ GIMT_Encode4(2299889), // Rule ID 55540 //
     /* 2299832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299862 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2299865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299888 */     // GIR_Coverage, 55540,
     /* 2299888 */     GIR_EraseRootFromParent_Done,
     /* 2299889 */   // Label 31552: @2299889
     /* 2299889 */   GIM_Try, /*On fail goto*//*Label 31553*/ GIMT_Encode4(2299951), // Rule ID 55541 //
     /* 2299894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2299897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2299909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2299913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2299917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2299924 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2299924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2299927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2299937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299950 */     // GIR_Coverage, 55541,
     /* 2299950 */     GIR_EraseRootFromParent_Done,
     /* 2299951 */   // Label 31553: @2299951
     /* 2299951 */   GIM_Try, /*On fail goto*//*Label 31554*/ GIMT_Encode4(2299996), // Rule ID 55536 //
     /* 2299956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2299959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2299971 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2299971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2299974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2299976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2299978 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2299980 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2299982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2299985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2299988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2299991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2299994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2299995 */     // GIR_Coverage, 55536,
     /* 2299995 */     GIR_EraseRootFromParent_Done,
     /* 2299996 */   // Label 31554: @2299996
     /* 2299996 */   GIM_Try, /*On fail goto*//*Label 31555*/ GIMT_Encode4(2300041), // Rule ID 55537 //
     /* 2300001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2300004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300016 */     // (fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2300019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2300036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300040 */     // GIR_Coverage, 55537,
     /* 2300040 */     GIR_EraseRootFromParent_Done,
     /* 2300041 */   // Label 31555: @2300041
     /* 2300041 */   GIM_Reject,
     /* 2300042 */ // Label 31543: @2300042
     /* 2300042 */ GIM_Reject,
     /* 2300043 */ // Label 31351: @2300043
     /* 2300043 */ GIM_Try, /*On fail goto*//*Label 31556*/ GIMT_Encode4(2300832),
     /* 2300048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2300054 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2300057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300061 */   GIM_Try, /*On fail goto*//*Label 31557*/ GIMT_Encode4(2300138), // Rule ID 55096 //
     /* 2300066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300109 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2300112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300114 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300120 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300136 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300137 */     // GIR_Coverage, 55096,
     /* 2300137 */     GIR_EraseRootFromParent_Done,
     /* 2300138 */   // Label 31557: @2300138
     /* 2300138 */   GIM_Try, /*On fail goto*//*Label 31558*/ GIMT_Encode4(2300215), // Rule ID 55097 //
     /* 2300143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300179 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300186 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2300189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300191 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300214 */     // GIR_Coverage, 55097,
     /* 2300214 */     GIR_EraseRootFromParent_Done,
     /* 2300215 */   // Label 31558: @2300215
     /* 2300215 */   GIM_Try, /*On fail goto*//*Label 31559*/ GIMT_Encode4(2300292), // Rule ID 72397 //
     /* 2300220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300263 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2300266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300291 */     // GIR_Coverage, 72397,
     /* 2300291 */     GIR_EraseRootFromParent_Done,
     /* 2300292 */   // Label 31559: @2300292
     /* 2300292 */   GIM_Try, /*On fail goto*//*Label 31560*/ GIMT_Encode4(2300369), // Rule ID 72398 //
     /* 2300297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300329 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300333 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300338 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300340 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2300343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300368 */     // GIR_Coverage, 72398,
     /* 2300368 */     GIR_EraseRootFromParent_Done,
     /* 2300369 */   // Label 31560: @2300369
     /* 2300369 */   GIM_Try, /*On fail goto*//*Label 31561*/ GIMT_Encode4(2300431), // Rule ID 55100 //
     /* 2300374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300404 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2300407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300409 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300415 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300430 */     // GIR_Coverage, 55100,
     /* 2300430 */     GIR_EraseRootFromParent_Done,
     /* 2300431 */   // Label 31561: @2300431
     /* 2300431 */   GIM_Try, /*On fail goto*//*Label 31562*/ GIMT_Encode4(2300493), // Rule ID 55101 //
     /* 2300436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300466 */     // (fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2300469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300477 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300492 */     // GIR_Coverage, 55101,
     /* 2300492 */     GIR_EraseRootFromParent_Done,
     /* 2300493 */   // Label 31562: @2300493
     /* 2300493 */   GIM_Try, /*On fail goto*//*Label 31563*/ GIMT_Encode4(2300555), // Rule ID 72401 //
     /* 2300498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300526 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300528 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2300531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300533 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300539 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300554 */     // GIR_Coverage, 72401,
     /* 2300554 */     GIR_EraseRootFromParent_Done,
     /* 2300555 */   // Label 31563: @2300555
     /* 2300555 */   GIM_Try, /*On fail goto*//*Label 31564*/ GIMT_Encode4(2300617), // Rule ID 72402 //
     /* 2300560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2300571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300584 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300590 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2300593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300595 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2300597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300616 */     // GIR_Coverage, 72402,
     /* 2300616 */     GIR_EraseRootFromParent_Done,
     /* 2300617 */   // Label 31564: @2300617
     /* 2300617 */   GIM_Try, /*On fail goto*//*Label 31565*/ GIMT_Encode4(2300679), // Rule ID 55092 //
     /* 2300622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2300637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300652 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2300655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300657 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2300665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300678 */     // GIR_Coverage, 55092,
     /* 2300678 */     GIR_EraseRootFromParent_Done,
     /* 2300679 */   // Label 31565: @2300679
     /* 2300679 */   GIM_Try, /*On fail goto*//*Label 31566*/ GIMT_Encode4(2300741), // Rule ID 55093 //
     /* 2300684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2300699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2300707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2300714 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2300717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2300727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300740 */     // GIR_Coverage, 55093,
     /* 2300740 */     GIR_EraseRootFromParent_Done,
     /* 2300741 */   // Label 31566: @2300741
     /* 2300741 */   GIM_Try, /*On fail goto*//*Label 31567*/ GIMT_Encode4(2300786), // Rule ID 55088 //
     /* 2300746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2300749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300761 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2300764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300766 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300785 */     // GIR_Coverage, 55088,
     /* 2300785 */     GIR_EraseRootFromParent_Done,
     /* 2300786 */   // Label 31567: @2300786
     /* 2300786 */   GIM_Try, /*On fail goto*//*Label 31568*/ GIMT_Encode4(2300831), // Rule ID 55089 //
     /* 2300791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2300794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2300806 */     // (fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2300809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300811 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2300815 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2300817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2300826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300830 */     // GIR_Coverage, 55089,
     /* 2300830 */     GIR_EraseRootFromParent_Done,
     /* 2300831 */   // Label 31568: @2300831
     /* 2300831 */   GIM_Reject,
     /* 2300832 */ // Label 31556: @2300832
     /* 2300832 */ GIM_Reject,
     /* 2300833 */ // Label 31352: @2300833
     /* 2300833 */ GIM_Try, /*On fail goto*//*Label 31569*/ GIMT_Encode4(2301622),
     /* 2300838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2300844 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2300847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300851 */   GIM_Try, /*On fail goto*//*Label 31570*/ GIMT_Encode4(2300928), // Rule ID 55352 //
     /* 2300856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2300859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300888 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300899 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2300899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2300902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300904 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2300923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2300926 */     GIR_RootConstrainSelectedInstOperands,
     /* 2300927 */     // GIR_Coverage, 55352,
     /* 2300927 */     GIR_EraseRootFromParent_Done,
     /* 2300928 */   // Label 31570: @2300928
     /* 2300928 */   GIM_Try, /*On fail goto*//*Label 31571*/ GIMT_Encode4(2301005), // Rule ID 55353 //
     /* 2300933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2300936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2300940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300944 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2300961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2300965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2300969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2300974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2300976 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2300976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2300979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2300981 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2300983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2300987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2300991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2300994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2300997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301004 */     // GIR_Coverage, 55353,
     /* 2301004 */     GIR_EraseRootFromParent_Done,
     /* 2301005 */   // Label 31571: @2301005
     /* 2301005 */   GIM_Try, /*On fail goto*//*Label 31572*/ GIMT_Encode4(2301082), // Rule ID 72621 //
     /* 2301010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301053 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2301056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301081 */     // GIR_Coverage, 72621,
     /* 2301081 */     GIR_EraseRootFromParent_Done,
     /* 2301082 */   // Label 31572: @2301082
     /* 2301082 */   GIM_Try, /*On fail goto*//*Label 31573*/ GIMT_Encode4(2301159), // Rule ID 72622 //
     /* 2301087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301128 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301130 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2301133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301158 */     // GIR_Coverage, 72622,
     /* 2301158 */     GIR_EraseRootFromParent_Done,
     /* 2301159 */   // Label 31573: @2301159
     /* 2301159 */   GIM_Try, /*On fail goto*//*Label 31574*/ GIMT_Encode4(2301221), // Rule ID 55356 //
     /* 2301164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301194 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2301197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301199 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301205 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301220 */     // GIR_Coverage, 55356,
     /* 2301220 */     GIR_EraseRootFromParent_Done,
     /* 2301221 */   // Label 31574: @2301221
     /* 2301221 */   GIM_Try, /*On fail goto*//*Label 31575*/ GIMT_Encode4(2301283), // Rule ID 55357 //
     /* 2301226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301256 */     // (fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2301259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301267 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301282 */     // GIR_Coverage, 55357,
     /* 2301282 */     GIR_EraseRootFromParent_Done,
     /* 2301283 */   // Label 31575: @2301283
     /* 2301283 */   GIM_Try, /*On fail goto*//*Label 31576*/ GIMT_Encode4(2301345), // Rule ID 72625 //
     /* 2301288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301318 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2301321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301323 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301344 */     // GIR_Coverage, 72625,
     /* 2301344 */     GIR_EraseRootFromParent_Done,
     /* 2301345 */   // Label 31576: @2301345
     /* 2301345 */   GIM_Try, /*On fail goto*//*Label 31577*/ GIMT_Encode4(2301407), // Rule ID 72626 //
     /* 2301350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301380 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2301383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301391 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301405 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301406 */     // GIR_Coverage, 72626,
     /* 2301406 */     GIR_EraseRootFromParent_Done,
     /* 2301407 */   // Label 31577: @2301407
     /* 2301407 */   GIM_Try, /*On fail goto*//*Label 31578*/ GIMT_Encode4(2301469), // Rule ID 55348 //
     /* 2301412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301442 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2301445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301447 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301468 */     // GIR_Coverage, 55348,
     /* 2301468 */     GIR_EraseRootFromParent_Done,
     /* 2301469 */   // Label 31578: @2301469
     /* 2301469 */   GIM_Try, /*On fail goto*//*Label 31579*/ GIMT_Encode4(2301531), // Rule ID 55349 //
     /* 2301474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2301489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2301497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301504 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2301507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2301517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301530 */     // GIR_Coverage, 55349,
     /* 2301530 */     GIR_EraseRootFromParent_Done,
     /* 2301531 */   // Label 31579: @2301531
     /* 2301531 */   GIM_Try, /*On fail goto*//*Label 31580*/ GIMT_Encode4(2301576), // Rule ID 55344 //
     /* 2301536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2301539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301551 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2301554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301556 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301560 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301575 */     // GIR_Coverage, 55344,
     /* 2301575 */     GIR_EraseRootFromParent_Done,
     /* 2301576 */   // Label 31580: @2301576
     /* 2301576 */   GIM_Try, /*On fail goto*//*Label 31581*/ GIMT_Encode4(2301621), // Rule ID 55345 //
     /* 2301581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2301584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2301596 */     // (fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2301599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2301605 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2301616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301620 */     // GIR_Coverage, 55345,
     /* 2301620 */     GIR_EraseRootFromParent_Done,
     /* 2301621 */   // Label 31581: @2301621
     /* 2301621 */   GIM_Reject,
     /* 2301622 */ // Label 31569: @2301622
     /* 2301622 */ GIM_Reject,
     /* 2301623 */ // Label 31353: @2301623
     /* 2301623 */ GIM_Try, /*On fail goto*//*Label 31582*/ GIMT_Encode4(2302412),
     /* 2301628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2301634 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2301637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301641 */   GIM_Try, /*On fail goto*//*Label 31583*/ GIMT_Encode4(2301718), // Rule ID 55608 //
     /* 2301646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301689 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2301692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301717 */     // GIR_Coverage, 55608,
     /* 2301717 */     GIR_EraseRootFromParent_Done,
     /* 2301718 */   // Label 31583: @2301718
     /* 2301718 */   GIM_Try, /*On fail goto*//*Label 31584*/ GIMT_Encode4(2301795), // Rule ID 55609 //
     /* 2301723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301766 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2301769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301793 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301794 */     // GIR_Coverage, 55609,
     /* 2301794 */     GIR_EraseRootFromParent_Done,
     /* 2301795 */   // Label 31584: @2301795
     /* 2301795 */   GIM_Try, /*On fail goto*//*Label 31585*/ GIMT_Encode4(2301872), // Rule ID 72845 //
     /* 2301800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301843 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2301846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301871 */     // GIR_Coverage, 72845,
     /* 2301871 */     GIR_EraseRootFromParent_Done,
     /* 2301872 */   // Label 31585: @2301872
     /* 2301872 */   GIM_Try, /*On fail goto*//*Label 31586*/ GIMT_Encode4(2301949), // Rule ID 72846 //
     /* 2301877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2301880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2301888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301901 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2301905 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301909 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301913 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2301920 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2301920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2301923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2301927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2301935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2301938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2301941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2301944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2301947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2301948 */     // GIR_Coverage, 72846,
     /* 2301948 */     GIR_EraseRootFromParent_Done,
     /* 2301949 */   // Label 31586: @2301949
     /* 2301949 */   GIM_Try, /*On fail goto*//*Label 31587*/ GIMT_Encode4(2302011), // Rule ID 55612 //
     /* 2301954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2301957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2301961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2301965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2301969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2301982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2301984 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2301984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2301987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2301989 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2301991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2301995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2301997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302010 */     // GIR_Coverage, 55612,
     /* 2302010 */     GIR_EraseRootFromParent_Done,
     /* 2302011 */   // Label 31587: @2302011
     /* 2302011 */   GIM_Try, /*On fail goto*//*Label 31588*/ GIMT_Encode4(2302073), // Rule ID 55613 //
     /* 2302016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302046 */     // (fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2302049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302057 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302072 */     // GIR_Coverage, 55613,
     /* 2302072 */     GIR_EraseRootFromParent_Done,
     /* 2302073 */   // Label 31588: @2302073
     /* 2302073 */   GIM_Try, /*On fail goto*//*Label 31589*/ GIMT_Encode4(2302135), // Rule ID 72849 //
     /* 2302078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302108 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2302111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302119 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302134 */     // GIR_Coverage, 72849,
     /* 2302134 */     GIR_EraseRootFromParent_Done,
     /* 2302135 */   // Label 31589: @2302135
     /* 2302135 */   GIM_Try, /*On fail goto*//*Label 31590*/ GIMT_Encode4(2302197), // Rule ID 72850 //
     /* 2302140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302170 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2302173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302196 */     // GIR_Coverage, 72850,
     /* 2302196 */     GIR_EraseRootFromParent_Done,
     /* 2302197 */   // Label 31590: @2302197
     /* 2302197 */   GIM_Try, /*On fail goto*//*Label 31591*/ GIMT_Encode4(2302259), // Rule ID 55604 //
     /* 2302202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2302217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302232 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2302235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302237 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2302245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302258 */     // GIR_Coverage, 55604,
     /* 2302258 */     GIR_EraseRootFromParent_Done,
     /* 2302259 */   // Label 31591: @2302259
     /* 2302259 */   GIM_Try, /*On fail goto*//*Label 31592*/ GIMT_Encode4(2302321), // Rule ID 55605 //
     /* 2302264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2302279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2302287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302294 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2302297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2302307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302320 */     // GIR_Coverage, 55605,
     /* 2302320 */     GIR_EraseRootFromParent_Done,
     /* 2302321 */   // Label 31592: @2302321
     /* 2302321 */   GIM_Try, /*On fail goto*//*Label 31593*/ GIMT_Encode4(2302366), // Rule ID 55600 //
     /* 2302326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2302329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302341 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2302344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302350 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302365 */     // GIR_Coverage, 55600,
     /* 2302365 */     GIR_EraseRootFromParent_Done,
     /* 2302366 */   // Label 31593: @2302366
     /* 2302366 */   GIM_Try, /*On fail goto*//*Label 31594*/ GIMT_Encode4(2302411), // Rule ID 55601 //
     /* 2302371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2302374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2302386 */     // (fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2302389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302391 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2302395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2302406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302410 */     // GIR_Coverage, 55601,
     /* 2302410 */     GIR_EraseRootFromParent_Done,
     /* 2302411 */   // Label 31594: @2302411
     /* 2302411 */   GIM_Reject,
     /* 2302412 */ // Label 31582: @2302412
     /* 2302412 */ GIM_Reject,
     /* 2302413 */ // Label 31354: @2302413
     /* 2302413 */ GIM_Try, /*On fail goto*//*Label 31595*/ GIMT_Encode4(2303202),
     /* 2302418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2302424 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2302427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302431 */   GIM_Try, /*On fail goto*//*Label 31596*/ GIMT_Encode4(2302508), // Rule ID 55160 //
     /* 2302436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302479 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2302482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302507 */     // GIR_Coverage, 55160,
     /* 2302507 */     GIR_EraseRootFromParent_Done,
     /* 2302508 */   // Label 31596: @2302508
     /* 2302508 */   GIM_Try, /*On fail goto*//*Label 31597*/ GIMT_Encode4(2302585), // Rule ID 55161 //
     /* 2302513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302549 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302556 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2302559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302561 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302584 */     // GIR_Coverage, 55161,
     /* 2302584 */     GIR_EraseRootFromParent_Done,
     /* 2302585 */   // Label 31597: @2302585
     /* 2302585 */   GIM_Try, /*On fail goto*//*Label 31598*/ GIMT_Encode4(2302662), // Rule ID 72453 //
     /* 2302590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302633 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2302636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302661 */     // GIR_Coverage, 72453,
     /* 2302661 */     GIR_EraseRootFromParent_Done,
     /* 2302662 */   // Label 31598: @2302662
     /* 2302662 */   GIM_Try, /*On fail goto*//*Label 31599*/ GIMT_Encode4(2302739), // Rule ID 72454 //
     /* 2302667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2302695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2302710 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2302713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2302725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302738 */     // GIR_Coverage, 72454,
     /* 2302738 */     GIR_EraseRootFromParent_Done,
     /* 2302739 */   // Label 31599: @2302739
     /* 2302739 */   GIM_Try, /*On fail goto*//*Label 31600*/ GIMT_Encode4(2302801), // Rule ID 55164 //
     /* 2302744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302774 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2302777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302785 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302800 */     // GIR_Coverage, 55164,
     /* 2302800 */     GIR_EraseRootFromParent_Done,
     /* 2302801 */   // Label 31600: @2302801
     /* 2302801 */   GIM_Try, /*On fail goto*//*Label 31601*/ GIMT_Encode4(2302863), // Rule ID 55165 //
     /* 2302806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2302813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302836 */     // (fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2302839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2302843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302862 */     // GIR_Coverage, 55165,
     /* 2302862 */     GIR_EraseRootFromParent_Done,
     /* 2302863 */   // Label 31601: @2302863
     /* 2302863 */   GIM_Try, /*On fail goto*//*Label 31602*/ GIMT_Encode4(2302925), // Rule ID 72457 //
     /* 2302868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302898 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2302898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2302901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302924 */     // GIR_Coverage, 72457,
     /* 2302924 */     GIR_EraseRootFromParent_Done,
     /* 2302925 */   // Label 31602: @2302925
     /* 2302925 */   GIM_Try, /*On fail goto*//*Label 31603*/ GIMT_Encode4(2302987), // Rule ID 72458 //
     /* 2302930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2302933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2302941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2302945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2302949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302958 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2302960 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2302960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2302963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2302965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2302967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2302971 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2302973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2302976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2302979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2302982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2302985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2302986 */     // GIR_Coverage, 72458,
     /* 2302986 */     GIR_EraseRootFromParent_Done,
     /* 2302987 */   // Label 31603: @2302987
     /* 2302987 */   GIM_Try, /*On fail goto*//*Label 31604*/ GIMT_Encode4(2303049), // Rule ID 55156 //
     /* 2302992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2302995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2302999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2303015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303020 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303022 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2303025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303048 */     // GIR_Coverage, 55156,
     /* 2303048 */     GIR_EraseRootFromParent_Done,
     /* 2303049 */   // Label 31604: @2303049
     /* 2303049 */   GIM_Try, /*On fail goto*//*Label 31605*/ GIMT_Encode4(2303111), // Rule ID 55157 //
     /* 2303054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2303077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303084 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2303087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303110 */     // GIR_Coverage, 55157,
     /* 2303110 */     GIR_EraseRootFromParent_Done,
     /* 2303111 */   // Label 31605: @2303111
     /* 2303111 */   GIM_Try, /*On fail goto*//*Label 31606*/ GIMT_Encode4(2303156), // Rule ID 55152 //
     /* 2303116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2303119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303131 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2303134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303140 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303154 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303155 */     // GIR_Coverage, 55152,
     /* 2303155 */     GIR_EraseRootFromParent_Done,
     /* 2303156 */   // Label 31606: @2303156
     /* 2303156 */   GIM_Try, /*On fail goto*//*Label 31607*/ GIMT_Encode4(2303201), // Rule ID 55153 //
     /* 2303161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2303164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2303176 */     // (fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2303179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303181 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303185 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2303196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303200 */     // GIR_Coverage, 55153,
     /* 2303200 */     GIR_EraseRootFromParent_Done,
     /* 2303201 */   // Label 31607: @2303201
     /* 2303201 */   GIM_Reject,
     /* 2303202 */ // Label 31595: @2303202
     /* 2303202 */ GIM_Reject,
     /* 2303203 */ // Label 31355: @2303203
     /* 2303203 */ GIM_Try, /*On fail goto*//*Label 31608*/ GIMT_Encode4(2303992),
     /* 2303208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303211 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2303214 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2303217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303221 */   GIM_Try, /*On fail goto*//*Label 31609*/ GIMT_Encode4(2303298), // Rule ID 55416 //
     /* 2303226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303269 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2303272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303296 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303297 */     // GIR_Coverage, 55416,
     /* 2303297 */     GIR_EraseRootFromParent_Done,
     /* 2303298 */   // Label 31609: @2303298
     /* 2303298 */   GIM_Try, /*On fail goto*//*Label 31610*/ GIMT_Encode4(2303375), // Rule ID 55417 //
     /* 2303303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303339 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303346 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2303349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303351 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303374 */     // GIR_Coverage, 55417,
     /* 2303374 */     GIR_EraseRootFromParent_Done,
     /* 2303375 */   // Label 31610: @2303375
     /* 2303375 */   GIM_Try, /*On fail goto*//*Label 31611*/ GIMT_Encode4(2303452), // Rule ID 72677 //
     /* 2303380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303423 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2303426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303451 */     // GIR_Coverage, 72677,
     /* 2303451 */     GIR_EraseRootFromParent_Done,
     /* 2303452 */   // Label 31611: @2303452
     /* 2303452 */   GIM_Try, /*On fail goto*//*Label 31612*/ GIMT_Encode4(2303529), // Rule ID 72678 //
     /* 2303457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2303485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2303500 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2303503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303505 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2303515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303528 */     // GIR_Coverage, 72678,
     /* 2303528 */     GIR_EraseRootFromParent_Done,
     /* 2303529 */   // Label 31612: @2303529
     /* 2303529 */   GIM_Try, /*On fail goto*//*Label 31613*/ GIMT_Encode4(2303591), // Rule ID 55420 //
     /* 2303534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303564 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2303567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303575 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303590 */     // GIR_Coverage, 55420,
     /* 2303590 */     GIR_EraseRootFromParent_Done,
     /* 2303591 */   // Label 31613: @2303591
     /* 2303591 */   GIM_Try, /*On fail goto*//*Label 31614*/ GIMT_Encode4(2303653), // Rule ID 55421 //
     /* 2303596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2303603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303620 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303626 */     // (fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2303629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303637 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303652 */     // GIR_Coverage, 55421,
     /* 2303652 */     GIR_EraseRootFromParent_Done,
     /* 2303653 */   // Label 31614: @2303653
     /* 2303653 */   GIM_Try, /*On fail goto*//*Label 31615*/ GIMT_Encode4(2303715), // Rule ID 72681 //
     /* 2303658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303688 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2303691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303699 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303713 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303714 */     // GIR_Coverage, 72681,
     /* 2303714 */     GIR_EraseRootFromParent_Done,
     /* 2303715 */   // Label 31615: @2303715
     /* 2303715 */   GIM_Try, /*On fail goto*//*Label 31616*/ GIMT_Encode4(2303777), // Rule ID 72682 //
     /* 2303720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2303731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303750 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2303753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2303757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2303761 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303776 */     // GIR_Coverage, 72682,
     /* 2303776 */     GIR_EraseRootFromParent_Done,
     /* 2303777 */   // Label 31616: @2303777
     /* 2303777 */   GIM_Try, /*On fail goto*//*Label 31617*/ GIMT_Encode4(2303839), // Rule ID 55412 //
     /* 2303782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303812 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2303815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303838 */     // GIR_Coverage, 55412,
     /* 2303838 */     GIR_EraseRootFromParent_Done,
     /* 2303839 */   // Label 31617: @2303839
     /* 2303839 */   GIM_Try, /*On fail goto*//*Label 31618*/ GIMT_Encode4(2303901), // Rule ID 55413 //
     /* 2303844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2303859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2303863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2303867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2303874 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2303877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2303887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303900 */     // GIR_Coverage, 55413,
     /* 2303900 */     GIR_EraseRootFromParent_Done,
     /* 2303901 */   // Label 31618: @2303901
     /* 2303901 */   GIM_Try, /*On fail goto*//*Label 31619*/ GIMT_Encode4(2303946), // Rule ID 55408 //
     /* 2303906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2303909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303921 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2303921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2303924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303930 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303945 */     // GIR_Coverage, 55408,
     /* 2303945 */     GIR_EraseRootFromParent_Done,
     /* 2303946 */   // Label 31619: @2303946
     /* 2303946 */   GIM_Try, /*On fail goto*//*Label 31620*/ GIMT_Encode4(2303991), // Rule ID 55409 //
     /* 2303951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2303954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2303966 */     // (fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2303966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2303969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2303971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2303973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2303975 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2303977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2303980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2303983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2303986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2303989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2303990 */     // GIR_Coverage, 55409,
     /* 2303990 */     GIR_EraseRootFromParent_Done,
     /* 2303991 */   // Label 31620: @2303991
     /* 2303991 */   GIM_Reject,
     /* 2303992 */ // Label 31608: @2303992
     /* 2303992 */ GIM_Reject,
     /* 2303993 */ // Label 31356: @2303993
     /* 2303993 */ GIM_Try, /*On fail goto*//*Label 31621*/ GIMT_Encode4(2304782),
     /* 2303998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2304004 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2304007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304011 */   GIM_Try, /*On fail goto*//*Label 31622*/ GIMT_Encode4(2304088), // Rule ID 55224 //
     /* 2304016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304059 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2304062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304064 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304087 */     // GIR_Coverage, 55224,
     /* 2304087 */     GIR_EraseRootFromParent_Done,
     /* 2304088 */   // Label 31622: @2304088
     /* 2304088 */   GIM_Try, /*On fail goto*//*Label 31623*/ GIMT_Encode4(2304165), // Rule ID 55225 //
     /* 2304093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304136 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2304139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304141 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304164 */     // GIR_Coverage, 55225,
     /* 2304164 */     GIR_EraseRootFromParent_Done,
     /* 2304165 */   // Label 31623: @2304165
     /* 2304165 */   GIM_Try, /*On fail goto*//*Label 31624*/ GIMT_Encode4(2304242), // Rule ID 72509 //
     /* 2304170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304211 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304213 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2304216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304241 */     // GIR_Coverage, 72509,
     /* 2304241 */     GIR_EraseRootFromParent_Done,
     /* 2304242 */   // Label 31624: @2304242
     /* 2304242 */   GIM_Try, /*On fail goto*//*Label 31625*/ GIMT_Encode4(2304319), // Rule ID 72510 //
     /* 2304247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2304275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2304290 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2304293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2304305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304318 */     // GIR_Coverage, 72510,
     /* 2304318 */     GIR_EraseRootFromParent_Done,
     /* 2304319 */   // Label 31625: @2304319
     /* 2304319 */   GIM_Try, /*On fail goto*//*Label 31626*/ GIMT_Encode4(2304381), // Rule ID 55228 //
     /* 2304324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304354 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2304357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304365 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304380 */     // GIR_Coverage, 55228,
     /* 2304380 */     GIR_EraseRootFromParent_Done,
     /* 2304381 */   // Label 31626: @2304381
     /* 2304381 */   GIM_Try, /*On fail goto*//*Label 31627*/ GIMT_Encode4(2304443), // Rule ID 55229 //
     /* 2304386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2304393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304416 */     // (fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2304419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304421 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304427 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304441 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304442 */     // GIR_Coverage, 55229,
     /* 2304442 */     GIR_EraseRootFromParent_Done,
     /* 2304443 */   // Label 31627: @2304443
     /* 2304443 */   GIM_Try, /*On fail goto*//*Label 31628*/ GIMT_Encode4(2304505), // Rule ID 72513 //
     /* 2304448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304478 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2304481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304489 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304504 */     // GIR_Coverage, 72513,
     /* 2304504 */     GIR_EraseRootFromParent_Done,
     /* 2304505 */   // Label 31628: @2304505
     /* 2304505 */   GIM_Try, /*On fail goto*//*Label 31629*/ GIMT_Encode4(2304567), // Rule ID 72514 //
     /* 2304510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2304521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304529 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304538 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304540 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2304543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304545 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2304547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2304551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304566 */     // GIR_Coverage, 72514,
     /* 2304566 */     GIR_EraseRootFromParent_Done,
     /* 2304567 */   // Label 31629: @2304567
     /* 2304567 */   GIM_Try, /*On fail goto*//*Label 31630*/ GIMT_Encode4(2304629), // Rule ID 55220 //
     /* 2304572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304602 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2304605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304609 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2304615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304628 */     // GIR_Coverage, 55220,
     /* 2304628 */     GIR_EraseRootFromParent_Done,
     /* 2304629 */   // Label 31630: @2304629
     /* 2304629 */   GIM_Try, /*On fail goto*//*Label 31631*/ GIMT_Encode4(2304691), // Rule ID 55221 //
     /* 2304634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2304649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2304653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2304657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2304664 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2304667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2304677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304690 */     // GIR_Coverage, 55221,
     /* 2304690 */     GIR_EraseRootFromParent_Done,
     /* 2304691 */   // Label 31631: @2304691
     /* 2304691 */   GIM_Try, /*On fail goto*//*Label 31632*/ GIMT_Encode4(2304736), // Rule ID 55216 //
     /* 2304696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2304699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304711 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2304711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2304714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304716 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304720 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304735 */     // GIR_Coverage, 55216,
     /* 2304735 */     GIR_EraseRootFromParent_Done,
     /* 2304736 */   // Label 31632: @2304736
     /* 2304736 */   GIM_Try, /*On fail goto*//*Label 31633*/ GIMT_Encode4(2304781), // Rule ID 55217 //
     /* 2304741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2304744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2304756 */     // (fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2304756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2304759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2304763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304765 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2304767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2304773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2304776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2304779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304780 */     // GIR_Coverage, 55217,
     /* 2304780 */     GIR_EraseRootFromParent_Done,
     /* 2304781 */   // Label 31633: @2304781
     /* 2304781 */   GIM_Reject,
     /* 2304782 */ // Label 31621: @2304782
     /* 2304782 */ GIM_Reject,
     /* 2304783 */ // Label 31357: @2304783
     /* 2304783 */ GIM_Reject,
     /* 2304784 */ // Label 63: @2304784
     /* 2304784 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31652*/ GIMT_Encode4(2307211),
     /* 2304795 */ /*GILLT_s16*//*Label 31634*/ GIMT_Encode4(2304915),
     /* 2304799 */ /*GILLT_s32*//*Label 31635*/ GIMT_Encode4(2305064),
     /* 2304803 */ /*GILLT_s64*//*Label 31636*/ GIMT_Encode4(2305213), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304815 */ /*GILLT_nxv1s16*//*Label 31637*/ GIMT_Encode4(2305396),
     /* 2304819 */ /*GILLT_nxv1s32*//*Label 31638*/ GIMT_Encode4(2305517),
     /* 2304823 */ /*GILLT_nxv1s64*//*Label 31639*/ GIMT_Encode4(2305638), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304835 */ /*GILLT_nxv2s16*//*Label 31640*/ GIMT_Encode4(2305759),
     /* 2304839 */ /*GILLT_nxv2s32*//*Label 31641*/ GIMT_Encode4(2305880),
     /* 2304843 */ /*GILLT_nxv2s64*//*Label 31642*/ GIMT_Encode4(2306001), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304855 */ /*GILLT_nxv4s16*//*Label 31643*/ GIMT_Encode4(2306122),
     /* 2304859 */ /*GILLT_nxv4s32*//*Label 31644*/ GIMT_Encode4(2306243),
     /* 2304863 */ /*GILLT_nxv4s64*//*Label 31645*/ GIMT_Encode4(2306364), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304875 */ /*GILLT_nxv8s16*//*Label 31646*/ GIMT_Encode4(2306485),
     /* 2304879 */ /*GILLT_nxv8s32*//*Label 31647*/ GIMT_Encode4(2306606),
     /* 2304883 */ /*GILLT_nxv8s64*//*Label 31648*/ GIMT_Encode4(2306727), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304895 */ /*GILLT_nxv16s16*//*Label 31649*/ GIMT_Encode4(2306848),
     /* 2304899 */ /*GILLT_nxv16s32*//*Label 31650*/ GIMT_Encode4(2306969), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2304911 */ /*GILLT_nxv32s16*//*Label 31651*/ GIMT_Encode4(2307090),
     /* 2304915 */ // Label 31634: @2304915
     /* 2304915 */ GIM_Try, /*On fail goto*//*Label 31653*/ GIMT_Encode4(2305063),
     /* 2304920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2304923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2304926 */   GIM_Try, /*On fail goto*//*Label 31654*/ GIMT_Encode4(2304960), // Rule ID 1872 //
     /* 2304931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2304934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304946 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2304946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2304949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304959 */     // GIR_Coverage, 1872,
     /* 2304959 */     GIR_EraseRootFromParent_Done,
     /* 2304960 */   // Label 31654: @2304960
     /* 2304960 */   GIM_Try, /*On fail goto*//*Label 31655*/ GIMT_Encode4(2304994), // Rule ID 1873 //
     /* 2304965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2304968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2304980 */     // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2304980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2304983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2304985 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2304987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2304989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2304992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2304993 */     // GIR_Coverage, 1873,
     /* 2304993 */     GIR_EraseRootFromParent_Done,
     /* 2304994 */   // Label 31655: @2304994
     /* 2304994 */   GIM_Try, /*On fail goto*//*Label 31656*/ GIMT_Encode4(2305028), // Rule ID 1876 //
     /* 2304999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2305002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305014 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2305014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2305017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305027 */     // GIR_Coverage, 1876,
     /* 2305027 */     GIR_EraseRootFromParent_Done,
     /* 2305028 */   // Label 31656: @2305028
     /* 2305028 */   GIM_Try, /*On fail goto*//*Label 31657*/ GIMT_Encode4(2305062), // Rule ID 1877 //
     /* 2305033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2305036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2305048 */     // (fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2305048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2305051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305060 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305061 */     // GIR_Coverage, 1877,
     /* 2305061 */     GIR_EraseRootFromParent_Done,
     /* 2305062 */   // Label 31657: @2305062
     /* 2305062 */   GIM_Reject,
     /* 2305063 */ // Label 31653: @2305063
     /* 2305063 */ GIM_Reject,
     /* 2305064 */ // Label 31635: @2305064
     /* 2305064 */ GIM_Try, /*On fail goto*//*Label 31658*/ GIMT_Encode4(2305212),
     /* 2305069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2305072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2305075 */   GIM_Try, /*On fail goto*//*Label 31659*/ GIMT_Encode4(2305109), // Rule ID 1163 //
     /* 2305080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2305083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305095 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2305098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305108 */     // GIR_Coverage, 1163,
     /* 2305108 */     GIR_EraseRootFromParent_Done,
     /* 2305109 */   // Label 31659: @2305109
     /* 2305109 */   GIM_Try, /*On fail goto*//*Label 31660*/ GIMT_Encode4(2305143), // Rule ID 1164 //
     /* 2305114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2305117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2305129 */     // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2305132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305142 */     // GIR_Coverage, 1164,
     /* 2305142 */     GIR_EraseRootFromParent_Done,
     /* 2305143 */   // Label 31660: @2305143
     /* 2305143 */   GIM_Try, /*On fail goto*//*Label 31661*/ GIMT_Encode4(2305177), // Rule ID 1167 //
     /* 2305148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2305151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305163 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2305163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2305166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305170 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305175 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305176 */     // GIR_Coverage, 1167,
     /* 2305176 */     GIR_EraseRootFromParent_Done,
     /* 2305177 */   // Label 31661: @2305177
     /* 2305177 */   GIM_Try, /*On fail goto*//*Label 31662*/ GIMT_Encode4(2305211), // Rule ID 1168 //
     /* 2305182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2305185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2305197 */     // (fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2305197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2305200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305202 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305210 */     // GIR_Coverage, 1168,
     /* 2305210 */     GIR_EraseRootFromParent_Done,
     /* 2305211 */   // Label 31662: @2305211
     /* 2305211 */   GIM_Reject,
     /* 2305212 */ // Label 31658: @2305212
     /* 2305212 */ GIM_Reject,
     /* 2305213 */ // Label 31636: @2305213
     /* 2305213 */ GIM_Try, /*On fail goto*//*Label 31663*/ GIMT_Encode4(2305395),
     /* 2305218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2305221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2305224 */   GIM_Try, /*On fail goto*//*Label 31664*/ GIMT_Encode4(2305258), // Rule ID 1504 //
     /* 2305229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2305232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305244 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2305247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305257 */     // GIR_Coverage, 1504,
     /* 2305257 */     GIR_EraseRootFromParent_Done,
     /* 2305258 */   // Label 31664: @2305258
     /* 2305258 */   GIM_Try, /*On fail goto*//*Label 31665*/ GIMT_Encode4(2305292), // Rule ID 1505 //
     /* 2305263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2305266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2305278 */     // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2305281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305285 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305291 */     // GIR_Coverage, 1505,
     /* 2305291 */     GIR_EraseRootFromParent_Done,
     /* 2305292 */   // Label 31665: @2305292
     /* 2305292 */   GIM_Try, /*On fail goto*//*Label 31666*/ GIMT_Encode4(2305326), // Rule ID 1508 //
     /* 2305297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2305300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305312 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2305315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305317 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305319 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305325 */     // GIR_Coverage, 1508,
     /* 2305325 */     GIR_EraseRootFromParent_Done,
     /* 2305326 */   // Label 31666: @2305326
     /* 2305326 */   GIM_Try, /*On fail goto*//*Label 31667*/ GIMT_Encode4(2305360), // Rule ID 1509 //
     /* 2305331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2305334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2305346 */     // (fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2305346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2305349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305359 */     // GIR_Coverage, 1509,
     /* 2305359 */     GIR_EraseRootFromParent_Done,
     /* 2305360 */   // Label 31667: @2305360
     /* 2305360 */   GIM_Try, /*On fail goto*//*Label 31668*/ GIMT_Encode4(2305394), // Rule ID 1511 //
     /* 2305365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2305368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2305380 */     // (fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2305380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2305383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305385 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305387 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305393 */     // GIR_Coverage, 1511,
     /* 2305393 */     GIR_EraseRootFromParent_Done,
     /* 2305394 */   // Label 31668: @2305394
     /* 2305394 */   GIM_Reject,
     /* 2305395 */ // Label 31663: @2305395
     /* 2305395 */ GIM_Reject,
     /* 2305396 */ // Label 31637: @2305396
     /* 2305396 */ GIM_Try, /*On fail goto*//*Label 31669*/ GIMT_Encode4(2305516),
     /* 2305401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2305404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2305407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305415 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305419 */   GIM_Try, /*On fail goto*//*Label 31670*/ GIMT_Encode4(2305467), // Rule ID 54278 //
     /* 2305424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305427 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2305444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305449 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305451 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305466 */     // GIR_Coverage, 54278,
     /* 2305466 */     GIR_EraseRootFromParent_Done,
     /* 2305467 */   // Label 31670: @2305467
     /* 2305467 */   GIM_Try, /*On fail goto*//*Label 31671*/ GIMT_Encode4(2305515), // Rule ID 54279 //
     /* 2305472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305475 */     // (fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2305478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2305492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305513 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305514 */     // GIR_Coverage, 54279,
     /* 2305514 */     GIR_EraseRootFromParent_Done,
     /* 2305515 */   // Label 31671: @2305515
     /* 2305515 */   GIM_Reject,
     /* 2305516 */ // Label 31669: @2305516
     /* 2305516 */ GIM_Reject,
     /* 2305517 */ // Label 31638: @2305517
     /* 2305517 */ GIM_Try, /*On fail goto*//*Label 31672*/ GIMT_Encode4(2305637),
     /* 2305522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2305525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2305528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305536 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305540 */   GIM_Try, /*On fail goto*//*Label 31673*/ GIMT_Encode4(2305588), // Rule ID 54302 //
     /* 2305545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305548 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2305565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305567 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305570 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305572 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305587 */     // GIR_Coverage, 54302,
     /* 2305587 */     GIR_EraseRootFromParent_Done,
     /* 2305588 */   // Label 31673: @2305588
     /* 2305588 */   GIM_Try, /*On fail goto*//*Label 31674*/ GIMT_Encode4(2305636), // Rule ID 54303 //
     /* 2305593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305596 */     // (fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2305599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2305613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305635 */     // GIR_Coverage, 54303,
     /* 2305635 */     GIR_EraseRootFromParent_Done,
     /* 2305636 */   // Label 31674: @2305636
     /* 2305636 */   GIM_Reject,
     /* 2305637 */ // Label 31672: @2305637
     /* 2305637 */ GIM_Reject,
     /* 2305638 */ // Label 31639: @2305638
     /* 2305638 */ GIM_Try, /*On fail goto*//*Label 31675*/ GIMT_Encode4(2305758),
     /* 2305643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2305646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2305649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305661 */   GIM_Try, /*On fail goto*//*Label 31676*/ GIMT_Encode4(2305709), // Rule ID 54338 //
     /* 2305666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2305669 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2305686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305708 */     // GIR_Coverage, 54338,
     /* 2305708 */     GIR_EraseRootFromParent_Done,
     /* 2305709 */   // Label 31676: @2305709
     /* 2305709 */   GIM_Try, /*On fail goto*//*Label 31677*/ GIMT_Encode4(2305757), // Rule ID 54339 //
     /* 2305714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2305717 */     // (fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2305720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2305734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305736 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305739 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305741 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2305752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305755 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305756 */     // GIR_Coverage, 54339,
     /* 2305756 */     GIR_EraseRootFromParent_Done,
     /* 2305757 */   // Label 31677: @2305757
     /* 2305757 */   GIM_Reject,
     /* 2305758 */ // Label 31675: @2305758
     /* 2305758 */ GIM_Reject,
     /* 2305759 */ // Label 31640: @2305759
     /* 2305759 */ GIM_Try, /*On fail goto*//*Label 31678*/ GIMT_Encode4(2305879),
     /* 2305764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2305767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2305770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305778 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305782 */   GIM_Try, /*On fail goto*//*Label 31679*/ GIMT_Encode4(2305830), // Rule ID 54290 //
     /* 2305787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2305790 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2305807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305812 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305829 */     // GIR_Coverage, 54290,
     /* 2305829 */     GIR_EraseRootFromParent_Done,
     /* 2305830 */   // Label 31679: @2305830
     /* 2305830 */   GIM_Try, /*On fail goto*//*Label 31680*/ GIMT_Encode4(2305878), // Rule ID 54291 //
     /* 2305835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2305838 */     // (fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2305841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2305855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2305873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305877 */     // GIR_Coverage, 54291,
     /* 2305877 */     GIR_EraseRootFromParent_Done,
     /* 2305878 */   // Label 31680: @2305878
     /* 2305878 */   GIM_Reject,
     /* 2305879 */ // Label 31678: @2305879
     /* 2305879 */ GIM_Reject,
     /* 2305880 */ // Label 31641: @2305880
     /* 2305880 */ GIM_Try, /*On fail goto*//*Label 31681*/ GIMT_Encode4(2306000),
     /* 2305885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2305888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2305891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2305903 */   GIM_Try, /*On fail goto*//*Label 31682*/ GIMT_Encode4(2305951), // Rule ID 54326 //
     /* 2305908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2305911 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2305911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2305928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305950 */     // GIR_Coverage, 54326,
     /* 2305950 */     GIR_EraseRootFromParent_Done,
     /* 2305951 */   // Label 31682: @2305951
     /* 2305951 */   GIM_Try, /*On fail goto*//*Label 31683*/ GIMT_Encode4(2305999), // Rule ID 54327 //
     /* 2305956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2305959 */     // (fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2305959 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2305962 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2305966 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2305971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2305973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2305976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2305978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2305981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2305983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2305985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2305988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2305991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2305994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2305997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2305998 */     // GIR_Coverage, 54327,
     /* 2305998 */     GIR_EraseRootFromParent_Done,
     /* 2305999 */   // Label 31683: @2305999
     /* 2305999 */   GIM_Reject,
     /* 2306000 */ // Label 31681: @2306000
     /* 2306000 */ GIM_Reject,
     /* 2306001 */ // Label 31642: @2306001
     /* 2306001 */ GIM_Try, /*On fail goto*//*Label 31684*/ GIMT_Encode4(2306121),
     /* 2306006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2306009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2306012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306020 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306024 */   GIM_Try, /*On fail goto*//*Label 31685*/ GIMT_Encode4(2306072), // Rule ID 54422 //
     /* 2306029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306032 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2306035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2306049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306071 */     // GIR_Coverage, 54422,
     /* 2306071 */     GIR_EraseRootFromParent_Done,
     /* 2306072 */   // Label 31685: @2306072
     /* 2306072 */   GIM_Try, /*On fail goto*//*Label 31686*/ GIMT_Encode4(2306120), // Rule ID 54423 //
     /* 2306077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306080 */     // (fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2306083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2306097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306104 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306119 */     // GIR_Coverage, 54423,
     /* 2306119 */     GIR_EraseRootFromParent_Done,
     /* 2306120 */   // Label 31686: @2306120
     /* 2306120 */   GIM_Reject,
     /* 2306121 */ // Label 31684: @2306121
     /* 2306121 */ GIM_Reject,
     /* 2306122 */ // Label 31643: @2306122
     /* 2306122 */ GIM_Try, /*On fail goto*//*Label 31687*/ GIMT_Encode4(2306242),
     /* 2306127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2306130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2306133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306141 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2306145 */   GIM_Try, /*On fail goto*//*Label 31688*/ GIMT_Encode4(2306193), // Rule ID 54314 //
     /* 2306150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306153 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2306170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306192 */     // GIR_Coverage, 54314,
     /* 2306192 */     GIR_EraseRootFromParent_Done,
     /* 2306193 */   // Label 31688: @2306193
     /* 2306193 */   GIM_Try, /*On fail goto*//*Label 31689*/ GIMT_Encode4(2306241), // Rule ID 54315 //
     /* 2306198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306201 */     // (fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2306204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2306218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306240 */     // GIR_Coverage, 54315,
     /* 2306240 */     GIR_EraseRootFromParent_Done,
     /* 2306241 */   // Label 31689: @2306241
     /* 2306241 */   GIM_Reject,
     /* 2306242 */ // Label 31687: @2306242
     /* 2306242 */ GIM_Reject,
     /* 2306243 */ // Label 31644: @2306243
     /* 2306243 */ GIM_Try, /*On fail goto*//*Label 31690*/ GIMT_Encode4(2306363),
     /* 2306248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2306251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2306254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306266 */   GIM_Try, /*On fail goto*//*Label 31691*/ GIMT_Encode4(2306314), // Rule ID 54386 //
     /* 2306271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306274 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2306291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306313 */     // GIR_Coverage, 54386,
     /* 2306313 */     GIR_EraseRootFromParent_Done,
     /* 2306314 */   // Label 31691: @2306314
     /* 2306314 */   GIM_Try, /*On fail goto*//*Label 31692*/ GIMT_Encode4(2306362), // Rule ID 54387 //
     /* 2306319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306322 */     // (fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2306325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2306339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306361 */     // GIR_Coverage, 54387,
     /* 2306361 */     GIR_EraseRootFromParent_Done,
     /* 2306362 */   // Label 31692: @2306362
     /* 2306362 */   GIM_Reject,
     /* 2306363 */ // Label 31690: @2306363
     /* 2306363 */ GIM_Reject,
     /* 2306364 */ // Label 31645: @2306364
     /* 2306364 */ GIM_Try, /*On fail goto*//*Label 31693*/ GIMT_Encode4(2306484),
     /* 2306369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2306372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2306375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306387 */   GIM_Try, /*On fail goto*//*Label 31694*/ GIMT_Encode4(2306435), // Rule ID 54434 //
     /* 2306392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306395 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2306412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306434 */     // GIR_Coverage, 54434,
     /* 2306434 */     GIR_EraseRootFromParent_Done,
     /* 2306435 */   // Label 31694: @2306435
     /* 2306435 */   GIM_Try, /*On fail goto*//*Label 31695*/ GIMT_Encode4(2306483), // Rule ID 54435 //
     /* 2306440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306443 */     // (fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2306446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2306460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306481 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306482 */     // GIR_Coverage, 54435,
     /* 2306482 */     GIR_EraseRootFromParent_Done,
     /* 2306483 */   // Label 31695: @2306483
     /* 2306483 */   GIM_Reject,
     /* 2306484 */ // Label 31693: @2306484
     /* 2306484 */ GIM_Reject,
     /* 2306485 */ // Label 31646: @2306485
     /* 2306485 */ GIM_Try, /*On fail goto*//*Label 31696*/ GIMT_Encode4(2306605),
     /* 2306490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2306493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2306496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306504 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2306508 */   GIM_Try, /*On fail goto*//*Label 31697*/ GIMT_Encode4(2306556), // Rule ID 54350 //
     /* 2306513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306516 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2306533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306555 */     // GIR_Coverage, 54350,
     /* 2306555 */     GIR_EraseRootFromParent_Done,
     /* 2306556 */   // Label 31697: @2306556
     /* 2306556 */   GIM_Try, /*On fail goto*//*Label 31698*/ GIMT_Encode4(2306604), // Rule ID 54351 //
     /* 2306561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306564 */     // (fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2306567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2306581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306603 */     // GIR_Coverage, 54351,
     /* 2306603 */     GIR_EraseRootFromParent_Done,
     /* 2306604 */   // Label 31698: @2306604
     /* 2306604 */   GIM_Reject,
     /* 2306605 */ // Label 31696: @2306605
     /* 2306605 */ GIM_Reject,
     /* 2306606 */ // Label 31647: @2306606
     /* 2306606 */ GIM_Try, /*On fail goto*//*Label 31699*/ GIMT_Encode4(2306726),
     /* 2306611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2306614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2306617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306625 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306629 */   GIM_Try, /*On fail goto*//*Label 31700*/ GIMT_Encode4(2306677), // Rule ID 54398 //
     /* 2306634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2306637 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2306654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306659 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306676 */     // GIR_Coverage, 54398,
     /* 2306676 */     GIR_EraseRootFromParent_Done,
     /* 2306677 */   // Label 31700: @2306677
     /* 2306677 */   GIM_Try, /*On fail goto*//*Label 31701*/ GIMT_Encode4(2306725), // Rule ID 54399 //
     /* 2306682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2306685 */     // (fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2306688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2306702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2306720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306724 */     // GIR_Coverage, 54399,
     /* 2306724 */     GIR_EraseRootFromParent_Done,
     /* 2306725 */   // Label 31701: @2306725
     /* 2306725 */   GIM_Reject,
     /* 2306726 */ // Label 31699: @2306726
     /* 2306726 */ GIM_Reject,
     /* 2306727 */ // Label 31648: @2306727
     /* 2306727 */ GIM_Try, /*On fail goto*//*Label 31702*/ GIMT_Encode4(2306847),
     /* 2306732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2306735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2306738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306746 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306750 */   GIM_Try, /*On fail goto*//*Label 31703*/ GIMT_Encode4(2306798), // Rule ID 54446 //
     /* 2306755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2306758 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2306775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306782 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306797 */     // GIR_Coverage, 54446,
     /* 2306797 */     GIR_EraseRootFromParent_Done,
     /* 2306798 */   // Label 31703: @2306798
     /* 2306798 */   GIM_Try, /*On fail goto*//*Label 31704*/ GIMT_Encode4(2306846), // Rule ID 54447 //
     /* 2306803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2306806 */     // (fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2306809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2306823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306828 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306830 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2306841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306845 */     // GIR_Coverage, 54447,
     /* 2306845 */     GIR_EraseRootFromParent_Done,
     /* 2306846 */   // Label 31704: @2306846
     /* 2306846 */   GIM_Reject,
     /* 2306847 */ // Label 31702: @2306847
     /* 2306847 */ GIM_Reject,
     /* 2306848 */ // Label 31649: @2306848
     /* 2306848 */ GIM_Try, /*On fail goto*//*Label 31705*/ GIMT_Encode4(2306968),
     /* 2306853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2306856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2306859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306867 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2306871 */   GIM_Try, /*On fail goto*//*Label 31706*/ GIMT_Encode4(2306919), // Rule ID 54362 //
     /* 2306876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2306879 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2306879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2306896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306901 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306903 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306918 */     // GIR_Coverage, 54362,
     /* 2306918 */     GIR_EraseRootFromParent_Done,
     /* 2306919 */   // Label 31706: @2306919
     /* 2306919 */   GIM_Try, /*On fail goto*//*Label 31707*/ GIMT_Encode4(2306967), // Rule ID 54363 //
     /* 2306924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2306927 */     // (fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2306927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2306930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2306934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2306939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2306941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2306944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2306946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2306949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2306951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2306953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2306956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2306959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2306962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2306965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2306966 */     // GIR_Coverage, 54363,
     /* 2306966 */     GIR_EraseRootFromParent_Done,
     /* 2306967 */   // Label 31707: @2306967
     /* 2306967 */   GIM_Reject,
     /* 2306968 */ // Label 31705: @2306968
     /* 2306968 */ GIM_Reject,
     /* 2306969 */ // Label 31650: @2306969
     /* 2306969 */ GIM_Try, /*On fail goto*//*Label 31708*/ GIMT_Encode4(2307089),
     /* 2306974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2306977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2306980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2306992 */   GIM_Try, /*On fail goto*//*Label 31709*/ GIMT_Encode4(2307040), // Rule ID 54410 //
     /* 2306997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307000 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2307003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2307017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307024 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307039 */     // GIR_Coverage, 54410,
     /* 2307039 */     GIR_EraseRootFromParent_Done,
     /* 2307040 */   // Label 31709: @2307040
     /* 2307040 */   GIM_Try, /*On fail goto*//*Label 31710*/ GIMT_Encode4(2307088), // Rule ID 54411 //
     /* 2307045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307048 */     // (fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2307051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307060 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2307065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307070 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307087 */     // GIR_Coverage, 54411,
     /* 2307087 */     GIR_EraseRootFromParent_Done,
     /* 2307088 */   // Label 31710: @2307088
     /* 2307088 */   GIM_Reject,
     /* 2307089 */ // Label 31708: @2307089
     /* 2307089 */ GIM_Reject,
     /* 2307090 */ // Label 31651: @2307090
     /* 2307090 */ GIM_Try, /*On fail goto*//*Label 31711*/ GIMT_Encode4(2307210),
     /* 2307095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2307098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2307101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307105 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307109 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2307113 */   GIM_Try, /*On fail goto*//*Label 31712*/ GIMT_Encode4(2307161), // Rule ID 54374 //
     /* 2307118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307121 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307121 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307124 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307128 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2307138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307143 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307160 */     // GIR_Coverage, 54374,
     /* 2307160 */     GIR_EraseRootFromParent_Done,
     /* 2307161 */   // Label 31712: @2307161
     /* 2307161 */   GIM_Try, /*On fail goto*//*Label 31713*/ GIMT_Encode4(2307209), // Rule ID 54375 //
     /* 2307166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307169 */     // (fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2307172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2307186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307193 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2307195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2307198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307208 */     // GIR_Coverage, 54375,
     /* 2307208 */     GIR_EraseRootFromParent_Done,
     /* 2307209 */   // Label 31713: @2307209
     /* 2307209 */   GIM_Reject,
     /* 2307210 */ // Label 31711: @2307210
     /* 2307210 */ GIM_Reject,
     /* 2307211 */ // Label 31652: @2307211
     /* 2307211 */ GIM_Reject,
     /* 2307212 */ // Label 64: @2307212
     /* 2307212 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 31732*/ GIMT_Encode4(2309182),
     /* 2307223 */ /*GILLT_s16*//*Label 31714*/ GIMT_Encode4(2307343),
     /* 2307227 */ /*GILLT_s32*//*Label 31715*/ GIMT_Encode4(2307407),
     /* 2307231 */ /*GILLT_s64*//*Label 31716*/ GIMT_Encode4(2307471), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307243 */ /*GILLT_nxv1s16*//*Label 31717*/ GIMT_Encode4(2307562),
     /* 2307247 */ /*GILLT_nxv1s32*//*Label 31718*/ GIMT_Encode4(2307670),
     /* 2307251 */ /*GILLT_nxv1s64*//*Label 31719*/ GIMT_Encode4(2307778), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307263 */ /*GILLT_nxv2s16*//*Label 31720*/ GIMT_Encode4(2307886),
     /* 2307267 */ /*GILLT_nxv2s32*//*Label 31721*/ GIMT_Encode4(2307994),
     /* 2307271 */ /*GILLT_nxv2s64*//*Label 31722*/ GIMT_Encode4(2308102), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307283 */ /*GILLT_nxv4s16*//*Label 31723*/ GIMT_Encode4(2308210),
     /* 2307287 */ /*GILLT_nxv4s32*//*Label 31724*/ GIMT_Encode4(2308318),
     /* 2307291 */ /*GILLT_nxv4s64*//*Label 31725*/ GIMT_Encode4(2308426), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307303 */ /*GILLT_nxv8s16*//*Label 31726*/ GIMT_Encode4(2308534),
     /* 2307307 */ /*GILLT_nxv8s32*//*Label 31727*/ GIMT_Encode4(2308642),
     /* 2307311 */ /*GILLT_nxv8s64*//*Label 31728*/ GIMT_Encode4(2308750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307323 */ /*GILLT_nxv16s16*//*Label 31729*/ GIMT_Encode4(2308858),
     /* 2307327 */ /*GILLT_nxv16s32*//*Label 31730*/ GIMT_Encode4(2308966), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2307339 */ /*GILLT_nxv32s16*//*Label 31731*/ GIMT_Encode4(2309074),
     /* 2307343 */ // Label 31714: @2307343
     /* 2307343 */ GIM_Try, /*On fail goto*//*Label 31733*/ GIMT_Encode4(2307406),
     /* 2307348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2307351 */   GIM_Try, /*On fail goto*//*Label 31734*/ GIMT_Encode4(2307378), // Rule ID 1882 //
     /* 2307356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2307359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2307367 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2307367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2307370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307377 */     // GIR_Coverage, 1882,
     /* 2307377 */     GIR_EraseRootFromParent_Done,
     /* 2307378 */   // Label 31734: @2307378
     /* 2307378 */   GIM_Try, /*On fail goto*//*Label 31735*/ GIMT_Encode4(2307405), // Rule ID 1915 //
     /* 2307383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2307386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2307394 */     // (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2307394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2307397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307404 */     // GIR_Coverage, 1915,
     /* 2307404 */     GIR_EraseRootFromParent_Done,
     /* 2307405 */   // Label 31735: @2307405
     /* 2307405 */   GIM_Reject,
     /* 2307406 */ // Label 31733: @2307406
     /* 2307406 */ GIM_Reject,
     /* 2307407 */ // Label 31715: @2307407
     /* 2307407 */ GIM_Try, /*On fail goto*//*Label 31736*/ GIMT_Encode4(2307470),
     /* 2307412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2307415 */   GIM_Try, /*On fail goto*//*Label 31737*/ GIMT_Encode4(2307442), // Rule ID 1173 //
     /* 2307420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2307423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2307431 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2307431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2307434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307441 */     // GIR_Coverage, 1173,
     /* 2307441 */     GIR_EraseRootFromParent_Done,
     /* 2307442 */   // Label 31737: @2307442
     /* 2307442 */   GIM_Try, /*On fail goto*//*Label 31738*/ GIMT_Encode4(2307469), // Rule ID 1181 //
     /* 2307447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2307450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2307458 */     // (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2307458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2307461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307465 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307468 */     // GIR_Coverage, 1181,
     /* 2307468 */     GIR_EraseRootFromParent_Done,
     /* 2307469 */   // Label 31738: @2307469
     /* 2307469 */   GIM_Reject,
     /* 2307470 */ // Label 31736: @2307470
     /* 2307470 */ GIM_Reject,
     /* 2307471 */ // Label 31716: @2307471
     /* 2307471 */ GIM_Try, /*On fail goto*//*Label 31739*/ GIMT_Encode4(2307561),
     /* 2307476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2307479 */   GIM_Try, /*On fail goto*//*Label 31740*/ GIMT_Encode4(2307506), // Rule ID 1516 //
     /* 2307484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2307487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2307495 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2307495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2307498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307502 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307505 */     // GIR_Coverage, 1516,
     /* 2307505 */     GIR_EraseRootFromParent_Done,
     /* 2307506 */   // Label 31740: @2307506
     /* 2307506 */   GIM_Try, /*On fail goto*//*Label 31741*/ GIMT_Encode4(2307533), // Rule ID 1549 //
     /* 2307511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2307514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2307522 */     // (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2307522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2307525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307531 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307532 */     // GIR_Coverage, 1549,
     /* 2307532 */     GIR_EraseRootFromParent_Done,
     /* 2307533 */   // Label 31741: @2307533
     /* 2307533 */   GIM_Try, /*On fail goto*//*Label 31742*/ GIMT_Encode4(2307560), // Rule ID 1571 //
     /* 2307538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2307541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2307549 */     // (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2307549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2307552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307554 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307556 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2307558 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307559 */     // GIR_Coverage, 1571,
     /* 2307559 */     GIR_EraseRootFromParent_Done,
     /* 2307560 */   // Label 31742: @2307560
     /* 2307560 */   GIM_Reject,
     /* 2307561 */ // Label 31739: @2307561
     /* 2307561 */ GIM_Reject,
     /* 2307562 */ // Label 31717: @2307562
     /* 2307562 */ GIM_Try, /*On fail goto*//*Label 31743*/ GIMT_Encode4(2307669),
     /* 2307567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2307570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307578 */   GIM_Try, /*On fail goto*//*Label 31744*/ GIMT_Encode4(2307623), // Rule ID 56116 //
     /* 2307583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307586 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2307603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307622 */     // GIR_Coverage, 56116,
     /* 2307622 */     GIR_EraseRootFromParent_Done,
     /* 2307623 */   // Label 31744: @2307623
     /* 2307623 */   GIM_Try, /*On fail goto*//*Label 31745*/ GIMT_Encode4(2307668), // Rule ID 56117 //
     /* 2307628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307631 */     // (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2307634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2307648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307667 */     // GIR_Coverage, 56117,
     /* 2307667 */     GIR_EraseRootFromParent_Done,
     /* 2307668 */   // Label 31745: @2307668
     /* 2307668 */   GIM_Reject,
     /* 2307669 */ // Label 31743: @2307669
     /* 2307669 */ GIM_Reject,
     /* 2307670 */ // Label 31718: @2307670
     /* 2307670 */ GIM_Try, /*On fail goto*//*Label 31746*/ GIMT_Encode4(2307777),
     /* 2307675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2307678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307686 */   GIM_Try, /*On fail goto*//*Label 31747*/ GIMT_Encode4(2307731), // Rule ID 56156 //
     /* 2307691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2307694 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2307711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307729 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307730 */     // GIR_Coverage, 56156,
     /* 2307730 */     GIR_EraseRootFromParent_Done,
     /* 2307731 */   // Label 31747: @2307731
     /* 2307731 */   GIM_Try, /*On fail goto*//*Label 31748*/ GIMT_Encode4(2307776), // Rule ID 56157 //
     /* 2307736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2307739 */     // (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2307742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2307756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2307771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307775 */     // GIR_Coverage, 56157,
     /* 2307775 */     GIR_EraseRootFromParent_Done,
     /* 2307776 */   // Label 31748: @2307776
     /* 2307776 */   GIM_Reject,
     /* 2307777 */ // Label 31746: @2307777
     /* 2307777 */ GIM_Reject,
     /* 2307778 */ // Label 31719: @2307778
     /* 2307778 */ GIM_Try, /*On fail goto*//*Label 31749*/ GIMT_Encode4(2307885),
     /* 2307783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2307786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307794 */   GIM_Try, /*On fail goto*//*Label 31750*/ GIMT_Encode4(2307839), // Rule ID 56216 //
     /* 2307799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2307802 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2307805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2307819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307826 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2307834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307838 */     // GIR_Coverage, 56216,
     /* 2307838 */     GIR_EraseRootFromParent_Done,
     /* 2307839 */   // Label 31750: @2307839
     /* 2307839 */   GIM_Try, /*On fail goto*//*Label 31751*/ GIMT_Encode4(2307884), // Rule ID 56217 //
     /* 2307844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2307847 */     // (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2307850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2307864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2307879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307882 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307883 */     // GIR_Coverage, 56217,
     /* 2307883 */     GIR_EraseRootFromParent_Done,
     /* 2307884 */   // Label 31751: @2307884
     /* 2307884 */   GIM_Reject,
     /* 2307885 */ // Label 31749: @2307885
     /* 2307885 */ GIM_Reject,
     /* 2307886 */ // Label 31720: @2307886
     /* 2307886 */ GIM_Try, /*On fail goto*//*Label 31752*/ GIMT_Encode4(2307993),
     /* 2307891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2307894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2307902 */   GIM_Try, /*On fail goto*//*Label 31753*/ GIMT_Encode4(2307947), // Rule ID 56136 //
     /* 2307907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2307910 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2307910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2307913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2307927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307929 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307932 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307934 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307946 */     // GIR_Coverage, 56136,
     /* 2307946 */     GIR_EraseRootFromParent_Done,
     /* 2307947 */   // Label 31753: @2307947
     /* 2307947 */   GIM_Try, /*On fail goto*//*Label 31754*/ GIMT_Encode4(2307992), // Rule ID 56137 //
     /* 2307952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2307955 */     // (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2307955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2307958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2307962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2307967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2307969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2307972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2307974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2307977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2307981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2307984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2307987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2307990 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307991 */     // GIR_Coverage, 56137,
     /* 2307991 */     GIR_EraseRootFromParent_Done,
     /* 2307992 */   // Label 31754: @2307992
     /* 2307992 */   GIM_Reject,
     /* 2307993 */ // Label 31752: @2307993
     /* 2307993 */ GIM_Reject,
     /* 2307994 */ // Label 31721: @2307994
     /* 2307994 */ GIM_Try, /*On fail goto*//*Label 31755*/ GIMT_Encode4(2308101),
     /* 2307999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2308002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308010 */   GIM_Try, /*On fail goto*//*Label 31756*/ GIMT_Encode4(2308055), // Rule ID 56196 //
     /* 2308015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308018 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2308035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308037 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308040 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308054 */     // GIR_Coverage, 56196,
     /* 2308054 */     GIR_EraseRootFromParent_Done,
     /* 2308055 */   // Label 31756: @2308055
     /* 2308055 */   GIM_Try, /*On fail goto*//*Label 31757*/ GIMT_Encode4(2308100), // Rule ID 56197 //
     /* 2308060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308063 */     // (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2308066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2308080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308085 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308099 */     // GIR_Coverage, 56197,
     /* 2308099 */     GIR_EraseRootFromParent_Done,
     /* 2308100 */   // Label 31757: @2308100
     /* 2308100 */   GIM_Reject,
     /* 2308101 */ // Label 31755: @2308101
     /* 2308101 */ GIM_Reject,
     /* 2308102 */ // Label 31722: @2308102
     /* 2308102 */ GIM_Try, /*On fail goto*//*Label 31758*/ GIMT_Encode4(2308209),
     /* 2308107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2308110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308118 */   GIM_Try, /*On fail goto*//*Label 31759*/ GIMT_Encode4(2308163), // Rule ID 56356 //
     /* 2308123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308126 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2308143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308150 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308162 */     // GIR_Coverage, 56356,
     /* 2308162 */     GIR_EraseRootFromParent_Done,
     /* 2308163 */   // Label 31759: @2308163
     /* 2308163 */   GIM_Try, /*On fail goto*//*Label 31760*/ GIMT_Encode4(2308208), // Rule ID 56357 //
     /* 2308168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308171 */     // (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2308174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2308188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308207 */     // GIR_Coverage, 56357,
     /* 2308207 */     GIR_EraseRootFromParent_Done,
     /* 2308208 */   // Label 31760: @2308208
     /* 2308208 */   GIM_Reject,
     /* 2308209 */ // Label 31758: @2308209
     /* 2308209 */ GIM_Reject,
     /* 2308210 */ // Label 31723: @2308210
     /* 2308210 */ GIM_Try, /*On fail goto*//*Label 31761*/ GIMT_Encode4(2308317),
     /* 2308215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2308218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2308226 */   GIM_Try, /*On fail goto*//*Label 31762*/ GIMT_Encode4(2308271), // Rule ID 56176 //
     /* 2308231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308234 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2308251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308269 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308270 */     // GIR_Coverage, 56176,
     /* 2308270 */     GIR_EraseRootFromParent_Done,
     /* 2308271 */   // Label 31762: @2308271
     /* 2308271 */   GIM_Try, /*On fail goto*//*Label 31763*/ GIMT_Encode4(2308316), // Rule ID 56177 //
     /* 2308276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308279 */     // (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2308282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2308296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308315 */     // GIR_Coverage, 56177,
     /* 2308315 */     GIR_EraseRootFromParent_Done,
     /* 2308316 */   // Label 31763: @2308316
     /* 2308316 */   GIM_Reject,
     /* 2308317 */ // Label 31761: @2308317
     /* 2308317 */ GIM_Reject,
     /* 2308318 */ // Label 31724: @2308318
     /* 2308318 */ GIM_Try, /*On fail goto*//*Label 31764*/ GIMT_Encode4(2308425),
     /* 2308323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2308326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308334 */   GIM_Try, /*On fail goto*//*Label 31765*/ GIMT_Encode4(2308379), // Rule ID 56296 //
     /* 2308339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308342 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2308359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308378 */     // GIR_Coverage, 56296,
     /* 2308378 */     GIR_EraseRootFromParent_Done,
     /* 2308379 */   // Label 31765: @2308379
     /* 2308379 */   GIM_Try, /*On fail goto*//*Label 31766*/ GIMT_Encode4(2308424), // Rule ID 56297 //
     /* 2308384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308387 */     // (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2308390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2308404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308406 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308409 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308423 */     // GIR_Coverage, 56297,
     /* 2308423 */     GIR_EraseRootFromParent_Done,
     /* 2308424 */   // Label 31766: @2308424
     /* 2308424 */   GIM_Reject,
     /* 2308425 */ // Label 31764: @2308425
     /* 2308425 */ GIM_Reject,
     /* 2308426 */ // Label 31725: @2308426
     /* 2308426 */ GIM_Try, /*On fail goto*//*Label 31767*/ GIMT_Encode4(2308533),
     /* 2308431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2308434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308442 */   GIM_Try, /*On fail goto*//*Label 31768*/ GIMT_Encode4(2308487), // Rule ID 56376 //
     /* 2308447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308450 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2308467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308486 */     // GIR_Coverage, 56376,
     /* 2308486 */     GIR_EraseRootFromParent_Done,
     /* 2308487 */   // Label 31768: @2308487
     /* 2308487 */   GIM_Try, /*On fail goto*//*Label 31769*/ GIMT_Encode4(2308532), // Rule ID 56377 //
     /* 2308492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308495 */     // (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2308498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2308512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308530 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308531 */     // GIR_Coverage, 56377,
     /* 2308531 */     GIR_EraseRootFromParent_Done,
     /* 2308532 */   // Label 31769: @2308532
     /* 2308532 */   GIM_Reject,
     /* 2308533 */ // Label 31767: @2308533
     /* 2308533 */ GIM_Reject,
     /* 2308534 */ // Label 31726: @2308534
     /* 2308534 */ GIM_Try, /*On fail goto*//*Label 31770*/ GIMT_Encode4(2308641),
     /* 2308539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2308542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2308550 */   GIM_Try, /*On fail goto*//*Label 31771*/ GIMT_Encode4(2308595), // Rule ID 56236 //
     /* 2308555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308558 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2308575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308594 */     // GIR_Coverage, 56236,
     /* 2308594 */     GIR_EraseRootFromParent_Done,
     /* 2308595 */   // Label 31771: @2308595
     /* 2308595 */   GIM_Try, /*On fail goto*//*Label 31772*/ GIMT_Encode4(2308640), // Rule ID 56237 //
     /* 2308600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308603 */     // (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2308606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2308620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308627 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308638 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308639 */     // GIR_Coverage, 56237,
     /* 2308639 */     GIR_EraseRootFromParent_Done,
     /* 2308640 */   // Label 31772: @2308640
     /* 2308640 */   GIM_Reject,
     /* 2308641 */ // Label 31770: @2308641
     /* 2308641 */ GIM_Reject,
     /* 2308642 */ // Label 31727: @2308642
     /* 2308642 */ GIM_Try, /*On fail goto*//*Label 31773*/ GIMT_Encode4(2308749),
     /* 2308647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2308650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308658 */   GIM_Try, /*On fail goto*//*Label 31774*/ GIMT_Encode4(2308703), // Rule ID 56316 //
     /* 2308663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308666 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2308669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2308683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308690 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308702 */     // GIR_Coverage, 56316,
     /* 2308702 */     GIR_EraseRootFromParent_Done,
     /* 2308703 */   // Label 31774: @2308703
     /* 2308703 */   GIM_Try, /*On fail goto*//*Label 31775*/ GIMT_Encode4(2308748), // Rule ID 56317 //
     /* 2308708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2308711 */     // (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2308714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2308728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2308743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308747 */     // GIR_Coverage, 56317,
     /* 2308747 */     GIR_EraseRootFromParent_Done,
     /* 2308748 */   // Label 31775: @2308748
     /* 2308748 */   GIM_Reject,
     /* 2308749 */ // Label 31773: @2308749
     /* 2308749 */ GIM_Reject,
     /* 2308750 */ // Label 31728: @2308750
     /* 2308750 */ GIM_Try, /*On fail goto*//*Label 31776*/ GIMT_Encode4(2308857),
     /* 2308755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2308758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308766 */   GIM_Try, /*On fail goto*//*Label 31777*/ GIMT_Encode4(2308811), // Rule ID 56396 //
     /* 2308771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2308774 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2308777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2308791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308793 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308796 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308798 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308809 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308810 */     // GIR_Coverage, 56396,
     /* 2308810 */     GIR_EraseRootFromParent_Done,
     /* 2308811 */   // Label 31777: @2308811
     /* 2308811 */   GIM_Try, /*On fail goto*//*Label 31778*/ GIMT_Encode4(2308856), // Rule ID 56397 //
     /* 2308816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2308819 */     // (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2308822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2308836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2308851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308855 */     // GIR_Coverage, 56397,
     /* 2308855 */     GIR_EraseRootFromParent_Done,
     /* 2308856 */   // Label 31778: @2308856
     /* 2308856 */   GIM_Reject,
     /* 2308857 */ // Label 31776: @2308857
     /* 2308857 */ GIM_Reject,
     /* 2308858 */ // Label 31729: @2308858
     /* 2308858 */ GIM_Try, /*On fail goto*//*Label 31779*/ GIMT_Encode4(2308965),
     /* 2308863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2308866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2308874 */   GIM_Try, /*On fail goto*//*Label 31780*/ GIMT_Encode4(2308919), // Rule ID 56256 //
     /* 2308879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2308882 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2308885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2308899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308918 */     // GIR_Coverage, 56256,
     /* 2308918 */     GIR_EraseRootFromParent_Done,
     /* 2308919 */   // Label 31780: @2308919
     /* 2308919 */   GIM_Try, /*On fail goto*//*Label 31781*/ GIMT_Encode4(2308964), // Rule ID 56257 //
     /* 2308924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2308927 */     // (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2308927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2308930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2308939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2308941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2308944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2308946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2308949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2308953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2308956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2308959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2308962 */     GIR_RootConstrainSelectedInstOperands,
     /* 2308963 */     // GIR_Coverage, 56257,
     /* 2308963 */     GIR_EraseRootFromParent_Done,
     /* 2308964 */   // Label 31781: @2308964
     /* 2308964 */   GIM_Reject,
     /* 2308965 */ // Label 31779: @2308965
     /* 2308965 */ GIM_Reject,
     /* 2308966 */ // Label 31730: @2308966
     /* 2308966 */ GIM_Try, /*On fail goto*//*Label 31782*/ GIMT_Encode4(2309073),
     /* 2308971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2308974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2308982 */   GIM_Try, /*On fail goto*//*Label 31783*/ GIMT_Encode4(2309027), // Rule ID 56336 //
     /* 2308987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2308990 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2308990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2308993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2308997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2309007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309012 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309014 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309026 */     // GIR_Coverage, 56336,
     /* 2309026 */     GIR_EraseRootFromParent_Done,
     /* 2309027 */   // Label 31783: @2309027
     /* 2309027 */   GIM_Try, /*On fail goto*//*Label 31784*/ GIMT_Encode4(2309072), // Rule ID 56337 //
     /* 2309032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2309035 */     // (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2309038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2309052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309059 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2309067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309070 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309071 */     // GIR_Coverage, 56337,
     /* 2309071 */     GIR_EraseRootFromParent_Done,
     /* 2309072 */   // Label 31784: @2309072
     /* 2309072 */   GIM_Reject,
     /* 2309073 */ // Label 31782: @2309073
     /* 2309073 */ GIM_Reject,
     /* 2309074 */ // Label 31731: @2309074
     /* 2309074 */ GIM_Try, /*On fail goto*//*Label 31785*/ GIMT_Encode4(2309181),
     /* 2309079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2309082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2309090 */   GIM_Try, /*On fail goto*//*Label 31786*/ GIMT_Encode4(2309135), // Rule ID 56276 //
     /* 2309095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2309098 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2309098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2309115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309134 */     // GIR_Coverage, 56276,
     /* 2309134 */     GIR_EraseRootFromParent_Done,
     /* 2309135 */   // Label 31786: @2309135
     /* 2309135 */   GIM_Try, /*On fail goto*//*Label 31787*/ GIMT_Encode4(2309180), // Rule ID 56277 //
     /* 2309140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2309143 */     // (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2309143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2309146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2309150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2309155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2309157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2309160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2309165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309167 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2309169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2309172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2309175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2309178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309179 */     // GIR_Coverage, 56277,
     /* 2309179 */     GIR_EraseRootFromParent_Done,
     /* 2309180 */   // Label 31787: @2309180
     /* 2309180 */   GIM_Reject,
     /* 2309181 */ // Label 31785: @2309181
     /* 2309181 */ GIM_Reject,
     /* 2309182 */ // Label 31732: @2309182
     /* 2309182 */ GIM_Reject,
     /* 2309183 */ // Label 65: @2309183
     /* 2309183 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 31790*/ GIMT_Encode4(2309635),
     /* 2309194 */ /*GILLT_s32*//*Label 31788*/ GIMT_Encode4(2309202),
     /* 2309198 */ /*GILLT_s64*//*Label 31789*/ GIMT_Encode4(2309324),
     /* 2309202 */ // Label 31788: @2309202
     /* 2309202 */ GIM_Try, /*On fail goto*//*Label 31791*/ GIMT_Encode4(2309323),
     /* 2309207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309210 */   GIM_Try, /*On fail goto*//*Label 31792*/ GIMT_Encode4(2309238), // Rule ID 2056 //
     /* 2309215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2309218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309226 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2309226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2309229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309237 */     // GIR_Coverage, 2056,
     /* 2309237 */     GIR_EraseRootFromParent_Done,
     /* 2309238 */   // Label 31792: @2309238
     /* 2309238 */   GIM_Try, /*On fail goto*//*Label 31793*/ GIMT_Encode4(2309266), // Rule ID 2057 //
     /* 2309243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2309246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309254 */     // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_S_H:{ *:[f32] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2309254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2309257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309265 */     // GIR_Coverage, 2057,
     /* 2309265 */     GIR_EraseRootFromParent_Done,
     /* 2309266 */   // Label 31793: @2309266
     /* 2309266 */   GIM_Try, /*On fail goto*//*Label 31794*/ GIMT_Encode4(2309294), // Rule ID 2072 //
     /* 2309271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2309274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309282 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2309282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2309285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309293 */     // GIR_Coverage, 2072,
     /* 2309293 */     GIR_EraseRootFromParent_Done,
     /* 2309294 */   // Label 31794: @2309294
     /* 2309294 */   GIM_Try, /*On fail goto*//*Label 31795*/ GIMT_Encode4(2309322), // Rule ID 2073 //
     /* 2309299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2309302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309310 */     // (fpextend:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_S_H_INX:{ *:[f32] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2309310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2309313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2309321 */     // GIR_Coverage, 2073,
     /* 2309321 */     GIR_EraseRootFromParent_Done,
     /* 2309322 */   // Label 31795: @2309322
     /* 2309322 */   GIM_Reject,
     /* 2309323 */ // Label 31791: @2309323
     /* 2309323 */ GIM_Reject,
     /* 2309324 */ // Label 31789: @2309324
     /* 2309324 */ GIM_Try, /*On fail goto*//*Label 31796*/ GIMT_Encode4(2309355), // Rule ID 1458 //
     /* 2309329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2309332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309343 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2309343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2309346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309348 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309354 */   // GIR_Coverage, 1458,
     /* 2309354 */   GIR_EraseRootFromParent_Done,
     /* 2309355 */ // Label 31796: @2309355
     /* 2309355 */ GIM_Try, /*On fail goto*//*Label 31797*/ GIMT_Encode4(2309386), // Rule ID 1459 //
     /* 2309360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2309363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309374 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_D_S:{ *:[f64] } FPR32:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2309374 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2309377 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309379 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309384 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309385 */   // GIR_Coverage, 1459,
     /* 2309385 */   GIR_EraseRootFromParent_Done,
     /* 2309386 */ // Label 31797: @2309386
     /* 2309386 */ GIM_Try, /*On fail goto*//*Label 31798*/ GIMT_Encode4(2309417), // Rule ID 1463 //
     /* 2309391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2309394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309405 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_INX:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2309405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2309408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309410 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309416 */   // GIR_Coverage, 1463,
     /* 2309416 */   GIR_EraseRootFromParent_Done,
     /* 2309417 */ // Label 31798: @2309417
     /* 2309417 */ GIM_Try, /*On fail goto*//*Label 31799*/ GIMT_Encode4(2309448), // Rule ID 1470 //
     /* 2309422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2309425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309436 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i64] })
     /* 2309436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2309439 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309441 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309446 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309447 */   // GIR_Coverage, 1470,
     /* 2309447 */   GIR_EraseRootFromParent_Done,
     /* 2309448 */ // Label 31799: @2309448
     /* 2309448 */ GIM_Try, /*On fail goto*//*Label 31800*/ GIMT_Encode4(2309479), // Rule ID 1471 //
     /* 2309453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2309456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309467 */   // (fpextend:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_D_S_IN32X:{ *:[f64] } FPR32INX:{ *:[f32] }:$rs1, 0:{ *:[i32] })
     /* 2309467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2309470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309472 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309477 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309478 */   // GIR_Coverage, 1471,
     /* 2309478 */   GIR_EraseRootFromParent_Done,
     /* 2309479 */ // Label 31800: @2309479
     /* 2309479 */ GIM_Try, /*On fail goto*//*Label 31801*/ GIMT_Encode4(2309510), // Rule ID 2190 //
     /* 2309484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2309487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309498 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2309498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2309501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309503 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309505 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309508 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309509 */   // GIR_Coverage, 2190,
     /* 2309509 */   GIR_EraseRootFromParent_Done,
     /* 2309510 */ // Label 31801: @2309510
     /* 2309510 */ GIM_Try, /*On fail goto*//*Label 31802*/ GIMT_Encode4(2309541), // Rule ID 2191 //
     /* 2309515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2309518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309529 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_D_H:{ *:[f64] } FPR16:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2309529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2309532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309534 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309536 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309539 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309540 */   // GIR_Coverage, 2191,
     /* 2309540 */   GIR_EraseRootFromParent_Done,
     /* 2309541 */ // Label 31802: @2309541
     /* 2309541 */ GIM_Try, /*On fail goto*//*Label 31803*/ GIMT_Encode4(2309572), // Rule ID 2202 //
     /* 2309546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2309549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309560 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2309560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2309563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309565 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309571 */   // GIR_Coverage, 2202,
     /* 2309571 */   GIR_EraseRootFromParent_Done,
     /* 2309572 */ // Label 31803: @2309572
     /* 2309572 */ GIM_Try, /*On fail goto*//*Label 31804*/ GIMT_Encode4(2309603), // Rule ID 2203 //
     /* 2309577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2309580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309591 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_IN32X:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i32] })
     /* 2309591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2309594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309596 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309601 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309602 */   // GIR_Coverage, 2203,
     /* 2309602 */   GIR_EraseRootFromParent_Done,
     /* 2309603 */ // Label 31804: @2309603
     /* 2309603 */ GIM_Try, /*On fail goto*//*Label 31805*/ GIMT_Encode4(2309634), // Rule ID 2211 //
     /* 2309608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2309611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2309614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2309618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309622 */   // (fpextend:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_D_H_INX:{ *:[f64] } FPR16INX:{ *:[f16] }:$rs1, 0:{ *:[i64] })
     /* 2309622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2309625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309627 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2309632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309633 */   // GIR_Coverage, 2211,
     /* 2309633 */   GIR_EraseRootFromParent_Done,
     /* 2309634 */ // Label 31805: @2309634
     /* 2309634 */ GIM_Reject,
     /* 2309635 */ // Label 31790: @2309635
     /* 2309635 */ GIM_Reject,
     /* 2309636 */ // Label 66: @2309636
     /* 2309636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(28), /*)*//*default:*//*Label 31817*/ GIMT_Encode4(2311171),
     /* 2309647 */ /*GILLT_s16*//*Label 31806*/ GIMT_Encode4(2309751),
     /* 2309651 */ /*GILLT_s32*//*Label 31807*/ GIMT_Encode4(2310031), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309667 */ /*GILLT_nxv1s16*//*Label 31808*/ GIMT_Encode4(2310181),
     /* 2309671 */ /*GILLT_nxv1s32*//*Label 31809*/ GIMT_Encode4(2310291), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309687 */ /*GILLT_nxv2s16*//*Label 31810*/ GIMT_Encode4(2310401),
     /* 2309691 */ /*GILLT_nxv2s32*//*Label 31811*/ GIMT_Encode4(2310511), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309707 */ /*GILLT_nxv4s16*//*Label 31812*/ GIMT_Encode4(2310621),
     /* 2309711 */ /*GILLT_nxv4s32*//*Label 31813*/ GIMT_Encode4(2310731), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309727 */ /*GILLT_nxv8s16*//*Label 31814*/ GIMT_Encode4(2310841),
     /* 2309731 */ /*GILLT_nxv8s32*//*Label 31815*/ GIMT_Encode4(2310951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2309747 */ /*GILLT_nxv16s16*//*Label 31816*/ GIMT_Encode4(2311061),
     /* 2309751 */ // Label 31806: @2309751
     /* 2309751 */ GIM_Try, /*On fail goto*//*Label 31818*/ GIMT_Encode4(2309782), // Rule ID 2052 //
     /* 2309756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2309759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309770 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2309770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2309773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309775 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309781 */   // GIR_Coverage, 2052,
     /* 2309781 */   GIR_EraseRootFromParent_Done,
     /* 2309782 */ // Label 31818: @2309782
     /* 2309782 */ GIM_Try, /*On fail goto*//*Label 31819*/ GIMT_Encode4(2309813), // Rule ID 2053 //
     /* 2309787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2309790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2309801 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_H_S:{ *:[f16] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2309801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2309804 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309806 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309808 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309811 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309812 */   // GIR_Coverage, 2053,
     /* 2309812 */   GIR_EraseRootFromParent_Done,
     /* 2309813 */ // Label 31819: @2309813
     /* 2309813 */ GIM_Try, /*On fail goto*//*Label 31820*/ GIMT_Encode4(2309844), // Rule ID 2068 //
     /* 2309818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2309821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309832 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2309832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2309835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309837 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309842 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309843 */   // GIR_Coverage, 2068,
     /* 2309843 */   GIR_EraseRootFromParent_Done,
     /* 2309844 */ // Label 31820: @2309844
     /* 2309844 */ GIM_Try, /*On fail goto*//*Label 31821*/ GIMT_Encode4(2309875), // Rule ID 2069 //
     /* 2309849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2309852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2309855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2309863 */   // (fpround:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_H_S_INX:{ *:[f16] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2309863 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2309866 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309868 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309874 */   // GIR_Coverage, 2069,
     /* 2309874 */   GIR_EraseRootFromParent_Done,
     /* 2309875 */ // Label 31821: @2309875
     /* 2309875 */ GIM_Try, /*On fail goto*//*Label 31822*/ GIMT_Encode4(2309906), // Rule ID 2186 //
     /* 2309880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2309883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309894 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2309894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2309897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309904 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309905 */   // GIR_Coverage, 2186,
     /* 2309905 */   GIR_EraseRootFromParent_Done,
     /* 2309906 */ // Label 31822: @2309906
     /* 2309906 */ GIM_Try, /*On fail goto*//*Label 31823*/ GIMT_Encode4(2309937), // Rule ID 2187 //
     /* 2309911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2309914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2309921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2309925 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_H_D:{ *:[f16] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2309925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2309928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309930 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309936 */   // GIR_Coverage, 2187,
     /* 2309936 */   GIR_EraseRootFromParent_Done,
     /* 2309937 */ // Label 31823: @2309937
     /* 2309937 */ GIM_Try, /*On fail goto*//*Label 31824*/ GIMT_Encode4(2309968), // Rule ID 2198 //
     /* 2309942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2309945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309956 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2309956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2309959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309961 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309963 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309966 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309967 */   // GIR_Coverage, 2198,
     /* 2309967 */   GIR_EraseRootFromParent_Done,
     /* 2309968 */ // Label 31824: @2309968
     /* 2309968 */ GIM_Try, /*On fail goto*//*Label 31825*/ GIMT_Encode4(2309999), // Rule ID 2199 //
     /* 2309973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2309976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2309979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2309983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2309987 */   // (fpround:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_IN32X:{ *:[f16] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2309987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2309990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2309992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2309994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2309997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2309998 */   // GIR_Coverage, 2199,
     /* 2309998 */   GIR_EraseRootFromParent_Done,
     /* 2309999 */ // Label 31825: @2309999
     /* 2309999 */ GIM_Try, /*On fail goto*//*Label 31826*/ GIMT_Encode4(2310030), // Rule ID 2209 //
     /* 2310004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2310007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2310014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310018 */   // (fpround:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_H_D_INX:{ *:[f16] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2310018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2310021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310023 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310025 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310028 */   GIR_RootConstrainSelectedInstOperands,
     /* 2310029 */   // GIR_Coverage, 2209,
     /* 2310029 */   GIR_EraseRootFromParent_Done,
     /* 2310030 */ // Label 31826: @2310030
     /* 2310030 */ GIM_Reject,
     /* 2310031 */ // Label 31807: @2310031
     /* 2310031 */ GIM_Try, /*On fail goto*//*Label 31827*/ GIMT_Encode4(2310180),
     /* 2310036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2310039 */   GIM_Try, /*On fail goto*//*Label 31828*/ GIMT_Encode4(2310067), // Rule ID 1454 //
     /* 2310044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2310047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2310051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310055 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2310055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2310058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310066 */     // GIR_Coverage, 1454,
     /* 2310066 */     GIR_EraseRootFromParent_Done,
     /* 2310067 */   // Label 31828: @2310067
     /* 2310067 */   GIM_Try, /*On fail goto*//*Label 31829*/ GIMT_Encode4(2310095), // Rule ID 1455 //
     /* 2310072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2310075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2310079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2310083 */     // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_S_D:{ *:[f32] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2310083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2310086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310088 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310094 */     // GIR_Coverage, 1455,
     /* 2310094 */     GIR_EraseRootFromParent_Done,
     /* 2310095 */   // Label 31829: @2310095
     /* 2310095 */   GIM_Try, /*On fail goto*//*Label 31830*/ GIMT_Encode4(2310123), // Rule ID 1461 //
     /* 2310100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2310103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2310107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2310111 */     // (fpround:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_INX:{ *:[f32] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2310111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2310114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310122 */     // GIR_Coverage, 1461,
     /* 2310122 */     GIR_EraseRootFromParent_Done,
     /* 2310123 */   // Label 31830: @2310123
     /* 2310123 */   GIM_Try, /*On fail goto*//*Label 31831*/ GIMT_Encode4(2310151), // Rule ID 1466 //
     /* 2310128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2310131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2310135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310139 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2310139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2310142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310144 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310150 */     // GIR_Coverage, 1466,
     /* 2310150 */     GIR_EraseRootFromParent_Done,
     /* 2310151 */   // Label 31831: @2310151
     /* 2310151 */   GIM_Try, /*On fail goto*//*Label 31832*/ GIMT_Encode4(2310179), // Rule ID 1467 //
     /* 2310156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2310159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2310163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2310167 */     // (fpround:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_S_D_IN32X:{ *:[f32] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2310167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2310170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310178 */     // GIR_Coverage, 1467,
     /* 2310178 */     GIR_EraseRootFromParent_Done,
     /* 2310179 */   // Label 31832: @2310179
     /* 2310179 */   GIM_Reject,
     /* 2310180 */ // Label 31827: @2310180
     /* 2310180 */ GIM_Reject,
     /* 2310181 */ // Label 31808: @2310181
     /* 2310181 */ GIM_Try, /*On fail goto*//*Label 31833*/ GIMT_Encode4(2310290),
     /* 2310186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2310189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310193 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310197 */   GIM_Try, /*On fail goto*//*Label 31834*/ GIMT_Encode4(2310243), // Rule ID 58764 //
     /* 2310202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2310205 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2310208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2310222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310242 */     // GIR_Coverage, 58764,
     /* 2310242 */     GIR_EraseRootFromParent_Done,
     /* 2310243 */   // Label 31834: @2310243
     /* 2310243 */   GIM_Try, /*On fail goto*//*Label 31835*/ GIMT_Encode4(2310289), // Rule ID 58765 //
     /* 2310248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2310251 */     // (fpround:{ *:[nxv1f16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2310254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF4_E16),
     /* 2310268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310288 */     // GIR_Coverage, 58765,
     /* 2310288 */     GIR_EraseRootFromParent_Done,
     /* 2310289 */   // Label 31835: @2310289
     /* 2310289 */   GIM_Reject,
     /* 2310290 */ // Label 31833: @2310290
     /* 2310290 */ GIM_Reject,
     /* 2310291 */ // Label 31809: @2310291
     /* 2310291 */ GIM_Try, /*On fail goto*//*Label 31836*/ GIMT_Encode4(2310400),
     /* 2310296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2310299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310307 */   GIM_Try, /*On fail goto*//*Label 31837*/ GIMT_Encode4(2310353), // Rule ID 58774 //
     /* 2310312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2310315 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2310318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2310332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310352 */     // GIR_Coverage, 58774,
     /* 2310352 */     GIR_EraseRootFromParent_Done,
     /* 2310353 */   // Label 31837: @2310353
     /* 2310353 */   GIM_Try, /*On fail goto*//*Label 31838*/ GIMT_Encode4(2310399), // Rule ID 58775 //
     /* 2310358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2310361 */     // (fpround:{ *:[nxv1f32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2310364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E32),
     /* 2310378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310398 */     // GIR_Coverage, 58775,
     /* 2310398 */     GIR_EraseRootFromParent_Done,
     /* 2310399 */   // Label 31838: @2310399
     /* 2310399 */   GIM_Reject,
     /* 2310400 */ // Label 31836: @2310400
     /* 2310400 */ GIM_Reject,
     /* 2310401 */ // Label 31810: @2310401
     /* 2310401 */ GIM_Try, /*On fail goto*//*Label 31839*/ GIMT_Encode4(2310510),
     /* 2310406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2310409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310417 */   GIM_Try, /*On fail goto*//*Label 31840*/ GIMT_Encode4(2310463), // Rule ID 58766 //
     /* 2310422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2310425 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2310428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2310442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310462 */     // GIR_Coverage, 58766,
     /* 2310462 */     GIR_EraseRootFromParent_Done,
     /* 2310463 */   // Label 31840: @2310463
     /* 2310463 */   GIM_Try, /*On fail goto*//*Label 31841*/ GIMT_Encode4(2310509), // Rule ID 58767 //
     /* 2310468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2310471 */     // (fpround:{ *:[nxv2f16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2310474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_MF2_E16),
     /* 2310488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310508 */     // GIR_Coverage, 58767,
     /* 2310508 */     GIR_EraseRootFromParent_Done,
     /* 2310509 */   // Label 31841: @2310509
     /* 2310509 */   GIM_Reject,
     /* 2310510 */ // Label 31839: @2310510
     /* 2310510 */ GIM_Reject,
     /* 2310511 */ // Label 31811: @2310511
     /* 2310511 */ GIM_Try, /*On fail goto*//*Label 31842*/ GIMT_Encode4(2310620),
     /* 2310516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2310519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310527 */   GIM_Try, /*On fail goto*//*Label 31843*/ GIMT_Encode4(2310573), // Rule ID 58776 //
     /* 2310532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2310535 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2310538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2310552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310557 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310572 */     // GIR_Coverage, 58776,
     /* 2310572 */     GIR_EraseRootFromParent_Done,
     /* 2310573 */   // Label 31843: @2310573
     /* 2310573 */   GIM_Try, /*On fail goto*//*Label 31844*/ GIMT_Encode4(2310619), // Rule ID 58777 //
     /* 2310578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2310581 */     // (fpround:{ *:[nxv2f32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2310584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E32),
     /* 2310598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310618 */     // GIR_Coverage, 58777,
     /* 2310618 */     GIR_EraseRootFromParent_Done,
     /* 2310619 */   // Label 31844: @2310619
     /* 2310619 */   GIM_Reject,
     /* 2310620 */ // Label 31842: @2310620
     /* 2310620 */ GIM_Reject,
     /* 2310621 */ // Label 31812: @2310621
     /* 2310621 */ GIM_Try, /*On fail goto*//*Label 31845*/ GIMT_Encode4(2310730),
     /* 2310626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2310629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2310633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310637 */   GIM_Try, /*On fail goto*//*Label 31846*/ GIMT_Encode4(2310683), // Rule ID 58768 //
     /* 2310642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2310645 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2310648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2310662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310667 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310682 */     // GIR_Coverage, 58768,
     /* 2310682 */     GIR_EraseRootFromParent_Done,
     /* 2310683 */   // Label 31846: @2310683
     /* 2310683 */   GIM_Try, /*On fail goto*//*Label 31847*/ GIMT_Encode4(2310729), // Rule ID 58769 //
     /* 2310688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2310691 */     // (fpround:{ *:[nxv4f16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2310694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M1_E16),
     /* 2310708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310728 */     // GIR_Coverage, 58769,
     /* 2310728 */     GIR_EraseRootFromParent_Done,
     /* 2310729 */   // Label 31847: @2310729
     /* 2310729 */   GIM_Reject,
     /* 2310730 */ // Label 31845: @2310730
     /* 2310730 */ GIM_Reject,
     /* 2310731 */ // Label 31813: @2310731
     /* 2310731 */ GIM_Try, /*On fail goto*//*Label 31848*/ GIMT_Encode4(2310840),
     /* 2310736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2310739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310747 */   GIM_Try, /*On fail goto*//*Label 31849*/ GIMT_Encode4(2310793), // Rule ID 58778 //
     /* 2310752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2310755 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2310758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2310772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310792 */     // GIR_Coverage, 58778,
     /* 2310792 */     GIR_EraseRootFromParent_Done,
     /* 2310793 */   // Label 31849: @2310793
     /* 2310793 */   GIM_Try, /*On fail goto*//*Label 31850*/ GIMT_Encode4(2310839), // Rule ID 58779 //
     /* 2310798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2310801 */     // (fpround:{ *:[nxv4f32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2310804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E32),
     /* 2310818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2310834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310838 */     // GIR_Coverage, 58779,
     /* 2310838 */     GIR_EraseRootFromParent_Done,
     /* 2310839 */   // Label 31850: @2310839
     /* 2310839 */   GIM_Reject,
     /* 2310840 */ // Label 31848: @2310840
     /* 2310840 */ GIM_Reject,
     /* 2310841 */ // Label 31814: @2310841
     /* 2310841 */ GIM_Try, /*On fail goto*//*Label 31851*/ GIMT_Encode4(2310950),
     /* 2310846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2310849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2310853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310857 */   GIM_Try, /*On fail goto*//*Label 31852*/ GIMT_Encode4(2310903), // Rule ID 58770 //
     /* 2310862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2310865 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2310868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310877 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2310882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310887 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310902 */     // GIR_Coverage, 58770,
     /* 2310902 */     GIR_EraseRootFromParent_Done,
     /* 2310903 */   // Label 31852: @2310903
     /* 2310903 */   GIM_Try, /*On fail goto*//*Label 31853*/ GIMT_Encode4(2310949), // Rule ID 58771 //
     /* 2310908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2310911 */     // (fpround:{ *:[nxv8f16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2310911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2310914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M2_E16),
     /* 2310928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2310938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2310941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2310944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2310947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2310948 */     // GIR_Coverage, 58771,
     /* 2310948 */     GIR_EraseRootFromParent_Done,
     /* 2310949 */   // Label 31853: @2310949
     /* 2310949 */   GIM_Reject,
     /* 2310950 */ // Label 31851: @2310950
     /* 2310950 */ GIM_Reject,
     /* 2310951 */ // Label 31815: @2310951
     /* 2310951 */ GIM_Try, /*On fail goto*//*Label 31854*/ GIMT_Encode4(2311060),
     /* 2310956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2310959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2310963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2310967 */   GIM_Try, /*On fail goto*//*Label 31855*/ GIMT_Encode4(2311013), // Rule ID 58780 //
     /* 2310972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode0),
     /* 2310975 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2310975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2310978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2310982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2310987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2310989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2310992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2310994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2310997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2310999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311012 */     // GIR_Coverage, 58780,
     /* 2311012 */     GIR_EraseRootFromParent_Done,
     /* 2311013 */   // Label 31855: @2311013
     /* 2311013 */   GIM_Try, /*On fail goto*//*Label 31856*/ GIMT_Encode4(2311059), // Rule ID 58781 //
     /* 2311018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsF64_HwMode1),
     /* 2311021 */     // (fpround:{ *:[nxv8f32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8f64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2311024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E32),
     /* 2311038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2311054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311058 */     // GIR_Coverage, 58781,
     /* 2311058 */     GIR_EraseRootFromParent_Done,
     /* 2311059 */   // Label 31856: @2311059
     /* 2311059 */   GIM_Reject,
     /* 2311060 */ // Label 31854: @2311060
     /* 2311060 */ GIM_Reject,
     /* 2311061 */ // Label 31816: @2311061
     /* 2311061 */ GIM_Try, /*On fail goto*//*Label 31857*/ GIMT_Encode4(2311170),
     /* 2311066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2311069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2311073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2311077 */   GIM_Try, /*On fail goto*//*Label 31858*/ GIMT_Encode4(2311123), // Rule ID 58772 //
     /* 2311082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode0),
     /* 2311085 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2311088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2311102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311122 */     // GIR_Coverage, 58772,
     /* 2311122 */     GIR_EraseRootFromParent_Done,
     /* 2311123 */   // Label 31858: @2311123
     /* 2311123 */   GIM_Try, /*On fail goto*//*Label 31859*/ GIMT_Encode4(2311169), // Rule ID 58773 //
     /* 2311128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16Minimal_HwMode1),
     /* 2311131 */     // (fpround:{ *:[nxv16f16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_F_F_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16f32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2311134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_F_W_M4_E16),
     /* 2311148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2311158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2311164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311168 */     // GIR_Coverage, 58773,
     /* 2311168 */     GIR_EraseRootFromParent_Done,
     /* 2311169 */   // Label 31859: @2311169
     /* 2311169 */   GIM_Reject,
     /* 2311170 */ // Label 31857: @2311170
     /* 2311170 */ GIM_Reject,
     /* 2311171 */ // Label 31817: @2311171
     /* 2311171 */ GIM_Reject,
     /* 2311172 */ // Label 67: @2311172
     /* 2311172 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 31883*/ GIMT_Encode4(2316057),
     /* 2311183 */ /*GILLT_s32*//*Label 31860*/ GIMT_Encode4(2311299),
     /* 2311187 */ /*GILLT_s64*//*Label 31861*/ GIMT_Encode4(2311672), GIMT_Encode4(0),
     /* 2311195 */ /*GILLT_nxv1s8*//*Label 31862*/ GIMT_Encode4(2311859),
     /* 2311199 */ /*GILLT_nxv1s16*//*Label 31863*/ GIMT_Encode4(2311963),
     /* 2311203 */ /*GILLT_nxv1s32*//*Label 31864*/ GIMT_Encode4(2312180),
     /* 2311207 */ /*GILLT_nxv1s64*//*Label 31865*/ GIMT_Encode4(2312505), GIMT_Encode4(0),
     /* 2311215 */ /*GILLT_nxv2s8*//*Label 31866*/ GIMT_Encode4(2312722),
     /* 2311219 */ /*GILLT_nxv2s16*//*Label 31867*/ GIMT_Encode4(2312826),
     /* 2311223 */ /*GILLT_nxv2s32*//*Label 31868*/ GIMT_Encode4(2313043),
     /* 2311227 */ /*GILLT_nxv2s64*//*Label 31869*/ GIMT_Encode4(2313368), GIMT_Encode4(0),
     /* 2311235 */ /*GILLT_nxv4s8*//*Label 31870*/ GIMT_Encode4(2313585),
     /* 2311239 */ /*GILLT_nxv4s16*//*Label 31871*/ GIMT_Encode4(2313689),
     /* 2311243 */ /*GILLT_nxv4s32*//*Label 31872*/ GIMT_Encode4(2313906),
     /* 2311247 */ /*GILLT_nxv4s64*//*Label 31873*/ GIMT_Encode4(2314231), GIMT_Encode4(0),
     /* 2311255 */ /*GILLT_nxv8s8*//*Label 31874*/ GIMT_Encode4(2314448),
     /* 2311259 */ /*GILLT_nxv8s16*//*Label 31875*/ GIMT_Encode4(2314552),
     /* 2311263 */ /*GILLT_nxv8s32*//*Label 31876*/ GIMT_Encode4(2314769),
     /* 2311267 */ /*GILLT_nxv8s64*//*Label 31877*/ GIMT_Encode4(2315094), GIMT_Encode4(0),
     /* 2311275 */ /*GILLT_nxv16s8*//*Label 31878*/ GIMT_Encode4(2315311),
     /* 2311279 */ /*GILLT_nxv16s16*//*Label 31879*/ GIMT_Encode4(2315415),
     /* 2311283 */ /*GILLT_nxv16s32*//*Label 31880*/ GIMT_Encode4(2315632), GIMT_Encode4(0),
     /* 2311291 */ /*GILLT_nxv32s8*//*Label 31881*/ GIMT_Encode4(2315849),
     /* 2311295 */ /*GILLT_nxv32s16*//*Label 31882*/ GIMT_Encode4(2315953),
     /* 2311299 */ // Label 31860: @2311299
     /* 2311299 */ GIM_Try, /*On fail goto*//*Label 31884*/ GIMT_Encode4(2311330), // Rule ID 1346 //
     /* 2311304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2311307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311318 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2311318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2311321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311328 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311329 */   // GIR_Coverage, 1346,
     /* 2311329 */   GIR_EraseRootFromParent_Done,
     /* 2311330 */ // Label 31884: @2311330
     /* 2311330 */ GIM_Try, /*On fail goto*//*Label 31885*/ GIMT_Encode4(2311361), // Rule ID 1347 //
     /* 2311335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2311338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311349 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2311349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2311352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311359 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311360 */   // GIR_Coverage, 1347,
     /* 2311360 */   GIR_EraseRootFromParent_Done,
     /* 2311361 */ // Label 31885: @2311361
     /* 2311361 */ GIM_Try, /*On fail goto*//*Label 31886*/ GIMT_Encode4(2311392), // Rule ID 1372 //
     /* 2311366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2311369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311380 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2311380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2311383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311385 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311387 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311390 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311391 */   // GIR_Coverage, 1372,
     /* 2311391 */   GIR_EraseRootFromParent_Done,
     /* 2311392 */ // Label 31886: @2311392
     /* 2311392 */ GIM_Try, /*On fail goto*//*Label 31887*/ GIMT_Encode4(2311423), // Rule ID 1373 //
     /* 2311397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2311400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311411 */   // (fp_to_sint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2311411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2311414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311416 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311422 */   // GIR_Coverage, 1373,
     /* 2311422 */   GIR_EraseRootFromParent_Done,
     /* 2311423 */ // Label 31887: @2311423
     /* 2311423 */ GIM_Try, /*On fail goto*//*Label 31888*/ GIMT_Encode4(2311454), // Rule ID 1740 //
     /* 2311428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2311431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2311442 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2311442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2311445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311447 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311452 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311453 */   // GIR_Coverage, 1740,
     /* 2311453 */   GIR_EraseRootFromParent_Done,
     /* 2311454 */ // Label 31888: @2311454
     /* 2311454 */ GIM_Try, /*On fail goto*//*Label 31889*/ GIMT_Encode4(2311485), // Rule ID 1741 //
     /* 2311459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2311462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2311473 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2311473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2311476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311478 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311483 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311484 */   // GIR_Coverage, 1741,
     /* 2311484 */   GIR_EraseRootFromParent_Done,
     /* 2311485 */ // Label 31889: @2311485
     /* 2311485 */ GIM_Try, /*On fail goto*//*Label 31890*/ GIMT_Encode4(2311516), // Rule ID 1766 //
     /* 2311490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2311493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2311504 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2311504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2311507 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311509 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311511 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311514 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311515 */   // GIR_Coverage, 1766,
     /* 2311515 */   GIR_EraseRootFromParent_Done,
     /* 2311516 */ // Label 31890: @2311516
     /* 2311516 */ GIM_Try, /*On fail goto*//*Label 31891*/ GIMT_Encode4(2311547), // Rule ID 1767 //
     /* 2311521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2311524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2311535 */   // (fp_to_sint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2311535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2311538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311540 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311545 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311546 */   // GIR_Coverage, 1767,
     /* 2311546 */   GIR_EraseRootFromParent_Done,
     /* 2311547 */ // Label 31891: @2311547
     /* 2311547 */ GIM_Try, /*On fail goto*//*Label 31892*/ GIMT_Encode4(2311578), // Rule ID 2082 //
     /* 2311552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2311555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311562 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311566 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2311566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2311569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311576 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311577 */   // GIR_Coverage, 2082,
     /* 2311577 */   GIR_EraseRootFromParent_Done,
     /* 2311578 */ // Label 31892: @2311578
     /* 2311578 */ GIM_Try, /*On fail goto*//*Label 31893*/ GIMT_Encode4(2311609), // Rule ID 2083 //
     /* 2311583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2311586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311593 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311597 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2311597 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2311600 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311602 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311607 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311608 */   // GIR_Coverage, 2083,
     /* 2311608 */   GIR_EraseRootFromParent_Done,
     /* 2311609 */ // Label 31893: @2311609
     /* 2311609 */ GIM_Try, /*On fail goto*//*Label 31894*/ GIMT_Encode4(2311640), // Rule ID 2108 //
     /* 2311614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2311617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311628 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2311628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2311631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311633 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311638 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311639 */   // GIR_Coverage, 2108,
     /* 2311639 */   GIR_EraseRootFromParent_Done,
     /* 2311640 */ // Label 31894: @2311640
     /* 2311640 */ GIM_Try, /*On fail goto*//*Label 31895*/ GIMT_Encode4(2311671), // Rule ID 2109 //
     /* 2311645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2311648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311659 */   // (fp_to_sint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2311659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2311662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311664 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311670 */   // GIR_Coverage, 2109,
     /* 2311670 */   GIR_EraseRootFromParent_Done,
     /* 2311671 */ // Label 31895: @2311671
     /* 2311671 */ GIM_Reject,
     /* 2311672 */ // Label 31861: @2311672
     /* 2311672 */ GIM_Try, /*On fail goto*//*Label 31896*/ GIMT_Encode4(2311703), // Rule ID 1403 //
     /* 2311677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2311680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2311691 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2311691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2311694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311702 */   // GIR_Coverage, 1403,
     /* 2311702 */   GIR_EraseRootFromParent_Done,
     /* 2311703 */ // Label 31896: @2311703
     /* 2311703 */ GIM_Try, /*On fail goto*//*Label 31897*/ GIMT_Encode4(2311734), // Rule ID 1431 //
     /* 2311708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2311711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2311714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2311722 */   // (fp_to_sint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2311722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2311725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311733 */   // GIR_Coverage, 1431,
     /* 2311733 */   GIR_EraseRootFromParent_Done,
     /* 2311734 */ // Label 31897: @2311734
     /* 2311734 */ GIM_Try, /*On fail goto*//*Label 31898*/ GIMT_Encode4(2311765), // Rule ID 1803 //
     /* 2311739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2311742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2311753 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2311753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2311756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311763 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311764 */   // GIR_Coverage, 1803,
     /* 2311764 */   GIR_EraseRootFromParent_Done,
     /* 2311765 */ // Label 31898: @2311765
     /* 2311765 */ GIM_Try, /*On fail goto*//*Label 31899*/ GIMT_Encode4(2311796), // Rule ID 1831 //
     /* 2311770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2311773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2311776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311784 */   // (fp_to_sint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2311784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2311787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311789 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311794 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311795 */   // GIR_Coverage, 1831,
     /* 2311795 */   GIR_EraseRootFromParent_Done,
     /* 2311796 */ // Label 31899: @2311796
     /* 2311796 */ GIM_Try, /*On fail goto*//*Label 31900*/ GIMT_Encode4(2311827), // Rule ID 2137 //
     /* 2311801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2311804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311811 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2311815 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2311815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2311818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311820 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311825 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311826 */   // GIR_Coverage, 2137,
     /* 2311826 */   GIR_EraseRootFromParent_Done,
     /* 2311827 */ // Label 31900: @2311827
     /* 2311827 */ GIM_Try, /*On fail goto*//*Label 31901*/ GIMT_Encode4(2311858), // Rule ID 2163 //
     /* 2311832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2311835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2311838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2311842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2311846 */   // (fp_to_sint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2311846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2311849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311851 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311853 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2311856 */   GIR_RootConstrainSelectedInstOperands,
     /* 2311857 */   // GIR_Coverage, 2163,
     /* 2311857 */   GIR_EraseRootFromParent_Done,
     /* 2311858 */ // Label 31901: @2311858
     /* 2311858 */ GIM_Reject,
     /* 2311859 */ // Label 31862: @2311859
     /* 2311859 */ GIM_Try, /*On fail goto*//*Label 31902*/ GIMT_Encode4(2311962),
     /* 2311864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311871 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311875 */   GIM_Try, /*On fail goto*//*Label 31903*/ GIMT_Encode4(2311918), // Rule ID 45698 //
     /* 2311880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2311883 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2311886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2311900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311916 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311917 */     // GIR_Coverage, 45698,
     /* 2311917 */     GIR_EraseRootFromParent_Done,
     /* 2311918 */   // Label 31903: @2311918
     /* 2311918 */   GIM_Try, /*On fail goto*//*Label 31904*/ GIMT_Encode4(2311961), // Rule ID 45699 //
     /* 2311923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2311926 */     // (fp_to_sint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2311926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2311929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF8),
     /* 2311943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2311945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2311948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2311950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2311953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2311959 */     GIR_RootConstrainSelectedInstOperands,
     /* 2311960 */     // GIR_Coverage, 45699,
     /* 2311960 */     GIR_EraseRootFromParent_Done,
     /* 2311961 */   // Label 31904: @2311961
     /* 2311961 */   GIM_Reject,
     /* 2311962 */ // Label 31902: @2311962
     /* 2311962 */ GIM_Reject,
     /* 2311963 */ // Label 31863: @2311963
     /* 2311963 */ GIM_Try, /*On fail goto*//*Label 31905*/ GIMT_Encode4(2312017), // Rule ID 45682 //
     /* 2311968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2311971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2311974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2311982 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2311982 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2311985 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2311989 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2311994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2311996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2311999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312001 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312004 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312012 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312015 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312016 */   // GIR_Coverage, 45682,
     /* 2312016 */   GIR_EraseRootFromParent_Done,
     /* 2312017 */ // Label 31905: @2312017
     /* 2312017 */ GIM_Try, /*On fail goto*//*Label 31906*/ GIMT_Encode4(2312071), // Rule ID 45683 //
     /* 2312022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2312025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2312028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312036 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2312039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF4),
     /* 2312053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312058 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312069 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312070 */   // GIR_Coverage, 45683,
     /* 2312070 */   GIR_EraseRootFromParent_Done,
     /* 2312071 */ // Label 31906: @2312071
     /* 2312071 */ GIM_Try, /*On fail goto*//*Label 31907*/ GIMT_Encode4(2312125), // Rule ID 58602 //
     /* 2312076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2312079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312090 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312090 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2312093 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312097 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2312107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312112 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312120 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312124 */   // GIR_Coverage, 58602,
     /* 2312124 */   GIR_EraseRootFromParent_Done,
     /* 2312125 */ // Label 31907: @2312125
     /* 2312125 */ GIM_Try, /*On fail goto*//*Label 31908*/ GIMT_Encode4(2312179), // Rule ID 58603 //
     /* 2312130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2312133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312144 */   // (fp_to_sint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312144 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2312147 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312151 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2312161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312166 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312177 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312178 */   // GIR_Coverage, 58603,
     /* 2312178 */   GIR_EraseRootFromParent_Done,
     /* 2312179 */ // Label 31908: @2312179
     /* 2312179 */ GIM_Reject,
     /* 2312180 */ // Label 31864: @2312180
     /* 2312180 */ GIM_Try, /*On fail goto*//*Label 31909*/ GIMT_Encode4(2312234), // Rule ID 45690 //
     /* 2312185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2312188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2312191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312199 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312211 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312213 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2312216 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312218 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312221 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312232 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312233 */   // GIR_Coverage, 45690,
     /* 2312233 */   GIR_EraseRootFromParent_Done,
     /* 2312234 */ // Label 31909: @2312234
     /* 2312234 */ GIM_Try, /*On fail goto*//*Label 31910*/ GIMT_Encode4(2312288), // Rule ID 45691 //
     /* 2312239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2312242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2312245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312253 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF4),
     /* 2312270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312275 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312286 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312287 */   // GIR_Coverage, 45691,
     /* 2312287 */   GIR_EraseRootFromParent_Done,
     /* 2312288 */ // Label 31910: @2312288
     /* 2312288 */ GIM_Try, /*On fail goto*//*Label 31911*/ GIMT_Encode4(2312342), // Rule ID 58170 //
     /* 2312293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2312296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312307 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312319 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312321 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2312324 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312329 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312337 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312340 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312341 */   // GIR_Coverage, 58170,
     /* 2312341 */   GIR_EraseRootFromParent_Done,
     /* 2312342 */ // Label 31911: @2312342
     /* 2312342 */ GIM_Try, /*On fail goto*//*Label 31912*/ GIMT_Encode4(2312396), // Rule ID 58171 //
     /* 2312347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2312350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312361 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312373 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2312378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312383 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312391 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312394 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312395 */   // GIR_Coverage, 58171,
     /* 2312395 */   GIR_EraseRootFromParent_Done,
     /* 2312396 */ // Label 31912: @2312396
     /* 2312396 */ GIM_Try, /*On fail goto*//*Label 31913*/ GIMT_Encode4(2312450), // Rule ID 58622 //
     /* 2312401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2312404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312415 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2312432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312437 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312445 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312448 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312449 */   // GIR_Coverage, 58622,
     /* 2312449 */   GIR_EraseRootFromParent_Done,
     /* 2312450 */ // Label 31913: @2312450
     /* 2312450 */ GIM_Try, /*On fail goto*//*Label 31914*/ GIMT_Encode4(2312504), // Rule ID 58623 //
     /* 2312455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2312458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312469 */   // (fp_to_sint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2312472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2312486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312491 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312499 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312502 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312503 */   // GIR_Coverage, 58623,
     /* 2312503 */   GIR_EraseRootFromParent_Done,
     /* 2312504 */ // Label 31914: @2312504
     /* 2312504 */ GIM_Reject,
     /* 2312505 */ // Label 31865: @2312505
     /* 2312505 */ GIM_Try, /*On fail goto*//*Label 31915*/ GIMT_Encode4(2312559), // Rule ID 58182 //
     /* 2312510 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2312513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312524 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312524 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312527 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312531 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312536 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2312541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312543 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312546 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312558 */   // GIR_Coverage, 58182,
     /* 2312558 */   GIR_EraseRootFromParent_Done,
     /* 2312559 */ // Label 31915: @2312559
     /* 2312559 */ GIM_Try, /*On fail goto*//*Label 31916*/ GIMT_Encode4(2312613), // Rule ID 58183 //
     /* 2312564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2312567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2312570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312578 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312578 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312581 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312585 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312590 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2312595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312597 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312600 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312605 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2312608 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312611 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312612 */   // GIR_Coverage, 58183,
     /* 2312612 */   GIR_EraseRootFromParent_Done,
     /* 2312613 */ // Label 31916: @2312613
     /* 2312613 */ GIM_Try, /*On fail goto*//*Label 31917*/ GIMT_Encode4(2312667), // Rule ID 58414 //
     /* 2312618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2312621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312632 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312644 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2312649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312654 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312656 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312659 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312662 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312665 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312666 */   // GIR_Coverage, 58414,
     /* 2312666 */   GIR_EraseRootFromParent_Done,
     /* 2312667 */ // Label 31917: @2312667
     /* 2312667 */ GIM_Try, /*On fail goto*//*Label 31918*/ GIMT_Encode4(2312721), // Rule ID 58415 //
     /* 2312672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2312675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2312678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312686 */   // (fp_to_sint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2312689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2312703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312708 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312710 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312713 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2312716 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312719 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312720 */   // GIR_Coverage, 58415,
     /* 2312720 */   GIR_EraseRootFromParent_Done,
     /* 2312721 */ // Label 31918: @2312721
     /* 2312721 */ GIM_Reject,
     /* 2312722 */ // Label 31866: @2312722
     /* 2312722 */ GIM_Try, /*On fail goto*//*Label 31919*/ GIMT_Encode4(2312825),
     /* 2312727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2312730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312738 */   GIM_Try, /*On fail goto*//*Label 31920*/ GIMT_Encode4(2312781), // Rule ID 58582 //
     /* 2312743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2312746 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2312749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2312763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312780 */     // GIR_Coverage, 58582,
     /* 2312780 */     GIR_EraseRootFromParent_Done,
     /* 2312781 */   // Label 31920: @2312781
     /* 2312781 */   GIM_Try, /*On fail goto*//*Label 31921*/ GIMT_Encode4(2312824), // Rule ID 58583 //
     /* 2312786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2312789 */     // (fp_to_sint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2312792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF4),
     /* 2312806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2312823 */     // GIR_Coverage, 58583,
     /* 2312823 */     GIR_EraseRootFromParent_Done,
     /* 2312824 */   // Label 31921: @2312824
     /* 2312824 */   GIM_Reject,
     /* 2312825 */ // Label 31919: @2312825
     /* 2312825 */ GIM_Reject,
     /* 2312826 */ // Label 31867: @2312826
     /* 2312826 */ GIM_Try, /*On fail goto*//*Label 31922*/ GIMT_Encode4(2312880), // Rule ID 58166 //
     /* 2312831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2312834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2312837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312845 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2312848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312857 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2312862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312864 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312867 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312878 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312879 */   // GIR_Coverage, 58166,
     /* 2312879 */   GIR_EraseRootFromParent_Done,
     /* 2312880 */ // Label 31922: @2312880
     /* 2312880 */ GIM_Try, /*On fail goto*//*Label 31923*/ GIMT_Encode4(2312934), // Rule ID 58167 //
     /* 2312885 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2312888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2312891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312899 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2312899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2312902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312911 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_MF2),
     /* 2312916 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312918 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312921 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312932 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312933 */   // GIR_Coverage, 58167,
     /* 2312933 */   GIR_EraseRootFromParent_Done,
     /* 2312934 */ // Label 31923: @2312934
     /* 2312934 */ GIM_Try, /*On fail goto*//*Label 31924*/ GIMT_Encode4(2312988), // Rule ID 58606 //
     /* 2312939 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2312942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312945 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312949 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2312953 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2312953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2312956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2312960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2312965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2312967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2312970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2312972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2312975 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2312977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2312980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2312983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2312986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2312987 */   // GIR_Coverage, 58606,
     /* 2312987 */   GIR_EraseRootFromParent_Done,
     /* 2312988 */ // Label 31924: @2312988
     /* 2312988 */ GIM_Try, /*On fail goto*//*Label 31925*/ GIMT_Encode4(2313042), // Rule ID 58607 //
     /* 2312993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2312996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2312999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313007 */   // (fp_to_sint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313007 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2313010 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313014 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2313024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313029 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313037 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313040 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313041 */   // GIR_Coverage, 58607,
     /* 2313041 */   GIR_EraseRootFromParent_Done,
     /* 2313042 */ // Label 31925: @2313042
     /* 2313042 */ GIM_Reject,
     /* 2313043 */ // Label 31868: @2313043
     /* 2313043 */ GIM_Try, /*On fail goto*//*Label 31926*/ GIMT_Encode4(2313097), // Rule ID 58178 //
     /* 2313048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2313051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313062 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2313079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313081 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313084 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313095 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313096 */   // GIR_Coverage, 58178,
     /* 2313096 */   GIR_EraseRootFromParent_Done,
     /* 2313097 */ // Label 31926: @2313097
     /* 2313097 */ GIM_Try, /*On fail goto*//*Label 31927*/ GIMT_Encode4(2313151), // Rule ID 58179 //
     /* 2313102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2313105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313116 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313128 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2313133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313138 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313149 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313150 */   // GIR_Coverage, 58179,
     /* 2313150 */   GIR_EraseRootFromParent_Done,
     /* 2313151 */ // Label 31927: @2313151
     /* 2313151 */ GIM_Try, /*On fail goto*//*Label 31928*/ GIMT_Encode4(2313205), // Rule ID 58398 //
     /* 2313156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2313159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313170 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313170 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313173 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313177 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2313187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313192 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313203 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313204 */   // GIR_Coverage, 58398,
     /* 2313204 */   GIR_EraseRootFromParent_Done,
     /* 2313205 */ // Label 31928: @2313205
     /* 2313205 */ GIM_Try, /*On fail goto*//*Label 31929*/ GIMT_Encode4(2313259), // Rule ID 58399 //
     /* 2313210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2313213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2313216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313224 */   // (fp_to_sint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313224 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313227 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313231 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_MF2),
     /* 2313241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313243 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313246 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313257 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313258 */   // GIR_Coverage, 58399,
     /* 2313258 */   GIR_EraseRootFromParent_Done,
     /* 2313259 */ // Label 31929: @2313259
     /* 2313259 */ GIM_Try, /*On fail goto*//*Label 31930*/ GIMT_Encode4(2313313), // Rule ID 58626 //
     /* 2313264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2313267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313278 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313278 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313281 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313285 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2313295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313297 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313300 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313311 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313312 */   // GIR_Coverage, 58626,
     /* 2313312 */   GIR_EraseRootFromParent_Done,
     /* 2313313 */ // Label 31930: @2313313
     /* 2313313 */ GIM_Try, /*On fail goto*//*Label 31931*/ GIMT_Encode4(2313367), // Rule ID 58627 //
     /* 2313318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2313321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313332 */   // (fp_to_sint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313332 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2313335 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313339 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2313349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313354 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313359 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313362 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313365 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313366 */   // GIR_Coverage, 58627,
     /* 2313366 */   GIR_EraseRootFromParent_Done,
     /* 2313367 */ // Label 31931: @2313367
     /* 2313367 */ GIM_Reject,
     /* 2313368 */ // Label 31869: @2313368
     /* 2313368 */ GIM_Try, /*On fail goto*//*Label 31932*/ GIMT_Encode4(2313422), // Rule ID 58210 //
     /* 2313373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2313376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313387 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2313390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313399 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2313404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313409 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313420 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313421 */   // GIR_Coverage, 58210,
     /* 2313421 */   GIR_EraseRootFromParent_Done,
     /* 2313422 */ // Label 31932: @2313422
     /* 2313422 */ GIM_Try, /*On fail goto*//*Label 31933*/ GIMT_Encode4(2313476), // Rule ID 58211 //
     /* 2313427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2313430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2313433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313441 */   // (fp_to_sint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313441 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2313444 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313448 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2313458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313463 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313468 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2313471 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313474 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313475 */   // GIR_Coverage, 58211,
     /* 2313475 */   GIR_EraseRootFromParent_Done,
     /* 2313476 */ // Label 31933: @2313476
     /* 2313476 */ GIM_Try, /*On fail goto*//*Label 31934*/ GIMT_Encode4(2313530), // Rule ID 58418 //
     /* 2313481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2313484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313491 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313495 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313495 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2313498 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313502 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313507 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2313512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313517 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313522 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313528 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313529 */   // GIR_Coverage, 58418,
     /* 2313529 */   GIR_EraseRootFromParent_Done,
     /* 2313530 */ // Label 31934: @2313530
     /* 2313530 */ GIM_Try, /*On fail goto*//*Label 31935*/ GIMT_Encode4(2313584), // Rule ID 58419 //
     /* 2313535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2313538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2313541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313549 */   // (fp_to_sint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313549 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2313552 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313556 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2313566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313571 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313573 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313576 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313579 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313582 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313583 */   // GIR_Coverage, 58419,
     /* 2313583 */   GIR_EraseRootFromParent_Done,
     /* 2313584 */ // Label 31935: @2313584
     /* 2313584 */ GIM_Reject,
     /* 2313585 */ // Label 31870: @2313585
     /* 2313585 */ GIM_Try, /*On fail goto*//*Label 31936*/ GIMT_Encode4(2313688),
     /* 2313590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313601 */   GIM_Try, /*On fail goto*//*Label 31937*/ GIMT_Encode4(2313644), // Rule ID 58586 //
     /* 2313606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2313609 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2313612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313621 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2313626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313631 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313643 */     // GIR_Coverage, 58586,
     /* 2313643 */     GIR_EraseRootFromParent_Done,
     /* 2313644 */   // Label 31937: @2313644
     /* 2313644 */   GIM_Try, /*On fail goto*//*Label 31938*/ GIMT_Encode4(2313687), // Rule ID 58587 //
     /* 2313649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2313652 */     // (fp_to_sint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2313655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_MF2),
     /* 2313669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2313686 */     // GIR_Coverage, 58587,
     /* 2313686 */     GIR_EraseRootFromParent_Done,
     /* 2313687 */   // Label 31938: @2313687
     /* 2313687 */   GIM_Reject,
     /* 2313688 */ // Label 31936: @2313688
     /* 2313688 */ GIM_Reject,
     /* 2313689 */ // Label 31871: @2313689
     /* 2313689 */ GIM_Try, /*On fail goto*//*Label 31939*/ GIMT_Encode4(2313743), // Rule ID 58174 //
     /* 2313694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2313697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313708 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2313711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313720 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2313725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313730 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313738 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313741 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313742 */   // GIR_Coverage, 58174,
     /* 2313742 */   GIR_EraseRootFromParent_Done,
     /* 2313743 */ // Label 31939: @2313743
     /* 2313743 */ GIM_Try, /*On fail goto*//*Label 31940*/ GIMT_Encode4(2313797), // Rule ID 58175 //
     /* 2313748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2313751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2313754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313762 */   // (fp_to_sint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2313765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M1),
     /* 2313779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313784 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313795 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313796 */   // GIR_Coverage, 58175,
     /* 2313796 */   GIR_EraseRootFromParent_Done,
     /* 2313797 */ // Label 31940: @2313797
     /* 2313797 */ GIM_Try, /*On fail goto*//*Label 31941*/ GIMT_Encode4(2313851), // Rule ID 58610 //
     /* 2313802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2313805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313816 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2313819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2313833 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313835 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313838 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313850 */   // GIR_Coverage, 58610,
     /* 2313850 */   GIR_EraseRootFromParent_Done,
     /* 2313851 */ // Label 31941: @2313851
     /* 2313851 */ GIM_Try, /*On fail goto*//*Label 31942*/ GIMT_Encode4(2313905), // Rule ID 58611 //
     /* 2313856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2313859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2313866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313870 */   // (fp_to_sint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313870 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2313873 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313877 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313882 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313884 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2313887 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313889 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313892 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313897 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2313900 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313903 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313904 */   // GIR_Coverage, 58611,
     /* 2313904 */   GIR_EraseRootFromParent_Done,
     /* 2313905 */ // Label 31942: @2313905
     /* 2313905 */ GIM_Reject,
     /* 2313906 */ // Label 31872: @2313906
     /* 2313906 */ GIM_Try, /*On fail goto*//*Label 31943*/ GIMT_Encode4(2313960), // Rule ID 58198 //
     /* 2313911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2313914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313925 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2313925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2313928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313937 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2313942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313944 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2313947 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2313949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2313952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2313955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2313958 */   GIR_RootConstrainSelectedInstOperands,
     /* 2313959 */   // GIR_Coverage, 58198,
     /* 2313959 */   GIR_EraseRootFromParent_Done,
     /* 2313960 */ // Label 31943: @2313960
     /* 2313960 */ GIM_Try, /*On fail goto*//*Label 31944*/ GIMT_Encode4(2314014), // Rule ID 58199 //
     /* 2313965 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2313968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2313971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2313979 */   // (fp_to_sint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2313979 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2313982 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2313986 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2313991 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2313993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2313996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2313998 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314001 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314012 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314013 */   // GIR_Coverage, 58199,
     /* 2314013 */   GIR_EraseRootFromParent_Done,
     /* 2314014 */ // Label 31944: @2314014
     /* 2314014 */ GIM_Try, /*On fail goto*//*Label 31945*/ GIMT_Encode4(2314068), // Rule ID 58402 //
     /* 2314019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2314022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2314025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314033 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314033 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2314036 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314040 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314045 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2314050 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314052 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314055 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314067 */   // GIR_Coverage, 58402,
     /* 2314067 */   GIR_EraseRootFromParent_Done,
     /* 2314068 */ // Label 31945: @2314068
     /* 2314068 */ GIM_Try, /*On fail goto*//*Label 31946*/ GIMT_Encode4(2314122), // Rule ID 58403 //
     /* 2314073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2314076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2314079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314087 */   // (fp_to_sint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314087 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2314090 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314094 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314099 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314101 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M1),
     /* 2314104 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314106 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314109 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314121 */   // GIR_Coverage, 58403,
     /* 2314121 */   GIR_EraseRootFromParent_Done,
     /* 2314122 */ // Label 31946: @2314122
     /* 2314122 */ GIM_Try, /*On fail goto*//*Label 31947*/ GIMT_Encode4(2314176), // Rule ID 58630 //
     /* 2314127 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2314130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314137 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314141 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314141 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2314144 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314148 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2314158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314160 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314163 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314165 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314174 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314175 */   // GIR_Coverage, 58630,
     /* 2314175 */   GIR_EraseRootFromParent_Done,
     /* 2314176 */ // Label 31947: @2314176
     /* 2314176 */ GIM_Try, /*On fail goto*//*Label 31948*/ GIMT_Encode4(2314230), // Rule ID 58631 //
     /* 2314181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2314184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314195 */   // (fp_to_sint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2314198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314207 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2314212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314217 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314219 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314228 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314229 */   // GIR_Coverage, 58631,
     /* 2314229 */   GIR_EraseRootFromParent_Done,
     /* 2314230 */ // Label 31948: @2314230
     /* 2314230 */ GIM_Reject,
     /* 2314231 */ // Label 31873: @2314231
     /* 2314231 */ GIM_Try, /*On fail goto*//*Label 31949*/ GIMT_Encode4(2314285), // Rule ID 58214 //
     /* 2314236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2314239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314250 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314250 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2314253 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314257 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2314267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314272 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314283 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314284 */   // GIR_Coverage, 58214,
     /* 2314284 */   GIR_EraseRootFromParent_Done,
     /* 2314285 */ // Label 31949: @2314285
     /* 2314285 */ GIM_Try, /*On fail goto*//*Label 31950*/ GIMT_Encode4(2314339), // Rule ID 58215 //
     /* 2314290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2314293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2314296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314304 */   // (fp_to_sint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2314307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2314321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314326 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2314334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314337 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314338 */   // GIR_Coverage, 58215,
     /* 2314338 */   GIR_EraseRootFromParent_Done,
     /* 2314339 */ // Label 31950: @2314339
     /* 2314339 */ GIM_Try, /*On fail goto*//*Label 31951*/ GIMT_Encode4(2314393), // Rule ID 58422 //
     /* 2314344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2314347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314358 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314358 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2314361 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314365 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2314375 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314377 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314380 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314388 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314391 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314392 */   // GIR_Coverage, 58422,
     /* 2314392 */   GIR_EraseRootFromParent_Done,
     /* 2314393 */ // Label 31951: @2314393
     /* 2314393 */ GIM_Try, /*On fail goto*//*Label 31952*/ GIMT_Encode4(2314447), // Rule ID 58423 //
     /* 2314398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2314401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2314404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314412 */   // (fp_to_sint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2314415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2314429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314445 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314446 */   // GIR_Coverage, 58423,
     /* 2314446 */   GIR_EraseRootFromParent_Done,
     /* 2314447 */ // Label 31952: @2314447
     /* 2314447 */ GIM_Reject,
     /* 2314448 */ // Label 31874: @2314448
     /* 2314448 */ GIM_Try, /*On fail goto*//*Label 31953*/ GIMT_Encode4(2314551),
     /* 2314453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2314460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314464 */   GIM_Try, /*On fail goto*//*Label 31954*/ GIMT_Encode4(2314507), // Rule ID 58590 //
     /* 2314469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2314472 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2314475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2314489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314506 */     // GIR_Coverage, 58590,
     /* 2314506 */     GIR_EraseRootFromParent_Done,
     /* 2314507 */   // Label 31954: @2314507
     /* 2314507 */   GIM_Try, /*On fail goto*//*Label 31955*/ GIMT_Encode4(2314550), // Rule ID 58591 //
     /* 2314512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2314515 */     // (fp_to_sint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2314518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M1),
     /* 2314532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314537 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2314549 */     // GIR_Coverage, 58591,
     /* 2314549 */     GIR_EraseRootFromParent_Done,
     /* 2314550 */   // Label 31955: @2314550
     /* 2314550 */   GIM_Reject,
     /* 2314551 */ // Label 31953: @2314551
     /* 2314551 */ GIM_Reject,
     /* 2314552 */ // Label 31875: @2314552
     /* 2314552 */ GIM_Try, /*On fail goto*//*Label 31956*/ GIMT_Encode4(2314606), // Rule ID 58186 //
     /* 2314557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2314560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314567 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314571 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2314574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314583 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2314588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314593 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314605 */   // GIR_Coverage, 58186,
     /* 2314605 */   GIR_EraseRootFromParent_Done,
     /* 2314606 */ // Label 31956: @2314606
     /* 2314606 */ GIM_Try, /*On fail goto*//*Label 31957*/ GIMT_Encode4(2314660), // Rule ID 58187 //
     /* 2314611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2314614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314625 */   // (fp_to_sint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2314628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M2),
     /* 2314642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314658 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314659 */   // GIR_Coverage, 58187,
     /* 2314659 */   GIR_EraseRootFromParent_Done,
     /* 2314660 */ // Label 31957: @2314660
     /* 2314660 */ GIM_Try, /*On fail goto*//*Label 31958*/ GIMT_Encode4(2314714), // Rule ID 58614 //
     /* 2314665 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2314668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2314671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314679 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314679 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2314682 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314686 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2314696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314701 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314713 */   // GIR_Coverage, 58614,
     /* 2314713 */   GIR_EraseRootFromParent_Done,
     /* 2314714 */ // Label 31958: @2314714
     /* 2314714 */ GIM_Try, /*On fail goto*//*Label 31959*/ GIMT_Encode4(2314768), // Rule ID 58615 //
     /* 2314719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2314722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2314725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314733 */   // (fp_to_sint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2314736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2314750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314755 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314757 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314766 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314767 */   // GIR_Coverage, 58615,
     /* 2314767 */   GIR_EraseRootFromParent_Done,
     /* 2314768 */ // Label 31959: @2314768
     /* 2314768 */ GIM_Reject,
     /* 2314769 */ // Label 31876: @2314769
     /* 2314769 */ GIM_Try, /*On fail goto*//*Label 31960*/ GIMT_Encode4(2314823), // Rule ID 58202 //
     /* 2314774 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2314777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2314780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314788 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2314791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314800 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314802 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2314805 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314807 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314810 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314821 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314822 */   // GIR_Coverage, 58202,
     /* 2314822 */   GIR_EraseRootFromParent_Done,
     /* 2314823 */ // Label 31960: @2314823
     /* 2314823 */ GIM_Try, /*On fail goto*//*Label 31961*/ GIMT_Encode4(2314877), // Rule ID 58203 //
     /* 2314828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2314831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2314834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314842 */   // (fp_to_sint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2314845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314854 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2314859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314861 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314864 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2314872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314875 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314876 */   // GIR_Coverage, 58203,
     /* 2314876 */   GIR_EraseRootFromParent_Done,
     /* 2314877 */ // Label 31961: @2314877
     /* 2314877 */ GIM_Try, /*On fail goto*//*Label 31962*/ GIMT_Encode4(2314931), // Rule ID 58406 //
     /* 2314882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2314885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314896 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2314896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2314899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314908 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2314913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314915 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314918 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314930 */   // GIR_Coverage, 58406,
     /* 2314930 */   GIR_EraseRootFromParent_Done,
     /* 2314931 */ // Label 31962: @2314931
     /* 2314931 */ GIM_Try, /*On fail goto*//*Label 31963*/ GIMT_Encode4(2314985), // Rule ID 58407 //
     /* 2314936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2314939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2314942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2314946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2314950 */   // (fp_to_sint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2314950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2314953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2314957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2314962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2314964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M2),
     /* 2314967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2314969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2314972 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2314974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2314977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2314980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2314983 */   GIR_RootConstrainSelectedInstOperands,
     /* 2314984 */   // GIR_Coverage, 58407,
     /* 2314984 */   GIR_EraseRootFromParent_Done,
     /* 2314985 */ // Label 31963: @2314985
     /* 2314985 */ GIM_Try, /*On fail goto*//*Label 31964*/ GIMT_Encode4(2315039), // Rule ID 58634 //
     /* 2314990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2314993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2314996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315004 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2315007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315021 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315026 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315028 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315031 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315037 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315038 */   // GIR_Coverage, 58634,
     /* 2315038 */   GIR_EraseRootFromParent_Done,
     /* 2315039 */ // Label 31964: @2315039
     /* 2315039 */ GIM_Try, /*On fail goto*//*Label 31965*/ GIMT_Encode4(2315093), // Rule ID 58635 //
     /* 2315044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2315047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2315050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315058 */   // (fp_to_sint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315058 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2315061 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315065 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315080 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315085 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315088 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315091 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315092 */   // GIR_Coverage, 58635,
     /* 2315092 */   GIR_EraseRootFromParent_Done,
     /* 2315093 */ // Label 31965: @2315093
     /* 2315093 */ GIM_Reject,
     /* 2315094 */ // Label 31877: @2315094
     /* 2315094 */ GIM_Try, /*On fail goto*//*Label 31966*/ GIMT_Encode4(2315148), // Rule ID 58218 //
     /* 2315099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2315102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2315105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315113 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315113 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2315116 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315120 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2315130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315135 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315146 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315147 */   // GIR_Coverage, 58218,
     /* 2315147 */   GIR_EraseRootFromParent_Done,
     /* 2315148 */ // Label 31966: @2315148
     /* 2315148 */ GIM_Try, /*On fail goto*//*Label 31967*/ GIMT_Encode4(2315202), // Rule ID 58219 //
     /* 2315153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2315156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2315159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315167 */   // (fp_to_sint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2315170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2315184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315189 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2315197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315200 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315201 */   // GIR_Coverage, 58219,
     /* 2315201 */   GIR_EraseRootFromParent_Done,
     /* 2315202 */ // Label 31967: @2315202
     /* 2315202 */ GIM_Try, /*On fail goto*//*Label 31968*/ GIMT_Encode4(2315256), // Rule ID 58426 //
     /* 2315207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2315210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2315213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315217 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315221 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315221 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2315224 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315228 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2315238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315240 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315243 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315251 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315254 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315255 */   // GIR_Coverage, 58426,
     /* 2315255 */   GIR_EraseRootFromParent_Done,
     /* 2315256 */ // Label 31968: @2315256
     /* 2315256 */ GIM_Try, /*On fail goto*//*Label 31969*/ GIMT_Encode4(2315310), // Rule ID 58427 //
     /* 2315261 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2315264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2315267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315275 */   // (fp_to_sint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315275 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2315278 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315282 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2315292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315294 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315308 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315309 */   // GIR_Coverage, 58427,
     /* 2315309 */   GIR_EraseRootFromParent_Done,
     /* 2315310 */ // Label 31969: @2315310
     /* 2315310 */ GIM_Reject,
     /* 2315311 */ // Label 31878: @2315311
     /* 2315311 */ GIM_Try, /*On fail goto*//*Label 31970*/ GIMT_Encode4(2315414),
     /* 2315316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2315319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2315323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315327 */   GIM_Try, /*On fail goto*//*Label 31971*/ GIMT_Encode4(2315370), // Rule ID 58594 //
     /* 2315332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2315335 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2315338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2315352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315369 */     // GIR_Coverage, 58594,
     /* 2315369 */     GIR_EraseRootFromParent_Done,
     /* 2315370 */   // Label 31971: @2315370
     /* 2315370 */   GIM_Try, /*On fail goto*//*Label 31972*/ GIMT_Encode4(2315413), // Rule ID 58595 //
     /* 2315375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2315378 */     // (fp_to_sint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2315381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M2),
     /* 2315395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315412 */     // GIR_Coverage, 58595,
     /* 2315412 */     GIR_EraseRootFromParent_Done,
     /* 2315413 */   // Label 31972: @2315413
     /* 2315413 */   GIM_Reject,
     /* 2315414 */ // Label 31970: @2315414
     /* 2315414 */ GIM_Reject,
     /* 2315415 */ // Label 31879: @2315415
     /* 2315415 */ GIM_Try, /*On fail goto*//*Label 31973*/ GIMT_Encode4(2315469), // Rule ID 58190 //
     /* 2315420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2315423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2315426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315434 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315434 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315437 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315441 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315446 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2315451 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315453 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315456 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315464 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315467 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315468 */   // GIR_Coverage, 58190,
     /* 2315468 */   GIR_EraseRootFromParent_Done,
     /* 2315469 */ // Label 31973: @2315469
     /* 2315469 */ GIM_Try, /*On fail goto*//*Label 31974*/ GIMT_Encode4(2315523), // Rule ID 58191 //
     /* 2315474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2315477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2315480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315488 */   // (fp_to_sint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315488 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315491 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315495 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315500 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M4),
     /* 2315505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315510 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315515 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315521 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315522 */   // GIR_Coverage, 58191,
     /* 2315522 */   GIR_EraseRootFromParent_Done,
     /* 2315523 */ // Label 31974: @2315523
     /* 2315523 */ GIM_Try, /*On fail goto*//*Label 31975*/ GIMT_Encode4(2315577), // Rule ID 58618 //
     /* 2315528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2315531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2315534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315542 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315564 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315575 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315576 */   // GIR_Coverage, 58618,
     /* 2315576 */   GIR_EraseRootFromParent_Done,
     /* 2315577 */ // Label 31975: @2315577
     /* 2315577 */ GIM_Try, /*On fail goto*//*Label 31976*/ GIMT_Encode4(2315631), // Rule ID 58619 //
     /* 2315582 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2315585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2315588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315592 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315596 */   // (fp_to_sint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315596 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2315599 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315603 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315615 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315618 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315620 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315623 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315629 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315630 */   // GIR_Coverage, 58619,
     /* 2315630 */   GIR_EraseRootFromParent_Done,
     /* 2315631 */ // Label 31976: @2315631
     /* 2315631 */ GIM_Reject,
     /* 2315632 */ // Label 31880: @2315632
     /* 2315632 */ GIM_Try, /*On fail goto*//*Label 31977*/ GIMT_Encode4(2315686), // Rule ID 58206 //
     /* 2315637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2315640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2315643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315651 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2315654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315663 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2315668 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315670 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315673 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315681 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315684 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315685 */   // GIR_Coverage, 58206,
     /* 2315685 */   GIR_EraseRootFromParent_Done,
     /* 2315686 */ // Label 31977: @2315686
     /* 2315686 */ GIM_Try, /*On fail goto*//*Label 31978*/ GIMT_Encode4(2315740), // Rule ID 58207 //
     /* 2315691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2315694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2315697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315705 */   // (fp_to_sint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2315708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315717 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315719 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2315722 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315727 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2315735 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315738 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315739 */   // GIR_Coverage, 58207,
     /* 2315739 */   GIR_EraseRootFromParent_Done,
     /* 2315740 */ // Label 31978: @2315740
     /* 2315740 */ GIM_Try, /*On fail goto*//*Label 31979*/ GIMT_Encode4(2315794), // Rule ID 58410 //
     /* 2315745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2315748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2315751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315759 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2315762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315771 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2315776 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315781 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315789 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315792 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315793 */   // GIR_Coverage, 58410,
     /* 2315793 */   GIR_EraseRootFromParent_Done,
     /* 2315794 */ // Label 31979: @2315794
     /* 2315794 */ GIM_Try, /*On fail goto*//*Label 31980*/ GIMT_Encode4(2315848), // Rule ID 58411 //
     /* 2315799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2315802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2315805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315813 */   // (fp_to_sint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_X_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315813 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2315816 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315820 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315825 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_X_F_V_M4),
     /* 2315830 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315832 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315835 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315840 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2315843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315846 */   GIR_RootConstrainSelectedInstOperands,
     /* 2315847 */   // GIR_Coverage, 58411,
     /* 2315847 */   GIR_EraseRootFromParent_Done,
     /* 2315848 */ // Label 31980: @2315848
     /* 2315848 */ GIM_Reject,
     /* 2315849 */ // Label 31881: @2315849
     /* 2315849 */ GIM_Try, /*On fail goto*//*Label 31981*/ GIMT_Encode4(2315952),
     /* 2315854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2315857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2315861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315865 */   GIM_Try, /*On fail goto*//*Label 31982*/ GIMT_Encode4(2315908), // Rule ID 58598 //
     /* 2315870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2315873 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2315876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315892 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315895 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315897 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315907 */     // GIR_Coverage, 58598,
     /* 2315907 */     GIR_EraseRootFromParent_Done,
     /* 2315908 */   // Label 31982: @2315908
     /* 2315908 */   GIM_Try, /*On fail goto*//*Label 31983*/ GIMT_Encode4(2315951), // Rule ID 58599 //
     /* 2315913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2315916 */     // (fp_to_sint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_X_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2315916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2315919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_X_F_W_M4),
     /* 2315933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315938 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2315940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2315943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2315949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2315950 */     // GIR_Coverage, 58599,
     /* 2315950 */     GIR_EraseRootFromParent_Done,
     /* 2315951 */   // Label 31983: @2315951
     /* 2315951 */   GIM_Reject,
     /* 2315952 */ // Label 31981: @2315952
     /* 2315952 */ GIM_Reject,
     /* 2315953 */ // Label 31882: @2315953
     /* 2315953 */ GIM_Try, /*On fail goto*//*Label 31984*/ GIMT_Encode4(2316056),
     /* 2315958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2315961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2315969 */   GIM_Try, /*On fail goto*//*Label 31985*/ GIMT_Encode4(2316012), // Rule ID 58194 //
     /* 2315974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2315977 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2315977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2315980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2315984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2315989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2315991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2315994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2315996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2315999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316011 */     // GIR_Coverage, 58194,
     /* 2316011 */     GIR_EraseRootFromParent_Done,
     /* 2316012 */   // Label 31985: @2316012
     /* 2316012 */   GIM_Try, /*On fail goto*//*Label 31986*/ GIMT_Encode4(2316055), // Rule ID 58195 //
     /* 2316017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316020 */     // (fp_to_sint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_X_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2316023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_X_F_V_M8),
     /* 2316037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316054 */     // GIR_Coverage, 58195,
     /* 2316054 */     GIR_EraseRootFromParent_Done,
     /* 2316055 */   // Label 31986: @2316055
     /* 2316055 */   GIM_Reject,
     /* 2316056 */ // Label 31984: @2316056
     /* 2316056 */ GIM_Reject,
     /* 2316057 */ // Label 31883: @2316057
     /* 2316057 */ GIM_Reject,
     /* 2316058 */ // Label 68: @2316058
     /* 2316058 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(32), /*)*//*default:*//*Label 32010*/ GIMT_Encode4(2320943),
     /* 2316069 */ /*GILLT_s32*//*Label 31987*/ GIMT_Encode4(2316185),
     /* 2316073 */ /*GILLT_s64*//*Label 31988*/ GIMT_Encode4(2316558), GIMT_Encode4(0),
     /* 2316081 */ /*GILLT_nxv1s8*//*Label 31989*/ GIMT_Encode4(2316745),
     /* 2316085 */ /*GILLT_nxv1s16*//*Label 31990*/ GIMT_Encode4(2316849),
     /* 2316089 */ /*GILLT_nxv1s32*//*Label 31991*/ GIMT_Encode4(2317066),
     /* 2316093 */ /*GILLT_nxv1s64*//*Label 31992*/ GIMT_Encode4(2317391), GIMT_Encode4(0),
     /* 2316101 */ /*GILLT_nxv2s8*//*Label 31993*/ GIMT_Encode4(2317608),
     /* 2316105 */ /*GILLT_nxv2s16*//*Label 31994*/ GIMT_Encode4(2317712),
     /* 2316109 */ /*GILLT_nxv2s32*//*Label 31995*/ GIMT_Encode4(2317929),
     /* 2316113 */ /*GILLT_nxv2s64*//*Label 31996*/ GIMT_Encode4(2318254), GIMT_Encode4(0),
     /* 2316121 */ /*GILLT_nxv4s8*//*Label 31997*/ GIMT_Encode4(2318471),
     /* 2316125 */ /*GILLT_nxv4s16*//*Label 31998*/ GIMT_Encode4(2318575),
     /* 2316129 */ /*GILLT_nxv4s32*//*Label 31999*/ GIMT_Encode4(2318792),
     /* 2316133 */ /*GILLT_nxv4s64*//*Label 32000*/ GIMT_Encode4(2319117), GIMT_Encode4(0),
     /* 2316141 */ /*GILLT_nxv8s8*//*Label 32001*/ GIMT_Encode4(2319334),
     /* 2316145 */ /*GILLT_nxv8s16*//*Label 32002*/ GIMT_Encode4(2319438),
     /* 2316149 */ /*GILLT_nxv8s32*//*Label 32003*/ GIMT_Encode4(2319655),
     /* 2316153 */ /*GILLT_nxv8s64*//*Label 32004*/ GIMT_Encode4(2319980), GIMT_Encode4(0),
     /* 2316161 */ /*GILLT_nxv16s8*//*Label 32005*/ GIMT_Encode4(2320197),
     /* 2316165 */ /*GILLT_nxv16s16*//*Label 32006*/ GIMT_Encode4(2320301),
     /* 2316169 */ /*GILLT_nxv16s32*//*Label 32007*/ GIMT_Encode4(2320518), GIMT_Encode4(0),
     /* 2316177 */ /*GILLT_nxv32s8*//*Label 32008*/ GIMT_Encode4(2320735),
     /* 2316181 */ /*GILLT_nxv32s16*//*Label 32009*/ GIMT_Encode4(2320839),
     /* 2316185 */ // Label 31987: @2316185
     /* 2316185 */ GIM_Try, /*On fail goto*//*Label 32011*/ GIMT_Encode4(2316216), // Rule ID 1350 //
     /* 2316190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2316193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2316204 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2316207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316209 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316214 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316215 */   // GIR_Coverage, 1350,
     /* 2316215 */   GIR_EraseRootFromParent_Done,
     /* 2316216 */ // Label 32011: @2316216
     /* 2316216 */ GIM_Try, /*On fail goto*//*Label 32012*/ GIMT_Encode4(2316247), // Rule ID 1351 //
     /* 2316221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2316224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2316235 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2316235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2316238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316240 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316245 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316246 */   // GIR_Coverage, 1351,
     /* 2316246 */   GIR_EraseRootFromParent_Done,
     /* 2316247 */ // Label 32012: @2316247
     /* 2316247 */ GIM_Try, /*On fail goto*//*Label 32013*/ GIMT_Encode4(2316278), // Rule ID 1376 //
     /* 2316252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2316255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2316266 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2316269 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316271 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316273 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316276 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316277 */   // GIR_Coverage, 1376,
     /* 2316277 */   GIR_EraseRootFromParent_Done,
     /* 2316278 */ // Label 32013: @2316278
     /* 2316278 */ GIM_Try, /*On fail goto*//*Label 32014*/ GIMT_Encode4(2316309), // Rule ID 1377 //
     /* 2316283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2316286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2316297 */   // (fp_to_uint:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_WU_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 1:{ *:[i32] })
     /* 2316297 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2316300 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316302 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316308 */   // GIR_Coverage, 1377,
     /* 2316308 */   GIR_EraseRootFromParent_Done,
     /* 2316309 */ // Label 32014: @2316309
     /* 2316309 */ GIM_Try, /*On fail goto*//*Label 32015*/ GIMT_Encode4(2316340), // Rule ID 1744 //
     /* 2316314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2316317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2316328 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2316331 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316333 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316339 */   // GIR_Coverage, 1744,
     /* 2316339 */   GIR_EraseRootFromParent_Done,
     /* 2316340 */ // Label 32015: @2316340
     /* 2316340 */ GIM_Try, /*On fail goto*//*Label 32016*/ GIMT_Encode4(2316371), // Rule ID 1745 //
     /* 2316345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2316348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2316359 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D:{ *:[i32] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2316359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2316362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316364 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316370 */   // GIR_Coverage, 1745,
     /* 2316370 */   GIR_EraseRootFromParent_Done,
     /* 2316371 */ // Label 32016: @2316371
     /* 2316371 */ GIM_Try, /*On fail goto*//*Label 32017*/ GIMT_Encode4(2316402), // Rule ID 1770 //
     /* 2316376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2316379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2316390 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2316393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316395 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316397 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316400 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316401 */   // GIR_Coverage, 1770,
     /* 2316401 */   GIR_EraseRootFromParent_Done,
     /* 2316402 */ // Label 32017: @2316402
     /* 2316402 */ GIM_Try, /*On fail goto*//*Label 32018*/ GIMT_Encode4(2316433), // Rule ID 1771 //
     /* 2316407 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2316410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2316421 */   // (fp_to_uint:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_WU_D_IN32X:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1, 1:{ *:[i32] })
     /* 2316421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_IN32X),
     /* 2316424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316426 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316432 */   // GIR_Coverage, 1771,
     /* 2316432 */   GIR_EraseRootFromParent_Done,
     /* 2316433 */ // Label 32018: @2316433
     /* 2316433 */ GIM_Try, /*On fail goto*//*Label 32019*/ GIMT_Encode4(2316464), // Rule ID 2086 //
     /* 2316438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2316441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2316452 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2316455 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316462 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316463 */   // GIR_Coverage, 2086,
     /* 2316463 */   GIR_EraseRootFromParent_Done,
     /* 2316464 */ // Label 32019: @2316464
     /* 2316464 */ GIM_Try, /*On fail goto*//*Label 32020*/ GIMT_Encode4(2316495), // Rule ID 2087 //
     /* 2316469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2316472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2316483 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2316483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2316486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316488 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316490 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316493 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316494 */   // GIR_Coverage, 2087,
     /* 2316494 */   GIR_EraseRootFromParent_Done,
     /* 2316495 */ // Label 32020: @2316495
     /* 2316495 */ GIM_Try, /*On fail goto*//*Label 32021*/ GIMT_Encode4(2316526), // Rule ID 2112 //
     /* 2316500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2316503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2316514 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2316517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316519 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316521 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316524 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316525 */   // GIR_Coverage, 2112,
     /* 2316525 */   GIR_EraseRootFromParent_Done,
     /* 2316526 */ // Label 32021: @2316526
     /* 2316526 */ GIM_Try, /*On fail goto*//*Label 32022*/ GIMT_Encode4(2316557), // Rule ID 2113 //
     /* 2316531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2316534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2316545 */   // (fp_to_uint:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_WU_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 1:{ *:[i32] })
     /* 2316545 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2316548 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316550 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316555 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316556 */   // GIR_Coverage, 2113,
     /* 2316556 */   GIR_EraseRootFromParent_Done,
     /* 2316557 */ // Label 32022: @2316557
     /* 2316557 */ GIM_Reject,
     /* 2316558 */ // Label 31988: @2316558
     /* 2316558 */ GIM_Try, /*On fail goto*//*Label 32023*/ GIMT_Encode4(2316589), // Rule ID 1405 //
     /* 2316563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2316566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2316577 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S),
     /* 2316580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316582 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316588 */   // GIR_Coverage, 1405,
     /* 2316588 */   GIR_EraseRootFromParent_Done,
     /* 2316589 */ // Label 32023: @2316589
     /* 2316589 */ GIM_Try, /*On fail goto*//*Label 32024*/ GIMT_Encode4(2316620), // Rule ID 1433 //
     /* 2316594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2316597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2316600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2316608 */   // (fp_to_uint:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_LU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 1:{ *:[i64] })
     /* 2316608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_S_INX),
     /* 2316611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316619 */   // GIR_Coverage, 1433,
     /* 2316619 */   GIR_EraseRootFromParent_Done,
     /* 2316620 */ // Label 32024: @2316620
     /* 2316620 */ GIM_Try, /*On fail goto*//*Label 32025*/ GIMT_Encode4(2316651), // Rule ID 1805 //
     /* 2316625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2316628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2316639 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D),
     /* 2316642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316644 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316650 */   // GIR_Coverage, 1805,
     /* 2316650 */   GIR_EraseRootFromParent_Done,
     /* 2316651 */ // Label 32025: @2316651
     /* 2316651 */ GIM_Try, /*On fail goto*//*Label 32026*/ GIMT_Encode4(2316682), // Rule ID 1833 //
     /* 2316656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2316659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2316662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316670 */   // (fp_to_uint:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_LU_D_INX:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, 1:{ *:[i64] })
     /* 2316670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_D_INX),
     /* 2316673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316675 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316680 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316681 */   // GIR_Coverage, 1833,
     /* 2316681 */   GIR_EraseRootFromParent_Done,
     /* 2316682 */ // Label 32026: @2316682
     /* 2316682 */ GIM_Try, /*On fail goto*//*Label 32027*/ GIMT_Encode4(2316713), // Rule ID 2139 //
     /* 2316687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2316690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2316701 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H),
     /* 2316704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316706 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316711 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316712 */   // GIR_Coverage, 2139,
     /* 2316712 */   GIR_EraseRootFromParent_Done,
     /* 2316713 */ // Label 32027: @2316713
     /* 2316713 */ GIM_Try, /*On fail goto*//*Label 32028*/ GIMT_Encode4(2316744), // Rule ID 2165 //
     /* 2316718 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2316721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2316724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2316728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2316732 */   // (fp_to_uint:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_LU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 1:{ *:[i64] })
     /* 2316732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_LU_H_INX),
     /* 2316735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316737 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316739 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2316742 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316743 */   // GIR_Coverage, 2165,
     /* 2316743 */   GIR_EraseRootFromParent_Done,
     /* 2316744 */ // Label 32028: @2316744
     /* 2316744 */ GIM_Reject,
     /* 2316745 */ // Label 31989: @2316745
     /* 2316745 */ GIM_Try, /*On fail goto*//*Label 32029*/ GIMT_Encode4(2316848),
     /* 2316750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316761 */   GIM_Try, /*On fail goto*//*Label 32030*/ GIMT_Encode4(2316804), // Rule ID 58638 //
     /* 2316766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2316769 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2316772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2316786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316803 */     // GIR_Coverage, 58638,
     /* 2316803 */     GIR_EraseRootFromParent_Done,
     /* 2316804 */   // Label 32030: @2316804
     /* 2316804 */   GIM_Try, /*On fail goto*//*Label 32031*/ GIMT_Encode4(2316847), // Rule ID 58639 //
     /* 2316809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316812 */     // (fp_to_uint:{ *:[nxv1i8] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2316815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF8),
     /* 2316829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2316846 */     // GIR_Coverage, 58639,
     /* 2316846 */     GIR_EraseRootFromParent_Done,
     /* 2316847 */   // Label 32031: @2316847
     /* 2316847 */   GIM_Reject,
     /* 2316848 */ // Label 32029: @2316848
     /* 2316848 */ GIM_Reject,
     /* 2316849 */ // Label 31990: @2316849
     /* 2316849 */ GIM_Try, /*On fail goto*//*Label 32032*/ GIMT_Encode4(2316903), // Rule ID 58222 //
     /* 2316854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2316857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316868 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316868 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316871 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316875 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316880 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2316885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316890 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316901 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316902 */   // GIR_Coverage, 58222,
     /* 2316902 */   GIR_EraseRootFromParent_Done,
     /* 2316903 */ // Label 32032: @2316903
     /* 2316903 */ GIM_Try, /*On fail goto*//*Label 32033*/ GIMT_Encode4(2316957), // Rule ID 58223 //
     /* 2316908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2316911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2316914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316922 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2316922 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316925 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316929 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316934 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF4),
     /* 2316939 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316944 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2316946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2316949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2316952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2316955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2316956 */   // GIR_Coverage, 58223,
     /* 2316956 */   GIR_EraseRootFromParent_Done,
     /* 2316957 */ // Label 32033: @2316957
     /* 2316957 */ GIM_Try, /*On fail goto*//*Label 32034*/ GIMT_Encode4(2317011), // Rule ID 58662 //
     /* 2316962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2316965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2316968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2316976 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2316976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2316979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2316983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2316988 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2316990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2316993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2316995 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2316998 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317010 */   // GIR_Coverage, 58662,
     /* 2317010 */   GIR_EraseRootFromParent_Done,
     /* 2317011 */ // Label 32034: @2317011
     /* 2317011 */ GIM_Try, /*On fail goto*//*Label 32035*/ GIMT_Encode4(2317065), // Rule ID 58663 //
     /* 2317016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2317022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317030 */   // (fp_to_uint:{ *:[nxv1i16] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2317033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2317047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317052 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317063 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317064 */   // GIR_Coverage, 58663,
     /* 2317064 */   GIR_EraseRootFromParent_Done,
     /* 2317065 */ // Label 32035: @2317065
     /* 2317065 */ GIM_Reject,
     /* 2317066 */ // Label 31991: @2317066
     /* 2317066 */ GIM_Try, /*On fail goto*//*Label 32036*/ GIMT_Encode4(2317120), // Rule ID 58230 //
     /* 2317071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2317074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2317077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317085 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2317102 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317107 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317119 */   // GIR_Coverage, 58230,
     /* 2317119 */   GIR_EraseRootFromParent_Done,
     /* 2317120 */ // Label 32036: @2317120
     /* 2317120 */ GIM_Try, /*On fail goto*//*Label 32037*/ GIMT_Encode4(2317174), // Rule ID 58231 //
     /* 2317125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2317131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317139 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2317156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317173 */   // GIR_Coverage, 58231,
     /* 2317173 */   GIR_EraseRootFromParent_Done,
     /* 2317174 */ // Label 32037: @2317174
     /* 2317174 */ GIM_Try, /*On fail goto*//*Label 32038*/ GIMT_Encode4(2317228), // Rule ID 58430 //
     /* 2317179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2317185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317193 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2317210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317227 */   // GIR_Coverage, 58430,
     /* 2317227 */   GIR_EraseRootFromParent_Done,
     /* 2317228 */ // Label 32038: @2317228
     /* 2317228 */ GIM_Try, /*On fail goto*//*Label 32039*/ GIMT_Encode4(2317282), // Rule ID 58431 //
     /* 2317233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2317239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317247 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF4:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317247 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317250 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317254 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF4),
     /* 2317264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317266 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317269 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317277 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317280 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317281 */   // GIR_Coverage, 58431,
     /* 2317281 */   GIR_EraseRootFromParent_Done,
     /* 2317282 */ // Label 32039: @2317282
     /* 2317282 */ GIM_Try, /*On fail goto*//*Label 32040*/ GIMT_Encode4(2317336), // Rule ID 58682 //
     /* 2317287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2317290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2317293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317301 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317313 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317315 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2317318 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317320 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317323 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317331 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317334 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317335 */   // GIR_Coverage, 58682,
     /* 2317335 */   GIR_EraseRootFromParent_Done,
     /* 2317336 */ // Label 32040: @2317336
     /* 2317336 */ GIM_Try, /*On fail goto*//*Label 32041*/ GIMT_Encode4(2317390), // Rule ID 58683 //
     /* 2317341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2317344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2317347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317355 */   // (fp_to_uint:{ *:[nxv1i32] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2317358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317367 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2317372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317374 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317377 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317379 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317385 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317388 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317389 */   // GIR_Coverage, 58683,
     /* 2317389 */   GIR_EraseRootFromParent_Done,
     /* 2317390 */ // Label 32041: @2317390
     /* 2317390 */ GIM_Reject,
     /* 2317391 */ // Label 31992: @2317391
     /* 2317391 */ GIM_Try, /*On fail goto*//*Label 32042*/ GIMT_Encode4(2317445), // Rule ID 58242 //
     /* 2317396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2317399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2317402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317410 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2317413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2317427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317444 */   // GIR_Coverage, 58242,
     /* 2317444 */   GIR_EraseRootFromParent_Done,
     /* 2317445 */ // Label 32042: @2317445
     /* 2317445 */ GIM_Try, /*On fail goto*//*Label 32043*/ GIMT_Encode4(2317499), // Rule ID 58243 //
     /* 2317450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2317453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2317456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317464 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2317467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317476 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2317481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317486 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317488 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317491 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2317494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317497 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317498 */   // GIR_Coverage, 58243,
     /* 2317498 */   GIR_EraseRootFromParent_Done,
     /* 2317499 */ // Label 32043: @2317499
     /* 2317499 */ GIM_Try, /*On fail goto*//*Label 32044*/ GIMT_Encode4(2317553), // Rule ID 58450 //
     /* 2317504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2317507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2317510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317518 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317518 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2317521 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317525 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317530 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2317535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317540 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317542 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317548 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317551 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317552 */   // GIR_Coverage, 58450,
     /* 2317552 */   GIR_EraseRootFromParent_Done,
     /* 2317553 */ // Label 32044: @2317553
     /* 2317553 */ GIM_Try, /*On fail goto*//*Label 32045*/ GIMT_Encode4(2317607), // Rule ID 58451 //
     /* 2317558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2317561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2317564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317572 */   // (fp_to_uint:{ *:[nxv1i64] } VR:{ *:[nxv1f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317572 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2317575 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317579 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2317589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317594 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317596 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317599 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317605 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317606 */   // GIR_Coverage, 58451,
     /* 2317606 */   GIR_EraseRootFromParent_Done,
     /* 2317607 */ // Label 32045: @2317607
     /* 2317607 */ GIM_Reject,
     /* 2317608 */ // Label 31993: @2317608
     /* 2317608 */ GIM_Try, /*On fail goto*//*Label 32046*/ GIMT_Encode4(2317711),
     /* 2317613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317624 */   GIM_Try, /*On fail goto*//*Label 32047*/ GIMT_Encode4(2317667), // Rule ID 58642 //
     /* 2317629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317632 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2317635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317644 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2317649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317654 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317666 */     // GIR_Coverage, 58642,
     /* 2317666 */     GIR_EraseRootFromParent_Done,
     /* 2317667 */   // Label 32047: @2317667
     /* 2317667 */   GIM_Try, /*On fail goto*//*Label 32048*/ GIMT_Encode4(2317710), // Rule ID 58643 //
     /* 2317672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317675 */     // (fp_to_uint:{ *:[nxv2i8] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2317678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317687 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF4),
     /* 2317692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317708 */     GIR_RootConstrainSelectedInstOperands,
     /* 2317709 */     // GIR_Coverage, 58643,
     /* 2317709 */     GIR_EraseRootFromParent_Done,
     /* 2317710 */   // Label 32048: @2317710
     /* 2317710 */   GIM_Reject,
     /* 2317711 */ // Label 32046: @2317711
     /* 2317711 */ GIM_Reject,
     /* 2317712 */ // Label 31994: @2317712
     /* 2317712 */ GIM_Try, /*On fail goto*//*Label 32049*/ GIMT_Encode4(2317766), // Rule ID 58226 //
     /* 2317717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2317720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317731 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2317748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317750 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317753 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317765 */   // GIR_Coverage, 58226,
     /* 2317765 */   GIR_EraseRootFromParent_Done,
     /* 2317766 */ // Label 32049: @2317766
     /* 2317766 */ GIM_Try, /*On fail goto*//*Label 32050*/ GIMT_Encode4(2317820), // Rule ID 58227 //
     /* 2317771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2317774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2317777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317785 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_MF2),
     /* 2317802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317819 */   // GIR_Coverage, 58227,
     /* 2317819 */   GIR_EraseRootFromParent_Done,
     /* 2317820 */ // Label 32050: @2317820
     /* 2317820 */ GIM_Try, /*On fail goto*//*Label 32051*/ GIMT_Encode4(2317874), // Rule ID 58666 //
     /* 2317825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2317828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317839 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2317856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317873 */   // GIR_Coverage, 58666,
     /* 2317873 */   GIR_EraseRootFromParent_Done,
     /* 2317874 */ // Label 32051: @2317874
     /* 2317874 */ GIM_Try, /*On fail goto*//*Label 32052*/ GIMT_Encode4(2317928), // Rule ID 58667 //
     /* 2317879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317893 */   // (fp_to_uint:{ *:[nxv2i16] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2317893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2317896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2317910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2317923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317927 */   // GIR_Coverage, 58667,
     /* 2317927 */   GIR_EraseRootFromParent_Done,
     /* 2317928 */ // Label 32052: @2317928
     /* 2317928 */ GIM_Reject,
     /* 2317929 */ // Label 31995: @2317929
     /* 2317929 */ GIM_Try, /*On fail goto*//*Label 32053*/ GIMT_Encode4(2317983), // Rule ID 58238 //
     /* 2317934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2317937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317948 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2317948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2317951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2317955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2317960 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2317962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2317965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2317967 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2317970 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2317972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2317975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2317978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2317981 */   GIR_RootConstrainSelectedInstOperands,
     /* 2317982 */   // GIR_Coverage, 58238,
     /* 2317982 */   GIR_EraseRootFromParent_Done,
     /* 2317983 */ // Label 32053: @2317983
     /* 2317983 */ GIM_Try, /*On fail goto*//*Label 32054*/ GIMT_Encode4(2318037), // Rule ID 58239 //
     /* 2317988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2317991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2317994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2317998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318002 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318002 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2318005 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318009 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2318019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318021 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318024 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318035 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318036 */   // GIR_Coverage, 58239,
     /* 2318036 */   GIR_EraseRootFromParent_Done,
     /* 2318037 */ // Label 32054: @2318037
     /* 2318037 */ GIM_Try, /*On fail goto*//*Label 32055*/ GIMT_Encode4(2318091), // Rule ID 58434 //
     /* 2318042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2318048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318056 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2318059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2318073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318078 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318090 */   // GIR_Coverage, 58434,
     /* 2318090 */   GIR_EraseRootFromParent_Done,
     /* 2318091 */ // Label 32055: @2318091
     /* 2318091 */ GIM_Try, /*On fail goto*//*Label 32056*/ GIMT_Encode4(2318145), // Rule ID 58435 //
     /* 2318096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2318102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318110 */   // (fp_to_uint:{ *:[nxv2i32] } VR:{ *:[nxv2f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_MF2:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2318113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318122 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_MF2),
     /* 2318127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318129 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318132 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318140 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318143 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318144 */   // GIR_Coverage, 58435,
     /* 2318144 */   GIR_EraseRootFromParent_Done,
     /* 2318145 */ // Label 32056: @2318145
     /* 2318145 */ GIM_Try, /*On fail goto*//*Label 32057*/ GIMT_Encode4(2318199), // Rule ID 58686 //
     /* 2318150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2318153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318164 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2318167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318176 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318178 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2318181 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318183 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318186 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318197 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318198 */   // GIR_Coverage, 58686,
     /* 2318198 */   GIR_EraseRootFromParent_Done,
     /* 2318199 */ // Label 32057: @2318199
     /* 2318199 */ GIM_Try, /*On fail goto*//*Label 32058*/ GIMT_Encode4(2318253), // Rule ID 58687 //
     /* 2318204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2318207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318218 */   // (fp_to_uint:{ *:[nxv2i32] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2318221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2318235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318240 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318251 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318252 */   // GIR_Coverage, 58687,
     /* 2318252 */   GIR_EraseRootFromParent_Done,
     /* 2318253 */ // Label 32058: @2318253
     /* 2318253 */ GIM_Reject,
     /* 2318254 */ // Label 31996: @2318254
     /* 2318254 */ GIM_Try, /*On fail goto*//*Label 32059*/ GIMT_Encode4(2318308), // Rule ID 58270 //
     /* 2318259 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2318262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318273 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2318276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2318290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318295 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318297 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318306 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318307 */   // GIR_Coverage, 58270,
     /* 2318307 */   GIR_EraseRootFromParent_Done,
     /* 2318308 */ // Label 32059: @2318308
     /* 2318308 */ GIM_Try, /*On fail goto*//*Label 32060*/ GIMT_Encode4(2318362), // Rule ID 58271 //
     /* 2318313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2318316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2318319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318327 */   // (fp_to_uint:{ *:[nxv2i64] } VRM2:{ *:[nxv2f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2318330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2318344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318349 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318354 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2318357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318360 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318361 */   // GIR_Coverage, 58271,
     /* 2318361 */   GIR_EraseRootFromParent_Done,
     /* 2318362 */ // Label 32060: @2318362
     /* 2318362 */ GIM_Try, /*On fail goto*//*Label 32061*/ GIMT_Encode4(2318416), // Rule ID 58454 //
     /* 2318367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2318370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318381 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318381 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2318384 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318388 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2318398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318400 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318403 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318408 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318414 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318415 */   // GIR_Coverage, 58454,
     /* 2318415 */   GIR_EraseRootFromParent_Done,
     /* 2318416 */ // Label 32061: @2318416
     /* 2318416 */ GIM_Try, /*On fail goto*//*Label 32062*/ GIMT_Encode4(2318470), // Rule ID 58455 //
     /* 2318421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2318424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2318427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318435 */   // (fp_to_uint:{ *:[nxv2i64] } VR:{ *:[nxv2f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VR:{ *:[nxv2f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318435 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2318438 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318442 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2318452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318457 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318462 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318469 */   // GIR_Coverage, 58455,
     /* 2318469 */   GIR_EraseRootFromParent_Done,
     /* 2318470 */ // Label 32062: @2318470
     /* 2318470 */ GIM_Reject,
     /* 2318471 */ // Label 31997: @2318471
     /* 2318471 */ GIM_Try, /*On fail goto*//*Label 32063*/ GIMT_Encode4(2318574),
     /* 2318476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318487 */   GIM_Try, /*On fail goto*//*Label 32064*/ GIMT_Encode4(2318530), // Rule ID 58646 //
     /* 2318492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318495 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2318498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2318512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318529 */     // GIR_Coverage, 58646,
     /* 2318529 */     GIR_EraseRootFromParent_Done,
     /* 2318530 */   // Label 32064: @2318530
     /* 2318530 */   GIM_Try, /*On fail goto*//*Label 32065*/ GIMT_Encode4(2318573), // Rule ID 58647 //
     /* 2318535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318538 */     // (fp_to_uint:{ *:[nxv4i8] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2318541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_MF2),
     /* 2318555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318571 */     GIR_RootConstrainSelectedInstOperands,
     /* 2318572 */     // GIR_Coverage, 58647,
     /* 2318572 */     GIR_EraseRootFromParent_Done,
     /* 2318573 */   // Label 32065: @2318573
     /* 2318573 */   GIM_Reject,
     /* 2318574 */ // Label 32063: @2318574
     /* 2318574 */ GIM_Reject,
     /* 2318575 */ // Label 31998: @2318575
     /* 2318575 */ GIM_Try, /*On fail goto*//*Label 32066*/ GIMT_Encode4(2318629), // Rule ID 58234 //
     /* 2318580 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318583 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318590 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318594 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318606 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2318611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318616 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318624 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318627 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318628 */   // GIR_Coverage, 58234,
     /* 2318628 */   GIR_EraseRootFromParent_Done,
     /* 2318629 */ // Label 32066: @2318629
     /* 2318629 */ GIM_Try, /*On fail goto*//*Label 32067*/ GIMT_Encode4(2318683), // Rule ID 58235 //
     /* 2318634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318648 */   // (fp_to_uint:{ *:[nxv4i16] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M1),
     /* 2318665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318670 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318678 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318682 */   // GIR_Coverage, 58235,
     /* 2318682 */   GIR_EraseRootFromParent_Done,
     /* 2318683 */ // Label 32067: @2318683
     /* 2318683 */ GIM_Try, /*On fail goto*//*Label 32068*/ GIMT_Encode4(2318737), // Rule ID 58670 //
     /* 2318688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2318691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318702 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318702 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318705 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318709 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2318719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318724 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318732 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318735 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318736 */   // GIR_Coverage, 58670,
     /* 2318736 */   GIR_EraseRootFromParent_Done,
     /* 2318737 */ // Label 32068: @2318737
     /* 2318737 */ GIM_Try, /*On fail goto*//*Label 32069*/ GIMT_Encode4(2318791), // Rule ID 58671 //
     /* 2318742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2318745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318756 */   // (fp_to_uint:{ *:[nxv4i16] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318756 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2318759 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318763 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2318773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318775 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318778 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318783 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318786 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318789 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318790 */   // GIR_Coverage, 58671,
     /* 2318790 */   GIR_EraseRootFromParent_Done,
     /* 2318791 */ // Label 32069: @2318791
     /* 2318791 */ GIM_Reject,
     /* 2318792 */ // Label 31999: @2318792
     /* 2318792 */ GIM_Try, /*On fail goto*//*Label 32070*/ GIMT_Encode4(2318846), // Rule ID 58258 //
     /* 2318797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2318800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318811 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318811 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318814 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318818 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318823 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318825 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2318828 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318830 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318833 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318845 */   // GIR_Coverage, 58258,
     /* 2318845 */   GIR_EraseRootFromParent_Done,
     /* 2318846 */ // Label 32070: @2318846
     /* 2318846 */ GIM_Try, /*On fail goto*//*Label 32071*/ GIMT_Encode4(2318900), // Rule ID 58259 //
     /* 2318851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2318854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2318857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318865 */   // (fp_to_uint:{ *:[nxv4i32] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2318882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2318895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318899 */   // GIR_Coverage, 58259,
     /* 2318899 */   GIR_EraseRootFromParent_Done,
     /* 2318900 */ // Label 32071: @2318900
     /* 2318900 */ GIM_Try, /*On fail goto*//*Label 32072*/ GIMT_Encode4(2318954), // Rule ID 58438 //
     /* 2318905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2318908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318919 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2318919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2318936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2318946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2318949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2318952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2318953 */   // GIR_Coverage, 58438,
     /* 2318953 */   GIR_EraseRootFromParent_Done,
     /* 2318954 */ // Label 32072: @2318954
     /* 2318954 */ GIM_Try, /*On fail goto*//*Label 32073*/ GIMT_Encode4(2319008), // Rule ID 58439 //
     /* 2318959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2318962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2318965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2318969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2318973 */   // (fp_to_uint:{ *:[nxv4i32] } VR:{ *:[nxv4f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M1:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VR:{ *:[nxv4f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2318973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2318976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2318980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2318985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2318987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M1),
     /* 2318990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2318992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2318995 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2318997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319006 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319007 */   // GIR_Coverage, 58439,
     /* 2319007 */   GIR_EraseRootFromParent_Done,
     /* 2319008 */ // Label 32073: @2319008
     /* 2319008 */ GIM_Try, /*On fail goto*//*Label 32074*/ GIMT_Encode4(2319062), // Rule ID 58690 //
     /* 2319013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2319016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2319019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319027 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319027 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2319030 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319034 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319039 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2319044 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319049 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319051 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319060 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319061 */   // GIR_Coverage, 58690,
     /* 2319061 */   GIR_EraseRootFromParent_Done,
     /* 2319062 */ // Label 32074: @2319062
     /* 2319062 */ GIM_Try, /*On fail goto*//*Label 32075*/ GIMT_Encode4(2319116), // Rule ID 58691 //
     /* 2319067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2319070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2319073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319081 */   // (fp_to_uint:{ *:[nxv4i32] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2319084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319093 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2319098 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319100 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319103 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319105 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319108 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319111 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319114 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319115 */   // GIR_Coverage, 58691,
     /* 2319115 */   GIR_EraseRootFromParent_Done,
     /* 2319116 */ // Label 32075: @2319116
     /* 2319116 */ GIM_Reject,
     /* 2319117 */ // Label 32000: @2319117
     /* 2319117 */ GIM_Try, /*On fail goto*//*Label 32076*/ GIMT_Encode4(2319171), // Rule ID 58274 //
     /* 2319122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2319125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2319128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319136 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319136 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2319139 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319143 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2319153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319155 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319158 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319170 */   // GIR_Coverage, 58274,
     /* 2319170 */   GIR_EraseRootFromParent_Done,
     /* 2319171 */ // Label 32076: @2319171
     /* 2319171 */ GIM_Try, /*On fail goto*//*Label 32077*/ GIMT_Encode4(2319225), // Rule ID 58275 //
     /* 2319176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2319179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2319182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319190 */   // (fp_to_uint:{ *:[nxv4i64] } VRM4:{ *:[nxv4f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2319193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2319207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319212 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2319220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319223 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319224 */   // GIR_Coverage, 58275,
     /* 2319224 */   GIR_EraseRootFromParent_Done,
     /* 2319225 */ // Label 32077: @2319225
     /* 2319225 */ GIM_Try, /*On fail goto*//*Label 32078*/ GIMT_Encode4(2319279), // Rule ID 58458 //
     /* 2319230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2319233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319244 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319244 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2319247 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319251 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2319261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319263 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319274 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319277 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319278 */   // GIR_Coverage, 58458,
     /* 2319278 */   GIR_EraseRootFromParent_Done,
     /* 2319279 */ // Label 32078: @2319279
     /* 2319279 */ GIM_Try, /*On fail goto*//*Label 32079*/ GIMT_Encode4(2319333), // Rule ID 58459 //
     /* 2319284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2319287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2319290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319294 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319298 */   // (fp_to_uint:{ *:[nxv4i64] } VRM2:{ *:[nxv4f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM2:{ *:[nxv4f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2319301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319310 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2319315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319317 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319320 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319325 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319328 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319331 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319332 */   // GIR_Coverage, 58459,
     /* 2319332 */   GIR_EraseRootFromParent_Done,
     /* 2319333 */ // Label 32079: @2319333
     /* 2319333 */ GIM_Reject,
     /* 2319334 */ // Label 32001: @2319334
     /* 2319334 */ GIM_Try, /*On fail goto*//*Label 32080*/ GIMT_Encode4(2319437),
     /* 2319339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2319346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319350 */   GIM_Try, /*On fail goto*//*Label 32081*/ GIMT_Encode4(2319393), // Rule ID 58650 //
     /* 2319355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319358 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2319361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2319375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319380 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319392 */     // GIR_Coverage, 58650,
     /* 2319392 */     GIR_EraseRootFromParent_Done,
     /* 2319393 */   // Label 32081: @2319393
     /* 2319393 */   GIM_Try, /*On fail goto*//*Label 32082*/ GIMT_Encode4(2319436), // Rule ID 58651 //
     /* 2319398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319401 */     // (fp_to_uint:{ *:[nxv8i8] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2319404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M1),
     /* 2319418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2319435 */     // GIR_Coverage, 58651,
     /* 2319435 */     GIR_EraseRootFromParent_Done,
     /* 2319436 */   // Label 32082: @2319436
     /* 2319436 */   GIM_Reject,
     /* 2319437 */ // Label 32080: @2319437
     /* 2319437 */ GIM_Reject,
     /* 2319438 */ // Label 32002: @2319438
     /* 2319438 */ GIM_Try, /*On fail goto*//*Label 32083*/ GIMT_Encode4(2319492), // Rule ID 58246 //
     /* 2319443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319453 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319457 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319457 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319460 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319464 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2319474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319479 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319491 */   // GIR_Coverage, 58246,
     /* 2319491 */   GIR_EraseRootFromParent_Done,
     /* 2319492 */ // Label 32083: @2319492
     /* 2319492 */ GIM_Try, /*On fail goto*//*Label 32084*/ GIMT_Encode4(2319546), // Rule ID 58247 //
     /* 2319497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319511 */   // (fp_to_uint:{ *:[nxv8i16] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M2),
     /* 2319528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319545 */   // GIR_Coverage, 58247,
     /* 2319545 */   GIR_EraseRootFromParent_Done,
     /* 2319546 */ // Label 32084: @2319546
     /* 2319546 */ GIM_Try, /*On fail goto*//*Label 32085*/ GIMT_Encode4(2319600), // Rule ID 58674 //
     /* 2319551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2319554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319565 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2319582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319599 */   // GIR_Coverage, 58674,
     /* 2319599 */   GIR_EraseRootFromParent_Done,
     /* 2319600 */ // Label 32085: @2319600
     /* 2319600 */ GIM_Try, /*On fail goto*//*Label 32086*/ GIMT_Encode4(2319654), // Rule ID 58675 //
     /* 2319605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2319608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319619 */   // (fp_to_uint:{ *:[nxv8i16] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2319622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2319636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319652 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319653 */   // GIR_Coverage, 58675,
     /* 2319653 */   GIR_EraseRootFromParent_Done,
     /* 2319654 */ // Label 32086: @2319654
     /* 2319654 */ GIM_Reject,
     /* 2319655 */ // Label 32003: @2319655
     /* 2319655 */ GIM_Try, /*On fail goto*//*Label 32087*/ GIMT_Encode4(2319709), // Rule ID 58262 //
     /* 2319660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2319663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319674 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319674 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319677 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319681 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2319691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319696 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319708 */   // GIR_Coverage, 58262,
     /* 2319708 */   GIR_EraseRootFromParent_Done,
     /* 2319709 */ // Label 32087: @2319709
     /* 2319709 */ GIM_Try, /*On fail goto*//*Label 32088*/ GIMT_Encode4(2319763), // Rule ID 58263 //
     /* 2319714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2319717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2319720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319728 */   // (fp_to_uint:{ *:[nxv8i32] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2319745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319761 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319762 */   // GIR_Coverage, 58263,
     /* 2319762 */   GIR_EraseRootFromParent_Done,
     /* 2319763 */ // Label 32088: @2319763
     /* 2319763 */ GIM_Try, /*On fail goto*//*Label 32089*/ GIMT_Encode4(2319817), // Rule ID 58442 //
     /* 2319768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2319771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319782 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319782 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319785 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319789 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319794 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319796 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2319799 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319804 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319816 */   // GIR_Coverage, 58442,
     /* 2319816 */   GIR_EraseRootFromParent_Done,
     /* 2319817 */ // Label 32089: @2319817
     /* 2319817 */ GIM_Try, /*On fail goto*//*Label 32090*/ GIMT_Encode4(2319871), // Rule ID 58443 //
     /* 2319822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2319825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2319828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2319836 */   // (fp_to_uint:{ *:[nxv8i32] } VRM2:{ *:[nxv8f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M2:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM2:{ *:[nxv8f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M2),
     /* 2319853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319858 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319860 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2319866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319869 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319870 */   // GIR_Coverage, 58443,
     /* 2319870 */   GIR_EraseRootFromParent_Done,
     /* 2319871 */ // Label 32090: @2319871
     /* 2319871 */ GIM_Try, /*On fail goto*//*Label 32091*/ GIMT_Encode4(2319925), // Rule ID 58694 //
     /* 2319876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2319879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319890 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319890 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319893 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319897 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2319907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319912 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319923 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319924 */   // GIR_Coverage, 58694,
     /* 2319924 */   GIR_EraseRootFromParent_Done,
     /* 2319925 */ // Label 32091: @2319925
     /* 2319925 */ GIM_Try, /*On fail goto*//*Label 32092*/ GIMT_Encode4(2319979), // Rule ID 58695 //
     /* 2319930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2319933 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2319940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319944 */   // (fp_to_uint:{ *:[nxv8i32] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2319944 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2319947 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2319951 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2319956 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2319958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2319961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2319963 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2319966 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2319968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2319971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2319974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2319977 */   GIR_RootConstrainSelectedInstOperands,
     /* 2319978 */   // GIR_Coverage, 58695,
     /* 2319978 */   GIR_EraseRootFromParent_Done,
     /* 2319979 */ // Label 32092: @2319979
     /* 2319979 */ GIM_Reject,
     /* 2319980 */ // Label 32004: @2319980
     /* 2319980 */ GIM_Try, /*On fail goto*//*Label 32093*/ GIMT_Encode4(2320034), // Rule ID 58278 //
     /* 2319985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2319988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2319991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2319999 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2319999 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2320002 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320006 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320011 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320021 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320033 */   // GIR_Coverage, 58278,
     /* 2320033 */   GIR_EraseRootFromParent_Done,
     /* 2320034 */ // Label 32093: @2320034
     /* 2320034 */ GIM_Try, /*On fail goto*//*Label 32094*/ GIMT_Encode4(2320088), // Rule ID 58279 //
     /* 2320039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2320042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2320045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320053 */   // (fp_to_uint:{ *:[nxv8i64] } VRM8:{ *:[nxv8f64] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8f64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2320056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2320083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320086 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320087 */   // GIR_Coverage, 58279,
     /* 2320087 */   GIR_EraseRootFromParent_Done,
     /* 2320088 */ // Label 32094: @2320088
     /* 2320088 */ GIM_Try, /*On fail goto*//*Label 32095*/ GIMT_Encode4(2320142), // Rule ID 58462 //
     /* 2320093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2320096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2320099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320107 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320107 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2320110 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320114 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2320124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320129 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320134 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320141 */   // GIR_Coverage, 58462,
     /* 2320141 */   GIR_EraseRootFromParent_Done,
     /* 2320142 */ // Label 32095: @2320142
     /* 2320142 */ GIM_Try, /*On fail goto*//*Label 32096*/ GIMT_Encode4(2320196), // Rule ID 58463 //
     /* 2320147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2320150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2320153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320161 */   // (fp_to_uint:{ *:[nxv8i64] } VRM4:{ *:[nxv8f32] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM4:{ *:[nxv8f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2320164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320173 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320175 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2320178 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320180 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320183 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320185 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320188 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320191 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320194 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320195 */   // GIR_Coverage, 58463,
     /* 2320195 */   GIR_EraseRootFromParent_Done,
     /* 2320196 */ // Label 32096: @2320196
     /* 2320196 */ GIM_Reject,
     /* 2320197 */ // Label 32005: @2320197
     /* 2320197 */ GIM_Try, /*On fail goto*//*Label 32097*/ GIMT_Encode4(2320300),
     /* 2320202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2320209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320213 */   GIM_Try, /*On fail goto*//*Label 32098*/ GIMT_Encode4(2320256), // Rule ID 58654 //
     /* 2320218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320221 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2320224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2320238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320255 */     // GIR_Coverage, 58654,
     /* 2320255 */     GIR_EraseRootFromParent_Done,
     /* 2320256 */   // Label 32098: @2320256
     /* 2320256 */   GIM_Try, /*On fail goto*//*Label 32099*/ GIMT_Encode4(2320299), // Rule ID 58655 //
     /* 2320261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320264 */     // (fp_to_uint:{ *:[nxv16i8] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2320267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320276 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M2),
     /* 2320281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320286 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320298 */     // GIR_Coverage, 58655,
     /* 2320298 */     GIR_EraseRootFromParent_Done,
     /* 2320299 */   // Label 32099: @2320299
     /* 2320299 */   GIM_Reject,
     /* 2320300 */ // Label 32097: @2320300
     /* 2320300 */ GIM_Reject,
     /* 2320301 */ // Label 32006: @2320301
     /* 2320301 */ GIM_Try, /*On fail goto*//*Label 32100*/ GIMT_Encode4(2320355), // Rule ID 58250 //
     /* 2320306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320320 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320320 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2320323 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320327 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320332 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320334 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2320337 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320339 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320342 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320347 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320353 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320354 */   // GIR_Coverage, 58250,
     /* 2320354 */   GIR_EraseRootFromParent_Done,
     /* 2320355 */ // Label 32100: @2320355
     /* 2320355 */ GIM_Try, /*On fail goto*//*Label 32101*/ GIMT_Encode4(2320409), // Rule ID 58251 //
     /* 2320360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320374 */   // (fp_to_uint:{ *:[nxv16i16] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320374 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2320377 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320381 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M4),
     /* 2320391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320393 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320396 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320407 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320408 */   // GIR_Coverage, 58251,
     /* 2320408 */   GIR_EraseRootFromParent_Done,
     /* 2320409 */ // Label 32101: @2320409
     /* 2320409 */ GIM_Try, /*On fail goto*//*Label 32102*/ GIMT_Encode4(2320463), // Rule ID 58678 //
     /* 2320414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2320417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2320420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320428 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320428 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2320431 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320435 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320440 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2320445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320447 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320450 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320458 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320461 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320462 */   // GIR_Coverage, 58678,
     /* 2320462 */   GIR_EraseRootFromParent_Done,
     /* 2320463 */ // Label 32102: @2320463
     /* 2320463 */ GIM_Try, /*On fail goto*//*Label 32103*/ GIMT_Encode4(2320517), // Rule ID 58679 //
     /* 2320468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2320471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2320474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320482 */   // (fp_to_uint:{ *:[nxv16i16] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2320485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320494 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320496 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2320499 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320501 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320504 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320515 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320516 */   // GIR_Coverage, 58679,
     /* 2320516 */   GIR_EraseRootFromParent_Done,
     /* 2320517 */ // Label 32103: @2320517
     /* 2320517 */ GIM_Reject,
     /* 2320518 */ // Label 32007: @2320518
     /* 2320518 */ GIM_Try, /*On fail goto*//*Label 32104*/ GIMT_Encode4(2320572), // Rule ID 58266 //
     /* 2320523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2320526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2320529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320533 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320537 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320537 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320540 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320544 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320556 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320559 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320567 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320571 */   // GIR_Coverage, 58266,
     /* 2320571 */   GIR_EraseRootFromParent_Done,
     /* 2320572 */ // Label 32104: @2320572
     /* 2320572 */ GIM_Try, /*On fail goto*//*Label 32105*/ GIMT_Encode4(2320626), // Rule ID 58267 //
     /* 2320577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2320580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2320583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320591 */   // (fp_to_uint:{ *:[nxv16i32] } VRM8:{ *:[nxv16f32] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16f32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320613 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2320621 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320624 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320625 */   // GIR_Coverage, 58267,
     /* 2320625 */   GIR_EraseRootFromParent_Done,
     /* 2320626 */ // Label 32105: @2320626
     /* 2320626 */ GIM_Try, /*On fail goto*//*Label 32106*/ GIMT_Encode4(2320680), // Rule ID 58446 //
     /* 2320631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320645 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2320662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320664 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320678 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320679 */   // GIR_Coverage, 58446,
     /* 2320679 */   GIR_EraseRootFromParent_Done,
     /* 2320680 */ // Label 32106: @2320680
     /* 2320680 */ GIM_Try, /*On fail goto*//*Label 32107*/ GIMT_Encode4(2320734), // Rule ID 58447 //
     /* 2320685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2320691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320699 */   // (fp_to_uint:{ *:[nxv16i32] } VRM4:{ *:[nxv16f16] }:$rs1)  =>  (PseudoVFWCVT_RTZ_XU_F_V_M4:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM4:{ *:[nxv16f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320699 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2320702 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320706 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320711 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320713 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_RTZ_XU_F_V_M4),
     /* 2320716 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320718 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320721 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320732 */   GIR_RootConstrainSelectedInstOperands,
     /* 2320733 */   // GIR_Coverage, 58447,
     /* 2320733 */   GIR_EraseRootFromParent_Done,
     /* 2320734 */ // Label 32107: @2320734
     /* 2320734 */ GIM_Reject,
     /* 2320735 */ // Label 32008: @2320735
     /* 2320735 */ GIM_Try, /*On fail goto*//*Label 32108*/ GIMT_Encode4(2320838),
     /* 2320740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2320747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320751 */   GIM_Try, /*On fail goto*//*Label 32109*/ GIMT_Encode4(2320794), // Rule ID 58658 //
     /* 2320756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320759 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2320762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2320776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320793 */     // GIR_Coverage, 58658,
     /* 2320793 */     GIR_EraseRootFromParent_Done,
     /* 2320794 */   // Label 32109: @2320794
     /* 2320794 */   GIM_Try, /*On fail goto*//*Label 32110*/ GIMT_Encode4(2320837), // Rule ID 58659 //
     /* 2320799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320802 */     // (fp_to_uint:{ *:[nxv32i8] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFNCVT_RTZ_XU_F_W_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2320805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_RTZ_XU_F_W_M4),
     /* 2320819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320836 */     // GIR_Coverage, 58659,
     /* 2320836 */     GIR_EraseRootFromParent_Done,
     /* 2320837 */   // Label 32110: @2320837
     /* 2320837 */   GIM_Reject,
     /* 2320838 */ // Label 32108: @2320838
     /* 2320838 */ GIM_Reject,
     /* 2320839 */ // Label 32009: @2320839
     /* 2320839 */ GIM_Try, /*On fail goto*//*Label 32111*/ GIMT_Encode4(2320942),
     /* 2320844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2320847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2320855 */   GIM_Try, /*On fail goto*//*Label 32112*/ GIMT_Encode4(2320898), // Rule ID 58254 //
     /* 2320860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2320863 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2320863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2320866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320897 */     // GIR_Coverage, 58254,
     /* 2320897 */     GIR_EraseRootFromParent_Done,
     /* 2320898 */   // Label 32112: @2320898
     /* 2320898 */   GIM_Try, /*On fail goto*//*Label 32113*/ GIMT_Encode4(2320941), // Rule ID 58255 //
     /* 2320903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2320906 */     // (fp_to_uint:{ *:[nxv32i16] } VRM8:{ *:[nxv32f16] }:$rs1)  =>  (PseudoVFCVT_RTZ_XU_F_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32f16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2320906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2320909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2320913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2320918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2320920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_RTZ_XU_F_V_M8),
     /* 2320923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2320925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2320928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2320930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2320933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2320936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2320939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2320940 */     // GIR_Coverage, 58255,
     /* 2320940 */     GIR_EraseRootFromParent_Done,
     /* 2320941 */   // Label 32113: @2320941
     /* 2320941 */   GIM_Reject,
     /* 2320942 */ // Label 32111: @2320942
     /* 2320942 */ GIM_Reject,
     /* 2320943 */ // Label 32010: @2320943
     /* 2320943 */ GIM_Reject,
     /* 2320944 */ // Label 69: @2320944
     /* 2320944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32132*/ GIMT_Encode4(2326229),
     /* 2320955 */ /*GILLT_s16*//*Label 32114*/ GIMT_Encode4(2321075),
     /* 2320959 */ /*GILLT_s32*//*Label 32115*/ GIMT_Encode4(2321336),
     /* 2320963 */ /*GILLT_s64*//*Label 32116*/ GIMT_Encode4(2321597), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320975 */ /*GILLT_nxv1s16*//*Label 32117*/ GIMT_Encode4(2321858),
     /* 2320979 */ /*GILLT_nxv1s32*//*Label 32118*/ GIMT_Encode4(2322195),
     /* 2320983 */ /*GILLT_nxv1s64*//*Label 32119*/ GIMT_Encode4(2322532), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2320995 */ /*GILLT_nxv2s16*//*Label 32120*/ GIMT_Encode4(2322755),
     /* 2320999 */ /*GILLT_nxv2s32*//*Label 32121*/ GIMT_Encode4(2323092),
     /* 2321003 */ /*GILLT_nxv2s64*//*Label 32122*/ GIMT_Encode4(2323429), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2321015 */ /*GILLT_nxv4s16*//*Label 32123*/ GIMT_Encode4(2323652),
     /* 2321019 */ /*GILLT_nxv4s32*//*Label 32124*/ GIMT_Encode4(2323989),
     /* 2321023 */ /*GILLT_nxv4s64*//*Label 32125*/ GIMT_Encode4(2324326), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2321035 */ /*GILLT_nxv8s16*//*Label 32126*/ GIMT_Encode4(2324549),
     /* 2321039 */ /*GILLT_nxv8s32*//*Label 32127*/ GIMT_Encode4(2324886),
     /* 2321043 */ /*GILLT_nxv8s64*//*Label 32128*/ GIMT_Encode4(2325223), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2321055 */ /*GILLT_nxv16s16*//*Label 32129*/ GIMT_Encode4(2325446),
     /* 2321059 */ /*GILLT_nxv16s32*//*Label 32130*/ GIMT_Encode4(2325783), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2321071 */ /*GILLT_nxv32s16*//*Label 32131*/ GIMT_Encode4(2326006),
     /* 2321075 */ // Label 32114: @2321075
     /* 2321075 */ GIM_Try, /*On fail goto*//*Label 32133*/ GIMT_Encode4(2321112), // Rule ID 2151 //
     /* 2321080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2321083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2321090 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321097 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2321100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321111 */   // GIR_Coverage, 2151,
     /* 2321111 */   GIR_EraseRootFromParent_Done,
     /* 2321112 */ // Label 32133: @2321112
     /* 2321112 */ GIM_Try, /*On fail goto*//*Label 32134*/ GIMT_Encode4(2321149), // Rule ID 2177 //
     /* 2321117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2321120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2321127 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321134 */   // (sint_to_fp:{ *:[f16] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2321137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321148 */   // GIR_Coverage, 2177,
     /* 2321148 */   GIR_EraseRootFromParent_Done,
     /* 2321149 */ // Label 32134: @2321149
     /* 2321149 */ GIM_Try, /*On fail goto*//*Label 32135*/ GIMT_Encode4(2321180), // Rule ID 2100 //
     /* 2321154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2321157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2321164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321168 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2321168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2321171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321173 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321178 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321179 */   // GIR_Coverage, 2100,
     /* 2321179 */   GIR_EraseRootFromParent_Done,
     /* 2321180 */ // Label 32135: @2321180
     /* 2321180 */ GIM_Try, /*On fail goto*//*Label 32136*/ GIMT_Encode4(2321211), // Rule ID 2101 //
     /* 2321185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2321188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2321195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321199 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2321199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W),
     /* 2321202 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321204 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321210 */   // GIR_Coverage, 2101,
     /* 2321210 */   GIR_EraseRootFromParent_Done,
     /* 2321211 */ // Label 32136: @2321211
     /* 2321211 */ GIM_Try, /*On fail goto*//*Label 32137*/ GIMT_Encode4(2321242), // Rule ID 2126 //
     /* 2321216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2321219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2321226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321230 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2321230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2321233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321235 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321240 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321241 */   // GIR_Coverage, 2126,
     /* 2321241 */   GIR_EraseRootFromParent_Done,
     /* 2321242 */ // Label 32137: @2321242
     /* 2321242 */ GIM_Try, /*On fail goto*//*Label 32138*/ GIMT_Encode4(2321273), // Rule ID 2127 //
     /* 2321247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2321250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2321257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321261 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_W_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2321261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_W_INX),
     /* 2321264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321266 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321271 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321272 */   // GIR_Coverage, 2127,
     /* 2321272 */   GIR_EraseRootFromParent_Done,
     /* 2321273 */ // Label 32138: @2321273
     /* 2321273 */ GIM_Try, /*On fail goto*//*Label 32139*/ GIMT_Encode4(2321304), // Rule ID 2155 //
     /* 2321278 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2321281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2321288 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321292 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L),
     /* 2321295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321297 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321302 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321303 */   // GIR_Coverage, 2155,
     /* 2321303 */   GIR_EraseRootFromParent_Done,
     /* 2321304 */ // Label 32139: @2321304
     /* 2321304 */ GIM_Try, /*On fail goto*//*Label 32140*/ GIMT_Encode4(2321335), // Rule ID 2181 //
     /* 2321309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2321312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2321319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321323 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_L_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_L_INX),
     /* 2321326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321328 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321330 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321333 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321334 */   // GIR_Coverage, 2181,
     /* 2321334 */   GIR_EraseRootFromParent_Done,
     /* 2321335 */ // Label 32140: @2321335
     /* 2321335 */ GIM_Reject,
     /* 2321336 */ // Label 32115: @2321336
     /* 2321336 */ GIM_Try, /*On fail goto*//*Label 32141*/ GIMT_Encode4(2321373), // Rule ID 1417 //
     /* 2321341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2321344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2321351 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321358 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2321361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321371 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321372 */   // GIR_Coverage, 1417,
     /* 2321372 */   GIR_EraseRootFromParent_Done,
     /* 2321373 */ // Label 32141: @2321373
     /* 2321373 */ GIM_Try, /*On fail goto*//*Label 32142*/ GIMT_Encode4(2321410), // Rule ID 1445 //
     /* 2321378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2321381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2321388 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321395 */   // (sint_to_fp:{ *:[f32] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2321398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321405 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321408 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321409 */   // GIR_Coverage, 1445,
     /* 2321409 */   GIR_EraseRootFromParent_Done,
     /* 2321410 */ // Label 32142: @2321410
     /* 2321410 */ GIM_Try, /*On fail goto*//*Label 32143*/ GIMT_Encode4(2321441), // Rule ID 1364 //
     /* 2321415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2321418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2321425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321429 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2321429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2321432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321434 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321439 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321440 */   // GIR_Coverage, 1364,
     /* 2321440 */   GIR_EraseRootFromParent_Done,
     /* 2321441 */ // Label 32143: @2321441
     /* 2321441 */ GIM_Try, /*On fail goto*//*Label 32144*/ GIMT_Encode4(2321472), // Rule ID 1365 //
     /* 2321446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2321449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2321456 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321460 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2321460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W),
     /* 2321463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321465 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321467 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321470 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321471 */   // GIR_Coverage, 1365,
     /* 2321471 */   GIR_EraseRootFromParent_Done,
     /* 2321472 */ // Label 32144: @2321472
     /* 2321472 */ GIM_Try, /*On fail goto*//*Label 32145*/ GIMT_Encode4(2321503), // Rule ID 1390 //
     /* 2321477 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2321480 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2321487 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321491 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2321491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2321494 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321496 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321502 */   // GIR_Coverage, 1390,
     /* 2321502 */   GIR_EraseRootFromParent_Done,
     /* 2321503 */ // Label 32145: @2321503
     /* 2321503 */ GIM_Try, /*On fail goto*//*Label 32146*/ GIMT_Encode4(2321534), // Rule ID 1391 //
     /* 2321508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2321511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2321518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321522 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_W_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2321522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_W_INX),
     /* 2321525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321532 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321533 */   // GIR_Coverage, 1391,
     /* 2321533 */   GIR_EraseRootFromParent_Done,
     /* 2321534 */ // Label 32146: @2321534
     /* 2321534 */ GIM_Try, /*On fail goto*//*Label 32147*/ GIMT_Encode4(2321565), // Rule ID 1421 //
     /* 2321539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2321542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2321549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321553 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L),
     /* 2321556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321558 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321560 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321563 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321564 */   // GIR_Coverage, 1421,
     /* 2321564 */   GIR_EraseRootFromParent_Done,
     /* 2321565 */ // Label 32147: @2321565
     /* 2321565 */ GIM_Try, /*On fail goto*//*Label 32148*/ GIMT_Encode4(2321596), // Rule ID 1449 //
     /* 2321570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2321573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2321580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321584 */   // (sint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_L_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_L_INX),
     /* 2321587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321589 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321591 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321594 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321595 */   // GIR_Coverage, 1449,
     /* 2321595 */   GIR_EraseRootFromParent_Done,
     /* 2321596 */ // Label 32148: @2321596
     /* 2321596 */ GIM_Reject,
     /* 2321597 */ // Label 32116: @2321597
     /* 2321597 */ GIM_Try, /*On fail goto*//*Label 32149*/ GIMT_Encode4(2321634), // Rule ID 1797 //
     /* 2321602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2321605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2321612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321619 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2321619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2321622 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321629 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321632 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321633 */   // GIR_Coverage, 1797,
     /* 2321633 */   GIR_EraseRootFromParent_Done,
     /* 2321634 */ // Label 32149: @2321634
     /* 2321634 */ GIM_Try, /*On fail goto*//*Label 32150*/ GIMT_Encode4(2321671), // Rule ID 1825 //
     /* 2321639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2321642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_sexti32),
     /* 2321656 */   // (sint_to_fp:{ *:[f64] } (sexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_W_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2321656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_INX),
     /* 2321659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2321666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321669 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321670 */   // GIR_Coverage, 1825,
     /* 2321670 */   GIR_EraseRootFromParent_Done,
     /* 2321671 */ // Label 32150: @2321671
     /* 2321671 */ GIM_Try, /*On fail goto*//*Label 32151*/ GIMT_Encode4(2321702), // Rule ID 1758 //
     /* 2321676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2321679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2321686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321690 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2321690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2321693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321695 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321697 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321700 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321701 */   // GIR_Coverage, 1758,
     /* 2321701 */   GIR_EraseRootFromParent_Done,
     /* 2321702 */ // Label 32151: @2321702
     /* 2321702 */ GIM_Try, /*On fail goto*//*Label 32152*/ GIMT_Encode4(2321733), // Rule ID 1759 //
     /* 2321707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2321710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2321717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321721 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2321721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W),
     /* 2321724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321726 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321732 */   // GIR_Coverage, 1759,
     /* 2321732 */   GIR_EraseRootFromParent_Done,
     /* 2321733 */ // Label 32152: @2321733
     /* 2321733 */ GIM_Try, /*On fail goto*//*Label 32153*/ GIMT_Encode4(2321764), // Rule ID 1784 //
     /* 2321738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2321741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321752 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2321752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2321755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321757 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321762 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321763 */   // GIR_Coverage, 1784,
     /* 2321763 */   GIR_EraseRootFromParent_Done,
     /* 2321764 */ // Label 32153: @2321764
     /* 2321764 */ GIM_Try, /*On fail goto*//*Label 32154*/ GIMT_Encode4(2321795), // Rule ID 1785 //
     /* 2321769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2321772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2321775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2321779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321783 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_W_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2321783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_W_IN32X),
     /* 2321786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321788 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2321793 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321794 */   // GIR_Coverage, 1785,
     /* 2321794 */   GIR_EraseRootFromParent_Done,
     /* 2321795 */ // Label 32154: @2321795
     /* 2321795 */ GIM_Try, /*On fail goto*//*Label 32155*/ GIMT_Encode4(2321826), // Rule ID 1815 //
     /* 2321800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2321803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2321810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321814 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L),
     /* 2321817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321819 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321824 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321825 */   // GIR_Coverage, 1815,
     /* 2321825 */   GIR_EraseRootFromParent_Done,
     /* 2321826 */ // Label 32155: @2321826
     /* 2321826 */ GIM_Try, /*On fail goto*//*Label 32156*/ GIMT_Encode4(2321857), // Rule ID 1843 //
     /* 2321831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2321834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2321837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2321845 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_L_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2321845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_L_INX),
     /* 2321848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321850 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321855 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321856 */   // GIR_Coverage, 1843,
     /* 2321856 */   GIR_EraseRootFromParent_Done,
     /* 2321857 */ // Label 32156: @2321857
     /* 2321857 */ GIM_Reject,
     /* 2321858 */ // Label 32117: @2321858
     /* 2321858 */ GIM_Try, /*On fail goto*//*Label 32157*/ GIMT_Encode4(2321915), // Rule ID 45678 //
     /* 2321863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321877 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321889 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2321894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321896 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321899 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321901 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321904 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321907 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321913 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321914 */   // GIR_Coverage, 45678,
     /* 2321914 */   GIR_EraseRootFromParent_Done,
     /* 2321915 */ // Label 32157: @2321915
     /* 2321915 */ GIM_Try, /*On fail goto*//*Label 32158*/ GIMT_Encode4(2321972), // Rule ID 45679 //
     /* 2321920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2321923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2321926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321934 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2321934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2321946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2321948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF4_E16),
     /* 2321951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2321953 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2321956 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2321958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2321961 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2321964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2321967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2321970 */   GIR_RootConstrainSelectedInstOperands,
     /* 2321971 */   // GIR_Coverage, 45679,
     /* 2321971 */   GIR_EraseRootFromParent_Done,
     /* 2321972 */ // Label 32158: @2321972
     /* 2321972 */ GIM_Try, /*On fail goto*//*Label 32159*/ GIMT_Encode4(2322026), // Rule ID 45686 //
     /* 2321977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2321980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2321983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2321991 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2321991 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2321994 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2321998 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322003 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2322008 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322013 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322015 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322018 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322021 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322024 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322025 */   // GIR_Coverage, 45686,
     /* 2322025 */   GIR_EraseRootFromParent_Done,
     /* 2322026 */ // Label 32159: @2322026
     /* 2322026 */ GIM_Try, /*On fail goto*//*Label 32160*/ GIMT_Encode4(2322080), // Rule ID 45687 //
     /* 2322031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2322037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322045 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322045 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2322048 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322052 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF8_E8),
     /* 2322062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322067 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322072 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322078 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322079 */   // GIR_Coverage, 45687,
     /* 2322079 */   GIR_EraseRootFromParent_Done,
     /* 2322080 */ // Label 32160: @2322080
     /* 2322080 */ GIM_Try, /*On fail goto*//*Label 32161*/ GIMT_Encode4(2322137), // Rule ID 45694 //
     /* 2322085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322099 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322099 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2322102 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322106 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2322116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322118 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322121 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322123 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322126 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322132 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322136 */   // GIR_Coverage, 45694,
     /* 2322136 */   GIR_EraseRootFromParent_Done,
     /* 2322137 */ // Label 32161: @2322137
     /* 2322137 */ GIM_Try, /*On fail goto*//*Label 32162*/ GIMT_Encode4(2322194), // Rule ID 45695 //
     /* 2322142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322156 */   // (sint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322156 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2322159 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322163 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF4_E16),
     /* 2322173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322175 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322178 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322183 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322186 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322193 */   // GIR_Coverage, 45695,
     /* 2322193 */   GIR_EraseRootFromParent_Done,
     /* 2322194 */ // Label 32162: @2322194
     /* 2322194 */ GIM_Reject,
     /* 2322195 */ // Label 32118: @2322195
     /* 2322195 */ GIM_Try, /*On fail goto*//*Label 32163*/ GIMT_Encode4(2322252), // Rule ID 58286 //
     /* 2322200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2322203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322214 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322214 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322217 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322221 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2322231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322233 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322236 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322238 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322241 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322250 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322251 */   // GIR_Coverage, 58286,
     /* 2322251 */   GIR_EraseRootFromParent_Done,
     /* 2322252 */ // Label 32163: @2322252
     /* 2322252 */ GIM_Try, /*On fail goto*//*Label 32164*/ GIMT_Encode4(2322309), // Rule ID 58287 //
     /* 2322257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2322260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322271 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322271 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322274 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322278 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322283 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E32),
     /* 2322288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322290 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322293 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322298 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322307 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322308 */   // GIR_Coverage, 58287,
     /* 2322308 */   GIR_EraseRootFromParent_Done,
     /* 2322309 */ // Label 32164: @2322309
     /* 2322309 */ GIM_Try, /*On fail goto*//*Label 32165*/ GIMT_Encode4(2322363), // Rule ID 58486 //
     /* 2322314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2322317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2322320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322324 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322328 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322328 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322331 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322335 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2322345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322350 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322361 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322362 */   // GIR_Coverage, 58486,
     /* 2322362 */   GIR_EraseRootFromParent_Done,
     /* 2322363 */ // Label 32165: @2322363
     /* 2322363 */ GIM_Try, /*On fail goto*//*Label 32166*/ GIMT_Encode4(2322417), // Rule ID 58487 //
     /* 2322368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2322371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2322374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322382 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322382 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322385 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322389 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E16),
     /* 2322399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322401 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322404 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322415 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322416 */   // GIR_Coverage, 58487,
     /* 2322416 */   GIR_EraseRootFromParent_Done,
     /* 2322417 */ // Label 32166: @2322417
     /* 2322417 */ GIM_Try, /*On fail goto*//*Label 32167*/ GIMT_Encode4(2322474), // Rule ID 58714 //
     /* 2322422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2322425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2322428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322436 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2322453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322458 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322472 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322473 */   // GIR_Coverage, 58714,
     /* 2322473 */   GIR_EraseRootFromParent_Done,
     /* 2322474 */ // Label 32167: @2322474
     /* 2322474 */ GIM_Try, /*On fail goto*//*Label 32168*/ GIMT_Encode4(2322531), // Rule ID 58715 //
     /* 2322479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2322482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2322485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322493 */   // (sint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322493 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2322496 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322500 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E32),
     /* 2322510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322512 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322515 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322517 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322520 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322526 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322529 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322530 */   // GIR_Coverage, 58715,
     /* 2322530 */   GIR_EraseRootFromParent_Done,
     /* 2322531 */ // Label 32168: @2322531
     /* 2322531 */ GIM_Reject,
     /* 2322532 */ // Label 32119: @2322532
     /* 2322532 */ GIM_Try, /*On fail goto*//*Label 32169*/ GIMT_Encode4(2322589), // Rule ID 58298 //
     /* 2322537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2322540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2322543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322551 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2322554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2322568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322570 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322573 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322575 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322587 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322588 */   // GIR_Coverage, 58298,
     /* 2322588 */   GIR_EraseRootFromParent_Done,
     /* 2322589 */ // Label 32169: @2322589
     /* 2322589 */ GIM_Try, /*On fail goto*//*Label 32170*/ GIMT_Encode4(2322646), // Rule ID 58299 //
     /* 2322594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2322597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2322600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322608 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322608 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2322611 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322615 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322620 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E64),
     /* 2322625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322630 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322632 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322635 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2322641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322644 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322645 */   // GIR_Coverage, 58299,
     /* 2322645 */   GIR_EraseRootFromParent_Done,
     /* 2322646 */ // Label 32170: @2322646
     /* 2322646 */ GIM_Try, /*On fail goto*//*Label 32171*/ GIMT_Encode4(2322700), // Rule ID 58506 //
     /* 2322651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2322654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322665 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322665 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2322668 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322672 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322677 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2322682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322684 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322687 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322689 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322698 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322699 */   // GIR_Coverage, 58506,
     /* 2322699 */   GIR_EraseRootFromParent_Done,
     /* 2322700 */ // Label 32171: @2322700
     /* 2322700 */ GIM_Try, /*On fail goto*//*Label 32172*/ GIMT_Encode4(2322754), // Rule ID 58507 //
     /* 2322705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2322708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2322711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322719 */   // (sint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322719 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2322722 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322726 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E32),
     /* 2322736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322741 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322743 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2322749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322752 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322753 */   // GIR_Coverage, 58507,
     /* 2322753 */   GIR_EraseRootFromParent_Done,
     /* 2322754 */ // Label 32172: @2322754
     /* 2322754 */ GIM_Reject,
     /* 2322755 */ // Label 32120: @2322755
     /* 2322755 */ GIM_Try, /*On fail goto*//*Label 32173*/ GIMT_Encode4(2322812), // Rule ID 58282 //
     /* 2322760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322774 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322774 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322777 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322781 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2322791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322796 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322801 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322804 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322807 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322810 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322811 */   // GIR_Coverage, 58282,
     /* 2322811 */   GIR_EraseRootFromParent_Done,
     /* 2322812 */ // Label 32173: @2322812
     /* 2322812 */ GIM_Try, /*On fail goto*//*Label 32174*/ GIMT_Encode4(2322869), // Rule ID 58283 //
     /* 2322817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2322823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322831 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322831 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322834 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322838 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_MF2_E16),
     /* 2322848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322850 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2322858 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2322864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322867 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322868 */   // GIR_Coverage, 58283,
     /* 2322868 */   GIR_EraseRootFromParent_Done,
     /* 2322869 */ // Label 32174: @2322869
     /* 2322869 */ GIM_Try, /*On fail goto*//*Label 32175*/ GIMT_Encode4(2322923), // Rule ID 58466 //
     /* 2322874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2322880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322888 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322888 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322891 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322895 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2322905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322910 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322921 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322922 */   // GIR_Coverage, 58466,
     /* 2322922 */   GIR_EraseRootFromParent_Done,
     /* 2322923 */ // Label 32175: @2322923
     /* 2322923 */ GIM_Try, /*On fail goto*//*Label 32176*/ GIMT_Encode4(2322977), // Rule ID 58467 //
     /* 2322928 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2322931 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2322934 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322938 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322942 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2322942 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322945 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2322949 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2322954 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2322956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF4_E8),
     /* 2322959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2322961 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2322964 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2322966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2322969 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2322975 */   GIR_RootConstrainSelectedInstOperands,
     /* 2322976 */   // GIR_Coverage, 58467,
     /* 2322976 */   GIR_EraseRootFromParent_Done,
     /* 2322977 */ // Label 32176: @2322977
     /* 2322977 */ GIM_Try, /*On fail goto*//*Label 32177*/ GIMT_Encode4(2323034), // Rule ID 58698 //
     /* 2322982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2322985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2322988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2322996 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2322996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2322999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323008 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2323013 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323018 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323020 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323023 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323032 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323033 */   // GIR_Coverage, 58698,
     /* 2323033 */   GIR_EraseRootFromParent_Done,
     /* 2323034 */ // Label 32177: @2323034
     /* 2323034 */ GIM_Try, /*On fail goto*//*Label 32178*/ GIMT_Encode4(2323091), // Rule ID 58699 //
     /* 2323039 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323053 */   // (sint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2323056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_MF2_E16),
     /* 2323070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323075 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323080 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323086 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323090 */   // GIR_Coverage, 58699,
     /* 2323090 */   GIR_EraseRootFromParent_Done,
     /* 2323091 */ // Label 32178: @2323091
     /* 2323091 */ GIM_Reject,
     /* 2323092 */ // Label 32121: @2323092
     /* 2323092 */ GIM_Try, /*On fail goto*//*Label 32179*/ GIMT_Encode4(2323149), // Rule ID 58294 //
     /* 2323097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323111 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323111 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323114 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323118 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2323128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323147 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323148 */   // GIR_Coverage, 58294,
     /* 2323148 */   GIR_EraseRootFromParent_Done,
     /* 2323149 */ // Label 32179: @2323149
     /* 2323149 */ GIM_Try, /*On fail goto*//*Label 32180*/ GIMT_Encode4(2323206), // Rule ID 58295 //
     /* 2323154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2323157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323168 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323168 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323171 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323175 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323180 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E32),
     /* 2323185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323190 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323192 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323195 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323204 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323205 */   // GIR_Coverage, 58295,
     /* 2323205 */   GIR_EraseRootFromParent_Done,
     /* 2323206 */ // Label 32180: @2323206
     /* 2323206 */ GIM_Try, /*On fail goto*//*Label 32181*/ GIMT_Encode4(2323260), // Rule ID 58490 //
     /* 2323211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2323217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323225 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323225 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323228 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323232 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323237 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323239 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2323242 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323247 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323258 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323259 */   // GIR_Coverage, 58490,
     /* 2323259 */   GIR_EraseRootFromParent_Done,
     /* 2323260 */ // Label 32181: @2323260
     /* 2323260 */ GIM_Try, /*On fail goto*//*Label 32182*/ GIMT_Encode4(2323314), // Rule ID 58491 //
     /* 2323265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2323268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2323271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323279 */   // (sint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323291 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323293 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E16),
     /* 2323296 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323298 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323301 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323303 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323312 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323313 */   // GIR_Coverage, 58491,
     /* 2323313 */   GIR_EraseRootFromParent_Done,
     /* 2323314 */ // Label 32182: @2323314
     /* 2323314 */ GIM_Try, /*On fail goto*//*Label 32183*/ GIMT_Encode4(2323371), // Rule ID 58718 //
     /* 2323319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2323322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323333 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323333 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323336 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323340 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2323350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323355 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323357 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323360 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323369 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323370 */   // GIR_Coverage, 58718,
     /* 2323370 */   GIR_EraseRootFromParent_Done,
     /* 2323371 */ // Label 32183: @2323371
     /* 2323371 */ GIM_Try, /*On fail goto*//*Label 32184*/ GIMT_Encode4(2323428), // Rule ID 58719 //
     /* 2323376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2323379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323390 */   // (sint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323390 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2323393 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323397 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E32),
     /* 2323407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323409 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323412 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323417 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323420 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323423 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323426 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323427 */   // GIR_Coverage, 58719,
     /* 2323427 */   GIR_EraseRootFromParent_Done,
     /* 2323428 */ // Label 32184: @2323428
     /* 2323428 */ GIM_Reject,
     /* 2323429 */ // Label 32122: @2323429
     /* 2323429 */ GIM_Try, /*On fail goto*//*Label 32185*/ GIMT_Encode4(2323486), // Rule ID 58326 //
     /* 2323434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2323437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323448 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323448 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323451 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323455 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323460 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2323465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323467 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323470 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323484 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323485 */   // GIR_Coverage, 58326,
     /* 2323485 */   GIR_EraseRootFromParent_Done,
     /* 2323486 */ // Label 32185: @2323486
     /* 2323486 */ GIM_Try, /*On fail goto*//*Label 32186*/ GIMT_Encode4(2323543), // Rule ID 58327 //
     /* 2323491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2323494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2323497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323505 */   // (sint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323505 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323508 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323512 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E64),
     /* 2323522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323527 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2323538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323541 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323542 */   // GIR_Coverage, 58327,
     /* 2323542 */   GIR_EraseRootFromParent_Done,
     /* 2323543 */ // Label 32186: @2323543
     /* 2323543 */ GIM_Try, /*On fail goto*//*Label 32187*/ GIMT_Encode4(2323597), // Rule ID 58510 //
     /* 2323548 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2323551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323562 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2323579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323584 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323595 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323596 */   // GIR_Coverage, 58510,
     /* 2323596 */   GIR_EraseRootFromParent_Done,
     /* 2323597 */ // Label 32187: @2323597
     /* 2323597 */ GIM_Try, /*On fail goto*//*Label 32188*/ GIMT_Encode4(2323651), // Rule ID 58511 //
     /* 2323602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2323605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2323608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323616 */   // (sint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323616 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2323619 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323623 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E32),
     /* 2323633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323638 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2323646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323649 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323650 */   // GIR_Coverage, 58511,
     /* 2323650 */   GIR_EraseRootFromParent_Done,
     /* 2323651 */ // Label 32188: @2323651
     /* 2323651 */ GIM_Reject,
     /* 2323652 */ // Label 32123: @2323652
     /* 2323652 */ GIM_Try, /*On fail goto*//*Label 32189*/ GIMT_Encode4(2323709), // Rule ID 58290 //
     /* 2323657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323671 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2323688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323690 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323693 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323701 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323707 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323708 */   // GIR_Coverage, 58290,
     /* 2323708 */   GIR_EraseRootFromParent_Done,
     /* 2323709 */ // Label 32189: @2323709
     /* 2323709 */ GIM_Try, /*On fail goto*//*Label 32190*/ GIMT_Encode4(2323766), // Rule ID 58291 //
     /* 2323714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2323720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323728 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323728 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323731 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323735 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323740 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M1_E16),
     /* 2323745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323747 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323750 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323764 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323765 */   // GIR_Coverage, 58291,
     /* 2323765 */   GIR_EraseRootFromParent_Done,
     /* 2323766 */ // Label 32190: @2323766
     /* 2323766 */ GIM_Try, /*On fail goto*//*Label 32191*/ GIMT_Encode4(2323820), // Rule ID 58470 //
     /* 2323771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2323777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323785 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323785 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323788 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323792 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323797 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323799 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2323802 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323804 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323807 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323819 */   // GIR_Coverage, 58470,
     /* 2323819 */   GIR_EraseRootFromParent_Done,
     /* 2323820 */ // Label 32191: @2323820
     /* 2323820 */ GIM_Try, /*On fail goto*//*Label 32192*/ GIMT_Encode4(2323874), // Rule ID 58471 //
     /* 2323825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2323831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323839 */   // (sint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323839 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323842 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323846 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_MF2_E8),
     /* 2323856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323861 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323863 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323872 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323873 */   // GIR_Coverage, 58471,
     /* 2323873 */   GIR_EraseRootFromParent_Done,
     /* 2323874 */ // Label 32192: @2323874
     /* 2323874 */ GIM_Try, /*On fail goto*//*Label 32193*/ GIMT_Encode4(2323931), // Rule ID 58702 //
     /* 2323879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2323882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323889 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323893 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2323893 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323896 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323900 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323905 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323907 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2323910 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323912 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323920 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323923 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323929 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323930 */   // GIR_Coverage, 58702,
     /* 2323930 */   GIR_EraseRootFromParent_Done,
     /* 2323931 */ // Label 32193: @2323931
     /* 2323931 */ GIM_Try, /*On fail goto*//*Label 32194*/ GIMT_Encode4(2323988), // Rule ID 58703 //
     /* 2323936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2323939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2323942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2323946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2323950 */   // (sint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2323950 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2323953 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2323957 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2323962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2323964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M1_E16),
     /* 2323967 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2323969 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2323972 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2323974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2323977 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2323980 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2323983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2323986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2323987 */   // GIR_Coverage, 58703,
     /* 2323987 */   GIR_EraseRootFromParent_Done,
     /* 2323988 */ // Label 32194: @2323988
     /* 2323988 */ GIM_Reject,
     /* 2323989 */ // Label 32124: @2323989
     /* 2323989 */ GIM_Try, /*On fail goto*//*Label 32195*/ GIMT_Encode4(2324046), // Rule ID 58314 //
     /* 2323994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2323997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324008 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324008 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324011 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324015 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2324025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324030 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324044 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324045 */   // GIR_Coverage, 58314,
     /* 2324045 */   GIR_EraseRootFromParent_Done,
     /* 2324046 */ // Label 32195: @2324046
     /* 2324046 */ GIM_Try, /*On fail goto*//*Label 32196*/ GIMT_Encode4(2324103), // Rule ID 58315 //
     /* 2324051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324065 */   // (sint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324077 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E32),
     /* 2324082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324087 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324089 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324101 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324102 */   // GIR_Coverage, 58315,
     /* 2324102 */   GIR_EraseRootFromParent_Done,
     /* 2324103 */ // Label 32196: @2324103
     /* 2324103 */ GIM_Try, /*On fail goto*//*Label 32197*/ GIMT_Encode4(2324157), // Rule ID 58494 //
     /* 2324108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2324111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2324114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324122 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324134 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2324139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324141 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324144 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324146 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324156 */   // GIR_Coverage, 58494,
     /* 2324156 */   GIR_EraseRootFromParent_Done,
     /* 2324157 */ // Label 32197: @2324157
     /* 2324157 */ GIM_Try, /*On fail goto*//*Label 32198*/ GIMT_Encode4(2324211), // Rule ID 58495 //
     /* 2324162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2324168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324176 */   // (sint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E16),
     /* 2324193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324198 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324209 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324210 */   // GIR_Coverage, 58495,
     /* 2324210 */   GIR_EraseRootFromParent_Done,
     /* 2324211 */ // Label 32198: @2324211
     /* 2324211 */ GIM_Try, /*On fail goto*//*Label 32199*/ GIMT_Encode4(2324268), // Rule ID 58722 //
     /* 2324216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2324219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324230 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324230 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324233 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324237 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2324247 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324249 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324252 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324254 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324266 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324267 */   // GIR_Coverage, 58722,
     /* 2324267 */   GIR_EraseRootFromParent_Done,
     /* 2324268 */ // Label 32199: @2324268
     /* 2324268 */ GIM_Try, /*On fail goto*//*Label 32200*/ GIMT_Encode4(2324325), // Rule ID 58723 //
     /* 2324273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2324276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324287 */   // (sint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2324290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324299 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E32),
     /* 2324304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324306 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324309 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324311 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324314 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324320 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324323 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324324 */   // GIR_Coverage, 58723,
     /* 2324324 */   GIR_EraseRootFromParent_Done,
     /* 2324325 */ // Label 32200: @2324325
     /* 2324325 */ GIM_Reject,
     /* 2324326 */ // Label 32125: @2324326
     /* 2324326 */ GIM_Try, /*On fail goto*//*Label 32201*/ GIMT_Encode4(2324383), // Rule ID 58330 //
     /* 2324331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2324334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324345 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324357 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2324362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324364 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324367 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324381 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324382 */   // GIR_Coverage, 58330,
     /* 2324382 */   GIR_EraseRootFromParent_Done,
     /* 2324383 */ // Label 32201: @2324383
     /* 2324383 */ GIM_Try, /*On fail goto*//*Label 32202*/ GIMT_Encode4(2324440), // Rule ID 58331 //
     /* 2324388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2324391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2324394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324398 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324402 */   // (sint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324414 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E64),
     /* 2324419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324424 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2324435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324438 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324439 */   // GIR_Coverage, 58331,
     /* 2324439 */   GIR_EraseRootFromParent_Done,
     /* 2324440 */ // Label 32202: @2324440
     /* 2324440 */ GIM_Try, /*On fail goto*//*Label 32203*/ GIMT_Encode4(2324494), // Rule ID 58514 //
     /* 2324445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2324448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324459 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2324476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324478 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324481 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324483 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324492 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324493 */   // GIR_Coverage, 58514,
     /* 2324493 */   GIR_EraseRootFromParent_Done,
     /* 2324494 */ // Label 32203: @2324494
     /* 2324494 */ GIM_Try, /*On fail goto*//*Label 32204*/ GIMT_Encode4(2324548), // Rule ID 58515 //
     /* 2324499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2324502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2324505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324513 */   // (sint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2324516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324525 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E32),
     /* 2324530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324535 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324546 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324547 */   // GIR_Coverage, 58515,
     /* 2324547 */   GIR_EraseRootFromParent_Done,
     /* 2324548 */ // Label 32204: @2324548
     /* 2324548 */ GIM_Reject,
     /* 2324549 */ // Label 32126: @2324549
     /* 2324549 */ GIM_Try, /*On fail goto*//*Label 32205*/ GIMT_Encode4(2324606), // Rule ID 58302 //
     /* 2324554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324568 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2324585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324590 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324598 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324601 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324604 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324605 */   // GIR_Coverage, 58302,
     /* 2324605 */   GIR_EraseRootFromParent_Done,
     /* 2324606 */ // Label 32205: @2324606
     /* 2324606 */ GIM_Try, /*On fail goto*//*Label 32206*/ GIMT_Encode4(2324663), // Rule ID 58303 //
     /* 2324611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2324617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324625 */   // (sint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324625 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324628 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324632 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324637 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324639 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M2_E16),
     /* 2324642 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324647 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324661 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324662 */   // GIR_Coverage, 58303,
     /* 2324662 */   GIR_EraseRootFromParent_Done,
     /* 2324663 */ // Label 32206: @2324663
     /* 2324663 */ GIM_Try, /*On fail goto*//*Label 32207*/ GIMT_Encode4(2324717), // Rule ID 58474 //
     /* 2324668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2324674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324678 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324682 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324694 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2324699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324704 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324715 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324716 */   // GIR_Coverage, 58474,
     /* 2324716 */   GIR_EraseRootFromParent_Done,
     /* 2324717 */ // Label 32207: @2324717
     /* 2324717 */ GIM_Try, /*On fail goto*//*Label 32208*/ GIMT_Encode4(2324771), // Rule ID 58475 //
     /* 2324722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2324728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2324736 */   // (sint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324736 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324739 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324743 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M1_E8),
     /* 2324753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324758 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324769 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324770 */   // GIR_Coverage, 58475,
     /* 2324770 */   GIR_EraseRootFromParent_Done,
     /* 2324771 */ // Label 32208: @2324771
     /* 2324771 */ GIM_Try, /*On fail goto*//*Label 32209*/ GIMT_Encode4(2324828), // Rule ID 58706 //
     /* 2324776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2324779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324790 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2324807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324812 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324814 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324817 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324826 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324827 */   // GIR_Coverage, 58706,
     /* 2324827 */   GIR_EraseRootFromParent_Done,
     /* 2324828 */ // Label 32209: @2324828
     /* 2324828 */ GIM_Try, /*On fail goto*//*Label 32210*/ GIMT_Encode4(2324885), // Rule ID 58707 //
     /* 2324833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2324836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2324843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324847 */   // (sint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324847 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2324850 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324854 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M2_E16),
     /* 2324864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324869 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324874 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2324880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324883 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324884 */   // GIR_Coverage, 58707,
     /* 2324884 */   GIR_EraseRootFromParent_Done,
     /* 2324885 */ // Label 32210: @2324885
     /* 2324885 */ GIM_Reject,
     /* 2324886 */ // Label 32127: @2324886
     /* 2324886 */ GIM_Try, /*On fail goto*//*Label 32211*/ GIMT_Encode4(2324943), // Rule ID 58318 //
     /* 2324891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2324894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324901 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324905 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2324905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2324922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324924 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324927 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324941 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324942 */   // GIR_Coverage, 58318,
     /* 2324942 */   GIR_EraseRootFromParent_Done,
     /* 2324943 */ // Label 32211: @2324943
     /* 2324943 */ GIM_Try, /*On fail goto*//*Label 32212*/ GIMT_Encode4(2325000), // Rule ID 58319 //
     /* 2324948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2324951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2324954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2324962 */   // (sint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2324962 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2324965 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2324969 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2324974 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2324976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E32),
     /* 2324979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2324981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2324984 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2324986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2324989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2324992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2324995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2324998 */   GIR_RootConstrainSelectedInstOperands,
     /* 2324999 */   // GIR_Coverage, 58319,
     /* 2324999 */   GIR_EraseRootFromParent_Done,
     /* 2325000 */ // Label 32212: @2325000
     /* 2325000 */ GIM_Try, /*On fail goto*//*Label 32213*/ GIMT_Encode4(2325054), // Rule ID 58498 //
     /* 2325005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2325008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2325011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325019 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2325022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325031 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2325036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325041 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325052 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325053 */   // GIR_Coverage, 58498,
     /* 2325053 */   GIR_EraseRootFromParent_Done,
     /* 2325054 */ // Label 32213: @2325054
     /* 2325054 */ GIM_Try, /*On fail goto*//*Label 32214*/ GIMT_Encode4(2325108), // Rule ID 58499 //
     /* 2325059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2325062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2325065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325073 */   // (sint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325073 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2325076 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325080 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325085 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E16),
     /* 2325090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325095 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325097 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325106 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325107 */   // GIR_Coverage, 58499,
     /* 2325107 */   GIR_EraseRootFromParent_Done,
     /* 2325108 */ // Label 32214: @2325108
     /* 2325108 */ GIM_Try, /*On fail goto*//*Label 32215*/ GIMT_Encode4(2325165), // Rule ID 58726 //
     /* 2325113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2325116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2325119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325127 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2325130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2325144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325149 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325151 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325154 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325164 */   // GIR_Coverage, 58726,
     /* 2325164 */   GIR_EraseRootFromParent_Done,
     /* 2325165 */ // Label 32215: @2325165
     /* 2325165 */ GIM_Try, /*On fail goto*//*Label 32216*/ GIMT_Encode4(2325222), // Rule ID 58727 //
     /* 2325170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2325173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2325176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325184 */   // (sint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2325187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E32),
     /* 2325201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325206 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325208 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325214 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325220 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325221 */   // GIR_Coverage, 58727,
     /* 2325221 */   GIR_EraseRootFromParent_Done,
     /* 2325222 */ // Label 32216: @2325222
     /* 2325222 */ GIM_Reject,
     /* 2325223 */ // Label 32128: @2325223
     /* 2325223 */ GIM_Try, /*On fail goto*//*Label 32217*/ GIMT_Encode4(2325280), // Rule ID 58334 //
     /* 2325228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2325231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2325234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325242 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325242 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2325245 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325249 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2325259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325264 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325278 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325279 */   // GIR_Coverage, 58334,
     /* 2325279 */   GIR_EraseRootFromParent_Done,
     /* 2325280 */ // Label 32217: @2325280
     /* 2325280 */ GIM_Try, /*On fail goto*//*Label 32218*/ GIMT_Encode4(2325337), // Rule ID 58335 //
     /* 2325285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2325288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2325291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325299 */   // (sint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325299 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2325302 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325306 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E64),
     /* 2325316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325321 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325323 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2325332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325335 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325336 */   // GIR_Coverage, 58335,
     /* 2325336 */   GIR_EraseRootFromParent_Done,
     /* 2325337 */ // Label 32218: @2325337
     /* 2325337 */ GIM_Try, /*On fail goto*//*Label 32219*/ GIMT_Encode4(2325391), // Rule ID 58518 //
     /* 2325342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2325345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2325348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325356 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2325359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2325373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325375 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325378 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325380 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325389 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325390 */   // GIR_Coverage, 58518,
     /* 2325390 */   GIR_EraseRootFromParent_Done,
     /* 2325391 */ // Label 32219: @2325391
     /* 2325391 */ GIM_Try, /*On fail goto*//*Label 32220*/ GIMT_Encode4(2325445), // Rule ID 58519 //
     /* 2325396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2325399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2325402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325410 */   // (sint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2325413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E32),
     /* 2325427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325429 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325432 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325434 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325443 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325444 */   // GIR_Coverage, 58519,
     /* 2325444 */   GIR_EraseRootFromParent_Done,
     /* 2325445 */ // Label 32220: @2325445
     /* 2325445 */ GIM_Reject,
     /* 2325446 */ // Label 32129: @2325446
     /* 2325446 */ GIM_Try, /*On fail goto*//*Label 32221*/ GIMT_Encode4(2325503), // Rule ID 58306 //
     /* 2325451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2325454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2325457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325465 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325477 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2325482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325487 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325495 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325501 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325502 */   // GIR_Coverage, 58306,
     /* 2325502 */   GIR_EraseRootFromParent_Done,
     /* 2325503 */ // Label 32221: @2325503
     /* 2325503 */ GIM_Try, /*On fail goto*//*Label 32222*/ GIMT_Encode4(2325560), // Rule ID 58307 //
     /* 2325508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2325514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325518 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325522 */   // (sint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325522 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325525 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325529 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M4_E16),
     /* 2325539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325541 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325544 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325558 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325559 */   // GIR_Coverage, 58307,
     /* 2325559 */   GIR_EraseRootFromParent_Done,
     /* 2325560 */ // Label 32222: @2325560
     /* 2325560 */ GIM_Try, /*On fail goto*//*Label 32223*/ GIMT_Encode4(2325614), // Rule ID 58478 //
     /* 2325565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2325568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2325571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325579 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325579 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325582 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325586 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325591 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2325596 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325598 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325601 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325612 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325613 */   // GIR_Coverage, 58478,
     /* 2325613 */   GIR_EraseRootFromParent_Done,
     /* 2325614 */ // Label 32223: @2325614
     /* 2325614 */ GIM_Try, /*On fail goto*//*Label 32224*/ GIMT_Encode4(2325668), // Rule ID 58479 //
     /* 2325619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2325625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2325633 */   // (sint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325633 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325636 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325640 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325645 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325647 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M2_E8),
     /* 2325650 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325652 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325655 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325657 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325666 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325667 */   // GIR_Coverage, 58479,
     /* 2325667 */   GIR_EraseRootFromParent_Done,
     /* 2325668 */ // Label 32224: @2325668
     /* 2325668 */ GIM_Try, /*On fail goto*//*Label 32225*/ GIMT_Encode4(2325725), // Rule ID 58710 //
     /* 2325673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2325676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325687 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2325704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325706 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325709 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325714 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325717 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325723 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325724 */   // GIR_Coverage, 58710,
     /* 2325724 */   GIR_EraseRootFromParent_Done,
     /* 2325725 */ // Label 32225: @2325725
     /* 2325725 */ GIM_Try, /*On fail goto*//*Label 32226*/ GIMT_Encode4(2325782), // Rule ID 58711 //
     /* 2325730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2325733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325744 */   // (sint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_X_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2325747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_X_W_M4_E16),
     /* 2325761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325766 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325768 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325771 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325777 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325780 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325781 */   // GIR_Coverage, 58711,
     /* 2325781 */   GIR_EraseRootFromParent_Done,
     /* 2325782 */ // Label 32226: @2325782
     /* 2325782 */ GIM_Reject,
     /* 2325783 */ // Label 32130: @2325783
     /* 2325783 */ GIM_Try, /*On fail goto*//*Label 32227*/ GIMT_Encode4(2325840), // Rule ID 58322 //
     /* 2325788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2325791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325802 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2325805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325814 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2325819 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325824 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325838 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325839 */   // GIR_Coverage, 58322,
     /* 2325839 */   GIR_EraseRootFromParent_Done,
     /* 2325840 */ // Label 32227: @2325840
     /* 2325840 */ GIM_Try, /*On fail goto*//*Label 32228*/ GIMT_Encode4(2325897), // Rule ID 58323 //
     /* 2325845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2325848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2325851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325859 */   // (sint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325859 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2325862 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325866 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E32),
     /* 2325876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325878 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325881 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325883 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2325886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2325892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325895 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325896 */   // GIR_Coverage, 58323,
     /* 2325896 */   GIR_EraseRootFromParent_Done,
     /* 2325897 */ // Label 32228: @2325897
     /* 2325897 */ GIM_Try, /*On fail goto*//*Label 32229*/ GIMT_Encode4(2325951), // Rule ID 58502 //
     /* 2325902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2325905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2325908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325916 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2325916 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2325919 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325923 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325928 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2325933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325935 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325938 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2325946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2325949 */   GIR_RootConstrainSelectedInstOperands,
     /* 2325950 */   // GIR_Coverage, 58502,
     /* 2325950 */   GIR_EraseRootFromParent_Done,
     /* 2325951 */ // Label 32229: @2325951
     /* 2325951 */ GIM_Try, /*On fail goto*//*Label 32230*/ GIMT_Encode4(2326005), // Rule ID 58503 //
     /* 2325956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2325959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2325962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2325966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2325970 */   // (sint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2325970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2325973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2325977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2325982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2325984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E16),
     /* 2325987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2325989 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2325992 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2325994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2325997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326003 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326004 */   // GIR_Coverage, 58503,
     /* 2326004 */   GIR_EraseRootFromParent_Done,
     /* 2326005 */ // Label 32230: @2326005
     /* 2326005 */ GIM_Reject,
     /* 2326006 */ // Label 32131: @2326006
     /* 2326006 */ GIM_Try, /*On fail goto*//*Label 32231*/ GIMT_Encode4(2326063), // Rule ID 58310 //
     /* 2326011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2326014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326025 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2326042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326047 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326055 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326061 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326062 */   // GIR_Coverage, 58310,
     /* 2326062 */   GIR_EraseRootFromParent_Done,
     /* 2326063 */ // Label 32231: @2326063
     /* 2326063 */ GIM_Try, /*On fail goto*//*Label 32232*/ GIMT_Encode4(2326120), // Rule ID 58311 //
     /* 2326068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2326071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2326074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326082 */   // (sint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_X_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326082 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326085 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326089 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_X_V_M8_E16),
     /* 2326099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326101 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326104 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2326115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326118 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326119 */   // GIR_Coverage, 58311,
     /* 2326119 */   GIR_EraseRootFromParent_Done,
     /* 2326120 */ // Label 32232: @2326120
     /* 2326120 */ GIM_Try, /*On fail goto*//*Label 32233*/ GIMT_Encode4(2326174), // Rule ID 58482 //
     /* 2326125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2326128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2326131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326135 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326139 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2326139 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326142 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326146 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326151 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2326156 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326161 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326172 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326173 */   // GIR_Coverage, 58482,
     /* 2326173 */   GIR_EraseRootFromParent_Done,
     /* 2326174 */ // Label 32233: @2326174
     /* 2326174 */ GIM_Try, /*On fail goto*//*Label 32234*/ GIMT_Encode4(2326228), // Rule ID 58483 //
     /* 2326179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2326182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2326185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2326189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2326193 */   // (sint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_X_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2326193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2326196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2326200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2326205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2326207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_X_V_M4_E8),
     /* 2326210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2326215 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326217 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2326220 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326223 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2326226 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326227 */   // GIR_Coverage, 58483,
     /* 2326227 */   GIR_EraseRootFromParent_Done,
     /* 2326228 */ // Label 32234: @2326228
     /* 2326228 */ GIM_Reject,
     /* 2326229 */ // Label 32132: @2326229
     /* 2326229 */ GIM_Reject,
     /* 2326230 */ // Label 70: @2326230
     /* 2326230 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32253*/ GIMT_Encode4(2331515),
     /* 2326241 */ /*GILLT_s16*//*Label 32235*/ GIMT_Encode4(2326361),
     /* 2326245 */ /*GILLT_s32*//*Label 32236*/ GIMT_Encode4(2326622),
     /* 2326249 */ /*GILLT_s64*//*Label 32237*/ GIMT_Encode4(2326883), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326261 */ /*GILLT_nxv1s16*//*Label 32238*/ GIMT_Encode4(2327144),
     /* 2326265 */ /*GILLT_nxv1s32*//*Label 32239*/ GIMT_Encode4(2327481),
     /* 2326269 */ /*GILLT_nxv1s64*//*Label 32240*/ GIMT_Encode4(2327818), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326281 */ /*GILLT_nxv2s16*//*Label 32241*/ GIMT_Encode4(2328041),
     /* 2326285 */ /*GILLT_nxv2s32*//*Label 32242*/ GIMT_Encode4(2328378),
     /* 2326289 */ /*GILLT_nxv2s64*//*Label 32243*/ GIMT_Encode4(2328715), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326301 */ /*GILLT_nxv4s16*//*Label 32244*/ GIMT_Encode4(2328938),
     /* 2326305 */ /*GILLT_nxv4s32*//*Label 32245*/ GIMT_Encode4(2329275),
     /* 2326309 */ /*GILLT_nxv4s64*//*Label 32246*/ GIMT_Encode4(2329612), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326321 */ /*GILLT_nxv8s16*//*Label 32247*/ GIMT_Encode4(2329835),
     /* 2326325 */ /*GILLT_nxv8s32*//*Label 32248*/ GIMT_Encode4(2330172),
     /* 2326329 */ /*GILLT_nxv8s64*//*Label 32249*/ GIMT_Encode4(2330509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326341 */ /*GILLT_nxv16s16*//*Label 32250*/ GIMT_Encode4(2330732),
     /* 2326345 */ /*GILLT_nxv16s32*//*Label 32251*/ GIMT_Encode4(2331069), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2326357 */ /*GILLT_nxv32s16*//*Label 32252*/ GIMT_Encode4(2331292),
     /* 2326361 */ // Label 32235: @2326361
     /* 2326361 */ GIM_Try, /*On fail goto*//*Label 32254*/ GIMT_Encode4(2326398), // Rule ID 2153 //
     /* 2326366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2326369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326383 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2326386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326393 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326397 */   // GIR_Coverage, 2153,
     /* 2326397 */   GIR_EraseRootFromParent_Done,
     /* 2326398 */ // Label 32254: @2326398
     /* 2326398 */ GIM_Try, /*On fail goto*//*Label 32255*/ GIMT_Encode4(2326435), // Rule ID 2179 //
     /* 2326403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2326406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326413 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326420 */   // (uint_to_fp:{ *:[f16] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2326423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326425 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326434 */   // GIR_Coverage, 2179,
     /* 2326434 */   GIR_EraseRootFromParent_Done,
     /* 2326435 */ // Label 32255: @2326435
     /* 2326435 */ GIM_Try, /*On fail goto*//*Label 32256*/ GIMT_Encode4(2326466), // Rule ID 2104 //
     /* 2326440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2326443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326454 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2326454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2326457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326459 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326461 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326464 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326465 */   // GIR_Coverage, 2104,
     /* 2326465 */   GIR_EraseRootFromParent_Done,
     /* 2326466 */ // Label 32256: @2326466
     /* 2326466 */ GIM_Try, /*On fail goto*//*Label 32257*/ GIMT_Encode4(2326497), // Rule ID 2105 //
     /* 2326471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2326474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326485 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2326485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU),
     /* 2326488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326490 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326496 */   // GIR_Coverage, 2105,
     /* 2326496 */   GIR_EraseRootFromParent_Done,
     /* 2326497 */ // Label 32257: @2326497
     /* 2326497 */ GIM_Try, /*On fail goto*//*Label 32258*/ GIMT_Encode4(2326528), // Rule ID 2130 //
     /* 2326502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2326505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326516 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2326516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2326519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326521 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326523 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326526 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326527 */   // GIR_Coverage, 2130,
     /* 2326527 */   GIR_EraseRootFromParent_Done,
     /* 2326528 */ // Label 32258: @2326528
     /* 2326528 */ GIM_Try, /*On fail goto*//*Label 32259*/ GIMT_Encode4(2326559), // Rule ID 2131 //
     /* 2326533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2326536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326547 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_H_WU_INX:{ *:[f16] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2326547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_WU_INX),
     /* 2326550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326552 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326557 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326558 */   // GIR_Coverage, 2131,
     /* 2326558 */   GIR_EraseRootFromParent_Done,
     /* 2326559 */ // Label 32259: @2326559
     /* 2326559 */ GIM_Try, /*On fail goto*//*Label 32260*/ GIMT_Encode4(2326590), // Rule ID 2157 //
     /* 2326564 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2326567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2326574 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326578 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU),
     /* 2326581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326583 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326585 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326588 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326589 */   // GIR_Coverage, 2157,
     /* 2326589 */   GIR_EraseRootFromParent_Done,
     /* 2326590 */ // Label 32260: @2326590
     /* 2326590 */ GIM_Try, /*On fail goto*//*Label 32261*/ GIMT_Encode4(2326621), // Rule ID 2183 //
     /* 2326595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2326598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2326605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326609 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_H_LU_INX:{ *:[f16] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_LU_INX),
     /* 2326612 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326614 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326619 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326620 */   // GIR_Coverage, 2183,
     /* 2326620 */   GIR_EraseRootFromParent_Done,
     /* 2326621 */ // Label 32261: @2326621
     /* 2326621 */ GIM_Reject,
     /* 2326622 */ // Label 32236: @2326622
     /* 2326622 */ GIM_Try, /*On fail goto*//*Label 32262*/ GIMT_Encode4(2326659), // Rule ID 1419 //
     /* 2326627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2326630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326637 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326644 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326644 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2326647 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326649 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326654 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326657 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326658 */   // GIR_Coverage, 1419,
     /* 2326658 */   GIR_EraseRootFromParent_Done,
     /* 2326659 */ // Label 32262: @2326659
     /* 2326659 */ GIM_Try, /*On fail goto*//*Label 32263*/ GIMT_Encode4(2326696), // Rule ID 1447 //
     /* 2326664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2326667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326674 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326681 */   // (uint_to_fp:{ *:[f32] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2326684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326686 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326691 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326694 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326695 */   // GIR_Coverage, 1447,
     /* 2326695 */   GIR_EraseRootFromParent_Done,
     /* 2326696 */ // Label 32263: @2326696
     /* 2326696 */ GIM_Try, /*On fail goto*//*Label 32264*/ GIMT_Encode4(2326727), // Rule ID 1368 //
     /* 2326701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2326704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326715 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2326715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2326718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326720 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326725 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326726 */   // GIR_Coverage, 1368,
     /* 2326726 */   GIR_EraseRootFromParent_Done,
     /* 2326727 */ // Label 32264: @2326727
     /* 2326727 */ GIM_Try, /*On fail goto*//*Label 32265*/ GIMT_Encode4(2326758), // Rule ID 1369 //
     /* 2326732 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2326735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326746 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2326746 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU),
     /* 2326749 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326751 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326753 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326756 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326757 */   // GIR_Coverage, 1369,
     /* 2326757 */   GIR_EraseRootFromParent_Done,
     /* 2326758 */ // Label 32265: @2326758
     /* 2326758 */ GIM_Try, /*On fail goto*//*Label 32266*/ GIMT_Encode4(2326789), // Rule ID 1394 //
     /* 2326763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2326766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326777 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i64] })
     /* 2326777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2326780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326782 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326788 */   // GIR_Coverage, 1394,
     /* 2326788 */   GIR_EraseRootFromParent_Done,
     /* 2326789 */ // Label 32266: @2326789
     /* 2326789 */ GIM_Try, /*On fail goto*//*Label 32267*/ GIMT_Encode4(2326820), // Rule ID 1395 //
     /* 2326794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2326797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326808 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_S_WU_INX:{ *:[f32] } ?:{ *:[i32] }:$rs1, 7:{ *:[i32] })
     /* 2326808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_WU_INX),
     /* 2326811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326813 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326818 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326819 */   // GIR_Coverage, 1395,
     /* 2326819 */   GIR_EraseRootFromParent_Done,
     /* 2326820 */ // Label 32267: @2326820
     /* 2326820 */ GIM_Try, /*On fail goto*//*Label 32268*/ GIMT_Encode4(2326851), // Rule ID 1423 //
     /* 2326825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2326828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2326835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326839 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU),
     /* 2326842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326844 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326846 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326849 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326850 */   // GIR_Coverage, 1423,
     /* 2326850 */   GIR_EraseRootFromParent_Done,
     /* 2326851 */ // Label 32268: @2326851
     /* 2326851 */ GIM_Try, /*On fail goto*//*Label 32269*/ GIMT_Encode4(2326882), // Rule ID 1451 //
     /* 2326856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2326859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2326866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326870 */   // (uint_to_fp:{ *:[f32] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_S_LU_INX:{ *:[f32] } ?:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2326870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_LU_INX),
     /* 2326873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326875 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2326880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326881 */   // GIR_Coverage, 1451,
     /* 2326881 */   GIR_EraseRootFromParent_Done,
     /* 2326882 */ // Label 32269: @2326882
     /* 2326882 */ GIM_Reject,
     /* 2326883 */ // Label 32237: @2326883
     /* 2326883 */ GIM_Try, /*On fail goto*//*Label 32270*/ GIMT_Encode4(2326920), // Rule ID 1799 //
     /* 2326888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2326891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326898 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326905 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2326905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2326908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326918 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326919 */   // GIR_Coverage, 1799,
     /* 2326919 */   GIR_EraseRootFromParent_Done,
     /* 2326920 */ // Label 32270: @2326920
     /* 2326920 */ GIM_Try, /*On fail goto*//*Label 32271*/ GIMT_Encode4(2326957), // Rule ID 1827 //
     /* 2326925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2326928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2326931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326935 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2326942 */   // (uint_to_fp:{ *:[f64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (FCVT_D_WU_INX:{ *:[f64] } ?:{ *:[i64] }:$rs1, 0:{ *:[i64] })
     /* 2326942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_INX),
     /* 2326945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2326952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326955 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326956 */   // GIR_Coverage, 1827,
     /* 2326956 */   GIR_EraseRootFromParent_Done,
     /* 2326957 */ // Label 32271: @2326957
     /* 2326957 */ GIM_Try, /*On fail goto*//*Label 32272*/ GIMT_Encode4(2326988), // Rule ID 1762 //
     /* 2326962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2326965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2326972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2326976 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2326976 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2326979 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2326981 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2326983 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2326986 */   GIR_RootConstrainSelectedInstOperands,
     /* 2326987 */   // GIR_Coverage, 1762,
     /* 2326987 */   GIR_EraseRootFromParent_Done,
     /* 2326988 */ // Label 32272: @2326988
     /* 2326988 */ GIM_Try, /*On fail goto*//*Label 32273*/ GIMT_Encode4(2327019), // Rule ID 1763 //
     /* 2326993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2326996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2326999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327007 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2327007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU),
     /* 2327010 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327012 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327014 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327017 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327018 */   // GIR_Coverage, 1763,
     /* 2327018 */   GIR_EraseRootFromParent_Done,
     /* 2327019 */ // Label 32273: @2327019
     /* 2327019 */ GIM_Try, /*On fail goto*//*Label 32274*/ GIMT_Encode4(2327050), // Rule ID 1788 //
     /* 2327024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2327027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327038 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i64] })
     /* 2327038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2327041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327043 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327048 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327049 */   // GIR_Coverage, 1788,
     /* 2327049 */   GIR_EraseRootFromParent_Done,
     /* 2327050 */ // Label 32274: @2327050
     /* 2327050 */ GIM_Try, /*On fail goto*//*Label 32275*/ GIMT_Encode4(2327081), // Rule ID 1789 //
     /* 2327055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2327058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2327061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2327065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327069 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$rs1)  =>  (FCVT_D_WU_IN32X:{ *:[f64] } GPR:{ *:[i32] }:$rs1, 0:{ *:[i32] })
     /* 2327069 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_WU_IN32X),
     /* 2327072 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327074 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2327079 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327080 */   // GIR_Coverage, 1789,
     /* 2327080 */   GIR_EraseRootFromParent_Done,
     /* 2327081 */ // Label 32275: @2327081
     /* 2327081 */ GIM_Try, /*On fail goto*//*Label 32276*/ GIMT_Encode4(2327112), // Rule ID 1817 //
     /* 2327086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2327089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2327096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327100 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2327100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU),
     /* 2327103 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327105 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327110 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327111 */   // GIR_Coverage, 1817,
     /* 2327111 */   GIR_EraseRootFromParent_Done,
     /* 2327112 */ // Label 32276: @2327112
     /* 2327112 */ GIM_Try, /*On fail goto*//*Label 32277*/ GIMT_Encode4(2327143), // Rule ID 1845 //
     /* 2327117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2327120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2327123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2327131 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i64] }:$rs1)  =>  (FCVT_D_LU_INX:{ *:[f64] } GPR:{ *:[i64] }:$rs1, 7:{ *:[i64] })
     /* 2327131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_LU_INX),
     /* 2327134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327136 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327141 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327142 */   // GIR_Coverage, 1845,
     /* 2327142 */   GIR_EraseRootFromParent_Done,
     /* 2327143 */ // Label 32277: @2327143
     /* 2327143 */ GIM_Reject,
     /* 2327144 */ // Label 32238: @2327144
     /* 2327144 */ GIM_Try, /*On fail goto*//*Label 32278*/ GIMT_Encode4(2327201), // Rule ID 58338 //
     /* 2327149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327163 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327163 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327166 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327170 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327175 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2327180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327182 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327185 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327190 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327193 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327199 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327200 */   // GIR_Coverage, 58338,
     /* 2327200 */   GIR_EraseRootFromParent_Done,
     /* 2327201 */ // Label 32278: @2327201
     /* 2327201 */ GIM_Try, /*On fail goto*//*Label 32279*/ GIMT_Encode4(2327258), // Rule ID 58339 //
     /* 2327206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327220 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327220 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327223 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327227 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF4_E16),
     /* 2327237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327239 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327242 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327244 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327250 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327253 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327256 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327257 */   // GIR_Coverage, 58339,
     /* 2327257 */   GIR_EraseRootFromParent_Done,
     /* 2327258 */ // Label 32279: @2327258
     /* 2327258 */ GIM_Try, /*On fail goto*//*Label 32280*/ GIMT_Encode4(2327312), // Rule ID 58522 //
     /* 2327263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2327269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327277 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2327294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327296 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327299 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327301 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327304 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327307 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327310 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327311 */   // GIR_Coverage, 58522,
     /* 2327311 */   GIR_EraseRootFromParent_Done,
     /* 2327312 */ // Label 32280: @2327312
     /* 2327312 */ GIM_Try, /*On fail goto*//*Label 32281*/ GIMT_Encode4(2327366), // Rule ID 58523 //
     /* 2327317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2327323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327331 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF8_E8:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327343 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF8_E8),
     /* 2327348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327353 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327355 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327358 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327361 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327364 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327365 */   // GIR_Coverage, 58523,
     /* 2327365 */   GIR_EraseRootFromParent_Done,
     /* 2327366 */ // Label 32281: @2327366
     /* 2327366 */ GIM_Try, /*On fail goto*//*Label 32282*/ GIMT_Encode4(2327423), // Rule ID 58730 //
     /* 2327371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2327374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327385 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327385 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327388 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327392 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327399 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2327402 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327407 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327412 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327415 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327421 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327422 */   // GIR_Coverage, 58730,
     /* 2327422 */   GIR_EraseRootFromParent_Done,
     /* 2327423 */ // Label 32282: @2327423
     /* 2327423 */ GIM_Try, /*On fail goto*//*Label 32283*/ GIMT_Encode4(2327480), // Rule ID 58731 //
     /* 2327428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2327431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327442 */   // (uint_to_fp:{ *:[nxv1f16] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327442 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2327445 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327449 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327454 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF4_E16),
     /* 2327459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327461 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327464 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327472 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327475 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327478 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327479 */   // GIR_Coverage, 58731,
     /* 2327479 */   GIR_EraseRootFromParent_Done,
     /* 2327480 */ // Label 32283: @2327480
     /* 2327480 */ GIM_Reject,
     /* 2327481 */ // Label 32239: @2327481
     /* 2327481 */ GIM_Try, /*On fail goto*//*Label 32284*/ GIMT_Encode4(2327538), // Rule ID 58346 //
     /* 2327486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327500 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2327517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327522 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327527 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327533 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327536 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327537 */   // GIR_Coverage, 58346,
     /* 2327537 */   GIR_EraseRootFromParent_Done,
     /* 2327538 */ // Label 32284: @2327538
     /* 2327538 */ GIM_Try, /*On fail goto*//*Label 32285*/ GIMT_Encode4(2327595), // Rule ID 58347 //
     /* 2327543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327557 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327557 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327560 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327564 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E32),
     /* 2327574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327576 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327579 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327581 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327584 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327587 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327590 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327593 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327594 */   // GIR_Coverage, 58347,
     /* 2327594 */   GIR_EraseRootFromParent_Done,
     /* 2327595 */ // Label 32285: @2327595
     /* 2327595 */ GIM_Try, /*On fail goto*//*Label 32286*/ GIMT_Encode4(2327649), // Rule ID 58546 //
     /* 2327600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2327603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327606 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327614 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327614 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327617 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327621 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327626 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327628 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2327631 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327633 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327641 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327644 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327647 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327648 */   // GIR_Coverage, 58546,
     /* 2327648 */   GIR_EraseRootFromParent_Done,
     /* 2327649 */ // Label 32286: @2327649
     /* 2327649 */ GIM_Try, /*On fail goto*//*Label 32287*/ GIMT_Encode4(2327703), // Rule ID 58547 //
     /* 2327654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2327657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2327660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327668 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E16:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E16),
     /* 2327685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327690 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327692 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327695 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2327698 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327701 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327702 */   // GIR_Coverage, 58547,
     /* 2327702 */   GIR_EraseRootFromParent_Done,
     /* 2327703 */ // Label 32287: @2327703
     /* 2327703 */ GIM_Try, /*On fail goto*//*Label 32288*/ GIMT_Encode4(2327760), // Rule ID 58750 //
     /* 2327708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2327711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327722 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327734 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2327739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327744 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327746 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327752 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327755 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327758 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327759 */   // GIR_Coverage, 58750,
     /* 2327759 */   GIR_EraseRootFromParent_Done,
     /* 2327760 */ // Label 32288: @2327760
     /* 2327760 */ GIM_Try, /*On fail goto*//*Label 32289*/ GIMT_Encode4(2327817), // Rule ID 58751 //
     /* 2327765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2327768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327779 */   // (uint_to_fp:{ *:[nxv1f32] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327779 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2327782 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327786 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E32),
     /* 2327796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327801 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327803 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327806 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327809 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327812 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327815 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327816 */   // GIR_Coverage, 58751,
     /* 2327816 */   GIR_EraseRootFromParent_Done,
     /* 2327817 */ // Label 32289: @2327817
     /* 2327817 */ GIM_Reject,
     /* 2327818 */ // Label 32240: @2327818
     /* 2327818 */ GIM_Try, /*On fail goto*//*Label 32290*/ GIMT_Encode4(2327875), // Rule ID 58358 //
     /* 2327823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2327826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327837 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2327854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327856 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327859 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327861 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327864 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327867 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327870 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327873 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327874 */   // GIR_Coverage, 58358,
     /* 2327874 */   GIR_EraseRootFromParent_Done,
     /* 2327875 */ // Label 32290: @2327875
     /* 2327875 */ GIM_Try, /*On fail goto*//*Label 32291*/ GIMT_Encode4(2327932), // Rule ID 58359 //
     /* 2327880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2327883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2327886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327894 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2327894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E64),
     /* 2327911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327916 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327918 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2327921 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2327927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327931 */   // GIR_Coverage, 58359,
     /* 2327931 */   GIR_EraseRootFromParent_Done,
     /* 2327932 */ // Label 32291: @2327932
     /* 2327932 */ GIM_Try, /*On fail goto*//*Label 32292*/ GIMT_Encode4(2327986), // Rule ID 58566 //
     /* 2327937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2327940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327947 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2327951 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2327951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2327954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2327958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2327963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2327965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2327968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2327970 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2327973 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2327975 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2327978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2327981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2327984 */   GIR_RootConstrainSelectedInstOperands,
     /* 2327985 */   // GIR_Coverage, 58566,
     /* 2327985 */   GIR_EraseRootFromParent_Done,
     /* 2327986 */ // Label 32292: @2327986
     /* 2327986 */ GIM_Try, /*On fail goto*//*Label 32293*/ GIMT_Encode4(2328040), // Rule ID 58567 //
     /* 2327991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2327994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2327997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328005 */   // (uint_to_fp:{ *:[nxv1f64] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E32:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2328008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328017 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E32),
     /* 2328022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328024 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328027 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328029 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328038 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328039 */   // GIR_Coverage, 58567,
     /* 2328039 */   GIR_EraseRootFromParent_Done,
     /* 2328040 */ // Label 32293: @2328040
     /* 2328040 */ GIM_Reject,
     /* 2328041 */ // Label 32241: @2328041
     /* 2328041 */ GIM_Try, /*On fail goto*//*Label 32294*/ GIMT_Encode4(2328098), // Rule ID 58342 //
     /* 2328046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328060 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328072 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2328077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328082 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328087 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328090 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328093 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328096 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328097 */   // GIR_Coverage, 58342,
     /* 2328097 */   GIR_EraseRootFromParent_Done,
     /* 2328098 */ // Label 32294: @2328098
     /* 2328098 */ GIM_Try, /*On fail goto*//*Label 32295*/ GIMT_Encode4(2328155), // Rule ID 58343 //
     /* 2328103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328117 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_MF2_E16),
     /* 2328134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328139 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328141 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328144 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328147 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328153 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328154 */   // GIR_Coverage, 58343,
     /* 2328154 */   GIR_EraseRootFromParent_Done,
     /* 2328155 */ // Label 32295: @2328155
     /* 2328155 */ GIM_Try, /*On fail goto*//*Label 32296*/ GIMT_Encode4(2328209), // Rule ID 58526 //
     /* 2328160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2328166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328174 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328174 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328177 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328181 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328186 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2328191 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328196 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328201 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328207 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328208 */   // GIR_Coverage, 58526,
     /* 2328208 */   GIR_EraseRootFromParent_Done,
     /* 2328209 */ // Label 32296: @2328209
     /* 2328209 */ GIM_Try, /*On fail goto*//*Label 32297*/ GIMT_Encode4(2328263), // Rule ID 58527 //
     /* 2328214 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328217 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2328220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328224 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328228 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF4_E8:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328242 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF4_E8),
     /* 2328245 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328247 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328250 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328258 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328261 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328262 */   // GIR_Coverage, 58527,
     /* 2328262 */   GIR_EraseRootFromParent_Done,
     /* 2328263 */ // Label 32297: @2328263
     /* 2328263 */ GIM_Try, /*On fail goto*//*Label 32298*/ GIMT_Encode4(2328320), // Rule ID 58734 //
     /* 2328268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328282 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328282 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328285 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328289 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328294 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328296 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2328299 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328301 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328304 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328309 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328312 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328319 */   // GIR_Coverage, 58734,
     /* 2328319 */   GIR_EraseRootFromParent_Done,
     /* 2328320 */ // Label 32298: @2328320
     /* 2328320 */ GIM_Try, /*On fail goto*//*Label 32299*/ GIMT_Encode4(2328377), // Rule ID 58735 //
     /* 2328325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2328328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328339 */   // (uint_to_fp:{ *:[nxv2f16] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2328342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_MF2_E16),
     /* 2328356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328358 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328361 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328363 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328375 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328376 */   // GIR_Coverage, 58735,
     /* 2328376 */   GIR_EraseRootFromParent_Done,
     /* 2328377 */ // Label 32299: @2328377
     /* 2328377 */ GIM_Reject,
     /* 2328378 */ // Label 32242: @2328378
     /* 2328378 */ GIM_Try, /*On fail goto*//*Label 32300*/ GIMT_Encode4(2328435), // Rule ID 58354 //
     /* 2328383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328397 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328397 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328400 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328404 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2328414 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328416 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328419 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328421 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328427 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328433 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328434 */   // GIR_Coverage, 58354,
     /* 2328434 */   GIR_EraseRootFromParent_Done,
     /* 2328435 */ // Label 32300: @2328435
     /* 2328435 */ GIM_Try, /*On fail goto*//*Label 32301*/ GIMT_Encode4(2328492), // Rule ID 58355 //
     /* 2328440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328454 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E32),
     /* 2328471 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328476 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328478 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328481 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328484 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328490 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328491 */   // GIR_Coverage, 58355,
     /* 2328491 */   GIR_EraseRootFromParent_Done,
     /* 2328492 */ // Label 32301: @2328492
     /* 2328492 */ GIM_Try, /*On fail goto*//*Label 32302*/ GIMT_Encode4(2328546), // Rule ID 58550 //
     /* 2328497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2328500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328511 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2328528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328530 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328533 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328535 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328538 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328544 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328545 */   // GIR_Coverage, 58550,
     /* 2328545 */   GIR_EraseRootFromParent_Done,
     /* 2328546 */ // Label 32302: @2328546
     /* 2328546 */ GIM_Try, /*On fail goto*//*Label 32303*/ GIMT_Encode4(2328600), // Rule ID 58551 //
     /* 2328551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2328554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2328557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328561 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328565 */   // (uint_to_fp:{ *:[nxv2f32] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E16:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328577 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E16),
     /* 2328582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328584 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328587 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328592 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328598 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328599 */   // GIR_Coverage, 58551,
     /* 2328599 */   GIR_EraseRootFromParent_Done,
     /* 2328600 */ // Label 32303: @2328600
     /* 2328600 */ GIM_Try, /*On fail goto*//*Label 32304*/ GIMT_Encode4(2328657), // Rule ID 58754 //
     /* 2328605 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2328608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328619 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328619 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328622 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328626 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2328636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328641 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328643 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328646 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328652 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328655 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328656 */   // GIR_Coverage, 58754,
     /* 2328656 */   GIR_EraseRootFromParent_Done,
     /* 2328657 */ // Label 32304: @2328657
     /* 2328657 */ GIM_Try, /*On fail goto*//*Label 32305*/ GIMT_Encode4(2328714), // Rule ID 58755 //
     /* 2328662 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2328665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328676 */   // (uint_to_fp:{ *:[nxv2f32] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2328679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328688 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328690 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E32),
     /* 2328693 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328703 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328709 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328712 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328713 */   // GIR_Coverage, 58755,
     /* 2328713 */   GIR_EraseRootFromParent_Done,
     /* 2328714 */ // Label 32305: @2328714
     /* 2328714 */ GIM_Reject,
     /* 2328715 */ // Label 32243: @2328715
     /* 2328715 */ GIM_Try, /*On fail goto*//*Label 32306*/ GIMT_Encode4(2328772), // Rule ID 58386 //
     /* 2328720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2328723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328734 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328734 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328737 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328741 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328746 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328748 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2328751 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328756 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328758 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328764 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328767 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328770 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328771 */   // GIR_Coverage, 58386,
     /* 2328771 */   GIR_EraseRootFromParent_Done,
     /* 2328772 */ // Label 32306: @2328772
     /* 2328772 */ GIM_Try, /*On fail goto*//*Label 32307*/ GIMT_Encode4(2328829), // Rule ID 58387 //
     /* 2328777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2328780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2328783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328791 */   // (uint_to_fp:{ *:[nxv2f64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328791 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328794 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328798 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E64),
     /* 2328808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328813 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328815 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2328824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328828 */   // GIR_Coverage, 58387,
     /* 2328828 */   GIR_EraseRootFromParent_Done,
     /* 2328829 */ // Label 32307: @2328829
     /* 2328829 */ GIM_Try, /*On fail goto*//*Label 32308*/ GIMT_Encode4(2328883), // Rule ID 58570 //
     /* 2328834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2328837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328848 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328848 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328851 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328855 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328860 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2328865 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328867 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328870 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328881 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328882 */   // GIR_Coverage, 58570,
     /* 2328882 */   GIR_EraseRootFromParent_Done,
     /* 2328883 */ // Label 32308: @2328883
     /* 2328883 */ GIM_Try, /*On fail goto*//*Label 32309*/ GIMT_Encode4(2328937), // Rule ID 58571 //
     /* 2328888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2328891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2328894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2328898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328902 */   // (uint_to_fp:{ *:[nxv2f64] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E32:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2328902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2328905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E32),
     /* 2328919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328924 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2328932 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328935 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328936 */   // GIR_Coverage, 58571,
     /* 2328936 */   GIR_EraseRootFromParent_Done,
     /* 2328937 */ // Label 32309: @2328937
     /* 2328937 */ GIM_Reject,
     /* 2328938 */ // Label 32244: @2328938
     /* 2328938 */ GIM_Try, /*On fail goto*//*Label 32310*/ GIMT_Encode4(2328995), // Rule ID 58350 //
     /* 2328943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2328946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2328949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2328957 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2328957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2328960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2328964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2328969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2328971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2328974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2328976 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2328979 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2328981 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2328984 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2328987 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2328990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2328993 */   GIR_RootConstrainSelectedInstOperands,
     /* 2328994 */   // GIR_Coverage, 58350,
     /* 2328994 */   GIR_EraseRootFromParent_Done,
     /* 2328995 */ // Label 32310: @2328995
     /* 2328995 */ GIM_Try, /*On fail goto*//*Label 32311*/ GIMT_Encode4(2329052), // Rule ID 58351 //
     /* 2329000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329014 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329014 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329017 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329021 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M1_E16),
     /* 2329031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329036 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329038 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329041 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329044 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329047 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329050 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329051 */   // GIR_Coverage, 58351,
     /* 2329051 */   GIR_EraseRootFromParent_Done,
     /* 2329052 */ // Label 32311: @2329052
     /* 2329052 */ GIM_Try, /*On fail goto*//*Label 32312*/ GIMT_Encode4(2329106), // Rule ID 58530 //
     /* 2329057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2329063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329071 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329071 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329074 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329078 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2329088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329090 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329093 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329098 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329104 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329105 */   // GIR_Coverage, 58530,
     /* 2329105 */   GIR_EraseRootFromParent_Done,
     /* 2329106 */ // Label 32312: @2329106
     /* 2329106 */ GIM_Try, /*On fail goto*//*Label 32313*/ GIMT_Encode4(2329160), // Rule ID 58531 //
     /* 2329111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2329117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329125 */   // (uint_to_fp:{ *:[nxv4f16] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_MF2_E8:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329139 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_MF2_E8),
     /* 2329142 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329144 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329147 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329149 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329155 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329158 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329159 */   // GIR_Coverage, 58531,
     /* 2329159 */   GIR_EraseRootFromParent_Done,
     /* 2329160 */ // Label 32313: @2329160
     /* 2329160 */ GIM_Try, /*On fail goto*//*Label 32314*/ GIMT_Encode4(2329217), // Rule ID 58738 //
     /* 2329165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329175 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329179 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2329196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329198 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329201 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329203 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329212 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329215 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329216 */   // GIR_Coverage, 58738,
     /* 2329216 */   GIR_EraseRootFromParent_Done,
     /* 2329217 */ // Label 32314: @2329217
     /* 2329217 */ GIM_Try, /*On fail goto*//*Label 32315*/ GIMT_Encode4(2329274), // Rule ID 58739 //
     /* 2329222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329236 */   // (uint_to_fp:{ *:[nxv4f16] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2329239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M1_E16),
     /* 2329253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329255 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329258 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329266 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329269 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329272 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329273 */   // GIR_Coverage, 58739,
     /* 2329273 */   GIR_EraseRootFromParent_Done,
     /* 2329274 */ // Label 32315: @2329274
     /* 2329274 */ GIM_Reject,
     /* 2329275 */ // Label 32245: @2329275
     /* 2329275 */ GIM_Try, /*On fail goto*//*Label 32316*/ GIMT_Encode4(2329332), // Rule ID 58374 //
     /* 2329280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329294 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2329311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329313 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329316 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329321 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329324 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329327 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329330 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329331 */   // GIR_Coverage, 58374,
     /* 2329331 */   GIR_EraseRootFromParent_Done,
     /* 2329332 */ // Label 32316: @2329332
     /* 2329332 */ GIM_Try, /*On fail goto*//*Label 32317*/ GIMT_Encode4(2329389), // Rule ID 58375 //
     /* 2329337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329351 */   // (uint_to_fp:{ *:[nxv4f32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E32),
     /* 2329368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329373 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329378 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329387 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329388 */   // GIR_Coverage, 58375,
     /* 2329388 */   GIR_EraseRootFromParent_Done,
     /* 2329389 */ // Label 32317: @2329389
     /* 2329389 */ GIM_Try, /*On fail goto*//*Label 32318*/ GIMT_Encode4(2329443), // Rule ID 58554 //
     /* 2329394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2329397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329408 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329420 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2329425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329430 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329432 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329435 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329438 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329441 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329442 */   // GIR_Coverage, 58554,
     /* 2329442 */   GIR_EraseRootFromParent_Done,
     /* 2329443 */ // Label 32318: @2329443
     /* 2329443 */ GIM_Try, /*On fail goto*//*Label 32319*/ GIMT_Encode4(2329497), // Rule ID 58555 //
     /* 2329448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2329451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2329454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329462 */   // (uint_to_fp:{ *:[nxv4f32] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E16:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329462 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329465 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329469 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E16),
     /* 2329479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329484 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329495 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329496 */   // GIR_Coverage, 58555,
     /* 2329496 */   GIR_EraseRootFromParent_Done,
     /* 2329497 */ // Label 32319: @2329497
     /* 2329497 */ GIM_Try, /*On fail goto*//*Label 32320*/ GIMT_Encode4(2329554), // Rule ID 58758 //
     /* 2329502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2329505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329516 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329516 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329519 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329523 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329528 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2329533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329535 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329538 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329546 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329549 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329552 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329553 */   // GIR_Coverage, 58758,
     /* 2329553 */   GIR_EraseRootFromParent_Done,
     /* 2329554 */ // Label 32320: @2329554
     /* 2329554 */ GIM_Try, /*On fail goto*//*Label 32321*/ GIMT_Encode4(2329611), // Rule ID 58759 //
     /* 2329559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2329562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329573 */   // (uint_to_fp:{ *:[nxv4f32] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329573 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2329576 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329580 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329585 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329587 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E32),
     /* 2329590 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329592 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329595 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329597 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329606 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329609 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329610 */   // GIR_Coverage, 58759,
     /* 2329610 */   GIR_EraseRootFromParent_Done,
     /* 2329611 */ // Label 32321: @2329611
     /* 2329611 */ GIM_Reject,
     /* 2329612 */ // Label 32246: @2329612
     /* 2329612 */ GIM_Try, /*On fail goto*//*Label 32322*/ GIMT_Encode4(2329669), // Rule ID 58390 //
     /* 2329617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2329620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329631 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329631 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329634 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329638 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2329648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329653 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329655 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329661 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329667 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329668 */   // GIR_Coverage, 58390,
     /* 2329668 */   GIR_EraseRootFromParent_Done,
     /* 2329669 */ // Label 32322: @2329669
     /* 2329669 */ GIM_Try, /*On fail goto*//*Label 32323*/ GIMT_Encode4(2329726), // Rule ID 58391 //
     /* 2329674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2329677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2329680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329688 */   // (uint_to_fp:{ *:[nxv4f64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329700 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329702 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E64),
     /* 2329705 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329707 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329710 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329712 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329718 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2329721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329724 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329725 */   // GIR_Coverage, 58391,
     /* 2329725 */   GIR_EraseRootFromParent_Done,
     /* 2329726 */ // Label 32323: @2329726
     /* 2329726 */ GIM_Try, /*On fail goto*//*Label 32324*/ GIMT_Encode4(2329780), // Rule ID 58574 //
     /* 2329731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2329734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329745 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2329762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329764 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329767 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329772 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329778 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329779 */   // GIR_Coverage, 58574,
     /* 2329779 */   GIR_EraseRootFromParent_Done,
     /* 2329780 */ // Label 32324: @2329780
     /* 2329780 */ GIM_Try, /*On fail goto*//*Label 32325*/ GIMT_Encode4(2329834), // Rule ID 58575 //
     /* 2329785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2329788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2329791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2329795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329799 */   // (uint_to_fp:{ *:[nxv4f64] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E32:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329799 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2329802 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329806 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329811 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E32),
     /* 2329816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329818 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329821 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329826 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2329829 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329832 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329833 */   // GIR_Coverage, 58575,
     /* 2329833 */   GIR_EraseRootFromParent_Done,
     /* 2329834 */ // Label 32325: @2329834
     /* 2329834 */ GIM_Reject,
     /* 2329835 */ // Label 32247: @2329835
     /* 2329835 */ GIM_Try, /*On fail goto*//*Label 32326*/ GIMT_Encode4(2329892), // Rule ID 58362 //
     /* 2329840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329854 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2329871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329873 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329876 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329878 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329881 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329884 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329887 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329890 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329891 */   // GIR_Coverage, 58362,
     /* 2329891 */   GIR_EraseRootFromParent_Done,
     /* 2329892 */ // Label 32326: @2329892
     /* 2329892 */ GIM_Try, /*On fail goto*//*Label 32327*/ GIMT_Encode4(2329949), // Rule ID 58363 //
     /* 2329897 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2329900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2329903 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329907 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329911 */   // (uint_to_fp:{ *:[nxv8f16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2329911 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329914 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329918 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M2_E16),
     /* 2329928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329933 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329935 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2329938 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2329944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329947 */   GIR_RootConstrainSelectedInstOperands,
     /* 2329948 */   // GIR_Coverage, 58363,
     /* 2329948 */   GIR_EraseRootFromParent_Done,
     /* 2329949 */ // Label 32327: @2329949
     /* 2329949 */ GIM_Try, /*On fail goto*//*Label 32328*/ GIMT_Encode4(2330003), // Rule ID 58534 //
     /* 2329954 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2329957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2329960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2329964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2329968 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2329968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2329971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2329975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2329980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2329982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2329985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2329987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2329990 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2329992 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2329995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2329998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330001 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330002 */   // GIR_Coverage, 58534,
     /* 2330002 */   GIR_EraseRootFromParent_Done,
     /* 2330003 */ // Label 32328: @2330003
     /* 2330003 */ GIM_Try, /*On fail goto*//*Label 32329*/ GIMT_Encode4(2330057), // Rule ID 58535 //
     /* 2330008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2330014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2330022 */   // (uint_to_fp:{ *:[nxv8f16] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M1_E8:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M1_E8),
     /* 2330039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330044 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330046 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330055 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330056 */   // GIR_Coverage, 58535,
     /* 2330056 */   GIR_EraseRootFromParent_Done,
     /* 2330057 */ // Label 32329: @2330057
     /* 2330057 */ GIM_Try, /*On fail goto*//*Label 32330*/ GIMT_Encode4(2330114), // Rule ID 58742 //
     /* 2330062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330076 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330088 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2330093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330095 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330098 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330103 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330106 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330109 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330112 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330113 */   // GIR_Coverage, 58742,
     /* 2330113 */   GIR_EraseRootFromParent_Done,
     /* 2330114 */ // Label 32330: @2330114
     /* 2330114 */ GIM_Try, /*On fail goto*//*Label 32331*/ GIMT_Encode4(2330171), // Rule ID 58743 //
     /* 2330119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330133 */   // (uint_to_fp:{ *:[nxv8f16] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2330136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330145 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330147 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M2_E16),
     /* 2330150 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330152 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330155 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330157 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330160 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330163 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330170 */   // GIR_Coverage, 58743,
     /* 2330170 */   GIR_EraseRootFromParent_Done,
     /* 2330171 */ // Label 32331: @2330171
     /* 2330171 */ GIM_Reject,
     /* 2330172 */ // Label 32248: @2330172
     /* 2330172 */ GIM_Try, /*On fail goto*//*Label 32332*/ GIMT_Encode4(2330229), // Rule ID 58378 //
     /* 2330177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330180 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330191 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330205 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2330208 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330213 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330215 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330227 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330228 */   // GIR_Coverage, 58378,
     /* 2330228 */   GIR_EraseRootFromParent_Done,
     /* 2330229 */ // Label 32332: @2330229
     /* 2330229 */ GIM_Try, /*On fail goto*//*Label 32333*/ GIMT_Encode4(2330286), // Rule ID 58379 //
     /* 2330234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330248 */   // (uint_to_fp:{ *:[nxv8f32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E32),
     /* 2330265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330270 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330272 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330275 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330284 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330285 */   // GIR_Coverage, 58379,
     /* 2330285 */   GIR_EraseRootFromParent_Done,
     /* 2330286 */ // Label 32333: @2330286
     /* 2330286 */ GIM_Try, /*On fail goto*//*Label 32334*/ GIMT_Encode4(2330340), // Rule ID 58558 //
     /* 2330291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2330294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330305 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330305 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330308 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330312 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2330322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330324 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330327 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330332 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330338 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330339 */   // GIR_Coverage, 58558,
     /* 2330339 */   GIR_EraseRootFromParent_Done,
     /* 2330340 */ // Label 32334: @2330340
     /* 2330340 */ GIM_Try, /*On fail goto*//*Label 32335*/ GIMT_Encode4(2330394), // Rule ID 58559 //
     /* 2330345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2330348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2330351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330359 */   // (uint_to_fp:{ *:[nxv8f32] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E16:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E16),
     /* 2330376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330381 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330383 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330386 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330392 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330393 */   // GIR_Coverage, 58559,
     /* 2330393 */   GIR_EraseRootFromParent_Done,
     /* 2330394 */ // Label 32335: @2330394
     /* 2330394 */ GIM_Try, /*On fail goto*//*Label 32336*/ GIMT_Encode4(2330451), // Rule ID 58762 //
     /* 2330399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode0),
     /* 2330402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330413 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330425 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2330430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330435 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330446 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330449 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330450 */   // GIR_Coverage, 58762,
     /* 2330450 */   GIR_EraseRootFromParent_Done,
     /* 2330451 */ // Label 32336: @2330451
     /* 2330451 */ GIM_Try, /*On fail goto*//*Label 32337*/ GIMT_Encode4(2330508), // Rule ID 58763 //
     /* 2330456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HasVInstructionsI64_HwMode1),
     /* 2330459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330470 */   // (uint_to_fp:{ *:[nxv8f32] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330470 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2330473 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330477 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330482 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E32),
     /* 2330487 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330489 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330492 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330494 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330497 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330507 */   // GIR_Coverage, 58763,
     /* 2330507 */   GIR_EraseRootFromParent_Done,
     /* 2330508 */ // Label 32337: @2330508
     /* 2330508 */ GIM_Reject,
     /* 2330509 */ // Label 32249: @2330509
     /* 2330509 */ GIM_Try, /*On fail goto*//*Label 32338*/ GIMT_Encode4(2330566), // Rule ID 58394 //
     /* 2330514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode0),
     /* 2330517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330528 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2330545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330550 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330552 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330555 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330561 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330564 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330565 */   // GIR_Coverage, 58394,
     /* 2330565 */   GIR_EraseRootFromParent_Done,
     /* 2330566 */ // Label 32338: @2330566
     /* 2330566 */ GIM_Try, /*On fail goto*//*Label 32339*/ GIMT_Encode4(2330623), // Rule ID 58395 //
     /* 2330571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HasVInstructionsI64_HwMode1),
     /* 2330574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2330577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330581 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330585 */   // (uint_to_fp:{ *:[nxv8f64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8i64] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330585 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330588 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330592 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E64),
     /* 2330602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330607 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330612 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2330618 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330621 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330622 */   // GIR_Coverage, 58395,
     /* 2330622 */   GIR_EraseRootFromParent_Done,
     /* 2330623 */ // Label 32339: @2330623
     /* 2330623 */ GIM_Try, /*On fail goto*//*Label 32340*/ GIMT_Encode4(2330677), // Rule ID 58578 //
     /* 2330628 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode0),
     /* 2330631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330642 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330642 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330645 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330649 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330654 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2330659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330664 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330666 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330672 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330676 */   // GIR_Coverage, 58578,
     /* 2330676 */   GIR_EraseRootFromParent_Done,
     /* 2330677 */ // Label 32340: @2330677
     /* 2330677 */ GIM_Try, /*On fail goto*//*Label 32341*/ GIMT_Encode4(2330731), // Rule ID 58579 //
     /* 2330682 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF64_HwMode1),
     /* 2330685 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2330688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330692 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330696 */   // (uint_to_fp:{ *:[nxv8f64] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E32:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2330699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E32),
     /* 2330713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330718 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330720 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2330726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330729 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330730 */   // GIR_Coverage, 58579,
     /* 2330730 */   GIR_EraseRootFromParent_Done,
     /* 2330731 */ // Label 32341: @2330731
     /* 2330731 */ GIM_Reject,
     /* 2330732 */ // Label 32250: @2330732
     /* 2330732 */ GIM_Try, /*On fail goto*//*Label 32342*/ GIMT_Encode4(2330789), // Rule ID 58366 //
     /* 2330737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330751 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330763 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330765 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2330768 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330770 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330773 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330775 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330778 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330784 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330787 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330788 */   // GIR_Coverage, 58366,
     /* 2330788 */   GIR_EraseRootFromParent_Done,
     /* 2330789 */ // Label 32342: @2330789
     /* 2330789 */ GIM_Try, /*On fail goto*//*Label 32343*/ GIMT_Encode4(2330846), // Rule ID 58367 //
     /* 2330794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2330800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330808 */   // (uint_to_fp:{ *:[nxv16f16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330808 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330811 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330815 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330820 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M4_E16),
     /* 2330825 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330827 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330830 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2330835 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330838 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2330841 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330844 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330845 */   // GIR_Coverage, 58367,
     /* 2330845 */   GIR_EraseRootFromParent_Done,
     /* 2330846 */ // Label 32343: @2330846
     /* 2330846 */ GIM_Try, /*On fail goto*//*Label 32344*/ GIMT_Encode4(2330900), // Rule ID 58538 //
     /* 2330851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2330857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330865 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330877 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2330882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330884 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330887 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330895 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330898 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330899 */   // GIR_Coverage, 58538,
     /* 2330899 */   GIR_EraseRootFromParent_Done,
     /* 2330900 */ // Label 32344: @2330900
     /* 2330900 */ GIM_Try, /*On fail goto*//*Label 32345*/ GIMT_Encode4(2330954), // Rule ID 58539 //
     /* 2330905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2330908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2330911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2330919 */   // (uint_to_fp:{ *:[nxv16f16] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M2_E8:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2330919 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330922 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330926 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330931 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M2_E8),
     /* 2330936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330941 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330943 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2330946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2330952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2330953 */   // GIR_Coverage, 58539,
     /* 2330953 */   GIR_EraseRootFromParent_Done,
     /* 2330954 */ // Label 32345: @2330954
     /* 2330954 */ GIM_Try, /*On fail goto*//*Label 32346*/ GIMT_Encode4(2331011), // Rule ID 58746 //
     /* 2330959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2330962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2330965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2330969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2330973 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2330973 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2330976 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2330980 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2330985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2330987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2330990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2330992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2330995 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2330997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331006 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331009 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331010 */   // GIR_Coverage, 58746,
     /* 2331010 */   GIR_EraseRootFromParent_Done,
     /* 2331011 */ // Label 32346: @2331011
     /* 2331011 */ GIM_Try, /*On fail goto*//*Label 32347*/ GIMT_Encode4(2331068), // Rule ID 58747 //
     /* 2331016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331030 */   // (uint_to_fp:{ *:[nxv16f16] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFNCVT_F_XU_W_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2331033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331042 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNCVT_F_XU_W_M4_E16),
     /* 2331047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331052 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331057 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331066 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331067 */   // GIR_Coverage, 58747,
     /* 2331067 */   GIR_EraseRootFromParent_Done,
     /* 2331068 */ // Label 32347: @2331068
     /* 2331068 */ GIM_Reject,
     /* 2331069 */ // Label 32251: @2331069
     /* 2331069 */ GIM_Try, /*On fail goto*//*Label 32348*/ GIMT_Encode4(2331126), // Rule ID 58382 //
     /* 2331074 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331088 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2331105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331110 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331112 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331115 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331124 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331125 */   // GIR_Coverage, 58382,
     /* 2331125 */   GIR_EraseRootFromParent_Done,
     /* 2331126 */ // Label 32348: @2331126
     /* 2331126 */ GIM_Try, /*On fail goto*//*Label 32349*/ GIMT_Encode4(2331183), // Rule ID 58383 //
     /* 2331131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2331137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331141 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331145 */   // (uint_to_fp:{ *:[nxv16f32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16i32] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E32),
     /* 2331162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331164 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331167 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331169 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331172 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331175 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2331178 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331181 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331182 */   // GIR_Coverage, 58383,
     /* 2331182 */   GIR_EraseRootFromParent_Done,
     /* 2331183 */ // Label 32349: @2331183
     /* 2331183 */ GIM_Try, /*On fail goto*//*Label 32350*/ GIMT_Encode4(2331237), // Rule ID 58562 //
     /* 2331188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode0),
     /* 2331191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331202 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331202 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331205 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331209 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2331219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331221 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331224 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331229 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331235 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331236 */   // GIR_Coverage, 58562,
     /* 2331236 */   GIR_EraseRootFromParent_Done,
     /* 2331237 */ // Label 32350: @2331237
     /* 2331237 */ GIM_Try, /*On fail goto*//*Label 32351*/ GIMT_Encode4(2331291), // Rule ID 58563 //
     /* 2331242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsAnyF_HwMode1),
     /* 2331245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2331248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331256 */   // (uint_to_fp:{ *:[nxv16f32] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E16:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331256 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2331259 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331263 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E16),
     /* 2331273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331275 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331278 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331280 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331289 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331290 */   // GIR_Coverage, 58563,
     /* 2331290 */   GIR_EraseRootFromParent_Done,
     /* 2331291 */ // Label 32351: @2331291
     /* 2331291 */ GIM_Reject,
     /* 2331292 */ // Label 32252: @2331292
     /* 2331292 */ GIM_Try, /*On fail goto*//*Label 32352*/ GIMT_Encode4(2331349), // Rule ID 58370 //
     /* 2331297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331311 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331311 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331314 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331318 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2331328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331333 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331338 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331341 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331347 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331348 */   // GIR_Coverage, 58370,
     /* 2331348 */   GIR_EraseRootFromParent_Done,
     /* 2331349 */ // Label 32352: @2331349
     /* 2331349 */ GIM_Try, /*On fail goto*//*Label 32353*/ GIMT_Encode4(2331406), // Rule ID 58371 //
     /* 2331354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2331360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331364 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331368 */   // (uint_to_fp:{ *:[nxv32f16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVFCVT_F_XU_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32i16] }:$rs1, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331368 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331371 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331375 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFCVT_F_XU_V_M8_E16),
     /* 2331385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331390 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2331395 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331398 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331404 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331405 */   // GIR_Coverage, 58371,
     /* 2331405 */   GIR_EraseRootFromParent_Done,
     /* 2331406 */ // Label 32353: @2331406
     /* 2331406 */ GIM_Try, /*On fail goto*//*Label 32354*/ GIMT_Encode4(2331460), // Rule ID 58542 //
     /* 2331411 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode0),
     /* 2331414 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2331417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331425 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331425 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331428 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331432 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331437 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2331442 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331447 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331452 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331455 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331458 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331459 */   // GIR_Coverage, 58542,
     /* 2331459 */   GIR_EraseRootFromParent_Done,
     /* 2331460 */ // Label 32354: @2331460
     /* 2331460 */ GIM_Try, /*On fail goto*//*Label 32355*/ GIMT_Encode4(2331514), // Rule ID 58543 //
     /* 2331465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HasVInstructionsF16_HwMode1),
     /* 2331468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2331471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2331475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2331479 */   // (uint_to_fp:{ *:[nxv32f16] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVFWCVT_F_XU_V_M4_E8:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331479 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2331482 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331486 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFWCVT_F_XU_V_M4_E8),
     /* 2331496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331501 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331509 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331512 */   GIR_RootConstrainSelectedInstOperands,
     /* 2331513 */   // GIR_Coverage, 58543,
     /* 2331513 */   GIR_EraseRootFromParent_Done,
     /* 2331514 */ // Label 32355: @2331514
     /* 2331514 */ GIM_Reject,
     /* 2331515 */ // Label 32253: @2331515
     /* 2331515 */ GIM_Reject,
     /* 2331516 */ // Label 71: @2331516
     /* 2331516 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32374*/ GIMT_Encode4(2333486),
     /* 2331527 */ /*GILLT_s16*//*Label 32356*/ GIMT_Encode4(2331647),
     /* 2331531 */ /*GILLT_s32*//*Label 32357*/ GIMT_Encode4(2331711),
     /* 2331535 */ /*GILLT_s64*//*Label 32358*/ GIMT_Encode4(2331775), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331547 */ /*GILLT_nxv1s16*//*Label 32359*/ GIMT_Encode4(2331866),
     /* 2331551 */ /*GILLT_nxv1s32*//*Label 32360*/ GIMT_Encode4(2331974),
     /* 2331555 */ /*GILLT_nxv1s64*//*Label 32361*/ GIMT_Encode4(2332082), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331567 */ /*GILLT_nxv2s16*//*Label 32362*/ GIMT_Encode4(2332190),
     /* 2331571 */ /*GILLT_nxv2s32*//*Label 32363*/ GIMT_Encode4(2332298),
     /* 2331575 */ /*GILLT_nxv2s64*//*Label 32364*/ GIMT_Encode4(2332406), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331587 */ /*GILLT_nxv4s16*//*Label 32365*/ GIMT_Encode4(2332514),
     /* 2331591 */ /*GILLT_nxv4s32*//*Label 32366*/ GIMT_Encode4(2332622),
     /* 2331595 */ /*GILLT_nxv4s64*//*Label 32367*/ GIMT_Encode4(2332730), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331607 */ /*GILLT_nxv8s16*//*Label 32368*/ GIMT_Encode4(2332838),
     /* 2331611 */ /*GILLT_nxv8s32*//*Label 32369*/ GIMT_Encode4(2332946),
     /* 2331615 */ /*GILLT_nxv8s64*//*Label 32370*/ GIMT_Encode4(2333054), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331627 */ /*GILLT_nxv16s16*//*Label 32371*/ GIMT_Encode4(2333162),
     /* 2331631 */ /*GILLT_nxv16s32*//*Label 32372*/ GIMT_Encode4(2333270), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2331643 */ /*GILLT_nxv32s16*//*Label 32373*/ GIMT_Encode4(2333378),
     /* 2331647 */ // Label 32356: @2331647
     /* 2331647 */ GIM_Try, /*On fail goto*//*Label 32375*/ GIMT_Encode4(2331710),
     /* 2331652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2331655 */   GIM_Try, /*On fail goto*//*Label 32376*/ GIMT_Encode4(2331682), // Rule ID 1883 //
     /* 2331660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2331663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331667 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2331671 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSGNJX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2331671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H),
     /* 2331674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331680 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331681 */     // GIR_Coverage, 1883,
     /* 2331681 */     GIR_EraseRootFromParent_Done,
     /* 2331682 */   // Label 32376: @2331682
     /* 2331682 */   GIM_Try, /*On fail goto*//*Label 32377*/ GIMT_Encode4(2331709), // Rule ID 1916 //
     /* 2331687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2331690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2331698 */     // (fabs:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSGNJX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2331698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_H_INX),
     /* 2331701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331708 */     // GIR_Coverage, 1916,
     /* 2331708 */     GIR_EraseRootFromParent_Done,
     /* 2331709 */   // Label 32377: @2331709
     /* 2331709 */   GIM_Reject,
     /* 2331710 */ // Label 32375: @2331710
     /* 2331710 */ GIM_Reject,
     /* 2331711 */ // Label 32357: @2331711
     /* 2331711 */ GIM_Try, /*On fail goto*//*Label 32378*/ GIMT_Encode4(2331774),
     /* 2331716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2331719 */   GIM_Try, /*On fail goto*//*Label 32379*/ GIMT_Encode4(2331746), // Rule ID 1174 //
     /* 2331724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2331727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2331735 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSGNJX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2331735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S),
     /* 2331738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331740 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331745 */     // GIR_Coverage, 1174,
     /* 2331745 */     GIR_EraseRootFromParent_Done,
     /* 2331746 */   // Label 32379: @2331746
     /* 2331746 */   GIM_Try, /*On fail goto*//*Label 32380*/ GIMT_Encode4(2331773), // Rule ID 1182 //
     /* 2331751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2331754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2331762 */     // (fabs:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSGNJX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2331762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_S_INX),
     /* 2331765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331772 */     // GIR_Coverage, 1182,
     /* 2331772 */     GIR_EraseRootFromParent_Done,
     /* 2331773 */   // Label 32380: @2331773
     /* 2331773 */   GIM_Reject,
     /* 2331774 */ // Label 32378: @2331774
     /* 2331774 */ GIM_Reject,
     /* 2331775 */ // Label 32358: @2331775
     /* 2331775 */ GIM_Try, /*On fail goto*//*Label 32381*/ GIMT_Encode4(2331865),
     /* 2331780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2331783 */   GIM_Try, /*On fail goto*//*Label 32382*/ GIMT_Encode4(2331810), // Rule ID 1517 //
     /* 2331788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2331791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2331799 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSGNJX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2331799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D),
     /* 2331802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331809 */     // GIR_Coverage, 1517,
     /* 2331809 */     GIR_EraseRootFromParent_Done,
     /* 2331810 */   // Label 32382: @2331810
     /* 2331810 */   GIM_Try, /*On fail goto*//*Label 32383*/ GIMT_Encode4(2331837), // Rule ID 1550 //
     /* 2331815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2331818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2331826 */     // (fabs:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2331826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_INX),
     /* 2331829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331836 */     // GIR_Coverage, 1550,
     /* 2331836 */     GIR_EraseRootFromParent_Done,
     /* 2331837 */   // Label 32383: @2331837
     /* 2331837 */   GIM_Try, /*On fail goto*//*Label 32384*/ GIMT_Encode4(2331864), // Rule ID 1572 //
     /* 2331842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2331845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2331853 */     // (fabs:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSGNJX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2331853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJX_D_IN32X),
     /* 2331856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2331862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331863 */     // GIR_Coverage, 1572,
     /* 2331863 */     GIR_EraseRootFromParent_Done,
     /* 2331864 */   // Label 32384: @2331864
     /* 2331864 */   GIM_Reject,
     /* 2331865 */ // Label 32381: @2331865
     /* 2331865 */ GIM_Reject,
     /* 2331866 */ // Label 32359: @2331866
     /* 2331866 */ GIM_Try, /*On fail goto*//*Label 32385*/ GIMT_Encode4(2331973),
     /* 2331871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2331874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331882 */   GIM_Try, /*On fail goto*//*Label 32386*/ GIMT_Encode4(2331927), // Rule ID 56114 //
     /* 2331887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2331890 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2331907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2331914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2331916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331926 */     // GIR_Coverage, 56114,
     /* 2331926 */     GIR_EraseRootFromParent_Done,
     /* 2331927 */   // Label 32386: @2331927
     /* 2331927 */   GIM_Try, /*On fail goto*//*Label 32387*/ GIMT_Encode4(2331972), // Rule ID 56115 //
     /* 2331932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2331935 */     // (fabs:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs, VR:{ *:[nxv1f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2331935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2331938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2331942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2331947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2331949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF4_E16),
     /* 2331952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2331954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2331957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2331959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2331961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2331964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2331967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2331970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2331971 */     // GIR_Coverage, 56115,
     /* 2331971 */     GIR_EraseRootFromParent_Done,
     /* 2331972 */   // Label 32387: @2331972
     /* 2331972 */   GIM_Reject,
     /* 2331973 */ // Label 32385: @2331973
     /* 2331973 */ GIM_Reject,
     /* 2331974 */ // Label 32360: @2331974
     /* 2331974 */ GIM_Try, /*On fail goto*//*Label 32388*/ GIMT_Encode4(2332081),
     /* 2331979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2331982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2331990 */   GIM_Try, /*On fail goto*//*Label 32389*/ GIMT_Encode4(2332035), // Rule ID 56154 //
     /* 2331995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2331998 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2331998 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332001 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332005 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2332015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332017 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332020 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332022 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332033 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332034 */     // GIR_Coverage, 56154,
     /* 2332034 */     GIR_EraseRootFromParent_Done,
     /* 2332035 */   // Label 32389: @2332035
     /* 2332035 */   GIM_Try, /*On fail goto*//*Label 32390*/ GIMT_Encode4(2332080), // Rule ID 56155 //
     /* 2332040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2332043 */     // (fabs:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs, VR:{ *:[nxv1f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2332046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E32),
     /* 2332060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332067 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332079 */     // GIR_Coverage, 56155,
     /* 2332079 */     GIR_EraseRootFromParent_Done,
     /* 2332080 */   // Label 32390: @2332080
     /* 2332080 */   GIM_Reject,
     /* 2332081 */ // Label 32388: @2332081
     /* 2332081 */ GIM_Reject,
     /* 2332082 */ // Label 32361: @2332082
     /* 2332082 */ GIM_Try, /*On fail goto*//*Label 32391*/ GIMT_Encode4(2332189),
     /* 2332087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2332090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332098 */   GIM_Try, /*On fail goto*//*Label 32392*/ GIMT_Encode4(2332143), // Rule ID 56214 //
     /* 2332103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2332106 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332106 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332109 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332113 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2332123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332128 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332142 */     // GIR_Coverage, 56214,
     /* 2332142 */     GIR_EraseRootFromParent_Done,
     /* 2332143 */   // Label 32392: @2332143
     /* 2332143 */   GIM_Try, /*On fail goto*//*Label 32393*/ GIMT_Encode4(2332188), // Rule ID 56215 //
     /* 2332148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2332151 */     // (fabs:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs, VR:{ *:[nxv1f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2332154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E64),
     /* 2332168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332170 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332187 */     // GIR_Coverage, 56215,
     /* 2332187 */     GIR_EraseRootFromParent_Done,
     /* 2332188 */   // Label 32393: @2332188
     /* 2332188 */   GIM_Reject,
     /* 2332189 */ // Label 32391: @2332189
     /* 2332189 */ GIM_Reject,
     /* 2332190 */ // Label 32362: @2332190
     /* 2332190 */ GIM_Try, /*On fail goto*//*Label 32394*/ GIMT_Encode4(2332297),
     /* 2332195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2332198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332206 */   GIM_Try, /*On fail goto*//*Label 32395*/ GIMT_Encode4(2332251), // Rule ID 56134 //
     /* 2332211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2332214 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2332231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332250 */     // GIR_Coverage, 56134,
     /* 2332250 */     GIR_EraseRootFromParent_Done,
     /* 2332251 */   // Label 32395: @2332251
     /* 2332251 */   GIM_Try, /*On fail goto*//*Label 32396*/ GIMT_Encode4(2332296), // Rule ID 56135 //
     /* 2332256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2332259 */     // (fabs:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs)  =>  (PseudoVFSGNJX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs, VR:{ *:[nxv2f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2332262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_MF2_E16),
     /* 2332276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332283 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332295 */     // GIR_Coverage, 56135,
     /* 2332295 */     GIR_EraseRootFromParent_Done,
     /* 2332296 */   // Label 32396: @2332296
     /* 2332296 */   GIM_Reject,
     /* 2332297 */ // Label 32394: @2332297
     /* 2332297 */ GIM_Reject,
     /* 2332298 */ // Label 32363: @2332298
     /* 2332298 */ GIM_Try, /*On fail goto*//*Label 32397*/ GIMT_Encode4(2332405),
     /* 2332303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2332306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332314 */   GIM_Try, /*On fail goto*//*Label 32398*/ GIMT_Encode4(2332359), // Rule ID 56194 //
     /* 2332319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2332322 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2332339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332358 */     // GIR_Coverage, 56194,
     /* 2332358 */     GIR_EraseRootFromParent_Done,
     /* 2332359 */   // Label 32398: @2332359
     /* 2332359 */   GIM_Try, /*On fail goto*//*Label 32399*/ GIMT_Encode4(2332404), // Rule ID 56195 //
     /* 2332364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2332367 */     // (fabs:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs, VR:{ *:[nxv2f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2332370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E32),
     /* 2332384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332389 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332403 */     // GIR_Coverage, 56195,
     /* 2332403 */     GIR_EraseRootFromParent_Done,
     /* 2332404 */   // Label 32399: @2332404
     /* 2332404 */   GIM_Reject,
     /* 2332405 */ // Label 32397: @2332405
     /* 2332405 */ GIM_Reject,
     /* 2332406 */ // Label 32364: @2332406
     /* 2332406 */ GIM_Try, /*On fail goto*//*Label 32400*/ GIMT_Encode4(2332513),
     /* 2332411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2332414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332422 */   GIM_Try, /*On fail goto*//*Label 32401*/ GIMT_Encode4(2332467), // Rule ID 56354 //
     /* 2332427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2332430 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2332433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2332447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332454 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332466 */     // GIR_Coverage, 56354,
     /* 2332466 */     GIR_EraseRootFromParent_Done,
     /* 2332467 */   // Label 32401: @2332467
     /* 2332467 */   GIM_Try, /*On fail goto*//*Label 32402*/ GIMT_Encode4(2332512), // Rule ID 56355 //
     /* 2332472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2332475 */     // (fabs:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs, VRM2:{ *:[nxv2f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2332478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E64),
     /* 2332492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332499 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332511 */     // GIR_Coverage, 56355,
     /* 2332511 */     GIR_EraseRootFromParent_Done,
     /* 2332512 */   // Label 32402: @2332512
     /* 2332512 */   GIM_Reject,
     /* 2332513 */ // Label 32400: @2332513
     /* 2332513 */ GIM_Reject,
     /* 2332514 */ // Label 32365: @2332514
     /* 2332514 */ GIM_Try, /*On fail goto*//*Label 32403*/ GIMT_Encode4(2332621),
     /* 2332519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2332522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2332530 */   GIM_Try, /*On fail goto*//*Label 32404*/ GIMT_Encode4(2332575), // Rule ID 56174 //
     /* 2332535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2332538 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2332555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332560 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332562 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332574 */     // GIR_Coverage, 56174,
     /* 2332574 */     GIR_EraseRootFromParent_Done,
     /* 2332575 */   // Label 32404: @2332575
     /* 2332575 */   GIM_Try, /*On fail goto*//*Label 32405*/ GIMT_Encode4(2332620), // Rule ID 56175 //
     /* 2332580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2332583 */     // (fabs:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs, VR:{ *:[nxv4f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2332586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M1_E16),
     /* 2332600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332619 */     // GIR_Coverage, 56175,
     /* 2332619 */     GIR_EraseRootFromParent_Done,
     /* 2332620 */   // Label 32405: @2332620
     /* 2332620 */   GIM_Reject,
     /* 2332621 */ // Label 32403: @2332621
     /* 2332621 */ GIM_Reject,
     /* 2332622 */ // Label 32366: @2332622
     /* 2332622 */ GIM_Try, /*On fail goto*//*Label 32406*/ GIMT_Encode4(2332729),
     /* 2332627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2332630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332638 */   GIM_Try, /*On fail goto*//*Label 32407*/ GIMT_Encode4(2332683), // Rule ID 56294 //
     /* 2332643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2332646 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2332663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332681 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332682 */     // GIR_Coverage, 56294,
     /* 2332682 */     GIR_EraseRootFromParent_Done,
     /* 2332683 */   // Label 32407: @2332683
     /* 2332683 */   GIM_Try, /*On fail goto*//*Label 32408*/ GIMT_Encode4(2332728), // Rule ID 56295 //
     /* 2332688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2332691 */     // (fabs:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs, VRM2:{ *:[nxv4f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2332694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E32),
     /* 2332708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2332723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332727 */     // GIR_Coverage, 56295,
     /* 2332727 */     GIR_EraseRootFromParent_Done,
     /* 2332728 */   // Label 32408: @2332728
     /* 2332728 */   GIM_Reject,
     /* 2332729 */ // Label 32406: @2332729
     /* 2332729 */ GIM_Reject,
     /* 2332730 */ // Label 32367: @2332730
     /* 2332730 */ GIM_Try, /*On fail goto*//*Label 32409*/ GIMT_Encode4(2332837),
     /* 2332735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2332738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332746 */   GIM_Try, /*On fail goto*//*Label 32410*/ GIMT_Encode4(2332791), // Rule ID 56374 //
     /* 2332751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2332754 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2332771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332790 */     // GIR_Coverage, 56374,
     /* 2332790 */     GIR_EraseRootFromParent_Done,
     /* 2332791 */   // Label 32410: @2332791
     /* 2332791 */   GIM_Try, /*On fail goto*//*Label 32411*/ GIMT_Encode4(2332836), // Rule ID 56375 //
     /* 2332796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2332799 */     // (fabs:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs, VRM4:{ *:[nxv4f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2332802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E64),
     /* 2332816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2332831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332835 */     // GIR_Coverage, 56375,
     /* 2332835 */     GIR_EraseRootFromParent_Done,
     /* 2332836 */   // Label 32411: @2332836
     /* 2332836 */   GIM_Reject,
     /* 2332837 */ // Label 32409: @2332837
     /* 2332837 */ GIM_Reject,
     /* 2332838 */ // Label 32368: @2332838
     /* 2332838 */ GIM_Try, /*On fail goto*//*Label 32412*/ GIMT_Encode4(2332945),
     /* 2332843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2332846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2332854 */   GIM_Try, /*On fail goto*//*Label 32413*/ GIMT_Encode4(2332899), // Rule ID 56234 //
     /* 2332859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2332862 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2332879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332898 */     // GIR_Coverage, 56234,
     /* 2332898 */     GIR_EraseRootFromParent_Done,
     /* 2332899 */   // Label 32413: @2332899
     /* 2332899 */   GIM_Try, /*On fail goto*//*Label 32414*/ GIMT_Encode4(2332944), // Rule ID 56235 //
     /* 2332904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2332907 */     // (fabs:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs, VRM2:{ *:[nxv8f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2332907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2332910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M2_E16),
     /* 2332924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2332939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2332942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2332943 */     // GIR_Coverage, 56235,
     /* 2332943 */     GIR_EraseRootFromParent_Done,
     /* 2332944 */   // Label 32414: @2332944
     /* 2332944 */   GIM_Reject,
     /* 2332945 */ // Label 32412: @2332945
     /* 2332945 */ GIM_Reject,
     /* 2332946 */ // Label 32369: @2332946
     /* 2332946 */ GIM_Try, /*On fail goto*//*Label 32415*/ GIMT_Encode4(2333053),
     /* 2332951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2332954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2332962 */   GIM_Try, /*On fail goto*//*Label 32416*/ GIMT_Encode4(2333007), // Rule ID 56314 //
     /* 2332967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2332970 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2332970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2332973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2332977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2332982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2332984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2332987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2332989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2332992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2332996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2332999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333006 */     // GIR_Coverage, 56314,
     /* 2333006 */     GIR_EraseRootFromParent_Done,
     /* 2333007 */   // Label 32416: @2333007
     /* 2333007 */   GIM_Try, /*On fail goto*//*Label 32417*/ GIMT_Encode4(2333052), // Rule ID 56315 //
     /* 2333012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2333015 */     // (fabs:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs, VRM4:{ *:[nxv8f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2333018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E32),
     /* 2333032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333039 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333051 */     // GIR_Coverage, 56315,
     /* 2333051 */     GIR_EraseRootFromParent_Done,
     /* 2333052 */   // Label 32417: @2333052
     /* 2333052 */   GIM_Reject,
     /* 2333053 */ // Label 32415: @2333053
     /* 2333053 */ GIM_Reject,
     /* 2333054 */ // Label 32370: @2333054
     /* 2333054 */ GIM_Try, /*On fail goto*//*Label 32418*/ GIMT_Encode4(2333161),
     /* 2333059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2333062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333070 */   GIM_Try, /*On fail goto*//*Label 32419*/ GIMT_Encode4(2333115), // Rule ID 56394 //
     /* 2333075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2333078 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2333081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2333095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333100 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333114 */     // GIR_Coverage, 56394,
     /* 2333114 */     GIR_EraseRootFromParent_Done,
     /* 2333115 */   // Label 32419: @2333115
     /* 2333115 */   GIM_Try, /*On fail goto*//*Label 32420*/ GIMT_Encode4(2333160), // Rule ID 56395 //
     /* 2333120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2333123 */     // (fabs:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs, VRM8:{ *:[nxv8f64] }:$rs, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2333126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E64),
     /* 2333140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2333155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333158 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333159 */     // GIR_Coverage, 56395,
     /* 2333159 */     GIR_EraseRootFromParent_Done,
     /* 2333160 */   // Label 32420: @2333160
     /* 2333160 */   GIM_Reject,
     /* 2333161 */ // Label 32418: @2333161
     /* 2333161 */ GIM_Reject,
     /* 2333162 */ // Label 32371: @2333162
     /* 2333162 */ GIM_Try, /*On fail goto*//*Label 32421*/ GIMT_Encode4(2333269),
     /* 2333167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2333170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2333178 */   GIM_Try, /*On fail goto*//*Label 32422*/ GIMT_Encode4(2333223), // Rule ID 56254 //
     /* 2333183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2333186 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2333203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333205 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333208 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333221 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333222 */     // GIR_Coverage, 56254,
     /* 2333222 */     GIR_EraseRootFromParent_Done,
     /* 2333223 */   // Label 32422: @2333223
     /* 2333223 */   GIM_Try, /*On fail goto*//*Label 32423*/ GIMT_Encode4(2333268), // Rule ID 56255 //
     /* 2333228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2333231 */     // (fabs:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs, VRM4:{ *:[nxv16f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2333234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M4_E16),
     /* 2333248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333250 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333266 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333267 */     // GIR_Coverage, 56255,
     /* 2333267 */     GIR_EraseRootFromParent_Done,
     /* 2333268 */   // Label 32423: @2333268
     /* 2333268 */   GIM_Reject,
     /* 2333269 */ // Label 32421: @2333269
     /* 2333269 */ GIM_Reject,
     /* 2333270 */ // Label 32372: @2333270
     /* 2333270 */ GIM_Try, /*On fail goto*//*Label 32424*/ GIMT_Encode4(2333377),
     /* 2333275 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2333278 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333282 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333286 */   GIM_Try, /*On fail goto*//*Label 32425*/ GIMT_Encode4(2333331), // Rule ID 56334 //
     /* 2333291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2333294 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2333311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333318 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333330 */     // GIR_Coverage, 56334,
     /* 2333330 */     GIR_EraseRootFromParent_Done,
     /* 2333331 */   // Label 32425: @2333331
     /* 2333331 */   GIM_Try, /*On fail goto*//*Label 32426*/ GIMT_Encode4(2333376), // Rule ID 56335 //
     /* 2333336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2333339 */     // (fabs:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs, VRM8:{ *:[nxv16f32] }:$rs, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2333342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E32),
     /* 2333356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2333371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333374 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333375 */     // GIR_Coverage, 56335,
     /* 2333375 */     GIR_EraseRootFromParent_Done,
     /* 2333376 */   // Label 32426: @2333376
     /* 2333376 */   GIM_Reject,
     /* 2333377 */ // Label 32424: @2333377
     /* 2333377 */ GIM_Reject,
     /* 2333378 */ // Label 32373: @2333378
     /* 2333378 */ GIM_Try, /*On fail goto*//*Label 32427*/ GIMT_Encode4(2333485),
     /* 2333383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2333386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2333394 */   GIM_Try, /*On fail goto*//*Label 32428*/ GIMT_Encode4(2333439), // Rule ID 56274 //
     /* 2333399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2333402 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2333402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2333405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333414 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2333419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333424 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333438 */     // GIR_Coverage, 56274,
     /* 2333438 */     GIR_EraseRootFromParent_Done,
     /* 2333439 */   // Label 32428: @2333439
     /* 2333439 */   GIM_Try, /*On fail goto*//*Label 32429*/ GIMT_Encode4(2333484), // Rule ID 56275 //
     /* 2333444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2333447 */     // (fabs:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs)  =>  (PseudoVFSGNJX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs, VRM8:{ *:[nxv32f16] }:$rs, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2333447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2333450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2333454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJX_VV_M8_E16),
     /* 2333464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2333473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2333476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2333479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2333482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333483 */     // GIR_Coverage, 56275,
     /* 2333483 */     GIR_EraseRootFromParent_Done,
     /* 2333484 */   // Label 32429: @2333484
     /* 2333484 */   GIM_Reject,
     /* 2333485 */ // Label 32427: @2333485
     /* 2333485 */ GIM_Reject,
     /* 2333486 */ // Label 32374: @2333486
     /* 2333486 */ GIM_Reject,
     /* 2333487 */ // Label 72: @2333487
     /* 2333487 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32448*/ GIMT_Encode4(2339548),
     /* 2333498 */ /*GILLT_s16*//*Label 32430*/ GIMT_Encode4(2333618),
     /* 2333502 */ /*GILLT_s32*//*Label 32431*/ GIMT_Encode4(2334294),
     /* 2333506 */ /*GILLT_s64*//*Label 32432*/ GIMT_Encode4(2334970), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333518 */ /*GILLT_nxv1s16*//*Label 32433*/ GIMT_Encode4(2335783),
     /* 2333522 */ /*GILLT_nxv1s32*//*Label 32434*/ GIMT_Encode4(2336034),
     /* 2333526 */ /*GILLT_nxv1s64*//*Label 32435*/ GIMT_Encode4(2336285), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333538 */ /*GILLT_nxv2s16*//*Label 32436*/ GIMT_Encode4(2336536),
     /* 2333542 */ /*GILLT_nxv2s32*//*Label 32437*/ GIMT_Encode4(2336787),
     /* 2333546 */ /*GILLT_nxv2s64*//*Label 32438*/ GIMT_Encode4(2337038), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333558 */ /*GILLT_nxv4s16*//*Label 32439*/ GIMT_Encode4(2337289),
     /* 2333562 */ /*GILLT_nxv4s32*//*Label 32440*/ GIMT_Encode4(2337540),
     /* 2333566 */ /*GILLT_nxv4s64*//*Label 32441*/ GIMT_Encode4(2337791), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333578 */ /*GILLT_nxv8s16*//*Label 32442*/ GIMT_Encode4(2338042),
     /* 2333582 */ /*GILLT_nxv8s32*//*Label 32443*/ GIMT_Encode4(2338293),
     /* 2333586 */ /*GILLT_nxv8s64*//*Label 32444*/ GIMT_Encode4(2338544), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333598 */ /*GILLT_nxv16s16*//*Label 32445*/ GIMT_Encode4(2338795),
     /* 2333602 */ /*GILLT_nxv16s32*//*Label 32446*/ GIMT_Encode4(2339046), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2333614 */ /*GILLT_nxv32s16*//*Label 32447*/ GIMT_Encode4(2339297),
     /* 2333618 */ // Label 32430: @2333618
     /* 2333618 */ GIM_Try, /*On fail goto*//*Label 32449*/ GIMT_Encode4(2334293),
     /* 2333623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333626 */   GIM_Try, /*On fail goto*//*Label 32450*/ GIMT_Encode4(2333677), // Rule ID 1888 //
     /* 2333631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2333634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2333637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2333649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2333653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2333664 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs2))  =>  (FSGNJN_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)
     /* 2333664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H),
     /* 2333667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2333675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333676 */     // GIR_Coverage, 1888,
     /* 2333676 */     GIR_EraseRootFromParent_Done,
     /* 2333677 */   // Label 32450: @2333677
     /* 2333677 */   GIM_Try, /*On fail goto*//*Label 32451*/ GIMT_Encode4(2333728), // Rule ID 1921 //
     /* 2333682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2333685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2333688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2333700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2333704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2333708 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2333715 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2))  =>  (FSGNJN_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)
     /* 2333715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_H_INX),
     /* 2333718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2333726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333727 */     // GIR_Coverage, 1921,
     /* 2333727 */     GIR_EraseRootFromParent_Done,
     /* 2333728 */   // Label 32451: @2333728
     /* 2333728 */   GIM_Try, /*On fail goto*//*Label 32452*/ GIMT_Encode4(2333758), // Rule ID 1886 //
     /* 2333733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2333736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2333739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333751 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2333751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2333756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333757 */     // GIR_Coverage, 1886,
     /* 2333757 */     GIR_Done,
     /* 2333758 */   // Label 32452: @2333758
     /* 2333758 */   GIM_Try, /*On fail goto*//*Label 32453*/ GIMT_Encode4(2333814), // Rule ID 1889 //
     /* 2333763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2333766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2333769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2333781 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2333781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2333784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2333788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333793 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2333797 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2333800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2333805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333812 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333813 */     // GIR_Coverage, 1889,
     /* 2333813 */     GIR_EraseRootFromParent_Done,
     /* 2333814 */   // Label 32453: @2333814
     /* 2333814 */   GIM_Try, /*On fail goto*//*Label 32454*/ GIMT_Encode4(2333870), // Rule ID 1890 //
     /* 2333819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2333822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2333825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2333833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2333837 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2333837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2333840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S),
     /* 2333844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2333853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2333856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2333861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333868 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333869 */     // GIR_Coverage, 1890,
     /* 2333869 */     GIR_EraseRootFromParent_Done,
     /* 2333870 */   // Label 32454: @2333870
     /* 2333870 */   GIM_Try, /*On fail goto*//*Label 32455*/ GIMT_Encode4(2333900), // Rule ID 1919 //
     /* 2333875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2333878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2333881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333893 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2333893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2333898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333899 */     // GIR_Coverage, 1919,
     /* 2333899 */     GIR_Done,
     /* 2333900 */   // Label 32455: @2333900
     /* 2333900 */   GIM_Try, /*On fail goto*//*Label 32456*/ GIMT_Encode4(2333956), // Rule ID 1922 //
     /* 2333905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2333908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2333911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2333923 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i64] }))
     /* 2333923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2333926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2333930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333935 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2333939 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2333942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2333944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2333947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2333949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2333951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2333954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2333955 */     // GIR_Coverage, 1922,
     /* 2333955 */     GIR_EraseRootFromParent_Done,
     /* 2333956 */   // Label 32456: @2333956
     /* 2333956 */   GIM_Try, /*On fail goto*//*Label 32457*/ GIMT_Encode4(2334012), // Rule ID 1923 //
     /* 2333961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2333964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2333967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2333975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2333979 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_S_INX:{ *:[f16] } ?:{ *:[f32] }:$rs2, 7:{ *:[i32] }))
     /* 2333979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2333982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_S_INX),
     /* 2333986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2333991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2333995 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2333998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2334003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334011 */     // GIR_Coverage, 1923,
     /* 2334011 */     GIR_EraseRootFromParent_Done,
     /* 2334012 */   // Label 32457: @2334012
     /* 2334012 */   GIM_Try, /*On fail goto*//*Label 32458*/ GIMT_Encode4(2334068), // Rule ID 2192 //
     /* 2334017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2334020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334035 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2334038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2334042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334047 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2334059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334066 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334067 */     // GIR_Coverage, 2192,
     /* 2334067 */     GIR_EraseRootFromParent_Done,
     /* 2334068 */   // Label 32458: @2334068
     /* 2334068 */   GIM_Try, /*On fail goto*//*Label 32459*/ GIMT_Encode4(2334124), // Rule ID 2193 //
     /* 2334073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2334076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334091 */     // (fcopysign:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2334091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2334094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D),
     /* 2334098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334103 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334107 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334110 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H),
     /* 2334115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334123 */     // GIR_Coverage, 2193,
     /* 2334123 */     GIR_EraseRootFromParent_Done,
     /* 2334124 */   // Label 32459: @2334124
     /* 2334124 */   GIM_Try, /*On fail goto*//*Label 32460*/ GIMT_Encode4(2334180), // Rule ID 2204 //
     /* 2334129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2334132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334147 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2334150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2334154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2334171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334173 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334178 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334179 */     // GIR_Coverage, 2204,
     /* 2334179 */     GIR_EraseRootFromParent_Done,
     /* 2334180 */   // Label 32460: @2334180
     /* 2334180 */   GIM_Try, /*On fail goto*//*Label 32461*/ GIMT_Encode4(2334236), // Rule ID 2205 //
     /* 2334185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2334188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334203 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_IN32X:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2334203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2334206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_IN32X),
     /* 2334210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334215 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334219 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2334227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334235 */     // GIR_Coverage, 2205,
     /* 2334235 */     GIR_EraseRootFromParent_Done,
     /* 2334236 */   // Label 32461: @2334236
     /* 2334236 */   GIM_Try, /*On fail goto*//*Label 32462*/ GIMT_Encode4(2334292), // Rule ID 2212 //
     /* 2334241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2334244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334259 */     // (fcopysign:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, (FCVT_H_D_INX:{ *:[f16] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 2334262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_H_D_INX),
     /* 2334266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334271 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334275 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334278 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_H_INX),
     /* 2334283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334285 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334291 */     // GIR_Coverage, 2212,
     /* 2334291 */     GIR_EraseRootFromParent_Done,
     /* 2334292 */   // Label 32462: @2334292
     /* 2334292 */   GIM_Reject,
     /* 2334293 */ // Label 32449: @2334293
     /* 2334293 */ GIM_Reject,
     /* 2334294 */ // Label 32431: @2334294
     /* 2334294 */ GIM_Try, /*On fail goto*//*Label 32463*/ GIMT_Encode4(2334969),
     /* 2334299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334302 */   GIM_Try, /*On fail goto*//*Label 32464*/ GIMT_Encode4(2334353), // Rule ID 1189 //
     /* 2334307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2334310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2334313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2334325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2334329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2334340 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs2))  =>  (FSGNJN_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)
     /* 2334340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S),
     /* 2334343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2334351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334352 */     // GIR_Coverage, 1189,
     /* 2334352 */     GIR_EraseRootFromParent_Done,
     /* 2334353 */   // Label 32464: @2334353
     /* 2334353 */   GIM_Try, /*On fail goto*//*Label 32465*/ GIMT_Encode4(2334404), // Rule ID 1210 //
     /* 2334358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2334361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2334364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2334376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2334380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2334384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2334391 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2))  =>  (FSGNJN_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)
     /* 2334391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_S_INX),
     /* 2334394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2334402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334403 */     // GIR_Coverage, 1210,
     /* 2334403 */     GIR_EraseRootFromParent_Done,
     /* 2334404 */   // Label 32465: @2334404
     /* 2334404 */   GIM_Try, /*On fail goto*//*Label 32466*/ GIMT_Encode4(2334434), // Rule ID 1185 //
     /* 2334409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2334412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2334415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334427 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2334427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2334432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334433 */     // GIR_Coverage, 1185,
     /* 2334433 */     GIR_Done,
     /* 2334434 */   // Label 32466: @2334434
     /* 2334434 */   GIM_Try, /*On fail goto*//*Label 32467*/ GIMT_Encode4(2334464), // Rule ID 1186 //
     /* 2334439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2334442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2334445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334457 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2334457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334463 */     // GIR_Coverage, 1186,
     /* 2334463 */     GIR_Done,
     /* 2334464 */   // Label 32467: @2334464
     /* 2334464 */   GIM_Try, /*On fail goto*//*Label 32468*/ GIMT_Encode4(2334520), // Rule ID 1525 //
     /* 2334469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2334472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334487 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2334494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2334511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334518 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334519 */     // GIR_Coverage, 1525,
     /* 2334519 */     GIR_EraseRootFromParent_Done,
     /* 2334520 */   // Label 32468: @2334520
     /* 2334520 */   GIM_Try, /*On fail goto*//*Label 32469*/ GIMT_Encode4(2334576), // Rule ID 1526 //
     /* 2334525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2334528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334543 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2334543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D),
     /* 2334550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2334567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334569 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334575 */     // GIR_Coverage, 1526,
     /* 2334575 */     GIR_EraseRootFromParent_Done,
     /* 2334576 */   // Label 32469: @2334576
     /* 2334576 */   GIM_Try, /*On fail goto*//*Label 32470*/ GIMT_Encode4(2334632), // Rule ID 1556 //
     /* 2334581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2334584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2334599 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_INX:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_INX),
     /* 2334606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334631 */     // GIR_Coverage, 1556,
     /* 2334631 */     GIR_EraseRootFromParent_Done,
     /* 2334632 */   // Label 32470: @2334632
     /* 2334632 */   GIM_Try, /*On fail goto*//*Label 32471*/ GIMT_Encode4(2334688), // Rule ID 1580 //
     /* 2334637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2334640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334655 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i64] }))
     /* 2334655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2334662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334667 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334671 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334681 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334687 */     // GIR_Coverage, 1580,
     /* 2334687 */     GIR_EraseRootFromParent_Done,
     /* 2334688 */   // Label 32471: @2334688
     /* 2334688 */   GIM_Try, /*On fail goto*//*Label 32472*/ GIMT_Encode4(2334744), // Rule ID 1581 //
     /* 2334693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2334696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2334711 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_D_IN32X:{ *:[f32] } ?:{ *:[f64] }:$rs2, 7:{ *:[i32] }))
     /* 2334711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_D_IN32X),
     /* 2334718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334723 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334727 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/7,
     /* 2334730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334737 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334743 */     // GIR_Coverage, 1581,
     /* 2334743 */     GIR_EraseRootFromParent_Done,
     /* 2334744 */   // Label 32472: @2334744
     /* 2334744 */   GIM_Try, /*On fail goto*//*Label 32473*/ GIMT_Encode4(2334800), // Rule ID 2064 //
     /* 2334749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode0),
     /* 2334752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2334755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334759 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334767 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2334767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2334774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334783 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2334786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2334791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334799 */     // GIR_Coverage, 2064,
     /* 2334799 */     GIR_EraseRootFromParent_Done,
     /* 2334800 */   // Label 32473: @2334800
     /* 2334800 */   GIM_Try, /*On fail goto*//*Label 32474*/ GIMT_Encode4(2334856), // Rule ID 2065 //
     /* 2334805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfhmin_HwMode1),
     /* 2334808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2334811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2334819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2334823 */     // (fcopysign:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2334823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H),
     /* 2334830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2334842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S),
     /* 2334847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334849 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334855 */     // GIR_Coverage, 2065,
     /* 2334855 */     GIR_EraseRootFromParent_Done,
     /* 2334856 */   // Label 32474: @2334856
     /* 2334856 */   GIM_Try, /*On fail goto*//*Label 32475*/ GIMT_Encode4(2334912), // Rule ID 2078 //
     /* 2334861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode0),
     /* 2334864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2334867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334879 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2334879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2334886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334891 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334895 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2334898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334905 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334911 */     // GIR_Coverage, 2078,
     /* 2334911 */     GIR_EraseRootFromParent_Done,
     /* 2334912 */   // Label 32475: @2334912
     /* 2334912 */   GIM_Try, /*On fail goto*//*Label 32476*/ GIMT_Encode4(2334968), // Rule ID 2079 //
     /* 2334917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinxmin_HwMode1),
     /* 2334920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2334923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2334931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2334935 */     // (fcopysign:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, (FCVT_S_H_INX:{ *:[f32] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2334935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 2334938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_S_H_INX),
     /* 2334942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2334947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2334951 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2334954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2334956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_S_INX),
     /* 2334959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2334961 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2334963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2334966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2334967 */     // GIR_Coverage, 2079,
     /* 2334967 */     GIR_EraseRootFromParent_Done,
     /* 2334968 */   // Label 32476: @2334968
     /* 2334968 */   GIM_Reject,
     /* 2334969 */ // Label 32463: @2334969
     /* 2334969 */ GIM_Reject,
     /* 2334970 */ // Label 32432: @2334970
     /* 2334970 */ GIM_Try, /*On fail goto*//*Label 32477*/ GIMT_Encode4(2335782),
     /* 2334975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2334978 */   GIM_Try, /*On fail goto*//*Label 32478*/ GIMT_Encode4(2335029), // Rule ID 1522 //
     /* 2334983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2334986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2334989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334993 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2334997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2335001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2335005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2335009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2335016 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs2))  =>  (FSGNJN_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)
     /* 2335016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D),
     /* 2335019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2335027 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335028 */     // GIR_Coverage, 1522,
     /* 2335028 */     GIR_EraseRootFromParent_Done,
     /* 2335029 */   // Label 32478: @2335029
     /* 2335029 */   GIM_Try, /*On fail goto*//*Label 32479*/ GIMT_Encode4(2335080), // Rule ID 1554 //
     /* 2335034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2335037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2335040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2335052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2335056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2335060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2335067 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)
     /* 2335067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_INX),
     /* 2335070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2335078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335079 */     // GIR_Coverage, 1554,
     /* 2335079 */     GIR_EraseRootFromParent_Done,
     /* 2335080 */   // Label 32479: @2335080
     /* 2335080 */   GIM_Try, /*On fail goto*//*Label 32480*/ GIMT_Encode4(2335131), // Rule ID 1577 //
     /* 2335085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2335088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2335091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2335103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2335107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2335111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2335118 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2))  =>  (FSGNJN_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)
     /* 2335118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJN_D_IN32X),
     /* 2335121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335123 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2335129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335130 */     // GIR_Coverage, 1577,
     /* 2335130 */     GIR_EraseRootFromParent_Done,
     /* 2335131 */   // Label 32480: @2335131
     /* 2335131 */   GIM_Try, /*On fail goto*//*Label 32481*/ GIMT_Encode4(2335161), // Rule ID 1520 //
     /* 2335136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2335139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2335142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335154 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2335154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2335159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335160 */     // GIR_Coverage, 1520,
     /* 2335160 */     GIR_Done,
     /* 2335161 */   // Label 32481: @2335161
     /* 2335161 */   GIM_Try, /*On fail goto*//*Label 32482*/ GIMT_Encode4(2335217), // Rule ID 1523 //
     /* 2335166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2335169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2335172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2335184 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2335184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2335191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335196 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335200 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335203 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2335208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335216 */     // GIR_Coverage, 1523,
     /* 2335216 */     GIR_EraseRootFromParent_Done,
     /* 2335217 */   // Label 32482: @2335217
     /* 2335217 */   GIM_Try, /*On fail goto*//*Label 32483*/ GIMT_Encode4(2335273), // Rule ID 1524 //
     /* 2335222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2335225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2335228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2335240 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2335240 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335243 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S),
     /* 2335247 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335252 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335256 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2335264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335272 */     // GIR_Coverage, 1524,
     /* 2335272 */     GIR_EraseRootFromParent_Done,
     /* 2335273 */   // Label 32483: @2335273
     /* 2335273 */   GIM_Try, /*On fail goto*//*Label 32484*/ GIMT_Encode4(2335303), // Rule ID 1552 //
     /* 2335278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2335281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2335284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335296 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2335296 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2335301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335302 */     // GIR_Coverage, 1552,
     /* 2335302 */     GIR_Done,
     /* 2335303 */   // Label 32484: @2335303
     /* 2335303 */   GIM_Try, /*On fail goto*//*Label 32485*/ GIMT_Encode4(2335359), // Rule ID 1555 //
     /* 2335308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2335311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2335314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2335326 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_INX:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2335326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_INX),
     /* 2335333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335338 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335342 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2335350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335357 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335358 */     // GIR_Coverage, 1555,
     /* 2335358 */     GIR_EraseRootFromParent_Done,
     /* 2335359 */   // Label 32485: @2335359
     /* 2335359 */   GIM_Try, /*On fail goto*//*Label 32486*/ GIMT_Encode4(2335389), // Rule ID 1575 //
     /* 2335364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2335367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2335370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335382 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2335382 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2335387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335388 */     // GIR_Coverage, 1575,
     /* 2335388 */     GIR_Done,
     /* 2335389 */   // Label 32486: @2335389
     /* 2335389 */   GIM_Try, /*On fail goto*//*Label 32487*/ GIMT_Encode4(2335445), // Rule ID 1578 //
     /* 2335394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2335397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2335400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2335412 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i64] }))
     /* 2335412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2335419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335424 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335428 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2335436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335444 */     // GIR_Coverage, 1578,
     /* 2335444 */     GIR_EraseRootFromParent_Done,
     /* 2335445 */   // Label 32487: @2335445
     /* 2335445 */   GIM_Try, /*On fail goto*//*Label 32488*/ GIMT_Encode4(2335501), // Rule ID 1579 //
     /* 2335450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2335453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2335456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2335468 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_S_IN32X:{ *:[f64] } ?:{ *:[f32] }:$rs2, 0:{ *:[i32] }))
     /* 2335468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_S_IN32X),
     /* 2335475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335480 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335484 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2335492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335496 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335500 */     // GIR_Coverage, 1579,
     /* 2335500 */     GIR_EraseRootFromParent_Done,
     /* 2335501 */   // Label 32488: @2335501
     /* 2335501 */   GIM_Try, /*On fail goto*//*Label 32489*/ GIMT_Encode4(2335557), // Rule ID 2194 //
     /* 2335506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode0),
     /* 2335509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2335512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2335524 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2335524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2335531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2335548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335550 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335556 */     // GIR_Coverage, 2194,
     /* 2335556 */     GIR_EraseRootFromParent_Done,
     /* 2335557 */   // Label 32489: @2335557
     /* 2335557 */   GIM_Try, /*On fail goto*//*Label 32490*/ GIMT_Encode4(2335613), // Rule ID 2195 //
     /* 2335562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfhmin_HwMode1),
     /* 2335565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2335568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2335576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2335580 */     // (fcopysign:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSGNJ_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2335580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H),
     /* 2335587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335596 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D),
     /* 2335604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335612 */     // GIR_Coverage, 2195,
     /* 2335612 */     GIR_EraseRootFromParent_Done,
     /* 2335613 */   // Label 32490: @2335613
     /* 2335613 */   GIM_Try, /*On fail goto*//*Label 32491*/ GIMT_Encode4(2335669), // Rule ID 2206 //
     /* 2335618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode0),
     /* 2335621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2335624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2335636 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2335636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2335643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2335660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335668 */     // GIR_Coverage, 2206,
     /* 2335668 */     GIR_EraseRootFromParent_Done,
     /* 2335669 */   // Label 32491: @2335669
     /* 2335669 */   GIM_Try, /*On fail goto*//*Label 32492*/ GIMT_Encode4(2335725), // Rule ID 2207 //
     /* 2335674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV32_HwMode1),
     /* 2335677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2335680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2335688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2335692 */     // (fcopysign:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_IN32X:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i32] }))
     /* 2335692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_IN32X),
     /* 2335699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335704 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335708 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_IN32X),
     /* 2335716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335724 */     // GIR_Coverage, 2207,
     /* 2335724 */     GIR_EraseRootFromParent_Done,
     /* 2335725 */   // Label 32492: @2335725
     /* 2335725 */   GIM_Try, /*On fail goto*//*Label 32493*/ GIMT_Encode4(2335781), // Rule ID 2213 //
     /* 2335730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_HasStdExtZhinxmin_IsRV64_HwMode0),
     /* 2335733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2335736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2335744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2335748 */     // (fcopysign:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSGNJ_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, (FCVT_D_H_INX:{ *:[f64] } ?:{ *:[f16] }:$rs2, 0:{ *:[i64] }))
     /* 2335748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2335751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::FCVT_D_H_INX),
     /* 2335755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // rs2
     /* 2335764 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 2335767 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSGNJ_D_INX),
     /* 2335772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335779 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335780 */     // GIR_Coverage, 2213,
     /* 2335780 */     GIR_EraseRootFromParent_Done,
     /* 2335781 */   // Label 32493: @2335781
     /* 2335781 */   GIM_Reject,
     /* 2335782 */ // Label 32477: @2335782
     /* 2335782 */ GIM_Reject,
     /* 2335783 */ // Label 32433: @2335783
     /* 2335783 */ GIM_Try, /*On fail goto*//*Label 32494*/ GIMT_Encode4(2336033),
     /* 2335788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2335791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2335794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335802 */   GIM_Try, /*On fail goto*//*Label 32495*/ GIMT_Encode4(2335868), // Rule ID 56124 //
     /* 2335807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2335810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2335814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2335818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2335822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2335829 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2335832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2335846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335851 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2335857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335867 */     // GIR_Coverage, 56124,
     /* 2335867 */     GIR_EraseRootFromParent_Done,
     /* 2335868 */   // Label 32495: @2335868
     /* 2335868 */   GIM_Try, /*On fail goto*//*Label 32496*/ GIMT_Encode4(2335934), // Rule ID 56125 //
     /* 2335873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2335876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2335880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2335884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2335888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335893 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2335895 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2335898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF4_E16),
     /* 2335912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2335923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335932 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335933 */     // GIR_Coverage, 56125,
     /* 2335933 */     GIR_EraseRootFromParent_Done,
     /* 2335934 */   // Label 32496: @2335934
     /* 2335934 */   GIM_Try, /*On fail goto*//*Label 32497*/ GIMT_Encode4(2335983), // Rule ID 56118 //
     /* 2335939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2335942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335946 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2335946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2335949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2335953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2335958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2335960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2335963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2335965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2335968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2335970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2335972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2335975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2335978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2335981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2335982 */     // GIR_Coverage, 56118,
     /* 2335982 */     GIR_EraseRootFromParent_Done,
     /* 2335983 */   // Label 32497: @2335983
     /* 2335983 */   GIM_Try, /*On fail goto*//*Label 32498*/ GIMT_Encode4(2336032), // Rule ID 56119 //
     /* 2335988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2335991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2335995 */     // (fcopysign:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2335995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2335998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336007 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF4_E16),
     /* 2336012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336017 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336019 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336030 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336031 */     // GIR_Coverage, 56119,
     /* 2336031 */     GIR_EraseRootFromParent_Done,
     /* 2336032 */   // Label 32498: @2336032
     /* 2336032 */   GIM_Reject,
     /* 2336033 */ // Label 32494: @2336033
     /* 2336033 */ GIM_Reject,
     /* 2336034 */ // Label 32434: @2336034
     /* 2336034 */ GIM_Try, /*On fail goto*//*Label 32499*/ GIMT_Encode4(2336284),
     /* 2336039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2336042 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2336045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336049 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336053 */   GIM_Try, /*On fail goto*//*Label 32500*/ GIMT_Encode4(2336119), // Rule ID 56164 //
     /* 2336058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2336073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336078 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336080 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2336097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336104 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336118 */     // GIR_Coverage, 56164,
     /* 2336118 */     GIR_EraseRootFromParent_Done,
     /* 2336119 */   // Label 32500: @2336119
     /* 2336119 */   GIM_Try, /*On fail goto*//*Label 32501*/ GIMT_Encode4(2336185), // Rule ID 56165 //
     /* 2336124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2336139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336146 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E32),
     /* 2336163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336165 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336168 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336184 */     // GIR_Coverage, 56165,
     /* 2336184 */     GIR_EraseRootFromParent_Done,
     /* 2336185 */   // Label 32501: @2336185
     /* 2336185 */   GIM_Try, /*On fail goto*//*Label 32502*/ GIMT_Encode4(2336234), // Rule ID 56158 //
     /* 2336190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336197 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2336214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336233 */     // GIR_Coverage, 56158,
     /* 2336233 */     GIR_EraseRootFromParent_Done,
     /* 2336234 */   // Label 32502: @2336234
     /* 2336234 */   GIM_Try, /*On fail goto*//*Label 32503*/ GIMT_Encode4(2336283), // Rule ID 56159 //
     /* 2336239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336246 */     // (fcopysign:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2336249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E32),
     /* 2336263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336282 */     // GIR_Coverage, 56159,
     /* 2336282 */     GIR_EraseRootFromParent_Done,
     /* 2336283 */   // Label 32503: @2336283
     /* 2336283 */   GIM_Reject,
     /* 2336284 */ // Label 32499: @2336284
     /* 2336284 */ GIM_Reject,
     /* 2336285 */ // Label 32435: @2336285
     /* 2336285 */ GIM_Try, /*On fail goto*//*Label 32504*/ GIMT_Encode4(2336535),
     /* 2336290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2336293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2336296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336304 */   GIM_Try, /*On fail goto*//*Label 32505*/ GIMT_Encode4(2336370), // Rule ID 56224 //
     /* 2336309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2336312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2336324 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336331 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2336348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336368 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336369 */     // GIR_Coverage, 56224,
     /* 2336369 */     GIR_EraseRootFromParent_Done,
     /* 2336370 */   // Label 32505: @2336370
     /* 2336370 */   GIM_Try, /*On fail goto*//*Label 32506*/ GIMT_Encode4(2336436), // Rule ID 56225 //
     /* 2336375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2336378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2336390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336397 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E64),
     /* 2336414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336435 */     // GIR_Coverage, 56225,
     /* 2336435 */     GIR_EraseRootFromParent_Done,
     /* 2336436 */   // Label 32506: @2336436
     /* 2336436 */   GIM_Try, /*On fail goto*//*Label 32507*/ GIMT_Encode4(2336485), // Rule ID 56218 //
     /* 2336441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2336444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336448 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2336465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336467 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336470 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336472 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336484 */     // GIR_Coverage, 56218,
     /* 2336484 */     GIR_EraseRootFromParent_Done,
     /* 2336485 */   // Label 32507: @2336485
     /* 2336485 */   GIM_Try, /*On fail goto*//*Label 32508*/ GIMT_Encode4(2336534), // Rule ID 56219 //
     /* 2336490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2336493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336497 */     // (fcopysign:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2336500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E64),
     /* 2336514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2336529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336533 */     // GIR_Coverage, 56219,
     /* 2336533 */     GIR_EraseRootFromParent_Done,
     /* 2336534 */   // Label 32508: @2336534
     /* 2336534 */   GIM_Reject,
     /* 2336535 */ // Label 32504: @2336535
     /* 2336535 */ GIM_Reject,
     /* 2336536 */ // Label 32436: @2336536
     /* 2336536 */ GIM_Try, /*On fail goto*//*Label 32509*/ GIMT_Encode4(2336786),
     /* 2336541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2336544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2336547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336555 */   GIM_Try, /*On fail goto*//*Label 32510*/ GIMT_Encode4(2336621), // Rule ID 56144 //
     /* 2336560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2336563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2336575 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336580 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336582 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2336599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336620 */     // GIR_Coverage, 56144,
     /* 2336620 */     GIR_EraseRootFromParent_Done,
     /* 2336621 */   // Label 32510: @2336621
     /* 2336621 */   GIM_Try, /*On fail goto*//*Label 32511*/ GIMT_Encode4(2336687), // Rule ID 56145 //
     /* 2336626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2336629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2336641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336648 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_MF2_E16),
     /* 2336665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336686 */     // GIR_Coverage, 56145,
     /* 2336686 */     GIR_EraseRootFromParent_Done,
     /* 2336687 */   // Label 32511: @2336687
     /* 2336687 */   GIM_Try, /*On fail goto*//*Label 32512*/ GIMT_Encode4(2336736), // Rule ID 56138 //
     /* 2336692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2336695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336699 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2336716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336735 */     // GIR_Coverage, 56138,
     /* 2336735 */     GIR_EraseRootFromParent_Done,
     /* 2336736 */   // Label 32512: @2336736
     /* 2336736 */   GIM_Try, /*On fail goto*//*Label 32513*/ GIMT_Encode4(2336785), // Rule ID 56139 //
     /* 2336741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2336744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336748 */     // (fcopysign:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2336751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_MF2_E16),
     /* 2336765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336770 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336772 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2336780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336784 */     // GIR_Coverage, 56139,
     /* 2336784 */     GIR_EraseRootFromParent_Done,
     /* 2336785 */   // Label 32513: @2336785
     /* 2336785 */   GIM_Reject,
     /* 2336786 */ // Label 32509: @2336786
     /* 2336786 */ GIM_Reject,
     /* 2336787 */ // Label 32437: @2336787
     /* 2336787 */ GIM_Try, /*On fail goto*//*Label 32514*/ GIMT_Encode4(2337037),
     /* 2336792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2336798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336806 */   GIM_Try, /*On fail goto*//*Label 32515*/ GIMT_Encode4(2336872), // Rule ID 56204 //
     /* 2336811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336833 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336845 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2336850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336855 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336870 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336871 */     // GIR_Coverage, 56204,
     /* 2336871 */     GIR_EraseRootFromParent_Done,
     /* 2336872 */   // Label 32515: @2336872
     /* 2336872 */   GIM_Try, /*On fail goto*//*Label 32516*/ GIMT_Encode4(2336938), // Rule ID 56205 //
     /* 2336877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2336884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2336888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2336892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2336899 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E32),
     /* 2336916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2336927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336937 */     // GIR_Coverage, 56205,
     /* 2336937 */     GIR_EraseRootFromParent_Done,
     /* 2336938 */   // Label 32516: @2336938
     /* 2336938 */   GIM_Try, /*On fail goto*//*Label 32517*/ GIMT_Encode4(2336987), // Rule ID 56198 //
     /* 2336943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2336946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336950 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2336950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2336953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2336957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2336962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2336964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2336967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2336969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2336972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2336974 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2336976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2336979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2336982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2336985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2336986 */     // GIR_Coverage, 56198,
     /* 2336986 */     GIR_EraseRootFromParent_Done,
     /* 2336987 */   // Label 32517: @2336987
     /* 2336987 */   GIM_Try, /*On fail goto*//*Label 32518*/ GIMT_Encode4(2337036), // Rule ID 56199 //
     /* 2336992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2336995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2336999 */     // (fcopysign:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2336999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2337002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E32),
     /* 2337016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337035 */     // GIR_Coverage, 56199,
     /* 2337035 */     GIR_EraseRootFromParent_Done,
     /* 2337036 */   // Label 32518: @2337036
     /* 2337036 */   GIM_Reject,
     /* 2337037 */ // Label 32514: @2337037
     /* 2337037 */ GIM_Reject,
     /* 2337038 */ // Label 32438: @2337038
     /* 2337038 */ GIM_Try, /*On fail goto*//*Label 32519*/ GIMT_Encode4(2337288),
     /* 2337043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2337046 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2337049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337057 */   GIM_Try, /*On fail goto*//*Label 32520*/ GIMT_Encode4(2337123), // Rule ID 56364 //
     /* 2337062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2337077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337084 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2337087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2337101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337106 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337122 */     // GIR_Coverage, 56364,
     /* 2337122 */     GIR_EraseRootFromParent_Done,
     /* 2337123 */   // Label 32520: @2337123
     /* 2337123 */   GIM_Try, /*On fail goto*//*Label 32521*/ GIMT_Encode4(2337189), // Rule ID 56365 //
     /* 2337128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2337143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337150 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337150 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2337153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337157 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337162 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E64),
     /* 2337167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337188 */     // GIR_Coverage, 56365,
     /* 2337188 */     GIR_EraseRootFromParent_Done,
     /* 2337189 */   // Label 32521: @2337189
     /* 2337189 */   GIM_Try, /*On fail goto*//*Label 32522*/ GIMT_Encode4(2337238), // Rule ID 56358 //
     /* 2337194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337201 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2337204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2337218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337223 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337225 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337236 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337237 */     // GIR_Coverage, 56358,
     /* 2337237 */     GIR_EraseRootFromParent_Done,
     /* 2337238 */   // Label 32522: @2337238
     /* 2337238 */   GIM_Try, /*On fail goto*//*Label 32523*/ GIMT_Encode4(2337287), // Rule ID 56359 //
     /* 2337243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337250 */     // (fcopysign:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2337253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337262 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E64),
     /* 2337267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337272 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337274 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337285 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337286 */     // GIR_Coverage, 56359,
     /* 2337286 */     GIR_EraseRootFromParent_Done,
     /* 2337287 */   // Label 32523: @2337287
     /* 2337287 */   GIM_Reject,
     /* 2337288 */ // Label 32519: @2337288
     /* 2337288 */ GIM_Reject,
     /* 2337289 */ // Label 32439: @2337289
     /* 2337289 */ GIM_Try, /*On fail goto*//*Label 32524*/ GIMT_Encode4(2337539),
     /* 2337294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2337297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2337300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337308 */   GIM_Try, /*On fail goto*//*Label 32525*/ GIMT_Encode4(2337374), // Rule ID 56184 //
     /* 2337313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2337316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2337328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337335 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2337338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2337352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337373 */     // GIR_Coverage, 56184,
     /* 2337373 */     GIR_EraseRootFromParent_Done,
     /* 2337374 */   // Label 32525: @2337374
     /* 2337374 */   GIM_Try, /*On fail goto*//*Label 32526*/ GIMT_Encode4(2337440), // Rule ID 56185 //
     /* 2337379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2337382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2337394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337401 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2337404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M1_E16),
     /* 2337418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337439 */     // GIR_Coverage, 56185,
     /* 2337439 */     GIR_EraseRootFromParent_Done,
     /* 2337440 */   // Label 32526: @2337440
     /* 2337440 */   GIM_Try, /*On fail goto*//*Label 32527*/ GIMT_Encode4(2337489), // Rule ID 56178 //
     /* 2337445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2337448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337452 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2337455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2337469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337476 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337488 */     // GIR_Coverage, 56178,
     /* 2337488 */     GIR_EraseRootFromParent_Done,
     /* 2337489 */   // Label 32527: @2337489
     /* 2337489 */   GIM_Try, /*On fail goto*//*Label 32528*/ GIMT_Encode4(2337538), // Rule ID 56179 //
     /* 2337494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2337497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2337501 */     // (fcopysign:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2337504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M1_E16),
     /* 2337518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337520 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337523 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337525 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2337533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337537 */     // GIR_Coverage, 56179,
     /* 2337537 */     GIR_EraseRootFromParent_Done,
     /* 2337538 */   // Label 32528: @2337538
     /* 2337538 */   GIM_Reject,
     /* 2337539 */ // Label 32524: @2337539
     /* 2337539 */ GIM_Reject,
     /* 2337540 */ // Label 32440: @2337540
     /* 2337540 */ GIM_Try, /*On fail goto*//*Label 32529*/ GIMT_Encode4(2337790),
     /* 2337545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2337548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2337551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337555 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337559 */   GIM_Try, /*On fail goto*//*Label 32530*/ GIMT_Encode4(2337625), // Rule ID 56304 //
     /* 2337564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2337567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2337579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337584 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337586 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2337589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2337603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337624 */     // GIR_Coverage, 56304,
     /* 2337624 */     GIR_EraseRootFromParent_Done,
     /* 2337625 */   // Label 32530: @2337625
     /* 2337625 */   GIM_Try, /*On fail goto*//*Label 32531*/ GIMT_Encode4(2337691), // Rule ID 56305 //
     /* 2337630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2337633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2337645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337652 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2337655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E32),
     /* 2337669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337690 */     // GIR_Coverage, 56305,
     /* 2337690 */     GIR_EraseRootFromParent_Done,
     /* 2337691 */   // Label 32531: @2337691
     /* 2337691 */   GIM_Try, /*On fail goto*//*Label 32532*/ GIMT_Encode4(2337740), // Rule ID 56298 //
     /* 2337696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2337699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337703 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2337706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2337720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337739 */     // GIR_Coverage, 56298,
     /* 2337739 */     GIR_EraseRootFromParent_Done,
     /* 2337740 */   // Label 32532: @2337740
     /* 2337740 */   GIM_Try, /*On fail goto*//*Label 32533*/ GIMT_Encode4(2337789), // Rule ID 56299 //
     /* 2337745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2337748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2337752 */     // (fcopysign:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2337755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E32),
     /* 2337769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337774 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337776 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2337784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337788 */     // GIR_Coverage, 56299,
     /* 2337788 */     GIR_EraseRootFromParent_Done,
     /* 2337789 */   // Label 32533: @2337789
     /* 2337789 */   GIM_Reject,
     /* 2337790 */ // Label 32529: @2337790
     /* 2337790 */ GIM_Reject,
     /* 2337791 */ // Label 32441: @2337791
     /* 2337791 */ GIM_Try, /*On fail goto*//*Label 32534*/ GIMT_Encode4(2338041),
     /* 2337796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2337799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2337802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337810 */   GIM_Try, /*On fail goto*//*Label 32535*/ GIMT_Encode4(2337876), // Rule ID 56384 //
     /* 2337815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2337830 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337837 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2337854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337875 */     // GIR_Coverage, 56384,
     /* 2337875 */     GIR_EraseRootFromParent_Done,
     /* 2337876 */   // Label 32535: @2337876
     /* 2337876 */   GIM_Try, /*On fail goto*//*Label 32536*/ GIMT_Encode4(2337942), // Rule ID 56385 //
     /* 2337881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2337888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2337892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2337896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2337903 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2337903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E64),
     /* 2337920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2337931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337941 */     // GIR_Coverage, 56385,
     /* 2337941 */     GIR_EraseRootFromParent_Done,
     /* 2337942 */   // Label 32536: @2337942
     /* 2337942 */   GIM_Try, /*On fail goto*//*Label 32537*/ GIMT_Encode4(2337991), // Rule ID 56378 //
     /* 2337947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2337950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2337954 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2337954 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2337957 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2337961 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2337966 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2337968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2337971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2337973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2337976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2337978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2337980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2337983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2337986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2337989 */     GIR_RootConstrainSelectedInstOperands,
     /* 2337990 */     // GIR_Coverage, 56378,
     /* 2337990 */     GIR_EraseRootFromParent_Done,
     /* 2337991 */   // Label 32537: @2337991
     /* 2337991 */   GIM_Try, /*On fail goto*//*Label 32538*/ GIMT_Encode4(2338040), // Rule ID 56379 //
     /* 2337996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2337999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338003 */     // (fcopysign:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2338006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E64),
     /* 2338020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338039 */     // GIR_Coverage, 56379,
     /* 2338039 */     GIR_EraseRootFromParent_Done,
     /* 2338040 */   // Label 32538: @2338040
     /* 2338040 */   GIM_Reject,
     /* 2338041 */ // Label 32534: @2338041
     /* 2338041 */ GIM_Reject,
     /* 2338042 */ // Label 32442: @2338042
     /* 2338042 */ GIM_Try, /*On fail goto*//*Label 32539*/ GIMT_Encode4(2338292),
     /* 2338047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2338050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2338053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338061 */   GIM_Try, /*On fail goto*//*Label 32540*/ GIMT_Encode4(2338127), // Rule ID 56244 //
     /* 2338066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2338069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2338081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338088 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2338091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2338105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338126 */     // GIR_Coverage, 56244,
     /* 2338126 */     GIR_EraseRootFromParent_Done,
     /* 2338127 */   // Label 32540: @2338127
     /* 2338127 */   GIM_Try, /*On fail goto*//*Label 32541*/ GIMT_Encode4(2338193), // Rule ID 56245 //
     /* 2338132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2338135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2338147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338154 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2338157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M2_E16),
     /* 2338171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338191 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338192 */     // GIR_Coverage, 56245,
     /* 2338192 */     GIR_EraseRootFromParent_Done,
     /* 2338193 */   // Label 32541: @2338193
     /* 2338193 */   GIM_Try, /*On fail goto*//*Label 32542*/ GIMT_Encode4(2338242), // Rule ID 56238 //
     /* 2338198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2338201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338205 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2338208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2338222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338227 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338229 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338241 */     // GIR_Coverage, 56238,
     /* 2338241 */     GIR_EraseRootFromParent_Done,
     /* 2338242 */   // Label 32542: @2338242
     /* 2338242 */   GIM_Try, /*On fail goto*//*Label 32543*/ GIMT_Encode4(2338291), // Rule ID 56239 //
     /* 2338247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2338250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2338254 */     // (fcopysign:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338254 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2338257 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338261 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M2_E16),
     /* 2338271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338276 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338278 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338289 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338290 */     // GIR_Coverage, 56239,
     /* 2338290 */     GIR_EraseRootFromParent_Done,
     /* 2338291 */   // Label 32543: @2338291
     /* 2338291 */   GIM_Reject,
     /* 2338292 */ // Label 32539: @2338292
     /* 2338292 */ GIM_Reject,
     /* 2338293 */ // Label 32443: @2338293
     /* 2338293 */ GIM_Try, /*On fail goto*//*Label 32544*/ GIMT_Encode4(2338543),
     /* 2338298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2338301 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2338304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338312 */   GIM_Try, /*On fail goto*//*Label 32545*/ GIMT_Encode4(2338378), // Rule ID 56324 //
     /* 2338317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2338320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2338332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338339 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2338342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2338356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338361 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338376 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338377 */     // GIR_Coverage, 56324,
     /* 2338377 */     GIR_EraseRootFromParent_Done,
     /* 2338378 */   // Label 32545: @2338378
     /* 2338378 */   GIM_Try, /*On fail goto*//*Label 32546*/ GIMT_Encode4(2338444), // Rule ID 56325 //
     /* 2338383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2338386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2338398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338405 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338405 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2338408 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338412 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E32),
     /* 2338422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338424 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338442 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338443 */     // GIR_Coverage, 56325,
     /* 2338443 */     GIR_EraseRootFromParent_Done,
     /* 2338444 */   // Label 32546: @2338444
     /* 2338444 */   GIM_Try, /*On fail goto*//*Label 32547*/ GIMT_Encode4(2338493), // Rule ID 56318 //
     /* 2338449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2338452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338456 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2338459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2338473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338480 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338492 */     // GIR_Coverage, 56318,
     /* 2338492 */     GIR_EraseRootFromParent_Done,
     /* 2338493 */   // Label 32547: @2338493
     /* 2338493 */   GIM_Try, /*On fail goto*//*Label 32548*/ GIMT_Encode4(2338542), // Rule ID 56319 //
     /* 2338498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2338501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338505 */     // (fcopysign:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338505 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2338508 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338512 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338517 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E32),
     /* 2338522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338527 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338529 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2338537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338540 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338541 */     // GIR_Coverage, 56319,
     /* 2338541 */     GIR_EraseRootFromParent_Done,
     /* 2338542 */   // Label 32548: @2338542
     /* 2338542 */   GIM_Reject,
     /* 2338543 */ // Label 32544: @2338543
     /* 2338543 */ GIM_Reject,
     /* 2338544 */ // Label 32444: @2338544
     /* 2338544 */ GIM_Try, /*On fail goto*//*Label 32549*/ GIMT_Encode4(2338794),
     /* 2338549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2338552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2338555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338563 */   GIM_Try, /*On fail goto*//*Label 32550*/ GIMT_Encode4(2338629), // Rule ID 56404 //
     /* 2338568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2338571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2338583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338590 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2338593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2338607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338628 */     // GIR_Coverage, 56404,
     /* 2338628 */     GIR_EraseRootFromParent_Done,
     /* 2338629 */   // Label 32550: @2338629
     /* 2338629 */   GIM_Try, /*On fail goto*//*Label 32551*/ GIMT_Encode4(2338695), // Rule ID 56405 //
     /* 2338634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2338637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2338649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338656 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338656 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2338659 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338663 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E64),
     /* 2338673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338694 */     // GIR_Coverage, 56405,
     /* 2338694 */     GIR_EraseRootFromParent_Done,
     /* 2338695 */   // Label 32551: @2338695
     /* 2338695 */   GIM_Try, /*On fail goto*//*Label 32552*/ GIMT_Encode4(2338744), // Rule ID 56398 //
     /* 2338700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2338703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338707 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2338710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2338724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338731 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338743 */     // GIR_Coverage, 56398,
     /* 2338743 */     GIR_EraseRootFromParent_Done,
     /* 2338744 */   // Label 32552: @2338744
     /* 2338744 */   GIM_Try, /*On fail goto*//*Label 32553*/ GIMT_Encode4(2338793), // Rule ID 56399 //
     /* 2338749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2338752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2338756 */     // (fcopysign:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2338759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E64),
     /* 2338773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338778 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338780 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2338788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338792 */     // GIR_Coverage, 56399,
     /* 2338792 */     GIR_EraseRootFromParent_Done,
     /* 2338793 */   // Label 32553: @2338793
     /* 2338793 */   GIM_Reject,
     /* 2338794 */ // Label 32549: @2338794
     /* 2338794 */ GIM_Reject,
     /* 2338795 */ // Label 32445: @2338795
     /* 2338795 */ GIM_Try, /*On fail goto*//*Label 32554*/ GIMT_Encode4(2339045),
     /* 2338800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2338806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338814 */   GIM_Try, /*On fail goto*//*Label 32555*/ GIMT_Encode4(2338880), // Rule ID 56264 //
     /* 2338819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2338822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338841 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2338858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338879 */     // GIR_Coverage, 56264,
     /* 2338879 */     GIR_EraseRootFromParent_Done,
     /* 2338880 */   // Label 32555: @2338880
     /* 2338880 */   GIM_Try, /*On fail goto*//*Label 32556*/ GIMT_Encode4(2338946), // Rule ID 56265 //
     /* 2338885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2338888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2338892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2338896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2338900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2338907 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2338907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M4_E16),
     /* 2338924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2338935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338945 */     // GIR_Coverage, 56265,
     /* 2338945 */     GIR_EraseRootFromParent_Done,
     /* 2338946 */   // Label 32556: @2338946
     /* 2338946 */   GIM_Try, /*On fail goto*//*Label 32557*/ GIMT_Encode4(2338995), // Rule ID 56258 //
     /* 2338951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2338954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2338958 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2338958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2338961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2338965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2338970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2338972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2338975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2338977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2338980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2338982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2338984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2338987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2338990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2338993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2338994 */     // GIR_Coverage, 56258,
     /* 2338994 */     GIR_EraseRootFromParent_Done,
     /* 2338995 */   // Label 32557: @2338995
     /* 2338995 */   GIM_Try, /*On fail goto*//*Label 32558*/ GIMT_Encode4(2339044), // Rule ID 56259 //
     /* 2339000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2339003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2339007 */     // (fcopysign:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2339010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M4_E16),
     /* 2339024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339031 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2339033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339043 */     // GIR_Coverage, 56259,
     /* 2339043 */     GIR_EraseRootFromParent_Done,
     /* 2339044 */   // Label 32558: @2339044
     /* 2339044 */   GIM_Reject,
     /* 2339045 */ // Label 32554: @2339045
     /* 2339045 */ GIM_Reject,
     /* 2339046 */ // Label 32446: @2339046
     /* 2339046 */ GIM_Try, /*On fail goto*//*Label 32559*/ GIMT_Encode4(2339296),
     /* 2339051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2339054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2339057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339065 */   GIM_Try, /*On fail goto*//*Label 32560*/ GIMT_Encode4(2339131), // Rule ID 56344 //
     /* 2339070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2339073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2339085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339092 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2339095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339104 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2339109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339114 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339130 */     // GIR_Coverage, 56344,
     /* 2339130 */     GIR_EraseRootFromParent_Done,
     /* 2339131 */   // Label 32560: @2339131
     /* 2339131 */   GIM_Try, /*On fail goto*//*Label 32561*/ GIMT_Encode4(2339197), // Rule ID 56345 //
     /* 2339136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2339139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2339151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339158 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2339161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E32),
     /* 2339175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339196 */     // GIR_Coverage, 56345,
     /* 2339196 */     GIR_EraseRootFromParent_Done,
     /* 2339197 */   // Label 32561: @2339197
     /* 2339197 */   GIM_Try, /*On fail goto*//*Label 32562*/ GIMT_Encode4(2339246), // Rule ID 56338 //
     /* 2339202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2339205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339209 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2339212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2339226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2339235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339245 */     // GIR_Coverage, 56338,
     /* 2339245 */     GIR_EraseRootFromParent_Done,
     /* 2339246 */   // Label 32562: @2339246
     /* 2339246 */   GIM_Try, /*On fail goto*//*Label 32563*/ GIMT_Encode4(2339295), // Rule ID 56339 //
     /* 2339251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2339254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339258 */     // (fcopysign:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2339261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E32),
     /* 2339275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2339284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2339290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339294 */     // GIR_Coverage, 56339,
     /* 2339294 */     GIR_EraseRootFromParent_Done,
     /* 2339295 */   // Label 32563: @2339295
     /* 2339295 */   GIM_Reject,
     /* 2339296 */ // Label 32559: @2339296
     /* 2339296 */ GIM_Reject,
     /* 2339297 */ // Label 32447: @2339297
     /* 2339297 */ GIM_Try, /*On fail goto*//*Label 32564*/ GIMT_Encode4(2339547),
     /* 2339302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2339305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2339308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339316 */   GIM_Try, /*On fail goto*//*Label 32565*/ GIMT_Encode4(2339382), // Rule ID 56284 //
     /* 2339321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2339324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2339336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339343 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2339346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2339360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339381 */     // GIR_Coverage, 56284,
     /* 2339381 */     GIR_EraseRootFromParent_Done,
     /* 2339382 */   // Label 32565: @2339382
     /* 2339382 */   GIM_Try, /*On fail goto*//*Label 32566*/ GIMT_Encode4(2339448), // Rule ID 56285 //
     /* 2339387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2339390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2339394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2339398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2339402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339409 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFSGNJN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2339412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJN_VV_M8_E16),
     /* 2339426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2339437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339447 */     // GIR_Coverage, 56285,
     /* 2339447 */     GIR_EraseRootFromParent_Done,
     /* 2339448 */   // Label 32566: @2339448
     /* 2339448 */   GIM_Try, /*On fail goto*//*Label 32567*/ GIMT_Encode4(2339497), // Rule ID 56278 //
     /* 2339453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2339456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339460 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2339460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2339463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2339477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339479 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339482 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339484 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2339486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339496 */     // GIR_Coverage, 56278,
     /* 2339496 */     GIR_EraseRootFromParent_Done,
     /* 2339497 */   // Label 32567: @2339497
     /* 2339497 */   GIM_Try, /*On fail goto*//*Label 32568*/ GIMT_Encode4(2339546), // Rule ID 56279 //
     /* 2339502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2339505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2339509 */     // (fcopysign:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSGNJ_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2339509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2339512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2339516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2339521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2339523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSGNJ_VV_M8_E16),
     /* 2339526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2339531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2339535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2339538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2339541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2339544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339545 */     // GIR_Coverage, 56279,
     /* 2339545 */     GIR_EraseRootFromParent_Done,
     /* 2339546 */   // Label 32568: @2339546
     /* 2339546 */   GIM_Reject,
     /* 2339547 */ // Label 32564: @2339547
     /* 2339547 */ GIM_Reject,
     /* 2339548 */ // Label 32448: @2339548
     /* 2339548 */ GIM_Reject,
     /* 2339549 */ // Label 73: @2339549
     /* 2339549 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32572*/ GIMT_Encode4(2339738),
     /* 2339560 */ /*GILLT_s16*//*Label 32569*/ GIMT_Encode4(2339572),
     /* 2339564 */ /*GILLT_s32*//*Label 32570*/ GIMT_Encode4(2339622),
     /* 2339568 */ /*GILLT_s64*//*Label 32571*/ GIMT_Encode4(2339672),
     /* 2339572 */ // Label 32569: @2339572
     /* 2339572 */ GIM_Try, /*On fail goto*//*Label 32573*/ GIMT_Encode4(2339621),
     /* 2339577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2339580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339584 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339588 */   GIM_Try, /*On fail goto*//*Label 32574*/ GIMT_Encode4(2339604), // Rule ID 1956 //
     /* 2339593 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2339593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2339596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339598 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339603 */     // GIR_Coverage, 1956,
     /* 2339603 */     GIR_EraseRootFromParent_Done,
     /* 2339604 */   // Label 32574: @2339604
     /* 2339604 */   GIM_Try, /*On fail goto*//*Label 32575*/ GIMT_Encode4(2339620), // Rule ID 1957 //
     /* 2339609 */     // (fcanonicalize:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs1)
     /* 2339609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2339612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339619 */     // GIR_Coverage, 1957,
     /* 2339619 */     GIR_EraseRootFromParent_Done,
     /* 2339620 */   // Label 32575: @2339620
     /* 2339620 */   GIM_Reject,
     /* 2339621 */ // Label 32573: @2339621
     /* 2339621 */ GIM_Reject,
     /* 2339622 */ // Label 32570: @2339622
     /* 2339622 */ GIM_Try, /*On fail goto*//*Label 32576*/ GIMT_Encode4(2339671),
     /* 2339627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339638 */   GIM_Try, /*On fail goto*//*Label 32577*/ GIMT_Encode4(2339654), // Rule ID 1243 //
     /* 2339643 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2339643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2339646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339648 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339650 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339652 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339653 */     // GIR_Coverage, 1243,
     /* 2339653 */     GIR_EraseRootFromParent_Done,
     /* 2339654 */   // Label 32577: @2339654
     /* 2339654 */   GIM_Try, /*On fail goto*//*Label 32578*/ GIMT_Encode4(2339670), // Rule ID 1244 //
     /* 2339659 */     // (fcanonicalize:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs1)
     /* 2339659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2339662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339669 */     // GIR_Coverage, 1244,
     /* 2339669 */     GIR_EraseRootFromParent_Done,
     /* 2339670 */   // Label 32578: @2339670
     /* 2339670 */   GIM_Reject,
     /* 2339671 */ // Label 32576: @2339671
     /* 2339671 */ GIM_Reject,
     /* 2339672 */ // Label 32571: @2339672
     /* 2339672 */ GIM_Try, /*On fail goto*//*Label 32579*/ GIMT_Encode4(2339737),
     /* 2339677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2339680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2339688 */   GIM_Try, /*On fail goto*//*Label 32580*/ GIMT_Encode4(2339704), // Rule ID 1620 //
     /* 2339693 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2339693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2339696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339700 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339702 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339703 */     // GIR_Coverage, 1620,
     /* 2339703 */     GIR_EraseRootFromParent_Done,
     /* 2339704 */   // Label 32580: @2339704
     /* 2339704 */   GIM_Try, /*On fail goto*//*Label 32581*/ GIMT_Encode4(2339720), // Rule ID 1621 //
     /* 2339709 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2339709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2339712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339714 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339719 */     // GIR_Coverage, 1621,
     /* 2339719 */     GIR_EraseRootFromParent_Done,
     /* 2339720 */   // Label 32581: @2339720
     /* 2339720 */   GIM_Try, /*On fail goto*//*Label 32582*/ GIMT_Encode4(2339736), // Rule ID 1622 //
     /* 2339725 */     // (fcanonicalize:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs1)
     /* 2339725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2339728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2339730 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2339734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339735 */     // GIR_Coverage, 1622,
     /* 2339735 */     GIR_EraseRootFromParent_Done,
     /* 2339736 */   // Label 32582: @2339736
     /* 2339736 */   GIM_Reject,
     /* 2339737 */ // Label 32579: @2339737
     /* 2339737 */ GIM_Reject,
     /* 2339738 */ // Label 32572: @2339738
     /* 2339738 */ GIM_Reject,
     /* 2339739 */ // Label 74: @2339739
     /* 2339739 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32601*/ GIMT_Encode4(2341823),
     /* 2339750 */ /*GILLT_s16*//*Label 32583*/ GIMT_Encode4(2339870),
     /* 2339754 */ /*GILLT_s32*//*Label 32584*/ GIMT_Encode4(2339937),
     /* 2339758 */ /*GILLT_s64*//*Label 32585*/ GIMT_Encode4(2340004), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339770 */ /*GILLT_nxv1s16*//*Label 32586*/ GIMT_Encode4(2340098),
     /* 2339774 */ /*GILLT_nxv1s32*//*Label 32587*/ GIMT_Encode4(2340213),
     /* 2339778 */ /*GILLT_nxv1s64*//*Label 32588*/ GIMT_Encode4(2340328), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339790 */ /*GILLT_nxv2s16*//*Label 32589*/ GIMT_Encode4(2340443),
     /* 2339794 */ /*GILLT_nxv2s32*//*Label 32590*/ GIMT_Encode4(2340558),
     /* 2339798 */ /*GILLT_nxv2s64*//*Label 32591*/ GIMT_Encode4(2340673), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339810 */ /*GILLT_nxv4s16*//*Label 32592*/ GIMT_Encode4(2340788),
     /* 2339814 */ /*GILLT_nxv4s32*//*Label 32593*/ GIMT_Encode4(2340903),
     /* 2339818 */ /*GILLT_nxv4s64*//*Label 32594*/ GIMT_Encode4(2341018), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339830 */ /*GILLT_nxv8s16*//*Label 32595*/ GIMT_Encode4(2341133),
     /* 2339834 */ /*GILLT_nxv8s32*//*Label 32596*/ GIMT_Encode4(2341248),
     /* 2339838 */ /*GILLT_nxv8s64*//*Label 32597*/ GIMT_Encode4(2341363), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339850 */ /*GILLT_nxv16s16*//*Label 32598*/ GIMT_Encode4(2341478),
     /* 2339854 */ /*GILLT_nxv16s32*//*Label 32599*/ GIMT_Encode4(2341593), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2339866 */ /*GILLT_nxv32s16*//*Label 32600*/ GIMT_Encode4(2341708),
     /* 2339870 */ // Label 32583: @2339870
     /* 2339870 */ GIM_Try, /*On fail goto*//*Label 32602*/ GIMT_Encode4(2339936),
     /* 2339875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2339878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2339881 */   GIM_Try, /*On fail goto*//*Label 32603*/ GIMT_Encode4(2339908), // Rule ID 1944 //
     /* 2339886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2339889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2339901 */     // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2339901 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2339906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339907 */     // GIR_Coverage, 1944,
     /* 2339907 */     GIR_Done,
     /* 2339908 */   // Label 32603: @2339908
     /* 2339908 */   GIM_Try, /*On fail goto*//*Label 32604*/ GIMT_Encode4(2339935), // Rule ID 1945 //
     /* 2339913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2339916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2339928 */     // (fminnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2339928 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2339933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339934 */     // GIR_Coverage, 1945,
     /* 2339934 */     GIR_Done,
     /* 2339935 */   // Label 32604: @2339935
     /* 2339935 */   GIM_Reject,
     /* 2339936 */ // Label 32602: @2339936
     /* 2339936 */ GIM_Reject,
     /* 2339937 */ // Label 32584: @2339937
     /* 2339937 */ GIM_Try, /*On fail goto*//*Label 32605*/ GIMT_Encode4(2340003),
     /* 2339942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2339945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2339948 */   GIM_Try, /*On fail goto*//*Label 32606*/ GIMT_Encode4(2339975), // Rule ID 1231 //
     /* 2339953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2339956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2339968 */     // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2339968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2339973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2339974 */     // GIR_Coverage, 1231,
     /* 2339974 */     GIR_Done,
     /* 2339975 */   // Label 32606: @2339975
     /* 2339975 */   GIM_Try, /*On fail goto*//*Label 32607*/ GIMT_Encode4(2340002), // Rule ID 1232 //
     /* 2339980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2339983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2339995 */     // (fminnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2339995 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2340000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340001 */     // GIR_Coverage, 1232,
     /* 2340001 */     GIR_Done,
     /* 2340002 */   // Label 32607: @2340002
     /* 2340002 */   GIM_Reject,
     /* 2340003 */ // Label 32605: @2340003
     /* 2340003 */ GIM_Reject,
     /* 2340004 */ // Label 32585: @2340004
     /* 2340004 */ GIM_Try, /*On fail goto*//*Label 32608*/ GIMT_Encode4(2340097),
     /* 2340009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2340012 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2340015 */   GIM_Try, /*On fail goto*//*Label 32609*/ GIMT_Encode4(2340042), // Rule ID 1602 //
     /* 2340020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2340023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2340027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2340031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2340035 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2340035 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2340040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340041 */     // GIR_Coverage, 1602,
     /* 2340041 */     GIR_Done,
     /* 2340042 */   // Label 32609: @2340042
     /* 2340042 */   GIM_Try, /*On fail goto*//*Label 32610*/ GIMT_Encode4(2340069), // Rule ID 1603 //
     /* 2340047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2340050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2340054 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2340058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2340062 */     // (fminnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2340062 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2340067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340068 */     // GIR_Coverage, 1603,
     /* 2340068 */     GIR_Done,
     /* 2340069 */   // Label 32610: @2340069
     /* 2340069 */   GIM_Try, /*On fail goto*//*Label 32611*/ GIMT_Encode4(2340096), // Rule ID 1604 //
     /* 2340074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2340077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2340081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2340085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2340089 */     // (fminnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2340089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2340094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340095 */     // GIR_Coverage, 1604,
     /* 2340095 */     GIR_Done,
     /* 2340096 */   // Label 32611: @2340096
     /* 2340096 */   GIM_Reject,
     /* 2340097 */ // Label 32608: @2340097
     /* 2340097 */ GIM_Reject,
     /* 2340098 */ // Label 32586: @2340098
     /* 2340098 */ GIM_Try, /*On fail goto*//*Label 32612*/ GIMT_Encode4(2340212),
     /* 2340103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2340106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2340109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340121 */   GIM_Try, /*On fail goto*//*Label 32613*/ GIMT_Encode4(2340166), // Rule ID 45630 //
     /* 2340126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340129 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2340146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340151 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340165 */     // GIR_Coverage, 45630,
     /* 2340165 */     GIR_EraseRootFromParent_Done,
     /* 2340166 */   // Label 32613: @2340166
     /* 2340166 */   GIM_Try, /*On fail goto*//*Label 32614*/ GIMT_Encode4(2340211), // Rule ID 45631 //
     /* 2340171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340174 */     // (fminnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2340177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2340191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340198 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340209 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340210 */     // GIR_Coverage, 45631,
     /* 2340210 */     GIR_EraseRootFromParent_Done,
     /* 2340211 */   // Label 32614: @2340211
     /* 2340211 */   GIM_Reject,
     /* 2340212 */ // Label 32612: @2340212
     /* 2340212 */ GIM_Reject,
     /* 2340213 */ // Label 32587: @2340213
     /* 2340213 */ GIM_Try, /*On fail goto*//*Label 32615*/ GIMT_Encode4(2340327),
     /* 2340218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2340221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2340224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340236 */   GIM_Try, /*On fail goto*//*Label 32616*/ GIMT_Encode4(2340281), // Rule ID 56416 //
     /* 2340241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2340244 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2340261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340279 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340280 */     // GIR_Coverage, 56416,
     /* 2340280 */     GIR_EraseRootFromParent_Done,
     /* 2340281 */   // Label 32616: @2340281
     /* 2340281 */   GIM_Try, /*On fail goto*//*Label 32617*/ GIMT_Encode4(2340326), // Rule ID 56417 //
     /* 2340286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2340289 */     // (fminnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2340292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2340306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340325 */     // GIR_Coverage, 56417,
     /* 2340325 */     GIR_EraseRootFromParent_Done,
     /* 2340326 */   // Label 32617: @2340326
     /* 2340326 */   GIM_Reject,
     /* 2340327 */ // Label 32615: @2340327
     /* 2340327 */ GIM_Reject,
     /* 2340328 */ // Label 32588: @2340328
     /* 2340328 */ GIM_Try, /*On fail goto*//*Label 32618*/ GIMT_Encode4(2340442),
     /* 2340333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2340336 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2340339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340343 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340347 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340351 */   GIM_Try, /*On fail goto*//*Label 32619*/ GIMT_Encode4(2340396), // Rule ID 56434 //
     /* 2340356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2340359 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2340376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340378 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340381 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340383 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340395 */     // GIR_Coverage, 56434,
     /* 2340395 */     GIR_EraseRootFromParent_Done,
     /* 2340396 */   // Label 32619: @2340396
     /* 2340396 */   GIM_Try, /*On fail goto*//*Label 32620*/ GIMT_Encode4(2340441), // Rule ID 56435 //
     /* 2340401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2340404 */     // (fminnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340404 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2340407 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340411 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2340421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340426 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340428 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340440 */     // GIR_Coverage, 56435,
     /* 2340440 */     GIR_EraseRootFromParent_Done,
     /* 2340441 */   // Label 32620: @2340441
     /* 2340441 */   GIM_Reject,
     /* 2340442 */ // Label 32618: @2340442
     /* 2340442 */ GIM_Reject,
     /* 2340443 */ // Label 32589: @2340443
     /* 2340443 */ GIM_Try, /*On fail goto*//*Label 32621*/ GIMT_Encode4(2340557),
     /* 2340448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2340451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2340454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340462 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340466 */   GIM_Try, /*On fail goto*//*Label 32622*/ GIMT_Encode4(2340511), // Rule ID 56410 //
     /* 2340471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340474 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340486 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2340491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340496 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340498 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340510 */     // GIR_Coverage, 56410,
     /* 2340510 */     GIR_EraseRootFromParent_Done,
     /* 2340511 */   // Label 32622: @2340511
     /* 2340511 */   GIM_Try, /*On fail goto*//*Label 32623*/ GIMT_Encode4(2340556), // Rule ID 56411 //
     /* 2340516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340519 */     // (fminnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2340522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2340536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340555 */     // GIR_Coverage, 56411,
     /* 2340555 */     GIR_EraseRootFromParent_Done,
     /* 2340556 */   // Label 32623: @2340556
     /* 2340556 */   GIM_Reject,
     /* 2340557 */ // Label 32621: @2340557
     /* 2340557 */ GIM_Reject,
     /* 2340558 */ // Label 32590: @2340558
     /* 2340558 */ GIM_Try, /*On fail goto*//*Label 32624*/ GIMT_Encode4(2340672),
     /* 2340563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2340566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2340569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340581 */   GIM_Try, /*On fail goto*//*Label 32625*/ GIMT_Encode4(2340626), // Rule ID 56428 //
     /* 2340586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2340589 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2340592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2340606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340611 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340613 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340625 */     // GIR_Coverage, 56428,
     /* 2340625 */     GIR_EraseRootFromParent_Done,
     /* 2340626 */   // Label 32625: @2340626
     /* 2340626 */   GIM_Try, /*On fail goto*//*Label 32626*/ GIMT_Encode4(2340671), // Rule ID 56429 //
     /* 2340631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2340634 */     // (fminnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2340637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2340651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340658 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340669 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340670 */     // GIR_Coverage, 56429,
     /* 2340670 */     GIR_EraseRootFromParent_Done,
     /* 2340671 */   // Label 32626: @2340671
     /* 2340671 */   GIM_Reject,
     /* 2340672 */ // Label 32624: @2340672
     /* 2340672 */ GIM_Reject,
     /* 2340673 */ // Label 32591: @2340673
     /* 2340673 */ GIM_Try, /*On fail goto*//*Label 32627*/ GIMT_Encode4(2340787),
     /* 2340678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2340681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2340684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340692 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340696 */   GIM_Try, /*On fail goto*//*Label 32628*/ GIMT_Encode4(2340741), // Rule ID 56476 //
     /* 2340701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2340704 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2340707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2340721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340739 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340740 */     // GIR_Coverage, 56476,
     /* 2340740 */     GIR_EraseRootFromParent_Done,
     /* 2340741 */   // Label 32628: @2340741
     /* 2340741 */   GIM_Try, /*On fail goto*//*Label 32629*/ GIMT_Encode4(2340786), // Rule ID 56477 //
     /* 2340746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2340749 */     // (fminnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2340752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2340766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2340781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340785 */     // GIR_Coverage, 56477,
     /* 2340785 */     GIR_EraseRootFromParent_Done,
     /* 2340786 */   // Label 32629: @2340786
     /* 2340786 */   GIM_Reject,
     /* 2340787 */ // Label 32627: @2340787
     /* 2340787 */ GIM_Reject,
     /* 2340788 */ // Label 32592: @2340788
     /* 2340788 */ GIM_Try, /*On fail goto*//*Label 32630*/ GIMT_Encode4(2340902),
     /* 2340793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2340796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2340799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340807 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2340811 */   GIM_Try, /*On fail goto*//*Label 32631*/ GIMT_Encode4(2340856), // Rule ID 56422 //
     /* 2340816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2340819 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340831 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2340836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340855 */     // GIR_Coverage, 56422,
     /* 2340855 */     GIR_EraseRootFromParent_Done,
     /* 2340856 */   // Label 32631: @2340856
     /* 2340856 */   GIM_Try, /*On fail goto*//*Label 32632*/ GIMT_Encode4(2340901), // Rule ID 56423 //
     /* 2340861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2340864 */     // (fminnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340864 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2340867 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340871 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2340881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2340896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340899 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340900 */     // GIR_Coverage, 56423,
     /* 2340900 */     GIR_EraseRootFromParent_Done,
     /* 2340901 */   // Label 32632: @2340901
     /* 2340901 */   GIM_Reject,
     /* 2340902 */ // Label 32630: @2340902
     /* 2340902 */ GIM_Reject,
     /* 2340903 */ // Label 32593: @2340903
     /* 2340903 */ GIM_Try, /*On fail goto*//*Label 32633*/ GIMT_Encode4(2341017),
     /* 2340908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2340911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2340914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2340926 */   GIM_Try, /*On fail goto*//*Label 32634*/ GIMT_Encode4(2340971), // Rule ID 56458 //
     /* 2340931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2340934 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2340934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340946 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2340951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2340956 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2340958 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2340960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2340963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2340966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2340969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2340970 */     // GIR_Coverage, 56458,
     /* 2340970 */     GIR_EraseRootFromParent_Done,
     /* 2340971 */   // Label 32634: @2340971
     /* 2340971 */   GIM_Try, /*On fail goto*//*Label 32635*/ GIMT_Encode4(2341016), // Rule ID 56459 //
     /* 2340976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2340979 */     // (fminnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2340979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2340982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2340986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2340991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2340993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2340996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2340998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341003 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341014 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341015 */     // GIR_Coverage, 56459,
     /* 2341015 */     GIR_EraseRootFromParent_Done,
     /* 2341016 */   // Label 32635: @2341016
     /* 2341016 */   GIM_Reject,
     /* 2341017 */ // Label 32633: @2341017
     /* 2341017 */ GIM_Reject,
     /* 2341018 */ // Label 32594: @2341018
     /* 2341018 */ GIM_Try, /*On fail goto*//*Label 32636*/ GIMT_Encode4(2341132),
     /* 2341023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2341026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2341029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341041 */   GIM_Try, /*On fail goto*//*Label 32637*/ GIMT_Encode4(2341086), // Rule ID 56482 //
     /* 2341046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2341049 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2341052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2341066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341073 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341085 */     // GIR_Coverage, 56482,
     /* 2341085 */     GIR_EraseRootFromParent_Done,
     /* 2341086 */   // Label 32637: @2341086
     /* 2341086 */   GIM_Try, /*On fail goto*//*Label 32638*/ GIMT_Encode4(2341131), // Rule ID 56483 //
     /* 2341091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2341094 */     // (fminnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2341097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2341111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341116 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341118 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341130 */     // GIR_Coverage, 56483,
     /* 2341130 */     GIR_EraseRootFromParent_Done,
     /* 2341131 */   // Label 32638: @2341131
     /* 2341131 */   GIM_Reject,
     /* 2341132 */ // Label 32636: @2341132
     /* 2341132 */ GIM_Reject,
     /* 2341133 */ // Label 32595: @2341133
     /* 2341133 */ GIM_Try, /*On fail goto*//*Label 32639*/ GIMT_Encode4(2341247),
     /* 2341138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2341141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2341144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2341156 */   GIM_Try, /*On fail goto*//*Label 32640*/ GIMT_Encode4(2341201), // Rule ID 56440 //
     /* 2341161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341164 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2341181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341200 */     // GIR_Coverage, 56440,
     /* 2341200 */     GIR_EraseRootFromParent_Done,
     /* 2341201 */   // Label 32640: @2341201
     /* 2341201 */   GIM_Try, /*On fail goto*//*Label 32641*/ GIMT_Encode4(2341246), // Rule ID 56441 //
     /* 2341206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341209 */     // (fminnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2341212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2341226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341233 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341244 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341245 */     // GIR_Coverage, 56441,
     /* 2341245 */     GIR_EraseRootFromParent_Done,
     /* 2341246 */   // Label 32641: @2341246
     /* 2341246 */   GIM_Reject,
     /* 2341247 */ // Label 32639: @2341247
     /* 2341247 */ GIM_Reject,
     /* 2341248 */ // Label 32596: @2341248
     /* 2341248 */ GIM_Try, /*On fail goto*//*Label 32642*/ GIMT_Encode4(2341362),
     /* 2341253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2341256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2341259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341271 */   GIM_Try, /*On fail goto*//*Label 32643*/ GIMT_Encode4(2341316), // Rule ID 56464 //
     /* 2341276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2341279 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2341296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341303 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341314 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341315 */     // GIR_Coverage, 56464,
     /* 2341315 */     GIR_EraseRootFromParent_Done,
     /* 2341316 */   // Label 32643: @2341316
     /* 2341316 */   GIM_Try, /*On fail goto*//*Label 32644*/ GIMT_Encode4(2341361), // Rule ID 56465 //
     /* 2341321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2341324 */     // (fminnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341324 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2341327 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341331 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341336 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2341341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341346 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341348 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341359 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341360 */     // GIR_Coverage, 56465,
     /* 2341360 */     GIR_EraseRootFromParent_Done,
     /* 2341361 */   // Label 32644: @2341361
     /* 2341361 */   GIM_Reject,
     /* 2341362 */ // Label 32642: @2341362
     /* 2341362 */ GIM_Reject,
     /* 2341363 */ // Label 32597: @2341363
     /* 2341363 */ GIM_Try, /*On fail goto*//*Label 32645*/ GIMT_Encode4(2341477),
     /* 2341368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2341371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2341374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341386 */   GIM_Try, /*On fail goto*//*Label 32646*/ GIMT_Encode4(2341431), // Rule ID 56488 //
     /* 2341391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2341394 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341394 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341397 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341401 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2341411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341413 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341429 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341430 */     // GIR_Coverage, 56488,
     /* 2341430 */     GIR_EraseRootFromParent_Done,
     /* 2341431 */   // Label 32646: @2341431
     /* 2341431 */   GIM_Try, /*On fail goto*//*Label 32647*/ GIMT_Encode4(2341476), // Rule ID 56489 //
     /* 2341436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2341439 */     // (fminnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2341442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341451 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2341456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341463 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2341471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341475 */     // GIR_Coverage, 56489,
     /* 2341475 */     GIR_EraseRootFromParent_Done,
     /* 2341476 */   // Label 32647: @2341476
     /* 2341476 */   GIM_Reject,
     /* 2341477 */ // Label 32645: @2341477
     /* 2341477 */ GIM_Reject,
     /* 2341478 */ // Label 32598: @2341478
     /* 2341478 */ GIM_Try, /*On fail goto*//*Label 32648*/ GIMT_Encode4(2341592),
     /* 2341483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2341486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2341489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341497 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2341501 */   GIM_Try, /*On fail goto*//*Label 32649*/ GIMT_Encode4(2341546), // Rule ID 56446 //
     /* 2341506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341509 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341521 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2341526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341528 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341531 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341533 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341544 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341545 */     // GIR_Coverage, 56446,
     /* 2341545 */     GIR_EraseRootFromParent_Done,
     /* 2341546 */   // Label 32649: @2341546
     /* 2341546 */   GIM_Try, /*On fail goto*//*Label 32650*/ GIMT_Encode4(2341591), // Rule ID 56447 //
     /* 2341551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341554 */     // (fminnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341554 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2341557 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341561 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2341571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341590 */     // GIR_Coverage, 56447,
     /* 2341590 */     GIR_EraseRootFromParent_Done,
     /* 2341591 */   // Label 32650: @2341591
     /* 2341591 */   GIM_Reject,
     /* 2341592 */ // Label 32648: @2341592
     /* 2341592 */ GIM_Reject,
     /* 2341593 */ // Label 32599: @2341593
     /* 2341593 */ GIM_Try, /*On fail goto*//*Label 32651*/ GIMT_Encode4(2341707),
     /* 2341598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2341601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2341604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341616 */   GIM_Try, /*On fail goto*//*Label 32652*/ GIMT_Encode4(2341661), // Rule ID 56470 //
     /* 2341621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2341624 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2341641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341660 */     // GIR_Coverage, 56470,
     /* 2341660 */     GIR_EraseRootFromParent_Done,
     /* 2341661 */   // Label 32652: @2341661
     /* 2341661 */   GIM_Try, /*On fail goto*//*Label 32653*/ GIMT_Encode4(2341706), // Rule ID 56471 //
     /* 2341666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2341669 */     // (fminnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2341672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341681 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2341686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341691 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341693 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2341701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341705 */     // GIR_Coverage, 56471,
     /* 2341705 */     GIR_EraseRootFromParent_Done,
     /* 2341706 */   // Label 32653: @2341706
     /* 2341706 */   GIM_Reject,
     /* 2341707 */ // Label 32651: @2341707
     /* 2341707 */ GIM_Reject,
     /* 2341708 */ // Label 32600: @2341708
     /* 2341708 */ GIM_Try, /*On fail goto*//*Label 32654*/ GIMT_Encode4(2341822),
     /* 2341713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2341716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2341719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2341731 */   GIM_Try, /*On fail goto*//*Label 32655*/ GIMT_Encode4(2341776), // Rule ID 56452 //
     /* 2341736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2341739 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2341739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2341756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341761 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341775 */     // GIR_Coverage, 56452,
     /* 2341775 */     GIR_EraseRootFromParent_Done,
     /* 2341776 */   // Label 32655: @2341776
     /* 2341776 */   GIM_Try, /*On fail goto*//*Label 32656*/ GIMT_Encode4(2341821), // Rule ID 56453 //
     /* 2341781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2341784 */     // (fminnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2341784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2341787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2341791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2341796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2341798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2341801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2341803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2341806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2341808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2341810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2341813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2341816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2341819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341820 */     // GIR_Coverage, 56453,
     /* 2341820 */     GIR_EraseRootFromParent_Done,
     /* 2341821 */   // Label 32656: @2341821
     /* 2341821 */   GIM_Reject,
     /* 2341822 */ // Label 32654: @2341822
     /* 2341822 */ GIM_Reject,
     /* 2341823 */ // Label 32601: @2341823
     /* 2341823 */ GIM_Reject,
     /* 2341824 */ // Label 75: @2341824
     /* 2341824 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32675*/ GIMT_Encode4(2343908),
     /* 2341835 */ /*GILLT_s16*//*Label 32657*/ GIMT_Encode4(2341955),
     /* 2341839 */ /*GILLT_s32*//*Label 32658*/ GIMT_Encode4(2342022),
     /* 2341843 */ /*GILLT_s64*//*Label 32659*/ GIMT_Encode4(2342089), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341855 */ /*GILLT_nxv1s16*//*Label 32660*/ GIMT_Encode4(2342183),
     /* 2341859 */ /*GILLT_nxv1s32*//*Label 32661*/ GIMT_Encode4(2342298),
     /* 2341863 */ /*GILLT_nxv1s64*//*Label 32662*/ GIMT_Encode4(2342413), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341875 */ /*GILLT_nxv2s16*//*Label 32663*/ GIMT_Encode4(2342528),
     /* 2341879 */ /*GILLT_nxv2s32*//*Label 32664*/ GIMT_Encode4(2342643),
     /* 2341883 */ /*GILLT_nxv2s64*//*Label 32665*/ GIMT_Encode4(2342758), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341895 */ /*GILLT_nxv4s16*//*Label 32666*/ GIMT_Encode4(2342873),
     /* 2341899 */ /*GILLT_nxv4s32*//*Label 32667*/ GIMT_Encode4(2342988),
     /* 2341903 */ /*GILLT_nxv4s64*//*Label 32668*/ GIMT_Encode4(2343103), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341915 */ /*GILLT_nxv8s16*//*Label 32669*/ GIMT_Encode4(2343218),
     /* 2341919 */ /*GILLT_nxv8s32*//*Label 32670*/ GIMT_Encode4(2343333),
     /* 2341923 */ /*GILLT_nxv8s64*//*Label 32671*/ GIMT_Encode4(2343448), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341935 */ /*GILLT_nxv16s16*//*Label 32672*/ GIMT_Encode4(2343563),
     /* 2341939 */ /*GILLT_nxv16s32*//*Label 32673*/ GIMT_Encode4(2343678), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2341951 */ /*GILLT_nxv32s16*//*Label 32674*/ GIMT_Encode4(2343793),
     /* 2341955 */ // Label 32657: @2341955
     /* 2341955 */ GIM_Try, /*On fail goto*//*Label 32676*/ GIMT_Encode4(2342021),
     /* 2341960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2341963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2341966 */   GIM_Try, /*On fail goto*//*Label 32677*/ GIMT_Encode4(2341993), // Rule ID 1946 //
     /* 2341971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2341974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2341986 */     // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2341986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2341991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2341992 */     // GIR_Coverage, 1946,
     /* 2341992 */     GIR_Done,
     /* 2341993 */   // Label 32677: @2341993
     /* 2341993 */   GIM_Try, /*On fail goto*//*Label 32678*/ GIMT_Encode4(2342020), // Rule ID 1947 //
     /* 2341998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2342001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2342013 */     // (fmaxnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2342013 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2342018 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342019 */     // GIR_Coverage, 1947,
     /* 2342019 */     GIR_Done,
     /* 2342020 */   // Label 32678: @2342020
     /* 2342020 */   GIM_Reject,
     /* 2342021 */ // Label 32676: @2342021
     /* 2342021 */ GIM_Reject,
     /* 2342022 */ // Label 32658: @2342022
     /* 2342022 */ GIM_Try, /*On fail goto*//*Label 32679*/ GIMT_Encode4(2342088),
     /* 2342027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2342030 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2342033 */   GIM_Try, /*On fail goto*//*Label 32680*/ GIMT_Encode4(2342060), // Rule ID 1233 //
     /* 2342038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2342041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2342053 */     // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2342053 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2342058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342059 */     // GIR_Coverage, 1233,
     /* 2342059 */     GIR_Done,
     /* 2342060 */   // Label 32680: @2342060
     /* 2342060 */   GIM_Try, /*On fail goto*//*Label 32681*/ GIMT_Encode4(2342087), // Rule ID 1234 //
     /* 2342065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2342068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2342080 */     // (fmaxnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2342080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2342085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342086 */     // GIR_Coverage, 1234,
     /* 2342086 */     GIR_Done,
     /* 2342087 */   // Label 32681: @2342087
     /* 2342087 */   GIM_Reject,
     /* 2342088 */ // Label 32679: @2342088
     /* 2342088 */ GIM_Reject,
     /* 2342089 */ // Label 32659: @2342089
     /* 2342089 */ GIM_Try, /*On fail goto*//*Label 32682*/ GIMT_Encode4(2342182),
     /* 2342094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2342097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2342100 */   GIM_Try, /*On fail goto*//*Label 32683*/ GIMT_Encode4(2342127), // Rule ID 1605 //
     /* 2342105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2342108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2342120 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2342120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2342125 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342126 */     // GIR_Coverage, 1605,
     /* 2342126 */     GIR_Done,
     /* 2342127 */   // Label 32683: @2342127
     /* 2342127 */   GIM_Try, /*On fail goto*//*Label 32684*/ GIMT_Encode4(2342154), // Rule ID 1606 //
     /* 2342132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2342135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2342147 */     // (fmaxnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2342147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2342152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342153 */     // GIR_Coverage, 1606,
     /* 2342153 */     GIR_Done,
     /* 2342154 */   // Label 32684: @2342154
     /* 2342154 */   GIM_Try, /*On fail goto*//*Label 32685*/ GIMT_Encode4(2342181), // Rule ID 1607 //
     /* 2342159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2342162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2342174 */     // (fmaxnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2342174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2342179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342180 */     // GIR_Coverage, 1607,
     /* 2342180 */     GIR_Done,
     /* 2342181 */   // Label 32685: @2342181
     /* 2342181 */   GIM_Reject,
     /* 2342182 */ // Label 32682: @2342182
     /* 2342182 */ GIM_Reject,
     /* 2342183 */ // Label 32660: @2342183
     /* 2342183 */ GIM_Try, /*On fail goto*//*Label 32686*/ GIMT_Encode4(2342297),
     /* 2342188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2342191 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2342194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342202 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342206 */   GIM_Try, /*On fail goto*//*Label 32687*/ GIMT_Encode4(2342251), // Rule ID 56494 //
     /* 2342211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2342214 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2342231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342238 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342249 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342250 */     // GIR_Coverage, 56494,
     /* 2342250 */     GIR_EraseRootFromParent_Done,
     /* 2342251 */   // Label 32687: @2342251
     /* 2342251 */   GIM_Try, /*On fail goto*//*Label 32688*/ GIMT_Encode4(2342296), // Rule ID 56495 //
     /* 2342256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2342259 */     // (fmaxnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2342262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2342276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342295 */     // GIR_Coverage, 56495,
     /* 2342295 */     GIR_EraseRootFromParent_Done,
     /* 2342296 */   // Label 32688: @2342296
     /* 2342296 */   GIM_Reject,
     /* 2342297 */ // Label 32686: @2342297
     /* 2342297 */ GIM_Reject,
     /* 2342298 */ // Label 32661: @2342298
     /* 2342298 */ GIM_Try, /*On fail goto*//*Label 32689*/ GIMT_Encode4(2342412),
     /* 2342303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2342306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2342309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342317 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342321 */   GIM_Try, /*On fail goto*//*Label 32690*/ GIMT_Encode4(2342366), // Rule ID 56506 //
     /* 2342326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2342329 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342341 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2342346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342348 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342365 */     // GIR_Coverage, 56506,
     /* 2342365 */     GIR_EraseRootFromParent_Done,
     /* 2342366 */   // Label 32690: @2342366
     /* 2342366 */   GIM_Try, /*On fail goto*//*Label 32691*/ GIMT_Encode4(2342411), // Rule ID 56507 //
     /* 2342371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2342374 */     // (fmaxnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2342377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2342391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342398 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342409 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342410 */     // GIR_Coverage, 56507,
     /* 2342410 */     GIR_EraseRootFromParent_Done,
     /* 2342411 */   // Label 32691: @2342411
     /* 2342411 */   GIM_Reject,
     /* 2342412 */ // Label 32689: @2342412
     /* 2342412 */ GIM_Reject,
     /* 2342413 */ // Label 32662: @2342413
     /* 2342413 */ GIM_Try, /*On fail goto*//*Label 32692*/ GIMT_Encode4(2342527),
     /* 2342418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2342421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2342424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342436 */   GIM_Try, /*On fail goto*//*Label 32693*/ GIMT_Encode4(2342481), // Rule ID 56524 //
     /* 2342441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2342444 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2342447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2342461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342480 */     // GIR_Coverage, 56524,
     /* 2342480 */     GIR_EraseRootFromParent_Done,
     /* 2342481 */   // Label 32693: @2342481
     /* 2342481 */   GIM_Try, /*On fail goto*//*Label 32694*/ GIMT_Encode4(2342526), // Rule ID 56525 //
     /* 2342486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2342489 */     // (fmaxnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342489 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2342492 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342496 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2342506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342513 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342525 */     // GIR_Coverage, 56525,
     /* 2342525 */     GIR_EraseRootFromParent_Done,
     /* 2342526 */   // Label 32694: @2342526
     /* 2342526 */   GIM_Reject,
     /* 2342527 */ // Label 32692: @2342527
     /* 2342527 */ GIM_Reject,
     /* 2342528 */ // Label 32663: @2342528
     /* 2342528 */ GIM_Try, /*On fail goto*//*Label 32695*/ GIMT_Encode4(2342642),
     /* 2342533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2342536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2342539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342551 */   GIM_Try, /*On fail goto*//*Label 32696*/ GIMT_Encode4(2342596), // Rule ID 56500 //
     /* 2342556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2342559 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2342562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2342576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342594 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342595 */     // GIR_Coverage, 56500,
     /* 2342595 */     GIR_EraseRootFromParent_Done,
     /* 2342596 */   // Label 32696: @2342596
     /* 2342596 */   GIM_Try, /*On fail goto*//*Label 32697*/ GIMT_Encode4(2342641), // Rule ID 56501 //
     /* 2342601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2342604 */     // (fmaxnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2342607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342616 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2342621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342623 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342640 */     // GIR_Coverage, 56501,
     /* 2342640 */     GIR_EraseRootFromParent_Done,
     /* 2342641 */   // Label 32697: @2342641
     /* 2342641 */   GIM_Reject,
     /* 2342642 */ // Label 32695: @2342642
     /* 2342642 */ GIM_Reject,
     /* 2342643 */ // Label 32664: @2342643
     /* 2342643 */ GIM_Try, /*On fail goto*//*Label 32698*/ GIMT_Encode4(2342757),
     /* 2342648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2342651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2342654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342662 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342666 */   GIM_Try, /*On fail goto*//*Label 32699*/ GIMT_Encode4(2342711), // Rule ID 56518 //
     /* 2342671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2342674 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2342677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2342691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342698 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342709 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342710 */     // GIR_Coverage, 56518,
     /* 2342710 */     GIR_EraseRootFromParent_Done,
     /* 2342711 */   // Label 32699: @2342711
     /* 2342711 */   GIM_Try, /*On fail goto*//*Label 32700*/ GIMT_Encode4(2342756), // Rule ID 56519 //
     /* 2342716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2342719 */     // (fmaxnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2342722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342731 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2342736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2342751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342755 */     // GIR_Coverage, 56519,
     /* 2342755 */     GIR_EraseRootFromParent_Done,
     /* 2342756 */   // Label 32700: @2342756
     /* 2342756 */   GIM_Reject,
     /* 2342757 */ // Label 32698: @2342757
     /* 2342757 */ GIM_Reject,
     /* 2342758 */ // Label 32665: @2342758
     /* 2342758 */ GIM_Try, /*On fail goto*//*Label 32701*/ GIMT_Encode4(2342872),
     /* 2342763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2342766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2342769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342777 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2342781 */   GIM_Try, /*On fail goto*//*Label 32702*/ GIMT_Encode4(2342826), // Rule ID 56566 //
     /* 2342786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2342789 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2342792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2342806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342824 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342825 */     // GIR_Coverage, 56566,
     /* 2342825 */     GIR_EraseRootFromParent_Done,
     /* 2342826 */   // Label 32702: @2342826
     /* 2342826 */   GIM_Try, /*On fail goto*//*Label 32703*/ GIMT_Encode4(2342871), // Rule ID 56567 //
     /* 2342831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2342834 */     // (fmaxnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2342837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2342851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2342866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342870 */     // GIR_Coverage, 56567,
     /* 2342870 */     GIR_EraseRootFromParent_Done,
     /* 2342871 */   // Label 32703: @2342871
     /* 2342871 */   GIM_Reject,
     /* 2342872 */ // Label 32701: @2342872
     /* 2342872 */ GIM_Reject,
     /* 2342873 */ // Label 32666: @2342873
     /* 2342873 */ GIM_Try, /*On fail goto*//*Label 32704*/ GIMT_Encode4(2342987),
     /* 2342878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2342881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2342884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2342896 */   GIM_Try, /*On fail goto*//*Label 32705*/ GIMT_Encode4(2342941), // Rule ID 56512 //
     /* 2342901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2342904 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2342904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2342907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2342921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342928 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342940 */     // GIR_Coverage, 56512,
     /* 2342940 */     GIR_EraseRootFromParent_Done,
     /* 2342941 */   // Label 32705: @2342941
     /* 2342941 */   GIM_Try, /*On fail goto*//*Label 32706*/ GIMT_Encode4(2342986), // Rule ID 56513 //
     /* 2342946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2342949 */     // (fmaxnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2342949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2342952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2342956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2342961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2342963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2342966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2342968 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2342971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2342973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2342975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2342978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2342981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2342984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2342985 */     // GIR_Coverage, 56513,
     /* 2342985 */     GIR_EraseRootFromParent_Done,
     /* 2342986 */   // Label 32706: @2342986
     /* 2342986 */   GIM_Reject,
     /* 2342987 */ // Label 32704: @2342987
     /* 2342987 */ GIM_Reject,
     /* 2342988 */ // Label 32667: @2342988
     /* 2342988 */ GIM_Try, /*On fail goto*//*Label 32707*/ GIMT_Encode4(2343102),
     /* 2342993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2342996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2342999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343011 */   GIM_Try, /*On fail goto*//*Label 32708*/ GIMT_Encode4(2343056), // Rule ID 56548 //
     /* 2343016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2343019 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2343022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2343036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343055 */     // GIR_Coverage, 56548,
     /* 2343055 */     GIR_EraseRootFromParent_Done,
     /* 2343056 */   // Label 32708: @2343056
     /* 2343056 */   GIM_Try, /*On fail goto*//*Label 32709*/ GIMT_Encode4(2343101), // Rule ID 56549 //
     /* 2343061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2343064 */     // (fmaxnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2343067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2343081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343100 */     // GIR_Coverage, 56549,
     /* 2343100 */     GIR_EraseRootFromParent_Done,
     /* 2343101 */   // Label 32709: @2343101
     /* 2343101 */   GIM_Reject,
     /* 2343102 */ // Label 32707: @2343102
     /* 2343102 */ GIM_Reject,
     /* 2343103 */ // Label 32668: @2343103
     /* 2343103 */ GIM_Try, /*On fail goto*//*Label 32710*/ GIMT_Encode4(2343217),
     /* 2343108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2343111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2343114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343126 */   GIM_Try, /*On fail goto*//*Label 32711*/ GIMT_Encode4(2343171), // Rule ID 56572 //
     /* 2343131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2343134 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2343137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2343151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343156 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343158 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343170 */     // GIR_Coverage, 56572,
     /* 2343170 */     GIR_EraseRootFromParent_Done,
     /* 2343171 */   // Label 32711: @2343171
     /* 2343171 */   GIM_Try, /*On fail goto*//*Label 32712*/ GIMT_Encode4(2343216), // Rule ID 56573 //
     /* 2343176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2343179 */     // (fmaxnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2343182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2343196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343215 */     // GIR_Coverage, 56573,
     /* 2343215 */     GIR_EraseRootFromParent_Done,
     /* 2343216 */   // Label 32712: @2343216
     /* 2343216 */   GIM_Reject,
     /* 2343217 */ // Label 32710: @2343217
     /* 2343217 */ GIM_Reject,
     /* 2343218 */ // Label 32669: @2343218
     /* 2343218 */ GIM_Try, /*On fail goto*//*Label 32713*/ GIMT_Encode4(2343332),
     /* 2343223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2343226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2343229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343237 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2343241 */   GIM_Try, /*On fail goto*//*Label 32714*/ GIMT_Encode4(2343286), // Rule ID 56530 //
     /* 2343246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343249 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2343252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343261 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2343266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343268 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343285 */     // GIR_Coverage, 56530,
     /* 2343285 */     GIR_EraseRootFromParent_Done,
     /* 2343286 */   // Label 32714: @2343286
     /* 2343286 */   GIM_Try, /*On fail goto*//*Label 32715*/ GIMT_Encode4(2343331), // Rule ID 56531 //
     /* 2343291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343294 */     // (fmaxnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2343297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2343311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343329 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343330 */     // GIR_Coverage, 56531,
     /* 2343330 */     GIR_EraseRootFromParent_Done,
     /* 2343331 */   // Label 32715: @2343331
     /* 2343331 */   GIM_Reject,
     /* 2343332 */ // Label 32713: @2343332
     /* 2343332 */ GIM_Reject,
     /* 2343333 */ // Label 32670: @2343333
     /* 2343333 */ GIM_Try, /*On fail goto*//*Label 32716*/ GIMT_Encode4(2343447),
     /* 2343338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2343341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2343344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343352 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343356 */   GIM_Try, /*On fail goto*//*Label 32717*/ GIMT_Encode4(2343401), // Rule ID 56554 //
     /* 2343361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2343364 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343364 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2343367 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343371 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2343381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343400 */     // GIR_Coverage, 56554,
     /* 2343400 */     GIR_EraseRootFromParent_Done,
     /* 2343401 */   // Label 32717: @2343401
     /* 2343401 */   GIM_Try, /*On fail goto*//*Label 32718*/ GIMT_Encode4(2343446), // Rule ID 56555 //
     /* 2343406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2343409 */     // (fmaxnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343409 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2343412 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343416 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2343426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343431 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343433 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343445 */     // GIR_Coverage, 56555,
     /* 2343445 */     GIR_EraseRootFromParent_Done,
     /* 2343446 */   // Label 32718: @2343446
     /* 2343446 */   GIM_Reject,
     /* 2343447 */ // Label 32716: @2343447
     /* 2343447 */ GIM_Reject,
     /* 2343448 */ // Label 32671: @2343448
     /* 2343448 */ GIM_Try, /*On fail goto*//*Label 32719*/ GIMT_Encode4(2343562),
     /* 2343453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2343456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2343459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343467 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343471 */   GIM_Try, /*On fail goto*//*Label 32720*/ GIMT_Encode4(2343516), // Rule ID 56578 //
     /* 2343476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2343479 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2343496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343501 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343503 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343515 */     // GIR_Coverage, 56578,
     /* 2343515 */     GIR_EraseRootFromParent_Done,
     /* 2343516 */   // Label 32720: @2343516
     /* 2343516 */   GIM_Try, /*On fail goto*//*Label 32721*/ GIMT_Encode4(2343561), // Rule ID 56579 //
     /* 2343521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2343524 */     // (fmaxnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343524 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2343527 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343531 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2343541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343548 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2343556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343560 */     // GIR_Coverage, 56579,
     /* 2343560 */     GIR_EraseRootFromParent_Done,
     /* 2343561 */   // Label 32721: @2343561
     /* 2343561 */   GIM_Reject,
     /* 2343562 */ // Label 32719: @2343562
     /* 2343562 */ GIM_Reject,
     /* 2343563 */ // Label 32672: @2343563
     /* 2343563 */ GIM_Try, /*On fail goto*//*Label 32722*/ GIMT_Encode4(2343677),
     /* 2343568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2343571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2343574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2343586 */   GIM_Try, /*On fail goto*//*Label 32723*/ GIMT_Encode4(2343631), // Rule ID 56536 //
     /* 2343591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343594 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2343611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343630 */     // GIR_Coverage, 56536,
     /* 2343630 */     GIR_EraseRootFromParent_Done,
     /* 2343631 */   // Label 32723: @2343631
     /* 2343631 */   GIM_Try, /*On fail goto*//*Label 32724*/ GIMT_Encode4(2343676), // Rule ID 56537 //
     /* 2343636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343639 */     // (fmaxnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2343642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2343656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343675 */     // GIR_Coverage, 56537,
     /* 2343675 */     GIR_EraseRootFromParent_Done,
     /* 2343676 */   // Label 32724: @2343676
     /* 2343676 */   GIM_Reject,
     /* 2343677 */ // Label 32722: @2343677
     /* 2343677 */ GIM_Reject,
     /* 2343678 */ // Label 32673: @2343678
     /* 2343678 */ GIM_Try, /*On fail goto*//*Label 32725*/ GIMT_Encode4(2343792),
     /* 2343683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2343686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2343689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343697 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343701 */   GIM_Try, /*On fail goto*//*Label 32726*/ GIMT_Encode4(2343746), // Rule ID 56560 //
     /* 2343706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2343709 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2343726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343728 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343731 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343733 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343745 */     // GIR_Coverage, 56560,
     /* 2343745 */     GIR_EraseRootFromParent_Done,
     /* 2343746 */   // Label 32726: @2343746
     /* 2343746 */   GIM_Try, /*On fail goto*//*Label 32727*/ GIMT_Encode4(2343791), // Rule ID 56561 //
     /* 2343751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2343754 */     // (fmaxnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2343757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2343771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343776 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343778 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2343786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343790 */     // GIR_Coverage, 56561,
     /* 2343790 */     GIR_EraseRootFromParent_Done,
     /* 2343791 */   // Label 32727: @2343791
     /* 2343791 */   GIM_Reject,
     /* 2343792 */ // Label 32725: @2343792
     /* 2343792 */ GIM_Reject,
     /* 2343793 */ // Label 32674: @2343793
     /* 2343793 */ GIM_Try, /*On fail goto*//*Label 32728*/ GIMT_Encode4(2343907),
     /* 2343798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2343801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2343804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343812 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2343816 */   GIM_Try, /*On fail goto*//*Label 32729*/ GIMT_Encode4(2343861), // Rule ID 56542 //
     /* 2343821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2343824 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2343824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2343841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343843 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343859 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343860 */     // GIR_Coverage, 56542,
     /* 2343860 */     GIR_EraseRootFromParent_Done,
     /* 2343861 */   // Label 32729: @2343861
     /* 2343861 */   GIM_Try, /*On fail goto*//*Label 32730*/ GIMT_Encode4(2343906), // Rule ID 56543 //
     /* 2343866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2343869 */     // (fmaxnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2343869 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2343872 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2343876 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2343881 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2343883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2343886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2343888 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2343891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2343893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2343895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2343898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2343901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2343904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2343905 */     // GIR_Coverage, 56543,
     /* 2343905 */     GIR_EraseRootFromParent_Done,
     /* 2343906 */   // Label 32730: @2343906
     /* 2343906 */   GIM_Reject,
     /* 2343907 */ // Label 32728: @2343907
     /* 2343907 */ GIM_Reject,
     /* 2343908 */ // Label 32675: @2343908
     /* 2343908 */ GIM_Reject,
     /* 2343909 */ // Label 76: @2343909
     /* 2343909 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32734*/ GIMT_Encode4(2344034),
     /* 2343920 */ /*GILLT_s16*//*Label 32731*/ GIMT_Encode4(2343932),
     /* 2343924 */ /*GILLT_s32*//*Label 32732*/ GIMT_Encode4(2343966),
     /* 2343928 */ /*GILLT_s64*//*Label 32733*/ GIMT_Encode4(2344000),
     /* 2343932 */ // Label 32731: @2343932
     /* 2343932 */ GIM_Try, /*On fail goto*//*Label 32735*/ GIMT_Encode4(2343965), // Rule ID 2298 //
     /* 2343937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2343940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2343943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2343946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2343950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2343954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2343958 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMINM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2343958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_H),
     /* 2343963 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343964 */   // GIR_Coverage, 2298,
     /* 2343964 */   GIR_Done,
     /* 2343965 */ // Label 32735: @2343965
     /* 2343965 */ GIM_Reject,
     /* 2343966 */ // Label 32732: @2343966
     /* 2343966 */ GIM_Try, /*On fail goto*//*Label 32736*/ GIMT_Encode4(2343999), // Rule ID 2216 //
     /* 2343971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2343974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2343977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2343980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2343984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2343988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2343992 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMINM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2343992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_S),
     /* 2343997 */   GIR_RootConstrainSelectedInstOperands,
     /* 2343998 */   // GIR_Coverage, 2216,
     /* 2343998 */   GIR_Done,
     /* 2343999 */ // Label 32736: @2343999
     /* 2343999 */ GIM_Reject,
     /* 2344000 */ // Label 32733: @2344000
     /* 2344000 */ GIM_Try, /*On fail goto*//*Label 32737*/ GIMT_Encode4(2344033), // Rule ID 2256 //
     /* 2344005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2344008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2344014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344026 */   // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMINM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMINM_D),
     /* 2344031 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344032 */   // GIR_Coverage, 2256,
     /* 2344032 */   GIR_Done,
     /* 2344033 */ // Label 32737: @2344033
     /* 2344033 */ GIM_Reject,
     /* 2344034 */ // Label 32734: @2344034
     /* 2344034 */ GIM_Reject,
     /* 2344035 */ // Label 77: @2344035
     /* 2344035 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 32741*/ GIMT_Encode4(2344160),
     /* 2344046 */ /*GILLT_s16*//*Label 32738*/ GIMT_Encode4(2344058),
     /* 2344050 */ /*GILLT_s32*//*Label 32739*/ GIMT_Encode4(2344092),
     /* 2344054 */ /*GILLT_s64*//*Label 32740*/ GIMT_Encode4(2344126),
     /* 2344058 */ // Label 32738: @2344058
     /* 2344058 */ GIM_Try, /*On fail goto*//*Label 32742*/ GIMT_Encode4(2344091), // Rule ID 2299 //
     /* 2344063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh),
     /* 2344066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2344069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2344072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344084 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAXM_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2344084 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_H),
     /* 2344089 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344090 */   // GIR_Coverage, 2299,
     /* 2344090 */   GIR_Done,
     /* 2344091 */ // Label 32742: @2344091
     /* 2344091 */ GIM_Reject,
     /* 2344092 */ // Label 32739: @2344092
     /* 2344092 */ GIM_Try, /*On fail goto*//*Label 32743*/ GIMT_Encode4(2344125), // Rule ID 2217 //
     /* 2344097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa),
     /* 2344100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2344106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344118 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAXM_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2344118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_S),
     /* 2344123 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344124 */   // GIR_Coverage, 2217,
     /* 2344124 */   GIR_Done,
     /* 2344125 */ // Label 32743: @2344125
     /* 2344125 */ GIM_Reject,
     /* 2344126 */ // Label 32740: @2344126
     /* 2344126 */ GIM_Try, /*On fail goto*//*Label 32744*/ GIMT_Encode4(2344159), // Rule ID 2257 //
     /* 2344131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa),
     /* 2344134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2344140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344148 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344152 */   // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAXM_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344152 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAXM_D),
     /* 2344157 */   GIR_RootConstrainSelectedInstOperands,
     /* 2344158 */   // GIR_Coverage, 2257,
     /* 2344158 */   GIR_Done,
     /* 2344159 */ // Label 32744: @2344159
     /* 2344159 */ GIM_Reject,
     /* 2344160 */ // Label 32741: @2344160
     /* 2344160 */ GIM_Reject,
     /* 2344161 */ // Label 78: @2344161
     /* 2344161 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32763*/ GIMT_Encode4(2346245),
     /* 2344172 */ /*GILLT_s16*//*Label 32745*/ GIMT_Encode4(2344292),
     /* 2344176 */ /*GILLT_s32*//*Label 32746*/ GIMT_Encode4(2344359),
     /* 2344180 */ /*GILLT_s64*//*Label 32747*/ GIMT_Encode4(2344426), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344192 */ /*GILLT_nxv1s16*//*Label 32748*/ GIMT_Encode4(2344520),
     /* 2344196 */ /*GILLT_nxv1s32*//*Label 32749*/ GIMT_Encode4(2344635),
     /* 2344200 */ /*GILLT_nxv1s64*//*Label 32750*/ GIMT_Encode4(2344750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344212 */ /*GILLT_nxv2s16*//*Label 32751*/ GIMT_Encode4(2344865),
     /* 2344216 */ /*GILLT_nxv2s32*//*Label 32752*/ GIMT_Encode4(2344980),
     /* 2344220 */ /*GILLT_nxv2s64*//*Label 32753*/ GIMT_Encode4(2345095), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344232 */ /*GILLT_nxv4s16*//*Label 32754*/ GIMT_Encode4(2345210),
     /* 2344236 */ /*GILLT_nxv4s32*//*Label 32755*/ GIMT_Encode4(2345325),
     /* 2344240 */ /*GILLT_nxv4s64*//*Label 32756*/ GIMT_Encode4(2345440), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344252 */ /*GILLT_nxv8s16*//*Label 32757*/ GIMT_Encode4(2345555),
     /* 2344256 */ /*GILLT_nxv8s32*//*Label 32758*/ GIMT_Encode4(2345670),
     /* 2344260 */ /*GILLT_nxv8s64*//*Label 32759*/ GIMT_Encode4(2345785), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344272 */ /*GILLT_nxv16s16*//*Label 32760*/ GIMT_Encode4(2345900),
     /* 2344276 */ /*GILLT_nxv16s32*//*Label 32761*/ GIMT_Encode4(2346015), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2344288 */ /*GILLT_nxv32s16*//*Label 32762*/ GIMT_Encode4(2346130),
     /* 2344292 */ // Label 32745: @2344292
     /* 2344292 */ GIM_Try, /*On fail goto*//*Label 32764*/ GIMT_Encode4(2344358),
     /* 2344297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2344300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2344303 */   GIM_Try, /*On fail goto*//*Label 32765*/ GIMT_Encode4(2344330), // Rule ID 1948 //
     /* 2344308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2344311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2344323 */     // (fminimumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMIN_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2344323 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H),
     /* 2344328 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344329 */     // GIR_Coverage, 1948,
     /* 2344329 */     GIR_Done,
     /* 2344330 */   // Label 32765: @2344330
     /* 2344330 */   GIM_Try, /*On fail goto*//*Label 32766*/ GIMT_Encode4(2344357), // Rule ID 1949 //
     /* 2344335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2344338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2344350 */     // (fminimumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMIN_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2344350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_H_INX),
     /* 2344355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344356 */     // GIR_Coverage, 1949,
     /* 2344356 */     GIR_Done,
     /* 2344357 */   // Label 32766: @2344357
     /* 2344357 */   GIM_Reject,
     /* 2344358 */ // Label 32764: @2344358
     /* 2344358 */ GIM_Reject,
     /* 2344359 */ // Label 32746: @2344359
     /* 2344359 */ GIM_Try, /*On fail goto*//*Label 32767*/ GIMT_Encode4(2344425),
     /* 2344364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2344367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2344370 */   GIM_Try, /*On fail goto*//*Label 32768*/ GIMT_Encode4(2344397), // Rule ID 1235 //
     /* 2344375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2344378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2344390 */     // (fminimumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMIN_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2344390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S),
     /* 2344395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344396 */     // GIR_Coverage, 1235,
     /* 2344396 */     GIR_Done,
     /* 2344397 */   // Label 32768: @2344397
     /* 2344397 */   GIM_Try, /*On fail goto*//*Label 32769*/ GIMT_Encode4(2344424), // Rule ID 1236 //
     /* 2344402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2344405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2344417 */     // (fminimumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMIN_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2344417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_S_INX),
     /* 2344422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344423 */     // GIR_Coverage, 1236,
     /* 2344423 */     GIR_Done,
     /* 2344424 */   // Label 32769: @2344424
     /* 2344424 */   GIM_Reject,
     /* 2344425 */ // Label 32767: @2344425
     /* 2344425 */ GIM_Reject,
     /* 2344426 */ // Label 32747: @2344426
     /* 2344426 */ GIM_Try, /*On fail goto*//*Label 32770*/ GIMT_Encode4(2344519),
     /* 2344431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2344434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2344437 */   GIM_Try, /*On fail goto*//*Label 32771*/ GIMT_Encode4(2344464), // Rule ID 1608 //
     /* 2344442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2344445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2344457 */     // (fminimumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMIN_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D),
     /* 2344462 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344463 */     // GIR_Coverage, 1608,
     /* 2344463 */     GIR_Done,
     /* 2344464 */   // Label 32771: @2344464
     /* 2344464 */   GIM_Try, /*On fail goto*//*Label 32772*/ GIMT_Encode4(2344491), // Rule ID 1609 //
     /* 2344469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2344472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2344484 */     // (fminimumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMIN_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_IN32X),
     /* 2344489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344490 */     // GIR_Coverage, 1609,
     /* 2344490 */     GIR_Done,
     /* 2344491 */   // Label 32772: @2344491
     /* 2344491 */   GIM_Try, /*On fail goto*//*Label 32773*/ GIMT_Encode4(2344518), // Rule ID 1610 //
     /* 2344496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2344499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2344511 */     // (fminimumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMIN_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2344511 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMIN_D_INX),
     /* 2344516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344517 */     // GIR_Coverage, 1610,
     /* 2344517 */     GIR_Done,
     /* 2344518 */   // Label 32773: @2344518
     /* 2344518 */   GIM_Reject,
     /* 2344519 */ // Label 32770: @2344519
     /* 2344519 */ GIM_Reject,
     /* 2344520 */ // Label 32748: @2344520
     /* 2344520 */ GIM_Try, /*On fail goto*//*Label 32774*/ GIMT_Encode4(2344634),
     /* 2344525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2344528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2344531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344543 */   GIM_Try, /*On fail goto*//*Label 32775*/ GIMT_Encode4(2344588), // Rule ID 56584 //
     /* 2344548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2344551 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2344554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2344568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344573 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344575 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344586 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344587 */     // GIR_Coverage, 56584,
     /* 2344587 */     GIR_EraseRootFromParent_Done,
     /* 2344588 */   // Label 32775: @2344588
     /* 2344588 */   GIM_Try, /*On fail goto*//*Label 32776*/ GIMT_Encode4(2344633), // Rule ID 56585 //
     /* 2344593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2344596 */     // (fminimumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2344599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF4_E16),
     /* 2344613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344625 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344632 */     // GIR_Coverage, 56585,
     /* 2344632 */     GIR_EraseRootFromParent_Done,
     /* 2344633 */   // Label 32776: @2344633
     /* 2344633 */   GIM_Reject,
     /* 2344634 */ // Label 32774: @2344634
     /* 2344634 */ GIM_Reject,
     /* 2344635 */ // Label 32749: @2344635
     /* 2344635 */ GIM_Try, /*On fail goto*//*Label 32777*/ GIMT_Encode4(2344749),
     /* 2344640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2344643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2344646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344654 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344658 */   GIM_Try, /*On fail goto*//*Label 32778*/ GIMT_Encode4(2344703), // Rule ID 56596 //
     /* 2344663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2344666 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344666 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2344669 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344673 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344678 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2344683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344702 */     // GIR_Coverage, 56596,
     /* 2344702 */     GIR_EraseRootFromParent_Done,
     /* 2344703 */   // Label 32778: @2344703
     /* 2344703 */   GIM_Try, /*On fail goto*//*Label 32779*/ GIMT_Encode4(2344748), // Rule ID 56597 //
     /* 2344708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2344711 */     // (fminimumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2344714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344723 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E32),
     /* 2344728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344733 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344735 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2344743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344746 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344747 */     // GIR_Coverage, 56597,
     /* 2344747 */     GIR_EraseRootFromParent_Done,
     /* 2344748 */   // Label 32779: @2344748
     /* 2344748 */   GIM_Reject,
     /* 2344749 */ // Label 32777: @2344749
     /* 2344749 */ GIM_Reject,
     /* 2344750 */ // Label 32750: @2344750
     /* 2344750 */ GIM_Try, /*On fail goto*//*Label 32780*/ GIMT_Encode4(2344864),
     /* 2344755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2344758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2344761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344769 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344773 */   GIM_Try, /*On fail goto*//*Label 32781*/ GIMT_Encode4(2344818), // Rule ID 56614 //
     /* 2344778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2344781 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344781 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344784 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344788 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2344798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344800 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344803 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344805 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344817 */     // GIR_Coverage, 56614,
     /* 2344817 */     GIR_EraseRootFromParent_Done,
     /* 2344818 */   // Label 32781: @2344818
     /* 2344818 */   GIM_Try, /*On fail goto*//*Label 32782*/ GIMT_Encode4(2344863), // Rule ID 56615 //
     /* 2344823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2344826 */     // (fminimumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2344829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E64),
     /* 2344843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2344858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344862 */     // GIR_Coverage, 56615,
     /* 2344862 */     GIR_EraseRootFromParent_Done,
     /* 2344863 */   // Label 32782: @2344863
     /* 2344863 */   GIM_Reject,
     /* 2344864 */ // Label 32780: @2344864
     /* 2344864 */ GIM_Reject,
     /* 2344865 */ // Label 32751: @2344865
     /* 2344865 */ GIM_Try, /*On fail goto*//*Label 32783*/ GIMT_Encode4(2344979),
     /* 2344870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2344873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2344876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344884 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344888 */   GIM_Try, /*On fail goto*//*Label 32784*/ GIMT_Encode4(2344933), // Rule ID 56590 //
     /* 2344893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2344896 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2344896 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344899 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344903 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2344913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344918 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344920 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344932 */     // GIR_Coverage, 56590,
     /* 2344932 */     GIR_EraseRootFromParent_Done,
     /* 2344933 */   // Label 32784: @2344933
     /* 2344933 */   GIM_Try, /*On fail goto*//*Label 32785*/ GIMT_Encode4(2344978), // Rule ID 56591 //
     /* 2344938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2344941 */     // (fminimumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMIN_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2344941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2344944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2344948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2344953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2344955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_MF2_E16),
     /* 2344958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2344960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2344963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2344965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2344967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2344970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2344973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2344976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2344977 */     // GIR_Coverage, 56591,
     /* 2344977 */     GIR_EraseRootFromParent_Done,
     /* 2344978 */   // Label 32785: @2344978
     /* 2344978 */   GIM_Reject,
     /* 2344979 */ // Label 32783: @2344979
     /* 2344979 */ GIM_Reject,
     /* 2344980 */ // Label 32752: @2344980
     /* 2344980 */ GIM_Try, /*On fail goto*//*Label 32786*/ GIMT_Encode4(2345094),
     /* 2344985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2344988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2344991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2344999 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345003 */   GIM_Try, /*On fail goto*//*Label 32787*/ GIMT_Encode4(2345048), // Rule ID 56608 //
     /* 2345008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345011 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2345014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2345028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345046 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345047 */     // GIR_Coverage, 56608,
     /* 2345047 */     GIR_EraseRootFromParent_Done,
     /* 2345048 */   // Label 32787: @2345048
     /* 2345048 */   GIM_Try, /*On fail goto*//*Label 32788*/ GIMT_Encode4(2345093), // Rule ID 56609 //
     /* 2345053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345056 */     // (fminimumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2345059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E32),
     /* 2345073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345092 */     // GIR_Coverage, 56609,
     /* 2345092 */     GIR_EraseRootFromParent_Done,
     /* 2345093 */   // Label 32788: @2345093
     /* 2345093 */   GIM_Reject,
     /* 2345094 */ // Label 32786: @2345094
     /* 2345094 */ GIM_Reject,
     /* 2345095 */ // Label 32753: @2345095
     /* 2345095 */ GIM_Try, /*On fail goto*//*Label 32789*/ GIMT_Encode4(2345209),
     /* 2345100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2345103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2345106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345118 */   GIM_Try, /*On fail goto*//*Label 32790*/ GIMT_Encode4(2345163), // Rule ID 56656 //
     /* 2345123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345126 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2345143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345162 */     // GIR_Coverage, 56656,
     /* 2345162 */     GIR_EraseRootFromParent_Done,
     /* 2345163 */   // Label 32790: @2345163
     /* 2345163 */   GIM_Try, /*On fail goto*//*Label 32791*/ GIMT_Encode4(2345208), // Rule ID 56657 //
     /* 2345168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345171 */     // (fminimumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345171 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2345174 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345178 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E64),
     /* 2345188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345193 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345207 */     // GIR_Coverage, 56657,
     /* 2345207 */     GIR_EraseRootFromParent_Done,
     /* 2345208 */   // Label 32791: @2345208
     /* 2345208 */   GIM_Reject,
     /* 2345209 */ // Label 32789: @2345209
     /* 2345209 */ GIM_Reject,
     /* 2345210 */ // Label 32754: @2345210
     /* 2345210 */ GIM_Try, /*On fail goto*//*Label 32792*/ GIMT_Encode4(2345324),
     /* 2345215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2345218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2345221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345225 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345229 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2345233 */   GIM_Try, /*On fail goto*//*Label 32793*/ GIMT_Encode4(2345278), // Rule ID 56602 //
     /* 2345238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345241 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2345258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345265 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345277 */     // GIR_Coverage, 56602,
     /* 2345277 */     GIR_EraseRootFromParent_Done,
     /* 2345278 */   // Label 32793: @2345278
     /* 2345278 */   GIM_Try, /*On fail goto*//*Label 32794*/ GIMT_Encode4(2345323), // Rule ID 56603 //
     /* 2345283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345286 */     // (fminimumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMIN_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345286 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2345289 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345293 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345298 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M1_E16),
     /* 2345303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345305 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345322 */     // GIR_Coverage, 56603,
     /* 2345322 */     GIR_EraseRootFromParent_Done,
     /* 2345323 */   // Label 32794: @2345323
     /* 2345323 */   GIM_Reject,
     /* 2345324 */ // Label 32792: @2345324
     /* 2345324 */ GIM_Reject,
     /* 2345325 */ // Label 32755: @2345325
     /* 2345325 */ GIM_Try, /*On fail goto*//*Label 32795*/ GIMT_Encode4(2345439),
     /* 2345330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2345333 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2345336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345344 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345348 */   GIM_Try, /*On fail goto*//*Label 32796*/ GIMT_Encode4(2345393), // Rule ID 56638 //
     /* 2345353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345356 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2345373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345378 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345380 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345392 */     // GIR_Coverage, 56638,
     /* 2345392 */     GIR_EraseRootFromParent_Done,
     /* 2345393 */   // Label 32796: @2345393
     /* 2345393 */   GIM_Try, /*On fail goto*//*Label 32797*/ GIMT_Encode4(2345438), // Rule ID 56639 //
     /* 2345398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345401 */     // (fminimumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2345404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E32),
     /* 2345418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345423 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345437 */     // GIR_Coverage, 56639,
     /* 2345437 */     GIR_EraseRootFromParent_Done,
     /* 2345438 */   // Label 32797: @2345438
     /* 2345438 */   GIM_Reject,
     /* 2345439 */ // Label 32795: @2345439
     /* 2345439 */ GIM_Reject,
     /* 2345440 */ // Label 32756: @2345440
     /* 2345440 */ GIM_Try, /*On fail goto*//*Label 32798*/ GIMT_Encode4(2345554),
     /* 2345445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2345448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2345451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345463 */   GIM_Try, /*On fail goto*//*Label 32799*/ GIMT_Encode4(2345508), // Rule ID 56662 //
     /* 2345468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345471 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2345488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345506 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345507 */     // GIR_Coverage, 56662,
     /* 2345507 */     GIR_EraseRootFromParent_Done,
     /* 2345508 */   // Label 32799: @2345508
     /* 2345508 */   GIM_Try, /*On fail goto*//*Label 32800*/ GIMT_Encode4(2345553), // Rule ID 56663 //
     /* 2345513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345516 */     // (fminimumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2345519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E64),
     /* 2345533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345551 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345552 */     // GIR_Coverage, 56663,
     /* 2345552 */     GIR_EraseRootFromParent_Done,
     /* 2345553 */   // Label 32800: @2345553
     /* 2345553 */   GIM_Reject,
     /* 2345554 */ // Label 32798: @2345554
     /* 2345554 */ GIM_Reject,
     /* 2345555 */ // Label 32757: @2345555
     /* 2345555 */ GIM_Try, /*On fail goto*//*Label 32801*/ GIMT_Encode4(2345669),
     /* 2345560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2345563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2345566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2345578 */   GIM_Try, /*On fail goto*//*Label 32802*/ GIMT_Encode4(2345623), // Rule ID 56620 //
     /* 2345583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345586 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2345603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345622 */     // GIR_Coverage, 56620,
     /* 2345622 */     GIR_EraseRootFromParent_Done,
     /* 2345623 */   // Label 32802: @2345623
     /* 2345623 */   GIM_Try, /*On fail goto*//*Label 32803*/ GIMT_Encode4(2345668), // Rule ID 56621 //
     /* 2345628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345631 */     // (fminimumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMIN_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2345634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M2_E16),
     /* 2345648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345655 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345667 */     // GIR_Coverage, 56621,
     /* 2345667 */     GIR_EraseRootFromParent_Done,
     /* 2345668 */   // Label 32803: @2345668
     /* 2345668 */   GIM_Reject,
     /* 2345669 */ // Label 32801: @2345669
     /* 2345669 */ GIM_Reject,
     /* 2345670 */ // Label 32758: @2345670
     /* 2345670 */ GIM_Try, /*On fail goto*//*Label 32804*/ GIMT_Encode4(2345784),
     /* 2345675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2345678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2345681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345693 */   GIM_Try, /*On fail goto*//*Label 32805*/ GIMT_Encode4(2345738), // Rule ID 56644 //
     /* 2345698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2345701 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2345718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345720 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345737 */     // GIR_Coverage, 56644,
     /* 2345737 */     GIR_EraseRootFromParent_Done,
     /* 2345738 */   // Label 32805: @2345738
     /* 2345738 */   GIM_Try, /*On fail goto*//*Label 32806*/ GIMT_Encode4(2345783), // Rule ID 56645 //
     /* 2345743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2345746 */     // (fminimumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2345749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E32),
     /* 2345763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2345778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345781 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345782 */     // GIR_Coverage, 56645,
     /* 2345782 */     GIR_EraseRootFromParent_Done,
     /* 2345783 */   // Label 32806: @2345783
     /* 2345783 */   GIM_Reject,
     /* 2345784 */ // Label 32804: @2345784
     /* 2345784 */ GIM_Reject,
     /* 2345785 */ // Label 32759: @2345785
     /* 2345785 */ GIM_Try, /*On fail goto*//*Label 32807*/ GIMT_Encode4(2345899),
     /* 2345790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2345793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2345796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345804 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2345808 */   GIM_Try, /*On fail goto*//*Label 32808*/ GIMT_Encode4(2345853), // Rule ID 56668 //
     /* 2345813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2345816 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2345833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345851 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345852 */     // GIR_Coverage, 56668,
     /* 2345852 */     GIR_EraseRootFromParent_Done,
     /* 2345853 */   // Label 32808: @2345853
     /* 2345853 */   GIM_Try, /*On fail goto*//*Label 32809*/ GIMT_Encode4(2345898), // Rule ID 56669 //
     /* 2345858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2345861 */     // (fminimumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2345864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E64),
     /* 2345878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345885 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2345893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345897 */     // GIR_Coverage, 56669,
     /* 2345897 */     GIR_EraseRootFromParent_Done,
     /* 2345898 */   // Label 32809: @2345898
     /* 2345898 */   GIM_Reject,
     /* 2345899 */ // Label 32807: @2345899
     /* 2345899 */ GIM_Reject,
     /* 2345900 */ // Label 32760: @2345900
     /* 2345900 */ GIM_Try, /*On fail goto*//*Label 32810*/ GIMT_Encode4(2346014),
     /* 2345905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2345908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2345911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345919 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2345923 */   GIM_Try, /*On fail goto*//*Label 32811*/ GIMT_Encode4(2345968), // Rule ID 56626 //
     /* 2345928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2345931 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2345931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2345934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2345948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345953 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2345955 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2345957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2345960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2345963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2345966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2345967 */     // GIR_Coverage, 56626,
     /* 2345967 */     GIR_EraseRootFromParent_Done,
     /* 2345968 */   // Label 32811: @2345968
     /* 2345968 */   GIM_Try, /*On fail goto*//*Label 32812*/ GIMT_Encode4(2346013), // Rule ID 56627 //
     /* 2345973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2345976 */     // (fminimumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMIN_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2345976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2345979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2345983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2345988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2345990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M4_E16),
     /* 2345993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2345995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2345998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346000 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346012 */     // GIR_Coverage, 56627,
     /* 2346012 */     GIR_EraseRootFromParent_Done,
     /* 2346013 */   // Label 32812: @2346013
     /* 2346013 */   GIM_Reject,
     /* 2346014 */ // Label 32810: @2346014
     /* 2346014 */ GIM_Reject,
     /* 2346015 */ // Label 32761: @2346015
     /* 2346015 */ GIM_Try, /*On fail goto*//*Label 32813*/ GIMT_Encode4(2346129),
     /* 2346020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2346023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2346026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346034 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346038 */   GIM_Try, /*On fail goto*//*Label 32814*/ GIMT_Encode4(2346083), // Rule ID 56650 //
     /* 2346043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2346046 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2346063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346068 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346070 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346082 */     // GIR_Coverage, 56650,
     /* 2346082 */     GIR_EraseRootFromParent_Done,
     /* 2346083 */   // Label 32814: @2346083
     /* 2346083 */   GIM_Try, /*On fail goto*//*Label 32815*/ GIMT_Encode4(2346128), // Rule ID 56651 //
     /* 2346088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2346091 */     // (fminimumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2346094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E32),
     /* 2346108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346127 */     // GIR_Coverage, 56651,
     /* 2346127 */     GIR_EraseRootFromParent_Done,
     /* 2346128 */   // Label 32815: @2346128
     /* 2346128 */   GIM_Reject,
     /* 2346129 */ // Label 32813: @2346129
     /* 2346129 */ GIM_Reject,
     /* 2346130 */ // Label 32762: @2346130
     /* 2346130 */ GIM_Try, /*On fail goto*//*Label 32816*/ GIMT_Encode4(2346244),
     /* 2346135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2346138 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2346141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346149 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2346153 */   GIM_Try, /*On fail goto*//*Label 32817*/ GIMT_Encode4(2346198), // Rule ID 56632 //
     /* 2346158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346161 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2346178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346185 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346197 */     // GIR_Coverage, 56632,
     /* 2346197 */     GIR_EraseRootFromParent_Done,
     /* 2346198 */   // Label 32817: @2346198
     /* 2346198 */   GIM_Try, /*On fail goto*//*Label 32818*/ GIMT_Encode4(2346243), // Rule ID 56633 //
     /* 2346203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2346206 */     // (fminimumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMIN_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2346209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346218 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMIN_VV_M8_E16),
     /* 2346223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346228 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346230 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346241 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346242 */     // GIR_Coverage, 56633,
     /* 2346242 */     GIR_EraseRootFromParent_Done,
     /* 2346243 */   // Label 32818: @2346243
     /* 2346243 */   GIM_Reject,
     /* 2346244 */ // Label 32816: @2346244
     /* 2346244 */ GIM_Reject,
     /* 2346245 */ // Label 32763: @2346245
     /* 2346245 */ GIM_Reject,
     /* 2346246 */ // Label 79: @2346246
     /* 2346246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 32837*/ GIMT_Encode4(2348330),
     /* 2346257 */ /*GILLT_s16*//*Label 32819*/ GIMT_Encode4(2346377),
     /* 2346261 */ /*GILLT_s32*//*Label 32820*/ GIMT_Encode4(2346444),
     /* 2346265 */ /*GILLT_s64*//*Label 32821*/ GIMT_Encode4(2346511), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346277 */ /*GILLT_nxv1s16*//*Label 32822*/ GIMT_Encode4(2346605),
     /* 2346281 */ /*GILLT_nxv1s32*//*Label 32823*/ GIMT_Encode4(2346720),
     /* 2346285 */ /*GILLT_nxv1s64*//*Label 32824*/ GIMT_Encode4(2346835), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346297 */ /*GILLT_nxv2s16*//*Label 32825*/ GIMT_Encode4(2346950),
     /* 2346301 */ /*GILLT_nxv2s32*//*Label 32826*/ GIMT_Encode4(2347065),
     /* 2346305 */ /*GILLT_nxv2s64*//*Label 32827*/ GIMT_Encode4(2347180), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346317 */ /*GILLT_nxv4s16*//*Label 32828*/ GIMT_Encode4(2347295),
     /* 2346321 */ /*GILLT_nxv4s32*//*Label 32829*/ GIMT_Encode4(2347410),
     /* 2346325 */ /*GILLT_nxv4s64*//*Label 32830*/ GIMT_Encode4(2347525), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346337 */ /*GILLT_nxv8s16*//*Label 32831*/ GIMT_Encode4(2347640),
     /* 2346341 */ /*GILLT_nxv8s32*//*Label 32832*/ GIMT_Encode4(2347755),
     /* 2346345 */ /*GILLT_nxv8s64*//*Label 32833*/ GIMT_Encode4(2347870), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346357 */ /*GILLT_nxv16s16*//*Label 32834*/ GIMT_Encode4(2347985),
     /* 2346361 */ /*GILLT_nxv16s32*//*Label 32835*/ GIMT_Encode4(2348100), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2346373 */ /*GILLT_nxv32s16*//*Label 32836*/ GIMT_Encode4(2348215),
     /* 2346377 */ // Label 32819: @2346377
     /* 2346377 */ GIM_Try, /*On fail goto*//*Label 32838*/ GIMT_Encode4(2346443),
     /* 2346382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2346385 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2346388 */   GIM_Try, /*On fail goto*//*Label 32839*/ GIMT_Encode4(2346415), // Rule ID 1950 //
     /* 2346393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh),
     /* 2346396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2346408 */     // (fmaximumnum:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMAX_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2346408 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H),
     /* 2346413 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346414 */     // GIR_Coverage, 1950,
     /* 2346414 */     GIR_Done,
     /* 2346415 */   // Label 32839: @2346415
     /* 2346415 */   GIM_Try, /*On fail goto*//*Label 32840*/ GIMT_Encode4(2346442), // Rule ID 1951 //
     /* 2346420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx),
     /* 2346423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2346435 */     // (fmaximumnum:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMAX_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2)
     /* 2346435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_H_INX),
     /* 2346440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346441 */     // GIR_Coverage, 1951,
     /* 2346441 */     GIR_Done,
     /* 2346442 */   // Label 32840: @2346442
     /* 2346442 */   GIM_Reject,
     /* 2346443 */ // Label 32838: @2346443
     /* 2346443 */ GIM_Reject,
     /* 2346444 */ // Label 32820: @2346444
     /* 2346444 */ GIM_Try, /*On fail goto*//*Label 32841*/ GIMT_Encode4(2346510),
     /* 2346449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2346452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2346455 */   GIM_Try, /*On fail goto*//*Label 32842*/ GIMT_Encode4(2346482), // Rule ID 1237 //
     /* 2346460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF),
     /* 2346463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2346475 */     // (fmaximumnum:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMAX_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2346475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S),
     /* 2346480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346481 */     // GIR_Coverage, 1237,
     /* 2346481 */     GIR_Done,
     /* 2346482 */   // Label 32842: @2346482
     /* 2346482 */   GIM_Try, /*On fail goto*//*Label 32843*/ GIMT_Encode4(2346509), // Rule ID 1238 //
     /* 2346487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx),
     /* 2346490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2346502 */     // (fmaximumnum:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMAX_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2)
     /* 2346502 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_S_INX),
     /* 2346507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346508 */     // GIR_Coverage, 1238,
     /* 2346508 */     GIR_Done,
     /* 2346509 */   // Label 32843: @2346509
     /* 2346509 */   GIM_Reject,
     /* 2346510 */ // Label 32841: @2346510
     /* 2346510 */ GIM_Reject,
     /* 2346511 */ // Label 32821: @2346511
     /* 2346511 */ GIM_Try, /*On fail goto*//*Label 32844*/ GIMT_Encode4(2346604),
     /* 2346516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2346519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2346522 */   GIM_Try, /*On fail goto*//*Label 32845*/ GIMT_Encode4(2346549), // Rule ID 1611 //
     /* 2346527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD),
     /* 2346530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2346542 */     // (fmaximumnum:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMAX_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D),
     /* 2346547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346548 */     // GIR_Coverage, 1611,
     /* 2346548 */     GIR_Done,
     /* 2346549 */   // Label 32845: @2346549
     /* 2346549 */   GIM_Try, /*On fail goto*//*Label 32846*/ GIMT_Encode4(2346576), // Rule ID 1612 //
     /* 2346554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32),
     /* 2346557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2346569 */     // (fmaximumnum:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMAX_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346569 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_IN32X),
     /* 2346574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346575 */     // GIR_Coverage, 1612,
     /* 2346575 */     GIR_Done,
     /* 2346576 */   // Label 32846: @2346576
     /* 2346576 */   GIM_Try, /*On fail goto*//*Label 32847*/ GIMT_Encode4(2346603), // Rule ID 1613 //
     /* 2346581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2346584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2346596 */     // (fmaximumnum:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMAX_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2)
     /* 2346596 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FMAX_D_INX),
     /* 2346601 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346602 */     // GIR_Coverage, 1613,
     /* 2346602 */     GIR_Done,
     /* 2346603 */   // Label 32847: @2346603
     /* 2346603 */   GIM_Reject,
     /* 2346604 */ // Label 32844: @2346604
     /* 2346604 */ GIM_Reject,
     /* 2346605 */ // Label 32822: @2346605
     /* 2346605 */ GIM_Try, /*On fail goto*//*Label 32848*/ GIMT_Encode4(2346719),
     /* 2346610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2346613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2346616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346620 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346624 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346628 */   GIM_Try, /*On fail goto*//*Label 32849*/ GIMT_Encode4(2346673), // Rule ID 56674 //
     /* 2346633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346636 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2346639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2346653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346672 */     // GIR_Coverage, 56674,
     /* 2346672 */     GIR_EraseRootFromParent_Done,
     /* 2346673 */   // Label 32849: @2346673
     /* 2346673 */   GIM_Try, /*On fail goto*//*Label 32850*/ GIMT_Encode4(2346718), // Rule ID 56675 //
     /* 2346678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2346681 */     // (fmaximumnum:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346681 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2346684 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346688 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF4_E16),
     /* 2346698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346703 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346705 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2346713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346717 */     // GIR_Coverage, 56675,
     /* 2346717 */     GIR_EraseRootFromParent_Done,
     /* 2346718 */   // Label 32850: @2346718
     /* 2346718 */   GIM_Reject,
     /* 2346719 */ // Label 32848: @2346719
     /* 2346719 */ GIM_Reject,
     /* 2346720 */ // Label 32823: @2346720
     /* 2346720 */ GIM_Try, /*On fail goto*//*Label 32851*/ GIMT_Encode4(2346834),
     /* 2346725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2346728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2346731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346743 */   GIM_Try, /*On fail goto*//*Label 32852*/ GIMT_Encode4(2346788), // Rule ID 56686 //
     /* 2346748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2346751 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2346754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2346768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346770 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346773 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346787 */     // GIR_Coverage, 56686,
     /* 2346787 */     GIR_EraseRootFromParent_Done,
     /* 2346788 */   // Label 32852: @2346788
     /* 2346788 */   GIM_Try, /*On fail goto*//*Label 32853*/ GIMT_Encode4(2346833), // Rule ID 56687 //
     /* 2346793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2346796 */     // (fmaximumnum:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2346799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E32),
     /* 2346813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346818 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346820 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2346828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346832 */     // GIR_Coverage, 56687,
     /* 2346832 */     GIR_EraseRootFromParent_Done,
     /* 2346833 */   // Label 32853: @2346833
     /* 2346833 */   GIM_Reject,
     /* 2346834 */ // Label 32851: @2346834
     /* 2346834 */ GIM_Reject,
     /* 2346835 */ // Label 32824: @2346835
     /* 2346835 */ GIM_Try, /*On fail goto*//*Label 32854*/ GIMT_Encode4(2346949),
     /* 2346840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2346843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2346846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346858 */   GIM_Try, /*On fail goto*//*Label 32855*/ GIMT_Encode4(2346903), // Rule ID 56704 //
     /* 2346863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2346866 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2346869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2346883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346902 */     // GIR_Coverage, 56704,
     /* 2346902 */     GIR_EraseRootFromParent_Done,
     /* 2346903 */   // Label 32855: @2346903
     /* 2346903 */   GIM_Try, /*On fail goto*//*Label 32856*/ GIMT_Encode4(2346948), // Rule ID 56705 //
     /* 2346908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2346911 */     // (fmaximumnum:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2346911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2346914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E64),
     /* 2346928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2346930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2346933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2346935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2346937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2346940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2346943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2346946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2346947 */     // GIR_Coverage, 56705,
     /* 2346947 */     GIR_EraseRootFromParent_Done,
     /* 2346948 */   // Label 32856: @2346948
     /* 2346948 */   GIM_Reject,
     /* 2346949 */ // Label 32854: @2346949
     /* 2346949 */ GIM_Reject,
     /* 2346950 */ // Label 32825: @2346950
     /* 2346950 */ GIM_Try, /*On fail goto*//*Label 32857*/ GIMT_Encode4(2347064),
     /* 2346955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2346958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2346961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346965 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346969 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2346973 */   GIM_Try, /*On fail goto*//*Label 32858*/ GIMT_Encode4(2347018), // Rule ID 56680 //
     /* 2346978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2346981 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2346981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2346984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2346988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2346993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2346995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2346998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347003 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347005 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347017 */     // GIR_Coverage, 56680,
     /* 2347017 */     GIR_EraseRootFromParent_Done,
     /* 2347018 */   // Label 32858: @2347018
     /* 2347018 */   GIM_Try, /*On fail goto*//*Label 32859*/ GIMT_Encode4(2347063), // Rule ID 56681 //
     /* 2347023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347026 */     // (fmaximumnum:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMAX_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2347029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_MF2_E16),
     /* 2347043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347061 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347062 */     // GIR_Coverage, 56681,
     /* 2347062 */     GIR_EraseRootFromParent_Done,
     /* 2347063 */   // Label 32859: @2347063
     /* 2347063 */   GIM_Reject,
     /* 2347064 */ // Label 32857: @2347064
     /* 2347064 */ GIM_Reject,
     /* 2347065 */ // Label 32826: @2347065
     /* 2347065 */ GIM_Try, /*On fail goto*//*Label 32860*/ GIMT_Encode4(2347179),
     /* 2347070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2347073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2347076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347084 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347088 */   GIM_Try, /*On fail goto*//*Label 32861*/ GIMT_Encode4(2347133), // Rule ID 56698 //
     /* 2347093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347096 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2347099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2347113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347118 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347120 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347132 */     // GIR_Coverage, 56698,
     /* 2347132 */     GIR_EraseRootFromParent_Done,
     /* 2347133 */   // Label 32861: @2347133
     /* 2347133 */   GIM_Try, /*On fail goto*//*Label 32862*/ GIMT_Encode4(2347178), // Rule ID 56699 //
     /* 2347138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347141 */     // (fmaximumnum:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2347144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E32),
     /* 2347158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347177 */     // GIR_Coverage, 56699,
     /* 2347177 */     GIR_EraseRootFromParent_Done,
     /* 2347178 */   // Label 32862: @2347178
     /* 2347178 */   GIM_Reject,
     /* 2347179 */ // Label 32860: @2347179
     /* 2347179 */ GIM_Reject,
     /* 2347180 */ // Label 32827: @2347180
     /* 2347180 */ GIM_Try, /*On fail goto*//*Label 32863*/ GIMT_Encode4(2347294),
     /* 2347185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2347188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2347191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347203 */   GIM_Try, /*On fail goto*//*Label 32864*/ GIMT_Encode4(2347248), // Rule ID 56746 //
     /* 2347208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347211 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2347228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347233 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347235 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347247 */     // GIR_Coverage, 56746,
     /* 2347247 */     GIR_EraseRootFromParent_Done,
     /* 2347248 */   // Label 32864: @2347248
     /* 2347248 */   GIM_Try, /*On fail goto*//*Label 32865*/ GIMT_Encode4(2347293), // Rule ID 56747 //
     /* 2347253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347256 */     // (fmaximumnum:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2347259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E64),
     /* 2347273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347278 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347280 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347292 */     // GIR_Coverage, 56747,
     /* 2347292 */     GIR_EraseRootFromParent_Done,
     /* 2347293 */   // Label 32865: @2347293
     /* 2347293 */   GIM_Reject,
     /* 2347294 */ // Label 32863: @2347294
     /* 2347294 */ GIM_Reject,
     /* 2347295 */ // Label 32828: @2347295
     /* 2347295 */ GIM_Try, /*On fail goto*//*Label 32866*/ GIMT_Encode4(2347409),
     /* 2347300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2347303 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2347306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347314 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2347318 */   GIM_Try, /*On fail goto*//*Label 32867*/ GIMT_Encode4(2347363), // Rule ID 56692 //
     /* 2347323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347326 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2347343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347348 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347350 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347361 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347362 */     // GIR_Coverage, 56692,
     /* 2347362 */     GIR_EraseRootFromParent_Done,
     /* 2347363 */   // Label 32867: @2347363
     /* 2347363 */   GIM_Try, /*On fail goto*//*Label 32868*/ GIMT_Encode4(2347408), // Rule ID 56693 //
     /* 2347368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347371 */     // (fmaximumnum:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMAX_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2347374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M1_E16),
     /* 2347388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347393 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347395 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347407 */     // GIR_Coverage, 56693,
     /* 2347407 */     GIR_EraseRootFromParent_Done,
     /* 2347408 */   // Label 32868: @2347408
     /* 2347408 */   GIM_Reject,
     /* 2347409 */ // Label 32866: @2347409
     /* 2347409 */ GIM_Reject,
     /* 2347410 */ // Label 32829: @2347410
     /* 2347410 */ GIM_Try, /*On fail goto*//*Label 32869*/ GIMT_Encode4(2347524),
     /* 2347415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2347418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2347421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347429 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347433 */   GIM_Try, /*On fail goto*//*Label 32870*/ GIMT_Encode4(2347478), // Rule ID 56728 //
     /* 2347438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347441 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2347458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347465 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347477 */     // GIR_Coverage, 56728,
     /* 2347477 */     GIR_EraseRootFromParent_Done,
     /* 2347478 */   // Label 32870: @2347478
     /* 2347478 */   GIM_Try, /*On fail goto*//*Label 32871*/ GIMT_Encode4(2347523), // Rule ID 56729 //
     /* 2347483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347486 */     // (fmaximumnum:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2347489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E32),
     /* 2347503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347522 */     // GIR_Coverage, 56729,
     /* 2347522 */     GIR_EraseRootFromParent_Done,
     /* 2347523 */   // Label 32871: @2347523
     /* 2347523 */   GIM_Reject,
     /* 2347524 */ // Label 32869: @2347524
     /* 2347524 */ GIM_Reject,
     /* 2347525 */ // Label 32830: @2347525
     /* 2347525 */ GIM_Try, /*On fail goto*//*Label 32872*/ GIMT_Encode4(2347639),
     /* 2347530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2347533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2347536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347548 */   GIM_Try, /*On fail goto*//*Label 32873*/ GIMT_Encode4(2347593), // Rule ID 56752 //
     /* 2347553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347556 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2347573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347592 */     // GIR_Coverage, 56752,
     /* 2347592 */     GIR_EraseRootFromParent_Done,
     /* 2347593 */   // Label 32873: @2347593
     /* 2347593 */   GIM_Try, /*On fail goto*//*Label 32874*/ GIMT_Encode4(2347638), // Rule ID 56753 //
     /* 2347598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347601 */     // (fmaximumnum:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2347604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E64),
     /* 2347618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347625 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347637 */     // GIR_Coverage, 56753,
     /* 2347637 */     GIR_EraseRootFromParent_Done,
     /* 2347638 */   // Label 32874: @2347638
     /* 2347638 */   GIM_Reject,
     /* 2347639 */ // Label 32872: @2347639
     /* 2347639 */ GIM_Reject,
     /* 2347640 */ // Label 32831: @2347640
     /* 2347640 */ GIM_Try, /*On fail goto*//*Label 32875*/ GIMT_Encode4(2347754),
     /* 2347645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2347648 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2347651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347659 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2347663 */   GIM_Try, /*On fail goto*//*Label 32876*/ GIMT_Encode4(2347708), // Rule ID 56710 //
     /* 2347668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2347671 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347683 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2347688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347707 */     // GIR_Coverage, 56710,
     /* 2347707 */     GIR_EraseRootFromParent_Done,
     /* 2347708 */   // Label 32876: @2347708
     /* 2347708 */   GIM_Try, /*On fail goto*//*Label 32877*/ GIMT_Encode4(2347753), // Rule ID 56711 //
     /* 2347713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2347716 */     // (fmaximumnum:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMAX_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2347719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M2_E16),
     /* 2347733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2347748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347752 */     // GIR_Coverage, 56711,
     /* 2347752 */     GIR_EraseRootFromParent_Done,
     /* 2347753 */   // Label 32877: @2347753
     /* 2347753 */   GIM_Reject,
     /* 2347754 */ // Label 32875: @2347754
     /* 2347754 */ GIM_Reject,
     /* 2347755 */ // Label 32832: @2347755
     /* 2347755 */ GIM_Try, /*On fail goto*//*Label 32878*/ GIMT_Encode4(2347869),
     /* 2347760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2347763 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2347766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347774 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2347778 */   GIM_Try, /*On fail goto*//*Label 32879*/ GIMT_Encode4(2347823), // Rule ID 56734 //
     /* 2347783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2347786 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2347789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347798 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2347803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347822 */     // GIR_Coverage, 56734,
     /* 2347822 */     GIR_EraseRootFromParent_Done,
     /* 2347823 */   // Label 32879: @2347823
     /* 2347823 */   GIM_Try, /*On fail goto*//*Label 32880*/ GIMT_Encode4(2347868), // Rule ID 56735 //
     /* 2347828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2347831 */     // (fmaximumnum:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2347834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E32),
     /* 2347848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347853 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347855 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2347863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347867 */     // GIR_Coverage, 56735,
     /* 2347867 */     GIR_EraseRootFromParent_Done,
     /* 2347868 */   // Label 32880: @2347868
     /* 2347868 */   GIM_Reject,
     /* 2347869 */ // Label 32878: @2347869
     /* 2347869 */ GIM_Reject,
     /* 2347870 */ // Label 32833: @2347870
     /* 2347870 */ GIM_Try, /*On fail goto*//*Label 32881*/ GIMT_Encode4(2347984),
     /* 2347875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2347878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2347881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347889 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2347893 */   GIM_Try, /*On fail goto*//*Label 32882*/ GIMT_Encode4(2347938), // Rule ID 56758 //
     /* 2347898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2347901 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2347901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2347904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2347918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347920 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347925 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347937 */     // GIR_Coverage, 56758,
     /* 2347937 */     GIR_EraseRootFromParent_Done,
     /* 2347938 */   // Label 32882: @2347938
     /* 2347938 */   GIM_Try, /*On fail goto*//*Label 32883*/ GIMT_Encode4(2347983), // Rule ID 56759 //
     /* 2347943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2347946 */     // (fmaximumnum:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2347946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2347949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2347953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2347958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2347960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E64),
     /* 2347963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2347965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2347968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2347970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2347972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2347975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2347978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2347981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2347982 */     // GIR_Coverage, 56759,
     /* 2347982 */     GIR_EraseRootFromParent_Done,
     /* 2347983 */   // Label 32883: @2347983
     /* 2347983 */   GIM_Reject,
     /* 2347984 */ // Label 32881: @2347984
     /* 2347984 */ GIM_Reject,
     /* 2347985 */ // Label 32834: @2347985
     /* 2347985 */ GIM_Try, /*On fail goto*//*Label 32884*/ GIMT_Encode4(2348099),
     /* 2347990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2347993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2347996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348004 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2348008 */   GIM_Try, /*On fail goto*//*Label 32885*/ GIMT_Encode4(2348053), // Rule ID 56716 //
     /* 2348013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348016 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2348033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348038 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348040 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348052 */     // GIR_Coverage, 56716,
     /* 2348052 */     GIR_EraseRootFromParent_Done,
     /* 2348053 */   // Label 32885: @2348053
     /* 2348053 */   GIM_Try, /*On fail goto*//*Label 32886*/ GIMT_Encode4(2348098), // Rule ID 56717 //
     /* 2348058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348061 */     // (fmaximumnum:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMAX_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2348064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M4_E16),
     /* 2348078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348085 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348097 */     // GIR_Coverage, 56717,
     /* 2348097 */     GIR_EraseRootFromParent_Done,
     /* 2348098 */   // Label 32886: @2348098
     /* 2348098 */   GIM_Reject,
     /* 2348099 */ // Label 32884: @2348099
     /* 2348099 */ GIM_Reject,
     /* 2348100 */ // Label 32835: @2348100
     /* 2348100 */ GIM_Try, /*On fail goto*//*Label 32887*/ GIMT_Encode4(2348214),
     /* 2348105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2348108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2348111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348123 */   GIM_Try, /*On fail goto*//*Label 32888*/ GIMT_Encode4(2348168), // Rule ID 56740 //
     /* 2348128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2348131 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2348148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348167 */     // GIR_Coverage, 56740,
     /* 2348167 */     GIR_EraseRootFromParent_Done,
     /* 2348168 */   // Label 32888: @2348168
     /* 2348168 */   GIM_Try, /*On fail goto*//*Label 32889*/ GIMT_Encode4(2348213), // Rule ID 56741 //
     /* 2348173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2348176 */     // (fmaximumnum:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348176 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2348179 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348183 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E32),
     /* 2348193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348195 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348212 */     // GIR_Coverage, 56741,
     /* 2348212 */     GIR_EraseRootFromParent_Done,
     /* 2348213 */   // Label 32889: @2348213
     /* 2348213 */   GIM_Reject,
     /* 2348214 */ // Label 32887: @2348214
     /* 2348214 */ GIM_Reject,
     /* 2348215 */ // Label 32836: @2348215
     /* 2348215 */ GIM_Try, /*On fail goto*//*Label 32890*/ GIMT_Encode4(2348329),
     /* 2348220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2348223 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2348226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348234 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2348238 */   GIM_Try, /*On fail goto*//*Label 32891*/ GIMT_Encode4(2348283), // Rule ID 56722 //
     /* 2348243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2348246 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2348263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348268 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348282 */     // GIR_Coverage, 56722,
     /* 2348282 */     GIR_EraseRootFromParent_Done,
     /* 2348283 */   // Label 32891: @2348283
     /* 2348283 */   GIM_Try, /*On fail goto*//*Label 32892*/ GIMT_Encode4(2348328), // Rule ID 56723 //
     /* 2348288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2348291 */     // (fmaximumnum:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMAX_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2348294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMAX_VV_M8_E16),
     /* 2348308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348315 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348326 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348327 */     // GIR_Coverage, 56723,
     /* 2348327 */     GIR_EraseRootFromParent_Done,
     /* 2348328 */   // Label 32892: @2348328
     /* 2348328 */   GIM_Reject,
     /* 2348329 */ // Label 32890: @2348329
     /* 2348329 */ GIM_Reject,
     /* 2348330 */ // Label 32837: @2348330
     /* 2348330 */ GIM_Reject,
     /* 2348331 */ // Label 80: @2348331
     /* 2348331 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 32917*/ GIMT_Encode4(2351106),
     /* 2348342 */ /*GILLT_s32*//*Label 32893*/ GIMT_Encode4(2348466),
     /* 2348346 */ /*GILLT_s64*//*Label 32894*/ GIMT_Encode4(2348521), GIMT_Encode4(0),
     /* 2348354 */ /*GILLT_nxv1s8*//*Label 32895*/ GIMT_Encode4(2348576),
     /* 2348358 */ /*GILLT_nxv1s16*//*Label 32896*/ GIMT_Encode4(2348691),
     /* 2348362 */ /*GILLT_nxv1s32*//*Label 32897*/ GIMT_Encode4(2348806),
     /* 2348366 */ /*GILLT_nxv1s64*//*Label 32898*/ GIMT_Encode4(2348921), GIMT_Encode4(0),
     /* 2348374 */ /*GILLT_nxv2s8*//*Label 32899*/ GIMT_Encode4(2349036),
     /* 2348378 */ /*GILLT_nxv2s16*//*Label 32900*/ GIMT_Encode4(2349151),
     /* 2348382 */ /*GILLT_nxv2s32*//*Label 32901*/ GIMT_Encode4(2349266),
     /* 2348386 */ /*GILLT_nxv2s64*//*Label 32902*/ GIMT_Encode4(2349381), GIMT_Encode4(0),
     /* 2348394 */ /*GILLT_nxv4s8*//*Label 32903*/ GIMT_Encode4(2349496),
     /* 2348398 */ /*GILLT_nxv4s16*//*Label 32904*/ GIMT_Encode4(2349611),
     /* 2348402 */ /*GILLT_nxv4s32*//*Label 32905*/ GIMT_Encode4(2349726),
     /* 2348406 */ /*GILLT_nxv4s64*//*Label 32906*/ GIMT_Encode4(2349841), GIMT_Encode4(0),
     /* 2348414 */ /*GILLT_nxv8s8*//*Label 32907*/ GIMT_Encode4(2349956),
     /* 2348418 */ /*GILLT_nxv8s16*//*Label 32908*/ GIMT_Encode4(2350071),
     /* 2348422 */ /*GILLT_nxv8s32*//*Label 32909*/ GIMT_Encode4(2350186),
     /* 2348426 */ /*GILLT_nxv8s64*//*Label 32910*/ GIMT_Encode4(2350301), GIMT_Encode4(0),
     /* 2348434 */ /*GILLT_nxv16s8*//*Label 32911*/ GIMT_Encode4(2350416),
     /* 2348438 */ /*GILLT_nxv16s16*//*Label 32912*/ GIMT_Encode4(2350531),
     /* 2348442 */ /*GILLT_nxv16s32*//*Label 32913*/ GIMT_Encode4(2350646), GIMT_Encode4(0),
     /* 2348450 */ /*GILLT_nxv32s8*//*Label 32914*/ GIMT_Encode4(2350761),
     /* 2348454 */ /*GILLT_nxv32s16*//*Label 32915*/ GIMT_Encode4(2350876), GIMT_Encode4(0),
     /* 2348462 */ /*GILLT_nxv64s8*//*Label 32916*/ GIMT_Encode4(2350991),
     /* 2348466 */ // Label 32893: @2348466
     /* 2348466 */ GIM_Try, /*On fail goto*//*Label 32918*/ GIMT_Encode4(2348520),
     /* 2348471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2348474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2348477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348489 */   GIM_Try, /*On fail goto*//*Label 32919*/ GIMT_Encode4(2348504), // Rule ID 64435 //
     /* 2348494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2348497 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2348497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2348502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348503 */     // GIR_Coverage, 64435,
     /* 2348503 */     GIR_Done,
     /* 2348504 */   // Label 32919: @2348504
     /* 2348504 */   GIM_Try, /*On fail goto*//*Label 32920*/ GIMT_Encode4(2348519), // Rule ID 2419 //
     /* 2348509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2348512 */     // (smin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MIN:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2348512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2348517 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348518 */     // GIR_Coverage, 2419,
     /* 2348518 */     GIR_Done,
     /* 2348519 */   // Label 32920: @2348519
     /* 2348519 */   GIM_Reject,
     /* 2348520 */ // Label 32918: @2348520
     /* 2348520 */ GIM_Reject,
     /* 2348521 */ // Label 32894: @2348521
     /* 2348521 */ GIM_Try, /*On fail goto*//*Label 32921*/ GIMT_Encode4(2348575),
     /* 2348526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2348529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2348532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2348544 */   GIM_Try, /*On fail goto*//*Label 32922*/ GIMT_Encode4(2348559), // Rule ID 64434 //
     /* 2348549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2348552 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2348552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MIN),
     /* 2348557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348558 */     // GIR_Coverage, 64434,
     /* 2348558 */     GIR_Done,
     /* 2348559 */   // Label 32922: @2348559
     /* 2348559 */   GIM_Try, /*On fail goto*//*Label 32923*/ GIMT_Encode4(2348574), // Rule ID 2418 //
     /* 2348564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2348567 */     // (smin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MIN:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2348567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MIN),
     /* 2348572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348573 */     // GIR_Coverage, 2418,
     /* 2348573 */     GIR_Done,
     /* 2348574 */   // Label 32923: @2348574
     /* 2348574 */   GIM_Reject,
     /* 2348575 */ // Label 32921: @2348575
     /* 2348575 */ GIM_Reject,
     /* 2348576 */ // Label 32895: @2348576
     /* 2348576 */ GIM_Try, /*On fail goto*//*Label 32924*/ GIMT_Encode4(2348690),
     /* 2348581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2348584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2348587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348595 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348599 */   GIM_Try, /*On fail goto*//*Label 32925*/ GIMT_Encode4(2348644), // Rule ID 50466 //
     /* 2348604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2348607 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2348610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2348624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348643 */     // GIR_Coverage, 50466,
     /* 2348643 */     GIR_EraseRootFromParent_Done,
     /* 2348644 */   // Label 32925: @2348644
     /* 2348644 */   GIM_Try, /*On fail goto*//*Label 32926*/ GIMT_Encode4(2348689), // Rule ID 50467 //
     /* 2348649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2348652 */     // (smin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMIN_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2348655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF8),
     /* 2348669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348674 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348676 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348688 */     // GIR_Coverage, 50467,
     /* 2348688 */     GIR_EraseRootFromParent_Done,
     /* 2348689 */   // Label 32926: @2348689
     /* 2348689 */   GIM_Reject,
     /* 2348690 */ // Label 32924: @2348690
     /* 2348690 */ GIM_Reject,
     /* 2348691 */ // Label 32896: @2348691
     /* 2348691 */ GIM_Try, /*On fail goto*//*Label 32927*/ GIMT_Encode4(2348805),
     /* 2348696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2348699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2348702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348710 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348714 */   GIM_Try, /*On fail goto*//*Label 32928*/ GIMT_Encode4(2348759), // Rule ID 50478 //
     /* 2348719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2348722 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2348739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348758 */     // GIR_Coverage, 50478,
     /* 2348758 */     GIR_EraseRootFromParent_Done,
     /* 2348759 */   // Label 32928: @2348759
     /* 2348759 */   GIM_Try, /*On fail goto*//*Label 32929*/ GIMT_Encode4(2348804), // Rule ID 50479 //
     /* 2348764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2348767 */     // (smin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2348770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2348784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348791 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2348799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348802 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348803 */     // GIR_Coverage, 50479,
     /* 2348803 */     GIR_EraseRootFromParent_Done,
     /* 2348804 */   // Label 32929: @2348804
     /* 2348804 */   GIM_Reject,
     /* 2348805 */ // Label 32927: @2348805
     /* 2348805 */ GIM_Reject,
     /* 2348806 */ // Label 32897: @2348806
     /* 2348806 */ GIM_Try, /*On fail goto*//*Label 32930*/ GIMT_Encode4(2348920),
     /* 2348811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2348814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2348817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348829 */   GIM_Try, /*On fail goto*//*Label 32931*/ GIMT_Encode4(2348874), // Rule ID 50486 //
     /* 2348834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2348837 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2348854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348873 */     // GIR_Coverage, 50486,
     /* 2348873 */     GIR_EraseRootFromParent_Done,
     /* 2348874 */   // Label 32931: @2348874
     /* 2348874 */   GIM_Try, /*On fail goto*//*Label 32932*/ GIMT_Encode4(2348919), // Rule ID 50487 //
     /* 2348879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2348882 */     // (smin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2348885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2348899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2348914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348918 */     // GIR_Coverage, 50487,
     /* 2348918 */     GIR_EraseRootFromParent_Done,
     /* 2348919 */   // Label 32932: @2348919
     /* 2348919 */   GIM_Reject,
     /* 2348920 */ // Label 32930: @2348920
     /* 2348920 */ GIM_Reject,
     /* 2348921 */ // Label 32898: @2348921
     /* 2348921 */ GIM_Try, /*On fail goto*//*Label 32933*/ GIMT_Encode4(2349035),
     /* 2348926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2348929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2348932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348936 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348940 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2348944 */   GIM_Try, /*On fail goto*//*Label 32934*/ GIMT_Encode4(2348989), // Rule ID 50502 //
     /* 2348949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2348952 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2348952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2348955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2348959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2348964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2348966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2348969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2348971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2348974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2348976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2348978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2348981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2348984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2348987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2348988 */     // GIR_Coverage, 50502,
     /* 2348988 */     GIR_EraseRootFromParent_Done,
     /* 2348989 */   // Label 32934: @2348989
     /* 2348989 */   GIM_Try, /*On fail goto*//*Label 32935*/ GIMT_Encode4(2349034), // Rule ID 50503 //
     /* 2348994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2348997 */     // (smin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2348997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2349000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2349014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349016 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349019 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349021 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349032 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349033 */     // GIR_Coverage, 50503,
     /* 2349033 */     GIR_EraseRootFromParent_Done,
     /* 2349034 */   // Label 32935: @2349034
     /* 2349034 */   GIM_Reject,
     /* 2349035 */ // Label 32933: @2349035
     /* 2349035 */ GIM_Reject,
     /* 2349036 */ // Label 32899: @2349036
     /* 2349036 */ GIM_Try, /*On fail goto*//*Label 32936*/ GIMT_Encode4(2349150),
     /* 2349041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2349044 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2349047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349051 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349055 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349059 */   GIM_Try, /*On fail goto*//*Label 32937*/ GIMT_Encode4(2349104), // Rule ID 50470 //
     /* 2349064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349067 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2349070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2349084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349103 */     // GIR_Coverage, 50470,
     /* 2349103 */     GIR_EraseRootFromParent_Done,
     /* 2349104 */   // Label 32937: @2349104
     /* 2349104 */   GIM_Try, /*On fail goto*//*Label 32938*/ GIMT_Encode4(2349149), // Rule ID 50471 //
     /* 2349109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349112 */     // (smin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMIN_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2349115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349124 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF4),
     /* 2349129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349134 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349136 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349148 */     // GIR_Coverage, 50471,
     /* 2349148 */     GIR_EraseRootFromParent_Done,
     /* 2349149 */   // Label 32938: @2349149
     /* 2349149 */   GIM_Reject,
     /* 2349150 */ // Label 32936: @2349150
     /* 2349150 */ GIM_Reject,
     /* 2349151 */ // Label 32900: @2349151
     /* 2349151 */ GIM_Try, /*On fail goto*//*Label 32939*/ GIMT_Encode4(2349265),
     /* 2349156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2349159 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2349162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349170 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349174 */   GIM_Try, /*On fail goto*//*Label 32940*/ GIMT_Encode4(2349219), // Rule ID 50482 //
     /* 2349179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349182 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2349199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349204 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349218 */     // GIR_Coverage, 50482,
     /* 2349218 */     GIR_EraseRootFromParent_Done,
     /* 2349219 */   // Label 32940: @2349219
     /* 2349219 */   GIM_Try, /*On fail goto*//*Label 32941*/ GIMT_Encode4(2349264), // Rule ID 50483 //
     /* 2349224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349227 */     // (smin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2349230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2349244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349262 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349263 */     // GIR_Coverage, 50483,
     /* 2349263 */     GIR_EraseRootFromParent_Done,
     /* 2349264 */   // Label 32941: @2349264
     /* 2349264 */   GIM_Reject,
     /* 2349265 */ // Label 32939: @2349265
     /* 2349265 */ GIM_Reject,
     /* 2349266 */ // Label 32901: @2349266
     /* 2349266 */ GIM_Try, /*On fail goto*//*Label 32942*/ GIMT_Encode4(2349380),
     /* 2349271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2349274 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2349277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349285 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349289 */   GIM_Try, /*On fail goto*//*Label 32943*/ GIMT_Encode4(2349334), // Rule ID 50498 //
     /* 2349294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349297 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2349314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349333 */     // GIR_Coverage, 50498,
     /* 2349333 */     GIR_EraseRootFromParent_Done,
     /* 2349334 */   // Label 32943: @2349334
     /* 2349334 */   GIM_Try, /*On fail goto*//*Label 32944*/ GIMT_Encode4(2349379), // Rule ID 50499 //
     /* 2349339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349342 */     // (smin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2349345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2349359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349378 */     // GIR_Coverage, 50499,
     /* 2349378 */     GIR_EraseRootFromParent_Done,
     /* 2349379 */   // Label 32944: @2349379
     /* 2349379 */   GIM_Reject,
     /* 2349380 */ // Label 32942: @2349380
     /* 2349380 */ GIM_Reject,
     /* 2349381 */ // Label 32902: @2349381
     /* 2349381 */ GIM_Try, /*On fail goto*//*Label 32945*/ GIMT_Encode4(2349495),
     /* 2349386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2349389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2349392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349404 */   GIM_Try, /*On fail goto*//*Label 32946*/ GIMT_Encode4(2349449), // Rule ID 50542 //
     /* 2349409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2349412 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2349415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2349429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349436 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349447 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349448 */     // GIR_Coverage, 50542,
     /* 2349448 */     GIR_EraseRootFromParent_Done,
     /* 2349449 */   // Label 32946: @2349449
     /* 2349449 */   GIM_Try, /*On fail goto*//*Label 32947*/ GIMT_Encode4(2349494), // Rule ID 50543 //
     /* 2349454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2349457 */     // (smin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2349460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2349474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349479 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349481 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349493 */     // GIR_Coverage, 50543,
     /* 2349493 */     GIR_EraseRootFromParent_Done,
     /* 2349494 */   // Label 32947: @2349494
     /* 2349494 */   GIM_Reject,
     /* 2349495 */ // Label 32945: @2349495
     /* 2349495 */ GIM_Reject,
     /* 2349496 */ // Label 32903: @2349496
     /* 2349496 */ GIM_Try, /*On fail goto*//*Label 32948*/ GIMT_Encode4(2349610),
     /* 2349501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2349504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2349507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349519 */   GIM_Try, /*On fail goto*//*Label 32949*/ GIMT_Encode4(2349564), // Rule ID 50474 //
     /* 2349524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349527 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2349530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2349544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349563 */     // GIR_Coverage, 50474,
     /* 2349563 */     GIR_EraseRootFromParent_Done,
     /* 2349564 */   // Label 32949: @2349564
     /* 2349564 */   GIM_Try, /*On fail goto*//*Label 32950*/ GIMT_Encode4(2349609), // Rule ID 50475 //
     /* 2349569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349572 */     // (smin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMIN_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2349575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349584 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_MF2),
     /* 2349589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349594 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349596 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349608 */     // GIR_Coverage, 50475,
     /* 2349608 */     GIR_EraseRootFromParent_Done,
     /* 2349609 */   // Label 32950: @2349609
     /* 2349609 */   GIM_Reject,
     /* 2349610 */ // Label 32948: @2349610
     /* 2349610 */ GIM_Reject,
     /* 2349611 */ // Label 32904: @2349611
     /* 2349611 */ GIM_Try, /*On fail goto*//*Label 32951*/ GIMT_Encode4(2349725),
     /* 2349616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2349619 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2349622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349630 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349634 */   GIM_Try, /*On fail goto*//*Label 32952*/ GIMT_Encode4(2349679), // Rule ID 50494 //
     /* 2349639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349642 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2349645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2349659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349677 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349678 */     // GIR_Coverage, 50494,
     /* 2349678 */     GIR_EraseRootFromParent_Done,
     /* 2349679 */   // Label 32952: @2349679
     /* 2349679 */   GIM_Try, /*On fail goto*//*Label 32953*/ GIMT_Encode4(2349724), // Rule ID 50495 //
     /* 2349684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349687 */     // (smin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349687 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2349690 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349694 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2349704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349709 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2349719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349723 */     // GIR_Coverage, 50495,
     /* 2349723 */     GIR_EraseRootFromParent_Done,
     /* 2349724 */   // Label 32953: @2349724
     /* 2349724 */   GIM_Reject,
     /* 2349725 */ // Label 32951: @2349725
     /* 2349725 */ GIM_Reject,
     /* 2349726 */ // Label 32905: @2349726
     /* 2349726 */ GIM_Try, /*On fail goto*//*Label 32954*/ GIMT_Encode4(2349840),
     /* 2349731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2349734 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2349737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349745 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2349749 */   GIM_Try, /*On fail goto*//*Label 32955*/ GIMT_Encode4(2349794), // Rule ID 50530 //
     /* 2349754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349757 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2349760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2349774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349779 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349781 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349793 */     // GIR_Coverage, 50530,
     /* 2349793 */     GIR_EraseRootFromParent_Done,
     /* 2349794 */   // Label 32955: @2349794
     /* 2349794 */   GIM_Try, /*On fail goto*//*Label 32956*/ GIMT_Encode4(2349839), // Rule ID 50531 //
     /* 2349799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2349802 */     // (smin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2349805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2349819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349824 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349826 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2349834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349838 */     // GIR_Coverage, 50531,
     /* 2349838 */     GIR_EraseRootFromParent_Done,
     /* 2349839 */   // Label 32956: @2349839
     /* 2349839 */   GIM_Reject,
     /* 2349840 */ // Label 32954: @2349840
     /* 2349840 */ GIM_Reject,
     /* 2349841 */ // Label 32906: @2349841
     /* 2349841 */ GIM_Try, /*On fail goto*//*Label 32957*/ GIMT_Encode4(2349955),
     /* 2349846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2349849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2349852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349860 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2349864 */   GIM_Try, /*On fail goto*//*Label 32958*/ GIMT_Encode4(2349909), // Rule ID 50546 //
     /* 2349869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2349872 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2349875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2349889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349896 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349908 */     // GIR_Coverage, 50546,
     /* 2349908 */     GIR_EraseRootFromParent_Done,
     /* 2349909 */   // Label 32958: @2349909
     /* 2349909 */   GIM_Try, /*On fail goto*//*Label 32959*/ GIMT_Encode4(2349954), // Rule ID 50547 //
     /* 2349914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2349917 */     // (smin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2349917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2349920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2349931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2349934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2349936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2349939 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2349941 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2349943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2349946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2349949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2349952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349953 */     // GIR_Coverage, 50547,
     /* 2349953 */     GIR_EraseRootFromParent_Done,
     /* 2349954 */   // Label 32959: @2349954
     /* 2349954 */   GIM_Reject,
     /* 2349955 */ // Label 32957: @2349955
     /* 2349955 */ GIM_Reject,
     /* 2349956 */ // Label 32907: @2349956
     /* 2349956 */ GIM_Try, /*On fail goto*//*Label 32960*/ GIMT_Encode4(2350070),
     /* 2349961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2349964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2349967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2349979 */   GIM_Try, /*On fail goto*//*Label 32961*/ GIMT_Encode4(2350024), // Rule ID 50490 //
     /* 2349984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2349987 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2349987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2349990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2349994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2349999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2350004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350022 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350023 */     // GIR_Coverage, 50490,
     /* 2350023 */     GIR_EraseRootFromParent_Done,
     /* 2350024 */   // Label 32961: @2350024
     /* 2350024 */   GIM_Try, /*On fail goto*//*Label 32962*/ GIMT_Encode4(2350069), // Rule ID 50491 //
     /* 2350029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350032 */     // (smin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMIN_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350032 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2350035 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350039 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M1),
     /* 2350049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350054 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350056 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350068 */     // GIR_Coverage, 50491,
     /* 2350068 */     GIR_EraseRootFromParent_Done,
     /* 2350069 */   // Label 32962: @2350069
     /* 2350069 */   GIM_Reject,
     /* 2350070 */ // Label 32960: @2350070
     /* 2350070 */ GIM_Reject,
     /* 2350071 */ // Label 32908: @2350071
     /* 2350071 */ GIM_Try, /*On fail goto*//*Label 32963*/ GIMT_Encode4(2350185),
     /* 2350076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2350079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2350082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350094 */   GIM_Try, /*On fail goto*//*Label 32964*/ GIMT_Encode4(2350139), // Rule ID 50518 //
     /* 2350099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350102 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350102 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2350105 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350109 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2350119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350124 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350126 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350138 */     // GIR_Coverage, 50518,
     /* 2350138 */     GIR_EraseRootFromParent_Done,
     /* 2350139 */   // Label 32964: @2350139
     /* 2350139 */   GIM_Try, /*On fail goto*//*Label 32965*/ GIMT_Encode4(2350184), // Rule ID 50519 //
     /* 2350144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350147 */     // (smin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2350150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2350164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350182 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350183 */     // GIR_Coverage, 50519,
     /* 2350183 */     GIR_EraseRootFromParent_Done,
     /* 2350184 */   // Label 32965: @2350184
     /* 2350184 */   GIM_Reject,
     /* 2350185 */ // Label 32963: @2350185
     /* 2350185 */ GIM_Reject,
     /* 2350186 */ // Label 32909: @2350186
     /* 2350186 */ GIM_Try, /*On fail goto*//*Label 32966*/ GIMT_Encode4(2350300),
     /* 2350191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2350194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2350197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350201 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350205 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350209 */   GIM_Try, /*On fail goto*//*Label 32967*/ GIMT_Encode4(2350254), // Rule ID 50534 //
     /* 2350214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350217 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350241 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350252 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350253 */     // GIR_Coverage, 50534,
     /* 2350253 */     GIR_EraseRootFromParent_Done,
     /* 2350254 */   // Label 32967: @2350254
     /* 2350254 */   GIM_Try, /*On fail goto*//*Label 32968*/ GIMT_Encode4(2350299), // Rule ID 50535 //
     /* 2350259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350262 */     // (smin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2350265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350297 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350298 */     // GIR_Coverage, 50535,
     /* 2350298 */     GIR_EraseRootFromParent_Done,
     /* 2350299 */   // Label 32968: @2350299
     /* 2350299 */   GIM_Reject,
     /* 2350300 */ // Label 32966: @2350300
     /* 2350300 */ GIM_Reject,
     /* 2350301 */ // Label 32910: @2350301
     /* 2350301 */ GIM_Try, /*On fail goto*//*Label 32969*/ GIMT_Encode4(2350415),
     /* 2350306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2350309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2350312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350320 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350324 */   GIM_Try, /*On fail goto*//*Label 32970*/ GIMT_Encode4(2350369), // Rule ID 50550 //
     /* 2350329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2350332 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350354 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350356 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350368 */     // GIR_Coverage, 50550,
     /* 2350368 */     GIR_EraseRootFromParent_Done,
     /* 2350369 */   // Label 32970: @2350369
     /* 2350369 */   GIM_Try, /*On fail goto*//*Label 32971*/ GIMT_Encode4(2350414), // Rule ID 50551 //
     /* 2350374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2350377 */     // (smin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2350380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2350409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350413 */     // GIR_Coverage, 50551,
     /* 2350413 */     GIR_EraseRootFromParent_Done,
     /* 2350414 */   // Label 32971: @2350414
     /* 2350414 */   GIM_Reject,
     /* 2350415 */ // Label 32969: @2350415
     /* 2350415 */ GIM_Reject,
     /* 2350416 */ // Label 32911: @2350416
     /* 2350416 */ GIM_Try, /*On fail goto*//*Label 32972*/ GIMT_Encode4(2350530),
     /* 2350421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2350424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2350427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350435 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2350439 */   GIM_Try, /*On fail goto*//*Label 32973*/ GIMT_Encode4(2350484), // Rule ID 50506 //
     /* 2350444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350447 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350447 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2350450 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350454 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2350464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350471 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350483 */     // GIR_Coverage, 50506,
     /* 2350483 */     GIR_EraseRootFromParent_Done,
     /* 2350484 */   // Label 32973: @2350484
     /* 2350484 */   GIM_Try, /*On fail goto*//*Label 32974*/ GIMT_Encode4(2350529), // Rule ID 50507 //
     /* 2350489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350492 */     // (smin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMIN_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2350495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M2),
     /* 2350509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350528 */     // GIR_Coverage, 50507,
     /* 2350528 */     GIR_EraseRootFromParent_Done,
     /* 2350529 */   // Label 32974: @2350529
     /* 2350529 */   GIM_Reject,
     /* 2350530 */ // Label 32972: @2350530
     /* 2350530 */ GIM_Reject,
     /* 2350531 */ // Label 32912: @2350531
     /* 2350531 */ GIM_Try, /*On fail goto*//*Label 32975*/ GIMT_Encode4(2350645),
     /* 2350536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2350539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2350542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350554 */   GIM_Try, /*On fail goto*//*Label 32976*/ GIMT_Encode4(2350599), // Rule ID 50522 //
     /* 2350559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350562 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2350565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350584 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350586 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350598 */     // GIR_Coverage, 50522,
     /* 2350598 */     GIR_EraseRootFromParent_Done,
     /* 2350599 */   // Label 32976: @2350599
     /* 2350599 */   GIM_Try, /*On fail goto*//*Label 32977*/ GIMT_Encode4(2350644), // Rule ID 50523 //
     /* 2350604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350607 */     // (smin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2350610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350643 */     // GIR_Coverage, 50523,
     /* 2350643 */     GIR_EraseRootFromParent_Done,
     /* 2350644 */   // Label 32977: @2350644
     /* 2350644 */   GIM_Reject,
     /* 2350645 */ // Label 32975: @2350645
     /* 2350645 */ GIM_Reject,
     /* 2350646 */ // Label 32913: @2350646
     /* 2350646 */ GIM_Try, /*On fail goto*//*Label 32978*/ GIMT_Encode4(2350760),
     /* 2350651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2350654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2350657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350665 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350669 */   GIM_Try, /*On fail goto*//*Label 32979*/ GIMT_Encode4(2350714), // Rule ID 50538 //
     /* 2350674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350677 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2350680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350713 */     // GIR_Coverage, 50538,
     /* 2350713 */     GIR_EraseRootFromParent_Done,
     /* 2350714 */   // Label 32979: @2350714
     /* 2350714 */   GIM_Try, /*On fail goto*//*Label 32980*/ GIMT_Encode4(2350759), // Rule ID 50539 //
     /* 2350719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350722 */     // (smin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2350725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2350754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350758 */     // GIR_Coverage, 50539,
     /* 2350758 */     GIR_EraseRootFromParent_Done,
     /* 2350759 */   // Label 32980: @2350759
     /* 2350759 */   GIM_Reject,
     /* 2350760 */ // Label 32978: @2350760
     /* 2350760 */ GIM_Reject,
     /* 2350761 */ // Label 32914: @2350761
     /* 2350761 */ GIM_Try, /*On fail goto*//*Label 32981*/ GIMT_Encode4(2350875),
     /* 2350766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2350769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2350772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350780 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2350784 */   GIM_Try, /*On fail goto*//*Label 32982*/ GIMT_Encode4(2350829), // Rule ID 50510 //
     /* 2350789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350792 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2350795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350828 */     // GIR_Coverage, 50510,
     /* 2350828 */     GIR_EraseRootFromParent_Done,
     /* 2350829 */   // Label 32982: @2350829
     /* 2350829 */   GIM_Try, /*On fail goto*//*Label 32983*/ GIMT_Encode4(2350874), // Rule ID 50511 //
     /* 2350834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350837 */     // (smin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMIN_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2350840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M4),
     /* 2350854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350861 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350873 */     // GIR_Coverage, 50511,
     /* 2350873 */     GIR_EraseRootFromParent_Done,
     /* 2350874 */   // Label 32983: @2350874
     /* 2350874 */   GIM_Reject,
     /* 2350875 */ // Label 32981: @2350875
     /* 2350875 */ GIM_Reject,
     /* 2350876 */ // Label 32915: @2350876
     /* 2350876 */ GIM_Try, /*On fail goto*//*Label 32984*/ GIMT_Encode4(2350990),
     /* 2350881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2350884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2350887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350895 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2350899 */   GIM_Try, /*On fail goto*//*Label 32985*/ GIMT_Encode4(2350944), // Rule ID 50526 //
     /* 2350904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2350907 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2350907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2350910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350929 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350942 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350943 */     // GIR_Coverage, 50526,
     /* 2350943 */     GIR_EraseRootFromParent_Done,
     /* 2350944 */   // Label 32985: @2350944
     /* 2350944 */   GIM_Try, /*On fail goto*//*Label 32986*/ GIMT_Encode4(2350989), // Rule ID 50527 //
     /* 2350949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2350952 */     // (smin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2350952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2350955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2350959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2350964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2350966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2350969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2350971 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2350974 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2350976 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2350978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2350981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2350984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2350987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2350988 */     // GIR_Coverage, 50527,
     /* 2350988 */     GIR_EraseRootFromParent_Done,
     /* 2350989 */   // Label 32986: @2350989
     /* 2350989 */   GIM_Reject,
     /* 2350990 */ // Label 32984: @2350990
     /* 2350990 */ GIM_Reject,
     /* 2350991 */ // Label 32916: @2350991
     /* 2350991 */ GIM_Try, /*On fail goto*//*Label 32987*/ GIMT_Encode4(2351105),
     /* 2350996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2350999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2351002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2351014 */   GIM_Try, /*On fail goto*//*Label 32988*/ GIMT_Encode4(2351059), // Rule ID 50514 //
     /* 2351019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351022 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2351025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2351039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351046 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351058 */     // GIR_Coverage, 50514,
     /* 2351058 */     GIR_EraseRootFromParent_Done,
     /* 2351059 */   // Label 32988: @2351059
     /* 2351059 */   GIM_Try, /*On fail goto*//*Label 32989*/ GIMT_Encode4(2351104), // Rule ID 50515 //
     /* 2351064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2351067 */     // (smin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMIN_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2351070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMIN_VV_M8),
     /* 2351084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351091 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351102 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351103 */     // GIR_Coverage, 50515,
     /* 2351103 */     GIR_EraseRootFromParent_Done,
     /* 2351104 */   // Label 32989: @2351104
     /* 2351104 */   GIM_Reject,
     /* 2351105 */ // Label 32987: @2351105
     /* 2351105 */ GIM_Reject,
     /* 2351106 */ // Label 32917: @2351106
     /* 2351106 */ GIM_Reject,
     /* 2351107 */ // Label 81: @2351107
     /* 2351107 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33014*/ GIMT_Encode4(2353882),
     /* 2351118 */ /*GILLT_s32*//*Label 32990*/ GIMT_Encode4(2351242),
     /* 2351122 */ /*GILLT_s64*//*Label 32991*/ GIMT_Encode4(2351297), GIMT_Encode4(0),
     /* 2351130 */ /*GILLT_nxv1s8*//*Label 32992*/ GIMT_Encode4(2351352),
     /* 2351134 */ /*GILLT_nxv1s16*//*Label 32993*/ GIMT_Encode4(2351467),
     /* 2351138 */ /*GILLT_nxv1s32*//*Label 32994*/ GIMT_Encode4(2351582),
     /* 2351142 */ /*GILLT_nxv1s64*//*Label 32995*/ GIMT_Encode4(2351697), GIMT_Encode4(0),
     /* 2351150 */ /*GILLT_nxv2s8*//*Label 32996*/ GIMT_Encode4(2351812),
     /* 2351154 */ /*GILLT_nxv2s16*//*Label 32997*/ GIMT_Encode4(2351927),
     /* 2351158 */ /*GILLT_nxv2s32*//*Label 32998*/ GIMT_Encode4(2352042),
     /* 2351162 */ /*GILLT_nxv2s64*//*Label 32999*/ GIMT_Encode4(2352157), GIMT_Encode4(0),
     /* 2351170 */ /*GILLT_nxv4s8*//*Label 33000*/ GIMT_Encode4(2352272),
     /* 2351174 */ /*GILLT_nxv4s16*//*Label 33001*/ GIMT_Encode4(2352387),
     /* 2351178 */ /*GILLT_nxv4s32*//*Label 33002*/ GIMT_Encode4(2352502),
     /* 2351182 */ /*GILLT_nxv4s64*//*Label 33003*/ GIMT_Encode4(2352617), GIMT_Encode4(0),
     /* 2351190 */ /*GILLT_nxv8s8*//*Label 33004*/ GIMT_Encode4(2352732),
     /* 2351194 */ /*GILLT_nxv8s16*//*Label 33005*/ GIMT_Encode4(2352847),
     /* 2351198 */ /*GILLT_nxv8s32*//*Label 33006*/ GIMT_Encode4(2352962),
     /* 2351202 */ /*GILLT_nxv8s64*//*Label 33007*/ GIMT_Encode4(2353077), GIMT_Encode4(0),
     /* 2351210 */ /*GILLT_nxv16s8*//*Label 33008*/ GIMT_Encode4(2353192),
     /* 2351214 */ /*GILLT_nxv16s16*//*Label 33009*/ GIMT_Encode4(2353307),
     /* 2351218 */ /*GILLT_nxv16s32*//*Label 33010*/ GIMT_Encode4(2353422), GIMT_Encode4(0),
     /* 2351226 */ /*GILLT_nxv32s8*//*Label 33011*/ GIMT_Encode4(2353537),
     /* 2351230 */ /*GILLT_nxv32s16*//*Label 33012*/ GIMT_Encode4(2353652), GIMT_Encode4(0),
     /* 2351238 */ /*GILLT_nxv64s8*//*Label 33013*/ GIMT_Encode4(2353767),
     /* 2351242 */ // Label 32990: @2351242
     /* 2351242 */ GIM_Try, /*On fail goto*//*Label 33015*/ GIMT_Encode4(2351296),
     /* 2351247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2351250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2351253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351261 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351265 */   GIM_Try, /*On fail goto*//*Label 33016*/ GIMT_Encode4(2351280), // Rule ID 64439 //
     /* 2351270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2351273 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2351273 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2351278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351279 */     // GIR_Coverage, 64439,
     /* 2351279 */     GIR_Done,
     /* 2351280 */   // Label 33016: @2351280
     /* 2351280 */   GIM_Try, /*On fail goto*//*Label 33017*/ GIMT_Encode4(2351295), // Rule ID 2421 //
     /* 2351285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2351288 */     // (smax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAX:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2351288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2351293 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351294 */     // GIR_Coverage, 2421,
     /* 2351294 */     GIR_Done,
     /* 2351295 */   // Label 33017: @2351295
     /* 2351295 */   GIM_Reject,
     /* 2351296 */ // Label 33015: @2351296
     /* 2351296 */ GIM_Reject,
     /* 2351297 */ // Label 32991: @2351297
     /* 2351297 */ GIM_Try, /*On fail goto*//*Label 33018*/ GIMT_Encode4(2351351),
     /* 2351302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2351305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2351308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2351320 */   GIM_Try, /*On fail goto*//*Label 33019*/ GIMT_Encode4(2351335), // Rule ID 64438 //
     /* 2351325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2351328 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2351328 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAX),
     /* 2351333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351334 */     // GIR_Coverage, 64438,
     /* 2351334 */     GIR_Done,
     /* 2351335 */   // Label 33019: @2351335
     /* 2351335 */   GIM_Try, /*On fail goto*//*Label 33020*/ GIMT_Encode4(2351350), // Rule ID 2420 //
     /* 2351340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2351343 */     // (smax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAX:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2351343 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAX),
     /* 2351348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351349 */     // GIR_Coverage, 2420,
     /* 2351349 */     GIR_Done,
     /* 2351350 */   // Label 33020: @2351350
     /* 2351350 */   GIM_Reject,
     /* 2351351 */ // Label 33018: @2351351
     /* 2351351 */ GIM_Reject,
     /* 2351352 */ // Label 32992: @2351352
     /* 2351352 */ GIM_Try, /*On fail goto*//*Label 33021*/ GIMT_Encode4(2351466),
     /* 2351357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2351360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2351363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351375 */   GIM_Try, /*On fail goto*//*Label 33022*/ GIMT_Encode4(2351420), // Rule ID 50642 //
     /* 2351380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351383 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2351386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2351400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351419 */     // GIR_Coverage, 50642,
     /* 2351419 */     GIR_EraseRootFromParent_Done,
     /* 2351420 */   // Label 33022: @2351420
     /* 2351420 */   GIM_Try, /*On fail goto*//*Label 33023*/ GIMT_Encode4(2351465), // Rule ID 50643 //
     /* 2351425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2351428 */     // (smax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAX_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2351431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351440 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF8),
     /* 2351445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351450 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351452 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351463 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351464 */     // GIR_Coverage, 50643,
     /* 2351464 */     GIR_EraseRootFromParent_Done,
     /* 2351465 */   // Label 33023: @2351465
     /* 2351465 */   GIM_Reject,
     /* 2351466 */ // Label 33021: @2351466
     /* 2351466 */ GIM_Reject,
     /* 2351467 */ // Label 32993: @2351467
     /* 2351467 */ GIM_Try, /*On fail goto*//*Label 33024*/ GIMT_Encode4(2351581),
     /* 2351472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2351475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2351478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351486 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351490 */   GIM_Try, /*On fail goto*//*Label 33025*/ GIMT_Encode4(2351535), // Rule ID 50654 //
     /* 2351495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351498 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2351515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351534 */     // GIR_Coverage, 50654,
     /* 2351534 */     GIR_EraseRootFromParent_Done,
     /* 2351535 */   // Label 33025: @2351535
     /* 2351535 */   GIM_Try, /*On fail goto*//*Label 33026*/ GIMT_Encode4(2351580), // Rule ID 50655 //
     /* 2351540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2351543 */     // (smax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2351546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2351560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351565 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351567 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351579 */     // GIR_Coverage, 50655,
     /* 2351579 */     GIR_EraseRootFromParent_Done,
     /* 2351580 */   // Label 33026: @2351580
     /* 2351580 */   GIM_Reject,
     /* 2351581 */ // Label 33024: @2351581
     /* 2351581 */ GIM_Reject,
     /* 2351582 */ // Label 32994: @2351582
     /* 2351582 */ GIM_Try, /*On fail goto*//*Label 33027*/ GIMT_Encode4(2351696),
     /* 2351587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2351590 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2351593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351601 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351605 */   GIM_Try, /*On fail goto*//*Label 33028*/ GIMT_Encode4(2351650), // Rule ID 50662 //
     /* 2351610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351613 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2351630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351649 */     // GIR_Coverage, 50662,
     /* 2351649 */     GIR_EraseRootFromParent_Done,
     /* 2351650 */   // Label 33028: @2351650
     /* 2351650 */   GIM_Try, /*On fail goto*//*Label 33029*/ GIMT_Encode4(2351695), // Rule ID 50663 //
     /* 2351655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2351658 */     // (smax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2351661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2351675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351680 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351682 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2351690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351694 */     // GIR_Coverage, 50663,
     /* 2351694 */     GIR_EraseRootFromParent_Done,
     /* 2351695 */   // Label 33029: @2351695
     /* 2351695 */   GIM_Reject,
     /* 2351696 */ // Label 33027: @2351696
     /* 2351696 */ GIM_Reject,
     /* 2351697 */ // Label 32995: @2351697
     /* 2351697 */ GIM_Try, /*On fail goto*//*Label 33030*/ GIMT_Encode4(2351811),
     /* 2351702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2351705 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2351708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351720 */   GIM_Try, /*On fail goto*//*Label 33031*/ GIMT_Encode4(2351765), // Rule ID 50678 //
     /* 2351725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2351728 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2351745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351764 */     // GIR_Coverage, 50678,
     /* 2351764 */     GIR_EraseRootFromParent_Done,
     /* 2351765 */   // Label 33031: @2351765
     /* 2351765 */   GIM_Try, /*On fail goto*//*Label 33032*/ GIMT_Encode4(2351810), // Rule ID 50679 //
     /* 2351770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2351773 */     // (smax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2351776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2351790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351795 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351797 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2351805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351808 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351809 */     // GIR_Coverage, 50679,
     /* 2351809 */     GIR_EraseRootFromParent_Done,
     /* 2351810 */   // Label 33032: @2351810
     /* 2351810 */   GIM_Reject,
     /* 2351811 */ // Label 33030: @2351811
     /* 2351811 */ GIM_Reject,
     /* 2351812 */ // Label 32996: @2351812
     /* 2351812 */ GIM_Try, /*On fail goto*//*Label 33033*/ GIMT_Encode4(2351926),
     /* 2351817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2351820 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2351823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351831 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351835 */   GIM_Try, /*On fail goto*//*Label 33034*/ GIMT_Encode4(2351880), // Rule ID 50646 //
     /* 2351840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351843 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2351846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2351860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351879 */     // GIR_Coverage, 50646,
     /* 2351879 */     GIR_EraseRootFromParent_Done,
     /* 2351880 */   // Label 33034: @2351880
     /* 2351880 */   GIM_Try, /*On fail goto*//*Label 33035*/ GIMT_Encode4(2351925), // Rule ID 50647 //
     /* 2351885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2351888 */     // (smax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAX_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2351888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2351891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF4),
     /* 2351905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351923 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351924 */     // GIR_Coverage, 50647,
     /* 2351924 */     GIR_EraseRootFromParent_Done,
     /* 2351925 */   // Label 33035: @2351925
     /* 2351925 */   GIM_Reject,
     /* 2351926 */ // Label 33033: @2351926
     /* 2351926 */ GIM_Reject,
     /* 2351927 */ // Label 32997: @2351927
     /* 2351927 */ GIM_Try, /*On fail goto*//*Label 33036*/ GIMT_Encode4(2352041),
     /* 2351932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2351935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2351938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2351950 */   GIM_Try, /*On fail goto*//*Label 33037*/ GIMT_Encode4(2351995), // Rule ID 50658 //
     /* 2351955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2351958 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2351958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2351961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2351965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2351970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2351972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2351975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2351977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2351980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2351982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2351984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2351987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2351990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2351993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2351994 */     // GIR_Coverage, 50658,
     /* 2351994 */     GIR_EraseRootFromParent_Done,
     /* 2351995 */   // Label 33037: @2351995
     /* 2351995 */   GIM_Try, /*On fail goto*//*Label 33038*/ GIMT_Encode4(2352040), // Rule ID 50659 //
     /* 2352000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352003 */     // (smax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2352006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2352020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352039 */     // GIR_Coverage, 50659,
     /* 2352039 */     GIR_EraseRootFromParent_Done,
     /* 2352040 */   // Label 33038: @2352040
     /* 2352040 */   GIM_Reject,
     /* 2352041 */ // Label 33036: @2352041
     /* 2352041 */ GIM_Reject,
     /* 2352042 */ // Label 32998: @2352042
     /* 2352042 */ GIM_Try, /*On fail goto*//*Label 33039*/ GIMT_Encode4(2352156),
     /* 2352047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2352050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2352053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352065 */   GIM_Try, /*On fail goto*//*Label 33040*/ GIMT_Encode4(2352110), // Rule ID 50674 //
     /* 2352070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352073 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352108 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352109 */     // GIR_Coverage, 50674,
     /* 2352109 */     GIR_EraseRootFromParent_Done,
     /* 2352110 */   // Label 33040: @2352110
     /* 2352110 */   GIM_Try, /*On fail goto*//*Label 33041*/ GIMT_Encode4(2352155), // Rule ID 50675 //
     /* 2352115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352118 */     // (smax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2352121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352140 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352142 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352154 */     // GIR_Coverage, 50675,
     /* 2352154 */     GIR_EraseRootFromParent_Done,
     /* 2352155 */   // Label 33041: @2352155
     /* 2352155 */   GIM_Reject,
     /* 2352156 */ // Label 33039: @2352156
     /* 2352156 */ GIM_Reject,
     /* 2352157 */ // Label 32999: @2352157
     /* 2352157 */ GIM_Try, /*On fail goto*//*Label 33042*/ GIMT_Encode4(2352271),
     /* 2352162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2352165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2352168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352180 */   GIM_Try, /*On fail goto*//*Label 33043*/ GIMT_Encode4(2352225), // Rule ID 50718 //
     /* 2352185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2352188 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352200 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352224 */     // GIR_Coverage, 50718,
     /* 2352224 */     GIR_EraseRootFromParent_Done,
     /* 2352225 */   // Label 33043: @2352225
     /* 2352225 */   GIM_Try, /*On fail goto*//*Label 33044*/ GIMT_Encode4(2352270), // Rule ID 50719 //
     /* 2352230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2352233 */     // (smax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2352236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352245 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352269 */     // GIR_Coverage, 50719,
     /* 2352269 */     GIR_EraseRootFromParent_Done,
     /* 2352270 */   // Label 33044: @2352270
     /* 2352270 */   GIM_Reject,
     /* 2352271 */ // Label 33042: @2352271
     /* 2352271 */ GIM_Reject,
     /* 2352272 */ // Label 33000: @2352272
     /* 2352272 */ GIM_Try, /*On fail goto*//*Label 33045*/ GIMT_Encode4(2352386),
     /* 2352277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2352280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2352283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352291 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352295 */   GIM_Try, /*On fail goto*//*Label 33046*/ GIMT_Encode4(2352340), // Rule ID 50650 //
     /* 2352300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352303 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2352306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2352320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352339 */     // GIR_Coverage, 50650,
     /* 2352339 */     GIR_EraseRootFromParent_Done,
     /* 2352340 */   // Label 33046: @2352340
     /* 2352340 */   GIM_Try, /*On fail goto*//*Label 33047*/ GIMT_Encode4(2352385), // Rule ID 50651 //
     /* 2352345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352348 */     // (smax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAX_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2352351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_MF2),
     /* 2352365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352384 */     // GIR_Coverage, 50651,
     /* 2352384 */     GIR_EraseRootFromParent_Done,
     /* 2352385 */   // Label 33047: @2352385
     /* 2352385 */   GIM_Reject,
     /* 2352386 */ // Label 33045: @2352386
     /* 2352386 */ GIM_Reject,
     /* 2352387 */ // Label 33001: @2352387
     /* 2352387 */ GIM_Try, /*On fail goto*//*Label 33048*/ GIMT_Encode4(2352501),
     /* 2352392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2352395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2352398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352406 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352410 */   GIM_Try, /*On fail goto*//*Label 33049*/ GIMT_Encode4(2352455), // Rule ID 50670 //
     /* 2352415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352418 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352440 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352454 */     // GIR_Coverage, 50670,
     /* 2352454 */     GIR_EraseRootFromParent_Done,
     /* 2352455 */   // Label 33049: @2352455
     /* 2352455 */   GIM_Try, /*On fail goto*//*Label 33050*/ GIMT_Encode4(2352500), // Rule ID 50671 //
     /* 2352460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352463 */     // (smax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2352466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352499 */     // GIR_Coverage, 50671,
     /* 2352499 */     GIR_EraseRootFromParent_Done,
     /* 2352500 */   // Label 33050: @2352500
     /* 2352500 */   GIM_Reject,
     /* 2352501 */ // Label 33048: @2352501
     /* 2352501 */ GIM_Reject,
     /* 2352502 */ // Label 33002: @2352502
     /* 2352502 */ GIM_Try, /*On fail goto*//*Label 33051*/ GIMT_Encode4(2352616),
     /* 2352507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2352510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2352513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352525 */   GIM_Try, /*On fail goto*//*Label 33052*/ GIMT_Encode4(2352570), // Rule ID 50706 //
     /* 2352530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352533 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2352536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352569 */     // GIR_Coverage, 50706,
     /* 2352569 */     GIR_EraseRootFromParent_Done,
     /* 2352570 */   // Label 33052: @2352570
     /* 2352570 */   GIM_Try, /*On fail goto*//*Label 33053*/ GIMT_Encode4(2352615), // Rule ID 50707 //
     /* 2352575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352578 */     // (smax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2352581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352600 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2352610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352614 */     // GIR_Coverage, 50707,
     /* 2352614 */     GIR_EraseRootFromParent_Done,
     /* 2352615 */   // Label 33053: @2352615
     /* 2352615 */   GIM_Reject,
     /* 2352616 */ // Label 33051: @2352616
     /* 2352616 */ GIM_Reject,
     /* 2352617 */ // Label 33003: @2352617
     /* 2352617 */ GIM_Try, /*On fail goto*//*Label 33054*/ GIMT_Encode4(2352731),
     /* 2352622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2352625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2352628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352640 */   GIM_Try, /*On fail goto*//*Label 33055*/ GIMT_Encode4(2352685), // Rule ID 50722 //
     /* 2352645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2352648 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2352651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2352665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352684 */     // GIR_Coverage, 50722,
     /* 2352684 */     GIR_EraseRootFromParent_Done,
     /* 2352685 */   // Label 33055: @2352685
     /* 2352685 */   GIM_Try, /*On fail goto*//*Label 33056*/ GIMT_Encode4(2352730), // Rule ID 50723 //
     /* 2352690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2352693 */     // (smax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2352696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2352710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352715 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352717 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2352725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352729 */     // GIR_Coverage, 50723,
     /* 2352729 */     GIR_EraseRootFromParent_Done,
     /* 2352730 */   // Label 33056: @2352730
     /* 2352730 */   GIM_Reject,
     /* 2352731 */ // Label 33054: @2352731
     /* 2352731 */ GIM_Reject,
     /* 2352732 */ // Label 33004: @2352732
     /* 2352732 */ GIM_Try, /*On fail goto*//*Label 33057*/ GIMT_Encode4(2352846),
     /* 2352737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2352740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2352743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352751 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2352755 */   GIM_Try, /*On fail goto*//*Label 33058*/ GIMT_Encode4(2352800), // Rule ID 50666 //
     /* 2352760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352763 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2352766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352782 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352798 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352799 */     // GIR_Coverage, 50666,
     /* 2352799 */     GIR_EraseRootFromParent_Done,
     /* 2352800 */   // Label 33058: @2352800
     /* 2352800 */   GIM_Try, /*On fail goto*//*Label 33059*/ GIMT_Encode4(2352845), // Rule ID 50667 //
     /* 2352805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352808 */     // (smax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAX_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2352811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M1),
     /* 2352825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352830 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352832 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352843 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352844 */     // GIR_Coverage, 50667,
     /* 2352844 */     GIR_EraseRootFromParent_Done,
     /* 2352845 */   // Label 33059: @2352845
     /* 2352845 */   GIM_Reject,
     /* 2352846 */ // Label 33057: @2352846
     /* 2352846 */ GIM_Reject,
     /* 2352847 */ // Label 33005: @2352847
     /* 2352847 */ GIM_Try, /*On fail goto*//*Label 33060*/ GIMT_Encode4(2352961),
     /* 2352852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2352855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2352858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2352870 */   GIM_Try, /*On fail goto*//*Label 33061*/ GIMT_Encode4(2352915), // Rule ID 50694 //
     /* 2352875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352878 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2352881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352900 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352902 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352913 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352914 */     // GIR_Coverage, 50694,
     /* 2352914 */     GIR_EraseRootFromParent_Done,
     /* 2352915 */   // Label 33061: @2352915
     /* 2352915 */   GIM_Try, /*On fail goto*//*Label 33062*/ GIMT_Encode4(2352960), // Rule ID 50695 //
     /* 2352920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2352923 */     // (smax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2352923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2352926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2352930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2352935 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2352937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2352940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2352942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2352945 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2352947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2352949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2352952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2352955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2352958 */     GIR_RootConstrainSelectedInstOperands,
     /* 2352959 */     // GIR_Coverage, 50695,
     /* 2352959 */     GIR_EraseRootFromParent_Done,
     /* 2352960 */   // Label 33062: @2352960
     /* 2352960 */   GIM_Reject,
     /* 2352961 */ // Label 33060: @2352961
     /* 2352961 */ GIM_Reject,
     /* 2352962 */ // Label 33006: @2352962
     /* 2352962 */ GIM_Try, /*On fail goto*//*Label 33063*/ GIMT_Encode4(2353076),
     /* 2352967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2352970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2352973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352981 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2352985 */   GIM_Try, /*On fail goto*//*Label 33064*/ GIMT_Encode4(2353030), // Rule ID 50710 //
     /* 2352990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2352993 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2352993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2352996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353005 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353015 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353017 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353029 */     // GIR_Coverage, 50710,
     /* 2353029 */     GIR_EraseRootFromParent_Done,
     /* 2353030 */   // Label 33064: @2353030
     /* 2353030 */   GIM_Try, /*On fail goto*//*Label 33065*/ GIMT_Encode4(2353075), // Rule ID 50711 //
     /* 2353035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353038 */     // (smax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2353041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353074 */     // GIR_Coverage, 50711,
     /* 2353074 */     GIR_EraseRootFromParent_Done,
     /* 2353075 */   // Label 33065: @2353075
     /* 2353075 */   GIM_Reject,
     /* 2353076 */ // Label 33063: @2353076
     /* 2353076 */ GIM_Reject,
     /* 2353077 */ // Label 33007: @2353077
     /* 2353077 */ GIM_Try, /*On fail goto*//*Label 33066*/ GIMT_Encode4(2353191),
     /* 2353082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2353085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2353088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353100 */   GIM_Try, /*On fail goto*//*Label 33067*/ GIMT_Encode4(2353145), // Rule ID 50726 //
     /* 2353105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2353108 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2353111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353144 */     // GIR_Coverage, 50726,
     /* 2353144 */     GIR_EraseRootFromParent_Done,
     /* 2353145 */   // Label 33067: @2353145
     /* 2353145 */   GIM_Try, /*On fail goto*//*Label 33068*/ GIMT_Encode4(2353190), // Rule ID 50727 //
     /* 2353150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2353153 */     // (smax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2353156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353177 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2353185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353189 */     // GIR_Coverage, 50727,
     /* 2353189 */     GIR_EraseRootFromParent_Done,
     /* 2353190 */   // Label 33068: @2353190
     /* 2353190 */   GIM_Reject,
     /* 2353191 */ // Label 33066: @2353191
     /* 2353191 */ GIM_Reject,
     /* 2353192 */ // Label 33008: @2353192
     /* 2353192 */ GIM_Try, /*On fail goto*//*Label 33069*/ GIMT_Encode4(2353306),
     /* 2353197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2353200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2353203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353211 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2353215 */   GIM_Try, /*On fail goto*//*Label 33070*/ GIMT_Encode4(2353260), // Rule ID 50682 //
     /* 2353220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353223 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2353226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2353240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353242 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353259 */     // GIR_Coverage, 50682,
     /* 2353259 */     GIR_EraseRootFromParent_Done,
     /* 2353260 */   // Label 33070: @2353260
     /* 2353260 */   GIM_Try, /*On fail goto*//*Label 33071*/ GIMT_Encode4(2353305), // Rule ID 50683 //
     /* 2353265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353268 */     // (smax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAX_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2353271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M2),
     /* 2353285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353304 */     // GIR_Coverage, 50683,
     /* 2353304 */     GIR_EraseRootFromParent_Done,
     /* 2353305 */   // Label 33071: @2353305
     /* 2353305 */   GIM_Reject,
     /* 2353306 */ // Label 33069: @2353306
     /* 2353306 */ GIM_Reject,
     /* 2353307 */ // Label 33009: @2353307
     /* 2353307 */ GIM_Try, /*On fail goto*//*Label 33072*/ GIMT_Encode4(2353421),
     /* 2353312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2353315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2353318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353330 */   GIM_Try, /*On fail goto*//*Label 33073*/ GIMT_Encode4(2353375), // Rule ID 50698 //
     /* 2353335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353338 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2353341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353374 */     // GIR_Coverage, 50698,
     /* 2353374 */     GIR_EraseRootFromParent_Done,
     /* 2353375 */   // Label 33073: @2353375
     /* 2353375 */   GIM_Try, /*On fail goto*//*Label 33074*/ GIMT_Encode4(2353420), // Rule ID 50699 //
     /* 2353380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353383 */     // (smax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2353386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353419 */     // GIR_Coverage, 50699,
     /* 2353419 */     GIR_EraseRootFromParent_Done,
     /* 2353420 */   // Label 33074: @2353420
     /* 2353420 */   GIM_Reject,
     /* 2353421 */ // Label 33072: @2353421
     /* 2353421 */ GIM_Reject,
     /* 2353422 */ // Label 33010: @2353422
     /* 2353422 */ GIM_Try, /*On fail goto*//*Label 33075*/ GIMT_Encode4(2353536),
     /* 2353427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2353430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2353433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353441 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353445 */   GIM_Try, /*On fail goto*//*Label 33076*/ GIMT_Encode4(2353490), // Rule ID 50714 //
     /* 2353450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353453 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2353456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353489 */     // GIR_Coverage, 50714,
     /* 2353489 */     GIR_EraseRootFromParent_Done,
     /* 2353490 */   // Label 33076: @2353490
     /* 2353490 */   GIM_Try, /*On fail goto*//*Label 33077*/ GIMT_Encode4(2353535), // Rule ID 50715 //
     /* 2353495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353498 */     // (smax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2353501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2353530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353533 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353534 */     // GIR_Coverage, 50715,
     /* 2353534 */     GIR_EraseRootFromParent_Done,
     /* 2353535 */   // Label 33077: @2353535
     /* 2353535 */   GIM_Reject,
     /* 2353536 */ // Label 33075: @2353536
     /* 2353536 */ GIM_Reject,
     /* 2353537 */ // Label 33011: @2353537
     /* 2353537 */ GIM_Try, /*On fail goto*//*Label 33078*/ GIMT_Encode4(2353651),
     /* 2353542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2353545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2353548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2353560 */   GIM_Try, /*On fail goto*//*Label 33079*/ GIMT_Encode4(2353605), // Rule ID 50686 //
     /* 2353565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353568 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2353571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353604 */     // GIR_Coverage, 50686,
     /* 2353604 */     GIR_EraseRootFromParent_Done,
     /* 2353605 */   // Label 33079: @2353605
     /* 2353605 */   GIM_Try, /*On fail goto*//*Label 33080*/ GIMT_Encode4(2353650), // Rule ID 50687 //
     /* 2353610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353613 */     // (smax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAX_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2353616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M4),
     /* 2353630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353635 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353637 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353648 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353649 */     // GIR_Coverage, 50687,
     /* 2353649 */     GIR_EraseRootFromParent_Done,
     /* 2353650 */   // Label 33080: @2353650
     /* 2353650 */   GIM_Reject,
     /* 2353651 */ // Label 33078: @2353651
     /* 2353651 */ GIM_Reject,
     /* 2353652 */ // Label 33012: @2353652
     /* 2353652 */ GIM_Try, /*On fail goto*//*Label 33081*/ GIMT_Encode4(2353766),
     /* 2353657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2353660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2353663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353675 */   GIM_Try, /*On fail goto*//*Label 33082*/ GIMT_Encode4(2353720), // Rule ID 50702 //
     /* 2353680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353683 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2353686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353705 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353707 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353719 */     // GIR_Coverage, 50702,
     /* 2353719 */     GIR_EraseRootFromParent_Done,
     /* 2353720 */   // Label 33082: @2353720
     /* 2353720 */   GIM_Try, /*On fail goto*//*Label 33083*/ GIMT_Encode4(2353765), // Rule ID 50703 //
     /* 2353725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353728 */     // (smax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2353731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2353760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353764 */     // GIR_Coverage, 50703,
     /* 2353764 */     GIR_EraseRootFromParent_Done,
     /* 2353765 */   // Label 33083: @2353765
     /* 2353765 */   GIM_Reject,
     /* 2353766 */ // Label 33081: @2353766
     /* 2353766 */ GIM_Reject,
     /* 2353767 */ // Label 33013: @2353767
     /* 2353767 */ GIM_Try, /*On fail goto*//*Label 33084*/ GIMT_Encode4(2353881),
     /* 2353772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2353775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2353778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353786 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2353790 */   GIM_Try, /*On fail goto*//*Label 33085*/ GIMT_Encode4(2353835), // Rule ID 50690 //
     /* 2353795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2353798 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2353798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2353801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353822 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353833 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353834 */     // GIR_Coverage, 50690,
     /* 2353834 */     GIR_EraseRootFromParent_Done,
     /* 2353835 */   // Label 33085: @2353835
     /* 2353835 */   GIM_Try, /*On fail goto*//*Label 33086*/ GIMT_Encode4(2353880), // Rule ID 50691 //
     /* 2353840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2353843 */     // (smax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAX_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2353843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2353846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2353850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2353855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2353857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAX_VV_M8),
     /* 2353860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2353862 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2353865 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2353867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2353869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2353872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2353878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2353879 */     // GIR_Coverage, 50691,
     /* 2353879 */     GIR_EraseRootFromParent_Done,
     /* 2353880 */   // Label 33086: @2353880
     /* 2353880 */   GIM_Reject,
     /* 2353881 */ // Label 33084: @2353881
     /* 2353881 */ GIM_Reject,
     /* 2353882 */ // Label 33014: @2353882
     /* 2353882 */ GIM_Reject,
     /* 2353883 */ // Label 82: @2353883
     /* 2353883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33111*/ GIMT_Encode4(2356658),
     /* 2353894 */ /*GILLT_s32*//*Label 33087*/ GIMT_Encode4(2354018),
     /* 2353898 */ /*GILLT_s64*//*Label 33088*/ GIMT_Encode4(2354073), GIMT_Encode4(0),
     /* 2353906 */ /*GILLT_nxv1s8*//*Label 33089*/ GIMT_Encode4(2354128),
     /* 2353910 */ /*GILLT_nxv1s16*//*Label 33090*/ GIMT_Encode4(2354243),
     /* 2353914 */ /*GILLT_nxv1s32*//*Label 33091*/ GIMT_Encode4(2354358),
     /* 2353918 */ /*GILLT_nxv1s64*//*Label 33092*/ GIMT_Encode4(2354473), GIMT_Encode4(0),
     /* 2353926 */ /*GILLT_nxv2s8*//*Label 33093*/ GIMT_Encode4(2354588),
     /* 2353930 */ /*GILLT_nxv2s16*//*Label 33094*/ GIMT_Encode4(2354703),
     /* 2353934 */ /*GILLT_nxv2s32*//*Label 33095*/ GIMT_Encode4(2354818),
     /* 2353938 */ /*GILLT_nxv2s64*//*Label 33096*/ GIMT_Encode4(2354933), GIMT_Encode4(0),
     /* 2353946 */ /*GILLT_nxv4s8*//*Label 33097*/ GIMT_Encode4(2355048),
     /* 2353950 */ /*GILLT_nxv4s16*//*Label 33098*/ GIMT_Encode4(2355163),
     /* 2353954 */ /*GILLT_nxv4s32*//*Label 33099*/ GIMT_Encode4(2355278),
     /* 2353958 */ /*GILLT_nxv4s64*//*Label 33100*/ GIMT_Encode4(2355393), GIMT_Encode4(0),
     /* 2353966 */ /*GILLT_nxv8s8*//*Label 33101*/ GIMT_Encode4(2355508),
     /* 2353970 */ /*GILLT_nxv8s16*//*Label 33102*/ GIMT_Encode4(2355623),
     /* 2353974 */ /*GILLT_nxv8s32*//*Label 33103*/ GIMT_Encode4(2355738),
     /* 2353978 */ /*GILLT_nxv8s64*//*Label 33104*/ GIMT_Encode4(2355853), GIMT_Encode4(0),
     /* 2353986 */ /*GILLT_nxv16s8*//*Label 33105*/ GIMT_Encode4(2355968),
     /* 2353990 */ /*GILLT_nxv16s16*//*Label 33106*/ GIMT_Encode4(2356083),
     /* 2353994 */ /*GILLT_nxv16s32*//*Label 33107*/ GIMT_Encode4(2356198), GIMT_Encode4(0),
     /* 2354002 */ /*GILLT_nxv32s8*//*Label 33108*/ GIMT_Encode4(2356313),
     /* 2354006 */ /*GILLT_nxv32s16*//*Label 33109*/ GIMT_Encode4(2356428), GIMT_Encode4(0),
     /* 2354014 */ /*GILLT_nxv64s8*//*Label 33110*/ GIMT_Encode4(2356543),
     /* 2354018 */ // Label 33087: @2354018
     /* 2354018 */ GIM_Try, /*On fail goto*//*Label 33112*/ GIMT_Encode4(2354072),
     /* 2354023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2354026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2354029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354037 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354041 */   GIM_Try, /*On fail goto*//*Label 33113*/ GIMT_Encode4(2354056), // Rule ID 64437 //
     /* 2354046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2354049 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2354049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2354054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354055 */     // GIR_Coverage, 64437,
     /* 2354055 */     GIR_Done,
     /* 2354056 */   // Label 33113: @2354056
     /* 2354056 */   GIM_Try, /*On fail goto*//*Label 33114*/ GIMT_Encode4(2354071), // Rule ID 2423 //
     /* 2354061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2354064 */     // (umin:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MINU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2354064 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2354069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354070 */     // GIR_Coverage, 2423,
     /* 2354070 */     GIR_Done,
     /* 2354071 */   // Label 33114: @2354071
     /* 2354071 */   GIM_Reject,
     /* 2354072 */ // Label 33112: @2354072
     /* 2354072 */ GIM_Reject,
     /* 2354073 */ // Label 33088: @2354073
     /* 2354073 */ GIM_Try, /*On fail goto*//*Label 33115*/ GIMT_Encode4(2354127),
     /* 2354078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2354081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2354084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354092 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2354096 */   GIM_Try, /*On fail goto*//*Label 33116*/ GIMT_Encode4(2354111), // Rule ID 64436 //
     /* 2354101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2354104 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2354104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MINU),
     /* 2354109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354110 */     // GIR_Coverage, 64436,
     /* 2354110 */     GIR_Done,
     /* 2354111 */   // Label 33116: @2354111
     /* 2354111 */   GIM_Try, /*On fail goto*//*Label 33117*/ GIMT_Encode4(2354126), // Rule ID 2422 //
     /* 2354116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2354119 */     // (umin:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MINU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2354119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MINU),
     /* 2354124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354125 */     // GIR_Coverage, 2422,
     /* 2354125 */     GIR_Done,
     /* 2354126 */   // Label 33117: @2354126
     /* 2354126 */   GIM_Reject,
     /* 2354127 */ // Label 33115: @2354127
     /* 2354127 */ GIM_Reject,
     /* 2354128 */ // Label 33089: @2354128
     /* 2354128 */ GIM_Try, /*On fail goto*//*Label 33118*/ GIMT_Encode4(2354242),
     /* 2354133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2354136 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2354139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354143 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354147 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354151 */   GIM_Try, /*On fail goto*//*Label 33119*/ GIMT_Encode4(2354196), // Rule ID 50378 //
     /* 2354156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354159 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2354162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2354176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354195 */     // GIR_Coverage, 50378,
     /* 2354195 */     GIR_EraseRootFromParent_Done,
     /* 2354196 */   // Label 33119: @2354196
     /* 2354196 */   GIM_Try, /*On fail goto*//*Label 33120*/ GIMT_Encode4(2354241), // Rule ID 50379 //
     /* 2354201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354204 */     // (umin:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMINU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2354207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF8),
     /* 2354221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354228 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354240 */     // GIR_Coverage, 50379,
     /* 2354240 */     GIR_EraseRootFromParent_Done,
     /* 2354241 */   // Label 33120: @2354241
     /* 2354241 */   GIM_Reject,
     /* 2354242 */ // Label 33118: @2354242
     /* 2354242 */ GIM_Reject,
     /* 2354243 */ // Label 33090: @2354243
     /* 2354243 */ GIM_Try, /*On fail goto*//*Label 33121*/ GIMT_Encode4(2354357),
     /* 2354248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2354251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2354254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354266 */   GIM_Try, /*On fail goto*//*Label 33122*/ GIMT_Encode4(2354311), // Rule ID 50390 //
     /* 2354271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354274 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2354277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2354291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354310 */     // GIR_Coverage, 50390,
     /* 2354310 */     GIR_EraseRootFromParent_Done,
     /* 2354311 */   // Label 33122: @2354311
     /* 2354311 */   GIM_Try, /*On fail goto*//*Label 33123*/ GIMT_Encode4(2354356), // Rule ID 50391 //
     /* 2354316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354319 */     // (umin:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2354322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2354336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354343 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354355 */     // GIR_Coverage, 50391,
     /* 2354355 */     GIR_EraseRootFromParent_Done,
     /* 2354356 */   // Label 33123: @2354356
     /* 2354356 */   GIM_Reject,
     /* 2354357 */ // Label 33121: @2354357
     /* 2354357 */ GIM_Reject,
     /* 2354358 */ // Label 33091: @2354358
     /* 2354358 */ GIM_Try, /*On fail goto*//*Label 33124*/ GIMT_Encode4(2354472),
     /* 2354363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2354366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2354369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354381 */   GIM_Try, /*On fail goto*//*Label 33125*/ GIMT_Encode4(2354426), // Rule ID 50398 //
     /* 2354386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354389 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2354392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2354406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354425 */     // GIR_Coverage, 50398,
     /* 2354425 */     GIR_EraseRootFromParent_Done,
     /* 2354426 */   // Label 33125: @2354426
     /* 2354426 */   GIM_Try, /*On fail goto*//*Label 33126*/ GIMT_Encode4(2354471), // Rule ID 50399 //
     /* 2354431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354434 */     // (umin:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2354437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2354451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354456 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354458 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354470 */     // GIR_Coverage, 50399,
     /* 2354470 */     GIR_EraseRootFromParent_Done,
     /* 2354471 */   // Label 33126: @2354471
     /* 2354471 */   GIM_Reject,
     /* 2354472 */ // Label 33124: @2354472
     /* 2354472 */ GIM_Reject,
     /* 2354473 */ // Label 33092: @2354473
     /* 2354473 */ GIM_Try, /*On fail goto*//*Label 33127*/ GIMT_Encode4(2354587),
     /* 2354478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2354481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2354484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354496 */   GIM_Try, /*On fail goto*//*Label 33128*/ GIMT_Encode4(2354541), // Rule ID 50414 //
     /* 2354501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2354504 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2354521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354540 */     // GIR_Coverage, 50414,
     /* 2354540 */     GIR_EraseRootFromParent_Done,
     /* 2354541 */   // Label 33128: @2354541
     /* 2354541 */   GIM_Try, /*On fail goto*//*Label 33129*/ GIMT_Encode4(2354586), // Rule ID 50415 //
     /* 2354546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2354549 */     // (umin:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2354552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2354566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354568 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354573 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354584 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354585 */     // GIR_Coverage, 50415,
     /* 2354585 */     GIR_EraseRootFromParent_Done,
     /* 2354586 */   // Label 33129: @2354586
     /* 2354586 */   GIM_Reject,
     /* 2354587 */ // Label 33127: @2354587
     /* 2354587 */ GIM_Reject,
     /* 2354588 */ // Label 33093: @2354588
     /* 2354588 */ GIM_Try, /*On fail goto*//*Label 33130*/ GIMT_Encode4(2354702),
     /* 2354593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2354596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2354599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354607 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354611 */   GIM_Try, /*On fail goto*//*Label 33131*/ GIMT_Encode4(2354656), // Rule ID 50382 //
     /* 2354616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354619 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2354622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2354636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354655 */     // GIR_Coverage, 50382,
     /* 2354655 */     GIR_EraseRootFromParent_Done,
     /* 2354656 */   // Label 33131: @2354656
     /* 2354656 */   GIM_Try, /*On fail goto*//*Label 33132*/ GIMT_Encode4(2354701), // Rule ID 50383 //
     /* 2354661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354664 */     // (umin:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMINU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2354667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF4),
     /* 2354681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354700 */     // GIR_Coverage, 50383,
     /* 2354700 */     GIR_EraseRootFromParent_Done,
     /* 2354701 */   // Label 33132: @2354701
     /* 2354701 */   GIM_Reject,
     /* 2354702 */ // Label 33130: @2354702
     /* 2354702 */ GIM_Reject,
     /* 2354703 */ // Label 33094: @2354703
     /* 2354703 */ GIM_Try, /*On fail goto*//*Label 33133*/ GIMT_Encode4(2354817),
     /* 2354708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2354711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2354714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354718 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354722 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354726 */   GIM_Try, /*On fail goto*//*Label 33134*/ GIMT_Encode4(2354771), // Rule ID 50394 //
     /* 2354731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354734 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2354751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354758 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354770 */     // GIR_Coverage, 50394,
     /* 2354770 */     GIR_EraseRootFromParent_Done,
     /* 2354771 */   // Label 33134: @2354771
     /* 2354771 */   GIM_Try, /*On fail goto*//*Label 33135*/ GIMT_Encode4(2354816), // Rule ID 50395 //
     /* 2354776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354779 */     // (umin:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2354782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2354796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354798 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354803 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2354811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354814 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354815 */     // GIR_Coverage, 50395,
     /* 2354815 */     GIR_EraseRootFromParent_Done,
     /* 2354816 */   // Label 33135: @2354816
     /* 2354816 */   GIM_Reject,
     /* 2354817 */ // Label 33133: @2354817
     /* 2354817 */ GIM_Reject,
     /* 2354818 */ // Label 33095: @2354818
     /* 2354818 */ GIM_Try, /*On fail goto*//*Label 33136*/ GIMT_Encode4(2354932),
     /* 2354823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2354826 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2354829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354837 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2354841 */   GIM_Try, /*On fail goto*//*Label 33137*/ GIMT_Encode4(2354886), // Rule ID 50410 //
     /* 2354846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2354849 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2354866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354885 */     // GIR_Coverage, 50410,
     /* 2354885 */     GIR_EraseRootFromParent_Done,
     /* 2354886 */   // Label 33137: @2354886
     /* 2354886 */   GIM_Try, /*On fail goto*//*Label 33138*/ GIMT_Encode4(2354931), // Rule ID 50411 //
     /* 2354891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2354894 */     // (umin:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2354894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2354897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2354911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2354926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2354930 */     // GIR_Coverage, 50411,
     /* 2354930 */     GIR_EraseRootFromParent_Done,
     /* 2354931 */   // Label 33138: @2354931
     /* 2354931 */   GIM_Reject,
     /* 2354932 */ // Label 33136: @2354932
     /* 2354932 */ GIM_Reject,
     /* 2354933 */ // Label 33096: @2354933
     /* 2354933 */ GIM_Try, /*On fail goto*//*Label 33139*/ GIMT_Encode4(2355047),
     /* 2354938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2354941 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2354944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2354956 */   GIM_Try, /*On fail goto*//*Label 33140*/ GIMT_Encode4(2355001), // Rule ID 50454 //
     /* 2354961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2354964 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2354964 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2354967 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2354971 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2354976 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2354978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2354981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2354983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2354986 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2354988 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2354990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2354993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2354996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2354999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355000 */     // GIR_Coverage, 50454,
     /* 2355000 */     GIR_EraseRootFromParent_Done,
     /* 2355001 */   // Label 33140: @2355001
     /* 2355001 */   GIM_Try, /*On fail goto*//*Label 33141*/ GIMT_Encode4(2355046), // Rule ID 50455 //
     /* 2355006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2355009 */     // (umin:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2355012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2355026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355045 */     // GIR_Coverage, 50455,
     /* 2355045 */     GIR_EraseRootFromParent_Done,
     /* 2355046 */   // Label 33141: @2355046
     /* 2355046 */   GIM_Reject,
     /* 2355047 */ // Label 33139: @2355047
     /* 2355047 */ GIM_Reject,
     /* 2355048 */ // Label 33097: @2355048
     /* 2355048 */ GIM_Try, /*On fail goto*//*Label 33142*/ GIMT_Encode4(2355162),
     /* 2355053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2355056 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2355059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355067 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355071 */   GIM_Try, /*On fail goto*//*Label 33143*/ GIMT_Encode4(2355116), // Rule ID 50386 //
     /* 2355076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355079 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2355082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2355096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355103 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355115 */     // GIR_Coverage, 50386,
     /* 2355115 */     GIR_EraseRootFromParent_Done,
     /* 2355116 */   // Label 33143: @2355116
     /* 2355116 */   GIM_Try, /*On fail goto*//*Label 33144*/ GIMT_Encode4(2355161), // Rule ID 50387 //
     /* 2355121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355124 */     // (umin:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMINU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2355127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_MF2),
     /* 2355141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355160 */     // GIR_Coverage, 50387,
     /* 2355160 */     GIR_EraseRootFromParent_Done,
     /* 2355161 */   // Label 33144: @2355161
     /* 2355161 */   GIM_Reject,
     /* 2355162 */ // Label 33142: @2355162
     /* 2355162 */ GIM_Reject,
     /* 2355163 */ // Label 33098: @2355163
     /* 2355163 */ GIM_Try, /*On fail goto*//*Label 33145*/ GIMT_Encode4(2355277),
     /* 2355168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2355171 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2355174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355182 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355186 */   GIM_Try, /*On fail goto*//*Label 33146*/ GIMT_Encode4(2355231), // Rule ID 50406 //
     /* 2355191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355194 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2355211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355229 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355230 */     // GIR_Coverage, 50406,
     /* 2355230 */     GIR_EraseRootFromParent_Done,
     /* 2355231 */   // Label 33146: @2355231
     /* 2355231 */   GIM_Try, /*On fail goto*//*Label 33147*/ GIMT_Encode4(2355276), // Rule ID 50407 //
     /* 2355236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355239 */     // (umin:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2355242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2355256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355261 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355263 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355274 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355275 */     // GIR_Coverage, 50407,
     /* 2355275 */     GIR_EraseRootFromParent_Done,
     /* 2355276 */   // Label 33147: @2355276
     /* 2355276 */   GIM_Reject,
     /* 2355277 */ // Label 33145: @2355277
     /* 2355277 */ GIM_Reject,
     /* 2355278 */ // Label 33099: @2355278
     /* 2355278 */ GIM_Try, /*On fail goto*//*Label 33148*/ GIMT_Encode4(2355392),
     /* 2355283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2355286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2355289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355297 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355301 */   GIM_Try, /*On fail goto*//*Label 33149*/ GIMT_Encode4(2355346), // Rule ID 50442 //
     /* 2355306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355309 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2355326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355345 */     // GIR_Coverage, 50442,
     /* 2355345 */     GIR_EraseRootFromParent_Done,
     /* 2355346 */   // Label 33149: @2355346
     /* 2355346 */   GIM_Try, /*On fail goto*//*Label 33150*/ GIMT_Encode4(2355391), // Rule ID 50443 //
     /* 2355351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355354 */     // (umin:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2355357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355366 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2355371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355376 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355378 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355389 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355390 */     // GIR_Coverage, 50443,
     /* 2355390 */     GIR_EraseRootFromParent_Done,
     /* 2355391 */   // Label 33150: @2355391
     /* 2355391 */   GIM_Reject,
     /* 2355392 */ // Label 33148: @2355392
     /* 2355392 */ GIM_Reject,
     /* 2355393 */ // Label 33100: @2355393
     /* 2355393 */ GIM_Try, /*On fail goto*//*Label 33151*/ GIMT_Encode4(2355507),
     /* 2355398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2355401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2355404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355416 */   GIM_Try, /*On fail goto*//*Label 33152*/ GIMT_Encode4(2355461), // Rule ID 50458 //
     /* 2355421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2355424 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355424 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355427 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355431 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355436 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2355441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355460 */     // GIR_Coverage, 50458,
     /* 2355460 */     GIR_EraseRootFromParent_Done,
     /* 2355461 */   // Label 33152: @2355461
     /* 2355461 */   GIM_Try, /*On fail goto*//*Label 33153*/ GIMT_Encode4(2355506), // Rule ID 50459 //
     /* 2355466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2355469 */     // (umin:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2355472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2355486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355488 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355493 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355505 */     // GIR_Coverage, 50459,
     /* 2355505 */     GIR_EraseRootFromParent_Done,
     /* 2355506 */   // Label 33153: @2355506
     /* 2355506 */   GIM_Reject,
     /* 2355507 */ // Label 33151: @2355507
     /* 2355507 */ GIM_Reject,
     /* 2355508 */ // Label 33101: @2355508
     /* 2355508 */ GIM_Try, /*On fail goto*//*Label 33154*/ GIMT_Encode4(2355622),
     /* 2355513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2355516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2355519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355527 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2355531 */   GIM_Try, /*On fail goto*//*Label 33155*/ GIMT_Encode4(2355576), // Rule ID 50402 //
     /* 2355536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355539 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2355542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2355556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355563 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355575 */     // GIR_Coverage, 50402,
     /* 2355575 */     GIR_EraseRootFromParent_Done,
     /* 2355576 */   // Label 33155: @2355576
     /* 2355576 */   GIM_Try, /*On fail goto*//*Label 33156*/ GIMT_Encode4(2355621), // Rule ID 50403 //
     /* 2355581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355584 */     // (umin:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMINU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2355587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M1),
     /* 2355601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355620 */     // GIR_Coverage, 50403,
     /* 2355620 */     GIR_EraseRootFromParent_Done,
     /* 2355621 */   // Label 33156: @2355621
     /* 2355621 */   GIM_Reject,
     /* 2355622 */ // Label 33154: @2355622
     /* 2355622 */ GIM_Reject,
     /* 2355623 */ // Label 33102: @2355623
     /* 2355623 */ GIM_Try, /*On fail goto*//*Label 33157*/ GIMT_Encode4(2355737),
     /* 2355628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2355631 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2355634 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355638 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355642 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355646 */   GIM_Try, /*On fail goto*//*Label 33158*/ GIMT_Encode4(2355691), // Rule ID 50430 //
     /* 2355651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355654 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2355657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2355671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355678 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355689 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355690 */     // GIR_Coverage, 50430,
     /* 2355690 */     GIR_EraseRootFromParent_Done,
     /* 2355691 */   // Label 33158: @2355691
     /* 2355691 */   GIM_Try, /*On fail goto*//*Label 33159*/ GIMT_Encode4(2355736), // Rule ID 50431 //
     /* 2355696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355699 */     // (umin:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2355702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355711 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2355716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2355731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355735 */     // GIR_Coverage, 50431,
     /* 2355735 */     GIR_EraseRootFromParent_Done,
     /* 2355736 */   // Label 33159: @2355736
     /* 2355736 */   GIM_Reject,
     /* 2355737 */ // Label 33157: @2355737
     /* 2355737 */ GIM_Reject,
     /* 2355738 */ // Label 33103: @2355738
     /* 2355738 */ GIM_Try, /*On fail goto*//*Label 33160*/ GIMT_Encode4(2355852),
     /* 2355743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2355746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2355749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2355761 */   GIM_Try, /*On fail goto*//*Label 33161*/ GIMT_Encode4(2355806), // Rule ID 50446 //
     /* 2355766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355769 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2355772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2355786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355805 */     // GIR_Coverage, 50446,
     /* 2355805 */     GIR_EraseRootFromParent_Done,
     /* 2355806 */   // Label 33161: @2355806
     /* 2355806 */   GIM_Try, /*On fail goto*//*Label 33162*/ GIMT_Encode4(2355851), // Rule ID 50447 //
     /* 2355811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2355814 */     // (umin:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2355817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2355831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355838 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2355846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355849 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355850 */     // GIR_Coverage, 50447,
     /* 2355850 */     GIR_EraseRootFromParent_Done,
     /* 2355851 */   // Label 33162: @2355851
     /* 2355851 */   GIM_Reject,
     /* 2355852 */ // Label 33160: @2355852
     /* 2355852 */ GIM_Reject,
     /* 2355853 */ // Label 33104: @2355853
     /* 2355853 */ GIM_Try, /*On fail goto*//*Label 33163*/ GIMT_Encode4(2355967),
     /* 2355858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2355861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2355864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355872 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2355876 */   GIM_Try, /*On fail goto*//*Label 33164*/ GIMT_Encode4(2355921), // Rule ID 50462 //
     /* 2355881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2355884 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2355887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2355901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355906 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355908 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355920 */     // GIR_Coverage, 50462,
     /* 2355920 */     GIR_EraseRootFromParent_Done,
     /* 2355921 */   // Label 33164: @2355921
     /* 2355921 */   GIM_Try, /*On fail goto*//*Label 33165*/ GIMT_Encode4(2355966), // Rule ID 50463 //
     /* 2355926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2355929 */     // (umin:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2355929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2355932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2355936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2355941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2355943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2355946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2355948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2355951 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2355953 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2355955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2355958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2355961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2355964 */     GIR_RootConstrainSelectedInstOperands,
     /* 2355965 */     // GIR_Coverage, 50463,
     /* 2355965 */     GIR_EraseRootFromParent_Done,
     /* 2355966 */   // Label 33165: @2355966
     /* 2355966 */   GIM_Reject,
     /* 2355967 */ // Label 33163: @2355967
     /* 2355967 */ GIM_Reject,
     /* 2355968 */ // Label 33105: @2355968
     /* 2355968 */ GIM_Try, /*On fail goto*//*Label 33166*/ GIMT_Encode4(2356082),
     /* 2355973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2355976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2355979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355987 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2355991 */   GIM_Try, /*On fail goto*//*Label 33167*/ GIMT_Encode4(2356036), // Rule ID 50418 //
     /* 2355996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2355999 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2355999 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2356002 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356006 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2356016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356035 */     // GIR_Coverage, 50418,
     /* 2356035 */     GIR_EraseRootFromParent_Done,
     /* 2356036 */   // Label 33167: @2356036
     /* 2356036 */   GIM_Try, /*On fail goto*//*Label 33168*/ GIMT_Encode4(2356081), // Rule ID 50419 //
     /* 2356041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356044 */     // (umin:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMINU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2356047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M2),
     /* 2356061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356080 */     // GIR_Coverage, 50419,
     /* 2356080 */     GIR_EraseRootFromParent_Done,
     /* 2356081 */   // Label 33168: @2356081
     /* 2356081 */   GIM_Reject,
     /* 2356082 */ // Label 33166: @2356082
     /* 2356082 */ GIM_Reject,
     /* 2356083 */ // Label 33106: @2356083
     /* 2356083 */ GIM_Try, /*On fail goto*//*Label 33169*/ GIMT_Encode4(2356197),
     /* 2356088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2356091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2356094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356102 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356106 */   GIM_Try, /*On fail goto*//*Label 33170*/ GIMT_Encode4(2356151), // Rule ID 50434 //
     /* 2356111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356114 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2356131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356150 */     // GIR_Coverage, 50434,
     /* 2356150 */     GIR_EraseRootFromParent_Done,
     /* 2356151 */   // Label 33170: @2356151
     /* 2356151 */   GIM_Try, /*On fail goto*//*Label 33171*/ GIMT_Encode4(2356196), // Rule ID 50435 //
     /* 2356156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356159 */     // (umin:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2356162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2356176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356183 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356195 */     // GIR_Coverage, 50435,
     /* 2356195 */     GIR_EraseRootFromParent_Done,
     /* 2356196 */   // Label 33171: @2356196
     /* 2356196 */   GIM_Reject,
     /* 2356197 */ // Label 33169: @2356197
     /* 2356197 */ GIM_Reject,
     /* 2356198 */ // Label 33107: @2356198
     /* 2356198 */ GIM_Try, /*On fail goto*//*Label 33172*/ GIMT_Encode4(2356312),
     /* 2356203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2356206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2356209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356221 */   GIM_Try, /*On fail goto*//*Label 33173*/ GIMT_Encode4(2356266), // Rule ID 50450 //
     /* 2356226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356229 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356265 */     // GIR_Coverage, 50450,
     /* 2356265 */     GIR_EraseRootFromParent_Done,
     /* 2356266 */   // Label 33173: @2356266
     /* 2356266 */   GIM_Try, /*On fail goto*//*Label 33174*/ GIMT_Encode4(2356311), // Rule ID 50451 //
     /* 2356271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356274 */     // (umin:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2356277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2356306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356309 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356310 */     // GIR_Coverage, 50451,
     /* 2356310 */     GIR_EraseRootFromParent_Done,
     /* 2356311 */   // Label 33174: @2356311
     /* 2356311 */   GIM_Reject,
     /* 2356312 */ // Label 33172: @2356312
     /* 2356312 */ GIM_Reject,
     /* 2356313 */ // Label 33108: @2356313
     /* 2356313 */ GIM_Try, /*On fail goto*//*Label 33175*/ GIMT_Encode4(2356427),
     /* 2356318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2356321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2356324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2356336 */   GIM_Try, /*On fail goto*//*Label 33176*/ GIMT_Encode4(2356381), // Rule ID 50422 //
     /* 2356341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356344 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2356347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2356361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356368 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356380 */     // GIR_Coverage, 50422,
     /* 2356380 */     GIR_EraseRootFromParent_Done,
     /* 2356381 */   // Label 33176: @2356381
     /* 2356381 */   GIM_Try, /*On fail goto*//*Label 33177*/ GIMT_Encode4(2356426), // Rule ID 50423 //
     /* 2356386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356389 */     // (umin:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMINU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2356392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M4),
     /* 2356406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356425 */     // GIR_Coverage, 50423,
     /* 2356425 */     GIR_EraseRootFromParent_Done,
     /* 2356426 */   // Label 33177: @2356426
     /* 2356426 */   GIM_Reject,
     /* 2356427 */ // Label 33175: @2356427
     /* 2356427 */ GIM_Reject,
     /* 2356428 */ // Label 33109: @2356428
     /* 2356428 */ GIM_Try, /*On fail goto*//*Label 33178*/ GIMT_Encode4(2356542),
     /* 2356433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2356436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2356439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356447 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356451 */   GIM_Try, /*On fail goto*//*Label 33179*/ GIMT_Encode4(2356496), // Rule ID 50438 //
     /* 2356456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356459 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2356462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356483 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356495 */     // GIR_Coverage, 50438,
     /* 2356495 */     GIR_EraseRootFromParent_Done,
     /* 2356496 */   // Label 33179: @2356496
     /* 2356496 */   GIM_Try, /*On fail goto*//*Label 33180*/ GIMT_Encode4(2356541), // Rule ID 50439 //
     /* 2356501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356504 */     // (umin:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2356507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2356536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356539 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356540 */     // GIR_Coverage, 50439,
     /* 2356540 */     GIR_EraseRootFromParent_Done,
     /* 2356541 */   // Label 33180: @2356541
     /* 2356541 */   GIM_Reject,
     /* 2356542 */ // Label 33178: @2356542
     /* 2356542 */ GIM_Reject,
     /* 2356543 */ // Label 33110: @2356543
     /* 2356543 */ GIM_Try, /*On fail goto*//*Label 33181*/ GIMT_Encode4(2356657),
     /* 2356548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2356551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2356554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2356566 */   GIM_Try, /*On fail goto*//*Label 33182*/ GIMT_Encode4(2356611), // Rule ID 50426 //
     /* 2356571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356574 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356574 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2356577 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356581 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356610 */     // GIR_Coverage, 50426,
     /* 2356610 */     GIR_EraseRootFromParent_Done,
     /* 2356611 */   // Label 33182: @2356611
     /* 2356611 */   GIM_Try, /*On fail goto*//*Label 33183*/ GIMT_Encode4(2356656), // Rule ID 50427 //
     /* 2356616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356619 */     // (umin:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMINU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2356622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356631 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMINU_VV_M8),
     /* 2356636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356643 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356654 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356655 */     // GIR_Coverage, 50427,
     /* 2356655 */     GIR_EraseRootFromParent_Done,
     /* 2356656 */   // Label 33183: @2356656
     /* 2356656 */   GIM_Reject,
     /* 2356657 */ // Label 33181: @2356657
     /* 2356657 */ GIM_Reject,
     /* 2356658 */ // Label 33111: @2356658
     /* 2356658 */ GIM_Reject,
     /* 2356659 */ // Label 83: @2356659
     /* 2356659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33208*/ GIMT_Encode4(2359434),
     /* 2356670 */ /*GILLT_s32*//*Label 33184*/ GIMT_Encode4(2356794),
     /* 2356674 */ /*GILLT_s64*//*Label 33185*/ GIMT_Encode4(2356849), GIMT_Encode4(0),
     /* 2356682 */ /*GILLT_nxv1s8*//*Label 33186*/ GIMT_Encode4(2356904),
     /* 2356686 */ /*GILLT_nxv1s16*//*Label 33187*/ GIMT_Encode4(2357019),
     /* 2356690 */ /*GILLT_nxv1s32*//*Label 33188*/ GIMT_Encode4(2357134),
     /* 2356694 */ /*GILLT_nxv1s64*//*Label 33189*/ GIMT_Encode4(2357249), GIMT_Encode4(0),
     /* 2356702 */ /*GILLT_nxv2s8*//*Label 33190*/ GIMT_Encode4(2357364),
     /* 2356706 */ /*GILLT_nxv2s16*//*Label 33191*/ GIMT_Encode4(2357479),
     /* 2356710 */ /*GILLT_nxv2s32*//*Label 33192*/ GIMT_Encode4(2357594),
     /* 2356714 */ /*GILLT_nxv2s64*//*Label 33193*/ GIMT_Encode4(2357709), GIMT_Encode4(0),
     /* 2356722 */ /*GILLT_nxv4s8*//*Label 33194*/ GIMT_Encode4(2357824),
     /* 2356726 */ /*GILLT_nxv4s16*//*Label 33195*/ GIMT_Encode4(2357939),
     /* 2356730 */ /*GILLT_nxv4s32*//*Label 33196*/ GIMT_Encode4(2358054),
     /* 2356734 */ /*GILLT_nxv4s64*//*Label 33197*/ GIMT_Encode4(2358169), GIMT_Encode4(0),
     /* 2356742 */ /*GILLT_nxv8s8*//*Label 33198*/ GIMT_Encode4(2358284),
     /* 2356746 */ /*GILLT_nxv8s16*//*Label 33199*/ GIMT_Encode4(2358399),
     /* 2356750 */ /*GILLT_nxv8s32*//*Label 33200*/ GIMT_Encode4(2358514),
     /* 2356754 */ /*GILLT_nxv8s64*//*Label 33201*/ GIMT_Encode4(2358629), GIMT_Encode4(0),
     /* 2356762 */ /*GILLT_nxv16s8*//*Label 33202*/ GIMT_Encode4(2358744),
     /* 2356766 */ /*GILLT_nxv16s16*//*Label 33203*/ GIMT_Encode4(2358859),
     /* 2356770 */ /*GILLT_nxv16s32*//*Label 33204*/ GIMT_Encode4(2358974), GIMT_Encode4(0),
     /* 2356778 */ /*GILLT_nxv32s8*//*Label 33205*/ GIMT_Encode4(2359089),
     /* 2356782 */ /*GILLT_nxv32s16*//*Label 33206*/ GIMT_Encode4(2359204), GIMT_Encode4(0),
     /* 2356790 */ /*GILLT_nxv64s8*//*Label 33207*/ GIMT_Encode4(2359319),
     /* 2356794 */ // Label 33184: @2356794
     /* 2356794 */ GIM_Try, /*On fail goto*//*Label 33209*/ GIMT_Encode4(2356848),
     /* 2356799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2356802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2356805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356817 */   GIM_Try, /*On fail goto*//*Label 33210*/ GIMT_Encode4(2356832), // Rule ID 64441 //
     /* 2356822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2356825 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (CV_MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2356825 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2356830 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356831 */     // GIR_Coverage, 64441,
     /* 2356831 */     GIR_Done,
     /* 2356832 */   // Label 33210: @2356832
     /* 2356832 */   GIM_Try, /*On fail goto*//*Label 33211*/ GIMT_Encode4(2356847), // Rule ID 2425 //
     /* 2356837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2356840 */     // (umax:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)  =>  (MAXU:{ *:[i32] } GPR:{ *:[i32] }:$rs1, GPR:{ *:[i32] }:$rs2)
     /* 2356840 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2356845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356846 */     // GIR_Coverage, 2425,
     /* 2356846 */     GIR_Done,
     /* 2356847 */   // Label 33211: @2356847
     /* 2356847 */   GIM_Reject,
     /* 2356848 */ // Label 33209: @2356848
     /* 2356848 */ GIM_Reject,
     /* 2356849 */ // Label 33185: @2356849
     /* 2356849 */ GIM_Try, /*On fail goto*//*Label 33212*/ GIMT_Encode4(2356903),
     /* 2356854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2356857 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2356860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2356872 */   GIM_Try, /*On fail goto*//*Label 33213*/ GIMT_Encode4(2356887), // Rule ID 64440 //
     /* 2356877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2356880 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (CV_MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2356880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_MAXU),
     /* 2356885 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356886 */     // GIR_Coverage, 64440,
     /* 2356886 */     GIR_Done,
     /* 2356887 */   // Label 33213: @2356887
     /* 2356887 */   GIM_Try, /*On fail goto*//*Label 33214*/ GIMT_Encode4(2356902), // Rule ID 2424 //
     /* 2356892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2356895 */     // (umax:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (MAXU:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2356895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::MAXU),
     /* 2356900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356901 */     // GIR_Coverage, 2424,
     /* 2356901 */     GIR_Done,
     /* 2356902 */   // Label 33214: @2356902
     /* 2356902 */   GIM_Reject,
     /* 2356903 */ // Label 33212: @2356903
     /* 2356903 */ GIM_Reject,
     /* 2356904 */ // Label 33186: @2356904
     /* 2356904 */ GIM_Try, /*On fail goto*//*Label 33215*/ GIMT_Encode4(2357018),
     /* 2356909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2356912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2356915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356923 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2356927 */   GIM_Try, /*On fail goto*//*Label 33216*/ GIMT_Encode4(2356972), // Rule ID 50554 //
     /* 2356932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2356935 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2356935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2356938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2356952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2356957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2356959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2356961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2356964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2356970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2356971 */     // GIR_Coverage, 50554,
     /* 2356971 */     GIR_EraseRootFromParent_Done,
     /* 2356972 */   // Label 33216: @2356972
     /* 2356972 */   GIM_Try, /*On fail goto*//*Label 33217*/ GIMT_Encode4(2357017), // Rule ID 50555 //
     /* 2356977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2356980 */     // (umax:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, VR:{ *:[nxv1i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2356980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2356983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2356987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2356992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2356994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF8),
     /* 2356997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2356999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357016 */     // GIR_Coverage, 50555,
     /* 2357016 */     GIR_EraseRootFromParent_Done,
     /* 2357017 */   // Label 33217: @2357017
     /* 2357017 */   GIM_Reject,
     /* 2357018 */ // Label 33215: @2357018
     /* 2357018 */ GIM_Reject,
     /* 2357019 */ // Label 33187: @2357019
     /* 2357019 */ GIM_Try, /*On fail goto*//*Label 33218*/ GIMT_Encode4(2357133),
     /* 2357024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2357027 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2357030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357038 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357042 */   GIM_Try, /*On fail goto*//*Label 33219*/ GIMT_Encode4(2357087), // Rule ID 50566 //
     /* 2357047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357050 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2357067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357086 */     // GIR_Coverage, 50566,
     /* 2357086 */     GIR_EraseRootFromParent_Done,
     /* 2357087 */   // Label 33219: @2357087
     /* 2357087 */   GIM_Try, /*On fail goto*//*Label 33220*/ GIMT_Encode4(2357132), // Rule ID 50567 //
     /* 2357092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357095 */     // (umax:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, VR:{ *:[nxv1i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2357098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2357112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357117 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357130 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357131 */     // GIR_Coverage, 50567,
     /* 2357131 */     GIR_EraseRootFromParent_Done,
     /* 2357132 */   // Label 33220: @2357132
     /* 2357132 */   GIM_Reject,
     /* 2357133 */ // Label 33218: @2357133
     /* 2357133 */ GIM_Reject,
     /* 2357134 */ // Label 33188: @2357134
     /* 2357134 */ GIM_Try, /*On fail goto*//*Label 33221*/ GIMT_Encode4(2357248),
     /* 2357139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2357142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2357145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357157 */   GIM_Try, /*On fail goto*//*Label 33222*/ GIMT_Encode4(2357202), // Rule ID 50574 //
     /* 2357162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357165 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357201 */     // GIR_Coverage, 50574,
     /* 2357201 */     GIR_EraseRootFromParent_Done,
     /* 2357202 */   // Label 33222: @2357202
     /* 2357202 */   GIM_Try, /*On fail goto*//*Label 33223*/ GIMT_Encode4(2357247), // Rule ID 50575 //
     /* 2357207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357210 */     // (umax:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, VR:{ *:[nxv1i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2357213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357245 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357246 */     // GIR_Coverage, 50575,
     /* 2357246 */     GIR_EraseRootFromParent_Done,
     /* 2357247 */   // Label 33223: @2357247
     /* 2357247 */   GIM_Reject,
     /* 2357248 */ // Label 33221: @2357248
     /* 2357248 */ GIM_Reject,
     /* 2357249 */ // Label 33189: @2357249
     /* 2357249 */ GIM_Try, /*On fail goto*//*Label 33224*/ GIMT_Encode4(2357363),
     /* 2357254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2357257 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2357260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357268 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357272 */   GIM_Try, /*On fail goto*//*Label 33225*/ GIMT_Encode4(2357317), // Rule ID 50590 //
     /* 2357277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2357280 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2357297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357316 */     // GIR_Coverage, 50590,
     /* 2357316 */     GIR_EraseRootFromParent_Done,
     /* 2357317 */   // Label 33225: @2357317
     /* 2357317 */   GIM_Try, /*On fail goto*//*Label 33226*/ GIMT_Encode4(2357362), // Rule ID 50591 //
     /* 2357322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2357325 */     // (umax:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, VR:{ *:[nxv1i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2357328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2357342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357361 */     // GIR_Coverage, 50591,
     /* 2357361 */     GIR_EraseRootFromParent_Done,
     /* 2357362 */   // Label 33226: @2357362
     /* 2357362 */   GIM_Reject,
     /* 2357363 */ // Label 33224: @2357363
     /* 2357363 */ GIM_Reject,
     /* 2357364 */ // Label 33190: @2357364
     /* 2357364 */ GIM_Try, /*On fail goto*//*Label 33227*/ GIMT_Encode4(2357478),
     /* 2357369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2357372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2357375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357379 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357383 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357387 */   GIM_Try, /*On fail goto*//*Label 33228*/ GIMT_Encode4(2357432), // Rule ID 50558 //
     /* 2357392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357395 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2357398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2357412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357431 */     // GIR_Coverage, 50558,
     /* 2357431 */     GIR_EraseRootFromParent_Done,
     /* 2357432 */   // Label 33228: @2357432
     /* 2357432 */   GIM_Try, /*On fail goto*//*Label 33229*/ GIMT_Encode4(2357477), // Rule ID 50559 //
     /* 2357437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357440 */     // (umax:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, VR:{ *:[nxv2i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2357443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF4),
     /* 2357457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357462 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357475 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357476 */     // GIR_Coverage, 50559,
     /* 2357476 */     GIR_EraseRootFromParent_Done,
     /* 2357477 */   // Label 33229: @2357477
     /* 2357477 */   GIM_Reject,
     /* 2357478 */ // Label 33227: @2357478
     /* 2357478 */ GIM_Reject,
     /* 2357479 */ // Label 33191: @2357479
     /* 2357479 */ GIM_Try, /*On fail goto*//*Label 33230*/ GIMT_Encode4(2357593),
     /* 2357484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2357487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2357490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357502 */   GIM_Try, /*On fail goto*//*Label 33231*/ GIMT_Encode4(2357547), // Rule ID 50570 //
     /* 2357507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357510 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2357513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357545 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357546 */     // GIR_Coverage, 50570,
     /* 2357546 */     GIR_EraseRootFromParent_Done,
     /* 2357547 */   // Label 33231: @2357547
     /* 2357547 */   GIM_Try, /*On fail goto*//*Label 33232*/ GIMT_Encode4(2357592), // Rule ID 50571 //
     /* 2357552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357555 */     // (umax:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, VR:{ *:[nxv2i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357555 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2357558 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357562 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2357587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357591 */     // GIR_Coverage, 50571,
     /* 2357591 */     GIR_EraseRootFromParent_Done,
     /* 2357592 */   // Label 33232: @2357592
     /* 2357592 */   GIM_Reject,
     /* 2357593 */ // Label 33230: @2357593
     /* 2357593 */ GIM_Reject,
     /* 2357594 */ // Label 33192: @2357594
     /* 2357594 */ GIM_Try, /*On fail goto*//*Label 33233*/ GIMT_Encode4(2357708),
     /* 2357599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2357602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2357605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357617 */   GIM_Try, /*On fail goto*//*Label 33234*/ GIMT_Encode4(2357662), // Rule ID 50586 //
     /* 2357622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357625 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2357628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2357642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357661 */     // GIR_Coverage, 50586,
     /* 2357661 */     GIR_EraseRootFromParent_Done,
     /* 2357662 */   // Label 33234: @2357662
     /* 2357662 */   GIM_Try, /*On fail goto*//*Label 33235*/ GIMT_Encode4(2357707), // Rule ID 50587 //
     /* 2357667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357670 */     // (umax:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, VR:{ *:[nxv2i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2357673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2357687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357689 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2357702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357706 */     // GIR_Coverage, 50587,
     /* 2357706 */     GIR_EraseRootFromParent_Done,
     /* 2357707 */   // Label 33235: @2357707
     /* 2357707 */   GIM_Reject,
     /* 2357708 */ // Label 33233: @2357708
     /* 2357708 */ GIM_Reject,
     /* 2357709 */ // Label 33193: @2357709
     /* 2357709 */ GIM_Try, /*On fail goto*//*Label 33236*/ GIMT_Encode4(2357823),
     /* 2357714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2357717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2357720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357728 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2357732 */   GIM_Try, /*On fail goto*//*Label 33237*/ GIMT_Encode4(2357777), // Rule ID 50630 //
     /* 2357737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2357740 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2357743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2357757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357759 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357762 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357776 */     // GIR_Coverage, 50630,
     /* 2357776 */     GIR_EraseRootFromParent_Done,
     /* 2357777 */   // Label 33237: @2357777
     /* 2357777 */   GIM_Try, /*On fail goto*//*Label 33238*/ GIMT_Encode4(2357822), // Rule ID 50631 //
     /* 2357782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2357785 */     // (umax:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, VRM2:{ *:[nxv2i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2357788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2357802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357807 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357809 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2357817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357821 */     // GIR_Coverage, 50631,
     /* 2357821 */     GIR_EraseRootFromParent_Done,
     /* 2357822 */   // Label 33238: @2357822
     /* 2357822 */   GIM_Reject,
     /* 2357823 */ // Label 33236: @2357823
     /* 2357823 */ GIM_Reject,
     /* 2357824 */ // Label 33194: @2357824
     /* 2357824 */ GIM_Try, /*On fail goto*//*Label 33239*/ GIMT_Encode4(2357938),
     /* 2357829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2357832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2357835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357847 */   GIM_Try, /*On fail goto*//*Label 33240*/ GIMT_Encode4(2357892), // Rule ID 50562 //
     /* 2357852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357855 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2357858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357891 */     // GIR_Coverage, 50562,
     /* 2357891 */     GIR_EraseRootFromParent_Done,
     /* 2357892 */   // Label 33240: @2357892
     /* 2357892 */   GIM_Try, /*On fail goto*//*Label 33241*/ GIMT_Encode4(2357937), // Rule ID 50563 //
     /* 2357897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2357900 */     // (umax:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2)  =>  (PseudoVMAXU_VV_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, VR:{ *:[nxv4i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2357900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2357903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357912 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_MF2),
     /* 2357917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357922 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357924 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2357935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2357936 */     // GIR_Coverage, 50563,
     /* 2357936 */     GIR_EraseRootFromParent_Done,
     /* 2357937 */   // Label 33241: @2357937
     /* 2357937 */   GIM_Reject,
     /* 2357938 */ // Label 33239: @2357938
     /* 2357938 */ GIM_Reject,
     /* 2357939 */ // Label 33195: @2357939
     /* 2357939 */ GIM_Try, /*On fail goto*//*Label 33242*/ GIMT_Encode4(2358053),
     /* 2357944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2357947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2357950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2357962 */   GIM_Try, /*On fail goto*//*Label 33243*/ GIMT_Encode4(2358007), // Rule ID 50582 //
     /* 2357967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2357970 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2357970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2357973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2357977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2357982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2357984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2357987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2357989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2357992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2357994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2357996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2357999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358006 */     // GIR_Coverage, 50582,
     /* 2358006 */     GIR_EraseRootFromParent_Done,
     /* 2358007 */   // Label 33243: @2358007
     /* 2358007 */   GIM_Try, /*On fail goto*//*Label 33244*/ GIMT_Encode4(2358052), // Rule ID 50583 //
     /* 2358012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358015 */     // (umax:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, VR:{ *:[nxv4i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2358018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2358032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358051 */     // GIR_Coverage, 50583,
     /* 2358051 */     GIR_EraseRootFromParent_Done,
     /* 2358052 */   // Label 33244: @2358052
     /* 2358052 */   GIM_Reject,
     /* 2358053 */ // Label 33242: @2358053
     /* 2358053 */ GIM_Reject,
     /* 2358054 */ // Label 33196: @2358054
     /* 2358054 */ GIM_Try, /*On fail goto*//*Label 33245*/ GIMT_Encode4(2358168),
     /* 2358059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2358062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2358065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358073 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358077 */   GIM_Try, /*On fail goto*//*Label 33246*/ GIMT_Encode4(2358122), // Rule ID 50618 //
     /* 2358082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358085 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358107 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358109 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358121 */     // GIR_Coverage, 50618,
     /* 2358121 */     GIR_EraseRootFromParent_Done,
     /* 2358122 */   // Label 33246: @2358122
     /* 2358122 */   GIM_Try, /*On fail goto*//*Label 33247*/ GIMT_Encode4(2358167), // Rule ID 50619 //
     /* 2358127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358130 */     // (umax:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, VRM2:{ *:[nxv4i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2358133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358142 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358166 */     // GIR_Coverage, 50619,
     /* 2358166 */     GIR_EraseRootFromParent_Done,
     /* 2358167 */   // Label 33247: @2358167
     /* 2358167 */   GIM_Reject,
     /* 2358168 */ // Label 33245: @2358168
     /* 2358168 */ GIM_Reject,
     /* 2358169 */ // Label 33197: @2358169
     /* 2358169 */ GIM_Try, /*On fail goto*//*Label 33248*/ GIMT_Encode4(2358283),
     /* 2358174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2358177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2358180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358188 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358192 */   GIM_Try, /*On fail goto*//*Label 33249*/ GIMT_Encode4(2358237), // Rule ID 50634 //
     /* 2358197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2358200 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358222 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358224 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358236 */     // GIR_Coverage, 50634,
     /* 2358236 */     GIR_EraseRootFromParent_Done,
     /* 2358237 */   // Label 33249: @2358237
     /* 2358237 */   GIM_Try, /*On fail goto*//*Label 33250*/ GIMT_Encode4(2358282), // Rule ID 50635 //
     /* 2358242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2358245 */     // (umax:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, VRM4:{ *:[nxv4i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2358248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358281 */     // GIR_Coverage, 50635,
     /* 2358281 */     GIR_EraseRootFromParent_Done,
     /* 2358282 */   // Label 33250: @2358282
     /* 2358282 */   GIM_Reject,
     /* 2358283 */ // Label 33248: @2358283
     /* 2358283 */ GIM_Reject,
     /* 2358284 */ // Label 33198: @2358284
     /* 2358284 */ GIM_Try, /*On fail goto*//*Label 33251*/ GIMT_Encode4(2358398),
     /* 2358289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2358292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2358295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358303 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2358307 */   GIM_Try, /*On fail goto*//*Label 33252*/ GIMT_Encode4(2358352), // Rule ID 50578 //
     /* 2358312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358315 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2358318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358327 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2358332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358337 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358339 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358351 */     // GIR_Coverage, 50578,
     /* 2358351 */     GIR_EraseRootFromParent_Done,
     /* 2358352 */   // Label 33252: @2358352
     /* 2358352 */   GIM_Try, /*On fail goto*//*Label 33253*/ GIMT_Encode4(2358397), // Rule ID 50579 //
     /* 2358357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358360 */     // (umax:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2)  =>  (PseudoVMAXU_VV_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, VR:{ *:[nxv8i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358360 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2358363 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358367 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M1),
     /* 2358377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358382 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358384 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358396 */     // GIR_Coverage, 50579,
     /* 2358396 */     GIR_EraseRootFromParent_Done,
     /* 2358397 */   // Label 33253: @2358397
     /* 2358397 */   GIM_Reject,
     /* 2358398 */ // Label 33251: @2358398
     /* 2358398 */ GIM_Reject,
     /* 2358399 */ // Label 33199: @2358399
     /* 2358399 */ GIM_Try, /*On fail goto*//*Label 33254*/ GIMT_Encode4(2358513),
     /* 2358404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2358407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2358410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358422 */   GIM_Try, /*On fail goto*//*Label 33255*/ GIMT_Encode4(2358467), // Rule ID 50606 //
     /* 2358427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358430 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358466 */     // GIR_Coverage, 50606,
     /* 2358466 */     GIR_EraseRootFromParent_Done,
     /* 2358467 */   // Label 33255: @2358467
     /* 2358467 */   GIM_Try, /*On fail goto*//*Label 33256*/ GIMT_Encode4(2358512), // Rule ID 50607 //
     /* 2358472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358475 */     // (umax:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, VRM2:{ *:[nxv8i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2358478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358507 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358510 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358511 */     // GIR_Coverage, 50607,
     /* 2358511 */     GIR_EraseRootFromParent_Done,
     /* 2358512 */   // Label 33256: @2358512
     /* 2358512 */   GIM_Reject,
     /* 2358513 */ // Label 33254: @2358513
     /* 2358513 */ GIM_Reject,
     /* 2358514 */ // Label 33200: @2358514
     /* 2358514 */ GIM_Try, /*On fail goto*//*Label 33257*/ GIMT_Encode4(2358628),
     /* 2358519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2358522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2358525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358537 */   GIM_Try, /*On fail goto*//*Label 33258*/ GIMT_Encode4(2358582), // Rule ID 50622 //
     /* 2358542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358545 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2358548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358581 */     // GIR_Coverage, 50622,
     /* 2358581 */     GIR_EraseRootFromParent_Done,
     /* 2358582 */   // Label 33258: @2358582
     /* 2358582 */   GIM_Try, /*On fail goto*//*Label 33259*/ GIMT_Encode4(2358627), // Rule ID 50623 //
     /* 2358587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358590 */     // (umax:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, VRM4:{ *:[nxv8i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2358593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358614 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2358622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358625 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358626 */     // GIR_Coverage, 50623,
     /* 2358626 */     GIR_EraseRootFromParent_Done,
     /* 2358627 */   // Label 33259: @2358627
     /* 2358627 */   GIM_Reject,
     /* 2358628 */ // Label 33257: @2358628
     /* 2358628 */ GIM_Reject,
     /* 2358629 */ // Label 33201: @2358629
     /* 2358629 */ GIM_Try, /*On fail goto*//*Label 33260*/ GIMT_Encode4(2358743),
     /* 2358634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2358637 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2358640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358648 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358652 */   GIM_Try, /*On fail goto*//*Label 33261*/ GIMT_Encode4(2358697), // Rule ID 50638 //
     /* 2358657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2358660 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2358663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2358677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358696 */     // GIR_Coverage, 50638,
     /* 2358696 */     GIR_EraseRootFromParent_Done,
     /* 2358697 */   // Label 33261: @2358697
     /* 2358697 */   GIM_Try, /*On fail goto*//*Label 33262*/ GIMT_Encode4(2358742), // Rule ID 50639 //
     /* 2358702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2358705 */     // (umax:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, VRM8:{ *:[nxv8i64] }:$rs2, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2358708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2358722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2358737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358741 */     // GIR_Coverage, 50639,
     /* 2358741 */     GIR_EraseRootFromParent_Done,
     /* 2358742 */   // Label 33262: @2358742
     /* 2358742 */   GIM_Reject,
     /* 2358743 */ // Label 33260: @2358743
     /* 2358743 */ GIM_Reject,
     /* 2358744 */ // Label 33202: @2358744
     /* 2358744 */ GIM_Try, /*On fail goto*//*Label 33263*/ GIMT_Encode4(2358858),
     /* 2358749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2358752 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2358755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358763 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2358767 */   GIM_Try, /*On fail goto*//*Label 33264*/ GIMT_Encode4(2358812), // Rule ID 50594 //
     /* 2358772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358775 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358775 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2358778 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358782 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358787 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358797 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358811 */     // GIR_Coverage, 50594,
     /* 2358811 */     GIR_EraseRootFromParent_Done,
     /* 2358812 */   // Label 33264: @2358812
     /* 2358812 */   GIM_Try, /*On fail goto*//*Label 33265*/ GIMT_Encode4(2358857), // Rule ID 50595 //
     /* 2358817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358820 */     // (umax:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2)  =>  (PseudoVMAXU_VV_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, VRM2:{ *:[nxv16i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2358823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M2),
     /* 2358837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358842 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358844 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358856 */     // GIR_Coverage, 50595,
     /* 2358856 */     GIR_EraseRootFromParent_Done,
     /* 2358857 */   // Label 33265: @2358857
     /* 2358857 */   GIM_Reject,
     /* 2358858 */ // Label 33263: @2358858
     /* 2358858 */ GIM_Reject,
     /* 2358859 */ // Label 33203: @2358859
     /* 2358859 */ GIM_Try, /*On fail goto*//*Label 33266*/ GIMT_Encode4(2358973),
     /* 2358864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2358867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2358870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2358882 */   GIM_Try, /*On fail goto*//*Label 33267*/ GIMT_Encode4(2358927), // Rule ID 50610 //
     /* 2358887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2358890 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2358890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2358893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358926 */     // GIR_Coverage, 50610,
     /* 2358926 */     GIR_EraseRootFromParent_Done,
     /* 2358927 */   // Label 33267: @2358927
     /* 2358927 */   GIM_Try, /*On fail goto*//*Label 33268*/ GIMT_Encode4(2358972), // Rule ID 50611 //
     /* 2358932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2358935 */     // (umax:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, VRM4:{ *:[nxv16i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2358935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2358938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2358942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2358947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2358949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2358952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2358954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2358957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2358959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2358961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2358964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2358967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2358970 */     GIR_RootConstrainSelectedInstOperands,
     /* 2358971 */     // GIR_Coverage, 50611,
     /* 2358971 */     GIR_EraseRootFromParent_Done,
     /* 2358972 */   // Label 33268: @2358972
     /* 2358972 */   GIM_Reject,
     /* 2358973 */ // Label 33266: @2358973
     /* 2358973 */ GIM_Reject,
     /* 2358974 */ // Label 33204: @2358974
     /* 2358974 */ GIM_Try, /*On fail goto*//*Label 33269*/ GIMT_Encode4(2359088),
     /* 2358979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2358982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2358985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2358997 */   GIM_Try, /*On fail goto*//*Label 33270*/ GIMT_Encode4(2359042), // Rule ID 50626 //
     /* 2359002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359005 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359027 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359029 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359041 */     // GIR_Coverage, 50626,
     /* 2359041 */     GIR_EraseRootFromParent_Done,
     /* 2359042 */   // Label 33270: @2359042
     /* 2359042 */   GIM_Try, /*On fail goto*//*Label 33271*/ GIMT_Encode4(2359087), // Rule ID 50627 //
     /* 2359047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359050 */     // (umax:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, VRM8:{ *:[nxv16i32] }:$rs2, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2359053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359074 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2359082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359086 */     // GIR_Coverage, 50627,
     /* 2359086 */     GIR_EraseRootFromParent_Done,
     /* 2359087 */   // Label 33271: @2359087
     /* 2359087 */   GIM_Reject,
     /* 2359088 */ // Label 33269: @2359088
     /* 2359088 */ GIM_Reject,
     /* 2359089 */ // Label 33205: @2359089
     /* 2359089 */ GIM_Try, /*On fail goto*//*Label 33272*/ GIMT_Encode4(2359203),
     /* 2359094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2359097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2359100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359108 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2359112 */   GIM_Try, /*On fail goto*//*Label 33273*/ GIMT_Encode4(2359157), // Rule ID 50598 //
     /* 2359117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359120 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2359123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2359137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359142 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359156 */     // GIR_Coverage, 50598,
     /* 2359156 */     GIR_EraseRootFromParent_Done,
     /* 2359157 */   // Label 33273: @2359157
     /* 2359157 */   GIM_Try, /*On fail goto*//*Label 33274*/ GIMT_Encode4(2359202), // Rule ID 50599 //
     /* 2359162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359165 */     // (umax:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2)  =>  (PseudoVMAXU_VV_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, VRM4:{ *:[nxv32i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2359168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359177 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M4),
     /* 2359182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359184 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359187 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359201 */     // GIR_Coverage, 50599,
     /* 2359201 */     GIR_EraseRootFromParent_Done,
     /* 2359202 */   // Label 33274: @2359202
     /* 2359202 */   GIM_Reject,
     /* 2359203 */ // Label 33272: @2359203
     /* 2359203 */ GIM_Reject,
     /* 2359204 */ // Label 33206: @2359204
     /* 2359204 */ GIM_Try, /*On fail goto*//*Label 33275*/ GIMT_Encode4(2359318),
     /* 2359209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2359212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2359215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359227 */   GIM_Try, /*On fail goto*//*Label 33276*/ GIMT_Encode4(2359272), // Rule ID 50614 //
     /* 2359232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359235 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359247 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359254 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359271 */     // GIR_Coverage, 50614,
     /* 2359271 */     GIR_EraseRootFromParent_Done,
     /* 2359272 */   // Label 33276: @2359272
     /* 2359272 */   GIM_Try, /*On fail goto*//*Label 33277*/ GIMT_Encode4(2359317), // Rule ID 50615 //
     /* 2359277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359280 */     // (umax:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, VRM8:{ *:[nxv32i16] }:$rs2, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2359283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359316 */     // GIR_Coverage, 50615,
     /* 2359316 */     GIR_EraseRootFromParent_Done,
     /* 2359317 */   // Label 33277: @2359317
     /* 2359317 */   GIM_Reject,
     /* 2359318 */ // Label 33275: @2359318
     /* 2359318 */ GIM_Reject,
     /* 2359319 */ // Label 33207: @2359319
     /* 2359319 */ GIM_Try, /*On fail goto*//*Label 33278*/ GIMT_Encode4(2359433),
     /* 2359324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2359327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2359330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2359342 */   GIM_Try, /*On fail goto*//*Label 33279*/ GIMT_Encode4(2359387), // Rule ID 50602 //
     /* 2359347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2359350 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2359350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2359353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359386 */     // GIR_Coverage, 50602,
     /* 2359386 */     GIR_EraseRootFromParent_Done,
     /* 2359387 */   // Label 33279: @2359387
     /* 2359387 */   GIM_Try, /*On fail goto*//*Label 33280*/ GIMT_Encode4(2359432), // Rule ID 50603 //
     /* 2359392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2359395 */     // (umax:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2)  =>  (PseudoVMAXU_VV_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, VRM8:{ *:[nxv64i8] }:$rs2, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2359395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2359398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2359402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2359407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2359409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMAXU_VV_M8),
     /* 2359412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2359417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359419 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2359421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2359424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2359430 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359431 */     // GIR_Coverage, 50603,
     /* 2359431 */     GIR_EraseRootFromParent_Done,
     /* 2359432 */   // Label 33280: @2359432
     /* 2359432 */   GIM_Reject,
     /* 2359433 */ // Label 33278: @2359433
     /* 2359433 */ GIM_Reject,
     /* 2359434 */ // Label 33208: @2359434
     /* 2359434 */ GIM_Reject,
     /* 2359435 */ // Label 84: @2359435
     /* 2359435 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33283*/ GIMT_Encode4(2359592),
     /* 2359446 */ /*GILLT_s32*//*Label 33281*/ GIMT_Encode4(2359454),
     /* 2359450 */ /*GILLT_s64*//*Label 33282*/ GIMT_Encode4(2359523),
     /* 2359454 */ // Label 33281: @2359454
     /* 2359454 */ GIM_Try, /*On fail goto*//*Label 33284*/ GIMT_Encode4(2359522),
     /* 2359459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359470 */   GIM_Try, /*On fail goto*//*Label 33285*/ GIMT_Encode4(2359485), // Rule ID 64429 //
     /* 2359475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode1),
     /* 2359478 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_ABS:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2359478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2359483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359484 */     // GIR_Coverage, 64429,
     /* 2359484 */     GIR_Done,
     /* 2359485 */   // Label 33285: @2359485
     /* 2359485 */   GIM_Try, /*On fail goto*//*Label 33286*/ GIMT_Encode4(2359521), // Rule ID 62483 //
     /* 2359490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode1),
     /* 2359493 */     // (abs:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (PseudoCCSUB:{ *:[i32] } GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, 2:{ *:[i32] }, GPR:{ *:[i32] }:$rs1, X0:{ *:[i32] }, GPR:{ *:[i32] }:$rs1)
     /* 2359493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2359496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2359498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359500 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2359506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2359509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359511 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2359517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359520 */     // GIR_Coverage, 62483,
     /* 2359520 */     GIR_EraseRootFromParent_Done,
     /* 2359521 */   // Label 33286: @2359521
     /* 2359521 */   GIM_Reject,
     /* 2359522 */ // Label 33284: @2359522
     /* 2359522 */ GIM_Reject,
     /* 2359523 */ // Label 33282: @2359523
     /* 2359523 */ GIM_Try, /*On fail goto*//*Label 33287*/ GIMT_Encode4(2359591),
     /* 2359528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359539 */   GIM_Try, /*On fail goto*//*Label 33288*/ GIMT_Encode4(2359554), // Rule ID 64428 //
     /* 2359544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCValu_IsRV32_HwMode0),
     /* 2359547 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_ABS:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2359547 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_ABS),
     /* 2359552 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359553 */     // GIR_Coverage, 64428,
     /* 2359553 */     GIR_Done,
     /* 2359554 */   // Label 33288: @2359554
     /* 2359554 */   GIM_Try, /*On fail goto*//*Label 33289*/ GIMT_Encode4(2359590), // Rule ID 62482 //
     /* 2359559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasShortForwardBranchOpt_HwMode0),
     /* 2359562 */     // (abs:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (PseudoCCSUB:{ *:[i64] } GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, 2:{ *:[i64] }, GPR:{ *:[i64] }:$rs1, X0:{ *:[i64] }, GPR:{ *:[i64] }:$rs1)
     /* 2359562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoCCSUB),
     /* 2359565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2359567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2359575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2359578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(RISCV::X0), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 2359586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2359589 */     // GIR_Coverage, 62482,
     /* 2359589 */     GIR_EraseRootFromParent_Done,
     /* 2359590 */   // Label 33289: @2359590
     /* 2359590 */   GIM_Reject,
     /* 2359591 */ // Label 33287: @2359591
     /* 2359591 */ GIM_Reject,
     /* 2359592 */ // Label 33283: @2359592
     /* 2359592 */ GIM_Reject,
     /* 2359593 */ // Label 85: @2359593
     /* 2359593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 33292*/ GIMT_Encode4(2360172),
     /* 2359604 */ /*GILLT_s32*//*Label 33290*/ GIMT_Encode4(2359612),
     /* 2359608 */ /*GILLT_s64*//*Label 33291*/ GIMT_Encode4(2359985),
     /* 2359612 */ // Label 33290: @2359612
     /* 2359612 */ GIM_Try, /*On fail goto*//*Label 33293*/ GIMT_Encode4(2359643), // Rule ID 1360 //
     /* 2359617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode0),
     /* 2359620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359631 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2359631 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2359634 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359636 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359638 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359641 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359642 */   // GIR_Coverage, 1360,
     /* 2359642 */   GIR_EraseRootFromParent_Done,
     /* 2359643 */ // Label 33293: @2359643
     /* 2359643 */ GIM_Try, /*On fail goto*//*Label 33294*/ GIMT_Encode4(2359674), // Rule ID 1361 //
     /* 2359648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV32_HwMode1),
     /* 2359651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2359662 */   // (lround:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_W_S:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2359662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2359665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359667 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359672 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359673 */   // GIR_Coverage, 1361,
     /* 2359673 */   GIR_EraseRootFromParent_Done,
     /* 2359674 */ // Label 33294: @2359674
     /* 2359674 */ GIM_Try, /*On fail goto*//*Label 33295*/ GIMT_Encode4(2359705), // Rule ID 1386 //
     /* 2359679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode0),
     /* 2359682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359693 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2359693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2359696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359698 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359703 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359704 */   // GIR_Coverage, 1386,
     /* 2359704 */   GIR_EraseRootFromParent_Done,
     /* 2359705 */ // Label 33295: @2359705
     /* 2359705 */ GIM_Try, /*On fail goto*//*Label 33296*/ GIMT_Encode4(2359736), // Rule ID 1387 //
     /* 2359710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV32_HwMode1),
     /* 2359713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2359724 */   // (lround:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_W_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1, 4:{ *:[i32] })
     /* 2359724 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2359727 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359729 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359731 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359734 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359735 */   // GIR_Coverage, 1387,
     /* 2359735 */   GIR_EraseRootFromParent_Done,
     /* 2359736 */ // Label 33296: @2359736
     /* 2359736 */ GIM_Try, /*On fail goto*//*Label 33297*/ GIMT_Encode4(2359767), // Rule ID 1754 //
     /* 2359741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode0),
     /* 2359744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359755 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2359755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2359758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359760 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359762 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359765 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359766 */   // GIR_Coverage, 1754,
     /* 2359766 */   GIR_EraseRootFromParent_Done,
     /* 2359767 */ // Label 33297: @2359767
     /* 2359767 */ GIM_Try, /*On fail goto*//*Label 33298*/ GIMT_Encode4(2359798), // Rule ID 1755 //
     /* 2359772 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV32_HwMode1),
     /* 2359775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359782 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2359786 */   // (lround:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_W_D:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2359786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2359789 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359791 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359793 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359796 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359797 */   // GIR_Coverage, 1755,
     /* 2359797 */   GIR_EraseRootFromParent_Done,
     /* 2359798 */ // Label 33298: @2359798
     /* 2359798 */ GIM_Try, /*On fail goto*//*Label 33299*/ GIMT_Encode4(2359829), // Rule ID 1780 //
     /* 2359803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2359806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359817 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2359817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2359820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359827 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359828 */   // GIR_Coverage, 1780,
     /* 2359828 */   GIR_EraseRootFromParent_Done,
     /* 2359829 */ // Label 33299: @2359829
     /* 2359829 */ GIM_Try, /*On fail goto*//*Label 33300*/ GIMT_Encode4(2359860), // Rule ID 1781 //
     /* 2359834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2359837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2359840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2359848 */   // (lround:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCVT_W_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1, 4:{ *:[i32] })
     /* 2359848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_IN32X),
     /* 2359851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359853 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359858 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359859 */   // GIR_Coverage, 1781,
     /* 2359859 */   GIR_EraseRootFromParent_Done,
     /* 2359860 */ // Label 33300: @2359860
     /* 2359860 */ GIM_Try, /*On fail goto*//*Label 33301*/ GIMT_Encode4(2359891), // Rule ID 2096 //
     /* 2359865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode0),
     /* 2359868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359879 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2359879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2359882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359884 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359889 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359890 */   // GIR_Coverage, 2096,
     /* 2359890 */   GIR_EraseRootFromParent_Done,
     /* 2359891 */ // Label 33301: @2359891
     /* 2359891 */ GIM_Try, /*On fail goto*//*Label 33302*/ GIMT_Encode4(2359922), // Rule ID 2097 //
     /* 2359896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV32_HwMode1),
     /* 2359899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2359910 */   // (lround:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_W_H:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2359910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2359913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359915 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359920 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359921 */   // GIR_Coverage, 2097,
     /* 2359921 */   GIR_EraseRootFromParent_Done,
     /* 2359922 */ // Label 33302: @2359922
     /* 2359922 */ GIM_Try, /*On fail goto*//*Label 33303*/ GIMT_Encode4(2359953), // Rule ID 2122 //
     /* 2359927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode0),
     /* 2359930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359941 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2359941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2359944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359946 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359948 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359951 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359952 */   // GIR_Coverage, 2122,
     /* 2359952 */   GIR_EraseRootFromParent_Done,
     /* 2359953 */ // Label 33303: @2359953
     /* 2359953 */ GIM_Try, /*On fail goto*//*Label 33304*/ GIMT_Encode4(2359984), // Rule ID 2123 //
     /* 2359958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV32_HwMode1),
     /* 2359961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2359964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2359968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2359972 */   // (lround:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_W_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1, 4:{ *:[i32] })
     /* 2359972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2359975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2359977 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2359979 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2359982 */   GIR_RootConstrainSelectedInstOperands,
     /* 2359983 */   // GIR_Coverage, 2123,
     /* 2359983 */   GIR_EraseRootFromParent_Done,
     /* 2359984 */ // Label 33304: @2359984
     /* 2359984 */ GIM_Reject,
     /* 2359985 */ // Label 33291: @2359985
     /* 2359985 */ GIM_Try, /*On fail goto*//*Label 33305*/ GIMT_Encode4(2360016), // Rule ID 1413 //
     /* 2359990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2359993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2359996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2360004 */   // (lround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2360004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2360007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360009 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360011 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360014 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360015 */   // GIR_Coverage, 1413,
     /* 2360015 */   GIR_EraseRootFromParent_Done,
     /* 2360016 */ // Label 33305: @2360016
     /* 2360016 */ GIM_Try, /*On fail goto*//*Label 33306*/ GIMT_Encode4(2360047), // Rule ID 1441 //
     /* 2360021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2360024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2360027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2360035 */   // (lround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2360035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2360038 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360040 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360045 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360046 */   // GIR_Coverage, 1441,
     /* 2360046 */   GIR_EraseRootFromParent_Done,
     /* 2360047 */ // Label 33306: @2360047
     /* 2360047 */ GIM_Try, /*On fail goto*//*Label 33307*/ GIMT_Encode4(2360078), // Rule ID 1811 //
     /* 2360052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2360055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2360058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2360066 */   // (lround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2360066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2360069 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360071 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360073 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360076 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360077 */   // GIR_Coverage, 1811,
     /* 2360077 */   GIR_EraseRootFromParent_Done,
     /* 2360078 */ // Label 33307: @2360078
     /* 2360078 */ GIM_Try, /*On fail goto*//*Label 33308*/ GIMT_Encode4(2360109), // Rule ID 1839 //
     /* 2360083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2360086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2360089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360097 */   // (lround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2360097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2360100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360102 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360104 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360107 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360108 */   // GIR_Coverage, 1839,
     /* 2360108 */   GIR_EraseRootFromParent_Done,
     /* 2360109 */ // Label 33308: @2360109
     /* 2360109 */ GIM_Try, /*On fail goto*//*Label 33309*/ GIMT_Encode4(2360140), // Rule ID 2147 //
     /* 2360114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2360117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2360120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2360128 */   // (lround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2360128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2360131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360133 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360135 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360138 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360139 */   // GIR_Coverage, 2147,
     /* 2360139 */   GIR_EraseRootFromParent_Done,
     /* 2360140 */ // Label 33309: @2360140
     /* 2360140 */ GIM_Try, /*On fail goto*//*Label 33310*/ GIMT_Encode4(2360171), // Rule ID 2173 //
     /* 2360145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2360148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2360151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360155 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2360159 */   // (lround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2360159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2360162 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360164 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360166 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360169 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360170 */   // GIR_Coverage, 2173,
     /* 2360170 */   GIR_EraseRootFromParent_Done,
     /* 2360171 */ // Label 33310: @2360171
     /* 2360171 */ GIM_Reject,
     /* 2360172 */ // Label 33292: @2360172
     /* 2360172 */ GIM_Reject,
     /* 2360173 */ // Label 86: @2360173
     /* 2360173 */ GIM_Try, /*On fail goto*//*Label 33311*/ GIMT_Encode4(2360382),
     /* 2360178 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2360181 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33315*/ GIMT_Encode4(2360381),
     /* 2360192 */   /*GILLT_s16*//*Label 33312*/ GIMT_Encode4(2360204),
     /* 2360196 */   /*GILLT_s32*//*Label 33313*/ GIMT_Encode4(2360263),
     /* 2360200 */   /*GILLT_s64*//*Label 33314*/ GIMT_Encode4(2360322),
     /* 2360204 */   // Label 33312: @2360204
     /* 2360204 */   GIM_Try, /*On fail goto*//*Label 33316*/ GIMT_Encode4(2360262),
     /* 2360209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360213 */     GIM_Try, /*On fail goto*//*Label 33317*/ GIMT_Encode4(2360237), // Rule ID 2149 //
     /* 2360218 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2360221 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2360225 */       // (llround:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCVT_L_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2360225 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H),
     /* 2360228 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360230 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360232 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360235 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360236 */       // GIR_Coverage, 2149,
     /* 2360236 */       GIR_EraseRootFromParent_Done,
     /* 2360237 */     // Label 33317: @2360237
     /* 2360237 */     GIM_Try, /*On fail goto*//*Label 33318*/ GIMT_Encode4(2360261), // Rule ID 2175 //
     /* 2360242 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2360245 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2360249 */       // (llround:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCVT_L_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, 4:{ *:[i64] })
     /* 2360249 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_H_INX),
     /* 2360252 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360254 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360256 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360259 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360260 */       // GIR_Coverage, 2175,
     /* 2360260 */       GIR_EraseRootFromParent_Done,
     /* 2360261 */     // Label 33318: @2360261
     /* 2360261 */     GIM_Reject,
     /* 2360262 */   // Label 33316: @2360262
     /* 2360262 */   GIM_Reject,
     /* 2360263 */   // Label 33313: @2360263
     /* 2360263 */   GIM_Try, /*On fail goto*//*Label 33319*/ GIMT_Encode4(2360321),
     /* 2360268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360272 */     GIM_Try, /*On fail goto*//*Label 33320*/ GIMT_Encode4(2360296), // Rule ID 1415 //
     /* 2360277 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2360280 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2360284 */       // (llround:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCVT_L_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2360284 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S),
     /* 2360287 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360289 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360291 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360294 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360295 */       // GIR_Coverage, 1415,
     /* 2360295 */       GIR_EraseRootFromParent_Done,
     /* 2360296 */     // Label 33320: @2360296
     /* 2360296 */     GIM_Try, /*On fail goto*//*Label 33321*/ GIMT_Encode4(2360320), // Rule ID 1443 //
     /* 2360301 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2360304 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2360308 */       // (llround:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCVT_L_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, 4:{ *:[i64] })
     /* 2360308 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_S_INX),
     /* 2360311 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360313 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360315 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360318 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360319 */       // GIR_Coverage, 1443,
     /* 2360319 */       GIR_EraseRootFromParent_Done,
     /* 2360320 */     // Label 33321: @2360320
     /* 2360320 */     GIM_Reject,
     /* 2360321 */   // Label 33319: @2360321
     /* 2360321 */   GIM_Reject,
     /* 2360322 */   // Label 33314: @2360322
     /* 2360322 */   GIM_Try, /*On fail goto*//*Label 33322*/ GIMT_Encode4(2360380),
     /* 2360327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360331 */     GIM_Try, /*On fail goto*//*Label 33323*/ GIMT_Encode4(2360355), // Rule ID 1813 //
     /* 2360336 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2360339 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2360343 */       // (llround:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCVT_L_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2360343 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D),
     /* 2360346 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360348 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360350 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360353 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360354 */       // GIR_Coverage, 1813,
     /* 2360354 */       GIR_EraseRootFromParent_Done,
     /* 2360355 */     // Label 33323: @2360355
     /* 2360355 */     GIM_Try, /*On fail goto*//*Label 33324*/ GIMT_Encode4(2360379), // Rule ID 1841 //
     /* 2360360 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2360363 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360367 */       // (llround:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCVT_L_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, 4:{ *:[i64] })
     /* 2360367 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FCVT_L_D_INX),
     /* 2360370 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360372 */       GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360374 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360377 */       GIR_RootConstrainSelectedInstOperands,
     /* 2360378 */       // GIR_Coverage, 1841,
     /* 2360378 */       GIR_EraseRootFromParent_Done,
     /* 2360379 */     // Label 33324: @2360379
     /* 2360379 */     GIM_Reject,
     /* 2360380 */   // Label 33322: @2360380
     /* 2360380 */   GIM_Reject,
     /* 2360381 */   // Label 33315: @2360381
     /* 2360381 */   GIM_Reject,
     /* 2360382 */ // Label 33311: @2360382
     /* 2360382 */ GIM_Reject,
     /* 2360383 */ // Label 87: @2360383
     /* 2360383 */ GIM_Try, /*On fail goto*//*Label 33325*/ GIMT_Encode4(2360398), // Rule ID 4 //
     /* 2360388 */   // MIs[0] imm20
     /* 2360388 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2360391 */   // (br (bb:{ *:[Other] }):$imm20)  =>  (PseudoBR (bb:{ *:[Other] }):$imm20)
     /* 2360391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoBR),
     /* 2360396 */   GIR_RootConstrainSelectedInstOperands,
     /* 2360397 */   // GIR_Coverage, 4,
     /* 2360397 */   GIR_Done,
     /* 2360398 */ // Label 33325: @2360398
     /* 2360398 */ GIM_Reject,
     /* 2360399 */ // Label 88: @2360399
     /* 2360399 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33350*/ GIMT_Encode4(2362918),
     /* 2360410 */ /*GILLT_s32*//*Label 33326*/ GIMT_Encode4(2360534),
     /* 2360414 */ /*GILLT_s64*//*Label 33327*/ GIMT_Encode4(2360582), GIMT_Encode4(0),
     /* 2360422 */ /*GILLT_nxv1s8*//*Label 33328*/ GIMT_Encode4(2360630),
     /* 2360426 */ /*GILLT_nxv1s16*//*Label 33329*/ GIMT_Encode4(2360734),
     /* 2360430 */ /*GILLT_nxv1s32*//*Label 33330*/ GIMT_Encode4(2360838),
     /* 2360434 */ /*GILLT_nxv1s64*//*Label 33331*/ GIMT_Encode4(2360942), GIMT_Encode4(0),
     /* 2360442 */ /*GILLT_nxv2s8*//*Label 33332*/ GIMT_Encode4(2361046),
     /* 2360446 */ /*GILLT_nxv2s16*//*Label 33333*/ GIMT_Encode4(2361150),
     /* 2360450 */ /*GILLT_nxv2s32*//*Label 33334*/ GIMT_Encode4(2361254),
     /* 2360454 */ /*GILLT_nxv2s64*//*Label 33335*/ GIMT_Encode4(2361358), GIMT_Encode4(0),
     /* 2360462 */ /*GILLT_nxv4s8*//*Label 33336*/ GIMT_Encode4(2361462),
     /* 2360466 */ /*GILLT_nxv4s16*//*Label 33337*/ GIMT_Encode4(2361566),
     /* 2360470 */ /*GILLT_nxv4s32*//*Label 33338*/ GIMT_Encode4(2361670),
     /* 2360474 */ /*GILLT_nxv4s64*//*Label 33339*/ GIMT_Encode4(2361774), GIMT_Encode4(0),
     /* 2360482 */ /*GILLT_nxv8s8*//*Label 33340*/ GIMT_Encode4(2361878),
     /* 2360486 */ /*GILLT_nxv8s16*//*Label 33341*/ GIMT_Encode4(2361982),
     /* 2360490 */ /*GILLT_nxv8s32*//*Label 33342*/ GIMT_Encode4(2362086),
     /* 2360494 */ /*GILLT_nxv8s64*//*Label 33343*/ GIMT_Encode4(2362190), GIMT_Encode4(0),
     /* 2360502 */ /*GILLT_nxv16s8*//*Label 33344*/ GIMT_Encode4(2362294),
     /* 2360506 */ /*GILLT_nxv16s16*//*Label 33345*/ GIMT_Encode4(2362398),
     /* 2360510 */ /*GILLT_nxv16s32*//*Label 33346*/ GIMT_Encode4(2362502), GIMT_Encode4(0),
     /* 2360518 */ /*GILLT_nxv32s8*//*Label 33347*/ GIMT_Encode4(2362606),
     /* 2360522 */ /*GILLT_nxv32s16*//*Label 33348*/ GIMT_Encode4(2362710), GIMT_Encode4(0),
     /* 2360530 */ /*GILLT_nxv64s8*//*Label 33349*/ GIMT_Encode4(2362814),
     /* 2360534 */ // Label 33326: @2360534
     /* 2360534 */ GIM_Try, /*On fail goto*//*Label 33351*/ GIMT_Encode4(2360581),
     /* 2360539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2360542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360550 */   GIM_Try, /*On fail goto*//*Label 33352*/ GIMT_Encode4(2360565), // Rule ID 2407 //
     /* 2360555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2360558 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CTZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2360558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2360563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360564 */     // GIR_Coverage, 2407,
     /* 2360564 */     GIR_Done,
     /* 2360565 */   // Label 33352: @2360565
     /* 2360565 */   GIM_Try, /*On fail goto*//*Label 33353*/ GIMT_Encode4(2360580), // Rule ID 64412 //
     /* 2360570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2360573 */     // (cttz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2360573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2360578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360579 */     // GIR_Coverage, 64412,
     /* 2360579 */     GIR_Done,
     /* 2360580 */   // Label 33353: @2360580
     /* 2360580 */   GIM_Reject,
     /* 2360581 */ // Label 33351: @2360581
     /* 2360581 */ GIM_Reject,
     /* 2360582 */ // Label 33327: @2360582
     /* 2360582 */ GIM_Try, /*On fail goto*//*Label 33354*/ GIMT_Encode4(2360629),
     /* 2360587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2360590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2360598 */   GIM_Try, /*On fail goto*//*Label 33355*/ GIMT_Encode4(2360613), // Rule ID 2406 //
     /* 2360603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2360606 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2360606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZ),
     /* 2360611 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360612 */     // GIR_Coverage, 2406,
     /* 2360612 */     GIR_Done,
     /* 2360613 */   // Label 33355: @2360613
     /* 2360613 */   GIM_Try, /*On fail goto*//*Label 33356*/ GIMT_Encode4(2360628), // Rule ID 64411 //
     /* 2360618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2360621 */     // (cttz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2360621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FF1),
     /* 2360626 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360627 */     // GIR_Coverage, 64411,
     /* 2360627 */     GIR_Done,
     /* 2360628 */   // Label 33356: @2360628
     /* 2360628 */   GIM_Reject,
     /* 2360629 */ // Label 33354: @2360629
     /* 2360629 */ GIM_Reject,
     /* 2360630 */ // Label 33328: @2360630
     /* 2360630 */ GIM_Try, /*On fail goto*//*Label 33357*/ GIMT_Encode4(2360733),
     /* 2360635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2360638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360646 */   GIM_Try, /*On fail goto*//*Label 33358*/ GIMT_Encode4(2360689), // Rule ID 59058 //
     /* 2360651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2360654 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2360657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2360671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360688 */     // GIR_Coverage, 59058,
     /* 2360688 */     GIR_EraseRootFromParent_Done,
     /* 2360689 */   // Label 33358: @2360689
     /* 2360689 */   GIM_Try, /*On fail goto*//*Label 33359*/ GIMT_Encode4(2360732), // Rule ID 59059 //
     /* 2360694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2360697 */     // (cttz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCTZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2360700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF8),
     /* 2360714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360731 */     // GIR_Coverage, 59059,
     /* 2360731 */     GIR_EraseRootFromParent_Done,
     /* 2360732 */   // Label 33359: @2360732
     /* 2360732 */   GIM_Reject,
     /* 2360733 */ // Label 33357: @2360733
     /* 2360733 */ GIM_Reject,
     /* 2360734 */ // Label 33329: @2360734
     /* 2360734 */ GIM_Try, /*On fail goto*//*Label 33360*/ GIMT_Encode4(2360837),
     /* 2360739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2360742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360750 */   GIM_Try, /*On fail goto*//*Label 33361*/ GIMT_Encode4(2360793), // Rule ID 59064 //
     /* 2360755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2360758 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360770 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2360775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360780 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360791 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360792 */     // GIR_Coverage, 59064,
     /* 2360792 */     GIR_EraseRootFromParent_Done,
     /* 2360793 */   // Label 33361: @2360793
     /* 2360793 */   GIM_Try, /*On fail goto*//*Label 33362*/ GIMT_Encode4(2360836), // Rule ID 59065 //
     /* 2360798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2360801 */     // (cttz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2360804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2360818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2360831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360835 */     // GIR_Coverage, 59065,
     /* 2360835 */     GIR_EraseRootFromParent_Done,
     /* 2360836 */   // Label 33362: @2360836
     /* 2360836 */   GIM_Reject,
     /* 2360837 */ // Label 33360: @2360837
     /* 2360837 */ GIM_Reject,
     /* 2360838 */ // Label 33330: @2360838
     /* 2360838 */ GIM_Try, /*On fail goto*//*Label 33363*/ GIMT_Encode4(2360941),
     /* 2360843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2360846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360854 */   GIM_Try, /*On fail goto*//*Label 33364*/ GIMT_Encode4(2360897), // Rule ID 59068 //
     /* 2360859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2360862 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2360879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360884 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360896 */     // GIR_Coverage, 59068,
     /* 2360896 */     GIR_EraseRootFromParent_Done,
     /* 2360897 */   // Label 33364: @2360897
     /* 2360897 */   GIM_Try, /*On fail goto*//*Label 33365*/ GIMT_Encode4(2360940), // Rule ID 59069 //
     /* 2360902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2360905 */     // (cttz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2360905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2360908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2360922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2360935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2360939 */     // GIR_Coverage, 59069,
     /* 2360939 */     GIR_EraseRootFromParent_Done,
     /* 2360940 */   // Label 33365: @2360940
     /* 2360940 */   GIM_Reject,
     /* 2360941 */ // Label 33363: @2360941
     /* 2360941 */ GIM_Reject,
     /* 2360942 */ // Label 33331: @2360942
     /* 2360942 */ GIM_Try, /*On fail goto*//*Label 33366*/ GIMT_Encode4(2361045),
     /* 2360947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2360950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2360958 */   GIM_Try, /*On fail goto*//*Label 33367*/ GIMT_Encode4(2361001), // Rule ID 59076 //
     /* 2360963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2360966 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2360966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2360969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2360973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2360978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2360980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2360983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2360985 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2360988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2360990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2360993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2360996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2360999 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361000 */     // GIR_Coverage, 59076,
     /* 2361000 */     GIR_EraseRootFromParent_Done,
     /* 2361001 */   // Label 33367: @2361001
     /* 2361001 */   GIM_Try, /*On fail goto*//*Label 33368*/ GIMT_Encode4(2361044), // Rule ID 59077 //
     /* 2361006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2361009 */     // (cttz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2361012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361043 */     // GIR_Coverage, 59077,
     /* 2361043 */     GIR_EraseRootFromParent_Done,
     /* 2361044 */   // Label 33368: @2361044
     /* 2361044 */   GIM_Reject,
     /* 2361045 */ // Label 33366: @2361045
     /* 2361045 */ GIM_Reject,
     /* 2361046 */ // Label 33332: @2361046
     /* 2361046 */ GIM_Try, /*On fail goto*//*Label 33369*/ GIMT_Encode4(2361149),
     /* 2361051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2361054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361062 */   GIM_Try, /*On fail goto*//*Label 33370*/ GIMT_Encode4(2361105), // Rule ID 59060 //
     /* 2361067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361070 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361070 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2361073 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361077 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2361087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361092 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361104 */     // GIR_Coverage, 59060,
     /* 2361104 */     GIR_EraseRootFromParent_Done,
     /* 2361105 */   // Label 33370: @2361105
     /* 2361105 */   GIM_Try, /*On fail goto*//*Label 33371*/ GIMT_Encode4(2361148), // Rule ID 59061 //
     /* 2361110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361113 */     // (cttz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCTZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2361116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF4),
     /* 2361130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361147 */     // GIR_Coverage, 59061,
     /* 2361147 */     GIR_EraseRootFromParent_Done,
     /* 2361148 */   // Label 33371: @2361148
     /* 2361148 */   GIM_Reject,
     /* 2361149 */ // Label 33369: @2361149
     /* 2361149 */ GIM_Reject,
     /* 2361150 */ // Label 33333: @2361150
     /* 2361150 */ GIM_Try, /*On fail goto*//*Label 33372*/ GIMT_Encode4(2361253),
     /* 2361155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2361158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361166 */   GIM_Try, /*On fail goto*//*Label 33373*/ GIMT_Encode4(2361209), // Rule ID 59066 //
     /* 2361171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361174 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361174 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361177 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361181 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2361191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361196 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361208 */     // GIR_Coverage, 59066,
     /* 2361208 */     GIR_EraseRootFromParent_Done,
     /* 2361209 */   // Label 33373: @2361209
     /* 2361209 */   GIM_Try, /*On fail goto*//*Label 33374*/ GIMT_Encode4(2361252), // Rule ID 59067 //
     /* 2361214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361217 */     // (cttz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2361220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361229 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2361234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361239 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361251 */     // GIR_Coverage, 59067,
     /* 2361251 */     GIR_EraseRootFromParent_Done,
     /* 2361252 */   // Label 33374: @2361252
     /* 2361252 */   GIM_Reject,
     /* 2361253 */ // Label 33372: @2361253
     /* 2361253 */ GIM_Reject,
     /* 2361254 */ // Label 33334: @2361254
     /* 2361254 */ GIM_Try, /*On fail goto*//*Label 33375*/ GIMT_Encode4(2361357),
     /* 2361259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2361262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361266 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361270 */   GIM_Try, /*On fail goto*//*Label 33376*/ GIMT_Encode4(2361313), // Rule ID 59074 //
     /* 2361275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361278 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2361281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361290 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361311 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361312 */     // GIR_Coverage, 59074,
     /* 2361312 */     GIR_EraseRootFromParent_Done,
     /* 2361313 */   // Label 33376: @2361313
     /* 2361313 */   GIM_Try, /*On fail goto*//*Label 33377*/ GIMT_Encode4(2361356), // Rule ID 59075 //
     /* 2361318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361321 */     // (cttz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2361324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361355 */     // GIR_Coverage, 59075,
     /* 2361355 */     GIR_EraseRootFromParent_Done,
     /* 2361356 */   // Label 33377: @2361356
     /* 2361356 */   GIM_Reject,
     /* 2361357 */ // Label 33375: @2361357
     /* 2361357 */ GIM_Reject,
     /* 2361358 */ // Label 33335: @2361358
     /* 2361358 */ GIM_Try, /*On fail goto*//*Label 33378*/ GIMT_Encode4(2361461),
     /* 2361363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2361366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361374 */   GIM_Try, /*On fail goto*//*Label 33379*/ GIMT_Encode4(2361417), // Rule ID 59096 //
     /* 2361379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2361382 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2361385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361394 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2361399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361415 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361416 */     // GIR_Coverage, 59096,
     /* 2361416 */     GIR_EraseRootFromParent_Done,
     /* 2361417 */   // Label 33379: @2361417
     /* 2361417 */   GIM_Try, /*On fail goto*//*Label 33380*/ GIMT_Encode4(2361460), // Rule ID 59097 //
     /* 2361422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2361425 */     // (cttz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2361428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2361442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361459 */     // GIR_Coverage, 59097,
     /* 2361459 */     GIR_EraseRootFromParent_Done,
     /* 2361460 */   // Label 33380: @2361460
     /* 2361460 */   GIM_Reject,
     /* 2361461 */ // Label 33378: @2361461
     /* 2361461 */ GIM_Reject,
     /* 2361462 */ // Label 33336: @2361462
     /* 2361462 */ GIM_Try, /*On fail goto*//*Label 33381*/ GIMT_Encode4(2361565),
     /* 2361467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2361470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361478 */   GIM_Try, /*On fail goto*//*Label 33382*/ GIMT_Encode4(2361521), // Rule ID 59062 //
     /* 2361483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361486 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2361489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2361503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361519 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361520 */     // GIR_Coverage, 59062,
     /* 2361520 */     GIR_EraseRootFromParent_Done,
     /* 2361521 */   // Label 33382: @2361521
     /* 2361521 */   GIM_Try, /*On fail goto*//*Label 33383*/ GIMT_Encode4(2361564), // Rule ID 59063 //
     /* 2361526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361529 */     // (cttz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCTZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2361532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_MF2),
     /* 2361546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361563 */     // GIR_Coverage, 59063,
     /* 2361563 */     GIR_EraseRootFromParent_Done,
     /* 2361564 */   // Label 33383: @2361564
     /* 2361564 */   GIM_Reject,
     /* 2361565 */ // Label 33381: @2361565
     /* 2361565 */ GIM_Reject,
     /* 2361566 */ // Label 33337: @2361566
     /* 2361566 */ GIM_Try, /*On fail goto*//*Label 33384*/ GIMT_Encode4(2361669),
     /* 2361571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2361574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361582 */   GIM_Try, /*On fail goto*//*Label 33385*/ GIMT_Encode4(2361625), // Rule ID 59072 //
     /* 2361587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361590 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361590 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2361593 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361597 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361612 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361623 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361624 */     // GIR_Coverage, 59072,
     /* 2361624 */     GIR_EraseRootFromParent_Done,
     /* 2361625 */   // Label 33385: @2361625
     /* 2361625 */   GIM_Try, /*On fail goto*//*Label 33386*/ GIMT_Encode4(2361668), // Rule ID 59073 //
     /* 2361630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361633 */     // (cttz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2361636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361645 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361655 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2361663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361667 */     // GIR_Coverage, 59073,
     /* 2361667 */     GIR_EraseRootFromParent_Done,
     /* 2361668 */   // Label 33386: @2361668
     /* 2361668 */   GIM_Reject,
     /* 2361669 */ // Label 33384: @2361669
     /* 2361669 */ GIM_Reject,
     /* 2361670 */ // Label 33338: @2361670
     /* 2361670 */ GIM_Try, /*On fail goto*//*Label 33387*/ GIMT_Encode4(2361773),
     /* 2361675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2361678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361686 */   GIM_Try, /*On fail goto*//*Label 33388*/ GIMT_Encode4(2361729), // Rule ID 59090 //
     /* 2361691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361694 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2361697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2361711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361716 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361728 */     // GIR_Coverage, 59090,
     /* 2361728 */     GIR_EraseRootFromParent_Done,
     /* 2361729 */   // Label 33388: @2361729
     /* 2361729 */   GIM_Try, /*On fail goto*//*Label 33389*/ GIMT_Encode4(2361772), // Rule ID 59091 //
     /* 2361734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361737 */     // (cttz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2361740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2361754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2361767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361770 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361771 */     // GIR_Coverage, 59091,
     /* 2361771 */     GIR_EraseRootFromParent_Done,
     /* 2361772 */   // Label 33389: @2361772
     /* 2361772 */   GIM_Reject,
     /* 2361773 */ // Label 33387: @2361773
     /* 2361773 */ GIM_Reject,
     /* 2361774 */ // Label 33339: @2361774
     /* 2361774 */ GIM_Try, /*On fail goto*//*Label 33390*/ GIMT_Encode4(2361877),
     /* 2361779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2361782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2361790 */   GIM_Try, /*On fail goto*//*Label 33391*/ GIMT_Encode4(2361833), // Rule ID 59098 //
     /* 2361795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2361798 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2361801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361810 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2361815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361832 */     // GIR_Coverage, 59098,
     /* 2361832 */     GIR_EraseRootFromParent_Done,
     /* 2361833 */   // Label 33391: @2361833
     /* 2361833 */   GIM_Try, /*On fail goto*//*Label 33392*/ GIMT_Encode4(2361876), // Rule ID 59099 //
     /* 2361838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2361841 */     // (cttz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2361844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2361858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361863 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2361871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361874 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361875 */     // GIR_Coverage, 59099,
     /* 2361875 */     GIR_EraseRootFromParent_Done,
     /* 2361876 */   // Label 33392: @2361876
     /* 2361876 */   GIM_Reject,
     /* 2361877 */ // Label 33390: @2361877
     /* 2361877 */ GIM_Reject,
     /* 2361878 */ // Label 33340: @2361878
     /* 2361878 */ GIM_Try, /*On fail goto*//*Label 33393*/ GIMT_Encode4(2361981),
     /* 2361883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2361886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2361894 */   GIM_Try, /*On fail goto*//*Label 33394*/ GIMT_Encode4(2361937), // Rule ID 59070 //
     /* 2361899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2361902 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2361902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2361905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361935 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361936 */     // GIR_Coverage, 59070,
     /* 2361936 */     GIR_EraseRootFromParent_Done,
     /* 2361937 */   // Label 33394: @2361937
     /* 2361937 */   GIM_Try, /*On fail goto*//*Label 33395*/ GIMT_Encode4(2361980), // Rule ID 59071 //
     /* 2361942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2361945 */     // (cttz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCTZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2361945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2361948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2361952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2361957 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2361959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M1),
     /* 2361962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2361964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2361967 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2361969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2361972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2361978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2361979 */     // GIR_Coverage, 59071,
     /* 2361979 */     GIR_EraseRootFromParent_Done,
     /* 2361980 */   // Label 33395: @2361980
     /* 2361980 */   GIM_Reject,
     /* 2361981 */ // Label 33393: @2361981
     /* 2361981 */ GIM_Reject,
     /* 2361982 */ // Label 33341: @2361982
     /* 2361982 */ GIM_Try, /*On fail goto*//*Label 33396*/ GIMT_Encode4(2362085),
     /* 2361987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2361990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2361998 */   GIM_Try, /*On fail goto*//*Label 33397*/ GIMT_Encode4(2362041), // Rule ID 59084 //
     /* 2362003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362006 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362006 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362009 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362013 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2362023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362028 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362040 */     // GIR_Coverage, 59084,
     /* 2362040 */     GIR_EraseRootFromParent_Done,
     /* 2362041 */   // Label 33397: @2362041
     /* 2362041 */   GIM_Try, /*On fail goto*//*Label 33398*/ GIMT_Encode4(2362084), // Rule ID 59085 //
     /* 2362046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362049 */     // (cttz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2362052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2362066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362082 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362083 */     // GIR_Coverage, 59085,
     /* 2362083 */     GIR_EraseRootFromParent_Done,
     /* 2362084 */   // Label 33398: @2362084
     /* 2362084 */   GIM_Reject,
     /* 2362085 */ // Label 33396: @2362085
     /* 2362085 */ GIM_Reject,
     /* 2362086 */ // Label 33342: @2362086
     /* 2362086 */ GIM_Try, /*On fail goto*//*Label 33399*/ GIMT_Encode4(2362189),
     /* 2362091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2362094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362102 */   GIM_Try, /*On fail goto*//*Label 33400*/ GIMT_Encode4(2362145), // Rule ID 59092 //
     /* 2362107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362110 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362129 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362143 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362144 */     // GIR_Coverage, 59092,
     /* 2362144 */     GIR_EraseRootFromParent_Done,
     /* 2362145 */   // Label 33400: @2362145
     /* 2362145 */   GIM_Try, /*On fail goto*//*Label 33401*/ GIMT_Encode4(2362188), // Rule ID 59093 //
     /* 2362150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362153 */     // (cttz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2362156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362175 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362186 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362187 */     // GIR_Coverage, 59093,
     /* 2362187 */     GIR_EraseRootFromParent_Done,
     /* 2362188 */   // Label 33401: @2362188
     /* 2362188 */   GIM_Reject,
     /* 2362189 */ // Label 33399: @2362189
     /* 2362189 */ GIM_Reject,
     /* 2362190 */ // Label 33343: @2362190
     /* 2362190 */ GIM_Try, /*On fail goto*//*Label 33402*/ GIMT_Encode4(2362293),
     /* 2362195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2362198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362206 */   GIM_Try, /*On fail goto*//*Label 33403*/ GIMT_Encode4(2362249), // Rule ID 59100 //
     /* 2362211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2362214 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362214 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362217 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362221 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362226 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362236 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362247 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362248 */     // GIR_Coverage, 59100,
     /* 2362248 */     GIR_EraseRootFromParent_Done,
     /* 2362249 */   // Label 33403: @2362249
     /* 2362249 */   GIM_Try, /*On fail goto*//*Label 33404*/ GIMT_Encode4(2362292), // Rule ID 59101 //
     /* 2362254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2362257 */     // (cttz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2362260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362279 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2362287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362291 */     // GIR_Coverage, 59101,
     /* 2362291 */     GIR_EraseRootFromParent_Done,
     /* 2362292 */   // Label 33404: @2362292
     /* 2362292 */   GIM_Reject,
     /* 2362293 */ // Label 33402: @2362293
     /* 2362293 */ GIM_Reject,
     /* 2362294 */ // Label 33344: @2362294
     /* 2362294 */ GIM_Try, /*On fail goto*//*Label 33405*/ GIMT_Encode4(2362397),
     /* 2362299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2362302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2362310 */   GIM_Try, /*On fail goto*//*Label 33406*/ GIMT_Encode4(2362353), // Rule ID 59078 //
     /* 2362315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362318 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2362321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2362335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362351 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362352 */     // GIR_Coverage, 59078,
     /* 2362352 */     GIR_EraseRootFromParent_Done,
     /* 2362353 */   // Label 33406: @2362353
     /* 2362353 */   GIM_Try, /*On fail goto*//*Label 33407*/ GIMT_Encode4(2362396), // Rule ID 59079 //
     /* 2362358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362361 */     // (cttz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCTZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2362364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M2),
     /* 2362378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362394 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362395 */     // GIR_Coverage, 59079,
     /* 2362395 */     GIR_EraseRootFromParent_Done,
     /* 2362396 */   // Label 33407: @2362396
     /* 2362396 */   GIM_Reject,
     /* 2362397 */ // Label 33405: @2362397
     /* 2362397 */ GIM_Reject,
     /* 2362398 */ // Label 33345: @2362398
     /* 2362398 */ GIM_Try, /*On fail goto*//*Label 33408*/ GIMT_Encode4(2362501),
     /* 2362403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2362406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362414 */   GIM_Try, /*On fail goto*//*Label 33409*/ GIMT_Encode4(2362457), // Rule ID 59086 //
     /* 2362419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362422 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362444 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362455 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362456 */     // GIR_Coverage, 59086,
     /* 2362456 */     GIR_EraseRootFromParent_Done,
     /* 2362457 */   // Label 33409: @2362457
     /* 2362457 */   GIM_Try, /*On fail goto*//*Label 33410*/ GIMT_Encode4(2362500), // Rule ID 59087 //
     /* 2362462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362465 */     // (cttz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362465 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2362468 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362472 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362487 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362499 */     // GIR_Coverage, 59087,
     /* 2362499 */     GIR_EraseRootFromParent_Done,
     /* 2362500 */   // Label 33410: @2362500
     /* 2362500 */   GIM_Reject,
     /* 2362501 */ // Label 33408: @2362501
     /* 2362501 */ GIM_Reject,
     /* 2362502 */ // Label 33346: @2362502
     /* 2362502 */ GIM_Try, /*On fail goto*//*Label 33411*/ GIMT_Encode4(2362605),
     /* 2362507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2362510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362514 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362518 */   GIM_Try, /*On fail goto*//*Label 33412*/ GIMT_Encode4(2362561), // Rule ID 59094 //
     /* 2362523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362526 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2362529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362538 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362560 */     // GIR_Coverage, 59094,
     /* 2362560 */     GIR_EraseRootFromParent_Done,
     /* 2362561 */   // Label 33412: @2362561
     /* 2362561 */   GIM_Try, /*On fail goto*//*Label 33413*/ GIMT_Encode4(2362604), // Rule ID 59095 //
     /* 2362566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362569 */     // (cttz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2362572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2362599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362602 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362603 */     // GIR_Coverage, 59095,
     /* 2362603 */     GIR_EraseRootFromParent_Done,
     /* 2362604 */   // Label 33413: @2362604
     /* 2362604 */   GIM_Reject,
     /* 2362605 */ // Label 33411: @2362605
     /* 2362605 */ GIM_Reject,
     /* 2362606 */ // Label 33347: @2362606
     /* 2362606 */ GIM_Try, /*On fail goto*//*Label 33414*/ GIMT_Encode4(2362709),
     /* 2362611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2362614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2362622 */   GIM_Try, /*On fail goto*//*Label 33415*/ GIMT_Encode4(2362665), // Rule ID 59080 //
     /* 2362627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362630 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362630 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2362633 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362637 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362649 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362652 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362664 */     // GIR_Coverage, 59080,
     /* 2362664 */     GIR_EraseRootFromParent_Done,
     /* 2362665 */   // Label 33415: @2362665
     /* 2362665 */   GIM_Try, /*On fail goto*//*Label 33416*/ GIMT_Encode4(2362708), // Rule ID 59081 //
     /* 2362670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362673 */     // (cttz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCTZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2362676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M4),
     /* 2362690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362706 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362707 */     // GIR_Coverage, 59081,
     /* 2362707 */     GIR_EraseRootFromParent_Done,
     /* 2362708 */   // Label 33416: @2362708
     /* 2362708 */   GIM_Reject,
     /* 2362709 */ // Label 33414: @2362709
     /* 2362709 */ GIM_Reject,
     /* 2362710 */ // Label 33348: @2362710
     /* 2362710 */ GIM_Try, /*On fail goto*//*Label 33417*/ GIMT_Encode4(2362813),
     /* 2362715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2362718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362726 */   GIM_Try, /*On fail goto*//*Label 33418*/ GIMT_Encode4(2362769), // Rule ID 59088 //
     /* 2362731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362734 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362734 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2362737 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362741 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362767 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362768 */     // GIR_Coverage, 59088,
     /* 2362768 */     GIR_EraseRootFromParent_Done,
     /* 2362769 */   // Label 33418: @2362769
     /* 2362769 */   GIM_Try, /*On fail goto*//*Label 33419*/ GIMT_Encode4(2362812), // Rule ID 59089 //
     /* 2362774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362777 */     // (cttz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362777 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2362780 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362784 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2362807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362810 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362811 */     // GIR_Coverage, 59089,
     /* 2362811 */     GIR_EraseRootFromParent_Done,
     /* 2362812 */   // Label 33419: @2362812
     /* 2362812 */   GIM_Reject,
     /* 2362813 */ // Label 33417: @2362813
     /* 2362813 */ GIM_Reject,
     /* 2362814 */ // Label 33349: @2362814
     /* 2362814 */ GIM_Try, /*On fail goto*//*Label 33420*/ GIMT_Encode4(2362917),
     /* 2362819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2362822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2362830 */   GIM_Try, /*On fail goto*//*Label 33421*/ GIMT_Encode4(2362873), // Rule ID 59082 //
     /* 2362835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2362838 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2362838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2362841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362860 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362872 */     // GIR_Coverage, 59082,
     /* 2362872 */     GIR_EraseRootFromParent_Done,
     /* 2362873 */   // Label 33421: @2362873
     /* 2362873 */   GIM_Try, /*On fail goto*//*Label 33422*/ GIMT_Encode4(2362916), // Rule ID 59083 //
     /* 2362878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2362881 */     // (cttz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCTZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2362881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2362884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2362888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2362893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2362895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCTZ_V_M8),
     /* 2362898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2362900 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2362903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2362905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2362908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2362914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2362915 */     // GIR_Coverage, 59083,
     /* 2362915 */     GIR_EraseRootFromParent_Done,
     /* 2362916 */   // Label 33422: @2362916
     /* 2362916 */   GIM_Reject,
     /* 2362917 */ // Label 33420: @2362917
     /* 2362917 */ GIM_Reject,
     /* 2362918 */ // Label 33350: @2362918
     /* 2362918 */ GIM_Reject,
     /* 2362919 */ // Label 89: @2362919
     /* 2362919 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33447*/ GIMT_Encode4(2365576),
     /* 2362930 */ /*GILLT_s32*//*Label 33423*/ GIMT_Encode4(2363054),
     /* 2362934 */ /*GILLT_s64*//*Label 33424*/ GIMT_Encode4(2363171), GIMT_Encode4(0),
     /* 2362942 */ /*GILLT_nxv1s8*//*Label 33425*/ GIMT_Encode4(2363288),
     /* 2362946 */ /*GILLT_nxv1s16*//*Label 33426*/ GIMT_Encode4(2363392),
     /* 2362950 */ /*GILLT_nxv1s32*//*Label 33427*/ GIMT_Encode4(2363496),
     /* 2362954 */ /*GILLT_nxv1s64*//*Label 33428*/ GIMT_Encode4(2363600), GIMT_Encode4(0),
     /* 2362962 */ /*GILLT_nxv2s8*//*Label 33429*/ GIMT_Encode4(2363704),
     /* 2362966 */ /*GILLT_nxv2s16*//*Label 33430*/ GIMT_Encode4(2363808),
     /* 2362970 */ /*GILLT_nxv2s32*//*Label 33431*/ GIMT_Encode4(2363912),
     /* 2362974 */ /*GILLT_nxv2s64*//*Label 33432*/ GIMT_Encode4(2364016), GIMT_Encode4(0),
     /* 2362982 */ /*GILLT_nxv4s8*//*Label 33433*/ GIMT_Encode4(2364120),
     /* 2362986 */ /*GILLT_nxv4s16*//*Label 33434*/ GIMT_Encode4(2364224),
     /* 2362990 */ /*GILLT_nxv4s32*//*Label 33435*/ GIMT_Encode4(2364328),
     /* 2362994 */ /*GILLT_nxv4s64*//*Label 33436*/ GIMT_Encode4(2364432), GIMT_Encode4(0),
     /* 2363002 */ /*GILLT_nxv8s8*//*Label 33437*/ GIMT_Encode4(2364536),
     /* 2363006 */ /*GILLT_nxv8s16*//*Label 33438*/ GIMT_Encode4(2364640),
     /* 2363010 */ /*GILLT_nxv8s32*//*Label 33439*/ GIMT_Encode4(2364744),
     /* 2363014 */ /*GILLT_nxv8s64*//*Label 33440*/ GIMT_Encode4(2364848), GIMT_Encode4(0),
     /* 2363022 */ /*GILLT_nxv16s8*//*Label 33441*/ GIMT_Encode4(2364952),
     /* 2363026 */ /*GILLT_nxv16s16*//*Label 33442*/ GIMT_Encode4(2365056),
     /* 2363030 */ /*GILLT_nxv16s32*//*Label 33443*/ GIMT_Encode4(2365160), GIMT_Encode4(0),
     /* 2363038 */ /*GILLT_nxv32s8*//*Label 33444*/ GIMT_Encode4(2365264),
     /* 2363042 */ /*GILLT_nxv32s16*//*Label 33445*/ GIMT_Encode4(2365368), GIMT_Encode4(0),
     /* 2363050 */ /*GILLT_nxv64s8*//*Label 33446*/ GIMT_Encode4(2365472),
     /* 2363054 */ // Label 33423: @2363054
     /* 2363054 */ GIM_Try, /*On fail goto*//*Label 33448*/ GIMT_Encode4(2363170),
     /* 2363059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363066 */   GIM_Try, /*On fail goto*//*Label 33449*/ GIMT_Encode4(2363112), // Rule ID 62537 //
     /* 2363071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2363074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2363078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2363082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2363086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 2363090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2363099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2363101 */     // (ctlz:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$rs1, -1:{ *:[i32] }))  =>  (TH_FF0:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2363101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2363104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2363110 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363111 */     // GIR_Coverage, 62537,
     /* 2363111 */     GIR_EraseRootFromParent_Done,
     /* 2363112 */   // Label 33449: @2363112
     /* 2363112 */   GIM_Try, /*On fail goto*//*Label 33450*/ GIMT_Encode4(2363131), // Rule ID 2405 //
     /* 2363117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2363120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363124 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2363124 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2363129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363130 */     // GIR_Coverage, 2405,
     /* 2363130 */     GIR_Done,
     /* 2363131 */   // Label 33450: @2363131
     /* 2363131 */   GIM_Try, /*On fail goto*//*Label 33451*/ GIMT_Encode4(2363150), // Rule ID 62535 //
     /* 2363136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2363139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363143 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_FF1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2363143 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2363148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363149 */     // GIR_Coverage, 62535,
     /* 2363149 */     GIR_Done,
     /* 2363150 */   // Label 33451: @2363150
     /* 2363150 */   GIM_Try, /*On fail goto*//*Label 33452*/ GIMT_Encode4(2363169), // Rule ID 64414 //
     /* 2363155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2363158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363162 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_FL1:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2363162 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2363167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363168 */     // GIR_Coverage, 64414,
     /* 2363168 */     GIR_Done,
     /* 2363169 */   // Label 33452: @2363169
     /* 2363169 */   GIM_Reject,
     /* 2363170 */ // Label 33448: @2363170
     /* 2363170 */ GIM_Reject,
     /* 2363171 */ // Label 33424: @2363171
     /* 2363171 */ GIM_Try, /*On fail goto*//*Label 33453*/ GIMT_Encode4(2363287),
     /* 2363176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363183 */   GIM_Try, /*On fail goto*//*Label 33454*/ GIMT_Encode4(2363229), // Rule ID 62536 //
     /* 2363188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2363191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2363195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 2363199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2363203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 2363207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363212 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /* 2363216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2363218 */     // (ctlz:{ *:[i64] } (xor:{ *:[i64] } GPR:{ *:[i64] }:$rs1, -1:{ *:[i64] }))  =>  (TH_FF0:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2363218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2363221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2363227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363228 */     // GIR_Coverage, 62536,
     /* 2363228 */     GIR_EraseRootFromParent_Done,
     /* 2363229 */   // Label 33454: @2363229
     /* 2363229 */   GIM_Try, /*On fail goto*//*Label 33455*/ GIMT_Encode4(2363248), // Rule ID 2404 //
     /* 2363234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2363237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363241 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZ:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2363241 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZ),
     /* 2363246 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363247 */     // GIR_Coverage, 2404,
     /* 2363247 */     GIR_Done,
     /* 2363248 */   // Label 33455: @2363248
     /* 2363248 */   GIM_Try, /*On fail goto*//*Label 33456*/ GIMT_Encode4(2363267), // Rule ID 62534 //
     /* 2363253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2363256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363260 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_FF1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2363260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_FF1),
     /* 2363265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363266 */     // GIR_Coverage, 62534,
     /* 2363266 */     GIR_Done,
     /* 2363267 */   // Label 33456: @2363267
     /* 2363267 */   GIM_Try, /*On fail goto*//*Label 33457*/ GIMT_Encode4(2363286), // Rule ID 64413 //
     /* 2363272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2363275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2363279 */     // (ctlz:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_FL1:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2363279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_FL1),
     /* 2363284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363285 */     // GIR_Coverage, 64413,
     /* 2363285 */     GIR_Done,
     /* 2363286 */   // Label 33457: @2363286
     /* 2363286 */   GIM_Reject,
     /* 2363287 */ // Label 33453: @2363287
     /* 2363287 */ GIM_Reject,
     /* 2363288 */ // Label 33425: @2363288
     /* 2363288 */ GIM_Try, /*On fail goto*//*Label 33458*/ GIMT_Encode4(2363391),
     /* 2363293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2363296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363304 */   GIM_Try, /*On fail goto*//*Label 33459*/ GIMT_Encode4(2363347), // Rule ID 59014 //
     /* 2363309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363312 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2363315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2363329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363331 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363334 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363346 */     // GIR_Coverage, 59014,
     /* 2363346 */     GIR_EraseRootFromParent_Done,
     /* 2363347 */   // Label 33459: @2363347
     /* 2363347 */   GIM_Try, /*On fail goto*//*Label 33460*/ GIMT_Encode4(2363390), // Rule ID 59015 //
     /* 2363352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363355 */     // (ctlz:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCLZ_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363355 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2363358 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363362 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363367 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF8),
     /* 2363372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363389 */     // GIR_Coverage, 59015,
     /* 2363389 */     GIR_EraseRootFromParent_Done,
     /* 2363390 */   // Label 33460: @2363390
     /* 2363390 */   GIM_Reject,
     /* 2363391 */ // Label 33458: @2363391
     /* 2363391 */ GIM_Reject,
     /* 2363392 */ // Label 33426: @2363392
     /* 2363392 */ GIM_Try, /*On fail goto*//*Label 33461*/ GIMT_Encode4(2363495),
     /* 2363397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2363400 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363404 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363408 */   GIM_Try, /*On fail goto*//*Label 33462*/ GIMT_Encode4(2363451), // Rule ID 59020 //
     /* 2363413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363416 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363428 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2363433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363438 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363450 */     // GIR_Coverage, 59020,
     /* 2363450 */     GIR_EraseRootFromParent_Done,
     /* 2363451 */   // Label 33462: @2363451
     /* 2363451 */   GIM_Try, /*On fail goto*//*Label 33463*/ GIMT_Encode4(2363494), // Rule ID 59021 //
     /* 2363456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363459 */     // (ctlz:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363459 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2363462 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363466 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2363476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363481 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363493 */     // GIR_Coverage, 59021,
     /* 2363493 */     GIR_EraseRootFromParent_Done,
     /* 2363494 */   // Label 33463: @2363494
     /* 2363494 */   GIM_Reject,
     /* 2363495 */ // Label 33461: @2363495
     /* 2363495 */ GIM_Reject,
     /* 2363496 */ // Label 33427: @2363496
     /* 2363496 */ GIM_Try, /*On fail goto*//*Label 33464*/ GIMT_Encode4(2363599),
     /* 2363501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2363504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363512 */   GIM_Try, /*On fail goto*//*Label 33465*/ GIMT_Encode4(2363555), // Rule ID 59024 //
     /* 2363517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363520 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2363537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363542 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363554 */     // GIR_Coverage, 59024,
     /* 2363554 */     GIR_EraseRootFromParent_Done,
     /* 2363555 */   // Label 33465: @2363555
     /* 2363555 */   GIM_Try, /*On fail goto*//*Label 33466*/ GIMT_Encode4(2363598), // Rule ID 59025 //
     /* 2363560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363563 */     // (ctlz:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2363566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2363580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363582 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363585 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363596 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363597 */     // GIR_Coverage, 59025,
     /* 2363597 */     GIR_EraseRootFromParent_Done,
     /* 2363598 */   // Label 33466: @2363598
     /* 2363598 */   GIM_Reject,
     /* 2363599 */ // Label 33464: @2363599
     /* 2363599 */ GIM_Reject,
     /* 2363600 */ // Label 33428: @2363600
     /* 2363600 */ GIM_Try, /*On fail goto*//*Label 33467*/ GIMT_Encode4(2363703),
     /* 2363605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2363608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363616 */   GIM_Try, /*On fail goto*//*Label 33468*/ GIMT_Encode4(2363659), // Rule ID 59032 //
     /* 2363621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2363624 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2363641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363658 */     // GIR_Coverage, 59032,
     /* 2363658 */     GIR_EraseRootFromParent_Done,
     /* 2363659 */   // Label 33468: @2363659
     /* 2363659 */   GIM_Try, /*On fail goto*//*Label 33469*/ GIMT_Encode4(2363702), // Rule ID 59033 //
     /* 2363664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2363667 */     // (ctlz:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2363670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2363684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363689 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2363697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363700 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363701 */     // GIR_Coverage, 59033,
     /* 2363701 */     GIR_EraseRootFromParent_Done,
     /* 2363702 */   // Label 33469: @2363702
     /* 2363702 */   GIM_Reject,
     /* 2363703 */ // Label 33467: @2363703
     /* 2363703 */ GIM_Reject,
     /* 2363704 */ // Label 33429: @2363704
     /* 2363704 */ GIM_Try, /*On fail goto*//*Label 33470*/ GIMT_Encode4(2363807),
     /* 2363709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2363712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363720 */   GIM_Try, /*On fail goto*//*Label 33471*/ GIMT_Encode4(2363763), // Rule ID 59016 //
     /* 2363725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363728 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2363731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2363745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363762 */     // GIR_Coverage, 59016,
     /* 2363762 */     GIR_EraseRootFromParent_Done,
     /* 2363763 */   // Label 33471: @2363763
     /* 2363763 */   GIM_Try, /*On fail goto*//*Label 33472*/ GIMT_Encode4(2363806), // Rule ID 59017 //
     /* 2363768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363771 */     // (ctlz:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCLZ_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2363774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF4),
     /* 2363788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363805 */     // GIR_Coverage, 59017,
     /* 2363805 */     GIR_EraseRootFromParent_Done,
     /* 2363806 */   // Label 33472: @2363806
     /* 2363806 */   GIM_Reject,
     /* 2363807 */ // Label 33470: @2363807
     /* 2363807 */ GIM_Reject,
     /* 2363808 */ // Label 33430: @2363808
     /* 2363808 */ GIM_Try, /*On fail goto*//*Label 33473*/ GIMT_Encode4(2363911),
     /* 2363813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2363816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363824 */   GIM_Try, /*On fail goto*//*Label 33474*/ GIMT_Encode4(2363867), // Rule ID 59022 //
     /* 2363829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363832 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2363835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2363849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363854 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363866 */     // GIR_Coverage, 59022,
     /* 2363866 */     GIR_EraseRootFromParent_Done,
     /* 2363867 */   // Label 33474: @2363867
     /* 2363867 */   GIM_Try, /*On fail goto*//*Label 33475*/ GIMT_Encode4(2363910), // Rule ID 59023 //
     /* 2363872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363875 */     // (ctlz:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2363878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2363892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363894 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2363905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363908 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363909 */     // GIR_Coverage, 59023,
     /* 2363909 */     GIR_EraseRootFromParent_Done,
     /* 2363910 */   // Label 33475: @2363910
     /* 2363910 */   GIM_Reject,
     /* 2363911 */ // Label 33473: @2363911
     /* 2363911 */ GIM_Reject,
     /* 2363912 */ // Label 33431: @2363912
     /* 2363912 */ GIM_Try, /*On fail goto*//*Label 33476*/ GIMT_Encode4(2364015),
     /* 2363917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2363920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2363928 */   GIM_Try, /*On fail goto*//*Label 33477*/ GIMT_Encode4(2363971), // Rule ID 59030 //
     /* 2363933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2363936 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2363936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2363939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2363953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2363958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2363960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2363963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2363966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2363969 */     GIR_RootConstrainSelectedInstOperands,
     /* 2363970 */     // GIR_Coverage, 59030,
     /* 2363970 */     GIR_EraseRootFromParent_Done,
     /* 2363971 */   // Label 33477: @2363971
     /* 2363971 */   GIM_Try, /*On fail goto*//*Label 33478*/ GIMT_Encode4(2364014), // Rule ID 59031 //
     /* 2363976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2363979 */     // (ctlz:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2363979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2363982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2363986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2363991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2363993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2363996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2363998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364001 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364013 */     // GIR_Coverage, 59031,
     /* 2364013 */     GIR_EraseRootFromParent_Done,
     /* 2364014 */   // Label 33478: @2364014
     /* 2364014 */   GIM_Reject,
     /* 2364015 */ // Label 33476: @2364015
     /* 2364015 */ GIM_Reject,
     /* 2364016 */ // Label 33432: @2364016
     /* 2364016 */ GIM_Try, /*On fail goto*//*Label 33479*/ GIMT_Encode4(2364119),
     /* 2364021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2364024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364032 */   GIM_Try, /*On fail goto*//*Label 33480*/ GIMT_Encode4(2364075), // Rule ID 59052 //
     /* 2364037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2364040 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364062 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364074 */     // GIR_Coverage, 59052,
     /* 2364074 */     GIR_EraseRootFromParent_Done,
     /* 2364075 */   // Label 33480: @2364075
     /* 2364075 */   GIM_Try, /*On fail goto*//*Label 33481*/ GIMT_Encode4(2364118), // Rule ID 59053 //
     /* 2364080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2364083 */     // (ctlz:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364083 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2364086 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364090 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364095 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364117 */     // GIR_Coverage, 59053,
     /* 2364117 */     GIR_EraseRootFromParent_Done,
     /* 2364118 */   // Label 33481: @2364118
     /* 2364118 */   GIM_Reject,
     /* 2364119 */ // Label 33479: @2364119
     /* 2364119 */ GIM_Reject,
     /* 2364120 */ // Label 33433: @2364120
     /* 2364120 */ GIM_Try, /*On fail goto*//*Label 33482*/ GIMT_Encode4(2364223),
     /* 2364125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2364128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364136 */   GIM_Try, /*On fail goto*//*Label 33483*/ GIMT_Encode4(2364179), // Rule ID 59018 //
     /* 2364141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364144 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2364147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2364161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364166 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364178 */     // GIR_Coverage, 59018,
     /* 2364178 */     GIR_EraseRootFromParent_Done,
     /* 2364179 */   // Label 33483: @2364179
     /* 2364179 */   GIM_Try, /*On fail goto*//*Label 33484*/ GIMT_Encode4(2364222), // Rule ID 59019 //
     /* 2364184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364187 */     // (ctlz:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCLZ_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2364190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_MF2),
     /* 2364204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364221 */     // GIR_Coverage, 59019,
     /* 2364221 */     GIR_EraseRootFromParent_Done,
     /* 2364222 */   // Label 33484: @2364222
     /* 2364222 */   GIM_Reject,
     /* 2364223 */ // Label 33482: @2364223
     /* 2364223 */ GIM_Reject,
     /* 2364224 */ // Label 33434: @2364224
     /* 2364224 */ GIM_Try, /*On fail goto*//*Label 33485*/ GIMT_Encode4(2364327),
     /* 2364229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2364232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364240 */   GIM_Try, /*On fail goto*//*Label 33486*/ GIMT_Encode4(2364283), // Rule ID 59028 //
     /* 2364245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364248 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2364265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364282 */     // GIR_Coverage, 59028,
     /* 2364282 */     GIR_EraseRootFromParent_Done,
     /* 2364283 */   // Label 33486: @2364283
     /* 2364283 */   GIM_Try, /*On fail goto*//*Label 33487*/ GIMT_Encode4(2364326), // Rule ID 59029 //
     /* 2364288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364291 */     // (ctlz:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364291 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2364294 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364298 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2364308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364313 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364324 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364325 */     // GIR_Coverage, 59029,
     /* 2364325 */     GIR_EraseRootFromParent_Done,
     /* 2364326 */   // Label 33487: @2364326
     /* 2364326 */   GIM_Reject,
     /* 2364327 */ // Label 33485: @2364327
     /* 2364327 */ GIM_Reject,
     /* 2364328 */ // Label 33435: @2364328
     /* 2364328 */ GIM_Try, /*On fail goto*//*Label 33488*/ GIMT_Encode4(2364431),
     /* 2364333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2364336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364344 */   GIM_Try, /*On fail goto*//*Label 33489*/ GIMT_Encode4(2364387), // Rule ID 59046 //
     /* 2364349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364352 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364386 */     // GIR_Coverage, 59046,
     /* 2364386 */     GIR_EraseRootFromParent_Done,
     /* 2364387 */   // Label 33489: @2364387
     /* 2364387 */   GIM_Try, /*On fail goto*//*Label 33490*/ GIMT_Encode4(2364430), // Rule ID 59047 //
     /* 2364392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364395 */     // (ctlz:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2364398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364407 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364417 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364429 */     // GIR_Coverage, 59047,
     /* 2364429 */     GIR_EraseRootFromParent_Done,
     /* 2364430 */   // Label 33490: @2364430
     /* 2364430 */   GIM_Reject,
     /* 2364431 */ // Label 33488: @2364431
     /* 2364431 */ GIM_Reject,
     /* 2364432 */ // Label 33436: @2364432
     /* 2364432 */ GIM_Try, /*On fail goto*//*Label 33491*/ GIMT_Encode4(2364535),
     /* 2364437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2364440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364448 */   GIM_Try, /*On fail goto*//*Label 33492*/ GIMT_Encode4(2364491), // Rule ID 59054 //
     /* 2364453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2364456 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2364473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364478 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364490 */     // GIR_Coverage, 59054,
     /* 2364490 */     GIR_EraseRootFromParent_Done,
     /* 2364491 */   // Label 33492: @2364491
     /* 2364491 */   GIM_Try, /*On fail goto*//*Label 33493*/ GIMT_Encode4(2364534), // Rule ID 59055 //
     /* 2364496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2364499 */     // (ctlz:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2364502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2364516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364518 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364521 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364533 */     // GIR_Coverage, 59055,
     /* 2364533 */     GIR_EraseRootFromParent_Done,
     /* 2364534 */   // Label 33493: @2364534
     /* 2364534 */   GIM_Reject,
     /* 2364535 */ // Label 33491: @2364535
     /* 2364535 */ GIM_Reject,
     /* 2364536 */ // Label 33437: @2364536
     /* 2364536 */ GIM_Try, /*On fail goto*//*Label 33494*/ GIMT_Encode4(2364639),
     /* 2364541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2364544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2364552 */   GIM_Try, /*On fail goto*//*Label 33495*/ GIMT_Encode4(2364595), // Rule ID 59026 //
     /* 2364557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364560 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2364563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2364577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364593 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364594 */     // GIR_Coverage, 59026,
     /* 2364594 */     GIR_EraseRootFromParent_Done,
     /* 2364595 */   // Label 33495: @2364595
     /* 2364595 */   GIM_Try, /*On fail goto*//*Label 33496*/ GIMT_Encode4(2364638), // Rule ID 59027 //
     /* 2364600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364603 */     // (ctlz:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCLZ_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2364606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M1),
     /* 2364620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364625 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364636 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364637 */     // GIR_Coverage, 59027,
     /* 2364637 */     GIR_EraseRootFromParent_Done,
     /* 2364638 */   // Label 33496: @2364638
     /* 2364638 */   GIM_Reject,
     /* 2364639 */ // Label 33494: @2364639
     /* 2364639 */ GIM_Reject,
     /* 2364640 */ // Label 33438: @2364640
     /* 2364640 */ GIM_Try, /*On fail goto*//*Label 33497*/ GIMT_Encode4(2364743),
     /* 2364645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2364648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364656 */   GIM_Try, /*On fail goto*//*Label 33498*/ GIMT_Encode4(2364699), // Rule ID 59040 //
     /* 2364661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364664 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364664 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364667 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364671 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364698 */     // GIR_Coverage, 59040,
     /* 2364698 */     GIR_EraseRootFromParent_Done,
     /* 2364699 */   // Label 33498: @2364699
     /* 2364699 */   GIM_Try, /*On fail goto*//*Label 33499*/ GIMT_Encode4(2364742), // Rule ID 59041 //
     /* 2364704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364707 */     // (ctlz:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364707 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2364710 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364714 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364726 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364729 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2364737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364741 */     // GIR_Coverage, 59041,
     /* 2364741 */     GIR_EraseRootFromParent_Done,
     /* 2364742 */   // Label 33499: @2364742
     /* 2364742 */   GIM_Reject,
     /* 2364743 */ // Label 33497: @2364743
     /* 2364743 */ GIM_Reject,
     /* 2364744 */ // Label 33439: @2364744
     /* 2364744 */ GIM_Try, /*On fail goto*//*Label 33500*/ GIMT_Encode4(2364847),
     /* 2364749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2364752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2364760 */   GIM_Try, /*On fail goto*//*Label 33501*/ GIMT_Encode4(2364803), // Rule ID 59048 //
     /* 2364765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364768 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2364785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364802 */     // GIR_Coverage, 59048,
     /* 2364802 */     GIR_EraseRootFromParent_Done,
     /* 2364803 */   // Label 33501: @2364803
     /* 2364803 */   GIM_Try, /*On fail goto*//*Label 33502*/ GIMT_Encode4(2364846), // Rule ID 59049 //
     /* 2364808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2364811 */     // (ctlz:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2364814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364823 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2364828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364830 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2364841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364845 */     // GIR_Coverage, 59049,
     /* 2364845 */     GIR_EraseRootFromParent_Done,
     /* 2364846 */   // Label 33502: @2364846
     /* 2364846 */   GIM_Reject,
     /* 2364847 */ // Label 33500: @2364847
     /* 2364847 */ GIM_Reject,
     /* 2364848 */ // Label 33440: @2364848
     /* 2364848 */ GIM_Try, /*On fail goto*//*Label 33503*/ GIMT_Encode4(2364951),
     /* 2364853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2364856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2364864 */   GIM_Try, /*On fail goto*//*Label 33504*/ GIMT_Encode4(2364907), // Rule ID 59056 //
     /* 2364869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2364872 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364872 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364875 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364879 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2364889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364894 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364906 */     // GIR_Coverage, 59056,
     /* 2364906 */     GIR_EraseRootFromParent_Done,
     /* 2364907 */   // Label 33504: @2364907
     /* 2364907 */   GIM_Try, /*On fail goto*//*Label 33505*/ GIMT_Encode4(2364950), // Rule ID 59057 //
     /* 2364912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2364915 */     // (ctlz:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2364915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2364918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2364932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2364939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2364942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2364945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2364948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2364949 */     // GIR_Coverage, 59057,
     /* 2364949 */     GIR_EraseRootFromParent_Done,
     /* 2364950 */   // Label 33505: @2364950
     /* 2364950 */   GIM_Reject,
     /* 2364951 */ // Label 33503: @2364951
     /* 2364951 */ GIM_Reject,
     /* 2364952 */ // Label 33441: @2364952
     /* 2364952 */ GIM_Try, /*On fail goto*//*Label 33506*/ GIMT_Encode4(2365055),
     /* 2364957 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2364960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2364968 */   GIM_Try, /*On fail goto*//*Label 33507*/ GIMT_Encode4(2365011), // Rule ID 59034 //
     /* 2364973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2364976 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2364976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2364979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2364983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2364988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2364990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2364993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2364995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2364998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365010 */     // GIR_Coverage, 59034,
     /* 2365010 */     GIR_EraseRootFromParent_Done,
     /* 2365011 */   // Label 33507: @2365011
     /* 2365011 */   GIM_Try, /*On fail goto*//*Label 33508*/ GIMT_Encode4(2365054), // Rule ID 59035 //
     /* 2365016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365019 */     // (ctlz:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCLZ_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2365022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M2),
     /* 2365036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365053 */     // GIR_Coverage, 59035,
     /* 2365053 */     GIR_EraseRootFromParent_Done,
     /* 2365054 */   // Label 33508: @2365054
     /* 2365054 */   GIM_Reject,
     /* 2365055 */ // Label 33506: @2365055
     /* 2365055 */ GIM_Reject,
     /* 2365056 */ // Label 33442: @2365056
     /* 2365056 */ GIM_Try, /*On fail goto*//*Label 33509*/ GIMT_Encode4(2365159),
     /* 2365061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2365064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365072 */   GIM_Try, /*On fail goto*//*Label 33510*/ GIMT_Encode4(2365115), // Rule ID 59042 //
     /* 2365077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365080 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2365097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365102 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365114 */     // GIR_Coverage, 59042,
     /* 2365114 */     GIR_EraseRootFromParent_Done,
     /* 2365115 */   // Label 33510: @2365115
     /* 2365115 */   GIM_Try, /*On fail goto*//*Label 33511*/ GIMT_Encode4(2365158), // Rule ID 59043 //
     /* 2365120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365123 */     // (ctlz:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2365126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2365140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365145 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365157 */     // GIR_Coverage, 59043,
     /* 2365157 */     GIR_EraseRootFromParent_Done,
     /* 2365158 */   // Label 33511: @2365158
     /* 2365158 */   GIM_Reject,
     /* 2365159 */ // Label 33509: @2365159
     /* 2365159 */ GIM_Reject,
     /* 2365160 */ // Label 33443: @2365160
     /* 2365160 */ GIM_Try, /*On fail goto*//*Label 33512*/ GIMT_Encode4(2365263),
     /* 2365165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2365168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365176 */   GIM_Try, /*On fail goto*//*Label 33513*/ GIMT_Encode4(2365219), // Rule ID 59050 //
     /* 2365181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365184 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365206 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365218 */     // GIR_Coverage, 59050,
     /* 2365218 */     GIR_EraseRootFromParent_Done,
     /* 2365219 */   // Label 33513: @2365219
     /* 2365219 */   GIM_Try, /*On fail goto*//*Label 33514*/ GIMT_Encode4(2365262), // Rule ID 59051 //
     /* 2365224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365227 */     // (ctlz:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365227 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2365230 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365234 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2365257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365261 */     // GIR_Coverage, 59051,
     /* 2365261 */     GIR_EraseRootFromParent_Done,
     /* 2365262 */   // Label 33514: @2365262
     /* 2365262 */   GIM_Reject,
     /* 2365263 */ // Label 33512: @2365263
     /* 2365263 */ GIM_Reject,
     /* 2365264 */ // Label 33444: @2365264
     /* 2365264 */ GIM_Try, /*On fail goto*//*Label 33515*/ GIMT_Encode4(2365367),
     /* 2365269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2365272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365276 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2365280 */   GIM_Try, /*On fail goto*//*Label 33516*/ GIMT_Encode4(2365323), // Rule ID 59036 //
     /* 2365285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365288 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2365291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2365305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365307 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365310 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365322 */     // GIR_Coverage, 59036,
     /* 2365322 */     GIR_EraseRootFromParent_Done,
     /* 2365323 */   // Label 33516: @2365323
     /* 2365323 */   GIM_Try, /*On fail goto*//*Label 33517*/ GIMT_Encode4(2365366), // Rule ID 59037 //
     /* 2365328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365331 */     // (ctlz:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCLZ_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2365334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M4),
     /* 2365348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365353 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365364 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365365 */     // GIR_Coverage, 59037,
     /* 2365365 */     GIR_EraseRootFromParent_Done,
     /* 2365366 */   // Label 33517: @2365366
     /* 2365366 */   GIM_Reject,
     /* 2365367 */ // Label 33515: @2365367
     /* 2365367 */ GIM_Reject,
     /* 2365368 */ // Label 33445: @2365368
     /* 2365368 */ GIM_Try, /*On fail goto*//*Label 33518*/ GIMT_Encode4(2365471),
     /* 2365373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2365376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365384 */   GIM_Try, /*On fail goto*//*Label 33519*/ GIMT_Encode4(2365427), // Rule ID 59044 //
     /* 2365389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365392 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365414 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365426 */     // GIR_Coverage, 59044,
     /* 2365426 */     GIR_EraseRootFromParent_Done,
     /* 2365427 */   // Label 33519: @2365427
     /* 2365427 */   GIM_Try, /*On fail goto*//*Label 33520*/ GIMT_Encode4(2365470), // Rule ID 59045 //
     /* 2365432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365435 */     // (ctlz:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2365438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365457 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365468 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365469 */     // GIR_Coverage, 59045,
     /* 2365469 */     GIR_EraseRootFromParent_Done,
     /* 2365470 */   // Label 33520: @2365470
     /* 2365470 */   GIM_Reject,
     /* 2365471 */ // Label 33518: @2365471
     /* 2365471 */ GIM_Reject,
     /* 2365472 */ // Label 33446: @2365472
     /* 2365472 */ GIM_Try, /*On fail goto*//*Label 33521*/ GIMT_Encode4(2365575),
     /* 2365477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2365480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2365488 */   GIM_Try, /*On fail goto*//*Label 33522*/ GIMT_Encode4(2365531), // Rule ID 59038 //
     /* 2365493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365496 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2365499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365518 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365530 */     // GIR_Coverage, 59038,
     /* 2365530 */     GIR_EraseRootFromParent_Done,
     /* 2365531 */   // Label 33522: @2365531
     /* 2365531 */   GIM_Try, /*On fail goto*//*Label 33523*/ GIMT_Encode4(2365574), // Rule ID 59039 //
     /* 2365536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365539 */     // (ctlz:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCLZ_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2365542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCLZ_V_M8),
     /* 2365556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365573 */     // GIR_Coverage, 59039,
     /* 2365573 */     GIR_EraseRootFromParent_Done,
     /* 2365574 */   // Label 33523: @2365574
     /* 2365574 */   GIM_Reject,
     /* 2365575 */ // Label 33521: @2365575
     /* 2365575 */ GIM_Reject,
     /* 2365576 */ // Label 33447: @2365576
     /* 2365576 */ GIM_Reject,
     /* 2365577 */ // Label 90: @2365577
     /* 2365577 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33548*/ GIMT_Encode4(2368127),
     /* 2365588 */ /*GILLT_s32*//*Label 33524*/ GIMT_Encode4(2365712),
     /* 2365592 */ /*GILLT_s64*//*Label 33525*/ GIMT_Encode4(2365760), GIMT_Encode4(0),
     /* 2365600 */ /*GILLT_nxv1s8*//*Label 33526*/ GIMT_Encode4(2365839),
     /* 2365604 */ /*GILLT_nxv1s16*//*Label 33527*/ GIMT_Encode4(2365943),
     /* 2365608 */ /*GILLT_nxv1s32*//*Label 33528*/ GIMT_Encode4(2366047),
     /* 2365612 */ /*GILLT_nxv1s64*//*Label 33529*/ GIMT_Encode4(2366151), GIMT_Encode4(0),
     /* 2365620 */ /*GILLT_nxv2s8*//*Label 33530*/ GIMT_Encode4(2366255),
     /* 2365624 */ /*GILLT_nxv2s16*//*Label 33531*/ GIMT_Encode4(2366359),
     /* 2365628 */ /*GILLT_nxv2s32*//*Label 33532*/ GIMT_Encode4(2366463),
     /* 2365632 */ /*GILLT_nxv2s64*//*Label 33533*/ GIMT_Encode4(2366567), GIMT_Encode4(0),
     /* 2365640 */ /*GILLT_nxv4s8*//*Label 33534*/ GIMT_Encode4(2366671),
     /* 2365644 */ /*GILLT_nxv4s16*//*Label 33535*/ GIMT_Encode4(2366775),
     /* 2365648 */ /*GILLT_nxv4s32*//*Label 33536*/ GIMT_Encode4(2366879),
     /* 2365652 */ /*GILLT_nxv4s64*//*Label 33537*/ GIMT_Encode4(2366983), GIMT_Encode4(0),
     /* 2365660 */ /*GILLT_nxv8s8*//*Label 33538*/ GIMT_Encode4(2367087),
     /* 2365664 */ /*GILLT_nxv8s16*//*Label 33539*/ GIMT_Encode4(2367191),
     /* 2365668 */ /*GILLT_nxv8s32*//*Label 33540*/ GIMT_Encode4(2367295),
     /* 2365672 */ /*GILLT_nxv8s64*//*Label 33541*/ GIMT_Encode4(2367399), GIMT_Encode4(0),
     /* 2365680 */ /*GILLT_nxv16s8*//*Label 33542*/ GIMT_Encode4(2367503),
     /* 2365684 */ /*GILLT_nxv16s16*//*Label 33543*/ GIMT_Encode4(2367607),
     /* 2365688 */ /*GILLT_nxv16s32*//*Label 33544*/ GIMT_Encode4(2367711), GIMT_Encode4(0),
     /* 2365696 */ /*GILLT_nxv32s8*//*Label 33545*/ GIMT_Encode4(2367815),
     /* 2365700 */ /*GILLT_nxv32s16*//*Label 33546*/ GIMT_Encode4(2367919), GIMT_Encode4(0),
     /* 2365708 */ /*GILLT_nxv64s8*//*Label 33547*/ GIMT_Encode4(2368023),
     /* 2365712 */ // Label 33524: @2365712
     /* 2365712 */ GIM_Try, /*On fail goto*//*Label 33549*/ GIMT_Encode4(2365759),
     /* 2365717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2365720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365728 */   GIM_Try, /*On fail goto*//*Label 33550*/ GIMT_Encode4(2365743), // Rule ID 2409 //
     /* 2365733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode1),
     /* 2365736 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CPOP:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2365736 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2365741 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365742 */     // GIR_Coverage, 2409,
     /* 2365742 */     GIR_Done,
     /* 2365743 */   // Label 33550: @2365743
     /* 2365743 */   GIM_Try, /*On fail goto*//*Label 33551*/ GIMT_Encode4(2365758), // Rule ID 64417 //
     /* 2365748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2365751 */     // (ctpop:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (CV_CNT:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2365751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2365756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365757 */     // GIR_Coverage, 64417,
     /* 2365757 */     GIR_Done,
     /* 2365758 */   // Label 33551: @2365758
     /* 2365758 */   GIM_Reject,
     /* 2365759 */ // Label 33549: @2365759
     /* 2365759 */ GIM_Reject,
     /* 2365760 */ // Label 33525: @2365760
     /* 2365760 */ GIM_Try, /*On fail goto*//*Label 33552*/ GIMT_Encode4(2365838),
     /* 2365765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2365768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365772 */   GIM_Try, /*On fail goto*//*Label 33553*/ GIMT_Encode4(2365799), // Rule ID 2412 //
     /* 2365777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2365780 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_zexti32),
     /* 2365787 */     // (ctpop:{ *:[i64] } (zexti32:{ *:[i64] } GPR:{ *:[i64] }:$rs1))  =>  (CPOPW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2365787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CPOPW),
     /* 2365790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs1
     /* 2365797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365798 */     // GIR_Coverage, 2412,
     /* 2365798 */     GIR_EraseRootFromParent_Done,
     /* 2365799 */   // Label 33553: @2365799
     /* 2365799 */   GIM_Try, /*On fail goto*//*Label 33554*/ GIMT_Encode4(2365818), // Rule ID 2408 //
     /* 2365804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_HwMode0),
     /* 2365807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365811 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CPOP:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2365811 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CPOP),
     /* 2365816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365817 */     // GIR_Coverage, 2408,
     /* 2365817 */     GIR_Done,
     /* 2365818 */   // Label 33554: @2365818
     /* 2365818 */   GIM_Try, /*On fail goto*//*Label 33555*/ GIMT_Encode4(2365837), // Rule ID 64416 //
     /* 2365823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2365826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2365830 */     // (ctpop:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CV_CNT:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2365830 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CV_CNT),
     /* 2365835 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365836 */     // GIR_Coverage, 64416,
     /* 2365836 */     GIR_Done,
     /* 2365837 */   // Label 33555: @2365837
     /* 2365837 */   GIM_Reject,
     /* 2365838 */ // Label 33552: @2365838
     /* 2365838 */ GIM_Reject,
     /* 2365839 */ // Label 33526: @2365839
     /* 2365839 */ GIM_Try, /*On fail goto*//*Label 33556*/ GIMT_Encode4(2365942),
     /* 2365844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2365847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365855 */   GIM_Try, /*On fail goto*//*Label 33557*/ GIMT_Encode4(2365898), // Rule ID 59102 //
     /* 2365860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365863 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2365866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2365880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365897 */     // GIR_Coverage, 59102,
     /* 2365897 */     GIR_EraseRootFromParent_Done,
     /* 2365898 */   // Label 33557: @2365898
     /* 2365898 */   GIM_Try, /*On fail goto*//*Label 33558*/ GIMT_Encode4(2365941), // Rule ID 59103 //
     /* 2365903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2365906 */     // (ctpop:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVCPOP_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2365906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2365909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF8),
     /* 2365923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365928 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2365939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2365940 */     // GIR_Coverage, 59103,
     /* 2365940 */     GIR_EraseRootFromParent_Done,
     /* 2365941 */   // Label 33558: @2365941
     /* 2365941 */   GIM_Reject,
     /* 2365942 */ // Label 33556: @2365942
     /* 2365942 */ GIM_Reject,
     /* 2365943 */ // Label 33527: @2365943
     /* 2365943 */ GIM_Try, /*On fail goto*//*Label 33559*/ GIMT_Encode4(2366046),
     /* 2365948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2365951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2365959 */   GIM_Try, /*On fail goto*//*Label 33560*/ GIMT_Encode4(2366002), // Rule ID 59108 //
     /* 2365964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2365967 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2365967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2365970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2365974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2365979 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2365981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2365984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2365986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2365989 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2365991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2365994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2365997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366000 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366001 */     // GIR_Coverage, 59108,
     /* 2366001 */     GIR_EraseRootFromParent_Done,
     /* 2366002 */   // Label 33560: @2366002
     /* 2366002 */   GIM_Try, /*On fail goto*//*Label 33561*/ GIMT_Encode4(2366045), // Rule ID 59109 //
     /* 2366007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366010 */     // (ctpop:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2366013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2366027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366043 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366044 */     // GIR_Coverage, 59109,
     /* 2366044 */     GIR_EraseRootFromParent_Done,
     /* 2366045 */   // Label 33561: @2366045
     /* 2366045 */   GIM_Reject,
     /* 2366046 */ // Label 33559: @2366046
     /* 2366046 */ GIM_Reject,
     /* 2366047 */ // Label 33528: @2366047
     /* 2366047 */ GIM_Try, /*On fail goto*//*Label 33562*/ GIMT_Encode4(2366150),
     /* 2366052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2366055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366063 */   GIM_Try, /*On fail goto*//*Label 33563*/ GIMT_Encode4(2366106), // Rule ID 59112 //
     /* 2366068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366071 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366090 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366104 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366105 */     // GIR_Coverage, 59112,
     /* 2366105 */     GIR_EraseRootFromParent_Done,
     /* 2366106 */   // Label 33563: @2366106
     /* 2366106 */   GIM_Try, /*On fail goto*//*Label 33564*/ GIMT_Encode4(2366149), // Rule ID 59113 //
     /* 2366111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366114 */     // (ctpop:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2366117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366147 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366148 */     // GIR_Coverage, 59113,
     /* 2366148 */     GIR_EraseRootFromParent_Done,
     /* 2366149 */   // Label 33564: @2366149
     /* 2366149 */   GIM_Reject,
     /* 2366150 */ // Label 33562: @2366150
     /* 2366150 */ GIM_Reject,
     /* 2366151 */ // Label 33529: @2366151
     /* 2366151 */ GIM_Try, /*On fail goto*//*Label 33565*/ GIMT_Encode4(2366254),
     /* 2366156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2366159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366167 */   GIM_Try, /*On fail goto*//*Label 33566*/ GIMT_Encode4(2366210), // Rule ID 59120 //
     /* 2366172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2366175 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366208 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366209 */     // GIR_Coverage, 59120,
     /* 2366209 */     GIR_EraseRootFromParent_Done,
     /* 2366210 */   // Label 33566: @2366210
     /* 2366210 */   GIM_Try, /*On fail goto*//*Label 33567*/ GIMT_Encode4(2366253), // Rule ID 59121 //
     /* 2366215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2366218 */     // (ctpop:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2366221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366240 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366252 */     // GIR_Coverage, 59121,
     /* 2366252 */     GIR_EraseRootFromParent_Done,
     /* 2366253 */   // Label 33567: @2366253
     /* 2366253 */   GIM_Reject,
     /* 2366254 */ // Label 33565: @2366254
     /* 2366254 */ GIM_Reject,
     /* 2366255 */ // Label 33530: @2366255
     /* 2366255 */ GIM_Try, /*On fail goto*//*Label 33568*/ GIMT_Encode4(2366358),
     /* 2366260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2366263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366271 */   GIM_Try, /*On fail goto*//*Label 33569*/ GIMT_Encode4(2366314), // Rule ID 59104 //
     /* 2366276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366279 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2366282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2366296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366298 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366312 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366313 */     // GIR_Coverage, 59104,
     /* 2366313 */     GIR_EraseRootFromParent_Done,
     /* 2366314 */   // Label 33569: @2366314
     /* 2366314 */   GIM_Try, /*On fail goto*//*Label 33570*/ GIMT_Encode4(2366357), // Rule ID 59105 //
     /* 2366319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366322 */     // (ctpop:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVCPOP_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2366325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF4),
     /* 2366339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366356 */     // GIR_Coverage, 59105,
     /* 2366356 */     GIR_EraseRootFromParent_Done,
     /* 2366357 */   // Label 33570: @2366357
     /* 2366357 */   GIM_Reject,
     /* 2366358 */ // Label 33568: @2366358
     /* 2366358 */ GIM_Reject,
     /* 2366359 */ // Label 33531: @2366359
     /* 2366359 */ GIM_Try, /*On fail goto*//*Label 33571*/ GIMT_Encode4(2366462),
     /* 2366364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2366367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366375 */   GIM_Try, /*On fail goto*//*Label 33572*/ GIMT_Encode4(2366418), // Rule ID 59110 //
     /* 2366380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366383 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366417 */     // GIR_Coverage, 59110,
     /* 2366417 */     GIR_EraseRootFromParent_Done,
     /* 2366418 */   // Label 33572: @2366418
     /* 2366418 */   GIM_Try, /*On fail goto*//*Label 33573*/ GIMT_Encode4(2366461), // Rule ID 59111 //
     /* 2366423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366426 */     // (ctpop:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2366429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366445 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366448 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366460 */     // GIR_Coverage, 59111,
     /* 2366460 */     GIR_EraseRootFromParent_Done,
     /* 2366461 */   // Label 33573: @2366461
     /* 2366461 */   GIM_Reject,
     /* 2366462 */ // Label 33571: @2366462
     /* 2366462 */ GIM_Reject,
     /* 2366463 */ // Label 33532: @2366463
     /* 2366463 */ GIM_Try, /*On fail goto*//*Label 33574*/ GIMT_Encode4(2366566),
     /* 2366468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2366471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366475 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366479 */   GIM_Try, /*On fail goto*//*Label 33575*/ GIMT_Encode4(2366522), // Rule ID 59118 //
     /* 2366484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366487 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366521 */     // GIR_Coverage, 59118,
     /* 2366521 */     GIR_EraseRootFromParent_Done,
     /* 2366522 */   // Label 33575: @2366522
     /* 2366522 */   GIM_Try, /*On fail goto*//*Label 33576*/ GIMT_Encode4(2366565), // Rule ID 59119 //
     /* 2366527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366530 */     // (ctpop:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2366533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366563 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366564 */     // GIR_Coverage, 59119,
     /* 2366564 */     GIR_EraseRootFromParent_Done,
     /* 2366565 */   // Label 33576: @2366565
     /* 2366565 */   GIM_Reject,
     /* 2366566 */ // Label 33574: @2366566
     /* 2366566 */ GIM_Reject,
     /* 2366567 */ // Label 33533: @2366567
     /* 2366567 */ GIM_Try, /*On fail goto*//*Label 33577*/ GIMT_Encode4(2366670),
     /* 2366572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2366575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366579 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366583 */   GIM_Try, /*On fail goto*//*Label 33578*/ GIMT_Encode4(2366626), // Rule ID 59140 //
     /* 2366588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2366591 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366603 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2366608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366613 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366625 */     // GIR_Coverage, 59140,
     /* 2366625 */     GIR_EraseRootFromParent_Done,
     /* 2366626 */   // Label 33578: @2366626
     /* 2366626 */   GIM_Try, /*On fail goto*//*Label 33579*/ GIMT_Encode4(2366669), // Rule ID 59141 //
     /* 2366631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2366634 */     // (ctpop:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2366637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2366651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366656 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2366664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366668 */     // GIR_Coverage, 59141,
     /* 2366668 */     GIR_EraseRootFromParent_Done,
     /* 2366669 */   // Label 33579: @2366669
     /* 2366669 */   GIM_Reject,
     /* 2366670 */ // Label 33577: @2366670
     /* 2366670 */ GIM_Reject,
     /* 2366671 */ // Label 33534: @2366671
     /* 2366671 */ GIM_Try, /*On fail goto*//*Label 33580*/ GIMT_Encode4(2366774),
     /* 2366676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2366679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366687 */   GIM_Try, /*On fail goto*//*Label 33581*/ GIMT_Encode4(2366730), // Rule ID 59106 //
     /* 2366692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366695 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366695 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2366698 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366702 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366717 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366728 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366729 */     // GIR_Coverage, 59106,
     /* 2366729 */     GIR_EraseRootFromParent_Done,
     /* 2366730 */   // Label 33581: @2366730
     /* 2366730 */   GIM_Try, /*On fail goto*//*Label 33582*/ GIMT_Encode4(2366773), // Rule ID 59107 //
     /* 2366735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366738 */     // (ctpop:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVCPOP_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2366741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_MF2),
     /* 2366755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366760 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366771 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366772 */     // GIR_Coverage, 59107,
     /* 2366772 */     GIR_EraseRootFromParent_Done,
     /* 2366773 */   // Label 33582: @2366773
     /* 2366773 */   GIM_Reject,
     /* 2366774 */ // Label 33580: @2366774
     /* 2366774 */ GIM_Reject,
     /* 2366775 */ // Label 33535: @2366775
     /* 2366775 */ GIM_Try, /*On fail goto*//*Label 33583*/ GIMT_Encode4(2366878),
     /* 2366780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2366783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2366791 */   GIM_Try, /*On fail goto*//*Label 33584*/ GIMT_Encode4(2366834), // Rule ID 59116 //
     /* 2366796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366799 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366833 */     // GIR_Coverage, 59116,
     /* 2366833 */     GIR_EraseRootFromParent_Done,
     /* 2366834 */   // Label 33584: @2366834
     /* 2366834 */   GIM_Try, /*On fail goto*//*Label 33585*/ GIMT_Encode4(2366877), // Rule ID 59117 //
     /* 2366839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366842 */     // (ctpop:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2366845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2366859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366861 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2366872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366875 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366876 */     // GIR_Coverage, 59117,
     /* 2366876 */     GIR_EraseRootFromParent_Done,
     /* 2366877 */   // Label 33585: @2366877
     /* 2366877 */   GIM_Reject,
     /* 2366878 */ // Label 33583: @2366878
     /* 2366878 */ GIM_Reject,
     /* 2366879 */ // Label 33536: @2366879
     /* 2366879 */ GIM_Try, /*On fail goto*//*Label 33586*/ GIMT_Encode4(2366982),
     /* 2366884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2366887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2366895 */   GIM_Try, /*On fail goto*//*Label 33587*/ GIMT_Encode4(2366938), // Rule ID 59134 //
     /* 2366900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2366903 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2366903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2366920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366925 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366936 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366937 */     // GIR_Coverage, 59134,
     /* 2366937 */     GIR_EraseRootFromParent_Done,
     /* 2366938 */   // Label 33587: @2366938
     /* 2366938 */   GIM_Try, /*On fail goto*//*Label 33588*/ GIMT_Encode4(2366981), // Rule ID 59135 //
     /* 2366943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2366946 */     // (ctpop:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2366946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2366949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2366953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2366958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2366960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2366963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2366965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2366968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2366970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2366973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2366976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2366979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2366980 */     // GIR_Coverage, 59135,
     /* 2366980 */     GIR_EraseRootFromParent_Done,
     /* 2366981 */   // Label 33588: @2366981
     /* 2366981 */   GIM_Reject,
     /* 2366982 */ // Label 33586: @2366982
     /* 2366982 */ GIM_Reject,
     /* 2366983 */ // Label 33537: @2366983
     /* 2366983 */ GIM_Try, /*On fail goto*//*Label 33589*/ GIMT_Encode4(2367086),
     /* 2366988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2366991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2366999 */   GIM_Try, /*On fail goto*//*Label 33590*/ GIMT_Encode4(2367042), // Rule ID 59142 //
     /* 2367004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2367007 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367007 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367010 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367014 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367029 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367041 */     // GIR_Coverage, 59142,
     /* 2367041 */     GIR_EraseRootFromParent_Done,
     /* 2367042 */   // Label 33590: @2367042
     /* 2367042 */   GIM_Try, /*On fail goto*//*Label 33591*/ GIMT_Encode4(2367085), // Rule ID 59143 //
     /* 2367047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2367050 */     // (ctpop:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2367053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367084 */     // GIR_Coverage, 59143,
     /* 2367084 */     GIR_EraseRootFromParent_Done,
     /* 2367085 */   // Label 33591: @2367085
     /* 2367085 */   GIM_Reject,
     /* 2367086 */ // Label 33589: @2367086
     /* 2367086 */ GIM_Reject,
     /* 2367087 */ // Label 33538: @2367087
     /* 2367087 */ GIM_Try, /*On fail goto*//*Label 33592*/ GIMT_Encode4(2367190),
     /* 2367092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2367095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2367103 */   GIM_Try, /*On fail goto*//*Label 33593*/ GIMT_Encode4(2367146), // Rule ID 59114 //
     /* 2367108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367111 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2367114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2367128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367144 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367145 */     // GIR_Coverage, 59114,
     /* 2367145 */     GIR_EraseRootFromParent_Done,
     /* 2367146 */   // Label 33593: @2367146
     /* 2367146 */   GIM_Try, /*On fail goto*//*Label 33594*/ GIMT_Encode4(2367189), // Rule ID 59115 //
     /* 2367151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367154 */     // (ctpop:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVCPOP_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2367157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367166 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M1),
     /* 2367171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367187 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367188 */     // GIR_Coverage, 59115,
     /* 2367188 */     GIR_EraseRootFromParent_Done,
     /* 2367189 */   // Label 33594: @2367189
     /* 2367189 */   GIM_Reject,
     /* 2367190 */ // Label 33592: @2367190
     /* 2367190 */ GIM_Reject,
     /* 2367191 */ // Label 33539: @2367191
     /* 2367191 */ GIM_Try, /*On fail goto*//*Label 33595*/ GIMT_Encode4(2367294),
     /* 2367196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2367199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367207 */   GIM_Try, /*On fail goto*//*Label 33596*/ GIMT_Encode4(2367250), // Rule ID 59128 //
     /* 2367212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367215 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2367232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367237 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367249 */     // GIR_Coverage, 59128,
     /* 2367249 */     GIR_EraseRootFromParent_Done,
     /* 2367250 */   // Label 33596: @2367250
     /* 2367250 */   GIM_Try, /*On fail goto*//*Label 33597*/ GIMT_Encode4(2367293), // Rule ID 59129 //
     /* 2367255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367258 */     // (ctpop:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2367261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2367275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367280 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367291 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367292 */     // GIR_Coverage, 59129,
     /* 2367292 */     GIR_EraseRootFromParent_Done,
     /* 2367293 */   // Label 33597: @2367293
     /* 2367293 */   GIM_Reject,
     /* 2367294 */ // Label 33595: @2367294
     /* 2367294 */ GIM_Reject,
     /* 2367295 */ // Label 33540: @2367295
     /* 2367295 */ GIM_Try, /*On fail goto*//*Label 33598*/ GIMT_Encode4(2367398),
     /* 2367300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2367303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367311 */   GIM_Try, /*On fail goto*//*Label 33599*/ GIMT_Encode4(2367354), // Rule ID 59136 //
     /* 2367316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367319 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367341 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367352 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367353 */     // GIR_Coverage, 59136,
     /* 2367353 */     GIR_EraseRootFromParent_Done,
     /* 2367354 */   // Label 33599: @2367354
     /* 2367354 */   GIM_Try, /*On fail goto*//*Label 33600*/ GIMT_Encode4(2367397), // Rule ID 59137 //
     /* 2367359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367362 */     // (ctpop:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2367365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367395 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367396 */     // GIR_Coverage, 59137,
     /* 2367396 */     GIR_EraseRootFromParent_Done,
     /* 2367397 */   // Label 33600: @2367397
     /* 2367397 */   GIM_Reject,
     /* 2367398 */ // Label 33598: @2367398
     /* 2367398 */ GIM_Reject,
     /* 2367399 */ // Label 33541: @2367399
     /* 2367399 */ GIM_Try, /*On fail goto*//*Label 33601*/ GIMT_Encode4(2367502),
     /* 2367404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2367407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367415 */   GIM_Try, /*On fail goto*//*Label 33602*/ GIMT_Encode4(2367458), // Rule ID 59144 //
     /* 2367420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2367423 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2367440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367445 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367456 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367457 */     // GIR_Coverage, 59144,
     /* 2367457 */     GIR_EraseRootFromParent_Done,
     /* 2367458 */   // Label 33602: @2367458
     /* 2367458 */   GIM_Try, /*On fail goto*//*Label 33603*/ GIMT_Encode4(2367501), // Rule ID 59145 //
     /* 2367463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2367466 */     // (ctpop:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2367469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2367483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367488 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2367496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367499 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367500 */     // GIR_Coverage, 59145,
     /* 2367500 */     GIR_EraseRootFromParent_Done,
     /* 2367501 */   // Label 33603: @2367501
     /* 2367501 */   GIM_Reject,
     /* 2367502 */ // Label 33601: @2367502
     /* 2367502 */ GIM_Reject,
     /* 2367503 */ // Label 33542: @2367503
     /* 2367503 */ GIM_Try, /*On fail goto*//*Label 33604*/ GIMT_Encode4(2367606),
     /* 2367508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2367511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2367519 */   GIM_Try, /*On fail goto*//*Label 33605*/ GIMT_Encode4(2367562), // Rule ID 59122 //
     /* 2367524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367527 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2367530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2367544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367561 */     // GIR_Coverage, 59122,
     /* 2367561 */     GIR_EraseRootFromParent_Done,
     /* 2367562 */   // Label 33605: @2367562
     /* 2367562 */   GIM_Try, /*On fail goto*//*Label 33606*/ GIMT_Encode4(2367605), // Rule ID 59123 //
     /* 2367567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367570 */     // (ctpop:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVCPOP_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2367573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M2),
     /* 2367587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367603 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367604 */     // GIR_Coverage, 59123,
     /* 2367604 */     GIR_EraseRootFromParent_Done,
     /* 2367605 */   // Label 33606: @2367605
     /* 2367605 */   GIM_Reject,
     /* 2367606 */ // Label 33604: @2367606
     /* 2367606 */ GIM_Reject,
     /* 2367607 */ // Label 33543: @2367607
     /* 2367607 */ GIM_Try, /*On fail goto*//*Label 33607*/ GIMT_Encode4(2367710),
     /* 2367612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2367615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367623 */   GIM_Try, /*On fail goto*//*Label 33608*/ GIMT_Encode4(2367666), // Rule ID 59130 //
     /* 2367628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367631 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367653 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367664 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367665 */     // GIR_Coverage, 59130,
     /* 2367665 */     GIR_EraseRootFromParent_Done,
     /* 2367666 */   // Label 33608: @2367666
     /* 2367666 */   GIM_Try, /*On fail goto*//*Label 33609*/ GIMT_Encode4(2367709), // Rule ID 59131 //
     /* 2367671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367674 */     // (ctpop:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2367677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367708 */     // GIR_Coverage, 59131,
     /* 2367708 */     GIR_EraseRootFromParent_Done,
     /* 2367709 */   // Label 33609: @2367709
     /* 2367709 */   GIM_Reject,
     /* 2367710 */ // Label 33607: @2367710
     /* 2367710 */ GIM_Reject,
     /* 2367711 */ // Label 33544: @2367711
     /* 2367711 */ GIM_Try, /*On fail goto*//*Label 33610*/ GIMT_Encode4(2367814),
     /* 2367716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2367719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367727 */   GIM_Try, /*On fail goto*//*Label 33611*/ GIMT_Encode4(2367770), // Rule ID 59138 //
     /* 2367732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367735 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2367752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367757 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367768 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367769 */     // GIR_Coverage, 59138,
     /* 2367769 */     GIR_EraseRootFromParent_Done,
     /* 2367770 */   // Label 33611: @2367770
     /* 2367770 */   GIM_Try, /*On fail goto*//*Label 33612*/ GIMT_Encode4(2367813), // Rule ID 59139 //
     /* 2367775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367778 */     // (ctpop:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2367781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2367795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2367808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367811 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367812 */     // GIR_Coverage, 59139,
     /* 2367812 */     GIR_EraseRootFromParent_Done,
     /* 2367813 */   // Label 33612: @2367813
     /* 2367813 */   GIM_Reject,
     /* 2367814 */ // Label 33610: @2367814
     /* 2367814 */ GIM_Reject,
     /* 2367815 */ // Label 33545: @2367815
     /* 2367815 */ GIM_Try, /*On fail goto*//*Label 33613*/ GIMT_Encode4(2367918),
     /* 2367820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2367823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2367831 */   GIM_Try, /*On fail goto*//*Label 33614*/ GIMT_Encode4(2367874), // Rule ID 59124 //
     /* 2367836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367839 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2367842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367851 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367858 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367873 */     // GIR_Coverage, 59124,
     /* 2367873 */     GIR_EraseRootFromParent_Done,
     /* 2367874 */   // Label 33614: @2367874
     /* 2367874 */   GIM_Try, /*On fail goto*//*Label 33615*/ GIMT_Encode4(2367917), // Rule ID 59125 //
     /* 2367879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367882 */     // (ctpop:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVCPOP_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2367885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M4),
     /* 2367899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367916 */     // GIR_Coverage, 59125,
     /* 2367916 */     GIR_EraseRootFromParent_Done,
     /* 2367917 */   // Label 33615: @2367917
     /* 2367917 */   GIM_Reject,
     /* 2367918 */ // Label 33613: @2367918
     /* 2367918 */ GIM_Reject,
     /* 2367919 */ // Label 33546: @2367919
     /* 2367919 */ GIM_Try, /*On fail goto*//*Label 33616*/ GIMT_Encode4(2368022),
     /* 2367924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2367927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2367935 */   GIM_Try, /*On fail goto*//*Label 33617*/ GIMT_Encode4(2367978), // Rule ID 59132 //
     /* 2367940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2367943 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2367943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2367957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2367960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2367962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2367965 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2367967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2367970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2367973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2367976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2367977 */     // GIR_Coverage, 59132,
     /* 2367977 */     GIR_EraseRootFromParent_Done,
     /* 2367978 */   // Label 33617: @2367978
     /* 2367978 */   GIM_Try, /*On fail goto*//*Label 33618*/ GIMT_Encode4(2368021), // Rule ID 59133 //
     /* 2367983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2367986 */     // (ctpop:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2367986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2367989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2367993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2367998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2368003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368019 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368020 */     // GIR_Coverage, 59133,
     /* 2368020 */     GIR_EraseRootFromParent_Done,
     /* 2368021 */   // Label 33618: @2368021
     /* 2368021 */   GIM_Reject,
     /* 2368022 */ // Label 33616: @2368022
     /* 2368022 */ GIM_Reject,
     /* 2368023 */ // Label 33547: @2368023
     /* 2368023 */ GIM_Try, /*On fail goto*//*Label 33619*/ GIMT_Encode4(2368126),
     /* 2368028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2368031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2368039 */   GIM_Try, /*On fail goto*//*Label 33620*/ GIMT_Encode4(2368082), // Rule ID 59126 //
     /* 2368044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2368047 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2368050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2368064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368080 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368081 */     // GIR_Coverage, 59126,
     /* 2368081 */     GIR_EraseRootFromParent_Done,
     /* 2368082 */   // Label 33620: @2368082
     /* 2368082 */   GIM_Try, /*On fail goto*//*Label 33621*/ GIMT_Encode4(2368125), // Rule ID 59127 //
     /* 2368087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2368090 */     // (ctpop:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVCPOP_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2368093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVCPOP_V_M8),
     /* 2368107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368112 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368124 */     // GIR_Coverage, 59127,
     /* 2368124 */     GIR_EraseRootFromParent_Done,
     /* 2368125 */   // Label 33621: @2368125
     /* 2368125 */   GIM_Reject,
     /* 2368126 */ // Label 33619: @2368126
     /* 2368126 */ GIM_Reject,
     /* 2368127 */ // Label 33548: @2368127
     /* 2368127 */ GIM_Reject,
     /* 2368128 */ // Label 91: @2368128
     /* 2368128 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33646*/ GIMT_Encode4(2370662),
     /* 2368139 */ /*GILLT_s32*//*Label 33622*/ GIMT_Encode4(2368263),
     /* 2368143 */ /*GILLT_s64*//*Label 33623*/ GIMT_Encode4(2368326), GIMT_Encode4(0),
     /* 2368151 */ /*GILLT_nxv1s8*//*Label 33624*/ GIMT_Encode4(2368374),
     /* 2368155 */ /*GILLT_nxv1s16*//*Label 33625*/ GIMT_Encode4(2368478),
     /* 2368159 */ /*GILLT_nxv1s32*//*Label 33626*/ GIMT_Encode4(2368582),
     /* 2368163 */ /*GILLT_nxv1s64*//*Label 33627*/ GIMT_Encode4(2368686), GIMT_Encode4(0),
     /* 2368171 */ /*GILLT_nxv2s8*//*Label 33628*/ GIMT_Encode4(2368790),
     /* 2368175 */ /*GILLT_nxv2s16*//*Label 33629*/ GIMT_Encode4(2368894),
     /* 2368179 */ /*GILLT_nxv2s32*//*Label 33630*/ GIMT_Encode4(2368998),
     /* 2368183 */ /*GILLT_nxv2s64*//*Label 33631*/ GIMT_Encode4(2369102), GIMT_Encode4(0),
     /* 2368191 */ /*GILLT_nxv4s8*//*Label 33632*/ GIMT_Encode4(2369206),
     /* 2368195 */ /*GILLT_nxv4s16*//*Label 33633*/ GIMT_Encode4(2369310),
     /* 2368199 */ /*GILLT_nxv4s32*//*Label 33634*/ GIMT_Encode4(2369414),
     /* 2368203 */ /*GILLT_nxv4s64*//*Label 33635*/ GIMT_Encode4(2369518), GIMT_Encode4(0),
     /* 2368211 */ /*GILLT_nxv8s8*//*Label 33636*/ GIMT_Encode4(2369622),
     /* 2368215 */ /*GILLT_nxv8s16*//*Label 33637*/ GIMT_Encode4(2369726),
     /* 2368219 */ /*GILLT_nxv8s32*//*Label 33638*/ GIMT_Encode4(2369830),
     /* 2368223 */ /*GILLT_nxv8s64*//*Label 33639*/ GIMT_Encode4(2369934), GIMT_Encode4(0),
     /* 2368231 */ /*GILLT_nxv16s8*//*Label 33640*/ GIMT_Encode4(2370038),
     /* 2368235 */ /*GILLT_nxv16s16*//*Label 33641*/ GIMT_Encode4(2370142),
     /* 2368239 */ /*GILLT_nxv16s32*//*Label 33642*/ GIMT_Encode4(2370246), GIMT_Encode4(0),
     /* 2368247 */ /*GILLT_nxv32s8*//*Label 33643*/ GIMT_Encode4(2370350),
     /* 2368251 */ /*GILLT_nxv32s16*//*Label 33644*/ GIMT_Encode4(2370454), GIMT_Encode4(0),
     /* 2368259 */ /*GILLT_nxv64s8*//*Label 33645*/ GIMT_Encode4(2370558),
     /* 2368263 */ // Label 33622: @2368263
     /* 2368263 */ GIM_Try, /*On fail goto*//*Label 33647*/ GIMT_Encode4(2368325),
     /* 2368268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2368271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368279 */   GIM_Try, /*On fail goto*//*Label 33648*/ GIMT_Encode4(2368294), // Rule ID 2426 //
     /* 2368284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode0),
     /* 2368287 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2368287 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2368292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368293 */     // GIR_Coverage, 2426,
     /* 2368293 */     GIR_Done,
     /* 2368294 */   // Label 33648: @2368294
     /* 2368294 */   GIM_Try, /*On fail goto*//*Label 33649*/ GIMT_Encode4(2368309), // Rule ID 2427 //
     /* 2368299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV32_HwMode1),
     /* 2368302 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (REV8_RV32:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2368302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV32),
     /* 2368307 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368308 */     // GIR_Coverage, 2427,
     /* 2368308 */     GIR_Done,
     /* 2368309 */   // Label 33649: @2368309
     /* 2368309 */   GIM_Try, /*On fail goto*//*Label 33650*/ GIMT_Encode4(2368324), // Rule ID 62539 //
     /* 2368314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode1),
     /* 2368317 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$rs1)  =>  (TH_REV:{ *:[i32] } GPR:{ *:[i32] }:$rs1)
     /* 2368317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2368322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368323 */     // GIR_Coverage, 62539,
     /* 2368323 */     GIR_Done,
     /* 2368324 */   // Label 33650: @2368324
     /* 2368324 */   GIM_Reject,
     /* 2368325 */ // Label 33647: @2368325
     /* 2368325 */ GIM_Reject,
     /* 2368326 */ // Label 33623: @2368326
     /* 2368326 */ GIM_Try, /*On fail goto*//*Label 33651*/ GIMT_Encode4(2368373),
     /* 2368331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2368334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2368342 */   GIM_Try, /*On fail goto*//*Label 33652*/ GIMT_Encode4(2368357), // Rule ID 2428 //
     /* 2368347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2368350 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (REV8_RV64:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2368350 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REV8_RV64),
     /* 2368355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368356 */     // GIR_Coverage, 2428,
     /* 2368356 */     GIR_Done,
     /* 2368357 */   // Label 33652: @2368357
     /* 2368357 */   GIM_Try, /*On fail goto*//*Label 33653*/ GIMT_Encode4(2368372), // Rule ID 62538 //
     /* 2368362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_HwMode0),
     /* 2368365 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (TH_REV:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2368365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::TH_REV),
     /* 2368370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368371 */     // GIR_Coverage, 62538,
     /* 2368371 */     GIR_Done,
     /* 2368372 */   // Label 33653: @2368372
     /* 2368372 */   GIM_Reject,
     /* 2368373 */ // Label 33651: @2368373
     /* 2368373 */ GIM_Reject,
     /* 2368374 */ // Label 33624: @2368374
     /* 2368374 */ GIM_Try, /*On fail goto*//*Label 33654*/ GIMT_Encode4(2368477),
     /* 2368379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2368382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368390 */   GIM_Try, /*On fail goto*//*Label 33655*/ GIMT_Encode4(2368433), // Rule ID 58970 //
     /* 2368395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2368398 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2368401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2368415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368431 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368432 */     // GIR_Coverage, 58970,
     /* 2368432 */     GIR_EraseRootFromParent_Done,
     /* 2368433 */   // Label 33655: @2368433
     /* 2368433 */   GIM_Try, /*On fail goto*//*Label 33656*/ GIMT_Encode4(2368476), // Rule ID 58971 //
     /* 2368438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2368441 */     // (bswap:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVREV8_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2368444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF8),
     /* 2368458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368475 */     // GIR_Coverage, 58971,
     /* 2368475 */     GIR_EraseRootFromParent_Done,
     /* 2368476 */   // Label 33656: @2368476
     /* 2368476 */   GIM_Reject,
     /* 2368477 */ // Label 33654: @2368477
     /* 2368477 */ GIM_Reject,
     /* 2368478 */ // Label 33625: @2368478
     /* 2368478 */ GIM_Try, /*On fail goto*//*Label 33657*/ GIMT_Encode4(2368581),
     /* 2368483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2368486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368494 */   GIM_Try, /*On fail goto*//*Label 33658*/ GIMT_Encode4(2368537), // Rule ID 58976 //
     /* 2368499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2368502 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2368519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368536 */     // GIR_Coverage, 58976,
     /* 2368536 */     GIR_EraseRootFromParent_Done,
     /* 2368537 */   // Label 33658: @2368537
     /* 2368537 */   GIM_Try, /*On fail goto*//*Label 33659*/ GIMT_Encode4(2368580), // Rule ID 58977 //
     /* 2368542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2368545 */     // (bswap:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368545 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2368548 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368552 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2368562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368575 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368578 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368579 */     // GIR_Coverage, 58977,
     /* 2368579 */     GIR_EraseRootFromParent_Done,
     /* 2368580 */   // Label 33659: @2368580
     /* 2368580 */   GIM_Reject,
     /* 2368581 */ // Label 33657: @2368581
     /* 2368581 */ GIM_Reject,
     /* 2368582 */ // Label 33626: @2368582
     /* 2368582 */ GIM_Try, /*On fail goto*//*Label 33660*/ GIMT_Encode4(2368685),
     /* 2368587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2368590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368598 */   GIM_Try, /*On fail goto*//*Label 33661*/ GIMT_Encode4(2368641), // Rule ID 58980 //
     /* 2368603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2368606 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2368623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368628 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368640 */     // GIR_Coverage, 58980,
     /* 2368640 */     GIR_EraseRootFromParent_Done,
     /* 2368641 */   // Label 33661: @2368641
     /* 2368641 */   GIM_Try, /*On fail goto*//*Label 33662*/ GIMT_Encode4(2368684), // Rule ID 58981 //
     /* 2368646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2368649 */     // (bswap:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2368652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2368666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2368679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368683 */     // GIR_Coverage, 58981,
     /* 2368683 */     GIR_EraseRootFromParent_Done,
     /* 2368684 */   // Label 33662: @2368684
     /* 2368684 */   GIM_Reject,
     /* 2368685 */ // Label 33660: @2368685
     /* 2368685 */ GIM_Reject,
     /* 2368686 */ // Label 33627: @2368686
     /* 2368686 */ GIM_Try, /*On fail goto*//*Label 33663*/ GIMT_Encode4(2368789),
     /* 2368691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2368694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368702 */   GIM_Try, /*On fail goto*//*Label 33664*/ GIMT_Encode4(2368745), // Rule ID 58988 //
     /* 2368707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2368710 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2368727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368744 */     // GIR_Coverage, 58988,
     /* 2368744 */     GIR_EraseRootFromParent_Done,
     /* 2368745 */   // Label 33664: @2368745
     /* 2368745 */   GIM_Try, /*On fail goto*//*Label 33665*/ GIMT_Encode4(2368788), // Rule ID 58989 //
     /* 2368750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2368753 */     // (bswap:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368753 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2368756 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368760 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2368770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368775 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2368783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368787 */     // GIR_Coverage, 58989,
     /* 2368787 */     GIR_EraseRootFromParent_Done,
     /* 2368788 */   // Label 33665: @2368788
     /* 2368788 */   GIM_Reject,
     /* 2368789 */ // Label 33663: @2368789
     /* 2368789 */ GIM_Reject,
     /* 2368790 */ // Label 33628: @2368790
     /* 2368790 */ GIM_Try, /*On fail goto*//*Label 33666*/ GIMT_Encode4(2368893),
     /* 2368795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2368798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368806 */   GIM_Try, /*On fail goto*//*Label 33667*/ GIMT_Encode4(2368849), // Rule ID 58972 //
     /* 2368811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2368814 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2368817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2368831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368847 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368848 */     // GIR_Coverage, 58972,
     /* 2368848 */     GIR_EraseRootFromParent_Done,
     /* 2368849 */   // Label 33667: @2368849
     /* 2368849 */   GIM_Try, /*On fail goto*//*Label 33668*/ GIMT_Encode4(2368892), // Rule ID 58973 //
     /* 2368854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2368857 */     // (bswap:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVREV8_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2368860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF4),
     /* 2368874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368891 */     // GIR_Coverage, 58973,
     /* 2368891 */     GIR_EraseRootFromParent_Done,
     /* 2368892 */   // Label 33668: @2368892
     /* 2368892 */   GIM_Reject,
     /* 2368893 */ // Label 33666: @2368893
     /* 2368893 */ GIM_Reject,
     /* 2368894 */ // Label 33629: @2368894
     /* 2368894 */ GIM_Try, /*On fail goto*//*Label 33669*/ GIMT_Encode4(2368997),
     /* 2368899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2368902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2368910 */   GIM_Try, /*On fail goto*//*Label 33670*/ GIMT_Encode4(2368953), // Rule ID 58978 //
     /* 2368915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2368918 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2368918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368930 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2368935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368937 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368940 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368951 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368952 */     // GIR_Coverage, 58978,
     /* 2368952 */     GIR_EraseRootFromParent_Done,
     /* 2368953 */   // Label 33670: @2368953
     /* 2368953 */   GIM_Try, /*On fail goto*//*Label 33671*/ GIMT_Encode4(2368996), // Rule ID 58979 //
     /* 2368958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2368961 */     // (bswap:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2368961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2368964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2368968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2368973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2368975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2368978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2368980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2368983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2368985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2368988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2368991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2368994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2368995 */     // GIR_Coverage, 58979,
     /* 2368995 */     GIR_EraseRootFromParent_Done,
     /* 2368996 */   // Label 33671: @2368996
     /* 2368996 */   GIM_Reject,
     /* 2368997 */ // Label 33669: @2368997
     /* 2368997 */ GIM_Reject,
     /* 2368998 */ // Label 33630: @2368998
     /* 2368998 */ GIM_Try, /*On fail goto*//*Label 33672*/ GIMT_Encode4(2369101),
     /* 2369003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2369006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369014 */   GIM_Try, /*On fail goto*//*Label 33673*/ GIMT_Encode4(2369057), // Rule ID 58986 //
     /* 2369019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369022 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2369025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369034 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369044 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369056 */     // GIR_Coverage, 58986,
     /* 2369056 */     GIR_EraseRootFromParent_Done,
     /* 2369057 */   // Label 33673: @2369057
     /* 2369057 */   GIM_Try, /*On fail goto*//*Label 33674*/ GIMT_Encode4(2369100), // Rule ID 58987 //
     /* 2369062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369065 */     // (bswap:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369065 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2369068 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369072 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369077 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369087 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369099 */     // GIR_Coverage, 58987,
     /* 2369099 */     GIR_EraseRootFromParent_Done,
     /* 2369100 */   // Label 33674: @2369100
     /* 2369100 */   GIM_Reject,
     /* 2369101 */ // Label 33672: @2369101
     /* 2369101 */ GIM_Reject,
     /* 2369102 */ // Label 33631: @2369102
     /* 2369102 */ GIM_Try, /*On fail goto*//*Label 33675*/ GIMT_Encode4(2369205),
     /* 2369107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2369110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369118 */   GIM_Try, /*On fail goto*//*Label 33676*/ GIMT_Encode4(2369161), // Rule ID 59008 //
     /* 2369123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2369126 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2369129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369160 */     // GIR_Coverage, 59008,
     /* 2369160 */     GIR_EraseRootFromParent_Done,
     /* 2369161 */   // Label 33676: @2369161
     /* 2369161 */   GIM_Try, /*On fail goto*//*Label 33677*/ GIMT_Encode4(2369204), // Rule ID 59009 //
     /* 2369166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2369169 */     // (bswap:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369169 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2369172 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369176 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369181 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369203 */     // GIR_Coverage, 59009,
     /* 2369203 */     GIR_EraseRootFromParent_Done,
     /* 2369204 */   // Label 33677: @2369204
     /* 2369204 */   GIM_Reject,
     /* 2369205 */ // Label 33675: @2369205
     /* 2369205 */ GIM_Reject,
     /* 2369206 */ // Label 33632: @2369206
     /* 2369206 */ GIM_Try, /*On fail goto*//*Label 33678*/ GIMT_Encode4(2369309),
     /* 2369211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2369214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369222 */   GIM_Try, /*On fail goto*//*Label 33679*/ GIMT_Encode4(2369265), // Rule ID 58974 //
     /* 2369227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369230 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2369233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2369247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369264 */     // GIR_Coverage, 58974,
     /* 2369264 */     GIR_EraseRootFromParent_Done,
     /* 2369265 */   // Label 33679: @2369265
     /* 2369265 */   GIM_Try, /*On fail goto*//*Label 33680*/ GIMT_Encode4(2369308), // Rule ID 58975 //
     /* 2369270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369273 */     // (bswap:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVREV8_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2369276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_MF2),
     /* 2369290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369292 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369295 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369307 */     // GIR_Coverage, 58975,
     /* 2369307 */     GIR_EraseRootFromParent_Done,
     /* 2369308 */   // Label 33680: @2369308
     /* 2369308 */   GIM_Reject,
     /* 2369309 */ // Label 33678: @2369309
     /* 2369309 */ GIM_Reject,
     /* 2369310 */ // Label 33633: @2369310
     /* 2369310 */ GIM_Try, /*On fail goto*//*Label 33681*/ GIMT_Encode4(2369413),
     /* 2369315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2369318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369326 */   GIM_Try, /*On fail goto*//*Label 33682*/ GIMT_Encode4(2369369), // Rule ID 58984 //
     /* 2369331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369334 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2369337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369368 */     // GIR_Coverage, 58984,
     /* 2369368 */     GIR_EraseRootFromParent_Done,
     /* 2369369 */   // Label 33682: @2369369
     /* 2369369 */   GIM_Try, /*On fail goto*//*Label 33683*/ GIMT_Encode4(2369412), // Rule ID 58985 //
     /* 2369374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369377 */     // (bswap:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2369380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369389 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369396 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369411 */     // GIR_Coverage, 58985,
     /* 2369411 */     GIR_EraseRootFromParent_Done,
     /* 2369412 */   // Label 33683: @2369412
     /* 2369412 */   GIM_Reject,
     /* 2369413 */ // Label 33681: @2369413
     /* 2369413 */ GIM_Reject,
     /* 2369414 */ // Label 33634: @2369414
     /* 2369414 */ GIM_Try, /*On fail goto*//*Label 33684*/ GIMT_Encode4(2369517),
     /* 2369419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2369422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369430 */   GIM_Try, /*On fail goto*//*Label 33685*/ GIMT_Encode4(2369473), // Rule ID 59002 //
     /* 2369435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369438 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2369441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369471 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369472 */     // GIR_Coverage, 59002,
     /* 2369472 */     GIR_EraseRootFromParent_Done,
     /* 2369473 */   // Label 33685: @2369473
     /* 2369473 */   GIM_Try, /*On fail goto*//*Label 33686*/ GIMT_Encode4(2369516), // Rule ID 59003 //
     /* 2369478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369481 */     // (bswap:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2369484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369515 */     // GIR_Coverage, 59003,
     /* 2369515 */     GIR_EraseRootFromParent_Done,
     /* 2369516 */   // Label 33686: @2369516
     /* 2369516 */   GIM_Reject,
     /* 2369517 */ // Label 33684: @2369517
     /* 2369517 */ GIM_Reject,
     /* 2369518 */ // Label 33635: @2369518
     /* 2369518 */ GIM_Try, /*On fail goto*//*Label 33687*/ GIMT_Encode4(2369621),
     /* 2369523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2369526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369534 */   GIM_Try, /*On fail goto*//*Label 33688*/ GIMT_Encode4(2369577), // Rule ID 59010 //
     /* 2369539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2369542 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2369545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2369559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369575 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369576 */     // GIR_Coverage, 59010,
     /* 2369576 */     GIR_EraseRootFromParent_Done,
     /* 2369577 */   // Label 33688: @2369577
     /* 2369577 */   GIM_Try, /*On fail goto*//*Label 33689*/ GIMT_Encode4(2369620), // Rule ID 59011 //
     /* 2369582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2369585 */     // (bswap:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2369588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2369602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369607 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369619 */     // GIR_Coverage, 59011,
     /* 2369619 */     GIR_EraseRootFromParent_Done,
     /* 2369620 */   // Label 33689: @2369620
     /* 2369620 */   GIM_Reject,
     /* 2369621 */ // Label 33687: @2369621
     /* 2369621 */ GIM_Reject,
     /* 2369622 */ // Label 33636: @2369622
     /* 2369622 */ GIM_Try, /*On fail goto*//*Label 33690*/ GIMT_Encode4(2369725),
     /* 2369627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2369630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2369638 */   GIM_Try, /*On fail goto*//*Label 33691*/ GIMT_Encode4(2369681), // Rule ID 58982 //
     /* 2369643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369646 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2369649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369679 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369680 */     // GIR_Coverage, 58982,
     /* 2369680 */     GIR_EraseRootFromParent_Done,
     /* 2369681 */   // Label 33691: @2369681
     /* 2369681 */   GIM_Try, /*On fail goto*//*Label 33692*/ GIMT_Encode4(2369724), // Rule ID 58983 //
     /* 2369686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369689 */     // (bswap:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVREV8_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2369692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M1),
     /* 2369706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369723 */     // GIR_Coverage, 58983,
     /* 2369723 */     GIR_EraseRootFromParent_Done,
     /* 2369724 */   // Label 33692: @2369724
     /* 2369724 */   GIM_Reject,
     /* 2369725 */ // Label 33690: @2369725
     /* 2369725 */ GIM_Reject,
     /* 2369726 */ // Label 33637: @2369726
     /* 2369726 */ GIM_Try, /*On fail goto*//*Label 33693*/ GIMT_Encode4(2369829),
     /* 2369731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2369734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2369742 */   GIM_Try, /*On fail goto*//*Label 33694*/ GIMT_Encode4(2369785), // Rule ID 58996 //
     /* 2369747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369750 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369769 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369772 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369784 */     // GIR_Coverage, 58996,
     /* 2369784 */     GIR_EraseRootFromParent_Done,
     /* 2369785 */   // Label 33694: @2369785
     /* 2369785 */   GIM_Try, /*On fail goto*//*Label 33695*/ GIMT_Encode4(2369828), // Rule ID 58997 //
     /* 2369790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369793 */     // (bswap:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2369796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2369810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2369823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369827 */     // GIR_Coverage, 58997,
     /* 2369827 */     GIR_EraseRootFromParent_Done,
     /* 2369828 */   // Label 33695: @2369828
     /* 2369828 */   GIM_Reject,
     /* 2369829 */ // Label 33693: @2369829
     /* 2369829 */ GIM_Reject,
     /* 2369830 */ // Label 33638: @2369830
     /* 2369830 */ GIM_Try, /*On fail goto*//*Label 33696*/ GIMT_Encode4(2369933),
     /* 2369835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2369838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2369846 */   GIM_Try, /*On fail goto*//*Label 33697*/ GIMT_Encode4(2369889), // Rule ID 59004 //
     /* 2369851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2369854 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2369871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369873 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369876 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369888 */     // GIR_Coverage, 59004,
     /* 2369888 */     GIR_EraseRootFromParent_Done,
     /* 2369889 */   // Label 33697: @2369889
     /* 2369889 */   GIM_Try, /*On fail goto*//*Label 33698*/ GIMT_Encode4(2369932), // Rule ID 59005 //
     /* 2369894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2369897 */     // (bswap:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2369897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2369900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369909 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2369914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369916 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2369927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369931 */     // GIR_Coverage, 59005,
     /* 2369931 */     GIR_EraseRootFromParent_Done,
     /* 2369932 */   // Label 33698: @2369932
     /* 2369932 */   GIM_Reject,
     /* 2369933 */ // Label 33696: @2369933
     /* 2369933 */ GIM_Reject,
     /* 2369934 */ // Label 33639: @2369934
     /* 2369934 */ GIM_Try, /*On fail goto*//*Label 33699*/ GIMT_Encode4(2370037),
     /* 2369939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2369942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2369950 */   GIM_Try, /*On fail goto*//*Label 33700*/ GIMT_Encode4(2369993), // Rule ID 59012 //
     /* 2369955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode0),
     /* 2369958 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2369958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2369961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2369965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2369970 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2369972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2369975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2369977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2369980 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2369982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2369985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2369988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2369991 */     GIR_RootConstrainSelectedInstOperands,
     /* 2369992 */     // GIR_Coverage, 59012,
     /* 2369992 */     GIR_EraseRootFromParent_Done,
     /* 2369993 */   // Label 33700: @2369993
     /* 2369993 */   GIM_Try, /*On fail goto*//*Label 33701*/ GIMT_Encode4(2370036), // Rule ID 59013 //
     /* 2369998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructionsI64_HwMode1),
     /* 2370001 */     // (bswap:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2370004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370023 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2370031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370034 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370035 */     // GIR_Coverage, 59013,
     /* 2370035 */     GIR_EraseRootFromParent_Done,
     /* 2370036 */   // Label 33701: @2370036
     /* 2370036 */   GIM_Reject,
     /* 2370037 */ // Label 33699: @2370037
     /* 2370037 */ GIM_Reject,
     /* 2370038 */ // Label 33640: @2370038
     /* 2370038 */ GIM_Try, /*On fail goto*//*Label 33702*/ GIMT_Encode4(2370141),
     /* 2370043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2370046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2370054 */   GIM_Try, /*On fail goto*//*Label 33703*/ GIMT_Encode4(2370097), // Rule ID 58990 //
     /* 2370059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370062 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370062 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2370065 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370069 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2370079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370084 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370095 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370096 */     // GIR_Coverage, 58990,
     /* 2370096 */     GIR_EraseRootFromParent_Done,
     /* 2370097 */   // Label 33703: @2370097
     /* 2370097 */   GIM_Try, /*On fail goto*//*Label 33704*/ GIMT_Encode4(2370140), // Rule ID 58991 //
     /* 2370102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370105 */     // (bswap:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVREV8_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2370108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M2),
     /* 2370122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370127 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370139 */     // GIR_Coverage, 58991,
     /* 2370139 */     GIR_EraseRootFromParent_Done,
     /* 2370140 */   // Label 33704: @2370140
     /* 2370140 */   GIM_Reject,
     /* 2370141 */ // Label 33702: @2370141
     /* 2370141 */ GIM_Reject,
     /* 2370142 */ // Label 33641: @2370142
     /* 2370142 */ GIM_Try, /*On fail goto*//*Label 33705*/ GIMT_Encode4(2370245),
     /* 2370147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2370150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370158 */   GIM_Try, /*On fail goto*//*Label 33706*/ GIMT_Encode4(2370201), // Rule ID 58998 //
     /* 2370163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370166 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2370169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2370183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370200 */     // GIR_Coverage, 58998,
     /* 2370200 */     GIR_EraseRootFromParent_Done,
     /* 2370201 */   // Label 33706: @2370201
     /* 2370201 */   GIM_Try, /*On fail goto*//*Label 33707*/ GIMT_Encode4(2370244), // Rule ID 58999 //
     /* 2370206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370209 */     // (bswap:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2370212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2370226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370228 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370243 */     // GIR_Coverage, 58999,
     /* 2370243 */     GIR_EraseRootFromParent_Done,
     /* 2370244 */   // Label 33707: @2370244
     /* 2370244 */   GIM_Reject,
     /* 2370245 */ // Label 33705: @2370245
     /* 2370245 */ GIM_Reject,
     /* 2370246 */ // Label 33642: @2370246
     /* 2370246 */ GIM_Try, /*On fail goto*//*Label 33708*/ GIMT_Encode4(2370349),
     /* 2370251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2370254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370262 */   GIM_Try, /*On fail goto*//*Label 33709*/ GIMT_Encode4(2370305), // Rule ID 59006 //
     /* 2370267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370270 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2370273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370303 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370304 */     // GIR_Coverage, 59006,
     /* 2370304 */     GIR_EraseRootFromParent_Done,
     /* 2370305 */   // Label 33709: @2370305
     /* 2370305 */   GIM_Try, /*On fail goto*//*Label 33710*/ GIMT_Encode4(2370348), // Rule ID 59007 //
     /* 2370310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370313 */     // (bswap:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2370316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2370343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370347 */     // GIR_Coverage, 59007,
     /* 2370347 */     GIR_EraseRootFromParent_Done,
     /* 2370348 */   // Label 33710: @2370348
     /* 2370348 */   GIM_Reject,
     /* 2370349 */ // Label 33708: @2370349
     /* 2370349 */ GIM_Reject,
     /* 2370350 */ // Label 33643: @2370350
     /* 2370350 */ GIM_Try, /*On fail goto*//*Label 33711*/ GIMT_Encode4(2370453),
     /* 2370355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2370358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2370366 */   GIM_Try, /*On fail goto*//*Label 33712*/ GIMT_Encode4(2370409), // Rule ID 58992 //
     /* 2370371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370374 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370374 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2370377 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370381 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2370391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370396 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370407 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370408 */     // GIR_Coverage, 58992,
     /* 2370408 */     GIR_EraseRootFromParent_Done,
     /* 2370409 */   // Label 33712: @2370409
     /* 2370409 */   GIM_Try, /*On fail goto*//*Label 33713*/ GIMT_Encode4(2370452), // Rule ID 58993 //
     /* 2370414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370417 */     // (bswap:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVREV8_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2370420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M4),
     /* 2370434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370436 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370439 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370451 */     // GIR_Coverage, 58993,
     /* 2370451 */     GIR_EraseRootFromParent_Done,
     /* 2370452 */   // Label 33713: @2370452
     /* 2370452 */   GIM_Reject,
     /* 2370453 */ // Label 33711: @2370453
     /* 2370453 */ GIM_Reject,
     /* 2370454 */ // Label 33644: @2370454
     /* 2370454 */ GIM_Try, /*On fail goto*//*Label 33714*/ GIMT_Encode4(2370557),
     /* 2370459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2370462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370470 */   GIM_Try, /*On fail goto*//*Label 33715*/ GIMT_Encode4(2370513), // Rule ID 59000 //
     /* 2370475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370478 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2370481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370500 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370512 */     // GIR_Coverage, 59000,
     /* 2370512 */     GIR_EraseRootFromParent_Done,
     /* 2370513 */   // Label 33715: @2370513
     /* 2370513 */   GIM_Try, /*On fail goto*//*Label 33716*/ GIMT_Encode4(2370556), // Rule ID 59001 //
     /* 2370518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370521 */     // (bswap:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2370524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2370551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370555 */     // GIR_Coverage, 59001,
     /* 2370555 */     GIR_EraseRootFromParent_Done,
     /* 2370556 */   // Label 33716: @2370556
     /* 2370556 */   GIM_Reject,
     /* 2370557 */ // Label 33714: @2370557
     /* 2370557 */ GIM_Reject,
     /* 2370558 */ // Label 33645: @2370558
     /* 2370558 */ GIM_Try, /*On fail goto*//*Label 33717*/ GIMT_Encode4(2370661),
     /* 2370563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2370566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2370574 */   GIM_Try, /*On fail goto*//*Label 33718*/ GIMT_Encode4(2370617), // Rule ID 58994 //
     /* 2370579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode0),
     /* 2370582 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2370585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370604 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370616 */     // GIR_Coverage, 58994,
     /* 2370616 */     GIR_EraseRootFromParent_Done,
     /* 2370617 */   // Label 33718: @2370617
     /* 2370617 */   GIM_Try, /*On fail goto*//*Label 33719*/ GIMT_Encode4(2370660), // Rule ID 58995 //
     /* 2370622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvkb_HasVInstructions_HwMode1),
     /* 2370625 */     // (bswap:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVREV8_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2370628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVREV8_V_M8),
     /* 2370642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370659 */     // GIR_Coverage, 58995,
     /* 2370659 */     GIR_EraseRootFromParent_Done,
     /* 2370660 */   // Label 33719: @2370660
     /* 2370660 */   GIM_Reject,
     /* 2370661 */ // Label 33717: @2370661
     /* 2370661 */ GIM_Reject,
     /* 2370662 */ // Label 33646: @2370662
     /* 2370662 */ GIM_Reject,
     /* 2370663 */ // Label 92: @2370663
     /* 2370663 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(34), /*)*//*default:*//*Label 33744*/ GIMT_Encode4(2373156),
     /* 2370674 */ /*GILLT_s32*//*Label 33720*/ GIMT_Encode4(2370798),
     /* 2370678 */ /*GILLT_s64*//*Label 33721*/ GIMT_Encode4(2370833), GIMT_Encode4(0),
     /* 2370686 */ /*GILLT_nxv1s8*//*Label 33722*/ GIMT_Encode4(2370868),
     /* 2370690 */ /*GILLT_nxv1s16*//*Label 33723*/ GIMT_Encode4(2370972),
     /* 2370694 */ /*GILLT_nxv1s32*//*Label 33724*/ GIMT_Encode4(2371076),
     /* 2370698 */ /*GILLT_nxv1s64*//*Label 33725*/ GIMT_Encode4(2371180), GIMT_Encode4(0),
     /* 2370706 */ /*GILLT_nxv2s8*//*Label 33726*/ GIMT_Encode4(2371284),
     /* 2370710 */ /*GILLT_nxv2s16*//*Label 33727*/ GIMT_Encode4(2371388),
     /* 2370714 */ /*GILLT_nxv2s32*//*Label 33728*/ GIMT_Encode4(2371492),
     /* 2370718 */ /*GILLT_nxv2s64*//*Label 33729*/ GIMT_Encode4(2371596), GIMT_Encode4(0),
     /* 2370726 */ /*GILLT_nxv4s8*//*Label 33730*/ GIMT_Encode4(2371700),
     /* 2370730 */ /*GILLT_nxv4s16*//*Label 33731*/ GIMT_Encode4(2371804),
     /* 2370734 */ /*GILLT_nxv4s32*//*Label 33732*/ GIMT_Encode4(2371908),
     /* 2370738 */ /*GILLT_nxv4s64*//*Label 33733*/ GIMT_Encode4(2372012), GIMT_Encode4(0),
     /* 2370746 */ /*GILLT_nxv8s8*//*Label 33734*/ GIMT_Encode4(2372116),
     /* 2370750 */ /*GILLT_nxv8s16*//*Label 33735*/ GIMT_Encode4(2372220),
     /* 2370754 */ /*GILLT_nxv8s32*//*Label 33736*/ GIMT_Encode4(2372324),
     /* 2370758 */ /*GILLT_nxv8s64*//*Label 33737*/ GIMT_Encode4(2372428), GIMT_Encode4(0),
     /* 2370766 */ /*GILLT_nxv16s8*//*Label 33738*/ GIMT_Encode4(2372532),
     /* 2370770 */ /*GILLT_nxv16s16*//*Label 33739*/ GIMT_Encode4(2372636),
     /* 2370774 */ /*GILLT_nxv16s32*//*Label 33740*/ GIMT_Encode4(2372740), GIMT_Encode4(0),
     /* 2370782 */ /*GILLT_nxv32s8*//*Label 33741*/ GIMT_Encode4(2372844),
     /* 2370786 */ /*GILLT_nxv32s16*//*Label 33742*/ GIMT_Encode4(2372948), GIMT_Encode4(0),
     /* 2370794 */ /*GILLT_nxv64s8*//*Label 33743*/ GIMT_Encode4(2373052),
     /* 2370798 */ // Label 33720: @2370798
     /* 2370798 */ GIM_Try, /*On fail goto*//*Label 33745*/ GIMT_Encode4(2370832), // Rule ID 64422 //
     /* 2370803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode1),
     /* 2370806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2370809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370817 */   // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$rs)  =>  (CV_BITREV:{ *:[i32] } GPR:{ *:[i32] }:$rs, 0:{ *:[i32] }, 0:{ *:[i32] })
     /* 2370817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2370820 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370822 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2370824 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2370827 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2370830 */   GIR_RootConstrainSelectedInstOperands,
     /* 2370831 */   // GIR_Coverage, 64422,
     /* 2370831 */   GIR_EraseRootFromParent_Done,
     /* 2370832 */ // Label 33745: @2370832
     /* 2370832 */ GIM_Reject,
     /* 2370833 */ // Label 33721: @2370833
     /* 2370833 */ GIM_Try, /*On fail goto*//*Label 33746*/ GIMT_Encode4(2370867), // Rule ID 64421 //
     /* 2370838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXCVbitmanip_IsRV32_HwMode0),
     /* 2370841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2370844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2370852 */   // (bitreverse:{ *:[i64] } GPR:{ *:[i64] }:$rs)  =>  (CV_BITREV:{ *:[i64] } GPR:{ *:[i64] }:$rs, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 2370852 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::CV_BITREV),
     /* 2370855 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370857 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs
     /* 2370859 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2370862 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2370865 */   GIR_RootConstrainSelectedInstOperands,
     /* 2370866 */   // GIR_Coverage, 64421,
     /* 2370866 */   GIR_EraseRootFromParent_Done,
     /* 2370867 */ // Label 33746: @2370867
     /* 2370867 */ GIM_Reject,
     /* 2370868 */ // Label 33722: @2370868
     /* 2370868 */ GIM_Try, /*On fail goto*//*Label 33747*/ GIMT_Encode4(2370971),
     /* 2370873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2370876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370884 */   GIM_Try, /*On fail goto*//*Label 33748*/ GIMT_Encode4(2370927), // Rule ID 58794 //
     /* 2370889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370892 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2370909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370925 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370926 */     // GIR_Coverage, 58794,
     /* 2370926 */     GIR_EraseRootFromParent_Done,
     /* 2370927 */   // Label 33748: @2370927
     /* 2370927 */   GIM_Try, /*On fail goto*//*Label 33749*/ GIMT_Encode4(2370970), // Rule ID 58795 //
     /* 2370932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2370935 */     // (bitreverse:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rs1)  =>  (PseudoVBREV_V_MF8:{ *:[nxv1i8] } (IMPLICIT_DEF:{ *:[nxv1i8] }), VR:{ *:[nxv1i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2370935 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s8,
     /* 2370938 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2370942 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2370947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2370949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF8),
     /* 2370952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2370954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2370957 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2370959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2370962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2370968 */     GIR_RootConstrainSelectedInstOperands,
     /* 2370969 */     // GIR_Coverage, 58795,
     /* 2370969 */     GIR_EraseRootFromParent_Done,
     /* 2370970 */   // Label 33749: @2370970
     /* 2370970 */   GIM_Reject,
     /* 2370971 */ // Label 33747: @2370971
     /* 2370971 */ GIM_Reject,
     /* 2370972 */ // Label 33723: @2370972
     /* 2370972 */ GIM_Try, /*On fail goto*//*Label 33750*/ GIMT_Encode4(2371075),
     /* 2370977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2370980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2370988 */   GIM_Try, /*On fail goto*//*Label 33751*/ GIMT_Encode4(2371031), // Rule ID 58932 //
     /* 2370993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2370996 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2370996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2370999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2371013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371030 */     // GIR_Coverage, 58932,
     /* 2371030 */     GIR_EraseRootFromParent_Done,
     /* 2371031 */   // Label 33751: @2371031
     /* 2371031 */   GIM_Try, /*On fail goto*//*Label 33752*/ GIMT_Encode4(2371074), // Rule ID 58933 //
     /* 2371036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371039 */     // (bitreverse:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv1i16] } (IMPLICIT_DEF:{ *:[nxv1i16] }), VR:{ *:[nxv1i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2371042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2371056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371061 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371073 */     // GIR_Coverage, 58933,
     /* 2371073 */     GIR_EraseRootFromParent_Done,
     /* 2371074 */   // Label 33752: @2371074
     /* 2371074 */   GIM_Reject,
     /* 2371075 */ // Label 33750: @2371075
     /* 2371075 */ GIM_Reject,
     /* 2371076 */ // Label 33724: @2371076
     /* 2371076 */ GIM_Try, /*On fail goto*//*Label 33753*/ GIMT_Encode4(2371179),
     /* 2371081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2371084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371092 */   GIM_Try, /*On fail goto*//*Label 33754*/ GIMT_Encode4(2371135), // Rule ID 58936 //
     /* 2371097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371100 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2371103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371133 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371134 */     // GIR_Coverage, 58936,
     /* 2371134 */     GIR_EraseRootFromParent_Done,
     /* 2371135 */   // Label 33754: @2371135
     /* 2371135 */   GIM_Try, /*On fail goto*//*Label 33755*/ GIMT_Encode4(2371178), // Rule ID 58937 //
     /* 2371140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371143 */     // (bitreverse:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv1i32] } (IMPLICIT_DEF:{ *:[nxv1i32] }), VR:{ *:[nxv1i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371143 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2371146 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371150 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371155 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371162 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371165 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371177 */     // GIR_Coverage, 58937,
     /* 2371177 */     GIR_EraseRootFromParent_Done,
     /* 2371178 */   // Label 33755: @2371178
     /* 2371178 */   GIM_Reject,
     /* 2371179 */ // Label 33753: @2371179
     /* 2371179 */ GIM_Reject,
     /* 2371180 */ // Label 33725: @2371180
     /* 2371180 */ GIM_Try, /*On fail goto*//*Label 33756*/ GIMT_Encode4(2371283),
     /* 2371185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2371188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371196 */   GIM_Try, /*On fail goto*//*Label 33757*/ GIMT_Encode4(2371239), // Rule ID 58944 //
     /* 2371201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2371204 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2371207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371223 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371237 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371238 */     // GIR_Coverage, 58944,
     /* 2371238 */     GIR_EraseRootFromParent_Done,
     /* 2371239 */   // Label 33757: @2371239
     /* 2371239 */   GIM_Try, /*On fail goto*//*Label 33758*/ GIMT_Encode4(2371282), // Rule ID 58945 //
     /* 2371244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2371247 */     // (bitreverse:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv1i64] } (IMPLICIT_DEF:{ *:[nxv1i64] }), VR:{ *:[nxv1i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2371250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371269 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371281 */     // GIR_Coverage, 58945,
     /* 2371281 */     GIR_EraseRootFromParent_Done,
     /* 2371282 */   // Label 33758: @2371282
     /* 2371282 */   GIM_Reject,
     /* 2371283 */ // Label 33756: @2371283
     /* 2371283 */ GIM_Reject,
     /* 2371284 */ // Label 33726: @2371284
     /* 2371284 */ GIM_Try, /*On fail goto*//*Label 33759*/ GIMT_Encode4(2371387),
     /* 2371289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2371292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371300 */   GIM_Try, /*On fail goto*//*Label 33760*/ GIMT_Encode4(2371343), // Rule ID 58928 //
     /* 2371305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371308 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2371311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2371325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371341 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371342 */     // GIR_Coverage, 58928,
     /* 2371342 */     GIR_EraseRootFromParent_Done,
     /* 2371343 */   // Label 33760: @2371343
     /* 2371343 */   GIM_Try, /*On fail goto*//*Label 33761*/ GIMT_Encode4(2371386), // Rule ID 58929 //
     /* 2371348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371351 */     // (bitreverse:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rs1)  =>  (PseudoVBREV_V_MF4:{ *:[nxv2i8] } (IMPLICIT_DEF:{ *:[nxv2i8] }), VR:{ *:[nxv2i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s8,
     /* 2371354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF4),
     /* 2371368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371384 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371385 */     // GIR_Coverage, 58929,
     /* 2371385 */     GIR_EraseRootFromParent_Done,
     /* 2371386 */   // Label 33761: @2371386
     /* 2371386 */   GIM_Reject,
     /* 2371387 */ // Label 33759: @2371387
     /* 2371387 */ GIM_Reject,
     /* 2371388 */ // Label 33727: @2371388
     /* 2371388 */ GIM_Try, /*On fail goto*//*Label 33762*/ GIMT_Encode4(2371491),
     /* 2371393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2371396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371404 */   GIM_Try, /*On fail goto*//*Label 33763*/ GIMT_Encode4(2371447), // Rule ID 58934 //
     /* 2371409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371412 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2371415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371424 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371434 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371446 */     // GIR_Coverage, 58934,
     /* 2371446 */     GIR_EraseRootFromParent_Done,
     /* 2371447 */   // Label 33763: @2371447
     /* 2371447 */   GIM_Try, /*On fail goto*//*Label 33764*/ GIMT_Encode4(2371490), // Rule ID 58935 //
     /* 2371452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371455 */     // (bitreverse:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv2i16] } (IMPLICIT_DEF:{ *:[nxv2i16] }), VR:{ *:[nxv2i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2371458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371489 */     // GIR_Coverage, 58935,
     /* 2371489 */     GIR_EraseRootFromParent_Done,
     /* 2371490 */   // Label 33764: @2371490
     /* 2371490 */   GIM_Reject,
     /* 2371491 */ // Label 33762: @2371491
     /* 2371491 */ GIM_Reject,
     /* 2371492 */ // Label 33728: @2371492
     /* 2371492 */ GIM_Try, /*On fail goto*//*Label 33765*/ GIMT_Encode4(2371595),
     /* 2371497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2371500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371508 */   GIM_Try, /*On fail goto*//*Label 33766*/ GIMT_Encode4(2371551), // Rule ID 58942 //
     /* 2371513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371516 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2371519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371549 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371550 */     // GIR_Coverage, 58942,
     /* 2371550 */     GIR_EraseRootFromParent_Done,
     /* 2371551 */   // Label 33766: @2371551
     /* 2371551 */   GIM_Try, /*On fail goto*//*Label 33767*/ GIMT_Encode4(2371594), // Rule ID 58943 //
     /* 2371556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371559 */     // (bitreverse:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv2i32] } (IMPLICIT_DEF:{ *:[nxv2i32] }), VR:{ *:[nxv2i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2371562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371592 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371593 */     // GIR_Coverage, 58943,
     /* 2371593 */     GIR_EraseRootFromParent_Done,
     /* 2371594 */   // Label 33767: @2371594
     /* 2371594 */   GIM_Reject,
     /* 2371595 */ // Label 33765: @2371595
     /* 2371595 */ GIM_Reject,
     /* 2371596 */ // Label 33729: @2371596
     /* 2371596 */ GIM_Try, /*On fail goto*//*Label 33768*/ GIMT_Encode4(2371699),
     /* 2371601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2371604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371612 */   GIM_Try, /*On fail goto*//*Label 33769*/ GIMT_Encode4(2371655), // Rule ID 58964 //
     /* 2371617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2371620 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371620 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2371623 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371627 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2371637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371654 */     // GIR_Coverage, 58964,
     /* 2371654 */     GIR_EraseRootFromParent_Done,
     /* 2371655 */   // Label 33769: @2371655
     /* 2371655 */   GIM_Try, /*On fail goto*//*Label 33770*/ GIMT_Encode4(2371698), // Rule ID 58965 //
     /* 2371660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2371663 */     // (bitreverse:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv2i64] }), VRM2:{ *:[nxv2i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2371666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2371680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2371693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371696 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371697 */     // GIR_Coverage, 58965,
     /* 2371697 */     GIR_EraseRootFromParent_Done,
     /* 2371698 */   // Label 33770: @2371698
     /* 2371698 */   GIM_Reject,
     /* 2371699 */ // Label 33768: @2371699
     /* 2371699 */ GIM_Reject,
     /* 2371700 */ // Label 33730: @2371700
     /* 2371700 */ GIM_Try, /*On fail goto*//*Label 33771*/ GIMT_Encode4(2371803),
     /* 2371705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2371708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371716 */   GIM_Try, /*On fail goto*//*Label 33772*/ GIMT_Encode4(2371759), // Rule ID 58930 //
     /* 2371721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371724 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371736 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371758 */     // GIR_Coverage, 58930,
     /* 2371758 */     GIR_EraseRootFromParent_Done,
     /* 2371759 */   // Label 33772: @2371759
     /* 2371759 */   GIM_Try, /*On fail goto*//*Label 33773*/ GIMT_Encode4(2371802), // Rule ID 58931 //
     /* 2371764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371767 */     // (bitreverse:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rs1)  =>  (PseudoVBREV_V_MF2:{ *:[nxv4i8] } (IMPLICIT_DEF:{ *:[nxv4i8] }), VR:{ *:[nxv4i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s8,
     /* 2371770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_MF2),
     /* 2371784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371801 */     // GIR_Coverage, 58931,
     /* 2371801 */     GIR_EraseRootFromParent_Done,
     /* 2371802 */   // Label 33773: @2371802
     /* 2371802 */   GIM_Reject,
     /* 2371803 */ // Label 33771: @2371803
     /* 2371803 */ GIM_Reject,
     /* 2371804 */ // Label 33731: @2371804
     /* 2371804 */ GIM_Try, /*On fail goto*//*Label 33774*/ GIMT_Encode4(2371907),
     /* 2371809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2371812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2371820 */   GIM_Try, /*On fail goto*//*Label 33775*/ GIMT_Encode4(2371863), // Rule ID 58940 //
     /* 2371825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371828 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371862 */     // GIR_Coverage, 58940,
     /* 2371862 */     GIR_EraseRootFromParent_Done,
     /* 2371863 */   // Label 33775: @2371863
     /* 2371863 */   GIM_Try, /*On fail goto*//*Label 33776*/ GIMT_Encode4(2371906), // Rule ID 58941 //
     /* 2371868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371871 */     // (bitreverse:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv4i16] } (IMPLICIT_DEF:{ *:[nxv4i16] }), VR:{ *:[nxv4i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2371874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2371888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371893 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2371901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371905 */     // GIR_Coverage, 58941,
     /* 2371905 */     GIR_EraseRootFromParent_Done,
     /* 2371906 */   // Label 33776: @2371906
     /* 2371906 */   GIM_Reject,
     /* 2371907 */ // Label 33774: @2371907
     /* 2371907 */ GIM_Reject,
     /* 2371908 */ // Label 33732: @2371908
     /* 2371908 */ GIM_Try, /*On fail goto*//*Label 33777*/ GIMT_Encode4(2372011),
     /* 2371913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2371916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2371924 */   GIM_Try, /*On fail goto*//*Label 33778*/ GIMT_Encode4(2371967), // Rule ID 58958 //
     /* 2371929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2371932 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2371932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2371949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2371959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2371962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2371965 */     GIR_RootConstrainSelectedInstOperands,
     /* 2371966 */     // GIR_Coverage, 58958,
     /* 2371966 */     GIR_EraseRootFromParent_Done,
     /* 2371967 */   // Label 33778: @2371967
     /* 2371967 */   GIM_Try, /*On fail goto*//*Label 33779*/ GIMT_Encode4(2372010), // Rule ID 58959 //
     /* 2371972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2371975 */     // (bitreverse:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv4i32] }), VRM2:{ *:[nxv4i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2371975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2371978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2371982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2371987 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2371989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2371992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2371994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2371997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2371999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372009 */     // GIR_Coverage, 58959,
     /* 2372009 */     GIR_EraseRootFromParent_Done,
     /* 2372010 */   // Label 33779: @2372010
     /* 2372010 */   GIM_Reject,
     /* 2372011 */ // Label 33777: @2372011
     /* 2372011 */ GIM_Reject,
     /* 2372012 */ // Label 33733: @2372012
     /* 2372012 */ GIM_Try, /*On fail goto*//*Label 33780*/ GIMT_Encode4(2372115),
     /* 2372017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2372020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372028 */   GIM_Try, /*On fail goto*//*Label 33781*/ GIMT_Encode4(2372071), // Rule ID 58966 //
     /* 2372033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2372036 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2372039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372070 */     // GIR_Coverage, 58966,
     /* 2372070 */     GIR_EraseRootFromParent_Done,
     /* 2372071 */   // Label 33781: @2372071
     /* 2372071 */   GIM_Try, /*On fail goto*//*Label 33782*/ GIMT_Encode4(2372114), // Rule ID 58967 //
     /* 2372076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2372079 */     // (bitreverse:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv4i64] } (IMPLICIT_DEF:{ *:[nxv4i64] }), VRM4:{ *:[nxv4i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2372082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372101 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372113 */     // GIR_Coverage, 58967,
     /* 2372113 */     GIR_EraseRootFromParent_Done,
     /* 2372114 */   // Label 33782: @2372114
     /* 2372114 */   GIM_Reject,
     /* 2372115 */ // Label 33780: @2372115
     /* 2372115 */ GIM_Reject,
     /* 2372116 */ // Label 33734: @2372116
     /* 2372116 */ GIM_Try, /*On fail goto*//*Label 33783*/ GIMT_Encode4(2372219),
     /* 2372121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2372124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2372132 */   GIM_Try, /*On fail goto*//*Label 33784*/ GIMT_Encode4(2372175), // Rule ID 58938 //
     /* 2372137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372140 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2372143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2372157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372162 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372173 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372174 */     // GIR_Coverage, 58938,
     /* 2372174 */     GIR_EraseRootFromParent_Done,
     /* 2372175 */   // Label 33784: @2372175
     /* 2372175 */   GIM_Try, /*On fail goto*//*Label 33785*/ GIMT_Encode4(2372218), // Rule ID 58939 //
     /* 2372180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372183 */     // (bitreverse:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rs1)  =>  (PseudoVBREV_V_M1:{ *:[nxv8i8] } (IMPLICIT_DEF:{ *:[nxv8i8] }), VR:{ *:[nxv8i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s8,
     /* 2372186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372195 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M1),
     /* 2372200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372217 */     // GIR_Coverage, 58939,
     /* 2372217 */     GIR_EraseRootFromParent_Done,
     /* 2372218 */   // Label 33785: @2372218
     /* 2372218 */   GIM_Reject,
     /* 2372219 */ // Label 33783: @2372219
     /* 2372219 */ GIM_Reject,
     /* 2372220 */ // Label 33735: @2372220
     /* 2372220 */ GIM_Try, /*On fail goto*//*Label 33786*/ GIMT_Encode4(2372323),
     /* 2372225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2372228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372236 */   GIM_Try, /*On fail goto*//*Label 33787*/ GIMT_Encode4(2372279), // Rule ID 58952 //
     /* 2372241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372244 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2372247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2372261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372278 */     // GIR_Coverage, 58952,
     /* 2372278 */     GIR_EraseRootFromParent_Done,
     /* 2372279 */   // Label 33787: @2372279
     /* 2372279 */   GIM_Try, /*On fail goto*//*Label 33788*/ GIMT_Encode4(2372322), // Rule ID 58953 //
     /* 2372284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372287 */     // (bitreverse:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv8i16] }), VRM2:{ *:[nxv8i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2372290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2372304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372321 */     // GIR_Coverage, 58953,
     /* 2372321 */     GIR_EraseRootFromParent_Done,
     /* 2372322 */   // Label 33788: @2372322
     /* 2372322 */   GIM_Reject,
     /* 2372323 */ // Label 33786: @2372323
     /* 2372323 */ GIM_Reject,
     /* 2372324 */ // Label 33736: @2372324
     /* 2372324 */ GIM_Try, /*On fail goto*//*Label 33789*/ GIMT_Encode4(2372427),
     /* 2372329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2372332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372340 */   GIM_Try, /*On fail goto*//*Label 33790*/ GIMT_Encode4(2372383), // Rule ID 58960 //
     /* 2372345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372348 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2372351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372370 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372382 */     // GIR_Coverage, 58960,
     /* 2372382 */     GIR_EraseRootFromParent_Done,
     /* 2372383 */   // Label 33790: @2372383
     /* 2372383 */   GIM_Try, /*On fail goto*//*Label 33791*/ GIMT_Encode4(2372426), // Rule ID 58961 //
     /* 2372388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372391 */     // (bitreverse:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv8i32] } (IMPLICIT_DEF:{ *:[nxv8i32] }), VRM4:{ *:[nxv8i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372391 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2372394 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372398 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372403 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372424 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372425 */     // GIR_Coverage, 58961,
     /* 2372425 */     GIR_EraseRootFromParent_Done,
     /* 2372426 */   // Label 33791: @2372426
     /* 2372426 */   GIM_Reject,
     /* 2372427 */ // Label 33789: @2372427
     /* 2372427 */ GIM_Reject,
     /* 2372428 */ // Label 33737: @2372428
     /* 2372428 */ GIM_Try, /*On fail goto*//*Label 33792*/ GIMT_Encode4(2372531),
     /* 2372433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2372436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372444 */   GIM_Try, /*On fail goto*//*Label 33793*/ GIMT_Encode4(2372487), // Rule ID 58968 //
     /* 2372449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode0),
     /* 2372452 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2372455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2372469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372474 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372486 */     // GIR_Coverage, 58968,
     /* 2372486 */     GIR_EraseRootFromParent_Done,
     /* 2372487 */   // Label 33793: @2372487
     /* 2372487 */   GIM_Try, /*On fail goto*//*Label 33794*/ GIMT_Encode4(2372530), // Rule ID 58969 //
     /* 2372492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructionsI64_HwMode1),
     /* 2372495 */     // (bitreverse:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv8i64] } (IMPLICIT_DEF:{ *:[nxv8i64] }), VRM8:{ *:[nxv8i64] }:$rs1, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372495 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2372498 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372502 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2372512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372519 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2372525 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372528 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372529 */     // GIR_Coverage, 58969,
     /* 2372529 */     GIR_EraseRootFromParent_Done,
     /* 2372530 */   // Label 33794: @2372530
     /* 2372530 */   GIM_Reject,
     /* 2372531 */ // Label 33792: @2372531
     /* 2372531 */ GIM_Reject,
     /* 2372532 */ // Label 33738: @2372532
     /* 2372532 */ GIM_Try, /*On fail goto*//*Label 33795*/ GIMT_Encode4(2372635),
     /* 2372537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2372540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372544 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2372548 */   GIM_Try, /*On fail goto*//*Label 33796*/ GIMT_Encode4(2372591), // Rule ID 58946 //
     /* 2372553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372556 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2372559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2372573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372590 */     // GIR_Coverage, 58946,
     /* 2372590 */     GIR_EraseRootFromParent_Done,
     /* 2372591 */   // Label 33796: @2372591
     /* 2372591 */   GIM_Try, /*On fail goto*//*Label 33797*/ GIMT_Encode4(2372634), // Rule ID 58947 //
     /* 2372596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372599 */     // (bitreverse:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rs1)  =>  (PseudoVBREV_V_M2:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), VRM2:{ *:[nxv16i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 2372602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M2),
     /* 2372616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372633 */     // GIR_Coverage, 58947,
     /* 2372633 */     GIR_EraseRootFromParent_Done,
     /* 2372634 */   // Label 33797: @2372634
     /* 2372634 */   GIM_Reject,
     /* 2372635 */ // Label 33795: @2372635
     /* 2372635 */ GIM_Reject,
     /* 2372636 */ // Label 33739: @2372636
     /* 2372636 */ GIM_Try, /*On fail goto*//*Label 33798*/ GIMT_Encode4(2372739),
     /* 2372641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2372644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372652 */   GIM_Try, /*On fail goto*//*Label 33799*/ GIMT_Encode4(2372695), // Rule ID 58954 //
     /* 2372657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372660 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2372663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372693 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372694 */     // GIR_Coverage, 58954,
     /* 2372694 */     GIR_EraseRootFromParent_Done,
     /* 2372695 */   // Label 33799: @2372695
     /* 2372695 */   GIM_Try, /*On fail goto*//*Label 33800*/ GIMT_Encode4(2372738), // Rule ID 58955 //
     /* 2372700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372703 */     // (bitreverse:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv16i16] } (IMPLICIT_DEF:{ *:[nxv16i16] }), VRM4:{ *:[nxv16i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2372706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372722 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2372733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372736 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372737 */     // GIR_Coverage, 58955,
     /* 2372737 */     GIR_EraseRootFromParent_Done,
     /* 2372738 */   // Label 33800: @2372738
     /* 2372738 */   GIM_Reject,
     /* 2372739 */ // Label 33798: @2372739
     /* 2372739 */ GIM_Reject,
     /* 2372740 */ // Label 33740: @2372740
     /* 2372740 */ GIM_Try, /*On fail goto*//*Label 33801*/ GIMT_Encode4(2372843),
     /* 2372745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2372748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372756 */   GIM_Try, /*On fail goto*//*Label 33802*/ GIMT_Encode4(2372799), // Rule ID 58962 //
     /* 2372761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372764 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372764 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372767 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372771 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2372781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372798 */     // GIR_Coverage, 58962,
     /* 2372798 */     GIR_EraseRootFromParent_Done,
     /* 2372799 */   // Label 33802: @2372799
     /* 2372799 */   GIM_Try, /*On fail goto*//*Label 33803*/ GIMT_Encode4(2372842), // Rule ID 58963 //
     /* 2372804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372807 */     // (bitreverse:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv16i32] } (IMPLICIT_DEF:{ *:[nxv16i32] }), VRM8:{ *:[nxv16i32] }:$rs1, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2372810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2372824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372829 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2372837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372840 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372841 */     // GIR_Coverage, 58963,
     /* 2372841 */     GIR_EraseRootFromParent_Done,
     /* 2372842 */   // Label 33803: @2372842
     /* 2372842 */   GIM_Reject,
     /* 2372843 */ // Label 33801: @2372843
     /* 2372843 */ GIM_Reject,
     /* 2372844 */ // Label 33741: @2372844
     /* 2372844 */ GIM_Try, /*On fail goto*//*Label 33804*/ GIMT_Encode4(2372947),
     /* 2372849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2372852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2372860 */   GIM_Try, /*On fail goto*//*Label 33805*/ GIMT_Encode4(2372903), // Rule ID 58948 //
     /* 2372865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372868 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372868 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372871 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372875 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372890 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372901 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372902 */     // GIR_Coverage, 58948,
     /* 2372902 */     GIR_EraseRootFromParent_Done,
     /* 2372903 */   // Label 33805: @2372903
     /* 2372903 */   GIM_Try, /*On fail goto*//*Label 33806*/ GIMT_Encode4(2372946), // Rule ID 58949 //
     /* 2372908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2372911 */     // (bitreverse:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rs1)  =>  (PseudoVBREV_V_M4:{ *:[nxv32i8] } (IMPLICIT_DEF:{ *:[nxv32i8] }), VRM4:{ *:[nxv32i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2372911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s8,
     /* 2372914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M4),
     /* 2372928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2372944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2372945 */     // GIR_Coverage, 58949,
     /* 2372945 */     GIR_EraseRootFromParent_Done,
     /* 2372946 */   // Label 33806: @2372946
     /* 2372946 */   GIM_Reject,
     /* 2372947 */ // Label 33804: @2372947
     /* 2372947 */ GIM_Reject,
     /* 2372948 */ // Label 33742: @2372948
     /* 2372948 */ GIM_Try, /*On fail goto*//*Label 33807*/ GIMT_Encode4(2373051),
     /* 2372953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2372956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2372964 */   GIM_Try, /*On fail goto*//*Label 33808*/ GIMT_Encode4(2373007), // Rule ID 58956 //
     /* 2372969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2372972 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2372972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2372975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2372979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2372984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2372986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2372989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2372991 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2372994 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2372996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2372999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373006 */     // GIR_Coverage, 58956,
     /* 2373006 */     GIR_EraseRootFromParent_Done,
     /* 2373007 */   // Label 33808: @2373007
     /* 2373007 */   GIM_Try, /*On fail goto*//*Label 33809*/ GIMT_Encode4(2373050), // Rule ID 58957 //
     /* 2373012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2373015 */     // (bitreverse:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv32i16] } (IMPLICIT_DEF:{ *:[nxv32i16] }), VRM8:{ *:[nxv32i16] }:$rs1, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2373018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373027 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2373032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373049 */     // GIR_Coverage, 58957,
     /* 2373049 */     GIR_EraseRootFromParent_Done,
     /* 2373050 */   // Label 33809: @2373050
     /* 2373050 */   GIM_Reject,
     /* 2373051 */ // Label 33807: @2373051
     /* 2373051 */ GIM_Reject,
     /* 2373052 */ // Label 33743: @2373052
     /* 2373052 */ GIM_Try, /*On fail goto*//*Label 33810*/ GIMT_Encode4(2373155),
     /* 2373057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2373060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2373068 */   GIM_Try, /*On fail goto*//*Label 33811*/ GIMT_Encode4(2373111), // Rule ID 58950 //
     /* 2373073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode0),
     /* 2373076 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i64] }, 3:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2373079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2373093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373109 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373110 */     // GIR_Coverage, 58950,
     /* 2373110 */     GIR_EraseRootFromParent_Done,
     /* 2373111 */   // Label 33811: @2373111
     /* 2373111 */   GIM_Try, /*On fail goto*//*Label 33812*/ GIMT_Encode4(2373154), // Rule ID 58951 //
     /* 2373116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZvbb_HasVInstructions_HwMode1),
     /* 2373119 */     // (bitreverse:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rs1)  =>  (PseudoVBREV_V_M8:{ *:[nxv64i8] } (IMPLICIT_DEF:{ *:[nxv64i8] }), VRM8:{ *:[nxv64i8] }:$rs1, -1:{ *:[i32] }, 3:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv64s8,
     /* 2373122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVBREV_V_M8),
     /* 2373136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373152 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373153 */     // GIR_Coverage, 58951,
     /* 2373153 */     GIR_EraseRootFromParent_Done,
     /* 2373154 */   // Label 33812: @2373154
     /* 2373154 */   GIM_Reject,
     /* 2373155 */ // Label 33810: @2373155
     /* 2373155 */ GIM_Reject,
     /* 2373156 */ // Label 33744: @2373156
     /* 2373156 */ GIM_Reject,
     /* 2373157 */ // Label 93: @2373157
     /* 2373157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33816*/ GIMT_Encode4(2373354),
     /* 2373168 */ /*GILLT_s16*//*Label 33813*/ GIMT_Encode4(2373180),
     /* 2373172 */ /*GILLT_s32*//*Label 33814*/ GIMT_Encode4(2373238),
     /* 2373176 */ /*GILLT_s64*//*Label 33815*/ GIMT_Encode4(2373296),
     /* 2373180 */ // Label 33813: @2373180
     /* 2373180 */ GIM_Try, /*On fail goto*//*Label 33817*/ GIMT_Encode4(2373237),
     /* 2373185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2373188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373196 */   GIM_Try, /*On fail goto*//*Label 33818*/ GIMT_Encode4(2373216), // Rule ID 2322 //
     /* 2373201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2373204 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i64] })
     /* 2373204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2373207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373214 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373215 */     // GIR_Coverage, 2322,
     /* 2373215 */     GIR_EraseRootFromParent_Done,
     /* 2373216 */   // Label 33818: @2373216
     /* 2373216 */   GIM_Try, /*On fail goto*//*Label 33819*/ GIMT_Encode4(2373236), // Rule ID 2323 //
     /* 2373221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2373224 */     // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 3:{ *:[i32] })
     /* 2373224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2373227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373235 */     // GIR_Coverage, 2323,
     /* 2373235 */     GIR_EraseRootFromParent_Done,
     /* 2373236 */   // Label 33819: @2373236
     /* 2373236 */   GIM_Reject,
     /* 2373237 */ // Label 33817: @2373237
     /* 2373237 */ GIM_Reject,
     /* 2373238 */ // Label 33814: @2373238
     /* 2373238 */ GIM_Try, /*On fail goto*//*Label 33820*/ GIMT_Encode4(2373295),
     /* 2373243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2373246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373250 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373254 */   GIM_Try, /*On fail goto*//*Label 33821*/ GIMT_Encode4(2373274), // Rule ID 2240 //
     /* 2373259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2373262 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i64] })
     /* 2373262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2373265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373273 */     // GIR_Coverage, 2240,
     /* 2373273 */     GIR_EraseRootFromParent_Done,
     /* 2373274 */   // Label 33821: @2373274
     /* 2373274 */   GIM_Try, /*On fail goto*//*Label 33822*/ GIMT_Encode4(2373294), // Rule ID 2241 //
     /* 2373279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2373282 */     // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 3:{ *:[i32] })
     /* 2373282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2373285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373287 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373292 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373293 */     // GIR_Coverage, 2241,
     /* 2373293 */     GIR_EraseRootFromParent_Done,
     /* 2373294 */   // Label 33822: @2373294
     /* 2373294 */   GIM_Reject,
     /* 2373295 */ // Label 33820: @2373295
     /* 2373295 */ GIM_Reject,
     /* 2373296 */ // Label 33815: @2373296
     /* 2373296 */ GIM_Try, /*On fail goto*//*Label 33823*/ GIMT_Encode4(2373353),
     /* 2373301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2373304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373308 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373312 */   GIM_Try, /*On fail goto*//*Label 33824*/ GIMT_Encode4(2373332), // Rule ID 2280 //
     /* 2373317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2373320 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i64] })
     /* 2373320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2373323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373330 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373331 */     // GIR_Coverage, 2280,
     /* 2373331 */     GIR_EraseRootFromParent_Done,
     /* 2373332 */   // Label 33824: @2373332
     /* 2373332 */   GIM_Try, /*On fail goto*//*Label 33825*/ GIMT_Encode4(2373352), // Rule ID 2281 //
     /* 2373337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2373340 */     // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 3:{ *:[i32] })
     /* 2373340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2373343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373345 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373351 */     // GIR_Coverage, 2281,
     /* 2373351 */     GIR_EraseRootFromParent_Done,
     /* 2373352 */   // Label 33825: @2373352
     /* 2373352 */   GIM_Reject,
     /* 2373353 */ // Label 33823: @2373353
     /* 2373353 */ GIM_Reject,
     /* 2373354 */ // Label 33816: @2373354
     /* 2373354 */ GIM_Reject,
     /* 2373355 */ // Label 94: @2373355
     /* 2373355 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33844*/ GIMT_Encode4(2375530),
     /* 2373366 */ /*GILLT_s16*//*Label 33826*/ GIMT_Encode4(2373486),
     /* 2373370 */ /*GILLT_s32*//*Label 33827*/ GIMT_Encode4(2373608),
     /* 2373374 */ /*GILLT_s64*//*Label 33828*/ GIMT_Encode4(2373730), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373386 */ /*GILLT_nxv1s16*//*Label 33829*/ GIMT_Encode4(2373880),
     /* 2373390 */ /*GILLT_nxv1s32*//*Label 33830*/ GIMT_Encode4(2373990),
     /* 2373394 */ /*GILLT_nxv1s64*//*Label 33831*/ GIMT_Encode4(2374100), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373406 */ /*GILLT_nxv2s16*//*Label 33832*/ GIMT_Encode4(2374210),
     /* 2373410 */ /*GILLT_nxv2s32*//*Label 33833*/ GIMT_Encode4(2374320),
     /* 2373414 */ /*GILLT_nxv2s64*//*Label 33834*/ GIMT_Encode4(2374430), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373426 */ /*GILLT_nxv4s16*//*Label 33835*/ GIMT_Encode4(2374540),
     /* 2373430 */ /*GILLT_nxv4s32*//*Label 33836*/ GIMT_Encode4(2374650),
     /* 2373434 */ /*GILLT_nxv4s64*//*Label 33837*/ GIMT_Encode4(2374760), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373446 */ /*GILLT_nxv8s16*//*Label 33838*/ GIMT_Encode4(2374870),
     /* 2373450 */ /*GILLT_nxv8s32*//*Label 33839*/ GIMT_Encode4(2374980),
     /* 2373454 */ /*GILLT_nxv8s64*//*Label 33840*/ GIMT_Encode4(2375090), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373466 */ /*GILLT_nxv16s16*//*Label 33841*/ GIMT_Encode4(2375200),
     /* 2373470 */ /*GILLT_nxv16s32*//*Label 33842*/ GIMT_Encode4(2375310), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2373482 */ /*GILLT_nxv32s16*//*Label 33843*/ GIMT_Encode4(2375420),
     /* 2373486 */ // Label 33826: @2373486
     /* 2373486 */ GIM_Try, /*On fail goto*//*Label 33845*/ GIMT_Encode4(2373607),
     /* 2373491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2373494 */   GIM_Try, /*On fail goto*//*Label 33846*/ GIMT_Encode4(2373522), // Rule ID 1880 //
     /* 2373499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2373502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373510 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2373510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2373513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373515 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373520 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373521 */     // GIR_Coverage, 1880,
     /* 2373521 */     GIR_EraseRootFromParent_Done,
     /* 2373522 */   // Label 33846: @2373522
     /* 2373522 */   GIM_Try, /*On fail goto*//*Label 33847*/ GIMT_Encode4(2373550), // Rule ID 1881 //
     /* 2373527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2373530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2373538 */     // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2373538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2373541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373549 */     // GIR_Coverage, 1881,
     /* 2373549 */     GIR_EraseRootFromParent_Done,
     /* 2373550 */   // Label 33847: @2373550
     /* 2373550 */   GIM_Try, /*On fail goto*//*Label 33848*/ GIMT_Encode4(2373578), // Rule ID 1913 //
     /* 2373555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2373558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2373562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2373566 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2373566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2373569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373571 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373576 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373577 */     // GIR_Coverage, 1913,
     /* 2373577 */     GIR_EraseRootFromParent_Done,
     /* 2373578 */   // Label 33848: @2373578
     /* 2373578 */   GIM_Try, /*On fail goto*//*Label 33849*/ GIMT_Encode4(2373606), // Rule ID 1914 //
     /* 2373583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2373586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2373590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2373594 */     // (fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2373594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2373597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373604 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373605 */     // GIR_Coverage, 1914,
     /* 2373605 */     GIR_EraseRootFromParent_Done,
     /* 2373606 */   // Label 33849: @2373606
     /* 2373606 */   GIM_Reject,
     /* 2373607 */ // Label 33845: @2373607
     /* 2373607 */ GIM_Reject,
     /* 2373608 */ // Label 33827: @2373608
     /* 2373608 */ GIM_Try, /*On fail goto*//*Label 33850*/ GIMT_Encode4(2373729),
     /* 2373613 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2373616 */   GIM_Try, /*On fail goto*//*Label 33851*/ GIMT_Encode4(2373644), // Rule ID 1171 //
     /* 2373621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2373624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373632 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2373632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2373635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373643 */     // GIR_Coverage, 1171,
     /* 2373643 */     GIR_EraseRootFromParent_Done,
     /* 2373644 */   // Label 33851: @2373644
     /* 2373644 */   GIM_Try, /*On fail goto*//*Label 33852*/ GIMT_Encode4(2373672), // Rule ID 1172 //
     /* 2373649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2373652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2373660 */     // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2373660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2373663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373671 */     // GIR_Coverage, 1172,
     /* 2373671 */     GIR_EraseRootFromParent_Done,
     /* 2373672 */   // Label 33852: @2373672
     /* 2373672 */   GIM_Try, /*On fail goto*//*Label 33853*/ GIMT_Encode4(2373700), // Rule ID 1179 //
     /* 2373677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2373680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2373684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2373688 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2373688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2373691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373698 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373699 */     // GIR_Coverage, 1179,
     /* 2373699 */     GIR_EraseRootFromParent_Done,
     /* 2373700 */   // Label 33853: @2373700
     /* 2373700 */   GIM_Try, /*On fail goto*//*Label 33854*/ GIMT_Encode4(2373728), // Rule ID 1180 //
     /* 2373705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2373708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2373712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2373716 */     // (fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2373716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2373719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373726 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373727 */     // GIR_Coverage, 1180,
     /* 2373727 */     GIR_EraseRootFromParent_Done,
     /* 2373728 */   // Label 33854: @2373728
     /* 2373728 */   GIM_Reject,
     /* 2373729 */ // Label 33850: @2373729
     /* 2373729 */ GIM_Reject,
     /* 2373730 */ // Label 33828: @2373730
     /* 2373730 */ GIM_Try, /*On fail goto*//*Label 33855*/ GIMT_Encode4(2373879),
     /* 2373735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2373738 */   GIM_Try, /*On fail goto*//*Label 33856*/ GIMT_Encode4(2373766), // Rule ID 1514 //
     /* 2373743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2373746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373754 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2373754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2373757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373764 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373765 */     // GIR_Coverage, 1514,
     /* 2373765 */     GIR_EraseRootFromParent_Done,
     /* 2373766 */   // Label 33856: @2373766
     /* 2373766 */   GIM_Try, /*On fail goto*//*Label 33857*/ GIMT_Encode4(2373794), // Rule ID 1515 //
     /* 2373771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2373774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2373782 */     // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2373782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2373785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373793 */     // GIR_Coverage, 1515,
     /* 2373793 */     GIR_EraseRootFromParent_Done,
     /* 2373794 */   // Label 33857: @2373794
     /* 2373794 */   GIM_Try, /*On fail goto*//*Label 33858*/ GIMT_Encode4(2373822), // Rule ID 1548 //
     /* 2373799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2373802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2373806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2373810 */     // (fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2373810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2373813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373821 */     // GIR_Coverage, 1548,
     /* 2373821 */     GIR_EraseRootFromParent_Done,
     /* 2373822 */   // Label 33858: @2373822
     /* 2373822 */   GIM_Try, /*On fail goto*//*Label 33859*/ GIMT_Encode4(2373850), // Rule ID 1569 //
     /* 2373827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2373830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2373834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2373838 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2373838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2373841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373849 */     // GIR_Coverage, 1569,
     /* 2373849 */     GIR_EraseRootFromParent_Done,
     /* 2373850 */   // Label 33859: @2373850
     /* 2373850 */   GIM_Try, /*On fail goto*//*Label 33860*/ GIMT_Encode4(2373878), // Rule ID 1570 //
     /* 2373855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2373858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2373862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2373866 */     // (fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2373866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2373869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2373873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373877 */     // GIR_Coverage, 1570,
     /* 2373877 */     GIR_EraseRootFromParent_Done,
     /* 2373878 */   // Label 33860: @2373878
     /* 2373878 */   GIM_Reject,
     /* 2373879 */ // Label 33855: @2373879
     /* 2373879 */ GIM_Reject,
     /* 2373880 */ // Label 33829: @2373880
     /* 2373880 */ GIM_Try, /*On fail goto*//*Label 33861*/ GIMT_Encode4(2373989),
     /* 2373885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2373888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2373896 */   GIM_Try, /*On fail goto*//*Label 33862*/ GIMT_Encode4(2373942), // Rule ID 56112 //
     /* 2373901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2373904 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2373904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2373907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2373921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373926 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2373928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373940 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373941 */     // GIR_Coverage, 56112,
     /* 2373941 */     GIR_EraseRootFromParent_Done,
     /* 2373942 */   // Label 33862: @2373942
     /* 2373942 */   GIM_Try, /*On fail goto*//*Label 33863*/ GIMT_Encode4(2373988), // Rule ID 56113 //
     /* 2373947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2373950 */     // (fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2373950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2373953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2373957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2373962 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2373964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2373967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2373969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2373972 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2373974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2373977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2373980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2373983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2373986 */     GIR_RootConstrainSelectedInstOperands,
     /* 2373987 */     // GIR_Coverage, 56113,
     /* 2373987 */     GIR_EraseRootFromParent_Done,
     /* 2373988 */   // Label 33863: @2373988
     /* 2373988 */   GIM_Reject,
     /* 2373989 */ // Label 33861: @2373989
     /* 2373989 */ GIM_Reject,
     /* 2373990 */ // Label 33830: @2373990
     /* 2373990 */ GIM_Try, /*On fail goto*//*Label 33864*/ GIMT_Encode4(2374099),
     /* 2373995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2373998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374006 */   GIM_Try, /*On fail goto*//*Label 33865*/ GIMT_Encode4(2374052), // Rule ID 56152 //
     /* 2374011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2374014 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2374017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2374031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374051 */     // GIR_Coverage, 56152,
     /* 2374051 */     GIR_EraseRootFromParent_Done,
     /* 2374052 */   // Label 33865: @2374052
     /* 2374052 */   GIM_Try, /*On fail goto*//*Label 33866*/ GIMT_Encode4(2374098), // Rule ID 56153 //
     /* 2374057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2374060 */     // (fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2374063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2374077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374082 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374097 */     // GIR_Coverage, 56153,
     /* 2374097 */     GIR_EraseRootFromParent_Done,
     /* 2374098 */   // Label 33866: @2374098
     /* 2374098 */   GIM_Reject,
     /* 2374099 */ // Label 33864: @2374099
     /* 2374099 */ GIM_Reject,
     /* 2374100 */ // Label 33831: @2374100
     /* 2374100 */ GIM_Try, /*On fail goto*//*Label 33867*/ GIMT_Encode4(2374209),
     /* 2374105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2374108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374116 */   GIM_Try, /*On fail goto*//*Label 33868*/ GIMT_Encode4(2374162), // Rule ID 56212 //
     /* 2374121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2374124 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2374127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2374141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374160 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374161 */     // GIR_Coverage, 56212,
     /* 2374161 */     GIR_EraseRootFromParent_Done,
     /* 2374162 */   // Label 33868: @2374162
     /* 2374162 */   GIM_Try, /*On fail goto*//*Label 33869*/ GIMT_Encode4(2374208), // Rule ID 56213 //
     /* 2374167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2374170 */     // (fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2374173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2374187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374192 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374206 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374207 */     // GIR_Coverage, 56213,
     /* 2374207 */     GIR_EraseRootFromParent_Done,
     /* 2374208 */   // Label 33869: @2374208
     /* 2374208 */   GIM_Reject,
     /* 2374209 */ // Label 33867: @2374209
     /* 2374209 */ GIM_Reject,
     /* 2374210 */ // Label 33832: @2374210
     /* 2374210 */ GIM_Try, /*On fail goto*//*Label 33870*/ GIMT_Encode4(2374319),
     /* 2374215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2374218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374226 */   GIM_Try, /*On fail goto*//*Label 33871*/ GIMT_Encode4(2374272), // Rule ID 56132 //
     /* 2374231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2374234 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2374237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2374251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374270 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374271 */     // GIR_Coverage, 56132,
     /* 2374271 */     GIR_EraseRootFromParent_Done,
     /* 2374272 */   // Label 33871: @2374272
     /* 2374272 */   GIM_Try, /*On fail goto*//*Label 33872*/ GIMT_Encode4(2374318), // Rule ID 56133 //
     /* 2374277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2374280 */     // (fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374280 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2374283 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374287 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2374297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374316 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374317 */     // GIR_Coverage, 56133,
     /* 2374317 */     GIR_EraseRootFromParent_Done,
     /* 2374318 */   // Label 33872: @2374318
     /* 2374318 */   GIM_Reject,
     /* 2374319 */ // Label 33870: @2374319
     /* 2374319 */ GIM_Reject,
     /* 2374320 */ // Label 33833: @2374320
     /* 2374320 */ GIM_Try, /*On fail goto*//*Label 33873*/ GIMT_Encode4(2374429),
     /* 2374325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2374328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374336 */   GIM_Try, /*On fail goto*//*Label 33874*/ GIMT_Encode4(2374382), // Rule ID 56192 //
     /* 2374341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2374344 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2374347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2374361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374366 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374381 */     // GIR_Coverage, 56192,
     /* 2374381 */     GIR_EraseRootFromParent_Done,
     /* 2374382 */   // Label 33874: @2374382
     /* 2374382 */   GIM_Try, /*On fail goto*//*Label 33875*/ GIMT_Encode4(2374428), // Rule ID 56193 //
     /* 2374387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2374390 */     // (fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2374393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2374407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374412 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374427 */     // GIR_Coverage, 56193,
     /* 2374427 */     GIR_EraseRootFromParent_Done,
     /* 2374428 */   // Label 33875: @2374428
     /* 2374428 */   GIM_Reject,
     /* 2374429 */ // Label 33873: @2374429
     /* 2374429 */ GIM_Reject,
     /* 2374430 */ // Label 33834: @2374430
     /* 2374430 */ GIM_Try, /*On fail goto*//*Label 33876*/ GIMT_Encode4(2374539),
     /* 2374435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2374438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374446 */   GIM_Try, /*On fail goto*//*Label 33877*/ GIMT_Encode4(2374492), // Rule ID 56352 //
     /* 2374451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2374454 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2374457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2374471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374491 */     // GIR_Coverage, 56352,
     /* 2374491 */     GIR_EraseRootFromParent_Done,
     /* 2374492 */   // Label 33877: @2374492
     /* 2374492 */   GIM_Try, /*On fail goto*//*Label 33878*/ GIMT_Encode4(2374538), // Rule ID 56353 //
     /* 2374497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2374500 */     // (fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2374503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2374517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374536 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374537 */     // GIR_Coverage, 56353,
     /* 2374537 */     GIR_EraseRootFromParent_Done,
     /* 2374538 */   // Label 33878: @2374538
     /* 2374538 */   GIM_Reject,
     /* 2374539 */ // Label 33876: @2374539
     /* 2374539 */ GIM_Reject,
     /* 2374540 */ // Label 33835: @2374540
     /* 2374540 */ GIM_Try, /*On fail goto*//*Label 33879*/ GIMT_Encode4(2374649),
     /* 2374545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2374548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2374556 */   GIM_Try, /*On fail goto*//*Label 33880*/ GIMT_Encode4(2374602), // Rule ID 56172 //
     /* 2374561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2374564 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2374567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2374581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374600 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374601 */     // GIR_Coverage, 56172,
     /* 2374601 */     GIR_EraseRootFromParent_Done,
     /* 2374602 */   // Label 33880: @2374602
     /* 2374602 */   GIM_Try, /*On fail goto*//*Label 33881*/ GIMT_Encode4(2374648), // Rule ID 56173 //
     /* 2374607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2374610 */     // (fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2374613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2374627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374632 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374647 */     // GIR_Coverage, 56173,
     /* 2374647 */     GIR_EraseRootFromParent_Done,
     /* 2374648 */   // Label 33881: @2374648
     /* 2374648 */   GIM_Reject,
     /* 2374649 */ // Label 33879: @2374649
     /* 2374649 */ GIM_Reject,
     /* 2374650 */ // Label 33836: @2374650
     /* 2374650 */ GIM_Try, /*On fail goto*//*Label 33882*/ GIMT_Encode4(2374759),
     /* 2374655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2374658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374666 */   GIM_Try, /*On fail goto*//*Label 33883*/ GIMT_Encode4(2374712), // Rule ID 56292 //
     /* 2374671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2374674 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2374677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2374691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374696 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374711 */     // GIR_Coverage, 56292,
     /* 2374711 */     GIR_EraseRootFromParent_Done,
     /* 2374712 */   // Label 33883: @2374712
     /* 2374712 */   GIM_Try, /*On fail goto*//*Label 33884*/ GIMT_Encode4(2374758), // Rule ID 56293 //
     /* 2374717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2374720 */     // (fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374720 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2374723 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374727 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2374737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2374753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374757 */     // GIR_Coverage, 56293,
     /* 2374757 */     GIR_EraseRootFromParent_Done,
     /* 2374758 */   // Label 33884: @2374758
     /* 2374758 */   GIM_Reject,
     /* 2374759 */ // Label 33882: @2374759
     /* 2374759 */ GIM_Reject,
     /* 2374760 */ // Label 33837: @2374760
     /* 2374760 */ GIM_Try, /*On fail goto*//*Label 33885*/ GIMT_Encode4(2374869),
     /* 2374765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2374768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374776 */   GIM_Try, /*On fail goto*//*Label 33886*/ GIMT_Encode4(2374822), // Rule ID 56372 //
     /* 2374781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2374784 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2374801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374820 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374821 */     // GIR_Coverage, 56372,
     /* 2374821 */     GIR_EraseRootFromParent_Done,
     /* 2374822 */   // Label 33886: @2374822
     /* 2374822 */   GIM_Try, /*On fail goto*//*Label 33887*/ GIMT_Encode4(2374868), // Rule ID 56373 //
     /* 2374827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2374830 */     // (fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2374833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2374847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2374863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374866 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374867 */     // GIR_Coverage, 56373,
     /* 2374867 */     GIR_EraseRootFromParent_Done,
     /* 2374868 */   // Label 33887: @2374868
     /* 2374868 */   GIM_Reject,
     /* 2374869 */ // Label 33885: @2374869
     /* 2374869 */ GIM_Reject,
     /* 2374870 */ // Label 33838: @2374870
     /* 2374870 */ GIM_Try, /*On fail goto*//*Label 33888*/ GIMT_Encode4(2374979),
     /* 2374875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2374878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2374886 */   GIM_Try, /*On fail goto*//*Label 33889*/ GIMT_Encode4(2374932), // Rule ID 56232 //
     /* 2374891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2374894 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2374894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2374911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374930 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374931 */     // GIR_Coverage, 56232,
     /* 2374931 */     GIR_EraseRootFromParent_Done,
     /* 2374932 */   // Label 33889: @2374932
     /* 2374932 */   GIM_Try, /*On fail goto*//*Label 33890*/ GIMT_Encode4(2374978), // Rule ID 56233 //
     /* 2374937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2374940 */     // (fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2374940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2374943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2374947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2374952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2374954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2374957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2374959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2374962 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2374964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2374967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2374970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2374973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2374976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2374977 */     // GIR_Coverage, 56233,
     /* 2374977 */     GIR_EraseRootFromParent_Done,
     /* 2374978 */   // Label 33890: @2374978
     /* 2374978 */   GIM_Reject,
     /* 2374979 */ // Label 33888: @2374979
     /* 2374979 */ GIM_Reject,
     /* 2374980 */ // Label 33839: @2374980
     /* 2374980 */ GIM_Try, /*On fail goto*//*Label 33891*/ GIMT_Encode4(2375089),
     /* 2374985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2374988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2374996 */   GIM_Try, /*On fail goto*//*Label 33892*/ GIMT_Encode4(2375042), // Rule ID 56312 //
     /* 2375001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2375004 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2375007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375016 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2375021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375026 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375040 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375041 */     // GIR_Coverage, 56312,
     /* 2375041 */     GIR_EraseRootFromParent_Done,
     /* 2375042 */   // Label 33892: @2375042
     /* 2375042 */   GIM_Try, /*On fail goto*//*Label 33893*/ GIMT_Encode4(2375088), // Rule ID 56313 //
     /* 2375047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2375050 */     // (fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2375053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2375067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375072 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375086 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375087 */     // GIR_Coverage, 56313,
     /* 2375087 */     GIR_EraseRootFromParent_Done,
     /* 2375088 */   // Label 33893: @2375088
     /* 2375088 */   GIM_Reject,
     /* 2375089 */ // Label 33891: @2375089
     /* 2375089 */ GIM_Reject,
     /* 2375090 */ // Label 33840: @2375090
     /* 2375090 */ GIM_Try, /*On fail goto*//*Label 33894*/ GIMT_Encode4(2375199),
     /* 2375095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2375098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375106 */   GIM_Try, /*On fail goto*//*Label 33895*/ GIMT_Encode4(2375152), // Rule ID 56392 //
     /* 2375111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2375114 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2375117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2375131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375150 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375151 */     // GIR_Coverage, 56392,
     /* 2375151 */     GIR_EraseRootFromParent_Done,
     /* 2375152 */   // Label 33895: @2375152
     /* 2375152 */   GIM_Try, /*On fail goto*//*Label 33896*/ GIMT_Encode4(2375198), // Rule ID 56393 //
     /* 2375157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2375160 */     // (fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375160 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2375163 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375167 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2375177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2375193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375197 */     // GIR_Coverage, 56393,
     /* 2375197 */     GIR_EraseRootFromParent_Done,
     /* 2375198 */   // Label 33896: @2375198
     /* 2375198 */   GIM_Reject,
     /* 2375199 */ // Label 33894: @2375199
     /* 2375199 */ GIM_Reject,
     /* 2375200 */ // Label 33841: @2375200
     /* 2375200 */ GIM_Try, /*On fail goto*//*Label 33897*/ GIMT_Encode4(2375309),
     /* 2375205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2375208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2375216 */   GIM_Try, /*On fail goto*//*Label 33898*/ GIMT_Encode4(2375262), // Rule ID 56252 //
     /* 2375221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2375224 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2375227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2375241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375246 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375260 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375261 */     // GIR_Coverage, 56252,
     /* 2375261 */     GIR_EraseRootFromParent_Done,
     /* 2375262 */   // Label 33898: @2375262
     /* 2375262 */   GIM_Try, /*On fail goto*//*Label 33899*/ GIMT_Encode4(2375308), // Rule ID 56253 //
     /* 2375267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2375270 */     // (fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2375273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2375287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375307 */     // GIR_Coverage, 56253,
     /* 2375307 */     GIR_EraseRootFromParent_Done,
     /* 2375308 */   // Label 33899: @2375308
     /* 2375308 */   GIM_Reject,
     /* 2375309 */ // Label 33897: @2375309
     /* 2375309 */ GIM_Reject,
     /* 2375310 */ // Label 33842: @2375310
     /* 2375310 */ GIM_Try, /*On fail goto*//*Label 33900*/ GIMT_Encode4(2375419),
     /* 2375315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2375318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375326 */   GIM_Try, /*On fail goto*//*Label 33901*/ GIMT_Encode4(2375372), // Rule ID 56332 //
     /* 2375331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2375334 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2375337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2375351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375353 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375371 */     // GIR_Coverage, 56332,
     /* 2375371 */     GIR_EraseRootFromParent_Done,
     /* 2375372 */   // Label 33901: @2375372
     /* 2375372 */   GIM_Try, /*On fail goto*//*Label 33902*/ GIMT_Encode4(2375418), // Rule ID 56333 //
     /* 2375377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2375380 */     // (fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2375383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2375397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2375413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375416 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375417 */     // GIR_Coverage, 56333,
     /* 2375417 */     GIR_EraseRootFromParent_Done,
     /* 2375418 */   // Label 33902: @2375418
     /* 2375418 */   GIM_Reject,
     /* 2375419 */ // Label 33900: @2375419
     /* 2375419 */ GIM_Reject,
     /* 2375420 */ // Label 33843: @2375420
     /* 2375420 */ GIM_Try, /*On fail goto*//*Label 33903*/ GIMT_Encode4(2375529),
     /* 2375425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2375428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2375436 */   GIM_Try, /*On fail goto*//*Label 33904*/ GIMT_Encode4(2375482), // Rule ID 56272 //
     /* 2375441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2375444 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2375444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2375461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375463 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375480 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375481 */     // GIR_Coverage, 56272,
     /* 2375481 */     GIR_EraseRootFromParent_Done,
     /* 2375482 */   // Label 33904: @2375482
     /* 2375482 */   GIM_Try, /*On fail goto*//*Label 33905*/ GIMT_Encode4(2375528), // Rule ID 56273 //
     /* 2375487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2375490 */     // (fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2375490 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2375493 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2375497 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2375502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2375504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2375507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2375512 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2375514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2375520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2375523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2375526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375527 */     // GIR_Coverage, 56273,
     /* 2375527 */     GIR_EraseRootFromParent_Done,
     /* 2375528 */   // Label 33905: @2375528
     /* 2375528 */   GIM_Reject,
     /* 2375529 */ // Label 33903: @2375529
     /* 2375529 */ GIM_Reject,
     /* 2375530 */ // Label 33844: @2375530
     /* 2375530 */ GIM_Reject,
     /* 2375531 */ // Label 95: @2375531
     /* 2375531 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33909*/ GIMT_Encode4(2375728),
     /* 2375542 */ /*GILLT_s16*//*Label 33906*/ GIMT_Encode4(2375554),
     /* 2375546 */ /*GILLT_s32*//*Label 33907*/ GIMT_Encode4(2375612),
     /* 2375550 */ /*GILLT_s64*//*Label 33908*/ GIMT_Encode4(2375670),
     /* 2375554 */ // Label 33906: @2375554
     /* 2375554 */ GIM_Try, /*On fail goto*//*Label 33910*/ GIMT_Encode4(2375611),
     /* 2375559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375570 */   GIM_Try, /*On fail goto*//*Label 33911*/ GIMT_Encode4(2375590), // Rule ID 2318 //
     /* 2375575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2375578 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i64] })
     /* 2375578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2375581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375583 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375588 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375589 */     // GIR_Coverage, 2318,
     /* 2375589 */     GIR_EraseRootFromParent_Done,
     /* 2375590 */   // Label 33911: @2375590
     /* 2375590 */   GIM_Try, /*On fail goto*//*Label 33912*/ GIMT_Encode4(2375610), // Rule ID 2319 //
     /* 2375595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2375598 */     // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 2:{ *:[i32] })
     /* 2375598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2375601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375609 */     // GIR_Coverage, 2319,
     /* 2375609 */     GIR_EraseRootFromParent_Done,
     /* 2375610 */   // Label 33912: @2375610
     /* 2375610 */   GIM_Reject,
     /* 2375611 */ // Label 33910: @2375611
     /* 2375611 */ GIM_Reject,
     /* 2375612 */ // Label 33907: @2375612
     /* 2375612 */ GIM_Try, /*On fail goto*//*Label 33913*/ GIMT_Encode4(2375669),
     /* 2375617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375628 */   GIM_Try, /*On fail goto*//*Label 33914*/ GIMT_Encode4(2375648), // Rule ID 2236 //
     /* 2375633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2375636 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i64] })
     /* 2375636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2375639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375641 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375646 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375647 */     // GIR_Coverage, 2236,
     /* 2375647 */     GIR_EraseRootFromParent_Done,
     /* 2375648 */   // Label 33914: @2375648
     /* 2375648 */   GIM_Try, /*On fail goto*//*Label 33915*/ GIMT_Encode4(2375668), // Rule ID 2237 //
     /* 2375653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2375656 */     // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 2:{ *:[i32] })
     /* 2375656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2375659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375661 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375666 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375667 */     // GIR_Coverage, 2237,
     /* 2375667 */     GIR_EraseRootFromParent_Done,
     /* 2375668 */   // Label 33915: @2375668
     /* 2375668 */   GIM_Reject,
     /* 2375669 */ // Label 33913: @2375669
     /* 2375669 */ GIM_Reject,
     /* 2375670 */ // Label 33908: @2375670
     /* 2375670 */ GIM_Try, /*On fail goto*//*Label 33916*/ GIMT_Encode4(2375727),
     /* 2375675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375686 */   GIM_Try, /*On fail goto*//*Label 33917*/ GIMT_Encode4(2375706), // Rule ID 2276 //
     /* 2375691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2375694 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i64] })
     /* 2375694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2375697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375705 */     // GIR_Coverage, 2276,
     /* 2375705 */     GIR_EraseRootFromParent_Done,
     /* 2375706 */   // Label 33917: @2375706
     /* 2375706 */   GIM_Try, /*On fail goto*//*Label 33918*/ GIMT_Encode4(2375726), // Rule ID 2277 //
     /* 2375711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2375714 */     // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 2:{ *:[i32] })
     /* 2375714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2375717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 2375724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375725 */     // GIR_Coverage, 2277,
     /* 2375725 */     GIR_EraseRootFromParent_Done,
     /* 2375726 */   // Label 33918: @2375726
     /* 2375726 */   GIM_Reject,
     /* 2375727 */ // Label 33916: @2375727
     /* 2375727 */ GIM_Reject,
     /* 2375728 */ // Label 33909: @2375728
     /* 2375728 */ GIM_Reject,
     /* 2375729 */ // Label 96: @2375729
     /* 2375729 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33922*/ GIMT_Encode4(2375926),
     /* 2375740 */ /*GILLT_s16*//*Label 33919*/ GIMT_Encode4(2375752),
     /* 2375744 */ /*GILLT_s32*//*Label 33920*/ GIMT_Encode4(2375810),
     /* 2375748 */ /*GILLT_s64*//*Label 33921*/ GIMT_Encode4(2375868),
     /* 2375752 */ // Label 33919: @2375752
     /* 2375752 */ GIM_Try, /*On fail goto*//*Label 33923*/ GIMT_Encode4(2375809),
     /* 2375757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375768 */   GIM_Try, /*On fail goto*//*Label 33924*/ GIMT_Encode4(2375788), // Rule ID 2302 //
     /* 2375773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2375776 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2375776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2375779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375781 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375786 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375787 */     // GIR_Coverage, 2302,
     /* 2375787 */     GIR_EraseRootFromParent_Done,
     /* 2375788 */   // Label 33924: @2375788
     /* 2375788 */   GIM_Try, /*On fail goto*//*Label 33925*/ GIMT_Encode4(2375808), // Rule ID 2303 //
     /* 2375793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2375796 */     // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUNDNX_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2375796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_H),
     /* 2375799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375801 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375807 */     // GIR_Coverage, 2303,
     /* 2375807 */     GIR_EraseRootFromParent_Done,
     /* 2375808 */   // Label 33925: @2375808
     /* 2375808 */   GIM_Reject,
     /* 2375809 */ // Label 33923: @2375809
     /* 2375809 */ GIM_Reject,
     /* 2375810 */ // Label 33920: @2375810
     /* 2375810 */ GIM_Try, /*On fail goto*//*Label 33926*/ GIMT_Encode4(2375867),
     /* 2375815 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2375818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2375826 */   GIM_Try, /*On fail goto*//*Label 33927*/ GIMT_Encode4(2375846), // Rule ID 2220 //
     /* 2375831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2375834 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2375834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2375837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375844 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375845 */     // GIR_Coverage, 2220,
     /* 2375845 */     GIR_EraseRootFromParent_Done,
     /* 2375846 */   // Label 33927: @2375846
     /* 2375846 */   GIM_Try, /*On fail goto*//*Label 33928*/ GIMT_Encode4(2375866), // Rule ID 2221 //
     /* 2375851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2375854 */     // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUNDNX_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2375854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_S),
     /* 2375857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375859 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375865 */     // GIR_Coverage, 2221,
     /* 2375865 */     GIR_EraseRootFromParent_Done,
     /* 2375866 */   // Label 33928: @2375866
     /* 2375866 */   GIM_Reject,
     /* 2375867 */ // Label 33926: @2375867
     /* 2375867 */ GIM_Reject,
     /* 2375868 */ // Label 33921: @2375868
     /* 2375868 */ GIM_Try, /*On fail goto*//*Label 33929*/ GIMT_Encode4(2375925),
     /* 2375873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2375876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2375884 */   GIM_Try, /*On fail goto*//*Label 33930*/ GIMT_Encode4(2375904), // Rule ID 2260 //
     /* 2375889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2375892 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2375892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2375895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375897 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375903 */     // GIR_Coverage, 2260,
     /* 2375903 */     GIR_EraseRootFromParent_Done,
     /* 2375904 */   // Label 33930: @2375904
     /* 2375904 */   GIM_Try, /*On fail goto*//*Label 33931*/ GIMT_Encode4(2375924), // Rule ID 2261 //
     /* 2375909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2375912 */     // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUNDNX_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2375912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUNDNX_D),
     /* 2375915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375917 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375922 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375923 */     // GIR_Coverage, 2261,
     /* 2375923 */     GIR_EraseRootFromParent_Done,
     /* 2375924 */   // Label 33931: @2375924
     /* 2375924 */   GIM_Reject,
     /* 2375925 */ // Label 33929: @2375925
     /* 2375925 */ GIM_Reject,
     /* 2375926 */ // Label 33922: @2375926
     /* 2375926 */ GIM_Reject,
     /* 2375927 */ // Label 97: @2375927
     /* 2375927 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 33935*/ GIMT_Encode4(2376124),
     /* 2375938 */ /*GILLT_s16*//*Label 33932*/ GIMT_Encode4(2375950),
     /* 2375942 */ /*GILLT_s32*//*Label 33933*/ GIMT_Encode4(2376008),
     /* 2375946 */ /*GILLT_s64*//*Label 33934*/ GIMT_Encode4(2376066),
     /* 2375950 */ // Label 33932: @2375950
     /* 2375950 */ GIM_Try, /*On fail goto*//*Label 33936*/ GIMT_Encode4(2376007),
     /* 2375955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2375958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2375966 */   GIM_Try, /*On fail goto*//*Label 33937*/ GIMT_Encode4(2375986), // Rule ID 2306 //
     /* 2375971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode0),
     /* 2375974 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2375974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2375977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2375981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2375984 */     GIR_RootConstrainSelectedInstOperands,
     /* 2375985 */     // GIR_Coverage, 2306,
     /* 2375985 */     GIR_EraseRootFromParent_Done,
     /* 2375986 */   // Label 33937: @2375986
     /* 2375986 */   GIM_Try, /*On fail goto*//*Label 33938*/ GIMT_Encode4(2376006), // Rule ID 2307 //
     /* 2375991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HasStdExtZfh_HwMode1),
     /* 2375994 */     // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FROUND_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2375994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_H),
     /* 2375997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2375999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376004 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376005 */     // GIR_Coverage, 2307,
     /* 2376005 */     GIR_EraseRootFromParent_Done,
     /* 2376006 */   // Label 33938: @2376006
     /* 2376006 */   GIM_Reject,
     /* 2376007 */ // Label 33936: @2376007
     /* 2376007 */ GIM_Reject,
     /* 2376008 */ // Label 33933: @2376008
     /* 2376008 */ GIM_Try, /*On fail goto*//*Label 33939*/ GIMT_Encode4(2376065),
     /* 2376013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2376016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376024 */   GIM_Try, /*On fail goto*//*Label 33940*/ GIMT_Encode4(2376044), // Rule ID 2224 //
     /* 2376029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode0),
     /* 2376032 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2376032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2376035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376042 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376043 */     // GIR_Coverage, 2224,
     /* 2376043 */     GIR_EraseRootFromParent_Done,
     /* 2376044 */   // Label 33940: @2376044
     /* 2376044 */   GIM_Try, /*On fail goto*//*Label 33941*/ GIMT_Encode4(2376064), // Rule ID 2225 //
     /* 2376049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfa_HwMode1),
     /* 2376052 */     // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FROUND_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2376052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_S),
     /* 2376055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376063 */     // GIR_Coverage, 2225,
     /* 2376063 */     GIR_EraseRootFromParent_Done,
     /* 2376064 */   // Label 33941: @2376064
     /* 2376064 */   GIM_Reject,
     /* 2376065 */ // Label 33939: @2376065
     /* 2376065 */ GIM_Reject,
     /* 2376066 */ // Label 33934: @2376066
     /* 2376066 */ GIM_Try, /*On fail goto*//*Label 33942*/ GIMT_Encode4(2376123),
     /* 2376071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2376074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376082 */   GIM_Try, /*On fail goto*//*Label 33943*/ GIMT_Encode4(2376102), // Rule ID 2264 //
     /* 2376087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode0),
     /* 2376090 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2376090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2376093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376095 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376101 */     // GIR_Coverage, 2264,
     /* 2376101 */     GIR_EraseRootFromParent_Done,
     /* 2376102 */   // Label 33943: @2376102
     /* 2376102 */   GIM_Try, /*On fail goto*//*Label 33944*/ GIMT_Encode4(2376122), // Rule ID 2265 //
     /* 2376107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HasStdExtZfa_HwMode1),
     /* 2376110 */     // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FROUND_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2376110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FROUND_D),
     /* 2376113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376120 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376121 */     // GIR_Coverage, 2265,
     /* 2376121 */     GIR_EraseRootFromParent_Done,
     /* 2376122 */   // Label 33944: @2376122
     /* 2376122 */   GIM_Reject,
     /* 2376123 */ // Label 33942: @2376123
     /* 2376123 */ GIM_Reject,
     /* 2376124 */ // Label 33935: @2376124
     /* 2376124 */ GIM_Reject,
     /* 2376125 */ // Label 98: @2376125
     /* 2376125 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 33963*/ GIMT_Encode4(2378552),
     /* 2376136 */ /*GILLT_s16*//*Label 33945*/ GIMT_Encode4(2376256),
     /* 2376140 */ /*GILLT_s32*//*Label 33946*/ GIMT_Encode4(2376405),
     /* 2376144 */ /*GILLT_s64*//*Label 33947*/ GIMT_Encode4(2376554), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376156 */ /*GILLT_nxv1s16*//*Label 33948*/ GIMT_Encode4(2376737),
     /* 2376160 */ /*GILLT_nxv1s32*//*Label 33949*/ GIMT_Encode4(2376858),
     /* 2376164 */ /*GILLT_nxv1s64*//*Label 33950*/ GIMT_Encode4(2376979), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376176 */ /*GILLT_nxv2s16*//*Label 33951*/ GIMT_Encode4(2377100),
     /* 2376180 */ /*GILLT_nxv2s32*//*Label 33952*/ GIMT_Encode4(2377221),
     /* 2376184 */ /*GILLT_nxv2s64*//*Label 33953*/ GIMT_Encode4(2377342), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376196 */ /*GILLT_nxv4s16*//*Label 33954*/ GIMT_Encode4(2377463),
     /* 2376200 */ /*GILLT_nxv4s32*//*Label 33955*/ GIMT_Encode4(2377584),
     /* 2376204 */ /*GILLT_nxv4s64*//*Label 33956*/ GIMT_Encode4(2377705), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376216 */ /*GILLT_nxv8s16*//*Label 33957*/ GIMT_Encode4(2377826),
     /* 2376220 */ /*GILLT_nxv8s32*//*Label 33958*/ GIMT_Encode4(2377947),
     /* 2376224 */ /*GILLT_nxv8s64*//*Label 33959*/ GIMT_Encode4(2378068), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376236 */ /*GILLT_nxv16s16*//*Label 33960*/ GIMT_Encode4(2378189),
     /* 2376240 */ /*GILLT_nxv16s32*//*Label 33961*/ GIMT_Encode4(2378310), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2376252 */ /*GILLT_nxv32s16*//*Label 33962*/ GIMT_Encode4(2378431),
     /* 2376256 */ // Label 33945: @2376256
     /* 2376256 */ GIM_Try, /*On fail goto*//*Label 33964*/ GIMT_Encode4(2376404),
     /* 2376261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2376264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2376267 */   GIM_Try, /*On fail goto*//*Label 33965*/ GIMT_Encode4(2376301), // Rule ID 1846 //
     /* 2376272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2376275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376287 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2376287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2376290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376292 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376294 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376299 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376300 */     // GIR_Coverage, 1846,
     /* 2376300 */     GIR_EraseRootFromParent_Done,
     /* 2376301 */   // Label 33965: @2376301
     /* 2376301 */   GIM_Try, /*On fail goto*//*Label 33966*/ GIMT_Encode4(2376335), // Rule ID 1847 //
     /* 2376306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2376309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2376321 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2376321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H),
     /* 2376324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376334 */     // GIR_Coverage, 1847,
     /* 2376334 */     GIR_EraseRootFromParent_Done,
     /* 2376335 */   // Label 33966: @2376335
     /* 2376335 */   GIM_Try, /*On fail goto*//*Label 33967*/ GIMT_Encode4(2376369), // Rule ID 1850 //
     /* 2376340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2376343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376355 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2376355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2376358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376368 */     // GIR_Coverage, 1850,
     /* 2376368 */     GIR_EraseRootFromParent_Done,
     /* 2376369 */   // Label 33967: @2376369
     /* 2376369 */   GIM_Try, /*On fail goto*//*Label 33968*/ GIMT_Encode4(2376403), // Rule ID 1851 //
     /* 2376374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2376377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2376389 */     // (strict_fadd:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2376389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_H_INX),
     /* 2376392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376394 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376396 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376402 */     // GIR_Coverage, 1851,
     /* 2376402 */     GIR_EraseRootFromParent_Done,
     /* 2376403 */   // Label 33968: @2376403
     /* 2376403 */   GIM_Reject,
     /* 2376404 */ // Label 33964: @2376404
     /* 2376404 */ GIM_Reject,
     /* 2376405 */ // Label 33946: @2376405
     /* 2376405 */ GIM_Try, /*On fail goto*//*Label 33969*/ GIMT_Encode4(2376553),
     /* 2376410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2376413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2376416 */   GIM_Try, /*On fail goto*//*Label 33970*/ GIMT_Encode4(2376450), // Rule ID 1137 //
     /* 2376421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2376424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376428 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376436 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2376436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2376439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376449 */     // GIR_Coverage, 1137,
     /* 2376449 */     GIR_EraseRootFromParent_Done,
     /* 2376450 */   // Label 33970: @2376450
     /* 2376450 */   GIM_Try, /*On fail goto*//*Label 33971*/ GIMT_Encode4(2376484), // Rule ID 1138 //
     /* 2376455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2376458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2376470 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2376470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S),
     /* 2376473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376483 */     // GIR_Coverage, 1138,
     /* 2376483 */     GIR_EraseRootFromParent_Done,
     /* 2376484 */   // Label 33971: @2376484
     /* 2376484 */   GIM_Try, /*On fail goto*//*Label 33972*/ GIMT_Encode4(2376518), // Rule ID 1141 //
     /* 2376489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2376492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376504 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2376504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2376507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376509 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376511 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376517 */     // GIR_Coverage, 1141,
     /* 2376517 */     GIR_EraseRootFromParent_Done,
     /* 2376518 */   // Label 33972: @2376518
     /* 2376518 */   GIM_Try, /*On fail goto*//*Label 33973*/ GIMT_Encode4(2376552), // Rule ID 1142 //
     /* 2376523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2376526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2376538 */     // (strict_fadd:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2376538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_S_INX),
     /* 2376541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376550 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376551 */     // GIR_Coverage, 1142,
     /* 2376551 */     GIR_EraseRootFromParent_Done,
     /* 2376552 */   // Label 33973: @2376552
     /* 2376552 */   GIM_Reject,
     /* 2376553 */ // Label 33969: @2376553
     /* 2376553 */ GIM_Reject,
     /* 2376554 */ // Label 33947: @2376554
     /* 2376554 */ GIM_Try, /*On fail goto*//*Label 33974*/ GIMT_Encode4(2376736),
     /* 2376559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2376562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2376565 */   GIM_Try, /*On fail goto*//*Label 33975*/ GIMT_Encode4(2376599), // Rule ID 1472 //
     /* 2376570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2376573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376585 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2376585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2376588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376590 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376598 */     // GIR_Coverage, 1472,
     /* 2376598 */     GIR_EraseRootFromParent_Done,
     /* 2376599 */   // Label 33975: @2376599
     /* 2376599 */   GIM_Try, /*On fail goto*//*Label 33976*/ GIMT_Encode4(2376633), // Rule ID 1473 //
     /* 2376604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2376607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2376619 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2376619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D),
     /* 2376622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376631 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376632 */     // GIR_Coverage, 1473,
     /* 2376632 */     GIR_EraseRootFromParent_Done,
     /* 2376633 */   // Label 33976: @2376633
     /* 2376633 */   GIM_Try, /*On fail goto*//*Label 33977*/ GIMT_Encode4(2376667), // Rule ID 1476 //
     /* 2376638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2376641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376653 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2376653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2376656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376658 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376660 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376665 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376666 */     // GIR_Coverage, 1476,
     /* 2376666 */     GIR_EraseRootFromParent_Done,
     /* 2376667 */   // Label 33977: @2376667
     /* 2376667 */   GIM_Try, /*On fail goto*//*Label 33978*/ GIMT_Encode4(2376701), // Rule ID 1477 //
     /* 2376672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2376675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2376687 */     // (strict_fadd:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2376687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_IN32X),
     /* 2376690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376692 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376694 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376699 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376700 */     // GIR_Coverage, 1477,
     /* 2376700 */     GIR_EraseRootFromParent_Done,
     /* 2376701 */   // Label 33978: @2376701
     /* 2376701 */   GIM_Try, /*On fail goto*//*Label 33979*/ GIMT_Encode4(2376735), // Rule ID 1480 //
     /* 2376706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2376709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2376721 */     // (strict_fadd:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2376721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FADD_D_INX),
     /* 2376724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376734 */     // GIR_Coverage, 1480,
     /* 2376734 */     GIR_EraseRootFromParent_Done,
     /* 2376735 */   // Label 33979: @2376735
     /* 2376735 */   GIM_Reject,
     /* 2376736 */ // Label 33974: @2376736
     /* 2376736 */ GIM_Reject,
     /* 2376737 */ // Label 33948: @2376737
     /* 2376737 */ GIM_Try, /*On fail goto*//*Label 33980*/ GIMT_Encode4(2376857),
     /* 2376742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2376745 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2376748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376756 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376760 */   GIM_Try, /*On fail goto*//*Label 33981*/ GIMT_Encode4(2376808), // Rule ID 45636 //
     /* 2376765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2376768 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376768 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376771 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376775 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2376785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376790 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376792 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376806 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376807 */     // GIR_Coverage, 45636,
     /* 2376807 */     GIR_EraseRootFromParent_Done,
     /* 2376808 */   // Label 33981: @2376808
     /* 2376808 */   GIM_Try, /*On fail goto*//*Label 33982*/ GIMT_Encode4(2376856), // Rule ID 45637 //
     /* 2376813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2376816 */     // (strict_fadd:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFADD_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2376819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF4_E16),
     /* 2376833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2376851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376854 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376855 */     // GIR_Coverage, 45637,
     /* 2376855 */     GIR_EraseRootFromParent_Done,
     /* 2376856 */   // Label 33982: @2376856
     /* 2376856 */   GIM_Reject,
     /* 2376857 */ // Label 33980: @2376857
     /* 2376857 */ GIM_Reject,
     /* 2376858 */ // Label 33949: @2376858
     /* 2376858 */ GIM_Try, /*On fail goto*//*Label 33983*/ GIMT_Encode4(2376978),
     /* 2376863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2376866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2376869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376881 */   GIM_Try, /*On fail goto*//*Label 33984*/ GIMT_Encode4(2376929), // Rule ID 53172 //
     /* 2376886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2376889 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2376889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2376906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376928 */     // GIR_Coverage, 53172,
     /* 2376928 */     GIR_EraseRootFromParent_Done,
     /* 2376929 */   // Label 33984: @2376929
     /* 2376929 */   GIM_Try, /*On fail goto*//*Label 33985*/ GIMT_Encode4(2376977), // Rule ID 53173 //
     /* 2376934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2376937 */     // (strict_fadd:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2376937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2376940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2376944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2376949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2376951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E32),
     /* 2376954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2376956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2376959 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2376961 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2376963 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2376966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2376969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2376972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2376975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2376976 */     // GIR_Coverage, 53173,
     /* 2376976 */     GIR_EraseRootFromParent_Done,
     /* 2376977 */   // Label 33985: @2376977
     /* 2376977 */   GIM_Reject,
     /* 2376978 */ // Label 33983: @2376978
     /* 2376978 */ GIM_Reject,
     /* 2376979 */ // Label 33950: @2376979
     /* 2376979 */ GIM_Try, /*On fail goto*//*Label 33986*/ GIMT_Encode4(2377099),
     /* 2376984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2376987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2376990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2376998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377002 */   GIM_Try, /*On fail goto*//*Label 33987*/ GIMT_Encode4(2377050), // Rule ID 53208 //
     /* 2377007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2377010 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2377013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2377027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377039 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377049 */     // GIR_Coverage, 53208,
     /* 2377049 */     GIR_EraseRootFromParent_Done,
     /* 2377050 */   // Label 33987: @2377050
     /* 2377050 */   GIM_Try, /*On fail goto*//*Label 33988*/ GIMT_Encode4(2377098), // Rule ID 53209 //
     /* 2377055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2377058 */     // (strict_fadd:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFADD_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2377061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E64),
     /* 2377075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377096 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377097 */     // GIR_Coverage, 53209,
     /* 2377097 */     GIR_EraseRootFromParent_Done,
     /* 2377098 */   // Label 33988: @2377098
     /* 2377098 */   GIM_Reject,
     /* 2377099 */ // Label 33986: @2377099
     /* 2377099 */ GIM_Reject,
     /* 2377100 */ // Label 33951: @2377100
     /* 2377100 */ GIM_Try, /*On fail goto*//*Label 33989*/ GIMT_Encode4(2377220),
     /* 2377105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2377108 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2377111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377119 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377123 */   GIM_Try, /*On fail goto*//*Label 33990*/ GIMT_Encode4(2377171), // Rule ID 53160 //
     /* 2377128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2377131 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2377134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2377148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377169 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377170 */     // GIR_Coverage, 53160,
     /* 2377170 */     GIR_EraseRootFromParent_Done,
     /* 2377171 */   // Label 33990: @2377171
     /* 2377171 */   GIM_Try, /*On fail goto*//*Label 33991*/ GIMT_Encode4(2377219), // Rule ID 53161 //
     /* 2377176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2377179 */     // (strict_fadd:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFADD_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2377182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_MF2_E16),
     /* 2377196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377198 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377201 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377218 */     // GIR_Coverage, 53161,
     /* 2377218 */     GIR_EraseRootFromParent_Done,
     /* 2377219 */   // Label 33991: @2377219
     /* 2377219 */   GIM_Reject,
     /* 2377220 */ // Label 33989: @2377220
     /* 2377220 */ GIM_Reject,
     /* 2377221 */ // Label 33952: @2377221
     /* 2377221 */ GIM_Try, /*On fail goto*//*Label 33992*/ GIMT_Encode4(2377341),
     /* 2377226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2377229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2377232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377244 */   GIM_Try, /*On fail goto*//*Label 33993*/ GIMT_Encode4(2377292), // Rule ID 53196 //
     /* 2377249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2377252 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2377255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2377269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377274 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377276 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377291 */     // GIR_Coverage, 53196,
     /* 2377291 */     GIR_EraseRootFromParent_Done,
     /* 2377292 */   // Label 33993: @2377292
     /* 2377292 */   GIM_Try, /*On fail goto*//*Label 33994*/ GIMT_Encode4(2377340), // Rule ID 53197 //
     /* 2377297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2377300 */     // (strict_fadd:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFADD_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2377303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E32),
     /* 2377317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377322 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377324 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377339 */     // GIR_Coverage, 53197,
     /* 2377339 */     GIR_EraseRootFromParent_Done,
     /* 2377340 */   // Label 33994: @2377340
     /* 2377340 */   GIM_Reject,
     /* 2377341 */ // Label 33992: @2377341
     /* 2377341 */ GIM_Reject,
     /* 2377342 */ // Label 33953: @2377342
     /* 2377342 */ GIM_Try, /*On fail goto*//*Label 33995*/ GIMT_Encode4(2377462),
     /* 2377347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2377350 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2377353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377361 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377365 */   GIM_Try, /*On fail goto*//*Label 33996*/ GIMT_Encode4(2377413), // Rule ID 53292 //
     /* 2377370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2377373 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2377376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2377390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377395 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377397 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377412 */     // GIR_Coverage, 53292,
     /* 2377412 */     GIR_EraseRootFromParent_Done,
     /* 2377413 */   // Label 33996: @2377413
     /* 2377413 */   GIM_Try, /*On fail goto*//*Label 33997*/ GIMT_Encode4(2377461), // Rule ID 53293 //
     /* 2377418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2377421 */     // (strict_fadd:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFADD_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377421 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2377424 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377428 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E64),
     /* 2377438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377443 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377445 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377459 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377460 */     // GIR_Coverage, 53293,
     /* 2377460 */     GIR_EraseRootFromParent_Done,
     /* 2377461 */   // Label 33997: @2377461
     /* 2377461 */   GIM_Reject,
     /* 2377462 */ // Label 33995: @2377462
     /* 2377462 */ GIM_Reject,
     /* 2377463 */ // Label 33954: @2377463
     /* 2377463 */ GIM_Try, /*On fail goto*//*Label 33998*/ GIMT_Encode4(2377583),
     /* 2377468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2377471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2377474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2377486 */   GIM_Try, /*On fail goto*//*Label 33999*/ GIMT_Encode4(2377534), // Rule ID 53184 //
     /* 2377491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2377494 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2377497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2377511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377518 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377533 */     // GIR_Coverage, 53184,
     /* 2377533 */     GIR_EraseRootFromParent_Done,
     /* 2377534 */   // Label 33999: @2377534
     /* 2377534 */   GIM_Try, /*On fail goto*//*Label 34000*/ GIMT_Encode4(2377582), // Rule ID 53185 //
     /* 2377539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2377542 */     // (strict_fadd:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFADD_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2377545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M1_E16),
     /* 2377559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377564 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377566 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377580 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377581 */     // GIR_Coverage, 53185,
     /* 2377581 */     GIR_EraseRootFromParent_Done,
     /* 2377582 */   // Label 34000: @2377582
     /* 2377582 */   GIM_Reject,
     /* 2377583 */ // Label 33998: @2377583
     /* 2377583 */ GIM_Reject,
     /* 2377584 */ // Label 33955: @2377584
     /* 2377584 */ GIM_Try, /*On fail goto*//*Label 34001*/ GIMT_Encode4(2377704),
     /* 2377589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2377592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2377595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377603 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377607 */   GIM_Try, /*On fail goto*//*Label 34002*/ GIMT_Encode4(2377655), // Rule ID 53256 //
     /* 2377612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2377615 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377615 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377618 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377622 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2377632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377637 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377654 */     // GIR_Coverage, 53256,
     /* 2377654 */     GIR_EraseRootFromParent_Done,
     /* 2377655 */   // Label 34002: @2377655
     /* 2377655 */   GIM_Try, /*On fail goto*//*Label 34003*/ GIMT_Encode4(2377703), // Rule ID 53257 //
     /* 2377660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2377663 */     // (strict_fadd:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFADD_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2377666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377675 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E32),
     /* 2377680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377682 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377685 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2377698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377702 */     // GIR_Coverage, 53257,
     /* 2377702 */     GIR_EraseRootFromParent_Done,
     /* 2377703 */   // Label 34003: @2377703
     /* 2377703 */   GIM_Reject,
     /* 2377704 */ // Label 34001: @2377704
     /* 2377704 */ GIM_Reject,
     /* 2377705 */ // Label 33956: @2377705
     /* 2377705 */ GIM_Try, /*On fail goto*//*Label 34004*/ GIMT_Encode4(2377825),
     /* 2377710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2377713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2377716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377728 */   GIM_Try, /*On fail goto*//*Label 34005*/ GIMT_Encode4(2377776), // Rule ID 53304 //
     /* 2377733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2377736 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2377753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377775 */     // GIR_Coverage, 53304,
     /* 2377775 */     GIR_EraseRootFromParent_Done,
     /* 2377776 */   // Label 34005: @2377776
     /* 2377776 */   GIM_Try, /*On fail goto*//*Label 34006*/ GIMT_Encode4(2377824), // Rule ID 53305 //
     /* 2377781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2377784 */     // (strict_fadd:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFADD_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377784 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2377787 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377791 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377796 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E64),
     /* 2377801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377808 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2377819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377822 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377823 */     // GIR_Coverage, 53305,
     /* 2377823 */     GIR_EraseRootFromParent_Done,
     /* 2377824 */   // Label 34006: @2377824
     /* 2377824 */   GIM_Reject,
     /* 2377825 */ // Label 34004: @2377825
     /* 2377825 */ GIM_Reject,
     /* 2377826 */ // Label 33957: @2377826
     /* 2377826 */ GIM_Try, /*On fail goto*//*Label 34007*/ GIMT_Encode4(2377946),
     /* 2377831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2377834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2377837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2377849 */   GIM_Try, /*On fail goto*//*Label 34008*/ GIMT_Encode4(2377897), // Rule ID 53220 //
     /* 2377854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2377857 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2377874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377879 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377883 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377886 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377896 */     // GIR_Coverage, 53220,
     /* 2377896 */     GIR_EraseRootFromParent_Done,
     /* 2377897 */   // Label 34008: @2377897
     /* 2377897 */   GIM_Try, /*On fail goto*//*Label 34009*/ GIMT_Encode4(2377945), // Rule ID 53221 //
     /* 2377902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2377905 */     // (strict_fadd:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFADD_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2377905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2377908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M2_E16),
     /* 2377922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2377927 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2377929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2377931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2377934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2377937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2377940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2377943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2377944 */     // GIR_Coverage, 53221,
     /* 2377944 */     GIR_EraseRootFromParent_Done,
     /* 2377945 */   // Label 34009: @2377945
     /* 2377945 */   GIM_Reject,
     /* 2377946 */ // Label 34007: @2377946
     /* 2377946 */ GIM_Reject,
     /* 2377947 */ // Label 33958: @2377947
     /* 2377947 */ GIM_Try, /*On fail goto*//*Label 34010*/ GIMT_Encode4(2378067),
     /* 2377952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2377955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2377958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2377970 */   GIM_Try, /*On fail goto*//*Label 34011*/ GIMT_Encode4(2378018), // Rule ID 53268 //
     /* 2377975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2377978 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2377978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2377981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2377985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2377990 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2377992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2377995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2377997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378000 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378002 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378017 */     // GIR_Coverage, 53268,
     /* 2378017 */     GIR_EraseRootFromParent_Done,
     /* 2378018 */   // Label 34011: @2378018
     /* 2378018 */   GIM_Try, /*On fail goto*//*Label 34012*/ GIMT_Encode4(2378066), // Rule ID 53269 //
     /* 2378023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2378026 */     // (strict_fadd:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFADD_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378026 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2378029 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378033 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E32),
     /* 2378043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378048 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378064 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378065 */     // GIR_Coverage, 53269,
     /* 2378065 */     GIR_EraseRootFromParent_Done,
     /* 2378066 */   // Label 34012: @2378066
     /* 2378066 */   GIM_Reject,
     /* 2378067 */ // Label 34010: @2378067
     /* 2378067 */ GIM_Reject,
     /* 2378068 */ // Label 33959: @2378068
     /* 2378068 */ GIM_Try, /*On fail goto*//*Label 34013*/ GIMT_Encode4(2378188),
     /* 2378073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2378076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2378079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378091 */   GIM_Try, /*On fail goto*//*Label 34014*/ GIMT_Encode4(2378139), // Rule ID 53316 //
     /* 2378096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2378099 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2378102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2378116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378123 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378137 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378138 */     // GIR_Coverage, 53316,
     /* 2378138 */     GIR_EraseRootFromParent_Done,
     /* 2378139 */   // Label 34014: @2378139
     /* 2378139 */   GIM_Try, /*On fail goto*//*Label 34015*/ GIMT_Encode4(2378187), // Rule ID 53317 //
     /* 2378144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2378147 */     // (strict_fadd:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFADD_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2378150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378159 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E64),
     /* 2378164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378166 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2378182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378185 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378186 */     // GIR_Coverage, 53317,
     /* 2378186 */     GIR_EraseRootFromParent_Done,
     /* 2378187 */   // Label 34015: @2378187
     /* 2378187 */   GIM_Reject,
     /* 2378188 */ // Label 34013: @2378188
     /* 2378188 */ GIM_Reject,
     /* 2378189 */ // Label 33960: @2378189
     /* 2378189 */ GIM_Try, /*On fail goto*//*Label 34016*/ GIMT_Encode4(2378309),
     /* 2378194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2378197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2378200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2378212 */   GIM_Try, /*On fail goto*//*Label 34017*/ GIMT_Encode4(2378260), // Rule ID 53232 //
     /* 2378217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2378220 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2378223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2378237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378242 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378244 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378258 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378259 */     // GIR_Coverage, 53232,
     /* 2378259 */     GIR_EraseRootFromParent_Done,
     /* 2378260 */   // Label 34017: @2378260
     /* 2378260 */   GIM_Try, /*On fail goto*//*Label 34018*/ GIMT_Encode4(2378308), // Rule ID 53233 //
     /* 2378265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2378268 */     // (strict_fadd:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFADD_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2378271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M4_E16),
     /* 2378285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378290 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378292 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378307 */     // GIR_Coverage, 53233,
     /* 2378307 */     GIR_EraseRootFromParent_Done,
     /* 2378308 */   // Label 34018: @2378308
     /* 2378308 */   GIM_Reject,
     /* 2378309 */ // Label 34016: @2378309
     /* 2378309 */ GIM_Reject,
     /* 2378310 */ // Label 33961: @2378310
     /* 2378310 */ GIM_Try, /*On fail goto*//*Label 34019*/ GIMT_Encode4(2378430),
     /* 2378315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2378318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2378321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378329 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378333 */   GIM_Try, /*On fail goto*//*Label 34020*/ GIMT_Encode4(2378381), // Rule ID 53280 //
     /* 2378338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2378341 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2378344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2378358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378363 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378365 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378379 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378380 */     // GIR_Coverage, 53280,
     /* 2378380 */     GIR_EraseRootFromParent_Done,
     /* 2378381 */   // Label 34020: @2378381
     /* 2378381 */   GIM_Try, /*On fail goto*//*Label 34021*/ GIMT_Encode4(2378429), // Rule ID 53281 //
     /* 2378386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2378389 */     // (strict_fadd:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFADD_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2378392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E32),
     /* 2378406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378411 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378413 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2378424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378428 */     // GIR_Coverage, 53281,
     /* 2378428 */     GIR_EraseRootFromParent_Done,
     /* 2378429 */   // Label 34021: @2378429
     /* 2378429 */   GIM_Reject,
     /* 2378430 */ // Label 34019: @2378430
     /* 2378430 */ GIM_Reject,
     /* 2378431 */ // Label 33962: @2378431
     /* 2378431 */ GIM_Try, /*On fail goto*//*Label 34022*/ GIMT_Encode4(2378551),
     /* 2378436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2378439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2378442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378450 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2378454 */   GIM_Try, /*On fail goto*//*Label 34023*/ GIMT_Encode4(2378502), // Rule ID 53244 //
     /* 2378459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2378462 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2378462 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378465 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378469 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378474 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2378479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378484 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378486 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378501 */     // GIR_Coverage, 53244,
     /* 2378501 */     GIR_EraseRootFromParent_Done,
     /* 2378502 */   // Label 34023: @2378502
     /* 2378502 */   GIM_Try, /*On fail goto*//*Label 34024*/ GIMT_Encode4(2378550), // Rule ID 53245 //
     /* 2378507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2378510 */     // (strict_fadd:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFADD_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2378510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2378513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2378517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2378522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2378524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFADD_VV_M8_E16),
     /* 2378527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2378532 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378534 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2378542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2378545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2378548 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378549 */     // GIR_Coverage, 53245,
     /* 2378549 */     GIR_EraseRootFromParent_Done,
     /* 2378550 */   // Label 34024: @2378550
     /* 2378550 */   GIM_Reject,
     /* 2378551 */ // Label 34022: @2378551
     /* 2378551 */ GIM_Reject,
     /* 2378552 */ // Label 33963: @2378552
     /* 2378552 */ GIM_Reject,
     /* 2378553 */ // Label 99: @2378553
     /* 2378553 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34043*/ GIMT_Encode4(2380980),
     /* 2378564 */ /*GILLT_s16*//*Label 34025*/ GIMT_Encode4(2378684),
     /* 2378568 */ /*GILLT_s32*//*Label 34026*/ GIMT_Encode4(2378833),
     /* 2378572 */ /*GILLT_s64*//*Label 34027*/ GIMT_Encode4(2378982), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378584 */ /*GILLT_nxv1s16*//*Label 34028*/ GIMT_Encode4(2379165),
     /* 2378588 */ /*GILLT_nxv1s32*//*Label 34029*/ GIMT_Encode4(2379286),
     /* 2378592 */ /*GILLT_nxv1s64*//*Label 34030*/ GIMT_Encode4(2379407), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378604 */ /*GILLT_nxv2s16*//*Label 34031*/ GIMT_Encode4(2379528),
     /* 2378608 */ /*GILLT_nxv2s32*//*Label 34032*/ GIMT_Encode4(2379649),
     /* 2378612 */ /*GILLT_nxv2s64*//*Label 34033*/ GIMT_Encode4(2379770), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378624 */ /*GILLT_nxv4s16*//*Label 34034*/ GIMT_Encode4(2379891),
     /* 2378628 */ /*GILLT_nxv4s32*//*Label 34035*/ GIMT_Encode4(2380012),
     /* 2378632 */ /*GILLT_nxv4s64*//*Label 34036*/ GIMT_Encode4(2380133), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378644 */ /*GILLT_nxv8s16*//*Label 34037*/ GIMT_Encode4(2380254),
     /* 2378648 */ /*GILLT_nxv8s32*//*Label 34038*/ GIMT_Encode4(2380375),
     /* 2378652 */ /*GILLT_nxv8s64*//*Label 34039*/ GIMT_Encode4(2380496), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378664 */ /*GILLT_nxv16s16*//*Label 34040*/ GIMT_Encode4(2380617),
     /* 2378668 */ /*GILLT_nxv16s32*//*Label 34041*/ GIMT_Encode4(2380738), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2378680 */ /*GILLT_nxv32s16*//*Label 34042*/ GIMT_Encode4(2380859),
     /* 2378684 */ // Label 34025: @2378684
     /* 2378684 */ GIM_Try, /*On fail goto*//*Label 34044*/ GIMT_Encode4(2378832),
     /* 2378689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2378692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2378695 */   GIM_Try, /*On fail goto*//*Label 34045*/ GIMT_Encode4(2378729), // Rule ID 1854 //
     /* 2378700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2378703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378715 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2378715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2378718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378720 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378722 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378728 */     // GIR_Coverage, 1854,
     /* 2378728 */     GIR_EraseRootFromParent_Done,
     /* 2378729 */   // Label 34045: @2378729
     /* 2378729 */   GIM_Try, /*On fail goto*//*Label 34046*/ GIMT_Encode4(2378763), // Rule ID 1855 //
     /* 2378734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2378737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2378749 */     // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FSUB_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2378749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H),
     /* 2378752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378754 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378756 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378761 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378762 */     // GIR_Coverage, 1855,
     /* 2378762 */     GIR_EraseRootFromParent_Done,
     /* 2378763 */   // Label 34046: @2378763
     /* 2378763 */   GIM_Try, /*On fail goto*//*Label 34047*/ GIMT_Encode4(2378797), // Rule ID 1858 //
     /* 2378768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2378771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378783 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2378783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2378786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378796 */     // GIR_Coverage, 1858,
     /* 2378796 */     GIR_EraseRootFromParent_Done,
     /* 2378797 */   // Label 34047: @2378797
     /* 2378797 */   GIM_Try, /*On fail goto*//*Label 34048*/ GIMT_Encode4(2378831), // Rule ID 1859 //
     /* 2378802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2378805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2378817 */     // (strict_fsub:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FSUB_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2378817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_H_INX),
     /* 2378820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378822 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378824 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378829 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378830 */     // GIR_Coverage, 1859,
     /* 2378830 */     GIR_EraseRootFromParent_Done,
     /* 2378831 */   // Label 34048: @2378831
     /* 2378831 */   GIM_Reject,
     /* 2378832 */ // Label 34044: @2378832
     /* 2378832 */ GIM_Reject,
     /* 2378833 */ // Label 34026: @2378833
     /* 2378833 */ GIM_Try, /*On fail goto*//*Label 34049*/ GIMT_Encode4(2378981),
     /* 2378838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2378841 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2378844 */   GIM_Try, /*On fail goto*//*Label 34050*/ GIMT_Encode4(2378878), // Rule ID 1145 //
     /* 2378849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2378852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378856 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378864 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2378864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2378867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378871 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378877 */     // GIR_Coverage, 1145,
     /* 2378877 */     GIR_EraseRootFromParent_Done,
     /* 2378878 */   // Label 34050: @2378878
     /* 2378878 */   GIM_Try, /*On fail goto*//*Label 34051*/ GIMT_Encode4(2378912), // Rule ID 1146 //
     /* 2378883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2378886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2378898 */     // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FSUB_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2378898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S),
     /* 2378901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378903 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378905 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378911 */     // GIR_Coverage, 1146,
     /* 2378911 */     GIR_EraseRootFromParent_Done,
     /* 2378912 */   // Label 34051: @2378912
     /* 2378912 */   GIM_Try, /*On fail goto*//*Label 34052*/ GIMT_Encode4(2378946), // Rule ID 1149 //
     /* 2378917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2378920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378932 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2378932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2378935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378945 */     // GIR_Coverage, 1149,
     /* 2378945 */     GIR_EraseRootFromParent_Done,
     /* 2378946 */   // Label 34052: @2378946
     /* 2378946 */   GIM_Try, /*On fail goto*//*Label 34053*/ GIMT_Encode4(2378980), // Rule ID 1150 //
     /* 2378951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2378954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2378966 */     // (strict_fsub:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FSUB_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2378966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_S_INX),
     /* 2378969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2378971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2378973 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2378975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2378978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2378979 */     // GIR_Coverage, 1150,
     /* 2378979 */     GIR_EraseRootFromParent_Done,
     /* 2378980 */   // Label 34053: @2378980
     /* 2378980 */   GIM_Reject,
     /* 2378981 */ // Label 34049: @2378981
     /* 2378981 */ GIM_Reject,
     /* 2378982 */ // Label 34027: @2378982
     /* 2378982 */ GIM_Try, /*On fail goto*//*Label 34054*/ GIMT_Encode4(2379164),
     /* 2378987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2378990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2378993 */   GIM_Try, /*On fail goto*//*Label 34055*/ GIMT_Encode4(2379027), // Rule ID 1482 //
     /* 2378998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2379001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379013 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2379013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2379016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379018 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379020 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379026 */     // GIR_Coverage, 1482,
     /* 2379026 */     GIR_EraseRootFromParent_Done,
     /* 2379027 */   // Label 34055: @2379027
     /* 2379027 */   GIM_Try, /*On fail goto*//*Label 34056*/ GIMT_Encode4(2379061), // Rule ID 1483 //
     /* 2379032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2379035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2379047 */     // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FSUB_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2379047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D),
     /* 2379050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379052 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379054 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379060 */     // GIR_Coverage, 1483,
     /* 2379060 */     GIR_EraseRootFromParent_Done,
     /* 2379061 */   // Label 34056: @2379061
     /* 2379061 */   GIM_Try, /*On fail goto*//*Label 34057*/ GIMT_Encode4(2379095), // Rule ID 1486 //
     /* 2379066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2379069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379081 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2379081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2379084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379094 */     // GIR_Coverage, 1486,
     /* 2379094 */     GIR_EraseRootFromParent_Done,
     /* 2379095 */   // Label 34057: @2379095
     /* 2379095 */   GIM_Try, /*On fail goto*//*Label 34058*/ GIMT_Encode4(2379129), // Rule ID 1487 //
     /* 2379100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2379103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2379115 */     // (strict_fsub:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FSUB_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2379115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_IN32X),
     /* 2379118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379120 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379122 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379128 */     // GIR_Coverage, 1487,
     /* 2379128 */     GIR_EraseRootFromParent_Done,
     /* 2379129 */   // Label 34058: @2379129
     /* 2379129 */   GIM_Try, /*On fail goto*//*Label 34059*/ GIMT_Encode4(2379163), // Rule ID 1490 //
     /* 2379134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2379137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2379149 */     // (strict_fsub:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FSUB_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2379149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSUB_D_INX),
     /* 2379152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379154 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379161 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379162 */     // GIR_Coverage, 1490,
     /* 2379162 */     GIR_EraseRootFromParent_Done,
     /* 2379163 */   // Label 34059: @2379163
     /* 2379163 */   GIM_Reject,
     /* 2379164 */ // Label 34054: @2379164
     /* 2379164 */ GIM_Reject,
     /* 2379165 */ // Label 34028: @2379165
     /* 2379165 */ GIM_Try, /*On fail goto*//*Label 34060*/ GIMT_Encode4(2379285),
     /* 2379170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2379173 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2379176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379184 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379188 */   GIM_Try, /*On fail goto*//*Label 34061*/ GIMT_Encode4(2379236), // Rule ID 53328 //
     /* 2379193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379196 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2379199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2379213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379218 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379220 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379235 */     // GIR_Coverage, 53328,
     /* 2379235 */     GIR_EraseRootFromParent_Done,
     /* 2379236 */   // Label 34061: @2379236
     /* 2379236 */   GIM_Try, /*On fail goto*//*Label 34062*/ GIMT_Encode4(2379284), // Rule ID 53329 //
     /* 2379241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379244 */     // (strict_fsub:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2379247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF4_E16),
     /* 2379261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379266 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379268 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379283 */     // GIR_Coverage, 53329,
     /* 2379283 */     GIR_EraseRootFromParent_Done,
     /* 2379284 */   // Label 34062: @2379284
     /* 2379284 */   GIM_Reject,
     /* 2379285 */ // Label 34060: @2379285
     /* 2379285 */ GIM_Reject,
     /* 2379286 */ // Label 34029: @2379286
     /* 2379286 */ GIM_Try, /*On fail goto*//*Label 34063*/ GIMT_Encode4(2379406),
     /* 2379291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2379294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2379297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379309 */   GIM_Try, /*On fail goto*//*Label 34064*/ GIMT_Encode4(2379357), // Rule ID 53352 //
     /* 2379314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2379317 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2379334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379339 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379341 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379355 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379356 */     // GIR_Coverage, 53352,
     /* 2379356 */     GIR_EraseRootFromParent_Done,
     /* 2379357 */   // Label 34064: @2379357
     /* 2379357 */   GIM_Try, /*On fail goto*//*Label 34065*/ GIMT_Encode4(2379405), // Rule ID 53353 //
     /* 2379362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2379365 */     // (strict_fsub:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2379368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E32),
     /* 2379382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379387 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379389 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379403 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379404 */     // GIR_Coverage, 53353,
     /* 2379404 */     GIR_EraseRootFromParent_Done,
     /* 2379405 */   // Label 34065: @2379405
     /* 2379405 */   GIM_Reject,
     /* 2379406 */ // Label 34063: @2379406
     /* 2379406 */ GIM_Reject,
     /* 2379407 */ // Label 34030: @2379407
     /* 2379407 */ GIM_Try, /*On fail goto*//*Label 34066*/ GIMT_Encode4(2379527),
     /* 2379412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2379415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2379418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379430 */   GIM_Try, /*On fail goto*//*Label 34067*/ GIMT_Encode4(2379478), // Rule ID 53388 //
     /* 2379435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2379438 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379438 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379441 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379445 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379450 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2379455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379476 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379477 */     // GIR_Coverage, 53388,
     /* 2379477 */     GIR_EraseRootFromParent_Done,
     /* 2379478 */   // Label 34067: @2379478
     /* 2379478 */   GIM_Try, /*On fail goto*//*Label 34068*/ GIMT_Encode4(2379526), // Rule ID 53389 //
     /* 2379483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2379486 */     // (strict_fsub:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2379489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E64),
     /* 2379503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379524 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379525 */     // GIR_Coverage, 53389,
     /* 2379525 */     GIR_EraseRootFromParent_Done,
     /* 2379526 */   // Label 34068: @2379526
     /* 2379526 */   GIM_Reject,
     /* 2379527 */ // Label 34066: @2379527
     /* 2379527 */ GIM_Reject,
     /* 2379528 */ // Label 34031: @2379528
     /* 2379528 */ GIM_Try, /*On fail goto*//*Label 34069*/ GIMT_Encode4(2379648),
     /* 2379533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2379536 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2379539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379547 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379551 */   GIM_Try, /*On fail goto*//*Label 34070*/ GIMT_Encode4(2379599), // Rule ID 53340 //
     /* 2379556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379559 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2379576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379581 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379583 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379598 */     // GIR_Coverage, 53340,
     /* 2379598 */     GIR_EraseRootFromParent_Done,
     /* 2379599 */   // Label 34070: @2379599
     /* 2379599 */   GIM_Try, /*On fail goto*//*Label 34071*/ GIMT_Encode4(2379647), // Rule ID 53341 //
     /* 2379604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379607 */     // (strict_fsub:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSUB_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2379610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_MF2_E16),
     /* 2379624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379631 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379646 */     // GIR_Coverage, 53341,
     /* 2379646 */     GIR_EraseRootFromParent_Done,
     /* 2379647 */   // Label 34071: @2379647
     /* 2379647 */   GIM_Reject,
     /* 2379648 */ // Label 34069: @2379648
     /* 2379648 */ GIM_Reject,
     /* 2379649 */ // Label 34032: @2379649
     /* 2379649 */ GIM_Try, /*On fail goto*//*Label 34072*/ GIMT_Encode4(2379769),
     /* 2379654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2379657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2379660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379672 */   GIM_Try, /*On fail goto*//*Label 34073*/ GIMT_Encode4(2379720), // Rule ID 53376 //
     /* 2379677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2379680 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2379697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379702 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379704 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379718 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379719 */     // GIR_Coverage, 53376,
     /* 2379719 */     GIR_EraseRootFromParent_Done,
     /* 2379720 */   // Label 34073: @2379720
     /* 2379720 */   GIM_Try, /*On fail goto*//*Label 34074*/ GIMT_Encode4(2379768), // Rule ID 53377 //
     /* 2379725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2379728 */     // (strict_fsub:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2379731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E32),
     /* 2379745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379747 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379750 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379752 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2379763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379767 */     // GIR_Coverage, 53377,
     /* 2379767 */     GIR_EraseRootFromParent_Done,
     /* 2379768 */   // Label 34074: @2379768
     /* 2379768 */   GIM_Reject,
     /* 2379769 */ // Label 34072: @2379769
     /* 2379769 */ GIM_Reject,
     /* 2379770 */ // Label 34033: @2379770
     /* 2379770 */ GIM_Try, /*On fail goto*//*Label 34075*/ GIMT_Encode4(2379890),
     /* 2379775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2379778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2379781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379789 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2379793 */   GIM_Try, /*On fail goto*//*Label 34076*/ GIMT_Encode4(2379841), // Rule ID 53472 //
     /* 2379798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2379801 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2379818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379839 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379840 */     // GIR_Coverage, 53472,
     /* 2379840 */     GIR_EraseRootFromParent_Done,
     /* 2379841 */   // Label 34076: @2379841
     /* 2379841 */   GIM_Try, /*On fail goto*//*Label 34077*/ GIMT_Encode4(2379889), // Rule ID 53473 //
     /* 2379846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2379849 */     // (strict_fsub:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2379852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E64),
     /* 2379866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2379884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379887 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379888 */     // GIR_Coverage, 53473,
     /* 2379888 */     GIR_EraseRootFromParent_Done,
     /* 2379889 */   // Label 34077: @2379889
     /* 2379889 */   GIM_Reject,
     /* 2379890 */ // Label 34075: @2379890
     /* 2379890 */ GIM_Reject,
     /* 2379891 */ // Label 34034: @2379891
     /* 2379891 */ GIM_Try, /*On fail goto*//*Label 34078*/ GIMT_Encode4(2380011),
     /* 2379896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2379899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2379902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379910 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2379914 */   GIM_Try, /*On fail goto*//*Label 34079*/ GIMT_Encode4(2379962), // Rule ID 53364 //
     /* 2379919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2379922 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2379922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2379939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379946 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2379954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2379957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2379960 */     GIR_RootConstrainSelectedInstOperands,
     /* 2379961 */     // GIR_Coverage, 53364,
     /* 2379961 */     GIR_EraseRootFromParent_Done,
     /* 2379962 */   // Label 34079: @2379962
     /* 2379962 */   GIM_Try, /*On fail goto*//*Label 34080*/ GIMT_Encode4(2380010), // Rule ID 53365 //
     /* 2379967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2379970 */     // (strict_fsub:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSUB_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2379970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2379973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2379977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2379982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2379984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M1_E16),
     /* 2379987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2379989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2379992 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2379994 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2379996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2379999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380008 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380009 */     // GIR_Coverage, 53365,
     /* 2380009 */     GIR_EraseRootFromParent_Done,
     /* 2380010 */   // Label 34080: @2380010
     /* 2380010 */   GIM_Reject,
     /* 2380011 */ // Label 34078: @2380011
     /* 2380011 */ GIM_Reject,
     /* 2380012 */ // Label 34035: @2380012
     /* 2380012 */ GIM_Try, /*On fail goto*//*Label 34081*/ GIMT_Encode4(2380132),
     /* 2380017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2380020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2380023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380031 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380035 */   GIM_Try, /*On fail goto*//*Label 34082*/ GIMT_Encode4(2380083), // Rule ID 53436 //
     /* 2380040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2380043 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2380046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2380060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380081 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380082 */     // GIR_Coverage, 53436,
     /* 2380082 */     GIR_EraseRootFromParent_Done,
     /* 2380083 */   // Label 34082: @2380083
     /* 2380083 */   GIM_Try, /*On fail goto*//*Label 34083*/ GIMT_Encode4(2380131), // Rule ID 53437 //
     /* 2380088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2380091 */     // (strict_fsub:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2380094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E32),
     /* 2380108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380129 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380130 */     // GIR_Coverage, 53437,
     /* 2380130 */     GIR_EraseRootFromParent_Done,
     /* 2380131 */   // Label 34083: @2380131
     /* 2380131 */   GIM_Reject,
     /* 2380132 */ // Label 34081: @2380132
     /* 2380132 */ GIM_Reject,
     /* 2380133 */ // Label 34036: @2380133
     /* 2380133 */ GIM_Try, /*On fail goto*//*Label 34084*/ GIMT_Encode4(2380253),
     /* 2380138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2380141 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2380144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380148 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380152 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380156 */   GIM_Try, /*On fail goto*//*Label 34085*/ GIMT_Encode4(2380204), // Rule ID 53484 //
     /* 2380161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2380164 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2380167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2380181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380202 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380203 */     // GIR_Coverage, 53484,
     /* 2380203 */     GIR_EraseRootFromParent_Done,
     /* 2380204 */   // Label 34085: @2380204
     /* 2380204 */   GIM_Try, /*On fail goto*//*Label 34086*/ GIMT_Encode4(2380252), // Rule ID 53485 //
     /* 2380209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2380212 */     // (strict_fsub:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2380215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E64),
     /* 2380229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380234 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380236 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380250 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380251 */     // GIR_Coverage, 53485,
     /* 2380251 */     GIR_EraseRootFromParent_Done,
     /* 2380252 */   // Label 34086: @2380252
     /* 2380252 */   GIM_Reject,
     /* 2380253 */ // Label 34084: @2380253
     /* 2380253 */ GIM_Reject,
     /* 2380254 */ // Label 34037: @2380254
     /* 2380254 */ GIM_Try, /*On fail goto*//*Label 34087*/ GIMT_Encode4(2380374),
     /* 2380259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2380262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2380265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380269 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380273 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2380277 */   GIM_Try, /*On fail goto*//*Label 34088*/ GIMT_Encode4(2380325), // Rule ID 53400 //
     /* 2380282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2380285 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2380302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380324 */     // GIR_Coverage, 53400,
     /* 2380324 */     GIR_EraseRootFromParent_Done,
     /* 2380325 */   // Label 34088: @2380325
     /* 2380325 */   GIM_Try, /*On fail goto*//*Label 34089*/ GIMT_Encode4(2380373), // Rule ID 53401 //
     /* 2380330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2380333 */     // (strict_fsub:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSUB_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2380336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M2_E16),
     /* 2380350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380352 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380372 */     // GIR_Coverage, 53401,
     /* 2380372 */     GIR_EraseRootFromParent_Done,
     /* 2380373 */   // Label 34089: @2380373
     /* 2380373 */   GIM_Reject,
     /* 2380374 */ // Label 34087: @2380374
     /* 2380374 */ GIM_Reject,
     /* 2380375 */ // Label 34038: @2380375
     /* 2380375 */ GIM_Try, /*On fail goto*//*Label 34090*/ GIMT_Encode4(2380495),
     /* 2380380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2380383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2380386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380394 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380398 */   GIM_Try, /*On fail goto*//*Label 34091*/ GIMT_Encode4(2380446), // Rule ID 53448 //
     /* 2380403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2380406 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2380423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380425 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380428 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380430 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380444 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380445 */     // GIR_Coverage, 53448,
     /* 2380445 */     GIR_EraseRootFromParent_Done,
     /* 2380446 */   // Label 34091: @2380446
     /* 2380446 */   GIM_Try, /*On fail goto*//*Label 34092*/ GIMT_Encode4(2380494), // Rule ID 53449 //
     /* 2380451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2380454 */     // (strict_fsub:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2380457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E32),
     /* 2380471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380492 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380493 */     // GIR_Coverage, 53449,
     /* 2380493 */     GIR_EraseRootFromParent_Done,
     /* 2380494 */   // Label 34092: @2380494
     /* 2380494 */   GIM_Reject,
     /* 2380495 */ // Label 34090: @2380495
     /* 2380495 */ GIM_Reject,
     /* 2380496 */ // Label 34039: @2380496
     /* 2380496 */ GIM_Try, /*On fail goto*//*Label 34093*/ GIMT_Encode4(2380616),
     /* 2380501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2380504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2380507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380515 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380519 */   GIM_Try, /*On fail goto*//*Label 34094*/ GIMT_Encode4(2380567), // Rule ID 53496 //
     /* 2380524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2380527 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2380544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380566 */     // GIR_Coverage, 53496,
     /* 2380566 */     GIR_EraseRootFromParent_Done,
     /* 2380567 */   // Label 34094: @2380567
     /* 2380567 */   GIM_Try, /*On fail goto*//*Label 34095*/ GIMT_Encode4(2380615), // Rule ID 53497 //
     /* 2380572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2380575 */     // (strict_fsub:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2380578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E64),
     /* 2380592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2380610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380614 */     // GIR_Coverage, 53497,
     /* 2380614 */     GIR_EraseRootFromParent_Done,
     /* 2380615 */   // Label 34095: @2380615
     /* 2380615 */   GIM_Reject,
     /* 2380616 */ // Label 34093: @2380616
     /* 2380616 */ GIM_Reject,
     /* 2380617 */ // Label 34040: @2380617
     /* 2380617 */ GIM_Try, /*On fail goto*//*Label 34096*/ GIMT_Encode4(2380737),
     /* 2380622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2380625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2380628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380636 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2380640 */   GIM_Try, /*On fail goto*//*Label 34097*/ GIMT_Encode4(2380688), // Rule ID 53412 //
     /* 2380645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2380648 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2380665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380672 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380687 */     // GIR_Coverage, 53412,
     /* 2380687 */     GIR_EraseRootFromParent_Done,
     /* 2380688 */   // Label 34097: @2380688
     /* 2380688 */   GIM_Try, /*On fail goto*//*Label 34098*/ GIMT_Encode4(2380736), // Rule ID 53413 //
     /* 2380693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2380696 */     // (strict_fsub:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSUB_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2380699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380708 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M4_E16),
     /* 2380713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380715 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380718 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380734 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380735 */     // GIR_Coverage, 53413,
     /* 2380735 */     GIR_EraseRootFromParent_Done,
     /* 2380736 */   // Label 34098: @2380736
     /* 2380736 */   GIM_Reject,
     /* 2380737 */ // Label 34096: @2380737
     /* 2380737 */ GIM_Reject,
     /* 2380738 */ // Label 34041: @2380738
     /* 2380738 */ GIM_Try, /*On fail goto*//*Label 34099*/ GIMT_Encode4(2380858),
     /* 2380743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2380746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2380749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380753 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380757 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380761 */   GIM_Try, /*On fail goto*//*Label 34100*/ GIMT_Encode4(2380809), // Rule ID 53460 //
     /* 2380766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2380769 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2380786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380788 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380791 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380808 */     // GIR_Coverage, 53460,
     /* 2380808 */     GIR_EraseRootFromParent_Done,
     /* 2380809 */   // Label 34100: @2380809
     /* 2380809 */   GIM_Try, /*On fail goto*//*Label 34101*/ GIMT_Encode4(2380857), // Rule ID 53461 //
     /* 2380814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2380817 */     // (strict_fsub:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2380820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E32),
     /* 2380834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380836 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380841 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2380852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380856 */     // GIR_Coverage, 53461,
     /* 2380856 */     GIR_EraseRootFromParent_Done,
     /* 2380857 */   // Label 34101: @2380857
     /* 2380857 */   GIM_Reject,
     /* 2380858 */ // Label 34099: @2380858
     /* 2380858 */ GIM_Reject,
     /* 2380859 */ // Label 34042: @2380859
     /* 2380859 */ GIM_Try, /*On fail goto*//*Label 34102*/ GIMT_Encode4(2380979),
     /* 2380864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2380867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2380870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2380882 */   GIM_Try, /*On fail goto*//*Label 34103*/ GIMT_Encode4(2380930), // Rule ID 53424 //
     /* 2380887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2380890 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2380890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380902 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2380907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380909 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380912 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380914 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380928 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380929 */     // GIR_Coverage, 53424,
     /* 2380929 */     GIR_EraseRootFromParent_Done,
     /* 2380930 */   // Label 34103: @2380930
     /* 2380930 */   GIM_Try, /*On fail goto*//*Label 34104*/ GIMT_Encode4(2380978), // Rule ID 53425 //
     /* 2380935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2380938 */     // (strict_fsub:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSUB_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2380938 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2380941 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2380945 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2380950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2380952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSUB_VV_M8_E16),
     /* 2380955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2380957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2380960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2380962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2380964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2380967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2380970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2380973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2380976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2380977 */     // GIR_Coverage, 53425,
     /* 2380977 */     GIR_EraseRootFromParent_Done,
     /* 2380978 */   // Label 34104: @2380978
     /* 2380978 */   GIM_Reject,
     /* 2380979 */ // Label 34102: @2380979
     /* 2380979 */ GIM_Reject,
     /* 2380980 */ // Label 34043: @2380980
     /* 2380980 */ GIM_Reject,
     /* 2380981 */ // Label 100: @2380981
     /* 2380981 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34123*/ GIMT_Encode4(2383408),
     /* 2380992 */ /*GILLT_s16*//*Label 34105*/ GIMT_Encode4(2381112),
     /* 2380996 */ /*GILLT_s32*//*Label 34106*/ GIMT_Encode4(2381261),
     /* 2381000 */ /*GILLT_s64*//*Label 34107*/ GIMT_Encode4(2381410), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381012 */ /*GILLT_nxv1s16*//*Label 34108*/ GIMT_Encode4(2381593),
     /* 2381016 */ /*GILLT_nxv1s32*//*Label 34109*/ GIMT_Encode4(2381714),
     /* 2381020 */ /*GILLT_nxv1s64*//*Label 34110*/ GIMT_Encode4(2381835), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381032 */ /*GILLT_nxv2s16*//*Label 34111*/ GIMT_Encode4(2381956),
     /* 2381036 */ /*GILLT_nxv2s32*//*Label 34112*/ GIMT_Encode4(2382077),
     /* 2381040 */ /*GILLT_nxv2s64*//*Label 34113*/ GIMT_Encode4(2382198), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381052 */ /*GILLT_nxv4s16*//*Label 34114*/ GIMT_Encode4(2382319),
     /* 2381056 */ /*GILLT_nxv4s32*//*Label 34115*/ GIMT_Encode4(2382440),
     /* 2381060 */ /*GILLT_nxv4s64*//*Label 34116*/ GIMT_Encode4(2382561), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381072 */ /*GILLT_nxv8s16*//*Label 34117*/ GIMT_Encode4(2382682),
     /* 2381076 */ /*GILLT_nxv8s32*//*Label 34118*/ GIMT_Encode4(2382803),
     /* 2381080 */ /*GILLT_nxv8s64*//*Label 34119*/ GIMT_Encode4(2382924), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381092 */ /*GILLT_nxv16s16*//*Label 34120*/ GIMT_Encode4(2383045),
     /* 2381096 */ /*GILLT_nxv16s32*//*Label 34121*/ GIMT_Encode4(2383166), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2381108 */ /*GILLT_nxv32s16*//*Label 34122*/ GIMT_Encode4(2383287),
     /* 2381112 */ // Label 34105: @2381112
     /* 2381112 */ GIM_Try, /*On fail goto*//*Label 34124*/ GIMT_Encode4(2381260),
     /* 2381117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2381120 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2381123 */   GIM_Try, /*On fail goto*//*Label 34125*/ GIMT_Encode4(2381157), // Rule ID 1862 //
     /* 2381128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2381131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381143 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2381143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2381146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381148 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381150 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381156 */     // GIR_Coverage, 1862,
     /* 2381156 */     GIR_EraseRootFromParent_Done,
     /* 2381157 */   // Label 34125: @2381157
     /* 2381157 */   GIM_Try, /*On fail goto*//*Label 34126*/ GIMT_Encode4(2381191), // Rule ID 1863 //
     /* 2381162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2381165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2381177 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FMUL_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2381177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H),
     /* 2381180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381190 */     // GIR_Coverage, 1863,
     /* 2381190 */     GIR_EraseRootFromParent_Done,
     /* 2381191 */   // Label 34126: @2381191
     /* 2381191 */   GIM_Try, /*On fail goto*//*Label 34127*/ GIMT_Encode4(2381225), // Rule ID 1866 //
     /* 2381196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2381199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381211 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2381211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2381214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381216 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381218 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381224 */     // GIR_Coverage, 1866,
     /* 2381224 */     GIR_EraseRootFromParent_Done,
     /* 2381225 */   // Label 34127: @2381225
     /* 2381225 */   GIM_Try, /*On fail goto*//*Label 34128*/ GIMT_Encode4(2381259), // Rule ID 1867 //
     /* 2381230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2381233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2381245 */     // (strict_fmul:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FMUL_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2381245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_H_INX),
     /* 2381248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381250 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381252 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381258 */     // GIR_Coverage, 1867,
     /* 2381258 */     GIR_EraseRootFromParent_Done,
     /* 2381259 */   // Label 34128: @2381259
     /* 2381259 */   GIM_Reject,
     /* 2381260 */ // Label 34124: @2381260
     /* 2381260 */ GIM_Reject,
     /* 2381261 */ // Label 34106: @2381261
     /* 2381261 */ GIM_Try, /*On fail goto*//*Label 34129*/ GIMT_Encode4(2381409),
     /* 2381266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2381269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2381272 */   GIM_Try, /*On fail goto*//*Label 34130*/ GIMT_Encode4(2381306), // Rule ID 1153 //
     /* 2381277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2381280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381284 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381292 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2381292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2381295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381305 */     // GIR_Coverage, 1153,
     /* 2381305 */     GIR_EraseRootFromParent_Done,
     /* 2381306 */   // Label 34130: @2381306
     /* 2381306 */   GIM_Try, /*On fail goto*//*Label 34131*/ GIMT_Encode4(2381340), // Rule ID 1154 //
     /* 2381311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2381314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2381326 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FMUL_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2381326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S),
     /* 2381329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381333 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381339 */     // GIR_Coverage, 1154,
     /* 2381339 */     GIR_EraseRootFromParent_Done,
     /* 2381340 */   // Label 34131: @2381340
     /* 2381340 */   GIM_Try, /*On fail goto*//*Label 34132*/ GIMT_Encode4(2381374), // Rule ID 1157 //
     /* 2381345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2381348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381360 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2381360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2381363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381365 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381373 */     // GIR_Coverage, 1157,
     /* 2381373 */     GIR_EraseRootFromParent_Done,
     /* 2381374 */   // Label 34132: @2381374
     /* 2381374 */   GIM_Try, /*On fail goto*//*Label 34133*/ GIMT_Encode4(2381408), // Rule ID 1158 //
     /* 2381379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2381382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2381394 */     // (strict_fmul:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FMUL_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2381394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_S_INX),
     /* 2381397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381407 */     // GIR_Coverage, 1158,
     /* 2381407 */     GIR_EraseRootFromParent_Done,
     /* 2381408 */   // Label 34133: @2381408
     /* 2381408 */   GIM_Reject,
     /* 2381409 */ // Label 34129: @2381409
     /* 2381409 */ GIM_Reject,
     /* 2381410 */ // Label 34107: @2381410
     /* 2381410 */ GIM_Try, /*On fail goto*//*Label 34134*/ GIMT_Encode4(2381592),
     /* 2381415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2381418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2381421 */   GIM_Try, /*On fail goto*//*Label 34135*/ GIMT_Encode4(2381455), // Rule ID 1492 //
     /* 2381426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2381429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381441 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2381441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2381444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381454 */     // GIR_Coverage, 1492,
     /* 2381454 */     GIR_EraseRootFromParent_Done,
     /* 2381455 */   // Label 34135: @2381455
     /* 2381455 */   GIM_Try, /*On fail goto*//*Label 34136*/ GIMT_Encode4(2381489), // Rule ID 1493 //
     /* 2381460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2381463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2381475 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FMUL_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2381475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D),
     /* 2381478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381488 */     // GIR_Coverage, 1493,
     /* 2381488 */     GIR_EraseRootFromParent_Done,
     /* 2381489 */   // Label 34136: @2381489
     /* 2381489 */   GIM_Try, /*On fail goto*//*Label 34137*/ GIMT_Encode4(2381523), // Rule ID 1496 //
     /* 2381494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2381497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381509 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2381509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2381512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381514 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381516 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381521 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381522 */     // GIR_Coverage, 1496,
     /* 2381522 */     GIR_EraseRootFromParent_Done,
     /* 2381523 */   // Label 34137: @2381523
     /* 2381523 */   GIM_Try, /*On fail goto*//*Label 34138*/ GIMT_Encode4(2381557), // Rule ID 1497 //
     /* 2381528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2381531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2381543 */     // (strict_fmul:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FMUL_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2381543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_IN32X),
     /* 2381546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381556 */     // GIR_Coverage, 1497,
     /* 2381556 */     GIR_EraseRootFromParent_Done,
     /* 2381557 */   // Label 34138: @2381557
     /* 2381557 */   GIM_Try, /*On fail goto*//*Label 34139*/ GIMT_Encode4(2381591), // Rule ID 1500 //
     /* 2381562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2381565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2381577 */     // (strict_fmul:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FMUL_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2381577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMUL_D_INX),
     /* 2381580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381582 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381584 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381589 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381590 */     // GIR_Coverage, 1500,
     /* 2381590 */     GIR_EraseRootFromParent_Done,
     /* 2381591 */   // Label 34139: @2381591
     /* 2381591 */   GIM_Reject,
     /* 2381592 */ // Label 34134: @2381592
     /* 2381592 */ GIM_Reject,
     /* 2381593 */ // Label 34108: @2381593
     /* 2381593 */ GIM_Try, /*On fail goto*//*Label 34140*/ GIMT_Encode4(2381713),
     /* 2381598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2381601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2381604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381612 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381616 */   GIM_Try, /*On fail goto*//*Label 34141*/ GIMT_Encode4(2381664), // Rule ID 54096 //
     /* 2381621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2381624 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381636 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2381641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381648 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381663 */     // GIR_Coverage, 54096,
     /* 2381663 */     GIR_EraseRootFromParent_Done,
     /* 2381664 */   // Label 34141: @2381664
     /* 2381664 */   GIM_Try, /*On fail goto*//*Label 34142*/ GIMT_Encode4(2381712), // Rule ID 54097 //
     /* 2381669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2381672 */     // (strict_fmul:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2381675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF4_E16),
     /* 2381689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2381707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381710 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381711 */     // GIR_Coverage, 54097,
     /* 2381711 */     GIR_EraseRootFromParent_Done,
     /* 2381712 */   // Label 34142: @2381712
     /* 2381712 */   GIM_Reject,
     /* 2381713 */ // Label 34140: @2381713
     /* 2381713 */ GIM_Reject,
     /* 2381714 */ // Label 34109: @2381714
     /* 2381714 */ GIM_Try, /*On fail goto*//*Label 34143*/ GIMT_Encode4(2381834),
     /* 2381719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2381722 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2381725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381729 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381733 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381737 */   GIM_Try, /*On fail goto*//*Label 34144*/ GIMT_Encode4(2381785), // Rule ID 54120 //
     /* 2381742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2381745 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381757 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2381762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381784 */     // GIR_Coverage, 54120,
     /* 2381784 */     GIR_EraseRootFromParent_Done,
     /* 2381785 */   // Label 34144: @2381785
     /* 2381785 */   GIM_Try, /*On fail goto*//*Label 34145*/ GIMT_Encode4(2381833), // Rule ID 54121 //
     /* 2381790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2381793 */     // (strict_fmul:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2381796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E32),
     /* 2381810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2381828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381832 */     // GIR_Coverage, 54121,
     /* 2381832 */     GIR_EraseRootFromParent_Done,
     /* 2381833 */   // Label 34145: @2381833
     /* 2381833 */   GIM_Reject,
     /* 2381834 */ // Label 34143: @2381834
     /* 2381834 */ GIM_Reject,
     /* 2381835 */ // Label 34110: @2381835
     /* 2381835 */ GIM_Try, /*On fail goto*//*Label 34146*/ GIMT_Encode4(2381955),
     /* 2381840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2381843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2381846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381854 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381858 */   GIM_Try, /*On fail goto*//*Label 34147*/ GIMT_Encode4(2381906), // Rule ID 54156 //
     /* 2381863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2381866 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2381883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381905 */     // GIR_Coverage, 54156,
     /* 2381905 */     GIR_EraseRootFromParent_Done,
     /* 2381906 */   // Label 34147: @2381906
     /* 2381906 */   GIM_Try, /*On fail goto*//*Label 34148*/ GIMT_Encode4(2381954), // Rule ID 54157 //
     /* 2381911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2381914 */     // (strict_fmul:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2381914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2381917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2381928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E64),
     /* 2381931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2381933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2381936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2381938 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2381940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2381943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2381946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2381949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2381952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2381953 */     // GIR_Coverage, 54157,
     /* 2381953 */     GIR_EraseRootFromParent_Done,
     /* 2381954 */   // Label 34148: @2381954
     /* 2381954 */   GIM_Reject,
     /* 2381955 */ // Label 34146: @2381955
     /* 2381955 */ GIM_Reject,
     /* 2381956 */ // Label 34111: @2381956
     /* 2381956 */ GIM_Try, /*On fail goto*//*Label 34149*/ GIMT_Encode4(2382076),
     /* 2381961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2381964 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2381967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381975 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2381979 */   GIM_Try, /*On fail goto*//*Label 34150*/ GIMT_Encode4(2382027), // Rule ID 54108 //
     /* 2381984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2381987 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2381987 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2381990 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2381994 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2381999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2382004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382006 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382009 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382011 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382022 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382025 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382026 */     // GIR_Coverage, 54108,
     /* 2382026 */     GIR_EraseRootFromParent_Done,
     /* 2382027 */   // Label 34150: @2382027
     /* 2382027 */   GIM_Try, /*On fail goto*//*Label 34151*/ GIMT_Encode4(2382075), // Rule ID 54109 //
     /* 2382032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382035 */     // (strict_fmul:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMUL_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2382038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_MF2_E16),
     /* 2382052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382057 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382073 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382074 */     // GIR_Coverage, 54109,
     /* 2382074 */     GIR_EraseRootFromParent_Done,
     /* 2382075 */   // Label 34151: @2382075
     /* 2382075 */   GIM_Reject,
     /* 2382076 */ // Label 34149: @2382076
     /* 2382076 */ GIM_Reject,
     /* 2382077 */ // Label 34112: @2382077
     /* 2382077 */ GIM_Try, /*On fail goto*//*Label 34152*/ GIMT_Encode4(2382197),
     /* 2382082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2382085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2382088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382096 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382100 */   GIM_Try, /*On fail goto*//*Label 34153*/ GIMT_Encode4(2382148), // Rule ID 54144 //
     /* 2382105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2382108 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2382125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382146 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382147 */     // GIR_Coverage, 54144,
     /* 2382147 */     GIR_EraseRootFromParent_Done,
     /* 2382148 */   // Label 34153: @2382148
     /* 2382148 */   GIM_Try, /*On fail goto*//*Label 34154*/ GIMT_Encode4(2382196), // Rule ID 54145 //
     /* 2382153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2382156 */     // (strict_fmul:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2382159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E32),
     /* 2382173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382178 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382180 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382194 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382195 */     // GIR_Coverage, 54145,
     /* 2382195 */     GIR_EraseRootFromParent_Done,
     /* 2382196 */   // Label 34154: @2382196
     /* 2382196 */   GIM_Reject,
     /* 2382197 */ // Label 34152: @2382197
     /* 2382197 */ GIM_Reject,
     /* 2382198 */ // Label 34113: @2382198
     /* 2382198 */ GIM_Try, /*On fail goto*//*Label 34155*/ GIMT_Encode4(2382318),
     /* 2382203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2382206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2382209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382217 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382221 */   GIM_Try, /*On fail goto*//*Label 34156*/ GIMT_Encode4(2382269), // Rule ID 54240 //
     /* 2382226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2382229 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2382246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382251 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382253 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382268 */     // GIR_Coverage, 54240,
     /* 2382268 */     GIR_EraseRootFromParent_Done,
     /* 2382269 */   // Label 34156: @2382269
     /* 2382269 */   GIM_Try, /*On fail goto*//*Label 34157*/ GIMT_Encode4(2382317), // Rule ID 54241 //
     /* 2382274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2382277 */     // (strict_fmul:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2382280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E64),
     /* 2382294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382296 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382299 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382301 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382316 */     // GIR_Coverage, 54241,
     /* 2382316 */     GIR_EraseRootFromParent_Done,
     /* 2382317 */   // Label 34157: @2382317
     /* 2382317 */   GIM_Reject,
     /* 2382318 */ // Label 34155: @2382318
     /* 2382318 */ GIM_Reject,
     /* 2382319 */ // Label 34114: @2382319
     /* 2382319 */ GIM_Try, /*On fail goto*//*Label 34158*/ GIMT_Encode4(2382439),
     /* 2382324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2382327 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2382330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382338 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2382342 */   GIM_Try, /*On fail goto*//*Label 34159*/ GIMT_Encode4(2382390), // Rule ID 54132 //
     /* 2382347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2382350 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382362 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2382367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382372 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382376 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382388 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382389 */     // GIR_Coverage, 54132,
     /* 2382389 */     GIR_EraseRootFromParent_Done,
     /* 2382390 */   // Label 34159: @2382390
     /* 2382390 */   GIM_Try, /*On fail goto*//*Label 34160*/ GIMT_Encode4(2382438), // Rule ID 54133 //
     /* 2382395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382398 */     // (strict_fmul:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMUL_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2382401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M1_E16),
     /* 2382415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382436 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382437 */     // GIR_Coverage, 54133,
     /* 2382437 */     GIR_EraseRootFromParent_Done,
     /* 2382438 */   // Label 34160: @2382438
     /* 2382438 */   GIM_Reject,
     /* 2382439 */ // Label 34158: @2382439
     /* 2382439 */ GIM_Reject,
     /* 2382440 */ // Label 34115: @2382440
     /* 2382440 */ GIM_Try, /*On fail goto*//*Label 34161*/ GIMT_Encode4(2382560),
     /* 2382445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2382448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2382451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382459 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382463 */   GIM_Try, /*On fail goto*//*Label 34162*/ GIMT_Encode4(2382511), // Rule ID 54204 //
     /* 2382468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2382471 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2382488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382495 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382509 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382510 */     // GIR_Coverage, 54204,
     /* 2382510 */     GIR_EraseRootFromParent_Done,
     /* 2382511 */   // Label 34162: @2382511
     /* 2382511 */   GIM_Try, /*On fail goto*//*Label 34163*/ GIMT_Encode4(2382559), // Rule ID 54205 //
     /* 2382516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2382519 */     // (strict_fmul:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2382522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E32),
     /* 2382536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382558 */     // GIR_Coverage, 54205,
     /* 2382558 */     GIR_EraseRootFromParent_Done,
     /* 2382559 */   // Label 34163: @2382559
     /* 2382559 */   GIM_Reject,
     /* 2382560 */ // Label 34161: @2382560
     /* 2382560 */ GIM_Reject,
     /* 2382561 */ // Label 34116: @2382561
     /* 2382561 */ GIM_Try, /*On fail goto*//*Label 34164*/ GIMT_Encode4(2382681),
     /* 2382566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2382569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2382572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382580 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382584 */   GIM_Try, /*On fail goto*//*Label 34165*/ GIMT_Encode4(2382632), // Rule ID 54252 //
     /* 2382589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2382592 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2382609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382614 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382616 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382630 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382631 */     // GIR_Coverage, 54252,
     /* 2382631 */     GIR_EraseRootFromParent_Done,
     /* 2382632 */   // Label 34165: @2382632
     /* 2382632 */   GIM_Try, /*On fail goto*//*Label 34166*/ GIMT_Encode4(2382680), // Rule ID 54253 //
     /* 2382637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2382640 */     // (strict_fmul:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2382643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382652 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E64),
     /* 2382657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382662 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382664 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382678 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382679 */     // GIR_Coverage, 54253,
     /* 2382679 */     GIR_EraseRootFromParent_Done,
     /* 2382680 */   // Label 34166: @2382680
     /* 2382680 */   GIM_Reject,
     /* 2382681 */ // Label 34164: @2382681
     /* 2382681 */ GIM_Reject,
     /* 2382682 */ // Label 34117: @2382682
     /* 2382682 */ GIM_Try, /*On fail goto*//*Label 34167*/ GIMT_Encode4(2382802),
     /* 2382687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2382690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2382693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382701 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2382705 */   GIM_Try, /*On fail goto*//*Label 34168*/ GIMT_Encode4(2382753), // Rule ID 54168 //
     /* 2382710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2382713 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2382730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382735 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382752 */     // GIR_Coverage, 54168,
     /* 2382752 */     GIR_EraseRootFromParent_Done,
     /* 2382753 */   // Label 34168: @2382753
     /* 2382753 */   GIM_Try, /*On fail goto*//*Label 34169*/ GIMT_Encode4(2382801), // Rule ID 54169 //
     /* 2382758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2382761 */     // (strict_fmul:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMUL_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2382764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382773 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M2_E16),
     /* 2382778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382783 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382785 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2382796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382799 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382800 */     // GIR_Coverage, 54169,
     /* 2382800 */     GIR_EraseRootFromParent_Done,
     /* 2382801 */   // Label 34169: @2382801
     /* 2382801 */   GIM_Reject,
     /* 2382802 */ // Label 34167: @2382802
     /* 2382802 */ GIM_Reject,
     /* 2382803 */ // Label 34118: @2382803
     /* 2382803 */ GIM_Try, /*On fail goto*//*Label 34170*/ GIMT_Encode4(2382923),
     /* 2382808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2382811 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2382814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382822 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2382826 */   GIM_Try, /*On fail goto*//*Label 34171*/ GIMT_Encode4(2382874), // Rule ID 54216 //
     /* 2382831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2382834 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382846 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2382851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382858 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382872 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382873 */     // GIR_Coverage, 54216,
     /* 2382873 */     GIR_EraseRootFromParent_Done,
     /* 2382874 */   // Label 34171: @2382874
     /* 2382874 */   GIM_Try, /*On fail goto*//*Label 34172*/ GIMT_Encode4(2382922), // Rule ID 54217 //
     /* 2382879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2382882 */     // (strict_fmul:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2382882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2382885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382894 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E32),
     /* 2382899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382904 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382906 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2382917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382921 */     // GIR_Coverage, 54217,
     /* 2382921 */     GIR_EraseRootFromParent_Done,
     /* 2382922 */   // Label 34172: @2382922
     /* 2382922 */   GIM_Reject,
     /* 2382923 */ // Label 34170: @2382923
     /* 2382923 */ GIM_Reject,
     /* 2382924 */ // Label 34119: @2382924
     /* 2382924 */ GIM_Try, /*On fail goto*//*Label 34173*/ GIMT_Encode4(2383044),
     /* 2382929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2382932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2382935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382943 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2382947 */   GIM_Try, /*On fail goto*//*Label 34174*/ GIMT_Encode4(2382995), // Rule ID 54264 //
     /* 2382952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2382955 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2382955 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2382958 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2382962 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2382967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2382969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2382972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2382974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2382977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2382979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2382981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2382984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2382987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2382990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2382993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2382994 */     // GIR_Coverage, 54264,
     /* 2382994 */     GIR_EraseRootFromParent_Done,
     /* 2382995 */   // Label 34174: @2382995
     /* 2382995 */   GIM_Try, /*On fail goto*//*Label 34175*/ GIMT_Encode4(2383043), // Rule ID 54265 //
     /* 2383000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2383003 */     // (strict_fmul:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2383006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383015 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E64),
     /* 2383020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383025 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383027 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2383038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383042 */     // GIR_Coverage, 54265,
     /* 2383042 */     GIR_EraseRootFromParent_Done,
     /* 2383043 */   // Label 34175: @2383043
     /* 2383043 */   GIM_Reject,
     /* 2383044 */ // Label 34173: @2383044
     /* 2383044 */ GIM_Reject,
     /* 2383045 */ // Label 34120: @2383045
     /* 2383045 */ GIM_Try, /*On fail goto*//*Label 34176*/ GIMT_Encode4(2383165),
     /* 2383050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2383053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2383056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2383068 */   GIM_Try, /*On fail goto*//*Label 34177*/ GIMT_Encode4(2383116), // Rule ID 54180 //
     /* 2383073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2383076 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2383093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383098 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383100 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383115 */     // GIR_Coverage, 54180,
     /* 2383115 */     GIR_EraseRootFromParent_Done,
     /* 2383116 */   // Label 34177: @2383116
     /* 2383116 */   GIM_Try, /*On fail goto*//*Label 34178*/ GIMT_Encode4(2383164), // Rule ID 54181 //
     /* 2383121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2383124 */     // (strict_fmul:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMUL_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2383127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M4_E16),
     /* 2383141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383148 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383163 */     // GIR_Coverage, 54181,
     /* 2383163 */     GIR_EraseRootFromParent_Done,
     /* 2383164 */   // Label 34178: @2383164
     /* 2383164 */   GIM_Reject,
     /* 2383165 */ // Label 34176: @2383165
     /* 2383165 */ GIM_Reject,
     /* 2383166 */ // Label 34121: @2383166
     /* 2383166 */ GIM_Try, /*On fail goto*//*Label 34179*/ GIMT_Encode4(2383286),
     /* 2383171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2383174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2383177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383189 */   GIM_Try, /*On fail goto*//*Label 34180*/ GIMT_Encode4(2383237), // Rule ID 54228 //
     /* 2383194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2383197 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2383214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383235 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383236 */     // GIR_Coverage, 54228,
     /* 2383236 */     GIR_EraseRootFromParent_Done,
     /* 2383237 */   // Label 34180: @2383237
     /* 2383237 */   GIM_Try, /*On fail goto*//*Label 34181*/ GIMT_Encode4(2383285), // Rule ID 54229 //
     /* 2383242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2383245 */     // (strict_fmul:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2383248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E32),
     /* 2383262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383264 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383267 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2383280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383284 */     // GIR_Coverage, 54229,
     /* 2383284 */     GIR_EraseRootFromParent_Done,
     /* 2383285 */   // Label 34181: @2383285
     /* 2383285 */   GIM_Reject,
     /* 2383286 */ // Label 34179: @2383286
     /* 2383286 */ GIM_Reject,
     /* 2383287 */ // Label 34122: @2383287
     /* 2383287 */ GIM_Try, /*On fail goto*//*Label 34182*/ GIMT_Encode4(2383407),
     /* 2383292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2383295 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2383298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383306 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2383310 */   GIM_Try, /*On fail goto*//*Label 34183*/ GIMT_Encode4(2383358), // Rule ID 54192 //
     /* 2383315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2383318 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2383318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2383335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383340 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383342 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383357 */     // GIR_Coverage, 54192,
     /* 2383357 */     GIR_EraseRootFromParent_Done,
     /* 2383358 */   // Label 34183: @2383358
     /* 2383358 */   GIM_Try, /*On fail goto*//*Label 34184*/ GIMT_Encode4(2383406), // Rule ID 54193 //
     /* 2383363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2383366 */     // (strict_fmul:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMUL_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2383366 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2383369 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2383373 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2383378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2383380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMUL_VV_M8_E16),
     /* 2383383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2383388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2383398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2383401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2383404 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383405 */     // GIR_Coverage, 54193,
     /* 2383405 */     GIR_EraseRootFromParent_Done,
     /* 2383406 */   // Label 34184: @2383406
     /* 2383406 */   GIM_Reject,
     /* 2383407 */ // Label 34182: @2383407
     /* 2383407 */ GIM_Reject,
     /* 2383408 */ // Label 34123: @2383408
     /* 2383408 */ GIM_Reject,
     /* 2383409 */ // Label 101: @2383409
     /* 2383409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34203*/ GIMT_Encode4(2385836),
     /* 2383420 */ /*GILLT_s16*//*Label 34185*/ GIMT_Encode4(2383540),
     /* 2383424 */ /*GILLT_s32*//*Label 34186*/ GIMT_Encode4(2383689),
     /* 2383428 */ /*GILLT_s64*//*Label 34187*/ GIMT_Encode4(2383838), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383440 */ /*GILLT_nxv1s16*//*Label 34188*/ GIMT_Encode4(2384021),
     /* 2383444 */ /*GILLT_nxv1s32*//*Label 34189*/ GIMT_Encode4(2384142),
     /* 2383448 */ /*GILLT_nxv1s64*//*Label 34190*/ GIMT_Encode4(2384263), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383460 */ /*GILLT_nxv2s16*//*Label 34191*/ GIMT_Encode4(2384384),
     /* 2383464 */ /*GILLT_nxv2s32*//*Label 34192*/ GIMT_Encode4(2384505),
     /* 2383468 */ /*GILLT_nxv2s64*//*Label 34193*/ GIMT_Encode4(2384626), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383480 */ /*GILLT_nxv4s16*//*Label 34194*/ GIMT_Encode4(2384747),
     /* 2383484 */ /*GILLT_nxv4s32*//*Label 34195*/ GIMT_Encode4(2384868),
     /* 2383488 */ /*GILLT_nxv4s64*//*Label 34196*/ GIMT_Encode4(2384989), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383500 */ /*GILLT_nxv8s16*//*Label 34197*/ GIMT_Encode4(2385110),
     /* 2383504 */ /*GILLT_nxv8s32*//*Label 34198*/ GIMT_Encode4(2385231),
     /* 2383508 */ /*GILLT_nxv8s64*//*Label 34199*/ GIMT_Encode4(2385352), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383520 */ /*GILLT_nxv16s16*//*Label 34200*/ GIMT_Encode4(2385473),
     /* 2383524 */ /*GILLT_nxv16s32*//*Label 34201*/ GIMT_Encode4(2385594), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2383536 */ /*GILLT_nxv32s16*//*Label 34202*/ GIMT_Encode4(2385715),
     /* 2383540 */ // Label 34185: @2383540
     /* 2383540 */ GIM_Try, /*On fail goto*//*Label 34204*/ GIMT_Encode4(2383688),
     /* 2383545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2383548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2383551 */   GIM_Try, /*On fail goto*//*Label 34205*/ GIMT_Encode4(2383585), // Rule ID 1870 //
     /* 2383556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2383559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383571 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2383571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2383574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383576 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383578 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383583 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383584 */     // GIR_Coverage, 1870,
     /* 2383584 */     GIR_EraseRootFromParent_Done,
     /* 2383585 */   // Label 34205: @2383585
     /* 2383585 */   GIM_Try, /*On fail goto*//*Label 34206*/ GIMT_Encode4(2383619), // Rule ID 1871 //
     /* 2383590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2383593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2383605 */     // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2)  =>  (FDIV_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2383605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H),
     /* 2383608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383610 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383612 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383618 */     // GIR_Coverage, 1871,
     /* 2383618 */     GIR_EraseRootFromParent_Done,
     /* 2383619 */   // Label 34206: @2383619
     /* 2383619 */   GIM_Try, /*On fail goto*//*Label 34207*/ GIMT_Encode4(2383653), // Rule ID 1874 //
     /* 2383624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2383627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383639 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i64] })
     /* 2383639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2383642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383644 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383651 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383652 */     // GIR_Coverage, 1874,
     /* 2383652 */     GIR_EraseRootFromParent_Done,
     /* 2383653 */   // Label 34207: @2383653
     /* 2383653 */   GIM_Try, /*On fail goto*//*Label 34208*/ GIMT_Encode4(2383687), // Rule ID 1875 //
     /* 2383658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2383661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2383673 */     // (strict_fdiv:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2)  =>  (FDIV_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, 7:{ *:[i32] })
     /* 2383673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_H_INX),
     /* 2383676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383678 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383680 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383685 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383686 */     // GIR_Coverage, 1875,
     /* 2383686 */     GIR_EraseRootFromParent_Done,
     /* 2383687 */   // Label 34208: @2383687
     /* 2383687 */   GIM_Reject,
     /* 2383688 */ // Label 34204: @2383688
     /* 2383688 */ GIM_Reject,
     /* 2383689 */ // Label 34186: @2383689
     /* 2383689 */ GIM_Try, /*On fail goto*//*Label 34209*/ GIMT_Encode4(2383837),
     /* 2383694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2383697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2383700 */   GIM_Try, /*On fail goto*//*Label 34210*/ GIMT_Encode4(2383734), // Rule ID 1161 //
     /* 2383705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2383708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383720 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2383720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2383723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383733 */     // GIR_Coverage, 1161,
     /* 2383733 */     GIR_EraseRootFromParent_Done,
     /* 2383734 */   // Label 34210: @2383734
     /* 2383734 */   GIM_Try, /*On fail goto*//*Label 34211*/ GIMT_Encode4(2383768), // Rule ID 1162 //
     /* 2383739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2383742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2383754 */     // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2)  =>  (FDIV_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2383754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S),
     /* 2383757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383766 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383767 */     // GIR_Coverage, 1162,
     /* 2383767 */     GIR_EraseRootFromParent_Done,
     /* 2383768 */   // Label 34211: @2383768
     /* 2383768 */   GIM_Try, /*On fail goto*//*Label 34212*/ GIMT_Encode4(2383802), // Rule ID 1165 //
     /* 2383773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2383776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383788 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i64] })
     /* 2383788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2383791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383793 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383795 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383801 */     // GIR_Coverage, 1165,
     /* 2383801 */     GIR_EraseRootFromParent_Done,
     /* 2383802 */   // Label 34212: @2383802
     /* 2383802 */   GIM_Try, /*On fail goto*//*Label 34213*/ GIMT_Encode4(2383836), // Rule ID 1166 //
     /* 2383807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2383810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383814 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2383822 */     // (strict_fdiv:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2)  =>  (FDIV_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, 7:{ *:[i32] })
     /* 2383822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_S_INX),
     /* 2383825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383835 */     // GIR_Coverage, 1166,
     /* 2383835 */     GIR_EraseRootFromParent_Done,
     /* 2383836 */   // Label 34213: @2383836
     /* 2383836 */   GIM_Reject,
     /* 2383837 */ // Label 34209: @2383837
     /* 2383837 */ GIM_Reject,
     /* 2383838 */ // Label 34187: @2383838
     /* 2383838 */ GIM_Try, /*On fail goto*//*Label 34214*/ GIMT_Encode4(2384020),
     /* 2383843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2383846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2383849 */   GIM_Try, /*On fail goto*//*Label 34215*/ GIMT_Encode4(2383883), // Rule ID 1502 //
     /* 2383854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2383857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383869 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2383869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2383872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383874 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383876 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383882 */     // GIR_Coverage, 1502,
     /* 2383882 */     GIR_EraseRootFromParent_Done,
     /* 2383883 */   // Label 34215: @2383883
     /* 2383883 */   GIM_Try, /*On fail goto*//*Label 34216*/ GIMT_Encode4(2383917), // Rule ID 1503 //
     /* 2383888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2383891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2383903 */     // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2)  =>  (FDIV_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2383903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D),
     /* 2383906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383916 */     // GIR_Coverage, 1503,
     /* 2383916 */     GIR_EraseRootFromParent_Done,
     /* 2383917 */   // Label 34216: @2383917
     /* 2383917 */   GIM_Try, /*On fail goto*//*Label 34217*/ GIMT_Encode4(2383951), // Rule ID 1506 //
     /* 2383922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2383925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383937 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2383937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2383940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383944 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383950 */     // GIR_Coverage, 1506,
     /* 2383950 */     GIR_EraseRootFromParent_Done,
     /* 2383951 */   // Label 34217: @2383951
     /* 2383951 */   GIM_Try, /*On fail goto*//*Label 34218*/ GIMT_Encode4(2383985), // Rule ID 1507 //
     /* 2383956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2383959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2383971 */     // (strict_fdiv:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2)  =>  (FDIV_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i32] })
     /* 2383971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_IN32X),
     /* 2383974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2383976 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2383978 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2383980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2383983 */     GIR_RootConstrainSelectedInstOperands,
     /* 2383984 */     // GIR_Coverage, 1507,
     /* 2383984 */     GIR_EraseRootFromParent_Done,
     /* 2383985 */   // Label 34218: @2383985
     /* 2383985 */   GIM_Try, /*On fail goto*//*Label 34219*/ GIMT_Encode4(2384019), // Rule ID 1510 //
     /* 2383990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2383993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2383997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2384005 */     // (strict_fdiv:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2)  =>  (FDIV_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, 7:{ *:[i64] })
     /* 2384005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FDIV_D_INX),
     /* 2384008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384018 */     // GIR_Coverage, 1510,
     /* 2384018 */     GIR_EraseRootFromParent_Done,
     /* 2384019 */   // Label 34219: @2384019
     /* 2384019 */   GIM_Reject,
     /* 2384020 */ // Label 34214: @2384020
     /* 2384020 */ GIM_Reject,
     /* 2384021 */ // Label 34188: @2384021
     /* 2384021 */ GIM_Try, /*On fail goto*//*Label 34220*/ GIMT_Encode4(2384141),
     /* 2384026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2384029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2384032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384040 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384044 */   GIM_Try, /*On fail goto*//*Label 34221*/ GIMT_Encode4(2384092), // Rule ID 54276 //
     /* 2384049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384052 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2384069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384081 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384090 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384091 */     // GIR_Coverage, 54276,
     /* 2384091 */     GIR_EraseRootFromParent_Done,
     /* 2384092 */   // Label 34221: @2384092
     /* 2384092 */   GIM_Try, /*On fail goto*//*Label 34222*/ GIMT_Encode4(2384140), // Rule ID 54277 //
     /* 2384097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2384100 */     // (strict_fdiv:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2384103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF4_E16),
     /* 2384117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384122 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384124 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384138 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384139 */     // GIR_Coverage, 54277,
     /* 2384139 */     GIR_EraseRootFromParent_Done,
     /* 2384140 */   // Label 34222: @2384140
     /* 2384140 */   GIM_Reject,
     /* 2384141 */ // Label 34220: @2384141
     /* 2384141 */ GIM_Reject,
     /* 2384142 */ // Label 34189: @2384142
     /* 2384142 */ GIM_Try, /*On fail goto*//*Label 34223*/ GIMT_Encode4(2384262),
     /* 2384147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2384150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2384153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384165 */   GIM_Try, /*On fail goto*//*Label 34224*/ GIMT_Encode4(2384213), // Rule ID 54300 //
     /* 2384170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2384173 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2384190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384195 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384197 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384211 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384212 */     // GIR_Coverage, 54300,
     /* 2384212 */     GIR_EraseRootFromParent_Done,
     /* 2384213 */   // Label 34224: @2384213
     /* 2384213 */   GIM_Try, /*On fail goto*//*Label 34225*/ GIMT_Encode4(2384261), // Rule ID 54301 //
     /* 2384218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384221 */     // (strict_fdiv:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2384224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384233 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E32),
     /* 2384238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384247 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384259 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384260 */     // GIR_Coverage, 54301,
     /* 2384260 */     GIR_EraseRootFromParent_Done,
     /* 2384261 */   // Label 34225: @2384261
     /* 2384261 */   GIM_Reject,
     /* 2384262 */ // Label 34223: @2384262
     /* 2384262 */ GIM_Reject,
     /* 2384263 */ // Label 34190: @2384263
     /* 2384263 */ GIM_Try, /*On fail goto*//*Label 34226*/ GIMT_Encode4(2384383),
     /* 2384268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2384271 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2384274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384282 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384286 */   GIM_Try, /*On fail goto*//*Label 34227*/ GIMT_Encode4(2384334), // Rule ID 54336 //
     /* 2384291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2384294 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2384311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384316 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384318 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384332 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384333 */     // GIR_Coverage, 54336,
     /* 2384333 */     GIR_EraseRootFromParent_Done,
     /* 2384334 */   // Label 34227: @2384334
     /* 2384334 */   GIM_Try, /*On fail goto*//*Label 34228*/ GIMT_Encode4(2384382), // Rule ID 54337 //
     /* 2384339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2384342 */     // (strict_fdiv:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2384345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E64),
     /* 2384359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384380 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384381 */     // GIR_Coverage, 54337,
     /* 2384381 */     GIR_EraseRootFromParent_Done,
     /* 2384382 */   // Label 34228: @2384382
     /* 2384382 */   GIM_Reject,
     /* 2384383 */ // Label 34226: @2384383
     /* 2384383 */ GIM_Reject,
     /* 2384384 */ // Label 34191: @2384384
     /* 2384384 */ GIM_Try, /*On fail goto*//*Label 34229*/ GIMT_Encode4(2384504),
     /* 2384389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2384392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2384395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384407 */   GIM_Try, /*On fail goto*//*Label 34230*/ GIMT_Encode4(2384455), // Rule ID 54288 //
     /* 2384412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384415 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2384432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384434 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384437 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384439 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384454 */     // GIR_Coverage, 54288,
     /* 2384454 */     GIR_EraseRootFromParent_Done,
     /* 2384455 */   // Label 34230: @2384455
     /* 2384455 */   GIM_Try, /*On fail goto*//*Label 34231*/ GIMT_Encode4(2384503), // Rule ID 54289 //
     /* 2384460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2384463 */     // (strict_fdiv:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFDIV_VV_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2384466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_MF2_E16),
     /* 2384480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384485 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384487 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384501 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384502 */     // GIR_Coverage, 54289,
     /* 2384502 */     GIR_EraseRootFromParent_Done,
     /* 2384503 */   // Label 34231: @2384503
     /* 2384503 */   GIM_Reject,
     /* 2384504 */ // Label 34229: @2384504
     /* 2384504 */ GIM_Reject,
     /* 2384505 */ // Label 34192: @2384505
     /* 2384505 */ GIM_Try, /*On fail goto*//*Label 34232*/ GIMT_Encode4(2384625),
     /* 2384510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2384513 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2384516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384528 */   GIM_Try, /*On fail goto*//*Label 34233*/ GIMT_Encode4(2384576), // Rule ID 54324 //
     /* 2384533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2384536 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2384553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384558 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384560 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384575 */     // GIR_Coverage, 54324,
     /* 2384575 */     GIR_EraseRootFromParent_Done,
     /* 2384576 */   // Label 34233: @2384576
     /* 2384576 */   GIM_Try, /*On fail goto*//*Label 34234*/ GIMT_Encode4(2384624), // Rule ID 54325 //
     /* 2384581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384584 */     // (strict_fdiv:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2384587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E32),
     /* 2384601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384606 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384608 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384623 */     // GIR_Coverage, 54325,
     /* 2384623 */     GIR_EraseRootFromParent_Done,
     /* 2384624 */   // Label 34234: @2384624
     /* 2384624 */   GIM_Reject,
     /* 2384625 */ // Label 34232: @2384625
     /* 2384625 */ GIM_Reject,
     /* 2384626 */ // Label 34193: @2384626
     /* 2384626 */ GIM_Try, /*On fail goto*//*Label 34235*/ GIMT_Encode4(2384746),
     /* 2384631 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2384634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2384637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384645 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384649 */   GIM_Try, /*On fail goto*//*Label 34236*/ GIMT_Encode4(2384697), // Rule ID 54420 //
     /* 2384654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2384657 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2384674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384681 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384696 */     // GIR_Coverage, 54420,
     /* 2384696 */     GIR_EraseRootFromParent_Done,
     /* 2384697 */   // Label 34236: @2384697
     /* 2384697 */   GIM_Try, /*On fail goto*//*Label 34237*/ GIMT_Encode4(2384745), // Rule ID 54421 //
     /* 2384702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2384705 */     // (strict_fdiv:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2384708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384717 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E64),
     /* 2384722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384724 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2384740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384744 */     // GIR_Coverage, 54421,
     /* 2384744 */     GIR_EraseRootFromParent_Done,
     /* 2384745 */   // Label 34237: @2384745
     /* 2384745 */   GIM_Reject,
     /* 2384746 */ // Label 34235: @2384746
     /* 2384746 */ GIM_Reject,
     /* 2384747 */ // Label 34194: @2384747
     /* 2384747 */ GIM_Try, /*On fail goto*//*Label 34238*/ GIMT_Encode4(2384867),
     /* 2384752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2384755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2384758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2384770 */   GIM_Try, /*On fail goto*//*Label 34239*/ GIMT_Encode4(2384818), // Rule ID 54312 //
     /* 2384775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2384778 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2384795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384800 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384802 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384816 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384817 */     // GIR_Coverage, 54312,
     /* 2384817 */     GIR_EraseRootFromParent_Done,
     /* 2384818 */   // Label 34239: @2384818
     /* 2384818 */   GIM_Try, /*On fail goto*//*Label 34240*/ GIMT_Encode4(2384866), // Rule ID 54313 //
     /* 2384823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2384826 */     // (strict_fdiv:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFDIV_VV_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2384829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M1_E16),
     /* 2384843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2384861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384864 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384865 */     // GIR_Coverage, 54313,
     /* 2384865 */     GIR_EraseRootFromParent_Done,
     /* 2384866 */   // Label 34240: @2384866
     /* 2384866 */   GIM_Reject,
     /* 2384867 */ // Label 34238: @2384867
     /* 2384867 */ GIM_Reject,
     /* 2384868 */ // Label 34195: @2384868
     /* 2384868 */ GIM_Try, /*On fail goto*//*Label 34241*/ GIMT_Encode4(2384988),
     /* 2384873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2384876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2384879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384887 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2384891 */   GIM_Try, /*On fail goto*//*Label 34242*/ GIMT_Encode4(2384939), // Rule ID 54384 //
     /* 2384896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2384899 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2384899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2384916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384938 */     // GIR_Coverage, 54384,
     /* 2384938 */     GIR_EraseRootFromParent_Done,
     /* 2384939 */   // Label 34242: @2384939
     /* 2384939 */   GIM_Try, /*On fail goto*//*Label 34243*/ GIMT_Encode4(2384987), // Rule ID 54385 //
     /* 2384944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2384947 */     // (strict_fdiv:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2384947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2384950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2384954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2384959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2384961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E32),
     /* 2384964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2384966 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2384969 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2384971 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2384973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2384976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2384979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2384982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2384985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2384986 */     // GIR_Coverage, 54385,
     /* 2384986 */     GIR_EraseRootFromParent_Done,
     /* 2384987 */   // Label 34243: @2384987
     /* 2384987 */   GIM_Reject,
     /* 2384988 */ // Label 34241: @2384988
     /* 2384988 */ GIM_Reject,
     /* 2384989 */ // Label 34196: @2384989
     /* 2384989 */ GIM_Try, /*On fail goto*//*Label 34244*/ GIMT_Encode4(2385109),
     /* 2384994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2384997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2385000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385008 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385012 */   GIM_Try, /*On fail goto*//*Label 34245*/ GIMT_Encode4(2385060), // Rule ID 54432 //
     /* 2385017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2385020 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2385037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385042 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385058 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385059 */     // GIR_Coverage, 54432,
     /* 2385059 */     GIR_EraseRootFromParent_Done,
     /* 2385060 */   // Label 34245: @2385060
     /* 2385060 */   GIM_Try, /*On fail goto*//*Label 34246*/ GIMT_Encode4(2385108), // Rule ID 54433 //
     /* 2385065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2385068 */     // (strict_fdiv:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385068 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2385071 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385075 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E64),
     /* 2385085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385090 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385092 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385107 */     // GIR_Coverage, 54433,
     /* 2385107 */     GIR_EraseRootFromParent_Done,
     /* 2385108 */   // Label 34246: @2385108
     /* 2385108 */   GIM_Reject,
     /* 2385109 */ // Label 34244: @2385109
     /* 2385109 */ GIM_Reject,
     /* 2385110 */ // Label 34197: @2385110
     /* 2385110 */ GIM_Try, /*On fail goto*//*Label 34247*/ GIMT_Encode4(2385230),
     /* 2385115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2385118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2385121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2385133 */   GIM_Try, /*On fail goto*//*Label 34248*/ GIMT_Encode4(2385181), // Rule ID 54348 //
     /* 2385138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2385141 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2385158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385165 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385179 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385180 */     // GIR_Coverage, 54348,
     /* 2385180 */     GIR_EraseRootFromParent_Done,
     /* 2385181 */   // Label 34248: @2385181
     /* 2385181 */   GIM_Try, /*On fail goto*//*Label 34249*/ GIMT_Encode4(2385229), // Rule ID 54349 //
     /* 2385186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385189 */     // (strict_fdiv:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFDIV_VV_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2385192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M2_E16),
     /* 2385206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385211 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385228 */     // GIR_Coverage, 54349,
     /* 2385228 */     GIR_EraseRootFromParent_Done,
     /* 2385229 */   // Label 34249: @2385229
     /* 2385229 */   GIM_Reject,
     /* 2385230 */ // Label 34247: @2385230
     /* 2385230 */ GIM_Reject,
     /* 2385231 */ // Label 34198: @2385231
     /* 2385231 */ GIM_Try, /*On fail goto*//*Label 34250*/ GIMT_Encode4(2385351),
     /* 2385236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2385239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2385242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385254 */   GIM_Try, /*On fail goto*//*Label 34251*/ GIMT_Encode4(2385302), // Rule ID 54396 //
     /* 2385259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2385262 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2385279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385284 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385286 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385288 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385301 */     // GIR_Coverage, 54396,
     /* 2385301 */     GIR_EraseRootFromParent_Done,
     /* 2385302 */   // Label 34251: @2385302
     /* 2385302 */   GIM_Try, /*On fail goto*//*Label 34252*/ GIMT_Encode4(2385350), // Rule ID 54397 //
     /* 2385307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2385310 */     // (strict_fdiv:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2385313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E32),
     /* 2385327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385349 */     // GIR_Coverage, 54397,
     /* 2385349 */     GIR_EraseRootFromParent_Done,
     /* 2385350 */   // Label 34252: @2385350
     /* 2385350 */   GIM_Reject,
     /* 2385351 */ // Label 34250: @2385351
     /* 2385351 */ GIM_Reject,
     /* 2385352 */ // Label 34199: @2385352
     /* 2385352 */ GIM_Try, /*On fail goto*//*Label 34253*/ GIMT_Encode4(2385472),
     /* 2385357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2385360 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2385363 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385367 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385371 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385375 */   GIM_Try, /*On fail goto*//*Label 34254*/ GIMT_Encode4(2385423), // Rule ID 54444 //
     /* 2385380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2385383 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385383 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385386 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385390 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2385400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385402 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385405 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385407 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385422 */     // GIR_Coverage, 54444,
     /* 2385422 */     GIR_EraseRootFromParent_Done,
     /* 2385423 */   // Label 34254: @2385423
     /* 2385423 */   GIM_Try, /*On fail goto*//*Label 34255*/ GIMT_Encode4(2385471), // Rule ID 54445 //
     /* 2385428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2385431 */     // (strict_fdiv:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2385434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E64),
     /* 2385448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385455 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2385466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385469 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385470 */     // GIR_Coverage, 54445,
     /* 2385470 */     GIR_EraseRootFromParent_Done,
     /* 2385471 */   // Label 34255: @2385471
     /* 2385471 */   GIM_Reject,
     /* 2385472 */ // Label 34253: @2385472
     /* 2385472 */ GIM_Reject,
     /* 2385473 */ // Label 34200: @2385473
     /* 2385473 */ GIM_Try, /*On fail goto*//*Label 34256*/ GIMT_Encode4(2385593),
     /* 2385478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2385481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2385484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385488 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385492 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2385496 */   GIM_Try, /*On fail goto*//*Label 34257*/ GIMT_Encode4(2385544), // Rule ID 54360 //
     /* 2385501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2385504 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2385521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385526 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385528 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385543 */     // GIR_Coverage, 54360,
     /* 2385543 */     GIR_EraseRootFromParent_Done,
     /* 2385544 */   // Label 34257: @2385544
     /* 2385544 */   GIM_Try, /*On fail goto*//*Label 34258*/ GIMT_Encode4(2385592), // Rule ID 54361 //
     /* 2385549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385552 */     // (strict_fdiv:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFDIV_VV_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2385555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M4_E16),
     /* 2385569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385574 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385576 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385581 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385590 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385591 */     // GIR_Coverage, 54361,
     /* 2385591 */     GIR_EraseRootFromParent_Done,
     /* 2385592 */   // Label 34258: @2385592
     /* 2385592 */   GIM_Reject,
     /* 2385593 */ // Label 34256: @2385593
     /* 2385593 */ GIM_Reject,
     /* 2385594 */ // Label 34201: @2385594
     /* 2385594 */ GIM_Try, /*On fail goto*//*Label 34259*/ GIMT_Encode4(2385714),
     /* 2385599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2385602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2385605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385617 */   GIM_Try, /*On fail goto*//*Label 34260*/ GIMT_Encode4(2385665), // Rule ID 54408 //
     /* 2385622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2385625 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385625 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385628 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385632 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2385642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385647 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385649 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385664 */     // GIR_Coverage, 54408,
     /* 2385664 */     GIR_EraseRootFromParent_Done,
     /* 2385665 */   // Label 34260: @2385665
     /* 2385665 */   GIM_Try, /*On fail goto*//*Label 34261*/ GIMT_Encode4(2385713), // Rule ID 54409 //
     /* 2385670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2385673 */     // (strict_fdiv:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2385676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E32),
     /* 2385690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385695 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385697 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2385708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385712 */     // GIR_Coverage, 54409,
     /* 2385712 */     GIR_EraseRootFromParent_Done,
     /* 2385713 */   // Label 34261: @2385713
     /* 2385713 */   GIM_Reject,
     /* 2385714 */ // Label 34259: @2385714
     /* 2385714 */ GIM_Reject,
     /* 2385715 */ // Label 34202: @2385715
     /* 2385715 */ GIM_Try, /*On fail goto*//*Label 34262*/ GIMT_Encode4(2385835),
     /* 2385720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2385723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2385726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2385738 */   GIM_Try, /*On fail goto*//*Label 34263*/ GIMT_Encode4(2385786), // Rule ID 54372 //
     /* 2385743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2385746 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2385746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2385763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385768 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385770 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385785 */     // GIR_Coverage, 54372,
     /* 2385785 */     GIR_EraseRootFromParent_Done,
     /* 2385786 */   // Label 34263: @2385786
     /* 2385786 */   GIM_Try, /*On fail goto*//*Label 34264*/ GIMT_Encode4(2385834), // Rule ID 54373 //
     /* 2385791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2385794 */     // (strict_fdiv:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFDIV_VV_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2385794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2385797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2385801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2385806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2385808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFDIV_VV_M8_E16),
     /* 2385811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2385813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2385816 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2385818 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2385820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2385823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2385826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2385829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2385832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2385833 */     // GIR_Coverage, 54373,
     /* 2385833 */     GIR_EraseRootFromParent_Done,
     /* 2385834 */   // Label 34264: @2385834
     /* 2385834 */   GIM_Reject,
     /* 2385835 */ // Label 34262: @2385835
     /* 2385835 */ GIM_Reject,
     /* 2385836 */ // Label 34203: @2385836
     /* 2385836 */ GIM_Reject,
     /* 2385837 */ // Label 102: @2385837
     /* 2385837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34283*/ GIMT_Encode4(2402481),
     /* 2385848 */ /*GILLT_s16*//*Label 34265*/ GIMT_Encode4(2385968),
     /* 2385852 */ /*GILLT_s32*//*Label 34266*/ GIMT_Encode4(2387404),
     /* 2385856 */ /*GILLT_s64*//*Label 34267*/ GIMT_Encode4(2388840), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385868 */ /*GILLT_nxv1s16*//*Label 34268*/ GIMT_Encode4(2390631),
     /* 2385872 */ /*GILLT_nxv1s32*//*Label 34269*/ GIMT_Encode4(2391421),
     /* 2385876 */ /*GILLT_nxv1s64*//*Label 34270*/ GIMT_Encode4(2392211), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385888 */ /*GILLT_nxv2s16*//*Label 34271*/ GIMT_Encode4(2393001),
     /* 2385892 */ /*GILLT_nxv2s32*//*Label 34272*/ GIMT_Encode4(2393791),
     /* 2385896 */ /*GILLT_nxv2s64*//*Label 34273*/ GIMT_Encode4(2394581), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385908 */ /*GILLT_nxv4s16*//*Label 34274*/ GIMT_Encode4(2395371),
     /* 2385912 */ /*GILLT_nxv4s32*//*Label 34275*/ GIMT_Encode4(2396161),
     /* 2385916 */ /*GILLT_nxv4s64*//*Label 34276*/ GIMT_Encode4(2396951), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385928 */ /*GILLT_nxv8s16*//*Label 34277*/ GIMT_Encode4(2397741),
     /* 2385932 */ /*GILLT_nxv8s32*//*Label 34278*/ GIMT_Encode4(2398531),
     /* 2385936 */ /*GILLT_nxv8s64*//*Label 34279*/ GIMT_Encode4(2399321), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385948 */ /*GILLT_nxv16s16*//*Label 34280*/ GIMT_Encode4(2400111),
     /* 2385952 */ /*GILLT_nxv16s32*//*Label 34281*/ GIMT_Encode4(2400901), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2385964 */ /*GILLT_nxv32s16*//*Label 34282*/ GIMT_Encode4(2401691),
     /* 2385968 */ // Label 34265: @2385968
     /* 2385968 */ GIM_Try, /*On fail goto*//*Label 34284*/ GIMT_Encode4(2387403),
     /* 2385973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2385976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 2385979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 2385982 */   GIM_Try, /*On fail goto*//*Label 34285*/ GIMT_Encode4(2386054), // Rule ID 1903 //
     /* 2385987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2385990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2385994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2385998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386006 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386034 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2386037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386052 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386053 */     // GIR_Coverage, 1903,
     /* 2386053 */     GIR_EraseRootFromParent_Done,
     /* 2386054 */   // Label 34285: @2386054
     /* 2386054 */   GIM_Try, /*On fail goto*//*Label 34286*/ GIMT_Encode4(2386126), // Rule ID 1904 //
     /* 2386059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2386062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386106 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2386109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386124 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386125 */     // GIR_Coverage, 1904,
     /* 2386125 */     GIR_EraseRootFromParent_Done,
     /* 2386126 */   // Label 34286: @2386126
     /* 2386126 */   GIM_Try, /*On fail goto*//*Label 34287*/ GIMT_Encode4(2386198), // Rule ID 1936 //
     /* 2386131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2386134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386167 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386178 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2386181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386196 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386197 */     // GIR_Coverage, 1936,
     /* 2386197 */     GIR_EraseRootFromParent_Done,
     /* 2386198 */   // Label 34287: @2386198
     /* 2386198 */   GIM_Try, /*On fail goto*//*Label 34288*/ GIMT_Encode4(2386270), // Rule ID 1937 //
     /* 2386203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2386206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386250 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2386253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386269 */     // GIR_Coverage, 1937,
     /* 2386269 */     GIR_EraseRootFromParent_Done,
     /* 2386270 */   // Label 34288: @2386270
     /* 2386270 */   GIM_Try, /*On fail goto*//*Label 34289*/ GIMT_Encode4(2386342), // Rule ID 65105 //
     /* 2386275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2386278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386322 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2386325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386331 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386341 */     // GIR_Coverage, 65105,
     /* 2386341 */     GIR_EraseRootFromParent_Done,
     /* 2386342 */   // Label 34289: @2386342
     /* 2386342 */   GIM_Try, /*On fail goto*//*Label 34290*/ GIMT_Encode4(2386414), // Rule ID 65106 //
     /* 2386347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2386350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386394 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FNMADD_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H),
     /* 2386397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386403 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386412 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386413 */     // GIR_Coverage, 65106,
     /* 2386413 */     GIR_EraseRootFromParent_Done,
     /* 2386414 */   // Label 34290: @2386414
     /* 2386414 */   GIM_Try, /*On fail goto*//*Label 34291*/ GIMT_Encode4(2386486), // Rule ID 65113 //
     /* 2386419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2386422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386466 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2386469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386484 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386485 */     // GIR_Coverage, 65113,
     /* 2386485 */     GIR_EraseRootFromParent_Done,
     /* 2386486 */   // Label 34291: @2386486
     /* 2386486 */   GIM_Try, /*On fail goto*//*Label 34292*/ GIMT_Encode4(2386558), // Rule ID 65114 //
     /* 2386491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2386494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2386523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386527 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2386538 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FNMADD_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_H_INX),
     /* 2386541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2386553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386557 */     // GIR_Coverage, 65114,
     /* 2386557 */     GIR_EraseRootFromParent_Done,
     /* 2386558 */   // Label 34292: @2386558
     /* 2386558 */   GIM_Try, /*On fail goto*//*Label 34293*/ GIMT_Encode4(2386615), // Rule ID 1899 //
     /* 2386563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2386566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386595 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386597 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2386600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386606 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386608 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386613 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386614 */     // GIR_Coverage, 1899,
     /* 2386614 */     GIR_EraseRootFromParent_Done,
     /* 2386615 */   // Label 34293: @2386615
     /* 2386615 */   GIM_Try, /*On fail goto*//*Label 34294*/ GIMT_Encode4(2386672), // Rule ID 1900 //
     /* 2386620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2386623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386654 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2386657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386663 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386665 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386667 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386670 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386671 */     // GIR_Coverage, 1900,
     /* 2386671 */     GIR_EraseRootFromParent_Done,
     /* 2386672 */   // Label 34294: @2386672
     /* 2386672 */   GIM_Try, /*On fail goto*//*Label 34295*/ GIMT_Encode4(2386729), // Rule ID 1932 //
     /* 2386677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2386680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386705 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386711 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2386714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386720 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386722 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386728 */     // GIR_Coverage, 1932,
     /* 2386728 */     GIR_EraseRootFromParent_Done,
     /* 2386729 */   // Label 34295: @2386729
     /* 2386729 */   GIM_Try, /*On fail goto*//*Label 34296*/ GIMT_Encode4(2386786), // Rule ID 1933 //
     /* 2386734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2386737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2386745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386768 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2386771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386777 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2386779 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386785 */     // GIR_Coverage, 1933,
     /* 2386785 */     GIR_EraseRootFromParent_Done,
     /* 2386786 */   // Label 34296: @2386786
     /* 2386786 */   GIM_Try, /*On fail goto*//*Label 34297*/ GIMT_Encode4(2386843), // Rule ID 65101 //
     /* 2386791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2386794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386825 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2386828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386834 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386836 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386841 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386842 */     // GIR_Coverage, 65101,
     /* 2386842 */     GIR_EraseRootFromParent_Done,
     /* 2386843 */   // Label 34297: @2386843
     /* 2386843 */   GIM_Try, /*On fail goto*//*Label 34298*/ GIMT_Encode4(2386900), // Rule ID 65102 //
     /* 2386848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2386851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2386880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386882 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs1), FPR16:{ *:[f16] }:$rs3)  =>  (FNMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H),
     /* 2386885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386893 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386898 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386899 */     // GIR_Coverage, 65102,
     /* 2386899 */     GIR_EraseRootFromParent_Done,
     /* 2386900 */   // Label 34298: @2386900
     /* 2386900 */   GIM_Try, /*On fail goto*//*Label 34299*/ GIMT_Encode4(2386957), // Rule ID 65109 //
     /* 2386905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2386908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386939 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2386939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2386942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2386944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2386948 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2386950 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2386952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2386955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2386956 */     // GIR_Coverage, 65109,
     /* 2386956 */     GIR_EraseRootFromParent_Done,
     /* 2386957 */   // Label 34299: @2386957
     /* 2386957 */   GIM_Try, /*On fail goto*//*Label 34300*/ GIMT_Encode4(2387014), // Rule ID 65110 //
     /* 2386962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2386965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2386977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2386981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2386985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2386994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2386996 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1), FPR16INX:{ *:[f16] }:$rs3)  =>  (FNMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2386996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_H_INX),
     /* 2386999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387005 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2387007 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2387009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387013 */     // GIR_Coverage, 65110,
     /* 2387013 */     GIR_EraseRootFromParent_Done,
     /* 2387014 */   // Label 34300: @2387014
     /* 2387014 */   GIM_Try, /*On fail goto*//*Label 34301*/ GIMT_Encode4(2387071), // Rule ID 1895 //
     /* 2387019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2387022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2387038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2387046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387051 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2387053 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2387053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2387056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387058 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387060 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2387066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387070 */     // GIR_Coverage, 1895,
     /* 2387070 */     GIR_EraseRootFromParent_Done,
     /* 2387071 */   // Label 34301: @2387071
     /* 2387071 */   GIM_Try, /*On fail goto*//*Label 34302*/ GIMT_Encode4(2387128), // Rule ID 1896 //
     /* 2387076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2387079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2387095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2387103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2387110 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$rs3))  =>  (FMSUB_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2387110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H),
     /* 2387113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387115 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387117 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2387123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387127 */     // GIR_Coverage, 1896,
     /* 2387127 */     GIR_EraseRootFromParent_Done,
     /* 2387128 */   // Label 34302: @2387128
     /* 2387128 */   GIM_Try, /*On fail goto*//*Label 34303*/ GIMT_Encode4(2387185), // Rule ID 1928 //
     /* 2387133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2387136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2387152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2387160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387165 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2387167 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2387167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2387170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387172 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387174 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2387180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387183 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387184 */     // GIR_Coverage, 1928,
     /* 2387184 */     GIR_EraseRootFromParent_Done,
     /* 2387185 */   // Label 34303: @2387185
     /* 2387185 */   GIM_Try, /*On fail goto*//*Label 34304*/ GIMT_Encode4(2387242), // Rule ID 1929 //
     /* 2387190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2387193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2387209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 2387217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2387224 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, (fneg:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs3))  =>  (FMSUB_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2387224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_H_INX),
     /* 2387227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387229 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387231 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2387237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387240 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387241 */     // GIR_Coverage, 1929,
     /* 2387241 */     GIR_EraseRootFromParent_Done,
     /* 2387242 */   // Label 34304: @2387242
     /* 2387242 */   GIM_Try, /*On fail goto*//*Label 34305*/ GIMT_Encode4(2387282), // Rule ID 1891 //
     /* 2387247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2387250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387266 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2387266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2387269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387275 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2387277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387280 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387281 */     // GIR_Coverage, 1891,
     /* 2387281 */     GIR_EraseRootFromParent_Done,
     /* 2387282 */   // Label 34305: @2387282
     /* 2387282 */   GIM_Try, /*On fail goto*//*Label 34306*/ GIMT_Encode4(2387322), // Rule ID 1892 //
     /* 2387287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2387290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2387306 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, FPR16:{ *:[f16] }:$rs2, FPR16:{ *:[f16] }:$rs3)  =>  (FMADD_H:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2387306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H),
     /* 2387309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387311 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387313 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387315 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2387317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387321 */     // GIR_Coverage, 1892,
     /* 2387321 */     GIR_EraseRootFromParent_Done,
     /* 2387322 */   // Label 34306: @2387322
     /* 2387322 */   GIM_Try, /*On fail goto*//*Label 34307*/ GIMT_Encode4(2387362), // Rule ID 1924 //
     /* 2387327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2387330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387346 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i64] })
     /* 2387346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2387349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387353 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387355 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2387357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387360 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387361 */     // GIR_Coverage, 1924,
     /* 2387361 */     GIR_EraseRootFromParent_Done,
     /* 2387362 */   // Label 34307: @2387362
     /* 2387362 */   GIM_Try, /*On fail goto*//*Label 34308*/ GIMT_Encode4(2387402), // Rule ID 1925 //
     /* 2387367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2387370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2387386 */     // (strict_fma:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, FPR16INX:{ *:[f16] }:$rs2, FPR16INX:{ *:[f16] }:$rs3)  =>  (FMADD_H_INX:{ *:[f16] } ?:{ *:[f16] }:$rs1, ?:{ *:[f16] }:$rs2, ?:{ *:[f16] }:$rs3, 7:{ *:[i32] })
     /* 2387386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_H_INX),
     /* 2387389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2387393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387395 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2387397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387400 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387401 */     // GIR_Coverage, 1925,
     /* 2387401 */     GIR_EraseRootFromParent_Done,
     /* 2387402 */   // Label 34308: @2387402
     /* 2387402 */   GIM_Reject,
     /* 2387403 */ // Label 34284: @2387403
     /* 2387403 */ GIM_Reject,
     /* 2387404 */ // Label 34266: @2387404
     /* 2387404 */ GIM_Try, /*On fail goto*//*Label 34309*/ GIMT_Encode4(2388839),
     /* 2387409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2387415 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2387418 */   GIM_Try, /*On fail goto*//*Label 34310*/ GIMT_Encode4(2387490), // Rule ID 1202 //
     /* 2387423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2387426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2387434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387451 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387455 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387459 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387470 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2387470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2387473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387488 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387489 */     // GIR_Coverage, 1202,
     /* 2387489 */     GIR_EraseRootFromParent_Done,
     /* 2387490 */   // Label 34310: @2387490
     /* 2387490 */   GIM_Try, /*On fail goto*//*Label 34311*/ GIMT_Encode4(2387562), // Rule ID 1203 //
     /* 2387495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2387498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2387506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387535 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387542 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2387542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2387545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387561 */     // GIR_Coverage, 1203,
     /* 2387561 */     GIR_EraseRootFromParent_Done,
     /* 2387562 */   // Label 34311: @2387562
     /* 2387562 */   GIM_Try, /*On fail goto*//*Label 34312*/ GIMT_Encode4(2387634), // Rule ID 1223 //
     /* 2387567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2387570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2387578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387614 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2387614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2387617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387632 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387633 */     // GIR_Coverage, 1223,
     /* 2387633 */     GIR_EraseRootFromParent_Done,
     /* 2387634 */   // Label 34312: @2387634
     /* 2387634 */   GIM_Try, /*On fail goto*//*Label 34313*/ GIMT_Encode4(2387706), // Rule ID 1224 //
     /* 2387639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2387642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2387650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387679 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387686 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2387686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2387689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2387697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387704 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387705 */     // GIR_Coverage, 1224,
     /* 2387705 */     GIR_EraseRootFromParent_Done,
     /* 2387706 */   // Label 34313: @2387706
     /* 2387706 */   GIM_Try, /*On fail goto*//*Label 34314*/ GIMT_Encode4(2387778), // Rule ID 65069 //
     /* 2387711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2387714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2387726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387758 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2387758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2387761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387767 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2387769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387777 */     // GIR_Coverage, 65069,
     /* 2387777 */     GIR_EraseRootFromParent_Done,
     /* 2387778 */   // Label 34314: @2387778
     /* 2387778 */   GIM_Try, /*On fail goto*//*Label 34315*/ GIMT_Encode4(2387850), // Rule ID 65070 //
     /* 2387783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2387786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2387798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387823 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2387828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387830 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FNMADD_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2387830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S),
     /* 2387833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2387841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387848 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387849 */     // GIR_Coverage, 65070,
     /* 2387849 */     GIR_EraseRootFromParent_Done,
     /* 2387850 */   // Label 34315: @2387850
     /* 2387850 */   GIM_Try, /*On fail goto*//*Label 34316*/ GIMT_Encode4(2387922), // Rule ID 65077 //
     /* 2387855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2387858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2387870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387902 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2387902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2387905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2387913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387920 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387921 */     // GIR_Coverage, 65077,
     /* 2387921 */     GIR_EraseRootFromParent_Done,
     /* 2387922 */   // Label 34316: @2387922
     /* 2387922 */   GIM_Try, /*On fail goto*//*Label 34317*/ GIMT_Encode4(2387994), // Rule ID 65078 //
     /* 2387927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2387930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2387942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2387959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2387963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 2387967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2387972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2387974 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FNMADD_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2387974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_S_INX),
     /* 2387977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2387979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2387983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2387985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2387989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2387992 */     GIR_RootConstrainSelectedInstOperands,
     /* 2387993 */     // GIR_Coverage, 65078,
     /* 2387993 */     GIR_EraseRootFromParent_Done,
     /* 2387994 */   // Label 34317: @2387994
     /* 2387994 */   GIM_Try, /*On fail goto*//*Label 34318*/ GIMT_Encode4(2388051), // Rule ID 1198 //
     /* 2387999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2388002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388033 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2388036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388042 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388044 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388050 */     // GIR_Coverage, 1198,
     /* 2388050 */     GIR_EraseRootFromParent_Done,
     /* 2388051 */   // Label 34318: @2388051
     /* 2388051 */   GIM_Try, /*On fail goto*//*Label 34319*/ GIMT_Encode4(2388108), // Rule ID 1199 //
     /* 2388056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2388059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388090 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2388093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388101 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388106 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388107 */     // GIR_Coverage, 1199,
     /* 2388107 */     GIR_EraseRootFromParent_Done,
     /* 2388108 */   // Label 34319: @2388108
     /* 2388108 */   GIM_Try, /*On fail goto*//*Label 34320*/ GIMT_Encode4(2388165), // Rule ID 1219 //
     /* 2388113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2388116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388147 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2388150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388156 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388158 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388163 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388164 */     // GIR_Coverage, 1219,
     /* 2388164 */     GIR_EraseRootFromParent_Done,
     /* 2388165 */   // Label 34320: @2388165
     /* 2388165 */   GIM_Try, /*On fail goto*//*Label 34321*/ GIMT_Encode4(2388222), // Rule ID 1220 //
     /* 2388170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2388173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388202 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388204 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2388207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388213 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388215 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388220 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388221 */     // GIR_Coverage, 1220,
     /* 2388221 */     GIR_EraseRootFromParent_Done,
     /* 2388222 */   // Label 34321: @2388222
     /* 2388222 */   GIM_Try, /*On fail goto*//*Label 34322*/ GIMT_Encode4(2388279), // Rule ID 65065 //
     /* 2388227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2388230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2388242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388261 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2388264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388270 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2388272 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388278 */     // GIR_Coverage, 65065,
     /* 2388278 */     GIR_EraseRootFromParent_Done,
     /* 2388279 */   // Label 34322: @2388279
     /* 2388279 */   GIM_Try, /*On fail goto*//*Label 34323*/ GIMT_Encode4(2388336), // Rule ID 65066 //
     /* 2388284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2388287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2388299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388318 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs1), FPR32:{ *:[f32] }:$rs3)  =>  (FNMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S),
     /* 2388321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2388329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388335 */     // GIR_Coverage, 65066,
     /* 2388335 */     GIR_EraseRootFromParent_Done,
     /* 2388336 */   // Label 34323: @2388336
     /* 2388336 */   GIM_Try, /*On fail goto*//*Label 34324*/ GIMT_Encode4(2388393), // Rule ID 65073 //
     /* 2388341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2388344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2388356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388373 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388375 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2388378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388384 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2388386 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388391 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388392 */     // GIR_Coverage, 65073,
     /* 2388392 */     GIR_EraseRootFromParent_Done,
     /* 2388393 */   // Label 34324: @2388393
     /* 2388393 */   GIM_Try, /*On fail goto*//*Label 34325*/ GIMT_Encode4(2388450), // Rule ID 65074 //
     /* 2388398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2388401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2388413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388432 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1), FPR32INX:{ *:[f32] }:$rs3)  =>  (FNMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_S_INX),
     /* 2388435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2388443 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388448 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388449 */     // GIR_Coverage, 65074,
     /* 2388449 */     GIR_EraseRootFromParent_Done,
     /* 2388450 */   // Label 34325: @2388450
     /* 2388450 */   GIM_Try, /*On fail goto*//*Label 34326*/ GIMT_Encode4(2388507), // Rule ID 1194 //
     /* 2388455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2388458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2388474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388489 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2388492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388494 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388496 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2388502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388506 */     // GIR_Coverage, 1194,
     /* 2388506 */     GIR_EraseRootFromParent_Done,
     /* 2388507 */   // Label 34326: @2388507
     /* 2388507 */   GIM_Try, /*On fail goto*//*Label 34327*/ GIMT_Encode4(2388564), // Rule ID 1195 //
     /* 2388512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2388515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2388531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388544 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388546 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$rs3))  =>  (FMSUB_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S),
     /* 2388549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388551 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388553 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2388559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388563 */     // GIR_Coverage, 1195,
     /* 2388563 */     GIR_EraseRootFromParent_Done,
     /* 2388564 */   // Label 34327: @2388564
     /* 2388564 */   GIM_Try, /*On fail goto*//*Label 34328*/ GIMT_Encode4(2388621), // Rule ID 1215 //
     /* 2388569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2388572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388576 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2388588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388603 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2388606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388608 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388610 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2388616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388619 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388620 */     // GIR_Coverage, 1215,
     /* 2388620 */     GIR_EraseRootFromParent_Done,
     /* 2388621 */   // Label 34328: @2388621
     /* 2388621 */   GIM_Try, /*On fail goto*//*Label 34329*/ GIMT_Encode4(2388678), // Rule ID 1216 //
     /* 2388626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2388629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2388645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 2388653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2388660 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, (fneg:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs3))  =>  (FMSUB_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_S_INX),
     /* 2388663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388665 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388667 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2388673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388676 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388677 */     // GIR_Coverage, 1216,
     /* 2388677 */     GIR_EraseRootFromParent_Done,
     /* 2388678 */   // Label 34329: @2388678
     /* 2388678 */   GIM_Try, /*On fail goto*//*Label 34330*/ GIMT_Encode4(2388718), // Rule ID 1190 //
     /* 2388683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2388686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388702 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2388705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388707 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388711 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388717 */     // GIR_Coverage, 1190,
     /* 2388717 */     GIR_EraseRootFromParent_Done,
     /* 2388718 */   // Label 34330: @2388718
     /* 2388718 */   GIM_Try, /*On fail goto*//*Label 34331*/ GIMT_Encode4(2388758), // Rule ID 1191 //
     /* 2388723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2388726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2388742 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, FPR32:{ *:[f32] }:$rs2, FPR32:{ *:[f32] }:$rs3)  =>  (FMADD_S:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S),
     /* 2388745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388747 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388751 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388757 */     // GIR_Coverage, 1191,
     /* 2388757 */     GIR_EraseRootFromParent_Done,
     /* 2388758 */   // Label 34331: @2388758
     /* 2388758 */   GIM_Try, /*On fail goto*//*Label 34332*/ GIMT_Encode4(2388798), // Rule ID 1211 //
     /* 2388763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2388766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388782 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i64] })
     /* 2388782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2388785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388787 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388789 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388791 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388796 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388797 */     // GIR_Coverage, 1211,
     /* 2388797 */     GIR_EraseRootFromParent_Done,
     /* 2388798 */   // Label 34332: @2388798
     /* 2388798 */   GIM_Try, /*On fail goto*//*Label 34333*/ GIMT_Encode4(2388838), // Rule ID 1212 //
     /* 2388803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2388806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2388822 */     // (strict_fma:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, FPR32INX:{ *:[f32] }:$rs2, FPR32INX:{ *:[f32] }:$rs3)  =>  (FMADD_S_INX:{ *:[f32] } ?:{ *:[f32] }:$rs1, ?:{ *:[f32] }:$rs2, ?:{ *:[f32] }:$rs3, 7:{ *:[i32] })
     /* 2388822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_S_INX),
     /* 2388825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2388829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388831 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2388833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388836 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388837 */     // GIR_Coverage, 1212,
     /* 2388837 */     GIR_EraseRootFromParent_Done,
     /* 2388838 */   // Label 34333: @2388838
     /* 2388838 */   GIM_Reject,
     /* 2388839 */ // Label 34309: @2388839
     /* 2388839 */ GIM_Reject,
     /* 2388840 */ // Label 34267: @2388840
     /* 2388840 */ GIM_Try, /*On fail goto*//*Label 34334*/ GIMT_Encode4(2390630),
     /* 2388845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2388851 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2388854 */   GIM_Try, /*On fail goto*//*Label 34335*/ GIMT_Encode4(2388926), // Rule ID 1539 //
     /* 2388859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2388862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2388891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388899 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388904 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2388906 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2388906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2388909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388915 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2388921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388924 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388925 */     // GIR_Coverage, 1539,
     /* 2388925 */     GIR_EraseRootFromParent_Done,
     /* 2388926 */   // Label 34335: @2388926
     /* 2388926 */   GIM_Try, /*On fail goto*//*Label 34336*/ GIMT_Encode4(2388998), // Rule ID 1540 //
     /* 2388931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2388934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2388942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2388963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2388967 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2388971 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2388976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2388978 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2388978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2388981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2388983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2388987 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2388989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2388993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2388996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2388997 */     // GIR_Coverage, 1540,
     /* 2388997 */     GIR_EraseRootFromParent_Done,
     /* 2388998 */   // Label 34336: @2388998
     /* 2388998 */   GIM_Try, /*On fail goto*//*Label 34337*/ GIMT_Encode4(2389070), // Rule ID 1563 //
     /* 2389003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389050 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2389053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389069 */     // GIR_Coverage, 1563,
     /* 2389069 */     GIR_EraseRootFromParent_Done,
     /* 2389070 */   // Label 34337: @2389070
     /* 2389070 */   GIM_Try, /*On fail goto*//*Label 34338*/ GIMT_Encode4(2389142), // Rule ID 1594 //
     /* 2389075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2389078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389122 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2389125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389131 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389140 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389141 */     // GIR_Coverage, 1594,
     /* 2389141 */     GIR_EraseRootFromParent_Done,
     /* 2389142 */   // Label 34338: @2389142
     /* 2389142 */   GIM_Try, /*On fail goto*//*Label 34339*/ GIMT_Encode4(2389214), // Rule ID 1595 //
     /* 2389147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2389150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389194 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2389197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389212 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389213 */     // GIR_Coverage, 1595,
     /* 2389213 */     GIR_EraseRootFromParent_Done,
     /* 2389214 */   // Label 34339: @2389214
     /* 2389214 */   GIM_Try, /*On fail goto*//*Label 34340*/ GIMT_Encode4(2389286), // Rule ID 65085 //
     /* 2389219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2389222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389266 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2389269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389285 */     // GIR_Coverage, 65085,
     /* 2389285 */     GIR_EraseRootFromParent_Done,
     /* 2389286 */   // Label 34340: @2389286
     /* 2389286 */   GIM_Try, /*On fail goto*//*Label 34341*/ GIMT_Encode4(2389358), // Rule ID 65086 //
     /* 2389291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2389294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389336 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389338 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FNMADD_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D),
     /* 2389341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389347 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389353 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389356 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389357 */     // GIR_Coverage, 65086,
     /* 2389357 */     GIR_EraseRootFromParent_Done,
     /* 2389358 */   // Label 34341: @2389358
     /* 2389358 */   GIM_Try, /*On fail goto*//*Label 34342*/ GIMT_Encode4(2389430), // Rule ID 65091 //
     /* 2389363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389410 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FNMADD_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_INX),
     /* 2389413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389428 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389429 */     // GIR_Coverage, 65091,
     /* 2389429 */     GIR_EraseRootFromParent_Done,
     /* 2389430 */   // Label 34342: @2389430
     /* 2389430 */   GIM_Try, /*On fail goto*//*Label 34343*/ GIMT_Encode4(2389502), // Rule ID 65097 //
     /* 2389435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2389438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389482 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2389485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389500 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389501 */     // GIR_Coverage, 65097,
     /* 2389501 */     GIR_EraseRootFromParent_Done,
     /* 2389502 */   // Label 34343: @2389502
     /* 2389502 */   GIM_Try, /*On fail goto*//*Label 34344*/ GIMT_Encode4(2389574), // Rule ID 65098 //
     /* 2389507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2389510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2389539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2389554 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FNMADD_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMADD_D_IN32X),
     /* 2389557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389563 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs3
     /* 2389569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389572 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389573 */     // GIR_Coverage, 65098,
     /* 2389573 */     GIR_EraseRootFromParent_Done,
     /* 2389574 */   // Label 34344: @2389574
     /* 2389574 */   GIM_Try, /*On fail goto*//*Label 34345*/ GIMT_Encode4(2389631), // Rule ID 1535 //
     /* 2389579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2389582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389590 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389594 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389613 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2389616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389622 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389624 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389629 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389630 */     // GIR_Coverage, 1535,
     /* 2389630 */     GIR_EraseRootFromParent_Done,
     /* 2389631 */   // Label 34345: @2389631
     /* 2389631 */   GIM_Try, /*On fail goto*//*Label 34346*/ GIMT_Encode4(2389688), // Rule ID 1536 //
     /* 2389636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2389639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389664 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389670 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2389673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389681 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389687 */     // GIR_Coverage, 1536,
     /* 2389687 */     GIR_EraseRootFromParent_Done,
     /* 2389688 */   // Label 34346: @2389688
     /* 2389688 */   GIM_Try, /*On fail goto*//*Label 34347*/ GIMT_Encode4(2389745), // Rule ID 1561 //
     /* 2389693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389725 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389727 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2389730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389736 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389738 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389743 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389744 */     // GIR_Coverage, 1561,
     /* 2389744 */     GIR_EraseRootFromParent_Done,
     /* 2389745 */   // Label 34347: @2389745
     /* 2389745 */   GIM_Try, /*On fail goto*//*Label 34348*/ GIMT_Encode4(2389802), // Rule ID 1590 //
     /* 2389750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2389753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389784 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2389787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389793 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389795 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389800 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389801 */     // GIR_Coverage, 1590,
     /* 2389801 */     GIR_EraseRootFromParent_Done,
     /* 2389802 */   // Label 34348: @2389802
     /* 2389802 */   GIM_Try, /*On fail goto*//*Label 34349*/ GIMT_Encode4(2389859), // Rule ID 1591 //
     /* 2389807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2389810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2389818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2389839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389841 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2389844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2389852 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389858 */     // GIR_Coverage, 1591,
     /* 2389858 */     GIR_EraseRootFromParent_Done,
     /* 2389859 */   // Label 34349: @2389859
     /* 2389859 */   GIM_Try, /*On fail goto*//*Label 34350*/ GIMT_Encode4(2389916), // Rule ID 65081 //
     /* 2389864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2389867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389898 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2389898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2389901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389907 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389909 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389914 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389915 */     // GIR_Coverage, 65081,
     /* 2389915 */     GIR_EraseRootFromParent_Done,
     /* 2389916 */   // Label 34350: @2389916
     /* 2389916 */   GIM_Try, /*On fail goto*//*Label 34351*/ GIMT_Encode4(2389973), // Rule ID 65082 //
     /* 2389921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2389924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2389944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2389953 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2389955 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs1), FPR64:{ *:[f64] }:$rs3)  =>  (FNMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2389955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D),
     /* 2389958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2389960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2389964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2389966 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2389968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2389971 */     GIR_RootConstrainSelectedInstOperands,
     /* 2389972 */     // GIR_Coverage, 65082,
     /* 2389972 */     GIR_EraseRootFromParent_Done,
     /* 2389973 */   // Label 34351: @2389973
     /* 2389973 */   GIM_Try, /*On fail goto*//*Label 34352*/ GIMT_Encode4(2390030), // Rule ID 65089 //
     /* 2389978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2389981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2389989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2389993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2389997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390012 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1), FPR64INX:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_INX),
     /* 2390015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390023 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390028 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390029 */     // GIR_Coverage, 65089,
     /* 2390029 */     GIR_EraseRootFromParent_Done,
     /* 2390030 */   // Label 34352: @2390030
     /* 2390030 */   GIM_Try, /*On fail goto*//*Label 34353*/ GIMT_Encode4(2390087), // Rule ID 65093 //
     /* 2390035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2390038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390058 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390069 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2390072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390080 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390085 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390086 */     // GIR_Coverage, 65093,
     /* 2390086 */     GIR_EraseRootFromParent_Done,
     /* 2390087 */   // Label 34353: @2390087
     /* 2390087 */   GIM_Try, /*On fail goto*//*Label 34354*/ GIMT_Encode4(2390144), // Rule ID 65094 //
     /* 2390092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2390095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390126 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1), FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FNMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2390126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FNMSUB_D_IN32X),
     /* 2390129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390135 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2390137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390142 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390143 */     // GIR_Coverage, 65094,
     /* 2390143 */     GIR_EraseRootFromParent_Done,
     /* 2390144 */   // Label 34354: @2390144
     /* 2390144 */   GIM_Try, /*On fail goto*//*Label 34355*/ GIMT_Encode4(2390201), // Rule ID 1531 //
     /* 2390149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2390152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2390168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390183 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2390186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2390196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390200 */     // GIR_Coverage, 1531,
     /* 2390200 */     GIR_EraseRootFromParent_Done,
     /* 2390201 */   // Label 34355: @2390201
     /* 2390201 */   GIM_Try, /*On fail goto*//*Label 34356*/ GIMT_Encode4(2390258), // Rule ID 1532 //
     /* 2390206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2390209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2390225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390240 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$rs3))  =>  (FMSUB_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2390240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D),
     /* 2390243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390245 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390247 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2390253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390256 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390257 */     // GIR_Coverage, 1532,
     /* 2390257 */     GIR_EraseRootFromParent_Done,
     /* 2390258 */   // Label 34356: @2390258
     /* 2390258 */   GIM_Try, /*On fail goto*//*Label 34357*/ GIMT_Encode4(2390315), // Rule ID 1559 //
     /* 2390263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2390266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2390282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390297 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs3))  =>  (FMSUB_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_INX),
     /* 2390300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2390310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390314 */     // GIR_Coverage, 1559,
     /* 2390314 */     GIR_EraseRootFromParent_Done,
     /* 2390315 */   // Label 34357: @2390315
     /* 2390315 */   GIM_Try, /*On fail goto*//*Label 34358*/ GIMT_Encode4(2390372), // Rule ID 1586 //
     /* 2390320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2390323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2390339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390354 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2390357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390359 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390361 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2390367 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390370 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390371 */     // GIR_Coverage, 1586,
     /* 2390371 */     GIR_EraseRootFromParent_Done,
     /* 2390372 */   // Label 34358: @2390372
     /* 2390372 */   GIM_Try, /*On fail goto*//*Label 34359*/ GIMT_Encode4(2390429), // Rule ID 1587 //
     /* 2390377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2390380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2390396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2390404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390411 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, (fneg:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs3))  =>  (FMSUB_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2390411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMSUB_D_IN32X),
     /* 2390414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs3
     /* 2390424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390427 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390428 */     // GIR_Coverage, 1587,
     /* 2390428 */     GIR_EraseRootFromParent_Done,
     /* 2390429 */   // Label 34359: @2390429
     /* 2390429 */   GIM_Try, /*On fail goto*//*Label 34360*/ GIMT_Encode4(2390469), // Rule ID 1527 //
     /* 2390434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2390437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390453 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2390456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390458 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390460 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390462 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390467 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390468 */     // GIR_Coverage, 1527,
     /* 2390468 */     GIR_EraseRootFromParent_Done,
     /* 2390469 */   // Label 34360: @2390469
     /* 2390469 */   GIM_Try, /*On fail goto*//*Label 34361*/ GIMT_Encode4(2390509), // Rule ID 1528 //
     /* 2390474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2390477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2390493 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, FPR64:{ *:[f64] }:$rs2, FPR64:{ *:[f64] }:$rs3)  =>  (FMADD_D:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2390493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D),
     /* 2390496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390498 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390500 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390502 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390508 */     // GIR_Coverage, 1528,
     /* 2390508 */     GIR_EraseRootFromParent_Done,
     /* 2390509 */   // Label 34361: @2390509
     /* 2390509 */   GIM_Try, /*On fail goto*//*Label 34362*/ GIMT_Encode4(2390549), // Rule ID 1557 //
     /* 2390514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2390517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2390533 */     // (strict_fma:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, FPR64INX:{ *:[f64] }:$rs2, FPR64INX:{ *:[f64] }:$rs3)  =>  (FMADD_D_INX:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_INX),
     /* 2390536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390538 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390540 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390542 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390548 */     // GIR_Coverage, 1557,
     /* 2390548 */     GIR_EraseRootFromParent_Done,
     /* 2390549 */   // Label 34362: @2390549
     /* 2390549 */   GIM_Try, /*On fail goto*//*Label 34363*/ GIMT_Encode4(2390589), // Rule ID 1582 //
     /* 2390554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2390557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390573 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i64] })
     /* 2390573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2390576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390578 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390580 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390582 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390587 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390588 */     // GIR_Coverage, 1582,
     /* 2390588 */     GIR_EraseRootFromParent_Done,
     /* 2390589 */   // Label 34363: @2390589
     /* 2390589 */   GIM_Try, /*On fail goto*//*Label 34364*/ GIMT_Encode4(2390629), // Rule ID 1583 //
     /* 2390594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2390597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2390613 */     // (strict_fma:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, FPR64IN32X:{ *:[f64] }:$rs2, FPR64IN32X:{ *:[f64] }:$rs3)  =>  (FMADD_D_IN32X:{ *:[f64] } ?:{ *:[f64] }:$rs1, ?:{ *:[f64] }:$rs2, ?:{ *:[f64] }:$rs3, 7:{ *:[i32] })
     /* 2390613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FMADD_D_IN32X),
     /* 2390616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390618 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2390620 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2390622 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs3
     /* 2390624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390627 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390628 */     // GIR_Coverage, 1583,
     /* 2390628 */     GIR_EraseRootFromParent_Done,
     /* 2390629 */   // Label 34364: @2390629
     /* 2390629 */   GIM_Reject,
     /* 2390630 */ // Label 34334: @2390630
     /* 2390630 */ GIM_Reject,
     /* 2390631 */ // Label 34268: @2390631
     /* 2390631 */ GIM_Try, /*On fail goto*//*Label 34365*/ GIMT_Encode4(2391420),
     /* 2390636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2390642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s16,
     /* 2390645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390649 */   GIM_Try, /*On fail goto*//*Label 34366*/ GIMT_Encode4(2390726), // Rule ID 54710 //
     /* 2390654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390697 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2390697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2390700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390702 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2390704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2390712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2390724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390725 */     // GIR_Coverage, 54710,
     /* 2390725 */     GIR_EraseRootFromParent_Done,
     /* 2390726 */   // Label 34366: @2390726
     /* 2390726 */   GIM_Try, /*On fail goto*//*Label 34367*/ GIMT_Encode4(2390803), // Rule ID 54711 //
     /* 2390731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390763 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390774 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2390774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2390777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390779 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2390781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2390789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2390801 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390802 */     // GIR_Coverage, 54711,
     /* 2390802 */     GIR_EraseRootFromParent_Done,
     /* 2390803 */   // Label 34367: @2390803
     /* 2390803 */   GIM_Try, /*On fail goto*//*Label 34368*/ GIMT_Encode4(2390880), // Rule ID 72059 //
     /* 2390808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390844 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390851 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2390851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2390854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390856 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2390858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2390866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2390878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390879 */     // GIR_Coverage, 72059,
     /* 2390879 */     GIR_EraseRootFromParent_Done,
     /* 2390880 */   // Label 34368: @2390880
     /* 2390880 */   GIM_Try, /*On fail goto*//*Label 34369*/ GIMT_Encode4(2390957), // Rule ID 72060 //
     /* 2390885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2390888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2390896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390900 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2390913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390917 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2390928 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2390928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF4_E16),
     /* 2390931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2390935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2390939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2390943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2390946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2390949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2390952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2390955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2390956 */     // GIR_Coverage, 72060,
     /* 2390956 */     GIR_EraseRootFromParent_Done,
     /* 2390957 */   // Label 34369: @2390957
     /* 2390957 */   GIM_Try, /*On fail goto*//*Label 34370*/ GIMT_Encode4(2391019), // Rule ID 54714 //
     /* 2390962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2390965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2390969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2390973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2390977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390986 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2390990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2390992 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2390992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2390995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2390997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2390999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391003 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391018 */     // GIR_Coverage, 54714,
     /* 2391018 */     GIR_EraseRootFromParent_Done,
     /* 2391019 */   // Label 34370: @2391019
     /* 2391019 */   GIM_Try, /*On fail goto*//*Label 34371*/ GIMT_Encode4(2391081), // Rule ID 54715 //
     /* 2391024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391052 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391054 */     // (strict_fma:{ *:[nxv1f16] } (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2391057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391059 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391065 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391080 */     // GIR_Coverage, 54715,
     /* 2391080 */     GIR_EraseRootFromParent_Done,
     /* 2391081 */   // Label 34371: @2391081
     /* 2391081 */   GIM_Try, /*On fail goto*//*Label 34372*/ GIMT_Encode4(2391143), // Rule ID 72063 //
     /* 2391086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391105 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391116 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2391119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391121 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391127 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391132 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391141 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391142 */     // GIR_Coverage, 72063,
     /* 2391142 */     GIR_EraseRootFromParent_Done,
     /* 2391143 */   // Label 34372: @2391143
     /* 2391143 */   GIM_Try, /*On fail goto*//*Label 34373*/ GIMT_Encode4(2391205), // Rule ID 72064 //
     /* 2391148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391178 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1), VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF4_E16),
     /* 2391181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391183 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391204 */     // GIR_Coverage, 72064,
     /* 2391204 */     GIR_EraseRootFromParent_Done,
     /* 2391205 */   // Label 34373: @2391205
     /* 2391205 */   GIM_Try, /*On fail goto*//*Label 34374*/ GIMT_Encode4(2391267), // Rule ID 54706 //
     /* 2391210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391240 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2391243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391245 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391247 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2391253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391265 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391266 */     // GIR_Coverage, 54706,
     /* 2391266 */     GIR_EraseRootFromParent_Done,
     /* 2391267 */   // Label 34374: @2391267
     /* 2391267 */   GIM_Try, /*On fail goto*//*Label 34375*/ GIMT_Encode4(2391329), // Rule ID 54707 //
     /* 2391272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2391287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2391295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391302 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, (fneg:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF4_E16),
     /* 2391305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2391315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391328 */     // GIR_Coverage, 54707,
     /* 2391328 */     GIR_EraseRootFromParent_Done,
     /* 2391329 */   // Label 34375: @2391329
     /* 2391329 */   GIM_Try, /*On fail goto*//*Label 34376*/ GIMT_Encode4(2391374), // Rule ID 54702 //
     /* 2391334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2391337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391349 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2391352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391356 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391358 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391372 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391373 */     // GIR_Coverage, 54702,
     /* 2391373 */     GIR_EraseRootFromParent_Done,
     /* 2391374 */   // Label 34376: @2391374
     /* 2391374 */   GIM_Try, /*On fail goto*//*Label 34377*/ GIMT_Encode4(2391419), // Rule ID 54703 //
     /* 2391379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2391382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391394 */     // (strict_fma:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF4_E16:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF4_E16),
     /* 2391397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391399 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391401 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2391403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2391414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391418 */     // GIR_Coverage, 54703,
     /* 2391418 */     GIR_EraseRootFromParent_Done,
     /* 2391419 */   // Label 34377: @2391419
     /* 2391419 */   GIM_Reject,
     /* 2391420 */ // Label 34365: @2391420
     /* 2391420 */ GIM_Reject,
     /* 2391421 */ // Label 34269: @2391421
     /* 2391421 */ GIM_Try, /*On fail goto*//*Label 34378*/ GIMT_Encode4(2392210),
     /* 2391426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2391432 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s32,
     /* 2391435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391439 */   GIM_Try, /*On fail goto*//*Label 34379*/ GIMT_Encode4(2391516), // Rule ID 54838 //
     /* 2391444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391476 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391487 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2391490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2391502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391514 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391515 */     // GIR_Coverage, 54838,
     /* 2391515 */     GIR_EraseRootFromParent_Done,
     /* 2391516 */   // Label 34379: @2391516
     /* 2391516 */   GIM_Try, /*On fail goto*//*Label 34380*/ GIMT_Encode4(2391593), // Rule ID 54839 //
     /* 2391521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391564 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2391567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391569 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2391579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391591 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391592 */     // GIR_Coverage, 54839,
     /* 2391592 */     GIR_EraseRootFromParent_Done,
     /* 2391593 */   // Label 34380: @2391593
     /* 2391593 */   GIM_Try, /*On fail goto*//*Label 34381*/ GIMT_Encode4(2391670), // Rule ID 72171 //
     /* 2391598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391641 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2391644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391646 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2391656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391669 */     // GIR_Coverage, 72171,
     /* 2391669 */     GIR_EraseRootFromParent_Done,
     /* 2391670 */   // Label 34381: @2391670
     /* 2391670 */   GIM_Try, /*On fail goto*//*Label 34382*/ GIMT_Encode4(2391747), // Rule ID 72172 //
     /* 2391675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2391703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2391718 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E32),
     /* 2391721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391723 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2391733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391746 */     // GIR_Coverage, 72172,
     /* 2391746 */     GIR_EraseRootFromParent_Done,
     /* 2391747 */   // Label 34382: @2391747
     /* 2391747 */   GIM_Try, /*On fail goto*//*Label 34383*/ GIMT_Encode4(2391809), // Rule ID 54842 //
     /* 2391752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391782 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2391785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391793 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391808 */     // GIR_Coverage, 54842,
     /* 2391808 */     GIR_EraseRootFromParent_Done,
     /* 2391809 */   // Label 34383: @2391809
     /* 2391809 */   GIM_Try, /*On fail goto*//*Label 34384*/ GIMT_Encode4(2391871), // Rule ID 54843 //
     /* 2391814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2391821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391842 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391844 */     // (strict_fma:{ *:[nxv1f32] } (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2391847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391849 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2391851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391855 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391869 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391870 */     // GIR_Coverage, 54843,
     /* 2391870 */     GIR_EraseRootFromParent_Done,
     /* 2391871 */   // Label 34384: @2391871
     /* 2391871 */   GIM_Try, /*On fail goto*//*Label 34385*/ GIMT_Encode4(2391933), // Rule ID 72175 //
     /* 2391876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2391879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391906 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2391906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2391909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391917 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391931 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391932 */     // GIR_Coverage, 72175,
     /* 2391932 */     GIR_EraseRootFromParent_Done,
     /* 2391933 */   // Label 34385: @2391933
     /* 2391933 */   GIM_Try, /*On fail goto*//*Label 34386*/ GIMT_Encode4(2391995), // Rule ID 72176 //
     /* 2391938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2391941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2391949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2391953 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2391957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2391966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2391968 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1), VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2391968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E32),
     /* 2391971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2391973 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2391975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2391979 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2391981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2391984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2391987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2391990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2391993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391994 */     // GIR_Coverage, 72176,
     /* 2391994 */     GIR_EraseRootFromParent_Done,
     /* 2391995 */   // Label 34386: @2391995
     /* 2391995 */   GIM_Try, /*On fail goto*//*Label 34387*/ GIMT_Encode4(2392057), // Rule ID 54834 //
     /* 2392000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392030 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2392033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2392043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392055 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392056 */     // GIR_Coverage, 54834,
     /* 2392056 */     GIR_EraseRootFromParent_Done,
     /* 2392057 */   // Label 34387: @2392057
     /* 2392057 */   GIM_Try, /*On fail goto*//*Label 34388*/ GIMT_Encode4(2392119), // Rule ID 54835 //
     /* 2392062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2392085 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392092 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, (fneg:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E32),
     /* 2392095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392097 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2392105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392117 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392118 */     // GIR_Coverage, 54835,
     /* 2392118 */     GIR_EraseRootFromParent_Done,
     /* 2392119 */   // Label 34388: @2392119
     /* 2392119 */   GIM_Try, /*On fail goto*//*Label 34389*/ GIMT_Encode4(2392164), // Rule ID 54830 //
     /* 2392124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2392127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392139 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2392142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392144 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392146 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392148 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392162 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392163 */     // GIR_Coverage, 54830,
     /* 2392163 */     GIR_EraseRootFromParent_Done,
     /* 2392164 */   // Label 34389: @2392164
     /* 2392164 */   GIM_Try, /*On fail goto*//*Label 34390*/ GIMT_Encode4(2392209), // Rule ID 54831 //
     /* 2392169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2392172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392184 */     // (strict_fma:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E32:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E32),
     /* 2392187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392189 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392191 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392193 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2392204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392208 */     // GIR_Coverage, 54831,
     /* 2392208 */     GIR_EraseRootFromParent_Done,
     /* 2392209 */   // Label 34390: @2392209
     /* 2392209 */   GIM_Reject,
     /* 2392210 */ // Label 34378: @2392210
     /* 2392210 */ GIM_Reject,
     /* 2392211 */ // Label 34270: @2392211
     /* 2392211 */ GIM_Try, /*On fail goto*//*Label 34391*/ GIMT_Encode4(2393000),
     /* 2392216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392219 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2392222 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s64,
     /* 2392225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392229 */   GIM_Try, /*On fail goto*//*Label 34392*/ GIMT_Encode4(2392306), // Rule ID 55030 //
     /* 2392234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392277 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2392280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392282 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2392292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392304 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392305 */     // GIR_Coverage, 55030,
     /* 2392305 */     GIR_EraseRootFromParent_Done,
     /* 2392306 */   // Label 34392: @2392306
     /* 2392306 */   GIM_Try, /*On fail goto*//*Label 34393*/ GIMT_Encode4(2392383), // Rule ID 55031 //
     /* 2392311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392354 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2392357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392359 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2392369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392381 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392382 */     // GIR_Coverage, 55031,
     /* 2392382 */     GIR_EraseRootFromParent_Done,
     /* 2392383 */   // Label 34393: @2392383
     /* 2392383 */   GIM_Try, /*On fail goto*//*Label 34394*/ GIMT_Encode4(2392460), // Rule ID 72339 //
     /* 2392388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392429 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392431 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2392434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392436 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2392438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2392446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392458 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392459 */     // GIR_Coverage, 72339,
     /* 2392459 */     GIR_EraseRootFromParent_Done,
     /* 2392460 */   // Label 34394: @2392460
     /* 2392460 */   GIM_Try, /*On fail goto*//*Label 34395*/ GIMT_Encode4(2392537), // Rule ID 72340 //
     /* 2392465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2392493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2392508 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E64),
     /* 2392511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392513 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2392515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2392523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392536 */     // GIR_Coverage, 72340,
     /* 2392536 */     GIR_EraseRootFromParent_Done,
     /* 2392537 */   // Label 34395: @2392537
     /* 2392537 */   GIM_Try, /*On fail goto*//*Label 34396*/ GIMT_Encode4(2392599), // Rule ID 55034 //
     /* 2392542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392572 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2392575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392583 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392598 */     // GIR_Coverage, 55034,
     /* 2392598 */     GIR_EraseRootFromParent_Done,
     /* 2392599 */   // Label 34396: @2392599
     /* 2392599 */   GIM_Try, /*On fail goto*//*Label 34397*/ GIMT_Encode4(2392661), // Rule ID 55035 //
     /* 2392604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2392611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392634 */     // (strict_fma:{ *:[nxv1f64] } (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2392637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392639 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392645 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392660 */     // GIR_Coverage, 55035,
     /* 2392660 */     GIR_EraseRootFromParent_Done,
     /* 2392661 */   // Label 34397: @2392661
     /* 2392661 */   GIM_Try, /*On fail goto*//*Label 34398*/ GIMT_Encode4(2392723), // Rule ID 72343 //
     /* 2392666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392696 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2392699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392701 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2392703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392707 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392721 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392722 */     // GIR_Coverage, 72343,
     /* 2392722 */     GIR_EraseRootFromParent_Done,
     /* 2392723 */   // Label 34398: @2392723
     /* 2392723 */   GIM_Try, /*On fail goto*//*Label 34399*/ GIMT_Encode4(2392785), // Rule ID 72344 //
     /* 2392728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2392739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392747 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392758 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1), VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E64),
     /* 2392761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2392765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2392769 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392783 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392784 */     // GIR_Coverage, 72344,
     /* 2392784 */     GIR_EraseRootFromParent_Done,
     /* 2392785 */   // Label 34399: @2392785
     /* 2392785 */   GIM_Try, /*On fail goto*//*Label 34400*/ GIMT_Encode4(2392847), // Rule ID 55026 //
     /* 2392790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392818 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392820 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2392823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392825 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2392833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392845 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392846 */     // GIR_Coverage, 55026,
     /* 2392846 */     GIR_EraseRootFromParent_Done,
     /* 2392847 */   // Label 34400: @2392847
     /* 2392847 */   GIM_Try, /*On fail goto*//*Label 34401*/ GIMT_Encode4(2392909), // Rule ID 55027 //
     /* 2392852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2392867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2392871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2392875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2392882 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, (fneg:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E64),
     /* 2392885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392889 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2392895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392907 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392908 */     // GIR_Coverage, 55027,
     /* 2392908 */     GIR_EraseRootFromParent_Done,
     /* 2392909 */   // Label 34401: @2392909
     /* 2392909 */   GIM_Try, /*On fail goto*//*Label 34402*/ GIMT_Encode4(2392954), // Rule ID 55022 //
     /* 2392914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2392917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392929 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2392929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2392932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392934 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392936 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392938 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392953 */     // GIR_Coverage, 55022,
     /* 2392953 */     GIR_EraseRootFromParent_Done,
     /* 2392954 */   // Label 34402: @2392954
     /* 2392954 */   GIM_Try, /*On fail goto*//*Label 34403*/ GIMT_Encode4(2392999), // Rule ID 55023 //
     /* 2392959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2392962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2392974 */     // (strict_fma:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E64:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2392974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E64),
     /* 2392977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2392979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2392981 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2392983 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2392985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2392988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2392991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2392994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2392997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2392998 */     // GIR_Coverage, 55023,
     /* 2392998 */     GIR_EraseRootFromParent_Done,
     /* 2392999 */   // Label 34403: @2392999
     /* 2392999 */   GIM_Reject,
     /* 2393000 */ // Label 34391: @2393000
     /* 2393000 */ GIM_Reject,
     /* 2393001 */ // Label 34271: @2393001
     /* 2393001 */ GIM_Try, /*On fail goto*//*Label 34404*/ GIMT_Encode4(2393790),
     /* 2393006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2393012 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 2393015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393019 */   GIM_Try, /*On fail goto*//*Label 34405*/ GIMT_Encode4(2393096), // Rule ID 54774 //
     /* 2393024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393060 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393065 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393067 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2393070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393072 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393094 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393095 */     // GIR_Coverage, 54774,
     /* 2393095 */     GIR_EraseRootFromParent_Done,
     /* 2393096 */   // Label 34405: @2393096
     /* 2393096 */   GIM_Try, /*On fail goto*//*Label 34406*/ GIMT_Encode4(2393173), // Rule ID 54775 //
     /* 2393101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393144 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2393147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393149 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393172 */     // GIR_Coverage, 54775,
     /* 2393172 */     GIR_EraseRootFromParent_Done,
     /* 2393173 */   // Label 34406: @2393173
     /* 2393173 */   GIM_Try, /*On fail goto*//*Label 34407*/ GIMT_Encode4(2393250), // Rule ID 72115 //
     /* 2393178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393214 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393221 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2393224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393226 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2393228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393249 */     // GIR_Coverage, 72115,
     /* 2393249 */     GIR_EraseRootFromParent_Done,
     /* 2393250 */   // Label 34407: @2393250
     /* 2393250 */   GIM_Try, /*On fail goto*//*Label 34408*/ GIMT_Encode4(2393327), // Rule ID 72116 //
     /* 2393255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393298 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFNMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_MF2_E16),
     /* 2393301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393303 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2393305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393326 */     // GIR_Coverage, 72116,
     /* 2393326 */     GIR_EraseRootFromParent_Done,
     /* 2393327 */   // Label 34408: @2393327
     /* 2393327 */   GIM_Try, /*On fail goto*//*Label 34409*/ GIMT_Encode4(2393389), // Rule ID 54778 //
     /* 2393332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393362 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2393365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393388 */     // GIR_Coverage, 54778,
     /* 2393388 */     GIR_EraseRootFromParent_Done,
     /* 2393389 */   // Label 34409: @2393389
     /* 2393389 */   GIM_Try, /*On fail goto*//*Label 34410*/ GIMT_Encode4(2393451), // Rule ID 54779 //
     /* 2393394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393424 */     // (strict_fma:{ *:[nxv2f16] } (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2393427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393435 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393449 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393450 */     // GIR_Coverage, 54779,
     /* 2393450 */     GIR_EraseRootFromParent_Done,
     /* 2393451 */   // Label 34410: @2393451
     /* 2393451 */   GIM_Try, /*On fail goto*//*Label 34411*/ GIMT_Encode4(2393513), // Rule ID 72119 //
     /* 2393456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393484 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393486 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2393489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393491 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2393493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393497 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393511 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393512 */     // GIR_Coverage, 72119,
     /* 2393512 */     GIR_EraseRootFromParent_Done,
     /* 2393513 */   // Label 34411: @2393513
     /* 2393513 */   GIM_Try, /*On fail goto*//*Label 34412*/ GIMT_Encode4(2393575), // Rule ID 72120 //
     /* 2393518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393548 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1), VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_MF2_E16),
     /* 2393551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393553 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2393555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393559 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393573 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393574 */     // GIR_Coverage, 72120,
     /* 2393574 */     GIR_EraseRootFromParent_Done,
     /* 2393575 */   // Label 34412: @2393575
     /* 2393575 */   GIM_Try, /*On fail goto*//*Label 34413*/ GIMT_Encode4(2393637), // Rule ID 54770 //
     /* 2393580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2393595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393610 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2393613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393615 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393617 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2393623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393636 */     // GIR_Coverage, 54770,
     /* 2393636 */     GIR_EraseRootFromParent_Done,
     /* 2393637 */   // Label 34413: @2393637
     /* 2393637 */   GIM_Try, /*On fail goto*//*Label 34414*/ GIMT_Encode4(2393699), // Rule ID 54771 //
     /* 2393642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2393657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2393665 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2393672 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, (fneg:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2))  =>  (PseudoVFMSUB_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_MF2_E16),
     /* 2393675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393679 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2393685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393697 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393698 */     // GIR_Coverage, 54771,
     /* 2393698 */     GIR_EraseRootFromParent_Done,
     /* 2393699 */   // Label 34414: @2393699
     /* 2393699 */   GIM_Try, /*On fail goto*//*Label 34415*/ GIMT_Encode4(2393744), // Rule ID 54766 //
     /* 2393704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2393707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393719 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2393722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393724 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393728 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393742 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393743 */     // GIR_Coverage, 54766,
     /* 2393743 */     GIR_EraseRootFromParent_Done,
     /* 2393744 */   // Label 34415: @2393744
     /* 2393744 */   GIM_Try, /*On fail goto*//*Label 34416*/ GIMT_Encode4(2393789), // Rule ID 54767 //
     /* 2393749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2393752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393764 */     // (strict_fma:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFMADD_VV_MF2_E16:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_MF2_E16),
     /* 2393767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393769 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2393773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2393775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2393784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393788 */     // GIR_Coverage, 54767,
     /* 2393788 */     GIR_EraseRootFromParent_Done,
     /* 2393789 */   // Label 34416: @2393789
     /* 2393789 */   GIM_Reject,
     /* 2393790 */ // Label 34404: @2393790
     /* 2393790 */ GIM_Reject,
     /* 2393791 */ // Label 34272: @2393791
     /* 2393791 */ GIM_Try, /*On fail goto*//*Label 34417*/ GIMT_Encode4(2394580),
     /* 2393796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2393802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 2393805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393809 */   GIM_Try, /*On fail goto*//*Label 34418*/ GIMT_Encode4(2393886), // Rule ID 54966 //
     /* 2393814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393846 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393855 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393857 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2393857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2393860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393862 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393884 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393885 */     // GIR_Coverage, 54966,
     /* 2393885 */     GIR_EraseRootFromParent_Done,
     /* 2393886 */   // Label 34418: @2393886
     /* 2393886 */   GIM_Try, /*On fail goto*//*Label 34419*/ GIMT_Encode4(2393963), // Rule ID 54967 //
     /* 2393891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2393894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2393898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393923 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2393934 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2393934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2393937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2393939 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2393941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2393945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2393949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2393952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2393955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2393958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2393961 */     GIR_RootConstrainSelectedInstOperands,
     /* 2393962 */     // GIR_Coverage, 54967,
     /* 2393962 */     GIR_EraseRootFromParent_Done,
     /* 2393963 */   // Label 34419: @2393963
     /* 2393963 */   GIM_Try, /*On fail goto*//*Label 34420*/ GIMT_Encode4(2394040), // Rule ID 72283 //
     /* 2393968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2393971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2393979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2393983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2393987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2393992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2393996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394011 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2394014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394038 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394039 */     // GIR_Coverage, 72283,
     /* 2394039 */     GIR_EraseRootFromParent_Done,
     /* 2394040 */   // Label 34420: @2394040
     /* 2394040 */   GIM_Try, /*On fail goto*//*Label 34421*/ GIMT_Encode4(2394117), // Rule ID 72284 //
     /* 2394045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2394073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394088 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E32),
     /* 2394091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394116 */     // GIR_Coverage, 72284,
     /* 2394116 */     GIR_EraseRootFromParent_Done,
     /* 2394117 */   // Label 34421: @2394117
     /* 2394117 */   GIM_Try, /*On fail goto*//*Label 34422*/ GIMT_Encode4(2394179), // Rule ID 54970 //
     /* 2394122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394152 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2394155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394163 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394178 */     // GIR_Coverage, 54970,
     /* 2394178 */     GIR_EraseRootFromParent_Done,
     /* 2394179 */   // Label 34422: @2394179
     /* 2394179 */   GIM_Try, /*On fail goto*//*Label 34423*/ GIMT_Encode4(2394241), // Rule ID 54971 //
     /* 2394184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394214 */     // (strict_fma:{ *:[nxv2f32] } (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2394217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394219 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394225 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394239 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394240 */     // GIR_Coverage, 54971,
     /* 2394240 */     GIR_EraseRootFromParent_Done,
     /* 2394241 */   // Label 34423: @2394241
     /* 2394241 */   GIM_Try, /*On fail goto*//*Label 34424*/ GIMT_Encode4(2394303), // Rule ID 72287 //
     /* 2394246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394276 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2394279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394287 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394302 */     // GIR_Coverage, 72287,
     /* 2394302 */     GIR_EraseRootFromParent_Done,
     /* 2394303 */   // Label 34424: @2394303
     /* 2394303 */   GIM_Try, /*On fail goto*//*Label 34425*/ GIMT_Encode4(2394365), // Rule ID 72288 //
     /* 2394308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394336 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394338 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1), VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E32),
     /* 2394341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394343 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394349 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394364 */     // GIR_Coverage, 72288,
     /* 2394364 */     GIR_EraseRootFromParent_Done,
     /* 2394365 */   // Label 34425: @2394365
     /* 2394365 */   GIM_Try, /*On fail goto*//*Label 34426*/ GIMT_Encode4(2394427), // Rule ID 54962 //
     /* 2394370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394400 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2394403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394405 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394407 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2394413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394425 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394426 */     // GIR_Coverage, 54962,
     /* 2394426 */     GIR_EraseRootFromParent_Done,
     /* 2394427 */   // Label 34426: @2394427
     /* 2394427 */   GIM_Try, /*On fail goto*//*Label 34427*/ GIMT_Encode4(2394489), // Rule ID 54963 //
     /* 2394432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2394447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2394455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394462 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, (fneg:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E32),
     /* 2394465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394467 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394469 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2394475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394487 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394488 */     // GIR_Coverage, 54963,
     /* 2394488 */     GIR_EraseRootFromParent_Done,
     /* 2394489 */   // Label 34427: @2394489
     /* 2394489 */   GIM_Try, /*On fail goto*//*Label 34428*/ GIMT_Encode4(2394534), // Rule ID 54958 //
     /* 2394494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2394497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394509 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2394512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394514 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394516 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394518 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394532 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394533 */     // GIR_Coverage, 54958,
     /* 2394533 */     GIR_EraseRootFromParent_Done,
     /* 2394534 */   // Label 34428: @2394534
     /* 2394534 */   GIM_Try, /*On fail goto*//*Label 34429*/ GIMT_Encode4(2394579), // Rule ID 54959 //
     /* 2394539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2394542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2394554 */     // (strict_fma:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E32:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E32),
     /* 2394557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394559 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394561 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2394563 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2394574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394577 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394578 */     // GIR_Coverage, 54959,
     /* 2394578 */     GIR_EraseRootFromParent_Done,
     /* 2394579 */   // Label 34429: @2394579
     /* 2394579 */   GIM_Reject,
     /* 2394580 */ // Label 34417: @2394580
     /* 2394580 */ GIM_Reject,
     /* 2394581 */ // Label 34273: @2394581
     /* 2394581 */ GIM_Try, /*On fail goto*//*Label 34430*/ GIMT_Encode4(2395370),
     /* 2394586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2394592 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 2394595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394599 */   GIM_Try, /*On fail goto*//*Label 34431*/ GIMT_Encode4(2394676), // Rule ID 55478 //
     /* 2394604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2394632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394647 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2394650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394652 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394675 */     // GIR_Coverage, 55478,
     /* 2394675 */     GIR_EraseRootFromParent_Done,
     /* 2394676 */   // Label 34431: @2394676
     /* 2394676 */   GIM_Try, /*On fail goto*//*Label 34432*/ GIMT_Encode4(2394753), // Rule ID 55479 //
     /* 2394681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2394684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2394709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394724 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2394727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394729 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394752 */     // GIR_Coverage, 55479,
     /* 2394752 */     GIR_EraseRootFromParent_Done,
     /* 2394753 */   // Label 34432: @2394753
     /* 2394753 */   GIM_Try, /*On fail goto*//*Label 34433*/ GIMT_Encode4(2394830), // Rule ID 72731 //
     /* 2394758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2394786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394790 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394801 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2394804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394806 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394829 */     // GIR_Coverage, 72731,
     /* 2394829 */     GIR_EraseRootFromParent_Done,
     /* 2394830 */   // Label 34433: @2394830
     /* 2394830 */   GIM_Try, /*On fail goto*//*Label 34434*/ GIMT_Encode4(2394907), // Rule ID 72732 //
     /* 2394835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2394838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2394846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2394863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394876 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2394878 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2394878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E64),
     /* 2394881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394883 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2394885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2394893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394905 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394906 */     // GIR_Coverage, 72732,
     /* 2394906 */     GIR_EraseRootFromParent_Done,
     /* 2394907 */   // Label 34434: @2394907
     /* 2394907 */   GIM_Try, /*On fail goto*//*Label 34435*/ GIMT_Encode4(2394969), // Rule ID 55482 //
     /* 2394912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2394915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2394942 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2394942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2394945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2394947 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2394949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2394953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2394955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2394958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2394961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2394964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2394967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2394968 */     // GIR_Coverage, 55482,
     /* 2394968 */     GIR_EraseRootFromParent_Done,
     /* 2394969 */   // Label 34435: @2394969
     /* 2394969 */   GIM_Try, /*On fail goto*//*Label 34436*/ GIMT_Encode4(2395031), // Rule ID 55483 //
     /* 2394974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2394977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2394981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2394985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2394989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2394998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395004 */     // (strict_fma:{ *:[nxv2f64] } (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2395007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395009 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395015 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395030 */     // GIR_Coverage, 55483,
     /* 2395030 */     GIR_EraseRootFromParent_Done,
     /* 2395031 */   // Label 34436: @2395031
     /* 2395031 */   GIM_Try, /*On fail goto*//*Label 34437*/ GIMT_Encode4(2395093), // Rule ID 72735 //
     /* 2395036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395066 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2395069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395071 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395077 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395091 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395092 */     // GIR_Coverage, 72735,
     /* 2395092 */     GIR_EraseRootFromParent_Done,
     /* 2395093 */   // Label 34437: @2395093
     /* 2395093 */   GIM_Try, /*On fail goto*//*Label 34438*/ GIMT_Encode4(2395155), // Rule ID 72736 //
     /* 2395098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395128 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1), VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E64),
     /* 2395131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395139 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395153 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395154 */     // GIR_Coverage, 72736,
     /* 2395154 */     GIR_EraseRootFromParent_Done,
     /* 2395155 */   // Label 34438: @2395155
     /* 2395155 */   GIM_Try, /*On fail goto*//*Label 34439*/ GIMT_Encode4(2395217), // Rule ID 55474 //
     /* 2395160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2395175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395190 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2395193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395195 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395197 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2395203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395215 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395216 */     // GIR_Coverage, 55474,
     /* 2395216 */     GIR_EraseRootFromParent_Done,
     /* 2395217 */   // Label 34439: @2395217
     /* 2395217 */   GIM_Try, /*On fail goto*//*Label 34440*/ GIMT_Encode4(2395279), // Rule ID 55475 //
     /* 2395222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2395237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2395245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395252 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, (fneg:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E64),
     /* 2395255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2395265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395278 */     // GIR_Coverage, 55475,
     /* 2395278 */     GIR_EraseRootFromParent_Done,
     /* 2395279 */   // Label 34440: @2395279
     /* 2395279 */   GIM_Try, /*On fail goto*//*Label 34441*/ GIMT_Encode4(2395324), // Rule ID 55470 //
     /* 2395284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2395287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395299 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2395302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395306 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395308 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395322 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395323 */     // GIR_Coverage, 55470,
     /* 2395323 */     GIR_EraseRootFromParent_Done,
     /* 2395324 */   // Label 34441: @2395324
     /* 2395324 */   GIM_Try, /*On fail goto*//*Label 34442*/ GIMT_Encode4(2395369), // Rule ID 55471 //
     /* 2395329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2395332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2395344 */     // (strict_fma:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E64:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E64),
     /* 2395347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395349 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395351 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395353 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2395364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395367 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395368 */     // GIR_Coverage, 55471,
     /* 2395368 */     GIR_EraseRootFromParent_Done,
     /* 2395369 */   // Label 34442: @2395369
     /* 2395369 */   GIM_Reject,
     /* 2395370 */ // Label 34430: @2395370
     /* 2395370 */ GIM_Reject,
     /* 2395371 */ // Label 34274: @2395371
     /* 2395371 */ GIM_Try, /*On fail goto*//*Label 34443*/ GIMT_Encode4(2396160),
     /* 2395376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2395382 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 2395385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395389 */   GIM_Try, /*On fail goto*//*Label 34444*/ GIMT_Encode4(2395466), // Rule ID 54902 //
     /* 2395394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395437 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2395440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395442 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395465 */     // GIR_Coverage, 54902,
     /* 2395465 */     GIR_EraseRootFromParent_Done,
     /* 2395466 */   // Label 34444: @2395466
     /* 2395466 */   GIM_Try, /*On fail goto*//*Label 34445*/ GIMT_Encode4(2395543), // Rule ID 54903 //
     /* 2395471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395507 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395514 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2395517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395519 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395542 */     // GIR_Coverage, 54903,
     /* 2395542 */     GIR_EraseRootFromParent_Done,
     /* 2395543 */   // Label 34445: @2395543
     /* 2395543 */   GIM_Try, /*On fail goto*//*Label 34446*/ GIMT_Encode4(2395620), // Rule ID 72227 //
     /* 2395548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395567 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395591 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2395594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395619 */     // GIR_Coverage, 72227,
     /* 2395619 */     GIR_EraseRootFromParent_Done,
     /* 2395620 */   // Label 34446: @2395620
     /* 2395620 */   GIM_Try, /*On fail goto*//*Label 34447*/ GIMT_Encode4(2395697), // Rule ID 72228 //
     /* 2395625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395649 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2395653 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395657 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2395668 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M1_E16),
     /* 2395671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395673 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2395683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395695 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395696 */     // GIR_Coverage, 72228,
     /* 2395696 */     GIR_EraseRootFromParent_Done,
     /* 2395697 */   // Label 34447: @2395697
     /* 2395697 */   GIM_Try, /*On fail goto*//*Label 34448*/ GIMT_Encode4(2395759), // Rule ID 54906 //
     /* 2395702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395732 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2395735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395737 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395743 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395757 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395758 */     // GIR_Coverage, 54906,
     /* 2395758 */     GIR_EraseRootFromParent_Done,
     /* 2395759 */   // Label 34448: @2395759
     /* 2395759 */   GIM_Try, /*On fail goto*//*Label 34449*/ GIMT_Encode4(2395821), // Rule ID 54907 //
     /* 2395764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2395771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395794 */     // (strict_fma:{ *:[nxv4f16] } (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2395797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395799 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395805 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395819 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395820 */     // GIR_Coverage, 54907,
     /* 2395820 */     GIR_EraseRootFromParent_Done,
     /* 2395821 */   // Label 34449: @2395821
     /* 2395821 */   GIM_Try, /*On fail goto*//*Label 34450*/ GIMT_Encode4(2395883), // Rule ID 72231 //
     /* 2395826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395845 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395854 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395856 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2395859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395861 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395867 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395881 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395882 */     // GIR_Coverage, 72231,
     /* 2395882 */     GIR_EraseRootFromParent_Done,
     /* 2395883 */   // Label 34450: @2395883
     /* 2395883 */   GIM_Try, /*On fail goto*//*Label 34451*/ GIMT_Encode4(2395945), // Rule ID 72232 //
     /* 2395888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2395891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2395899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395918 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1), VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2395918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M1_E16),
     /* 2395921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395923 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2395925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2395929 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2395931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2395940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2395943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2395944 */     // GIR_Coverage, 72232,
     /* 2395944 */     GIR_EraseRootFromParent_Done,
     /* 2395945 */   // Label 34451: @2395945
     /* 2395945 */   GIM_Try, /*On fail goto*//*Label 34452*/ GIMT_Encode4(2396007), // Rule ID 54898 //
     /* 2395950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2395953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2395965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2395969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2395973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2395978 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2395980 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2395980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2395983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2395985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2395987 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2395989 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2395993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2395996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2395999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396005 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396006 */     // GIR_Coverage, 54898,
     /* 2396006 */     GIR_EraseRootFromParent_Done,
     /* 2396007 */   // Label 34452: @2396007
     /* 2396007 */   GIM_Try, /*On fail goto*//*Label 34453*/ GIMT_Encode4(2396069), // Rule ID 54899 //
     /* 2396012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2396027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2396035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396042 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, (fneg:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M1_E16),
     /* 2396045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396047 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2396055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396068 */     // GIR_Coverage, 54899,
     /* 2396068 */     GIR_EraseRootFromParent_Done,
     /* 2396069 */   // Label 34453: @2396069
     /* 2396069 */   GIM_Try, /*On fail goto*//*Label 34454*/ GIMT_Encode4(2396114), // Rule ID 54894 //
     /* 2396074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2396077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396089 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2396092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396094 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396096 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396098 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396113 */     // GIR_Coverage, 54894,
     /* 2396113 */     GIR_EraseRootFromParent_Done,
     /* 2396114 */   // Label 34454: @2396114
     /* 2396114 */   GIM_Try, /*On fail goto*//*Label 34455*/ GIMT_Encode4(2396159), // Rule ID 54895 //
     /* 2396119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2396122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2396134 */     // (strict_fma:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFMADD_VV_M1_E16:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M1_E16),
     /* 2396137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396143 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396148 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2396154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396157 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396158 */     // GIR_Coverage, 54895,
     /* 2396158 */     GIR_EraseRootFromParent_Done,
     /* 2396159 */   // Label 34455: @2396159
     /* 2396159 */   GIM_Reject,
     /* 2396160 */ // Label 34443: @2396160
     /* 2396160 */ GIM_Reject,
     /* 2396161 */ // Label 34275: @2396161
     /* 2396161 */ GIM_Try, /*On fail goto*//*Label 34456*/ GIMT_Encode4(2396950),
     /* 2396166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2396172 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 2396175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396179 */   GIM_Try, /*On fail goto*//*Label 34457*/ GIMT_Encode4(2396256), // Rule ID 55286 //
     /* 2396184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396227 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2396230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396254 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396255 */     // GIR_Coverage, 55286,
     /* 2396255 */     GIR_EraseRootFromParent_Done,
     /* 2396256 */   // Label 34457: @2396256
     /* 2396256 */   GIM_Try, /*On fail goto*//*Label 34458*/ GIMT_Encode4(2396333), // Rule ID 55287 //
     /* 2396261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396304 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2396307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396309 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396331 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396332 */     // GIR_Coverage, 55287,
     /* 2396332 */     GIR_EraseRootFromParent_Done,
     /* 2396333 */   // Label 34458: @2396333
     /* 2396333 */   GIM_Try, /*On fail goto*//*Label 34459*/ GIMT_Encode4(2396410), // Rule ID 72563 //
     /* 2396338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396381 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2396384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396386 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396408 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396409 */     // GIR_Coverage, 72563,
     /* 2396409 */     GIR_EraseRootFromParent_Done,
     /* 2396410 */   // Label 34459: @2396410
     /* 2396410 */   GIM_Try, /*On fail goto*//*Label 34460*/ GIMT_Encode4(2396487), // Rule ID 72564 //
     /* 2396415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2396443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2396458 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E32),
     /* 2396461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396463 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2396473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396486 */     // GIR_Coverage, 72564,
     /* 2396486 */     GIR_EraseRootFromParent_Done,
     /* 2396487 */   // Label 34460: @2396487
     /* 2396487 */   GIM_Try, /*On fail goto*//*Label 34461*/ GIMT_Encode4(2396549), // Rule ID 55290 //
     /* 2396492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396522 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2396525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396527 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396533 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396547 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396548 */     // GIR_Coverage, 55290,
     /* 2396548 */     GIR_EraseRootFromParent_Done,
     /* 2396549 */   // Label 34461: @2396549
     /* 2396549 */   GIM_Try, /*On fail goto*//*Label 34462*/ GIMT_Encode4(2396611), // Rule ID 55291 //
     /* 2396554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396584 */     // (strict_fma:{ *:[nxv4f32] } (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2396587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396589 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396610 */     // GIR_Coverage, 55291,
     /* 2396610 */     GIR_EraseRootFromParent_Done,
     /* 2396611 */   // Label 34462: @2396611
     /* 2396611 */   GIM_Try, /*On fail goto*//*Label 34463*/ GIMT_Encode4(2396673), // Rule ID 72567 //
     /* 2396616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396646 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2396649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396651 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396657 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396671 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396672 */     // GIR_Coverage, 72567,
     /* 2396672 */     GIR_EraseRootFromParent_Done,
     /* 2396673 */   // Label 34463: @2396673
     /* 2396673 */   GIM_Try, /*On fail goto*//*Label 34464*/ GIMT_Encode4(2396735), // Rule ID 72568 //
     /* 2396678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2396689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396708 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1), VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E32),
     /* 2396711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2396715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2396719 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396733 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396734 */     // GIR_Coverage, 72568,
     /* 2396734 */     GIR_EraseRootFromParent_Done,
     /* 2396735 */   // Label 34464: @2396735
     /* 2396735 */   GIM_Try, /*On fail goto*//*Label 34465*/ GIMT_Encode4(2396797), // Rule ID 55282 //
     /* 2396740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2396755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396768 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396770 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2396773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396775 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396777 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2396783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396795 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396796 */     // GIR_Coverage, 55282,
     /* 2396796 */     GIR_EraseRootFromParent_Done,
     /* 2396797 */   // Label 34465: @2396797
     /* 2396797 */   GIM_Try, /*On fail goto*//*Label 34466*/ GIMT_Encode4(2396859), // Rule ID 55283 //
     /* 2396802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2396817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2396825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2396832 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, (fneg:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E32),
     /* 2396835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396837 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396839 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2396845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396858 */     // GIR_Coverage, 55283,
     /* 2396858 */     GIR_EraseRootFromParent_Done,
     /* 2396859 */   // Label 34466: @2396859
     /* 2396859 */   GIM_Try, /*On fail goto*//*Label 34467*/ GIMT_Encode4(2396904), // Rule ID 55278 //
     /* 2396864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2396867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396879 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2396879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2396882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396888 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396902 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396903 */     // GIR_Coverage, 55278,
     /* 2396903 */     GIR_EraseRootFromParent_Done,
     /* 2396904 */   // Label 34467: @2396904
     /* 2396904 */   GIM_Try, /*On fail goto*//*Label 34468*/ GIMT_Encode4(2396949), // Rule ID 55279 //
     /* 2396909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2396912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2396924 */     // (strict_fma:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E32:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2396924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E32),
     /* 2396927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2396929 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2396931 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2396933 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2396935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2396938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2396941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2396944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2396947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2396948 */     // GIR_Coverage, 55279,
     /* 2396948 */     GIR_EraseRootFromParent_Done,
     /* 2396949 */   // Label 34468: @2396949
     /* 2396949 */   GIM_Reject,
     /* 2396950 */ // Label 34456: @2396950
     /* 2396950 */ GIM_Reject,
     /* 2396951 */ // Label 34276: @2396951
     /* 2396951 */ GIM_Try, /*On fail goto*//*Label 34469*/ GIMT_Encode4(2397740),
     /* 2396956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2396959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2396962 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s64,
     /* 2396965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396969 */   GIM_Try, /*On fail goto*//*Label 34470*/ GIMT_Encode4(2397046), // Rule ID 55542 //
     /* 2396974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2396977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2396981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2396985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2396989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2396998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397006 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397017 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2397020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397022 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397044 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397045 */     // GIR_Coverage, 55542,
     /* 2397045 */     GIR_EraseRootFromParent_Done,
     /* 2397046 */   // Label 34470: @2397046
     /* 2397046 */   GIM_Try, /*On fail goto*//*Label 34471*/ GIMT_Encode4(2397123), // Rule ID 55543 //
     /* 2397051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397087 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397094 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2397097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397122 */     // GIR_Coverage, 55543,
     /* 2397122 */     GIR_EraseRootFromParent_Done,
     /* 2397123 */   // Label 34471: @2397123
     /* 2397123 */   GIM_Try, /*On fail goto*//*Label 34472*/ GIMT_Encode4(2397200), // Rule ID 72787 //
     /* 2397128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397169 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397171 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2397174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397199 */     // GIR_Coverage, 72787,
     /* 2397199 */     GIR_EraseRootFromParent_Done,
     /* 2397200 */   // Label 34472: @2397200
     /* 2397200 */   GIM_Try, /*On fail goto*//*Label 34473*/ GIMT_Encode4(2397277), // Rule ID 72788 //
     /* 2397205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397241 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397248 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E64),
     /* 2397251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397276 */     // GIR_Coverage, 72788,
     /* 2397276 */     GIR_EraseRootFromParent_Done,
     /* 2397277 */   // Label 34473: @2397277
     /* 2397277 */   GIM_Try, /*On fail goto*//*Label 34474*/ GIMT_Encode4(2397339), // Rule ID 55546 //
     /* 2397282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397312 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2397315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397323 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397337 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397338 */     // GIR_Coverage, 55546,
     /* 2397338 */     GIR_EraseRootFromParent_Done,
     /* 2397339 */   // Label 34474: @2397339
     /* 2397339 */   GIM_Try, /*On fail goto*//*Label 34475*/ GIMT_Encode4(2397401), // Rule ID 55547 //
     /* 2397344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397372 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397374 */     // (strict_fma:{ *:[nxv4f64] } (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2397377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397385 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397399 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397400 */     // GIR_Coverage, 55547,
     /* 2397400 */     GIR_EraseRootFromParent_Done,
     /* 2397401 */   // Label 34475: @2397401
     /* 2397401 */   GIM_Try, /*On fail goto*//*Label 34476*/ GIMT_Encode4(2397463), // Rule ID 72791 //
     /* 2397406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397436 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2397439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397447 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397461 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397462 */     // GIR_Coverage, 72791,
     /* 2397462 */     GIR_EraseRootFromParent_Done,
     /* 2397463 */   // Label 34476: @2397463
     /* 2397463 */   GIM_Try, /*On fail goto*//*Label 34477*/ GIMT_Encode4(2397525), // Rule ID 72792 //
     /* 2397468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397498 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1), VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E64),
     /* 2397501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397509 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397524 */     // GIR_Coverage, 72792,
     /* 2397524 */     GIR_EraseRootFromParent_Done,
     /* 2397525 */   // Label 34477: @2397525
     /* 2397525 */   GIM_Try, /*On fail goto*//*Label 34478*/ GIMT_Encode4(2397587), // Rule ID 55538 //
     /* 2397530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397560 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2397563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397565 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397567 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2397573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397586 */     // GIR_Coverage, 55538,
     /* 2397586 */     GIR_EraseRootFromParent_Done,
     /* 2397587 */   // Label 34478: @2397587
     /* 2397587 */   GIM_Try, /*On fail goto*//*Label 34479*/ GIMT_Encode4(2397649), // Rule ID 55539 //
     /* 2397592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2397607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2397615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2397622 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, (fneg:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E64),
     /* 2397625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397627 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397629 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2397635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397648 */     // GIR_Coverage, 55539,
     /* 2397648 */     GIR_EraseRootFromParent_Done,
     /* 2397649 */   // Label 34479: @2397649
     /* 2397649 */   GIM_Try, /*On fail goto*//*Label 34480*/ GIMT_Encode4(2397694), // Rule ID 55534 //
     /* 2397654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2397657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397669 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2397672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397674 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397676 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397678 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397692 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397693 */     // GIR_Coverage, 55534,
     /* 2397693 */     GIR_EraseRootFromParent_Done,
     /* 2397694 */   // Label 34480: @2397694
     /* 2397694 */   GIM_Try, /*On fail goto*//*Label 34481*/ GIMT_Encode4(2397739), // Rule ID 55535 //
     /* 2397699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2397702 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2397714 */     // (strict_fma:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E64:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E64),
     /* 2397717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397719 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2397723 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2397725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2397734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397737 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397738 */     // GIR_Coverage, 55535,
     /* 2397738 */     GIR_EraseRootFromParent_Done,
     /* 2397739 */   // Label 34481: @2397739
     /* 2397739 */   GIM_Reject,
     /* 2397740 */ // Label 34469: @2397740
     /* 2397740 */ GIM_Reject,
     /* 2397741 */ // Label 34277: @2397741
     /* 2397741 */ GIM_Try, /*On fail goto*//*Label 34482*/ GIMT_Encode4(2398530),
     /* 2397746 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397749 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2397752 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 2397755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397759 */   GIM_Try, /*On fail goto*//*Label 34483*/ GIMT_Encode4(2397836), // Rule ID 55094 //
     /* 2397764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397807 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2397810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397835 */     // GIR_Coverage, 55094,
     /* 2397835 */     GIR_EraseRootFromParent_Done,
     /* 2397836 */   // Label 34483: @2397836
     /* 2397836 */   GIM_Try, /*On fail goto*//*Label 34484*/ GIMT_Encode4(2397913), // Rule ID 55095 //
     /* 2397841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2397848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397884 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2397884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2397887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397889 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2397891 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397911 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397912 */     // GIR_Coverage, 55095,
     /* 2397912 */     GIR_EraseRootFromParent_Done,
     /* 2397913 */   // Label 34484: @2397913
     /* 2397913 */   GIM_Try, /*On fail goto*//*Label 34485*/ GIMT_Encode4(2397990), // Rule ID 72395 //
     /* 2397918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2397921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2397929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2397946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2397950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2397954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2397959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2397961 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2397961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2397964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2397966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2397968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2397972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2397976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2397979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2397982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2397985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2397988 */     GIR_RootConstrainSelectedInstOperands,
     /* 2397989 */     // GIR_Coverage, 72395,
     /* 2397989 */     GIR_EraseRootFromParent_Done,
     /* 2397990 */   // Label 34485: @2397990
     /* 2397990 */   GIM_Try, /*On fail goto*//*Label 34486*/ GIMT_Encode4(2398067), // Rule ID 72396 //
     /* 2397995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2397998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398038 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M2_E16),
     /* 2398041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398065 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398066 */     // GIR_Coverage, 72396,
     /* 2398066 */     GIR_EraseRootFromParent_Done,
     /* 2398067 */   // Label 34486: @2398067
     /* 2398067 */   GIM_Try, /*On fail goto*//*Label 34487*/ GIMT_Encode4(2398129), // Rule ID 55098 //
     /* 2398072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398102 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2398105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398113 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398127 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398128 */     // GIR_Coverage, 55098,
     /* 2398128 */     GIR_EraseRootFromParent_Done,
     /* 2398129 */   // Label 34487: @2398129
     /* 2398129 */   GIM_Try, /*On fail goto*//*Label 34488*/ GIMT_Encode4(2398191), // Rule ID 55099 //
     /* 2398134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398164 */     // (strict_fma:{ *:[nxv8f16] } (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2398167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398169 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398175 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398189 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398190 */     // GIR_Coverage, 55099,
     /* 2398190 */     GIR_EraseRootFromParent_Done,
     /* 2398191 */   // Label 34488: @2398191
     /* 2398191 */   GIM_Try, /*On fail goto*//*Label 34489*/ GIMT_Encode4(2398253), // Rule ID 72399 //
     /* 2398196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398226 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2398229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398231 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398233 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398237 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398252 */     // GIR_Coverage, 72399,
     /* 2398252 */     GIR_EraseRootFromParent_Done,
     /* 2398253 */   // Label 34489: @2398253
     /* 2398253 */   GIM_Try, /*On fail goto*//*Label 34490*/ GIMT_Encode4(2398315), // Rule ID 72400 //
     /* 2398258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398288 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1), VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M2_E16),
     /* 2398291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398293 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398299 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398313 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398314 */     // GIR_Coverage, 72400,
     /* 2398314 */     GIR_EraseRootFromParent_Done,
     /* 2398315 */   // Label 34490: @2398315
     /* 2398315 */   GIM_Try, /*On fail goto*//*Label 34491*/ GIMT_Encode4(2398377), // Rule ID 55090 //
     /* 2398320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2398335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398350 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2398353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398355 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398357 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2398363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398375 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398376 */     // GIR_Coverage, 55090,
     /* 2398376 */     GIR_EraseRootFromParent_Done,
     /* 2398377 */   // Label 34491: @2398377
     /* 2398377 */   GIM_Try, /*On fail goto*//*Label 34492*/ GIMT_Encode4(2398439), // Rule ID 55091 //
     /* 2398382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2398397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2398405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398412 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, (fneg:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M2_E16),
     /* 2398415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398417 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2398425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398438 */     // GIR_Coverage, 55091,
     /* 2398438 */     GIR_EraseRootFromParent_Done,
     /* 2398439 */   // Label 34492: @2398439
     /* 2398439 */   GIM_Try, /*On fail goto*//*Label 34493*/ GIMT_Encode4(2398484), // Rule ID 55086 //
     /* 2398444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2398447 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398459 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2398462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398464 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398483 */     // GIR_Coverage, 55086,
     /* 2398483 */     GIR_EraseRootFromParent_Done,
     /* 2398484 */   // Label 34493: @2398484
     /* 2398484 */   GIM_Try, /*On fail goto*//*Label 34494*/ GIMT_Encode4(2398529), // Rule ID 55087 //
     /* 2398489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2398492 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2398504 */     // (strict_fma:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFMADD_VV_M2_E16:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M2_E16),
     /* 2398507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398509 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398511 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2398513 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398515 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2398524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398527 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398528 */     // GIR_Coverage, 55087,
     /* 2398528 */     GIR_EraseRootFromParent_Done,
     /* 2398529 */   // Label 34494: @2398529
     /* 2398529 */   GIM_Reject,
     /* 2398530 */ // Label 34482: @2398530
     /* 2398530 */ GIM_Reject,
     /* 2398531 */ // Label 34278: @2398531
     /* 2398531 */ GIM_Try, /*On fail goto*//*Label 34495*/ GIMT_Encode4(2399320),
     /* 2398536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2398542 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s32,
     /* 2398545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398549 */   GIM_Try, /*On fail goto*//*Label 34496*/ GIMT_Encode4(2398626), // Rule ID 55350 //
     /* 2398554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398582 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398586 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398590 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398597 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2398600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398602 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398625 */     // GIR_Coverage, 55350,
     /* 2398625 */     GIR_EraseRootFromParent_Done,
     /* 2398626 */   // Label 34496: @2398626
     /* 2398626 */   GIM_Try, /*On fail goto*//*Label 34497*/ GIMT_Encode4(2398703), // Rule ID 55351 //
     /* 2398631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398674 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2398677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398679 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398702 */     // GIR_Coverage, 55351,
     /* 2398702 */     GIR_EraseRootFromParent_Done,
     /* 2398703 */   // Label 34497: @2398703
     /* 2398703 */   GIM_Try, /*On fail goto*//*Label 34498*/ GIMT_Encode4(2398780), // Rule ID 72619 //
     /* 2398708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398751 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2398754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398756 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398778 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398779 */     // GIR_Coverage, 72619,
     /* 2398779 */     GIR_EraseRootFromParent_Done,
     /* 2398780 */   // Label 34498: @2398780
     /* 2398780 */   GIM_Try, /*On fail goto*//*Label 34499*/ GIMT_Encode4(2398857), // Rule ID 72620 //
     /* 2398785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2398813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2398828 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E32),
     /* 2398831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398833 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2398835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2398843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398855 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398856 */     // GIR_Coverage, 72620,
     /* 2398856 */     GIR_EraseRootFromParent_Done,
     /* 2398857 */   // Label 34499: @2398857
     /* 2398857 */   GIM_Try, /*On fail goto*//*Label 34500*/ GIMT_Encode4(2398919), // Rule ID 55354 //
     /* 2398862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398892 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2398892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2398895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398897 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398903 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398917 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398918 */     // GIR_Coverage, 55354,
     /* 2398918 */     GIR_EraseRootFromParent_Done,
     /* 2398919 */   // Label 34500: @2398919
     /* 2398919 */   GIM_Try, /*On fail goto*//*Label 34501*/ GIMT_Encode4(2398981), // Rule ID 55355 //
     /* 2398924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2398927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2398931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2398935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2398939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2398954 */     // (strict_fma:{ *:[nxv8f32] } (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2398954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2398957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2398959 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2398961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2398965 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2398967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2398970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2398973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2398976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2398979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2398980 */     // GIR_Coverage, 55355,
     /* 2398980 */     GIR_EraseRootFromParent_Done,
     /* 2398981 */   // Label 34501: @2398981
     /* 2398981 */   GIM_Try, /*On fail goto*//*Label 34502*/ GIMT_Encode4(2399043), // Rule ID 72623 //
     /* 2398986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2398989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2398993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2398997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399016 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2399019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399027 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399042 */     // GIR_Coverage, 72623,
     /* 2399042 */     GIR_EraseRootFromParent_Done,
     /* 2399043 */   // Label 34502: @2399043
     /* 2399043 */   GIM_Try, /*On fail goto*//*Label 34503*/ GIMT_Encode4(2399105), // Rule ID 72624 //
     /* 2399048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399078 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1), VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E32),
     /* 2399081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399083 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399089 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399104 */     // GIR_Coverage, 72624,
     /* 2399104 */     GIR_EraseRootFromParent_Done,
     /* 2399105 */   // Label 34503: @2399105
     /* 2399105 */   GIM_Try, /*On fail goto*//*Label 34504*/ GIMT_Encode4(2399167), // Rule ID 55346 //
     /* 2399110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399140 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2399143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399145 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399147 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2399153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399166 */     // GIR_Coverage, 55346,
     /* 2399166 */     GIR_EraseRootFromParent_Done,
     /* 2399167 */   // Label 34504: @2399167
     /* 2399167 */   GIM_Try, /*On fail goto*//*Label 34505*/ GIMT_Encode4(2399229), // Rule ID 55347 //
     /* 2399172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2399195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399202 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, (fneg:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E32),
     /* 2399205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2399215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399227 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399228 */     // GIR_Coverage, 55347,
     /* 2399228 */     GIR_EraseRootFromParent_Done,
     /* 2399229 */   // Label 34505: @2399229
     /* 2399229 */   GIM_Try, /*On fail goto*//*Label 34506*/ GIMT_Encode4(2399274), // Rule ID 55342 //
     /* 2399234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2399237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399249 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2399252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399256 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399273 */     // GIR_Coverage, 55342,
     /* 2399273 */     GIR_EraseRootFromParent_Done,
     /* 2399274 */   // Label 34506: @2399274
     /* 2399274 */   GIM_Try, /*On fail goto*//*Label 34507*/ GIMT_Encode4(2399319), // Rule ID 55343 //
     /* 2399279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2399282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2399294 */     // (strict_fma:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E32:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E32),
     /* 2399297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399301 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399303 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399305 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2399314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399317 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399318 */     // GIR_Coverage, 55343,
     /* 2399318 */     GIR_EraseRootFromParent_Done,
     /* 2399319 */   // Label 34507: @2399319
     /* 2399319 */   GIM_Reject,
     /* 2399320 */ // Label 34495: @2399320
     /* 2399320 */ GIM_Reject,
     /* 2399321 */ // Label 34279: @2399321
     /* 2399321 */ GIM_Try, /*On fail goto*//*Label 34508*/ GIMT_Encode4(2400110),
     /* 2399326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2399332 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s64,
     /* 2399335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399339 */   GIM_Try, /*On fail goto*//*Label 34509*/ GIMT_Encode4(2399416), // Rule ID 55606 //
     /* 2399344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399376 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399387 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2399390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399392 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399414 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399415 */     // GIR_Coverage, 55606,
     /* 2399415 */     GIR_EraseRootFromParent_Done,
     /* 2399416 */   // Label 34509: @2399416
     /* 2399416 */   GIM_Try, /*On fail goto*//*Label 34510*/ GIMT_Encode4(2399493), // Rule ID 55607 //
     /* 2399421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399464 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2399467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399469 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399491 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399492 */     // GIR_Coverage, 55607,
     /* 2399492 */     GIR_EraseRootFromParent_Done,
     /* 2399493 */   // Label 34510: @2399493
     /* 2399493 */   GIM_Try, /*On fail goto*//*Label 34511*/ GIMT_Encode4(2399570), // Rule ID 72843 //
     /* 2399498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399534 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399541 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2399544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399546 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399569 */     // GIR_Coverage, 72843,
     /* 2399569 */     GIR_EraseRootFromParent_Done,
     /* 2399570 */   // Label 34511: @2399570
     /* 2399570 */   GIM_Try, /*On fail goto*//*Label 34512*/ GIMT_Encode4(2399647), // Rule ID 72844 //
     /* 2399575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2399603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2399618 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E64),
     /* 2399621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399623 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2399633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399646 */     // GIR_Coverage, 72844,
     /* 2399646 */     GIR_EraseRootFromParent_Done,
     /* 2399647 */   // Label 34512: @2399647
     /* 2399647 */   GIM_Try, /*On fail goto*//*Label 34513*/ GIMT_Encode4(2399709), // Rule ID 55610 //
     /* 2399652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399682 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2399685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399687 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399693 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399708 */     // GIR_Coverage, 55610,
     /* 2399708 */     GIR_EraseRootFromParent_Done,
     /* 2399709 */   // Label 34513: @2399709
     /* 2399709 */   GIM_Try, /*On fail goto*//*Label 34514*/ GIMT_Encode4(2399771), // Rule ID 55611 //
     /* 2399714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2399721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399744 */     // (strict_fma:{ *:[nxv8f64] } (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2399747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399749 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399755 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399770 */     // GIR_Coverage, 55611,
     /* 2399770 */     GIR_EraseRootFromParent_Done,
     /* 2399771 */   // Label 34514: @2399771
     /* 2399771 */   GIM_Try, /*On fail goto*//*Label 34515*/ GIMT_Encode4(2399833), // Rule ID 72847 //
     /* 2399776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399806 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2399809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399811 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399832 */     // GIR_Coverage, 72847,
     /* 2399832 */     GIR_EraseRootFromParent_Done,
     /* 2399833 */   // Label 34515: @2399833
     /* 2399833 */   GIM_Try, /*On fail goto*//*Label 34516*/ GIMT_Encode4(2399895), // Rule ID 72848 //
     /* 2399838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2399849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399868 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1), VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E64),
     /* 2399871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399873 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2399875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2399879 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2399881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399893 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399894 */     // GIR_Coverage, 72848,
     /* 2399894 */     GIR_EraseRootFromParent_Done,
     /* 2399895 */   // Label 34516: @2399895
     /* 2399895 */   GIM_Try, /*On fail goto*//*Label 34517*/ GIMT_Encode4(2399957), // Rule ID 55602 //
     /* 2399900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2399903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399930 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2399930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2399933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399937 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2399939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2399943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2399946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2399949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2399952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2399955 */     GIR_RootConstrainSelectedInstOperands,
     /* 2399956 */     // GIR_Coverage, 55602,
     /* 2399956 */     GIR_EraseRootFromParent_Done,
     /* 2399957 */   // Label 34517: @2399957
     /* 2399957 */   GIM_Try, /*On fail goto*//*Label 34518*/ GIMT_Encode4(2400019), // Rule ID 55603 //
     /* 2399962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2399965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2399977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2399981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2399985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2399990 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2399992 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, (fneg:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2399992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E64),
     /* 2399995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2399997 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2399999 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2400005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400017 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400018 */     // GIR_Coverage, 55603,
     /* 2400018 */     GIR_EraseRootFromParent_Done,
     /* 2400019 */   // Label 34518: @2400019
     /* 2400019 */   GIM_Try, /*On fail goto*//*Label 34519*/ GIMT_Encode4(2400064), // Rule ID 55598 //
     /* 2400024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2400027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400039 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2400042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400044 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400046 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400048 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400063 */     // GIR_Coverage, 55598,
     /* 2400063 */     GIR_EraseRootFromParent_Done,
     /* 2400064 */   // Label 34519: @2400064
     /* 2400064 */   GIM_Try, /*On fail goto*//*Label 34520*/ GIMT_Encode4(2400109), // Rule ID 55599 //
     /* 2400069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2400072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400084 */     // (strict_fma:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E64:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E64),
     /* 2400087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400089 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400091 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400093 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2400104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400107 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400108 */     // GIR_Coverage, 55599,
     /* 2400108 */     GIR_EraseRootFromParent_Done,
     /* 2400109 */   // Label 34520: @2400109
     /* 2400109 */   GIM_Reject,
     /* 2400110 */ // Label 34508: @2400110
     /* 2400110 */ GIM_Reject,
     /* 2400111 */ // Label 34280: @2400111
     /* 2400111 */ GIM_Try, /*On fail goto*//*Label 34521*/ GIMT_Encode4(2400900),
     /* 2400116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2400122 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s16,
     /* 2400125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400129 */   GIM_Try, /*On fail goto*//*Label 34522*/ GIMT_Encode4(2400206), // Rule ID 55158 //
     /* 2400134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400166 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400170 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400175 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400177 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2400180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400205 */     // GIR_Coverage, 55158,
     /* 2400205 */     GIR_EraseRootFromParent_Done,
     /* 2400206 */   // Label 34522: @2400206
     /* 2400206 */   GIM_Try, /*On fail goto*//*Label 34523*/ GIMT_Encode4(2400283), // Rule ID 55159 //
     /* 2400211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400247 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400254 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2400257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400281 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400282 */     // GIR_Coverage, 55159,
     /* 2400282 */     GIR_EraseRootFromParent_Done,
     /* 2400283 */   // Label 34523: @2400283
     /* 2400283 */   GIM_Try, /*On fail goto*//*Label 34524*/ GIMT_Encode4(2400360), // Rule ID 72451 //
     /* 2400288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400331 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2400334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400336 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400358 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400359 */     // GIR_Coverage, 72451,
     /* 2400359 */     GIR_EraseRootFromParent_Done,
     /* 2400360 */   // Label 34524: @2400360
     /* 2400360 */   GIM_Try, /*On fail goto*//*Label 34525*/ GIMT_Encode4(2400437), // Rule ID 72452 //
     /* 2400365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400406 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400408 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M4_E16),
     /* 2400411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400413 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400435 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400436 */     // GIR_Coverage, 72452,
     /* 2400436 */     GIR_EraseRootFromParent_Done,
     /* 2400437 */   // Label 34525: @2400437
     /* 2400437 */   GIM_Try, /*On fail goto*//*Label 34526*/ GIMT_Encode4(2400499), // Rule ID 55162 //
     /* 2400442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400453 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400472 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2400475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400483 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400498 */     // GIR_Coverage, 55162,
     /* 2400498 */     GIR_EraseRootFromParent_Done,
     /* 2400499 */   // Label 34526: @2400499
     /* 2400499 */   GIM_Try, /*On fail goto*//*Label 34527*/ GIMT_Encode4(2400561), // Rule ID 55163 //
     /* 2400504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400534 */     // (strict_fma:{ *:[nxv16f16] } (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2400537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400539 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400545 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400559 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400560 */     // GIR_Coverage, 55163,
     /* 2400560 */     GIR_EraseRootFromParent_Done,
     /* 2400561 */   // Label 34527: @2400561
     /* 2400561 */   GIM_Try, /*On fail goto*//*Label 34528*/ GIMT_Encode4(2400623), // Rule ID 72455 //
     /* 2400566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400596 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2400599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400601 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400607 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400621 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400622 */     // GIR_Coverage, 72455,
     /* 2400622 */     GIR_EraseRootFromParent_Done,
     /* 2400623 */   // Label 34528: @2400623
     /* 2400623 */   GIM_Try, /*On fail goto*//*Label 34529*/ GIMT_Encode4(2400685), // Rule ID 72456 //
     /* 2400628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2400639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400656 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400658 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1), VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M4_E16),
     /* 2400661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2400665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400669 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400683 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400684 */     // GIR_Coverage, 72456,
     /* 2400684 */     GIR_EraseRootFromParent_Done,
     /* 2400685 */   // Label 34529: @2400685
     /* 2400685 */   GIM_Try, /*On fail goto*//*Label 34530*/ GIMT_Encode4(2400747), // Rule ID 55154 //
     /* 2400690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2400705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400720 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2400723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400725 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400727 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2400733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400746 */     // GIR_Coverage, 55154,
     /* 2400746 */     GIR_EraseRootFromParent_Done,
     /* 2400747 */   // Label 34530: @2400747
     /* 2400747 */   GIM_Try, /*On fail goto*//*Label 34531*/ GIMT_Encode4(2400809), // Rule ID 55155 //
     /* 2400752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2400767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2400775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2400782 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, (fneg:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M4_E16),
     /* 2400785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400787 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400789 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2400795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400808 */     // GIR_Coverage, 55155,
     /* 2400808 */     GIR_EraseRootFromParent_Done,
     /* 2400809 */   // Label 34531: @2400809
     /* 2400809 */   GIM_Try, /*On fail goto*//*Label 34532*/ GIMT_Encode4(2400854), // Rule ID 55150 //
     /* 2400814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2400817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400825 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400829 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2400832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400834 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400836 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400838 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400852 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400853 */     // GIR_Coverage, 55150,
     /* 2400853 */     GIR_EraseRootFromParent_Done,
     /* 2400854 */   // Label 34532: @2400854
     /* 2400854 */   GIM_Try, /*On fail goto*//*Label 34533*/ GIMT_Encode4(2400899), // Rule ID 55151 //
     /* 2400859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2400862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400866 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400870 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2400874 */     // (strict_fma:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFMADD_VV_M4_E16:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2400874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M4_E16),
     /* 2400877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400881 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2400883 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2400885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2400894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400897 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400898 */     // GIR_Coverage, 55151,
     /* 2400898 */     GIR_EraseRootFromParent_Done,
     /* 2400899 */   // Label 34533: @2400899
     /* 2400899 */   GIM_Reject,
     /* 2400900 */ // Label 34521: @2400900
     /* 2400900 */ GIM_Reject,
     /* 2400901 */ // Label 34281: @2400901
     /* 2400901 */ GIM_Try, /*On fail goto*//*Label 34534*/ GIMT_Encode4(2401690),
     /* 2400906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400909 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2400912 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s32,
     /* 2400915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400919 */   GIM_Try, /*On fail goto*//*Label 34535*/ GIMT_Encode4(2400996), // Rule ID 55414 //
     /* 2400924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2400927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2400931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2400952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2400956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2400960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2400965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2400967 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2400967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2400970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2400972 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2400974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2400978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2400982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2400985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2400988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2400991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2400994 */     GIR_RootConstrainSelectedInstOperands,
     /* 2400995 */     // GIR_Coverage, 55414,
     /* 2400995 */     GIR_EraseRootFromParent_Done,
     /* 2400996 */   // Label 34535: @2400996
     /* 2400996 */   GIM_Try, /*On fail goto*//*Label 34536*/ GIMT_Encode4(2401073), // Rule ID 55415 //
     /* 2401001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401037 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401044 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2401047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401071 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401072 */     // GIR_Coverage, 55415,
     /* 2401072 */     GIR_EraseRootFromParent_Done,
     /* 2401073 */   // Label 34536: @2401073
     /* 2401073 */   GIM_Try, /*On fail goto*//*Label 34537*/ GIMT_Encode4(2401150), // Rule ID 72675 //
     /* 2401078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401121 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2401124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401126 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401148 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401149 */     // GIR_Coverage, 72675,
     /* 2401149 */     GIR_EraseRootFromParent_Done,
     /* 2401150 */   // Label 34537: @2401150
     /* 2401150 */   GIM_Try, /*On fail goto*//*Label 34538*/ GIMT_Encode4(2401227), // Rule ID 72676 //
     /* 2401155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401198 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E32),
     /* 2401201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401203 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401225 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401226 */     // GIR_Coverage, 72676,
     /* 2401226 */     GIR_EraseRootFromParent_Done,
     /* 2401227 */   // Label 34538: @2401227
     /* 2401227 */   GIM_Try, /*On fail goto*//*Label 34539*/ GIMT_Encode4(2401289), // Rule ID 55418 //
     /* 2401232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401262 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2401265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401267 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401273 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401288 */     // GIR_Coverage, 55418,
     /* 2401288 */     GIR_EraseRootFromParent_Done,
     /* 2401289 */   // Label 34539: @2401289
     /* 2401289 */   GIM_Try, /*On fail goto*//*Label 34540*/ GIMT_Encode4(2401351), // Rule ID 55419 //
     /* 2401294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401324 */     // (strict_fma:{ *:[nxv16f32] } (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2401327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401335 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401349 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401350 */     // GIR_Coverage, 55419,
     /* 2401350 */     GIR_EraseRootFromParent_Done,
     /* 2401351 */   // Label 34540: @2401351
     /* 2401351 */   GIM_Try, /*On fail goto*//*Label 34541*/ GIMT_Encode4(2401413), // Rule ID 72679 //
     /* 2401356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401386 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2401389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401397 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401399 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401402 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401411 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401412 */     // GIR_Coverage, 72679,
     /* 2401412 */     GIR_EraseRootFromParent_Done,
     /* 2401413 */   // Label 34541: @2401413
     /* 2401413 */   GIM_Try, /*On fail goto*//*Label 34542*/ GIMT_Encode4(2401475), // Rule ID 72680 //
     /* 2401418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401448 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1), VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E32),
     /* 2401451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401453 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401459 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401473 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401474 */     // GIR_Coverage, 72680,
     /* 2401474 */     GIR_EraseRootFromParent_Done,
     /* 2401475 */   // Label 34542: @2401475
     /* 2401475 */   GIM_Try, /*On fail goto*//*Label 34543*/ GIMT_Encode4(2401537), // Rule ID 55410 //
     /* 2401480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401510 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2401513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401515 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401517 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401535 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401536 */     // GIR_Coverage, 55410,
     /* 2401536 */     GIR_EraseRootFromParent_Done,
     /* 2401537 */   // Label 34543: @2401537
     /* 2401537 */   GIM_Try, /*On fail goto*//*Label 34544*/ GIMT_Encode4(2401599), // Rule ID 55411 //
     /* 2401542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2401557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2401565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2401572 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, (fneg:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E32),
     /* 2401575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401577 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401579 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2401585 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401597 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401598 */     // GIR_Coverage, 55411,
     /* 2401598 */     GIR_EraseRootFromParent_Done,
     /* 2401599 */   // Label 34544: @2401599
     /* 2401599 */   GIM_Try, /*On fail goto*//*Label 34545*/ GIMT_Encode4(2401644), // Rule ID 55406 //
     /* 2401604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2401607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401619 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2401622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401643 */     // GIR_Coverage, 55406,
     /* 2401643 */     GIR_EraseRootFromParent_Done,
     /* 2401644 */   // Label 34545: @2401644
     /* 2401644 */   GIM_Try, /*On fail goto*//*Label 34546*/ GIMT_Encode4(2401689), // Rule ID 55407 //
     /* 2401649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2401652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401664 */     // (strict_fma:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E32:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E32),
     /* 2401667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401669 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401671 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2401673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2401675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2401684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401688 */     // GIR_Coverage, 55407,
     /* 2401688 */     GIR_EraseRootFromParent_Done,
     /* 2401689 */   // Label 34546: @2401689
     /* 2401689 */   GIM_Reject,
     /* 2401690 */ // Label 34534: @2401690
     /* 2401690 */ GIM_Reject,
     /* 2401691 */ // Label 34282: @2401691
     /* 2401691 */ GIM_Try, /*On fail goto*//*Label 34547*/ GIMT_Encode4(2402480),
     /* 2401696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401699 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2401702 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv32s16,
     /* 2401705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401709 */   GIM_Try, /*On fail goto*//*Label 34548*/ GIMT_Encode4(2401786), // Rule ID 55222 //
     /* 2401714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401746 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401755 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401757 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2401760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401785 */     // GIR_Coverage, 55222,
     /* 2401785 */     GIR_EraseRootFromParent_Done,
     /* 2401786 */   // Label 34548: @2401786
     /* 2401786 */   GIM_Try, /*On fail goto*//*Label 34549*/ GIMT_Encode4(2401863), // Rule ID 55223 //
     /* 2401791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2401798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401834 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2401837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401839 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2401841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401862 */     // GIR_Coverage, 55223,
     /* 2401862 */     GIR_EraseRootFromParent_Done,
     /* 2401863 */   // Label 34549: @2401863
     /* 2401863 */   GIM_Try, /*On fail goto*//*Label 34550*/ GIMT_Encode4(2401940), // Rule ID 72507 //
     /* 2401868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2401871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401911 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2401911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2401914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2401926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2401929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2401932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2401935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2401938 */     GIR_RootConstrainSelectedInstOperands,
     /* 2401939 */     // GIR_Coverage, 72507,
     /* 2401939 */     GIR_EraseRootFromParent_Done,
     /* 2401940 */   // Label 34550: @2401940
     /* 2401940 */   GIM_Try, /*On fail goto*//*Label 34551*/ GIMT_Encode4(2402017), // Rule ID 72508 //
     /* 2401945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2401948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2401956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 2401973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2401977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2401981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2401986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 2401988 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFNMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2401988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMADD_VV_M8_E16),
     /* 2401991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2401993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2401995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2401999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // rs2
     /* 2402003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402016 */     // GIR_Coverage, 72508,
     /* 2402016 */     GIR_EraseRootFromParent_Done,
     /* 2402017 */   // Label 34551: @2402017
     /* 2402017 */   GIM_Try, /*On fail goto*//*Label 34552*/ GIMT_Encode4(2402079), // Rule ID 55226 //
     /* 2402022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402052 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2402055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402057 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402063 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402077 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402078 */     // GIR_Coverage, 55226,
     /* 2402078 */     GIR_EraseRootFromParent_Done,
     /* 2402079 */   // Label 34552: @2402079
     /* 2402079 */   GIM_Try, /*On fail goto*//*Label 34553*/ GIMT_Encode4(2402141), // Rule ID 55227 //
     /* 2402084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2402091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402114 */     // (strict_fma:{ *:[nxv32f16] } (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2402117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402119 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402125 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402139 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402140 */     // GIR_Coverage, 55227,
     /* 2402140 */     GIR_EraseRootFromParent_Done,
     /* 2402141 */   // Label 34553: @2402141
     /* 2402141 */   GIM_Try, /*On fail goto*//*Label 34554*/ GIMT_Encode4(2402203), // Rule ID 72511 //
     /* 2402146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402176 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2402179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402181 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402187 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402202 */     // GIR_Coverage, 72511,
     /* 2402202 */     GIR_EraseRootFromParent_Done,
     /* 2402203 */   // Label 34554: @2402203
     /* 2402203 */   GIM_Try, /*On fail goto*//*Label 34555*/ GIMT_Encode4(2402265), // Rule ID 72512 //
     /* 2402208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2402219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402238 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1), VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFNMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFNMSUB_VV_M8_E16),
     /* 2402241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402243 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2402245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs1
     /* 2402249 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402264 */     // GIR_Coverage, 72512,
     /* 2402264 */     GIR_EraseRootFromParent_Done,
     /* 2402265 */   // Label 34555: @2402265
     /* 2402265 */   GIM_Try, /*On fail goto*//*Label 34556*/ GIMT_Encode4(2402327), // Rule ID 55218 //
     /* 2402270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402300 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2402303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402305 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402307 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2402313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402325 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402326 */     // GIR_Coverage, 55218,
     /* 2402326 */     GIR_EraseRootFromParent_Done,
     /* 2402327 */   // Label 34556: @2402327
     /* 2402327 */   GIM_Try, /*On fail goto*//*Label 34557*/ GIMT_Encode4(2402389), // Rule ID 55219 //
     /* 2402332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402335 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2402347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 2402351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2402355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2402362 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, (fneg:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2))  =>  (PseudoVFMSUB_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMSUB_VV_M8_E16),
     /* 2402365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402367 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // rs2
     /* 2402375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402388 */     // GIR_Coverage, 55219,
     /* 2402388 */     GIR_EraseRootFromParent_Done,
     /* 2402389 */   // Label 34557: @2402389
     /* 2402389 */   GIM_Try, /*On fail goto*//*Label 34558*/ GIMT_Encode4(2402434), // Rule ID 55214 //
     /* 2402394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2402397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402409 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 1:{ *:[i64] })
     /* 2402409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2402412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402414 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402418 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402426 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402433 */     // GIR_Coverage, 55214,
     /* 2402433 */     GIR_EraseRootFromParent_Done,
     /* 2402434 */   // Label 34558: @2402434
     /* 2402434 */   GIM_Try, /*On fail goto*//*Label 34559*/ GIMT_Encode4(2402479), // Rule ID 55215 //
     /* 2402439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2402442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2402454 */     // (strict_fma:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFMADD_VV_M8_E16:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 1:{ *:[i32] })
     /* 2402454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFMADD_VV_M8_E16),
     /* 2402457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402459 */     GIR_RootToRootCopy, /*OpIdx*/2, // rd
     /* 2402461 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402463 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2402465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2402471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2402474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 2402477 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402478 */     // GIR_Coverage, 55215,
     /* 2402478 */     GIR_EraseRootFromParent_Done,
     /* 2402479 */   // Label 34559: @2402479
     /* 2402479 */   GIM_Reject,
     /* 2402480 */ // Label 34547: @2402480
     /* 2402480 */ GIM_Reject,
     /* 2402481 */ // Label 34283: @2402481
     /* 2402481 */ GIM_Reject,
     /* 2402482 */ // Label 103: @2402482
     /* 2402482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(32), /*)*//*default:*//*Label 34578*/ GIMT_Encode4(2404657),
     /* 2402493 */ /*GILLT_s16*//*Label 34560*/ GIMT_Encode4(2402613),
     /* 2402497 */ /*GILLT_s32*//*Label 34561*/ GIMT_Encode4(2402735),
     /* 2402501 */ /*GILLT_s64*//*Label 34562*/ GIMT_Encode4(2402857), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402513 */ /*GILLT_nxv1s16*//*Label 34563*/ GIMT_Encode4(2403007),
     /* 2402517 */ /*GILLT_nxv1s32*//*Label 34564*/ GIMT_Encode4(2403117),
     /* 2402521 */ /*GILLT_nxv1s64*//*Label 34565*/ GIMT_Encode4(2403227), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402533 */ /*GILLT_nxv2s16*//*Label 34566*/ GIMT_Encode4(2403337),
     /* 2402537 */ /*GILLT_nxv2s32*//*Label 34567*/ GIMT_Encode4(2403447),
     /* 2402541 */ /*GILLT_nxv2s64*//*Label 34568*/ GIMT_Encode4(2403557), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402553 */ /*GILLT_nxv4s16*//*Label 34569*/ GIMT_Encode4(2403667),
     /* 2402557 */ /*GILLT_nxv4s32*//*Label 34570*/ GIMT_Encode4(2403777),
     /* 2402561 */ /*GILLT_nxv4s64*//*Label 34571*/ GIMT_Encode4(2403887), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402573 */ /*GILLT_nxv8s16*//*Label 34572*/ GIMT_Encode4(2403997),
     /* 2402577 */ /*GILLT_nxv8s32*//*Label 34573*/ GIMT_Encode4(2404107),
     /* 2402581 */ /*GILLT_nxv8s64*//*Label 34574*/ GIMT_Encode4(2404217), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402593 */ /*GILLT_nxv16s16*//*Label 34575*/ GIMT_Encode4(2404327),
     /* 2402597 */ /*GILLT_nxv16s32*//*Label 34576*/ GIMT_Encode4(2404437), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2402609 */ /*GILLT_nxv32s16*//*Label 34577*/ GIMT_Encode4(2404547),
     /* 2402613 */ // Label 34560: @2402613
     /* 2402613 */ GIM_Try, /*On fail goto*//*Label 34579*/ GIMT_Encode4(2402734),
     /* 2402618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2402621 */   GIM_Try, /*On fail goto*//*Label 34580*/ GIMT_Encode4(2402649), // Rule ID 1878 //
     /* 2402626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2402629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402637 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2402637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2402640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402647 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402648 */     // GIR_Coverage, 1878,
     /* 2402648 */     GIR_EraseRootFromParent_Done,
     /* 2402649 */   // Label 34580: @2402649
     /* 2402649 */   GIM_Try, /*On fail goto*//*Label 34581*/ GIMT_Encode4(2402677), // Rule ID 1879 //
     /* 2402654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2402657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2402665 */     // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$rs1)  =>  (FSQRT_H:{ *:[f16] } FPR16:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2402665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H),
     /* 2402668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402670 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402675 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402676 */     // GIR_Coverage, 1879,
     /* 2402676 */     GIR_EraseRootFromParent_Done,
     /* 2402677 */   // Label 34581: @2402677
     /* 2402677 */   GIM_Try, /*On fail goto*//*Label 34582*/ GIMT_Encode4(2402705), // Rule ID 1911 //
     /* 2402682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2402685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402693 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i64] })
     /* 2402693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2402696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402698 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402703 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402704 */     // GIR_Coverage, 1911,
     /* 2402704 */     GIR_EraseRootFromParent_Done,
     /* 2402705 */   // Label 34582: @2402705
     /* 2402705 */   GIM_Try, /*On fail goto*//*Label 34583*/ GIMT_Encode4(2402733), // Rule ID 1912 //
     /* 2402710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2402713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2402721 */     // (strict_fsqrt:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FSQRT_H_INX:{ *:[f16] } FPR16INX:{ *:[f16] }:$rs1, 7:{ *:[i32] })
     /* 2402721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_H_INX),
     /* 2402724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402731 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402732 */     // GIR_Coverage, 1912,
     /* 2402732 */     GIR_EraseRootFromParent_Done,
     /* 2402733 */   // Label 34583: @2402733
     /* 2402733 */   GIM_Reject,
     /* 2402734 */ // Label 34579: @2402734
     /* 2402734 */ GIM_Reject,
     /* 2402735 */ // Label 34561: @2402735
     /* 2402735 */ GIM_Try, /*On fail goto*//*Label 34584*/ GIMT_Encode4(2402856),
     /* 2402740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2402743 */   GIM_Try, /*On fail goto*//*Label 34585*/ GIMT_Encode4(2402771), // Rule ID 1169 //
     /* 2402748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2402751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402759 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2402759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2402762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402764 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402769 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402770 */     // GIR_Coverage, 1169,
     /* 2402770 */     GIR_EraseRootFromParent_Done,
     /* 2402771 */   // Label 34585: @2402771
     /* 2402771 */   GIM_Try, /*On fail goto*//*Label 34586*/ GIMT_Encode4(2402799), // Rule ID 1170 //
     /* 2402776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2402779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2402787 */     // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$rs1)  =>  (FSQRT_S:{ *:[f32] } FPR32:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2402787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S),
     /* 2402790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402792 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402797 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402798 */     // GIR_Coverage, 1170,
     /* 2402798 */     GIR_EraseRootFromParent_Done,
     /* 2402799 */   // Label 34586: @2402799
     /* 2402799 */   GIM_Try, /*On fail goto*//*Label 34587*/ GIMT_Encode4(2402827), // Rule ID 1177 //
     /* 2402804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2402807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2402811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2402815 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i64] })
     /* 2402815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2402818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402820 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402825 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402826 */     // GIR_Coverage, 1177,
     /* 2402826 */     GIR_EraseRootFromParent_Done,
     /* 2402827 */   // Label 34587: @2402827
     /* 2402827 */   GIM_Try, /*On fail goto*//*Label 34588*/ GIMT_Encode4(2402855), // Rule ID 1178 //
     /* 2402832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2402835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2402839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2402843 */     // (strict_fsqrt:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FSQRT_S_INX:{ *:[f32] } FPR32INX:{ *:[f32] }:$rs1, 7:{ *:[i32] })
     /* 2402843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_S_INX),
     /* 2402846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402853 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402854 */     // GIR_Coverage, 1178,
     /* 2402854 */     GIR_EraseRootFromParent_Done,
     /* 2402855 */   // Label 34588: @2402855
     /* 2402855 */   GIM_Reject,
     /* 2402856 */ // Label 34584: @2402856
     /* 2402856 */ GIM_Reject,
     /* 2402857 */ // Label 34562: @2402857
     /* 2402857 */ GIM_Try, /*On fail goto*//*Label 34589*/ GIMT_Encode4(2403006),
     /* 2402862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2402865 */   GIM_Try, /*On fail goto*//*Label 34590*/ GIMT_Encode4(2402893), // Rule ID 1512 //
     /* 2402870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2402873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2402877 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2402881 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2402881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2402884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402891 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402892 */     // GIR_Coverage, 1512,
     /* 2402892 */     GIR_EraseRootFromParent_Done,
     /* 2402893 */   // Label 34590: @2402893
     /* 2402893 */   GIM_Try, /*On fail goto*//*Label 34591*/ GIMT_Encode4(2402921), // Rule ID 1513 //
     /* 2402898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2402901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2402905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2402909 */     // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$rs1)  =>  (FSQRT_D:{ *:[f64] } FPR64:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2402909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D),
     /* 2402912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402919 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402920 */     // GIR_Coverage, 1513,
     /* 2402920 */     GIR_EraseRootFromParent_Done,
     /* 2402921 */   // Label 34591: @2402921
     /* 2402921 */   GIM_Try, /*On fail goto*//*Label 34592*/ GIMT_Encode4(2402949), // Rule ID 1547 //
     /* 2402926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2402929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2402933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2402937 */     // (strict_fsqrt:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FSQRT_D_INX:{ *:[f64] } FPR64INX:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2402937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_INX),
     /* 2402940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402942 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402948 */     // GIR_Coverage, 1547,
     /* 2402948 */     GIR_EraseRootFromParent_Done,
     /* 2402949 */   // Label 34592: @2402949
     /* 2402949 */   GIM_Try, /*On fail goto*//*Label 34593*/ GIMT_Encode4(2402977), // Rule ID 1567 //
     /* 2402954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2402957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2402961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2402965 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i64] })
     /* 2402965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2402968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402970 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2402972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2402975 */     GIR_RootConstrainSelectedInstOperands,
     /* 2402976 */     // GIR_Coverage, 1567,
     /* 2402976 */     GIR_EraseRootFromParent_Done,
     /* 2402977 */   // Label 34593: @2402977
     /* 2402977 */   GIM_Try, /*On fail goto*//*Label 34594*/ GIMT_Encode4(2403005), // Rule ID 1568 //
     /* 2402982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2402985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2402989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2402993 */     // (strict_fsqrt:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FSQRT_D_IN32X:{ *:[f64] } FPR64IN32X:{ *:[f64] }:$rs1, 7:{ *:[i32] })
     /* 2402993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::FSQRT_D_IN32X),
     /* 2402996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2402998 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2403000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403003 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403004 */     // GIR_Coverage, 1568,
     /* 2403004 */     GIR_EraseRootFromParent_Done,
     /* 2403005 */   // Label 34594: @2403005
     /* 2403005 */   GIM_Reject,
     /* 2403006 */ // Label 34589: @2403006
     /* 2403006 */ GIM_Reject,
     /* 2403007 */ // Label 34563: @2403007
     /* 2403007 */ GIM_Try, /*On fail goto*//*Label 34595*/ GIMT_Encode4(2403116),
     /* 2403012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2403015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403023 */   GIM_Try, /*On fail goto*//*Label 34596*/ GIMT_Encode4(2403069), // Rule ID 56110 //
     /* 2403028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403031 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2403048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403067 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403068 */     // GIR_Coverage, 56110,
     /* 2403068 */     GIR_EraseRootFromParent_Done,
     /* 2403069 */   // Label 34596: @2403069
     /* 2403069 */   GIM_Try, /*On fail goto*//*Label 34597*/ GIMT_Encode4(2403115), // Rule ID 56111 //
     /* 2403074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403077 */     // (strict_fsqrt:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF4_E16:{ *:[nxv1f16] } (IMPLICIT_DEF:{ *:[nxv1f16] }), VR:{ *:[nxv1f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s16,
     /* 2403080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF4_E16),
     /* 2403094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403096 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403113 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403114 */     // GIR_Coverage, 56111,
     /* 2403114 */     GIR_EraseRootFromParent_Done,
     /* 2403115 */   // Label 34597: @2403115
     /* 2403115 */   GIM_Reject,
     /* 2403116 */ // Label 34595: @2403116
     /* 2403116 */ GIM_Reject,
     /* 2403117 */ // Label 34564: @2403117
     /* 2403117 */ GIM_Try, /*On fail goto*//*Label 34598*/ GIMT_Encode4(2403226),
     /* 2403122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2403125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403133 */   GIM_Try, /*On fail goto*//*Label 34599*/ GIMT_Encode4(2403179), // Rule ID 56150 //
     /* 2403138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403141 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2403158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403163 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403177 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403178 */     // GIR_Coverage, 56150,
     /* 2403178 */     GIR_EraseRootFromParent_Done,
     /* 2403179 */   // Label 34599: @2403179
     /* 2403179 */   GIM_Try, /*On fail goto*//*Label 34600*/ GIMT_Encode4(2403225), // Rule ID 56151 //
     /* 2403184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403187 */     // (strict_fsqrt:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E32:{ *:[nxv1f32] } (IMPLICIT_DEF:{ *:[nxv1f32] }), VR:{ *:[nxv1f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s32,
     /* 2403190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E32),
     /* 2403204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403209 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403224 */     // GIR_Coverage, 56151,
     /* 2403224 */     GIR_EraseRootFromParent_Done,
     /* 2403225 */   // Label 34600: @2403225
     /* 2403225 */   GIM_Reject,
     /* 2403226 */ // Label 34598: @2403226
     /* 2403226 */ GIM_Reject,
     /* 2403227 */ // Label 34565: @2403227
     /* 2403227 */ GIM_Try, /*On fail goto*//*Label 34601*/ GIMT_Encode4(2403336),
     /* 2403232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2403235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403239 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403243 */   GIM_Try, /*On fail goto*//*Label 34602*/ GIMT_Encode4(2403289), // Rule ID 56210 //
     /* 2403248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403251 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403263 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2403268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403273 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403287 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403288 */     // GIR_Coverage, 56210,
     /* 2403288 */     GIR_EraseRootFromParent_Done,
     /* 2403289 */   // Label 34602: @2403289
     /* 2403289 */   GIM_Try, /*On fail goto*//*Label 34603*/ GIMT_Encode4(2403335), // Rule ID 56211 //
     /* 2403294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403297 */     // (strict_fsqrt:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E64:{ *:[nxv1f64] } (IMPLICIT_DEF:{ *:[nxv1f64] }), VR:{ *:[nxv1f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s64,
     /* 2403300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E64),
     /* 2403314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403333 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403334 */     // GIR_Coverage, 56211,
     /* 2403334 */     GIR_EraseRootFromParent_Done,
     /* 2403335 */   // Label 34603: @2403335
     /* 2403335 */   GIM_Reject,
     /* 2403336 */ // Label 34601: @2403336
     /* 2403336 */ GIM_Reject,
     /* 2403337 */ // Label 34566: @2403337
     /* 2403337 */ GIM_Try, /*On fail goto*//*Label 34604*/ GIMT_Encode4(2403446),
     /* 2403342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2403345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403353 */   GIM_Try, /*On fail goto*//*Label 34605*/ GIMT_Encode4(2403399), // Rule ID 56130 //
     /* 2403358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403361 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2403378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403397 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403398 */     // GIR_Coverage, 56130,
     /* 2403398 */     GIR_EraseRootFromParent_Done,
     /* 2403399 */   // Label 34605: @2403399
     /* 2403399 */   GIM_Try, /*On fail goto*//*Label 34606*/ GIMT_Encode4(2403445), // Rule ID 56131 //
     /* 2403404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403407 */     // (strict_fsqrt:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rs2)  =>  (PseudoVFSQRT_V_MF2_E16:{ *:[nxv2f16] } (IMPLICIT_DEF:{ *:[nxv2f16] }), VR:{ *:[nxv2f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s16,
     /* 2403410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_MF2_E16),
     /* 2403424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403429 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403437 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403443 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403444 */     // GIR_Coverage, 56131,
     /* 2403444 */     GIR_EraseRootFromParent_Done,
     /* 2403445 */   // Label 34606: @2403445
     /* 2403445 */   GIM_Reject,
     /* 2403446 */ // Label 34604: @2403446
     /* 2403446 */ GIM_Reject,
     /* 2403447 */ // Label 34567: @2403447
     /* 2403447 */ GIM_Try, /*On fail goto*//*Label 34607*/ GIMT_Encode4(2403556),
     /* 2403452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2403455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403463 */   GIM_Try, /*On fail goto*//*Label 34608*/ GIMT_Encode4(2403509), // Rule ID 56190 //
     /* 2403468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403471 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2403488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403493 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403507 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403508 */     // GIR_Coverage, 56190,
     /* 2403508 */     GIR_EraseRootFromParent_Done,
     /* 2403509 */   // Label 34608: @2403509
     /* 2403509 */   GIM_Try, /*On fail goto*//*Label 34609*/ GIMT_Encode4(2403555), // Rule ID 56191 //
     /* 2403514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403517 */     // (strict_fsqrt:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E32:{ *:[nxv2f32] } (IMPLICIT_DEF:{ *:[nxv2f32] }), VR:{ *:[nxv2f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s32,
     /* 2403520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E32),
     /* 2403534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403539 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403553 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403554 */     // GIR_Coverage, 56191,
     /* 2403554 */     GIR_EraseRootFromParent_Done,
     /* 2403555 */   // Label 34609: @2403555
     /* 2403555 */   GIM_Reject,
     /* 2403556 */ // Label 34607: @2403556
     /* 2403556 */ GIM_Reject,
     /* 2403557 */ // Label 34568: @2403557
     /* 2403557 */ GIM_Try, /*On fail goto*//*Label 34610*/ GIMT_Encode4(2403666),
     /* 2403562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2403565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403573 */   GIM_Try, /*On fail goto*//*Label 34611*/ GIMT_Encode4(2403619), // Rule ID 56350 //
     /* 2403578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403581 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2403598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403600 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403603 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403617 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403618 */     // GIR_Coverage, 56350,
     /* 2403618 */     GIR_EraseRootFromParent_Done,
     /* 2403619 */   // Label 34611: @2403619
     /* 2403619 */   GIM_Try, /*On fail goto*//*Label 34612*/ GIMT_Encode4(2403665), // Rule ID 56351 //
     /* 2403624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403627 */     // (strict_fsqrt:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E64:{ *:[nxv2f64] } (IMPLICIT_DEF:{ *:[nxv2f64] }), VRM2:{ *:[nxv2f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv2s64,
     /* 2403630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E64),
     /* 2403644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403663 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403664 */     // GIR_Coverage, 56351,
     /* 2403664 */     GIR_EraseRootFromParent_Done,
     /* 2403665 */   // Label 34612: @2403665
     /* 2403665 */   GIM_Reject,
     /* 2403666 */ // Label 34610: @2403666
     /* 2403666 */ GIM_Reject,
     /* 2403667 */ // Label 34569: @2403667
     /* 2403667 */ GIM_Try, /*On fail goto*//*Label 34613*/ GIMT_Encode4(2403776),
     /* 2403672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2403675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2403683 */   GIM_Try, /*On fail goto*//*Label 34614*/ GIMT_Encode4(2403729), // Rule ID 56170 //
     /* 2403688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2403691 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403691 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2403694 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403698 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2403708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403727 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403728 */     // GIR_Coverage, 56170,
     /* 2403728 */     GIR_EraseRootFromParent_Done,
     /* 2403729 */   // Label 34614: @2403729
     /* 2403729 */   GIM_Try, /*On fail goto*//*Label 34615*/ GIMT_Encode4(2403775), // Rule ID 56171 //
     /* 2403734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2403737 */     // (strict_fsqrt:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rs2)  =>  (PseudoVFSQRT_V_M1_E16:{ *:[nxv4f16] } (IMPLICIT_DEF:{ *:[nxv4f16] }), VR:{ *:[nxv4f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403737 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s16,
     /* 2403740 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403744 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403749 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M1_E16),
     /* 2403754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403756 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403759 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2403770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403773 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403774 */     // GIR_Coverage, 56171,
     /* 2403774 */     GIR_EraseRootFromParent_Done,
     /* 2403775 */   // Label 34615: @2403775
     /* 2403775 */   GIM_Reject,
     /* 2403776 */ // Label 34613: @2403776
     /* 2403776 */ GIM_Reject,
     /* 2403777 */ // Label 34570: @2403777
     /* 2403777 */ GIM_Try, /*On fail goto*//*Label 34616*/ GIMT_Encode4(2403886),
     /* 2403782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2403785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2403793 */   GIM_Try, /*On fail goto*//*Label 34617*/ GIMT_Encode4(2403839), // Rule ID 56290 //
     /* 2403798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2403801 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2403804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2403818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403823 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403838 */     // GIR_Coverage, 56290,
     /* 2403838 */     GIR_EraseRootFromParent_Done,
     /* 2403839 */   // Label 34617: @2403839
     /* 2403839 */   GIM_Try, /*On fail goto*//*Label 34618*/ GIMT_Encode4(2403885), // Rule ID 56291 //
     /* 2403844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2403847 */     // (strict_fsqrt:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E32:{ *:[nxv4f32] } (IMPLICIT_DEF:{ *:[nxv4f32] }), VRM2:{ *:[nxv4f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s32,
     /* 2403850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E32),
     /* 2403864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403866 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403869 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2403880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403884 */     // GIR_Coverage, 56291,
     /* 2403884 */     GIR_EraseRootFromParent_Done,
     /* 2403885 */   // Label 34618: @2403885
     /* 2403885 */   GIM_Reject,
     /* 2403886 */ // Label 34616: @2403886
     /* 2403886 */ GIM_Reject,
     /* 2403887 */ // Label 34571: @2403887
     /* 2403887 */ GIM_Try, /*On fail goto*//*Label 34619*/ GIMT_Encode4(2403996),
     /* 2403892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2403895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2403903 */   GIM_Try, /*On fail goto*//*Label 34620*/ GIMT_Encode4(2403949), // Rule ID 56370 //
     /* 2403908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2403911 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2403911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2403914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2403928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403930 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403947 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403948 */     // GIR_Coverage, 56370,
     /* 2403948 */     GIR_EraseRootFromParent_Done,
     /* 2403949 */   // Label 34620: @2403949
     /* 2403949 */   GIM_Try, /*On fail goto*//*Label 34621*/ GIMT_Encode4(2403995), // Rule ID 56371 //
     /* 2403954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2403957 */     // (strict_fsqrt:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E64:{ *:[nxv4f64] } (IMPLICIT_DEF:{ *:[nxv4f64] }), VRM4:{ *:[nxv4f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2403957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv4s64,
     /* 2403960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2403964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2403969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2403971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E64),
     /* 2403974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2403976 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2403979 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2403981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2403984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2403987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2403990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2403993 */     GIR_RootConstrainSelectedInstOperands,
     /* 2403994 */     // GIR_Coverage, 56371,
     /* 2403994 */     GIR_EraseRootFromParent_Done,
     /* 2403995 */   // Label 34621: @2403995
     /* 2403995 */   GIM_Reject,
     /* 2403996 */ // Label 34619: @2403996
     /* 2403996 */ GIM_Reject,
     /* 2403997 */ // Label 34572: @2403997
     /* 2403997 */ GIM_Try, /*On fail goto*//*Label 34622*/ GIMT_Encode4(2404106),
     /* 2404002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2404005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2404013 */   GIM_Try, /*On fail goto*//*Label 34623*/ GIMT_Encode4(2404059), // Rule ID 56230 //
     /* 2404018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404021 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404021 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404024 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404028 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2404038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404043 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404057 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404058 */     // GIR_Coverage, 56230,
     /* 2404058 */     GIR_EraseRootFromParent_Done,
     /* 2404059 */   // Label 34623: @2404059
     /* 2404059 */   GIM_Try, /*On fail goto*//*Label 34624*/ GIMT_Encode4(2404105), // Rule ID 56231 //
     /* 2404064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404067 */     // (strict_fsqrt:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rs2)  =>  (PseudoVFSQRT_V_M2_E16:{ *:[nxv8f16] } (IMPLICIT_DEF:{ *:[nxv8f16] }), VRM2:{ *:[nxv8f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s16,
     /* 2404070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M2_E16),
     /* 2404084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404089 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404103 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404104 */     // GIR_Coverage, 56231,
     /* 2404104 */     GIR_EraseRootFromParent_Done,
     /* 2404105 */   // Label 34624: @2404105
     /* 2404105 */   GIM_Reject,
     /* 2404106 */ // Label 34622: @2404106
     /* 2404106 */ GIM_Reject,
     /* 2404107 */ // Label 34573: @2404107
     /* 2404107 */ GIM_Try, /*On fail goto*//*Label 34625*/ GIMT_Encode4(2404216),
     /* 2404112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2404115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404123 */   GIM_Try, /*On fail goto*//*Label 34626*/ GIMT_Encode4(2404169), // Rule ID 56310 //
     /* 2404128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404131 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404143 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2404148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404168 */     // GIR_Coverage, 56310,
     /* 2404168 */     GIR_EraseRootFromParent_Done,
     /* 2404169 */   // Label 34626: @2404169
     /* 2404169 */   GIM_Try, /*On fail goto*//*Label 34627*/ GIMT_Encode4(2404215), // Rule ID 56311 //
     /* 2404174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404177 */     // (strict_fsqrt:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E32:{ *:[nxv8f32] } (IMPLICIT_DEF:{ *:[nxv8f32] }), VRM4:{ *:[nxv8f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s32,
     /* 2404180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E32),
     /* 2404194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404213 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404214 */     // GIR_Coverage, 56311,
     /* 2404214 */     GIR_EraseRootFromParent_Done,
     /* 2404215 */   // Label 34627: @2404215
     /* 2404215 */   GIM_Reject,
     /* 2404216 */ // Label 34625: @2404216
     /* 2404216 */ GIM_Reject,
     /* 2404217 */ // Label 34574: @2404217
     /* 2404217 */ GIM_Try, /*On fail goto*//*Label 34628*/ GIMT_Encode4(2404326),
     /* 2404222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2404225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404233 */   GIM_Try, /*On fail goto*//*Label 34629*/ GIMT_Encode4(2404279), // Rule ID 56390 //
     /* 2404238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode0),
     /* 2404241 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 6:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2404258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404263 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404277 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404278 */     // GIR_Coverage, 56390,
     /* 2404278 */     GIR_EraseRootFromParent_Done,
     /* 2404279 */   // Label 34629: @2404279
     /* 2404279 */   GIM_Try, /*On fail goto*//*Label 34630*/ GIMT_Encode4(2404325), // Rule ID 56391 //
     /* 2404284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF64_HwMode1),
     /* 2404287 */     // (strict_fsqrt:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E64:{ *:[nxv8f64] } (IMPLICIT_DEF:{ *:[nxv8f64] }), VRM8:{ *:[nxv8f64] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 6:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv8s64,
     /* 2404290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E64),
     /* 2404304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404309 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404311 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2404320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404323 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404324 */     // GIR_Coverage, 56391,
     /* 2404324 */     GIR_EraseRootFromParent_Done,
     /* 2404325 */   // Label 34630: @2404325
     /* 2404325 */   GIM_Reject,
     /* 2404326 */ // Label 34628: @2404326
     /* 2404326 */ GIM_Reject,
     /* 2404327 */ // Label 34575: @2404327
     /* 2404327 */ GIM_Try, /*On fail goto*//*Label 34631*/ GIMT_Encode4(2404436),
     /* 2404332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2404335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2404343 */   GIM_Try, /*On fail goto*//*Label 34632*/ GIMT_Encode4(2404389), // Rule ID 56250 //
     /* 2404348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404351 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2404368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404373 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404388 */     // GIR_Coverage, 56250,
     /* 2404388 */     GIR_EraseRootFromParent_Done,
     /* 2404389 */   // Label 34632: @2404389
     /* 2404389 */   GIM_Try, /*On fail goto*//*Label 34633*/ GIMT_Encode4(2404435), // Rule ID 56251 //
     /* 2404394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404397 */     // (strict_fsqrt:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rs2)  =>  (PseudoVFSQRT_V_M4_E16:{ *:[nxv16f16] } (IMPLICIT_DEF:{ *:[nxv16f16] }), VRM4:{ *:[nxv16f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s16,
     /* 2404400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404409 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M4_E16),
     /* 2404414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404419 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404433 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404434 */     // GIR_Coverage, 56251,
     /* 2404434 */     GIR_EraseRootFromParent_Done,
     /* 2404435 */   // Label 34633: @2404435
     /* 2404435 */   GIM_Reject,
     /* 2404436 */ // Label 34631: @2404436
     /* 2404436 */ GIM_Reject,
     /* 2404437 */ // Label 34576: @2404437
     /* 2404437 */ GIM_Try, /*On fail goto*//*Label 34634*/ GIMT_Encode4(2404546),
     /* 2404442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2404445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404453 */   GIM_Try, /*On fail goto*//*Label 34635*/ GIMT_Encode4(2404499), // Rule ID 56330 //
     /* 2404458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode0),
     /* 2404461 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 5:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404461 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404464 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404468 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2404478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404483 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404497 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404498 */     // GIR_Coverage, 56330,
     /* 2404498 */     GIR_EraseRootFromParent_Done,
     /* 2404499 */   // Label 34635: @2404499
     /* 2404499 */   GIM_Try, /*On fail goto*//*Label 34636*/ GIMT_Encode4(2404545), // Rule ID 56331 //
     /* 2404504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsAnyF_HwMode1),
     /* 2404507 */     // (strict_fsqrt:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E32:{ *:[nxv16f32] } (IMPLICIT_DEF:{ *:[nxv16f32] }), VRM8:{ *:[nxv16f32] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 5:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s32,
     /* 2404510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E32),
     /* 2404524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404529 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2404540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404544 */     // GIR_Coverage, 56331,
     /* 2404544 */     GIR_EraseRootFromParent_Done,
     /* 2404545 */   // Label 34636: @2404545
     /* 2404545 */   GIM_Reject,
     /* 2404546 */ // Label 34634: @2404546
     /* 2404546 */ GIM_Reject,
     /* 2404547 */ // Label 34577: @2404547
     /* 2404547 */ GIM_Try, /*On fail goto*//*Label 34637*/ GIMT_Encode4(2404656),
     /* 2404552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2404555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2404563 */   GIM_Try, /*On fail goto*//*Label 34638*/ GIMT_Encode4(2404609), // Rule ID 56270 //
     /* 2404568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode0),
     /* 2404571 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i64] }, -1:{ *:[i64] }, 4:{ *:[i64] }, 3:{ *:[i64] })
     /* 2404571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2404574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2404588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404608 */     // GIR_Coverage, 56270,
     /* 2404608 */     GIR_EraseRootFromParent_Done,
     /* 2404609 */   // Label 34638: @2404609
     /* 2404609 */   GIM_Try, /*On fail goto*//*Label 34639*/ GIMT_Encode4(2404655), // Rule ID 56271 //
     /* 2404614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsF16_HwMode1),
     /* 2404617 */     // (strict_fsqrt:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rs2)  =>  (PseudoVFSQRT_V_M8_E16:{ *:[nxv32f16] } (IMPLICIT_DEF:{ *:[nxv32f16] }), VRM8:{ *:[nxv32f16] }:$rs2, 7:{ *:[i32] }, -1:{ *:[i32] }, 4:{ *:[i32] }, 3:{ *:[i32] })
     /* 2404617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv32s16,
     /* 2404620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 2404624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVFSQRT_V_M8_E16),
     /* 2404634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404639 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs2
     /* 2404641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 2404644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/uint8_t(-1),
     /* 2404647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2404650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2404653 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404654 */     // GIR_Coverage, 56271,
     /* 2404654 */     GIR_EraseRootFromParent_Done,
     /* 2404655 */   // Label 34639: @2404655
     /* 2404655 */   GIM_Reject,
     /* 2404656 */ // Label 34637: @2404656
     /* 2404656 */ GIM_Reject,
     /* 2404657 */ // Label 34578: @2404657
     /* 2404657 */ GIM_Reject,
     /* 2404658 */ // Label 104: @2404658
     /* 2404658 */ GIM_Try, /*On fail goto*//*Label 34640*/ GIMT_Encode4(2404670), // Rule ID 283 //
     /* 2404663 */   // (trap)  =>  (UNIMP)
     /* 2404663 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::UNIMP),
     /* 2404668 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404669 */   // GIR_Coverage, 283,
     /* 2404669 */   GIR_Done,
     /* 2404670 */ // Label 34640: @2404670
     /* 2404670 */ GIM_Reject,
     /* 2404671 */ // Label 105: @2404671
     /* 2404671 */ GIM_Try, /*On fail goto*//*Label 34641*/ GIMT_Encode4(2404683), // Rule ID 284 //
     /* 2404676 */   // (debugtrap)  =>  (EBREAK)
     /* 2404676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::EBREAK),
     /* 2404681 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404682 */   // GIR_Coverage, 284,
     /* 2404682 */   GIR_Done,
     /* 2404683 */ // Label 34641: @2404683
     /* 2404683 */ GIM_Reject,
     /* 2404684 */ // Label 106: @2404684
     /* 2404684 */ GIM_Try, /*On fail goto*//*Label 34642*/ GIMT_Encode4(2404778),
     /* 2404689 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2404692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404699 */   GIM_Try, /*On fail goto*//*Label 34643*/ GIMT_Encode4(2404718), // Rule ID 2410 //
     /* 2404704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2404707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404711 */     // (riscv_clzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CLZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2404711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CLZW),
     /* 2404716 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404717 */     // GIR_Coverage, 2410,
     /* 2404717 */     GIR_Done,
     /* 2404718 */   // Label 34643: @2404718
     /* 2404718 */   GIM_Try, /*On fail goto*//*Label 34644*/ GIMT_Encode4(2404777), // Rule ID 62544 //
     /* 2404723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2404726 */     // (riscv_clzw:{ *:[i64] } i64:{ *:[i64] }:$rs1)  =>  (TH_FF0:{ *:[i64] } (SLLI:{ *:[i64] } (XORI:{ *:[i64] } i64:{ *:[i64] }:$rs1, -1:{ *:[i64] }), 32:{ *:[i64] }))
     /* 2404726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 2404729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(RISCV::XORI),
     /* 2404733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404738 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // rs1
     /* 2404742 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/uint8_t(-1),
     /* 2404745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 2404747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 2404750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(RISCV::SLLI),
     /* 2404754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 2404759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 2404762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 2404765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 2404767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_FF0),
     /* 2404770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2404772 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 2404775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2404776 */     // GIR_Coverage, 62544,
     /* 2404776 */     GIR_EraseRootFromParent_Done,
     /* 2404777 */   // Label 34644: @2404777
     /* 2404777 */   GIM_Reject,
     /* 2404778 */ // Label 34642: @2404778
     /* 2404778 */ GIM_Reject,
     /* 2404779 */ // Label 107: @2404779
     /* 2404779 */ GIM_Try, /*On fail goto*//*Label 34645*/ GIMT_Encode4(2404808), // Rule ID 2411 //
     /* 2404784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbb_IsRV64_HwMode0),
     /* 2404787 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2404790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404801 */   // (riscv_ctzw:{ *:[i64] } GPR:{ *:[i64] }:$rs1)  =>  (CTZW:{ *:[i64] } GPR:{ *:[i64] }:$rs1)
     /* 2404801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::CTZW),
     /* 2404806 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404807 */   // GIR_Coverage, 2411,
     /* 2404807 */   GIR_Done,
     /* 2404808 */ // Label 34645: @2404808
     /* 2404808 */ GIM_Reject,
     /* 2404809 */ // Label 108: @2404809
     /* 2404809 */ GIM_Try, /*On fail goto*//*Label 34646*/ GIMT_Encode4(2404845), // Rule ID 307 //
     /* 2404814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2404817 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2404820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2404826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404838 */   // (riscv_divuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2404838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVUW),
     /* 2404843 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404844 */   // GIR_Coverage, 307,
     /* 2404844 */   GIR_Done,
     /* 2404845 */ // Label 34646: @2404845
     /* 2404845 */ GIM_Reject,
     /* 2404846 */ // Label 109: @2404846
     /* 2404846 */ GIM_Try, /*On fail goto*//*Label 34647*/ GIMT_Encode4(2404882), // Rule ID 306 //
     /* 2404851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2404854 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2404857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2404863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404871 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404875 */   // (riscv_divw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (DIVW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2404875 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::DIVW),
     /* 2404880 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404881 */   // GIR_Coverage, 306,
     /* 2404881 */   GIR_Done,
     /* 2404882 */ // Label 34647: @2404882
     /* 2404882 */ GIM_Reject,
     /* 2404883 */ // Label 110: @2404883
     /* 2404883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34650*/ GIMT_Encode4(2405242),
     /* 2404894 */ /*GILLT_s32*//*Label 34648*/ GIMT_Encode4(2404902),
     /* 2404898 */ /*GILLT_s64*//*Label 34649*/ GIMT_Encode4(2405059),
     /* 2404902 */ // Label 34648: @2404902
     /* 2404902 */ GIM_Try, /*On fail goto*//*Label 34651*/ GIMT_Encode4(2404928), // Rule ID 1176 //
     /* 2404907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode1),
     /* 2404910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2404921 */   // (riscv_fclass:{ *:[i32] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2404921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2404926 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404927 */   // GIR_Coverage, 1176,
     /* 2404927 */   GIR_Done,
     /* 2404928 */ // Label 34651: @2404928
     /* 2404928 */ GIM_Try, /*On fail goto*//*Label 34652*/ GIMT_Encode4(2404954), // Rule ID 1184 //
     /* 2404933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode1),
     /* 2404936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2404939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2404947 */   // (riscv_fclass:{ *:[i32] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i32] } ?:{ *:[f32] }:$rs1)
     /* 2404947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2404952 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404953 */   // GIR_Coverage, 1184,
     /* 2404953 */   GIR_Done,
     /* 2404954 */ // Label 34652: @2404954
     /* 2404954 */ GIM_Try, /*On fail goto*//*Label 34653*/ GIMT_Encode4(2404980), // Rule ID 1519 //
     /* 2404959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode1),
     /* 2404962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2404973 */   // (riscv_fclass:{ *:[i32] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2404973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2404978 */   GIR_RootConstrainSelectedInstOperands,
     /* 2404979 */   // GIR_Coverage, 1519,
     /* 2404979 */   GIR_Done,
     /* 2404980 */ // Label 34653: @2404980
     /* 2404980 */ GIM_Try, /*On fail goto*//*Label 34654*/ GIMT_Encode4(2405006), // Rule ID 1574 //
     /* 2404985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode1),
     /* 2404988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2404991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2404995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2404999 */   // (riscv_fclass:{ *:[i32] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i32] } ?:{ *:[f64] }:$rs1)
     /* 2404999 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2405004 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405005 */   // GIR_Coverage, 1574,
     /* 2405005 */   GIR_Done,
     /* 2405006 */ // Label 34654: @2405006
     /* 2405006 */ GIM_Try, /*On fail goto*//*Label 34655*/ GIMT_Encode4(2405032), // Rule ID 1885 //
     /* 2405011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode1),
     /* 2405014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405025 */   // (riscv_fclass:{ *:[i32] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2405025 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2405030 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405031 */   // GIR_Coverage, 1885,
     /* 2405031 */   GIR_Done,
     /* 2405032 */ // Label 34655: @2405032
     /* 2405032 */ GIM_Try, /*On fail goto*//*Label 34656*/ GIMT_Encode4(2405058), // Rule ID 1918 //
     /* 2405037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode1),
     /* 2405040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405051 */   // (riscv_fclass:{ *:[i32] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i32] } ?:{ *:[f16] }:$rs1)
     /* 2405051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2405056 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405057 */   // GIR_Coverage, 1918,
     /* 2405057 */   GIR_Done,
     /* 2405058 */ // Label 34656: @2405058
     /* 2405058 */ GIM_Reject,
     /* 2405059 */ // Label 34649: @2405059
     /* 2405059 */ GIM_Try, /*On fail goto*//*Label 34657*/ GIMT_Encode4(2405085), // Rule ID 1175 //
     /* 2405064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_HwMode0),
     /* 2405067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405078 */   // (riscv_fclass:{ *:[i64] } FPR32:{ *:[f32] }:$rs1)  =>  (FCLASS_S:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2405078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S),
     /* 2405083 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405084 */   // GIR_Coverage, 1175,
     /* 2405084 */   GIR_Done,
     /* 2405085 */ // Label 34657: @2405085
     /* 2405085 */ GIM_Try, /*On fail goto*//*Label 34658*/ GIMT_Encode4(2405111), // Rule ID 1183 //
     /* 2405090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_HwMode0),
     /* 2405093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2405096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405104 */   // (riscv_fclass:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1)  =>  (FCLASS_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1)
     /* 2405104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_S_INX),
     /* 2405109 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405110 */   // GIR_Coverage, 1183,
     /* 2405110 */   GIR_Done,
     /* 2405111 */ // Label 34658: @2405111
     /* 2405111 */ GIM_Try, /*On fail goto*//*Label 34659*/ GIMT_Encode4(2405137), // Rule ID 1518 //
     /* 2405116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_HwMode0),
     /* 2405119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405130 */   // (riscv_fclass:{ *:[i64] } FPR64:{ *:[f64] }:$rs1)  =>  (FCLASS_D:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2405130 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D),
     /* 2405135 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405136 */   // GIR_Coverage, 1518,
     /* 2405136 */   GIR_Done,
     /* 2405137 */ // Label 34659: @2405137
     /* 2405137 */ GIM_Try, /*On fail goto*//*Label 34660*/ GIMT_Encode4(2405163), // Rule ID 1551 //
     /* 2405142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405156 */   // (riscv_fclass:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1)  =>  (FCLASS_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2405156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_INX),
     /* 2405161 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405162 */   // GIR_Coverage, 1551,
     /* 2405162 */   GIR_Done,
     /* 2405163 */ // Label 34660: @2405163
     /* 2405163 */ GIM_Try, /*On fail goto*//*Label 34661*/ GIMT_Encode4(2405189), // Rule ID 1573 //
     /* 2405168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV32_HwMode0),
     /* 2405171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405174 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405178 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRPairRegClassID),
     /* 2405182 */   // (riscv_fclass:{ *:[i64] } FPR64IN32X:{ *:[f64] }:$rs1)  =>  (FCLASS_D_IN32X:{ *:[i64] } ?:{ *:[f64] }:$rs1)
     /* 2405182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_D_IN32X),
     /* 2405187 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405188 */   // GIR_Coverage, 1573,
     /* 2405188 */   GIR_Done,
     /* 2405189 */ // Label 34661: @2405189
     /* 2405189 */ GIM_Try, /*On fail goto*//*Label 34662*/ GIMT_Encode4(2405215), // Rule ID 1884 //
     /* 2405194 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_HwMode0),
     /* 2405197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405208 */   // (riscv_fclass:{ *:[i64] } FPR16:{ *:[f16] }:$rs1)  =>  (FCLASS_H:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2405208 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H),
     /* 2405213 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405214 */   // GIR_Coverage, 1884,
     /* 2405214 */   GIR_Done,
     /* 2405215 */ // Label 34662: @2405215
     /* 2405215 */ GIM_Try, /*On fail goto*//*Label 34663*/ GIMT_Encode4(2405241), // Rule ID 1917 //
     /* 2405220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_HwMode0),
     /* 2405223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 2405226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405234 */   // (riscv_fclass:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1)  =>  (FCLASS_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1)
     /* 2405234 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCLASS_H_INX),
     /* 2405239 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405240 */   // GIR_Coverage, 1917,
     /* 2405240 */   GIR_Done,
     /* 2405241 */ // Label 34663: @2405241
     /* 2405241 */ GIM_Reject,
     /* 2405242 */ // Label 34650: @2405242
     /* 2405242 */ GIM_Reject,
     /* 2405243 */ // Label 111: @2405243
     /* 2405243 */ GIM_Try, /*On fail goto*//*Label 34664*/ GIMT_Encode4(2405440),
     /* 2405248 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405251 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34668*/ GIMT_Encode4(2405439),
     /* 2405262 */   /*GILLT_s16*//*Label 34665*/ GIMT_Encode4(2405274),
     /* 2405266 */   /*GILLT_s32*//*Label 34666*/ GIMT_Encode4(2405329),
     /* 2405270 */   /*GILLT_s64*//*Label 34667*/ GIMT_Encode4(2405384),
     /* 2405274 */   // Label 34665: @2405274
     /* 2405274 */   GIM_Try, /*On fail goto*//*Label 34669*/ GIMT_Encode4(2405328),
     /* 2405279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405283 */     GIM_Try, /*On fail goto*//*Label 34670*/ GIMT_Encode4(2405305), // Rule ID 2135 //
     /* 2405288 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2405291 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405295 */       // MIs[0] frm
     /* 2405295 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405298 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405298 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H),
     /* 2405303 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405304 */       // GIR_Coverage, 2135,
     /* 2405304 */       GIR_Done,
     /* 2405305 */     // Label 34670: @2405305
     /* 2405305 */     GIM_Try, /*On fail goto*//*Label 34671*/ GIMT_Encode4(2405327), // Rule ID 2161 //
     /* 2405310 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2405313 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405317 */       // MIs[0] frm
     /* 2405317 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405320 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405320 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_H_INX),
     /* 2405325 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405326 */       // GIR_Coverage, 2161,
     /* 2405326 */       GIR_Done,
     /* 2405327 */     // Label 34671: @2405327
     /* 2405327 */     GIM_Reject,
     /* 2405328 */   // Label 34669: @2405328
     /* 2405328 */   GIM_Reject,
     /* 2405329 */   // Label 34666: @2405329
     /* 2405329 */   GIM_Try, /*On fail goto*//*Label 34672*/ GIMT_Encode4(2405383),
     /* 2405334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405338 */     GIM_Try, /*On fail goto*//*Label 34673*/ GIMT_Encode4(2405360), // Rule ID 1401 //
     /* 2405343 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2405346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405350 */       // MIs[0] frm
     /* 2405350 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405353 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405353 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S),
     /* 2405358 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405359 */       // GIR_Coverage, 1401,
     /* 2405359 */       GIR_Done,
     /* 2405360 */     // Label 34673: @2405360
     /* 2405360 */     GIM_Try, /*On fail goto*//*Label 34674*/ GIMT_Encode4(2405382), // Rule ID 1429 //
     /* 2405365 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2405368 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405372 */       // MIs[0] frm
     /* 2405372 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405375 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405375 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_S_INX),
     /* 2405380 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405381 */       // GIR_Coverage, 1429,
     /* 2405381 */       GIR_Done,
     /* 2405382 */     // Label 34674: @2405382
     /* 2405382 */     GIM_Reject,
     /* 2405383 */   // Label 34672: @2405383
     /* 2405383 */   GIM_Reject,
     /* 2405384 */   // Label 34667: @2405384
     /* 2405384 */   GIM_Try, /*On fail goto*//*Label 34675*/ GIMT_Encode4(2405438),
     /* 2405389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405393 */     GIM_Try, /*On fail goto*//*Label 34676*/ GIMT_Encode4(2405415), // Rule ID 1795 //
     /* 2405398 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2405401 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405405 */       // MIs[0] frm
     /* 2405405 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405408 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405408 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D),
     /* 2405413 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405414 */       // GIR_Coverage, 1795,
     /* 2405414 */       GIR_Done,
     /* 2405415 */     // Label 34676: @2405415
     /* 2405415 */     GIM_Try, /*On fail goto*//*Label 34677*/ GIMT_Encode4(2405437), // Rule ID 1823 //
     /* 2405420 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405423 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405427 */       // MIs[0] frm
     /* 2405427 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405430 */       // (riscv_fcvt_wu_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_WU_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405430 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_WU_D_INX),
     /* 2405435 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405436 */       // GIR_Coverage, 1823,
     /* 2405436 */       GIR_Done,
     /* 2405437 */     // Label 34677: @2405437
     /* 2405437 */     GIM_Reject,
     /* 2405438 */   // Label 34675: @2405438
     /* 2405438 */   GIM_Reject,
     /* 2405439 */   // Label 34668: @2405439
     /* 2405439 */   GIM_Reject,
     /* 2405440 */ // Label 34664: @2405440
     /* 2405440 */ GIM_Reject,
     /* 2405441 */ // Label 112: @2405441
     /* 2405441 */ GIM_Try, /*On fail goto*//*Label 34678*/ GIMT_Encode4(2405638),
     /* 2405446 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405449 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(2), GIMT_Encode2(5), /*)*//*default:*//*Label 34682*/ GIMT_Encode4(2405637),
     /* 2405460 */   /*GILLT_s16*//*Label 34679*/ GIMT_Encode4(2405472),
     /* 2405464 */   /*GILLT_s32*//*Label 34680*/ GIMT_Encode4(2405527),
     /* 2405468 */   /*GILLT_s64*//*Label 34681*/ GIMT_Encode4(2405582),
     /* 2405472 */   // Label 34679: @2405472
     /* 2405472 */   GIM_Try, /*On fail goto*//*Label 34683*/ GIMT_Encode4(2405526),
     /* 2405477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405481 */     GIM_Try, /*On fail goto*//*Label 34684*/ GIMT_Encode4(2405503), // Rule ID 2133 //
     /* 2405486 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfh_IsRV64_HwMode0),
     /* 2405489 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR16RegClassID),
     /* 2405493 */       // MIs[0] frm
     /* 2405493 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405496 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405496 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H),
     /* 2405501 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405502 */       // GIR_Coverage, 2133,
     /* 2405502 */       GIR_Done,
     /* 2405503 */     // Label 34684: @2405503
     /* 2405503 */     GIM_Try, /*On fail goto*//*Label 34685*/ GIMT_Encode4(2405525), // Rule ID 2159 //
     /* 2405508 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZhinx_IsRV64_HwMode0),
     /* 2405511 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF16RegClassID),
     /* 2405515 */       // MIs[0] frm
     /* 2405515 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405518 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR16INX:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_H_INX:{ *:[i64] } ?:{ *:[f16] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405518 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_H_INX),
     /* 2405523 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405524 */       // GIR_Coverage, 2159,
     /* 2405524 */       GIR_Done,
     /* 2405525 */     // Label 34685: @2405525
     /* 2405525 */     GIM_Reject,
     /* 2405526 */   // Label 34683: @2405526
     /* 2405526 */   GIM_Reject,
     /* 2405527 */   // Label 34680: @2405527
     /* 2405527 */   GIM_Try, /*On fail goto*//*Label 34686*/ GIMT_Encode4(2405581),
     /* 2405532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405536 */     GIM_Try, /*On fail goto*//*Label 34687*/ GIMT_Encode4(2405558), // Rule ID 1399 //
     /* 2405541 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtF_IsRV64_HwMode0),
     /* 2405544 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR32RegClassID),
     /* 2405548 */       // MIs[0] frm
     /* 2405548 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405551 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405551 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S),
     /* 2405556 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405557 */       // GIR_Coverage, 1399,
     /* 2405557 */       GIR_Done,
     /* 2405558 */     // Label 34687: @2405558
     /* 2405558 */     GIM_Try, /*On fail goto*//*Label 34688*/ GIMT_Encode4(2405580), // Rule ID 1427 //
     /* 2405563 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZfinx_IsRV64_HwMode0),
     /* 2405566 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRF32RegClassID),
     /* 2405570 */       // MIs[0] frm
     /* 2405570 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405573 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR32INX:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_S_INX:{ *:[i64] } ?:{ *:[f32] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405573 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_S_INX),
     /* 2405578 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405579 */       // GIR_Coverage, 1427,
     /* 2405579 */       GIR_Done,
     /* 2405580 */     // Label 34688: @2405580
     /* 2405580 */     GIM_Reject,
     /* 2405581 */   // Label 34686: @2405581
     /* 2405581 */   GIM_Reject,
     /* 2405582 */   // Label 34681: @2405582
     /* 2405582 */   GIM_Try, /*On fail goto*//*Label 34689*/ GIMT_Encode4(2405636),
     /* 2405587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405591 */     GIM_Try, /*On fail goto*//*Label 34690*/ GIMT_Encode4(2405613), // Rule ID 1793 //
     /* 2405596 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtD_IsRV64_HwMode0),
     /* 2405599 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::FPR64RegClassID),
     /* 2405603 */       // MIs[0] frm
     /* 2405603 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405606 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405606 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D),
     /* 2405611 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405612 */       // GIR_Coverage, 1793,
     /* 2405612 */       GIR_Done,
     /* 2405613 */     // Label 34690: @2405613
     /* 2405613 */     GIM_Try, /*On fail goto*//*Label 34691*/ GIMT_Encode4(2405635), // Rule ID 1821 //
     /* 2405618 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZdinx_IsRV64_HwMode0),
     /* 2405621 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405625 */       // MIs[0] frm
     /* 2405625 */       GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 2405628 */       // (riscv_fcvt_w_rv64:{ *:[i64] } FPR64INX:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)  =>  (FCVT_W_D_INX:{ *:[i64] } ?:{ *:[f64] }:$rs1, (timm:{ *:[i64] }):$frm)
     /* 2405628 */       GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::FCVT_W_D_INX),
     /* 2405633 */       GIR_RootConstrainSelectedInstOperands,
     /* 2405634 */       // GIR_Coverage, 1821,
     /* 2405634 */       GIR_Done,
     /* 2405635 */     // Label 34691: @2405635
     /* 2405635 */     GIM_Reject,
     /* 2405636 */   // Label 34689: @2405636
     /* 2405636 */   GIM_Reject,
     /* 2405637 */   // Label 34682: @2405637
     /* 2405637 */   GIM_Reject,
     /* 2405638 */ // Label 34678: @2405638
     /* 2405638 */ GIM_Reject,
     /* 2405639 */ // Label 113: @2405639
     /* 2405639 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(5), /*)*//*default:*//*Label 34694*/ GIMT_Encode4(2405698),
     /* 2405650 */ /*GILLT_s32*//*Label 34692*/ GIMT_Encode4(2405658),
     /* 2405654 */ /*GILLT_s64*//*Label 34693*/ GIMT_Encode4(2405678),
     /* 2405658 */ // Label 34692: @2405658
     /* 2405658 */ GIM_Try, /*On fail goto*//*Label 34695*/ GIMT_Encode4(2405677), // Rule ID 67 //
     /* 2405663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2405666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405670 */   // (riscv_read_vlenb:{ *:[i32] })  =>  (PseudoReadVLENB:{ *:[i32] })
     /* 2405670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2405675 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405676 */   // GIR_Coverage, 67,
     /* 2405676 */   GIR_Done,
     /* 2405677 */ // Label 34695: @2405677
     /* 2405677 */ GIM_Reject,
     /* 2405678 */ // Label 34693: @2405678
     /* 2405678 */ GIM_Try, /*On fail goto*//*Label 34696*/ GIMT_Encode4(2405697), // Rule ID 66 //
     /* 2405683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2405686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405690 */   // (riscv_read_vlenb:{ *:[i64] })  =>  (PseudoReadVLENB:{ *:[i64] })
     /* 2405690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::PseudoReadVLENB),
     /* 2405695 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405696 */   // GIR_Coverage, 66,
     /* 2405696 */   GIR_Done,
     /* 2405697 */ // Label 34696: @2405697
     /* 2405697 */ GIM_Reject,
     /* 2405698 */ // Label 34694: @2405698
     /* 2405698 */ GIM_Reject,
     /* 2405699 */ // Label 114: @2405699
     /* 2405699 */ GIM_Try, /*On fail goto*//*Label 34697*/ GIMT_Encode4(2405735), // Rule ID 308 //
     /* 2405704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtM_IsRV64_HwMode0),
     /* 2405707 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405728 */   // (riscv_remuw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)  =>  (REMUW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2405728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(RISCV::REMUW),
     /* 2405733 */   GIR_RootConstrainSelectedInstOperands,
     /* 2405734 */   // GIR_Coverage, 308,
     /* 2405734 */   GIR_Done,
     /* 2405735 */ // Label 34697: @2405735
     /* 2405735 */ GIM_Reject,
     /* 2405736 */ // Label 115: @2405736
     /* 2405736 */ GIM_Try, /*On fail goto*//*Label 34698*/ GIMT_Encode4(2405860),
     /* 2405741 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405747 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405758 */   GIM_Try, /*On fail goto*//*Label 34699*/ GIMT_Encode4(2405794), // Rule ID 2359 //
     /* 2405763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2405766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2405774 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2405778 */     // MIs[1] Operand 1
     /* 2405778 */     // No operand predicates
     /* 2405778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405780 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2405780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2405783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405785 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405787 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2405792 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405793 */     // GIR_Coverage, 2359,
     /* 2405793 */     GIR_EraseRootFromParent_Done,
     /* 2405794 */   // Label 34699: @2405794
     /* 2405794 */   GIM_Try, /*On fail goto*//*Label 34700*/ GIMT_Encode4(2405830), // Rule ID 62541 //
     /* 2405799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2405802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2405810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2405814 */     // MIs[1] Operand 1
     /* 2405814 */     // No operand predicates
     /* 2405814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405816 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (ImmSubFrom32:{ *:[i64] } (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2))
     /* 2405816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2405819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405821 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405823 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderImmSubFrom32), // rs2
     /* 2405828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405829 */     // GIR_Coverage, 62541,
     /* 2405829 */     GIR_EraseRootFromParent_Done,
     /* 2405830 */   // Label 34700: @2405830
     /* 2405830 */   GIM_Try, /*On fail goto*//*Label 34701*/ GIMT_Encode4(2405859), // Rule ID 2356 //
     /* 2405835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2405838 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2405845 */     // (riscv_rolw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (ROLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2405845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::ROLW),
     /* 2405848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405850 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2405857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405858 */     // GIR_Coverage, 2356,
     /* 2405858 */     GIR_EraseRootFromParent_Done,
     /* 2405859 */   // Label 34701: @2405859
     /* 2405859 */   GIM_Reject,
     /* 2405860 */ // Label 34698: @2405860
     /* 2405860 */ GIM_Reject,
     /* 2405861 */ // Label 116: @2405861
     /* 2405861 */ GIM_Try, /*On fail goto*//*Label 34702*/ GIMT_Encode4(2405981),
     /* 2405866 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2405883 */   GIM_Try, /*On fail goto*//*Label 34703*/ GIMT_Encode4(2405917), // Rule ID 2358 //
     /* 2405888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2405891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2405899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2405903 */     // MIs[1] Operand 1
     /* 2405903 */     // No operand predicates
     /* 2405903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405905 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (RORIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2405905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORIW),
     /* 2405908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2405915 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405916 */     // GIR_Coverage, 2358,
     /* 2405916 */     GIR_EraseRootFromParent_Done,
     /* 2405917 */   // Label 34703: @2405917
     /* 2405917 */   GIM_Try, /*On fail goto*//*Label 34704*/ GIMT_Encode4(2405951), // Rule ID 62540 //
     /* 2405922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVendorXTHeadBb_IsRV64_HwMode0),
     /* 2405925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 2405929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2405933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2405937 */     // MIs[1] Operand 1
     /* 2405937 */     // No operand predicates
     /* 2405937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2405939 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)  =>  (TH_SRRIW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$imm)
     /* 2405939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::TH_SRRIW),
     /* 2405942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405944 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 2405949 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405950 */     // GIR_Coverage, 62540,
     /* 2405950 */     GIR_EraseRootFromParent_Done,
     /* 2405951 */   // Label 34704: @2405951
     /* 2405951 */   GIM_Try, /*On fail goto*//*Label 34705*/ GIMT_Encode4(2405980), // Rule ID 2357 //
     /* 2405956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasStdExtZbbOrZbkb_IsRV64_HwMode0),
     /* 2405959 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2405966 */     // (riscv_rorw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (RORW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2405966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::RORW),
     /* 2405969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2405971 */     GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2405973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2405978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2405979 */     // GIR_Coverage, 2357,
     /* 2405979 */     GIR_EraseRootFromParent_Done,
     /* 2405980 */   // Label 34705: @2405980
     /* 2405980 */   GIM_Reject,
     /* 2405981 */ // Label 34702: @2405981
     /* 2405981 */ GIM_Reject,
     /* 2405982 */ // Label 117: @2405982
     /* 2405982 */ GIM_Try, /*On fail goto*//*Label 34706*/ GIMT_Encode4(2406028), // Rule ID 261 //
     /* 2405987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2405990 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2405993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2405996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2405999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406007 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2406014 */   // (riscv_sllw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SLLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2406014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SLLW),
     /* 2406017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406019 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2406026 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406027 */   // GIR_Coverage, 261,
     /* 2406027 */   GIR_EraseRootFromParent_Done,
     /* 2406028 */ // Label 34706: @2406028
     /* 2406028 */ GIM_Reject,
     /* 2406029 */ // Label 118: @2406029
     /* 2406029 */ GIM_Try, /*On fail goto*//*Label 34707*/ GIMT_Encode4(2406075), // Rule ID 263 //
     /* 2406034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2406037 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2406040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406043 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2406046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406054 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2406061 */   // (riscv_sraw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRAW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2406061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRAW),
     /* 2406064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406066 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2406073 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406074 */   // GIR_Coverage, 263,
     /* 2406074 */   GIR_EraseRootFromParent_Done,
     /* 2406075 */ // Label 34707: @2406075
     /* 2406075 */ GIM_Reject,
     /* 2406076 */ // Label 119: @2406076
     /* 2406076 */ GIM_Try, /*On fail goto*//*Label 34708*/ GIMT_Encode4(2406122), // Rule ID 262 //
     /* 2406081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsRV64_HwMode0),
     /* 2406084 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2406087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2406093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2406101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIShiftMask32),
     /* 2406108 */   // (riscv_srlw:{ *:[i64] } GPR:{ *:[i64] }:$rs1, (shiftMask32:{ *:[i64] } GPR:{ *:[i64] }:$rs2))  =>  (SRLW:{ *:[i64] } GPR:{ *:[i64] }:$rs1, GPR:{ *:[i64] }:$rs2)
     /* 2406108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::SRLW),
     /* 2406111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406113 */   GIR_RootToRootCopy, /*OpIdx*/1, // rs1
     /* 2406115 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // rs2
     /* 2406120 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406121 */   // GIR_Coverage, 262,
     /* 2406121 */   GIR_EraseRootFromParent_Done,
     /* 2406122 */ // Label 34708: @2406122
     /* 2406122 */ GIM_Reject,
     /* 2406123 */ // Label 120: @2406123
     /* 2406123 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34716*/ GIMT_Encode4(2406771),
     /* 2406134 */ /*GILLT_nxv1s1*//*Label 34709*/ GIMT_Encode4(2406246), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406154 */ /*GILLT_nxv2s1*//*Label 34710*/ GIMT_Encode4(2406321), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406174 */ /*GILLT_nxv4s1*//*Label 34711*/ GIMT_Encode4(2406396), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406194 */ /*GILLT_nxv8s1*//*Label 34712*/ GIMT_Encode4(2406471), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406214 */ /*GILLT_nxv16s1*//*Label 34713*/ GIMT_Encode4(2406546), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406230 */ /*GILLT_nxv32s1*//*Label 34714*/ GIMT_Encode4(2406621), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406242 */ /*GILLT_nxv64s1*//*Label 34715*/ GIMT_Encode4(2406696),
     /* 2406246 */ // Label 34709: @2406246
     /* 2406246 */ GIM_Try, /*On fail goto*//*Label 34717*/ GIMT_Encode4(2406283), // Rule ID 44592 //
     /* 2406251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406261 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406268 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2406271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406273 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406278 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406281 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406282 */   // GIR_Coverage, 44592,
     /* 2406282 */   GIR_EraseRootFromParent_Done,
     /* 2406283 */ // Label 34717: @2406283
     /* 2406283 */ GIM_Try, /*On fail goto*//*Label 34718*/ GIMT_Encode4(2406320), // Rule ID 44593 //
     /* 2406288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406298 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406305 */   // (riscv_vmclr_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406305 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B64),
     /* 2406308 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406310 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406318 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406319 */   // GIR_Coverage, 44593,
     /* 2406319 */   GIR_EraseRootFromParent_Done,
     /* 2406320 */ // Label 34718: @2406320
     /* 2406320 */ GIM_Reject,
     /* 2406321 */ // Label 34710: @2406321
     /* 2406321 */ GIM_Try, /*On fail goto*//*Label 34719*/ GIMT_Encode4(2406358), // Rule ID 44620 //
     /* 2406326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406336 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406343 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2406346 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406348 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406356 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406357 */   // GIR_Coverage, 44620,
     /* 2406357 */   GIR_EraseRootFromParent_Done,
     /* 2406358 */ // Label 34719: @2406358
     /* 2406358 */ GIM_Try, /*On fail goto*//*Label 34720*/ GIMT_Encode4(2406395), // Rule ID 44621 //
     /* 2406363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406373 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406380 */   // (riscv_vmclr_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B32),
     /* 2406383 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406393 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406394 */   // GIR_Coverage, 44621,
     /* 2406394 */   GIR_EraseRootFromParent_Done,
     /* 2406395 */ // Label 34720: @2406395
     /* 2406395 */ GIM_Reject,
     /* 2406396 */ // Label 34711: @2406396
     /* 2406396 */ GIM_Try, /*On fail goto*//*Label 34721*/ GIMT_Encode4(2406433), // Rule ID 44648 //
     /* 2406401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406418 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2406421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406428 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406431 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406432 */   // GIR_Coverage, 44648,
     /* 2406432 */   GIR_EraseRootFromParent_Done,
     /* 2406433 */ // Label 34721: @2406433
     /* 2406433 */ GIM_Try, /*On fail goto*//*Label 34722*/ GIMT_Encode4(2406470), // Rule ID 44649 //
     /* 2406438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406448 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406455 */   // (riscv_vmclr_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B16),
     /* 2406458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406468 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406469 */   // GIR_Coverage, 44649,
     /* 2406469 */   GIR_EraseRootFromParent_Done,
     /* 2406470 */ // Label 34722: @2406470
     /* 2406470 */ GIM_Reject,
     /* 2406471 */ // Label 34712: @2406471
     /* 2406471 */ GIM_Try, /*On fail goto*//*Label 34723*/ GIMT_Encode4(2406508), // Rule ID 44676 //
     /* 2406476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406486 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406493 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2406496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406503 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406506 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406507 */   // GIR_Coverage, 44676,
     /* 2406507 */   GIR_EraseRootFromParent_Done,
     /* 2406508 */ // Label 34723: @2406508
     /* 2406508 */ GIM_Try, /*On fail goto*//*Label 34724*/ GIMT_Encode4(2406545), // Rule ID 44677 //
     /* 2406513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406530 */   // (riscv_vmclr_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B8),
     /* 2406533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406540 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406543 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406544 */   // GIR_Coverage, 44677,
     /* 2406544 */   GIR_EraseRootFromParent_Done,
     /* 2406545 */ // Label 34724: @2406545
     /* 2406545 */ GIM_Reject,
     /* 2406546 */ // Label 34713: @2406546
     /* 2406546 */ GIM_Try, /*On fail goto*//*Label 34725*/ GIMT_Encode4(2406583), // Rule ID 44704 //
     /* 2406551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406561 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406568 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2406571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406578 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406581 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406582 */   // GIR_Coverage, 44704,
     /* 2406582 */   GIR_EraseRootFromParent_Done,
     /* 2406583 */ // Label 34725: @2406583
     /* 2406583 */ GIM_Try, /*On fail goto*//*Label 34726*/ GIMT_Encode4(2406620), // Rule ID 44705 //
     /* 2406588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406598 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406605 */   // (riscv_vmclr_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B4),
     /* 2406608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406618 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406619 */   // GIR_Coverage, 44705,
     /* 2406619 */   GIR_EraseRootFromParent_Done,
     /* 2406620 */ // Label 34726: @2406620
     /* 2406620 */ GIM_Reject,
     /* 2406621 */ // Label 34714: @2406621
     /* 2406621 */ GIM_Try, /*On fail goto*//*Label 34727*/ GIMT_Encode4(2406658), // Rule ID 44732 //
     /* 2406626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406643 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2406646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406656 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406657 */   // GIR_Coverage, 44732,
     /* 2406657 */   GIR_EraseRootFromParent_Done,
     /* 2406658 */ // Label 34727: @2406658
     /* 2406658 */ GIM_Try, /*On fail goto*//*Label 34728*/ GIMT_Encode4(2406695), // Rule ID 44733 //
     /* 2406663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406673 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406680 */   // (riscv_vmclr_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B2),
     /* 2406683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406693 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406694 */   // GIR_Coverage, 44733,
     /* 2406694 */   GIR_EraseRootFromParent_Done,
     /* 2406695 */ // Label 34728: @2406695
     /* 2406695 */ GIM_Reject,
     /* 2406696 */ // Label 34715: @2406696
     /* 2406696 */ GIM_Try, /*On fail goto*//*Label 34729*/ GIMT_Encode4(2406733), // Rule ID 44760 //
     /* 2406701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406711 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406718 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2406721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406723 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406731 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406732 */   // GIR_Coverage, 44760,
     /* 2406732 */   GIR_EraseRootFromParent_Done,
     /* 2406733 */ // Label 34729: @2406733
     /* 2406733 */ GIM_Try, /*On fail goto*//*Label 34730*/ GIMT_Encode4(2406770), // Rule ID 44761 //
     /* 2406738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406748 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406755 */   // (riscv_vmclr_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMCLR_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMCLR_M_B1),
     /* 2406758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406765 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406768 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406769 */   // GIR_Coverage, 44761,
     /* 2406769 */   GIR_EraseRootFromParent_Done,
     /* 2406770 */ // Label 34730: @2406770
     /* 2406770 */ GIM_Reject,
     /* 2406771 */ // Label 34716: @2406771
     /* 2406771 */ GIM_Reject,
     /* 2406772 */ // Label 121: @2406772
     /* 2406772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(33), /*)*//*default:*//*Label 34738*/ GIMT_Encode4(2407420),
     /* 2406783 */ /*GILLT_nxv1s1*//*Label 34731*/ GIMT_Encode4(2406895), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406803 */ /*GILLT_nxv2s1*//*Label 34732*/ GIMT_Encode4(2406970), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406823 */ /*GILLT_nxv4s1*//*Label 34733*/ GIMT_Encode4(2407045), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406843 */ /*GILLT_nxv8s1*//*Label 34734*/ GIMT_Encode4(2407120), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406863 */ /*GILLT_nxv16s1*//*Label 34735*/ GIMT_Encode4(2407195), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406879 */ /*GILLT_nxv32s1*//*Label 34736*/ GIMT_Encode4(2407270), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 2406891 */ /*GILLT_nxv64s1*//*Label 34737*/ GIMT_Encode4(2407345),
     /* 2406895 */ // Label 34731: @2406895
     /* 2406895 */ GIM_Try, /*On fail goto*//*Label 34739*/ GIMT_Encode4(2406932), // Rule ID 44590 //
     /* 2406900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406910 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406917 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2406920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406927 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406930 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406931 */   // GIR_Coverage, 44590,
     /* 2406931 */   GIR_EraseRootFromParent_Done,
     /* 2406932 */ // Label 34739: @2406932
     /* 2406932 */ GIM_Try, /*On fail goto*//*Label 34740*/ GIMT_Encode4(2406969), // Rule ID 44591 //
     /* 2406937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2406940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2406943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406947 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406954 */   // (riscv_vmset_vl:{ *:[nxv1i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B64:{ *:[nxv1i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2406954 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B64),
     /* 2406957 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2406964 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2406967 */   GIR_RootConstrainSelectedInstOperands,
     /* 2406968 */   // GIR_Coverage, 44591,
     /* 2406968 */   GIR_EraseRootFromParent_Done,
     /* 2406969 */ // Label 34740: @2406969
     /* 2406969 */ GIM_Reject,
     /* 2406970 */ // Label 34732: @2406970
     /* 2406970 */ GIM_Try, /*On fail goto*//*Label 34741*/ GIMT_Encode4(2407007), // Rule ID 44618 //
     /* 2406975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2406978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2406981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2406985 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2406992 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2406992 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2406995 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2406997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407002 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407005 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407006 */   // GIR_Coverage, 44618,
     /* 2407006 */   GIR_EraseRootFromParent_Done,
     /* 2407007 */ // Label 34741: @2407007
     /* 2407007 */ GIM_Try, /*On fail goto*//*Label 34742*/ GIMT_Encode4(2407044), // Rule ID 44619 //
     /* 2407012 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407015 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407029 */   // (riscv_vmset_vl:{ *:[nxv2i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B32:{ *:[nxv2i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B32),
     /* 2407032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407042 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407043 */   // GIR_Coverage, 44619,
     /* 2407043 */   GIR_EraseRootFromParent_Done,
     /* 2407044 */ // Label 34742: @2407044
     /* 2407044 */ GIM_Reject,
     /* 2407045 */ // Label 34733: @2407045
     /* 2407045 */ GIM_Try, /*On fail goto*//*Label 34743*/ GIMT_Encode4(2407082), // Rule ID 44646 //
     /* 2407050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407060 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407067 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2407067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2407070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407080 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407081 */   // GIR_Coverage, 44646,
     /* 2407081 */   GIR_EraseRootFromParent_Done,
     /* 2407082 */ // Label 34743: @2407082
     /* 2407082 */ GIM_Try, /*On fail goto*//*Label 34744*/ GIMT_Encode4(2407119), // Rule ID 44647 //
     /* 2407087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407097 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407104 */   // (riscv_vmset_vl:{ *:[nxv4i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B16:{ *:[nxv4i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B16),
     /* 2407107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407114 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407117 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407118 */   // GIR_Coverage, 44647,
     /* 2407118 */   GIR_EraseRootFromParent_Done,
     /* 2407119 */ // Label 34744: @2407119
     /* 2407119 */ GIM_Reject,
     /* 2407120 */ // Label 34734: @2407120
     /* 2407120 */ GIM_Try, /*On fail goto*//*Label 34745*/ GIMT_Encode4(2407157), // Rule ID 44674 //
     /* 2407125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407135 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407142 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2407142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2407145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407152 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407155 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407156 */   // GIR_Coverage, 44674,
     /* 2407156 */   GIR_EraseRootFromParent_Done,
     /* 2407157 */ // Label 34745: @2407157
     /* 2407157 */ GIM_Try, /*On fail goto*//*Label 34746*/ GIMT_Encode4(2407194), // Rule ID 44675 //
     /* 2407162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407179 */   // (riscv_vmset_vl:{ *:[nxv8i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B8:{ *:[nxv8i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B8),
     /* 2407182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407189 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407192 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407193 */   // GIR_Coverage, 44675,
     /* 2407193 */   GIR_EraseRootFromParent_Done,
     /* 2407194 */ // Label 34746: @2407194
     /* 2407194 */ GIM_Reject,
     /* 2407195 */ // Label 34735: @2407195
     /* 2407195 */ GIM_Try, /*On fail goto*//*Label 34747*/ GIMT_Encode4(2407232), // Rule ID 44702 //
     /* 2407200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407217 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2407217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2407220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407227 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407230 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407231 */   // GIR_Coverage, 44702,
     /* 2407231 */   GIR_EraseRootFromParent_Done,
     /* 2407232 */ // Label 34747: @2407232
     /* 2407232 */ GIM_Try, /*On fail goto*//*Label 34748*/ GIMT_Encode4(2407269), // Rule ID 44703 //
     /* 2407237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407254 */   // (riscv_vmset_vl:{ *:[nxv16i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B4:{ *:[nxv16i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B4),
     /* 2407257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407267 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407268 */   // GIR_Coverage, 44703,
     /* 2407268 */   GIR_EraseRootFromParent_Done,
     /* 2407269 */ // Label 34748: @2407269
     /* 2407269 */ GIM_Reject,
     /* 2407270 */ // Label 34736: @2407270
     /* 2407270 */ GIM_Try, /*On fail goto*//*Label 34749*/ GIMT_Encode4(2407307), // Rule ID 44730 //
     /* 2407275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407285 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407292 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2407292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2407295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407305 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407306 */   // GIR_Coverage, 44730,
     /* 2407306 */   GIR_EraseRootFromParent_Done,
     /* 2407307 */ // Label 34749: @2407307
     /* 2407307 */ GIM_Try, /*On fail goto*//*Label 34750*/ GIMT_Encode4(2407344), // Rule ID 44731 //
     /* 2407312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407322 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407329 */   // (riscv_vmset_vl:{ *:[nxv32i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B2:{ *:[nxv32i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B2),
     /* 2407332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407342 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407343 */   // GIR_Coverage, 44731,
     /* 2407343 */   GIR_EraseRootFromParent_Done,
     /* 2407344 */ // Label 34750: @2407344
     /* 2407344 */ GIM_Reject,
     /* 2407345 */ // Label 34737: @2407345
     /* 2407345 */ GIM_Try, /*On fail goto*//*Label 34751*/ GIMT_Encode4(2407382), // Rule ID 44758 //
     /* 2407350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2407356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407367 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i64] }:$vl, 0:{ *:[i64] })
     /* 2407367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2407370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407377 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407380 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407381 */   // GIR_Coverage, 44758,
     /* 2407381 */   GIR_EraseRootFromParent_Done,
     /* 2407382 */ // Label 34751: @2407382
     /* 2407382 */ GIM_Try, /*On fail goto*//*Label 34752*/ GIMT_Encode4(2407419), // Rule ID 44759 //
     /* 2407387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2407393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407404 */   // (riscv_vmset_vl:{ *:[nxv64i1] } (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMSET_M_B1:{ *:[nxv64i1] } GPR:{ *:[i32] }:$vl, 0:{ *:[i32] })
     /* 2407404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMSET_M_B1),
     /* 2407407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407414 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407417 */   GIR_RootConstrainSelectedInstOperands,
     /* 2407418 */   // GIR_Coverage, 44759,
     /* 2407418 */   GIR_EraseRootFromParent_Done,
     /* 2407419 */ // Label 34752: @2407419
     /* 2407419 */ GIM_Reject,
     /* 2407420 */ // Label 34738: @2407420
     /* 2407420 */ GIM_Reject,
     /* 2407421 */ // Label 122: @2407421
     /* 2407421 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 34775*/ GIMT_Encode4(2411678),
     /* 2407432 */ /*GILLT_nxv1s8*//*Label 34753*/ GIMT_Encode4(2407544),
     /* 2407436 */ /*GILLT_nxv1s16*//*Label 34754*/ GIMT_Encode4(2407661),
     /* 2407440 */ /*GILLT_nxv1s32*//*Label 34755*/ GIMT_Encode4(2407882),
     /* 2407444 */ /*GILLT_nxv1s64*//*Label 34756*/ GIMT_Encode4(2408103), GIMT_Encode4(0),
     /* 2407452 */ /*GILLT_nxv2s8*//*Label 34757*/ GIMT_Encode4(2408324),
     /* 2407456 */ /*GILLT_nxv2s16*//*Label 34758*/ GIMT_Encode4(2408441),
     /* 2407460 */ /*GILLT_nxv2s32*//*Label 34759*/ GIMT_Encode4(2408662),
     /* 2407464 */ /*GILLT_nxv2s64*//*Label 34760*/ GIMT_Encode4(2408883), GIMT_Encode4(0),
     /* 2407472 */ /*GILLT_nxv4s8*//*Label 34761*/ GIMT_Encode4(2409104),
     /* 2407476 */ /*GILLT_nxv4s16*//*Label 34762*/ GIMT_Encode4(2409221),
     /* 2407480 */ /*GILLT_nxv4s32*//*Label 34763*/ GIMT_Encode4(2409442),
     /* 2407484 */ /*GILLT_nxv4s64*//*Label 34764*/ GIMT_Encode4(2409663), GIMT_Encode4(0),
     /* 2407492 */ /*GILLT_nxv8s8*//*Label 34765*/ GIMT_Encode4(2409884),
     /* 2407496 */ /*GILLT_nxv8s16*//*Label 34766*/ GIMT_Encode4(2410001),
     /* 2407500 */ /*GILLT_nxv8s32*//*Label 34767*/ GIMT_Encode4(2410222),
     /* 2407504 */ /*GILLT_nxv8s64*//*Label 34768*/ GIMT_Encode4(2410443), GIMT_Encode4(0),
     /* 2407512 */ /*GILLT_nxv16s8*//*Label 34769*/ GIMT_Encode4(2410664),
     /* 2407516 */ /*GILLT_nxv16s16*//*Label 34770*/ GIMT_Encode4(2410781),
     /* 2407520 */ /*GILLT_nxv16s32*//*Label 34771*/ GIMT_Encode4(2411002), GIMT_Encode4(0),
     /* 2407528 */ /*GILLT_nxv32s8*//*Label 34772*/ GIMT_Encode4(2411223),
     /* 2407532 */ /*GILLT_nxv32s16*//*Label 34773*/ GIMT_Encode4(2411340), GIMT_Encode4(0),
     /* 2407540 */ /*GILLT_nxv64s8*//*Label 34774*/ GIMT_Encode4(2411561),
     /* 2407544 */ // Label 34753: @2407544
     /* 2407544 */ GIM_Try, /*On fail goto*//*Label 34776*/ GIMT_Encode4(2407660),
     /* 2407549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2407552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2407555 */   GIM_Try, /*On fail goto*//*Label 34777*/ GIMT_Encode4(2407607), // Rule ID 32180 //
     /* 2407560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2407566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407578 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407585 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2407585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2407588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407590 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407592 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407606 */     // GIR_Coverage, 32180,
     /* 2407606 */     GIR_EraseRootFromParent_Done,
     /* 2407607 */   // Label 34777: @2407607
     /* 2407607 */   GIM_Try, /*On fail goto*//*Label 34778*/ GIMT_Encode4(2407659), // Rule ID 32181 //
     /* 2407612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2407618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407637 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF8:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$passthru, VR:{ *:[nxv1i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2407637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF8),
     /* 2407640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407642 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407651 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2407654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407658 */     // GIR_Coverage, 32181,
     /* 2407658 */     GIR_EraseRootFromParent_Done,
     /* 2407659 */   // Label 34778: @2407659
     /* 2407659 */   GIM_Reject,
     /* 2407660 */ // Label 34776: @2407660
     /* 2407660 */ GIM_Reject,
     /* 2407661 */ // Label 34754: @2407661
     /* 2407661 */ GIM_Try, /*On fail goto*//*Label 34779*/ GIMT_Encode4(2407881),
     /* 2407666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2407669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2407672 */   GIM_Try, /*On fail goto*//*Label 34780*/ GIMT_Encode4(2407724), // Rule ID 32450 //
     /* 2407677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2407683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407702 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2407702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2407705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407707 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407709 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407722 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407723 */     // GIR_Coverage, 32450,
     /* 2407723 */     GIR_EraseRootFromParent_Done,
     /* 2407724 */   // Label 34780: @2407724
     /* 2407724 */   GIM_Try, /*On fail goto*//*Label 34781*/ GIMT_Encode4(2407776), // Rule ID 32451 //
     /* 2407729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2407735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407747 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407754 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$passthru, VR:{ *:[nxv1i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2407754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2407757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407759 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407761 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407775 */     // GIR_Coverage, 32451,
     /* 2407775 */     GIR_EraseRootFromParent_Done,
     /* 2407776 */   // Label 34781: @2407776
     /* 2407776 */   GIM_Try, /*On fail goto*//*Label 34782*/ GIMT_Encode4(2407828), // Rule ID 34160 //
     /* 2407781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2407787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407806 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2407806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2407809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407811 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407813 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407826 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407827 */     // GIR_Coverage, 34160,
     /* 2407827 */     GIR_EraseRootFromParent_Done,
     /* 2407828 */   // Label 34782: @2407828
     /* 2407828 */   GIM_Try, /*On fail goto*//*Label 34783*/ GIMT_Encode4(2407880), // Rule ID 34161 //
     /* 2407833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2407839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407858 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$passthru, VR:{ *:[nxv1f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2407858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2407861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407863 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407865 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407867 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2407875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407878 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407879 */     // GIR_Coverage, 34161,
     /* 2407879 */     GIR_EraseRootFromParent_Done,
     /* 2407880 */   // Label 34783: @2407880
     /* 2407880 */   GIM_Reject,
     /* 2407881 */ // Label 34779: @2407881
     /* 2407881 */ GIM_Reject,
     /* 2407882 */ // Label 34755: @2407882
     /* 2407882 */ GIM_Try, /*On fail goto*//*Label 34784*/ GIMT_Encode4(2408102),
     /* 2407887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2407890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2407893 */   GIM_Try, /*On fail goto*//*Label 34785*/ GIMT_Encode4(2407945), // Rule ID 32630 //
     /* 2407898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2407901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2407904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407916 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407923 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2407923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2407926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407928 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407930 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407944 */     // GIR_Coverage, 32630,
     /* 2407944 */     GIR_EraseRootFromParent_Done,
     /* 2407945 */   // Label 34785: @2407945
     /* 2407945 */   GIM_Try, /*On fail goto*//*Label 34786*/ GIMT_Encode4(2407997), // Rule ID 32631 //
     /* 2407950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2407953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2407956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2407968 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2407975 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$passthru, VR:{ *:[nxv1i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2407975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2407978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2407980 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2407982 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2407984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2407989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2407992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2407995 */     GIR_RootConstrainSelectedInstOperands,
     /* 2407996 */     // GIR_Coverage, 32631,
     /* 2407996 */     GIR_EraseRootFromParent_Done,
     /* 2407997 */   // Label 34786: @2407997
     /* 2407997 */   GIM_Try, /*On fail goto*//*Label 34787*/ GIMT_Encode4(2408049), // Rule ID 34340 //
     /* 2408002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408027 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408032 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408047 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408048 */     // GIR_Coverage, 34340,
     /* 2408048 */     GIR_EraseRootFromParent_Done,
     /* 2408049 */   // Label 34787: @2408049
     /* 2408049 */   GIM_Try, /*On fail goto*//*Label 34788*/ GIMT_Encode4(2408101), // Rule ID 34341 //
     /* 2408054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408079 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$passthru, VR:{ *:[nxv1f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408084 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408086 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408100 */     // GIR_Coverage, 34341,
     /* 2408100 */     GIR_EraseRootFromParent_Done,
     /* 2408101 */   // Label 34788: @2408101
     /* 2408101 */   GIM_Reject,
     /* 2408102 */ // Label 34784: @2408102
     /* 2408102 */ GIM_Reject,
     /* 2408103 */ // Label 34756: @2408103
     /* 2408103 */ GIM_Try, /*On fail goto*//*Label 34789*/ GIMT_Encode4(2408323),
     /* 2408108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2408111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2408114 */   GIM_Try, /*On fail goto*//*Label 34790*/ GIMT_Encode4(2408166), // Rule ID 32990 //
     /* 2408119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2408122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408144 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408149 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408151 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408164 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408165 */     // GIR_Coverage, 32990,
     /* 2408165 */     GIR_EraseRootFromParent_Done,
     /* 2408166 */   // Label 34790: @2408166
     /* 2408166 */   GIM_Try, /*On fail goto*//*Label 34791*/ GIMT_Encode4(2408218), // Rule ID 32991 //
     /* 2408171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2408174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408189 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408196 */     // (riscv_vmv_v_v_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$passthru, VR:{ *:[nxv1i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408201 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408203 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408216 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408217 */     // GIR_Coverage, 32991,
     /* 2408217 */     GIR_EraseRootFromParent_Done,
     /* 2408218 */   // Label 34791: @2408218
     /* 2408218 */   GIM_Try, /*On fail goto*//*Label 34792*/ GIMT_Encode4(2408270), // Rule ID 34610 //
     /* 2408223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2408226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408248 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408253 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408268 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408269 */     // GIR_Coverage, 34610,
     /* 2408269 */     GIR_EraseRootFromParent_Done,
     /* 2408270 */   // Label 34792: @2408270
     /* 2408270 */   GIM_Try, /*On fail goto*//*Label 34793*/ GIMT_Encode4(2408322), // Rule ID 34611 //
     /* 2408275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2408278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408300 */     // (riscv_vmv_v_v_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$passthru, VR:{ *:[nxv1f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408305 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408307 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408321 */     // GIR_Coverage, 34611,
     /* 2408321 */     GIR_EraseRootFromParent_Done,
     /* 2408322 */   // Label 34793: @2408322
     /* 2408322 */   GIM_Reject,
     /* 2408323 */ // Label 34789: @2408323
     /* 2408323 */ GIM_Reject,
     /* 2408324 */ // Label 34757: @2408324
     /* 2408324 */ GIM_Try, /*On fail goto*//*Label 34794*/ GIMT_Encode4(2408440),
     /* 2408329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2408332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2408335 */   GIM_Try, /*On fail goto*//*Label 34795*/ GIMT_Encode4(2408387), // Rule ID 32270 //
     /* 2408340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408365 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2408368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408370 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408372 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408385 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408386 */     // GIR_Coverage, 32270,
     /* 2408386 */     GIR_EraseRootFromParent_Done,
     /* 2408387 */   // Label 34795: @2408387
     /* 2408387 */   GIM_Try, /*On fail goto*//*Label 34796*/ GIMT_Encode4(2408439), // Rule ID 32271 //
     /* 2408392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408417 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF4:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$passthru, VR:{ *:[nxv2i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF4),
     /* 2408420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408422 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408424 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408426 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2408434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408437 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408438 */     // GIR_Coverage, 32271,
     /* 2408438 */     GIR_EraseRootFromParent_Done,
     /* 2408439 */   // Label 34796: @2408439
     /* 2408439 */   GIM_Reject,
     /* 2408440 */ // Label 34794: @2408440
     /* 2408440 */ GIM_Reject,
     /* 2408441 */ // Label 34758: @2408441
     /* 2408441 */ GIM_Try, /*On fail goto*//*Label 34797*/ GIMT_Encode4(2408661),
     /* 2408446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2408449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2408452 */   GIM_Try, /*On fail goto*//*Label 34798*/ GIMT_Encode4(2408504), // Rule ID 32540 //
     /* 2408457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408475 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408482 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408487 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408489 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408502 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408503 */     // GIR_Coverage, 32540,
     /* 2408503 */     GIR_EraseRootFromParent_Done,
     /* 2408504 */   // Label 34798: @2408504
     /* 2408504 */   GIM_Try, /*On fail goto*//*Label 34799*/ GIMT_Encode4(2408556), // Rule ID 32541 //
     /* 2408509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408527 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408534 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$passthru, VR:{ *:[nxv2i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408539 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408541 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408555 */     // GIR_Coverage, 32541,
     /* 2408555 */     GIR_EraseRootFromParent_Done,
     /* 2408556 */   // Label 34799: @2408556
     /* 2408556 */   GIM_Try, /*On fail goto*//*Label 34800*/ GIMT_Encode4(2408608), // Rule ID 34250 //
     /* 2408561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408586 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408591 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408606 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408607 */     // GIR_Coverage, 34250,
     /* 2408607 */     GIR_EraseRootFromParent_Done,
     /* 2408608 */   // Label 34800: @2408608
     /* 2408608 */   GIM_Try, /*On fail goto*//*Label 34801*/ GIMT_Encode4(2408660), // Rule ID 34251 //
     /* 2408613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408638 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$passthru, VR:{ *:[nxv2f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2408641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408643 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2408655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408658 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408659 */     // GIR_Coverage, 34251,
     /* 2408659 */     GIR_EraseRootFromParent_Done,
     /* 2408660 */   // Label 34801: @2408660
     /* 2408660 */   GIM_Reject,
     /* 2408661 */ // Label 34797: @2408661
     /* 2408661 */ GIM_Reject,
     /* 2408662 */ // Label 34759: @2408662
     /* 2408662 */ GIM_Try, /*On fail goto*//*Label 34802*/ GIMT_Encode4(2408882),
     /* 2408667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2408670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2408673 */   GIM_Try, /*On fail goto*//*Label 34803*/ GIMT_Encode4(2408725), // Rule ID 32900 //
     /* 2408678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408696 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408703 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408708 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408710 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408723 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408724 */     // GIR_Coverage, 32900,
     /* 2408724 */     GIR_EraseRootFromParent_Done,
     /* 2408725 */   // Label 34803: @2408725
     /* 2408725 */   GIM_Try, /*On fail goto*//*Label 34804*/ GIMT_Encode4(2408777), // Rule ID 32901 //
     /* 2408730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408755 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$passthru, VR:{ *:[nxv2i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408760 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408762 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408775 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408776 */     // GIR_Coverage, 32901,
     /* 2408776 */     GIR_EraseRootFromParent_Done,
     /* 2408777 */   // Label 34804: @2408777
     /* 2408777 */   GIM_Try, /*On fail goto*//*Label 34805*/ GIMT_Encode4(2408829), // Rule ID 34520 //
     /* 2408782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2408785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408800 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408807 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408812 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408814 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408828 */     // GIR_Coverage, 34520,
     /* 2408828 */     GIR_EraseRootFromParent_Done,
     /* 2408829 */   // Label 34805: @2408829
     /* 2408829 */   GIM_Try, /*On fail goto*//*Label 34806*/ GIMT_Encode4(2408881), // Rule ID 34521 //
     /* 2408834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2408837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2408852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408859 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$passthru, VR:{ *:[nxv2f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2408862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408864 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2408876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408879 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408880 */     // GIR_Coverage, 34521,
     /* 2408880 */     GIR_EraseRootFromParent_Done,
     /* 2408881 */   // Label 34806: @2408881
     /* 2408881 */   GIM_Reject,
     /* 2408882 */ // Label 34802: @2408882
     /* 2408882 */ GIM_Reject,
     /* 2408883 */ // Label 34760: @2408883
     /* 2408883 */ GIM_Try, /*On fail goto*//*Label 34807*/ GIMT_Encode4(2409103),
     /* 2408888 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2408891 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2408894 */   GIM_Try, /*On fail goto*//*Label 34808*/ GIMT_Encode4(2408946), // Rule ID 33890 //
     /* 2408899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2408902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2408905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408924 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2408924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2408927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408929 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408931 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408944 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408945 */     // GIR_Coverage, 33890,
     /* 2408945 */     GIR_EraseRootFromParent_Done,
     /* 2408946 */   // Label 34808: @2408946
     /* 2408946 */   GIM_Try, /*On fail goto*//*Label 34809*/ GIMT_Encode4(2408998), // Rule ID 33891 //
     /* 2408951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2408954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2408957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2408969 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2408976 */     // (riscv_vmv_v_v_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$passthru, VRM2:{ *:[nxv2i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2408976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2408979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2408981 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2408983 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2408985 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2408990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2408993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2408996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2408997 */     // GIR_Coverage, 33891,
     /* 2408997 */     GIR_EraseRootFromParent_Done,
     /* 2408998 */   // Label 34809: @2408998
     /* 2408998 */   GIM_Try, /*On fail goto*//*Label 34810*/ GIMT_Encode4(2409050), // Rule ID 35240 //
     /* 2409003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2409006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409028 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409033 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409042 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409048 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409049 */     // GIR_Coverage, 35240,
     /* 2409049 */     GIR_EraseRootFromParent_Done,
     /* 2409050 */   // Label 34810: @2409050
     /* 2409050 */   GIM_Try, /*On fail goto*//*Label 34811*/ GIMT_Encode4(2409102), // Rule ID 35241 //
     /* 2409055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2409058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409080 */     // (riscv_vmv_v_v_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$passthru, VRM2:{ *:[nxv2f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409085 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409087 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409100 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409101 */     // GIR_Coverage, 35241,
     /* 2409101 */     GIR_EraseRootFromParent_Done,
     /* 2409102 */   // Label 34811: @2409102
     /* 2409102 */   GIM_Reject,
     /* 2409103 */ // Label 34807: @2409103
     /* 2409103 */ GIM_Reject,
     /* 2409104 */ // Label 34761: @2409104
     /* 2409104 */ GIM_Try, /*On fail goto*//*Label 34812*/ GIMT_Encode4(2409220),
     /* 2409109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2409112 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2409115 */   GIM_Try, /*On fail goto*//*Label 34813*/ GIMT_Encode4(2409167), // Rule ID 32360 //
     /* 2409120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409138 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409145 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2409148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409150 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409152 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2409162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409165 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409166 */     // GIR_Coverage, 32360,
     /* 2409166 */     GIR_EraseRootFromParent_Done,
     /* 2409167 */   // Label 34813: @2409167
     /* 2409167 */   GIM_Try, /*On fail goto*//*Label 34814*/ GIMT_Encode4(2409219), // Rule ID 32361 //
     /* 2409172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409197 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_MF2:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$passthru, VR:{ *:[nxv4i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_MF2),
     /* 2409200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409202 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409204 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2409214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409218 */     // GIR_Coverage, 32361,
     /* 2409218 */     GIR_EraseRootFromParent_Done,
     /* 2409219 */   // Label 34814: @2409219
     /* 2409219 */   GIM_Reject,
     /* 2409220 */ // Label 34812: @2409220
     /* 2409220 */ GIM_Reject,
     /* 2409221 */ // Label 34762: @2409221
     /* 2409221 */ GIM_Try, /*On fail goto*//*Label 34815*/ GIMT_Encode4(2409441),
     /* 2409226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2409229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2409232 */   GIM_Try, /*On fail goto*//*Label 34816*/ GIMT_Encode4(2409284), // Rule ID 32810 //
     /* 2409237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409262 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409267 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409269 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409282 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409283 */     // GIR_Coverage, 32810,
     /* 2409283 */     GIR_EraseRootFromParent_Done,
     /* 2409284 */   // Label 34816: @2409284
     /* 2409284 */   GIM_Try, /*On fail goto*//*Label 34817*/ GIMT_Encode4(2409336), // Rule ID 32811 //
     /* 2409289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409314 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$passthru, VR:{ *:[nxv4i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409319 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409335 */     // GIR_Coverage, 32811,
     /* 2409335 */     GIR_EraseRootFromParent_Done,
     /* 2409336 */   // Label 34817: @2409336
     /* 2409336 */   GIM_Try, /*On fail goto*//*Label 34818*/ GIMT_Encode4(2409388), // Rule ID 34430 //
     /* 2409341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409366 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409371 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409373 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409386 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409387 */     // GIR_Coverage, 34430,
     /* 2409387 */     GIR_EraseRootFromParent_Done,
     /* 2409388 */   // Label 34818: @2409388
     /* 2409388 */   GIM_Try, /*On fail goto*//*Label 34819*/ GIMT_Encode4(2409440), // Rule ID 34431 //
     /* 2409393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409418 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$passthru, VR:{ *:[nxv4f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409423 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409425 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2409435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409438 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409439 */     // GIR_Coverage, 34431,
     /* 2409439 */     GIR_EraseRootFromParent_Done,
     /* 2409440 */   // Label 34819: @2409440
     /* 2409440 */   GIM_Reject,
     /* 2409441 */ // Label 34815: @2409441
     /* 2409441 */ GIM_Reject,
     /* 2409442 */ // Label 34763: @2409442
     /* 2409442 */ GIM_Try, /*On fail goto*//*Label 34820*/ GIMT_Encode4(2409662),
     /* 2409447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2409450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2409453 */   GIM_Try, /*On fail goto*//*Label 34821*/ GIMT_Encode4(2409505), // Rule ID 33620 //
     /* 2409458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409476 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409483 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409488 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409490 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409503 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409504 */     // GIR_Coverage, 33620,
     /* 2409504 */     GIR_EraseRootFromParent_Done,
     /* 2409505 */   // Label 34821: @2409505
     /* 2409505 */   GIM_Try, /*On fail goto*//*Label 34822*/ GIMT_Encode4(2409557), // Rule ID 33621 //
     /* 2409510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409535 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$passthru, VRM2:{ *:[nxv4i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409540 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409542 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409552 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409555 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409556 */     // GIR_Coverage, 33621,
     /* 2409556 */     GIR_EraseRootFromParent_Done,
     /* 2409557 */   // Label 34822: @2409557
     /* 2409557 */   GIM_Try, /*On fail goto*//*Label 34823*/ GIMT_Encode4(2409609), // Rule ID 34970 //
     /* 2409562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409587 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409592 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409607 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409608 */     // GIR_Coverage, 34970,
     /* 2409608 */     GIR_EraseRootFromParent_Done,
     /* 2409609 */   // Label 34823: @2409609
     /* 2409609 */   GIM_Try, /*On fail goto*//*Label 34824*/ GIMT_Encode4(2409661), // Rule ID 34971 //
     /* 2409614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2409632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409639 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$passthru, VRM2:{ *:[nxv4f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2409642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409644 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409646 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2409656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409659 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409660 */     // GIR_Coverage, 34971,
     /* 2409660 */     GIR_EraseRootFromParent_Done,
     /* 2409661 */   // Label 34824: @2409661
     /* 2409661 */   GIM_Reject,
     /* 2409662 */ // Label 34820: @2409662
     /* 2409662 */ GIM_Reject,
     /* 2409663 */ // Label 34764: @2409663
     /* 2409663 */ GIM_Try, /*On fail goto*//*Label 34825*/ GIMT_Encode4(2409883),
     /* 2409668 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2409671 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2409674 */   GIM_Try, /*On fail goto*//*Label 34826*/ GIMT_Encode4(2409726), // Rule ID 33980 //
     /* 2409679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2409682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409697 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409704 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2409707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409709 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409711 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409724 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409725 */     // GIR_Coverage, 33980,
     /* 2409725 */     GIR_EraseRootFromParent_Done,
     /* 2409726 */   // Label 34826: @2409726
     /* 2409726 */   GIM_Try, /*On fail goto*//*Label 34827*/ GIMT_Encode4(2409778), // Rule ID 33981 //
     /* 2409731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2409734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409749 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409756 */     // (riscv_vmv_v_v_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$passthru, VRM4:{ *:[nxv4i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2409759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409761 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409763 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409776 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409777 */     // GIR_Coverage, 33981,
     /* 2409777 */     GIR_EraseRootFromParent_Done,
     /* 2409778 */   // Label 34827: @2409778
     /* 2409778 */   GIM_Try, /*On fail goto*//*Label 34828*/ GIMT_Encode4(2409830), // Rule ID 35330 //
     /* 2409783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2409786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409808 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2409811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409813 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409829 */     // GIR_Coverage, 35330,
     /* 2409829 */     GIR_EraseRootFromParent_Done,
     /* 2409830 */   // Label 34828: @2409830
     /* 2409830 */   GIM_Try, /*On fail goto*//*Label 34829*/ GIMT_Encode4(2409882), // Rule ID 35331 //
     /* 2409835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2409838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2409853 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409860 */     // (riscv_vmv_v_v_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$passthru, VRM4:{ *:[nxv4f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2409863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409865 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409867 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2409877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409880 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409881 */     // GIR_Coverage, 35331,
     /* 2409881 */     GIR_EraseRootFromParent_Done,
     /* 2409882 */   // Label 34829: @2409882
     /* 2409882 */   GIM_Reject,
     /* 2409883 */ // Label 34825: @2409883
     /* 2409883 */ GIM_Reject,
     /* 2409884 */ // Label 34765: @2409884
     /* 2409884 */ GIM_Try, /*On fail goto*//*Label 34830*/ GIMT_Encode4(2410000),
     /* 2409889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2409892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2409895 */   GIM_Try, /*On fail goto*//*Label 34831*/ GIMT_Encode4(2409947), // Rule ID 32720 //
     /* 2409900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2409903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2409906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409925 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2409925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409930 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2409942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409945 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409946 */     // GIR_Coverage, 32720,
     /* 2409946 */     GIR_EraseRootFromParent_Done,
     /* 2409947 */   // Label 34831: @2409947
     /* 2409947 */   GIM_Try, /*On fail goto*//*Label 34832*/ GIMT_Encode4(2409999), // Rule ID 32721 //
     /* 2409952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2409955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2409958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2409970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2409977 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M1:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$passthru, VR:{ *:[nxv8i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2409977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M1),
     /* 2409980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2409982 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2409984 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2409986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2409991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2409994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2409997 */     GIR_RootConstrainSelectedInstOperands,
     /* 2409998 */     // GIR_Coverage, 32721,
     /* 2409998 */     GIR_EraseRootFromParent_Done,
     /* 2409999 */   // Label 34832: @2409999
     /* 2409999 */   GIM_Reject,
     /* 2410000 */ // Label 34830: @2410000
     /* 2410000 */ GIM_Reject,
     /* 2410001 */ // Label 34766: @2410001
     /* 2410001 */ GIM_Try, /*On fail goto*//*Label 34833*/ GIMT_Encode4(2410221),
     /* 2410006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2410009 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2410012 */   GIM_Try, /*On fail goto*//*Label 34834*/ GIMT_Encode4(2410064), // Rule ID 33350 //
     /* 2410017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410042 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410047 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410049 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410062 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410063 */     // GIR_Coverage, 33350,
     /* 2410063 */     GIR_EraseRootFromParent_Done,
     /* 2410064 */   // Label 34834: @2410064
     /* 2410064 */   GIM_Try, /*On fail goto*//*Label 34835*/ GIMT_Encode4(2410116), // Rule ID 33351 //
     /* 2410069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410094 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$passthru, VRM2:{ *:[nxv8i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410099 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410103 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410114 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410115 */     // GIR_Coverage, 33351,
     /* 2410115 */     GIR_EraseRootFromParent_Done,
     /* 2410116 */   // Label 34835: @2410116
     /* 2410116 */   GIM_Try, /*On fail goto*//*Label 34836*/ GIMT_Encode4(2410168), // Rule ID 34700 //
     /* 2410121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410146 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410151 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410153 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410166 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410167 */     // GIR_Coverage, 34700,
     /* 2410167 */     GIR_EraseRootFromParent_Done,
     /* 2410168 */   // Label 34836: @2410168
     /* 2410168 */   GIM_Try, /*On fail goto*//*Label 34837*/ GIMT_Encode4(2410220), // Rule ID 34701 //
     /* 2410173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410191 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410198 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$passthru, VRM2:{ *:[nxv8f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410203 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410205 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410215 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410219 */     // GIR_Coverage, 34701,
     /* 2410219 */     GIR_EraseRootFromParent_Done,
     /* 2410220 */   // Label 34837: @2410220
     /* 2410220 */   GIM_Reject,
     /* 2410221 */ // Label 34833: @2410221
     /* 2410221 */ GIM_Reject,
     /* 2410222 */ // Label 34767: @2410222
     /* 2410222 */ GIM_Try, /*On fail goto*//*Label 34838*/ GIMT_Encode4(2410442),
     /* 2410227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2410230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2410233 */   GIM_Try, /*On fail goto*//*Label 34839*/ GIMT_Encode4(2410285), // Rule ID 33710 //
     /* 2410238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410256 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410263 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410268 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410270 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410283 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410284 */     // GIR_Coverage, 33710,
     /* 2410284 */     GIR_EraseRootFromParent_Done,
     /* 2410285 */   // Label 34839: @2410285
     /* 2410285 */   GIM_Try, /*On fail goto*//*Label 34840*/ GIMT_Encode4(2410337), // Rule ID 33711 //
     /* 2410290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410308 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410315 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$passthru, VRM4:{ *:[nxv8i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410320 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410322 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410335 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410336 */     // GIR_Coverage, 33711,
     /* 2410336 */     GIR_EraseRootFromParent_Done,
     /* 2410337 */   // Label 34840: @2410337
     /* 2410337 */   GIM_Try, /*On fail goto*//*Label 34841*/ GIMT_Encode4(2410389), // Rule ID 35060 //
     /* 2410342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410360 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410367 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410372 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410374 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410388 */     // GIR_Coverage, 35060,
     /* 2410388 */     GIR_EraseRootFromParent_Done,
     /* 2410389 */   // Label 34841: @2410389
     /* 2410389 */   GIM_Try, /*On fail goto*//*Label 34842*/ GIMT_Encode4(2410441), // Rule ID 35061 //
     /* 2410394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410412 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410419 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$passthru, VRM4:{ *:[nxv8f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410424 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410426 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2410436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410440 */     // GIR_Coverage, 35061,
     /* 2410440 */     GIR_EraseRootFromParent_Done,
     /* 2410441 */   // Label 34842: @2410441
     /* 2410441 */   GIM_Reject,
     /* 2410442 */ // Label 34838: @2410442
     /* 2410442 */ GIM_Reject,
     /* 2410443 */ // Label 34768: @2410443
     /* 2410443 */ GIM_Try, /*On fail goto*//*Label 34843*/ GIMT_Encode4(2410663),
     /* 2410448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2410451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2410454 */   GIM_Try, /*On fail goto*//*Label 34844*/ GIMT_Encode4(2410506), // Rule ID 34070 //
     /* 2410459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2410462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410484 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2410487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410489 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410491 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410493 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410504 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410505 */     // GIR_Coverage, 34070,
     /* 2410505 */     GIR_EraseRootFromParent_Done,
     /* 2410506 */   // Label 34844: @2410506
     /* 2410506 */   GIM_Try, /*On fail goto*//*Label 34845*/ GIMT_Encode4(2410558), // Rule ID 34071 //
     /* 2410511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2410514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410536 */     // (riscv_vmv_v_v_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$passthru, VRM8:{ *:[nxv8i64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2410539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410541 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410556 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410557 */     // GIR_Coverage, 34071,
     /* 2410557 */     GIR_EraseRootFromParent_Done,
     /* 2410558 */   // Label 34845: @2410558
     /* 2410558 */   GIM_Try, /*On fail goto*//*Label 34846*/ GIMT_Encode4(2410610), // Rule ID 35420 //
     /* 2410563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2410566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410573 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410588 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2410591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410593 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410597 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410608 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410609 */     // GIR_Coverage, 35420,
     /* 2410609 */     GIR_EraseRootFromParent_Done,
     /* 2410610 */   // Label 34846: @2410610
     /* 2410610 */   GIM_Try, /*On fail goto*//*Label 34847*/ GIMT_Encode4(2410662), // Rule ID 35421 //
     /* 2410615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2410618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2410633 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410640 */     // (riscv_vmv_v_v_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$passthru, VRM8:{ *:[nxv8f64] }:$rs2, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2410643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410645 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410647 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2410657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410660 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410661 */     // GIR_Coverage, 35421,
     /* 2410661 */     GIR_EraseRootFromParent_Done,
     /* 2410662 */   // Label 34847: @2410662
     /* 2410662 */   GIM_Reject,
     /* 2410663 */ // Label 34843: @2410663
     /* 2410663 */ GIM_Reject,
     /* 2410664 */ // Label 34769: @2410664
     /* 2410664 */ GIM_Try, /*On fail goto*//*Label 34848*/ GIMT_Encode4(2410780),
     /* 2410669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2410672 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2410675 */   GIM_Try, /*On fail goto*//*Label 34849*/ GIMT_Encode4(2410727), // Rule ID 33080 //
     /* 2410680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410705 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410710 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410712 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2410722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410725 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410726 */     // GIR_Coverage, 33080,
     /* 2410726 */     GIR_EraseRootFromParent_Done,
     /* 2410727 */   // Label 34849: @2410727
     /* 2410727 */   GIM_Try, /*On fail goto*//*Label 34850*/ GIMT_Encode4(2410779), // Rule ID 33081 //
     /* 2410732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2410750 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410757 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M2:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$passthru, VRM2:{ *:[nxv16i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M2),
     /* 2410760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410762 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410764 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410766 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2410774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410778 */     // GIR_Coverage, 33081,
     /* 2410778 */     GIR_EraseRootFromParent_Done,
     /* 2410779 */   // Label 34850: @2410779
     /* 2410779 */   GIM_Reject,
     /* 2410780 */ // Label 34848: @2410780
     /* 2410780 */ GIM_Reject,
     /* 2410781 */ // Label 34770: @2410781
     /* 2410781 */ GIM_Try, /*On fail goto*//*Label 34851*/ GIMT_Encode4(2411001),
     /* 2410786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2410789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2410792 */   GIM_Try, /*On fail goto*//*Label 34852*/ GIMT_Encode4(2410844), // Rule ID 33440 //
     /* 2410797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410822 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410827 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410842 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410843 */     // GIR_Coverage, 33440,
     /* 2410843 */     GIR_EraseRootFromParent_Done,
     /* 2410844 */   // Label 34852: @2410844
     /* 2410844 */   GIM_Try, /*On fail goto*//*Label 34853*/ GIMT_Encode4(2410896), // Rule ID 33441 //
     /* 2410849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410867 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410874 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$passthru, VRM4:{ *:[nxv16i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410879 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410881 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410895 */     // GIR_Coverage, 33441,
     /* 2410895 */     GIR_EraseRootFromParent_Done,
     /* 2410896 */   // Label 34853: @2410896
     /* 2410896 */   GIM_Try, /*On fail goto*//*Label 34854*/ GIMT_Encode4(2410948), // Rule ID 34790 //
     /* 2410901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2410904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2410907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410919 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410926 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2410926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410931 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410933 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410946 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410947 */     // GIR_Coverage, 34790,
     /* 2410947 */     GIR_EraseRootFromParent_Done,
     /* 2410948 */   // Label 34854: @2410948
     /* 2410948 */   GIM_Try, /*On fail goto*//*Label 34855*/ GIMT_Encode4(2411000), // Rule ID 34791 //
     /* 2410953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2410956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2410959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2410971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2410978 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$passthru, VRM4:{ *:[nxv16f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2410978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2410981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2410983 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2410985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2410987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2410992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2410995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2410998 */     GIR_RootConstrainSelectedInstOperands,
     /* 2410999 */     // GIR_Coverage, 34791,
     /* 2410999 */     GIR_EraseRootFromParent_Done,
     /* 2411000 */   // Label 34855: @2411000
     /* 2411000 */   GIM_Reject,
     /* 2411001 */ // Label 34851: @2411001
     /* 2411001 */ GIM_Reject,
     /* 2411002 */ // Label 34771: @2411002
     /* 2411002 */ GIM_Try, /*On fail goto*//*Label 34856*/ GIMT_Encode4(2411222),
     /* 2411007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2411010 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2411013 */   GIM_Try, /*On fail goto*//*Label 34857*/ GIMT_Encode4(2411065), // Rule ID 33800 //
     /* 2411018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411036 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411043 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411048 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411050 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411063 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411064 */     // GIR_Coverage, 33800,
     /* 2411064 */     GIR_EraseRootFromParent_Done,
     /* 2411065 */   // Label 34857: @2411065
     /* 2411065 */   GIM_Try, /*On fail goto*//*Label 34858*/ GIMT_Encode4(2411117), // Rule ID 33801 //
     /* 2411070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411095 */     // (riscv_vmv_v_v_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$passthru, VRM8:{ *:[nxv16i32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411100 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411102 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411115 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411116 */     // GIR_Coverage, 33801,
     /* 2411116 */     GIR_EraseRootFromParent_Done,
     /* 2411117 */   // Label 34858: @2411117
     /* 2411117 */   GIM_Try, /*On fail goto*//*Label 34859*/ GIMT_Encode4(2411169), // Rule ID 35150 //
     /* 2411122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411147 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411152 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411167 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411168 */     // GIR_Coverage, 35150,
     /* 2411168 */     GIR_EraseRootFromParent_Done,
     /* 2411169 */   // Label 34859: @2411169
     /* 2411169 */   GIM_Try, /*On fail goto*//*Label 34860*/ GIMT_Encode4(2411221), // Rule ID 35151 //
     /* 2411174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411199 */     // (riscv_vmv_v_v_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$passthru, VRM8:{ *:[nxv16f32] }:$rs2, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411204 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411206 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2411216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411219 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411220 */     // GIR_Coverage, 35151,
     /* 2411220 */     GIR_EraseRootFromParent_Done,
     /* 2411221 */   // Label 34860: @2411221
     /* 2411221 */   GIM_Reject,
     /* 2411222 */ // Label 34856: @2411222
     /* 2411222 */ GIM_Reject,
     /* 2411223 */ // Label 34772: @2411223
     /* 2411223 */ GIM_Try, /*On fail goto*//*Label 34861*/ GIMT_Encode4(2411339),
     /* 2411228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2411231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2411234 */   GIM_Try, /*On fail goto*//*Label 34862*/ GIMT_Encode4(2411286), // Rule ID 33170 //
     /* 2411239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411257 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411264 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2411267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411269 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411271 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411284 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411285 */     // GIR_Coverage, 33170,
     /* 2411285 */     GIR_EraseRootFromParent_Done,
     /* 2411286 */   // Label 34862: @2411286
     /* 2411286 */   GIM_Try, /*On fail goto*//*Label 34863*/ GIMT_Encode4(2411338), // Rule ID 33171 //
     /* 2411291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2411309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411316 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M4:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$passthru, VRM4:{ *:[nxv32i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M4),
     /* 2411319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411321 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411336 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411337 */     // GIR_Coverage, 33171,
     /* 2411337 */     GIR_EraseRootFromParent_Done,
     /* 2411338 */   // Label 34863: @2411338
     /* 2411338 */   GIM_Reject,
     /* 2411339 */ // Label 34861: @2411339
     /* 2411339 */ GIM_Reject,
     /* 2411340 */ // Label 34773: @2411340
     /* 2411340 */ GIM_Try, /*On fail goto*//*Label 34864*/ GIMT_Encode4(2411560),
     /* 2411345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2411348 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2411351 */   GIM_Try, /*On fail goto*//*Label 34865*/ GIMT_Encode4(2411403), // Rule ID 33530 //
     /* 2411356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411381 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411386 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411388 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411401 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411402 */     // GIR_Coverage, 33530,
     /* 2411402 */     GIR_EraseRootFromParent_Done,
     /* 2411403 */   // Label 34865: @2411403
     /* 2411403 */   GIM_Try, /*On fail goto*//*Label 34866*/ GIMT_Encode4(2411455), // Rule ID 33531 //
     /* 2411408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411426 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411433 */     // (riscv_vmv_v_v_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$passthru, VRM8:{ *:[nxv32i16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411438 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411440 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411453 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411454 */     // GIR_Coverage, 33531,
     /* 2411454 */     GIR_EraseRootFromParent_Done,
     /* 2411455 */   // Label 34866: @2411455
     /* 2411455 */   GIM_Try, /*On fail goto*//*Label 34867*/ GIMT_Encode4(2411507), // Rule ID 34880 //
     /* 2411460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411478 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411485 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411490 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411492 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411505 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411506 */     // GIR_Coverage, 34880,
     /* 2411506 */     GIR_EraseRootFromParent_Done,
     /* 2411507 */   // Label 34867: @2411507
     /* 2411507 */   GIM_Try, /*On fail goto*//*Label 34868*/ GIMT_Encode4(2411559), // Rule ID 34881 //
     /* 2411512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411530 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411537 */     // (riscv_vmv_v_v_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$passthru, VRM8:{ *:[nxv32f16] }:$rs2, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411542 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411544 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2411554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411557 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411558 */     // GIR_Coverage, 34881,
     /* 2411558 */     GIR_EraseRootFromParent_Done,
     /* 2411559 */   // Label 34868: @2411559
     /* 2411559 */   GIM_Reject,
     /* 2411560 */ // Label 34864: @2411560
     /* 2411560 */ GIM_Reject,
     /* 2411561 */ // Label 34774: @2411561
     /* 2411561 */ GIM_Try, /*On fail goto*//*Label 34869*/ GIMT_Encode4(2411677),
     /* 2411566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2411569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2411572 */   GIM_Try, /*On fail goto*//*Label 34870*/ GIMT_Encode4(2411624), // Rule ID 33260 //
     /* 2411577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411595 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411602 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, 0:{ *:[i64] })
     /* 2411602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411607 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411609 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411616 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411622 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411623 */     // GIR_Coverage, 33260,
     /* 2411623 */     GIR_EraseRootFromParent_Done,
     /* 2411624 */   // Label 34870: @2411624
     /* 2411624 */   GIM_Try, /*On fail goto*//*Label 34871*/ GIMT_Encode4(2411676), // Rule ID 33261 //
     /* 2411629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2411647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411654 */     // (riscv_vmv_v_v_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl))  =>  (PseudoVMV_V_V_M8:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$passthru, VRM8:{ *:[nxv64i8] }:$rs2, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, 0:{ *:[i32] })
     /* 2411654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVMV_V_V_M8),
     /* 2411657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411659 */     GIR_RootToRootCopy, /*OpIdx*/1, // passthru
     /* 2411661 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs2
     /* 2411663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 2411674 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411675 */     // GIR_Coverage, 33261,
     /* 2411675 */     GIR_EraseRootFromParent_Done,
     /* 2411676 */   // Label 34871: @2411676
     /* 2411676 */   GIM_Reject,
     /* 2411677 */ // Label 34869: @2411677
     /* 2411677 */ GIM_Reject,
     /* 2411678 */ // Label 34775: @2411678
     /* 2411678 */ GIM_Reject,
     /* 2411679 */ // Label 123: @2411679
     /* 2411679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 34894*/ GIMT_Encode4(2423558),
     /* 2411690 */ /*GILLT_nxv1s8*//*Label 34872*/ GIMT_Encode4(2411802),
     /* 2411694 */ /*GILLT_nxv1s16*//*Label 34873*/ GIMT_Encode4(2412125),
     /* 2411698 */ /*GILLT_nxv1s32*//*Label 34874*/ GIMT_Encode4(2412758),
     /* 2411702 */ /*GILLT_nxv1s64*//*Label 34875*/ GIMT_Encode4(2413391), GIMT_Encode4(0),
     /* 2411710 */ /*GILLT_nxv2s8*//*Label 34876*/ GIMT_Encode4(2414024),
     /* 2411714 */ /*GILLT_nxv2s16*//*Label 34877*/ GIMT_Encode4(2414347),
     /* 2411718 */ /*GILLT_nxv2s32*//*Label 34878*/ GIMT_Encode4(2414980),
     /* 2411722 */ /*GILLT_nxv2s64*//*Label 34879*/ GIMT_Encode4(2415613), GIMT_Encode4(0),
     /* 2411730 */ /*GILLT_nxv4s8*//*Label 34880*/ GIMT_Encode4(2416246),
     /* 2411734 */ /*GILLT_nxv4s16*//*Label 34881*/ GIMT_Encode4(2416569),
     /* 2411738 */ /*GILLT_nxv4s32*//*Label 34882*/ GIMT_Encode4(2417202),
     /* 2411742 */ /*GILLT_nxv4s64*//*Label 34883*/ GIMT_Encode4(2417835), GIMT_Encode4(0),
     /* 2411750 */ /*GILLT_nxv8s8*//*Label 34884*/ GIMT_Encode4(2418468),
     /* 2411754 */ /*GILLT_nxv8s16*//*Label 34885*/ GIMT_Encode4(2418791),
     /* 2411758 */ /*GILLT_nxv8s32*//*Label 34886*/ GIMT_Encode4(2419424),
     /* 2411762 */ /*GILLT_nxv8s64*//*Label 34887*/ GIMT_Encode4(2420057), GIMT_Encode4(0),
     /* 2411770 */ /*GILLT_nxv16s8*//*Label 34888*/ GIMT_Encode4(2420690),
     /* 2411774 */ /*GILLT_nxv16s16*//*Label 34889*/ GIMT_Encode4(2421013),
     /* 2411778 */ /*GILLT_nxv16s32*//*Label 34890*/ GIMT_Encode4(2421646), GIMT_Encode4(0),
     /* 2411786 */ /*GILLT_nxv32s8*//*Label 34891*/ GIMT_Encode4(2422279),
     /* 2411790 */ /*GILLT_nxv32s16*//*Label 34892*/ GIMT_Encode4(2422602), GIMT_Encode4(0),
     /* 2411798 */ /*GILLT_nxv64s8*//*Label 34893*/ GIMT_Encode4(2423235),
     /* 2411802 */ // Label 34872: @2411802
     /* 2411802 */ GIM_Try, /*On fail goto*//*Label 34895*/ GIMT_Encode4(2412124),
     /* 2411807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2411810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2411813 */   GIM_Try, /*On fail goto*//*Label 34896*/ GIMT_Encode4(2411896), // Rule ID 45324 //
     /* 2411818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2411827 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2411830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2411834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2411850 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2411854 */     // MIs[1] Operand 1
     /* 2411854 */     // No operand predicates
     /* 2411854 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2411858 */     // MIs[0] policy
     /* 2411858 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2411861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411870 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2411870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2411873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411875 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411877 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2411879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2411882 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2411884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411889 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411892 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2411894 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411895 */     // GIR_Coverage, 45324,
     /* 2411895 */     GIR_EraseRootFromParent_Done,
     /* 2411896 */   // Label 34896: @2411896
     /* 2411896 */   GIM_Try, /*On fail goto*//*Label 34897*/ GIMT_Encode4(2411979), // Rule ID 45325 //
     /* 2411901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2411904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2411907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2411910 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2411913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2411917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411921 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2411925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2411929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2411933 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2411937 */     // MIs[1] Operand 1
     /* 2411937 */     // No operand predicates
     /* 2411937 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2411941 */     // MIs[0] policy
     /* 2411941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2411944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2411946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2411953 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2411953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF8_MASK),
     /* 2411956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2411958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2411960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2411962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2411965 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2411967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2411972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2411975 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2411977 */     GIR_RootConstrainSelectedInstOperands,
     /* 2411978 */     // GIR_Coverage, 45325,
     /* 2411978 */     GIR_EraseRootFromParent_Done,
     /* 2411979 */   // Label 34897: @2411979
     /* 2411979 */   GIM_Try, /*On fail goto*//*Label 34898*/ GIMT_Encode4(2412051), // Rule ID 45326 //
     /* 2411984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2411987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2411990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2411993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2411996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412012 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412016 */     // MIs[0] policy
     /* 2412016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412019 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412026 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2412029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412031 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412033 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412035 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2412047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412050 */     // GIR_Coverage, 45326,
     /* 2412050 */     GIR_EraseRootFromParent_Done,
     /* 2412051 */   // Label 34898: @2412051
     /* 2412051 */   GIM_Try, /*On fail goto*//*Label 34899*/ GIMT_Encode4(2412123), // Rule ID 45327 //
     /* 2412056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412084 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412088 */     // MIs[0] policy
     /* 2412088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412098 */     // (riscv_slidedown_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF8_MASK),
     /* 2412101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412103 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412105 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412107 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412109 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2412119 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412121 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412122 */     // GIR_Coverage, 45327,
     /* 2412122 */     GIR_EraseRootFromParent_Done,
     /* 2412123 */   // Label 34899: @2412123
     /* 2412123 */   GIM_Reject,
     /* 2412124 */ // Label 34895: @2412124
     /* 2412124 */ GIM_Reject,
     /* 2412125 */ // Label 34873: @2412125
     /* 2412125 */ GIM_Try, /*On fail goto*//*Label 34900*/ GIMT_Encode4(2412757),
     /* 2412130 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2412133 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2412136 */   GIM_Try, /*On fail goto*//*Label 34901*/ GIMT_Encode4(2412219), // Rule ID 45336 //
     /* 2412141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412150 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412173 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412177 */     // MIs[1] Operand 1
     /* 2412177 */     // No operand predicates
     /* 2412177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412181 */     // MIs[0] policy
     /* 2412181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412193 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2412196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412198 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412200 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412205 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412215 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412217 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412218 */     // GIR_Coverage, 45336,
     /* 2412218 */     GIR_EraseRootFromParent_Done,
     /* 2412219 */   // Label 34901: @2412219
     /* 2412219 */   GIM_Try, /*On fail goto*//*Label 34902*/ GIMT_Encode4(2412302), // Rule ID 45337 //
     /* 2412224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412256 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412260 */     // MIs[1] Operand 1
     /* 2412260 */     // No operand predicates
     /* 2412260 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412264 */     // MIs[0] policy
     /* 2412264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412267 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412269 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412276 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2412279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412281 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412283 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412301 */     // GIR_Coverage, 45337,
     /* 2412301 */     GIR_EraseRootFromParent_Done,
     /* 2412302 */   // Label 34902: @2412302
     /* 2412302 */   GIM_Try, /*On fail goto*//*Label 34903*/ GIMT_Encode4(2412385), // Rule ID 45412 //
     /* 2412307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412339 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412343 */     // MIs[1] Operand 1
     /* 2412343 */     // No operand predicates
     /* 2412343 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412347 */     // MIs[0] policy
     /* 2412347 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412352 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412359 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2412362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412364 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412366 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412371 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412373 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412381 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412383 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412384 */     // GIR_Coverage, 45412,
     /* 2412384 */     GIR_EraseRootFromParent_Done,
     /* 2412385 */   // Label 34903: @2412385
     /* 2412385 */   GIM_Try, /*On fail goto*//*Label 34904*/ GIMT_Encode4(2412468), // Rule ID 45413 //
     /* 2412390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412422 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412426 */     // MIs[1] Operand 1
     /* 2412426 */     // No operand predicates
     /* 2412426 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412430 */     // MIs[0] policy
     /* 2412430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412442 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2412445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412454 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412464 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412466 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412467 */     // GIR_Coverage, 45413,
     /* 2412467 */     GIR_EraseRootFromParent_Done,
     /* 2412468 */   // Label 34904: @2412468
     /* 2412468 */   GIM_Try, /*On fail goto*//*Label 34905*/ GIMT_Encode4(2412540), // Rule ID 45338 //
     /* 2412473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412482 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412489 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412505 */     // MIs[0] policy
     /* 2412505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412508 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412515 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2412518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412520 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412522 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412524 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412526 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412528 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412536 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412538 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412539 */     // GIR_Coverage, 45338,
     /* 2412539 */     GIR_EraseRootFromParent_Done,
     /* 2412540 */   // Label 34905: @2412540
     /* 2412540 */   GIM_Try, /*On fail goto*//*Label 34906*/ GIMT_Encode4(2412612), // Rule ID 45339 //
     /* 2412545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412573 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412577 */     // MIs[0] policy
     /* 2412577 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412580 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412587 */     // (riscv_slidedown_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2412590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412592 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412594 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412596 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412598 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412608 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412610 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412611 */     // GIR_Coverage, 45339,
     /* 2412611 */     GIR_EraseRootFromParent_Done,
     /* 2412612 */   // Label 34906: @2412612
     /* 2412612 */   GIM_Try, /*On fail goto*//*Label 34907*/ GIMT_Encode4(2412684), // Rule ID 45414 //
     /* 2412617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412620 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412623 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412626 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412645 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412649 */     // MIs[0] policy
     /* 2412649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412652 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412659 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2412662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412664 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412666 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412668 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412683 */     // GIR_Coverage, 45414,
     /* 2412683 */     GIR_EraseRootFromParent_Done,
     /* 2412684 */   // Label 34907: @2412684
     /* 2412684 */   GIM_Try, /*On fail goto*//*Label 34908*/ GIMT_Encode4(2412756), // Rule ID 45415 //
     /* 2412689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2412717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412721 */     // MIs[0] policy
     /* 2412721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412724 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412731 */     // (riscv_slidedown_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2412734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412736 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412738 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412740 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2412742 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2412752 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412754 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412755 */     // GIR_Coverage, 45415,
     /* 2412755 */     GIR_EraseRootFromParent_Done,
     /* 2412756 */   // Label 34908: @2412756
     /* 2412756 */   GIM_Reject,
     /* 2412757 */ // Label 34900: @2412757
     /* 2412757 */ GIM_Reject,
     /* 2412758 */ // Label 34874: @2412758
     /* 2412758 */ GIM_Try, /*On fail goto*//*Label 34909*/ GIMT_Encode4(2413390),
     /* 2412763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2412766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2412769 */   GIM_Try, /*On fail goto*//*Label 34910*/ GIMT_Encode4(2412852), // Rule ID 45344 //
     /* 2412774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412806 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412810 */     // MIs[1] Operand 1
     /* 2412810 */     // No operand predicates
     /* 2412810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412814 */     // MIs[0] policy
     /* 2412814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412819 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412826 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2412829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412831 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412833 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412838 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412848 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412850 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412851 */     // GIR_Coverage, 45344,
     /* 2412851 */     GIR_EraseRootFromParent_Done,
     /* 2412852 */   // Label 34910: @2412852
     /* 2412852 */   GIM_Try, /*On fail goto*//*Label 34911*/ GIMT_Encode4(2412935), // Rule ID 45345 //
     /* 2412857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2412860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2412863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412866 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2412869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412889 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412893 */     // MIs[1] Operand 1
     /* 2412893 */     // No operand predicates
     /* 2412893 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412897 */     // MIs[0] policy
     /* 2412897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412909 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2412909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2412912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412914 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412916 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2412918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2412921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2412923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2412928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2412931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2412933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2412934 */     // GIR_Coverage, 45345,
     /* 2412934 */     GIR_EraseRootFromParent_Done,
     /* 2412935 */   // Label 34911: @2412935
     /* 2412935 */   GIM_Try, /*On fail goto*//*Label 34912*/ GIMT_Encode4(2413018), // Rule ID 45420 //
     /* 2412940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2412943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2412946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2412949 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2412952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2412956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2412964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2412968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2412972 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2412976 */     // MIs[1] Operand 1
     /* 2412976 */     // No operand predicates
     /* 2412976 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2412980 */     // MIs[0] policy
     /* 2412980 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2412983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2412985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2412992 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2412992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2412995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2412997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2412999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413004 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413014 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413016 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413017 */     // GIR_Coverage, 45420,
     /* 2413017 */     GIR_EraseRootFromParent_Done,
     /* 2413018 */   // Label 34912: @2413018
     /* 2413018 */   GIM_Try, /*On fail goto*//*Label 34913*/ GIMT_Encode4(2413101), // Rule ID 45421 //
     /* 2413023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2413055 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2413059 */     // MIs[1] Operand 1
     /* 2413059 */     // No operand predicates
     /* 2413059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413063 */     // MIs[0] policy
     /* 2413063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413075 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2413078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413087 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413097 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413099 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413100 */     // GIR_Coverage, 45421,
     /* 2413100 */     GIR_EraseRootFromParent_Done,
     /* 2413101 */   // Label 34913: @2413101
     /* 2413101 */   GIM_Try, /*On fail goto*//*Label 34914*/ GIMT_Encode4(2413173), // Rule ID 45346 //
     /* 2413106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413138 */     // MIs[0] policy
     /* 2413138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413141 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413148 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2413151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413153 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413155 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413157 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413159 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413169 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413171 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413172 */     // GIR_Coverage, 45346,
     /* 2413172 */     GIR_EraseRootFromParent_Done,
     /* 2413173 */   // Label 34914: @2413173
     /* 2413173 */   GIM_Try, /*On fail goto*//*Label 34915*/ GIMT_Encode4(2413245), // Rule ID 45347 //
     /* 2413178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413187 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413206 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413210 */     // MIs[0] policy
     /* 2413210 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413213 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413220 */     // (riscv_slidedown_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2413223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413225 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413227 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413229 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413231 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413241 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413243 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413244 */     // GIR_Coverage, 45347,
     /* 2413244 */     GIR_EraseRootFromParent_Done,
     /* 2413245 */   // Label 34915: @2413245
     /* 2413245 */   GIM_Try, /*On fail goto*//*Label 34916*/ GIMT_Encode4(2413317), // Rule ID 45422 //
     /* 2413250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2413253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413282 */     // MIs[0] policy
     /* 2413282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413285 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413292 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2413295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413297 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413299 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413301 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413316 */     // GIR_Coverage, 45422,
     /* 2413316 */     GIR_EraseRootFromParent_Done,
     /* 2413317 */   // Label 34916: @2413317
     /* 2413317 */   GIM_Try, /*On fail goto*//*Label 34917*/ GIMT_Encode4(2413389), // Rule ID 45423 //
     /* 2413322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2413325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413350 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413354 */     // MIs[0] policy
     /* 2413354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413357 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413364 */     // (riscv_slidedown_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2413367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413369 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413371 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413373 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413375 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2413385 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413387 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413388 */     // GIR_Coverage, 45423,
     /* 2413388 */     GIR_EraseRootFromParent_Done,
     /* 2413389 */   // Label 34917: @2413389
     /* 2413389 */   GIM_Reject,
     /* 2413390 */ // Label 34909: @2413390
     /* 2413390 */ GIM_Reject,
     /* 2413391 */ // Label 34875: @2413391
     /* 2413391 */ GIM_Try, /*On fail goto*//*Label 34918*/ GIMT_Encode4(2414023),
     /* 2413396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2413399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2413402 */   GIM_Try, /*On fail goto*//*Label 34919*/ GIMT_Encode4(2413485), // Rule ID 45360 //
     /* 2413407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413416 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2413439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2413443 */     // MIs[1] Operand 1
     /* 2413443 */     // No operand predicates
     /* 2413443 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413447 */     // MIs[0] policy
     /* 2413447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413459 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2413462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413471 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413481 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413483 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413484 */     // GIR_Coverage, 45360,
     /* 2413484 */     GIR_EraseRootFromParent_Done,
     /* 2413485 */   // Label 34919: @2413485
     /* 2413485 */   GIM_Try, /*On fail goto*//*Label 34920*/ GIMT_Encode4(2413568), // Rule ID 45361 //
     /* 2413490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413499 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2413522 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2413526 */     // MIs[1] Operand 1
     /* 2413526 */     // No operand predicates
     /* 2413526 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413530 */     // MIs[0] policy
     /* 2413530 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413542 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2413545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413567 */     // GIR_Coverage, 45361,
     /* 2413567 */     GIR_EraseRootFromParent_Done,
     /* 2413568 */   // Label 34920: @2413568
     /* 2413568 */   GIM_Try, /*On fail goto*//*Label 34921*/ GIMT_Encode4(2413651), // Rule ID 45432 //
     /* 2413573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413582 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413589 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2413605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2413609 */     // MIs[1] Operand 1
     /* 2413609 */     // No operand predicates
     /* 2413609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413613 */     // MIs[0] policy
     /* 2413613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413618 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413625 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2413628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413630 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413632 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413637 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413647 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413649 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413650 */     // GIR_Coverage, 45432,
     /* 2413650 */     GIR_EraseRootFromParent_Done,
     /* 2413651 */   // Label 34921: @2413651
     /* 2413651 */   GIM_Try, /*On fail goto*//*Label 34922*/ GIMT_Encode4(2413734), // Rule ID 45433 //
     /* 2413656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413665 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2413684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2413688 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2413692 */     // MIs[1] Operand 1
     /* 2413692 */     // No operand predicates
     /* 2413692 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413696 */     // MIs[0] policy
     /* 2413696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2413701 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413708 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2413711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413713 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413715 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2413720 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413730 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413732 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413733 */     // GIR_Coverage, 45433,
     /* 2413733 */     GIR_EraseRootFromParent_Done,
     /* 2413734 */   // Label 34922: @2413734
     /* 2413734 */   GIM_Try, /*On fail goto*//*Label 34923*/ GIMT_Encode4(2413806), // Rule ID 45362 //
     /* 2413739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413748 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413771 */     // MIs[0] policy
     /* 2413771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413774 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413781 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2413784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413786 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413788 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413790 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413792 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413802 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413804 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413805 */     // GIR_Coverage, 45362,
     /* 2413805 */     GIR_EraseRootFromParent_Done,
     /* 2413806 */   // Label 34923: @2413806
     /* 2413806 */   GIM_Try, /*On fail goto*//*Label 34924*/ GIMT_Encode4(2413878), // Rule ID 45363 //
     /* 2413811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413839 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413843 */     // MIs[0] policy
     /* 2413843 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413846 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413853 */     // (riscv_slidedown_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2413856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413858 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413860 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413862 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413864 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413874 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413876 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413877 */     // GIR_Coverage, 45363,
     /* 2413877 */     GIR_EraseRootFromParent_Done,
     /* 2413878 */   // Label 34924: @2413878
     /* 2413878 */   GIM_Try, /*On fail goto*//*Label 34925*/ GIMT_Encode4(2413950), // Rule ID 45434 //
     /* 2413883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2413886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2413889 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413892 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2413895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413899 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413915 */     // MIs[0] policy
     /* 2413915 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413918 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413925 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2413925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2413928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2413930 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2413932 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2413934 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2413936 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2413938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2413943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2413946 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2413948 */     GIR_RootConstrainSelectedInstOperands,
     /* 2413949 */     // GIR_Coverage, 45434,
     /* 2413949 */     GIR_EraseRootFromParent_Done,
     /* 2413950 */   // Label 34925: @2413950
     /* 2413950 */   GIM_Try, /*On fail goto*//*Label 34926*/ GIMT_Encode4(2414022), // Rule ID 45435 //
     /* 2413955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2413958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2413961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2413964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2413967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2413971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2413979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2413983 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2413987 */     // MIs[0] policy
     /* 2413987 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2413990 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2413997 */     // (riscv_slidedown_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2413997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2414000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414002 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414004 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414006 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414008 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2414018 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414020 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414021 */     // GIR_Coverage, 45435,
     /* 2414021 */     GIR_EraseRootFromParent_Done,
     /* 2414022 */   // Label 34926: @2414022
     /* 2414022 */   GIM_Reject,
     /* 2414023 */ // Label 34918: @2414023
     /* 2414023 */ GIM_Reject,
     /* 2414024 */ // Label 34876: @2414024
     /* 2414024 */ GIM_Try, /*On fail goto*//*Label 34927*/ GIMT_Encode4(2414346),
     /* 2414029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2414032 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2414035 */   GIM_Try, /*On fail goto*//*Label 34928*/ GIMT_Encode4(2414118), // Rule ID 45328 //
     /* 2414040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414064 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414068 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414072 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414076 */     // MIs[1] Operand 1
     /* 2414076 */     // No operand predicates
     /* 2414076 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414080 */     // MIs[0] policy
     /* 2414080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414083 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414085 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414092 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2414095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414097 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414099 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414104 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414111 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414114 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414116 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414117 */     // GIR_Coverage, 45328,
     /* 2414117 */     GIR_EraseRootFromParent_Done,
     /* 2414118 */   // Label 34928: @2414118
     /* 2414118 */   GIM_Try, /*On fail goto*//*Label 34929*/ GIMT_Encode4(2414201), // Rule ID 45329 //
     /* 2414123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414155 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414159 */     // MIs[1] Operand 1
     /* 2414159 */     // No operand predicates
     /* 2414159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414163 */     // MIs[0] policy
     /* 2414163 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414175 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF4_MASK),
     /* 2414178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414187 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414189 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414197 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414199 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414200 */     // GIR_Coverage, 45329,
     /* 2414200 */     GIR_EraseRootFromParent_Done,
     /* 2414201 */   // Label 34929: @2414201
     /* 2414201 */   GIM_Try, /*On fail goto*//*Label 34930*/ GIMT_Encode4(2414273), // Rule ID 45330 //
     /* 2414206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414215 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414234 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414238 */     // MIs[0] policy
     /* 2414238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414248 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2414251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414253 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414255 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414257 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414272 */     // GIR_Coverage, 45330,
     /* 2414272 */     GIR_EraseRootFromParent_Done,
     /* 2414273 */   // Label 34930: @2414273
     /* 2414273 */   GIM_Try, /*On fail goto*//*Label 34931*/ GIMT_Encode4(2414345), // Rule ID 45331 //
     /* 2414278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414310 */     // MIs[0] policy
     /* 2414310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414320 */     // (riscv_slidedown_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF4_MASK),
     /* 2414323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414325 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414327 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414329 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414331 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414333 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2414341 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414343 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414344 */     // GIR_Coverage, 45331,
     /* 2414344 */     GIR_EraseRootFromParent_Done,
     /* 2414345 */   // Label 34931: @2414345
     /* 2414345 */   GIM_Reject,
     /* 2414346 */ // Label 34927: @2414346
     /* 2414346 */ GIM_Reject,
     /* 2414347 */ // Label 34877: @2414347
     /* 2414347 */ GIM_Try, /*On fail goto*//*Label 34932*/ GIMT_Encode4(2414979),
     /* 2414352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2414355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2414358 */   GIM_Try, /*On fail goto*//*Label 34933*/ GIMT_Encode4(2414441), // Rule ID 45340 //
     /* 2414363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414372 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414395 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414399 */     // MIs[1] Operand 1
     /* 2414399 */     // No operand predicates
     /* 2414399 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414403 */     // MIs[0] policy
     /* 2414403 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414415 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2414418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414420 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414422 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414427 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414429 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414437 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414439 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414440 */     // GIR_Coverage, 45340,
     /* 2414440 */     GIR_EraseRootFromParent_Done,
     /* 2414441 */   // Label 34933: @2414441
     /* 2414441 */   GIM_Try, /*On fail goto*//*Label 34934*/ GIMT_Encode4(2414524), // Rule ID 45341 //
     /* 2414446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414455 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414482 */     // MIs[1] Operand 1
     /* 2414482 */     // No operand predicates
     /* 2414482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414486 */     // MIs[0] policy
     /* 2414486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414498 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2414501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414503 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414505 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414523 */     // GIR_Coverage, 45341,
     /* 2414523 */     GIR_EraseRootFromParent_Done,
     /* 2414524 */   // Label 34934: @2414524
     /* 2414524 */   GIM_Try, /*On fail goto*//*Label 34935*/ GIMT_Encode4(2414607), // Rule ID 45416 //
     /* 2414529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414565 */     // MIs[1] Operand 1
     /* 2414565 */     // No operand predicates
     /* 2414565 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414569 */     // MIs[0] policy
     /* 2414569 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414574 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414581 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2414584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414586 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414588 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414593 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414603 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414606 */     // GIR_Coverage, 45416,
     /* 2414606 */     GIR_EraseRootFromParent_Done,
     /* 2414607 */   // Label 34935: @2414607
     /* 2414607 */   GIM_Try, /*On fail goto*//*Label 34936*/ GIMT_Encode4(2414690), // Rule ID 45417 //
     /* 2414612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2414640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2414644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2414648 */     // MIs[1] Operand 1
     /* 2414648 */     // No operand predicates
     /* 2414648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414652 */     // MIs[0] policy
     /* 2414652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2414657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414664 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2414667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2414676 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414686 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414688 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414689 */     // GIR_Coverage, 45417,
     /* 2414689 */     GIR_EraseRootFromParent_Done,
     /* 2414690 */   // Label 34936: @2414690
     /* 2414690 */   GIM_Try, /*On fail goto*//*Label 34937*/ GIMT_Encode4(2414762), // Rule ID 45342 //
     /* 2414695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414704 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414727 */     // MIs[0] policy
     /* 2414727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414730 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414737 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2414740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414742 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414744 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414746 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414748 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414755 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414758 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414760 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414761 */     // GIR_Coverage, 45342,
     /* 2414761 */     GIR_EraseRootFromParent_Done,
     /* 2414762 */   // Label 34937: @2414762
     /* 2414762 */   GIM_Try, /*On fail goto*//*Label 34938*/ GIMT_Encode4(2414834), // Rule ID 45343 //
     /* 2414767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414795 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414799 */     // MIs[0] policy
     /* 2414799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414802 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414809 */     // (riscv_slidedown_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2414812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414814 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414816 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414818 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414820 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414822 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414830 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414832 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414833 */     // GIR_Coverage, 45343,
     /* 2414833 */     GIR_EraseRootFromParent_Done,
     /* 2414834 */   // Label 34938: @2414834
     /* 2414834 */   GIM_Try, /*On fail goto*//*Label 34939*/ GIMT_Encode4(2414906), // Rule ID 45418 //
     /* 2414839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2414845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414848 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2414851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414867 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414871 */     // MIs[0] policy
     /* 2414871 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414881 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2414881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2414884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414886 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414888 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414890 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414905 */     // GIR_Coverage, 45418,
     /* 2414905 */     GIR_EraseRootFromParent_Done,
     /* 2414906 */   // Label 34939: @2414906
     /* 2414906 */   GIM_Try, /*On fail goto*//*Label 34940*/ GIMT_Encode4(2414978), // Rule ID 45419 //
     /* 2414911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2414914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2414917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2414920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2414923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2414927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2414935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2414939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2414943 */     // MIs[0] policy
     /* 2414943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2414946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2414953 */     // (riscv_slidedown_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2414953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2414956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2414958 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2414960 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2414962 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2414964 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2414966 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2414971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2414974 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2414976 */     GIR_RootConstrainSelectedInstOperands,
     /* 2414977 */     // GIR_Coverage, 45419,
     /* 2414977 */     GIR_EraseRootFromParent_Done,
     /* 2414978 */   // Label 34940: @2414978
     /* 2414978 */   GIM_Reject,
     /* 2414979 */ // Label 34932: @2414979
     /* 2414979 */ GIM_Reject,
     /* 2414980 */ // Label 34878: @2414980
     /* 2414980 */ GIM_Try, /*On fail goto*//*Label 34941*/ GIMT_Encode4(2415612),
     /* 2414985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2414988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2414991 */   GIM_Try, /*On fail goto*//*Label 34942*/ GIMT_Encode4(2415074), // Rule ID 45356 //
     /* 2414996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2414999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415005 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415032 */     // MIs[1] Operand 1
     /* 2415032 */     // No operand predicates
     /* 2415032 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415036 */     // MIs[0] policy
     /* 2415036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415041 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415048 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2415051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415053 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415055 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415057 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415060 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415070 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415072 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415073 */     // GIR_Coverage, 45356,
     /* 2415073 */     GIR_EraseRootFromParent_Done,
     /* 2415074 */   // Label 34942: @2415074
     /* 2415074 */   GIM_Try, /*On fail goto*//*Label 34943*/ GIMT_Encode4(2415157), // Rule ID 45357 //
     /* 2415079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415111 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415115 */     // MIs[1] Operand 1
     /* 2415115 */     // No operand predicates
     /* 2415115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415119 */     // MIs[0] policy
     /* 2415119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415124 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415131 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2415134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415136 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415138 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415156 */     // GIR_Coverage, 45357,
     /* 2415156 */     GIR_EraseRootFromParent_Done,
     /* 2415157 */   // Label 34943: @2415157
     /* 2415157 */   GIM_Try, /*On fail goto*//*Label 34944*/ GIMT_Encode4(2415240), // Rule ID 45428 //
     /* 2415162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415171 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415178 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415194 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415198 */     // MIs[1] Operand 1
     /* 2415198 */     // No operand predicates
     /* 2415198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415202 */     // MIs[0] policy
     /* 2415202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415207 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415214 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2415217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415219 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415221 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415226 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415228 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415233 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415236 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415238 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415239 */     // GIR_Coverage, 45428,
     /* 2415239 */     GIR_EraseRootFromParent_Done,
     /* 2415240 */   // Label 34944: @2415240
     /* 2415240 */   GIM_Try, /*On fail goto*//*Label 34945*/ GIMT_Encode4(2415323), // Rule ID 45429 //
     /* 2415245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415254 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415277 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415281 */     // MIs[1] Operand 1
     /* 2415281 */     // No operand predicates
     /* 2415281 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415285 */     // MIs[0] policy
     /* 2415285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415288 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415297 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2415300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415309 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415319 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415321 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415322 */     // GIR_Coverage, 45429,
     /* 2415322 */     GIR_EraseRootFromParent_Done,
     /* 2415323 */   // Label 34945: @2415323
     /* 2415323 */   GIM_Try, /*On fail goto*//*Label 34946*/ GIMT_Encode4(2415395), // Rule ID 45358 //
     /* 2415328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2415356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415360 */     // MIs[0] policy
     /* 2415360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415363 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415370 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2415373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415375 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415377 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415379 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415381 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415383 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415391 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415393 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415394 */     // GIR_Coverage, 45358,
     /* 2415394 */     GIR_EraseRootFromParent_Done,
     /* 2415395 */   // Label 34946: @2415395
     /* 2415395 */   GIM_Try, /*On fail goto*//*Label 34947*/ GIMT_Encode4(2415467), // Rule ID 45359 //
     /* 2415400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415424 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2415428 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415432 */     // MIs[0] policy
     /* 2415432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415442 */     // (riscv_slidedown_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2415445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415447 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415449 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415451 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415453 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415455 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415460 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415463 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415465 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415466 */     // GIR_Coverage, 45359,
     /* 2415466 */     GIR_EraseRootFromParent_Done,
     /* 2415467 */   // Label 34947: @2415467
     /* 2415467 */   GIM_Try, /*On fail goto*//*Label 34948*/ GIMT_Encode4(2415539), // Rule ID 45430 //
     /* 2415472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2415475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2415500 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415504 */     // MIs[0] policy
     /* 2415504 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415514 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2415517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415519 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415521 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415523 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415525 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415535 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415537 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415538 */     // GIR_Coverage, 45430,
     /* 2415538 */     GIR_EraseRootFromParent_Done,
     /* 2415539 */   // Label 34948: @2415539
     /* 2415539 */   GIM_Try, /*On fail goto*//*Label 34949*/ GIMT_Encode4(2415611), // Rule ID 45431 //
     /* 2415544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2415547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415550 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415553 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2415560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2415568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2415572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415576 */     // MIs[0] policy
     /* 2415576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415579 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415586 */     // (riscv_slidedown_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2415589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415591 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415593 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415595 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2415597 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2415607 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415609 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415610 */     // GIR_Coverage, 45431,
     /* 2415610 */     GIR_EraseRootFromParent_Done,
     /* 2415611 */   // Label 34949: @2415611
     /* 2415611 */   GIM_Reject,
     /* 2415612 */ // Label 34941: @2415612
     /* 2415612 */ GIM_Reject,
     /* 2415613 */ // Label 34879: @2415613
     /* 2415613 */ GIM_Try, /*On fail goto*//*Label 34950*/ GIMT_Encode4(2416245),
     /* 2415618 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2415621 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2415624 */   GIM_Try, /*On fail goto*//*Label 34951*/ GIMT_Encode4(2415707), // Rule ID 45400 //
     /* 2415629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2415632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415638 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2415645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415661 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415665 */     // MIs[1] Operand 1
     /* 2415665 */     // No operand predicates
     /* 2415665 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415669 */     // MIs[0] policy
     /* 2415669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415672 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415674 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415681 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2415684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415686 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415688 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415690 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415693 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415700 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415703 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415705 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415706 */     // GIR_Coverage, 45400,
     /* 2415706 */     GIR_EraseRootFromParent_Done,
     /* 2415707 */   // Label 34951: @2415707
     /* 2415707 */   GIM_Try, /*On fail goto*//*Label 34952*/ GIMT_Encode4(2415790), // Rule ID 45401 //
     /* 2415712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2415715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415718 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415721 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2415728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415740 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415744 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415748 */     // MIs[1] Operand 1
     /* 2415748 */     // No operand predicates
     /* 2415748 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415752 */     // MIs[0] policy
     /* 2415752 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415764 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2415767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415776 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415786 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415788 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415789 */     // GIR_Coverage, 45401,
     /* 2415789 */     GIR_EraseRootFromParent_Done,
     /* 2415790 */   // Label 34952: @2415790
     /* 2415790 */   GIM_Try, /*On fail goto*//*Label 34953*/ GIMT_Encode4(2415873), // Rule ID 45460 //
     /* 2415795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2415798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415804 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2415811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415827 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415831 */     // MIs[1] Operand 1
     /* 2415831 */     // No operand predicates
     /* 2415831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415835 */     // MIs[0] policy
     /* 2415835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415840 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415847 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2415847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2415850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415852 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415854 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415859 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415869 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415871 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415872 */     // GIR_Coverage, 45460,
     /* 2415872 */     GIR_EraseRootFromParent_Done,
     /* 2415873 */   // Label 34953: @2415873
     /* 2415873 */   GIM_Try, /*On fail goto*//*Label 34954*/ GIMT_Encode4(2415956), // Rule ID 45461 //
     /* 2415878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2415881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2415884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2415890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2415894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2415906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2415910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2415914 */     // MIs[1] Operand 1
     /* 2415914 */     // No operand predicates
     /* 2415914 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415918 */     // MIs[0] policy
     /* 2415918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415921 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2415923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2415930 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2415930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2415933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2415935 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2415937 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2415939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2415942 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2415944 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2415949 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2415952 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2415954 */     GIR_RootConstrainSelectedInstOperands,
     /* 2415955 */     // GIR_Coverage, 45461,
     /* 2415955 */     GIR_EraseRootFromParent_Done,
     /* 2415956 */   // Label 34954: @2415956
     /* 2415956 */   GIM_Try, /*On fail goto*//*Label 34955*/ GIMT_Encode4(2416028), // Rule ID 45402 //
     /* 2415961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2415964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2415967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2415970 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2415973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2415977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2415985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2415989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2415993 */     // MIs[0] policy
     /* 2415993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2415996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416003 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2416006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416008 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416010 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416012 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416014 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416016 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416024 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416026 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416027 */     // GIR_Coverage, 45402,
     /* 2416027 */     GIR_EraseRootFromParent_Done,
     /* 2416028 */   // Label 34955: @2416028
     /* 2416028 */   GIM_Try, /*On fail goto*//*Label 34956*/ GIMT_Encode4(2416100), // Rule ID 45403 //
     /* 2416033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2416036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2416042 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2416049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416061 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416065 */     // MIs[0] policy
     /* 2416065 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416075 */     // (riscv_slidedown_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2416078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416080 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416082 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416084 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416086 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416096 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416098 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416099 */     // GIR_Coverage, 45403,
     /* 2416099 */     GIR_EraseRootFromParent_Done,
     /* 2416100 */   // Label 34956: @2416100
     /* 2416100 */   GIM_Try, /*On fail goto*//*Label 34957*/ GIMT_Encode4(2416172), // Rule ID 45462 //
     /* 2416105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2416108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2416114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2416121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416133 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416137 */     // MIs[0] policy
     /* 2416137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416147 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2416150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416152 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416154 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416156 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416158 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416168 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416170 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416171 */     // GIR_Coverage, 45462,
     /* 2416171 */     GIR_EraseRootFromParent_Done,
     /* 2416172 */   // Label 34957: @2416172
     /* 2416172 */   GIM_Try, /*On fail goto*//*Label 34958*/ GIMT_Encode4(2416244), // Rule ID 45463 //
     /* 2416177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2416180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2416186 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2416193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2416201 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416205 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416209 */     // MIs[0] policy
     /* 2416209 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416212 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416219 */     // (riscv_slidedown_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2416222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416224 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416226 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416228 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416230 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2416240 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416242 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416243 */     // GIR_Coverage, 45463,
     /* 2416243 */     GIR_EraseRootFromParent_Done,
     /* 2416244 */   // Label 34958: @2416244
     /* 2416244 */   GIM_Reject,
     /* 2416245 */ // Label 34950: @2416245
     /* 2416245 */ GIM_Reject,
     /* 2416246 */ // Label 34880: @2416246
     /* 2416246 */ GIM_Try, /*On fail goto*//*Label 34959*/ GIMT_Encode4(2416568),
     /* 2416251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2416254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2416257 */   GIM_Try, /*On fail goto*//*Label 34960*/ GIMT_Encode4(2416340), // Rule ID 45332 //
     /* 2416262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416294 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416298 */     // MIs[1] Operand 1
     /* 2416298 */     // No operand predicates
     /* 2416298 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416302 */     // MIs[0] policy
     /* 2416302 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416314 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2416317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416319 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416321 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416326 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416336 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416338 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416339 */     // GIR_Coverage, 45332,
     /* 2416339 */     GIR_EraseRootFromParent_Done,
     /* 2416340 */   // Label 34960: @2416340
     /* 2416340 */   GIM_Try, /*On fail goto*//*Label 34961*/ GIMT_Encode4(2416423), // Rule ID 45333 //
     /* 2416345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416354 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416377 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416381 */     // MIs[1] Operand 1
     /* 2416381 */     // No operand predicates
     /* 2416381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416385 */     // MIs[0] policy
     /* 2416385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416397 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_MF2_MASK),
     /* 2416400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416409 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416419 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416421 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416422 */     // GIR_Coverage, 45333,
     /* 2416422 */     GIR_EraseRootFromParent_Done,
     /* 2416423 */   // Label 34961: @2416423
     /* 2416423 */   GIM_Try, /*On fail goto*//*Label 34962*/ GIMT_Encode4(2416495), // Rule ID 45334 //
     /* 2416428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416437 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416460 */     // MIs[0] policy
     /* 2416460 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416463 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416470 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2416473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416475 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416477 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416479 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416481 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416491 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416493 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416494 */     // GIR_Coverage, 45334,
     /* 2416494 */     GIR_EraseRootFromParent_Done,
     /* 2416495 */   // Label 34962: @2416495
     /* 2416495 */   GIM_Try, /*On fail goto*//*Label 34963*/ GIMT_Encode4(2416567), // Rule ID 45335 //
     /* 2416500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416506 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416509 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416532 */     // MIs[0] policy
     /* 2416532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416535 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416542 */     // (riscv_slidedown_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_MF2_MASK),
     /* 2416545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416547 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416549 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416551 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416553 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2416563 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416565 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416566 */     // GIR_Coverage, 45335,
     /* 2416566 */     GIR_EraseRootFromParent_Done,
     /* 2416567 */   // Label 34963: @2416567
     /* 2416567 */   GIM_Reject,
     /* 2416568 */ // Label 34959: @2416568
     /* 2416568 */ GIM_Reject,
     /* 2416569 */ // Label 34881: @2416569
     /* 2416569 */ GIM_Try, /*On fail goto*//*Label 34964*/ GIMT_Encode4(2417201),
     /* 2416574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2416577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2416580 */   GIM_Try, /*On fail goto*//*Label 34965*/ GIMT_Encode4(2416663), // Rule ID 45352 //
     /* 2416585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416594 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416617 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416621 */     // MIs[1] Operand 1
     /* 2416621 */     // No operand predicates
     /* 2416621 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416625 */     // MIs[0] policy
     /* 2416625 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416630 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416637 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2416640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416642 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416644 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416646 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416649 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416659 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416661 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416662 */     // GIR_Coverage, 45352,
     /* 2416662 */     GIR_EraseRootFromParent_Done,
     /* 2416663 */   // Label 34965: @2416663
     /* 2416663 */   GIM_Try, /*On fail goto*//*Label 34966*/ GIMT_Encode4(2416746), // Rule ID 45353 //
     /* 2416668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416674 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416677 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416704 */     // MIs[1] Operand 1
     /* 2416704 */     // No operand predicates
     /* 2416704 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416708 */     // MIs[0] policy
     /* 2416708 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416720 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2416723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416725 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416727 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416732 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416742 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416744 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416745 */     // GIR_Coverage, 45353,
     /* 2416745 */     GIR_EraseRootFromParent_Done,
     /* 2416746 */   // Label 34966: @2416746
     /* 2416746 */   GIM_Try, /*On fail goto*//*Label 34967*/ GIMT_Encode4(2416829), // Rule ID 45424 //
     /* 2416751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416760 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416783 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416787 */     // MIs[1] Operand 1
     /* 2416787 */     // No operand predicates
     /* 2416787 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416791 */     // MIs[0] policy
     /* 2416791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416796 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416803 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2416806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416808 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416810 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416815 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416817 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416822 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416825 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416827 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416828 */     // GIR_Coverage, 45424,
     /* 2416828 */     GIR_EraseRootFromParent_Done,
     /* 2416829 */   // Label 34967: @2416829
     /* 2416829 */   GIM_Try, /*On fail goto*//*Label 34968*/ GIMT_Encode4(2416912), // Rule ID 45425 //
     /* 2416834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416843 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2416846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416850 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2416862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2416866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2416870 */     // MIs[1] Operand 1
     /* 2416870 */     // No operand predicates
     /* 2416870 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416874 */     // MIs[0] policy
     /* 2416874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2416879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416886 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2416886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2416889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416895 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2416898 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416905 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416908 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416910 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416911 */     // GIR_Coverage, 45425,
     /* 2416911 */     GIR_EraseRootFromParent_Done,
     /* 2416912 */   // Label 34968: @2416912
     /* 2416912 */   GIM_Try, /*On fail goto*//*Label 34969*/ GIMT_Encode4(2416984), // Rule ID 45354 //
     /* 2416917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2416920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2416923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416926 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2416929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2416933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2416941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2416945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2416949 */     // MIs[0] policy
     /* 2416949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2416952 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2416959 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2416959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2416962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2416964 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2416966 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2416968 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2416970 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2416972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2416977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2416980 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2416982 */     GIR_RootConstrainSelectedInstOperands,
     /* 2416983 */     // GIR_Coverage, 45354,
     /* 2416983 */     GIR_EraseRootFromParent_Done,
     /* 2416984 */   // Label 34969: @2416984
     /* 2416984 */   GIM_Try, /*On fail goto*//*Label 34970*/ GIMT_Encode4(2417056), // Rule ID 45355 //
     /* 2416989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2416992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2416995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2416998 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417017 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417021 */     // MIs[0] policy
     /* 2417021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417031 */     // (riscv_slidedown_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2417034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417036 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417038 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417040 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417042 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417052 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417054 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417055 */     // GIR_Coverage, 45355,
     /* 2417055 */     GIR_EraseRootFromParent_Done,
     /* 2417056 */   // Label 34970: @2417056
     /* 2417056 */   GIM_Try, /*On fail goto*//*Label 34971*/ GIMT_Encode4(2417128), // Rule ID 45426 //
     /* 2417061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417067 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417070 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417077 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417093 */     // MIs[0] policy
     /* 2417093 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417096 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417103 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2417106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417108 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417110 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417112 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417114 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417124 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417126 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417127 */     // GIR_Coverage, 45426,
     /* 2417127 */     GIR_EraseRootFromParent_Done,
     /* 2417128 */   // Label 34971: @2417128
     /* 2417128 */   GIM_Try, /*On fail goto*//*Label 34972*/ GIMT_Encode4(2417200), // Rule ID 45427 //
     /* 2417133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417142 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2417149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2417157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417165 */     // MIs[0] policy
     /* 2417165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417168 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417175 */     // (riscv_slidedown_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2417178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417180 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417182 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417184 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417186 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2417196 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417198 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417199 */     // GIR_Coverage, 45427,
     /* 2417199 */     GIR_EraseRootFromParent_Done,
     /* 2417200 */   // Label 34972: @2417200
     /* 2417200 */   GIM_Reject,
     /* 2417201 */ // Label 34964: @2417201
     /* 2417201 */ GIM_Reject,
     /* 2417202 */ // Label 34882: @2417202
     /* 2417202 */ GIM_Try, /*On fail goto*//*Label 34973*/ GIMT_Encode4(2417834),
     /* 2417207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2417210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2417213 */   GIM_Try, /*On fail goto*//*Label 34974*/ GIMT_Encode4(2417296), // Rule ID 45388 //
     /* 2417218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417227 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417250 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417254 */     // MIs[1] Operand 1
     /* 2417254 */     // No operand predicates
     /* 2417254 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417258 */     // MIs[0] policy
     /* 2417258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417263 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417270 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2417273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417275 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417277 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417282 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417292 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417294 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417295 */     // GIR_Coverage, 45388,
     /* 2417295 */     GIR_EraseRootFromParent_Done,
     /* 2417296 */   // Label 34974: @2417296
     /* 2417296 */   GIM_Try, /*On fail goto*//*Label 34975*/ GIMT_Encode4(2417379), // Rule ID 45389 //
     /* 2417301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417333 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417337 */     // MIs[1] Operand 1
     /* 2417337 */     // No operand predicates
     /* 2417337 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417341 */     // MIs[0] policy
     /* 2417341 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417353 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2417356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417358 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417360 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417365 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417375 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417377 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417378 */     // GIR_Coverage, 45389,
     /* 2417378 */     GIR_EraseRootFromParent_Done,
     /* 2417379 */   // Label 34975: @2417379
     /* 2417379 */   GIM_Try, /*On fail goto*//*Label 34976*/ GIMT_Encode4(2417462), // Rule ID 45448 //
     /* 2417384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417416 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417420 */     // MIs[1] Operand 1
     /* 2417420 */     // No operand predicates
     /* 2417420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417424 */     // MIs[0] policy
     /* 2417424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417429 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417436 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2417439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417441 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417443 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417448 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417458 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417460 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417461 */     // GIR_Coverage, 45448,
     /* 2417461 */     GIR_EraseRootFromParent_Done,
     /* 2417462 */   // Label 34976: @2417462
     /* 2417462 */   GIM_Try, /*On fail goto*//*Label 34977*/ GIMT_Encode4(2417545), // Rule ID 45449 //
     /* 2417467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417499 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417503 */     // MIs[1] Operand 1
     /* 2417503 */     // No operand predicates
     /* 2417503 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417507 */     // MIs[0] policy
     /* 2417507 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417519 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2417522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417531 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417533 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417541 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417543 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417544 */     // GIR_Coverage, 45449,
     /* 2417544 */     GIR_EraseRootFromParent_Done,
     /* 2417545 */   // Label 34977: @2417545
     /* 2417545 */   GIM_Try, /*On fail goto*//*Label 34978*/ GIMT_Encode4(2417617), // Rule ID 45390 //
     /* 2417550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417559 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417582 */     // MIs[0] policy
     /* 2417582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417585 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417592 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2417595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417597 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417599 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417601 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417603 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417613 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417615 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417616 */     // GIR_Coverage, 45390,
     /* 2417616 */     GIR_EraseRootFromParent_Done,
     /* 2417617 */   // Label 34978: @2417617
     /* 2417617 */   GIM_Try, /*On fail goto*//*Label 34979*/ GIMT_Encode4(2417689), // Rule ID 45391 //
     /* 2417622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417638 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417654 */     // MIs[0] policy
     /* 2417654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417657 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417664 */     // (riscv_slidedown_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2417667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417669 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417671 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417673 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417675 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417685 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417687 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417688 */     // GIR_Coverage, 45391,
     /* 2417688 */     GIR_EraseRootFromParent_Done,
     /* 2417689 */   // Label 34979: @2417689
     /* 2417689 */   GIM_Try, /*On fail goto*//*Label 34980*/ GIMT_Encode4(2417761), // Rule ID 45450 //
     /* 2417694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2417697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417722 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417726 */     // MIs[0] policy
     /* 2417726 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417729 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417736 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2417739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417741 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417743 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417745 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417747 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417757 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417759 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417760 */     // GIR_Coverage, 45450,
     /* 2417760 */     GIR_EraseRootFromParent_Done,
     /* 2417761 */   // Label 34980: @2417761
     /* 2417761 */   GIM_Try, /*On fail goto*//*Label 34981*/ GIMT_Encode4(2417833), // Rule ID 45451 //
     /* 2417766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2417769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2417782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2417790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2417794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417798 */     // MIs[0] policy
     /* 2417798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417808 */     // (riscv_slidedown_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2417811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417813 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417815 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417817 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2417819 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2417829 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417831 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417832 */     // GIR_Coverage, 45451,
     /* 2417832 */     GIR_EraseRootFromParent_Done,
     /* 2417833 */   // Label 34981: @2417833
     /* 2417833 */   GIM_Reject,
     /* 2417834 */ // Label 34973: @2417834
     /* 2417834 */ GIM_Reject,
     /* 2417835 */ // Label 34883: @2417835
     /* 2417835 */ GIM_Try, /*On fail goto*//*Label 34982*/ GIMT_Encode4(2418467),
     /* 2417840 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2417843 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2417846 */   GIM_Try, /*On fail goto*//*Label 34983*/ GIMT_Encode4(2417929), // Rule ID 45404 //
     /* 2417851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2417854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2417857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417860 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2417863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2417867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417883 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417887 */     // MIs[1] Operand 1
     /* 2417887 */     // No operand predicates
     /* 2417887 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417891 */     // MIs[0] policy
     /* 2417891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417903 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2417903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2417906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417908 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417910 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417915 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2417917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2417922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2417925 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2417927 */     GIR_RootConstrainSelectedInstOperands,
     /* 2417928 */     // GIR_Coverage, 45404,
     /* 2417928 */     GIR_EraseRootFromParent_Done,
     /* 2417929 */   // Label 34983: @2417929
     /* 2417929 */   GIM_Try, /*On fail goto*//*Label 34984*/ GIMT_Encode4(2418012), // Rule ID 45405 //
     /* 2417934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2417937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2417940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2417943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2417946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2417950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2417958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2417962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2417966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2417970 */     // MIs[1] Operand 1
     /* 2417970 */     // No operand predicates
     /* 2417970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2417974 */     // MIs[0] policy
     /* 2417974 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2417977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2417979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2417986 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2417986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2417989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2417991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2417993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2417995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2417998 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418008 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418010 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418011 */     // GIR_Coverage, 45405,
     /* 2418011 */     GIR_EraseRootFromParent_Done,
     /* 2418012 */   // Label 34984: @2418012
     /* 2418012 */   GIM_Try, /*On fail goto*//*Label 34985*/ GIMT_Encode4(2418095), // Rule ID 45464 //
     /* 2418017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2418020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418026 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418049 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418053 */     // MIs[1] Operand 1
     /* 2418053 */     // No operand predicates
     /* 2418053 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418057 */     // MIs[0] policy
     /* 2418057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418062 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418069 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2418072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418074 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418076 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418081 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418091 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418093 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418094 */     // GIR_Coverage, 45464,
     /* 2418094 */     GIR_EraseRootFromParent_Done,
     /* 2418095 */   // Label 34985: @2418095
     /* 2418095 */   GIM_Try, /*On fail goto*//*Label 34986*/ GIMT_Encode4(2418178), // Rule ID 45465 //
     /* 2418100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2418103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418109 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418132 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418136 */     // MIs[1] Operand 1
     /* 2418136 */     // No operand predicates
     /* 2418136 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418140 */     // MIs[0] policy
     /* 2418140 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418152 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2418155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418157 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418159 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418161 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418164 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418166 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418174 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418176 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418177 */     // GIR_Coverage, 45465,
     /* 2418177 */     GIR_EraseRootFromParent_Done,
     /* 2418178 */   // Label 34986: @2418178
     /* 2418178 */   GIM_Try, /*On fail goto*//*Label 34987*/ GIMT_Encode4(2418250), // Rule ID 45406 //
     /* 2418183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2418186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418192 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418215 */     // MIs[0] policy
     /* 2418215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418218 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418225 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2418228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418230 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418232 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418234 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418236 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418246 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418248 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418249 */     // GIR_Coverage, 45406,
     /* 2418249 */     GIR_EraseRootFromParent_Done,
     /* 2418250 */   // Label 34987: @2418250
     /* 2418250 */   GIM_Try, /*On fail goto*//*Label 34988*/ GIMT_Encode4(2418322), // Rule ID 45407 //
     /* 2418255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2418258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418261 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418264 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418283 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418287 */     // MIs[0] policy
     /* 2418287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418297 */     // (riscv_slidedown_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2418300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418302 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418304 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418306 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418308 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418318 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418320 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418321 */     // GIR_Coverage, 45407,
     /* 2418321 */     GIR_EraseRootFromParent_Done,
     /* 2418322 */   // Label 34988: @2418322
     /* 2418322 */   GIM_Try, /*On fail goto*//*Label 34989*/ GIMT_Encode4(2418394), // Rule ID 45466 //
     /* 2418327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2418330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418355 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418359 */     // MIs[0] policy
     /* 2418359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418362 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418369 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2418372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418374 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418376 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418378 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418380 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418382 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418390 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418392 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418393 */     // GIR_Coverage, 45466,
     /* 2418393 */     GIR_EraseRootFromParent_Done,
     /* 2418394 */   // Label 34989: @2418394
     /* 2418394 */   GIM_Try, /*On fail goto*//*Label 34990*/ GIMT_Encode4(2418466), // Rule ID 45467 //
     /* 2418399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2418402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2418408 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2418415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2418423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418431 */     // MIs[0] policy
     /* 2418431 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418441 */     // (riscv_slidedown_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2418444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418446 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418448 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418450 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418452 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2418462 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418464 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418465 */     // GIR_Coverage, 45467,
     /* 2418465 */     GIR_EraseRootFromParent_Done,
     /* 2418466 */   // Label 34990: @2418466
     /* 2418466 */   GIM_Reject,
     /* 2418467 */ // Label 34982: @2418467
     /* 2418467 */ GIM_Reject,
     /* 2418468 */ // Label 34884: @2418468
     /* 2418468 */ GIM_Try, /*On fail goto*//*Label 34991*/ GIMT_Encode4(2418790),
     /* 2418473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2418476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2418479 */   GIM_Try, /*On fail goto*//*Label 34992*/ GIMT_Encode4(2418562), // Rule ID 45348 //
     /* 2418484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418493 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418516 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418520 */     // MIs[1] Operand 1
     /* 2418520 */     // No operand predicates
     /* 2418520 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418524 */     // MIs[0] policy
     /* 2418524 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418529 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418536 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2418539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418541 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418543 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418548 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418558 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418560 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418561 */     // GIR_Coverage, 45348,
     /* 2418561 */     GIR_EraseRootFromParent_Done,
     /* 2418562 */   // Label 34992: @2418562
     /* 2418562 */   GIM_Try, /*On fail goto*//*Label 34993*/ GIMT_Encode4(2418645), // Rule ID 45349 //
     /* 2418567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418599 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418603 */     // MIs[1] Operand 1
     /* 2418603 */     // No operand predicates
     /* 2418603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418607 */     // MIs[0] policy
     /* 2418607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418619 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M1_MASK),
     /* 2418622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418631 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418641 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418643 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418644 */     // GIR_Coverage, 45349,
     /* 2418644 */     GIR_EraseRootFromParent_Done,
     /* 2418645 */   // Label 34993: @2418645
     /* 2418645 */   GIM_Try, /*On fail goto*//*Label 34994*/ GIMT_Encode4(2418717), // Rule ID 45350 //
     /* 2418650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418659 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418674 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418678 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418682 */     // MIs[0] policy
     /* 2418682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418685 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418692 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418697 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418699 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418701 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418703 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418713 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418715 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418716 */     // GIR_Coverage, 45350,
     /* 2418716 */     GIR_EraseRootFromParent_Done,
     /* 2418717 */   // Label 34994: @2418717
     /* 2418717 */   GIM_Try, /*On fail goto*//*Label 34995*/ GIMT_Encode4(2418789), // Rule ID 45351 //
     /* 2418722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2418738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2418746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2418750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418754 */     // MIs[0] policy
     /* 2418754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418764 */     // (riscv_slidedown_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M1_MASK),
     /* 2418767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418769 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418771 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418773 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2418775 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2418785 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418787 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418788 */     // GIR_Coverage, 45351,
     /* 2418788 */     GIR_EraseRootFromParent_Done,
     /* 2418789 */   // Label 34995: @2418789
     /* 2418789 */   GIM_Reject,
     /* 2418790 */ // Label 34991: @2418790
     /* 2418790 */ GIM_Reject,
     /* 2418791 */ // Label 34885: @2418791
     /* 2418791 */ GIM_Try, /*On fail goto*//*Label 34996*/ GIMT_Encode4(2419423),
     /* 2418796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2418799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2418802 */   GIM_Try, /*On fail goto*//*Label 34997*/ GIMT_Encode4(2418885), // Rule ID 45376 //
     /* 2418807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418816 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2418823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418843 */     // MIs[1] Operand 1
     /* 2418843 */     // No operand predicates
     /* 2418843 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418847 */     // MIs[0] policy
     /* 2418847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418850 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418859 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2418859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2418862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418864 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418866 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418871 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418881 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418883 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418884 */     // GIR_Coverage, 45376,
     /* 2418884 */     GIR_EraseRootFromParent_Done,
     /* 2418885 */   // Label 34997: @2418885
     /* 2418885 */   GIM_Try, /*On fail goto*//*Label 34998*/ GIMT_Encode4(2418968), // Rule ID 45377 //
     /* 2418890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2418893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2418896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418899 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2418902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2418906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2418918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2418922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2418926 */     // MIs[1] Operand 1
     /* 2418926 */     // No operand predicates
     /* 2418926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2418930 */     // MIs[0] policy
     /* 2418930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2418933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2418935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2418942 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2418942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2418945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2418947 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2418949 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2418951 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2418954 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2418956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2418961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2418964 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2418966 */     GIR_RootConstrainSelectedInstOperands,
     /* 2418967 */     // GIR_Coverage, 45377,
     /* 2418967 */     GIR_EraseRootFromParent_Done,
     /* 2418968 */   // Label 34998: @2418968
     /* 2418968 */   GIM_Try, /*On fail goto*//*Label 34999*/ GIMT_Encode4(2419051), // Rule ID 45436 //
     /* 2418973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2418976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2418979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2418982 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2418985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2418989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2418997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419005 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419009 */     // MIs[1] Operand 1
     /* 2419009 */     // No operand predicates
     /* 2419009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419013 */     // MIs[0] policy
     /* 2419013 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419025 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2419028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419030 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419032 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419034 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419037 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419047 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419049 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419050 */     // GIR_Coverage, 45436,
     /* 2419050 */     GIR_EraseRootFromParent_Done,
     /* 2419051 */   // Label 34999: @2419051
     /* 2419051 */   GIM_Try, /*On fail goto*//*Label 35000*/ GIMT_Encode4(2419134), // Rule ID 45437 //
     /* 2419056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419088 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419092 */     // MIs[1] Operand 1
     /* 2419092 */     // No operand predicates
     /* 2419092 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419096 */     // MIs[0] policy
     /* 2419096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419108 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2419111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419120 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419130 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419132 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419133 */     // GIR_Coverage, 45437,
     /* 2419133 */     GIR_EraseRootFromParent_Done,
     /* 2419134 */   // Label 35000: @2419134
     /* 2419134 */   GIM_Try, /*On fail goto*//*Label 35001*/ GIMT_Encode4(2419206), // Rule ID 45378 //
     /* 2419139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419148 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419171 */     // MIs[0] policy
     /* 2419171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419181 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2419184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419186 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419188 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419190 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419192 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419202 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419204 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419205 */     // GIR_Coverage, 45378,
     /* 2419205 */     GIR_EraseRootFromParent_Done,
     /* 2419206 */   // Label 35001: @2419206
     /* 2419206 */   GIM_Try, /*On fail goto*//*Label 35002*/ GIMT_Encode4(2419278), // Rule ID 45379 //
     /* 2419211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419239 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419243 */     // MIs[0] policy
     /* 2419243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419246 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419253 */     // (riscv_slidedown_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2419256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419258 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419260 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419262 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419264 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419274 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419276 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419277 */     // GIR_Coverage, 45379,
     /* 2419277 */     GIR_EraseRootFromParent_Done,
     /* 2419278 */   // Label 35002: @2419278
     /* 2419278 */   GIM_Try, /*On fail goto*//*Label 35003*/ GIMT_Encode4(2419350), // Rule ID 45438 //
     /* 2419283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419292 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419311 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419315 */     // MIs[0] policy
     /* 2419315 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419318 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419325 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2419328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419330 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419332 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419334 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419336 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419346 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419349 */     // GIR_Coverage, 45438,
     /* 2419349 */     GIR_EraseRootFromParent_Done,
     /* 2419350 */   // Label 35003: @2419350
     /* 2419350 */   GIM_Try, /*On fail goto*//*Label 35004*/ GIMT_Encode4(2419422), // Rule ID 45439 //
     /* 2419355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419364 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2419371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2419379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419387 */     // MIs[0] policy
     /* 2419387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419390 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419397 */     // (riscv_slidedown_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2419400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419402 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419404 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419406 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419408 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2419418 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419420 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419421 */     // GIR_Coverage, 45439,
     /* 2419421 */     GIR_EraseRootFromParent_Done,
     /* 2419422 */   // Label 35004: @2419422
     /* 2419422 */   GIM_Reject,
     /* 2419423 */ // Label 34996: @2419423
     /* 2419423 */ GIM_Reject,
     /* 2419424 */ // Label 34886: @2419424
     /* 2419424 */ GIM_Try, /*On fail goto*//*Label 35005*/ GIMT_Encode4(2420056),
     /* 2419429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2419432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2419435 */   GIM_Try, /*On fail goto*//*Label 35006*/ GIMT_Encode4(2419518), // Rule ID 45392 //
     /* 2419440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419449 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419472 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419476 */     // MIs[1] Operand 1
     /* 2419476 */     // No operand predicates
     /* 2419476 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419480 */     // MIs[0] policy
     /* 2419480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419492 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2419495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419497 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419499 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419504 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419511 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419514 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419516 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419517 */     // GIR_Coverage, 45392,
     /* 2419517 */     GIR_EraseRootFromParent_Done,
     /* 2419518 */   // Label 35006: @2419518
     /* 2419518 */   GIM_Try, /*On fail goto*//*Label 35007*/ GIMT_Encode4(2419601), // Rule ID 45393 //
     /* 2419523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419532 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419555 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419559 */     // MIs[1] Operand 1
     /* 2419559 */     // No operand predicates
     /* 2419559 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419563 */     // MIs[0] policy
     /* 2419563 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419575 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2419578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419587 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419597 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419599 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419600 */     // GIR_Coverage, 45393,
     /* 2419600 */     GIR_EraseRootFromParent_Done,
     /* 2419601 */   // Label 35007: @2419601
     /* 2419601 */   GIM_Try, /*On fail goto*//*Label 35008*/ GIMT_Encode4(2419684), // Rule ID 45452 //
     /* 2419606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419642 */     // MIs[1] Operand 1
     /* 2419642 */     // No operand predicates
     /* 2419642 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419646 */     // MIs[0] policy
     /* 2419646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419658 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2419661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419663 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419665 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419670 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419677 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419680 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419682 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419683 */     // GIR_Coverage, 45452,
     /* 2419683 */     GIR_EraseRootFromParent_Done,
     /* 2419684 */   // Label 35008: @2419684
     /* 2419684 */   GIM_Try, /*On fail goto*//*Label 35009*/ GIMT_Encode4(2419767), // Rule ID 45453 //
     /* 2419689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419698 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2419717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2419721 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2419725 */     // MIs[1] Operand 1
     /* 2419725 */     // No operand predicates
     /* 2419725 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419729 */     // MIs[0] policy
     /* 2419729 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2419734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419741 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2419744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419746 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419748 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2419753 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419763 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419765 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419766 */     // GIR_Coverage, 45453,
     /* 2419766 */     GIR_EraseRootFromParent_Done,
     /* 2419767 */   // Label 35009: @2419767
     /* 2419767 */   GIM_Try, /*On fail goto*//*Label 35010*/ GIMT_Encode4(2419839), // Rule ID 45394 //
     /* 2419772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419781 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419804 */     // MIs[0] policy
     /* 2419804 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419807 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419814 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2419817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419819 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419821 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419823 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419825 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419835 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419837 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419838 */     // GIR_Coverage, 45394,
     /* 2419838 */     GIR_EraseRootFromParent_Done,
     /* 2419839 */   // Label 35010: @2419839
     /* 2419839 */   GIM_Try, /*On fail goto*//*Label 35011*/ GIMT_Encode4(2419911), // Rule ID 45395 //
     /* 2419844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419853 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2419856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419876 */     // MIs[0] policy
     /* 2419876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419879 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419886 */     // (riscv_slidedown_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2419886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2419889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419891 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419893 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419895 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419897 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419907 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419909 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419910 */     // GIR_Coverage, 45395,
     /* 2419910 */     GIR_EraseRootFromParent_Done,
     /* 2419911 */   // Label 35011: @2419911
     /* 2419911 */   GIM_Try, /*On fail goto*//*Label 35012*/ GIMT_Encode4(2419983), // Rule ID 45454 //
     /* 2419916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2419919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2419922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419925 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2419928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2419932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2419940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2419944 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2419948 */     // MIs[0] policy
     /* 2419948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2419951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2419958 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2419958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2419961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2419963 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2419965 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2419967 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2419969 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2419971 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2419976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2419979 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2419981 */     GIR_RootConstrainSelectedInstOperands,
     /* 2419982 */     // GIR_Coverage, 45454,
     /* 2419982 */     GIR_EraseRootFromParent_Done,
     /* 2419983 */   // Label 35012: @2419983
     /* 2419983 */   GIM_Try, /*On fail goto*//*Label 35013*/ GIMT_Encode4(2420055), // Rule ID 45455 //
     /* 2419988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2419991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2419994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2419997 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2420004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2420012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420020 */     // MIs[0] policy
     /* 2420020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420023 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420030 */     // (riscv_slidedown_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2420033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420035 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420037 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420039 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420041 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420043 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2420051 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420053 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420054 */     // GIR_Coverage, 45455,
     /* 2420054 */     GIR_EraseRootFromParent_Done,
     /* 2420055 */   // Label 35013: @2420055
     /* 2420055 */   GIM_Reject,
     /* 2420056 */ // Label 35005: @2420056
     /* 2420056 */ GIM_Reject,
     /* 2420057 */ // Label 34887: @2420057
     /* 2420057 */ GIM_Try, /*On fail goto*//*Label 35014*/ GIMT_Encode4(2420689),
     /* 2420062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2420065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2420068 */   GIM_Try, /*On fail goto*//*Label 35015*/ GIMT_Encode4(2420151), // Rule ID 45408 //
     /* 2420073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420105 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420109 */     // MIs[1] Operand 1
     /* 2420109 */     // No operand predicates
     /* 2420109 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420113 */     // MIs[0] policy
     /* 2420113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420125 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2420128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420130 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420132 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420137 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420147 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420149 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420150 */     // GIR_Coverage, 45408,
     /* 2420150 */     GIR_EraseRootFromParent_Done,
     /* 2420151 */   // Label 35015: @2420151
     /* 2420151 */   GIM_Try, /*On fail goto*//*Label 35016*/ GIMT_Encode4(2420234), // Rule ID 45409 //
     /* 2420156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420192 */     // MIs[1] Operand 1
     /* 2420192 */     // No operand predicates
     /* 2420192 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420196 */     // MIs[0] policy
     /* 2420196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420208 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2420211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420220 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420230 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420232 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420233 */     // GIR_Coverage, 45409,
     /* 2420233 */     GIR_EraseRootFromParent_Done,
     /* 2420234 */   // Label 35016: @2420234
     /* 2420234 */   GIM_Try, /*On fail goto*//*Label 35017*/ GIMT_Encode4(2420317), // Rule ID 45468 //
     /* 2420239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420271 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420275 */     // MIs[1] Operand 1
     /* 2420275 */     // No operand predicates
     /* 2420275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420279 */     // MIs[0] policy
     /* 2420279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420291 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2420294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420296 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420298 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420303 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420313 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420315 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420316 */     // GIR_Coverage, 45468,
     /* 2420316 */     GIR_EraseRootFromParent_Done,
     /* 2420317 */   // Label 35017: @2420317
     /* 2420317 */   GIM_Try, /*On fail goto*//*Label 35018*/ GIMT_Encode4(2420400), // Rule ID 45469 //
     /* 2420322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420331 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420354 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420358 */     // MIs[1] Operand 1
     /* 2420358 */     // No operand predicates
     /* 2420358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420362 */     // MIs[0] policy
     /* 2420362 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420374 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2420377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420379 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420381 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420386 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420388 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420393 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420396 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420398 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420399 */     // GIR_Coverage, 45469,
     /* 2420399 */     GIR_EraseRootFromParent_Done,
     /* 2420400 */   // Label 35018: @2420400
     /* 2420400 */   GIM_Try, /*On fail goto*//*Label 35019*/ GIMT_Encode4(2420472), // Rule ID 45410 //
     /* 2420405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420414 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420437 */     // MIs[0] policy
     /* 2420437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420447 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2420450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420452 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420454 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420456 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420458 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420468 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420470 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420471 */     // GIR_Coverage, 45410,
     /* 2420471 */     GIR_EraseRootFromParent_Done,
     /* 2420472 */   // Label 35019: @2420472
     /* 2420472 */   GIM_Try, /*On fail goto*//*Label 35020*/ GIMT_Encode4(2420544), // Rule ID 45411 //
     /* 2420477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420509 */     // MIs[0] policy
     /* 2420509 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420512 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420519 */     // (riscv_slidedown_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2420522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420524 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420526 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420528 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420530 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420540 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420542 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420543 */     // GIR_Coverage, 45411,
     /* 2420543 */     GIR_EraseRootFromParent_Done,
     /* 2420544 */   // Label 35020: @2420544
     /* 2420544 */   GIM_Try, /*On fail goto*//*Label 35021*/ GIMT_Encode4(2420616), // Rule ID 45470 //
     /* 2420549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2420552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420558 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420577 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420581 */     // MIs[0] policy
     /* 2420581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420584 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420591 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2420594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420596 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420598 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420600 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420602 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420612 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420614 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420615 */     // GIR_Coverage, 45470,
     /* 2420615 */     GIR_EraseRootFromParent_Done,
     /* 2420616 */   // Label 35021: @2420616
     /* 2420616 */   GIM_Try, /*On fail goto*//*Label 35022*/ GIMT_Encode4(2420688), // Rule ID 45471 //
     /* 2420621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2420624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2420630 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2420637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2420645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420649 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420653 */     // MIs[0] policy
     /* 2420653 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420656 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420663 */     // (riscv_slidedown_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2420666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420668 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420670 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420672 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420674 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2420684 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420686 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420687 */     // GIR_Coverage, 45471,
     /* 2420687 */     GIR_EraseRootFromParent_Done,
     /* 2420688 */   // Label 35022: @2420688
     /* 2420688 */   GIM_Reject,
     /* 2420689 */ // Label 35014: @2420689
     /* 2420689 */ GIM_Reject,
     /* 2420690 */ // Label 34888: @2420690
     /* 2420690 */ GIM_Try, /*On fail goto*//*Label 35023*/ GIMT_Encode4(2421012),
     /* 2420695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2420698 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2420701 */   GIM_Try, /*On fail goto*//*Label 35024*/ GIMT_Encode4(2420784), // Rule ID 45364 //
     /* 2420706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2420709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2420715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420722 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420742 */     // MIs[1] Operand 1
     /* 2420742 */     // No operand predicates
     /* 2420742 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420746 */     // MIs[0] policy
     /* 2420746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420758 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420763 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420765 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420770 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420780 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420782 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420783 */     // GIR_Coverage, 45364,
     /* 2420783 */     GIR_EraseRootFromParent_Done,
     /* 2420784 */   // Label 35024: @2420784
     /* 2420784 */   GIM_Try, /*On fail goto*//*Label 35025*/ GIMT_Encode4(2420867), // Rule ID 45365 //
     /* 2420789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2420792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2420798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2420817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2420821 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2420825 */     // MIs[1] Operand 1
     /* 2420825 */     // No operand predicates
     /* 2420825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420829 */     // MIs[0] policy
     /* 2420829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2420834 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420841 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M2_MASK),
     /* 2420844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420846 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420848 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420850 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2420853 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420863 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420865 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420866 */     // GIR_Coverage, 45365,
     /* 2420866 */     GIR_EraseRootFromParent_Done,
     /* 2420867 */   // Label 35025: @2420867
     /* 2420867 */   GIM_Try, /*On fail goto*//*Label 35026*/ GIMT_Encode4(2420939), // Rule ID 45366 //
     /* 2420872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2420875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2420878 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2420881 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2420884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420900 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420904 */     // MIs[0] policy
     /* 2420904 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420914 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2420914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420919 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420921 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420923 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420925 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2420932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2420935 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2420937 */     GIR_RootConstrainSelectedInstOperands,
     /* 2420938 */     // GIR_Coverage, 45366,
     /* 2420938 */     GIR_EraseRootFromParent_Done,
     /* 2420939 */   // Label 35026: @2420939
     /* 2420939 */   GIM_Try, /*On fail goto*//*Label 35027*/ GIMT_Encode4(2421011), // Rule ID 45367 //
     /* 2420944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2420947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2420950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2420953 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2420956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2420960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2420968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2420972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2420976 */     // MIs[0] policy
     /* 2420976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2420979 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2420986 */     // (riscv_slidedown_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2420986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M2_MASK),
     /* 2420989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2420991 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2420993 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2420995 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2420997 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2420999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2421007 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421009 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421010 */     // GIR_Coverage, 45367,
     /* 2421010 */     GIR_EraseRootFromParent_Done,
     /* 2421011 */   // Label 35027: @2421011
     /* 2421011 */   GIM_Reject,
     /* 2421012 */ // Label 35023: @2421012
     /* 2421012 */ GIM_Reject,
     /* 2421013 */ // Label 34889: @2421013
     /* 2421013 */ GIM_Try, /*On fail goto*//*Label 35028*/ GIMT_Encode4(2421645),
     /* 2421018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2421021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2421024 */   GIM_Try, /*On fail goto*//*Label 35029*/ GIMT_Encode4(2421107), // Rule ID 45380 //
     /* 2421029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421038 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421061 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421065 */     // MIs[1] Operand 1
     /* 2421065 */     // No operand predicates
     /* 2421065 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421069 */     // MIs[0] policy
     /* 2421069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421081 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2421084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421086 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421088 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421093 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421103 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421105 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421106 */     // GIR_Coverage, 45380,
     /* 2421106 */     GIR_EraseRootFromParent_Done,
     /* 2421107 */   // Label 35029: @2421107
     /* 2421107 */   GIM_Try, /*On fail goto*//*Label 35030*/ GIMT_Encode4(2421190), // Rule ID 45381 //
     /* 2421112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421144 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421148 */     // MIs[1] Operand 1
     /* 2421148 */     // No operand predicates
     /* 2421148 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421152 */     // MIs[0] policy
     /* 2421152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421157 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421164 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2421167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421169 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421171 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421173 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421176 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421186 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421188 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421189 */     // GIR_Coverage, 45381,
     /* 2421189 */     GIR_EraseRootFromParent_Done,
     /* 2421190 */   // Label 35030: @2421190
     /* 2421190 */   GIM_Try, /*On fail goto*//*Label 35031*/ GIMT_Encode4(2421273), // Rule ID 45440 //
     /* 2421195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421204 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421227 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421231 */     // MIs[1] Operand 1
     /* 2421231 */     // No operand predicates
     /* 2421231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421235 */     // MIs[0] policy
     /* 2421235 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421247 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2421250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421252 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421254 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421259 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421269 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421271 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421272 */     // GIR_Coverage, 45440,
     /* 2421272 */     GIR_EraseRootFromParent_Done,
     /* 2421273 */   // Label 35031: @2421273
     /* 2421273 */   GIM_Try, /*On fail goto*//*Label 35032*/ GIMT_Encode4(2421356), // Rule ID 45441 //
     /* 2421278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421287 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421314 */     // MIs[1] Operand 1
     /* 2421314 */     // No operand predicates
     /* 2421314 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421318 */     // MIs[0] policy
     /* 2421318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421323 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421330 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2421333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421335 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421337 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421342 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421352 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421354 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421355 */     // GIR_Coverage, 45441,
     /* 2421355 */     GIR_EraseRootFromParent_Done,
     /* 2421356 */   // Label 35032: @2421356
     /* 2421356 */   GIM_Try, /*On fail goto*//*Label 35033*/ GIMT_Encode4(2421428), // Rule ID 45382 //
     /* 2421361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421389 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421393 */     // MIs[0] policy
     /* 2421393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421396 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421403 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2421406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421408 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421410 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421412 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421414 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421424 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421426 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421427 */     // GIR_Coverage, 45382,
     /* 2421427 */     GIR_EraseRootFromParent_Done,
     /* 2421428 */   // Label 35033: @2421428
     /* 2421428 */   GIM_Try, /*On fail goto*//*Label 35034*/ GIMT_Encode4(2421500), // Rule ID 45383 //
     /* 2421433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421461 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421465 */     // MIs[0] policy
     /* 2421465 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421475 */     // (riscv_slidedown_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2421478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421480 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421482 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421484 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421486 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421496 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421498 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421499 */     // GIR_Coverage, 45383,
     /* 2421499 */     GIR_EraseRootFromParent_Done,
     /* 2421500 */   // Label 35034: @2421500
     /* 2421500 */   GIM_Try, /*On fail goto*//*Label 35035*/ GIMT_Encode4(2421572), // Rule ID 45442 //
     /* 2421505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421533 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421537 */     // MIs[0] policy
     /* 2421537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421540 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421547 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2421550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421552 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421554 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421556 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421558 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421568 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421570 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421571 */     // GIR_Coverage, 45442,
     /* 2421571 */     GIR_EraseRootFromParent_Done,
     /* 2421572 */   // Label 35035: @2421572
     /* 2421572 */   GIM_Try, /*On fail goto*//*Label 35036*/ GIMT_Encode4(2421644), // Rule ID 45443 //
     /* 2421577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421586 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2421593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2421601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2421605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421609 */     // MIs[0] policy
     /* 2421609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421612 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421619 */     // (riscv_slidedown_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2421622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421624 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421626 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421628 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2421630 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2421640 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421642 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421643 */     // GIR_Coverage, 45443,
     /* 2421643 */     GIR_EraseRootFromParent_Done,
     /* 2421644 */   // Label 35036: @2421644
     /* 2421644 */   GIM_Reject,
     /* 2421645 */ // Label 35028: @2421645
     /* 2421645 */ GIM_Reject,
     /* 2421646 */ // Label 34890: @2421646
     /* 2421646 */ GIM_Try, /*On fail goto*//*Label 35037*/ GIMT_Encode4(2422278),
     /* 2421651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2421654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2421657 */   GIM_Try, /*On fail goto*//*Label 35038*/ GIMT_Encode4(2421740), // Rule ID 45396 //
     /* 2421662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421668 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421671 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2421678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421694 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421698 */     // MIs[1] Operand 1
     /* 2421698 */     // No operand predicates
     /* 2421698 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421702 */     // MIs[0] policy
     /* 2421702 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421707 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421714 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2421717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421719 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421721 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421726 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421736 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421738 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421739 */     // GIR_Coverage, 45396,
     /* 2421739 */     GIR_EraseRootFromParent_Done,
     /* 2421740 */   // Label 35038: @2421740
     /* 2421740 */   GIM_Try, /*On fail goto*//*Label 35039*/ GIMT_Encode4(2421823), // Rule ID 45397 //
     /* 2421745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421754 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2421761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421777 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421781 */     // MIs[1] Operand 1
     /* 2421781 */     // No operand predicates
     /* 2421781 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421785 */     // MIs[0] policy
     /* 2421785 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421797 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2421800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421802 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421804 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421809 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421819 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421821 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421822 */     // GIR_Coverage, 45397,
     /* 2421822 */     GIR_EraseRootFromParent_Done,
     /* 2421823 */   // Label 35039: @2421823
     /* 2421823 */   GIM_Try, /*On fail goto*//*Label 35040*/ GIMT_Encode4(2421906), // Rule ID 45456 //
     /* 2421828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2421834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2421840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2421844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421860 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421864 */     // MIs[1] Operand 1
     /* 2421864 */     // No operand predicates
     /* 2421864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421868 */     // MIs[0] policy
     /* 2421868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421873 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421880 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2421880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2421883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421885 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421887 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421892 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421902 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421904 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421905 */     // GIR_Coverage, 45456,
     /* 2421905 */     GIR_EraseRootFromParent_Done,
     /* 2421906 */   // Label 35040: @2421906
     /* 2421906 */   GIM_Try, /*On fail goto*//*Label 35041*/ GIMT_Encode4(2421989), // Rule ID 45457 //
     /* 2421911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2421914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2421917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2421920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2421923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2421927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2421935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2421939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2421943 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2421947 */     // MIs[1] Operand 1
     /* 2421947 */     // No operand predicates
     /* 2421947 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2421951 */     // MIs[0] policy
     /* 2421951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2421954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2421956 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2421963 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2421963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2421966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2421968 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2421970 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2421972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2421975 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2421977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2421982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2421985 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2421987 */     GIR_RootConstrainSelectedInstOperands,
     /* 2421988 */     // GIR_Coverage, 45457,
     /* 2421988 */     GIR_EraseRootFromParent_Done,
     /* 2421989 */   // Label 35041: @2421989
     /* 2421989 */   GIM_Try, /*On fail goto*//*Label 35042*/ GIMT_Encode4(2422061), // Rule ID 45398 //
     /* 2421994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2421997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2422003 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422022 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422026 */     // MIs[0] policy
     /* 2422026 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422029 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422036 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2422039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422041 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422043 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422045 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422047 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422057 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422059 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422060 */     // GIR_Coverage, 45398,
     /* 2422060 */     GIR_EraseRootFromParent_Done,
     /* 2422061 */   // Label 35042: @2422061
     /* 2422061 */   GIM_Try, /*On fail goto*//*Label 35043*/ GIMT_Encode4(2422133), // Rule ID 45399 //
     /* 2422066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2422075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422094 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422098 */     // MIs[0] policy
     /* 2422098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422101 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422108 */     // (riscv_slidedown_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2422111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422113 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422115 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422117 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422119 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422121 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422129 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422131 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422132 */     // GIR_Coverage, 45399,
     /* 2422132 */     GIR_EraseRootFromParent_Done,
     /* 2422133 */   // Label 35043: @2422133
     /* 2422133 */   GIM_Try, /*On fail goto*//*Label 35044*/ GIMT_Encode4(2422205), // Rule ID 45458 //
     /* 2422138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2422147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422166 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422170 */     // MIs[0] policy
     /* 2422170 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422180 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2422183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422185 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422187 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422189 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422191 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422201 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422203 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422204 */     // GIR_Coverage, 45458,
     /* 2422204 */     GIR_EraseRootFromParent_Done,
     /* 2422205 */   // Label 35044: @2422205
     /* 2422205 */   GIM_Try, /*On fail goto*//*Label 35045*/ GIMT_Encode4(2422277), // Rule ID 45459 //
     /* 2422210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2422219 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422234 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422242 */     // MIs[0] policy
     /* 2422242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422245 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422252 */     // (riscv_slidedown_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2422255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422257 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422259 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422261 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422263 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2422273 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422275 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422276 */     // GIR_Coverage, 45459,
     /* 2422276 */     GIR_EraseRootFromParent_Done,
     /* 2422277 */   // Label 35045: @2422277
     /* 2422277 */   GIM_Reject,
     /* 2422278 */ // Label 35037: @2422278
     /* 2422278 */ GIM_Reject,
     /* 2422279 */ // Label 34891: @2422279
     /* 2422279 */ GIM_Try, /*On fail goto*//*Label 35046*/ GIMT_Encode4(2422601),
     /* 2422284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2422287 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2422290 */   GIM_Try, /*On fail goto*//*Label 35047*/ GIMT_Encode4(2422373), // Rule ID 45368 //
     /* 2422295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422304 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422327 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422331 */     // MIs[1] Operand 1
     /* 2422331 */     // No operand predicates
     /* 2422331 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422335 */     // MIs[0] policy
     /* 2422335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422338 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422340 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422347 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422352 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422354 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422359 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422369 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422371 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422372 */     // GIR_Coverage, 45368,
     /* 2422372 */     GIR_EraseRootFromParent_Done,
     /* 2422373 */   // Label 35047: @2422373
     /* 2422373 */   GIM_Try, /*On fail goto*//*Label 35048*/ GIMT_Encode4(2422456), // Rule ID 45369 //
     /* 2422378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422410 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422414 */     // MIs[1] Operand 1
     /* 2422414 */     // No operand predicates
     /* 2422414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422418 */     // MIs[0] policy
     /* 2422418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422423 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422430 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M4_MASK),
     /* 2422433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422435 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422437 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422442 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422452 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422454 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422455 */     // GIR_Coverage, 45369,
     /* 2422455 */     GIR_EraseRootFromParent_Done,
     /* 2422456 */   // Label 35048: @2422456
     /* 2422456 */   GIM_Try, /*On fail goto*//*Label 35049*/ GIMT_Encode4(2422528), // Rule ID 45370 //
     /* 2422461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422477 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422493 */     // MIs[0] policy
     /* 2422493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422503 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422508 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422510 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422512 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422514 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422524 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422526 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422527 */     // GIR_Coverage, 45370,
     /* 2422527 */     GIR_EraseRootFromParent_Done,
     /* 2422528 */   // Label 35049: @2422528
     /* 2422528 */   GIM_Try, /*On fail goto*//*Label 35050*/ GIMT_Encode4(2422600), // Rule ID 45371 //
     /* 2422533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422542 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2422549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2422557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422565 */     // MIs[0] policy
     /* 2422565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422575 */     // (riscv_slidedown_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M4_MASK),
     /* 2422578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422580 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422582 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422584 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2422586 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2422596 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422598 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422599 */     // GIR_Coverage, 45371,
     /* 2422599 */     GIR_EraseRootFromParent_Done,
     /* 2422600 */   // Label 35050: @2422600
     /* 2422600 */   GIM_Reject,
     /* 2422601 */ // Label 35046: @2422601
     /* 2422601 */ GIM_Reject,
     /* 2422602 */ // Label 34892: @2422602
     /* 2422602 */ GIM_Try, /*On fail goto*//*Label 35051*/ GIMT_Encode4(2423234),
     /* 2422607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2422610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2422613 */   GIM_Try, /*On fail goto*//*Label 35052*/ GIMT_Encode4(2422696), // Rule ID 45384 //
     /* 2422618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422627 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422650 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422654 */     // MIs[1] Operand 1
     /* 2422654 */     // No operand predicates
     /* 2422654 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422658 */     // MIs[0] policy
     /* 2422658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422663 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422670 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2422673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422675 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422677 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422682 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422689 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422692 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422694 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422695 */     // GIR_Coverage, 45384,
     /* 2422695 */     GIR_EraseRootFromParent_Done,
     /* 2422696 */   // Label 35052: @2422696
     /* 2422696 */   GIM_Try, /*On fail goto*//*Label 35053*/ GIMT_Encode4(2422779), // Rule ID 45385 //
     /* 2422701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422710 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422733 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422737 */     // MIs[1] Operand 1
     /* 2422737 */     // No operand predicates
     /* 2422737 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422741 */     // MIs[0] policy
     /* 2422741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422746 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422753 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2422756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422758 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422760 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422765 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422775 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422777 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422778 */     // GIR_Coverage, 45385,
     /* 2422778 */     GIR_EraseRootFromParent_Done,
     /* 2422779 */   // Label 35053: @2422779
     /* 2422779 */   GIM_Try, /*On fail goto*//*Label 35054*/ GIMT_Encode4(2422862), // Rule ID 45444 //
     /* 2422784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422793 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422820 */     // MIs[1] Operand 1
     /* 2422820 */     // No operand predicates
     /* 2422820 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422824 */     // MIs[0] policy
     /* 2422824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422829 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422836 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2422839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422841 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422843 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422848 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422858 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422860 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422861 */     // GIR_Coverage, 45444,
     /* 2422861 */     GIR_EraseRootFromParent_Done,
     /* 2422862 */   // Label 35054: @2422862
     /* 2422862 */   GIM_Try, /*On fail goto*//*Label 35055*/ GIMT_Encode4(2422945), // Rule ID 45445 //
     /* 2422867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2422870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2422873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422876 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2422879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2422895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2422899 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2422903 */     // MIs[1] Operand 1
     /* 2422903 */     // No operand predicates
     /* 2422903 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422907 */     // MIs[0] policy
     /* 2422907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2422912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422919 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2422919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2422922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422924 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422926 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2422928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2422931 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2422933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2422938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2422941 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2422943 */     GIR_RootConstrainSelectedInstOperands,
     /* 2422944 */     // GIR_Coverage, 45445,
     /* 2422944 */     GIR_EraseRootFromParent_Done,
     /* 2422945 */   // Label 35055: @2422945
     /* 2422945 */   GIM_Try, /*On fail goto*//*Label 35056*/ GIMT_Encode4(2423017), // Rule ID 45386 //
     /* 2422950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2422953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2422956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2422959 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2422962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2422966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2422974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2422978 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2422982 */     // MIs[0] policy
     /* 2422982 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2422985 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2422992 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2422992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2422995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2422997 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2422999 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423001 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423003 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423013 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423015 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423016 */     // GIR_Coverage, 45386,
     /* 2423016 */     GIR_EraseRootFromParent_Done,
     /* 2423017 */   // Label 35056: @2423017
     /* 2423017 */   GIM_Try, /*On fail goto*//*Label 35057*/ GIMT_Encode4(2423089), // Rule ID 45387 //
     /* 2423022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2423031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423050 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423054 */     // MIs[0] policy
     /* 2423054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423057 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423064 */     // (riscv_slidedown_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2423067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423069 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423071 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423073 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423075 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423085 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423087 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423088 */     // GIR_Coverage, 45387,
     /* 2423088 */     GIR_EraseRootFromParent_Done,
     /* 2423089 */   // Label 35057: @2423089
     /* 2423089 */   GIM_Try, /*On fail goto*//*Label 35058*/ GIMT_Encode4(2423161), // Rule ID 45446 //
     /* 2423094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2423103 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423122 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423126 */     // MIs[0] policy
     /* 2423126 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423129 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423136 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2423139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423141 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423143 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423145 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423147 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423157 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423159 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423160 */     // GIR_Coverage, 45446,
     /* 2423160 */     GIR_EraseRootFromParent_Done,
     /* 2423161 */   // Label 35058: @2423161
     /* 2423161 */   GIM_Try, /*On fail goto*//*Label 35059*/ GIMT_Encode4(2423233), // Rule ID 45447 //
     /* 2423166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2423175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423198 */     // MIs[0] policy
     /* 2423198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423201 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423208 */     // (riscv_slidedown_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2423211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423213 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423215 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423217 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423219 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2423229 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423231 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423232 */     // GIR_Coverage, 45447,
     /* 2423232 */     GIR_EraseRootFromParent_Done,
     /* 2423233 */   // Label 35059: @2423233
     /* 2423233 */   GIM_Reject,
     /* 2423234 */ // Label 35051: @2423234
     /* 2423234 */ GIM_Reject,
     /* 2423235 */ // Label 34893: @2423235
     /* 2423235 */ GIM_Try, /*On fail goto*//*Label 35060*/ GIMT_Encode4(2423557),
     /* 2423240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2423243 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2423246 */   GIM_Try, /*On fail goto*//*Label 35061*/ GIMT_Encode4(2423329), // Rule ID 45372 //
     /* 2423251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2423260 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423267 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423283 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423287 */     // MIs[1] Operand 1
     /* 2423287 */     // No operand predicates
     /* 2423287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423291 */     // MIs[0] policy
     /* 2423291 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423296 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423303 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2423306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423308 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423310 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423315 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423317 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423325 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423327 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423328 */     // GIR_Coverage, 45372,
     /* 2423328 */     GIR_EraseRootFromParent_Done,
     /* 2423329 */   // Label 35061: @2423329
     /* 2423329 */   GIM_Try, /*On fail goto*//*Label 35062*/ GIMT_Encode4(2423412), // Rule ID 45373 //
     /* 2423334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423340 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2423343 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423366 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423370 */     // MIs[1] Operand 1
     /* 2423370 */     // No operand predicates
     /* 2423370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423374 */     // MIs[0] policy
     /* 2423374 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423386 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VI_M8_MASK),
     /* 2423389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423391 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423393 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423398 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423408 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423410 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423411 */     // GIR_Coverage, 45373,
     /* 2423411 */     GIR_EraseRootFromParent_Done,
     /* 2423412 */   // Label 35062: @2423412
     /* 2423412 */   GIM_Try, /*On fail goto*//*Label 35063*/ GIMT_Encode4(2423484), // Rule ID 45374 //
     /* 2423417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2423426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423449 */     // MIs[0] policy
     /* 2423449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423452 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423459 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2423462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423464 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423466 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423468 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423470 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423472 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423480 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423482 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423483 */     // GIR_Coverage, 45374,
     /* 2423483 */     GIR_EraseRootFromParent_Done,
     /* 2423484 */   // Label 35063: @2423484
     /* 2423484 */   GIM_Try, /*On fail goto*//*Label 35064*/ GIMT_Encode4(2423556), // Rule ID 45375 //
     /* 2423489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2423498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2423505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2423513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423517 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423521 */     // MIs[0] policy
     /* 2423521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423524 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423531 */     // (riscv_slidedown_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEDOWN_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEDOWN_VX_M8_MASK),
     /* 2423534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423536 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423538 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423540 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423542 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423552 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423554 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423555 */     // GIR_Coverage, 45375,
     /* 2423555 */     GIR_EraseRootFromParent_Done,
     /* 2423556 */   // Label 35064: @2423556
     /* 2423556 */   GIM_Reject,
     /* 2423557 */ // Label 35060: @2423557
     /* 2423557 */ GIM_Reject,
     /* 2423558 */ // Label 34894: @2423558
     /* 2423558 */ GIM_Reject,
     /* 2423559 */ // Label 124: @2423559
     /* 2423559 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(34), /*)*//*default:*//*Label 35087*/ GIMT_Encode4(2435438),
     /* 2423570 */ /*GILLT_nxv1s8*//*Label 35065*/ GIMT_Encode4(2423682),
     /* 2423574 */ /*GILLT_nxv1s16*//*Label 35066*/ GIMT_Encode4(2424005),
     /* 2423578 */ /*GILLT_nxv1s32*//*Label 35067*/ GIMT_Encode4(2424638),
     /* 2423582 */ /*GILLT_nxv1s64*//*Label 35068*/ GIMT_Encode4(2425271), GIMT_Encode4(0),
     /* 2423590 */ /*GILLT_nxv2s8*//*Label 35069*/ GIMT_Encode4(2425904),
     /* 2423594 */ /*GILLT_nxv2s16*//*Label 35070*/ GIMT_Encode4(2426227),
     /* 2423598 */ /*GILLT_nxv2s32*//*Label 35071*/ GIMT_Encode4(2426860),
     /* 2423602 */ /*GILLT_nxv2s64*//*Label 35072*/ GIMT_Encode4(2427493), GIMT_Encode4(0),
     /* 2423610 */ /*GILLT_nxv4s8*//*Label 35073*/ GIMT_Encode4(2428126),
     /* 2423614 */ /*GILLT_nxv4s16*//*Label 35074*/ GIMT_Encode4(2428449),
     /* 2423618 */ /*GILLT_nxv4s32*//*Label 35075*/ GIMT_Encode4(2429082),
     /* 2423622 */ /*GILLT_nxv4s64*//*Label 35076*/ GIMT_Encode4(2429715), GIMT_Encode4(0),
     /* 2423630 */ /*GILLT_nxv8s8*//*Label 35077*/ GIMT_Encode4(2430348),
     /* 2423634 */ /*GILLT_nxv8s16*//*Label 35078*/ GIMT_Encode4(2430671),
     /* 2423638 */ /*GILLT_nxv8s32*//*Label 35079*/ GIMT_Encode4(2431304),
     /* 2423642 */ /*GILLT_nxv8s64*//*Label 35080*/ GIMT_Encode4(2431937), GIMT_Encode4(0),
     /* 2423650 */ /*GILLT_nxv16s8*//*Label 35081*/ GIMT_Encode4(2432570),
     /* 2423654 */ /*GILLT_nxv16s16*//*Label 35082*/ GIMT_Encode4(2432893),
     /* 2423658 */ /*GILLT_nxv16s32*//*Label 35083*/ GIMT_Encode4(2433526), GIMT_Encode4(0),
     /* 2423666 */ /*GILLT_nxv32s8*//*Label 35084*/ GIMT_Encode4(2434159),
     /* 2423670 */ /*GILLT_nxv32s16*//*Label 35085*/ GIMT_Encode4(2434482), GIMT_Encode4(0),
     /* 2423678 */ /*GILLT_nxv64s8*//*Label 35086*/ GIMT_Encode4(2435115),
     /* 2423682 */ // Label 35065: @2423682
     /* 2423682 */ GIM_Try, /*On fail goto*//*Label 35088*/ GIMT_Encode4(2424004),
     /* 2423687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s8,
     /* 2423690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s8,
     /* 2423693 */   GIM_Try, /*On fail goto*//*Label 35089*/ GIMT_Encode4(2423776), // Rule ID 25242 //
     /* 2423698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2423707 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2423714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423730 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423734 */     // MIs[1] Operand 1
     /* 2423734 */     // No operand predicates
     /* 2423734 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423738 */     // MIs[0] policy
     /* 2423738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423743 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423750 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2423753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423755 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423757 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423762 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423772 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423774 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423775 */     // GIR_Coverage, 25242,
     /* 2423775 */     GIR_EraseRootFromParent_Done,
     /* 2423776 */   // Label 35089: @2423776
     /* 2423776 */   GIM_Try, /*On fail goto*//*Label 35090*/ GIMT_Encode4(2423859), // Rule ID 25243 //
     /* 2423781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2423790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2423797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2423809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2423813 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2423817 */     // MIs[1] Operand 1
     /* 2423817 */     // No operand predicates
     /* 2423817 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423821 */     // MIs[0] policy
     /* 2423821 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423833 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF8_MASK),
     /* 2423836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2423845 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423855 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423857 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423858 */     // GIR_Coverage, 25243,
     /* 2423858 */     GIR_EraseRootFromParent_Done,
     /* 2423859 */   // Label 35090: @2423859
     /* 2423859 */   GIM_Try, /*On fail goto*//*Label 35091*/ GIMT_Encode4(2423931), // Rule ID 25244 //
     /* 2423864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2423867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2423870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2423873 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2423876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2423880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423892 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423896 */     // MIs[0] policy
     /* 2423896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423899 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423906 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2423906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2423909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423911 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423913 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423915 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2423929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2423930 */     // GIR_Coverage, 25244,
     /* 2423930 */     GIR_EraseRootFromParent_Done,
     /* 2423931 */   // Label 35091: @2423931
     /* 2423931 */   GIM_Try, /*On fail goto*//*Label 35092*/ GIMT_Encode4(2424003), // Rule ID 25245 //
     /* 2423936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2423939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2423942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2423945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2423948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2423952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2423960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2423964 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2423968 */     // MIs[0] policy
     /* 2423968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2423971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2423978 */     // (riscv_slideup_vl:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF8_MASK:{ *:[nxv1i8] } VR:{ *:[nxv1i8] }:$rd, VR:{ *:[nxv1i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2423978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF8_MASK),
     /* 2423981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2423983 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2423985 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2423987 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2423989 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2423991 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2423996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2423999 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424001 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424002 */     // GIR_Coverage, 25245,
     /* 2424002 */     GIR_EraseRootFromParent_Done,
     /* 2424003 */   // Label 35092: @2424003
     /* 2424003 */   GIM_Reject,
     /* 2424004 */ // Label 35088: @2424004
     /* 2424004 */ GIM_Reject,
     /* 2424005 */ // Label 35066: @2424005
     /* 2424005 */ GIM_Try, /*On fail goto*//*Label 35093*/ GIMT_Encode4(2424637),
     /* 2424010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s16,
     /* 2424013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s16,
     /* 2424016 */   GIM_Try, /*On fail goto*//*Label 35094*/ GIMT_Encode4(2424099), // Rule ID 45188 //
     /* 2424021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424030 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424057 */     // MIs[1] Operand 1
     /* 2424057 */     // No operand predicates
     /* 2424057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424061 */     // MIs[0] policy
     /* 2424061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424073 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2424076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424078 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424080 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424085 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424095 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424097 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424098 */     // GIR_Coverage, 45188,
     /* 2424098 */     GIR_EraseRootFromParent_Done,
     /* 2424099 */   // Label 35094: @2424099
     /* 2424099 */   GIM_Try, /*On fail goto*//*Label 35095*/ GIMT_Encode4(2424182), // Rule ID 45189 //
     /* 2424104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424113 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424140 */     // MIs[1] Operand 1
     /* 2424140 */     // No operand predicates
     /* 2424140 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424144 */     // MIs[0] policy
     /* 2424144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424149 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424156 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2424159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424161 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424163 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424168 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424178 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424180 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424181 */     // GIR_Coverage, 45189,
     /* 2424181 */     GIR_EraseRootFromParent_Done,
     /* 2424182 */   // Label 35095: @2424182
     /* 2424182 */   GIM_Try, /*On fail goto*//*Label 35096*/ GIMT_Encode4(2424265), // Rule ID 45264 //
     /* 2424187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424219 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424223 */     // MIs[1] Operand 1
     /* 2424223 */     // No operand predicates
     /* 2424223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424227 */     // MIs[0] policy
     /* 2424227 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424232 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424239 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2424242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424244 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424246 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424248 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424251 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424261 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424263 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424264 */     // GIR_Coverage, 45264,
     /* 2424264 */     GIR_EraseRootFromParent_Done,
     /* 2424265 */   // Label 35096: @2424265
     /* 2424265 */   GIM_Try, /*On fail goto*//*Label 35097*/ GIMT_Encode4(2424348), // Rule ID 45265 //
     /* 2424270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424279 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424302 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424306 */     // MIs[1] Operand 1
     /* 2424306 */     // No operand predicates
     /* 2424306 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424310 */     // MIs[0] policy
     /* 2424310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424322 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2424325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424334 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424344 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424346 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424347 */     // GIR_Coverage, 45265,
     /* 2424347 */     GIR_EraseRootFromParent_Done,
     /* 2424348 */   // Label 35097: @2424348
     /* 2424348 */   GIM_Try, /*On fail goto*//*Label 35098*/ GIMT_Encode4(2424420), // Rule ID 45190 //
     /* 2424353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424362 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424381 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424385 */     // MIs[0] policy
     /* 2424385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424388 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424395 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2424398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424400 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424402 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424404 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424406 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424416 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424418 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424419 */     // GIR_Coverage, 45190,
     /* 2424419 */     GIR_EraseRootFromParent_Done,
     /* 2424420 */   // Label 35098: @2424420
     /* 2424420 */   GIM_Try, /*On fail goto*//*Label 35099*/ GIMT_Encode4(2424492), // Rule ID 45191 //
     /* 2424425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424453 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424457 */     // MIs[0] policy
     /* 2424457 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424460 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424467 */     // (riscv_slideup_vl:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1i16] } VR:{ *:[nxv1i16] }:$rd, VR:{ *:[nxv1i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2424470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424472 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424474 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424476 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424478 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424488 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424490 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424491 */     // GIR_Coverage, 45191,
     /* 2424491 */     GIR_EraseRootFromParent_Done,
     /* 2424492 */   // Label 35099: @2424492
     /* 2424492 */   GIM_Try, /*On fail goto*//*Label 35100*/ GIMT_Encode4(2424564), // Rule ID 45266 //
     /* 2424497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424506 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424525 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424529 */     // MIs[0] policy
     /* 2424529 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424539 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2424542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424544 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424546 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424548 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424563 */     // GIR_Coverage, 45266,
     /* 2424563 */     GIR_EraseRootFromParent_Done,
     /* 2424564 */   // Label 35100: @2424564
     /* 2424564 */   GIM_Try, /*On fail goto*//*Label 35101*/ GIMT_Encode4(2424636), // Rule ID 45267 //
     /* 2424569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2424597 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424601 */     // MIs[0] policy
     /* 2424601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424604 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424611 */     // (riscv_slideup_vl:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv1f16] } VR:{ *:[nxv1f16] }:$rd, VR:{ *:[nxv1f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2424614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424616 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424618 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424620 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2424622 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424624 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2424632 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424634 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424635 */     // GIR_Coverage, 45267,
     /* 2424635 */     GIR_EraseRootFromParent_Done,
     /* 2424636 */   // Label 35101: @2424636
     /* 2424636 */   GIM_Reject,
     /* 2424637 */ // Label 35093: @2424637
     /* 2424637 */ GIM_Reject,
     /* 2424638 */ // Label 35067: @2424638
     /* 2424638 */ GIM_Try, /*On fail goto*//*Label 35102*/ GIMT_Encode4(2425270),
     /* 2424643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s32,
     /* 2424646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s32,
     /* 2424649 */   GIM_Try, /*On fail goto*//*Label 35103*/ GIMT_Encode4(2424732), // Rule ID 45196 //
     /* 2424654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424660 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424663 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424690 */     // MIs[1] Operand 1
     /* 2424690 */     // No operand predicates
     /* 2424690 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424694 */     // MIs[0] policy
     /* 2424694 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424706 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2424709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424711 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424713 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424718 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424728 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424730 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424731 */     // GIR_Coverage, 45196,
     /* 2424731 */     GIR_EraseRootFromParent_Done,
     /* 2424732 */   // Label 35103: @2424732
     /* 2424732 */   GIM_Try, /*On fail goto*//*Label 35104*/ GIMT_Encode4(2424815), // Rule ID 45197 //
     /* 2424737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424746 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424769 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424773 */     // MIs[1] Operand 1
     /* 2424773 */     // No operand predicates
     /* 2424773 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424777 */     // MIs[0] policy
     /* 2424777 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424782 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424789 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2424792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424794 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424796 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424801 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424811 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424813 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424814 */     // GIR_Coverage, 45197,
     /* 2424814 */     GIR_EraseRootFromParent_Done,
     /* 2424815 */   // Label 35104: @2424815
     /* 2424815 */   GIM_Try, /*On fail goto*//*Label 35105*/ GIMT_Encode4(2424898), // Rule ID 45272 //
     /* 2424820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424829 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424852 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424856 */     // MIs[1] Operand 1
     /* 2424856 */     // No operand predicates
     /* 2424856 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424860 */     // MIs[0] policy
     /* 2424860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424872 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2424872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2424875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424884 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424894 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424896 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424897 */     // GIR_Coverage, 45272,
     /* 2424897 */     GIR_EraseRootFromParent_Done,
     /* 2424898 */   // Label 35105: @2424898
     /* 2424898 */   GIM_Try, /*On fail goto*//*Label 35106*/ GIMT_Encode4(2424981), // Rule ID 45273 //
     /* 2424903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2424906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2424909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424912 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2424915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2424919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2424927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2424931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2424935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2424939 */     // MIs[1] Operand 1
     /* 2424939 */     // No operand predicates
     /* 2424939 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2424943 */     // MIs[0] policy
     /* 2424943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2424946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2424948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2424955 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2424955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2424958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2424960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2424962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2424964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2424967 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2424969 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2424974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2424977 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2424979 */     GIR_RootConstrainSelectedInstOperands,
     /* 2424980 */     // GIR_Coverage, 45273,
     /* 2424980 */     GIR_EraseRootFromParent_Done,
     /* 2424981 */   // Label 35106: @2424981
     /* 2424981 */   GIM_Try, /*On fail goto*//*Label 35107*/ GIMT_Encode4(2425053), // Rule ID 45198 //
     /* 2424986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2424989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2424992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2424995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2424998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425014 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425018 */     // MIs[0] policy
     /* 2425018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425028 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2425031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425033 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425035 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425037 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425039 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425049 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425051 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425052 */     // GIR_Coverage, 45198,
     /* 2425052 */     GIR_EraseRootFromParent_Done,
     /* 2425053 */   // Label 35107: @2425053
     /* 2425053 */   GIM_Try, /*On fail goto*//*Label 35108*/ GIMT_Encode4(2425125), // Rule ID 45199 //
     /* 2425058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425086 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425090 */     // MIs[0] policy
     /* 2425090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425093 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425100 */     // (riscv_slideup_vl:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1i32] } VR:{ *:[nxv1i32] }:$rd, VR:{ *:[nxv1i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2425103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425105 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425107 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425109 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425111 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425113 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425121 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425123 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425124 */     // GIR_Coverage, 45199,
     /* 2425124 */     GIR_EraseRootFromParent_Done,
     /* 2425125 */   // Label 35108: @2425125
     /* 2425125 */   GIM_Try, /*On fail goto*//*Label 35109*/ GIMT_Encode4(2425197), // Rule ID 45274 //
     /* 2425130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425139 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425146 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425162 */     // MIs[0] policy
     /* 2425162 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425172 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2425175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425177 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425179 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425181 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425196 */     // GIR_Coverage, 45274,
     /* 2425196 */     GIR_EraseRootFromParent_Done,
     /* 2425197 */   // Label 35109: @2425197
     /* 2425197 */   GIM_Try, /*On fail goto*//*Label 35110*/ GIMT_Encode4(2425269), // Rule ID 45275 //
     /* 2425202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2425205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425234 */     // MIs[0] policy
     /* 2425234 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425237 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425244 */     // (riscv_slideup_vl:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv1f32] } VR:{ *:[nxv1f32] }:$rd, VR:{ *:[nxv1f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2425247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425249 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425251 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425253 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425255 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2425265 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425267 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425268 */     // GIR_Coverage, 45275,
     /* 2425268 */     GIR_EraseRootFromParent_Done,
     /* 2425269 */   // Label 35110: @2425269
     /* 2425269 */   GIM_Reject,
     /* 2425270 */ // Label 35102: @2425270
     /* 2425270 */ GIM_Reject,
     /* 2425271 */ // Label 35068: @2425271
     /* 2425271 */ GIM_Try, /*On fail goto*//*Label 35111*/ GIMT_Encode4(2425903),
     /* 2425276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s64,
     /* 2425279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s64,
     /* 2425282 */   GIM_Try, /*On fail goto*//*Label 35112*/ GIMT_Encode4(2425365), // Rule ID 45212 //
     /* 2425287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425319 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425323 */     // MIs[1] Operand 1
     /* 2425323 */     // No operand predicates
     /* 2425323 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425327 */     // MIs[0] policy
     /* 2425327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425339 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2425342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425351 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425361 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425363 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425364 */     // GIR_Coverage, 45212,
     /* 2425364 */     GIR_EraseRootFromParent_Done,
     /* 2425365 */   // Label 35112: @2425365
     /* 2425365 */   GIM_Try, /*On fail goto*//*Label 35113*/ GIMT_Encode4(2425448), // Rule ID 45213 //
     /* 2425370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425406 */     // MIs[1] Operand 1
     /* 2425406 */     // No operand predicates
     /* 2425406 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425410 */     // MIs[0] policy
     /* 2425410 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425422 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2425425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425434 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425444 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425446 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425447 */     // GIR_Coverage, 45213,
     /* 2425447 */     GIR_EraseRootFromParent_Done,
     /* 2425448 */   // Label 35113: @2425448
     /* 2425448 */   GIM_Try, /*On fail goto*//*Label 35114*/ GIMT_Encode4(2425531), // Rule ID 45284 //
     /* 2425453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425462 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425485 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425489 */     // MIs[1] Operand 1
     /* 2425489 */     // No operand predicates
     /* 2425489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425493 */     // MIs[0] policy
     /* 2425493 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425505 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2425508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425510 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425512 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425517 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425527 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425529 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425530 */     // GIR_Coverage, 45284,
     /* 2425530 */     GIR_EraseRootFromParent_Done,
     /* 2425531 */   // Label 35114: @2425531
     /* 2425531 */   GIM_Try, /*On fail goto*//*Label 35115*/ GIMT_Encode4(2425614), // Rule ID 45285 //
     /* 2425536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425545 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425568 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425572 */     // MIs[1] Operand 1
     /* 2425572 */     // No operand predicates
     /* 2425572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425576 */     // MIs[0] policy
     /* 2425576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425588 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2425591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425593 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425595 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425600 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425602 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425610 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425612 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425613 */     // GIR_Coverage, 45285,
     /* 2425613 */     GIR_EraseRootFromParent_Done,
     /* 2425614 */   // Label 35115: @2425614
     /* 2425614 */   GIM_Try, /*On fail goto*//*Label 35116*/ GIMT_Encode4(2425686), // Rule ID 45214 //
     /* 2425619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425651 */     // MIs[0] policy
     /* 2425651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425661 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2425664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425666 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425668 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425670 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425672 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425679 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425682 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425684 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425685 */     // GIR_Coverage, 45214,
     /* 2425685 */     GIR_EraseRootFromParent_Done,
     /* 2425686 */   // Label 35116: @2425686
     /* 2425686 */   GIM_Try, /*On fail goto*//*Label 35117*/ GIMT_Encode4(2425758), // Rule ID 45215 //
     /* 2425691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425700 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425707 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425723 */     // MIs[0] policy
     /* 2425723 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425726 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425733 */     // (riscv_slideup_vl:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1i64] } VR:{ *:[nxv1i64] }:$rd, VR:{ *:[nxv1i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2425736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425738 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425740 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425742 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425744 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425754 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425756 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425757 */     // GIR_Coverage, 45215,
     /* 2425757 */     GIR_EraseRootFromParent_Done,
     /* 2425758 */   // Label 35117: @2425758
     /* 2425758 */   GIM_Try, /*On fail goto*//*Label 35118*/ GIMT_Encode4(2425830), // Rule ID 45286 //
     /* 2425763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2425766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425772 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425791 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425795 */     // MIs[0] policy
     /* 2425795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425798 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425805 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2425808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425810 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425812 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425814 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425816 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425826 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425828 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425829 */     // GIR_Coverage, 45286,
     /* 2425829 */     GIR_EraseRootFromParent_Done,
     /* 2425830 */   // Label 35118: @2425830
     /* 2425830 */   GIM_Try, /*On fail goto*//*Label 35119*/ GIMT_Encode4(2425902), // Rule ID 45287 //
     /* 2425835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2425838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2425841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 2425844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2425847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2425863 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425867 */     // MIs[0] policy
     /* 2425867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425877 */     // (riscv_slideup_vl:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv1f64] } VR:{ *:[nxv1f64] }:$rd, VR:{ *:[nxv1f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv1i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2425877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2425880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425882 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425884 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425886 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2425888 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425890 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425895 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2425898 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425900 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425901 */     // GIR_Coverage, 45287,
     /* 2425901 */     GIR_EraseRootFromParent_Done,
     /* 2425902 */   // Label 35119: @2425902
     /* 2425902 */   GIM_Reject,
     /* 2425903 */ // Label 35111: @2425903
     /* 2425903 */ GIM_Reject,
     /* 2425904 */ // Label 35069: @2425904
     /* 2425904 */ GIM_Try, /*On fail goto*//*Label 35120*/ GIMT_Encode4(2426226),
     /* 2425909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s8,
     /* 2425912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s8,
     /* 2425915 */   GIM_Try, /*On fail goto*//*Label 35121*/ GIMT_Encode4(2425998), // Rule ID 45180 //
     /* 2425920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2425923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2425926 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2425929 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2425932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2425936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2425944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2425948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2425952 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2425956 */     // MIs[1] Operand 1
     /* 2425956 */     // No operand predicates
     /* 2425956 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2425960 */     // MIs[0] policy
     /* 2425960 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2425963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2425965 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2425972 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2425972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2425975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2425977 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2425979 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2425981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2425984 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2425986 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2425991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2425994 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2425996 */     GIR_RootConstrainSelectedInstOperands,
     /* 2425997 */     // GIR_Coverage, 45180,
     /* 2425997 */     GIR_EraseRootFromParent_Done,
     /* 2425998 */   // Label 35121: @2425998
     /* 2425998 */   GIM_Try, /*On fail goto*//*Label 35122*/ GIMT_Encode4(2426081), // Rule ID 45181 //
     /* 2426003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426019 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426035 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426039 */     // MIs[1] Operand 1
     /* 2426039 */     // No operand predicates
     /* 2426039 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426043 */     // MIs[0] policy
     /* 2426043 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426046 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426055 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF4_MASK),
     /* 2426058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426067 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426077 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426079 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426080 */     // GIR_Coverage, 45181,
     /* 2426080 */     GIR_EraseRootFromParent_Done,
     /* 2426081 */   // Label 35122: @2426081
     /* 2426081 */   GIM_Try, /*On fail goto*//*Label 35123*/ GIMT_Encode4(2426153), // Rule ID 45182 //
     /* 2426086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426095 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426110 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426114 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426118 */     // MIs[0] policy
     /* 2426118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426121 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426128 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2426131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426133 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426135 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426137 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426152 */     // GIR_Coverage, 45182,
     /* 2426152 */     GIR_EraseRootFromParent_Done,
     /* 2426153 */   // Label 35123: @2426153
     /* 2426153 */   GIM_Try, /*On fail goto*//*Label 35124*/ GIMT_Encode4(2426225), // Rule ID 45183 //
     /* 2426158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426190 */     // MIs[0] policy
     /* 2426190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426193 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426200 */     // (riscv_slideup_vl:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF4_MASK:{ *:[nxv2i8] } VR:{ *:[nxv2i8] }:$rd, VR:{ *:[nxv2i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF4_MASK),
     /* 2426203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426205 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426207 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426209 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426211 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2426221 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426223 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426224 */     // GIR_Coverage, 45183,
     /* 2426224 */     GIR_EraseRootFromParent_Done,
     /* 2426225 */   // Label 35124: @2426225
     /* 2426225 */   GIM_Reject,
     /* 2426226 */ // Label 35120: @2426226
     /* 2426226 */ GIM_Reject,
     /* 2426227 */ // Label 35070: @2426227
     /* 2426227 */ GIM_Try, /*On fail goto*//*Label 35125*/ GIMT_Encode4(2426859),
     /* 2426232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 2426235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 2426238 */   GIM_Try, /*On fail goto*//*Label 35126*/ GIMT_Encode4(2426321), // Rule ID 45192 //
     /* 2426243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426252 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426275 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426279 */     // MIs[1] Operand 1
     /* 2426279 */     // No operand predicates
     /* 2426279 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426283 */     // MIs[0] policy
     /* 2426283 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426288 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426295 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2426298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426300 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426302 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426307 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426317 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426319 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426320 */     // GIR_Coverage, 45192,
     /* 2426320 */     GIR_EraseRootFromParent_Done,
     /* 2426321 */   // Label 35126: @2426321
     /* 2426321 */   GIM_Try, /*On fail goto*//*Label 35127*/ GIMT_Encode4(2426404), // Rule ID 45193 //
     /* 2426326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426329 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426332 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426335 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426358 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426362 */     // MIs[1] Operand 1
     /* 2426362 */     // No operand predicates
     /* 2426362 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426366 */     // MIs[0] policy
     /* 2426366 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426371 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426378 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2426381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426383 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426385 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426390 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426400 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426402 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426403 */     // GIR_Coverage, 45193,
     /* 2426403 */     GIR_EraseRootFromParent_Done,
     /* 2426404 */   // Label 35127: @2426404
     /* 2426404 */   GIM_Try, /*On fail goto*//*Label 35128*/ GIMT_Encode4(2426487), // Rule ID 45268 //
     /* 2426409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426418 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426441 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426445 */     // MIs[1] Operand 1
     /* 2426445 */     // No operand predicates
     /* 2426445 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426449 */     // MIs[0] policy
     /* 2426449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426461 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2426464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426466 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426468 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426473 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426483 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426485 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426486 */     // GIR_Coverage, 45268,
     /* 2426486 */     GIR_EraseRootFromParent_Done,
     /* 2426487 */   // Label 35128: @2426487
     /* 2426487 */   GIM_Try, /*On fail goto*//*Label 35129*/ GIMT_Encode4(2426570), // Rule ID 45269 //
     /* 2426492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426498 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426501 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426524 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426528 */     // MIs[1] Operand 1
     /* 2426528 */     // No operand predicates
     /* 2426528 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426532 */     // MIs[0] policy
     /* 2426532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426544 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2426547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426553 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426556 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426566 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426568 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426569 */     // GIR_Coverage, 45269,
     /* 2426569 */     GIR_EraseRootFromParent_Done,
     /* 2426570 */   // Label 35129: @2426570
     /* 2426570 */   GIM_Try, /*On fail goto*//*Label 35130*/ GIMT_Encode4(2426642), // Rule ID 45194 //
     /* 2426575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426599 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426607 */     // MIs[0] policy
     /* 2426607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426617 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2426620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426622 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426624 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426626 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426628 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426638 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426640 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426641 */     // GIR_Coverage, 45194,
     /* 2426641 */     GIR_EraseRootFromParent_Done,
     /* 2426642 */   // Label 35130: @2426642
     /* 2426642 */   GIM_Try, /*On fail goto*//*Label 35131*/ GIMT_Encode4(2426714), // Rule ID 45195 //
     /* 2426647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426656 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426675 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426679 */     // MIs[0] policy
     /* 2426679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426682 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426689 */     // (riscv_slideup_vl:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2i16] } VR:{ *:[nxv2i16] }:$rd, VR:{ *:[nxv2i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2426692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426694 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426696 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426698 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426700 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426710 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426712 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426713 */     // GIR_Coverage, 45195,
     /* 2426713 */     GIR_EraseRootFromParent_Done,
     /* 2426714 */   // Label 35131: @2426714
     /* 2426714 */   GIM_Try, /*On fail goto*//*Label 35132*/ GIMT_Encode4(2426786), // Rule ID 45270 //
     /* 2426719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426751 */     // MIs[0] policy
     /* 2426751 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426754 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426761 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2426764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426766 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426768 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426770 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426785 */     // GIR_Coverage, 45270,
     /* 2426785 */     GIR_EraseRootFromParent_Done,
     /* 2426786 */   // Label 35132: @2426786
     /* 2426786 */   GIM_Try, /*On fail goto*//*Label 35133*/ GIMT_Encode4(2426858), // Rule ID 45271 //
     /* 2426791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2426819 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426823 */     // MIs[0] policy
     /* 2426823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426833 */     // (riscv_slideup_vl:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv2f16] } VR:{ *:[nxv2f16] }:$rd, VR:{ *:[nxv2f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2426833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2426836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426838 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426840 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426842 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2426844 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2426854 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426856 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426857 */     // GIR_Coverage, 45271,
     /* 2426857 */     GIR_EraseRootFromParent_Done,
     /* 2426858 */   // Label 35133: @2426858
     /* 2426858 */   GIM_Reject,
     /* 2426859 */ // Label 35125: @2426859
     /* 2426859 */ GIM_Reject,
     /* 2426860 */ // Label 35071: @2426860
     /* 2426860 */ GIM_Try, /*On fail goto*//*Label 35134*/ GIMT_Encode4(2427492),
     /* 2426865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 2426868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 2426871 */   GIM_Try, /*On fail goto*//*Label 35135*/ GIMT_Encode4(2426954), // Rule ID 45208 //
     /* 2426876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2426879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2426882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426885 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2426888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426908 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426912 */     // MIs[1] Operand 1
     /* 2426912 */     // No operand predicates
     /* 2426912 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426916 */     // MIs[0] policy
     /* 2426916 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2426919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2426921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2426928 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2426928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2426931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2426933 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2426935 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2426937 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2426940 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2426942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2426947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2426950 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2426952 */     GIR_RootConstrainSelectedInstOperands,
     /* 2426953 */     // GIR_Coverage, 45208,
     /* 2426953 */     GIR_EraseRootFromParent_Done,
     /* 2426954 */   // Label 35135: @2426954
     /* 2426954 */   GIM_Try, /*On fail goto*//*Label 35136*/ GIMT_Encode4(2427037), // Rule ID 45209 //
     /* 2426959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2426962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2426965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2426968 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2426971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2426975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2426983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2426987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2426991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2426995 */     // MIs[1] Operand 1
     /* 2426995 */     // No operand predicates
     /* 2426995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2426999 */     // MIs[0] policy
     /* 2426999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427004 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427011 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2427014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427016 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427018 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427020 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427023 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427033 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427035 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427036 */     // GIR_Coverage, 45209,
     /* 2427036 */     GIR_EraseRootFromParent_Done,
     /* 2427037 */   // Label 35136: @2427037
     /* 2427037 */   GIM_Try, /*On fail goto*//*Label 35137*/ GIMT_Encode4(2427120), // Rule ID 45280 //
     /* 2427042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427074 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427078 */     // MIs[1] Operand 1
     /* 2427078 */     // No operand predicates
     /* 2427078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427082 */     // MIs[0] policy
     /* 2427082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427087 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427094 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2427097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427099 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427101 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427103 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427106 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427108 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427116 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427118 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427119 */     // GIR_Coverage, 45280,
     /* 2427119 */     GIR_EraseRootFromParent_Done,
     /* 2427120 */   // Label 35137: @2427120
     /* 2427120 */   GIM_Try, /*On fail goto*//*Label 35138*/ GIMT_Encode4(2427203), // Rule ID 45281 //
     /* 2427125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427134 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427157 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427161 */     // MIs[1] Operand 1
     /* 2427161 */     // No operand predicates
     /* 2427161 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427165 */     // MIs[0] policy
     /* 2427165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427177 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2427180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427189 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427199 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427201 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427202 */     // GIR_Coverage, 45281,
     /* 2427202 */     GIR_EraseRootFromParent_Done,
     /* 2427203 */   // Label 35138: @2427203
     /* 2427203 */   GIM_Try, /*On fail goto*//*Label 35139*/ GIMT_Encode4(2427275), // Rule ID 45210 //
     /* 2427208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427236 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427240 */     // MIs[0] policy
     /* 2427240 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427243 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427250 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2427253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427255 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427257 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427259 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427261 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427271 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427273 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427274 */     // GIR_Coverage, 45210,
     /* 2427274 */     GIR_EraseRootFromParent_Done,
     /* 2427275 */   // Label 35139: @2427275
     /* 2427275 */   GIM_Try, /*On fail goto*//*Label 35140*/ GIMT_Encode4(2427347), // Rule ID 45211 //
     /* 2427280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427289 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427308 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427312 */     // MIs[0] policy
     /* 2427312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427315 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427322 */     // (riscv_slideup_vl:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2i32] } VR:{ *:[nxv2i32] }:$rd, VR:{ *:[nxv2i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2427325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427327 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427329 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427331 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427333 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427343 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427345 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427346 */     // GIR_Coverage, 45211,
     /* 2427346 */     GIR_EraseRootFromParent_Done,
     /* 2427347 */   // Label 35140: @2427347
     /* 2427347 */   GIM_Try, /*On fail goto*//*Label 35141*/ GIMT_Encode4(2427419), // Rule ID 45282 //
     /* 2427352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2427355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427361 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427380 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427384 */     // MIs[0] policy
     /* 2427384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427387 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427394 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2427397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427399 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427401 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427403 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427405 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427415 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427417 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427418 */     // GIR_Coverage, 45282,
     /* 2427418 */     GIR_EraseRootFromParent_Done,
     /* 2427419 */   // Label 35141: @2427419
     /* 2427419 */   GIM_Try, /*On fail goto*//*Label 35142*/ GIMT_Encode4(2427491), // Rule ID 45283 //
     /* 2427424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2427427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2427440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2427448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427452 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427456 */     // MIs[0] policy
     /* 2427456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427459 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427466 */     // (riscv_slideup_vl:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv2f32] } VR:{ *:[nxv2f32] }:$rd, VR:{ *:[nxv2f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2427469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427471 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427473 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427475 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427477 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2427487 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427489 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427490 */     // GIR_Coverage, 45283,
     /* 2427490 */     GIR_EraseRootFromParent_Done,
     /* 2427491 */   // Label 35142: @2427491
     /* 2427491 */   GIM_Reject,
     /* 2427492 */ // Label 35134: @2427492
     /* 2427492 */ GIM_Reject,
     /* 2427493 */ // Label 35072: @2427493
     /* 2427493 */ GIM_Try, /*On fail goto*//*Label 35143*/ GIMT_Encode4(2428125),
     /* 2427498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 2427501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 2427504 */   GIM_Try, /*On fail goto*//*Label 35144*/ GIMT_Encode4(2427587), // Rule ID 45252 //
     /* 2427509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427518 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427541 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427545 */     // MIs[1] Operand 1
     /* 2427545 */     // No operand predicates
     /* 2427545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427549 */     // MIs[0] policy
     /* 2427549 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427554 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427561 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2427564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427566 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427568 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427573 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427583 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427585 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427586 */     // GIR_Coverage, 45252,
     /* 2427586 */     GIR_EraseRootFromParent_Done,
     /* 2427587 */   // Label 35144: @2427587
     /* 2427587 */   GIM_Try, /*On fail goto*//*Label 35145*/ GIMT_Encode4(2427670), // Rule ID 45253 //
     /* 2427592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2427595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427624 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427628 */     // MIs[1] Operand 1
     /* 2427628 */     // No operand predicates
     /* 2427628 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427632 */     // MIs[0] policy
     /* 2427632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427644 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2427647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427656 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427666 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427668 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427669 */     // GIR_Coverage, 45253,
     /* 2427669 */     GIR_EraseRootFromParent_Done,
     /* 2427670 */   // Label 35145: @2427670
     /* 2427670 */   GIM_Try, /*On fail goto*//*Label 35146*/ GIMT_Encode4(2427753), // Rule ID 45312 //
     /* 2427675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427684 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427711 */     // MIs[1] Operand 1
     /* 2427711 */     // No operand predicates
     /* 2427711 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427715 */     // MIs[0] policy
     /* 2427715 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427720 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427727 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2427730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427732 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427734 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427739 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427741 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427746 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427749 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427751 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427752 */     // GIR_Coverage, 45312,
     /* 2427752 */     GIR_EraseRootFromParent_Done,
     /* 2427753 */   // Label 35146: @2427753
     /* 2427753 */   GIM_Try, /*On fail goto*//*Label 35147*/ GIMT_Encode4(2427836), // Rule ID 45313 //
     /* 2427758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2427761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2427786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2427790 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2427794 */     // MIs[1] Operand 1
     /* 2427794 */     // No operand predicates
     /* 2427794 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427798 */     // MIs[0] policy
     /* 2427798 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2427803 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427810 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2427813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427815 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427817 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2427822 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427832 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427834 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427835 */     // GIR_Coverage, 45313,
     /* 2427835 */     GIR_EraseRootFromParent_Done,
     /* 2427836 */   // Label 35147: @2427836
     /* 2427836 */   GIM_Try, /*On fail goto*//*Label 35148*/ GIMT_Encode4(2427908), // Rule ID 45254 //
     /* 2427841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427850 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427873 */     // MIs[0] policy
     /* 2427873 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427883 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2427883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2427886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427888 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427890 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427892 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427894 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427896 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427901 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427904 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427906 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427907 */     // GIR_Coverage, 45254,
     /* 2427907 */     GIR_EraseRootFromParent_Done,
     /* 2427908 */   // Label 35148: @2427908
     /* 2427908 */   GIM_Try, /*On fail goto*//*Label 35149*/ GIMT_Encode4(2427980), // Rule ID 45255 //
     /* 2427913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2427916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2427919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427922 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2427925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2427929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2427937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2427941 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2427945 */     // MIs[0] policy
     /* 2427945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2427948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2427955 */     // (riscv_slideup_vl:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2i64] } VRM2:{ *:[nxv2i64] }:$rd, VRM2:{ *:[nxv2i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2427955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2427958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2427960 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2427962 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2427964 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2427966 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2427968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2427973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2427976 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2427978 */     GIR_RootConstrainSelectedInstOperands,
     /* 2427979 */     // GIR_Coverage, 45255,
     /* 2427979 */     GIR_EraseRootFromParent_Done,
     /* 2427980 */   // Label 35149: @2427980
     /* 2427980 */   GIM_Try, /*On fail goto*//*Label 35150*/ GIMT_Encode4(2428052), // Rule ID 45314 //
     /* 2427985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2427988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2427991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2427994 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2427997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2428001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428017 */     // MIs[0] policy
     /* 2428017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428020 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428027 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2428030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428032 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428034 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428036 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428038 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428048 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428050 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428051 */     // GIR_Coverage, 45314,
     /* 2428051 */     GIR_EraseRootFromParent_Done,
     /* 2428052 */   // Label 35150: @2428052
     /* 2428052 */   GIM_Try, /*On fail goto*//*Label 35151*/ GIMT_Encode4(2428124), // Rule ID 45315 //
     /* 2428057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2428060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 2428066 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2428073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2428081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428089 */     // MIs[0] policy
     /* 2428089 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428092 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428099 */     // (riscv_slideup_vl:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv2f64] } VRM2:{ *:[nxv2f64] }:$rd, VRM2:{ *:[nxv2f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv2i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2428102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428104 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428106 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428108 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428110 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2428120 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428122 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428123 */     // GIR_Coverage, 45315,
     /* 2428123 */     GIR_EraseRootFromParent_Done,
     /* 2428124 */   // Label 35151: @2428124
     /* 2428124 */   GIM_Reject,
     /* 2428125 */ // Label 35143: @2428125
     /* 2428125 */ GIM_Reject,
     /* 2428126 */ // Label 35073: @2428126
     /* 2428126 */ GIM_Try, /*On fail goto*//*Label 35152*/ GIMT_Encode4(2428448),
     /* 2428131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s8,
     /* 2428134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s8,
     /* 2428137 */   GIM_Try, /*On fail goto*//*Label 35153*/ GIMT_Encode4(2428220), // Rule ID 45184 //
     /* 2428142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428151 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428174 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428178 */     // MIs[1] Operand 1
     /* 2428178 */     // No operand predicates
     /* 2428178 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428182 */     // MIs[0] policy
     /* 2428182 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428187 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428194 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2428197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428199 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428201 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428206 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428216 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428218 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428219 */     // GIR_Coverage, 45184,
     /* 2428219 */     GIR_EraseRootFromParent_Done,
     /* 2428220 */   // Label 35153: @2428220
     /* 2428220 */   GIM_Try, /*On fail goto*//*Label 35154*/ GIMT_Encode4(2428303), // Rule ID 45185 //
     /* 2428225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428234 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428261 */     // MIs[1] Operand 1
     /* 2428261 */     // No operand predicates
     /* 2428261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428265 */     // MIs[0] policy
     /* 2428265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428277 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_MF2_MASK),
     /* 2428280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428286 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428289 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428299 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428301 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428302 */     // GIR_Coverage, 45185,
     /* 2428302 */     GIR_EraseRootFromParent_Done,
     /* 2428303 */   // Label 35154: @2428303
     /* 2428303 */   GIM_Try, /*On fail goto*//*Label 35155*/ GIMT_Encode4(2428375), // Rule ID 45186 //
     /* 2428308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428317 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428340 */     // MIs[0] policy
     /* 2428340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428343 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428350 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2428353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428355 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428357 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428359 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428361 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428371 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428373 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428374 */     // GIR_Coverage, 45186,
     /* 2428374 */     GIR_EraseRootFromParent_Done,
     /* 2428375 */   // Label 35155: @2428375
     /* 2428375 */   GIM_Try, /*On fail goto*//*Label 35156*/ GIMT_Encode4(2428447), // Rule ID 45187 //
     /* 2428380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428389 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428408 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428412 */     // MIs[0] policy
     /* 2428412 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428415 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428422 */     // (riscv_slideup_vl:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_MF2_MASK:{ *:[nxv4i8] } VR:{ *:[nxv4i8] }:$rd, VR:{ *:[nxv4i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_MF2_MASK),
     /* 2428425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428427 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428429 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428431 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428433 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2428443 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428445 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428446 */     // GIR_Coverage, 45187,
     /* 2428446 */     GIR_EraseRootFromParent_Done,
     /* 2428447 */   // Label 35156: @2428447
     /* 2428447 */   GIM_Reject,
     /* 2428448 */ // Label 35152: @2428448
     /* 2428448 */ GIM_Reject,
     /* 2428449 */ // Label 35074: @2428449
     /* 2428449 */ GIM_Try, /*On fail goto*//*Label 35157*/ GIMT_Encode4(2429081),
     /* 2428454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 2428457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 2428460 */   GIM_Try, /*On fail goto*//*Label 35158*/ GIMT_Encode4(2428543), // Rule ID 45204 //
     /* 2428465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428471 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428474 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428497 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428501 */     // MIs[1] Operand 1
     /* 2428501 */     // No operand predicates
     /* 2428501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428505 */     // MIs[0] policy
     /* 2428505 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428508 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428510 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428517 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2428520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428522 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428524 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428526 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428529 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428539 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428541 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428542 */     // GIR_Coverage, 45204,
     /* 2428542 */     GIR_EraseRootFromParent_Done,
     /* 2428543 */   // Label 35158: @2428543
     /* 2428543 */   GIM_Try, /*On fail goto*//*Label 35159*/ GIMT_Encode4(2428626), // Rule ID 45205 //
     /* 2428548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428557 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428580 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428584 */     // MIs[1] Operand 1
     /* 2428584 */     // No operand predicates
     /* 2428584 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428588 */     // MIs[0] policy
     /* 2428588 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428591 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428593 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428600 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2428603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428605 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428607 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428612 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428622 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428624 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428625 */     // GIR_Coverage, 45205,
     /* 2428625 */     GIR_EraseRootFromParent_Done,
     /* 2428626 */   // Label 35159: @2428626
     /* 2428626 */   GIM_Try, /*On fail goto*//*Label 35160*/ GIMT_Encode4(2428709), // Rule ID 45276 //
     /* 2428631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428640 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428663 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428667 */     // MIs[1] Operand 1
     /* 2428667 */     // No operand predicates
     /* 2428667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428671 */     // MIs[0] policy
     /* 2428671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428674 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428676 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428683 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2428686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428688 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428690 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428695 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428705 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428707 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428708 */     // GIR_Coverage, 45276,
     /* 2428708 */     GIR_EraseRootFromParent_Done,
     /* 2428709 */   // Label 35160: @2428709
     /* 2428709 */   GIM_Try, /*On fail goto*//*Label 35161*/ GIMT_Encode4(2428792), // Rule ID 45277 //
     /* 2428714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428723 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428730 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2428742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2428746 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2428750 */     // MIs[1] Operand 1
     /* 2428750 */     // No operand predicates
     /* 2428750 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428754 */     // MIs[0] policy
     /* 2428754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428757 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2428759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428766 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2428769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2428778 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428785 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428788 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428790 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428791 */     // GIR_Coverage, 45277,
     /* 2428791 */     GIR_EraseRootFromParent_Done,
     /* 2428792 */   // Label 35161: @2428792
     /* 2428792 */   GIM_Try, /*On fail goto*//*Label 35162*/ GIMT_Encode4(2428864), // Rule ID 45206 //
     /* 2428797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428806 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428829 */     // MIs[0] policy
     /* 2428829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428839 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2428842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428844 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428846 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428848 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428850 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428860 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428862 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428863 */     // GIR_Coverage, 45206,
     /* 2428863 */     GIR_EraseRootFromParent_Done,
     /* 2428864 */   // Label 35162: @2428864
     /* 2428864 */   GIM_Try, /*On fail goto*//*Label 35163*/ GIMT_Encode4(2428936), // Rule ID 45207 //
     /* 2428869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2428872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2428875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2428881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428901 */     // MIs[0] policy
     /* 2428901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428904 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428911 */     // (riscv_slideup_vl:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4i16] } VR:{ *:[nxv4i16] }:$rd, VR:{ *:[nxv4i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2428911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2428914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428916 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428918 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428920 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428922 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2428929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2428932 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2428934 */     GIR_RootConstrainSelectedInstOperands,
     /* 2428935 */     // GIR_Coverage, 45207,
     /* 2428935 */     GIR_EraseRootFromParent_Done,
     /* 2428936 */   // Label 35163: @2428936
     /* 2428936 */   GIM_Try, /*On fail goto*//*Label 35164*/ GIMT_Encode4(2429008), // Rule ID 45278 //
     /* 2428941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2428944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2428947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2428950 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2428953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2428957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2428965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2428969 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2428973 */     // MIs[0] policy
     /* 2428973 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2428976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2428983 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2428983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2428986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2428988 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2428990 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2428992 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2428994 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2428996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429004 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429006 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429007 */     // GIR_Coverage, 45278,
     /* 2429007 */     GIR_EraseRootFromParent_Done,
     /* 2429008 */   // Label 35164: @2429008
     /* 2429008 */   GIM_Try, /*On fail goto*//*Label 35165*/ GIMT_Encode4(2429080), // Rule ID 45279 //
     /* 2429013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429022 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2429029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2429037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429041 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429045 */     // MIs[0] policy
     /* 2429045 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429055 */     // (riscv_slideup_vl:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv4f16] } VR:{ *:[nxv4f16] }:$rd, VR:{ *:[nxv4f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2429058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429060 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429062 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429064 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429066 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2429076 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429078 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429079 */     // GIR_Coverage, 45279,
     /* 2429079 */     GIR_EraseRootFromParent_Done,
     /* 2429080 */   // Label 35165: @2429080
     /* 2429080 */   GIM_Reject,
     /* 2429081 */ // Label 35157: @2429081
     /* 2429081 */ GIM_Reject,
     /* 2429082 */ // Label 35075: @2429082
     /* 2429082 */ GIM_Try, /*On fail goto*//*Label 35166*/ GIMT_Encode4(2429714),
     /* 2429087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 2429090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 2429093 */   GIM_Try, /*On fail goto*//*Label 35167*/ GIMT_Encode4(2429176), // Rule ID 45240 //
     /* 2429098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429130 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429134 */     // MIs[1] Operand 1
     /* 2429134 */     // No operand predicates
     /* 2429134 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429138 */     // MIs[0] policy
     /* 2429138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429150 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2429153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429155 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429157 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429162 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429169 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429172 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429174 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429175 */     // GIR_Coverage, 45240,
     /* 2429175 */     GIR_EraseRootFromParent_Done,
     /* 2429176 */   // Label 35167: @2429176
     /* 2429176 */   GIM_Try, /*On fail goto*//*Label 35168*/ GIMT_Encode4(2429259), // Rule ID 45241 //
     /* 2429181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429190 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429217 */     // MIs[1] Operand 1
     /* 2429217 */     // No operand predicates
     /* 2429217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429221 */     // MIs[0] policy
     /* 2429221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429224 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429226 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429233 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2429236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429238 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429240 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429245 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429255 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429257 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429258 */     // GIR_Coverage, 45241,
     /* 2429258 */     GIR_EraseRootFromParent_Done,
     /* 2429259 */   // Label 35168: @2429259
     /* 2429259 */   GIM_Try, /*On fail goto*//*Label 35169*/ GIMT_Encode4(2429342), // Rule ID 45300 //
     /* 2429264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429273 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429300 */     // MIs[1] Operand 1
     /* 2429300 */     // No operand predicates
     /* 2429300 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429304 */     // MIs[0] policy
     /* 2429304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429309 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429316 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2429319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429321 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429323 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429328 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429338 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429340 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429341 */     // GIR_Coverage, 45300,
     /* 2429341 */     GIR_EraseRootFromParent_Done,
     /* 2429342 */   // Label 35169: @2429342
     /* 2429342 */   GIM_Try, /*On fail goto*//*Label 35170*/ GIMT_Encode4(2429425), // Rule ID 45301 //
     /* 2429347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429353 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429356 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429379 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429383 */     // MIs[1] Operand 1
     /* 2429383 */     // No operand predicates
     /* 2429383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429387 */     // MIs[0] policy
     /* 2429387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429399 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2429402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429411 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429421 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429423 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429424 */     // GIR_Coverage, 45301,
     /* 2429424 */     GIR_EraseRootFromParent_Done,
     /* 2429425 */   // Label 35170: @2429425
     /* 2429425 */   GIM_Try, /*On fail goto*//*Label 35171*/ GIMT_Encode4(2429497), // Rule ID 45242 //
     /* 2429430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429439 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429462 */     // MIs[0] policy
     /* 2429462 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429465 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429472 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2429475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429477 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429479 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429481 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429483 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429493 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429495 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429496 */     // GIR_Coverage, 45242,
     /* 2429496 */     GIR_EraseRootFromParent_Done,
     /* 2429497 */   // Label 35171: @2429497
     /* 2429497 */   GIM_Try, /*On fail goto*//*Label 35172*/ GIMT_Encode4(2429569), // Rule ID 45243 //
     /* 2429502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429534 */     // MIs[0] policy
     /* 2429534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429537 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429544 */     // (riscv_slideup_vl:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4i32] } VRM2:{ *:[nxv4i32] }:$rd, VRM2:{ *:[nxv4i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2429547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429549 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429551 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429553 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429555 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429565 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429567 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429568 */     // GIR_Coverage, 45243,
     /* 2429568 */     GIR_EraseRootFromParent_Done,
     /* 2429569 */   // Label 35172: @2429569
     /* 2429569 */   GIM_Try, /*On fail goto*//*Label 35173*/ GIMT_Encode4(2429641), // Rule ID 45302 //
     /* 2429574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2429577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429606 */     // MIs[0] policy
     /* 2429606 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429616 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2429619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429621 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429623 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429625 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429627 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429637 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429639 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429640 */     // GIR_Coverage, 45302,
     /* 2429640 */     GIR_EraseRootFromParent_Done,
     /* 2429641 */   // Label 35173: @2429641
     /* 2429641 */   GIM_Try, /*On fail goto*//*Label 35174*/ GIMT_Encode4(2429713), // Rule ID 45303 //
     /* 2429646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2429649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2429662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2429670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2429674 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429678 */     // MIs[0] policy
     /* 2429678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429688 */     // (riscv_slideup_vl:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv4f32] } VRM2:{ *:[nxv4f32] }:$rd, VRM2:{ *:[nxv4f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2429691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429693 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429695 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429697 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2429699 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2429709 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429711 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429712 */     // GIR_Coverage, 45303,
     /* 2429712 */     GIR_EraseRootFromParent_Done,
     /* 2429713 */   // Label 35174: @2429713
     /* 2429713 */   GIM_Reject,
     /* 2429714 */ // Label 35166: @2429714
     /* 2429714 */ GIM_Reject,
     /* 2429715 */ // Label 35076: @2429715
     /* 2429715 */ GIM_Try, /*On fail goto*//*Label 35175*/ GIMT_Encode4(2430347),
     /* 2429720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s64,
     /* 2429723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s64,
     /* 2429726 */   GIM_Try, /*On fail goto*//*Label 35176*/ GIMT_Encode4(2429809), // Rule ID 45256 //
     /* 2429731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2429747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429767 */     // MIs[1] Operand 1
     /* 2429767 */     // No operand predicates
     /* 2429767 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429771 */     // MIs[0] policy
     /* 2429771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429776 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429783 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2429786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429788 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429790 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429795 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429805 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429807 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429808 */     // GIR_Coverage, 45256,
     /* 2429808 */     GIR_EraseRootFromParent_Done,
     /* 2429809 */   // Label 35176: @2429809
     /* 2429809 */   GIM_Try, /*On fail goto*//*Label 35177*/ GIMT_Encode4(2429892), // Rule ID 45257 //
     /* 2429814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2429830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429846 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429850 */     // MIs[1] Operand 1
     /* 2429850 */     // No operand predicates
     /* 2429850 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429854 */     // MIs[0] policy
     /* 2429854 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429866 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2429866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2429869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429878 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429888 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429890 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429891 */     // GIR_Coverage, 45257,
     /* 2429891 */     GIR_EraseRootFromParent_Done,
     /* 2429892 */   // Label 35177: @2429892
     /* 2429892 */   GIM_Try, /*On fail goto*//*Label 35178*/ GIMT_Encode4(2429975), // Rule ID 45316 //
     /* 2429897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2429900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2429903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429906 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2429909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2429913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2429921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2429925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2429929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2429933 */     // MIs[1] Operand 1
     /* 2429933 */     // No operand predicates
     /* 2429933 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2429937 */     // MIs[0] policy
     /* 2429937 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2429940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2429942 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2429949 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2429949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2429952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2429954 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2429956 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2429958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2429961 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2429963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2429968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2429971 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2429973 */     GIR_RootConstrainSelectedInstOperands,
     /* 2429974 */     // GIR_Coverage, 45316,
     /* 2429974 */     GIR_EraseRootFromParent_Done,
     /* 2429975 */   // Label 35178: @2429975
     /* 2429975 */   GIM_Try, /*On fail goto*//*Label 35179*/ GIMT_Encode4(2430058), // Rule ID 45317 //
     /* 2429980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2429983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2429986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2429989 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2429992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2429996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430012 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430016 */     // MIs[1] Operand 1
     /* 2430016 */     // No operand predicates
     /* 2430016 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430020 */     // MIs[0] policy
     /* 2430020 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430032 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2430035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430037 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430039 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430044 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430054 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430056 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430057 */     // GIR_Coverage, 45317,
     /* 2430057 */     GIR_EraseRootFromParent_Done,
     /* 2430058 */   // Label 35179: @2430058
     /* 2430058 */   GIM_Try, /*On fail goto*//*Label 35180*/ GIMT_Encode4(2430130), // Rule ID 45258 //
     /* 2430063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2430072 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2430079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430091 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430095 */     // MIs[0] policy
     /* 2430095 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430098 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430105 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2430108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430110 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430112 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430114 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430116 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430118 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430126 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430128 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430129 */     // GIR_Coverage, 45258,
     /* 2430129 */     GIR_EraseRootFromParent_Done,
     /* 2430130 */   // Label 35180: @2430130
     /* 2430130 */   GIM_Try, /*On fail goto*//*Label 35181*/ GIMT_Encode4(2430202), // Rule ID 45259 //
     /* 2430135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430141 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2430144 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2430151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430155 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430159 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430163 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430167 */     // MIs[0] policy
     /* 2430167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430177 */     // (riscv_slideup_vl:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4i64] } VRM4:{ *:[nxv4i64] }:$rd, VRM4:{ *:[nxv4i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2430180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430182 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430184 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430186 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430188 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430198 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430200 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430201 */     // GIR_Coverage, 45259,
     /* 2430201 */     GIR_EraseRootFromParent_Done,
     /* 2430202 */   // Label 35181: @2430202
     /* 2430202 */   GIM_Try, /*On fail goto*//*Label 35182*/ GIMT_Encode4(2430274), // Rule ID 45318 //
     /* 2430207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2430210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2430216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2430223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430235 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430239 */     // MIs[0] policy
     /* 2430239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430249 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2430252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430254 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430256 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430258 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430260 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430270 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430272 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430273 */     // GIR_Coverage, 45318,
     /* 2430273 */     GIR_EraseRootFromParent_Done,
     /* 2430274 */   // Label 35182: @2430274
     /* 2430274 */   GIM_Try, /*On fail goto*//*Label 35183*/ GIMT_Encode4(2430346), // Rule ID 45319 //
     /* 2430279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2430282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 2430288 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2430295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2430303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430307 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430311 */     // MIs[0] policy
     /* 2430311 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430321 */     // (riscv_slideup_vl:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv4f64] } VRM4:{ *:[nxv4f64] }:$rd, VRM4:{ *:[nxv4f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv4i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2430324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430326 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430328 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430330 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430332 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2430342 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430344 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430345 */     // GIR_Coverage, 45319,
     /* 2430345 */     GIR_EraseRootFromParent_Done,
     /* 2430346 */   // Label 35183: @2430346
     /* 2430346 */   GIM_Reject,
     /* 2430347 */ // Label 35175: @2430347
     /* 2430347 */ GIM_Reject,
     /* 2430348 */ // Label 35077: @2430348
     /* 2430348 */ GIM_Try, /*On fail goto*//*Label 35184*/ GIMT_Encode4(2430670),
     /* 2430353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s8,
     /* 2430356 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s8,
     /* 2430359 */   GIM_Try, /*On fail goto*//*Label 35185*/ GIMT_Encode4(2430442), // Rule ID 45200 //
     /* 2430364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430373 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430396 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430400 */     // MIs[1] Operand 1
     /* 2430400 */     // No operand predicates
     /* 2430400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430404 */     // MIs[0] policy
     /* 2430404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430409 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430416 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2430419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430421 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430423 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430428 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430438 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430440 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430441 */     // GIR_Coverage, 45200,
     /* 2430441 */     GIR_EraseRootFromParent_Done,
     /* 2430442 */   // Label 35185: @2430442
     /* 2430442 */   GIM_Try, /*On fail goto*//*Label 35186*/ GIMT_Encode4(2430525), // Rule ID 45201 //
     /* 2430447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430483 */     // MIs[1] Operand 1
     /* 2430483 */     // No operand predicates
     /* 2430483 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430487 */     // MIs[0] policy
     /* 2430487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430499 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M1_MASK),
     /* 2430502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430511 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430521 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430523 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430524 */     // GIR_Coverage, 45201,
     /* 2430524 */     GIR_EraseRootFromParent_Done,
     /* 2430525 */   // Label 35186: @2430525
     /* 2430525 */   GIM_Try, /*On fail goto*//*Label 35187*/ GIMT_Encode4(2430597), // Rule ID 45202 //
     /* 2430530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430539 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430558 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430562 */     // MIs[0] policy
     /* 2430562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430565 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430572 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2430575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430577 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430579 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430581 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430583 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430593 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430595 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430596 */     // GIR_Coverage, 45202,
     /* 2430596 */     GIR_EraseRootFromParent_Done,
     /* 2430597 */   // Label 35187: @2430597
     /* 2430597 */   GIM_Try, /*On fail goto*//*Label 35188*/ GIMT_Encode4(2430669), // Rule ID 45203 //
     /* 2430602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRNoV0RegClassID),
     /* 2430618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRRegClassID),
     /* 2430626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2430630 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430634 */     // MIs[0] policy
     /* 2430634 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430637 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430644 */     // (riscv_slideup_vl:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M1_MASK:{ *:[nxv8i8] } VR:{ *:[nxv8i8] }:$rd, VR:{ *:[nxv8i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M1_MASK),
     /* 2430647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430649 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430651 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430653 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2430655 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2430665 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430667 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430668 */     // GIR_Coverage, 45203,
     /* 2430668 */     GIR_EraseRootFromParent_Done,
     /* 2430669 */   // Label 35188: @2430669
     /* 2430669 */   GIM_Reject,
     /* 2430670 */ // Label 35184: @2430670
     /* 2430670 */ GIM_Reject,
     /* 2430671 */ // Label 35078: @2430671
     /* 2430671 */ GIM_Try, /*On fail goto*//*Label 35189*/ GIMT_Encode4(2431303),
     /* 2430676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 2430679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 2430682 */   GIM_Try, /*On fail goto*//*Label 35190*/ GIMT_Encode4(2430765), // Rule ID 45228 //
     /* 2430687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430696 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2430703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430719 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430723 */     // MIs[1] Operand 1
     /* 2430723 */     // No operand predicates
     /* 2430723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430727 */     // MIs[0] policy
     /* 2430727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430732 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430739 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2430742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430744 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430746 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430751 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430761 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430763 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430764 */     // GIR_Coverage, 45228,
     /* 2430764 */     GIR_EraseRootFromParent_Done,
     /* 2430765 */   // Label 35190: @2430765
     /* 2430765 */   GIM_Try, /*On fail goto*//*Label 35191*/ GIMT_Encode4(2430848), // Rule ID 45229 //
     /* 2430770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430779 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2430786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430802 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430806 */     // MIs[1] Operand 1
     /* 2430806 */     // No operand predicates
     /* 2430806 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430810 */     // MIs[0] policy
     /* 2430810 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430822 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2430825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430827 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430829 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430834 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430844 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430846 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430847 */     // GIR_Coverage, 45229,
     /* 2430847 */     GIR_EraseRootFromParent_Done,
     /* 2430848 */   // Label 35191: @2430848
     /* 2430848 */   GIM_Try, /*On fail goto*//*Label 35192*/ GIMT_Encode4(2430931), // Rule ID 45288 //
     /* 2430853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2430856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2430859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430862 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2430865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2430869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430885 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430889 */     // MIs[1] Operand 1
     /* 2430889 */     // No operand predicates
     /* 2430889 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430893 */     // MIs[0] policy
     /* 2430893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430898 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430905 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2430905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2430908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430910 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430912 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2430917 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2430919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2430924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2430927 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2430929 */     GIR_RootConstrainSelectedInstOperands,
     /* 2430930 */     // GIR_Coverage, 45288,
     /* 2430930 */     GIR_EraseRootFromParent_Done,
     /* 2430931 */   // Label 35192: @2430931
     /* 2430931 */   GIM_Try, /*On fail goto*//*Label 35193*/ GIMT_Encode4(2431014), // Rule ID 45289 //
     /* 2430936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2430939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2430942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2430945 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2430948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2430952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2430960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2430964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2430968 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2430972 */     // MIs[1] Operand 1
     /* 2430972 */     // No operand predicates
     /* 2430972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2430976 */     // MIs[0] policy
     /* 2430976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2430979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2430981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2430988 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2430988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2430991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2430993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2430995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2430997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431000 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431010 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431012 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431013 */     // GIR_Coverage, 45289,
     /* 2431013 */     GIR_EraseRootFromParent_Done,
     /* 2431014 */   // Label 35193: @2431014
     /* 2431014 */   GIM_Try, /*On fail goto*//*Label 35194*/ GIMT_Encode4(2431086), // Rule ID 45230 //
     /* 2431019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431025 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431028 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431047 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431051 */     // MIs[0] policy
     /* 2431051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431054 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431061 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2431064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431066 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431068 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431070 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431072 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431074 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431082 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431084 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431085 */     // GIR_Coverage, 45230,
     /* 2431085 */     GIR_EraseRootFromParent_Done,
     /* 2431086 */   // Label 35194: @2431086
     /* 2431086 */   GIM_Try, /*On fail goto*//*Label 35195*/ GIMT_Encode4(2431158), // Rule ID 45231 //
     /* 2431091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431100 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431119 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431123 */     // MIs[0] policy
     /* 2431123 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431126 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431133 */     // (riscv_slideup_vl:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8i16] } VRM2:{ *:[nxv8i16] }:$rd, VRM2:{ *:[nxv8i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2431136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431138 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431140 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431142 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431144 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431154 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431156 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431157 */     // GIR_Coverage, 45231,
     /* 2431157 */     GIR_EraseRootFromParent_Done,
     /* 2431158 */   // Label 35195: @2431158
     /* 2431158 */   GIM_Try, /*On fail goto*//*Label 35196*/ GIMT_Encode4(2431230), // Rule ID 45290 //
     /* 2431163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431191 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431195 */     // MIs[0] policy
     /* 2431195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431205 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2431208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431210 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431212 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431214 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431216 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431226 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431228 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431229 */     // GIR_Coverage, 45290,
     /* 2431229 */     GIR_EraseRootFromParent_Done,
     /* 2431230 */   // Label 35196: @2431230
     /* 2431230 */   GIM_Try, /*On fail goto*//*Label 35197*/ GIMT_Encode4(2431302), // Rule ID 45291 //
     /* 2431235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431244 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2431251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2431259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431267 */     // MIs[0] policy
     /* 2431267 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431270 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431277 */     // (riscv_slideup_vl:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv8f16] } VRM2:{ *:[nxv8f16] }:$rd, VRM2:{ *:[nxv8f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2431280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431282 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431284 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431286 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431288 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2431298 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431300 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431301 */     // GIR_Coverage, 45291,
     /* 2431301 */     GIR_EraseRootFromParent_Done,
     /* 2431302 */   // Label 35197: @2431302
     /* 2431302 */   GIM_Reject,
     /* 2431303 */ // Label 35189: @2431303
     /* 2431303 */ GIM_Reject,
     /* 2431304 */ // Label 35079: @2431304
     /* 2431304 */ GIM_Try, /*On fail goto*//*Label 35198*/ GIMT_Encode4(2431936),
     /* 2431309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s32,
     /* 2431312 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s32,
     /* 2431315 */   GIM_Try, /*On fail goto*//*Label 35199*/ GIMT_Encode4(2431398), // Rule ID 45244 //
     /* 2431320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431329 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431352 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431356 */     // MIs[1] Operand 1
     /* 2431356 */     // No operand predicates
     /* 2431356 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431360 */     // MIs[0] policy
     /* 2431360 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431363 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431365 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431372 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2431375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431377 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431379 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431384 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431394 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431396 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431397 */     // GIR_Coverage, 45244,
     /* 2431397 */     GIR_EraseRootFromParent_Done,
     /* 2431398 */   // Label 35199: @2431398
     /* 2431398 */   GIM_Try, /*On fail goto*//*Label 35200*/ GIMT_Encode4(2431481), // Rule ID 45245 //
     /* 2431403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431412 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431435 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431439 */     // MIs[1] Operand 1
     /* 2431439 */     // No operand predicates
     /* 2431439 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431443 */     // MIs[0] policy
     /* 2431443 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431455 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2431458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431467 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431477 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431479 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431480 */     // GIR_Coverage, 45245,
     /* 2431480 */     GIR_EraseRootFromParent_Done,
     /* 2431481 */   // Label 35200: @2431481
     /* 2431481 */   GIM_Try, /*On fail goto*//*Label 35201*/ GIMT_Encode4(2431564), // Rule ID 45304 //
     /* 2431486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431518 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431522 */     // MIs[1] Operand 1
     /* 2431522 */     // No operand predicates
     /* 2431522 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431526 */     // MIs[0] policy
     /* 2431526 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431531 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431538 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2431541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431543 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431545 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431550 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431552 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431560 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431562 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431563 */     // GIR_Coverage, 45304,
     /* 2431563 */     GIR_EraseRootFromParent_Done,
     /* 2431564 */   // Label 35201: @2431564
     /* 2431564 */   GIM_Try, /*On fail goto*//*Label 35202*/ GIMT_Encode4(2431647), // Rule ID 45305 //
     /* 2431569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431578 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431601 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431605 */     // MIs[1] Operand 1
     /* 2431605 */     // No operand predicates
     /* 2431605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431609 */     // MIs[0] policy
     /* 2431609 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431614 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431621 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2431624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431626 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431628 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431630 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2431633 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431635 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431643 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431645 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431646 */     // GIR_Coverage, 45305,
     /* 2431646 */     GIR_EraseRootFromParent_Done,
     /* 2431647 */   // Label 35202: @2431647
     /* 2431647 */   GIM_Try, /*On fail goto*//*Label 35203*/ GIMT_Encode4(2431719), // Rule ID 45246 //
     /* 2431652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431680 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431684 */     // MIs[0] policy
     /* 2431684 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431687 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431694 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2431697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431699 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431701 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431703 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431705 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431715 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431717 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431718 */     // GIR_Coverage, 45246,
     /* 2431718 */     GIR_EraseRootFromParent_Done,
     /* 2431719 */   // Label 35203: @2431719
     /* 2431719 */   GIM_Try, /*On fail goto*//*Label 35204*/ GIMT_Encode4(2431791), // Rule ID 45247 //
     /* 2431724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431733 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431752 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431756 */     // MIs[0] policy
     /* 2431756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431766 */     // (riscv_slideup_vl:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8i32] } VRM4:{ *:[nxv8i32] }:$rd, VRM4:{ *:[nxv8i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2431769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431771 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431773 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431775 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431777 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431787 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431789 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431790 */     // GIR_Coverage, 45247,
     /* 2431790 */     GIR_EraseRootFromParent_Done,
     /* 2431791 */   // Label 35204: @2431791
     /* 2431791 */   GIM_Try, /*On fail goto*//*Label 35205*/ GIMT_Encode4(2431863), // Rule ID 45306 //
     /* 2431796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2431799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431805 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431824 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431828 */     // MIs[0] policy
     /* 2431828 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431831 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431838 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2431838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2431841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431843 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431845 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431847 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431849 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431859 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431861 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431862 */     // GIR_Coverage, 45306,
     /* 2431862 */     GIR_EraseRootFromParent_Done,
     /* 2431863 */   // Label 35205: @2431863
     /* 2431863 */   GIM_Try, /*On fail goto*//*Label 35206*/ GIMT_Encode4(2431935), // Rule ID 45307 //
     /* 2431868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2431871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2431874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2431880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2431884 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2431892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2431896 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431900 */     // MIs[0] policy
     /* 2431900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431903 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2431910 */     // (riscv_slideup_vl:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv8f32] } VRM4:{ *:[nxv8f32] }:$rd, VRM4:{ *:[nxv8f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2431910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2431913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2431915 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2431917 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2431919 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2431921 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2431923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2431928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2431931 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2431933 */     GIR_RootConstrainSelectedInstOperands,
     /* 2431934 */     // GIR_Coverage, 45307,
     /* 2431934 */     GIR_EraseRootFromParent_Done,
     /* 2431935 */   // Label 35206: @2431935
     /* 2431935 */   GIM_Reject,
     /* 2431936 */ // Label 35198: @2431936
     /* 2431936 */ GIM_Reject,
     /* 2431937 */ // Label 35080: @2431937
     /* 2431937 */ GIM_Try, /*On fail goto*//*Label 35207*/ GIMT_Encode4(2432569),
     /* 2431942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s64,
     /* 2431945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s64,
     /* 2431948 */   GIM_Try, /*On fail goto*//*Label 35208*/ GIMT_Encode4(2432031), // Rule ID 45260 //
     /* 2431953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2431956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2431959 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2431962 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2431965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2431969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2431973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2431977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2431981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2431985 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2431989 */     // MIs[1] Operand 1
     /* 2431989 */     // No operand predicates
     /* 2431989 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2431993 */     // MIs[0] policy
     /* 2431993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2431996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2431998 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432005 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2432008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432010 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432012 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432017 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432027 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432029 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432030 */     // GIR_Coverage, 45260,
     /* 2432030 */     GIR_EraseRootFromParent_Done,
     /* 2432031 */   // Label 35208: @2432031
     /* 2432031 */   GIM_Try, /*On fail goto*//*Label 35209*/ GIMT_Encode4(2432114), // Rule ID 45261 //
     /* 2432036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432045 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432068 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432072 */     // MIs[1] Operand 1
     /* 2432072 */     // No operand predicates
     /* 2432072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432076 */     // MIs[0] policy
     /* 2432076 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432088 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2432091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432100 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432110 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432112 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432113 */     // GIR_Coverage, 45261,
     /* 2432113 */     GIR_EraseRootFromParent_Done,
     /* 2432114 */   // Label 35209: @2432114
     /* 2432114 */   GIM_Try, /*On fail goto*//*Label 35210*/ GIMT_Encode4(2432197), // Rule ID 45320 //
     /* 2432119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432151 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432155 */     // MIs[1] Operand 1
     /* 2432155 */     // No operand predicates
     /* 2432155 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432159 */     // MIs[0] policy
     /* 2432159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432162 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432164 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432171 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2432174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432176 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432178 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432183 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432193 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432195 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432196 */     // GIR_Coverage, 45320,
     /* 2432196 */     GIR_EraseRootFromParent_Done,
     /* 2432197 */   // Label 35210: @2432197
     /* 2432197 */   GIM_Try, /*On fail goto*//*Label 35211*/ GIMT_Encode4(2432280), // Rule ID 45321 //
     /* 2432202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432211 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432238 */     // MIs[1] Operand 1
     /* 2432238 */     // No operand predicates
     /* 2432238 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432242 */     // MIs[0] policy
     /* 2432242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432247 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432254 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2432257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432259 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432261 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432266 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432276 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432278 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432279 */     // GIR_Coverage, 45321,
     /* 2432279 */     GIR_EraseRootFromParent_Done,
     /* 2432280 */   // Label 35211: @2432280
     /* 2432280 */   GIM_Try, /*On fail goto*//*Label 35212*/ GIMT_Encode4(2432352), // Rule ID 45262 //
     /* 2432285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432294 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432317 */     // MIs[0] policy
     /* 2432317 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432320 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432327 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2432330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432332 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432334 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432336 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432338 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432348 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432350 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432351 */     // GIR_Coverage, 45262,
     /* 2432351 */     GIR_EraseRootFromParent_Done,
     /* 2432352 */   // Label 35212: @2432352
     /* 2432352 */   GIM_Try, /*On fail goto*//*Label 35213*/ GIMT_Encode4(2432424), // Rule ID 45263 //
     /* 2432357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432381 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432385 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432389 */     // MIs[0] policy
     /* 2432389 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432392 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432399 */     // (riscv_slideup_vl:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8i64] } VRM8:{ *:[nxv8i64] }:$rd, VRM8:{ *:[nxv8i64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2432402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432404 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432406 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432408 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432410 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432420 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432422 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432423 */     // GIR_Coverage, 45263,
     /* 2432423 */     GIR_EraseRootFromParent_Done,
     /* 2432424 */   // Label 35213: @2432424
     /* 2432424 */   GIM_Try, /*On fail goto*//*Label 35214*/ GIMT_Encode4(2432496), // Rule ID 45322 //
     /* 2432429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode0),
     /* 2432432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432435 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432438 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432457 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432461 */     // MIs[0] policy
     /* 2432461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432464 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432471 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i64] }:$vl, 6:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2432474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432476 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432478 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432480 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432482 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432492 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432494 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432495 */     // GIR_Coverage, 45322,
     /* 2432495 */     GIR_EraseRootFromParent_Done,
     /* 2432496 */   // Label 35214: @2432496
     /* 2432496 */   GIM_Try, /*On fail goto*//*Label 35215*/ GIMT_Encode4(2432568), // Rule ID 45323 //
     /* 2432501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructionsI64_HwMode1),
     /* 2432504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 2432510 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2432517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2432525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432533 */     // MIs[0] policy
     /* 2432533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432536 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432543 */     // (riscv_slideup_vl:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv8f64] } VRM8:{ *:[nxv8f64] }:$rd, VRM8:{ *:[nxv8f64] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv8i1] }:$vm, GPR:{ *:[i32] }:$vl, 6:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2432546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432548 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432550 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432552 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432554 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/6,
     /* 2432564 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432566 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432567 */     // GIR_Coverage, 45323,
     /* 2432567 */     GIR_EraseRootFromParent_Done,
     /* 2432568 */   // Label 35215: @2432568
     /* 2432568 */   GIM_Reject,
     /* 2432569 */ // Label 35207: @2432569
     /* 2432569 */ GIM_Reject,
     /* 2432570 */ // Label 35081: @2432570
     /* 2432570 */ GIM_Try, /*On fail goto*//*Label 35216*/ GIMT_Encode4(2432892),
     /* 2432575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 2432578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 2432581 */   GIM_Try, /*On fail goto*//*Label 35217*/ GIMT_Encode4(2432664), // Rule ID 45216 //
     /* 2432586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2432595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432618 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432622 */     // MIs[1] Operand 1
     /* 2432622 */     // No operand predicates
     /* 2432622 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432626 */     // MIs[0] policy
     /* 2432626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432631 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432638 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2432641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432643 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432645 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432650 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432660 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432662 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432663 */     // GIR_Coverage, 45216,
     /* 2432663 */     GIR_EraseRootFromParent_Done,
     /* 2432664 */   // Label 35217: @2432664
     /* 2432664 */   GIM_Try, /*On fail goto*//*Label 35218*/ GIMT_Encode4(2432747), // Rule ID 45217 //
     /* 2432669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2432678 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432701 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432705 */     // MIs[1] Operand 1
     /* 2432705 */     // No operand predicates
     /* 2432705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432709 */     // MIs[0] policy
     /* 2432709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432721 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M2_MASK),
     /* 2432724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432726 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432728 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432733 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432740 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432743 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432745 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432746 */     // GIR_Coverage, 45217,
     /* 2432746 */     GIR_EraseRootFromParent_Done,
     /* 2432747 */   // Label 35218: @2432747
     /* 2432747 */   GIM_Try, /*On fail goto*//*Label 35219*/ GIMT_Encode4(2432819), // Rule ID 45218 //
     /* 2432752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2432761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432780 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432784 */     // MIs[0] policy
     /* 2432784 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432787 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432794 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432799 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432801 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432803 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432805 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432815 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432817 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432818 */     // GIR_Coverage, 45218,
     /* 2432818 */     GIR_EraseRootFromParent_Done,
     /* 2432819 */   // Label 35219: @2432819
     /* 2432819 */   GIM_Try, /*On fail goto*//*Label 35220*/ GIMT_Encode4(2432891), // Rule ID 45219 //
     /* 2432824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2432833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2432836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM2NoV0RegClassID),
     /* 2432840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM2RegClassID),
     /* 2432848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2432852 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432856 */     // MIs[0] policy
     /* 2432856 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432859 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432866 */     // (riscv_slideup_vl:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M2_MASK:{ *:[nxv16i8] } VRM2:{ *:[nxv16i8] }:$rd, VRM2:{ *:[nxv16i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2432866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M2_MASK),
     /* 2432869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432871 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432873 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432875 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2432877 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2432887 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432889 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432890 */     // GIR_Coverage, 45219,
     /* 2432890 */     GIR_EraseRootFromParent_Done,
     /* 2432891 */   // Label 35220: @2432891
     /* 2432891 */   GIM_Reject,
     /* 2432892 */ // Label 35216: @2432892
     /* 2432892 */ GIM_Reject,
     /* 2432893 */ // Label 35082: @2432893
     /* 2432893 */ GIM_Try, /*On fail goto*//*Label 35221*/ GIMT_Encode4(2433525),
     /* 2432898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s16,
     /* 2432901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s16,
     /* 2432904 */   GIM_Try, /*On fail goto*//*Label 35222*/ GIMT_Encode4(2432987), // Rule ID 45232 //
     /* 2432909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2432912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2432915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2432918 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2432921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2432925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2432933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2432937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2432941 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2432945 */     // MIs[1] Operand 1
     /* 2432945 */     // No operand predicates
     /* 2432945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2432949 */     // MIs[0] policy
     /* 2432949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2432952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2432954 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2432961 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2432961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2432964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2432966 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2432968 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2432970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2432973 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2432975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2432980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2432983 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2432985 */     GIR_RootConstrainSelectedInstOperands,
     /* 2432986 */     // GIR_Coverage, 45232,
     /* 2432986 */     GIR_EraseRootFromParent_Done,
     /* 2432987 */   // Label 35222: @2432987
     /* 2432987 */   GIM_Try, /*On fail goto*//*Label 35223*/ GIMT_Encode4(2433070), // Rule ID 45233 //
     /* 2432992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2432995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2432998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433001 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433024 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433028 */     // MIs[1] Operand 1
     /* 2433028 */     // No operand predicates
     /* 2433028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433032 */     // MIs[0] policy
     /* 2433032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433044 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2433047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433049 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433051 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433056 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433063 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433066 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433068 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433069 */     // GIR_Coverage, 45233,
     /* 2433069 */     GIR_EraseRootFromParent_Done,
     /* 2433070 */   // Label 35223: @2433070
     /* 2433070 */   GIM_Try, /*On fail goto*//*Label 35224*/ GIMT_Encode4(2433153), // Rule ID 45292 //
     /* 2433075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433107 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433111 */     // MIs[1] Operand 1
     /* 2433111 */     // No operand predicates
     /* 2433111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433115 */     // MIs[0] policy
     /* 2433115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433127 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2433130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433132 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433134 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433136 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433139 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433149 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433151 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433152 */     // GIR_Coverage, 45292,
     /* 2433152 */     GIR_EraseRootFromParent_Done,
     /* 2433153 */   // Label 35224: @2433153
     /* 2433153 */   GIM_Try, /*On fail goto*//*Label 35225*/ GIMT_Encode4(2433236), // Rule ID 45293 //
     /* 2433158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433167 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433194 */     // MIs[1] Operand 1
     /* 2433194 */     // No operand predicates
     /* 2433194 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433198 */     // MIs[0] policy
     /* 2433198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433203 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433210 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2433213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433215 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433217 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433222 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433232 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433234 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433235 */     // GIR_Coverage, 45293,
     /* 2433235 */     GIR_EraseRootFromParent_Done,
     /* 2433236 */   // Label 35225: @2433236
     /* 2433236 */   GIM_Try, /*On fail goto*//*Label 35226*/ GIMT_Encode4(2433308), // Rule ID 45234 //
     /* 2433241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433250 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433269 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433273 */     // MIs[0] policy
     /* 2433273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433276 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433283 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2433286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433288 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433290 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433292 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433294 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433304 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433307 */     // GIR_Coverage, 45234,
     /* 2433307 */     GIR_EraseRootFromParent_Done,
     /* 2433308 */   // Label 35226: @2433308
     /* 2433308 */   GIM_Try, /*On fail goto*//*Label 35227*/ GIMT_Encode4(2433380), // Rule ID 45235 //
     /* 2433313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433319 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433322 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433345 */     // MIs[0] policy
     /* 2433345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433348 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433355 */     // (riscv_slideup_vl:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16i16] } VRM4:{ *:[nxv16i16] }:$rd, VRM4:{ *:[nxv16i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2433358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433360 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433362 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433364 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433366 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433376 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433378 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433379 */     // GIR_Coverage, 45235,
     /* 2433379 */     GIR_EraseRootFromParent_Done,
     /* 2433380 */   // Label 35227: @2433380
     /* 2433380 */   GIM_Try, /*On fail goto*//*Label 35228*/ GIMT_Encode4(2433452), // Rule ID 45294 //
     /* 2433385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433394 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433413 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433417 */     // MIs[0] policy
     /* 2433417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433427 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2433430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433432 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433434 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433436 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433438 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433448 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433450 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433451 */     // GIR_Coverage, 45294,
     /* 2433451 */     GIR_EraseRootFromParent_Done,
     /* 2433452 */   // Label 35228: @2433452
     /* 2433452 */   GIM_Try, /*On fail goto*//*Label 35229*/ GIMT_Encode4(2433524), // Rule ID 45295 //
     /* 2433457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433463 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433466 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2433473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2433481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433485 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433489 */     // MIs[0] policy
     /* 2433489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433499 */     // (riscv_slideup_vl:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv16f16] } VRM4:{ *:[nxv16f16] }:$rd, VRM4:{ *:[nxv16f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2433502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433504 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433506 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433508 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433510 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2433520 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433522 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433523 */     // GIR_Coverage, 45295,
     /* 2433523 */     GIR_EraseRootFromParent_Done,
     /* 2433524 */   // Label 35229: @2433524
     /* 2433524 */   GIM_Reject,
     /* 2433525 */ // Label 35221: @2433525
     /* 2433525 */ GIM_Reject,
     /* 2433526 */ // Label 35083: @2433526
     /* 2433526 */ GIM_Try, /*On fail goto*//*Label 35230*/ GIMT_Encode4(2434158),
     /* 2433531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s32,
     /* 2433534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s32,
     /* 2433537 */   GIM_Try, /*On fail goto*//*Label 35231*/ GIMT_Encode4(2433620), // Rule ID 45248 //
     /* 2433542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433566 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433570 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433574 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433578 */     // MIs[1] Operand 1
     /* 2433578 */     // No operand predicates
     /* 2433578 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433582 */     // MIs[0] policy
     /* 2433582 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433594 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2433597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433599 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433601 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433606 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433616 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433618 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433619 */     // GIR_Coverage, 45248,
     /* 2433619 */     GIR_EraseRootFromParent_Done,
     /* 2433620 */   // Label 35231: @2433620
     /* 2433620 */   GIM_Try, /*On fail goto*//*Label 35232*/ GIMT_Encode4(2433703), // Rule ID 45249 //
     /* 2433625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433634 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433641 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433661 */     // MIs[1] Operand 1
     /* 2433661 */     // No operand predicates
     /* 2433661 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433665 */     // MIs[0] policy
     /* 2433665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433668 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433670 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433677 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2433680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433682 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433684 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433686 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433689 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433699 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433701 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433702 */     // GIR_Coverage, 45249,
     /* 2433702 */     GIR_EraseRootFromParent_Done,
     /* 2433703 */   // Label 35232: @2433703
     /* 2433703 */   GIM_Try, /*On fail goto*//*Label 35233*/ GIMT_Encode4(2433786), // Rule ID 45308 //
     /* 2433708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433717 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433740 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433744 */     // MIs[1] Operand 1
     /* 2433744 */     // No operand predicates
     /* 2433744 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433748 */     // MIs[0] policy
     /* 2433748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433760 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2433763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433765 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433767 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433772 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433782 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433784 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433785 */     // GIR_Coverage, 45308,
     /* 2433785 */     GIR_EraseRootFromParent_Done,
     /* 2433786 */   // Label 35233: @2433786
     /* 2433786 */   GIM_Try, /*On fail goto*//*Label 35234*/ GIMT_Encode4(2433869), // Rule ID 45309 //
     /* 2433791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433800 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433807 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2433819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2433823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2433827 */     // MIs[1] Operand 1
     /* 2433827 */     // No operand predicates
     /* 2433827 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433831 */     // MIs[0] policy
     /* 2433831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2433836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433843 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2433846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433848 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433850 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433852 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2433855 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433865 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433867 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433868 */     // GIR_Coverage, 45309,
     /* 2433868 */     GIR_EraseRootFromParent_Done,
     /* 2433869 */   // Label 35234: @2433869
     /* 2433869 */   GIM_Try, /*On fail goto*//*Label 35235*/ GIMT_Encode4(2433941), // Rule ID 45250 //
     /* 2433874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2433877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2433880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2433886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433902 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433906 */     // MIs[0] policy
     /* 2433906 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433916 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2433916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2433919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433921 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433923 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433925 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433927 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2433929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2433934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2433937 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2433939 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433940 */     // GIR_Coverage, 45250,
     /* 2433940 */     GIR_EraseRootFromParent_Done,
     /* 2433941 */   // Label 35235: @2433941
     /* 2433941 */   GIM_Try, /*On fail goto*//*Label 35236*/ GIMT_Encode4(2434013), // Rule ID 45251 //
     /* 2433946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2433949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2433952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2433955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2433958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2433962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2433970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2433974 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2433978 */     // MIs[0] policy
     /* 2433978 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2433981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2433988 */     // (riscv_slideup_vl:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16i32] } VRM8:{ *:[nxv16i32] }:$rd, VRM8:{ *:[nxv16i32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2433988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2433991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2433993 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2433995 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2433997 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2433999 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434009 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434011 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434012 */     // GIR_Coverage, 45251,
     /* 2434012 */     GIR_EraseRootFromParent_Done,
     /* 2434013 */   // Label 35236: @2434013
     /* 2434013 */   GIM_Try, /*On fail goto*//*Label 35237*/ GIMT_Encode4(2434085), // Rule ID 45310 //
     /* 2434018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2434027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434046 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434050 */     // MIs[0] policy
     /* 2434050 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434053 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434060 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i64] }:$vl, 5:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2434063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434065 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434067 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434069 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434071 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434081 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434083 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434084 */     // GIR_Coverage, 45310,
     /* 2434084 */     GIR_EraseRootFromParent_Done,
     /* 2434085 */   // Label 35237: @2434085
     /* 2434085 */   GIM_Try, /*On fail goto*//*Label 35238*/ GIMT_Encode4(2434157), // Rule ID 45311 //
     /* 2434090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 2434099 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434118 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434122 */     // MIs[0] policy
     /* 2434122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434132 */     // (riscv_slideup_vl:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv16f32] } VRM8:{ *:[nxv16f32] }:$rd, VRM8:{ *:[nxv16f32] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv16i1] }:$vm, GPR:{ *:[i32] }:$vl, 5:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2434135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434137 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434139 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434141 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434143 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/5,
     /* 2434153 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434155 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434156 */     // GIR_Coverage, 45311,
     /* 2434156 */     GIR_EraseRootFromParent_Done,
     /* 2434157 */   // Label 35238: @2434157
     /* 2434157 */   GIM_Reject,
     /* 2434158 */ // Label 35230: @2434158
     /* 2434158 */ GIM_Reject,
     /* 2434159 */ // Label 35084: @2434159
     /* 2434159 */ GIM_Try, /*On fail goto*//*Label 35239*/ GIMT_Encode4(2434481),
     /* 2434164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s8,
     /* 2434167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s8,
     /* 2434170 */   GIM_Try, /*On fail goto*//*Label 35240*/ GIMT_Encode4(2434253), // Rule ID 45220 //
     /* 2434175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434184 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434211 */     // MIs[1] Operand 1
     /* 2434211 */     // No operand predicates
     /* 2434211 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434215 */     // MIs[0] policy
     /* 2434215 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434218 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434227 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434232 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434234 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434236 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434239 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434249 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434251 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434252 */     // GIR_Coverage, 45220,
     /* 2434252 */     GIR_EraseRootFromParent_Done,
     /* 2434253 */   // Label 35240: @2434253
     /* 2434253 */   GIM_Try, /*On fail goto*//*Label 35241*/ GIMT_Encode4(2434336), // Rule ID 45221 //
     /* 2434258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434264 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434267 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434290 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434294 */     // MIs[1] Operand 1
     /* 2434294 */     // No operand predicates
     /* 2434294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434298 */     // MIs[0] policy
     /* 2434298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434303 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434310 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M4_MASK),
     /* 2434313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434315 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434317 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434322 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434332 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434334 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434335 */     // GIR_Coverage, 45221,
     /* 2434335 */     GIR_EraseRootFromParent_Done,
     /* 2434336 */   // Label 35241: @2434336
     /* 2434336 */   GIM_Try, /*On fail goto*//*Label 35242*/ GIMT_Encode4(2434408), // Rule ID 45222 //
     /* 2434341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434373 */     // MIs[0] policy
     /* 2434373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434376 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434383 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434388 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434390 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434392 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434394 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434396 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434404 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434406 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434407 */     // GIR_Coverage, 45222,
     /* 2434407 */     GIR_EraseRootFromParent_Done,
     /* 2434408 */   // Label 35242: @2434408
     /* 2434408 */   GIM_Try, /*On fail goto*//*Label 35243*/ GIMT_Encode4(2434480), // Rule ID 45223 //
     /* 2434413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434422 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM4NoV0RegClassID),
     /* 2434429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM4RegClassID),
     /* 2434437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434441 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434445 */     // MIs[0] policy
     /* 2434445 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434455 */     // (riscv_slideup_vl:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M4_MASK:{ *:[nxv32i8] } VRM4:{ *:[nxv32i8] }:$rd, VRM4:{ *:[nxv32i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M4_MASK),
     /* 2434458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434460 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434462 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434464 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434466 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2434476 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434478 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434479 */     // GIR_Coverage, 45223,
     /* 2434479 */     GIR_EraseRootFromParent_Done,
     /* 2434480 */   // Label 35243: @2434480
     /* 2434480 */   GIM_Reject,
     /* 2434481 */ // Label 35239: @2434481
     /* 2434481 */ GIM_Reject,
     /* 2434482 */ // Label 35085: @2434482
     /* 2434482 */ GIM_Try, /*On fail goto*//*Label 35244*/ GIMT_Encode4(2435114),
     /* 2434487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv32s16,
     /* 2434490 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv32s16,
     /* 2434493 */   GIM_Try, /*On fail goto*//*Label 35245*/ GIMT_Encode4(2434576), // Rule ID 45236 //
     /* 2434498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434530 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434534 */     // MIs[1] Operand 1
     /* 2434534 */     // No operand predicates
     /* 2434534 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434538 */     // MIs[0] policy
     /* 2434538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434550 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2434553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434555 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434557 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434562 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434572 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434574 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434575 */     // GIR_Coverage, 45236,
     /* 2434575 */     GIR_EraseRootFromParent_Done,
     /* 2434576 */   // Label 35245: @2434576
     /* 2434576 */   GIM_Try, /*On fail goto*//*Label 35246*/ GIMT_Encode4(2434659), // Rule ID 45237 //
     /* 2434581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434590 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434613 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434617 */     // MIs[1] Operand 1
     /* 2434617 */     // No operand predicates
     /* 2434617 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434621 */     // MIs[0] policy
     /* 2434621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434626 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434633 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2434636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434638 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434640 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434645 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434655 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434657 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434658 */     // GIR_Coverage, 45237,
     /* 2434658 */     GIR_EraseRootFromParent_Done,
     /* 2434659 */   // Label 35246: @2434659
     /* 2434659 */   GIM_Try, /*On fail goto*//*Label 35247*/ GIMT_Encode4(2434742), // Rule ID 45296 //
     /* 2434664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434673 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434696 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434700 */     // MIs[1] Operand 1
     /* 2434700 */     // No operand predicates
     /* 2434700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434704 */     // MIs[0] policy
     /* 2434704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434707 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434709 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434716 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2434719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434721 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434723 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434728 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434738 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434740 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434741 */     // GIR_Coverage, 45296,
     /* 2434741 */     GIR_EraseRootFromParent_Done,
     /* 2434742 */   // Label 35247: @2434742
     /* 2434742 */   GIM_Try, /*On fail goto*//*Label 35248*/ GIMT_Encode4(2434825), // Rule ID 45297 //
     /* 2434747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434756 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2434775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2434779 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2434783 */     // MIs[1] Operand 1
     /* 2434783 */     // No operand predicates
     /* 2434783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434787 */     // MIs[0] policy
     /* 2434787 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2434792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434799 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2434802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434804 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434806 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2434811 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434821 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434823 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434824 */     // GIR_Coverage, 45297,
     /* 2434824 */     GIR_EraseRootFromParent_Done,
     /* 2434825 */   // Label 35248: @2434825
     /* 2434825 */   GIM_Try, /*On fail goto*//*Label 35249*/ GIMT_Encode4(2434897), // Rule ID 45238 //
     /* 2434830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434836 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434839 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434858 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434862 */     // MIs[0] policy
     /* 2434862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434865 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434872 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2434872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2434875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434877 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434879 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434881 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434883 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434885 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434893 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434895 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434896 */     // GIR_Coverage, 45238,
     /* 2434896 */     GIR_EraseRootFromParent_Done,
     /* 2434897 */   // Label 35249: @2434897
     /* 2434897 */   GIM_Try, /*On fail goto*//*Label 35250*/ GIMT_Encode4(2434969), // Rule ID 45239 //
     /* 2434902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2434905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2434908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434911 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2434914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2434930 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2434934 */     // MIs[0] policy
     /* 2434934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2434937 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2434944 */     // (riscv_slideup_vl:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32i16] } VRM8:{ *:[nxv32i16] }:$rd, VRM8:{ *:[nxv32i16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2434944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2434947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2434949 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2434951 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2434953 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2434955 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2434957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2434962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2434965 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2434967 */     GIR_RootConstrainSelectedInstOperands,
     /* 2434968 */     // GIR_Coverage, 45239,
     /* 2434968 */     GIR_EraseRootFromParent_Done,
     /* 2434969 */   // Label 35250: @2434969
     /* 2434969 */   GIM_Try, /*On fail goto*//*Label 35251*/ GIMT_Encode4(2435041), // Rule ID 45298 //
     /* 2434974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2434977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2434980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2434983 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2434986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2434990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2434998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435006 */     // MIs[0] policy
     /* 2435006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435009 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435016 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i64] }:$vl, 4:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2435019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435021 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435023 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435025 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435027 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435037 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435039 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435040 */     // GIR_Coverage, 45298,
     /* 2435040 */     GIR_EraseRootFromParent_Done,
     /* 2435041 */   // Label 35251: @2435041
     /* 2435041 */   GIM_Try, /*On fail goto*//*Label 35252*/ GIMT_Encode4(2435113), // Rule ID 45299 //
     /* 2435046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv32s1,
     /* 2435055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435074 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435078 */     // MIs[0] policy
     /* 2435078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435088 */     // (riscv_slideup_vl:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv32f16] } VRM8:{ *:[nxv32f16] }:$rd, VRM8:{ *:[nxv32f16] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv32i1] }:$vm, GPR:{ *:[i32] }:$vl, 4:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2435091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435093 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435095 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435097 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435099 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/4,
     /* 2435109 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435111 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435112 */     // GIR_Coverage, 45299,
     /* 2435112 */     GIR_EraseRootFromParent_Done,
     /* 2435113 */   // Label 35252: @2435113
     /* 2435113 */   GIM_Reject,
     /* 2435114 */ // Label 35244: @2435114
     /* 2435114 */ GIM_Reject,
     /* 2435115 */ // Label 35086: @2435115
     /* 2435115 */ GIM_Try, /*On fail goto*//*Label 35253*/ GIMT_Encode4(2435437),
     /* 2435120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv64s8,
     /* 2435123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv64s8,
     /* 2435126 */   GIM_Try, /*On fail goto*//*Label 35254*/ GIMT_Encode4(2435209), // Rule ID 45224 //
     /* 2435131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2435140 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435163 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435167 */     // MIs[1] Operand 1
     /* 2435167 */     // No operand predicates
     /* 2435167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435171 */     // MIs[0] policy
     /* 2435171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435183 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i64] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2435186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435188 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435190 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435195 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435205 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435207 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435208 */     // GIR_Coverage, 45224,
     /* 2435208 */     GIR_EraseRootFromParent_Done,
     /* 2435209 */   // Label 35254: @2435209
     /* 2435209 */   GIM_Try, /*On fail goto*//*Label 35255*/ GIMT_Encode4(2435292), // Rule ID 45225 //
     /* 2435214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2435223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 2435242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 2435246 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm5),
     /* 2435250 */     // MIs[1] Operand 1
     /* 2435250 */     // No operand predicates
     /* 2435250 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435254 */     // MIs[0] policy
     /* 2435254 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435257 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2435259 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435266 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VI_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, (imm:{ *:[i32] })<<P:Predicate_uimm5>>:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VI_M8_MASK),
     /* 2435269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435271 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435273 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rs2
     /* 2435278 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435288 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435290 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435291 */     // GIR_Coverage, 45225,
     /* 2435291 */     GIR_EraseRootFromParent_Done,
     /* 2435292 */   // Label 35255: @2435292
     /* 2435292 */   GIM_Try, /*On fail goto*//*Label 35256*/ GIMT_Encode4(2435364), // Rule ID 45226 //
     /* 2435297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode0),
     /* 2435300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 2435303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2435306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 2435309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435325 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435329 */     // MIs[0] policy
     /* 2435329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435339 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i64] } AVL:{ *:[i64] }:$vl), (timm:{ *:[i64] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i64] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i64] }:$vl, 3:{ *:[i64] }, (timm:{ *:[i64] }):$policy)
     /* 2435339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2435342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435344 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435346 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435348 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435350 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435357 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435360 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435362 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435363 */     // GIR_Coverage, 45226,
     /* 2435363 */     GIR_EraseRootFromParent_Done,
     /* 2435364 */   // Label 35256: @2435364
     /* 2435364 */   GIM_Try, /*On fail goto*//*Label 35257*/ GIMT_Encode4(2435436), // Rule ID 45227 //
     /* 2435369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVInstructions_HwMode1),
     /* 2435372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 2435375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv64s1,
     /* 2435378 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /* 2435381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(RISCV::VRM8NoV0RegClassID),
     /* 2435385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(RISCV::VRM8RegClassID),
     /* 2435393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(RISCV::GPRRegClassID),
     /* 2435397 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(RISCV::VMV0RegClassID),
     /* 2435401 */     // MIs[0] policy
     /* 2435401 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /* 2435404 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/5, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_GIVLOp),
     /* 2435411 */     // (riscv_slideup_vl:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, (VLOp:{ *:[i32] } AVL:{ *:[i32] }:$vl), (timm:{ *:[i32] }):$policy)  =>  (PseudoVSLIDEUP_VX_M8_MASK:{ *:[nxv64i8] } VRM8:{ *:[nxv64i8] }:$rd, VRM8:{ *:[nxv64i8] }:$rs1, GPR:{ *:[i32] }:$rs2, VMV0:{ *:[nxv64i1] }:$vm, GPR:{ *:[i32] }:$vl, 3:{ *:[i32] }, (timm:{ *:[i32] }):$policy)
     /* 2435411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(RISCV::PseudoVSLIDEUP_VX_M8_MASK),
     /* 2435414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[rd]
     /* 2435416 */     GIR_RootToRootCopy, /*OpIdx*/1, // rd
     /* 2435418 */     GIR_RootToRootCopy, /*OpIdx*/2, // rs1
     /* 2435420 */     GIR_RootToRootCopy, /*OpIdx*/3, // rs2
     /* 2435422 */     GIR_RootToRootCopy, /*OpIdx*/4, // vm
     /* 2435424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // vl
     /* 2435429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 2435432 */     GIR_RootToRootCopy, /*OpIdx*/6, // policy
     /* 2435434 */     GIR_RootConstrainSelectedInstOperands,
     /* 2435435 */     // GIR_Coverage, 45227,
     /* 2435435 */     GIR_EraseRootFromParent_Done,
     /* 2435436 */   // Label 35257: @2435436
     /* 2435436 */   GIM_Reject,
     /* 2435437 */ // Label 35253: @2435437
     /* 2435437 */ GIM_Reject,
     /* 2435438 */ // Label 35087: @2435438
     /* 2435438 */ GIM_Reject,
     /* 2435439 */ // Label 125: @2435439
     /* 2435439 */ GIM_Reject,
     /* 2435440 */ }; // Size: 2435440 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const RISCVSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const RISCVSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
